Module["asm"] =  (function(global,env,buffer) {

  'use asm';
  
  
  var HEAP8 = new global.Int8Array(buffer);
  var HEAP16 = new global.Int16Array(buffer);
  var HEAP32 = new global.Int32Array(buffer);
  var HEAPU8 = new global.Uint8Array(buffer);
  var HEAPU16 = new global.Uint16Array(buffer);
  var HEAPU32 = new global.Uint32Array(buffer);
  var HEAPF32 = new global.Float32Array(buffer);
  var HEAPF64 = new global.Float64Array(buffer);


  var STACKTOP=env.STACKTOP|0;
  var STACK_MAX=env.STACK_MAX|0;
  var tempDoublePtr=env.tempDoublePtr|0;
  var ABORT=env.ABORT|0;
  var cttz_i8=env.cttz_i8|0;
  var gb=env.gb|0;
  var fb=env.fb|0;

  var __THREW__ = 0;
  var threwValue = 0;
  var setjmpId = 0;
  var undef = 0;
  var nan = global.NaN, inf = global.Infinity;
  var tempInt = 0, tempBigInt = 0, tempBigIntP = 0, tempBigIntS = 0, tempBigIntR = 0.0, tempBigIntI = 0, tempBigIntD = 0, tempValue = 0, tempDouble = 0.0;
  var tempRet0 = 0;

  var Math_floor=global.Math.floor;
  var Math_abs=global.Math.abs;
  var Math_sqrt=global.Math.sqrt;
  var Math_pow=global.Math.pow;
  var Math_cos=global.Math.cos;
  var Math_sin=global.Math.sin;
  var Math_tan=global.Math.tan;
  var Math_acos=global.Math.acos;
  var Math_asin=global.Math.asin;
  var Math_atan=global.Math.atan;
  var Math_atan2=global.Math.atan2;
  var Math_exp=global.Math.exp;
  var Math_log=global.Math.log;
  var Math_ceil=global.Math.ceil;
  var Math_imul=global.Math.imul;
  var Math_min=global.Math.min;
  var Math_max=global.Math.max;
  var Math_clz32=global.Math.clz32;
  var Math_fround=global.Math.fround;
  var abort=env.abort;
  var assert=env.assert;
  var abortStackOverflow=env.abortStackOverflow;
  var nullFunc_viiifiii=env.nullFunc_viiifiii;
  var nullFunc_iiiiiid=env.nullFunc_iiiiiid;
  var nullFunc_fiff=env.nullFunc_fiff;
  var nullFunc_iiififii=env.nullFunc_iiififii;
  var nullFunc_iiiiiii=env.nullFunc_iiiiiii;
  var nullFunc_vifiiiiiiiiiiiiiiiiii=env.nullFunc_vifiiiiiiiiiiiiiiiiii;
  var nullFunc_viiiiiiiiiii=env.nullFunc_viiiiiiiiiii;
  var nullFunc_fff=env.nullFunc_fff;
  var nullFunc_fiiiiiifiiiiiif=env.nullFunc_fiiiiiifiiiiiif;
  var nullFunc_iiiiifiif=env.nullFunc_iiiiifiif;
  var nullFunc_iiiiifii=env.nullFunc_iiiiifii;
  var nullFunc_iiffi=env.nullFunc_iiffi;
  var nullFunc_vidd=env.nullFunc_vidd;
  var nullFunc_iiiiiiiiiiii=env.nullFunc_iiiiiiiiiiii;
  var nullFunc_fif=env.nullFunc_fif;
  var nullFunc_viifiii=env.nullFunc_viifiii;
  var nullFunc_fii=env.nullFunc_fii;
  var nullFunc_viiiiiff=env.nullFunc_viiiiiff;
  var nullFunc_viiiiiifiii=env.nullFunc_viiiiiifiii;
  var nullFunc_di=env.nullFunc_di;
  var nullFunc_viff=env.nullFunc_viff;
  var nullFunc_iiifiii=env.nullFunc_iiifiii;
  var nullFunc_viiiif=env.nullFunc_viiiif;
  var nullFunc_viffff=env.nullFunc_viffff;
  var nullFunc_vfff=env.nullFunc_vfff;
  var nullFunc_vififfi=env.nullFunc_vififfi;
  var nullFunc_dii=env.nullFunc_dii;
  var nullFunc_iiifiiff=env.nullFunc_iiifiiff;
  var nullFunc_viiiiii=env.nullFunc_viiiiii;
  var nullFunc_iifff=env.nullFunc_iifff;
  var nullFunc_iifii=env.nullFunc_iifii;
  var nullFunc_iiiiiiiiii=env.nullFunc_iiiiiiiiii;
  var nullFunc_vdddddd=env.nullFunc_vdddddd;
  var nullFunc_iiiiiiiiiiiiffffii=env.nullFunc_iiiiiiiiiiiiffffii;
  var nullFunc_vdd=env.nullFunc_vdd;
  var nullFunc_iiiif=env.nullFunc_iiiif;
  var nullFunc_iiiiiiii=env.nullFunc_iiiiiiii;
  var nullFunc_vfii=env.nullFunc_vfii;
  var nullFunc_vifiiiiiiiiiiiii=env.nullFunc_vifiiiiiiiiiiiii;
  var nullFunc_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.nullFunc_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var nullFunc_iiiiiiif=env.nullFunc_iiiiiiif;
  var nullFunc_iiiii=env.nullFunc_iiiii;
  var nullFunc_vifififfi=env.nullFunc_vifififfi;
  var nullFunc_iiifii=env.nullFunc_iiifii;
  var nullFunc_viiiiiiiiiiiiiiiii=env.nullFunc_viiiiiiiiiiiiiiiii;
  var nullFunc_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.nullFunc_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var nullFunc_viffi=env.nullFunc_viffi;
  var nullFunc_iiiifiiii=env.nullFunc_iiiifiiii;
  var nullFunc_vifi=env.nullFunc_vifi;
  var nullFunc_vifff=env.nullFunc_vifff;
  var nullFunc_viifififfi=env.nullFunc_viifififfi;
  var nullFunc_fiii=env.nullFunc_fiii;
  var nullFunc_iiiiiifffiiifii=env.nullFunc_iiiiiifffiiifii;
  var nullFunc_iifiiff=env.nullFunc_iifiiff;
  var nullFunc_iifiii=env.nullFunc_iifiii;
  var nullFunc_fiif=env.nullFunc_fiif;
  var nullFunc_iiiiifiiiif=env.nullFunc_iiiiifiiiif;
  var nullFunc_iiidiiii=env.nullFunc_iiidiiii;
  var nullFunc_iiifiifii=env.nullFunc_iiifiifii;
  var nullFunc_viiiiiiiiii=env.nullFunc_viiiiiiiiii;
  var nullFunc_iiiiiiffiiiiiiiiiffffiii=env.nullFunc_iiiiiiffiiiiiiiiiffffiii;
  var nullFunc_diii=env.nullFunc_diii;
  var nullFunc_iifififf=env.nullFunc_iifififf;
  var nullFunc_viiiiiiiiiiii=env.nullFunc_viiiiiiiiiiii;
  var nullFunc_iiiiii=env.nullFunc_iiiiii;
  var nullFunc_iiiiid=env.nullFunc_iiiiid;
  var nullFunc_iiiiiifiif=env.nullFunc_iiiiiifiif;
  var nullFunc_viiii=env.nullFunc_viiii;
  var nullFunc_viiiii=env.nullFunc_viiiii;
  var nullFunc_vif=env.nullFunc_vif;
  var nullFunc_vid=env.nullFunc_vid;
  var nullFunc_iiidi=env.nullFunc_iiidi;
  var nullFunc_vii=env.nullFunc_vii;
  var nullFunc_iiiifififf=env.nullFunc_iiiifififf;
  var nullFunc_iiiiiifii=env.nullFunc_iiiiiifii;
  var nullFunc_iiifiififf=env.nullFunc_iiifiififf;
  var nullFunc_d=env.nullFunc_d;
  var nullFunc_viiifififfi=env.nullFunc_viiifififfi;
  var nullFunc_viifii=env.nullFunc_viifii;
  var nullFunc_fi=env.nullFunc_fi;
  var nullFunc_viifif=env.nullFunc_viifif;
  var nullFunc_fiiiiiiiifiiiif=env.nullFunc_fiiiiiiiifiiiif;
  var nullFunc_viiifiiiii=env.nullFunc_viiifiiiii;
  var nullFunc_iiiififf=env.nullFunc_iiiififf;
  var nullFunc_vifiii=env.nullFunc_vifiii;
  var nullFunc_viiiifiiiiif=env.nullFunc_viiiifiiiiif;
  var nullFunc_viiiiiiiiiiiiiii=env.nullFunc_viiiiiiiiiiiiiii;
  var nullFunc_iiiiiiiiiiffffii=env.nullFunc_iiiiiiiiiiffffii;
  var nullFunc_iiiiiff=env.nullFunc_iiiiiff;
  var nullFunc_viiiiiiii=env.nullFunc_viiiiiiii;
  var nullFunc_viiff=env.nullFunc_viiff;
  var nullFunc_iif=env.nullFunc_iif;
  var nullFunc_vifiiii=env.nullFunc_vifiiii;
  var nullFunc_viiiiiii=env.nullFunc_viiiiiii;
  var nullFunc_vifii=env.nullFunc_vifii;
  var nullFunc_viiiiiiiii=env.nullFunc_viiiiiiiii;
  var nullFunc_iii=env.nullFunc_iii;
  var nullFunc_fiiiif=env.nullFunc_fiiiif;
  var nullFunc_iiiifii=env.nullFunc_iiiifii;
  var nullFunc_f=env.nullFunc_f;
  var nullFunc_vffff=env.nullFunc_vffff;
  var nullFunc_iiiff=env.nullFunc_iiiff;
  var nullFunc_viii=env.nullFunc_viii;
  var nullFunc_v=env.nullFunc_v;
  var nullFunc_viid=env.nullFunc_viid;
  var nullFunc_viif=env.nullFunc_viif;
  var nullFunc_iiiifi=env.nullFunc_iiiifi;
  var nullFunc_iiifififf=env.nullFunc_iiifififf;
  var nullFunc_vd=env.nullFunc_vd;
  var nullFunc_vf=env.nullFunc_vf;
  var nullFunc_vi=env.nullFunc_vi;
  var nullFunc_iiiiiiiiiii=env.nullFunc_iiiiiiiiiii;
  var nullFunc_iiiiff=env.nullFunc_iiiiff;
  var nullFunc_ii=env.nullFunc_ii;
  var nullFunc_iiff=env.nullFunc_iiff;
  var nullFunc_viifi=env.nullFunc_viifi;
  var nullFunc_iiiiifiiiiii=env.nullFunc_iiiiifiiiiii;
  var nullFunc_iiiiifiiiiif=env.nullFunc_iiiiifiiiiif;
  var nullFunc_iiiifiiff=env.nullFunc_iiiifiiff;
  var nullFunc_iifi=env.nullFunc_iifi;
  var nullFunc_if=env.nullFunc_if;
  var nullFunc_viiif=env.nullFunc_viiif;
  var nullFunc_vffffi=env.nullFunc_vffffi;
  var nullFunc_vifiiiiiiiiiiiiiiiiiiiiiii=env.nullFunc_vifiiiiiiiiiiiiiiiiiiiiiii;
  var nullFunc_iiiffii=env.nullFunc_iiiffii;
  var nullFunc_iifiiiii=env.nullFunc_iifiiiii;
  var nullFunc_iiifi=env.nullFunc_iiifi;
  var nullFunc_iiii=env.nullFunc_iiii;
  var nullFunc_viifff=env.nullFunc_viifff;
  var nullFunc_iifiififf=env.nullFunc_iifiififf;
  var nullFunc_viiffi=env.nullFunc_viiffi;
  var nullFunc_iiid=env.nullFunc_iiid;
  var nullFunc_iiif=env.nullFunc_iiif;
  var nullFunc_viiiffi=env.nullFunc_viiiffi;
  var nullFunc_vffffffi=env.nullFunc_vffffffi;
  var nullFunc_viiifi=env.nullFunc_viiifi;
  var nullFunc_iiiifiii=env.nullFunc_iiiifiii;
  var nullFunc_ff=env.nullFunc_ff;
  var nullFunc_iiiifiiiii=env.nullFunc_iiiifiiiii;
  var nullFunc_iiiifiififf=env.nullFunc_iiiifiififf;
  var nullFunc_viififfi=env.nullFunc_viififfi;
  var nullFunc_viffffffffffffiiii=env.nullFunc_viffffffffffffiiii;
  var nullFunc_vfi=env.nullFunc_vfi;
  var nullFunc_iififf=env.nullFunc_iififf;
  var nullFunc_i=env.nullFunc_i;
  var nullFunc_vff=env.nullFunc_vff;
  var nullFunc_iiififf=env.nullFunc_iiififf;
  var nullFunc_vifffff=env.nullFunc_vifffff;
  var nullFunc_iiiiiiiii=env.nullFunc_iiiiiiiii;
  var nullFunc_viffffi=env.nullFunc_viffffi;
  var setTempRet0=env.setTempRet0;
  var getTempRet0=env.getTempRet0;
  var invoke_viiifiii=env.invoke_viiifiii;
  var ftCall_viiifiii=env.ftCall_viiifiii;
  var invoke_iiiiiid=env.invoke_iiiiiid;
  var ftCall_iiiiiid=env.ftCall_iiiiiid;
  var invoke_fiff=env.invoke_fiff;
  var ftCall_fiff=env.ftCall_fiff;
  var invoke_iiififii=env.invoke_iiififii;
  var ftCall_iiififii=env.ftCall_iiififii;
  var invoke_iiiiiii=env.invoke_iiiiiii;
  var ftCall_iiiiiii=env.ftCall_iiiiiii;
  var invoke_vifiiiiiiiiiiiiiiiiii=env.invoke_vifiiiiiiiiiiiiiiiiii;
  var ftCall_vifiiiiiiiiiiiiiiiiii=env.ftCall_vifiiiiiiiiiiiiiiiiii;
  var invoke_viiiiiiiiiii=env.invoke_viiiiiiiiiii;
  var ftCall_viiiiiiiiiii=env.ftCall_viiiiiiiiiii;
  var invoke_fff=env.invoke_fff;
  var ftCall_fff=env.ftCall_fff;
  var invoke_fiiiiiifiiiiiif=env.invoke_fiiiiiifiiiiiif;
  var ftCall_fiiiiiifiiiiiif=env.ftCall_fiiiiiifiiiiiif;
  var invoke_iiiiifiif=env.invoke_iiiiifiif;
  var ftCall_iiiiifiif=env.ftCall_iiiiifiif;
  var invoke_iiiiifii=env.invoke_iiiiifii;
  var ftCall_iiiiifii=env.ftCall_iiiiifii;
  var invoke_iiffi=env.invoke_iiffi;
  var ftCall_iiffi=env.ftCall_iiffi;
  var invoke_vidd=env.invoke_vidd;
  var ftCall_vidd=env.ftCall_vidd;
  var invoke_iiiiiiiiiiii=env.invoke_iiiiiiiiiiii;
  var ftCall_iiiiiiiiiiii=env.ftCall_iiiiiiiiiiii;
  var invoke_fif=env.invoke_fif;
  var ftCall_fif=env.ftCall_fif;
  var invoke_viifiii=env.invoke_viifiii;
  var ftCall_viifiii=env.ftCall_viifiii;
  var invoke_fii=env.invoke_fii;
  var ftCall_fii=env.ftCall_fii;
  var invoke_viiiiiff=env.invoke_viiiiiff;
  var ftCall_viiiiiff=env.ftCall_viiiiiff;
  var invoke_viiiiiifiii=env.invoke_viiiiiifiii;
  var ftCall_viiiiiifiii=env.ftCall_viiiiiifiii;
  var invoke_di=env.invoke_di;
  var ftCall_di=env.ftCall_di;
  var invoke_viff=env.invoke_viff;
  var ftCall_viff=env.ftCall_viff;
  var invoke_iiifiii=env.invoke_iiifiii;
  var ftCall_iiifiii=env.ftCall_iiifiii;
  var invoke_viiiif=env.invoke_viiiif;
  var ftCall_viiiif=env.ftCall_viiiif;
  var invoke_viffff=env.invoke_viffff;
  var ftCall_viffff=env.ftCall_viffff;
  var invoke_vfff=env.invoke_vfff;
  var ftCall_vfff=env.ftCall_vfff;
  var invoke_vififfi=env.invoke_vififfi;
  var ftCall_vififfi=env.ftCall_vififfi;
  var invoke_dii=env.invoke_dii;
  var ftCall_dii=env.ftCall_dii;
  var invoke_iiifiiff=env.invoke_iiifiiff;
  var ftCall_iiifiiff=env.ftCall_iiifiiff;
  var invoke_viiiiii=env.invoke_viiiiii;
  var ftCall_viiiiii=env.ftCall_viiiiii;
  var invoke_iifff=env.invoke_iifff;
  var ftCall_iifff=env.ftCall_iifff;
  var invoke_iifii=env.invoke_iifii;
  var ftCall_iifii=env.ftCall_iifii;
  var invoke_iiiiiiiiii=env.invoke_iiiiiiiiii;
  var ftCall_iiiiiiiiii=env.ftCall_iiiiiiiiii;
  var invoke_vdddddd=env.invoke_vdddddd;
  var ftCall_vdddddd=env.ftCall_vdddddd;
  var invoke_iiiiiiiiiiiiffffii=env.invoke_iiiiiiiiiiiiffffii;
  var ftCall_iiiiiiiiiiiiffffii=env.ftCall_iiiiiiiiiiiiffffii;
  var invoke_vdd=env.invoke_vdd;
  var ftCall_vdd=env.ftCall_vdd;
  var invoke_iiiif=env.invoke_iiiif;
  var ftCall_iiiif=env.ftCall_iiiif;
  var invoke_iiiiiiii=env.invoke_iiiiiiii;
  var ftCall_iiiiiiii=env.ftCall_iiiiiiii;
  var invoke_vfii=env.invoke_vfii;
  var ftCall_vfii=env.ftCall_vfii;
  var invoke_vifiiiiiiiiiiiii=env.invoke_vifiiiiiiiiiiiii;
  var ftCall_vifiiiiiiiiiiiii=env.ftCall_vifiiiiiiiiiiiii;
  var invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.invoke_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var ftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.ftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var invoke_iiiiiiif=env.invoke_iiiiiiif;
  var ftCall_iiiiiiif=env.ftCall_iiiiiiif;
  var invoke_iiiii=env.invoke_iiiii;
  var ftCall_iiiii=env.ftCall_iiiii;
  var invoke_vifififfi=env.invoke_vifififfi;
  var ftCall_vifififfi=env.ftCall_vifififfi;
  var invoke_iiifii=env.invoke_iiifii;
  var ftCall_iiifii=env.ftCall_iiifii;
  var invoke_viiiiiiiiiiiiiiiii=env.invoke_viiiiiiiiiiiiiiiii;
  var ftCall_viiiiiiiiiiiiiiiii=env.ftCall_viiiiiiiiiiiiiiiii;
  var invoke_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.invoke_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var ftCall_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii=env.ftCall_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii;
  var invoke_viffi=env.invoke_viffi;
  var ftCall_viffi=env.ftCall_viffi;
  var invoke_iiiifiiii=env.invoke_iiiifiiii;
  var ftCall_iiiifiiii=env.ftCall_iiiifiiii;
  var invoke_vifi=env.invoke_vifi;
  var ftCall_vifi=env.ftCall_vifi;
  var invoke_vifff=env.invoke_vifff;
  var ftCall_vifff=env.ftCall_vifff;
  var invoke_viifififfi=env.invoke_viifififfi;
  var ftCall_viifififfi=env.ftCall_viifififfi;
  var invoke_fiii=env.invoke_fiii;
  var ftCall_fiii=env.ftCall_fiii;
  var invoke_iiiiiifffiiifii=env.invoke_iiiiiifffiiifii;
  var ftCall_iiiiiifffiiifii=env.ftCall_iiiiiifffiiifii;
  var invoke_iifiiff=env.invoke_iifiiff;
  var ftCall_iifiiff=env.ftCall_iifiiff;
  var invoke_iifiii=env.invoke_iifiii;
  var ftCall_iifiii=env.ftCall_iifiii;
  var invoke_fiif=env.invoke_fiif;
  var ftCall_fiif=env.ftCall_fiif;
  var invoke_iiiiifiiiif=env.invoke_iiiiifiiiif;
  var ftCall_iiiiifiiiif=env.ftCall_iiiiifiiiif;
  var invoke_iiidiiii=env.invoke_iiidiiii;
  var ftCall_iiidiiii=env.ftCall_iiidiiii;
  var invoke_iiifiifii=env.invoke_iiifiifii;
  var ftCall_iiifiifii=env.ftCall_iiifiifii;
  var invoke_viiiiiiiiii=env.invoke_viiiiiiiiii;
  var ftCall_viiiiiiiiii=env.ftCall_viiiiiiiiii;
  var invoke_iiiiiiffiiiiiiiiiffffiii=env.invoke_iiiiiiffiiiiiiiiiffffiii;
  var ftCall_iiiiiiffiiiiiiiiiffffiii=env.ftCall_iiiiiiffiiiiiiiiiffffiii;
  var invoke_diii=env.invoke_diii;
  var ftCall_diii=env.ftCall_diii;
  var invoke_iifififf=env.invoke_iifififf;
  var ftCall_iifififf=env.ftCall_iifififf;
  var invoke_viiiiiiiiiiii=env.invoke_viiiiiiiiiiii;
  var ftCall_viiiiiiiiiiii=env.ftCall_viiiiiiiiiiii;
  var invoke_iiiiii=env.invoke_iiiiii;
  var ftCall_iiiiii=env.ftCall_iiiiii;
  var invoke_iiiiid=env.invoke_iiiiid;
  var ftCall_iiiiid=env.ftCall_iiiiid;
  var invoke_iiiiiifiif=env.invoke_iiiiiifiif;
  var ftCall_iiiiiifiif=env.ftCall_iiiiiifiif;
  var invoke_viiii=env.invoke_viiii;
  var ftCall_viiii=env.ftCall_viiii;
  var invoke_viiiii=env.invoke_viiiii;
  var ftCall_viiiii=env.ftCall_viiiii;
  var invoke_vif=env.invoke_vif;
  var ftCall_vif=env.ftCall_vif;
  var invoke_vid=env.invoke_vid;
  var ftCall_vid=env.ftCall_vid;
  var invoke_iiidi=env.invoke_iiidi;
  var ftCall_iiidi=env.ftCall_iiidi;
  var invoke_vii=env.invoke_vii;
  var ftCall_vii=env.ftCall_vii;
  var invoke_iiiifififf=env.invoke_iiiifififf;
  var ftCall_iiiifififf=env.ftCall_iiiifififf;
  var invoke_iiiiiifii=env.invoke_iiiiiifii;
  var ftCall_iiiiiifii=env.ftCall_iiiiiifii;
  var invoke_iiifiififf=env.invoke_iiifiififf;
  var ftCall_iiifiififf=env.ftCall_iiifiififf;
  var invoke_d=env.invoke_d;
  var ftCall_d=env.ftCall_d;
  var invoke_viiifififfi=env.invoke_viiifififfi;
  var ftCall_viiifififfi=env.ftCall_viiifififfi;
  var invoke_viifii=env.invoke_viifii;
  var ftCall_viifii=env.ftCall_viifii;
  var invoke_fi=env.invoke_fi;
  var ftCall_fi=env.ftCall_fi;
  var invoke_viifif=env.invoke_viifif;
  var ftCall_viifif=env.ftCall_viifif;
  var invoke_fiiiiiiiifiiiif=env.invoke_fiiiiiiiifiiiif;
  var ftCall_fiiiiiiiifiiiif=env.ftCall_fiiiiiiiifiiiif;
  var invoke_viiifiiiii=env.invoke_viiifiiiii;
  var ftCall_viiifiiiii=env.ftCall_viiifiiiii;
  var invoke_iiiififf=env.invoke_iiiififf;
  var ftCall_iiiififf=env.ftCall_iiiififf;
  var invoke_vifiii=env.invoke_vifiii;
  var ftCall_vifiii=env.ftCall_vifiii;
  var invoke_viiiifiiiiif=env.invoke_viiiifiiiiif;
  var ftCall_viiiifiiiiif=env.ftCall_viiiifiiiiif;
  var invoke_viiiiiiiiiiiiiii=env.invoke_viiiiiiiiiiiiiii;
  var ftCall_viiiiiiiiiiiiiii=env.ftCall_viiiiiiiiiiiiiii;
  var invoke_iiiiiiiiiiffffii=env.invoke_iiiiiiiiiiffffii;
  var ftCall_iiiiiiiiiiffffii=env.ftCall_iiiiiiiiiiffffii;
  var invoke_iiiiiff=env.invoke_iiiiiff;
  var ftCall_iiiiiff=env.ftCall_iiiiiff;
  var invoke_viiiiiiii=env.invoke_viiiiiiii;
  var ftCall_viiiiiiii=env.ftCall_viiiiiiii;
  var invoke_viiff=env.invoke_viiff;
  var ftCall_viiff=env.ftCall_viiff;
  var invoke_iif=env.invoke_iif;
  var ftCall_iif=env.ftCall_iif;
  var invoke_vifiiii=env.invoke_vifiiii;
  var ftCall_vifiiii=env.ftCall_vifiiii;
  var invoke_viiiiiii=env.invoke_viiiiiii;
  var ftCall_viiiiiii=env.ftCall_viiiiiii;
  var invoke_vifii=env.invoke_vifii;
  var ftCall_vifii=env.ftCall_vifii;
  var invoke_viiiiiiiii=env.invoke_viiiiiiiii;
  var ftCall_viiiiiiiii=env.ftCall_viiiiiiiii;
  var invoke_iii=env.invoke_iii;
  var ftCall_iii=env.ftCall_iii;
  var invoke_fiiiif=env.invoke_fiiiif;
  var ftCall_fiiiif=env.ftCall_fiiiif;
  var invoke_iiiifii=env.invoke_iiiifii;
  var ftCall_iiiifii=env.ftCall_iiiifii;
  var invoke_f=env.invoke_f;
  var ftCall_f=env.ftCall_f;
  var invoke_vffff=env.invoke_vffff;
  var ftCall_vffff=env.ftCall_vffff;
  var invoke_iiiff=env.invoke_iiiff;
  var ftCall_iiiff=env.ftCall_iiiff;
  var invoke_viii=env.invoke_viii;
  var ftCall_viii=env.ftCall_viii;
  var invoke_v=env.invoke_v;
  var ftCall_v=env.ftCall_v;
  var invoke_viid=env.invoke_viid;
  var ftCall_viid=env.ftCall_viid;
  var invoke_viif=env.invoke_viif;
  var ftCall_viif=env.ftCall_viif;
  var invoke_iiiifi=env.invoke_iiiifi;
  var ftCall_iiiifi=env.ftCall_iiiifi;
  var invoke_iiifififf=env.invoke_iiifififf;
  var ftCall_iiifififf=env.ftCall_iiifififf;
  var invoke_vd=env.invoke_vd;
  var ftCall_vd=env.ftCall_vd;
  var invoke_vf=env.invoke_vf;
  var ftCall_vf=env.ftCall_vf;
  var invoke_vi=env.invoke_vi;
  var ftCall_vi=env.ftCall_vi;
  var invoke_iiiiiiiiiii=env.invoke_iiiiiiiiiii;
  var ftCall_iiiiiiiiiii=env.ftCall_iiiiiiiiiii;
  var invoke_iiiiff=env.invoke_iiiiff;
  var ftCall_iiiiff=env.ftCall_iiiiff;
  var invoke_ii=env.invoke_ii;
  var ftCall_ii=env.ftCall_ii;
  var invoke_iiff=env.invoke_iiff;
  var ftCall_iiff=env.ftCall_iiff;
  var invoke_viifi=env.invoke_viifi;
  var ftCall_viifi=env.ftCall_viifi;
  var invoke_iiiiifiiiiii=env.invoke_iiiiifiiiiii;
  var ftCall_iiiiifiiiiii=env.ftCall_iiiiifiiiiii;
  var invoke_iiiiifiiiiif=env.invoke_iiiiifiiiiif;
  var ftCall_iiiiifiiiiif=env.ftCall_iiiiifiiiiif;
  var invoke_iiiifiiff=env.invoke_iiiifiiff;
  var ftCall_iiiifiiff=env.ftCall_iiiifiiff;
  var invoke_iifi=env.invoke_iifi;
  var ftCall_iifi=env.ftCall_iifi;
  var invoke_if=env.invoke_if;
  var ftCall_if=env.ftCall_if;
  var invoke_viiif=env.invoke_viiif;
  var ftCall_viiif=env.ftCall_viiif;
  var invoke_vffffi=env.invoke_vffffi;
  var ftCall_vffffi=env.ftCall_vffffi;
  var invoke_vifiiiiiiiiiiiiiiiiiiiiiii=env.invoke_vifiiiiiiiiiiiiiiiiiiiiiii;
  var ftCall_vifiiiiiiiiiiiiiiiiiiiiiii=env.ftCall_vifiiiiiiiiiiiiiiiiiiiiiii;
  var invoke_iiiffii=env.invoke_iiiffii;
  var ftCall_iiiffii=env.ftCall_iiiffii;
  var invoke_iifiiiii=env.invoke_iifiiiii;
  var ftCall_iifiiiii=env.ftCall_iifiiiii;
  var invoke_iiifi=env.invoke_iiifi;
  var ftCall_iiifi=env.ftCall_iiifi;
  var invoke_iiii=env.invoke_iiii;
  var ftCall_iiii=env.ftCall_iiii;
  var invoke_viifff=env.invoke_viifff;
  var ftCall_viifff=env.ftCall_viifff;
  var invoke_iifiififf=env.invoke_iifiififf;
  var ftCall_iifiififf=env.ftCall_iifiififf;
  var invoke_viiffi=env.invoke_viiffi;
  var ftCall_viiffi=env.ftCall_viiffi;
  var invoke_iiid=env.invoke_iiid;
  var ftCall_iiid=env.ftCall_iiid;
  var invoke_iiif=env.invoke_iiif;
  var ftCall_iiif=env.ftCall_iiif;
  var invoke_viiiffi=env.invoke_viiiffi;
  var ftCall_viiiffi=env.ftCall_viiiffi;
  var invoke_vffffffi=env.invoke_vffffffi;
  var ftCall_vffffffi=env.ftCall_vffffffi;
  var invoke_viiifi=env.invoke_viiifi;
  var ftCall_viiifi=env.ftCall_viiifi;
  var invoke_iiiifiii=env.invoke_iiiifiii;
  var ftCall_iiiifiii=env.ftCall_iiiifiii;
  var invoke_ff=env.invoke_ff;
  var ftCall_ff=env.ftCall_ff;
  var invoke_iiiifiiiii=env.invoke_iiiifiiiii;
  var ftCall_iiiifiiiii=env.ftCall_iiiifiiiii;
  var invoke_iiiifiififf=env.invoke_iiiifiififf;
  var ftCall_iiiifiififf=env.ftCall_iiiifiififf;
  var invoke_viififfi=env.invoke_viififfi;
  var ftCall_viififfi=env.ftCall_viififfi;
  var invoke_viffffffffffffiiii=env.invoke_viffffffffffffiiii;
  var ftCall_viffffffffffffiiii=env.ftCall_viffffffffffffiiii;
  var invoke_vfi=env.invoke_vfi;
  var ftCall_vfi=env.ftCall_vfi;
  var invoke_iififf=env.invoke_iififf;
  var ftCall_iififf=env.ftCall_iififf;
  var invoke_i=env.invoke_i;
  var ftCall_i=env.ftCall_i;
  var invoke_vff=env.invoke_vff;
  var ftCall_vff=env.ftCall_vff;
  var invoke_iiififf=env.invoke_iiififf;
  var ftCall_iiififf=env.ftCall_iiififf;
  var invoke_vifffff=env.invoke_vifffff;
  var ftCall_vifffff=env.ftCall_vifffff;
  var invoke_iiiiiiiii=env.invoke_iiiiiiiii;
  var ftCall_iiiiiiiii=env.ftCall_iiiiiiiii;
  var invoke_viffffi=env.invoke_viffffi;
  var ftCall_viffffi=env.ftCall_viffffi;
  var _glClearStencil=env._glClearStencil;
  var __ZN4FMOD13DSPConnection6getMixEPf=env.__ZN4FMOD13DSPConnection6getMixEPf;
  var _glUniformMatrix2fv=env._glUniformMatrix2fv;
  var _il2cpp_class_get_image=env._il2cpp_class_get_image;
  var _eglGetCurrentSurface=env._eglGetCurrentSurface;
  var _glUniformMatrix4fv=env._glUniformMatrix4fv;
  var _glfwGetMouseWheel=env._glfwGetMouseWheel;
  var _emscripten_worker_respond=env._emscripten_worker_respond;
  var _pthread_attr_setdetachstate=env._pthread_attr_setdetachstate;
  var _emscripten_glDeleteSync=env._emscripten_glDeleteSync;
  var _emscripten_webgl_create_context=env._emscripten_webgl_create_context;
  var _glDisableVertexAttribArray=env._glDisableVertexAttribArray;
  var _pthread_attr_init=env._pthread_attr_init;
  var _Mix_Resume=env._Mix_Resume;
  var _emscripten_glBindSampler=env._emscripten_glBindSampler;
  var _glInvalidateFramebuffer=env._glInvalidateFramebuffer;
  var ___restore_sigs=env.___restore_sigs;
  var _glewGetErrorString=env._glewGetErrorString;
  var _glfwSetWindowSizeCallback=env._glfwSetWindowSizeCallback;
  var _glUniform3f=env._glUniform3f;
  var _glGenSamplers=env._glGenSamplers;
  var _glEndTransformFeedback=env._glEndTransformFeedback;
  var _il2cpp_class_from_system_type=env._il2cpp_class_from_system_type;
  var _il2cpp_thread_current=env._il2cpp_thread_current;
  var _emscripten_glIsQuery=env._emscripten_glIsQuery;
  var _glGetSynciv=env._glGetSynciv;
  var _SDL_LoadBMP_RW=env._SDL_LoadBMP_RW;
  var _alcCreateContext=env._alcCreateContext;
  var _SDL_GetVideoSurface=env._SDL_GetVideoSurface;
  var _emscripten_asm_const_iii=env._emscripten_asm_const_iii;
  var _SDL_GetTicks=env._SDL_GetTicks;
  var _SDL_GetKeyboardState=env._SDL_GetKeyboardState;
  var _wait=env._wait;
  var _emscripten_glFlush=env._emscripten_glFlush;
  var _llvm_powi_f64=env._llvm_powi_f64;
  var _nanosleep=env._nanosleep;
  var _setgroups=env._setgroups;
  var _pthread_once=env._pthread_once;
  var _pthread_rwlock_trywrlock=env._pthread_rwlock_trywrlock;
  var _glewGetExtension=env._glewGetExtension;
  var _emscripten_glGetAttribLocation=env._emscripten_glGetAttribLocation;
  var _glUniform1ui=env._glUniform1ui;
  var _emscripten_glTexCoordPointer=env._emscripten_glTexCoordPointer;
  var _emscripten_idb_async_exists=env._emscripten_idb_async_exists;
  var _glfwRestoreWindow=env._glfwRestoreWindow;
  var _emscripten_set_blur_callback=env._emscripten_set_blur_callback;
  var _emscripten_set_mouseout_callback=env._emscripten_set_mouseout_callback;
  var _emscripten_glGetInteger64v=env._emscripten_glGetInteger64v;
  var _eglCreateWindowSurface=env._eglCreateWindowSurface;
  var _llvm_invariant_end=env._llvm_invariant_end;
  var _SDL_Has3DNow=env._SDL_Has3DNow;
  var _emscripten_glBeginQuery=env._emscripten_glBeginQuery;
  var __Exit=env.__Exit;
  var _emscripten_glBeginTransformFeedback=env._emscripten_glBeginTransformFeedback;
  var _glCompressedTexImage2D=env._glCompressedTexImage2D;
  var _SDL_EnableUNICODE=env._SDL_EnableUNICODE;
  var ___syscall295=env.___syscall295;
  var ___syscall296=env.___syscall296;
  var ___syscall297=env.___syscall297;
  var ___syscall298=env.___syscall298;
  var ___syscall299=env.___syscall299;
  var _SDL_getenv=env._SDL_getenv;
  var _emscripten_vibrate=env._emscripten_vibrate;
  var _Mix_LoadMUS=env._Mix_LoadMUS;
  var _emscripten_glGetBufferParameteriv=env._emscripten_glGetBufferParameteriv;
  var _posix_spawnp=env._posix_spawnp;
  var _alListenerf=env._alListenerf;
  var ___syscall272=env.___syscall272;
  var _emscripten_autodebug_i16=env._emscripten_autodebug_i16;
  var _emscripten_glDepthRange=env._emscripten_glDepthRange;
  var _sqrtf=env._sqrtf;
  var __Unwind_DeleteException=env.__Unwind_DeleteException;
  var _sqrtl=env._sqrtl;
  var _SDL_ClearError=env._SDL_ClearError;
  var _il2cpp_gchandle_free=env._il2cpp_gchandle_free;
  var _emscripten_glStencilFunc=env._emscripten_glStencilFunc;
  var ___syscall181=env.___syscall181;
  var _emscripten_atomic_add_u32=env._emscripten_atomic_add_u32;
  var ___syscall183=env.___syscall183;
  var _alDistanceModel=env._alDistanceModel;
  var _glewInit=env._glewInit;
  var _glGetUniformBlockIndex=env._glGetUniformBlockIndex;
  var _glGetActiveUniformBlockName=env._glGetActiveUniformBlockName;
  var _glGetUniformIndices=env._glGetUniformIndices;
  var _SDL_UnlockAudio=env._SDL_UnlockAudio;
  var _pathconf=env._pathconf;
  var _emscripten_vr_hmd_get_eye_parameters=env._emscripten_vr_hmd_get_eye_parameters;
  var _eglInitialize=env._eglInitialize;
  var _emscripten_get_worker_queue_size=env._emscripten_get_worker_queue_size;
  var _times=env._times;
  var _glDeleteQueries=env._glDeleteQueries;
  var _il2cpp_class_get_name=env._il2cpp_class_get_name;
  var _emscripten_glUniform2uiv=env._emscripten_glUniform2uiv;
  var _glfwUnlockMutex=env._glfwUnlockMutex;
  var _glClearDepth=env._glClearDepth;
  var _JS_Sound_SetLoop=env._JS_Sound_SetLoop;
  var _gluOrtho2D=env._gluOrtho2D;
  var _JS_WebCamVideo_CanPlay=env._JS_WebCamVideo_CanPlay;
  var _glGetActiveUniformBlockiv=env._glGetActiveUniformBlockiv;
  var _sigprocmask=env._sigprocmask;
  var _emscripten_glGetFloatv=env._emscripten_glGetFloatv;
  var _glfwSetWindowTitle=env._glfwSetWindowTitle;
  var _glVertexAttrib1f=env._glVertexAttrib1f;
  var ___cxa_uncaught_exception=env.___cxa_uncaught_exception;
  var _exp=env._exp;
  var _il2cpp_class_is_generic=env._il2cpp_class_is_generic;
  var _Mix_Playing=env._Mix_Playing;
  var _SDL_LowerBlit=env._SDL_LowerBlit;
  var _emscripten_glIsProgram=env._emscripten_glIsProgram;
  var _filledEllipseRGBA=env._filledEllipseRGBA;
  var _JS_UNETWebSockets_SocketCleanEvnt=env._JS_UNETWebSockets_SocketCleanEvnt;
  var _emscripten_request_fullscreen=env._emscripten_request_fullscreen;
  var _il2cpp_object_unbox=env._il2cpp_object_unbox;
  var _glGetUniformLocation=env._glGetUniformLocation;
  var _emscripten_glDisableVertexAttribArray=env._emscripten_glDisableVertexAttribArray;
  var _eglBindAPI=env._eglBindAPI;
  var _emscripten_glUniformMatrix2x4fv=env._emscripten_glUniformMatrix2x4fv;
  var _Mix_QuerySpec=env._Mix_QuerySpec;
  var _JS_UNETWebSockets_SocketStop=env._JS_UNETWebSockets_SocketStop;
  var _clock=env._clock;
  var _SDL_InitSubSystem=env._SDL_InitSubSystem;
  var _emscripten_glVertexAttribDivisor=env._emscripten_glVertexAttribDivisor;
  var _il2cpp_gchandle_new_weakref=env._il2cpp_gchandle_new_weakref;
  var _emscripten_glDeleteObjectARB=env._emscripten_glDeleteObjectARB;
  var _emscripten_request_fullscreen_strategy=env._emscripten_request_fullscreen_strategy;
  var _SDL_JoystickOpen=env._SDL_JoystickOpen;
  var __inet_pton6=env.__inet_pton6;
  var _emscripten_exit_with_live_runtime=env._emscripten_exit_with_live_runtime;
  var _glGenerateMipmap=env._glGenerateMipmap;
  var _JS_Sound_SetPosition=env._JS_Sound_SetPosition;
  var _emscripten_glGetUniformuiv=env._emscripten_glGetUniformuiv;
  var _emscripten_get_callstack_js=env._emscripten_get_callstack_js;
  var _il2cpp_class_is_subclass_of=env._il2cpp_class_is_subclass_of;
  var _glfwOpenWindow=env._glfwOpenWindow;
  var ___cxa_free_exception=env.___cxa_free_exception;
  var _emscripten_glValidateProgram=env._emscripten_glValidateProgram;
  var _glGetBufferParameteri64v=env._glGetBufferParameteri64v;
  var _pthread_rwlock_timedrdlock=env._pthread_rwlock_timedrdlock;
  var _emscripten_force_exit=env._emscripten_force_exit;
  var _llvm_log_f64=env._llvm_log_f64;
  var _SDL_GetNumAudioDrivers=env._SDL_GetNumAudioDrivers;
  var _glGenTextures=env._glGenTextures;
  var _alIsBuffer=env._alIsBuffer;
  var _SDL_JoystickOpened=env._SDL_JoystickOpened;
  var _emscripten_glUniform1uiv=env._emscripten_glUniform1uiv;
  var _glGetSamplerParameteriv=env._glGetSamplerParameteriv;
  var _SDL_MapRGB=env._SDL_MapRGB;
  var _emscripten_create_worker=env._emscripten_create_worker;
  var ___atomic_store_8=env.___atomic_store_8;
  var _glGetInteger64i_v=env._glGetInteger64i_v;
  var _emscripten_async_call=env._emscripten_async_call;
  var _SDL_SetWindowFullscreen=env._SDL_SetWindowFullscreen;
  var _emscripten_async_wget2_data=env._emscripten_async_wget2_data;
  var _llvm_pow_f64=env._llvm_pow_f64;
  var _timelocal=env._timelocal;
  var _glVertexAttribDivisorANGLE=env._glVertexAttribDivisorANGLE;
  var _emscripten_glBlendFunc=env._emscripten_glBlendFunc;
  var _glfwGetNumberOfProcessors=env._glfwGetNumberOfProcessors;
  var _fabsl=env._fabsl;
  var _boxColor=env._boxColor;
  var _sigaddset=env._sigaddset;
  var _glfwLoadMemoryTexture2D=env._glfwLoadMemoryTexture2D;
  var _alcGetIntegerv=env._alcGetIntegerv;
  var _localtime_r=env._localtime_r;
  var _fabsf=env._fabsf;
  var ___atomic_compare_exchange_8=env.___atomic_compare_exchange_8;
  var _glGetFloatv=env._glGetFloatv;
  var ___atomic_fetch_sub_8=env.___atomic_fetch_sub_8;
  var _strftime=env._strftime;
  var _glReadPixels=env._glReadPixels;
  var _glGetActiveAttrib=env._glGetActiveAttrib;
  var _TTF_FontLineSkip=env._TTF_FontLineSkip;
  var _emscripten_glClearBufferuiv=env._emscripten_glClearBufferuiv;
  var _glutInit=env._glutInit;
  var _syscall=env._syscall;
  var _Mix_PauseMusic=env._Mix_PauseMusic;
  var _uuid_variant=env._uuid_variant;
  var _glFrontFace=env._glFrontFace;
  var _emscripten_glUniform1iv=env._emscripten_glUniform1iv;
  var _Mix_PlayChannelTimed=env._Mix_PlayChannelTimed;
  var _llvm_exp_f64=env._llvm_exp_f64;
  var _emscripten_glGetUniformIndices=env._emscripten_glGetUniformIndices;
  var _glGetProgramiv=env._glGetProgramiv;
  var _emscripten_autodebug_i64=env._emscripten_autodebug_i64;
  var _glScissor=env._glScissor;
  var _il2cpp_object_get_virtual_method=env._il2cpp_object_get_virtual_method;
  var _emscripten_set_focusin_callback=env._emscripten_set_focusin_callback;
  var _glClearBufferiv=env._glClearBufferiv;
  var ___cxa_find_matching_catch_2=env.___cxa_find_matching_catch_2;
  var ___cxa_find_matching_catch_3=env.___cxa_find_matching_catch_3;
  var _SDL_GetVideoInfo=env._SDL_GetVideoInfo;
  var _strftime_l=env._strftime_l;
  var _il2cpp_string_new_len=env._il2cpp_string_new_len;
  var _llvm_eh_typeid_for=env._llvm_eh_typeid_for;
  var _glBindBufferBase=env._glBindBufferBase;
  var _IMG_Init=env._IMG_Init;
  var _rectangleRGBA=env._rectangleRGBA;
  var _glVertexAttrib2f=env._glVertexAttrib2f;
  var _XOpenDisplay=env._XOpenDisplay;
  var _IMG_Load_RW=env._IMG_Load_RW;
  var _posix_spawn_file_actions_init=env._posix_spawn_file_actions_init;
  var _emscripten_glDrawElementsInstancedNV=env._emscripten_glDrawElementsInstancedNV;
  var _glGetVertexAttribIuiv=env._glGetVertexAttribIuiv;
  var _emscripten_is_main_browser_thread=env._emscripten_is_main_browser_thread;
  var _XStoreName=env._XStoreName;
  var _pthread_condattr_destroy=env._pthread_condattr_destroy;
  var _emscripten_destroy_worker=env._emscripten_destroy_worker;
  var _emscripten_set_main_loop=env._emscripten_set_main_loop;
  var _llvm_objectsize_i32=env._llvm_objectsize_i32;
  var _emscripten_glIsShader=env._emscripten_glIsShader;
  var _pthread_attr_getstack=env._pthread_attr_getstack;
  var _glDrawArraysInstancedNV=env._glDrawArraysInstancedNV;
  var _atexit=env._atexit;
  var _JS_UNETWebSockets_SocketRecvEvntBuffLengthFromHost=env._JS_UNETWebSockets_SocketRecvEvntBuffLengthFromHost;
  var _SDL_Linked_Version=env._SDL_Linked_Version;
  var _pthread_key_create=env._pthread_key_create;
  var _glutKeyboardUpFunc=env._glutKeyboardUpFunc;
  var _glBlendEquation=env._glBlendEquation;
  var _emscripten_glUseProgram=env._emscripten_glUseProgram;
  var _pthread_rwlock_destroy=env._pthread_rwlock_destroy;
  var _rotozoomSurface=env._rotozoomSurface;
  var _glGetAttribLocation=env._glGetAttribLocation;
  var _llvm_va_copy=env._llvm_va_copy;
  var _il2cpp_value_box=env._il2cpp_value_box;
  var _emscripten_glGenTransformFeedbacks=env._emscripten_glGenTransformFeedbacks;
  var _glVertexAttrib1fv=env._glVertexAttrib1fv;
  var _il2cpp_method_is_inflated=env._il2cpp_method_is_inflated;
  var _glShaderSource=env._glShaderSource;
  var _JS_SystemInfo_HasFullscreen=env._JS_SystemInfo_HasFullscreen;
  var _emscripten_set_element_css_size=env._emscripten_set_element_css_size;
  var _glGetVertexAttribfv=env._glGetVertexAttribfv;
  var _emscripten_glInvalidateFramebuffer=env._emscripten_glInvalidateFramebuffer;
  var _Mix_VolumeChunk=env._Mix_VolumeChunk;
  var _emscripten_get_main_loop_timing=env._emscripten_get_main_loop_timing;
  var _JS_WebRequest_SetTimeout=env._JS_WebRequest_SetTimeout;
  var _emscripten_set_batterychargingchange_callback=env._emscripten_set_batterychargingchange_callback;
  var _emscripten_glGetAttachedShaders=env._emscripten_glGetAttachedShaders;
  var _glVertexAttrib2fv=env._glVertexAttrib2fv;
  var _il2cpp_class_is_valuetype=env._il2cpp_class_is_valuetype;
  var _glBindRenderbuffer=env._glBindRenderbuffer;
  var _alGetSourcei=env._alGetSourcei;
  var _alGetSourcef=env._alGetSourcef;
  var _emscripten_glGetTexParameteriv=env._emscripten_glGetTexParameteriv;
  var _glDeleteTextures=env._glDeleteTextures;
  var _SDL_ThreadID=env._SDL_ThreadID;
  var _emscripten_set_mousedown_callback=env._emscripten_set_mousedown_callback;
  var ___atomic_fetch_or_8=env.___atomic_fetch_or_8;
  var _il2cpp_runtime_unhandled_exception_policy_set=env._il2cpp_runtime_unhandled_exception_policy_set;
  var _SDL_SaveBMP_RW=env._SDL_SaveBMP_RW;
  var _abs=env._abs;
  var _il2cpp_thread_detach=env._il2cpp_thread_detach;
  var _SDL_DestroyRenderer=env._SDL_DestroyRenderer;
  var _emscripten_glDeleteShader=env._emscripten_glDeleteShader;
  var _XMapWindow=env._XMapWindow;
  var _il2cpp_gchandle_new=env._il2cpp_gchandle_new;
  var _glVertexAttribDivisorARB=env._glVertexAttribDivisorARB;
  var _glGetSamplerParameterfv=env._glGetSamplerParameterfv;
  var _eglWaitNative=env._eglWaitNative;
  var _setpwent=env._setpwent;
  var _il2cpp_unity_liveness_calculation_end=env._il2cpp_unity_liveness_calculation_end;
  var _SDL_ShowCursor=env._SDL_ShowCursor;
  var _glfwPollEvents=env._glfwPollEvents;
  var _glUniform3ui=env._glUniform3ui;
  var _emscripten_force_num_logical_cores=env._emscripten_force_num_logical_cores;
  var _uuid_parse=env._uuid_parse;
  var _SDL_GetThreadID=env._SDL_GetThreadID;
  var _JS_UNETWebSockets_HostsContainingMessagesCleanHost=env._JS_UNETWebSockets_HostsContainingMessagesCleanHost;
  var _eglWaitClient=env._eglWaitClient;
  var _glIsEnabled=env._glIsEnabled;
  var _SDL_Init=env._SDL_Init;
  var _emscripten_glDisable=env._emscripten_glDisable;
  var ___cxa_end_catch=env.___cxa_end_catch;
  var _emscripten_glDeleteRenderbuffers=env._emscripten_glDeleteRenderbuffers;
  var _emscripten_glDrawElementsInstanced=env._emscripten_glDrawElementsInstanced;
  var _Mix_Init=env._Mix_Init;
  var _pthread_rwlockattr_setpshared=env._pthread_rwlockattr_setpshared;
  var _log=env._log;
  var _glfwSwapBuffers=env._glfwSwapBuffers;
  var __emscripten_push_uncounted_main_loop_blocker=env.__emscripten_push_uncounted_main_loop_blocker;
  var _llvm_floor_f64=env._llvm_floor_f64;
  var _llvm_cttz_i64=env._llvm_cttz_i64;
  var _emscripten_get_deviceorientation_status=env._emscripten_get_deviceorientation_status;
  var _alcCloseDevice=env._alcCloseDevice;
  var _glBufferData=env._glBufferData;
  var _emscripten_glGetShaderiv=env._emscripten_glGetShaderiv;
  var _emscripten_get_battery_status=env._emscripten_get_battery_status;
  var _Mix_ReserveChannels=env._Mix_ReserveChannels;
  var _acos=env._acos;
  var _glStencilOp=env._glStencilOp;
  var _glGetAttachedShaders=env._glGetAttachedShaders;
  var _emscripten_set_touchcancel_callback=env._emscripten_set_touchcancel_callback;
  var _glDeleteRenderbuffers=env._glDeleteRenderbuffers;
  var _gai_strerror=env._gai_strerror;
  var _glBlitFramebuffer=env._glBlitFramebuffer;
  var _emscripten_glClientWaitSync=env._emscripten_glClientWaitSync;
  var _emscripten_coroutine_next=env._emscripten_coroutine_next;
  var _emscripten_set_focus_callback=env._emscripten_set_focus_callback;
  var _XInternAtom=env._XInternAtom;
  var _emscripten_glCompileShader=env._emscripten_glCompileShader;
  var _SDL_JoystickNumButtons=env._SDL_JoystickNumButtons;
  var _emscripten_log_js=env._emscripten_log_js;
  var _uuid_clear=env._uuid_clear;
  var _posix_spawn=env._posix_spawn;
  var _alGetSourcefv=env._alGetSourcefv;
  var _emscripten_get_pointerlock_status=env._emscripten_get_pointerlock_status;
  var _glGetActiveUniformsiv=env._glGetActiveUniformsiv;
  var _emscripten_exit_fullscreen=env._emscripten_exit_fullscreen;
  var _glCopyTexSubImage2D=env._glCopyTexSubImage2D;
  var _glBlendColor=env._glBlendColor;
  var _il2cpp_string_chars=env._il2cpp_string_chars;
  var _getprotobynumber=env._getprotobynumber;
  var ___execvpe=env.___execvpe;
  var _llvm_trunc_f64=env._llvm_trunc_f64;
  var _pthread_getattr_np=env._pthread_getattr_np;
  var _emscripten_glUniformMatrix4x3fv=env._emscripten_glUniformMatrix4x3fv;
  var _il2cpp_method_has_attribute=env._il2cpp_method_has_attribute;
  var _pthread_getschedparam=env._pthread_getschedparam;
  var _sbrk=env._sbrk;
  var _sigismember=env._sigismember;
  var _Mix_SetPanning=env._Mix_SetPanning;
  var _dysize=env._dysize;
  var _glGetTransformFeedbackVarying=env._glGetTransformFeedbackVarying;
  var _emscripten_glGetShaderSource=env._emscripten_glGetShaderSource;
  var _glUniform4i=env._glUniform4i;
  var _glUniform4f=env._glUniform4f;
  var _glfwGetProcAddress=env._glfwGetProcAddress;
  var _SDL_JoystickNumBalls=env._SDL_JoystickNumBalls;
  var _emscripten_get_canvas_size=env._emscripten_get_canvas_size;
  var _JS_Sound_GetLength=env._JS_Sound_GetLength;
  var _emscripten_get_orientation_status=env._emscripten_get_orientation_status;
  var _SDL_putenv=env._SDL_putenv;
  var _expf=env._expf;
  var _glVertexAttrib3f=env._glVertexAttrib3f;
  var _expl=env._expl;
  var _glutMotionFunc=env._glutMotionFunc;
  var _glutCreateWindow=env._glutCreateWindow;
  var _JS_Eval_EvalJS=env._JS_Eval_EvalJS;
  var _execve=env._execve;
  var ___gcc_personality_v0=env.___gcc_personality_v0;
  var _execvp=env._execvp;
  var _glutGet=env._glutGet;
  var _il2cpp_field_get_offset=env._il2cpp_field_get_offset;
  var ___assert_func=env.___assert_func;
  var _emscripten_glColorMask=env._emscripten_glColorMask;
  var _llvm_mono_store_i8_p0i8=env._llvm_mono_store_i8_p0i8;
  var _emscripten_glGenVertexArrays=env._emscripten_glGenVertexArrays;
  var _glGetStringi=env._glGetStringi;
  var _alarm=env._alarm;
  var _glDepthFunc=env._glDepthFunc;
  var _emscripten_set_canvas_size=env._emscripten_set_canvas_size;
  var _Mix_FadeInMusicPos=env._Mix_FadeInMusicPos;
  var _wait4=env._wait4;
  var _alSourcePlay=env._alSourcePlay;
  var _glIsTexture=env._glIsTexture;
  var _SDL_SetPalette=env._SDL_SetPalette;
  var _glVertexAttribDivisor=env._glVertexAttribDivisor;
  var _emscripten_vibrate_pattern=env._emscripten_vibrate_pattern;
  var _emscripten_glUniform2ui=env._emscripten_glUniform2ui;
  var ___syscall15=env.___syscall15;
  var ___syscall14=env.___syscall14;
  var ___syscall12=env.___syscall12;
  var ___syscall10=env.___syscall10;
  var ___clock_gettime=env.___clock_gettime;
  var _alListenerfv=env._alListenerfv;
  var _SDL_LoadBMP=env._SDL_LoadBMP;
  var _putenv=env._putenv;
  var _glMapBufferRange=env._glMapBufferRange;
  var _eglReleaseThread=env._eglReleaseThread;
  var _emscripten_run_script_string=env._emscripten_run_script_string;
  var _JS_Cursor_SetImage=env._JS_Cursor_SetImage;
  var _glUniform3fv=env._glUniform3fv;
  var __Unwind_GetIPInfo=env.__Unwind_GetIPInfo;
  var _glClientWaitSync=env._glClientWaitSync;
  var _llvm_sqrt_f64=env._llvm_sqrt_f64;
  var _glDrawArraysInstancedANGLE=env._glDrawArraysInstancedANGLE;
  var _emscripten_glGetActiveUniform=env._emscripten_glGetActiveUniform;
  var emscriptenWebGLGetVertexAttrib=env.emscriptenWebGLGetVertexAttrib;
  var _glutDestroyWindow=env._glutDestroyWindow;
  var _glFlushMappedBufferRange=env._glFlushMappedBufferRange;
  var _alGenSources=env._alGenSources;
  var _emscripten_glColorPointer=env._emscripten_glColorPointer;
  var _setprotoent=env._setprotoent;
  var _llvm_fma_f64=env._llvm_fma_f64;
  var _llvm_eh_exception=env._llvm_eh_exception;
  var _emscripten_glDepthMask=env._emscripten_glDepthMask;
  var _emscripten_glDrawBuffers=env._emscripten_glDrawBuffers;
  var _glfwTerminate=env._glfwTerminate;
  var _sigpending=env._sigpending;
  var _pthread_rwlock_timedwrlock=env._pthread_rwlock_timedwrlock;
  var _emscripten_resume_main_loop=env._emscripten_resume_main_loop;
  var _JS_Sound_GetLoadState=env._JS_Sound_GetLoadState;
  var _emscripten_glSamplerParameterfv=env._emscripten_glSamplerParameterfv;
  var _glDrawBuffers=env._glDrawBuffers;
  var _glUniform4uiv=env._glUniform4uiv;
  var _alGetSourceiv=env._alGetSourceiv;
  var _glDeleteShader=env._glDeleteShader;
  var _emscripten_glEndQuery=env._emscripten_glEndQuery;
  var _il2cpp_exception_from_name_msg=env._il2cpp_exception_from_name_msg;
  var _emscripten_glShaderSource=env._emscripten_glShaderSource;
  var _glGenVertexArrays=env._glGenVertexArrays;
  var _fork=env._fork;
  var _usleep=env._usleep;
  var _zoomSurface=env._zoomSurface;
  var _endprotoent=env._endprotoent;
  var _glGenRenderbuffers=env._glGenRenderbuffers;
  var _eglTerminate=env._eglTerminate;
  var _TTF_RenderText_Blended=env._TTF_RenderText_Blended;
  var _emscripten_glFrustum=env._emscripten_glFrustum;
  var _emscripten_glDepthRangef=env._emscripten_glDepthRangef;
  var _emscripten_glGenerateMipmap=env._emscripten_glGenerateMipmap;
  var _SDL_LogSetOutputFunction=env._SDL_LogSetOutputFunction;
  var _emscripten_glIsTexture=env._emscripten_glIsTexture;
  var _emscripten_glBindVertexArray=env._emscripten_glBindVertexArray;
  var _emscripten_glActiveTexture=env._emscripten_glActiveTexture;
  var _emscripten_set_wheel_callback=env._emscripten_set_wheel_callback;
  var _glFramebufferTextureLayer=env._glFramebufferTextureLayer;
  var _JS_FileSystem_HasIndexedDB=env._JS_FileSystem_HasIndexedDB;
  var _emscripten_glCopyTexSubImage2D=env._emscripten_glCopyTexSubImage2D;
  var _SDL_UpperBlit=env._SDL_UpperBlit;
  var ___syscall221=env.___syscall221;
  var ___syscall220=env.___syscall220;
  var __inet_ntop6_raw=env.__inet_ntop6_raw;
  var _emscripten_idb_async_delete=env._emscripten_idb_async_delete;
  var _emscripten_set_visibilitychange_callback=env._emscripten_set_visibilitychange_callback;
  var _glSamplerParameterfv=env._glSamplerParameterfv;
  var _glVertexAttrib4f=env._glVertexAttrib4f;
  var _emscripten_glDepthFunc=env._emscripten_glDepthFunc;
  var _il2cpp_class_get_field_from_name=env._il2cpp_class_get_field_from_name;
  var _emscripten_glGetStringi=env._emscripten_glGetStringi;
  var _llvm_memory_barrier=env._llvm_memory_barrier;
  var _SDL_CreateThread=env._SDL_CreateThread;
  var _endgrent=env._endgrent;
  var _llvm_eh_selector=env._llvm_eh_selector;
  var __emscripten_atomic_fetch_and_and_u64=env.__emscripten_atomic_fetch_and_and_u64;
  var _emscripten_glUniform1f=env._emscripten_glUniform1f;
  var _SDL_GetRGB=env._SDL_GetRGB;
  var ___syscall133=env.___syscall133;
  var ___syscall132=env.___syscall132;
  var _il2cpp_class_from_name=env._il2cpp_class_from_name;
  var _TTF_GlyphMetrics=env._TTF_GlyphMetrics;
  var _glBindTransformFeedback=env._glBindTransformFeedback;
  var _glFramebufferRenderbuffer=env._glFramebufferRenderbuffer;
  var _il2cpp_class_has_parent=env._il2cpp_class_has_parent;
  var _emscripten_glCopyTexImage2D=env._emscripten_glCopyTexImage2D;
  var _gmtime_r=env._gmtime_r;
  var _glResumeTransformFeedback=env._glResumeTransformFeedback;
  var _emscripten_glAttachShader=env._emscripten_glAttachShader;
  var __Z43InvokeRegisterStaticallyLinkedModuleClassesv=env.__Z43InvokeRegisterStaticallyLinkedModuleClassesv;
  var _emscripten_vr_get_device_type=env._emscripten_vr_get_device_type;
  var ___syscall180=env.___syscall180;
  var _il2cpp_runtime_object_init=env._il2cpp_runtime_object_init;
  var _emscripten_glTexParameterfv=env._emscripten_glTexParameterfv;
  var _emscripten_glDrawArraysInstanced=env._emscripten_glDrawArraysInstanced;
  var _il2cpp_object_get_size=env._il2cpp_object_get_size;
  var _il2cpp_gchandle_get_target=env._il2cpp_gchandle_get_target;
  var ___cxa_call_unexpected=env.___cxa_call_unexpected;
  var _il2cpp_domain_get=env._il2cpp_domain_get;
  var _il2cpp_string_length=env._il2cpp_string_length;
  var _dlopen=env._dlopen;
  var _glBeginQuery=env._glBeginQuery;
  var _emscripten_glLoadMatrixf=env._emscripten_glLoadMatrixf;
  var _emscripten_glStencilFuncSeparate=env._emscripten_glStencilFuncSeparate;
  var _emscripten_webgl_enable_extension=env._emscripten_webgl_enable_extension;
  var _emscripten_glTexStorage3D=env._emscripten_glTexStorage3D;
  var _glCullFace=env._glCullFace;
  var _emscripten_set_socket_message_callback=env._emscripten_set_socket_message_callback;
  var _emscripten_get_gamepad_status=env._emscripten_get_gamepad_status;
  var _SDL_SetAlpha=env._SDL_SetAlpha;
  var _sched_yield=env._sched_yield;
  var _emscripten_set_touchmove_callback=env._emscripten_set_touchmove_callback;
  var ___syscall29=env.___syscall29;
  var ___syscall20=env.___syscall20;
  var _glfwSetMouseWheel=env._glfwSetMouseWheel;
  var _JS_WebRequest_SetRequestHeader=env._JS_WebRequest_SetRequestHeader;
  var _pthread_rwlockattr_destroy=env._pthread_rwlockattr_destroy;
  var _glDrawArrays=env._glDrawArrays;
  var _il2cpp_raise_exception=env._il2cpp_raise_exception;
  var _il2cpp_type_get_name=env._il2cpp_type_get_name;
  var _emscripten_vr_init=env._emscripten_vr_init;
  var _il2cpp_profiler_install_gc=env._il2cpp_profiler_install_gc;
  var _SDL_NumJoysticks=env._SDL_NumJoysticks;
  var _emscripten_glVertexAttribI4uiv=env._emscripten_glVertexAttribI4uiv;
  var _emscripten_glFramebufferTexture2D=env._emscripten_glFramebufferTexture2D;
  var _sinl=env._sinl;
  var _glfwGetWindowParam=env._glfwGetWindowParam;
  var _glVertexAttrib4fv=env._glVertexAttrib4fv;
  var _emscripten_glDeleteQueries=env._emscripten_glDeleteQueries;
  var ___mulsc3=env.___mulsc3;
  var ___atomic_load_8=env.___atomic_load_8;
  var _sin=env._sin;
  var _emscripten_glRenderbufferStorage=env._emscripten_glRenderbufferStorage;
  var _glUniformMatrix2x4fv=env._glUniformMatrix2x4fv;
  var _emscripten_glGetActiveUniformsiv=env._emscripten_glGetActiveUniformsiv;
  var _emscripten_glVertexPointer=env._emscripten_glVertexPointer;
  var _timegm=env._timegm;
  var _emscripten_glGetTransformFeedbackVarying=env._emscripten_glGetTransformFeedbackVarying;
  var _glLinkProgram=env._glLinkProgram;
  var _alcIsExtensionPresent=env._alcIsExtensionPresent;
  var _JS_UNETWebSockets_SocketRecvEvntType=env._JS_UNETWebSockets_SocketRecvEvntType;
  var _emscripten_glCopyTexSubImage3D=env._emscripten_glCopyTexSubImage3D;
  var _glfwSetWindowCloseCallback=env._glfwSetWindowCloseCallback;
  var __Z39RegisterStaticallyLinkedModulesGranularv=env.__Z39RegisterStaticallyLinkedModulesGranularv;
  var _TTF_Quit=env._TTF_Quit;
  var _il2cpp_class_is_inflated=env._il2cpp_class_is_inflated;
  var _SDL_FillRect=env._SDL_FillRect;
  var _confstr=env._confstr;
  var _emscripten_glDrawBuffersEXT=env._emscripten_glDrawBuffersEXT;
  var _JS_WebCamVideo_GetNativeWidth=env._JS_WebCamVideo_GetNativeWidth;
  var _dlclose=env._dlclose;
  var _emscripten_glGetProgramInfoLog=env._emscripten_glGetProgramInfoLog;
  var _getpwuid=env._getpwuid;
  var _il2cpp_array_new=env._il2cpp_array_new;
  var _glUniform1iv=env._glUniform1iv;
  var ___atomic_exchange_8=env.___atomic_exchange_8;
  var _il2cpp_set_find_plugin_callback=env._il2cpp_set_find_plugin_callback;
  var _pthread_mutex_init=env._pthread_mutex_init;
  var _JS_UNETWebSockets_IsHostCorrect=env._JS_UNETWebSockets_IsHostCorrect;
  var _glUseProgram=env._glUseProgram;
  var _emscripten_gluUnProject=env._emscripten_gluUnProject;
  var _glUniformMatrix3fv=env._glUniformMatrix3fv;
  var ___muldc3=env.___muldc3;
  var _pthread_condattr_setpshared=env._pthread_condattr_setpshared;
  var _XCreateWindow=env._XCreateWindow;
  var _glBindBuffer=env._glBindBuffer;
  var _emscripten_atomic_cas_u64=env._emscripten_atomic_cas_u64;
  var _llvm_exp_f32=env._llvm_exp_f32;
  var _siginterrupt=env._siginterrupt;
  var _emscripten_webgl_get_current_context=env._emscripten_webgl_get_current_context;
  var _emscripten_glGetVertexAttribIiv=env._emscripten_glGetVertexAttribIiv;
  var _emscripten_glGetBooleanv=env._emscripten_glGetBooleanv;
  var _SDL_HasMMX=env._SDL_HasMMX;
  var _SDL_GL_SwapWindow=env._SDL_GL_SwapWindow;
  var _glDrawElementsInstanced=env._glDrawElementsInstanced;
  var _emscripten_glGetShaderPrecisionFormat=env._emscripten_glGetShaderPrecisionFormat;
  var _il2cpp_gc_collect=env._il2cpp_gc_collect;
  var _alGetListeneri=env._alGetListeneri;
  var _JS_SystemInfo_GetLanguage=env._JS_SystemInfo_GetLanguage;
  var _alcSuspendContext=env._alcSuspendContext;
  var _JS_UNETWebSockets_SocketRecvEvntBuff=env._JS_UNETWebSockets_SocketRecvEvntBuff;
  var _alGetListenerf=env._alGetListenerf;
  var _glWaitSync=env._glWaitSync;
  var ___syscall306=env.___syscall306;
  var ___syscall307=env.___syscall307;
  var _Mix_HaltMusic=env._Mix_HaltMusic;
  var ___syscall305=env.___syscall305;
  var ___syscall302=env.___syscall302;
  var ___syscall303=env.___syscall303;
  var ___syscall300=env.___syscall300;
  var ___syscall301=env.___syscall301;
  var ___syscall308=env.___syscall308;
  var _emscripten_SDL_SetEventHandler=env._emscripten_SDL_SetEventHandler;
  var _emscripten_set_click_callback=env._emscripten_set_click_callback;
  var ___syscall125=env.___syscall125;
  var ___syscall122=env.___syscall122;
  var _SDL_CreateRGBSurfaceFrom=env._SDL_CreateRGBSurfaceFrom;
  var ___syscall121=env.___syscall121;
  var _emscripten_glBlitFramebuffer=env._emscripten_glBlitFramebuffer;
  var ___cxa_find_matching_catch=env.___cxa_find_matching_catch;
  var _SDL_LockAudio=env._SDL_LockAudio;
  var _emscripten_random=env._emscripten_random;
  var _emscripten_glVertexAttribDivisorEXT=env._emscripten_glVertexAttribDivisorEXT;
  var _emscripten_glRenderbufferStorageMultisample=env._emscripten_glRenderbufferStorageMultisample;
  var _emscripten_glUniform4iv=env._emscripten_glUniform4iv;
  var ___resumeException=env.___resumeException;
  var _gethostbyaddr=env._gethostbyaddr;
  var _SDL_SetGamma=env._SDL_SetGamma;
  var _kill=env._kill;
  var _SDL_SetColors=env._SDL_SetColors;
  var _logl=env._logl;
  var _SDL_JoystickGetButton=env._SDL_JoystickGetButton;
  var _SDL_GL_SetSwapInterval=env._SDL_GL_SetSwapInterval;
  var _JS_Sound_Stop=env._JS_Sound_Stop;
  var _il2cpp_class_instance_size=env._il2cpp_class_instance_size;
  var _emscripten_get_device_pixel_ratio=env._emscripten_get_device_pixel_ratio;
  var _emscripten_set_mouseup_callback=env._emscripten_set_mouseup_callback;
  var _emscripten_glFinish=env._emscripten_glFinish;
  var _il2cpp_class_is_interface=env._il2cpp_class_is_interface;
  var _glBindFramebuffer=env._glBindFramebuffer;
  var _glGenFramebuffers=env._glGenFramebuffers;
  var _emscripten_set_resize_callback=env._emscripten_set_resize_callback;
  var _alDopplerFactor=env._alDopplerFactor;
  var _glUniform1fv=env._glUniform1fv;
  var _JS_FileSystem_Sync=env._JS_FileSystem_Sync;
  var _IMG_Load=env._IMG_Load;
  var _emscripten_worker_respond_provisionally=env._emscripten_worker_respond_provisionally;
  var _uuid_unparse=env._uuid_unparse;
  var __emscripten_sample_gamepad_data=env.__emscripten_sample_gamepad_data;
  var _emscripten_glVertexAttribI4ui=env._emscripten_glVertexAttribI4ui;
  var _Mix_PlayingMusic=env._Mix_PlayingMusic;
  var _alcDestroyContext=env._alcDestroyContext;
  var _pow=env._pow;
  var _glfwSetWindowPos=env._glfwSetWindowPos;
  var _SDL_JoystickName=env._SDL_JoystickName;
  var ___syscall34=env.___syscall34;
  var ___syscall36=env.___syscall36;
  var ___syscall33=env.___syscall33;
  var _glGetActiveUniform=env._glGetActiveUniform;
  var _sched_get_priority_min=env._sched_get_priority_min;
  var ___syscall39=env.___syscall39;
  var ___syscall38=env.___syscall38;
  var _alcGetString=env._alcGetString;
  var _pthread_rwlock_init=env._pthread_rwlock_init;
  var _emscripten_glGetObjectParameterivARB=env._emscripten_glGetObjectParameterivARB;
  var _emscripten_glWaitSync=env._emscripten_glWaitSync;
  var ___cxa_throw=env.___cxa_throw;
  var _SDL_Flip=env._SDL_Flip;
  var _pthread_rwlockattr_getpshared=env._pthread_rwlockattr_getpshared;
  var _il2cpp_class_get_parent=env._il2cpp_class_get_parent;
  var _eglDestroySurface=env._eglDestroySurface;
  var _SDL_Has3DNowExt=env._SDL_Has3DNowExt;
  var _difftime=env._difftime;
  var _emscripten_set_mousemove_callback=env._emscripten_set_mousemove_callback;
  var _emscripten_glTexImage3D=env._emscripten_glTexImage3D;
  var _glfwWaitEvents=env._glfwWaitEvents;
  var _posix_spawn_file_actions_destroy=env._posix_spawn_file_actions_destroy;
  var _emscripten_idb_delete=env._emscripten_idb_delete;
  var _glGetShaderiv=env._glGetShaderiv;
  var _il2cpp_type_get_class_or_element_class=env._il2cpp_type_get_class_or_element_class;
  var _glUniform4fv=env._glUniform4fv;
  var _emscripten_glTexStorage2D=env._emscripten_glTexStorage2D;
  var _getprotoent=env._getprotoent;
  var _emscripten_webgl_destroy_context=env._emscripten_webgl_destroy_context;
  var ___atomic_is_lock_free=env.___atomic_is_lock_free;
  var _emscripten_enter_soft_fullscreen=env._emscripten_enter_soft_fullscreen;
  var _emscripten_glBindTexture=env._emscripten_glBindTexture;
  var _emscripten_idb_store=env._emscripten_idb_store;
  var __emscripten_atomic_fetch_and_or_u64=env.__emscripten_atomic_fetch_and_or_u64;
  var _glUniformBlockBinding=env._glUniformBlockBinding;
  var _emscripten_set_orientationchange_callback=env._emscripten_set_orientationchange_callback;
  var _pthread_rwlockattr_init=env._pthread_rwlockattr_init;
  var _pthread_rwlock_tryrdlock=env._pthread_rwlock_tryrdlock;
  var ___wait=env.___wait;
  var _ellipseColor=env._ellipseColor;
  var _JS_WebRequest_GetResponseHeaders=env._JS_WebRequest_GetResponseHeaders;
  var _glInvalidateSubFramebuffer=env._glInvalidateSubFramebuffer;
  var _uuid_is_null=env._uuid_is_null;
  var _clock_settime=env._clock_settime;
  var _SDL_RWFromMem=env._SDL_RWFromMem;
  var _SDL_RemoveTimer=env._SDL_RemoveTimer;
  var _il2cpp_field_get_type=env._il2cpp_field_get_type;
  var _SDL_RWFromFile=env._SDL_RWFromFile;
  var _glDepthRange=env._glDepthRange;
  var _glCreateProgram=env._glCreateProgram;
  var _emscripten_autodebug_float=env._emscripten_autodebug_float;
  var _emscripten_set_beforeunload_callback=env._emscripten_set_beforeunload_callback;
  var _gnu_dev_makedev=env._gnu_dev_makedev;
  var _Mix_PlayChannel=env._Mix_PlayChannel;
  var _clearenv=env._clearenv;
  var _stime=env._stime;
  var _sysconf=env._sysconf;
  var _glEndQuery=env._glEndQuery;
  var _pthread_spin_destroy=env._pthread_spin_destroy;
  var _alSourceStop=env._alSourceStop;
  var _SDL_StartTextInput=env._SDL_StartTextInput;
  var _glfwInit=env._glfwInit;
  var _emscripten_run_preload_plugins_data=env._emscripten_run_preload_plugins_data;
  var _glGenBuffers=env._glGenBuffers;
  var _emscripten_sleep=env._emscripten_sleep;
  var _emscripten_glScissor=env._emscripten_glScissor;
  var _pthread_cancel=env._pthread_cancel;
  var _llvm_fabs_f64=env._llvm_fabs_f64;
  var _emscripten_glIsVertexArray=env._emscripten_glIsVertexArray;
  var _emscripten_glCheckFramebufferStatus=env._emscripten_glCheckFramebufferStatus;
  var _emscripten_glUniformMatrix3x4fv=env._emscripten_glUniformMatrix3x4fv;
  var _llvm_trap=env._llvm_trap;
  var _SDL_JoystickGetBall=env._SDL_JoystickGetBall;
  var _emscripten_set_keyup_callback=env._emscripten_set_keyup_callback;
  var _emscripten_glTransformFeedbackVaryings=env._emscripten_glTransformFeedbackVaryings;
  var _JS_WebRequest_Release=env._JS_WebRequest_Release;
  var _emscripten_glFenceSync=env._emscripten_glFenceSync;
  var _emscripten_glResumeTransformFeedback=env._emscripten_glResumeTransformFeedback;
  var _JS_Log_Dump=env._JS_Log_Dump;
  var _emscripten_glGenTextures=env._emscripten_glGenTextures;
  var _llvm_stackrestore=env._llvm_stackrestore;
  var _glfwGetVersion=env._glfwGetVersion;
  var _JS_WebRequest_Create=env._JS_WebRequest_Create;
  var _glTexParameterfv=env._glTexParameterfv;
  var _emscripten_glUniform3f=env._emscripten_glUniform3f;
  var _emscripten_glVertexAttribI4i=env._emscripten_glVertexAttribI4i;
  var _SDL_LockMutex=env._SDL_LockMutex;
  var ___syscall333=env.___syscall333;
  var ___syscall331=env.___syscall331;
  var ___syscall330=env.___syscall330;
  var ___syscall334=env.___syscall334;
  var _terminate=env._terminate;
  var ___syscall118=env.___syscall118;
  var _gmtime=env._gmtime;
  var _emscripten_glUniform3i=env._emscripten_glUniform3i;
  var _glGetFramebufferAttachmentParameteriv=env._glGetFramebufferAttachmentParameteriv;
  var ___syscall114=env.___syscall114;
  var _emscripten_glGetUniformLocation=env._emscripten_glGetUniformLocation;
  var _emscripten_glGetFragDataLocation=env._emscripten_glGetFragDataLocation;
  var _emscripten_glEnableVertexAttribArray=env._emscripten_glEnableVertexAttribArray;
  var _sigdelset=env._sigdelset;
  var __registerRestoreOldStyle=env.__registerRestoreOldStyle;
  var _glDrawArraysInstancedARB=env._glDrawArraysInstancedARB;
  var _alSource3f=env._alSource3f;
  var _alSource3i=env._alSource3i;
  var _glDetachShader=env._glDetachShader;
  var ___syscall209=env.___syscall209;
  var ___syscall208=env.___syscall208;
  var ___syscall207=env.___syscall207;
  var ___syscall205=env.___syscall205;
  var ___syscall204=env.___syscall204;
  var ___syscall203=env.___syscall203;
  var ___syscall202=env.___syscall202;
  var ___syscall201=env.___syscall201;
  var ___syscall200=env.___syscall200;
  var _emscripten_glClearBufferfv=env._emscripten_glClearBufferfv;
  var _pthread_join=env._pthread_join;
  var _glutGetModifiers=env._glutGetModifiers;
  var _setitimer=env._setitimer;
  var _il2cpp_class_get_methods=env._il2cpp_class_get_methods;
  var _il2cpp_type_get_type=env._il2cpp_type_get_type;
  var _strptime_l=env._strptime_l;
  var _eglChooseConfig=env._eglChooseConfig;
  var _JS_Sound_Init=env._JS_Sound_Init;
  var _SDL_SetColorKey=env._SDL_SetColorKey;
  var _il2cpp_class_is_enum=env._il2cpp_class_is_enum;
  var _il2cpp_class_get_type=env._il2cpp_class_get_type;
  var _emscripten_get_compiler_setting=env._emscripten_get_compiler_setting;
  var _emscripten_glBindTransformFeedback=env._emscripten_glBindTransformFeedback;
  var _emscripten_vr_select_hmd_device=env._emscripten_vr_select_hmd_device;
  var _glfwSetCharCallback=env._glfwSetCharCallback;
  var _glfwFreeImage=env._glfwFreeImage;
  var _emscripten_glVertexAttrib4f=env._emscripten_glVertexAttrib4f;
  var _TTF_RenderText_Solid=env._TTF_RenderText_Solid;
  var _emscripten_glPixelStorei=env._emscripten_glPixelStorei;
  var _SDL_SetGammaRamp=env._SDL_SetGammaRamp;
  var _SDL_JoystickEventState=env._SDL_JoystickEventState;
  var _llvm_va_end=env._llvm_va_end;
  var _il2cpp_gc_get_used_size=env._il2cpp_gc_get_used_size;
  var _il2cpp_thread_attach=env._il2cpp_thread_attach;
  var _emscripten_glProgramBinary=env._emscripten_glProgramBinary;
  var _glfwCreateCond=env._glfwCreateCond;
  var _JS_Eval_ClearTimeout=env._JS_Eval_ClearTimeout;
  var _glGenVertexArraysOES=env._glGenVertexArraysOES;
  var _waitpid=env._waitpid;
  var _emscripten_glGetPointerv=env._emscripten_glGetPointerv;
  var _acosf=env._acosf;
  var _emscripten_glIsRenderbuffer=env._emscripten_glIsRenderbuffer;
  var _cosl=env._cosl;
  var ___syscall40=env.___syscall40;
  var ___syscall41=env.___syscall41;
  var _alListener3f=env._alListener3f;
  var _emscripten_autodebug_i8=env._emscripten_autodebug_i8;
  var _pthread_mutexattr_destroy=env._pthread_mutexattr_destroy;
  var _glDrawBuffersEXT=env._glDrawBuffersEXT;
  var _glClear=env._glClear;
  var _SDL_WM_SetCaption=env._SDL_WM_SetCaption;
  var _emscripten_glSamplerParameteriv=env._emscripten_glSamplerParameteriv;
  var _getdate=env._getdate;
  var _emscripten_glDrawRangeElements=env._emscripten_glDrawRangeElements;
  var ___unlock=env.___unlock;
  var _eglGetConfigs=env._eglGetConfigs;
  var _pthread_setspecific=env._pthread_setspecific;
  var _llvm_atomic_load_add_i32_p0i32=env._llvm_atomic_load_add_i32_p0i32;
  var _rectangleColor=env._rectangleColor;
  var _emscripten_set_pointerlockchange_callback=env._emscripten_set_pointerlockchange_callback;
  var _SDL_VideoModeOK=env._SDL_VideoModeOK;
  var _killpg=env._killpg;
  var _emscripten_glEnableClientState=env._emscripten_glEnableClientState;
  var _emscripten_glVertexAttribDivisorANGLE=env._emscripten_glVertexAttribDivisorANGLE;
  var _glGenQueries=env._glGenQueries;
  var _emscripten_set_fullscreenchange_callback=env._emscripten_set_fullscreenchange_callback;
  var __Z15ComputeSHA1HashPKhjPh=env.__Z15ComputeSHA1HashPKhjPh;
  var _glIsVertexArray=env._glIsVertexArray;
  var _emscripten_set_webglcontextlost_callback=env._emscripten_set_webglcontextlost_callback;
  var _emscripten_glDrawArrays=env._emscripten_glDrawArrays;
  var _emscripten_glBlendColor=env._emscripten_glBlendColor;
  var _Mix_HookMusicFinished=env._Mix_HookMusicFinished;
  var _clock_getres=env._clock_getres;
  var _signal=env._signal;
  var _ceilf=env._ceilf;
  var _il2cpp_add_internal_call=env._il2cpp_add_internal_call;
  var _glutPassiveMotionFunc=env._glutPassiveMotionFunc;
  var _uuid_generate=env._uuid_generate;
  var _ceill=env._ceill;
  var _il2cpp_method_get_return_type=env._il2cpp_method_get_return_type;
  var _emscripten_glGetSamplerParameteriv=env._emscripten_glGetSamplerParameteriv;
  var _Mix_QuickLoad_RAW=env._Mix_QuickLoad_RAW;
  var __emscripten_traverse_stack=env.__emscripten_traverse_stack;
  var _Mix_LoadMUS_RW=env._Mix_LoadMUS_RW;
  var _glfwSetMousePos=env._glfwSetMousePos;
  var _emscripten_glTexImage2D=env._emscripten_glTexImage2D;
  var _il2cpp_gc_collect_a_little=env._il2cpp_gc_collect_a_little;
  var __isLeapYear=env.__isLeapYear;
  var _emscripten_glBindProgramARB=env._emscripten_glBindProgramARB;
  var _pthread_detach=env._pthread_detach;
  var _pthread_spin_init=env._pthread_spin_init;
  var ___cxa_current_primary_exception=env.___cxa_current_primary_exception;
  var _emscripten_glUniform2i=env._emscripten_glUniform2i;
  var _emscripten_glUniform2f=env._emscripten_glUniform2f;
  var _alSourcefv=env._alSourcefv;
  var __emscripten_atomic_fetch_and_xor_u64=env.__emscripten_atomic_fetch_and_xor_u64;
  var _SDL_Delay=env._SDL_Delay;
  var _JS_SystemInfo_GetWidth=env._JS_SystemInfo_GetWidth;
  var _atan2=env._atan2;
  var __restoreHiddenElements=env.__restoreHiddenElements;
  var _emscripten_glTexParameterf=env._emscripten_glTexParameterf;
  var _emscripten_glTexParameteri=env._emscripten_glTexParameteri;
  var _JS_Sound_Load=env._JS_Sound_Load;
  var _glutInitDisplayMode=env._glutInitDisplayMode;
  var _emscripten_glStencilOpSeparate=env._emscripten_glStencilOpSeparate;
  var _emscripten_glBindAttribLocation=env._emscripten_glBindAttribLocation;
  var _llvm_pow_f32=env._llvm_pow_f32;
  var _alEnable=env._alEnable;
  var _emscripten_glClearBufferfi=env._emscripten_glClearBufferfi;
  var _il2cpp_class_get_declaring_type=env._il2cpp_class_get_declaring_type;
  var _SDL_GetAppState=env._SDL_GetAppState;
  var _il2cpp_array_length=env._il2cpp_array_length;
  var _pthread_condattr_setclock=env._pthread_condattr_setclock;
  var _il2cpp_unity_liveness_calculation_from_statics=env._il2cpp_unity_liveness_calculation_from_statics;
  var _atanf=env._atanf;
  var _glfwDestroyThread=env._glfwDestroyThread;
  var _atanl=env._atanl;
  var _glfwSetTime=env._glfwSetTime;
  var _emscripten_glMatrixMode=env._emscripten_glMatrixMode;
  var _SDL_GetClipRect=env._SDL_GetClipRect;
  var _emscripten_glHint=env._emscripten_glHint;
  var ___syscall9=env.___syscall9;
  var ___syscall324=env.___syscall324;
  var ___syscall1=env.___syscall1;
  var ___syscall320=env.___syscall320;
  var ___syscall6=env.___syscall6;
  var ___syscall5=env.___syscall5;
  var ___syscall4=env.___syscall4;
  var _emscripten_glGetIntegeri_v=env._emscripten_glGetIntegeri_v;
  var _il2cpp_assembly_get_image=env._il2cpp_assembly_get_image;
  var _lineRGBA=env._lineRGBA;
  var ___syscall104=env.___syscall104;
  var _glfwLoadTextureImage2D=env._glfwLoadTextureImage2D;
  var ___syscall102=env.___syscall102;
  var ___pthread_self=env.___pthread_self;
  var _emscripten_webgl_commit_frame=env._emscripten_webgl_commit_frame;
  var _JS_SystemInfo_GetBrowserVersionString=env._JS_SystemInfo_GetBrowserVersionString;
  var _glGetTexParameterfv=env._glGetTexParameterfv;
  var _emscripten_glGetQueryiv=env._emscripten_glGetQueryiv;
  var _glIsRenderbuffer=env._glIsRenderbuffer;
  var _emscripten_glDrawElementsInstancedARB=env._emscripten_glDrawElementsInstancedARB;
  var _emscripten_glShaderBinary=env._emscripten_glShaderBinary;
  var _glGetBufferParameteriv=env._glGetBufferParameteriv;
  var _eglQueryAPI=env._eglQueryAPI;
  var _emscripten_glSamplerParameteri=env._emscripten_glSamplerParameteri;
  var _emscripten_glSamplerParameterf=env._emscripten_glSamplerParameterf;
  var _alSourceRewind=env._alSourceRewind;
  var ___syscall218=env.___syscall218;
  var ___syscall219=env.___syscall219;
  var ___syscall210=env.___syscall210;
  var ___syscall211=env.___syscall211;
  var ___syscall212=env.___syscall212;
  var _emscripten_glDeleteProgram=env._emscripten_glDeleteProgram;
  var ___syscall214=env.___syscall214;
  var _SDL_GL_SetAttribute=env._SDL_GL_SetAttribute;
  var _il2cpp_set_data_dir=env._il2cpp_set_data_dir;
  var _glFenceSync=env._glFenceSync;
  var _emscripten_glViewport=env._emscripten_glViewport;
  var _JS_WebCamVideo_GrabFrame=env._JS_WebCamVideo_GrabFrame;
  var _SDL_HasSSE=env._SDL_HasSSE;
  var _glfwGetThreadID=env._glfwGetThreadID;
  var _SDL_DestroyWindow=env._SDL_DestroyWindow;
  var _eglQuerySurface=env._eglQuerySurface;
  var _SDL_JoystickNumAxes=env._SDL_JoystickNumAxes;
  var ___syscall213=env.___syscall213;
  var _abort=env._abort;
  var _JS_UNETWebSockets_SocketCleanEvntFromHost=env._JS_UNETWebSockets_SocketCleanEvntFromHost;
  var _glTexImage2D=env._glTexImage2D;
  var _SDL_JoystickGetAxis=env._SDL_JoystickGetAxis;
  var _emscripten_glGenFramebuffers=env._emscripten_glGenFramebuffers;
  var _emscripten_glLoadIdentity=env._emscripten_glLoadIdentity;
  var _alcGetProcAddress=env._alcGetProcAddress;
  var _glfwGetWindowSize=env._glfwGetWindowSize;
  var _vfork=env._vfork;
  var _emscripten_vr_count_devices=env._emscripten_vr_count_devices;
  var _emscripten_glIsTransformFeedback=env._emscripten_glIsTransformFeedback;
  var _glfwReadImage=env._glfwReadImage;
  var _glfwOpenWindowHint=env._glfwOpenWindowHint;
  var _glewIsSupported=env._glewIsSupported;
  var _emscripten_glSampleCoverage=env._emscripten_glSampleCoverage;
  var _SDL_HasSSE2=env._SDL_HasSSE2;
  var _glPixelStorei=env._glPixelStorei;
  var _SDL_PushEvent=env._SDL_PushEvent;
  var _pthread_attr_setstacksize=env._pthread_attr_setstacksize;
  var _glStencilMask=env._glStencilMask;
  var ___syscall51=env.___syscall51;
  var ___syscall57=env.___syscall57;
  var ___syscall54=env.___syscall54;
  var _SDL_mutexP=env._SDL_mutexP;
  var _emscripten_glUniform2iv=env._emscripten_glUniform2iv;
  var _SDL_mutexV=env._SDL_mutexV;
  var _SDL_GL_SwapBuffers=env._SDL_GL_SwapBuffers;
  var __hideEverythingExceptGivenElement=env.__hideEverythingExceptGivenElement;
  var _emscripten_glUniform4ui=env._emscripten_glUniform4ui;
  var _il2cpp_array_new_full=env._il2cpp_array_new_full;
  var _SDL_DisplayFormatAlpha=env._SDL_DisplayFormatAlpha;
  var _glDeleteVertexArraysOES=env._glDeleteVertexArraysOES;
  var _il2cpp_method_get_param_count=env._il2cpp_method_get_param_count;
  var _SDL_JoystickGetHat=env._SDL_JoystickGetHat;
  var _emscripten_glGetTexParameterfv=env._emscripten_glGetTexParameterfv;
  var _fabs=env._fabs;
  var _XPending=env._XPending;
  var _emscripten_wget_data=env._emscripten_wget_data;
  var _emscripten_glDeleteTransformFeedbacks=env._emscripten_glDeleteTransformFeedbacks;
  var _glfwEnable=env._glfwEnable;
  var _glutReshapeWindow=env._glutReshapeWindow;
  var _emscripten_debugger=env._emscripten_debugger;
  var _emscripten_memcpy_big=env._emscripten_memcpy_big;
  var _glRenderbufferStorageMultisample=env._glRenderbufferStorageMultisample;
  var _Mix_PlayMusic=env._Mix_PlayMusic;
  var _emscripten_glUniform3uiv=env._emscripten_glUniform3uiv;
  var _SDL_GetWindowSize=env._SDL_GetWindowSize;
  var _emscripten_glGetIntegerv=env._emscripten_glGetIntegerv;
  var _llvm_copysign_f64=env._llvm_copysign_f64;
  var _SDL_GL_DeleteContext=env._SDL_GL_DeleteContext;
  var _emscripten_glTexParameteriv=env._emscripten_glTexParameteriv;
  var _emscripten_set_webglcontextrestored_callback=env._emscripten_set_webglcontextrestored_callback;
  var _alSourcePause=env._alSourcePause;
  var _alGetString=env._alGetString;
  var _glfwGetWindowPos=env._glfwGetWindowPos;
  var _gluProject=env._gluProject;
  var _emscripten_glVertexAttribDivisorNV=env._emscripten_glVertexAttribDivisorNV;
  var _emscripten_get_now_is_monotonic=env._emscripten_get_now_is_monotonic;
  var _SDL_CreateCond=env._SDL_CreateCond;
  var _llvm_floor_f32=env._llvm_floor_f32;
  var _emscripten_yield=env._emscripten_yield;
  var _il2cpp_field_has_attribute=env._il2cpp_field_has_attribute;
  var _fexecve=env._fexecve;
  var _SDL_VideoDriverName=env._SDL_VideoDriverName;
  var _emscripten_idb_async_load=env._emscripten_idb_async_load;
  var _alcMakeContextCurrent=env._alcMakeContextCurrent;
  var _glClearBufferfi=env._glClearBufferfi;
  var _emscripten_glCopyBufferSubData=env._emscripten_glCopyBufferSubData;
  var _emscripten_glVertexAttrib2fv=env._emscripten_glVertexAttrib2fv;
  var _glViewport=env._glViewport;
  var _glClearBufferfv=env._glClearBufferfv;
  var _eglGetCurrentDisplay=env._eglGetCurrentDisplay;
  var _glVertexAttribI4i=env._glVertexAttribI4i;
  var _il2cpp_image_get_name=env._il2cpp_image_get_name;
  var _SDL_WarpMouse=env._SDL_WarpMouse;
  var __emscripten_atomic_fetch_and_add_u64=env.__emscripten_atomic_fetch_and_add_u64;
  var _SDL_GL_ExtensionSupported=env._SDL_GL_ExtensionSupported;
  var __emscripten_push_main_loop_blocker=env.__emscripten_push_main_loop_blocker;
  var _emscripten_glBegin=env._emscripten_glBegin;
  var ___syscall=env.___syscall;
  var ___libc_current_sigrtmax=env.___libc_current_sigrtmax;
  var _lineColor=env._lineColor;
  var _dlerror=env._dlerror;
  var _utimes=env._utimes;
  var _eglQueryContext=env._eglQueryContext;
  var _glfwSignalCond=env._glfwSignalCond;
  var _Mix_PausedMusic=env._Mix_PausedMusic;
  var _inet_addr=env._inet_addr;
  var _pthread_rwlock_unlock=env._pthread_rwlock_unlock;
  var _alcProcessContext=env._alcProcessContext;
  var _cosf=env._cosf;
  var emscriptenWebGLGetUniform=env.emscriptenWebGLGetUniform;
  var _glClearColor=env._glClearColor;
  var _Mix_Pause=env._Mix_Pause;
  var _emscripten_set_gamepadconnected_callback=env._emscripten_set_gamepadconnected_callback;
  var _glGetTexParameteriv=env._glGetTexParameteriv;
  var _emscripten_wget=env._emscripten_wget;
  var _glUniform2ui=env._glUniform2ui;
  var _glGetError=env._glGetError;
  var _acosl=env._acosl;
  var _glDrawArraysInstancedEXT=env._glDrawArraysInstancedEXT;
  var _floorf=env._floorf;
  var _emscripten_get_callstack=env._emscripten_get_callstack;
  var _JS_SystemInfo_GetBrowserVersion=env._JS_SystemInfo_GetBrowserVersion;
  var _floorl=env._floorl;
  var _glUniformMatrix4x2fv=env._glUniformMatrix4x2fv;
  var _emscripten_is_webgl_context_lost=env._emscripten_is_webgl_context_lost;
  var _emscripten_glClearDepth=env._emscripten_glClearDepth;
  var _emscripten_glGetActiveUniformBlockName=env._emscripten_glGetActiveUniformBlockName;
  var ___syscall42=env.___syscall42;
  var _glVertexAttribIPointer=env._glVertexAttribIPointer;
  var _glDeleteBuffers=env._glDeleteBuffers;
  var _localtime=env._localtime;
  var _JS_UNETWebSockets_SocketRecvEvntTypeFromHost=env._JS_UNETWebSockets_SocketRecvEvntTypeFromHost;
  var _SDL_JoystickIndex=env._SDL_JoystickIndex;
  var _SDL_VideoQuit=env._SDL_VideoQuit;
  var _glGetInteger64v=env._glGetInteger64v;
  var _eglQueryString=env._eglQueryString;
  var ___atomic_fetch_add_8=env.___atomic_fetch_add_8;
  var _emscripten_set_keydown_callback=env._emscripten_set_keydown_callback;
  var __read_sockaddr=env.__read_sockaddr;
  var _JS_SystemInfo_GetHeight=env._JS_SystemInfo_GetHeight;
  var _glGetVertexAttribPointerv=env._glGetVertexAttribPointerv;
  var _emscripten_glBufferSubData=env._emscripten_glBufferSubData;
  var _emscripten_gluProject=env._emscripten_gluProject;
  var _SDL_HasRDTSC=env._SDL_HasRDTSC;
  var _llvm_trunc_f32=env._llvm_trunc_f32;
  var _emscripten_glBlendEquation=env._emscripten_glBlendEquation;
  var _glTexImage3D=env._glTexImage3D;
  var emscriptenWebGLGetIndexed=env.emscriptenWebGLGetIndexed;
  var _TTF_SizeText=env._TTF_SizeText;
  var _emscripten_glUniform1i=env._emscripten_glUniform1i;
  var _emscripten_glUniform4fv=env._emscripten_glUniform4fv;
  var _uuid_type=env._uuid_type;
  var _il2cpp_object_get_class=env._il2cpp_object_get_class;
  var _Mix_Quit=env._Mix_Quit;
  var _pthread_condattr_getpshared=env._pthread_condattr_getpshared;
  var _SDL_GetKeyState=env._SDL_GetKeyState;
  var _getpwent=env._getpwent;
  var _emscripten_glUniform2fv=env._emscripten_glUniform2fv;
  var _glDrawElementsInstancedARB=env._glDrawElementsInstancedARB;
  var _glTexSubImage2D=env._glTexSubImage2D;
  var __ZN4FMOD3DSP11getCPUUsageEPt=env.__ZN4FMOD3DSP11getCPUUsageEPt;
  var __softFullscreenResizeWebGLRenderTarget=env.__softFullscreenResizeWebGLRenderTarget;
  var ___syscall66=env.___syscall66;
  var ___syscall64=env.___syscall64;
  var ___syscall65=env.___syscall65;
  var ___syscall63=env.___syscall63;
  var ___syscall60=env.___syscall60;
  var _emscripten_glGetProgramBinary=env._emscripten_glGetProgramBinary;
  var _Mix_FadeOutChannel=env._Mix_FadeOutChannel;
  var _emscripten_glStencilMaskSeparate=env._emscripten_glStencilMaskSeparate;
  var _glfwDisable=env._glfwDisable;
  var _setgrent=env._setgrent;
  var _emscripten_glDrawArraysInstancedEXT=env._emscripten_glDrawArraysInstancedEXT;
  var _glfwBroadcastCond=env._glfwBroadcastCond;
  var _glPolygonOffset=env._glPolygonOffset;
  var _llvm_mono_store_i16_p0i16=env._llvm_mono_store_i16_p0i16;
  var _emscripten_set_touchstart_callback=env._emscripten_set_touchstart_callback;
  var _tanf=env._tanf;
  var _glGetShaderPrecisionFormat=env._glGetShaderPrecisionFormat;
  var _tanl=env._tanl;
  var _glLoadIdentity=env._glLoadIdentity;
  var _emscripten_glVertexAttribPointer=env._emscripten_glVertexAttribPointer;
  var __write_sockaddr=env.__write_sockaddr;
  var _glutSpecialFunc=env._glutSpecialFunc;
  var _chroot=env._chroot;
  var _llvm_sqrt_f32=env._llvm_sqrt_f32;
  var _emscripten_glIsEnabled=env._emscripten_glIsEnabled;
  var _glfwLoadTexture2D=env._glfwLoadTexture2D;
  var _pthread_cond_destroy=env._pthread_cond_destroy;
  var _llvm_lifetime_end=env._llvm_lifetime_end;
  var _JS_Sound_Set3D=env._JS_Sound_Set3D;
  var ___block_all_sigs=env.___block_all_sigs;
  var _SDL_QuitSubSystem=env._SDL_QuitSubSystem;
  var _pthread_condattr_getclock=env._pthread_condattr_getclock;
  var _glGetQueryObjectuiv=env._glGetQueryObjectuiv;
  var _JS_WebCamVideo_GetNumDevices=env._JS_WebCamVideo_GetNumDevices;
  var _emscripten_call_worker=env._emscripten_call_worker;
  var _Mix_CloseAudio=env._Mix_CloseAudio;
  var ___cxa_rethrow_primary_exception=env.___cxa_rethrow_primary_exception;
  var _SDL_CondWaitTimeout=env._SDL_CondWaitTimeout;
  var _JS_SystemInfo_HasCursorLock=env._JS_SystemInfo_HasCursorLock;
  var _emscripten_run_preload_plugins=env._emscripten_run_preload_plugins;
  var _glDrawElements=env._glDrawElements;
  var _emscripten_async_wget2=env._emscripten_async_wget2;
  var _eglSwapBuffers=env._eglSwapBuffers;
  var _SDL_OpenAudio=env._SDL_OpenAudio;
  var _glStencilOpSeparate=env._glStencilOpSeparate;
  var _JS_WebRequest_Abort=env._JS_WebRequest_Abort;
  var _emscripten_atomic_load_u64=env._emscripten_atomic_load_u64;
  var _il2cpp_class_is_abstract=env._il2cpp_class_is_abstract;
  var _mktime=env._mktime;
  var _emscripten_glGetError=env._emscripten_glGetError;
  var _emscripten_glBufferData=env._emscripten_glBufferData;
  var _emscripten_glStencilMask=env._emscripten_glStencilMask;
  var _emscripten_glReadPixels=env._emscripten_glReadPixels;
  var _glUniform3iv=env._glUniform3iv;
  var emscriptenWebGLGet=env.emscriptenWebGLGet;
  var ___syscall142=env.___syscall142;
  var _Mix_SetPostMix=env._Mix_SetPostMix;
  var _boxRGBA=env._boxRGBA;
  var _alGetEnumValue=env._alGetEnumValue;
  var _il2cpp_class_get_fields=env._il2cpp_class_get_fields;
  var _Mix_FreeMusic=env._Mix_FreeMusic;
  var ___syscall147=env.___syscall147;
  var _ftime=env._ftime;
  var _emscripten_glUniform4i=env._emscripten_glUniform4i;
  var _glCopyTexSubImage3D=env._glCopyTexSubImage3D;
  var _glDeleteFramebuffers=env._glDeleteFramebuffers;
  var _emscripten_glVertexAttribDivisorARB=env._emscripten_glVertexAttribDivisorARB;
  var _emscripten_glUniform4f=env._emscripten_glUniform4f;
  var _emscripten_glUniformMatrix4x2fv=env._emscripten_glUniformMatrix4x2fv;
  var _asin=env._asin;
  var _floor=env._floor;
  var _glGetProgramBinary=env._glGetProgramBinary;
  var _SDL_PumpEvents=env._SDL_PumpEvents;
  var _llvm_mono_load_i32_p0i32=env._llvm_mono_load_i32_p0i32;
  var ___cxa_increment_exception_refcount=env.___cxa_increment_exception_refcount;
  var _pthread_create=env._pthread_create;
  var _filledEllipseColor=env._filledEllipseColor;
  var _emscripten_glUniformMatrix3fv=env._emscripten_glUniformMatrix3fv;
  var _glutMouseFunc=env._glutMouseFunc;
  var __setLetterbox=env.__setLetterbox;
  var _JS_WebCamVideo_Stop=env._JS_WebCamVideo_Stop;
  var _emscripten_glUniformMatrix2fv=env._emscripten_glUniformMatrix2fv;
  var _tan=env._tan;
  var ___syscall340=env.___syscall340;
  var _JS_SystemInfo_HasWebGL=env._JS_SystemInfo_HasWebGL;
  var _emscripten_glGetUniformiv=env._emscripten_glGetUniformiv;
  var _glutMainLoop=env._glutMainLoop;
  var _glDrawElementsInstancedNV=env._glDrawElementsInstancedNV;
  var _glutIdleFunc=env._glutIdleFunc;
  var ___syscall168=env.___syscall168;
  var _glfwSetWindowSize=env._glfwSetWindowSize;
  var _glGetInternalFormativ=env._glGetInternalFormativ;
  var _SDL_CondBroadcast=env._SDL_CondBroadcast;
  var _glDepthRangef=env._glDepthRangef;
  var _emscripten_glDeleteTextures=env._emscripten_glDeleteTextures;
  var _asinl=env._asinl;
  var _glfwSetWindowRefreshCallback=env._glfwSetWindowRefreshCallback;
  var ___cxa_decrement_exception_refcount=env.___cxa_decrement_exception_refcount;
  var _glReleaseShaderCompiler=env._glReleaseShaderCompiler;
  var _emscripten_vr_get_selected_hmd_device=env._emscripten_vr_get_selected_hmd_device;
  var _asinf=env._asinf;
  var _SDL_PollEvent=env._SDL_PollEvent;
  var _emscripten_cancel_main_loop=env._emscripten_cancel_main_loop;
  var _JS_WebCam_IsSupported=env._JS_WebCam_IsSupported;
  var _glTexSubImage3D=env._glTexSubImage3D;
  var _emscripten_coroutine_create=env._emscripten_coroutine_create;
  var _emscripten_glEndTransformFeedback=env._emscripten_glEndTransformFeedback;
  var _SDL_AllocRW=env._SDL_AllocRW;
  var _TTF_RenderUTF8_Solid=env._TTF_RenderUTF8_Solid;
  var _SDL_JoystickUpdate=env._SDL_JoystickUpdate;
  var _glIsFramebuffer=env._glIsFramebuffer;
  var __pthread_cleanup_pop=env.__pthread_cleanup_pop;
  var _glUniformMatrix3x4fv=env._glUniformMatrix3x4fv;
  var _glDeleteSamplers=env._glDeleteSamplers;
  var _emscripten_glCompressedTexImage2D=env._emscripten_glCompressedTexImage2D;
  var _glIsSync=env._glIsSync;
  var _emscripten_glGetInfoLogARB=env._emscripten_glGetInfoLogARB;
  var _ctime_r=env._ctime_r;
  var _SDL_WM_ToggleFullScreen=env._SDL_WM_ToggleFullScreen;
  var _JS_Sound_ReleaseInstance=env._JS_Sound_ReleaseInstance;
  var _glfwSleep=env._glfwSleep;
  var _IMG_Quit=env._IMG_Quit;
  var _glStencilFunc=env._glStencilFunc;
  var _glUniform2fv=env._glUniform2fv;
  var _emscripten_glProgramParameteri=env._emscripten_glProgramParameteri;
  var _il2cpp_field_get_parent=env._il2cpp_field_get_parent;
  var _glDeleteProgram=env._glDeleteProgram;
  var _clock_gettime=env._clock_gettime;
  var _SDL_GetError=env._SDL_GetError;
  var _glUniformMatrix2x3fv=env._glUniformMatrix2x3fv;
  var _emscripten_autodebug_double=env._emscripten_autodebug_double;
  var _glCreateShader=env._glCreateShader;
  var _il2cpp_gc_enable=env._il2cpp_gc_enable;
  var _glIsShader=env._glIsShader;
  var _emscripten_glVertexAttribI4iv=env._emscripten_glVertexAttribI4iv;
  var _getnameinfo=env._getnameinfo;
  var ___syscall75=env.___syscall75;
  var ___syscall77=env.___syscall77;
  var _glTexStorage2D=env._glTexStorage2D;
  var ___cxa_atexit=env.___cxa_atexit;
  var _glGetQueryiv=env._glGetQueryiv;
  var _XChangeWindowAttributes=env._XChangeWindowAttributes;
  var _SDL_WasInit=env._SDL_WasInit;
  var _glSamplerParameterf=env._glSamplerParameterf;
  var _emscripten_glVertexAttrib1f=env._emscripten_glVertexAttrib1f;
  var ___syscall97=env.___syscall97;
  var _Mix_Linked_Version=env._Mix_Linked_Version;
  var _glVertexAttribPointer=env._glVertexAttribPointer;
  var _emscripten_glTexSubImage3D=env._emscripten_glTexSubImage3D;
  var _glSamplerParameteri=env._glSamplerParameteri;
  var _llvm_sin_f64=env._llvm_sin_f64;
  var _emscripten_async_wget=env._emscripten_async_wget;
  var _emscripten_glClientActiveTexture=env._emscripten_glClientActiveTexture;
  var _TTF_Init=env._TTF_Init;
  var _llvm_mono_store_i32_p0i32=env._llvm_mono_store_i32_p0i32;
  var _glEnable=env._glEnable;
  var ___cxa_get_exception_ptr=env.___cxa_get_exception_ptr;
  var _glfwIconifyWindow=env._glfwIconifyWindow;
  var _glGetString=env._glGetString;
  var _emscripten_get_preloaded_image_data=env._emscripten_get_preloaded_image_data;
  var _emscripten_glUniformMatrix3x2fv=env._emscripten_glUniformMatrix3x2fv;
  var _SDL_CreateRGBSurface=env._SDL_CreateRGBSurface;
  var _emscripten_set_main_loop_expected_blockers=env._emscripten_set_main_loop_expected_blockers;
  var _alDopplerVelocity=env._alDopplerVelocity;
  var emscriptenWebGLGetTexPixelData=env.emscriptenWebGLGetTexPixelData;
  var _emscripten_glBindBufferBase=env._emscripten_glBindBufferBase;
  var _gettimeofday=env._gettimeofday;
  var ___syscall163=env.___syscall163;
  var _llvm_powi_f32=env._llvm_powi_f32;
  var _emscripten_vr_get_device_id=env._emscripten_vr_get_device_id;
  var _il2cpp_runtime_object_init_exception=env._il2cpp_runtime_object_init_exception;
  var _arc4random=env._arc4random;
  var _llvm_invariant_start=env._llvm_invariant_start;
  var ___buildEnvironment=env.___buildEnvironment;
  var _JS_Sound_SetListenerOrientation=env._JS_Sound_SetListenerOrientation;
  var _glfwSetMousePosCallback=env._glfwSetMousePosCallback;
  var _JS_Log_StackTrace=env._JS_Log_StackTrace;
  var _glClearDepthf=env._glClearDepthf;
  var _pthread_setschedparam=env._pthread_setschedparam;
  var _SDL_FreeSurface=env._SDL_FreeSurface;
  var _il2cpp_type_get_object=env._il2cpp_type_get_object;
  var _il2cpp_runtime_invoke=env._il2cpp_runtime_invoke;
  var _JS_Sound_Create_Channel=env._JS_Sound_Create_Channel;
  var _SDL_StopTextInput=env._SDL_StopTextInput;
  var _glutFullScreen=env._glutFullScreen;
  var _asctime_r=env._asctime_r;
  var _glCopyBufferSubData=env._glCopyBufferSubData;
  var _getenv=env._getenv;
  var _SDL_CondWait=env._SDL_CondWait;
  var _emscripten_num_logical_cores=env._emscripten_num_logical_cores;
  var _emscripten_set_gamepaddisconnected_callback=env._emscripten_set_gamepaddisconnected_callback;
  var _glVertexAttribI4iv=env._glVertexAttribI4iv;
  var _glutKeyboardFunc=env._glutKeyboardFunc;
  var _glfwSwapInterval=env._glfwSwapInterval;
  var _emscripten_glFramebufferRenderbuffer=env._emscripten_glFramebufferRenderbuffer;
  var _emscripten_set_socket_listen_callback=env._emscripten_set_socket_listen_callback;
  var ___cxa_pure_virtual=env.___cxa_pure_virtual;
  var _pthread_cond_wait=env._pthread_cond_wait;
  var __inet_ntop4_raw=env.__inet_ntop4_raw;
  var _Mix_SetPosition=env._Mix_SetPosition;
  var _llvm_bswap_i64=env._llvm_bswap_i64;
  var __inet_pton6_raw=env.__inet_pton6_raw;
  var __emscripten_atomic_fetch_and_sub_u64=env.__emscripten_atomic_fetch_and_sub_u64;
  var _TTF_FontDescent=env._TTF_FontDescent;
  var _JS_SystemInfo_GetDocumentURL=env._JS_SystemInfo_GetDocumentURL;
  var _JS_WebRequest_SetResponseHandler=env._JS_WebRequest_SetResponseHandler;
  var _emscripten_glCompressedTexImage3D=env._emscripten_glCompressedTexImage3D;
  var _emscripten_glGetInternalFormativ=env._emscripten_glGetInternalFormativ;
  var _getpagesize=env._getpagesize;
  var _alDisable=env._alDisable;
  var _emscripten_glGetBufferParameteri64v=env._emscripten_glGetBufferParameteri64v;
  var _pthread_equal=env._pthread_equal;
  var _glUniform2i=env._glUniform2i;
  var _atan=env._atan;
  var _SDL_DestroyMutex=env._SDL_DestroyMutex;
  var _eglDestroyContext=env._eglDestroyContext;
  var _glProgramParameteri=env._glProgramParameteri;
  var _logf=env._logf;
  var _glColorMask=env._glColorMask;
  var _alIsSource=env._alIsSource;
  var _emscripten_glDrawArraysInstancedANGLE=env._emscripten_glDrawArraysInstancedANGLE;
  var _emscripten_glCreateProgram=env._emscripten_glCreateProgram;
  var _JS_WebRequest_SetProgressHandler=env._JS_WebRequest_SetProgressHandler;
  var _il2cpp_class_get_flags=env._il2cpp_class_get_flags;
  var _SDL_RWFromConstMem=env._SDL_RWFromConstMem;
  var _emscripten_do_request_fullscreen=env._emscripten_do_request_fullscreen;
  var _emscripten_set_mouseleave_callback=env._emscripten_set_mouseleave_callback;
  var _glTexStorage3D=env._glTexStorage3D;
  var _emscripten_set_socket_close_callback=env._emscripten_set_socket_close_callback;
  var _JS_SystemInfo_GetBrowserName=env._JS_SystemInfo_GetBrowserName;
  var _emscripten_glPolygonOffset=env._emscripten_glPolygonOffset;
  var _longjmp=env._longjmp;
  var _emscripten_get_now_res=env._emscripten_get_now_res;
  var _glGetShaderInfoLog=env._glGetShaderInfoLog;
  var _emscripten_set_main_loop_timing=env._emscripten_set_main_loop_timing;
  var _glDeleteSync=env._glDeleteSync;
  var _emscripten_glGetInteger64i_v=env._emscripten_glGetInteger64i_v;
  var _il2cpp_gc_get_heap_size=env._il2cpp_gc_get_heap_size;
  var _SDL_JoystickClose=env._SDL_JoystickClose;
  var ___syscall153=env.___syscall153;
  var ___syscall152=env.___syscall152;
  var ___syscall151=env.___syscall151;
  var ___syscall150=env.___syscall150;
  var _JS_UNETWebSockets_SocketRecvEvntBuffFromHost=env._JS_UNETWebSockets_SocketRecvEvntBuffFromHost;
  var _cos=env._cos;
  var _llvm_stacksave=env._llvm_stacksave;
  var _gluPerspective=env._gluPerspective;
  var _emscripten_glBlendEquationSeparate=env._emscripten_glBlendEquationSeparate;
  var _emscripten_glGetString=env._emscripten_glGetString;
  var _emscripten_glDeleteVertexArraysOES=env._emscripten_glDeleteVertexArraysOES;
  var _glUniform2uiv=env._glUniform2uiv;
  var _emscripten_vr_ready=env._emscripten_vr_ready;
  var _getaddrinfo=env._getaddrinfo;
  var _SDL_UpdateRect=env._SDL_UpdateRect;
  var _glutPostRedisplay=env._glutPostRedisplay;
  var _glVertexAttribI4ui=env._glVertexAttribI4ui;
  var ___syscall85=env.___syscall85;
  var ___syscall83=env.___syscall83;
  var _glGenTransformFeedbacks=env._glGenTransformFeedbacks;
  var _SDL_SetError=env._SDL_SetError;
  var _glUniform4ui=env._glUniform4ui;
  var _emscripten_idb_async_store=env._emscripten_idb_async_store;
  var _glDeleteVertexArrays=env._glDeleteVertexArrays;
  var _eglGetProcAddress=env._eglGetProcAddress;
  var _gnu_dev_major=env._gnu_dev_major;
  var _emscripten_glClearDepthf=env._emscripten_glClearDepthf;
  var _glutReshapeFunc=env._glutReshapeFunc;
  var _glGetUniformuiv=env._glGetUniformuiv;
  var _emscripten_glGetProgramiv=env._emscripten_glGetProgramiv;
  var _emscripten_glNormalPointer=env._emscripten_glNormalPointer;
  var ___lock=env.___lock;
  var _SDL_CondSignal=env._SDL_CondSignal;
  var _il2cpp_class_has_attribute=env._il2cpp_class_has_attribute;
  var _emscripten_glBindRenderbuffer=env._emscripten_glBindRenderbuffer;
  var _emscripten_unlock_orientation=env._emscripten_unlock_orientation;
  var _emscripten_glGetFramebufferAttachmentParameteriv=env._emscripten_glGetFramebufferAttachmentParameteriv;
  var _emscripten_set_dblclick_callback=env._emscripten_set_dblclick_callback;
  var _powl=env._powl;
  var _powf=env._powf;
  var _glGetIntegeri_v=env._glGetIntegeri_v;
  var _emscripten_glClear=env._emscripten_glClear;
  var _pthread_spin_lock=env._pthread_spin_lock;
  var _SDL_HasMMXExt=env._SDL_HasMMXExt;
  var _JS_FileSystem_SetSyncInterval=env._JS_FileSystem_SetSyncInterval;
  var _emscripten_get_mouse_status=env._emscripten_get_mouse_status;
  var _emscripten_set_deviceorientation_callback=env._emscripten_set_deviceorientation_callback;
  var _SDL_WM_GrabInput=env._SDL_WM_GrabInput;
  var _eglSwapInterval=env._eglSwapInterval;
  var _emscripten_glTexSubImage2D=env._emscripten_glTexSubImage2D;
  var _pthread_mutex_destroy=env._pthread_mutex_destroy;
  var _JS_UNETWebSockets_SocketCreate=env._JS_UNETWebSockets_SocketCreate;
  var _glCompileShader=env._glCompileShader;
  var _il2cpp_free=env._il2cpp_free;
  var _SDL_MapRGBA=env._SDL_MapRGBA;
  var ___atomic_fetch_xor_8=env.___atomic_fetch_xor_8;
  var _getitimer=env._getitimer;
  var _glFlush=env._glFlush;
  var _SDL_BlitScaled=env._SDL_BlitScaled;
  var _SDL_CloseAudio=env._SDL_CloseAudio;
  var _il2cpp_method_get_param=env._il2cpp_method_get_param;
  var _glBindBufferRange=env._glBindBufferRange;
  var _emscripten_get_fullscreen_status=env._emscripten_get_fullscreen_status;
  var _glfwSetMouseWheelCallback=env._glfwSetMouseWheelCallback;
  var _emscripten_glGetRenderbufferParameteriv=env._emscripten_glGetRenderbufferParameteriv;
  var _emscripten_log=env._emscripten_log;
  var _Mix_FreeChunk=env._Mix_FreeChunk;
  var _JS_Sound_SetPitch=env._JS_Sound_SetPitch;
  var _il2cpp_runtime_invoke_convert_args=env._il2cpp_runtime_invoke_convert_args;
  var _glCompressedTexSubImage3D=env._glCompressedTexSubImage3D;
  var _emscripten_glIsSampler=env._emscripten_glIsSampler;
  var _glIsTransformFeedback=env._glIsTransformFeedback;
  var _emscripten_glDeleteBuffers=env._emscripten_glDeleteBuffers;
  var _il2cpp_get_corlib=env._il2cpp_get_corlib;
  var _il2cpp_get_exception_argument_null=env._il2cpp_get_exception_argument_null;
  var _emscripten_vr_get_device_hwid=env._emscripten_vr_get_device_hwid;
  var __Z18RegisterAllClassesv=env.__Z18RegisterAllClassesv;
  var _emscripten_glGenVertexArraysOES=env._emscripten_glGenVertexArraysOES;
  var _sqrt=env._sqrt;
  var _glDrawElementsInstancedEXT=env._glDrawElementsInstancedEXT;
  var _SDL_GetAudioDriver=env._SDL_GetAudioDriver;
  var _emscripten_glBlendFuncSeparate=env._emscripten_glBlendFuncSeparate;
  var _JS_SystemInfo_GetCurrentCanvasHeight=env._JS_SystemInfo_GetCurrentCanvasHeight;
  var _glTexParameteriv=env._glTexParameteriv;
  var _il2cpp_method_get_name=env._il2cpp_method_get_name;
  var _emscripten_glGenQueries=env._emscripten_glGenQueries;
  var ___assert_fail=env.___assert_fail;
  var _emscripten_set_mouseover_callback=env._emscripten_set_mouseover_callback;
  var _glutSpecialUpFunc=env._glutSpecialUpFunc;
  var _pthread_key_delete=env._pthread_key_delete;
  var _glutSwapBuffers=env._glutSwapBuffers;
  var _glutPositionWindow=env._glutPositionWindow;
  var _dlsym=env._dlsym;
  var emscriptenWebGLComputeImageSize=env.emscriptenWebGLComputeImageSize;
  var _JS_WebCamVideo_Start=env._JS_WebCamVideo_Start;
  var _pthread_spin_trylock=env._pthread_spin_trylock;
  var _emscripten_webgl_make_context_current=env._emscripten_webgl_make_context_current;
  var _Mix_ChannelFinished=env._Mix_ChannelFinished;
  var _emscripten_gluOrtho2D=env._emscripten_gluOrtho2D;
  var ___cxa_rethrow=env.___cxa_rethrow;
  var ___set_network_callback=env.___set_network_callback;
  var ___syscall148=env.___syscall148;
  var ___syscall140=env.___syscall140;
  var _makedev=env._makedev;
  var ___syscall144=env.___syscall144;
  var ___syscall145=env.___syscall145;
  var ___syscall146=env.___syscall146;
  var _glUniform1uiv=env._glUniform1uiv;
  var _JS_WebRequest_GetStatusLine=env._JS_WebRequest_GetStatusLine;
  var _uuid_unparse_upper=env._uuid_unparse_upper;
  var _SDL_GetCurrentAudioDriver=env._SDL_GetCurrentAudioDriver;
  var __Z32RegisterAllStrippedInternalCallsv=env.__Z32RegisterAllStrippedInternalCallsv;
  var _pthread_attr_destroy=env._pthread_attr_destroy;
  var _waitid=env._waitid;
  var _emscripten_set_socket_connection_callback=env._emscripten_set_socket_connection_callback;
  var _JS_UNETWebSockets_IsHostReadyToConnect=env._JS_UNETWebSockets_IsHostReadyToConnect;
  var _emscripten_glFrontFace=env._emscripten_glFrontFace;
  var _emscripten_set_socket_error_callback=env._emscripten_set_socket_error_callback;
  var _glDepthMask=env._glDepthMask;
  var _emscripten_glDrawArraysInstancedNV=env._emscripten_glDrawArraysInstancedNV;
  var _alSourcef=env._alSourcef;
  var _il2cpp_set_config_dir=env._il2cpp_set_config_dir;
  var _pthread_rwlock_rdlock=env._pthread_rwlock_rdlock;
  var _alSourcei=env._alSourcei;
  var _getloadavg=env._getloadavg;
  var ___syscall96=env.___syscall96;
  var _alGenBuffers=env._alGenBuffers;
  var ___syscall94=env.___syscall94;
  var _glfwLockMutex=env._glfwLockMutex;
  var ___syscall91=env.___syscall91;
  var _alIsExtensionPresent=env._alIsExtensionPresent;
  var _execle=env._execle;
  var _glGetFragDataLocation=env._glGetFragDataLocation;
  var _glDrawArraysInstanced=env._glDrawArraysInstanced;
  var _glStencilMaskSeparate=env._glStencilMaskSeparate;
  var _execlp=env._execlp;
  var _glAttachShader=env._glAttachShader;
  var _SDL_ListModes=env._SDL_ListModes;
  var _asctime=env._asctime;
  var _il2cpp_field_get_flags=env._il2cpp_field_get_flags;
  var __addDays=env.__addDays;
  var _glfwCreateThread=env._glfwCreateThread;
  var _emscripten_glVertexAttrib3f=env._emscripten_glVertexAttrib3f;
  var _glewGetString=env._glewGetString;
  var _glutInitWindowPosition=env._glutInitWindowPosition;
  var _glfwSetMouseButtonCallback=env._glfwSetMouseButtonCallback;
  var _glUniform2f=env._glUniform2f;
  var _il2cpp_unity_liveness_calculation_from_root=env._il2cpp_unity_liveness_calculation_from_root;
  var _emscripten_run_script=env._emscripten_run_script;
  var _emscripten_glUniformBlockBinding=env._emscripten_glUniformBlockBinding;
  var _fpathconf=env._fpathconf;
  var _SDL_CreateMutex=env._SDL_CreateMutex;
  var _ellipseRGBA=env._ellipseRGBA;
  var _endpwent=env._endpwent;
  var _glFinish=env._glFinish;
  var ___cxa_thread_atexit_impl=env.___cxa_thread_atexit_impl;
  var _SDL_Quit=env._SDL_Quit;
  var _pthread_spin_unlock=env._pthread_spin_unlock;
  var _emscripten_glVertexAttrib4fv=env._emscripten_glVertexAttrib4fv;
  var _SDL_malloc=env._SDL_malloc;
  var _raise=env._raise;
  var _pthread_getspecific=env._pthread_getspecific;
  var _pthread_cond_signal=env._pthread_cond_signal;
  var __reallyNegative=env.__reallyNegative;
  var _glActiveTexture=env._glActiveTexture;
  var _eglMakeCurrent=env._eglMakeCurrent;
  var ___ubsan_handle_float_cast_overflow=env.___ubsan_handle_float_cast_overflow;
  var _glEnableVertexAttribArray=env._glEnableVertexAttribArray;
  var _pthread_cond_timedwait=env._pthread_cond_timedwait;
  var _glBindVertexArray=env._glBindVertexArray;
  var _utime=env._utime;
  var _SDL_SetWindowTitle=env._SDL_SetWindowTitle;
  var ___syscall3=env.___syscall3;
  var _Mix_VolumeMusic=env._Mix_VolumeMusic;
  var _il2cpp_gc_disable=env._il2cpp_gc_disable;
  var _llvm_lifetime_start=env._llvm_lifetime_start;
  var _emscripten_glBindFramebuffer=env._emscripten_glBindFramebuffer;
  var _glCompressedTexSubImage2D=env._glCompressedTexSubImage2D;
  var _glfwDestroyMutex=env._glfwDestroyMutex;
  var _gluUnProject=env._gluUnProject;
  var _emscripten_glBindVertexArrayOES=env._emscripten_glBindVertexArrayOES;
  var _emscripten_glGetUniformfv=env._emscripten_glGetUniformfv;
  var _SDL_FreeRW=env._SDL_FreeRW;
  var _glfwWaitCond=env._glfwWaitCond;
  var ___atomic_fetch_and_8=env.___atomic_fetch_and_8;
  var _SDL_SetClipRect=env._SDL_SetClipRect;
  var _Mix_LoadWAV_RW=env._Mix_LoadWAV_RW;
  var _emscripten_glLineWidth=env._emscripten_glLineWidth;
  var _emscripten_glStencilOp=env._emscripten_glStencilOp;
  var _emscripten_glDrawElementsInstancedANGLE=env._emscripten_glDrawElementsInstancedANGLE;
  var _SDL_AddTimer=env._SDL_AddTimer;
  var _emscripten_glVertexAttrib1fv=env._emscripten_glVertexAttrib1fv;
  var _pthread_exit=env._pthread_exit;
  var _SDL_AudioDriverName=env._SDL_AudioDriverName;
  var _SDL_GetWindowFlags=env._SDL_GetWindowFlags;
  var _exit=env._exit;
  var _SDL_GL_GetProcAddress=env._SDL_GL_GetProcAddress;
  var _SDL_DestroyCond=env._SDL_DestroyCond;
  var _glBlendEquationSeparate=env._glBlendEquationSeparate;
  var _SDL_EnableKeyRepeat=env._SDL_EnableKeyRepeat;
  var _emscripten_glGenRenderbuffers=env._emscripten_glGenRenderbuffers;
  var _glDrawRangeElements=env._glDrawRangeElements;
  var _SDL_UpdateRects=env._SDL_UpdateRects;
  var _il2cpp_object_new=env._il2cpp_object_new;
  var _glGetVertexAttribIiv=env._glGetVertexAttribIiv;
  var _emscripten_glUniform3fv=env._emscripten_glUniform3fv;
  var _il2cpp_domain_assembly_open=env._il2cpp_domain_assembly_open;
  var _emscripten_glVertexAttribIPointer=env._emscripten_glVertexAttribIPointer;
  var _emscripten_glGetQueryObjectuiv=env._emscripten_glGetQueryObjectuiv;
  var _JS_UNETWebSockets_AddHost=env._JS_UNETWebSockets_AddHost;
  var _JS_Sound_Play=env._JS_Sound_Play;
  var _emscripten_set_keypress_callback=env._emscripten_set_keypress_callback;
  var _emscripten_glFramebufferTextureLayer=env._emscripten_glFramebufferTextureLayer;
  var _SDL_GetKeyName=env._SDL_GetKeyName;
  var _emscripten_glInvalidateSubFramebuffer=env._emscripten_glInvalidateSubFramebuffer;
  var _JS_Sound_SetListenerPosition=env._JS_Sound_SetListenerPosition;
  var _emscripten_vr_sensor_zero=env._emscripten_vr_sensor_zero;
  var _JS_Eval_SetTimeout=env._JS_Eval_SetTimeout;
  var _emscripten_glGenBuffers=env._emscripten_glGenBuffers;
  var _SDL_HasAltiVec=env._SDL_HasAltiVec;
  var _glMatrixMode=env._glMatrixMode;
  var _il2cpp_set_commandline_arguments=env._il2cpp_set_commandline_arguments;
  var _emscripten_atomic_exchange_u64=env._emscripten_atomic_exchange_u64;
  var _pthread_cleanup_pop=env._pthread_cleanup_pop;
  var _glHint=env._glHint;
  var _ctime=env._ctime;
  var _atan2l=env._atan2l;
  var _pthread_cleanup_push=env._pthread_cleanup_push;
  var _il2cpp_profiler_install_allocation=env._il2cpp_profiler_install_allocation;
  var _atan2f=env._atan2f;
  var _glDeleteTransformFeedbacks=env._glDeleteTransformFeedbacks;
  var _JS_WebRequest_Send=env._JS_WebRequest_Send;
  var ___clone=env.___clone;
  var ___setErrNo=env.___setErrNo;
  var _alcGetCurrentContext=env._alcGetCurrentContext;
  var _il2cpp_method_is_generic=env._il2cpp_method_is_generic;
  var _glUniform3i=env._glUniform3i;
  var _emscripten_glVertexAttrib2f=env._emscripten_glVertexAttrib2f;
  var _TTF_FontAscent=env._TTF_FontAscent;
  var _emscripten_set_pointerlockerror_callback=env._emscripten_set_pointerlockerror_callback;
  var _emscripten_async_run_script=env._emscripten_async_run_script;
  var _glfwDestroyCond=env._glfwDestroyCond;
  var _dladdr=env._dladdr;
  var _glGetIntegerv=env._glGetIntegerv;
  var _emscripten_set_scroll_callback=env._emscripten_set_scroll_callback;
  var _emscripten_glClearStencil=env._emscripten_glClearStencil;
  var _Mix_Paused=env._Mix_Paused;
  var _emscripten_glUniform1fv=env._emscripten_glUniform1fv;
  var _il2cpp_init=env._il2cpp_init;
  var _emscripten_glUniform1ui=env._emscripten_glUniform1ui;
  var _SDL_UpperBlitScaled=env._SDL_UpperBlitScaled;
  var _eglGetDisplay=env._eglGetDisplay;
  var _il2cpp_array_element_size=env._il2cpp_array_element_size;
  var _glCheckFramebufferStatus=env._glCheckFramebufferStatus;
  var _il2cpp_unity_liveness_calculation_begin=env._il2cpp_unity_liveness_calculation_begin;
  var _TTF_SizeUTF8=env._TTF_SizeUTF8;
  var _glBlendFuncSeparate=env._glBlendFuncSeparate;
  var _il2cpp_profiler_install=env._il2cpp_profiler_install;
  var _SDL_WM_IconifyWindow=env._SDL_WM_IconifyWindow;
  var _glBindTexture=env._glBindTexture;
  var _glClearBufferuiv=env._glClearBufferuiv;
  var _sigemptyset=env._sigemptyset;
  var _emscripten_glGetVertexAttribiv=env._emscripten_glGetVertexAttribiv;
  var _emscripten_atomic_store_u64=env._emscripten_atomic_store_u64;
  var _glfwGetMouseButton=env._glfwGetMouseButton;
  var _glUniform2iv=env._glUniform2iv;
  var _glfwCreateMutex=env._glfwCreateMutex;
  var _SDL_PauseAudio=env._SDL_PauseAudio;
  var _SDL_PeepEvents=env._SDL_PeepEvents;
  var _uuid_unparse_lower=env._uuid_unparse_lower;
  var _glUniformMatrix4x3fv=env._glUniformMatrix4x3fv;
  var _glGetUniformiv=env._glGetUniformiv;
  var _JS_UNETWebSockets_SocketRecvEvntHost=env._JS_UNETWebSockets_SocketRecvEvntHost;
  var _ceil=env._ceil;
  var _eglGetError=env._eglGetError;
  var _SDL_JoystickNumHats=env._SDL_JoystickNumHats;
  var __Unwind_FindEnclosingFunction=env.__Unwind_FindEnclosingFunction;
  var _sigaction=env._sigaction;
  var _llvm_mono_load_i16_p0i16=env._llvm_mono_load_i16_p0i16;
  var _glfwGetDesktopMode=env._glfwGetDesktopMode;
  var _emscripten_async_wget2_abort=env._emscripten_async_wget2_abort;
  var _glfwGetKey=env._glfwGetKey;
  var _emscripten_get_element_css_size=env._emscripten_get_element_css_size;
  var _JS_UNETWebSockets_HostsContainingMessagesPush=env._JS_UNETWebSockets_HostsContainingMessagesPush;
  var _Mix_OpenAudio=env._Mix_OpenAudio;
  var _glRenderbufferStorage=env._glRenderbufferStorage;
  var _glUniformMatrix3x2fv=env._glUniformMatrix3x2fv;
  var _alGetListenerfv=env._alGetListenerfv;
  var _glBindAttribLocation=env._glBindAttribLocation;
  var _emscripten_glBindBuffer=env._emscripten_glBindBuffer;
  var _emscripten_glUniform4uiv=env._emscripten_glUniform4uiv;
  var _TTF_OpenFont=env._TTF_OpenFont;
  var _eglGetConfigAttrib=env._eglGetConfigAttrib;
  var _emscripten_exit_soft_fullscreen=env._emscripten_exit_soft_fullscreen;
  var _glFramebufferTexture2D=env._glFramebufferTexture2D;
  var _glUniform4iv=env._glUniform4iv;
  var _emscripten_glDrawArraysInstancedARB=env._emscripten_glDrawArraysInstancedARB;
  var _alcOpenDevice=env._alcOpenDevice;
  var _emscripten_idb_load=env._emscripten_idb_load;
  var _llvm_copysign_f32=env._llvm_copysign_f32;
  var _glUniform3uiv=env._glUniform3uiv;
  var _glDisable=env._glDisable;
  var _strptime=env._strptime;
  var _emscripten_longjmp=env._emscripten_longjmp;
  var __formatString=env.__formatString;
  var _glStencilFuncSeparate=env._glStencilFuncSeparate;
  var _SDL_SetVideoMode=env._SDL_SetVideoMode;
  var _emscripten_glDeleteVertexArrays=env._emscripten_glDeleteVertexArrays;
  var _TTF_CloseFont=env._TTF_CloseFont;
  var _glfwReadMemoryImage=env._glfwReadMemoryImage;
  var _emscripten_glReleaseShaderCompiler=env._emscripten_glReleaseShaderCompiler;
  var __ZN4FMOD13DSPConnection6setMixEf=env.__ZN4FMOD13DSPConnection6setMixEf;
  var _flock=env._flock;
  var _emscripten_glIsSync=env._emscripten_glIsSync;
  var _llvm_log_f32=env._llvm_log_f32;
  var _gluLookAt=env._gluLookAt;
  var _SDL_UnlockMutex=env._SDL_UnlockMutex;
  var __ZSt18uncaught_exceptionv=env.__ZSt18uncaught_exceptionv;
  var _Mix_AllocateChannels=env._Mix_AllocateChannels;
  var _Mix_Volume=env._Mix_Volume;
  var _glShaderBinary=env._glShaderBinary;
  var _emscripten_glDeleteSamplers=env._emscripten_glDeleteSamplers;
  var _SDL_WM_SetIcon=env._SDL_WM_SetIcon;
  var _JS_Eval_OpenURL=env._JS_Eval_OpenURL;
  var _glBlendFunc=env._glBlendFunc;
  var _emscripten_glUniform3iv=env._emscripten_glUniform3iv;
  var _glIsBuffer=env._glIsBuffer;
  var _emscripten_set_main_loop_arg=env._emscripten_set_main_loop_arg;
  var _il2cpp_class_get_assemblyname=env._il2cpp_class_get_assemblyname;
  var _pthread_setcancelstate=env._pthread_setcancelstate;
  var _pthread_condattr_init=env._pthread_condattr_init;
  var _pthread_mutexattr_settype=env._pthread_mutexattr_settype;
  var _emscripten_vr_hmd_set_fov=env._emscripten_vr_hmd_set_fov;
  var _emscripten_run_script_int=env._emscripten_run_script_int;
  var _il2cpp_class_array_element_size=env._il2cpp_class_array_element_size;
  var _SDL_ConvertSurface=env._SDL_ConvertSurface;
  var _SDL_GetModState=env._SDL_GetModState;
  var _emscripten_glCullFace=env._emscripten_glCullFace;
  var _glVertexAttribDivisorEXT=env._glVertexAttribDivisorEXT;
  var _XSetWMHints=env._XSetWMHints;
  var _glVertexPointer=env._glVertexPointer;
  var _glGetBooleanv=env._glGetBooleanv;
  var _JS_Sound_SetVolume=env._JS_Sound_SetVolume;
  var _JS_Cursor_SetShow=env._JS_Cursor_SetShow;
  var _il2cpp_profiler_install_enter_leave=env._il2cpp_profiler_install_enter_leave;
  var _emscripten_glIsBuffer=env._emscripten_glIsBuffer;
  var _glValidateProgram=env._glValidateProgram;
  var _emscripten_glCompressedTexSubImage2D=env._emscripten_glCompressedTexSubImage2D;
  var _alcGetContextsDevice=env._alcGetContextsDevice;
  var _glBindSampler=env._glBindSampler;
  var _glVertexAttribI4uiv=env._glVertexAttribI4uiv;
  var _glGetVertexAttribiv=env._glGetVertexAttribiv;
  var _emscripten_set_socket_open_callback=env._emscripten_set_socket_open_callback;
  var _emscripten_get_preloaded_image_data_from_FILE=env._emscripten_get_preloaded_image_data_from_FILE;
  var _JS_Cursor_SetCursorString=env._JS_Cursor_SetCursorString;
  var _pthread_cond_init=env._pthread_cond_init;
  var _SDL_LockSurface=env._SDL_LockSurface;
  var ___builtin_prefetch=env.___builtin_prefetch;
  var _alSourceQueueBuffers=env._alSourceQueueBuffers;
  var _glSamplerParameteriv=env._glSamplerParameteriv;
  var _il2cpp_array_class_get=env._il2cpp_array_class_get;
  var _emscripten_set_focusout_callback=env._emscripten_set_focusout_callback;
  var _Mix_FadingChannel=env._Mix_FadingChannel;
  var _eglWaitGL=env._eglWaitGL;
  var _emscripten_async_load_script=env._emscripten_async_load_script;
  var _emscripten_pause_main_loop=env._emscripten_pause_main_loop;
  var _uuid_copy=env._uuid_copy;
  var _glUnmapBuffer=env._glUnmapBuffer;
  var __Unwind_Backtrace=env.__Unwind_Backtrace;
  var _emscripten_get_now=env._emscripten_get_now;
  var _XSendEvent=env._XSendEvent;
  var _emscripten_autodebug_i32=env._emscripten_autodebug_i32;
  var _il2cpp_method_is_instance=env._il2cpp_method_is_instance;
  var _emscripten_gluLookAt=env._emscripten_gluLookAt;
  var _emscripten_glPauseTransformFeedback=env._emscripten_glPauseTransformFeedback;
  var _alDeleteSources=env._alDeleteSources;
  var _JS_SystemInfo_GetCurrentCanvasWidth=env._JS_SystemInfo_GetCurrentCanvasWidth;
  var _emscripten_glGetVertexAttribIuiv=env._emscripten_glGetVertexAttribIuiv;
  var _emscripten_get_visibility_status=env._emscripten_get_visibility_status;
  var _gethostbyname_r=env._gethostbyname_r;
  var _pixelRGBA=env._pixelRGBA;
  var _getgrent=env._getgrent;
  var _TTF_FontHeight=env._TTF_FontHeight;
  var _Mix_ResumeMusic=env._Mix_ResumeMusic;
  var _emscripten_get_num_gamepads=env._emscripten_get_num_gamepads;
  var _glGetUniformfv=env._glGetUniformfv;
  var _emscripten_glReadBuffer=env._emscripten_glReadBuffer;
  var _Mix_LoadWAV=env._Mix_LoadWAV;
  var _emscripten_glClearBufferiv=env._emscripten_glClearBufferiv;
  var _tzset=env._tzset;
  var _il2cpp_class_get_namespace=env._il2cpp_class_get_namespace;
  var _major=env._major;
  var _SDL_GL_GetAttribute=env._SDL_GL_GetAttribute;
  var _llvm_fabs_f32=env._llvm_fabs_f32;
  var _SDL_BlitSurface=env._SDL_BlitSurface;
  var _emscripten_webgl_init_context_attributes=env._emscripten_webgl_init_context_attributes;
  var _sched_get_priority_max=env._sched_get_priority_max;
  var _llvm_flt_rounds=env._llvm_flt_rounds;
  var _SDL_GL_MakeCurrent=env._SDL_GL_MakeCurrent;
  var _emscripten_glDrawElementsInstancedEXT=env._emscripten_glDrawElementsInstancedEXT;
  var _gethostbyname=env._gethostbyname;
  var _glSampleCoverage=env._glSampleCoverage;
  var _glReadBuffer=env._glReadBuffer;
  var _emscripten_glRotatef=env._emscripten_glRotatef;
  var _emscripten_glUniform3ui=env._emscripten_glUniform3ui;
  var _eglCreateContext=env._eglCreateContext;
  var _emscripten_glUniformMatrix4fv=env._emscripten_glUniformMatrix4fv;
  var _alSpeedOfSound=env._alSpeedOfSound;
  var _alGetProcAddress=env._alGetProcAddress;
  var _emscripten_request_pointerlock=env._emscripten_request_pointerlock;
  var __Unwind_RaiseException=env.__Unwind_RaiseException;
  var _glProgramBinary=env._glProgramBinary;
  var _JS_SystemInfo_GetMemory=env._JS_SystemInfo_GetMemory;
  var _il2cpp_field_get_name=env._il2cpp_field_get_name;
  var _emscripten_glUniformMatrix2x3fv=env._emscripten_glUniformMatrix2x3fv;
  var _emscripten_glGetVertexAttribfv=env._emscripten_glGetVertexAttribfv;
  var _glIsSampler=env._glIsSampler;
  var _emscripten_glVertexAttrib3fv=env._emscripten_glVertexAttrib3fv;
  var _pthread_rwlock_wrlock=env._pthread_rwlock_wrlock;
  var _il2cpp_class_from_type=env._il2cpp_class_from_type;
  var _il2cpp_shutdown=env._il2cpp_shutdown;
  var _glBeginTransformFeedback=env._glBeginTransformFeedback;
  var _sinf=env._sinf;
  var _glutTimerFunc=env._glutTimerFunc;
  var __arraySum=env.__arraySum;
  var _emscripten_glLinkProgram=env._emscripten_glLinkProgram;
  var _alDeleteBuffers=env._alDeleteBuffers;
  var _Mix_HaltChannel=env._Mix_HaltChannel;
  var _JS_UNETWebSockets_SocketSend=env._JS_UNETWebSockets_SocketSend;
  var _emscripten_has_threading_support=env._emscripten_has_threading_support;
  var _emscripten_glGenSamplers=env._emscripten_glGenSamplers;
  var _emscripten_main_thread_process_queued_calls=env._emscripten_main_thread_process_queued_calls;
  var _emscripten_glDeleteFramebuffers=env._emscripten_glDeleteFramebuffers;
  var _getprotobyname=env._getprotobyname;
  var _emscripten_glClearColor=env._emscripten_glClearColor;
  var _emscripten_glDrawElements=env._emscripten_glDrawElements;
  var _glTexParameteri=env._glTexParameteri;
  var _emscripten_glDetachShader=env._emscripten_glDetachShader;
  var _glTexParameterf=env._glTexParameterf;
  var _setenv=env._setenv;
  var _emscripten_glGetActiveUniformBlockiv=env._emscripten_glGetActiveUniformBlockiv;
  var _glLineWidth=env._glLineWidth;
  var _glIsQuery=env._glIsQuery;
  var _alBufferData=env._alBufferData;
  var _execv=env._execv;
  var _emscripten_idb_exists=env._emscripten_idb_exists;
  var _eglGetCurrentContext=env._eglGetCurrentContext;
  var _JS_WebCamVideo_GetNativeHeight=env._JS_WebCamVideo_GetNativeHeight;
  var _sigfillset=env._sigfillset;
  var ___cxa_begin_catch=env.___cxa_begin_catch;
  var _uuid_compare=env._uuid_compare;
  var _emscripten_is_main_runtime_thread=env._emscripten_is_main_runtime_thread;
  var _execl=env._execl;
  var _il2cpp_method_get_class=env._il2cpp_method_get_class;
  var _pthread_mutexattr_setpshared=env._pthread_mutexattr_setpshared;
  var _emscripten_glGetUniformBlockIndex=env._emscripten_glGetUniformBlockIndex;
  var _glfwGetMousePos=env._glfwGetMousePos;
  var _il2cpp_profiler_set_events=env._il2cpp_profiler_set_events;
  var _llvm_prefetch=env._llvm_prefetch;
  var _minor=env._minor;
  var _glfwGetGLVersion=env._glfwGetGLVersion;
  var _emscripten_get_devicemotion_status=env._emscripten_get_devicemotion_status;
  var _emscripten_glIsFramebuffer=env._emscripten_glIsFramebuffer;
  var _emscripten_glGetSamplerParameterfv=env._emscripten_glGetSamplerParameterfv;
  var _alGetBufferi=env._alGetBufferi;
  var _glfwExtensionSupported=env._glfwExtensionSupported;
  var _gnu_dev_minor=env._gnu_dev_minor;
  var _unsetenv=env._unsetenv;
  var _JS_Sound_SetLoopPoints=env._JS_Sound_SetLoopPoints;
  var _glDrawElementsInstancedANGLE=env._glDrawElementsInstancedANGLE;
  var _posix_spawn_file_actions_adddup2=env._posix_spawn_file_actions_adddup2;
  var _emscripten_set_devicemotion_callback=env._emscripten_set_devicemotion_callback;
  var _SDL_LowerBlitScaled=env._SDL_LowerBlitScaled;
  var _emscripten_print_double=env._emscripten_print_double;
  var _alcGetError=env._alcGetError;
  var _SDL_free=env._SDL_free;
  var _glBegin=env._glBegin;
  var _glutSetCursor=env._glutSetCursor;
  var _glGetProgramInfoLog=env._glGetProgramInfoLog;
  var _JS_Sound_Load_PCM=env._JS_Sound_Load_PCM;
  var _emscripten_glGetSynciv=env._emscripten_glGetSynciv;
  var _emscripten_hide_mouse=env._emscripten_hide_mouse;
  var ___syscall304=env.___syscall304;
  var _il2cpp_string_new_wrapper=env._il2cpp_string_new_wrapper;
  var _llvm_mono_load_i8_p0i8=env._llvm_mono_load_i8_p0i8;
  var __pthread_cleanup_push=env.__pthread_cleanup_push;
  var _Mix_FadeInChannelTimed=env._Mix_FadeInChannelTimed;
  var _emscripten_set_mouseenter_callback=env._emscripten_set_mouseenter_callback;
  var _alGetError=env._alGetError;
  var _emscripten_glEnable=env._emscripten_glEnable;
  var _emscripten_gluPerspective=env._emscripten_gluPerspective;
  var _getpwnam=env._getpwnam;
  var _wait3=env._wait3;
  var _emscripten_glBindBufferRange=env._emscripten_glBindBufferRange;
  var _time=env._time;
  var ___libc_current_sigrtmin=env.___libc_current_sigrtmin;
  var _emscripten_vr_get_device_name=env._emscripten_vr_get_device_name;
  var _JS_UNETWebSockets_SocketRecvEvntBuffLength=env._JS_UNETWebSockets_SocketRecvEvntBuffLength;
  var _il2cpp_class_enum_basetype=env._il2cpp_class_enum_basetype;
  var _emscripten_glGetActiveAttrib=env._emscripten_glGetActiveAttrib;
  var _glIsProgram=env._glIsProgram;
  var __inet_pton4_raw=env.__inet_pton4_raw;
  var ___syscall269=env.___syscall269;
  var ___syscall268=env.___syscall268;
  var _SDL_WaitThread=env._SDL_WaitThread;
  var ___syscall265=env.___syscall265;
  var _JS_SystemInfo_GetOS=env._JS_SystemInfo_GetOS;
  var _glPauseTransformFeedback=env._glPauseTransformFeedback;
  var _glBindVertexArrayOES=env._glBindVertexArrayOES;
  var _emscripten_glGetShaderInfoLog=env._emscripten_glGetShaderInfoLog;
  var _emscripten_glGetVertexAttribPointerv=env._emscripten_glGetVertexAttribPointerv;
  var _clock_getcpuclockid=env._clock_getcpuclockid;
  var _il2cpp_free_captured_memory_snapshot=env._il2cpp_free_captured_memory_snapshot;
  var ___syscall193=env.___syscall193;
  var ___syscall192=env.___syscall192;
  var ___syscall191=env.___syscall191;
  var _glUniform1f=env._glUniform1f;
  var ___syscall197=env.___syscall197;
  var ___syscall196=env.___syscall196;
  var ___syscall195=env.___syscall195;
  var ___syscall194=env.___syscall194;
  var ___syscall199=env.___syscall199;
  var ___syscall198=env.___syscall198;
  var _glUniform1i=env._glUniform1i;
  var _glVertexAttrib3fv=env._glVertexAttrib3fv;
  var _emscripten_glCreateShader=env._emscripten_glCreateShader;
  var _emscripten_lock_orientation=env._emscripten_lock_orientation;
  var _emscripten_glCompressedTexSubImage3D=env._emscripten_glCompressedTexSubImage3D;
  var _SDL_GetMouseState=env._SDL_GetMouseState;
  var _glTransformFeedbackVaryings=env._glTransformFeedbackVaryings;
  var _glVertexAttribDivisorNV=env._glVertexAttribDivisorNV;
  var _glGetShaderSource=env._glGetShaderSource;
  var _glutDisplayFunc=env._glutDisplayFunc;
  var _emscripten_exit_pointerlock=env._emscripten_exit_pointerlock;
  var _SDL_UnlockSurface=env._SDL_UnlockSurface;
  var _SDL_GL_GetSwapInterval=env._SDL_GL_GetSwapInterval;
  var _emscripten_vr_sensor_get_state=env._emscripten_vr_sensor_get_state;
  var _emscripten_async_wget_data=env._emscripten_async_wget_data;
  var _glCompressedTexImage3D=env._glCompressedTexImage3D;
  var _SDL_GetRGBA=env._SDL_GetRGBA;
  var _glfwGetTime=env._glfwGetTime;
  var _TTF_RenderText_Shaded=env._TTF_RenderText_Shaded;
  var ___gxx_personality_v0=env.___gxx_personality_v0;
  var _glfwCloseWindow=env._glfwCloseWindow;
  var _system=env._system;
  var _emscripten_set_touchend_callback=env._emscripten_set_touchend_callback;
  var _emscripten_set_batterylevelchange_callback=env._emscripten_set_batterylevelchange_callback;
  var _glutInitWindowSize=env._glutInitWindowSize;
  var _glGetRenderbufferParameteriv=env._glGetRenderbufferParameteriv;
  var _glfwWaitThread=env._glfwWaitThread;
  var _llvm_sin_f32=env._llvm_sin_f32;
  var _glCopyTexImage2D=env._glCopyTexImage2D;
  var _JS_WebCamVideo_GetDeviceName=env._JS_WebCamVideo_GetDeviceName;
  var _il2cpp_class_get_nested_types=env._il2cpp_class_get_nested_types;
  var _SDL_AudioQuit=env._SDL_AudioQuit;
  var _pthread_mutexattr_init=env._pthread_mutexattr_init;
  var _glBufferSubData=env._glBufferSubData;
  var _Mix_FadeOutMusic=env._Mix_FadeOutMusic;
  var _glfwSetKeyCallback=env._glfwSetKeyCallback;
  var _il2cpp_capture_memory_snapshot=env._il2cpp_capture_memory_snapshot;
  var ___cxa_allocate_exception=env.___cxa_allocate_exception;
  var _glGetInternalformativ=env._glGetInternalformativ;
  var _JS_UNETWebSockets_SocketClose=env._JS_UNETWebSockets_SocketClose;
  var _alSourceUnqueueBuffers=env._alSourceUnqueueBuffers;
  var g$___environ=env.g$___environ;
  var tempFloat = Math_fround(0);
  const f0 = Math_fround(0);

// EMSCRIPTEN_START_FUNCS
function __ZL22DrawParticlesWithPivotILb1EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i16, i13, i2, i1, i527, i528) {
 i16 = i16 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i527 = i527 | 0;
 i528 = i528 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, f342 = f0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, f440 = f0, f441 = f0, f442 = f0, f443 = f0, f444 = f0, f445 = f0, f446 = f0, f447 = f0, f448 = f0, f449 = f0, f450 = f0, f451 = f0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, f464 = f0, f465 = f0, f466 = f0, f467 = f0, f468 = f0, f469 = f0, f470 = f0, f471 = f0, f472 = f0, f473 = f0, f474 = f0, f475 = f0, f476 = f0, f477 = f0, f478 = f0, f479 = f0, f480 = f0, f481 = f0, f482 = f0, f483 = f0, f484 = f0, i485 = 0, f486 = f0, f487 = f0, f488 = f0, f489 = f0, f490 = f0, f491 = f0, f492 = f0, f493 = f0, f494 = f0, f495 = f0, f496 = f0, f497 = f0, f498 = f0, f499 = f0, f500 = f0, f501 = f0, f502 = f0, f503 = f0, f504 = f0, f505 = f0, f506 = f0, f507 = f0, f508 = f0, f509 = f0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i529 = 0, i530 = 0, i531 = 0, f532 = f0, f533 = f0, f534 = f0, f535 = f0, f536 = f0, f537 = f0, f538 = f0, f539 = f0, f540 = f0, f541 = f0, f542 = f0, f543 = f0, f544 = f0, f545 = f0, f546 = f0, f547 = f0, f548 = f0, f549 = f0, f550 = f0, f551 = f0, f552 = f0, f553 = f0, f554 = f0, f555 = f0, f556 = f0, f557 = f0, f558 = f0;
 i531 = STACKTOP;
 STACKTOP = STACKTOP + 1520 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i531 + 1448 | 0;
 i14 = i531 + 1384 | 0;
 i511 = i531 + 1344 | 0;
 i529 = i531 + 1296 | 0;
 i530 = i531 + 1248 | 0;
 i512 = i531 + 1200 | 0;
 i513 = i531 + 1184 | 0;
 i514 = i531 + 1168 | 0;
 i515 = i531 + 1152 | 0;
 i516 = i531 + 1136 | 0;
 i517 = i531 + 1088 | 0;
 i518 = i531 + 1040 | 0;
 i519 = i531 + 992 | 0;
 i520 = i531 + 944 | 0;
 i510 = i531;
 i521 = i531 + 880 | 0;
 i522 = i531 + 752 | 0;
 i523 = i531 + 496 | 0;
 i524 = i531 + 304 | 0;
 i525 = i531 + 112 | 0;
 i526 = i531 + 48 | 0;
 switch (HEAP16[i2 >> 1] | 0) {
 case 0:
  {
   if (!(HEAP8[i527 + 870 >> 0] | 0)) {
    i17 = i12;
    i15 = i17 + 36 | 0;
    do {
     HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
     i17 = i17 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i17 | 0) < (i15 | 0));
    __ZL28DrawBillboardsWith3DRotationILb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i16, i13, i2, i12, i527, i528);
    STACKTOP = i531;
    return;
   }
   i17 = i510;
   i15 = i17 + 36 | 0;
   do {
    HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
    i17 = i17 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   do if ((i4 | 0) == 3) {
    i17 = i12;
    i1 = i510;
    i15 = i17 + 36 | 0;
    do {
     HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
     i17 = i17 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i17 | 0) < (i15 | 0));
    __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i16, i13, i2, i12, i527, i528);
   } else {
    i485 = i13 + 332 | 0;
    i1 = HEAP32[i485 >> 2] | 0;
    if (!(i1 & 1073741824)) {
     i17 = i12;
     i1 = i510;
     i15 = i17 + 36 | 0;
     do {
      HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
      i17 = i17 + 4 | 0;
      i1 = i1 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i16, i13, i2, i12, i527, i528);
     break;
    }
    i11 = HEAP32[i510 + 32 >> 2] | 0;
    f474 = Math_fround((i1 & 4095) >>> 0);
    f475 = Math_fround(Math_fround(1.0) / f474);
    f476 = Math_fround(HEAPF32[i13 + 368 >> 2]);
    f477 = Math_fround(HEAPF32[i13 + 372 >> 2]);
    f478 = Math_fround(HEAPF32[i13 + 376 >> 2]);
    f479 = Math_fround(Math_fround(1.0) - f478);
    i3 = i13 + 420 | 0;
    f480 = Math_fround(HEAPF32[i13 + 404 >> 2]);
    i452 = i13 + 408 | 0;
    f472 = Math_fround(HEAPF32[i452 >> 2]);
    f466 = Math_fround(HEAPF32[i452 + 4 >> 2]);
    f468 = Math_fround(HEAPF32[i452 + 8 >> 2]);
    i452 = i13 + 336 | 0;
    f481 = Math_fround(HEAPF32[i452 >> 2]);
    f482 = Math_fround(HEAPF32[i452 + 4 >> 2]);
    f483 = Math_fround(HEAPF32[i452 + 8 >> 2]);
    f484 = Math_fround(HEAPF32[i452 + 12 >> 2]);
    i452 = i13 + 352 | 0;
    f471 = Math_fround(HEAPF32[i452 >> 2]);
    f465 = Math_fround(HEAPF32[i452 + 4 >> 2]);
    i452 = i13 + 360 | 0;
    f470 = Math_fround(HEAPF32[i452 >> 2]);
    f464 = Math_fround(HEAPF32[i452 + 4 >> 2]);
    i452 = i2 + 36 | 0;
    f473 = Math_fround(HEAPF32[i452 >> 2]);
    f467 = Math_fround(HEAPF32[i452 + 4 >> 2]);
    f469 = Math_fround(HEAPF32[i452 + 8 >> 2]);
    i2 = HEAP32[i2 + 56 >> 2] | 0;
    f440 = Math_fround(HEAPF32[i13 + 128 >> 2]);
    f441 = Math_fround(HEAPF32[i13 + 132 >> 2]);
    f442 = Math_fround(HEAPF32[i13 + 136 >> 2]);
    f443 = Math_fround(HEAPF32[i13 + 144 >> 2]);
    f444 = Math_fround(HEAPF32[i13 + 148 >> 2]);
    f445 = Math_fround(HEAPF32[i13 + 152 >> 2]);
    f446 = Math_fround(HEAPF32[i13 + 160 >> 2]);
    f447 = Math_fround(HEAPF32[i13 + 164 >> 2]);
    f448 = Math_fround(HEAPF32[i13 + 168 >> 2]);
    f449 = Math_fround(HEAPF32[i13 + 176 >> 2]);
    f450 = Math_fround(HEAPF32[i13 + 180 >> 2]);
    f451 = Math_fround(HEAPF32[i13 + 184 >> 2]);
    i452 = i521 + 12 | 0;
    i453 = i521 + 8 | 0;
    i454 = i521 + 4 | 0;
    i455 = i521 + 28 | 0;
    HEAP32[i521 >> 2] = 0;
    HEAP32[i521 + 4 >> 2] = 0;
    HEAP32[i521 + 8 >> 2] = 0;
    HEAP32[i521 + 12 >> 2] = 0;
    HEAP32[i455 >> 2] = 1;
    i456 = i521 + 24 | 0;
    HEAP32[i456 >> 2] = 1;
    i457 = i521 + 20 | 0;
    HEAP32[i457 >> 2] = 1;
    i458 = i521 + 16 | 0;
    HEAP32[i458 >> 2] = 1;
    i459 = i521 + 44 | 0;
    HEAP32[i459 >> 2] = 2;
    i460 = i521 + 40 | 0;
    HEAP32[i460 >> 2] = 2;
    i461 = i521 + 36 | 0;
    HEAP32[i461 >> 2] = 2;
    i462 = i521 + 32 | 0;
    HEAP32[i462 >> 2] = 2;
    i463 = i521 + 60 | 0;
    HEAP32[i463 >> 2] = 3;
    i437 = i521 + 56 | 0;
    HEAP32[i437 >> 2] = 3;
    i438 = i521 + 52 | 0;
    HEAP32[i438 >> 2] = 3;
    i439 = i521 + 48 | 0;
    HEAP32[i439 >> 2] = 3;
    i388 = i522 + 4 | 0;
    i412 = i522 + 8 | 0;
    i436 = i522 + 12 | 0;
    i364 = i522 + 16 | 0;
    HEAP32[i522 >> 2] = 0;
    HEAP32[i522 + 4 >> 2] = 0;
    HEAP32[i522 + 8 >> 2] = 0;
    HEAP32[i522 + 12 >> 2] = 0;
    HEAPF32[i364 >> 2] = Math_fround(1.0);
    i387 = i522 + 20 | 0;
    HEAPF32[i387 >> 2] = Math_fround(1.0);
    i411 = i522 + 24 | 0;
    HEAPF32[i411 >> 2] = Math_fround(1.0);
    i435 = i522 + 28 | 0;
    HEAPF32[i435 >> 2] = Math_fround(1.0);
    i363 = i522 + 32 | 0;
    HEAPF32[i363 >> 2] = Math_fround(1.0);
    i386 = i522 + 36 | 0;
    HEAPF32[i386 >> 2] = Math_fround(1.0);
    i410 = i522 + 40 | 0;
    HEAPF32[i410 >> 2] = Math_fround(1.0);
    i434 = i522 + 44 | 0;
    HEAPF32[i434 >> 2] = Math_fround(1.0);
    i362 = i522 + 48 | 0;
    HEAPF32[i362 >> 2] = Math_fround(1.0);
    i385 = i522 + 52 | 0;
    HEAPF32[i385 >> 2] = Math_fround(1.0);
    i409 = i522 + 56 | 0;
    HEAPF32[i409 >> 2] = Math_fround(1.0);
    i433 = i522 + 60 | 0;
    HEAPF32[i433 >> 2] = Math_fround(1.0);
    i361 = i522 + 64 | 0;
    HEAPF32[i361 >> 2] = Math_fround(1.0);
    i384 = i522 + 68 | 0;
    HEAPF32[i384 >> 2] = Math_fround(1.0);
    i408 = i522 + 72 | 0;
    HEAPF32[i408 >> 2] = Math_fround(1.0);
    i432 = i522 + 76 | 0;
    HEAPF32[i432 >> 2] = Math_fround(1.0);
    i360 = i522 + 80 | 0;
    i383 = i522 + 84 | 0;
    i407 = i522 + 88 | 0;
    i431 = i522 + 92 | 0;
    i359 = i522 + 96 | 0;
    i382 = i522 + 100 | 0;
    i406 = i522 + 104 | 0;
    i430 = i522 + 108 | 0;
    i358 = i522 + 112 | 0;
    i381 = i522 + 116 | 0;
    i405 = i522 + 120 | 0;
    i429 = i522 + 124 | 0;
    i17 = i360;
    i15 = i17 + 48 | 0;
    do {
     HEAP32[i17 >> 2] = 0;
     i17 = i17 + 4 | 0;
    } while ((i17 | 0) < (i15 | 0));
    i380 = i523 + 4 | 0;
    i404 = i523 + 8 | 0;
    i428 = i523 + 12 | 0;
    i357 = i523 + 16 | 0;
    HEAP32[i523 >> 2] = 0;
    HEAP32[i523 + 4 >> 2] = 0;
    HEAP32[i523 + 8 >> 2] = 0;
    HEAP32[i523 + 12 >> 2] = 0;
    HEAPF32[i357 >> 2] = Math_fround(1.0);
    i379 = i523 + 20 | 0;
    HEAPF32[i379 >> 2] = Math_fround(1.0);
    i403 = i523 + 24 | 0;
    HEAPF32[i403 >> 2] = Math_fround(1.0);
    i427 = i523 + 28 | 0;
    HEAPF32[i427 >> 2] = Math_fround(1.0);
    i356 = i523 + 32 | 0;
    i378 = i523 + 36 | 0;
    i402 = i523 + 40 | 0;
    i426 = i523 + 44 | 0;
    i355 = i523 + 48 | 0;
    i377 = i523 + 52 | 0;
    i401 = i523 + 56 | 0;
    i425 = i523 + 60 | 0;
    i354 = i523 + 64 | 0;
    HEAP32[i356 >> 2] = 0;
    HEAP32[i356 + 4 >> 2] = 0;
    HEAP32[i356 + 8 >> 2] = 0;
    HEAP32[i356 + 12 >> 2] = 0;
    HEAP32[i356 + 16 >> 2] = 0;
    HEAP32[i356 + 20 >> 2] = 0;
    HEAP32[i356 + 24 >> 2] = 0;
    HEAP32[i356 + 28 >> 2] = 0;
    HEAPF32[i354 >> 2] = Math_fround(1.0);
    i376 = i523 + 68 | 0;
    HEAPF32[i376 >> 2] = Math_fround(1.0);
    i400 = i523 + 72 | 0;
    HEAPF32[i400 >> 2] = Math_fround(1.0);
    i424 = i523 + 76 | 0;
    HEAPF32[i424 >> 2] = Math_fround(1.0);
    i353 = i523 + 80 | 0;
    HEAPF32[i353 >> 2] = Math_fround(1.0);
    i375 = i523 + 84 | 0;
    HEAPF32[i375 >> 2] = Math_fround(1.0);
    i399 = i523 + 88 | 0;
    HEAPF32[i399 >> 2] = Math_fround(1.0);
    i423 = i523 + 92 | 0;
    HEAPF32[i423 >> 2] = Math_fround(1.0);
    i352 = i523 + 96 | 0;
    i374 = i523 + 100 | 0;
    i398 = i523 + 104 | 0;
    i422 = i523 + 108 | 0;
    i351 = i523 + 112 | 0;
    i373 = i523 + 116 | 0;
    i397 = i523 + 120 | 0;
    i421 = i523 + 124 | 0;
    i350 = i523 + 128 | 0;
    HEAP32[i352 >> 2] = 0;
    HEAP32[i352 + 4 >> 2] = 0;
    HEAP32[i352 + 8 >> 2] = 0;
    HEAP32[i352 + 12 >> 2] = 0;
    HEAP32[i352 + 16 >> 2] = 0;
    HEAP32[i352 + 20 >> 2] = 0;
    HEAP32[i352 + 24 >> 2] = 0;
    HEAP32[i352 + 28 >> 2] = 0;
    HEAPF32[i350 >> 2] = Math_fround(1.0);
    i372 = i523 + 132 | 0;
    HEAPF32[i372 >> 2] = Math_fround(1.0);
    i396 = i523 + 136 | 0;
    HEAPF32[i396 >> 2] = Math_fround(1.0);
    i420 = i523 + 140 | 0;
    HEAPF32[i420 >> 2] = Math_fround(1.0);
    i349 = i523 + 144 | 0;
    i371 = i523 + 148 | 0;
    i395 = i523 + 152 | 0;
    i419 = i523 + 156 | 0;
    i348 = i523 + 160 | 0;
    i370 = i523 + 164 | 0;
    i394 = i523 + 168 | 0;
    i418 = i523 + 172 | 0;
    i347 = i523 + 176 | 0;
    i369 = i523 + 180 | 0;
    i393 = i523 + 184 | 0;
    i417 = i523 + 188 | 0;
    i346 = i523 + 192 | 0;
    i368 = i523 + 196 | 0;
    i392 = i523 + 200 | 0;
    i416 = i523 + 204 | 0;
    i345 = i523 + 208 | 0;
    i367 = i523 + 212 | 0;
    i391 = i523 + 216 | 0;
    i415 = i523 + 220 | 0;
    i344 = i523 + 224 | 0;
    i366 = i523 + 228 | 0;
    i390 = i523 + 232 | 0;
    i414 = i523 + 236 | 0;
    i343 = i523 + 240 | 0;
    i365 = i523 + 244 | 0;
    i389 = i523 + 248 | 0;
    i413 = i523 + 252 | 0;
    i17 = i349;
    i15 = i17 + 112 | 0;
    do {
     HEAP32[i17 >> 2] = 0;
     i17 = i17 + 4 | 0;
    } while ((i17 | 0) < (i15 | 0));
    switch (i4 | 0) {
    case 1:
     {
      i17 = i12;
      i1 = gb + 1162292 | 0;
      i15 = i17 + 64 | 0;
      do {
       HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
       i17 = i17 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i17 | 0) < (i15 | 0));
      break;
     }
    case 2:
     {
      i17 = i12;
      i1 = i13 + 256 | 0;
      i15 = i17 + 64 | 0;
      do {
       HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
       i17 = i17 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i17 | 0) < (i15 | 0));
      break;
     }
    default:
     {
      i17 = i12;
      i1 = i13 + 64 | 0;
      i15 = i17 + 64 | 0;
      do {
       HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
       i17 = i17 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i17 | 0) < (i15 | 0));
     }
    }
    __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
    f508 = Math_fround(HEAPF32[i3 >> 2]);
    f499 = Math_fround(HEAPF32[i13 + 428 >> 2]);
    f82 = Math_fround(HEAPF32[i13 + 424 >> 2]);
    f80 = Math_fround(HEAPF32[i14 >> 2]);
    i334 = i14 + 4 | 0;
    f507 = Math_fround(HEAPF32[i334 >> 2]);
    i335 = i14 + 8 | 0;
    f505 = Math_fround(HEAPF32[i335 >> 2]);
    i336 = i14 + 12 | 0;
    f84 = Math_fround(HEAPF32[i336 >> 2]);
    i337 = i14 + 16 | 0;
    f498 = Math_fround(HEAPF32[i337 >> 2]);
    i338 = i14 + 20 | 0;
    f503 = Math_fround(HEAPF32[i338 >> 2]);
    i510 = i14 + 24 | 0;
    f506 = Math_fround(HEAPF32[i510 >> 2]);
    i172 = i14 + 28 | 0;
    f500 = Math_fround(HEAPF32[i172 >> 2]);
    i171 = i14 + 32 | 0;
    f86 = Math_fround(HEAPF32[i171 >> 2]);
    f83 = Math_fround(f507 * Math_fround(0.0));
    f509 = Math_fround(f505 * Math_fround(0.0));
    f85 = Math_fround(f498 * Math_fround(0.0));
    f504 = Math_fround(f503 * Math_fround(0.0));
    f87 = Math_fround(Math_fround(Math_fround(f508 * f84) + f85) + f504);
    f81 = Math_fround(f500 * Math_fround(0.0));
    f502 = Math_fround(f86 * Math_fround(0.0));
    f342 = Math_fround(Math_fround(Math_fround(f508 * f506) + f81) + f502);
    f501 = Math_fround(f80 * Math_fround(0.0));
    f507 = Math_fround(Math_fround(f501 + Math_fround(f499 * f507)) + f509);
    f84 = Math_fround(f84 * Math_fround(0.0));
    f504 = Math_fround(Math_fround(f84 + Math_fround(f499 * f498)) + f504);
    f506 = Math_fround(f506 * Math_fround(0.0));
    f502 = Math_fround(Math_fround(f506 + Math_fround(f499 * f500)) + f502);
    f505 = Math_fround(Math_fround(f501 + f83) + Math_fround(f82 * f505));
    f503 = Math_fround(Math_fround(f84 + f85) + Math_fround(f82 * f503));
    f86 = Math_fround(Math_fround(f506 + f81) + Math_fround(f82 * f86));
    HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(f508 * f80) + f83) + f509);
    HEAPF32[i334 >> 2] = f507;
    HEAPF32[i335 >> 2] = f505;
    HEAPF32[i336 >> 2] = f87;
    HEAPF32[i337 >> 2] = f504;
    HEAPF32[i338 >> 2] = f503;
    HEAPF32[i510 >> 2] = f342;
    HEAPF32[i172 >> 2] = f502;
    HEAPF32[i171 >> 2] = f86;
    i339 = i527 + 300 | 0;
    f86 = Math_fround(HEAPF32[HEAP32[i339 >> 2] >> 2]);
    i340 = i527 + 320 | 0;
    f502 = Math_fround(HEAPF32[HEAP32[i340 >> 2] >> 2]);
    i341 = i527 + 340 | 0;
    f502 = Math_fround(-f502);
    f342 = Math_fround(-Math_fround(HEAPF32[HEAP32[i341 >> 2] >> 2]));
    HEAPF32[i529 >> 2] = Math_fround(-f86);
    HEAPF32[i529 + 4 >> 2] = f502;
    HEAPF32[i529 + 8 >> 2] = f342;
    __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f(i529, i511);
    f342 = Math_fround(HEAPF32[i511 >> 2]);
    f502 = Math_fround(HEAPF32[i511 + 4 >> 2]);
    f86 = Math_fround(HEAPF32[i511 + 8 >> 2]);
    f503 = Math_fround(HEAPF32[i511 + 12 >> 2]);
    f504 = Math_fround(HEAPF32[i511 + 16 >> 2]);
    f87 = Math_fround(HEAPF32[i511 + 20 >> 2]);
    f505 = Math_fround(HEAPF32[i511 + 24 >> 2]);
    f507 = Math_fround(HEAPF32[i511 + 28 >> 2]);
    f509 = Math_fround(HEAPF32[i511 + 32 >> 2]);
    f83 = Math_fround(HEAPF32[i14 >> 2]);
    f80 = Math_fround(f342 * f83);
    f508 = Math_fround(HEAPF32[i336 >> 2]);
    f80 = Math_fround(f80 + Math_fround(f502 * f508));
    f82 = Math_fround(HEAPF32[i510 >> 2]);
    f80 = Math_fround(f80 + Math_fround(f86 * f82));
    f81 = Math_fround(Math_fround(Math_fround(f503 * f83) + Math_fround(f504 * f508)) + Math_fround(f87 * f82));
    f82 = Math_fround(Math_fround(Math_fround(f505 * f83) + Math_fround(f507 * f508)) + Math_fround(f509 * f82));
    f508 = Math_fround(HEAPF32[i334 >> 2]);
    f83 = Math_fround(f342 * f508);
    f506 = Math_fround(HEAPF32[i337 >> 2]);
    f83 = Math_fround(f83 + Math_fround(f502 * f506));
    f85 = Math_fround(HEAPF32[i172 >> 2]);
    f83 = Math_fround(f83 + Math_fround(f86 * f85));
    f84 = Math_fround(Math_fround(Math_fround(f503 * f508) + Math_fround(f504 * f506)) + Math_fround(f87 * f85));
    f85 = Math_fround(Math_fround(Math_fround(f505 * f508) + Math_fround(f507 * f506)) + Math_fround(f509 * f85));
    f506 = Math_fround(HEAPF32[i335 >> 2]);
    f342 = Math_fround(f342 * f506);
    f508 = Math_fround(HEAPF32[i338 >> 2]);
    f502 = Math_fround(f342 + Math_fround(f502 * f508));
    f342 = Math_fround(HEAPF32[i171 >> 2]);
    f86 = Math_fround(f502 + Math_fround(f86 * f342));
    f87 = Math_fround(Math_fround(Math_fround(f503 * f506) + Math_fround(f504 * f508)) + Math_fround(f87 * f342));
    f342 = Math_fround(Math_fround(Math_fround(f505 * f506) + Math_fround(f507 * f508)) + Math_fround(f509 * f342));
    HEAPF32[i14 >> 2] = f80;
    HEAPF32[i334 >> 2] = f83;
    HEAPF32[i335 >> 2] = f86;
    HEAPF32[i336 >> 2] = f81;
    HEAPF32[i337 >> 2] = f84;
    HEAPF32[i338 >> 2] = f87;
    HEAPF32[i510 >> 2] = f82;
    HEAPF32[i172 >> 2] = f85;
    HEAPF32[i171 >> 2] = f342;
    i171 = (i2 | 0) == 27;
    HEAP32[i511 >> 2] = 0;
    HEAP32[i511 + 4 >> 2] = 0;
    HEAP32[i511 + 8 >> 2] = 0;
    HEAP32[i511 + 12 >> 2] = 0;
    i172 = HEAP32[i527 + 12 >> 2] | 0;
    if (i172 | 0) {
     i173 = i529 + 12 | 0;
     i174 = i529 + 8 | 0;
     i175 = i529 + 4 | 0;
     i176 = i529 + 16 | 0;
     i177 = i529 + 28 | 0;
     i178 = i529 + 24 | 0;
     i179 = i529 + 20 | 0;
     i180 = i529 + 32 | 0;
     i181 = i529 + 44 | 0;
     i182 = i529 + 40 | 0;
     i183 = i529 + 36 | 0;
     i184 = i530 + 12 | 0;
     i185 = i530 + 8 | 0;
     i186 = i530 + 4 | 0;
     i187 = i530 + 28 | 0;
     i188 = i530 + 24 | 0;
     i189 = i530 + 20 | 0;
     i190 = i530 + 44 | 0;
     i191 = i530 + 40 | 0;
     i192 = i530 + 36 | 0;
     i193 = i528 + 20 | 0;
     i194 = i527 + 20 | 0;
     i195 = i527 + 40 | 0;
     i196 = i527 + 60 | 0;
     i197 = i527 + 80 | 0;
     i198 = i527 + 100 | 0;
     i199 = i527 + 120 | 0;
     i200 = i527 + 140 | 0;
     i201 = i527 + 160 | 0;
     i202 = i530 + 16 | 0;
     i203 = i530 + 32 | 0;
     i204 = i528 + 4 | 0;
     i205 = i512 + 4 | 0;
     i206 = i512 + 8 | 0;
     i207 = i512 + 12 | 0;
     i208 = i528 + 8 | 0;
     i209 = i513 + 4 | 0;
     i210 = i513 + 8 | 0;
     i211 = i513 + 12 | 0;
     i212 = i527 + 520 | 0;
     i213 = i514 + 4 | 0;
     i214 = i514 + 8 | 0;
     i215 = i514 + 12 | 0;
     i216 = i527 + 500 | 0;
     i217 = i515 + 4 | 0;
     i218 = i515 + 8 | 0;
     i219 = i515 + 12 | 0;
     i220 = i528 + 16 | 0;
     i221 = i516 + 4 | 0;
     i222 = i516 + 8 | 0;
     i223 = i516 + 12 | 0;
     i224 = i529 + 16 | 0;
     i225 = i529 + 32 | 0;
     i226 = i517 + 4 | 0;
     i227 = i517 + 8 | 0;
     i228 = i517 + 12 | 0;
     i229 = i517 + 16 | 0;
     i230 = i517 + 20 | 0;
     i231 = i517 + 24 | 0;
     i232 = i517 + 28 | 0;
     i233 = i517 + 32 | 0;
     i234 = i517 + 36 | 0;
     i235 = i517 + 40 | 0;
     i236 = i517 + 44 | 0;
     i237 = i524 + 4 | 0;
     i238 = i524 + 8 | 0;
     i239 = i524 + 12 | 0;
     i240 = i524 + 16 | 0;
     i241 = i524 + 20 | 0;
     i242 = i524 + 24 | 0;
     i243 = i524 + 28 | 0;
     i244 = i524 + 32 | 0;
     i245 = i524 + 36 | 0;
     i246 = i524 + 40 | 0;
     i247 = i524 + 44 | 0;
     i248 = i524 + 48 | 0;
     i249 = i524 + 52 | 0;
     i250 = i524 + 56 | 0;
     i251 = i524 + 60 | 0;
     i252 = i524 + 64 | 0;
     i253 = i524 + 68 | 0;
     i254 = i524 + 72 | 0;
     i255 = i524 + 76 | 0;
     i256 = i524 + 80 | 0;
     i257 = i524 + 84 | 0;
     i258 = i524 + 88 | 0;
     i259 = i524 + 92 | 0;
     i260 = i524 + 96 | 0;
     i261 = i524 + 100 | 0;
     i262 = i524 + 104 | 0;
     i263 = i524 + 108 | 0;
     i264 = i524 + 112 | 0;
     i265 = i524 + 116 | 0;
     i266 = i524 + 120 | 0;
     i267 = i524 + 124 | 0;
     i268 = i524 + 128 | 0;
     i269 = i524 + 132 | 0;
     i270 = i524 + 136 | 0;
     i271 = i524 + 140 | 0;
     i272 = i524 + 144 | 0;
     i273 = i524 + 148 | 0;
     i274 = i524 + 152 | 0;
     i275 = i524 + 156 | 0;
     i276 = i524 + 160 | 0;
     i277 = i524 + 164 | 0;
     i278 = i524 + 168 | 0;
     i279 = i524 + 172 | 0;
     i280 = i524 + 176 | 0;
     i281 = i524 + 180 | 0;
     i282 = i524 + 184 | 0;
     i283 = i524 + 188 | 0;
     i284 = (i2 & 48 | 0) == 0;
     i133 = i525 + 4 | 0;
     i150 = i525 + 8 | 0;
     i167 = i525 + 12 | 0;
     i285 = i525 + 16 | 0;
     i128 = i525 + 20 | 0;
     i145 = i525 + 24 | 0;
     i162 = i525 + 28 | 0;
     i286 = i525 + 32 | 0;
     i123 = i525 + 36 | 0;
     i140 = i525 + 40 | 0;
     i157 = i525 + 44 | 0;
     i287 = i525 + 48 | 0;
     i132 = i525 + 52 | 0;
     i149 = i525 + 56 | 0;
     i166 = i525 + 60 | 0;
     i288 = i525 + 64 | 0;
     i127 = i525 + 68 | 0;
     i144 = i525 + 72 | 0;
     i161 = i525 + 76 | 0;
     i289 = i525 + 80 | 0;
     i122 = i525 + 84 | 0;
     i139 = i525 + 88 | 0;
     i156 = i525 + 92 | 0;
     i290 = i525 + 96 | 0;
     i131 = i525 + 100 | 0;
     i148 = i525 + 104 | 0;
     i165 = i525 + 108 | 0;
     i291 = i525 + 112 | 0;
     i126 = i525 + 116 | 0;
     i143 = i525 + 120 | 0;
     i160 = i525 + 124 | 0;
     i292 = i525 + 128 | 0;
     i121 = i525 + 132 | 0;
     i138 = i525 + 136 | 0;
     i155 = i525 + 140 | 0;
     i293 = i525 + 144 | 0;
     i130 = i525 + 148 | 0;
     i147 = i525 + 152 | 0;
     i164 = i525 + 156 | 0;
     i294 = i525 + 160 | 0;
     i125 = i525 + 164 | 0;
     i142 = i525 + 168 | 0;
     i159 = i525 + 172 | 0;
     i295 = i525 + 176 | 0;
     i120 = i525 + 180 | 0;
     i137 = i525 + 184 | 0;
     i154 = i525 + 188 | 0;
     i134 = i518 + 4 | 0;
     i151 = i518 + 8 | 0;
     i168 = i518 + 12 | 0;
     i296 = i518 + 16 | 0;
     i129 = i518 + 20 | 0;
     i146 = i518 + 24 | 0;
     i163 = i518 + 28 | 0;
     i297 = i518 + 32 | 0;
     i124 = i518 + 36 | 0;
     i141 = i518 + 40 | 0;
     i158 = i518 + 44 | 0;
     i136 = i519 + 4 | 0;
     i153 = i519 + 8 | 0;
     i170 = i519 + 12 | 0;
     i298 = i519 + 16 | 0;
     i135 = i519 + 20 | 0;
     i152 = i519 + 24 | 0;
     i169 = i519 + 28 | 0;
     i119 = i519 + 32 | 0;
     i299 = (i2 & 512 | 0) != 0;
     i300 = i520 + 4 | 0;
     i301 = i520 + 8 | 0;
     i302 = i520 + 12 | 0;
     i303 = i520 + 16 | 0;
     i304 = i520 + 20 | 0;
     i305 = i520 + 24 | 0;
     i306 = i520 + 28 | 0;
     i307 = i520 + 32 | 0;
     i308 = i520 + 36 | 0;
     i309 = i520 + 40 | 0;
     i310 = i520 + 44 | 0;
     i311 = (i2 & 8192 | 0) != 0;
     i312 = i526 + 4 | 0;
     i313 = i526 + 8 | 0;
     i314 = i526 + 12 | 0;
     i315 = i526 + 16 | 0;
     i316 = i526 + 20 | 0;
     i317 = i526 + 24 | 0;
     i318 = i526 + 28 | 0;
     i319 = i526 + 32 | 0;
     i320 = i526 + 36 | 0;
     i321 = i526 + 40 | 0;
     i322 = i526 + 44 | 0;
     i323 = i526 + 48 | 0;
     i324 = i526 + 52 | 0;
     i325 = i526 + 56 | 0;
     i326 = i526 + 60 | 0;
     i327 = (i2 & 2 | 0) == 0;
     i328 = (i2 & 8 | 0) == 0;
     i329 = (i2 & 16 | 0) == 0;
     i330 = (i2 & 32 | 0) == 0;
     i331 = (i2 & 64 | 0) == 0;
     i332 = (i2 & 128 | 0) == 0;
     i333 = (i2 & 256 | 0) == 0;
     i334 = i520 + 16 | 0;
     i335 = i520 + 32 | 0;
     i336 = (i2 & 1024 | 0) == 0;
     i337 = (i2 & 2048 | 0) == 0;
     i338 = (i2 & 4096 | 0) == 0;
     i90 = (i2 & 4 | 0) == 0;
     i91 = i518 + 16 | 0;
     i92 = i518 + 32 | 0;
     i93 = i527 + 864 | 0;
     i94 = i527 + 848 | 0;
     i95 = i527 + 844 | 0;
     i96 = i527 + 828 | 0;
     i97 = i527 + 540 | 0;
     i98 = i519 + 16 | 0;
     i99 = i519 + 32 | 0;
     i100 = i517 + 16 | 0;
     i101 = i517 + 32 | 0;
     i102 = i524 + 16 | 0;
     i103 = i524 + 32 | 0;
     i104 = i525 + 16 | 0;
     i105 = i525 + 32 | 0;
     i106 = i248 + 16 | 0;
     i107 = i248 + 32 | 0;
     i108 = i287 + 16 | 0;
     i109 = i287 + 32 | 0;
     i110 = i260 + 16 | 0;
     i111 = i260 + 32 | 0;
     i112 = i290 + 16 | 0;
     i113 = i290 + 32 | 0;
     i114 = i272 + 16 | 0;
     i115 = i272 + 32 | 0;
     i116 = i293 + 16 | 0;
     i117 = i293 + 32 | 0;
     i118 = i11 + 564 | 0;
     i89 = i11 + 568 | 0;
     i88 = 0;
     i1 = i16;
     do {
      i17 = i529;
      i15 = i17 + 48 | 0;
      do {
       HEAP32[i17 >> 2] = 0;
       i17 = i17 + 4 | 0;
      } while ((i17 | 0) < (i15 | 0));
      i17 = i530;
      i15 = i17 + 48 | 0;
      do {
       HEAP32[i17 >> 2] = 0;
       i17 = i17 + 4 | 0;
      } while ((i17 | 0) < (i15 | 0));
      HEAP32[i512 >> 2] = 0;
      HEAP32[i512 + 4 >> 2] = 0;
      HEAP32[i512 + 8 >> 2] = 0;
      HEAP32[i512 + 12 >> 2] = 0;
      HEAP32[i513 >> 2] = 0;
      HEAP32[i513 + 4 >> 2] = 0;
      HEAP32[i513 + 8 >> 2] = 0;
      HEAP32[i513 + 12 >> 2] = 0;
      HEAP32[i514 >> 2] = 0;
      HEAP32[i514 + 4 >> 2] = 0;
      HEAP32[i514 + 8 >> 2] = 0;
      HEAP32[i514 + 12 >> 2] = 0;
      HEAP32[i515 >> 2] = 0;
      HEAP32[i515 + 4 >> 2] = 0;
      HEAP32[i515 + 8 >> 2] = 0;
      HEAP32[i515 + 12 >> 2] = 0;
      HEAP32[i516 >> 2] = 0;
      HEAP32[i516 + 4 >> 2] = 0;
      HEAP32[i516 + 8 >> 2] = 0;
      HEAP32[i516 + 12 >> 2] = 0;
      i22 = HEAP32[i193 >> 2] | 0;
      i23 = HEAP32[i527 >> 2] | 0;
      if (!i22) {
       i68 = i23 + (i88 << 2) | 0;
       i69 = HEAP32[i68 + 4 >> 2] | 0;
       i70 = HEAP32[i68 + 8 >> 2] | 0;
       i71 = HEAP32[i68 + 12 >> 2] | 0;
       i75 = (HEAP32[i194 >> 2] | 0) + (i88 << 2) | 0;
       i72 = HEAP32[i75 >> 2] | 0;
       i73 = HEAP32[i75 + 4 >> 2] | 0;
       i74 = HEAP32[i75 + 8 >> 2] | 0;
       i75 = HEAP32[i75 + 12 >> 2] | 0;
       i510 = (HEAP32[i195 >> 2] | 0) + (i88 << 2) | 0;
       i76 = HEAP32[i510 >> 2] | 0;
       i77 = HEAP32[i510 + 4 >> 2] | 0;
       i78 = HEAP32[i510 + 8 >> 2] | 0;
       i510 = HEAP32[i510 + 12 >> 2] | 0;
       HEAP32[i529 >> 2] = HEAP32[i68 >> 2];
       HEAP32[i175 >> 2] = i69;
       HEAP32[i174 >> 2] = i70;
       HEAP32[i173 >> 2] = i71;
       HEAP32[i176 >> 2] = i72;
       HEAP32[i179 >> 2] = i73;
       HEAP32[i178 >> 2] = i74;
       HEAP32[i177 >> 2] = i75;
       HEAP32[i180 >> 2] = i76;
       HEAP32[i183 >> 2] = i77;
       HEAP32[i182 >> 2] = i78;
       HEAP32[i181 >> 2] = i510;
       i510 = (HEAP32[i196 >> 2] | 0) + (i88 << 2) | 0;
       f497 = Math_fround(HEAPF32[i510 >> 2]);
       f487 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f488 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f489 = Math_fround(HEAPF32[i510 + 12 >> 2]);
       i510 = (HEAP32[i197 >> 2] | 0) + (i88 << 2) | 0;
       f490 = Math_fround(HEAPF32[i510 >> 2]);
       f491 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f492 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f493 = Math_fround(HEAPF32[i510 + 12 >> 2]);
       i510 = (HEAP32[i198 >> 2] | 0) + (i88 << 2) | 0;
       f494 = Math_fround(HEAPF32[i510 >> 2]);
       f495 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f496 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f509 = Math_fround(HEAPF32[i510 + 12 >> 2]);
       i510 = (HEAP32[i199 >> 2] | 0) + (i88 << 2) | 0;
       f498 = Math_fround(HEAPF32[i510 >> 2]);
       f499 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f500 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f501 = Math_fround(HEAPF32[i510 + 12 >> 2]);
       i510 = (HEAP32[i200 >> 2] | 0) + (i88 << 2) | 0;
       f502 = Math_fround(HEAPF32[i510 >> 2]);
       f503 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f504 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f505 = Math_fround(HEAPF32[i510 + 12 >> 2]);
       i510 = (HEAP32[i201 >> 2] | 0) + (i88 << 2) | 0;
       f506 = Math_fround(HEAPF32[i510 >> 2]);
       f507 = Math_fround(HEAPF32[i510 + 4 >> 2]);
       f508 = Math_fround(HEAPF32[i510 + 8 >> 2]);
       f499 = Math_fround(f487 + f499);
       f500 = Math_fround(f488 + f500);
       f501 = Math_fround(f489 + f501);
       f502 = Math_fround(f490 + f502);
       f503 = Math_fround(f491 + f503);
       f504 = Math_fround(f492 + f504);
       f505 = Math_fround(f493 + f505);
       f506 = Math_fround(f494 + f506);
       f507 = Math_fround(f495 + f507);
       f508 = Math_fround(f496 + f508);
       f509 = Math_fround(f509 + Math_fround(HEAPF32[i510 + 12 >> 2]));
       HEAPF32[i530 >> 2] = Math_fround(f497 + f498);
       HEAPF32[i186 >> 2] = f499;
       HEAPF32[i185 >> 2] = f500;
       HEAPF32[i184 >> 2] = f501;
       HEAPF32[i202 >> 2] = f502;
       HEAPF32[i189 >> 2] = f503;
       HEAPF32[i188 >> 2] = f504;
       HEAPF32[i187 >> 2] = f505;
       HEAPF32[i203 >> 2] = f506;
       HEAPF32[i192 >> 2] = f507;
       HEAPF32[i191 >> 2] = f508;
       HEAPF32[i190 >> 2] = f509;
       i510 = (HEAP32[i204 >> 2] | 0) + (i88 << 2) | 0;
       i78 = HEAP32[i510 + 4 >> 2] | 0;
       i77 = HEAP32[i510 + 8 >> 2] | 0;
       i76 = HEAP32[i510 + 12 >> 2] | 0;
       HEAP32[i512 >> 2] = HEAP32[i510 >> 2];
       HEAP32[i205 >> 2] = i78;
       HEAP32[i206 >> 2] = i77;
       HEAP32[i207 >> 2] = i76;
       i76 = (HEAP32[i208 >> 2] | 0) + (i88 << 2) | 0;
       i77 = HEAP32[i76 + 4 >> 2] | 0;
       i78 = HEAP32[i76 + 8 >> 2] | 0;
       i510 = HEAP32[i76 + 12 >> 2] | 0;
       HEAP32[i513 >> 2] = HEAP32[i76 >> 2];
       HEAP32[i209 >> 2] = i77;
       HEAP32[i210 >> 2] = i78;
       HEAP32[i211 >> 2] = i510;
       i510 = (HEAP32[i212 >> 2] | 0) + (i88 << 2) | 0;
       i78 = HEAP32[i510 + 4 >> 2] | 0;
       i77 = HEAP32[i510 + 8 >> 2] | 0;
       i76 = HEAP32[i510 + 12 >> 2] | 0;
       HEAP32[i514 >> 2] = HEAP32[i510 >> 2];
       HEAP32[i213 >> 2] = i78;
       HEAP32[i214 >> 2] = i77;
       HEAP32[i215 >> 2] = i76;
       i76 = (HEAP32[i216 >> 2] | 0) + (i88 << 2) | 0;
       i77 = HEAP32[i76 + 4 >> 2] | 0;
       i78 = HEAP32[i76 + 8 >> 2] | 0;
       i510 = HEAP32[i76 + 12 >> 2] | 0;
       HEAP32[i515 >> 2] = HEAP32[i76 >> 2];
       HEAP32[i217 >> 2] = i77;
       HEAP32[i218 >> 2] = i78;
       HEAP32[i219 >> 2] = i510;
       if (HEAP32[i485 >> 2] & 268435456 | 0) {
        i76 = (HEAP32[i220 >> 2] | 0) + (i88 << 2) | 0;
        i77 = HEAP32[i76 + 4 >> 2] | 0;
        i78 = HEAP32[i76 + 8 >> 2] | 0;
        i510 = HEAP32[i76 + 12 >> 2] | 0;
        HEAP32[i516 >> 2] = HEAP32[i76 >> 2];
        HEAP32[i221 >> 2] = i77;
        HEAP32[i222 >> 2] = i78;
        HEAP32[i223 >> 2] = i510;
       }
      } else {
       i4 = HEAP32[i196 >> 2] | 0;
       i11 = HEAP32[i199 >> 2] | 0;
       i12 = HEAP32[i194 >> 2] | 0;
       i13 = HEAP32[i197 >> 2] | 0;
       i14 = HEAP32[i200 >> 2] | 0;
       i15 = HEAP32[i195 >> 2] | 0;
       i16 = HEAP32[i198 >> 2] | 0;
       i17 = HEAP32[i201 >> 2] | 0;
       i18 = HEAP32[i204 >> 2] | 0;
       i19 = HEAP32[i208 >> 2] | 0;
       i20 = HEAP32[i212 >> 2] | 0;
       i21 = HEAP32[i216 >> 2] | 0;
       i3 = HEAP32[i220 >> 2] | 0;
       if (!(HEAP32[i485 >> 2] & 268435456)) {
        i2 = 0;
        do {
         i510 = HEAP32[i22 + (i2 + i88 << 3) >> 2] | 0;
         HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i4 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i2 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i11 + (i510 << 2) >> 2]));
         i78 = i2 + 4 | 0;
         HEAP32[i529 + (i78 << 2) >> 2] = HEAP32[i12 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i13 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i78 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i14 + (i510 << 2) >> 2]));
         i78 = i2 + 8 | 0;
         HEAP32[i529 + (i78 << 2) >> 2] = HEAP32[i15 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i16 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i78 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i17 + (i510 << 2) >> 2]));
         HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i510 << 2) >> 2];
         HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i510 << 2) >> 2];
         HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i510 << 2) >> 2];
         HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i510 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != 4);
       } else {
        i2 = 0;
        do {
         i510 = HEAP32[i22 + (i2 + i88 << 3) >> 2] | 0;
         HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i4 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i2 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i11 + (i510 << 2) >> 2]));
         i78 = i2 + 4 | 0;
         HEAP32[i529 + (i78 << 2) >> 2] = HEAP32[i12 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i13 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i78 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i14 + (i510 << 2) >> 2]));
         i78 = i2 + 8 | 0;
         HEAP32[i529 + (i78 << 2) >> 2] = HEAP32[i15 + (i510 << 2) >> 2];
         f509 = Math_fround(HEAPF32[i16 + (i510 << 2) >> 2]);
         HEAPF32[i530 + (i78 << 2) >> 2] = Math_fround(f509 + Math_fround(HEAPF32[i17 + (i510 << 2) >> 2]));
         HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i510 << 2) >> 2];
         HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i510 << 2) >> 2];
         HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i510 << 2) >> 2];
         HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i510 << 2) >> 2];
         HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i3 + (i510 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != 4);
       }
      }
      f27 = Math_fround(HEAPF32[i529 >> 2]);
      f7 = Math_fround(f440 * f27);
      f32 = Math_fround(HEAPF32[i175 >> 2]);
      f30 = Math_fround(f440 * f32);
      f509 = Math_fround(HEAPF32[i174 >> 2]);
      f6 = Math_fround(f440 * f509);
      f507 = Math_fround(HEAPF32[i173 >> 2]);
      f79 = Math_fround(f440 * f507);
      f33 = Math_fround(HEAPF32[i224 >> 2]);
      f31 = Math_fround(f443 * f33);
      f26 = Math_fround(HEAPF32[i179 >> 2]);
      f35 = Math_fround(f443 * f26);
      f508 = Math_fround(HEAPF32[i178 >> 2]);
      f10 = Math_fround(f443 * f508);
      f506 = Math_fround(HEAPF32[i177 >> 2]);
      f31 = Math_fround(f7 + f31);
      f35 = Math_fround(f30 + f35);
      f10 = Math_fround(f6 + f10);
      f79 = Math_fround(f79 + Math_fround(f443 * f506));
      f6 = Math_fround(HEAPF32[i225 >> 2]);
      f30 = Math_fround(f446 * f6);
      f7 = Math_fround(HEAPF32[i183 >> 2]);
      f29 = Math_fround(f446 * f7);
      f8 = Math_fround(HEAPF32[i182 >> 2]);
      f28 = Math_fround(f446 * f8);
      f34 = Math_fround(HEAPF32[i181 >> 2]);
      f29 = Math_fround(f449 + Math_fround(f35 + f29));
      f28 = Math_fround(f449 + Math_fround(f10 + f28));
      f79 = Math_fround(f449 + Math_fround(f79 + Math_fround(f446 * f34)));
      HEAPF32[i517 >> 2] = Math_fround(f449 + Math_fround(f31 + f30));
      HEAPF32[i226 >> 2] = f29;
      HEAPF32[i227 >> 2] = f28;
      HEAPF32[i228 >> 2] = f79;
      f79 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f32) + Math_fround(f444 * f26)) + Math_fround(f447 * f7)));
      f28 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f509) + Math_fround(f444 * f508)) + Math_fround(f447 * f8)));
      f29 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f507) + Math_fround(f444 * f506)) + Math_fround(f447 * f34)));
      HEAPF32[i229 >> 2] = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f27) + Math_fround(f444 * f33)) + Math_fround(f447 * f6)));
      HEAPF32[i230 >> 2] = f79;
      HEAPF32[i231 >> 2] = f28;
      HEAPF32[i232 >> 2] = f29;
      f29 = Math_fround(f451 + Math_fround(Math_fround(Math_fround(f442 * f32) + Math_fround(f445 * f26)) + Math_fround(f448 * f7)));
      f28 = Math_fround(f451 + Math_fround(Math_fround(Math_fround(f442 * f509) + Math_fround(f445 * f508)) + Math_fround(f448 * f8)));
      f79 = Math_fround(f451 + Math_fround(Math_fround(Math_fround(f442 * f507) + Math_fround(f445 * f506)) + Math_fround(f448 * f34)));
      HEAPF32[i233 >> 2] = Math_fround(f451 + Math_fround(Math_fround(Math_fround(f442 * f27) + Math_fround(f445 * f33)) + Math_fround(f448 * f6)));
      HEAPF32[i234 >> 2] = f29;
      HEAPF32[i235 >> 2] = f28;
      HEAPF32[i236 >> 2] = f79;
      f6 = Math_fround(f484 + Math_fround(Math_fround(Math_fround(f481 * f27) + Math_fround(f482 * f33)) + Math_fround(f483 * f6)));
      f7 = Math_fround(f484 + Math_fround(Math_fround(Math_fround(f481 * f32) + Math_fround(f482 * f26)) + Math_fround(f483 * f7)));
      f8 = Math_fround(f484 + Math_fround(Math_fround(Math_fround(f481 * f509) + Math_fround(f482 * f508)) + Math_fround(f483 * f8)));
      f34 = Math_fround(f484 + Math_fround(Math_fround(Math_fround(f481 * f507) + Math_fround(f482 * f506)) + Math_fround(f483 * f34)));
      f506 = Math_fround(f470 + Math_fround(f471 * f6));
      f507 = Math_fround(f470 + Math_fround(f471 * f7));
      f508 = Math_fround(f470 + Math_fround(f471 * f8));
      f509 = Math_fround(f470 + Math_fround(f471 * f34));
      f6 = Math_fround(f464 + Math_fround(f465 * f6));
      f7 = Math_fround(f464 + Math_fround(f465 * f7));
      f8 = Math_fround(f464 + Math_fround(f465 * f8));
      f34 = Math_fround(f464 + Math_fround(f465 * f34));
      f26 = Math_fround(HEAPF32[i512 >> 2]);
      f32 = Math_fround(HEAPF32[i205 >> 2]);
      f33 = Math_fround(HEAPF32[i206 >> 2]);
      f27 = Math_fround(HEAPF32[i207 >> 2]);
      f28 = Math_fround(HEAPF32[i513 >> 2]);
      f29 = Math_fround(HEAPF32[i209 >> 2]);
      f30 = Math_fround(HEAPF32[i210 >> 2]);
      f31 = Math_fround(HEAPF32[i211 >> 2]);
      f10 = f26 > f28 ? f26 : f28;
      f35 = f32 > f29 ? f32 : f29;
      f25 = f33 > f30 ? f33 : f30;
      f36 = f27 > f31 ? f27 : f31;
      f503 = Math_fround((f10 > f506 ? f10 : f506) * Math_fround(.5));
      f504 = Math_fround((f35 > f507 ? f35 : f507) * Math_fround(.5));
      f505 = Math_fround((f25 > f508 ? f25 : f508) * Math_fround(.5));
      f5 = Math_fround((f36 > f509 ? f36 : f509) * Math_fround(.5));
      i15 = (HEAPF32[tempDoublePtr >> 2] = f503, HEAP32[tempDoublePtr >> 2] | 0);
      i16 = (HEAPF32[tempDoublePtr >> 2] = f504, HEAP32[tempDoublePtr >> 2] | 0);
      i17 = (HEAPF32[tempDoublePtr >> 2] = f505, HEAP32[tempDoublePtr >> 2] | 0);
      i76 = f506 >= Math_fround(0.0);
      i77 = f507 >= Math_fround(0.0);
      i78 = f508 >= Math_fround(0.0);
      i510 = f509 >= Math_fround(0.0);
      i15 = i76 ? i15 : 0;
      i16 = i77 ? i16 : 0;
      i17 = i78 ? i17 : 0;
      i11 = i510 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      f505 = Math_fround(f6 * Math_fround(.5));
      f507 = Math_fround(f7 * Math_fround(.5));
      f509 = Math_fround(f8 * Math_fround(.5));
      f5 = Math_fround(f34 * Math_fround(.5));
      f504 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f506 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f508 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = (HEAPF32[tempDoublePtr >> 2] = f504 < f505 ? f504 : f505, HEAP32[tempDoublePtr >> 2] | 0);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f506 < f507 ? f506 : f507, HEAP32[tempDoublePtr >> 2] | 0);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f508 < f509 ? f508 : f509, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = f6 >= Math_fround(0.0);
      i3 = f7 >= Math_fround(0.0);
      i2 = f8 >= Math_fround(0.0);
      i510 = f34 >= Math_fround(0.0);
      i76 = i510 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
      f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
      f44 = (HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
      f46 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f39 = Math_fround(f26 * f43);
      f41 = Math_fround(f33 * f45);
      f43 = Math_fround(f28 * f43);
      f45 = Math_fround(f30 * f45);
      f507 = Math_fround(HEAPF32[i514 >> 2]);
      f486 = Math_fround(HEAPF32[i213 >> 2]);
      f25 = Math_fround(HEAPF32[i214 >> 2]);
      f10 = Math_fround(f473 * f26);
      f534 = Math_fround(f473 * f33);
      f506 = Math_fround(f467 * f28);
      f508 = Math_fround(f467 * f30);
      f537 = Math_fround(f469 * f26);
      f535 = Math_fround(f469 * f33);
      f44 = Math_fround(f44 / f35);
      f40 = Math_fround(f32 * f44);
      f44 = Math_fround(f29 * f44);
      i76 = f507 < Math_fround(100.0);
      i78 = f25 < Math_fround(100.0);
      f25 = Math_fround(f473 * f32);
      f507 = Math_fround(f467 * f29);
      f536 = Math_fround(f469 * f32);
      f46 = Math_fround(f46 / f36);
      f42 = Math_fround(f27 * f46);
      f46 = Math_fround(f31 * f46);
      i77 = f486 < Math_fround(100.0);
      i510 = Math_fround(HEAPF32[i215 >> 2]) < Math_fround(100.0);
      f486 = Math_fround(f473 * f27);
      f509 = Math_fround(f467 * f31);
      f546 = Math_fround(f469 * f27);
      f39 = i76 ? f39 : Math_fround(0.0);
      f40 = i77 ? f40 : Math_fround(0.0);
      f41 = i78 ? f41 : Math_fround(0.0);
      f42 = i510 ? f42 : Math_fround(0.0);
      f489 = Math_fround(f10 - f39);
      f488 = Math_fround(f25 - f40);
      f487 = Math_fround(f534 - f41);
      f497 = Math_fround(f486 - f42);
      f43 = i76 ? f43 : Math_fround(0.0);
      f35 = Math_fround(f506 + f43);
      f44 = i77 ? f44 : Math_fround(0.0);
      f36 = Math_fround(f507 + f44);
      f45 = i78 ? f45 : Math_fround(0.0);
      f37 = Math_fround(f508 + f45);
      f46 = i510 ? f46 : Math_fround(0.0);
      f38 = Math_fround(f509 + f46);
      f545 = Math_fround(f80 * f489);
      f496 = Math_fround(f80 * f488);
      f495 = Math_fround(f80 * f487);
      f494 = Math_fround(f80 * f497);
      f27 = Math_fround(f81 * f35);
      f28 = Math_fround(f81 * f36);
      f29 = Math_fround(f81 * f37);
      f30 = Math_fround(f81 * f38);
      f547 = Math_fround(f82 * f537);
      f544 = Math_fround(f82 * f536);
      f543 = Math_fround(f82 * f535);
      f542 = Math_fround(f82 * f546);
      f47 = Math_fround(f547 + Math_fround(f545 + f27));
      f48 = Math_fround(f544 + Math_fround(f496 + f28));
      f49 = Math_fround(f543 + Math_fround(f495 + f29));
      f50 = Math_fround(f542 + Math_fround(f494 + f30));
      f493 = Math_fround(f83 * f489);
      f492 = Math_fround(f83 * f488);
      f491 = Math_fround(f83 * f487);
      f490 = Math_fround(f83 * f497);
      f31 = Math_fround(f84 * f35);
      f32 = Math_fround(f84 * f36);
      f33 = Math_fround(f84 * f37);
      f34 = Math_fround(f84 * f38);
      f541 = Math_fround(f85 * f537);
      f540 = Math_fround(f85 * f536);
      f539 = Math_fround(f85 * f535);
      f538 = Math_fround(f85 * f546);
      f51 = Math_fround(f541 + Math_fround(f493 + f31));
      f52 = Math_fround(f540 + Math_fround(f492 + f32));
      f53 = Math_fround(f539 + Math_fround(f491 + f33));
      f54 = Math_fround(f538 + Math_fround(f490 + f34));
      f489 = Math_fround(f86 * f489);
      f488 = Math_fround(f86 * f488);
      f487 = Math_fround(f86 * f487);
      f497 = Math_fround(f86 * f497);
      f35 = Math_fround(f87 * f35);
      f36 = Math_fround(f87 * f36);
      f37 = Math_fround(f87 * f37);
      f38 = Math_fround(f87 * f38);
      f537 = Math_fround(f342 * f537);
      f536 = Math_fround(f342 * f536);
      f535 = Math_fround(f342 * f535);
      f546 = Math_fround(f342 * f546);
      f55 = Math_fround(f537 + Math_fround(f489 + f35));
      f56 = Math_fround(f536 + Math_fround(f488 + f36));
      f57 = Math_fround(f535 + Math_fround(f487 + f37));
      f58 = Math_fround(f546 + Math_fround(f497 + f38));
      f10 = Math_fround(f10 + f39);
      f25 = Math_fround(f25 + f40);
      f26 = Math_fround(f534 + f41);
      f486 = Math_fround(f486 + f42);
      f534 = Math_fround(f80 * f10);
      f533 = Math_fround(f80 * f25);
      f532 = Math_fround(f80 * f26);
      f5 = Math_fround(f80 * f486);
      f27 = Math_fround(f547 + Math_fround(f534 + f27));
      f28 = Math_fround(f544 + Math_fround(f533 + f28));
      f29 = Math_fround(f543 + Math_fround(f532 + f29));
      f30 = Math_fround(f542 + Math_fround(f5 + f30));
      f6 = Math_fround(f83 * f10);
      f7 = Math_fround(f83 * f25);
      f8 = Math_fround(f83 * f26);
      f9 = Math_fround(f83 * f486);
      f31 = Math_fround(f541 + Math_fround(f6 + f31));
      f32 = Math_fround(f540 + Math_fround(f7 + f32));
      f33 = Math_fround(f539 + Math_fround(f8 + f33));
      f34 = Math_fround(f538 + Math_fround(f9 + f34));
      f10 = Math_fround(f86 * f10);
      f25 = Math_fround(f86 * f25);
      f26 = Math_fround(f86 * f26);
      f486 = Math_fround(f86 * f486);
      f35 = Math_fround(f537 + Math_fround(f10 + f35));
      f36 = Math_fround(f536 + Math_fround(f25 + f36));
      f37 = Math_fround(f535 + Math_fround(f26 + f37));
      f38 = Math_fround(f546 + Math_fround(f486 + f38));
      f506 = Math_fround(f506 - f43);
      f507 = Math_fround(f507 - f44);
      f508 = Math_fround(f508 - f45);
      f509 = Math_fround(f509 - f46);
      f498 = Math_fround(f81 * f506);
      f499 = Math_fround(f81 * f507);
      f500 = Math_fround(f81 * f508);
      f501 = Math_fround(f81 * f509);
      f534 = Math_fround(f547 + Math_fround(f534 + f498));
      f533 = Math_fround(f544 + Math_fround(f533 + f499));
      f532 = Math_fround(f543 + Math_fround(f532 + f500));
      f5 = Math_fround(f542 + Math_fround(f5 + f501));
      f502 = Math_fround(f84 * f506);
      f503 = Math_fround(f84 * f507);
      f504 = Math_fround(f84 * f508);
      f505 = Math_fround(f84 * f509);
      f6 = Math_fround(f541 + Math_fround(f6 + f502));
      f7 = Math_fround(f540 + Math_fround(f7 + f503));
      f8 = Math_fround(f539 + Math_fround(f8 + f504));
      f9 = Math_fround(f538 + Math_fround(f9 + f505));
      f506 = Math_fround(f87 * f506);
      f507 = Math_fround(f87 * f507);
      f508 = Math_fround(f87 * f508);
      f509 = Math_fround(f87 * f509);
      f10 = Math_fround(f537 + Math_fround(f10 + f506));
      f25 = Math_fround(f536 + Math_fround(f25 + f507));
      f26 = Math_fround(f535 + Math_fround(f26 + f508));
      f486 = Math_fround(f546 + Math_fround(f486 + f509));
      f498 = Math_fround(f547 + Math_fround(f545 + f498));
      f499 = Math_fround(f544 + Math_fround(f496 + f499));
      f500 = Math_fround(f543 + Math_fround(f495 + f500));
      f501 = Math_fround(f542 + Math_fround(f494 + f501));
      f502 = Math_fround(f541 + Math_fround(f493 + f502));
      f503 = Math_fround(f540 + Math_fround(f492 + f503));
      f504 = Math_fround(f539 + Math_fround(f491 + f504));
      f505 = Math_fround(f538 + Math_fround(f490 + f505));
      f506 = Math_fround(f537 + Math_fround(f489 + f506));
      f507 = Math_fround(f536 + Math_fround(f488 + f507));
      f508 = Math_fround(f535 + Math_fround(f487 + f508));
      f509 = Math_fround(f546 + Math_fround(f497 + f509));
      f497 = Math_fround(HEAPF32[i517 >> 2]);
      f546 = Math_fround(f497 + f47);
      f487 = Math_fround(HEAPF32[i226 >> 2]);
      f535 = Math_fround(f487 + f48);
      f488 = Math_fround(HEAPF32[i227 >> 2]);
      f536 = Math_fround(f488 + f49);
      f489 = Math_fround(HEAPF32[i228 >> 2]);
      f537 = Math_fround(f489 + f50);
      f490 = Math_fround(HEAPF32[i229 >> 2]);
      f538 = Math_fround(f490 + f51);
      f491 = Math_fround(HEAPF32[i230 >> 2]);
      f539 = Math_fround(f491 + f52);
      f492 = Math_fround(HEAPF32[i231 >> 2]);
      f540 = Math_fround(f492 + f53);
      f493 = Math_fround(HEAPF32[i232 >> 2]);
      f541 = Math_fround(f493 + f54);
      f494 = Math_fround(HEAPF32[i233 >> 2]);
      f542 = Math_fround(f494 + f55);
      f495 = Math_fround(HEAPF32[i234 >> 2]);
      f543 = Math_fround(f495 + f56);
      f496 = Math_fround(HEAPF32[i235 >> 2]);
      f544 = Math_fround(f496 + f57);
      f545 = Math_fround(f79 + f58);
      HEAPF32[i524 >> 2] = f546;
      HEAPF32[i237 >> 2] = f535;
      HEAPF32[i238 >> 2] = f536;
      HEAPF32[i239 >> 2] = f537;
      HEAPF32[i240 >> 2] = f538;
      HEAPF32[i241 >> 2] = f539;
      HEAPF32[i242 >> 2] = f540;
      HEAPF32[i243 >> 2] = f541;
      HEAPF32[i244 >> 2] = f542;
      HEAPF32[i245 >> 2] = f543;
      HEAPF32[i246 >> 2] = f544;
      HEAPF32[i247 >> 2] = f545;
      f545 = Math_fround(f487 + f28);
      f544 = Math_fround(f488 + f29);
      f543 = Math_fround(f489 + f30);
      f542 = Math_fround(f490 + f31);
      f541 = Math_fround(f491 + f32);
      f540 = Math_fround(f492 + f33);
      f539 = Math_fround(f493 + f34);
      f538 = Math_fround(f494 + f35);
      f537 = Math_fround(f495 + f36);
      f536 = Math_fround(f496 + f37);
      f535 = Math_fround(f79 + f38);
      HEAPF32[i248 >> 2] = Math_fround(f497 + f27);
      HEAPF32[i249 >> 2] = f545;
      HEAPF32[i250 >> 2] = f544;
      HEAPF32[i251 >> 2] = f543;
      HEAPF32[i252 >> 2] = f542;
      HEAPF32[i253 >> 2] = f541;
      HEAPF32[i254 >> 2] = f540;
      HEAPF32[i255 >> 2] = f539;
      HEAPF32[i256 >> 2] = f538;
      HEAPF32[i257 >> 2] = f537;
      HEAPF32[i258 >> 2] = f536;
      HEAPF32[i259 >> 2] = f535;
      f533 = Math_fround(f487 + f533);
      f532 = Math_fround(f488 + f532);
      f5 = Math_fround(f489 + f5);
      f6 = Math_fround(f490 + f6);
      f7 = Math_fround(f491 + f7);
      f8 = Math_fround(f492 + f8);
      f9 = Math_fround(f493 + f9);
      f10 = Math_fround(f494 + f10);
      f25 = Math_fround(f495 + f25);
      f26 = Math_fround(f496 + f26);
      f486 = Math_fround(f79 + f486);
      HEAPF32[i260 >> 2] = Math_fround(f497 + f534);
      HEAPF32[i261 >> 2] = f533;
      HEAPF32[i262 >> 2] = f532;
      HEAPF32[i263 >> 2] = f5;
      HEAPF32[i264 >> 2] = f6;
      HEAPF32[i265 >> 2] = f7;
      HEAPF32[i266 >> 2] = f8;
      HEAPF32[i267 >> 2] = f9;
      HEAPF32[i268 >> 2] = f10;
      HEAPF32[i269 >> 2] = f25;
      HEAPF32[i270 >> 2] = f26;
      HEAPF32[i271 >> 2] = f486;
      f499 = Math_fround(f487 + f499);
      f500 = Math_fround(f488 + f500);
      f501 = Math_fround(f489 + f501);
      f502 = Math_fround(f490 + f502);
      f503 = Math_fround(f491 + f503);
      f504 = Math_fround(f492 + f504);
      f505 = Math_fround(f493 + f505);
      f506 = Math_fround(f494 + f506);
      f507 = Math_fround(f495 + f507);
      f508 = Math_fround(f496 + f508);
      f509 = Math_fround(f79 + f509);
      HEAPF32[i272 >> 2] = Math_fround(f497 + f498);
      HEAPF32[i273 >> 2] = f499;
      HEAPF32[i274 >> 2] = f500;
      HEAPF32[i275 >> 2] = f501;
      HEAPF32[i276 >> 2] = f502;
      HEAPF32[i277 >> 2] = f503;
      HEAPF32[i278 >> 2] = f504;
      HEAPF32[i279 >> 2] = f505;
      HEAPF32[i280 >> 2] = f506;
      HEAPF32[i281 >> 2] = f507;
      HEAPF32[i282 >> 2] = f508;
      HEAPF32[i283 >> 2] = f509;
      if (!i284) {
       i2 = HEAP32[i485 >> 2] | 0;
       if (i2 & 536870912) {
        f547 = Math_fround(HEAPF32[i118 >> 2]);
        i67 = HEAP32[i515 >> 2] | 0;
        i78 = i67 + 693089735 | 0;
        i65 = HEAP32[i217 >> 2] | 0;
        i75 = i65 + 693089735 | 0;
        i63 = HEAP32[i218 >> 2] | 0;
        i72 = i63 + 693089735 | 0;
        i61 = HEAP32[i219 >> 2] | 0;
        i69 = i61 + 693089735 | 0;
        i62 = (Math_imul(i78, 1790253981) | 0) + 1900727103 | 0;
        i64 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
        i66 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i68 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
        i78 = i78 << 11 ^ i78;
        i75 = i75 << 11 ^ i75;
        i72 = i72 << 11 ^ i72;
        i69 = i69 << 11 ^ i69;
        i62 = Math_fround(Math_fround((i62 ^ i78 ^ i78 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i64 = Math_fround(Math_fround((i64 ^ i75 ^ i75 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i66 = Math_fround(Math_fround((i66 ^ i72 ^ i72 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i68 = Math_fround(Math_fround((i68 ^ i69 ^ i69 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        f547 = Math_fround(HEAPF32[i89 >> 2]);
        i67 = i67 + 13945730 | 0;
        i65 = i65 + 13945730 | 0;
        i63 = i63 + 13945730 | 0;
        i61 = i61 + 13945730 | 0;
        i69 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
        i72 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
        i78 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
        i67 = i67 << 11 ^ i67;
        i65 = i65 << 11 ^ i65;
        i63 = i63 << 11 ^ i63;
        i61 = i61 << 11 ^ i61;
        i69 = Math_fround(Math_fround((i69 ^ i67 ^ i67 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i72 = Math_fround(Math_fround((i72 ^ i65 ^ i65 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i75 = Math_fround(Math_fround((i75 ^ i63 ^ i63 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i78 = Math_fround(Math_fround((i78 ^ i61 ^ i61 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f547;
        i61 = i62 & 1;
        i63 = i64 & 1;
        i65 = i66 & 1;
        i67 = i68 & 1;
        i70 = i61 ^ 1;
        i73 = i63 ^ 1;
        i76 = i65 ^ 1;
        i510 = i67 ^ 1;
        i71 = i62 ? 3 : 2;
        i74 = i64 ? 3 : 2;
        i77 = i66 ? 3 : 2;
        i2 = i68 ? 3 : 2;
        i62 = i62 ? 2 : 3;
        i64 = i64 ? 2 : 3;
        i66 = i66 ? 2 : 3;
        i68 = i68 ? 2 : 3;
        HEAP32[i521 >> 2] = i69 ? i62 : i61;
        HEAP32[i454 >> 2] = i72 ? i64 : i63;
        HEAP32[i453 >> 2] = i75 ? i66 : i65;
        HEAP32[i452 >> 2] = i78 ? i68 : i67;
        HEAP32[i439 >> 2] = i69 ? i61 : i62;
        HEAP32[i438 >> 2] = i72 ? i63 : i64;
        HEAP32[i437 >> 2] = i75 ? i65 : i66;
        HEAP32[i463 >> 2] = i78 ? i67 : i68;
        HEAP32[i458 >> 2] = i69 ? i71 : i70;
        HEAP32[i457 >> 2] = i72 ? i74 : i73;
        HEAP32[i456 >> 2] = i75 ? i77 : i76;
        HEAP32[i455 >> 2] = i78 ? i2 : i510;
        HEAP32[i462 >> 2] = i69 ? i70 : i71;
        HEAP32[i461 >> 2] = i72 ? i73 : i74;
        HEAP32[i460 >> 2] = i75 ? i76 : i77;
        HEAP32[i459 >> 2] = i78 ? i510 : i2;
        i2 = HEAP32[i485 >> 2] | 0;
       }
       if (i2 & 268435456 | 0) {
        f5 = Math_fround(f476 * Math_fround(HEAPF32[i516 >> 2]));
        f6 = Math_fround(f476 * Math_fround(HEAPF32[i221 >> 2]));
        f7 = Math_fround(f476 * Math_fround(HEAPF32[i222 >> 2]));
        f8 = Math_fround(f476 * Math_fround(HEAPF32[i223 >> 2]));
        f9 = Math_fround(Math_floor(Math_fround(f5)));
        f10 = Math_fround(Math_floor(Math_fround(f6)));
        f25 = Math_fround(Math_floor(Math_fround(f7)));
        f26 = Math_fround(Math_floor(Math_fround(f8)));
        if (i2 & 16777216 | 0) {
         f544 = Math_fround(Math_floor(Math_fround(f475 * f9)));
         f545 = Math_fround(Math_floor(Math_fround(f475 * f10)));
         f546 = Math_fround(Math_floor(Math_fround(f475 * f25)));
         f547 = Math_fround(Math_floor(Math_fround(f475 * f26)));
         f540 = Math_fround(f477 * Math_fround(f9 - Math_fround(f474 * f544)));
         f541 = Math_fround(f477 * Math_fround(f10 - Math_fround(f474 * f545)));
         f542 = Math_fround(f477 * Math_fround(f25 - Math_fround(f474 * f546)));
         f543 = Math_fround(f477 * Math_fround(f26 - Math_fround(f474 * f547)));
         f544 = Math_fround(f479 - Math_fround(f478 * f544));
         f545 = Math_fround(f479 - Math_fround(f478 * f545));
         f546 = Math_fround(f479 - Math_fround(f478 * f546));
         f547 = Math_fround(f479 - Math_fround(f478 * f547));
         f532 = Math_fround(f478 + f544);
         f533 = Math_fround(f478 + f545);
         f534 = Math_fround(f478 + f546);
         f535 = Math_fround(f478 + f547);
         HEAPF32[i522 >> 2] = f540;
         HEAPF32[i388 >> 2] = f541;
         HEAPF32[i412 >> 2] = f542;
         HEAPF32[i436 >> 2] = f543;
         HEAPF32[i364 >> 2] = f532;
         HEAPF32[i387 >> 2] = f533;
         HEAPF32[i411 >> 2] = f534;
         HEAPF32[i435 >> 2] = f535;
         f536 = Math_fround(f477 + f540);
         f537 = Math_fround(f477 + f541);
         f538 = Math_fround(f477 + f542);
         f539 = Math_fround(f477 + f543);
         HEAPF32[i363 >> 2] = f536;
         HEAPF32[i386 >> 2] = f537;
         HEAPF32[i410 >> 2] = f538;
         HEAPF32[i434 >> 2] = f539;
         HEAPF32[i362 >> 2] = f532;
         HEAPF32[i385 >> 2] = f533;
         HEAPF32[i409 >> 2] = f534;
         HEAPF32[i433 >> 2] = f535;
         HEAPF32[i361 >> 2] = f536;
         HEAPF32[i384 >> 2] = f537;
         HEAPF32[i408 >> 2] = f538;
         HEAPF32[i432 >> 2] = f539;
         HEAPF32[i360 >> 2] = f544;
         HEAPF32[i383 >> 2] = f545;
         HEAPF32[i407 >> 2] = f546;
         HEAPF32[i431 >> 2] = f547;
         HEAPF32[i359 >> 2] = f540;
         HEAPF32[i382 >> 2] = f541;
         HEAPF32[i406 >> 2] = f542;
         HEAPF32[i430 >> 2] = f543;
         HEAPF32[i358 >> 2] = f544;
         HEAPF32[i381 >> 2] = f545;
         HEAPF32[i405 >> 2] = f546;
         HEAPF32[i429 >> 2] = f547;
        }
        if (i2 & 33554432 | 0) {
         f536 = Math_fround(f9 + Math_fround(1.0));
         f537 = Math_fround(f10 + Math_fround(1.0));
         f538 = Math_fround(f25 + Math_fround(1.0));
         f539 = Math_fround(f26 + Math_fround(1.0));
         f544 = Math_fround(f5 - f9);
         f545 = Math_fround(f6 - f10);
         f546 = Math_fround(f7 - f25);
         f547 = Math_fround(f8 - f26);
         f540 = Math_fround(Math_floor(Math_fround(f475 * f536)));
         f541 = Math_fround(Math_floor(Math_fround(f475 * f537)));
         f542 = Math_fround(Math_floor(Math_fround(f475 * f538)));
         f543 = Math_fround(Math_floor(Math_fround(f475 * f539)));
         f536 = Math_fround(f477 * Math_fround(f536 - Math_fround(f474 * f540)));
         f537 = Math_fround(f477 * Math_fround(f537 - Math_fround(f474 * f541)));
         f538 = Math_fround(f477 * Math_fround(f538 - Math_fround(f474 * f542)));
         f539 = Math_fround(f477 * Math_fround(f539 - Math_fround(f474 * f543)));
         f540 = Math_fround(f479 - Math_fround(f478 * f540));
         f541 = Math_fround(f479 - Math_fround(f478 * f541));
         f542 = Math_fround(f479 - Math_fround(f478 * f542));
         f543 = Math_fround(f479 - Math_fround(f478 * f543));
         f506 = Math_fround(f478 + f540);
         f507 = Math_fround(f478 + f541);
         f508 = Math_fround(f478 + f542);
         f509 = Math_fround(f478 + f543);
         HEAPF32[i523 >> 2] = f536;
         HEAPF32[i380 >> 2] = f537;
         HEAPF32[i404 >> 2] = f538;
         HEAPF32[i428 >> 2] = f539;
         HEAPF32[i357 >> 2] = f506;
         HEAPF32[i379 >> 2] = f507;
         HEAPF32[i403 >> 2] = f508;
         HEAPF32[i427 >> 2] = f509;
         HEAPF32[i356 >> 2] = f544;
         HEAPF32[i378 >> 2] = f545;
         HEAPF32[i402 >> 2] = f546;
         HEAPF32[i426 >> 2] = f547;
         HEAPF32[i355 >> 2] = f5;
         HEAPF32[i377 >> 2] = f6;
         HEAPF32[i401 >> 2] = f7;
         HEAPF32[i425 >> 2] = f8;
         f532 = Math_fround(f477 + f536);
         f533 = Math_fround(f477 + f537);
         f534 = Math_fround(f477 + f538);
         f535 = Math_fround(f477 + f539);
         HEAPF32[i354 >> 2] = f532;
         HEAPF32[i376 >> 2] = f533;
         HEAPF32[i400 >> 2] = f534;
         HEAPF32[i424 >> 2] = f535;
         HEAPF32[i353 >> 2] = f506;
         HEAPF32[i375 >> 2] = f507;
         HEAPF32[i399 >> 2] = f508;
         HEAPF32[i423 >> 2] = f509;
         HEAPF32[i352 >> 2] = f544;
         HEAPF32[i374 >> 2] = f545;
         HEAPF32[i398 >> 2] = f546;
         HEAPF32[i422 >> 2] = f547;
         HEAPF32[i351 >> 2] = f5;
         HEAPF32[i373 >> 2] = f6;
         HEAPF32[i397 >> 2] = f7;
         HEAPF32[i421 >> 2] = f8;
         HEAPF32[i350 >> 2] = f532;
         HEAPF32[i372 >> 2] = f533;
         HEAPF32[i396 >> 2] = f534;
         HEAPF32[i420 >> 2] = f535;
         HEAPF32[i349 >> 2] = f540;
         HEAPF32[i371 >> 2] = f541;
         HEAPF32[i395 >> 2] = f542;
         HEAPF32[i419 >> 2] = f543;
         HEAPF32[i348 >> 2] = f544;
         HEAPF32[i370 >> 2] = f545;
         HEAPF32[i394 >> 2] = f546;
         HEAPF32[i418 >> 2] = f547;
         HEAPF32[i347 >> 2] = f5;
         HEAPF32[i369 >> 2] = f6;
         HEAPF32[i393 >> 2] = f7;
         HEAPF32[i417 >> 2] = f8;
         HEAPF32[i346 >> 2] = f536;
         HEAPF32[i368 >> 2] = f537;
         HEAPF32[i392 >> 2] = f538;
         HEAPF32[i416 >> 2] = f539;
         HEAPF32[i345 >> 2] = f540;
         HEAPF32[i367 >> 2] = f541;
         HEAPF32[i391 >> 2] = f542;
         HEAPF32[i415 >> 2] = f543;
         HEAPF32[i344 >> 2] = f544;
         HEAPF32[i366 >> 2] = f545;
         HEAPF32[i390 >> 2] = f546;
         HEAPF32[i414 >> 2] = f547;
         HEAPF32[i343 >> 2] = f5;
         HEAPF32[i365 >> 2] = f6;
         HEAPF32[i389 >> 2] = f7;
         HEAPF32[i413 >> 2] = f8;
        }
       }
      }
      f532 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
      f533 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
      f534 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
      f535 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
      f502 = Math_fround(f480 * Math_fround(f47 * f532));
      f503 = Math_fround(f480 * Math_fround(f48 * f533));
      f504 = Math_fround(f480 * Math_fround(f49 * f534));
      f505 = Math_fround(f480 * Math_fround(f50 * f535));
      f506 = Math_fround(f480 * Math_fround(f51 * f532));
      f507 = Math_fround(f480 * Math_fround(f52 * f533));
      f508 = Math_fround(f480 * Math_fround(f53 * f534));
      f509 = Math_fround(f480 * Math_fround(f54 * f535));
      f532 = Math_fround(f480 * Math_fround(f55 * f532));
      f533 = Math_fround(f480 * Math_fround(f56 * f533));
      f534 = Math_fround(f480 * Math_fround(f57 * f534));
      f535 = Math_fround(f480 * Math_fround(f58 * f535));
      f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f35 * f35) + Math_fround(Math_fround(f27 * f27) + Math_fround(f31 * f31))))));
      f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f36 * f36) + Math_fround(Math_fround(f28 * f28) + Math_fround(f32 * f32))))));
      f546 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f37 * f37) + Math_fround(Math_fround(f29 * f29) + Math_fround(f33 * f33))))));
      f547 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f38 * f38) + Math_fround(Math_fround(f30 * f30) + Math_fround(f34 * f34))))));
      f536 = Math_fround(f480 * Math_fround(f27 * f544));
      f537 = Math_fround(f480 * Math_fround(f28 * f545));
      f538 = Math_fround(f480 * Math_fround(f29 * f546));
      f539 = Math_fround(f480 * Math_fround(f30 * f547));
      f540 = Math_fround(f480 * Math_fround(f31 * f544));
      f541 = Math_fround(f480 * Math_fround(f32 * f545));
      f542 = Math_fround(f480 * Math_fround(f33 * f546));
      f543 = Math_fround(f480 * Math_fround(f34 * f547));
      f544 = Math_fround(f480 * Math_fround(f35 * f544));
      f545 = Math_fround(f480 * Math_fround(f36 * f545));
      f546 = Math_fround(f480 * Math_fround(f37 * f546));
      f547 = Math_fround(f480 * Math_fround(f38 * f547));
      f501 = Math_fround(f472 + f503);
      f500 = Math_fround(f472 + f504);
      f499 = Math_fround(f472 + f505);
      f498 = Math_fround(f466 + f506);
      f497 = Math_fround(f466 + f507);
      f496 = Math_fround(f466 + f508);
      f495 = Math_fround(f466 + f509);
      f494 = Math_fround(f468 + f532);
      f493 = Math_fround(f468 + f533);
      f492 = Math_fround(f468 + f534);
      f491 = Math_fround(f468 + f535);
      HEAPF32[i525 >> 2] = Math_fround(f472 + f502);
      HEAPF32[i133 >> 2] = f501;
      HEAPF32[i150 >> 2] = f500;
      HEAPF32[i167 >> 2] = f499;
      HEAPF32[i285 >> 2] = f498;
      HEAPF32[i128 >> 2] = f497;
      HEAPF32[i145 >> 2] = f496;
      HEAPF32[i162 >> 2] = f495;
      HEAPF32[i286 >> 2] = f494;
      HEAPF32[i123 >> 2] = f493;
      HEAPF32[i140 >> 2] = f492;
      HEAPF32[i157 >> 2] = f491;
      f491 = Math_fround(f472 + f537);
      f492 = Math_fround(f472 + f538);
      f493 = Math_fround(f472 + f539);
      f494 = Math_fround(f466 + f540);
      f495 = Math_fround(f466 + f541);
      f496 = Math_fround(f466 + f542);
      f497 = Math_fround(f466 + f543);
      f498 = Math_fround(f468 + f544);
      f499 = Math_fround(f468 + f545);
      f500 = Math_fround(f468 + f546);
      f501 = Math_fround(f468 + f547);
      HEAPF32[i287 >> 2] = Math_fround(f472 + f536);
      HEAPF32[i132 >> 2] = f491;
      HEAPF32[i149 >> 2] = f492;
      HEAPF32[i166 >> 2] = f493;
      HEAPF32[i288 >> 2] = f494;
      HEAPF32[i127 >> 2] = f495;
      HEAPF32[i144 >> 2] = f496;
      HEAPF32[i161 >> 2] = f497;
      HEAPF32[i289 >> 2] = f498;
      HEAPF32[i122 >> 2] = f499;
      HEAPF32[i139 >> 2] = f500;
      HEAPF32[i156 >> 2] = f501;
      f503 = Math_fround(f472 - f503);
      f504 = Math_fround(f472 - f504);
      f505 = Math_fround(f472 - f505);
      f506 = Math_fround(f466 - f506);
      f507 = Math_fround(f466 - f507);
      f508 = Math_fround(f466 - f508);
      f509 = Math_fround(f466 - f509);
      f532 = Math_fround(f468 - f532);
      f533 = Math_fround(f468 - f533);
      f534 = Math_fround(f468 - f534);
      f535 = Math_fround(f468 - f535);
      HEAPF32[i290 >> 2] = Math_fround(f472 - f502);
      HEAPF32[i131 >> 2] = f503;
      HEAPF32[i148 >> 2] = f504;
      HEAPF32[i165 >> 2] = f505;
      HEAPF32[i291 >> 2] = f506;
      HEAPF32[i126 >> 2] = f507;
      HEAPF32[i143 >> 2] = f508;
      HEAPF32[i160 >> 2] = f509;
      HEAPF32[i292 >> 2] = f532;
      HEAPF32[i121 >> 2] = f533;
      HEAPF32[i138 >> 2] = f534;
      HEAPF32[i155 >> 2] = f535;
      f537 = Math_fround(f472 - f537);
      f538 = Math_fround(f472 - f538);
      f539 = Math_fround(f472 - f539);
      f540 = Math_fround(f466 - f540);
      f541 = Math_fround(f466 - f541);
      f542 = Math_fround(f466 - f542);
      f543 = Math_fround(f466 - f543);
      f544 = Math_fround(f468 - f544);
      f545 = Math_fround(f468 - f545);
      f546 = Math_fround(f468 - f546);
      f547 = Math_fround(f468 - f547);
      HEAPF32[i293 >> 2] = Math_fround(f472 - f536);
      HEAPF32[i130 >> 2] = f537;
      HEAPF32[i147 >> 2] = f538;
      HEAPF32[i164 >> 2] = f539;
      HEAPF32[i294 >> 2] = f540;
      HEAPF32[i125 >> 2] = f541;
      HEAPF32[i142 >> 2] = f542;
      HEAPF32[i159 >> 2] = f543;
      HEAPF32[i295 >> 2] = f544;
      HEAPF32[i120 >> 2] = f545;
      HEAPF32[i137 >> 2] = f546;
      HEAPF32[i154 >> 2] = f547;
      do if (i171) {
       i4 = HEAP32[i193 >> 2] | 0;
       i11 = HEAP32[i528 >> 2] | 0;
       if (!i4) {
        i2 = 0;
        i3 = i1;
        while (1) {
         i510 = i11 + (i2 + i88 << 2) | 0;
         HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
         HEAP32[i3 + 24 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 28 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 32 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 36 >> 2] = HEAP32[i248 + (i2 << 2) >> 2];
         HEAP32[i3 + 40 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
         HEAP32[i3 + 44 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
         HEAP32[i3 + 48 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
         HEAP32[i3 + 52 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
         HEAP32[i3 + 56 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
         HEAP32[i3 + 60 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 64 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 68 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 72 >> 2] = HEAP32[i260 + (i2 << 2) >> 2];
         HEAP32[i3 + 76 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
         HEAP32[i3 + 80 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
         HEAP32[i3 + 84 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
         HEAP32[i3 + 88 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
         HEAP32[i3 + 92 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
         HEAP32[i3 + 96 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 100 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 104 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 108 >> 2] = HEAP32[i272 + (i2 << 2) >> 2];
         HEAP32[i3 + 112 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
         HEAP32[i3 + 116 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
         HEAP32[i3 + 120 >> 2] = HEAP32[i293 + (i2 << 2) >> 2];
         HEAP32[i3 + 124 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
         HEAP32[i3 + 128 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
         HEAP32[i3 + 132 >> 2] = HEAP32[i510 >> 2];
         i510 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 136 >> 2] = HEAP32[i510 + (i2 << 2) >> 2];
         HEAP32[i3 + 140 >> 2] = HEAP32[i510 + 16 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
        }
        i1 = i1 + 576 | 0;
        break;
       } else {
        i2 = 0;
        i3 = i1;
        while (1) {
         i510 = i11 + (HEAP32[i4 + (i2 + i88 << 3) >> 2] << 2) | 0;
         HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
         HEAP32[i3 + 24 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 28 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 32 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 36 >> 2] = HEAP32[i248 + (i2 << 2) >> 2];
         HEAP32[i3 + 40 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
         HEAP32[i3 + 44 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
         HEAP32[i3 + 48 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
         HEAP32[i3 + 52 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
         HEAP32[i3 + 56 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
         HEAP32[i3 + 60 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 64 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 68 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 72 >> 2] = HEAP32[i260 + (i2 << 2) >> 2];
         HEAP32[i3 + 76 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
         HEAP32[i3 + 80 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
         HEAP32[i3 + 84 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
         HEAP32[i3 + 88 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
         HEAP32[i3 + 92 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
         HEAP32[i3 + 96 >> 2] = HEAP32[i510 >> 2];
         i78 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 100 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 104 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 108 >> 2] = HEAP32[i272 + (i2 << 2) >> 2];
         HEAP32[i3 + 112 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
         HEAP32[i3 + 116 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
         HEAP32[i3 + 120 >> 2] = HEAP32[i293 + (i2 << 2) >> 2];
         HEAP32[i3 + 124 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
         HEAP32[i3 + 128 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
         HEAP32[i3 + 132 >> 2] = HEAP32[i510 >> 2];
         i510 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 136 >> 2] = HEAP32[i510 + (i2 << 2) >> 2];
         HEAP32[i3 + 140 >> 2] = HEAP32[i510 + 16 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
        }
        i1 = i1 + 576 | 0;
        break;
       }
      } else {
       f535 = Math_fround(HEAPF32[i248 >> 2]);
       f535 = Math_fround(f535 - Math_fround(HEAPF32[i524 >> 2]));
       f537 = Math_fround(HEAPF32[i249 >> 2]);
       f537 = Math_fround(f537 - Math_fround(HEAPF32[i237 >> 2]));
       f538 = Math_fround(HEAPF32[i250 >> 2]);
       f538 = Math_fround(f538 - Math_fround(HEAPF32[i238 >> 2]));
       f539 = Math_fround(HEAPF32[i251 >> 2]);
       f539 = Math_fround(f539 - Math_fround(HEAPF32[i239 >> 2]));
       f540 = Math_fround(HEAPF32[i252 >> 2]);
       f540 = Math_fround(f540 - Math_fround(HEAPF32[i240 >> 2]));
       f547 = Math_fround(HEAPF32[i253 >> 2]);
       f547 = Math_fround(f547 - Math_fround(HEAPF32[i241 >> 2]));
       f546 = Math_fround(HEAPF32[i254 >> 2]);
       f546 = Math_fround(f546 - Math_fround(HEAPF32[i242 >> 2]));
       f545 = Math_fround(HEAPF32[i255 >> 2]);
       f545 = Math_fround(f545 - Math_fround(HEAPF32[i243 >> 2]));
       f544 = Math_fround(HEAPF32[i256 >> 2]);
       f544 = Math_fround(f544 - Math_fround(HEAPF32[i244 >> 2]));
       f532 = Math_fround(HEAPF32[i257 >> 2]);
       f532 = Math_fround(f532 - Math_fround(HEAPF32[i245 >> 2]));
       f533 = Math_fround(HEAPF32[i258 >> 2]);
       f533 = Math_fround(f533 - Math_fround(HEAPF32[i246 >> 2]));
       f534 = Math_fround(HEAPF32[i259 >> 2]);
       f534 = Math_fround(f534 - Math_fround(HEAPF32[i247 >> 2]));
       f536 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f535 * f535) + Math_fround(f540 * f540)) + Math_fround(f544 * f544)))));
       f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f537 * f537) + Math_fround(f547 * f547)) + Math_fround(f532 * f532)))));
       f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f538 * f538) + Math_fround(f546 * f546)) + Math_fround(f533 * f533)))));
       f541 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f539 * f539) + Math_fround(f545 * f545)) + Math_fround(f534 * f534)))));
       f537 = Math_fround(f537 * f543);
       f538 = Math_fround(f538 * f542);
       f539 = Math_fround(f539 * f541);
       f540 = Math_fround(f540 * f536);
       f547 = Math_fround(f547 * f543);
       f546 = Math_fround(f546 * f542);
       f545 = Math_fround(f545 * f541);
       f544 = Math_fround(f544 * f536);
       f543 = Math_fround(f532 * f543);
       f542 = Math_fround(f533 * f542);
       f541 = Math_fround(f534 * f541);
       HEAPF32[i518 >> 2] = Math_fround(f535 * f536);
       HEAPF32[i134 >> 2] = f537;
       HEAPF32[i151 >> 2] = f538;
       HEAPF32[i168 >> 2] = f539;
       HEAPF32[i296 >> 2] = f540;
       HEAPF32[i129 >> 2] = f547;
       HEAPF32[i146 >> 2] = f546;
       HEAPF32[i163 >> 2] = f545;
       HEAPF32[i297 >> 2] = f544;
       HEAPF32[i124 >> 2] = f543;
       HEAPF32[i141 >> 2] = f542;
       HEAPF32[i158 >> 2] = f541;
       f541 = Math_fround(f40 * Math_fround(2.0));
       f542 = Math_fround(f41 * Math_fround(2.0));
       f543 = Math_fround(f42 * Math_fround(2.0));
       f544 = Math_fround(f43 * Math_fround(2.0));
       f545 = Math_fround(f44 * Math_fround(2.0));
       f546 = Math_fround(f45 * Math_fround(2.0));
       f547 = Math_fround(f46 * Math_fround(2.0));
       HEAPF32[i519 >> 2] = Math_fround(f39 * Math_fround(2.0));
       HEAPF32[i136 >> 2] = f541;
       HEAPF32[i153 >> 2] = f542;
       HEAPF32[i170 >> 2] = f543;
       HEAPF32[i298 >> 2] = f544;
       HEAPF32[i135 >> 2] = f545;
       HEAPF32[i152 >> 2] = f546;
       HEAPF32[i169 >> 2] = f547;
       HEAP32[i119 >> 2] = 0;
       HEAP32[i119 + 4 >> 2] = 0;
       HEAP32[i119 + 8 >> 2] = 0;
       HEAP32[i119 + 12 >> 2] = 0;
       if (i299) {
        f505 = Math_fround(HEAPF32[i530 >> 2]);
        f545 = Math_fround(f440 * f505);
        f507 = Math_fround(HEAPF32[i186 >> 2]);
        f536 = Math_fround(f440 * f507);
        f509 = Math_fround(HEAPF32[i185 >> 2]);
        f544 = Math_fround(f440 * f509);
        f533 = Math_fround(HEAPF32[i184 >> 2]);
        f539 = Math_fround(f440 * f533);
        f506 = Math_fround(HEAPF32[i202 >> 2]);
        f535 = Math_fround(f443 * f506);
        f508 = Math_fround(HEAPF32[i189 >> 2]);
        f541 = Math_fround(f443 * f508);
        f532 = Math_fround(HEAPF32[i188 >> 2]);
        f540 = Math_fround(f443 * f532);
        f534 = Math_fround(HEAPF32[i187 >> 2]);
        f535 = Math_fround(f545 + f535);
        f541 = Math_fround(f536 + f541);
        f540 = Math_fround(f544 + f540);
        f539 = Math_fround(f539 + Math_fround(f443 * f534));
        f544 = Math_fround(HEAPF32[i203 >> 2]);
        f536 = Math_fround(f446 * f544);
        f545 = Math_fround(HEAPF32[i192 >> 2]);
        f537 = Math_fround(f446 * f545);
        f546 = Math_fround(HEAPF32[i191 >> 2]);
        f538 = Math_fround(f446 * f546);
        f547 = Math_fround(HEAPF32[i190 >> 2]);
        f537 = Math_fround(f541 + f537);
        f538 = Math_fround(f540 + f538);
        f539 = Math_fround(f539 + Math_fround(f446 * f547));
        f540 = Math_fround(Math_fround(Math_fround(f441 * f505) + Math_fround(f444 * f506)) + Math_fround(f447 * f544));
        f541 = Math_fround(Math_fround(Math_fround(f441 * f507) + Math_fround(f444 * f508)) + Math_fround(f447 * f545));
        f542 = Math_fround(Math_fround(Math_fround(f441 * f509) + Math_fround(f444 * f532)) + Math_fround(f447 * f546));
        f543 = Math_fround(Math_fround(Math_fround(f441 * f533) + Math_fround(f444 * f534)) + Math_fround(f447 * f547));
        f544 = Math_fround(Math_fround(Math_fround(f442 * f505) + Math_fround(f445 * f506)) + Math_fround(f448 * f544));
        f545 = Math_fround(Math_fround(Math_fround(f442 * f507) + Math_fround(f445 * f508)) + Math_fround(f448 * f545));
        f546 = Math_fround(Math_fround(Math_fround(f442 * f509) + Math_fround(f445 * f532)) + Math_fround(f448 * f546));
        f547 = Math_fround(Math_fround(Math_fround(f442 * f533) + Math_fround(f445 * f534)) + Math_fround(f448 * f547));
        HEAPF32[i520 >> 2] = Math_fround(f535 + f536);
        HEAPF32[i300 >> 2] = f537;
        HEAPF32[i301 >> 2] = f538;
        HEAPF32[i302 >> 2] = f539;
        HEAPF32[i303 >> 2] = f540;
        HEAPF32[i304 >> 2] = f541;
        HEAPF32[i305 >> 2] = f542;
        HEAPF32[i306 >> 2] = f543;
        HEAPF32[i307 >> 2] = f544;
        HEAPF32[i308 >> 2] = f545;
        HEAPF32[i309 >> 2] = f546;
        HEAPF32[i310 >> 2] = f547;
       }
       if (i311) {
        i73 = HEAP32[i515 >> 2] | 0;
        i76 = i73 + 1068538453 | 0;
        i77 = HEAP32[i217 >> 2] | 0;
        i75 = i77 + 1068538453 | 0;
        i70 = HEAP32[i218 >> 2] | 0;
        i69 = i70 + 1068538453 | 0;
        i68 = HEAP32[i219 >> 2] | 0;
        i72 = i68 + 1068538453 | 0;
        i78 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
        i71 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
        i510 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
        i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i76 = i76 << 11 ^ i76;
        i75 = i75 << 11 ^ i75;
        i69 = i69 << 11 ^ i69;
        i72 = i72 << 11 ^ i72;
        f545 = Math_fround(Math_fround((i71 ^ i75 ^ i75 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f546 = Math_fround(Math_fround((i510 ^ i69 ^ i69 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f547 = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i526 >> 2] = Math_fround(Math_fround((i78 ^ i76 ^ i76 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i312 >> 2] = f545;
        HEAPF32[i313 >> 2] = f546;
        HEAPF32[i314 >> 2] = f547;
        i73 = i73 + 1068538454 | 0;
        i77 = i77 + 1068538454 | 0;
        i70 = i70 + 1068538454 | 0;
        i68 = i68 + 1068538454 | 0;
        i78 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
        i76 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
        i74 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
        i72 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
        i73 = i73 << 11 ^ i73;
        i77 = i77 << 11 ^ i77;
        i70 = i70 << 11 ^ i70;
        i68 = i68 << 11 ^ i68;
        f547 = Math_fround(Math_fround((i76 ^ i77 ^ i77 >>> 8) & 8388607 ^ i76 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f546 = Math_fround(Math_fround((i74 ^ i70 ^ i70 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f545 = Math_fround(Math_fround((i72 ^ i68 ^ i68 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i315 >> 2] = Math_fround(Math_fround((i78 ^ i73 ^ i73 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i316 >> 2] = f547;
        HEAPF32[i317 >> 2] = f546;
        HEAPF32[i318 >> 2] = f545;
        i78 = HEAP32[i515 >> 2] | 0;
        i73 = i78 + 1068538455 | 0;
        i72 = HEAP32[i217 >> 2] | 0;
        i68 = i72 + 1068538455 | 0;
        i74 = HEAP32[i218 >> 2] | 0;
        i70 = i74 + 1068538455 | 0;
        i76 = HEAP32[i219 >> 2] | 0;
        i77 = i76 + 1068538455 | 0;
        i510 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
        i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
        i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
        i73 = i73 << 11 ^ i73;
        i68 = i68 << 11 ^ i68;
        i70 = i70 << 11 ^ i70;
        i77 = i77 << 11 ^ i77;
        f545 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f546 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f547 = Math_fround(Math_fround((i75 ^ i77 ^ i77 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i319 >> 2] = Math_fround(Math_fround((i510 ^ i73 ^ i73 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i320 >> 2] = f545;
        HEAPF32[i321 >> 2] = f546;
        HEAPF32[i322 >> 2] = f547;
        f547 = Math_fround(Math_fround(HEAPF32[i514 >> 2]) * Math_fround(1.0e5));
        f546 = Math_fround(Math_fround(HEAPF32[i213 >> 2]) * Math_fround(1.0e5));
        f545 = Math_fround(Math_fround(HEAPF32[i214 >> 2]) * Math_fround(1.0e5));
        i78 = i78 + 1068538453 + ~~f547 | 0;
        i72 = i72 + 1068538453 + ~~f546 | 0;
        i74 = i74 + 1068538453 + ~~f545 | 0;
        i76 = i76 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i215 >> 2]) * Math_fround(1.0e5)) | 0;
        i510 = (Math_imul(i78, 1790253981) | 0) + 1900727103 | 0;
        i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
        i77 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
        i78 = i78 << 11 ^ i78;
        i72 = i72 << 11 ^ i72;
        i74 = i74 << 11 ^ i74;
        i76 = i76 << 11 ^ i76;
        f545 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f546 = Math_fround(Math_fround((i75 ^ i74 ^ i74 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f547 = Math_fround(Math_fround((i77 ^ i76 ^ i76 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i323 >> 2] = Math_fround(Math_fround((i510 ^ i78 ^ i78 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i324 >> 2] = f545;
        HEAPF32[i325 >> 2] = f546;
        HEAPF32[i326 >> 2] = f547;
       }
       i69 = HEAP32[i193 >> 2] | 0;
       i70 = (i69 | 0) == 0;
       i71 = HEAP32[i94 >> 2] | 0;
       i72 = HEAP32[i96 >> 2] | 0;
       i73 = HEAP32[i212 >> 2] | 0;
       i74 = HEAP32[i97 >> 2] | 0;
       i75 = HEAP32[i339 >> 2] | 0;
       i76 = HEAP32[i340 >> 2] | 0;
       i77 = HEAP32[i341 >> 2] | 0;
       i78 = HEAP32[i528 >> 2] | 0;
       i68 = 0;
       do {
        i2 = i68 + i88 | 0;
        if (!i70) i2 = HEAP32[i69 + (i2 << 3) >> 2] | 0;
        i11 = i520 + (i68 << 2) | 0;
        i12 = i334 + (i68 << 2) | 0;
        i13 = i335 + (i68 << 2) | 0;
        i14 = i526 + (i68 << 2) | 0;
        i15 = i315 + (i68 << 2) | 0;
        i16 = i319 + (i68 << 2) | 0;
        i17 = i323 + (i68 << 2) | 0;
        i18 = i518 + (i68 << 2) | 0;
        i19 = i91 + (i68 << 2) | 0;
        i20 = i92 + (i68 << 2) | 0;
        i21 = i71 + (i2 << 4) | 0;
        i22 = i72 + (i2 << 4) | 0;
        i23 = i73 + (i2 << 2) | 0;
        i24 = i74 + (i2 << 2) | 0;
        i59 = i75 + (i2 << 2) | 0;
        i60 = i76 + (i2 << 2) | 0;
        i61 = i77 + (i2 << 2) | 0;
        i62 = i519 + (i68 << 2) | 0;
        i63 = i98 + (i68 << 2) | 0;
        i64 = i99 + (i68 << 2) | 0;
        i65 = i517 + (i68 << 2) | 0;
        i66 = i100 + (i68 << 2) | 0;
        i67 = i101 + (i68 << 2) | 0;
        i4 = i78 + (i2 << 2) | 0;
        i3 = 0;
        i2 = i1;
        while (1) {
         i1 = i524 + (i3 * 48 | 0) | 0;
         HEAP32[i2 >> 2] = HEAP32[i1 + (i68 << 2) >> 2];
         HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i68 << 2) >> 2];
         HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i68 << 2) >> 2];
         i1 = i2 + 12 | 0;
         if (!i327) {
          i510 = i525 + (i3 * 48 | 0) | 0;
          HEAP32[i1 >> 2] = HEAP32[i510 + (i68 << 2) >> 2];
          HEAP32[i2 + 16 >> 2] = HEAP32[i510 + 16 + (i68 << 2) >> 2];
          HEAP32[i2 + 20 >> 2] = HEAP32[i510 + 32 + (i68 << 2) >> 2];
          i1 = i2 + 24 | 0;
         }
         if (!i328) {
          HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
          i1 = i1 + 4 | 0;
         }
         if (!i329) {
          i510 = i522 + (HEAP32[i521 + ((i3 << 2) + i68 << 2) >> 2] << 5) | 0;
          HEAP32[i1 >> 2] = HEAP32[i510 + (i68 << 2) >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 16 + (i68 << 2) >> 2];
          i1 = i1 + 8 | 0;
         }
         if (!i330) {
          i510 = i523 + (HEAP32[i521 + ((i3 << 2) + i68 << 2) >> 2] << 6) | 0;
          HEAP32[i1 >> 2] = HEAP32[i510 + (i68 << 2) >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 16 + (i68 << 2) >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 32 + (i68 << 2) >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 48 + (i68 << 2) >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i331) {
          f547 = Math_fround(i3 | 0);
          HEAP32[i1 >> 2] = HEAP32[i65 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i66 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i67 >> 2];
          HEAPF32[i1 + 12 >> 2] = f547;
          i1 = i1 + 16 | 0;
         }
         if (!i332) {
          HEAP32[i1 >> 2] = HEAP32[i62 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i63 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i64 >> 2];
          i1 = i1 + 12 | 0;
         }
         if (!i333) {
          i2 = HEAP32[i60 >> 2] | 0;
          i510 = HEAP32[i61 >> 2] | 0;
          HEAP32[i1 >> 2] = HEAP32[i59 >> 2];
          HEAP32[i1 + 4 >> 2] = i2;
          HEAP32[i1 + 8 >> 2] = i510;
          i1 = i1 + 12 | 0;
         }
         if (i299) {
          HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
          i1 = i1 + 12 | 0;
         }
         if (!i336) {
          f547 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
          i510 = HEAP32[i24 >> 2] | 0;
          HEAPF32[i1 >> 2] = f547;
          HEAP32[i1 + 4 >> 2] = i510;
          i1 = i1 + 8 | 0;
         }
         if (!i337) {
          i510 = (HEAP32[i95 >> 2] & 2147483647 | 0) == 0 ? i511 : i22;
          HEAP32[i1 >> 2] = HEAP32[i510 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 12 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i338) {
          i510 = (HEAP32[i93 >> 2] & 2147483647 | 0) == 0 ? i511 : i21;
          HEAP32[i1 >> 2] = HEAP32[i510 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 12 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (i311) {
          HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i90) {
          HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
          HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
          i1 = i1 + 16 | 0;
         }
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == 4) break; else i2 = i1;
        }
        i68 = i68 + 1 | 0;
       } while ((i68 | 0) != 4);
      } while (0);
      i88 = i88 + 4 | 0;
     } while (i88 >>> 0 < i172 >>> 0);
    }
   } while (0);
   STACKTOP = i531;
   return;
  }
 case 1:
  {
   i11 = HEAP32[i1 + 32 >> 2] | 0;
   i458 = i13 + 332 | 0;
   f489 = Math_fround((HEAP32[i458 >> 2] & 4095) >>> 0);
   f490 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f491 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f492 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   f5 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   i3 = i13 + 420 | 0;
   f10 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f493 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i4 = i13 + 408 | 0;
   f483 = Math_fround(HEAPF32[i4 >> 2]);
   f472 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f475 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   i4 = i13 + 336 | 0;
   f494 = Math_fround(HEAPF32[i4 >> 2]);
   f495 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f496 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f497 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   i4 = i13 + 352 | 0;
   f482 = Math_fround(HEAPF32[i4 >> 2]);
   f471 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i4 = i13 + 360 | 0;
   f481 = Math_fround(HEAPF32[i4 >> 2]);
   f470 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i4 = i2 + 36 | 0;
   f484 = Math_fround(HEAPF32[i4 >> 2]);
   f473 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i4 = HEAP32[i2 + 56 >> 2] | 0;
   f498 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f499 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f500 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f501 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f502 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f503 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f504 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f505 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f506 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f507 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f508 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f509 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   f488 = Math_fround(HEAPF32[i13 + 192 >> 2]);
   f479 = Math_fround(HEAPF32[i13 + 196 >> 2]);
   f480 = Math_fround(HEAPF32[i13 + 200 >> 2]);
   f487 = Math_fround(HEAPF32[i13 + 208 >> 2]);
   f477 = Math_fround(HEAPF32[i13 + 212 >> 2]);
   f478 = Math_fround(HEAPF32[i13 + 216 >> 2]);
   f486 = Math_fround(HEAPF32[i13 + 224 >> 2]);
   f474 = Math_fround(HEAPF32[i13 + 228 >> 2]);
   f476 = Math_fround(HEAPF32[i13 + 232 >> 2]);
   i1 = i13 + 64 | 0;
   f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 320 >> 2]);
   f469 = Math_fround(f7 * Math_fround(HEAPF32[i13 + 324 >> 2]));
   f9 = Math_fround(f7 * Math_fround(HEAPF32[i13 + 328 >> 2]));
   f469 = Math_fround(f10 * f469);
   i431 = i521 + 12 | 0;
   i432 = i521 + 8 | 0;
   i433 = i521 + 4 | 0;
   i434 = i521 + 28 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAP32[i434 >> 2] = 1;
   i435 = i521 + 24 | 0;
   HEAP32[i435 >> 2] = 1;
   i436 = i521 + 20 | 0;
   HEAP32[i436 >> 2] = 1;
   i437 = i521 + 16 | 0;
   HEAP32[i437 >> 2] = 1;
   i438 = i521 + 44 | 0;
   HEAP32[i438 >> 2] = 2;
   i439 = i521 + 40 | 0;
   HEAP32[i439 >> 2] = 2;
   i452 = i521 + 36 | 0;
   HEAP32[i452 >> 2] = 2;
   i453 = i521 + 32 | 0;
   HEAP32[i453 >> 2] = 2;
   i454 = i521 + 60 | 0;
   HEAP32[i454 >> 2] = 3;
   i455 = i521 + 56 | 0;
   HEAP32[i455 >> 2] = 3;
   i456 = i521 + 52 | 0;
   HEAP32[i456 >> 2] = 3;
   i457 = i521 + 48 | 0;
   HEAP32[i457 >> 2] = 3;
   i382 = i522 + 4 | 0;
   i406 = i522 + 8 | 0;
   i430 = i522 + 12 | 0;
   i358 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i358 >> 2] = Math_fround(1.0);
   i381 = i522 + 20 | 0;
   HEAPF32[i381 >> 2] = Math_fround(1.0);
   i405 = i522 + 24 | 0;
   HEAPF32[i405 >> 2] = Math_fround(1.0);
   i429 = i522 + 28 | 0;
   HEAPF32[i429 >> 2] = Math_fround(1.0);
   i357 = i522 + 32 | 0;
   HEAPF32[i357 >> 2] = Math_fround(1.0);
   i380 = i522 + 36 | 0;
   HEAPF32[i380 >> 2] = Math_fround(1.0);
   i404 = i522 + 40 | 0;
   HEAPF32[i404 >> 2] = Math_fround(1.0);
   i428 = i522 + 44 | 0;
   HEAPF32[i428 >> 2] = Math_fround(1.0);
   i356 = i522 + 48 | 0;
   HEAPF32[i356 >> 2] = Math_fround(1.0);
   i379 = i522 + 52 | 0;
   HEAPF32[i379 >> 2] = Math_fround(1.0);
   i403 = i522 + 56 | 0;
   HEAPF32[i403 >> 2] = Math_fround(1.0);
   i427 = i522 + 60 | 0;
   HEAPF32[i427 >> 2] = Math_fround(1.0);
   i355 = i522 + 64 | 0;
   HEAPF32[i355 >> 2] = Math_fround(1.0);
   i378 = i522 + 68 | 0;
   HEAPF32[i378 >> 2] = Math_fround(1.0);
   i402 = i522 + 72 | 0;
   HEAPF32[i402 >> 2] = Math_fround(1.0);
   i426 = i522 + 76 | 0;
   HEAPF32[i426 >> 2] = Math_fround(1.0);
   i354 = i522 + 80 | 0;
   i377 = i522 + 84 | 0;
   i401 = i522 + 88 | 0;
   i425 = i522 + 92 | 0;
   i353 = i522 + 96 | 0;
   i376 = i522 + 100 | 0;
   i400 = i522 + 104 | 0;
   i424 = i522 + 108 | 0;
   i352 = i522 + 112 | 0;
   i375 = i522 + 116 | 0;
   i399 = i522 + 120 | 0;
   i423 = i522 + 124 | 0;
   i17 = i354;
   i15 = i17 + 48 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i374 = i523 + 4 | 0;
   i398 = i523 + 8 | 0;
   i422 = i523 + 12 | 0;
   i351 = i523 + 16 | 0;
   HEAP32[i523 >> 2] = 0;
   HEAP32[i523 + 4 >> 2] = 0;
   HEAP32[i523 + 8 >> 2] = 0;
   HEAP32[i523 + 12 >> 2] = 0;
   HEAPF32[i351 >> 2] = Math_fround(1.0);
   i373 = i523 + 20 | 0;
   HEAPF32[i373 >> 2] = Math_fround(1.0);
   i397 = i523 + 24 | 0;
   HEAPF32[i397 >> 2] = Math_fround(1.0);
   i421 = i523 + 28 | 0;
   HEAPF32[i421 >> 2] = Math_fround(1.0);
   i350 = i523 + 32 | 0;
   i372 = i523 + 36 | 0;
   i396 = i523 + 40 | 0;
   i420 = i523 + 44 | 0;
   i349 = i523 + 48 | 0;
   i371 = i523 + 52 | 0;
   i395 = i523 + 56 | 0;
   i419 = i523 + 60 | 0;
   i348 = i523 + 64 | 0;
   HEAP32[i350 >> 2] = 0;
   HEAP32[i350 + 4 >> 2] = 0;
   HEAP32[i350 + 8 >> 2] = 0;
   HEAP32[i350 + 12 >> 2] = 0;
   HEAP32[i350 + 16 >> 2] = 0;
   HEAP32[i350 + 20 >> 2] = 0;
   HEAP32[i350 + 24 >> 2] = 0;
   HEAP32[i350 + 28 >> 2] = 0;
   HEAPF32[i348 >> 2] = Math_fround(1.0);
   i370 = i523 + 68 | 0;
   HEAPF32[i370 >> 2] = Math_fround(1.0);
   i394 = i523 + 72 | 0;
   HEAPF32[i394 >> 2] = Math_fround(1.0);
   i418 = i523 + 76 | 0;
   HEAPF32[i418 >> 2] = Math_fround(1.0);
   i347 = i523 + 80 | 0;
   HEAPF32[i347 >> 2] = Math_fround(1.0);
   i369 = i523 + 84 | 0;
   HEAPF32[i369 >> 2] = Math_fround(1.0);
   i393 = i523 + 88 | 0;
   HEAPF32[i393 >> 2] = Math_fround(1.0);
   i417 = i523 + 92 | 0;
   HEAPF32[i417 >> 2] = Math_fround(1.0);
   i346 = i523 + 96 | 0;
   i368 = i523 + 100 | 0;
   i392 = i523 + 104 | 0;
   i416 = i523 + 108 | 0;
   i345 = i523 + 112 | 0;
   i367 = i523 + 116 | 0;
   i391 = i523 + 120 | 0;
   i415 = i523 + 124 | 0;
   i344 = i523 + 128 | 0;
   HEAP32[i346 >> 2] = 0;
   HEAP32[i346 + 4 >> 2] = 0;
   HEAP32[i346 + 8 >> 2] = 0;
   HEAP32[i346 + 12 >> 2] = 0;
   HEAP32[i346 + 16 >> 2] = 0;
   HEAP32[i346 + 20 >> 2] = 0;
   HEAP32[i346 + 24 >> 2] = 0;
   HEAP32[i346 + 28 >> 2] = 0;
   HEAPF32[i344 >> 2] = Math_fround(1.0);
   i366 = i523 + 132 | 0;
   HEAPF32[i366 >> 2] = Math_fround(1.0);
   i390 = i523 + 136 | 0;
   HEAPF32[i390 >> 2] = Math_fround(1.0);
   i414 = i523 + 140 | 0;
   HEAPF32[i414 >> 2] = Math_fround(1.0);
   i343 = i523 + 144 | 0;
   i365 = i523 + 148 | 0;
   i389 = i523 + 152 | 0;
   i413 = i523 + 156 | 0;
   i341 = i523 + 160 | 0;
   i364 = i523 + 164 | 0;
   i388 = i523 + 168 | 0;
   i412 = i523 + 172 | 0;
   i340 = i523 + 176 | 0;
   i363 = i523 + 180 | 0;
   i387 = i523 + 184 | 0;
   i411 = i523 + 188 | 0;
   i339 = i523 + 192 | 0;
   i362 = i523 + 196 | 0;
   i386 = i523 + 200 | 0;
   i410 = i523 + 204 | 0;
   i338 = i523 + 208 | 0;
   i361 = i523 + 212 | 0;
   i385 = i523 + 216 | 0;
   i409 = i523 + 220 | 0;
   i337 = i523 + 224 | 0;
   i360 = i523 + 228 | 0;
   i384 = i523 + 232 | 0;
   i408 = i523 + 236 | 0;
   i336 = i523 + 240 | 0;
   i359 = i523 + 244 | 0;
   i383 = i523 + 248 | 0;
   i407 = i523 + 252 | 0;
   i17 = i343;
   i15 = i17 + 112 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i17 = i12;
   i15 = i17 + 64 | 0;
   do {
    HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
    i17 = i17 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   f83 = Math_fround(HEAPF32[i12 >> 2]);
   f84 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f85 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f86 = Math_fround(HEAPF32[i12 + 16 >> 2]);
   f87 = Math_fround(HEAPF32[i12 + 20 >> 2]);
   f342 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   f440 = Math_fround(HEAPF32[i12 + 32 >> 2]);
   f441 = Math_fround(HEAPF32[i12 + 36 >> 2]);
   f442 = Math_fround(HEAPF32[i12 + 40 >> 2]);
   f443 = Math_fround(HEAPF32[i12 + 48 >> 2]);
   f444 = Math_fround(HEAPF32[i12 + 52 >> 2]);
   f445 = Math_fround(HEAPF32[i12 + 56 >> 2]);
   __Z25InvertMatrix4x4_General3DPKfPf(i12, i14) | 0;
   f446 = Math_fround(HEAPF32[i14 >> 2]);
   f447 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f448 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f449 = Math_fround(HEAPF32[i14 + 16 >> 2]);
   f450 = Math_fround(HEAPF32[i14 + 20 >> 2]);
   f451 = Math_fround(HEAPF32[i14 + 24 >> 2]);
   f464 = Math_fround(HEAPF32[i14 + 32 >> 2]);
   f465 = Math_fround(HEAPF32[i14 + 36 >> 2]);
   f466 = Math_fround(HEAPF32[i14 + 40 >> 2]);
   f467 = Math_fround(HEAPF32[i14 + 48 >> 2]);
   f468 = Math_fround(HEAPF32[i14 + 52 >> 2]);
   f82 = Math_fround(HEAPF32[i14 + 56 >> 2]);
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i511, i12);
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   f545 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f54 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f547 = Math_fround(HEAPF32[i511 >> 2]);
   i459 = i511 + 4 | 0;
   f543 = Math_fround(HEAPF32[i459 >> 2]);
   i460 = i511 + 8 | 0;
   f80 = Math_fround(HEAPF32[i460 >> 2]);
   i461 = i511 + 12 | 0;
   f51 = Math_fround(HEAPF32[i461 >> 2]);
   i462 = i511 + 16 | 0;
   f544 = Math_fround(HEAPF32[i462 >> 2]);
   i463 = i511 + 20 | 0;
   f81 = Math_fround(HEAPF32[i463 >> 2]);
   i485 = i511 + 24 | 0;
   f53 = Math_fround(HEAPF32[i485 >> 2]);
   i170 = i511 + 28 | 0;
   f546 = Math_fround(HEAPF32[i170 >> 2]);
   i169 = i511 + 32 | 0;
   f27 = Math_fround(HEAPF32[i169 >> 2]);
   f50 = Math_fround(f543 * Math_fround(0.0));
   f58 = Math_fround(f80 * Math_fround(0.0));
   f56 = Math_fround(Math_fround(Math_fround(f25 * f547) + f50) + f58);
   f52 = Math_fround(f544 * Math_fround(0.0));
   f79 = Math_fround(f81 * Math_fround(0.0));
   f57 = Math_fround(Math_fround(Math_fround(f25 * f51) + f52) + f79);
   f55 = Math_fround(f546 * Math_fround(0.0));
   f26 = Math_fround(f27 * Math_fround(0.0));
   f25 = Math_fround(Math_fround(Math_fround(f25 * f53) + f55) + f26);
   f547 = Math_fround(f547 * Math_fround(0.0));
   f58 = Math_fround(Math_fround(f547 + Math_fround(f545 * f543)) + f58);
   f51 = Math_fround(f51 * Math_fround(0.0));
   f79 = Math_fround(Math_fround(f51 + Math_fround(f545 * f544)) + f79);
   f53 = Math_fround(f53 * Math_fround(0.0));
   f26 = Math_fround(Math_fround(f53 + Math_fround(f545 * f546)) + f26);
   f80 = Math_fround(Math_fround(f547 + f50) + Math_fround(f54 * f80));
   f81 = Math_fround(Math_fround(f51 + f52) + Math_fround(f54 * f81));
   f27 = Math_fround(Math_fround(f53 + f55) + Math_fround(f54 * f27));
   HEAPF32[i511 >> 2] = f56;
   HEAPF32[i459 >> 2] = f58;
   HEAPF32[i460 >> 2] = f80;
   HEAPF32[i461 >> 2] = f57;
   HEAPF32[i462 >> 2] = f79;
   HEAPF32[i463 >> 2] = f81;
   HEAPF32[i485 >> 2] = f25;
   HEAPF32[i170 >> 2] = f26;
   HEAPF32[i169 >> 2] = f27;
   f54 = Math_fround(Math_fround(1.0) / f489);
   f55 = Math_fround(Math_fround(1.0) - f492);
   f53 = Math_fround(f5 * f10);
   f52 = Math_fround(f10 * f6);
   f51 = Math_fround(f10 * Math_fround(f7 * f8));
   f50 = Math_fround(f10 * f9);
   i169 = (i4 | 0) == 27;
   HEAP32[i529 >> 2] = 0;
   HEAP32[i529 + 4 >> 2] = 0;
   HEAP32[i529 + 8 >> 2] = 0;
   HEAP32[i529 + 12 >> 2] = 0;
   i170 = HEAP32[i527 + 12 >> 2] | 0;
   if (i170 | 0) {
    i171 = i530 + 12 | 0;
    i172 = i530 + 8 | 0;
    i173 = i530 + 4 | 0;
    i174 = i530 + 16 | 0;
    i175 = i530 + 28 | 0;
    i176 = i530 + 24 | 0;
    i177 = i530 + 20 | 0;
    i178 = i530 + 32 | 0;
    i179 = i530 + 44 | 0;
    i180 = i530 + 40 | 0;
    i181 = i530 + 36 | 0;
    i182 = i512 + 12 | 0;
    i183 = i512 + 8 | 0;
    i184 = i512 + 4 | 0;
    i185 = i512 + 28 | 0;
    i186 = i512 + 24 | 0;
    i187 = i512 + 20 | 0;
    i188 = i512 + 44 | 0;
    i189 = i512 + 40 | 0;
    i190 = i512 + 36 | 0;
    i191 = i528 + 20 | 0;
    i192 = i527 + 20 | 0;
    i193 = i527 + 40 | 0;
    i194 = i527 + 60 | 0;
    i195 = i527 + 80 | 0;
    i196 = i527 + 100 | 0;
    i197 = i527 + 120 | 0;
    i198 = i527 + 140 | 0;
    i199 = i527 + 160 | 0;
    i200 = i512 + 16 | 0;
    i201 = i512 + 32 | 0;
    i202 = i528 + 4 | 0;
    i203 = i513 + 4 | 0;
    i204 = i513 + 8 | 0;
    i205 = i513 + 12 | 0;
    i206 = i528 + 8 | 0;
    i207 = i514 + 4 | 0;
    i208 = i514 + 8 | 0;
    i209 = i514 + 12 | 0;
    i210 = i527 + 520 | 0;
    i211 = i515 + 4 | 0;
    i212 = i515 + 8 | 0;
    i213 = i515 + 12 | 0;
    i214 = i527 + 500 | 0;
    i215 = i516 + 4 | 0;
    i216 = i516 + 8 | 0;
    i217 = i516 + 12 | 0;
    i218 = i528 + 16 | 0;
    i219 = i517 + 4 | 0;
    i220 = i517 + 8 | 0;
    i221 = i517 + 12 | 0;
    i222 = i530 + 16 | 0;
    i223 = i530 + 32 | 0;
    i224 = i518 + 4 | 0;
    i225 = i518 + 8 | 0;
    i226 = i518 + 12 | 0;
    i227 = i518 + 16 | 0;
    i228 = i518 + 20 | 0;
    i229 = i518 + 24 | 0;
    i230 = i518 + 28 | 0;
    i231 = i518 + 32 | 0;
    i232 = i518 + 36 | 0;
    i233 = i518 + 40 | 0;
    i234 = i518 + 44 | 0;
    i235 = i524 + 4 | 0;
    i236 = i524 + 8 | 0;
    i237 = i524 + 12 | 0;
    i238 = i524 + 16 | 0;
    i239 = i524 + 20 | 0;
    i240 = i524 + 24 | 0;
    i241 = i524 + 28 | 0;
    i242 = i524 + 32 | 0;
    i243 = i524 + 36 | 0;
    i244 = i524 + 40 | 0;
    i245 = i524 + 44 | 0;
    i246 = i524 + 48 | 0;
    i247 = i524 + 52 | 0;
    i248 = i524 + 56 | 0;
    i249 = i524 + 60 | 0;
    i250 = i524 + 64 | 0;
    i251 = i524 + 68 | 0;
    i252 = i524 + 72 | 0;
    i253 = i524 + 76 | 0;
    i254 = i524 + 80 | 0;
    i255 = i524 + 84 | 0;
    i256 = i524 + 88 | 0;
    i257 = i524 + 92 | 0;
    i258 = i524 + 96 | 0;
    i259 = i524 + 100 | 0;
    i260 = i524 + 104 | 0;
    i261 = i524 + 108 | 0;
    i262 = i524 + 112 | 0;
    i263 = i524 + 116 | 0;
    i264 = i524 + 120 | 0;
    i265 = i524 + 124 | 0;
    i266 = i524 + 128 | 0;
    i267 = i524 + 132 | 0;
    i268 = i524 + 136 | 0;
    i269 = i524 + 140 | 0;
    i270 = i524 + 144 | 0;
    i271 = i524 + 148 | 0;
    i272 = i524 + 152 | 0;
    i273 = i524 + 156 | 0;
    i274 = i524 + 160 | 0;
    i275 = i524 + 164 | 0;
    i276 = i524 + 168 | 0;
    i277 = i524 + 172 | 0;
    i278 = i524 + 176 | 0;
    i279 = i524 + 180 | 0;
    i280 = i524 + 184 | 0;
    i281 = i524 + 188 | 0;
    i282 = (i4 & 48 | 0) == 0;
    i131 = i525 + 4 | 0;
    i148 = i525 + 8 | 0;
    i165 = i525 + 12 | 0;
    i283 = i525 + 16 | 0;
    i126 = i525 + 20 | 0;
    i143 = i525 + 24 | 0;
    i160 = i525 + 28 | 0;
    i284 = i525 + 32 | 0;
    i121 = i525 + 36 | 0;
    i138 = i525 + 40 | 0;
    i155 = i525 + 44 | 0;
    i285 = i525 + 48 | 0;
    i130 = i525 + 52 | 0;
    i147 = i525 + 56 | 0;
    i164 = i525 + 60 | 0;
    i286 = i525 + 64 | 0;
    i125 = i525 + 68 | 0;
    i142 = i525 + 72 | 0;
    i159 = i525 + 76 | 0;
    i287 = i525 + 80 | 0;
    i120 = i525 + 84 | 0;
    i137 = i525 + 88 | 0;
    i154 = i525 + 92 | 0;
    i288 = i525 + 96 | 0;
    i129 = i525 + 100 | 0;
    i146 = i525 + 104 | 0;
    i163 = i525 + 108 | 0;
    i289 = i525 + 112 | 0;
    i124 = i525 + 116 | 0;
    i141 = i525 + 120 | 0;
    i158 = i525 + 124 | 0;
    i290 = i525 + 128 | 0;
    i119 = i525 + 132 | 0;
    i136 = i525 + 136 | 0;
    i153 = i525 + 140 | 0;
    i291 = i525 + 144 | 0;
    i128 = i525 + 148 | 0;
    i145 = i525 + 152 | 0;
    i162 = i525 + 156 | 0;
    i292 = i525 + 160 | 0;
    i123 = i525 + 164 | 0;
    i140 = i525 + 168 | 0;
    i157 = i525 + 172 | 0;
    i293 = i525 + 176 | 0;
    i118 = i525 + 180 | 0;
    i135 = i525 + 184 | 0;
    i152 = i525 + 188 | 0;
    i132 = i519 + 4 | 0;
    i149 = i519 + 8 | 0;
    i166 = i519 + 12 | 0;
    i294 = i519 + 16 | 0;
    i127 = i519 + 20 | 0;
    i144 = i519 + 24 | 0;
    i161 = i519 + 28 | 0;
    i295 = i519 + 32 | 0;
    i122 = i519 + 36 | 0;
    i139 = i519 + 40 | 0;
    i156 = i519 + 44 | 0;
    i134 = i520 + 4 | 0;
    i151 = i520 + 8 | 0;
    i168 = i520 + 12 | 0;
    i117 = i520 + 16 | 0;
    i133 = i520 + 20 | 0;
    i150 = i520 + 24 | 0;
    i167 = i520 + 28 | 0;
    i116 = i520 + 32 | 0;
    i296 = (i4 & 512 | 0) != 0;
    i297 = i510 + 4 | 0;
    i298 = i510 + 8 | 0;
    i299 = i510 + 12 | 0;
    i300 = i510 + 16 | 0;
    i301 = i510 + 20 | 0;
    i302 = i510 + 24 | 0;
    i303 = i510 + 28 | 0;
    i304 = i510 + 32 | 0;
    i305 = i510 + 36 | 0;
    i306 = i510 + 40 | 0;
    i307 = i510 + 44 | 0;
    i308 = (i4 & 8192 | 0) != 0;
    i309 = i526 + 4 | 0;
    i310 = i526 + 8 | 0;
    i311 = i526 + 12 | 0;
    i312 = i526 + 16 | 0;
    i313 = i526 + 20 | 0;
    i314 = i526 + 24 | 0;
    i315 = i526 + 28 | 0;
    i316 = i526 + 32 | 0;
    i317 = i526 + 36 | 0;
    i318 = i526 + 40 | 0;
    i319 = i526 + 44 | 0;
    i320 = i526 + 48 | 0;
    i321 = i526 + 52 | 0;
    i322 = i526 + 56 | 0;
    i323 = i526 + 60 | 0;
    i324 = (i4 & 2 | 0) == 0;
    i325 = (i4 & 8 | 0) == 0;
    i326 = (i4 & 16 | 0) == 0;
    i327 = (i4 & 32 | 0) == 0;
    i328 = (i4 & 64 | 0) == 0;
    i329 = (i4 & 128 | 0) == 0;
    i330 = (i4 & 256 | 0) == 0;
    i331 = i510 + 16 | 0;
    i332 = i510 + 32 | 0;
    i333 = (i4 & 1024 | 0) == 0;
    i334 = (i4 & 2048 | 0) == 0;
    i335 = (i4 & 4096 | 0) == 0;
    i78 = (i4 & 4 | 0) == 0;
    i88 = i519 + 16 | 0;
    i89 = i519 + 32 | 0;
    i90 = i527 + 864 | 0;
    i91 = i527 + 848 | 0;
    i92 = i527 + 844 | 0;
    i93 = i527 + 828 | 0;
    i94 = i527 + 540 | 0;
    i95 = i527 + 340 | 0;
    i96 = i520 + 16 | 0;
    i97 = i520 + 32 | 0;
    i98 = i518 + 16 | 0;
    i99 = i518 + 32 | 0;
    i100 = i524 + 16 | 0;
    i101 = i524 + 32 | 0;
    i102 = i525 + 16 | 0;
    i103 = i525 + 32 | 0;
    i104 = i246 + 16 | 0;
    i105 = i246 + 32 | 0;
    i106 = i285 + 16 | 0;
    i107 = i285 + 32 | 0;
    i108 = i258 + 16 | 0;
    i109 = i258 + 32 | 0;
    i110 = i288 + 16 | 0;
    i111 = i288 + 32 | 0;
    i112 = i270 + 16 | 0;
    i113 = i270 + 32 | 0;
    i114 = i291 + 16 | 0;
    i115 = i291 + 32 | 0;
    f49 = Math_fround(f25 * Math_fround(0.0));
    f48 = Math_fround(f26 * Math_fround(0.0));
    f47 = Math_fround(f27 * Math_fround(0.0));
    i77 = i11 + 564 | 0;
    i76 = i11 + 568 | 0;
    i75 = 0;
    i1 = i16;
    do {
     i17 = i530;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     i17 = i512;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     HEAP32[i517 >> 2] = 0;
     HEAP32[i517 + 4 >> 2] = 0;
     HEAP32[i517 + 8 >> 2] = 0;
     HEAP32[i517 + 12 >> 2] = 0;
     i22 = HEAP32[i191 >> 2] | 0;
     i23 = HEAP32[i527 >> 2] | 0;
     if (!i22) {
      i70 = i23 + (i75 << 2) | 0;
      i71 = HEAP32[i70 + 4 >> 2] | 0;
      i72 = HEAP32[i70 + 8 >> 2] | 0;
      i73 = HEAP32[i70 + 12 >> 2] | 0;
      i461 = (HEAP32[i192 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i461 >> 2] | 0;
      i459 = HEAP32[i461 + 4 >> 2] | 0;
      i460 = HEAP32[i461 + 8 >> 2] | 0;
      i461 = HEAP32[i461 + 12 >> 2] | 0;
      i511 = (HEAP32[i193 >> 2] | 0) + (i75 << 2) | 0;
      i462 = HEAP32[i511 >> 2] | 0;
      i463 = HEAP32[i511 + 4 >> 2] | 0;
      i485 = HEAP32[i511 + 8 >> 2] | 0;
      i511 = HEAP32[i511 + 12 >> 2] | 0;
      HEAP32[i530 >> 2] = HEAP32[i70 >> 2];
      HEAP32[i173 >> 2] = i71;
      HEAP32[i172 >> 2] = i72;
      HEAP32[i171 >> 2] = i73;
      HEAP32[i174 >> 2] = i74;
      HEAP32[i177 >> 2] = i459;
      HEAP32[i176 >> 2] = i460;
      HEAP32[i175 >> 2] = i461;
      HEAP32[i178 >> 2] = i462;
      HEAP32[i181 >> 2] = i463;
      HEAP32[i180 >> 2] = i485;
      HEAP32[i179 >> 2] = i511;
      i511 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      f535 = Math_fround(HEAPF32[i511 >> 2]);
      f40 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f42 = Math_fround(HEAPF32[i511 + 12 >> 2]);
      i511 = (HEAP32[i195 >> 2] | 0) + (i75 << 2) | 0;
      f43 = Math_fround(HEAPF32[i511 >> 2]);
      f44 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f45 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f46 = Math_fround(HEAPF32[i511 + 12 >> 2]);
      i511 = (HEAP32[i196 >> 2] | 0) + (i75 << 2) | 0;
      f532 = Math_fround(HEAPF32[i511 >> 2]);
      f533 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f534 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f547 = Math_fround(HEAPF32[i511 + 12 >> 2]);
      i511 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      f536 = Math_fround(HEAPF32[i511 >> 2]);
      f537 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f538 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f539 = Math_fround(HEAPF32[i511 + 12 >> 2]);
      i511 = (HEAP32[i198 >> 2] | 0) + (i75 << 2) | 0;
      f540 = Math_fround(HEAPF32[i511 >> 2]);
      f541 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f542 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f543 = Math_fround(HEAPF32[i511 + 12 >> 2]);
      i511 = (HEAP32[i199 >> 2] | 0) + (i75 << 2) | 0;
      f544 = Math_fround(HEAPF32[i511 >> 2]);
      f545 = Math_fround(HEAPF32[i511 + 4 >> 2]);
      f546 = Math_fround(HEAPF32[i511 + 8 >> 2]);
      f537 = Math_fround(f40 + f537);
      f538 = Math_fround(f41 + f538);
      f539 = Math_fround(f42 + f539);
      f540 = Math_fround(f43 + f540);
      f541 = Math_fround(f44 + f541);
      f542 = Math_fround(f45 + f542);
      f543 = Math_fround(f46 + f543);
      f544 = Math_fround(f532 + f544);
      f545 = Math_fround(f533 + f545);
      f546 = Math_fround(f534 + f546);
      f547 = Math_fround(f547 + Math_fround(HEAPF32[i511 + 12 >> 2]));
      HEAPF32[i512 >> 2] = Math_fround(f535 + f536);
      HEAPF32[i184 >> 2] = f537;
      HEAPF32[i183 >> 2] = f538;
      HEAPF32[i182 >> 2] = f539;
      HEAPF32[i200 >> 2] = f540;
      HEAPF32[i187 >> 2] = f541;
      HEAPF32[i186 >> 2] = f542;
      HEAPF32[i185 >> 2] = f543;
      HEAPF32[i201 >> 2] = f544;
      HEAPF32[i190 >> 2] = f545;
      HEAPF32[i189 >> 2] = f546;
      HEAPF32[i188 >> 2] = f547;
      i511 = (HEAP32[i202 >> 2] | 0) + (i75 << 2) | 0;
      i485 = HEAP32[i511 + 4 >> 2] | 0;
      i463 = HEAP32[i511 + 8 >> 2] | 0;
      i462 = HEAP32[i511 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i511 >> 2];
      HEAP32[i203 >> 2] = i485;
      HEAP32[i204 >> 2] = i463;
      HEAP32[i205 >> 2] = i462;
      i462 = (HEAP32[i206 >> 2] | 0) + (i75 << 2) | 0;
      i463 = HEAP32[i462 + 4 >> 2] | 0;
      i485 = HEAP32[i462 + 8 >> 2] | 0;
      i511 = HEAP32[i462 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i462 >> 2];
      HEAP32[i207 >> 2] = i463;
      HEAP32[i208 >> 2] = i485;
      HEAP32[i209 >> 2] = i511;
      i511 = (HEAP32[i210 >> 2] | 0) + (i75 << 2) | 0;
      i485 = HEAP32[i511 + 4 >> 2] | 0;
      i463 = HEAP32[i511 + 8 >> 2] | 0;
      i462 = HEAP32[i511 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i511 >> 2];
      HEAP32[i211 >> 2] = i485;
      HEAP32[i212 >> 2] = i463;
      HEAP32[i213 >> 2] = i462;
      i462 = (HEAP32[i214 >> 2] | 0) + (i75 << 2) | 0;
      i463 = HEAP32[i462 + 4 >> 2] | 0;
      i485 = HEAP32[i462 + 8 >> 2] | 0;
      i511 = HEAP32[i462 + 12 >> 2] | 0;
      HEAP32[i516 >> 2] = HEAP32[i462 >> 2];
      HEAP32[i215 >> 2] = i463;
      HEAP32[i216 >> 2] = i485;
      HEAP32[i217 >> 2] = i511;
      if (HEAP32[i458 >> 2] & 268435456 | 0) {
       i462 = (HEAP32[i218 >> 2] | 0) + (i75 << 2) | 0;
       i463 = HEAP32[i462 + 4 >> 2] | 0;
       i485 = HEAP32[i462 + 8 >> 2] | 0;
       i511 = HEAP32[i462 + 12 >> 2] | 0;
       HEAP32[i517 >> 2] = HEAP32[i462 >> 2];
       HEAP32[i219 >> 2] = i463;
       HEAP32[i220 >> 2] = i485;
       HEAP32[i221 >> 2] = i511;
      }
     } else {
      i4 = HEAP32[i194 >> 2] | 0;
      i11 = HEAP32[i197 >> 2] | 0;
      i12 = HEAP32[i192 >> 2] | 0;
      i13 = HEAP32[i195 >> 2] | 0;
      i14 = HEAP32[i198 >> 2] | 0;
      i15 = HEAP32[i193 >> 2] | 0;
      i16 = HEAP32[i196 >> 2] | 0;
      i17 = HEAP32[i199 >> 2] | 0;
      i18 = HEAP32[i202 >> 2] | 0;
      i19 = HEAP32[i206 >> 2] | 0;
      i20 = HEAP32[i210 >> 2] | 0;
      i21 = HEAP32[i214 >> 2] | 0;
      i3 = HEAP32[i218 >> 2] | 0;
      if (!(HEAP32[i458 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i511 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i530 + (i2 << 2) >> 2] = HEAP32[i23 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i4 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i11 + (i511 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i12 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i13 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i14 + (i511 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i15 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i16 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i17 + (i511 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i511 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i511 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i511 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i511 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i511 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i530 + (i2 << 2) >> 2] = HEAP32[i23 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i4 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i11 + (i511 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i12 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i13 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i14 + (i511 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i15 + (i511 << 2) >> 2];
        f547 = Math_fround(HEAPF32[i16 + (i511 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f547 + Math_fround(HEAPF32[i17 + (i511 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i511 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i511 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i511 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i511 << 2) >> 2];
        HEAP32[i517 + (i2 << 2) >> 2] = HEAP32[i3 + (i511 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f30 = Math_fround(HEAPF32[i530 >> 2]);
     f7 = Math_fround(f498 * f30);
     f35 = Math_fround(HEAPF32[i173 >> 2]);
     f33 = Math_fround(f498 * f35);
     f547 = Math_fround(HEAPF32[i172 >> 2]);
     f6 = Math_fround(f498 * f547);
     f545 = Math_fround(HEAPF32[i171 >> 2]);
     f37 = Math_fround(f498 * f545);
     f36 = Math_fround(HEAPF32[i222 >> 2]);
     f34 = Math_fround(f501 * f36);
     f29 = Math_fround(HEAPF32[i177 >> 2]);
     f27 = Math_fround(f501 * f29);
     f546 = Math_fround(HEAPF32[i176 >> 2]);
     f10 = Math_fround(f501 * f546);
     f544 = Math_fround(HEAPF32[i175 >> 2]);
     f34 = Math_fround(f7 + f34);
     f27 = Math_fround(f33 + f27);
     f10 = Math_fround(f6 + f10);
     f37 = Math_fround(f37 + Math_fround(f501 * f544));
     f6 = Math_fround(HEAPF32[i223 >> 2]);
     f33 = Math_fround(f504 * f6);
     f7 = Math_fround(HEAPF32[i181 >> 2]);
     f32 = Math_fround(f504 * f7);
     f8 = Math_fround(HEAPF32[i180 >> 2]);
     f31 = Math_fround(f504 * f8);
     f26 = Math_fround(HEAPF32[i179 >> 2]);
     f32 = Math_fround(f507 + Math_fround(f27 + f32));
     f31 = Math_fround(f507 + Math_fround(f10 + f31));
     f37 = Math_fround(f507 + Math_fround(f37 + Math_fround(f504 * f26)));
     HEAPF32[i518 >> 2] = Math_fround(f507 + Math_fround(f34 + f33));
     HEAPF32[i224 >> 2] = f32;
     HEAPF32[i225 >> 2] = f31;
     HEAPF32[i226 >> 2] = f37;
     f37 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f35) + Math_fround(f502 * f29)) + Math_fround(f505 * f7)));
     f31 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f547) + Math_fround(f502 * f546)) + Math_fround(f505 * f8)));
     f32 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f545) + Math_fround(f502 * f544)) + Math_fround(f505 * f26)));
     HEAPF32[i227 >> 2] = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f30) + Math_fround(f502 * f36)) + Math_fround(f505 * f6)));
     HEAPF32[i228 >> 2] = f37;
     HEAPF32[i229 >> 2] = f31;
     HEAPF32[i230 >> 2] = f32;
     f32 = Math_fround(f509 + Math_fround(Math_fround(Math_fround(f500 * f35) + Math_fround(f503 * f29)) + Math_fround(f506 * f7)));
     f31 = Math_fround(f509 + Math_fround(Math_fround(Math_fround(f500 * f547) + Math_fround(f503 * f546)) + Math_fround(f506 * f8)));
     f37 = Math_fround(f509 + Math_fround(Math_fround(Math_fround(f500 * f545) + Math_fround(f503 * f544)) + Math_fround(f506 * f26)));
     HEAPF32[i231 >> 2] = Math_fround(f509 + Math_fround(Math_fround(Math_fround(f500 * f30) + Math_fround(f503 * f36)) + Math_fround(f506 * f6)));
     HEAPF32[i232 >> 2] = f32;
     HEAPF32[i233 >> 2] = f31;
     HEAPF32[i234 >> 2] = f37;
     f6 = Math_fround(f497 + Math_fround(Math_fround(Math_fround(f494 * f30) + Math_fround(f495 * f36)) + Math_fround(f496 * f6)));
     f7 = Math_fround(f497 + Math_fround(Math_fround(Math_fround(f494 * f35) + Math_fround(f495 * f29)) + Math_fround(f496 * f7)));
     f8 = Math_fround(f497 + Math_fround(Math_fround(Math_fround(f494 * f547) + Math_fround(f495 * f546)) + Math_fround(f496 * f8)));
     f26 = Math_fround(f497 + Math_fround(Math_fround(Math_fround(f494 * f545) + Math_fround(f495 * f544)) + Math_fround(f496 * f26)));
     f544 = Math_fround(f481 + Math_fround(f482 * f6));
     f545 = Math_fround(f481 + Math_fround(f482 * f7));
     f546 = Math_fround(f481 + Math_fround(f482 * f8));
     f547 = Math_fround(f481 + Math_fround(f482 * f26));
     f6 = Math_fround(f470 + Math_fround(f471 * f6));
     f7 = Math_fround(f470 + Math_fround(f471 * f7));
     f8 = Math_fround(f470 + Math_fround(f471 * f8));
     f26 = Math_fround(f470 + Math_fround(f471 * f26));
     f29 = Math_fround(HEAPF32[i513 >> 2]);
     f35 = Math_fround(HEAPF32[i203 >> 2]);
     f36 = Math_fround(HEAPF32[i204 >> 2]);
     f30 = Math_fround(HEAPF32[i205 >> 2]);
     f31 = Math_fround(HEAPF32[i514 >> 2]);
     f32 = Math_fround(HEAPF32[i207 >> 2]);
     f33 = Math_fround(HEAPF32[i208 >> 2]);
     f34 = Math_fround(HEAPF32[i209 >> 2]);
     f10 = f29 > f31 ? f29 : f31;
     f27 = f35 > f32 ? f35 : f32;
     f25 = f36 > f33 ? f36 : f33;
     f28 = f30 > f34 ? f30 : f34;
     f541 = Math_fround((f10 > f544 ? f10 : f544) * Math_fround(.5));
     f542 = Math_fround((f27 > f545 ? f27 : f545) * Math_fround(.5));
     f543 = Math_fround((f25 > f546 ? f25 : f546) * Math_fround(.5));
     f5 = Math_fround((f28 > f547 ? f28 : f547) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f541, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f542, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f543, HEAP32[tempDoublePtr >> 2] | 0);
     i462 = f544 >= Math_fround(0.0);
     i463 = f545 >= Math_fround(0.0);
     i485 = f546 >= Math_fround(0.0);
     i511 = f547 >= Math_fround(0.0);
     i15 = i462 ? i15 : 0;
     i16 = i463 ? i16 : 0;
     i17 = i485 ? i17 : 0;
     i11 = i511 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f543 = Math_fround(f6 * Math_fround(.5));
     f545 = Math_fround(f7 * Math_fround(.5));
     f547 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f26 * Math_fround(.5));
     f542 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f544 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f546 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f542 < f543 ? f542 : f543, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f544 < f545 ? f544 : f545, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f546 < f547 ? f546 : f547, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i511 = f26 >= Math_fround(0.0);
     i11 = i511 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f44 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f27);
     f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
     f27 = Math_fround(f29 * f43);
     f40 = Math_fround(f35 * f44);
     f41 = Math_fround(f36 * f45);
     f42 = Math_fround(f30 * f46);
     f43 = Math_fround(f31 * f43);
     f44 = Math_fround(f32 * f44);
     f45 = Math_fround(f33 * f45);
     f46 = Math_fround(f34 * f46);
     i3 = Math_fround(HEAPF32[i515 >> 2]) < Math_fround(100.0);
     i11 = Math_fround(HEAPF32[i211 >> 2]) < Math_fround(100.0);
     i12 = Math_fround(HEAPF32[i212 >> 2]) < Math_fround(100.0);
     i13 = Math_fround(HEAPF32[i213 >> 2]) < Math_fround(100.0);
     f532 = Math_fround(HEAPF32[i512 >> 2]);
     f548 = Math_fround(f488 * f532);
     f549 = Math_fround(HEAPF32[i184 >> 2]);
     f555 = Math_fround(f488 * f549);
     f535 = Math_fround(HEAPF32[i183 >> 2]);
     f38 = Math_fround(f488 * f535);
     f39 = Math_fround(HEAPF32[i182 >> 2]);
     f552 = Math_fround(f488 * f39);
     f533 = Math_fround(HEAPF32[i200 >> 2]);
     f541 = Math_fround(f487 * f533);
     f534 = Math_fround(HEAPF32[i187 >> 2]);
     f542 = Math_fround(f487 * f534);
     f10 = Math_fround(HEAPF32[i186 >> 2]);
     f543 = Math_fround(f487 * f10);
     f25 = Math_fround(HEAPF32[i185 >> 2]);
     f541 = Math_fround(f548 + f541);
     f542 = Math_fround(f555 + f542);
     f543 = Math_fround(f38 + f543);
     f552 = Math_fround(f552 + Math_fround(f487 * f25));
     f38 = Math_fround(HEAPF32[i201 >> 2]);
     f555 = Math_fround(f486 * f38);
     f548 = Math_fround(HEAPF32[i190 >> 2]);
     f554 = Math_fround(f486 * f548);
     f550 = Math_fround(HEAPF32[i189 >> 2]);
     f553 = Math_fround(f486 * f550);
     f551 = Math_fround(HEAPF32[i188 >> 2]);
     f555 = Math_fround(Math_fround(f541 + f555) - f51);
     f554 = Math_fround(Math_fround(f542 + f554) - f51);
     f553 = Math_fround(Math_fround(f543 + f553) - f51);
     f552 = Math_fround(Math_fround(f552 + Math_fround(f486 * f551)) - f51);
     f543 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f532) + Math_fround(f477 * f533)) + Math_fround(f474 * f38)) - f469);
     f542 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f549) + Math_fround(f477 * f534)) + Math_fround(f474 * f548)) - f469);
     f541 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f535) + Math_fround(f477 * f10)) + Math_fround(f474 * f550)) - f469);
     f540 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f39) + Math_fround(f477 * f25)) + Math_fround(f474 * f551)) - f469);
     f38 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f532) + Math_fround(f478 * f533)) + Math_fround(f476 * f38)) - f50);
     f548 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f549) + Math_fround(f478 * f534)) + Math_fround(f476 * f548)) - f50);
     f550 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f535) + Math_fround(f478 * f10)) + Math_fround(f476 * f550)) - f50);
     f551 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f39) + Math_fround(f478 * f25)) + Math_fround(f476 * f551)) - f50);
     f25 = Math_fround(Math_fround(f38 * f38) + Math_fround(Math_fround(f555 * f555) + Math_fround(f543 * f543)));
     f39 = Math_fround(Math_fround(f548 * f548) + Math_fround(Math_fround(f554 * f554) + Math_fround(f542 * f542)));
     f10 = Math_fround(Math_fround(f550 * f550) + Math_fround(Math_fround(f553 * f553) + Math_fround(f541 * f541)));
     f535 = Math_fround(Math_fround(f551 * f551) + Math_fround(Math_fround(f552 * f552) + Math_fround(f540 * f540)));
     f534 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25))));
     f549 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f39))));
     f533 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f10))));
     f532 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f535))));
     i462 = !(f25 <= Math_fround(9.99999974e-06));
     i463 = !(f39 <= Math_fround(9.99999974e-06));
     i485 = !(f10 <= Math_fround(9.99999974e-06));
     i511 = !(f535 <= Math_fround(9.99999974e-06));
     f535 = Math_fround(HEAPF32[i518 >> 2]);
     f10 = Math_fround(f446 * f535);
     f39 = Math_fround(HEAPF32[i224 >> 2]);
     f25 = Math_fround(f446 * f39);
     f537 = Math_fround(HEAPF32[i225 >> 2]);
     f26 = Math_fround(f446 * f537);
     f539 = Math_fround(HEAPF32[i226 >> 2]);
     f5 = Math_fround(f446 * f539);
     f28 = Math_fround(HEAPF32[i227 >> 2]);
     f545 = Math_fround(f449 * f28);
     f536 = Math_fround(HEAPF32[i228 >> 2]);
     f544 = Math_fround(f449 * f536);
     f538 = Math_fround(HEAPF32[i229 >> 2]);
     f7 = Math_fround(f449 * f538);
     f6 = Math_fround(HEAPF32[i230 >> 2]);
     f545 = Math_fround(f10 + f545);
     f544 = Math_fround(f25 + f544);
     f7 = Math_fround(f26 + f7);
     f5 = Math_fround(f5 + Math_fround(f449 * f6));
     f26 = Math_fround(HEAPF32[i231 >> 2]);
     f25 = Math_fround(f464 * f26);
     f10 = Math_fround(HEAPF32[i232 >> 2]);
     f9 = Math_fround(f464 * f10);
     f8 = Math_fround(HEAPF32[i233 >> 2]);
     f25 = Math_fround(f467 + Math_fround(f545 + f25));
     f9 = Math_fround(f467 + Math_fround(f544 + f9));
     f7 = Math_fround(f467 + Math_fround(f7 + Math_fround(f464 * f8)));
     f5 = Math_fround(f467 + Math_fround(Math_fround(f464 * f37) + f5));
     f544 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f447 * f535) + Math_fround(f450 * f28)) + Math_fround(f465 * f26)));
     f545 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f447 * f39) + Math_fround(f450 * f536)) + Math_fround(f465 * f10)));
     f546 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f447 * f537) + Math_fround(f450 * f538)) + Math_fround(f465 * f8)));
     f547 = Math_fround(f468 + Math_fround(Math_fround(f465 * f37) + Math_fround(Math_fround(f447 * f539) + Math_fround(f450 * f6))));
     f26 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f448 * f535) + Math_fround(f451 * f28)) + Math_fround(f466 * f26)));
     f10 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f448 * f39) + Math_fround(f451 * f536)) + Math_fround(f466 * f10)));
     f8 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f448 * f537) + Math_fround(f451 * f538)) + Math_fround(f466 * f8)));
     f6 = Math_fround(f82 + Math_fround(Math_fround(f466 * f37) + Math_fround(Math_fround(f448 * f539) + Math_fround(f451 * f6))));
     f539 = Math_fround(f484 * f29);
     f538 = Math_fround(f484 * f35);
     f537 = Math_fround(f484 * f36);
     f536 = Math_fround(f484 * f30);
     f39 = Math_fround(f473 * f31);
     f30 = Math_fround(f473 * f32);
     f28 = Math_fround(f473 * f33);
     f37 = Math_fround(f473 * f34);
     f35 = i462 ? f534 : Math_fround(0.0);
     f39 = Math_fround(f39 * f35);
     f549 = i463 ? f549 : Math_fround(0.0);
     f30 = Math_fround(f30 * f549);
     f36 = i485 ? f533 : Math_fround(0.0);
     f28 = Math_fround(f28 * f36);
     f29 = i511 ? f532 : Math_fround(0.0);
     f37 = Math_fround(f37 * f29);
     f25 = Math_fround(Math_fround(f555 * f39) + f25);
     f9 = Math_fround(Math_fround(f554 * f30) + f9);
     f7 = Math_fround(Math_fround(f553 * f28) + f7);
     f5 = Math_fround(Math_fround(f552 * f37) + f5);
     f544 = Math_fround(Math_fround(f543 * f39) + f544);
     f545 = Math_fround(Math_fround(f542 * f30) + f545);
     f546 = Math_fround(Math_fround(f541 * f28) + f546);
     f547 = Math_fround(Math_fround(f540 * f37) + f547);
     f26 = Math_fround(Math_fround(f38 * f39) + f26);
     f10 = Math_fround(Math_fround(f548 * f30) + f10);
     f8 = Math_fround(Math_fround(f550 * f28) + f8);
     f6 = Math_fround(Math_fround(f551 * f37) + f6);
     f35 = Math_fround(f52 + Math_fround(Math_fround(f53 * f31) * f35));
     f549 = Math_fround(f52 + Math_fround(Math_fround(f53 * f32) * f549));
     f31 = Math_fround(f52 + Math_fround(Math_fround(f53 * f33) * f36));
     f29 = Math_fround(f52 + Math_fround(Math_fround(f53 * f34) * f29));
     f555 = Math_fround(f25 - Math_fround(f555 * f35));
     f554 = Math_fround(f9 - Math_fround(f554 * f549));
     f553 = Math_fround(f7 - Math_fround(f553 * f31));
     f552 = Math_fround(f5 - Math_fround(f552 * f29));
     f543 = Math_fround(f544 - Math_fround(f543 * f35));
     f542 = Math_fround(f545 - Math_fround(f542 * f549));
     f541 = Math_fround(f546 - Math_fround(f541 * f31));
     f540 = Math_fround(f547 - Math_fround(f540 * f29));
     f35 = Math_fround(f26 - Math_fround(f38 * f35));
     f33 = Math_fround(f10 - Math_fround(f548 * f549));
     f31 = Math_fround(f8 - Math_fround(f550 * f31));
     f29 = Math_fround(f6 - Math_fround(f551 * f29));
     f551 = Math_fround(Math_fround(f26 * f543) - Math_fround(f544 * f35));
     f550 = Math_fround(Math_fround(f10 * f542) - Math_fround(f545 * f33));
     f549 = Math_fround(Math_fround(f8 * f541) - Math_fround(f546 * f31));
     f548 = Math_fround(Math_fround(f6 * f540) - Math_fround(f547 * f29));
     f36 = Math_fround(Math_fround(f25 * f35) - Math_fround(f26 * f555));
     f37 = Math_fround(Math_fround(f9 * f33) - Math_fround(f10 * f554));
     f38 = Math_fround(Math_fround(f7 * f31) - Math_fround(f8 * f553));
     f34 = Math_fround(Math_fround(f5 * f29) - Math_fround(f6 * f552));
     f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f551 * f551) + Math_fround(f36 * f36)))));
     f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f550 * f550) + Math_fround(f37 * f37)))));
     f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f549 * f549) + Math_fround(f38 * f38)))));
     f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f548 * f548) + Math_fround(f34 * f34)))));
     f551 = Math_fround(f28 * f551);
     f550 = Math_fround(f30 * f550);
     f549 = Math_fround(f32 * f549);
     f548 = Math_fround(f548 * f39);
     f36 = Math_fround(f28 * f36);
     f37 = Math_fround(f30 * f37);
     f38 = Math_fround(f32 * f38);
     f39 = Math_fround(f34 * f39);
     f27 = i3 ? f27 : Math_fround(0.0);
     f551 = Math_fround(f27 * f551);
     f40 = i11 ? f40 : Math_fround(0.0);
     f550 = Math_fround(f40 * f550);
     f41 = i12 ? f41 : Math_fround(0.0);
     f549 = Math_fround(f41 * f549);
     f42 = i13 ? f42 : Math_fround(0.0);
     f548 = Math_fround(f42 * f548);
     f36 = Math_fround(f27 * f36);
     f37 = Math_fround(f40 * f37);
     f38 = Math_fround(f41 * f38);
     f39 = Math_fround(f42 * f39);
     f34 = Math_fround(f539 * f551);
     f32 = Math_fround(f538 * f550);
     f30 = Math_fround(f537 * f549);
     f28 = Math_fround(f536 * f548);
     f532 = Math_fround(f539 * f36);
     f533 = Math_fround(f538 * f37);
     f534 = Math_fround(f537 * f38);
     f535 = Math_fround(f536 * f39);
     f539 = Math_fround(f539 * Math_fround(0.0));
     f538 = Math_fround(f538 * Math_fround(0.0));
     f537 = Math_fround(f537 * Math_fround(0.0));
     f536 = Math_fround(f536 * Math_fround(0.0));
     f25 = Math_fround(f25 + f34);
     f9 = Math_fround(f9 + f32);
     f7 = Math_fround(f7 + f30);
     f5 = Math_fround(f5 + f28);
     f544 = Math_fround(f544 + f532);
     f545 = Math_fround(f545 + f533);
     f546 = Math_fround(f546 + f534);
     f547 = Math_fround(f547 + f535);
     f26 = Math_fround(f539 + f26);
     f10 = Math_fround(f538 + f10);
     f8 = Math_fround(f537 + f8);
     f6 = Math_fround(f536 + f6);
     f34 = Math_fround(f555 + f34);
     f32 = Math_fround(f554 + f32);
     f30 = Math_fround(f553 + f30);
     f28 = Math_fround(f552 + f28);
     f532 = Math_fround(f543 + f532);
     f533 = Math_fround(f542 + f533);
     f534 = Math_fround(f541 + f534);
     f535 = Math_fround(f540 + f535);
     f35 = Math_fround(f539 + f35);
     f33 = Math_fround(f538 + f33);
     f31 = Math_fround(f537 + f31);
     f29 = Math_fround(f536 + f29);
     f536 = Math_fround(f443 + Math_fround(Math_fround(f440 * f26) + Math_fround(Math_fround(f83 * f25) + Math_fround(f86 * f544))));
     f537 = Math_fround(f443 + Math_fround(Math_fround(f440 * f10) + Math_fround(Math_fround(f83 * f9) + Math_fround(f86 * f545))));
     f538 = Math_fround(f443 + Math_fround(Math_fround(f440 * f8) + Math_fround(Math_fround(f83 * f7) + Math_fround(f86 * f546))));
     f539 = Math_fround(f443 + Math_fround(Math_fround(f440 * f6) + Math_fround(Math_fround(f83 * f5) + Math_fround(f86 * f547))));
     f540 = Math_fround(f444 + Math_fround(Math_fround(f441 * f26) + Math_fround(Math_fround(f84 * f25) + Math_fround(f87 * f544))));
     f541 = Math_fround(f444 + Math_fround(Math_fround(f441 * f10) + Math_fround(Math_fround(f84 * f9) + Math_fround(f87 * f545))));
     f542 = Math_fround(f444 + Math_fround(Math_fround(f441 * f8) + Math_fround(Math_fround(f84 * f7) + Math_fround(f87 * f546))));
     f543 = Math_fround(f444 + Math_fround(Math_fround(f441 * f6) + Math_fround(Math_fround(f84 * f5) + Math_fround(f87 * f547))));
     f544 = Math_fround(f445 + Math_fround(Math_fround(f442 * f26) + Math_fround(Math_fround(f85 * f25) + Math_fround(f342 * f544))));
     f545 = Math_fround(f445 + Math_fround(Math_fround(f442 * f10) + Math_fround(Math_fround(f85 * f9) + Math_fround(f342 * f545))));
     f546 = Math_fround(f445 + Math_fround(Math_fround(f442 * f8) + Math_fround(Math_fround(f85 * f7) + Math_fround(f342 * f546))));
     f547 = Math_fround(f445 + Math_fround(Math_fround(f442 * f6) + Math_fround(Math_fround(f85 * f5) + Math_fround(f342 * f547))));
     f5 = Math_fround(f443 + Math_fround(Math_fround(f440 * f35) + Math_fround(Math_fround(f83 * f34) + Math_fround(f86 * f532))));
     f6 = Math_fround(f443 + Math_fround(Math_fround(f440 * f33) + Math_fround(Math_fround(f83 * f32) + Math_fround(f86 * f533))));
     f7 = Math_fround(f443 + Math_fround(Math_fround(f440 * f31) + Math_fround(Math_fround(f83 * f30) + Math_fround(f86 * f534))));
     f8 = Math_fround(f443 + Math_fround(Math_fround(f440 * f29) + Math_fround(Math_fround(f83 * f28) + Math_fround(f86 * f535))));
     f9 = Math_fround(f444 + Math_fround(Math_fround(f441 * f35) + Math_fround(Math_fround(f84 * f34) + Math_fround(f87 * f532))));
     f10 = Math_fround(f444 + Math_fround(Math_fround(f441 * f33) + Math_fround(Math_fround(f84 * f32) + Math_fround(f87 * f533))));
     f25 = Math_fround(f444 + Math_fround(Math_fround(f441 * f31) + Math_fround(Math_fround(f84 * f30) + Math_fround(f87 * f534))));
     f26 = Math_fround(f444 + Math_fround(Math_fround(f441 * f29) + Math_fround(Math_fround(f84 * f28) + Math_fround(f87 * f535))));
     f532 = Math_fround(f445 + Math_fround(Math_fround(f442 * f35) + Math_fround(Math_fround(f85 * f34) + Math_fround(f342 * f532))));
     f533 = Math_fround(f445 + Math_fround(Math_fround(f442 * f33) + Math_fround(Math_fround(f85 * f32) + Math_fround(f342 * f533))));
     f534 = Math_fround(f445 + Math_fround(Math_fround(f442 * f31) + Math_fround(Math_fround(f85 * f30) + Math_fround(f342 * f534))));
     f535 = Math_fround(f445 + Math_fround(Math_fround(f442 * f29) + Math_fround(Math_fround(f85 * f28) + Math_fround(f342 * f535))));
     f28 = Math_fround(f49 + Math_fround(Math_fround(f56 * f551) + Math_fround(f57 * f36)));
     f29 = Math_fround(f49 + Math_fround(Math_fround(f56 * f550) + Math_fround(f57 * f37)));
     f30 = Math_fround(f49 + Math_fround(Math_fround(f56 * f549) + Math_fround(f57 * f38)));
     f31 = Math_fround(f49 + Math_fround(Math_fround(f56 * f548) + Math_fround(f57 * f39)));
     f32 = Math_fround(f48 + Math_fround(Math_fround(f58 * f551) + Math_fround(f79 * f36)));
     f33 = Math_fround(f48 + Math_fround(Math_fround(f58 * f550) + Math_fround(f79 * f37)));
     f34 = Math_fround(f48 + Math_fround(Math_fround(f58 * f549) + Math_fround(f79 * f38)));
     f35 = Math_fround(f48 + Math_fround(Math_fround(f58 * f548) + Math_fround(f79 * f39)));
     f36 = Math_fround(f47 + Math_fround(Math_fround(f80 * f551) + Math_fround(f81 * f36)));
     f37 = Math_fround(f47 + Math_fround(Math_fround(f80 * f550) + Math_fround(f81 * f37)));
     f38 = Math_fround(f47 + Math_fround(Math_fround(f80 * f549) + Math_fround(f81 * f38)));
     f39 = Math_fround(f47 + Math_fround(Math_fround(f80 * f548) + Math_fround(f81 * f39)));
     f548 = Math_fround(f29 + f537);
     f549 = Math_fround(f30 + f538);
     f550 = Math_fround(f31 + f539);
     f551 = Math_fround(f32 + f540);
     f552 = Math_fround(f33 + f541);
     f553 = Math_fround(f34 + f542);
     f554 = Math_fround(f35 + f543);
     f555 = Math_fround(f36 + f544);
     f556 = Math_fround(f37 + f545);
     f557 = Math_fround(f38 + f546);
     f558 = Math_fround(f39 + f547);
     HEAPF32[i524 >> 2] = Math_fround(f28 + f536);
     HEAPF32[i235 >> 2] = f548;
     HEAPF32[i236 >> 2] = f549;
     HEAPF32[i237 >> 2] = f550;
     HEAPF32[i238 >> 2] = f551;
     HEAPF32[i239 >> 2] = f552;
     HEAPF32[i240 >> 2] = f553;
     HEAPF32[i241 >> 2] = f554;
     HEAPF32[i242 >> 2] = f555;
     HEAPF32[i243 >> 2] = f556;
     HEAPF32[i244 >> 2] = f557;
     HEAPF32[i245 >> 2] = f558;
     f558 = Math_fround(f29 + f6);
     f557 = Math_fround(f30 + f7);
     f556 = Math_fround(f31 + f8);
     f555 = Math_fround(f32 + f9);
     f554 = Math_fround(f33 + f10);
     f553 = Math_fround(f34 + f25);
     f552 = Math_fround(f35 + f26);
     f551 = Math_fround(f36 + f532);
     f550 = Math_fround(f37 + f533);
     f549 = Math_fround(f38 + f534);
     f548 = Math_fround(f39 + f535);
     HEAPF32[i246 >> 2] = Math_fround(f28 + f5);
     HEAPF32[i247 >> 2] = f558;
     HEAPF32[i248 >> 2] = f557;
     HEAPF32[i249 >> 2] = f556;
     HEAPF32[i250 >> 2] = f555;
     HEAPF32[i251 >> 2] = f554;
     HEAPF32[i252 >> 2] = f553;
     HEAPF32[i253 >> 2] = f552;
     HEAPF32[i254 >> 2] = f551;
     HEAPF32[i255 >> 2] = f550;
     HEAPF32[i256 >> 2] = f549;
     HEAPF32[i257 >> 2] = f548;
     f6 = Math_fround(f6 - f29);
     f7 = Math_fround(f7 - f30);
     f8 = Math_fround(f8 - f31);
     f9 = Math_fround(f9 - f32);
     f10 = Math_fround(f10 - f33);
     f25 = Math_fround(f25 - f34);
     f26 = Math_fround(f26 - f35);
     f532 = Math_fround(f532 - f36);
     f533 = Math_fround(f533 - f37);
     f534 = Math_fround(f534 - f38);
     f535 = Math_fround(f535 - f39);
     HEAPF32[i258 >> 2] = Math_fround(f5 - f28);
     HEAPF32[i259 >> 2] = f6;
     HEAPF32[i260 >> 2] = f7;
     HEAPF32[i261 >> 2] = f8;
     HEAPF32[i262 >> 2] = f9;
     HEAPF32[i263 >> 2] = f10;
     HEAPF32[i264 >> 2] = f25;
     HEAPF32[i265 >> 2] = f26;
     HEAPF32[i266 >> 2] = f532;
     HEAPF32[i267 >> 2] = f533;
     HEAPF32[i268 >> 2] = f534;
     HEAPF32[i269 >> 2] = f535;
     f537 = Math_fround(f537 - f29);
     f538 = Math_fround(f538 - f30);
     f539 = Math_fround(f539 - f31);
     f540 = Math_fround(f540 - f32);
     f541 = Math_fround(f541 - f33);
     f542 = Math_fround(f542 - f34);
     f543 = Math_fround(f543 - f35);
     f544 = Math_fround(f544 - f36);
     f545 = Math_fround(f545 - f37);
     f546 = Math_fround(f546 - f38);
     f547 = Math_fround(f547 - f39);
     HEAPF32[i270 >> 2] = Math_fround(f536 - f28);
     HEAPF32[i271 >> 2] = f537;
     HEAPF32[i272 >> 2] = f538;
     HEAPF32[i273 >> 2] = f539;
     HEAPF32[i274 >> 2] = f540;
     HEAPF32[i275 >> 2] = f541;
     HEAPF32[i276 >> 2] = f542;
     HEAPF32[i277 >> 2] = f543;
     HEAPF32[i278 >> 2] = f544;
     HEAPF32[i279 >> 2] = f545;
     HEAPF32[i280 >> 2] = f546;
     HEAPF32[i281 >> 2] = f547;
     if (!i282) {
      i2 = HEAP32[i458 >> 2] | 0;
      if (i2 & 536870912) {
       f558 = Math_fround(HEAPF32[i77 >> 2]);
       i69 = HEAP32[i516 >> 2] | 0;
       i485 = i69 + 693089735 | 0;
       i67 = HEAP32[i215 >> 2] | 0;
       i461 = i67 + 693089735 | 0;
       i65 = HEAP32[i216 >> 2] | 0;
       i74 = i65 + 693089735 | 0;
       i63 = HEAP32[i217 >> 2] | 0;
       i71 = i63 + 693089735 | 0;
       i64 = (Math_imul(i485, 1790253981) | 0) + 1900727103 | 0;
       i66 = (Math_imul(i461, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i485 = i485 << 11 ^ i485;
       i461 = i461 << 11 ^ i461;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i64 = Math_fround(Math_fround((i64 ^ i485 ^ i485 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i66 = Math_fround(Math_fround((i66 ^ i461 ^ i461 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i68 = Math_fround(Math_fround((i68 ^ i74 ^ i74 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i70 = Math_fround(Math_fround((i70 ^ i71 ^ i71 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       f558 = Math_fround(HEAPF32[i76 >> 2]);
       i69 = i69 + 13945730 | 0;
       i67 = i67 + 13945730 | 0;
       i65 = i65 + 13945730 | 0;
       i63 = i63 + 13945730 | 0;
       i71 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i485 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i67 = i67 << 11 ^ i67;
       i65 = i65 << 11 ^ i65;
       i63 = i63 << 11 ^ i63;
       i71 = Math_fround(Math_fround((i71 ^ i69 ^ i69 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i74 = Math_fround(Math_fround((i74 ^ i67 ^ i67 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i461 = Math_fround(Math_fround((i461 ^ i65 ^ i65 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i485 = Math_fround(Math_fround((i485 ^ i63 ^ i63 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i63 = i64 & 1;
       i65 = i66 & 1;
       i67 = i68 & 1;
       i69 = i70 & 1;
       i72 = i63 ^ 1;
       i459 = i65 ^ 1;
       i462 = i67 ^ 1;
       i511 = i69 ^ 1;
       i73 = i64 ? 3 : 2;
       i460 = i66 ? 3 : 2;
       i463 = i68 ? 3 : 2;
       i2 = i70 ? 3 : 2;
       i64 = i64 ? 2 : 3;
       i66 = i66 ? 2 : 3;
       i68 = i68 ? 2 : 3;
       i70 = i70 ? 2 : 3;
       HEAP32[i521 >> 2] = i71 ? i64 : i63;
       HEAP32[i433 >> 2] = i74 ? i66 : i65;
       HEAP32[i432 >> 2] = i461 ? i68 : i67;
       HEAP32[i431 >> 2] = i485 ? i70 : i69;
       HEAP32[i457 >> 2] = i71 ? i63 : i64;
       HEAP32[i456 >> 2] = i74 ? i65 : i66;
       HEAP32[i455 >> 2] = i461 ? i67 : i68;
       HEAP32[i454 >> 2] = i485 ? i69 : i70;
       HEAP32[i437 >> 2] = i71 ? i73 : i72;
       HEAP32[i436 >> 2] = i74 ? i460 : i459;
       HEAP32[i435 >> 2] = i461 ? i463 : i462;
       HEAP32[i434 >> 2] = i485 ? i2 : i511;
       HEAP32[i453 >> 2] = i71 ? i72 : i73;
       HEAP32[i452 >> 2] = i74 ? i459 : i460;
       HEAP32[i439 >> 2] = i461 ? i462 : i463;
       HEAP32[i438 >> 2] = i485 ? i511 : i2;
       i2 = HEAP32[i458 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f490 * Math_fround(HEAPF32[i517 >> 2]));
       f6 = Math_fround(f490 * Math_fround(HEAPF32[i219 >> 2]));
       f7 = Math_fround(f490 * Math_fround(HEAPF32[i220 >> 2]));
       f8 = Math_fround(f490 * Math_fround(HEAPF32[i221 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f555 = Math_fround(Math_floor(Math_fround(f54 * f9)));
        f556 = Math_fround(Math_floor(Math_fround(f54 * f10)));
        f557 = Math_fround(Math_floor(Math_fround(f54 * f25)));
        f558 = Math_fround(Math_floor(Math_fround(f54 * f26)));
        f551 = Math_fround(f491 * Math_fround(f9 - Math_fround(f489 * f555)));
        f552 = Math_fround(f491 * Math_fround(f10 - Math_fround(f489 * f556)));
        f553 = Math_fround(f491 * Math_fround(f25 - Math_fround(f489 * f557)));
        f554 = Math_fround(f491 * Math_fround(f26 - Math_fround(f489 * f558)));
        f555 = Math_fround(f55 - Math_fround(f492 * f555));
        f556 = Math_fround(f55 - Math_fround(f492 * f556));
        f557 = Math_fround(f55 - Math_fround(f492 * f557));
        f558 = Math_fround(f55 - Math_fround(f492 * f558));
        f543 = Math_fround(f492 + f555);
        f544 = Math_fround(f492 + f556);
        f545 = Math_fround(f492 + f557);
        f546 = Math_fround(f492 + f558);
        HEAPF32[i522 >> 2] = f551;
        HEAPF32[i382 >> 2] = f552;
        HEAPF32[i406 >> 2] = f553;
        HEAPF32[i430 >> 2] = f554;
        HEAPF32[i358 >> 2] = f543;
        HEAPF32[i381 >> 2] = f544;
        HEAPF32[i405 >> 2] = f545;
        HEAPF32[i429 >> 2] = f546;
        f547 = Math_fround(f491 + f551);
        f548 = Math_fround(f491 + f552);
        f549 = Math_fround(f491 + f553);
        f550 = Math_fround(f491 + f554);
        HEAPF32[i357 >> 2] = f547;
        HEAPF32[i380 >> 2] = f548;
        HEAPF32[i404 >> 2] = f549;
        HEAPF32[i428 >> 2] = f550;
        HEAPF32[i356 >> 2] = f543;
        HEAPF32[i379 >> 2] = f544;
        HEAPF32[i403 >> 2] = f545;
        HEAPF32[i427 >> 2] = f546;
        HEAPF32[i355 >> 2] = f547;
        HEAPF32[i378 >> 2] = f548;
        HEAPF32[i402 >> 2] = f549;
        HEAPF32[i426 >> 2] = f550;
        HEAPF32[i354 >> 2] = f555;
        HEAPF32[i377 >> 2] = f556;
        HEAPF32[i401 >> 2] = f557;
        HEAPF32[i425 >> 2] = f558;
        HEAPF32[i353 >> 2] = f551;
        HEAPF32[i376 >> 2] = f552;
        HEAPF32[i400 >> 2] = f553;
        HEAPF32[i424 >> 2] = f554;
        HEAPF32[i352 >> 2] = f555;
        HEAPF32[i375 >> 2] = f556;
        HEAPF32[i399 >> 2] = f557;
        HEAPF32[i423 >> 2] = f558;
       }
       if (i2 & 33554432 | 0) {
        f547 = Math_fround(f9 + Math_fround(1.0));
        f548 = Math_fround(f10 + Math_fround(1.0));
        f549 = Math_fround(f25 + Math_fround(1.0));
        f550 = Math_fround(f26 + Math_fround(1.0));
        f555 = Math_fround(f5 - f9);
        f556 = Math_fround(f6 - f10);
        f557 = Math_fround(f7 - f25);
        f558 = Math_fround(f8 - f26);
        f551 = Math_fround(Math_floor(Math_fround(f54 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f54 * f548)));
        f553 = Math_fround(Math_floor(Math_fround(f54 * f549)));
        f554 = Math_fround(Math_floor(Math_fround(f54 * f550)));
        f547 = Math_fround(f491 * Math_fround(f547 - Math_fround(f489 * f551)));
        f548 = Math_fround(f491 * Math_fround(f548 - Math_fround(f489 * f552)));
        f549 = Math_fround(f491 * Math_fround(f549 - Math_fround(f489 * f553)));
        f550 = Math_fround(f491 * Math_fround(f550 - Math_fround(f489 * f554)));
        f551 = Math_fround(f55 - Math_fround(f492 * f551));
        f552 = Math_fround(f55 - Math_fround(f492 * f552));
        f553 = Math_fround(f55 - Math_fround(f492 * f553));
        f554 = Math_fround(f55 - Math_fround(f492 * f554));
        f539 = Math_fround(f492 + f551);
        f540 = Math_fround(f492 + f552);
        f541 = Math_fround(f492 + f553);
        f542 = Math_fround(f492 + f554);
        HEAPF32[i523 >> 2] = f547;
        HEAPF32[i374 >> 2] = f548;
        HEAPF32[i398 >> 2] = f549;
        HEAPF32[i422 >> 2] = f550;
        HEAPF32[i351 >> 2] = f539;
        HEAPF32[i373 >> 2] = f540;
        HEAPF32[i397 >> 2] = f541;
        HEAPF32[i421 >> 2] = f542;
        HEAPF32[i350 >> 2] = f555;
        HEAPF32[i372 >> 2] = f556;
        HEAPF32[i396 >> 2] = f557;
        HEAPF32[i420 >> 2] = f558;
        HEAPF32[i349 >> 2] = f5;
        HEAPF32[i371 >> 2] = f6;
        HEAPF32[i395 >> 2] = f7;
        HEAPF32[i419 >> 2] = f8;
        f543 = Math_fround(f491 + f547);
        f544 = Math_fround(f491 + f548);
        f545 = Math_fround(f491 + f549);
        f546 = Math_fround(f491 + f550);
        HEAPF32[i348 >> 2] = f543;
        HEAPF32[i370 >> 2] = f544;
        HEAPF32[i394 >> 2] = f545;
        HEAPF32[i418 >> 2] = f546;
        HEAPF32[i347 >> 2] = f539;
        HEAPF32[i369 >> 2] = f540;
        HEAPF32[i393 >> 2] = f541;
        HEAPF32[i417 >> 2] = f542;
        HEAPF32[i346 >> 2] = f555;
        HEAPF32[i368 >> 2] = f556;
        HEAPF32[i392 >> 2] = f557;
        HEAPF32[i416 >> 2] = f558;
        HEAPF32[i345 >> 2] = f5;
        HEAPF32[i367 >> 2] = f6;
        HEAPF32[i391 >> 2] = f7;
        HEAPF32[i415 >> 2] = f8;
        HEAPF32[i344 >> 2] = f543;
        HEAPF32[i366 >> 2] = f544;
        HEAPF32[i390 >> 2] = f545;
        HEAPF32[i414 >> 2] = f546;
        HEAPF32[i343 >> 2] = f551;
        HEAPF32[i365 >> 2] = f552;
        HEAPF32[i389 >> 2] = f553;
        HEAPF32[i413 >> 2] = f554;
        HEAPF32[i341 >> 2] = f555;
        HEAPF32[i364 >> 2] = f556;
        HEAPF32[i388 >> 2] = f557;
        HEAPF32[i412 >> 2] = f558;
        HEAPF32[i340 >> 2] = f5;
        HEAPF32[i363 >> 2] = f6;
        HEAPF32[i387 >> 2] = f7;
        HEAPF32[i411 >> 2] = f8;
        HEAPF32[i339 >> 2] = f547;
        HEAPF32[i362 >> 2] = f548;
        HEAPF32[i386 >> 2] = f549;
        HEAPF32[i410 >> 2] = f550;
        HEAPF32[i338 >> 2] = f551;
        HEAPF32[i361 >> 2] = f552;
        HEAPF32[i385 >> 2] = f553;
        HEAPF32[i409 >> 2] = f554;
        HEAPF32[i337 >> 2] = f555;
        HEAPF32[i360 >> 2] = f556;
        HEAPF32[i384 >> 2] = f557;
        HEAPF32[i408 >> 2] = f558;
        HEAPF32[i336 >> 2] = f5;
        HEAPF32[i359 >> 2] = f6;
        HEAPF32[i383 >> 2] = f7;
        HEAPF32[i407 >> 2] = f8;
       }
      }
     }
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f36 * f36) + Math_fround(Math_fround(f28 * f28) + Math_fround(f32 * f32))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f37 * f37) + Math_fround(Math_fround(f29 * f29) + Math_fround(f33 * f33))))));
     f557 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f38 * f38) + Math_fround(Math_fround(f30 * f30) + Math_fround(f34 * f34))))));
     f558 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f39 * f39) + Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35))))));
     f547 = Math_fround(f493 * Math_fround(f28 * f555));
     f548 = Math_fround(f493 * Math_fround(f29 * f556));
     f549 = Math_fround(f493 * Math_fround(f30 * f557));
     f550 = Math_fround(f493 * Math_fround(f31 * f558));
     f551 = Math_fround(f493 * Math_fround(f32 * f555));
     f552 = Math_fround(f493 * Math_fround(f33 * f556));
     f553 = Math_fround(f493 * Math_fround(f34 * f557));
     f554 = Math_fround(f493 * Math_fround(f35 * f558));
     f555 = Math_fround(f493 * Math_fround(f36 * f555));
     f556 = Math_fround(f493 * Math_fround(f37 * f556));
     f557 = Math_fround(f493 * Math_fround(f38 * f557));
     f558 = Math_fround(f493 * Math_fround(f39 * f558));
     f535 = Math_fround(f483 + f547);
     f536 = Math_fround(f483 + f548);
     f537 = Math_fround(f483 + f549);
     f538 = Math_fround(f483 + f550);
     f539 = Math_fround(f472 + f551);
     f540 = Math_fround(f472 + f552);
     f541 = Math_fround(f472 + f553);
     f542 = Math_fround(f472 + f554);
     f543 = Math_fround(f475 + f555);
     f544 = Math_fround(f475 + f556);
     f545 = Math_fround(f475 + f557);
     f546 = Math_fround(f475 + f558);
     HEAPF32[i525 >> 2] = f535;
     HEAPF32[i131 >> 2] = f536;
     HEAPF32[i148 >> 2] = f537;
     HEAPF32[i165 >> 2] = f538;
     HEAPF32[i283 >> 2] = f539;
     HEAPF32[i126 >> 2] = f540;
     HEAPF32[i143 >> 2] = f541;
     HEAPF32[i160 >> 2] = f542;
     HEAPF32[i284 >> 2] = f543;
     HEAPF32[i121 >> 2] = f544;
     HEAPF32[i138 >> 2] = f545;
     HEAPF32[i155 >> 2] = f546;
     HEAPF32[i285 >> 2] = f535;
     HEAPF32[i130 >> 2] = f536;
     HEAPF32[i147 >> 2] = f537;
     HEAPF32[i164 >> 2] = f538;
     HEAPF32[i286 >> 2] = f539;
     HEAPF32[i125 >> 2] = f540;
     HEAPF32[i142 >> 2] = f541;
     HEAPF32[i159 >> 2] = f542;
     HEAPF32[i287 >> 2] = f543;
     HEAPF32[i120 >> 2] = f544;
     HEAPF32[i137 >> 2] = f545;
     HEAPF32[i154 >> 2] = f546;
     f547 = Math_fround(f483 - f547);
     f548 = Math_fround(f483 - f548);
     f549 = Math_fround(f483 - f549);
     f550 = Math_fround(f483 - f550);
     f551 = Math_fround(f472 - f551);
     f552 = Math_fround(f472 - f552);
     f553 = Math_fround(f472 - f553);
     f554 = Math_fround(f472 - f554);
     f555 = Math_fround(f475 - f555);
     f556 = Math_fround(f475 - f556);
     f557 = Math_fround(f475 - f557);
     f558 = Math_fround(f475 - f558);
     HEAPF32[i288 >> 2] = f547;
     HEAPF32[i129 >> 2] = f548;
     HEAPF32[i146 >> 2] = f549;
     HEAPF32[i163 >> 2] = f550;
     HEAPF32[i289 >> 2] = f551;
     HEAPF32[i124 >> 2] = f552;
     HEAPF32[i141 >> 2] = f553;
     HEAPF32[i158 >> 2] = f554;
     HEAPF32[i290 >> 2] = f555;
     HEAPF32[i119 >> 2] = f556;
     HEAPF32[i136 >> 2] = f557;
     HEAPF32[i153 >> 2] = f558;
     HEAPF32[i291 >> 2] = f547;
     HEAPF32[i128 >> 2] = f548;
     HEAPF32[i145 >> 2] = f549;
     HEAPF32[i162 >> 2] = f550;
     HEAPF32[i292 >> 2] = f551;
     HEAPF32[i123 >> 2] = f552;
     HEAPF32[i140 >> 2] = f553;
     HEAPF32[i157 >> 2] = f554;
     HEAPF32[i293 >> 2] = f555;
     HEAPF32[i118 >> 2] = f556;
     HEAPF32[i135 >> 2] = f557;
     HEAPF32[i152 >> 2] = f558;
     do if (i169) {
      i4 = HEAP32[i191 >> 2] | 0;
      i11 = HEAP32[i528 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i511 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i246 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i285 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i258 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i288 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i270 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i291 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i511 >> 2];
        i511 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i511 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i511 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i511 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i246 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i285 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i258 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i288 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i511 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i270 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i291 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i511 >> 2];
        i511 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i511 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i511 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f554 = Math_fround(HEAPF32[i246 >> 2]);
      f554 = Math_fround(f554 - Math_fround(HEAPF32[i524 >> 2]));
      f556 = Math_fround(HEAPF32[i247 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i235 >> 2]));
      f557 = Math_fround(HEAPF32[i248 >> 2]);
      f557 = Math_fround(f557 - Math_fround(HEAPF32[i236 >> 2]));
      f558 = Math_fround(HEAPF32[i249 >> 2]);
      f558 = Math_fround(f558 - Math_fround(HEAPF32[i237 >> 2]));
      f8 = Math_fround(HEAPF32[i250 >> 2]);
      f8 = Math_fround(f8 - Math_fround(HEAPF32[i238 >> 2]));
      f7 = Math_fround(HEAPF32[i251 >> 2]);
      f7 = Math_fround(f7 - Math_fround(HEAPF32[i239 >> 2]));
      f6 = Math_fround(HEAPF32[i252 >> 2]);
      f6 = Math_fround(f6 - Math_fround(HEAPF32[i240 >> 2]));
      f5 = Math_fround(HEAPF32[i253 >> 2]);
      f5 = Math_fround(f5 - Math_fround(HEAPF32[i241 >> 2]));
      f9 = Math_fround(HEAPF32[i254 >> 2]);
      f9 = Math_fround(f9 - Math_fround(HEAPF32[i242 >> 2]));
      f551 = Math_fround(HEAPF32[i255 >> 2]);
      f551 = Math_fround(f551 - Math_fround(HEAPF32[i243 >> 2]));
      f552 = Math_fround(HEAPF32[i256 >> 2]);
      f552 = Math_fround(f552 - Math_fround(HEAPF32[i244 >> 2]));
      f553 = Math_fround(HEAPF32[i257 >> 2]);
      f553 = Math_fround(f553 - Math_fround(HEAPF32[i245 >> 2]));
      f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f554 * f554) + Math_fround(f8 * f8)) + Math_fround(f9 * f9)))));
      f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f556 * f556) + Math_fround(f7 * f7)) + Math_fround(f551 * f551)))));
      f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f557 * f557) + Math_fround(f6 * f6)) + Math_fround(f552 * f552)))));
      f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f558 * f558) + Math_fround(f5 * f5)) + Math_fround(f553 * f553)))));
      f556 = Math_fround(f556 * f10);
      f557 = Math_fround(f557 * f25);
      f558 = Math_fround(f558 * f26);
      f8 = Math_fround(f8 * f555);
      f7 = Math_fround(f7 * f10);
      f6 = Math_fround(f6 * f25);
      f5 = Math_fround(f5 * f26);
      f9 = Math_fround(f9 * f555);
      f10 = Math_fround(f551 * f10);
      f25 = Math_fround(f552 * f25);
      f26 = Math_fround(f553 * f26);
      HEAPF32[i519 >> 2] = Math_fround(f554 * f555);
      HEAPF32[i132 >> 2] = f556;
      HEAPF32[i149 >> 2] = f557;
      HEAPF32[i166 >> 2] = f558;
      HEAPF32[i294 >> 2] = f8;
      HEAPF32[i127 >> 2] = f7;
      HEAPF32[i144 >> 2] = f6;
      HEAPF32[i161 >> 2] = f5;
      HEAPF32[i295 >> 2] = f9;
      HEAPF32[i122 >> 2] = f10;
      HEAPF32[i139 >> 2] = f25;
      HEAPF32[i156 >> 2] = f26;
      f26 = Math_fround(f27 * Math_fround(2.0));
      f25 = Math_fround(f40 * Math_fround(2.0));
      f10 = Math_fround(f41 * Math_fround(2.0));
      f9 = Math_fround(f42 * Math_fround(2.0));
      f5 = Math_fround(f43 * Math_fround(2.0));
      f6 = Math_fround(f44 * Math_fround(2.0));
      f7 = Math_fround(f45 * Math_fround(2.0));
      f8 = Math_fround(f46 * Math_fround(2.0));
      i4 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i3 = i11 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i2 = i12 ? (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i511 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      HEAPF32[i520 >> 2] = f26;
      HEAPF32[i134 >> 2] = f25;
      HEAPF32[i151 >> 2] = f10;
      HEAPF32[i168 >> 2] = f9;
      HEAP32[i117 >> 2] = i4;
      HEAP32[i133 >> 2] = i3;
      HEAP32[i150 >> 2] = i2;
      HEAP32[i167 >> 2] = i511;
      HEAP32[i116 >> 2] = 0;
      HEAP32[i116 + 4 >> 2] = 0;
      HEAP32[i116 + 8 >> 2] = 0;
      HEAP32[i116 + 12 >> 2] = 0;
      if (i296) {
       f538 = Math_fround(HEAPF32[i512 >> 2]);
       f556 = Math_fround(f498 * f538);
       f540 = Math_fround(HEAPF32[i184 >> 2]);
       f547 = Math_fround(f498 * f540);
       f542 = Math_fround(HEAPF32[i183 >> 2]);
       f555 = Math_fround(f498 * f542);
       f544 = Math_fround(HEAPF32[i182 >> 2]);
       f550 = Math_fround(f498 * f544);
       f539 = Math_fround(HEAPF32[i200 >> 2]);
       f546 = Math_fround(f501 * f539);
       f541 = Math_fround(HEAPF32[i187 >> 2]);
       f552 = Math_fround(f501 * f541);
       f543 = Math_fround(HEAPF32[i186 >> 2]);
       f551 = Math_fround(f501 * f543);
       f545 = Math_fround(HEAPF32[i185 >> 2]);
       f546 = Math_fround(f556 + f546);
       f552 = Math_fround(f547 + f552);
       f551 = Math_fround(f555 + f551);
       f550 = Math_fround(f550 + Math_fround(f501 * f545));
       f555 = Math_fround(HEAPF32[i201 >> 2]);
       f547 = Math_fround(f504 * f555);
       f556 = Math_fround(HEAPF32[i190 >> 2]);
       f548 = Math_fround(f504 * f556);
       f557 = Math_fround(HEAPF32[i189 >> 2]);
       f549 = Math_fround(f504 * f557);
       f558 = Math_fround(HEAPF32[i188 >> 2]);
       f548 = Math_fround(f552 + f548);
       f549 = Math_fround(f551 + f549);
       f550 = Math_fround(f550 + Math_fround(f504 * f558));
       f551 = Math_fround(Math_fround(Math_fround(f499 * f538) + Math_fround(f502 * f539)) + Math_fround(f505 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f499 * f540) + Math_fround(f502 * f541)) + Math_fround(f505 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f499 * f542) + Math_fround(f502 * f543)) + Math_fround(f505 * f557));
       f554 = Math_fround(Math_fround(Math_fround(f499 * f544) + Math_fround(f502 * f545)) + Math_fround(f505 * f558));
       f555 = Math_fround(Math_fround(Math_fround(f500 * f538) + Math_fround(f503 * f539)) + Math_fround(f506 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f500 * f540) + Math_fround(f503 * f541)) + Math_fround(f506 * f556));
       f557 = Math_fround(Math_fround(Math_fround(f500 * f542) + Math_fround(f503 * f543)) + Math_fround(f506 * f557));
       f558 = Math_fround(Math_fround(Math_fround(f500 * f544) + Math_fround(f503 * f545)) + Math_fround(f506 * f558));
       HEAPF32[i510 >> 2] = Math_fround(f546 + f547);
       HEAPF32[i297 >> 2] = f548;
       HEAPF32[i298 >> 2] = f549;
       HEAPF32[i299 >> 2] = f550;
       HEAPF32[i300 >> 2] = f551;
       HEAPF32[i301 >> 2] = f552;
       HEAPF32[i302 >> 2] = f553;
       HEAPF32[i303 >> 2] = f554;
       HEAPF32[i304 >> 2] = f555;
       HEAPF32[i305 >> 2] = f556;
       HEAPF32[i306 >> 2] = f557;
       HEAPF32[i307 >> 2] = f558;
      }
      if (i308) {
       i459 = HEAP32[i516 >> 2] | 0;
       i462 = i459 + 1068538453 | 0;
       i463 = HEAP32[i215 >> 2] | 0;
       i461 = i463 + 1068538453 | 0;
       i72 = HEAP32[i216 >> 2] | 0;
       i71 = i72 + 1068538453 | 0;
       i70 = HEAP32[i217 >> 2] | 0;
       i74 = i70 + 1068538453 | 0;
       i485 = (Math_imul(i462, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i461, 1790253981) | 0) + 1900727103 | 0;
       i511 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i460 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i462 = i462 << 11 ^ i462;
       i461 = i461 << 11 ^ i461;
       i71 = i71 << 11 ^ i71;
       i74 = i74 << 11 ^ i74;
       f556 = Math_fround(Math_fround((i73 ^ i461 ^ i461 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i511 ^ i71 ^ i71 >>> 8) & 8388607 ^ i511 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i460 ^ i74 ^ i74 >>> 8) & 8388607 ^ i460 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i526 >> 2] = Math_fround(Math_fround((i485 ^ i462 ^ i462 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i309 >> 2] = f556;
       HEAPF32[i310 >> 2] = f557;
       HEAPF32[i311 >> 2] = f558;
       i459 = i459 + 1068538454 | 0;
       i463 = i463 + 1068538454 | 0;
       i72 = i72 + 1068538454 | 0;
       i70 = i70 + 1068538454 | 0;
       i485 = (Math_imul(i459, 1790253981) | 0) + 1900727103 | 0;
       i462 = (Math_imul(i463, 1790253981) | 0) + 1900727103 | 0;
       i460 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i459 = i459 << 11 ^ i459;
       i463 = i463 << 11 ^ i463;
       i72 = i72 << 11 ^ i72;
       i70 = i70 << 11 ^ i70;
       f558 = Math_fround(Math_fround((i462 ^ i463 ^ i463 >>> 8) & 8388607 ^ i462 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i460 ^ i72 ^ i72 >>> 8) & 8388607 ^ i460 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i74 ^ i70 ^ i70 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i312 >> 2] = Math_fround(Math_fround((i485 ^ i459 ^ i459 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i313 >> 2] = f558;
       HEAPF32[i314 >> 2] = f557;
       HEAPF32[i315 >> 2] = f556;
       i485 = HEAP32[i516 >> 2] | 0;
       i459 = i485 + 1068538455 | 0;
       i74 = HEAP32[i215 >> 2] | 0;
       i70 = i74 + 1068538455 | 0;
       i460 = HEAP32[i216 >> 2] | 0;
       i72 = i460 + 1068538455 | 0;
       i462 = HEAP32[i217 >> 2] | 0;
       i463 = i462 + 1068538455 | 0;
       i511 = (Math_imul(i459, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i463, 1790253981) | 0) + 1900727103 | 0;
       i459 = i459 << 11 ^ i459;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       i463 = i463 << 11 ^ i463;
       f556 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i461 ^ i463 ^ i463 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i316 >> 2] = Math_fround(Math_fround((i511 ^ i459 ^ i459 >>> 8) & 8388607 ^ i511 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i317 >> 2] = f556;
       HEAPF32[i318 >> 2] = f557;
       HEAPF32[i319 >> 2] = f558;
       f558 = Math_fround(Math_fround(HEAPF32[i515 >> 2]) * Math_fround(1.0e5));
       f557 = Math_fround(Math_fround(HEAPF32[i211 >> 2]) * Math_fround(1.0e5));
       f556 = Math_fround(Math_fround(HEAPF32[i212 >> 2]) * Math_fround(1.0e5));
       i485 = i485 + 1068538453 + ~~f558 | 0;
       i74 = i74 + 1068538453 + ~~f557 | 0;
       i460 = i460 + 1068538453 + ~~f556 | 0;
       i462 = i462 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i213 >> 2]) * Math_fround(1.0e5)) | 0;
       i511 = (Math_imul(i485, 1790253981) | 0) + 1900727103 | 0;
       i459 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i460, 1790253981) | 0) + 1900727103 | 0;
       i463 = (Math_imul(i462, 1790253981) | 0) + 1900727103 | 0;
       i485 = i485 << 11 ^ i485;
       i74 = i74 << 11 ^ i74;
       i460 = i460 << 11 ^ i460;
       i462 = i462 << 11 ^ i462;
       f556 = Math_fround(Math_fround((i459 ^ i74 ^ i74 >>> 8) & 8388607 ^ i459 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i461 ^ i460 ^ i460 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i463 ^ i462 ^ i462 >>> 8) & 8388607 ^ i463 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i320 >> 2] = Math_fround(Math_fround((i511 ^ i485 ^ i485 >>> 8) & 8388607 ^ i511 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i321 >> 2] = f556;
       HEAPF32[i322 >> 2] = f557;
       HEAPF32[i323 >> 2] = f558;
      }
      i67 = HEAP32[i191 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i91 >> 2] | 0;
      i70 = HEAP32[i93 >> 2] | 0;
      i71 = HEAP32[i210 >> 2] | 0;
      i72 = HEAP32[i94 >> 2] | 0;
      i73 = HEAP32[i95 >> 2] | 0;
      i74 = HEAP32[i528 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i510 + (i66 << 2) | 0;
       i12 = i331 + (i66 << 2) | 0;
       i13 = i332 + (i66 << 2) | 0;
       i14 = i526 + (i66 << 2) | 0;
       i15 = i312 + (i66 << 2) | 0;
       i16 = i316 + (i66 << 2) | 0;
       i17 = i320 + (i66 << 2) | 0;
       i18 = i519 + (i66 << 2) | 0;
       i19 = i88 + (i66 << 2) | 0;
       i20 = i89 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i520 + (i66 << 2) | 0;
       i61 = i96 + (i66 << 2) | 0;
       i62 = i97 + (i66 << 2) | 0;
       i63 = i518 + (i66 << 2) | 0;
       i64 = i98 + (i66 << 2) | 0;
       i65 = i99 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i524 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i324) {
         i511 = i525 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i511 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i511 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i511 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i325) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i326) {
         i511 = i522 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i511 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i511 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i327) {
         i511 = i523 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i511 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i511 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i511 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i511 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i328) {
         f558 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f558;
         i1 = i1 + 16 | 0;
        }
        if (!i329) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i330) {
         i511 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i511;
         HEAP32[i1 + 4 >> 2] = i511;
         HEAP32[i1 + 8 >> 2] = i511;
         i1 = i1 + 12 | 0;
        }
        if (i296) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i333) {
         f558 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i511 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f558;
         HEAP32[i1 + 4 >> 2] = i511;
         i1 = i1 + 8 | 0;
        }
        if (!i334) {
         i511 = (HEAP32[i92 >> 2] & 2147483647 | 0) == 0 ? i529 : i22;
         HEAP32[i1 >> 2] = HEAP32[i511 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i511 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i511 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i511 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i335) {
         i511 = (HEAP32[i90 >> 2] & 2147483647 | 0) == 0 ? i529 : i21;
         HEAP32[i1 >> 2] = HEAP32[i511 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i511 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i511 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i511 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i308) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i78) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i170 >>> 0);
   }
   STACKTOP = i531;
   return;
  }
 case 2:
  {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i463 = i13 + 380 | 0;
   f490 = Math_fround(HEAPF32[i463 >> 2]);
   f479 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f483 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 392 | 0;
   f487 = Math_fround(HEAPF32[i463 >> 2]);
   f476 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f480 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 332 | 0;
   f491 = Math_fround((HEAP32[i463 >> 2] & 4095) >>> 0);
   f492 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f493 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f494 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   i3 = i13 + 420 | 0;
   f495 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i1 = i13 + 408 | 0;
   f488 = Math_fround(HEAPF32[i1 >> 2]);
   f477 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f481 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i1 = i13 + 336 | 0;
   f496 = Math_fround(HEAPF32[i1 >> 2]);
   f497 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f498 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f499 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   i1 = i13 + 352 | 0;
   f486 = Math_fround(HEAPF32[i1 >> 2]);
   f475 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i13 + 360 | 0;
   f484 = Math_fround(HEAPF32[i1 >> 2]);
   f474 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i2 + 36 | 0;
   f489 = Math_fround(HEAPF32[i1 >> 2]);
   f478 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f482 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i2 = HEAP32[i2 + 56 >> 2] | 0;
   f450 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f451 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f464 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f465 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f466 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f467 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f468 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f469 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f470 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f471 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f472 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f473 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   i1 = i13 + 64 | 0;
   i436 = i521 + 12 | 0;
   i437 = i521 + 8 | 0;
   i438 = i521 + 4 | 0;
   i439 = i521 + 28 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAP32[i439 >> 2] = 1;
   i452 = i521 + 24 | 0;
   HEAP32[i452 >> 2] = 1;
   i453 = i521 + 20 | 0;
   HEAP32[i453 >> 2] = 1;
   i454 = i521 + 16 | 0;
   HEAP32[i454 >> 2] = 1;
   i455 = i521 + 44 | 0;
   HEAP32[i455 >> 2] = 2;
   i456 = i521 + 40 | 0;
   HEAP32[i456 >> 2] = 2;
   i457 = i521 + 36 | 0;
   HEAP32[i457 >> 2] = 2;
   i458 = i521 + 32 | 0;
   HEAP32[i458 >> 2] = 2;
   i459 = i521 + 60 | 0;
   HEAP32[i459 >> 2] = 3;
   i460 = i521 + 56 | 0;
   HEAP32[i460 >> 2] = 3;
   i461 = i521 + 52 | 0;
   HEAP32[i461 >> 2] = 3;
   i462 = i521 + 48 | 0;
   HEAP32[i462 >> 2] = 3;
   i387 = i522 + 4 | 0;
   i411 = i522 + 8 | 0;
   i435 = i522 + 12 | 0;
   i363 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i363 >> 2] = Math_fround(1.0);
   i386 = i522 + 20 | 0;
   HEAPF32[i386 >> 2] = Math_fround(1.0);
   i410 = i522 + 24 | 0;
   HEAPF32[i410 >> 2] = Math_fround(1.0);
   i434 = i522 + 28 | 0;
   HEAPF32[i434 >> 2] = Math_fround(1.0);
   i362 = i522 + 32 | 0;
   HEAPF32[i362 >> 2] = Math_fround(1.0);
   i385 = i522 + 36 | 0;
   HEAPF32[i385 >> 2] = Math_fround(1.0);
   i409 = i522 + 40 | 0;
   HEAPF32[i409 >> 2] = Math_fround(1.0);
   i433 = i522 + 44 | 0;
   HEAPF32[i433 >> 2] = Math_fround(1.0);
   i361 = i522 + 48 | 0;
   HEAPF32[i361 >> 2] = Math_fround(1.0);
   i384 = i522 + 52 | 0;
   HEAPF32[i384 >> 2] = Math_fround(1.0);
   i408 = i522 + 56 | 0;
   HEAPF32[i408 >> 2] = Math_fround(1.0);
   i432 = i522 + 60 | 0;
   HEAPF32[i432 >> 2] = Math_fround(1.0);
   i360 = i522 + 64 | 0;
   HEAPF32[i360 >> 2] = Math_fround(1.0);
   i383 = i522 + 68 | 0;
   HEAPF32[i383 >> 2] = Math_fround(1.0);
   i407 = i522 + 72 | 0;
   HEAPF32[i407 >> 2] = Math_fround(1.0);
   i431 = i522 + 76 | 0;
   HEAPF32[i431 >> 2] = Math_fround(1.0);
   i359 = i522 + 80 | 0;
   i382 = i522 + 84 | 0;
   i406 = i522 + 88 | 0;
   i430 = i522 + 92 | 0;
   i358 = i522 + 96 | 0;
   i381 = i522 + 100 | 0;
   i405 = i522 + 104 | 0;
   i429 = i522 + 108 | 0;
   i357 = i522 + 112 | 0;
   i380 = i522 + 116 | 0;
   i404 = i522 + 120 | 0;
   i428 = i522 + 124 | 0;
   i17 = i359;
   i15 = i17 + 48 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i379 = i523 + 4 | 0;
   i403 = i523 + 8 | 0;
   i427 = i523 + 12 | 0;
   i356 = i523 + 16 | 0;
   HEAP32[i523 >> 2] = 0;
   HEAP32[i523 + 4 >> 2] = 0;
   HEAP32[i523 + 8 >> 2] = 0;
   HEAP32[i523 + 12 >> 2] = 0;
   HEAPF32[i356 >> 2] = Math_fround(1.0);
   i378 = i523 + 20 | 0;
   HEAPF32[i378 >> 2] = Math_fround(1.0);
   i402 = i523 + 24 | 0;
   HEAPF32[i402 >> 2] = Math_fround(1.0);
   i426 = i523 + 28 | 0;
   HEAPF32[i426 >> 2] = Math_fround(1.0);
   i355 = i523 + 32 | 0;
   i377 = i523 + 36 | 0;
   i401 = i523 + 40 | 0;
   i425 = i523 + 44 | 0;
   i354 = i523 + 48 | 0;
   i376 = i523 + 52 | 0;
   i400 = i523 + 56 | 0;
   i424 = i523 + 60 | 0;
   i353 = i523 + 64 | 0;
   HEAP32[i355 >> 2] = 0;
   HEAP32[i355 + 4 >> 2] = 0;
   HEAP32[i355 + 8 >> 2] = 0;
   HEAP32[i355 + 12 >> 2] = 0;
   HEAP32[i355 + 16 >> 2] = 0;
   HEAP32[i355 + 20 >> 2] = 0;
   HEAP32[i355 + 24 >> 2] = 0;
   HEAP32[i355 + 28 >> 2] = 0;
   HEAPF32[i353 >> 2] = Math_fround(1.0);
   i375 = i523 + 68 | 0;
   HEAPF32[i375 >> 2] = Math_fround(1.0);
   i399 = i523 + 72 | 0;
   HEAPF32[i399 >> 2] = Math_fround(1.0);
   i423 = i523 + 76 | 0;
   HEAPF32[i423 >> 2] = Math_fround(1.0);
   i352 = i523 + 80 | 0;
   HEAPF32[i352 >> 2] = Math_fround(1.0);
   i374 = i523 + 84 | 0;
   HEAPF32[i374 >> 2] = Math_fround(1.0);
   i398 = i523 + 88 | 0;
   HEAPF32[i398 >> 2] = Math_fround(1.0);
   i422 = i523 + 92 | 0;
   HEAPF32[i422 >> 2] = Math_fround(1.0);
   i351 = i523 + 96 | 0;
   i373 = i523 + 100 | 0;
   i397 = i523 + 104 | 0;
   i421 = i523 + 108 | 0;
   i350 = i523 + 112 | 0;
   i372 = i523 + 116 | 0;
   i396 = i523 + 120 | 0;
   i420 = i523 + 124 | 0;
   i349 = i523 + 128 | 0;
   HEAP32[i351 >> 2] = 0;
   HEAP32[i351 + 4 >> 2] = 0;
   HEAP32[i351 + 8 >> 2] = 0;
   HEAP32[i351 + 12 >> 2] = 0;
   HEAP32[i351 + 16 >> 2] = 0;
   HEAP32[i351 + 20 >> 2] = 0;
   HEAP32[i351 + 24 >> 2] = 0;
   HEAP32[i351 + 28 >> 2] = 0;
   HEAPF32[i349 >> 2] = Math_fround(1.0);
   i371 = i523 + 132 | 0;
   HEAPF32[i371 >> 2] = Math_fround(1.0);
   i395 = i523 + 136 | 0;
   HEAPF32[i395 >> 2] = Math_fround(1.0);
   i419 = i523 + 140 | 0;
   HEAPF32[i419 >> 2] = Math_fround(1.0);
   i348 = i523 + 144 | 0;
   i370 = i523 + 148 | 0;
   i394 = i523 + 152 | 0;
   i418 = i523 + 156 | 0;
   i347 = i523 + 160 | 0;
   i369 = i523 + 164 | 0;
   i393 = i523 + 168 | 0;
   i417 = i523 + 172 | 0;
   i346 = i523 + 176 | 0;
   i368 = i523 + 180 | 0;
   i392 = i523 + 184 | 0;
   i416 = i523 + 188 | 0;
   i345 = i523 + 192 | 0;
   i367 = i523 + 196 | 0;
   i391 = i523 + 200 | 0;
   i415 = i523 + 204 | 0;
   i344 = i523 + 208 | 0;
   i366 = i523 + 212 | 0;
   i390 = i523 + 216 | 0;
   i414 = i523 + 220 | 0;
   i343 = i523 + 224 | 0;
   i365 = i523 + 228 | 0;
   i389 = i523 + 232 | 0;
   i413 = i523 + 236 | 0;
   i341 = i523 + 240 | 0;
   i364 = i523 + 244 | 0;
   i388 = i523 + 248 | 0;
   i412 = i523 + 252 | 0;
   i17 = i348;
   i15 = i17 + 112 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i17 = i12;
   i15 = i17 + 64 | 0;
   do {
    HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
    i17 = i17 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
   f443 = Math_fround(HEAPF32[i3 >> 2]);
   f552 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f342 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f554 = Math_fround(HEAPF32[i14 >> 2]);
   i336 = i14 + 4 | 0;
   f550 = Math_fround(HEAPF32[i336 >> 2]);
   i337 = i14 + 8 | 0;
   f447 = Math_fround(HEAPF32[i337 >> 2]);
   i338 = i14 + 12 | 0;
   f556 = Math_fround(HEAPF32[i338 >> 2]);
   i339 = i14 + 16 | 0;
   f551 = Math_fround(HEAPF32[i339 >> 2]);
   i340 = i14 + 20 | 0;
   f448 = Math_fround(HEAPF32[i340 >> 2]);
   i485 = i14 + 24 | 0;
   f558 = Math_fround(HEAPF32[i485 >> 2]);
   i168 = i14 + 28 | 0;
   f553 = Math_fround(HEAPF32[i168 >> 2]);
   i167 = i14 + 32 | 0;
   f449 = Math_fround(HEAPF32[i167 >> 2]);
   f555 = Math_fround(f550 * Math_fround(0.0));
   f444 = Math_fround(f447 * Math_fround(0.0));
   f441 = Math_fround(Math_fround(Math_fround(f443 * f554) + f555) + f444);
   f557 = Math_fround(f551 * Math_fround(0.0));
   f445 = Math_fround(f448 * Math_fround(0.0));
   f442 = Math_fround(Math_fround(Math_fround(f443 * f556) + f557) + f445);
   f440 = Math_fround(f553 * Math_fround(0.0));
   f446 = Math_fround(f449 * Math_fround(0.0));
   f443 = Math_fround(Math_fround(Math_fround(f443 * f558) + f440) + f446);
   f554 = Math_fround(f554 * Math_fround(0.0));
   f444 = Math_fround(Math_fround(f554 + Math_fround(f552 * f550)) + f444);
   f556 = Math_fround(f556 * Math_fround(0.0));
   f445 = Math_fround(Math_fround(f556 + Math_fround(f552 * f551)) + f445);
   f558 = Math_fround(f558 * Math_fround(0.0));
   f446 = Math_fround(Math_fround(f558 + Math_fround(f552 * f553)) + f446);
   f447 = Math_fround(Math_fround(f554 + f555) + Math_fround(f342 * f447));
   f448 = Math_fround(Math_fround(f556 + f557) + Math_fround(f342 * f448));
   f449 = Math_fround(Math_fround(f558 + f440) + Math_fround(f342 * f449));
   HEAPF32[i14 >> 2] = f441;
   HEAPF32[i336 >> 2] = f444;
   HEAPF32[i337 >> 2] = f447;
   HEAPF32[i338 >> 2] = f442;
   HEAPF32[i339 >> 2] = f445;
   HEAPF32[i340 >> 2] = f448;
   HEAPF32[i485 >> 2] = f443;
   HEAPF32[i168 >> 2] = f446;
   HEAPF32[i167 >> 2] = f449;
   f342 = Math_fround(Math_fround(1.0) / f491);
   f440 = Math_fround(Math_fround(1.0) - f494);
   i167 = (i2 | 0) == 27;
   HEAP32[i511 >> 2] = 0;
   HEAP32[i511 + 4 >> 2] = 0;
   HEAP32[i511 + 8 >> 2] = 0;
   HEAP32[i511 + 12 >> 2] = 0;
   i168 = HEAP32[i527 + 12 >> 2] | 0;
   if (i168 | 0) {
    i169 = i529 + 12 | 0;
    i170 = i529 + 8 | 0;
    i171 = i529 + 4 | 0;
    i172 = i529 + 16 | 0;
    i173 = i529 + 28 | 0;
    i174 = i529 + 24 | 0;
    i175 = i529 + 20 | 0;
    i176 = i529 + 32 | 0;
    i177 = i529 + 44 | 0;
    i178 = i529 + 40 | 0;
    i179 = i529 + 36 | 0;
    i180 = i530 + 32 | 0;
    i181 = i530 + 44 | 0;
    i182 = i530 + 40 | 0;
    i183 = i530 + 36 | 0;
    i184 = i512 + 12 | 0;
    i185 = i512 + 8 | 0;
    i186 = i512 + 4 | 0;
    i187 = i512 + 28 | 0;
    i188 = i512 + 24 | 0;
    i189 = i512 + 20 | 0;
    i190 = i512 + 44 | 0;
    i191 = i512 + 40 | 0;
    i192 = i512 + 36 | 0;
    i193 = i528 + 20 | 0;
    i194 = i527 + 20 | 0;
    i195 = i527 + 40 | 0;
    i196 = i527 + 340 | 0;
    i197 = i527 + 60 | 0;
    i198 = i527 + 80 | 0;
    i199 = i527 + 100 | 0;
    i200 = i527 + 120 | 0;
    i201 = i527 + 140 | 0;
    i202 = i527 + 160 | 0;
    i203 = i512 + 16 | 0;
    i204 = i512 + 32 | 0;
    i205 = i528 + 4 | 0;
    i206 = i513 + 4 | 0;
    i207 = i513 + 8 | 0;
    i208 = i513 + 12 | 0;
    i209 = i528 + 8 | 0;
    i210 = i514 + 4 | 0;
    i211 = i514 + 8 | 0;
    i212 = i514 + 12 | 0;
    i213 = i527 + 520 | 0;
    i214 = i515 + 4 | 0;
    i215 = i515 + 8 | 0;
    i216 = i515 + 12 | 0;
    i217 = i527 + 500 | 0;
    i218 = i516 + 4 | 0;
    i219 = i516 + 8 | 0;
    i220 = i516 + 12 | 0;
    i221 = i528 + 16 | 0;
    i222 = i517 + 4 | 0;
    i223 = i517 + 8 | 0;
    i224 = i517 + 12 | 0;
    i225 = i529 + 16 | 0;
    i226 = i529 + 32 | 0;
    i227 = i518 + 4 | 0;
    i228 = i518 + 8 | 0;
    i229 = i518 + 12 | 0;
    i230 = i518 + 16 | 0;
    i231 = i518 + 20 | 0;
    i232 = i518 + 24 | 0;
    i233 = i518 + 28 | 0;
    i234 = i518 + 32 | 0;
    i235 = i518 + 36 | 0;
    i236 = i518 + 40 | 0;
    i237 = i518 + 44 | 0;
    i238 = i530 + 32 | 0;
    i239 = i524 + 4 | 0;
    i240 = i524 + 8 | 0;
    i241 = i524 + 12 | 0;
    i242 = i524 + 16 | 0;
    i243 = i524 + 20 | 0;
    i244 = i524 + 24 | 0;
    i245 = i524 + 28 | 0;
    i246 = i524 + 32 | 0;
    i247 = i524 + 36 | 0;
    i248 = i524 + 40 | 0;
    i249 = i524 + 44 | 0;
    i250 = i524 + 48 | 0;
    i251 = i524 + 52 | 0;
    i252 = i524 + 56 | 0;
    i253 = i524 + 60 | 0;
    i254 = i524 + 64 | 0;
    i255 = i524 + 68 | 0;
    i256 = i524 + 72 | 0;
    i257 = i524 + 76 | 0;
    i258 = i524 + 80 | 0;
    i259 = i524 + 84 | 0;
    i260 = i524 + 88 | 0;
    i261 = i524 + 92 | 0;
    i262 = i524 + 96 | 0;
    i263 = i524 + 100 | 0;
    i264 = i524 + 104 | 0;
    i265 = i524 + 108 | 0;
    i266 = i524 + 112 | 0;
    i267 = i524 + 116 | 0;
    i268 = i524 + 120 | 0;
    i269 = i524 + 124 | 0;
    i270 = i524 + 128 | 0;
    i271 = i524 + 132 | 0;
    i272 = i524 + 136 | 0;
    i273 = i524 + 140 | 0;
    i274 = i524 + 144 | 0;
    i275 = i524 + 148 | 0;
    i276 = i524 + 152 | 0;
    i277 = i524 + 156 | 0;
    i278 = i524 + 160 | 0;
    i279 = i524 + 164 | 0;
    i280 = i524 + 168 | 0;
    i281 = i524 + 172 | 0;
    i282 = i524 + 176 | 0;
    i283 = i524 + 180 | 0;
    i284 = i524 + 184 | 0;
    i285 = i524 + 188 | 0;
    i286 = (i2 & 48 | 0) == 0;
    i129 = i525 + 4 | 0;
    i146 = i525 + 8 | 0;
    i163 = i525 + 12 | 0;
    i287 = i525 + 16 | 0;
    i124 = i525 + 20 | 0;
    i141 = i525 + 24 | 0;
    i158 = i525 + 28 | 0;
    i288 = i525 + 32 | 0;
    i119 = i525 + 36 | 0;
    i136 = i525 + 40 | 0;
    i153 = i525 + 44 | 0;
    i289 = i525 + 48 | 0;
    i128 = i525 + 52 | 0;
    i145 = i525 + 56 | 0;
    i162 = i525 + 60 | 0;
    i290 = i525 + 64 | 0;
    i123 = i525 + 68 | 0;
    i140 = i525 + 72 | 0;
    i157 = i525 + 76 | 0;
    i291 = i525 + 80 | 0;
    i118 = i525 + 84 | 0;
    i135 = i525 + 88 | 0;
    i152 = i525 + 92 | 0;
    i292 = i525 + 96 | 0;
    i127 = i525 + 100 | 0;
    i144 = i525 + 104 | 0;
    i161 = i525 + 108 | 0;
    i293 = i525 + 112 | 0;
    i122 = i525 + 116 | 0;
    i139 = i525 + 120 | 0;
    i156 = i525 + 124 | 0;
    i294 = i525 + 128 | 0;
    i117 = i525 + 132 | 0;
    i134 = i525 + 136 | 0;
    i151 = i525 + 140 | 0;
    i295 = i525 + 144 | 0;
    i126 = i525 + 148 | 0;
    i143 = i525 + 152 | 0;
    i160 = i525 + 156 | 0;
    i296 = i525 + 160 | 0;
    i121 = i525 + 164 | 0;
    i138 = i525 + 168 | 0;
    i155 = i525 + 172 | 0;
    i297 = i525 + 176 | 0;
    i116 = i525 + 180 | 0;
    i133 = i525 + 184 | 0;
    i150 = i525 + 188 | 0;
    i130 = i519 + 4 | 0;
    i147 = i519 + 8 | 0;
    i164 = i519 + 12 | 0;
    i298 = i519 + 16 | 0;
    i125 = i519 + 20 | 0;
    i142 = i519 + 24 | 0;
    i159 = i519 + 28 | 0;
    i299 = i519 + 32 | 0;
    i120 = i519 + 36 | 0;
    i137 = i519 + 40 | 0;
    i154 = i519 + 44 | 0;
    i132 = i520 + 4 | 0;
    i149 = i520 + 8 | 0;
    i166 = i520 + 12 | 0;
    i300 = i520 + 16 | 0;
    i131 = i520 + 20 | 0;
    i148 = i520 + 24 | 0;
    i165 = i520 + 28 | 0;
    i115 = i520 + 32 | 0;
    i301 = (i2 & 512 | 0) != 0;
    i302 = i510 + 4 | 0;
    i303 = i510 + 8 | 0;
    i304 = i510 + 12 | 0;
    i305 = i510 + 16 | 0;
    i306 = i510 + 20 | 0;
    i307 = i510 + 24 | 0;
    i308 = i510 + 28 | 0;
    i309 = i510 + 32 | 0;
    i310 = i510 + 36 | 0;
    i311 = i510 + 40 | 0;
    i312 = i510 + 44 | 0;
    i313 = (i2 & 8192 | 0) != 0;
    i314 = i526 + 4 | 0;
    i315 = i526 + 8 | 0;
    i316 = i526 + 12 | 0;
    i317 = i526 + 16 | 0;
    i318 = i526 + 20 | 0;
    i319 = i526 + 24 | 0;
    i320 = i526 + 28 | 0;
    i321 = i526 + 32 | 0;
    i322 = i526 + 36 | 0;
    i323 = i526 + 40 | 0;
    i324 = i526 + 44 | 0;
    i325 = i526 + 48 | 0;
    i326 = i526 + 52 | 0;
    i327 = i526 + 56 | 0;
    i328 = i526 + 60 | 0;
    i329 = (i2 & 2 | 0) == 0;
    i330 = (i2 & 8 | 0) == 0;
    i331 = (i2 & 16 | 0) == 0;
    i332 = (i2 & 32 | 0) == 0;
    i333 = (i2 & 64 | 0) == 0;
    i334 = (i2 & 128 | 0) == 0;
    i335 = (i2 & 256 | 0) == 0;
    i336 = i510 + 16 | 0;
    i337 = i510 + 32 | 0;
    i338 = (i2 & 1024 | 0) == 0;
    i339 = (i2 & 2048 | 0) == 0;
    i340 = (i2 & 4096 | 0) == 0;
    i77 = (i2 & 4 | 0) == 0;
    i78 = i519 + 16 | 0;
    i88 = i519 + 32 | 0;
    i89 = i527 + 864 | 0;
    i90 = i527 + 848 | 0;
    i91 = i527 + 844 | 0;
    i92 = i527 + 828 | 0;
    i93 = i527 + 540 | 0;
    i94 = i520 + 16 | 0;
    i95 = i520 + 32 | 0;
    i96 = i518 + 16 | 0;
    i97 = i518 + 32 | 0;
    i98 = i524 + 16 | 0;
    i99 = i524 + 32 | 0;
    i100 = i525 + 16 | 0;
    i101 = i525 + 32 | 0;
    i102 = i250 + 16 | 0;
    i103 = i250 + 32 | 0;
    i104 = i289 + 16 | 0;
    i105 = i289 + 32 | 0;
    i106 = i262 + 16 | 0;
    i107 = i262 + 32 | 0;
    i108 = i292 + 16 | 0;
    i109 = i292 + 32 | 0;
    i110 = i274 + 16 | 0;
    i111 = i274 + 32 | 0;
    i112 = i295 + 16 | 0;
    i113 = i295 + 32 | 0;
    i114 = i4 + 564 | 0;
    i76 = i4 + 568 | 0;
    i75 = 0;
    i1 = i16;
    do {
     i17 = i529;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     i17 = i530;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     i17 = i512;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     HEAP32[i517 >> 2] = 0;
     HEAP32[i517 + 4 >> 2] = 0;
     HEAP32[i517 + 8 >> 2] = 0;
     HEAP32[i517 + 12 >> 2] = 0;
     i22 = HEAP32[i193 >> 2] | 0;
     i23 = HEAP32[i527 >> 2] | 0;
     if (!i22) {
      i64 = i23 + (i75 << 2) | 0;
      i65 = HEAP32[i64 + 4 >> 2] | 0;
      i66 = HEAP32[i64 + 8 >> 2] | 0;
      i67 = HEAP32[i64 + 12 >> 2] | 0;
      i71 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      i68 = HEAP32[i71 >> 2] | 0;
      i69 = HEAP32[i71 + 4 >> 2] | 0;
      i70 = HEAP32[i71 + 8 >> 2] | 0;
      i71 = HEAP32[i71 + 12 >> 2] | 0;
      i72 = (HEAP32[i195 >> 2] | 0) + (i75 << 2) | 0;
      i485 = HEAP32[i72 >> 2] | 0;
      i74 = HEAP32[i72 + 4 >> 2] | 0;
      i73 = HEAP32[i72 + 8 >> 2] | 0;
      i72 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i529 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i171 >> 2] = i65;
      HEAP32[i170 >> 2] = i66;
      HEAP32[i169 >> 2] = i67;
      HEAP32[i172 >> 2] = i68;
      HEAP32[i175 >> 2] = i69;
      HEAP32[i174 >> 2] = i70;
      HEAP32[i173 >> 2] = i71;
      HEAP32[i176 >> 2] = i485;
      HEAP32[i179 >> 2] = i74;
      HEAP32[i178 >> 2] = i73;
      HEAP32[i177 >> 2] = i72;
      i72 = (HEAP32[i196 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i180 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i183 >> 2] = i73;
      HEAP32[i182 >> 2] = i74;
      HEAP32[i181 >> 2] = i485;
      i485 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      f546 = Math_fround(HEAPF32[i485 >> 2]);
      f536 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f537 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f538 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i198 >> 2] | 0) + (i75 << 2) | 0;
      f539 = Math_fround(HEAPF32[i485 >> 2]);
      f540 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f541 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f542 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i199 >> 2] | 0) + (i75 << 2) | 0;
      f543 = Math_fround(HEAPF32[i485 >> 2]);
      f544 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f545 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f558 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i200 >> 2] | 0) + (i75 << 2) | 0;
      f547 = Math_fround(HEAPF32[i485 >> 2]);
      f548 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f549 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f550 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i201 >> 2] | 0) + (i75 << 2) | 0;
      f551 = Math_fround(HEAPF32[i485 >> 2]);
      f552 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f553 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f554 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i202 >> 2] | 0) + (i75 << 2) | 0;
      f555 = Math_fround(HEAPF32[i485 >> 2]);
      f556 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f557 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f548 = Math_fround(f536 + f548);
      f549 = Math_fround(f537 + f549);
      f550 = Math_fround(f538 + f550);
      f551 = Math_fround(f539 + f551);
      f552 = Math_fround(f540 + f552);
      f553 = Math_fround(f541 + f553);
      f554 = Math_fround(f542 + f554);
      f555 = Math_fround(f543 + f555);
      f556 = Math_fround(f544 + f556);
      f557 = Math_fround(f545 + f557);
      f558 = Math_fround(f558 + Math_fround(HEAPF32[i485 + 12 >> 2]));
      HEAPF32[i512 >> 2] = Math_fround(f546 + f547);
      HEAPF32[i186 >> 2] = f548;
      HEAPF32[i185 >> 2] = f549;
      HEAPF32[i184 >> 2] = f550;
      HEAPF32[i203 >> 2] = f551;
      HEAPF32[i189 >> 2] = f552;
      HEAPF32[i188 >> 2] = f553;
      HEAPF32[i187 >> 2] = f554;
      HEAPF32[i204 >> 2] = f555;
      HEAPF32[i192 >> 2] = f556;
      HEAPF32[i191 >> 2] = f557;
      HEAPF32[i190 >> 2] = f558;
      i485 = (HEAP32[i205 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i485 + 4 >> 2] | 0;
      i73 = HEAP32[i485 + 8 >> 2] | 0;
      i72 = HEAP32[i485 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i485 >> 2];
      HEAP32[i206 >> 2] = i74;
      HEAP32[i207 >> 2] = i73;
      HEAP32[i208 >> 2] = i72;
      i72 = (HEAP32[i209 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i210 >> 2] = i73;
      HEAP32[i211 >> 2] = i74;
      HEAP32[i212 >> 2] = i485;
      i485 = (HEAP32[i213 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i485 + 4 >> 2] | 0;
      i73 = HEAP32[i485 + 8 >> 2] | 0;
      i72 = HEAP32[i485 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i485 >> 2];
      HEAP32[i214 >> 2] = i74;
      HEAP32[i215 >> 2] = i73;
      HEAP32[i216 >> 2] = i72;
      i72 = (HEAP32[i217 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i516 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i218 >> 2] = i73;
      HEAP32[i219 >> 2] = i74;
      HEAP32[i220 >> 2] = i485;
      if (HEAP32[i463 >> 2] & 268435456 | 0) {
       i72 = (HEAP32[i221 >> 2] | 0) + (i75 << 2) | 0;
       i73 = HEAP32[i72 + 4 >> 2] | 0;
       i74 = HEAP32[i72 + 8 >> 2] | 0;
       i485 = HEAP32[i72 + 12 >> 2] | 0;
       HEAP32[i517 >> 2] = HEAP32[i72 >> 2];
       HEAP32[i222 >> 2] = i73;
       HEAP32[i223 >> 2] = i74;
       HEAP32[i224 >> 2] = i485;
      }
     } else {
      i4 = HEAP32[i197 >> 2] | 0;
      i11 = HEAP32[i200 >> 2] | 0;
      i12 = HEAP32[i194 >> 2] | 0;
      i13 = HEAP32[i198 >> 2] | 0;
      i14 = HEAP32[i201 >> 2] | 0;
      i15 = HEAP32[i195 >> 2] | 0;
      i16 = HEAP32[i199 >> 2] | 0;
      i17 = HEAP32[i202 >> 2] | 0;
      i18 = HEAP32[i205 >> 2] | 0;
      i19 = HEAP32[i209 >> 2] | 0;
      i20 = HEAP32[i213 >> 2] | 0;
      i21 = HEAP32[i217 >> 2] | 0;
      i24 = HEAP32[i196 >> 2] | 0;
      i3 = HEAP32[i221 >> 2] | 0;
      if (!(HEAP32[i463 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i517 + (i2 << 2) >> 2] = HEAP32[i3 + (i74 << 2) >> 2];
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f80 = Math_fround(HEAPF32[i529 >> 2]);
     f7 = Math_fround(f450 * f80);
     f85 = Math_fround(HEAPF32[i171 >> 2]);
     f83 = Math_fround(f450 * f85);
     f558 = Math_fround(HEAPF32[i170 >> 2]);
     f6 = Math_fround(f450 * f558);
     f556 = Math_fround(HEAPF32[i169 >> 2]);
     f87 = Math_fround(f450 * f556);
     f86 = Math_fround(HEAPF32[i225 >> 2]);
     f84 = Math_fround(f465 * f86);
     f79 = Math_fround(HEAPF32[i175 >> 2]);
     f27 = Math_fround(f465 * f79);
     f557 = Math_fround(HEAPF32[i174 >> 2]);
     f10 = Math_fround(f465 * f557);
     f555 = Math_fround(HEAPF32[i173 >> 2]);
     f84 = Math_fround(f7 + f84);
     f27 = Math_fround(f83 + f27);
     f10 = Math_fround(f6 + f10);
     f87 = Math_fround(f87 + Math_fround(f465 * f555));
     f6 = Math_fround(HEAPF32[i226 >> 2]);
     f83 = Math_fround(f468 * f6);
     f7 = Math_fround(HEAPF32[i179 >> 2]);
     f82 = Math_fround(f468 * f7);
     f8 = Math_fround(HEAPF32[i178 >> 2]);
     f81 = Math_fround(f468 * f8);
     f26 = Math_fround(HEAPF32[i177 >> 2]);
     f82 = Math_fround(f471 + Math_fround(f27 + f82));
     f81 = Math_fround(f471 + Math_fround(f10 + f81));
     f87 = Math_fround(f471 + Math_fround(f87 + Math_fround(f468 * f26)));
     HEAPF32[i518 >> 2] = Math_fround(f471 + Math_fround(f84 + f83));
     HEAPF32[i227 >> 2] = f82;
     HEAPF32[i228 >> 2] = f81;
     HEAPF32[i229 >> 2] = f87;
     f87 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f85) + Math_fround(f466 * f79)) + Math_fround(f469 * f7)));
     f81 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f558) + Math_fround(f466 * f557)) + Math_fround(f469 * f8)));
     f82 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f556) + Math_fround(f466 * f555)) + Math_fround(f469 * f26)));
     HEAPF32[i230 >> 2] = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f80) + Math_fround(f466 * f86)) + Math_fround(f469 * f6)));
     HEAPF32[i231 >> 2] = f87;
     HEAPF32[i232 >> 2] = f81;
     HEAPF32[i233 >> 2] = f82;
     f82 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f85) + Math_fround(f467 * f79)) + Math_fround(f470 * f7)));
     f81 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f558) + Math_fround(f467 * f557)) + Math_fround(f470 * f8)));
     f87 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f556) + Math_fround(f467 * f555)) + Math_fround(f470 * f26)));
     HEAPF32[i234 >> 2] = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f80) + Math_fround(f467 * f86)) + Math_fround(f470 * f6)));
     HEAPF32[i235 >> 2] = f82;
     HEAPF32[i236 >> 2] = f81;
     HEAPF32[i237 >> 2] = f87;
     f6 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f80) + Math_fround(f497 * f86)) + Math_fround(f498 * f6)));
     f7 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f85) + Math_fround(f497 * f79)) + Math_fround(f498 * f7)));
     f8 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f558) + Math_fround(f497 * f557)) + Math_fround(f498 * f8)));
     f26 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f556) + Math_fround(f497 * f555)) + Math_fround(f498 * f26)));
     f555 = Math_fround(f484 + Math_fround(f486 * f6));
     f556 = Math_fround(f484 + Math_fround(f486 * f7));
     f557 = Math_fround(f484 + Math_fround(f486 * f8));
     f558 = Math_fround(f484 + Math_fround(f486 * f26));
     f6 = Math_fround(f474 + Math_fround(f475 * f6));
     f7 = Math_fround(f474 + Math_fround(f475 * f7));
     f8 = Math_fround(f474 + Math_fround(f475 * f8));
     f26 = Math_fround(f474 + Math_fround(f475 * f26));
     f79 = Math_fround(HEAPF32[i513 >> 2]);
     f85 = Math_fround(HEAPF32[i206 >> 2]);
     f86 = Math_fround(HEAPF32[i207 >> 2]);
     f80 = Math_fround(HEAPF32[i208 >> 2]);
     f81 = Math_fround(HEAPF32[i514 >> 2]);
     f82 = Math_fround(HEAPF32[i210 >> 2]);
     f83 = Math_fround(HEAPF32[i211 >> 2]);
     f84 = Math_fround(HEAPF32[i212 >> 2]);
     f10 = f79 > f81 ? f79 : f81;
     f27 = f85 > f82 ? f85 : f82;
     f25 = f86 > f83 ? f86 : f83;
     f28 = f80 > f84 ? f80 : f84;
     f552 = Math_fround((f10 > f555 ? f10 : f555) * Math_fround(.5));
     f553 = Math_fround((f27 > f556 ? f27 : f556) * Math_fround(.5));
     f554 = Math_fround((f25 > f557 ? f25 : f557) * Math_fround(.5));
     f5 = Math_fround((f28 > f558 ? f28 : f558) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f552, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f553, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f554, HEAP32[tempDoublePtr >> 2] | 0);
     i72 = f555 >= Math_fround(0.0);
     i73 = f556 >= Math_fround(0.0);
     i74 = f557 >= Math_fround(0.0);
     i485 = f558 >= Math_fround(0.0);
     i15 = i72 ? i15 : 0;
     i16 = i73 ? i16 : 0;
     i17 = i74 ? i17 : 0;
     i11 = i485 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f554 = Math_fround(f6 * Math_fround(.5));
     f556 = Math_fround(f7 * Math_fround(.5));
     f558 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f26 * Math_fround(.5));
     f553 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f555 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f557 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f553 < f554 ? f553 : f554, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f555 < f556 ? f555 : f556, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f557 < f558 ? f557 : f558, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i485 = f26 >= Math_fround(0.0);
     i72 = i485 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f27);
     f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
     f27 = Math_fround(f79 * f31);
     f28 = Math_fround(f85 * f32);
     f29 = Math_fround(f86 * f33);
     f30 = Math_fround(f80 * f34);
     f31 = Math_fround(f81 * f31);
     f32 = Math_fround(f82 * f32);
     f33 = Math_fround(f83 * f33);
     f34 = Math_fround(f84 * f34);
     i72 = Math_fround(HEAPF32[i515 >> 2]) < Math_fround(100.0);
     i73 = Math_fround(HEAPF32[i214 >> 2]) < Math_fround(100.0);
     i74 = Math_fround(HEAPF32[i215 >> 2]) < Math_fround(100.0);
     i485 = Math_fround(HEAPF32[i216 >> 2]) < Math_fround(100.0);
     f27 = i72 ? f27 : Math_fround(0.0);
     f540 = Math_fround(f490 * f27);
     f28 = i73 ? f28 : Math_fround(0.0);
     f507 = Math_fround(f490 * f28);
     f29 = i74 ? f29 : Math_fround(0.0);
     f535 = Math_fround(f490 * f29);
     f30 = i485 ? f30 : Math_fround(0.0);
     f555 = Math_fround(f490 * f30);
     f55 = Math_fround(f479 * f27);
     f56 = Math_fround(f479 * f28);
     f57 = Math_fround(f479 * f29);
     f58 = Math_fround(f479 * f30);
     f541 = Math_fround(f483 * f27);
     f53 = Math_fround(f483 * f28);
     f50 = Math_fround(f483 * f29);
     f47 = Math_fround(f483 * f30);
     f31 = i72 ? f31 : Math_fround(0.0);
     f536 = Math_fround(f487 * f31);
     f32 = i73 ? f32 : Math_fround(0.0);
     f539 = Math_fround(f487 * f32);
     f33 = i74 ? f33 : Math_fround(0.0);
     f542 = Math_fround(f487 * f33);
     f34 = i485 ? f34 : Math_fround(0.0);
     f553 = Math_fround(f487 * f34);
     f506 = Math_fround(f476 * f31);
     f558 = Math_fround(f476 * f32);
     f552 = Math_fround(f476 * f33);
     f543 = Math_fround(f476 * f34);
     f546 = Math_fround(f480 * f31);
     f508 = Math_fround(f480 * f32);
     f52 = Math_fround(f480 * f33);
     f49 = Math_fround(f480 * f34);
     f533 = Math_fround(HEAPF32[i238 >> 2]);
     f534 = Math_fround(f533 + Math_fround(.785398125));
     f532 = Math_fround(HEAPF32[i183 >> 2]);
     f554 = Math_fround(f532 + Math_fround(.785398125));
     f509 = Math_fround(HEAPF32[i182 >> 2]);
     f537 = Math_fround(f509 + Math_fround(.785398125));
     f544 = Math_fround(HEAPF32[i181 >> 2]);
     f534 = Math_fround(f534 * Math_fround(.159154937));
     f554 = Math_fround(f554 * Math_fround(.159154937));
     f537 = Math_fround(f537 * Math_fround(.159154937));
     f550 = Math_fround(Math_fround(f544 + Math_fround(.785398125)) * Math_fround(.159154937));
     f549 = Math_fround(+_roundf(+f534));
     f43 = Math_fround(+_roundf(+f554));
     f556 = Math_fround(+_roundf(+f537));
     f549 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f534 - f549))));
     f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f554 - f43))));
     f556 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f556))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f550 - Math_fround(+_roundf(+f550))))));
     f538 = Math_fround(f549 * f549);
     f54 = Math_fround(f43 * f43);
     f51 = Math_fround(f556 * f556);
     f48 = Math_fround(f44 * f44);
     f545 = Math_fround(f538 * f538);
     f45 = Math_fround(f54 * f54);
     f557 = Math_fround(f51 * f51);
     f46 = Math_fround(f48 * f48);
     f538 = Math_fround(f549 * Math_fround(Math_fround(Math_fround(f545 * f545) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f538 * Math_fround(41.3416595))) + Math_fround(f545 * Math_fround(Math_fround(81.6018218) - Math_fround(f538 * Math_fround(76.5686187)))))));
     f54 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
     f51 = Math_fround(f556 * Math_fround(Math_fround(Math_fround(f557 * f557) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f557 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
     f48 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f46 * f46) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f48 * Math_fround(41.3416595))) + Math_fround(f46 * Math_fround(Math_fround(81.6018218) - Math_fround(f48 * Math_fround(76.5686187)))))));
     f534 = Math_fround(f534 + Math_fround(-.25));
     f554 = Math_fround(f554 + Math_fround(-.25));
     f537 = Math_fround(f537 + Math_fround(-.25));
     f550 = Math_fround(f550 + Math_fround(-.25));
     f46 = Math_fround(+_roundf(+f534));
     f44 = Math_fround(+_roundf(+f554));
     f557 = Math_fround(+_roundf(+f537));
     f46 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f534 - f46))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f554 - f44))));
     f557 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f557))));
     f550 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f550 - Math_fround(+_roundf(+f550))))));
     f537 = Math_fround(f46 * f46);
     f554 = Math_fround(f44 * f44);
     f534 = Math_fround(f557 * f557);
     f556 = Math_fround(f550 * f550);
     f45 = Math_fround(f537 * f537);
     f43 = Math_fround(f554 * f554);
     f545 = Math_fround(f534 * f534);
     f549 = Math_fround(f556 * f556);
     f537 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f537 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f537 * Math_fround(76.5686187)))))));
     f554 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f43) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f554 * Math_fround(41.3416595))) + Math_fround(f43 * Math_fround(Math_fround(81.6018218) - Math_fround(f554 * Math_fround(76.5686187)))))));
     f534 = Math_fround(f557 * Math_fround(Math_fround(Math_fround(f545 * f545) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f534 * Math_fround(41.3416595))) + Math_fround(f545 * Math_fround(Math_fround(81.6018218) - Math_fround(f534 * Math_fround(76.5686187)))))));
     f556 = Math_fround(f550 * Math_fround(Math_fround(Math_fround(f549 * f549) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f556 * Math_fround(41.3416595))) + Math_fround(f549 * Math_fround(Math_fround(81.6018218) - Math_fround(f556 * Math_fround(76.5686187)))))));
     f549 = Math_fround(Math_fround(f540 * f538) + Math_fround(f536 * f537));
     f550 = Math_fround(Math_fround(f507 * f54) + Math_fround(f539 * f554));
     f545 = Math_fround(Math_fround(f535 * f51) + Math_fround(f542 * f534));
     f557 = Math_fround(Math_fround(f555 * f48) + Math_fround(f553 * f556));
     f43 = Math_fround(Math_fround(f55 * f538) + Math_fround(f506 * f537));
     f44 = Math_fround(Math_fround(f56 * f54) + Math_fround(f558 * f554));
     f45 = Math_fround(Math_fround(f57 * f51) + Math_fround(f552 * f534));
     f46 = Math_fround(Math_fround(f58 * f48) + Math_fround(f543 * f556));
     f503 = Math_fround(Math_fround(f541 * f538) + Math_fround(f546 * f537));
     f504 = Math_fround(Math_fround(f53 * f54) + Math_fround(f508 * f554));
     f505 = Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f534));
     f551 = Math_fround(Math_fround(f47 * f48) + Math_fround(f49 * f556));
     f35 = Math_fround(Math_fround(f443 * f503) + Math_fround(Math_fround(f441 * f549) + Math_fround(f442 * f43)));
     f36 = Math_fround(Math_fround(f443 * f504) + Math_fround(Math_fround(f441 * f550) + Math_fround(f442 * f44)));
     f37 = Math_fround(Math_fround(f443 * f505) + Math_fround(Math_fround(f441 * f545) + Math_fround(f442 * f45)));
     f38 = Math_fround(Math_fround(f443 * f551) + Math_fround(Math_fround(f441 * f557) + Math_fround(f442 * f46)));
     f39 = Math_fround(Math_fround(f446 * f503) + Math_fround(Math_fround(f444 * f549) + Math_fround(f445 * f43)));
     f40 = Math_fround(Math_fround(f446 * f504) + Math_fround(Math_fround(f444 * f550) + Math_fround(f445 * f44)));
     f41 = Math_fround(Math_fround(f446 * f505) + Math_fround(Math_fround(f444 * f545) + Math_fround(f445 * f45)));
     f42 = Math_fround(Math_fround(f446 * f551) + Math_fround(Math_fround(f444 * f557) + Math_fround(f445 * f46)));
     f43 = Math_fround(Math_fround(f449 * f503) + Math_fround(Math_fround(f447 * f549) + Math_fround(f448 * f43)));
     f44 = Math_fround(Math_fround(f449 * f504) + Math_fround(Math_fround(f447 * f550) + Math_fround(f448 * f44)));
     f45 = Math_fround(Math_fround(f449 * f505) + Math_fround(Math_fround(f447 * f545) + Math_fround(f448 * f45)));
     f46 = Math_fround(Math_fround(f449 * f551) + Math_fround(Math_fround(f447 * f557) + Math_fround(f448 * f46)));
     f540 = Math_fround(Math_fround(f536 * f538) - Math_fround(f540 * f537));
     f507 = Math_fround(Math_fround(f539 * f54) - Math_fround(f507 * f554));
     f535 = Math_fround(Math_fround(f542 * f51) - Math_fround(f535 * f534));
     f555 = Math_fround(Math_fround(f553 * f48) - Math_fround(f555 * f556));
     f55 = Math_fround(Math_fround(f506 * f538) - Math_fround(f55 * f537));
     f56 = Math_fround(Math_fround(f558 * f54) - Math_fround(f56 * f554));
     f57 = Math_fround(Math_fround(f552 * f51) - Math_fround(f57 * f534));
     f58 = Math_fround(Math_fround(f543 * f48) - Math_fround(f58 * f556));
     f537 = Math_fround(Math_fround(f546 * f538) - Math_fround(f541 * f537));
     f554 = Math_fround(Math_fround(f508 * f54) - Math_fround(f53 * f554));
     f534 = Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * f534));
     f556 = Math_fround(Math_fround(f49 * f48) - Math_fround(f47 * f556));
     f47 = Math_fround(Math_fround(f443 * f537) + Math_fround(Math_fround(f441 * f540) + Math_fround(f442 * f55)));
     f48 = Math_fround(Math_fround(f443 * f554) + Math_fround(Math_fround(f441 * f507) + Math_fround(f442 * f56)));
     f49 = Math_fround(Math_fround(f443 * f534) + Math_fround(Math_fround(f441 * f535) + Math_fround(f442 * f57)));
     f50 = Math_fround(Math_fround(f443 * f556) + Math_fround(Math_fround(f441 * f555) + Math_fround(f442 * f58)));
     f51 = Math_fround(Math_fround(f446 * f537) + Math_fround(Math_fround(f444 * f540) + Math_fround(f445 * f55)));
     f52 = Math_fround(Math_fround(f446 * f554) + Math_fround(Math_fround(f444 * f507) + Math_fround(f445 * f56)));
     f53 = Math_fround(Math_fround(f446 * f534) + Math_fround(Math_fround(f444 * f535) + Math_fround(f445 * f57)));
     f54 = Math_fround(Math_fround(f446 * f556) + Math_fround(Math_fround(f444 * f555) + Math_fround(f445 * f58)));
     f55 = Math_fround(Math_fround(f449 * f537) + Math_fround(Math_fround(f447 * f540) + Math_fround(f448 * f55)));
     f56 = Math_fround(Math_fround(f449 * f554) + Math_fround(Math_fround(f447 * f507) + Math_fround(f448 * f56)));
     f57 = Math_fround(Math_fround(f449 * f534) + Math_fround(Math_fround(f447 * f535) + Math_fround(f448 * f57)));
     f58 = Math_fround(Math_fround(f449 * f556) + Math_fround(Math_fround(f447 * f555) + Math_fround(f448 * f58)));
     f555 = Math_fround(f489 * f79);
     f556 = Math_fround(f489 * f85);
     f535 = Math_fround(f489 * f86);
     f534 = Math_fround(f489 * f80);
     f507 = Math_fround(f478 * f81);
     f554 = Math_fround(f478 * f82);
     f540 = Math_fround(f478 * f83);
     f537 = Math_fround(f478 * f84);
     f508 = Math_fround(f482 * f79);
     f541 = Math_fround(f482 * f85);
     f538 = Math_fround(f482 * f86);
     f546 = Math_fround(f482 * f80);
     f533 = Math_fround(f533 * Math_fround(-.159154937));
     f532 = Math_fround(f532 * Math_fround(-.159154937));
     f509 = Math_fround(f509 * Math_fround(-.159154937));
     f544 = Math_fround(f544 * Math_fround(-.159154937));
     f543 = Math_fround(+_roundf(+f533));
     f552 = Math_fround(+_roundf(+f532));
     f558 = Math_fround(+_roundf(+f509));
     f543 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f533 - f543))));
     f552 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - f552))));
     f558 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f509 - f558))));
     f506 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f544 - Math_fround(+_roundf(+f544))))));
     f553 = Math_fround(f543 * f543);
     f542 = Math_fround(f552 * f552);
     f539 = Math_fround(f558 * f558);
     f536 = Math_fround(f506 * f506);
     f557 = Math_fround(f553 * f553);
     f551 = Math_fround(f542 * f542);
     f545 = Math_fround(f539 * f539);
     f505 = Math_fround(f536 * f536);
     f553 = Math_fround(f543 * Math_fround(Math_fround(Math_fround(f557 * f557) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f553 * Math_fround(41.3416595))) + Math_fround(f557 * Math_fround(Math_fround(81.6018218) - Math_fround(f553 * Math_fround(76.5686187)))))));
     f542 = Math_fround(f552 * Math_fround(Math_fround(Math_fround(f551 * f551) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f542 * Math_fround(41.3416595))) + Math_fround(f551 * Math_fround(Math_fround(81.6018218) - Math_fround(f542 * Math_fround(76.5686187)))))));
     f539 = Math_fround(f558 * Math_fround(Math_fround(Math_fround(f545 * f545) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f539 * Math_fround(41.3416595))) + Math_fround(f545 * Math_fround(Math_fround(81.6018218) - Math_fround(f539 * Math_fround(76.5686187)))))));
     f536 = Math_fround(f506 * Math_fround(Math_fround(Math_fround(f505 * f505) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f536 * Math_fround(41.3416595))) + Math_fround(f505 * Math_fround(Math_fround(81.6018218) - Math_fround(f536 * Math_fround(76.5686187)))))));
     f533 = Math_fround(f533 + Math_fround(-.25));
     f532 = Math_fround(f532 + Math_fround(-.25));
     f509 = Math_fround(f509 + Math_fround(-.25));
     f544 = Math_fround(f544 + Math_fround(-.25));
     f505 = Math_fround(+_roundf(+f533));
     f506 = Math_fround(+_roundf(+f532));
     f545 = Math_fround(+_roundf(+f509));
     f505 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f533 - f505))));
     f506 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - f506))));
     f545 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f509 - f545))));
     f544 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f544 - Math_fround(+_roundf(+f544))))));
     f509 = Math_fround(f505 * f505);
     f532 = Math_fround(f506 * f506);
     f533 = Math_fround(f545 * f545);
     f558 = Math_fround(f544 * f544);
     f551 = Math_fround(f509 * f509);
     f552 = Math_fround(f532 * f532);
     f557 = Math_fround(f533 * f533);
     f543 = Math_fround(f558 * f558);
     f509 = Math_fround(f505 * Math_fround(Math_fround(Math_fround(f551 * f551) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f509 * Math_fround(41.3416595))) + Math_fround(f551 * Math_fround(Math_fround(81.6018218) - Math_fround(f509 * Math_fround(76.5686187)))))));
     f532 = Math_fround(f506 * Math_fround(Math_fround(Math_fround(f552 * f552) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f532 * Math_fround(41.3416595))) + Math_fround(f552 * Math_fround(Math_fround(81.6018218) - Math_fround(f532 * Math_fround(76.5686187)))))));
     f533 = Math_fround(f545 * Math_fround(Math_fround(Math_fround(f557 * f557) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f533 * Math_fround(41.3416595))) + Math_fround(f557 * Math_fround(Math_fround(81.6018218) - Math_fround(f533 * Math_fround(76.5686187)))))));
     f558 = Math_fround(f544 * Math_fround(Math_fround(Math_fround(f543 * f543) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f558 * Math_fround(41.3416595))) + Math_fround(f543 * Math_fround(Math_fround(81.6018218) - Math_fround(f558 * Math_fround(76.5686187)))))));
     f543 = Math_fround(Math_fround(f508 * f553) + Math_fround(f507 * f509));
     f544 = Math_fround(Math_fround(f541 * f542) + Math_fround(f554 * f532));
     f557 = Math_fround(Math_fround(f538 * f539) + Math_fround(f540 * f533));
     f545 = Math_fround(Math_fround(f546 * f536) + Math_fround(f537 * f558));
     f509 = Math_fround(Math_fround(f507 * f553) - Math_fround(f508 * f509));
     f532 = Math_fround(Math_fround(f554 * f542) - Math_fround(f541 * f532));
     f533 = Math_fround(Math_fround(f540 * f539) - Math_fround(f538 * f533));
     f558 = Math_fround(Math_fround(f537 * f536) - Math_fround(f546 * f558));
     f546 = Math_fround(Math_fround(f443 * f509) + Math_fround(Math_fround(f441 * f555) + Math_fround(f442 * f543)));
     f536 = Math_fround(Math_fround(f443 * f532) + Math_fround(Math_fround(f441 * f556) + Math_fround(f442 * f544)));
     f537 = Math_fround(Math_fround(f443 * f533) + Math_fround(Math_fround(f441 * f535) + Math_fround(f442 * f557)));
     f538 = Math_fround(Math_fround(f443 * f558) + Math_fround(Math_fround(f441 * f534) + Math_fround(f442 * f545)));
     f539 = Math_fround(Math_fround(f446 * f509) + Math_fround(Math_fround(f444 * f555) + Math_fround(f445 * f543)));
     f540 = Math_fround(Math_fround(f446 * f532) + Math_fround(Math_fround(f444 * f556) + Math_fround(f445 * f544)));
     f541 = Math_fround(Math_fround(f446 * f533) + Math_fround(Math_fround(f444 * f535) + Math_fround(f445 * f557)));
     f542 = Math_fround(Math_fround(f446 * f558) + Math_fround(Math_fround(f444 * f534) + Math_fround(f445 * f545)));
     f543 = Math_fround(Math_fround(f449 * f509) + Math_fround(Math_fround(f447 * f555) + Math_fround(f448 * f543)));
     f544 = Math_fround(Math_fround(f449 * f532) + Math_fround(Math_fround(f447 * f556) + Math_fround(f448 * f544)));
     f557 = Math_fround(Math_fround(f449 * f533) + Math_fround(Math_fround(f447 * f535) + Math_fround(f448 * f557)));
     f545 = Math_fround(Math_fround(f449 * f558) + Math_fround(Math_fround(f447 * f534) + Math_fround(f448 * f545)));
     f534 = Math_fround(HEAPF32[i518 >> 2]);
     f558 = Math_fround(f534 + f35);
     f535 = Math_fround(HEAPF32[i227 >> 2]);
     f533 = Math_fround(f535 + f36);
     f556 = Math_fround(HEAPF32[i228 >> 2]);
     f532 = Math_fround(f556 + f37);
     f555 = Math_fround(HEAPF32[i229 >> 2]);
     f509 = Math_fround(f555 + f38);
     f554 = Math_fround(HEAPF32[i230 >> 2]);
     f508 = Math_fround(f39 + f554);
     f553 = Math_fround(HEAPF32[i231 >> 2]);
     f507 = Math_fround(f40 + f553);
     f552 = Math_fround(HEAPF32[i232 >> 2]);
     f506 = Math_fround(f41 + f552);
     f551 = Math_fround(HEAPF32[i233 >> 2]);
     f505 = Math_fround(f42 + f551);
     f550 = Math_fround(HEAPF32[i234 >> 2]);
     f504 = Math_fround(f43 + f550);
     f549 = Math_fround(HEAPF32[i235 >> 2]);
     f503 = Math_fround(f44 + f549);
     f548 = Math_fround(HEAPF32[i236 >> 2]);
     f533 = Math_fround(f533 + f536);
     f532 = Math_fround(f532 + f537);
     f509 = Math_fround(f509 + f538);
     f508 = Math_fround(f508 + f539);
     f507 = Math_fround(f507 + f540);
     f506 = Math_fround(f506 + f541);
     f505 = Math_fround(f505 + f542);
     f504 = Math_fround(f504 + f543);
     f503 = Math_fround(f503 + f544);
     f502 = Math_fround(Math_fround(f45 + f548) + f557);
     f501 = Math_fround(Math_fround(f87 + f46) + f545);
     HEAPF32[i524 >> 2] = Math_fround(f558 + f546);
     HEAPF32[i239 >> 2] = f533;
     HEAPF32[i240 >> 2] = f532;
     HEAPF32[i241 >> 2] = f509;
     HEAPF32[i242 >> 2] = f508;
     HEAPF32[i243 >> 2] = f507;
     HEAPF32[i244 >> 2] = f506;
     HEAPF32[i245 >> 2] = f505;
     HEAPF32[i246 >> 2] = f504;
     HEAPF32[i247 >> 2] = f503;
     HEAPF32[i248 >> 2] = f502;
     HEAPF32[i249 >> 2] = f501;
     f501 = Math_fround(f534 + f47);
     f502 = Math_fround(f535 + f48);
     f503 = Math_fround(f556 + f49);
     f504 = Math_fround(f555 + f50);
     f505 = Math_fround(f51 + f554);
     f506 = Math_fround(f52 + f553);
     f507 = Math_fround(f53 + f552);
     f508 = Math_fround(f54 + f551);
     f509 = Math_fround(f55 + f550);
     f532 = Math_fround(f56 + f549);
     f533 = Math_fround(f57 + f548);
     f558 = Math_fround(HEAPF32[i237 >> 2]);
     f502 = Math_fround(f502 + f536);
     f503 = Math_fround(f503 + f537);
     f504 = Math_fround(f504 + f538);
     f505 = Math_fround(f505 + f539);
     f506 = Math_fround(f506 + f540);
     f507 = Math_fround(f507 + f541);
     f508 = Math_fround(f508 + f542);
     f509 = Math_fround(f509 + f543);
     f532 = Math_fround(f532 + f544);
     f533 = Math_fround(f533 + f557);
     f547 = Math_fround(f545 + Math_fround(f58 + f558));
     HEAPF32[i250 >> 2] = Math_fround(f501 + f546);
     HEAPF32[i251 >> 2] = f502;
     HEAPF32[i252 >> 2] = f503;
     HEAPF32[i253 >> 2] = f504;
     HEAPF32[i254 >> 2] = f505;
     HEAPF32[i255 >> 2] = f506;
     HEAPF32[i256 >> 2] = f507;
     HEAPF32[i257 >> 2] = f508;
     HEAPF32[i258 >> 2] = f509;
     HEAPF32[i259 >> 2] = f532;
     HEAPF32[i260 >> 2] = f533;
     HEAPF32[i261 >> 2] = f547;
     f535 = Math_fround(Math_fround(f535 - f36) + f536);
     f556 = Math_fround(Math_fround(f556 - f37) + f537);
     f555 = Math_fround(Math_fround(f555 - f38) + f538);
     f554 = Math_fround(Math_fround(f554 - f39) + f539);
     f553 = Math_fround(Math_fround(f553 - f40) + f540);
     f552 = Math_fround(Math_fround(f552 - f41) + f541);
     f551 = Math_fround(Math_fround(f551 - f42) + f542);
     f550 = Math_fround(Math_fround(f550 - f43) + f543);
     f549 = Math_fround(Math_fround(f549 - f44) + f544);
     f548 = Math_fround(Math_fround(f548 - f45) + f557);
     f547 = Math_fround(f545 + Math_fround(f558 - f46));
     HEAPF32[i262 >> 2] = Math_fround(Math_fround(f534 - f35) + f546);
     HEAPF32[i263 >> 2] = f535;
     HEAPF32[i264 >> 2] = f556;
     HEAPF32[i265 >> 2] = f555;
     HEAPF32[i266 >> 2] = f554;
     HEAPF32[i267 >> 2] = f553;
     HEAPF32[i268 >> 2] = f552;
     HEAPF32[i269 >> 2] = f551;
     HEAPF32[i270 >> 2] = f550;
     HEAPF32[i271 >> 2] = f549;
     HEAPF32[i272 >> 2] = f548;
     HEAPF32[i273 >> 2] = f547;
     f547 = Math_fround(Math_fround(HEAPF32[i518 >> 2]) - f47);
     f548 = Math_fround(Math_fround(HEAPF32[i227 >> 2]) - f48);
     f549 = Math_fround(Math_fround(HEAPF32[i228 >> 2]) - f49);
     f550 = Math_fround(Math_fround(HEAPF32[i229 >> 2]) - f50);
     f551 = Math_fround(Math_fround(HEAPF32[i230 >> 2]) - f51);
     f552 = Math_fround(Math_fround(HEAPF32[i231 >> 2]) - f52);
     f553 = Math_fround(Math_fround(HEAPF32[i232 >> 2]) - f53);
     f554 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) - f54);
     f555 = Math_fround(Math_fround(HEAPF32[i234 >> 2]) - f55);
     f556 = Math_fround(Math_fround(HEAPF32[i235 >> 2]) - f56);
     f548 = Math_fround(f536 + f548);
     f549 = Math_fround(f537 + f549);
     f550 = Math_fround(f538 + f550);
     f551 = Math_fround(f539 + f551);
     f552 = Math_fround(f540 + f552);
     f553 = Math_fround(f541 + f553);
     f554 = Math_fround(f542 + f554);
     f555 = Math_fround(f543 + f555);
     f556 = Math_fround(f544 + f556);
     f557 = Math_fround(f557 + Math_fround(Math_fround(HEAPF32[i236 >> 2]) - f57));
     f558 = Math_fround(f545 + Math_fround(f558 - f58));
     HEAPF32[i274 >> 2] = Math_fround(f546 + f547);
     HEAPF32[i275 >> 2] = f548;
     HEAPF32[i276 >> 2] = f549;
     HEAPF32[i277 >> 2] = f550;
     HEAPF32[i278 >> 2] = f551;
     HEAPF32[i279 >> 2] = f552;
     HEAPF32[i280 >> 2] = f553;
     HEAPF32[i281 >> 2] = f554;
     HEAPF32[i282 >> 2] = f555;
     HEAPF32[i283 >> 2] = f556;
     HEAPF32[i284 >> 2] = f557;
     HEAPF32[i285 >> 2] = f558;
     if (!i286) {
      i2 = HEAP32[i463 >> 2] | 0;
      if (i2 & 536870912) {
       f558 = Math_fround(HEAPF32[i114 >> 2]);
       i63 = HEAP32[i516 >> 2] | 0;
       i74 = i63 + 693089735 | 0;
       i61 = HEAP32[i218 >> 2] | 0;
       i71 = i61 + 693089735 | 0;
       i59 = HEAP32[i219 >> 2] | 0;
       i68 = i59 + 693089735 | 0;
       i23 = HEAP32[i220 >> 2] | 0;
       i65 = i23 + 693089735 | 0;
       i24 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i60 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i62 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i64 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i68 = i68 << 11 ^ i68;
       i65 = i65 << 11 ^ i65;
       i24 = Math_fround(Math_fround((i24 ^ i74 ^ i74 >>> 8) & 8388607 ^ i24 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i60 = Math_fround(Math_fround((i60 ^ i71 ^ i71 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i62 = Math_fround(Math_fround((i62 ^ i68 ^ i68 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i64 = Math_fround(Math_fround((i64 ^ i65 ^ i65 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       f558 = Math_fround(HEAPF32[i76 >> 2]);
       i63 = i63 + 13945730 | 0;
       i61 = i61 + 13945730 | 0;
       i59 = i59 + 13945730 | 0;
       i23 = i23 + 13945730 | 0;
       i65 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i59, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
       i63 = i63 << 11 ^ i63;
       i61 = i61 << 11 ^ i61;
       i59 = i59 << 11 ^ i59;
       i23 = i23 << 11 ^ i23;
       i65 = Math_fround(Math_fround((i65 ^ i63 ^ i63 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i68 = Math_fround(Math_fround((i68 ^ i61 ^ i61 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i71 = Math_fround(Math_fround((i71 ^ i59 ^ i59 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i23 = i24 & 1;
       i59 = i60 & 1;
       i61 = i62 & 1;
       i63 = i64 & 1;
       i66 = i23 ^ 1;
       i69 = i59 ^ 1;
       i72 = i61 ^ 1;
       i485 = i63 ^ 1;
       i67 = i24 ? 3 : 2;
       i70 = i60 ? 3 : 2;
       i73 = i62 ? 3 : 2;
       i2 = i64 ? 3 : 2;
       i24 = i24 ? 2 : 3;
       i60 = i60 ? 2 : 3;
       i62 = i62 ? 2 : 3;
       i64 = i64 ? 2 : 3;
       HEAP32[i521 >> 2] = i65 ? i24 : i23;
       HEAP32[i438 >> 2] = i68 ? i60 : i59;
       HEAP32[i437 >> 2] = i71 ? i62 : i61;
       HEAP32[i436 >> 2] = i74 ? i64 : i63;
       HEAP32[i462 >> 2] = i65 ? i23 : i24;
       HEAP32[i461 >> 2] = i68 ? i59 : i60;
       HEAP32[i460 >> 2] = i71 ? i61 : i62;
       HEAP32[i459 >> 2] = i74 ? i63 : i64;
       HEAP32[i454 >> 2] = i65 ? i67 : i66;
       HEAP32[i453 >> 2] = i68 ? i70 : i69;
       HEAP32[i452 >> 2] = i71 ? i73 : i72;
       HEAP32[i439 >> 2] = i74 ? i2 : i485;
       HEAP32[i458 >> 2] = i65 ? i66 : i67;
       HEAP32[i457 >> 2] = i68 ? i69 : i70;
       HEAP32[i456 >> 2] = i71 ? i72 : i73;
       HEAP32[i455 >> 2] = i74 ? i485 : i2;
       i2 = HEAP32[i463 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f492 * Math_fround(HEAPF32[i517 >> 2]));
       f6 = Math_fround(f492 * Math_fround(HEAPF32[i222 >> 2]));
       f7 = Math_fround(f492 * Math_fround(HEAPF32[i223 >> 2]));
       f8 = Math_fround(f492 * Math_fround(HEAPF32[i224 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f555 = Math_fround(Math_floor(Math_fround(f342 * f9)));
        f556 = Math_fround(Math_floor(Math_fround(f342 * f10)));
        f557 = Math_fround(Math_floor(Math_fround(f342 * f25)));
        f558 = Math_fround(Math_floor(Math_fround(f342 * f26)));
        f551 = Math_fround(f493 * Math_fround(f9 - Math_fround(f491 * f555)));
        f552 = Math_fround(f493 * Math_fround(f10 - Math_fround(f491 * f556)));
        f553 = Math_fround(f493 * Math_fround(f25 - Math_fround(f491 * f557)));
        f554 = Math_fround(f493 * Math_fround(f26 - Math_fround(f491 * f558)));
        f555 = Math_fround(f440 - Math_fround(f494 * f555));
        f556 = Math_fround(f440 - Math_fround(f494 * f556));
        f557 = Math_fround(f440 - Math_fround(f494 * f557));
        f558 = Math_fround(f440 - Math_fround(f494 * f558));
        f543 = Math_fround(f494 + f555);
        f544 = Math_fround(f494 + f556);
        f545 = Math_fround(f494 + f557);
        f546 = Math_fround(f494 + f558);
        HEAPF32[i522 >> 2] = f551;
        HEAPF32[i387 >> 2] = f552;
        HEAPF32[i411 >> 2] = f553;
        HEAPF32[i435 >> 2] = f554;
        HEAPF32[i363 >> 2] = f543;
        HEAPF32[i386 >> 2] = f544;
        HEAPF32[i410 >> 2] = f545;
        HEAPF32[i434 >> 2] = f546;
        f547 = Math_fround(f493 + f551);
        f548 = Math_fround(f493 + f552);
        f549 = Math_fround(f493 + f553);
        f550 = Math_fround(f493 + f554);
        HEAPF32[i362 >> 2] = f547;
        HEAPF32[i385 >> 2] = f548;
        HEAPF32[i409 >> 2] = f549;
        HEAPF32[i433 >> 2] = f550;
        HEAPF32[i361 >> 2] = f543;
        HEAPF32[i384 >> 2] = f544;
        HEAPF32[i408 >> 2] = f545;
        HEAPF32[i432 >> 2] = f546;
        HEAPF32[i360 >> 2] = f547;
        HEAPF32[i383 >> 2] = f548;
        HEAPF32[i407 >> 2] = f549;
        HEAPF32[i431 >> 2] = f550;
        HEAPF32[i359 >> 2] = f555;
        HEAPF32[i382 >> 2] = f556;
        HEAPF32[i406 >> 2] = f557;
        HEAPF32[i430 >> 2] = f558;
        HEAPF32[i358 >> 2] = f551;
        HEAPF32[i381 >> 2] = f552;
        HEAPF32[i405 >> 2] = f553;
        HEAPF32[i429 >> 2] = f554;
        HEAPF32[i357 >> 2] = f555;
        HEAPF32[i380 >> 2] = f556;
        HEAPF32[i404 >> 2] = f557;
        HEAPF32[i428 >> 2] = f558;
       }
       if (i2 & 33554432 | 0) {
        f547 = Math_fround(f9 + Math_fround(1.0));
        f548 = Math_fround(f10 + Math_fround(1.0));
        f549 = Math_fround(f25 + Math_fround(1.0));
        f550 = Math_fround(f26 + Math_fround(1.0));
        f555 = Math_fround(f5 - f9);
        f556 = Math_fround(f6 - f10);
        f557 = Math_fround(f7 - f25);
        f558 = Math_fround(f8 - f26);
        f551 = Math_fround(Math_floor(Math_fround(f342 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f342 * f548)));
        f553 = Math_fround(Math_floor(Math_fround(f342 * f549)));
        f554 = Math_fround(Math_floor(Math_fround(f342 * f550)));
        f547 = Math_fround(f493 * Math_fround(f547 - Math_fround(f491 * f551)));
        f548 = Math_fround(f493 * Math_fround(f548 - Math_fround(f491 * f552)));
        f549 = Math_fround(f493 * Math_fround(f549 - Math_fround(f491 * f553)));
        f550 = Math_fround(f493 * Math_fround(f550 - Math_fround(f491 * f554)));
        f551 = Math_fround(f440 - Math_fround(f494 * f551));
        f552 = Math_fround(f440 - Math_fround(f494 * f552));
        f553 = Math_fround(f440 - Math_fround(f494 * f553));
        f554 = Math_fround(f440 - Math_fround(f494 * f554));
        f539 = Math_fround(f494 + f551);
        f540 = Math_fround(f494 + f552);
        f541 = Math_fround(f494 + f553);
        f542 = Math_fround(f494 + f554);
        HEAPF32[i523 >> 2] = f547;
        HEAPF32[i379 >> 2] = f548;
        HEAPF32[i403 >> 2] = f549;
        HEAPF32[i427 >> 2] = f550;
        HEAPF32[i356 >> 2] = f539;
        HEAPF32[i378 >> 2] = f540;
        HEAPF32[i402 >> 2] = f541;
        HEAPF32[i426 >> 2] = f542;
        HEAPF32[i355 >> 2] = f555;
        HEAPF32[i377 >> 2] = f556;
        HEAPF32[i401 >> 2] = f557;
        HEAPF32[i425 >> 2] = f558;
        HEAPF32[i354 >> 2] = f5;
        HEAPF32[i376 >> 2] = f6;
        HEAPF32[i400 >> 2] = f7;
        HEAPF32[i424 >> 2] = f8;
        f543 = Math_fround(f493 + f547);
        f544 = Math_fround(f493 + f548);
        f545 = Math_fround(f493 + f549);
        f546 = Math_fround(f493 + f550);
        HEAPF32[i353 >> 2] = f543;
        HEAPF32[i375 >> 2] = f544;
        HEAPF32[i399 >> 2] = f545;
        HEAPF32[i423 >> 2] = f546;
        HEAPF32[i352 >> 2] = f539;
        HEAPF32[i374 >> 2] = f540;
        HEAPF32[i398 >> 2] = f541;
        HEAPF32[i422 >> 2] = f542;
        HEAPF32[i351 >> 2] = f555;
        HEAPF32[i373 >> 2] = f556;
        HEAPF32[i397 >> 2] = f557;
        HEAPF32[i421 >> 2] = f558;
        HEAPF32[i350 >> 2] = f5;
        HEAPF32[i372 >> 2] = f6;
        HEAPF32[i396 >> 2] = f7;
        HEAPF32[i420 >> 2] = f8;
        HEAPF32[i349 >> 2] = f543;
        HEAPF32[i371 >> 2] = f544;
        HEAPF32[i395 >> 2] = f545;
        HEAPF32[i419 >> 2] = f546;
        HEAPF32[i348 >> 2] = f551;
        HEAPF32[i370 >> 2] = f552;
        HEAPF32[i394 >> 2] = f553;
        HEAPF32[i418 >> 2] = f554;
        HEAPF32[i347 >> 2] = f555;
        HEAPF32[i369 >> 2] = f556;
        HEAPF32[i393 >> 2] = f557;
        HEAPF32[i417 >> 2] = f558;
        HEAPF32[i346 >> 2] = f5;
        HEAPF32[i368 >> 2] = f6;
        HEAPF32[i392 >> 2] = f7;
        HEAPF32[i416 >> 2] = f8;
        HEAPF32[i345 >> 2] = f547;
        HEAPF32[i367 >> 2] = f548;
        HEAPF32[i391 >> 2] = f549;
        HEAPF32[i415 >> 2] = f550;
        HEAPF32[i344 >> 2] = f551;
        HEAPF32[i366 >> 2] = f552;
        HEAPF32[i390 >> 2] = f553;
        HEAPF32[i414 >> 2] = f554;
        HEAPF32[i343 >> 2] = f555;
        HEAPF32[i365 >> 2] = f556;
        HEAPF32[i389 >> 2] = f557;
        HEAPF32[i413 >> 2] = f558;
        HEAPF32[i341 >> 2] = f5;
        HEAPF32[i364 >> 2] = f6;
        HEAPF32[i388 >> 2] = f7;
        HEAPF32[i412 >> 2] = f8;
       }
      }
     }
     f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
     f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
     f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
     f546 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
     f535 = Math_fround(f495 * Math_fround(f35 * f543));
     f536 = Math_fround(f495 * Math_fround(f36 * f544));
     f537 = Math_fround(f495 * Math_fround(f37 * f545));
     f538 = Math_fround(f495 * Math_fround(f38 * f546));
     f539 = Math_fround(f495 * Math_fround(f39 * f543));
     f540 = Math_fround(f495 * Math_fround(f40 * f544));
     f541 = Math_fround(f495 * Math_fround(f41 * f545));
     f542 = Math_fround(f495 * Math_fround(f42 * f546));
     f543 = Math_fround(f495 * Math_fround(f43 * f543));
     f544 = Math_fround(f495 * Math_fround(f44 * f544));
     f545 = Math_fround(f495 * Math_fround(f45 * f545));
     f546 = Math_fround(f495 * Math_fround(f46 * f546));
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
     f557 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
     f558 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
     f547 = Math_fround(f495 * Math_fround(f47 * f555));
     f548 = Math_fround(f495 * Math_fround(f48 * f556));
     f549 = Math_fround(f495 * Math_fround(f49 * f557));
     f550 = Math_fround(f495 * Math_fround(f50 * f558));
     f551 = Math_fround(f495 * Math_fround(f51 * f555));
     f552 = Math_fround(f495 * Math_fround(f52 * f556));
     f553 = Math_fround(f495 * Math_fround(f53 * f557));
     f554 = Math_fround(f495 * Math_fround(f54 * f558));
     f555 = Math_fround(f495 * Math_fround(f55 * f555));
     f556 = Math_fround(f495 * Math_fround(f56 * f556));
     f557 = Math_fround(f495 * Math_fround(f57 * f557));
     f558 = Math_fround(f495 * Math_fround(f58 * f558));
     f534 = Math_fround(f488 + f536);
     f533 = Math_fround(f488 + f537);
     f532 = Math_fround(f488 + f538);
     f509 = Math_fround(f477 + f539);
     f508 = Math_fround(f477 + f540);
     f507 = Math_fround(f477 + f541);
     f506 = Math_fround(f477 + f542);
     f505 = Math_fround(f481 + f543);
     f504 = Math_fround(f481 + f544);
     f503 = Math_fround(f481 + f545);
     f502 = Math_fround(f481 + f546);
     HEAPF32[i525 >> 2] = Math_fround(f488 + f535);
     HEAPF32[i129 >> 2] = f534;
     HEAPF32[i146 >> 2] = f533;
     HEAPF32[i163 >> 2] = f532;
     HEAPF32[i287 >> 2] = f509;
     HEAPF32[i124 >> 2] = f508;
     HEAPF32[i141 >> 2] = f507;
     HEAPF32[i158 >> 2] = f506;
     HEAPF32[i288 >> 2] = f505;
     HEAPF32[i119 >> 2] = f504;
     HEAPF32[i136 >> 2] = f503;
     HEAPF32[i153 >> 2] = f502;
     f502 = Math_fround(f488 + f548);
     f503 = Math_fround(f488 + f549);
     f504 = Math_fround(f488 + f550);
     f505 = Math_fround(f477 + f551);
     f506 = Math_fround(f477 + f552);
     f507 = Math_fround(f477 + f553);
     f508 = Math_fround(f477 + f554);
     f509 = Math_fround(f481 + f555);
     f532 = Math_fround(f481 + f556);
     f533 = Math_fround(f481 + f557);
     f534 = Math_fround(f481 + f558);
     HEAPF32[i289 >> 2] = Math_fround(f488 + f547);
     HEAPF32[i128 >> 2] = f502;
     HEAPF32[i145 >> 2] = f503;
     HEAPF32[i162 >> 2] = f504;
     HEAPF32[i290 >> 2] = f505;
     HEAPF32[i123 >> 2] = f506;
     HEAPF32[i140 >> 2] = f507;
     HEAPF32[i157 >> 2] = f508;
     HEAPF32[i291 >> 2] = f509;
     HEAPF32[i118 >> 2] = f532;
     HEAPF32[i135 >> 2] = f533;
     HEAPF32[i152 >> 2] = f534;
     f536 = Math_fround(f488 - f536);
     f537 = Math_fround(f488 - f537);
     f538 = Math_fround(f488 - f538);
     f539 = Math_fround(f477 - f539);
     f540 = Math_fround(f477 - f540);
     f541 = Math_fround(f477 - f541);
     f542 = Math_fround(f477 - f542);
     f543 = Math_fround(f481 - f543);
     f544 = Math_fround(f481 - f544);
     f545 = Math_fround(f481 - f545);
     f546 = Math_fround(f481 - f546);
     HEAPF32[i292 >> 2] = Math_fround(f488 - f535);
     HEAPF32[i127 >> 2] = f536;
     HEAPF32[i144 >> 2] = f537;
     HEAPF32[i161 >> 2] = f538;
     HEAPF32[i293 >> 2] = f539;
     HEAPF32[i122 >> 2] = f540;
     HEAPF32[i139 >> 2] = f541;
     HEAPF32[i156 >> 2] = f542;
     HEAPF32[i294 >> 2] = f543;
     HEAPF32[i117 >> 2] = f544;
     HEAPF32[i134 >> 2] = f545;
     HEAPF32[i151 >> 2] = f546;
     f548 = Math_fround(f488 - f548);
     f549 = Math_fround(f488 - f549);
     f550 = Math_fround(f488 - f550);
     f551 = Math_fround(f477 - f551);
     f552 = Math_fround(f477 - f552);
     f553 = Math_fround(f477 - f553);
     f554 = Math_fround(f477 - f554);
     f555 = Math_fround(f481 - f555);
     f556 = Math_fround(f481 - f556);
     f557 = Math_fround(f481 - f557);
     f558 = Math_fround(f481 - f558);
     HEAPF32[i295 >> 2] = Math_fround(f488 - f547);
     HEAPF32[i126 >> 2] = f548;
     HEAPF32[i143 >> 2] = f549;
     HEAPF32[i160 >> 2] = f550;
     HEAPF32[i296 >> 2] = f551;
     HEAPF32[i121 >> 2] = f552;
     HEAPF32[i138 >> 2] = f553;
     HEAPF32[i155 >> 2] = f554;
     HEAPF32[i297 >> 2] = f555;
     HEAPF32[i116 >> 2] = f556;
     HEAPF32[i133 >> 2] = f557;
     HEAPF32[i150 >> 2] = f558;
     do if (i167) {
      i4 = HEAP32[i193 >> 2] | 0;
      i11 = HEAP32[i528 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i485 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i250 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i262 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i292 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i274 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i295 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i485 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i485 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i250 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i262 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i292 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i274 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i295 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i485 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f546 = Math_fround(HEAPF32[i250 >> 2]);
      f546 = Math_fround(f546 - Math_fround(HEAPF32[i524 >> 2]));
      f548 = Math_fround(HEAPF32[i251 >> 2]);
      f548 = Math_fround(f548 - Math_fround(HEAPF32[i239 >> 2]));
      f549 = Math_fround(HEAPF32[i252 >> 2]);
      f549 = Math_fround(f549 - Math_fround(HEAPF32[i240 >> 2]));
      f550 = Math_fround(HEAPF32[i253 >> 2]);
      f550 = Math_fround(f550 - Math_fround(HEAPF32[i241 >> 2]));
      f551 = Math_fround(HEAPF32[i254 >> 2]);
      f551 = Math_fround(f551 - Math_fround(HEAPF32[i242 >> 2]));
      f558 = Math_fround(HEAPF32[i255 >> 2]);
      f558 = Math_fround(f558 - Math_fround(HEAPF32[i243 >> 2]));
      f557 = Math_fround(HEAPF32[i256 >> 2]);
      f557 = Math_fround(f557 - Math_fround(HEAPF32[i244 >> 2]));
      f556 = Math_fround(HEAPF32[i257 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i245 >> 2]));
      f555 = Math_fround(HEAPF32[i258 >> 2]);
      f555 = Math_fround(f555 - Math_fround(HEAPF32[i246 >> 2]));
      f543 = Math_fround(HEAPF32[i259 >> 2]);
      f543 = Math_fround(f543 - Math_fround(HEAPF32[i247 >> 2]));
      f544 = Math_fround(HEAPF32[i260 >> 2]);
      f544 = Math_fround(f544 - Math_fround(HEAPF32[i248 >> 2]));
      f545 = Math_fround(HEAPF32[i261 >> 2]);
      f545 = Math_fround(f545 - Math_fround(HEAPF32[i249 >> 2]));
      f547 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f551 * f551)) + Math_fround(f555 * f555)))));
      f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f558 * f558)) + Math_fround(f543 * f543)))));
      f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f549 * f549) + Math_fround(f557 * f557)) + Math_fround(f544 * f544)))));
      f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f550 * f550) + Math_fround(f556 * f556)) + Math_fround(f545 * f545)))));
      f548 = Math_fround(f548 * f554);
      f549 = Math_fround(f549 * f553);
      f550 = Math_fround(f550 * f552);
      f551 = Math_fround(f551 * f547);
      f558 = Math_fround(f558 * f554);
      f557 = Math_fround(f557 * f553);
      f556 = Math_fround(f556 * f552);
      f555 = Math_fround(f555 * f547);
      f554 = Math_fround(f543 * f554);
      f553 = Math_fround(f544 * f553);
      f552 = Math_fround(f545 * f552);
      HEAPF32[i519 >> 2] = Math_fround(f546 * f547);
      HEAPF32[i130 >> 2] = f548;
      HEAPF32[i147 >> 2] = f549;
      HEAPF32[i164 >> 2] = f550;
      HEAPF32[i298 >> 2] = f551;
      HEAPF32[i125 >> 2] = f558;
      HEAPF32[i142 >> 2] = f557;
      HEAPF32[i159 >> 2] = f556;
      HEAPF32[i299 >> 2] = f555;
      HEAPF32[i120 >> 2] = f554;
      HEAPF32[i137 >> 2] = f553;
      HEAPF32[i154 >> 2] = f552;
      f552 = Math_fround(f28 * Math_fround(2.0));
      f553 = Math_fround(f29 * Math_fround(2.0));
      f554 = Math_fround(f30 * Math_fround(2.0));
      f555 = Math_fround(f31 * Math_fround(2.0));
      f556 = Math_fround(f32 * Math_fround(2.0));
      f557 = Math_fround(f33 * Math_fround(2.0));
      f558 = Math_fround(f34 * Math_fround(2.0));
      HEAPF32[i520 >> 2] = Math_fround(f27 * Math_fround(2.0));
      HEAPF32[i132 >> 2] = f552;
      HEAPF32[i149 >> 2] = f553;
      HEAPF32[i166 >> 2] = f554;
      HEAPF32[i300 >> 2] = f555;
      HEAPF32[i131 >> 2] = f556;
      HEAPF32[i148 >> 2] = f557;
      HEAPF32[i165 >> 2] = f558;
      HEAP32[i115 >> 2] = 0;
      HEAP32[i115 + 4 >> 2] = 0;
      HEAP32[i115 + 8 >> 2] = 0;
      HEAP32[i115 + 12 >> 2] = 0;
      if (i301) {
       f538 = Math_fround(HEAPF32[i512 >> 2]);
       f556 = Math_fround(f450 * f538);
       f540 = Math_fround(HEAPF32[i186 >> 2]);
       f547 = Math_fround(f450 * f540);
       f542 = Math_fround(HEAPF32[i185 >> 2]);
       f555 = Math_fround(f450 * f542);
       f544 = Math_fround(HEAPF32[i184 >> 2]);
       f550 = Math_fround(f450 * f544);
       f539 = Math_fround(HEAPF32[i203 >> 2]);
       f546 = Math_fround(f465 * f539);
       f541 = Math_fround(HEAPF32[i189 >> 2]);
       f552 = Math_fround(f465 * f541);
       f543 = Math_fround(HEAPF32[i188 >> 2]);
       f551 = Math_fround(f465 * f543);
       f545 = Math_fround(HEAPF32[i187 >> 2]);
       f546 = Math_fround(f556 + f546);
       f552 = Math_fround(f547 + f552);
       f551 = Math_fround(f555 + f551);
       f550 = Math_fround(f550 + Math_fround(f465 * f545));
       f555 = Math_fround(HEAPF32[i204 >> 2]);
       f547 = Math_fround(f468 * f555);
       f556 = Math_fround(HEAPF32[i192 >> 2]);
       f548 = Math_fround(f468 * f556);
       f557 = Math_fround(HEAPF32[i191 >> 2]);
       f549 = Math_fround(f468 * f557);
       f558 = Math_fround(HEAPF32[i190 >> 2]);
       f548 = Math_fround(f552 + f548);
       f549 = Math_fround(f551 + f549);
       f550 = Math_fround(f550 + Math_fround(f468 * f558));
       f551 = Math_fround(Math_fround(Math_fround(f451 * f538) + Math_fround(f466 * f539)) + Math_fround(f469 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f451 * f540) + Math_fround(f466 * f541)) + Math_fround(f469 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f451 * f542) + Math_fround(f466 * f543)) + Math_fround(f469 * f557));
       f554 = Math_fround(Math_fround(Math_fround(f451 * f544) + Math_fround(f466 * f545)) + Math_fround(f469 * f558));
       f555 = Math_fround(Math_fround(Math_fround(f464 * f538) + Math_fround(f467 * f539)) + Math_fround(f470 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f464 * f540) + Math_fround(f467 * f541)) + Math_fround(f470 * f556));
       f557 = Math_fround(Math_fround(Math_fround(f464 * f542) + Math_fround(f467 * f543)) + Math_fround(f470 * f557));
       f558 = Math_fround(Math_fround(Math_fround(f464 * f544) + Math_fround(f467 * f545)) + Math_fround(f470 * f558));
       HEAPF32[i510 >> 2] = Math_fround(f546 + f547);
       HEAPF32[i302 >> 2] = f548;
       HEAPF32[i303 >> 2] = f549;
       HEAPF32[i304 >> 2] = f550;
       HEAPF32[i305 >> 2] = f551;
       HEAPF32[i306 >> 2] = f552;
       HEAPF32[i307 >> 2] = f553;
       HEAPF32[i308 >> 2] = f554;
       HEAPF32[i309 >> 2] = f555;
       HEAPF32[i310 >> 2] = f556;
       HEAPF32[i311 >> 2] = f557;
       HEAPF32[i312 >> 2] = f558;
      }
      if (i313) {
       i69 = HEAP32[i516 >> 2] | 0;
       i72 = i69 + 1068538453 | 0;
       i73 = HEAP32[i218 >> 2] | 0;
       i71 = i73 + 1068538453 | 0;
       i66 = HEAP32[i219 >> 2] | 0;
       i65 = i66 + 1068538453 | 0;
       i64 = HEAP32[i220 >> 2] | 0;
       i68 = i64 + 1068538453 | 0;
       i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i485 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i72 = i72 << 11 ^ i72;
       i71 = i71 << 11 ^ i71;
       i65 = i65 << 11 ^ i65;
       i68 = i68 << 11 ^ i68;
       f556 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i485 ^ i65 ^ i65 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i526 >> 2] = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i314 >> 2] = f556;
       HEAPF32[i315 >> 2] = f557;
       HEAPF32[i316 >> 2] = f558;
       i69 = i69 + 1068538454 | 0;
       i73 = i73 + 1068538454 | 0;
       i66 = i66 + 1068538454 | 0;
       i64 = i64 + 1068538454 | 0;
       i74 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i72 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i73 = i73 << 11 ^ i73;
       i66 = i66 << 11 ^ i66;
       i64 = i64 << 11 ^ i64;
       f558 = Math_fround(Math_fround((i72 ^ i73 ^ i73 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i70 ^ i66 ^ i66 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i68 ^ i64 ^ i64 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i317 >> 2] = Math_fround(Math_fround((i74 ^ i69 ^ i69 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i318 >> 2] = f558;
       HEAPF32[i319 >> 2] = f557;
       HEAPF32[i320 >> 2] = f556;
       i74 = HEAP32[i516 >> 2] | 0;
       i69 = i74 + 1068538455 | 0;
       i68 = HEAP32[i218 >> 2] | 0;
       i64 = i68 + 1068538455 | 0;
       i70 = HEAP32[i219 >> 2] | 0;
       i66 = i70 + 1068538455 | 0;
       i72 = HEAP32[i220 >> 2] | 0;
       i73 = i72 + 1068538455 | 0;
       i485 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i64 = i64 << 11 ^ i64;
       i66 = i66 << 11 ^ i66;
       i73 = i73 << 11 ^ i73;
       f556 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i71 ^ i73 ^ i73 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i321 >> 2] = Math_fround(Math_fround((i485 ^ i69 ^ i69 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i322 >> 2] = f556;
       HEAPF32[i323 >> 2] = f557;
       HEAPF32[i324 >> 2] = f558;
       f558 = Math_fround(Math_fround(HEAPF32[i515 >> 2]) * Math_fround(1.0e5));
       f557 = Math_fround(Math_fround(HEAPF32[i214 >> 2]) * Math_fround(1.0e5));
       f556 = Math_fround(Math_fround(HEAPF32[i215 >> 2]) * Math_fround(1.0e5));
       i74 = i74 + 1068538453 + ~~f558 | 0;
       i68 = i68 + 1068538453 + ~~f557 | 0;
       i70 = i70 + 1068538453 + ~~f556 | 0;
       i72 = i72 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i216 >> 2]) * Math_fround(1.0e5)) | 0;
       i485 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i68 = i68 << 11 ^ i68;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       f556 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i325 >> 2] = Math_fround(Math_fround((i485 ^ i74 ^ i74 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i326 >> 2] = f556;
       HEAPF32[i327 >> 2] = f557;
       HEAPF32[i328 >> 2] = f558;
      }
      i67 = HEAP32[i193 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i90 >> 2] | 0;
      i70 = HEAP32[i92 >> 2] | 0;
      i71 = HEAP32[i213 >> 2] | 0;
      i72 = HEAP32[i93 >> 2] | 0;
      i73 = HEAP32[i196 >> 2] | 0;
      i74 = HEAP32[i528 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i510 + (i66 << 2) | 0;
       i12 = i336 + (i66 << 2) | 0;
       i13 = i337 + (i66 << 2) | 0;
       i14 = i526 + (i66 << 2) | 0;
       i15 = i317 + (i66 << 2) | 0;
       i16 = i321 + (i66 << 2) | 0;
       i17 = i325 + (i66 << 2) | 0;
       i18 = i519 + (i66 << 2) | 0;
       i19 = i78 + (i66 << 2) | 0;
       i20 = i88 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i520 + (i66 << 2) | 0;
       i61 = i94 + (i66 << 2) | 0;
       i62 = i95 + (i66 << 2) | 0;
       i63 = i518 + (i66 << 2) | 0;
       i64 = i96 + (i66 << 2) | 0;
       i65 = i97 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i524 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i329) {
         i485 = i525 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i485 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i330) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i331) {
         i485 = i522 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i332) {
         i485 = i523 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i333) {
         f558 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f558;
         i1 = i1 + 16 | 0;
        }
        if (!i334) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i335) {
         i485 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i485;
         HEAP32[i1 + 4 >> 2] = i485;
         HEAP32[i1 + 8 >> 2] = i485;
         i1 = i1 + 12 | 0;
        }
        if (i301) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i338) {
         f558 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i485 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f558;
         HEAP32[i1 + 4 >> 2] = i485;
         i1 = i1 + 8 | 0;
        }
        if (!i339) {
         i485 = (HEAP32[i91 >> 2] & 2147483647 | 0) == 0 ? i511 : i22;
         HEAP32[i1 >> 2] = HEAP32[i485 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i340) {
         i485 = (HEAP32[i89 >> 2] & 2147483647 | 0) == 0 ? i511 : i21;
         HEAP32[i1 >> 2] = HEAP32[i485 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i313) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i77) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i168 >>> 0);
   }
   STACKTOP = i531;
   return;
  }
 case 3:
  {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i463 = i13 + 380 | 0;
   f490 = Math_fround(HEAPF32[i463 >> 2]);
   f479 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f483 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 392 | 0;
   f487 = Math_fround(HEAPF32[i463 >> 2]);
   f476 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f480 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 332 | 0;
   f491 = Math_fround((HEAP32[i463 >> 2] & 4095) >>> 0);
   f492 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f493 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f494 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   i3 = i13 + 420 | 0;
   f495 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i1 = i13 + 408 | 0;
   f488 = Math_fround(HEAPF32[i1 >> 2]);
   f477 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f481 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i1 = i13 + 336 | 0;
   f496 = Math_fround(HEAPF32[i1 >> 2]);
   f497 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f498 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f499 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   i1 = i13 + 352 | 0;
   f486 = Math_fround(HEAPF32[i1 >> 2]);
   f475 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i13 + 360 | 0;
   f484 = Math_fround(HEAPF32[i1 >> 2]);
   f474 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i2 + 36 | 0;
   f489 = Math_fround(HEAPF32[i1 >> 2]);
   f478 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f482 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i2 = HEAP32[i2 + 56 >> 2] | 0;
   f450 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f451 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f464 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f465 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f466 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f467 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f468 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f469 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f470 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f471 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f472 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f473 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   i1 = i13 + 64 | 0;
   i436 = i521 + 12 | 0;
   i437 = i521 + 8 | 0;
   i438 = i521 + 4 | 0;
   i439 = i521 + 28 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAP32[i439 >> 2] = 1;
   i452 = i521 + 24 | 0;
   HEAP32[i452 >> 2] = 1;
   i453 = i521 + 20 | 0;
   HEAP32[i453 >> 2] = 1;
   i454 = i521 + 16 | 0;
   HEAP32[i454 >> 2] = 1;
   i455 = i521 + 44 | 0;
   HEAP32[i455 >> 2] = 2;
   i456 = i521 + 40 | 0;
   HEAP32[i456 >> 2] = 2;
   i457 = i521 + 36 | 0;
   HEAP32[i457 >> 2] = 2;
   i458 = i521 + 32 | 0;
   HEAP32[i458 >> 2] = 2;
   i459 = i521 + 60 | 0;
   HEAP32[i459 >> 2] = 3;
   i460 = i521 + 56 | 0;
   HEAP32[i460 >> 2] = 3;
   i461 = i521 + 52 | 0;
   HEAP32[i461 >> 2] = 3;
   i462 = i521 + 48 | 0;
   HEAP32[i462 >> 2] = 3;
   i387 = i522 + 4 | 0;
   i411 = i522 + 8 | 0;
   i435 = i522 + 12 | 0;
   i363 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i363 >> 2] = Math_fround(1.0);
   i386 = i522 + 20 | 0;
   HEAPF32[i386 >> 2] = Math_fround(1.0);
   i410 = i522 + 24 | 0;
   HEAPF32[i410 >> 2] = Math_fround(1.0);
   i434 = i522 + 28 | 0;
   HEAPF32[i434 >> 2] = Math_fround(1.0);
   i362 = i522 + 32 | 0;
   HEAPF32[i362 >> 2] = Math_fround(1.0);
   i385 = i522 + 36 | 0;
   HEAPF32[i385 >> 2] = Math_fround(1.0);
   i409 = i522 + 40 | 0;
   HEAPF32[i409 >> 2] = Math_fround(1.0);
   i433 = i522 + 44 | 0;
   HEAPF32[i433 >> 2] = Math_fround(1.0);
   i361 = i522 + 48 | 0;
   HEAPF32[i361 >> 2] = Math_fround(1.0);
   i384 = i522 + 52 | 0;
   HEAPF32[i384 >> 2] = Math_fround(1.0);
   i408 = i522 + 56 | 0;
   HEAPF32[i408 >> 2] = Math_fround(1.0);
   i432 = i522 + 60 | 0;
   HEAPF32[i432 >> 2] = Math_fround(1.0);
   i360 = i522 + 64 | 0;
   HEAPF32[i360 >> 2] = Math_fround(1.0);
   i383 = i522 + 68 | 0;
   HEAPF32[i383 >> 2] = Math_fround(1.0);
   i407 = i522 + 72 | 0;
   HEAPF32[i407 >> 2] = Math_fround(1.0);
   i431 = i522 + 76 | 0;
   HEAPF32[i431 >> 2] = Math_fround(1.0);
   i359 = i522 + 80 | 0;
   i382 = i522 + 84 | 0;
   i406 = i522 + 88 | 0;
   i430 = i522 + 92 | 0;
   i358 = i522 + 96 | 0;
   i381 = i522 + 100 | 0;
   i405 = i522 + 104 | 0;
   i429 = i522 + 108 | 0;
   i357 = i522 + 112 | 0;
   i380 = i522 + 116 | 0;
   i404 = i522 + 120 | 0;
   i428 = i522 + 124 | 0;
   i17 = i359;
   i15 = i17 + 48 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i379 = i523 + 4 | 0;
   i403 = i523 + 8 | 0;
   i427 = i523 + 12 | 0;
   i356 = i523 + 16 | 0;
   HEAP32[i523 >> 2] = 0;
   HEAP32[i523 + 4 >> 2] = 0;
   HEAP32[i523 + 8 >> 2] = 0;
   HEAP32[i523 + 12 >> 2] = 0;
   HEAPF32[i356 >> 2] = Math_fround(1.0);
   i378 = i523 + 20 | 0;
   HEAPF32[i378 >> 2] = Math_fround(1.0);
   i402 = i523 + 24 | 0;
   HEAPF32[i402 >> 2] = Math_fround(1.0);
   i426 = i523 + 28 | 0;
   HEAPF32[i426 >> 2] = Math_fround(1.0);
   i355 = i523 + 32 | 0;
   i377 = i523 + 36 | 0;
   i401 = i523 + 40 | 0;
   i425 = i523 + 44 | 0;
   i354 = i523 + 48 | 0;
   i376 = i523 + 52 | 0;
   i400 = i523 + 56 | 0;
   i424 = i523 + 60 | 0;
   i353 = i523 + 64 | 0;
   HEAP32[i355 >> 2] = 0;
   HEAP32[i355 + 4 >> 2] = 0;
   HEAP32[i355 + 8 >> 2] = 0;
   HEAP32[i355 + 12 >> 2] = 0;
   HEAP32[i355 + 16 >> 2] = 0;
   HEAP32[i355 + 20 >> 2] = 0;
   HEAP32[i355 + 24 >> 2] = 0;
   HEAP32[i355 + 28 >> 2] = 0;
   HEAPF32[i353 >> 2] = Math_fround(1.0);
   i375 = i523 + 68 | 0;
   HEAPF32[i375 >> 2] = Math_fround(1.0);
   i399 = i523 + 72 | 0;
   HEAPF32[i399 >> 2] = Math_fround(1.0);
   i423 = i523 + 76 | 0;
   HEAPF32[i423 >> 2] = Math_fround(1.0);
   i352 = i523 + 80 | 0;
   HEAPF32[i352 >> 2] = Math_fround(1.0);
   i374 = i523 + 84 | 0;
   HEAPF32[i374 >> 2] = Math_fround(1.0);
   i398 = i523 + 88 | 0;
   HEAPF32[i398 >> 2] = Math_fround(1.0);
   i422 = i523 + 92 | 0;
   HEAPF32[i422 >> 2] = Math_fround(1.0);
   i351 = i523 + 96 | 0;
   i373 = i523 + 100 | 0;
   i397 = i523 + 104 | 0;
   i421 = i523 + 108 | 0;
   i350 = i523 + 112 | 0;
   i372 = i523 + 116 | 0;
   i396 = i523 + 120 | 0;
   i420 = i523 + 124 | 0;
   i349 = i523 + 128 | 0;
   HEAP32[i351 >> 2] = 0;
   HEAP32[i351 + 4 >> 2] = 0;
   HEAP32[i351 + 8 >> 2] = 0;
   HEAP32[i351 + 12 >> 2] = 0;
   HEAP32[i351 + 16 >> 2] = 0;
   HEAP32[i351 + 20 >> 2] = 0;
   HEAP32[i351 + 24 >> 2] = 0;
   HEAP32[i351 + 28 >> 2] = 0;
   HEAPF32[i349 >> 2] = Math_fround(1.0);
   i371 = i523 + 132 | 0;
   HEAPF32[i371 >> 2] = Math_fround(1.0);
   i395 = i523 + 136 | 0;
   HEAPF32[i395 >> 2] = Math_fround(1.0);
   i419 = i523 + 140 | 0;
   HEAPF32[i419 >> 2] = Math_fround(1.0);
   i348 = i523 + 144 | 0;
   i370 = i523 + 148 | 0;
   i394 = i523 + 152 | 0;
   i418 = i523 + 156 | 0;
   i347 = i523 + 160 | 0;
   i369 = i523 + 164 | 0;
   i393 = i523 + 168 | 0;
   i417 = i523 + 172 | 0;
   i346 = i523 + 176 | 0;
   i368 = i523 + 180 | 0;
   i392 = i523 + 184 | 0;
   i416 = i523 + 188 | 0;
   i345 = i523 + 192 | 0;
   i367 = i523 + 196 | 0;
   i391 = i523 + 200 | 0;
   i415 = i523 + 204 | 0;
   i344 = i523 + 208 | 0;
   i366 = i523 + 212 | 0;
   i390 = i523 + 216 | 0;
   i414 = i523 + 220 | 0;
   i343 = i523 + 224 | 0;
   i365 = i523 + 228 | 0;
   i389 = i523 + 232 | 0;
   i413 = i523 + 236 | 0;
   i341 = i523 + 240 | 0;
   i364 = i523 + 244 | 0;
   i388 = i523 + 248 | 0;
   i412 = i523 + 252 | 0;
   i17 = i348;
   i15 = i17 + 112 | 0;
   do {
    HEAP32[i17 >> 2] = 0;
    i17 = i17 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   i17 = i12;
   i15 = i17 + 64 | 0;
   do {
    HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
    i17 = i17 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i17 | 0) < (i15 | 0));
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
   f443 = Math_fround(HEAPF32[i3 >> 2]);
   f552 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f342 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f554 = Math_fround(HEAPF32[i14 >> 2]);
   i336 = i14 + 4 | 0;
   f550 = Math_fround(HEAPF32[i336 >> 2]);
   i337 = i14 + 8 | 0;
   f447 = Math_fround(HEAPF32[i337 >> 2]);
   i338 = i14 + 12 | 0;
   f556 = Math_fround(HEAPF32[i338 >> 2]);
   i339 = i14 + 16 | 0;
   f551 = Math_fround(HEAPF32[i339 >> 2]);
   i340 = i14 + 20 | 0;
   f448 = Math_fround(HEAPF32[i340 >> 2]);
   i485 = i14 + 24 | 0;
   f558 = Math_fround(HEAPF32[i485 >> 2]);
   i168 = i14 + 28 | 0;
   f553 = Math_fround(HEAPF32[i168 >> 2]);
   i167 = i14 + 32 | 0;
   f449 = Math_fround(HEAPF32[i167 >> 2]);
   f555 = Math_fround(f550 * Math_fround(0.0));
   f444 = Math_fround(f447 * Math_fround(0.0));
   f441 = Math_fround(Math_fround(Math_fround(f443 * f554) + f555) + f444);
   f557 = Math_fround(f551 * Math_fround(0.0));
   f445 = Math_fround(f448 * Math_fround(0.0));
   f442 = Math_fround(Math_fround(Math_fround(f443 * f556) + f557) + f445);
   f440 = Math_fround(f553 * Math_fround(0.0));
   f446 = Math_fround(f449 * Math_fround(0.0));
   f443 = Math_fround(Math_fround(Math_fround(f443 * f558) + f440) + f446);
   f554 = Math_fround(f554 * Math_fround(0.0));
   f444 = Math_fround(Math_fround(f554 + Math_fround(f552 * f550)) + f444);
   f556 = Math_fround(f556 * Math_fround(0.0));
   f445 = Math_fround(Math_fround(f556 + Math_fround(f552 * f551)) + f445);
   f558 = Math_fround(f558 * Math_fround(0.0));
   f446 = Math_fround(Math_fround(f558 + Math_fround(f552 * f553)) + f446);
   f447 = Math_fround(Math_fround(f554 + f555) + Math_fround(f342 * f447));
   f448 = Math_fround(Math_fround(f556 + f557) + Math_fround(f342 * f448));
   f449 = Math_fround(Math_fround(f558 + f440) + Math_fround(f342 * f449));
   HEAPF32[i14 >> 2] = f441;
   HEAPF32[i336 >> 2] = f444;
   HEAPF32[i337 >> 2] = f447;
   HEAPF32[i338 >> 2] = f442;
   HEAPF32[i339 >> 2] = f445;
   HEAPF32[i340 >> 2] = f448;
   HEAPF32[i485 >> 2] = f443;
   HEAPF32[i168 >> 2] = f446;
   HEAPF32[i167 >> 2] = f449;
   f342 = Math_fround(Math_fround(1.0) / f491);
   f440 = Math_fround(Math_fround(1.0) - f494);
   i167 = (i2 | 0) == 27;
   HEAP32[i511 >> 2] = 0;
   HEAP32[i511 + 4 >> 2] = 0;
   HEAP32[i511 + 8 >> 2] = 0;
   HEAP32[i511 + 12 >> 2] = 0;
   i168 = HEAP32[i527 + 12 >> 2] | 0;
   if (i168 | 0) {
    i169 = i529 + 12 | 0;
    i170 = i529 + 8 | 0;
    i171 = i529 + 4 | 0;
    i172 = i529 + 16 | 0;
    i173 = i529 + 28 | 0;
    i174 = i529 + 24 | 0;
    i175 = i529 + 20 | 0;
    i176 = i529 + 32 | 0;
    i177 = i529 + 44 | 0;
    i178 = i529 + 40 | 0;
    i179 = i529 + 36 | 0;
    i180 = i530 + 32 | 0;
    i181 = i530 + 44 | 0;
    i182 = i530 + 40 | 0;
    i183 = i530 + 36 | 0;
    i184 = i512 + 12 | 0;
    i185 = i512 + 8 | 0;
    i186 = i512 + 4 | 0;
    i187 = i512 + 28 | 0;
    i188 = i512 + 24 | 0;
    i189 = i512 + 20 | 0;
    i190 = i512 + 44 | 0;
    i191 = i512 + 40 | 0;
    i192 = i512 + 36 | 0;
    i193 = i528 + 20 | 0;
    i194 = i527 + 20 | 0;
    i195 = i527 + 40 | 0;
    i196 = i527 + 340 | 0;
    i197 = i527 + 60 | 0;
    i198 = i527 + 80 | 0;
    i199 = i527 + 100 | 0;
    i200 = i527 + 120 | 0;
    i201 = i527 + 140 | 0;
    i202 = i527 + 160 | 0;
    i203 = i512 + 16 | 0;
    i204 = i512 + 32 | 0;
    i205 = i528 + 4 | 0;
    i206 = i513 + 4 | 0;
    i207 = i513 + 8 | 0;
    i208 = i513 + 12 | 0;
    i209 = i528 + 8 | 0;
    i210 = i514 + 4 | 0;
    i211 = i514 + 8 | 0;
    i212 = i514 + 12 | 0;
    i213 = i527 + 520 | 0;
    i214 = i515 + 4 | 0;
    i215 = i515 + 8 | 0;
    i216 = i515 + 12 | 0;
    i217 = i527 + 500 | 0;
    i218 = i516 + 4 | 0;
    i219 = i516 + 8 | 0;
    i220 = i516 + 12 | 0;
    i221 = i528 + 16 | 0;
    i222 = i517 + 4 | 0;
    i223 = i517 + 8 | 0;
    i224 = i517 + 12 | 0;
    i225 = i529 + 16 | 0;
    i226 = i529 + 32 | 0;
    i227 = i518 + 4 | 0;
    i228 = i518 + 8 | 0;
    i229 = i518 + 12 | 0;
    i230 = i518 + 16 | 0;
    i231 = i518 + 20 | 0;
    i232 = i518 + 24 | 0;
    i233 = i518 + 28 | 0;
    i234 = i518 + 32 | 0;
    i235 = i518 + 36 | 0;
    i236 = i518 + 40 | 0;
    i237 = i518 + 44 | 0;
    i238 = i530 + 32 | 0;
    i239 = i524 + 4 | 0;
    i240 = i524 + 8 | 0;
    i241 = i524 + 12 | 0;
    i242 = i524 + 16 | 0;
    i243 = i524 + 20 | 0;
    i244 = i524 + 24 | 0;
    i245 = i524 + 28 | 0;
    i246 = i524 + 32 | 0;
    i247 = i524 + 36 | 0;
    i248 = i524 + 40 | 0;
    i249 = i524 + 44 | 0;
    i250 = i524 + 48 | 0;
    i251 = i524 + 52 | 0;
    i252 = i524 + 56 | 0;
    i253 = i524 + 60 | 0;
    i254 = i524 + 64 | 0;
    i255 = i524 + 68 | 0;
    i256 = i524 + 72 | 0;
    i257 = i524 + 76 | 0;
    i258 = i524 + 80 | 0;
    i259 = i524 + 84 | 0;
    i260 = i524 + 88 | 0;
    i261 = i524 + 92 | 0;
    i262 = i524 + 96 | 0;
    i263 = i524 + 100 | 0;
    i264 = i524 + 104 | 0;
    i265 = i524 + 108 | 0;
    i266 = i524 + 112 | 0;
    i267 = i524 + 116 | 0;
    i268 = i524 + 120 | 0;
    i269 = i524 + 124 | 0;
    i270 = i524 + 128 | 0;
    i271 = i524 + 132 | 0;
    i272 = i524 + 136 | 0;
    i273 = i524 + 140 | 0;
    i274 = i524 + 144 | 0;
    i275 = i524 + 148 | 0;
    i276 = i524 + 152 | 0;
    i277 = i524 + 156 | 0;
    i278 = i524 + 160 | 0;
    i279 = i524 + 164 | 0;
    i280 = i524 + 168 | 0;
    i281 = i524 + 172 | 0;
    i282 = i524 + 176 | 0;
    i283 = i524 + 180 | 0;
    i284 = i524 + 184 | 0;
    i285 = i524 + 188 | 0;
    i286 = (i2 & 48 | 0) == 0;
    i129 = i525 + 4 | 0;
    i146 = i525 + 8 | 0;
    i163 = i525 + 12 | 0;
    i287 = i525 + 16 | 0;
    i124 = i525 + 20 | 0;
    i141 = i525 + 24 | 0;
    i158 = i525 + 28 | 0;
    i288 = i525 + 32 | 0;
    i119 = i525 + 36 | 0;
    i136 = i525 + 40 | 0;
    i153 = i525 + 44 | 0;
    i289 = i525 + 48 | 0;
    i128 = i525 + 52 | 0;
    i145 = i525 + 56 | 0;
    i162 = i525 + 60 | 0;
    i290 = i525 + 64 | 0;
    i123 = i525 + 68 | 0;
    i140 = i525 + 72 | 0;
    i157 = i525 + 76 | 0;
    i291 = i525 + 80 | 0;
    i118 = i525 + 84 | 0;
    i135 = i525 + 88 | 0;
    i152 = i525 + 92 | 0;
    i292 = i525 + 96 | 0;
    i127 = i525 + 100 | 0;
    i144 = i525 + 104 | 0;
    i161 = i525 + 108 | 0;
    i293 = i525 + 112 | 0;
    i122 = i525 + 116 | 0;
    i139 = i525 + 120 | 0;
    i156 = i525 + 124 | 0;
    i294 = i525 + 128 | 0;
    i117 = i525 + 132 | 0;
    i134 = i525 + 136 | 0;
    i151 = i525 + 140 | 0;
    i295 = i525 + 144 | 0;
    i126 = i525 + 148 | 0;
    i143 = i525 + 152 | 0;
    i160 = i525 + 156 | 0;
    i296 = i525 + 160 | 0;
    i121 = i525 + 164 | 0;
    i138 = i525 + 168 | 0;
    i155 = i525 + 172 | 0;
    i297 = i525 + 176 | 0;
    i116 = i525 + 180 | 0;
    i133 = i525 + 184 | 0;
    i150 = i525 + 188 | 0;
    i130 = i519 + 4 | 0;
    i147 = i519 + 8 | 0;
    i164 = i519 + 12 | 0;
    i298 = i519 + 16 | 0;
    i125 = i519 + 20 | 0;
    i142 = i519 + 24 | 0;
    i159 = i519 + 28 | 0;
    i299 = i519 + 32 | 0;
    i120 = i519 + 36 | 0;
    i137 = i519 + 40 | 0;
    i154 = i519 + 44 | 0;
    i132 = i520 + 4 | 0;
    i149 = i520 + 8 | 0;
    i166 = i520 + 12 | 0;
    i300 = i520 + 16 | 0;
    i131 = i520 + 20 | 0;
    i148 = i520 + 24 | 0;
    i165 = i520 + 28 | 0;
    i115 = i520 + 32 | 0;
    i301 = (i2 & 512 | 0) != 0;
    i302 = i510 + 4 | 0;
    i303 = i510 + 8 | 0;
    i304 = i510 + 12 | 0;
    i305 = i510 + 16 | 0;
    i306 = i510 + 20 | 0;
    i307 = i510 + 24 | 0;
    i308 = i510 + 28 | 0;
    i309 = i510 + 32 | 0;
    i310 = i510 + 36 | 0;
    i311 = i510 + 40 | 0;
    i312 = i510 + 44 | 0;
    i313 = (i2 & 8192 | 0) != 0;
    i314 = i526 + 4 | 0;
    i315 = i526 + 8 | 0;
    i316 = i526 + 12 | 0;
    i317 = i526 + 16 | 0;
    i318 = i526 + 20 | 0;
    i319 = i526 + 24 | 0;
    i320 = i526 + 28 | 0;
    i321 = i526 + 32 | 0;
    i322 = i526 + 36 | 0;
    i323 = i526 + 40 | 0;
    i324 = i526 + 44 | 0;
    i325 = i526 + 48 | 0;
    i326 = i526 + 52 | 0;
    i327 = i526 + 56 | 0;
    i328 = i526 + 60 | 0;
    i329 = (i2 & 2 | 0) == 0;
    i330 = (i2 & 8 | 0) == 0;
    i331 = (i2 & 16 | 0) == 0;
    i332 = (i2 & 32 | 0) == 0;
    i333 = (i2 & 64 | 0) == 0;
    i334 = (i2 & 128 | 0) == 0;
    i335 = (i2 & 256 | 0) == 0;
    i336 = i510 + 16 | 0;
    i337 = i510 + 32 | 0;
    i338 = (i2 & 1024 | 0) == 0;
    i339 = (i2 & 2048 | 0) == 0;
    i340 = (i2 & 4096 | 0) == 0;
    i77 = (i2 & 4 | 0) == 0;
    i78 = i519 + 16 | 0;
    i88 = i519 + 32 | 0;
    i89 = i527 + 864 | 0;
    i90 = i527 + 848 | 0;
    i91 = i527 + 844 | 0;
    i92 = i527 + 828 | 0;
    i93 = i527 + 540 | 0;
    i94 = i520 + 16 | 0;
    i95 = i520 + 32 | 0;
    i96 = i518 + 16 | 0;
    i97 = i518 + 32 | 0;
    i98 = i524 + 16 | 0;
    i99 = i524 + 32 | 0;
    i100 = i525 + 16 | 0;
    i101 = i525 + 32 | 0;
    i102 = i250 + 16 | 0;
    i103 = i250 + 32 | 0;
    i104 = i289 + 16 | 0;
    i105 = i289 + 32 | 0;
    i106 = i262 + 16 | 0;
    i107 = i262 + 32 | 0;
    i108 = i292 + 16 | 0;
    i109 = i292 + 32 | 0;
    i110 = i274 + 16 | 0;
    i111 = i274 + 32 | 0;
    i112 = i295 + 16 | 0;
    i113 = i295 + 32 | 0;
    i114 = i4 + 564 | 0;
    i76 = i4 + 568 | 0;
    i75 = 0;
    i1 = i16;
    do {
     i17 = i529;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     i17 = i530;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     i17 = i512;
     i15 = i17 + 48 | 0;
     do {
      HEAP32[i17 >> 2] = 0;
      i17 = i17 + 4 | 0;
     } while ((i17 | 0) < (i15 | 0));
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     HEAP32[i517 >> 2] = 0;
     HEAP32[i517 + 4 >> 2] = 0;
     HEAP32[i517 + 8 >> 2] = 0;
     HEAP32[i517 + 12 >> 2] = 0;
     i22 = HEAP32[i193 >> 2] | 0;
     i23 = HEAP32[i527 >> 2] | 0;
     if (!i22) {
      i64 = i23 + (i75 << 2) | 0;
      i65 = HEAP32[i64 + 4 >> 2] | 0;
      i66 = HEAP32[i64 + 8 >> 2] | 0;
      i67 = HEAP32[i64 + 12 >> 2] | 0;
      i71 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      i68 = HEAP32[i71 >> 2] | 0;
      i69 = HEAP32[i71 + 4 >> 2] | 0;
      i70 = HEAP32[i71 + 8 >> 2] | 0;
      i71 = HEAP32[i71 + 12 >> 2] | 0;
      i72 = (HEAP32[i195 >> 2] | 0) + (i75 << 2) | 0;
      i485 = HEAP32[i72 >> 2] | 0;
      i74 = HEAP32[i72 + 4 >> 2] | 0;
      i73 = HEAP32[i72 + 8 >> 2] | 0;
      i72 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i529 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i171 >> 2] = i65;
      HEAP32[i170 >> 2] = i66;
      HEAP32[i169 >> 2] = i67;
      HEAP32[i172 >> 2] = i68;
      HEAP32[i175 >> 2] = i69;
      HEAP32[i174 >> 2] = i70;
      HEAP32[i173 >> 2] = i71;
      HEAP32[i176 >> 2] = i485;
      HEAP32[i179 >> 2] = i74;
      HEAP32[i178 >> 2] = i73;
      HEAP32[i177 >> 2] = i72;
      i72 = (HEAP32[i196 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i180 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i183 >> 2] = i73;
      HEAP32[i182 >> 2] = i74;
      HEAP32[i181 >> 2] = i485;
      i485 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      f546 = Math_fround(HEAPF32[i485 >> 2]);
      f536 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f537 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f538 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i198 >> 2] | 0) + (i75 << 2) | 0;
      f539 = Math_fround(HEAPF32[i485 >> 2]);
      f540 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f541 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f542 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i199 >> 2] | 0) + (i75 << 2) | 0;
      f543 = Math_fround(HEAPF32[i485 >> 2]);
      f544 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f545 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f558 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i200 >> 2] | 0) + (i75 << 2) | 0;
      f547 = Math_fround(HEAPF32[i485 >> 2]);
      f548 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f549 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f550 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i201 >> 2] | 0) + (i75 << 2) | 0;
      f551 = Math_fround(HEAPF32[i485 >> 2]);
      f552 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f553 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f554 = Math_fround(HEAPF32[i485 + 12 >> 2]);
      i485 = (HEAP32[i202 >> 2] | 0) + (i75 << 2) | 0;
      f555 = Math_fround(HEAPF32[i485 >> 2]);
      f556 = Math_fround(HEAPF32[i485 + 4 >> 2]);
      f557 = Math_fround(HEAPF32[i485 + 8 >> 2]);
      f548 = Math_fround(f536 + f548);
      f549 = Math_fround(f537 + f549);
      f550 = Math_fround(f538 + f550);
      f551 = Math_fround(f539 + f551);
      f552 = Math_fround(f540 + f552);
      f553 = Math_fround(f541 + f553);
      f554 = Math_fround(f542 + f554);
      f555 = Math_fround(f543 + f555);
      f556 = Math_fround(f544 + f556);
      f557 = Math_fround(f545 + f557);
      f558 = Math_fround(f558 + Math_fround(HEAPF32[i485 + 12 >> 2]));
      HEAPF32[i512 >> 2] = Math_fround(f546 + f547);
      HEAPF32[i186 >> 2] = f548;
      HEAPF32[i185 >> 2] = f549;
      HEAPF32[i184 >> 2] = f550;
      HEAPF32[i203 >> 2] = f551;
      HEAPF32[i189 >> 2] = f552;
      HEAPF32[i188 >> 2] = f553;
      HEAPF32[i187 >> 2] = f554;
      HEAPF32[i204 >> 2] = f555;
      HEAPF32[i192 >> 2] = f556;
      HEAPF32[i191 >> 2] = f557;
      HEAPF32[i190 >> 2] = f558;
      i485 = (HEAP32[i205 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i485 + 4 >> 2] | 0;
      i73 = HEAP32[i485 + 8 >> 2] | 0;
      i72 = HEAP32[i485 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i485 >> 2];
      HEAP32[i206 >> 2] = i74;
      HEAP32[i207 >> 2] = i73;
      HEAP32[i208 >> 2] = i72;
      i72 = (HEAP32[i209 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i210 >> 2] = i73;
      HEAP32[i211 >> 2] = i74;
      HEAP32[i212 >> 2] = i485;
      i485 = (HEAP32[i213 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i485 + 4 >> 2] | 0;
      i73 = HEAP32[i485 + 8 >> 2] | 0;
      i72 = HEAP32[i485 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i485 >> 2];
      HEAP32[i214 >> 2] = i74;
      HEAP32[i215 >> 2] = i73;
      HEAP32[i216 >> 2] = i72;
      i72 = (HEAP32[i217 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i485 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i516 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i218 >> 2] = i73;
      HEAP32[i219 >> 2] = i74;
      HEAP32[i220 >> 2] = i485;
      if (HEAP32[i463 >> 2] & 268435456 | 0) {
       i72 = (HEAP32[i221 >> 2] | 0) + (i75 << 2) | 0;
       i73 = HEAP32[i72 + 4 >> 2] | 0;
       i74 = HEAP32[i72 + 8 >> 2] | 0;
       i485 = HEAP32[i72 + 12 >> 2] | 0;
       HEAP32[i517 >> 2] = HEAP32[i72 >> 2];
       HEAP32[i222 >> 2] = i73;
       HEAP32[i223 >> 2] = i74;
       HEAP32[i224 >> 2] = i485;
      }
     } else {
      i4 = HEAP32[i197 >> 2] | 0;
      i11 = HEAP32[i200 >> 2] | 0;
      i12 = HEAP32[i194 >> 2] | 0;
      i13 = HEAP32[i198 >> 2] | 0;
      i14 = HEAP32[i201 >> 2] | 0;
      i15 = HEAP32[i195 >> 2] | 0;
      i16 = HEAP32[i199 >> 2] | 0;
      i17 = HEAP32[i202 >> 2] | 0;
      i18 = HEAP32[i205 >> 2] | 0;
      i19 = HEAP32[i209 >> 2] | 0;
      i20 = HEAP32[i213 >> 2] | 0;
      i21 = HEAP32[i217 >> 2] | 0;
      i24 = HEAP32[i196 >> 2] | 0;
      i3 = HEAP32[i221 >> 2] | 0;
      if (!(HEAP32[i463 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i2 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i485 = i2 + 4 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i485 = i2 + 8 | 0;
        HEAP32[i529 + (i485 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f558 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i512 + (i485 << 2) >> 2] = Math_fround(f558 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i517 + (i2 << 2) >> 2] = HEAP32[i3 + (i74 << 2) >> 2];
        HEAP32[i530 + (i485 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f80 = Math_fround(HEAPF32[i529 >> 2]);
     f7 = Math_fround(f450 * f80);
     f85 = Math_fround(HEAPF32[i171 >> 2]);
     f83 = Math_fround(f450 * f85);
     f558 = Math_fround(HEAPF32[i170 >> 2]);
     f6 = Math_fround(f450 * f558);
     f556 = Math_fround(HEAPF32[i169 >> 2]);
     f87 = Math_fround(f450 * f556);
     f86 = Math_fround(HEAPF32[i225 >> 2]);
     f84 = Math_fround(f465 * f86);
     f79 = Math_fround(HEAPF32[i175 >> 2]);
     f27 = Math_fround(f465 * f79);
     f557 = Math_fround(HEAPF32[i174 >> 2]);
     f10 = Math_fround(f465 * f557);
     f555 = Math_fround(HEAPF32[i173 >> 2]);
     f84 = Math_fround(f7 + f84);
     f27 = Math_fround(f83 + f27);
     f10 = Math_fround(f6 + f10);
     f87 = Math_fround(f87 + Math_fround(f465 * f555));
     f6 = Math_fround(HEAPF32[i226 >> 2]);
     f83 = Math_fround(f468 * f6);
     f7 = Math_fround(HEAPF32[i179 >> 2]);
     f82 = Math_fround(f468 * f7);
     f8 = Math_fround(HEAPF32[i178 >> 2]);
     f81 = Math_fround(f468 * f8);
     f26 = Math_fround(HEAPF32[i177 >> 2]);
     f82 = Math_fround(f471 + Math_fround(f27 + f82));
     f81 = Math_fround(f471 + Math_fround(f10 + f81));
     f87 = Math_fround(f471 + Math_fround(f87 + Math_fround(f468 * f26)));
     HEAPF32[i518 >> 2] = Math_fround(f471 + Math_fround(f84 + f83));
     HEAPF32[i227 >> 2] = f82;
     HEAPF32[i228 >> 2] = f81;
     HEAPF32[i229 >> 2] = f87;
     f87 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f85) + Math_fround(f466 * f79)) + Math_fround(f469 * f7)));
     f81 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f558) + Math_fround(f466 * f557)) + Math_fround(f469 * f8)));
     f82 = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f556) + Math_fround(f466 * f555)) + Math_fround(f469 * f26)));
     HEAPF32[i230 >> 2] = Math_fround(f472 + Math_fround(Math_fround(Math_fround(f451 * f80) + Math_fround(f466 * f86)) + Math_fround(f469 * f6)));
     HEAPF32[i231 >> 2] = f87;
     HEAPF32[i232 >> 2] = f81;
     HEAPF32[i233 >> 2] = f82;
     f82 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f85) + Math_fround(f467 * f79)) + Math_fround(f470 * f7)));
     f81 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f558) + Math_fround(f467 * f557)) + Math_fround(f470 * f8)));
     f87 = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f556) + Math_fround(f467 * f555)) + Math_fround(f470 * f26)));
     HEAPF32[i234 >> 2] = Math_fround(f473 + Math_fround(Math_fround(Math_fround(f464 * f80) + Math_fround(f467 * f86)) + Math_fround(f470 * f6)));
     HEAPF32[i235 >> 2] = f82;
     HEAPF32[i236 >> 2] = f81;
     HEAPF32[i237 >> 2] = f87;
     f6 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f80) + Math_fround(f497 * f86)) + Math_fround(f498 * f6)));
     f7 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f85) + Math_fround(f497 * f79)) + Math_fround(f498 * f7)));
     f8 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f558) + Math_fround(f497 * f557)) + Math_fround(f498 * f8)));
     f26 = Math_fround(f499 + Math_fround(Math_fround(Math_fround(f496 * f556) + Math_fround(f497 * f555)) + Math_fround(f498 * f26)));
     f555 = Math_fround(f484 + Math_fround(f486 * f6));
     f556 = Math_fround(f484 + Math_fround(f486 * f7));
     f557 = Math_fround(f484 + Math_fround(f486 * f8));
     f558 = Math_fround(f484 + Math_fround(f486 * f26));
     f6 = Math_fround(f474 + Math_fround(f475 * f6));
     f7 = Math_fround(f474 + Math_fround(f475 * f7));
     f8 = Math_fround(f474 + Math_fround(f475 * f8));
     f26 = Math_fround(f474 + Math_fround(f475 * f26));
     f79 = Math_fround(HEAPF32[i513 >> 2]);
     f85 = Math_fround(HEAPF32[i206 >> 2]);
     f86 = Math_fround(HEAPF32[i207 >> 2]);
     f80 = Math_fround(HEAPF32[i208 >> 2]);
     f81 = Math_fround(HEAPF32[i514 >> 2]);
     f82 = Math_fround(HEAPF32[i210 >> 2]);
     f83 = Math_fround(HEAPF32[i211 >> 2]);
     f84 = Math_fround(HEAPF32[i212 >> 2]);
     f10 = f79 > f81 ? f79 : f81;
     f27 = f85 > f82 ? f85 : f82;
     f25 = f86 > f83 ? f86 : f83;
     f28 = f80 > f84 ? f80 : f84;
     f552 = Math_fround((f10 > f555 ? f10 : f555) * Math_fround(.5));
     f553 = Math_fround((f27 > f556 ? f27 : f556) * Math_fround(.5));
     f554 = Math_fround((f25 > f557 ? f25 : f557) * Math_fround(.5));
     f5 = Math_fround((f28 > f558 ? f28 : f558) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f552, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f553, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f554, HEAP32[tempDoublePtr >> 2] | 0);
     i72 = f555 >= Math_fround(0.0);
     i73 = f556 >= Math_fround(0.0);
     i74 = f557 >= Math_fround(0.0);
     i485 = f558 >= Math_fround(0.0);
     i15 = i72 ? i15 : 0;
     i16 = i73 ? i16 : 0;
     i17 = i74 ? i17 : 0;
     i11 = i485 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f554 = Math_fround(f6 * Math_fround(.5));
     f556 = Math_fround(f7 * Math_fround(.5));
     f558 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f26 * Math_fround(.5));
     f553 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f555 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f557 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f553 < f554 ? f553 : f554, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f555 < f556 ? f555 : f556, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f557 < f558 ? f557 : f558, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i485 = f26 >= Math_fround(0.0);
     i72 = i485 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f27);
     f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
     f27 = Math_fround(f79 * f31);
     f28 = Math_fround(f85 * f32);
     f29 = Math_fround(f86 * f33);
     f30 = Math_fround(f80 * f34);
     f31 = Math_fround(f81 * f31);
     f32 = Math_fround(f82 * f32);
     f33 = Math_fround(f83 * f33);
     f34 = Math_fround(f84 * f34);
     i72 = Math_fround(HEAPF32[i515 >> 2]) < Math_fround(100.0);
     i73 = Math_fround(HEAPF32[i214 >> 2]) < Math_fround(100.0);
     i74 = Math_fround(HEAPF32[i215 >> 2]) < Math_fround(100.0);
     i485 = Math_fround(HEAPF32[i216 >> 2]) < Math_fround(100.0);
     f27 = i72 ? f27 : Math_fround(0.0);
     f540 = Math_fround(f490 * f27);
     f28 = i73 ? f28 : Math_fround(0.0);
     f507 = Math_fround(f490 * f28);
     f29 = i74 ? f29 : Math_fround(0.0);
     f538 = Math_fround(f490 * f29);
     f30 = i485 ? f30 : Math_fround(0.0);
     f508 = Math_fround(f490 * f30);
     f55 = Math_fround(f479 * f27);
     f56 = Math_fround(f479 * f28);
     f57 = Math_fround(f479 * f29);
     f58 = Math_fround(f479 * f30);
     f532 = Math_fround(f483 * f27);
     f53 = Math_fround(f483 * f28);
     f50 = Math_fround(f483 * f29);
     f47 = Math_fround(f483 * f30);
     f31 = i72 ? f31 : Math_fround(0.0);
     f536 = Math_fround(f487 * f31);
     f32 = i73 ? f32 : Math_fround(0.0);
     f539 = Math_fround(f487 * f32);
     f33 = i74 ? f33 : Math_fround(0.0);
     f542 = Math_fround(f487 * f33);
     f34 = i485 ? f34 : Math_fround(0.0);
     f553 = Math_fround(f487 * f34);
     f506 = Math_fround(f476 * f31);
     f545 = Math_fround(f476 * f32);
     f552 = Math_fround(f476 * f33);
     f555 = Math_fround(f476 * f34);
     f558 = Math_fround(f480 * f31);
     f509 = Math_fround(f480 * f32);
     f52 = Math_fround(f480 * f33);
     f49 = Math_fround(f480 * f34);
     f557 = Math_fround(HEAPF32[i238 >> 2]);
     f546 = Math_fround(f557 + Math_fround(.785398125));
     f544 = Math_fround(HEAPF32[i183 >> 2]);
     f554 = Math_fround(f544 + Math_fround(.785398125));
     f543 = Math_fround(HEAPF32[i182 >> 2]);
     f537 = Math_fround(f543 + Math_fround(.785398125));
     f556 = Math_fround(HEAPF32[i181 >> 2]);
     f546 = Math_fround(f546 * Math_fround(.159154937));
     f554 = Math_fround(f554 * Math_fround(.159154937));
     f537 = Math_fround(f537 * Math_fround(.159154937));
     f550 = Math_fround(Math_fround(f556 + Math_fround(.785398125)) * Math_fround(.159154937));
     f549 = Math_fround(+_roundf(+f546));
     f43 = Math_fround(+_roundf(+f554));
     f541 = Math_fround(+_roundf(+f537));
     f549 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f546 - f549))));
     f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f554 - f43))));
     f541 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f541))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f550 - Math_fround(+_roundf(+f550))))));
     f533 = Math_fround(f549 * f549);
     f54 = Math_fround(f43 * f43);
     f51 = Math_fround(f541 * f541);
     f48 = Math_fround(f44 * f44);
     f534 = Math_fround(f533 * f533);
     f45 = Math_fround(f54 * f54);
     f535 = Math_fround(f51 * f51);
     f46 = Math_fround(f48 * f48);
     f533 = Math_fround(f549 * Math_fround(Math_fround(Math_fround(f534 * f534) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f533 * Math_fround(41.3416595))) + Math_fround(f534 * Math_fround(Math_fround(81.6018218) - Math_fround(f533 * Math_fround(76.5686187)))))));
     f54 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
     f51 = Math_fround(f541 * Math_fround(Math_fround(Math_fround(f535 * f535) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f535 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
     f48 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f46 * f46) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f48 * Math_fround(41.3416595))) + Math_fround(f46 * Math_fround(Math_fround(81.6018218) - Math_fround(f48 * Math_fround(76.5686187)))))));
     f546 = Math_fround(f546 + Math_fround(-.25));
     f554 = Math_fround(f554 + Math_fround(-.25));
     f537 = Math_fround(f537 + Math_fround(-.25));
     f550 = Math_fround(f550 + Math_fround(-.25));
     f46 = Math_fround(+_roundf(+f546));
     f44 = Math_fround(+_roundf(+f554));
     f535 = Math_fround(+_roundf(+f537));
     f46 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f546 - f46))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f554 - f44))));
     f535 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f535))));
     f550 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f550 - Math_fround(+_roundf(+f550))))));
     f537 = Math_fround(f46 * f46);
     f554 = Math_fround(f44 * f44);
     f546 = Math_fround(f535 * f535);
     f541 = Math_fround(f550 * f550);
     f45 = Math_fround(f537 * f537);
     f43 = Math_fround(f554 * f554);
     f534 = Math_fround(f546 * f546);
     f549 = Math_fround(f541 * f541);
     f537 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f537 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f537 * Math_fround(76.5686187)))))));
     f554 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f43) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f554 * Math_fround(41.3416595))) + Math_fround(f43 * Math_fround(Math_fround(81.6018218) - Math_fround(f554 * Math_fround(76.5686187)))))));
     f546 = Math_fround(f535 * Math_fround(Math_fround(Math_fround(f534 * f534) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f546 * Math_fround(41.3416595))) + Math_fround(f534 * Math_fround(Math_fround(81.6018218) - Math_fround(f546 * Math_fround(76.5686187)))))));
     f541 = Math_fround(f550 * Math_fround(Math_fround(Math_fround(f549 * f549) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f541 * Math_fround(41.3416595))) + Math_fround(f549 * Math_fround(Math_fround(81.6018218) - Math_fround(f541 * Math_fround(76.5686187)))))));
     f549 = Math_fround(Math_fround(f540 * f533) + Math_fround(f536 * f537));
     f550 = Math_fround(Math_fround(f507 * f54) + Math_fround(f539 * f554));
     f534 = Math_fround(Math_fround(f538 * f51) + Math_fround(f542 * f546));
     f535 = Math_fround(Math_fround(f508 * f48) + Math_fround(f553 * f541));
     f43 = Math_fround(Math_fround(f55 * f533) + Math_fround(f506 * f537));
     f44 = Math_fround(Math_fround(f56 * f54) + Math_fround(f545 * f554));
     f45 = Math_fround(Math_fround(f57 * f51) + Math_fround(f552 * f546));
     f46 = Math_fround(Math_fround(f58 * f48) + Math_fround(f555 * f541));
     f503 = Math_fround(Math_fround(f532 * f533) + Math_fround(f558 * f537));
     f504 = Math_fround(Math_fround(f53 * f54) + Math_fround(f509 * f554));
     f505 = Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f546));
     f551 = Math_fround(Math_fround(f47 * f48) + Math_fround(f49 * f541));
     f35 = Math_fround(Math_fround(f443 * f503) + Math_fround(Math_fround(f441 * f549) + Math_fround(f442 * f43)));
     f36 = Math_fround(Math_fround(f443 * f504) + Math_fround(Math_fround(f441 * f550) + Math_fround(f442 * f44)));
     f37 = Math_fround(Math_fround(f443 * f505) + Math_fround(Math_fround(f441 * f534) + Math_fround(f442 * f45)));
     f38 = Math_fround(Math_fround(f443 * f551) + Math_fround(Math_fround(f441 * f535) + Math_fround(f442 * f46)));
     f39 = Math_fround(Math_fround(f446 * f503) + Math_fround(Math_fround(f444 * f549) + Math_fround(f445 * f43)));
     f40 = Math_fround(Math_fround(f446 * f504) + Math_fround(Math_fround(f444 * f550) + Math_fround(f445 * f44)));
     f41 = Math_fround(Math_fround(f446 * f505) + Math_fround(Math_fround(f444 * f534) + Math_fround(f445 * f45)));
     f42 = Math_fround(Math_fround(f446 * f551) + Math_fround(Math_fround(f444 * f535) + Math_fround(f445 * f46)));
     f43 = Math_fround(Math_fround(f449 * f503) + Math_fround(Math_fround(f447 * f549) + Math_fround(f448 * f43)));
     f44 = Math_fround(Math_fround(f449 * f504) + Math_fround(Math_fround(f447 * f550) + Math_fround(f448 * f44)));
     f45 = Math_fround(Math_fround(f449 * f505) + Math_fround(Math_fround(f447 * f534) + Math_fround(f448 * f45)));
     f46 = Math_fround(Math_fround(f449 * f551) + Math_fround(Math_fround(f447 * f535) + Math_fround(f448 * f46)));
     f540 = Math_fround(Math_fround(f536 * f533) - Math_fround(f540 * f537));
     f507 = Math_fround(Math_fround(f539 * f54) - Math_fround(f507 * f554));
     f538 = Math_fround(Math_fround(f542 * f51) - Math_fround(f538 * f546));
     f508 = Math_fround(Math_fround(f553 * f48) - Math_fround(f508 * f541));
     f55 = Math_fround(Math_fround(f506 * f533) - Math_fround(f55 * f537));
     f56 = Math_fround(Math_fround(f545 * f54) - Math_fround(f56 * f554));
     f57 = Math_fround(Math_fround(f552 * f51) - Math_fround(f57 * f546));
     f58 = Math_fround(Math_fround(f555 * f48) - Math_fround(f58 * f541));
     f537 = Math_fround(Math_fround(f558 * f533) - Math_fround(f532 * f537));
     f554 = Math_fround(Math_fround(f509 * f54) - Math_fround(f53 * f554));
     f546 = Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * f546));
     f541 = Math_fround(Math_fround(f49 * f48) - Math_fround(f47 * f541));
     f47 = Math_fround(Math_fround(f443 * f537) + Math_fround(Math_fround(f441 * f540) + Math_fround(f442 * f55)));
     f48 = Math_fround(Math_fround(f443 * f554) + Math_fround(Math_fround(f441 * f507) + Math_fround(f442 * f56)));
     f49 = Math_fround(Math_fround(f443 * f546) + Math_fround(Math_fround(f441 * f538) + Math_fround(f442 * f57)));
     f50 = Math_fround(Math_fround(f443 * f541) + Math_fround(Math_fround(f441 * f508) + Math_fround(f442 * f58)));
     f51 = Math_fround(Math_fround(f446 * f537) + Math_fround(Math_fround(f444 * f540) + Math_fround(f445 * f55)));
     f52 = Math_fround(Math_fround(f446 * f554) + Math_fround(Math_fround(f444 * f507) + Math_fround(f445 * f56)));
     f53 = Math_fround(Math_fround(f446 * f546) + Math_fround(Math_fround(f444 * f538) + Math_fround(f445 * f57)));
     f54 = Math_fround(Math_fround(f446 * f541) + Math_fround(Math_fround(f444 * f508) + Math_fround(f445 * f58)));
     f55 = Math_fround(Math_fround(f449 * f537) + Math_fround(Math_fround(f447 * f540) + Math_fround(f448 * f55)));
     f56 = Math_fround(Math_fround(f449 * f554) + Math_fround(Math_fround(f447 * f507) + Math_fround(f448 * f56)));
     f57 = Math_fround(Math_fround(f449 * f546) + Math_fround(Math_fround(f447 * f538) + Math_fround(f448 * f57)));
     f58 = Math_fround(Math_fround(f449 * f541) + Math_fround(Math_fround(f447 * f508) + Math_fround(f448 * f58)));
     f508 = Math_fround(f489 * f79);
     f541 = Math_fround(f489 * f85);
     f538 = Math_fround(f489 * f86);
     f546 = Math_fround(f489 * f80);
     f507 = Math_fround(f478 * f81);
     f554 = Math_fround(f478 * f82);
     f540 = Math_fround(f478 * f83);
     f537 = Math_fround(f478 * f84);
     f509 = Math_fround(f482 * f79);
     f532 = Math_fround(f482 * f85);
     f533 = Math_fround(f482 * f86);
     f558 = Math_fround(f482 * f80);
     f557 = Math_fround(f557 * Math_fround(-.159154937));
     f544 = Math_fround(f544 * Math_fround(-.159154937));
     f543 = Math_fround(f543 * Math_fround(-.159154937));
     f556 = Math_fround(f556 * Math_fround(-.159154937));
     f555 = Math_fround(+_roundf(+f557));
     f552 = Math_fround(+_roundf(+f544));
     f545 = Math_fround(+_roundf(+f543));
     f555 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f557 - f555))));
     f552 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f544 - f552))));
     f545 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f543 - f545))));
     f506 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f556 - Math_fround(+_roundf(+f556))))));
     f553 = Math_fround(f555 * f555);
     f542 = Math_fround(f552 * f552);
     f539 = Math_fround(f545 * f545);
     f536 = Math_fround(f506 * f506);
     f535 = Math_fround(f553 * f553);
     f551 = Math_fround(f542 * f542);
     f534 = Math_fround(f539 * f539);
     f505 = Math_fround(f536 * f536);
     f553 = Math_fround(f555 * Math_fround(Math_fround(Math_fround(f535 * f535) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f553 * Math_fround(41.3416595))) + Math_fround(f535 * Math_fround(Math_fround(81.6018218) - Math_fround(f553 * Math_fround(76.5686187)))))));
     f542 = Math_fround(f552 * Math_fround(Math_fround(Math_fround(f551 * f551) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f542 * Math_fround(41.3416595))) + Math_fround(f551 * Math_fround(Math_fround(81.6018218) - Math_fround(f542 * Math_fround(76.5686187)))))));
     f539 = Math_fround(f545 * Math_fround(Math_fround(Math_fround(f534 * f534) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f539 * Math_fround(41.3416595))) + Math_fround(f534 * Math_fround(Math_fround(81.6018218) - Math_fround(f539 * Math_fround(76.5686187)))))));
     f536 = Math_fround(f506 * Math_fround(Math_fround(Math_fround(f505 * f505) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f536 * Math_fround(41.3416595))) + Math_fround(f505 * Math_fround(Math_fround(81.6018218) - Math_fround(f536 * Math_fround(76.5686187)))))));
     f557 = Math_fround(f557 + Math_fround(-.25));
     f544 = Math_fround(f544 + Math_fround(-.25));
     f543 = Math_fround(f543 + Math_fround(-.25));
     f556 = Math_fround(f556 + Math_fround(-.25));
     f505 = Math_fround(+_roundf(+f557));
     f506 = Math_fround(+_roundf(+f544));
     f534 = Math_fround(+_roundf(+f543));
     f505 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f557 - f505))));
     f506 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f544 - f506))));
     f534 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f543 - f534))));
     f556 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f556 - Math_fround(+_roundf(+f556))))));
     f543 = Math_fround(f505 * f505);
     f544 = Math_fround(f506 * f506);
     f557 = Math_fround(f534 * f534);
     f545 = Math_fround(f556 * f556);
     f551 = Math_fround(f543 * f543);
     f552 = Math_fround(f544 * f544);
     f535 = Math_fround(f557 * f557);
     f555 = Math_fround(f545 * f545);
     f543 = Math_fround(f505 * Math_fround(Math_fround(Math_fround(f551 * f551) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f543 * Math_fround(41.3416595))) + Math_fround(f551 * Math_fround(Math_fround(81.6018218) - Math_fround(f543 * Math_fround(76.5686187)))))));
     f544 = Math_fround(f506 * Math_fround(Math_fround(Math_fround(f552 * f552) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f544 * Math_fround(41.3416595))) + Math_fround(f552 * Math_fround(Math_fround(81.6018218) - Math_fround(f544 * Math_fround(76.5686187)))))));
     f557 = Math_fround(f534 * Math_fround(Math_fround(Math_fround(f535 * f535) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f557 * Math_fround(41.3416595))) + Math_fround(f535 * Math_fround(Math_fround(81.6018218) - Math_fround(f557 * Math_fround(76.5686187)))))));
     f545 = Math_fround(f556 * Math_fround(Math_fround(Math_fround(f555 * f555) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f545 * Math_fround(41.3416595))) + Math_fround(f555 * Math_fround(Math_fround(81.6018218) - Math_fround(f545 * Math_fround(76.5686187)))))));
     f555 = Math_fround(Math_fround(f508 * f553) - Math_fround(f507 * f543));
     f556 = Math_fround(Math_fround(f541 * f542) - Math_fround(f554 * f544));
     f535 = Math_fround(Math_fround(f538 * f539) - Math_fround(f540 * f557));
     f534 = Math_fround(Math_fround(f546 * f536) - Math_fround(f537 * f545));
     f543 = Math_fround(Math_fround(f507 * f553) + Math_fround(f508 * f543));
     f544 = Math_fround(Math_fround(f554 * f542) + Math_fround(f541 * f544));
     f557 = Math_fround(Math_fround(f540 * f539) + Math_fround(f538 * f557));
     f545 = Math_fround(Math_fround(f537 * f536) + Math_fround(f546 * f545));
     f546 = Math_fround(Math_fround(f443 * f509) + Math_fround(Math_fround(f441 * f555) + Math_fround(f442 * f543)));
     f536 = Math_fround(Math_fround(f443 * f532) + Math_fround(Math_fround(f441 * f556) + Math_fround(f442 * f544)));
     f537 = Math_fround(Math_fround(f443 * f533) + Math_fround(Math_fround(f441 * f535) + Math_fround(f442 * f557)));
     f538 = Math_fround(Math_fround(f443 * f558) + Math_fround(Math_fround(f441 * f534) + Math_fround(f442 * f545)));
     f539 = Math_fround(Math_fround(f446 * f509) + Math_fround(Math_fround(f444 * f555) + Math_fround(f445 * f543)));
     f540 = Math_fround(Math_fround(f446 * f532) + Math_fround(Math_fround(f444 * f556) + Math_fround(f445 * f544)));
     f541 = Math_fround(Math_fround(f446 * f533) + Math_fround(Math_fround(f444 * f535) + Math_fround(f445 * f557)));
     f542 = Math_fround(Math_fround(f446 * f558) + Math_fround(Math_fround(f444 * f534) + Math_fround(f445 * f545)));
     f543 = Math_fround(Math_fround(f449 * f509) + Math_fround(Math_fround(f447 * f555) + Math_fround(f448 * f543)));
     f544 = Math_fround(Math_fround(f449 * f532) + Math_fround(Math_fround(f447 * f556) + Math_fround(f448 * f544)));
     f557 = Math_fround(Math_fround(f449 * f533) + Math_fround(Math_fround(f447 * f535) + Math_fround(f448 * f557)));
     f545 = Math_fround(Math_fround(f449 * f558) + Math_fround(Math_fround(f447 * f534) + Math_fround(f448 * f545)));
     f534 = Math_fround(HEAPF32[i518 >> 2]);
     f558 = Math_fround(f534 + f35);
     f535 = Math_fround(HEAPF32[i227 >> 2]);
     f533 = Math_fround(f535 + f36);
     f556 = Math_fround(HEAPF32[i228 >> 2]);
     f532 = Math_fround(f556 + f37);
     f555 = Math_fround(HEAPF32[i229 >> 2]);
     f509 = Math_fround(f555 + f38);
     f554 = Math_fround(HEAPF32[i230 >> 2]);
     f508 = Math_fround(f39 + f554);
     f553 = Math_fround(HEAPF32[i231 >> 2]);
     f507 = Math_fround(f40 + f553);
     f552 = Math_fround(HEAPF32[i232 >> 2]);
     f506 = Math_fround(f41 + f552);
     f551 = Math_fround(HEAPF32[i233 >> 2]);
     f505 = Math_fround(f42 + f551);
     f550 = Math_fround(HEAPF32[i234 >> 2]);
     f504 = Math_fround(f43 + f550);
     f549 = Math_fround(HEAPF32[i235 >> 2]);
     f503 = Math_fround(f44 + f549);
     f548 = Math_fround(HEAPF32[i236 >> 2]);
     f533 = Math_fround(f533 + f536);
     f532 = Math_fround(f532 + f537);
     f509 = Math_fround(f509 + f538);
     f508 = Math_fround(f508 + f539);
     f507 = Math_fround(f507 + f540);
     f506 = Math_fround(f506 + f541);
     f505 = Math_fround(f505 + f542);
     f504 = Math_fround(f504 + f543);
     f503 = Math_fround(f503 + f544);
     f502 = Math_fround(Math_fround(f45 + f548) + f557);
     f501 = Math_fround(Math_fround(f87 + f46) + f545);
     HEAPF32[i524 >> 2] = Math_fround(f558 + f546);
     HEAPF32[i239 >> 2] = f533;
     HEAPF32[i240 >> 2] = f532;
     HEAPF32[i241 >> 2] = f509;
     HEAPF32[i242 >> 2] = f508;
     HEAPF32[i243 >> 2] = f507;
     HEAPF32[i244 >> 2] = f506;
     HEAPF32[i245 >> 2] = f505;
     HEAPF32[i246 >> 2] = f504;
     HEAPF32[i247 >> 2] = f503;
     HEAPF32[i248 >> 2] = f502;
     HEAPF32[i249 >> 2] = f501;
     f501 = Math_fround(f534 + f47);
     f502 = Math_fround(f535 + f48);
     f503 = Math_fround(f556 + f49);
     f504 = Math_fround(f555 + f50);
     f505 = Math_fround(f51 + f554);
     f506 = Math_fround(f52 + f553);
     f507 = Math_fround(f53 + f552);
     f508 = Math_fround(f54 + f551);
     f509 = Math_fround(f55 + f550);
     f532 = Math_fround(f56 + f549);
     f533 = Math_fround(f57 + f548);
     f558 = Math_fround(HEAPF32[i237 >> 2]);
     f502 = Math_fround(f502 + f536);
     f503 = Math_fround(f503 + f537);
     f504 = Math_fround(f504 + f538);
     f505 = Math_fround(f505 + f539);
     f506 = Math_fround(f506 + f540);
     f507 = Math_fround(f507 + f541);
     f508 = Math_fround(f508 + f542);
     f509 = Math_fround(f509 + f543);
     f532 = Math_fround(f532 + f544);
     f533 = Math_fround(f533 + f557);
     f547 = Math_fround(f545 + Math_fround(f58 + f558));
     HEAPF32[i250 >> 2] = Math_fround(f501 + f546);
     HEAPF32[i251 >> 2] = f502;
     HEAPF32[i252 >> 2] = f503;
     HEAPF32[i253 >> 2] = f504;
     HEAPF32[i254 >> 2] = f505;
     HEAPF32[i255 >> 2] = f506;
     HEAPF32[i256 >> 2] = f507;
     HEAPF32[i257 >> 2] = f508;
     HEAPF32[i258 >> 2] = f509;
     HEAPF32[i259 >> 2] = f532;
     HEAPF32[i260 >> 2] = f533;
     HEAPF32[i261 >> 2] = f547;
     f535 = Math_fround(Math_fround(f535 - f36) + f536);
     f556 = Math_fround(Math_fround(f556 - f37) + f537);
     f555 = Math_fround(Math_fround(f555 - f38) + f538);
     f554 = Math_fround(Math_fround(f554 - f39) + f539);
     f553 = Math_fround(Math_fround(f553 - f40) + f540);
     f552 = Math_fround(Math_fround(f552 - f41) + f541);
     f551 = Math_fround(Math_fround(f551 - f42) + f542);
     f550 = Math_fround(Math_fround(f550 - f43) + f543);
     f549 = Math_fround(Math_fround(f549 - f44) + f544);
     f548 = Math_fround(Math_fround(f548 - f45) + f557);
     f547 = Math_fround(f545 + Math_fround(f558 - f46));
     HEAPF32[i262 >> 2] = Math_fround(Math_fround(f534 - f35) + f546);
     HEAPF32[i263 >> 2] = f535;
     HEAPF32[i264 >> 2] = f556;
     HEAPF32[i265 >> 2] = f555;
     HEAPF32[i266 >> 2] = f554;
     HEAPF32[i267 >> 2] = f553;
     HEAPF32[i268 >> 2] = f552;
     HEAPF32[i269 >> 2] = f551;
     HEAPF32[i270 >> 2] = f550;
     HEAPF32[i271 >> 2] = f549;
     HEAPF32[i272 >> 2] = f548;
     HEAPF32[i273 >> 2] = f547;
     f547 = Math_fround(Math_fround(HEAPF32[i518 >> 2]) - f47);
     f548 = Math_fround(Math_fround(HEAPF32[i227 >> 2]) - f48);
     f549 = Math_fround(Math_fround(HEAPF32[i228 >> 2]) - f49);
     f550 = Math_fround(Math_fround(HEAPF32[i229 >> 2]) - f50);
     f551 = Math_fround(Math_fround(HEAPF32[i230 >> 2]) - f51);
     f552 = Math_fround(Math_fround(HEAPF32[i231 >> 2]) - f52);
     f553 = Math_fround(Math_fround(HEAPF32[i232 >> 2]) - f53);
     f554 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) - f54);
     f555 = Math_fround(Math_fround(HEAPF32[i234 >> 2]) - f55);
     f556 = Math_fround(Math_fround(HEAPF32[i235 >> 2]) - f56);
     f548 = Math_fround(f536 + f548);
     f549 = Math_fround(f537 + f549);
     f550 = Math_fround(f538 + f550);
     f551 = Math_fround(f539 + f551);
     f552 = Math_fround(f540 + f552);
     f553 = Math_fround(f541 + f553);
     f554 = Math_fround(f542 + f554);
     f555 = Math_fround(f543 + f555);
     f556 = Math_fround(f544 + f556);
     f557 = Math_fround(f557 + Math_fround(Math_fround(HEAPF32[i236 >> 2]) - f57));
     f558 = Math_fround(f545 + Math_fround(f558 - f58));
     HEAPF32[i274 >> 2] = Math_fround(f546 + f547);
     HEAPF32[i275 >> 2] = f548;
     HEAPF32[i276 >> 2] = f549;
     HEAPF32[i277 >> 2] = f550;
     HEAPF32[i278 >> 2] = f551;
     HEAPF32[i279 >> 2] = f552;
     HEAPF32[i280 >> 2] = f553;
     HEAPF32[i281 >> 2] = f554;
     HEAPF32[i282 >> 2] = f555;
     HEAPF32[i283 >> 2] = f556;
     HEAPF32[i284 >> 2] = f557;
     HEAPF32[i285 >> 2] = f558;
     if (!i286) {
      i2 = HEAP32[i463 >> 2] | 0;
      if (i2 & 536870912) {
       f558 = Math_fround(HEAPF32[i114 >> 2]);
       i63 = HEAP32[i516 >> 2] | 0;
       i74 = i63 + 693089735 | 0;
       i61 = HEAP32[i218 >> 2] | 0;
       i71 = i61 + 693089735 | 0;
       i59 = HEAP32[i219 >> 2] | 0;
       i68 = i59 + 693089735 | 0;
       i23 = HEAP32[i220 >> 2] | 0;
       i65 = i23 + 693089735 | 0;
       i24 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i60 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i62 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i64 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i68 = i68 << 11 ^ i68;
       i65 = i65 << 11 ^ i65;
       i24 = Math_fround(Math_fround((i24 ^ i74 ^ i74 >>> 8) & 8388607 ^ i24 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i60 = Math_fround(Math_fround((i60 ^ i71 ^ i71 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i62 = Math_fround(Math_fround((i62 ^ i68 ^ i68 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i64 = Math_fround(Math_fround((i64 ^ i65 ^ i65 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       f558 = Math_fround(HEAPF32[i76 >> 2]);
       i63 = i63 + 13945730 | 0;
       i61 = i61 + 13945730 | 0;
       i59 = i59 + 13945730 | 0;
       i23 = i23 + 13945730 | 0;
       i65 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i59, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
       i63 = i63 << 11 ^ i63;
       i61 = i61 << 11 ^ i61;
       i59 = i59 << 11 ^ i59;
       i23 = i23 << 11 ^ i23;
       i65 = Math_fround(Math_fround((i65 ^ i63 ^ i63 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i68 = Math_fround(Math_fround((i68 ^ i61 ^ i61 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i71 = Math_fround(Math_fround((i71 ^ i59 ^ i59 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f558;
       i23 = i24 & 1;
       i59 = i60 & 1;
       i61 = i62 & 1;
       i63 = i64 & 1;
       i66 = i23 ^ 1;
       i69 = i59 ^ 1;
       i72 = i61 ^ 1;
       i485 = i63 ^ 1;
       i67 = i24 ? 3 : 2;
       i70 = i60 ? 3 : 2;
       i73 = i62 ? 3 : 2;
       i2 = i64 ? 3 : 2;
       i24 = i24 ? 2 : 3;
       i60 = i60 ? 2 : 3;
       i62 = i62 ? 2 : 3;
       i64 = i64 ? 2 : 3;
       HEAP32[i521 >> 2] = i65 ? i24 : i23;
       HEAP32[i438 >> 2] = i68 ? i60 : i59;
       HEAP32[i437 >> 2] = i71 ? i62 : i61;
       HEAP32[i436 >> 2] = i74 ? i64 : i63;
       HEAP32[i462 >> 2] = i65 ? i23 : i24;
       HEAP32[i461 >> 2] = i68 ? i59 : i60;
       HEAP32[i460 >> 2] = i71 ? i61 : i62;
       HEAP32[i459 >> 2] = i74 ? i63 : i64;
       HEAP32[i454 >> 2] = i65 ? i67 : i66;
       HEAP32[i453 >> 2] = i68 ? i70 : i69;
       HEAP32[i452 >> 2] = i71 ? i73 : i72;
       HEAP32[i439 >> 2] = i74 ? i2 : i485;
       HEAP32[i458 >> 2] = i65 ? i66 : i67;
       HEAP32[i457 >> 2] = i68 ? i69 : i70;
       HEAP32[i456 >> 2] = i71 ? i72 : i73;
       HEAP32[i455 >> 2] = i74 ? i485 : i2;
       i2 = HEAP32[i463 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f492 * Math_fround(HEAPF32[i517 >> 2]));
       f6 = Math_fround(f492 * Math_fround(HEAPF32[i222 >> 2]));
       f7 = Math_fround(f492 * Math_fround(HEAPF32[i223 >> 2]));
       f8 = Math_fround(f492 * Math_fround(HEAPF32[i224 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f555 = Math_fround(Math_floor(Math_fround(f342 * f9)));
        f556 = Math_fround(Math_floor(Math_fround(f342 * f10)));
        f557 = Math_fround(Math_floor(Math_fround(f342 * f25)));
        f558 = Math_fround(Math_floor(Math_fround(f342 * f26)));
        f551 = Math_fround(f493 * Math_fround(f9 - Math_fround(f491 * f555)));
        f552 = Math_fround(f493 * Math_fround(f10 - Math_fround(f491 * f556)));
        f553 = Math_fround(f493 * Math_fround(f25 - Math_fround(f491 * f557)));
        f554 = Math_fround(f493 * Math_fround(f26 - Math_fround(f491 * f558)));
        f555 = Math_fround(f440 - Math_fround(f494 * f555));
        f556 = Math_fround(f440 - Math_fround(f494 * f556));
        f557 = Math_fround(f440 - Math_fround(f494 * f557));
        f558 = Math_fround(f440 - Math_fround(f494 * f558));
        f543 = Math_fround(f494 + f555);
        f544 = Math_fround(f494 + f556);
        f545 = Math_fround(f494 + f557);
        f546 = Math_fround(f494 + f558);
        HEAPF32[i522 >> 2] = f551;
        HEAPF32[i387 >> 2] = f552;
        HEAPF32[i411 >> 2] = f553;
        HEAPF32[i435 >> 2] = f554;
        HEAPF32[i363 >> 2] = f543;
        HEAPF32[i386 >> 2] = f544;
        HEAPF32[i410 >> 2] = f545;
        HEAPF32[i434 >> 2] = f546;
        f547 = Math_fround(f493 + f551);
        f548 = Math_fround(f493 + f552);
        f549 = Math_fround(f493 + f553);
        f550 = Math_fround(f493 + f554);
        HEAPF32[i362 >> 2] = f547;
        HEAPF32[i385 >> 2] = f548;
        HEAPF32[i409 >> 2] = f549;
        HEAPF32[i433 >> 2] = f550;
        HEAPF32[i361 >> 2] = f543;
        HEAPF32[i384 >> 2] = f544;
        HEAPF32[i408 >> 2] = f545;
        HEAPF32[i432 >> 2] = f546;
        HEAPF32[i360 >> 2] = f547;
        HEAPF32[i383 >> 2] = f548;
        HEAPF32[i407 >> 2] = f549;
        HEAPF32[i431 >> 2] = f550;
        HEAPF32[i359 >> 2] = f555;
        HEAPF32[i382 >> 2] = f556;
        HEAPF32[i406 >> 2] = f557;
        HEAPF32[i430 >> 2] = f558;
        HEAPF32[i358 >> 2] = f551;
        HEAPF32[i381 >> 2] = f552;
        HEAPF32[i405 >> 2] = f553;
        HEAPF32[i429 >> 2] = f554;
        HEAPF32[i357 >> 2] = f555;
        HEAPF32[i380 >> 2] = f556;
        HEAPF32[i404 >> 2] = f557;
        HEAPF32[i428 >> 2] = f558;
       }
       if (i2 & 33554432 | 0) {
        f547 = Math_fround(f9 + Math_fround(1.0));
        f548 = Math_fround(f10 + Math_fround(1.0));
        f549 = Math_fround(f25 + Math_fround(1.0));
        f550 = Math_fround(f26 + Math_fround(1.0));
        f555 = Math_fround(f5 - f9);
        f556 = Math_fround(f6 - f10);
        f557 = Math_fround(f7 - f25);
        f558 = Math_fround(f8 - f26);
        f551 = Math_fround(Math_floor(Math_fround(f342 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f342 * f548)));
        f553 = Math_fround(Math_floor(Math_fround(f342 * f549)));
        f554 = Math_fround(Math_floor(Math_fround(f342 * f550)));
        f547 = Math_fround(f493 * Math_fround(f547 - Math_fround(f491 * f551)));
        f548 = Math_fround(f493 * Math_fround(f548 - Math_fround(f491 * f552)));
        f549 = Math_fround(f493 * Math_fround(f549 - Math_fround(f491 * f553)));
        f550 = Math_fround(f493 * Math_fround(f550 - Math_fround(f491 * f554)));
        f551 = Math_fround(f440 - Math_fround(f494 * f551));
        f552 = Math_fround(f440 - Math_fround(f494 * f552));
        f553 = Math_fround(f440 - Math_fround(f494 * f553));
        f554 = Math_fround(f440 - Math_fround(f494 * f554));
        f539 = Math_fround(f494 + f551);
        f540 = Math_fround(f494 + f552);
        f541 = Math_fround(f494 + f553);
        f542 = Math_fround(f494 + f554);
        HEAPF32[i523 >> 2] = f547;
        HEAPF32[i379 >> 2] = f548;
        HEAPF32[i403 >> 2] = f549;
        HEAPF32[i427 >> 2] = f550;
        HEAPF32[i356 >> 2] = f539;
        HEAPF32[i378 >> 2] = f540;
        HEAPF32[i402 >> 2] = f541;
        HEAPF32[i426 >> 2] = f542;
        HEAPF32[i355 >> 2] = f555;
        HEAPF32[i377 >> 2] = f556;
        HEAPF32[i401 >> 2] = f557;
        HEAPF32[i425 >> 2] = f558;
        HEAPF32[i354 >> 2] = f5;
        HEAPF32[i376 >> 2] = f6;
        HEAPF32[i400 >> 2] = f7;
        HEAPF32[i424 >> 2] = f8;
        f543 = Math_fround(f493 + f547);
        f544 = Math_fround(f493 + f548);
        f545 = Math_fround(f493 + f549);
        f546 = Math_fround(f493 + f550);
        HEAPF32[i353 >> 2] = f543;
        HEAPF32[i375 >> 2] = f544;
        HEAPF32[i399 >> 2] = f545;
        HEAPF32[i423 >> 2] = f546;
        HEAPF32[i352 >> 2] = f539;
        HEAPF32[i374 >> 2] = f540;
        HEAPF32[i398 >> 2] = f541;
        HEAPF32[i422 >> 2] = f542;
        HEAPF32[i351 >> 2] = f555;
        HEAPF32[i373 >> 2] = f556;
        HEAPF32[i397 >> 2] = f557;
        HEAPF32[i421 >> 2] = f558;
        HEAPF32[i350 >> 2] = f5;
        HEAPF32[i372 >> 2] = f6;
        HEAPF32[i396 >> 2] = f7;
        HEAPF32[i420 >> 2] = f8;
        HEAPF32[i349 >> 2] = f543;
        HEAPF32[i371 >> 2] = f544;
        HEAPF32[i395 >> 2] = f545;
        HEAPF32[i419 >> 2] = f546;
        HEAPF32[i348 >> 2] = f551;
        HEAPF32[i370 >> 2] = f552;
        HEAPF32[i394 >> 2] = f553;
        HEAPF32[i418 >> 2] = f554;
        HEAPF32[i347 >> 2] = f555;
        HEAPF32[i369 >> 2] = f556;
        HEAPF32[i393 >> 2] = f557;
        HEAPF32[i417 >> 2] = f558;
        HEAPF32[i346 >> 2] = f5;
        HEAPF32[i368 >> 2] = f6;
        HEAPF32[i392 >> 2] = f7;
        HEAPF32[i416 >> 2] = f8;
        HEAPF32[i345 >> 2] = f547;
        HEAPF32[i367 >> 2] = f548;
        HEAPF32[i391 >> 2] = f549;
        HEAPF32[i415 >> 2] = f550;
        HEAPF32[i344 >> 2] = f551;
        HEAPF32[i366 >> 2] = f552;
        HEAPF32[i390 >> 2] = f553;
        HEAPF32[i414 >> 2] = f554;
        HEAPF32[i343 >> 2] = f555;
        HEAPF32[i365 >> 2] = f556;
        HEAPF32[i389 >> 2] = f557;
        HEAPF32[i413 >> 2] = f558;
        HEAPF32[i341 >> 2] = f5;
        HEAPF32[i364 >> 2] = f6;
        HEAPF32[i388 >> 2] = f7;
        HEAPF32[i412 >> 2] = f8;
       }
      }
     }
     f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
     f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
     f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
     f546 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
     f535 = Math_fround(f495 * Math_fround(f35 * f543));
     f536 = Math_fround(f495 * Math_fround(f36 * f544));
     f537 = Math_fround(f495 * Math_fround(f37 * f545));
     f538 = Math_fround(f495 * Math_fround(f38 * f546));
     f539 = Math_fround(f495 * Math_fround(f39 * f543));
     f540 = Math_fround(f495 * Math_fround(f40 * f544));
     f541 = Math_fround(f495 * Math_fround(f41 * f545));
     f542 = Math_fround(f495 * Math_fround(f42 * f546));
     f543 = Math_fround(f495 * Math_fround(f43 * f543));
     f544 = Math_fround(f495 * Math_fround(f44 * f544));
     f545 = Math_fround(f495 * Math_fround(f45 * f545));
     f546 = Math_fround(f495 * Math_fround(f46 * f546));
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
     f557 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
     f558 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
     f547 = Math_fround(f495 * Math_fround(f47 * f555));
     f548 = Math_fround(f495 * Math_fround(f48 * f556));
     f549 = Math_fround(f495 * Math_fround(f49 * f557));
     f550 = Math_fround(f495 * Math_fround(f50 * f558));
     f551 = Math_fround(f495 * Math_fround(f51 * f555));
     f552 = Math_fround(f495 * Math_fround(f52 * f556));
     f553 = Math_fround(f495 * Math_fround(f53 * f557));
     f554 = Math_fround(f495 * Math_fround(f54 * f558));
     f555 = Math_fround(f495 * Math_fround(f55 * f555));
     f556 = Math_fround(f495 * Math_fround(f56 * f556));
     f557 = Math_fround(f495 * Math_fround(f57 * f557));
     f558 = Math_fround(f495 * Math_fround(f58 * f558));
     f534 = Math_fround(f488 + f536);
     f533 = Math_fround(f488 + f537);
     f532 = Math_fround(f488 + f538);
     f509 = Math_fround(f477 + f539);
     f508 = Math_fround(f477 + f540);
     f507 = Math_fround(f477 + f541);
     f506 = Math_fround(f477 + f542);
     f505 = Math_fround(f481 + f543);
     f504 = Math_fround(f481 + f544);
     f503 = Math_fround(f481 + f545);
     f502 = Math_fround(f481 + f546);
     HEAPF32[i525 >> 2] = Math_fround(f488 + f535);
     HEAPF32[i129 >> 2] = f534;
     HEAPF32[i146 >> 2] = f533;
     HEAPF32[i163 >> 2] = f532;
     HEAPF32[i287 >> 2] = f509;
     HEAPF32[i124 >> 2] = f508;
     HEAPF32[i141 >> 2] = f507;
     HEAPF32[i158 >> 2] = f506;
     HEAPF32[i288 >> 2] = f505;
     HEAPF32[i119 >> 2] = f504;
     HEAPF32[i136 >> 2] = f503;
     HEAPF32[i153 >> 2] = f502;
     f502 = Math_fround(f488 + f548);
     f503 = Math_fround(f488 + f549);
     f504 = Math_fround(f488 + f550);
     f505 = Math_fround(f477 + f551);
     f506 = Math_fround(f477 + f552);
     f507 = Math_fround(f477 + f553);
     f508 = Math_fround(f477 + f554);
     f509 = Math_fround(f481 + f555);
     f532 = Math_fround(f481 + f556);
     f533 = Math_fround(f481 + f557);
     f534 = Math_fround(f481 + f558);
     HEAPF32[i289 >> 2] = Math_fround(f488 + f547);
     HEAPF32[i128 >> 2] = f502;
     HEAPF32[i145 >> 2] = f503;
     HEAPF32[i162 >> 2] = f504;
     HEAPF32[i290 >> 2] = f505;
     HEAPF32[i123 >> 2] = f506;
     HEAPF32[i140 >> 2] = f507;
     HEAPF32[i157 >> 2] = f508;
     HEAPF32[i291 >> 2] = f509;
     HEAPF32[i118 >> 2] = f532;
     HEAPF32[i135 >> 2] = f533;
     HEAPF32[i152 >> 2] = f534;
     f536 = Math_fround(f488 - f536);
     f537 = Math_fround(f488 - f537);
     f538 = Math_fround(f488 - f538);
     f539 = Math_fround(f477 - f539);
     f540 = Math_fround(f477 - f540);
     f541 = Math_fround(f477 - f541);
     f542 = Math_fround(f477 - f542);
     f543 = Math_fround(f481 - f543);
     f544 = Math_fround(f481 - f544);
     f545 = Math_fround(f481 - f545);
     f546 = Math_fround(f481 - f546);
     HEAPF32[i292 >> 2] = Math_fround(f488 - f535);
     HEAPF32[i127 >> 2] = f536;
     HEAPF32[i144 >> 2] = f537;
     HEAPF32[i161 >> 2] = f538;
     HEAPF32[i293 >> 2] = f539;
     HEAPF32[i122 >> 2] = f540;
     HEAPF32[i139 >> 2] = f541;
     HEAPF32[i156 >> 2] = f542;
     HEAPF32[i294 >> 2] = f543;
     HEAPF32[i117 >> 2] = f544;
     HEAPF32[i134 >> 2] = f545;
     HEAPF32[i151 >> 2] = f546;
     f548 = Math_fround(f488 - f548);
     f549 = Math_fround(f488 - f549);
     f550 = Math_fround(f488 - f550);
     f551 = Math_fround(f477 - f551);
     f552 = Math_fround(f477 - f552);
     f553 = Math_fround(f477 - f553);
     f554 = Math_fround(f477 - f554);
     f555 = Math_fround(f481 - f555);
     f556 = Math_fround(f481 - f556);
     f557 = Math_fround(f481 - f557);
     f558 = Math_fround(f481 - f558);
     HEAPF32[i295 >> 2] = Math_fround(f488 - f547);
     HEAPF32[i126 >> 2] = f548;
     HEAPF32[i143 >> 2] = f549;
     HEAPF32[i160 >> 2] = f550;
     HEAPF32[i296 >> 2] = f551;
     HEAPF32[i121 >> 2] = f552;
     HEAPF32[i138 >> 2] = f553;
     HEAPF32[i155 >> 2] = f554;
     HEAPF32[i297 >> 2] = f555;
     HEAPF32[i116 >> 2] = f556;
     HEAPF32[i133 >> 2] = f557;
     HEAPF32[i150 >> 2] = f558;
     do if (i167) {
      i4 = HEAP32[i193 >> 2] | 0;
      i11 = HEAP32[i528 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i485 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i250 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i262 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i292 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i274 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i295 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i485 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i485 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i525 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i250 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i262 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i292 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i485 >> 2];
        i74 = i522 + (HEAP32[i521 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i274 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i295 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i485 >> 2];
        i485 = i522 + (HEAP32[i521 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i485 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i485 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f546 = Math_fround(HEAPF32[i250 >> 2]);
      f546 = Math_fround(f546 - Math_fround(HEAPF32[i524 >> 2]));
      f548 = Math_fround(HEAPF32[i251 >> 2]);
      f548 = Math_fround(f548 - Math_fround(HEAPF32[i239 >> 2]));
      f549 = Math_fround(HEAPF32[i252 >> 2]);
      f549 = Math_fround(f549 - Math_fround(HEAPF32[i240 >> 2]));
      f550 = Math_fround(HEAPF32[i253 >> 2]);
      f550 = Math_fround(f550 - Math_fround(HEAPF32[i241 >> 2]));
      f551 = Math_fround(HEAPF32[i254 >> 2]);
      f551 = Math_fround(f551 - Math_fround(HEAPF32[i242 >> 2]));
      f558 = Math_fround(HEAPF32[i255 >> 2]);
      f558 = Math_fround(f558 - Math_fround(HEAPF32[i243 >> 2]));
      f557 = Math_fround(HEAPF32[i256 >> 2]);
      f557 = Math_fround(f557 - Math_fround(HEAPF32[i244 >> 2]));
      f556 = Math_fround(HEAPF32[i257 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i245 >> 2]));
      f555 = Math_fround(HEAPF32[i258 >> 2]);
      f555 = Math_fround(f555 - Math_fround(HEAPF32[i246 >> 2]));
      f543 = Math_fround(HEAPF32[i259 >> 2]);
      f543 = Math_fround(f543 - Math_fround(HEAPF32[i247 >> 2]));
      f544 = Math_fround(HEAPF32[i260 >> 2]);
      f544 = Math_fround(f544 - Math_fround(HEAPF32[i248 >> 2]));
      f545 = Math_fround(HEAPF32[i261 >> 2]);
      f545 = Math_fround(f545 - Math_fround(HEAPF32[i249 >> 2]));
      f547 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f551 * f551)) + Math_fround(f555 * f555)))));
      f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f558 * f558)) + Math_fround(f543 * f543)))));
      f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f549 * f549) + Math_fround(f557 * f557)) + Math_fround(f544 * f544)))));
      f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f550 * f550) + Math_fround(f556 * f556)) + Math_fround(f545 * f545)))));
      f548 = Math_fround(f548 * f554);
      f549 = Math_fround(f549 * f553);
      f550 = Math_fround(f550 * f552);
      f551 = Math_fround(f551 * f547);
      f558 = Math_fround(f558 * f554);
      f557 = Math_fround(f557 * f553);
      f556 = Math_fround(f556 * f552);
      f555 = Math_fround(f555 * f547);
      f554 = Math_fround(f543 * f554);
      f553 = Math_fround(f544 * f553);
      f552 = Math_fround(f545 * f552);
      HEAPF32[i519 >> 2] = Math_fround(f546 * f547);
      HEAPF32[i130 >> 2] = f548;
      HEAPF32[i147 >> 2] = f549;
      HEAPF32[i164 >> 2] = f550;
      HEAPF32[i298 >> 2] = f551;
      HEAPF32[i125 >> 2] = f558;
      HEAPF32[i142 >> 2] = f557;
      HEAPF32[i159 >> 2] = f556;
      HEAPF32[i299 >> 2] = f555;
      HEAPF32[i120 >> 2] = f554;
      HEAPF32[i137 >> 2] = f553;
      HEAPF32[i154 >> 2] = f552;
      f552 = Math_fround(f28 * Math_fround(2.0));
      f553 = Math_fround(f29 * Math_fround(2.0));
      f554 = Math_fround(f30 * Math_fround(2.0));
      f555 = Math_fround(f31 * Math_fround(2.0));
      f556 = Math_fround(f32 * Math_fround(2.0));
      f557 = Math_fround(f33 * Math_fround(2.0));
      f558 = Math_fround(f34 * Math_fround(2.0));
      HEAPF32[i520 >> 2] = Math_fround(f27 * Math_fround(2.0));
      HEAPF32[i132 >> 2] = f552;
      HEAPF32[i149 >> 2] = f553;
      HEAPF32[i166 >> 2] = f554;
      HEAPF32[i300 >> 2] = f555;
      HEAPF32[i131 >> 2] = f556;
      HEAPF32[i148 >> 2] = f557;
      HEAPF32[i165 >> 2] = f558;
      HEAP32[i115 >> 2] = 0;
      HEAP32[i115 + 4 >> 2] = 0;
      HEAP32[i115 + 8 >> 2] = 0;
      HEAP32[i115 + 12 >> 2] = 0;
      if (i301) {
       f538 = Math_fround(HEAPF32[i512 >> 2]);
       f556 = Math_fround(f450 * f538);
       f540 = Math_fround(HEAPF32[i186 >> 2]);
       f547 = Math_fround(f450 * f540);
       f542 = Math_fround(HEAPF32[i185 >> 2]);
       f555 = Math_fround(f450 * f542);
       f544 = Math_fround(HEAPF32[i184 >> 2]);
       f550 = Math_fround(f450 * f544);
       f539 = Math_fround(HEAPF32[i203 >> 2]);
       f546 = Math_fround(f465 * f539);
       f541 = Math_fround(HEAPF32[i189 >> 2]);
       f552 = Math_fround(f465 * f541);
       f543 = Math_fround(HEAPF32[i188 >> 2]);
       f551 = Math_fround(f465 * f543);
       f545 = Math_fround(HEAPF32[i187 >> 2]);
       f546 = Math_fround(f556 + f546);
       f552 = Math_fround(f547 + f552);
       f551 = Math_fround(f555 + f551);
       f550 = Math_fround(f550 + Math_fround(f465 * f545));
       f555 = Math_fround(HEAPF32[i204 >> 2]);
       f547 = Math_fround(f468 * f555);
       f556 = Math_fround(HEAPF32[i192 >> 2]);
       f548 = Math_fround(f468 * f556);
       f557 = Math_fround(HEAPF32[i191 >> 2]);
       f549 = Math_fround(f468 * f557);
       f558 = Math_fround(HEAPF32[i190 >> 2]);
       f548 = Math_fround(f552 + f548);
       f549 = Math_fround(f551 + f549);
       f550 = Math_fround(f550 + Math_fround(f468 * f558));
       f551 = Math_fround(Math_fround(Math_fround(f451 * f538) + Math_fround(f466 * f539)) + Math_fround(f469 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f451 * f540) + Math_fround(f466 * f541)) + Math_fround(f469 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f451 * f542) + Math_fround(f466 * f543)) + Math_fround(f469 * f557));
       f554 = Math_fround(Math_fround(Math_fround(f451 * f544) + Math_fround(f466 * f545)) + Math_fround(f469 * f558));
       f555 = Math_fround(Math_fround(Math_fround(f464 * f538) + Math_fround(f467 * f539)) + Math_fround(f470 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f464 * f540) + Math_fround(f467 * f541)) + Math_fround(f470 * f556));
       f557 = Math_fround(Math_fround(Math_fround(f464 * f542) + Math_fround(f467 * f543)) + Math_fround(f470 * f557));
       f558 = Math_fround(Math_fround(Math_fround(f464 * f544) + Math_fround(f467 * f545)) + Math_fround(f470 * f558));
       HEAPF32[i510 >> 2] = Math_fround(f546 + f547);
       HEAPF32[i302 >> 2] = f548;
       HEAPF32[i303 >> 2] = f549;
       HEAPF32[i304 >> 2] = f550;
       HEAPF32[i305 >> 2] = f551;
       HEAPF32[i306 >> 2] = f552;
       HEAPF32[i307 >> 2] = f553;
       HEAPF32[i308 >> 2] = f554;
       HEAPF32[i309 >> 2] = f555;
       HEAPF32[i310 >> 2] = f556;
       HEAPF32[i311 >> 2] = f557;
       HEAPF32[i312 >> 2] = f558;
      }
      if (i313) {
       i69 = HEAP32[i516 >> 2] | 0;
       i72 = i69 + 1068538453 | 0;
       i73 = HEAP32[i218 >> 2] | 0;
       i71 = i73 + 1068538453 | 0;
       i66 = HEAP32[i219 >> 2] | 0;
       i65 = i66 + 1068538453 | 0;
       i64 = HEAP32[i220 >> 2] | 0;
       i68 = i64 + 1068538453 | 0;
       i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i485 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i72 = i72 << 11 ^ i72;
       i71 = i71 << 11 ^ i71;
       i65 = i65 << 11 ^ i65;
       i68 = i68 << 11 ^ i68;
       f556 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i485 ^ i65 ^ i65 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i526 >> 2] = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i314 >> 2] = f556;
       HEAPF32[i315 >> 2] = f557;
       HEAPF32[i316 >> 2] = f558;
       i69 = i69 + 1068538454 | 0;
       i73 = i73 + 1068538454 | 0;
       i66 = i66 + 1068538454 | 0;
       i64 = i64 + 1068538454 | 0;
       i74 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i72 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i73 = i73 << 11 ^ i73;
       i66 = i66 << 11 ^ i66;
       i64 = i64 << 11 ^ i64;
       f558 = Math_fround(Math_fround((i72 ^ i73 ^ i73 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i70 ^ i66 ^ i66 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i68 ^ i64 ^ i64 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i317 >> 2] = Math_fround(Math_fround((i74 ^ i69 ^ i69 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i318 >> 2] = f558;
       HEAPF32[i319 >> 2] = f557;
       HEAPF32[i320 >> 2] = f556;
       i74 = HEAP32[i516 >> 2] | 0;
       i69 = i74 + 1068538455 | 0;
       i68 = HEAP32[i218 >> 2] | 0;
       i64 = i68 + 1068538455 | 0;
       i70 = HEAP32[i219 >> 2] | 0;
       i66 = i70 + 1068538455 | 0;
       i72 = HEAP32[i220 >> 2] | 0;
       i73 = i72 + 1068538455 | 0;
       i485 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i64 = i64 << 11 ^ i64;
       i66 = i66 << 11 ^ i66;
       i73 = i73 << 11 ^ i73;
       f556 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i71 ^ i73 ^ i73 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i321 >> 2] = Math_fround(Math_fround((i485 ^ i69 ^ i69 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i322 >> 2] = f556;
       HEAPF32[i323 >> 2] = f557;
       HEAPF32[i324 >> 2] = f558;
       f558 = Math_fround(Math_fround(HEAPF32[i515 >> 2]) * Math_fround(1.0e5));
       f557 = Math_fround(Math_fround(HEAPF32[i214 >> 2]) * Math_fround(1.0e5));
       f556 = Math_fround(Math_fround(HEAPF32[i215 >> 2]) * Math_fround(1.0e5));
       i74 = i74 + 1068538453 + ~~f558 | 0;
       i68 = i68 + 1068538453 + ~~f557 | 0;
       i70 = i70 + 1068538453 + ~~f556 | 0;
       i72 = i72 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i216 >> 2]) * Math_fround(1.0e5)) | 0;
       i485 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i68 = i68 << 11 ^ i68;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       f556 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f557 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f558 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i325 >> 2] = Math_fround(Math_fround((i485 ^ i74 ^ i74 >>> 8) & 8388607 ^ i485 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i326 >> 2] = f556;
       HEAPF32[i327 >> 2] = f557;
       HEAPF32[i328 >> 2] = f558;
      }
      i67 = HEAP32[i193 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i90 >> 2] | 0;
      i70 = HEAP32[i92 >> 2] | 0;
      i71 = HEAP32[i213 >> 2] | 0;
      i72 = HEAP32[i93 >> 2] | 0;
      i73 = HEAP32[i196 >> 2] | 0;
      i74 = HEAP32[i528 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i510 + (i66 << 2) | 0;
       i12 = i336 + (i66 << 2) | 0;
       i13 = i337 + (i66 << 2) | 0;
       i14 = i526 + (i66 << 2) | 0;
       i15 = i317 + (i66 << 2) | 0;
       i16 = i321 + (i66 << 2) | 0;
       i17 = i325 + (i66 << 2) | 0;
       i18 = i519 + (i66 << 2) | 0;
       i19 = i78 + (i66 << 2) | 0;
       i20 = i88 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i520 + (i66 << 2) | 0;
       i61 = i94 + (i66 << 2) | 0;
       i62 = i95 + (i66 << 2) | 0;
       i63 = i518 + (i66 << 2) | 0;
       i64 = i96 + (i66 << 2) | 0;
       i65 = i97 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i524 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i329) {
         i485 = i525 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i485 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i330) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i331) {
         i485 = i522 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i332) {
         i485 = i523 + (HEAP32[i521 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i485 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i333) {
         f558 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f558;
         i1 = i1 + 16 | 0;
        }
        if (!i334) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i335) {
         i485 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i485;
         HEAP32[i1 + 4 >> 2] = i485;
         HEAP32[i1 + 8 >> 2] = i485;
         i1 = i1 + 12 | 0;
        }
        if (i301) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i338) {
         f558 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i485 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f558;
         HEAP32[i1 + 4 >> 2] = i485;
         i1 = i1 + 8 | 0;
        }
        if (!i339) {
         i485 = (HEAP32[i91 >> 2] & 2147483647 | 0) == 0 ? i511 : i22;
         HEAP32[i1 >> 2] = HEAP32[i485 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i340) {
         i485 = (HEAP32[i89 >> 2] & 2147483647 | 0) == 0 ? i511 : i21;
         HEAP32[i1 >> 2] = HEAP32[i485 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i485 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i485 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i485 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i313) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i77) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i168 >>> 0);
   }
   STACKTOP = i531;
   return;
  }
 default:
  {
   STACKTOP = i531;
   return;
  }
 }
}

function __ZL22DrawParticlesWithPivotILb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i17, i13, i2, i1, i526, i527) {
 i17 = i17 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i526 = i526 | 0;
 i527 = i527 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, f79 = f0, i80 = 0, i81 = 0, f82 = f0, i83 = 0, f84 = f0, f85 = f0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, f337 = f0, f338 = f0, f339 = f0, f340 = f0, f341 = f0, f342 = f0, f343 = f0, f344 = f0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, f441 = f0, f442 = f0, f443 = f0, f444 = f0, f445 = f0, f446 = f0, f447 = f0, f448 = f0, f449 = f0, f450 = f0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, f464 = f0, f465 = f0, f466 = f0, f467 = f0, f468 = f0, f469 = f0, f470 = f0, f471 = f0, f472 = f0, f473 = f0, f474 = f0, f475 = f0, f476 = f0, f477 = f0, f478 = f0, f479 = f0, f480 = f0, f481 = f0, i482 = 0, f483 = f0, f484 = f0, f485 = f0, f486 = f0, f487 = f0, f488 = f0, f489 = f0, f490 = f0, f491 = f0, f492 = f0, f493 = f0, f494 = f0, f495 = f0, f496 = f0, f497 = f0, f498 = f0, f499 = f0, f500 = f0, f501 = f0, f502 = f0, f503 = f0, f504 = f0, f505 = f0, f506 = f0, f507 = f0, f508 = f0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i528 = 0, i529 = 0, i530 = 0, f531 = f0, f532 = f0, f533 = f0, f534 = f0, f535 = f0, f536 = f0, f537 = f0, f538 = f0, f539 = f0, f540 = f0, f541 = f0, f542 = f0, f543 = f0, f544 = f0, f545 = f0, f546 = f0, f547 = f0, f548 = f0, f549 = f0, f550 = f0, f551 = f0, f552 = f0, f553 = f0, f554 = f0, f555 = f0, f556 = f0;
 i530 = STACKTOP;
 STACKTOP = STACKTOP + 1520 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i530 + 1448 | 0;
 i14 = i530 + 1384 | 0;
 i510 = i530 + 1344 | 0;
 i528 = i530 + 1296 | 0;
 i529 = i530 + 1248 | 0;
 i511 = i530 + 1200 | 0;
 i512 = i530 + 1184 | 0;
 i513 = i530 + 1168 | 0;
 i514 = i530 + 1152 | 0;
 i515 = i530 + 1136 | 0;
 i516 = i530 + 1088 | 0;
 i517 = i530 + 1040 | 0;
 i518 = i530 + 992 | 0;
 i519 = i530 + 944 | 0;
 i509 = i530;
 i520 = i530 + 880 | 0;
 i521 = i530 + 752 | 0;
 i522 = i530 + 496 | 0;
 i523 = i530 + 304 | 0;
 i524 = i530 + 112 | 0;
 i525 = i530 + 48 | 0;
 switch (HEAP16[i2 >> 1] | 0) {
 case 0:
  {
   if (!(HEAP8[i526 + 870 >> 0] | 0)) {
    i16 = i12;
    i15 = i16 + 36 | 0;
    do {
     HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
     i16 = i16 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i16 | 0) < (i15 | 0));
    __ZL28DrawBillboardsWith3DRotationILb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i17, i13, i2, i12, i526, i527);
    STACKTOP = i530;
    return;
   }
   i16 = i509;
   i15 = i16 + 36 | 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
    i16 = i16 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   do if ((i4 | 0) == 3) {
    i16 = i12;
    i1 = i509;
    i15 = i16 + 36 | 0;
    do {
     HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
     i16 = i16 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i16 | 0) < (i15 | 0));
    __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i17, i13, i2, i12, i526, i527);
   } else {
    i482 = i13 + 332 | 0;
    i1 = HEAP32[i482 >> 2] | 0;
    if (!(i1 & 1073741824)) {
     i16 = i12;
     i1 = i509;
     i15 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
      i16 = i16 + 4 | 0;
      i1 = i1 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i17, i13, i2, i12, i526, i527);
     break;
    }
    i11 = HEAP32[i509 + 32 >> 2] | 0;
    f471 = Math_fround((i1 & 4095) >>> 0);
    f472 = Math_fround(Math_fround(1.0) / f471);
    f473 = Math_fround(HEAPF32[i13 + 368 >> 2]);
    f474 = Math_fround(HEAPF32[i13 + 372 >> 2]);
    f475 = Math_fround(HEAPF32[i13 + 376 >> 2]);
    f476 = Math_fround(Math_fround(1.0) - f475);
    i3 = i13 + 420 | 0;
    f477 = Math_fround(HEAPF32[i13 + 404 >> 2]);
    i451 = i13 + 408 | 0;
    f470 = Math_fround(HEAPF32[i451 >> 2]);
    f466 = Math_fround(HEAPF32[i451 + 4 >> 2]);
    f467 = Math_fround(HEAPF32[i451 + 8 >> 2]);
    i451 = i13 + 336 | 0;
    f478 = Math_fround(HEAPF32[i451 >> 2]);
    f479 = Math_fround(HEAPF32[i451 + 4 >> 2]);
    f480 = Math_fround(HEAPF32[i451 + 8 >> 2]);
    f481 = Math_fround(HEAPF32[i451 + 12 >> 2]);
    i451 = i13 + 352 | 0;
    f469 = Math_fround(HEAPF32[i451 >> 2]);
    f465 = Math_fround(HEAPF32[i451 + 4 >> 2]);
    i451 = i13 + 360 | 0;
    f468 = Math_fround(HEAPF32[i451 >> 2]);
    f464 = Math_fround(HEAPF32[i451 + 4 >> 2]);
    i2 = HEAP32[i2 + 56 >> 2] | 0;
    f343 = Math_fround(HEAPF32[i13 + 128 >> 2]);
    f344 = Math_fround(HEAPF32[i13 + 132 >> 2]);
    f441 = Math_fround(HEAPF32[i13 + 136 >> 2]);
    f442 = Math_fround(HEAPF32[i13 + 144 >> 2]);
    f443 = Math_fround(HEAPF32[i13 + 148 >> 2]);
    f444 = Math_fround(HEAPF32[i13 + 152 >> 2]);
    f445 = Math_fround(HEAPF32[i13 + 160 >> 2]);
    f446 = Math_fround(HEAPF32[i13 + 164 >> 2]);
    f447 = Math_fround(HEAPF32[i13 + 168 >> 2]);
    f448 = Math_fround(HEAPF32[i13 + 176 >> 2]);
    f449 = Math_fround(HEAPF32[i13 + 180 >> 2]);
    f450 = Math_fround(HEAPF32[i13 + 184 >> 2]);
    i451 = i520 + 12 | 0;
    i452 = i520 + 8 | 0;
    i453 = i520 + 4 | 0;
    i454 = i520 + 28 | 0;
    HEAP32[i520 >> 2] = 0;
    HEAP32[i520 + 4 >> 2] = 0;
    HEAP32[i520 + 8 >> 2] = 0;
    HEAP32[i520 + 12 >> 2] = 0;
    HEAP32[i454 >> 2] = 1;
    i455 = i520 + 24 | 0;
    HEAP32[i455 >> 2] = 1;
    i456 = i520 + 20 | 0;
    HEAP32[i456 >> 2] = 1;
    i457 = i520 + 16 | 0;
    HEAP32[i457 >> 2] = 1;
    i458 = i520 + 44 | 0;
    HEAP32[i458 >> 2] = 2;
    i459 = i520 + 40 | 0;
    HEAP32[i459 >> 2] = 2;
    i460 = i520 + 36 | 0;
    HEAP32[i460 >> 2] = 2;
    i461 = i520 + 32 | 0;
    HEAP32[i461 >> 2] = 2;
    i462 = i520 + 60 | 0;
    HEAP32[i462 >> 2] = 3;
    i463 = i520 + 56 | 0;
    HEAP32[i463 >> 2] = 3;
    i439 = i520 + 52 | 0;
    HEAP32[i439 >> 2] = 3;
    i440 = i520 + 48 | 0;
    HEAP32[i440 >> 2] = 3;
    i390 = i521 + 4 | 0;
    i414 = i521 + 8 | 0;
    i438 = i521 + 12 | 0;
    i366 = i521 + 16 | 0;
    HEAP32[i521 >> 2] = 0;
    HEAP32[i521 + 4 >> 2] = 0;
    HEAP32[i521 + 8 >> 2] = 0;
    HEAP32[i521 + 12 >> 2] = 0;
    HEAPF32[i366 >> 2] = Math_fround(1.0);
    i389 = i521 + 20 | 0;
    HEAPF32[i389 >> 2] = Math_fround(1.0);
    i413 = i521 + 24 | 0;
    HEAPF32[i413 >> 2] = Math_fround(1.0);
    i437 = i521 + 28 | 0;
    HEAPF32[i437 >> 2] = Math_fround(1.0);
    i365 = i521 + 32 | 0;
    HEAPF32[i365 >> 2] = Math_fround(1.0);
    i388 = i521 + 36 | 0;
    HEAPF32[i388 >> 2] = Math_fround(1.0);
    i412 = i521 + 40 | 0;
    HEAPF32[i412 >> 2] = Math_fround(1.0);
    i436 = i521 + 44 | 0;
    HEAPF32[i436 >> 2] = Math_fround(1.0);
    i364 = i521 + 48 | 0;
    HEAPF32[i364 >> 2] = Math_fround(1.0);
    i387 = i521 + 52 | 0;
    HEAPF32[i387 >> 2] = Math_fround(1.0);
    i411 = i521 + 56 | 0;
    HEAPF32[i411 >> 2] = Math_fround(1.0);
    i435 = i521 + 60 | 0;
    HEAPF32[i435 >> 2] = Math_fround(1.0);
    i363 = i521 + 64 | 0;
    HEAPF32[i363 >> 2] = Math_fround(1.0);
    i386 = i521 + 68 | 0;
    HEAPF32[i386 >> 2] = Math_fround(1.0);
    i410 = i521 + 72 | 0;
    HEAPF32[i410 >> 2] = Math_fround(1.0);
    i434 = i521 + 76 | 0;
    HEAPF32[i434 >> 2] = Math_fround(1.0);
    i362 = i521 + 80 | 0;
    i385 = i521 + 84 | 0;
    i409 = i521 + 88 | 0;
    i433 = i521 + 92 | 0;
    i361 = i521 + 96 | 0;
    i384 = i521 + 100 | 0;
    i408 = i521 + 104 | 0;
    i432 = i521 + 108 | 0;
    i360 = i521 + 112 | 0;
    i383 = i521 + 116 | 0;
    i407 = i521 + 120 | 0;
    i431 = i521 + 124 | 0;
    i16 = i362;
    i15 = i16 + 48 | 0;
    do {
     HEAP32[i16 >> 2] = 0;
     i16 = i16 + 4 | 0;
    } while ((i16 | 0) < (i15 | 0));
    i382 = i522 + 4 | 0;
    i406 = i522 + 8 | 0;
    i430 = i522 + 12 | 0;
    i359 = i522 + 16 | 0;
    HEAP32[i522 >> 2] = 0;
    HEAP32[i522 + 4 >> 2] = 0;
    HEAP32[i522 + 8 >> 2] = 0;
    HEAP32[i522 + 12 >> 2] = 0;
    HEAPF32[i359 >> 2] = Math_fround(1.0);
    i381 = i522 + 20 | 0;
    HEAPF32[i381 >> 2] = Math_fround(1.0);
    i405 = i522 + 24 | 0;
    HEAPF32[i405 >> 2] = Math_fround(1.0);
    i429 = i522 + 28 | 0;
    HEAPF32[i429 >> 2] = Math_fround(1.0);
    i358 = i522 + 32 | 0;
    i380 = i522 + 36 | 0;
    i404 = i522 + 40 | 0;
    i428 = i522 + 44 | 0;
    i357 = i522 + 48 | 0;
    i379 = i522 + 52 | 0;
    i403 = i522 + 56 | 0;
    i427 = i522 + 60 | 0;
    i356 = i522 + 64 | 0;
    HEAP32[i358 >> 2] = 0;
    HEAP32[i358 + 4 >> 2] = 0;
    HEAP32[i358 + 8 >> 2] = 0;
    HEAP32[i358 + 12 >> 2] = 0;
    HEAP32[i358 + 16 >> 2] = 0;
    HEAP32[i358 + 20 >> 2] = 0;
    HEAP32[i358 + 24 >> 2] = 0;
    HEAP32[i358 + 28 >> 2] = 0;
    HEAPF32[i356 >> 2] = Math_fround(1.0);
    i378 = i522 + 68 | 0;
    HEAPF32[i378 >> 2] = Math_fround(1.0);
    i402 = i522 + 72 | 0;
    HEAPF32[i402 >> 2] = Math_fround(1.0);
    i426 = i522 + 76 | 0;
    HEAPF32[i426 >> 2] = Math_fround(1.0);
    i355 = i522 + 80 | 0;
    HEAPF32[i355 >> 2] = Math_fround(1.0);
    i377 = i522 + 84 | 0;
    HEAPF32[i377 >> 2] = Math_fround(1.0);
    i401 = i522 + 88 | 0;
    HEAPF32[i401 >> 2] = Math_fround(1.0);
    i425 = i522 + 92 | 0;
    HEAPF32[i425 >> 2] = Math_fround(1.0);
    i354 = i522 + 96 | 0;
    i376 = i522 + 100 | 0;
    i400 = i522 + 104 | 0;
    i424 = i522 + 108 | 0;
    i353 = i522 + 112 | 0;
    i375 = i522 + 116 | 0;
    i399 = i522 + 120 | 0;
    i423 = i522 + 124 | 0;
    i352 = i522 + 128 | 0;
    HEAP32[i354 >> 2] = 0;
    HEAP32[i354 + 4 >> 2] = 0;
    HEAP32[i354 + 8 >> 2] = 0;
    HEAP32[i354 + 12 >> 2] = 0;
    HEAP32[i354 + 16 >> 2] = 0;
    HEAP32[i354 + 20 >> 2] = 0;
    HEAP32[i354 + 24 >> 2] = 0;
    HEAP32[i354 + 28 >> 2] = 0;
    HEAPF32[i352 >> 2] = Math_fround(1.0);
    i374 = i522 + 132 | 0;
    HEAPF32[i374 >> 2] = Math_fround(1.0);
    i398 = i522 + 136 | 0;
    HEAPF32[i398 >> 2] = Math_fround(1.0);
    i422 = i522 + 140 | 0;
    HEAPF32[i422 >> 2] = Math_fround(1.0);
    i351 = i522 + 144 | 0;
    i373 = i522 + 148 | 0;
    i397 = i522 + 152 | 0;
    i421 = i522 + 156 | 0;
    i350 = i522 + 160 | 0;
    i372 = i522 + 164 | 0;
    i396 = i522 + 168 | 0;
    i420 = i522 + 172 | 0;
    i349 = i522 + 176 | 0;
    i371 = i522 + 180 | 0;
    i395 = i522 + 184 | 0;
    i419 = i522 + 188 | 0;
    i348 = i522 + 192 | 0;
    i370 = i522 + 196 | 0;
    i394 = i522 + 200 | 0;
    i418 = i522 + 204 | 0;
    i347 = i522 + 208 | 0;
    i369 = i522 + 212 | 0;
    i393 = i522 + 216 | 0;
    i417 = i522 + 220 | 0;
    i346 = i522 + 224 | 0;
    i368 = i522 + 228 | 0;
    i392 = i522 + 232 | 0;
    i416 = i522 + 236 | 0;
    i345 = i522 + 240 | 0;
    i367 = i522 + 244 | 0;
    i391 = i522 + 248 | 0;
    i415 = i522 + 252 | 0;
    i16 = i351;
    i15 = i16 + 112 | 0;
    do {
     HEAP32[i16 >> 2] = 0;
     i16 = i16 + 4 | 0;
    } while ((i16 | 0) < (i15 | 0));
    switch (i4 | 0) {
    case 1:
     {
      i16 = i12;
      i1 = gb + 1162292 | 0;
      i15 = i16 + 64 | 0;
      do {
       HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
       i16 = i16 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i16 | 0) < (i15 | 0));
      break;
     }
    case 2:
     {
      i16 = i12;
      i1 = i13 + 256 | 0;
      i15 = i16 + 64 | 0;
      do {
       HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
       i16 = i16 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i16 | 0) < (i15 | 0));
      break;
     }
    default:
     {
      i16 = i12;
      i1 = i13 + 64 | 0;
      i15 = i16 + 64 | 0;
      do {
       HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
       i16 = i16 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i16 | 0) < (i15 | 0));
     }
    }
    __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
    f507 = Math_fround(HEAPF32[i3 >> 2]);
    f498 = Math_fround(HEAPF32[i13 + 428 >> 2]);
    f5 = Math_fround(HEAPF32[i13 + 424 >> 2]);
    f337 = Math_fround(HEAPF32[i14 >> 2]);
    i329 = i14 + 4 | 0;
    f506 = Math_fround(HEAPF32[i329 >> 2]);
    i330 = i14 + 8 | 0;
    f504 = Math_fround(HEAPF32[i330 >> 2]);
    i331 = i14 + 12 | 0;
    f340 = Math_fround(HEAPF32[i331 >> 2]);
    i332 = i14 + 16 | 0;
    f497 = Math_fround(HEAPF32[i332 >> 2]);
    i333 = i14 + 20 | 0;
    f502 = Math_fround(HEAPF32[i333 >> 2]);
    i509 = i14 + 24 | 0;
    f505 = Math_fround(HEAPF32[i509 >> 2]);
    i167 = i14 + 28 | 0;
    f499 = Math_fround(HEAPF32[i167 >> 2]);
    i166 = i14 + 32 | 0;
    f341 = Math_fround(HEAPF32[i166 >> 2]);
    f339 = Math_fround(f506 * Math_fround(0.0));
    f508 = Math_fround(f504 * Math_fround(0.0));
    f6 = Math_fround(f497 * Math_fround(0.0));
    f503 = Math_fround(f502 * Math_fround(0.0));
    f342 = Math_fround(Math_fround(Math_fround(f507 * f340) + f6) + f503);
    f338 = Math_fround(f499 * Math_fround(0.0));
    f501 = Math_fround(f341 * Math_fround(0.0));
    f7 = Math_fround(Math_fround(Math_fround(f507 * f505) + f338) + f501);
    f500 = Math_fround(f337 * Math_fround(0.0));
    f506 = Math_fround(Math_fround(f500 + Math_fround(f498 * f506)) + f508);
    f340 = Math_fround(f340 * Math_fround(0.0));
    f503 = Math_fround(Math_fround(f340 + Math_fround(f498 * f497)) + f503);
    f505 = Math_fround(f505 * Math_fround(0.0));
    f501 = Math_fround(Math_fround(f505 + Math_fround(f498 * f499)) + f501);
    f504 = Math_fround(Math_fround(f500 + f339) + Math_fround(f5 * f504));
    f502 = Math_fround(Math_fround(f340 + f6) + Math_fround(f5 * f502));
    f341 = Math_fround(Math_fround(f505 + f338) + Math_fround(f5 * f341));
    HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(f507 * f337) + f339) + f508);
    HEAPF32[i329 >> 2] = f506;
    HEAPF32[i330 >> 2] = f504;
    HEAPF32[i331 >> 2] = f342;
    HEAPF32[i332 >> 2] = f503;
    HEAPF32[i333 >> 2] = f502;
    HEAPF32[i509 >> 2] = f7;
    HEAPF32[i167 >> 2] = f501;
    HEAPF32[i166 >> 2] = f341;
    i334 = i526 + 300 | 0;
    f341 = Math_fround(HEAPF32[HEAP32[i334 >> 2] >> 2]);
    i335 = i526 + 320 | 0;
    f501 = Math_fround(HEAPF32[HEAP32[i335 >> 2] >> 2]);
    i336 = i526 + 340 | 0;
    f501 = Math_fround(-f501);
    f7 = Math_fround(-Math_fround(HEAPF32[HEAP32[i336 >> 2] >> 2]));
    HEAPF32[i528 >> 2] = Math_fround(-f341);
    HEAPF32[i528 + 4 >> 2] = f501;
    HEAPF32[i528 + 8 >> 2] = f7;
    __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f(i528, i510);
    f7 = Math_fround(HEAPF32[i510 >> 2]);
    f501 = Math_fround(HEAPF32[i510 + 4 >> 2]);
    f341 = Math_fround(HEAPF32[i510 + 8 >> 2]);
    f502 = Math_fround(HEAPF32[i510 + 12 >> 2]);
    f503 = Math_fround(HEAPF32[i510 + 16 >> 2]);
    f342 = Math_fround(HEAPF32[i510 + 20 >> 2]);
    f504 = Math_fround(HEAPF32[i510 + 24 >> 2]);
    f506 = Math_fround(HEAPF32[i510 + 28 >> 2]);
    f508 = Math_fround(HEAPF32[i510 + 32 >> 2]);
    f339 = Math_fround(HEAPF32[i14 >> 2]);
    f337 = Math_fround(f7 * f339);
    f507 = Math_fround(HEAPF32[i331 >> 2]);
    f337 = Math_fround(f337 + Math_fround(f501 * f507));
    f5 = Math_fround(HEAPF32[i509 >> 2]);
    f337 = Math_fround(f337 + Math_fround(f341 * f5));
    f338 = Math_fround(Math_fround(Math_fround(f502 * f339) + Math_fround(f503 * f507)) + Math_fround(f342 * f5));
    f5 = Math_fround(Math_fround(Math_fround(f504 * f339) + Math_fround(f506 * f507)) + Math_fround(f508 * f5));
    f507 = Math_fround(HEAPF32[i329 >> 2]);
    f339 = Math_fround(f7 * f507);
    f505 = Math_fround(HEAPF32[i332 >> 2]);
    f339 = Math_fround(f339 + Math_fround(f501 * f505));
    f6 = Math_fround(HEAPF32[i167 >> 2]);
    f339 = Math_fround(f339 + Math_fround(f341 * f6));
    f340 = Math_fround(Math_fround(Math_fround(f502 * f507) + Math_fround(f503 * f505)) + Math_fround(f342 * f6));
    f6 = Math_fround(Math_fround(Math_fround(f504 * f507) + Math_fround(f506 * f505)) + Math_fround(f508 * f6));
    f505 = Math_fround(HEAPF32[i330 >> 2]);
    f7 = Math_fround(f7 * f505);
    f507 = Math_fround(HEAPF32[i333 >> 2]);
    f501 = Math_fround(f7 + Math_fround(f501 * f507));
    f7 = Math_fround(HEAPF32[i166 >> 2]);
    f341 = Math_fround(f501 + Math_fround(f341 * f7));
    f342 = Math_fround(Math_fround(Math_fround(f502 * f505) + Math_fround(f503 * f507)) + Math_fround(f342 * f7));
    f7 = Math_fround(Math_fround(Math_fround(f504 * f505) + Math_fround(f506 * f507)) + Math_fround(f508 * f7));
    HEAPF32[i14 >> 2] = f337;
    HEAPF32[i329 >> 2] = f339;
    HEAPF32[i330 >> 2] = f341;
    HEAPF32[i331 >> 2] = f338;
    HEAPF32[i332 >> 2] = f340;
    HEAPF32[i333 >> 2] = f342;
    HEAPF32[i509 >> 2] = f5;
    HEAPF32[i167 >> 2] = f6;
    HEAPF32[i166 >> 2] = f7;
    i166 = (i2 | 0) == 27;
    HEAP32[i510 >> 2] = 0;
    HEAP32[i510 + 4 >> 2] = 0;
    HEAP32[i510 + 8 >> 2] = 0;
    HEAP32[i510 + 12 >> 2] = 0;
    i167 = HEAP32[i526 + 12 >> 2] | 0;
    if (i167 | 0) {
     i168 = i528 + 12 | 0;
     i169 = i528 + 8 | 0;
     i170 = i528 + 4 | 0;
     i171 = i528 + 16 | 0;
     i172 = i528 + 28 | 0;
     i173 = i528 + 24 | 0;
     i174 = i528 + 20 | 0;
     i175 = i528 + 32 | 0;
     i176 = i528 + 44 | 0;
     i177 = i528 + 40 | 0;
     i178 = i528 + 36 | 0;
     i179 = i529 + 12 | 0;
     i180 = i529 + 8 | 0;
     i181 = i529 + 4 | 0;
     i182 = i529 + 28 | 0;
     i183 = i529 + 24 | 0;
     i184 = i529 + 20 | 0;
     i185 = i529 + 44 | 0;
     i186 = i529 + 40 | 0;
     i187 = i529 + 36 | 0;
     i188 = i527 + 20 | 0;
     i189 = i526 + 20 | 0;
     i190 = i526 + 40 | 0;
     i191 = i526 + 60 | 0;
     i192 = i526 + 80 | 0;
     i193 = i526 + 100 | 0;
     i194 = i526 + 120 | 0;
     i195 = i526 + 140 | 0;
     i196 = i526 + 160 | 0;
     i197 = i529 + 16 | 0;
     i198 = i529 + 32 | 0;
     i199 = i527 + 4 | 0;
     i200 = i511 + 4 | 0;
     i201 = i511 + 8 | 0;
     i202 = i511 + 12 | 0;
     i203 = i527 + 8 | 0;
     i204 = i512 + 4 | 0;
     i205 = i512 + 8 | 0;
     i206 = i512 + 12 | 0;
     i207 = i526 + 520 | 0;
     i208 = i513 + 4 | 0;
     i209 = i513 + 8 | 0;
     i210 = i513 + 12 | 0;
     i211 = i526 + 500 | 0;
     i212 = i514 + 4 | 0;
     i213 = i514 + 8 | 0;
     i214 = i514 + 12 | 0;
     i215 = i527 + 16 | 0;
     i216 = i515 + 4 | 0;
     i217 = i515 + 8 | 0;
     i218 = i515 + 12 | 0;
     i219 = i528 + 16 | 0;
     i220 = i528 + 32 | 0;
     i221 = i516 + 4 | 0;
     i222 = i516 + 8 | 0;
     i223 = i516 + 12 | 0;
     i224 = i516 + 16 | 0;
     i225 = i516 + 20 | 0;
     i226 = i516 + 24 | 0;
     i227 = i516 + 28 | 0;
     i228 = i516 + 32 | 0;
     i229 = i516 + 36 | 0;
     i230 = i516 + 40 | 0;
     i231 = i516 + 44 | 0;
     i232 = i523 + 4 | 0;
     i233 = i523 + 8 | 0;
     i234 = i523 + 12 | 0;
     i235 = i523 + 16 | 0;
     i236 = i523 + 20 | 0;
     i237 = i523 + 24 | 0;
     i238 = i523 + 28 | 0;
     i239 = i523 + 32 | 0;
     i240 = i523 + 36 | 0;
     i241 = i523 + 40 | 0;
     i242 = i523 + 44 | 0;
     i243 = i523 + 48 | 0;
     i244 = i523 + 52 | 0;
     i245 = i523 + 56 | 0;
     i246 = i523 + 60 | 0;
     i247 = i523 + 64 | 0;
     i248 = i523 + 68 | 0;
     i249 = i523 + 72 | 0;
     i250 = i523 + 76 | 0;
     i251 = i523 + 80 | 0;
     i252 = i523 + 84 | 0;
     i253 = i523 + 88 | 0;
     i254 = i523 + 92 | 0;
     i255 = i523 + 96 | 0;
     i256 = i523 + 100 | 0;
     i257 = i523 + 104 | 0;
     i258 = i523 + 108 | 0;
     i259 = i523 + 112 | 0;
     i260 = i523 + 116 | 0;
     i261 = i523 + 120 | 0;
     i262 = i523 + 124 | 0;
     i263 = i523 + 128 | 0;
     i264 = i523 + 132 | 0;
     i265 = i523 + 136 | 0;
     i266 = i523 + 140 | 0;
     i267 = i523 + 144 | 0;
     i268 = i523 + 148 | 0;
     i269 = i523 + 152 | 0;
     i270 = i523 + 156 | 0;
     i271 = i523 + 160 | 0;
     i272 = i523 + 164 | 0;
     i273 = i523 + 168 | 0;
     i274 = i523 + 172 | 0;
     i275 = i523 + 176 | 0;
     i276 = i523 + 180 | 0;
     i277 = i523 + 184 | 0;
     i278 = i523 + 188 | 0;
     i279 = (i2 & 48 | 0) == 0;
     i128 = i524 + 4 | 0;
     i145 = i524 + 8 | 0;
     i162 = i524 + 12 | 0;
     i280 = i524 + 16 | 0;
     i123 = i524 + 20 | 0;
     i140 = i524 + 24 | 0;
     i157 = i524 + 28 | 0;
     i281 = i524 + 32 | 0;
     i118 = i524 + 36 | 0;
     i135 = i524 + 40 | 0;
     i152 = i524 + 44 | 0;
     i282 = i524 + 48 | 0;
     i127 = i524 + 52 | 0;
     i144 = i524 + 56 | 0;
     i161 = i524 + 60 | 0;
     i283 = i524 + 64 | 0;
     i122 = i524 + 68 | 0;
     i139 = i524 + 72 | 0;
     i156 = i524 + 76 | 0;
     i284 = i524 + 80 | 0;
     i117 = i524 + 84 | 0;
     i134 = i524 + 88 | 0;
     i151 = i524 + 92 | 0;
     i285 = i524 + 96 | 0;
     i126 = i524 + 100 | 0;
     i143 = i524 + 104 | 0;
     i160 = i524 + 108 | 0;
     i286 = i524 + 112 | 0;
     i121 = i524 + 116 | 0;
     i138 = i524 + 120 | 0;
     i155 = i524 + 124 | 0;
     i287 = i524 + 128 | 0;
     i116 = i524 + 132 | 0;
     i133 = i524 + 136 | 0;
     i150 = i524 + 140 | 0;
     i288 = i524 + 144 | 0;
     i125 = i524 + 148 | 0;
     i142 = i524 + 152 | 0;
     i159 = i524 + 156 | 0;
     i289 = i524 + 160 | 0;
     i120 = i524 + 164 | 0;
     i137 = i524 + 168 | 0;
     i154 = i524 + 172 | 0;
     i290 = i524 + 176 | 0;
     i115 = i524 + 180 | 0;
     i132 = i524 + 184 | 0;
     i149 = i524 + 188 | 0;
     i129 = i517 + 4 | 0;
     i146 = i517 + 8 | 0;
     i163 = i517 + 12 | 0;
     i291 = i517 + 16 | 0;
     i124 = i517 + 20 | 0;
     i141 = i517 + 24 | 0;
     i158 = i517 + 28 | 0;
     i292 = i517 + 32 | 0;
     i119 = i517 + 36 | 0;
     i136 = i517 + 40 | 0;
     i153 = i517 + 44 | 0;
     i131 = i518 + 4 | 0;
     i148 = i518 + 8 | 0;
     i165 = i518 + 12 | 0;
     i293 = i518 + 16 | 0;
     i130 = i518 + 20 | 0;
     i147 = i518 + 24 | 0;
     i164 = i518 + 28 | 0;
     i114 = i518 + 32 | 0;
     i294 = (i2 & 512 | 0) != 0;
     i295 = i519 + 4 | 0;
     i296 = i519 + 8 | 0;
     i297 = i519 + 12 | 0;
     i298 = i519 + 16 | 0;
     i299 = i519 + 20 | 0;
     i300 = i519 + 24 | 0;
     i301 = i519 + 28 | 0;
     i302 = i519 + 32 | 0;
     i303 = i519 + 36 | 0;
     i304 = i519 + 40 | 0;
     i305 = i519 + 44 | 0;
     i306 = (i2 & 8192 | 0) != 0;
     i307 = i525 + 4 | 0;
     i308 = i525 + 8 | 0;
     i309 = i525 + 12 | 0;
     i310 = i525 + 16 | 0;
     i311 = i525 + 20 | 0;
     i312 = i525 + 24 | 0;
     i313 = i525 + 28 | 0;
     i314 = i525 + 32 | 0;
     i315 = i525 + 36 | 0;
     i316 = i525 + 40 | 0;
     i317 = i525 + 44 | 0;
     i318 = i525 + 48 | 0;
     i319 = i525 + 52 | 0;
     i320 = i525 + 56 | 0;
     i321 = i525 + 60 | 0;
     i322 = (i2 & 2 | 0) == 0;
     i323 = (i2 & 8 | 0) == 0;
     i324 = (i2 & 16 | 0) == 0;
     i325 = (i2 & 32 | 0) == 0;
     i326 = (i2 & 64 | 0) == 0;
     i327 = (i2 & 128 | 0) == 0;
     i328 = (i2 & 256 | 0) == 0;
     i329 = i519 + 16 | 0;
     i330 = i519 + 32 | 0;
     i331 = (i2 & 1024 | 0) == 0;
     i332 = (i2 & 2048 | 0) == 0;
     i333 = (i2 & 4096 | 0) == 0;
     i86 = (i2 & 4 | 0) == 0;
     i87 = i517 + 16 | 0;
     i88 = i517 + 32 | 0;
     i89 = i526 + 864 | 0;
     i90 = i526 + 848 | 0;
     i91 = i526 + 844 | 0;
     i92 = i526 + 828 | 0;
     i93 = i526 + 540 | 0;
     i94 = i518 + 16 | 0;
     i95 = i518 + 32 | 0;
     i96 = i516 + 16 | 0;
     i97 = i516 + 32 | 0;
     i98 = i523 + 16 | 0;
     i99 = i523 + 32 | 0;
     i100 = i524 + 16 | 0;
     i101 = i524 + 32 | 0;
     i102 = i243 + 16 | 0;
     i103 = i243 + 32 | 0;
     i104 = i282 + 16 | 0;
     i105 = i282 + 32 | 0;
     i106 = i255 + 16 | 0;
     i107 = i255 + 32 | 0;
     i108 = i285 + 16 | 0;
     i109 = i285 + 32 | 0;
     i110 = i267 + 16 | 0;
     i111 = i267 + 32 | 0;
     i112 = i288 + 16 | 0;
     i113 = i288 + 32 | 0;
     f85 = Math_fround(f5 * Math_fround(0.0));
     f84 = Math_fround(f6 * Math_fround(0.0));
     f82 = Math_fround(f7 * Math_fround(0.0));
     i83 = i11 + 564 | 0;
     i81 = i11 + 568 | 0;
     i80 = 0;
     i1 = i17;
     do {
      i16 = i528;
      i15 = i16 + 48 | 0;
      do {
       HEAP32[i16 >> 2] = 0;
       i16 = i16 + 4 | 0;
      } while ((i16 | 0) < (i15 | 0));
      i16 = i529;
      i15 = i16 + 48 | 0;
      do {
       HEAP32[i16 >> 2] = 0;
       i16 = i16 + 4 | 0;
      } while ((i16 | 0) < (i15 | 0));
      HEAP32[i511 >> 2] = 0;
      HEAP32[i511 + 4 >> 2] = 0;
      HEAP32[i511 + 8 >> 2] = 0;
      HEAP32[i511 + 12 >> 2] = 0;
      HEAP32[i512 >> 2] = 0;
      HEAP32[i512 + 4 >> 2] = 0;
      HEAP32[i512 + 8 >> 2] = 0;
      HEAP32[i512 + 12 >> 2] = 0;
      HEAP32[i513 >> 2] = 0;
      HEAP32[i513 + 4 >> 2] = 0;
      HEAP32[i513 + 8 >> 2] = 0;
      HEAP32[i513 + 12 >> 2] = 0;
      HEAP32[i514 >> 2] = 0;
      HEAP32[i514 + 4 >> 2] = 0;
      HEAP32[i514 + 8 >> 2] = 0;
      HEAP32[i514 + 12 >> 2] = 0;
      HEAP32[i515 >> 2] = 0;
      HEAP32[i515 + 4 >> 2] = 0;
      HEAP32[i515 + 8 >> 2] = 0;
      HEAP32[i515 + 12 >> 2] = 0;
      i22 = HEAP32[i188 >> 2] | 0;
      i23 = HEAP32[i526 >> 2] | 0;
      if (!i22) {
       i68 = i23 + (i80 << 2) | 0;
       i69 = HEAP32[i68 + 4 >> 2] | 0;
       i70 = HEAP32[i68 + 8 >> 2] | 0;
       i71 = HEAP32[i68 + 12 >> 2] | 0;
       i75 = (HEAP32[i189 >> 2] | 0) + (i80 << 2) | 0;
       i72 = HEAP32[i75 >> 2] | 0;
       i73 = HEAP32[i75 + 4 >> 2] | 0;
       i74 = HEAP32[i75 + 8 >> 2] | 0;
       i75 = HEAP32[i75 + 12 >> 2] | 0;
       i509 = (HEAP32[i190 >> 2] | 0) + (i80 << 2) | 0;
       i76 = HEAP32[i509 >> 2] | 0;
       i77 = HEAP32[i509 + 4 >> 2] | 0;
       i78 = HEAP32[i509 + 8 >> 2] | 0;
       i509 = HEAP32[i509 + 12 >> 2] | 0;
       HEAP32[i528 >> 2] = HEAP32[i68 >> 2];
       HEAP32[i170 >> 2] = i69;
       HEAP32[i169 >> 2] = i70;
       HEAP32[i168 >> 2] = i71;
       HEAP32[i171 >> 2] = i72;
       HEAP32[i174 >> 2] = i73;
       HEAP32[i173 >> 2] = i74;
       HEAP32[i172 >> 2] = i75;
       HEAP32[i175 >> 2] = i76;
       HEAP32[i178 >> 2] = i77;
       HEAP32[i177 >> 2] = i78;
       HEAP32[i176 >> 2] = i509;
       i509 = (HEAP32[i191 >> 2] | 0) + (i80 << 2) | 0;
       f496 = Math_fround(HEAPF32[i509 >> 2]);
       f486 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f487 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f488 = Math_fround(HEAPF32[i509 + 12 >> 2]);
       i509 = (HEAP32[i192 >> 2] | 0) + (i80 << 2) | 0;
       f489 = Math_fround(HEAPF32[i509 >> 2]);
       f490 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f491 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f492 = Math_fround(HEAPF32[i509 + 12 >> 2]);
       i509 = (HEAP32[i193 >> 2] | 0) + (i80 << 2) | 0;
       f493 = Math_fround(HEAPF32[i509 >> 2]);
       f494 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f495 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f508 = Math_fround(HEAPF32[i509 + 12 >> 2]);
       i509 = (HEAP32[i194 >> 2] | 0) + (i80 << 2) | 0;
       f497 = Math_fround(HEAPF32[i509 >> 2]);
       f498 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f499 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f500 = Math_fround(HEAPF32[i509 + 12 >> 2]);
       i509 = (HEAP32[i195 >> 2] | 0) + (i80 << 2) | 0;
       f501 = Math_fround(HEAPF32[i509 >> 2]);
       f502 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f503 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f504 = Math_fround(HEAPF32[i509 + 12 >> 2]);
       i509 = (HEAP32[i196 >> 2] | 0) + (i80 << 2) | 0;
       f505 = Math_fround(HEAPF32[i509 >> 2]);
       f506 = Math_fround(HEAPF32[i509 + 4 >> 2]);
       f507 = Math_fround(HEAPF32[i509 + 8 >> 2]);
       f498 = Math_fround(f486 + f498);
       f499 = Math_fround(f487 + f499);
       f500 = Math_fround(f488 + f500);
       f501 = Math_fround(f489 + f501);
       f502 = Math_fround(f490 + f502);
       f503 = Math_fround(f491 + f503);
       f504 = Math_fround(f492 + f504);
       f505 = Math_fround(f493 + f505);
       f506 = Math_fround(f494 + f506);
       f507 = Math_fround(f495 + f507);
       f508 = Math_fround(f508 + Math_fround(HEAPF32[i509 + 12 >> 2]));
       HEAPF32[i529 >> 2] = Math_fround(f496 + f497);
       HEAPF32[i181 >> 2] = f498;
       HEAPF32[i180 >> 2] = f499;
       HEAPF32[i179 >> 2] = f500;
       HEAPF32[i197 >> 2] = f501;
       HEAPF32[i184 >> 2] = f502;
       HEAPF32[i183 >> 2] = f503;
       HEAPF32[i182 >> 2] = f504;
       HEAPF32[i198 >> 2] = f505;
       HEAPF32[i187 >> 2] = f506;
       HEAPF32[i186 >> 2] = f507;
       HEAPF32[i185 >> 2] = f508;
       i509 = (HEAP32[i199 >> 2] | 0) + (i80 << 2) | 0;
       i78 = HEAP32[i509 + 4 >> 2] | 0;
       i77 = HEAP32[i509 + 8 >> 2] | 0;
       i76 = HEAP32[i509 + 12 >> 2] | 0;
       HEAP32[i511 >> 2] = HEAP32[i509 >> 2];
       HEAP32[i200 >> 2] = i78;
       HEAP32[i201 >> 2] = i77;
       HEAP32[i202 >> 2] = i76;
       i76 = (HEAP32[i203 >> 2] | 0) + (i80 << 2) | 0;
       i77 = HEAP32[i76 + 4 >> 2] | 0;
       i78 = HEAP32[i76 + 8 >> 2] | 0;
       i509 = HEAP32[i76 + 12 >> 2] | 0;
       HEAP32[i512 >> 2] = HEAP32[i76 >> 2];
       HEAP32[i204 >> 2] = i77;
       HEAP32[i205 >> 2] = i78;
       HEAP32[i206 >> 2] = i509;
       i509 = (HEAP32[i207 >> 2] | 0) + (i80 << 2) | 0;
       i78 = HEAP32[i509 + 4 >> 2] | 0;
       i77 = HEAP32[i509 + 8 >> 2] | 0;
       i76 = HEAP32[i509 + 12 >> 2] | 0;
       HEAP32[i513 >> 2] = HEAP32[i509 >> 2];
       HEAP32[i208 >> 2] = i78;
       HEAP32[i209 >> 2] = i77;
       HEAP32[i210 >> 2] = i76;
       i76 = (HEAP32[i211 >> 2] | 0) + (i80 << 2) | 0;
       i77 = HEAP32[i76 + 4 >> 2] | 0;
       i78 = HEAP32[i76 + 8 >> 2] | 0;
       i509 = HEAP32[i76 + 12 >> 2] | 0;
       HEAP32[i514 >> 2] = HEAP32[i76 >> 2];
       HEAP32[i212 >> 2] = i77;
       HEAP32[i213 >> 2] = i78;
       HEAP32[i214 >> 2] = i509;
       if (HEAP32[i482 >> 2] & 268435456 | 0) {
        i76 = (HEAP32[i215 >> 2] | 0) + (i80 << 2) | 0;
        i77 = HEAP32[i76 + 4 >> 2] | 0;
        i78 = HEAP32[i76 + 8 >> 2] | 0;
        i509 = HEAP32[i76 + 12 >> 2] | 0;
        HEAP32[i515 >> 2] = HEAP32[i76 >> 2];
        HEAP32[i216 >> 2] = i77;
        HEAP32[i217 >> 2] = i78;
        HEAP32[i218 >> 2] = i509;
       }
      } else {
       i4 = HEAP32[i191 >> 2] | 0;
       i11 = HEAP32[i194 >> 2] | 0;
       i12 = HEAP32[i189 >> 2] | 0;
       i13 = HEAP32[i192 >> 2] | 0;
       i14 = HEAP32[i195 >> 2] | 0;
       i15 = HEAP32[i190 >> 2] | 0;
       i16 = HEAP32[i193 >> 2] | 0;
       i17 = HEAP32[i196 >> 2] | 0;
       i18 = HEAP32[i199 >> 2] | 0;
       i19 = HEAP32[i203 >> 2] | 0;
       i20 = HEAP32[i207 >> 2] | 0;
       i21 = HEAP32[i211 >> 2] | 0;
       i3 = HEAP32[i215 >> 2] | 0;
       if (!(HEAP32[i482 >> 2] & 268435456)) {
        i2 = 0;
        do {
         i509 = HEAP32[i22 + (i2 + i80 << 3) >> 2] | 0;
         HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i4 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i2 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i11 + (i509 << 2) >> 2]));
         i78 = i2 + 4 | 0;
         HEAP32[i528 + (i78 << 2) >> 2] = HEAP32[i12 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i13 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i78 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i14 + (i509 << 2) >> 2]));
         i78 = i2 + 8 | 0;
         HEAP32[i528 + (i78 << 2) >> 2] = HEAP32[i15 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i16 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i78 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i17 + (i509 << 2) >> 2]));
         HEAP32[i511 + (i2 << 2) >> 2] = HEAP32[i18 + (i509 << 2) >> 2];
         HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i19 + (i509 << 2) >> 2];
         HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i20 + (i509 << 2) >> 2];
         HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i21 + (i509 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != 4);
       } else {
        i2 = 0;
        do {
         i509 = HEAP32[i22 + (i2 + i80 << 3) >> 2] | 0;
         HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i4 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i2 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i11 + (i509 << 2) >> 2]));
         i78 = i2 + 4 | 0;
         HEAP32[i528 + (i78 << 2) >> 2] = HEAP32[i12 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i13 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i78 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i14 + (i509 << 2) >> 2]));
         i78 = i2 + 8 | 0;
         HEAP32[i528 + (i78 << 2) >> 2] = HEAP32[i15 + (i509 << 2) >> 2];
         f508 = Math_fround(HEAPF32[i16 + (i509 << 2) >> 2]);
         HEAPF32[i529 + (i78 << 2) >> 2] = Math_fround(f508 + Math_fround(HEAPF32[i17 + (i509 << 2) >> 2]));
         HEAP32[i511 + (i2 << 2) >> 2] = HEAP32[i18 + (i509 << 2) >> 2];
         HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i19 + (i509 << 2) >> 2];
         HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i20 + (i509 << 2) >> 2];
         HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i21 + (i509 << 2) >> 2];
         HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i3 + (i509 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != 4);
       }
      }
      f33 = Math_fround(HEAPF32[i528 >> 2]);
      f7 = Math_fround(f343 * f33);
      f31 = Math_fround(HEAPF32[i170 >> 2]);
      f29 = Math_fround(f343 * f31);
      f508 = Math_fround(HEAPF32[i169 >> 2]);
      f6 = Math_fround(f343 * f508);
      f506 = Math_fround(HEAPF32[i168 >> 2]);
      f79 = Math_fround(f343 * f506);
      f32 = Math_fround(HEAPF32[i219 >> 2]);
      f30 = Math_fround(f442 * f32);
      f26 = Math_fround(HEAPF32[i174 >> 2]);
      f35 = Math_fround(f442 * f26);
      f507 = Math_fround(HEAPF32[i173 >> 2]);
      f10 = Math_fround(f442 * f507);
      f505 = Math_fround(HEAPF32[i172 >> 2]);
      f30 = Math_fround(f7 + f30);
      f35 = Math_fround(f29 + f35);
      f10 = Math_fround(f6 + f10);
      f79 = Math_fround(f79 + Math_fround(f442 * f505));
      f6 = Math_fround(HEAPF32[i220 >> 2]);
      f29 = Math_fround(f445 * f6);
      f7 = Math_fround(HEAPF32[i178 >> 2]);
      f28 = Math_fround(f445 * f7);
      f8 = Math_fround(HEAPF32[i177 >> 2]);
      f27 = Math_fround(f445 * f8);
      f34 = Math_fround(HEAPF32[i176 >> 2]);
      f28 = Math_fround(f448 + Math_fround(f35 + f28));
      f27 = Math_fround(f448 + Math_fround(f10 + f27));
      f79 = Math_fround(f448 + Math_fround(f79 + Math_fround(f445 * f34)));
      HEAPF32[i516 >> 2] = Math_fround(f448 + Math_fround(f30 + f29));
      HEAPF32[i221 >> 2] = f28;
      HEAPF32[i222 >> 2] = f27;
      HEAPF32[i223 >> 2] = f79;
      f79 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f344 * f31) + Math_fround(f443 * f26)) + Math_fround(f446 * f7)));
      f27 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f344 * f508) + Math_fround(f443 * f507)) + Math_fround(f446 * f8)));
      f28 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f344 * f506) + Math_fround(f443 * f505)) + Math_fround(f446 * f34)));
      HEAPF32[i224 >> 2] = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f344 * f33) + Math_fround(f443 * f32)) + Math_fround(f446 * f6)));
      HEAPF32[i225 >> 2] = f79;
      HEAPF32[i226 >> 2] = f27;
      HEAPF32[i227 >> 2] = f28;
      f28 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f31) + Math_fround(f444 * f26)) + Math_fround(f447 * f7)));
      f27 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f508) + Math_fround(f444 * f507)) + Math_fround(f447 * f8)));
      f79 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f506) + Math_fround(f444 * f505)) + Math_fround(f447 * f34)));
      HEAPF32[i228 >> 2] = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f33) + Math_fround(f444 * f32)) + Math_fround(f447 * f6)));
      HEAPF32[i229 >> 2] = f28;
      HEAPF32[i230 >> 2] = f27;
      HEAPF32[i231 >> 2] = f79;
      f6 = Math_fround(f481 + Math_fround(Math_fround(Math_fround(f478 * f33) + Math_fround(f479 * f32)) + Math_fround(f480 * f6)));
      f7 = Math_fround(f481 + Math_fround(Math_fround(Math_fround(f478 * f31) + Math_fround(f479 * f26)) + Math_fround(f480 * f7)));
      f8 = Math_fround(f481 + Math_fround(Math_fround(Math_fround(f478 * f508) + Math_fround(f479 * f507)) + Math_fround(f480 * f8)));
      f34 = Math_fround(f481 + Math_fround(Math_fround(Math_fround(f478 * f506) + Math_fround(f479 * f505)) + Math_fround(f480 * f34)));
      f505 = Math_fround(f468 + Math_fround(f469 * f6));
      f506 = Math_fround(f468 + Math_fround(f469 * f7));
      f507 = Math_fround(f468 + Math_fround(f469 * f8));
      f508 = Math_fround(f468 + Math_fround(f469 * f34));
      f6 = Math_fround(f464 + Math_fround(f465 * f6));
      f7 = Math_fround(f464 + Math_fround(f465 * f7));
      f8 = Math_fround(f464 + Math_fround(f465 * f8));
      f34 = Math_fround(f464 + Math_fround(f465 * f34));
      f26 = Math_fround(HEAPF32[i511 >> 2]);
      f31 = Math_fround(HEAPF32[i200 >> 2]);
      f32 = Math_fround(HEAPF32[i201 >> 2]);
      f33 = Math_fround(HEAPF32[i202 >> 2]);
      f27 = Math_fround(HEAPF32[i512 >> 2]);
      f28 = Math_fround(HEAPF32[i204 >> 2]);
      f29 = Math_fround(HEAPF32[i205 >> 2]);
      f30 = Math_fround(HEAPF32[i206 >> 2]);
      f10 = f26 > f27 ? f26 : f27;
      f35 = f31 > f28 ? f31 : f28;
      f25 = f32 > f29 ? f32 : f29;
      f36 = f33 > f30 ? f33 : f30;
      f502 = Math_fround((f10 > f505 ? f10 : f505) * Math_fround(.5));
      f503 = Math_fround((f35 > f506 ? f35 : f506) * Math_fround(.5));
      f504 = Math_fround((f25 > f507 ? f25 : f507) * Math_fround(.5));
      f5 = Math_fround((f36 > f508 ? f36 : f508) * Math_fround(.5));
      i15 = (HEAPF32[tempDoublePtr >> 2] = f502, HEAP32[tempDoublePtr >> 2] | 0);
      i16 = (HEAPF32[tempDoublePtr >> 2] = f503, HEAP32[tempDoublePtr >> 2] | 0);
      i17 = (HEAPF32[tempDoublePtr >> 2] = f504, HEAP32[tempDoublePtr >> 2] | 0);
      i76 = f505 >= Math_fround(0.0);
      i77 = f506 >= Math_fround(0.0);
      i78 = f507 >= Math_fround(0.0);
      i509 = f508 >= Math_fround(0.0);
      i15 = i76 ? i15 : 0;
      i16 = i77 ? i16 : 0;
      i17 = i78 ? i17 : 0;
      i11 = i509 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      f504 = Math_fround(f6 * Math_fround(.5));
      f506 = Math_fround(f7 * Math_fround(.5));
      f508 = Math_fround(f8 * Math_fround(.5));
      f5 = Math_fround(f34 * Math_fround(.5));
      f503 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f505 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f507 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = (HEAPF32[tempDoublePtr >> 2] = f503 < f504 ? f503 : f504, HEAP32[tempDoublePtr >> 2] | 0);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f505 < f506 ? f505 : f506, HEAP32[tempDoublePtr >> 2] | 0);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f507 < f508 ? f507 : f508, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = f6 >= Math_fround(0.0);
      i3 = f7 >= Math_fround(0.0);
      i2 = f8 >= Math_fround(0.0);
      i509 = f34 >= Math_fround(0.0);
      i76 = i509 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
      f50 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
      f48 = (HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
      f47 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f44 = Math_fround(f26 * f50);
      f46 = Math_fround(f32 * f34);
      f32 = Math_fround(f27 * f50);
      f34 = Math_fround(f29 * f34);
      f50 = Math_fround(HEAPF32[i513 >> 2]);
      f45 = Math_fround(HEAPF32[i208 >> 2]);
      f49 = Math_fround(HEAPF32[i209 >> 2]);
      f48 = Math_fround(f48 / f35);
      f29 = Math_fround(f31 * f48);
      f48 = Math_fround(f28 * f48);
      i76 = f50 < Math_fround(100.0);
      i78 = f49 < Math_fround(100.0);
      f35 = Math_fround(f47 / f36);
      f31 = Math_fround(f33 * f35);
      f35 = Math_fround(f30 * f35);
      i77 = f45 < Math_fround(100.0);
      i509 = Math_fround(HEAPF32[i210 >> 2]) < Math_fround(100.0);
      f28 = i76 ? f44 : Math_fround(0.0);
      f44 = Math_fround(-f28);
      f29 = i77 ? f29 : Math_fround(0.0);
      f45 = Math_fround(-f29);
      f30 = i78 ? f46 : Math_fround(0.0);
      f46 = Math_fround(-f30);
      f31 = i509 ? f31 : Math_fround(0.0);
      f47 = Math_fround(-f31);
      f32 = i76 ? f32 : Math_fround(0.0);
      f33 = i77 ? f48 : Math_fround(0.0);
      f34 = i78 ? f34 : Math_fround(0.0);
      f35 = i509 ? f35 : Math_fround(0.0);
      f48 = Math_fround(f338 * f32);
      f49 = Math_fround(f338 * f33);
      f50 = Math_fround(f338 * f34);
      f51 = Math_fround(f338 * f35);
      f36 = Math_fround(f85 + Math_fround(Math_fround(f337 * f44) + f48));
      f37 = Math_fround(f85 + Math_fround(Math_fround(f337 * f45) + f49));
      f38 = Math_fround(f85 + Math_fround(Math_fround(f337 * f46) + f50));
      f39 = Math_fround(f85 + Math_fround(Math_fround(f337 * f47) + f51));
      f52 = Math_fround(f340 * f32);
      f53 = Math_fround(f340 * f33);
      f54 = Math_fround(f340 * f34);
      f55 = Math_fround(f340 * f35);
      f40 = Math_fround(f84 + Math_fround(Math_fround(f339 * f44) + f52));
      f41 = Math_fround(f84 + Math_fround(Math_fround(f339 * f45) + f53));
      f42 = Math_fround(f84 + Math_fround(Math_fround(f339 * f46) + f54));
      f43 = Math_fround(f84 + Math_fround(Math_fround(f339 * f47) + f55));
      f56 = Math_fround(f342 * f32);
      f57 = Math_fround(f342 * f33);
      f58 = Math_fround(f342 * f34);
      f27 = Math_fround(f342 * f35);
      f44 = Math_fround(f82 + Math_fround(Math_fround(f341 * f44) + f56));
      f45 = Math_fround(f82 + Math_fround(Math_fround(f341 * f45) + f57));
      f46 = Math_fround(f82 + Math_fround(Math_fround(f341 * f46) + f58));
      f47 = Math_fround(f82 + Math_fround(Math_fround(f341 * f47) + f27));
      f48 = Math_fround(f85 + Math_fround(Math_fround(f337 * f28) + f48));
      f49 = Math_fround(f85 + Math_fround(Math_fround(f337 * f29) + f49));
      f50 = Math_fround(f85 + Math_fround(Math_fround(f337 * f30) + f50));
      f51 = Math_fround(f85 + Math_fround(Math_fround(f337 * f31) + f51));
      f52 = Math_fround(f84 + Math_fround(Math_fround(f339 * f28) + f52));
      f53 = Math_fround(f84 + Math_fround(Math_fround(f339 * f29) + f53));
      f54 = Math_fround(f84 + Math_fround(Math_fround(f339 * f30) + f54));
      f55 = Math_fround(f84 + Math_fround(Math_fround(f339 * f31) + f55));
      f56 = Math_fround(f82 + Math_fround(Math_fround(f341 * f28) + f56));
      f57 = Math_fround(f82 + Math_fround(Math_fround(f341 * f29) + f57));
      f58 = Math_fround(f82 + Math_fround(Math_fround(f341 * f30) + f58));
      f27 = Math_fround(f82 + Math_fround(Math_fround(f341 * f31) + f27));
      f497 = Math_fround(HEAPF32[i516 >> 2]);
      f486 = Math_fround(f497 + f36);
      f498 = Math_fround(HEAPF32[i221 >> 2]);
      f487 = Math_fround(f498 + f37);
      f499 = Math_fround(HEAPF32[i222 >> 2]);
      f488 = Math_fround(f499 + f38);
      f500 = Math_fround(HEAPF32[i223 >> 2]);
      f489 = Math_fround(f500 + f39);
      f501 = Math_fround(HEAPF32[i224 >> 2]);
      f490 = Math_fround(f501 + f40);
      f502 = Math_fround(HEAPF32[i225 >> 2]);
      f491 = Math_fround(f502 + f41);
      f503 = Math_fround(HEAPF32[i226 >> 2]);
      f492 = Math_fround(f503 + f42);
      f504 = Math_fround(HEAPF32[i227 >> 2]);
      f493 = Math_fround(f504 + f43);
      f505 = Math_fround(HEAPF32[i228 >> 2]);
      f494 = Math_fround(f505 + f44);
      f506 = Math_fround(HEAPF32[i229 >> 2]);
      f495 = Math_fround(f506 + f45);
      f507 = Math_fround(HEAPF32[i230 >> 2]);
      f496 = Math_fround(f507 + f46);
      f508 = Math_fround(f79 + f47);
      HEAPF32[i523 >> 2] = f486;
      HEAPF32[i232 >> 2] = f487;
      HEAPF32[i233 >> 2] = f488;
      HEAPF32[i234 >> 2] = f489;
      HEAPF32[i235 >> 2] = f490;
      HEAPF32[i236 >> 2] = f491;
      HEAPF32[i237 >> 2] = f492;
      HEAPF32[i238 >> 2] = f493;
      HEAPF32[i239 >> 2] = f494;
      HEAPF32[i240 >> 2] = f495;
      HEAPF32[i241 >> 2] = f496;
      HEAPF32[i242 >> 2] = f508;
      f508 = Math_fround(f498 + f49);
      f496 = Math_fround(f499 + f50);
      f495 = Math_fround(f500 + f51);
      f494 = Math_fround(f501 + f52);
      f493 = Math_fround(f502 + f53);
      f492 = Math_fround(f503 + f54);
      f491 = Math_fround(f504 + f55);
      f490 = Math_fround(f505 + f56);
      f489 = Math_fround(f506 + f57);
      f488 = Math_fround(f507 + f58);
      f487 = Math_fround(f79 + f27);
      HEAPF32[i243 >> 2] = Math_fround(f497 + f48);
      HEAPF32[i244 >> 2] = f508;
      HEAPF32[i245 >> 2] = f496;
      HEAPF32[i246 >> 2] = f495;
      HEAPF32[i247 >> 2] = f494;
      HEAPF32[i248 >> 2] = f493;
      HEAPF32[i249 >> 2] = f492;
      HEAPF32[i250 >> 2] = f491;
      HEAPF32[i251 >> 2] = f490;
      HEAPF32[i252 >> 2] = f489;
      HEAPF32[i253 >> 2] = f488;
      HEAPF32[i254 >> 2] = f487;
      f487 = Math_fround(f498 - f37);
      f488 = Math_fround(f499 - f38);
      f489 = Math_fround(f500 - f39);
      f490 = Math_fround(f501 - f40);
      f491 = Math_fround(f502 - f41);
      f492 = Math_fround(f503 - f42);
      f493 = Math_fround(f504 - f43);
      f494 = Math_fround(f505 - f44);
      f495 = Math_fround(f506 - f45);
      f496 = Math_fround(f507 - f46);
      f508 = Math_fround(f79 - f47);
      HEAPF32[i255 >> 2] = Math_fround(f497 - f36);
      HEAPF32[i256 >> 2] = f487;
      HEAPF32[i257 >> 2] = f488;
      HEAPF32[i258 >> 2] = f489;
      HEAPF32[i259 >> 2] = f490;
      HEAPF32[i260 >> 2] = f491;
      HEAPF32[i261 >> 2] = f492;
      HEAPF32[i262 >> 2] = f493;
      HEAPF32[i263 >> 2] = f494;
      HEAPF32[i264 >> 2] = f495;
      HEAPF32[i265 >> 2] = f496;
      HEAPF32[i266 >> 2] = f508;
      f498 = Math_fround(f498 - f49);
      f499 = Math_fround(f499 - f50);
      f500 = Math_fround(f500 - f51);
      f501 = Math_fround(f501 - f52);
      f502 = Math_fround(f502 - f53);
      f503 = Math_fround(f503 - f54);
      f504 = Math_fround(f504 - f55);
      f505 = Math_fround(f505 - f56);
      f506 = Math_fround(f506 - f57);
      f507 = Math_fround(f507 - f58);
      f508 = Math_fround(f79 - f27);
      HEAPF32[i267 >> 2] = Math_fround(f497 - f48);
      HEAPF32[i268 >> 2] = f498;
      HEAPF32[i269 >> 2] = f499;
      HEAPF32[i270 >> 2] = f500;
      HEAPF32[i271 >> 2] = f501;
      HEAPF32[i272 >> 2] = f502;
      HEAPF32[i273 >> 2] = f503;
      HEAPF32[i274 >> 2] = f504;
      HEAPF32[i275 >> 2] = f505;
      HEAPF32[i276 >> 2] = f506;
      HEAPF32[i277 >> 2] = f507;
      HEAPF32[i278 >> 2] = f508;
      if (!i279) {
       i2 = HEAP32[i482 >> 2] | 0;
       if (i2 & 536870912) {
        f508 = Math_fround(HEAPF32[i83 >> 2]);
        i67 = HEAP32[i514 >> 2] | 0;
        i78 = i67 + 693089735 | 0;
        i65 = HEAP32[i212 >> 2] | 0;
        i75 = i65 + 693089735 | 0;
        i63 = HEAP32[i213 >> 2] | 0;
        i72 = i63 + 693089735 | 0;
        i61 = HEAP32[i214 >> 2] | 0;
        i69 = i61 + 693089735 | 0;
        i62 = (Math_imul(i78, 1790253981) | 0) + 1900727103 | 0;
        i64 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
        i66 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i68 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
        i78 = i78 << 11 ^ i78;
        i75 = i75 << 11 ^ i75;
        i72 = i72 << 11 ^ i72;
        i69 = i69 << 11 ^ i69;
        i62 = Math_fround(Math_fround((i62 ^ i78 ^ i78 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i64 = Math_fround(Math_fround((i64 ^ i75 ^ i75 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i66 = Math_fround(Math_fround((i66 ^ i72 ^ i72 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i68 = Math_fround(Math_fround((i68 ^ i69 ^ i69 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        f508 = Math_fround(HEAPF32[i81 >> 2]);
        i67 = i67 + 13945730 | 0;
        i65 = i65 + 13945730 | 0;
        i63 = i63 + 13945730 | 0;
        i61 = i61 + 13945730 | 0;
        i69 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
        i72 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
        i78 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
        i67 = i67 << 11 ^ i67;
        i65 = i65 << 11 ^ i65;
        i63 = i63 << 11 ^ i63;
        i61 = i61 << 11 ^ i61;
        i69 = Math_fround(Math_fround((i69 ^ i67 ^ i67 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i72 = Math_fround(Math_fround((i72 ^ i65 ^ i65 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i75 = Math_fround(Math_fround((i75 ^ i63 ^ i63 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i78 = Math_fround(Math_fround((i78 ^ i61 ^ i61 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f508;
        i61 = i62 & 1;
        i63 = i64 & 1;
        i65 = i66 & 1;
        i67 = i68 & 1;
        i70 = i61 ^ 1;
        i73 = i63 ^ 1;
        i76 = i65 ^ 1;
        i509 = i67 ^ 1;
        i71 = i62 ? 3 : 2;
        i74 = i64 ? 3 : 2;
        i77 = i66 ? 3 : 2;
        i2 = i68 ? 3 : 2;
        i62 = i62 ? 2 : 3;
        i64 = i64 ? 2 : 3;
        i66 = i66 ? 2 : 3;
        i68 = i68 ? 2 : 3;
        HEAP32[i520 >> 2] = i69 ? i62 : i61;
        HEAP32[i453 >> 2] = i72 ? i64 : i63;
        HEAP32[i452 >> 2] = i75 ? i66 : i65;
        HEAP32[i451 >> 2] = i78 ? i68 : i67;
        HEAP32[i440 >> 2] = i69 ? i61 : i62;
        HEAP32[i439 >> 2] = i72 ? i63 : i64;
        HEAP32[i463 >> 2] = i75 ? i65 : i66;
        HEAP32[i462 >> 2] = i78 ? i67 : i68;
        HEAP32[i457 >> 2] = i69 ? i71 : i70;
        HEAP32[i456 >> 2] = i72 ? i74 : i73;
        HEAP32[i455 >> 2] = i75 ? i77 : i76;
        HEAP32[i454 >> 2] = i78 ? i2 : i509;
        HEAP32[i461 >> 2] = i69 ? i70 : i71;
        HEAP32[i460 >> 2] = i72 ? i73 : i74;
        HEAP32[i459 >> 2] = i75 ? i76 : i77;
        HEAP32[i458 >> 2] = i78 ? i509 : i2;
        i2 = HEAP32[i482 >> 2] | 0;
       }
       if (i2 & 268435456 | 0) {
        f5 = Math_fround(f473 * Math_fround(HEAPF32[i515 >> 2]));
        f6 = Math_fround(f473 * Math_fround(HEAPF32[i216 >> 2]));
        f7 = Math_fround(f473 * Math_fround(HEAPF32[i217 >> 2]));
        f8 = Math_fround(f473 * Math_fround(HEAPF32[i218 >> 2]));
        f9 = Math_fround(Math_floor(Math_fround(f5)));
        f10 = Math_fround(Math_floor(Math_fround(f6)));
        f25 = Math_fround(Math_floor(Math_fround(f7)));
        f26 = Math_fround(Math_floor(Math_fround(f8)));
        if (i2 & 16777216 | 0) {
         f505 = Math_fround(Math_floor(Math_fround(f472 * f9)));
         f506 = Math_fround(Math_floor(Math_fround(f472 * f10)));
         f507 = Math_fround(Math_floor(Math_fround(f472 * f25)));
         f508 = Math_fround(Math_floor(Math_fround(f472 * f26)));
         f501 = Math_fround(f474 * Math_fround(f9 - Math_fround(f471 * f505)));
         f502 = Math_fround(f474 * Math_fround(f10 - Math_fround(f471 * f506)));
         f503 = Math_fround(f474 * Math_fround(f25 - Math_fround(f471 * f507)));
         f504 = Math_fround(f474 * Math_fround(f26 - Math_fround(f471 * f508)));
         f505 = Math_fround(f476 - Math_fround(f475 * f505));
         f506 = Math_fround(f476 - Math_fround(f475 * f506));
         f507 = Math_fround(f476 - Math_fround(f475 * f507));
         f508 = Math_fround(f476 - Math_fround(f475 * f508));
         f493 = Math_fround(f475 + f505);
         f494 = Math_fround(f475 + f506);
         f495 = Math_fround(f475 + f507);
         f496 = Math_fround(f475 + f508);
         HEAPF32[i521 >> 2] = f501;
         HEAPF32[i390 >> 2] = f502;
         HEAPF32[i414 >> 2] = f503;
         HEAPF32[i438 >> 2] = f504;
         HEAPF32[i366 >> 2] = f493;
         HEAPF32[i389 >> 2] = f494;
         HEAPF32[i413 >> 2] = f495;
         HEAPF32[i437 >> 2] = f496;
         f497 = Math_fround(f474 + f501);
         f498 = Math_fround(f474 + f502);
         f499 = Math_fround(f474 + f503);
         f500 = Math_fround(f474 + f504);
         HEAPF32[i365 >> 2] = f497;
         HEAPF32[i388 >> 2] = f498;
         HEAPF32[i412 >> 2] = f499;
         HEAPF32[i436 >> 2] = f500;
         HEAPF32[i364 >> 2] = f493;
         HEAPF32[i387 >> 2] = f494;
         HEAPF32[i411 >> 2] = f495;
         HEAPF32[i435 >> 2] = f496;
         HEAPF32[i363 >> 2] = f497;
         HEAPF32[i386 >> 2] = f498;
         HEAPF32[i410 >> 2] = f499;
         HEAPF32[i434 >> 2] = f500;
         HEAPF32[i362 >> 2] = f505;
         HEAPF32[i385 >> 2] = f506;
         HEAPF32[i409 >> 2] = f507;
         HEAPF32[i433 >> 2] = f508;
         HEAPF32[i361 >> 2] = f501;
         HEAPF32[i384 >> 2] = f502;
         HEAPF32[i408 >> 2] = f503;
         HEAPF32[i432 >> 2] = f504;
         HEAPF32[i360 >> 2] = f505;
         HEAPF32[i383 >> 2] = f506;
         HEAPF32[i407 >> 2] = f507;
         HEAPF32[i431 >> 2] = f508;
        }
        if (i2 & 33554432 | 0) {
         f497 = Math_fround(f9 + Math_fround(1.0));
         f498 = Math_fround(f10 + Math_fround(1.0));
         f499 = Math_fround(f25 + Math_fround(1.0));
         f500 = Math_fround(f26 + Math_fround(1.0));
         f505 = Math_fround(f5 - f9);
         f506 = Math_fround(f6 - f10);
         f507 = Math_fround(f7 - f25);
         f508 = Math_fround(f8 - f26);
         f501 = Math_fround(Math_floor(Math_fround(f472 * f497)));
         f502 = Math_fround(Math_floor(Math_fround(f472 * f498)));
         f503 = Math_fround(Math_floor(Math_fround(f472 * f499)));
         f504 = Math_fround(Math_floor(Math_fround(f472 * f500)));
         f497 = Math_fround(f474 * Math_fround(f497 - Math_fround(f471 * f501)));
         f498 = Math_fround(f474 * Math_fround(f498 - Math_fround(f471 * f502)));
         f499 = Math_fround(f474 * Math_fround(f499 - Math_fround(f471 * f503)));
         f500 = Math_fround(f474 * Math_fround(f500 - Math_fround(f471 * f504)));
         f501 = Math_fround(f476 - Math_fround(f475 * f501));
         f502 = Math_fround(f476 - Math_fround(f475 * f502));
         f503 = Math_fround(f476 - Math_fround(f475 * f503));
         f504 = Math_fround(f476 - Math_fround(f475 * f504));
         f489 = Math_fround(f475 + f501);
         f490 = Math_fround(f475 + f502);
         f491 = Math_fround(f475 + f503);
         f492 = Math_fround(f475 + f504);
         HEAPF32[i522 >> 2] = f497;
         HEAPF32[i382 >> 2] = f498;
         HEAPF32[i406 >> 2] = f499;
         HEAPF32[i430 >> 2] = f500;
         HEAPF32[i359 >> 2] = f489;
         HEAPF32[i381 >> 2] = f490;
         HEAPF32[i405 >> 2] = f491;
         HEAPF32[i429 >> 2] = f492;
         HEAPF32[i358 >> 2] = f505;
         HEAPF32[i380 >> 2] = f506;
         HEAPF32[i404 >> 2] = f507;
         HEAPF32[i428 >> 2] = f508;
         HEAPF32[i357 >> 2] = f5;
         HEAPF32[i379 >> 2] = f6;
         HEAPF32[i403 >> 2] = f7;
         HEAPF32[i427 >> 2] = f8;
         f493 = Math_fround(f474 + f497);
         f494 = Math_fround(f474 + f498);
         f495 = Math_fround(f474 + f499);
         f496 = Math_fround(f474 + f500);
         HEAPF32[i356 >> 2] = f493;
         HEAPF32[i378 >> 2] = f494;
         HEAPF32[i402 >> 2] = f495;
         HEAPF32[i426 >> 2] = f496;
         HEAPF32[i355 >> 2] = f489;
         HEAPF32[i377 >> 2] = f490;
         HEAPF32[i401 >> 2] = f491;
         HEAPF32[i425 >> 2] = f492;
         HEAPF32[i354 >> 2] = f505;
         HEAPF32[i376 >> 2] = f506;
         HEAPF32[i400 >> 2] = f507;
         HEAPF32[i424 >> 2] = f508;
         HEAPF32[i353 >> 2] = f5;
         HEAPF32[i375 >> 2] = f6;
         HEAPF32[i399 >> 2] = f7;
         HEAPF32[i423 >> 2] = f8;
         HEAPF32[i352 >> 2] = f493;
         HEAPF32[i374 >> 2] = f494;
         HEAPF32[i398 >> 2] = f495;
         HEAPF32[i422 >> 2] = f496;
         HEAPF32[i351 >> 2] = f501;
         HEAPF32[i373 >> 2] = f502;
         HEAPF32[i397 >> 2] = f503;
         HEAPF32[i421 >> 2] = f504;
         HEAPF32[i350 >> 2] = f505;
         HEAPF32[i372 >> 2] = f506;
         HEAPF32[i396 >> 2] = f507;
         HEAPF32[i420 >> 2] = f508;
         HEAPF32[i349 >> 2] = f5;
         HEAPF32[i371 >> 2] = f6;
         HEAPF32[i395 >> 2] = f7;
         HEAPF32[i419 >> 2] = f8;
         HEAPF32[i348 >> 2] = f497;
         HEAPF32[i370 >> 2] = f498;
         HEAPF32[i394 >> 2] = f499;
         HEAPF32[i418 >> 2] = f500;
         HEAPF32[i347 >> 2] = f501;
         HEAPF32[i369 >> 2] = f502;
         HEAPF32[i393 >> 2] = f503;
         HEAPF32[i417 >> 2] = f504;
         HEAPF32[i346 >> 2] = f505;
         HEAPF32[i368 >> 2] = f506;
         HEAPF32[i392 >> 2] = f507;
         HEAPF32[i416 >> 2] = f508;
         HEAPF32[i345 >> 2] = f5;
         HEAPF32[i367 >> 2] = f6;
         HEAPF32[i391 >> 2] = f7;
         HEAPF32[i415 >> 2] = f8;
        }
       }
      }
      f493 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
      f494 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
      f495 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
      f496 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f47 * f47) + Math_fround(Math_fround(f39 * f39) + Math_fround(f43 * f43))))));
      f485 = Math_fround(f477 * Math_fround(f36 * f493));
      f486 = Math_fround(f477 * Math_fround(f37 * f494));
      f487 = Math_fround(f477 * Math_fround(f38 * f495));
      f488 = Math_fround(f477 * Math_fround(f39 * f496));
      f489 = Math_fround(f477 * Math_fround(f40 * f493));
      f490 = Math_fround(f477 * Math_fround(f41 * f494));
      f491 = Math_fround(f477 * Math_fround(f42 * f495));
      f492 = Math_fround(f477 * Math_fround(f43 * f496));
      f493 = Math_fround(f477 * Math_fround(f44 * f493));
      f494 = Math_fround(f477 * Math_fround(f45 * f494));
      f495 = Math_fround(f477 * Math_fround(f46 * f495));
      f496 = Math_fround(f477 * Math_fround(f47 * f496));
      f505 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
      f506 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
      f507 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
      f508 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f51 * f51) + Math_fround(f55 * f55))))));
      f497 = Math_fround(f477 * Math_fround(f48 * f505));
      f498 = Math_fround(f477 * Math_fround(f49 * f506));
      f499 = Math_fround(f477 * Math_fround(f50 * f507));
      f500 = Math_fround(f477 * Math_fround(f51 * f508));
      f501 = Math_fround(f477 * Math_fround(f52 * f505));
      f502 = Math_fround(f477 * Math_fround(f53 * f506));
      f503 = Math_fround(f477 * Math_fround(f54 * f507));
      f504 = Math_fround(f477 * Math_fround(f55 * f508));
      f505 = Math_fround(f477 * Math_fround(f56 * f505));
      f506 = Math_fround(f477 * Math_fround(f57 * f506));
      f507 = Math_fround(f477 * Math_fround(f58 * f507));
      f508 = Math_fround(f477 * Math_fround(f27 * f508));
      f484 = Math_fround(f470 + f486);
      f483 = Math_fround(f470 + f487);
      f79 = Math_fround(f470 + f488);
      f58 = Math_fround(f466 + f489);
      f57 = Math_fround(f466 + f490);
      f56 = Math_fround(f466 + f491);
      f55 = Math_fround(f466 + f492);
      f54 = Math_fround(f467 + f493);
      f53 = Math_fround(f467 + f494);
      f52 = Math_fround(f467 + f495);
      f51 = Math_fround(f467 + f496);
      HEAPF32[i524 >> 2] = Math_fround(f470 + f485);
      HEAPF32[i128 >> 2] = f484;
      HEAPF32[i145 >> 2] = f483;
      HEAPF32[i162 >> 2] = f79;
      HEAPF32[i280 >> 2] = f58;
      HEAPF32[i123 >> 2] = f57;
      HEAPF32[i140 >> 2] = f56;
      HEAPF32[i157 >> 2] = f55;
      HEAPF32[i281 >> 2] = f54;
      HEAPF32[i118 >> 2] = f53;
      HEAPF32[i135 >> 2] = f52;
      HEAPF32[i152 >> 2] = f51;
      f51 = Math_fround(f470 + f498);
      f52 = Math_fround(f470 + f499);
      f53 = Math_fround(f470 + f500);
      f54 = Math_fround(f466 + f501);
      f55 = Math_fround(f466 + f502);
      f56 = Math_fround(f466 + f503);
      f57 = Math_fround(f466 + f504);
      f58 = Math_fround(f467 + f505);
      f79 = Math_fround(f467 + f506);
      f483 = Math_fround(f467 + f507);
      f484 = Math_fround(f467 + f508);
      HEAPF32[i282 >> 2] = Math_fround(f470 + f497);
      HEAPF32[i127 >> 2] = f51;
      HEAPF32[i144 >> 2] = f52;
      HEAPF32[i161 >> 2] = f53;
      HEAPF32[i283 >> 2] = f54;
      HEAPF32[i122 >> 2] = f55;
      HEAPF32[i139 >> 2] = f56;
      HEAPF32[i156 >> 2] = f57;
      HEAPF32[i284 >> 2] = f58;
      HEAPF32[i117 >> 2] = f79;
      HEAPF32[i134 >> 2] = f483;
      HEAPF32[i151 >> 2] = f484;
      f486 = Math_fround(f470 - f486);
      f487 = Math_fround(f470 - f487);
      f488 = Math_fround(f470 - f488);
      f489 = Math_fround(f466 - f489);
      f490 = Math_fround(f466 - f490);
      f491 = Math_fround(f466 - f491);
      f492 = Math_fround(f466 - f492);
      f493 = Math_fround(f467 - f493);
      f494 = Math_fround(f467 - f494);
      f495 = Math_fround(f467 - f495);
      f496 = Math_fround(f467 - f496);
      HEAPF32[i285 >> 2] = Math_fround(f470 - f485);
      HEAPF32[i126 >> 2] = f486;
      HEAPF32[i143 >> 2] = f487;
      HEAPF32[i160 >> 2] = f488;
      HEAPF32[i286 >> 2] = f489;
      HEAPF32[i121 >> 2] = f490;
      HEAPF32[i138 >> 2] = f491;
      HEAPF32[i155 >> 2] = f492;
      HEAPF32[i287 >> 2] = f493;
      HEAPF32[i116 >> 2] = f494;
      HEAPF32[i133 >> 2] = f495;
      HEAPF32[i150 >> 2] = f496;
      f498 = Math_fround(f470 - f498);
      f499 = Math_fround(f470 - f499);
      f500 = Math_fround(f470 - f500);
      f501 = Math_fround(f466 - f501);
      f502 = Math_fround(f466 - f502);
      f503 = Math_fround(f466 - f503);
      f504 = Math_fround(f466 - f504);
      f505 = Math_fround(f467 - f505);
      f506 = Math_fround(f467 - f506);
      f507 = Math_fround(f467 - f507);
      f508 = Math_fround(f467 - f508);
      HEAPF32[i288 >> 2] = Math_fround(f470 - f497);
      HEAPF32[i125 >> 2] = f498;
      HEAPF32[i142 >> 2] = f499;
      HEAPF32[i159 >> 2] = f500;
      HEAPF32[i289 >> 2] = f501;
      HEAPF32[i120 >> 2] = f502;
      HEAPF32[i137 >> 2] = f503;
      HEAPF32[i154 >> 2] = f504;
      HEAPF32[i290 >> 2] = f505;
      HEAPF32[i115 >> 2] = f506;
      HEAPF32[i132 >> 2] = f507;
      HEAPF32[i149 >> 2] = f508;
      do if (i166) {
       i4 = HEAP32[i188 >> 2] | 0;
       i11 = HEAP32[i527 >> 2] | 0;
       if (!i4) {
        i2 = 0;
        i3 = i1;
        while (1) {
         i509 = i11 + (i2 + i80 << 2) | 0;
         HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
         HEAP32[i3 + 24 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 28 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 32 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 36 >> 2] = HEAP32[i243 + (i2 << 2) >> 2];
         HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
         HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
         HEAP32[i3 + 48 >> 2] = HEAP32[i282 + (i2 << 2) >> 2];
         HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
         HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
         HEAP32[i3 + 60 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 64 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 68 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 72 >> 2] = HEAP32[i255 + (i2 << 2) >> 2];
         HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
         HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
         HEAP32[i3 + 84 >> 2] = HEAP32[i285 + (i2 << 2) >> 2];
         HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
         HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
         HEAP32[i3 + 96 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 100 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 104 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 108 >> 2] = HEAP32[i267 + (i2 << 2) >> 2];
         HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
         HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
         HEAP32[i3 + 120 >> 2] = HEAP32[i288 + (i2 << 2) >> 2];
         HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
         HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
         HEAP32[i3 + 132 >> 2] = HEAP32[i509 >> 2];
         i509 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 136 >> 2] = HEAP32[i509 + (i2 << 2) >> 2];
         HEAP32[i3 + 140 >> 2] = HEAP32[i509 + 16 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
        }
        i1 = i1 + 576 | 0;
        break;
       } else {
        i2 = 0;
        i3 = i1;
        while (1) {
         i509 = i11 + (HEAP32[i4 + (i2 + i80 << 3) >> 2] << 2) | 0;
         HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
         HEAP32[i3 + 24 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 28 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 32 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 36 >> 2] = HEAP32[i243 + (i2 << 2) >> 2];
         HEAP32[i3 + 40 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
         HEAP32[i3 + 44 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
         HEAP32[i3 + 48 >> 2] = HEAP32[i282 + (i2 << 2) >> 2];
         HEAP32[i3 + 52 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
         HEAP32[i3 + 56 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
         HEAP32[i3 + 60 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 64 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 68 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 72 >> 2] = HEAP32[i255 + (i2 << 2) >> 2];
         HEAP32[i3 + 76 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
         HEAP32[i3 + 80 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
         HEAP32[i3 + 84 >> 2] = HEAP32[i285 + (i2 << 2) >> 2];
         HEAP32[i3 + 88 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
         HEAP32[i3 + 92 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
         HEAP32[i3 + 96 >> 2] = HEAP32[i509 >> 2];
         i78 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 100 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
         HEAP32[i3 + 104 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
         HEAP32[i3 + 108 >> 2] = HEAP32[i267 + (i2 << 2) >> 2];
         HEAP32[i3 + 112 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
         HEAP32[i3 + 116 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
         HEAP32[i3 + 120 >> 2] = HEAP32[i288 + (i2 << 2) >> 2];
         HEAP32[i3 + 124 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
         HEAP32[i3 + 128 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
         HEAP32[i3 + 132 >> 2] = HEAP32[i509 >> 2];
         i509 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
         HEAP32[i3 + 136 >> 2] = HEAP32[i509 + (i2 << 2) >> 2];
         HEAP32[i3 + 140 >> 2] = HEAP32[i509 + 16 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
        }
        i1 = i1 + 576 | 0;
        break;
       }
      } else {
       f496 = Math_fround(HEAPF32[i243 >> 2]);
       f496 = Math_fround(f496 - Math_fround(HEAPF32[i523 >> 2]));
       f498 = Math_fround(HEAPF32[i244 >> 2]);
       f498 = Math_fround(f498 - Math_fround(HEAPF32[i232 >> 2]));
       f499 = Math_fround(HEAPF32[i245 >> 2]);
       f499 = Math_fround(f499 - Math_fround(HEAPF32[i233 >> 2]));
       f500 = Math_fround(HEAPF32[i246 >> 2]);
       f500 = Math_fround(f500 - Math_fround(HEAPF32[i234 >> 2]));
       f501 = Math_fround(HEAPF32[i247 >> 2]);
       f501 = Math_fround(f501 - Math_fround(HEAPF32[i235 >> 2]));
       f508 = Math_fround(HEAPF32[i248 >> 2]);
       f508 = Math_fround(f508 - Math_fround(HEAPF32[i236 >> 2]));
       f507 = Math_fround(HEAPF32[i249 >> 2]);
       f507 = Math_fround(f507 - Math_fround(HEAPF32[i237 >> 2]));
       f506 = Math_fround(HEAPF32[i250 >> 2]);
       f506 = Math_fround(f506 - Math_fround(HEAPF32[i238 >> 2]));
       f505 = Math_fround(HEAPF32[i251 >> 2]);
       f505 = Math_fround(f505 - Math_fround(HEAPF32[i239 >> 2]));
       f493 = Math_fround(HEAPF32[i252 >> 2]);
       f493 = Math_fround(f493 - Math_fround(HEAPF32[i240 >> 2]));
       f494 = Math_fround(HEAPF32[i253 >> 2]);
       f494 = Math_fround(f494 - Math_fround(HEAPF32[i241 >> 2]));
       f495 = Math_fround(HEAPF32[i254 >> 2]);
       f495 = Math_fround(f495 - Math_fround(HEAPF32[i242 >> 2]));
       f497 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f496 * f496) + Math_fround(f501 * f501)) + Math_fround(f505 * f505)))));
       f504 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f498 * f498) + Math_fround(f508 * f508)) + Math_fround(f493 * f493)))));
       f503 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f499 * f499) + Math_fround(f507 * f507)) + Math_fround(f494 * f494)))));
       f502 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f500 * f500) + Math_fround(f506 * f506)) + Math_fround(f495 * f495)))));
       f498 = Math_fround(f498 * f504);
       f499 = Math_fround(f499 * f503);
       f500 = Math_fround(f500 * f502);
       f501 = Math_fround(f501 * f497);
       f508 = Math_fround(f508 * f504);
       f507 = Math_fround(f507 * f503);
       f506 = Math_fround(f506 * f502);
       f505 = Math_fround(f505 * f497);
       f504 = Math_fround(f493 * f504);
       f503 = Math_fround(f494 * f503);
       f502 = Math_fround(f495 * f502);
       HEAPF32[i517 >> 2] = Math_fround(f496 * f497);
       HEAPF32[i129 >> 2] = f498;
       HEAPF32[i146 >> 2] = f499;
       HEAPF32[i163 >> 2] = f500;
       HEAPF32[i291 >> 2] = f501;
       HEAPF32[i124 >> 2] = f508;
       HEAPF32[i141 >> 2] = f507;
       HEAPF32[i158 >> 2] = f506;
       HEAPF32[i292 >> 2] = f505;
       HEAPF32[i119 >> 2] = f504;
       HEAPF32[i136 >> 2] = f503;
       HEAPF32[i153 >> 2] = f502;
       f502 = Math_fround(f29 * Math_fround(2.0));
       f503 = Math_fround(f30 * Math_fround(2.0));
       f504 = Math_fround(f31 * Math_fround(2.0));
       f505 = Math_fround(f32 * Math_fround(2.0));
       f506 = Math_fround(f33 * Math_fround(2.0));
       f507 = Math_fround(f34 * Math_fround(2.0));
       f508 = Math_fround(f35 * Math_fround(2.0));
       HEAPF32[i518 >> 2] = Math_fround(f28 * Math_fround(2.0));
       HEAPF32[i131 >> 2] = f502;
       HEAPF32[i148 >> 2] = f503;
       HEAPF32[i165 >> 2] = f504;
       HEAPF32[i293 >> 2] = f505;
       HEAPF32[i130 >> 2] = f506;
       HEAPF32[i147 >> 2] = f507;
       HEAPF32[i164 >> 2] = f508;
       HEAP32[i114 >> 2] = 0;
       HEAP32[i114 + 4 >> 2] = 0;
       HEAP32[i114 + 8 >> 2] = 0;
       HEAP32[i114 + 12 >> 2] = 0;
       if (i294) {
        f488 = Math_fround(HEAPF32[i529 >> 2]);
        f506 = Math_fround(f343 * f488);
        f490 = Math_fround(HEAPF32[i181 >> 2]);
        f497 = Math_fround(f343 * f490);
        f492 = Math_fround(HEAPF32[i180 >> 2]);
        f505 = Math_fround(f343 * f492);
        f494 = Math_fround(HEAPF32[i179 >> 2]);
        f500 = Math_fround(f343 * f494);
        f489 = Math_fround(HEAPF32[i197 >> 2]);
        f496 = Math_fround(f442 * f489);
        f491 = Math_fround(HEAPF32[i184 >> 2]);
        f502 = Math_fround(f442 * f491);
        f493 = Math_fround(HEAPF32[i183 >> 2]);
        f501 = Math_fround(f442 * f493);
        f495 = Math_fround(HEAPF32[i182 >> 2]);
        f496 = Math_fround(f506 + f496);
        f502 = Math_fround(f497 + f502);
        f501 = Math_fround(f505 + f501);
        f500 = Math_fround(f500 + Math_fround(f442 * f495));
        f505 = Math_fround(HEAPF32[i198 >> 2]);
        f497 = Math_fround(f445 * f505);
        f506 = Math_fround(HEAPF32[i187 >> 2]);
        f498 = Math_fround(f445 * f506);
        f507 = Math_fround(HEAPF32[i186 >> 2]);
        f499 = Math_fround(f445 * f507);
        f508 = Math_fround(HEAPF32[i185 >> 2]);
        f498 = Math_fround(f502 + f498);
        f499 = Math_fround(f501 + f499);
        f500 = Math_fround(f500 + Math_fround(f445 * f508));
        f501 = Math_fround(Math_fround(Math_fround(f344 * f488) + Math_fround(f443 * f489)) + Math_fround(f446 * f505));
        f502 = Math_fround(Math_fround(Math_fround(f344 * f490) + Math_fround(f443 * f491)) + Math_fround(f446 * f506));
        f503 = Math_fround(Math_fround(Math_fround(f344 * f492) + Math_fround(f443 * f493)) + Math_fround(f446 * f507));
        f504 = Math_fround(Math_fround(Math_fround(f344 * f494) + Math_fround(f443 * f495)) + Math_fround(f446 * f508));
        f505 = Math_fround(Math_fround(Math_fround(f441 * f488) + Math_fround(f444 * f489)) + Math_fround(f447 * f505));
        f506 = Math_fround(Math_fround(Math_fround(f441 * f490) + Math_fround(f444 * f491)) + Math_fround(f447 * f506));
        f507 = Math_fround(Math_fround(Math_fround(f441 * f492) + Math_fround(f444 * f493)) + Math_fround(f447 * f507));
        f508 = Math_fround(Math_fround(Math_fround(f441 * f494) + Math_fround(f444 * f495)) + Math_fround(f447 * f508));
        HEAPF32[i519 >> 2] = Math_fround(f496 + f497);
        HEAPF32[i295 >> 2] = f498;
        HEAPF32[i296 >> 2] = f499;
        HEAPF32[i297 >> 2] = f500;
        HEAPF32[i298 >> 2] = f501;
        HEAPF32[i299 >> 2] = f502;
        HEAPF32[i300 >> 2] = f503;
        HEAPF32[i301 >> 2] = f504;
        HEAPF32[i302 >> 2] = f505;
        HEAPF32[i303 >> 2] = f506;
        HEAPF32[i304 >> 2] = f507;
        HEAPF32[i305 >> 2] = f508;
       }
       if (i306) {
        i73 = HEAP32[i514 >> 2] | 0;
        i76 = i73 + 1068538453 | 0;
        i77 = HEAP32[i212 >> 2] | 0;
        i75 = i77 + 1068538453 | 0;
        i70 = HEAP32[i213 >> 2] | 0;
        i69 = i70 + 1068538453 | 0;
        i68 = HEAP32[i214 >> 2] | 0;
        i72 = i68 + 1068538453 | 0;
        i78 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
        i71 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
        i509 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
        i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i76 = i76 << 11 ^ i76;
        i75 = i75 << 11 ^ i75;
        i69 = i69 << 11 ^ i69;
        i72 = i72 << 11 ^ i72;
        f506 = Math_fround(Math_fround((i71 ^ i75 ^ i75 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f507 = Math_fround(Math_fround((i509 ^ i69 ^ i69 >>> 8) & 8388607 ^ i509 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f508 = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i525 >> 2] = Math_fround(Math_fround((i78 ^ i76 ^ i76 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i307 >> 2] = f506;
        HEAPF32[i308 >> 2] = f507;
        HEAPF32[i309 >> 2] = f508;
        i73 = i73 + 1068538454 | 0;
        i77 = i77 + 1068538454 | 0;
        i70 = i70 + 1068538454 | 0;
        i68 = i68 + 1068538454 | 0;
        i78 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
        i76 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
        i74 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
        i72 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
        i73 = i73 << 11 ^ i73;
        i77 = i77 << 11 ^ i77;
        i70 = i70 << 11 ^ i70;
        i68 = i68 << 11 ^ i68;
        f508 = Math_fround(Math_fround((i76 ^ i77 ^ i77 >>> 8) & 8388607 ^ i76 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f507 = Math_fround(Math_fround((i74 ^ i70 ^ i70 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f506 = Math_fround(Math_fround((i72 ^ i68 ^ i68 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i310 >> 2] = Math_fround(Math_fround((i78 ^ i73 ^ i73 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i311 >> 2] = f508;
        HEAPF32[i312 >> 2] = f507;
        HEAPF32[i313 >> 2] = f506;
        i78 = HEAP32[i514 >> 2] | 0;
        i73 = i78 + 1068538455 | 0;
        i72 = HEAP32[i212 >> 2] | 0;
        i68 = i72 + 1068538455 | 0;
        i74 = HEAP32[i213 >> 2] | 0;
        i70 = i74 + 1068538455 | 0;
        i76 = HEAP32[i214 >> 2] | 0;
        i77 = i76 + 1068538455 | 0;
        i509 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
        i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
        i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
        i73 = i73 << 11 ^ i73;
        i68 = i68 << 11 ^ i68;
        i70 = i70 << 11 ^ i70;
        i77 = i77 << 11 ^ i77;
        f506 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f507 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f508 = Math_fround(Math_fround((i75 ^ i77 ^ i77 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i314 >> 2] = Math_fround(Math_fround((i509 ^ i73 ^ i73 >>> 8) & 8388607 ^ i509 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i315 >> 2] = f506;
        HEAPF32[i316 >> 2] = f507;
        HEAPF32[i317 >> 2] = f508;
        f508 = Math_fround(Math_fround(HEAPF32[i513 >> 2]) * Math_fround(1.0e5));
        f507 = Math_fround(Math_fround(HEAPF32[i208 >> 2]) * Math_fround(1.0e5));
        f506 = Math_fround(Math_fround(HEAPF32[i209 >> 2]) * Math_fround(1.0e5));
        i78 = i78 + 1068538453 + ~~f508 | 0;
        i72 = i72 + 1068538453 + ~~f507 | 0;
        i74 = i74 + 1068538453 + ~~f506 | 0;
        i76 = i76 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i210 >> 2]) * Math_fround(1.0e5)) | 0;
        i509 = (Math_imul(i78, 1790253981) | 0) + 1900727103 | 0;
        i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
        i75 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
        i77 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
        i78 = i78 << 11 ^ i78;
        i72 = i72 << 11 ^ i72;
        i74 = i74 << 11 ^ i74;
        i76 = i76 << 11 ^ i76;
        f506 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f507 = Math_fround(Math_fround((i75 ^ i74 ^ i74 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
        f508 = Math_fround(Math_fround((i77 ^ i76 ^ i76 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i318 >> 2] = Math_fround(Math_fround((i509 ^ i78 ^ i78 >>> 8) & 8388607 ^ i509 >>> 19 | 0) * Math_fround(1.19209304e-07));
        HEAPF32[i319 >> 2] = f506;
        HEAPF32[i320 >> 2] = f507;
        HEAPF32[i321 >> 2] = f508;
       }
       i69 = HEAP32[i188 >> 2] | 0;
       i70 = (i69 | 0) == 0;
       i71 = HEAP32[i90 >> 2] | 0;
       i72 = HEAP32[i92 >> 2] | 0;
       i73 = HEAP32[i207 >> 2] | 0;
       i74 = HEAP32[i93 >> 2] | 0;
       i75 = HEAP32[i334 >> 2] | 0;
       i76 = HEAP32[i335 >> 2] | 0;
       i77 = HEAP32[i336 >> 2] | 0;
       i78 = HEAP32[i527 >> 2] | 0;
       i68 = 0;
       do {
        i2 = i68 + i80 | 0;
        if (!i70) i2 = HEAP32[i69 + (i2 << 3) >> 2] | 0;
        i11 = i519 + (i68 << 2) | 0;
        i12 = i329 + (i68 << 2) | 0;
        i13 = i330 + (i68 << 2) | 0;
        i14 = i525 + (i68 << 2) | 0;
        i15 = i310 + (i68 << 2) | 0;
        i16 = i314 + (i68 << 2) | 0;
        i17 = i318 + (i68 << 2) | 0;
        i18 = i517 + (i68 << 2) | 0;
        i19 = i87 + (i68 << 2) | 0;
        i20 = i88 + (i68 << 2) | 0;
        i21 = i71 + (i2 << 4) | 0;
        i22 = i72 + (i2 << 4) | 0;
        i23 = i73 + (i2 << 2) | 0;
        i24 = i74 + (i2 << 2) | 0;
        i59 = i75 + (i2 << 2) | 0;
        i60 = i76 + (i2 << 2) | 0;
        i61 = i77 + (i2 << 2) | 0;
        i62 = i518 + (i68 << 2) | 0;
        i63 = i94 + (i68 << 2) | 0;
        i64 = i95 + (i68 << 2) | 0;
        i65 = i516 + (i68 << 2) | 0;
        i66 = i96 + (i68 << 2) | 0;
        i67 = i97 + (i68 << 2) | 0;
        i4 = i78 + (i2 << 2) | 0;
        i3 = 0;
        i2 = i1;
        while (1) {
         i1 = i523 + (i3 * 48 | 0) | 0;
         HEAP32[i2 >> 2] = HEAP32[i1 + (i68 << 2) >> 2];
         HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i68 << 2) >> 2];
         HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i68 << 2) >> 2];
         i1 = i2 + 12 | 0;
         if (!i322) {
          i509 = i524 + (i3 * 48 | 0) | 0;
          HEAP32[i1 >> 2] = HEAP32[i509 + (i68 << 2) >> 2];
          HEAP32[i2 + 16 >> 2] = HEAP32[i509 + 16 + (i68 << 2) >> 2];
          HEAP32[i2 + 20 >> 2] = HEAP32[i509 + 32 + (i68 << 2) >> 2];
          i1 = i2 + 24 | 0;
         }
         if (!i323) {
          HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
          i1 = i1 + 4 | 0;
         }
         if (!i324) {
          i509 = i521 + (HEAP32[i520 + ((i3 << 2) + i68 << 2) >> 2] << 5) | 0;
          HEAP32[i1 >> 2] = HEAP32[i509 + (i68 << 2) >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i509 + 16 + (i68 << 2) >> 2];
          i1 = i1 + 8 | 0;
         }
         if (!i325) {
          i509 = i522 + (HEAP32[i520 + ((i3 << 2) + i68 << 2) >> 2] << 6) | 0;
          HEAP32[i1 >> 2] = HEAP32[i509 + (i68 << 2) >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i509 + 16 + (i68 << 2) >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i509 + 32 + (i68 << 2) >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i509 + 48 + (i68 << 2) >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i326) {
          f508 = Math_fround(i3 | 0);
          HEAP32[i1 >> 2] = HEAP32[i65 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i66 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i67 >> 2];
          HEAPF32[i1 + 12 >> 2] = f508;
          i1 = i1 + 16 | 0;
         }
         if (!i327) {
          HEAP32[i1 >> 2] = HEAP32[i62 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i63 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i64 >> 2];
          i1 = i1 + 12 | 0;
         }
         if (!i328) {
          i2 = HEAP32[i60 >> 2] | 0;
          i509 = HEAP32[i61 >> 2] | 0;
          HEAP32[i1 >> 2] = HEAP32[i59 >> 2];
          HEAP32[i1 + 4 >> 2] = i2;
          HEAP32[i1 + 8 >> 2] = i509;
          i1 = i1 + 12 | 0;
         }
         if (i294) {
          HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
          i1 = i1 + 12 | 0;
         }
         if (!i331) {
          f508 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
          i509 = HEAP32[i24 >> 2] | 0;
          HEAPF32[i1 >> 2] = f508;
          HEAP32[i1 + 4 >> 2] = i509;
          i1 = i1 + 8 | 0;
         }
         if (!i332) {
          i509 = (HEAP32[i91 >> 2] & 2147483647 | 0) == 0 ? i510 : i22;
          HEAP32[i1 >> 2] = HEAP32[i509 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i509 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i509 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i509 + 12 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i333) {
          i509 = (HEAP32[i89 >> 2] & 2147483647 | 0) == 0 ? i510 : i21;
          HEAP32[i1 >> 2] = HEAP32[i509 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i509 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i509 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i509 + 12 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (i306) {
          HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
          i1 = i1 + 16 | 0;
         }
         if (!i86) {
          HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
          HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
          i1 = i1 + 16 | 0;
         }
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == 4) break; else i2 = i1;
        }
        i68 = i68 + 1 | 0;
       } while ((i68 | 0) != 4);
      } while (0);
      i80 = i80 + 4 | 0;
     } while (i80 >>> 0 < i167 >>> 0);
    }
   } while (0);
   STACKTOP = i530;
   return;
  }
 case 1:
  {
   i11 = HEAP32[i1 + 32 >> 2] | 0;
   i458 = i13 + 332 | 0;
   f488 = Math_fround((HEAP32[i458 >> 2] & 4095) >>> 0);
   f489 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f490 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f491 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   f5 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   i3 = i13 + 420 | 0;
   f10 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f492 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i4 = i13 + 408 | 0;
   f484 = Math_fround(HEAPF32[i4 >> 2]);
   f473 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f475 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   i4 = i13 + 336 | 0;
   f493 = Math_fround(HEAPF32[i4 >> 2]);
   f494 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f495 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f496 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   i4 = i13 + 352 | 0;
   f483 = Math_fround(HEAPF32[i4 >> 2]);
   f472 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i4 = i13 + 360 | 0;
   f481 = Math_fround(HEAPF32[i4 >> 2]);
   f471 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i4 = HEAP32[i2 + 56 >> 2] | 0;
   f497 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f498 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f499 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f500 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f501 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f502 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f503 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f504 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f505 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f506 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f507 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f508 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   f487 = Math_fround(HEAPF32[i13 + 192 >> 2]);
   f479 = Math_fround(HEAPF32[i13 + 196 >> 2]);
   f480 = Math_fround(HEAPF32[i13 + 200 >> 2]);
   f486 = Math_fround(HEAPF32[i13 + 208 >> 2]);
   f477 = Math_fround(HEAPF32[i13 + 212 >> 2]);
   f478 = Math_fround(HEAPF32[i13 + 216 >> 2]);
   f485 = Math_fround(HEAPF32[i13 + 224 >> 2]);
   f474 = Math_fround(HEAPF32[i13 + 228 >> 2]);
   f476 = Math_fround(HEAPF32[i13 + 232 >> 2]);
   i1 = i13 + 64 | 0;
   f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 320 >> 2]);
   f470 = Math_fround(f7 * Math_fround(HEAPF32[i13 + 324 >> 2]));
   f9 = Math_fround(f7 * Math_fround(HEAPF32[i13 + 328 >> 2]));
   f470 = Math_fround(f10 * f470);
   i433 = i520 + 12 | 0;
   i434 = i520 + 8 | 0;
   i435 = i520 + 4 | 0;
   i436 = i520 + 28 | 0;
   HEAP32[i520 >> 2] = 0;
   HEAP32[i520 + 4 >> 2] = 0;
   HEAP32[i520 + 8 >> 2] = 0;
   HEAP32[i520 + 12 >> 2] = 0;
   HEAP32[i436 >> 2] = 1;
   i437 = i520 + 24 | 0;
   HEAP32[i437 >> 2] = 1;
   i438 = i520 + 20 | 0;
   HEAP32[i438 >> 2] = 1;
   i439 = i520 + 16 | 0;
   HEAP32[i439 >> 2] = 1;
   i440 = i520 + 44 | 0;
   HEAP32[i440 >> 2] = 2;
   i451 = i520 + 40 | 0;
   HEAP32[i451 >> 2] = 2;
   i452 = i520 + 36 | 0;
   HEAP32[i452 >> 2] = 2;
   i453 = i520 + 32 | 0;
   HEAP32[i453 >> 2] = 2;
   i454 = i520 + 60 | 0;
   HEAP32[i454 >> 2] = 3;
   i455 = i520 + 56 | 0;
   HEAP32[i455 >> 2] = 3;
   i456 = i520 + 52 | 0;
   HEAP32[i456 >> 2] = 3;
   i457 = i520 + 48 | 0;
   HEAP32[i457 >> 2] = 3;
   i384 = i521 + 4 | 0;
   i408 = i521 + 8 | 0;
   i432 = i521 + 12 | 0;
   i360 = i521 + 16 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAPF32[i360 >> 2] = Math_fround(1.0);
   i383 = i521 + 20 | 0;
   HEAPF32[i383 >> 2] = Math_fround(1.0);
   i407 = i521 + 24 | 0;
   HEAPF32[i407 >> 2] = Math_fround(1.0);
   i431 = i521 + 28 | 0;
   HEAPF32[i431 >> 2] = Math_fround(1.0);
   i359 = i521 + 32 | 0;
   HEAPF32[i359 >> 2] = Math_fround(1.0);
   i382 = i521 + 36 | 0;
   HEAPF32[i382 >> 2] = Math_fround(1.0);
   i406 = i521 + 40 | 0;
   HEAPF32[i406 >> 2] = Math_fround(1.0);
   i430 = i521 + 44 | 0;
   HEAPF32[i430 >> 2] = Math_fround(1.0);
   i358 = i521 + 48 | 0;
   HEAPF32[i358 >> 2] = Math_fround(1.0);
   i381 = i521 + 52 | 0;
   HEAPF32[i381 >> 2] = Math_fround(1.0);
   i405 = i521 + 56 | 0;
   HEAPF32[i405 >> 2] = Math_fround(1.0);
   i429 = i521 + 60 | 0;
   HEAPF32[i429 >> 2] = Math_fround(1.0);
   i357 = i521 + 64 | 0;
   HEAPF32[i357 >> 2] = Math_fround(1.0);
   i380 = i521 + 68 | 0;
   HEAPF32[i380 >> 2] = Math_fround(1.0);
   i404 = i521 + 72 | 0;
   HEAPF32[i404 >> 2] = Math_fround(1.0);
   i428 = i521 + 76 | 0;
   HEAPF32[i428 >> 2] = Math_fround(1.0);
   i356 = i521 + 80 | 0;
   i379 = i521 + 84 | 0;
   i403 = i521 + 88 | 0;
   i427 = i521 + 92 | 0;
   i355 = i521 + 96 | 0;
   i378 = i521 + 100 | 0;
   i402 = i521 + 104 | 0;
   i426 = i521 + 108 | 0;
   i354 = i521 + 112 | 0;
   i377 = i521 + 116 | 0;
   i401 = i521 + 120 | 0;
   i425 = i521 + 124 | 0;
   i16 = i356;
   i15 = i16 + 48 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i376 = i522 + 4 | 0;
   i400 = i522 + 8 | 0;
   i424 = i522 + 12 | 0;
   i353 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i353 >> 2] = Math_fround(1.0);
   i375 = i522 + 20 | 0;
   HEAPF32[i375 >> 2] = Math_fround(1.0);
   i399 = i522 + 24 | 0;
   HEAPF32[i399 >> 2] = Math_fround(1.0);
   i423 = i522 + 28 | 0;
   HEAPF32[i423 >> 2] = Math_fround(1.0);
   i352 = i522 + 32 | 0;
   i374 = i522 + 36 | 0;
   i398 = i522 + 40 | 0;
   i422 = i522 + 44 | 0;
   i351 = i522 + 48 | 0;
   i373 = i522 + 52 | 0;
   i397 = i522 + 56 | 0;
   i421 = i522 + 60 | 0;
   i350 = i522 + 64 | 0;
   HEAP32[i352 >> 2] = 0;
   HEAP32[i352 + 4 >> 2] = 0;
   HEAP32[i352 + 8 >> 2] = 0;
   HEAP32[i352 + 12 >> 2] = 0;
   HEAP32[i352 + 16 >> 2] = 0;
   HEAP32[i352 + 20 >> 2] = 0;
   HEAP32[i352 + 24 >> 2] = 0;
   HEAP32[i352 + 28 >> 2] = 0;
   HEAPF32[i350 >> 2] = Math_fround(1.0);
   i372 = i522 + 68 | 0;
   HEAPF32[i372 >> 2] = Math_fround(1.0);
   i396 = i522 + 72 | 0;
   HEAPF32[i396 >> 2] = Math_fround(1.0);
   i420 = i522 + 76 | 0;
   HEAPF32[i420 >> 2] = Math_fround(1.0);
   i349 = i522 + 80 | 0;
   HEAPF32[i349 >> 2] = Math_fround(1.0);
   i371 = i522 + 84 | 0;
   HEAPF32[i371 >> 2] = Math_fround(1.0);
   i395 = i522 + 88 | 0;
   HEAPF32[i395 >> 2] = Math_fround(1.0);
   i419 = i522 + 92 | 0;
   HEAPF32[i419 >> 2] = Math_fround(1.0);
   i348 = i522 + 96 | 0;
   i370 = i522 + 100 | 0;
   i394 = i522 + 104 | 0;
   i418 = i522 + 108 | 0;
   i347 = i522 + 112 | 0;
   i369 = i522 + 116 | 0;
   i393 = i522 + 120 | 0;
   i417 = i522 + 124 | 0;
   i346 = i522 + 128 | 0;
   HEAP32[i348 >> 2] = 0;
   HEAP32[i348 + 4 >> 2] = 0;
   HEAP32[i348 + 8 >> 2] = 0;
   HEAP32[i348 + 12 >> 2] = 0;
   HEAP32[i348 + 16 >> 2] = 0;
   HEAP32[i348 + 20 >> 2] = 0;
   HEAP32[i348 + 24 >> 2] = 0;
   HEAP32[i348 + 28 >> 2] = 0;
   HEAPF32[i346 >> 2] = Math_fround(1.0);
   i368 = i522 + 132 | 0;
   HEAPF32[i368 >> 2] = Math_fround(1.0);
   i392 = i522 + 136 | 0;
   HEAPF32[i392 >> 2] = Math_fround(1.0);
   i416 = i522 + 140 | 0;
   HEAPF32[i416 >> 2] = Math_fround(1.0);
   i345 = i522 + 144 | 0;
   i367 = i522 + 148 | 0;
   i391 = i522 + 152 | 0;
   i415 = i522 + 156 | 0;
   i336 = i522 + 160 | 0;
   i366 = i522 + 164 | 0;
   i390 = i522 + 168 | 0;
   i414 = i522 + 172 | 0;
   i335 = i522 + 176 | 0;
   i365 = i522 + 180 | 0;
   i389 = i522 + 184 | 0;
   i413 = i522 + 188 | 0;
   i334 = i522 + 192 | 0;
   i364 = i522 + 196 | 0;
   i388 = i522 + 200 | 0;
   i412 = i522 + 204 | 0;
   i333 = i522 + 208 | 0;
   i363 = i522 + 212 | 0;
   i387 = i522 + 216 | 0;
   i411 = i522 + 220 | 0;
   i332 = i522 + 224 | 0;
   i362 = i522 + 228 | 0;
   i386 = i522 + 232 | 0;
   i410 = i522 + 236 | 0;
   i331 = i522 + 240 | 0;
   i361 = i522 + 244 | 0;
   i385 = i522 + 248 | 0;
   i409 = i522 + 252 | 0;
   i16 = i345;
   i15 = i16 + 112 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i16 = i12;
   i15 = i16 + 64 | 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
    i16 = i16 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   f338 = Math_fround(HEAPF32[i12 >> 2]);
   f339 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f340 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f341 = Math_fround(HEAPF32[i12 + 16 >> 2]);
   f342 = Math_fround(HEAPF32[i12 + 20 >> 2]);
   f343 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   f344 = Math_fround(HEAPF32[i12 + 32 >> 2]);
   f441 = Math_fround(HEAPF32[i12 + 36 >> 2]);
   f442 = Math_fround(HEAPF32[i12 + 40 >> 2]);
   f443 = Math_fround(HEAPF32[i12 + 48 >> 2]);
   f444 = Math_fround(HEAPF32[i12 + 52 >> 2]);
   f445 = Math_fround(HEAPF32[i12 + 56 >> 2]);
   __Z25InvertMatrix4x4_General3DPKfPf(i12, i14) | 0;
   f446 = Math_fround(HEAPF32[i14 >> 2]);
   f447 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f448 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f449 = Math_fround(HEAPF32[i14 + 16 >> 2]);
   f450 = Math_fround(HEAPF32[i14 + 20 >> 2]);
   f464 = Math_fround(HEAPF32[i14 + 24 >> 2]);
   f465 = Math_fround(HEAPF32[i14 + 32 >> 2]);
   f466 = Math_fround(HEAPF32[i14 + 36 >> 2]);
   f467 = Math_fround(HEAPF32[i14 + 40 >> 2]);
   f468 = Math_fround(HEAPF32[i14 + 48 >> 2]);
   f469 = Math_fround(HEAPF32[i14 + 52 >> 2]);
   f337 = Math_fround(HEAPF32[i14 + 56 >> 2]);
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i510, i12);
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   f48 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f55 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f50 = Math_fround(HEAPF32[i510 >> 2]);
   i459 = i510 + 4 | 0;
   f46 = Math_fround(HEAPF32[i459 >> 2]);
   i460 = i510 + 8 | 0;
   f84 = Math_fround(HEAPF32[i460 >> 2]);
   i461 = i510 + 12 | 0;
   f52 = Math_fround(HEAPF32[i461 >> 2]);
   i462 = i510 + 16 | 0;
   f47 = Math_fround(HEAPF32[i462 >> 2]);
   i463 = i510 + 20 | 0;
   f85 = Math_fround(HEAPF32[i463 >> 2]);
   i482 = i510 + 24 | 0;
   f54 = Math_fround(HEAPF32[i482 >> 2]);
   i165 = i510 + 28 | 0;
   f49 = Math_fround(HEAPF32[i165 >> 2]);
   i164 = i510 + 32 | 0;
   f27 = Math_fround(HEAPF32[i164 >> 2]);
   f51 = Math_fround(f46 * Math_fround(0.0));
   f79 = Math_fround(f84 * Math_fround(0.0));
   f57 = Math_fround(Math_fround(Math_fround(f25 * f50) + f51) + f79);
   f53 = Math_fround(f47 * Math_fround(0.0));
   f82 = Math_fround(f85 * Math_fround(0.0));
   f58 = Math_fround(Math_fround(Math_fround(f25 * f52) + f53) + f82);
   f56 = Math_fround(f49 * Math_fround(0.0));
   f26 = Math_fround(f27 * Math_fround(0.0));
   f25 = Math_fround(Math_fround(Math_fround(f25 * f54) + f56) + f26);
   f50 = Math_fround(f50 * Math_fround(0.0));
   f79 = Math_fround(Math_fround(f50 + Math_fround(f48 * f46)) + f79);
   f52 = Math_fround(f52 * Math_fround(0.0));
   f82 = Math_fround(Math_fround(f52 + Math_fround(f48 * f47)) + f82);
   f54 = Math_fround(f54 * Math_fround(0.0));
   f26 = Math_fround(Math_fround(f54 + Math_fround(f48 * f49)) + f26);
   f84 = Math_fround(Math_fround(f50 + f51) + Math_fround(f55 * f84));
   f85 = Math_fround(Math_fround(f52 + f53) + Math_fround(f55 * f85));
   f27 = Math_fround(Math_fround(f54 + f56) + Math_fround(f55 * f27));
   HEAPF32[i510 >> 2] = f57;
   HEAPF32[i459 >> 2] = f79;
   HEAPF32[i460 >> 2] = f84;
   HEAPF32[i461 >> 2] = f58;
   HEAPF32[i462 >> 2] = f82;
   HEAPF32[i463 >> 2] = f85;
   HEAPF32[i482 >> 2] = f25;
   HEAPF32[i165 >> 2] = f26;
   HEAPF32[i164 >> 2] = f27;
   f55 = Math_fround(Math_fround(1.0) / f488);
   f56 = Math_fround(Math_fround(1.0) - f491);
   f54 = Math_fround(f5 * f10);
   f53 = Math_fround(f10 * f6);
   f52 = Math_fround(f10 * Math_fround(f7 * f8));
   f51 = Math_fround(f10 * f9);
   i164 = (i4 | 0) == 27;
   HEAP32[i528 >> 2] = 0;
   HEAP32[i528 + 4 >> 2] = 0;
   HEAP32[i528 + 8 >> 2] = 0;
   HEAP32[i528 + 12 >> 2] = 0;
   i165 = HEAP32[i526 + 12 >> 2] | 0;
   if (i165 | 0) {
    i166 = i529 + 12 | 0;
    i167 = i529 + 8 | 0;
    i168 = i529 + 4 | 0;
    i169 = i529 + 16 | 0;
    i170 = i529 + 28 | 0;
    i171 = i529 + 24 | 0;
    i172 = i529 + 20 | 0;
    i173 = i529 + 32 | 0;
    i174 = i529 + 44 | 0;
    i175 = i529 + 40 | 0;
    i176 = i529 + 36 | 0;
    i177 = i511 + 12 | 0;
    i178 = i511 + 8 | 0;
    i179 = i511 + 4 | 0;
    i180 = i511 + 28 | 0;
    i181 = i511 + 24 | 0;
    i182 = i511 + 20 | 0;
    i183 = i511 + 44 | 0;
    i184 = i511 + 40 | 0;
    i185 = i511 + 36 | 0;
    i186 = i527 + 20 | 0;
    i187 = i526 + 20 | 0;
    i188 = i526 + 40 | 0;
    i189 = i526 + 60 | 0;
    i190 = i526 + 80 | 0;
    i191 = i526 + 100 | 0;
    i192 = i526 + 120 | 0;
    i193 = i526 + 140 | 0;
    i194 = i526 + 160 | 0;
    i195 = i511 + 16 | 0;
    i196 = i511 + 32 | 0;
    i197 = i527 + 4 | 0;
    i198 = i512 + 4 | 0;
    i199 = i512 + 8 | 0;
    i200 = i512 + 12 | 0;
    i201 = i527 + 8 | 0;
    i202 = i513 + 4 | 0;
    i203 = i513 + 8 | 0;
    i204 = i513 + 12 | 0;
    i205 = i526 + 520 | 0;
    i206 = i514 + 4 | 0;
    i207 = i514 + 8 | 0;
    i208 = i514 + 12 | 0;
    i209 = i526 + 500 | 0;
    i210 = i515 + 4 | 0;
    i211 = i515 + 8 | 0;
    i212 = i515 + 12 | 0;
    i213 = i527 + 16 | 0;
    i214 = i516 + 4 | 0;
    i215 = i516 + 8 | 0;
    i216 = i516 + 12 | 0;
    i217 = i529 + 16 | 0;
    i218 = i529 + 32 | 0;
    i219 = i517 + 4 | 0;
    i220 = i517 + 8 | 0;
    i221 = i517 + 12 | 0;
    i222 = i517 + 16 | 0;
    i223 = i517 + 20 | 0;
    i224 = i517 + 24 | 0;
    i225 = i517 + 28 | 0;
    i226 = i517 + 32 | 0;
    i227 = i517 + 36 | 0;
    i228 = i517 + 40 | 0;
    i229 = i517 + 44 | 0;
    i230 = i523 + 4 | 0;
    i231 = i523 + 8 | 0;
    i232 = i523 + 12 | 0;
    i233 = i523 + 16 | 0;
    i234 = i523 + 20 | 0;
    i235 = i523 + 24 | 0;
    i236 = i523 + 28 | 0;
    i237 = i523 + 32 | 0;
    i238 = i523 + 36 | 0;
    i239 = i523 + 40 | 0;
    i240 = i523 + 44 | 0;
    i241 = i523 + 48 | 0;
    i242 = i523 + 52 | 0;
    i243 = i523 + 56 | 0;
    i244 = i523 + 60 | 0;
    i245 = i523 + 64 | 0;
    i246 = i523 + 68 | 0;
    i247 = i523 + 72 | 0;
    i248 = i523 + 76 | 0;
    i249 = i523 + 80 | 0;
    i250 = i523 + 84 | 0;
    i251 = i523 + 88 | 0;
    i252 = i523 + 92 | 0;
    i253 = i523 + 96 | 0;
    i254 = i523 + 100 | 0;
    i255 = i523 + 104 | 0;
    i256 = i523 + 108 | 0;
    i257 = i523 + 112 | 0;
    i258 = i523 + 116 | 0;
    i259 = i523 + 120 | 0;
    i260 = i523 + 124 | 0;
    i261 = i523 + 128 | 0;
    i262 = i523 + 132 | 0;
    i263 = i523 + 136 | 0;
    i264 = i523 + 140 | 0;
    i265 = i523 + 144 | 0;
    i266 = i523 + 148 | 0;
    i267 = i523 + 152 | 0;
    i268 = i523 + 156 | 0;
    i269 = i523 + 160 | 0;
    i270 = i523 + 164 | 0;
    i271 = i523 + 168 | 0;
    i272 = i523 + 172 | 0;
    i273 = i523 + 176 | 0;
    i274 = i523 + 180 | 0;
    i275 = i523 + 184 | 0;
    i276 = i523 + 188 | 0;
    i277 = (i4 & 48 | 0) == 0;
    i126 = i524 + 4 | 0;
    i143 = i524 + 8 | 0;
    i160 = i524 + 12 | 0;
    i278 = i524 + 16 | 0;
    i121 = i524 + 20 | 0;
    i138 = i524 + 24 | 0;
    i155 = i524 + 28 | 0;
    i279 = i524 + 32 | 0;
    i116 = i524 + 36 | 0;
    i133 = i524 + 40 | 0;
    i150 = i524 + 44 | 0;
    i280 = i524 + 48 | 0;
    i125 = i524 + 52 | 0;
    i142 = i524 + 56 | 0;
    i159 = i524 + 60 | 0;
    i281 = i524 + 64 | 0;
    i120 = i524 + 68 | 0;
    i137 = i524 + 72 | 0;
    i154 = i524 + 76 | 0;
    i282 = i524 + 80 | 0;
    i115 = i524 + 84 | 0;
    i132 = i524 + 88 | 0;
    i149 = i524 + 92 | 0;
    i283 = i524 + 96 | 0;
    i124 = i524 + 100 | 0;
    i141 = i524 + 104 | 0;
    i158 = i524 + 108 | 0;
    i284 = i524 + 112 | 0;
    i119 = i524 + 116 | 0;
    i136 = i524 + 120 | 0;
    i153 = i524 + 124 | 0;
    i285 = i524 + 128 | 0;
    i114 = i524 + 132 | 0;
    i131 = i524 + 136 | 0;
    i148 = i524 + 140 | 0;
    i286 = i524 + 144 | 0;
    i123 = i524 + 148 | 0;
    i140 = i524 + 152 | 0;
    i157 = i524 + 156 | 0;
    i287 = i524 + 160 | 0;
    i118 = i524 + 164 | 0;
    i135 = i524 + 168 | 0;
    i152 = i524 + 172 | 0;
    i288 = i524 + 176 | 0;
    i113 = i524 + 180 | 0;
    i130 = i524 + 184 | 0;
    i147 = i524 + 188 | 0;
    i127 = i518 + 4 | 0;
    i144 = i518 + 8 | 0;
    i161 = i518 + 12 | 0;
    i289 = i518 + 16 | 0;
    i122 = i518 + 20 | 0;
    i139 = i518 + 24 | 0;
    i156 = i518 + 28 | 0;
    i290 = i518 + 32 | 0;
    i117 = i518 + 36 | 0;
    i134 = i518 + 40 | 0;
    i151 = i518 + 44 | 0;
    i129 = i519 + 4 | 0;
    i146 = i519 + 8 | 0;
    i163 = i519 + 12 | 0;
    i112 = i519 + 16 | 0;
    i128 = i519 + 20 | 0;
    i145 = i519 + 24 | 0;
    i162 = i519 + 28 | 0;
    i111 = i519 + 32 | 0;
    i291 = (i4 & 512 | 0) != 0;
    i292 = i509 + 4 | 0;
    i293 = i509 + 8 | 0;
    i294 = i509 + 12 | 0;
    i295 = i509 + 16 | 0;
    i296 = i509 + 20 | 0;
    i297 = i509 + 24 | 0;
    i298 = i509 + 28 | 0;
    i299 = i509 + 32 | 0;
    i300 = i509 + 36 | 0;
    i301 = i509 + 40 | 0;
    i302 = i509 + 44 | 0;
    i303 = (i4 & 8192 | 0) != 0;
    i304 = i525 + 4 | 0;
    i305 = i525 + 8 | 0;
    i306 = i525 + 12 | 0;
    i307 = i525 + 16 | 0;
    i308 = i525 + 20 | 0;
    i309 = i525 + 24 | 0;
    i310 = i525 + 28 | 0;
    i311 = i525 + 32 | 0;
    i312 = i525 + 36 | 0;
    i313 = i525 + 40 | 0;
    i314 = i525 + 44 | 0;
    i315 = i525 + 48 | 0;
    i316 = i525 + 52 | 0;
    i317 = i525 + 56 | 0;
    i318 = i525 + 60 | 0;
    i319 = (i4 & 2 | 0) == 0;
    i320 = (i4 & 8 | 0) == 0;
    i321 = (i4 & 16 | 0) == 0;
    i322 = (i4 & 32 | 0) == 0;
    i323 = (i4 & 64 | 0) == 0;
    i324 = (i4 & 128 | 0) == 0;
    i325 = (i4 & 256 | 0) == 0;
    i326 = i509 + 16 | 0;
    i327 = i509 + 32 | 0;
    i328 = (i4 & 1024 | 0) == 0;
    i329 = (i4 & 2048 | 0) == 0;
    i330 = (i4 & 4096 | 0) == 0;
    i78 = (i4 & 4 | 0) == 0;
    i80 = i518 + 16 | 0;
    i81 = i518 + 32 | 0;
    i83 = i526 + 864 | 0;
    i86 = i526 + 848 | 0;
    i87 = i526 + 844 | 0;
    i88 = i526 + 828 | 0;
    i89 = i526 + 540 | 0;
    i90 = i526 + 340 | 0;
    i91 = i519 + 16 | 0;
    i92 = i519 + 32 | 0;
    i93 = i517 + 16 | 0;
    i94 = i517 + 32 | 0;
    i95 = i523 + 16 | 0;
    i96 = i523 + 32 | 0;
    i97 = i524 + 16 | 0;
    i98 = i524 + 32 | 0;
    i99 = i241 + 16 | 0;
    i100 = i241 + 32 | 0;
    i101 = i280 + 16 | 0;
    i102 = i280 + 32 | 0;
    i103 = i253 + 16 | 0;
    i104 = i253 + 32 | 0;
    i105 = i283 + 16 | 0;
    i106 = i283 + 32 | 0;
    i107 = i265 + 16 | 0;
    i108 = i265 + 32 | 0;
    i109 = i286 + 16 | 0;
    i110 = i286 + 32 | 0;
    f50 = Math_fround(f25 * Math_fround(0.0));
    f49 = Math_fround(f26 * Math_fround(0.0));
    f48 = Math_fround(f27 * Math_fround(0.0));
    i77 = i11 + 564 | 0;
    i76 = i11 + 568 | 0;
    i75 = 0;
    i1 = i17;
    do {
     i16 = i529;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     i16 = i511;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     HEAP32[i512 >> 2] = 0;
     HEAP32[i512 + 4 >> 2] = 0;
     HEAP32[i512 + 8 >> 2] = 0;
     HEAP32[i512 + 12 >> 2] = 0;
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     i22 = HEAP32[i186 >> 2] | 0;
     i23 = HEAP32[i526 >> 2] | 0;
     if (!i22) {
      i70 = i23 + (i75 << 2) | 0;
      i71 = HEAP32[i70 + 4 >> 2] | 0;
      i72 = HEAP32[i70 + 8 >> 2] | 0;
      i73 = HEAP32[i70 + 12 >> 2] | 0;
      i461 = (HEAP32[i187 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i461 >> 2] | 0;
      i459 = HEAP32[i461 + 4 >> 2] | 0;
      i460 = HEAP32[i461 + 8 >> 2] | 0;
      i461 = HEAP32[i461 + 12 >> 2] | 0;
      i510 = (HEAP32[i188 >> 2] | 0) + (i75 << 2) | 0;
      i462 = HEAP32[i510 >> 2] | 0;
      i463 = HEAP32[i510 + 4 >> 2] | 0;
      i482 = HEAP32[i510 + 8 >> 2] | 0;
      i510 = HEAP32[i510 + 12 >> 2] | 0;
      HEAP32[i529 >> 2] = HEAP32[i70 >> 2];
      HEAP32[i168 >> 2] = i71;
      HEAP32[i167 >> 2] = i72;
      HEAP32[i166 >> 2] = i73;
      HEAP32[i169 >> 2] = i74;
      HEAP32[i172 >> 2] = i459;
      HEAP32[i171 >> 2] = i460;
      HEAP32[i170 >> 2] = i461;
      HEAP32[i173 >> 2] = i462;
      HEAP32[i176 >> 2] = i463;
      HEAP32[i175 >> 2] = i482;
      HEAP32[i174 >> 2] = i510;
      i510 = (HEAP32[i189 >> 2] | 0) + (i75 << 2) | 0;
      f35 = Math_fround(HEAPF32[i510 >> 2]);
      f25 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f26 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f27 = Math_fround(HEAPF32[i510 + 12 >> 2]);
      i510 = (HEAP32[i190 >> 2] | 0) + (i75 << 2) | 0;
      f28 = Math_fround(HEAPF32[i510 >> 2]);
      f29 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f30 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f31 = Math_fround(HEAPF32[i510 + 12 >> 2]);
      i510 = (HEAP32[i191 >> 2] | 0) + (i75 << 2) | 0;
      f32 = Math_fround(HEAPF32[i510 >> 2]);
      f33 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f34 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f47 = Math_fround(HEAPF32[i510 + 12 >> 2]);
      i510 = (HEAP32[i192 >> 2] | 0) + (i75 << 2) | 0;
      f36 = Math_fround(HEAPF32[i510 >> 2]);
      f37 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f38 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f39 = Math_fround(HEAPF32[i510 + 12 >> 2]);
      i510 = (HEAP32[i193 >> 2] | 0) + (i75 << 2) | 0;
      f40 = Math_fround(HEAPF32[i510 >> 2]);
      f41 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f42 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f43 = Math_fround(HEAPF32[i510 + 12 >> 2]);
      i510 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      f44 = Math_fround(HEAPF32[i510 >> 2]);
      f45 = Math_fround(HEAPF32[i510 + 4 >> 2]);
      f46 = Math_fround(HEAPF32[i510 + 8 >> 2]);
      f37 = Math_fround(f25 + f37);
      f38 = Math_fround(f26 + f38);
      f39 = Math_fround(f27 + f39);
      f40 = Math_fround(f28 + f40);
      f41 = Math_fround(f29 + f41);
      f42 = Math_fround(f30 + f42);
      f43 = Math_fround(f31 + f43);
      f44 = Math_fround(f32 + f44);
      f45 = Math_fround(f33 + f45);
      f46 = Math_fround(f34 + f46);
      f47 = Math_fround(f47 + Math_fround(HEAPF32[i510 + 12 >> 2]));
      HEAPF32[i511 >> 2] = Math_fround(f35 + f36);
      HEAPF32[i179 >> 2] = f37;
      HEAPF32[i178 >> 2] = f38;
      HEAPF32[i177 >> 2] = f39;
      HEAPF32[i195 >> 2] = f40;
      HEAPF32[i182 >> 2] = f41;
      HEAPF32[i181 >> 2] = f42;
      HEAPF32[i180 >> 2] = f43;
      HEAPF32[i196 >> 2] = f44;
      HEAPF32[i185 >> 2] = f45;
      HEAPF32[i184 >> 2] = f46;
      HEAPF32[i183 >> 2] = f47;
      i510 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      i482 = HEAP32[i510 + 4 >> 2] | 0;
      i463 = HEAP32[i510 + 8 >> 2] | 0;
      i462 = HEAP32[i510 + 12 >> 2] | 0;
      HEAP32[i512 >> 2] = HEAP32[i510 >> 2];
      HEAP32[i198 >> 2] = i482;
      HEAP32[i199 >> 2] = i463;
      HEAP32[i200 >> 2] = i462;
      i462 = (HEAP32[i201 >> 2] | 0) + (i75 << 2) | 0;
      i463 = HEAP32[i462 + 4 >> 2] | 0;
      i482 = HEAP32[i462 + 8 >> 2] | 0;
      i510 = HEAP32[i462 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i462 >> 2];
      HEAP32[i202 >> 2] = i463;
      HEAP32[i203 >> 2] = i482;
      HEAP32[i204 >> 2] = i510;
      i510 = (HEAP32[i205 >> 2] | 0) + (i75 << 2) | 0;
      i482 = HEAP32[i510 + 4 >> 2] | 0;
      i463 = HEAP32[i510 + 8 >> 2] | 0;
      i462 = HEAP32[i510 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i510 >> 2];
      HEAP32[i206 >> 2] = i482;
      HEAP32[i207 >> 2] = i463;
      HEAP32[i208 >> 2] = i462;
      i462 = (HEAP32[i209 >> 2] | 0) + (i75 << 2) | 0;
      i463 = HEAP32[i462 + 4 >> 2] | 0;
      i482 = HEAP32[i462 + 8 >> 2] | 0;
      i510 = HEAP32[i462 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i462 >> 2];
      HEAP32[i210 >> 2] = i463;
      HEAP32[i211 >> 2] = i482;
      HEAP32[i212 >> 2] = i510;
      if (HEAP32[i458 >> 2] & 268435456 | 0) {
       i462 = (HEAP32[i213 >> 2] | 0) + (i75 << 2) | 0;
       i463 = HEAP32[i462 + 4 >> 2] | 0;
       i482 = HEAP32[i462 + 8 >> 2] | 0;
       i510 = HEAP32[i462 + 12 >> 2] | 0;
       HEAP32[i516 >> 2] = HEAP32[i462 >> 2];
       HEAP32[i214 >> 2] = i463;
       HEAP32[i215 >> 2] = i482;
       HEAP32[i216 >> 2] = i510;
      }
     } else {
      i4 = HEAP32[i189 >> 2] | 0;
      i11 = HEAP32[i192 >> 2] | 0;
      i12 = HEAP32[i187 >> 2] | 0;
      i13 = HEAP32[i190 >> 2] | 0;
      i14 = HEAP32[i193 >> 2] | 0;
      i15 = HEAP32[i188 >> 2] | 0;
      i16 = HEAP32[i191 >> 2] | 0;
      i17 = HEAP32[i194 >> 2] | 0;
      i18 = HEAP32[i197 >> 2] | 0;
      i19 = HEAP32[i201 >> 2] | 0;
      i20 = HEAP32[i205 >> 2] | 0;
      i21 = HEAP32[i209 >> 2] | 0;
      i3 = HEAP32[i213 >> 2] | 0;
      if (!(HEAP32[i458 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i510 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i4 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i11 + (i510 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i12 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i13 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i14 + (i510 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i15 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i16 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i17 + (i510 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i510 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i510 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i510 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i510 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i510 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i529 + (i2 << 2) >> 2] = HEAP32[i23 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i4 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i11 + (i510 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i12 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i13 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i14 + (i510 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i15 + (i510 << 2) >> 2];
        f47 = Math_fround(HEAPF32[i16 + (i510 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f47 + Math_fround(HEAPF32[i17 + (i510 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i510 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i510 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i510 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i510 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i3 + (i510 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f29 = Math_fround(HEAPF32[i529 >> 2]);
     f7 = Math_fround(f497 * f29);
     f27 = Math_fround(HEAPF32[i168 >> 2]);
     f35 = Math_fround(f497 * f27);
     f46 = Math_fround(HEAPF32[i167 >> 2]);
     f6 = Math_fround(f497 * f46);
     f44 = Math_fround(HEAPF32[i166 >> 2]);
     f47 = Math_fround(f497 * f44);
     f28 = Math_fround(HEAPF32[i217 >> 2]);
     f36 = Math_fround(f500 * f28);
     f26 = Math_fround(HEAPF32[i172 >> 2]);
     f31 = Math_fround(f500 * f26);
     f45 = Math_fround(HEAPF32[i171 >> 2]);
     f10 = Math_fround(f500 * f45);
     f43 = Math_fround(HEAPF32[i170 >> 2]);
     f36 = Math_fround(f7 + f36);
     f31 = Math_fround(f35 + f31);
     f10 = Math_fround(f6 + f10);
     f47 = Math_fround(f47 + Math_fround(f500 * f43));
     f6 = Math_fround(HEAPF32[i218 >> 2]);
     f35 = Math_fround(f503 * f6);
     f7 = Math_fround(HEAPF32[i176 >> 2]);
     f34 = Math_fround(f503 * f7);
     f8 = Math_fround(HEAPF32[i175 >> 2]);
     f33 = Math_fround(f503 * f8);
     f30 = Math_fround(HEAPF32[i174 >> 2]);
     f34 = Math_fround(f506 + Math_fround(f31 + f34));
     f33 = Math_fround(f506 + Math_fround(f10 + f33));
     f47 = Math_fround(f506 + Math_fround(f47 + Math_fround(f503 * f30)));
     HEAPF32[i517 >> 2] = Math_fround(f506 + Math_fround(f36 + f35));
     HEAPF32[i219 >> 2] = f34;
     HEAPF32[i220 >> 2] = f33;
     HEAPF32[i221 >> 2] = f47;
     f47 = Math_fround(f507 + Math_fround(Math_fround(Math_fround(f498 * f27) + Math_fround(f501 * f26)) + Math_fround(f504 * f7)));
     f33 = Math_fround(f507 + Math_fround(Math_fround(Math_fround(f498 * f46) + Math_fround(f501 * f45)) + Math_fround(f504 * f8)));
     f34 = Math_fround(f507 + Math_fround(Math_fround(Math_fround(f498 * f44) + Math_fround(f501 * f43)) + Math_fround(f504 * f30)));
     HEAPF32[i222 >> 2] = Math_fround(f507 + Math_fround(Math_fround(Math_fround(f498 * f29) + Math_fround(f501 * f28)) + Math_fround(f504 * f6)));
     HEAPF32[i223 >> 2] = f47;
     HEAPF32[i224 >> 2] = f33;
     HEAPF32[i225 >> 2] = f34;
     f34 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f27) + Math_fround(f502 * f26)) + Math_fround(f505 * f7)));
     f33 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f46) + Math_fround(f502 * f45)) + Math_fround(f505 * f8)));
     f47 = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f44) + Math_fround(f502 * f43)) + Math_fround(f505 * f30)));
     HEAPF32[i226 >> 2] = Math_fround(f508 + Math_fround(Math_fround(Math_fround(f499 * f29) + Math_fround(f502 * f28)) + Math_fround(f505 * f6)));
     HEAPF32[i227 >> 2] = f34;
     HEAPF32[i228 >> 2] = f33;
     HEAPF32[i229 >> 2] = f47;
     f6 = Math_fround(f496 + Math_fround(Math_fround(Math_fround(f493 * f29) + Math_fround(f494 * f28)) + Math_fround(f495 * f6)));
     f7 = Math_fround(f496 + Math_fround(Math_fround(Math_fround(f493 * f27) + Math_fround(f494 * f26)) + Math_fround(f495 * f7)));
     f8 = Math_fround(f496 + Math_fround(Math_fround(Math_fround(f493 * f46) + Math_fround(f494 * f45)) + Math_fround(f495 * f8)));
     f30 = Math_fround(f496 + Math_fround(Math_fround(Math_fround(f493 * f44) + Math_fround(f494 * f43)) + Math_fround(f495 * f30)));
     f43 = Math_fround(f481 + Math_fround(f483 * f6));
     f44 = Math_fround(f481 + Math_fround(f483 * f7));
     f45 = Math_fround(f481 + Math_fround(f483 * f8));
     f46 = Math_fround(f481 + Math_fround(f483 * f30));
     f6 = Math_fround(f471 + Math_fround(f472 * f6));
     f7 = Math_fround(f471 + Math_fround(f472 * f7));
     f8 = Math_fround(f471 + Math_fround(f472 * f8));
     f30 = Math_fround(f471 + Math_fround(f472 * f30));
     f26 = Math_fround(HEAPF32[i512 >> 2]);
     f27 = Math_fround(HEAPF32[i198 >> 2]);
     f28 = Math_fround(HEAPF32[i199 >> 2]);
     f29 = Math_fround(HEAPF32[i200 >> 2]);
     f33 = Math_fround(HEAPF32[i513 >> 2]);
     f34 = Math_fround(HEAPF32[i202 >> 2]);
     f35 = Math_fround(HEAPF32[i203 >> 2]);
     f36 = Math_fround(HEAPF32[i204 >> 2]);
     f10 = f26 > f33 ? f26 : f33;
     f31 = f27 > f34 ? f27 : f34;
     f25 = f28 > f35 ? f28 : f35;
     f32 = f29 > f36 ? f29 : f36;
     f40 = Math_fround((f10 > f43 ? f10 : f43) * Math_fround(.5));
     f41 = Math_fround((f31 > f44 ? f31 : f44) * Math_fround(.5));
     f42 = Math_fround((f25 > f45 ? f25 : f45) * Math_fround(.5));
     f5 = Math_fround((f32 > f46 ? f32 : f46) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
     i462 = f43 >= Math_fround(0.0);
     i463 = f44 >= Math_fround(0.0);
     i482 = f45 >= Math_fround(0.0);
     i510 = f46 >= Math_fround(0.0);
     i15 = i462 ? i15 : 0;
     i16 = i463 ? i16 : 0;
     i17 = i482 ? i17 : 0;
     i11 = i510 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f42 = Math_fround(f6 * Math_fround(.5));
     f44 = Math_fround(f7 * Math_fround(.5));
     f46 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f30 * Math_fround(.5));
     f41 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f43 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f45 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f41 < f42 ? f41 : f42, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f43 < f44 ? f43 : f44, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f45 < f46 ? f45 : f46, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i510 = f30 >= Math_fround(0.0);
     i11 = i510 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f44 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f31);
     f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f32);
     f545 = Math_fround(f26 * f43);
     f40 = Math_fround(f27 * f44);
     f41 = Math_fround(f28 * f45);
     f42 = Math_fround(f29 * f46);
     f43 = Math_fround(f33 * f43);
     f44 = Math_fround(f34 * f44);
     f45 = Math_fround(f35 * f45);
     f46 = Math_fround(f36 * f46);
     i3 = Math_fround(HEAPF32[i514 >> 2]) < Math_fround(100.0);
     i11 = Math_fround(HEAPF32[i206 >> 2]) < Math_fround(100.0);
     i12 = Math_fround(HEAPF32[i207 >> 2]) < Math_fround(100.0);
     i13 = Math_fround(HEAPF32[i208 >> 2]) < Math_fround(100.0);
     f29 = Math_fround(HEAPF32[i511 >> 2]);
     f538 = Math_fround(f487 * f29);
     f553 = Math_fround(HEAPF32[i179 >> 2]);
     f551 = Math_fround(f487 * f553);
     f533 = Math_fround(HEAPF32[i178 >> 2]);
     f550 = Math_fround(f487 * f533);
     f531 = Math_fround(HEAPF32[i177 >> 2]);
     f28 = Math_fround(f487 * f531);
     f31 = Math_fround(HEAPF32[i195 >> 2]);
     f535 = Math_fround(f486 * f31);
     f554 = Math_fround(HEAPF32[i182 >> 2]);
     f536 = Math_fround(f486 * f554);
     f532 = Math_fround(HEAPF32[i181 >> 2]);
     f537 = Math_fround(f486 * f532);
     f5 = Math_fround(HEAPF32[i180 >> 2]);
     f535 = Math_fround(f538 + f535);
     f536 = Math_fround(f551 + f536);
     f537 = Math_fround(f550 + f537);
     f28 = Math_fround(f28 + Math_fround(f486 * f5));
     f550 = Math_fround(HEAPF32[i196 >> 2]);
     f551 = Math_fround(f485 * f550);
     f538 = Math_fround(HEAPF32[i185 >> 2]);
     f32 = Math_fround(f485 * f538);
     f539 = Math_fround(HEAPF32[i184 >> 2]);
     f30 = Math_fround(f485 * f539);
     f540 = Math_fround(HEAPF32[i183 >> 2]);
     f551 = Math_fround(Math_fround(f535 + f551) - f52);
     f32 = Math_fround(Math_fround(f536 + f32) - f52);
     f30 = Math_fround(Math_fround(f537 + f30) - f52);
     f28 = Math_fround(Math_fround(f28 + Math_fround(f485 * f540)) - f52);
     f537 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f29) + Math_fround(f477 * f31)) + Math_fround(f474 * f550)) - f470);
     f536 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f553) + Math_fround(f477 * f554)) + Math_fround(f474 * f538)) - f470);
     f535 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f533) + Math_fround(f477 * f532)) + Math_fround(f474 * f539)) - f470);
     f534 = Math_fround(Math_fround(Math_fround(Math_fround(f479 * f531) + Math_fround(f477 * f5)) + Math_fround(f474 * f540)) - f470);
     f550 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f29) + Math_fround(f478 * f31)) + Math_fround(f476 * f550)) - f51);
     f538 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f553) + Math_fround(f478 * f554)) + Math_fround(f476 * f538)) - f51);
     f539 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f533) + Math_fround(f478 * f532)) + Math_fround(f476 * f539)) - f51);
     f540 = Math_fround(Math_fround(Math_fround(Math_fround(f480 * f531) + Math_fround(f478 * f5)) + Math_fround(f476 * f540)) - f51);
     f5 = Math_fround(Math_fround(f550 * f550) + Math_fround(Math_fround(f551 * f551) + Math_fround(f537 * f537)));
     f531 = Math_fround(Math_fround(f538 * f538) + Math_fround(Math_fround(f32 * f32) + Math_fround(f536 * f536)));
     f532 = Math_fround(Math_fround(f539 * f539) + Math_fround(Math_fround(f30 * f30) + Math_fround(f535 * f535)));
     f533 = Math_fround(Math_fround(f540 * f540) + Math_fround(Math_fround(f28 * f28) + Math_fround(f534 * f534)));
     f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
     f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f531))));
     f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f532))));
     f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f533))));
     i462 = !(f5 <= Math_fround(9.99999974e-06));
     i463 = !(f531 <= Math_fround(9.99999974e-06));
     i482 = !(f532 <= Math_fround(9.99999974e-06));
     i510 = !(f533 <= Math_fround(9.99999974e-06));
     f533 = Math_fround(HEAPF32[i517 >> 2]);
     f532 = Math_fround(HEAPF32[i219 >> 2]);
     f531 = Math_fround(HEAPF32[i220 >> 2]);
     f5 = Math_fround(HEAPF32[i221 >> 2]);
     f6 = Math_fround(HEAPF32[i222 >> 2]);
     f7 = Math_fround(HEAPF32[i223 >> 2]);
     f8 = Math_fround(HEAPF32[i224 >> 2]);
     f9 = Math_fround(HEAPF32[i225 >> 2]);
     f10 = Math_fround(HEAPF32[i226 >> 2]);
     f25 = Math_fround(HEAPF32[i227 >> 2]);
     f26 = Math_fround(HEAPF32[i228 >> 2]);
     f541 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f446 * f533) + Math_fround(f449 * f6)) + Math_fround(f465 * f10)));
     f544 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f446 * f532) + Math_fround(f449 * f7)) + Math_fround(f465 * f25)));
     f543 = Math_fround(f468 + Math_fround(Math_fround(Math_fround(f446 * f531) + Math_fround(f449 * f8)) + Math_fround(f465 * f26)));
     f542 = Math_fround(f468 + Math_fround(Math_fround(f465 * f47) + Math_fround(Math_fround(f446 * f5) + Math_fround(f449 * f9))));
     f549 = Math_fround(f469 + Math_fround(Math_fround(Math_fround(f447 * f533) + Math_fround(f450 * f6)) + Math_fround(f466 * f10)));
     f548 = Math_fround(f469 + Math_fround(Math_fround(Math_fround(f447 * f532) + Math_fround(f450 * f7)) + Math_fround(f466 * f25)));
     f547 = Math_fround(f469 + Math_fround(Math_fround(Math_fround(f447 * f531) + Math_fround(f450 * f8)) + Math_fround(f466 * f26)));
     f546 = Math_fround(f469 + Math_fround(Math_fround(f466 * f47) + Math_fround(Math_fround(f447 * f5) + Math_fround(f450 * f9))));
     f39 = Math_fround(f337 + Math_fround(Math_fround(Math_fround(f448 * f533) + Math_fround(f464 * f6)) + Math_fround(f467 * f10)));
     f37 = Math_fround(f337 + Math_fround(Math_fround(Math_fround(f448 * f532) + Math_fround(f464 * f7)) + Math_fround(f467 * f25)));
     f38 = Math_fround(f337 + Math_fround(Math_fround(Math_fround(f448 * f531) + Math_fround(f464 * f8)) + Math_fround(f467 * f26)));
     f27 = Math_fround(f337 + Math_fround(Math_fround(f467 * f47) + Math_fround(Math_fround(f448 * f5) + Math_fround(f464 * f9))));
     f555 = Math_fround(f54 * f33);
     f33 = Math_fround(f54 * f34);
     f552 = Math_fround(f54 * f35);
     f34 = Math_fround(f54 * f36);
     f35 = Math_fround(f555 * (i462 ? f554 : Math_fround(0.0)));
     f33 = Math_fround(f33 * (i463 ? f553 : Math_fround(0.0)));
     f31 = Math_fround(f552 * (i482 ? f31 : Math_fround(0.0)));
     f35 = Math_fround(f53 + f35);
     f33 = Math_fround(f53 + f33);
     f31 = Math_fround(f53 + f31);
     f29 = Math_fround(f53 + Math_fround(f34 * (i510 ? f29 : Math_fround(0.0))));
     f34 = Math_fround(f541 - Math_fround(f551 * f35));
     f32 = Math_fround(f544 - Math_fround(f32 * f33));
     f30 = Math_fround(f543 - Math_fround(f30 * f31));
     f28 = Math_fround(f542 - Math_fround(f28 * f29));
     f537 = Math_fround(f549 - Math_fround(f537 * f35));
     f536 = Math_fround(f548 - Math_fround(f536 * f33));
     f535 = Math_fround(f547 - Math_fround(f535 * f31));
     f534 = Math_fround(f546 - Math_fround(f534 * f29));
     f35 = Math_fround(f39 - Math_fround(f550 * f35));
     f33 = Math_fround(f37 - Math_fround(f538 * f33));
     f31 = Math_fround(f38 - Math_fround(f539 * f31));
     f29 = Math_fround(f27 - Math_fround(f540 * f29));
     f549 = Math_fround(Math_fround(f39 * f537) - Math_fround(f549 * f35));
     f548 = Math_fround(Math_fround(f37 * f536) - Math_fround(f548 * f33));
     f547 = Math_fround(Math_fround(f38 * f535) - Math_fround(f547 * f31));
     f546 = Math_fround(Math_fround(f27 * f534) - Math_fround(f546 * f29));
     f36 = Math_fround(Math_fround(f541 * f35) - Math_fround(f39 * f34));
     f37 = Math_fround(Math_fround(f544 * f33) - Math_fround(f37 * f32));
     f38 = Math_fround(Math_fround(f543 * f31) - Math_fround(f38 * f30));
     f27 = Math_fround(Math_fround(f542 * f29) - Math_fround(f27 * f28));
     f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f549 * f549) + Math_fround(f36 * f36)))));
     f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f548 * f548) + Math_fround(f37 * f37)))));
     f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f547 * f547) + Math_fround(f38 * f38)))));
     f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f546 * f546) + Math_fround(f27 * f27)))));
     f549 = Math_fround(f542 * f549);
     f548 = Math_fround(f543 * f548);
     f547 = Math_fround(f544 * f547);
     f546 = Math_fround(f546 * f39);
     f36 = Math_fround(f542 * f36);
     f37 = Math_fround(f543 * f37);
     f38 = Math_fround(f544 * f38);
     f39 = Math_fround(f27 * f39);
     f27 = i3 ? f545 : Math_fround(0.0);
     f549 = Math_fround(f27 * f549);
     f40 = i11 ? f40 : Math_fround(0.0);
     f548 = Math_fround(f40 * f548);
     f41 = i12 ? f41 : Math_fround(0.0);
     f547 = Math_fround(f41 * f547);
     f42 = i13 ? f42 : Math_fround(0.0);
     f546 = Math_fround(f42 * f546);
     f36 = Math_fround(f27 * f36);
     f37 = Math_fround(f40 * f37);
     f38 = Math_fround(f41 * f38);
     f39 = Math_fround(f42 * f39);
     f545 = Math_fround(f443 + Math_fround(Math_fround(f344 * f35) + Math_fround(Math_fround(f338 * f34) + Math_fround(f341 * f537))));
     f544 = Math_fround(f443 + Math_fround(Math_fround(f344 * f33) + Math_fround(Math_fround(f338 * f32) + Math_fround(f341 * f536))));
     f543 = Math_fround(f443 + Math_fround(Math_fround(f344 * f31) + Math_fround(Math_fround(f338 * f30) + Math_fround(f341 * f535))));
     f542 = Math_fround(f443 + Math_fround(Math_fround(f344 * f29) + Math_fround(Math_fround(f338 * f28) + Math_fround(f341 * f534))));
     f541 = Math_fround(f444 + Math_fround(Math_fround(f441 * f35) + Math_fround(Math_fround(f339 * f34) + Math_fround(f342 * f537))));
     f540 = Math_fround(f444 + Math_fround(Math_fround(f441 * f33) + Math_fround(Math_fround(f339 * f32) + Math_fround(f342 * f536))));
     f539 = Math_fround(f444 + Math_fround(Math_fround(f441 * f31) + Math_fround(Math_fround(f339 * f30) + Math_fround(f342 * f535))));
     f538 = Math_fround(f444 + Math_fround(Math_fround(f441 * f29) + Math_fround(Math_fround(f339 * f28) + Math_fround(f342 * f534))));
     f537 = Math_fround(f445 + Math_fround(Math_fround(f442 * f35) + Math_fround(Math_fround(f340 * f34) + Math_fround(f343 * f537))));
     f536 = Math_fround(f445 + Math_fround(Math_fround(f442 * f33) + Math_fround(Math_fround(f340 * f32) + Math_fround(f343 * f536))));
     f535 = Math_fround(f445 + Math_fround(Math_fround(f442 * f31) + Math_fround(Math_fround(f340 * f30) + Math_fround(f343 * f535))));
     f534 = Math_fround(f445 + Math_fround(Math_fround(f442 * f29) + Math_fround(Math_fround(f340 * f28) + Math_fround(f343 * f534))));
     f28 = Math_fround(f50 + Math_fround(Math_fround(f57 * f549) + Math_fround(f58 * f36)));
     f29 = Math_fround(f50 + Math_fround(Math_fround(f57 * f548) + Math_fround(f58 * f37)));
     f30 = Math_fround(f50 + Math_fround(Math_fround(f57 * f547) + Math_fround(f58 * f38)));
     f31 = Math_fround(f50 + Math_fround(Math_fround(f57 * f546) + Math_fround(f58 * f39)));
     f32 = Math_fround(f49 + Math_fround(Math_fround(f79 * f549) + Math_fround(f82 * f36)));
     f33 = Math_fround(f49 + Math_fround(Math_fround(f79 * f548) + Math_fround(f82 * f37)));
     f34 = Math_fround(f49 + Math_fround(Math_fround(f79 * f547) + Math_fround(f82 * f38)));
     f35 = Math_fround(f49 + Math_fround(Math_fround(f79 * f546) + Math_fround(f82 * f39)));
     f36 = Math_fround(f48 + Math_fround(Math_fround(f84 * f549) + Math_fround(f85 * f36)));
     f37 = Math_fround(f48 + Math_fround(Math_fround(f84 * f548) + Math_fround(f85 * f37)));
     f38 = Math_fround(f48 + Math_fround(Math_fround(f84 * f547) + Math_fround(f85 * f38)));
     f39 = Math_fround(f48 + Math_fround(Math_fround(f84 * f546) + Math_fround(f85 * f39)));
     f546 = Math_fround(f532 + f29);
     f547 = Math_fround(f531 + f30);
     f548 = Math_fround(f5 + f31);
     f549 = Math_fround(f6 + f32);
     f550 = Math_fround(f7 + f33);
     f551 = Math_fround(f8 + f34);
     f552 = Math_fround(f9 + f35);
     f553 = Math_fround(f10 + f36);
     f554 = Math_fround(f25 + f37);
     f555 = Math_fround(f26 + f38);
     f556 = Math_fround(f47 + f39);
     HEAPF32[i523 >> 2] = Math_fround(f533 + f28);
     HEAPF32[i230 >> 2] = f546;
     HEAPF32[i231 >> 2] = f547;
     HEAPF32[i232 >> 2] = f548;
     HEAPF32[i233 >> 2] = f549;
     HEAPF32[i234 >> 2] = f550;
     HEAPF32[i235 >> 2] = f551;
     HEAPF32[i236 >> 2] = f552;
     HEAPF32[i237 >> 2] = f553;
     HEAPF32[i238 >> 2] = f554;
     HEAPF32[i239 >> 2] = f555;
     HEAPF32[i240 >> 2] = f556;
     f556 = Math_fround(f544 + f29);
     f555 = Math_fround(f543 + f30);
     f554 = Math_fround(f542 + f31);
     f553 = Math_fround(f541 + f32);
     f552 = Math_fround(f540 + f33);
     f551 = Math_fround(f539 + f34);
     f550 = Math_fround(f538 + f35);
     f549 = Math_fround(f537 + f36);
     f548 = Math_fround(f536 + f37);
     f547 = Math_fround(f535 + f38);
     f546 = Math_fround(f534 + f39);
     HEAPF32[i241 >> 2] = Math_fround(f545 + f28);
     HEAPF32[i242 >> 2] = f556;
     HEAPF32[i243 >> 2] = f555;
     HEAPF32[i244 >> 2] = f554;
     HEAPF32[i245 >> 2] = f553;
     HEAPF32[i246 >> 2] = f552;
     HEAPF32[i247 >> 2] = f551;
     HEAPF32[i248 >> 2] = f550;
     HEAPF32[i249 >> 2] = f549;
     HEAPF32[i250 >> 2] = f548;
     HEAPF32[i251 >> 2] = f547;
     HEAPF32[i252 >> 2] = f546;
     f544 = Math_fround(f544 - f29);
     f543 = Math_fround(f543 - f30);
     f542 = Math_fround(f542 - f31);
     f541 = Math_fround(f541 - f32);
     f540 = Math_fround(f540 - f33);
     f539 = Math_fround(f539 - f34);
     f538 = Math_fround(f538 - f35);
     f537 = Math_fround(f537 - f36);
     f536 = Math_fround(f536 - f37);
     f535 = Math_fround(f535 - f38);
     f534 = Math_fround(f534 - f39);
     HEAPF32[i253 >> 2] = Math_fround(f545 - f28);
     HEAPF32[i254 >> 2] = f544;
     HEAPF32[i255 >> 2] = f543;
     HEAPF32[i256 >> 2] = f542;
     HEAPF32[i257 >> 2] = f541;
     HEAPF32[i258 >> 2] = f540;
     HEAPF32[i259 >> 2] = f539;
     HEAPF32[i260 >> 2] = f538;
     HEAPF32[i261 >> 2] = f537;
     HEAPF32[i262 >> 2] = f536;
     HEAPF32[i263 >> 2] = f535;
     HEAPF32[i264 >> 2] = f534;
     f532 = Math_fround(f532 - f29);
     f531 = Math_fround(f531 - f30);
     f5 = Math_fround(f5 - f31);
     f6 = Math_fround(f6 - f32);
     f7 = Math_fround(f7 - f33);
     f8 = Math_fround(f8 - f34);
     f9 = Math_fround(f9 - f35);
     f10 = Math_fround(f10 - f36);
     f25 = Math_fround(f25 - f37);
     f26 = Math_fround(f26 - f38);
     f47 = Math_fround(f47 - f39);
     HEAPF32[i265 >> 2] = Math_fround(f533 - f28);
     HEAPF32[i266 >> 2] = f532;
     HEAPF32[i267 >> 2] = f531;
     HEAPF32[i268 >> 2] = f5;
     HEAPF32[i269 >> 2] = f6;
     HEAPF32[i270 >> 2] = f7;
     HEAPF32[i271 >> 2] = f8;
     HEAPF32[i272 >> 2] = f9;
     HEAPF32[i273 >> 2] = f10;
     HEAPF32[i274 >> 2] = f25;
     HEAPF32[i275 >> 2] = f26;
     HEAPF32[i276 >> 2] = f47;
     if (!i277) {
      i2 = HEAP32[i458 >> 2] | 0;
      if (i2 & 536870912) {
       f556 = Math_fround(HEAPF32[i77 >> 2]);
       i69 = HEAP32[i515 >> 2] | 0;
       i482 = i69 + 693089735 | 0;
       i67 = HEAP32[i210 >> 2] | 0;
       i461 = i67 + 693089735 | 0;
       i65 = HEAP32[i211 >> 2] | 0;
       i74 = i65 + 693089735 | 0;
       i63 = HEAP32[i212 >> 2] | 0;
       i71 = i63 + 693089735 | 0;
       i64 = (Math_imul(i482, 1790253981) | 0) + 1900727103 | 0;
       i66 = (Math_imul(i461, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i482 = i482 << 11 ^ i482;
       i461 = i461 << 11 ^ i461;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i64 = Math_fround(Math_fround((i64 ^ i482 ^ i482 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i66 = Math_fround(Math_fround((i66 ^ i461 ^ i461 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i68 = Math_fround(Math_fround((i68 ^ i74 ^ i74 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i70 = Math_fround(Math_fround((i70 ^ i71 ^ i71 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       f556 = Math_fround(HEAPF32[i76 >> 2]);
       i69 = i69 + 13945730 | 0;
       i67 = i67 + 13945730 | 0;
       i65 = i65 + 13945730 | 0;
       i63 = i63 + 13945730 | 0;
       i71 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i482 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i67 = i67 << 11 ^ i67;
       i65 = i65 << 11 ^ i65;
       i63 = i63 << 11 ^ i63;
       i71 = Math_fround(Math_fround((i71 ^ i69 ^ i69 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i74 = Math_fround(Math_fround((i74 ^ i67 ^ i67 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i461 = Math_fround(Math_fround((i461 ^ i65 ^ i65 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i482 = Math_fround(Math_fround((i482 ^ i63 ^ i63 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i63 = i64 & 1;
       i65 = i66 & 1;
       i67 = i68 & 1;
       i69 = i70 & 1;
       i72 = i63 ^ 1;
       i459 = i65 ^ 1;
       i462 = i67 ^ 1;
       i510 = i69 ^ 1;
       i73 = i64 ? 3 : 2;
       i460 = i66 ? 3 : 2;
       i463 = i68 ? 3 : 2;
       i2 = i70 ? 3 : 2;
       i64 = i64 ? 2 : 3;
       i66 = i66 ? 2 : 3;
       i68 = i68 ? 2 : 3;
       i70 = i70 ? 2 : 3;
       HEAP32[i520 >> 2] = i71 ? i64 : i63;
       HEAP32[i435 >> 2] = i74 ? i66 : i65;
       HEAP32[i434 >> 2] = i461 ? i68 : i67;
       HEAP32[i433 >> 2] = i482 ? i70 : i69;
       HEAP32[i457 >> 2] = i71 ? i63 : i64;
       HEAP32[i456 >> 2] = i74 ? i65 : i66;
       HEAP32[i455 >> 2] = i461 ? i67 : i68;
       HEAP32[i454 >> 2] = i482 ? i69 : i70;
       HEAP32[i439 >> 2] = i71 ? i73 : i72;
       HEAP32[i438 >> 2] = i74 ? i460 : i459;
       HEAP32[i437 >> 2] = i461 ? i463 : i462;
       HEAP32[i436 >> 2] = i482 ? i2 : i510;
       HEAP32[i453 >> 2] = i71 ? i72 : i73;
       HEAP32[i452 >> 2] = i74 ? i459 : i460;
       HEAP32[i451 >> 2] = i461 ? i462 : i463;
       HEAP32[i440 >> 2] = i482 ? i510 : i2;
       i2 = HEAP32[i458 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f489 * Math_fround(HEAPF32[i516 >> 2]));
       f6 = Math_fround(f489 * Math_fround(HEAPF32[i214 >> 2]));
       f7 = Math_fround(f489 * Math_fround(HEAPF32[i215 >> 2]));
       f8 = Math_fround(f489 * Math_fround(HEAPF32[i216 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f553 = Math_fround(Math_floor(Math_fround(f55 * f9)));
        f554 = Math_fround(Math_floor(Math_fround(f55 * f10)));
        f555 = Math_fround(Math_floor(Math_fround(f55 * f25)));
        f556 = Math_fround(Math_floor(Math_fround(f55 * f26)));
        f549 = Math_fround(f490 * Math_fround(f9 - Math_fround(f488 * f553)));
        f550 = Math_fround(f490 * Math_fround(f10 - Math_fround(f488 * f554)));
        f551 = Math_fround(f490 * Math_fround(f25 - Math_fround(f488 * f555)));
        f552 = Math_fround(f490 * Math_fround(f26 - Math_fround(f488 * f556)));
        f553 = Math_fround(f56 - Math_fround(f491 * f553));
        f554 = Math_fround(f56 - Math_fround(f491 * f554));
        f555 = Math_fround(f56 - Math_fround(f491 * f555));
        f556 = Math_fround(f56 - Math_fround(f491 * f556));
        f541 = Math_fround(f491 + f553);
        f542 = Math_fround(f491 + f554);
        f543 = Math_fround(f491 + f555);
        f544 = Math_fround(f491 + f556);
        HEAPF32[i521 >> 2] = f549;
        HEAPF32[i384 >> 2] = f550;
        HEAPF32[i408 >> 2] = f551;
        HEAPF32[i432 >> 2] = f552;
        HEAPF32[i360 >> 2] = f541;
        HEAPF32[i383 >> 2] = f542;
        HEAPF32[i407 >> 2] = f543;
        HEAPF32[i431 >> 2] = f544;
        f545 = Math_fround(f490 + f549);
        f546 = Math_fround(f490 + f550);
        f547 = Math_fround(f490 + f551);
        f548 = Math_fround(f490 + f552);
        HEAPF32[i359 >> 2] = f545;
        HEAPF32[i382 >> 2] = f546;
        HEAPF32[i406 >> 2] = f547;
        HEAPF32[i430 >> 2] = f548;
        HEAPF32[i358 >> 2] = f541;
        HEAPF32[i381 >> 2] = f542;
        HEAPF32[i405 >> 2] = f543;
        HEAPF32[i429 >> 2] = f544;
        HEAPF32[i357 >> 2] = f545;
        HEAPF32[i380 >> 2] = f546;
        HEAPF32[i404 >> 2] = f547;
        HEAPF32[i428 >> 2] = f548;
        HEAPF32[i356 >> 2] = f553;
        HEAPF32[i379 >> 2] = f554;
        HEAPF32[i403 >> 2] = f555;
        HEAPF32[i427 >> 2] = f556;
        HEAPF32[i355 >> 2] = f549;
        HEAPF32[i378 >> 2] = f550;
        HEAPF32[i402 >> 2] = f551;
        HEAPF32[i426 >> 2] = f552;
        HEAPF32[i354 >> 2] = f553;
        HEAPF32[i377 >> 2] = f554;
        HEAPF32[i401 >> 2] = f555;
        HEAPF32[i425 >> 2] = f556;
       }
       if (i2 & 33554432 | 0) {
        f545 = Math_fround(f9 + Math_fround(1.0));
        f546 = Math_fround(f10 + Math_fround(1.0));
        f547 = Math_fround(f25 + Math_fround(1.0));
        f548 = Math_fround(f26 + Math_fround(1.0));
        f553 = Math_fround(f5 - f9);
        f554 = Math_fround(f6 - f10);
        f555 = Math_fround(f7 - f25);
        f556 = Math_fround(f8 - f26);
        f549 = Math_fround(Math_floor(Math_fround(f55 * f545)));
        f550 = Math_fround(Math_floor(Math_fround(f55 * f546)));
        f551 = Math_fround(Math_floor(Math_fround(f55 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f55 * f548)));
        f545 = Math_fround(f490 * Math_fround(f545 - Math_fround(f488 * f549)));
        f546 = Math_fround(f490 * Math_fround(f546 - Math_fround(f488 * f550)));
        f547 = Math_fround(f490 * Math_fround(f547 - Math_fround(f488 * f551)));
        f548 = Math_fround(f490 * Math_fround(f548 - Math_fround(f488 * f552)));
        f549 = Math_fround(f56 - Math_fround(f491 * f549));
        f550 = Math_fround(f56 - Math_fround(f491 * f550));
        f551 = Math_fround(f56 - Math_fround(f491 * f551));
        f552 = Math_fround(f56 - Math_fround(f491 * f552));
        f537 = Math_fround(f491 + f549);
        f538 = Math_fround(f491 + f550);
        f539 = Math_fround(f491 + f551);
        f540 = Math_fround(f491 + f552);
        HEAPF32[i522 >> 2] = f545;
        HEAPF32[i376 >> 2] = f546;
        HEAPF32[i400 >> 2] = f547;
        HEAPF32[i424 >> 2] = f548;
        HEAPF32[i353 >> 2] = f537;
        HEAPF32[i375 >> 2] = f538;
        HEAPF32[i399 >> 2] = f539;
        HEAPF32[i423 >> 2] = f540;
        HEAPF32[i352 >> 2] = f553;
        HEAPF32[i374 >> 2] = f554;
        HEAPF32[i398 >> 2] = f555;
        HEAPF32[i422 >> 2] = f556;
        HEAPF32[i351 >> 2] = f5;
        HEAPF32[i373 >> 2] = f6;
        HEAPF32[i397 >> 2] = f7;
        HEAPF32[i421 >> 2] = f8;
        f541 = Math_fround(f490 + f545);
        f542 = Math_fround(f490 + f546);
        f543 = Math_fround(f490 + f547);
        f544 = Math_fround(f490 + f548);
        HEAPF32[i350 >> 2] = f541;
        HEAPF32[i372 >> 2] = f542;
        HEAPF32[i396 >> 2] = f543;
        HEAPF32[i420 >> 2] = f544;
        HEAPF32[i349 >> 2] = f537;
        HEAPF32[i371 >> 2] = f538;
        HEAPF32[i395 >> 2] = f539;
        HEAPF32[i419 >> 2] = f540;
        HEAPF32[i348 >> 2] = f553;
        HEAPF32[i370 >> 2] = f554;
        HEAPF32[i394 >> 2] = f555;
        HEAPF32[i418 >> 2] = f556;
        HEAPF32[i347 >> 2] = f5;
        HEAPF32[i369 >> 2] = f6;
        HEAPF32[i393 >> 2] = f7;
        HEAPF32[i417 >> 2] = f8;
        HEAPF32[i346 >> 2] = f541;
        HEAPF32[i368 >> 2] = f542;
        HEAPF32[i392 >> 2] = f543;
        HEAPF32[i416 >> 2] = f544;
        HEAPF32[i345 >> 2] = f549;
        HEAPF32[i367 >> 2] = f550;
        HEAPF32[i391 >> 2] = f551;
        HEAPF32[i415 >> 2] = f552;
        HEAPF32[i336 >> 2] = f553;
        HEAPF32[i366 >> 2] = f554;
        HEAPF32[i390 >> 2] = f555;
        HEAPF32[i414 >> 2] = f556;
        HEAPF32[i335 >> 2] = f5;
        HEAPF32[i365 >> 2] = f6;
        HEAPF32[i389 >> 2] = f7;
        HEAPF32[i413 >> 2] = f8;
        HEAPF32[i334 >> 2] = f545;
        HEAPF32[i364 >> 2] = f546;
        HEAPF32[i388 >> 2] = f547;
        HEAPF32[i412 >> 2] = f548;
        HEAPF32[i333 >> 2] = f549;
        HEAPF32[i363 >> 2] = f550;
        HEAPF32[i387 >> 2] = f551;
        HEAPF32[i411 >> 2] = f552;
        HEAPF32[i332 >> 2] = f553;
        HEAPF32[i362 >> 2] = f554;
        HEAPF32[i386 >> 2] = f555;
        HEAPF32[i410 >> 2] = f556;
        HEAPF32[i331 >> 2] = f5;
        HEAPF32[i361 >> 2] = f6;
        HEAPF32[i385 >> 2] = f7;
        HEAPF32[i409 >> 2] = f8;
       }
      }
     }
     f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f36 * f36) + Math_fround(Math_fround(f28 * f28) + Math_fround(f32 * f32))))));
     f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f37 * f37) + Math_fround(Math_fround(f29 * f29) + Math_fround(f33 * f33))))));
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f38 * f38) + Math_fround(Math_fround(f30 * f30) + Math_fround(f34 * f34))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f39 * f39) + Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35))))));
     f545 = Math_fround(f492 * Math_fround(f28 * f553));
     f546 = Math_fround(f492 * Math_fround(f29 * f554));
     f547 = Math_fround(f492 * Math_fround(f30 * f555));
     f548 = Math_fround(f492 * Math_fround(f31 * f556));
     f549 = Math_fround(f492 * Math_fround(f32 * f553));
     f550 = Math_fround(f492 * Math_fround(f33 * f554));
     f551 = Math_fround(f492 * Math_fround(f34 * f555));
     f552 = Math_fround(f492 * Math_fround(f35 * f556));
     f553 = Math_fround(f492 * Math_fround(f36 * f553));
     f554 = Math_fround(f492 * Math_fround(f37 * f554));
     f555 = Math_fround(f492 * Math_fround(f38 * f555));
     f556 = Math_fround(f492 * Math_fround(f39 * f556));
     f533 = Math_fround(f484 + f545);
     f534 = Math_fround(f484 + f546);
     f535 = Math_fround(f484 + f547);
     f536 = Math_fround(f484 + f548);
     f537 = Math_fround(f473 + f549);
     f538 = Math_fround(f473 + f550);
     f539 = Math_fround(f473 + f551);
     f540 = Math_fround(f473 + f552);
     f541 = Math_fround(f475 + f553);
     f542 = Math_fround(f475 + f554);
     f543 = Math_fround(f475 + f555);
     f544 = Math_fround(f475 + f556);
     HEAPF32[i524 >> 2] = f533;
     HEAPF32[i126 >> 2] = f534;
     HEAPF32[i143 >> 2] = f535;
     HEAPF32[i160 >> 2] = f536;
     HEAPF32[i278 >> 2] = f537;
     HEAPF32[i121 >> 2] = f538;
     HEAPF32[i138 >> 2] = f539;
     HEAPF32[i155 >> 2] = f540;
     HEAPF32[i279 >> 2] = f541;
     HEAPF32[i116 >> 2] = f542;
     HEAPF32[i133 >> 2] = f543;
     HEAPF32[i150 >> 2] = f544;
     HEAPF32[i280 >> 2] = f533;
     HEAPF32[i125 >> 2] = f534;
     HEAPF32[i142 >> 2] = f535;
     HEAPF32[i159 >> 2] = f536;
     HEAPF32[i281 >> 2] = f537;
     HEAPF32[i120 >> 2] = f538;
     HEAPF32[i137 >> 2] = f539;
     HEAPF32[i154 >> 2] = f540;
     HEAPF32[i282 >> 2] = f541;
     HEAPF32[i115 >> 2] = f542;
     HEAPF32[i132 >> 2] = f543;
     HEAPF32[i149 >> 2] = f544;
     f545 = Math_fround(f484 - f545);
     f546 = Math_fround(f484 - f546);
     f547 = Math_fround(f484 - f547);
     f548 = Math_fround(f484 - f548);
     f549 = Math_fround(f473 - f549);
     f550 = Math_fround(f473 - f550);
     f551 = Math_fround(f473 - f551);
     f552 = Math_fround(f473 - f552);
     f553 = Math_fround(f475 - f553);
     f554 = Math_fround(f475 - f554);
     f555 = Math_fround(f475 - f555);
     f556 = Math_fround(f475 - f556);
     HEAPF32[i283 >> 2] = f545;
     HEAPF32[i124 >> 2] = f546;
     HEAPF32[i141 >> 2] = f547;
     HEAPF32[i158 >> 2] = f548;
     HEAPF32[i284 >> 2] = f549;
     HEAPF32[i119 >> 2] = f550;
     HEAPF32[i136 >> 2] = f551;
     HEAPF32[i153 >> 2] = f552;
     HEAPF32[i285 >> 2] = f553;
     HEAPF32[i114 >> 2] = f554;
     HEAPF32[i131 >> 2] = f555;
     HEAPF32[i148 >> 2] = f556;
     HEAPF32[i286 >> 2] = f545;
     HEAPF32[i123 >> 2] = f546;
     HEAPF32[i140 >> 2] = f547;
     HEAPF32[i157 >> 2] = f548;
     HEAPF32[i287 >> 2] = f549;
     HEAPF32[i118 >> 2] = f550;
     HEAPF32[i135 >> 2] = f551;
     HEAPF32[i152 >> 2] = f552;
     HEAPF32[i288 >> 2] = f553;
     HEAPF32[i113 >> 2] = f554;
     HEAPF32[i130 >> 2] = f555;
     HEAPF32[i147 >> 2] = f556;
     do if (i164) {
      i4 = HEAP32[i186 >> 2] | 0;
      i11 = HEAP32[i527 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i510 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i241 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i280 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i253 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i265 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i510 >> 2];
        i510 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i510 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i510 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i510 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i241 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i280 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i253 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i510 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i265 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i510 >> 2];
        i510 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i510 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i510 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f552 = Math_fround(HEAPF32[i241 >> 2]);
      f552 = Math_fround(f552 - Math_fround(HEAPF32[i523 >> 2]));
      f554 = Math_fround(HEAPF32[i242 >> 2]);
      f554 = Math_fround(f554 - Math_fround(HEAPF32[i230 >> 2]));
      f555 = Math_fround(HEAPF32[i243 >> 2]);
      f555 = Math_fround(f555 - Math_fround(HEAPF32[i231 >> 2]));
      f556 = Math_fround(HEAPF32[i244 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i232 >> 2]));
      f8 = Math_fround(HEAPF32[i245 >> 2]);
      f8 = Math_fround(f8 - Math_fround(HEAPF32[i233 >> 2]));
      f7 = Math_fround(HEAPF32[i246 >> 2]);
      f7 = Math_fround(f7 - Math_fround(HEAPF32[i234 >> 2]));
      f6 = Math_fround(HEAPF32[i247 >> 2]);
      f6 = Math_fround(f6 - Math_fround(HEAPF32[i235 >> 2]));
      f5 = Math_fround(HEAPF32[i248 >> 2]);
      f5 = Math_fround(f5 - Math_fround(HEAPF32[i236 >> 2]));
      f9 = Math_fround(HEAPF32[i249 >> 2]);
      f9 = Math_fround(f9 - Math_fround(HEAPF32[i237 >> 2]));
      f549 = Math_fround(HEAPF32[i250 >> 2]);
      f549 = Math_fround(f549 - Math_fround(HEAPF32[i238 >> 2]));
      f550 = Math_fround(HEAPF32[i251 >> 2]);
      f550 = Math_fround(f550 - Math_fround(HEAPF32[i239 >> 2]));
      f551 = Math_fround(HEAPF32[i252 >> 2]);
      f551 = Math_fround(f551 - Math_fround(HEAPF32[i240 >> 2]));
      f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f552 * f552) + Math_fround(f8 * f8)) + Math_fround(f9 * f9)))));
      f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f554 * f554) + Math_fround(f7 * f7)) + Math_fround(f549 * f549)))));
      f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f555 * f555) + Math_fround(f6 * f6)) + Math_fround(f550 * f550)))));
      f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f556 * f556) + Math_fround(f5 * f5)) + Math_fround(f551 * f551)))));
      f554 = Math_fround(f554 * f10);
      f555 = Math_fround(f555 * f25);
      f556 = Math_fround(f556 * f26);
      f8 = Math_fround(f8 * f553);
      f7 = Math_fround(f7 * f10);
      f6 = Math_fround(f6 * f25);
      f5 = Math_fround(f5 * f26);
      f9 = Math_fround(f9 * f553);
      f10 = Math_fround(f549 * f10);
      f25 = Math_fround(f550 * f25);
      f26 = Math_fround(f551 * f26);
      HEAPF32[i518 >> 2] = Math_fround(f552 * f553);
      HEAPF32[i127 >> 2] = f554;
      HEAPF32[i144 >> 2] = f555;
      HEAPF32[i161 >> 2] = f556;
      HEAPF32[i289 >> 2] = f8;
      HEAPF32[i122 >> 2] = f7;
      HEAPF32[i139 >> 2] = f6;
      HEAPF32[i156 >> 2] = f5;
      HEAPF32[i290 >> 2] = f9;
      HEAPF32[i117 >> 2] = f10;
      HEAPF32[i134 >> 2] = f25;
      HEAPF32[i151 >> 2] = f26;
      f26 = Math_fround(f27 * Math_fround(2.0));
      f25 = Math_fround(f40 * Math_fround(2.0));
      f10 = Math_fround(f41 * Math_fround(2.0));
      f9 = Math_fround(f42 * Math_fround(2.0));
      f5 = Math_fround(f43 * Math_fround(2.0));
      f6 = Math_fround(f44 * Math_fround(2.0));
      f7 = Math_fround(f45 * Math_fround(2.0));
      f8 = Math_fround(f46 * Math_fround(2.0));
      i4 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i3 = i11 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i2 = i12 ? (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i510 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      HEAPF32[i519 >> 2] = f26;
      HEAPF32[i129 >> 2] = f25;
      HEAPF32[i146 >> 2] = f10;
      HEAPF32[i163 >> 2] = f9;
      HEAP32[i112 >> 2] = i4;
      HEAP32[i128 >> 2] = i3;
      HEAP32[i145 >> 2] = i2;
      HEAP32[i162 >> 2] = i510;
      HEAP32[i111 >> 2] = 0;
      HEAP32[i111 + 4 >> 2] = 0;
      HEAP32[i111 + 8 >> 2] = 0;
      HEAP32[i111 + 12 >> 2] = 0;
      if (i291) {
       f536 = Math_fround(HEAPF32[i511 >> 2]);
       f554 = Math_fround(f497 * f536);
       f538 = Math_fround(HEAPF32[i179 >> 2]);
       f545 = Math_fround(f497 * f538);
       f540 = Math_fround(HEAPF32[i178 >> 2]);
       f553 = Math_fround(f497 * f540);
       f542 = Math_fround(HEAPF32[i177 >> 2]);
       f548 = Math_fround(f497 * f542);
       f537 = Math_fround(HEAPF32[i195 >> 2]);
       f544 = Math_fround(f500 * f537);
       f539 = Math_fround(HEAPF32[i182 >> 2]);
       f550 = Math_fround(f500 * f539);
       f541 = Math_fround(HEAPF32[i181 >> 2]);
       f549 = Math_fround(f500 * f541);
       f543 = Math_fround(HEAPF32[i180 >> 2]);
       f544 = Math_fround(f554 + f544);
       f550 = Math_fround(f545 + f550);
       f549 = Math_fround(f553 + f549);
       f548 = Math_fround(f548 + Math_fround(f500 * f543));
       f553 = Math_fround(HEAPF32[i196 >> 2]);
       f545 = Math_fround(f503 * f553);
       f554 = Math_fround(HEAPF32[i185 >> 2]);
       f546 = Math_fround(f503 * f554);
       f555 = Math_fround(HEAPF32[i184 >> 2]);
       f547 = Math_fround(f503 * f555);
       f556 = Math_fround(HEAPF32[i183 >> 2]);
       f546 = Math_fround(f550 + f546);
       f547 = Math_fround(f549 + f547);
       f548 = Math_fround(f548 + Math_fround(f503 * f556));
       f549 = Math_fround(Math_fround(Math_fround(f498 * f536) + Math_fround(f501 * f537)) + Math_fround(f504 * f553));
       f550 = Math_fround(Math_fround(Math_fround(f498 * f538) + Math_fround(f501 * f539)) + Math_fround(f504 * f554));
       f551 = Math_fround(Math_fround(Math_fround(f498 * f540) + Math_fround(f501 * f541)) + Math_fround(f504 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f498 * f542) + Math_fround(f501 * f543)) + Math_fround(f504 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f499 * f536) + Math_fround(f502 * f537)) + Math_fround(f505 * f553));
       f554 = Math_fround(Math_fround(Math_fround(f499 * f538) + Math_fround(f502 * f539)) + Math_fround(f505 * f554));
       f555 = Math_fround(Math_fround(Math_fround(f499 * f540) + Math_fround(f502 * f541)) + Math_fround(f505 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f499 * f542) + Math_fround(f502 * f543)) + Math_fround(f505 * f556));
       HEAPF32[i509 >> 2] = Math_fround(f544 + f545);
       HEAPF32[i292 >> 2] = f546;
       HEAPF32[i293 >> 2] = f547;
       HEAPF32[i294 >> 2] = f548;
       HEAPF32[i295 >> 2] = f549;
       HEAPF32[i296 >> 2] = f550;
       HEAPF32[i297 >> 2] = f551;
       HEAPF32[i298 >> 2] = f552;
       HEAPF32[i299 >> 2] = f553;
       HEAPF32[i300 >> 2] = f554;
       HEAPF32[i301 >> 2] = f555;
       HEAPF32[i302 >> 2] = f556;
      }
      if (i303) {
       i459 = HEAP32[i515 >> 2] | 0;
       i462 = i459 + 1068538453 | 0;
       i463 = HEAP32[i210 >> 2] | 0;
       i461 = i463 + 1068538453 | 0;
       i72 = HEAP32[i211 >> 2] | 0;
       i71 = i72 + 1068538453 | 0;
       i70 = HEAP32[i212 >> 2] | 0;
       i74 = i70 + 1068538453 | 0;
       i482 = (Math_imul(i462, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i461, 1790253981) | 0) + 1900727103 | 0;
       i510 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i460 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i462 = i462 << 11 ^ i462;
       i461 = i461 << 11 ^ i461;
       i71 = i71 << 11 ^ i71;
       i74 = i74 << 11 ^ i74;
       f554 = Math_fround(Math_fround((i73 ^ i461 ^ i461 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i510 ^ i71 ^ i71 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i460 ^ i74 ^ i74 >>> 8) & 8388607 ^ i460 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i525 >> 2] = Math_fround(Math_fround((i482 ^ i462 ^ i462 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i304 >> 2] = f554;
       HEAPF32[i305 >> 2] = f555;
       HEAPF32[i306 >> 2] = f556;
       i459 = i459 + 1068538454 | 0;
       i463 = i463 + 1068538454 | 0;
       i72 = i72 + 1068538454 | 0;
       i70 = i70 + 1068538454 | 0;
       i482 = (Math_imul(i459, 1790253981) | 0) + 1900727103 | 0;
       i462 = (Math_imul(i463, 1790253981) | 0) + 1900727103 | 0;
       i460 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i459 = i459 << 11 ^ i459;
       i463 = i463 << 11 ^ i463;
       i72 = i72 << 11 ^ i72;
       i70 = i70 << 11 ^ i70;
       f556 = Math_fround(Math_fround((i462 ^ i463 ^ i463 >>> 8) & 8388607 ^ i462 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i460 ^ i72 ^ i72 >>> 8) & 8388607 ^ i460 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f554 = Math_fround(Math_fround((i74 ^ i70 ^ i70 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i307 >> 2] = Math_fround(Math_fround((i482 ^ i459 ^ i459 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i308 >> 2] = f556;
       HEAPF32[i309 >> 2] = f555;
       HEAPF32[i310 >> 2] = f554;
       i482 = HEAP32[i515 >> 2] | 0;
       i459 = i482 + 1068538455 | 0;
       i74 = HEAP32[i210 >> 2] | 0;
       i70 = i74 + 1068538455 | 0;
       i460 = HEAP32[i211 >> 2] | 0;
       i72 = i460 + 1068538455 | 0;
       i462 = HEAP32[i212 >> 2] | 0;
       i463 = i462 + 1068538455 | 0;
       i510 = (Math_imul(i459, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i463, 1790253981) | 0) + 1900727103 | 0;
       i459 = i459 << 11 ^ i459;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       i463 = i463 << 11 ^ i463;
       f554 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i461 ^ i463 ^ i463 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i311 >> 2] = Math_fround(Math_fround((i510 ^ i459 ^ i459 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i312 >> 2] = f554;
       HEAPF32[i313 >> 2] = f555;
       HEAPF32[i314 >> 2] = f556;
       f556 = Math_fround(Math_fround(HEAPF32[i514 >> 2]) * Math_fround(1.0e5));
       f555 = Math_fround(Math_fround(HEAPF32[i206 >> 2]) * Math_fround(1.0e5));
       f554 = Math_fround(Math_fround(HEAPF32[i207 >> 2]) * Math_fround(1.0e5));
       i482 = i482 + 1068538453 + ~~f556 | 0;
       i74 = i74 + 1068538453 + ~~f555 | 0;
       i460 = i460 + 1068538453 + ~~f554 | 0;
       i462 = i462 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i208 >> 2]) * Math_fround(1.0e5)) | 0;
       i510 = (Math_imul(i482, 1790253981) | 0) + 1900727103 | 0;
       i459 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i461 = (Math_imul(i460, 1790253981) | 0) + 1900727103 | 0;
       i463 = (Math_imul(i462, 1790253981) | 0) + 1900727103 | 0;
       i482 = i482 << 11 ^ i482;
       i74 = i74 << 11 ^ i74;
       i460 = i460 << 11 ^ i460;
       i462 = i462 << 11 ^ i462;
       f554 = Math_fround(Math_fround((i459 ^ i74 ^ i74 >>> 8) & 8388607 ^ i459 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i461 ^ i460 ^ i460 >>> 8) & 8388607 ^ i461 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i463 ^ i462 ^ i462 >>> 8) & 8388607 ^ i463 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i315 >> 2] = Math_fround(Math_fround((i510 ^ i482 ^ i482 >>> 8) & 8388607 ^ i510 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i316 >> 2] = f554;
       HEAPF32[i317 >> 2] = f555;
       HEAPF32[i318 >> 2] = f556;
      }
      i67 = HEAP32[i186 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i86 >> 2] | 0;
      i70 = HEAP32[i88 >> 2] | 0;
      i71 = HEAP32[i205 >> 2] | 0;
      i72 = HEAP32[i89 >> 2] | 0;
      i73 = HEAP32[i90 >> 2] | 0;
      i74 = HEAP32[i527 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i509 + (i66 << 2) | 0;
       i12 = i326 + (i66 << 2) | 0;
       i13 = i327 + (i66 << 2) | 0;
       i14 = i525 + (i66 << 2) | 0;
       i15 = i307 + (i66 << 2) | 0;
       i16 = i311 + (i66 << 2) | 0;
       i17 = i315 + (i66 << 2) | 0;
       i18 = i518 + (i66 << 2) | 0;
       i19 = i80 + (i66 << 2) | 0;
       i20 = i81 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i519 + (i66 << 2) | 0;
       i61 = i91 + (i66 << 2) | 0;
       i62 = i92 + (i66 << 2) | 0;
       i63 = i517 + (i66 << 2) | 0;
       i64 = i93 + (i66 << 2) | 0;
       i65 = i94 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i523 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i319) {
         i510 = i524 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i510 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i510 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i510 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i320) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i321) {
         i510 = i521 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i510 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i322) {
         i510 = i522 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i510 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i323) {
         f556 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f556;
         i1 = i1 + 16 | 0;
        }
        if (!i324) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i325) {
         i510 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i510;
         HEAP32[i1 + 4 >> 2] = i510;
         HEAP32[i1 + 8 >> 2] = i510;
         i1 = i1 + 12 | 0;
        }
        if (i291) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i328) {
         f556 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i510 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f556;
         HEAP32[i1 + 4 >> 2] = i510;
         i1 = i1 + 8 | 0;
        }
        if (!i329) {
         i510 = (HEAP32[i87 >> 2] & 2147483647 | 0) == 0 ? i528 : i22;
         HEAP32[i1 >> 2] = HEAP32[i510 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i330) {
         i510 = (HEAP32[i83 >> 2] & 2147483647 | 0) == 0 ? i528 : i21;
         HEAP32[i1 >> 2] = HEAP32[i510 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i510 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i510 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i510 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i303) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i78) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i165 >>> 0);
   }
   STACKTOP = i530;
   return;
  }
 case 2:
  {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i463 = i13 + 380 | 0;
   f478 = Math_fround(HEAPF32[i463 >> 2]);
   f470 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f473 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 392 | 0;
   f476 = Math_fround(HEAPF32[i463 >> 2]);
   f468 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f471 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 332 | 0;
   f479 = Math_fround((HEAP32[i463 >> 2] & 4095) >>> 0);
   f480 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f481 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f483 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   i3 = i13 + 420 | 0;
   f484 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i1 = i13 + 408 | 0;
   f477 = Math_fround(HEAPF32[i1 >> 2]);
   f469 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f472 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i1 = i13 + 336 | 0;
   f485 = Math_fround(HEAPF32[i1 >> 2]);
   f486 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f487 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f488 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   i1 = i13 + 352 | 0;
   f475 = Math_fround(HEAPF32[i1 >> 2]);
   f467 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i13 + 360 | 0;
   f474 = Math_fround(HEAPF32[i1 >> 2]);
   f466 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i2 = HEAP32[i2 + 56 >> 2] | 0;
   f441 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f442 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f443 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f444 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f445 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f446 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f447 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f448 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f449 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f450 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f464 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f465 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   i1 = i13 + 64 | 0;
   i438 = i520 + 12 | 0;
   i439 = i520 + 8 | 0;
   i440 = i520 + 4 | 0;
   i451 = i520 + 28 | 0;
   HEAP32[i520 >> 2] = 0;
   HEAP32[i520 + 4 >> 2] = 0;
   HEAP32[i520 + 8 >> 2] = 0;
   HEAP32[i520 + 12 >> 2] = 0;
   HEAP32[i451 >> 2] = 1;
   i452 = i520 + 24 | 0;
   HEAP32[i452 >> 2] = 1;
   i453 = i520 + 20 | 0;
   HEAP32[i453 >> 2] = 1;
   i454 = i520 + 16 | 0;
   HEAP32[i454 >> 2] = 1;
   i455 = i520 + 44 | 0;
   HEAP32[i455 >> 2] = 2;
   i456 = i520 + 40 | 0;
   HEAP32[i456 >> 2] = 2;
   i457 = i520 + 36 | 0;
   HEAP32[i457 >> 2] = 2;
   i458 = i520 + 32 | 0;
   HEAP32[i458 >> 2] = 2;
   i459 = i520 + 60 | 0;
   HEAP32[i459 >> 2] = 3;
   i460 = i520 + 56 | 0;
   HEAP32[i460 >> 2] = 3;
   i461 = i520 + 52 | 0;
   HEAP32[i461 >> 2] = 3;
   i462 = i520 + 48 | 0;
   HEAP32[i462 >> 2] = 3;
   i389 = i521 + 4 | 0;
   i413 = i521 + 8 | 0;
   i437 = i521 + 12 | 0;
   i365 = i521 + 16 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAPF32[i365 >> 2] = Math_fround(1.0);
   i388 = i521 + 20 | 0;
   HEAPF32[i388 >> 2] = Math_fround(1.0);
   i412 = i521 + 24 | 0;
   HEAPF32[i412 >> 2] = Math_fround(1.0);
   i436 = i521 + 28 | 0;
   HEAPF32[i436 >> 2] = Math_fround(1.0);
   i364 = i521 + 32 | 0;
   HEAPF32[i364 >> 2] = Math_fround(1.0);
   i387 = i521 + 36 | 0;
   HEAPF32[i387 >> 2] = Math_fround(1.0);
   i411 = i521 + 40 | 0;
   HEAPF32[i411 >> 2] = Math_fround(1.0);
   i435 = i521 + 44 | 0;
   HEAPF32[i435 >> 2] = Math_fround(1.0);
   i363 = i521 + 48 | 0;
   HEAPF32[i363 >> 2] = Math_fround(1.0);
   i386 = i521 + 52 | 0;
   HEAPF32[i386 >> 2] = Math_fround(1.0);
   i410 = i521 + 56 | 0;
   HEAPF32[i410 >> 2] = Math_fround(1.0);
   i434 = i521 + 60 | 0;
   HEAPF32[i434 >> 2] = Math_fround(1.0);
   i362 = i521 + 64 | 0;
   HEAPF32[i362 >> 2] = Math_fround(1.0);
   i385 = i521 + 68 | 0;
   HEAPF32[i385 >> 2] = Math_fround(1.0);
   i409 = i521 + 72 | 0;
   HEAPF32[i409 >> 2] = Math_fround(1.0);
   i433 = i521 + 76 | 0;
   HEAPF32[i433 >> 2] = Math_fround(1.0);
   i361 = i521 + 80 | 0;
   i384 = i521 + 84 | 0;
   i408 = i521 + 88 | 0;
   i432 = i521 + 92 | 0;
   i360 = i521 + 96 | 0;
   i383 = i521 + 100 | 0;
   i407 = i521 + 104 | 0;
   i431 = i521 + 108 | 0;
   i359 = i521 + 112 | 0;
   i382 = i521 + 116 | 0;
   i406 = i521 + 120 | 0;
   i430 = i521 + 124 | 0;
   i16 = i361;
   i15 = i16 + 48 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i381 = i522 + 4 | 0;
   i405 = i522 + 8 | 0;
   i429 = i522 + 12 | 0;
   i358 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i358 >> 2] = Math_fround(1.0);
   i380 = i522 + 20 | 0;
   HEAPF32[i380 >> 2] = Math_fround(1.0);
   i404 = i522 + 24 | 0;
   HEAPF32[i404 >> 2] = Math_fround(1.0);
   i428 = i522 + 28 | 0;
   HEAPF32[i428 >> 2] = Math_fround(1.0);
   i357 = i522 + 32 | 0;
   i379 = i522 + 36 | 0;
   i403 = i522 + 40 | 0;
   i427 = i522 + 44 | 0;
   i356 = i522 + 48 | 0;
   i378 = i522 + 52 | 0;
   i402 = i522 + 56 | 0;
   i426 = i522 + 60 | 0;
   i355 = i522 + 64 | 0;
   HEAP32[i357 >> 2] = 0;
   HEAP32[i357 + 4 >> 2] = 0;
   HEAP32[i357 + 8 >> 2] = 0;
   HEAP32[i357 + 12 >> 2] = 0;
   HEAP32[i357 + 16 >> 2] = 0;
   HEAP32[i357 + 20 >> 2] = 0;
   HEAP32[i357 + 24 >> 2] = 0;
   HEAP32[i357 + 28 >> 2] = 0;
   HEAPF32[i355 >> 2] = Math_fround(1.0);
   i377 = i522 + 68 | 0;
   HEAPF32[i377 >> 2] = Math_fround(1.0);
   i401 = i522 + 72 | 0;
   HEAPF32[i401 >> 2] = Math_fround(1.0);
   i425 = i522 + 76 | 0;
   HEAPF32[i425 >> 2] = Math_fround(1.0);
   i354 = i522 + 80 | 0;
   HEAPF32[i354 >> 2] = Math_fround(1.0);
   i376 = i522 + 84 | 0;
   HEAPF32[i376 >> 2] = Math_fround(1.0);
   i400 = i522 + 88 | 0;
   HEAPF32[i400 >> 2] = Math_fround(1.0);
   i424 = i522 + 92 | 0;
   HEAPF32[i424 >> 2] = Math_fround(1.0);
   i353 = i522 + 96 | 0;
   i375 = i522 + 100 | 0;
   i399 = i522 + 104 | 0;
   i423 = i522 + 108 | 0;
   i352 = i522 + 112 | 0;
   i374 = i522 + 116 | 0;
   i398 = i522 + 120 | 0;
   i422 = i522 + 124 | 0;
   i351 = i522 + 128 | 0;
   HEAP32[i353 >> 2] = 0;
   HEAP32[i353 + 4 >> 2] = 0;
   HEAP32[i353 + 8 >> 2] = 0;
   HEAP32[i353 + 12 >> 2] = 0;
   HEAP32[i353 + 16 >> 2] = 0;
   HEAP32[i353 + 20 >> 2] = 0;
   HEAP32[i353 + 24 >> 2] = 0;
   HEAP32[i353 + 28 >> 2] = 0;
   HEAPF32[i351 >> 2] = Math_fround(1.0);
   i373 = i522 + 132 | 0;
   HEAPF32[i373 >> 2] = Math_fround(1.0);
   i397 = i522 + 136 | 0;
   HEAPF32[i397 >> 2] = Math_fround(1.0);
   i421 = i522 + 140 | 0;
   HEAPF32[i421 >> 2] = Math_fround(1.0);
   i350 = i522 + 144 | 0;
   i372 = i522 + 148 | 0;
   i396 = i522 + 152 | 0;
   i420 = i522 + 156 | 0;
   i349 = i522 + 160 | 0;
   i371 = i522 + 164 | 0;
   i395 = i522 + 168 | 0;
   i419 = i522 + 172 | 0;
   i348 = i522 + 176 | 0;
   i370 = i522 + 180 | 0;
   i394 = i522 + 184 | 0;
   i418 = i522 + 188 | 0;
   i347 = i522 + 192 | 0;
   i369 = i522 + 196 | 0;
   i393 = i522 + 200 | 0;
   i417 = i522 + 204 | 0;
   i346 = i522 + 208 | 0;
   i368 = i522 + 212 | 0;
   i392 = i522 + 216 | 0;
   i416 = i522 + 220 | 0;
   i345 = i522 + 224 | 0;
   i367 = i522 + 228 | 0;
   i391 = i522 + 232 | 0;
   i415 = i522 + 236 | 0;
   i336 = i522 + 240 | 0;
   i366 = i522 + 244 | 0;
   i390 = i522 + 248 | 0;
   i414 = i522 + 252 | 0;
   i16 = i350;
   i15 = i16 + 112 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i16 = i12;
   i15 = i16 + 64 | 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
    i16 = i16 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
   f338 = Math_fround(HEAPF32[i3 >> 2]);
   f550 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f82 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f552 = Math_fround(HEAPF32[i14 >> 2]);
   i331 = i14 + 4 | 0;
   f548 = Math_fround(HEAPF32[i331 >> 2]);
   i332 = i14 + 8 | 0;
   f342 = Math_fround(HEAPF32[i332 >> 2]);
   i333 = i14 + 12 | 0;
   f554 = Math_fround(HEAPF32[i333 >> 2]);
   i334 = i14 + 16 | 0;
   f549 = Math_fround(HEAPF32[i334 >> 2]);
   i335 = i14 + 20 | 0;
   f343 = Math_fround(HEAPF32[i335 >> 2]);
   i482 = i14 + 24 | 0;
   f556 = Math_fround(HEAPF32[i482 >> 2]);
   i163 = i14 + 28 | 0;
   f551 = Math_fround(HEAPF32[i163 >> 2]);
   i162 = i14 + 32 | 0;
   f344 = Math_fround(HEAPF32[i162 >> 2]);
   f553 = Math_fround(f548 * Math_fround(0.0));
   f339 = Math_fround(f342 * Math_fround(0.0));
   f85 = Math_fround(Math_fround(Math_fround(f338 * f552) + f553) + f339);
   f555 = Math_fround(f549 * Math_fround(0.0));
   f340 = Math_fround(f343 * Math_fround(0.0));
   f337 = Math_fround(Math_fround(Math_fround(f338 * f554) + f555) + f340);
   f84 = Math_fround(f551 * Math_fround(0.0));
   f341 = Math_fround(f344 * Math_fround(0.0));
   f338 = Math_fround(Math_fround(Math_fround(f338 * f556) + f84) + f341);
   f552 = Math_fround(f552 * Math_fround(0.0));
   f339 = Math_fround(Math_fround(f552 + Math_fround(f550 * f548)) + f339);
   f554 = Math_fround(f554 * Math_fround(0.0));
   f340 = Math_fround(Math_fround(f554 + Math_fround(f550 * f549)) + f340);
   f556 = Math_fround(f556 * Math_fround(0.0));
   f341 = Math_fround(Math_fround(f556 + Math_fround(f550 * f551)) + f341);
   f342 = Math_fround(Math_fround(f552 + f553) + Math_fround(f82 * f342));
   f343 = Math_fround(Math_fround(f554 + f555) + Math_fround(f82 * f343));
   f344 = Math_fround(Math_fround(f556 + f84) + Math_fround(f82 * f344));
   HEAPF32[i14 >> 2] = f85;
   HEAPF32[i331 >> 2] = f339;
   HEAPF32[i332 >> 2] = f342;
   HEAPF32[i333 >> 2] = f337;
   HEAPF32[i334 >> 2] = f340;
   HEAPF32[i335 >> 2] = f343;
   HEAPF32[i482 >> 2] = f338;
   HEAPF32[i163 >> 2] = f341;
   HEAPF32[i162 >> 2] = f344;
   f82 = Math_fround(Math_fround(1.0) / f479);
   f84 = Math_fround(Math_fround(1.0) - f483);
   i162 = (i2 | 0) == 27;
   HEAP32[i510 >> 2] = 0;
   HEAP32[i510 + 4 >> 2] = 0;
   HEAP32[i510 + 8 >> 2] = 0;
   HEAP32[i510 + 12 >> 2] = 0;
   i163 = HEAP32[i526 + 12 >> 2] | 0;
   if (i163 | 0) {
    i164 = i528 + 12 | 0;
    i165 = i528 + 8 | 0;
    i166 = i528 + 4 | 0;
    i167 = i528 + 16 | 0;
    i168 = i528 + 28 | 0;
    i169 = i528 + 24 | 0;
    i170 = i528 + 20 | 0;
    i171 = i528 + 32 | 0;
    i172 = i528 + 44 | 0;
    i173 = i528 + 40 | 0;
    i174 = i528 + 36 | 0;
    i175 = i529 + 32 | 0;
    i176 = i529 + 44 | 0;
    i177 = i529 + 40 | 0;
    i178 = i529 + 36 | 0;
    i179 = i511 + 12 | 0;
    i180 = i511 + 8 | 0;
    i181 = i511 + 4 | 0;
    i182 = i511 + 28 | 0;
    i183 = i511 + 24 | 0;
    i184 = i511 + 20 | 0;
    i185 = i511 + 44 | 0;
    i186 = i511 + 40 | 0;
    i187 = i511 + 36 | 0;
    i188 = i527 + 20 | 0;
    i189 = i526 + 20 | 0;
    i190 = i526 + 40 | 0;
    i191 = i526 + 340 | 0;
    i192 = i526 + 60 | 0;
    i193 = i526 + 80 | 0;
    i194 = i526 + 100 | 0;
    i195 = i526 + 120 | 0;
    i196 = i526 + 140 | 0;
    i197 = i526 + 160 | 0;
    i198 = i511 + 16 | 0;
    i199 = i511 + 32 | 0;
    i200 = i527 + 4 | 0;
    i201 = i512 + 4 | 0;
    i202 = i512 + 8 | 0;
    i203 = i512 + 12 | 0;
    i204 = i527 + 8 | 0;
    i205 = i513 + 4 | 0;
    i206 = i513 + 8 | 0;
    i207 = i513 + 12 | 0;
    i208 = i526 + 520 | 0;
    i209 = i514 + 4 | 0;
    i210 = i514 + 8 | 0;
    i211 = i514 + 12 | 0;
    i212 = i526 + 500 | 0;
    i213 = i515 + 4 | 0;
    i214 = i515 + 8 | 0;
    i215 = i515 + 12 | 0;
    i216 = i527 + 16 | 0;
    i217 = i516 + 4 | 0;
    i218 = i516 + 8 | 0;
    i219 = i516 + 12 | 0;
    i220 = i528 + 16 | 0;
    i221 = i528 + 32 | 0;
    i222 = i517 + 4 | 0;
    i223 = i517 + 8 | 0;
    i224 = i517 + 12 | 0;
    i225 = i517 + 16 | 0;
    i226 = i517 + 20 | 0;
    i227 = i517 + 24 | 0;
    i228 = i517 + 28 | 0;
    i229 = i517 + 32 | 0;
    i230 = i517 + 36 | 0;
    i231 = i517 + 40 | 0;
    i232 = i517 + 44 | 0;
    i233 = i529 + 32 | 0;
    i234 = i523 + 4 | 0;
    i235 = i523 + 8 | 0;
    i236 = i523 + 12 | 0;
    i237 = i523 + 16 | 0;
    i238 = i523 + 20 | 0;
    i239 = i523 + 24 | 0;
    i240 = i523 + 28 | 0;
    i241 = i523 + 32 | 0;
    i242 = i523 + 36 | 0;
    i243 = i523 + 40 | 0;
    i244 = i523 + 44 | 0;
    i245 = i523 + 48 | 0;
    i246 = i523 + 52 | 0;
    i247 = i523 + 56 | 0;
    i248 = i523 + 60 | 0;
    i249 = i523 + 64 | 0;
    i250 = i523 + 68 | 0;
    i251 = i523 + 72 | 0;
    i252 = i523 + 76 | 0;
    i253 = i523 + 80 | 0;
    i254 = i523 + 84 | 0;
    i255 = i523 + 88 | 0;
    i256 = i523 + 92 | 0;
    i257 = i523 + 96 | 0;
    i258 = i523 + 100 | 0;
    i259 = i523 + 104 | 0;
    i260 = i523 + 108 | 0;
    i261 = i523 + 112 | 0;
    i262 = i523 + 116 | 0;
    i263 = i523 + 120 | 0;
    i264 = i523 + 124 | 0;
    i265 = i523 + 128 | 0;
    i266 = i523 + 132 | 0;
    i267 = i523 + 136 | 0;
    i268 = i523 + 140 | 0;
    i269 = i523 + 144 | 0;
    i270 = i523 + 148 | 0;
    i271 = i523 + 152 | 0;
    i272 = i523 + 156 | 0;
    i273 = i523 + 160 | 0;
    i274 = i523 + 164 | 0;
    i275 = i523 + 168 | 0;
    i276 = i523 + 172 | 0;
    i277 = i523 + 176 | 0;
    i278 = i523 + 180 | 0;
    i279 = i523 + 184 | 0;
    i280 = i523 + 188 | 0;
    i281 = (i2 & 48 | 0) == 0;
    i124 = i524 + 4 | 0;
    i141 = i524 + 8 | 0;
    i158 = i524 + 12 | 0;
    i282 = i524 + 16 | 0;
    i119 = i524 + 20 | 0;
    i136 = i524 + 24 | 0;
    i153 = i524 + 28 | 0;
    i283 = i524 + 32 | 0;
    i114 = i524 + 36 | 0;
    i131 = i524 + 40 | 0;
    i148 = i524 + 44 | 0;
    i284 = i524 + 48 | 0;
    i123 = i524 + 52 | 0;
    i140 = i524 + 56 | 0;
    i157 = i524 + 60 | 0;
    i285 = i524 + 64 | 0;
    i118 = i524 + 68 | 0;
    i135 = i524 + 72 | 0;
    i152 = i524 + 76 | 0;
    i286 = i524 + 80 | 0;
    i113 = i524 + 84 | 0;
    i130 = i524 + 88 | 0;
    i147 = i524 + 92 | 0;
    i287 = i524 + 96 | 0;
    i122 = i524 + 100 | 0;
    i139 = i524 + 104 | 0;
    i156 = i524 + 108 | 0;
    i288 = i524 + 112 | 0;
    i117 = i524 + 116 | 0;
    i134 = i524 + 120 | 0;
    i151 = i524 + 124 | 0;
    i289 = i524 + 128 | 0;
    i112 = i524 + 132 | 0;
    i129 = i524 + 136 | 0;
    i146 = i524 + 140 | 0;
    i290 = i524 + 144 | 0;
    i121 = i524 + 148 | 0;
    i138 = i524 + 152 | 0;
    i155 = i524 + 156 | 0;
    i291 = i524 + 160 | 0;
    i116 = i524 + 164 | 0;
    i133 = i524 + 168 | 0;
    i150 = i524 + 172 | 0;
    i292 = i524 + 176 | 0;
    i111 = i524 + 180 | 0;
    i128 = i524 + 184 | 0;
    i145 = i524 + 188 | 0;
    i125 = i518 + 4 | 0;
    i142 = i518 + 8 | 0;
    i159 = i518 + 12 | 0;
    i293 = i518 + 16 | 0;
    i120 = i518 + 20 | 0;
    i137 = i518 + 24 | 0;
    i154 = i518 + 28 | 0;
    i294 = i518 + 32 | 0;
    i115 = i518 + 36 | 0;
    i132 = i518 + 40 | 0;
    i149 = i518 + 44 | 0;
    i127 = i519 + 4 | 0;
    i144 = i519 + 8 | 0;
    i161 = i519 + 12 | 0;
    i295 = i519 + 16 | 0;
    i126 = i519 + 20 | 0;
    i143 = i519 + 24 | 0;
    i160 = i519 + 28 | 0;
    i110 = i519 + 32 | 0;
    i296 = (i2 & 512 | 0) != 0;
    i297 = i509 + 4 | 0;
    i298 = i509 + 8 | 0;
    i299 = i509 + 12 | 0;
    i300 = i509 + 16 | 0;
    i301 = i509 + 20 | 0;
    i302 = i509 + 24 | 0;
    i303 = i509 + 28 | 0;
    i304 = i509 + 32 | 0;
    i305 = i509 + 36 | 0;
    i306 = i509 + 40 | 0;
    i307 = i509 + 44 | 0;
    i308 = (i2 & 8192 | 0) != 0;
    i309 = i525 + 4 | 0;
    i310 = i525 + 8 | 0;
    i311 = i525 + 12 | 0;
    i312 = i525 + 16 | 0;
    i313 = i525 + 20 | 0;
    i314 = i525 + 24 | 0;
    i315 = i525 + 28 | 0;
    i316 = i525 + 32 | 0;
    i317 = i525 + 36 | 0;
    i318 = i525 + 40 | 0;
    i319 = i525 + 44 | 0;
    i320 = i525 + 48 | 0;
    i321 = i525 + 52 | 0;
    i322 = i525 + 56 | 0;
    i323 = i525 + 60 | 0;
    i324 = (i2 & 2 | 0) == 0;
    i325 = (i2 & 8 | 0) == 0;
    i326 = (i2 & 16 | 0) == 0;
    i327 = (i2 & 32 | 0) == 0;
    i328 = (i2 & 64 | 0) == 0;
    i329 = (i2 & 128 | 0) == 0;
    i330 = (i2 & 256 | 0) == 0;
    i331 = i509 + 16 | 0;
    i332 = i509 + 32 | 0;
    i333 = (i2 & 1024 | 0) == 0;
    i334 = (i2 & 2048 | 0) == 0;
    i335 = (i2 & 4096 | 0) == 0;
    i77 = (i2 & 4 | 0) == 0;
    i78 = i518 + 16 | 0;
    i80 = i518 + 32 | 0;
    i81 = i526 + 864 | 0;
    i83 = i526 + 848 | 0;
    i86 = i526 + 844 | 0;
    i87 = i526 + 828 | 0;
    i88 = i526 + 540 | 0;
    i89 = i519 + 16 | 0;
    i90 = i519 + 32 | 0;
    i91 = i517 + 16 | 0;
    i92 = i517 + 32 | 0;
    i93 = i523 + 16 | 0;
    i94 = i523 + 32 | 0;
    i95 = i524 + 16 | 0;
    i96 = i524 + 32 | 0;
    i97 = i245 + 16 | 0;
    i98 = i245 + 32 | 0;
    i99 = i284 + 16 | 0;
    i100 = i284 + 32 | 0;
    i101 = i257 + 16 | 0;
    i102 = i257 + 32 | 0;
    i103 = i287 + 16 | 0;
    i104 = i287 + 32 | 0;
    i105 = i269 + 16 | 0;
    i106 = i269 + 32 | 0;
    i107 = i290 + 16 | 0;
    i108 = i290 + 32 | 0;
    i109 = i4 + 564 | 0;
    i76 = i4 + 568 | 0;
    i75 = 0;
    i1 = i17;
    do {
     i16 = i528;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     i16 = i529;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     i16 = i511;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     HEAP32[i512 >> 2] = 0;
     HEAP32[i512 + 4 >> 2] = 0;
     HEAP32[i512 + 8 >> 2] = 0;
     HEAP32[i512 + 12 >> 2] = 0;
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     i22 = HEAP32[i188 >> 2] | 0;
     i23 = HEAP32[i526 >> 2] | 0;
     if (!i22) {
      i64 = i23 + (i75 << 2) | 0;
      i65 = HEAP32[i64 + 4 >> 2] | 0;
      i66 = HEAP32[i64 + 8 >> 2] | 0;
      i67 = HEAP32[i64 + 12 >> 2] | 0;
      i71 = (HEAP32[i189 >> 2] | 0) + (i75 << 2) | 0;
      i68 = HEAP32[i71 >> 2] | 0;
      i69 = HEAP32[i71 + 4 >> 2] | 0;
      i70 = HEAP32[i71 + 8 >> 2] | 0;
      i71 = HEAP32[i71 + 12 >> 2] | 0;
      i72 = (HEAP32[i190 >> 2] | 0) + (i75 << 2) | 0;
      i482 = HEAP32[i72 >> 2] | 0;
      i74 = HEAP32[i72 + 4 >> 2] | 0;
      i73 = HEAP32[i72 + 8 >> 2] | 0;
      i72 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i528 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i166 >> 2] = i65;
      HEAP32[i165 >> 2] = i66;
      HEAP32[i164 >> 2] = i67;
      HEAP32[i167 >> 2] = i68;
      HEAP32[i170 >> 2] = i69;
      HEAP32[i169 >> 2] = i70;
      HEAP32[i168 >> 2] = i71;
      HEAP32[i171 >> 2] = i482;
      HEAP32[i174 >> 2] = i74;
      HEAP32[i173 >> 2] = i73;
      HEAP32[i172 >> 2] = i72;
      i72 = (HEAP32[i191 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i175 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i178 >> 2] = i73;
      HEAP32[i177 >> 2] = i74;
      HEAP32[i176 >> 2] = i482;
      i482 = (HEAP32[i192 >> 2] | 0) + (i75 << 2) | 0;
      f544 = Math_fround(HEAPF32[i482 >> 2]);
      f534 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f535 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f536 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i193 >> 2] | 0) + (i75 << 2) | 0;
      f537 = Math_fround(HEAPF32[i482 >> 2]);
      f538 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f539 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f540 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      f541 = Math_fround(HEAPF32[i482 >> 2]);
      f542 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f543 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f556 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i195 >> 2] | 0) + (i75 << 2) | 0;
      f545 = Math_fround(HEAPF32[i482 >> 2]);
      f546 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f547 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f548 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i196 >> 2] | 0) + (i75 << 2) | 0;
      f549 = Math_fround(HEAPF32[i482 >> 2]);
      f550 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f551 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f552 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      f553 = Math_fround(HEAPF32[i482 >> 2]);
      f554 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f555 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f546 = Math_fround(f534 + f546);
      f547 = Math_fround(f535 + f547);
      f548 = Math_fround(f536 + f548);
      f549 = Math_fround(f537 + f549);
      f550 = Math_fround(f538 + f550);
      f551 = Math_fround(f539 + f551);
      f552 = Math_fround(f540 + f552);
      f553 = Math_fround(f541 + f553);
      f554 = Math_fround(f542 + f554);
      f555 = Math_fround(f543 + f555);
      f556 = Math_fround(f556 + Math_fround(HEAPF32[i482 + 12 >> 2]));
      HEAPF32[i511 >> 2] = Math_fround(f544 + f545);
      HEAPF32[i181 >> 2] = f546;
      HEAPF32[i180 >> 2] = f547;
      HEAPF32[i179 >> 2] = f548;
      HEAPF32[i198 >> 2] = f549;
      HEAPF32[i184 >> 2] = f550;
      HEAPF32[i183 >> 2] = f551;
      HEAPF32[i182 >> 2] = f552;
      HEAPF32[i199 >> 2] = f553;
      HEAPF32[i187 >> 2] = f554;
      HEAPF32[i186 >> 2] = f555;
      HEAPF32[i185 >> 2] = f556;
      i482 = (HEAP32[i200 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i482 + 4 >> 2] | 0;
      i73 = HEAP32[i482 + 8 >> 2] | 0;
      i72 = HEAP32[i482 + 12 >> 2] | 0;
      HEAP32[i512 >> 2] = HEAP32[i482 >> 2];
      HEAP32[i201 >> 2] = i74;
      HEAP32[i202 >> 2] = i73;
      HEAP32[i203 >> 2] = i72;
      i72 = (HEAP32[i204 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i205 >> 2] = i73;
      HEAP32[i206 >> 2] = i74;
      HEAP32[i207 >> 2] = i482;
      i482 = (HEAP32[i208 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i482 + 4 >> 2] | 0;
      i73 = HEAP32[i482 + 8 >> 2] | 0;
      i72 = HEAP32[i482 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i482 >> 2];
      HEAP32[i209 >> 2] = i74;
      HEAP32[i210 >> 2] = i73;
      HEAP32[i211 >> 2] = i72;
      i72 = (HEAP32[i212 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i213 >> 2] = i73;
      HEAP32[i214 >> 2] = i74;
      HEAP32[i215 >> 2] = i482;
      if (HEAP32[i463 >> 2] & 268435456 | 0) {
       i72 = (HEAP32[i216 >> 2] | 0) + (i75 << 2) | 0;
       i73 = HEAP32[i72 + 4 >> 2] | 0;
       i74 = HEAP32[i72 + 8 >> 2] | 0;
       i482 = HEAP32[i72 + 12 >> 2] | 0;
       HEAP32[i516 >> 2] = HEAP32[i72 >> 2];
       HEAP32[i217 >> 2] = i73;
       HEAP32[i218 >> 2] = i74;
       HEAP32[i219 >> 2] = i482;
      }
     } else {
      i4 = HEAP32[i192 >> 2] | 0;
      i11 = HEAP32[i195 >> 2] | 0;
      i12 = HEAP32[i189 >> 2] | 0;
      i13 = HEAP32[i193 >> 2] | 0;
      i14 = HEAP32[i196 >> 2] | 0;
      i15 = HEAP32[i190 >> 2] | 0;
      i16 = HEAP32[i194 >> 2] | 0;
      i17 = HEAP32[i197 >> 2] | 0;
      i18 = HEAP32[i200 >> 2] | 0;
      i19 = HEAP32[i204 >> 2] | 0;
      i20 = HEAP32[i208 >> 2] | 0;
      i21 = HEAP32[i212 >> 2] | 0;
      i24 = HEAP32[i191 >> 2] | 0;
      i3 = HEAP32[i216 >> 2] | 0;
      if (!(HEAP32[i463 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i3 + (i74 << 2) >> 2];
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f33 = Math_fround(HEAPF32[i528 >> 2]);
     f7 = Math_fround(f441 * f33);
     f31 = Math_fround(HEAPF32[i166 >> 2]);
     f29 = Math_fround(f441 * f31);
     f556 = Math_fround(HEAPF32[i165 >> 2]);
     f6 = Math_fround(f441 * f556);
     f554 = Math_fround(HEAPF32[i164 >> 2]);
     f79 = Math_fround(f441 * f554);
     f32 = Math_fround(HEAPF32[i220 >> 2]);
     f30 = Math_fround(f444 * f32);
     f26 = Math_fround(HEAPF32[i170 >> 2]);
     f35 = Math_fround(f444 * f26);
     f555 = Math_fround(HEAPF32[i169 >> 2]);
     f10 = Math_fround(f444 * f555);
     f553 = Math_fround(HEAPF32[i168 >> 2]);
     f30 = Math_fround(f7 + f30);
     f35 = Math_fround(f29 + f35);
     f10 = Math_fround(f6 + f10);
     f79 = Math_fround(f79 + Math_fround(f444 * f553));
     f6 = Math_fround(HEAPF32[i221 >> 2]);
     f29 = Math_fround(f447 * f6);
     f7 = Math_fround(HEAPF32[i174 >> 2]);
     f28 = Math_fround(f447 * f7);
     f8 = Math_fround(HEAPF32[i173 >> 2]);
     f27 = Math_fround(f447 * f8);
     f34 = Math_fround(HEAPF32[i172 >> 2]);
     f28 = Math_fround(f450 + Math_fround(f35 + f28));
     f27 = Math_fround(f450 + Math_fround(f10 + f27));
     f79 = Math_fround(f450 + Math_fround(f79 + Math_fround(f447 * f34)));
     HEAPF32[i517 >> 2] = Math_fround(f450 + Math_fround(f30 + f29));
     HEAPF32[i222 >> 2] = f28;
     HEAPF32[i223 >> 2] = f27;
     HEAPF32[i224 >> 2] = f79;
     f79 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f31) + Math_fround(f445 * f26)) + Math_fround(f448 * f7)));
     f27 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f556) + Math_fround(f445 * f555)) + Math_fround(f448 * f8)));
     f28 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f554) + Math_fround(f445 * f553)) + Math_fround(f448 * f34)));
     HEAPF32[i225 >> 2] = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f33) + Math_fround(f445 * f32)) + Math_fround(f448 * f6)));
     HEAPF32[i226 >> 2] = f79;
     HEAPF32[i227 >> 2] = f27;
     HEAPF32[i228 >> 2] = f28;
     f28 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f31) + Math_fround(f446 * f26)) + Math_fround(f449 * f7)));
     f27 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f556) + Math_fround(f446 * f555)) + Math_fround(f449 * f8)));
     f79 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f554) + Math_fround(f446 * f553)) + Math_fround(f449 * f34)));
     HEAPF32[i229 >> 2] = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f33) + Math_fround(f446 * f32)) + Math_fround(f449 * f6)));
     HEAPF32[i230 >> 2] = f28;
     HEAPF32[i231 >> 2] = f27;
     HEAPF32[i232 >> 2] = f79;
     f6 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f33) + Math_fround(f486 * f32)) + Math_fround(f487 * f6)));
     f7 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f31) + Math_fround(f486 * f26)) + Math_fround(f487 * f7)));
     f8 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f556) + Math_fround(f486 * f555)) + Math_fround(f487 * f8)));
     f34 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f554) + Math_fround(f486 * f553)) + Math_fround(f487 * f34)));
     f553 = Math_fround(f474 + Math_fround(f475 * f6));
     f554 = Math_fround(f474 + Math_fround(f475 * f7));
     f555 = Math_fround(f474 + Math_fround(f475 * f8));
     f556 = Math_fround(f474 + Math_fround(f475 * f34));
     f6 = Math_fround(f466 + Math_fround(f467 * f6));
     f7 = Math_fround(f466 + Math_fround(f467 * f7));
     f8 = Math_fround(f466 + Math_fround(f467 * f8));
     f34 = Math_fround(f466 + Math_fround(f467 * f34));
     f26 = Math_fround(HEAPF32[i512 >> 2]);
     f31 = Math_fround(HEAPF32[i201 >> 2]);
     f32 = Math_fround(HEAPF32[i202 >> 2]);
     f33 = Math_fround(HEAPF32[i203 >> 2]);
     f27 = Math_fround(HEAPF32[i513 >> 2]);
     f28 = Math_fround(HEAPF32[i205 >> 2]);
     f29 = Math_fround(HEAPF32[i206 >> 2]);
     f30 = Math_fround(HEAPF32[i207 >> 2]);
     f10 = f26 > f27 ? f26 : f27;
     f35 = f31 > f28 ? f31 : f28;
     f25 = f32 > f29 ? f32 : f29;
     f36 = f33 > f30 ? f33 : f30;
     f550 = Math_fround((f10 > f553 ? f10 : f553) * Math_fround(.5));
     f551 = Math_fround((f35 > f554 ? f35 : f554) * Math_fround(.5));
     f552 = Math_fround((f25 > f555 ? f25 : f555) * Math_fround(.5));
     f5 = Math_fround((f36 > f556 ? f36 : f556) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f550, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f551, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f552, HEAP32[tempDoublePtr >> 2] | 0);
     i72 = f553 >= Math_fround(0.0);
     i73 = f554 >= Math_fround(0.0);
     i74 = f555 >= Math_fround(0.0);
     i482 = f556 >= Math_fround(0.0);
     i15 = i72 ? i15 : 0;
     i16 = i73 ? i16 : 0;
     i17 = i74 ? i17 : 0;
     i11 = i482 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f552 = Math_fround(f6 * Math_fround(.5));
     f554 = Math_fround(f7 * Math_fround(.5));
     f556 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f34 * Math_fround(.5));
     f551 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f553 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f555 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f551 < f552 ? f551 : f552, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f553 < f554 ? f553 : f554, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f555 < f556 ? f555 : f556, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i482 = f34 >= Math_fround(0.0);
     i72 = i482 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f35);
     f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f36);
     f548 = Math_fround(f26 * f57);
     f547 = Math_fround(f31 * f56);
     f546 = Math_fround(f32 * f55);
     f545 = Math_fround(f33 * f34);
     f31 = Math_fround(f27 * f57);
     f32 = Math_fround(f28 * f56);
     f33 = Math_fround(f29 * f55);
     f34 = Math_fround(f30 * f34);
     i72 = Math_fround(HEAPF32[i514 >> 2]) < Math_fround(100.0);
     i73 = Math_fround(HEAPF32[i209 >> 2]) < Math_fround(100.0);
     i74 = Math_fround(HEAPF32[i210 >> 2]) < Math_fround(100.0);
     i482 = Math_fround(HEAPF32[i211 >> 2]) < Math_fround(100.0);
     f27 = i72 ? f548 : Math_fround(0.0);
     f548 = Math_fround(f478 * f27);
     f28 = i73 ? f547 : Math_fround(0.0);
     f547 = Math_fround(f478 * f28);
     f29 = i74 ? f546 : Math_fround(0.0);
     f546 = Math_fround(f478 * f29);
     f30 = i482 ? f545 : Math_fround(0.0);
     f545 = Math_fround(f478 * f30);
     f55 = Math_fround(f470 * f27);
     f56 = Math_fround(f470 * f28);
     f57 = Math_fround(f470 * f29);
     f58 = Math_fround(f470 * f30);
     f538 = Math_fround(f473 * f27);
     f53 = Math_fround(f473 * f28);
     f50 = Math_fround(f473 * f29);
     f47 = Math_fround(f473 * f30);
     f31 = i72 ? f31 : Math_fround(0.0);
     f543 = Math_fround(f476 * f31);
     f32 = i73 ? f32 : Math_fround(0.0);
     f554 = Math_fround(f476 * f32);
     f33 = i74 ? f33 : Math_fround(0.0);
     f542 = Math_fround(f476 * f33);
     f34 = i482 ? f34 : Math_fround(0.0);
     f553 = Math_fround(f476 * f34);
     f541 = Math_fround(f468 * f31);
     f552 = Math_fround(f468 * f32);
     f540 = Math_fround(f468 * f33);
     f551 = Math_fround(f468 * f34);
     f539 = Math_fround(f471 * f31);
     f549 = Math_fround(f471 * f32);
     f52 = Math_fround(f471 * f33);
     f49 = Math_fround(f471 * f34);
     f535 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) + Math_fround(.785398125));
     f536 = Math_fround(Math_fround(HEAPF32[i178 >> 2]) + Math_fround(.785398125));
     f537 = Math_fround(Math_fround(HEAPF32[i177 >> 2]) + Math_fround(.785398125));
     f535 = Math_fround(f535 * Math_fround(.159154937));
     f536 = Math_fround(f536 * Math_fround(.159154937));
     f537 = Math_fround(f537 * Math_fround(.159154937));
     f532 = Math_fround(Math_fround(Math_fround(HEAPF32[i176 >> 2]) + Math_fround(.785398125)) * Math_fround(.159154937));
     f508 = Math_fround(+_roundf(+f535));
     f43 = Math_fround(+_roundf(+f536));
     f534 = Math_fround(+_roundf(+f537));
     f508 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f535 - f508))));
     f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f536 - f43))));
     f534 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f534))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - Math_fround(+_roundf(+f532))))));
     f550 = Math_fround(f508 * f508);
     f54 = Math_fround(f43 * f43);
     f51 = Math_fround(f534 * f534);
     f48 = Math_fround(f44 * f44);
     f556 = Math_fround(f550 * f550);
     f45 = Math_fround(f54 * f54);
     f555 = Math_fround(f51 * f51);
     f46 = Math_fround(f48 * f48);
     f550 = Math_fround(f508 * Math_fround(Math_fround(Math_fround(f556 * f556) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f550 * Math_fround(41.3416595))) + Math_fround(f556 * Math_fround(Math_fround(81.6018218) - Math_fround(f550 * Math_fround(76.5686187)))))));
     f54 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
     f51 = Math_fround(f534 * Math_fround(Math_fround(Math_fround(f555 * f555) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f555 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
     f48 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f46 * f46) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f48 * Math_fround(41.3416595))) + Math_fround(f46 * Math_fround(Math_fround(81.6018218) - Math_fround(f48 * Math_fround(76.5686187)))))));
     f535 = Math_fround(f535 + Math_fround(-.25));
     f536 = Math_fround(f536 + Math_fround(-.25));
     f537 = Math_fround(f537 + Math_fround(-.25));
     f532 = Math_fround(f532 + Math_fround(-.25));
     f46 = Math_fround(+_roundf(+f535));
     f44 = Math_fround(+_roundf(+f536));
     f555 = Math_fround(+_roundf(+f537));
     f46 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f535 - f46))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f536 - f44))));
     f555 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f555))));
     f532 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - Math_fround(+_roundf(+f532))))));
     f537 = Math_fround(f46 * f46);
     f536 = Math_fround(f44 * f44);
     f535 = Math_fround(f555 * f555);
     f534 = Math_fround(f532 * f532);
     f45 = Math_fround(f537 * f537);
     f43 = Math_fround(f536 * f536);
     f556 = Math_fround(f535 * f535);
     f508 = Math_fround(f534 * f534);
     f537 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f537 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f537 * Math_fround(76.5686187)))))));
     f536 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f43) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f536 * Math_fround(41.3416595))) + Math_fround(f43 * Math_fround(Math_fround(81.6018218) - Math_fround(f536 * Math_fround(76.5686187)))))));
     f535 = Math_fround(f555 * Math_fround(Math_fround(Math_fround(f556 * f556) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f535 * Math_fround(41.3416595))) + Math_fround(f556 * Math_fround(Math_fround(81.6018218) - Math_fround(f535 * Math_fround(76.5686187)))))));
     f534 = Math_fround(f532 * Math_fround(Math_fround(Math_fround(f508 * f508) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f534 * Math_fround(41.3416595))) + Math_fround(f508 * Math_fround(Math_fround(81.6018218) - Math_fround(f534 * Math_fround(76.5686187)))))));
     f508 = Math_fround(Math_fround(f548 * f550) + Math_fround(f543 * f537));
     f532 = Math_fround(Math_fround(f547 * f54) + Math_fround(f554 * f536));
     f556 = Math_fround(Math_fround(f546 * f51) + Math_fround(f542 * f535));
     f555 = Math_fround(Math_fround(f545 * f48) + Math_fround(f553 * f534));
     f43 = Math_fround(Math_fround(f55 * f550) + Math_fround(f541 * f537));
     f44 = Math_fround(Math_fround(f56 * f54) + Math_fround(f552 * f536));
     f45 = Math_fround(Math_fround(f57 * f51) + Math_fround(f540 * f535));
     f46 = Math_fround(Math_fround(f58 * f48) + Math_fround(f551 * f534));
     f507 = Math_fround(Math_fround(f538 * f550) + Math_fround(f539 * f537));
     f531 = Math_fround(Math_fround(f53 * f54) + Math_fround(f549 * f536));
     f533 = Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f535));
     f544 = Math_fround(Math_fround(f47 * f48) + Math_fround(f49 * f534));
     f35 = Math_fround(Math_fround(f338 * f507) + Math_fround(Math_fround(f85 * f508) + Math_fround(f337 * f43)));
     f36 = Math_fround(Math_fround(f338 * f531) + Math_fround(Math_fround(f85 * f532) + Math_fround(f337 * f44)));
     f37 = Math_fround(Math_fround(f338 * f533) + Math_fround(Math_fround(f85 * f556) + Math_fround(f337 * f45)));
     f38 = Math_fround(Math_fround(f338 * f544) + Math_fround(Math_fround(f85 * f555) + Math_fround(f337 * f46)));
     f39 = Math_fround(Math_fround(f341 * f507) + Math_fround(Math_fround(f339 * f508) + Math_fround(f340 * f43)));
     f40 = Math_fround(Math_fround(f341 * f531) + Math_fround(Math_fround(f339 * f532) + Math_fround(f340 * f44)));
     f41 = Math_fround(Math_fround(f341 * f533) + Math_fround(Math_fround(f339 * f556) + Math_fround(f340 * f45)));
     f42 = Math_fround(Math_fround(f341 * f544) + Math_fround(Math_fround(f339 * f555) + Math_fround(f340 * f46)));
     f43 = Math_fround(Math_fround(f344 * f507) + Math_fround(Math_fround(f342 * f508) + Math_fround(f343 * f43)));
     f44 = Math_fround(Math_fround(f344 * f531) + Math_fround(Math_fround(f342 * f532) + Math_fround(f343 * f44)));
     f45 = Math_fround(Math_fround(f344 * f533) + Math_fround(Math_fround(f342 * f556) + Math_fround(f343 * f45)));
     f46 = Math_fround(Math_fround(f344 * f544) + Math_fround(Math_fround(f342 * f555) + Math_fround(f343 * f46)));
     f548 = Math_fround(Math_fround(f543 * f550) - Math_fround(f548 * f537));
     f547 = Math_fround(Math_fround(f554 * f54) - Math_fround(f547 * f536));
     f546 = Math_fround(Math_fround(f542 * f51) - Math_fround(f546 * f535));
     f545 = Math_fround(Math_fround(f553 * f48) - Math_fround(f545 * f534));
     f55 = Math_fround(Math_fround(f541 * f550) - Math_fround(f55 * f537));
     f56 = Math_fround(Math_fround(f552 * f54) - Math_fround(f56 * f536));
     f57 = Math_fround(Math_fround(f540 * f51) - Math_fround(f57 * f535));
     f58 = Math_fround(Math_fround(f551 * f48) - Math_fround(f58 * f534));
     f537 = Math_fround(Math_fround(f539 * f550) - Math_fround(f538 * f537));
     f536 = Math_fround(Math_fround(f549 * f54) - Math_fround(f53 * f536));
     f535 = Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * f535));
     f534 = Math_fround(Math_fround(f49 * f48) - Math_fround(f47 * f534));
     f47 = Math_fround(Math_fround(f338 * f537) + Math_fround(Math_fround(f85 * f548) + Math_fround(f337 * f55)));
     f48 = Math_fround(Math_fround(f338 * f536) + Math_fround(Math_fround(f85 * f547) + Math_fround(f337 * f56)));
     f49 = Math_fround(Math_fround(f338 * f535) + Math_fround(Math_fround(f85 * f546) + Math_fround(f337 * f57)));
     f50 = Math_fround(Math_fround(f338 * f534) + Math_fround(Math_fround(f85 * f545) + Math_fround(f337 * f58)));
     f51 = Math_fround(Math_fround(f341 * f537) + Math_fround(Math_fround(f339 * f548) + Math_fround(f340 * f55)));
     f52 = Math_fround(Math_fround(f341 * f536) + Math_fround(Math_fround(f339 * f547) + Math_fround(f340 * f56)));
     f53 = Math_fround(Math_fround(f341 * f535) + Math_fround(Math_fround(f339 * f546) + Math_fround(f340 * f57)));
     f54 = Math_fround(Math_fround(f341 * f534) + Math_fround(Math_fround(f339 * f545) + Math_fround(f340 * f58)));
     f55 = Math_fround(Math_fround(f344 * f537) + Math_fround(Math_fround(f342 * f548) + Math_fround(f343 * f55)));
     f56 = Math_fround(Math_fround(f344 * f536) + Math_fround(Math_fround(f342 * f547) + Math_fround(f343 * f56)));
     f57 = Math_fround(Math_fround(f344 * f535) + Math_fround(Math_fround(f342 * f546) + Math_fround(f343 * f57)));
     f58 = Math_fround(Math_fround(f344 * f534) + Math_fround(Math_fround(f342 * f545) + Math_fround(f343 * f58)));
     f545 = Math_fround(HEAPF32[i517 >> 2]);
     f534 = Math_fround(f545 + f35);
     f546 = Math_fround(HEAPF32[i222 >> 2]);
     f535 = Math_fround(f546 + f36);
     f547 = Math_fround(HEAPF32[i223 >> 2]);
     f536 = Math_fround(f547 + f37);
     f548 = Math_fround(HEAPF32[i224 >> 2]);
     f537 = Math_fround(f548 + f38);
     f549 = Math_fround(HEAPF32[i225 >> 2]);
     f538 = Math_fround(f549 + f39);
     f550 = Math_fround(HEAPF32[i226 >> 2]);
     f539 = Math_fround(f550 + f40);
     f551 = Math_fround(HEAPF32[i227 >> 2]);
     f540 = Math_fround(f551 + f41);
     f552 = Math_fround(HEAPF32[i228 >> 2]);
     f541 = Math_fround(f552 + f42);
     f553 = Math_fround(HEAPF32[i229 >> 2]);
     f542 = Math_fround(f553 + f43);
     f554 = Math_fround(HEAPF32[i230 >> 2]);
     f543 = Math_fround(f554 + f44);
     f555 = Math_fround(HEAPF32[i231 >> 2]);
     f544 = Math_fround(f555 + f45);
     f556 = Math_fround(f79 + f46);
     HEAPF32[i523 >> 2] = f534;
     HEAPF32[i234 >> 2] = f535;
     HEAPF32[i235 >> 2] = f536;
     HEAPF32[i236 >> 2] = f537;
     HEAPF32[i237 >> 2] = f538;
     HEAPF32[i238 >> 2] = f539;
     HEAPF32[i239 >> 2] = f540;
     HEAPF32[i240 >> 2] = f541;
     HEAPF32[i241 >> 2] = f542;
     HEAPF32[i242 >> 2] = f543;
     HEAPF32[i243 >> 2] = f544;
     HEAPF32[i244 >> 2] = f556;
     f556 = Math_fround(f546 + f48);
     f544 = Math_fround(f547 + f49);
     f543 = Math_fround(f548 + f50);
     f542 = Math_fround(f549 + f51);
     f541 = Math_fround(f550 + f52);
     f540 = Math_fround(f551 + f53);
     f539 = Math_fround(f552 + f54);
     f538 = Math_fround(f553 + f55);
     f537 = Math_fround(f554 + f56);
     f536 = Math_fround(f555 + f57);
     f535 = Math_fround(f79 + f58);
     HEAPF32[i245 >> 2] = Math_fround(f545 + f47);
     HEAPF32[i246 >> 2] = f556;
     HEAPF32[i247 >> 2] = f544;
     HEAPF32[i248 >> 2] = f543;
     HEAPF32[i249 >> 2] = f542;
     HEAPF32[i250 >> 2] = f541;
     HEAPF32[i251 >> 2] = f540;
     HEAPF32[i252 >> 2] = f539;
     HEAPF32[i253 >> 2] = f538;
     HEAPF32[i254 >> 2] = f537;
     HEAPF32[i255 >> 2] = f536;
     HEAPF32[i256 >> 2] = f535;
     f535 = Math_fround(f546 - f36);
     f536 = Math_fround(f547 - f37);
     f537 = Math_fround(f548 - f38);
     f538 = Math_fround(f549 - f39);
     f539 = Math_fround(f550 - f40);
     f540 = Math_fround(f551 - f41);
     f541 = Math_fround(f552 - f42);
     f542 = Math_fround(f553 - f43);
     f543 = Math_fround(f554 - f44);
     f544 = Math_fround(f555 - f45);
     f556 = Math_fround(f79 - f46);
     HEAPF32[i257 >> 2] = Math_fround(f545 - f35);
     HEAPF32[i258 >> 2] = f535;
     HEAPF32[i259 >> 2] = f536;
     HEAPF32[i260 >> 2] = f537;
     HEAPF32[i261 >> 2] = f538;
     HEAPF32[i262 >> 2] = f539;
     HEAPF32[i263 >> 2] = f540;
     HEAPF32[i264 >> 2] = f541;
     HEAPF32[i265 >> 2] = f542;
     HEAPF32[i266 >> 2] = f543;
     HEAPF32[i267 >> 2] = f544;
     HEAPF32[i268 >> 2] = f556;
     f546 = Math_fround(f546 - f48);
     f547 = Math_fround(f547 - f49);
     f548 = Math_fround(f548 - f50);
     f549 = Math_fround(f549 - f51);
     f550 = Math_fround(f550 - f52);
     f551 = Math_fround(f551 - f53);
     f552 = Math_fround(f552 - f54);
     f553 = Math_fround(f553 - f55);
     f554 = Math_fround(f554 - f56);
     f555 = Math_fround(f555 - f57);
     f556 = Math_fround(f79 - f58);
     HEAPF32[i269 >> 2] = Math_fround(f545 - f47);
     HEAPF32[i270 >> 2] = f546;
     HEAPF32[i271 >> 2] = f547;
     HEAPF32[i272 >> 2] = f548;
     HEAPF32[i273 >> 2] = f549;
     HEAPF32[i274 >> 2] = f550;
     HEAPF32[i275 >> 2] = f551;
     HEAPF32[i276 >> 2] = f552;
     HEAPF32[i277 >> 2] = f553;
     HEAPF32[i278 >> 2] = f554;
     HEAPF32[i279 >> 2] = f555;
     HEAPF32[i280 >> 2] = f556;
     if (!i281) {
      i2 = HEAP32[i463 >> 2] | 0;
      if (i2 & 536870912) {
       f556 = Math_fround(HEAPF32[i109 >> 2]);
       i63 = HEAP32[i515 >> 2] | 0;
       i74 = i63 + 693089735 | 0;
       i61 = HEAP32[i213 >> 2] | 0;
       i71 = i61 + 693089735 | 0;
       i59 = HEAP32[i214 >> 2] | 0;
       i68 = i59 + 693089735 | 0;
       i23 = HEAP32[i215 >> 2] | 0;
       i65 = i23 + 693089735 | 0;
       i24 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i60 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i62 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i64 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i68 = i68 << 11 ^ i68;
       i65 = i65 << 11 ^ i65;
       i24 = Math_fround(Math_fround((i24 ^ i74 ^ i74 >>> 8) & 8388607 ^ i24 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i60 = Math_fround(Math_fround((i60 ^ i71 ^ i71 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i62 = Math_fround(Math_fround((i62 ^ i68 ^ i68 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i64 = Math_fround(Math_fround((i64 ^ i65 ^ i65 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       f556 = Math_fround(HEAPF32[i76 >> 2]);
       i63 = i63 + 13945730 | 0;
       i61 = i61 + 13945730 | 0;
       i59 = i59 + 13945730 | 0;
       i23 = i23 + 13945730 | 0;
       i65 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i59, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
       i63 = i63 << 11 ^ i63;
       i61 = i61 << 11 ^ i61;
       i59 = i59 << 11 ^ i59;
       i23 = i23 << 11 ^ i23;
       i65 = Math_fround(Math_fround((i65 ^ i63 ^ i63 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i68 = Math_fround(Math_fround((i68 ^ i61 ^ i61 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i71 = Math_fround(Math_fround((i71 ^ i59 ^ i59 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i23 = i24 & 1;
       i59 = i60 & 1;
       i61 = i62 & 1;
       i63 = i64 & 1;
       i66 = i23 ^ 1;
       i69 = i59 ^ 1;
       i72 = i61 ^ 1;
       i482 = i63 ^ 1;
       i67 = i24 ? 3 : 2;
       i70 = i60 ? 3 : 2;
       i73 = i62 ? 3 : 2;
       i2 = i64 ? 3 : 2;
       i24 = i24 ? 2 : 3;
       i60 = i60 ? 2 : 3;
       i62 = i62 ? 2 : 3;
       i64 = i64 ? 2 : 3;
       HEAP32[i520 >> 2] = i65 ? i24 : i23;
       HEAP32[i440 >> 2] = i68 ? i60 : i59;
       HEAP32[i439 >> 2] = i71 ? i62 : i61;
       HEAP32[i438 >> 2] = i74 ? i64 : i63;
       HEAP32[i462 >> 2] = i65 ? i23 : i24;
       HEAP32[i461 >> 2] = i68 ? i59 : i60;
       HEAP32[i460 >> 2] = i71 ? i61 : i62;
       HEAP32[i459 >> 2] = i74 ? i63 : i64;
       HEAP32[i454 >> 2] = i65 ? i67 : i66;
       HEAP32[i453 >> 2] = i68 ? i70 : i69;
       HEAP32[i452 >> 2] = i71 ? i73 : i72;
       HEAP32[i451 >> 2] = i74 ? i2 : i482;
       HEAP32[i458 >> 2] = i65 ? i66 : i67;
       HEAP32[i457 >> 2] = i68 ? i69 : i70;
       HEAP32[i456 >> 2] = i71 ? i72 : i73;
       HEAP32[i455 >> 2] = i74 ? i482 : i2;
       i2 = HEAP32[i463 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f480 * Math_fround(HEAPF32[i516 >> 2]));
       f6 = Math_fround(f480 * Math_fround(HEAPF32[i217 >> 2]));
       f7 = Math_fround(f480 * Math_fround(HEAPF32[i218 >> 2]));
       f8 = Math_fround(f480 * Math_fround(HEAPF32[i219 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f553 = Math_fround(Math_floor(Math_fround(f82 * f9)));
        f554 = Math_fround(Math_floor(Math_fround(f82 * f10)));
        f555 = Math_fround(Math_floor(Math_fround(f82 * f25)));
        f556 = Math_fround(Math_floor(Math_fround(f82 * f26)));
        f549 = Math_fround(f481 * Math_fround(f9 - Math_fround(f479 * f553)));
        f550 = Math_fround(f481 * Math_fround(f10 - Math_fround(f479 * f554)));
        f551 = Math_fround(f481 * Math_fround(f25 - Math_fround(f479 * f555)));
        f552 = Math_fround(f481 * Math_fround(f26 - Math_fround(f479 * f556)));
        f553 = Math_fround(f84 - Math_fround(f483 * f553));
        f554 = Math_fround(f84 - Math_fround(f483 * f554));
        f555 = Math_fround(f84 - Math_fround(f483 * f555));
        f556 = Math_fround(f84 - Math_fround(f483 * f556));
        f541 = Math_fround(f483 + f553);
        f542 = Math_fround(f483 + f554);
        f543 = Math_fround(f483 + f555);
        f544 = Math_fround(f483 + f556);
        HEAPF32[i521 >> 2] = f549;
        HEAPF32[i389 >> 2] = f550;
        HEAPF32[i413 >> 2] = f551;
        HEAPF32[i437 >> 2] = f552;
        HEAPF32[i365 >> 2] = f541;
        HEAPF32[i388 >> 2] = f542;
        HEAPF32[i412 >> 2] = f543;
        HEAPF32[i436 >> 2] = f544;
        f545 = Math_fround(f481 + f549);
        f546 = Math_fround(f481 + f550);
        f547 = Math_fround(f481 + f551);
        f548 = Math_fround(f481 + f552);
        HEAPF32[i364 >> 2] = f545;
        HEAPF32[i387 >> 2] = f546;
        HEAPF32[i411 >> 2] = f547;
        HEAPF32[i435 >> 2] = f548;
        HEAPF32[i363 >> 2] = f541;
        HEAPF32[i386 >> 2] = f542;
        HEAPF32[i410 >> 2] = f543;
        HEAPF32[i434 >> 2] = f544;
        HEAPF32[i362 >> 2] = f545;
        HEAPF32[i385 >> 2] = f546;
        HEAPF32[i409 >> 2] = f547;
        HEAPF32[i433 >> 2] = f548;
        HEAPF32[i361 >> 2] = f553;
        HEAPF32[i384 >> 2] = f554;
        HEAPF32[i408 >> 2] = f555;
        HEAPF32[i432 >> 2] = f556;
        HEAPF32[i360 >> 2] = f549;
        HEAPF32[i383 >> 2] = f550;
        HEAPF32[i407 >> 2] = f551;
        HEAPF32[i431 >> 2] = f552;
        HEAPF32[i359 >> 2] = f553;
        HEAPF32[i382 >> 2] = f554;
        HEAPF32[i406 >> 2] = f555;
        HEAPF32[i430 >> 2] = f556;
       }
       if (i2 & 33554432 | 0) {
        f545 = Math_fround(f9 + Math_fround(1.0));
        f546 = Math_fround(f10 + Math_fround(1.0));
        f547 = Math_fround(f25 + Math_fround(1.0));
        f548 = Math_fround(f26 + Math_fround(1.0));
        f553 = Math_fround(f5 - f9);
        f554 = Math_fround(f6 - f10);
        f555 = Math_fround(f7 - f25);
        f556 = Math_fround(f8 - f26);
        f549 = Math_fround(Math_floor(Math_fround(f82 * f545)));
        f550 = Math_fround(Math_floor(Math_fround(f82 * f546)));
        f551 = Math_fround(Math_floor(Math_fround(f82 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f82 * f548)));
        f545 = Math_fround(f481 * Math_fround(f545 - Math_fround(f479 * f549)));
        f546 = Math_fround(f481 * Math_fround(f546 - Math_fround(f479 * f550)));
        f547 = Math_fround(f481 * Math_fround(f547 - Math_fround(f479 * f551)));
        f548 = Math_fround(f481 * Math_fround(f548 - Math_fround(f479 * f552)));
        f549 = Math_fround(f84 - Math_fround(f483 * f549));
        f550 = Math_fround(f84 - Math_fround(f483 * f550));
        f551 = Math_fround(f84 - Math_fround(f483 * f551));
        f552 = Math_fround(f84 - Math_fround(f483 * f552));
        f537 = Math_fround(f483 + f549);
        f538 = Math_fround(f483 + f550);
        f539 = Math_fround(f483 + f551);
        f540 = Math_fround(f483 + f552);
        HEAPF32[i522 >> 2] = f545;
        HEAPF32[i381 >> 2] = f546;
        HEAPF32[i405 >> 2] = f547;
        HEAPF32[i429 >> 2] = f548;
        HEAPF32[i358 >> 2] = f537;
        HEAPF32[i380 >> 2] = f538;
        HEAPF32[i404 >> 2] = f539;
        HEAPF32[i428 >> 2] = f540;
        HEAPF32[i357 >> 2] = f553;
        HEAPF32[i379 >> 2] = f554;
        HEAPF32[i403 >> 2] = f555;
        HEAPF32[i427 >> 2] = f556;
        HEAPF32[i356 >> 2] = f5;
        HEAPF32[i378 >> 2] = f6;
        HEAPF32[i402 >> 2] = f7;
        HEAPF32[i426 >> 2] = f8;
        f541 = Math_fround(f481 + f545);
        f542 = Math_fround(f481 + f546);
        f543 = Math_fround(f481 + f547);
        f544 = Math_fround(f481 + f548);
        HEAPF32[i355 >> 2] = f541;
        HEAPF32[i377 >> 2] = f542;
        HEAPF32[i401 >> 2] = f543;
        HEAPF32[i425 >> 2] = f544;
        HEAPF32[i354 >> 2] = f537;
        HEAPF32[i376 >> 2] = f538;
        HEAPF32[i400 >> 2] = f539;
        HEAPF32[i424 >> 2] = f540;
        HEAPF32[i353 >> 2] = f553;
        HEAPF32[i375 >> 2] = f554;
        HEAPF32[i399 >> 2] = f555;
        HEAPF32[i423 >> 2] = f556;
        HEAPF32[i352 >> 2] = f5;
        HEAPF32[i374 >> 2] = f6;
        HEAPF32[i398 >> 2] = f7;
        HEAPF32[i422 >> 2] = f8;
        HEAPF32[i351 >> 2] = f541;
        HEAPF32[i373 >> 2] = f542;
        HEAPF32[i397 >> 2] = f543;
        HEAPF32[i421 >> 2] = f544;
        HEAPF32[i350 >> 2] = f549;
        HEAPF32[i372 >> 2] = f550;
        HEAPF32[i396 >> 2] = f551;
        HEAPF32[i420 >> 2] = f552;
        HEAPF32[i349 >> 2] = f553;
        HEAPF32[i371 >> 2] = f554;
        HEAPF32[i395 >> 2] = f555;
        HEAPF32[i419 >> 2] = f556;
        HEAPF32[i348 >> 2] = f5;
        HEAPF32[i370 >> 2] = f6;
        HEAPF32[i394 >> 2] = f7;
        HEAPF32[i418 >> 2] = f8;
        HEAPF32[i347 >> 2] = f545;
        HEAPF32[i369 >> 2] = f546;
        HEAPF32[i393 >> 2] = f547;
        HEAPF32[i417 >> 2] = f548;
        HEAPF32[i346 >> 2] = f549;
        HEAPF32[i368 >> 2] = f550;
        HEAPF32[i392 >> 2] = f551;
        HEAPF32[i416 >> 2] = f552;
        HEAPF32[i345 >> 2] = f553;
        HEAPF32[i367 >> 2] = f554;
        HEAPF32[i391 >> 2] = f555;
        HEAPF32[i415 >> 2] = f556;
        HEAPF32[i336 >> 2] = f5;
        HEAPF32[i366 >> 2] = f6;
        HEAPF32[i390 >> 2] = f7;
        HEAPF32[i414 >> 2] = f8;
       }
      }
     }
     f541 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
     f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
     f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
     f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
     f533 = Math_fround(f484 * Math_fround(f35 * f541));
     f534 = Math_fround(f484 * Math_fround(f36 * f542));
     f535 = Math_fround(f484 * Math_fround(f37 * f543));
     f536 = Math_fround(f484 * Math_fround(f38 * f544));
     f537 = Math_fround(f484 * Math_fround(f39 * f541));
     f538 = Math_fround(f484 * Math_fround(f40 * f542));
     f539 = Math_fround(f484 * Math_fround(f41 * f543));
     f540 = Math_fround(f484 * Math_fround(f42 * f544));
     f541 = Math_fround(f484 * Math_fround(f43 * f541));
     f542 = Math_fround(f484 * Math_fround(f44 * f542));
     f543 = Math_fround(f484 * Math_fround(f45 * f543));
     f544 = Math_fround(f484 * Math_fround(f46 * f544));
     f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
     f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
     f545 = Math_fround(f484 * Math_fround(f47 * f553));
     f546 = Math_fround(f484 * Math_fround(f48 * f554));
     f547 = Math_fround(f484 * Math_fround(f49 * f555));
     f548 = Math_fround(f484 * Math_fround(f50 * f556));
     f549 = Math_fround(f484 * Math_fround(f51 * f553));
     f550 = Math_fround(f484 * Math_fround(f52 * f554));
     f551 = Math_fround(f484 * Math_fround(f53 * f555));
     f552 = Math_fround(f484 * Math_fround(f54 * f556));
     f553 = Math_fround(f484 * Math_fround(f55 * f553));
     f554 = Math_fround(f484 * Math_fround(f56 * f554));
     f555 = Math_fround(f484 * Math_fround(f57 * f555));
     f556 = Math_fround(f484 * Math_fround(f58 * f556));
     f532 = Math_fround(f477 + f534);
     f531 = Math_fround(f477 + f535);
     f508 = Math_fround(f477 + f536);
     f507 = Math_fround(f469 + f537);
     f506 = Math_fround(f469 + f538);
     f505 = Math_fround(f469 + f539);
     f504 = Math_fround(f469 + f540);
     f503 = Math_fround(f472 + f541);
     f502 = Math_fround(f472 + f542);
     f501 = Math_fround(f472 + f543);
     f500 = Math_fround(f472 + f544);
     HEAPF32[i524 >> 2] = Math_fround(f477 + f533);
     HEAPF32[i124 >> 2] = f532;
     HEAPF32[i141 >> 2] = f531;
     HEAPF32[i158 >> 2] = f508;
     HEAPF32[i282 >> 2] = f507;
     HEAPF32[i119 >> 2] = f506;
     HEAPF32[i136 >> 2] = f505;
     HEAPF32[i153 >> 2] = f504;
     HEAPF32[i283 >> 2] = f503;
     HEAPF32[i114 >> 2] = f502;
     HEAPF32[i131 >> 2] = f501;
     HEAPF32[i148 >> 2] = f500;
     f500 = Math_fround(f477 + f546);
     f501 = Math_fround(f477 + f547);
     f502 = Math_fround(f477 + f548);
     f503 = Math_fround(f469 + f549);
     f504 = Math_fround(f469 + f550);
     f505 = Math_fround(f469 + f551);
     f506 = Math_fround(f469 + f552);
     f507 = Math_fround(f472 + f553);
     f508 = Math_fround(f472 + f554);
     f531 = Math_fround(f472 + f555);
     f532 = Math_fround(f472 + f556);
     HEAPF32[i284 >> 2] = Math_fround(f477 + f545);
     HEAPF32[i123 >> 2] = f500;
     HEAPF32[i140 >> 2] = f501;
     HEAPF32[i157 >> 2] = f502;
     HEAPF32[i285 >> 2] = f503;
     HEAPF32[i118 >> 2] = f504;
     HEAPF32[i135 >> 2] = f505;
     HEAPF32[i152 >> 2] = f506;
     HEAPF32[i286 >> 2] = f507;
     HEAPF32[i113 >> 2] = f508;
     HEAPF32[i130 >> 2] = f531;
     HEAPF32[i147 >> 2] = f532;
     f534 = Math_fround(f477 - f534);
     f535 = Math_fround(f477 - f535);
     f536 = Math_fround(f477 - f536);
     f537 = Math_fround(f469 - f537);
     f538 = Math_fround(f469 - f538);
     f539 = Math_fround(f469 - f539);
     f540 = Math_fround(f469 - f540);
     f541 = Math_fround(f472 - f541);
     f542 = Math_fround(f472 - f542);
     f543 = Math_fround(f472 - f543);
     f544 = Math_fround(f472 - f544);
     HEAPF32[i287 >> 2] = Math_fround(f477 - f533);
     HEAPF32[i122 >> 2] = f534;
     HEAPF32[i139 >> 2] = f535;
     HEAPF32[i156 >> 2] = f536;
     HEAPF32[i288 >> 2] = f537;
     HEAPF32[i117 >> 2] = f538;
     HEAPF32[i134 >> 2] = f539;
     HEAPF32[i151 >> 2] = f540;
     HEAPF32[i289 >> 2] = f541;
     HEAPF32[i112 >> 2] = f542;
     HEAPF32[i129 >> 2] = f543;
     HEAPF32[i146 >> 2] = f544;
     f546 = Math_fround(f477 - f546);
     f547 = Math_fround(f477 - f547);
     f548 = Math_fround(f477 - f548);
     f549 = Math_fround(f469 - f549);
     f550 = Math_fround(f469 - f550);
     f551 = Math_fround(f469 - f551);
     f552 = Math_fround(f469 - f552);
     f553 = Math_fround(f472 - f553);
     f554 = Math_fround(f472 - f554);
     f555 = Math_fround(f472 - f555);
     f556 = Math_fround(f472 - f556);
     HEAPF32[i290 >> 2] = Math_fround(f477 - f545);
     HEAPF32[i121 >> 2] = f546;
     HEAPF32[i138 >> 2] = f547;
     HEAPF32[i155 >> 2] = f548;
     HEAPF32[i291 >> 2] = f549;
     HEAPF32[i116 >> 2] = f550;
     HEAPF32[i133 >> 2] = f551;
     HEAPF32[i150 >> 2] = f552;
     HEAPF32[i292 >> 2] = f553;
     HEAPF32[i111 >> 2] = f554;
     HEAPF32[i128 >> 2] = f555;
     HEAPF32[i145 >> 2] = f556;
     do if (i162) {
      i4 = HEAP32[i188 >> 2] | 0;
      i11 = HEAP32[i527 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i482 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i245 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i257 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i269 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i482 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i482 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i245 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i257 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i269 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i482 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f544 = Math_fround(HEAPF32[i245 >> 2]);
      f544 = Math_fround(f544 - Math_fround(HEAPF32[i523 >> 2]));
      f546 = Math_fround(HEAPF32[i246 >> 2]);
      f546 = Math_fround(f546 - Math_fround(HEAPF32[i234 >> 2]));
      f547 = Math_fround(HEAPF32[i247 >> 2]);
      f547 = Math_fround(f547 - Math_fround(HEAPF32[i235 >> 2]));
      f548 = Math_fround(HEAPF32[i248 >> 2]);
      f548 = Math_fround(f548 - Math_fround(HEAPF32[i236 >> 2]));
      f549 = Math_fround(HEAPF32[i249 >> 2]);
      f549 = Math_fround(f549 - Math_fround(HEAPF32[i237 >> 2]));
      f556 = Math_fround(HEAPF32[i250 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i238 >> 2]));
      f555 = Math_fround(HEAPF32[i251 >> 2]);
      f555 = Math_fround(f555 - Math_fround(HEAPF32[i239 >> 2]));
      f554 = Math_fround(HEAPF32[i252 >> 2]);
      f554 = Math_fround(f554 - Math_fround(HEAPF32[i240 >> 2]));
      f553 = Math_fround(HEAPF32[i253 >> 2]);
      f553 = Math_fround(f553 - Math_fround(HEAPF32[i241 >> 2]));
      f541 = Math_fround(HEAPF32[i254 >> 2]);
      f541 = Math_fround(f541 - Math_fround(HEAPF32[i242 >> 2]));
      f542 = Math_fround(HEAPF32[i255 >> 2]);
      f542 = Math_fround(f542 - Math_fround(HEAPF32[i243 >> 2]));
      f543 = Math_fround(HEAPF32[i256 >> 2]);
      f543 = Math_fround(f543 - Math_fround(HEAPF32[i244 >> 2]));
      f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f544 * f544) + Math_fround(f549 * f549)) + Math_fround(f553 * f553)))));
      f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f556 * f556)) + Math_fround(f541 * f541)))));
      f551 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f547 * f547) + Math_fround(f555 * f555)) + Math_fround(f542 * f542)))));
      f550 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f554 * f554)) + Math_fround(f543 * f543)))));
      f546 = Math_fround(f546 * f552);
      f547 = Math_fround(f547 * f551);
      f548 = Math_fround(f548 * f550);
      f549 = Math_fround(f549 * f545);
      f556 = Math_fround(f556 * f552);
      f555 = Math_fround(f555 * f551);
      f554 = Math_fround(f554 * f550);
      f553 = Math_fround(f553 * f545);
      f552 = Math_fround(f541 * f552);
      f551 = Math_fround(f542 * f551);
      f550 = Math_fround(f543 * f550);
      HEAPF32[i518 >> 2] = Math_fround(f544 * f545);
      HEAPF32[i125 >> 2] = f546;
      HEAPF32[i142 >> 2] = f547;
      HEAPF32[i159 >> 2] = f548;
      HEAPF32[i293 >> 2] = f549;
      HEAPF32[i120 >> 2] = f556;
      HEAPF32[i137 >> 2] = f555;
      HEAPF32[i154 >> 2] = f554;
      HEAPF32[i294 >> 2] = f553;
      HEAPF32[i115 >> 2] = f552;
      HEAPF32[i132 >> 2] = f551;
      HEAPF32[i149 >> 2] = f550;
      f550 = Math_fround(f28 * Math_fround(2.0));
      f551 = Math_fround(f29 * Math_fround(2.0));
      f552 = Math_fround(f30 * Math_fround(2.0));
      f553 = Math_fround(f31 * Math_fround(2.0));
      f554 = Math_fround(f32 * Math_fround(2.0));
      f555 = Math_fround(f33 * Math_fround(2.0));
      f556 = Math_fround(f34 * Math_fround(2.0));
      HEAPF32[i519 >> 2] = Math_fround(f27 * Math_fround(2.0));
      HEAPF32[i127 >> 2] = f550;
      HEAPF32[i144 >> 2] = f551;
      HEAPF32[i161 >> 2] = f552;
      HEAPF32[i295 >> 2] = f553;
      HEAPF32[i126 >> 2] = f554;
      HEAPF32[i143 >> 2] = f555;
      HEAPF32[i160 >> 2] = f556;
      HEAP32[i110 >> 2] = 0;
      HEAP32[i110 + 4 >> 2] = 0;
      HEAP32[i110 + 8 >> 2] = 0;
      HEAP32[i110 + 12 >> 2] = 0;
      if (i296) {
       f536 = Math_fround(HEAPF32[i511 >> 2]);
       f554 = Math_fround(f441 * f536);
       f538 = Math_fround(HEAPF32[i181 >> 2]);
       f545 = Math_fround(f441 * f538);
       f540 = Math_fround(HEAPF32[i180 >> 2]);
       f553 = Math_fround(f441 * f540);
       f542 = Math_fround(HEAPF32[i179 >> 2]);
       f548 = Math_fround(f441 * f542);
       f537 = Math_fround(HEAPF32[i198 >> 2]);
       f544 = Math_fround(f444 * f537);
       f539 = Math_fround(HEAPF32[i184 >> 2]);
       f550 = Math_fround(f444 * f539);
       f541 = Math_fround(HEAPF32[i183 >> 2]);
       f549 = Math_fround(f444 * f541);
       f543 = Math_fround(HEAPF32[i182 >> 2]);
       f544 = Math_fround(f554 + f544);
       f550 = Math_fround(f545 + f550);
       f549 = Math_fround(f553 + f549);
       f548 = Math_fround(f548 + Math_fround(f444 * f543));
       f553 = Math_fround(HEAPF32[i199 >> 2]);
       f545 = Math_fround(f447 * f553);
       f554 = Math_fround(HEAPF32[i187 >> 2]);
       f546 = Math_fround(f447 * f554);
       f555 = Math_fround(HEAPF32[i186 >> 2]);
       f547 = Math_fround(f447 * f555);
       f556 = Math_fround(HEAPF32[i185 >> 2]);
       f546 = Math_fround(f550 + f546);
       f547 = Math_fround(f549 + f547);
       f548 = Math_fround(f548 + Math_fround(f447 * f556));
       f549 = Math_fround(Math_fround(Math_fround(f442 * f536) + Math_fround(f445 * f537)) + Math_fround(f448 * f553));
       f550 = Math_fround(Math_fround(Math_fround(f442 * f538) + Math_fround(f445 * f539)) + Math_fround(f448 * f554));
       f551 = Math_fround(Math_fround(Math_fround(f442 * f540) + Math_fround(f445 * f541)) + Math_fround(f448 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f442 * f542) + Math_fround(f445 * f543)) + Math_fround(f448 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f443 * f536) + Math_fround(f446 * f537)) + Math_fround(f449 * f553));
       f554 = Math_fround(Math_fround(Math_fround(f443 * f538) + Math_fround(f446 * f539)) + Math_fround(f449 * f554));
       f555 = Math_fround(Math_fround(Math_fround(f443 * f540) + Math_fround(f446 * f541)) + Math_fround(f449 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f443 * f542) + Math_fround(f446 * f543)) + Math_fround(f449 * f556));
       HEAPF32[i509 >> 2] = Math_fround(f544 + f545);
       HEAPF32[i297 >> 2] = f546;
       HEAPF32[i298 >> 2] = f547;
       HEAPF32[i299 >> 2] = f548;
       HEAPF32[i300 >> 2] = f549;
       HEAPF32[i301 >> 2] = f550;
       HEAPF32[i302 >> 2] = f551;
       HEAPF32[i303 >> 2] = f552;
       HEAPF32[i304 >> 2] = f553;
       HEAPF32[i305 >> 2] = f554;
       HEAPF32[i306 >> 2] = f555;
       HEAPF32[i307 >> 2] = f556;
      }
      if (i308) {
       i69 = HEAP32[i515 >> 2] | 0;
       i72 = i69 + 1068538453 | 0;
       i73 = HEAP32[i213 >> 2] | 0;
       i71 = i73 + 1068538453 | 0;
       i66 = HEAP32[i214 >> 2] | 0;
       i65 = i66 + 1068538453 | 0;
       i64 = HEAP32[i215 >> 2] | 0;
       i68 = i64 + 1068538453 | 0;
       i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i482 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i72 = i72 << 11 ^ i72;
       i71 = i71 << 11 ^ i71;
       i65 = i65 << 11 ^ i65;
       i68 = i68 << 11 ^ i68;
       f554 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i482 ^ i65 ^ i65 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i525 >> 2] = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i309 >> 2] = f554;
       HEAPF32[i310 >> 2] = f555;
       HEAPF32[i311 >> 2] = f556;
       i69 = i69 + 1068538454 | 0;
       i73 = i73 + 1068538454 | 0;
       i66 = i66 + 1068538454 | 0;
       i64 = i64 + 1068538454 | 0;
       i74 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i72 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i73 = i73 << 11 ^ i73;
       i66 = i66 << 11 ^ i66;
       i64 = i64 << 11 ^ i64;
       f556 = Math_fround(Math_fround((i72 ^ i73 ^ i73 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i70 ^ i66 ^ i66 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f554 = Math_fround(Math_fround((i68 ^ i64 ^ i64 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i312 >> 2] = Math_fround(Math_fround((i74 ^ i69 ^ i69 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i313 >> 2] = f556;
       HEAPF32[i314 >> 2] = f555;
       HEAPF32[i315 >> 2] = f554;
       i74 = HEAP32[i515 >> 2] | 0;
       i69 = i74 + 1068538455 | 0;
       i68 = HEAP32[i213 >> 2] | 0;
       i64 = i68 + 1068538455 | 0;
       i70 = HEAP32[i214 >> 2] | 0;
       i66 = i70 + 1068538455 | 0;
       i72 = HEAP32[i215 >> 2] | 0;
       i73 = i72 + 1068538455 | 0;
       i482 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i64 = i64 << 11 ^ i64;
       i66 = i66 << 11 ^ i66;
       i73 = i73 << 11 ^ i73;
       f554 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i71 ^ i73 ^ i73 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i316 >> 2] = Math_fround(Math_fround((i482 ^ i69 ^ i69 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i317 >> 2] = f554;
       HEAPF32[i318 >> 2] = f555;
       HEAPF32[i319 >> 2] = f556;
       f556 = Math_fround(Math_fround(HEAPF32[i514 >> 2]) * Math_fround(1.0e5));
       f555 = Math_fround(Math_fround(HEAPF32[i209 >> 2]) * Math_fround(1.0e5));
       f554 = Math_fround(Math_fround(HEAPF32[i210 >> 2]) * Math_fround(1.0e5));
       i74 = i74 + 1068538453 + ~~f556 | 0;
       i68 = i68 + 1068538453 + ~~f555 | 0;
       i70 = i70 + 1068538453 + ~~f554 | 0;
       i72 = i72 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i211 >> 2]) * Math_fround(1.0e5)) | 0;
       i482 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i68 = i68 << 11 ^ i68;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       f554 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i320 >> 2] = Math_fround(Math_fround((i482 ^ i74 ^ i74 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i321 >> 2] = f554;
       HEAPF32[i322 >> 2] = f555;
       HEAPF32[i323 >> 2] = f556;
      }
      i67 = HEAP32[i188 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i83 >> 2] | 0;
      i70 = HEAP32[i87 >> 2] | 0;
      i71 = HEAP32[i208 >> 2] | 0;
      i72 = HEAP32[i88 >> 2] | 0;
      i73 = HEAP32[i191 >> 2] | 0;
      i74 = HEAP32[i527 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i509 + (i66 << 2) | 0;
       i12 = i331 + (i66 << 2) | 0;
       i13 = i332 + (i66 << 2) | 0;
       i14 = i525 + (i66 << 2) | 0;
       i15 = i312 + (i66 << 2) | 0;
       i16 = i316 + (i66 << 2) | 0;
       i17 = i320 + (i66 << 2) | 0;
       i18 = i518 + (i66 << 2) | 0;
       i19 = i78 + (i66 << 2) | 0;
       i20 = i80 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i519 + (i66 << 2) | 0;
       i61 = i89 + (i66 << 2) | 0;
       i62 = i90 + (i66 << 2) | 0;
       i63 = i517 + (i66 << 2) | 0;
       i64 = i91 + (i66 << 2) | 0;
       i65 = i92 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i523 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i324) {
         i482 = i524 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i482 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i325) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i326) {
         i482 = i521 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i327) {
         i482 = i522 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i328) {
         f556 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f556;
         i1 = i1 + 16 | 0;
        }
        if (!i329) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i330) {
         i482 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i482;
         HEAP32[i1 + 4 >> 2] = i482;
         HEAP32[i1 + 8 >> 2] = i482;
         i1 = i1 + 12 | 0;
        }
        if (i296) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i333) {
         f556 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i482 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f556;
         HEAP32[i1 + 4 >> 2] = i482;
         i1 = i1 + 8 | 0;
        }
        if (!i334) {
         i482 = (HEAP32[i86 >> 2] & 2147483647 | 0) == 0 ? i510 : i22;
         HEAP32[i1 >> 2] = HEAP32[i482 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i335) {
         i482 = (HEAP32[i81 >> 2] & 2147483647 | 0) == 0 ? i510 : i21;
         HEAP32[i1 >> 2] = HEAP32[i482 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i308) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i77) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i163 >>> 0);
   }
   STACKTOP = i530;
   return;
  }
 case 3:
  {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i463 = i13 + 380 | 0;
   f478 = Math_fround(HEAPF32[i463 >> 2]);
   f470 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f473 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 392 | 0;
   f476 = Math_fround(HEAPF32[i463 >> 2]);
   f468 = Math_fround(HEAPF32[i463 + 4 >> 2]);
   f471 = Math_fround(HEAPF32[i463 + 8 >> 2]);
   i463 = i13 + 332 | 0;
   f479 = Math_fround((HEAP32[i463 >> 2] & 4095) >>> 0);
   f480 = Math_fround(HEAPF32[i13 + 368 >> 2]);
   f481 = Math_fround(HEAPF32[i13 + 372 >> 2]);
   f483 = Math_fround(HEAPF32[i13 + 376 >> 2]);
   i3 = i13 + 420 | 0;
   f484 = Math_fround(HEAPF32[i13 + 404 >> 2]);
   i1 = i13 + 408 | 0;
   f477 = Math_fround(HEAPF32[i1 >> 2]);
   f469 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f472 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i1 = i13 + 336 | 0;
   f485 = Math_fround(HEAPF32[i1 >> 2]);
   f486 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f487 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f488 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   i1 = i13 + 352 | 0;
   f475 = Math_fround(HEAPF32[i1 >> 2]);
   f467 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i1 = i13 + 360 | 0;
   f474 = Math_fround(HEAPF32[i1 >> 2]);
   f466 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i2 = HEAP32[i2 + 56 >> 2] | 0;
   f441 = Math_fround(HEAPF32[i13 + 128 >> 2]);
   f442 = Math_fround(HEAPF32[i13 + 132 >> 2]);
   f443 = Math_fround(HEAPF32[i13 + 136 >> 2]);
   f444 = Math_fround(HEAPF32[i13 + 144 >> 2]);
   f445 = Math_fround(HEAPF32[i13 + 148 >> 2]);
   f446 = Math_fround(HEAPF32[i13 + 152 >> 2]);
   f447 = Math_fround(HEAPF32[i13 + 160 >> 2]);
   f448 = Math_fround(HEAPF32[i13 + 164 >> 2]);
   f449 = Math_fround(HEAPF32[i13 + 168 >> 2]);
   f450 = Math_fround(HEAPF32[i13 + 176 >> 2]);
   f464 = Math_fround(HEAPF32[i13 + 180 >> 2]);
   f465 = Math_fround(HEAPF32[i13 + 184 >> 2]);
   i1 = i13 + 64 | 0;
   i438 = i520 + 12 | 0;
   i439 = i520 + 8 | 0;
   i440 = i520 + 4 | 0;
   i451 = i520 + 28 | 0;
   HEAP32[i520 >> 2] = 0;
   HEAP32[i520 + 4 >> 2] = 0;
   HEAP32[i520 + 8 >> 2] = 0;
   HEAP32[i520 + 12 >> 2] = 0;
   HEAP32[i451 >> 2] = 1;
   i452 = i520 + 24 | 0;
   HEAP32[i452 >> 2] = 1;
   i453 = i520 + 20 | 0;
   HEAP32[i453 >> 2] = 1;
   i454 = i520 + 16 | 0;
   HEAP32[i454 >> 2] = 1;
   i455 = i520 + 44 | 0;
   HEAP32[i455 >> 2] = 2;
   i456 = i520 + 40 | 0;
   HEAP32[i456 >> 2] = 2;
   i457 = i520 + 36 | 0;
   HEAP32[i457 >> 2] = 2;
   i458 = i520 + 32 | 0;
   HEAP32[i458 >> 2] = 2;
   i459 = i520 + 60 | 0;
   HEAP32[i459 >> 2] = 3;
   i460 = i520 + 56 | 0;
   HEAP32[i460 >> 2] = 3;
   i461 = i520 + 52 | 0;
   HEAP32[i461 >> 2] = 3;
   i462 = i520 + 48 | 0;
   HEAP32[i462 >> 2] = 3;
   i389 = i521 + 4 | 0;
   i413 = i521 + 8 | 0;
   i437 = i521 + 12 | 0;
   i365 = i521 + 16 | 0;
   HEAP32[i521 >> 2] = 0;
   HEAP32[i521 + 4 >> 2] = 0;
   HEAP32[i521 + 8 >> 2] = 0;
   HEAP32[i521 + 12 >> 2] = 0;
   HEAPF32[i365 >> 2] = Math_fround(1.0);
   i388 = i521 + 20 | 0;
   HEAPF32[i388 >> 2] = Math_fround(1.0);
   i412 = i521 + 24 | 0;
   HEAPF32[i412 >> 2] = Math_fround(1.0);
   i436 = i521 + 28 | 0;
   HEAPF32[i436 >> 2] = Math_fround(1.0);
   i364 = i521 + 32 | 0;
   HEAPF32[i364 >> 2] = Math_fround(1.0);
   i387 = i521 + 36 | 0;
   HEAPF32[i387 >> 2] = Math_fround(1.0);
   i411 = i521 + 40 | 0;
   HEAPF32[i411 >> 2] = Math_fround(1.0);
   i435 = i521 + 44 | 0;
   HEAPF32[i435 >> 2] = Math_fround(1.0);
   i363 = i521 + 48 | 0;
   HEAPF32[i363 >> 2] = Math_fround(1.0);
   i386 = i521 + 52 | 0;
   HEAPF32[i386 >> 2] = Math_fround(1.0);
   i410 = i521 + 56 | 0;
   HEAPF32[i410 >> 2] = Math_fround(1.0);
   i434 = i521 + 60 | 0;
   HEAPF32[i434 >> 2] = Math_fround(1.0);
   i362 = i521 + 64 | 0;
   HEAPF32[i362 >> 2] = Math_fround(1.0);
   i385 = i521 + 68 | 0;
   HEAPF32[i385 >> 2] = Math_fround(1.0);
   i409 = i521 + 72 | 0;
   HEAPF32[i409 >> 2] = Math_fround(1.0);
   i433 = i521 + 76 | 0;
   HEAPF32[i433 >> 2] = Math_fround(1.0);
   i361 = i521 + 80 | 0;
   i384 = i521 + 84 | 0;
   i408 = i521 + 88 | 0;
   i432 = i521 + 92 | 0;
   i360 = i521 + 96 | 0;
   i383 = i521 + 100 | 0;
   i407 = i521 + 104 | 0;
   i431 = i521 + 108 | 0;
   i359 = i521 + 112 | 0;
   i382 = i521 + 116 | 0;
   i406 = i521 + 120 | 0;
   i430 = i521 + 124 | 0;
   i16 = i361;
   i15 = i16 + 48 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i381 = i522 + 4 | 0;
   i405 = i522 + 8 | 0;
   i429 = i522 + 12 | 0;
   i358 = i522 + 16 | 0;
   HEAP32[i522 >> 2] = 0;
   HEAP32[i522 + 4 >> 2] = 0;
   HEAP32[i522 + 8 >> 2] = 0;
   HEAP32[i522 + 12 >> 2] = 0;
   HEAPF32[i358 >> 2] = Math_fround(1.0);
   i380 = i522 + 20 | 0;
   HEAPF32[i380 >> 2] = Math_fround(1.0);
   i404 = i522 + 24 | 0;
   HEAPF32[i404 >> 2] = Math_fround(1.0);
   i428 = i522 + 28 | 0;
   HEAPF32[i428 >> 2] = Math_fround(1.0);
   i357 = i522 + 32 | 0;
   i379 = i522 + 36 | 0;
   i403 = i522 + 40 | 0;
   i427 = i522 + 44 | 0;
   i356 = i522 + 48 | 0;
   i378 = i522 + 52 | 0;
   i402 = i522 + 56 | 0;
   i426 = i522 + 60 | 0;
   i355 = i522 + 64 | 0;
   HEAP32[i357 >> 2] = 0;
   HEAP32[i357 + 4 >> 2] = 0;
   HEAP32[i357 + 8 >> 2] = 0;
   HEAP32[i357 + 12 >> 2] = 0;
   HEAP32[i357 + 16 >> 2] = 0;
   HEAP32[i357 + 20 >> 2] = 0;
   HEAP32[i357 + 24 >> 2] = 0;
   HEAP32[i357 + 28 >> 2] = 0;
   HEAPF32[i355 >> 2] = Math_fround(1.0);
   i377 = i522 + 68 | 0;
   HEAPF32[i377 >> 2] = Math_fround(1.0);
   i401 = i522 + 72 | 0;
   HEAPF32[i401 >> 2] = Math_fround(1.0);
   i425 = i522 + 76 | 0;
   HEAPF32[i425 >> 2] = Math_fround(1.0);
   i354 = i522 + 80 | 0;
   HEAPF32[i354 >> 2] = Math_fround(1.0);
   i376 = i522 + 84 | 0;
   HEAPF32[i376 >> 2] = Math_fround(1.0);
   i400 = i522 + 88 | 0;
   HEAPF32[i400 >> 2] = Math_fround(1.0);
   i424 = i522 + 92 | 0;
   HEAPF32[i424 >> 2] = Math_fround(1.0);
   i353 = i522 + 96 | 0;
   i375 = i522 + 100 | 0;
   i399 = i522 + 104 | 0;
   i423 = i522 + 108 | 0;
   i352 = i522 + 112 | 0;
   i374 = i522 + 116 | 0;
   i398 = i522 + 120 | 0;
   i422 = i522 + 124 | 0;
   i351 = i522 + 128 | 0;
   HEAP32[i353 >> 2] = 0;
   HEAP32[i353 + 4 >> 2] = 0;
   HEAP32[i353 + 8 >> 2] = 0;
   HEAP32[i353 + 12 >> 2] = 0;
   HEAP32[i353 + 16 >> 2] = 0;
   HEAP32[i353 + 20 >> 2] = 0;
   HEAP32[i353 + 24 >> 2] = 0;
   HEAP32[i353 + 28 >> 2] = 0;
   HEAPF32[i351 >> 2] = Math_fround(1.0);
   i373 = i522 + 132 | 0;
   HEAPF32[i373 >> 2] = Math_fround(1.0);
   i397 = i522 + 136 | 0;
   HEAPF32[i397 >> 2] = Math_fround(1.0);
   i421 = i522 + 140 | 0;
   HEAPF32[i421 >> 2] = Math_fround(1.0);
   i350 = i522 + 144 | 0;
   i372 = i522 + 148 | 0;
   i396 = i522 + 152 | 0;
   i420 = i522 + 156 | 0;
   i349 = i522 + 160 | 0;
   i371 = i522 + 164 | 0;
   i395 = i522 + 168 | 0;
   i419 = i522 + 172 | 0;
   i348 = i522 + 176 | 0;
   i370 = i522 + 180 | 0;
   i394 = i522 + 184 | 0;
   i418 = i522 + 188 | 0;
   i347 = i522 + 192 | 0;
   i369 = i522 + 196 | 0;
   i393 = i522 + 200 | 0;
   i417 = i522 + 204 | 0;
   i346 = i522 + 208 | 0;
   i368 = i522 + 212 | 0;
   i392 = i522 + 216 | 0;
   i416 = i522 + 220 | 0;
   i345 = i522 + 224 | 0;
   i367 = i522 + 228 | 0;
   i391 = i522 + 232 | 0;
   i415 = i522 + 236 | 0;
   i336 = i522 + 240 | 0;
   i366 = i522 + 244 | 0;
   i390 = i522 + 248 | 0;
   i414 = i522 + 252 | 0;
   i16 = i350;
   i15 = i16 + 112 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   i16 = i12;
   i15 = i16 + 64 | 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
    i16 = i16 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i16 | 0) < (i15 | 0));
   __ZN10Matrix3x3fC2ERK10Matrix4x4f(i14, i12);
   f338 = Math_fround(HEAPF32[i3 >> 2]);
   f550 = Math_fround(HEAPF32[i13 + 428 >> 2]);
   f82 = Math_fround(HEAPF32[i13 + 424 >> 2]);
   f552 = Math_fround(HEAPF32[i14 >> 2]);
   i331 = i14 + 4 | 0;
   f548 = Math_fround(HEAPF32[i331 >> 2]);
   i332 = i14 + 8 | 0;
   f342 = Math_fround(HEAPF32[i332 >> 2]);
   i333 = i14 + 12 | 0;
   f554 = Math_fround(HEAPF32[i333 >> 2]);
   i334 = i14 + 16 | 0;
   f549 = Math_fround(HEAPF32[i334 >> 2]);
   i335 = i14 + 20 | 0;
   f343 = Math_fround(HEAPF32[i335 >> 2]);
   i482 = i14 + 24 | 0;
   f556 = Math_fround(HEAPF32[i482 >> 2]);
   i163 = i14 + 28 | 0;
   f551 = Math_fround(HEAPF32[i163 >> 2]);
   i162 = i14 + 32 | 0;
   f344 = Math_fround(HEAPF32[i162 >> 2]);
   f553 = Math_fround(f548 * Math_fround(0.0));
   f339 = Math_fround(f342 * Math_fround(0.0));
   f85 = Math_fround(Math_fround(Math_fround(f338 * f552) + f553) + f339);
   f555 = Math_fround(f549 * Math_fround(0.0));
   f340 = Math_fround(f343 * Math_fround(0.0));
   f337 = Math_fround(Math_fround(Math_fround(f338 * f554) + f555) + f340);
   f84 = Math_fround(f551 * Math_fround(0.0));
   f341 = Math_fround(f344 * Math_fround(0.0));
   f338 = Math_fround(Math_fround(Math_fround(f338 * f556) + f84) + f341);
   f552 = Math_fround(f552 * Math_fround(0.0));
   f339 = Math_fround(Math_fround(f552 + Math_fround(f550 * f548)) + f339);
   f554 = Math_fround(f554 * Math_fround(0.0));
   f340 = Math_fround(Math_fround(f554 + Math_fround(f550 * f549)) + f340);
   f556 = Math_fround(f556 * Math_fround(0.0));
   f341 = Math_fround(Math_fround(f556 + Math_fround(f550 * f551)) + f341);
   f342 = Math_fround(Math_fround(f552 + f553) + Math_fround(f82 * f342));
   f343 = Math_fround(Math_fround(f554 + f555) + Math_fround(f82 * f343));
   f344 = Math_fround(Math_fround(f556 + f84) + Math_fround(f82 * f344));
   HEAPF32[i14 >> 2] = f85;
   HEAPF32[i331 >> 2] = f339;
   HEAPF32[i332 >> 2] = f342;
   HEAPF32[i333 >> 2] = f337;
   HEAPF32[i334 >> 2] = f340;
   HEAPF32[i335 >> 2] = f343;
   HEAPF32[i482 >> 2] = f338;
   HEAPF32[i163 >> 2] = f341;
   HEAPF32[i162 >> 2] = f344;
   f82 = Math_fround(Math_fround(1.0) / f479);
   f84 = Math_fround(Math_fround(1.0) - f483);
   i162 = (i2 | 0) == 27;
   HEAP32[i510 >> 2] = 0;
   HEAP32[i510 + 4 >> 2] = 0;
   HEAP32[i510 + 8 >> 2] = 0;
   HEAP32[i510 + 12 >> 2] = 0;
   i163 = HEAP32[i526 + 12 >> 2] | 0;
   if (i163 | 0) {
    i164 = i528 + 12 | 0;
    i165 = i528 + 8 | 0;
    i166 = i528 + 4 | 0;
    i167 = i528 + 16 | 0;
    i168 = i528 + 28 | 0;
    i169 = i528 + 24 | 0;
    i170 = i528 + 20 | 0;
    i171 = i528 + 32 | 0;
    i172 = i528 + 44 | 0;
    i173 = i528 + 40 | 0;
    i174 = i528 + 36 | 0;
    i175 = i529 + 32 | 0;
    i176 = i529 + 44 | 0;
    i177 = i529 + 40 | 0;
    i178 = i529 + 36 | 0;
    i179 = i511 + 12 | 0;
    i180 = i511 + 8 | 0;
    i181 = i511 + 4 | 0;
    i182 = i511 + 28 | 0;
    i183 = i511 + 24 | 0;
    i184 = i511 + 20 | 0;
    i185 = i511 + 44 | 0;
    i186 = i511 + 40 | 0;
    i187 = i511 + 36 | 0;
    i188 = i527 + 20 | 0;
    i189 = i526 + 20 | 0;
    i190 = i526 + 40 | 0;
    i191 = i526 + 340 | 0;
    i192 = i526 + 60 | 0;
    i193 = i526 + 80 | 0;
    i194 = i526 + 100 | 0;
    i195 = i526 + 120 | 0;
    i196 = i526 + 140 | 0;
    i197 = i526 + 160 | 0;
    i198 = i511 + 16 | 0;
    i199 = i511 + 32 | 0;
    i200 = i527 + 4 | 0;
    i201 = i512 + 4 | 0;
    i202 = i512 + 8 | 0;
    i203 = i512 + 12 | 0;
    i204 = i527 + 8 | 0;
    i205 = i513 + 4 | 0;
    i206 = i513 + 8 | 0;
    i207 = i513 + 12 | 0;
    i208 = i526 + 520 | 0;
    i209 = i514 + 4 | 0;
    i210 = i514 + 8 | 0;
    i211 = i514 + 12 | 0;
    i212 = i526 + 500 | 0;
    i213 = i515 + 4 | 0;
    i214 = i515 + 8 | 0;
    i215 = i515 + 12 | 0;
    i216 = i527 + 16 | 0;
    i217 = i516 + 4 | 0;
    i218 = i516 + 8 | 0;
    i219 = i516 + 12 | 0;
    i220 = i528 + 16 | 0;
    i221 = i528 + 32 | 0;
    i222 = i517 + 4 | 0;
    i223 = i517 + 8 | 0;
    i224 = i517 + 12 | 0;
    i225 = i517 + 16 | 0;
    i226 = i517 + 20 | 0;
    i227 = i517 + 24 | 0;
    i228 = i517 + 28 | 0;
    i229 = i517 + 32 | 0;
    i230 = i517 + 36 | 0;
    i231 = i517 + 40 | 0;
    i232 = i517 + 44 | 0;
    i233 = i529 + 32 | 0;
    i234 = i523 + 4 | 0;
    i235 = i523 + 8 | 0;
    i236 = i523 + 12 | 0;
    i237 = i523 + 16 | 0;
    i238 = i523 + 20 | 0;
    i239 = i523 + 24 | 0;
    i240 = i523 + 28 | 0;
    i241 = i523 + 32 | 0;
    i242 = i523 + 36 | 0;
    i243 = i523 + 40 | 0;
    i244 = i523 + 44 | 0;
    i245 = i523 + 48 | 0;
    i246 = i523 + 52 | 0;
    i247 = i523 + 56 | 0;
    i248 = i523 + 60 | 0;
    i249 = i523 + 64 | 0;
    i250 = i523 + 68 | 0;
    i251 = i523 + 72 | 0;
    i252 = i523 + 76 | 0;
    i253 = i523 + 80 | 0;
    i254 = i523 + 84 | 0;
    i255 = i523 + 88 | 0;
    i256 = i523 + 92 | 0;
    i257 = i523 + 96 | 0;
    i258 = i523 + 100 | 0;
    i259 = i523 + 104 | 0;
    i260 = i523 + 108 | 0;
    i261 = i523 + 112 | 0;
    i262 = i523 + 116 | 0;
    i263 = i523 + 120 | 0;
    i264 = i523 + 124 | 0;
    i265 = i523 + 128 | 0;
    i266 = i523 + 132 | 0;
    i267 = i523 + 136 | 0;
    i268 = i523 + 140 | 0;
    i269 = i523 + 144 | 0;
    i270 = i523 + 148 | 0;
    i271 = i523 + 152 | 0;
    i272 = i523 + 156 | 0;
    i273 = i523 + 160 | 0;
    i274 = i523 + 164 | 0;
    i275 = i523 + 168 | 0;
    i276 = i523 + 172 | 0;
    i277 = i523 + 176 | 0;
    i278 = i523 + 180 | 0;
    i279 = i523 + 184 | 0;
    i280 = i523 + 188 | 0;
    i281 = (i2 & 48 | 0) == 0;
    i124 = i524 + 4 | 0;
    i141 = i524 + 8 | 0;
    i158 = i524 + 12 | 0;
    i282 = i524 + 16 | 0;
    i119 = i524 + 20 | 0;
    i136 = i524 + 24 | 0;
    i153 = i524 + 28 | 0;
    i283 = i524 + 32 | 0;
    i114 = i524 + 36 | 0;
    i131 = i524 + 40 | 0;
    i148 = i524 + 44 | 0;
    i284 = i524 + 48 | 0;
    i123 = i524 + 52 | 0;
    i140 = i524 + 56 | 0;
    i157 = i524 + 60 | 0;
    i285 = i524 + 64 | 0;
    i118 = i524 + 68 | 0;
    i135 = i524 + 72 | 0;
    i152 = i524 + 76 | 0;
    i286 = i524 + 80 | 0;
    i113 = i524 + 84 | 0;
    i130 = i524 + 88 | 0;
    i147 = i524 + 92 | 0;
    i287 = i524 + 96 | 0;
    i122 = i524 + 100 | 0;
    i139 = i524 + 104 | 0;
    i156 = i524 + 108 | 0;
    i288 = i524 + 112 | 0;
    i117 = i524 + 116 | 0;
    i134 = i524 + 120 | 0;
    i151 = i524 + 124 | 0;
    i289 = i524 + 128 | 0;
    i112 = i524 + 132 | 0;
    i129 = i524 + 136 | 0;
    i146 = i524 + 140 | 0;
    i290 = i524 + 144 | 0;
    i121 = i524 + 148 | 0;
    i138 = i524 + 152 | 0;
    i155 = i524 + 156 | 0;
    i291 = i524 + 160 | 0;
    i116 = i524 + 164 | 0;
    i133 = i524 + 168 | 0;
    i150 = i524 + 172 | 0;
    i292 = i524 + 176 | 0;
    i111 = i524 + 180 | 0;
    i128 = i524 + 184 | 0;
    i145 = i524 + 188 | 0;
    i125 = i518 + 4 | 0;
    i142 = i518 + 8 | 0;
    i159 = i518 + 12 | 0;
    i293 = i518 + 16 | 0;
    i120 = i518 + 20 | 0;
    i137 = i518 + 24 | 0;
    i154 = i518 + 28 | 0;
    i294 = i518 + 32 | 0;
    i115 = i518 + 36 | 0;
    i132 = i518 + 40 | 0;
    i149 = i518 + 44 | 0;
    i127 = i519 + 4 | 0;
    i144 = i519 + 8 | 0;
    i161 = i519 + 12 | 0;
    i295 = i519 + 16 | 0;
    i126 = i519 + 20 | 0;
    i143 = i519 + 24 | 0;
    i160 = i519 + 28 | 0;
    i110 = i519 + 32 | 0;
    i296 = (i2 & 512 | 0) != 0;
    i297 = i509 + 4 | 0;
    i298 = i509 + 8 | 0;
    i299 = i509 + 12 | 0;
    i300 = i509 + 16 | 0;
    i301 = i509 + 20 | 0;
    i302 = i509 + 24 | 0;
    i303 = i509 + 28 | 0;
    i304 = i509 + 32 | 0;
    i305 = i509 + 36 | 0;
    i306 = i509 + 40 | 0;
    i307 = i509 + 44 | 0;
    i308 = (i2 & 8192 | 0) != 0;
    i309 = i525 + 4 | 0;
    i310 = i525 + 8 | 0;
    i311 = i525 + 12 | 0;
    i312 = i525 + 16 | 0;
    i313 = i525 + 20 | 0;
    i314 = i525 + 24 | 0;
    i315 = i525 + 28 | 0;
    i316 = i525 + 32 | 0;
    i317 = i525 + 36 | 0;
    i318 = i525 + 40 | 0;
    i319 = i525 + 44 | 0;
    i320 = i525 + 48 | 0;
    i321 = i525 + 52 | 0;
    i322 = i525 + 56 | 0;
    i323 = i525 + 60 | 0;
    i324 = (i2 & 2 | 0) == 0;
    i325 = (i2 & 8 | 0) == 0;
    i326 = (i2 & 16 | 0) == 0;
    i327 = (i2 & 32 | 0) == 0;
    i328 = (i2 & 64 | 0) == 0;
    i329 = (i2 & 128 | 0) == 0;
    i330 = (i2 & 256 | 0) == 0;
    i331 = i509 + 16 | 0;
    i332 = i509 + 32 | 0;
    i333 = (i2 & 1024 | 0) == 0;
    i334 = (i2 & 2048 | 0) == 0;
    i335 = (i2 & 4096 | 0) == 0;
    i77 = (i2 & 4 | 0) == 0;
    i78 = i518 + 16 | 0;
    i80 = i518 + 32 | 0;
    i81 = i526 + 864 | 0;
    i83 = i526 + 848 | 0;
    i86 = i526 + 844 | 0;
    i87 = i526 + 828 | 0;
    i88 = i526 + 540 | 0;
    i89 = i519 + 16 | 0;
    i90 = i519 + 32 | 0;
    i91 = i517 + 16 | 0;
    i92 = i517 + 32 | 0;
    i93 = i523 + 16 | 0;
    i94 = i523 + 32 | 0;
    i95 = i524 + 16 | 0;
    i96 = i524 + 32 | 0;
    i97 = i245 + 16 | 0;
    i98 = i245 + 32 | 0;
    i99 = i284 + 16 | 0;
    i100 = i284 + 32 | 0;
    i101 = i257 + 16 | 0;
    i102 = i257 + 32 | 0;
    i103 = i287 + 16 | 0;
    i104 = i287 + 32 | 0;
    i105 = i269 + 16 | 0;
    i106 = i269 + 32 | 0;
    i107 = i290 + 16 | 0;
    i108 = i290 + 32 | 0;
    i109 = i4 + 564 | 0;
    i76 = i4 + 568 | 0;
    i75 = 0;
    i1 = i17;
    do {
     i16 = i528;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     i16 = i529;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     i16 = i511;
     i15 = i16 + 48 | 0;
     do {
      HEAP32[i16 >> 2] = 0;
      i16 = i16 + 4 | 0;
     } while ((i16 | 0) < (i15 | 0));
     HEAP32[i512 >> 2] = 0;
     HEAP32[i512 + 4 >> 2] = 0;
     HEAP32[i512 + 8 >> 2] = 0;
     HEAP32[i512 + 12 >> 2] = 0;
     HEAP32[i513 >> 2] = 0;
     HEAP32[i513 + 4 >> 2] = 0;
     HEAP32[i513 + 8 >> 2] = 0;
     HEAP32[i513 + 12 >> 2] = 0;
     HEAP32[i514 >> 2] = 0;
     HEAP32[i514 + 4 >> 2] = 0;
     HEAP32[i514 + 8 >> 2] = 0;
     HEAP32[i514 + 12 >> 2] = 0;
     HEAP32[i515 >> 2] = 0;
     HEAP32[i515 + 4 >> 2] = 0;
     HEAP32[i515 + 8 >> 2] = 0;
     HEAP32[i515 + 12 >> 2] = 0;
     HEAP32[i516 >> 2] = 0;
     HEAP32[i516 + 4 >> 2] = 0;
     HEAP32[i516 + 8 >> 2] = 0;
     HEAP32[i516 + 12 >> 2] = 0;
     i22 = HEAP32[i188 >> 2] | 0;
     i23 = HEAP32[i526 >> 2] | 0;
     if (!i22) {
      i64 = i23 + (i75 << 2) | 0;
      i65 = HEAP32[i64 + 4 >> 2] | 0;
      i66 = HEAP32[i64 + 8 >> 2] | 0;
      i67 = HEAP32[i64 + 12 >> 2] | 0;
      i71 = (HEAP32[i189 >> 2] | 0) + (i75 << 2) | 0;
      i68 = HEAP32[i71 >> 2] | 0;
      i69 = HEAP32[i71 + 4 >> 2] | 0;
      i70 = HEAP32[i71 + 8 >> 2] | 0;
      i71 = HEAP32[i71 + 12 >> 2] | 0;
      i72 = (HEAP32[i190 >> 2] | 0) + (i75 << 2) | 0;
      i482 = HEAP32[i72 >> 2] | 0;
      i74 = HEAP32[i72 + 4 >> 2] | 0;
      i73 = HEAP32[i72 + 8 >> 2] | 0;
      i72 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i528 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i166 >> 2] = i65;
      HEAP32[i165 >> 2] = i66;
      HEAP32[i164 >> 2] = i67;
      HEAP32[i167 >> 2] = i68;
      HEAP32[i170 >> 2] = i69;
      HEAP32[i169 >> 2] = i70;
      HEAP32[i168 >> 2] = i71;
      HEAP32[i171 >> 2] = i482;
      HEAP32[i174 >> 2] = i74;
      HEAP32[i173 >> 2] = i73;
      HEAP32[i172 >> 2] = i72;
      i72 = (HEAP32[i191 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i175 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i178 >> 2] = i73;
      HEAP32[i177 >> 2] = i74;
      HEAP32[i176 >> 2] = i482;
      i482 = (HEAP32[i192 >> 2] | 0) + (i75 << 2) | 0;
      f544 = Math_fround(HEAPF32[i482 >> 2]);
      f534 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f535 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f536 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i193 >> 2] | 0) + (i75 << 2) | 0;
      f537 = Math_fround(HEAPF32[i482 >> 2]);
      f538 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f539 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f540 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i194 >> 2] | 0) + (i75 << 2) | 0;
      f541 = Math_fround(HEAPF32[i482 >> 2]);
      f542 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f543 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f556 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i195 >> 2] | 0) + (i75 << 2) | 0;
      f545 = Math_fround(HEAPF32[i482 >> 2]);
      f546 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f547 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f548 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i196 >> 2] | 0) + (i75 << 2) | 0;
      f549 = Math_fround(HEAPF32[i482 >> 2]);
      f550 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f551 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f552 = Math_fround(HEAPF32[i482 + 12 >> 2]);
      i482 = (HEAP32[i197 >> 2] | 0) + (i75 << 2) | 0;
      f553 = Math_fround(HEAPF32[i482 >> 2]);
      f554 = Math_fround(HEAPF32[i482 + 4 >> 2]);
      f555 = Math_fround(HEAPF32[i482 + 8 >> 2]);
      f546 = Math_fround(f534 + f546);
      f547 = Math_fround(f535 + f547);
      f548 = Math_fround(f536 + f548);
      f549 = Math_fround(f537 + f549);
      f550 = Math_fround(f538 + f550);
      f551 = Math_fround(f539 + f551);
      f552 = Math_fround(f540 + f552);
      f553 = Math_fround(f541 + f553);
      f554 = Math_fround(f542 + f554);
      f555 = Math_fround(f543 + f555);
      f556 = Math_fround(f556 + Math_fround(HEAPF32[i482 + 12 >> 2]));
      HEAPF32[i511 >> 2] = Math_fround(f544 + f545);
      HEAPF32[i181 >> 2] = f546;
      HEAPF32[i180 >> 2] = f547;
      HEAPF32[i179 >> 2] = f548;
      HEAPF32[i198 >> 2] = f549;
      HEAPF32[i184 >> 2] = f550;
      HEAPF32[i183 >> 2] = f551;
      HEAPF32[i182 >> 2] = f552;
      HEAPF32[i199 >> 2] = f553;
      HEAPF32[i187 >> 2] = f554;
      HEAPF32[i186 >> 2] = f555;
      HEAPF32[i185 >> 2] = f556;
      i482 = (HEAP32[i200 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i482 + 4 >> 2] | 0;
      i73 = HEAP32[i482 + 8 >> 2] | 0;
      i72 = HEAP32[i482 + 12 >> 2] | 0;
      HEAP32[i512 >> 2] = HEAP32[i482 >> 2];
      HEAP32[i201 >> 2] = i74;
      HEAP32[i202 >> 2] = i73;
      HEAP32[i203 >> 2] = i72;
      i72 = (HEAP32[i204 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i513 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i205 >> 2] = i73;
      HEAP32[i206 >> 2] = i74;
      HEAP32[i207 >> 2] = i482;
      i482 = (HEAP32[i208 >> 2] | 0) + (i75 << 2) | 0;
      i74 = HEAP32[i482 + 4 >> 2] | 0;
      i73 = HEAP32[i482 + 8 >> 2] | 0;
      i72 = HEAP32[i482 + 12 >> 2] | 0;
      HEAP32[i514 >> 2] = HEAP32[i482 >> 2];
      HEAP32[i209 >> 2] = i74;
      HEAP32[i210 >> 2] = i73;
      HEAP32[i211 >> 2] = i72;
      i72 = (HEAP32[i212 >> 2] | 0) + (i75 << 2) | 0;
      i73 = HEAP32[i72 + 4 >> 2] | 0;
      i74 = HEAP32[i72 + 8 >> 2] | 0;
      i482 = HEAP32[i72 + 12 >> 2] | 0;
      HEAP32[i515 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i213 >> 2] = i73;
      HEAP32[i214 >> 2] = i74;
      HEAP32[i215 >> 2] = i482;
      if (HEAP32[i463 >> 2] & 268435456 | 0) {
       i72 = (HEAP32[i216 >> 2] | 0) + (i75 << 2) | 0;
       i73 = HEAP32[i72 + 4 >> 2] | 0;
       i74 = HEAP32[i72 + 8 >> 2] | 0;
       i482 = HEAP32[i72 + 12 >> 2] | 0;
       HEAP32[i516 >> 2] = HEAP32[i72 >> 2];
       HEAP32[i217 >> 2] = i73;
       HEAP32[i218 >> 2] = i74;
       HEAP32[i219 >> 2] = i482;
      }
     } else {
      i4 = HEAP32[i192 >> 2] | 0;
      i11 = HEAP32[i195 >> 2] | 0;
      i12 = HEAP32[i189 >> 2] | 0;
      i13 = HEAP32[i193 >> 2] | 0;
      i14 = HEAP32[i196 >> 2] | 0;
      i15 = HEAP32[i190 >> 2] | 0;
      i16 = HEAP32[i194 >> 2] | 0;
      i17 = HEAP32[i197 >> 2] | 0;
      i18 = HEAP32[i200 >> 2] | 0;
      i19 = HEAP32[i204 >> 2] | 0;
      i20 = HEAP32[i208 >> 2] | 0;
      i21 = HEAP32[i212 >> 2] | 0;
      i24 = HEAP32[i191 >> 2] | 0;
      i3 = HEAP32[i216 >> 2] | 0;
      if (!(HEAP32[i463 >> 2] & 268435456)) {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      } else {
       i2 = 0;
       do {
        i74 = HEAP32[i22 + (i2 + i75 << 3) >> 2] | 0;
        HEAP32[i528 + (i2 << 2) >> 2] = HEAP32[i23 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i4 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i11 + (i74 << 2) >> 2]));
        i482 = i2 + 4 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i12 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i13 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i74 << 2) >> 2]));
        i482 = i2 + 8 | 0;
        HEAP32[i528 + (i482 << 2) >> 2] = HEAP32[i15 + (i74 << 2) >> 2];
        f556 = Math_fround(HEAPF32[i16 + (i74 << 2) >> 2]);
        HEAPF32[i511 + (i482 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i17 + (i74 << 2) >> 2]));
        HEAP32[i512 + (i2 << 2) >> 2] = HEAP32[i18 + (i74 << 2) >> 2];
        HEAP32[i513 + (i2 << 2) >> 2] = HEAP32[i19 + (i74 << 2) >> 2];
        HEAP32[i514 + (i2 << 2) >> 2] = HEAP32[i20 + (i74 << 2) >> 2];
        HEAP32[i515 + (i2 << 2) >> 2] = HEAP32[i21 + (i74 << 2) >> 2];
        HEAP32[i516 + (i2 << 2) >> 2] = HEAP32[i3 + (i74 << 2) >> 2];
        HEAP32[i529 + (i482 << 2) >> 2] = HEAP32[i24 + (i74 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
      }
     }
     f33 = Math_fround(HEAPF32[i528 >> 2]);
     f7 = Math_fround(f441 * f33);
     f31 = Math_fround(HEAPF32[i166 >> 2]);
     f29 = Math_fround(f441 * f31);
     f556 = Math_fround(HEAPF32[i165 >> 2]);
     f6 = Math_fround(f441 * f556);
     f554 = Math_fround(HEAPF32[i164 >> 2]);
     f79 = Math_fround(f441 * f554);
     f32 = Math_fround(HEAPF32[i220 >> 2]);
     f30 = Math_fround(f444 * f32);
     f26 = Math_fround(HEAPF32[i170 >> 2]);
     f35 = Math_fround(f444 * f26);
     f555 = Math_fround(HEAPF32[i169 >> 2]);
     f10 = Math_fround(f444 * f555);
     f553 = Math_fround(HEAPF32[i168 >> 2]);
     f30 = Math_fround(f7 + f30);
     f35 = Math_fround(f29 + f35);
     f10 = Math_fround(f6 + f10);
     f79 = Math_fround(f79 + Math_fround(f444 * f553));
     f6 = Math_fround(HEAPF32[i221 >> 2]);
     f29 = Math_fround(f447 * f6);
     f7 = Math_fround(HEAPF32[i174 >> 2]);
     f28 = Math_fround(f447 * f7);
     f8 = Math_fround(HEAPF32[i173 >> 2]);
     f27 = Math_fround(f447 * f8);
     f34 = Math_fround(HEAPF32[i172 >> 2]);
     f28 = Math_fround(f450 + Math_fround(f35 + f28));
     f27 = Math_fround(f450 + Math_fround(f10 + f27));
     f79 = Math_fround(f450 + Math_fround(f79 + Math_fround(f447 * f34)));
     HEAPF32[i517 >> 2] = Math_fround(f450 + Math_fround(f30 + f29));
     HEAPF32[i222 >> 2] = f28;
     HEAPF32[i223 >> 2] = f27;
     HEAPF32[i224 >> 2] = f79;
     f79 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f31) + Math_fround(f445 * f26)) + Math_fround(f448 * f7)));
     f27 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f556) + Math_fround(f445 * f555)) + Math_fround(f448 * f8)));
     f28 = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f554) + Math_fround(f445 * f553)) + Math_fround(f448 * f34)));
     HEAPF32[i225 >> 2] = Math_fround(f464 + Math_fround(Math_fround(Math_fround(f442 * f33) + Math_fround(f445 * f32)) + Math_fround(f448 * f6)));
     HEAPF32[i226 >> 2] = f79;
     HEAPF32[i227 >> 2] = f27;
     HEAPF32[i228 >> 2] = f28;
     f28 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f31) + Math_fround(f446 * f26)) + Math_fround(f449 * f7)));
     f27 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f556) + Math_fround(f446 * f555)) + Math_fround(f449 * f8)));
     f79 = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f554) + Math_fround(f446 * f553)) + Math_fround(f449 * f34)));
     HEAPF32[i229 >> 2] = Math_fround(f465 + Math_fround(Math_fround(Math_fround(f443 * f33) + Math_fround(f446 * f32)) + Math_fround(f449 * f6)));
     HEAPF32[i230 >> 2] = f28;
     HEAPF32[i231 >> 2] = f27;
     HEAPF32[i232 >> 2] = f79;
     f6 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f33) + Math_fround(f486 * f32)) + Math_fround(f487 * f6)));
     f7 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f31) + Math_fround(f486 * f26)) + Math_fround(f487 * f7)));
     f8 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f556) + Math_fround(f486 * f555)) + Math_fround(f487 * f8)));
     f34 = Math_fround(f488 + Math_fround(Math_fround(Math_fround(f485 * f554) + Math_fround(f486 * f553)) + Math_fround(f487 * f34)));
     f553 = Math_fround(f474 + Math_fround(f475 * f6));
     f554 = Math_fround(f474 + Math_fround(f475 * f7));
     f555 = Math_fround(f474 + Math_fround(f475 * f8));
     f556 = Math_fround(f474 + Math_fround(f475 * f34));
     f6 = Math_fround(f466 + Math_fround(f467 * f6));
     f7 = Math_fround(f466 + Math_fround(f467 * f7));
     f8 = Math_fround(f466 + Math_fround(f467 * f8));
     f34 = Math_fround(f466 + Math_fround(f467 * f34));
     f26 = Math_fround(HEAPF32[i512 >> 2]);
     f31 = Math_fround(HEAPF32[i201 >> 2]);
     f32 = Math_fround(HEAPF32[i202 >> 2]);
     f33 = Math_fround(HEAPF32[i203 >> 2]);
     f27 = Math_fround(HEAPF32[i513 >> 2]);
     f28 = Math_fround(HEAPF32[i205 >> 2]);
     f29 = Math_fround(HEAPF32[i206 >> 2]);
     f30 = Math_fround(HEAPF32[i207 >> 2]);
     f10 = f26 > f27 ? f26 : f27;
     f35 = f31 > f28 ? f31 : f28;
     f25 = f32 > f29 ? f32 : f29;
     f36 = f33 > f30 ? f33 : f30;
     f550 = Math_fround((f10 > f553 ? f10 : f553) * Math_fround(.5));
     f551 = Math_fround((f35 > f554 ? f35 : f554) * Math_fround(.5));
     f552 = Math_fround((f25 > f555 ? f25 : f555) * Math_fround(.5));
     f5 = Math_fround((f36 > f556 ? f36 : f556) * Math_fround(.5));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f550, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f551, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f552, HEAP32[tempDoublePtr >> 2] | 0);
     i72 = f553 >= Math_fround(0.0);
     i73 = f554 >= Math_fround(0.0);
     i74 = f555 >= Math_fround(0.0);
     i482 = f556 >= Math_fround(0.0);
     i15 = i72 ? i15 : 0;
     i16 = i73 ? i16 : 0;
     i17 = i74 ? i17 : 0;
     i11 = i482 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f552 = Math_fround(f6 * Math_fround(.5));
     f554 = Math_fround(f7 * Math_fround(.5));
     f556 = Math_fround(f8 * Math_fround(.5));
     f5 = Math_fround(f34 * Math_fround(.5));
     f551 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f553 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f555 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f551 < f552 ? f551 : f552, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f553 < f554 ? f553 : f554, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f555 < f556 ? f555 : f556, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = f6 >= Math_fround(0.0);
     i3 = f7 >= Math_fround(0.0);
     i2 = f8 >= Math_fround(0.0);
     i482 = f34 >= Math_fround(0.0);
     i72 = i482 ? (HEAPF32[tempDoublePtr >> 2] = f9 < f5 ? f9 : f5, HEAP32[tempDoublePtr >> 2] | 0) : i11;
     f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i12 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
     f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i13 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f35);
     f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i14 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f36);
     f548 = Math_fround(f26 * f57);
     f547 = Math_fround(f31 * f56);
     f546 = Math_fround(f32 * f55);
     f545 = Math_fround(f33 * f34);
     f31 = Math_fround(f27 * f57);
     f32 = Math_fround(f28 * f56);
     f33 = Math_fround(f29 * f55);
     f34 = Math_fround(f30 * f34);
     i72 = Math_fround(HEAPF32[i514 >> 2]) < Math_fround(100.0);
     i73 = Math_fround(HEAPF32[i209 >> 2]) < Math_fround(100.0);
     i74 = Math_fround(HEAPF32[i210 >> 2]) < Math_fround(100.0);
     i482 = Math_fround(HEAPF32[i211 >> 2]) < Math_fround(100.0);
     f27 = i72 ? f548 : Math_fround(0.0);
     f548 = Math_fround(f478 * f27);
     f28 = i73 ? f547 : Math_fround(0.0);
     f547 = Math_fround(f478 * f28);
     f29 = i74 ? f546 : Math_fround(0.0);
     f546 = Math_fround(f478 * f29);
     f30 = i482 ? f545 : Math_fround(0.0);
     f545 = Math_fround(f478 * f30);
     f55 = Math_fround(f470 * f27);
     f56 = Math_fround(f470 * f28);
     f57 = Math_fround(f470 * f29);
     f58 = Math_fround(f470 * f30);
     f538 = Math_fround(f473 * f27);
     f53 = Math_fround(f473 * f28);
     f50 = Math_fround(f473 * f29);
     f47 = Math_fround(f473 * f30);
     f31 = i72 ? f31 : Math_fround(0.0);
     f543 = Math_fround(f476 * f31);
     f32 = i73 ? f32 : Math_fround(0.0);
     f554 = Math_fround(f476 * f32);
     f33 = i74 ? f33 : Math_fround(0.0);
     f542 = Math_fround(f476 * f33);
     f34 = i482 ? f34 : Math_fround(0.0);
     f553 = Math_fround(f476 * f34);
     f541 = Math_fround(f468 * f31);
     f552 = Math_fround(f468 * f32);
     f540 = Math_fround(f468 * f33);
     f551 = Math_fround(f468 * f34);
     f539 = Math_fround(f471 * f31);
     f549 = Math_fround(f471 * f32);
     f52 = Math_fround(f471 * f33);
     f49 = Math_fround(f471 * f34);
     f535 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) + Math_fround(.785398125));
     f536 = Math_fround(Math_fround(HEAPF32[i178 >> 2]) + Math_fround(.785398125));
     f537 = Math_fround(Math_fround(HEAPF32[i177 >> 2]) + Math_fround(.785398125));
     f535 = Math_fround(f535 * Math_fround(.159154937));
     f536 = Math_fround(f536 * Math_fround(.159154937));
     f537 = Math_fround(f537 * Math_fround(.159154937));
     f532 = Math_fround(Math_fround(Math_fround(HEAPF32[i176 >> 2]) + Math_fround(.785398125)) * Math_fround(.159154937));
     f508 = Math_fround(+_roundf(+f535));
     f43 = Math_fround(+_roundf(+f536));
     f534 = Math_fround(+_roundf(+f537));
     f508 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f535 - f508))));
     f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f536 - f43))));
     f534 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f534))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - Math_fround(+_roundf(+f532))))));
     f550 = Math_fround(f508 * f508);
     f54 = Math_fround(f43 * f43);
     f51 = Math_fround(f534 * f534);
     f48 = Math_fround(f44 * f44);
     f556 = Math_fround(f550 * f550);
     f45 = Math_fround(f54 * f54);
     f555 = Math_fround(f51 * f51);
     f46 = Math_fround(f48 * f48);
     f550 = Math_fround(f508 * Math_fround(Math_fround(Math_fround(f556 * f556) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f550 * Math_fround(41.3416595))) + Math_fround(f556 * Math_fround(Math_fround(81.6018218) - Math_fround(f550 * Math_fround(76.5686187)))))));
     f54 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
     f51 = Math_fround(f534 * Math_fround(Math_fround(Math_fround(f555 * f555) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f555 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
     f48 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f46 * f46) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f48 * Math_fround(41.3416595))) + Math_fround(f46 * Math_fround(Math_fround(81.6018218) - Math_fround(f48 * Math_fround(76.5686187)))))));
     f535 = Math_fround(f535 + Math_fround(-.25));
     f536 = Math_fround(f536 + Math_fround(-.25));
     f537 = Math_fround(f537 + Math_fround(-.25));
     f532 = Math_fround(f532 + Math_fround(-.25));
     f46 = Math_fround(+_roundf(+f535));
     f44 = Math_fround(+_roundf(+f536));
     f555 = Math_fround(+_roundf(+f537));
     f46 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f535 - f46))));
     f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f536 - f44))));
     f555 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f537 - f555))));
     f532 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f532 - Math_fround(+_roundf(+f532))))));
     f537 = Math_fround(f46 * f46);
     f536 = Math_fround(f44 * f44);
     f535 = Math_fround(f555 * f555);
     f534 = Math_fround(f532 * f532);
     f45 = Math_fround(f537 * f537);
     f43 = Math_fround(f536 * f536);
     f556 = Math_fround(f535 * f535);
     f508 = Math_fround(f534 * f534);
     f537 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f537 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f537 * Math_fround(76.5686187)))))));
     f536 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f43) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f536 * Math_fround(41.3416595))) + Math_fround(f43 * Math_fround(Math_fround(81.6018218) - Math_fround(f536 * Math_fround(76.5686187)))))));
     f535 = Math_fround(f555 * Math_fround(Math_fround(Math_fround(f556 * f556) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f535 * Math_fround(41.3416595))) + Math_fround(f556 * Math_fround(Math_fround(81.6018218) - Math_fround(f535 * Math_fround(76.5686187)))))));
     f534 = Math_fround(f532 * Math_fround(Math_fround(Math_fround(f508 * f508) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f534 * Math_fround(41.3416595))) + Math_fround(f508 * Math_fround(Math_fround(81.6018218) - Math_fround(f534 * Math_fround(76.5686187)))))));
     f508 = Math_fround(Math_fround(f548 * f550) + Math_fround(f543 * f537));
     f532 = Math_fround(Math_fround(f547 * f54) + Math_fround(f554 * f536));
     f556 = Math_fround(Math_fround(f546 * f51) + Math_fround(f542 * f535));
     f555 = Math_fround(Math_fround(f545 * f48) + Math_fround(f553 * f534));
     f43 = Math_fround(Math_fround(f55 * f550) + Math_fround(f541 * f537));
     f44 = Math_fround(Math_fround(f56 * f54) + Math_fround(f552 * f536));
     f45 = Math_fround(Math_fround(f57 * f51) + Math_fround(f540 * f535));
     f46 = Math_fround(Math_fround(f58 * f48) + Math_fround(f551 * f534));
     f507 = Math_fround(Math_fround(f538 * f550) + Math_fround(f539 * f537));
     f531 = Math_fround(Math_fround(f53 * f54) + Math_fround(f549 * f536));
     f533 = Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f535));
     f544 = Math_fround(Math_fround(f47 * f48) + Math_fround(f49 * f534));
     f35 = Math_fround(Math_fround(f338 * f507) + Math_fround(Math_fround(f85 * f508) + Math_fround(f337 * f43)));
     f36 = Math_fround(Math_fround(f338 * f531) + Math_fround(Math_fround(f85 * f532) + Math_fround(f337 * f44)));
     f37 = Math_fround(Math_fround(f338 * f533) + Math_fround(Math_fround(f85 * f556) + Math_fround(f337 * f45)));
     f38 = Math_fround(Math_fround(f338 * f544) + Math_fround(Math_fround(f85 * f555) + Math_fround(f337 * f46)));
     f39 = Math_fround(Math_fround(f341 * f507) + Math_fround(Math_fround(f339 * f508) + Math_fround(f340 * f43)));
     f40 = Math_fround(Math_fround(f341 * f531) + Math_fround(Math_fround(f339 * f532) + Math_fround(f340 * f44)));
     f41 = Math_fround(Math_fround(f341 * f533) + Math_fround(Math_fround(f339 * f556) + Math_fround(f340 * f45)));
     f42 = Math_fround(Math_fround(f341 * f544) + Math_fround(Math_fround(f339 * f555) + Math_fround(f340 * f46)));
     f43 = Math_fround(Math_fround(f344 * f507) + Math_fround(Math_fround(f342 * f508) + Math_fround(f343 * f43)));
     f44 = Math_fround(Math_fround(f344 * f531) + Math_fround(Math_fround(f342 * f532) + Math_fround(f343 * f44)));
     f45 = Math_fround(Math_fround(f344 * f533) + Math_fround(Math_fround(f342 * f556) + Math_fround(f343 * f45)));
     f46 = Math_fround(Math_fround(f344 * f544) + Math_fround(Math_fround(f342 * f555) + Math_fround(f343 * f46)));
     f548 = Math_fround(Math_fround(f543 * f550) - Math_fround(f548 * f537));
     f547 = Math_fround(Math_fround(f554 * f54) - Math_fround(f547 * f536));
     f546 = Math_fround(Math_fround(f542 * f51) - Math_fround(f546 * f535));
     f545 = Math_fround(Math_fround(f553 * f48) - Math_fround(f545 * f534));
     f55 = Math_fround(Math_fround(f541 * f550) - Math_fround(f55 * f537));
     f56 = Math_fround(Math_fround(f552 * f54) - Math_fround(f56 * f536));
     f57 = Math_fround(Math_fround(f540 * f51) - Math_fround(f57 * f535));
     f58 = Math_fround(Math_fround(f551 * f48) - Math_fround(f58 * f534));
     f537 = Math_fround(Math_fround(f539 * f550) - Math_fround(f538 * f537));
     f536 = Math_fround(Math_fround(f549 * f54) - Math_fround(f53 * f536));
     f535 = Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * f535));
     f534 = Math_fround(Math_fround(f49 * f48) - Math_fround(f47 * f534));
     f47 = Math_fround(Math_fround(f338 * f537) + Math_fround(Math_fround(f85 * f548) + Math_fround(f337 * f55)));
     f48 = Math_fround(Math_fround(f338 * f536) + Math_fround(Math_fround(f85 * f547) + Math_fround(f337 * f56)));
     f49 = Math_fround(Math_fround(f338 * f535) + Math_fround(Math_fround(f85 * f546) + Math_fround(f337 * f57)));
     f50 = Math_fround(Math_fround(f338 * f534) + Math_fround(Math_fround(f85 * f545) + Math_fround(f337 * f58)));
     f51 = Math_fround(Math_fround(f341 * f537) + Math_fround(Math_fround(f339 * f548) + Math_fround(f340 * f55)));
     f52 = Math_fround(Math_fround(f341 * f536) + Math_fround(Math_fround(f339 * f547) + Math_fround(f340 * f56)));
     f53 = Math_fround(Math_fround(f341 * f535) + Math_fround(Math_fround(f339 * f546) + Math_fround(f340 * f57)));
     f54 = Math_fround(Math_fround(f341 * f534) + Math_fround(Math_fround(f339 * f545) + Math_fround(f340 * f58)));
     f55 = Math_fround(Math_fround(f344 * f537) + Math_fround(Math_fround(f342 * f548) + Math_fround(f343 * f55)));
     f56 = Math_fround(Math_fround(f344 * f536) + Math_fround(Math_fround(f342 * f547) + Math_fround(f343 * f56)));
     f57 = Math_fround(Math_fround(f344 * f535) + Math_fround(Math_fround(f342 * f546) + Math_fround(f343 * f57)));
     f58 = Math_fround(Math_fround(f344 * f534) + Math_fround(Math_fround(f342 * f545) + Math_fround(f343 * f58)));
     f545 = Math_fround(HEAPF32[i517 >> 2]);
     f534 = Math_fround(f545 + f35);
     f546 = Math_fround(HEAPF32[i222 >> 2]);
     f535 = Math_fround(f546 + f36);
     f547 = Math_fround(HEAPF32[i223 >> 2]);
     f536 = Math_fround(f547 + f37);
     f548 = Math_fround(HEAPF32[i224 >> 2]);
     f537 = Math_fround(f548 + f38);
     f549 = Math_fround(HEAPF32[i225 >> 2]);
     f538 = Math_fround(f549 + f39);
     f550 = Math_fround(HEAPF32[i226 >> 2]);
     f539 = Math_fround(f550 + f40);
     f551 = Math_fround(HEAPF32[i227 >> 2]);
     f540 = Math_fround(f551 + f41);
     f552 = Math_fround(HEAPF32[i228 >> 2]);
     f541 = Math_fround(f552 + f42);
     f553 = Math_fround(HEAPF32[i229 >> 2]);
     f542 = Math_fround(f553 + f43);
     f554 = Math_fround(HEAPF32[i230 >> 2]);
     f543 = Math_fround(f554 + f44);
     f555 = Math_fround(HEAPF32[i231 >> 2]);
     f544 = Math_fround(f555 + f45);
     f556 = Math_fround(f79 + f46);
     HEAPF32[i523 >> 2] = f534;
     HEAPF32[i234 >> 2] = f535;
     HEAPF32[i235 >> 2] = f536;
     HEAPF32[i236 >> 2] = f537;
     HEAPF32[i237 >> 2] = f538;
     HEAPF32[i238 >> 2] = f539;
     HEAPF32[i239 >> 2] = f540;
     HEAPF32[i240 >> 2] = f541;
     HEAPF32[i241 >> 2] = f542;
     HEAPF32[i242 >> 2] = f543;
     HEAPF32[i243 >> 2] = f544;
     HEAPF32[i244 >> 2] = f556;
     f556 = Math_fround(f546 + f48);
     f544 = Math_fround(f547 + f49);
     f543 = Math_fround(f548 + f50);
     f542 = Math_fround(f549 + f51);
     f541 = Math_fround(f550 + f52);
     f540 = Math_fround(f551 + f53);
     f539 = Math_fround(f552 + f54);
     f538 = Math_fround(f553 + f55);
     f537 = Math_fround(f554 + f56);
     f536 = Math_fround(f555 + f57);
     f535 = Math_fround(f79 + f58);
     HEAPF32[i245 >> 2] = Math_fround(f545 + f47);
     HEAPF32[i246 >> 2] = f556;
     HEAPF32[i247 >> 2] = f544;
     HEAPF32[i248 >> 2] = f543;
     HEAPF32[i249 >> 2] = f542;
     HEAPF32[i250 >> 2] = f541;
     HEAPF32[i251 >> 2] = f540;
     HEAPF32[i252 >> 2] = f539;
     HEAPF32[i253 >> 2] = f538;
     HEAPF32[i254 >> 2] = f537;
     HEAPF32[i255 >> 2] = f536;
     HEAPF32[i256 >> 2] = f535;
     f535 = Math_fround(f546 - f36);
     f536 = Math_fround(f547 - f37);
     f537 = Math_fround(f548 - f38);
     f538 = Math_fround(f549 - f39);
     f539 = Math_fround(f550 - f40);
     f540 = Math_fround(f551 - f41);
     f541 = Math_fround(f552 - f42);
     f542 = Math_fround(f553 - f43);
     f543 = Math_fround(f554 - f44);
     f544 = Math_fround(f555 - f45);
     f556 = Math_fround(f79 - f46);
     HEAPF32[i257 >> 2] = Math_fround(f545 - f35);
     HEAPF32[i258 >> 2] = f535;
     HEAPF32[i259 >> 2] = f536;
     HEAPF32[i260 >> 2] = f537;
     HEAPF32[i261 >> 2] = f538;
     HEAPF32[i262 >> 2] = f539;
     HEAPF32[i263 >> 2] = f540;
     HEAPF32[i264 >> 2] = f541;
     HEAPF32[i265 >> 2] = f542;
     HEAPF32[i266 >> 2] = f543;
     HEAPF32[i267 >> 2] = f544;
     HEAPF32[i268 >> 2] = f556;
     f546 = Math_fround(f546 - f48);
     f547 = Math_fround(f547 - f49);
     f548 = Math_fround(f548 - f50);
     f549 = Math_fround(f549 - f51);
     f550 = Math_fround(f550 - f52);
     f551 = Math_fround(f551 - f53);
     f552 = Math_fround(f552 - f54);
     f553 = Math_fround(f553 - f55);
     f554 = Math_fround(f554 - f56);
     f555 = Math_fround(f555 - f57);
     f556 = Math_fround(f79 - f58);
     HEAPF32[i269 >> 2] = Math_fround(f545 - f47);
     HEAPF32[i270 >> 2] = f546;
     HEAPF32[i271 >> 2] = f547;
     HEAPF32[i272 >> 2] = f548;
     HEAPF32[i273 >> 2] = f549;
     HEAPF32[i274 >> 2] = f550;
     HEAPF32[i275 >> 2] = f551;
     HEAPF32[i276 >> 2] = f552;
     HEAPF32[i277 >> 2] = f553;
     HEAPF32[i278 >> 2] = f554;
     HEAPF32[i279 >> 2] = f555;
     HEAPF32[i280 >> 2] = f556;
     if (!i281) {
      i2 = HEAP32[i463 >> 2] | 0;
      if (i2 & 536870912) {
       f556 = Math_fround(HEAPF32[i109 >> 2]);
       i63 = HEAP32[i515 >> 2] | 0;
       i74 = i63 + 693089735 | 0;
       i61 = HEAP32[i213 >> 2] | 0;
       i71 = i61 + 693089735 | 0;
       i59 = HEAP32[i214 >> 2] | 0;
       i68 = i59 + 693089735 | 0;
       i23 = HEAP32[i215 >> 2] | 0;
       i65 = i23 + 693089735 | 0;
       i24 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i60 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i62 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i64 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i71 = i71 << 11 ^ i71;
       i68 = i68 << 11 ^ i68;
       i65 = i65 << 11 ^ i65;
       i24 = Math_fround(Math_fround((i24 ^ i74 ^ i74 >>> 8) & 8388607 ^ i24 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i60 = Math_fround(Math_fround((i60 ^ i71 ^ i71 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i62 = Math_fround(Math_fround((i62 ^ i68 ^ i68 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i64 = Math_fround(Math_fround((i64 ^ i65 ^ i65 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       f556 = Math_fround(HEAPF32[i76 >> 2]);
       i63 = i63 + 13945730 | 0;
       i61 = i61 + 13945730 | 0;
       i59 = i59 + 13945730 | 0;
       i23 = i23 + 13945730 | 0;
       i65 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i59, 1790253981) | 0) + 1900727103 | 0;
       i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
       i63 = i63 << 11 ^ i63;
       i61 = i61 << 11 ^ i61;
       i59 = i59 << 11 ^ i59;
       i23 = i23 << 11 ^ i23;
       i65 = Math_fround(Math_fround((i65 ^ i63 ^ i63 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i68 = Math_fround(Math_fround((i68 ^ i61 ^ i61 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i71 = Math_fround(Math_fround((i71 ^ i59 ^ i59 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
       i23 = i24 & 1;
       i59 = i60 & 1;
       i61 = i62 & 1;
       i63 = i64 & 1;
       i66 = i23 ^ 1;
       i69 = i59 ^ 1;
       i72 = i61 ^ 1;
       i482 = i63 ^ 1;
       i67 = i24 ? 3 : 2;
       i70 = i60 ? 3 : 2;
       i73 = i62 ? 3 : 2;
       i2 = i64 ? 3 : 2;
       i24 = i24 ? 2 : 3;
       i60 = i60 ? 2 : 3;
       i62 = i62 ? 2 : 3;
       i64 = i64 ? 2 : 3;
       HEAP32[i520 >> 2] = i65 ? i24 : i23;
       HEAP32[i440 >> 2] = i68 ? i60 : i59;
       HEAP32[i439 >> 2] = i71 ? i62 : i61;
       HEAP32[i438 >> 2] = i74 ? i64 : i63;
       HEAP32[i462 >> 2] = i65 ? i23 : i24;
       HEAP32[i461 >> 2] = i68 ? i59 : i60;
       HEAP32[i460 >> 2] = i71 ? i61 : i62;
       HEAP32[i459 >> 2] = i74 ? i63 : i64;
       HEAP32[i454 >> 2] = i65 ? i67 : i66;
       HEAP32[i453 >> 2] = i68 ? i70 : i69;
       HEAP32[i452 >> 2] = i71 ? i73 : i72;
       HEAP32[i451 >> 2] = i74 ? i2 : i482;
       HEAP32[i458 >> 2] = i65 ? i66 : i67;
       HEAP32[i457 >> 2] = i68 ? i69 : i70;
       HEAP32[i456 >> 2] = i71 ? i72 : i73;
       HEAP32[i455 >> 2] = i74 ? i482 : i2;
       i2 = HEAP32[i463 >> 2] | 0;
      }
      if (i2 & 268435456 | 0) {
       f5 = Math_fround(f480 * Math_fround(HEAPF32[i516 >> 2]));
       f6 = Math_fround(f480 * Math_fround(HEAPF32[i217 >> 2]));
       f7 = Math_fround(f480 * Math_fround(HEAPF32[i218 >> 2]));
       f8 = Math_fround(f480 * Math_fround(HEAPF32[i219 >> 2]));
       f9 = Math_fround(Math_floor(Math_fround(f5)));
       f10 = Math_fround(Math_floor(Math_fround(f6)));
       f25 = Math_fround(Math_floor(Math_fround(f7)));
       f26 = Math_fround(Math_floor(Math_fround(f8)));
       if (i2 & 16777216 | 0) {
        f553 = Math_fround(Math_floor(Math_fround(f82 * f9)));
        f554 = Math_fround(Math_floor(Math_fround(f82 * f10)));
        f555 = Math_fround(Math_floor(Math_fround(f82 * f25)));
        f556 = Math_fround(Math_floor(Math_fround(f82 * f26)));
        f549 = Math_fround(f481 * Math_fround(f9 - Math_fround(f479 * f553)));
        f550 = Math_fround(f481 * Math_fround(f10 - Math_fround(f479 * f554)));
        f551 = Math_fround(f481 * Math_fround(f25 - Math_fround(f479 * f555)));
        f552 = Math_fround(f481 * Math_fround(f26 - Math_fround(f479 * f556)));
        f553 = Math_fround(f84 - Math_fround(f483 * f553));
        f554 = Math_fround(f84 - Math_fround(f483 * f554));
        f555 = Math_fround(f84 - Math_fround(f483 * f555));
        f556 = Math_fround(f84 - Math_fround(f483 * f556));
        f541 = Math_fround(f483 + f553);
        f542 = Math_fround(f483 + f554);
        f543 = Math_fround(f483 + f555);
        f544 = Math_fround(f483 + f556);
        HEAPF32[i521 >> 2] = f549;
        HEAPF32[i389 >> 2] = f550;
        HEAPF32[i413 >> 2] = f551;
        HEAPF32[i437 >> 2] = f552;
        HEAPF32[i365 >> 2] = f541;
        HEAPF32[i388 >> 2] = f542;
        HEAPF32[i412 >> 2] = f543;
        HEAPF32[i436 >> 2] = f544;
        f545 = Math_fround(f481 + f549);
        f546 = Math_fround(f481 + f550);
        f547 = Math_fround(f481 + f551);
        f548 = Math_fround(f481 + f552);
        HEAPF32[i364 >> 2] = f545;
        HEAPF32[i387 >> 2] = f546;
        HEAPF32[i411 >> 2] = f547;
        HEAPF32[i435 >> 2] = f548;
        HEAPF32[i363 >> 2] = f541;
        HEAPF32[i386 >> 2] = f542;
        HEAPF32[i410 >> 2] = f543;
        HEAPF32[i434 >> 2] = f544;
        HEAPF32[i362 >> 2] = f545;
        HEAPF32[i385 >> 2] = f546;
        HEAPF32[i409 >> 2] = f547;
        HEAPF32[i433 >> 2] = f548;
        HEAPF32[i361 >> 2] = f553;
        HEAPF32[i384 >> 2] = f554;
        HEAPF32[i408 >> 2] = f555;
        HEAPF32[i432 >> 2] = f556;
        HEAPF32[i360 >> 2] = f549;
        HEAPF32[i383 >> 2] = f550;
        HEAPF32[i407 >> 2] = f551;
        HEAPF32[i431 >> 2] = f552;
        HEAPF32[i359 >> 2] = f553;
        HEAPF32[i382 >> 2] = f554;
        HEAPF32[i406 >> 2] = f555;
        HEAPF32[i430 >> 2] = f556;
       }
       if (i2 & 33554432 | 0) {
        f545 = Math_fround(f9 + Math_fround(1.0));
        f546 = Math_fround(f10 + Math_fround(1.0));
        f547 = Math_fround(f25 + Math_fround(1.0));
        f548 = Math_fround(f26 + Math_fround(1.0));
        f553 = Math_fround(f5 - f9);
        f554 = Math_fround(f6 - f10);
        f555 = Math_fround(f7 - f25);
        f556 = Math_fround(f8 - f26);
        f549 = Math_fround(Math_floor(Math_fround(f82 * f545)));
        f550 = Math_fround(Math_floor(Math_fround(f82 * f546)));
        f551 = Math_fround(Math_floor(Math_fround(f82 * f547)));
        f552 = Math_fround(Math_floor(Math_fround(f82 * f548)));
        f545 = Math_fround(f481 * Math_fround(f545 - Math_fround(f479 * f549)));
        f546 = Math_fround(f481 * Math_fround(f546 - Math_fround(f479 * f550)));
        f547 = Math_fround(f481 * Math_fround(f547 - Math_fround(f479 * f551)));
        f548 = Math_fround(f481 * Math_fround(f548 - Math_fround(f479 * f552)));
        f549 = Math_fround(f84 - Math_fround(f483 * f549));
        f550 = Math_fround(f84 - Math_fround(f483 * f550));
        f551 = Math_fround(f84 - Math_fround(f483 * f551));
        f552 = Math_fround(f84 - Math_fround(f483 * f552));
        f537 = Math_fround(f483 + f549);
        f538 = Math_fround(f483 + f550);
        f539 = Math_fround(f483 + f551);
        f540 = Math_fround(f483 + f552);
        HEAPF32[i522 >> 2] = f545;
        HEAPF32[i381 >> 2] = f546;
        HEAPF32[i405 >> 2] = f547;
        HEAPF32[i429 >> 2] = f548;
        HEAPF32[i358 >> 2] = f537;
        HEAPF32[i380 >> 2] = f538;
        HEAPF32[i404 >> 2] = f539;
        HEAPF32[i428 >> 2] = f540;
        HEAPF32[i357 >> 2] = f553;
        HEAPF32[i379 >> 2] = f554;
        HEAPF32[i403 >> 2] = f555;
        HEAPF32[i427 >> 2] = f556;
        HEAPF32[i356 >> 2] = f5;
        HEAPF32[i378 >> 2] = f6;
        HEAPF32[i402 >> 2] = f7;
        HEAPF32[i426 >> 2] = f8;
        f541 = Math_fround(f481 + f545);
        f542 = Math_fround(f481 + f546);
        f543 = Math_fround(f481 + f547);
        f544 = Math_fround(f481 + f548);
        HEAPF32[i355 >> 2] = f541;
        HEAPF32[i377 >> 2] = f542;
        HEAPF32[i401 >> 2] = f543;
        HEAPF32[i425 >> 2] = f544;
        HEAPF32[i354 >> 2] = f537;
        HEAPF32[i376 >> 2] = f538;
        HEAPF32[i400 >> 2] = f539;
        HEAPF32[i424 >> 2] = f540;
        HEAPF32[i353 >> 2] = f553;
        HEAPF32[i375 >> 2] = f554;
        HEAPF32[i399 >> 2] = f555;
        HEAPF32[i423 >> 2] = f556;
        HEAPF32[i352 >> 2] = f5;
        HEAPF32[i374 >> 2] = f6;
        HEAPF32[i398 >> 2] = f7;
        HEAPF32[i422 >> 2] = f8;
        HEAPF32[i351 >> 2] = f541;
        HEAPF32[i373 >> 2] = f542;
        HEAPF32[i397 >> 2] = f543;
        HEAPF32[i421 >> 2] = f544;
        HEAPF32[i350 >> 2] = f549;
        HEAPF32[i372 >> 2] = f550;
        HEAPF32[i396 >> 2] = f551;
        HEAPF32[i420 >> 2] = f552;
        HEAPF32[i349 >> 2] = f553;
        HEAPF32[i371 >> 2] = f554;
        HEAPF32[i395 >> 2] = f555;
        HEAPF32[i419 >> 2] = f556;
        HEAPF32[i348 >> 2] = f5;
        HEAPF32[i370 >> 2] = f6;
        HEAPF32[i394 >> 2] = f7;
        HEAPF32[i418 >> 2] = f8;
        HEAPF32[i347 >> 2] = f545;
        HEAPF32[i369 >> 2] = f546;
        HEAPF32[i393 >> 2] = f547;
        HEAPF32[i417 >> 2] = f548;
        HEAPF32[i346 >> 2] = f549;
        HEAPF32[i368 >> 2] = f550;
        HEAPF32[i392 >> 2] = f551;
        HEAPF32[i416 >> 2] = f552;
        HEAPF32[i345 >> 2] = f553;
        HEAPF32[i367 >> 2] = f554;
        HEAPF32[i391 >> 2] = f555;
        HEAPF32[i415 >> 2] = f556;
        HEAPF32[i336 >> 2] = f5;
        HEAPF32[i366 >> 2] = f6;
        HEAPF32[i390 >> 2] = f7;
        HEAPF32[i414 >> 2] = f8;
       }
      }
     }
     f541 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
     f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
     f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
     f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
     f533 = Math_fround(f484 * Math_fround(f35 * f541));
     f534 = Math_fround(f484 * Math_fround(f36 * f542));
     f535 = Math_fround(f484 * Math_fround(f37 * f543));
     f536 = Math_fround(f484 * Math_fround(f38 * f544));
     f537 = Math_fround(f484 * Math_fround(f39 * f541));
     f538 = Math_fround(f484 * Math_fround(f40 * f542));
     f539 = Math_fround(f484 * Math_fround(f41 * f543));
     f540 = Math_fround(f484 * Math_fround(f42 * f544));
     f541 = Math_fround(f484 * Math_fround(f43 * f541));
     f542 = Math_fround(f484 * Math_fround(f44 * f542));
     f543 = Math_fround(f484 * Math_fround(f45 * f543));
     f544 = Math_fround(f484 * Math_fround(f46 * f544));
     f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
     f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
     f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
     f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
     f545 = Math_fround(f484 * Math_fround(f47 * f553));
     f546 = Math_fround(f484 * Math_fround(f48 * f554));
     f547 = Math_fround(f484 * Math_fround(f49 * f555));
     f548 = Math_fround(f484 * Math_fround(f50 * f556));
     f549 = Math_fround(f484 * Math_fround(f51 * f553));
     f550 = Math_fround(f484 * Math_fround(f52 * f554));
     f551 = Math_fround(f484 * Math_fround(f53 * f555));
     f552 = Math_fround(f484 * Math_fround(f54 * f556));
     f553 = Math_fround(f484 * Math_fround(f55 * f553));
     f554 = Math_fround(f484 * Math_fround(f56 * f554));
     f555 = Math_fround(f484 * Math_fround(f57 * f555));
     f556 = Math_fround(f484 * Math_fround(f58 * f556));
     f532 = Math_fround(f477 + f534);
     f531 = Math_fround(f477 + f535);
     f508 = Math_fround(f477 + f536);
     f507 = Math_fround(f469 + f537);
     f506 = Math_fround(f469 + f538);
     f505 = Math_fround(f469 + f539);
     f504 = Math_fround(f469 + f540);
     f503 = Math_fround(f472 + f541);
     f502 = Math_fround(f472 + f542);
     f501 = Math_fround(f472 + f543);
     f500 = Math_fround(f472 + f544);
     HEAPF32[i524 >> 2] = Math_fround(f477 + f533);
     HEAPF32[i124 >> 2] = f532;
     HEAPF32[i141 >> 2] = f531;
     HEAPF32[i158 >> 2] = f508;
     HEAPF32[i282 >> 2] = f507;
     HEAPF32[i119 >> 2] = f506;
     HEAPF32[i136 >> 2] = f505;
     HEAPF32[i153 >> 2] = f504;
     HEAPF32[i283 >> 2] = f503;
     HEAPF32[i114 >> 2] = f502;
     HEAPF32[i131 >> 2] = f501;
     HEAPF32[i148 >> 2] = f500;
     f500 = Math_fround(f477 + f546);
     f501 = Math_fround(f477 + f547);
     f502 = Math_fround(f477 + f548);
     f503 = Math_fround(f469 + f549);
     f504 = Math_fround(f469 + f550);
     f505 = Math_fround(f469 + f551);
     f506 = Math_fround(f469 + f552);
     f507 = Math_fround(f472 + f553);
     f508 = Math_fround(f472 + f554);
     f531 = Math_fround(f472 + f555);
     f532 = Math_fround(f472 + f556);
     HEAPF32[i284 >> 2] = Math_fround(f477 + f545);
     HEAPF32[i123 >> 2] = f500;
     HEAPF32[i140 >> 2] = f501;
     HEAPF32[i157 >> 2] = f502;
     HEAPF32[i285 >> 2] = f503;
     HEAPF32[i118 >> 2] = f504;
     HEAPF32[i135 >> 2] = f505;
     HEAPF32[i152 >> 2] = f506;
     HEAPF32[i286 >> 2] = f507;
     HEAPF32[i113 >> 2] = f508;
     HEAPF32[i130 >> 2] = f531;
     HEAPF32[i147 >> 2] = f532;
     f534 = Math_fround(f477 - f534);
     f535 = Math_fround(f477 - f535);
     f536 = Math_fround(f477 - f536);
     f537 = Math_fround(f469 - f537);
     f538 = Math_fround(f469 - f538);
     f539 = Math_fround(f469 - f539);
     f540 = Math_fround(f469 - f540);
     f541 = Math_fround(f472 - f541);
     f542 = Math_fround(f472 - f542);
     f543 = Math_fround(f472 - f543);
     f544 = Math_fround(f472 - f544);
     HEAPF32[i287 >> 2] = Math_fround(f477 - f533);
     HEAPF32[i122 >> 2] = f534;
     HEAPF32[i139 >> 2] = f535;
     HEAPF32[i156 >> 2] = f536;
     HEAPF32[i288 >> 2] = f537;
     HEAPF32[i117 >> 2] = f538;
     HEAPF32[i134 >> 2] = f539;
     HEAPF32[i151 >> 2] = f540;
     HEAPF32[i289 >> 2] = f541;
     HEAPF32[i112 >> 2] = f542;
     HEAPF32[i129 >> 2] = f543;
     HEAPF32[i146 >> 2] = f544;
     f546 = Math_fround(f477 - f546);
     f547 = Math_fround(f477 - f547);
     f548 = Math_fround(f477 - f548);
     f549 = Math_fround(f469 - f549);
     f550 = Math_fround(f469 - f550);
     f551 = Math_fround(f469 - f551);
     f552 = Math_fround(f469 - f552);
     f553 = Math_fround(f472 - f553);
     f554 = Math_fround(f472 - f554);
     f555 = Math_fround(f472 - f555);
     f556 = Math_fround(f472 - f556);
     HEAPF32[i290 >> 2] = Math_fround(f477 - f545);
     HEAPF32[i121 >> 2] = f546;
     HEAPF32[i138 >> 2] = f547;
     HEAPF32[i155 >> 2] = f548;
     HEAPF32[i291 >> 2] = f549;
     HEAPF32[i116 >> 2] = f550;
     HEAPF32[i133 >> 2] = f551;
     HEAPF32[i150 >> 2] = f552;
     HEAPF32[i292 >> 2] = f553;
     HEAPF32[i111 >> 2] = f554;
     HEAPF32[i128 >> 2] = f555;
     HEAPF32[i145 >> 2] = f556;
     do if (i162) {
      i4 = HEAP32[i188 >> 2] | 0;
      i11 = HEAP32[i527 >> 2] | 0;
      if (!i4) {
       i2 = 0;
       i3 = i1;
       while (1) {
        i482 = i11 + (i2 + i75 << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i245 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i257 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i269 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i482 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      } else {
       i2 = 0;
       i3 = i1;
       while (1) {
        i482 = i11 + (HEAP32[i4 + (i2 + i75 << 3) >> 2] << 2) | 0;
        HEAP32[i3 >> 2] = HEAP32[i523 + (i2 << 2) >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i524 + (i2 << 2) >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
        HEAP32[i3 + 24 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 36 >> 2] = HEAP32[i245 + (i2 << 2) >> 2];
        HEAP32[i3 + 40 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
        HEAP32[i3 + 44 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
        HEAP32[i3 + 48 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
        HEAP32[i3 + 52 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
        HEAP32[i3 + 56 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
        HEAP32[i3 + 60 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 4 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 64 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 68 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 72 >> 2] = HEAP32[i257 + (i2 << 2) >> 2];
        HEAP32[i3 + 76 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
        HEAP32[i3 + 80 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
        HEAP32[i3 + 84 >> 2] = HEAP32[i287 + (i2 << 2) >> 2];
        HEAP32[i3 + 88 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
        HEAP32[i3 + 92 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
        HEAP32[i3 + 96 >> 2] = HEAP32[i482 >> 2];
        i74 = i521 + (HEAP32[i520 + (i2 + 8 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 100 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
        HEAP32[i3 + 104 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
        HEAP32[i3 + 108 >> 2] = HEAP32[i269 + (i2 << 2) >> 2];
        HEAP32[i3 + 112 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
        HEAP32[i3 + 116 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
        HEAP32[i3 + 120 >> 2] = HEAP32[i290 + (i2 << 2) >> 2];
        HEAP32[i3 + 124 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
        HEAP32[i3 + 128 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
        HEAP32[i3 + 132 >> 2] = HEAP32[i482 >> 2];
        i482 = i521 + (HEAP32[i520 + (i2 + 12 << 2) >> 2] << 5) | 0;
        HEAP32[i3 + 136 >> 2] = HEAP32[i482 + (i2 << 2) >> 2];
        HEAP32[i3 + 140 >> 2] = HEAP32[i482 + 16 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
       }
       i1 = i1 + 576 | 0;
       break;
      }
     } else {
      f544 = Math_fround(HEAPF32[i245 >> 2]);
      f544 = Math_fround(f544 - Math_fround(HEAPF32[i523 >> 2]));
      f546 = Math_fround(HEAPF32[i246 >> 2]);
      f546 = Math_fround(f546 - Math_fround(HEAPF32[i234 >> 2]));
      f547 = Math_fround(HEAPF32[i247 >> 2]);
      f547 = Math_fround(f547 - Math_fround(HEAPF32[i235 >> 2]));
      f548 = Math_fround(HEAPF32[i248 >> 2]);
      f548 = Math_fround(f548 - Math_fround(HEAPF32[i236 >> 2]));
      f549 = Math_fround(HEAPF32[i249 >> 2]);
      f549 = Math_fround(f549 - Math_fround(HEAPF32[i237 >> 2]));
      f556 = Math_fround(HEAPF32[i250 >> 2]);
      f556 = Math_fround(f556 - Math_fround(HEAPF32[i238 >> 2]));
      f555 = Math_fround(HEAPF32[i251 >> 2]);
      f555 = Math_fround(f555 - Math_fround(HEAPF32[i239 >> 2]));
      f554 = Math_fround(HEAPF32[i252 >> 2]);
      f554 = Math_fround(f554 - Math_fround(HEAPF32[i240 >> 2]));
      f553 = Math_fround(HEAPF32[i253 >> 2]);
      f553 = Math_fround(f553 - Math_fround(HEAPF32[i241 >> 2]));
      f541 = Math_fround(HEAPF32[i254 >> 2]);
      f541 = Math_fround(f541 - Math_fround(HEAPF32[i242 >> 2]));
      f542 = Math_fround(HEAPF32[i255 >> 2]);
      f542 = Math_fround(f542 - Math_fround(HEAPF32[i243 >> 2]));
      f543 = Math_fround(HEAPF32[i256 >> 2]);
      f543 = Math_fround(f543 - Math_fround(HEAPF32[i244 >> 2]));
      f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f544 * f544) + Math_fround(f549 * f549)) + Math_fround(f553 * f553)))));
      f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f556 * f556)) + Math_fround(f541 * f541)))));
      f551 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f547 * f547) + Math_fround(f555 * f555)) + Math_fround(f542 * f542)))));
      f550 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f554 * f554)) + Math_fround(f543 * f543)))));
      f546 = Math_fround(f546 * f552);
      f547 = Math_fround(f547 * f551);
      f548 = Math_fround(f548 * f550);
      f549 = Math_fround(f549 * f545);
      f556 = Math_fround(f556 * f552);
      f555 = Math_fround(f555 * f551);
      f554 = Math_fround(f554 * f550);
      f553 = Math_fround(f553 * f545);
      f552 = Math_fround(f541 * f552);
      f551 = Math_fround(f542 * f551);
      f550 = Math_fround(f543 * f550);
      HEAPF32[i518 >> 2] = Math_fround(f544 * f545);
      HEAPF32[i125 >> 2] = f546;
      HEAPF32[i142 >> 2] = f547;
      HEAPF32[i159 >> 2] = f548;
      HEAPF32[i293 >> 2] = f549;
      HEAPF32[i120 >> 2] = f556;
      HEAPF32[i137 >> 2] = f555;
      HEAPF32[i154 >> 2] = f554;
      HEAPF32[i294 >> 2] = f553;
      HEAPF32[i115 >> 2] = f552;
      HEAPF32[i132 >> 2] = f551;
      HEAPF32[i149 >> 2] = f550;
      f550 = Math_fround(f28 * Math_fround(2.0));
      f551 = Math_fround(f29 * Math_fround(2.0));
      f552 = Math_fround(f30 * Math_fround(2.0));
      f553 = Math_fround(f31 * Math_fround(2.0));
      f554 = Math_fround(f32 * Math_fround(2.0));
      f555 = Math_fround(f33 * Math_fround(2.0));
      f556 = Math_fround(f34 * Math_fround(2.0));
      HEAPF32[i519 >> 2] = Math_fround(f27 * Math_fround(2.0));
      HEAPF32[i127 >> 2] = f550;
      HEAPF32[i144 >> 2] = f551;
      HEAPF32[i161 >> 2] = f552;
      HEAPF32[i295 >> 2] = f553;
      HEAPF32[i126 >> 2] = f554;
      HEAPF32[i143 >> 2] = f555;
      HEAPF32[i160 >> 2] = f556;
      HEAP32[i110 >> 2] = 0;
      HEAP32[i110 + 4 >> 2] = 0;
      HEAP32[i110 + 8 >> 2] = 0;
      HEAP32[i110 + 12 >> 2] = 0;
      if (i296) {
       f536 = Math_fround(HEAPF32[i511 >> 2]);
       f554 = Math_fround(f441 * f536);
       f538 = Math_fround(HEAPF32[i181 >> 2]);
       f545 = Math_fround(f441 * f538);
       f540 = Math_fround(HEAPF32[i180 >> 2]);
       f553 = Math_fround(f441 * f540);
       f542 = Math_fround(HEAPF32[i179 >> 2]);
       f548 = Math_fround(f441 * f542);
       f537 = Math_fround(HEAPF32[i198 >> 2]);
       f544 = Math_fround(f444 * f537);
       f539 = Math_fround(HEAPF32[i184 >> 2]);
       f550 = Math_fround(f444 * f539);
       f541 = Math_fround(HEAPF32[i183 >> 2]);
       f549 = Math_fround(f444 * f541);
       f543 = Math_fround(HEAPF32[i182 >> 2]);
       f544 = Math_fround(f554 + f544);
       f550 = Math_fround(f545 + f550);
       f549 = Math_fround(f553 + f549);
       f548 = Math_fround(f548 + Math_fround(f444 * f543));
       f553 = Math_fround(HEAPF32[i199 >> 2]);
       f545 = Math_fround(f447 * f553);
       f554 = Math_fround(HEAPF32[i187 >> 2]);
       f546 = Math_fround(f447 * f554);
       f555 = Math_fround(HEAPF32[i186 >> 2]);
       f547 = Math_fround(f447 * f555);
       f556 = Math_fround(HEAPF32[i185 >> 2]);
       f546 = Math_fround(f550 + f546);
       f547 = Math_fround(f549 + f547);
       f548 = Math_fround(f548 + Math_fround(f447 * f556));
       f549 = Math_fround(Math_fround(Math_fround(f442 * f536) + Math_fround(f445 * f537)) + Math_fround(f448 * f553));
       f550 = Math_fround(Math_fround(Math_fround(f442 * f538) + Math_fround(f445 * f539)) + Math_fround(f448 * f554));
       f551 = Math_fround(Math_fround(Math_fround(f442 * f540) + Math_fround(f445 * f541)) + Math_fround(f448 * f555));
       f552 = Math_fround(Math_fround(Math_fround(f442 * f542) + Math_fround(f445 * f543)) + Math_fround(f448 * f556));
       f553 = Math_fround(Math_fround(Math_fround(f443 * f536) + Math_fround(f446 * f537)) + Math_fround(f449 * f553));
       f554 = Math_fround(Math_fround(Math_fround(f443 * f538) + Math_fround(f446 * f539)) + Math_fround(f449 * f554));
       f555 = Math_fround(Math_fround(Math_fround(f443 * f540) + Math_fround(f446 * f541)) + Math_fround(f449 * f555));
       f556 = Math_fround(Math_fround(Math_fround(f443 * f542) + Math_fround(f446 * f543)) + Math_fround(f449 * f556));
       HEAPF32[i509 >> 2] = Math_fround(f544 + f545);
       HEAPF32[i297 >> 2] = f546;
       HEAPF32[i298 >> 2] = f547;
       HEAPF32[i299 >> 2] = f548;
       HEAPF32[i300 >> 2] = f549;
       HEAPF32[i301 >> 2] = f550;
       HEAPF32[i302 >> 2] = f551;
       HEAPF32[i303 >> 2] = f552;
       HEAPF32[i304 >> 2] = f553;
       HEAPF32[i305 >> 2] = f554;
       HEAPF32[i306 >> 2] = f555;
       HEAPF32[i307 >> 2] = f556;
      }
      if (i308) {
       i69 = HEAP32[i515 >> 2] | 0;
       i72 = i69 + 1068538453 | 0;
       i73 = HEAP32[i213 >> 2] | 0;
       i71 = i73 + 1068538453 | 0;
       i66 = HEAP32[i214 >> 2] | 0;
       i65 = i66 + 1068538453 | 0;
       i64 = HEAP32[i215 >> 2] | 0;
       i68 = i64 + 1068538453 | 0;
       i74 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
       i482 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i72 = i72 << 11 ^ i72;
       i71 = i71 << 11 ^ i71;
       i65 = i65 << 11 ^ i65;
       i68 = i68 << 11 ^ i68;
       f554 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i482 ^ i65 ^ i65 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i525 >> 2] = Math_fround(Math_fround((i74 ^ i72 ^ i72 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i309 >> 2] = f554;
       HEAPF32[i310 >> 2] = f555;
       HEAPF32[i311 >> 2] = f556;
       i69 = i69 + 1068538454 | 0;
       i73 = i73 + 1068538454 | 0;
       i66 = i66 + 1068538454 | 0;
       i64 = i64 + 1068538454 | 0;
       i74 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i72 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i70 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i68 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i73 = i73 << 11 ^ i73;
       i66 = i66 << 11 ^ i66;
       i64 = i64 << 11 ^ i64;
       f556 = Math_fround(Math_fround((i72 ^ i73 ^ i73 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i70 ^ i66 ^ i66 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f554 = Math_fround(Math_fround((i68 ^ i64 ^ i64 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i312 >> 2] = Math_fround(Math_fround((i74 ^ i69 ^ i69 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i313 >> 2] = f556;
       HEAPF32[i314 >> 2] = f555;
       HEAPF32[i315 >> 2] = f554;
       i74 = HEAP32[i515 >> 2] | 0;
       i69 = i74 + 1068538455 | 0;
       i68 = HEAP32[i213 >> 2] | 0;
       i64 = i68 + 1068538455 | 0;
       i70 = HEAP32[i214 >> 2] | 0;
       i66 = i70 + 1068538455 | 0;
       i72 = HEAP32[i215 >> 2] | 0;
       i73 = i72 + 1068538455 | 0;
       i482 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
       i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
       i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
       i69 = i69 << 11 ^ i69;
       i64 = i64 << 11 ^ i64;
       i66 = i66 << 11 ^ i66;
       i73 = i73 << 11 ^ i73;
       f554 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i71 ^ i73 ^ i73 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i316 >> 2] = Math_fround(Math_fround((i482 ^ i69 ^ i69 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i317 >> 2] = f554;
       HEAPF32[i318 >> 2] = f555;
       HEAPF32[i319 >> 2] = f556;
       f556 = Math_fround(Math_fround(HEAPF32[i514 >> 2]) * Math_fround(1.0e5));
       f555 = Math_fround(Math_fround(HEAPF32[i209 >> 2]) * Math_fround(1.0e5));
       f554 = Math_fround(Math_fround(HEAPF32[i210 >> 2]) * Math_fround(1.0e5));
       i74 = i74 + 1068538453 + ~~f556 | 0;
       i68 = i68 + 1068538453 + ~~f555 | 0;
       i70 = i70 + 1068538453 + ~~f554 | 0;
       i72 = i72 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i211 >> 2]) * Math_fround(1.0e5)) | 0;
       i482 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
       i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
       i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
       i73 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
       i74 = i74 << 11 ^ i74;
       i68 = i68 << 11 ^ i68;
       i70 = i70 << 11 ^ i70;
       i72 = i72 << 11 ^ i72;
       f554 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f555 = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
       f556 = Math_fround(Math_fround((i73 ^ i72 ^ i72 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i320 >> 2] = Math_fround(Math_fround((i482 ^ i74 ^ i74 >>> 8) & 8388607 ^ i482 >>> 19 | 0) * Math_fround(1.19209304e-07));
       HEAPF32[i321 >> 2] = f554;
       HEAPF32[i322 >> 2] = f555;
       HEAPF32[i323 >> 2] = f556;
      }
      i67 = HEAP32[i188 >> 2] | 0;
      i68 = (i67 | 0) == 0;
      i69 = HEAP32[i83 >> 2] | 0;
      i70 = HEAP32[i87 >> 2] | 0;
      i71 = HEAP32[i208 >> 2] | 0;
      i72 = HEAP32[i88 >> 2] | 0;
      i73 = HEAP32[i191 >> 2] | 0;
      i74 = HEAP32[i527 >> 2] | 0;
      i66 = 0;
      do {
       i2 = i66 + i75 | 0;
       if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
       i11 = i509 + (i66 << 2) | 0;
       i12 = i331 + (i66 << 2) | 0;
       i13 = i332 + (i66 << 2) | 0;
       i14 = i525 + (i66 << 2) | 0;
       i15 = i312 + (i66 << 2) | 0;
       i16 = i316 + (i66 << 2) | 0;
       i17 = i320 + (i66 << 2) | 0;
       i18 = i518 + (i66 << 2) | 0;
       i19 = i78 + (i66 << 2) | 0;
       i20 = i80 + (i66 << 2) | 0;
       i21 = i69 + (i2 << 4) | 0;
       i22 = i70 + (i2 << 4) | 0;
       i23 = i71 + (i2 << 2) | 0;
       i24 = i72 + (i2 << 2) | 0;
       i59 = i73 + (i2 << 2) | 0;
       i60 = i519 + (i66 << 2) | 0;
       i61 = i89 + (i66 << 2) | 0;
       i62 = i90 + (i66 << 2) | 0;
       i63 = i517 + (i66 << 2) | 0;
       i64 = i91 + (i66 << 2) | 0;
       i65 = i92 + (i66 << 2) | 0;
       i4 = i74 + (i2 << 2) | 0;
       i3 = 0;
       i2 = i1;
       while (1) {
        i1 = i523 + (i3 * 48 | 0) | 0;
        HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 12 | 0;
        if (!i324) {
         i482 = i524 + (i3 * 48 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i2 + 16 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         HEAP32[i2 + 20 >> 2] = HEAP32[i482 + 32 + (i66 << 2) >> 2];
         i1 = i2 + 24 | 0;
        }
        if (!i325) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i1 = i1 + 4 | 0;
        }
        if (!i326) {
         i482 = i521 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         i1 = i1 + 8 | 0;
        }
        if (!i327) {
         i482 = i522 + (HEAP32[i520 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
         HEAP32[i1 >> 2] = HEAP32[i482 + (i66 << 2) >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 16 + (i66 << 2) >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 32 + (i66 << 2) >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 48 + (i66 << 2) >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i328) {
         f556 = Math_fround(i3 | 0);
         HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
         HEAPF32[i1 + 12 >> 2] = f556;
         i1 = i1 + 16 | 0;
        }
        if (!i329) {
         HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i330) {
         i482 = HEAP32[i59 >> 2] | 0;
         HEAP32[i1 >> 2] = i482;
         HEAP32[i1 + 4 >> 2] = i482;
         HEAP32[i1 + 8 >> 2] = i482;
         i1 = i1 + 12 | 0;
        }
        if (i296) {
         HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
         i1 = i1 + 12 | 0;
        }
        if (!i333) {
         f556 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.00999999977));
         i482 = HEAP32[i24 >> 2] | 0;
         HEAPF32[i1 >> 2] = f556;
         HEAP32[i1 + 4 >> 2] = i482;
         i1 = i1 + 8 | 0;
        }
        if (!i334) {
         i482 = (HEAP32[i86 >> 2] & 2147483647 | 0) == 0 ? i510 : i22;
         HEAP32[i1 >> 2] = HEAP32[i482 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i335) {
         i482 = (HEAP32[i81 >> 2] & 2147483647 | 0) == 0 ? i510 : i21;
         HEAP32[i1 >> 2] = HEAP32[i482 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i482 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i482 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i482 + 12 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (i308) {
         HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 >> 2];
         i1 = i1 + 16 | 0;
        }
        if (!i77) {
         HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
         i1 = i1 + 16 | 0;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 4) break; else i2 = i1;
       }
       i66 = i66 + 1 | 0;
      } while ((i66 | 0) != 4);
     } while (0);
     i75 = i75 + 4 | 0;
    } while (i75 >>> 0 < i163 >>> 0);
   }
   STACKTOP = i530;
   return;
  }
 default:
  {
   STACKTOP = i530;
   return;
  }
 }
}

function __ZL28DrawBillboardsWith3DRotationILb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i15, i7, i2, i1, i503, i504) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i503 = i503 | 0;
 i504 = i504 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, f328 = f0, f329 = f0, f330 = f0, f331 = f0, f332 = f0, f333 = f0, f334 = f0, f335 = f0, f336 = f0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, f341 = f0, f342 = f0, f343 = f0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, f439 = f0, f440 = f0, f441 = f0, f442 = f0, f443 = f0, f444 = f0, f445 = f0, f446 = f0, f447 = f0, f448 = f0, f449 = f0, f450 = f0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, f466 = f0, f467 = f0, f468 = f0, f469 = f0, f470 = f0, f471 = f0, f472 = f0, f473 = f0, f474 = f0, f475 = f0, f476 = f0, f477 = f0, f478 = f0, f479 = f0, f480 = f0, f481 = f0, f482 = f0, f483 = f0, f484 = f0, f485 = f0, f486 = f0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, f509 = f0, f510 = f0, f511 = f0, f512 = f0, f513 = f0, f514 = f0, f515 = f0, f516 = f0, f517 = f0, f518 = f0, f519 = f0, f520 = f0, f521 = f0, f522 = f0, f523 = f0, f524 = f0, f525 = f0, f526 = f0, f527 = f0, f528 = f0, f529 = f0, f530 = f0, f531 = f0, f532 = f0, f533 = f0, f534 = f0, f535 = f0, f536 = f0, f537 = f0, f538 = f0, f539 = f0, f540 = f0, f541 = f0, f542 = f0, f543 = f0, f544 = f0, f545 = f0, f546 = f0, f547 = f0, f548 = f0, f549 = f0, f550 = f0, f551 = f0, f552 = f0, f553 = f0, f554 = f0, f555 = f0, f556 = f0, i557 = 0;
 i508 = STACKTOP;
 STACKTOP = STACKTOP + 1488 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i508 + 1416 | 0;
 i8 = i508 + 1380 | 0;
 i505 = i508 + 1344 | 0;
 i506 = i508 + 1296 | 0;
 i507 = i508 + 1248 | 0;
 i487 = i508 + 1200 | 0;
 i488 = i508 + 1184 | 0;
 i489 = i508 + 1168 | 0;
 i490 = i508 + 1152 | 0;
 i491 = i508 + 1136 | 0;
 i492 = i508 + 1088 | 0;
 i493 = i508 + 1040 | 0;
 i494 = i508 + 992 | 0;
 i495 = i508 + 944 | 0;
 i344 = i508 + 896 | 0;
 i496 = i508 + 832 | 0;
 i497 = i508 + 704 | 0;
 i498 = i508 + 448 | 0;
 i499 = i508 + 256 | 0;
 i500 = i508 + 64 | 0;
 i501 = i508;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i3 | 0) == 3) {
  i14 = i6;
  i13 = i14 + 36 | 0;
  do {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   i14 = i14 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i15, i7, i2, i6, i503, i504);
  STACKTOP = i508;
  return;
 }
 i502 = i7 + 332 | 0;
 i5 = HEAP32[i502 >> 2] | 0;
 i4 = (i5 & 1073741824 | 0) == 0;
 i12 = HEAP32[i1 + 32 >> 2] | 0;
 f476 = Math_fround((i5 & 4095) >>> 0);
 f477 = Math_fround(Math_fround(1.0) / f476);
 f478 = Math_fround(HEAPF32[i7 + 368 >> 2]);
 f479 = Math_fround(HEAPF32[i7 + 372 >> 2]);
 f480 = Math_fround(HEAPF32[i7 + 376 >> 2]);
 f481 = Math_fround(Math_fround(1.0) - f480);
 i5 = i7 + 420 | 0;
 f482 = Math_fround(HEAPF32[i7 + 404 >> 2]);
 i451 = i7 + 408 | 0;
 f474 = Math_fround(HEAPF32[i451 >> 2]);
 f468 = Math_fround(HEAPF32[i451 + 4 >> 2]);
 f470 = Math_fround(HEAPF32[i451 + 8 >> 2]);
 i451 = i7 + 336 | 0;
 f483 = Math_fround(HEAPF32[i451 >> 2]);
 f484 = Math_fround(HEAPF32[i451 + 4 >> 2]);
 f485 = Math_fround(HEAPF32[i451 + 8 >> 2]);
 f486 = Math_fround(HEAPF32[i451 + 12 >> 2]);
 i451 = i7 + 352 | 0;
 f473 = Math_fround(HEAPF32[i451 >> 2]);
 f467 = Math_fround(HEAPF32[i451 + 4 >> 2]);
 i451 = i7 + 360 | 0;
 f472 = Math_fround(HEAPF32[i451 >> 2]);
 f466 = Math_fround(HEAPF32[i451 + 4 >> 2]);
 i451 = i2 + 36 | 0;
 f475 = Math_fround(HEAPF32[i451 >> 2]);
 f469 = Math_fround(HEAPF32[i451 + 4 >> 2]);
 f471 = Math_fround(HEAPF32[i451 + 8 >> 2]);
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 f439 = Math_fround(HEAPF32[i7 + 128 >> 2]);
 f440 = Math_fround(HEAPF32[i7 + 132 >> 2]);
 f441 = Math_fround(HEAPF32[i7 + 136 >> 2]);
 f442 = Math_fround(HEAPF32[i7 + 144 >> 2]);
 f443 = Math_fround(HEAPF32[i7 + 148 >> 2]);
 f444 = Math_fround(HEAPF32[i7 + 152 >> 2]);
 f445 = Math_fround(HEAPF32[i7 + 160 >> 2]);
 f446 = Math_fround(HEAPF32[i7 + 164 >> 2]);
 f447 = Math_fround(HEAPF32[i7 + 168 >> 2]);
 f448 = Math_fround(HEAPF32[i7 + 176 >> 2]);
 f449 = Math_fround(HEAPF32[i7 + 180 >> 2]);
 f450 = Math_fround(HEAPF32[i7 + 184 >> 2]);
 i451 = i496 + 12 | 0;
 i452 = i496 + 8 | 0;
 i453 = i496 + 4 | 0;
 i454 = i496 + 28 | 0;
 HEAP32[i496 >> 2] = 0;
 HEAP32[i496 + 4 >> 2] = 0;
 HEAP32[i496 + 8 >> 2] = 0;
 HEAP32[i496 + 12 >> 2] = 0;
 HEAP32[i454 >> 2] = 1;
 i455 = i496 + 24 | 0;
 HEAP32[i455 >> 2] = 1;
 i456 = i496 + 20 | 0;
 HEAP32[i456 >> 2] = 1;
 i457 = i496 + 16 | 0;
 HEAP32[i457 >> 2] = 1;
 i458 = i496 + 44 | 0;
 HEAP32[i458 >> 2] = 2;
 i459 = i496 + 40 | 0;
 HEAP32[i459 >> 2] = 2;
 i460 = i496 + 36 | 0;
 HEAP32[i460 >> 2] = 2;
 i461 = i496 + 32 | 0;
 HEAP32[i461 >> 2] = 2;
 i462 = i496 + 60 | 0;
 HEAP32[i462 >> 2] = 3;
 i463 = i496 + 56 | 0;
 HEAP32[i463 >> 2] = 3;
 i464 = i496 + 52 | 0;
 HEAP32[i464 >> 2] = 3;
 i465 = i496 + 48 | 0;
 HEAP32[i465 >> 2] = 3;
 i390 = i497 + 4 | 0;
 i414 = i497 + 8 | 0;
 i438 = i497 + 12 | 0;
 i366 = i497 + 16 | 0;
 HEAP32[i497 >> 2] = 0;
 HEAP32[i497 + 4 >> 2] = 0;
 HEAP32[i497 + 8 >> 2] = 0;
 HEAP32[i497 + 12 >> 2] = 0;
 HEAPF32[i366 >> 2] = Math_fround(1.0);
 i389 = i497 + 20 | 0;
 HEAPF32[i389 >> 2] = Math_fround(1.0);
 i413 = i497 + 24 | 0;
 HEAPF32[i413 >> 2] = Math_fround(1.0);
 i437 = i497 + 28 | 0;
 HEAPF32[i437 >> 2] = Math_fround(1.0);
 i365 = i497 + 32 | 0;
 HEAPF32[i365 >> 2] = Math_fround(1.0);
 i388 = i497 + 36 | 0;
 HEAPF32[i388 >> 2] = Math_fround(1.0);
 i412 = i497 + 40 | 0;
 HEAPF32[i412 >> 2] = Math_fround(1.0);
 i436 = i497 + 44 | 0;
 HEAPF32[i436 >> 2] = Math_fround(1.0);
 i364 = i497 + 48 | 0;
 HEAPF32[i364 >> 2] = Math_fround(1.0);
 i387 = i497 + 52 | 0;
 HEAPF32[i387 >> 2] = Math_fround(1.0);
 i411 = i497 + 56 | 0;
 HEAPF32[i411 >> 2] = Math_fround(1.0);
 i435 = i497 + 60 | 0;
 HEAPF32[i435 >> 2] = Math_fround(1.0);
 i363 = i497 + 64 | 0;
 HEAPF32[i363 >> 2] = Math_fround(1.0);
 i386 = i497 + 68 | 0;
 HEAPF32[i386 >> 2] = Math_fround(1.0);
 i410 = i497 + 72 | 0;
 HEAPF32[i410 >> 2] = Math_fround(1.0);
 i434 = i497 + 76 | 0;
 HEAPF32[i434 >> 2] = Math_fround(1.0);
 i362 = i497 + 80 | 0;
 i385 = i497 + 84 | 0;
 i409 = i497 + 88 | 0;
 i433 = i497 + 92 | 0;
 i361 = i497 + 96 | 0;
 i384 = i497 + 100 | 0;
 i408 = i497 + 104 | 0;
 i432 = i497 + 108 | 0;
 i360 = i497 + 112 | 0;
 i383 = i497 + 116 | 0;
 i407 = i497 + 120 | 0;
 i431 = i497 + 124 | 0;
 i14 = i362;
 i13 = i14 + 48 | 0;
 do {
  HEAP32[i14 >> 2] = 0;
  i14 = i14 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 i382 = i498 + 4 | 0;
 i406 = i498 + 8 | 0;
 i430 = i498 + 12 | 0;
 i359 = i498 + 16 | 0;
 HEAP32[i498 >> 2] = 0;
 HEAP32[i498 + 4 >> 2] = 0;
 HEAP32[i498 + 8 >> 2] = 0;
 HEAP32[i498 + 12 >> 2] = 0;
 HEAPF32[i359 >> 2] = Math_fround(1.0);
 i381 = i498 + 20 | 0;
 HEAPF32[i381 >> 2] = Math_fround(1.0);
 i405 = i498 + 24 | 0;
 HEAPF32[i405 >> 2] = Math_fround(1.0);
 i429 = i498 + 28 | 0;
 HEAPF32[i429 >> 2] = Math_fround(1.0);
 i358 = i498 + 32 | 0;
 i380 = i498 + 36 | 0;
 i404 = i498 + 40 | 0;
 i428 = i498 + 44 | 0;
 i357 = i498 + 48 | 0;
 i379 = i498 + 52 | 0;
 i403 = i498 + 56 | 0;
 i427 = i498 + 60 | 0;
 i356 = i498 + 64 | 0;
 HEAP32[i358 >> 2] = 0;
 HEAP32[i358 + 4 >> 2] = 0;
 HEAP32[i358 + 8 >> 2] = 0;
 HEAP32[i358 + 12 >> 2] = 0;
 HEAP32[i358 + 16 >> 2] = 0;
 HEAP32[i358 + 20 >> 2] = 0;
 HEAP32[i358 + 24 >> 2] = 0;
 HEAP32[i358 + 28 >> 2] = 0;
 HEAPF32[i356 >> 2] = Math_fround(1.0);
 i378 = i498 + 68 | 0;
 HEAPF32[i378 >> 2] = Math_fround(1.0);
 i402 = i498 + 72 | 0;
 HEAPF32[i402 >> 2] = Math_fround(1.0);
 i426 = i498 + 76 | 0;
 HEAPF32[i426 >> 2] = Math_fround(1.0);
 i355 = i498 + 80 | 0;
 HEAPF32[i355 >> 2] = Math_fround(1.0);
 i377 = i498 + 84 | 0;
 HEAPF32[i377 >> 2] = Math_fround(1.0);
 i401 = i498 + 88 | 0;
 HEAPF32[i401 >> 2] = Math_fround(1.0);
 i425 = i498 + 92 | 0;
 HEAPF32[i425 >> 2] = Math_fround(1.0);
 i354 = i498 + 96 | 0;
 i376 = i498 + 100 | 0;
 i400 = i498 + 104 | 0;
 i424 = i498 + 108 | 0;
 i353 = i498 + 112 | 0;
 i375 = i498 + 116 | 0;
 i399 = i498 + 120 | 0;
 i423 = i498 + 124 | 0;
 i352 = i498 + 128 | 0;
 HEAP32[i354 >> 2] = 0;
 HEAP32[i354 + 4 >> 2] = 0;
 HEAP32[i354 + 8 >> 2] = 0;
 HEAP32[i354 + 12 >> 2] = 0;
 HEAP32[i354 + 16 >> 2] = 0;
 HEAP32[i354 + 20 >> 2] = 0;
 HEAP32[i354 + 24 >> 2] = 0;
 HEAP32[i354 + 28 >> 2] = 0;
 HEAPF32[i352 >> 2] = Math_fround(1.0);
 i374 = i498 + 132 | 0;
 HEAPF32[i374 >> 2] = Math_fround(1.0);
 i398 = i498 + 136 | 0;
 HEAPF32[i398 >> 2] = Math_fround(1.0);
 i422 = i498 + 140 | 0;
 HEAPF32[i422 >> 2] = Math_fround(1.0);
 i351 = i498 + 144 | 0;
 i373 = i498 + 148 | 0;
 i397 = i498 + 152 | 0;
 i421 = i498 + 156 | 0;
 i350 = i498 + 160 | 0;
 i372 = i498 + 164 | 0;
 i396 = i498 + 168 | 0;
 i420 = i498 + 172 | 0;
 i349 = i498 + 176 | 0;
 i371 = i498 + 180 | 0;
 i395 = i498 + 184 | 0;
 i419 = i498 + 188 | 0;
 i348 = i498 + 192 | 0;
 i370 = i498 + 196 | 0;
 i394 = i498 + 200 | 0;
 i418 = i498 + 204 | 0;
 i347 = i498 + 208 | 0;
 i369 = i498 + 212 | 0;
 i393 = i498 + 216 | 0;
 i417 = i498 + 220 | 0;
 i346 = i498 + 224 | 0;
 i368 = i498 + 228 | 0;
 i392 = i498 + 232 | 0;
 i416 = i498 + 236 | 0;
 i345 = i498 + 240 | 0;
 i367 = i498 + 244 | 0;
 i391 = i498 + 248 | 0;
 i415 = i498 + 252 | 0;
 if (i4) {
  i14 = i351;
  i13 = i14 + 112 | 0;
  do {
   HEAP32[i14 >> 2] = 0;
   i14 = i14 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  switch (i3 | 0) {
  case 1:
   {
    i14 = i6;
    i1 = gb + 1162292 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  case 2:
   {
    i14 = i6;
    i1 = i7 + 256 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  default:
   {
    i14 = i6;
    i1 = i7 + 64 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
   }
  }
  __ZN10Matrix3x3fC2ERK10Matrix4x4f(i8, i6);
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  f57 = Math_fround(HEAPF32[i7 + 428 >> 2]);
  f333 = Math_fround(HEAPF32[i7 + 424 >> 2]);
  f75 = Math_fround(HEAPF32[i8 >> 2]);
  i326 = i8 + 4 | 0;
  f55 = Math_fround(HEAPF32[i326 >> 2]);
  i327 = i8 + 8 | 0;
  f342 = Math_fround(HEAPF32[i327 >> 2]);
  i337 = i8 + 12 | 0;
  f329 = Math_fround(HEAPF32[i337 >> 2]);
  i338 = i8 + 16 | 0;
  f56 = Math_fround(HEAPF32[i338 >> 2]);
  i339 = i8 + 20 | 0;
  f343 = Math_fround(HEAPF32[i339 >> 2]);
  i340 = i8 + 24 | 0;
  f331 = Math_fround(HEAPF32[i340 >> 2]);
  i160 = i8 + 28 | 0;
  f58 = Math_fround(HEAPF32[i160 >> 2]);
  i159 = i8 + 32 | 0;
  f11 = Math_fround(HEAPF32[i159 >> 2]);
  f328 = Math_fround(f55 * Math_fround(0.0));
  f336 = Math_fround(f342 * Math_fround(0.0));
  f334 = Math_fround(Math_fround(Math_fround(f9 * f75) + f328) + f336);
  f330 = Math_fround(f56 * Math_fround(0.0));
  f341 = Math_fround(f343 * Math_fround(0.0));
  f335 = Math_fround(Math_fround(Math_fround(f9 * f329) + f330) + f341);
  f332 = Math_fround(f58 * Math_fround(0.0));
  f10 = Math_fround(f11 * Math_fround(0.0));
  f9 = Math_fround(Math_fround(Math_fround(f9 * f331) + f332) + f10);
  f75 = Math_fround(f75 * Math_fround(0.0));
  f336 = Math_fround(Math_fround(f75 + Math_fround(f57 * f55)) + f336);
  f329 = Math_fround(f329 * Math_fround(0.0));
  f341 = Math_fround(Math_fround(f329 + Math_fround(f57 * f56)) + f341);
  f331 = Math_fround(f331 * Math_fround(0.0));
  f10 = Math_fround(Math_fround(f331 + Math_fround(f57 * f58)) + f10);
  f342 = Math_fround(Math_fround(f75 + f328) + Math_fround(f333 * f342));
  f343 = Math_fround(Math_fround(f329 + f330) + Math_fround(f333 * f343));
  f11 = Math_fround(Math_fround(f331 + f332) + Math_fround(f333 * f11));
  HEAPF32[i8 >> 2] = f334;
  HEAPF32[i326 >> 2] = f336;
  HEAPF32[i327 >> 2] = f342;
  HEAPF32[i337 >> 2] = f335;
  HEAPF32[i338 >> 2] = f341;
  HEAPF32[i339 >> 2] = f343;
  HEAPF32[i340 >> 2] = f9;
  HEAPF32[i160 >> 2] = f10;
  HEAPF32[i159 >> 2] = f11;
  i159 = (i2 | 0) == 27;
  HEAP32[i505 >> 2] = 0;
  HEAP32[i505 + 4 >> 2] = 0;
  HEAP32[i505 + 8 >> 2] = 0;
  HEAP32[i505 + 12 >> 2] = 0;
  i160 = HEAP32[i503 + 12 >> 2] | 0;
  if (i160 | 0) {
   i161 = i506 + 12 | 0;
   i162 = i506 + 8 | 0;
   i163 = i506 + 4 | 0;
   i164 = i506 + 16 | 0;
   i165 = i506 + 28 | 0;
   i166 = i506 + 24 | 0;
   i167 = i506 + 20 | 0;
   i168 = i506 + 32 | 0;
   i169 = i506 + 44 | 0;
   i170 = i506 + 40 | 0;
   i171 = i506 + 36 | 0;
   i172 = i507 + 32 | 0;
   i173 = i507 + 44 | 0;
   i174 = i507 + 40 | 0;
   i175 = i507 + 36 | 0;
   i176 = i487 + 12 | 0;
   i177 = i487 + 8 | 0;
   i178 = i487 + 4 | 0;
   i179 = i487 + 28 | 0;
   i180 = i487 + 24 | 0;
   i181 = i487 + 20 | 0;
   i182 = i487 + 44 | 0;
   i183 = i487 + 40 | 0;
   i184 = i487 + 36 | 0;
   i185 = i504 + 20 | 0;
   i186 = i503 + 20 | 0;
   i187 = i503 + 40 | 0;
   i188 = i503 + 340 | 0;
   i189 = i503 + 60 | 0;
   i190 = i503 + 80 | 0;
   i191 = i503 + 100 | 0;
   i192 = i503 + 120 | 0;
   i193 = i503 + 140 | 0;
   i194 = i503 + 160 | 0;
   i195 = i487 + 16 | 0;
   i196 = i487 + 32 | 0;
   i197 = i504 + 4 | 0;
   i198 = i488 + 4 | 0;
   i199 = i488 + 8 | 0;
   i200 = i488 + 12 | 0;
   i201 = i504 + 8 | 0;
   i202 = i489 + 4 | 0;
   i203 = i489 + 8 | 0;
   i204 = i489 + 12 | 0;
   i205 = i503 + 520 | 0;
   i206 = i490 + 4 | 0;
   i207 = i490 + 8 | 0;
   i208 = i490 + 12 | 0;
   i209 = i503 + 500 | 0;
   i210 = i491 + 4 | 0;
   i211 = i491 + 8 | 0;
   i212 = i491 + 12 | 0;
   i213 = i504 + 16 | 0;
   i214 = i492 + 4 | 0;
   i215 = i492 + 8 | 0;
   i216 = i492 + 12 | 0;
   i217 = i506 + 16 | 0;
   i218 = i506 + 32 | 0;
   i219 = i493 + 4 | 0;
   i220 = i493 + 8 | 0;
   i221 = i493 + 12 | 0;
   i222 = i493 + 16 | 0;
   i223 = i493 + 20 | 0;
   i224 = i493 + 24 | 0;
   i225 = i493 + 28 | 0;
   i226 = i493 + 32 | 0;
   i227 = i493 + 36 | 0;
   i228 = i493 + 40 | 0;
   i229 = i493 + 44 | 0;
   i230 = i499 + 4 | 0;
   i231 = i499 + 8 | 0;
   i232 = i499 + 12 | 0;
   i233 = i499 + 16 | 0;
   i234 = i499 + 20 | 0;
   i235 = i499 + 24 | 0;
   i236 = i499 + 28 | 0;
   i237 = i499 + 32 | 0;
   i238 = i499 + 36 | 0;
   i239 = i499 + 40 | 0;
   i240 = i499 + 44 | 0;
   i241 = i499 + 48 | 0;
   i242 = i499 + 52 | 0;
   i243 = i499 + 56 | 0;
   i244 = i499 + 60 | 0;
   i245 = i499 + 64 | 0;
   i246 = i499 + 68 | 0;
   i247 = i499 + 72 | 0;
   i248 = i499 + 76 | 0;
   i249 = i499 + 80 | 0;
   i250 = i499 + 84 | 0;
   i251 = i499 + 88 | 0;
   i252 = i499 + 92 | 0;
   i253 = i499 + 96 | 0;
   i254 = i499 + 100 | 0;
   i255 = i499 + 104 | 0;
   i256 = i499 + 108 | 0;
   i257 = i499 + 112 | 0;
   i258 = i499 + 116 | 0;
   i259 = i499 + 120 | 0;
   i260 = i499 + 124 | 0;
   i261 = i499 + 128 | 0;
   i262 = i499 + 132 | 0;
   i263 = i499 + 136 | 0;
   i264 = i499 + 140 | 0;
   i265 = i499 + 144 | 0;
   i266 = i499 + 148 | 0;
   i267 = i499 + 152 | 0;
   i268 = i499 + 156 | 0;
   i269 = i499 + 160 | 0;
   i270 = i499 + 164 | 0;
   i271 = i499 + 168 | 0;
   i272 = i499 + 172 | 0;
   i273 = i499 + 176 | 0;
   i274 = i499 + 180 | 0;
   i275 = i499 + 184 | 0;
   i276 = i499 + 188 | 0;
   i277 = (i2 & 48 | 0) == 0;
   i121 = i500 + 4 | 0;
   i138 = i500 + 8 | 0;
   i155 = i500 + 12 | 0;
   i278 = i500 + 16 | 0;
   i116 = i500 + 20 | 0;
   i133 = i500 + 24 | 0;
   i150 = i500 + 28 | 0;
   i279 = i500 + 32 | 0;
   i111 = i500 + 36 | 0;
   i128 = i500 + 40 | 0;
   i145 = i500 + 44 | 0;
   i280 = i500 + 48 | 0;
   i120 = i500 + 52 | 0;
   i137 = i500 + 56 | 0;
   i154 = i500 + 60 | 0;
   i281 = i500 + 64 | 0;
   i115 = i500 + 68 | 0;
   i132 = i500 + 72 | 0;
   i149 = i500 + 76 | 0;
   i282 = i500 + 80 | 0;
   i110 = i500 + 84 | 0;
   i127 = i500 + 88 | 0;
   i144 = i500 + 92 | 0;
   i283 = i500 + 96 | 0;
   i119 = i500 + 100 | 0;
   i136 = i500 + 104 | 0;
   i153 = i500 + 108 | 0;
   i284 = i500 + 112 | 0;
   i114 = i500 + 116 | 0;
   i131 = i500 + 120 | 0;
   i148 = i500 + 124 | 0;
   i285 = i500 + 128 | 0;
   i109 = i500 + 132 | 0;
   i126 = i500 + 136 | 0;
   i143 = i500 + 140 | 0;
   i286 = i500 + 144 | 0;
   i118 = i500 + 148 | 0;
   i135 = i500 + 152 | 0;
   i152 = i500 + 156 | 0;
   i287 = i500 + 160 | 0;
   i113 = i500 + 164 | 0;
   i130 = i500 + 168 | 0;
   i147 = i500 + 172 | 0;
   i288 = i500 + 176 | 0;
   i108 = i500 + 180 | 0;
   i125 = i500 + 184 | 0;
   i142 = i500 + 188 | 0;
   i122 = i494 + 4 | 0;
   i139 = i494 + 8 | 0;
   i156 = i494 + 12 | 0;
   i289 = i494 + 16 | 0;
   i117 = i494 + 20 | 0;
   i134 = i494 + 24 | 0;
   i151 = i494 + 28 | 0;
   i290 = i494 + 32 | 0;
   i112 = i494 + 36 | 0;
   i129 = i494 + 40 | 0;
   i146 = i494 + 44 | 0;
   i124 = i495 + 4 | 0;
   i141 = i495 + 8 | 0;
   i158 = i495 + 12 | 0;
   i291 = i495 + 16 | 0;
   i123 = i495 + 20 | 0;
   i140 = i495 + 24 | 0;
   i157 = i495 + 28 | 0;
   i107 = i495 + 32 | 0;
   i292 = (i2 & 512 | 0) != 0;
   i293 = i344 + 4 | 0;
   i294 = i344 + 8 | 0;
   i295 = i344 + 12 | 0;
   i296 = i344 + 16 | 0;
   i297 = i344 + 20 | 0;
   i298 = i344 + 24 | 0;
   i299 = i344 + 28 | 0;
   i300 = i344 + 32 | 0;
   i301 = i344 + 36 | 0;
   i302 = i344 + 40 | 0;
   i303 = i344 + 44 | 0;
   i304 = (i2 & 8192 | 0) != 0;
   i305 = i501 + 4 | 0;
   i306 = i501 + 8 | 0;
   i307 = i501 + 12 | 0;
   i308 = i501 + 16 | 0;
   i309 = i501 + 20 | 0;
   i310 = i501 + 24 | 0;
   i311 = i501 + 28 | 0;
   i312 = i501 + 32 | 0;
   i313 = i501 + 36 | 0;
   i314 = i501 + 40 | 0;
   i315 = i501 + 44 | 0;
   i316 = i501 + 48 | 0;
   i317 = i501 + 52 | 0;
   i318 = i501 + 56 | 0;
   i319 = i501 + 60 | 0;
   i320 = (i2 & 2 | 0) == 0;
   i321 = (i2 & 8 | 0) == 0;
   i322 = (i2 & 16 | 0) == 0;
   i323 = (i2 & 32 | 0) == 0;
   i324 = (i2 & 64 | 0) == 0;
   i325 = (i2 & 128 | 0) == 0;
   i326 = (i2 & 256 | 0) == 0;
   i327 = i344 + 16 | 0;
   i337 = i344 + 32 | 0;
   i338 = (i2 & 1024 | 0) == 0;
   i339 = (i2 & 2048 | 0) == 0;
   i340 = (i2 & 4096 | 0) == 0;
   i79 = (i2 & 4 | 0) == 0;
   i80 = i494 + 16 | 0;
   i81 = i494 + 32 | 0;
   i82 = i503 + 864 | 0;
   i83 = i503 + 848 | 0;
   i84 = i503 + 844 | 0;
   i85 = i503 + 828 | 0;
   i86 = i503 + 540 | 0;
   i87 = i495 + 16 | 0;
   i88 = i495 + 32 | 0;
   i89 = i493 + 16 | 0;
   i90 = i493 + 32 | 0;
   i91 = i499 + 16 | 0;
   i92 = i499 + 32 | 0;
   i93 = i500 + 16 | 0;
   i94 = i500 + 32 | 0;
   i95 = i241 + 16 | 0;
   i96 = i241 + 32 | 0;
   i97 = i280 + 16 | 0;
   i98 = i280 + 32 | 0;
   i99 = i253 + 16 | 0;
   i100 = i253 + 32 | 0;
   i101 = i283 + 16 | 0;
   i102 = i283 + 32 | 0;
   i103 = i265 + 16 | 0;
   i104 = i265 + 32 | 0;
   i105 = i286 + 16 | 0;
   i106 = i286 + 32 | 0;
   f333 = Math_fround(f9 * Math_fround(0.0));
   f331 = Math_fround(Math_fround(Math_fround(f334 * Math_fround(0.0)) + Math_fround(f335 * Math_fround(0.0))) + f9);
   f332 = Math_fround(f10 * Math_fround(0.0));
   f329 = Math_fround(Math_fround(Math_fround(f336 * Math_fround(0.0)) + Math_fround(f341 * Math_fround(0.0))) + f10);
   f330 = Math_fround(f11 * Math_fround(0.0));
   f328 = Math_fround(Math_fround(Math_fround(f342 * Math_fround(0.0)) + Math_fround(f343 * Math_fround(0.0))) + f11);
   i78 = i12 + 564 | 0;
   i77 = i12 + 568 | 0;
   i76 = 0;
   i1 = i15;
   do {
    i14 = i506;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i507;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i487;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    HEAP32[i488 >> 2] = 0;
    HEAP32[i488 + 4 >> 2] = 0;
    HEAP32[i488 + 8 >> 2] = 0;
    HEAP32[i488 + 12 >> 2] = 0;
    HEAP32[i489 >> 2] = 0;
    HEAP32[i489 + 4 >> 2] = 0;
    HEAP32[i489 + 8 >> 2] = 0;
    HEAP32[i489 + 12 >> 2] = 0;
    HEAP32[i490 >> 2] = 0;
    HEAP32[i490 + 4 >> 2] = 0;
    HEAP32[i490 + 8 >> 2] = 0;
    HEAP32[i490 + 12 >> 2] = 0;
    HEAP32[i491 >> 2] = 0;
    HEAP32[i491 + 4 >> 2] = 0;
    HEAP32[i491 + 8 >> 2] = 0;
    HEAP32[i491 + 12 >> 2] = 0;
    HEAP32[i492 >> 2] = 0;
    HEAP32[i492 + 4 >> 2] = 0;
    HEAP32[i492 + 8 >> 2] = 0;
    HEAP32[i492 + 12 >> 2] = 0;
    i19 = HEAP32[i185 >> 2] | 0;
    i20 = HEAP32[i503 >> 2] | 0;
    if (!i19) {
     i63 = i20 + (i76 << 2) | 0;
     i64 = HEAP32[i63 + 4 >> 2] | 0;
     i65 = HEAP32[i63 + 8 >> 2] | 0;
     i66 = HEAP32[i63 + 12 >> 2] | 0;
     i70 = (HEAP32[i186 >> 2] | 0) + (i76 << 2) | 0;
     i67 = HEAP32[i70 >> 2] | 0;
     i68 = HEAP32[i70 + 4 >> 2] | 0;
     i69 = HEAP32[i70 + 8 >> 2] | 0;
     i70 = HEAP32[i70 + 12 >> 2] | 0;
     i71 = (HEAP32[i187 >> 2] | 0) + (i76 << 2) | 0;
     i74 = HEAP32[i71 >> 2] | 0;
     i73 = HEAP32[i71 + 4 >> 2] | 0;
     i72 = HEAP32[i71 + 8 >> 2] | 0;
     i71 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i506 >> 2] = HEAP32[i63 >> 2];
     HEAP32[i163 >> 2] = i64;
     HEAP32[i162 >> 2] = i65;
     HEAP32[i161 >> 2] = i66;
     HEAP32[i164 >> 2] = i67;
     HEAP32[i167 >> 2] = i68;
     HEAP32[i166 >> 2] = i69;
     HEAP32[i165 >> 2] = i70;
     HEAP32[i168 >> 2] = i74;
     HEAP32[i171 >> 2] = i73;
     HEAP32[i170 >> 2] = i72;
     HEAP32[i169 >> 2] = i71;
     i71 = (HEAP32[i188 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i172 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i175 >> 2] = i72;
     HEAP32[i174 >> 2] = i73;
     HEAP32[i173 >> 2] = i74;
     i74 = (HEAP32[i189 >> 2] | 0) + (i76 << 2) | 0;
     f47 = Math_fround(HEAPF32[i74 >> 2]);
     f37 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f38 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f39 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i190 >> 2] | 0) + (i76 << 2) | 0;
     f40 = Math_fround(HEAPF32[i74 >> 2]);
     f41 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f42 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f43 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i191 >> 2] | 0) + (i76 << 2) | 0;
     f44 = Math_fround(HEAPF32[i74 >> 2]);
     f45 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f46 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f75 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i192 >> 2] | 0) + (i76 << 2) | 0;
     f48 = Math_fround(HEAPF32[i74 >> 2]);
     f49 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f50 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f51 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i193 >> 2] | 0) + (i76 << 2) | 0;
     f52 = Math_fround(HEAPF32[i74 >> 2]);
     f53 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f54 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f55 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i194 >> 2] | 0) + (i76 << 2) | 0;
     f56 = Math_fround(HEAPF32[i74 >> 2]);
     f57 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f58 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f49 = Math_fround(f37 + f49);
     f50 = Math_fround(f38 + f50);
     f51 = Math_fround(f39 + f51);
     f52 = Math_fround(f40 + f52);
     f53 = Math_fround(f41 + f53);
     f54 = Math_fround(f42 + f54);
     f55 = Math_fround(f43 + f55);
     f56 = Math_fround(f44 + f56);
     f57 = Math_fround(f45 + f57);
     f58 = Math_fround(f46 + f58);
     f75 = Math_fround(f75 + Math_fround(HEAPF32[i74 + 12 >> 2]));
     HEAPF32[i487 >> 2] = Math_fround(f47 + f48);
     HEAPF32[i178 >> 2] = f49;
     HEAPF32[i177 >> 2] = f50;
     HEAPF32[i176 >> 2] = f51;
     HEAPF32[i195 >> 2] = f52;
     HEAPF32[i181 >> 2] = f53;
     HEAPF32[i180 >> 2] = f54;
     HEAPF32[i179 >> 2] = f55;
     HEAPF32[i196 >> 2] = f56;
     HEAPF32[i184 >> 2] = f57;
     HEAPF32[i183 >> 2] = f58;
     HEAPF32[i182 >> 2] = f75;
     i74 = (HEAP32[i197 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i74 + 4 >> 2] | 0;
     i72 = HEAP32[i74 + 8 >> 2] | 0;
     i71 = HEAP32[i74 + 12 >> 2] | 0;
     HEAP32[i488 >> 2] = HEAP32[i74 >> 2];
     HEAP32[i198 >> 2] = i73;
     HEAP32[i199 >> 2] = i72;
     HEAP32[i200 >> 2] = i71;
     i71 = (HEAP32[i201 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i489 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i202 >> 2] = i72;
     HEAP32[i203 >> 2] = i73;
     HEAP32[i204 >> 2] = i74;
     i74 = (HEAP32[i205 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i74 + 4 >> 2] | 0;
     i72 = HEAP32[i74 + 8 >> 2] | 0;
     i71 = HEAP32[i74 + 12 >> 2] | 0;
     HEAP32[i490 >> 2] = HEAP32[i74 >> 2];
     HEAP32[i206 >> 2] = i73;
     HEAP32[i207 >> 2] = i72;
     HEAP32[i208 >> 2] = i71;
     i71 = (HEAP32[i209 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i491 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i210 >> 2] = i72;
     HEAP32[i211 >> 2] = i73;
     HEAP32[i212 >> 2] = i74;
     if (HEAP32[i502 >> 2] & 268435456 | 0) {
      i71 = (HEAP32[i213 >> 2] | 0) + (i76 << 2) | 0;
      i72 = HEAP32[i71 + 4 >> 2] | 0;
      i73 = HEAP32[i71 + 8 >> 2] | 0;
      i74 = HEAP32[i71 + 12 >> 2] | 0;
      HEAP32[i492 >> 2] = HEAP32[i71 >> 2];
      HEAP32[i214 >> 2] = i72;
      HEAP32[i215 >> 2] = i73;
      HEAP32[i216 >> 2] = i74;
     }
    } else {
     i4 = HEAP32[i189 >> 2] | 0;
     i5 = HEAP32[i192 >> 2] | 0;
     i6 = HEAP32[i186 >> 2] | 0;
     i7 = HEAP32[i190 >> 2] | 0;
     i8 = HEAP32[i193 >> 2] | 0;
     i12 = HEAP32[i187 >> 2] | 0;
     i13 = HEAP32[i191 >> 2] | 0;
     i14 = HEAP32[i194 >> 2] | 0;
     i15 = HEAP32[i197 >> 2] | 0;
     i16 = HEAP32[i201 >> 2] | 0;
     i17 = HEAP32[i205 >> 2] | 0;
     i18 = HEAP32[i209 >> 2] | 0;
     i21 = HEAP32[i188 >> 2] | 0;
     i3 = HEAP32[i213 >> 2] | 0;
     if (!(HEAP32[i502 >> 2] & 268435456)) {
      i2 = 0;
      do {
       i73 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i506 + (i2 << 2) >> 2] = HEAP32[i20 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i4 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i2 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i5 + (i73 << 2) >> 2]));
       i74 = i2 + 4 | 0;
       HEAP32[i506 + (i74 << 2) >> 2] = HEAP32[i6 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i7 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i8 + (i73 << 2) >> 2]));
       i74 = i2 + 8 | 0;
       HEAP32[i506 + (i74 << 2) >> 2] = HEAP32[i12 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i13 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i14 + (i73 << 2) >> 2]));
       HEAP32[i488 + (i2 << 2) >> 2] = HEAP32[i15 + (i73 << 2) >> 2];
       HEAP32[i489 + (i2 << 2) >> 2] = HEAP32[i16 + (i73 << 2) >> 2];
       HEAP32[i490 + (i2 << 2) >> 2] = HEAP32[i17 + (i73 << 2) >> 2];
       HEAP32[i491 + (i2 << 2) >> 2] = HEAP32[i18 + (i73 << 2) >> 2];
       HEAP32[i507 + (i74 << 2) >> 2] = HEAP32[i21 + (i73 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     } else {
      i2 = 0;
      do {
       i73 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i506 + (i2 << 2) >> 2] = HEAP32[i20 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i4 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i2 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i5 + (i73 << 2) >> 2]));
       i74 = i2 + 4 | 0;
       HEAP32[i506 + (i74 << 2) >> 2] = HEAP32[i6 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i7 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i8 + (i73 << 2) >> 2]));
       i74 = i2 + 8 | 0;
       HEAP32[i506 + (i74 << 2) >> 2] = HEAP32[i12 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i13 + (i73 << 2) >> 2]);
       HEAPF32[i487 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i14 + (i73 << 2) >> 2]));
       HEAP32[i488 + (i2 << 2) >> 2] = HEAP32[i15 + (i73 << 2) >> 2];
       HEAP32[i489 + (i2 << 2) >> 2] = HEAP32[i16 + (i73 << 2) >> 2];
       HEAP32[i490 + (i2 << 2) >> 2] = HEAP32[i17 + (i73 << 2) >> 2];
       HEAP32[i491 + (i2 << 2) >> 2] = HEAP32[i18 + (i73 << 2) >> 2];
       HEAP32[i492 + (i2 << 2) >> 2] = HEAP32[i3 + (i73 << 2) >> 2];
       HEAP32[i507 + (i74 << 2) >> 2] = HEAP32[i21 + (i73 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     }
    }
    f27 = Math_fround(HEAPF32[i506 >> 2]);
    f11 = Math_fround(f439 * f27);
    f32 = Math_fround(HEAPF32[i163 >> 2]);
    f30 = Math_fround(f439 * f32);
    f58 = Math_fround(HEAPF32[i162 >> 2]);
    f10 = Math_fround(f439 * f58);
    f56 = Math_fround(HEAPF32[i161 >> 2]);
    f75 = Math_fround(f439 * f56);
    f33 = Math_fround(HEAPF32[i217 >> 2]);
    f31 = Math_fround(f442 * f33);
    f26 = Math_fround(HEAPF32[i167 >> 2]);
    f35 = Math_fround(f442 * f26);
    f57 = Math_fround(HEAPF32[i166 >> 2]);
    f24 = Math_fround(f442 * f57);
    f55 = Math_fround(HEAPF32[i165 >> 2]);
    f31 = Math_fround(f11 + f31);
    f35 = Math_fround(f30 + f35);
    f24 = Math_fround(f10 + f24);
    f75 = Math_fround(f75 + Math_fround(f442 * f55));
    f10 = Math_fround(HEAPF32[i218 >> 2]);
    f30 = Math_fround(f445 * f10);
    f11 = Math_fround(HEAPF32[i171 >> 2]);
    f29 = Math_fround(f445 * f11);
    f22 = Math_fround(HEAPF32[i170 >> 2]);
    f28 = Math_fround(f445 * f22);
    f34 = Math_fround(HEAPF32[i169 >> 2]);
    f29 = Math_fround(f448 + Math_fround(f35 + f29));
    f28 = Math_fround(f448 + Math_fround(f24 + f28));
    f75 = Math_fround(f448 + Math_fround(f75 + Math_fround(f445 * f34)));
    HEAPF32[i493 >> 2] = Math_fround(f448 + Math_fround(f31 + f30));
    HEAPF32[i219 >> 2] = f29;
    HEAPF32[i220 >> 2] = f28;
    HEAPF32[i221 >> 2] = f75;
    f75 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f32) + Math_fround(f443 * f26)) + Math_fround(f446 * f11)));
    f28 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f58) + Math_fround(f443 * f57)) + Math_fround(f446 * f22)));
    f29 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f56) + Math_fround(f443 * f55)) + Math_fround(f446 * f34)));
    HEAPF32[i222 >> 2] = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f27) + Math_fround(f443 * f33)) + Math_fround(f446 * f10)));
    HEAPF32[i223 >> 2] = f75;
    HEAPF32[i224 >> 2] = f28;
    HEAPF32[i225 >> 2] = f29;
    f29 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f32) + Math_fround(f444 * f26)) + Math_fround(f447 * f11)));
    f28 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f58) + Math_fround(f444 * f57)) + Math_fround(f447 * f22)));
    f75 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f56) + Math_fround(f444 * f55)) + Math_fround(f447 * f34)));
    HEAPF32[i226 >> 2] = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f27) + Math_fround(f444 * f33)) + Math_fround(f447 * f10)));
    HEAPF32[i227 >> 2] = f29;
    HEAPF32[i228 >> 2] = f28;
    HEAPF32[i229 >> 2] = f75;
    f10 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f27) + Math_fround(f484 * f33)) + Math_fround(f485 * f10)));
    f11 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f32) + Math_fround(f484 * f26)) + Math_fround(f485 * f11)));
    f22 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f58) + Math_fround(f484 * f57)) + Math_fround(f485 * f22)));
    f34 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f56) + Math_fround(f484 * f55)) + Math_fround(f485 * f34)));
    f55 = Math_fround(f472 + Math_fround(f473 * f10));
    f56 = Math_fround(f472 + Math_fround(f473 * f11));
    f57 = Math_fround(f472 + Math_fround(f473 * f22));
    f58 = Math_fround(f472 + Math_fround(f473 * f34));
    f10 = Math_fround(f466 + Math_fround(f467 * f10));
    f11 = Math_fround(f466 + Math_fround(f467 * f11));
    f22 = Math_fround(f466 + Math_fround(f467 * f22));
    f34 = Math_fround(f466 + Math_fround(f467 * f34));
    f26 = Math_fround(HEAPF32[i488 >> 2]);
    f32 = Math_fround(HEAPF32[i198 >> 2]);
    f33 = Math_fround(HEAPF32[i199 >> 2]);
    f27 = Math_fround(HEAPF32[i200 >> 2]);
    f28 = Math_fround(HEAPF32[i489 >> 2]);
    f29 = Math_fround(HEAPF32[i202 >> 2]);
    f30 = Math_fround(HEAPF32[i203 >> 2]);
    f31 = Math_fround(HEAPF32[i204 >> 2]);
    f24 = f26 > f28 ? f26 : f28;
    f35 = f32 > f29 ? f32 : f29;
    f25 = f33 > f30 ? f33 : f30;
    f36 = f27 > f31 ? f27 : f31;
    f52 = Math_fround((f24 > f55 ? f24 : f55) * Math_fround(.5));
    f53 = Math_fround((f35 > f56 ? f35 : f56) * Math_fround(.5));
    f54 = Math_fround((f25 > f57 ? f25 : f57) * Math_fround(.5));
    f9 = Math_fround((f36 > f58 ? f36 : f58) * Math_fround(.5));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    i71 = f55 >= Math_fround(0.0);
    i72 = f56 >= Math_fround(0.0);
    i73 = f57 >= Math_fround(0.0);
    i74 = f58 >= Math_fround(0.0);
    i12 = i71 ? i12 : 0;
    i13 = i72 ? i13 : 0;
    i14 = i73 ? i14 : 0;
    i5 = i74 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    f54 = Math_fround(f10 * Math_fround(.5));
    f56 = Math_fround(f11 * Math_fround(.5));
    f58 = Math_fround(f22 * Math_fround(.5));
    f9 = Math_fround(f34 * Math_fround(.5));
    f53 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f57 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f53 < f54 ? f53 : f54, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f55 < f56 ? f55 : f56, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f57 < f58 ? f57 : f58, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = f10 >= Math_fround(0.0);
    i3 = f11 >= Math_fround(0.0);
    i2 = f22 >= Math_fround(0.0);
    i74 = f34 >= Math_fround(0.0);
    i71 = i74 ? (HEAPF32[tempDoublePtr >> 2] = f23 < f9 ? f23 : f9, HEAP32[tempDoublePtr >> 2] | 0) : i5;
    f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f24);
    f56 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
    f34 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f522 = Math_fround(f26 * f55);
    f521 = Math_fround(f33 * f57);
    f55 = Math_fround(f28 * f55);
    f57 = Math_fround(f30 * f57);
    f551 = Math_fround(HEAPF32[i490 >> 2]);
    f553 = Math_fround(HEAPF32[i206 >> 2]);
    f555 = Math_fround(HEAPF32[i207 >> 2]);
    f556 = Math_fround(f475 * f26);
    f554 = Math_fround(f475 * f33);
    f552 = Math_fround(f469 * f28);
    f550 = Math_fround(f469 * f30);
    f538 = Math_fround(f471 * f26);
    f536 = Math_fround(f471 * f33);
    f56 = Math_fround(f56 / f35);
    f28 = Math_fround(f32 * f56);
    f56 = Math_fround(f29 * f56);
    i71 = f551 < Math_fround(100.0);
    i73 = f555 < Math_fround(100.0);
    f555 = Math_fround(f475 * f32);
    f551 = Math_fround(f469 * f29);
    f537 = Math_fround(f471 * f32);
    f34 = Math_fround(f34 / f36);
    f30 = Math_fround(f27 * f34);
    f34 = Math_fround(f31 * f34);
    i72 = f553 < Math_fround(100.0);
    i74 = Math_fround(HEAPF32[i208 >> 2]) < Math_fround(100.0);
    f553 = Math_fround(f475 * f27);
    f549 = Math_fround(f469 * f31);
    f547 = Math_fround(f471 * f27);
    f26 = Math_fround(Math_fround(HEAPF32[i172 >> 2]) * Math_fround(.159154937));
    f25 = Math_fround(Math_fround(HEAPF32[i175 >> 2]) * Math_fround(.159154937));
    f24 = Math_fround(Math_fround(HEAPF32[i174 >> 2]) * Math_fround(.159154937));
    f526 = Math_fround(Math_fround(HEAPF32[i173 >> 2]) * Math_fround(.159154937));
    f527 = Math_fround(+_roundf(+f26));
    f535 = Math_fround(+_roundf(+f25));
    f513 = Math_fround(+_roundf(+f24));
    f527 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f527))));
    f535 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f25 - f535))));
    f513 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f24 - f513))));
    f534 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f526 - Math_fround(+_roundf(+f526))))));
    f512 = Math_fround(f527 * f527);
    f523 = Math_fround(f535 * f535);
    f29 = Math_fround(f513 * f513);
    f27 = Math_fround(f534 * f534);
    f525 = Math_fround(f512 * f512);
    f533 = Math_fround(f523 * f523);
    f524 = Math_fround(f29 * f29);
    f532 = Math_fround(f27 * f27);
    f512 = Math_fround(f527 * Math_fround(Math_fround(Math_fround(f525 * f525) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f512 * Math_fround(41.3416595))) + Math_fround(f525 * Math_fround(Math_fround(81.6018218) - Math_fround(f512 * Math_fround(76.5686187)))))));
    f523 = Math_fround(f535 * Math_fround(Math_fround(Math_fround(f533 * f533) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f523 * Math_fround(41.3416595))) + Math_fround(f533 * Math_fround(Math_fround(81.6018218) - Math_fround(f523 * Math_fround(76.5686187)))))));
    f29 = Math_fround(f513 * Math_fround(Math_fround(Math_fround(f524 * f524) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f29 * Math_fround(41.3416595))) + Math_fround(f524 * Math_fround(Math_fround(81.6018218) - Math_fround(f29 * Math_fround(76.5686187)))))));
    f27 = Math_fround(f534 * Math_fround(Math_fround(Math_fround(f532 * f532) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f532 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187)))))));
    f26 = Math_fround(f26 + Math_fround(-.25));
    f25 = Math_fround(f25 + Math_fround(-.25));
    f24 = Math_fround(f24 + Math_fround(-.25));
    f526 = Math_fround(f526 + Math_fround(-.25));
    f532 = Math_fround(+_roundf(+f26));
    f534 = Math_fround(+_roundf(+f25));
    f524 = Math_fround(+_roundf(+f24));
    f532 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f532))));
    f534 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f25 - f534))));
    f524 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f24 - f524))));
    f526 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f526 - Math_fround(+_roundf(+f526))))));
    f24 = Math_fround(f532 * f532);
    f25 = Math_fround(f534 * f534);
    f26 = Math_fround(f524 * f524);
    f513 = Math_fround(f526 * f526);
    f533 = Math_fround(f24 * f24);
    f535 = Math_fround(f25 * f25);
    f525 = Math_fround(f26 * f26);
    f527 = Math_fround(f513 * f513);
    f24 = Math_fround(f532 * Math_fround(Math_fround(Math_fround(f533 * f533) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f24 * Math_fround(41.3416595))) + Math_fround(f533 * Math_fround(Math_fround(81.6018218) - Math_fround(f24 * Math_fround(76.5686187)))))));
    f25 = Math_fround(f534 * Math_fround(Math_fround(Math_fround(f535 * f535) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f25 * Math_fround(41.3416595))) + Math_fround(f535 * Math_fround(Math_fround(81.6018218) - Math_fround(f25 * Math_fround(76.5686187)))))));
    f26 = Math_fround(f524 * Math_fround(Math_fround(Math_fround(f525 * f525) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f26 * Math_fround(41.3416595))) + Math_fround(f525 * Math_fround(Math_fround(81.6018218) - Math_fround(f26 * Math_fround(76.5686187)))))));
    f513 = Math_fround(f526 * Math_fround(Math_fround(Math_fround(f527 * f527) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f513 * Math_fround(41.3416595))) + Math_fround(f527 * Math_fround(Math_fround(81.6018218) - Math_fround(f513 * Math_fround(76.5686187)))))));
    f527 = Math_fround(-f24);
    f526 = Math_fround(-f25);
    f525 = Math_fround(-f26);
    f524 = Math_fround(-f513);
    f535 = Math_fround(f333 + Math_fround(Math_fround(f334 * f512) + Math_fround(f335 * f527)));
    f534 = Math_fround(f333 + Math_fround(Math_fround(f334 * f523) + Math_fround(f335 * f526)));
    f533 = Math_fround(f333 + Math_fround(Math_fround(f334 * f29) + Math_fround(f335 * f525)));
    f532 = Math_fround(f333 + Math_fround(Math_fround(f334 * f27) + Math_fround(f335 * f524)));
    f511 = Math_fround(f333 + Math_fround(Math_fround(f335 * f512) + Math_fround(f334 * f24)));
    f510 = Math_fround(f333 + Math_fround(Math_fround(f335 * f523) + Math_fround(f334 * f25)));
    f509 = Math_fround(f333 + Math_fround(Math_fround(f335 * f29) + Math_fround(f334 * f26)));
    f9 = Math_fround(f333 + Math_fround(Math_fround(f335 * f27) + Math_fround(f334 * f513)));
    f531 = Math_fround(f332 + Math_fround(Math_fround(f336 * f512) + Math_fround(f341 * f527)));
    f530 = Math_fround(f332 + Math_fround(Math_fround(f336 * f523) + Math_fround(f341 * f526)));
    f529 = Math_fround(f332 + Math_fround(Math_fround(f336 * f29) + Math_fround(f341 * f525)));
    f528 = Math_fround(f332 + Math_fround(Math_fround(f336 * f27) + Math_fround(f341 * f524)));
    f10 = Math_fround(f332 + Math_fround(Math_fround(f341 * f512) + Math_fround(f336 * f24)));
    f11 = Math_fround(f332 + Math_fround(Math_fround(f341 * f523) + Math_fround(f336 * f25)));
    f22 = Math_fround(f332 + Math_fround(Math_fround(f341 * f29) + Math_fround(f336 * f26)));
    f23 = Math_fround(f332 + Math_fround(Math_fround(f341 * f27) + Math_fround(f336 * f513)));
    f527 = Math_fround(f330 + Math_fround(Math_fround(f342 * f512) + Math_fround(f343 * f527)));
    f526 = Math_fround(f330 + Math_fround(Math_fround(f342 * f523) + Math_fround(f343 * f526)));
    f525 = Math_fround(f330 + Math_fround(Math_fround(f342 * f29) + Math_fround(f343 * f525)));
    f524 = Math_fround(f330 + Math_fround(Math_fround(f342 * f27) + Math_fround(f343 * f524)));
    f24 = Math_fround(f330 + Math_fround(Math_fround(f343 * f512) + Math_fround(f342 * f24)));
    f25 = Math_fround(f330 + Math_fround(Math_fround(f343 * f523) + Math_fround(f342 * f25)));
    f26 = Math_fround(f330 + Math_fround(Math_fround(f343 * f29) + Math_fround(f342 * f26)));
    f513 = Math_fround(f330 + Math_fround(Math_fround(f343 * f27) + Math_fround(f342 * f513)));
    f27 = i71 ? f522 : Math_fround(0.0);
    f28 = i72 ? f28 : Math_fround(0.0);
    f29 = i73 ? f521 : Math_fround(0.0);
    f30 = i74 ? f30 : Math_fround(0.0);
    f521 = Math_fround(f556 - f27);
    f522 = Math_fround(f555 - f28);
    f523 = Math_fround(f554 - f29);
    f512 = Math_fround(f553 - f30);
    f31 = i71 ? f55 : Math_fround(0.0);
    f55 = Math_fround(f552 + f31);
    f32 = i72 ? f56 : Math_fround(0.0);
    f56 = Math_fround(f551 + f32);
    f33 = i73 ? f57 : Math_fround(0.0);
    f57 = Math_fround(f550 + f33);
    f34 = i74 ? f34 : Math_fround(0.0);
    f58 = Math_fround(f549 + f34);
    f546 = Math_fround(f521 * f535);
    f514 = Math_fround(f522 * f534);
    f515 = Math_fround(f523 * f533);
    f516 = Math_fround(f512 * f532);
    f47 = Math_fround(f55 * f511);
    f48 = Math_fround(f56 * f510);
    f49 = Math_fround(f57 * f509);
    f50 = Math_fround(f58 * f9);
    f548 = Math_fround(f331 * f538);
    f545 = Math_fround(f331 * f537);
    f544 = Math_fround(f331 * f536);
    f543 = Math_fround(f331 * f547);
    f35 = Math_fround(f548 + Math_fround(f546 + f47));
    f36 = Math_fround(f545 + Math_fround(f514 + f48));
    f37 = Math_fround(f544 + Math_fround(f515 + f49));
    f38 = Math_fround(f543 + Math_fround(f516 + f50));
    f517 = Math_fround(f521 * f531);
    f518 = Math_fround(f522 * f530);
    f519 = Math_fround(f523 * f529);
    f520 = Math_fround(f512 * f528);
    f51 = Math_fround(f55 * f10);
    f52 = Math_fround(f56 * f11);
    f53 = Math_fround(f57 * f22);
    f54 = Math_fround(f58 * f23);
    f542 = Math_fround(f329 * f538);
    f541 = Math_fround(f329 * f537);
    f540 = Math_fround(f329 * f536);
    f539 = Math_fround(f329 * f547);
    f39 = Math_fround(f542 + Math_fround(f517 + f51));
    f40 = Math_fround(f541 + Math_fround(f518 + f52));
    f41 = Math_fround(f540 + Math_fround(f519 + f53));
    f42 = Math_fround(f539 + Math_fround(f520 + f54));
    f521 = Math_fround(f521 * f527);
    f522 = Math_fround(f522 * f526);
    f523 = Math_fround(f523 * f525);
    f512 = Math_fround(f512 * f524);
    f55 = Math_fround(f55 * f24);
    f56 = Math_fround(f56 * f25);
    f57 = Math_fround(f57 * f26);
    f58 = Math_fround(f58 * f513);
    f538 = Math_fround(f328 * f538);
    f537 = Math_fround(f328 * f537);
    f536 = Math_fround(f328 * f536);
    f547 = Math_fround(f328 * f547);
    f43 = Math_fround(f538 + Math_fround(f521 + f55));
    f44 = Math_fround(f537 + Math_fround(f522 + f56));
    f45 = Math_fround(f536 + Math_fround(f523 + f57));
    f46 = Math_fround(f547 + Math_fround(f512 + f58));
    f556 = Math_fround(f556 + f27);
    f555 = Math_fround(f555 + f28);
    f554 = Math_fround(f554 + f29);
    f553 = Math_fround(f553 + f30);
    f535 = Math_fround(f556 * f535);
    f534 = Math_fround(f555 * f534);
    f533 = Math_fround(f554 * f533);
    f532 = Math_fround(f553 * f532);
    f47 = Math_fround(f548 + Math_fround(f535 + f47));
    f48 = Math_fround(f545 + Math_fround(f534 + f48));
    f49 = Math_fround(f544 + Math_fround(f533 + f49));
    f50 = Math_fround(f543 + Math_fround(f532 + f50));
    f531 = Math_fround(f556 * f531);
    f530 = Math_fround(f555 * f530);
    f529 = Math_fround(f554 * f529);
    f528 = Math_fround(f553 * f528);
    f51 = Math_fround(f542 + Math_fround(f531 + f51));
    f52 = Math_fround(f541 + Math_fround(f530 + f52));
    f53 = Math_fround(f540 + Math_fround(f529 + f53));
    f54 = Math_fround(f539 + Math_fround(f528 + f54));
    f527 = Math_fround(f556 * f527);
    f526 = Math_fround(f555 * f526);
    f525 = Math_fround(f554 * f525);
    f524 = Math_fround(f553 * f524);
    f55 = Math_fround(f538 + Math_fround(f527 + f55));
    f56 = Math_fround(f537 + Math_fround(f526 + f56));
    f57 = Math_fround(f536 + Math_fround(f525 + f57));
    f58 = Math_fround(f547 + Math_fround(f524 + f58));
    f552 = Math_fround(f552 - f31);
    f551 = Math_fround(f551 - f32);
    f550 = Math_fround(f550 - f33);
    f549 = Math_fround(f549 - f34);
    f511 = Math_fround(f552 * f511);
    f510 = Math_fround(f551 * f510);
    f509 = Math_fround(f550 * f509);
    f9 = Math_fround(f549 * f9);
    f535 = Math_fround(f548 + Math_fround(f535 + f511));
    f534 = Math_fround(f545 + Math_fround(f534 + f510));
    f533 = Math_fround(f544 + Math_fround(f533 + f509));
    f532 = Math_fround(f543 + Math_fround(f532 + f9));
    f10 = Math_fround(f552 * f10);
    f11 = Math_fround(f551 * f11);
    f22 = Math_fround(f550 * f22);
    f23 = Math_fround(f549 * f23);
    f531 = Math_fround(f542 + Math_fround(f531 + f10));
    f530 = Math_fround(f541 + Math_fround(f530 + f11));
    f529 = Math_fround(f540 + Math_fround(f529 + f22));
    f528 = Math_fround(f539 + Math_fround(f528 + f23));
    f24 = Math_fround(f552 * f24);
    f25 = Math_fround(f551 * f25);
    f26 = Math_fround(f550 * f26);
    f513 = Math_fround(f549 * f513);
    f527 = Math_fround(f538 + Math_fround(f527 + f24));
    f526 = Math_fround(f537 + Math_fround(f526 + f25));
    f525 = Math_fround(f536 + Math_fround(f525 + f26));
    f524 = Math_fround(f547 + Math_fround(f524 + f513));
    f511 = Math_fround(f548 + Math_fround(f546 + f511));
    f510 = Math_fround(f545 + Math_fround(f514 + f510));
    f509 = Math_fround(f544 + Math_fround(f515 + f509));
    f9 = Math_fround(f543 + Math_fround(f516 + f9));
    f10 = Math_fround(f542 + Math_fround(f517 + f10));
    f11 = Math_fround(f541 + Math_fround(f518 + f11));
    f22 = Math_fround(f540 + Math_fround(f519 + f22));
    f23 = Math_fround(f539 + Math_fround(f520 + f23));
    f24 = Math_fround(f538 + Math_fround(f521 + f24));
    f25 = Math_fround(f537 + Math_fround(f522 + f25));
    f26 = Math_fround(f536 + Math_fround(f523 + f26));
    f513 = Math_fround(f547 + Math_fround(f512 + f513));
    f512 = Math_fround(HEAPF32[i493 >> 2]);
    f547 = Math_fround(f512 + f35);
    f523 = Math_fround(HEAPF32[i219 >> 2]);
    f536 = Math_fround(f523 + f36);
    f522 = Math_fround(HEAPF32[i220 >> 2]);
    f537 = Math_fround(f522 + f37);
    f521 = Math_fround(HEAPF32[i221 >> 2]);
    f538 = Math_fround(f521 + f38);
    f520 = Math_fround(HEAPF32[i222 >> 2]);
    f539 = Math_fround(f520 + f39);
    f519 = Math_fround(HEAPF32[i223 >> 2]);
    f540 = Math_fround(f519 + f40);
    f518 = Math_fround(HEAPF32[i224 >> 2]);
    f541 = Math_fround(f518 + f41);
    f517 = Math_fround(HEAPF32[i225 >> 2]);
    f542 = Math_fround(f517 + f42);
    f516 = Math_fround(HEAPF32[i226 >> 2]);
    f543 = Math_fround(f516 + f43);
    f515 = Math_fround(HEAPF32[i227 >> 2]);
    f544 = Math_fround(f515 + f44);
    f514 = Math_fround(HEAPF32[i228 >> 2]);
    f545 = Math_fround(f514 + f45);
    f546 = Math_fround(f75 + f46);
    HEAPF32[i499 >> 2] = f547;
    HEAPF32[i230 >> 2] = f536;
    HEAPF32[i231 >> 2] = f537;
    HEAPF32[i232 >> 2] = f538;
    HEAPF32[i233 >> 2] = f539;
    HEAPF32[i234 >> 2] = f540;
    HEAPF32[i235 >> 2] = f541;
    HEAPF32[i236 >> 2] = f542;
    HEAPF32[i237 >> 2] = f543;
    HEAPF32[i238 >> 2] = f544;
    HEAPF32[i239 >> 2] = f545;
    HEAPF32[i240 >> 2] = f546;
    f546 = Math_fround(f523 + f48);
    f545 = Math_fround(f522 + f49);
    f544 = Math_fround(f521 + f50);
    f543 = Math_fround(f520 + f51);
    f542 = Math_fround(f519 + f52);
    f541 = Math_fround(f518 + f53);
    f540 = Math_fround(f517 + f54);
    f539 = Math_fround(f516 + f55);
    f538 = Math_fround(f515 + f56);
    f537 = Math_fround(f514 + f57);
    f536 = Math_fround(f75 + f58);
    HEAPF32[i241 >> 2] = Math_fround(f512 + f47);
    HEAPF32[i242 >> 2] = f546;
    HEAPF32[i243 >> 2] = f545;
    HEAPF32[i244 >> 2] = f544;
    HEAPF32[i245 >> 2] = f543;
    HEAPF32[i246 >> 2] = f542;
    HEAPF32[i247 >> 2] = f541;
    HEAPF32[i248 >> 2] = f540;
    HEAPF32[i249 >> 2] = f539;
    HEAPF32[i250 >> 2] = f538;
    HEAPF32[i251 >> 2] = f537;
    HEAPF32[i252 >> 2] = f536;
    f534 = Math_fround(f523 + f534);
    f533 = Math_fround(f522 + f533);
    f532 = Math_fround(f521 + f532);
    f531 = Math_fround(f520 + f531);
    f530 = Math_fround(f519 + f530);
    f529 = Math_fround(f518 + f529);
    f528 = Math_fround(f517 + f528);
    f527 = Math_fround(f516 + f527);
    f526 = Math_fround(f515 + f526);
    f525 = Math_fround(f514 + f525);
    f524 = Math_fround(f75 + f524);
    HEAPF32[i253 >> 2] = Math_fround(f512 + f535);
    HEAPF32[i254 >> 2] = f534;
    HEAPF32[i255 >> 2] = f533;
    HEAPF32[i256 >> 2] = f532;
    HEAPF32[i257 >> 2] = f531;
    HEAPF32[i258 >> 2] = f530;
    HEAPF32[i259 >> 2] = f529;
    HEAPF32[i260 >> 2] = f528;
    HEAPF32[i261 >> 2] = f527;
    HEAPF32[i262 >> 2] = f526;
    HEAPF32[i263 >> 2] = f525;
    HEAPF32[i264 >> 2] = f524;
    f510 = Math_fround(f523 + f510);
    f509 = Math_fround(f522 + f509);
    f9 = Math_fround(f521 + f9);
    f10 = Math_fround(f520 + f10);
    f11 = Math_fround(f519 + f11);
    f22 = Math_fround(f518 + f22);
    f23 = Math_fround(f517 + f23);
    f24 = Math_fround(f516 + f24);
    f25 = Math_fround(f515 + f25);
    f26 = Math_fround(f514 + f26);
    f75 = Math_fround(f75 + f513);
    HEAPF32[i265 >> 2] = Math_fround(f512 + f511);
    HEAPF32[i266 >> 2] = f510;
    HEAPF32[i267 >> 2] = f509;
    HEAPF32[i268 >> 2] = f9;
    HEAPF32[i269 >> 2] = f10;
    HEAPF32[i270 >> 2] = f11;
    HEAPF32[i271 >> 2] = f22;
    HEAPF32[i272 >> 2] = f23;
    HEAPF32[i273 >> 2] = f24;
    HEAPF32[i274 >> 2] = f25;
    HEAPF32[i275 >> 2] = f26;
    HEAPF32[i276 >> 2] = f75;
    if (!i277) {
     i2 = HEAP32[i502 >> 2] | 0;
     if (i2 & 536870912) {
      f556 = Math_fround(HEAPF32[i78 >> 2]);
      i62 = HEAP32[i491 >> 2] | 0;
      i73 = i62 + 693089735 | 0;
      i60 = HEAP32[i210 >> 2] | 0;
      i70 = i60 + 693089735 | 0;
      i21 = HEAP32[i211 >> 2] | 0;
      i67 = i21 + 693089735 | 0;
      i19 = HEAP32[i212 >> 2] | 0;
      i64 = i19 + 693089735 | 0;
      i20 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i59 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i61 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i63 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i73 = i73 << 11 ^ i73;
      i70 = i70 << 11 ^ i70;
      i67 = i67 << 11 ^ i67;
      i64 = i64 << 11 ^ i64;
      i20 = Math_fround(Math_fround((i20 ^ i73 ^ i73 >>> 8) & 8388607 ^ i20 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i59 = Math_fround(Math_fround((i59 ^ i70 ^ i70 >>> 8) & 8388607 ^ i59 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i61 = Math_fround(Math_fround((i61 ^ i67 ^ i67 >>> 8) & 8388607 ^ i61 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i63 = Math_fround(Math_fround((i63 ^ i64 ^ i64 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      f556 = Math_fround(HEAPF32[i77 >> 2]);
      i62 = i62 + 13945730 | 0;
      i60 = i60 + 13945730 | 0;
      i21 = i21 + 13945730 | 0;
      i19 = i19 + 13945730 | 0;
      i64 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i60, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i19, 1790253981) | 0) + 1900727103 | 0;
      i62 = i62 << 11 ^ i62;
      i60 = i60 << 11 ^ i60;
      i21 = i21 << 11 ^ i21;
      i19 = i19 << 11 ^ i19;
      i64 = Math_fround(Math_fround((i64 ^ i62 ^ i62 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i67 = Math_fround(Math_fround((i67 ^ i60 ^ i60 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i70 = Math_fround(Math_fround((i70 ^ i21 ^ i21 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i73 = Math_fround(Math_fround((i73 ^ i19 ^ i19 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i19 = i20 & 1;
      i21 = i59 & 1;
      i60 = i61 & 1;
      i62 = i63 & 1;
      i65 = i19 ^ 1;
      i68 = i21 ^ 1;
      i71 = i60 ^ 1;
      i74 = i62 ^ 1;
      i66 = i20 ? 3 : 2;
      i69 = i59 ? 3 : 2;
      i72 = i61 ? 3 : 2;
      i2 = i63 ? 3 : 2;
      i20 = i20 ? 2 : 3;
      i59 = i59 ? 2 : 3;
      i61 = i61 ? 2 : 3;
      i63 = i63 ? 2 : 3;
      HEAP32[i496 >> 2] = i64 ? i20 : i19;
      HEAP32[i453 >> 2] = i67 ? i59 : i21;
      HEAP32[i452 >> 2] = i70 ? i61 : i60;
      HEAP32[i451 >> 2] = i73 ? i63 : i62;
      HEAP32[i465 >> 2] = i64 ? i19 : i20;
      HEAP32[i464 >> 2] = i67 ? i21 : i59;
      HEAP32[i463 >> 2] = i70 ? i60 : i61;
      HEAP32[i462 >> 2] = i73 ? i62 : i63;
      HEAP32[i457 >> 2] = i64 ? i66 : i65;
      HEAP32[i456 >> 2] = i67 ? i69 : i68;
      HEAP32[i455 >> 2] = i70 ? i72 : i71;
      HEAP32[i454 >> 2] = i73 ? i2 : i74;
      HEAP32[i461 >> 2] = i64 ? i65 : i66;
      HEAP32[i460 >> 2] = i67 ? i68 : i69;
      HEAP32[i459 >> 2] = i70 ? i71 : i72;
      HEAP32[i458 >> 2] = i73 ? i74 : i2;
      i2 = HEAP32[i502 >> 2] | 0;
     }
     if (i2 & 268435456 | 0) {
      f9 = Math_fround(f478 * Math_fround(HEAPF32[i492 >> 2]));
      f10 = Math_fround(f478 * Math_fround(HEAPF32[i214 >> 2]));
      f11 = Math_fround(f478 * Math_fround(HEAPF32[i215 >> 2]));
      f22 = Math_fround(f478 * Math_fround(HEAPF32[i216 >> 2]));
      f23 = Math_fround(Math_floor(Math_fround(f9)));
      f24 = Math_fround(Math_floor(Math_fround(f10)));
      f25 = Math_fround(Math_floor(Math_fround(f11)));
      f26 = Math_fround(Math_floor(Math_fround(f22)));
      if (i2 & 16777216 | 0) {
       f553 = Math_fround(Math_floor(Math_fround(f477 * f23)));
       f554 = Math_fround(Math_floor(Math_fround(f477 * f24)));
       f555 = Math_fround(Math_floor(Math_fround(f477 * f25)));
       f556 = Math_fround(Math_floor(Math_fround(f477 * f26)));
       f549 = Math_fround(f479 * Math_fround(f23 - Math_fround(f476 * f553)));
       f550 = Math_fround(f479 * Math_fround(f24 - Math_fround(f476 * f554)));
       f551 = Math_fround(f479 * Math_fround(f25 - Math_fround(f476 * f555)));
       f552 = Math_fround(f479 * Math_fround(f26 - Math_fround(f476 * f556)));
       f553 = Math_fround(f481 - Math_fround(f480 * f553));
       f554 = Math_fround(f481 - Math_fround(f480 * f554));
       f555 = Math_fround(f481 - Math_fround(f480 * f555));
       f556 = Math_fround(f481 - Math_fround(f480 * f556));
       f541 = Math_fround(f480 + f553);
       f542 = Math_fround(f480 + f554);
       f543 = Math_fround(f480 + f555);
       f544 = Math_fround(f480 + f556);
       HEAPF32[i497 >> 2] = f549;
       HEAPF32[i390 >> 2] = f550;
       HEAPF32[i414 >> 2] = f551;
       HEAPF32[i438 >> 2] = f552;
       HEAPF32[i366 >> 2] = f541;
       HEAPF32[i389 >> 2] = f542;
       HEAPF32[i413 >> 2] = f543;
       HEAPF32[i437 >> 2] = f544;
       f545 = Math_fround(f479 + f549);
       f546 = Math_fround(f479 + f550);
       f547 = Math_fround(f479 + f551);
       f548 = Math_fround(f479 + f552);
       HEAPF32[i365 >> 2] = f545;
       HEAPF32[i388 >> 2] = f546;
       HEAPF32[i412 >> 2] = f547;
       HEAPF32[i436 >> 2] = f548;
       HEAPF32[i364 >> 2] = f541;
       HEAPF32[i387 >> 2] = f542;
       HEAPF32[i411 >> 2] = f543;
       HEAPF32[i435 >> 2] = f544;
       HEAPF32[i363 >> 2] = f545;
       HEAPF32[i386 >> 2] = f546;
       HEAPF32[i410 >> 2] = f547;
       HEAPF32[i434 >> 2] = f548;
       HEAPF32[i362 >> 2] = f553;
       HEAPF32[i385 >> 2] = f554;
       HEAPF32[i409 >> 2] = f555;
       HEAPF32[i433 >> 2] = f556;
       HEAPF32[i361 >> 2] = f549;
       HEAPF32[i384 >> 2] = f550;
       HEAPF32[i408 >> 2] = f551;
       HEAPF32[i432 >> 2] = f552;
       HEAPF32[i360 >> 2] = f553;
       HEAPF32[i383 >> 2] = f554;
       HEAPF32[i407 >> 2] = f555;
       HEAPF32[i431 >> 2] = f556;
      }
      if (i2 & 33554432 | 0) {
       f545 = Math_fround(f23 + Math_fround(1.0));
       f546 = Math_fround(f24 + Math_fround(1.0));
       f547 = Math_fround(f25 + Math_fround(1.0));
       f548 = Math_fround(f26 + Math_fround(1.0));
       f553 = Math_fround(f9 - f23);
       f554 = Math_fround(f10 - f24);
       f555 = Math_fround(f11 - f25);
       f556 = Math_fround(f22 - f26);
       f549 = Math_fround(Math_floor(Math_fround(f477 * f545)));
       f550 = Math_fround(Math_floor(Math_fround(f477 * f546)));
       f551 = Math_fround(Math_floor(Math_fround(f477 * f547)));
       f552 = Math_fround(Math_floor(Math_fround(f477 * f548)));
       f545 = Math_fround(f479 * Math_fround(f545 - Math_fround(f476 * f549)));
       f546 = Math_fround(f479 * Math_fround(f546 - Math_fround(f476 * f550)));
       f547 = Math_fround(f479 * Math_fround(f547 - Math_fround(f476 * f551)));
       f548 = Math_fround(f479 * Math_fround(f548 - Math_fround(f476 * f552)));
       f549 = Math_fround(f481 - Math_fround(f480 * f549));
       f550 = Math_fround(f481 - Math_fround(f480 * f550));
       f551 = Math_fround(f481 - Math_fround(f480 * f551));
       f552 = Math_fround(f481 - Math_fround(f480 * f552));
       f537 = Math_fround(f480 + f549);
       f538 = Math_fround(f480 + f550);
       f539 = Math_fround(f480 + f551);
       f540 = Math_fround(f480 + f552);
       HEAPF32[i498 >> 2] = f545;
       HEAPF32[i382 >> 2] = f546;
       HEAPF32[i406 >> 2] = f547;
       HEAPF32[i430 >> 2] = f548;
       HEAPF32[i359 >> 2] = f537;
       HEAPF32[i381 >> 2] = f538;
       HEAPF32[i405 >> 2] = f539;
       HEAPF32[i429 >> 2] = f540;
       HEAPF32[i358 >> 2] = f553;
       HEAPF32[i380 >> 2] = f554;
       HEAPF32[i404 >> 2] = f555;
       HEAPF32[i428 >> 2] = f556;
       HEAPF32[i357 >> 2] = f9;
       HEAPF32[i379 >> 2] = f10;
       HEAPF32[i403 >> 2] = f11;
       HEAPF32[i427 >> 2] = f22;
       f541 = Math_fround(f479 + f545);
       f542 = Math_fround(f479 + f546);
       f543 = Math_fround(f479 + f547);
       f544 = Math_fround(f479 + f548);
       HEAPF32[i356 >> 2] = f541;
       HEAPF32[i378 >> 2] = f542;
       HEAPF32[i402 >> 2] = f543;
       HEAPF32[i426 >> 2] = f544;
       HEAPF32[i355 >> 2] = f537;
       HEAPF32[i377 >> 2] = f538;
       HEAPF32[i401 >> 2] = f539;
       HEAPF32[i425 >> 2] = f540;
       HEAPF32[i354 >> 2] = f553;
       HEAPF32[i376 >> 2] = f554;
       HEAPF32[i400 >> 2] = f555;
       HEAPF32[i424 >> 2] = f556;
       HEAPF32[i353 >> 2] = f9;
       HEAPF32[i375 >> 2] = f10;
       HEAPF32[i399 >> 2] = f11;
       HEAPF32[i423 >> 2] = f22;
       HEAPF32[i352 >> 2] = f541;
       HEAPF32[i374 >> 2] = f542;
       HEAPF32[i398 >> 2] = f543;
       HEAPF32[i422 >> 2] = f544;
       HEAPF32[i351 >> 2] = f549;
       HEAPF32[i373 >> 2] = f550;
       HEAPF32[i397 >> 2] = f551;
       HEAPF32[i421 >> 2] = f552;
       HEAPF32[i350 >> 2] = f553;
       HEAPF32[i372 >> 2] = f554;
       HEAPF32[i396 >> 2] = f555;
       HEAPF32[i420 >> 2] = f556;
       HEAPF32[i349 >> 2] = f9;
       HEAPF32[i371 >> 2] = f10;
       HEAPF32[i395 >> 2] = f11;
       HEAPF32[i419 >> 2] = f22;
       HEAPF32[i348 >> 2] = f545;
       HEAPF32[i370 >> 2] = f546;
       HEAPF32[i394 >> 2] = f547;
       HEAPF32[i418 >> 2] = f548;
       HEAPF32[i347 >> 2] = f549;
       HEAPF32[i369 >> 2] = f550;
       HEAPF32[i393 >> 2] = f551;
       HEAPF32[i417 >> 2] = f552;
       HEAPF32[i346 >> 2] = f553;
       HEAPF32[i368 >> 2] = f554;
       HEAPF32[i392 >> 2] = f555;
       HEAPF32[i416 >> 2] = f556;
       HEAPF32[i345 >> 2] = f9;
       HEAPF32[i367 >> 2] = f10;
       HEAPF32[i391 >> 2] = f11;
       HEAPF32[i415 >> 2] = f22;
      }
     }
    }
    f541 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
    f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
    f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
    f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
    f533 = Math_fround(f482 * Math_fround(f35 * f541));
    f534 = Math_fround(f482 * Math_fround(f36 * f542));
    f535 = Math_fround(f482 * Math_fround(f37 * f543));
    f536 = Math_fround(f482 * Math_fround(f38 * f544));
    f537 = Math_fround(f482 * Math_fround(f39 * f541));
    f538 = Math_fround(f482 * Math_fround(f40 * f542));
    f539 = Math_fround(f482 * Math_fround(f41 * f543));
    f540 = Math_fround(f482 * Math_fround(f42 * f544));
    f541 = Math_fround(f482 * Math_fround(f43 * f541));
    f542 = Math_fround(f482 * Math_fround(f44 * f542));
    f543 = Math_fround(f482 * Math_fround(f45 * f543));
    f544 = Math_fround(f482 * Math_fround(f46 * f544));
    f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
    f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
    f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
    f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
    f545 = Math_fround(f482 * Math_fround(f47 * f553));
    f546 = Math_fround(f482 * Math_fround(f48 * f554));
    f547 = Math_fround(f482 * Math_fround(f49 * f555));
    f548 = Math_fround(f482 * Math_fround(f50 * f556));
    f549 = Math_fround(f482 * Math_fround(f51 * f553));
    f550 = Math_fround(f482 * Math_fround(f52 * f554));
    f551 = Math_fround(f482 * Math_fround(f53 * f555));
    f552 = Math_fround(f482 * Math_fround(f54 * f556));
    f553 = Math_fround(f482 * Math_fround(f55 * f553));
    f554 = Math_fround(f482 * Math_fround(f56 * f554));
    f555 = Math_fround(f482 * Math_fround(f57 * f555));
    f556 = Math_fround(f482 * Math_fround(f58 * f556));
    f532 = Math_fround(f474 + f534);
    f531 = Math_fround(f474 + f535);
    f530 = Math_fround(f474 + f536);
    f529 = Math_fround(f468 + f537);
    f528 = Math_fround(f468 + f538);
    f527 = Math_fround(f468 + f539);
    f526 = Math_fround(f468 + f540);
    f525 = Math_fround(f470 + f541);
    f524 = Math_fround(f470 + f542);
    f523 = Math_fround(f470 + f543);
    f522 = Math_fround(f470 + f544);
    HEAPF32[i500 >> 2] = Math_fround(f474 + f533);
    HEAPF32[i121 >> 2] = f532;
    HEAPF32[i138 >> 2] = f531;
    HEAPF32[i155 >> 2] = f530;
    HEAPF32[i278 >> 2] = f529;
    HEAPF32[i116 >> 2] = f528;
    HEAPF32[i133 >> 2] = f527;
    HEAPF32[i150 >> 2] = f526;
    HEAPF32[i279 >> 2] = f525;
    HEAPF32[i111 >> 2] = f524;
    HEAPF32[i128 >> 2] = f523;
    HEAPF32[i145 >> 2] = f522;
    f522 = Math_fround(f474 + f546);
    f523 = Math_fround(f474 + f547);
    f524 = Math_fround(f474 + f548);
    f525 = Math_fround(f468 + f549);
    f526 = Math_fround(f468 + f550);
    f527 = Math_fround(f468 + f551);
    f528 = Math_fround(f468 + f552);
    f529 = Math_fround(f470 + f553);
    f530 = Math_fround(f470 + f554);
    f531 = Math_fround(f470 + f555);
    f532 = Math_fround(f470 + f556);
    HEAPF32[i280 >> 2] = Math_fround(f474 + f545);
    HEAPF32[i120 >> 2] = f522;
    HEAPF32[i137 >> 2] = f523;
    HEAPF32[i154 >> 2] = f524;
    HEAPF32[i281 >> 2] = f525;
    HEAPF32[i115 >> 2] = f526;
    HEAPF32[i132 >> 2] = f527;
    HEAPF32[i149 >> 2] = f528;
    HEAPF32[i282 >> 2] = f529;
    HEAPF32[i110 >> 2] = f530;
    HEAPF32[i127 >> 2] = f531;
    HEAPF32[i144 >> 2] = f532;
    f534 = Math_fround(f474 - f534);
    f535 = Math_fround(f474 - f535);
    f536 = Math_fround(f474 - f536);
    f537 = Math_fround(f468 - f537);
    f538 = Math_fround(f468 - f538);
    f539 = Math_fround(f468 - f539);
    f540 = Math_fround(f468 - f540);
    f541 = Math_fround(f470 - f541);
    f542 = Math_fround(f470 - f542);
    f543 = Math_fround(f470 - f543);
    f544 = Math_fround(f470 - f544);
    HEAPF32[i283 >> 2] = Math_fround(f474 - f533);
    HEAPF32[i119 >> 2] = f534;
    HEAPF32[i136 >> 2] = f535;
    HEAPF32[i153 >> 2] = f536;
    HEAPF32[i284 >> 2] = f537;
    HEAPF32[i114 >> 2] = f538;
    HEAPF32[i131 >> 2] = f539;
    HEAPF32[i148 >> 2] = f540;
    HEAPF32[i285 >> 2] = f541;
    HEAPF32[i109 >> 2] = f542;
    HEAPF32[i126 >> 2] = f543;
    HEAPF32[i143 >> 2] = f544;
    f546 = Math_fround(f474 - f546);
    f547 = Math_fround(f474 - f547);
    f548 = Math_fround(f474 - f548);
    f549 = Math_fround(f468 - f549);
    f550 = Math_fround(f468 - f550);
    f551 = Math_fround(f468 - f551);
    f552 = Math_fround(f468 - f552);
    f553 = Math_fround(f470 - f553);
    f554 = Math_fround(f470 - f554);
    f555 = Math_fround(f470 - f555);
    f556 = Math_fround(f470 - f556);
    HEAPF32[i286 >> 2] = Math_fround(f474 - f545);
    HEAPF32[i118 >> 2] = f546;
    HEAPF32[i135 >> 2] = f547;
    HEAPF32[i152 >> 2] = f548;
    HEAPF32[i287 >> 2] = f549;
    HEAPF32[i113 >> 2] = f550;
    HEAPF32[i130 >> 2] = f551;
    HEAPF32[i147 >> 2] = f552;
    HEAPF32[i288 >> 2] = f553;
    HEAPF32[i108 >> 2] = f554;
    HEAPF32[i125 >> 2] = f555;
    HEAPF32[i142 >> 2] = f556;
    do if (i159) {
     i4 = HEAP32[i185 >> 2] | 0;
     i5 = HEAP32[i504 >> 2] | 0;
     if (!i4) {
      i2 = 0;
      i3 = i1;
      while (1) {
       i74 = i5 + (i2 + i76 << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i499 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i500 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i241 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i280 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i253 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i265 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i74 >> 2];
       i74 = i497 + (HEAP32[i496 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     } else {
      i2 = 0;
      i3 = i1;
      while (1) {
       i74 = i5 + (HEAP32[i4 + (i2 + i76 << 3) >> 2] << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i499 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i500 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i241 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i280 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i253 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i74 >> 2];
       i73 = i497 + (HEAP32[i496 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i265 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i74 >> 2];
       i74 = i497 + (HEAP32[i496 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     }
    } else {
     f544 = Math_fround(HEAPF32[i241 >> 2]);
     f544 = Math_fround(f544 - Math_fround(HEAPF32[i499 >> 2]));
     f546 = Math_fround(HEAPF32[i242 >> 2]);
     f546 = Math_fround(f546 - Math_fround(HEAPF32[i230 >> 2]));
     f547 = Math_fround(HEAPF32[i243 >> 2]);
     f547 = Math_fround(f547 - Math_fround(HEAPF32[i231 >> 2]));
     f548 = Math_fround(HEAPF32[i244 >> 2]);
     f548 = Math_fround(f548 - Math_fround(HEAPF32[i232 >> 2]));
     f549 = Math_fround(HEAPF32[i245 >> 2]);
     f549 = Math_fround(f549 - Math_fround(HEAPF32[i233 >> 2]));
     f556 = Math_fround(HEAPF32[i246 >> 2]);
     f556 = Math_fround(f556 - Math_fround(HEAPF32[i234 >> 2]));
     f555 = Math_fround(HEAPF32[i247 >> 2]);
     f555 = Math_fround(f555 - Math_fround(HEAPF32[i235 >> 2]));
     f554 = Math_fround(HEAPF32[i248 >> 2]);
     f554 = Math_fround(f554 - Math_fround(HEAPF32[i236 >> 2]));
     f553 = Math_fround(HEAPF32[i249 >> 2]);
     f553 = Math_fround(f553 - Math_fround(HEAPF32[i237 >> 2]));
     f541 = Math_fround(HEAPF32[i250 >> 2]);
     f541 = Math_fround(f541 - Math_fround(HEAPF32[i238 >> 2]));
     f542 = Math_fround(HEAPF32[i251 >> 2]);
     f542 = Math_fround(f542 - Math_fround(HEAPF32[i239 >> 2]));
     f543 = Math_fround(HEAPF32[i252 >> 2]);
     f543 = Math_fround(f543 - Math_fround(HEAPF32[i240 >> 2]));
     f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f544 * f544) + Math_fround(f549 * f549)) + Math_fround(f553 * f553)))));
     f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f556 * f556)) + Math_fround(f541 * f541)))));
     f551 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f547 * f547) + Math_fround(f555 * f555)) + Math_fround(f542 * f542)))));
     f550 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f554 * f554)) + Math_fround(f543 * f543)))));
     f546 = Math_fround(f546 * f552);
     f547 = Math_fround(f547 * f551);
     f548 = Math_fround(f548 * f550);
     f549 = Math_fround(f549 * f545);
     f556 = Math_fround(f556 * f552);
     f555 = Math_fround(f555 * f551);
     f554 = Math_fround(f554 * f550);
     f553 = Math_fround(f553 * f545);
     f552 = Math_fround(f541 * f552);
     f551 = Math_fround(f542 * f551);
     f550 = Math_fround(f543 * f550);
     HEAPF32[i494 >> 2] = Math_fround(f544 * f545);
     HEAPF32[i122 >> 2] = f546;
     HEAPF32[i139 >> 2] = f547;
     HEAPF32[i156 >> 2] = f548;
     HEAPF32[i289 >> 2] = f549;
     HEAPF32[i117 >> 2] = f556;
     HEAPF32[i134 >> 2] = f555;
     HEAPF32[i151 >> 2] = f554;
     HEAPF32[i290 >> 2] = f553;
     HEAPF32[i112 >> 2] = f552;
     HEAPF32[i129 >> 2] = f551;
     HEAPF32[i146 >> 2] = f550;
     f550 = Math_fround(f28 * Math_fround(2.0));
     f551 = Math_fround(f29 * Math_fround(2.0));
     f552 = Math_fround(f30 * Math_fround(2.0));
     f553 = Math_fround(f31 * Math_fround(2.0));
     f554 = Math_fround(f32 * Math_fround(2.0));
     f555 = Math_fround(f33 * Math_fround(2.0));
     f556 = Math_fround(f34 * Math_fround(2.0));
     HEAPF32[i495 >> 2] = Math_fround(f27 * Math_fround(2.0));
     HEAPF32[i124 >> 2] = f550;
     HEAPF32[i141 >> 2] = f551;
     HEAPF32[i158 >> 2] = f552;
     HEAPF32[i291 >> 2] = f553;
     HEAPF32[i123 >> 2] = f554;
     HEAPF32[i140 >> 2] = f555;
     HEAPF32[i157 >> 2] = f556;
     HEAP32[i107 >> 2] = 0;
     HEAP32[i107 + 4 >> 2] = 0;
     HEAP32[i107 + 8 >> 2] = 0;
     HEAP32[i107 + 12 >> 2] = 0;
     if (i292) {
      f536 = Math_fround(HEAPF32[i487 >> 2]);
      f554 = Math_fround(f439 * f536);
      f538 = Math_fround(HEAPF32[i178 >> 2]);
      f545 = Math_fround(f439 * f538);
      f540 = Math_fround(HEAPF32[i177 >> 2]);
      f553 = Math_fround(f439 * f540);
      f542 = Math_fround(HEAPF32[i176 >> 2]);
      f548 = Math_fround(f439 * f542);
      f537 = Math_fround(HEAPF32[i195 >> 2]);
      f544 = Math_fround(f442 * f537);
      f539 = Math_fround(HEAPF32[i181 >> 2]);
      f550 = Math_fround(f442 * f539);
      f541 = Math_fround(HEAPF32[i180 >> 2]);
      f549 = Math_fround(f442 * f541);
      f543 = Math_fround(HEAPF32[i179 >> 2]);
      f544 = Math_fround(f554 + f544);
      f550 = Math_fround(f545 + f550);
      f549 = Math_fround(f553 + f549);
      f548 = Math_fround(f548 + Math_fround(f442 * f543));
      f553 = Math_fround(HEAPF32[i196 >> 2]);
      f545 = Math_fround(f445 * f553);
      f554 = Math_fround(HEAPF32[i184 >> 2]);
      f546 = Math_fround(f445 * f554);
      f555 = Math_fround(HEAPF32[i183 >> 2]);
      f547 = Math_fround(f445 * f555);
      f556 = Math_fround(HEAPF32[i182 >> 2]);
      f546 = Math_fround(f550 + f546);
      f547 = Math_fround(f549 + f547);
      f548 = Math_fround(f548 + Math_fround(f445 * f556));
      f549 = Math_fround(Math_fround(Math_fround(f440 * f536) + Math_fround(f443 * f537)) + Math_fround(f446 * f553));
      f550 = Math_fround(Math_fround(Math_fround(f440 * f538) + Math_fround(f443 * f539)) + Math_fround(f446 * f554));
      f551 = Math_fround(Math_fround(Math_fround(f440 * f540) + Math_fround(f443 * f541)) + Math_fround(f446 * f555));
      f552 = Math_fround(Math_fround(Math_fround(f440 * f542) + Math_fround(f443 * f543)) + Math_fround(f446 * f556));
      f553 = Math_fround(Math_fround(Math_fround(f441 * f536) + Math_fround(f444 * f537)) + Math_fround(f447 * f553));
      f554 = Math_fround(Math_fround(Math_fround(f441 * f538) + Math_fround(f444 * f539)) + Math_fround(f447 * f554));
      f555 = Math_fround(Math_fround(Math_fround(f441 * f540) + Math_fround(f444 * f541)) + Math_fround(f447 * f555));
      f556 = Math_fround(Math_fround(Math_fround(f441 * f542) + Math_fround(f444 * f543)) + Math_fround(f447 * f556));
      HEAPF32[i344 >> 2] = Math_fround(f544 + f545);
      HEAPF32[i293 >> 2] = f546;
      HEAPF32[i294 >> 2] = f547;
      HEAPF32[i295 >> 2] = f548;
      HEAPF32[i296 >> 2] = f549;
      HEAPF32[i297 >> 2] = f550;
      HEAPF32[i298 >> 2] = f551;
      HEAPF32[i299 >> 2] = f552;
      HEAPF32[i300 >> 2] = f553;
      HEAPF32[i301 >> 2] = f554;
      HEAPF32[i302 >> 2] = f555;
      HEAPF32[i303 >> 2] = f556;
     }
     if (i304) {
      i68 = HEAP32[i491 >> 2] | 0;
      i71 = i68 + 1068538453 | 0;
      i72 = HEAP32[i210 >> 2] | 0;
      i70 = i72 + 1068538453 | 0;
      i65 = HEAP32[i211 >> 2] | 0;
      i64 = i65 + 1068538453 | 0;
      i63 = HEAP32[i212 >> 2] | 0;
      i67 = i63 + 1068538453 | 0;
      i73 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i66 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i74 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i71 = i71 << 11 ^ i71;
      i70 = i70 << 11 ^ i70;
      i64 = i64 << 11 ^ i64;
      i67 = i67 << 11 ^ i67;
      f554 = Math_fround(Math_fround((i66 ^ i70 ^ i70 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i74 ^ i64 ^ i64 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i69 ^ i67 ^ i67 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i501 >> 2] = Math_fround(Math_fround((i73 ^ i71 ^ i71 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i305 >> 2] = f554;
      HEAPF32[i306 >> 2] = f555;
      HEAPF32[i307 >> 2] = f556;
      i68 = i68 + 1068538454 | 0;
      i72 = i72 + 1068538454 | 0;
      i65 = i65 + 1068538454 | 0;
      i63 = i63 + 1068538454 | 0;
      i73 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i71 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i72 = i72 << 11 ^ i72;
      i65 = i65 << 11 ^ i65;
      i63 = i63 << 11 ^ i63;
      f556 = Math_fround(Math_fround((i71 ^ i72 ^ i72 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i69 ^ i65 ^ i65 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f554 = Math_fround(Math_fround((i67 ^ i63 ^ i63 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i308 >> 2] = Math_fround(Math_fround((i73 ^ i68 ^ i68 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i309 >> 2] = f556;
      HEAPF32[i310 >> 2] = f555;
      HEAPF32[i311 >> 2] = f554;
      i73 = HEAP32[i491 >> 2] | 0;
      i68 = i73 + 1068538455 | 0;
      i67 = HEAP32[i210 >> 2] | 0;
      i63 = i67 + 1068538455 | 0;
      i69 = HEAP32[i211 >> 2] | 0;
      i65 = i69 + 1068538455 | 0;
      i71 = HEAP32[i212 >> 2] | 0;
      i72 = i71 + 1068538455 | 0;
      i74 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i64 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
      i66 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i63 = i63 << 11 ^ i63;
      i65 = i65 << 11 ^ i65;
      i72 = i72 << 11 ^ i72;
      f554 = Math_fround(Math_fround((i64 ^ i63 ^ i63 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i66 ^ i65 ^ i65 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i70 ^ i72 ^ i72 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i312 >> 2] = Math_fround(Math_fround((i74 ^ i68 ^ i68 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i313 >> 2] = f554;
      HEAPF32[i314 >> 2] = f555;
      HEAPF32[i315 >> 2] = f556;
      f556 = Math_fround(Math_fround(HEAPF32[i490 >> 2]) * Math_fround(1.0e5));
      f555 = Math_fround(Math_fround(HEAPF32[i206 >> 2]) * Math_fround(1.0e5));
      f554 = Math_fround(Math_fround(HEAPF32[i207 >> 2]) * Math_fround(1.0e5));
      i73 = i73 + 1068538453 + ~~f556 | 0;
      i67 = i67 + 1068538453 + ~~f555 | 0;
      i69 = i69 + 1068538453 + ~~f554 | 0;
      i71 = i71 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i208 >> 2]) * Math_fround(1.0e5)) | 0;
      i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i68 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i73 = i73 << 11 ^ i73;
      i67 = i67 << 11 ^ i67;
      i69 = i69 << 11 ^ i69;
      i71 = i71 << 11 ^ i71;
      f554 = Math_fround(Math_fround((i68 ^ i67 ^ i67 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i316 >> 2] = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i317 >> 2] = f554;
      HEAPF32[i318 >> 2] = f555;
      HEAPF32[i319 >> 2] = f556;
     }
     i67 = HEAP32[i185 >> 2] | 0;
     i68 = (i67 | 0) == 0;
     i69 = HEAP32[i83 >> 2] | 0;
     i70 = HEAP32[i85 >> 2] | 0;
     i71 = HEAP32[i205 >> 2] | 0;
     i72 = HEAP32[i86 >> 2] | 0;
     i73 = HEAP32[i188 >> 2] | 0;
     i74 = HEAP32[i504 >> 2] | 0;
     i66 = 0;
     do {
      i2 = i66 + i76 | 0;
      if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
      i5 = i344 + (i66 << 2) | 0;
      i6 = i327 + (i66 << 2) | 0;
      i7 = i337 + (i66 << 2) | 0;
      i8 = i501 + (i66 << 2) | 0;
      i12 = i308 + (i66 << 2) | 0;
      i13 = i312 + (i66 << 2) | 0;
      i14 = i316 + (i66 << 2) | 0;
      i15 = i494 + (i66 << 2) | 0;
      i16 = i80 + (i66 << 2) | 0;
      i17 = i81 + (i66 << 2) | 0;
      i18 = i69 + (i2 << 4) | 0;
      i19 = i70 + (i2 << 4) | 0;
      i20 = i71 + (i2 << 2) | 0;
      i21 = i72 + (i2 << 2) | 0;
      i59 = i73 + (i2 << 2) | 0;
      i60 = i495 + (i66 << 2) | 0;
      i61 = i87 + (i66 << 2) | 0;
      i62 = i88 + (i66 << 2) | 0;
      i63 = i493 + (i66 << 2) | 0;
      i64 = i89 + (i66 << 2) | 0;
      i65 = i90 + (i66 << 2) | 0;
      i4 = i74 + (i2 << 2) | 0;
      i3 = 0;
      i2 = i1;
      while (1) {
       i1 = i499 + (i3 * 48 | 0) | 0;
       HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
       i1 = i2 + 12 | 0;
       if (!i320) {
        i557 = i500 + (i3 * 48 | 0) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i2 + 16 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 20 >> 2] = HEAP32[i557 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 24 | 0;
       }
       if (!i321) {
        HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
        i1 = i1 + 4 | 0;
       }
       if (!i322) {
        i557 = i497 + (HEAP32[i496 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i323) {
        i557 = i498 + (HEAP32[i496 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 32 + (i66 << 2) >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 48 + (i66 << 2) >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i324) {
        f556 = Math_fround(i3 | 0);
        HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
        HEAPF32[i1 + 12 >> 2] = f556;
        i1 = i1 + 16 | 0;
       }
       if (!i325) {
        HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i326) {
        i557 = HEAP32[i59 >> 2] | 0;
        HEAP32[i1 >> 2] = i557;
        HEAP32[i1 + 4 >> 2] = i557;
        HEAP32[i1 + 8 >> 2] = i557;
        i1 = i1 + 12 | 0;
       }
       if (i292) {
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i338) {
        f556 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(.00999999977));
        i557 = HEAP32[i21 >> 2] | 0;
        HEAPF32[i1 >> 2] = f556;
        HEAP32[i1 + 4 >> 2] = i557;
        i1 = i1 + 8 | 0;
       }
       if (!i339) {
        i557 = (HEAP32[i84 >> 2] & 2147483647 | 0) == 0 ? i505 : i19;
        HEAP32[i1 >> 2] = HEAP32[i557 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i340) {
        i557 = (HEAP32[i82 >> 2] & 2147483647 | 0) == 0 ? i505 : i18;
        HEAP32[i1 >> 2] = HEAP32[i557 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (i304) {
        HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i14 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i79) {
        HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i17 >> 2];
        HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
        i1 = i1 + 16 | 0;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == 4) break; else i2 = i1;
      }
      i66 = i66 + 1 | 0;
     } while ((i66 | 0) != 4);
    } while (0);
    i76 = i76 + 4 | 0;
   } while (i76 >>> 0 < i160 >>> 0);
  }
  STACKTOP = i508;
  return;
 } else {
  i14 = i351;
  i13 = i14 + 112 | 0;
  do {
   HEAP32[i14 >> 2] = 0;
   i14 = i14 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  switch (i3 | 0) {
  case 1:
   {
    i14 = i6;
    i1 = gb + 1162292 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  case 2:
   {
    i14 = i6;
    i1 = i7 + 256 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  default:
   {
    i14 = i6;
    i1 = i7 + 64 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
   }
  }
  __ZN10Matrix3x3fC2ERK10Matrix4x4f(i8, i6);
  f555 = Math_fround(HEAPF32[i5 >> 2]);
  f546 = Math_fround(HEAPF32[i7 + 428 >> 2]);
  f330 = Math_fround(HEAPF32[i7 + 424 >> 2]);
  f328 = Math_fround(HEAPF32[i8 >> 2]);
  i337 = i8 + 4 | 0;
  f554 = Math_fround(HEAPF32[i337 >> 2]);
  i338 = i8 + 8 | 0;
  f552 = Math_fround(HEAPF32[i338 >> 2]);
  i339 = i8 + 12 | 0;
  f332 = Math_fround(HEAPF32[i339 >> 2]);
  i340 = i8 + 16 | 0;
  f545 = Math_fround(HEAPF32[i340 >> 2]);
  i344 = i8 + 20 | 0;
  f550 = Math_fround(HEAPF32[i344 >> 2]);
  i557 = i8 + 24 | 0;
  f553 = Math_fround(HEAPF32[i557 >> 2]);
  i160 = i8 + 28 | 0;
  f547 = Math_fround(HEAPF32[i160 >> 2]);
  i159 = i8 + 32 | 0;
  f336 = Math_fround(HEAPF32[i159 >> 2]);
  f331 = Math_fround(f554 * Math_fround(0.0));
  f556 = Math_fround(f552 * Math_fround(0.0));
  f333 = Math_fround(f545 * Math_fround(0.0));
  f551 = Math_fround(f550 * Math_fround(0.0));
  f335 = Math_fround(Math_fround(Math_fround(f555 * f332) + f333) + f551);
  f329 = Math_fround(f547 * Math_fround(0.0));
  f549 = Math_fround(f336 * Math_fround(0.0));
  f334 = Math_fround(Math_fround(Math_fround(f555 * f553) + f329) + f549);
  f548 = Math_fround(f328 * Math_fround(0.0));
  f554 = Math_fround(Math_fround(f548 + Math_fround(f546 * f554)) + f556);
  f332 = Math_fround(f332 * Math_fround(0.0));
  f551 = Math_fround(Math_fround(f332 + Math_fround(f546 * f545)) + f551);
  f553 = Math_fround(f553 * Math_fround(0.0));
  f549 = Math_fround(Math_fround(f553 + Math_fround(f546 * f547)) + f549);
  f552 = Math_fround(Math_fround(f548 + f331) + Math_fround(f330 * f552));
  f550 = Math_fround(Math_fround(f332 + f333) + Math_fround(f330 * f550));
  f336 = Math_fround(Math_fround(f553 + f329) + Math_fround(f330 * f336));
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f555 * f328) + f331) + f556);
  HEAPF32[i337 >> 2] = f554;
  HEAPF32[i338 >> 2] = f552;
  HEAPF32[i339 >> 2] = f335;
  HEAPF32[i340 >> 2] = f551;
  HEAPF32[i344 >> 2] = f550;
  HEAPF32[i557 >> 2] = f334;
  HEAPF32[i160 >> 2] = f549;
  HEAPF32[i159 >> 2] = f336;
  i327 = i503 + 340 | 0;
  f336 = Math_fround(-Math_fround(HEAPF32[HEAP32[i327 >> 2] >> 2]));
  HEAPF32[i506 >> 2] = Math_fround(0.0);
  HEAPF32[i506 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i506 + 8 >> 2] = f336;
  __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f(i506, i505);
  f336 = Math_fround(HEAPF32[i505 >> 2]);
  f549 = Math_fround(HEAPF32[i505 + 4 >> 2]);
  f334 = Math_fround(HEAPF32[i505 + 8 >> 2]);
  f550 = Math_fround(HEAPF32[i505 + 12 >> 2]);
  f551 = Math_fround(HEAPF32[i505 + 16 >> 2]);
  f335 = Math_fround(HEAPF32[i505 + 20 >> 2]);
  f552 = Math_fround(HEAPF32[i505 + 24 >> 2]);
  f554 = Math_fround(HEAPF32[i505 + 28 >> 2]);
  f556 = Math_fround(HEAPF32[i505 + 32 >> 2]);
  f331 = Math_fround(HEAPF32[i8 >> 2]);
  f328 = Math_fround(f336 * f331);
  f555 = Math_fround(HEAPF32[i339 >> 2]);
  f328 = Math_fround(f328 + Math_fround(f549 * f555));
  f330 = Math_fround(HEAPF32[i557 >> 2]);
  f328 = Math_fround(f328 + Math_fround(f334 * f330));
  f329 = Math_fround(Math_fround(Math_fround(f550 * f331) + Math_fround(f551 * f555)) + Math_fround(f335 * f330));
  f330 = Math_fround(Math_fround(Math_fround(f552 * f331) + Math_fround(f554 * f555)) + Math_fround(f556 * f330));
  f555 = Math_fround(HEAPF32[i337 >> 2]);
  f331 = Math_fround(f336 * f555);
  f553 = Math_fround(HEAPF32[i340 >> 2]);
  f331 = Math_fround(f331 + Math_fround(f549 * f553));
  f333 = Math_fround(HEAPF32[i160 >> 2]);
  f331 = Math_fround(f331 + Math_fround(f334 * f333));
  f332 = Math_fround(Math_fround(Math_fround(f550 * f555) + Math_fround(f551 * f553)) + Math_fround(f335 * f333));
  f333 = Math_fround(Math_fround(Math_fround(f552 * f555) + Math_fround(f554 * f553)) + Math_fround(f556 * f333));
  f553 = Math_fround(HEAPF32[i338 >> 2]);
  f336 = Math_fround(f336 * f553);
  f555 = Math_fround(HEAPF32[i344 >> 2]);
  f549 = Math_fround(f336 + Math_fround(f549 * f555));
  f336 = Math_fround(HEAPF32[i159 >> 2]);
  f334 = Math_fround(f549 + Math_fround(f334 * f336));
  f335 = Math_fround(Math_fround(Math_fround(f550 * f553) + Math_fround(f551 * f555)) + Math_fround(f335 * f336));
  f336 = Math_fround(Math_fround(Math_fround(f552 * f553) + Math_fround(f554 * f555)) + Math_fround(f556 * f336));
  HEAPF32[i8 >> 2] = f328;
  HEAPF32[i337 >> 2] = f331;
  HEAPF32[i338 >> 2] = f334;
  HEAPF32[i339 >> 2] = f329;
  HEAPF32[i340 >> 2] = f332;
  HEAPF32[i344 >> 2] = f335;
  HEAPF32[i557 >> 2] = f330;
  HEAPF32[i160 >> 2] = f333;
  HEAPF32[i159 >> 2] = f336;
  i159 = (i2 | 0) == 27;
  HEAP32[i505 >> 2] = 0;
  HEAP32[i505 + 4 >> 2] = 0;
  HEAP32[i505 + 8 >> 2] = 0;
  HEAP32[i505 + 12 >> 2] = 0;
  i160 = HEAP32[i503 + 12 >> 2] | 0;
  if (i160 | 0) {
   i161 = i506 + 12 | 0;
   i162 = i506 + 8 | 0;
   i163 = i506 + 4 | 0;
   i164 = i506 + 16 | 0;
   i165 = i506 + 28 | 0;
   i166 = i506 + 24 | 0;
   i167 = i506 + 20 | 0;
   i168 = i506 + 32 | 0;
   i169 = i506 + 44 | 0;
   i170 = i506 + 40 | 0;
   i171 = i506 + 36 | 0;
   i172 = i507 + 12 | 0;
   i173 = i507 + 8 | 0;
   i174 = i507 + 4 | 0;
   i175 = i507 + 28 | 0;
   i176 = i507 + 24 | 0;
   i177 = i507 + 20 | 0;
   i178 = i507 + 44 | 0;
   i179 = i507 + 40 | 0;
   i180 = i507 + 36 | 0;
   i181 = i504 + 20 | 0;
   i182 = i503 + 20 | 0;
   i183 = i503 + 40 | 0;
   i184 = i503 + 60 | 0;
   i185 = i503 + 80 | 0;
   i186 = i503 + 100 | 0;
   i187 = i503 + 120 | 0;
   i188 = i503 + 140 | 0;
   i189 = i503 + 160 | 0;
   i190 = i507 + 16 | 0;
   i191 = i507 + 32 | 0;
   i192 = i504 + 4 | 0;
   i193 = i487 + 4 | 0;
   i194 = i487 + 8 | 0;
   i195 = i487 + 12 | 0;
   i196 = i504 + 8 | 0;
   i197 = i488 + 4 | 0;
   i198 = i488 + 8 | 0;
   i199 = i488 + 12 | 0;
   i200 = i503 + 520 | 0;
   i201 = i489 + 4 | 0;
   i202 = i489 + 8 | 0;
   i203 = i489 + 12 | 0;
   i204 = i503 + 500 | 0;
   i205 = i490 + 4 | 0;
   i206 = i490 + 8 | 0;
   i207 = i490 + 12 | 0;
   i208 = i504 + 16 | 0;
   i209 = i491 + 4 | 0;
   i210 = i491 + 8 | 0;
   i211 = i491 + 12 | 0;
   i212 = i506 + 16 | 0;
   i213 = i506 + 32 | 0;
   i214 = i492 + 4 | 0;
   i215 = i492 + 8 | 0;
   i216 = i492 + 12 | 0;
   i217 = i492 + 16 | 0;
   i218 = i492 + 20 | 0;
   i219 = i492 + 24 | 0;
   i220 = i492 + 28 | 0;
   i221 = i492 + 32 | 0;
   i222 = i492 + 36 | 0;
   i223 = i492 + 40 | 0;
   i224 = i492 + 44 | 0;
   i225 = i499 + 4 | 0;
   i226 = i499 + 8 | 0;
   i227 = i499 + 12 | 0;
   i228 = i499 + 16 | 0;
   i229 = i499 + 20 | 0;
   i230 = i499 + 24 | 0;
   i231 = i499 + 28 | 0;
   i232 = i499 + 32 | 0;
   i233 = i499 + 36 | 0;
   i234 = i499 + 40 | 0;
   i235 = i499 + 44 | 0;
   i236 = i499 + 48 | 0;
   i237 = i499 + 52 | 0;
   i238 = i499 + 56 | 0;
   i239 = i499 + 60 | 0;
   i240 = i499 + 64 | 0;
   i241 = i499 + 68 | 0;
   i242 = i499 + 72 | 0;
   i243 = i499 + 76 | 0;
   i244 = i499 + 80 | 0;
   i245 = i499 + 84 | 0;
   i246 = i499 + 88 | 0;
   i247 = i499 + 92 | 0;
   i248 = i499 + 96 | 0;
   i249 = i499 + 100 | 0;
   i250 = i499 + 104 | 0;
   i251 = i499 + 108 | 0;
   i252 = i499 + 112 | 0;
   i253 = i499 + 116 | 0;
   i254 = i499 + 120 | 0;
   i255 = i499 + 124 | 0;
   i256 = i499 + 128 | 0;
   i257 = i499 + 132 | 0;
   i258 = i499 + 136 | 0;
   i259 = i499 + 140 | 0;
   i260 = i499 + 144 | 0;
   i261 = i499 + 148 | 0;
   i262 = i499 + 152 | 0;
   i263 = i499 + 156 | 0;
   i264 = i499 + 160 | 0;
   i265 = i499 + 164 | 0;
   i266 = i499 + 168 | 0;
   i267 = i499 + 172 | 0;
   i268 = i499 + 176 | 0;
   i269 = i499 + 180 | 0;
   i270 = i499 + 184 | 0;
   i271 = i499 + 188 | 0;
   i272 = (i2 & 48 | 0) == 0;
   i121 = i500 + 4 | 0;
   i138 = i500 + 8 | 0;
   i155 = i500 + 12 | 0;
   i273 = i500 + 16 | 0;
   i116 = i500 + 20 | 0;
   i133 = i500 + 24 | 0;
   i150 = i500 + 28 | 0;
   i274 = i500 + 32 | 0;
   i111 = i500 + 36 | 0;
   i128 = i500 + 40 | 0;
   i145 = i500 + 44 | 0;
   i275 = i500 + 48 | 0;
   i120 = i500 + 52 | 0;
   i137 = i500 + 56 | 0;
   i154 = i500 + 60 | 0;
   i276 = i500 + 64 | 0;
   i115 = i500 + 68 | 0;
   i132 = i500 + 72 | 0;
   i149 = i500 + 76 | 0;
   i277 = i500 + 80 | 0;
   i110 = i500 + 84 | 0;
   i127 = i500 + 88 | 0;
   i144 = i500 + 92 | 0;
   i278 = i500 + 96 | 0;
   i119 = i500 + 100 | 0;
   i136 = i500 + 104 | 0;
   i153 = i500 + 108 | 0;
   i279 = i500 + 112 | 0;
   i114 = i500 + 116 | 0;
   i131 = i500 + 120 | 0;
   i148 = i500 + 124 | 0;
   i280 = i500 + 128 | 0;
   i109 = i500 + 132 | 0;
   i126 = i500 + 136 | 0;
   i143 = i500 + 140 | 0;
   i281 = i500 + 144 | 0;
   i118 = i500 + 148 | 0;
   i135 = i500 + 152 | 0;
   i152 = i500 + 156 | 0;
   i282 = i500 + 160 | 0;
   i113 = i500 + 164 | 0;
   i130 = i500 + 168 | 0;
   i147 = i500 + 172 | 0;
   i283 = i500 + 176 | 0;
   i108 = i500 + 180 | 0;
   i125 = i500 + 184 | 0;
   i142 = i500 + 188 | 0;
   i122 = i493 + 4 | 0;
   i139 = i493 + 8 | 0;
   i156 = i493 + 12 | 0;
   i284 = i493 + 16 | 0;
   i117 = i493 + 20 | 0;
   i134 = i493 + 24 | 0;
   i151 = i493 + 28 | 0;
   i285 = i493 + 32 | 0;
   i112 = i493 + 36 | 0;
   i129 = i493 + 40 | 0;
   i146 = i493 + 44 | 0;
   i124 = i494 + 4 | 0;
   i141 = i494 + 8 | 0;
   i158 = i494 + 12 | 0;
   i286 = i494 + 16 | 0;
   i123 = i494 + 20 | 0;
   i140 = i494 + 24 | 0;
   i157 = i494 + 28 | 0;
   i107 = i494 + 32 | 0;
   i287 = (i2 & 512 | 0) != 0;
   i288 = i495 + 4 | 0;
   i289 = i495 + 8 | 0;
   i290 = i495 + 12 | 0;
   i291 = i495 + 16 | 0;
   i292 = i495 + 20 | 0;
   i293 = i495 + 24 | 0;
   i294 = i495 + 28 | 0;
   i295 = i495 + 32 | 0;
   i296 = i495 + 36 | 0;
   i297 = i495 + 40 | 0;
   i298 = i495 + 44 | 0;
   i299 = (i2 & 8192 | 0) != 0;
   i300 = i501 + 4 | 0;
   i301 = i501 + 8 | 0;
   i302 = i501 + 12 | 0;
   i303 = i501 + 16 | 0;
   i304 = i501 + 20 | 0;
   i305 = i501 + 24 | 0;
   i306 = i501 + 28 | 0;
   i307 = i501 + 32 | 0;
   i308 = i501 + 36 | 0;
   i309 = i501 + 40 | 0;
   i310 = i501 + 44 | 0;
   i311 = i501 + 48 | 0;
   i312 = i501 + 52 | 0;
   i313 = i501 + 56 | 0;
   i314 = i501 + 60 | 0;
   i315 = (i2 & 2 | 0) == 0;
   i316 = (i2 & 8 | 0) == 0;
   i317 = (i2 & 16 | 0) == 0;
   i318 = (i2 & 32 | 0) == 0;
   i319 = (i2 & 64 | 0) == 0;
   i320 = (i2 & 128 | 0) == 0;
   i321 = (i2 & 256 | 0) == 0;
   i322 = i495 + 16 | 0;
   i323 = i495 + 32 | 0;
   i324 = (i2 & 1024 | 0) == 0;
   i325 = (i2 & 2048 | 0) == 0;
   i326 = (i2 & 4096 | 0) == 0;
   i78 = (i2 & 4 | 0) == 0;
   i79 = i493 + 16 | 0;
   i80 = i493 + 32 | 0;
   i81 = i503 + 864 | 0;
   i82 = i503 + 848 | 0;
   i83 = i503 + 844 | 0;
   i84 = i503 + 828 | 0;
   i85 = i503 + 540 | 0;
   i86 = i494 + 16 | 0;
   i87 = i494 + 32 | 0;
   i88 = i492 + 16 | 0;
   i89 = i492 + 32 | 0;
   i90 = i499 + 16 | 0;
   i91 = i499 + 32 | 0;
   i92 = i500 + 16 | 0;
   i93 = i500 + 32 | 0;
   i94 = i236 + 16 | 0;
   i95 = i236 + 32 | 0;
   i96 = i275 + 16 | 0;
   i97 = i275 + 32 | 0;
   i98 = i248 + 16 | 0;
   i99 = i248 + 32 | 0;
   i100 = i278 + 16 | 0;
   i101 = i278 + 32 | 0;
   i102 = i260 + 16 | 0;
   i103 = i260 + 32 | 0;
   i104 = i281 + 16 | 0;
   i105 = i281 + 32 | 0;
   i106 = i12 + 564 | 0;
   i77 = i12 + 568 | 0;
   i76 = 0;
   i1 = i15;
   do {
    i14 = i506;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i507;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    HEAP32[i487 >> 2] = 0;
    HEAP32[i487 + 4 >> 2] = 0;
    HEAP32[i487 + 8 >> 2] = 0;
    HEAP32[i487 + 12 >> 2] = 0;
    HEAP32[i488 >> 2] = 0;
    HEAP32[i488 + 4 >> 2] = 0;
    HEAP32[i488 + 8 >> 2] = 0;
    HEAP32[i488 + 12 >> 2] = 0;
    HEAP32[i489 >> 2] = 0;
    HEAP32[i489 + 4 >> 2] = 0;
    HEAP32[i489 + 8 >> 2] = 0;
    HEAP32[i489 + 12 >> 2] = 0;
    HEAP32[i490 >> 2] = 0;
    HEAP32[i490 + 4 >> 2] = 0;
    HEAP32[i490 + 8 >> 2] = 0;
    HEAP32[i490 + 12 >> 2] = 0;
    HEAP32[i491 >> 2] = 0;
    HEAP32[i491 + 4 >> 2] = 0;
    HEAP32[i491 + 8 >> 2] = 0;
    HEAP32[i491 + 12 >> 2] = 0;
    i19 = HEAP32[i181 >> 2] | 0;
    i20 = HEAP32[i503 >> 2] | 0;
    if (!i19) {
     i69 = i20 + (i76 << 2) | 0;
     i70 = HEAP32[i69 + 4 >> 2] | 0;
     i71 = HEAP32[i69 + 8 >> 2] | 0;
     i72 = HEAP32[i69 + 12 >> 2] | 0;
     i338 = (HEAP32[i182 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i338 >> 2] | 0;
     i74 = HEAP32[i338 + 4 >> 2] | 0;
     i337 = HEAP32[i338 + 8 >> 2] | 0;
     i338 = HEAP32[i338 + 12 >> 2] | 0;
     i557 = (HEAP32[i183 >> 2] | 0) + (i76 << 2) | 0;
     i339 = HEAP32[i557 >> 2] | 0;
     i340 = HEAP32[i557 + 4 >> 2] | 0;
     i344 = HEAP32[i557 + 8 >> 2] | 0;
     i557 = HEAP32[i557 + 12 >> 2] | 0;
     HEAP32[i506 >> 2] = HEAP32[i69 >> 2];
     HEAP32[i163 >> 2] = i70;
     HEAP32[i162 >> 2] = i71;
     HEAP32[i161 >> 2] = i72;
     HEAP32[i164 >> 2] = i73;
     HEAP32[i167 >> 2] = i74;
     HEAP32[i166 >> 2] = i337;
     HEAP32[i165 >> 2] = i338;
     HEAP32[i168 >> 2] = i339;
     HEAP32[i171 >> 2] = i340;
     HEAP32[i170 >> 2] = i344;
     HEAP32[i169 >> 2] = i557;
     i557 = (HEAP32[i184 >> 2] | 0) + (i76 << 2) | 0;
     f544 = Math_fround(HEAPF32[i557 >> 2]);
     f534 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f535 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f536 = Math_fround(HEAPF32[i557 + 12 >> 2]);
     i557 = (HEAP32[i185 >> 2] | 0) + (i76 << 2) | 0;
     f537 = Math_fround(HEAPF32[i557 >> 2]);
     f538 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f539 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f540 = Math_fround(HEAPF32[i557 + 12 >> 2]);
     i557 = (HEAP32[i186 >> 2] | 0) + (i76 << 2) | 0;
     f541 = Math_fround(HEAPF32[i557 >> 2]);
     f542 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f543 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f556 = Math_fround(HEAPF32[i557 + 12 >> 2]);
     i557 = (HEAP32[i187 >> 2] | 0) + (i76 << 2) | 0;
     f545 = Math_fround(HEAPF32[i557 >> 2]);
     f546 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f547 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f548 = Math_fround(HEAPF32[i557 + 12 >> 2]);
     i557 = (HEAP32[i188 >> 2] | 0) + (i76 << 2) | 0;
     f549 = Math_fround(HEAPF32[i557 >> 2]);
     f550 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f551 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f552 = Math_fround(HEAPF32[i557 + 12 >> 2]);
     i557 = (HEAP32[i189 >> 2] | 0) + (i76 << 2) | 0;
     f553 = Math_fround(HEAPF32[i557 >> 2]);
     f554 = Math_fround(HEAPF32[i557 + 4 >> 2]);
     f555 = Math_fround(HEAPF32[i557 + 8 >> 2]);
     f546 = Math_fround(f534 + f546);
     f547 = Math_fround(f535 + f547);
     f548 = Math_fround(f536 + f548);
     f549 = Math_fround(f537 + f549);
     f550 = Math_fround(f538 + f550);
     f551 = Math_fround(f539 + f551);
     f552 = Math_fround(f540 + f552);
     f553 = Math_fround(f541 + f553);
     f554 = Math_fround(f542 + f554);
     f555 = Math_fround(f543 + f555);
     f556 = Math_fround(f556 + Math_fround(HEAPF32[i557 + 12 >> 2]));
     HEAPF32[i507 >> 2] = Math_fround(f544 + f545);
     HEAPF32[i174 >> 2] = f546;
     HEAPF32[i173 >> 2] = f547;
     HEAPF32[i172 >> 2] = f548;
     HEAPF32[i190 >> 2] = f549;
     HEAPF32[i177 >> 2] = f550;
     HEAPF32[i176 >> 2] = f551;
     HEAPF32[i175 >> 2] = f552;
     HEAPF32[i191 >> 2] = f553;
     HEAPF32[i180 >> 2] = f554;
     HEAPF32[i179 >> 2] = f555;
     HEAPF32[i178 >> 2] = f556;
     i557 = (HEAP32[i192 >> 2] | 0) + (i76 << 2) | 0;
     i344 = HEAP32[i557 + 4 >> 2] | 0;
     i340 = HEAP32[i557 + 8 >> 2] | 0;
     i339 = HEAP32[i557 + 12 >> 2] | 0;
     HEAP32[i487 >> 2] = HEAP32[i557 >> 2];
     HEAP32[i193 >> 2] = i344;
     HEAP32[i194 >> 2] = i340;
     HEAP32[i195 >> 2] = i339;
     i339 = (HEAP32[i196 >> 2] | 0) + (i76 << 2) | 0;
     i340 = HEAP32[i339 + 4 >> 2] | 0;
     i344 = HEAP32[i339 + 8 >> 2] | 0;
     i557 = HEAP32[i339 + 12 >> 2] | 0;
     HEAP32[i488 >> 2] = HEAP32[i339 >> 2];
     HEAP32[i197 >> 2] = i340;
     HEAP32[i198 >> 2] = i344;
     HEAP32[i199 >> 2] = i557;
     i557 = (HEAP32[i200 >> 2] | 0) + (i76 << 2) | 0;
     i344 = HEAP32[i557 + 4 >> 2] | 0;
     i340 = HEAP32[i557 + 8 >> 2] | 0;
     i339 = HEAP32[i557 + 12 >> 2] | 0;
     HEAP32[i489 >> 2] = HEAP32[i557 >> 2];
     HEAP32[i201 >> 2] = i344;
     HEAP32[i202 >> 2] = i340;
     HEAP32[i203 >> 2] = i339;
     i339 = (HEAP32[i204 >> 2] | 0) + (i76 << 2) | 0;
     i340 = HEAP32[i339 + 4 >> 2] | 0;
     i344 = HEAP32[i339 + 8 >> 2] | 0;
     i557 = HEAP32[i339 + 12 >> 2] | 0;
     HEAP32[i490 >> 2] = HEAP32[i339 >> 2];
     HEAP32[i205 >> 2] = i340;
     HEAP32[i206 >> 2] = i344;
     HEAP32[i207 >> 2] = i557;
     if (HEAP32[i502 >> 2] & 268435456 | 0) {
      i339 = (HEAP32[i208 >> 2] | 0) + (i76 << 2) | 0;
      i340 = HEAP32[i339 + 4 >> 2] | 0;
      i344 = HEAP32[i339 + 8 >> 2] | 0;
      i557 = HEAP32[i339 + 12 >> 2] | 0;
      HEAP32[i491 >> 2] = HEAP32[i339 >> 2];
      HEAP32[i209 >> 2] = i340;
      HEAP32[i210 >> 2] = i344;
      HEAP32[i211 >> 2] = i557;
     }
    } else {
     i4 = HEAP32[i184 >> 2] | 0;
     i5 = HEAP32[i187 >> 2] | 0;
     i6 = HEAP32[i182 >> 2] | 0;
     i7 = HEAP32[i185 >> 2] | 0;
     i8 = HEAP32[i188 >> 2] | 0;
     i12 = HEAP32[i183 >> 2] | 0;
     i13 = HEAP32[i186 >> 2] | 0;
     i14 = HEAP32[i189 >> 2] | 0;
     i15 = HEAP32[i192 >> 2] | 0;
     i16 = HEAP32[i196 >> 2] | 0;
     i17 = HEAP32[i200 >> 2] | 0;
     i18 = HEAP32[i204 >> 2] | 0;
     i3 = HEAP32[i208 >> 2] | 0;
     if (!(HEAP32[i502 >> 2] & 268435456)) {
      i2 = 0;
      do {
       i557 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i506 + (i2 << 2) >> 2] = HEAP32[i20 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i4 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i5 + (i557 << 2) >> 2]));
       i344 = i2 + 4 | 0;
       HEAP32[i506 + (i344 << 2) >> 2] = HEAP32[i6 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i7 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i344 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i8 + (i557 << 2) >> 2]));
       i344 = i2 + 8 | 0;
       HEAP32[i506 + (i344 << 2) >> 2] = HEAP32[i12 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i13 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i344 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i557 << 2) >> 2]));
       HEAP32[i487 + (i2 << 2) >> 2] = HEAP32[i15 + (i557 << 2) >> 2];
       HEAP32[i488 + (i2 << 2) >> 2] = HEAP32[i16 + (i557 << 2) >> 2];
       HEAP32[i489 + (i2 << 2) >> 2] = HEAP32[i17 + (i557 << 2) >> 2];
       HEAP32[i490 + (i2 << 2) >> 2] = HEAP32[i18 + (i557 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     } else {
      i2 = 0;
      do {
       i557 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i506 + (i2 << 2) >> 2] = HEAP32[i20 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i4 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i2 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i5 + (i557 << 2) >> 2]));
       i344 = i2 + 4 | 0;
       HEAP32[i506 + (i344 << 2) >> 2] = HEAP32[i6 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i7 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i344 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i8 + (i557 << 2) >> 2]));
       i344 = i2 + 8 | 0;
       HEAP32[i506 + (i344 << 2) >> 2] = HEAP32[i12 + (i557 << 2) >> 2];
       f556 = Math_fround(HEAPF32[i13 + (i557 << 2) >> 2]);
       HEAPF32[i507 + (i344 << 2) >> 2] = Math_fround(f556 + Math_fround(HEAPF32[i14 + (i557 << 2) >> 2]));
       HEAP32[i487 + (i2 << 2) >> 2] = HEAP32[i15 + (i557 << 2) >> 2];
       HEAP32[i488 + (i2 << 2) >> 2] = HEAP32[i16 + (i557 << 2) >> 2];
       HEAP32[i489 + (i2 << 2) >> 2] = HEAP32[i17 + (i557 << 2) >> 2];
       HEAP32[i490 + (i2 << 2) >> 2] = HEAP32[i18 + (i557 << 2) >> 2];
       HEAP32[i491 + (i2 << 2) >> 2] = HEAP32[i3 + (i557 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     }
    }
    f27 = Math_fround(HEAPF32[i506 >> 2]);
    f11 = Math_fround(f439 * f27);
    f32 = Math_fround(HEAPF32[i163 >> 2]);
    f30 = Math_fround(f439 * f32);
    f556 = Math_fround(HEAPF32[i162 >> 2]);
    f10 = Math_fround(f439 * f556);
    f554 = Math_fround(HEAPF32[i161 >> 2]);
    f75 = Math_fround(f439 * f554);
    f33 = Math_fround(HEAPF32[i212 >> 2]);
    f31 = Math_fround(f442 * f33);
    f26 = Math_fround(HEAPF32[i167 >> 2]);
    f35 = Math_fround(f442 * f26);
    f555 = Math_fround(HEAPF32[i166 >> 2]);
    f24 = Math_fround(f442 * f555);
    f553 = Math_fround(HEAPF32[i165 >> 2]);
    f31 = Math_fround(f11 + f31);
    f35 = Math_fround(f30 + f35);
    f24 = Math_fround(f10 + f24);
    f75 = Math_fround(f75 + Math_fround(f442 * f553));
    f10 = Math_fround(HEAPF32[i213 >> 2]);
    f30 = Math_fround(f445 * f10);
    f11 = Math_fround(HEAPF32[i171 >> 2]);
    f29 = Math_fround(f445 * f11);
    f22 = Math_fround(HEAPF32[i170 >> 2]);
    f28 = Math_fround(f445 * f22);
    f34 = Math_fround(HEAPF32[i169 >> 2]);
    f29 = Math_fround(f448 + Math_fround(f35 + f29));
    f28 = Math_fround(f448 + Math_fround(f24 + f28));
    f75 = Math_fround(f448 + Math_fround(f75 + Math_fround(f445 * f34)));
    HEAPF32[i492 >> 2] = Math_fround(f448 + Math_fround(f31 + f30));
    HEAPF32[i214 >> 2] = f29;
    HEAPF32[i215 >> 2] = f28;
    HEAPF32[i216 >> 2] = f75;
    f75 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f32) + Math_fround(f443 * f26)) + Math_fround(f446 * f11)));
    f28 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f556) + Math_fround(f443 * f555)) + Math_fround(f446 * f22)));
    f29 = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f554) + Math_fround(f443 * f553)) + Math_fround(f446 * f34)));
    HEAPF32[i217 >> 2] = Math_fround(f449 + Math_fround(Math_fround(Math_fround(f440 * f27) + Math_fround(f443 * f33)) + Math_fround(f446 * f10)));
    HEAPF32[i218 >> 2] = f75;
    HEAPF32[i219 >> 2] = f28;
    HEAPF32[i220 >> 2] = f29;
    f29 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f32) + Math_fround(f444 * f26)) + Math_fround(f447 * f11)));
    f28 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f556) + Math_fround(f444 * f555)) + Math_fround(f447 * f22)));
    f75 = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f554) + Math_fround(f444 * f553)) + Math_fround(f447 * f34)));
    HEAPF32[i221 >> 2] = Math_fround(f450 + Math_fround(Math_fround(Math_fround(f441 * f27) + Math_fround(f444 * f33)) + Math_fround(f447 * f10)));
    HEAPF32[i222 >> 2] = f29;
    HEAPF32[i223 >> 2] = f28;
    HEAPF32[i224 >> 2] = f75;
    f10 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f27) + Math_fround(f484 * f33)) + Math_fround(f485 * f10)));
    f11 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f32) + Math_fround(f484 * f26)) + Math_fround(f485 * f11)));
    f22 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f556) + Math_fround(f484 * f555)) + Math_fround(f485 * f22)));
    f34 = Math_fround(f486 + Math_fround(Math_fround(Math_fround(f483 * f554) + Math_fround(f484 * f553)) + Math_fround(f485 * f34)));
    f553 = Math_fround(f472 + Math_fround(f473 * f10));
    f554 = Math_fround(f472 + Math_fround(f473 * f11));
    f555 = Math_fround(f472 + Math_fround(f473 * f22));
    f556 = Math_fround(f472 + Math_fround(f473 * f34));
    f10 = Math_fround(f466 + Math_fround(f467 * f10));
    f11 = Math_fround(f466 + Math_fround(f467 * f11));
    f22 = Math_fround(f466 + Math_fround(f467 * f22));
    f34 = Math_fround(f466 + Math_fround(f467 * f34));
    f26 = Math_fround(HEAPF32[i487 >> 2]);
    f32 = Math_fround(HEAPF32[i193 >> 2]);
    f33 = Math_fround(HEAPF32[i194 >> 2]);
    f27 = Math_fround(HEAPF32[i195 >> 2]);
    f28 = Math_fround(HEAPF32[i488 >> 2]);
    f29 = Math_fround(HEAPF32[i197 >> 2]);
    f30 = Math_fround(HEAPF32[i198 >> 2]);
    f31 = Math_fround(HEAPF32[i199 >> 2]);
    f24 = f26 > f28 ? f26 : f28;
    f35 = f32 > f29 ? f32 : f29;
    f25 = f33 > f30 ? f33 : f30;
    f36 = f27 > f31 ? f27 : f31;
    f550 = Math_fround((f24 > f553 ? f24 : f553) * Math_fround(.5));
    f551 = Math_fround((f35 > f554 ? f35 : f554) * Math_fround(.5));
    f552 = Math_fround((f25 > f555 ? f25 : f555) * Math_fround(.5));
    f9 = Math_fround((f36 > f556 ? f36 : f556) * Math_fround(.5));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f550, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f551, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f552, HEAP32[tempDoublePtr >> 2] | 0);
    i339 = f553 >= Math_fround(0.0);
    i340 = f554 >= Math_fround(0.0);
    i344 = f555 >= Math_fround(0.0);
    i557 = f556 >= Math_fround(0.0);
    i12 = i339 ? i12 : 0;
    i13 = i340 ? i13 : 0;
    i14 = i344 ? i14 : 0;
    i5 = i557 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    f552 = Math_fround(f10 * Math_fround(.5));
    f554 = Math_fround(f11 * Math_fround(.5));
    f556 = Math_fround(f22 * Math_fround(.5));
    f9 = Math_fround(f34 * Math_fround(.5));
    f551 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f553 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f555 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f551 < f552 ? f551 : f552, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f553 < f554 ? f553 : f554, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f555 < f556 ? f555 : f556, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = f10 >= Math_fround(0.0);
    i3 = f11 >= Math_fround(0.0);
    i2 = f22 >= Math_fround(0.0);
    i557 = f34 >= Math_fround(0.0);
    i339 = i557 ? (HEAPF32[tempDoublePtr >> 2] = f23 < f9 ? f23 : f9, HEAP32[tempDoublePtr >> 2] | 0) : i5;
    f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f24);
    f40 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f41 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
    f42 = (HEAP32[tempDoublePtr >> 2] = i339, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f535 = Math_fround(f26 * f39);
    f37 = Math_fround(f33 * f41);
    f39 = Math_fround(f28 * f39);
    f41 = Math_fround(f30 * f41);
    f554 = Math_fround(HEAPF32[i489 >> 2]);
    f533 = Math_fround(HEAPF32[i201 >> 2]);
    f531 = Math_fround(HEAPF32[i202 >> 2]);
    f530 = Math_fround(f475 * f26);
    f532 = Math_fround(f475 * f33);
    f553 = Math_fround(f469 * f28);
    f555 = Math_fround(f469 * f30);
    f519 = Math_fround(f471 * f26);
    f521 = Math_fround(f471 * f33);
    f40 = Math_fround(f40 / f35);
    f536 = Math_fround(f32 * f40);
    f40 = Math_fround(f29 * f40);
    i339 = f554 < Math_fround(100.0);
    i344 = f531 < Math_fround(100.0);
    f531 = Math_fround(f475 * f32);
    f554 = Math_fround(f469 * f29);
    f520 = Math_fround(f471 * f32);
    f42 = Math_fround(f42 / f36);
    f38 = Math_fround(f27 * f42);
    f42 = Math_fround(f31 * f42);
    i340 = f533 < Math_fround(100.0);
    i557 = Math_fround(HEAPF32[i203 >> 2]) < Math_fround(100.0);
    f533 = Math_fround(f475 * f27);
    f556 = Math_fround(f469 * f31);
    f510 = Math_fround(f471 * f27);
    f35 = i339 ? f535 : Math_fround(0.0);
    f36 = i340 ? f536 : Math_fround(0.0);
    f37 = i344 ? f37 : Math_fround(0.0);
    f38 = i557 ? f38 : Math_fround(0.0);
    f536 = Math_fround(f530 - f35);
    f535 = Math_fround(f531 - f36);
    f534 = Math_fround(f532 - f37);
    f544 = Math_fround(f533 - f38);
    f39 = i339 ? f39 : Math_fround(0.0);
    f31 = Math_fround(f553 + f39);
    f40 = i340 ? f40 : Math_fround(0.0);
    f32 = Math_fround(f554 + f40);
    f41 = i344 ? f41 : Math_fround(0.0);
    f33 = Math_fround(f555 + f41);
    f42 = i557 ? f42 : Math_fround(0.0);
    f34 = Math_fround(f556 + f42);
    f511 = Math_fround(f328 * f536);
    f543 = Math_fround(f328 * f535);
    f542 = Math_fround(f328 * f534);
    f541 = Math_fround(f328 * f544);
    f55 = Math_fround(f329 * f31);
    f56 = Math_fround(f329 * f32);
    f57 = Math_fround(f329 * f33);
    f58 = Math_fround(f329 * f34);
    f509 = Math_fround(f330 * f519);
    f512 = Math_fround(f330 * f520);
    f513 = Math_fround(f330 * f521);
    f514 = Math_fround(f330 * f510);
    f43 = Math_fround(f509 + Math_fround(f511 + f55));
    f44 = Math_fround(f512 + Math_fround(f543 + f56));
    f45 = Math_fround(f513 + Math_fround(f542 + f57));
    f46 = Math_fround(f514 + Math_fround(f541 + f58));
    f540 = Math_fround(f331 * f536);
    f539 = Math_fround(f331 * f535);
    f538 = Math_fround(f331 * f534);
    f537 = Math_fround(f331 * f544);
    f27 = Math_fround(f332 * f31);
    f28 = Math_fround(f332 * f32);
    f29 = Math_fround(f332 * f33);
    f30 = Math_fround(f332 * f34);
    f515 = Math_fround(f333 * f519);
    f516 = Math_fround(f333 * f520);
    f517 = Math_fround(f333 * f521);
    f518 = Math_fround(f333 * f510);
    f47 = Math_fround(f515 + Math_fround(f540 + f27));
    f48 = Math_fround(f516 + Math_fround(f539 + f28));
    f49 = Math_fround(f517 + Math_fround(f538 + f29));
    f50 = Math_fround(f518 + Math_fround(f537 + f30));
    f536 = Math_fround(f334 * f536);
    f535 = Math_fround(f334 * f535);
    f534 = Math_fround(f334 * f534);
    f544 = Math_fround(f334 * f544);
    f31 = Math_fround(f335 * f31);
    f32 = Math_fround(f335 * f32);
    f33 = Math_fround(f335 * f33);
    f34 = Math_fround(f335 * f34);
    f519 = Math_fround(f336 * f519);
    f520 = Math_fround(f336 * f520);
    f521 = Math_fround(f336 * f521);
    f510 = Math_fround(f336 * f510);
    f51 = Math_fround(f519 + Math_fround(f536 + f31));
    f52 = Math_fround(f520 + Math_fround(f535 + f32));
    f53 = Math_fround(f521 + Math_fround(f534 + f33));
    f54 = Math_fround(f510 + Math_fround(f544 + f34));
    f530 = Math_fround(f530 + f35);
    f531 = Math_fround(f531 + f36);
    f532 = Math_fround(f532 + f37);
    f533 = Math_fround(f533 + f38);
    f522 = Math_fround(f328 * f530);
    f523 = Math_fround(f328 * f531);
    f524 = Math_fround(f328 * f532);
    f525 = Math_fround(f328 * f533);
    f55 = Math_fround(f509 + Math_fround(f522 + f55));
    f56 = Math_fround(f512 + Math_fround(f523 + f56));
    f57 = Math_fround(f513 + Math_fround(f524 + f57));
    f58 = Math_fround(f514 + Math_fround(f525 + f58));
    f526 = Math_fround(f331 * f530);
    f527 = Math_fround(f331 * f531);
    f528 = Math_fround(f331 * f532);
    f529 = Math_fround(f331 * f533);
    f27 = Math_fround(f515 + Math_fround(f526 + f27));
    f28 = Math_fround(f516 + Math_fround(f527 + f28));
    f29 = Math_fround(f517 + Math_fround(f528 + f29));
    f30 = Math_fround(f518 + Math_fround(f529 + f30));
    f530 = Math_fround(f334 * f530);
    f531 = Math_fround(f334 * f531);
    f532 = Math_fround(f334 * f532);
    f533 = Math_fround(f334 * f533);
    f31 = Math_fround(f519 + Math_fround(f530 + f31));
    f32 = Math_fround(f520 + Math_fround(f531 + f32));
    f33 = Math_fround(f521 + Math_fround(f532 + f33));
    f34 = Math_fround(f510 + Math_fround(f533 + f34));
    f553 = Math_fround(f553 - f39);
    f554 = Math_fround(f554 - f40);
    f555 = Math_fround(f555 - f41);
    f556 = Math_fround(f556 - f42);
    f545 = Math_fround(f329 * f553);
    f546 = Math_fround(f329 * f554);
    f547 = Math_fround(f329 * f555);
    f548 = Math_fround(f329 * f556);
    f522 = Math_fround(f509 + Math_fround(f522 + f545));
    f523 = Math_fround(f512 + Math_fround(f523 + f546));
    f524 = Math_fround(f513 + Math_fround(f524 + f547));
    f525 = Math_fround(f514 + Math_fround(f525 + f548));
    f549 = Math_fround(f332 * f553);
    f550 = Math_fround(f332 * f554);
    f551 = Math_fround(f332 * f555);
    f552 = Math_fround(f332 * f556);
    f526 = Math_fround(f515 + Math_fround(f526 + f549));
    f527 = Math_fround(f516 + Math_fround(f527 + f550));
    f528 = Math_fround(f517 + Math_fround(f528 + f551));
    f529 = Math_fround(f518 + Math_fround(f529 + f552));
    f553 = Math_fround(f335 * f553);
    f554 = Math_fround(f335 * f554);
    f555 = Math_fround(f335 * f555);
    f556 = Math_fround(f335 * f556);
    f530 = Math_fround(f519 + Math_fround(f530 + f553));
    f531 = Math_fround(f520 + Math_fround(f531 + f554));
    f532 = Math_fround(f521 + Math_fround(f532 + f555));
    f533 = Math_fround(f510 + Math_fround(f533 + f556));
    f545 = Math_fround(f509 + Math_fround(f511 + f545));
    f546 = Math_fround(f512 + Math_fround(f543 + f546));
    f547 = Math_fround(f513 + Math_fround(f542 + f547));
    f548 = Math_fround(f514 + Math_fround(f541 + f548));
    f549 = Math_fround(f515 + Math_fround(f540 + f549));
    f550 = Math_fround(f516 + Math_fround(f539 + f550));
    f551 = Math_fround(f517 + Math_fround(f538 + f551));
    f552 = Math_fround(f518 + Math_fround(f537 + f552));
    f553 = Math_fround(f519 + Math_fround(f536 + f553));
    f554 = Math_fround(f520 + Math_fround(f535 + f554));
    f555 = Math_fround(f521 + Math_fround(f534 + f555));
    f556 = Math_fround(f510 + Math_fround(f544 + f556));
    f544 = Math_fround(HEAPF32[i492 >> 2]);
    f510 = Math_fround(f544 + f43);
    f534 = Math_fround(HEAPF32[i214 >> 2]);
    f521 = Math_fround(f534 + f44);
    f535 = Math_fround(HEAPF32[i215 >> 2]);
    f520 = Math_fround(f535 + f45);
    f536 = Math_fround(HEAPF32[i216 >> 2]);
    f519 = Math_fround(f536 + f46);
    f537 = Math_fround(HEAPF32[i217 >> 2]);
    f518 = Math_fround(f537 + f47);
    f538 = Math_fround(HEAPF32[i218 >> 2]);
    f517 = Math_fround(f538 + f48);
    f539 = Math_fround(HEAPF32[i219 >> 2]);
    f516 = Math_fround(f539 + f49);
    f540 = Math_fround(HEAPF32[i220 >> 2]);
    f515 = Math_fround(f540 + f50);
    f541 = Math_fround(HEAPF32[i221 >> 2]);
    f514 = Math_fround(f541 + f51);
    f542 = Math_fround(HEAPF32[i222 >> 2]);
    f513 = Math_fround(f542 + f52);
    f543 = Math_fround(HEAPF32[i223 >> 2]);
    f512 = Math_fround(f543 + f53);
    f511 = Math_fround(f75 + f54);
    HEAPF32[i499 >> 2] = f510;
    HEAPF32[i225 >> 2] = f521;
    HEAPF32[i226 >> 2] = f520;
    HEAPF32[i227 >> 2] = f519;
    HEAPF32[i228 >> 2] = f518;
    HEAPF32[i229 >> 2] = f517;
    HEAPF32[i230 >> 2] = f516;
    HEAPF32[i231 >> 2] = f515;
    HEAPF32[i232 >> 2] = f514;
    HEAPF32[i233 >> 2] = f513;
    HEAPF32[i234 >> 2] = f512;
    HEAPF32[i235 >> 2] = f511;
    f511 = Math_fround(f534 + f56);
    f512 = Math_fround(f535 + f57);
    f513 = Math_fround(f536 + f58);
    f514 = Math_fround(f537 + f27);
    f515 = Math_fround(f538 + f28);
    f516 = Math_fround(f539 + f29);
    f517 = Math_fround(f540 + f30);
    f518 = Math_fround(f541 + f31);
    f519 = Math_fround(f542 + f32);
    f520 = Math_fround(f543 + f33);
    f521 = Math_fround(f75 + f34);
    HEAPF32[i236 >> 2] = Math_fround(f544 + f55);
    HEAPF32[i237 >> 2] = f511;
    HEAPF32[i238 >> 2] = f512;
    HEAPF32[i239 >> 2] = f513;
    HEAPF32[i240 >> 2] = f514;
    HEAPF32[i241 >> 2] = f515;
    HEAPF32[i242 >> 2] = f516;
    HEAPF32[i243 >> 2] = f517;
    HEAPF32[i244 >> 2] = f518;
    HEAPF32[i245 >> 2] = f519;
    HEAPF32[i246 >> 2] = f520;
    HEAPF32[i247 >> 2] = f521;
    f523 = Math_fround(f534 + f523);
    f524 = Math_fround(f535 + f524);
    f525 = Math_fround(f536 + f525);
    f526 = Math_fround(f537 + f526);
    f527 = Math_fround(f538 + f527);
    f528 = Math_fround(f539 + f528);
    f529 = Math_fround(f540 + f529);
    f530 = Math_fround(f541 + f530);
    f531 = Math_fround(f542 + f531);
    f532 = Math_fround(f543 + f532);
    f533 = Math_fround(f75 + f533);
    HEAPF32[i248 >> 2] = Math_fround(f544 + f522);
    HEAPF32[i249 >> 2] = f523;
    HEAPF32[i250 >> 2] = f524;
    HEAPF32[i251 >> 2] = f525;
    HEAPF32[i252 >> 2] = f526;
    HEAPF32[i253 >> 2] = f527;
    HEAPF32[i254 >> 2] = f528;
    HEAPF32[i255 >> 2] = f529;
    HEAPF32[i256 >> 2] = f530;
    HEAPF32[i257 >> 2] = f531;
    HEAPF32[i258 >> 2] = f532;
    HEAPF32[i259 >> 2] = f533;
    f546 = Math_fround(f534 + f546);
    f547 = Math_fround(f535 + f547);
    f548 = Math_fround(f536 + f548);
    f549 = Math_fround(f537 + f549);
    f550 = Math_fround(f538 + f550);
    f551 = Math_fround(f539 + f551);
    f552 = Math_fround(f540 + f552);
    f553 = Math_fround(f541 + f553);
    f554 = Math_fround(f542 + f554);
    f555 = Math_fround(f543 + f555);
    f556 = Math_fround(f75 + f556);
    HEAPF32[i260 >> 2] = Math_fround(f544 + f545);
    HEAPF32[i261 >> 2] = f546;
    HEAPF32[i262 >> 2] = f547;
    HEAPF32[i263 >> 2] = f548;
    HEAPF32[i264 >> 2] = f549;
    HEAPF32[i265 >> 2] = f550;
    HEAPF32[i266 >> 2] = f551;
    HEAPF32[i267 >> 2] = f552;
    HEAPF32[i268 >> 2] = f553;
    HEAPF32[i269 >> 2] = f554;
    HEAPF32[i270 >> 2] = f555;
    HEAPF32[i271 >> 2] = f556;
    if (!i272) {
     i2 = HEAP32[i502 >> 2] | 0;
     if (i2 & 536870912) {
      f556 = Math_fround(HEAPF32[i106 >> 2]);
      i68 = HEAP32[i490 >> 2] | 0;
      i344 = i68 + 693089735 | 0;
      i66 = HEAP32[i205 >> 2] | 0;
      i338 = i66 + 693089735 | 0;
      i64 = HEAP32[i206 >> 2] | 0;
      i73 = i64 + 693089735 | 0;
      i62 = HEAP32[i207 >> 2] | 0;
      i70 = i62 + 693089735 | 0;
      i63 = (Math_imul(i344, 1790253981) | 0) + 1900727103 | 0;
      i65 = (Math_imul(i338, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i344 = i344 << 11 ^ i344;
      i338 = i338 << 11 ^ i338;
      i73 = i73 << 11 ^ i73;
      i70 = i70 << 11 ^ i70;
      i63 = Math_fround(Math_fround((i63 ^ i344 ^ i344 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i65 = Math_fround(Math_fround((i65 ^ i338 ^ i338 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i67 = Math_fround(Math_fround((i67 ^ i73 ^ i73 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i69 = Math_fround(Math_fround((i69 ^ i70 ^ i70 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      f556 = Math_fround(HEAPF32[i77 >> 2]);
      i68 = i68 + 13945730 | 0;
      i66 = i66 + 13945730 | 0;
      i64 = i64 + 13945730 | 0;
      i62 = i62 + 13945730 | 0;
      i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i344 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i66 = i66 << 11 ^ i66;
      i64 = i64 << 11 ^ i64;
      i62 = i62 << 11 ^ i62;
      i70 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i73 = Math_fround(Math_fround((i73 ^ i66 ^ i66 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i338 = Math_fround(Math_fround((i338 ^ i64 ^ i64 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i344 = Math_fround(Math_fround((i344 ^ i62 ^ i62 >>> 8) & 8388607 ^ i344 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f556;
      i62 = i63 & 1;
      i64 = i65 & 1;
      i66 = i67 & 1;
      i68 = i69 & 1;
      i71 = i62 ^ 1;
      i74 = i64 ^ 1;
      i339 = i66 ^ 1;
      i557 = i68 ^ 1;
      i72 = i63 ? 3 : 2;
      i337 = i65 ? 3 : 2;
      i340 = i67 ? 3 : 2;
      i2 = i69 ? 3 : 2;
      i63 = i63 ? 2 : 3;
      i65 = i65 ? 2 : 3;
      i67 = i67 ? 2 : 3;
      i69 = i69 ? 2 : 3;
      HEAP32[i496 >> 2] = i70 ? i63 : i62;
      HEAP32[i453 >> 2] = i73 ? i65 : i64;
      HEAP32[i452 >> 2] = i338 ? i67 : i66;
      HEAP32[i451 >> 2] = i344 ? i69 : i68;
      HEAP32[i465 >> 2] = i70 ? i62 : i63;
      HEAP32[i464 >> 2] = i73 ? i64 : i65;
      HEAP32[i463 >> 2] = i338 ? i66 : i67;
      HEAP32[i462 >> 2] = i344 ? i68 : i69;
      HEAP32[i457 >> 2] = i70 ? i72 : i71;
      HEAP32[i456 >> 2] = i73 ? i337 : i74;
      HEAP32[i455 >> 2] = i338 ? i340 : i339;
      HEAP32[i454 >> 2] = i344 ? i2 : i557;
      HEAP32[i461 >> 2] = i70 ? i71 : i72;
      HEAP32[i460 >> 2] = i73 ? i74 : i337;
      HEAP32[i459 >> 2] = i338 ? i339 : i340;
      HEAP32[i458 >> 2] = i344 ? i557 : i2;
      i2 = HEAP32[i502 >> 2] | 0;
     }
     if (i2 & 268435456 | 0) {
      f9 = Math_fround(f478 * Math_fround(HEAPF32[i491 >> 2]));
      f10 = Math_fround(f478 * Math_fround(HEAPF32[i209 >> 2]));
      f11 = Math_fround(f478 * Math_fround(HEAPF32[i210 >> 2]));
      f22 = Math_fround(f478 * Math_fround(HEAPF32[i211 >> 2]));
      f23 = Math_fround(Math_floor(Math_fround(f9)));
      f24 = Math_fround(Math_floor(Math_fround(f10)));
      f25 = Math_fround(Math_floor(Math_fround(f11)));
      f26 = Math_fround(Math_floor(Math_fround(f22)));
      if (i2 & 16777216 | 0) {
       f553 = Math_fround(Math_floor(Math_fround(f477 * f23)));
       f554 = Math_fround(Math_floor(Math_fround(f477 * f24)));
       f555 = Math_fround(Math_floor(Math_fround(f477 * f25)));
       f556 = Math_fround(Math_floor(Math_fround(f477 * f26)));
       f549 = Math_fround(f479 * Math_fround(f23 - Math_fround(f476 * f553)));
       f550 = Math_fround(f479 * Math_fround(f24 - Math_fround(f476 * f554)));
       f551 = Math_fround(f479 * Math_fround(f25 - Math_fround(f476 * f555)));
       f552 = Math_fround(f479 * Math_fround(f26 - Math_fround(f476 * f556)));
       f553 = Math_fround(f481 - Math_fround(f480 * f553));
       f554 = Math_fround(f481 - Math_fround(f480 * f554));
       f555 = Math_fround(f481 - Math_fround(f480 * f555));
       f556 = Math_fround(f481 - Math_fround(f480 * f556));
       f541 = Math_fround(f480 + f553);
       f542 = Math_fround(f480 + f554);
       f543 = Math_fround(f480 + f555);
       f544 = Math_fround(f480 + f556);
       HEAPF32[i497 >> 2] = f549;
       HEAPF32[i390 >> 2] = f550;
       HEAPF32[i414 >> 2] = f551;
       HEAPF32[i438 >> 2] = f552;
       HEAPF32[i366 >> 2] = f541;
       HEAPF32[i389 >> 2] = f542;
       HEAPF32[i413 >> 2] = f543;
       HEAPF32[i437 >> 2] = f544;
       f545 = Math_fround(f479 + f549);
       f546 = Math_fround(f479 + f550);
       f547 = Math_fround(f479 + f551);
       f548 = Math_fround(f479 + f552);
       HEAPF32[i365 >> 2] = f545;
       HEAPF32[i388 >> 2] = f546;
       HEAPF32[i412 >> 2] = f547;
       HEAPF32[i436 >> 2] = f548;
       HEAPF32[i364 >> 2] = f541;
       HEAPF32[i387 >> 2] = f542;
       HEAPF32[i411 >> 2] = f543;
       HEAPF32[i435 >> 2] = f544;
       HEAPF32[i363 >> 2] = f545;
       HEAPF32[i386 >> 2] = f546;
       HEAPF32[i410 >> 2] = f547;
       HEAPF32[i434 >> 2] = f548;
       HEAPF32[i362 >> 2] = f553;
       HEAPF32[i385 >> 2] = f554;
       HEAPF32[i409 >> 2] = f555;
       HEAPF32[i433 >> 2] = f556;
       HEAPF32[i361 >> 2] = f549;
       HEAPF32[i384 >> 2] = f550;
       HEAPF32[i408 >> 2] = f551;
       HEAPF32[i432 >> 2] = f552;
       HEAPF32[i360 >> 2] = f553;
       HEAPF32[i383 >> 2] = f554;
       HEAPF32[i407 >> 2] = f555;
       HEAPF32[i431 >> 2] = f556;
      }
      if (i2 & 33554432 | 0) {
       f545 = Math_fround(f23 + Math_fround(1.0));
       f546 = Math_fround(f24 + Math_fround(1.0));
       f547 = Math_fround(f25 + Math_fround(1.0));
       f548 = Math_fround(f26 + Math_fround(1.0));
       f553 = Math_fround(f9 - f23);
       f554 = Math_fround(f10 - f24);
       f555 = Math_fround(f11 - f25);
       f556 = Math_fround(f22 - f26);
       f549 = Math_fround(Math_floor(Math_fround(f477 * f545)));
       f550 = Math_fround(Math_floor(Math_fround(f477 * f546)));
       f551 = Math_fround(Math_floor(Math_fround(f477 * f547)));
       f552 = Math_fround(Math_floor(Math_fround(f477 * f548)));
       f545 = Math_fround(f479 * Math_fround(f545 - Math_fround(f476 * f549)));
       f546 = Math_fround(f479 * Math_fround(f546 - Math_fround(f476 * f550)));
       f547 = Math_fround(f479 * Math_fround(f547 - Math_fround(f476 * f551)));
       f548 = Math_fround(f479 * Math_fround(f548 - Math_fround(f476 * f552)));
       f549 = Math_fround(f481 - Math_fround(f480 * f549));
       f550 = Math_fround(f481 - Math_fround(f480 * f550));
       f551 = Math_fround(f481 - Math_fround(f480 * f551));
       f552 = Math_fround(f481 - Math_fround(f480 * f552));
       f537 = Math_fround(f480 + f549);
       f538 = Math_fround(f480 + f550);
       f539 = Math_fround(f480 + f551);
       f540 = Math_fround(f480 + f552);
       HEAPF32[i498 >> 2] = f545;
       HEAPF32[i382 >> 2] = f546;
       HEAPF32[i406 >> 2] = f547;
       HEAPF32[i430 >> 2] = f548;
       HEAPF32[i359 >> 2] = f537;
       HEAPF32[i381 >> 2] = f538;
       HEAPF32[i405 >> 2] = f539;
       HEAPF32[i429 >> 2] = f540;
       HEAPF32[i358 >> 2] = f553;
       HEAPF32[i380 >> 2] = f554;
       HEAPF32[i404 >> 2] = f555;
       HEAPF32[i428 >> 2] = f556;
       HEAPF32[i357 >> 2] = f9;
       HEAPF32[i379 >> 2] = f10;
       HEAPF32[i403 >> 2] = f11;
       HEAPF32[i427 >> 2] = f22;
       f541 = Math_fround(f479 + f545);
       f542 = Math_fround(f479 + f546);
       f543 = Math_fround(f479 + f547);
       f544 = Math_fround(f479 + f548);
       HEAPF32[i356 >> 2] = f541;
       HEAPF32[i378 >> 2] = f542;
       HEAPF32[i402 >> 2] = f543;
       HEAPF32[i426 >> 2] = f544;
       HEAPF32[i355 >> 2] = f537;
       HEAPF32[i377 >> 2] = f538;
       HEAPF32[i401 >> 2] = f539;
       HEAPF32[i425 >> 2] = f540;
       HEAPF32[i354 >> 2] = f553;
       HEAPF32[i376 >> 2] = f554;
       HEAPF32[i400 >> 2] = f555;
       HEAPF32[i424 >> 2] = f556;
       HEAPF32[i353 >> 2] = f9;
       HEAPF32[i375 >> 2] = f10;
       HEAPF32[i399 >> 2] = f11;
       HEAPF32[i423 >> 2] = f22;
       HEAPF32[i352 >> 2] = f541;
       HEAPF32[i374 >> 2] = f542;
       HEAPF32[i398 >> 2] = f543;
       HEAPF32[i422 >> 2] = f544;
       HEAPF32[i351 >> 2] = f549;
       HEAPF32[i373 >> 2] = f550;
       HEAPF32[i397 >> 2] = f551;
       HEAPF32[i421 >> 2] = f552;
       HEAPF32[i350 >> 2] = f553;
       HEAPF32[i372 >> 2] = f554;
       HEAPF32[i396 >> 2] = f555;
       HEAPF32[i420 >> 2] = f556;
       HEAPF32[i349 >> 2] = f9;
       HEAPF32[i371 >> 2] = f10;
       HEAPF32[i395 >> 2] = f11;
       HEAPF32[i419 >> 2] = f22;
       HEAPF32[i348 >> 2] = f545;
       HEAPF32[i370 >> 2] = f546;
       HEAPF32[i394 >> 2] = f547;
       HEAPF32[i418 >> 2] = f548;
       HEAPF32[i347 >> 2] = f549;
       HEAPF32[i369 >> 2] = f550;
       HEAPF32[i393 >> 2] = f551;
       HEAPF32[i417 >> 2] = f552;
       HEAPF32[i346 >> 2] = f553;
       HEAPF32[i368 >> 2] = f554;
       HEAPF32[i392 >> 2] = f555;
       HEAPF32[i416 >> 2] = f556;
       HEAPF32[i345 >> 2] = f9;
       HEAPF32[i367 >> 2] = f10;
       HEAPF32[i391 >> 2] = f11;
       HEAPF32[i415 >> 2] = f22;
      }
     }
    }
    f541 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f43 * f43) + Math_fround(f47 * f47))))));
    f542 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f52 * f52) + Math_fround(Math_fround(f44 * f44) + Math_fround(f48 * f48))))));
    f543 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f53 * f53) + Math_fround(Math_fround(f45 * f45) + Math_fround(f49 * f49))))));
    f544 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f54 * f54) + Math_fround(Math_fround(f46 * f46) + Math_fround(f50 * f50))))));
    f533 = Math_fround(f482 * Math_fround(f43 * f541));
    f534 = Math_fround(f482 * Math_fround(f44 * f542));
    f535 = Math_fround(f482 * Math_fround(f45 * f543));
    f536 = Math_fround(f482 * Math_fround(f46 * f544));
    f537 = Math_fround(f482 * Math_fround(f47 * f541));
    f538 = Math_fround(f482 * Math_fround(f48 * f542));
    f539 = Math_fround(f482 * Math_fround(f49 * f543));
    f540 = Math_fround(f482 * Math_fround(f50 * f544));
    f541 = Math_fround(f482 * Math_fround(f51 * f541));
    f542 = Math_fround(f482 * Math_fround(f52 * f542));
    f543 = Math_fround(f482 * Math_fround(f53 * f543));
    f544 = Math_fround(f482 * Math_fround(f54 * f544));
    f553 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f55 * f55) + Math_fround(f27 * f27))))));
    f554 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f56 * f56) + Math_fround(f28 * f28))))));
    f555 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f57 * f57) + Math_fround(f29 * f29))))));
    f556 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f58 * f58) + Math_fround(f30 * f30))))));
    f545 = Math_fround(f482 * Math_fround(f55 * f553));
    f546 = Math_fround(f482 * Math_fround(f56 * f554));
    f547 = Math_fround(f482 * Math_fround(f57 * f555));
    f548 = Math_fround(f482 * Math_fround(f58 * f556));
    f549 = Math_fround(f482 * Math_fround(f27 * f553));
    f550 = Math_fround(f482 * Math_fround(f28 * f554));
    f551 = Math_fround(f482 * Math_fround(f29 * f555));
    f552 = Math_fround(f482 * Math_fround(f30 * f556));
    f553 = Math_fround(f482 * Math_fround(f31 * f553));
    f554 = Math_fround(f482 * Math_fround(f32 * f554));
    f555 = Math_fround(f482 * Math_fround(f33 * f555));
    f556 = Math_fround(f482 * Math_fround(f34 * f556));
    f532 = Math_fround(f474 + f534);
    f531 = Math_fround(f474 + f535);
    f530 = Math_fround(f474 + f536);
    f529 = Math_fround(f468 + f537);
    f528 = Math_fround(f468 + f538);
    f527 = Math_fround(f468 + f539);
    f526 = Math_fround(f468 + f540);
    f525 = Math_fround(f470 + f541);
    f524 = Math_fround(f470 + f542);
    f523 = Math_fround(f470 + f543);
    f522 = Math_fround(f470 + f544);
    HEAPF32[i500 >> 2] = Math_fround(f474 + f533);
    HEAPF32[i121 >> 2] = f532;
    HEAPF32[i138 >> 2] = f531;
    HEAPF32[i155 >> 2] = f530;
    HEAPF32[i273 >> 2] = f529;
    HEAPF32[i116 >> 2] = f528;
    HEAPF32[i133 >> 2] = f527;
    HEAPF32[i150 >> 2] = f526;
    HEAPF32[i274 >> 2] = f525;
    HEAPF32[i111 >> 2] = f524;
    HEAPF32[i128 >> 2] = f523;
    HEAPF32[i145 >> 2] = f522;
    f522 = Math_fround(f474 + f546);
    f523 = Math_fround(f474 + f547);
    f524 = Math_fround(f474 + f548);
    f525 = Math_fround(f468 + f549);
    f526 = Math_fround(f468 + f550);
    f527 = Math_fround(f468 + f551);
    f528 = Math_fround(f468 + f552);
    f529 = Math_fround(f470 + f553);
    f530 = Math_fround(f470 + f554);
    f531 = Math_fround(f470 + f555);
    f532 = Math_fround(f470 + f556);
    HEAPF32[i275 >> 2] = Math_fround(f474 + f545);
    HEAPF32[i120 >> 2] = f522;
    HEAPF32[i137 >> 2] = f523;
    HEAPF32[i154 >> 2] = f524;
    HEAPF32[i276 >> 2] = f525;
    HEAPF32[i115 >> 2] = f526;
    HEAPF32[i132 >> 2] = f527;
    HEAPF32[i149 >> 2] = f528;
    HEAPF32[i277 >> 2] = f529;
    HEAPF32[i110 >> 2] = f530;
    HEAPF32[i127 >> 2] = f531;
    HEAPF32[i144 >> 2] = f532;
    f534 = Math_fround(f474 - f534);
    f535 = Math_fround(f474 - f535);
    f536 = Math_fround(f474 - f536);
    f537 = Math_fround(f468 - f537);
    f538 = Math_fround(f468 - f538);
    f539 = Math_fround(f468 - f539);
    f540 = Math_fround(f468 - f540);
    f541 = Math_fround(f470 - f541);
    f542 = Math_fround(f470 - f542);
    f543 = Math_fround(f470 - f543);
    f544 = Math_fround(f470 - f544);
    HEAPF32[i278 >> 2] = Math_fround(f474 - f533);
    HEAPF32[i119 >> 2] = f534;
    HEAPF32[i136 >> 2] = f535;
    HEAPF32[i153 >> 2] = f536;
    HEAPF32[i279 >> 2] = f537;
    HEAPF32[i114 >> 2] = f538;
    HEAPF32[i131 >> 2] = f539;
    HEAPF32[i148 >> 2] = f540;
    HEAPF32[i280 >> 2] = f541;
    HEAPF32[i109 >> 2] = f542;
    HEAPF32[i126 >> 2] = f543;
    HEAPF32[i143 >> 2] = f544;
    f546 = Math_fround(f474 - f546);
    f547 = Math_fround(f474 - f547);
    f548 = Math_fround(f474 - f548);
    f549 = Math_fround(f468 - f549);
    f550 = Math_fround(f468 - f550);
    f551 = Math_fround(f468 - f551);
    f552 = Math_fround(f468 - f552);
    f553 = Math_fround(f470 - f553);
    f554 = Math_fround(f470 - f554);
    f555 = Math_fround(f470 - f555);
    f556 = Math_fround(f470 - f556);
    HEAPF32[i281 >> 2] = Math_fround(f474 - f545);
    HEAPF32[i118 >> 2] = f546;
    HEAPF32[i135 >> 2] = f547;
    HEAPF32[i152 >> 2] = f548;
    HEAPF32[i282 >> 2] = f549;
    HEAPF32[i113 >> 2] = f550;
    HEAPF32[i130 >> 2] = f551;
    HEAPF32[i147 >> 2] = f552;
    HEAPF32[i283 >> 2] = f553;
    HEAPF32[i108 >> 2] = f554;
    HEAPF32[i125 >> 2] = f555;
    HEAPF32[i142 >> 2] = f556;
    do if (i159) {
     i4 = HEAP32[i181 >> 2] | 0;
     i5 = HEAP32[i504 >> 2] | 0;
     if (!i4) {
      i2 = 0;
      i3 = i1;
      while (1) {
       i557 = i5 + (i2 + i76 << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i499 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i500 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i236 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i275 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i248 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i278 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i260 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i281 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i557 >> 2];
       i557 = i497 + (HEAP32[i496 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i557 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i557 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     } else {
      i2 = 0;
      i3 = i1;
      while (1) {
       i557 = i5 + (HEAP32[i4 + (i2 + i76 << 3) >> 2] << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i499 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i500 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i236 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i275 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i248 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i278 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i557 >> 2];
       i344 = i497 + (HEAP32[i496 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i344 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i344 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i260 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i281 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i557 >> 2];
       i557 = i497 + (HEAP32[i496 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i557 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i557 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     }
    } else {
     f544 = Math_fround(HEAPF32[i236 >> 2]);
     f544 = Math_fround(f544 - Math_fround(HEAPF32[i499 >> 2]));
     f546 = Math_fround(HEAPF32[i237 >> 2]);
     f546 = Math_fround(f546 - Math_fround(HEAPF32[i225 >> 2]));
     f547 = Math_fround(HEAPF32[i238 >> 2]);
     f547 = Math_fround(f547 - Math_fround(HEAPF32[i226 >> 2]));
     f548 = Math_fround(HEAPF32[i239 >> 2]);
     f548 = Math_fround(f548 - Math_fround(HEAPF32[i227 >> 2]));
     f549 = Math_fround(HEAPF32[i240 >> 2]);
     f549 = Math_fround(f549 - Math_fround(HEAPF32[i228 >> 2]));
     f556 = Math_fround(HEAPF32[i241 >> 2]);
     f556 = Math_fround(f556 - Math_fround(HEAPF32[i229 >> 2]));
     f555 = Math_fround(HEAPF32[i242 >> 2]);
     f555 = Math_fround(f555 - Math_fround(HEAPF32[i230 >> 2]));
     f554 = Math_fround(HEAPF32[i243 >> 2]);
     f554 = Math_fround(f554 - Math_fround(HEAPF32[i231 >> 2]));
     f553 = Math_fround(HEAPF32[i244 >> 2]);
     f553 = Math_fround(f553 - Math_fround(HEAPF32[i232 >> 2]));
     f541 = Math_fround(HEAPF32[i245 >> 2]);
     f541 = Math_fround(f541 - Math_fround(HEAPF32[i233 >> 2]));
     f542 = Math_fround(HEAPF32[i246 >> 2]);
     f542 = Math_fround(f542 - Math_fround(HEAPF32[i234 >> 2]));
     f543 = Math_fround(HEAPF32[i247 >> 2]);
     f543 = Math_fround(f543 - Math_fround(HEAPF32[i235 >> 2]));
     f545 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f544 * f544) + Math_fround(f549 * f549)) + Math_fround(f553 * f553)))));
     f552 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f546 * f546) + Math_fround(f556 * f556)) + Math_fround(f541 * f541)))));
     f551 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f547 * f547) + Math_fround(f555 * f555)) + Math_fround(f542 * f542)))));
     f550 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f548 * f548) + Math_fround(f554 * f554)) + Math_fround(f543 * f543)))));
     f546 = Math_fround(f546 * f552);
     f547 = Math_fround(f547 * f551);
     f548 = Math_fround(f548 * f550);
     f549 = Math_fround(f549 * f545);
     f556 = Math_fround(f556 * f552);
     f555 = Math_fround(f555 * f551);
     f554 = Math_fround(f554 * f550);
     f553 = Math_fround(f553 * f545);
     f552 = Math_fround(f541 * f552);
     f551 = Math_fround(f542 * f551);
     f550 = Math_fround(f543 * f550);
     HEAPF32[i493 >> 2] = Math_fround(f544 * f545);
     HEAPF32[i122 >> 2] = f546;
     HEAPF32[i139 >> 2] = f547;
     HEAPF32[i156 >> 2] = f548;
     HEAPF32[i284 >> 2] = f549;
     HEAPF32[i117 >> 2] = f556;
     HEAPF32[i134 >> 2] = f555;
     HEAPF32[i151 >> 2] = f554;
     HEAPF32[i285 >> 2] = f553;
     HEAPF32[i112 >> 2] = f552;
     HEAPF32[i129 >> 2] = f551;
     HEAPF32[i146 >> 2] = f550;
     f550 = Math_fround(f36 * Math_fround(2.0));
     f551 = Math_fround(f37 * Math_fround(2.0));
     f552 = Math_fround(f38 * Math_fround(2.0));
     f553 = Math_fround(f39 * Math_fround(2.0));
     f554 = Math_fround(f40 * Math_fround(2.0));
     f555 = Math_fround(f41 * Math_fround(2.0));
     f556 = Math_fround(f42 * Math_fround(2.0));
     HEAPF32[i494 >> 2] = Math_fround(f35 * Math_fround(2.0));
     HEAPF32[i124 >> 2] = f550;
     HEAPF32[i141 >> 2] = f551;
     HEAPF32[i158 >> 2] = f552;
     HEAPF32[i286 >> 2] = f553;
     HEAPF32[i123 >> 2] = f554;
     HEAPF32[i140 >> 2] = f555;
     HEAPF32[i157 >> 2] = f556;
     HEAP32[i107 >> 2] = 0;
     HEAP32[i107 + 4 >> 2] = 0;
     HEAP32[i107 + 8 >> 2] = 0;
     HEAP32[i107 + 12 >> 2] = 0;
     if (i287) {
      f536 = Math_fround(HEAPF32[i507 >> 2]);
      f554 = Math_fround(f439 * f536);
      f538 = Math_fround(HEAPF32[i174 >> 2]);
      f545 = Math_fround(f439 * f538);
      f540 = Math_fround(HEAPF32[i173 >> 2]);
      f553 = Math_fround(f439 * f540);
      f542 = Math_fround(HEAPF32[i172 >> 2]);
      f548 = Math_fround(f439 * f542);
      f537 = Math_fround(HEAPF32[i190 >> 2]);
      f544 = Math_fround(f442 * f537);
      f539 = Math_fround(HEAPF32[i177 >> 2]);
      f550 = Math_fround(f442 * f539);
      f541 = Math_fround(HEAPF32[i176 >> 2]);
      f549 = Math_fround(f442 * f541);
      f543 = Math_fround(HEAPF32[i175 >> 2]);
      f544 = Math_fround(f554 + f544);
      f550 = Math_fround(f545 + f550);
      f549 = Math_fround(f553 + f549);
      f548 = Math_fround(f548 + Math_fround(f442 * f543));
      f553 = Math_fround(HEAPF32[i191 >> 2]);
      f545 = Math_fround(f445 * f553);
      f554 = Math_fround(HEAPF32[i180 >> 2]);
      f546 = Math_fround(f445 * f554);
      f555 = Math_fround(HEAPF32[i179 >> 2]);
      f547 = Math_fround(f445 * f555);
      f556 = Math_fround(HEAPF32[i178 >> 2]);
      f546 = Math_fround(f550 + f546);
      f547 = Math_fround(f549 + f547);
      f548 = Math_fround(f548 + Math_fround(f445 * f556));
      f549 = Math_fround(Math_fround(Math_fround(f440 * f536) + Math_fround(f443 * f537)) + Math_fround(f446 * f553));
      f550 = Math_fround(Math_fround(Math_fround(f440 * f538) + Math_fround(f443 * f539)) + Math_fround(f446 * f554));
      f551 = Math_fround(Math_fround(Math_fround(f440 * f540) + Math_fround(f443 * f541)) + Math_fround(f446 * f555));
      f552 = Math_fround(Math_fround(Math_fround(f440 * f542) + Math_fround(f443 * f543)) + Math_fround(f446 * f556));
      f553 = Math_fround(Math_fround(Math_fround(f441 * f536) + Math_fround(f444 * f537)) + Math_fround(f447 * f553));
      f554 = Math_fround(Math_fround(Math_fround(f441 * f538) + Math_fround(f444 * f539)) + Math_fround(f447 * f554));
      f555 = Math_fround(Math_fround(Math_fround(f441 * f540) + Math_fround(f444 * f541)) + Math_fround(f447 * f555));
      f556 = Math_fround(Math_fround(Math_fround(f441 * f542) + Math_fround(f444 * f543)) + Math_fround(f447 * f556));
      HEAPF32[i495 >> 2] = Math_fround(f544 + f545);
      HEAPF32[i288 >> 2] = f546;
      HEAPF32[i289 >> 2] = f547;
      HEAPF32[i290 >> 2] = f548;
      HEAPF32[i291 >> 2] = f549;
      HEAPF32[i292 >> 2] = f550;
      HEAPF32[i293 >> 2] = f551;
      HEAPF32[i294 >> 2] = f552;
      HEAPF32[i295 >> 2] = f553;
      HEAPF32[i296 >> 2] = f554;
      HEAPF32[i297 >> 2] = f555;
      HEAPF32[i298 >> 2] = f556;
     }
     if (i299) {
      i74 = HEAP32[i490 >> 2] | 0;
      i339 = i74 + 1068538453 | 0;
      i340 = HEAP32[i205 >> 2] | 0;
      i338 = i340 + 1068538453 | 0;
      i71 = HEAP32[i206 >> 2] | 0;
      i70 = i71 + 1068538453 | 0;
      i69 = HEAP32[i207 >> 2] | 0;
      i73 = i69 + 1068538453 | 0;
      i344 = (Math_imul(i339, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i338, 1790253981) | 0) + 1900727103 | 0;
      i557 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i337 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i339 = i339 << 11 ^ i339;
      i338 = i338 << 11 ^ i338;
      i70 = i70 << 11 ^ i70;
      i73 = i73 << 11 ^ i73;
      f554 = Math_fround(Math_fround((i72 ^ i338 ^ i338 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i557 ^ i70 ^ i70 >>> 8) & 8388607 ^ i557 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i337 ^ i73 ^ i73 >>> 8) & 8388607 ^ i337 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i501 >> 2] = Math_fround(Math_fround((i344 ^ i339 ^ i339 >>> 8) & 8388607 ^ i344 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i300 >> 2] = f554;
      HEAPF32[i301 >> 2] = f555;
      HEAPF32[i302 >> 2] = f556;
      i74 = i74 + 1068538454 | 0;
      i340 = i340 + 1068538454 | 0;
      i71 = i71 + 1068538454 | 0;
      i69 = i69 + 1068538454 | 0;
      i344 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
      i339 = (Math_imul(i340, 1790253981) | 0) + 1900727103 | 0;
      i337 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i74 = i74 << 11 ^ i74;
      i340 = i340 << 11 ^ i340;
      i71 = i71 << 11 ^ i71;
      i69 = i69 << 11 ^ i69;
      f556 = Math_fround(Math_fround((i339 ^ i340 ^ i340 >>> 8) & 8388607 ^ i339 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i337 ^ i71 ^ i71 >>> 8) & 8388607 ^ i337 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f554 = Math_fround(Math_fround((i73 ^ i69 ^ i69 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i303 >> 2] = Math_fround(Math_fround((i344 ^ i74 ^ i74 >>> 8) & 8388607 ^ i344 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i304 >> 2] = f556;
      HEAPF32[i305 >> 2] = f555;
      HEAPF32[i306 >> 2] = f554;
      i344 = HEAP32[i490 >> 2] | 0;
      i74 = i344 + 1068538455 | 0;
      i73 = HEAP32[i205 >> 2] | 0;
      i69 = i73 + 1068538455 | 0;
      i337 = HEAP32[i206 >> 2] | 0;
      i71 = i337 + 1068538455 | 0;
      i339 = HEAP32[i207 >> 2] | 0;
      i340 = i339 + 1068538455 | 0;
      i557 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i340, 1790253981) | 0) + 1900727103 | 0;
      i74 = i74 << 11 ^ i74;
      i69 = i69 << 11 ^ i69;
      i71 = i71 << 11 ^ i71;
      i340 = i340 << 11 ^ i340;
      f554 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i338 ^ i340 ^ i340 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i307 >> 2] = Math_fround(Math_fround((i557 ^ i74 ^ i74 >>> 8) & 8388607 ^ i557 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i308 >> 2] = f554;
      HEAPF32[i309 >> 2] = f555;
      HEAPF32[i310 >> 2] = f556;
      f556 = Math_fround(Math_fround(HEAPF32[i489 >> 2]) * Math_fround(1.0e5));
      f555 = Math_fround(Math_fround(HEAPF32[i201 >> 2]) * Math_fround(1.0e5));
      f554 = Math_fround(Math_fround(HEAPF32[i202 >> 2]) * Math_fround(1.0e5));
      i344 = i344 + 1068538453 + ~~f556 | 0;
      i73 = i73 + 1068538453 + ~~f555 | 0;
      i337 = i337 + 1068538453 + ~~f554 | 0;
      i339 = i339 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i203 >> 2]) * Math_fround(1.0e5)) | 0;
      i557 = (Math_imul(i344, 1790253981) | 0) + 1900727103 | 0;
      i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i337, 1790253981) | 0) + 1900727103 | 0;
      i340 = (Math_imul(i339, 1790253981) | 0) + 1900727103 | 0;
      i344 = i344 << 11 ^ i344;
      i73 = i73 << 11 ^ i73;
      i337 = i337 << 11 ^ i337;
      i339 = i339 << 11 ^ i339;
      f554 = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f555 = Math_fround(Math_fround((i338 ^ i337 ^ i337 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f556 = Math_fround(Math_fround((i340 ^ i339 ^ i339 >>> 8) & 8388607 ^ i340 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i311 >> 2] = Math_fround(Math_fround((i557 ^ i344 ^ i344 >>> 8) & 8388607 ^ i557 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i312 >> 2] = f554;
      HEAPF32[i313 >> 2] = f555;
      HEAPF32[i314 >> 2] = f556;
     }
     i67 = HEAP32[i181 >> 2] | 0;
     i68 = (i67 | 0) == 0;
     i69 = HEAP32[i82 >> 2] | 0;
     i70 = HEAP32[i84 >> 2] | 0;
     i71 = HEAP32[i200 >> 2] | 0;
     i72 = HEAP32[i85 >> 2] | 0;
     i73 = HEAP32[i327 >> 2] | 0;
     i74 = HEAP32[i504 >> 2] | 0;
     i66 = 0;
     do {
      i2 = i66 + i76 | 0;
      if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
      i5 = i495 + (i66 << 2) | 0;
      i6 = i322 + (i66 << 2) | 0;
      i7 = i323 + (i66 << 2) | 0;
      i8 = i501 + (i66 << 2) | 0;
      i12 = i303 + (i66 << 2) | 0;
      i13 = i307 + (i66 << 2) | 0;
      i14 = i311 + (i66 << 2) | 0;
      i15 = i493 + (i66 << 2) | 0;
      i16 = i79 + (i66 << 2) | 0;
      i17 = i80 + (i66 << 2) | 0;
      i18 = i69 + (i2 << 4) | 0;
      i19 = i70 + (i2 << 4) | 0;
      i20 = i71 + (i2 << 2) | 0;
      i21 = i72 + (i2 << 2) | 0;
      i59 = i73 + (i2 << 2) | 0;
      i60 = i494 + (i66 << 2) | 0;
      i61 = i86 + (i66 << 2) | 0;
      i62 = i87 + (i66 << 2) | 0;
      i63 = i492 + (i66 << 2) | 0;
      i64 = i88 + (i66 << 2) | 0;
      i65 = i89 + (i66 << 2) | 0;
      i4 = i74 + (i2 << 2) | 0;
      i3 = 0;
      i2 = i1;
      while (1) {
       i1 = i499 + (i3 * 48 | 0) | 0;
       HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
       i1 = i2 + 12 | 0;
       if (!i315) {
        i557 = i500 + (i3 * 48 | 0) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i2 + 16 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 20 >> 2] = HEAP32[i557 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 24 | 0;
       }
       if (!i316) {
        HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
        i1 = i1 + 4 | 0;
       }
       if (!i317) {
        i557 = i497 + (HEAP32[i496 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i318) {
        i557 = i498 + (HEAP32[i496 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
        HEAP32[i1 >> 2] = HEAP32[i557 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 16 + (i66 << 2) >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 32 + (i66 << 2) >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 48 + (i66 << 2) >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i319) {
        f556 = Math_fround(i3 | 0);
        HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
        HEAPF32[i1 + 12 >> 2] = f556;
        i1 = i1 + 16 | 0;
       }
       if (!i320) {
        HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i321) {
        i557 = HEAP32[i59 >> 2] | 0;
        HEAP32[i1 >> 2] = i557;
        HEAP32[i1 + 4 >> 2] = i557;
        HEAP32[i1 + 8 >> 2] = i557;
        i1 = i1 + 12 | 0;
       }
       if (i287) {
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i324) {
        f556 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(.00999999977));
        i557 = HEAP32[i21 >> 2] | 0;
        HEAPF32[i1 >> 2] = f556;
        HEAP32[i1 + 4 >> 2] = i557;
        i1 = i1 + 8 | 0;
       }
       if (!i325) {
        i557 = (HEAP32[i83 >> 2] & 2147483647 | 0) == 0 ? i505 : i19;
        HEAP32[i1 >> 2] = HEAP32[i557 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i326) {
        i557 = (HEAP32[i81 >> 2] & 2147483647 | 0) == 0 ? i505 : i18;
        HEAP32[i1 >> 2] = HEAP32[i557 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i557 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i557 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i557 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (i299) {
        HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i14 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i78) {
        HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i17 >> 2];
        HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
        i1 = i1 + 16 | 0;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == 4) break; else i2 = i1;
      }
      i66 = i66 + 1 | 0;
     } while ((i66 | 0) != 4);
    } while (0);
    i76 = i76 + 4 | 0;
   } while (i76 >>> 0 < i160 >>> 0);
  }
  STACKTOP = i508;
  return;
 }
}
function __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) {
 i21 = i21 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i25 + 184 | 0;
 i24 = i25 + 160 | 0;
 i23 = i25 + 136 | 0;
 i22 = i25 + 88 | 0;
 i17 = i25 + 64 | 0;
 i18 = i25 + 40 | 0;
 i16 = i25 + 24 | 0;
 i8 = i25 + 124 | 0;
 i6 = i25 + 112 | 0;
 i7 = i25 + 100 | 0;
 i9 = i25 + 76 | 0;
 i10 = i25 + 12 | 0;
 i11 = i25;
 i4 = i15;
 i2 = i4 - i21 | 0;
 L1 : do if ((i2 | 0) > 1) {
  i3 = (i2 | 0) > 3;
  if (i3) if ((HEAP8[i21 >> 0] | 0) == 103) {
   i5 = (HEAP8[i21 + 1 >> 0] | 0) == 115;
   i1 = i5 ? i21 + 2 | 0 : i21;
  } else {
   i1 = i21;
   i5 = 0;
  } else {
   i1 = i21;
   i5 = 0;
  }
  L7 : do switch (HEAP8[i1 >> 0] | 0) {
  case 76:
   {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_118parse_expr_primaryINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
    break L1;
   }
  case 84:
   {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
    break L1;
   }
  case 102:
   {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_120parse_function_paramINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
    break L1;
   }
  case 97:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 97:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086412 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 100:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086433 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 110:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086433 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 78:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087555 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 83:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087558 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 116:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 97) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 116) {
      i1 = i21;
      break L1;
     }
     i22 = i21 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i22, i15, i20) | 0;
     if ((i1 | 0) == (i22 | 0)) {
      i1 = i21;
      break L1;
     }
     i11 = HEAP32[i20 + 4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i11 | 0)) {
      i1 = i21;
      break L1;
     }
     i10 = i11 + -24 | 0;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i11 + -24 | 0);
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1087560 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     do if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1086288 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      };
      HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i9 = i10 + 11 | 0;
      if ((HEAP8[i9 >> 0] | 0) < 0) {
       HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
       HEAP32[i11 + -20 >> 2] = 0;
       i2 = HEAP8[i9 >> 0] | 0;
       if (i2 << 24 >> 24 < 0) {
        i8 = 0;
        i6 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
        i5 = 1;
       } else i19 = 42;
      } else {
       HEAP8[i10 >> 0] = 0;
       HEAP8[i9 >> 0] = 0;
       i2 = 0;
       i19 = 42;
      }
      if ((i19 | 0) == 42) {
       i8 = i2 & 255;
       i6 = 10;
       i5 = 0;
      }
      i3 = i8 >>> 0 < 11;
      i7 = i3 ? 10 : (i8 + 16 & 496) + -1 | 0;
      L60 : do if ((i7 | 0) != (i6 | 0)) {
       do if (i3) {
        i3 = HEAP32[i10 >> 2] | 0;
        if (i5) {
         i2 = 0;
         i4 = i10;
         i19 = 50;
        } else {
         i5 = 0;
         i6 = 1;
         i4 = i10;
         i19 = 51;
        }
       } else {
        i4 = _malloc(i7 + 1 | 0) | 0;
        if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L60;
        if (i5) {
         i2 = 1;
         i3 = HEAP32[i10 >> 2] | 0;
         i19 = 50;
         break;
        } else {
         i5 = 1;
         i6 = 0;
         i3 = i10;
         i19 = 51;
         break;
        }
       } while (0);
       if ((i19 | 0) == 50) {
        i5 = i2;
        i6 = 1;
        i2 = HEAP32[i11 + -20 >> 2] | 0;
       } else if ((i19 | 0) == 51) i2 = i2 & 255;
       i2 = i2 + 1 | 0;
       if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
       if (i6) _free(i3);
       if (i5) {
        HEAP32[i11 + -16 >> 2] = i7 + 1 | -2147483648;
        HEAP32[i11 + -20 >> 2] = i8;
        HEAP32[i10 >> 2] = i4;
        break;
       } else {
        HEAP8[i9 >> 0] = i8;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i26 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
      break L1;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     ___resumeException(i1 | 0);
    }
   case 122:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 97) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 122) {
      i1 = i21;
      break L1;
     }
     i22 = i21 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i22, i15, i20) | 0;
     if ((i1 | 0) == (i22 | 0)) {
      i1 = i21;
      break L1;
     }
     i11 = HEAP32[i20 + 4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i11 | 0)) {
      i1 = i21;
      break L1;
     }
     i10 = i11 + -24 | 0;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i11 + -24 | 0);
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1087560 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     do if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1086288 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      };
      HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i8 = i10 + 11 | 0;
      if ((HEAP8[i8 >> 0] | 0) < 0) {
       HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
       HEAP32[i11 + -20 >> 2] = 0;
       i2 = HEAP8[i8 >> 0] | 0;
       if (i2 << 24 >> 24 < 0) {
        i9 = 0;
        i6 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
        i5 = 1;
       } else i19 = 83;
      } else {
       HEAP8[i10 >> 0] = 0;
       HEAP8[i8 >> 0] = 0;
       i2 = 0;
       i19 = 83;
      }
      if ((i19 | 0) == 83) {
       i9 = i2 & 255;
       i6 = 10;
       i5 = 0;
      }
      i3 = i9 >>> 0 < 11;
      i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
      L115 : do if ((i7 | 0) != (i6 | 0)) {
       do if (i3) {
        i3 = HEAP32[i10 >> 2] | 0;
        if (i5) {
         i2 = 0;
         i4 = i10;
         i19 = 91;
        } else {
         i5 = 0;
         i6 = 1;
         i4 = i10;
         i19 = 92;
        }
       } else {
        i4 = _malloc(i7 + 1 | 0) | 0;
        if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L115;
        if (i5) {
         i2 = 1;
         i3 = HEAP32[i10 >> 2] | 0;
         i19 = 91;
         break;
        } else {
         i5 = 1;
         i6 = 0;
         i3 = i10;
         i19 = 92;
         break;
        }
       } while (0);
       if ((i19 | 0) == 91) {
        i5 = i2;
        i6 = 1;
        i2 = HEAP32[i11 + -20 >> 2] | 0;
       } else if ((i19 | 0) == 92) i2 = i2 & 255;
       i2 = i2 + 1 | 0;
       if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
       if (i6) _free(i3);
       if (i5) {
        HEAP32[i11 + -16 >> 2] = i7 + 1 | -2147483648;
        HEAP32[i11 + -20 >> 2] = i9;
        HEAP32[i10 >> 2] = i4;
        break;
       } else {
        HEAP8[i8 >> 0] = i9;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i26 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
      break L1;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     ___resumeException(i1 | 0);
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 99:
   {
    switch (HEAP8[i1 + 1 >> 0] | 0) {
    case 99:
     {
      L146 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 99) if ((HEAP8[i21 + 1 >> 0] | 0) == 99) {
       i19 = i21 + 2 | 0;
       i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
       if ((i2 | 0) == (i19 | 0)) i1 = i21; else {
        i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
        if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
         i5 = i20 + 4 | 0;
         i2 = HEAP32[i5 >> 2] | 0;
         if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) i1 = i21; else {
          __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
          i2 = HEAP32[i5 >> 2] | 0;
          i3 = i2 + -24 | 0;
          i4 = i2;
          while (1) {
           if ((i4 | 0) == (i3 | 0)) break;
           i21 = i4 + -24 | 0;
           HEAP32[i5 >> 2] = i21;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
           i4 = HEAP32[i5 >> 2] | 0;
          }
          i4 = i2 + -48 | 0;
          __THREW__ = 0;
          invoke_vii(fb + 4619 | 0, i16 | 0, i4 | 0);
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           __THREW__ = 0;
           i3 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1087570 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __THREW__ = 0;
            i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087582 | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i3 = HEAP8[i26 + 11 >> 0] | 0;
             i21 = i3 << 24 >> 24 < 0;
             __THREW__ = 0;
             i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             do if (i21 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
             } else {
              HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
              HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
              HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
              i2 = 0;
              while (1) {
               if ((i2 | 0) == 3) break;
               HEAP32[i3 + (i2 << 2) >> 2] = 0;
               i2 = i2 + 1 | 0;
              }
              __THREW__ = 0;
              i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086288 | 0) | 0;
              i21 = __THREW__;
              __THREW__ = 0;
              if (i21 & 1) {
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
               break;
              };
              HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
              HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
              HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
              i2 = 0;
              while (1) {
               if ((i2 | 0) == 3) break;
               HEAP32[i3 + (i2 << 2) >> 2] = 0;
               i2 = i2 + 1 | 0;
              }
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i23);
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
              break L146;
             } while (0);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          ___resumeException(i1 | 0);
         }
        }
       }
      } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
      break L1;
     }
    case 108:
     {
      if (!i3) {
       i1 = i21;
       break L1;
      }
      if ((HEAP8[i21 >> 0] | 0) != 99) {
       i1 = i21;
       break L1;
      }
      if ((HEAP8[i21 + 1 >> 0] | 0) != 108) {
       i1 = i21;
       break L1;
      }
      i24 = i21 + 2 | 0;
      i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i24, i15, i20) | 0;
      if ((i2 | 0) == (i24 | 0) | (i2 | 0) == (i15 | 0)) {
       i1 = i21;
       break L1;
      }
      i12 = i20 + 4 | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      if ((HEAP32[i20 >> 2] | 0) == (i1 | 0)) {
       i1 = i21;
       break L1;
      }
      i23 = i1 + -12 | 0;
      i11 = HEAP8[i23 + 11 >> 0] | 0;
      i24 = i11 << 24 >> 24 < 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj(i1 + -24 | 0, i24 ? HEAP32[i23 >> 2] | 0 : i23, i24 ? HEAP32[i1 + -8 >> 2] | 0 : i11 & 255) | 0;
      i11 = HEAP32[i12 >> 2] | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i26 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      i8 = i11 + -12 | 0;
      i9 = i8 + 11 | 0;
      if ((HEAP8[i9 >> 0] | 0) < 0) {
       HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
       HEAP32[i11 + -8 >> 2] = 0;
       i1 = HEAP8[i9 >> 0] | 0;
       if (i1 << 24 >> 24 < 0) {
        i6 = 1;
        i10 = 0;
        i5 = (HEAP32[i11 + -4 >> 2] & 2147483647) + -1 | 0;
       } else i19 = 157;
      } else {
       HEAP8[i8 >> 0] = 0;
       HEAP8[i9 >> 0] = 0;
       i1 = 0;
       i19 = 157;
      }
      if ((i19 | 0) == 157) {
       i6 = 0;
       i10 = i1 & 255;
       i5 = 10;
      }
      i3 = i10 >>> 0 < 11;
      i7 = i3 ? 10 : (i10 + 16 & 496) + -1 | 0;
      L210 : do if ((i7 | 0) != (i5 | 0)) {
       do if (i3) {
        i3 = HEAP32[i8 >> 2] | 0;
        if (i6) {
         i1 = 0;
         i4 = i8;
         i19 = 165;
        } else {
         i5 = 0;
         i6 = 1;
         i4 = i8;
         i19 = 166;
        }
       } else {
        i4 = _malloc(i7 + 1 | 0) | 0;
        if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L210;
        if (i6) {
         i1 = 1;
         i3 = HEAP32[i8 >> 2] | 0;
         i19 = 165;
         break;
        } else {
         i5 = 1;
         i6 = 0;
         i3 = i8;
         i19 = 166;
         break;
        }
       } while (0);
       if ((i19 | 0) == 165) {
        i5 = i1;
        i6 = 1;
        i1 = HEAP32[i11 + -8 >> 2] | 0;
       } else if ((i19 | 0) == 166) i1 = i1 & 255;
       i1 = i1 + 1 | 0;
       if (i1 | 0) _memcpy(i4 | 0, i3 | 0, i1 | 0) | 0;
       if (i6) _free(i3);
       if (i5) {
        HEAP32[i11 + -4 >> 2] = i7 + 1 | -2147483648;
        HEAP32[i11 + -8 >> 2] = i10;
        HEAP32[i8 >> 2] = i4;
        break;
       } else {
        HEAP8[i9 >> 0] = i10;
        break;
       }
      } while (0);
      HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i26 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086383 | 0) | 0;
      i6 = i26 + 11 | 0;
      i7 = i26 + 4 | 0;
      while (1) {
       if ((HEAP8[i2 >> 0] | 0) == 69) {
        i19 = 190;
        break;
       }
       i5 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
       if ((i5 | 0) == (i2 | 0) | (i5 | 0) == (i15 | 0)) {
        i1 = i21;
        break L1;
       }
       i1 = HEAP32[i12 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i1 | 0)) {
        i1 = i21;
        break L1;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i1 + -24 | 0);
       i3 = HEAP32[i12 >> 2] | 0;
       i4 = i3 + -24 | 0;
       i1 = i3;
       while (1) {
        if ((i1 | 0) == (i4 | 0)) break;
        i24 = i1 + -24 | 0;
        HEAP32[i12 >> 2] = i24;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
        i1 = HEAP32[i12 >> 2] | 0;
       }
       i2 = HEAP8[i6 >> 0] | 0;
       i1 = i2 << 24 >> 24 < 0;
       i2 = i1 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
       if (i2 | 0) {
        if ((HEAP32[i20 >> 2] | 0) == (i4 | 0)) {
         i19 = 189;
         break;
        }
        __THREW__ = 0;
        invoke_iiii(fb + 519 | 0, i3 + -48 | 0, (i1 ? HEAP32[i26 >> 2] | 0 : i26) | 0, i2 | 0) | 0;
        i24 = __THREW__;
        __THREW__ = 0;
        if (i24 & 1) {
         i19 = 186;
         break;
        }
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i2 = i5;
      }
      if ((i19 | 0) == 186) {
       i25 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       ___resumeException(i25 | 0);
      } else if ((i19 | 0) == 189) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i1 = i21;
       break L1;
      } else if ((i19 | 0) == 190) {
       i1 = HEAP32[i12 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i1 | 0)) {
        i1 = i21;
        break L1;
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i1 + -24 | 0, gb + 1086288 | 0) | 0;
       i1 = i2 + 1 | 0;
       break L1;
      }
      break;
     }
    case 109:
     {
      i2 = i21 + 2 | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087585 | 0, 1);
      __THREW__ = 0;
      i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (i24 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L7;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
       break L1;
      }
     }
    case 111:
     {
      i2 = i21 + 2 | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086597 | 0, 1);
      __THREW__ = 0;
      i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (i24 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L7;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
       break L1;
      }
     }
    case 118:
     {
      L264 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 99) if ((HEAP8[i21 + 1 >> 0] | 0) == 118) {
       i14 = i20 + 63 | 0;
       i13 = HEAP8[i14 >> 0] | 0;
       HEAP8[i14 >> 0] = 0;
       i19 = i21 + 2 | 0;
       i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
       HEAP8[i14 >> 0] = i13;
       if ((i2 | 0) == (i19 | 0) | (i2 | 0) == (i15 | 0)) i1 = i21; else {
        if ((HEAP8[i2 >> 0] | 0) == 95) {
         i1 = i2 + 1 | 0;
         if ((i1 | 0) == (i15 | 0)) {
          i1 = i21;
          break;
         }
         i2 = HEAP8[i1 >> 0] | 0;
         L272 : do if (i2 << 24 >> 24 == 69) {
          i4 = i20 + 4 | 0;
          i3 = HEAP32[i4 >> 2] | 0;
          i19 = HEAP32[i20 + 8 >> 2] | 0;
          i5 = i19;
          if (i3 >>> 0 < i19 >>> 0) {
           HEAP32[i3 >> 2] = 0;
           HEAP32[i3 + 4 >> 2] = 0;
           HEAP32[i3 + 8 >> 2] = 0;
           HEAP32[i3 + 12 >> 2] = 0;
           HEAP32[i3 + 16 >> 2] = 0;
           HEAP32[i3 + 20 >> 2] = 0;
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           i3 = i3 + 12 | 0;
           HEAP32[i3 >> 2] = 0;
           HEAP32[i3 + 4 >> 2] = 0;
           HEAP32[i3 + 8 >> 2] = 0;
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 24;
           break;
          }
          i4 = HEAP32[i20 >> 2] | 0;
          i2 = (i3 - i4 | 0) / 24 | 0;
          i3 = i2 + 1 | 0;
          if (i3 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i20);
          i5 = (i5 - i4 | 0) / 24 | 0;
          i4 = i5 << 1;
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i5 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970, i2, i20 + 12 | 0);
          i4 = i26 + 8 | 0;
          i5 = HEAP32[i4 >> 2] | 0;
          HEAP32[i5 >> 2] = 0;
          HEAP32[i5 + 4 >> 2] = 0;
          HEAP32[i5 + 8 >> 2] = 0;
          HEAP32[i5 + 12 >> 2] = 0;
          HEAP32[i5 + 16 >> 2] = 0;
          HEAP32[i5 + 20 >> 2] = 0;
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i5 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          i3 = i5 + 12 | 0;
          HEAP32[i3 >> 2] = 0;
          HEAP32[i3 + 4 >> 2] = 0;
          HEAP32[i3 + 8 >> 2] = 0;
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i3 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          HEAP32[i4 >> 2] = i5 + 24;
          __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i20, i26);
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
         } else while (1) {
          if (i2 << 24 >> 24 == 69) break L272;
          i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i15, i20) | 0;
          i3 = (i2 | 0) == (i1 | 0) | (i2 | 0) == (i15 | 0);
          if (i3) {
           i1 = i21;
           break L264;
          }
          i19 = HEAP8[(i3 ? i1 : i2) >> 0] | 0;
          i1 = i2;
          i2 = i19;
         } while (0);
         i1 = i1 + 1 | 0;
        } else {
         i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
         if ((i1 | 0) == (i2 | 0)) {
          i1 = i21;
          break;
         }
        }
        i5 = i20 + 4 | 0;
        i2 = HEAP32[i5 >> 2] | 0;
        if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) i1 = i21; else {
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i21 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i21;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         i4 = i2 + -48 | 0;
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i16 | 0, i4 | 0);
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1086383 | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __THREW__ = 0;
           i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087587 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            i3 = HEAP8[i26 + 11 >> 0] | 0;
            i21 = i3 << 24 >> 24 < 0;
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            do if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086288 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
              break;
             };
             HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i23);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             break L264;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         ___resumeException(i1 | 0);
        }
       }
      } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
      break L1;
     }
    default:
     {
      i1 = i21;
      break L1;
     }
    }
    break;
   }
  case 100:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 97:
    {
     i18 = i1 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i18, i15, i20) | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i21;
      break L1;
     }
     i4 = i20 + 4 | 0;
     i11 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i11 | 0)) {
      i1 = i21;
      break L1;
     }
     i10 = i11 + -24 | 0;
     HEAP32[i23 >> 2] = 0;
     HEAP32[i23 + 4 >> 2] = 0;
     HEAP32[i23 + 8 >> 2] = 0;
     L349 : do if (i5) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i23, gb + 1086571 | 0, 2); else {
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break L349;
       HEAP32[i23 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
     } while (0);
     __THREW__ = 0;
     i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1087590 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4619 | 0, i22 | 0, (HEAP32[i4 >> 2] | 0) + -24 | 0);
      i21 = __THREW__;
      __THREW__ = 0;
      do if (i21 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       i3 = HEAP8[i22 + 11 >> 0] | 0;
       i21 = i3 << 24 >> 24 < 0;
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 519 | 0, i24 | 0, (i21 ? HEAP32[i22 >> 2] | 0 : i22) | 0, (i21 ? HEAP32[i22 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
       i21 = __THREW__;
       __THREW__ = 0;
       if (i21 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        break;
       };
       HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i8 = i10 + 11 | 0;
       if ((HEAP8[i8 >> 0] | 0) < 0) {
        HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
        HEAP32[i11 + -20 >> 2] = 0;
        i2 = HEAP8[i8 >> 0] | 0;
        if (i2 << 24 >> 24 < 0) {
         i6 = 1;
         i9 = 0;
         i5 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
        } else i19 = 280;
       } else {
        HEAP8[i10 >> 0] = 0;
        HEAP8[i8 >> 0] = 0;
        i2 = 0;
        i19 = 280;
       }
       if ((i19 | 0) == 280) {
        i6 = 0;
        i9 = i2 & 255;
        i5 = 10;
       }
       i3 = i9 >>> 0 < 11;
       i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
       L380 : do if ((i7 | 0) != (i5 | 0)) {
        do if (i3) {
         i3 = HEAP32[i10 >> 2] | 0;
         if (i6) {
          i2 = 0;
          i4 = i10;
          i19 = 288;
         } else {
          i5 = 0;
          i6 = 1;
          i4 = i10;
          i19 = 289;
         }
        } else {
         i4 = _malloc(i7 + 1 | 0) | 0;
         if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L380;
         if (i6) {
          i2 = 1;
          i3 = HEAP32[i10 >> 2] | 0;
          i19 = 288;
          break;
         } else {
          i5 = 1;
          i6 = 0;
          i3 = i10;
          i19 = 289;
          break;
         }
        } while (0);
        if ((i19 | 0) == 288) {
         i5 = i2;
         i6 = 1;
         i2 = HEAP32[i11 + -20 >> 2] | 0;
        } else if ((i19 | 0) == 289) i2 = i2 & 255;
        i2 = i2 + 1 | 0;
        if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
        if (i6) _free(i3);
        if (i5) {
         HEAP32[i11 + -16 >> 2] = i7 + 1 | -2147483648;
         HEAP32[i11 + -20 >> 2] = i9;
         HEAP32[i10 >> 2] = i4;
         break;
        } else {
         HEAP8[i8 >> 0] = i9;
         break;
        }
       } while (0);
       HEAP32[i10 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i10 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i10 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i26 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
       break L1;
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     break L7;
    }
   case 99:
    {
     L410 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 100) if ((HEAP8[i21 + 1 >> 0] | 0) == 99) {
      i19 = i21 + 2 | 0;
      i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
      if ((i2 | 0) == (i19 | 0)) i1 = i21; else {
       i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
       if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
        i5 = i20 + 4 | 0;
        i2 = HEAP32[i5 >> 2] | 0;
        if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) i1 = i21; else {
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i21 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i21;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         i4 = i2 + -48 | 0;
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i16 | 0, i4 | 0);
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1087600 | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __THREW__ = 0;
           i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087582 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            i3 = HEAP8[i26 + 11 >> 0] | 0;
            i21 = i3 << 24 >> 24 < 0;
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            do if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086288 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
              break;
             };
             HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i23);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             break L410;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         ___resumeException(i1 | 0);
        }
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 101:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086428 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 108:
    {
     i18 = i1 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i18, i15, i20) | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i21;
      break L1;
     }
     i4 = i20 + 4 | 0;
     i11 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i11 | 0)) {
      i1 = i21;
      break L1;
     }
     i10 = i11 + -24 | 0;
     HEAP32[i23 >> 2] = 0;
     HEAP32[i23 + 4 >> 2] = 0;
     HEAP32[i23 + 8 >> 2] = 0;
     L464 : do if (i5) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i23, gb + 1086571 | 0, 2); else {
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break L464;
       HEAP32[i23 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
     } while (0);
     __THREW__ = 0;
     i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1087614 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4619 | 0, i22 | 0, (HEAP32[i4 >> 2] | 0) + -24 | 0);
      i21 = __THREW__;
      __THREW__ = 0;
      do if (i21 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       i3 = HEAP8[i22 + 11 >> 0] | 0;
       i21 = i3 << 24 >> 24 < 0;
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 519 | 0, i24 | 0, (i21 ? HEAP32[i22 >> 2] | 0 : i22) | 0, (i21 ? HEAP32[i22 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
       i21 = __THREW__;
       __THREW__ = 0;
       if (i21 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        break;
       };
       HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i8 = i10 + 11 | 0;
       if ((HEAP8[i8 >> 0] | 0) < 0) {
        HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
        HEAP32[i11 + -20 >> 2] = 0;
        i2 = HEAP8[i8 >> 0] | 0;
        if (i2 << 24 >> 24 < 0) {
         i6 = 1;
         i9 = 0;
         i5 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
        } else i19 = 366;
       } else {
        HEAP8[i10 >> 0] = 0;
        HEAP8[i8 >> 0] = 0;
        i2 = 0;
        i19 = 366;
       }
       if ((i19 | 0) == 366) {
        i6 = 0;
        i9 = i2 & 255;
        i5 = 10;
       }
       i3 = i9 >>> 0 < 11;
       i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
       L495 : do if ((i7 | 0) != (i5 | 0)) {
        do if (i3) {
         i3 = HEAP32[i10 >> 2] | 0;
         if (i6) {
          i2 = 0;
          i4 = i10;
          i19 = 374;
         } else {
          i5 = 0;
          i6 = 1;
          i4 = i10;
          i19 = 375;
         }
        } else {
         i4 = _malloc(i7 + 1 | 0) | 0;
         if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L495;
         if (i6) {
          i2 = 1;
          i3 = HEAP32[i10 >> 2] | 0;
          i19 = 374;
          break;
         } else {
          i5 = 1;
          i6 = 0;
          i3 = i10;
          i19 = 375;
          break;
         }
        } while (0);
        if ((i19 | 0) == 374) {
         i5 = i2;
         i6 = 1;
         i2 = HEAP32[i11 + -20 >> 2] | 0;
        } else if ((i19 | 0) == 375) i2 = i2 & 255;
        i2 = i2 + 1 | 0;
        if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
        if (i6) _free(i3);
        if (i5) {
         HEAP32[i11 + -16 >> 2] = i7 + 1 | -2147483648;
         HEAP32[i11 + -20 >> 2] = i9;
         HEAP32[i10 >> 2] = i4;
         break;
        } else {
         HEAP8[i8 >> 0] = i9;
         break;
        }
       } while (0);
       HEAP32[i10 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i10 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i10 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i26 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
       break L1;
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     break L7;
    }
   case 110:
    {
     i1 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
     break L1;
    }
   case 115:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 100) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 115) {
      i1 = i21;
      break L1;
     }
     i23 = i21 + 2 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i23, i15, i20) | 0;
     if ((i2 | 0) == (i23 | 0)) {
      i1 = i21;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i5 = i20 + 4 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i21;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i23 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i23;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     __THREW__ = 0;
     invoke_viii(fb + 1067 | 0, i24 | 0, gb + 1087622 | 0, i26 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     do if (i23 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i23 = HEAP8[i24 + 11 >> 0] | 0;
      i22 = i23 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i22 ? HEAP32[i24 >> 2] | 0 : i24) | 0, (i22 ? HEAP32[i24 + 4 >> 2] | 0 : i23 & 255) | 0) | 0;
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L1;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
     ___resumeException(i1 | 0);
    }
   case 116:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 100) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 116) {
      i1 = i21;
      break L1;
     }
     i23 = i21 + 2 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i23, i15, i20) | 0;
     if ((i2 | 0) == (i23 | 0)) {
      i1 = i21;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i5 = i20 + 4 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i21;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i23 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i23;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     __THREW__ = 0;
     invoke_viii(fb + 1067 | 0, i24 | 0, gb + 1087625 | 0, i26 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     do if (i23 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i23 = HEAP8[i24 + 11 >> 0] | 0;
      i22 = i23 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i22 ? HEAP32[i24 >> 2] | 0 : i24) | 0, (i22 ? HEAP32[i24 + 4 >> 2] | 0 : i23 & 255) | 0) | 0;
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L1;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
     ___resumeException(i1 | 0);
    }
   case 118:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087627 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 86:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087629 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 101:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 111:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087632 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 79:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087634 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 113:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087637 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 103:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 101:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087640 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 116:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086447 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 105:
   {
    if ((HEAP8[i1 + 1 >> 0] | 0) != 120) {
     i1 = i21;
     break L1;
    }
    i19 = i21 + 2 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
    if ((i2 | 0) == (i19 | 0)) {
     i1 = i21;
     break L1;
    }
    i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
    i5 = i20 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = i2 + -24 | 0;
     while (1) {
      if ((i2 | 0) == (i1 | 0)) {
       i1 = i21;
       break L1;
      }
      i26 = i2 + -24 | 0;
      HEAP32[i5 >> 2] = i26;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      i2 = HEAP32[i5 >> 2] | 0;
     }
    }
    i2 = HEAP32[i5 >> 2] | 0;
    if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
     i1 = i21;
     break L1;
    }
    __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i2 + -24 | 0;
    i4 = i2;
    while (1) {
     if ((i4 | 0) == (i3 | 0)) break;
     i21 = i4 + -24 | 0;
     HEAP32[i5 >> 2] = i21;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
     i4 = HEAP32[i5 >> 2] | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4619 | 0, i24 | 0, i2 + -48 | 0);
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i4 = (HEAP32[i5 >> 2] | 0) + -24 | 0;
     __THREW__ = 0;
     invoke_viii(fb + 1067 | 0, i18 | 0, gb + 1086383 | 0, i24 | 0);
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087643 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i3 = HEAP8[i26 + 11 >> 0] | 0;
       i21 = i3 << 24 >> 24 < 0;
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
       i21 = __THREW__;
       __THREW__ = 0;
       do if (i21 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __THREW__ = 0;
        i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086372 | 0) | 0;
        i21 = __THREW__;
        __THREW__ = 0;
        if (i21 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
         break;
        };
        HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i23, i8);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i23);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
        break L1;
       } while (0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
    break;
   }
  case 108:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 101:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087646 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 115:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087649 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 83:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087652 | 0, 3);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 116:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086445 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 109:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 105:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087656 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 73:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087658 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 108:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1086428 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 76:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087661 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 109:
    {
     i2 = i21 + 2 | 0;
     if ((i2 | 0) != (i15 | 0)) if ((HEAP8[i2 >> 0] | 0) == 95) {
      i2 = i21 + 3 | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087664 | 0, 2);
      __THREW__ = 0;
      i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (i24 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L7;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
       break L1;
      }
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i2 = HEAP32[i20 + 4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i4 = i2 + -24 | 0;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i4);
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1086383 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     do if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1087667 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      };
      HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i6);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
      break L1;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     break L7;
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 110:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 119:
   case 97:
    {
     L702 : do if (i3) {
      i1 = HEAP8[i21 >> 0] | 0;
      if (i1 << 24 >> 24 == 103) {
       i14 = (HEAP8[i21 + 1 >> 0] | 0) == 115;
       i1 = i14 ? i21 + 2 | 0 : i21;
       i2 = i1;
       i1 = HEAP8[i1 >> 0] | 0;
      } else {
       i14 = 0;
       i2 = i21;
      }
      if (i1 << 24 >> 24 == 110) {
       i1 = HEAP8[i2 + 1 >> 0] | 0;
       switch (i1 << 24 >> 24) {
       case 97:
       case 119:
        break;
       default:
        {
         i1 = i21;
         break L702;
        }
       }
       i13 = i1 << 24 >> 24 == 97;
       i1 = i2 + 2 | 0;
       L709 : do if ((i1 | 0) != (i15 | 0)) {
        i11 = 0;
        while (1) {
         if ((HEAP8[i1 >> 0] | 0) == 95) break;
         i3 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i15, i20) | 0;
         i1 = (i3 | 0) == (i1 | 0);
         i2 = (i3 | 0) == (i15 | 0);
         if (i1 | i2) break L709; else {
          i11 = i11 | (i1 | i2) ^ 1;
          i1 = i3;
         }
        }
        i12 = i1 + 1 | 0;
        i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i12, i15, i20) | 0;
        if (!((i2 | 0) == (i12 | 0) | (i2 | 0) == (i15 | 0))) {
         i1 = HEAP8[i2 >> 0] | 0;
         L715 : do if ((i4 - i2 | 0) > 2 & i1 << 24 >> 24 == 112) {
          if ((HEAP8[i2 + 1 >> 0] | 0) != 105) break L709;
          i1 = i2 + 2 | 0;
          while (1) {
           if ((HEAP8[i1 >> 0] | 0) == 69) {
            i10 = 1;
            i12 = i1;
            break L715;
           }
           i12 = i1;
           i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i15, i20) | 0;
           if ((i1 | 0) == (i12 | 0) | (i1 | 0) == (i15 | 0)) break L709;
          }
         } else if (i1 << 24 >> 24 == 69) {
          i10 = 0;
          i12 = i2;
         } else break L709; while (0);
         HEAP32[i24 >> 2] = 0;
         HEAP32[i24 + 4 >> 2] = 0;
         HEAP32[i24 + 8 >> 2] = 0;
         i1 = 0;
         while (1) {
          if ((i1 | 0) == 3) break;
          HEAP32[i24 + (i1 << 2) >> 2] = 0;
          i1 = i1 + 1 | 0;
         }
         L727 : do if (i10) {
          i9 = i20 + 4 | 0;
          i1 = HEAP32[i9 >> 2] | 0;
          if ((HEAP32[i20 >> 2] | 0) == (i1 | 0)) {
           i1 = i21;
           i2 = 1;
           i19 = 660;
          } else {
           __THREW__ = 0;
           invoke_vii(fb + 4619 | 0, i26 | 0, i1 + -24 | 0);
           i15 = __THREW__;
           __THREW__ = 0;
           if (i15 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            i19 = 663;
            break;
           }
           i7 = i24 + 11 | 0;
           if ((HEAP8[i7 >> 0] | 0) < 0) {
            HEAP8[HEAP32[i24 >> 2] >> 0] = 0;
            HEAP32[i24 + 4 >> 2] = 0;
            i1 = HEAP8[i7 >> 0] | 0;
            if (i1 << 24 >> 24 < 0) {
             i8 = 0;
             i5 = (HEAP32[i24 + 8 >> 2] & 2147483647) + -1 | 0;
             i4 = 1;
            } else i19 = 552;
           } else {
            HEAP8[i24 >> 0] = 0;
            HEAP8[i7 >> 0] = 0;
            i1 = 0;
            i19 = 552;
           }
           if ((i19 | 0) == 552) {
            i8 = i1 & 255;
            i5 = 10;
            i4 = 0;
           }
           i2 = i8 >>> 0 < 11;
           i6 = i2 ? 10 : (i8 + 16 & 496) + -1 | 0;
           L740 : do if ((i6 | 0) != (i5 | 0)) {
            do if (i2) {
             i2 = HEAP32[i24 >> 2] | 0;
             if (i4) {
              i1 = 0;
              i3 = i24;
              i19 = 559;
             } else {
              i4 = 0;
              i5 = 1;
              i3 = i24;
              i19 = 560;
             }
            } else {
             i3 = _malloc(i6 + 1 | 0) | 0;
             if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L740;
             if (!i4) {
              i4 = 1;
              i5 = 0;
              i2 = i24;
              i19 = 560;
              break;
             }
             i1 = 1;
             i2 = HEAP32[i24 >> 2] | 0;
             i19 = 559;
            } while (0);
            if ((i19 | 0) == 559) {
             i4 = i1;
             i5 = 1;
             i1 = HEAP32[i24 + 4 >> 2] | 0;
            } else if ((i19 | 0) == 560) i1 = i1 & 255;
            i1 = i1 + 1 | 0;
            if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
            if (i5) _free(i2);
            if (i4) {
             HEAP32[i24 + 8 >> 2] = i6 + 1 | -2147483648;
             HEAP32[i24 + 4 >> 2] = i8;
             HEAP32[i24 >> 2] = i3;
             break;
            } else {
             HEAP8[i7 >> 0] = i8;
             break;
            }
           } while (0);
           HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
           HEAP32[i24 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
           HEAP32[i24 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
           i1 = 0;
           while (1) {
            if ((i1 | 0) == 3) break;
            HEAP32[i26 + (i1 << 2) >> 2] = 0;
            i1 = i1 + 1 | 0;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           i1 = HEAP32[i9 >> 2] | 0;
           i2 = i1 + -24 | 0;
           while (1) {
            if ((i1 | 0) == (i2 | 0)) {
             i4 = i20;
             i1 = i2;
             i19 = 576;
             break L727;
            }
            i19 = i1 + -24 | 0;
            HEAP32[i9 >> 2] = i19;
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i19);
            i1 = HEAP32[i9 >> 2] | 0;
           }
          }
         } else {
          i1 = i20 + 4 | 0;
          i9 = i1;
          i4 = i20;
          i1 = HEAP32[i1 >> 2] | 0;
          i19 = 576;
         } while (0);
         do if ((i19 | 0) == 576) if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
          i1 = i21;
          i2 = 1;
          i19 = 660;
         } else {
          __THREW__ = 0;
          invoke_vii(fb + 4619 | 0, i23 | 0, i1 + -24 | 0);
          i15 = __THREW__;
          __THREW__ = 0;
          if (i15 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           i19 = 663;
           break;
          }
          i2 = HEAP32[i9 >> 2] | 0;
          i3 = i2 + -24 | 0;
          i1 = i2;
          while (1) {
           if ((i1 | 0) == (i3 | 0)) break;
           i15 = i1 + -24 | 0;
           HEAP32[i9 >> 2] = i15;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
           i1 = HEAP32[i9 >> 2] | 0;
          }
          HEAP32[i22 >> 2] = 0;
          HEAP32[i22 + 4 >> 2] = 0;
          HEAP32[i22 + 8 >> 2] = 0;
          i1 = 0;
          while (1) {
           if ((i1 | 0) == 3) break;
           HEAP32[i22 + (i1 << 2) >> 2] = 0;
           i1 = i1 + 1 | 0;
          }
          L783 : do if (i11) if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) {
           i1 = i21;
           i2 = 1;
           i19 = 659;
          } else {
           __THREW__ = 0;
           invoke_vii(fb + 4619 | 0, i26 | 0, i2 + -48 | 0);
           i15 = __THREW__;
           __THREW__ = 0;
           if (i15 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            i19 = 662;
            break;
           }
           i7 = i22 + 11 | 0;
           do if ((HEAP8[i7 >> 0] | 0) < 0) {
            HEAP8[HEAP32[i22 >> 2] >> 0] = 0;
            HEAP32[i22 + 4 >> 2] = 0;
            i1 = HEAP8[i7 >> 0] | 0;
            if (i1 << 24 >> 24 >= 0) {
             i19 = 591;
             break;
            }
            i8 = 0;
            i5 = (HEAP32[i22 + 8 >> 2] & 2147483647) + -1 | 0;
            i4 = 1;
           } else {
            HEAP8[i22 >> 0] = 0;
            HEAP8[i7 >> 0] = 0;
            i1 = 0;
            i19 = 591;
           } while (0);
           if ((i19 | 0) == 591) {
            i8 = i1 & 255;
            i5 = 10;
            i4 = 0;
           }
           i2 = i8 >>> 0 < 11;
           i6 = i2 ? 10 : (i8 + 16 & 496) + -1 | 0;
           L796 : do if ((i6 | 0) != (i5 | 0)) {
            do if (i2) {
             i2 = HEAP32[i22 >> 2] | 0;
             if (i4) {
              i1 = 0;
              i3 = i22;
              i19 = 598;
             } else {
              i4 = 0;
              i5 = 1;
              i3 = i22;
              i19 = 599;
             }
            } else {
             i3 = _malloc(i6 + 1 | 0) | 0;
             if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L796;
             if (!i4) {
              i4 = 1;
              i5 = 0;
              i2 = i22;
              i19 = 599;
              break;
             }
             i1 = 1;
             i2 = HEAP32[i22 >> 2] | 0;
             i19 = 598;
            } while (0);
            if ((i19 | 0) == 598) {
             i4 = i1;
             i5 = 1;
             i1 = HEAP32[i22 + 4 >> 2] | 0;
            } else if ((i19 | 0) == 599) i1 = i1 & 255;
            i1 = i1 + 1 | 0;
            if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
            if (i5) _free(i2);
            if (i4) {
             HEAP32[i22 + 8 >> 2] = i6 + 1 | -2147483648;
             HEAP32[i22 + 4 >> 2] = i8;
             HEAP32[i22 >> 2] = i3;
             break;
            } else {
             HEAP8[i7 >> 0] = i8;
             break;
            }
           } while (0);
           HEAP32[i22 >> 2] = HEAP32[i26 >> 2];
           HEAP32[i22 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
           HEAP32[i22 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
           i1 = 0;
           while (1) {
            if ((i1 | 0) == 3) break;
            HEAP32[i26 + (i1 << 2) >> 2] = 0;
            i1 = i1 + 1 | 0;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           i2 = HEAP32[i9 >> 2] | 0;
           i1 = i2 + -24 | 0;
           while (1) {
            if ((i2 | 0) == (i1 | 0)) {
             i19 = 614;
             break L783;
            }
            i19 = i2 + -24 | 0;
            HEAP32[i9 >> 2] = i19;
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i19);
            i2 = HEAP32[i9 >> 2] | 0;
           }
          } else i19 = 614; while (0);
          L824 : do if ((i19 | 0) == 614) {
           HEAP32[i17 >> 2] = 0;
           HEAP32[i17 + 4 >> 2] = 0;
           HEAP32[i17 + 8 >> 2] = 0;
           i1 = 0;
           while (1) {
            if ((i1 | 0) == 3) break;
            HEAP32[i17 + (i1 << 2) >> 2] = 0;
            i1 = i1 + 1 | 0;
           }
           if (i14) {
            __THREW__ = 0;
            invoke_viii(fb + 1068 | 0, i17 | 0, gb + 1086571 | 0, 2);
            i19 = __THREW__;
            __THREW__ = 0;
            if (i19 & 1) i19 = 619; else i19 = 620;
           } else i19 = 620;
           L832 : do if ((i19 | 0) == 620) {
            if (i13) {
             __THREW__ = 0;
             invoke_iii(fb + 1152 | 0, i17 | 0, gb + 1087671 | 0) | 0;
             i15 = __THREW__;
             __THREW__ = 0;
             if (i15 & 1) {
              i19 = 619;
              break;
             }
            } else {
             __THREW__ = 0;
             invoke_iii(fb + 1152 | 0, i17 | 0, gb + 1086395 | 0) | 0;
             i15 = __THREW__;
             __THREW__ = 0;
             if (i15 & 1) {
              i19 = 619;
              break;
             }
            }
            L838 : do if (i11) {
             __THREW__ = 0;
             invoke_viii(fb + 1067 | 0, i18 | 0, gb + 1086383 | 0, i22 | 0);
             i15 = __THREW__;
             __THREW__ = 0;
             if (i15 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
             } else {
              __THREW__ = 0;
              i2 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087675 | 0) | 0;
              i15 = __THREW__;
              __THREW__ = 0;
              do if (i15 & 1) {
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
              } else {
               HEAP32[i26 >> 2] = HEAP32[i2 >> 2];
               HEAP32[i26 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
               HEAP32[i26 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
               i1 = 0;
               while (1) {
                if ((i1 | 0) == 3) break;
                HEAP32[i2 + (i1 << 2) >> 2] = 0;
                i1 = i1 + 1 | 0;
               }
               i15 = HEAP8[i26 + 11 >> 0] | 0;
               i14 = i15 << 24 >> 24 < 0;
               __THREW__ = 0;
               invoke_iiii(fb + 519 | 0, i17 | 0, (i14 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i14 ? HEAP32[i26 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
               i15 = __THREW__;
               __THREW__ = 0;
               if (i15 & 1) {
                i1 = ___cxa_find_matching_catch_2() | 0;
                getTempRet0() | 0;
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
                break;
               } else {
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
                break L838;
               }
              } while (0);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             }
             break L832;
            } while (0);
            i15 = HEAP8[i23 + 11 >> 0] | 0;
            i14 = i15 << 24 >> 24 < 0;
            __THREW__ = 0;
            invoke_iiii(fb + 519 | 0, i17 | 0, (i14 ? HEAP32[i23 >> 2] | 0 : i23) | 0, (i14 ? HEAP32[i23 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
            i15 = __THREW__;
            __THREW__ = 0;
            if (i15 & 1) {
             i19 = 619;
             break;
            }
            L857 : do if (i10) {
             __THREW__ = 0;
             invoke_viii(fb + 1067 | 0, i18 | 0, gb + 1086285 | 0, i24 | 0);
             i15 = __THREW__;
             __THREW__ = 0;
             if (i15 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
             } else {
              __THREW__ = 0;
              i2 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1086288 | 0) | 0;
              i15 = __THREW__;
              __THREW__ = 0;
              do if (i15 & 1) {
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
              } else {
               HEAP32[i26 >> 2] = HEAP32[i2 >> 2];
               HEAP32[i26 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
               HEAP32[i26 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
               i1 = 0;
               while (1) {
                if ((i1 | 0) == 3) break;
                HEAP32[i2 + (i1 << 2) >> 2] = 0;
                i1 = i1 + 1 | 0;
               }
               i15 = HEAP8[i26 + 11 >> 0] | 0;
               i14 = i15 << 24 >> 24 < 0;
               __THREW__ = 0;
               invoke_iiii(fb + 519 | 0, i17 | 0, (i14 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i14 ? HEAP32[i26 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
               i15 = __THREW__;
               __THREW__ = 0;
               if (i15 & 1) {
                i1 = ___cxa_find_matching_catch_2() | 0;
                getTempRet0() | 0;
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
                break;
               } else {
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
                break L857;
               }
              } while (0);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             }
             break L832;
            } while (0);
            HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
            HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
            HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
            i1 = 0;
            while (1) {
             if ((i1 | 0) == 3) break;
             HEAP32[i17 + (i1 << 2) >> 2] = 0;
             i1 = i1 + 1 | 0;
            }
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i18, i16);
            i1 = HEAP32[i9 >> 2] | 0;
            i15 = HEAP32[i20 + 8 >> 2] | 0;
            i4 = i15;
            do if (i1 >>> 0 < i15 >>> 0) {
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i1, i18);
             HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 24;
            } else {
             i3 = HEAP32[i20 >> 2] | 0;
             i1 = (i1 - i3 | 0) / 24 | 0;
             i2 = i1 + 1 | 0;
             if (i2 >>> 0 > 178956970) {
              __THREW__ = 0;
              invoke_vi(fb + 4014 | 0, i20 | 0);
              __THREW__ = 0;
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
              break L832;
             } else {
              i15 = (i4 - i3 | 0) / 24 | 0;
              i19 = i15 << 1;
              __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i15 >>> 0 < 89478485 ? (i19 >>> 0 < i2 >>> 0 ? i2 : i19) : 178956970, i1, i20 + 12 | 0);
              i19 = i26 + 8 | 0;
              i15 = HEAP32[i19 >> 2] | 0;
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i15, i18);
              HEAP32[i19 >> 2] = i15 + 24;
              __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i20, i26);
              __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
              break;
             }
            } while (0);
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
            i1 = i12 + 1 | 0;
            i2 = 0;
            i19 = 659;
            break L824;
           } while (0);
           if ((i19 | 0) == 619) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           i19 = 662;
          } while (0);
          if ((i19 | 0) == 659) {
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
           i19 = 660;
           break;
          } else if ((i19 | 0) == 662) {
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
           i19 = 663;
           break;
          }
         } while (0);
         if ((i19 | 0) == 660) {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
          if (!i2) break L702; else break;
         } else if ((i19 | 0) == 663) {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
          ___resumeException(i1 | 0);
         }
        }
       } while (0);
       i1 = i21;
      } else i1 = i21;
     } else i1 = i21; while (0);
     break L1;
    }
   case 101:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087678 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 103:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087656 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 116:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087681 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 120:
    {
     i12 = i21 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i12, i15, i20) | 0;
     L910 : do if ((i1 | 0) == (i12 | 0)) i1 = i12; else {
      i11 = HEAP32[i20 + 4 >> 2] | 0;
      if ((HEAP32[i20 >> 2] | 0) == (i11 | 0)) i1 = i12; else {
       i10 = i11 + -24 | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i11 + -24 | 0);
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1087683 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       do if (i22 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __THREW__ = 0;
        i3 = invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1086288 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         break;
        };
        HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        i8 = i10 + 11 | 0;
        if ((HEAP8[i8 >> 0] | 0) < 0) {
         HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
         HEAP32[i11 + -20 >> 2] = 0;
         i2 = HEAP8[i8 >> 0] | 0;
         if (i2 << 24 >> 24 < 0) {
          i9 = 0;
          i6 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
          i5 = 1;
         } else i19 = 689;
        } else {
         HEAP8[i10 >> 0] = 0;
         HEAP8[i8 >> 0] = 0;
         i2 = 0;
         i19 = 689;
        }
        if ((i19 | 0) == 689) {
         i9 = i2 & 255;
         i6 = 10;
         i5 = 0;
        }
        i3 = i9 >>> 0 < 11;
        i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
        L934 : do if ((i7 | 0) != (i6 | 0)) {
         do if (i3) {
          i3 = HEAP32[i10 >> 2] | 0;
          if (i5) {
           i2 = 0;
           i4 = i10;
           i19 = 697;
          } else {
           i5 = 0;
           i6 = 1;
           i4 = i10;
           i19 = 698;
          }
         } else {
          i4 = _malloc(i7 + 1 | 0) | 0;
          if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L934;
          if (i5) {
           i2 = 1;
           i3 = HEAP32[i10 >> 2] | 0;
           i19 = 697;
           break;
          } else {
           i5 = 1;
           i6 = 0;
           i3 = i10;
           i19 = 698;
           break;
          }
         } while (0);
         if ((i19 | 0) == 697) {
          i5 = i2;
          i6 = 1;
          i2 = HEAP32[i11 + -20 >> 2] | 0;
         } else if ((i19 | 0) == 698) i2 = i2 & 255;
         i2 = i2 + 1 | 0;
         if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
         if (i6) _free(i3);
         if (i5) {
          HEAP32[i11 + -16 >> 2] = i7 + 1 | -2147483648;
          HEAP32[i11 + -20 >> 2] = i9;
          HEAP32[i10 >> 2] = i4;
          break;
         } else {
          HEAP8[i8 >> 0] = i9;
          break;
         }
        } while (0);
        HEAP32[i10 >> 2] = HEAP32[i26 >> 2];
        HEAP32[i10 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
        HEAP32[i10 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i26 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
        break L910;
       } while (0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
       ___resumeException(i1 | 0);
      }
     } while (0);
     i1 = (i1 | 0) == (i12 | 0) ? i21 : i1;
     break L1;
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 111:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 110:
    {
     i1 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
     break L1;
    }
   case 111:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087694 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 114:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087697 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 82:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087699 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 112:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 109:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087702 | 0, 3);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 108:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087706 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 76:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087708 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 112:
    {
     i2 = i21 + 2 | 0;
     if ((i2 | 0) != (i15 | 0)) if ((HEAP8[i2 >> 0] | 0) == 95) {
      i2 = i21 + 3 | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087711 | 0, 2);
      __THREW__ = 0;
      i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (i24 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L7;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
       break L1;
      }
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i2 = HEAP32[i20 + 4 >> 2] | 0;
     if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i4 = i2 + -24 | 0;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i4);
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1086383 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     do if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1087714 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       break;
      };
      HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i7);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
      break L1;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
     break L7;
    }
   case 115:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087706 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 218 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 116:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 112) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 116) {
      i1 = i21;
      break L1;
     }
     i24 = i21 + 2 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i24, i15, i20) | 0;
     if ((i2 | 0) == (i24 | 0)) {
      i1 = i21;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i21;
      break L1;
     }
     i5 = i20 + 4 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i21;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i24 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i24;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     __THREW__ = 0;
     invoke_iii(fb + 1152 | 0, i2 + -48 | 0, gb + 1087718 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (!(i24 & 1)) {
      i24 = HEAP8[i26 + 11 >> 0] | 0;
      i23 = i24 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, (HEAP32[i5 >> 2] | 0) + -24 | 0, (i23 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i23 ? HEAP32[i26 + 4 >> 2] | 0 : i24 & 255) | 0) | 0;
      i24 = __THREW__;
      __THREW__ = 0;
      if (!(i24 & 1)) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
       break L1;
      }
     }
     i25 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
     ___resumeException(i25 | 0);
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 113:
   {
    if ((HEAP8[i1 + 1 >> 0] | 0) != 117) {
     i1 = i21;
     break L1;
    }
    i19 = i21 + 2 | 0;
    i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
    if ((i1 | 0) == (i19 | 0)) {
     i1 = i21;
     break L1;
    }
    i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i15, i20) | 0;
    if ((i2 | 0) == (i1 | 0)) {
     i1 = i20 + 4 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = i3 + -24 | 0;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) {
       i1 = i21;
       break L1;
      }
      i26 = i3 + -24 | 0;
      HEAP32[i1 >> 2] = i26;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      i3 = HEAP32[i1 >> 2] | 0;
     }
    }
    i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
    i5 = i20 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = i2 + -24 | 0;
     i3 = i2;
     while (1) {
      if ((i3 | 0) == (i1 | 0)) break;
      i26 = i3 + -24 | 0;
      HEAP32[i5 >> 2] = i26;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      i3 = HEAP32[i5 >> 2] | 0;
     }
     i2 = i2 + -48 | 0;
     while (1) {
      if ((i1 | 0) == (i2 | 0)) {
       i1 = i21;
       break L1;
      }
      i26 = i1 + -24 | 0;
      HEAP32[i5 >> 2] = i26;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
      i1 = HEAP32[i5 >> 2] | 0;
     }
    }
    i2 = HEAP32[i5 >> 2] | 0;
    if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 3) {
     i1 = i21;
     break L1;
    }
    __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i2 + -24 | 0;
    i4 = i2;
    while (1) {
     if ((i4 | 0) == (i3 | 0)) break;
     i21 = i4 + -24 | 0;
     HEAP32[i5 >> 2] = i21;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
     i4 = HEAP32[i5 >> 2] | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4619 | 0, i23 | 0, i2 + -48 | 0);
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i21 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i21;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4619 | 0, i22 | 0, i2 + -48 | 0);
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i4 = (HEAP32[i5 >> 2] | 0) + -24 | 0;
      __THREW__ = 0;
      invoke_viii(fb + 1067 | 0, i11 | 0, gb + 1086383 | 0, i22 | 0);
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       __THREW__ = 0;
       i3 = invoke_iii(fb + 1152 | 0, i11 | 0, gb + 1087721 | 0) | 0;
       i21 = __THREW__;
       __THREW__ = 0;
       if (i21 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        i3 = HEAP8[i23 + 11 >> 0] | 0;
        i21 = i3 << 24 >> 24 < 0;
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 519 | 0, i10 | 0, (i21 ? HEAP32[i23 >> 2] | 0 : i23) | 0, (i21 ? HEAP32[i23 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
        i21 = __THREW__;
        __THREW__ = 0;
        if (i21 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i16 | 0, gb + 1087727 | 0) | 0;
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
          HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
          HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i3 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          i3 = HEAP8[i26 + 11 >> 0] | 0;
          i21 = i3 << 24 >> 24 < 0;
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 519 | 0, i18 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          do if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __THREW__ = 0;
           i3 = invoke_iii(fb + 1152 | 0, i17 | 0, gb + 1086288 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
            break;
           };
           HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i9);
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i10);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           break L1;
          } while (0);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i10);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
    break;
   }
  case 114:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 99:
    {
     L1118 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 114) if ((HEAP8[i21 + 1 >> 0] | 0) == 99) {
      i19 = i21 + 2 | 0;
      i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
      if ((i2 | 0) == (i19 | 0)) i1 = i21; else {
       i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
       if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
        i5 = i20 + 4 | 0;
        i2 = HEAP32[i5 >> 2] | 0;
        if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) i1 = i21; else {
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i21 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i21;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         i4 = i2 + -48 | 0;
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i16 | 0, i4 | 0);
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1087733 | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __THREW__ = 0;
           i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087582 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            i3 = HEAP8[i26 + 11 >> 0] | 0;
            i21 = i3 << 24 >> 24 < 0;
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            do if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086288 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
              break;
             };
             HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i23);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             break L1118;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         ___resumeException(i1 | 0);
        }
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 109:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087751 | 0, 1);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 77:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087753 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 115:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087756 | 0, 2);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   case 83:
    {
     i2 = i21 + 2 | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i26, gb + 1087759 | 0, 3);
     __THREW__ = 0;
     i1 = invoke_iiiii(fb + 217 | 0, i2 | 0, i15 | 0, i26 | 0, i20 | 0) | 0;
     i24 = __THREW__;
     __THREW__ = 0;
     if (i24 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      break L7;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
      i1 = (i1 | 0) == (i2 | 0) ? i21 : i1;
      break L1;
     }
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 115:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 99:
    {
     L1184 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 115) if ((HEAP8[i21 + 1 >> 0] | 0) == 99) {
      i19 = i21 + 2 | 0;
      i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
      if ((i2 | 0) == (i19 | 0)) i1 = i21; else {
       i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
       if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
        i5 = i20 + 4 | 0;
        i2 = HEAP32[i5 >> 2] | 0;
        if (((i2 - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) i1 = i21; else {
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i26, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i21 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i21;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         i4 = i2 + -48 | 0;
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i16 | 0, i4 | 0);
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1087763 | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __THREW__ = 0;
           i3 = invoke_iii(fb + 1152 | 0, i18 | 0, gb + 1087582 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            i3 = HEAP8[i26 + 11 >> 0] | 0;
            i21 = i3 << 24 >> 24 < 0;
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 519 | 0, i17 | 0, (i21 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i21 ? HEAP32[i26 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            do if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i22 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i22 | 0, gb + 1086288 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
              break;
             };
             HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i24, i23);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i24);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             break L1184;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         ___resumeException(i1 | 0);
        }
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 112:
    {
     if ((i2 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 >> 0] | 0) != 115) {
      i1 = i21;
      break L1;
     }
     if ((HEAP8[i21 + 1 >> 0] | 0) != 112) {
      i1 = i21;
      break L1;
     }
     i26 = i21 + 2 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i26, i15, i20) | 0;
     i1 = (i1 | 0) == (i26 | 0) ? i21 : i1;
     break L1;
    }
   case 114:
    {
     i1 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
     break L1;
    }
   case 116:
    {
     L1237 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 115) if ((HEAP8[i21 + 1 >> 0] | 0) == 116) {
      i19 = i21 + 2 | 0;
      i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
      if ((i1 | 0) == (i19 | 0)) i1 = i21; else {
       i2 = HEAP32[i20 + 4 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i21; else {
        i4 = i2 + -24 | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i22, i4);
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 520 | 0, i22 | 0, 0, gb + 1087776 | 0) | 0;
        i21 = __THREW__;
        __THREW__ = 0;
        do if (i21 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1086288 | 0) | 0;
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
          break;
         };
         HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i24);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
         break L1237;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        ___resumeException(i1 | 0);
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 122:
    {
     L1260 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 115) if ((HEAP8[i21 + 1 >> 0] | 0) == 122) {
      i19 = i21 + 2 | 0;
      i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i19, i15, i20) | 0;
      if ((i1 | 0) == (i19 | 0)) i1 = i21; else {
       i2 = HEAP32[i20 + 4 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i21; else {
        i4 = i2 + -24 | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i22, i4);
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 520 | 0, i22 | 0, 0, gb + 1087776 | 0) | 0;
        i21 = __THREW__;
        __THREW__ = 0;
        do if (i21 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1086288 | 0) | 0;
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
          break;
         };
         HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i24);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
         break L1260;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        ___resumeException(i1 | 0);
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 90:
    {
     if ((i4 - i1 | 0) <= 2) {
      i1 = i21;
      break L1;
     }
     switch (HEAP8[i1 + 2 >> 0] | 0) {
     case 84:
      break;
     case 102:
      {
       L1286 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 115) if ((HEAP8[i21 + 1 >> 0] | 0) == 90) {
        i2 = i21 + 2 | 0;
        if ((HEAP8[i2 >> 0] | 0) == 102) {
         i1 = __ZN10__cxxabiv112_GLOBAL__N_120parse_function_paramINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
         if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
          i2 = HEAP32[i20 + 4 >> 2] | 0;
          if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i21; else {
           i4 = i2 + -24 | 0;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i22, i4);
           __THREW__ = 0;
           i3 = invoke_iiii(fb + 520 | 0, i22 | 0, 0, gb + 1087785 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           do if (i21 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __THREW__ = 0;
            i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1086288 | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            if (i21 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
             break;
            };
            HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i24);
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
            break L1286;
           } while (0);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
           ___resumeException(i1 | 0);
          }
         }
        } else i1 = i21;
       } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
       break L1;
      }
     default:
      {
       i1 = i21;
       break L1;
      }
     }
     L1310 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 115) if ((HEAP8[i21 + 1 >> 0] | 0) == 90) {
      i3 = i21 + 2 | 0;
      if ((HEAP8[i3 >> 0] | 0) == 84) {
       i9 = i20 + 4 | 0;
       i8 = ((HEAP32[i9 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0;
       i1 = __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i3, i15, i20) | 0;
       i6 = HEAP32[i20 >> 2] | 0;
       i2 = ((HEAP32[i9 >> 2] | 0) - i6 | 0) / 24 | 0;
       if ((i1 | 0) == (i3 | 0)) i1 = i21; else {
        HEAP8[i24 + 11 >> 0] = 10;
        i3 = i24;
        i4 = gb + 1087785 | 0;
        i5 = i3 + 10 | 0;
        do {
         HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
         i3 = i3 + 1 | 0;
         i4 = i4 + 1 | 0;
        } while ((i3 | 0) < (i5 | 0));
        HEAP8[i24 + 10 >> 0] = 0;
        L1316 : do if ((i8 | 0) == (i2 | 0)) i19 = 985; else {
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i26 | 0, i6 + (i8 * 24 | 0) | 0);
         i21 = __THREW__;
         __THREW__ = 0;
         do if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          i21 = HEAP8[i26 + 11 >> 0] | 0;
          i18 = i21 << 24 >> 24 < 0;
          __THREW__ = 0;
          invoke_iiii(fb + 519 | 0, i24 | 0, (i18 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i18 ? HEAP32[i26 + 4 >> 2] | 0 : i21 & 255) | 0) | 0;
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           break;
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          i6 = i26 + 11 | 0;
          i7 = i26 + 4 | 0;
          i3 = i8;
          while (1) {
           i3 = i3 + 1 | 0;
           if ((i3 | 0) == (i2 | 0)) {
            i19 = 985;
            break L1316;
           }
           __THREW__ = 0;
           invoke_vii(fb + 4619 | 0, i23 | 0, (HEAP32[i20 >> 2] | 0) + (i3 * 24 | 0) | 0);
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i19 = 980;
            break;
           }
           __THREW__ = 0;
           i5 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1086385 | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i19 = 981;
            break;
           };
           HEAP32[i26 >> 2] = HEAP32[i5 >> 2];
           HEAP32[i26 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
           HEAP32[i26 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
           i4 = 0;
           while (1) {
            if ((i4 | 0) == 3) break;
            HEAP32[i5 + (i4 << 2) >> 2] = 0;
            i4 = i4 + 1 | 0;
           }
           i21 = HEAP8[i6 >> 0] | 0;
           i19 = i21 << 24 >> 24 < 0;
           __THREW__ = 0;
           invoke_iiii(fb + 519 | 0, i24 | 0, (i19 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i19 ? HEAP32[i7 >> 2] | 0 : i21 & 255) | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) {
            i19 = 982;
            break;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
          }
          if ((i19 | 0) == 980) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else if ((i19 | 0) == 981) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           i19 = 983;
          } else if ((i19 | 0) == 982) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           i19 = 983;
          }
          if ((i19 | 0) == 983) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
          break L1316;
         } while (0);
        } while (0);
        L1342 : do if ((i19 | 0) == 985) {
         __THREW__ = 0;
         invoke_iii(fb + 1152 | 0, i24 | 0, gb + 1086288 | 0) | 0;
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          break;
         }
         while (1) {
          if ((i2 | 0) == (i8 | 0)) break;
          i4 = HEAP32[i9 >> 2] | 0;
          i3 = i4 + -24 | 0;
          while (1) {
           if ((i4 | 0) == (i3 | 0)) break;
           i21 = i4 + -24 | 0;
           HEAP32[i9 >> 2] = i21;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i21);
           i4 = HEAP32[i9 >> 2] | 0;
          }
          i2 = i2 + -1 | 0;
         }
         HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
         HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
         HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i24 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i23, i22);
         i2 = HEAP32[i9 >> 2] | 0;
         i21 = HEAP32[i20 + 8 >> 2] | 0;
         i5 = i21;
         do if (i2 >>> 0 < i21 >>> 0) {
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i23);
          HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 24;
         } else {
          i4 = HEAP32[i20 >> 2] | 0;
          i2 = (i2 - i4 | 0) / 24 | 0;
          i3 = i2 + 1 | 0;
          if (i3 >>> 0 > 178956970) {
           __THREW__ = 0;
           invoke_vi(fb + 4014 | 0, i20 | 0);
           __THREW__ = 0;
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
           break L1342;
          } else {
           i19 = (i5 - i4 | 0) / 24 | 0;
           i21 = i19 << 1;
           __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i19 >>> 0 < 89478485 ? (i21 >>> 0 < i3 >>> 0 ? i3 : i21) : 178956970, i2, i20 + 12 | 0);
           i21 = i26 + 8 | 0;
           i19 = HEAP32[i21 >> 2] | 0;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i19, i23);
           HEAP32[i21 >> 2] = i19 + 24;
           __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i20, i26);
           __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
           break;
          }
         } while (0);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         break L1310;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
        ___resumeException(i1 | 0);
       }
      } else i1 = i21;
     } else i1 = i21; else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 116:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 105:
   case 101:
    {
     L1370 : do if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 116) {
      i1 = HEAP8[i21 + 1 >> 0] | 0;
      switch (i1 << 24 >> 24) {
      case 105:
      case 101:
       break;
      default:
       {
        i1 = i21;
        break L1370;
       }
      }
      i2 = i21 + 2 | 0;
      if (i1 << 24 >> 24 == 101) i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0; else i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i15, i20) | 0;
      if ((i1 | 0) == (i2 | 0)) i1 = i21; else {
       i2 = HEAP32[i20 + 4 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i21; else {
        i4 = i2 + -24 | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i22, i4);
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 520 | 0, i22 | 0, 0, gb + 1087796 | 0) | 0;
        i21 = __THREW__;
        __THREW__ = 0;
        do if (i21 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i23 | 0, gb + 1086288 | 0) | 0;
         i21 = __THREW__;
         __THREW__ = 0;
         if (i21 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
          break;
         };
         HEAP32[i24 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i24 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i24 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i24);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i26);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
         break L1370;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        ___resumeException(i1 | 0);
       }
      }
     } else i1 = i21; else i1 = i21; while (0);
     break L1;
    }
   case 114:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc(i24, gb + 1087804 | 0);
     i1 = i20 + 4 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     i23 = HEAP32[i20 + 8 >> 2] | 0;
     i4 = i23;
     do if (i2 >>> 0 < i23 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i24);
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
     } else {
      i3 = HEAP32[i20 >> 2] | 0;
      i1 = (i2 - i3 | 0) / 24 | 0;
      i2 = i1 + 1 | 0;
      if (i2 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i20 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
       break L7;
      } else {
       i22 = (i4 - i3 | 0) / 24 | 0;
       i23 = i22 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i22 >>> 0 < 89478485 ? (i23 >>> 0 < i2 >>> 0 ? i2 : i23) : 178956970, i1, i20 + 12 | 0);
       i23 = i26 + 8 | 0;
       i22 = HEAP32[i23 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i22, i24);
       HEAP32[i23 >> 2] = i22 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i20, i26);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i24);
     i1 = i21 + 2 | 0;
     break L1;
    }
   case 119:
    {
     if ((i2 | 0) > 2) if ((HEAP8[i21 >> 0] | 0) == 116) if ((HEAP8[i21 + 1 >> 0] | 0) == 119) {
      i22 = i21 + 2 | 0;
      i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i22, i15, i20) | 0;
      if ((i1 | 0) == (i22 | 0)) i1 = i21; else {
       i2 = HEAP32[i20 + 4 >> 2] | 0;
       if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i21; else {
        i3 = i2 + -24 | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i23, i3);
        __THREW__ = 0;
        i4 = invoke_iiii(fb + 520 | 0, i23 | 0, 0, gb + 1087810 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i26 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
         ___resumeException(i26 | 0);
        };
        HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i24 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
        HEAP32[i24 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i4 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i26, i24);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i3, i26);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i26);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i23);
       }
      }
     } else i1 = i21; else i1 = i21; else i1 = i21;
     break L1;
    }
   default:
    {
     i1 = i21;
     break L1;
    }
   }
  case 57:
  case 56:
  case 55:
  case 54:
  case 53:
  case 52:
  case 51:
  case 50:
  case 49:
   {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i21, i15, i20) | 0;
    break L1;
   }
  default:
   {
    i1 = i21;
    break L1;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } else i1 = i21; while (0);
 STACKTOP = i25;
 return i1 | 0;
}

function __ZL28DrawBillboardsWith3DRotationILb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i15, i7, i2, i1, i497, i498) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i497 = i497 | 0;
 i498 = i498 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, i76 = 0, i77 = 0, f78 = f0, i79 = 0, f80 = f0, f81 = f0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, f331 = f0, f332 = f0, f333 = f0, f334 = f0, f335 = f0, f336 = f0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, f436 = f0, f437 = f0, f438 = f0, f439 = f0, f440 = f0, f441 = f0, f442 = f0, f443 = f0, f444 = f0, f445 = f0, f446 = f0, f447 = f0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, f463 = f0, f464 = f0, f465 = f0, f466 = f0, f467 = f0, f468 = f0, f469 = f0, f470 = f0, f471 = f0, f472 = f0, f473 = f0, f474 = f0, f475 = f0, f476 = f0, f477 = f0, f478 = f0, f479 = f0, f480 = f0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, f503 = f0, f504 = f0, f505 = f0, f506 = f0, f507 = f0, f508 = f0, f509 = f0, f510 = f0, f511 = f0, f512 = f0, f513 = f0, f514 = f0, f515 = f0, f516 = f0, f517 = f0, i518 = 0;
 i502 = STACKTOP;
 STACKTOP = STACKTOP + 1488 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i502 + 1416 | 0;
 i8 = i502 + 1380 | 0;
 i499 = i502 + 1344 | 0;
 i500 = i502 + 1296 | 0;
 i501 = i502 + 1248 | 0;
 i481 = i502 + 1200 | 0;
 i482 = i502 + 1184 | 0;
 i483 = i502 + 1168 | 0;
 i484 = i502 + 1152 | 0;
 i485 = i502 + 1136 | 0;
 i486 = i502 + 1088 | 0;
 i487 = i502 + 1040 | 0;
 i488 = i502 + 992 | 0;
 i489 = i502 + 944 | 0;
 i341 = i502 + 896 | 0;
 i490 = i502 + 832 | 0;
 i491 = i502 + 704 | 0;
 i492 = i502 + 448 | 0;
 i493 = i502 + 256 | 0;
 i494 = i502 + 64 | 0;
 i495 = i502;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i3 | 0) == 3) {
  i14 = i6;
  i13 = i14 + 36 | 0;
  do {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   i14 = i14 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i15, i7, i2, i6, i497, i498);
  STACKTOP = i502;
  return;
 }
 i496 = i7 + 332 | 0;
 i5 = HEAP32[i496 >> 2] | 0;
 i4 = (i5 & 1073741824 | 0) == 0;
 i12 = HEAP32[i1 + 32 >> 2] | 0;
 f470 = Math_fround((i5 & 4095) >>> 0);
 f471 = Math_fround(Math_fround(1.0) / f470);
 f472 = Math_fround(HEAPF32[i7 + 368 >> 2]);
 f473 = Math_fround(HEAPF32[i7 + 372 >> 2]);
 f474 = Math_fround(HEAPF32[i7 + 376 >> 2]);
 f475 = Math_fround(Math_fround(1.0) - f474);
 i5 = i7 + 420 | 0;
 f476 = Math_fround(HEAPF32[i7 + 404 >> 2]);
 i448 = i7 + 408 | 0;
 f469 = Math_fround(HEAPF32[i448 >> 2]);
 f465 = Math_fround(HEAPF32[i448 + 4 >> 2]);
 f466 = Math_fround(HEAPF32[i448 + 8 >> 2]);
 i448 = i7 + 336 | 0;
 f477 = Math_fround(HEAPF32[i448 >> 2]);
 f478 = Math_fround(HEAPF32[i448 + 4 >> 2]);
 f479 = Math_fround(HEAPF32[i448 + 8 >> 2]);
 f480 = Math_fround(HEAPF32[i448 + 12 >> 2]);
 i448 = i7 + 352 | 0;
 f468 = Math_fround(HEAPF32[i448 >> 2]);
 f464 = Math_fround(HEAPF32[i448 + 4 >> 2]);
 i448 = i7 + 360 | 0;
 f467 = Math_fround(HEAPF32[i448 >> 2]);
 f463 = Math_fround(HEAPF32[i448 + 4 >> 2]);
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 f436 = Math_fround(HEAPF32[i7 + 128 >> 2]);
 f437 = Math_fround(HEAPF32[i7 + 132 >> 2]);
 f438 = Math_fround(HEAPF32[i7 + 136 >> 2]);
 f439 = Math_fround(HEAPF32[i7 + 144 >> 2]);
 f440 = Math_fround(HEAPF32[i7 + 148 >> 2]);
 f441 = Math_fround(HEAPF32[i7 + 152 >> 2]);
 f442 = Math_fround(HEAPF32[i7 + 160 >> 2]);
 f443 = Math_fround(HEAPF32[i7 + 164 >> 2]);
 f444 = Math_fround(HEAPF32[i7 + 168 >> 2]);
 f445 = Math_fround(HEAPF32[i7 + 176 >> 2]);
 f446 = Math_fround(HEAPF32[i7 + 180 >> 2]);
 f447 = Math_fround(HEAPF32[i7 + 184 >> 2]);
 i448 = i490 + 12 | 0;
 i449 = i490 + 8 | 0;
 i450 = i490 + 4 | 0;
 i451 = i490 + 28 | 0;
 HEAP32[i490 >> 2] = 0;
 HEAP32[i490 + 4 >> 2] = 0;
 HEAP32[i490 + 8 >> 2] = 0;
 HEAP32[i490 + 12 >> 2] = 0;
 HEAP32[i451 >> 2] = 1;
 i452 = i490 + 24 | 0;
 HEAP32[i452 >> 2] = 1;
 i453 = i490 + 20 | 0;
 HEAP32[i453 >> 2] = 1;
 i454 = i490 + 16 | 0;
 HEAP32[i454 >> 2] = 1;
 i455 = i490 + 44 | 0;
 HEAP32[i455 >> 2] = 2;
 i456 = i490 + 40 | 0;
 HEAP32[i456 >> 2] = 2;
 i457 = i490 + 36 | 0;
 HEAP32[i457 >> 2] = 2;
 i458 = i490 + 32 | 0;
 HEAP32[i458 >> 2] = 2;
 i459 = i490 + 60 | 0;
 HEAP32[i459 >> 2] = 3;
 i460 = i490 + 56 | 0;
 HEAP32[i460 >> 2] = 3;
 i461 = i490 + 52 | 0;
 HEAP32[i461 >> 2] = 3;
 i462 = i490 + 48 | 0;
 HEAP32[i462 >> 2] = 3;
 i387 = i491 + 4 | 0;
 i411 = i491 + 8 | 0;
 i435 = i491 + 12 | 0;
 i363 = i491 + 16 | 0;
 HEAP32[i491 >> 2] = 0;
 HEAP32[i491 + 4 >> 2] = 0;
 HEAP32[i491 + 8 >> 2] = 0;
 HEAP32[i491 + 12 >> 2] = 0;
 HEAPF32[i363 >> 2] = Math_fround(1.0);
 i386 = i491 + 20 | 0;
 HEAPF32[i386 >> 2] = Math_fround(1.0);
 i410 = i491 + 24 | 0;
 HEAPF32[i410 >> 2] = Math_fround(1.0);
 i434 = i491 + 28 | 0;
 HEAPF32[i434 >> 2] = Math_fround(1.0);
 i362 = i491 + 32 | 0;
 HEAPF32[i362 >> 2] = Math_fround(1.0);
 i385 = i491 + 36 | 0;
 HEAPF32[i385 >> 2] = Math_fround(1.0);
 i409 = i491 + 40 | 0;
 HEAPF32[i409 >> 2] = Math_fround(1.0);
 i433 = i491 + 44 | 0;
 HEAPF32[i433 >> 2] = Math_fround(1.0);
 i361 = i491 + 48 | 0;
 HEAPF32[i361 >> 2] = Math_fround(1.0);
 i384 = i491 + 52 | 0;
 HEAPF32[i384 >> 2] = Math_fround(1.0);
 i408 = i491 + 56 | 0;
 HEAPF32[i408 >> 2] = Math_fround(1.0);
 i432 = i491 + 60 | 0;
 HEAPF32[i432 >> 2] = Math_fround(1.0);
 i360 = i491 + 64 | 0;
 HEAPF32[i360 >> 2] = Math_fround(1.0);
 i383 = i491 + 68 | 0;
 HEAPF32[i383 >> 2] = Math_fround(1.0);
 i407 = i491 + 72 | 0;
 HEAPF32[i407 >> 2] = Math_fround(1.0);
 i431 = i491 + 76 | 0;
 HEAPF32[i431 >> 2] = Math_fround(1.0);
 i359 = i491 + 80 | 0;
 i382 = i491 + 84 | 0;
 i406 = i491 + 88 | 0;
 i430 = i491 + 92 | 0;
 i358 = i491 + 96 | 0;
 i381 = i491 + 100 | 0;
 i405 = i491 + 104 | 0;
 i429 = i491 + 108 | 0;
 i357 = i491 + 112 | 0;
 i380 = i491 + 116 | 0;
 i404 = i491 + 120 | 0;
 i428 = i491 + 124 | 0;
 i14 = i359;
 i13 = i14 + 48 | 0;
 do {
  HEAP32[i14 >> 2] = 0;
  i14 = i14 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 i379 = i492 + 4 | 0;
 i403 = i492 + 8 | 0;
 i427 = i492 + 12 | 0;
 i356 = i492 + 16 | 0;
 HEAP32[i492 >> 2] = 0;
 HEAP32[i492 + 4 >> 2] = 0;
 HEAP32[i492 + 8 >> 2] = 0;
 HEAP32[i492 + 12 >> 2] = 0;
 HEAPF32[i356 >> 2] = Math_fround(1.0);
 i378 = i492 + 20 | 0;
 HEAPF32[i378 >> 2] = Math_fround(1.0);
 i402 = i492 + 24 | 0;
 HEAPF32[i402 >> 2] = Math_fround(1.0);
 i426 = i492 + 28 | 0;
 HEAPF32[i426 >> 2] = Math_fround(1.0);
 i355 = i492 + 32 | 0;
 i377 = i492 + 36 | 0;
 i401 = i492 + 40 | 0;
 i425 = i492 + 44 | 0;
 i354 = i492 + 48 | 0;
 i376 = i492 + 52 | 0;
 i400 = i492 + 56 | 0;
 i424 = i492 + 60 | 0;
 i353 = i492 + 64 | 0;
 HEAP32[i355 >> 2] = 0;
 HEAP32[i355 + 4 >> 2] = 0;
 HEAP32[i355 + 8 >> 2] = 0;
 HEAP32[i355 + 12 >> 2] = 0;
 HEAP32[i355 + 16 >> 2] = 0;
 HEAP32[i355 + 20 >> 2] = 0;
 HEAP32[i355 + 24 >> 2] = 0;
 HEAP32[i355 + 28 >> 2] = 0;
 HEAPF32[i353 >> 2] = Math_fround(1.0);
 i375 = i492 + 68 | 0;
 HEAPF32[i375 >> 2] = Math_fround(1.0);
 i399 = i492 + 72 | 0;
 HEAPF32[i399 >> 2] = Math_fround(1.0);
 i423 = i492 + 76 | 0;
 HEAPF32[i423 >> 2] = Math_fround(1.0);
 i352 = i492 + 80 | 0;
 HEAPF32[i352 >> 2] = Math_fround(1.0);
 i374 = i492 + 84 | 0;
 HEAPF32[i374 >> 2] = Math_fround(1.0);
 i398 = i492 + 88 | 0;
 HEAPF32[i398 >> 2] = Math_fround(1.0);
 i422 = i492 + 92 | 0;
 HEAPF32[i422 >> 2] = Math_fround(1.0);
 i351 = i492 + 96 | 0;
 i373 = i492 + 100 | 0;
 i397 = i492 + 104 | 0;
 i421 = i492 + 108 | 0;
 i350 = i492 + 112 | 0;
 i372 = i492 + 116 | 0;
 i396 = i492 + 120 | 0;
 i420 = i492 + 124 | 0;
 i349 = i492 + 128 | 0;
 HEAP32[i351 >> 2] = 0;
 HEAP32[i351 + 4 >> 2] = 0;
 HEAP32[i351 + 8 >> 2] = 0;
 HEAP32[i351 + 12 >> 2] = 0;
 HEAP32[i351 + 16 >> 2] = 0;
 HEAP32[i351 + 20 >> 2] = 0;
 HEAP32[i351 + 24 >> 2] = 0;
 HEAP32[i351 + 28 >> 2] = 0;
 HEAPF32[i349 >> 2] = Math_fround(1.0);
 i371 = i492 + 132 | 0;
 HEAPF32[i371 >> 2] = Math_fround(1.0);
 i395 = i492 + 136 | 0;
 HEAPF32[i395 >> 2] = Math_fround(1.0);
 i419 = i492 + 140 | 0;
 HEAPF32[i419 >> 2] = Math_fround(1.0);
 i348 = i492 + 144 | 0;
 i370 = i492 + 148 | 0;
 i394 = i492 + 152 | 0;
 i418 = i492 + 156 | 0;
 i347 = i492 + 160 | 0;
 i369 = i492 + 164 | 0;
 i393 = i492 + 168 | 0;
 i417 = i492 + 172 | 0;
 i346 = i492 + 176 | 0;
 i368 = i492 + 180 | 0;
 i392 = i492 + 184 | 0;
 i416 = i492 + 188 | 0;
 i345 = i492 + 192 | 0;
 i367 = i492 + 196 | 0;
 i391 = i492 + 200 | 0;
 i415 = i492 + 204 | 0;
 i344 = i492 + 208 | 0;
 i366 = i492 + 212 | 0;
 i390 = i492 + 216 | 0;
 i414 = i492 + 220 | 0;
 i343 = i492 + 224 | 0;
 i365 = i492 + 228 | 0;
 i389 = i492 + 232 | 0;
 i413 = i492 + 236 | 0;
 i342 = i492 + 240 | 0;
 i364 = i492 + 244 | 0;
 i388 = i492 + 248 | 0;
 i412 = i492 + 252 | 0;
 if (i4) {
  i14 = i348;
  i13 = i14 + 112 | 0;
  do {
   HEAP32[i14 >> 2] = 0;
   i14 = i14 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  switch (i3 | 0) {
  case 1:
   {
    i14 = i6;
    i1 = gb + 1162292 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  case 2:
   {
    i14 = i6;
    i1 = i7 + 256 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  default:
   {
    i14 = i6;
    i1 = i7 + 64 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
   }
  }
  __ZN10Matrix3x3fC2ERK10Matrix4x4f(i8, i6);
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  f54 = Math_fround(HEAPF32[i7 + 428 >> 2]);
  f81 = Math_fround(HEAPF32[i7 + 424 >> 2]);
  f56 = Math_fround(HEAPF32[i8 >> 2]);
  i329 = i8 + 4 | 0;
  f52 = Math_fround(HEAPF32[i329 >> 2]);
  i330 = i8 + 8 | 0;
  f335 = Math_fround(HEAPF32[i330 >> 2]);
  i337 = i8 + 12 | 0;
  f58 = Math_fround(HEAPF32[i337 >> 2]);
  i338 = i8 + 16 | 0;
  f53 = Math_fround(HEAPF32[i338 >> 2]);
  i339 = i8 + 20 | 0;
  f336 = Math_fround(HEAPF32[i339 >> 2]);
  i340 = i8 + 24 | 0;
  f78 = Math_fround(HEAPF32[i340 >> 2]);
  i163 = i8 + 28 | 0;
  f55 = Math_fround(HEAPF32[i163 >> 2]);
  i162 = i8 + 32 | 0;
  f11 = Math_fround(HEAPF32[i162 >> 2]);
  f57 = Math_fround(f52 * Math_fround(0.0));
  f333 = Math_fround(f335 * Math_fround(0.0));
  f331 = Math_fround(Math_fround(Math_fround(f9 * f56) + f57) + f333);
  f75 = Math_fround(f53 * Math_fround(0.0));
  f334 = Math_fround(f336 * Math_fround(0.0));
  f332 = Math_fround(Math_fround(Math_fround(f9 * f58) + f75) + f334);
  f80 = Math_fround(f55 * Math_fround(0.0));
  f10 = Math_fround(f11 * Math_fround(0.0));
  f9 = Math_fround(Math_fround(Math_fround(f9 * f78) + f80) + f10);
  f56 = Math_fround(f56 * Math_fround(0.0));
  f333 = Math_fround(Math_fround(f56 + Math_fround(f54 * f52)) + f333);
  f58 = Math_fround(f58 * Math_fround(0.0));
  f334 = Math_fround(Math_fround(f58 + Math_fround(f54 * f53)) + f334);
  f78 = Math_fround(f78 * Math_fround(0.0));
  f10 = Math_fround(Math_fround(f78 + Math_fround(f54 * f55)) + f10);
  f335 = Math_fround(Math_fround(f56 + f57) + Math_fround(f81 * f335));
  f336 = Math_fround(Math_fround(f58 + f75) + Math_fround(f81 * f336));
  f11 = Math_fround(Math_fround(f78 + f80) + Math_fround(f81 * f11));
  HEAPF32[i8 >> 2] = f331;
  HEAPF32[i329 >> 2] = f333;
  HEAPF32[i330 >> 2] = f335;
  HEAPF32[i337 >> 2] = f332;
  HEAPF32[i338 >> 2] = f334;
  HEAPF32[i339 >> 2] = f336;
  HEAPF32[i340 >> 2] = f9;
  HEAPF32[i163 >> 2] = f10;
  HEAPF32[i162 >> 2] = f11;
  i162 = (i2 | 0) == 27;
  HEAP32[i499 >> 2] = 0;
  HEAP32[i499 + 4 >> 2] = 0;
  HEAP32[i499 + 8 >> 2] = 0;
  HEAP32[i499 + 12 >> 2] = 0;
  i163 = HEAP32[i497 + 12 >> 2] | 0;
  if (i163 | 0) {
   i164 = i500 + 12 | 0;
   i165 = i500 + 8 | 0;
   i166 = i500 + 4 | 0;
   i167 = i500 + 16 | 0;
   i168 = i500 + 28 | 0;
   i169 = i500 + 24 | 0;
   i170 = i500 + 20 | 0;
   i171 = i500 + 32 | 0;
   i172 = i500 + 44 | 0;
   i173 = i500 + 40 | 0;
   i174 = i500 + 36 | 0;
   i175 = i501 + 32 | 0;
   i176 = i501 + 44 | 0;
   i177 = i501 + 40 | 0;
   i178 = i501 + 36 | 0;
   i179 = i481 + 12 | 0;
   i180 = i481 + 8 | 0;
   i181 = i481 + 4 | 0;
   i182 = i481 + 28 | 0;
   i183 = i481 + 24 | 0;
   i184 = i481 + 20 | 0;
   i185 = i481 + 44 | 0;
   i186 = i481 + 40 | 0;
   i187 = i481 + 36 | 0;
   i188 = i498 + 20 | 0;
   i189 = i497 + 20 | 0;
   i190 = i497 + 40 | 0;
   i191 = i497 + 340 | 0;
   i192 = i497 + 60 | 0;
   i193 = i497 + 80 | 0;
   i194 = i497 + 100 | 0;
   i195 = i497 + 120 | 0;
   i196 = i497 + 140 | 0;
   i197 = i497 + 160 | 0;
   i198 = i481 + 16 | 0;
   i199 = i481 + 32 | 0;
   i200 = i498 + 4 | 0;
   i201 = i482 + 4 | 0;
   i202 = i482 + 8 | 0;
   i203 = i482 + 12 | 0;
   i204 = i498 + 8 | 0;
   i205 = i483 + 4 | 0;
   i206 = i483 + 8 | 0;
   i207 = i483 + 12 | 0;
   i208 = i497 + 520 | 0;
   i209 = i484 + 4 | 0;
   i210 = i484 + 8 | 0;
   i211 = i484 + 12 | 0;
   i212 = i497 + 500 | 0;
   i213 = i485 + 4 | 0;
   i214 = i485 + 8 | 0;
   i215 = i485 + 12 | 0;
   i216 = i498 + 16 | 0;
   i217 = i486 + 4 | 0;
   i218 = i486 + 8 | 0;
   i219 = i486 + 12 | 0;
   i220 = i500 + 16 | 0;
   i221 = i500 + 32 | 0;
   i222 = i487 + 4 | 0;
   i223 = i487 + 8 | 0;
   i224 = i487 + 12 | 0;
   i225 = i487 + 16 | 0;
   i226 = i487 + 20 | 0;
   i227 = i487 + 24 | 0;
   i228 = i487 + 28 | 0;
   i229 = i487 + 32 | 0;
   i230 = i487 + 36 | 0;
   i231 = i487 + 40 | 0;
   i232 = i487 + 44 | 0;
   i233 = i493 + 4 | 0;
   i234 = i493 + 8 | 0;
   i235 = i493 + 12 | 0;
   i236 = i493 + 16 | 0;
   i237 = i493 + 20 | 0;
   i238 = i493 + 24 | 0;
   i239 = i493 + 28 | 0;
   i240 = i493 + 32 | 0;
   i241 = i493 + 36 | 0;
   i242 = i493 + 40 | 0;
   i243 = i493 + 44 | 0;
   i244 = i493 + 48 | 0;
   i245 = i493 + 52 | 0;
   i246 = i493 + 56 | 0;
   i247 = i493 + 60 | 0;
   i248 = i493 + 64 | 0;
   i249 = i493 + 68 | 0;
   i250 = i493 + 72 | 0;
   i251 = i493 + 76 | 0;
   i252 = i493 + 80 | 0;
   i253 = i493 + 84 | 0;
   i254 = i493 + 88 | 0;
   i255 = i493 + 92 | 0;
   i256 = i493 + 96 | 0;
   i257 = i493 + 100 | 0;
   i258 = i493 + 104 | 0;
   i259 = i493 + 108 | 0;
   i260 = i493 + 112 | 0;
   i261 = i493 + 116 | 0;
   i262 = i493 + 120 | 0;
   i263 = i493 + 124 | 0;
   i264 = i493 + 128 | 0;
   i265 = i493 + 132 | 0;
   i266 = i493 + 136 | 0;
   i267 = i493 + 140 | 0;
   i268 = i493 + 144 | 0;
   i269 = i493 + 148 | 0;
   i270 = i493 + 152 | 0;
   i271 = i493 + 156 | 0;
   i272 = i493 + 160 | 0;
   i273 = i493 + 164 | 0;
   i274 = i493 + 168 | 0;
   i275 = i493 + 172 | 0;
   i276 = i493 + 176 | 0;
   i277 = i493 + 180 | 0;
   i278 = i493 + 184 | 0;
   i279 = i493 + 188 | 0;
   i280 = (i2 & 48 | 0) == 0;
   i124 = i494 + 4 | 0;
   i141 = i494 + 8 | 0;
   i158 = i494 + 12 | 0;
   i281 = i494 + 16 | 0;
   i119 = i494 + 20 | 0;
   i136 = i494 + 24 | 0;
   i153 = i494 + 28 | 0;
   i282 = i494 + 32 | 0;
   i114 = i494 + 36 | 0;
   i131 = i494 + 40 | 0;
   i148 = i494 + 44 | 0;
   i283 = i494 + 48 | 0;
   i123 = i494 + 52 | 0;
   i140 = i494 + 56 | 0;
   i157 = i494 + 60 | 0;
   i284 = i494 + 64 | 0;
   i118 = i494 + 68 | 0;
   i135 = i494 + 72 | 0;
   i152 = i494 + 76 | 0;
   i285 = i494 + 80 | 0;
   i113 = i494 + 84 | 0;
   i130 = i494 + 88 | 0;
   i147 = i494 + 92 | 0;
   i286 = i494 + 96 | 0;
   i122 = i494 + 100 | 0;
   i139 = i494 + 104 | 0;
   i156 = i494 + 108 | 0;
   i287 = i494 + 112 | 0;
   i117 = i494 + 116 | 0;
   i134 = i494 + 120 | 0;
   i151 = i494 + 124 | 0;
   i288 = i494 + 128 | 0;
   i112 = i494 + 132 | 0;
   i129 = i494 + 136 | 0;
   i146 = i494 + 140 | 0;
   i289 = i494 + 144 | 0;
   i121 = i494 + 148 | 0;
   i138 = i494 + 152 | 0;
   i155 = i494 + 156 | 0;
   i290 = i494 + 160 | 0;
   i116 = i494 + 164 | 0;
   i133 = i494 + 168 | 0;
   i150 = i494 + 172 | 0;
   i291 = i494 + 176 | 0;
   i111 = i494 + 180 | 0;
   i128 = i494 + 184 | 0;
   i145 = i494 + 188 | 0;
   i125 = i488 + 4 | 0;
   i142 = i488 + 8 | 0;
   i159 = i488 + 12 | 0;
   i292 = i488 + 16 | 0;
   i120 = i488 + 20 | 0;
   i137 = i488 + 24 | 0;
   i154 = i488 + 28 | 0;
   i293 = i488 + 32 | 0;
   i115 = i488 + 36 | 0;
   i132 = i488 + 40 | 0;
   i149 = i488 + 44 | 0;
   i127 = i489 + 4 | 0;
   i144 = i489 + 8 | 0;
   i161 = i489 + 12 | 0;
   i294 = i489 + 16 | 0;
   i126 = i489 + 20 | 0;
   i143 = i489 + 24 | 0;
   i160 = i489 + 28 | 0;
   i110 = i489 + 32 | 0;
   i295 = (i2 & 512 | 0) != 0;
   i296 = i341 + 4 | 0;
   i297 = i341 + 8 | 0;
   i298 = i341 + 12 | 0;
   i299 = i341 + 16 | 0;
   i300 = i341 + 20 | 0;
   i301 = i341 + 24 | 0;
   i302 = i341 + 28 | 0;
   i303 = i341 + 32 | 0;
   i304 = i341 + 36 | 0;
   i305 = i341 + 40 | 0;
   i306 = i341 + 44 | 0;
   i307 = (i2 & 8192 | 0) != 0;
   i308 = i495 + 4 | 0;
   i309 = i495 + 8 | 0;
   i310 = i495 + 12 | 0;
   i311 = i495 + 16 | 0;
   i312 = i495 + 20 | 0;
   i313 = i495 + 24 | 0;
   i314 = i495 + 28 | 0;
   i315 = i495 + 32 | 0;
   i316 = i495 + 36 | 0;
   i317 = i495 + 40 | 0;
   i318 = i495 + 44 | 0;
   i319 = i495 + 48 | 0;
   i320 = i495 + 52 | 0;
   i321 = i495 + 56 | 0;
   i322 = i495 + 60 | 0;
   i323 = (i2 & 2 | 0) == 0;
   i324 = (i2 & 8 | 0) == 0;
   i325 = (i2 & 16 | 0) == 0;
   i326 = (i2 & 32 | 0) == 0;
   i327 = (i2 & 64 | 0) == 0;
   i328 = (i2 & 128 | 0) == 0;
   i329 = (i2 & 256 | 0) == 0;
   i330 = i341 + 16 | 0;
   i337 = i341 + 32 | 0;
   i338 = (i2 & 1024 | 0) == 0;
   i339 = (i2 & 2048 | 0) == 0;
   i340 = (i2 & 4096 | 0) == 0;
   i82 = (i2 & 4 | 0) == 0;
   i83 = i488 + 16 | 0;
   i84 = i488 + 32 | 0;
   i85 = i497 + 864 | 0;
   i86 = i497 + 848 | 0;
   i87 = i497 + 844 | 0;
   i88 = i497 + 828 | 0;
   i89 = i497 + 540 | 0;
   i90 = i489 + 16 | 0;
   i91 = i489 + 32 | 0;
   i92 = i487 + 16 | 0;
   i93 = i487 + 32 | 0;
   i94 = i493 + 16 | 0;
   i95 = i493 + 32 | 0;
   i96 = i494 + 16 | 0;
   i97 = i494 + 32 | 0;
   i98 = i244 + 16 | 0;
   i99 = i244 + 32 | 0;
   i100 = i283 + 16 | 0;
   i101 = i283 + 32 | 0;
   i102 = i256 + 16 | 0;
   i103 = i256 + 32 | 0;
   i104 = i286 + 16 | 0;
   i105 = i286 + 32 | 0;
   i106 = i268 + 16 | 0;
   i107 = i268 + 32 | 0;
   i108 = i289 + 16 | 0;
   i109 = i289 + 32 | 0;
   f81 = Math_fround(f9 * Math_fround(0.0));
   f80 = Math_fround(f10 * Math_fround(0.0));
   f78 = Math_fround(f11 * Math_fround(0.0));
   i79 = i12 + 564 | 0;
   i77 = i12 + 568 | 0;
   i76 = 0;
   i1 = i15;
   do {
    i14 = i500;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i501;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i481;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    HEAP32[i482 >> 2] = 0;
    HEAP32[i482 + 4 >> 2] = 0;
    HEAP32[i482 + 8 >> 2] = 0;
    HEAP32[i482 + 12 >> 2] = 0;
    HEAP32[i483 >> 2] = 0;
    HEAP32[i483 + 4 >> 2] = 0;
    HEAP32[i483 + 8 >> 2] = 0;
    HEAP32[i483 + 12 >> 2] = 0;
    HEAP32[i484 >> 2] = 0;
    HEAP32[i484 + 4 >> 2] = 0;
    HEAP32[i484 + 8 >> 2] = 0;
    HEAP32[i484 + 12 >> 2] = 0;
    HEAP32[i485 >> 2] = 0;
    HEAP32[i485 + 4 >> 2] = 0;
    HEAP32[i485 + 8 >> 2] = 0;
    HEAP32[i485 + 12 >> 2] = 0;
    HEAP32[i486 >> 2] = 0;
    HEAP32[i486 + 4 >> 2] = 0;
    HEAP32[i486 + 8 >> 2] = 0;
    HEAP32[i486 + 12 >> 2] = 0;
    i19 = HEAP32[i188 >> 2] | 0;
    i20 = HEAP32[i497 >> 2] | 0;
    if (!i19) {
     i63 = i20 + (i76 << 2) | 0;
     i64 = HEAP32[i63 + 4 >> 2] | 0;
     i65 = HEAP32[i63 + 8 >> 2] | 0;
     i66 = HEAP32[i63 + 12 >> 2] | 0;
     i70 = (HEAP32[i189 >> 2] | 0) + (i76 << 2) | 0;
     i67 = HEAP32[i70 >> 2] | 0;
     i68 = HEAP32[i70 + 4 >> 2] | 0;
     i69 = HEAP32[i70 + 8 >> 2] | 0;
     i70 = HEAP32[i70 + 12 >> 2] | 0;
     i71 = (HEAP32[i190 >> 2] | 0) + (i76 << 2) | 0;
     i74 = HEAP32[i71 >> 2] | 0;
     i73 = HEAP32[i71 + 4 >> 2] | 0;
     i72 = HEAP32[i71 + 8 >> 2] | 0;
     i71 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i500 >> 2] = HEAP32[i63 >> 2];
     HEAP32[i166 >> 2] = i64;
     HEAP32[i165 >> 2] = i65;
     HEAP32[i164 >> 2] = i66;
     HEAP32[i167 >> 2] = i67;
     HEAP32[i170 >> 2] = i68;
     HEAP32[i169 >> 2] = i69;
     HEAP32[i168 >> 2] = i70;
     HEAP32[i171 >> 2] = i74;
     HEAP32[i174 >> 2] = i73;
     HEAP32[i173 >> 2] = i72;
     HEAP32[i172 >> 2] = i71;
     i71 = (HEAP32[i191 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i175 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i178 >> 2] = i72;
     HEAP32[i177 >> 2] = i73;
     HEAP32[i176 >> 2] = i74;
     i74 = (HEAP32[i192 >> 2] | 0) + (i76 << 2) | 0;
     f47 = Math_fround(HEAPF32[i74 >> 2]);
     f37 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f38 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f39 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i193 >> 2] | 0) + (i76 << 2) | 0;
     f40 = Math_fround(HEAPF32[i74 >> 2]);
     f41 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f42 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f43 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i194 >> 2] | 0) + (i76 << 2) | 0;
     f44 = Math_fround(HEAPF32[i74 >> 2]);
     f45 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f46 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f75 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i195 >> 2] | 0) + (i76 << 2) | 0;
     f48 = Math_fround(HEAPF32[i74 >> 2]);
     f49 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f50 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f51 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i196 >> 2] | 0) + (i76 << 2) | 0;
     f52 = Math_fround(HEAPF32[i74 >> 2]);
     f53 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f54 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f55 = Math_fround(HEAPF32[i74 + 12 >> 2]);
     i74 = (HEAP32[i197 >> 2] | 0) + (i76 << 2) | 0;
     f56 = Math_fround(HEAPF32[i74 >> 2]);
     f57 = Math_fround(HEAPF32[i74 + 4 >> 2]);
     f58 = Math_fround(HEAPF32[i74 + 8 >> 2]);
     f49 = Math_fround(f37 + f49);
     f50 = Math_fround(f38 + f50);
     f51 = Math_fround(f39 + f51);
     f52 = Math_fround(f40 + f52);
     f53 = Math_fround(f41 + f53);
     f54 = Math_fround(f42 + f54);
     f55 = Math_fround(f43 + f55);
     f56 = Math_fround(f44 + f56);
     f57 = Math_fround(f45 + f57);
     f58 = Math_fround(f46 + f58);
     f75 = Math_fround(f75 + Math_fround(HEAPF32[i74 + 12 >> 2]));
     HEAPF32[i481 >> 2] = Math_fround(f47 + f48);
     HEAPF32[i181 >> 2] = f49;
     HEAPF32[i180 >> 2] = f50;
     HEAPF32[i179 >> 2] = f51;
     HEAPF32[i198 >> 2] = f52;
     HEAPF32[i184 >> 2] = f53;
     HEAPF32[i183 >> 2] = f54;
     HEAPF32[i182 >> 2] = f55;
     HEAPF32[i199 >> 2] = f56;
     HEAPF32[i187 >> 2] = f57;
     HEAPF32[i186 >> 2] = f58;
     HEAPF32[i185 >> 2] = f75;
     i74 = (HEAP32[i200 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i74 + 4 >> 2] | 0;
     i72 = HEAP32[i74 + 8 >> 2] | 0;
     i71 = HEAP32[i74 + 12 >> 2] | 0;
     HEAP32[i482 >> 2] = HEAP32[i74 >> 2];
     HEAP32[i201 >> 2] = i73;
     HEAP32[i202 >> 2] = i72;
     HEAP32[i203 >> 2] = i71;
     i71 = (HEAP32[i204 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i483 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i205 >> 2] = i72;
     HEAP32[i206 >> 2] = i73;
     HEAP32[i207 >> 2] = i74;
     i74 = (HEAP32[i208 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i74 + 4 >> 2] | 0;
     i72 = HEAP32[i74 + 8 >> 2] | 0;
     i71 = HEAP32[i74 + 12 >> 2] | 0;
     HEAP32[i484 >> 2] = HEAP32[i74 >> 2];
     HEAP32[i209 >> 2] = i73;
     HEAP32[i210 >> 2] = i72;
     HEAP32[i211 >> 2] = i71;
     i71 = (HEAP32[i212 >> 2] | 0) + (i76 << 2) | 0;
     i72 = HEAP32[i71 + 4 >> 2] | 0;
     i73 = HEAP32[i71 + 8 >> 2] | 0;
     i74 = HEAP32[i71 + 12 >> 2] | 0;
     HEAP32[i485 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i213 >> 2] = i72;
     HEAP32[i214 >> 2] = i73;
     HEAP32[i215 >> 2] = i74;
     if (HEAP32[i496 >> 2] & 268435456 | 0) {
      i71 = (HEAP32[i216 >> 2] | 0) + (i76 << 2) | 0;
      i72 = HEAP32[i71 + 4 >> 2] | 0;
      i73 = HEAP32[i71 + 8 >> 2] | 0;
      i74 = HEAP32[i71 + 12 >> 2] | 0;
      HEAP32[i486 >> 2] = HEAP32[i71 >> 2];
      HEAP32[i217 >> 2] = i72;
      HEAP32[i218 >> 2] = i73;
      HEAP32[i219 >> 2] = i74;
     }
    } else {
     i4 = HEAP32[i192 >> 2] | 0;
     i5 = HEAP32[i195 >> 2] | 0;
     i6 = HEAP32[i189 >> 2] | 0;
     i7 = HEAP32[i193 >> 2] | 0;
     i8 = HEAP32[i196 >> 2] | 0;
     i12 = HEAP32[i190 >> 2] | 0;
     i13 = HEAP32[i194 >> 2] | 0;
     i14 = HEAP32[i197 >> 2] | 0;
     i15 = HEAP32[i200 >> 2] | 0;
     i16 = HEAP32[i204 >> 2] | 0;
     i17 = HEAP32[i208 >> 2] | 0;
     i18 = HEAP32[i212 >> 2] | 0;
     i21 = HEAP32[i191 >> 2] | 0;
     i3 = HEAP32[i216 >> 2] | 0;
     if (!(HEAP32[i496 >> 2] & 268435456)) {
      i2 = 0;
      do {
       i73 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i500 + (i2 << 2) >> 2] = HEAP32[i20 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i4 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i2 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i5 + (i73 << 2) >> 2]));
       i74 = i2 + 4 | 0;
       HEAP32[i500 + (i74 << 2) >> 2] = HEAP32[i6 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i7 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i8 + (i73 << 2) >> 2]));
       i74 = i2 + 8 | 0;
       HEAP32[i500 + (i74 << 2) >> 2] = HEAP32[i12 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i13 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i14 + (i73 << 2) >> 2]));
       HEAP32[i482 + (i2 << 2) >> 2] = HEAP32[i15 + (i73 << 2) >> 2];
       HEAP32[i483 + (i2 << 2) >> 2] = HEAP32[i16 + (i73 << 2) >> 2];
       HEAP32[i484 + (i2 << 2) >> 2] = HEAP32[i17 + (i73 << 2) >> 2];
       HEAP32[i485 + (i2 << 2) >> 2] = HEAP32[i18 + (i73 << 2) >> 2];
       HEAP32[i501 + (i74 << 2) >> 2] = HEAP32[i21 + (i73 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     } else {
      i2 = 0;
      do {
       i73 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i500 + (i2 << 2) >> 2] = HEAP32[i20 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i4 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i2 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i5 + (i73 << 2) >> 2]));
       i74 = i2 + 4 | 0;
       HEAP32[i500 + (i74 << 2) >> 2] = HEAP32[i6 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i7 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i8 + (i73 << 2) >> 2]));
       i74 = i2 + 8 | 0;
       HEAP32[i500 + (i74 << 2) >> 2] = HEAP32[i12 + (i73 << 2) >> 2];
       f75 = Math_fround(HEAPF32[i13 + (i73 << 2) >> 2]);
       HEAPF32[i481 + (i74 << 2) >> 2] = Math_fround(f75 + Math_fround(HEAPF32[i14 + (i73 << 2) >> 2]));
       HEAP32[i482 + (i2 << 2) >> 2] = HEAP32[i15 + (i73 << 2) >> 2];
       HEAP32[i483 + (i2 << 2) >> 2] = HEAP32[i16 + (i73 << 2) >> 2];
       HEAP32[i484 + (i2 << 2) >> 2] = HEAP32[i17 + (i73 << 2) >> 2];
       HEAP32[i485 + (i2 << 2) >> 2] = HEAP32[i18 + (i73 << 2) >> 2];
       HEAP32[i486 + (i2 << 2) >> 2] = HEAP32[i3 + (i73 << 2) >> 2];
       HEAP32[i501 + (i74 << 2) >> 2] = HEAP32[i21 + (i73 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     }
    }
    f33 = Math_fround(HEAPF32[i500 >> 2]);
    f11 = Math_fround(f436 * f33);
    f31 = Math_fround(HEAPF32[i166 >> 2]);
    f29 = Math_fround(f436 * f31);
    f58 = Math_fround(HEAPF32[i165 >> 2]);
    f10 = Math_fround(f436 * f58);
    f56 = Math_fround(HEAPF32[i164 >> 2]);
    f75 = Math_fround(f436 * f56);
    f32 = Math_fround(HEAPF32[i220 >> 2]);
    f30 = Math_fround(f439 * f32);
    f26 = Math_fround(HEAPF32[i170 >> 2]);
    f35 = Math_fround(f439 * f26);
    f57 = Math_fround(HEAPF32[i169 >> 2]);
    f24 = Math_fround(f439 * f57);
    f55 = Math_fround(HEAPF32[i168 >> 2]);
    f30 = Math_fround(f11 + f30);
    f35 = Math_fround(f29 + f35);
    f24 = Math_fround(f10 + f24);
    f75 = Math_fround(f75 + Math_fround(f439 * f55));
    f10 = Math_fround(HEAPF32[i221 >> 2]);
    f29 = Math_fround(f442 * f10);
    f11 = Math_fround(HEAPF32[i174 >> 2]);
    f28 = Math_fround(f442 * f11);
    f22 = Math_fround(HEAPF32[i173 >> 2]);
    f27 = Math_fround(f442 * f22);
    f34 = Math_fround(HEAPF32[i172 >> 2]);
    f28 = Math_fround(f445 + Math_fround(f35 + f28));
    f27 = Math_fround(f445 + Math_fround(f24 + f27));
    f75 = Math_fround(f445 + Math_fround(f75 + Math_fround(f442 * f34)));
    HEAPF32[i487 >> 2] = Math_fround(f445 + Math_fround(f30 + f29));
    HEAPF32[i222 >> 2] = f28;
    HEAPF32[i223 >> 2] = f27;
    HEAPF32[i224 >> 2] = f75;
    f75 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f31) + Math_fround(f440 * f26)) + Math_fround(f443 * f11)));
    f27 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f58) + Math_fround(f440 * f57)) + Math_fround(f443 * f22)));
    f28 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f56) + Math_fround(f440 * f55)) + Math_fround(f443 * f34)));
    HEAPF32[i225 >> 2] = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f33) + Math_fround(f440 * f32)) + Math_fround(f443 * f10)));
    HEAPF32[i226 >> 2] = f75;
    HEAPF32[i227 >> 2] = f27;
    HEAPF32[i228 >> 2] = f28;
    f28 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f31) + Math_fround(f441 * f26)) + Math_fround(f444 * f11)));
    f27 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f58) + Math_fround(f441 * f57)) + Math_fround(f444 * f22)));
    f75 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f56) + Math_fround(f441 * f55)) + Math_fround(f444 * f34)));
    HEAPF32[i229 >> 2] = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f33) + Math_fround(f441 * f32)) + Math_fround(f444 * f10)));
    HEAPF32[i230 >> 2] = f28;
    HEAPF32[i231 >> 2] = f27;
    HEAPF32[i232 >> 2] = f75;
    f10 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f33) + Math_fround(f478 * f32)) + Math_fround(f479 * f10)));
    f11 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f31) + Math_fround(f478 * f26)) + Math_fround(f479 * f11)));
    f22 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f58) + Math_fround(f478 * f57)) + Math_fround(f479 * f22)));
    f34 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f56) + Math_fround(f478 * f55)) + Math_fround(f479 * f34)));
    f55 = Math_fround(f467 + Math_fround(f468 * f10));
    f56 = Math_fround(f467 + Math_fround(f468 * f11));
    f57 = Math_fround(f467 + Math_fround(f468 * f22));
    f58 = Math_fround(f467 + Math_fround(f468 * f34));
    f10 = Math_fround(f463 + Math_fround(f464 * f10));
    f11 = Math_fround(f463 + Math_fround(f464 * f11));
    f22 = Math_fround(f463 + Math_fround(f464 * f22));
    f34 = Math_fround(f463 + Math_fround(f464 * f34));
    f26 = Math_fround(HEAPF32[i482 >> 2]);
    f31 = Math_fround(HEAPF32[i201 >> 2]);
    f32 = Math_fround(HEAPF32[i202 >> 2]);
    f33 = Math_fround(HEAPF32[i203 >> 2]);
    f27 = Math_fround(HEAPF32[i483 >> 2]);
    f28 = Math_fround(HEAPF32[i205 >> 2]);
    f29 = Math_fround(HEAPF32[i206 >> 2]);
    f30 = Math_fround(HEAPF32[i207 >> 2]);
    f24 = f26 > f27 ? f26 : f27;
    f35 = f31 > f28 ? f31 : f28;
    f25 = f32 > f29 ? f32 : f29;
    f36 = f33 > f30 ? f33 : f30;
    f52 = Math_fround((f24 > f55 ? f24 : f55) * Math_fround(.5));
    f53 = Math_fround((f35 > f56 ? f35 : f56) * Math_fround(.5));
    f54 = Math_fround((f25 > f57 ? f25 : f57) * Math_fround(.5));
    f9 = Math_fround((f36 > f58 ? f36 : f58) * Math_fround(.5));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    i71 = f55 >= Math_fround(0.0);
    i72 = f56 >= Math_fround(0.0);
    i73 = f57 >= Math_fround(0.0);
    i74 = f58 >= Math_fround(0.0);
    i12 = i71 ? i12 : 0;
    i13 = i72 ? i13 : 0;
    i14 = i73 ? i14 : 0;
    i5 = i74 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    f54 = Math_fround(f10 * Math_fround(.5));
    f56 = Math_fround(f11 * Math_fround(.5));
    f58 = Math_fround(f22 * Math_fround(.5));
    f9 = Math_fround(f34 * Math_fround(.5));
    f53 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f57 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f53 < f54 ? f53 : f54, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f55 < f56 ? f55 : f56, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f57 < f58 ? f57 : f58, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = f10 >= Math_fround(0.0);
    i3 = f11 >= Math_fround(0.0);
    i2 = f22 >= Math_fround(0.0);
    i74 = f34 >= Math_fround(0.0);
    i71 = i74 ? (HEAPF32[tempDoublePtr >> 2] = f23 < f9 ? f23 : f9, HEAP32[tempDoublePtr >> 2] | 0) : i5;
    f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f24);
    f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f35);
    f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
    f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f36);
    f46 = Math_fround(f26 * f55);
    f45 = Math_fround(f31 * f56);
    f44 = Math_fround(f32 * f57);
    f43 = Math_fround(f33 * f34);
    f31 = Math_fround(f27 * f55);
    f32 = Math_fround(f28 * f56);
    f33 = Math_fround(f29 * f57);
    f34 = Math_fround(f30 * f34);
    i71 = Math_fround(HEAPF32[i484 >> 2]) < Math_fround(100.0);
    i72 = Math_fround(HEAPF32[i209 >> 2]) < Math_fround(100.0);
    i73 = Math_fround(HEAPF32[i210 >> 2]) < Math_fround(100.0);
    i74 = Math_fround(HEAPF32[i211 >> 2]) < Math_fround(100.0);
    f57 = Math_fround(Math_fround(HEAPF32[i175 >> 2]) * Math_fround(.159154937));
    f56 = Math_fround(Math_fround(HEAPF32[i178 >> 2]) * Math_fround(.159154937));
    f55 = Math_fround(Math_fround(HEAPF32[i177 >> 2]) * Math_fround(.159154937));
    f28 = Math_fround(Math_fround(HEAPF32[i176 >> 2]) * Math_fround(.159154937));
    f27 = Math_fround(+_roundf(+f57));
    f516 = Math_fround(+_roundf(+f56));
    f58 = Math_fround(+_roundf(+f55));
    f27 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f57 - f27))));
    f516 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f56 - f516))));
    f58 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f55 - f58))));
    f504 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
    f50 = Math_fround(f27 * f27);
    f49 = Math_fround(f516 * f516);
    f48 = Math_fround(f58 * f58);
    f47 = Math_fround(f504 * f504);
    f29 = Math_fround(f50 * f50);
    f517 = Math_fround(f49 * f49);
    f30 = Math_fround(f48 * f48);
    f505 = Math_fround(f47 * f47);
    f50 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f50 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f50 * Math_fround(76.5686187)))))));
    f49 = Math_fround(f516 * Math_fround(Math_fround(Math_fround(f517 * f517) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f49 * Math_fround(41.3416595))) + Math_fround(f517 * Math_fround(Math_fround(81.6018218) - Math_fround(f49 * Math_fround(76.5686187)))))));
    f48 = Math_fround(f58 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f48 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f48 * Math_fround(76.5686187)))))));
    f47 = Math_fround(f504 * Math_fround(Math_fround(Math_fround(f505 * f505) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f47 * Math_fround(41.3416595))) + Math_fround(f505 * Math_fround(Math_fround(81.6018218) - Math_fround(f47 * Math_fround(76.5686187)))))));
    f57 = Math_fround(f57 + Math_fround(-.25));
    f56 = Math_fround(f56 + Math_fround(-.25));
    f55 = Math_fround(f55 + Math_fround(-.25));
    f28 = Math_fround(f28 + Math_fround(-.25));
    f505 = Math_fround(+_roundf(+f57));
    f504 = Math_fround(+_roundf(+f56));
    f30 = Math_fround(+_roundf(+f55));
    f505 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f57 - f505))));
    f504 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f56 - f504))));
    f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f55 - f30))));
    f28 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
    f55 = Math_fround(f505 * f505);
    f56 = Math_fround(f504 * f504);
    f57 = Math_fround(f30 * f30);
    f58 = Math_fround(f28 * f28);
    f517 = Math_fround(f55 * f55);
    f516 = Math_fround(f56 * f56);
    f29 = Math_fround(f57 * f57);
    f27 = Math_fround(f58 * f58);
    f55 = Math_fround(f505 * Math_fround(Math_fround(Math_fround(f517 * f517) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f55 * Math_fround(41.3416595))) + Math_fround(f517 * Math_fround(Math_fround(81.6018218) - Math_fround(f55 * Math_fround(76.5686187)))))));
    f56 = Math_fround(f504 * Math_fround(Math_fround(Math_fround(f516 * f516) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f56 * Math_fround(41.3416595))) + Math_fround(f516 * Math_fround(Math_fround(81.6018218) - Math_fround(f56 * Math_fround(76.5686187)))))));
    f57 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f57 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f57 * Math_fround(76.5686187)))))));
    f58 = Math_fround(f28 * Math_fround(Math_fround(Math_fround(f27 * f27) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f58 * Math_fround(41.3416595))) + Math_fround(f27 * Math_fround(Math_fround(81.6018218) - Math_fround(f58 * Math_fround(76.5686187)))))));
    f27 = i71 ? f46 : Math_fround(0.0);
    f55 = Math_fround(f27 * f55);
    f28 = i72 ? f45 : Math_fround(0.0);
    f56 = Math_fround(f28 * f56);
    f29 = i73 ? f44 : Math_fround(0.0);
    f57 = Math_fround(f29 * f57);
    f30 = i74 ? f43 : Math_fround(0.0);
    f58 = Math_fround(f30 * f58);
    f31 = i71 ? f31 : Math_fround(0.0);
    f50 = Math_fround(f31 * f50);
    f32 = i72 ? f32 : Math_fround(0.0);
    f49 = Math_fround(f32 * f49);
    f33 = i73 ? f33 : Math_fround(0.0);
    f48 = Math_fround(f33 * f48);
    f34 = i74 ? f34 : Math_fround(0.0);
    f47 = Math_fround(f34 * f47);
    f43 = Math_fround(f55 - f50);
    f44 = Math_fround(f56 - f49);
    f45 = Math_fround(f57 - f48);
    f46 = Math_fround(f58 - f47);
    f516 = Math_fround(f50 + f55);
    f504 = Math_fround(f49 + f56);
    f517 = Math_fround(f48 + f57);
    f505 = Math_fround(f47 + f58);
    f35 = Math_fround(f81 + Math_fround(Math_fround(f331 * f43) + Math_fround(f332 * f516)));
    f36 = Math_fround(f81 + Math_fround(Math_fround(f331 * f44) + Math_fround(f332 * f504)));
    f37 = Math_fround(f81 + Math_fround(Math_fround(f331 * f45) + Math_fround(f332 * f517)));
    f38 = Math_fround(f81 + Math_fround(Math_fround(f331 * f46) + Math_fround(f332 * f505)));
    f39 = Math_fround(f80 + Math_fround(Math_fround(f333 * f43) + Math_fround(f334 * f516)));
    f40 = Math_fround(f80 + Math_fround(Math_fround(f333 * f44) + Math_fround(f334 * f504)));
    f41 = Math_fround(f80 + Math_fround(Math_fround(f333 * f45) + Math_fround(f334 * f517)));
    f42 = Math_fround(f80 + Math_fround(Math_fround(f333 * f46) + Math_fround(f334 * f505)));
    f43 = Math_fround(f78 + Math_fround(Math_fround(f335 * f43) + Math_fround(f336 * f516)));
    f44 = Math_fround(f78 + Math_fround(Math_fround(f335 * f44) + Math_fround(f336 * f504)));
    f45 = Math_fround(f78 + Math_fround(Math_fround(f335 * f45) + Math_fround(f336 * f517)));
    f46 = Math_fround(f78 + Math_fround(Math_fround(f335 * f46) + Math_fround(f336 * f505)));
    f55 = Math_fround(f50 - f55);
    f56 = Math_fround(f49 - f56);
    f57 = Math_fround(f48 - f57);
    f58 = Math_fround(f47 - f58);
    f47 = Math_fround(f81 + Math_fround(Math_fround(f331 * f516) + Math_fround(f332 * f55)));
    f48 = Math_fround(f81 + Math_fround(Math_fround(f331 * f504) + Math_fround(f332 * f56)));
    f49 = Math_fround(f81 + Math_fround(Math_fround(f331 * f517) + Math_fround(f332 * f57)));
    f50 = Math_fround(f81 + Math_fround(Math_fround(f331 * f505) + Math_fround(f332 * f58)));
    f51 = Math_fround(f80 + Math_fround(Math_fround(f333 * f516) + Math_fround(f334 * f55)));
    f52 = Math_fround(f80 + Math_fround(Math_fround(f333 * f504) + Math_fround(f334 * f56)));
    f53 = Math_fround(f80 + Math_fround(Math_fround(f333 * f517) + Math_fround(f334 * f57)));
    f54 = Math_fround(f80 + Math_fround(Math_fround(f333 * f505) + Math_fround(f334 * f58)));
    f55 = Math_fround(f78 + Math_fround(Math_fround(f335 * f516) + Math_fround(f336 * f55)));
    f56 = Math_fround(f78 + Math_fround(Math_fround(f335 * f504) + Math_fround(f336 * f56)));
    f57 = Math_fround(f78 + Math_fround(Math_fround(f335 * f517) + Math_fround(f336 * f57)));
    f58 = Math_fround(f78 + Math_fround(Math_fround(f335 * f505) + Math_fround(f336 * f58)));
    f505 = Math_fround(HEAPF32[i487 >> 2]);
    f517 = Math_fround(f505 + f35);
    f504 = Math_fround(HEAPF32[i222 >> 2]);
    f516 = Math_fround(f504 + f36);
    f503 = Math_fround(HEAPF32[i223 >> 2]);
    f515 = Math_fround(f503 + f37);
    f9 = Math_fround(HEAPF32[i224 >> 2]);
    f514 = Math_fround(f9 + f38);
    f10 = Math_fround(HEAPF32[i225 >> 2]);
    f513 = Math_fround(f10 + f39);
    f11 = Math_fround(HEAPF32[i226 >> 2]);
    f512 = Math_fround(f11 + f40);
    f22 = Math_fround(HEAPF32[i227 >> 2]);
    f511 = Math_fround(f22 + f41);
    f23 = Math_fround(HEAPF32[i228 >> 2]);
    f510 = Math_fround(f23 + f42);
    f24 = Math_fround(HEAPF32[i229 >> 2]);
    f509 = Math_fround(f24 + f43);
    f25 = Math_fround(HEAPF32[i230 >> 2]);
    f508 = Math_fround(f25 + f44);
    f26 = Math_fround(HEAPF32[i231 >> 2]);
    f507 = Math_fround(f26 + f45);
    f506 = Math_fround(f75 + f46);
    HEAPF32[i493 >> 2] = f517;
    HEAPF32[i233 >> 2] = f516;
    HEAPF32[i234 >> 2] = f515;
    HEAPF32[i235 >> 2] = f514;
    HEAPF32[i236 >> 2] = f513;
    HEAPF32[i237 >> 2] = f512;
    HEAPF32[i238 >> 2] = f511;
    HEAPF32[i239 >> 2] = f510;
    HEAPF32[i240 >> 2] = f509;
    HEAPF32[i241 >> 2] = f508;
    HEAPF32[i242 >> 2] = f507;
    HEAPF32[i243 >> 2] = f506;
    f506 = Math_fround(f504 + f48);
    f507 = Math_fround(f503 + f49);
    f508 = Math_fround(f9 + f50);
    f509 = Math_fround(f10 + f51);
    f510 = Math_fround(f11 + f52);
    f511 = Math_fround(f22 + f53);
    f512 = Math_fround(f23 + f54);
    f513 = Math_fround(f24 + f55);
    f514 = Math_fround(f25 + f56);
    f515 = Math_fround(f26 + f57);
    f516 = Math_fround(f75 + f58);
    HEAPF32[i244 >> 2] = Math_fround(f505 + f47);
    HEAPF32[i245 >> 2] = f506;
    HEAPF32[i246 >> 2] = f507;
    HEAPF32[i247 >> 2] = f508;
    HEAPF32[i248 >> 2] = f509;
    HEAPF32[i249 >> 2] = f510;
    HEAPF32[i250 >> 2] = f511;
    HEAPF32[i251 >> 2] = f512;
    HEAPF32[i252 >> 2] = f513;
    HEAPF32[i253 >> 2] = f514;
    HEAPF32[i254 >> 2] = f515;
    HEAPF32[i255 >> 2] = f516;
    f516 = Math_fround(f504 - f36);
    f515 = Math_fround(f503 - f37);
    f514 = Math_fround(f9 - f38);
    f513 = Math_fround(f10 - f39);
    f512 = Math_fround(f11 - f40);
    f511 = Math_fround(f22 - f41);
    f510 = Math_fround(f23 - f42);
    f509 = Math_fround(f24 - f43);
    f508 = Math_fround(f25 - f44);
    f507 = Math_fround(f26 - f45);
    f506 = Math_fround(f75 - f46);
    HEAPF32[i256 >> 2] = Math_fround(f505 - f35);
    HEAPF32[i257 >> 2] = f516;
    HEAPF32[i258 >> 2] = f515;
    HEAPF32[i259 >> 2] = f514;
    HEAPF32[i260 >> 2] = f513;
    HEAPF32[i261 >> 2] = f512;
    HEAPF32[i262 >> 2] = f511;
    HEAPF32[i263 >> 2] = f510;
    HEAPF32[i264 >> 2] = f509;
    HEAPF32[i265 >> 2] = f508;
    HEAPF32[i266 >> 2] = f507;
    HEAPF32[i267 >> 2] = f506;
    f504 = Math_fround(f504 - f48);
    f503 = Math_fround(f503 - f49);
    f9 = Math_fround(f9 - f50);
    f10 = Math_fround(f10 - f51);
    f11 = Math_fround(f11 - f52);
    f22 = Math_fround(f22 - f53);
    f23 = Math_fround(f23 - f54);
    f24 = Math_fround(f24 - f55);
    f25 = Math_fround(f25 - f56);
    f26 = Math_fround(f26 - f57);
    f75 = Math_fround(f75 - f58);
    HEAPF32[i268 >> 2] = Math_fround(f505 - f47);
    HEAPF32[i269 >> 2] = f504;
    HEAPF32[i270 >> 2] = f503;
    HEAPF32[i271 >> 2] = f9;
    HEAPF32[i272 >> 2] = f10;
    HEAPF32[i273 >> 2] = f11;
    HEAPF32[i274 >> 2] = f22;
    HEAPF32[i275 >> 2] = f23;
    HEAPF32[i276 >> 2] = f24;
    HEAPF32[i277 >> 2] = f25;
    HEAPF32[i278 >> 2] = f26;
    HEAPF32[i279 >> 2] = f75;
    if (!i280) {
     i2 = HEAP32[i496 >> 2] | 0;
     if (i2 & 536870912) {
      f517 = Math_fround(HEAPF32[i79 >> 2]);
      i62 = HEAP32[i485 >> 2] | 0;
      i73 = i62 + 693089735 | 0;
      i60 = HEAP32[i213 >> 2] | 0;
      i70 = i60 + 693089735 | 0;
      i21 = HEAP32[i214 >> 2] | 0;
      i67 = i21 + 693089735 | 0;
      i19 = HEAP32[i215 >> 2] | 0;
      i64 = i19 + 693089735 | 0;
      i20 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i59 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i61 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i63 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i73 = i73 << 11 ^ i73;
      i70 = i70 << 11 ^ i70;
      i67 = i67 << 11 ^ i67;
      i64 = i64 << 11 ^ i64;
      i20 = Math_fround(Math_fround((i20 ^ i73 ^ i73 >>> 8) & 8388607 ^ i20 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i59 = Math_fround(Math_fround((i59 ^ i70 ^ i70 >>> 8) & 8388607 ^ i59 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i61 = Math_fround(Math_fround((i61 ^ i67 ^ i67 >>> 8) & 8388607 ^ i61 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i63 = Math_fround(Math_fround((i63 ^ i64 ^ i64 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      f517 = Math_fround(HEAPF32[i77 >> 2]);
      i62 = i62 + 13945730 | 0;
      i60 = i60 + 13945730 | 0;
      i21 = i21 + 13945730 | 0;
      i19 = i19 + 13945730 | 0;
      i64 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i60, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i19, 1790253981) | 0) + 1900727103 | 0;
      i62 = i62 << 11 ^ i62;
      i60 = i60 << 11 ^ i60;
      i21 = i21 << 11 ^ i21;
      i19 = i19 << 11 ^ i19;
      i64 = Math_fround(Math_fround((i64 ^ i62 ^ i62 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i67 = Math_fround(Math_fround((i67 ^ i60 ^ i60 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i70 = Math_fround(Math_fround((i70 ^ i21 ^ i21 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i73 = Math_fround(Math_fround((i73 ^ i19 ^ i19 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i19 = i20 & 1;
      i21 = i59 & 1;
      i60 = i61 & 1;
      i62 = i63 & 1;
      i65 = i19 ^ 1;
      i68 = i21 ^ 1;
      i71 = i60 ^ 1;
      i74 = i62 ^ 1;
      i66 = i20 ? 3 : 2;
      i69 = i59 ? 3 : 2;
      i72 = i61 ? 3 : 2;
      i2 = i63 ? 3 : 2;
      i20 = i20 ? 2 : 3;
      i59 = i59 ? 2 : 3;
      i61 = i61 ? 2 : 3;
      i63 = i63 ? 2 : 3;
      HEAP32[i490 >> 2] = i64 ? i20 : i19;
      HEAP32[i450 >> 2] = i67 ? i59 : i21;
      HEAP32[i449 >> 2] = i70 ? i61 : i60;
      HEAP32[i448 >> 2] = i73 ? i63 : i62;
      HEAP32[i462 >> 2] = i64 ? i19 : i20;
      HEAP32[i461 >> 2] = i67 ? i21 : i59;
      HEAP32[i460 >> 2] = i70 ? i60 : i61;
      HEAP32[i459 >> 2] = i73 ? i62 : i63;
      HEAP32[i454 >> 2] = i64 ? i66 : i65;
      HEAP32[i453 >> 2] = i67 ? i69 : i68;
      HEAP32[i452 >> 2] = i70 ? i72 : i71;
      HEAP32[i451 >> 2] = i73 ? i2 : i74;
      HEAP32[i458 >> 2] = i64 ? i65 : i66;
      HEAP32[i457 >> 2] = i67 ? i68 : i69;
      HEAP32[i456 >> 2] = i70 ? i71 : i72;
      HEAP32[i455 >> 2] = i73 ? i74 : i2;
      i2 = HEAP32[i496 >> 2] | 0;
     }
     if (i2 & 268435456 | 0) {
      f9 = Math_fround(f472 * Math_fround(HEAPF32[i486 >> 2]));
      f10 = Math_fround(f472 * Math_fround(HEAPF32[i217 >> 2]));
      f11 = Math_fround(f472 * Math_fround(HEAPF32[i218 >> 2]));
      f22 = Math_fround(f472 * Math_fround(HEAPF32[i219 >> 2]));
      f23 = Math_fround(Math_floor(Math_fround(f9)));
      f24 = Math_fround(Math_floor(Math_fround(f10)));
      f25 = Math_fround(Math_floor(Math_fround(f11)));
      f26 = Math_fround(Math_floor(Math_fround(f22)));
      if (i2 & 16777216 | 0) {
       f514 = Math_fround(Math_floor(Math_fround(f471 * f23)));
       f515 = Math_fround(Math_floor(Math_fround(f471 * f24)));
       f516 = Math_fround(Math_floor(Math_fround(f471 * f25)));
       f517 = Math_fround(Math_floor(Math_fround(f471 * f26)));
       f510 = Math_fround(f473 * Math_fround(f23 - Math_fround(f470 * f514)));
       f511 = Math_fround(f473 * Math_fround(f24 - Math_fround(f470 * f515)));
       f512 = Math_fround(f473 * Math_fround(f25 - Math_fround(f470 * f516)));
       f513 = Math_fround(f473 * Math_fround(f26 - Math_fround(f470 * f517)));
       f514 = Math_fround(f475 - Math_fround(f474 * f514));
       f515 = Math_fround(f475 - Math_fround(f474 * f515));
       f516 = Math_fround(f475 - Math_fround(f474 * f516));
       f517 = Math_fround(f475 - Math_fround(f474 * f517));
       f75 = Math_fround(f474 + f514);
       f503 = Math_fround(f474 + f515);
       f504 = Math_fround(f474 + f516);
       f505 = Math_fround(f474 + f517);
       HEAPF32[i491 >> 2] = f510;
       HEAPF32[i387 >> 2] = f511;
       HEAPF32[i411 >> 2] = f512;
       HEAPF32[i435 >> 2] = f513;
       HEAPF32[i363 >> 2] = f75;
       HEAPF32[i386 >> 2] = f503;
       HEAPF32[i410 >> 2] = f504;
       HEAPF32[i434 >> 2] = f505;
       f506 = Math_fround(f473 + f510);
       f507 = Math_fround(f473 + f511);
       f508 = Math_fround(f473 + f512);
       f509 = Math_fround(f473 + f513);
       HEAPF32[i362 >> 2] = f506;
       HEAPF32[i385 >> 2] = f507;
       HEAPF32[i409 >> 2] = f508;
       HEAPF32[i433 >> 2] = f509;
       HEAPF32[i361 >> 2] = f75;
       HEAPF32[i384 >> 2] = f503;
       HEAPF32[i408 >> 2] = f504;
       HEAPF32[i432 >> 2] = f505;
       HEAPF32[i360 >> 2] = f506;
       HEAPF32[i383 >> 2] = f507;
       HEAPF32[i407 >> 2] = f508;
       HEAPF32[i431 >> 2] = f509;
       HEAPF32[i359 >> 2] = f514;
       HEAPF32[i382 >> 2] = f515;
       HEAPF32[i406 >> 2] = f516;
       HEAPF32[i430 >> 2] = f517;
       HEAPF32[i358 >> 2] = f510;
       HEAPF32[i381 >> 2] = f511;
       HEAPF32[i405 >> 2] = f512;
       HEAPF32[i429 >> 2] = f513;
       HEAPF32[i357 >> 2] = f514;
       HEAPF32[i380 >> 2] = f515;
       HEAPF32[i404 >> 2] = f516;
       HEAPF32[i428 >> 2] = f517;
      }
      if (i2 & 33554432 | 0) {
       f506 = Math_fround(f23 + Math_fround(1.0));
       f507 = Math_fround(f24 + Math_fround(1.0));
       f508 = Math_fround(f25 + Math_fround(1.0));
       f509 = Math_fround(f26 + Math_fround(1.0));
       f514 = Math_fround(f9 - f23);
       f515 = Math_fround(f10 - f24);
       f516 = Math_fround(f11 - f25);
       f517 = Math_fround(f22 - f26);
       f510 = Math_fround(Math_floor(Math_fround(f471 * f506)));
       f511 = Math_fround(Math_floor(Math_fround(f471 * f507)));
       f512 = Math_fround(Math_floor(Math_fround(f471 * f508)));
       f513 = Math_fround(Math_floor(Math_fround(f471 * f509)));
       f506 = Math_fround(f473 * Math_fround(f506 - Math_fround(f470 * f510)));
       f507 = Math_fround(f473 * Math_fround(f507 - Math_fround(f470 * f511)));
       f508 = Math_fround(f473 * Math_fround(f508 - Math_fround(f470 * f512)));
       f509 = Math_fround(f473 * Math_fround(f509 - Math_fround(f470 * f513)));
       f510 = Math_fround(f475 - Math_fround(f474 * f510));
       f511 = Math_fround(f475 - Math_fround(f474 * f511));
       f512 = Math_fround(f475 - Math_fround(f474 * f512));
       f513 = Math_fround(f475 - Math_fround(f474 * f513));
       f23 = Math_fround(f474 + f510);
       f24 = Math_fround(f474 + f511);
       f25 = Math_fround(f474 + f512);
       f26 = Math_fround(f474 + f513);
       HEAPF32[i492 >> 2] = f506;
       HEAPF32[i379 >> 2] = f507;
       HEAPF32[i403 >> 2] = f508;
       HEAPF32[i427 >> 2] = f509;
       HEAPF32[i356 >> 2] = f23;
       HEAPF32[i378 >> 2] = f24;
       HEAPF32[i402 >> 2] = f25;
       HEAPF32[i426 >> 2] = f26;
       HEAPF32[i355 >> 2] = f514;
       HEAPF32[i377 >> 2] = f515;
       HEAPF32[i401 >> 2] = f516;
       HEAPF32[i425 >> 2] = f517;
       HEAPF32[i354 >> 2] = f9;
       HEAPF32[i376 >> 2] = f10;
       HEAPF32[i400 >> 2] = f11;
       HEAPF32[i424 >> 2] = f22;
       f75 = Math_fround(f473 + f506);
       f503 = Math_fround(f473 + f507);
       f504 = Math_fround(f473 + f508);
       f505 = Math_fround(f473 + f509);
       HEAPF32[i353 >> 2] = f75;
       HEAPF32[i375 >> 2] = f503;
       HEAPF32[i399 >> 2] = f504;
       HEAPF32[i423 >> 2] = f505;
       HEAPF32[i352 >> 2] = f23;
       HEAPF32[i374 >> 2] = f24;
       HEAPF32[i398 >> 2] = f25;
       HEAPF32[i422 >> 2] = f26;
       HEAPF32[i351 >> 2] = f514;
       HEAPF32[i373 >> 2] = f515;
       HEAPF32[i397 >> 2] = f516;
       HEAPF32[i421 >> 2] = f517;
       HEAPF32[i350 >> 2] = f9;
       HEAPF32[i372 >> 2] = f10;
       HEAPF32[i396 >> 2] = f11;
       HEAPF32[i420 >> 2] = f22;
       HEAPF32[i349 >> 2] = f75;
       HEAPF32[i371 >> 2] = f503;
       HEAPF32[i395 >> 2] = f504;
       HEAPF32[i419 >> 2] = f505;
       HEAPF32[i348 >> 2] = f510;
       HEAPF32[i370 >> 2] = f511;
       HEAPF32[i394 >> 2] = f512;
       HEAPF32[i418 >> 2] = f513;
       HEAPF32[i347 >> 2] = f514;
       HEAPF32[i369 >> 2] = f515;
       HEAPF32[i393 >> 2] = f516;
       HEAPF32[i417 >> 2] = f517;
       HEAPF32[i346 >> 2] = f9;
       HEAPF32[i368 >> 2] = f10;
       HEAPF32[i392 >> 2] = f11;
       HEAPF32[i416 >> 2] = f22;
       HEAPF32[i345 >> 2] = f506;
       HEAPF32[i367 >> 2] = f507;
       HEAPF32[i391 >> 2] = f508;
       HEAPF32[i415 >> 2] = f509;
       HEAPF32[i344 >> 2] = f510;
       HEAPF32[i366 >> 2] = f511;
       HEAPF32[i390 >> 2] = f512;
       HEAPF32[i414 >> 2] = f513;
       HEAPF32[i343 >> 2] = f514;
       HEAPF32[i365 >> 2] = f515;
       HEAPF32[i389 >> 2] = f516;
       HEAPF32[i413 >> 2] = f517;
       HEAPF32[i342 >> 2] = f9;
       HEAPF32[i364 >> 2] = f10;
       HEAPF32[i388 >> 2] = f11;
       HEAPF32[i412 >> 2] = f22;
      }
     }
    }
    f75 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
    f503 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
    f504 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
    f505 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
    f35 = Math_fround(f476 * Math_fround(f35 * f75));
    f36 = Math_fround(f476 * Math_fround(f36 * f503));
    f37 = Math_fround(f476 * Math_fround(f37 * f504));
    f38 = Math_fround(f476 * Math_fround(f38 * f505));
    f39 = Math_fround(f476 * Math_fround(f39 * f75));
    f40 = Math_fround(f476 * Math_fround(f40 * f503));
    f41 = Math_fround(f476 * Math_fround(f41 * f504));
    f42 = Math_fround(f476 * Math_fround(f42 * f505));
    f75 = Math_fround(f476 * Math_fround(f43 * f75));
    f503 = Math_fround(f476 * Math_fround(f44 * f503));
    f504 = Math_fround(f476 * Math_fround(f45 * f504));
    f505 = Math_fround(f476 * Math_fround(f46 * f505));
    f514 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
    f515 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
    f516 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
    f517 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
    f506 = Math_fround(f476 * Math_fround(f47 * f514));
    f507 = Math_fround(f476 * Math_fround(f48 * f515));
    f508 = Math_fround(f476 * Math_fround(f49 * f516));
    f509 = Math_fround(f476 * Math_fround(f50 * f517));
    f510 = Math_fround(f476 * Math_fround(f51 * f514));
    f511 = Math_fround(f476 * Math_fround(f52 * f515));
    f512 = Math_fround(f476 * Math_fround(f53 * f516));
    f513 = Math_fround(f476 * Math_fround(f54 * f517));
    f514 = Math_fround(f476 * Math_fround(f55 * f514));
    f515 = Math_fround(f476 * Math_fround(f56 * f515));
    f516 = Math_fround(f476 * Math_fround(f57 * f516));
    f517 = Math_fround(f476 * Math_fround(f58 * f517));
    f52 = Math_fround(f469 + f36);
    f53 = Math_fround(f469 + f37);
    f54 = Math_fround(f469 + f38);
    f55 = Math_fround(f465 + f39);
    f56 = Math_fround(f465 + f40);
    f57 = Math_fround(f465 + f41);
    f58 = Math_fround(f465 + f42);
    f51 = Math_fround(f466 + f75);
    f50 = Math_fround(f466 + f503);
    f49 = Math_fround(f466 + f504);
    f48 = Math_fround(f466 + f505);
    HEAPF32[i494 >> 2] = Math_fround(f469 + f35);
    HEAPF32[i124 >> 2] = f52;
    HEAPF32[i141 >> 2] = f53;
    HEAPF32[i158 >> 2] = f54;
    HEAPF32[i281 >> 2] = f55;
    HEAPF32[i119 >> 2] = f56;
    HEAPF32[i136 >> 2] = f57;
    HEAPF32[i153 >> 2] = f58;
    HEAPF32[i282 >> 2] = f51;
    HEAPF32[i114 >> 2] = f50;
    HEAPF32[i131 >> 2] = f49;
    HEAPF32[i148 >> 2] = f48;
    f48 = Math_fround(f469 + f507);
    f49 = Math_fround(f469 + f508);
    f50 = Math_fround(f469 + f509);
    f51 = Math_fround(f465 + f510);
    f58 = Math_fround(f465 + f511);
    f57 = Math_fround(f465 + f512);
    f56 = Math_fround(f465 + f513);
    f55 = Math_fround(f466 + f514);
    f54 = Math_fround(f466 + f515);
    f53 = Math_fround(f466 + f516);
    f52 = Math_fround(f466 + f517);
    HEAPF32[i283 >> 2] = Math_fround(f469 + f506);
    HEAPF32[i123 >> 2] = f48;
    HEAPF32[i140 >> 2] = f49;
    HEAPF32[i157 >> 2] = f50;
    HEAPF32[i284 >> 2] = f51;
    HEAPF32[i118 >> 2] = f58;
    HEAPF32[i135 >> 2] = f57;
    HEAPF32[i152 >> 2] = f56;
    HEAPF32[i285 >> 2] = f55;
    HEAPF32[i113 >> 2] = f54;
    HEAPF32[i130 >> 2] = f53;
    HEAPF32[i147 >> 2] = f52;
    f52 = Math_fround(f469 - f36);
    f53 = Math_fround(f469 - f37);
    f54 = Math_fround(f469 - f38);
    f55 = Math_fround(f465 - f39);
    f56 = Math_fround(f465 - f40);
    f57 = Math_fround(f465 - f41);
    f58 = Math_fround(f465 - f42);
    f75 = Math_fround(f466 - f75);
    f503 = Math_fround(f466 - f503);
    f504 = Math_fround(f466 - f504);
    f505 = Math_fround(f466 - f505);
    HEAPF32[i286 >> 2] = Math_fround(f469 - f35);
    HEAPF32[i122 >> 2] = f52;
    HEAPF32[i139 >> 2] = f53;
    HEAPF32[i156 >> 2] = f54;
    HEAPF32[i287 >> 2] = f55;
    HEAPF32[i117 >> 2] = f56;
    HEAPF32[i134 >> 2] = f57;
    HEAPF32[i151 >> 2] = f58;
    HEAPF32[i288 >> 2] = f75;
    HEAPF32[i112 >> 2] = f503;
    HEAPF32[i129 >> 2] = f504;
    HEAPF32[i146 >> 2] = f505;
    f507 = Math_fround(f469 - f507);
    f508 = Math_fround(f469 - f508);
    f509 = Math_fround(f469 - f509);
    f510 = Math_fround(f465 - f510);
    f511 = Math_fround(f465 - f511);
    f512 = Math_fround(f465 - f512);
    f513 = Math_fround(f465 - f513);
    f514 = Math_fround(f466 - f514);
    f515 = Math_fround(f466 - f515);
    f516 = Math_fround(f466 - f516);
    f517 = Math_fround(f466 - f517);
    HEAPF32[i289 >> 2] = Math_fround(f469 - f506);
    HEAPF32[i121 >> 2] = f507;
    HEAPF32[i138 >> 2] = f508;
    HEAPF32[i155 >> 2] = f509;
    HEAPF32[i290 >> 2] = f510;
    HEAPF32[i116 >> 2] = f511;
    HEAPF32[i133 >> 2] = f512;
    HEAPF32[i150 >> 2] = f513;
    HEAPF32[i291 >> 2] = f514;
    HEAPF32[i111 >> 2] = f515;
    HEAPF32[i128 >> 2] = f516;
    HEAPF32[i145 >> 2] = f517;
    do if (i162) {
     i4 = HEAP32[i188 >> 2] | 0;
     i5 = HEAP32[i498 >> 2] | 0;
     if (!i4) {
      i2 = 0;
      i3 = i1;
      while (1) {
       i74 = i5 + (i2 + i76 << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i493 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i494 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i244 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i256 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i268 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i74 >> 2];
       i74 = i491 + (HEAP32[i490 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     } else {
      i2 = 0;
      i3 = i1;
      while (1) {
       i74 = i5 + (HEAP32[i4 + (i2 + i76 << 3) >> 2] << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i493 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i494 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i244 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i283 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i256 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i286 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i74 >> 2];
       i73 = i491 + (HEAP32[i490 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i73 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i73 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i268 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i289 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i74 >> 2];
       i74 = i491 + (HEAP32[i490 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i74 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i74 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     }
    } else {
     f505 = Math_fround(HEAPF32[i244 >> 2]);
     f505 = Math_fround(f505 - Math_fround(HEAPF32[i493 >> 2]));
     f507 = Math_fround(HEAPF32[i245 >> 2]);
     f507 = Math_fround(f507 - Math_fround(HEAPF32[i233 >> 2]));
     f508 = Math_fround(HEAPF32[i246 >> 2]);
     f508 = Math_fround(f508 - Math_fround(HEAPF32[i234 >> 2]));
     f509 = Math_fround(HEAPF32[i247 >> 2]);
     f509 = Math_fround(f509 - Math_fround(HEAPF32[i235 >> 2]));
     f510 = Math_fround(HEAPF32[i248 >> 2]);
     f510 = Math_fround(f510 - Math_fround(HEAPF32[i236 >> 2]));
     f517 = Math_fround(HEAPF32[i249 >> 2]);
     f517 = Math_fround(f517 - Math_fround(HEAPF32[i237 >> 2]));
     f516 = Math_fround(HEAPF32[i250 >> 2]);
     f516 = Math_fround(f516 - Math_fround(HEAPF32[i238 >> 2]));
     f515 = Math_fround(HEAPF32[i251 >> 2]);
     f515 = Math_fround(f515 - Math_fround(HEAPF32[i239 >> 2]));
     f514 = Math_fround(HEAPF32[i252 >> 2]);
     f514 = Math_fround(f514 - Math_fround(HEAPF32[i240 >> 2]));
     f75 = Math_fround(HEAPF32[i253 >> 2]);
     f75 = Math_fround(f75 - Math_fround(HEAPF32[i241 >> 2]));
     f503 = Math_fround(HEAPF32[i254 >> 2]);
     f503 = Math_fround(f503 - Math_fround(HEAPF32[i242 >> 2]));
     f504 = Math_fround(HEAPF32[i255 >> 2]);
     f504 = Math_fround(f504 - Math_fround(HEAPF32[i243 >> 2]));
     f506 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f505 * f505) + Math_fround(f510 * f510)) + Math_fround(f514 * f514)))));
     f513 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f507 * f507) + Math_fround(f517 * f517)) + Math_fround(f75 * f75)))));
     f512 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f508 * f508) + Math_fround(f516 * f516)) + Math_fround(f503 * f503)))));
     f511 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f509 * f509) + Math_fround(f515 * f515)) + Math_fround(f504 * f504)))));
     f507 = Math_fround(f507 * f513);
     f508 = Math_fround(f508 * f512);
     f509 = Math_fround(f509 * f511);
     f510 = Math_fround(f510 * f506);
     f517 = Math_fround(f517 * f513);
     f516 = Math_fround(f516 * f512);
     f515 = Math_fround(f515 * f511);
     f514 = Math_fround(f514 * f506);
     f513 = Math_fround(f75 * f513);
     f512 = Math_fround(f503 * f512);
     f511 = Math_fround(f504 * f511);
     HEAPF32[i488 >> 2] = Math_fround(f505 * f506);
     HEAPF32[i125 >> 2] = f507;
     HEAPF32[i142 >> 2] = f508;
     HEAPF32[i159 >> 2] = f509;
     HEAPF32[i292 >> 2] = f510;
     HEAPF32[i120 >> 2] = f517;
     HEAPF32[i137 >> 2] = f516;
     HEAPF32[i154 >> 2] = f515;
     HEAPF32[i293 >> 2] = f514;
     HEAPF32[i115 >> 2] = f513;
     HEAPF32[i132 >> 2] = f512;
     HEAPF32[i149 >> 2] = f511;
     f511 = Math_fround(f28 * Math_fround(2.0));
     f512 = Math_fround(f29 * Math_fround(2.0));
     f513 = Math_fround(f30 * Math_fround(2.0));
     f514 = Math_fround(f31 * Math_fround(2.0));
     f515 = Math_fround(f32 * Math_fround(2.0));
     f516 = Math_fround(f33 * Math_fround(2.0));
     f517 = Math_fround(f34 * Math_fround(2.0));
     HEAPF32[i489 >> 2] = Math_fround(f27 * Math_fround(2.0));
     HEAPF32[i127 >> 2] = f511;
     HEAPF32[i144 >> 2] = f512;
     HEAPF32[i161 >> 2] = f513;
     HEAPF32[i294 >> 2] = f514;
     HEAPF32[i126 >> 2] = f515;
     HEAPF32[i143 >> 2] = f516;
     HEAPF32[i160 >> 2] = f517;
     HEAP32[i110 >> 2] = 0;
     HEAP32[i110 + 4 >> 2] = 0;
     HEAP32[i110 + 8 >> 2] = 0;
     HEAP32[i110 + 12 >> 2] = 0;
     if (i295) {
      f54 = Math_fround(HEAPF32[i481 >> 2]);
      f515 = Math_fround(f436 * f54);
      f56 = Math_fround(HEAPF32[i181 >> 2]);
      f506 = Math_fround(f436 * f56);
      f58 = Math_fround(HEAPF32[i180 >> 2]);
      f514 = Math_fround(f436 * f58);
      f503 = Math_fround(HEAPF32[i179 >> 2]);
      f509 = Math_fround(f436 * f503);
      f55 = Math_fround(HEAPF32[i198 >> 2]);
      f505 = Math_fround(f439 * f55);
      f57 = Math_fround(HEAPF32[i184 >> 2]);
      f511 = Math_fround(f439 * f57);
      f75 = Math_fround(HEAPF32[i183 >> 2]);
      f510 = Math_fround(f439 * f75);
      f504 = Math_fround(HEAPF32[i182 >> 2]);
      f505 = Math_fround(f515 + f505);
      f511 = Math_fround(f506 + f511);
      f510 = Math_fround(f514 + f510);
      f509 = Math_fround(f509 + Math_fround(f439 * f504));
      f514 = Math_fround(HEAPF32[i199 >> 2]);
      f506 = Math_fround(f442 * f514);
      f515 = Math_fround(HEAPF32[i187 >> 2]);
      f507 = Math_fround(f442 * f515);
      f516 = Math_fround(HEAPF32[i186 >> 2]);
      f508 = Math_fround(f442 * f516);
      f517 = Math_fround(HEAPF32[i185 >> 2]);
      f507 = Math_fround(f511 + f507);
      f508 = Math_fround(f510 + f508);
      f509 = Math_fround(f509 + Math_fround(f442 * f517));
      f510 = Math_fround(Math_fround(Math_fround(f437 * f54) + Math_fround(f440 * f55)) + Math_fround(f443 * f514));
      f511 = Math_fround(Math_fround(Math_fround(f437 * f56) + Math_fround(f440 * f57)) + Math_fround(f443 * f515));
      f512 = Math_fround(Math_fround(Math_fround(f437 * f58) + Math_fround(f440 * f75)) + Math_fround(f443 * f516));
      f513 = Math_fround(Math_fround(Math_fround(f437 * f503) + Math_fround(f440 * f504)) + Math_fround(f443 * f517));
      f514 = Math_fround(Math_fround(Math_fround(f438 * f54) + Math_fround(f441 * f55)) + Math_fround(f444 * f514));
      f515 = Math_fround(Math_fround(Math_fround(f438 * f56) + Math_fround(f441 * f57)) + Math_fround(f444 * f515));
      f516 = Math_fround(Math_fround(Math_fround(f438 * f58) + Math_fround(f441 * f75)) + Math_fround(f444 * f516));
      f517 = Math_fround(Math_fround(Math_fround(f438 * f503) + Math_fround(f441 * f504)) + Math_fround(f444 * f517));
      HEAPF32[i341 >> 2] = Math_fround(f505 + f506);
      HEAPF32[i296 >> 2] = f507;
      HEAPF32[i297 >> 2] = f508;
      HEAPF32[i298 >> 2] = f509;
      HEAPF32[i299 >> 2] = f510;
      HEAPF32[i300 >> 2] = f511;
      HEAPF32[i301 >> 2] = f512;
      HEAPF32[i302 >> 2] = f513;
      HEAPF32[i303 >> 2] = f514;
      HEAPF32[i304 >> 2] = f515;
      HEAPF32[i305 >> 2] = f516;
      HEAPF32[i306 >> 2] = f517;
     }
     if (i307) {
      i68 = HEAP32[i485 >> 2] | 0;
      i71 = i68 + 1068538453 | 0;
      i72 = HEAP32[i213 >> 2] | 0;
      i70 = i72 + 1068538453 | 0;
      i65 = HEAP32[i214 >> 2] | 0;
      i64 = i65 + 1068538453 | 0;
      i63 = HEAP32[i215 >> 2] | 0;
      i67 = i63 + 1068538453 | 0;
      i73 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i66 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i74 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i71 = i71 << 11 ^ i71;
      i70 = i70 << 11 ^ i70;
      i64 = i64 << 11 ^ i64;
      i67 = i67 << 11 ^ i67;
      f515 = Math_fround(Math_fround((i66 ^ i70 ^ i70 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i74 ^ i64 ^ i64 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i69 ^ i67 ^ i67 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i495 >> 2] = Math_fround(Math_fround((i73 ^ i71 ^ i71 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i308 >> 2] = f515;
      HEAPF32[i309 >> 2] = f516;
      HEAPF32[i310 >> 2] = f517;
      i68 = i68 + 1068538454 | 0;
      i72 = i72 + 1068538454 | 0;
      i65 = i65 + 1068538454 | 0;
      i63 = i63 + 1068538454 | 0;
      i73 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i71 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i72 = i72 << 11 ^ i72;
      i65 = i65 << 11 ^ i65;
      i63 = i63 << 11 ^ i63;
      f517 = Math_fround(Math_fround((i71 ^ i72 ^ i72 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i69 ^ i65 ^ i65 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f515 = Math_fround(Math_fround((i67 ^ i63 ^ i63 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i311 >> 2] = Math_fround(Math_fround((i73 ^ i68 ^ i68 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i312 >> 2] = f517;
      HEAPF32[i313 >> 2] = f516;
      HEAPF32[i314 >> 2] = f515;
      i73 = HEAP32[i485 >> 2] | 0;
      i68 = i73 + 1068538455 | 0;
      i67 = HEAP32[i213 >> 2] | 0;
      i63 = i67 + 1068538455 | 0;
      i69 = HEAP32[i214 >> 2] | 0;
      i65 = i69 + 1068538455 | 0;
      i71 = HEAP32[i215 >> 2] | 0;
      i72 = i71 + 1068538455 | 0;
      i74 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i64 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
      i66 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i63 = i63 << 11 ^ i63;
      i65 = i65 << 11 ^ i65;
      i72 = i72 << 11 ^ i72;
      f515 = Math_fround(Math_fround((i64 ^ i63 ^ i63 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i66 ^ i65 ^ i65 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i70 ^ i72 ^ i72 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i315 >> 2] = Math_fround(Math_fround((i74 ^ i68 ^ i68 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i316 >> 2] = f515;
      HEAPF32[i317 >> 2] = f516;
      HEAPF32[i318 >> 2] = f517;
      f517 = Math_fround(Math_fround(HEAPF32[i484 >> 2]) * Math_fround(1.0e5));
      f516 = Math_fround(Math_fround(HEAPF32[i209 >> 2]) * Math_fround(1.0e5));
      f515 = Math_fround(Math_fround(HEAPF32[i210 >> 2]) * Math_fround(1.0e5));
      i73 = i73 + 1068538453 + ~~f517 | 0;
      i67 = i67 + 1068538453 + ~~f516 | 0;
      i69 = i69 + 1068538453 + ~~f515 | 0;
      i71 = i71 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i211 >> 2]) * Math_fround(1.0e5)) | 0;
      i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i68 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i73 = i73 << 11 ^ i73;
      i67 = i67 << 11 ^ i67;
      i69 = i69 << 11 ^ i69;
      i71 = i71 << 11 ^ i71;
      f515 = Math_fround(Math_fround((i68 ^ i67 ^ i67 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i319 >> 2] = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i320 >> 2] = f515;
      HEAPF32[i321 >> 2] = f516;
      HEAPF32[i322 >> 2] = f517;
     }
     i67 = HEAP32[i188 >> 2] | 0;
     i68 = (i67 | 0) == 0;
     i69 = HEAP32[i86 >> 2] | 0;
     i70 = HEAP32[i88 >> 2] | 0;
     i71 = HEAP32[i208 >> 2] | 0;
     i72 = HEAP32[i89 >> 2] | 0;
     i73 = HEAP32[i191 >> 2] | 0;
     i74 = HEAP32[i498 >> 2] | 0;
     i66 = 0;
     do {
      i2 = i66 + i76 | 0;
      if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
      i5 = i341 + (i66 << 2) | 0;
      i6 = i330 + (i66 << 2) | 0;
      i7 = i337 + (i66 << 2) | 0;
      i8 = i495 + (i66 << 2) | 0;
      i12 = i311 + (i66 << 2) | 0;
      i13 = i315 + (i66 << 2) | 0;
      i14 = i319 + (i66 << 2) | 0;
      i15 = i488 + (i66 << 2) | 0;
      i16 = i83 + (i66 << 2) | 0;
      i17 = i84 + (i66 << 2) | 0;
      i18 = i69 + (i2 << 4) | 0;
      i19 = i70 + (i2 << 4) | 0;
      i20 = i71 + (i2 << 2) | 0;
      i21 = i72 + (i2 << 2) | 0;
      i59 = i73 + (i2 << 2) | 0;
      i60 = i489 + (i66 << 2) | 0;
      i61 = i90 + (i66 << 2) | 0;
      i62 = i91 + (i66 << 2) | 0;
      i63 = i487 + (i66 << 2) | 0;
      i64 = i92 + (i66 << 2) | 0;
      i65 = i93 + (i66 << 2) | 0;
      i4 = i74 + (i2 << 2) | 0;
      i3 = 0;
      i2 = i1;
      while (1) {
       i1 = i493 + (i3 * 48 | 0) | 0;
       HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
       i1 = i2 + 12 | 0;
       if (!i323) {
        i518 = i494 + (i3 * 48 | 0) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i2 + 16 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 20 >> 2] = HEAP32[i518 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 24 | 0;
       }
       if (!i324) {
        HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
        i1 = i1 + 4 | 0;
       }
       if (!i325) {
        i518 = i491 + (HEAP32[i490 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i326) {
        i518 = i492 + (HEAP32[i490 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 32 + (i66 << 2) >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 48 + (i66 << 2) >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i327) {
        f517 = Math_fround(i3 | 0);
        HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
        HEAPF32[i1 + 12 >> 2] = f517;
        i1 = i1 + 16 | 0;
       }
       if (!i328) {
        HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i329) {
        i518 = HEAP32[i59 >> 2] | 0;
        HEAP32[i1 >> 2] = i518;
        HEAP32[i1 + 4 >> 2] = i518;
        HEAP32[i1 + 8 >> 2] = i518;
        i1 = i1 + 12 | 0;
       }
       if (i295) {
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i338) {
        f517 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(.00999999977));
        i518 = HEAP32[i21 >> 2] | 0;
        HEAPF32[i1 >> 2] = f517;
        HEAP32[i1 + 4 >> 2] = i518;
        i1 = i1 + 8 | 0;
       }
       if (!i339) {
        i518 = (HEAP32[i87 >> 2] & 2147483647 | 0) == 0 ? i499 : i19;
        HEAP32[i1 >> 2] = HEAP32[i518 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i340) {
        i518 = (HEAP32[i85 >> 2] & 2147483647 | 0) == 0 ? i499 : i18;
        HEAP32[i1 >> 2] = HEAP32[i518 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (i307) {
        HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i14 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i82) {
        HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i17 >> 2];
        HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
        i1 = i1 + 16 | 0;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == 4) break; else i2 = i1;
      }
      i66 = i66 + 1 | 0;
     } while ((i66 | 0) != 4);
    } while (0);
    i76 = i76 + 4 | 0;
   } while (i76 >>> 0 < i163 >>> 0);
  }
  STACKTOP = i502;
  return;
 } else {
  i14 = i348;
  i13 = i14 + 112 | 0;
  do {
   HEAP32[i14 >> 2] = 0;
   i14 = i14 + 4 | 0;
  } while ((i14 | 0) < (i13 | 0));
  switch (i3 | 0) {
  case 1:
   {
    i14 = i6;
    i1 = gb + 1162292 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  case 2:
   {
    i14 = i6;
    i1 = i7 + 256 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    break;
   }
  default:
   {
    i14 = i6;
    i1 = i7 + 64 | 0;
    i13 = i14 + 64 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     i14 = i14 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
   }
  }
  __ZN10Matrix3x3fC2ERK10Matrix4x4f(i8, i6);
  f516 = Math_fround(HEAPF32[i5 >> 2]);
  f507 = Math_fround(HEAPF32[i7 + 428 >> 2]);
  f9 = Math_fround(HEAPF32[i7 + 424 >> 2]);
  f331 = Math_fround(HEAPF32[i8 >> 2]);
  i337 = i8 + 4 | 0;
  f515 = Math_fround(HEAPF32[i337 >> 2]);
  i338 = i8 + 8 | 0;
  f513 = Math_fround(HEAPF32[i338 >> 2]);
  i339 = i8 + 12 | 0;
  f334 = Math_fround(HEAPF32[i339 >> 2]);
  i340 = i8 + 16 | 0;
  f506 = Math_fround(HEAPF32[i340 >> 2]);
  i341 = i8 + 20 | 0;
  f511 = Math_fround(HEAPF32[i341 >> 2]);
  i518 = i8 + 24 | 0;
  f514 = Math_fround(HEAPF32[i518 >> 2]);
  i163 = i8 + 28 | 0;
  f508 = Math_fround(HEAPF32[i163 >> 2]);
  i162 = i8 + 32 | 0;
  f11 = Math_fround(HEAPF32[i162 >> 2]);
  f333 = Math_fround(f515 * Math_fround(0.0));
  f517 = Math_fround(f513 * Math_fround(0.0));
  f10 = Math_fround(f506 * Math_fround(0.0));
  f512 = Math_fround(f511 * Math_fround(0.0));
  f336 = Math_fround(Math_fround(Math_fround(f516 * f334) + f10) + f512);
  f332 = Math_fround(f508 * Math_fround(0.0));
  f510 = Math_fround(f11 * Math_fround(0.0));
  f335 = Math_fround(Math_fround(Math_fround(f516 * f514) + f332) + f510);
  f509 = Math_fround(f331 * Math_fround(0.0));
  f515 = Math_fround(Math_fround(f509 + Math_fround(f507 * f515)) + f517);
  f334 = Math_fround(f334 * Math_fround(0.0));
  f512 = Math_fround(Math_fround(f334 + Math_fround(f507 * f506)) + f512);
  f514 = Math_fround(f514 * Math_fround(0.0));
  f510 = Math_fround(Math_fround(f514 + Math_fround(f507 * f508)) + f510);
  f513 = Math_fround(Math_fround(f509 + f333) + Math_fround(f9 * f513));
  f511 = Math_fround(Math_fround(f334 + f10) + Math_fround(f9 * f511));
  f11 = Math_fround(Math_fround(f514 + f332) + Math_fround(f9 * f11));
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f516 * f331) + f333) + f517);
  HEAPF32[i337 >> 2] = f515;
  HEAPF32[i338 >> 2] = f513;
  HEAPF32[i339 >> 2] = f336;
  HEAPF32[i340 >> 2] = f512;
  HEAPF32[i341 >> 2] = f511;
  HEAPF32[i518 >> 2] = f335;
  HEAPF32[i163 >> 2] = f510;
  HEAPF32[i162 >> 2] = f11;
  i330 = i497 + 340 | 0;
  f11 = Math_fround(-Math_fround(HEAPF32[HEAP32[i330 >> 2] >> 2]));
  HEAPF32[i500 >> 2] = Math_fround(0.0);
  HEAPF32[i500 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i500 + 8 >> 2] = f11;
  __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f(i500, i499);
  f11 = Math_fround(HEAPF32[i499 >> 2]);
  f510 = Math_fround(HEAPF32[i499 + 4 >> 2]);
  f335 = Math_fround(HEAPF32[i499 + 8 >> 2]);
  f511 = Math_fround(HEAPF32[i499 + 12 >> 2]);
  f512 = Math_fround(HEAPF32[i499 + 16 >> 2]);
  f336 = Math_fround(HEAPF32[i499 + 20 >> 2]);
  f513 = Math_fround(HEAPF32[i499 + 24 >> 2]);
  f515 = Math_fround(HEAPF32[i499 + 28 >> 2]);
  f517 = Math_fround(HEAPF32[i499 + 32 >> 2]);
  f333 = Math_fround(HEAPF32[i8 >> 2]);
  f331 = Math_fround(f11 * f333);
  f516 = Math_fround(HEAPF32[i339 >> 2]);
  f331 = Math_fround(f331 + Math_fround(f510 * f516));
  f9 = Math_fround(HEAPF32[i518 >> 2]);
  f331 = Math_fround(f331 + Math_fround(f335 * f9));
  f332 = Math_fround(Math_fround(Math_fround(f511 * f333) + Math_fround(f512 * f516)) + Math_fround(f336 * f9));
  f9 = Math_fround(Math_fround(Math_fround(f513 * f333) + Math_fround(f515 * f516)) + Math_fround(f517 * f9));
  f516 = Math_fround(HEAPF32[i337 >> 2]);
  f333 = Math_fround(f11 * f516);
  f514 = Math_fround(HEAPF32[i340 >> 2]);
  f333 = Math_fround(f333 + Math_fround(f510 * f514));
  f10 = Math_fround(HEAPF32[i163 >> 2]);
  f333 = Math_fround(f333 + Math_fround(f335 * f10));
  f334 = Math_fround(Math_fround(Math_fround(f511 * f516) + Math_fround(f512 * f514)) + Math_fround(f336 * f10));
  f10 = Math_fround(Math_fround(Math_fround(f513 * f516) + Math_fround(f515 * f514)) + Math_fround(f517 * f10));
  f514 = Math_fround(HEAPF32[i338 >> 2]);
  f11 = Math_fround(f11 * f514);
  f516 = Math_fround(HEAPF32[i341 >> 2]);
  f510 = Math_fround(f11 + Math_fround(f510 * f516));
  f11 = Math_fround(HEAPF32[i162 >> 2]);
  f335 = Math_fround(f510 + Math_fround(f335 * f11));
  f336 = Math_fround(Math_fround(Math_fround(f511 * f514) + Math_fround(f512 * f516)) + Math_fround(f336 * f11));
  f11 = Math_fround(Math_fround(Math_fround(f513 * f514) + Math_fround(f515 * f516)) + Math_fround(f517 * f11));
  HEAPF32[i8 >> 2] = f331;
  HEAPF32[i337 >> 2] = f333;
  HEAPF32[i338 >> 2] = f335;
  HEAPF32[i339 >> 2] = f332;
  HEAPF32[i340 >> 2] = f334;
  HEAPF32[i341 >> 2] = f336;
  HEAPF32[i518 >> 2] = f9;
  HEAPF32[i163 >> 2] = f10;
  HEAPF32[i162 >> 2] = f11;
  i162 = (i2 | 0) == 27;
  HEAP32[i499 >> 2] = 0;
  HEAP32[i499 + 4 >> 2] = 0;
  HEAP32[i499 + 8 >> 2] = 0;
  HEAP32[i499 + 12 >> 2] = 0;
  i163 = HEAP32[i497 + 12 >> 2] | 0;
  if (i163 | 0) {
   i164 = i500 + 12 | 0;
   i165 = i500 + 8 | 0;
   i166 = i500 + 4 | 0;
   i167 = i500 + 16 | 0;
   i168 = i500 + 28 | 0;
   i169 = i500 + 24 | 0;
   i170 = i500 + 20 | 0;
   i171 = i500 + 32 | 0;
   i172 = i500 + 44 | 0;
   i173 = i500 + 40 | 0;
   i174 = i500 + 36 | 0;
   i175 = i501 + 12 | 0;
   i176 = i501 + 8 | 0;
   i177 = i501 + 4 | 0;
   i178 = i501 + 28 | 0;
   i179 = i501 + 24 | 0;
   i180 = i501 + 20 | 0;
   i181 = i501 + 44 | 0;
   i182 = i501 + 40 | 0;
   i183 = i501 + 36 | 0;
   i184 = i498 + 20 | 0;
   i185 = i497 + 20 | 0;
   i186 = i497 + 40 | 0;
   i187 = i497 + 60 | 0;
   i188 = i497 + 80 | 0;
   i189 = i497 + 100 | 0;
   i190 = i497 + 120 | 0;
   i191 = i497 + 140 | 0;
   i192 = i497 + 160 | 0;
   i193 = i501 + 16 | 0;
   i194 = i501 + 32 | 0;
   i195 = i498 + 4 | 0;
   i196 = i481 + 4 | 0;
   i197 = i481 + 8 | 0;
   i198 = i481 + 12 | 0;
   i199 = i498 + 8 | 0;
   i200 = i482 + 4 | 0;
   i201 = i482 + 8 | 0;
   i202 = i482 + 12 | 0;
   i203 = i497 + 520 | 0;
   i204 = i483 + 4 | 0;
   i205 = i483 + 8 | 0;
   i206 = i483 + 12 | 0;
   i207 = i497 + 500 | 0;
   i208 = i484 + 4 | 0;
   i209 = i484 + 8 | 0;
   i210 = i484 + 12 | 0;
   i211 = i498 + 16 | 0;
   i212 = i485 + 4 | 0;
   i213 = i485 + 8 | 0;
   i214 = i485 + 12 | 0;
   i215 = i500 + 16 | 0;
   i216 = i500 + 32 | 0;
   i217 = i486 + 4 | 0;
   i218 = i486 + 8 | 0;
   i219 = i486 + 12 | 0;
   i220 = i486 + 16 | 0;
   i221 = i486 + 20 | 0;
   i222 = i486 + 24 | 0;
   i223 = i486 + 28 | 0;
   i224 = i486 + 32 | 0;
   i225 = i486 + 36 | 0;
   i226 = i486 + 40 | 0;
   i227 = i486 + 44 | 0;
   i228 = i493 + 4 | 0;
   i229 = i493 + 8 | 0;
   i230 = i493 + 12 | 0;
   i231 = i493 + 16 | 0;
   i232 = i493 + 20 | 0;
   i233 = i493 + 24 | 0;
   i234 = i493 + 28 | 0;
   i235 = i493 + 32 | 0;
   i236 = i493 + 36 | 0;
   i237 = i493 + 40 | 0;
   i238 = i493 + 44 | 0;
   i239 = i493 + 48 | 0;
   i240 = i493 + 52 | 0;
   i241 = i493 + 56 | 0;
   i242 = i493 + 60 | 0;
   i243 = i493 + 64 | 0;
   i244 = i493 + 68 | 0;
   i245 = i493 + 72 | 0;
   i246 = i493 + 76 | 0;
   i247 = i493 + 80 | 0;
   i248 = i493 + 84 | 0;
   i249 = i493 + 88 | 0;
   i250 = i493 + 92 | 0;
   i251 = i493 + 96 | 0;
   i252 = i493 + 100 | 0;
   i253 = i493 + 104 | 0;
   i254 = i493 + 108 | 0;
   i255 = i493 + 112 | 0;
   i256 = i493 + 116 | 0;
   i257 = i493 + 120 | 0;
   i258 = i493 + 124 | 0;
   i259 = i493 + 128 | 0;
   i260 = i493 + 132 | 0;
   i261 = i493 + 136 | 0;
   i262 = i493 + 140 | 0;
   i263 = i493 + 144 | 0;
   i264 = i493 + 148 | 0;
   i265 = i493 + 152 | 0;
   i266 = i493 + 156 | 0;
   i267 = i493 + 160 | 0;
   i268 = i493 + 164 | 0;
   i269 = i493 + 168 | 0;
   i270 = i493 + 172 | 0;
   i271 = i493 + 176 | 0;
   i272 = i493 + 180 | 0;
   i273 = i493 + 184 | 0;
   i274 = i493 + 188 | 0;
   i275 = (i2 & 48 | 0) == 0;
   i124 = i494 + 4 | 0;
   i141 = i494 + 8 | 0;
   i158 = i494 + 12 | 0;
   i276 = i494 + 16 | 0;
   i119 = i494 + 20 | 0;
   i136 = i494 + 24 | 0;
   i153 = i494 + 28 | 0;
   i277 = i494 + 32 | 0;
   i114 = i494 + 36 | 0;
   i131 = i494 + 40 | 0;
   i148 = i494 + 44 | 0;
   i278 = i494 + 48 | 0;
   i123 = i494 + 52 | 0;
   i140 = i494 + 56 | 0;
   i157 = i494 + 60 | 0;
   i279 = i494 + 64 | 0;
   i118 = i494 + 68 | 0;
   i135 = i494 + 72 | 0;
   i152 = i494 + 76 | 0;
   i280 = i494 + 80 | 0;
   i113 = i494 + 84 | 0;
   i130 = i494 + 88 | 0;
   i147 = i494 + 92 | 0;
   i281 = i494 + 96 | 0;
   i122 = i494 + 100 | 0;
   i139 = i494 + 104 | 0;
   i156 = i494 + 108 | 0;
   i282 = i494 + 112 | 0;
   i117 = i494 + 116 | 0;
   i134 = i494 + 120 | 0;
   i151 = i494 + 124 | 0;
   i283 = i494 + 128 | 0;
   i112 = i494 + 132 | 0;
   i129 = i494 + 136 | 0;
   i146 = i494 + 140 | 0;
   i284 = i494 + 144 | 0;
   i121 = i494 + 148 | 0;
   i138 = i494 + 152 | 0;
   i155 = i494 + 156 | 0;
   i285 = i494 + 160 | 0;
   i116 = i494 + 164 | 0;
   i133 = i494 + 168 | 0;
   i150 = i494 + 172 | 0;
   i286 = i494 + 176 | 0;
   i111 = i494 + 180 | 0;
   i128 = i494 + 184 | 0;
   i145 = i494 + 188 | 0;
   i125 = i487 + 4 | 0;
   i142 = i487 + 8 | 0;
   i159 = i487 + 12 | 0;
   i287 = i487 + 16 | 0;
   i120 = i487 + 20 | 0;
   i137 = i487 + 24 | 0;
   i154 = i487 + 28 | 0;
   i288 = i487 + 32 | 0;
   i115 = i487 + 36 | 0;
   i132 = i487 + 40 | 0;
   i149 = i487 + 44 | 0;
   i127 = i488 + 4 | 0;
   i144 = i488 + 8 | 0;
   i161 = i488 + 12 | 0;
   i289 = i488 + 16 | 0;
   i126 = i488 + 20 | 0;
   i143 = i488 + 24 | 0;
   i160 = i488 + 28 | 0;
   i110 = i488 + 32 | 0;
   i290 = (i2 & 512 | 0) != 0;
   i291 = i489 + 4 | 0;
   i292 = i489 + 8 | 0;
   i293 = i489 + 12 | 0;
   i294 = i489 + 16 | 0;
   i295 = i489 + 20 | 0;
   i296 = i489 + 24 | 0;
   i297 = i489 + 28 | 0;
   i298 = i489 + 32 | 0;
   i299 = i489 + 36 | 0;
   i300 = i489 + 40 | 0;
   i301 = i489 + 44 | 0;
   i302 = (i2 & 8192 | 0) != 0;
   i303 = i495 + 4 | 0;
   i304 = i495 + 8 | 0;
   i305 = i495 + 12 | 0;
   i306 = i495 + 16 | 0;
   i307 = i495 + 20 | 0;
   i308 = i495 + 24 | 0;
   i309 = i495 + 28 | 0;
   i310 = i495 + 32 | 0;
   i311 = i495 + 36 | 0;
   i312 = i495 + 40 | 0;
   i313 = i495 + 44 | 0;
   i314 = i495 + 48 | 0;
   i315 = i495 + 52 | 0;
   i316 = i495 + 56 | 0;
   i317 = i495 + 60 | 0;
   i318 = (i2 & 2 | 0) == 0;
   i319 = (i2 & 8 | 0) == 0;
   i320 = (i2 & 16 | 0) == 0;
   i321 = (i2 & 32 | 0) == 0;
   i322 = (i2 & 64 | 0) == 0;
   i323 = (i2 & 128 | 0) == 0;
   i324 = (i2 & 256 | 0) == 0;
   i325 = i489 + 16 | 0;
   i326 = i489 + 32 | 0;
   i327 = (i2 & 1024 | 0) == 0;
   i328 = (i2 & 2048 | 0) == 0;
   i329 = (i2 & 4096 | 0) == 0;
   i82 = (i2 & 4 | 0) == 0;
   i83 = i487 + 16 | 0;
   i84 = i487 + 32 | 0;
   i85 = i497 + 864 | 0;
   i86 = i497 + 848 | 0;
   i87 = i497 + 844 | 0;
   i88 = i497 + 828 | 0;
   i89 = i497 + 540 | 0;
   i90 = i488 + 16 | 0;
   i91 = i488 + 32 | 0;
   i92 = i486 + 16 | 0;
   i93 = i486 + 32 | 0;
   i94 = i493 + 16 | 0;
   i95 = i493 + 32 | 0;
   i96 = i494 + 16 | 0;
   i97 = i494 + 32 | 0;
   i98 = i239 + 16 | 0;
   i99 = i239 + 32 | 0;
   i100 = i278 + 16 | 0;
   i101 = i278 + 32 | 0;
   i102 = i251 + 16 | 0;
   i103 = i251 + 32 | 0;
   i104 = i281 + 16 | 0;
   i105 = i281 + 32 | 0;
   i106 = i263 + 16 | 0;
   i107 = i263 + 32 | 0;
   i108 = i284 + 16 | 0;
   i109 = i284 + 32 | 0;
   f81 = Math_fround(f9 * Math_fround(0.0));
   f80 = Math_fround(f10 * Math_fround(0.0));
   f78 = Math_fround(f11 * Math_fround(0.0));
   i79 = i12 + 564 | 0;
   i77 = i12 + 568 | 0;
   i76 = 0;
   i1 = i15;
   do {
    i14 = i500;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    i14 = i501;
    i13 = i14 + 48 | 0;
    do {
     HEAP32[i14 >> 2] = 0;
     i14 = i14 + 4 | 0;
    } while ((i14 | 0) < (i13 | 0));
    HEAP32[i481 >> 2] = 0;
    HEAP32[i481 + 4 >> 2] = 0;
    HEAP32[i481 + 8 >> 2] = 0;
    HEAP32[i481 + 12 >> 2] = 0;
    HEAP32[i482 >> 2] = 0;
    HEAP32[i482 + 4 >> 2] = 0;
    HEAP32[i482 + 8 >> 2] = 0;
    HEAP32[i482 + 12 >> 2] = 0;
    HEAP32[i483 >> 2] = 0;
    HEAP32[i483 + 4 >> 2] = 0;
    HEAP32[i483 + 8 >> 2] = 0;
    HEAP32[i483 + 12 >> 2] = 0;
    HEAP32[i484 >> 2] = 0;
    HEAP32[i484 + 4 >> 2] = 0;
    HEAP32[i484 + 8 >> 2] = 0;
    HEAP32[i484 + 12 >> 2] = 0;
    HEAP32[i485 >> 2] = 0;
    HEAP32[i485 + 4 >> 2] = 0;
    HEAP32[i485 + 8 >> 2] = 0;
    HEAP32[i485 + 12 >> 2] = 0;
    i19 = HEAP32[i184 >> 2] | 0;
    i20 = HEAP32[i497 >> 2] | 0;
    if (!i19) {
     i69 = i20 + (i76 << 2) | 0;
     i70 = HEAP32[i69 + 4 >> 2] | 0;
     i71 = HEAP32[i69 + 8 >> 2] | 0;
     i72 = HEAP32[i69 + 12 >> 2] | 0;
     i338 = (HEAP32[i185 >> 2] | 0) + (i76 << 2) | 0;
     i73 = HEAP32[i338 >> 2] | 0;
     i74 = HEAP32[i338 + 4 >> 2] | 0;
     i337 = HEAP32[i338 + 8 >> 2] | 0;
     i338 = HEAP32[i338 + 12 >> 2] | 0;
     i518 = (HEAP32[i186 >> 2] | 0) + (i76 << 2) | 0;
     i339 = HEAP32[i518 >> 2] | 0;
     i340 = HEAP32[i518 + 4 >> 2] | 0;
     i341 = HEAP32[i518 + 8 >> 2] | 0;
     i518 = HEAP32[i518 + 12 >> 2] | 0;
     HEAP32[i500 >> 2] = HEAP32[i69 >> 2];
     HEAP32[i166 >> 2] = i70;
     HEAP32[i165 >> 2] = i71;
     HEAP32[i164 >> 2] = i72;
     HEAP32[i167 >> 2] = i73;
     HEAP32[i170 >> 2] = i74;
     HEAP32[i169 >> 2] = i337;
     HEAP32[i168 >> 2] = i338;
     HEAP32[i171 >> 2] = i339;
     HEAP32[i174 >> 2] = i340;
     HEAP32[i173 >> 2] = i341;
     HEAP32[i172 >> 2] = i518;
     i518 = (HEAP32[i187 >> 2] | 0) + (i76 << 2) | 0;
     f505 = Math_fround(HEAPF32[i518 >> 2]);
     f52 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f53 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f54 = Math_fround(HEAPF32[i518 + 12 >> 2]);
     i518 = (HEAP32[i188 >> 2] | 0) + (i76 << 2) | 0;
     f55 = Math_fround(HEAPF32[i518 >> 2]);
     f56 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f57 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f58 = Math_fround(HEAPF32[i518 + 12 >> 2]);
     i518 = (HEAP32[i189 >> 2] | 0) + (i76 << 2) | 0;
     f75 = Math_fround(HEAPF32[i518 >> 2]);
     f503 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f504 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f517 = Math_fround(HEAPF32[i518 + 12 >> 2]);
     i518 = (HEAP32[i190 >> 2] | 0) + (i76 << 2) | 0;
     f506 = Math_fround(HEAPF32[i518 >> 2]);
     f507 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f508 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f509 = Math_fround(HEAPF32[i518 + 12 >> 2]);
     i518 = (HEAP32[i191 >> 2] | 0) + (i76 << 2) | 0;
     f510 = Math_fround(HEAPF32[i518 >> 2]);
     f511 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f512 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f513 = Math_fround(HEAPF32[i518 + 12 >> 2]);
     i518 = (HEAP32[i192 >> 2] | 0) + (i76 << 2) | 0;
     f514 = Math_fround(HEAPF32[i518 >> 2]);
     f515 = Math_fround(HEAPF32[i518 + 4 >> 2]);
     f516 = Math_fround(HEAPF32[i518 + 8 >> 2]);
     f507 = Math_fround(f52 + f507);
     f508 = Math_fround(f53 + f508);
     f509 = Math_fround(f54 + f509);
     f510 = Math_fround(f55 + f510);
     f511 = Math_fround(f56 + f511);
     f512 = Math_fround(f57 + f512);
     f513 = Math_fround(f58 + f513);
     f514 = Math_fround(f75 + f514);
     f515 = Math_fround(f503 + f515);
     f516 = Math_fround(f504 + f516);
     f517 = Math_fround(f517 + Math_fround(HEAPF32[i518 + 12 >> 2]));
     HEAPF32[i501 >> 2] = Math_fround(f505 + f506);
     HEAPF32[i177 >> 2] = f507;
     HEAPF32[i176 >> 2] = f508;
     HEAPF32[i175 >> 2] = f509;
     HEAPF32[i193 >> 2] = f510;
     HEAPF32[i180 >> 2] = f511;
     HEAPF32[i179 >> 2] = f512;
     HEAPF32[i178 >> 2] = f513;
     HEAPF32[i194 >> 2] = f514;
     HEAPF32[i183 >> 2] = f515;
     HEAPF32[i182 >> 2] = f516;
     HEAPF32[i181 >> 2] = f517;
     i518 = (HEAP32[i195 >> 2] | 0) + (i76 << 2) | 0;
     i341 = HEAP32[i518 + 4 >> 2] | 0;
     i340 = HEAP32[i518 + 8 >> 2] | 0;
     i339 = HEAP32[i518 + 12 >> 2] | 0;
     HEAP32[i481 >> 2] = HEAP32[i518 >> 2];
     HEAP32[i196 >> 2] = i341;
     HEAP32[i197 >> 2] = i340;
     HEAP32[i198 >> 2] = i339;
     i339 = (HEAP32[i199 >> 2] | 0) + (i76 << 2) | 0;
     i340 = HEAP32[i339 + 4 >> 2] | 0;
     i341 = HEAP32[i339 + 8 >> 2] | 0;
     i518 = HEAP32[i339 + 12 >> 2] | 0;
     HEAP32[i482 >> 2] = HEAP32[i339 >> 2];
     HEAP32[i200 >> 2] = i340;
     HEAP32[i201 >> 2] = i341;
     HEAP32[i202 >> 2] = i518;
     i518 = (HEAP32[i203 >> 2] | 0) + (i76 << 2) | 0;
     i341 = HEAP32[i518 + 4 >> 2] | 0;
     i340 = HEAP32[i518 + 8 >> 2] | 0;
     i339 = HEAP32[i518 + 12 >> 2] | 0;
     HEAP32[i483 >> 2] = HEAP32[i518 >> 2];
     HEAP32[i204 >> 2] = i341;
     HEAP32[i205 >> 2] = i340;
     HEAP32[i206 >> 2] = i339;
     i339 = (HEAP32[i207 >> 2] | 0) + (i76 << 2) | 0;
     i340 = HEAP32[i339 + 4 >> 2] | 0;
     i341 = HEAP32[i339 + 8 >> 2] | 0;
     i518 = HEAP32[i339 + 12 >> 2] | 0;
     HEAP32[i484 >> 2] = HEAP32[i339 >> 2];
     HEAP32[i208 >> 2] = i340;
     HEAP32[i209 >> 2] = i341;
     HEAP32[i210 >> 2] = i518;
     if (HEAP32[i496 >> 2] & 268435456 | 0) {
      i339 = (HEAP32[i211 >> 2] | 0) + (i76 << 2) | 0;
      i340 = HEAP32[i339 + 4 >> 2] | 0;
      i341 = HEAP32[i339 + 8 >> 2] | 0;
      i518 = HEAP32[i339 + 12 >> 2] | 0;
      HEAP32[i485 >> 2] = HEAP32[i339 >> 2];
      HEAP32[i212 >> 2] = i340;
      HEAP32[i213 >> 2] = i341;
      HEAP32[i214 >> 2] = i518;
     }
    } else {
     i4 = HEAP32[i187 >> 2] | 0;
     i5 = HEAP32[i190 >> 2] | 0;
     i6 = HEAP32[i185 >> 2] | 0;
     i7 = HEAP32[i188 >> 2] | 0;
     i8 = HEAP32[i191 >> 2] | 0;
     i12 = HEAP32[i186 >> 2] | 0;
     i13 = HEAP32[i189 >> 2] | 0;
     i14 = HEAP32[i192 >> 2] | 0;
     i15 = HEAP32[i195 >> 2] | 0;
     i16 = HEAP32[i199 >> 2] | 0;
     i17 = HEAP32[i203 >> 2] | 0;
     i18 = HEAP32[i207 >> 2] | 0;
     i3 = HEAP32[i211 >> 2] | 0;
     if (!(HEAP32[i496 >> 2] & 268435456)) {
      i2 = 0;
      do {
       i518 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i500 + (i2 << 2) >> 2] = HEAP32[i20 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i4 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i2 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i5 + (i518 << 2) >> 2]));
       i341 = i2 + 4 | 0;
       HEAP32[i500 + (i341 << 2) >> 2] = HEAP32[i6 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i7 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i341 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i8 + (i518 << 2) >> 2]));
       i341 = i2 + 8 | 0;
       HEAP32[i500 + (i341 << 2) >> 2] = HEAP32[i12 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i13 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i341 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i14 + (i518 << 2) >> 2]));
       HEAP32[i481 + (i2 << 2) >> 2] = HEAP32[i15 + (i518 << 2) >> 2];
       HEAP32[i482 + (i2 << 2) >> 2] = HEAP32[i16 + (i518 << 2) >> 2];
       HEAP32[i483 + (i2 << 2) >> 2] = HEAP32[i17 + (i518 << 2) >> 2];
       HEAP32[i484 + (i2 << 2) >> 2] = HEAP32[i18 + (i518 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     } else {
      i2 = 0;
      do {
       i518 = HEAP32[i19 + (i2 + i76 << 3) >> 2] | 0;
       HEAP32[i500 + (i2 << 2) >> 2] = HEAP32[i20 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i4 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i2 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i5 + (i518 << 2) >> 2]));
       i341 = i2 + 4 | 0;
       HEAP32[i500 + (i341 << 2) >> 2] = HEAP32[i6 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i7 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i341 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i8 + (i518 << 2) >> 2]));
       i341 = i2 + 8 | 0;
       HEAP32[i500 + (i341 << 2) >> 2] = HEAP32[i12 + (i518 << 2) >> 2];
       f517 = Math_fround(HEAPF32[i13 + (i518 << 2) >> 2]);
       HEAPF32[i501 + (i341 << 2) >> 2] = Math_fround(f517 + Math_fround(HEAPF32[i14 + (i518 << 2) >> 2]));
       HEAP32[i481 + (i2 << 2) >> 2] = HEAP32[i15 + (i518 << 2) >> 2];
       HEAP32[i482 + (i2 << 2) >> 2] = HEAP32[i16 + (i518 << 2) >> 2];
       HEAP32[i483 + (i2 << 2) >> 2] = HEAP32[i17 + (i518 << 2) >> 2];
       HEAP32[i484 + (i2 << 2) >> 2] = HEAP32[i18 + (i518 << 2) >> 2];
       HEAP32[i485 + (i2 << 2) >> 2] = HEAP32[i3 + (i518 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     }
    }
    f33 = Math_fround(HEAPF32[i500 >> 2]);
    f11 = Math_fround(f436 * f33);
    f31 = Math_fround(HEAPF32[i166 >> 2]);
    f29 = Math_fround(f436 * f31);
    f517 = Math_fround(HEAPF32[i165 >> 2]);
    f10 = Math_fround(f436 * f517);
    f515 = Math_fround(HEAPF32[i164 >> 2]);
    f75 = Math_fround(f436 * f515);
    f32 = Math_fround(HEAPF32[i215 >> 2]);
    f30 = Math_fround(f439 * f32);
    f26 = Math_fround(HEAPF32[i170 >> 2]);
    f35 = Math_fround(f439 * f26);
    f516 = Math_fround(HEAPF32[i169 >> 2]);
    f24 = Math_fround(f439 * f516);
    f514 = Math_fround(HEAPF32[i168 >> 2]);
    f30 = Math_fround(f11 + f30);
    f35 = Math_fround(f29 + f35);
    f24 = Math_fround(f10 + f24);
    f75 = Math_fround(f75 + Math_fround(f439 * f514));
    f10 = Math_fround(HEAPF32[i216 >> 2]);
    f29 = Math_fround(f442 * f10);
    f11 = Math_fround(HEAPF32[i174 >> 2]);
    f28 = Math_fround(f442 * f11);
    f22 = Math_fround(HEAPF32[i173 >> 2]);
    f27 = Math_fround(f442 * f22);
    f34 = Math_fround(HEAPF32[i172 >> 2]);
    f28 = Math_fround(f445 + Math_fround(f35 + f28));
    f27 = Math_fround(f445 + Math_fround(f24 + f27));
    f75 = Math_fround(f445 + Math_fround(f75 + Math_fround(f442 * f34)));
    HEAPF32[i486 >> 2] = Math_fround(f445 + Math_fround(f30 + f29));
    HEAPF32[i217 >> 2] = f28;
    HEAPF32[i218 >> 2] = f27;
    HEAPF32[i219 >> 2] = f75;
    f75 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f31) + Math_fround(f440 * f26)) + Math_fround(f443 * f11)));
    f27 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f517) + Math_fround(f440 * f516)) + Math_fround(f443 * f22)));
    f28 = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f515) + Math_fround(f440 * f514)) + Math_fround(f443 * f34)));
    HEAPF32[i220 >> 2] = Math_fround(f446 + Math_fround(Math_fround(Math_fround(f437 * f33) + Math_fround(f440 * f32)) + Math_fround(f443 * f10)));
    HEAPF32[i221 >> 2] = f75;
    HEAPF32[i222 >> 2] = f27;
    HEAPF32[i223 >> 2] = f28;
    f28 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f31) + Math_fround(f441 * f26)) + Math_fround(f444 * f11)));
    f27 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f517) + Math_fround(f441 * f516)) + Math_fround(f444 * f22)));
    f75 = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f515) + Math_fround(f441 * f514)) + Math_fround(f444 * f34)));
    HEAPF32[i224 >> 2] = Math_fround(f447 + Math_fround(Math_fround(Math_fround(f438 * f33) + Math_fround(f441 * f32)) + Math_fround(f444 * f10)));
    HEAPF32[i225 >> 2] = f28;
    HEAPF32[i226 >> 2] = f27;
    HEAPF32[i227 >> 2] = f75;
    f10 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f33) + Math_fround(f478 * f32)) + Math_fround(f479 * f10)));
    f11 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f31) + Math_fround(f478 * f26)) + Math_fround(f479 * f11)));
    f22 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f517) + Math_fround(f478 * f516)) + Math_fround(f479 * f22)));
    f34 = Math_fround(f480 + Math_fround(Math_fround(Math_fround(f477 * f515) + Math_fround(f478 * f514)) + Math_fround(f479 * f34)));
    f514 = Math_fround(f467 + Math_fround(f468 * f10));
    f515 = Math_fround(f467 + Math_fround(f468 * f11));
    f516 = Math_fround(f467 + Math_fround(f468 * f22));
    f517 = Math_fround(f467 + Math_fround(f468 * f34));
    f10 = Math_fround(f463 + Math_fround(f464 * f10));
    f11 = Math_fround(f463 + Math_fround(f464 * f11));
    f22 = Math_fround(f463 + Math_fround(f464 * f22));
    f34 = Math_fround(f463 + Math_fround(f464 * f34));
    f26 = Math_fround(HEAPF32[i481 >> 2]);
    f31 = Math_fround(HEAPF32[i196 >> 2]);
    f32 = Math_fround(HEAPF32[i197 >> 2]);
    f33 = Math_fround(HEAPF32[i198 >> 2]);
    f27 = Math_fround(HEAPF32[i482 >> 2]);
    f28 = Math_fround(HEAPF32[i200 >> 2]);
    f29 = Math_fround(HEAPF32[i201 >> 2]);
    f30 = Math_fround(HEAPF32[i202 >> 2]);
    f24 = f26 > f27 ? f26 : f27;
    f35 = f31 > f28 ? f31 : f28;
    f25 = f32 > f29 ? f32 : f29;
    f36 = f33 > f30 ? f33 : f30;
    f511 = Math_fround((f24 > f514 ? f24 : f514) * Math_fround(.5));
    f512 = Math_fround((f35 > f515 ? f35 : f515) * Math_fround(.5));
    f513 = Math_fround((f25 > f516 ? f25 : f516) * Math_fround(.5));
    f9 = Math_fround((f36 > f517 ? f36 : f517) * Math_fround(.5));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f511, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f512, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f513, HEAP32[tempDoublePtr >> 2] | 0);
    i339 = f514 >= Math_fround(0.0);
    i340 = f515 >= Math_fround(0.0);
    i341 = f516 >= Math_fround(0.0);
    i518 = f517 >= Math_fround(0.0);
    i12 = i339 ? i12 : 0;
    i13 = i340 ? i13 : 0;
    i14 = i341 ? i14 : 0;
    i5 = i518 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    f513 = Math_fround(f10 * Math_fround(.5));
    f515 = Math_fround(f11 * Math_fround(.5));
    f517 = Math_fround(f22 * Math_fround(.5));
    f9 = Math_fround(f34 * Math_fround(.5));
    f512 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f514 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f516 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f512 < f513 ? f512 : f513, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f514 < f515 ? f514 : f515, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f516 < f517 ? f516 : f517, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = f10 >= Math_fround(0.0);
    i3 = f11 >= Math_fround(0.0);
    i2 = f22 >= Math_fround(0.0);
    i518 = f34 >= Math_fround(0.0);
    i339 = i518 ? (HEAPF32[tempDoublePtr >> 2] = f23 < f9 ? f23 : f9, HEAP32[tempDoublePtr >> 2] | 0) : i5;
    f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f24);
    f48 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f35);
    f47 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f25);
    f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i339, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f36);
    f43 = Math_fround(f26 * f49);
    f44 = Math_fround(f31 * f48);
    f45 = Math_fround(f32 * f47);
    f46 = Math_fround(f33 * f34);
    f31 = Math_fround(f27 * f49);
    f32 = Math_fround(f28 * f48);
    f33 = Math_fround(f29 * f47);
    f34 = Math_fround(f30 * f34);
    i339 = Math_fround(HEAPF32[i483 >> 2]) < Math_fround(100.0);
    i340 = Math_fround(HEAPF32[i204 >> 2]) < Math_fround(100.0);
    i341 = Math_fround(HEAPF32[i205 >> 2]) < Math_fround(100.0);
    i518 = Math_fround(HEAPF32[i206 >> 2]) < Math_fround(100.0);
    f27 = i339 ? f43 : Math_fround(0.0);
    f43 = Math_fround(-f27);
    f28 = i340 ? f44 : Math_fround(0.0);
    f44 = Math_fround(-f28);
    f29 = i341 ? f45 : Math_fround(0.0);
    f45 = Math_fround(-f29);
    f30 = i518 ? f46 : Math_fround(0.0);
    f46 = Math_fround(-f30);
    f31 = i339 ? f31 : Math_fround(0.0);
    f32 = i340 ? f32 : Math_fround(0.0);
    f33 = i341 ? f33 : Math_fround(0.0);
    f34 = i518 ? f34 : Math_fround(0.0);
    f47 = Math_fround(f332 * f31);
    f48 = Math_fround(f332 * f32);
    f49 = Math_fround(f332 * f33);
    f50 = Math_fround(f332 * f34);
    f35 = Math_fround(f81 + Math_fround(Math_fround(f331 * f43) + f47));
    f36 = Math_fround(f81 + Math_fround(Math_fround(f331 * f44) + f48));
    f37 = Math_fround(f81 + Math_fround(Math_fround(f331 * f45) + f49));
    f38 = Math_fround(f81 + Math_fround(Math_fround(f331 * f46) + f50));
    f51 = Math_fround(f334 * f31);
    f52 = Math_fround(f334 * f32);
    f53 = Math_fround(f334 * f33);
    f54 = Math_fround(f334 * f34);
    f39 = Math_fround(f80 + Math_fround(Math_fround(f333 * f43) + f51));
    f40 = Math_fround(f80 + Math_fround(Math_fround(f333 * f44) + f52));
    f41 = Math_fround(f80 + Math_fround(Math_fround(f333 * f45) + f53));
    f42 = Math_fround(f80 + Math_fround(Math_fround(f333 * f46) + f54));
    f55 = Math_fround(f336 * f31);
    f56 = Math_fround(f336 * f32);
    f57 = Math_fround(f336 * f33);
    f58 = Math_fround(f336 * f34);
    f43 = Math_fround(f78 + Math_fround(Math_fround(f335 * f43) + f55));
    f44 = Math_fround(f78 + Math_fround(Math_fround(f335 * f44) + f56));
    f45 = Math_fround(f78 + Math_fround(Math_fround(f335 * f45) + f57));
    f46 = Math_fround(f78 + Math_fround(Math_fround(f335 * f46) + f58));
    f47 = Math_fround(f81 + Math_fround(Math_fround(f331 * f27) + f47));
    f48 = Math_fround(f81 + Math_fround(Math_fround(f331 * f28) + f48));
    f49 = Math_fround(f81 + Math_fround(Math_fround(f331 * f29) + f49));
    f50 = Math_fround(f81 + Math_fround(Math_fround(f331 * f30) + f50));
    f51 = Math_fround(f80 + Math_fround(Math_fround(f333 * f27) + f51));
    f52 = Math_fround(f80 + Math_fround(Math_fround(f333 * f28) + f52));
    f53 = Math_fround(f80 + Math_fround(Math_fround(f333 * f29) + f53));
    f54 = Math_fround(f80 + Math_fround(Math_fround(f333 * f30) + f54));
    f55 = Math_fround(f78 + Math_fround(Math_fround(f335 * f27) + f55));
    f56 = Math_fround(f78 + Math_fround(Math_fround(f335 * f28) + f56));
    f57 = Math_fround(f78 + Math_fround(Math_fround(f335 * f29) + f57));
    f58 = Math_fround(f78 + Math_fround(Math_fround(f335 * f30) + f58));
    f506 = Math_fround(HEAPF32[i486 >> 2]);
    f9 = Math_fround(f506 + f35);
    f507 = Math_fround(HEAPF32[i217 >> 2]);
    f10 = Math_fround(f507 + f36);
    f508 = Math_fround(HEAPF32[i218 >> 2]);
    f11 = Math_fround(f508 + f37);
    f509 = Math_fround(HEAPF32[i219 >> 2]);
    f22 = Math_fround(f509 + f38);
    f510 = Math_fround(HEAPF32[i220 >> 2]);
    f23 = Math_fround(f510 + f39);
    f511 = Math_fround(HEAPF32[i221 >> 2]);
    f24 = Math_fround(f511 + f40);
    f512 = Math_fround(HEAPF32[i222 >> 2]);
    f25 = Math_fround(f512 + f41);
    f513 = Math_fround(HEAPF32[i223 >> 2]);
    f26 = Math_fround(f513 + f42);
    f514 = Math_fround(HEAPF32[i224 >> 2]);
    f503 = Math_fround(f514 + f43);
    f515 = Math_fround(HEAPF32[i225 >> 2]);
    f504 = Math_fround(f515 + f44);
    f516 = Math_fround(HEAPF32[i226 >> 2]);
    f505 = Math_fround(f516 + f45);
    f517 = Math_fround(f75 + f46);
    HEAPF32[i493 >> 2] = f9;
    HEAPF32[i228 >> 2] = f10;
    HEAPF32[i229 >> 2] = f11;
    HEAPF32[i230 >> 2] = f22;
    HEAPF32[i231 >> 2] = f23;
    HEAPF32[i232 >> 2] = f24;
    HEAPF32[i233 >> 2] = f25;
    HEAPF32[i234 >> 2] = f26;
    HEAPF32[i235 >> 2] = f503;
    HEAPF32[i236 >> 2] = f504;
    HEAPF32[i237 >> 2] = f505;
    HEAPF32[i238 >> 2] = f517;
    f517 = Math_fround(f507 + f48);
    f505 = Math_fround(f508 + f49);
    f504 = Math_fround(f509 + f50);
    f503 = Math_fround(f510 + f51);
    f26 = Math_fround(f511 + f52);
    f25 = Math_fround(f512 + f53);
    f24 = Math_fround(f513 + f54);
    f23 = Math_fround(f514 + f55);
    f22 = Math_fround(f515 + f56);
    f11 = Math_fround(f516 + f57);
    f10 = Math_fround(f75 + f58);
    HEAPF32[i239 >> 2] = Math_fround(f506 + f47);
    HEAPF32[i240 >> 2] = f517;
    HEAPF32[i241 >> 2] = f505;
    HEAPF32[i242 >> 2] = f504;
    HEAPF32[i243 >> 2] = f503;
    HEAPF32[i244 >> 2] = f26;
    HEAPF32[i245 >> 2] = f25;
    HEAPF32[i246 >> 2] = f24;
    HEAPF32[i247 >> 2] = f23;
    HEAPF32[i248 >> 2] = f22;
    HEAPF32[i249 >> 2] = f11;
    HEAPF32[i250 >> 2] = f10;
    f10 = Math_fround(f507 - f36);
    f11 = Math_fround(f508 - f37);
    f22 = Math_fround(f509 - f38);
    f23 = Math_fround(f510 - f39);
    f24 = Math_fround(f511 - f40);
    f25 = Math_fround(f512 - f41);
    f26 = Math_fround(f513 - f42);
    f503 = Math_fround(f514 - f43);
    f504 = Math_fround(f515 - f44);
    f505 = Math_fround(f516 - f45);
    f517 = Math_fround(f75 - f46);
    HEAPF32[i251 >> 2] = Math_fround(f506 - f35);
    HEAPF32[i252 >> 2] = f10;
    HEAPF32[i253 >> 2] = f11;
    HEAPF32[i254 >> 2] = f22;
    HEAPF32[i255 >> 2] = f23;
    HEAPF32[i256 >> 2] = f24;
    HEAPF32[i257 >> 2] = f25;
    HEAPF32[i258 >> 2] = f26;
    HEAPF32[i259 >> 2] = f503;
    HEAPF32[i260 >> 2] = f504;
    HEAPF32[i261 >> 2] = f505;
    HEAPF32[i262 >> 2] = f517;
    f507 = Math_fround(f507 - f48);
    f508 = Math_fround(f508 - f49);
    f509 = Math_fround(f509 - f50);
    f510 = Math_fround(f510 - f51);
    f511 = Math_fround(f511 - f52);
    f512 = Math_fround(f512 - f53);
    f513 = Math_fround(f513 - f54);
    f514 = Math_fround(f514 - f55);
    f515 = Math_fround(f515 - f56);
    f516 = Math_fround(f516 - f57);
    f517 = Math_fround(f75 - f58);
    HEAPF32[i263 >> 2] = Math_fround(f506 - f47);
    HEAPF32[i264 >> 2] = f507;
    HEAPF32[i265 >> 2] = f508;
    HEAPF32[i266 >> 2] = f509;
    HEAPF32[i267 >> 2] = f510;
    HEAPF32[i268 >> 2] = f511;
    HEAPF32[i269 >> 2] = f512;
    HEAPF32[i270 >> 2] = f513;
    HEAPF32[i271 >> 2] = f514;
    HEAPF32[i272 >> 2] = f515;
    HEAPF32[i273 >> 2] = f516;
    HEAPF32[i274 >> 2] = f517;
    if (!i275) {
     i2 = HEAP32[i496 >> 2] | 0;
     if (i2 & 536870912) {
      f517 = Math_fround(HEAPF32[i79 >> 2]);
      i68 = HEAP32[i484 >> 2] | 0;
      i341 = i68 + 693089735 | 0;
      i66 = HEAP32[i208 >> 2] | 0;
      i338 = i66 + 693089735 | 0;
      i64 = HEAP32[i209 >> 2] | 0;
      i73 = i64 + 693089735 | 0;
      i62 = HEAP32[i210 >> 2] | 0;
      i70 = i62 + 693089735 | 0;
      i63 = (Math_imul(i341, 1790253981) | 0) + 1900727103 | 0;
      i65 = (Math_imul(i338, 1790253981) | 0) + 1900727103 | 0;
      i67 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i69 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i341 = i341 << 11 ^ i341;
      i338 = i338 << 11 ^ i338;
      i73 = i73 << 11 ^ i73;
      i70 = i70 << 11 ^ i70;
      i63 = Math_fround(Math_fround((i63 ^ i341 ^ i341 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i65 = Math_fround(Math_fround((i65 ^ i338 ^ i338 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i67 = Math_fround(Math_fround((i67 ^ i73 ^ i73 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i69 = Math_fround(Math_fround((i69 ^ i70 ^ i70 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      f517 = Math_fround(HEAPF32[i77 >> 2]);
      i68 = i68 + 13945730 | 0;
      i66 = i66 + 13945730 | 0;
      i64 = i64 + 13945730 | 0;
      i62 = i62 + 13945730 | 0;
      i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
      i341 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
      i68 = i68 << 11 ^ i68;
      i66 = i66 << 11 ^ i66;
      i64 = i64 << 11 ^ i64;
      i62 = i62 << 11 ^ i62;
      i70 = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i73 = Math_fround(Math_fround((i73 ^ i66 ^ i66 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i338 = Math_fround(Math_fround((i338 ^ i64 ^ i64 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i341 = Math_fround(Math_fround((i341 ^ i62 ^ i62 >>> 8) & 8388607 ^ i341 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f517;
      i62 = i63 & 1;
      i64 = i65 & 1;
      i66 = i67 & 1;
      i68 = i69 & 1;
      i71 = i62 ^ 1;
      i74 = i64 ^ 1;
      i339 = i66 ^ 1;
      i518 = i68 ^ 1;
      i72 = i63 ? 3 : 2;
      i337 = i65 ? 3 : 2;
      i340 = i67 ? 3 : 2;
      i2 = i69 ? 3 : 2;
      i63 = i63 ? 2 : 3;
      i65 = i65 ? 2 : 3;
      i67 = i67 ? 2 : 3;
      i69 = i69 ? 2 : 3;
      HEAP32[i490 >> 2] = i70 ? i63 : i62;
      HEAP32[i450 >> 2] = i73 ? i65 : i64;
      HEAP32[i449 >> 2] = i338 ? i67 : i66;
      HEAP32[i448 >> 2] = i341 ? i69 : i68;
      HEAP32[i462 >> 2] = i70 ? i62 : i63;
      HEAP32[i461 >> 2] = i73 ? i64 : i65;
      HEAP32[i460 >> 2] = i338 ? i66 : i67;
      HEAP32[i459 >> 2] = i341 ? i68 : i69;
      HEAP32[i454 >> 2] = i70 ? i72 : i71;
      HEAP32[i453 >> 2] = i73 ? i337 : i74;
      HEAP32[i452 >> 2] = i338 ? i340 : i339;
      HEAP32[i451 >> 2] = i341 ? i2 : i518;
      HEAP32[i458 >> 2] = i70 ? i71 : i72;
      HEAP32[i457 >> 2] = i73 ? i74 : i337;
      HEAP32[i456 >> 2] = i338 ? i339 : i340;
      HEAP32[i455 >> 2] = i341 ? i518 : i2;
      i2 = HEAP32[i496 >> 2] | 0;
     }
     if (i2 & 268435456 | 0) {
      f9 = Math_fround(f472 * Math_fround(HEAPF32[i485 >> 2]));
      f10 = Math_fround(f472 * Math_fround(HEAPF32[i212 >> 2]));
      f11 = Math_fround(f472 * Math_fround(HEAPF32[i213 >> 2]));
      f22 = Math_fround(f472 * Math_fround(HEAPF32[i214 >> 2]));
      f23 = Math_fround(Math_floor(Math_fround(f9)));
      f24 = Math_fround(Math_floor(Math_fround(f10)));
      f25 = Math_fround(Math_floor(Math_fround(f11)));
      f26 = Math_fround(Math_floor(Math_fround(f22)));
      if (i2 & 16777216 | 0) {
       f514 = Math_fround(Math_floor(Math_fround(f471 * f23)));
       f515 = Math_fround(Math_floor(Math_fround(f471 * f24)));
       f516 = Math_fround(Math_floor(Math_fround(f471 * f25)));
       f517 = Math_fround(Math_floor(Math_fround(f471 * f26)));
       f510 = Math_fround(f473 * Math_fround(f23 - Math_fround(f470 * f514)));
       f511 = Math_fround(f473 * Math_fround(f24 - Math_fround(f470 * f515)));
       f512 = Math_fround(f473 * Math_fround(f25 - Math_fround(f470 * f516)));
       f513 = Math_fround(f473 * Math_fround(f26 - Math_fround(f470 * f517)));
       f514 = Math_fround(f475 - Math_fround(f474 * f514));
       f515 = Math_fround(f475 - Math_fround(f474 * f515));
       f516 = Math_fround(f475 - Math_fround(f474 * f516));
       f517 = Math_fround(f475 - Math_fround(f474 * f517));
       f75 = Math_fround(f474 + f514);
       f503 = Math_fround(f474 + f515);
       f504 = Math_fround(f474 + f516);
       f505 = Math_fround(f474 + f517);
       HEAPF32[i491 >> 2] = f510;
       HEAPF32[i387 >> 2] = f511;
       HEAPF32[i411 >> 2] = f512;
       HEAPF32[i435 >> 2] = f513;
       HEAPF32[i363 >> 2] = f75;
       HEAPF32[i386 >> 2] = f503;
       HEAPF32[i410 >> 2] = f504;
       HEAPF32[i434 >> 2] = f505;
       f506 = Math_fround(f473 + f510);
       f507 = Math_fround(f473 + f511);
       f508 = Math_fround(f473 + f512);
       f509 = Math_fround(f473 + f513);
       HEAPF32[i362 >> 2] = f506;
       HEAPF32[i385 >> 2] = f507;
       HEAPF32[i409 >> 2] = f508;
       HEAPF32[i433 >> 2] = f509;
       HEAPF32[i361 >> 2] = f75;
       HEAPF32[i384 >> 2] = f503;
       HEAPF32[i408 >> 2] = f504;
       HEAPF32[i432 >> 2] = f505;
       HEAPF32[i360 >> 2] = f506;
       HEAPF32[i383 >> 2] = f507;
       HEAPF32[i407 >> 2] = f508;
       HEAPF32[i431 >> 2] = f509;
       HEAPF32[i359 >> 2] = f514;
       HEAPF32[i382 >> 2] = f515;
       HEAPF32[i406 >> 2] = f516;
       HEAPF32[i430 >> 2] = f517;
       HEAPF32[i358 >> 2] = f510;
       HEAPF32[i381 >> 2] = f511;
       HEAPF32[i405 >> 2] = f512;
       HEAPF32[i429 >> 2] = f513;
       HEAPF32[i357 >> 2] = f514;
       HEAPF32[i380 >> 2] = f515;
       HEAPF32[i404 >> 2] = f516;
       HEAPF32[i428 >> 2] = f517;
      }
      if (i2 & 33554432 | 0) {
       f506 = Math_fround(f23 + Math_fround(1.0));
       f507 = Math_fround(f24 + Math_fround(1.0));
       f508 = Math_fround(f25 + Math_fround(1.0));
       f509 = Math_fround(f26 + Math_fround(1.0));
       f514 = Math_fround(f9 - f23);
       f515 = Math_fround(f10 - f24);
       f516 = Math_fround(f11 - f25);
       f517 = Math_fround(f22 - f26);
       f510 = Math_fround(Math_floor(Math_fround(f471 * f506)));
       f511 = Math_fround(Math_floor(Math_fround(f471 * f507)));
       f512 = Math_fround(Math_floor(Math_fround(f471 * f508)));
       f513 = Math_fround(Math_floor(Math_fround(f471 * f509)));
       f506 = Math_fround(f473 * Math_fround(f506 - Math_fround(f470 * f510)));
       f507 = Math_fround(f473 * Math_fround(f507 - Math_fround(f470 * f511)));
       f508 = Math_fround(f473 * Math_fround(f508 - Math_fround(f470 * f512)));
       f509 = Math_fround(f473 * Math_fround(f509 - Math_fround(f470 * f513)));
       f510 = Math_fround(f475 - Math_fround(f474 * f510));
       f511 = Math_fround(f475 - Math_fround(f474 * f511));
       f512 = Math_fround(f475 - Math_fround(f474 * f512));
       f513 = Math_fround(f475 - Math_fround(f474 * f513));
       f23 = Math_fround(f474 + f510);
       f24 = Math_fround(f474 + f511);
       f25 = Math_fround(f474 + f512);
       f26 = Math_fround(f474 + f513);
       HEAPF32[i492 >> 2] = f506;
       HEAPF32[i379 >> 2] = f507;
       HEAPF32[i403 >> 2] = f508;
       HEAPF32[i427 >> 2] = f509;
       HEAPF32[i356 >> 2] = f23;
       HEAPF32[i378 >> 2] = f24;
       HEAPF32[i402 >> 2] = f25;
       HEAPF32[i426 >> 2] = f26;
       HEAPF32[i355 >> 2] = f514;
       HEAPF32[i377 >> 2] = f515;
       HEAPF32[i401 >> 2] = f516;
       HEAPF32[i425 >> 2] = f517;
       HEAPF32[i354 >> 2] = f9;
       HEAPF32[i376 >> 2] = f10;
       HEAPF32[i400 >> 2] = f11;
       HEAPF32[i424 >> 2] = f22;
       f75 = Math_fround(f473 + f506);
       f503 = Math_fround(f473 + f507);
       f504 = Math_fround(f473 + f508);
       f505 = Math_fround(f473 + f509);
       HEAPF32[i353 >> 2] = f75;
       HEAPF32[i375 >> 2] = f503;
       HEAPF32[i399 >> 2] = f504;
       HEAPF32[i423 >> 2] = f505;
       HEAPF32[i352 >> 2] = f23;
       HEAPF32[i374 >> 2] = f24;
       HEAPF32[i398 >> 2] = f25;
       HEAPF32[i422 >> 2] = f26;
       HEAPF32[i351 >> 2] = f514;
       HEAPF32[i373 >> 2] = f515;
       HEAPF32[i397 >> 2] = f516;
       HEAPF32[i421 >> 2] = f517;
       HEAPF32[i350 >> 2] = f9;
       HEAPF32[i372 >> 2] = f10;
       HEAPF32[i396 >> 2] = f11;
       HEAPF32[i420 >> 2] = f22;
       HEAPF32[i349 >> 2] = f75;
       HEAPF32[i371 >> 2] = f503;
       HEAPF32[i395 >> 2] = f504;
       HEAPF32[i419 >> 2] = f505;
       HEAPF32[i348 >> 2] = f510;
       HEAPF32[i370 >> 2] = f511;
       HEAPF32[i394 >> 2] = f512;
       HEAPF32[i418 >> 2] = f513;
       HEAPF32[i347 >> 2] = f514;
       HEAPF32[i369 >> 2] = f515;
       HEAPF32[i393 >> 2] = f516;
       HEAPF32[i417 >> 2] = f517;
       HEAPF32[i346 >> 2] = f9;
       HEAPF32[i368 >> 2] = f10;
       HEAPF32[i392 >> 2] = f11;
       HEAPF32[i416 >> 2] = f22;
       HEAPF32[i345 >> 2] = f506;
       HEAPF32[i367 >> 2] = f507;
       HEAPF32[i391 >> 2] = f508;
       HEAPF32[i415 >> 2] = f509;
       HEAPF32[i344 >> 2] = f510;
       HEAPF32[i366 >> 2] = f511;
       HEAPF32[i390 >> 2] = f512;
       HEAPF32[i414 >> 2] = f513;
       HEAPF32[i343 >> 2] = f514;
       HEAPF32[i365 >> 2] = f515;
       HEAPF32[i389 >> 2] = f516;
       HEAPF32[i413 >> 2] = f517;
       HEAPF32[i342 >> 2] = f9;
       HEAPF32[i364 >> 2] = f10;
       HEAPF32[i388 >> 2] = f11;
       HEAPF32[i412 >> 2] = f22;
      }
     }
    }
    f75 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f35 * f35) + Math_fround(f39 * f39))))));
    f503 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f36 * f36) + Math_fround(f40 * f40))))));
    f504 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f37 * f37) + Math_fround(f41 * f41))))));
    f505 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f38 * f38) + Math_fround(f42 * f42))))));
    f35 = Math_fround(f476 * Math_fround(f35 * f75));
    f36 = Math_fround(f476 * Math_fround(f36 * f503));
    f37 = Math_fround(f476 * Math_fround(f37 * f504));
    f38 = Math_fround(f476 * Math_fround(f38 * f505));
    f39 = Math_fround(f476 * Math_fround(f39 * f75));
    f40 = Math_fround(f476 * Math_fround(f40 * f503));
    f41 = Math_fround(f476 * Math_fround(f41 * f504));
    f42 = Math_fround(f476 * Math_fround(f42 * f505));
    f75 = Math_fround(f476 * Math_fround(f43 * f75));
    f503 = Math_fround(f476 * Math_fround(f44 * f503));
    f504 = Math_fround(f476 * Math_fround(f45 * f504));
    f505 = Math_fround(f476 * Math_fround(f46 * f505));
    f514 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f47 * f47) + Math_fround(f51 * f51))))));
    f515 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f56 * f56) + Math_fround(Math_fround(f48 * f48) + Math_fround(f52 * f52))))));
    f516 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f49 * f49) + Math_fround(f53 * f53))))));
    f517 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f50 * f50) + Math_fround(f54 * f54))))));
    f506 = Math_fround(f476 * Math_fround(f47 * f514));
    f507 = Math_fround(f476 * Math_fround(f48 * f515));
    f508 = Math_fround(f476 * Math_fround(f49 * f516));
    f509 = Math_fround(f476 * Math_fround(f50 * f517));
    f510 = Math_fround(f476 * Math_fround(f51 * f514));
    f511 = Math_fround(f476 * Math_fround(f52 * f515));
    f512 = Math_fround(f476 * Math_fround(f53 * f516));
    f513 = Math_fround(f476 * Math_fround(f54 * f517));
    f514 = Math_fround(f476 * Math_fround(f55 * f514));
    f515 = Math_fround(f476 * Math_fround(f56 * f515));
    f516 = Math_fround(f476 * Math_fround(f57 * f516));
    f517 = Math_fround(f476 * Math_fround(f58 * f517));
    f52 = Math_fround(f469 + f36);
    f53 = Math_fround(f469 + f37);
    f54 = Math_fround(f469 + f38);
    f55 = Math_fround(f465 + f39);
    f56 = Math_fround(f465 + f40);
    f57 = Math_fround(f465 + f41);
    f58 = Math_fround(f465 + f42);
    f51 = Math_fround(f466 + f75);
    f50 = Math_fround(f466 + f503);
    f49 = Math_fround(f466 + f504);
    f48 = Math_fround(f466 + f505);
    HEAPF32[i494 >> 2] = Math_fround(f469 + f35);
    HEAPF32[i124 >> 2] = f52;
    HEAPF32[i141 >> 2] = f53;
    HEAPF32[i158 >> 2] = f54;
    HEAPF32[i276 >> 2] = f55;
    HEAPF32[i119 >> 2] = f56;
    HEAPF32[i136 >> 2] = f57;
    HEAPF32[i153 >> 2] = f58;
    HEAPF32[i277 >> 2] = f51;
    HEAPF32[i114 >> 2] = f50;
    HEAPF32[i131 >> 2] = f49;
    HEAPF32[i148 >> 2] = f48;
    f48 = Math_fround(f469 + f507);
    f49 = Math_fround(f469 + f508);
    f50 = Math_fround(f469 + f509);
    f51 = Math_fround(f465 + f510);
    f58 = Math_fround(f465 + f511);
    f57 = Math_fround(f465 + f512);
    f56 = Math_fround(f465 + f513);
    f55 = Math_fround(f466 + f514);
    f54 = Math_fround(f466 + f515);
    f53 = Math_fround(f466 + f516);
    f52 = Math_fround(f466 + f517);
    HEAPF32[i278 >> 2] = Math_fround(f469 + f506);
    HEAPF32[i123 >> 2] = f48;
    HEAPF32[i140 >> 2] = f49;
    HEAPF32[i157 >> 2] = f50;
    HEAPF32[i279 >> 2] = f51;
    HEAPF32[i118 >> 2] = f58;
    HEAPF32[i135 >> 2] = f57;
    HEAPF32[i152 >> 2] = f56;
    HEAPF32[i280 >> 2] = f55;
    HEAPF32[i113 >> 2] = f54;
    HEAPF32[i130 >> 2] = f53;
    HEAPF32[i147 >> 2] = f52;
    f52 = Math_fround(f469 - f36);
    f53 = Math_fround(f469 - f37);
    f54 = Math_fround(f469 - f38);
    f55 = Math_fround(f465 - f39);
    f56 = Math_fround(f465 - f40);
    f57 = Math_fround(f465 - f41);
    f58 = Math_fround(f465 - f42);
    f75 = Math_fround(f466 - f75);
    f503 = Math_fround(f466 - f503);
    f504 = Math_fround(f466 - f504);
    f505 = Math_fround(f466 - f505);
    HEAPF32[i281 >> 2] = Math_fround(f469 - f35);
    HEAPF32[i122 >> 2] = f52;
    HEAPF32[i139 >> 2] = f53;
    HEAPF32[i156 >> 2] = f54;
    HEAPF32[i282 >> 2] = f55;
    HEAPF32[i117 >> 2] = f56;
    HEAPF32[i134 >> 2] = f57;
    HEAPF32[i151 >> 2] = f58;
    HEAPF32[i283 >> 2] = f75;
    HEAPF32[i112 >> 2] = f503;
    HEAPF32[i129 >> 2] = f504;
    HEAPF32[i146 >> 2] = f505;
    f507 = Math_fround(f469 - f507);
    f508 = Math_fround(f469 - f508);
    f509 = Math_fround(f469 - f509);
    f510 = Math_fround(f465 - f510);
    f511 = Math_fround(f465 - f511);
    f512 = Math_fround(f465 - f512);
    f513 = Math_fround(f465 - f513);
    f514 = Math_fround(f466 - f514);
    f515 = Math_fround(f466 - f515);
    f516 = Math_fround(f466 - f516);
    f517 = Math_fround(f466 - f517);
    HEAPF32[i284 >> 2] = Math_fround(f469 - f506);
    HEAPF32[i121 >> 2] = f507;
    HEAPF32[i138 >> 2] = f508;
    HEAPF32[i155 >> 2] = f509;
    HEAPF32[i285 >> 2] = f510;
    HEAPF32[i116 >> 2] = f511;
    HEAPF32[i133 >> 2] = f512;
    HEAPF32[i150 >> 2] = f513;
    HEAPF32[i286 >> 2] = f514;
    HEAPF32[i111 >> 2] = f515;
    HEAPF32[i128 >> 2] = f516;
    HEAPF32[i145 >> 2] = f517;
    do if (i162) {
     i4 = HEAP32[i184 >> 2] | 0;
     i5 = HEAP32[i498 >> 2] | 0;
     if (!i4) {
      i2 = 0;
      i3 = i1;
      while (1) {
       i518 = i5 + (i2 + i76 << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i493 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i494 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i239 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i278 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i251 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i281 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i263 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i518 >> 2];
       i518 = i491 + (HEAP32[i490 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i518 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i518 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     } else {
      i2 = 0;
      i3 = i1;
      while (1) {
       i518 = i5 + (HEAP32[i4 + (i2 + i76 << 3) >> 2] << 2) | 0;
       HEAP32[i3 >> 2] = HEAP32[i493 + (i2 << 2) >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i494 + (i2 << 2) >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 28 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 32 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 36 >> 2] = HEAP32[i239 + (i2 << 2) >> 2];
       HEAP32[i3 + 40 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
       HEAP32[i3 + 44 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
       HEAP32[i3 + 48 >> 2] = HEAP32[i278 + (i2 << 2) >> 2];
       HEAP32[i3 + 52 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
       HEAP32[i3 + 56 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
       HEAP32[i3 + 60 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 + 4 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 64 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 68 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 72 >> 2] = HEAP32[i251 + (i2 << 2) >> 2];
       HEAP32[i3 + 76 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
       HEAP32[i3 + 80 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
       HEAP32[i3 + 84 >> 2] = HEAP32[i281 + (i2 << 2) >> 2];
       HEAP32[i3 + 88 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
       HEAP32[i3 + 92 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
       HEAP32[i3 + 96 >> 2] = HEAP32[i518 >> 2];
       i341 = i491 + (HEAP32[i490 + (i2 + 8 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 100 >> 2] = HEAP32[i341 + (i2 << 2) >> 2];
       HEAP32[i3 + 104 >> 2] = HEAP32[i341 + 16 + (i2 << 2) >> 2];
       HEAP32[i3 + 108 >> 2] = HEAP32[i263 + (i2 << 2) >> 2];
       HEAP32[i3 + 112 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
       HEAP32[i3 + 116 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
       HEAP32[i3 + 120 >> 2] = HEAP32[i284 + (i2 << 2) >> 2];
       HEAP32[i3 + 124 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
       HEAP32[i3 + 128 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
       HEAP32[i3 + 132 >> 2] = HEAP32[i518 >> 2];
       i518 = i491 + (HEAP32[i490 + (i2 + 12 << 2) >> 2] << 5) | 0;
       HEAP32[i3 + 136 >> 2] = HEAP32[i518 + (i2 << 2) >> 2];
       HEAP32[i3 + 140 >> 2] = HEAP32[i518 + 16 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
      }
      i1 = i1 + 576 | 0;
      break;
     }
    } else {
     f505 = Math_fround(HEAPF32[i239 >> 2]);
     f505 = Math_fround(f505 - Math_fround(HEAPF32[i493 >> 2]));
     f507 = Math_fround(HEAPF32[i240 >> 2]);
     f507 = Math_fround(f507 - Math_fround(HEAPF32[i228 >> 2]));
     f508 = Math_fround(HEAPF32[i241 >> 2]);
     f508 = Math_fround(f508 - Math_fround(HEAPF32[i229 >> 2]));
     f509 = Math_fround(HEAPF32[i242 >> 2]);
     f509 = Math_fround(f509 - Math_fround(HEAPF32[i230 >> 2]));
     f510 = Math_fround(HEAPF32[i243 >> 2]);
     f510 = Math_fround(f510 - Math_fround(HEAPF32[i231 >> 2]));
     f517 = Math_fround(HEAPF32[i244 >> 2]);
     f517 = Math_fround(f517 - Math_fround(HEAPF32[i232 >> 2]));
     f516 = Math_fround(HEAPF32[i245 >> 2]);
     f516 = Math_fround(f516 - Math_fround(HEAPF32[i233 >> 2]));
     f515 = Math_fround(HEAPF32[i246 >> 2]);
     f515 = Math_fround(f515 - Math_fround(HEAPF32[i234 >> 2]));
     f514 = Math_fround(HEAPF32[i247 >> 2]);
     f514 = Math_fround(f514 - Math_fround(HEAPF32[i235 >> 2]));
     f75 = Math_fround(HEAPF32[i248 >> 2]);
     f75 = Math_fround(f75 - Math_fround(HEAPF32[i236 >> 2]));
     f503 = Math_fround(HEAPF32[i249 >> 2]);
     f503 = Math_fround(f503 - Math_fround(HEAPF32[i237 >> 2]));
     f504 = Math_fround(HEAPF32[i250 >> 2]);
     f504 = Math_fround(f504 - Math_fround(HEAPF32[i238 >> 2]));
     f506 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f505 * f505) + Math_fround(f510 * f510)) + Math_fround(f514 * f514)))));
     f513 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f507 * f507) + Math_fround(f517 * f517)) + Math_fround(f75 * f75)))));
     f512 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f508 * f508) + Math_fround(f516 * f516)) + Math_fround(f503 * f503)))));
     f511 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f509 * f509) + Math_fround(f515 * f515)) + Math_fround(f504 * f504)))));
     f507 = Math_fround(f507 * f513);
     f508 = Math_fround(f508 * f512);
     f509 = Math_fround(f509 * f511);
     f510 = Math_fround(f510 * f506);
     f517 = Math_fround(f517 * f513);
     f516 = Math_fround(f516 * f512);
     f515 = Math_fround(f515 * f511);
     f514 = Math_fround(f514 * f506);
     f513 = Math_fround(f75 * f513);
     f512 = Math_fround(f503 * f512);
     f511 = Math_fround(f504 * f511);
     HEAPF32[i487 >> 2] = Math_fround(f505 * f506);
     HEAPF32[i125 >> 2] = f507;
     HEAPF32[i142 >> 2] = f508;
     HEAPF32[i159 >> 2] = f509;
     HEAPF32[i287 >> 2] = f510;
     HEAPF32[i120 >> 2] = f517;
     HEAPF32[i137 >> 2] = f516;
     HEAPF32[i154 >> 2] = f515;
     HEAPF32[i288 >> 2] = f514;
     HEAPF32[i115 >> 2] = f513;
     HEAPF32[i132 >> 2] = f512;
     HEAPF32[i149 >> 2] = f511;
     f511 = Math_fround(f28 * Math_fround(2.0));
     f512 = Math_fround(f29 * Math_fround(2.0));
     f513 = Math_fround(f30 * Math_fround(2.0));
     f514 = Math_fround(f31 * Math_fround(2.0));
     f515 = Math_fround(f32 * Math_fround(2.0));
     f516 = Math_fround(f33 * Math_fround(2.0));
     f517 = Math_fround(f34 * Math_fround(2.0));
     HEAPF32[i488 >> 2] = Math_fround(f27 * Math_fround(2.0));
     HEAPF32[i127 >> 2] = f511;
     HEAPF32[i144 >> 2] = f512;
     HEAPF32[i161 >> 2] = f513;
     HEAPF32[i289 >> 2] = f514;
     HEAPF32[i126 >> 2] = f515;
     HEAPF32[i143 >> 2] = f516;
     HEAPF32[i160 >> 2] = f517;
     HEAP32[i110 >> 2] = 0;
     HEAP32[i110 + 4 >> 2] = 0;
     HEAP32[i110 + 8 >> 2] = 0;
     HEAP32[i110 + 12 >> 2] = 0;
     if (i290) {
      f54 = Math_fround(HEAPF32[i501 >> 2]);
      f515 = Math_fround(f436 * f54);
      f56 = Math_fround(HEAPF32[i177 >> 2]);
      f506 = Math_fround(f436 * f56);
      f58 = Math_fround(HEAPF32[i176 >> 2]);
      f514 = Math_fround(f436 * f58);
      f503 = Math_fround(HEAPF32[i175 >> 2]);
      f509 = Math_fround(f436 * f503);
      f55 = Math_fround(HEAPF32[i193 >> 2]);
      f505 = Math_fround(f439 * f55);
      f57 = Math_fround(HEAPF32[i180 >> 2]);
      f511 = Math_fround(f439 * f57);
      f75 = Math_fround(HEAPF32[i179 >> 2]);
      f510 = Math_fround(f439 * f75);
      f504 = Math_fround(HEAPF32[i178 >> 2]);
      f505 = Math_fround(f515 + f505);
      f511 = Math_fround(f506 + f511);
      f510 = Math_fround(f514 + f510);
      f509 = Math_fround(f509 + Math_fround(f439 * f504));
      f514 = Math_fround(HEAPF32[i194 >> 2]);
      f506 = Math_fround(f442 * f514);
      f515 = Math_fround(HEAPF32[i183 >> 2]);
      f507 = Math_fround(f442 * f515);
      f516 = Math_fround(HEAPF32[i182 >> 2]);
      f508 = Math_fround(f442 * f516);
      f517 = Math_fround(HEAPF32[i181 >> 2]);
      f507 = Math_fround(f511 + f507);
      f508 = Math_fround(f510 + f508);
      f509 = Math_fround(f509 + Math_fround(f442 * f517));
      f510 = Math_fround(Math_fround(Math_fround(f437 * f54) + Math_fround(f440 * f55)) + Math_fround(f443 * f514));
      f511 = Math_fround(Math_fround(Math_fround(f437 * f56) + Math_fround(f440 * f57)) + Math_fround(f443 * f515));
      f512 = Math_fround(Math_fround(Math_fround(f437 * f58) + Math_fround(f440 * f75)) + Math_fround(f443 * f516));
      f513 = Math_fround(Math_fround(Math_fround(f437 * f503) + Math_fround(f440 * f504)) + Math_fround(f443 * f517));
      f514 = Math_fround(Math_fround(Math_fround(f438 * f54) + Math_fround(f441 * f55)) + Math_fround(f444 * f514));
      f515 = Math_fround(Math_fround(Math_fround(f438 * f56) + Math_fround(f441 * f57)) + Math_fround(f444 * f515));
      f516 = Math_fround(Math_fround(Math_fround(f438 * f58) + Math_fround(f441 * f75)) + Math_fround(f444 * f516));
      f517 = Math_fround(Math_fround(Math_fround(f438 * f503) + Math_fround(f441 * f504)) + Math_fround(f444 * f517));
      HEAPF32[i489 >> 2] = Math_fround(f505 + f506);
      HEAPF32[i291 >> 2] = f507;
      HEAPF32[i292 >> 2] = f508;
      HEAPF32[i293 >> 2] = f509;
      HEAPF32[i294 >> 2] = f510;
      HEAPF32[i295 >> 2] = f511;
      HEAPF32[i296 >> 2] = f512;
      HEAPF32[i297 >> 2] = f513;
      HEAPF32[i298 >> 2] = f514;
      HEAPF32[i299 >> 2] = f515;
      HEAPF32[i300 >> 2] = f516;
      HEAPF32[i301 >> 2] = f517;
     }
     if (i302) {
      i74 = HEAP32[i484 >> 2] | 0;
      i339 = i74 + 1068538453 | 0;
      i340 = HEAP32[i208 >> 2] | 0;
      i338 = i340 + 1068538453 | 0;
      i71 = HEAP32[i209 >> 2] | 0;
      i70 = i71 + 1068538453 | 0;
      i69 = HEAP32[i210 >> 2] | 0;
      i73 = i69 + 1068538453 | 0;
      i341 = (Math_imul(i339, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i338, 1790253981) | 0) + 1900727103 | 0;
      i518 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
      i337 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i339 = i339 << 11 ^ i339;
      i338 = i338 << 11 ^ i338;
      i70 = i70 << 11 ^ i70;
      i73 = i73 << 11 ^ i73;
      f515 = Math_fround(Math_fround((i72 ^ i338 ^ i338 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i518 ^ i70 ^ i70 >>> 8) & 8388607 ^ i518 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i337 ^ i73 ^ i73 >>> 8) & 8388607 ^ i337 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i495 >> 2] = Math_fround(Math_fround((i341 ^ i339 ^ i339 >>> 8) & 8388607 ^ i341 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i303 >> 2] = f515;
      HEAPF32[i304 >> 2] = f516;
      HEAPF32[i305 >> 2] = f517;
      i74 = i74 + 1068538454 | 0;
      i340 = i340 + 1068538454 | 0;
      i71 = i71 + 1068538454 | 0;
      i69 = i69 + 1068538454 | 0;
      i341 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
      i339 = (Math_imul(i340, 1790253981) | 0) + 1900727103 | 0;
      i337 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i73 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i74 = i74 << 11 ^ i74;
      i340 = i340 << 11 ^ i340;
      i71 = i71 << 11 ^ i71;
      i69 = i69 << 11 ^ i69;
      f517 = Math_fround(Math_fround((i339 ^ i340 ^ i340 >>> 8) & 8388607 ^ i339 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i337 ^ i71 ^ i71 >>> 8) & 8388607 ^ i337 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f515 = Math_fround(Math_fround((i73 ^ i69 ^ i69 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i306 >> 2] = Math_fround(Math_fround((i341 ^ i74 ^ i74 >>> 8) & 8388607 ^ i341 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i307 >> 2] = f517;
      HEAPF32[i308 >> 2] = f516;
      HEAPF32[i309 >> 2] = f515;
      i341 = HEAP32[i484 >> 2] | 0;
      i74 = i341 + 1068538455 | 0;
      i73 = HEAP32[i208 >> 2] | 0;
      i69 = i73 + 1068538455 | 0;
      i337 = HEAP32[i209 >> 2] | 0;
      i71 = i337 + 1068538455 | 0;
      i339 = HEAP32[i210 >> 2] | 0;
      i340 = i339 + 1068538455 | 0;
      i518 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
      i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
      i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i340, 1790253981) | 0) + 1900727103 | 0;
      i74 = i74 << 11 ^ i74;
      i69 = i69 << 11 ^ i69;
      i71 = i71 << 11 ^ i71;
      i340 = i340 << 11 ^ i340;
      f515 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i338 ^ i340 ^ i340 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i310 >> 2] = Math_fround(Math_fround((i518 ^ i74 ^ i74 >>> 8) & 8388607 ^ i518 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i311 >> 2] = f515;
      HEAPF32[i312 >> 2] = f516;
      HEAPF32[i313 >> 2] = f517;
      f517 = Math_fround(Math_fround(HEAPF32[i483 >> 2]) * Math_fround(1.0e5));
      f516 = Math_fround(Math_fround(HEAPF32[i204 >> 2]) * Math_fround(1.0e5));
      f515 = Math_fround(Math_fround(HEAPF32[i205 >> 2]) * Math_fround(1.0e5));
      i341 = i341 + 1068538453 + ~~f517 | 0;
      i73 = i73 + 1068538453 + ~~f516 | 0;
      i337 = i337 + 1068538453 + ~~f515 | 0;
      i339 = i339 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i206 >> 2]) * Math_fround(1.0e5)) | 0;
      i518 = (Math_imul(i341, 1790253981) | 0) + 1900727103 | 0;
      i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
      i338 = (Math_imul(i337, 1790253981) | 0) + 1900727103 | 0;
      i340 = (Math_imul(i339, 1790253981) | 0) + 1900727103 | 0;
      i341 = i341 << 11 ^ i341;
      i73 = i73 << 11 ^ i73;
      i337 = i337 << 11 ^ i337;
      i339 = i339 << 11 ^ i339;
      f515 = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f516 = Math_fround(Math_fround((i338 ^ i337 ^ i337 >>> 8) & 8388607 ^ i338 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f517 = Math_fround(Math_fround((i340 ^ i339 ^ i339 >>> 8) & 8388607 ^ i340 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i314 >> 2] = Math_fround(Math_fround((i518 ^ i341 ^ i341 >>> 8) & 8388607 ^ i518 >>> 19 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i315 >> 2] = f515;
      HEAPF32[i316 >> 2] = f516;
      HEAPF32[i317 >> 2] = f517;
     }
     i67 = HEAP32[i184 >> 2] | 0;
     i68 = (i67 | 0) == 0;
     i69 = HEAP32[i86 >> 2] | 0;
     i70 = HEAP32[i88 >> 2] | 0;
     i71 = HEAP32[i203 >> 2] | 0;
     i72 = HEAP32[i89 >> 2] | 0;
     i73 = HEAP32[i330 >> 2] | 0;
     i74 = HEAP32[i498 >> 2] | 0;
     i66 = 0;
     do {
      i2 = i66 + i76 | 0;
      if (!i68) i2 = HEAP32[i67 + (i2 << 3) >> 2] | 0;
      i5 = i489 + (i66 << 2) | 0;
      i6 = i325 + (i66 << 2) | 0;
      i7 = i326 + (i66 << 2) | 0;
      i8 = i495 + (i66 << 2) | 0;
      i12 = i306 + (i66 << 2) | 0;
      i13 = i310 + (i66 << 2) | 0;
      i14 = i314 + (i66 << 2) | 0;
      i15 = i487 + (i66 << 2) | 0;
      i16 = i83 + (i66 << 2) | 0;
      i17 = i84 + (i66 << 2) | 0;
      i18 = i69 + (i2 << 4) | 0;
      i19 = i70 + (i2 << 4) | 0;
      i20 = i71 + (i2 << 2) | 0;
      i21 = i72 + (i2 << 2) | 0;
      i59 = i73 + (i2 << 2) | 0;
      i60 = i488 + (i66 << 2) | 0;
      i61 = i90 + (i66 << 2) | 0;
      i62 = i91 + (i66 << 2) | 0;
      i63 = i486 + (i66 << 2) | 0;
      i64 = i92 + (i66 << 2) | 0;
      i65 = i93 + (i66 << 2) | 0;
      i4 = i74 + (i2 << 2) | 0;
      i3 = 0;
      i2 = i1;
      while (1) {
       i1 = i493 + (i3 * 48 | 0) | 0;
       HEAP32[i2 >> 2] = HEAP32[i1 + (i66 << 2) >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i66 << 2) >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i66 << 2) >> 2];
       i1 = i2 + 12 | 0;
       if (!i318) {
        i518 = i494 + (i3 * 48 | 0) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i2 + 16 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        HEAP32[i2 + 20 >> 2] = HEAP32[i518 + 32 + (i66 << 2) >> 2];
        i1 = i2 + 24 | 0;
       }
       if (!i319) {
        HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
        i1 = i1 + 4 | 0;
       }
       if (!i320) {
        i518 = i491 + (HEAP32[i490 + ((i3 << 2) + i66 << 2) >> 2] << 5) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i321) {
        i518 = i492 + (HEAP32[i490 + ((i3 << 2) + i66 << 2) >> 2] << 6) | 0;
        HEAP32[i1 >> 2] = HEAP32[i518 + (i66 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 16 + (i66 << 2) >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 32 + (i66 << 2) >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 48 + (i66 << 2) >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i322) {
        f517 = Math_fround(i3 | 0);
        HEAP32[i1 >> 2] = HEAP32[i63 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i65 >> 2];
        HEAPF32[i1 + 12 >> 2] = f517;
        i1 = i1 + 16 | 0;
       }
       if (!i323) {
        HEAP32[i1 >> 2] = HEAP32[i60 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i61 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i62 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i324) {
        i518 = HEAP32[i59 >> 2] | 0;
        HEAP32[i1 >> 2] = i518;
        HEAP32[i1 + 4 >> 2] = i518;
        HEAP32[i1 + 8 >> 2] = i518;
        i1 = i1 + 12 | 0;
       }
       if (i290) {
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
        i1 = i1 + 12 | 0;
       }
       if (!i327) {
        f517 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(.00999999977));
        i518 = HEAP32[i21 >> 2] | 0;
        HEAPF32[i1 >> 2] = f517;
        HEAP32[i1 + 4 >> 2] = i518;
        i1 = i1 + 8 | 0;
       }
       if (!i328) {
        i518 = (HEAP32[i87 >> 2] & 2147483647 | 0) == 0 ? i499 : i19;
        HEAP32[i1 >> 2] = HEAP32[i518 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i329) {
        i518 = (HEAP32[i85 >> 2] & 2147483647 | 0) == 0 ? i499 : i18;
        HEAP32[i1 >> 2] = HEAP32[i518 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i518 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i518 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i518 + 12 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (i302) {
        HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i14 >> 2];
        i1 = i1 + 16 | 0;
       }
       if (!i82) {
        HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i17 >> 2];
        HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
        i1 = i1 + 16 | 0;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == 4) break; else i2 = i1;
      }
      i66 = i66 + 1 | 0;
     } while ((i66 | 0) != 4);
    } while (0);
    i76 = i76 + 4 | 0;
   } while (i76 >>> 0 < i163 >>> 0);
  }
  STACKTOP = i502;
  return;
 }
}

function __ZN7mecanim9animation18EvaluateRootMotionERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfS8_RNS0_12MotionOutputEb(i131, i167, i71, i76, i169, i170) {
 i131 = i131 | 0;
 i167 = i167 | 0;
 i71 = i71 | 0;
 i76 = i76 | 0;
 i169 = i169 | 0;
 i170 = i170 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, i49 = 0, i50 = 0, f51 = f0, i52 = 0, i53 = 0, f54 = f0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, i69 = 0, i70 = 0, f72 = f0, f73 = f0, f74 = f0, i75 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, i96 = 0, i97 = 0, f98 = f0, i99 = 0, f100 = f0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f105 = f0, i106 = 0, f107 = f0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, f112 = f0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, f117 = f0, f118 = f0, f119 = f0, i120 = 0, i121 = 0, f122 = f0, f123 = f0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i168 = 0, i171 = 0, i172 = 0, i173 = 0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0;
 i173 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i127 = i173 + 164 | 0;
 i125 = i173 + 160 | 0;
 i171 = i173 + 120 | 0;
 i172 = i173 + 80 | 0;
 i168 = i173 + 40 | 0;
 i128 = i173;
 i70 = i131 + 1088 | 0;
 if ((HEAP32[i70 >> 2] | 0) == -1) if ((HEAP32[i131 + 1092 >> 2] | 0) == -1) if ((HEAP32[i131 + 1096 >> 2] | 0) == -1) if ((HEAP32[i131 + 1100 >> 2] | 0) == -1) if ((HEAP32[i131 + 1104 >> 2] | 0) == -1) if ((HEAP32[i131 + 1108 >> 2] | 0) == -1) i130 = (HEAP32[i131 + 1112 >> 2] | 0) != -1; else i130 = 1; else i130 = 1; else i130 = 1; else i130 = 1; else i130 = 1; else i130 = 1;
 i4 = i131 + 1116 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) if ((HEAP32[i131 + 1120 >> 2] | 0) == -1) if ((HEAP32[i131 + 1124 >> 2] | 0) == -1) if ((HEAP32[i131 + 1128 >> 2] | 0) == -1) if ((HEAP32[i131 + 1132 >> 2] | 0) == -1) if ((HEAP32[i131 + 1136 >> 2] | 0) == -1) i1 = (HEAP32[i131 + 1140 >> 2] | 0) != -1; else i1 = 1; else i1 = 1; else i1 = 1; else i1 = 1; else i1 = 1; else i1 = 1;
 i129 = i1 | i170;
 i137 = i169 + 52 | 0;
 i2 = i169;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i137 >> 2] = 1065353216;
 i138 = i169 + 56 | 0;
 HEAP32[i138 >> 2] = 1065353216;
 i139 = i169 + 60 | 0;
 HEAP32[i139 >> 2] = 1065353216;
 i140 = i169 + 64 | 0;
 HEAP32[i140 >> 2] = 1065353216;
 i141 = i169 + 68 | 0;
 i142 = i169 + 92 | 0;
 HEAP32[i141 >> 2] = 0;
 HEAP32[i141 + 4 >> 2] = 0;
 HEAP32[i141 + 8 >> 2] = 0;
 HEAP32[i141 + 12 >> 2] = 0;
 HEAP32[i141 + 16 >> 2] = 0;
 HEAP32[i141 + 20 >> 2] = 0;
 HEAP32[i142 >> 2] = 1065353216;
 i143 = i169 + 96 | 0;
 HEAP32[i143 >> 2] = 1065353216;
 i144 = i169 + 100 | 0;
 HEAP32[i144 >> 2] = 1065353216;
 i145 = i169 + 104 | 0;
 HEAP32[i145 >> 2] = 1065353216;
 i146 = i169 + 108 | 0;
 i147 = i169 + 132 | 0;
 HEAP32[i146 >> 2] = 0;
 HEAP32[i146 + 4 >> 2] = 0;
 HEAP32[i146 + 8 >> 2] = 0;
 HEAP32[i146 + 12 >> 2] = 0;
 HEAP32[i146 + 16 >> 2] = 0;
 HEAP32[i146 + 20 >> 2] = 0;
 HEAP32[i147 >> 2] = 1065353216;
 i148 = i169 + 136 | 0;
 HEAP32[i148 >> 2] = 1065353216;
 i149 = i169 + 140 | 0;
 HEAP32[i149 >> 2] = 1065353216;
 i150 = i169 + 144 | 0;
 HEAP32[i150 >> 2] = 1065353216;
 i151 = i169 + 148 | 0;
 i152 = i169 + 172 | 0;
 HEAP32[i151 >> 2] = 0;
 HEAP32[i151 + 4 >> 2] = 0;
 HEAP32[i151 + 8 >> 2] = 0;
 HEAP32[i151 + 12 >> 2] = 0;
 HEAP32[i151 + 16 >> 2] = 0;
 HEAP32[i151 + 20 >> 2] = 0;
 HEAP32[i152 >> 2] = 1065353216;
 i153 = i169 + 176 | 0;
 HEAP32[i153 >> 2] = 1065353216;
 i154 = i169 + 180 | 0;
 HEAP32[i154 >> 2] = 1065353216;
 i155 = i169 + 184 | 0;
 HEAP32[i155 >> 2] = 1065353216;
 i156 = i169 + 188 | 0;
 i157 = i169 + 212 | 0;
 HEAP32[i156 >> 2] = 0;
 HEAP32[i156 + 4 >> 2] = 0;
 HEAP32[i156 + 8 >> 2] = 0;
 HEAP32[i156 + 12 >> 2] = 0;
 HEAP32[i156 + 16 >> 2] = 0;
 HEAP32[i156 + 20 >> 2] = 0;
 HEAP32[i157 >> 2] = 1065353216;
 i158 = i169 + 216 | 0;
 HEAP32[i158 >> 2] = 1065353216;
 i159 = i169 + 220 | 0;
 HEAP32[i159 >> 2] = 1065353216;
 i160 = i169 + 224 | 0;
 HEAP32[i160 >> 2] = 1065353216;
 i161 = i169 + 228 | 0;
 i162 = i169 + 252 | 0;
 HEAP32[i161 >> 2] = 0;
 HEAP32[i161 + 4 >> 2] = 0;
 HEAP32[i161 + 8 >> 2] = 0;
 HEAP32[i161 + 12 >> 2] = 0;
 HEAP32[i161 + 16 >> 2] = 0;
 HEAP32[i161 + 20 >> 2] = 0;
 HEAP32[i162 >> 2] = 1065353216;
 i163 = i169 + 256 | 0;
 HEAP32[i163 >> 2] = 1065353216;
 i164 = i169 + 260 | 0;
 HEAP32[i164 >> 2] = 1065353216;
 i165 = i169 + 264 | 0;
 HEAP32[i165 >> 2] = 1065353216;
 i166 = i169 + 268 | 0;
 i1 = i169 + 316 | 0;
 i2 = i166;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i169 + 320 >> 2] = 1065353216;
 HEAP32[i169 + 324 >> 2] = 1065353216;
 HEAP32[i169 + 328 >> 2] = 1065353216;
 if (!(i130 | i129)) {
  STACKTOP = i173;
  return;
 }
 i2 = HEAP16[i131 + 1724 >> 1] | 0;
 i132 = HEAP8[i167 + 12 >> 0] | 0;
 i132 = (i2 & 255) << 24 >> 24 == 0 ? i132 << 24 >> 24 == 0 : i132 << 24 >> 24 != 0;
 f117 = Math_fround(HEAPF32[i131 + 1080 >> 2]);
 f117 = Math_fround(f117 + Math_fround(HEAPF32[i167 + 16 >> 2]));
 i134 = i167 + 4 | 0;
 f122 = Math_fround(HEAPF32[i134 >> 2]);
 i135 = i131 + 1064 | 0;
 i136 = i131 + 1068 | 0;
 i124 = i131 + 1725 | 0;
 i2 = (i2 & 65535) > 255;
 i133 = i167 + 8 | 0;
 i1 = Math_fround(HEAPF32[i167 >> 2]) < Math_fround(0.0);
 f118 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i133 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f123 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f122))));
 f122 = Math_fround(_modff(Math_fround(f117 + f122), i127));
 f123 = i2 ? f122 : f123;
 f122 = Math_fround(HEAPF32[i127 >> 2]);
 HEAPF32[i127 >> 2] = i2 ? f122 : Math_fround(0.0);
 f122 = Math_fround(f123 + Math_fround(1.0));
 f123 = i2 & i1 ? f122 : f123;
 f122 = Math_fround(Math_fround(1.0) - f123);
 i1 = !(f118 < Math_fround(0.0));
 f122 = i1 ? f123 : f122;
 f123 = Math_fround(HEAPF32[i167 >> 2]);
 i1 = (HEAP8[i124 >> 0] | 0) != 0;
 i2 = f123 < Math_fround(0.0);
 f118 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i133 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f119 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f123))));
 f123 = Math_fround(_modff(Math_fround(f117 + f123), i125));
 f119 = i1 ? f123 : f119;
 f123 = Math_fround(HEAPF32[i125 >> 2]);
 HEAPF32[i125 >> 2] = i1 ? f123 : Math_fround(0.0);
 f123 = Math_fround(f119 + Math_fround(1.0));
 f119 = i2 & i1 ? f123 : f119;
 f123 = Math_fround(Math_fround(1.0) - f119);
 i1 = !(f118 < Math_fround(0.0));
 f123 = i1 ? f119 : f123;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (i1 | 0) == -1;
 if (i2) i113 = 0; else i113 = HEAP32[i76 + (i1 << 2) >> 2] | 0;
 i3 = HEAP32[i131 + 1120 >> 2] | 0;
 i4 = (i3 | 0) == -1;
 if (i4) i114 = 0; else i114 = HEAP32[i76 + (i3 << 2) >> 2] | 0;
 i9 = HEAP32[i131 + 1124 >> 2] | 0;
 i10 = (i9 | 0) == -1;
 if (i10) i115 = 0; else i115 = HEAP32[i76 + (i9 << 2) >> 2] | 0;
 i11 = HEAP32[i131 + 1128 >> 2] | 0;
 i12 = (i11 | 0) == -1;
 if (i12) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i76 + (i11 << 2) >> 2]);
 i13 = HEAP32[i131 + 1132 >> 2] | 0;
 i14 = (i13 | 0) == -1;
 if (i14) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i76 + (i13 << 2) >> 2]);
 i15 = HEAP32[i131 + 1136 >> 2] | 0;
 i16 = (i15 | 0) == -1;
 if (i16) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i76 + (i15 << 2) >> 2]);
 i17 = HEAP32[i131 + 1140 >> 2] | 0;
 i18 = (i17 | 0) == -1;
 if (i18) f8 = Math_fround(1.0); else f8 = Math_fround(HEAPF32[i76 + (i17 << 2) >> 2]);
 f112 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
 f119 = Math_fround(f5 * f112);
 f118 = Math_fround(f6 * f112);
 f117 = Math_fround(f7 * f112);
 f112 = Math_fround(f8 * f112);
 if (i2) f59 = Math_fround(0.0); else f59 = Math_fround(HEAPF32[i71 + (i1 << 2) >> 2]);
 if (i4) i77 = 0; else i77 = HEAP32[i71 + (i3 << 2) >> 2] | 0;
 if (i10) f58 = Math_fround(0.0); else f58 = Math_fround(HEAPF32[i71 + (i9 << 2) >> 2]);
 if (i12) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i71 + (i11 << 2) >> 2]);
 if (i14) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i71 + (i13 << 2) >> 2]);
 if (i16) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i71 + (i15 << 2) >> 2]);
 if (i18) f5 = Math_fround(1.0); else f5 = Math_fround(HEAPF32[i71 + (i17 << 2) >> 2]);
 f60 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))))));
 f63 = Math_fround(f8 * f60);
 f62 = Math_fround(f7 * f60);
 f61 = Math_fround(f6 * f60);
 f60 = Math_fround(f5 * f60);
 f98 = Math_fround(HEAPF32[i131 + 888 >> 2]);
 i99 = HEAP32[i131 + 892 >> 2] | 0;
 f100 = Math_fround(HEAPF32[i131 + 896 >> 2]);
 i101 = HEAP32[i131 + 900 >> 2] | 0;
 i102 = HEAP32[i131 + 904 >> 2] | 0;
 i103 = HEAP32[i131 + 908 >> 2] | 0;
 i104 = HEAP32[i131 + 912 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i131 + 916 >> 2]);
 f20 = Math_fround(HEAPF32[i131 + 920 >> 2]);
 f21 = Math_fround(HEAPF32[i131 + 924 >> 2]);
 f105 = Math_fround(HEAPF32[i131 + 928 >> 2]);
 i106 = HEAP32[i131 + 932 >> 2] | 0;
 f107 = Math_fround(HEAPF32[i131 + 936 >> 2]);
 i108 = HEAP32[i131 + 940 >> 2] | 0;
 i109 = HEAP32[i131 + 944 >> 2] | 0;
 i110 = HEAP32[i131 + 948 >> 2] | 0;
 i111 = HEAP32[i131 + 952 >> 2] | 0;
 f25 = Math_fround(HEAPF32[i131 + 956 >> 2]);
 f30 = Math_fround(HEAPF32[i131 + 960 >> 2]);
 f47 = Math_fround(HEAPF32[i131 + 964 >> 2]);
 if (i170) {
  i2 = HEAP32[i131 + 1144 >> 2] | 0;
  i3 = (i2 | 0) == -1;
  if (i3) i44 = 0; else i44 = HEAP32[i76 + (i2 << 2) >> 2] | 0;
  i4 = HEAP32[i131 + 1148 >> 2] | 0;
  i9 = (i4 | 0) == -1;
  if (i9) i56 = 0; else i56 = HEAP32[i76 + (i4 << 2) >> 2] | 0;
  i10 = HEAP32[i131 + 1152 >> 2] | 0;
  i11 = (i10 | 0) == -1;
  if (i11) i64 = 0; else i64 = HEAP32[i76 + (i10 << 2) >> 2] | 0;
  i12 = HEAP32[i131 + 1156 >> 2] | 0;
  i13 = (i12 | 0) == -1;
  if (i13) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i76 + (i12 << 2) >> 2]);
  i14 = HEAP32[i131 + 1160 >> 2] | 0;
  i15 = (i14 | 0) == -1;
  if (i15) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i76 + (i14 << 2) >> 2]);
  i16 = HEAP32[i131 + 1164 >> 2] | 0;
  i17 = (i16 | 0) == -1;
  if (i17) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i76 + (i16 << 2) >> 2]);
  i23 = HEAP32[i131 + 1168 >> 2] | 0;
  i24 = (i23 | 0) == -1;
  if (i24) f8 = Math_fround(1.0); else f8 = Math_fround(HEAPF32[i76 + (i23 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
  f92 = Math_fround(f5 * f95);
  f93 = Math_fround(f6 * f95);
  f94 = Math_fround(f7 * f95);
  f95 = Math_fround(f8 * f95);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = HEAP32[i131 + 1172 >> 2] | 0;
  i34 = (i29 | 0) == -1;
  if (i34) i45 = 0; else i45 = HEAP32[i76 + (i29 << 2) >> 2] | 0;
  i36 = HEAP32[i131 + 1176 >> 2] | 0;
  i37 = (i36 | 0) == -1;
  if (i37) i38 = 0; else i38 = HEAP32[i76 + (i36 << 2) >> 2] | 0;
  i39 = HEAP32[i131 + 1180 >> 2] | 0;
  i40 = (i39 | 0) == -1;
  if (i40) i35 = 0; else i35 = HEAP32[i76 + (i39 << 2) >> 2] | 0;
  i41 = HEAP32[i131 + 1184 >> 2] | 0;
  i42 = (i41 | 0) == -1;
  if (i42) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i76 + (i41 << 2) >> 2]);
  i43 = HEAP32[i131 + 1188 >> 2] | 0;
  i49 = (i43 | 0) == -1;
  if (i49) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i76 + (i43 << 2) >> 2]);
  i50 = HEAP32[i131 + 1192 >> 2] | 0;
  i52 = (i50 | 0) == -1;
  if (i52) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i76 + (i50 << 2) >> 2]);
  i53 = HEAP32[i131 + 1196 >> 2] | 0;
  i55 = (i53 | 0) == -1;
  if (i55) f8 = Math_fround(1.0); else f8 = Math_fround(HEAPF32[i76 + (i53 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
  f92 = Math_fround(f5 * f95);
  f93 = Math_fround(f6 * f95);
  f94 = Math_fround(f7 * f95);
  f95 = Math_fround(f8 * f95);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  if (i3) i46 = 0; else i46 = HEAP32[i71 + (i2 << 2) >> 2] | 0;
  if (i9) i4 = 0; else i4 = HEAP32[i71 + (i4 << 2) >> 2] | 0;
  if (i11) i9 = 0; else i9 = HEAP32[i71 + (i10 << 2) >> 2] | 0;
  if (i13) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i71 + (i12 << 2) >> 2]);
  if (i15) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i71 + (i14 << 2) >> 2]);
  if (i17) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i71 + (i16 << 2) >> 2]);
  if (i24) f5 = Math_fround(1.0); else f5 = Math_fround(HEAPF32[i71 + (i23 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))))));
  f92 = Math_fround(f8 * f95);
  f93 = Math_fround(f7 * f95);
  f94 = Math_fround(f6 * f95);
  f95 = Math_fround(f5 * f95);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  if (i34) i2 = 0; else i2 = HEAP32[i71 + (i29 << 2) >> 2] | 0;
  if (i37) i3 = 0; else i3 = HEAP32[i71 + (i36 << 2) >> 2] | 0;
  if (i40) i36 = 0; else i36 = HEAP32[i71 + (i39 << 2) >> 2] | 0;
  if (i42) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i71 + (i41 << 2) >> 2]);
  if (i49) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i71 + (i43 << 2) >> 2]);
  if (i52) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i71 + (i50 << 2) >> 2]);
  if (i55) f5 = Math_fround(1.0); else f5 = Math_fround(HEAPF32[i71 + (i53 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))))));
  f92 = Math_fround(f8 * f95);
  f93 = Math_fround(f7 * f95);
  f94 = Math_fround(f6 * f95);
  f95 = Math_fround(f5 * f95);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i78 = i2;
  i40 = i3;
  i79 = i4;
  i75 = i56;
  i96 = i9;
  i97 = i64;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  i120 = i69;
 } else {
  i78 = 0;
  i46 = 0;
  i45 = 0;
  i44 = 0;
  i40 = 0;
  i79 = 0;
  i38 = 0;
  i75 = 0;
  i36 = 0;
  i96 = 0;
  i35 = 0;
  i97 = 0;
  i34 = 0;
  i33 = 0;
  i32 = 0;
  i31 = 0;
  i29 = 0;
  i28 = 0;
  i27 = 0;
  i26 = 0;
  i24 = 0;
  i23 = 0;
  i22 = 0;
  i18 = 0;
  i16 = 0;
  i15 = 0;
  i120 = 0;
  i1 = 0;
 }
 do if (i130) {
  __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi(i128, i131, 0);
  i12 = HEAP32[i128 + 4 >> 2] | 0;
  i13 = HEAP32[i128 + 8 >> 2] | 0;
  HEAP32[i171 >> 2] = HEAP32[i128 >> 2];
  HEAP32[i171 + 4 >> 2] = i12;
  HEAP32[i171 + 8 >> 2] = i13;
  i13 = HEAP32[i128 + 16 >> 2] | 0;
  i12 = HEAP32[i128 + 20 >> 2] | 0;
  i121 = HEAP32[i128 + 24 >> 2] | 0;
  HEAP32[i171 + 12 >> 2] = HEAP32[i128 + 12 >> 2];
  HEAP32[i171 + 16 >> 2] = i13;
  HEAP32[i171 + 20 >> 2] = i12;
  HEAP32[i171 + 24 >> 2] = i121;
  i121 = HEAP32[i128 + 32 >> 2] | 0;
  i12 = HEAP32[i128 + 36 >> 2] | 0;
  HEAP32[i171 + 28 >> 2] = HEAP32[i128 + 28 >> 2];
  HEAP32[i171 + 32 >> 2] = i121;
  HEAP32[i171 + 36 >> 2] = i12;
  __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi(i128, i131, 0);
  i12 = HEAP32[i128 + 4 >> 2] | 0;
  i121 = HEAP32[i128 + 8 >> 2] | 0;
  HEAP32[i172 >> 2] = HEAP32[i128 >> 2];
  HEAP32[i172 + 4 >> 2] = i12;
  HEAP32[i172 + 8 >> 2] = i121;
  i121 = HEAP32[i128 + 16 >> 2] | 0;
  i12 = HEAP32[i128 + 20 >> 2] | 0;
  i13 = HEAP32[i128 + 24 >> 2] | 0;
  HEAP32[i172 + 12 >> 2] = HEAP32[i128 + 12 >> 2];
  HEAP32[i172 + 16 >> 2] = i121;
  HEAP32[i172 + 20 >> 2] = i12;
  HEAP32[i172 + 24 >> 2] = i13;
  i13 = HEAP32[i128 + 32 >> 2] | 0;
  i12 = HEAP32[i128 + 36 >> 2] | 0;
  HEAP32[i172 + 28 >> 2] = HEAP32[i128 + 28 >> 2];
  HEAP32[i172 + 32 >> 2] = i13;
  HEAP32[i172 + 36 >> 2] = i12;
  i12 = HEAP32[i70 >> 2] | 0;
  i13 = (i12 | 0) == -1;
  if (i13) i64 = 0; else i64 = HEAP32[i71 + (i12 << 2) >> 2] | 0;
  i17 = HEAP32[i131 + 1092 >> 2] | 0;
  i37 = (i17 | 0) == -1;
  if (i37) i9 = 0; else i9 = HEAP32[i71 + (i17 << 2) >> 2] | 0;
  i39 = HEAP32[i131 + 1096 >> 2] | 0;
  i41 = (i39 | 0) == -1;
  if (i41) i10 = 0; else i10 = HEAP32[i71 + (i39 << 2) >> 2] | 0;
  i42 = HEAP32[i131 + 1100 >> 2] | 0;
  i43 = (i42 | 0) == -1;
  if (i43) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i71 + (i42 << 2) >> 2]);
  i49 = HEAP32[i131 + 1104 >> 2] | 0;
  i50 = (i49 | 0) == -1;
  if (i50) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i71 + (i49 << 2) >> 2]);
  i52 = HEAP32[i131 + 1108 >> 2] | 0;
  i53 = (i52 | 0) == -1;
  if (i53) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i71 + (i52 << 2) >> 2]);
  i55 = HEAP32[i131 + 1112 >> 2] | 0;
  i56 = (i55 | 0) == -1;
  if (i56) f5 = Math_fround(1.0); else f5 = Math_fround(HEAPF32[i71 + (i55 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f8 * f8) + Math_fround(f5 * f5))))));
  f92 = Math_fround(f6 * f95);
  f93 = Math_fround(f7 * f95);
  f94 = Math_fround(f8 * f95);
  f95 = Math_fround(f5 * f95);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  if (i13) i14 = 0; else i14 = HEAP32[i76 + (i12 << 2) >> 2] | 0;
  if (i37) i13 = 0; else i13 = HEAP32[i76 + (i17 << 2) >> 2] | 0;
  if (i41) i12 = 0; else i12 = HEAP32[i76 + (i39 << 2) >> 2] | 0;
  if (i43) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i76 + (i42 << 2) >> 2]);
  if (i50) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i76 + (i49 << 2) >> 2]);
  if (i53) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i76 + (i52 << 2) >> 2]);
  if (i56) f5 = Math_fround(1.0); else f5 = Math_fround(HEAPF32[i76 + (i55 << 2) >> 2]);
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))))));
  f92 = Math_fround(f8 * f95);
  f93 = Math_fround(f7 * f95);
  f94 = Math_fround(f6 * f95);
  f95 = Math_fround(f5 * f95);
  HEAP32[i168 >> 2] = i14;
  i56 = i168 + 4 | 0;
  HEAP32[i56 >> 2] = i13;
  i121 = i168 + 8 | 0;
  HEAP32[i121 >> 2] = i12;
  HEAPF32[i168 + 12 >> 2] = f92;
  i69 = i168 + 16 | 0;
  HEAPF32[i69 >> 2] = f93;
  i70 = i168 + 20 | 0;
  HEAPF32[i70 >> 2] = f94;
  i71 = i168 + 24 | 0;
  HEAPF32[i71 >> 2] = f95;
  HEAP32[i168 + 28 >> 2] = 1065353216;
  HEAP32[i168 + 32 >> 2] = 1065353216;
  HEAP32[i168 + 36 >> 2] = 1065353216;
  i12 = i64;
 } else {
  if (!i129) {
   i56 = i168 + 4 | 0;
   i121 = i168 + 8 | 0;
   i69 = i168 + 16 | 0;
   i70 = i168 + 20 | 0;
   i71 = i168 + 24 | 0;
   i12 = 0;
   i9 = 0;
   i10 = 0;
   i11 = 0;
   i3 = 0;
   i4 = 0;
   i2 = 0;
   break;
  }
  __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi(i128, i131, 7);
  i53 = HEAP32[i128 + 4 >> 2] | 0;
  i13 = HEAP32[i128 + 8 >> 2] | 0;
  HEAP32[i171 >> 2] = HEAP32[i128 >> 2];
  i50 = i171 + 4 | 0;
  HEAP32[i50 >> 2] = i53;
  i53 = i171 + 8 | 0;
  HEAP32[i53 >> 2] = i13;
  i13 = i171 + 12 | 0;
  i17 = HEAP32[i128 + 16 >> 2] | 0;
  i37 = HEAP32[i128 + 20 >> 2] | 0;
  i39 = HEAP32[i128 + 24 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i128 + 12 >> 2];
  i14 = i171 + 16 | 0;
  HEAP32[i14 >> 2] = i17;
  i17 = i171 + 20 | 0;
  HEAP32[i17 >> 2] = i37;
  i37 = i171 + 24 | 0;
  HEAP32[i37 >> 2] = i39;
  i39 = HEAP32[i128 + 32 >> 2] | 0;
  i55 = HEAP32[i128 + 36 >> 2] | 0;
  HEAP32[i171 + 28 >> 2] = HEAP32[i128 + 28 >> 2];
  HEAP32[i171 + 32 >> 2] = i39;
  HEAP32[i171 + 36 >> 2] = i55;
  __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi(i128, i131, 7);
  i55 = HEAP32[i128 + 4 >> 2] | 0;
  i39 = HEAP32[i128 + 8 >> 2] | 0;
  HEAP32[i172 >> 2] = HEAP32[i128 >> 2];
  i52 = i172 + 4 | 0;
  HEAP32[i52 >> 2] = i55;
  i55 = i172 + 8 | 0;
  HEAP32[i55 >> 2] = i39;
  i39 = i172 + 12 | 0;
  i42 = HEAP32[i128 + 16 >> 2] | 0;
  i43 = HEAP32[i128 + 20 >> 2] | 0;
  i64 = HEAP32[i128 + 24 >> 2] | 0;
  HEAP32[i39 >> 2] = HEAP32[i128 + 12 >> 2];
  i41 = i172 + 16 | 0;
  HEAP32[i41 >> 2] = i42;
  i42 = i172 + 20 | 0;
  HEAP32[i42 >> 2] = i43;
  i43 = i172 + 24 | 0;
  HEAP32[i43 >> 2] = i64;
  i64 = HEAP32[i128 + 32 >> 2] | 0;
  i56 = HEAP32[i128 + 36 >> 2] | 0;
  HEAP32[i172 + 28 >> 2] = HEAP32[i128 + 28 >> 2];
  HEAP32[i172 + 32 >> 2] = i64;
  HEAP32[i172 + 36 >> 2] = i56;
  HEAP32[i168 >> 2] = i113;
  i56 = i168 + 4 | 0;
  HEAP32[i56 >> 2] = i114;
  i64 = i168 + 8 | 0;
  HEAP32[i64 >> 2] = i115;
  i49 = i168 + 12 | 0;
  HEAPF32[i49 >> 2] = f119;
  i69 = i168 + 16 | 0;
  HEAPF32[i69 >> 2] = f118;
  i70 = i168 + 20 | 0;
  HEAPF32[i70 >> 2] = f117;
  i71 = i168 + 24 | 0;
  HEAPF32[i71 >> 2] = f112;
  HEAP32[i168 + 28 >> 2] = 1065353216;
  HEAP32[i168 + 32 >> 2] = 1065353216;
  HEAP32[i168 + 36 >> 2] = 1065353216;
  f51 = Math_fround(HEAPF32[i37 >> 2]);
  f89 = Math_fround(HEAPF32[i13 >> 2]);
  f85 = Math_fround(f51 * f89);
  f93 = Math_fround(HEAPF32[i14 >> 2]);
  f48 = Math_fround(HEAPF32[i17 >> 2]);
  f94 = Math_fround(Math_fround(f89 * f93) - Math_fround(f51 * f48));
  f57 = Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(-.5)) + Math_fround(f93 * f93));
  f85 = Math_fround(f85 + Math_fround(f93 * f48));
  f94 = Math_fround(f94 + f94);
  f57 = Math_fround(f57 + f57);
  f85 = Math_fround(f85 + f85);
  f54 = Math_fround(f57 * Math_fround(0.0));
  f86 = Math_fround(f85 * Math_fround(0.0));
  f95 = Math_fround(f94 * Math_fround(0.0));
  f84 = Math_fround(f94 - f54);
  f54 = Math_fround(f54 - f85);
  f87 = Math_fround(f86 - f95);
  f86 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f94 * f94)) + Math_fround(Math_fround(f85 * f85) + Math_fround(0.0))))) + Math_fround(Math_fround(f57 + f95) + Math_fround(f86 + Math_fround(0.0))));
  f95 = Math_fround(Math_fround(Math_fround(Math_fround(f89 * f87) - Math_fround(f48 * f86)) - Math_fround(f51 * f84)) - Math_fround(f93 * f54));
  f57 = Math_fround(Math_fround(Math_fround(Math_fround(f51 * f86) - Math_fround(f89 * f54)) - Math_fround(f48 * f84)) - Math_fround(f93 * f87));
  f85 = Math_fround(Math_fround(Math_fround(Math_fround(f93 * f84) - Math_fround(f48 * f87)) - Math_fround(f89 * f86)) - Math_fround(f51 * f54));
  f87 = Math_fround(Math_fround(Math_fround(Math_fround(f48 * f54) - Math_fround(f89 * f84)) - Math_fround(f93 * f86)) - Math_fround(f51 * f87));
  i116 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  i121 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f87 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f85 = Math_fround((HEAP32[tempDoublePtr >> 2] = i116 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f95 = Math_fround(f87 * f87);
  f51 = (HEAP32[tempDoublePtr >> 2] = i121, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + f95) + Math_fround(Math_fround(f57 * f57) + Math_fround(f85 * f85))))));
  f51 = Math_fround(f95 * f51);
  f85 = Math_fround(f95 * f85);
  f57 = Math_fround(f95 * f57);
  HEAPF32[i13 >> 2] = Math_fround(f95 * f87);
  HEAPF32[i14 >> 2] = f51;
  HEAPF32[i17 >> 2] = f85;
  HEAPF32[i37 >> 2] = f57;
  f57 = Math_fround(HEAPF32[i43 >> 2]);
  f85 = Math_fround(HEAPF32[i39 >> 2]);
  f51 = Math_fround(f57 * f85);
  f87 = Math_fround(HEAPF32[i41 >> 2]);
  f95 = Math_fround(HEAPF32[i42 >> 2]);
  f86 = Math_fround(Math_fround(f85 * f87) - Math_fround(f57 * f95));
  f93 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(-.5)) + Math_fround(f87 * f87));
  f51 = Math_fround(f51 + Math_fround(f87 * f95));
  f86 = Math_fround(f86 + f86);
  f93 = Math_fround(f93 + f93);
  f51 = Math_fround(f51 + f51);
  f84 = Math_fround(f93 * Math_fround(0.0));
  f89 = Math_fround(f51 * Math_fround(0.0));
  f54 = Math_fround(f86 * Math_fround(0.0));
  f48 = Math_fround(f86 - f84);
  f84 = Math_fround(f84 - f51);
  f94 = Math_fround(f89 - f54);
  f89 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f93 * f93) + Math_fround(f86 * f86)) + Math_fround(Math_fround(f51 * f51) + Math_fround(0.0))))) + Math_fround(Math_fround(f93 + f54) + Math_fround(f89 + Math_fround(0.0))));
  f54 = Math_fround(Math_fround(Math_fround(Math_fround(f85 * f94) - Math_fround(f95 * f89)) - Math_fround(f57 * f48)) - Math_fround(f87 * f84));
  f93 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f89) - Math_fround(f85 * f84)) - Math_fround(f95 * f48)) - Math_fround(f87 * f94));
  f51 = Math_fround(Math_fround(Math_fround(Math_fround(f87 * f48) - Math_fround(f95 * f94)) - Math_fround(f85 * f89)) - Math_fround(f57 * f84));
  f94 = Math_fround(Math_fround(Math_fround(Math_fround(f95 * f84) - Math_fround(f85 * f48)) - Math_fround(f87 * f89)) - Math_fround(f57 * f94));
  i121 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i116 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f94 = Math_fround((HEAP32[tempDoublePtr >> 2] = i116 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f51 = Math_fround((HEAP32[tempDoublePtr >> 2] = i121 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f54 = Math_fround(f94 * f94);
  f57 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + f54) + Math_fround(Math_fround(f93 * f93) + Math_fround(f51 * f51))))));
  f57 = Math_fround(f54 * f57);
  f51 = Math_fround(f54 * f51);
  f93 = Math_fround(f54 * f93);
  HEAPF32[i39 >> 2] = Math_fround(f54 * f94);
  HEAPF32[i41 >> 2] = f57;
  HEAPF32[i42 >> 2] = f51;
  HEAPF32[i43 >> 2] = f93;
  f93 = Math_fround(Math_fround(f63 * f62) - Math_fround(f60 * f61));
  f51 = Math_fround(Math_fround(f62 * f62) + Math_fround(Math_fround(f60 * f60) + Math_fround(-.5)));
  f57 = Math_fround(Math_fround(f60 * f63) + Math_fround(f62 * f61));
  f93 = Math_fround(f93 + f93);
  f51 = Math_fround(f51 + f51);
  f57 = Math_fround(f57 + f57);
  f94 = Math_fround(f51 * Math_fround(0.0));
  f54 = Math_fround(f57 * Math_fround(0.0));
  f89 = Math_fround(f93 * Math_fround(0.0));
  f87 = Math_fround(f93 - f94);
  f94 = Math_fround(f94 - f57);
  f48 = Math_fround(f54 - f89);
  f51 = Math_fround(Math_fround(Math_fround(f51 + f89) + Math_fround(f54 + Math_fround(0.0))) + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(0.0)) + Math_fround(Math_fround(f93 * f93) + Math_fround(f51 * f51))))));
  f93 = Math_fround(Math_fround(Math_fround(Math_fround(f63 * f48) - Math_fround(f61 * f51)) - Math_fround(f60 * f87)) - Math_fround(f62 * f94));
  f57 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f51) - Math_fround(f63 * f94)) - Math_fround(f61 * f87)) - Math_fround(f62 * f48));
  f54 = Math_fround(Math_fround(Math_fround(Math_fround(f62 * f87) - Math_fround(f61 * f48)) - Math_fround(f63 * f51)) - Math_fround(f60 * f94));
  f48 = Math_fround(Math_fround(Math_fround(Math_fround(f61 * f94) - Math_fround(f63 * f87)) - Math_fround(f62 * f51)) - Math_fround(f60 * f48));
  i76 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
  i121 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i116 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f48 = Math_fround((HEAP32[tempDoublePtr >> 2] = i121 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f54 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f93 = Math_fround(f48 * f48);
  f51 = (HEAP32[tempDoublePtr >> 2] = i116, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f93 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + f93) + Math_fround(Math_fround(f57 * f57) + Math_fround(f54 * f54))))));
  f48 = Math_fround(f93 * f48);
  f51 = Math_fround(f93 * f51);
  f54 = Math_fround(f93 * f54);
  f57 = Math_fround(f93 * f57);
  f93 = Math_fround(HEAPF32[i71 >> 2]);
  f87 = Math_fround(HEAPF32[i49 >> 2]);
  f94 = Math_fround(f93 * f87);
  f89 = Math_fround(HEAPF32[i69 >> 2]);
  f85 = Math_fround(HEAPF32[i70 >> 2]);
  f84 = Math_fround(Math_fround(f87 * f89) - Math_fround(f93 * f85));
  f95 = Math_fround(Math_fround(Math_fround(f93 * f93) + Math_fround(-.5)) + Math_fround(f89 * f89));
  f94 = Math_fround(f94 + Math_fround(f89 * f85));
  f84 = Math_fround(f84 + f84);
  f95 = Math_fround(f95 + f95);
  f94 = Math_fround(f94 + f94);
  f86 = Math_fround(f95 * Math_fround(0.0));
  f90 = Math_fround(f94 * Math_fround(0.0));
  f91 = Math_fround(f84 * Math_fround(0.0));
  f88 = Math_fround(f84 - f86);
  f86 = Math_fround(f86 - f94);
  f92 = Math_fround(f90 - f91);
  f90 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f95 * f95) + Math_fround(f84 * f84)) + Math_fround(Math_fround(f94 * f94) + Math_fround(0.0))))) + Math_fround(Math_fround(f95 + f91) + Math_fround(f90 + Math_fround(0.0))));
  f91 = Math_fround(Math_fround(Math_fround(Math_fround(f87 * f92) - Math_fround(f85 * f90)) - Math_fround(f93 * f88)) - Math_fround(f89 * f86));
  f95 = Math_fround(Math_fround(Math_fround(Math_fround(f93 * f90) - Math_fround(f87 * f86)) - Math_fround(f85 * f88)) - Math_fround(f89 * f92));
  f94 = Math_fround(Math_fround(Math_fround(Math_fround(f89 * f88) - Math_fround(f85 * f92)) - Math_fround(f87 * f90)) - Math_fround(f93 * f86));
  f92 = Math_fround(Math_fround(Math_fround(Math_fround(f85 * f86) - Math_fround(f87 * f88)) - Math_fround(f89 * f90)) - Math_fround(f93 * f92));
  i116 = (HEAPF32[tempDoublePtr >> 2] = f91, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i121 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f92 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f94 = Math_fround((HEAP32[tempDoublePtr >> 2] = i116 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f91 = Math_fround(f92 * f92);
  f93 = (HEAP32[tempDoublePtr >> 2] = i121, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f91 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f93 * f93) + f91) + Math_fround(Math_fround(f95 * f95) + Math_fround(f94 * f94))))));
  f93 = Math_fround(f91 * f93);
  f94 = Math_fround(f91 * f94);
  f95 = Math_fround(f91 * f95);
  HEAPF32[i49 >> 2] = Math_fround(f91 * f92);
  HEAPF32[i69 >> 2] = f93;
  HEAPF32[i70 >> 2] = f94;
  HEAPF32[i71 >> 2] = f95;
  do if (i170) {
   if (!(HEAP8[i131 + 1734 >> 0] | 0)) {
    i3 = i77;
    break;
   }
   f66 = Math_fround(HEAPF32[i131 + 968 >> 2]);
   f174 = Math_fround(HEAPF32[i131 + 972 >> 2]);
   f85 = Math_fround(HEAPF32[i131 + 976 >> 2]);
   f86 = Math_fround(f19 * f66);
   f68 = Math_fround(f20 * f174);
   f87 = Math_fround(f21 * f85);
   f180 = (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f83 = (HEAP32[tempDoublePtr >> 2] = i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f178 = (HEAP32[tempDoublePtr >> 2] = i104, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f88 = (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f94 = Math_fround(f88 * Math_fround(-2.0));
   f93 = Math_fround(Math_fround(f83 * Math_fround(f180 * Math_fround(2.0))) - Math_fround(f178 * f94));
   f94 = Math_fround(Math_fround(f88 * f94) - Math_fround(f83 * Math_fround(f83 * Math_fround(2.0))));
   f88 = Math_fround(Math_fround(Math_fround(f83 * Math_fround(-2.0)) * f178) - Math_fround(Math_fround(f180 * Math_fround(-2.0)) * f88));
   f87 = Math_fround(Math_fround(f68 + Math_fround(f93 * f86)) + Math_fround(Math_fround(f94 * f68) + Math_fround(f88 * f87)));
   f68 = (HEAP32[tempDoublePtr >> 2] = i99, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f87 = Math_fround(f68 + f87);
   f86 = Math_fround(HEAPF32[i131 + 980 >> 2]);
   f180 = Math_fround(HEAPF32[i131 + 992 >> 2]);
   f178 = Math_fround(HEAPF32[i131 + 984 >> 2]);
   f83 = Math_fround(HEAPF32[i131 + 988 >> 2]);
   f186 = Math_fround(HEAPF32[i131 + 996 >> 2]);
   f184 = Math_fround(HEAPF32[i131 + 1e3 >> 2]);
   f8 = Math_fround(HEAPF32[i131 + 1004 >> 2]);
   f65 = Math_fround(HEAPF32[i131 + 1008 >> 2]);
   f90 = Math_fround(HEAPF32[i131 + 1012 >> 2]);
   f74 = Math_fround(HEAPF32[i131 + 1016 >> 2]);
   f84 = Math_fround(f20 * f90);
   f88 = Math_fround(f68 + Math_fround(Math_fround(f84 + Math_fround(f93 * Math_fround(f19 * f65))) + Math_fround(Math_fround(f94 * f84) + Math_fround(f88 * Math_fround(f21 * f74)))));
   f84 = Math_fround(HEAPF32[i131 + 1020 >> 2]);
   f94 = Math_fround(HEAPF32[i131 + 1032 >> 2]);
   f93 = Math_fround(HEAPF32[i131 + 1024 >> 2]);
   f68 = Math_fround(HEAPF32[i131 + 1028 >> 2]);
   f181 = Math_fround(HEAPF32[i131 + 1036 >> 2]);
   f179 = Math_fround(HEAPF32[i131 + 1040 >> 2]);
   f5 = Math_fround(HEAPF32[i131 + 1044 >> 2]);
   f80 = Math_fround(HEAPF32[i131 + 92 >> 2]);
   i3 = Math_fround(Math_abs(Math_fround(f186))) < Math_fround(9.99999971e-10);
   i121 = Math_fround(Math_abs(Math_fround(f184))) < Math_fround(9.99999971e-10);
   i116 = Math_fround(Math_abs(Math_fround(f8))) < Math_fround(9.99999971e-10);
   f185 = Math_fround(Math_fround(1.0) / f186);
   f185 = i3 ? Math_fround(1.0) : f185;
   f183 = Math_fround(Math_fround(1.0) / f184);
   f183 = i121 ? Math_fround(1.0) : f183;
   f82 = Math_fround(Math_fround(1.0) / f8);
   f82 = i116 ? Math_fround(1.0) : f82;
   f176 = Math_fround(HEAPF32[i131 + 68 >> 2]);
   f91 = Math_fround(HEAPF32[i131 + 72 >> 2]);
   f89 = Math_fround(HEAPF32[i131 + 76 >> 2]);
   f175 = Math_fround(-f176);
   f73 = Math_fround(-f91);
   f6 = Math_fround(-f89);
   f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 84 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 80 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f177 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 88 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f72 = Math_fround(f19 * Math_fround(-2.0));
   f67 = Math_fround(f19 * Math_fround(2.0));
   f7 = Math_fround(f80 * f72);
   f92 = Math_fround(f177 * Math_fround(2.0));
   f81 = Math_fround(f177 * Math_fround(-2.0));
   f182 = Math_fround(f80 * f81);
   f95 = Math_fround(f21 * Math_fround(-2.0));
   f20 = Math_fround(f21 * Math_fround(2.0));
   f80 = Math_fround(f80 * f95);
   f176 = Math_fround(f186 * Math_fround(f185 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f19 * f72) - Math_fround(f177 * f92)) * f175) - f176) + Math_fround(Math_fround(Math_fround(Math_fround(f20 * f177) - f7) * f6) + Math_fround(Math_fround(f182 - Math_fround(f19 * f95)) * f73)))));
   f20 = Math_fround(f184 * Math_fround(f183 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f21 * f67) - f182) * f175) - f91) + Math_fround(Math_fround(Math_fround(f80 - Math_fround(f177 * f72)) * f6) + Math_fround(Math_fround(Math_fround(f177 * f81) - Math_fround(f21 * f20)) * f73)))));
   f73 = Math_fround(f8 * Math_fround(f82 * Math_fround(Math_fround(Math_fround(Math_fround(f7 - Math_fround(f21 * f81)) * f175) - f89) + Math_fround(Math_fround(Math_fround(Math_fround(f21 * f95) - Math_fround(f19 * f67)) * f6) + Math_fround(Math_fround(Math_fround(f19 * f92) - f80) * f73)))));
   f80 = Math_fround(f178 * Math_fround(-2.0));
   f92 = Math_fround(f178 * Math_fround(2.0));
   f19 = Math_fround(f180 * f80);
   f6 = Math_fround(f83 * Math_fround(2.0));
   f67 = Math_fround(f83 * Math_fround(-2.0));
   f95 = Math_fround(f180 * f67);
   f21 = Math_fround(f86 * Math_fround(-2.0));
   f89 = Math_fround(f86 * Math_fround(2.0));
   f180 = Math_fround(f180 * f21);
   f66 = Math_fround(f25 * Math_fround(f66 + Math_fround(Math_fround(f176 + Math_fround(Math_fround(Math_fround(f178 * f80) - Math_fround(f83 * f6)) * f176)) + Math_fround(Math_fround(Math_fround(Math_fround(f89 * f83) - f19) * f73) + Math_fround(Math_fround(f95 - Math_fround(f21 * f178)) * f20)))));
   f89 = Math_fround(f30 * Math_fround(f174 + Math_fround(Math_fround(f20 + Math_fround(Math_fround(Math_fround(f86 * f92) - f95) * f176)) + Math_fround(Math_fround(Math_fround(f180 - Math_fround(f80 * f83)) * f73) + Math_fround(Math_fround(Math_fround(f83 * f67) - Math_fround(f86 * f89)) * f20)))));
   f20 = Math_fround(f47 * Math_fround(f85 + Math_fround(Math_fround(f73 + Math_fround(Math_fround(f19 - Math_fround(f86 * f67)) * f176)) + Math_fround(Math_fround(Math_fround(Math_fround(f86 * f21) - Math_fround(f178 * f92)) * f73) + Math_fround(Math_fround(Math_fround(f178 * f6) - f180) * f20)))));
   f180 = (HEAP32[tempDoublePtr >> 2] = i109, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i108, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f178 = (HEAP32[tempDoublePtr >> 2] = i111, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = (HEAP32[tempDoublePtr >> 2] = i110, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f92 = Math_fround(f73 * Math_fround(-2.0));
   f21 = Math_fround(Math_fround(f6 * Math_fround(f180 * Math_fround(2.0))) - Math_fround(f178 * f92));
   f92 = Math_fround(Math_fround(f73 * f92) - Math_fround(f6 * Math_fround(f6 * Math_fround(2.0))));
   f73 = Math_fround(Math_fround(Math_fround(f6 * Math_fround(-2.0)) * f178) - Math_fround(Math_fround(f180 * Math_fround(-2.0)) * f73));
   f89 = Math_fround(Math_fround(f89 + Math_fround(f21 * f66)) + Math_fround(Math_fround(f73 * f20) + Math_fround(f92 * f89)));
   f20 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f89 = Math_fround(f20 + f89);
   f66 = Math_fround(HEAPF32[i131 + 156 >> 2]);
   i116 = Math_fround(Math_abs(Math_fround(f181))) < Math_fround(9.99999971e-10);
   i121 = Math_fround(Math_abs(Math_fround(f179))) < Math_fround(9.99999971e-10);
   i3 = Math_fround(Math_abs(Math_fround(f5))) < Math_fround(9.99999971e-10);
   f180 = Math_fround(Math_fround(1.0) / f181);
   f180 = i116 ? Math_fround(1.0) : f180;
   f178 = Math_fround(Math_fround(1.0) / f179);
   f178 = i121 ? Math_fround(1.0) : f178;
   f6 = Math_fround(Math_fround(1.0) / f5);
   f6 = i3 ? Math_fround(1.0) : f6;
   f86 = Math_fround(HEAPF32[i131 + 132 >> 2]);
   f176 = Math_fround(HEAPF32[i131 + 136 >> 2]);
   f67 = Math_fround(HEAPF32[i131 + 140 >> 2]);
   f19 = Math_fround(-f86);
   f85 = Math_fround(-f176);
   f83 = Math_fround(-f67);
   f80 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 148 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f95 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 144 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f174 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i131 + 152 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f175 = Math_fround(f80 * Math_fround(-2.0));
   f81 = Math_fround(f80 * Math_fround(2.0));
   f7 = Math_fround(f66 * f175);
   f82 = Math_fround(f174 * Math_fround(2.0));
   f8 = Math_fround(f174 * Math_fround(-2.0));
   f177 = Math_fround(f66 * f8);
   f72 = Math_fround(f95 * Math_fround(-2.0));
   f91 = Math_fround(f95 * Math_fround(2.0));
   f66 = Math_fround(f66 * f72);
   f86 = Math_fround(f181 * Math_fround(f180 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f80 * f175) - Math_fround(f174 * f82)) * f19) - f86) + Math_fround(Math_fround(Math_fround(Math_fround(f91 * f174) - f7) * f83) + Math_fround(Math_fround(f177 - Math_fround(f80 * f72)) * f85)))));
   f91 = Math_fround(f179 * Math_fround(f178 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f95 * f81) - f177) * f19) - f176) + Math_fround(Math_fround(Math_fround(f66 - Math_fround(f174 * f175)) * f83) + Math_fround(Math_fround(Math_fround(f174 * f8) - Math_fround(f95 * f91)) * f85)))));
   f85 = Math_fround(f5 * Math_fround(f6 * Math_fround(Math_fround(Math_fround(Math_fround(f7 - Math_fround(f95 * f8)) * f19) - f67) + Math_fround(Math_fround(Math_fround(Math_fround(f95 * f72) - Math_fround(f80 * f81)) * f83) + Math_fround(Math_fround(Math_fround(f80 * f82) - f66) * f85)))));
   f66 = Math_fround(f93 * Math_fround(-2.0));
   f82 = Math_fround(f93 * Math_fround(2.0));
   f80 = Math_fround(f94 * f66);
   f83 = Math_fround(f68 * Math_fround(2.0));
   f81 = Math_fround(f68 * Math_fround(-2.0));
   f72 = Math_fround(f94 * f81);
   f95 = Math_fround(f84 * Math_fround(-2.0));
   f67 = Math_fround(f84 * Math_fround(2.0));
   f94 = Math_fround(f94 * f95);
   f90 = Math_fround(f30 * Math_fround(f90 + Math_fround(Math_fround(f91 + Math_fround(Math_fround(Math_fround(f84 * f82) - f72) * f86)) + Math_fround(Math_fround(Math_fround(f94 - Math_fround(f66 * f68)) * f85) + Math_fround(Math_fround(Math_fround(f68 * f81) - Math_fround(f84 * f67)) * f91)))));
   f90 = Math_fround(f20 + Math_fround(Math_fround(f90 + Math_fround(f21 * Math_fround(f25 * Math_fround(f65 + Math_fround(Math_fround(f86 + Math_fround(Math_fround(Math_fround(f93 * f66) - Math_fround(f68 * f83)) * f86)) + Math_fround(Math_fround(Math_fround(Math_fround(f67 * f68) - f80) * f85) + Math_fround(Math_fround(f72 - Math_fround(f95 * f93)) * f91))))))) + Math_fround(Math_fround(f73 * Math_fround(f47 * Math_fround(f74 + Math_fround(Math_fround(f85 + Math_fround(Math_fround(f80 - Math_fround(f84 * f81)) * f86)) + Math_fround(Math_fround(Math_fround(Math_fround(f84 * f95) - Math_fround(f93 * f82)) * f85) + Math_fround(Math_fround(Math_fround(f93 * f83) - f94) * f91)))))) + Math_fround(f92 * f90))));
   f92 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f91 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f94 = Math_fround(f61 * Math_fround(-2.0));
   f83 = Math_fround(Math_fround(f63 * Math_fround(f62 * Math_fround(2.0))) - Math_fround(f60 * f94));
   f94 = Math_fround(Math_fround(f61 * f94) - Math_fround(f63 * Math_fround(f63 * Math_fround(2.0))));
   f93 = Math_fround(Math_fround(f60 * Math_fround(f63 * Math_fround(-2.0))) - Math_fround(f61 * Math_fround(f62 * Math_fround(-2.0))));
   f91 = Math_fround(Math_fround(f91 + Math_fround(f83 * f92)) + Math_fround(Math_fround(f94 * f91) + Math_fround(f93 * (HEAP32[tempDoublePtr >> 2] = i96, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
   f92 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f91 = Math_fround(f92 + f91);
   f85 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f82 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f93 = Math_fround(f92 + Math_fround(Math_fround(f82 + Math_fround(f83 * f85)) + Math_fround(Math_fround(f94 * f82) + Math_fround(f93 * (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
   f82 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f94 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f85 = Math_fround(f117 * Math_fround(-2.0));
   f83 = Math_fround(Math_fround(f119 * Math_fround(f118 * Math_fround(2.0))) - Math_fround(f112 * f85));
   f85 = Math_fround(Math_fround(f117 * f85) - Math_fround(f119 * Math_fround(f119 * Math_fround(2.0))));
   f95 = Math_fround(Math_fround(f112 * Math_fround(f119 * Math_fround(-2.0))) - Math_fround(f117 * Math_fround(f118 * Math_fround(-2.0))));
   f94 = Math_fround(Math_fround(f94 + Math_fround(f83 * f82)) + Math_fround(Math_fround(f85 * f94) + Math_fround(f95 * (HEAP32[tempDoublePtr >> 2] = i97, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
   f82 = (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f94 = Math_fround(f82 + f94);
   f84 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f86 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f95 = Math_fround(f82 + Math_fround(Math_fround(f86 + Math_fround(f83 * f84)) + Math_fround(Math_fround(f85 * f86) + Math_fround(f95 * (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
   f88 = f87 < f88 ? f87 : f88;
   f87 = Math_fround(HEAPF32[i50 >> 2]);
   HEAPF32[i50 >> 2] = f87 < f88 ? f87 : f88;
   f90 = f89 < f90 ? f89 : f90;
   f89 = Math_fround(HEAPF32[i52 >> 2]);
   HEAPF32[i52 >> 2] = f89 < f90 ? f89 : f90;
   f93 = f91 < f93 ? f91 : f93;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f92 < f93 ? f92 : f93, HEAP32[tempDoublePtr >> 2] | 0);
   f95 = f94 < f95 ? f94 : f95;
   f94 = Math_fround(HEAPF32[i56 >> 2]);
   HEAPF32[i56 >> 2] = f94 < f95 ? f94 : f95;
  } else i3 = i77; while (0);
  f186 = Math_fround(HEAPF32[i131 + 1076 >> 2]);
  f5 = Math_fround(Math_fround(HEAPF32[i131 + 1072 >> 2]) * Math_fround(.0174532924));
  f21 = Math_fround(Math_fround(Math_abs(Math_fround(f5))) + Math_fround(3.14159274));
  f21 = Math_fround(Math_fround(f21 - Math_fround(Math_fround(_truncf(Math_fround(f21 / Math_fround(6.28318548)))) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f5 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ^ (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
  f21 = Math_fround(f5 + Math_fround(-.25));
  f5 = Math_fround(f5 + Math_fround(0.0));
  f185 = Math_fround(+_roundf(+f21));
  f185 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f21 - f185))));
  f5 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f5 - Math_fround(+_roundf(+f5))))));
  f21 = Math_fround(f185 * f185);
  f7 = Math_fround(f5 * f5);
  f47 = Math_fround(f21 * f21);
  f6 = Math_fround(f7 * f7);
  f7 = Math_fround(Math_fround(f185 * Math_fround(Math_fround(Math_fround(f47 * f47) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f21 * Math_fround(41.3416595))) + Math_fround(f47 * Math_fround(Math_fround(81.6018218) - Math_fround(f21 * Math_fround(76.5686187))))))) / Math_fround(f5 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))));
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(0.0)) + Math_fround(1.0)))));
  f5 = Math_fround(f6 * Math_fround(0.0));
  f7 = Math_fround(f6 * f7);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i121 = HEAP16[i131 + 1732 >> 1] | 0;
  f21 = Math_fround(HEAPF32[i50 >> 2]);
  f47 = Math_fround(f186 - f21);
  f47 = (i121 & 255) << 24 >> 24 == 0 ? f186 : f47;
  if ((i121 & 65535) < 256) {
   f25 = Math_fround(0.0);
   f30 = Math_fround(0.0);
  } else {
   f25 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i171 >> 2]));
   f30 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i53 >> 2]));
  }
  if (!(HEAP8[i131 + 1731 >> 0] | 0)) {
   f5 = Math_fround(HEAPF32[i13 >> 2]);
   f8 = Math_fround(HEAPF32[i37 >> 2]);
   f19 = Math_fround(HEAPF32[i14 >> 2]);
   i4 = i2;
   f20 = Math_fround(HEAPF32[i17 >> 2]);
  } else {
   i76 = HEAP32[i13 >> 2] | 0;
   i116 = HEAP32[i14 >> 2] | 0;
   i121 = HEAP32[i17 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i37 >> 2]);
   f183 = (HEAP32[tempDoublePtr >> 2] = i76 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f180 = Math_fround(f7 * f183);
   f20 = Math_fround(f6 * f8);
   f19 = (HEAP32[tempDoublePtr >> 2] = i116 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f181 = Math_fround(f5 * f19);
   f182 = (HEAP32[tempDoublePtr >> 2] = i121 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f184 = Math_fround(f5 * f182);
   f185 = Math_fround(f5 * f183);
   f186 = Math_fround(f5 * f8);
   f5 = Math_fround(Math_fround(Math_fround(f180 - Math_fround(f6 * f182)) - f186) - f181);
   f20 = Math_fround(Math_fround(Math_fround(f20 - f185) - f184) - Math_fround(f7 * f19));
   f186 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f7 * f182)) - Math_fround(f6 * f183)) - f186);
   f19 = Math_fround(Math_fround(Math_fround(f184 - f185) - Math_fround(f6 * f19)) - Math_fround(f7 * f8));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f19 = (HEAP32[tempDoublePtr >> 2] = i12 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f186 = Math_fround(f19 * f19);
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f7 * f7);
   f5 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f186 + f6) + Math_fround(Math_fround(f20 * f20) + Math_fround(f5 * f5))))));
   f19 = Math_fround(f6 * f19);
   f7 = Math_fround(f6 * f7);
   f5 = Math_fround(f6 * f5);
   f6 = Math_fround(f6 * f20);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   f5 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i116, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i121, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
  f186 = Math_fround(HEAPF32[i171 >> 2]);
  f182 = Math_fround(f47 + f21);
  f180 = Math_fround(f30 + Math_fround(HEAPF32[i53 >> 2]));
  HEAPF32[i171 >> 2] = Math_fround(f25 + f186);
  HEAPF32[i50 >> 2] = f182;
  HEAPF32[i53 >> 2] = f180;
  f180 = Math_fround(HEAPF32[i172 >> 2]);
  f182 = Math_fround(HEAPF32[i52 >> 2]);
  f182 = Math_fround(f47 + f182);
  f186 = Math_fround(f30 + Math_fround(HEAPF32[i55 >> 2]));
  HEAPF32[i172 >> 2] = Math_fround(f25 + f180);
  HEAPF32[i52 >> 2] = f182;
  HEAPF32[i55 >> 2] = f186;
  f186 = Math_fround(f59 + f25);
  f182 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f47);
  f180 = Math_fround(f58 + f30);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  f180 = Math_fround(HEAPF32[i168 >> 2]);
  f182 = Math_fround(HEAPF32[i56 >> 2]);
  f182 = Math_fround(f47 + f182);
  f186 = Math_fround(f30 + Math_fround(HEAPF32[i64 >> 2]));
  HEAPF32[i168 >> 2] = Math_fround(f25 + f180);
  HEAPF32[i56 >> 2] = f182;
  HEAPF32[i64 >> 2] = f186;
  f186 = Math_fround(f7 * f5);
  f182 = Math_fround(f6 * f8);
  f180 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = Math_fround(f180 * f19);
  f178 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f6 * f20)) - Math_fround(f180 * f8)) - Math_fround(f178 * f19));
  f182 = Math_fround(Math_fround(Math_fround(f182 - Math_fround(f178 * f5)) - Math_fround(f180 * f20)) - Math_fround(f7 * f19));
  f184 = Math_fround(Math_fround(Math_fround(f184 - Math_fround(f7 * f20)) - Math_fround(f6 * f5)) - Math_fround(f178 * f8));
  f183 = Math_fround(Math_fround(Math_fround(Math_fround(f178 * f20) - Math_fround(f180 * f5)) - Math_fround(f6 * f19)) - Math_fround(f7 * f8));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f183 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = Math_fround(f183 * f183);
  f186 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(f186 * f186);
  f181 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f184 + f185) + Math_fround(Math_fround(f182 * f182) + Math_fround(f181 * f181))))));
  f186 = Math_fround(f185 * f186);
  f181 = Math_fround(f185 * f181);
  f182 = Math_fround(f185 * f182);
  HEAPF32[i13 >> 2] = Math_fround(f185 * f183);
  HEAPF32[i14 >> 2] = f186;
  HEAPF32[i17 >> 2] = f181;
  HEAPF32[i37 >> 2] = f182;
  f182 = Math_fround(HEAPF32[i39 >> 2]);
  f181 = Math_fround(f7 * f182);
  f186 = Math_fround(HEAPF32[i43 >> 2]);
  f183 = Math_fround(f6 * f186);
  f185 = Math_fround(HEAPF32[i41 >> 2]);
  f184 = Math_fround(f180 * f185);
  f179 = Math_fround(HEAPF32[i42 >> 2]);
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f6 * f179)) - Math_fround(f180 * f186)) - Math_fround(f178 * f185));
  f183 = Math_fround(Math_fround(Math_fround(f183 - Math_fround(f178 * f182)) - Math_fround(f180 * f179)) - Math_fround(f7 * f185));
  f184 = Math_fround(Math_fround(Math_fround(f184 - Math_fround(f7 * f179)) - Math_fround(f6 * f182)) - Math_fround(f178 * f186));
  f186 = Math_fround(Math_fround(Math_fround(Math_fround(f178 * f179) - Math_fround(f180 * f182)) - Math_fround(f6 * f185)) - Math_fround(f7 * f186));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f186 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = Math_fround(f186 * f186);
  f181 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(f181 * f181);
  f182 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f184 + f185) + Math_fround(Math_fround(f183 * f183) + Math_fround(f182 * f182))))));
  f181 = Math_fround(f185 * f181);
  f182 = Math_fround(f185 * f182);
  f183 = Math_fround(f185 * f183);
  HEAPF32[i39 >> 2] = Math_fround(f185 * f186);
  HEAPF32[i41 >> 2] = f181;
  HEAPF32[i42 >> 2] = f182;
  HEAPF32[i43 >> 2] = f183;
  f183 = Math_fround(Math_fround(Math_fround(Math_fround(f48 * f7) - Math_fround(f54 * f6)) - Math_fround(f57 * f180)) - Math_fround(f51 * f178));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f6) - Math_fround(f48 * f178)) - Math_fround(f54 * f180)) - Math_fround(f51 * f7));
  f181 = Math_fround(Math_fround(Math_fround(Math_fround(f51 * f180) - Math_fround(f54 * f7)) - Math_fround(f48 * f6)) - Math_fround(f57 * f178));
  f186 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f178) - Math_fround(f48 * f180)) - Math_fround(f51 * f6)) - Math_fround(f57 * f7));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f186 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f186 * f186);
  f183 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(f183 * f183);
  f184 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f181 + f185) + Math_fround(Math_fround(f182 * f182) + Math_fround(f184 * f184))))));
  f186 = Math_fround(f186 * f185);
  f183 = Math_fround(f183 * f185);
  f184 = Math_fround(f184 * f185);
  f185 = Math_fround(f182 * f185);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  f185 = Math_fround(HEAPF32[i49 >> 2]);
  f184 = Math_fround(f7 * f185);
  f183 = Math_fround(HEAPF32[i71 >> 2]);
  f186 = Math_fround(f6 * f183);
  f182 = Math_fround(HEAPF32[i69 >> 2]);
  f181 = Math_fround(f180 * f182);
  f179 = Math_fround(HEAPF32[i70 >> 2]);
  f184 = Math_fround(Math_fround(Math_fround(f184 - Math_fround(f6 * f179)) - Math_fround(f180 * f183)) - Math_fround(f178 * f182));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f178 * f185)) - Math_fround(f180 * f179)) - Math_fround(f7 * f182));
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f7 * f179)) - Math_fround(f6 * f185)) - Math_fround(f178 * f183));
  f183 = Math_fround(Math_fround(Math_fround(Math_fround(f178 * f179) - Math_fround(f180 * f185)) - Math_fround(f6 * f182)) - Math_fround(f7 * f183));
  i121 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i116 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f183 = (HEAP32[tempDoublePtr >> 2] = i76 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f183 * f183);
  f184 = (HEAP32[tempDoublePtr >> 2] = i116, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f184 * f184);
  f185 = (HEAP32[tempDoublePtr >> 2] = i121 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f181 + f182) + Math_fround(Math_fround(f186 * f186) + Math_fround(f185 * f185))))));
  f184 = Math_fround(f182 * f184);
  f185 = Math_fround(f182 * f185);
  f186 = Math_fround(f182 * f186);
  HEAPF32[i49 >> 2] = Math_fround(f182 * f183);
  HEAPF32[i69 >> 2] = f184;
  HEAPF32[i70 >> 2] = f185;
  HEAPF32[i71 >> 2] = f186;
  if (!(HEAP8[i131 + 1727 >> 0] | 0)) i13 = i3; else {
   i11 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i37 >> 2] | 0;
   HEAP32[i39 >> 2] = i11;
   HEAP32[i41 >> 2] = i13;
   HEAP32[i42 >> 2] = i4;
   HEAP32[i43 >> 2] = i2;
   HEAP32[i49 >> 2] = i11;
   HEAP32[i69 >> 2] = i13;
   HEAP32[i70 >> 2] = i4;
   HEAP32[i71 >> 2] = i2;
  }
  i3 = HEAP16[i131 + 1728 >> 1] | 0;
  if ((i3 & 255) << 24 >> 24) {
   i9 = HEAP32[i50 >> 2] | 0;
   HEAP32[i52 >> 2] = i9;
   HEAP32[i56 >> 2] = i9;
  }
  if ((i3 & 65535) < 256) {
   HEAPF32[i169 + 288 >> 2] = Math_fround(1.0);
   i121 = i64;
   i3 = i13;
   break;
  } else {
   i12 = HEAP32[i171 >> 2] | 0;
   HEAP32[i172 >> 2] = i12;
   HEAP32[i168 >> 2] = i12;
   i10 = HEAP32[i53 >> 2] | 0;
   HEAP32[i55 >> 2] = i10;
   HEAP32[i64 >> 2] = i10;
   HEAPF32[i169 + 288 >> 2] = Math_fround(0.0);
   i121 = i64;
   i3 = i13;
   break;
  }
 } while (0);
 f95 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f74 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f94 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f93 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f92 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f59 - f94);
 f74 = Math_fround(f74 - f93);
 f186 = Math_fround(f58 - f92);
 f91 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f90 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f80 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f88 = Math_fround(f91 * Math_fround(-2.0));
 f89 = Math_fround(f91 * Math_fround(2.0));
 f87 = Math_fround(f95 * f88);
 f86 = Math_fround(f80 * Math_fround(2.0));
 f85 = Math_fround(f80 * Math_fround(-2.0));
 f84 = Math_fround(f95 * f85);
 f81 = Math_fround(Math_fround(f91 * f88) - Math_fround(f80 * f86));
 f82 = Math_fround(Math_fround(f90 * f89) - f84);
 f83 = Math_fround(f87 - Math_fround(f90 * f85));
 f72 = Math_fround(f90 * Math_fround(-2.0));
 f181 = Math_fround(f90 * Math_fround(2.0));
 f73 = Math_fround(f72 * f95);
 f84 = Math_fround(f84 - Math_fround(f91 * f72));
 f85 = Math_fround(Math_fround(f80 * f85) - Math_fround(f90 * f181));
 f86 = Math_fround(Math_fround(f91 * f86) - f73);
 f87 = Math_fround(Math_fround(f181 * f80) - f87);
 f88 = Math_fround(f73 - Math_fround(f80 * f88));
 f89 = Math_fround(Math_fround(f90 * f72) - Math_fround(f91 * f89));
 f72 = Math_fround(Math_fround(f5 + Math_fround(f5 * f81)) + Math_fround(Math_fround(f186 * f87) + Math_fround(f74 * f84)));
 f73 = Math_fround(Math_fround(f74 + Math_fround(f5 * f82)) + Math_fround(Math_fround(f186 * f88) + Math_fround(f74 * f85)));
 f74 = Math_fround(Math_fround(f186 + Math_fround(f5 * f83)) + Math_fround(Math_fround(f186 * f89) + Math_fround(f74 * f86)));
 f186 = Math_fround(Math_fround(Math_fround(Math_fround(f63 * f91) - Math_fround(f61 * f95)) - Math_fround(f60 * f80)) - Math_fround(f62 * f90));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f95) - Math_fround(f63 * f90)) - Math_fround(f61 * f80)) - Math_fround(f62 * f91));
 f181 = Math_fround(Math_fround(Math_fround(Math_fround(f62 * f80) - Math_fround(f61 * f91)) - Math_fround(f63 * f95)) - Math_fround(f60 * f90));
 f183 = Math_fround(Math_fround(Math_fround(Math_fround(f61 * f90) - Math_fround(f63 * f80)) - Math_fround(f62 * f95)) - Math_fround(f60 * f91));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = i9 ^ -2147483648;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i3 = i3 ^ -2147483648;
 i116 = i168 + 12 | 0;
 f183 = Math_fround(HEAPF32[i71 >> 2]);
 f181 = (HEAP32[tempDoublePtr >> 2] = i113, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f186 = (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f67 = (HEAP32[tempDoublePtr >> 2] = i115, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f176 = Math_fround(HEAPF32[i168 >> 2]);
 f179 = Math_fround(HEAPF32[i56 >> 2]);
 f176 = Math_fround(f181 - f176);
 f179 = Math_fround(f186 - f179);
 f67 = Math_fround(f67 - Math_fround(HEAPF32[i121 >> 2]));
 f186 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i69 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f181 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i116 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f182 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i70 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f66 = Math_fround(f186 * Math_fround(-2.0));
 f184 = Math_fround(f186 * Math_fround(2.0));
 f177 = Math_fround(f183 * f66);
 f180 = Math_fround(f182 * Math_fround(2.0));
 f178 = Math_fround(f182 * Math_fround(-2.0));
 f174 = Math_fround(f183 * f178);
 f68 = Math_fround(f181 * Math_fround(-2.0));
 f175 = Math_fround(f181 * Math_fround(2.0));
 f185 = Math_fround(f183 * f68);
 f65 = Math_fround(Math_fround(f176 + Math_fround(f176 * Math_fround(Math_fround(f186 * f66) - Math_fround(f182 * f180)))) + Math_fround(Math_fround(f179 * Math_fround(f174 - Math_fround(f186 * f68))) + Math_fround(Math_fround(Math_fround(f175 * f182) - f177) * f67)));
 f66 = Math_fround(Math_fround(f179 + Math_fround(f176 * Math_fround(Math_fround(f181 * f184) - f174))) + Math_fround(Math_fround(f179 * Math_fround(Math_fround(f182 * f178) - Math_fround(f181 * f175))) + Math_fround(Math_fround(f185 - Math_fround(f182 * f66)) * f67)));
 f67 = Math_fround(Math_fround(f67 + Math_fround(f176 * Math_fround(f177 - Math_fround(f181 * f178)))) + Math_fround(Math_fround(f179 * Math_fround(Math_fround(f186 * f180) - f185)) + Math_fround(Math_fround(Math_fround(f181 * f68) - Math_fround(f186 * f184)) * f67)));
 f184 = Math_fround(Math_fround(Math_fround(Math_fround(f119 * f186) - Math_fround(f117 * f183)) - Math_fround(f112 * f182)) - Math_fround(f118 * f181));
 f68 = Math_fround(Math_fround(Math_fround(Math_fround(f112 * f183) - Math_fround(f119 * f181)) - Math_fround(f117 * f182)) - Math_fround(f118 * f186));
 f185 = Math_fround(Math_fround(Math_fround(Math_fround(f118 * f182) - Math_fround(f117 * f186)) - Math_fround(f119 * f183)) - Math_fround(f112 * f181));
 f186 = Math_fround(Math_fround(Math_fround(Math_fround(f117 * f181) - Math_fround(f119 * f182)) - Math_fround(f118 * f183)) - Math_fround(f112 * f186));
 i13 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
 i39 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
 i39 = i39 ^ -2147483648;
 i17 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i13 = i13 ^ -2147483648;
 i42 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
 i41 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
 do if (!(HEAP8[i124 >> 0] | 0)) i126 = 153; else {
  if (!(HEAP8[i131 + 1726 >> 0] | 0)) {
   i126 = 153;
   break;
  }
  f185 = Math_fround(HEAPF32[i172 + 24 >> 2]);
  f181 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(HEAPF32[i172 >> 2]);
  f21 = Math_fround(HEAPF32[i172 + 4 >> 2]);
  f61 = Math_fround(f105 - f61);
  f21 = Math_fround(f181 - f21);
  f181 = Math_fround(f107 - Math_fround(HEAPF32[i172 + 8 >> 2]));
  f177 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i172 + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i172 + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i172 + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f177 * Math_fround(-2.0));
  f58 = Math_fround(f177 * Math_fround(2.0));
  f117 = Math_fround(f185 * f182);
  f178 = Math_fround(f60 * Math_fround(2.0));
  f54 = Math_fround(f60 * Math_fround(-2.0));
  f20 = Math_fround(f185 * f54);
  f175 = Math_fround(f19 * Math_fround(-2.0));
  f8 = Math_fround(f19 * Math_fround(2.0));
  f6 = Math_fround(f185 * f175);
  f62 = Math_fround(Math_fround(f61 + Math_fround(f61 * Math_fround(Math_fround(f177 * f182) - Math_fround(f60 * f178)))) + Math_fround(Math_fround(f21 * Math_fround(f20 - Math_fround(f177 * f175))) + Math_fround(Math_fround(Math_fround(f8 * f60) - f117) * f181)));
  f182 = Math_fround(Math_fround(f21 + Math_fround(f61 * Math_fround(Math_fround(f19 * f58) - f20))) + Math_fround(Math_fround(f21 * Math_fround(Math_fround(f60 * f54) - Math_fround(f19 * f8))) + Math_fround(Math_fround(f6 - Math_fround(f60 * f182)) * f181)));
  f181 = Math_fround(Math_fround(f181 + Math_fround(f61 * Math_fround(f117 - Math_fround(f19 * f54)))) + Math_fround(Math_fround(f21 * Math_fround(Math_fround(f177 * f178) - f6)) + Math_fround(Math_fround(Math_fround(f19 * f175) - Math_fround(f177 * f58)) * f181)));
  f58 = (HEAP32[tempDoublePtr >> 2] = i108, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f58 * f177);
  f6 = (HEAP32[tempDoublePtr >> 2] = i111, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f6 * f185);
  f21 = (HEAP32[tempDoublePtr >> 2] = i109, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f21 * f60);
  f117 = (HEAP32[tempDoublePtr >> 2] = i110, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(Math_fround(Math_fround(f175 - Math_fround(f117 * f185)) - Math_fround(f6 * f60)) - Math_fround(f21 * f19));
  f178 = Math_fround(Math_fround(Math_fround(f178 - Math_fround(f58 * f19)) - Math_fround(f117 * f60)) - Math_fround(f21 * f177));
  f54 = Math_fround(Math_fround(Math_fround(f54 - Math_fround(f117 * f177)) - Math_fround(f58 * f185)) - Math_fround(f6 * f19));
  f177 = Math_fround(Math_fround(Math_fround(Math_fround(f117 * f19) - Math_fround(f58 * f60)) - Math_fround(f21 * f185)) - Math_fround(f6 * f177));
  f6 = Math_fround(HEAPF32[i171 + 24 >> 2]);
  f185 = (HEAP32[tempDoublePtr >> 2] = i99, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(HEAPF32[i171 >> 2]);
  f60 = Math_fround(HEAPF32[i171 + 4 >> 2]);
  f21 = Math_fround(f98 - f21);
  f60 = Math_fround(f185 - f60);
  f185 = Math_fround(f100 - Math_fround(HEAPF32[i171 + 8 >> 2]));
  f58 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i171 + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i171 + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f117 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i171 + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f58 * Math_fround(-2.0));
  f8 = Math_fround(f58 * Math_fround(2.0));
  f20 = Math_fround(f6 * f61);
  f57 = Math_fround(f117 * Math_fround(2.0));
  f63 = Math_fround(f117 * Math_fround(-2.0));
  f30 = Math_fround(f6 * f63);
  f7 = Math_fround(f19 * Math_fround(-2.0));
  f25 = Math_fround(f19 * Math_fround(2.0));
  f59 = Math_fround(f6 * f7);
  f51 = Math_fround(Math_fround(f21 + Math_fround(f21 * Math_fround(Math_fround(f58 * f61) - Math_fround(f117 * f57)))) + Math_fround(Math_fround(f60 * Math_fround(f30 - Math_fround(f58 * f7))) + Math_fround(Math_fround(Math_fround(f25 * f117) - f20) * f185)));
  f61 = Math_fround(Math_fround(f60 + Math_fround(f21 * Math_fround(Math_fround(f19 * f8) - f30))) + Math_fround(Math_fround(f60 * Math_fround(Math_fround(f117 * f63) - Math_fround(f19 * f25))) + Math_fround(Math_fround(f59 - Math_fround(f117 * f61)) * f185)));
  f185 = Math_fround(Math_fround(f185 + Math_fround(f21 * Math_fround(f20 - Math_fround(f19 * f63)))) + Math_fround(Math_fround(f60 * Math_fround(Math_fround(f58 * f57) - f59)) + Math_fround(Math_fround(Math_fround(f19 * f7) - Math_fround(f58 * f8)) * f185)));
  f8 = (HEAP32[tempDoublePtr >> 2] = i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f8 * f58);
  f59 = (HEAP32[tempDoublePtr >> 2] = i104, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = Math_fround(f59 * f6);
  f60 = (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(f60 * f117);
  f20 = (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f20 * f6)) - Math_fround(f59 * f117)) - Math_fround(f60 * f19));
  f57 = Math_fround(Math_fround(Math_fround(f57 - Math_fround(f8 * f19)) - Math_fround(f20 * f117)) - Math_fround(f60 * f58));
  f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f20 * f58)) - Math_fround(f8 * f6)) - Math_fround(f59 * f19));
  f58 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f8 * f117)) - Math_fround(f60 * f6)) - Math_fround(f59 * f58));
  i42 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f62 = Math_fround(f51 - f62);
  f182 = Math_fround(f61 - f182);
  f181 = Math_fround(f185 - f181);
  f185 = Math_fround(f177 * Math_fround(-2.0));
  f61 = Math_fround(f177 * Math_fround(2.0));
  f51 = Math_fround(f178 * f185);
  f58 = Math_fround(f175 * Math_fround(2.0));
  f63 = Math_fround(f175 * Math_fround(-2.0));
  f7 = Math_fround(f178 * f63);
  f59 = Math_fround(f54 * Math_fround(-2.0));
  f6 = Math_fround(f54 * Math_fround(2.0));
  f60 = Math_fround(f178 * f59);
  f117 = Math_fround(Math_fround(f62 + Math_fround(Math_fround(Math_fround(f177 * f185) - Math_fround(f175 * f58)) * f62)) + Math_fround(Math_fround(Math_fround(f7 - Math_fround(f177 * f59)) * f182) + Math_fround(Math_fround(Math_fround(f175 * f6) - f51) * f181)));
  f185 = Math_fround(Math_fround(f182 + Math_fround(Math_fround(Math_fround(f54 * f61) - f7) * f62)) + Math_fround(Math_fround(Math_fround(Math_fround(f175 * f63) - Math_fround(f54 * f6)) * f182) + Math_fround(Math_fround(f60 - Math_fround(f175 * f185)) * f181)));
  f181 = Math_fround(Math_fround(f181 + Math_fround(Math_fround(f51 - Math_fround(f54 * f63)) * f62)) + Math_fround(Math_fround(Math_fround(Math_fround(f177 * f58) - f60) * f182) + Math_fround(Math_fround(Math_fround(f54 * f59) - Math_fround(f177 * f61)) * f181)));
  f61 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(f177 * f61);
  f182 = Math_fround(f178 * f57);
  f60 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f175 * f60);
  f62 = (HEAP32[tempDoublePtr >> 2] = i42 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(Math_fround(Math_fround(f59 - Math_fround(f178 * f62)) - Math_fround(f175 * f57)) - Math_fround(f54 * f60));
  f182 = Math_fround(Math_fround(Math_fround(f182 - Math_fround(f54 * f61)) - Math_fround(f175 * f62)) - Math_fround(f177 * f60));
  f58 = Math_fround(Math_fround(Math_fround(f58 - Math_fround(f177 * f62)) - Math_fround(f178 * f61)) - Math_fround(f54 * f57));
  f57 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f62) - Math_fround(f175 * f61)) - Math_fround(f178 * f60)) - Math_fround(f177 * f57));
  i42 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f57 = Math_fround(f122 * f117);
  f58 = Math_fround(f122 * f185);
  f59 = Math_fround(f122 * f181);
  f177 = (HEAP32[tempDoublePtr >> 2] = i41 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f122 * f177);
  f178 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f122 * f178);
  f175 = (HEAP32[tempDoublePtr >> 2] = i42 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f122 * f175);
  f54 = Math_fround(f182 * f182);
  f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f61 * f61)) + Math_fround(f54 + Math_fround(f62 * f62))))));
  f60 = Math_fround(f63 * f60);
  f61 = Math_fround(f63 * f61);
  f62 = Math_fround(f63 * f62);
  f63 = Math_fround(f63 * f182);
  f117 = Math_fround(f123 * f117);
  f185 = Math_fround(f123 * f185);
  f181 = Math_fround(f123 * f181);
  f177 = Math_fround(f123 * f177);
  f178 = Math_fround(f123 * f178);
  f175 = Math_fround(f123 * f175);
  f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f177 * f177) + Math_fround(f178 * f178)) + Math_fround(f54 + Math_fround(f175 * f175))))));
  f177 = Math_fround(f54 * f177);
  f178 = Math_fround(f54 * f178);
  f175 = Math_fround(f54 * f175);
  f182 = Math_fround(f54 * f182);
  f54 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f51 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f54 * Math_fround(-2.0));
  f8 = Math_fround(f54 * Math_fround(2.0));
  f19 = Math_fround(f5 * f7);
  f20 = Math_fround(f6 * Math_fround(2.0));
  f21 = Math_fround(f6 * Math_fround(-2.0));
  f25 = Math_fround(f5 * f21);
  f30 = Math_fround(f51 * Math_fround(-2.0));
  f47 = Math_fround(f51 * Math_fround(2.0));
  f48 = Math_fround(f5 * f30);
  f179 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f105 = Math_fround(f179 * Math_fround(-2.0));
  f119 = Math_fround(f179 * Math_fround(2.0));
  f107 = Math_fround(f68 * f105);
  f186 = Math_fround(f176 * Math_fround(2.0));
  f112 = Math_fround(f176 * Math_fround(-2.0));
  f100 = Math_fround(f68 * f112);
  f118 = Math_fround(f174 * Math_fround(-2.0));
  f184 = Math_fround(f174 * Math_fround(2.0));
  f180 = Math_fround(f68 * f118);
  f183 = Math_fround(f65 + Math_fround(Math_fround(f117 + Math_fround(Math_fround(Math_fround(f179 * f105) - Math_fround(f176 * f186)) * f117)) + Math_fround(Math_fround(Math_fround(Math_fround(f176 * f184) - f107) * f181) + Math_fround(Math_fround(f100 - Math_fround(f179 * f118)) * f185))));
  f184 = Math_fround(f66 + Math_fround(Math_fround(f185 + Math_fround(Math_fround(Math_fround(f174 * f119) - f100) * f117)) + Math_fround(Math_fround(Math_fround(f180 - Math_fround(f176 * f105)) * f181) + Math_fround(Math_fround(Math_fround(f176 * f112) - Math_fround(f174 * f184)) * f185))));
  f185 = Math_fround(f67 + Math_fround(Math_fround(f181 + Math_fround(Math_fround(f107 - Math_fround(f174 * f112)) * f117)) + Math_fround(Math_fround(Math_fround(Math_fround(f174 * f118) - Math_fround(f179 * f119)) * f181) + Math_fround(Math_fround(Math_fround(f179 * f186) - f180) * f185))));
  f180 = Math_fround(Math_fround(Math_fround(Math_fround(f179 * f177) - Math_fround(f68 * f175)) - Math_fround(f176 * f182)) - Math_fround(f174 * f178));
  f186 = Math_fround(Math_fround(Math_fround(Math_fround(f68 * f182) - Math_fround(f174 * f177)) - Math_fround(f176 * f175)) - Math_fround(f179 * f178));
  f181 = Math_fround(Math_fround(Math_fround(Math_fround(f176 * f178) - Math_fround(f179 * f175)) - Math_fround(f68 * f177)) - Math_fround(f174 * f182));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f174 * f175) - Math_fround(f176 * f177)) - Math_fround(f68 * f178)) - Math_fround(f179 * f182));
  i13 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i39 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i39 = i39 ^ -2147483648;
  i17 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i13 = i13 ^ -2147483648;
  i42 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  if (!i170) {
   i49 = i78;
   i64 = i79;
   i79 = i2;
   i37 = i96;
   i55 = i97;
   i78 = i41;
   i77 = i39;
   i52 = i120;
   i53 = i1;
   i50 = i13;
   i76 = i12;
   break;
  }
  f186 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f63) - Math_fround(f51 * f60)) - Math_fround(f6 * f62)) - Math_fround(f54 * f61));
  f185 = Math_fround(f74 + Math_fround(Math_fround(f59 + Math_fround(Math_fround(f19 - Math_fround(f51 * f21)) * f57)) + Math_fround(Math_fround(Math_fround(Math_fround(f51 * f30) - Math_fround(f54 * f8)) * f59) + Math_fround(Math_fround(Math_fround(f54 * f20) - f48) * f58))));
  f184 = Math_fround(f73 + Math_fround(Math_fround(f58 + Math_fround(Math_fround(Math_fround(f51 * f8) - f25) * f57)) + Math_fround(Math_fround(Math_fround(f48 - Math_fround(f6 * f7)) * f59) + Math_fround(Math_fround(Math_fround(f6 * f21) - Math_fround(f51 * f47)) * f58))));
  f8 = Math_fround(f72 + Math_fround(Math_fround(f57 + Math_fround(Math_fround(Math_fround(f54 * f7) - Math_fround(f6 * f20)) * f57)) + Math_fround(Math_fround(Math_fround(Math_fround(f6 * f47) - f19) * f59) + Math_fround(Math_fround(f25 - Math_fround(f54 * f30)) * f58))));
  f72 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f60) - Math_fround(f5 * f62)) - Math_fround(f6 * f63)) - Math_fround(f51 * f61));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f72 = Math_fround(Math_fround(Math_fround(Math_fround(f51 * f62) - Math_fround(f6 * f60)) - Math_fround(f5 * f61)) - Math_fround(f54 * f63));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f72 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f61) - Math_fround(f54 * f62)) - Math_fround(f5 * f60)) - Math_fround(f51 * f63));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f72 = Math_fround(HEAPF32[i131 + 68 >> 2]);
  f112 = Math_fround(HEAPF32[i131 + 72 >> 2]);
  f177 = Math_fround(HEAPF32[i131 + 76 >> 2]);
  f119 = Math_fround(f123 * f72);
  f180 = Math_fround(f123 * f112);
  f181 = Math_fround(f123 * f177);
  f107 = Math_fround(HEAPF32[i131 + 80 >> 2]);
  f174 = Math_fround(f123 * f107);
  f105 = Math_fround(HEAPF32[i131 + 84 >> 2]);
  f178 = Math_fround(f123 * f105);
  f100 = Math_fround(HEAPF32[i131 + 88 >> 2]);
  f179 = Math_fround(f123 * f100);
  f117 = Math_fround(HEAPF32[i131 + 92 >> 2]);
  f5 = Math_fround(f117 * f117);
  f67 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f174 * f174) + Math_fround(f178 * f178)) + Math_fround(Math_fround(f179 * f179) + f5)))));
  f174 = Math_fround(f174 * f67);
  f178 = Math_fround(f178 * f67);
  f179 = Math_fround(f179 * f67);
  f67 = Math_fround(f117 * f67);
  f66 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f66 * Math_fround(-2.0));
  f118 = Math_fround(f66 * Math_fround(2.0));
  f183 = Math_fround(f7 * f65);
  f63 = Math_fround(f6 * Math_fround(2.0));
  f74 = Math_fround(f6 * Math_fround(-2.0));
  f58 = Math_fround(f65 * f74);
  f176 = Math_fround(f182 * Math_fround(-2.0));
  f98 = Math_fround(f182 * Math_fround(2.0));
  f68 = Math_fround(f176 * f65);
  f60 = Math_fround(Math_fround(f119 + Math_fround(Math_fround(Math_fround(f66 * f7) - Math_fround(f6 * f63)) * f119)) + Math_fround(Math_fround(Math_fround(f58 - Math_fround(f66 * f176)) * f180) + Math_fround(Math_fround(Math_fround(f98 * f6) - f183) * f181)));
  f7 = Math_fround(Math_fround(f180 + Math_fround(Math_fround(Math_fround(f182 * f118) - f58) * f119)) + Math_fround(Math_fround(Math_fround(Math_fround(f6 * f74) - Math_fround(f182 * f98)) * f180) + Math_fround(Math_fround(f68 - Math_fround(f7 * f6)) * f181)));
  f181 = Math_fround(Math_fround(Math_fround(Math_fround(f183 - Math_fround(f182 * f74)) * f119) + f181) + Math_fround(Math_fround(Math_fround(Math_fround(f66 * f63) - f68) * f180) + Math_fround(Math_fround(Math_fround(f182 * f176) - Math_fround(f66 * f118)) * f181)));
  f118 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f118 + f60);
  f7 = Math_fround(f176 + f7);
  f181 = Math_fround((HEAP32[tempDoublePtr >> 2] = i97, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f181);
  f176 = Math_fround(Math_fround(Math_fround(Math_fround(f66 * f174) - Math_fround(f65 * f179)) - Math_fround(f6 * f67)) - Math_fround(f182 * f178));
  f118 = Math_fround(Math_fround(Math_fround(Math_fround(f65 * f67) - Math_fround(f182 * f174)) - Math_fround(f6 * f179)) - Math_fround(f66 * f178));
  f180 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f178) - Math_fround(f66 * f179)) - Math_fround(f65 * f174)) - Math_fround(f182 * f67));
  f67 = Math_fround(Math_fround(Math_fround(Math_fround(f182 * f179) - Math_fround(f6 * f174)) - Math_fround(f65 * f178)) - Math_fround(f66 * f67));
  i18 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i44 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f118, HEAP32[tempDoublePtr >> 2] | 0);
  f118 = Math_fround(HEAPF32[i131 + 132 >> 2]);
  f181 = Math_fround(HEAPF32[i131 + 136 >> 2]);
  f7 = Math_fround(HEAPF32[i131 + 140 >> 2]);
  f60 = Math_fround(f123 * f118);
  f67 = Math_fround(f123 * f181);
  f180 = Math_fround(f123 * f7);
  f176 = Math_fround(HEAPF32[i131 + 144 >> 2]);
  f66 = Math_fround(f123 * f176);
  f178 = Math_fround(HEAPF32[i131 + 148 >> 2]);
  f65 = Math_fround(f123 * f178);
  f174 = Math_fround(HEAPF32[i131 + 152 >> 2]);
  f6 = Math_fround(f123 * f174);
  f179 = Math_fround(HEAPF32[i131 + 156 >> 2]);
  f182 = Math_fround(f179 * f179);
  f123 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f66 * f66) + Math_fround(f65 * f65)) + Math_fround(Math_fround(f6 * f6) + f182)))));
  f66 = Math_fround(f66 * f123);
  f65 = Math_fround(f65 * f123);
  f6 = Math_fround(f6 * f123);
  f123 = Math_fround(f179 * f123);
  f68 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f119 = (HEAP32[tempDoublePtr >> 2] = i120, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(f68 * Math_fround(-2.0));
  f98 = Math_fround(f68 * Math_fround(2.0));
  f58 = Math_fround(f183 * f119);
  f61 = Math_fround(f74 * Math_fround(2.0));
  f59 = Math_fround(f74 * Math_fround(-2.0));
  f54 = Math_fround(f119 * f59);
  f73 = Math_fround(f63 * Math_fround(-2.0));
  f57 = Math_fround(f63 * Math_fround(2.0));
  f62 = Math_fround(f73 * f119);
  f175 = Math_fround(Math_fround(f60 + Math_fround(Math_fround(Math_fround(f68 * f183) - Math_fround(f74 * f61)) * f60)) + Math_fround(Math_fround(Math_fround(f54 - Math_fround(f68 * f73)) * f67) + Math_fround(Math_fround(Math_fround(f57 * f74) - f58) * f180)));
  f183 = Math_fround(Math_fround(f67 + Math_fround(Math_fround(Math_fround(f63 * f98) - f54) * f60)) + Math_fround(Math_fround(Math_fround(Math_fround(f74 * f59) - Math_fround(f63 * f57)) * f67) + Math_fround(Math_fround(f62 - Math_fround(f183 * f74)) * f180)));
  f180 = Math_fround(Math_fround(Math_fround(Math_fround(f58 - Math_fround(f63 * f59)) * f60) + f180) + Math_fround(Math_fround(Math_fround(Math_fround(f68 * f61) - f62) * f67) + Math_fround(Math_fround(Math_fround(f63 * f73) - Math_fround(f68 * f98)) * f180)));
  f98 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f73 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f98 + f175);
  f183 = Math_fround(f73 + f183);
  f180 = Math_fround((HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f180);
  f73 = Math_fround(Math_fround(Math_fround(Math_fround(f68 * f66) - Math_fround(f119 * f6)) - Math_fround(f74 * f123)) - Math_fround(f63 * f65));
  f98 = Math_fround(Math_fround(Math_fround(Math_fround(f119 * f123) - Math_fround(f63 * f66)) - Math_fround(f74 * f6)) - Math_fround(f68 * f65));
  f67 = Math_fround(Math_fround(Math_fround(Math_fround(f74 * f65) - Math_fround(f68 * f6)) - Math_fround(f119 * f66)) - Math_fround(f63 * f123));
  f123 = Math_fround(Math_fround(Math_fround(Math_fround(f63 * f6) - Math_fround(f74 * f66)) - Math_fround(f119 * f65)) - Math_fround(f68 * f123));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i45 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i126 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
  f72 = Math_fround(f122 * f72);
  f112 = Math_fround(f122 * f112);
  f177 = Math_fround(f122 * f177);
  f107 = Math_fround(f122 * f107);
  f105 = Math_fround(f122 * f105);
  f100 = Math_fround(f122 * f100);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f107 * f107) + Math_fround(f105 * f105)) + Math_fround(Math_fround(f100 * f100) + f5)))));
  f107 = Math_fround(f107 * f5);
  f105 = Math_fround(f105 * f5);
  f100 = Math_fround(f100 * f5);
  f5 = Math_fround(f117 * f5);
  f117 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f98 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f117 * Math_fround(-2.0));
  f123 = Math_fround(f117 * Math_fround(2.0));
  f67 = Math_fround(f175 * f180);
  f73 = Math_fround(f183 * Math_fround(2.0));
  f68 = Math_fround(f183 * Math_fround(-2.0));
  f65 = Math_fround(f180 * f68);
  f119 = Math_fround(f98 * Math_fround(-2.0));
  f66 = Math_fround(f98 * Math_fround(2.0));
  f74 = Math_fround(f119 * f180);
  f6 = Math_fround(Math_fround(f72 + Math_fround(Math_fround(Math_fround(f117 * f175) - Math_fround(f183 * f73)) * f72)) + Math_fround(Math_fround(Math_fround(f65 - Math_fround(f117 * f119)) * f112) + Math_fround(Math_fround(Math_fround(f66 * f183) - f67) * f177)));
  f175 = Math_fround(Math_fround(f112 + Math_fround(Math_fround(Math_fround(f98 * f123) - f65) * f72)) + Math_fround(Math_fround(Math_fround(Math_fround(f183 * f68) - Math_fround(f98 * f66)) * f112) + Math_fround(Math_fround(f74 - Math_fround(f175 * f183)) * f177)));
  f177 = Math_fround(Math_fround(Math_fround(Math_fround(f67 - Math_fround(f98 * f68)) * f72) + f177) + Math_fround(Math_fround(Math_fround(Math_fround(f117 * f73) - f74) * f112) + Math_fround(Math_fround(Math_fround(f98 * f119) - Math_fround(f117 * f123)) * f177)));
  f123 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f119 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f123 + f6);
  f175 = Math_fround(f119 + f175);
  f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i96, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f177);
  f119 = Math_fround(Math_fround(Math_fround(Math_fround(f117 * f107) - Math_fround(f180 * f100)) - Math_fround(f183 * f5)) - Math_fround(f98 * f105));
  f123 = Math_fround(Math_fround(Math_fround(Math_fround(f180 * f5) - Math_fround(f98 * f107)) - Math_fround(f183 * f100)) - Math_fround(f117 * f105));
  f112 = Math_fround(Math_fround(Math_fround(Math_fround(f183 * f105) - Math_fround(f117 * f100)) - Math_fround(f180 * f107)) - Math_fround(f98 * f5));
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f98 * f100) - Math_fround(f183 * f107)) - Math_fround(f180 * f105)) - Math_fround(f117 * f5));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i46 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f118 = Math_fround(f122 * f118);
  f181 = Math_fround(f122 * f181);
  f7 = Math_fround(f122 * f7);
  f176 = Math_fround(f122 * f176);
  f178 = Math_fround(f122 * f178);
  f174 = Math_fround(f122 * f174);
  f182 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f176 * f176) + Math_fround(f178 * f178)) + Math_fround(Math_fround(f174 * f174) + f182)))));
  f176 = Math_fround(f176 * f182);
  f178 = Math_fround(f178 * f182);
  f174 = Math_fround(f174 * f182);
  f182 = Math_fround(f179 * f182);
  f179 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f177 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f179 * Math_fround(-2.0));
  f5 = Math_fround(f179 * Math_fround(2.0));
  f112 = Math_fround(f6 * f177);
  f119 = Math_fround(f175 * Math_fround(2.0));
  f117 = Math_fround(f175 * Math_fround(-2.0));
  f105 = Math_fround(f177 * f117);
  f180 = Math_fround(f123 * Math_fround(-2.0));
  f107 = Math_fround(f123 * Math_fround(2.0));
  f122 = Math_fround(f180 * f177);
  f183 = Math_fround(Math_fround(f118 + Math_fround(Math_fround(Math_fround(f179 * f6) - Math_fround(f175 * f119)) * f118)) + Math_fround(Math_fround(Math_fround(f105 - Math_fround(f179 * f180)) * f181) + Math_fround(Math_fround(Math_fround(f107 * f175) - f112) * f7)));
  f6 = Math_fround(Math_fround(f181 + Math_fround(Math_fround(Math_fround(f123 * f5) - f105) * f118)) + Math_fround(Math_fround(Math_fround(Math_fround(f175 * f117) - Math_fround(f123 * f107)) * f181) + Math_fround(Math_fround(f122 - Math_fround(f6 * f175)) * f7)));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f112 - Math_fround(f123 * f117)) * f118) + f7) + Math_fround(Math_fround(Math_fround(Math_fround(f179 * f119) - f122) * f181) + Math_fround(Math_fround(Math_fround(f123 * f180) - Math_fround(f179 * f5)) * f7)));
  f5 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(f5 + f183);
  f6 = Math_fround(f180 + f6);
  f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f7);
  f180 = Math_fround(Math_fround(Math_fround(Math_fround(f179 * f176) - Math_fround(f177 * f174)) - Math_fround(f175 * f182)) - Math_fround(f123 * f178));
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f177 * f182) - Math_fround(f123 * f176)) - Math_fround(f175 * f174)) - Math_fround(f179 * f178));
  f181 = Math_fround(Math_fround(Math_fround(Math_fround(f175 * f178) - Math_fround(f179 * f174)) - Math_fround(f177 * f176)) - Math_fround(f123 * f182));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f123 * f174) - Math_fround(f175 * f176)) - Math_fround(f177 * f178)) - Math_fround(f179 * f182));
  i24 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i49 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i36 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f7 = f184;
  i43 = i2;
  f6 = f185;
  i34 = i34 ^ -2147483648;
  i33 = i33 ^ -2147483648;
  i32 = i32 ^ -2147483648;
  i31 = i31 ^ -2147483648;
  i24 = i24 ^ -2147483648;
  i23 = i23 ^ -2147483648;
  i22 = i22 ^ -2147483648;
  i18 = i18 ^ -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = i126;
  f5 = f186;
  i126 = 154;
 } while (0);
 if ((i126 | 0) == 153) if (i170) {
  i49 = i78;
  f8 = f72;
  i37 = i79;
  i14 = i75;
  f7 = f73;
  i43 = i2;
  i11 = i96;
  i10 = i97;
  f6 = f74;
  i2 = i120;
  i126 = 154;
 } else {
  i49 = i78;
  i64 = i79;
  i79 = i2;
  i37 = i96;
  i55 = i97;
  i78 = i41;
  i77 = i39;
  i52 = i120;
  i53 = i1;
  i50 = i13;
  i76 = i12;
 }
 if ((i126 | 0) == 154) {
  f174 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f119 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f177 = Math_fround(f178 * Math_fround(-2.0));
  f122 = Math_fround(f178 * Math_fround(2.0));
  f180 = Math_fround(f186 * f177);
  f182 = Math_fround(f123 * Math_fround(2.0));
  f183 = Math_fround(f123 * Math_fround(-2.0));
  f118 = Math_fround(f186 * f183);
  f179 = Math_fround(Math_fround(f178 * f177) - Math_fround(f123 * f182));
  f105 = Math_fround(Math_fround(f184 * f122) - f118);
  f181 = Math_fround(f180 - Math_fround(f183 * f184));
  f107 = Math_fround(f184 * Math_fround(-2.0));
  f176 = Math_fround(f184 * Math_fround(2.0));
  f175 = Math_fround(f186 * f107);
  f118 = Math_fround(f118 - Math_fround(f178 * f107));
  f183 = Math_fround(Math_fround(f123 * f183) - Math_fround(f184 * f176));
  f182 = Math_fround(Math_fround(f178 * f182) - f175);
  f180 = Math_fround(Math_fround(f123 * f176) - f180);
  f177 = Math_fround(f175 - Math_fround(f123 * f177));
  f122 = Math_fround(Math_fround(f184 * f107) - Math_fround(f178 * f122));
  f107 = Math_fround(Math_fround(Math_fround(f180 * f185) + Math_fround(f118 * f119)) + Math_fround(f174 + Math_fround(f179 * f174)));
  f175 = Math_fround(Math_fround(Math_fround(f177 * f185) + Math_fround(f183 * f119)) + Math_fround(f119 + Math_fround(f105 * f174)));
  f174 = Math_fround(Math_fround(Math_fround(f122 * f185) + Math_fround(f182 * f119)) + Math_fround(f185 + Math_fround(f181 * f174)));
  f185 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f119 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f107 = Math_fround(f185 + f107);
  f175 = Math_fround(f119 + f175);
  f174 = Math_fround(f176 + f174);
  f73 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f98 = Math_fround(f178 * f73);
  f117 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = Math_fround(f186 * f117);
  f74 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f100 = Math_fround(f123 * f74);
  f72 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f98 = Math_fround(Math_fround(Math_fround(f98 - Math_fround(f186 * f72)) - Math_fround(f123 * f117)) - Math_fround(f184 * f74));
  f112 = Math_fround(Math_fround(Math_fround(f112 - Math_fround(f184 * f73)) - Math_fround(f123 * f72)) - Math_fround(f178 * f74));
  f100 = Math_fround(Math_fround(Math_fround(f100 - Math_fround(f178 * f72)) - Math_fround(f186 * f73)) - Math_fround(f184 * f117));
  f117 = Math_fround(Math_fround(Math_fround(Math_fround(f184 * f72) - Math_fround(f123 * f73)) - Math_fround(f186 * f74)) - Math_fround(f178 * f117));
  i18 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f100, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f117, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i44 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
  i53 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  f112 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f185 + Math_fround(Math_fround(Math_fround(f180 * f175) + Math_fround(f118 * f174)) + Math_fround(f112 + Math_fround(f179 * f112))));
  f105 = Math_fround(f119 + Math_fround(Math_fround(Math_fround(f177 * f175) + Math_fround(f183 * f174)) + Math_fround(f174 + Math_fround(f105 * f112))));
  f112 = Math_fround(f176 + Math_fround(Math_fround(Math_fround(f122 * f175) + Math_fround(f182 * f174)) + Math_fround(f175 + Math_fround(f181 * f112))));
  f181 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f178 * f181);
  f174 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f186 * f174);
  f122 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(f123 * f122);
  f183 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(Math_fround(Math_fround(f175 - Math_fround(f186 * f183)) - Math_fround(f123 * f174)) - Math_fround(f184 * f122));
  f182 = Math_fround(Math_fround(Math_fround(f182 - Math_fround(f184 * f181)) - Math_fround(f123 * f183)) - Math_fround(f178 * f122));
  f176 = Math_fround(Math_fround(Math_fround(f176 - Math_fround(f178 * f183)) - Math_fround(f186 * f181)) - Math_fround(f184 * f174));
  f174 = Math_fround(Math_fround(Math_fround(Math_fround(f184 * f183) - Math_fround(f123 * f181)) - Math_fround(f186 * f122)) - Math_fround(f178 * f174));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i45 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  i52 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  f182 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f105 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f179 * Math_fround(-2.0));
  f178 = Math_fround(f179 * Math_fround(2.0));
  f122 = Math_fround(f5 * f175);
  f186 = Math_fround(f176 * Math_fround(2.0));
  f181 = Math_fround(f176 * Math_fround(-2.0));
  f123 = Math_fround(f5 * f181);
  f183 = Math_fround(Math_fround(f179 * f175) - Math_fround(f176 * f186));
  f184 = Math_fround(Math_fround(f174 * f178) - f123);
  f177 = Math_fround(f122 - Math_fround(f181 * f174));
  f119 = Math_fround(f174 * Math_fround(-2.0));
  f118 = Math_fround(f174 * Math_fround(2.0));
  f180 = Math_fround(f5 * f119);
  f123 = Math_fround(f123 - Math_fround(f179 * f119));
  f181 = Math_fround(Math_fround(f176 * f181) - Math_fround(f174 * f118));
  f186 = Math_fround(Math_fround(f179 * f186) - f180);
  f122 = Math_fround(Math_fround(f176 * f118) - f122);
  f175 = Math_fround(f180 - Math_fround(f176 * f175));
  f178 = Math_fround(Math_fround(f174 * f119) - Math_fround(f179 * f178));
  f119 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f122 * f105) + Math_fround(f123 * f112)) + Math_fround(f182 + Math_fround(f183 * f182))));
  f180 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f175 * f105) + Math_fround(f181 * f112)) + Math_fround(f112 + Math_fround(f184 * f182))));
  f182 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f178 * f105) + Math_fround(f186 * f112)) + Math_fround(f105 + Math_fround(f177 * f182))));
  f105 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = Math_fround(f179 * f105);
  f118 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(f5 * f118);
  f107 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f117 = Math_fround(f176 * f107);
  f100 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = Math_fround(Math_fround(Math_fround(f112 - Math_fround(f5 * f100)) - Math_fround(f176 * f118)) - Math_fround(f174 * f107));
  f185 = Math_fround(Math_fround(Math_fround(f185 - Math_fround(f174 * f105)) - Math_fround(f176 * f100)) - Math_fround(f179 * f107));
  f117 = Math_fround(Math_fround(Math_fround(f117 - Math_fround(f179 * f100)) - Math_fround(f5 * f105)) - Math_fround(f174 * f118));
  f118 = Math_fround(Math_fround(Math_fround(Math_fround(f174 * f100) - Math_fround(f176 * f105)) - Math_fround(f5 * f107)) - Math_fround(f179 * f118));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f117, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f118, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i46 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
  i64 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  f185 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f122 * f180) + Math_fround(f123 * f182)) + Math_fround(f185 + Math_fround(f183 * f185))));
  f184 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f175 * f180) + Math_fround(f181 * f182)) + Math_fround(f182 + Math_fround(f184 * f185))));
  f185 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f178 * f180) + Math_fround(f186 * f182)) + Math_fround(f180 + Math_fround(f177 * f185))));
  f177 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = Math_fround(f179 * f177);
  f182 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f5 * f182);
  f178 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f176 * f178);
  f175 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = Math_fround(Math_fround(Math_fround(f180 - Math_fround(f5 * f175)) - Math_fround(f176 * f182)) - Math_fround(f174 * f178));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f174 * f177)) - Math_fround(f176 * f175)) - Math_fround(f179 * f178));
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f179 * f175)) - Math_fround(f5 * f177)) - Math_fround(f174 * f182));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f174 * f175) - Math_fround(f176 * f177)) - Math_fround(f5 * f178)) - Math_fround(f179 * f182));
  i24 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i49 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i36 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i79 = i43;
  i78 = i41;
  i34 = i34 ^ -2147483648;
  i33 = i33 ^ -2147483648;
  i32 = i32 ^ -2147483648;
  i31 = i31 ^ -2147483648;
  i77 = i39;
  i24 = i24 ^ -2147483648;
  i23 = i23 ^ -2147483648;
  i22 = i22 ^ -2147483648;
  i18 = i18 ^ -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i50 = i13;
  i76 = i12;
 }
 do if (!(HEAP8[i124 >> 0] | 0)) {
  f186 = Math_fround(HEAPF32[i134 >> 2]);
  if (!(f186 != Math_fround(HEAPF32[i167 >> 2]))) {
   i1 = 0;
   i3 = 0;
   i4 = 0;
   i10 = 0;
   i9 = 0;
   i11 = 0;
   i2 = 1065353216;
   i12 = 1065353216;
   i13 = 1065353216;
   i14 = 1065353216;
   break;
  }
  f180 = Math_fround(HEAPF32[i168 >> 2]);
  f178 = Math_fround(HEAPF32[i56 >> 2]);
  f180 = Math_fround(f180 - f94);
  f178 = Math_fround(f178 - f93);
  f185 = Math_fround(Math_fround(HEAPF32[i121 >> 2]) - f92);
  f183 = Math_fround(Math_fround(f180 + Math_fround(f81 * f180)) + Math_fround(Math_fround(f84 * f178) + Math_fround(f87 * f185)));
  f184 = Math_fround(Math_fround(f178 + Math_fround(f82 * f180)) + Math_fround(Math_fround(f85 * f178) + Math_fround(f88 * f185)));
  f185 = Math_fround(Math_fround(Math_fround(f83 * f180) + f185) + Math_fround(Math_fround(f86 * f178) + Math_fround(f89 * f185)));
  f178 = Math_fround(HEAPF32[i168 + 12 >> 2]);
  f180 = Math_fround(f91 * f178);
  f182 = Math_fround(HEAPF32[i71 >> 2]);
  f186 = Math_fround(f95 * f182);
  f179 = Math_fround(HEAPF32[i69 >> 2]);
  f181 = Math_fround(f80 * f179);
  f177 = Math_fround(HEAPF32[i70 >> 2]);
  f180 = Math_fround(Math_fround(Math_fround(f180 - Math_fround(f95 * f177)) - Math_fround(f80 * f182)) - Math_fround(f90 * f179));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f90 * f178)) - Math_fround(f80 * f177)) - Math_fround(f91 * f179));
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f91 * f177)) - Math_fround(f95 * f178)) - Math_fround(f90 * f182));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f90 * f177) - Math_fround(f80 * f178)) - Math_fround(f95 * f179)) - Math_fround(f91 * f182));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 ^ -2147483648;
  i11 = i11 ^ -2147483648;
  i2 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = 1065353216;
  i13 = 1065353216;
  i14 = 1065353216;
 } else {
  f5 = Math_fround(HEAPF32[i125 >> 2]);
  i11 = ~~Math_fround(f5 - Math_fround(HEAPF32[i127 >> 2]));
  __ZN7mecanim9animation9GetCycleXERKN4math4trsXES4_S4_if(i128, i168, i171, i172, i11, Math_fround(HEAPF32[i133 >> 2]));
  f180 = Math_fround(HEAPF32[i128 >> 2]);
  f178 = Math_fround(HEAPF32[i128 + 4 >> 2]);
  f180 = Math_fround(f180 - f94);
  f178 = Math_fround(f178 - f93);
  f185 = Math_fround(Math_fround(HEAPF32[i128 + 8 >> 2]) - f92);
  f183 = Math_fround(Math_fround(f180 + Math_fround(f81 * f180)) + Math_fround(Math_fround(f84 * f178) + Math_fround(f87 * f185)));
  f184 = Math_fround(Math_fround(f178 + Math_fround(f82 * f180)) + Math_fround(Math_fround(f85 * f178) + Math_fround(f88 * f185)));
  f185 = Math_fround(Math_fround(Math_fround(f83 * f180) + f185) + Math_fround(Math_fround(f86 * f178) + Math_fround(f89 * f185)));
  f178 = Math_fround(HEAPF32[i128 + 12 >> 2]);
  f180 = Math_fround(f91 * f178);
  f182 = Math_fround(HEAPF32[i128 + 24 >> 2]);
  f186 = Math_fround(f95 * f182);
  f179 = Math_fround(HEAPF32[i128 + 16 >> 2]);
  f181 = Math_fround(f80 * f179);
  f177 = Math_fround(HEAPF32[i128 + 20 >> 2]);
  f180 = Math_fround(Math_fround(Math_fround(f180 - Math_fround(f95 * f177)) - Math_fround(f80 * f182)) - Math_fround(f90 * f179));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f90 * f178)) - Math_fround(f80 * f177)) - Math_fround(f91 * f179));
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f91 * f177)) - Math_fround(f95 * f178)) - Math_fround(f90 * f182));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f90 * f177) - Math_fround(f80 * f178)) - Math_fround(f95 * f179)) - Math_fround(f91 * f182));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 ^ -2147483648;
  i9 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i11 = i11 ^ -2147483648;
  i12 = HEAP32[i128 + 28 >> 2] | 0;
  i13 = HEAP32[i128 + 32 >> 2] | 0;
  i14 = HEAP32[i128 + 36 >> 2] | 0;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  if (!(HEAP8[i167 + 20 >> 0] | 0)) break;
  __ZN7mecanim9animation9GetCycleXERKN4math4trsXES4_S4_if(i128, i168, i171, i172, ~~f5, Math_fround(0.0));
  i127 = HEAP32[i128 + 4 >> 2] | 0;
  i125 = HEAP32[i128 + 8 >> 2] | 0;
  HEAP32[i168 >> 2] = HEAP32[i128 >> 2];
  HEAP32[i56 >> 2] = i127;
  HEAP32[i121 >> 2] = i125;
  i125 = HEAP32[i128 + 16 >> 2] | 0;
  i127 = HEAP32[i128 + 20 >> 2] | 0;
  i126 = HEAP32[i128 + 24 >> 2] | 0;
  HEAP32[i116 >> 2] = HEAP32[i128 + 12 >> 2];
  HEAP32[i69 >> 2] = i125;
  HEAP32[i70 >> 2] = i127;
  HEAP32[i71 >> 2] = i126;
  i126 = HEAP32[i128 + 32 >> 2] | 0;
  i127 = HEAP32[i128 + 36 >> 2] | 0;
  HEAP32[i168 + 28 >> 2] = HEAP32[i128 + 28 >> 2];
  HEAP32[i168 + 32 >> 2] = i126;
  HEAP32[i168 + 36 >> 2] = i127;
 } while (0);
 f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 / f6);
 f5 = Math_fround(f5 / f6);
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f6);
 if (!(i130 | i129 ^ 1)) {
  i129 = HEAP16[i131 + 1728 >> 1] | 0;
  i130 = (i129 & 65535) < 256;
  f7 = Math_fround(0.0);
  i1 = i130 ? i1 : 0;
  i3 = (i129 & 255) << 24 >> 24 == 0 ? i3 : 0;
  i4 = i130 ? i4 : 0;
  f5 = (HEAP8[i131 + 1727 >> 0] | 0) == 0 ? f5 : Math_fround(0.0);
  f6 = Math_fround(0.0);
 }
 f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f6 * f6) + Math_fround(1.0))))));
 f47 = Math_fround(f7 * f48);
 f5 = Math_fround(f5 * f48);
 f6 = Math_fround(f6 * f48);
 if (i132 | i170 ^ 1) {
  i43 = i40;
  i40 = i64;
  i41 = i38;
  i38 = i75;
  i39 = i36;
  i36 = i37;
  i37 = i35;
  i35 = i55;
  f30 = f5;
  f25 = f6;
  i11 = i52;
  i10 = i53;
  i9 = i50;
 } else {
  f30 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  f30 = Math_fround(-f5);
  f25 = Math_fround(-f6);
  f183 = Math_fround(HEAPF32[i168 >> 2]);
  f180 = Math_fround(HEAPF32[i69 >> 2]);
  f182 = Math_fround(HEAPF32[i70 >> 2]);
  i11 = i168 + 28 | 0;
  i132 = HEAP32[i11 >> 2] | 0;
  i131 = i168 + 32 | 0;
  i10 = HEAP32[i131 >> 2] | 0;
  i9 = i168 + 36 | 0;
  i43 = HEAP32[i9 >> 2] | 0;
  f180 = Math_fround(-f180);
  f182 = Math_fround(-f182);
  HEAPF32[i168 >> 2] = Math_fround(-f183);
  HEAPF32[i69 >> 2] = f180;
  HEAPF32[i70 >> 2] = f182;
  HEAP32[i11 >> 2] = i132;
  HEAP32[i131 >> 2] = i10;
  HEAP32[i9 >> 2] = i43;
  f182 = Math_fround(HEAPF32[i171 >> 2]);
  i9 = i171 + 16 | 0;
  f180 = Math_fround(HEAPF32[i9 >> 2]);
  i43 = i171 + 20 | 0;
  f180 = Math_fround(-f180);
  f183 = Math_fround(-Math_fround(HEAPF32[i43 >> 2]));
  HEAPF32[i171 >> 2] = Math_fround(-f182);
  HEAPF32[i9 >> 2] = f180;
  HEAPF32[i43 >> 2] = f183;
  f183 = Math_fround(HEAPF32[i172 >> 2]);
  i43 = i172 + 16 | 0;
  f180 = Math_fround(HEAPF32[i43 >> 2]);
  i9 = i172 + 20 | 0;
  f180 = Math_fround(-f180);
  f182 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
  HEAPF32[i172 >> 2] = Math_fround(-f183);
  HEAPF32[i43 >> 2] = f180;
  HEAPF32[i9 >> 2] = f182;
  f182 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(-f182);
  i42 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  f180 = Math_fround(-f180);
  f183 = Math_fround(-f183);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f180, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  f183 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(-f183);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  f183 = Math_fround(-f182);
  f177 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f177 = Math_fround(-f177);
  i44 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
  f177 = Math_fround(-f179);
  f185 = Math_fround(f184 * Math_fround(-0.0));
  f176 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f176 * Math_fround(0.0));
  f186 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f186 * Math_fround(0.0));
  f179 = Math_fround(f179 * Math_fround(-0.0));
  f186 = Math_fround(Math_fround(Math_fround(f185 - f178) - f179) - f186);
  f184 = Math_fround(f184 + Math_fround(Math_fround(f178 - f181) - f179));
  f178 = Math_fround(Math_fround(Math_fround(f177 - f185) - f178) - f181);
  f185 = Math_fround(Math_fround(Math_fround(f181 - f179) - f176) - f185);
  i131 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f178, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f185 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f185 * f185);
  f186 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(f186 * f186);
  f179 = (HEAP32[tempDoublePtr >> 2] = i131 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f178 + f176) + Math_fround(Math_fround(f184 * f184) + Math_fround(f179 * f179))))));
  f185 = Math_fround(f185 * f176);
  f186 = Math_fround(f186 * f176);
  f179 = Math_fround(f179 * f176);
  f176 = Math_fround(f184 * f176);
  i131 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
  f176 = Math_fround(f180 * Math_fround(-0.0));
  f179 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f179 * Math_fround(0.0));
  f185 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = Math_fround(f185 * Math_fround(0.0));
  f182 = Math_fround(f182 * Math_fround(-0.0));
  f185 = Math_fround(Math_fround(Math_fround(f176 - f186) - f182) - f185);
  f180 = Math_fround(f180 + Math_fround(Math_fround(f186 - f184) - f182));
  f186 = Math_fround(Math_fround(Math_fround(f183 - f176) - f186) - f184);
  f176 = Math_fround(Math_fround(Math_fround(f184 - f182) - f179) - f176);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f176 = (HEAP32[tempDoublePtr >> 2] = i22 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f176 * f176);
  f185 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f185 * f185);
  f182 = (HEAP32[tempDoublePtr >> 2] = i32 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f186 + f179) + Math_fround(Math_fround(f180 * f180) + Math_fround(f182 * f182))))));
  f176 = Math_fround(f176 * f179);
  f185 = Math_fround(f185 * f179);
  f182 = Math_fround(f182 * f179);
  f179 = Math_fround(f180 * f179);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0);
  f179 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(-f179);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0);
  f179 = Math_fround(-f185);
  f176 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(-f176);
  i46 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
  f176 = Math_fround(-f186);
  f184 = Math_fround(f180 * Math_fround(-0.0));
  f183 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f183 * Math_fround(0.0));
  f181 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f177 = Math_fround(f181 * Math_fround(0.0));
  f186 = Math_fround(f186 * Math_fround(-0.0));
  f181 = Math_fround(Math_fround(Math_fround(f184 - f178) - f186) - f181);
  f180 = Math_fround(f180 + Math_fround(Math_fround(f178 - f177) - f186));
  f178 = Math_fround(Math_fround(Math_fround(f176 - f184) - f178) - f177);
  f184 = Math_fround(Math_fround(Math_fround(f177 - f186) - f183) - f184);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f178, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f184 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f184 * f184);
  f181 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(f181 * f181);
  f186 = (HEAP32[tempDoublePtr >> 2] = i31 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f178 + f183) + Math_fround(Math_fround(f180 * f180) + Math_fround(f186 * f186))))));
  f184 = Math_fround(f184 * f183);
  f181 = Math_fround(f181 * f183);
  f186 = Math_fround(f186 * f183);
  f183 = Math_fround(f180 * f183);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i132 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  f183 = Math_fround(f182 * Math_fround(-0.0));
  f186 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f186 * Math_fround(0.0));
  f184 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = Math_fround(f184 * Math_fround(0.0));
  f185 = Math_fround(f185 * Math_fround(-0.0));
  f184 = Math_fround(Math_fround(Math_fround(f183 - f181) - f185) - f184);
  f182 = Math_fround(f182 + Math_fround(Math_fround(f181 - f180) - f185));
  f181 = Math_fround(Math_fround(Math_fround(f179 - f183) - f181) - f180);
  f183 = Math_fround(Math_fround(Math_fround(f180 - f185) - f186) - f183);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f183 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f183 * f183);
  f184 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f184 * f184);
  f185 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f181 + f186) + Math_fround(Math_fround(f182 * f182) + Math_fround(f185 * f185))))));
  f183 = Math_fround(f183 * f186);
  f184 = Math_fround(f184 * f186);
  f185 = Math_fround(f185 * f186);
  f186 = Math_fround(f182 * f186);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i49 = i45;
  i45 = i43;
  i43 = i64;
  i41 = i75;
  i39 = i37;
  i37 = i55;
  i33 = i31;
  i31 = i131;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = i132;
 }
 f5 = Math_fround(HEAPF32[i133 >> 2]);
 if (f5 != Math_fround(0.0)) {
  f186 = Math_fround(HEAPF32[i167 >> 2]);
  f186 = Math_fround(f186 - Math_fround(HEAPF32[i134 >> 2]));
  f8 = Math_fround(HEAPF32[i136 >> 2]);
  f8 = Math_fround(Math_fround(f186 * Math_fround(f8 - Math_fround(HEAPF32[i135 >> 2]))) / Math_fround(Math_abs(Math_fround(f5))));
 } else f8 = Math_fround(0.0);
 HEAPF32[i169 >> 2] = f8;
 f21 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f21 / f8);
 f6 = Math_fround(f20 / f8);
 f7 = Math_fround(f19 / f8);
 i3 = f8 != Math_fround(0.0);
 i2 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i136 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i169 + 4 >> 2] = i2;
 HEAP32[i169 + 8 >> 2] = i1;
 HEAP32[i169 + 12 >> 2] = i136;
 f185 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f30 * f30)) + Math_fround(Math_fround(f48 * f48) + Math_fround(f25 * f25))))));
 f5 = Math_fround(f47 * f185);
 f6 = Math_fround(f30 * f185);
 f185 = Math_fround(f25 * f185);
 f186 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f185 * f185) + Math_fround(0.0)))));
 f7 = Math_fround(Math_fround(+Math_asin(+f186)) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f5 * f7) / f186);
 f6 = Math_fround(Math_fround(f6 * f7) / f186);
 f7 = Math_fround(Math_fround(f185 * f7) / f186);
 i136 = f186 != Math_fround(0.0);
 f5 = i136 ? f5 : Math_fround(0.0);
 f6 = i136 ? f6 : Math_fround(0.0);
 f5 = Math_fround(f5 / f8);
 f6 = Math_fround(f6 / f8);
 f7 = Math_fround((i136 ? f7 : Math_fround(0.0)) / f8);
 i2 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i136 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i169 + 16 >> 2] = i2;
 HEAP32[i169 + 20 >> 2] = i1;
 HEAP32[i169 + 24 >> 2] = i136;
 HEAP32[i169 + 28 >> 2] = i42;
 HEAP32[i169 + 32 >> 2] = i79;
 HEAP32[i169 + 36 >> 2] = i78;
 HEAP32[i169 + 40 >> 2] = i77;
 HEAP32[i169 + 44 >> 2] = i17;
 HEAP32[i169 + 48 >> 2] = i9;
 HEAP32[i137 >> 2] = i76;
 HEAP32[i138 >> 2] = 1065353216;
 HEAP32[i139 >> 2] = 1065353216;
 HEAP32[i140 >> 2] = 1065353216;
 if (!(HEAP8[i167 + 21 >> 0] | 0)) {
  i167 = HEAP32[i56 >> 2] | 0;
  i140 = HEAP32[i121 >> 2] | 0;
  HEAP32[i141 >> 2] = HEAP32[i168 >> 2];
  HEAP32[i169 + 72 >> 2] = i167;
  HEAP32[i169 + 76 >> 2] = i140;
  i140 = HEAP32[i69 >> 2] | 0;
  i141 = HEAP32[i70 >> 2] | 0;
  i167 = HEAP32[i71 >> 2] | 0;
  HEAP32[i169 + 80 >> 2] = HEAP32[i116 >> 2];
  HEAP32[i169 + 84 >> 2] = i140;
  HEAP32[i169 + 88 >> 2] = i141;
  HEAP32[i142 >> 2] = i167;
  i142 = HEAP32[i168 + 32 >> 2] | 0;
  i167 = HEAP32[i168 + 36 >> 2] | 0;
  HEAP32[i143 >> 2] = HEAP32[i168 + 28 >> 2];
  HEAP32[i144 >> 2] = i142;
  HEAP32[i145 >> 2] = i167;
  i168 = HEAP32[i171 + 4 >> 2] | 0;
  i167 = HEAP32[i171 + 8 >> 2] | 0;
  HEAP32[i146 >> 2] = HEAP32[i171 >> 2];
  HEAP32[i169 + 112 >> 2] = i168;
  HEAP32[i169 + 116 >> 2] = i167;
  i146 = HEAP32[i171 + 16 >> 2] | 0;
  i167 = HEAP32[i171 + 20 >> 2] | 0;
  i168 = HEAP32[i171 + 24 >> 2] | 0;
  HEAP32[i169 + 120 >> 2] = HEAP32[i171 + 12 >> 2];
  HEAP32[i169 + 124 >> 2] = i146;
  HEAP32[i169 + 128 >> 2] = i167;
  HEAP32[i147 >> 2] = i168;
  i168 = HEAP32[i171 + 32 >> 2] | 0;
  i167 = HEAP32[i171 + 36 >> 2] | 0;
  HEAP32[i148 >> 2] = HEAP32[i171 + 28 >> 2];
  HEAP32[i149 >> 2] = i168;
  HEAP32[i150 >> 2] = i167;
  i171 = HEAP32[i172 + 4 >> 2] | 0;
  i167 = HEAP32[i172 + 8 >> 2] | 0;
  HEAP32[i151 >> 2] = HEAP32[i172 >> 2];
  HEAP32[i169 + 152 >> 2] = i171;
  HEAP32[i169 + 156 >> 2] = i167;
  i167 = HEAP32[i172 + 16 >> 2] | 0;
  i171 = HEAP32[i172 + 20 >> 2] | 0;
  i168 = HEAP32[i172 + 24 >> 2] | 0;
  HEAP32[i169 + 160 >> 2] = HEAP32[i172 + 12 >> 2];
  HEAP32[i169 + 164 >> 2] = i167;
  HEAP32[i169 + 168 >> 2] = i171;
  HEAP32[i152 >> 2] = i168;
  i168 = HEAP32[i172 + 32 >> 2] | 0;
  i171 = HEAP32[i172 + 36 >> 2] | 0;
  HEAP32[i153 >> 2] = HEAP32[i172 + 28 >> 2];
  HEAP32[i154 >> 2] = i168;
  HEAP32[i155 >> 2] = i171;
 } else {
  i139 = i171 + 12 | 0;
  i138 = i171 + 16 | 0;
  i140 = i171 + 20 | 0;
  i135 = i171 + 24 | 0;
  f119 = Math_fround(HEAPF32[i135 >> 2]);
  f180 = Math_fround(HEAPF32[i168 >> 2]);
  f177 = Math_fround(HEAPF32[i56 >> 2]);
  f184 = Math_fround(HEAPF32[i121 >> 2]);
  f176 = Math_fround(HEAPF32[i171 >> 2]);
  i136 = i171 + 4 | 0;
  f174 = Math_fround(HEAPF32[i136 >> 2]);
  i137 = i171 + 8 | 0;
  f176 = Math_fround(f180 - f176);
  f174 = Math_fround(f177 - f174);
  f184 = Math_fround(f184 - Math_fround(HEAPF32[i137 >> 2]));
  f177 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i138 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i139 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i140 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f177 * Math_fround(-2.0));
  f178 = Math_fround(f177 * Math_fround(2.0));
  f183 = Math_fround(f119 * f186);
  f175 = Math_fround(f185 * Math_fround(2.0));
  f182 = Math_fround(f185 * Math_fround(-2.0));
  f123 = Math_fround(f119 * f182);
  f181 = Math_fround(f180 * Math_fround(-2.0));
  f118 = Math_fround(f180 * Math_fround(2.0));
  f179 = Math_fround(f119 * f181);
  f122 = Math_fround(Math_fround(f176 + Math_fround(Math_fround(Math_fround(f177 * f186) - Math_fround(f185 * f175)) * f176)) + Math_fround(Math_fround(Math_fround(f123 - Math_fround(f177 * f181)) * f174) + Math_fround(Math_fround(Math_fround(f118 * f185) - f183) * f184)));
  f186 = Math_fround(Math_fround(f174 + Math_fround(Math_fround(Math_fround(f180 * f178) - f123) * f176)) + Math_fround(Math_fround(Math_fround(Math_fround(f185 * f182) - Math_fround(f180 * f118)) * f174) + Math_fround(Math_fround(f179 - Math_fround(f185 * f186)) * f184)));
  f184 = Math_fround(Math_fround(Math_fround(Math_fround(f183 - Math_fround(f180 * f182)) * f176) + f184) + Math_fround(Math_fround(Math_fround(Math_fround(f177 * f175) - f179) * f174) + Math_fround(Math_fround(Math_fround(f180 * f181) - Math_fround(f177 * f178)) * f184)));
  i143 = i171 + 28 | 0;
  f178 = Math_fround(HEAPF32[i143 >> 2]);
  i153 = i171 + 32 | 0;
  f181 = Math_fround(HEAPF32[i153 >> 2]);
  i167 = i171 + 36 | 0;
  f174 = Math_fround(HEAPF32[i167 >> 2]);
  i133 = Math_fround(Math_abs(Math_fround(f178))) < Math_fround(9.99999971e-10);
  i132 = Math_fround(Math_abs(Math_fround(f181))) < Math_fround(9.99999971e-10);
  i134 = Math_fround(Math_abs(Math_fround(f174))) < Math_fround(9.99999971e-10);
  f178 = Math_fround(Math_fround(1.0) / f178);
  f178 = i133 ? Math_fround(1.0) : f178;
  f181 = Math_fround(Math_fround(1.0) / f181);
  f181 = i132 ? Math_fround(1.0) : f181;
  f174 = Math_fround(Math_fround(1.0) / f174);
  f174 = i134 ? Math_fround(1.0) : f174;
  f122 = Math_fround(f122 * f178);
  f186 = Math_fround(f186 * f181);
  f184 = Math_fround(f184 * f174);
  f179 = Math_fround(HEAPF32[i168 + 12 >> 2]);
  f175 = Math_fround(f177 * f179);
  f176 = Math_fround(HEAPF32[i71 >> 2]);
  f182 = Math_fround(f119 * f176);
  f183 = Math_fround(HEAPF32[i69 >> 2]);
  f118 = Math_fround(f185 * f183);
  f123 = Math_fround(HEAPF32[i70 >> 2]);
  f175 = Math_fround(Math_fround(Math_fround(f175 - Math_fround(f119 * f123)) - Math_fround(f185 * f176)) - Math_fround(f180 * f183));
  f182 = Math_fround(Math_fround(Math_fround(f182 - Math_fround(f180 * f179)) - Math_fround(f185 * f123)) - Math_fround(f177 * f183));
  f118 = Math_fround(Math_fround(Math_fround(f118 - Math_fround(f177 * f123)) - Math_fround(f119 * f179)) - Math_fround(f180 * f176));
  f176 = Math_fround(Math_fround(Math_fround(Math_fround(f180 * f123) - Math_fround(f185 * f179)) - Math_fround(f119 * f183)) - Math_fround(f177 * f176));
  i134 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
  i132 = (HEAPF32[tempDoublePtr >> 2] = f118, HEAP32[tempDoublePtr >> 2] | 0);
  i133 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f176 = Math_fround(HEAPF32[i168 + 28 >> 2]);
  f118 = Math_fround(HEAPF32[i168 + 32 >> 2]);
  f176 = Math_fround(f178 * f176);
  f118 = Math_fround(f181 * f118);
  f174 = Math_fround(f174 * Math_fround(HEAPF32[i168 + 36 >> 2]));
  HEAPF32[i141 >> 2] = f122;
  HEAPF32[i169 + 72 >> 2] = f186;
  HEAPF32[i169 + 76 >> 2] = f184;
  HEAP32[i169 + 80 >> 2] = i132 ^ -2147483648;
  HEAP32[i169 + 84 >> 2] = i133;
  HEAP32[i169 + 88 >> 2] = i134 ^ -2147483648;
  HEAPF32[i142 >> 2] = f182;
  HEAPF32[i169 + 96 >> 2] = f176;
  HEAPF32[i144 >> 2] = f118;
  HEAPF32[i145 >> 2] = f174;
  HEAP32[i146 >> 2] = 0;
  HEAP32[i146 + 4 >> 2] = 0;
  HEAP32[i146 + 8 >> 2] = 0;
  HEAP32[i146 + 12 >> 2] = 0;
  HEAP32[i146 + 16 >> 2] = 0;
  HEAP32[i146 + 20 >> 2] = 0;
  HEAP32[i147 >> 2] = 1065353216;
  HEAP32[i148 >> 2] = 1065353216;
  HEAP32[i149 >> 2] = 1065353216;
  HEAP32[i150 >> 2] = 1065353216;
  f174 = Math_fround(HEAPF32[i135 >> 2]);
  f118 = Math_fround(HEAPF32[i172 >> 2]);
  f176 = Math_fround(HEAPF32[i172 + 4 >> 2]);
  f182 = Math_fround(HEAPF32[i172 + 8 >> 2]);
  f184 = Math_fround(HEAPF32[i171 >> 2]);
  f186 = Math_fround(HEAPF32[i136 >> 2]);
  f184 = Math_fround(f118 - f184);
  f186 = Math_fround(f176 - f186);
  f182 = Math_fround(f182 - Math_fround(HEAPF32[i137 >> 2]));
  f176 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i138 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f118 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i139 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f122 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i140 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f176 * Math_fround(-2.0));
  f178 = Math_fround(f176 * Math_fround(2.0));
  f175 = Math_fround(f174 * f181);
  f177 = Math_fround(f122 * Math_fround(2.0));
  f183 = Math_fround(f122 * Math_fround(-2.0));
  f119 = Math_fround(f174 * f183);
  f179 = Math_fround(f118 * Math_fround(-2.0));
  f185 = Math_fround(f118 * Math_fround(2.0));
  f123 = Math_fround(f174 * f179);
  f180 = Math_fround(Math_fround(f184 + Math_fround(Math_fround(Math_fround(f176 * f181) - Math_fround(f122 * f177)) * f184)) + Math_fround(Math_fround(Math_fround(f119 - Math_fround(f176 * f179)) * f186) + Math_fround(Math_fround(Math_fround(f185 * f122) - f175) * f182)));
  f181 = Math_fround(Math_fround(f186 + Math_fround(Math_fround(Math_fround(f118 * f178) - f119) * f184)) + Math_fround(Math_fround(Math_fround(Math_fround(f122 * f183) - Math_fround(f118 * f185)) * f186) + Math_fround(Math_fround(f123 - Math_fround(f122 * f181)) * f182)));
  f182 = Math_fround(Math_fround(Math_fround(Math_fround(f175 - Math_fround(f118 * f183)) * f184) + f182) + Math_fround(Math_fround(Math_fround(Math_fround(f176 * f177) - f123) * f186) + Math_fround(Math_fround(Math_fround(f118 * f179) - Math_fround(f176 * f178)) * f182)));
  f178 = Math_fround(HEAPF32[i143 >> 2]);
  f179 = Math_fround(HEAPF32[i153 >> 2]);
  f186 = Math_fround(HEAPF32[i167 >> 2]);
  i168 = Math_fround(Math_abs(Math_fround(f178))) < Math_fround(9.99999971e-10);
  i167 = Math_fround(Math_abs(Math_fround(f179))) < Math_fround(9.99999971e-10);
  i171 = Math_fround(Math_abs(Math_fround(f186))) < Math_fround(9.99999971e-10);
  f178 = Math_fround(Math_fround(1.0) / f178);
  f178 = i168 ? Math_fround(1.0) : f178;
  f179 = Math_fround(Math_fround(1.0) / f179);
  f179 = i167 ? Math_fround(1.0) : f179;
  f186 = Math_fround(Math_fround(1.0) / f186);
  f186 = i171 ? Math_fround(1.0) : f186;
  f180 = Math_fround(f180 * f178);
  f181 = Math_fround(f181 * f179);
  f182 = Math_fround(f182 * f186);
  f123 = Math_fround(HEAPF32[i172 + 12 >> 2]);
  f177 = Math_fround(f176 * f123);
  f184 = Math_fround(HEAPF32[i172 + 24 >> 2]);
  f183 = Math_fround(f174 * f184);
  f175 = Math_fround(HEAPF32[i172 + 16 >> 2]);
  f185 = Math_fround(f122 * f175);
  f119 = Math_fround(HEAPF32[i172 + 20 >> 2]);
  f177 = Math_fround(Math_fround(Math_fround(f177 - Math_fround(f174 * f119)) - Math_fround(f122 * f184)) - Math_fround(f118 * f175));
  f183 = Math_fround(Math_fround(Math_fround(f183 - Math_fround(f118 * f123)) - Math_fround(f122 * f119)) - Math_fround(f176 * f175));
  f185 = Math_fround(Math_fround(Math_fround(f185 - Math_fround(f176 * f119)) - Math_fround(f174 * f123)) - Math_fround(f118 * f184));
  f184 = Math_fround(Math_fround(Math_fround(Math_fround(f118 * f119) - Math_fround(f122 * f123)) - Math_fround(f174 * f175)) - Math_fround(f176 * f184));
  i171 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
  i167 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i168 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f184 = Math_fround(HEAPF32[i172 + 28 >> 2]);
  f185 = Math_fround(HEAPF32[i172 + 32 >> 2]);
  f184 = Math_fround(f178 * f184);
  f185 = Math_fround(f179 * f185);
  f186 = Math_fround(f186 * Math_fround(HEAPF32[i172 + 36 >> 2]));
  HEAPF32[i151 >> 2] = f180;
  HEAPF32[i169 + 152 >> 2] = f181;
  HEAPF32[i169 + 156 >> 2] = f182;
  HEAP32[i169 + 160 >> 2] = i167 ^ -2147483648;
  HEAP32[i169 + 164 >> 2] = i168;
  HEAP32[i169 + 168 >> 2] = i171 ^ -2147483648;
  HEAPF32[i152 >> 2] = f183;
  HEAPF32[i169 + 176 >> 2] = f184;
  HEAPF32[i154 >> 2] = f185;
  HEAPF32[i155 >> 2] = f186;
 }
 if (Math_fround(HEAPF32[i169 >> 2]) != Math_fround(0.0) & i170) {
  f179 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f117 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f122 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f117 * f179);
  f181 = Math_fround(f122 * f181);
  f185 = Math_fround(f183 * f185);
  f180 = Math_fround(f30 * Math_fround(-2.0));
  f184 = Math_fround(f30 * Math_fround(2.0));
  f123 = Math_fround(f48 * f180);
  f177 = Math_fround(f25 * Math_fround(2.0));
  f174 = Math_fround(f25 * Math_fround(-2.0));
  f119 = Math_fround(f48 * f174);
  f186 = Math_fround(Math_fround(f30 * f180) - Math_fround(f25 * f177));
  f176 = Math_fround(Math_fround(f47 * f184) - f119);
  f175 = Math_fround(f123 - Math_fround(f47 * f174));
  f93 = Math_fround(f47 * Math_fround(-2.0));
  f100 = Math_fround(f47 * Math_fround(2.0));
  f107 = Math_fround(f48 * f93);
  f119 = Math_fround(f119 - Math_fround(f93 * f30));
  f174 = Math_fround(Math_fround(f25 * f174) - Math_fround(f47 * f100));
  f177 = Math_fround(Math_fround(f30 * f177) - f107);
  f123 = Math_fround(Math_fround(f100 * f25) - f123);
  f180 = Math_fround(f107 - Math_fround(f180 * f25));
  f184 = Math_fround(Math_fround(f47 * f93) - Math_fround(f30 * f184));
  f93 = Math_fround(f21 + Math_fround(Math_fround(f179 + Math_fround(f186 * f179)) + Math_fround(Math_fround(f119 * f181) + Math_fround(f123 * f185))));
  f107 = Math_fround(f20 + Math_fround(Math_fround(f181 + Math_fround(f176 * f179)) + Math_fround(Math_fround(f174 * f181) + Math_fround(f180 * f185))));
  f185 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f175 * f179) + f185) + Math_fround(Math_fround(f177 * f181) + Math_fround(f184 * f185))));
  f181 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f30 * f181);
  f100 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f48 * f100);
  f95 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f94 = Math_fround(f25 * f95);
  f98 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(Math_fround(Math_fround(f179 - Math_fround(f48 * f98)) - Math_fround(f25 * f100)) - Math_fround(f47 * f95));
  f178 = Math_fround(Math_fround(Math_fround(f178 - Math_fround(f47 * f181)) - Math_fround(f25 * f98)) - Math_fround(f30 * f95));
  f94 = Math_fround(Math_fround(Math_fround(f94 - Math_fround(f30 * f98)) - Math_fround(f48 * f181)) - Math_fround(f47 * f100));
  f100 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f98) - Math_fround(f25 * f181)) - Math_fround(f48 * f95)) - Math_fround(f30 * f100));
  i172 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0);
  i168 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i167 = (HEAPF32[tempDoublePtr >> 2] = f100, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f100 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f94 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f94 = Math_fround(f93 - f94);
  f179 = Math_fround(f107 - f179);
  f185 = Math_fround(f185 - (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f107 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f93 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f95 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f107 * Math_fround(-2.0));
  f98 = Math_fround(f107 * Math_fround(2.0));
  f91 = Math_fround(f100 * f181);
  f182 = Math_fround(f95 * Math_fround(2.0));
  f92 = Math_fround(f95 * Math_fround(-2.0));
  f89 = Math_fround(f100 * f92);
  f112 = Math_fround(f93 * Math_fround(-2.0));
  f90 = Math_fround(f93 * Math_fround(2.0));
  f105 = Math_fround(f112 * f100);
  f118 = Math_fround(Math_fround(f94 + Math_fround(Math_fround(Math_fround(f107 * f181) - Math_fround(f95 * f182)) * f94)) + Math_fround(Math_fround(Math_fround(f89 - Math_fround(f107 * f112)) * f179) + Math_fround(Math_fround(Math_fround(f90 * f95) - f91) * f185)));
  f181 = Math_fround(Math_fround(f179 + Math_fround(Math_fround(Math_fround(f93 * f98) - f89) * f94)) + Math_fround(Math_fround(Math_fround(Math_fround(f95 * f92) - Math_fround(f93 * f90)) * f179) + Math_fround(Math_fround(f105 - Math_fround(f95 * f181)) * f185)));
  f185 = Math_fround(Math_fround(f185 + Math_fround(Math_fround(f91 - Math_fround(f93 * f92)) * f94)) + Math_fround(Math_fround(Math_fround(Math_fround(f107 * f182) - f105) * f179) + Math_fround(Math_fround(Math_fround(f93 * f112) - Math_fround(f107 * f98)) * f185)));
  f98 = (HEAP32[tempDoublePtr >> 2] = i168 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = Math_fround(f107 * f98);
  f179 = Math_fround(f100 * f178);
  f105 = (HEAP32[tempDoublePtr >> 2] = i167, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f95 * f105);
  f94 = (HEAP32[tempDoublePtr >> 2] = i172 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = Math_fround(Math_fround(Math_fround(f112 - Math_fround(f100 * f94)) - Math_fround(f95 * f178)) - Math_fround(f93 * f105));
  f179 = Math_fround(Math_fround(Math_fround(f179 - Math_fround(f93 * f98)) - Math_fround(f95 * f94)) - Math_fround(f107 * f105));
  f182 = Math_fround(Math_fround(Math_fround(f182 - Math_fround(f107 * f94)) - Math_fround(f100 * f98)) - Math_fround(f93 * f178));
  f178 = Math_fround(Math_fround(Math_fround(Math_fround(f93 * f94) - Math_fround(f95 * f98)) - Math_fround(f100 * f105)) - Math_fround(f107 * f178));
  i172 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  i167 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
  i168 = (HEAPF32[tempDoublePtr >> 2] = f178, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAPF32[i156 >> 2] = f118;
  i154 = i169 + 192 | 0;
  HEAPF32[i154 >> 2] = f181;
  i155 = i169 + 196 | 0;
  HEAPF32[i155 >> 2] = f185;
  HEAP32[i169 + 200 >> 2] = i167 ^ -2147483648;
  i167 = i169 + 204 | 0;
  HEAP32[i167 >> 2] = i168;
  i168 = i169 + 208 | 0;
  HEAP32[i168 >> 2] = i172 ^ -2147483648;
  HEAPF32[i157 >> 2] = f179;
  HEAP32[i158 >> 2] = i12;
  HEAP32[i159 >> 2] = i13;
  HEAP32[i160 >> 2] = i14;
  f179 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f117 * f179);
  f185 = Math_fround(f122 * f185);
  f183 = Math_fround(f183 * (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f123 = Math_fround(f21 + Math_fround(Math_fround(f179 + Math_fround(f186 * f179)) + Math_fround(Math_fround(f119 * f185) + Math_fround(f123 * f183))));
  f180 = Math_fround(f20 + Math_fround(Math_fround(f185 + Math_fround(f176 * f179)) + Math_fround(Math_fround(f174 * f185) + Math_fround(f180 * f183))));
  f183 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f175 * f179) + f183) + Math_fround(Math_fround(f177 * f185) + Math_fround(f184 * f183))));
  f184 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(f30 * f184);
  f177 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f48 * f177);
  f175 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = Math_fround(f25 * f175);
  f176 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = Math_fround(Math_fround(Math_fround(f185 - Math_fround(f48 * f176)) - Math_fround(f25 * f177)) - Math_fround(f47 * f175));
  f179 = Math_fround(Math_fround(Math_fround(f179 - Math_fround(f47 * f184)) - Math_fround(f25 * f176)) - Math_fround(f30 * f175));
  f174 = Math_fround(Math_fround(Math_fround(f174 - Math_fround(f30 * f176)) - Math_fround(f48 * f184)) - Math_fround(f47 * f177));
  f177 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f176) - Math_fround(f25 * f184)) - Math_fround(f48 * f175)) - Math_fround(f30 * f177));
  i172 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
  i171 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
  i170 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f177 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f185 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = Math_fround(f123 - f174);
  f185 = Math_fround(f180 - f185);
  f183 = Math_fround(f183 - (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f180 = (HEAP32[tempDoublePtr >> 2] = i29 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = Math_fround(f180 * Math_fround(-2.0));
  f176 = Math_fround(f180 * Math_fround(2.0));
  f119 = Math_fround(f177 * f184);
  f186 = Math_fround(f175 * Math_fround(2.0));
  f122 = Math_fround(f175 * Math_fround(-2.0));
  f117 = Math_fround(f177 * f122);
  f181 = Math_fround(f123 * Math_fround(-2.0));
  f118 = Math_fround(f123 * Math_fround(2.0));
  f178 = Math_fround(f181 * f177);
  f182 = Math_fround(Math_fround(f174 + Math_fround(Math_fround(Math_fround(f180 * f184) - Math_fround(f175 * f186)) * f174)) + Math_fround(Math_fround(Math_fround(f117 - Math_fround(f180 * f181)) * f185) + Math_fround(Math_fround(Math_fround(f118 * f175) - f119) * f183)));
  f184 = Math_fround(Math_fround(f185 + Math_fround(Math_fround(Math_fround(f123 * f176) - f117) * f174)) + Math_fround(Math_fround(Math_fround(Math_fround(f175 * f122) - Math_fround(f123 * f118)) * f185) + Math_fround(Math_fround(f178 - Math_fround(f175 * f184)) * f183)));
  f183 = Math_fround(Math_fround(f183 + Math_fround(Math_fround(f119 - Math_fround(f123 * f122)) * f174)) + Math_fround(Math_fround(Math_fround(Math_fround(f180 * f186) - f178) * f185) + Math_fround(Math_fround(Math_fround(f123 * f181) - Math_fround(f180 * f176)) * f183)));
  f176 = (HEAP32[tempDoublePtr >> 2] = i171 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f180 * f176);
  f185 = Math_fround(f177 * f179);
  f178 = (HEAP32[tempDoublePtr >> 2] = i170, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f186 = Math_fround(f175 * f178);
  f174 = (HEAP32[tempDoublePtr >> 2] = i172 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(Math_fround(Math_fround(f181 - Math_fround(f177 * f174)) - Math_fround(f175 * f179)) - Math_fround(f123 * f178));
  f185 = Math_fround(Math_fround(Math_fround(f185 - Math_fround(f123 * f176)) - Math_fround(f175 * f174)) - Math_fround(f180 * f178));
  f186 = Math_fround(Math_fround(Math_fround(f186 - Math_fround(f180 * f174)) - Math_fround(f177 * f176)) - Math_fround(f123 * f179));
  f179 = Math_fround(Math_fround(Math_fround(Math_fround(f123 * f174) - Math_fround(f175 * f176)) - Math_fround(f177 * f178)) - Math_fround(f180 * f179));
  i172 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
  i170 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
  i170 = i170 ^ -2147483648;
  i171 = (HEAPF32[tempDoublePtr >> 2] = f179, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i172 = i172 ^ -2147483648;
  HEAPF32[i161 >> 2] = f182;
  HEAPF32[i169 + 232 >> 2] = f184;
  HEAPF32[i169 + 236 >> 2] = f183;
  HEAP32[i169 + 240 >> 2] = i170;
  HEAP32[i169 + 244 >> 2] = i171;
  HEAP32[i169 + 248 >> 2] = i172;
  HEAPF32[i162 >> 2] = f185;
  HEAP32[i163 >> 2] = i12;
  HEAP32[i164 >> 2] = i13;
  HEAP32[i165 >> 2] = i14;
  f179 = Math_fround(HEAPF32[i156 >> 2]);
  f186 = Math_fround(HEAPF32[i154 >> 2]);
  f181 = Math_fround(HEAPF32[i155 >> 2]);
  f181 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f179 * f179) + Math_fround(f186 * f186)) + Math_fround(Math_fround(f181 * f181) + Math_fround(0.0)))));
  f186 = Math_fround(HEAPF32[i169 >> 2]);
  HEAPF32[i166 >> 2] = Math_fround(f181 / f186);
  f181 = Math_fround(HEAPF32[i157 >> 2]);
  f179 = Math_fround(HEAPF32[i169 + 200 >> 2]);
  f180 = Math_fround(HEAPF32[i167 >> 2]);
  f179 = Math_fround(Math_fround(+Math_atan(+Math_fround(f179 / f181))) * Math_fround(2.0));
  f180 = Math_fround(Math_fround(+Math_atan(+Math_fround(f180 / f181))) * Math_fround(2.0));
  f181 = Math_fround(Math_fround(+Math_atan(+Math_fround(Math_fround(HEAPF32[i168 >> 2]) / f181))) * Math_fround(2.0));
  HEAPF32[i169 + 272 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f179 * f179) + Math_fround(f180 * f180)) + Math_fround(Math_fround(f181 * f181) + Math_fround(0.0))))) / f186);
  HEAPF32[i169 + 276 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f182 * f182) + Math_fround(f184 * f184)) + Math_fround(Math_fround(f183 * f183) + Math_fround(0.0))))) / f186);
  f183 = (HEAP32[tempDoublePtr >> 2] = i170, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f184 = (HEAP32[tempDoublePtr >> 2] = i171, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f183 = Math_fround(Math_fround(+Math_atan(+Math_fround(f183 / f185))) * Math_fround(2.0));
  f184 = Math_fround(Math_fround(+Math_atan(+Math_fround(f184 / f185))) * Math_fround(2.0));
  f185 = Math_fround(Math_fround(+Math_atan(+Math_fround((HEAP32[tempDoublePtr >> 2] = i172, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f185))) * Math_fround(2.0));
  HEAPF32[i169 + 280 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f183 * f183) + Math_fround(f184 * f184)) + Math_fround(Math_fround(f185 * f185) + Math_fround(0.0))))) / f186);
 }
 STACKTOP = i173;
 return;
}

function __ZN13SpeedTreeWind7SParams8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482386 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482406 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482427 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482443 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482466 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482481 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482496 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482511 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482526 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482541 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482556 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482571 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482586 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482601 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482616 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482631 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 171; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 171;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482646 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 182; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 182;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 182) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482661 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 193; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 193;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 193) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482676 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 204; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 204;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 204) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482691 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 215; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 215;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 215) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482706 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 226; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 226;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 226) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482721 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 237; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 237;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 237) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482736 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 248; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 248;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 248) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482751 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 259; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 259;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 259) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482766 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 270; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 270;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 270) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482781 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 281; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 281;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 281) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482796 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 292; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 292;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 292) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482811 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 303; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 303;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 303) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482826 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 314; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 314;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 314) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482841 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 325; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 325;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 325) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482856 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 336; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 336;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 336) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482871 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   do if (i1 >>> 0 < i2 >>> 0) i8 = 347; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 347;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   } while (0);
   if ((i8 | 0) == 347) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482886 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 358; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 358;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 358) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482901 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 369; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 369;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 369) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482916 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 380; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 380;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 380) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482931 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 391; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 391;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 391) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482946 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 402; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 402;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 402) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482961 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 413; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 413;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 413) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482976 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 424; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 424;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 424) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482991 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 435; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 435;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 435) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 160 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483006 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 446; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 446;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 446) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 164 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483021 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 457; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 457;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 457) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483036 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 468; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 468;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 468) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 172 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483051 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 479; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 479;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 479) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483066 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 490; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 490;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 490) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483081 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 501; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 501;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 501) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 184 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483096 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 512; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 512;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 512) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 188 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483111 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 523; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 523;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 523) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483126 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 534; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 534;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 534) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 196 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483141 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 545; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 545;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 545) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483156 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 556; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 556;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 556) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 204 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483171 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 567; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 567;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 567) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 208 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483186 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 578; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 578;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 578) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 212 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483201 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 589; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 589;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 589) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 216 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483216 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 600; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 600;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 600) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 220 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483231 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 611; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 611;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 611) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 224 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483246 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 622; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 622;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 622) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 228 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483261 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 633; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 633;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 633) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 232 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483276 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 644; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 644;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 644) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 236 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483291 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 655; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 655;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 655) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 240 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483306 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 666; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 666;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 666) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 244 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483321 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 677; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 677;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 677) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 248 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483336 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 688; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 688;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 688) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 252 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483351 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 699; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 699;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 699) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 256 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483366 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 710; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 710;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 710) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 260 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483381 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 721; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 721;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 721) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 264 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483396 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 732; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 732;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 732) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 268 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483411 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 743; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 743;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 743) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483426 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 754; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 754;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 754) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483441 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 765; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 765;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 765) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483456 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 776; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 776;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 776) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 284 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483471 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 787; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 787;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 787) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483486 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 798; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 798;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 798) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483501 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 809; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 809;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 809) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 296 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483516 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 820; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 820;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 820) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 300 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483531 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 831; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 831;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 831) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 304 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483546 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 842; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 842;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 842) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483561 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 853; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 853;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 853) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 312 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483576 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 864; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 864;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 864) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 316 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483591 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 875; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 875;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 875) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 320 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483606 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 886; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 886;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 886) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 324 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483621 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 897; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 897;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 897) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 328 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483636 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 908; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 908;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 908) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 332 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483651 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 919; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 919;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 919) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483666 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 930; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 930;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 930) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 340 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483681 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 941; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 941;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 941) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 344 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483696 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 952; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 952;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 952) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 348 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483711 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 963; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 963;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 963) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483726 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 974; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 974;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 974) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 356 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483741 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 985; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 985;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 985) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 360 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483756 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i8 = 996; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 996;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 996) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 364 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483771 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1007; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1007;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1007) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483786 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1018; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1018;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1018) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483801 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1029; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1029;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1029) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 376 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483816 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1040; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1040;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1040) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 380 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483831 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1051; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1051;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1051) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 384 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483846 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1062; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1062;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1062) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 388 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483861 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1073; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1073;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1073) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 392 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483876 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1084; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1084;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1084) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 396 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483891 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1095; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1095;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1095) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 400 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483906 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1106; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1106;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1106) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 404 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483921 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1117; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1117;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1117) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 408 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483936 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1128; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1128;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1128) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 412 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483951 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1139; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1139;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1139) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 416 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483966 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1150; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1150;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1150) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 420 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 483982 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1161; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1161;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1161) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 424 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484006 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1172; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1172;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1172) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 428 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484027 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1183; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1183;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1183) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 432 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484048 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1194; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1194;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1194) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 436 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484069 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1205; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1205;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1205) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 440 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484090 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1216; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1216;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1216) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 444 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484111 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1227; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1227;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1227) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 448 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484132 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1238; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1238;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1238) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 452 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484153 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1249; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1249;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1249) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 456 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484174 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1260; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1260;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1260) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 460 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484195 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1271; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1271;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1271) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 464 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484216 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1282; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1282;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1282) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 468 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484247 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1293; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1293;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1293) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 472 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484278 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1304; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1304;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1304) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 476 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484309 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1315; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1315;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1315) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 480 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484340 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1326; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1326;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1326) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 484 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484371 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1337; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1337;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1337) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 488 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484402 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1348; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1348;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1348) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 492 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484433 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1359; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1359;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1359) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 496 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484464 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1370; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1370;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1370) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 500 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484495 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1381; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1381;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1381) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 504 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484526 | 0, gb + 484539 | 0, i7, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN13SpeedTreeWind16SBranchWindLevel8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 636 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484556 | 0, gb + 484539 | 0, i7, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN13SpeedTreeWind16SBranchWindLevel8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 768 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484569 | 0, gb + 484580 | 0, i7, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN13SpeedTreeWind10SWindGroup8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 992 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484591 | 0, gb + 484580 | 0, i7, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN13SpeedTreeWind10SWindGroup8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1216 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484602 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1416; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1416;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1416) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1220 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484628 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1427; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1427;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1427) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1224 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484654 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1438; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1438;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1438) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1228 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484680 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1449; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1449;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1449) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1232 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484706 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1460; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1460;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1460) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1236 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484732 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1471; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1471;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1471) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1240 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484758 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1482; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1482;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1482) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1244 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484784 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1493; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1493;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1493) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1248 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484810 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1504; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1504;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1504) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1252 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484836 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1515; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1515;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1515) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1256 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484862 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1526; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1526;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1526) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1260 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484881 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1537; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1537;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1537) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1264 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484910 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1548; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1548;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1548) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1268 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484930 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1559; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1559;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1559) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484951 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1570; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1570;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1570) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484977 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1581; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1581;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1581) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 484999 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1592; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1592;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1592) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1284 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485020 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1603; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1603;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1603) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485045 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1614; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1614;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1614) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485076 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1625; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1625;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1625) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1296 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485107 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1636; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1636;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1636) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1300 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485131 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1647; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1647;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1647) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1304 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485155 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1658; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1658;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1658) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485172 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1669; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1669;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1669) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1312 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485191 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1680; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1680;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1680) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1316 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485210 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1691; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1691;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1691) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1320 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485229 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1702; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1702;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1702) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1324 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485248 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 1713; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 1713;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 1713) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 1328 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485266 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 1724; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 1724;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 1724) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i9 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) {
 i28 = i28 | 0;
 i23 = i23 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i32 + 296 | 0;
 i29 = i32 + 272 | 0;
 i27 = i32 + 248 | 0;
 i26 = i32 + 228 | 0;
 i25 = i32 + 208 | 0;
 i24 = i32 + 152 | 0;
 i8 = i32 + 132 | 0;
 i22 = i32 + 112 | 0;
 i7 = i32 + 92 | 0;
 i10 = i32 + 72 | 0;
 i9 = i32 + 52 | 0;
 i15 = i32 + 32 | 0;
 i21 = i32 + 12 | 0;
 i5 = i32 + 196 | 0;
 i13 = i32;
 i11 = i32 + 184 | 0;
 i12 = i32 + 172 | 0;
 L1 : do if ((i28 | 0) == (i23 | 0)) i1 = i28; else {
  switch (HEAP8[i28 >> 0] | 0) {
  case 75:
  case 86:
  case 114:
   {
    HEAP32[i29 >> 2] = 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj(i28, i23, i29) | 0;
    L5 : do if ((i2 | 0) == (i28 | 0)) i1 = i28; else {
     i3 = HEAP8[i2 >> 0] | 0;
     i17 = i31 + 4 | 0;
     i8 = ((HEAP32[i17 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i23, i31) | 0;
     i17 = ((HEAP32[i17 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     if ((i1 | 0) == (i2 | 0)) i1 = i28; else {
      i15 = i3 << 24 >> 24 == 70;
      i16 = i31 + 20 | 0;
      i2 = HEAP32[i16 >> 2] | 0;
      L8 : do if (i15) {
       i3 = i2 + -16 | 0;
       while (1) {
        if ((i2 | 0) == (i3 | 0)) {
         i2 = i3;
         break L8;
        }
        i30 = i2 + -16 | 0;
        HEAP32[i16 >> 2] = i30;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i30);
        i2 = HEAP32[i16 >> 2] | 0;
       }
      } while (0);
      i5 = i31 + 16 | 0;
      i4 = HEAP32[i31 + 12 >> 2] | 0;
      i30 = HEAP32[i31 + 24 >> 2] | 0;
      i6 = i30;
      do if (i2 >>> 0 < i30 >>> 0) {
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP32[i2 + 12 >> 2] = i4;
       HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 16;
      } else {
       i7 = HEAP32[i5 >> 2] | 0;
       i2 = i2 - i7 >> 4;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5); else {
        i28 = i6 - i7 | 0;
        i30 = i28 >> 3;
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i28 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
        i30 = i33 + 8 | 0;
        i28 = HEAP32[i30 >> 2] | 0;
        HEAP32[i28 >> 2] = 0;
        HEAP32[i28 + 4 >> 2] = 0;
        HEAP32[i28 + 8 >> 2] = 0;
        HEAP32[i28 + 12 >> 2] = i4;
        HEAP32[i30 >> 2] = i28 + 16;
        __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i33);
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
        break;
       }
      } while (0);
      i13 = HEAP32[i29 >> 2] | 0;
      i11 = (i13 & 1 | 0) == 0;
      i12 = (i13 & 2 | 0) == 0;
      i13 = (i13 & 4 | 0) == 0;
      i14 = i33 + 8 | 0;
      i10 = i8;
      while (1) {
       if (i10 >>> 0 >= i17 >>> 0) break L5;
       if (i15) {
        i4 = HEAP32[i31 >> 2] | 0;
        i8 = i4 + (i10 * 24 | 0) + 12 | 0;
        i5 = HEAP8[i8 + 11 >> 0] | 0;
        i2 = i5 << 24 >> 24 < 0;
        if (i2) {
         i6 = HEAP32[i4 + (i10 * 24 | 0) + 16 >> 2] | 0;
         i3 = HEAP32[i8 >> 2] | 0;
        } else {
         i6 = i5 & 255;
         i3 = i8;
        }
        i7 = i6 + -2 | 0;
        if ((HEAP8[i3 + i7 >> 0] | 0) == 38) i2 = i6 + -3 | 0; else {
         if (i2) {
          i3 = HEAP32[i8 >> 2] | 0;
          i2 = HEAP32[i4 + (i10 * 24 | 0) + 16 >> 2] | 0;
         } else {
          i3 = i8;
          i2 = i5 & 255;
         }
         i2 = (HEAP8[i3 + i2 + -1 >> 0] | 0) == 38 ? i7 : i6;
        }
        if (!i11) {
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i8, i2, gb + 1086338 | 0) | 0;
         i2 = i2 + 6 | 0;
        }
        if (!i12) {
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i10 * 24 | 0) + 12 | 0, i2, gb + 1086345 | 0) | 0;
         i2 = i2 + 9 | 0;
        }
        if (!i13) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i10 * 24 | 0) + 12 | 0, i2, gb + 1086355 | 0) | 0;
       } else {
        if (!i11) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i31 >> 2] | 0) + (i10 * 24 | 0) | 0, gb + 1086338 | 0) | 0;
        if (!i12) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i31 >> 2] | 0) + (i10 * 24 | 0) | 0, gb + 1086345 | 0) | 0;
        if (!i13) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i31 >> 2] | 0) + (i10 * 24 | 0) | 0, gb + 1086355 | 0) | 0;
       }
       i5 = HEAP32[i16 >> 2] | 0;
       i9 = i5 + -16 | 0;
       i7 = HEAP32[i31 >> 2] | 0;
       i8 = i7 + (i10 * 24 | 0) | 0;
       i2 = i5 + -12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i30 = HEAP32[i5 + -8 >> 2] | 0;
       i6 = i30;
       if ((i3 | 0) == (i30 | 0)) {
        i4 = HEAP32[i9 >> 2] | 0;
        i2 = (i3 - i4 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         i30 = 43;
         break;
        }
        i29 = (i6 - i4 | 0) / 24 | 0;
        i30 = i29 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i29 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i5 + -4 | 0);
        i2 = HEAP32[i14 >> 2] | 0;
        __THREW__ = 0;
        invoke_vii(fb + 4621 | 0, i2 | 0, i8 | 0);
        i30 = __THREW__;
        __THREW__ = 0;
        if (i30 & 1) {
         i30 = 47;
         break;
        }
        __THREW__ = 0;
        invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i7 + (i10 * 24 | 0) + 12 | 0);
        i30 = __THREW__;
        __THREW__ = 0;
        if (i30 & 1) {
         i30 = 46;
         break;
        }
        HEAP32[i14 >> 2] = i2 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i9, i33);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       } else {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i8);
        __THREW__ = 0;
        invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i7 + (i10 * 24 | 0) + 12 | 0);
        i30 = __THREW__;
        __THREW__ = 0;
        if (i30 & 1) {
         i30 = 40;
         break;
        }
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
       }
       i10 = i10 + 1 | 0;
      }
      if ((i30 | 0) == 40) {
       i33 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
       ___resumeException(i33 | 0);
      } else if ((i30 | 0) == 43) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9); else if ((i30 | 0) == 46) {
       i18 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
      } else if ((i30 | 0) == 47) {
       i18 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      }
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      ___resumeException(i18 | 0);
     }
    } while (0);
    break L1;
   }
  default:
   {}
  }
  i1 = __ZN10__cxxabiv112_GLOBAL__N_118parse_builtin_typeINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
  if ((i1 | 0) == (i28 | 0)) {
   i2 = HEAP8[i28 >> 0] | 0;
   L71 : do switch (i2 << 24 >> 24 | 0) {
   case 65:
    {
     if (i2 << 24 >> 24 != 65) {
      i1 = i28;
      break L1;
     }
     i8 = i28 + 1 | 0;
     if ((i8 | 0) == (i23 | 0)) {
      i1 = i28;
      break L1;
     }
     i1 = HEAP8[i8 >> 0] | 0;
     L75 : do if (i1 << 24 >> 24 == 95) {
      i27 = i28 + 2 | 0;
      i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i27, i23, i31) | 0;
      if ((i1 | 0) == (i27 | 0)) {
       i1 = i28;
       break L1;
      }
      i3 = i31 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
       i1 = i28;
       break L1;
      }
      i26 = i2 + -12 | 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i33 + 4 >> 2] = 0;
      HEAP32[i33 + 8 >> 2] = 0;
      i27 = HEAP8[i26 + 11 >> 0] | 0;
      i25 = i27 << 24 >> 24 < 0;
      i27 = i25 ? HEAP32[i2 + -8 >> 2] | 0 : i27 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i25 ? HEAP32[i26 >> 2] | 0 : i26, i27 >>> 0 < 2 ? i27 : 2);
      i27 = HEAP8[i33 + 11 >> 0] | 0;
      i2 = i27 << 24 >> 24 < 0;
      if (((i2 ? HEAP32[i33 + 4 >> 2] | 0 : i27 & 255) | 0) == 2) {
       i27 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086365 | 0, 2) | 0) == 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       if (i27) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj((HEAP32[i3 >> 2] | 0) + -12 | 0);
      } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i3 >> 2] | 0) + -12 | 0, 0, gb + 1086368 | 0) | 0;
     } else {
      if ((i1 + -49 & 255) < 9) {
       i6 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i8, i23) | 0;
       if ((i6 | 0) == (i23 | 0)) {
        i1 = i28;
        break L1;
       }
       if ((HEAP8[i6 >> 0] | 0) != 95) {
        i1 = i28;
        break L1;
       }
       i26 = i6 + 1 | 0;
       i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i26, i23, i31) | 0;
       if ((i1 | 0) == (i26 | 0)) {
        i1 = i28;
        break L1;
       }
       i3 = i31 + 4 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
        i1 = i28;
        break L1;
       }
       i25 = i2 + -12 | 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i33 + 4 >> 2] = 0;
       HEAP32[i33 + 8 >> 2] = 0;
       i26 = HEAP8[i25 + 11 >> 0] | 0;
       i24 = i26 << 24 >> 24 < 0;
       i26 = i24 ? HEAP32[i2 + -8 >> 2] | 0 : i26 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i24 ? HEAP32[i25 >> 2] | 0 : i25, i26 >>> 0 < 2 ? i26 : 2);
       i26 = HEAP8[i33 + 11 >> 0] | 0;
       i2 = i26 << 24 >> 24 < 0;
       if (((i2 ? HEAP32[i33 + 4 >> 2] | 0 : i26 & 255) | 0) == 2) {
        i26 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086365 | 0, 2) | 0) == 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
        if (i26) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj((HEAP32[i3 >> 2] | 0) + -12 | 0);
       } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       i7 = (HEAP32[i3 >> 2] | 0) + -12 | 0;
       HEAP32[i27 >> 2] = 0;
       HEAP32[i27 + 4 >> 2] = 0;
       HEAP32[i27 + 8 >> 2] = 0;
       i5 = i6 - i8 | 0;
       if (i5 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
       if (i5 >>> 0 < 11) {
        HEAP8[i27 + 11 >> 0] = i5;
        i4 = i27;
       } else {
        i26 = i5 + 16 & -16;
        i4 = _malloc(i26) | 0;
        HEAP32[i27 >> 2] = i4;
        HEAP32[i27 + 8 >> 2] = i26 | -2147483648;
        HEAP32[i27 + 4 >> 2] = i5;
       }
       i2 = i8;
       i3 = i4;
       while (1) {
        if ((i2 | 0) == (i6 | 0)) break;
        HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
        i2 = i2 + 1 | 0;
        i3 = i3 + 1 | 0;
       }
       HEAP8[i4 + i5 >> 0] = 0;
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 520 | 0, i27 | 0, 0, gb + 1086365 | 0) | 0;
       i26 = __THREW__;
       __THREW__ = 0;
       if (i26 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i29 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i29 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __THREW__ = 0;
        i3 = invoke_iii(fb + 1152 | 0, i29 | 0, gb + 1086372 | 0) | 0;
        i26 = __THREW__;
        __THREW__ = 0;
        do if (i26 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i33 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i33 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i33 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         i26 = HEAP8[i33 + 11 >> 0] | 0;
         i25 = i26 << 24 >> 24 < 0;
         __THREW__ = 0;
         invoke_iiiii(fb + 216 | 0, i7 | 0, 0, (i25 ? HEAP32[i33 >> 2] | 0 : i33) | 0, (i25 ? HEAP32[i33 + 4 >> 2] | 0 : i26 & 255) | 0) | 0;
         i26 = __THREW__;
         __THREW__ = 0;
         if (i26 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
          break;
         } else {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
          break L75;
         }
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
      } else {
       i1 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i8, i23, i31) | 0;
       if ((i1 | 0) == (i8 | 0) | (i1 | 0) == (i23 | 0)) {
        i1 = i28;
        break L1;
       }
       if ((HEAP8[i1 >> 0] | 0) != 95) {
        i1 = i28;
        break L1;
       }
       i21 = i1 + 1 | 0;
       i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i21, i23, i31) | 0;
       if ((i1 | 0) == (i21 | 0)) {
        i1 = i28;
        break L1;
       }
       i12 = i31 + 4 | 0;
       i2 = HEAP32[i12 >> 2] | 0;
       if (((i2 - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
        i1 = i28;
        break L1;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i33, i2 + -24 | 0);
       i2 = HEAP32[i12 >> 2] | 0;
       i3 = i2 + -24 | 0;
       i4 = i2;
       while (1) {
        if ((i4 | 0) == (i3 | 0)) break;
        i23 = i4 + -24 | 0;
        HEAP32[i12 >> 2] = i23;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
        i4 = HEAP32[i12 >> 2] | 0;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i29, i2 + -48 | 0);
       i8 = HEAP32[i12 >> 2] | 0;
       i9 = i8 + -24 | 0;
       i10 = i9 + 11 | 0;
       if ((HEAP8[i10 >> 0] | 0) < 0) {
        HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
        HEAP32[i8 + -20 >> 2] = 0;
        i2 = HEAP8[i10 >> 0] | 0;
        if (i2 << 24 >> 24 < 0) {
         i6 = 1;
         i11 = 0;
         i5 = (HEAP32[i8 + -16 >> 2] & 2147483647) + -1 | 0;
        } else i30 = 107;
       } else {
        HEAP8[i9 >> 0] = 0;
        HEAP8[i10 >> 0] = 0;
        i2 = 0;
        i30 = 107;
       }
       if ((i30 | 0) == 107) {
        i6 = 0;
        i11 = i2 & 255;
        i5 = 10;
       }
       i3 = i11 >>> 0 < 11;
       i7 = i3 ? 10 : (i11 + 16 & 496) + -1 | 0;
       L142 : do if ((i7 | 0) != (i5 | 0)) {
        do if (i3) {
         i3 = HEAP32[i9 >> 2] | 0;
         if (i6) {
          i2 = 0;
          i4 = i9;
          i30 = 115;
         } else {
          i5 = 0;
          i6 = 1;
          i4 = i9;
          i30 = 116;
         }
        } else {
         i4 = _malloc(i7 + 1 | 0) | 0;
         if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L142;
         if (i6) {
          i2 = 1;
          i3 = HEAP32[i9 >> 2] | 0;
          i30 = 115;
          break;
         } else {
          i5 = 1;
          i6 = 0;
          i3 = i9;
          i30 = 116;
          break;
         }
        } while (0);
        if ((i30 | 0) == 115) {
         i5 = i2;
         i6 = 1;
         i2 = HEAP32[i8 + -20 >> 2] | 0;
        } else if ((i30 | 0) == 116) i2 = i2 & 255;
        i2 = i2 + 1 | 0;
        if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
        if (i6) _free(i3);
        if (i5) {
         HEAP32[i8 + -16 >> 2] = i7 + 1 | -2147483648;
         HEAP32[i8 + -20 >> 2] = i11;
         HEAP32[i9 >> 2] = i4;
         break;
        } else {
         HEAP8[i10 >> 0] = i11;
         break;
        }
       } while (0);
       HEAP32[i9 >> 2] = HEAP32[i33 >> 2];
       HEAP32[i9 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
       HEAP32[i9 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i33 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i4 = i33 + 12 | 0;
       HEAP32[i27 >> 2] = 0;
       HEAP32[i27 + 4 >> 2] = 0;
       HEAP32[i27 + 8 >> 2] = 0;
       i5 = i4 + 11 | 0;
       i23 = HEAP8[i5 >> 0] | 0;
       i21 = i23 << 24 >> 24 < 0;
       i6 = i33 + 16 | 0;
       i23 = i21 ? HEAP32[i6 >> 2] | 0 : i23 & 255;
       __THREW__ = 0;
       invoke_viii(fb + 1064 | 0, i27 | 0, (i21 ? HEAP32[i4 >> 2] | 0 : i4) | 0, (i23 >>> 0 < 2 ? i23 : 2) | 0);
       i23 = __THREW__;
       __THREW__ = 0;
       if (i23 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        i23 = HEAP8[i27 + 11 >> 0] | 0;
        i2 = i23 << 24 >> 24 < 0;
        do if (((i2 ? HEAP32[i27 + 4 >> 2] | 0 : i23 & 255) | 0) == 2) {
         i23 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i27 >> 2] | 0 : i27, gb + 1086365 | 0, 2) | 0) == 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
         if (!i23) break;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj(i4);
        } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27); while (0);
        i10 = HEAP32[i12 >> 2] | 0;
        i11 = i10 + -12 | 0;
        __THREW__ = 0;
        invoke_vii(fb + 4619 | 0, i24 | 0, i29 | 0);
        i23 = __THREW__;
        __THREW__ = 0;
        if (i23 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         __THREW__ = 0;
         i3 = invoke_iiii(fb + 520 | 0, i24 | 0, 0, gb + 1086365 | 0) | 0;
         i23 = __THREW__;
         __THREW__ = 0;
         if (i23 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
          HEAP32[i25 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
          HEAP32[i25 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i3 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          __THREW__ = 0;
          i3 = invoke_iii(fb + 1152 | 0, i25 | 0, gb + 1086372 | 0) | 0;
          i23 = __THREW__;
          __THREW__ = 0;
          do if (i23 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           i3 = HEAP8[i5 >> 0] | 0;
           i23 = i3 << 24 >> 24 < 0;
           __THREW__ = 0;
           i3 = invoke_iiii(fb + 519 | 0, i26 | 0, (i23 ? HEAP32[i4 >> 2] | 0 : i4) | 0, (i23 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0) | 0;
           i23 = __THREW__;
           __THREW__ = 0;
           if (i23 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
            break;
           };
           HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i3 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           i8 = i11 + 11 | 0;
           do if ((HEAP8[i8 >> 0] | 0) < 0) {
            HEAP8[HEAP32[i11 >> 2] >> 0] = 0;
            HEAP32[i10 + -8 >> 2] = 0;
            i2 = HEAP8[i8 >> 0] | 0;
            if (i2 << 24 >> 24 >= 0) {
             i30 = 150;
             break;
            }
            i6 = 1;
            i9 = 0;
            i5 = (HEAP32[i10 + -4 >> 2] & 2147483647) + -1 | 0;
           } else {
            HEAP8[i11 >> 0] = 0;
            HEAP8[i8 >> 0] = 0;
            i2 = 0;
            i30 = 150;
           } while (0);
           if ((i30 | 0) == 150) {
            i6 = 0;
            i9 = i2 & 255;
            i5 = 10;
           }
           i3 = i9 >>> 0 < 11;
           i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
           L208 : do if ((i7 | 0) != (i5 | 0)) {
            do if (i3) {
             i3 = HEAP32[i11 >> 2] | 0;
             if (i6) {
              i2 = 0;
              i4 = i11;
              i30 = 158;
             } else {
              i5 = 0;
              i6 = 1;
              i4 = i11;
              i30 = 159;
             }
            } else {
             i4 = _malloc(i7 + 1 | 0) | 0;
             if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L208;
             if (i6) {
              i2 = 1;
              i3 = HEAP32[i11 >> 2] | 0;
              i30 = 158;
              break;
             } else {
              i5 = 1;
              i6 = 0;
              i3 = i11;
              i30 = 159;
              break;
             }
            } while (0);
            if ((i30 | 0) == 158) {
             i5 = i2;
             i6 = 1;
             i2 = HEAP32[i10 + -8 >> 2] | 0;
            } else if ((i30 | 0) == 159) i2 = i2 & 255;
            i2 = i2 + 1 | 0;
            if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
            if (i6) _free(i3);
            if (i5) {
             HEAP32[i10 + -4 >> 2] = i7 + 1 | -2147483648;
             HEAP32[i10 + -8 >> 2] = i9;
             HEAP32[i11 >> 2] = i4;
             break;
            } else {
             HEAP8[i8 >> 0] = i9;
             break;
            }
           } while (0);
           HEAP32[i11 >> 2] = HEAP32[i27 >> 2];
           HEAP32[i11 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
           HEAP32[i11 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
           i2 = 0;
           while (1) {
            if ((i2 | 0) == 3) break;
            HEAP32[i27 + (i2 << 2) >> 2] = 0;
            i2 = i2 + 1 | 0;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
           break L75;
          } while (0);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
        }
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
      }
      ___resumeException(i1 | 0);
     } while (0);
     if ((i1 | 0) == (i28 | 0)) {
      i1 = i28;
      break L1;
     }
     i2 = HEAP32[i31 + 4 >> 2] | 0;
     if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     i6 = i31 + 16 | 0;
     HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
     i2 = i31 + 20 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i29 = HEAP32[i31 + 24 >> 2] | 0;
     i5 = i29;
     do if (i3 >>> 0 < i29 >>> 0) {
      HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
      i31 = i33 + 4 | 0;
      HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
      i30 = i33 + 8 | 0;
      HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i30 >> 2] = 0;
      HEAP32[i31 >> 2] = 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
     } else {
      i4 = HEAP32[i6 >> 2] | 0;
      i2 = i3 - i4 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i6 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       break L71;
      } else {
       i29 = i5 - i4 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i22, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i31 = i22 + 8 | 0;
       i30 = HEAP32[i31 >> 2] | 0;
       HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
       i29 = i33 + 4 | 0;
       HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
       i28 = i33 + 8 | 0;
       HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i28 >> 2] = 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i31 >> 2] = i30 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i22);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i22);
       break;
      }
     } while (0);
     __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     break L1;
    }
   case 67:
    {
     i27 = i28 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i27, i23, i31) | 0;
     if ((i1 | 0) == (i27 | 0)) {
      i1 = i28;
      break L1;
     }
     i3 = i31 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i2 + -24 | 0, gb + 1086374 | 0) | 0;
     i6 = i31 + 16 | 0;
     i2 = (HEAP32[i3 >> 2] | 0) + -24 | 0;
     HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2, i29);
     i2 = i31 + 20 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i29 = HEAP32[i31 + 24 >> 2] | 0;
     i5 = i29;
     do if (i3 >>> 0 < i29 >>> 0) {
      HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
      i31 = i33 + 4 | 0;
      HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
      i30 = i33 + 8 | 0;
      HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i30 >> 2] = 0;
      HEAP32[i31 >> 2] = 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
     } else {
      i4 = HEAP32[i6 >> 2] | 0;
      i2 = i3 - i4 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i6 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       break L71;
      } else {
       i29 = i5 - i4 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i8, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i31 = i8 + 8 | 0;
       i30 = HEAP32[i31 >> 2] | 0;
       HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
       i29 = i33 + 4 | 0;
       HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
       i28 = i33 + 8 | 0;
       HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i28 >> 2] = 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i31 >> 2] = i30 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i8);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i8);
       break;
      }
     } while (0);
     __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     break L1;
    }
   case 70:
    {
     if (i2 << 24 >> 24 != 70) {
      i1 = i28;
      break L1;
     }
     i1 = i28 + 1 | 0;
     if ((i1 | 0) == (i23 | 0)) {
      i1 = i28;
      break L1;
     }
     if ((HEAP8[i1 >> 0] | 0) == 89) {
      i1 = i28 + 2 | 0;
      if ((i1 | 0) == (i23 | 0)) {
       i1 = i28;
       break L1;
      }
     }
     i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i1, i23, i31) | 0;
     if ((i2 | 0) == (i1 | 0)) {
      i1 = i28;
      break L1;
     };
     HEAP32[i33 >> 2] = 0;
     HEAP32[i33 + 4 >> 2] = 0;
     HEAP32[i33 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, gb + 1086383 | 0, 1);
     i11 = i31 + 4 | 0;
     i9 = i33 + 11 | 0;
     i10 = i33 + 4 | 0;
     i6 = i29 + 11 | 0;
     i7 = i29 + 4 | 0;
     i8 = 0;
     i1 = i2;
     L267 : while (1) L269 : while (1) {
      if ((i1 | 0) == (i23 | 0)) {
       i30 = 204;
       break L267;
      }
      switch (HEAP8[i1 >> 0] | 0) {
      case 69:
       {
        i30 = 209;
        break L267;
       }
      case 118:
       {
        i1 = i1 + 1 | 0;
        continue L269;
       }
      case 82:
       {
        i2 = i1 + 1 | 0;
        if ((i2 | 0) != (i23 | 0)) if ((HEAP8[i2 >> 0] | 0) == 69) {
         i8 = 1;
         i1 = i2;
         continue L267;
        }
        break;
       }
      case 79:
       {
        i2 = i1 + 1 | 0;
        if ((i2 | 0) != (i23 | 0)) if ((HEAP8[i2 >> 0] | 0) == 69) {
         i8 = 2;
         i1 = i2;
         continue L267;
        }
        break;
       }
      default:
       {}
      }
      i2 = ((HEAP32[i11 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
      __THREW__ = 0;
      i4 = invoke_iiii(fb + 521 | 0, i1 | 0, i23 | 0, i31 | 0) | 0;
      i30 = __THREW__;
      __THREW__ = 0;
      if (i30 & 1) {
       i30 = 218;
       break L267;
      }
      i5 = ((HEAP32[i11 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
      if ((i4 | 0) == (i1 | 0) | (i4 | 0) == (i23 | 0)) {
       i1 = i28;
       i2 = 1;
       i30 = 239;
       break L267;
      } else i1 = i2;
      while (1) {
       if (i1 >>> 0 >= i5 >>> 0) {
        i1 = i2;
        break;
       }
       i30 = HEAP8[i9 >> 0] | 0;
       if ((i30 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i30 & 255) >>> 0 > 1) {
        __THREW__ = 0;
        invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086385 | 0) | 0;
        i30 = __THREW__;
        __THREW__ = 0;
        if (i30 & 1) {
         i30 = 222;
         break L267;
        }
       }
       __THREW__ = 0;
       invoke_vii(fb + 4619 | 0, i29 | 0, (HEAP32[i31 >> 2] | 0) + (i1 * 24 | 0) | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 226;
        break L267;
       }
       i30 = HEAP8[i6 >> 0] | 0;
       i27 = i30 << 24 >> 24 < 0;
       __THREW__ = 0;
       invoke_iiii(fb + 519 | 0, i33 | 0, (i27 ? HEAP32[i29 >> 2] | 0 : i29) | 0, (i27 ? HEAP32[i7 >> 2] | 0 : i30 & 255) | 0) | 0;
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 227;
        break L267;
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
       i1 = i1 + 1 | 0;
      }
      while (1) {
       if (i1 >>> 0 >= i5 >>> 0) {
        i1 = i4;
        continue L269;
       }
       i3 = HEAP32[i11 >> 2] | 0;
       i2 = i3 + -24 | 0;
       while (1) {
        if ((i3 | 0) == (i2 | 0)) break;
        i30 = i3 + -24 | 0;
        HEAP32[i11 >> 2] = i30;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i30);
        i3 = HEAP32[i11 >> 2] | 0;
       }
       i1 = i1 + 1 | 0;
      }
     }
     L295 : do if ((i30 | 0) == 204) {
      i2 = HEAP32[i11 >> 2] | 0;
      i1 = i2 + -24 | 0;
      while (1) {
       if ((i2 | 0) == (i1 | 0)) {
        i1 = i28;
        i2 = 1;
        i30 = 239;
        break L295;
       }
       i30 = i2 + -24 | 0;
       HEAP32[i11 >> 2] = i30;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i30);
       i2 = HEAP32[i11 >> 2] | 0;
      }
     } else if ((i30 | 0) == 209) {
      i1 = i1 + 1 | 0;
      __THREW__ = 0;
      invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086288 | 0) | 0;
      i27 = __THREW__;
      __THREW__ = 0;
      L297 : do if (!(i27 & 1)) {
       switch (i8 & 3) {
       case 1:
        {
         __THREW__ = 0;
         invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086388 | 0) | 0;
         i27 = __THREW__;
         __THREW__ = 0;
         if (i27 & 1) break L297;
         break;
        }
       case 2:
        {
         __THREW__ = 0;
         invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086391 | 0) | 0;
         i27 = __THREW__;
         __THREW__ = 0;
         if (i27 & 1) break L297;
         break;
        }
       default:
        {}
       }
       i2 = HEAP32[i11 >> 2] | 0;
       if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
        i1 = i28;
        i2 = 1;
        i30 = 239;
        break L295;
       }
       __THREW__ = 0;
       invoke_iii(fb + 1152 | 0, i2 + -24 | 0, gb + 1086395 | 0) | 0;
       i27 = __THREW__;
       __THREW__ = 0;
       if (!(i27 & 1)) {
        i27 = HEAP8[i9 >> 0] | 0;
        i26 = i27 << 24 >> 24 < 0;
        __THREW__ = 0;
        invoke_iiiii(fb + 216 | 0, (HEAP32[i11 >> 2] | 0) + -12 | 0, 0, (i26 ? HEAP32[i33 >> 2] | 0 : i33) | 0, (i26 ? HEAP32[i10 >> 2] | 0 : i27 & 255) | 0) | 0;
        i27 = __THREW__;
        __THREW__ = 0;
        if (!(i27 & 1)) {
         i2 = 0;
         i30 = 239;
         break L295;
        }
       }
      } while (0);
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i30 | 0) == 218) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i30 | 0) == 222) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i30 | 0) == 226) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      i30 = 228;
     } else if ((i30 | 0) == 227) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
      i30 = 228;
     } while (0);
     if ((i30 | 0) != 228) if ((i30 | 0) == 239) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      if (i2 | (i1 | 0) == (i28 | 0)) {
       i1 = i28;
       break L1;
      }
      i2 = HEAP32[i11 >> 2] | 0;
      if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
       i1 = i28;
       break L1;
      }
      i6 = i31 + 16 | 0;
      HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
      i2 = i31 + 20 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i29 = HEAP32[i31 + 24 >> 2] | 0;
      i5 = i29;
      do if (i3 >>> 0 < i29 >>> 0) {
       HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
       i31 = i33 + 4 | 0;
       HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
       i30 = i33 + 8 | 0;
       HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i30 >> 2] = 0;
       HEAP32[i31 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
      } else {
       i4 = HEAP32[i6 >> 2] | 0;
       i2 = i3 - i4 >> 4;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 268435455) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i6 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
        break L71;
       } else {
        i29 = i5 - i4 | 0;
        i30 = i29 >> 3;
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i24, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
        i31 = i24 + 8 | 0;
        i30 = HEAP32[i31 >> 2] | 0;
        HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
        HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
        i29 = i33 + 4 | 0;
        HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
        i28 = i33 + 8 | 0;
        HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i28 >> 2] = 0;
        HEAP32[i29 >> 2] = 0;
        HEAP32[i33 >> 2] = 0;
        HEAP32[i31 >> 2] = i30 + 16;
        __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i24);
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i24);
        break;
       }
      } while (0);
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      break L1;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
     ___resumeException(i1 | 0);
    }
   case 71:
    {
     i27 = i28 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i27, i23, i31) | 0;
     if ((i1 | 0) == (i27 | 0)) {
      i1 = i28;
      break L1;
     }
     i3 = i31 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i2 + -24 | 0, gb + 1086397 | 0) | 0;
     i6 = i31 + 16 | 0;
     i2 = (HEAP32[i3 >> 2] | 0) + -24 | 0;
     HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2, i29);
     i2 = i31 + 20 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i29 = HEAP32[i31 + 24 >> 2] | 0;
     i5 = i29;
     do if (i3 >>> 0 < i29 >>> 0) {
      HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
      i31 = i33 + 4 | 0;
      HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
      i30 = i33 + 8 | 0;
      HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i30 >> 2] = 0;
      HEAP32[i31 >> 2] = 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
     } else {
      i4 = HEAP32[i6 >> 2] | 0;
      i2 = i3 - i4 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i6 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       break L71;
      } else {
       i29 = i5 - i4 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i25, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i31 = i25 + 8 | 0;
       i30 = HEAP32[i31 >> 2] | 0;
       HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
       i29 = i33 + 4 | 0;
       HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
       i28 = i33 + 8 | 0;
       HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i28 >> 2] = 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i31 >> 2] = i30 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i25);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i25);
       break;
      }
     } while (0);
     __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     break L1;
    }
   case 77:
    {
     if (i2 << 24 >> 24 != 77) {
      i1 = i28;
      break L1;
     }
     i22 = i28 + 1 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i22, i23, i31) | 0;
     if ((i2 | 0) == (i22 | 0)) {
      i1 = i28;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i23, i31) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     i13 = i31 + 4 | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     if (((i2 - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i28;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i33, i2 + -24 | 0);
     i2 = HEAP32[i13 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i23 = i4 + -24 | 0;
      HEAP32[i13 >> 2] = i23;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i23);
      i4 = HEAP32[i13 >> 2] | 0;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i29, i2 + -48 | 0);
     i12 = i33 + 12 | 0;
     i10 = HEAP32[i13 >> 2] | 0;
     i11 = i10 + -24 | 0;
     L346 : do if ((HEAP8[((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12) >> 0] | 0) == 40) {
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086383 | 0) | 0;
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4619 | 0, i24 | 0, i29 | 0);
       i23 = __THREW__;
       __THREW__ = 0;
       if (i23 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        i3 = HEAP8[i24 + 11 >> 0] | 0;
        i23 = i3 << 24 >> 24 < 0;
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 519 | 0, i25 | 0, (i23 ? HEAP32[i24 >> 2] | 0 : i24) | 0, (i23 ? HEAP32[i24 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
        i23 = __THREW__;
        __THREW__ = 0;
        do if (i23 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i26 | 0, gb + 1086408 | 0) | 0;
         i23 = __THREW__;
         __THREW__ = 0;
         if (i23 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          break;
         };
         HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         i8 = i11 + 11 | 0;
         if ((HEAP8[i8 >> 0] | 0) < 0) {
          HEAP8[HEAP32[i11 >> 2] >> 0] = 0;
          HEAP32[i10 + -20 >> 2] = 0;
          i2 = HEAP8[i8 >> 0] | 0;
          if (i2 << 24 >> 24 < 0) {
           i6 = 1;
           i9 = 0;
           i5 = (HEAP32[i10 + -16 >> 2] & 2147483647) + -1 | 0;
          } else i30 = 281;
         } else {
          HEAP8[i11 >> 0] = 0;
          HEAP8[i8 >> 0] = 0;
          i2 = 0;
          i30 = 281;
         }
         if ((i30 | 0) == 281) {
          i6 = 0;
          i9 = i2 & 255;
          i5 = 10;
         }
         i3 = i9 >>> 0 < 11;
         i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
         L379 : do if ((i7 | 0) != (i5 | 0)) {
          do if (i3) {
           i3 = HEAP32[i11 >> 2] | 0;
           if (i6) {
            i2 = 0;
            i4 = i11;
            i30 = 289;
           } else {
            i5 = 0;
            i6 = 1;
            i4 = i11;
            i30 = 290;
           }
          } else {
           i4 = _malloc(i7 + 1 | 0) | 0;
           if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L379;
           if (i6) {
            i2 = 1;
            i3 = HEAP32[i11 >> 2] | 0;
            i30 = 289;
            break;
           } else {
            i5 = 1;
            i6 = 0;
            i3 = i11;
            i30 = 290;
            break;
           }
          } while (0);
          if ((i30 | 0) == 289) {
           i5 = i2;
           i6 = 1;
           i2 = HEAP32[i10 + -20 >> 2] | 0;
          } else if ((i30 | 0) == 290) i2 = i2 & 255;
          i2 = i2 + 1 | 0;
          if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
          if (i6) _free(i3);
          if (i5) {
           HEAP32[i10 + -16 >> 2] = i7 + 1 | -2147483648;
           HEAP32[i10 + -20 >> 2] = i9;
           HEAP32[i11 >> 2] = i4;
           break;
          } else {
           HEAP8[i8 >> 0] = i9;
           break;
          }
         } while (0);
         HEAP32[i11 >> 2] = HEAP32[i27 >> 2];
         HEAP32[i11 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
         HEAP32[i11 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i27 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
         i11 = HEAP32[i13 >> 2] | 0;
         __THREW__ = 0;
         i3 = invoke_iiii(fb + 520 | 0, i12 | 0, 0, gb + 1086288 | 0) | 0;
         i25 = __THREW__;
         __THREW__ = 0;
         if (i25 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          i30 = 406;
          break L346;
         };
         HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         i8 = i11 + -12 | 0;
         i9 = i8 + 11 | 0;
         do if ((HEAP8[i9 >> 0] | 0) < 0) {
          HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
          HEAP32[i11 + -8 >> 2] = 0;
          i2 = HEAP8[i9 >> 0] | 0;
          if (i2 << 24 >> 24 >= 0) {
           i30 = 309;
           break;
          }
          i6 = 1;
          i10 = 0;
          i5 = (HEAP32[i11 + -4 >> 2] & 2147483647) + -1 | 0;
         } else {
          HEAP8[i8 >> 0] = 0;
          HEAP8[i9 >> 0] = 0;
          i2 = 0;
          i30 = 309;
         } while (0);
         if ((i30 | 0) == 309) {
          i6 = 0;
          i10 = i2 & 255;
          i5 = 10;
         }
         i3 = i10 >>> 0 < 11;
         i7 = i3 ? 10 : (i10 + 16 & 496) + -1 | 0;
         L420 : do if ((i7 | 0) != (i5 | 0)) {
          do if (i3) {
           i3 = HEAP32[i8 >> 2] | 0;
           if (i6) {
            i2 = 0;
            i4 = i8;
            i30 = 317;
           } else {
            i5 = 0;
            i6 = 1;
            i4 = i8;
            i30 = 318;
           }
          } else {
           i4 = _malloc(i7 + 1 | 0) | 0;
           if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L420;
           if (i6) {
            i2 = 1;
            i3 = HEAP32[i8 >> 2] | 0;
            i30 = 317;
            break;
           } else {
            i5 = 1;
            i6 = 0;
            i3 = i8;
            i30 = 318;
            break;
           }
          } while (0);
          if ((i30 | 0) == 317) {
           i5 = i2;
           i6 = 1;
           i2 = HEAP32[i11 + -8 >> 2] | 0;
          } else if ((i30 | 0) == 318) i2 = i2 & 255;
          i2 = i2 + 1 | 0;
          if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
          if (i6) _free(i3);
          if (i5) {
           HEAP32[i11 + -4 >> 2] = i7 + 1 | -2147483648;
           HEAP32[i11 + -8 >> 2] = i10;
           HEAP32[i8 >> 2] = i4;
           break;
          } else {
           HEAP8[i9 >> 0] = i10;
           break;
          }
         } while (0);
         HEAP32[i8 >> 2] = HEAP32[i27 >> 2];
         HEAP32[i8 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
         HEAP32[i8 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i27 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
         break L346;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
      }
      i30 = 406;
     } else {
      __THREW__ = 0;
      i3 = invoke_iii(fb + 1152 | 0, i33 | 0, gb + 1086395 | 0) | 0;
      i23 = __THREW__;
      __THREW__ = 0;
      if (i23 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4619 | 0, i24 | 0, i29 | 0);
       i23 = __THREW__;
       __THREW__ = 0;
       if (i23 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        i3 = HEAP8[i24 + 11 >> 0] | 0;
        i23 = i3 << 24 >> 24 < 0;
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 519 | 0, i25 | 0, (i23 ? HEAP32[i24 >> 2] | 0 : i24) | 0, (i23 ? HEAP32[i24 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
        i23 = __THREW__;
        __THREW__ = 0;
        do if (i23 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         i3 = invoke_iii(fb + 1152 | 0, i26 | 0, gb + 1086408 | 0) | 0;
         i23 = __THREW__;
         __THREW__ = 0;
         if (i23 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          break;
         };
         HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         i8 = i11 + 11 | 0;
         if ((HEAP8[i8 >> 0] | 0) < 0) {
          HEAP8[HEAP32[i11 >> 2] >> 0] = 0;
          HEAP32[i10 + -20 >> 2] = 0;
          i2 = HEAP8[i8 >> 0] | 0;
          if (i2 << 24 >> 24 < 0) {
           i6 = 1;
           i9 = 0;
           i5 = (HEAP32[i10 + -16 >> 2] & 2147483647) + -1 | 0;
          } else i30 = 355;
         } else {
          HEAP8[i11 >> 0] = 0;
          HEAP8[i8 >> 0] = 0;
          i2 = 0;
          i30 = 355;
         }
         if ((i30 | 0) == 355) {
          i6 = 0;
          i9 = i2 & 255;
          i5 = 10;
         }
         i3 = i9 >>> 0 < 11;
         i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
         L482 : do if ((i7 | 0) != (i5 | 0)) {
          do if (i3) {
           i3 = HEAP32[i11 >> 2] | 0;
           if (i6) {
            i2 = 0;
            i4 = i11;
            i30 = 363;
           } else {
            i5 = 0;
            i6 = 1;
            i4 = i11;
            i30 = 364;
           }
          } else {
           i4 = _malloc(i7 + 1 | 0) | 0;
           if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L482;
           if (i6) {
            i2 = 1;
            i3 = HEAP32[i11 >> 2] | 0;
            i30 = 363;
            break;
           } else {
            i5 = 1;
            i6 = 0;
            i3 = i11;
            i30 = 364;
            break;
           }
          } while (0);
          if ((i30 | 0) == 363) {
           i5 = i2;
           i6 = 1;
           i2 = HEAP32[i10 + -20 >> 2] | 0;
          } else if ((i30 | 0) == 364) i2 = i2 & 255;
          i2 = i2 + 1 | 0;
          if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
          if (i6) _free(i3);
          if (i5) {
           HEAP32[i10 + -16 >> 2] = i7 + 1 | -2147483648;
           HEAP32[i10 + -20 >> 2] = i9;
           HEAP32[i11 >> 2] = i4;
           break;
          } else {
           HEAP8[i8 >> 0] = i9;
           break;
          }
         } while (0);
         HEAP32[i11 >> 2] = HEAP32[i27 >> 2];
         HEAP32[i11 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
         HEAP32[i11 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i27 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
         i9 = HEAP32[i13 >> 2] | 0;
         i10 = i9 + -12 | 0;
         i11 = i10 + 11 | 0;
         do if ((HEAP8[i11 >> 0] | 0) < 0) {
          HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
          HEAP32[i9 + -8 >> 2] = 0;
          i2 = HEAP8[i11 >> 0] | 0;
          if (i2 << 24 >> 24 >= 0) {
           i3 = i2;
           i30 = 379;
           break;
          }
          i5 = (HEAP32[i9 + -4 >> 2] & 2147483647) + -1 | 0;
          i6 = 1;
          i8 = 0;
         } else {
          HEAP8[i10 >> 0] = 0;
          HEAP8[i11 >> 0] = 0;
          i3 = 0;
          i30 = 379;
         } while (0);
         if ((i30 | 0) == 379) {
          i5 = 10;
          i2 = i3;
          i6 = 0;
          i8 = i3 & 255;
         }
         i3 = i8 >>> 0 < 11;
         i7 = i3 ? 10 : (i8 + 16 & 496) + -1 | 0;
         L516 : do if ((i7 | 0) != (i5 | 0)) {
          do if (i3) {
           i3 = HEAP32[i10 >> 2] | 0;
           if (i6) {
            i2 = 0;
            i4 = i10;
            i30 = 387;
           } else {
            i5 = 0;
            i6 = 1;
            i4 = i10;
            i30 = 388;
           }
          } else {
           i4 = _malloc(i7 + 1 | 0) | 0;
           if (i7 >>> 0 <= i5 >>> 0 & (i4 | 0) == 0) break L516;
           if (i6) {
            i2 = 1;
            i3 = HEAP32[i10 >> 2] | 0;
            i30 = 387;
            break;
           } else {
            i5 = 1;
            i6 = 0;
            i3 = i10;
            i30 = 388;
            break;
           }
          } while (0);
          if ((i30 | 0) == 387) {
           i5 = i2;
           i6 = 1;
           i2 = HEAP32[i9 + -8 >> 2] | 0;
          } else if ((i30 | 0) == 388) i2 = i2 & 255;
          i2 = i2 + 1 | 0;
          if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
          if (i6) _free(i3);
          if (i5) {
           HEAP32[i9 + -4 >> 2] = i7 + 1 | -2147483648;
           HEAP32[i9 + -8 >> 2] = i8;
           HEAP32[i10 >> 2] = i4;
           break;
          } else {
           HEAP8[i11 >> 0] = i8;
           break;
          }
         } while (0);
         HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
         HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break L346;
          HEAP32[i12 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i24);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
      }
      i30 = 406;
     } while (0);
     if ((i30 | 0) == 406) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
      ___resumeException(i1 | 0);
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
     if ((i1 | 0) == (i28 | 0)) {
      i1 = i28;
      break L1;
     }
     i2 = HEAP32[i13 >> 2] | 0;
     if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     i6 = i31 + 16 | 0;
     HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
     i2 = i31 + 20 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i29 = HEAP32[i31 + 24 >> 2] | 0;
     i5 = i29;
     do if (i3 >>> 0 < i29 >>> 0) {
      HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
      i31 = i33 + 4 | 0;
      HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
      i30 = i33 + 8 | 0;
      HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i30 >> 2] = 0;
      HEAP32[i31 >> 2] = 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
     } else {
      i4 = HEAP32[i6 >> 2] | 0;
      i2 = i3 - i4 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i6 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       break L71;
      } else {
       i29 = i5 - i4 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i26, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i31 = i26 + 8 | 0;
       i30 = HEAP32[i31 >> 2] | 0;
       HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
       i29 = i33 + 4 | 0;
       HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
       i28 = i33 + 8 | 0;
       HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i28 >> 2] = 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i31 >> 2] = i30 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i26);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i26);
       break;
      }
     } while (0);
     __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     break L1;
    }
   case 79:
    {
     i15 = i31 + 4 | 0;
     i8 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     i30 = i28 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i30, i23, i31) | 0;
     i15 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     if ((i1 | 0) == (i30 | 0)) {
      i1 = i28;
      break L1;
     }
     i5 = i31 + 16 | 0;
     i4 = HEAP32[i31 + 12 >> 2] | 0;
     i14 = i31 + 20 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
     i30 = HEAP32[i31 + 24 >> 2] | 0;
     i6 = i30;
     do if (i2 >>> 0 < i30 >>> 0) {
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = i4;
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 16;
     } else {
      i7 = HEAP32[i5 >> 2] | 0;
      i2 = i2 - i7 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5); else {
       i29 = i6 - i7 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i30 = i33 + 8 | 0;
       i29 = HEAP32[i30 >> 2] | 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i29 + 4 >> 2] = 0;
       HEAP32[i29 + 8 >> 2] = 0;
       HEAP32[i29 + 12 >> 2] = i4;
       HEAP32[i30 >> 2] = i29 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i33);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
       break;
      }
     } while (0);
     i11 = i33 + 11 | 0;
     i12 = i33 + 4 | 0;
     i13 = i33 + 8 | 0;
     while (1) {
      if (i8 >>> 0 >= i15 >>> 0) break L1;
      i28 = HEAP32[i31 >> 2] | 0;
      i2 = i28 + (i8 * 24 | 0) + 12 | 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i33 + 4 >> 2] = 0;
      HEAP32[i33 + 8 >> 2] = 0;
      i30 = HEAP8[i2 + 11 >> 0] | 0;
      i29 = i30 << 24 >> 24 < 0;
      i30 = i29 ? HEAP32[i28 + (i8 * 24 | 0) + 16 >> 2] | 0 : i30 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i29 ? HEAP32[i2 >> 2] | 0 : i2, i30 >>> 0 < 2 ? i30 : 2);
      i30 = HEAP8[i11 >> 0] | 0;
      i2 = i30 << 24 >> 24 < 0;
      if (((i2 ? HEAP32[i12 >> 2] | 0 : i30 & 255) | 0) == 2) i2 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086365 | 0, 2) | 0) == 0; else i2 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      i3 = HEAP32[i31 >> 2] | 0;
      if (i2) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086285 | 0) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
      } else {
       i2 = i3 + (i8 * 24 | 0) + 12 | 0;
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
       if ((HEAP8[i2 >> 0] | 0) == 40) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086383 | 0) | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
       }
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) | 0, gb + 1086412 | 0) | 0;
      i5 = HEAP32[i14 >> 2] | 0;
      i10 = i5 + -16 | 0;
      i7 = HEAP32[i31 >> 2] | 0;
      i9 = i7 + (i8 * 24 | 0) | 0;
      i2 = i5 + -12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i30 = HEAP32[i5 + -8 >> 2] | 0;
      i6 = i30;
      if ((i3 | 0) == (i30 | 0)) {
       i4 = HEAP32[i10 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        i30 = 437;
        break;
       }
       i29 = (i6 - i4 | 0) / 24 | 0;
       i30 = i29 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i29 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i5 + -4 | 0);
       i2 = HEAP32[i13 >> 2] | 0;
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 | 0, i9 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 441;
        break;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i7 + (i8 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 440;
        break;
       }
       HEAP32[i13 >> 2] = i2 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i33);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i9);
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i7 + (i8 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 434;
        break;
       }
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      }
      i8 = i8 + 1 | 0;
     }
     if ((i30 | 0) == 434) {
      i33 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
      ___resumeException(i33 | 0);
     } else if ((i30 | 0) == 437) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10); else if ((i30 | 0) == 440) {
      i16 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
     } else if ((i30 | 0) == 441) {
      i16 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     ___resumeException(i16 | 0);
    }
   case 80:
    {
     i17 = i31 + 4 | 0;
     i8 = ((HEAP32[i17 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     i18 = i28 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i18, i23, i31) | 0;
     i17 = ((HEAP32[i17 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i28;
      break L1;
     }
     i5 = i31 + 16 | 0;
     i4 = HEAP32[i31 + 12 >> 2] | 0;
     i16 = i31 + 20 | 0;
     i2 = HEAP32[i16 >> 2] | 0;
     i29 = HEAP32[i31 + 24 >> 2] | 0;
     i6 = i29;
     do if (i2 >>> 0 < i29 >>> 0) {
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = i4;
      HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 16;
     } else {
      i7 = HEAP32[i5 >> 2] | 0;
      i2 = i2 - i7 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5); else {
       i28 = i6 - i7 | 0;
       i29 = i28 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i28 >> 4 >>> 0 < 134217727 ? (i29 >>> 0 < i3 >>> 0 ? i3 : i29) : 268435455, i2, i31 + 28 | 0);
       i29 = i33 + 8 | 0;
       i28 = HEAP32[i29 >> 2] | 0;
       HEAP32[i28 >> 2] = 0;
       HEAP32[i28 + 4 >> 2] = 0;
       HEAP32[i28 + 8 >> 2] = 0;
       HEAP32[i28 + 12 >> 2] = i4;
       HEAP32[i29 >> 2] = i28 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i33);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
       break;
      }
     } while (0);
     i11 = i33 + 11 | 0;
     i12 = i33 + 4 | 0;
     i13 = i33 + 11 | 0;
     i14 = i33 + 4 | 0;
     i15 = i33 + 8 | 0;
     while (1) {
      if (i8 >>> 0 >= i17 >>> 0) break L1;
      i27 = HEAP32[i31 >> 2] | 0;
      i2 = i27 + (i8 * 24 | 0) + 12 | 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i33 + 4 >> 2] = 0;
      HEAP32[i33 + 8 >> 2] = 0;
      i29 = HEAP8[i2 + 11 >> 0] | 0;
      i28 = i29 << 24 >> 24 < 0;
      i29 = i28 ? HEAP32[i27 + (i8 * 24 | 0) + 16 >> 2] | 0 : i29 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i28 ? HEAP32[i2 >> 2] | 0 : i2, i29 >>> 0 < 2 ? i29 : 2);
      i29 = HEAP8[i11 >> 0] | 0;
      i2 = i29 << 24 >> 24 < 0;
      if (((i2 ? HEAP32[i12 >> 2] | 0 : i29 & 255) | 0) == 2) i2 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086365 | 0, 2) | 0) == 0; else i2 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      i3 = HEAP32[i31 >> 2] | 0;
      if (i2) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086285 | 0) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
      } else {
       i2 = i3 + (i8 * 24 | 0) + 12 | 0;
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
       if ((HEAP8[i2 >> 0] | 0) == 40) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086383 | 0) | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
       }
      }
      do if ((HEAP8[i18 >> 0] | 0) == 85) {
       i27 = HEAP32[i31 >> 2] | 0;
       i2 = i27 + (i8 * 24 | 0) | 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i33 + 4 >> 2] = 0;
       HEAP32[i33 + 8 >> 2] = 0;
       i29 = HEAP8[i2 + 11 >> 0] | 0;
       i28 = i29 << 24 >> 24 < 0;
       i29 = i28 ? HEAP32[i27 + (i8 * 24 | 0) + 4 >> 2] | 0 : i29 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i28 ? HEAP32[i2 >> 2] | 0 : i2, i29 >>> 0 < 12 ? i29 : 12);
       i29 = HEAP8[i13 >> 0] | 0;
       i2 = i29 << 24 >> 24 < 0;
       if (((i2 ? HEAP32[i14 >> 2] | 0 : i29 & 255) | 0) == 12) i3 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086415 | 0, 12) | 0) != 0; else i3 = 1;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       i10 = HEAP32[i31 >> 2] | 0;
       i2 = i10 + (i8 * 24 | 0) | 0;
       if (i3) i30 = 467; else {
        i9 = i2 + 11 | 0;
        i3 = HEAP8[i9 >> 0] | 0;
        i4 = i3 << 24 >> 24 < 0;
        if (i4) {
         i7 = HEAP32[i10 + (i8 * 24 | 0) + 4 >> 2] | 0;
         i6 = i7 >>> 0 < 11 ? i7 : 11;
         i3 = (HEAP32[i10 + (i8 * 24 | 0) + 8 >> 2] & 2147483647) + -1 | 0;
        } else {
         i7 = i3 & 255;
         i6 = i7 >>> 0 < 11 ? i7 : 11;
         i3 = 10;
        }
        if ((i6 - i7 + i3 | 0) >>> 0 < 2) {
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc(i2, i3, 2 - i6 + i7 - i3 | 0, i7, 0, i6, 2, gb + 1086430 | 0);
         break;
        }
        if (i4) i2 = HEAP32[i2 >> 2] | 0;
        L636 : do if ((i6 | 0) == 2) {
         i4 = 2;
         i6 = 0;
         i5 = gb + 1086430 | 0;
         i3 = 2;
         i30 = 486;
        } else {
         i4 = i7 - i6 | 0;
         if (!i4) {
          i4 = i6;
          i6 = 0;
          i5 = gb + 1086430 | 0;
          i3 = 2;
          i30 = 486;
         } else {
          if (i6 >>> 0 > 2) {
           HEAP8[i2 >> 0] = 105;
           HEAP8[i2 + 1 >> 0] = 100;
           _memmove(i2 + 2 | 0, i2 + i6 | 0, i4 | 0) | 0;
           i4 = i6;
           i3 = 2;
           break;
          }
          i5 = i2 + i6 | 0;
          do if (i2 >>> 0 < (gb + 1086430 | 0) >>> 0 & (i2 + i7 | 0) >>> 0 > (gb + 1086430 | 0) >>> 0) {
           if (i5 >>> 0 <= (gb + 1086430 | 0) >>> 0) {
            i3 = 2 - i6 + (gb + 1086430) | 0;
            break;
           }
           if (i6 | 0) _memcpy(i2 | 0, gb + 1086430 | 0, i6 | 0) | 0;
           i3 = 2 - i6 | 0;
           _memmove(i5 + i3 | 0, i5 | 0, i4 | 0) | 0;
           if (!i3) {
            i4 = 0;
            i3 = 0;
            break L636;
           } else {
            i4 = 0;
            i5 = gb + 1086430 + 2 | 0;
            i30 = 486;
            break L636;
           }
          } else i3 = gb + 1086430 | 0; while (0);
          _memmove(i2 + 2 | 0, i5 | 0, i4 | 0) | 0;
          i4 = i6;
          i6 = 0;
          i5 = i3;
          i3 = 2;
          i30 = 486;
         }
        } while (0);
        if ((i30 | 0) == 486) {
         i30 = 0;
         _memmove(i2 + i6 | 0, i5 | 0, i3 | 0) | 0;
        }
        i3 = i3 - i4 + i7 | 0;
        if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i10 + (i8 * 24 | 0) + 4 >> 2] = i3; else HEAP8[i9 >> 0] = i3;
        HEAP8[i2 + i3 >> 0] = 0;
       }
      } else {
       i2 = (HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) | 0;
       i30 = 467;
      } while (0);
      if ((i30 | 0) == 467) {
       i30 = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i2, gb + 1086428 | 0) | 0;
      }
      i5 = HEAP32[i16 >> 2] | 0;
      i7 = i5 + -16 | 0;
      i9 = HEAP32[i31 >> 2] | 0;
      i10 = i9 + (i8 * 24 | 0) | 0;
      i2 = i5 + -12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i29 = HEAP32[i5 + -8 >> 2] | 0;
      i6 = i29;
      if ((i3 | 0) == (i29 | 0)) {
       i4 = HEAP32[i7 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        i30 = 497;
        break;
       }
       i28 = (i6 - i4 | 0) / 24 | 0;
       i29 = i28 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i28 >>> 0 < 89478485 ? (i29 >>> 0 < i3 >>> 0 ? i3 : i29) : 178956970, i2, i5 + -4 | 0);
       i2 = HEAP32[i15 >> 2] | 0;
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 | 0, i10 | 0);
       i29 = __THREW__;
       __THREW__ = 0;
       if (i29 & 1) {
        i30 = 501;
        break;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i9 + (i8 * 24 | 0) + 12 | 0);
       i29 = __THREW__;
       __THREW__ = 0;
       if (i29 & 1) {
        i30 = 500;
        break;
       }
       HEAP32[i15 >> 2] = i2 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i7, i33);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i10);
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i9 + (i8 * 24 | 0) + 12 | 0);
       i29 = __THREW__;
       __THREW__ = 0;
       if (i29 & 1) {
        i30 = 494;
        break;
       }
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      }
      i8 = i8 + 1 | 0;
     }
     if ((i30 | 0) == 494) {
      i33 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
      ___resumeException(i33 | 0);
     } else if ((i30 | 0) == 497) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7); else if ((i30 | 0) == 500) {
      i20 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
     } else if ((i30 | 0) == 501) {
      i20 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     ___resumeException(i20 | 0);
    }
   case 82:
    {
     i15 = i31 + 4 | 0;
     i8 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     i30 = i28 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i30, i23, i31) | 0;
     i15 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     if ((i1 | 0) == (i30 | 0)) {
      i1 = i28;
      break L1;
     }
     i5 = i31 + 16 | 0;
     i4 = HEAP32[i31 + 12 >> 2] | 0;
     i14 = i31 + 20 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
     i30 = HEAP32[i31 + 24 >> 2] | 0;
     i6 = i30;
     do if (i2 >>> 0 < i30 >>> 0) {
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = i4;
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 16;
     } else {
      i7 = HEAP32[i5 >> 2] | 0;
      i2 = i2 - i7 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5); else {
       i29 = i6 - i7 | 0;
       i30 = i29 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i30 = i33 + 8 | 0;
       i29 = HEAP32[i30 >> 2] | 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i29 + 4 >> 2] = 0;
       HEAP32[i29 + 8 >> 2] = 0;
       HEAP32[i29 + 12 >> 2] = i4;
       HEAP32[i30 >> 2] = i29 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i33);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
       break;
      }
     } while (0);
     i11 = i33 + 11 | 0;
     i12 = i33 + 4 | 0;
     i13 = i33 + 8 | 0;
     while (1) {
      if (i8 >>> 0 >= i15 >>> 0) break L1;
      i28 = HEAP32[i31 >> 2] | 0;
      i2 = i28 + (i8 * 24 | 0) + 12 | 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i33 + 4 >> 2] = 0;
      HEAP32[i33 + 8 >> 2] = 0;
      i30 = HEAP8[i2 + 11 >> 0] | 0;
      i29 = i30 << 24 >> 24 < 0;
      i30 = i29 ? HEAP32[i28 + (i8 * 24 | 0) + 16 >> 2] | 0 : i30 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i33, i29 ? HEAP32[i2 >> 2] | 0 : i2, i30 >>> 0 < 2 ? i30 : 2);
      i30 = HEAP8[i11 >> 0] | 0;
      i2 = i30 << 24 >> 24 < 0;
      if (((i2 ? HEAP32[i12 >> 2] | 0 : i30 & 255) | 0) == 2) i2 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086365 | 0, 2) | 0) == 0; else i2 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      i3 = HEAP32[i31 >> 2] | 0;
      if (i2) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086285 | 0) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
      } else {
       i2 = i3 + (i8 * 24 | 0) + 12 | 0;
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
       if ((HEAP8[i2 >> 0] | 0) == 40) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i3 + (i8 * 24 | 0) | 0, gb + 1086383 | 0) | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) + 12 | 0, 0, gb + 1086288 | 0) | 0;
       }
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc((HEAP32[i31 >> 2] | 0) + (i8 * 24 | 0) | 0, gb + 1086433 | 0) | 0;
      i5 = HEAP32[i14 >> 2] | 0;
      i10 = i5 + -16 | 0;
      i7 = HEAP32[i31 >> 2] | 0;
      i9 = i7 + (i8 * 24 | 0) | 0;
      i2 = i5 + -12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i30 = HEAP32[i5 + -8 >> 2] | 0;
      i6 = i30;
      if ((i3 | 0) == (i30 | 0)) {
       i4 = HEAP32[i10 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        i30 = 527;
        break;
       }
       i29 = (i6 - i4 | 0) / 24 | 0;
       i30 = i29 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i29 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i5 + -4 | 0);
       i2 = HEAP32[i13 >> 2] | 0;
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 | 0, i9 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 531;
        break;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i7 + (i8 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 530;
        break;
       }
       HEAP32[i13 >> 2] = i2 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i33);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i9);
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i7 + (i8 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 524;
        break;
       }
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      }
      i8 = i8 + 1 | 0;
     }
     if ((i30 | 0) == 524) {
      i33 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
      ___resumeException(i33 | 0);
     } else if ((i30 | 0) == 527) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10); else if ((i30 | 0) == 530) {
      i17 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
     } else if ((i30 | 0) == 531) {
      i17 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     ___resumeException(i17 | 0);
    }
   case 84:
    {
     i15 = i31 + 4 | 0;
     i12 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
     i13 = ((HEAP32[i15 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
     if ((i1 | 0) == (i28 | 0)) {
      i1 = i28;
      break L1;
     }
     i18 = i31 + 16 | 0;
     i14 = i31 + 12 | 0;
     i4 = HEAP32[i14 >> 2] | 0;
     i17 = i31 + 20 | 0;
     i2 = HEAP32[i17 >> 2] | 0;
     i16 = i31 + 24 | 0;
     i30 = HEAP32[i16 >> 2] | 0;
     i5 = i30;
     do if (i2 >>> 0 < i30 >>> 0) {
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = i4;
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 16;
     } else {
      i6 = HEAP32[i18 >> 2] | 0;
      i2 = i2 - i6 >> 4;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18); else {
       i28 = i5 - i6 | 0;
       i30 = i28 >> 3;
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i28 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
       i30 = i33 + 8 | 0;
       i28 = HEAP32[i30 >> 2] | 0;
       HEAP32[i28 >> 2] = 0;
       HEAP32[i28 + 4 >> 2] = 0;
       HEAP32[i28 + 8 >> 2] = 0;
       HEAP32[i28 + 12 >> 2] = i4;
       HEAP32[i30 >> 2] = i28 + 16;
       __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i18, i33);
       __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
       break;
      }
     } while (0);
     i8 = i33 + 8 | 0;
     i7 = i12;
     while (1) {
      if (i7 >>> 0 >= i13 >>> 0) {
       i30 = 543;
       break;
      }
      i5 = HEAP32[i17 >> 2] | 0;
      i11 = i5 + -16 | 0;
      i9 = HEAP32[i31 >> 2] | 0;
      i10 = i9 + (i7 * 24 | 0) | 0;
      i2 = i5 + -12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i30 = HEAP32[i5 + -8 >> 2] | 0;
      i6 = i30;
      if ((i3 | 0) == (i30 | 0)) {
       i4 = HEAP32[i11 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        i30 = 549;
        break;
       }
       i28 = (i6 - i4 | 0) / 24 | 0;
       i30 = i28 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i28 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i5 + -4 | 0);
       i2 = HEAP32[i8 >> 2] | 0;
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 | 0, i10 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 553;
        break;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i9 + (i7 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 552;
        break;
       }
       HEAP32[i8 >> 2] = i2 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i11, i33);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i10);
       __THREW__ = 0;
       invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i9 + (i7 * 24 | 0) + 12 | 0);
       i30 = __THREW__;
       __THREW__ = 0;
       if (i30 & 1) {
        i30 = 546;
        break;
       }
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      }
      i7 = i7 + 1 | 0;
     }
     if ((i30 | 0) == 543) {
      if (!((i13 | 0) == (i12 + 1 | 0) & (HEAP8[i31 + 63 >> 0] | 0) != 0)) break L1;
      i5 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i1, i23, i31) | 0;
      if ((i5 | 0) == (i1 | 0)) break L1;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i33, (HEAP32[i15 >> 2] | 0) + -24 | 0);
      i1 = HEAP32[i15 >> 2] | 0;
      i2 = i1 + -24 | 0;
      i3 = i1;
      while (1) {
       if ((i3 | 0) == (i2 | 0)) break;
       i28 = i3 + -24 | 0;
       HEAP32[i15 >> 2] = i28;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i28);
       i3 = HEAP32[i15 >> 2] | 0;
      }
      i28 = HEAP8[i33 + 11 >> 0] | 0;
      i25 = i28 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i1 + -48 | 0, (i25 ? HEAP32[i33 >> 2] | 0 : i33) | 0, (i25 ? HEAP32[i33 + 4 >> 2] | 0 : i28 & 255) | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       i28 = (HEAP32[i15 >> 2] | 0) + -24 | 0;
       HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
       __THREW__ = 0;
       invoke_viii(fb + 1065 | 0, i29 | 0, i28 | 0, i26 | 0);
       i28 = __THREW__;
       __THREW__ = 0;
       L745 : do if (i28 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        i1 = HEAP32[i17 >> 2] | 0;
        i28 = HEAP32[i16 >> 2] | 0;
        i4 = i28;
        do if (i1 >>> 0 < i28 >>> 0) {
         HEAP32[i1 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i29 >> 2];
         i31 = i29 + 4 | 0;
         HEAP32[i1 + 4 >> 2] = HEAP32[i31 >> 2];
         i30 = i29 + 8 | 0;
         HEAP32[i1 + 8 >> 2] = HEAP32[i30 >> 2];
         HEAP32[i30 >> 2] = 0;
         HEAP32[i31 >> 2] = 0;
         HEAP32[i29 >> 2] = 0;
         HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 16;
        } else {
         i3 = HEAP32[i18 >> 2] | 0;
         i1 = i1 - i3 >> 4;
         i2 = i1 + 1 | 0;
         if (i2 >>> 0 > 268435455) {
          __THREW__ = 0;
          invoke_vi(fb + 4014 | 0, i18 | 0);
          __THREW__ = 0;
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
          break L745;
         } else {
          i28 = i4 - i3 | 0;
          i30 = i28 >> 3;
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i27, i28 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i2 >>> 0 ? i2 : i30) : 268435455, i1, i31 + 28 | 0);
          i31 = i27 + 8 | 0;
          i30 = HEAP32[i31 >> 2] | 0;
          HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
          HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
          i28 = i29 + 4 | 0;
          HEAP32[i30 + 4 >> 2] = HEAP32[i28 >> 2];
          i26 = i29 + 8 | 0;
          HEAP32[i30 + 8 >> 2] = HEAP32[i26 >> 2];
          HEAP32[i26 >> 2] = 0;
          HEAP32[i28 >> 2] = 0;
          HEAP32[i29 >> 2] = 0;
          HEAP32[i31 >> 2] = i30 + 16;
          __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i18, i27);
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i27);
          break;
         }
        } while (0);
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
        i1 = i5;
        break L1;
       } while (0);
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      break L71;
     } else if ((i30 | 0) == 546) {
      i33 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
      ___resumeException(i33 | 0);
     } else if ((i30 | 0) == 549) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11); else if ((i30 | 0) == 552) {
      i19 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
     } else if ((i30 | 0) == 553) {
      i19 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
     ___resumeException(i19 | 0);
    }
   case 85:
    {
     i1 = i28 + 1 | 0;
     if ((i1 | 0) == (i23 | 0)) {
      i1 = i28;
      break L1;
     }
     i2 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i23, i31) | 0;
     if ((i2 | 0) == (i1 | 0)) {
      i1 = i28;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i23, i31) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i28;
      break L1;
     }
     i6 = i31 + 4 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     if (((i2 - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i28;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i27, i2 + -24 | 0);
     i2 = HEAP32[i6 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i28 = i4 + -24 | 0;
      HEAP32[i6 >> 2] = i28;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i28);
      i4 = HEAP32[i6 >> 2] | 0;
     }
     i24 = i2 + -48 | 0;
     HEAP32[i33 >> 2] = 0;
     HEAP32[i33 + 4 >> 2] = 0;
     HEAP32[i33 + 8 >> 2] = 0;
     i28 = HEAP8[i24 + 11 >> 0] | 0;
     i23 = i28 << 24 >> 24 < 0;
     i28 = i23 ? HEAP32[i2 + -44 >> 2] | 0 : i28 & 255;
     __THREW__ = 0;
     invoke_viii(fb + 1064 | 0, i33 | 0, (i23 ? HEAP32[i24 >> 2] | 0 : i24) | 0, (i28 >>> 0 < 9 ? i28 : 9) | 0);
     i28 = __THREW__;
     __THREW__ = 0;
     L771 : do if (i28 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i28 = HEAP8[i33 + 11 >> 0] | 0;
      i2 = i28 << 24 >> 24 < 0;
      L774 : do if (((i2 ? HEAP32[i33 + 4 >> 2] | 0 : i28 & 255) | 0) == 9) {
       i28 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i33 >> 2] | 0 : i33, gb + 1086435 | 0, 9) | 0) == 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       if (i28) {
        __THREW__ = 0;
        invoke_vii(fb + 4619 | 0, i13 | 0, (HEAP32[i6 >> 2] | 0) + -24 | 0);
        i28 = __THREW__;
        __THREW__ = 0;
        if (i28 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         break L771;
        }
        i3 = HEAP32[i6 >> 2] | 0;
        i2 = i3 + -24 | 0;
        while (1) {
         if ((i3 | 0) == (i2 | 0)) break;
         i28 = i3 + -24 | 0;
         HEAP32[i6 >> 2] = i28;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i28);
         i3 = HEAP32[i6 >> 2] | 0;
        }
        i2 = i13 + 11 | 0;
        i3 = HEAP8[i2 >> 0] | 0;
        i28 = i3 << 24 >> 24 < 0;
        i24 = HEAP32[i13 >> 2] | 0;
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 524 | 0, (i28 ? i24 + 9 | 0 : i13 + 9 | 0) | 0, (i28 ? i24 : i13) + (i28 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255) | 0, i31 | 0) | 0;
        i28 = __THREW__;
        __THREW__ = 0;
        L784 : do if (i28 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         L787 : do if ((i3 | 0) == (((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) + 9 | 0)) {
          __THREW__ = 0;
          invoke_viii(fb + 1066 | 0, i26 | 0, i27 | 0, gb + 1086395 | 0);
          i28 = __THREW__;
          __THREW__ = 0;
          if (i28 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           i3 = HEAP8[i2 >> 0] | 0;
           i28 = i3 << 24 >> 24 < 0;
           __THREW__ = 0;
           i3 = invoke_iiii(fb + 519 | 0, i26 | 0, (i28 ? HEAP32[i13 >> 2] | 0 : i13) | 0, (i28 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
           i28 = __THREW__;
           __THREW__ = 0;
           L792 : do if (i28 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i12 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i29, i12);
            i2 = HEAP32[i6 >> 2] | 0;
            i28 = HEAP32[i31 + 8 >> 2] | 0;
            i4 = i28;
            do if (i2 >>> 0 < i28 >>> 0) {
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i29);
             HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 24;
            } else {
             i5 = HEAP32[i31 >> 2] | 0;
             i2 = (i2 - i5 | 0) / 24 | 0;
             i3 = i2 + 1 | 0;
             if (i3 >>> 0 > 178956970) {
              __THREW__ = 0;
              invoke_vi(fb + 4014 | 0, i31 | 0);
              __THREW__ = 0;
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
              break L792;
             } else {
              i25 = (i4 - i5 | 0) / 24 | 0;
              i28 = i25 << 1;
              __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i25 >>> 0 < 89478485 ? (i28 >>> 0 < i3 >>> 0 ? i3 : i28) : 178956970, i2, i31 + 12 | 0);
              i28 = i33 + 8 | 0;
              i25 = HEAP32[i28 >> 2] | 0;
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i25, i29);
              HEAP32[i28 >> 2] = i25 + 24;
              __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i31, i33);
              __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
              break;
             }
            } while (0);
            __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
            break L787;
           } while (0);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          }
          break L784;
         } else {
          i4 = (HEAP32[i6 >> 2] | 0) + -24 | 0;
          __THREW__ = 0;
          invoke_viii(fb + 1066 | 0, i26 | 0, i27 | 0, gb + 1086445 | 0);
          i28 = __THREW__;
          __THREW__ = 0;
          if (i28 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           __THREW__ = 0;
           invoke_vii(fb + 4619 | 0, i25 | 0, (HEAP32[i6 >> 2] | 0) + -24 | 0);
           i28 = __THREW__;
           __THREW__ = 0;
           if (i28 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            i3 = HEAP8[i25 + 11 >> 0] | 0;
            i28 = i3 << 24 >> 24 < 0;
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 519 | 0, i26 | 0, (i28 ? HEAP32[i25 >> 2] | 0 : i25) | 0, (i28 ? HEAP32[i25 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
            i28 = __THREW__;
            __THREW__ = 0;
            do if (i28 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i29 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i29 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i29 | 0, gb + 1086447 | 0) | 0;
             i28 = __THREW__;
             __THREW__ = 0;
             if (i28 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
              break;
             };
             HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i33, i11);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i4, i33);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             break L787;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          }
          break L784;
         } while (0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
         break L774;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
        break L771;
       } else i30 = 584;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       i30 = 584;
      } while (0);
      L835 : do if ((i30 | 0) == 584) {
       i3 = (HEAP32[i6 >> 2] | 0) + -24 | 0;
       __THREW__ = 0;
       invoke_viii(fb + 1066 | 0, i29 | 0, i27 | 0, gb + 1086395 | 0);
       i28 = __THREW__;
       __THREW__ = 0;
       if (i28 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        __THREW__ = 0;
        invoke_vii(fb + 4619 | 0, i26 | 0, (HEAP32[i6 >> 2] | 0) + -24 | 0);
        i28 = __THREW__;
        __THREW__ = 0;
        do if (i28 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         i4 = HEAP8[i26 + 11 >> 0] | 0;
         i28 = i4 << 24 >> 24 < 0;
         __THREW__ = 0;
         i4 = invoke_iiii(fb + 519 | 0, i29 | 0, (i28 ? HEAP32[i26 >> 2] | 0 : i26) | 0, (i28 ? HEAP32[i26 + 4 >> 2] | 0 : i4 & 255) | 0) | 0;
         i28 = __THREW__;
         __THREW__ = 0;
         if (i28 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
          break;
         };
         HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
         HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i4 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i33, i5);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i3, i33);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i5);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
         break L835;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
       }
       break L771;
      } while (0);
      i28 = (HEAP32[i6 >> 2] | 0) + -24 | 0;
      HEAP32[i26 >> 2] = HEAP32[i31 + 12 >> 2];
      __THREW__ = 0;
      invoke_viii(fb + 1065 | 0, i33 | 0, i28 | 0, i26 | 0);
      i28 = __THREW__;
      __THREW__ = 0;
      L853 : do if (i28 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       i5 = i31 + 16 | 0;
       i2 = i31 + 20 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i28 = HEAP32[i31 + 24 >> 2] | 0;
       i6 = i28;
       do if (i3 >>> 0 < i28 >>> 0) {
        HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
        HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
        i31 = i33 + 4 | 0;
        HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
        i30 = i33 + 8 | 0;
        HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
        HEAP32[i30 >> 2] = 0;
        HEAP32[i31 >> 2] = 0;
        HEAP32[i33 >> 2] = 0;
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
       } else {
        i4 = HEAP32[i5 >> 2] | 0;
        i2 = i3 - i4 >> 4;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 268435455) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i5 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
         break L853;
        } else {
         i28 = i6 - i4 | 0;
         i30 = i28 >> 3;
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i29, i28 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
         i31 = i29 + 8 | 0;
         i30 = HEAP32[i31 >> 2] | 0;
         HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
         HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
         i28 = i33 + 4 | 0;
         HEAP32[i30 + 4 >> 2] = HEAP32[i28 >> 2];
         i26 = i33 + 8 | 0;
         HEAP32[i30 + 8 >> 2] = HEAP32[i26 >> 2];
         HEAP32[i26 >> 2] = 0;
         HEAP32[i28 >> 2] = 0;
         HEAP32[i33 >> 2] = 0;
         HEAP32[i31 >> 2] = i30 + 16;
         __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i29);
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i29);
         break;
        }
       } while (0);
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
       break L1;
      } while (0);
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
     break;
    }
   case 83:
    {
     i1 = i28 + 1 | 0;
     if ((i1 | 0) != (i23 | 0)) if ((HEAP8[i1 >> 0] | 0) == 116) {
      i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
      if ((i1 | 0) == (i28 | 0)) {
       i1 = i28;
       break L1;
      }
      i2 = HEAP32[i31 + 4 >> 2] | 0;
      if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
       i1 = i28;
       break L1;
      }
      i6 = i31 + 16 | 0;
      HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
      i2 = i31 + 20 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i29 = HEAP32[i31 + 24 >> 2] | 0;
      i5 = i29;
      do if (i3 >>> 0 < i29 >>> 0) {
       HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
       HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
       i31 = i33 + 4 | 0;
       HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
       i30 = i33 + 8 | 0;
       HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i30 >> 2] = 0;
       HEAP32[i31 >> 2] = 0;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
      } else {
       i4 = HEAP32[i6 >> 2] | 0;
       i2 = i3 - i4 >> 4;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 268435455) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i6 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
        break L71;
       } else {
        i29 = i5 - i4 | 0;
        i30 = i29 >> 3;
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i7, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
        i31 = i7 + 8 | 0;
        i30 = HEAP32[i31 >> 2] | 0;
        HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
        HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
        i29 = i33 + 4 | 0;
        HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
        i28 = i33 + 8 | 0;
        HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i28 >> 2] = 0;
        HEAP32[i29 >> 2] = 0;
        HEAP32[i33 >> 2] = 0;
        HEAP32[i31 >> 2] = i30 + 16;
        __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i7);
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i7);
        break;
       }
      } while (0);
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
     if ((i1 | 0) == (i28 | 0)) {
      i1 = i28;
      break L1;
     }
     i6 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i1, i23, i31) | 0;
     if ((i6 | 0) == (i1 | 0)) break L1;
     i4 = i31 + 4 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (((i2 - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i33, i2 + -24 | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     i2 = i1 + -24 | 0;
     i3 = i1;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) break;
      i28 = i3 + -24 | 0;
      HEAP32[i4 >> 2] = i28;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i28);
      i3 = HEAP32[i4 >> 2] | 0;
     }
     i28 = HEAP8[i33 + 11 >> 0] | 0;
     i26 = i28 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i1 + -48 | 0, (i26 ? HEAP32[i33 >> 2] | 0 : i33) | 0, (i26 ? HEAP32[i33 + 4 >> 2] | 0 : i28 & 255) | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i28 = (HEAP32[i4 >> 2] | 0) + -24 | 0;
      HEAP32[i27 >> 2] = HEAP32[i31 + 12 >> 2];
      __THREW__ = 0;
      invoke_viii(fb + 1065 | 0, i29 | 0, i28 | 0, i27 | 0);
      i28 = __THREW__;
      __THREW__ = 0;
      L889 : do if (i28 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       i4 = i31 + 16 | 0;
       i1 = i31 + 20 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       i28 = HEAP32[i31 + 24 >> 2] | 0;
       i5 = i28;
       do if (i2 >>> 0 < i28 >>> 0) {
        HEAP32[i2 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
        HEAP32[i2 >> 2] = HEAP32[i29 >> 2];
        i31 = i29 + 4 | 0;
        HEAP32[i2 + 4 >> 2] = HEAP32[i31 >> 2];
        i30 = i29 + 8 | 0;
        HEAP32[i2 + 8 >> 2] = HEAP32[i30 >> 2];
        HEAP32[i30 >> 2] = 0;
        HEAP32[i31 >> 2] = 0;
        HEAP32[i29 >> 2] = 0;
        HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
       } else {
        i3 = HEAP32[i4 >> 2] | 0;
        i1 = i2 - i3 >> 4;
        i2 = i1 + 1 | 0;
        if (i2 >>> 0 > 268435455) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i4 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
         break L889;
        } else {
         i28 = i5 - i3 | 0;
         i30 = i28 >> 3;
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i10, i28 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i2 >>> 0 ? i2 : i30) : 268435455, i1, i31 + 28 | 0);
         i31 = i10 + 8 | 0;
         i30 = HEAP32[i31 >> 2] | 0;
         HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
         HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
         i28 = i29 + 4 | 0;
         HEAP32[i30 + 4 >> 2] = HEAP32[i28 >> 2];
         i27 = i29 + 8 | 0;
         HEAP32[i30 + 8 >> 2] = HEAP32[i27 >> 2];
         HEAP32[i27 >> 2] = 0;
         HEAP32[i28 >> 2] = 0;
         HEAP32[i29 >> 2] = 0;
         HEAP32[i31 >> 2] = i30 + 16;
         __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i4, i10);
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i10);
         break;
        }
       } while (0);
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
       i1 = i6;
       break L1;
      } while (0);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
     break;
    }
   case 68:
    {
     i1 = i28 + 1 | 0;
     if ((i1 | 0) == (i23 | 0)) i30 = 819; else {
      i1 = HEAP8[i1 >> 0] | 0;
      switch (i1 << 24 >> 24 | 0) {
      case 112:
       {
        i13 = i31 + 4 | 0;
        i8 = ((HEAP32[i13 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
        i30 = i28 + 2 | 0;
        i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i30, i23, i31) | 0;
        i13 = ((HEAP32[i13 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
        if ((i1 | 0) == (i30 | 0)) {
         i30 = 819;
         break L71;
        }
        i5 = i31 + 16 | 0;
        i4 = HEAP32[i31 + 12 >> 2] | 0;
        i12 = i31 + 20 | 0;
        i2 = HEAP32[i12 >> 2] | 0;
        i30 = HEAP32[i31 + 24 >> 2] | 0;
        i6 = i30;
        do if (i2 >>> 0 < i30 >>> 0) {
         HEAP32[i2 >> 2] = 0;
         HEAP32[i2 + 4 >> 2] = 0;
         HEAP32[i2 + 8 >> 2] = 0;
         HEAP32[i2 + 12 >> 2] = i4;
         HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 16;
        } else {
         i7 = HEAP32[i5 >> 2] | 0;
         i2 = i2 - i7 >> 4;
         i3 = i2 + 1 | 0;
         if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5); else {
          i29 = i6 - i7 | 0;
          i30 = i29 >> 3;
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i33, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
          i30 = i33 + 8 | 0;
          i29 = HEAP32[i30 >> 2] | 0;
          HEAP32[i29 >> 2] = 0;
          HEAP32[i29 + 4 >> 2] = 0;
          HEAP32[i29 + 8 >> 2] = 0;
          HEAP32[i29 + 12 >> 2] = i4;
          HEAP32[i30 >> 2] = i29 + 16;
          __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i33);
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i33);
          break;
         }
        } while (0);
        i10 = i33 + 8 | 0;
        i7 = i8;
        while (1) {
         if (i7 >>> 0 >= i13 >>> 0) break L1;
         i5 = HEAP32[i12 >> 2] | 0;
         i11 = i5 + -16 | 0;
         i8 = HEAP32[i31 >> 2] | 0;
         i9 = i8 + (i7 * 24 | 0) | 0;
         i2 = i5 + -12 | 0;
         i3 = HEAP32[i2 >> 2] | 0;
         i30 = HEAP32[i5 + -8 >> 2] | 0;
         i6 = i30;
         if ((i3 | 0) == (i30 | 0)) {
          i4 = HEAP32[i11 >> 2] | 0;
          i2 = (i3 - i4 | 0) / 24 | 0;
          i3 = i2 + 1 | 0;
          if (i3 >>> 0 > 178956970) {
           i30 = 693;
           break;
          }
          i29 = (i6 - i4 | 0) / 24 | 0;
          i30 = i29 << 1;
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i29 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i5 + -4 | 0);
          i2 = HEAP32[i10 >> 2] | 0;
          __THREW__ = 0;
          invoke_vii(fb + 4621 | 0, i2 | 0, i9 | 0);
          i30 = __THREW__;
          __THREW__ = 0;
          if (i30 & 1) {
           i30 = 697;
           break;
          }
          __THREW__ = 0;
          invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i8 + (i7 * 24 | 0) + 12 | 0);
          i30 = __THREW__;
          __THREW__ = 0;
          if (i30 & 1) {
           i30 = 696;
           break;
          }
          HEAP32[i10 >> 2] = i2 + 24;
          __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i11, i33);
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
         } else {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i9);
          __THREW__ = 0;
          invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i8 + (i7 * 24 | 0) + 12 | 0);
          i30 = __THREW__;
          __THREW__ = 0;
          if (i30 & 1) {
           i30 = 690;
           break;
          }
          HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
         }
         i7 = i7 + 1 | 0;
        }
        if ((i30 | 0) == 690) {
         i33 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
         ___resumeException(i33 | 0);
        } else if ((i30 | 0) == 693) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11); else if ((i30 | 0) == 696) {
         i14 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
        } else if ((i30 | 0) == 697) {
         i14 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        }
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
        ___resumeException(i14 | 0);
       }
      case 84:
      case 116:
       {
        i1 = __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
        if ((i1 | 0) == (i28 | 0)) {
         i30 = 819;
         break L71;
        }
        i2 = HEAP32[i31 + 4 >> 2] | 0;
        if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
         i1 = i28;
         break L1;
        }
        i6 = i31 + 16 | 0;
        HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
        i2 = i31 + 20 | 0;
        i3 = HEAP32[i2 >> 2] | 0;
        i29 = HEAP32[i31 + 24 >> 2] | 0;
        i5 = i29;
        do if (i3 >>> 0 < i29 >>> 0) {
         HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
         HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
         i31 = i33 + 4 | 0;
         HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
         i30 = i33 + 8 | 0;
         HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
         HEAP32[i30 >> 2] = 0;
         HEAP32[i31 >> 2] = 0;
         HEAP32[i33 >> 2] = 0;
         HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
        } else {
         i4 = HEAP32[i6 >> 2] | 0;
         i2 = i3 - i4 >> 4;
         i3 = i2 + 1 | 0;
         if (i3 >>> 0 > 268435455) {
          __THREW__ = 0;
          invoke_vi(fb + 4014 | 0, i6 | 0);
          __THREW__ = 0;
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
          break L71;
         } else {
          i29 = i5 - i4 | 0;
          i30 = i29 >> 3;
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i9, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
          i31 = i9 + 8 | 0;
          i30 = HEAP32[i31 >> 2] | 0;
          HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
          HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
          i29 = i33 + 4 | 0;
          HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
          i28 = i33 + 8 | 0;
          HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
          HEAP32[i28 >> 2] = 0;
          HEAP32[i29 >> 2] = 0;
          HEAP32[i33 >> 2] = 0;
          HEAP32[i31 >> 2] = i30 + 16;
          __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i9);
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i9);
          break;
         }
        } while (0);
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
        break L1;
       }
      case 118:
       {
        if (!((i23 - i28 | 0) > 3 & i2 << 24 >> 24 == 68 & i1 << 24 >> 24 == 118)) {
         i30 = 819;
         break L71;
        }
        i5 = i28 + 2 | 0;
        i2 = HEAP8[i5 >> 0] | 0;
        L944 : do if ((i2 + -49 & 255) < 9) {
         i1 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i5, i23) | 0;
         if ((i1 | 0) == (i23 | 0)) i30 = 808; else if ((HEAP8[i1 >> 0] | 0) == 95) {
          i3 = i1 - i5 | 0;
          i2 = i1 + 1 | 0;
          do if ((i2 | 0) != (i23 | 0)) {
           if ((HEAP8[i2 >> 0] | 0) != 112) {
            i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i23, i31) | 0;
            if ((i1 | 0) == (i2 | 0)) break;
            i2 = HEAP32[i31 + 4 >> 2] | 0;
            if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
             i30 = 808;
             break L944;
            }
            i4 = i2 + -24 | 0;
            HEAP32[i27 >> 2] = 0;
            HEAP32[i27 + 4 >> 2] = 0;
            HEAP32[i27 + 8 >> 2] = 0;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i27, i5, i3);
            __THREW__ = 0;
            i3 = invoke_iiii(fb + 520 | 0, i27 | 0, 0, gb + 1086449 | 0) | 0;
            i30 = __THREW__;
            __THREW__ = 0;
            if (i30 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i29 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i29 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             i3 = invoke_iii(fb + 1152 | 0, i29 | 0, gb + 1086372 | 0) | 0;
             i30 = __THREW__;
             __THREW__ = 0;
             do if (i30 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
             } else {
              HEAP32[i33 >> 2] = HEAP32[i3 >> 2];
              HEAP32[i33 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
              HEAP32[i33 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
              i2 = 0;
              while (1) {
               if ((i2 | 0) == 3) break;
               HEAP32[i3 + (i2 << 2) >> 2] = 0;
               i2 = i2 + 1 | 0;
              }
              i30 = HEAP8[i33 + 11 >> 0] | 0;
              i26 = i30 << 24 >> 24 < 0;
              __THREW__ = 0;
              invoke_iiii(fb + 519 | 0, i4 | 0, (i26 ? HEAP32[i33 >> 2] | 0 : i33) | 0, (i26 ? HEAP32[i33 + 4 >> 2] | 0 : i30 & 255) | 0) | 0;
              i30 = __THREW__;
              __THREW__ = 0;
              if (i30 & 1) {
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
               break;
              } else {
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
               i30 = 811;
               break L944;
              }
             } while (0);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
            i30 = 807;
            break L944;
           }
           i1 = i1 + 2 | 0;
           HEAP32[i25 >> 2] = 0;
           HEAP32[i25 + 4 >> 2] = 0;
           HEAP32[i25 + 8 >> 2] = 0;
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i25, i5, i3);
           __THREW__ = 0;
           i3 = invoke_iiii(fb + 520 | 0, i25 | 0, 0, gb + 1086458 | 0) | 0;
           i30 = __THREW__;
           __THREW__ = 0;
           if (i30 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else {
            HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
            HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
            HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i3 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __THREW__ = 0;
            i3 = invoke_iii(fb + 1152 | 0, i27 | 0, gb + 1086372 | 0) | 0;
            i30 = __THREW__;
            __THREW__ = 0;
            L981 : do if (i30 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
            } else {
             HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i29, i26);
             i2 = i31 + 4 | 0;
             i3 = HEAP32[i2 >> 2] | 0;
             i30 = HEAP32[i31 + 8 >> 2] | 0;
             i5 = i30;
             do if (i3 >>> 0 < i30 >>> 0) {
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i29);
              HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
             } else {
              i4 = HEAP32[i31 >> 2] | 0;
              i2 = (i3 - i4 | 0) / 24 | 0;
              i3 = i2 + 1 | 0;
              if (i3 >>> 0 > 178956970) {
               __THREW__ = 0;
               invoke_vi(fb + 4014 | 0, i31 | 0);
               __THREW__ = 0;
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
               __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
               break L981;
              } else {
               i24 = (i5 - i4 | 0) / 24 | 0;
               i30 = i24 << 1;
               __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i24 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i31 + 12 | 0);
               i30 = i33 + 8 | 0;
               i24 = HEAP32[i30 >> 2] | 0;
               __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i24, i29);
               HEAP32[i30 >> 2] = i24 + 24;
               __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i31, i33);
               __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
               break;
              }
             } while (0);
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i29);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i26);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
             i30 = 811;
             break L944;
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i25);
           i30 = 807;
           break L944;
          } while (0);
          i30 = 819;
          break L71;
         } else i30 = 808;
        } else {
         HEAP32[i33 >> 2] = 0;
         HEAP32[i33 + 4 >> 2] = 0;
         HEAP32[i33 + 8 >> 2] = 0;
         i1 = 0;
         while (1) {
          if ((i1 | 0) == 3) break;
          HEAP32[i33 + (i1 << 2) >> 2] = 0;
          i1 = i1 + 1 | 0;
         }
         L1003 : do if (i2 << 24 >> 24 == 95) {
          i1 = i5;
          i30 = 786;
         } else {
          __THREW__ = 0;
          i1 = invoke_iiii(fb + 525 | 0, i5 | 0, i23 | 0, i31 | 0) | 0;
          i26 = __THREW__;
          __THREW__ = 0;
          if (i26 & 1) i30 = 757; else if ((i1 | 0) == (i5 | 0)) {
           i1 = i5;
           i30 = 786;
          } else {
           i10 = i31 + 4 | 0;
           i2 = HEAP32[i10 >> 2] | 0;
           if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) i30 = 805; else {
            __THREW__ = 0;
            invoke_vii(fb + 4619 | 0, i29 | 0, i2 + -24 | 0);
            i26 = __THREW__;
            __THREW__ = 0;
            if (i26 & 1) {
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
             break;
            }
            i8 = i33 + 11 | 0;
            if ((HEAP8[i8 >> 0] | 0) < 0) {
             HEAP8[HEAP32[i33 >> 2] >> 0] = 0;
             HEAP32[i33 + 4 >> 2] = 0;
             i2 = HEAP8[i8 >> 0] | 0;
             if (i2 << 24 >> 24 < 0) {
              i9 = 0;
              i6 = (HEAP32[i33 + 8 >> 2] & 2147483647) + -1 | 0;
              i5 = 1;
             } else i30 = 763;
            } else {
             HEAP8[i33 >> 0] = 0;
             HEAP8[i8 >> 0] = 0;
             i2 = 0;
             i30 = 763;
            }
            if ((i30 | 0) == 763) {
             i9 = i2 & 255;
             i6 = 10;
             i5 = 0;
            }
            i3 = i9 >>> 0 < 11;
            i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
            L1018 : do if ((i7 | 0) != (i6 | 0)) {
             do if (i3) {
              i3 = HEAP32[i33 >> 2] | 0;
              if (i5) {
               i2 = 0;
               i4 = i33;
               i30 = 770;
              } else {
               i5 = 0;
               i6 = 1;
               i4 = i33;
               i30 = 771;
              }
             } else {
              i4 = _malloc(i7 + 1 | 0) | 0;
              if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L1018;
              if (!i5) {
               i5 = 1;
               i6 = 0;
               i3 = i33;
               i30 = 771;
               break;
              }
              i2 = 1;
              i3 = HEAP32[i33 >> 2] | 0;
              i30 = 770;
             } while (0);
             if ((i30 | 0) == 770) {
              i5 = i2;
              i6 = 1;
              i2 = HEAP32[i33 + 4 >> 2] | 0;
             } else if ((i30 | 0) == 771) i2 = i2 & 255;
             i2 = i2 + 1 | 0;
             if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
             if (i6) _free(i3);
             if (i5) {
              HEAP32[i33 + 8 >> 2] = i7 + 1 | -2147483648;
              HEAP32[i33 + 4 >> 2] = i9;
              HEAP32[i33 >> 2] = i4;
              break;
             } else {
              HEAP8[i8 >> 0] = i9;
              break;
             }
            } while (0);
            HEAP32[i33 >> 2] = HEAP32[i29 >> 2];
            HEAP32[i33 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
            HEAP32[i33 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
            i2 = 0;
            while (1) {
             if ((i2 | 0) == 3) break;
             HEAP32[i29 + (i2 << 2) >> 2] = 0;
             i2 = i2 + 1 | 0;
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
            i3 = HEAP32[i10 >> 2] | 0;
            i2 = i3 + -24 | 0;
            while (1) {
             if ((i3 | 0) == (i2 | 0)) {
              i30 = 786;
              break L1003;
             }
             i30 = i3 + -24 | 0;
             HEAP32[i10 >> 2] = i30;
             __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i30);
             i3 = HEAP32[i10 >> 2] | 0;
            }
           }
          }
         } while (0);
         L1046 : do if ((i30 | 0) == 786) {
          L1048 : do if ((i1 | 0) == (i23 | 0)) i1 = i28; else if ((HEAP8[i1 >> 0] | 0) == 95) {
           i2 = i1 + 1 | 0;
           if ((i2 | 0) == (i23 | 0)) i1 = i28; else {
            __THREW__ = 0;
            i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i23 | 0, i31 | 0) | 0;
            i26 = __THREW__;
            __THREW__ = 0;
            if (i26 & 1) {
             i30 = 757;
             break L1046;
            }
            if ((i1 | 0) == (i2 | 0)) i1 = i28; else {
             i2 = HEAP32[i31 + 4 >> 2] | 0;
             if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
              i30 = 805;
              break L1046;
             }
             i3 = i2 + -24 | 0;
             __THREW__ = 0;
             invoke_viii(fb + 1067 | 0, i27 | 0, gb + 1086449 | 0, i33 | 0);
             i26 = __THREW__;
             __THREW__ = 0;
             if (i26 & 1) {
              i1 = ___cxa_find_matching_catch_2() | 0;
              getTempRet0() | 0;
             } else {
              __THREW__ = 0;
              i4 = invoke_iii(fb + 1152 | 0, i27 | 0, gb + 1086372 | 0) | 0;
              i26 = __THREW__;
              __THREW__ = 0;
              do if (i26 & 1) {
               i1 = ___cxa_find_matching_catch_2() | 0;
               getTempRet0() | 0;
              } else {
               HEAP32[i29 >> 2] = HEAP32[i4 >> 2];
               HEAP32[i29 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
               HEAP32[i29 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
               i2 = 0;
               while (1) {
                if ((i2 | 0) == 3) break;
                HEAP32[i4 + (i2 << 2) >> 2] = 0;
                i2 = i2 + 1 | 0;
               }
               i26 = HEAP8[i29 + 11 >> 0] | 0;
               i25 = i26 << 24 >> 24 < 0;
               __THREW__ = 0;
               invoke_iiii(fb + 519 | 0, i3 | 0, (i25 ? HEAP32[i29 >> 2] | 0 : i29) | 0, (i25 ? HEAP32[i29 + 4 >> 2] | 0 : i26 & 255) | 0) | 0;
               i26 = __THREW__;
               __THREW__ = 0;
               if (i26 & 1) {
                i1 = ___cxa_find_matching_catch_2() | 0;
                getTempRet0() | 0;
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
                break;
               } else {
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i29);
                __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
                break L1048;
               }
              } while (0);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i27);
             }
             break L1046;
            }
           }
          } else i1 = i28; while (0);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
          i30 = 811;
          break L944;
         } while (0);
         if ((i30 | 0) == 757) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else if ((i30 | 0) == 805) {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
          i30 = 808;
          break;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
         i30 = 807;
        } while (0);
        if ((i30 | 0) == 807) ___resumeException(i1 | 0); else if ((i30 | 0) == 808) {
         i30 = 819;
         break L71;
        } else if ((i30 | 0) == 811) {
         if ((i1 | 0) == (i28 | 0)) {
          i30 = 819;
          break L71;
         }
         i2 = HEAP32[i31 + 4 >> 2] | 0;
         if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
          i1 = i28;
          break L1;
         }
         i6 = i31 + 16 | 0;
         HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
         i2 = i31 + 20 | 0;
         i3 = HEAP32[i2 >> 2] | 0;
         i29 = HEAP32[i31 + 24 >> 2] | 0;
         i5 = i29;
         do if (i3 >>> 0 < i29 >>> 0) {
          HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
          HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
          i31 = i33 + 4 | 0;
          HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
          i30 = i33 + 8 | 0;
          HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
          HEAP32[i30 >> 2] = 0;
          HEAP32[i31 >> 2] = 0;
          HEAP32[i33 >> 2] = 0;
          HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
         } else {
          i4 = HEAP32[i6 >> 2] | 0;
          i2 = i3 - i4 >> 4;
          i3 = i2 + 1 | 0;
          if (i3 >>> 0 > 268435455) {
           __THREW__ = 0;
           invoke_vi(fb + 4014 | 0, i6 | 0);
           __THREW__ = 0;
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
           break L71;
          } else {
           i29 = i5 - i4 | 0;
           i30 = i29 >> 3;
           __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i15, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
           i31 = i15 + 8 | 0;
           i30 = HEAP32[i31 >> 2] | 0;
           HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
           HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
           i29 = i33 + 4 | 0;
           HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
           i28 = i33 + 8 | 0;
           HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
           HEAP32[i28 >> 2] = 0;
           HEAP32[i29 >> 2] = 0;
           HEAP32[i33 >> 2] = 0;
           HEAP32[i31 >> 2] = i30 + 16;
           __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i15);
           __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i15);
           break;
          }
         } while (0);
         __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
         break L1;
        }
        break;
       }
      default:
       {
        i30 = 819;
        break L71;
       }
      }
     }
     break;
    }
   default:
    i30 = 819;
   } while (0);
   L1088 : do if ((i30 | 0) == 819) {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_118parse_builtin_typeINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
    if ((i1 | 0) != (i28 | 0)) break L1;
    i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_(i28, i23, i31) | 0;
    if ((i1 | 0) == (i28 | 0)) {
     i1 = i28;
     break L1;
    }
    i2 = HEAP32[i31 + 4 >> 2] | 0;
    if ((HEAP32[i31 >> 2] | 0) == (i2 | 0)) {
     i1 = i28;
     break L1;
    }
    i6 = i31 + 16 | 0;
    HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
    __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i33, i2 + -24 | 0, i29);
    i2 = i31 + 20 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i30 = HEAP32[i31 + 24 >> 2] | 0;
    i5 = i30;
    do if (i3 >>> 0 < i30 >>> 0) {
     HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
     i31 = i33 + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i31 >> 2];
     i30 = i33 + 8 | 0;
     HEAP32[i3 + 8 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i30 >> 2] = 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i33 >> 2] = 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
    } else {
     i4 = HEAP32[i6 >> 2] | 0;
     i2 = i3 - i4 >> 4;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 268435455) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i6 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
      break L1088;
     } else {
      i29 = i5 - i4 | 0;
      i30 = i29 >> 3;
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i21, i29 >> 4 >>> 0 < 134217727 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 268435455, i2, i31 + 28 | 0);
      i31 = i21 + 8 | 0;
      i30 = HEAP32[i31 >> 2] | 0;
      HEAP32[i30 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
      HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
      i29 = i33 + 4 | 0;
      HEAP32[i30 + 4 >> 2] = HEAP32[i29 >> 2];
      i28 = i33 + 8 | 0;
      HEAP32[i30 + 8 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i28 >> 2] = 0;
      HEAP32[i29 >> 2] = 0;
      HEAP32[i33 >> 2] = 0;
      HEAP32[i31 >> 2] = i30 + 16;
      __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i21);
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i21);
      break;
     }
    } while (0);
    __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
    break L1;
   } while (0);
   ___resumeException(i1 | 0);
  }
 } while (0);
 STACKTOP = i32;
 return i1 | 0;
}

function __ZN5physx31setupFinalizeSolverConstraints4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRKNS_6shdfnd3aos5Vec4VES9_S9_S9_(i425, i427, i13, f426, f424, i7, i5, i8, i6) {
 i425 = i425 | 0;
 i427 = i427 | 0;
 i13 = i13 | 0;
 f426 = Math_fround(f426);
 f424 = Math_fround(f424);
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, i39 = 0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, i100 = 0, i101 = 0, f102 = f0, f103 = f0, f104 = f0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, f202 = f0, f203 = f0, f204 = f0, f205 = f0, f206 = f0, f207 = f0, f208 = f0, f209 = f0, f210 = f0, f211 = f0, f212 = f0, f213 = f0, f214 = f0, f215 = f0, f216 = f0, f217 = f0, f218 = f0, f219 = f0, f220 = f0, f221 = f0, f222 = f0, f223 = f0, f224 = f0, f225 = f0, f226 = f0, f227 = f0, f228 = f0, f229 = f0, f230 = f0, f231 = f0, f232 = f0, f233 = f0, f234 = f0, f235 = f0, f236 = f0, f237 = f0, f238 = f0, f239 = f0, f240 = f0, f241 = f0, f242 = f0, f243 = f0, f244 = f0, f245 = f0, f246 = f0, f247 = f0, f248 = f0, f249 = f0, f250 = f0, f251 = f0, f252 = f0, f253 = f0, f254 = f0, f255 = f0, f256 = f0, f257 = f0, f258 = f0, f259 = f0, f260 = f0, f261 = f0, f262 = f0, f263 = f0, f264 = f0, f265 = f0, f266 = f0, f267 = f0, f268 = f0, f269 = f0, f270 = f0, f271 = f0, f272 = f0, f273 = f0, f274 = f0, f275 = f0, f276 = f0, f277 = f0, f278 = f0, f279 = f0, f280 = f0, f281 = f0, f282 = f0, f283 = f0, f284 = f0, f285 = f0, f286 = f0, f287 = f0, f288 = f0, f289 = f0, f290 = f0, f291 = f0, f292 = f0, f293 = f0, f294 = f0, f295 = f0, f296 = f0, f297 = f0, f298 = f0, f299 = f0, f300 = f0, f301 = f0, f302 = f0, f303 = f0, f304 = f0, f305 = f0, f306 = f0, f307 = f0, f308 = f0, f309 = f0, f310 = f0, f311 = f0, f312 = f0, f313 = f0, f314 = f0, f315 = f0, f316 = f0, f317 = f0, f318 = f0, f319 = f0, f320 = f0, f321 = f0, f322 = f0, f323 = f0, f324 = f0, f325 = f0, f326 = f0, f327 = f0, f328 = f0, f329 = f0, f330 = f0, f331 = f0, f332 = f0, f333 = f0, f334 = f0, f335 = f0, f336 = f0, f337 = f0, f338 = f0, f339 = f0, f340 = f0, f341 = f0, f342 = f0, f343 = f0, f344 = f0, f345 = f0, f346 = f0, f347 = f0, f348 = f0, f349 = f0, f350 = f0, f351 = f0, f352 = f0, f353 = f0, f354 = f0, f355 = f0, f356 = f0, f357 = f0, f358 = f0, f359 = f0, f360 = f0, f361 = f0, f362 = f0, f363 = f0, f364 = f0, f365 = f0, f366 = f0, f367 = f0, f368 = f0, f369 = f0, f370 = f0, f371 = f0, f372 = f0, f373 = f0, f374 = f0, f375 = f0, f376 = f0, f377 = f0, f378 = f0, f379 = f0, f380 = f0, f381 = f0, f382 = f0, f383 = f0, f384 = f0, f385 = f0, f386 = f0, f387 = f0, f388 = f0, f389 = f0, f390 = f0, f391 = f0, f392 = f0, f393 = f0, f394 = f0, f395 = f0, f396 = f0, f397 = f0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, f404 = f0, f405 = f0, f406 = f0, f407 = f0, f408 = f0, f409 = f0, f410 = f0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i428 = 0, f429 = f0, f430 = f0, f431 = f0, f432 = f0, f433 = f0, f434 = f0, f435 = f0, f436 = f0, f437 = f0, f438 = f0, f439 = f0, f440 = f0, i441 = 0, f442 = f0, f443 = f0, f444 = f0, f445 = f0, f446 = f0, f447 = f0, f448 = f0, f449 = f0, f450 = f0, f451 = f0, f452 = f0, f453 = f0, f454 = f0, f455 = f0, f456 = f0, f457 = f0, f458 = f0, f459 = f0, f460 = f0, f461 = f0, f462 = f0, f463 = f0, f464 = f0, f465 = f0, f466 = f0, f467 = f0, f468 = f0, f469 = f0, f470 = f0, f471 = f0, f472 = f0, f473 = f0;
 i428 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i423 = i428;
 HEAP32[i423 >> 2] = 0;
 HEAP32[i423 + 4 >> 2] = 0;
 HEAP32[i423 + 8 >> 2] = 0;
 HEAP32[i423 + 12 >> 2] = 0;
 i9 = HEAP32[i425 >> 2] | 0;
 i2 = HEAP16[i9 + 22 >> 1] | 0;
 i419 = (i2 & 65535) >>> 8 & 1;
 i420 = i425 + 56 | 0;
 i10 = HEAP32[i420 >> 2] | 0;
 i4 = HEAP16[i10 + 22 >> 1] | 0;
 i414 = (i4 & 65535) >>> 8 & 1;
 i415 = i425 + 112 | 0;
 i11 = HEAP32[i415 >> 2] | 0;
 i1 = HEAP16[i11 + 22 >> 1] | 0;
 i416 = (i1 & 65535) >>> 8 & 1;
 i417 = i425 + 168 | 0;
 i12 = HEAP32[i417 >> 2] | 0;
 i3 = HEAP16[i12 + 22 >> 1] | 0;
 i418 = (i3 & 65535) >>> 8 & 1;
 if (!(HEAP8[i425 + 53 >> 0] | 0)) if (!(HEAP8[i425 + 109 >> 0] | 0)) if (!(HEAP8[i425 + 165 >> 0] | 0)) i422 = (HEAP8[i425 + 221 >> 0] | 0) != 0; else i422 = 1; else i422 = 1; else i422 = 1;
 if (!(HEAP8[i425 + 54 >> 0] | 0)) if (!(HEAP8[i425 + 110 >> 0] | 0)) if (!(HEAP8[i425 + 166 >> 0] | 0)) i421 = (HEAP8[i425 + 222 >> 0] | 0) != 0; else i421 = 1; else i421 = 1; else i421 = 1;
 i1 = (i4 | i2 | i1 | i3) & 64;
 i411 = i1 << 16 >> 16 != 0;
 i412 = i411 ? 240 : 144;
 i413 = i411 ? 224 : 128;
 f341 = Math_fround(HEAPF32[i9 + 84 >> 2]);
 f342 = Math_fround(HEAPF32[i10 + 84 >> 2]);
 f343 = Math_fround(HEAPF32[i11 + 84 >> 2]);
 f344 = Math_fround(HEAPF32[i12 + 84 >> 2]);
 f405 = Math_fround(HEAPF32[i9 + 88 >> 2]);
 f404 = Math_fround(HEAPF32[i10 + 88 >> 2]);
 f196 = Math_fround(HEAPF32[i11 + 88 >> 2]);
 f340 = Math_fround(HEAPF32[i12 + 88 >> 2]);
 f277 = Math_fround(HEAPF32[i7 >> 2]);
 f273 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f269 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f277 = Math_fround(f341 * f277);
 f273 = Math_fround(f342 * f273);
 f269 = Math_fround(f343 * f269);
 f268 = Math_fround(f344 * Math_fround(HEAPF32[i7 + 12 >> 2]));
 f262 = Math_fround(HEAPF32[i8 >> 2]);
 f264 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f266 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f262 = Math_fround(f405 * f262);
 f264 = Math_fround(f404 * f264);
 f266 = Math_fround(f196 * f266);
 f267 = Math_fround(f340 * Math_fround(HEAPF32[i8 + 12 >> 2]));
 f347 = Math_fround(HEAPF32[i5 >> 2]);
 f346 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f345 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f347 = Math_fround(f341 * f347);
 f346 = Math_fround(f342 * f346);
 f345 = Math_fround(f343 * f345);
 f344 = Math_fround(f344 * Math_fround(HEAPF32[i5 + 12 >> 2]));
 f343 = Math_fround(HEAPF32[i6 >> 2]);
 f342 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f341 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f343 = Math_fround(f405 * f343);
 f342 = Math_fround(f404 * f342);
 f341 = Math_fround(f196 * f341);
 f340 = Math_fround(f340 * Math_fround(HEAPF32[i6 + 12 >> 2]));
 i398 = HEAP32[i425 + 44 >> 2] | 0;
 f196 = Math_fround(HEAPF32[i398 + 52 >> 2]);
 i402 = HEAP32[i425 + 100 >> 2] | 0;
 f404 = Math_fround(HEAPF32[i402 + 52 >> 2]);
 i399 = HEAP32[i425 + 156 >> 2] | 0;
 f405 = Math_fround(HEAPF32[i399 + 52 >> 2]);
 i403 = HEAP32[i425 + 212 >> 2] | 0;
 f406 = Math_fround(HEAPF32[i403 + 52 >> 2]);
 i400 = HEAP32[i425 + 48 >> 2] | 0;
 f407 = Math_fround(HEAPF32[i400 + 52 >> 2]);
 i195 = HEAP32[i425 + 104 >> 2] | 0;
 f408 = Math_fround(HEAPF32[i195 + 52 >> 2]);
 i401 = HEAP32[i425 + 160 >> 2] | 0;
 f409 = Math_fround(HEAPF32[i401 + 52 >> 2]);
 i194 = HEAP32[i425 + 216 >> 2] | 0;
 f410 = Math_fround(HEAPF32[i194 + 52 >> 2]);
 f407 = f196 > f407 ? f196 : f407;
 f408 = f404 > f408 ? f404 : f408;
 f409 = f405 > f409 ? f405 : f409;
 f410 = f406 > f410 ? f406 : f410;
 f406 = Math_fround(HEAPF32[i9 + 92 >> 2]);
 f405 = Math_fround(HEAPF32[i10 + 92 >> 2]);
 f404 = Math_fround(HEAPF32[i11 + 92 >> 2]);
 f196 = Math_fround(HEAPF32[i12 + 92 >> 2]);
 i178 = HEAP32[i425 + 36 >> 2] | 0;
 f197 = Math_fround(HEAPF32[i178 >> 2]);
 f198 = Math_fround(HEAPF32[i178 + 4 >> 2]);
 f199 = Math_fround(HEAPF32[i178 + 8 >> 2]);
 i179 = HEAP32[i425 + 92 >> 2] | 0;
 f200 = Math_fround(HEAPF32[i179 >> 2]);
 f201 = Math_fround(HEAPF32[i179 + 4 >> 2]);
 f202 = Math_fround(HEAPF32[i179 + 8 >> 2]);
 i180 = HEAP32[i425 + 148 >> 2] | 0;
 f203 = Math_fround(HEAPF32[i180 >> 2]);
 f204 = Math_fround(HEAPF32[i180 + 4 >> 2]);
 f205 = Math_fround(HEAPF32[i180 + 8 >> 2]);
 i181 = HEAP32[i425 + 204 >> 2] | 0;
 f206 = Math_fround(HEAPF32[i181 >> 2]);
 f207 = Math_fround(HEAPF32[i181 + 4 >> 2]);
 f208 = Math_fround(HEAPF32[i181 + 8 >> 2]);
 i182 = HEAP32[i425 + 40 >> 2] | 0;
 f209 = Math_fround(HEAPF32[i182 >> 2]);
 f210 = Math_fround(HEAPF32[i182 + 4 >> 2]);
 f211 = Math_fround(HEAPF32[i182 + 8 >> 2]);
 i191 = HEAP32[i425 + 96 >> 2] | 0;
 f212 = Math_fround(HEAPF32[i191 >> 2]);
 f213 = Math_fround(HEAPF32[i191 + 4 >> 2]);
 f214 = Math_fround(HEAPF32[i191 + 8 >> 2]);
 i192 = HEAP32[i425 + 152 >> 2] | 0;
 f215 = Math_fround(HEAPF32[i192 >> 2]);
 f216 = Math_fround(HEAPF32[i192 + 4 >> 2]);
 f217 = Math_fround(HEAPF32[i192 + 8 >> 2]);
 i193 = HEAP32[i425 + 208 >> 2] | 0;
 f218 = Math_fround(HEAPF32[i193 >> 2]);
 f219 = Math_fround(HEAPF32[i193 + 4 >> 2]);
 f220 = Math_fround(HEAPF32[i193 + 8 >> 2]);
 i178 = i178 + 16 | 0;
 f221 = Math_fround(HEAPF32[i178 >> 2]);
 f222 = Math_fround(HEAPF32[i178 + 4 >> 2]);
 f223 = Math_fround(HEAPF32[i178 + 8 >> 2]);
 i179 = i179 + 16 | 0;
 f224 = Math_fround(HEAPF32[i179 >> 2]);
 f225 = Math_fround(HEAPF32[i179 + 4 >> 2]);
 f226 = Math_fround(HEAPF32[i179 + 8 >> 2]);
 i180 = i180 + 16 | 0;
 f227 = Math_fround(HEAPF32[i180 >> 2]);
 f228 = Math_fround(HEAPF32[i180 + 4 >> 2]);
 f229 = Math_fround(HEAPF32[i180 + 8 >> 2]);
 i181 = i181 + 16 | 0;
 f230 = Math_fround(HEAPF32[i181 >> 2]);
 f231 = Math_fround(HEAPF32[i181 + 4 >> 2]);
 f232 = Math_fround(HEAPF32[i181 + 8 >> 2]);
 i182 = i182 + 16 | 0;
 f233 = Math_fround(HEAPF32[i182 >> 2]);
 f234 = Math_fround(HEAPF32[i182 + 4 >> 2]);
 f235 = Math_fround(HEAPF32[i182 + 8 >> 2]);
 i191 = i191 + 16 | 0;
 f236 = Math_fround(HEAPF32[i191 >> 2]);
 f237 = Math_fround(HEAPF32[i191 + 4 >> 2]);
 f238 = Math_fround(HEAPF32[i191 + 8 >> 2]);
 i192 = i192 + 16 | 0;
 f239 = Math_fround(HEAPF32[i192 >> 2]);
 f240 = Math_fround(HEAPF32[i192 + 4 >> 2]);
 f241 = Math_fround(HEAPF32[i192 + 8 >> 2]);
 i193 = i193 + 16 | 0;
 f242 = Math_fround(HEAPF32[i193 >> 2]);
 f243 = Math_fround(HEAPF32[i193 + 4 >> 2]);
 f244 = Math_fround(HEAPF32[i193 + 8 >> 2]);
 f245 = Math_fround(f197 - f209);
 f246 = Math_fround(f200 - f212);
 f247 = Math_fround(f203 - f215);
 f248 = Math_fround(f206 - f218);
 f249 = Math_fround(f198 - f210);
 f250 = Math_fround(f201 - f213);
 f251 = Math_fround(f204 - f216);
 f252 = Math_fround(f207 - f219);
 f253 = Math_fround(f199 - f211);
 f254 = Math_fround(f202 - f214);
 f255 = Math_fround(f205 - f217);
 f256 = Math_fround(f208 - f220);
 f257 = Math_fround(HEAPF32[i398 + 48 >> 2]);
 f258 = Math_fround(HEAPF32[i402 + 48 >> 2]);
 f259 = Math_fround(HEAPF32[i399 + 48 >> 2]);
 f260 = Math_fround(HEAPF32[i403 + 48 >> 2]);
 f261 = Math_fround(HEAPF32[i400 + 48 >> 2]);
 f263 = Math_fround(HEAPF32[i195 + 48 >> 2]);
 f265 = Math_fround(HEAPF32[i401 + 48 >> 2]);
 f257 = Math_fround(f277 * f257);
 f258 = Math_fround(f273 * f258);
 f259 = Math_fround(f269 * f259);
 f260 = Math_fround(f268 * f260);
 f261 = Math_fround(f262 * f261);
 f262 = Math_fround(-f261);
 f263 = Math_fround(f264 * f263);
 f264 = Math_fround(-f263);
 f265 = Math_fround(f266 * f265);
 f266 = Math_fround(-f265);
 f267 = Math_fround(f267 * Math_fround(HEAPF32[i194 + 48 >> 2]));
 f268 = Math_fround(-f267);
 f269 = Math_fround(HEAPF32[i398 >> 2]);
 f273 = Math_fround(HEAPF32[i398 + 4 >> 2]);
 f277 = Math_fround(HEAPF32[i398 + 8 >> 2]);
 f281 = Math_fround(HEAPF32[i398 + 12 >> 2]);
 f285 = Math_fround(HEAPF32[i398 + 16 >> 2]);
 f289 = Math_fround(HEAPF32[i398 + 20 >> 2]);
 f293 = Math_fround(HEAPF32[i398 + 24 >> 2]);
 f297 = Math_fround(HEAPF32[i398 + 28 >> 2]);
 f301 = Math_fround(HEAPF32[i398 + 32 >> 2]);
 f270 = Math_fround(HEAPF32[i402 >> 2]);
 f274 = Math_fround(HEAPF32[i402 + 4 >> 2]);
 f278 = Math_fround(HEAPF32[i402 + 8 >> 2]);
 f282 = Math_fround(HEAPF32[i402 + 12 >> 2]);
 f286 = Math_fround(HEAPF32[i402 + 16 >> 2]);
 f290 = Math_fround(HEAPF32[i402 + 20 >> 2]);
 f294 = Math_fround(HEAPF32[i402 + 24 >> 2]);
 f298 = Math_fround(HEAPF32[i402 + 28 >> 2]);
 f302 = Math_fround(HEAPF32[i402 + 32 >> 2]);
 f271 = Math_fround(HEAPF32[i399 >> 2]);
 f275 = Math_fround(HEAPF32[i399 + 4 >> 2]);
 f279 = Math_fround(HEAPF32[i399 + 8 >> 2]);
 f283 = Math_fround(HEAPF32[i399 + 12 >> 2]);
 f287 = Math_fround(HEAPF32[i399 + 16 >> 2]);
 f291 = Math_fround(HEAPF32[i399 + 20 >> 2]);
 f295 = Math_fround(HEAPF32[i399 + 24 >> 2]);
 f299 = Math_fround(HEAPF32[i399 + 28 >> 2]);
 f303 = Math_fround(HEAPF32[i399 + 32 >> 2]);
 f272 = Math_fround(HEAPF32[i403 >> 2]);
 f276 = Math_fround(HEAPF32[i403 + 4 >> 2]);
 f280 = Math_fround(HEAPF32[i403 + 8 >> 2]);
 f284 = Math_fround(HEAPF32[i403 + 12 >> 2]);
 f288 = Math_fround(HEAPF32[i403 + 16 >> 2]);
 f292 = Math_fround(HEAPF32[i403 + 20 >> 2]);
 f296 = Math_fround(HEAPF32[i403 + 24 >> 2]);
 f300 = Math_fround(HEAPF32[i403 + 28 >> 2]);
 f304 = Math_fround(HEAPF32[i403 + 32 >> 2]);
 f305 = Math_fround(HEAPF32[i400 >> 2]);
 f309 = Math_fround(HEAPF32[i400 + 4 >> 2]);
 f313 = Math_fround(HEAPF32[i400 + 8 >> 2]);
 f317 = Math_fround(HEAPF32[i400 + 12 >> 2]);
 f321 = Math_fround(HEAPF32[i400 + 16 >> 2]);
 f325 = Math_fround(HEAPF32[i400 + 20 >> 2]);
 f329 = Math_fround(HEAPF32[i400 + 24 >> 2]);
 f333 = Math_fround(HEAPF32[i400 + 28 >> 2]);
 f337 = Math_fround(HEAPF32[i400 + 32 >> 2]);
 f306 = Math_fround(HEAPF32[i195 >> 2]);
 f310 = Math_fround(HEAPF32[i195 + 4 >> 2]);
 f314 = Math_fround(HEAPF32[i195 + 8 >> 2]);
 f318 = Math_fround(HEAPF32[i195 + 12 >> 2]);
 f322 = Math_fround(HEAPF32[i195 + 16 >> 2]);
 f326 = Math_fround(HEAPF32[i195 + 20 >> 2]);
 f330 = Math_fround(HEAPF32[i195 + 24 >> 2]);
 f334 = Math_fround(HEAPF32[i195 + 28 >> 2]);
 f338 = Math_fround(HEAPF32[i195 + 32 >> 2]);
 f307 = Math_fround(HEAPF32[i401 >> 2]);
 f311 = Math_fround(HEAPF32[i401 + 4 >> 2]);
 f315 = Math_fround(HEAPF32[i401 + 8 >> 2]);
 f319 = Math_fround(HEAPF32[i401 + 12 >> 2]);
 f323 = Math_fround(HEAPF32[i401 + 16 >> 2]);
 f327 = Math_fround(HEAPF32[i401 + 20 >> 2]);
 f331 = Math_fround(HEAPF32[i401 + 24 >> 2]);
 f335 = Math_fround(HEAPF32[i401 + 28 >> 2]);
 f339 = Math_fround(HEAPF32[i401 + 32 >> 2]);
 f308 = Math_fround(HEAPF32[i194 >> 2]);
 f312 = Math_fround(HEAPF32[i194 + 4 >> 2]);
 f316 = Math_fround(HEAPF32[i194 + 8 >> 2]);
 f320 = Math_fround(HEAPF32[i194 + 12 >> 2]);
 f324 = Math_fround(HEAPF32[i194 + 16 >> 2]);
 f328 = Math_fround(HEAPF32[i194 + 20 >> 2]);
 f332 = Math_fround(HEAPF32[i194 + 24 >> 2]);
 f336 = Math_fround(HEAPF32[i194 + 28 >> 2]);
 f269 = Math_fround(f347 * f269);
 f270 = Math_fround(f346 * f270);
 f271 = Math_fround(f345 * f271);
 f272 = Math_fround(f344 * f272);
 f273 = Math_fround(f347 * f273);
 f274 = Math_fround(f346 * f274);
 f275 = Math_fround(f345 * f275);
 f276 = Math_fround(f344 * f276);
 f277 = Math_fround(f347 * f277);
 f278 = Math_fround(f346 * f278);
 f279 = Math_fround(f345 * f279);
 f280 = Math_fround(f344 * f280);
 f281 = Math_fround(f347 * f281);
 f282 = Math_fround(f346 * f282);
 f283 = Math_fround(f345 * f283);
 f284 = Math_fround(f344 * f284);
 f285 = Math_fround(f347 * f285);
 f286 = Math_fround(f346 * f286);
 f287 = Math_fround(f345 * f287);
 f288 = Math_fround(f344 * f288);
 f289 = Math_fround(f347 * f289);
 f290 = Math_fround(f346 * f290);
 f291 = Math_fround(f345 * f291);
 f292 = Math_fround(f344 * f292);
 f293 = Math_fround(f347 * f293);
 f294 = Math_fround(f346 * f294);
 f295 = Math_fround(f345 * f295);
 f296 = Math_fround(f344 * f296);
 f297 = Math_fround(f347 * f297);
 f298 = Math_fround(f346 * f298);
 f299 = Math_fround(f345 * f299);
 f300 = Math_fround(f344 * f300);
 f301 = Math_fround(f347 * f301);
 f302 = Math_fround(f346 * f302);
 f303 = Math_fround(f345 * f303);
 f304 = Math_fround(f344 * f304);
 f305 = Math_fround(f343 * f305);
 f306 = Math_fround(f342 * f306);
 f307 = Math_fround(f341 * f307);
 f308 = Math_fround(f340 * f308);
 f309 = Math_fround(f343 * f309);
 f310 = Math_fround(f342 * f310);
 f311 = Math_fround(f341 * f311);
 f312 = Math_fround(f340 * f312);
 f313 = Math_fround(f343 * f313);
 f314 = Math_fround(f342 * f314);
 f315 = Math_fround(f341 * f315);
 f316 = Math_fround(f340 * f316);
 f317 = Math_fround(f343 * f317);
 f318 = Math_fround(f342 * f318);
 f319 = Math_fround(f341 * f319);
 f320 = Math_fround(f340 * f320);
 f321 = Math_fround(f343 * f321);
 f322 = Math_fround(f342 * f322);
 f323 = Math_fround(f341 * f323);
 f324 = Math_fround(f340 * f324);
 f325 = Math_fround(f343 * f325);
 f326 = Math_fround(f342 * f326);
 f327 = Math_fround(f341 * f327);
 f328 = Math_fround(f340 * f328);
 f329 = Math_fround(f343 * f329);
 f330 = Math_fround(f342 * f330);
 f331 = Math_fround(f341 * f331);
 f332 = Math_fround(f340 * f332);
 f333 = Math_fround(f343 * f333);
 f334 = Math_fround(f342 * f334);
 f335 = Math_fround(f341 * f335);
 f336 = Math_fround(f340 * f336);
 f337 = Math_fround(f343 * f337);
 f338 = Math_fround(f342 * f338);
 f339 = Math_fround(f341 * f339);
 f340 = Math_fround(f340 * Math_fround(HEAPF32[i194 + 32 >> 2]));
 f341 = Math_fround(f426 * Math_fround(.800000011));
 i194 = HEAP32[i425 + 28 >> 2] | 0;
 f342 = Math_fround(HEAPF32[i194 + 16 >> 2]);
 f343 = Math_fround(HEAPF32[i194 + 20 >> 2]);
 f344 = Math_fround(HEAPF32[i194 + 24 >> 2]);
 i401 = HEAP32[i425 + 84 >> 2] | 0;
 f345 = Math_fround(HEAPF32[i401 + 16 >> 2]);
 f346 = Math_fround(HEAPF32[i401 + 20 >> 2]);
 f347 = Math_fround(HEAPF32[i401 + 24 >> 2]);
 i195 = HEAP32[i425 + 140 >> 2] | 0;
 f348 = Math_fround(HEAPF32[i195 + 16 >> 2]);
 f349 = Math_fround(HEAPF32[i195 + 20 >> 2]);
 f350 = Math_fround(HEAPF32[i195 + 24 >> 2]);
 i400 = HEAP32[i425 + 196 >> 2] | 0;
 f351 = Math_fround(HEAPF32[i400 + 16 >> 2]);
 f352 = Math_fround(HEAPF32[i400 + 20 >> 2]);
 f353 = Math_fround(HEAPF32[i400 + 24 >> 2]);
 i403 = HEAP32[i425 + 32 >> 2] | 0;
 f354 = Math_fround(HEAPF32[i403 + 16 >> 2]);
 f355 = Math_fround(HEAPF32[i403 + 20 >> 2]);
 f356 = Math_fround(HEAPF32[i403 + 24 >> 2]);
 i399 = HEAP32[i425 + 88 >> 2] | 0;
 f357 = Math_fround(HEAPF32[i399 + 16 >> 2]);
 f358 = Math_fround(HEAPF32[i399 + 20 >> 2]);
 f359 = Math_fround(HEAPF32[i399 + 24 >> 2]);
 i402 = HEAP32[i425 + 144 >> 2] | 0;
 f360 = Math_fround(HEAPF32[i402 + 16 >> 2]);
 f361 = Math_fround(HEAPF32[i402 + 20 >> 2]);
 f362 = Math_fround(HEAPF32[i402 + 24 >> 2]);
 i398 = HEAP32[i425 + 200 >> 2] | 0;
 f363 = Math_fround(HEAPF32[i398 + 16 >> 2]);
 f364 = Math_fround(HEAPF32[i398 + 20 >> 2]);
 f365 = Math_fround(HEAPF32[i398 + 24 >> 2]);
 f366 = Math_fround(HEAPF32[i194 >> 2]);
 f367 = Math_fround(HEAPF32[i194 + 4 >> 2]);
 f368 = Math_fround(HEAPF32[i194 + 8 >> 2]);
 f369 = Math_fround(HEAPF32[i194 + 12 >> 2]);
 f370 = Math_fround(HEAPF32[i401 >> 2]);
 f371 = Math_fround(HEAPF32[i401 + 4 >> 2]);
 f372 = Math_fround(HEAPF32[i401 + 8 >> 2]);
 f373 = Math_fround(HEAPF32[i401 + 12 >> 2]);
 f374 = Math_fround(HEAPF32[i195 >> 2]);
 f375 = Math_fround(HEAPF32[i195 + 4 >> 2]);
 f376 = Math_fround(HEAPF32[i195 + 8 >> 2]);
 f377 = Math_fround(HEAPF32[i195 + 12 >> 2]);
 f378 = Math_fround(HEAPF32[i400 >> 2]);
 f379 = Math_fround(HEAPF32[i400 + 4 >> 2]);
 f380 = Math_fround(HEAPF32[i400 + 8 >> 2]);
 f381 = Math_fround(HEAPF32[i400 + 12 >> 2]);
 f382 = Math_fround(HEAPF32[i403 >> 2]);
 f383 = Math_fround(HEAPF32[i403 + 4 >> 2]);
 f384 = Math_fround(HEAPF32[i403 + 8 >> 2]);
 f385 = Math_fround(HEAPF32[i403 + 12 >> 2]);
 f386 = Math_fround(HEAPF32[i399 >> 2]);
 f387 = Math_fround(HEAPF32[i399 + 4 >> 2]);
 f388 = Math_fround(HEAPF32[i399 + 8 >> 2]);
 f389 = Math_fround(HEAPF32[i399 + 12 >> 2]);
 f390 = Math_fround(HEAPF32[i402 >> 2]);
 f391 = Math_fround(HEAPF32[i402 + 4 >> 2]);
 f392 = Math_fround(HEAPF32[i402 + 8 >> 2]);
 f393 = Math_fround(HEAPF32[i402 + 12 >> 2]);
 f394 = Math_fround(HEAPF32[i398 >> 2]);
 f395 = Math_fround(HEAPF32[i398 + 4 >> 2]);
 f396 = Math_fround(HEAPF32[i398 + 8 >> 2]);
 f397 = Math_fround(HEAPF32[i398 + 12 >> 2]);
 i398 = i425 + 8 | 0;
 i402 = HEAP32[i398 >> 2] | 0;
 i399 = i425 + 64 | 0;
 i403 = HEAP32[i399 >> 2] | 0;
 i400 = i425 + 120 | 0;
 i195 = HEAP32[i400 >> 2] | 0;
 i401 = i425 + 176 | 0;
 i194 = HEAP32[i401 >> 2] | 0;
 i195 = i195 >>> 0 < i194 >>> 0 ? i194 : i195;
 i403 = i403 >>> 0 < i195 >>> 0 ? i195 : i403;
 i402 = i402 >>> 0 < i403 >>> 0 ? i403 : i402;
 if (i421) i403 = (i422 & 1 | 2) & 255; else i403 = i422 & 1;
 if (!i402) {
  STACKTOP = i428;
  return;
 }
 i182 = 8 - ((i1 & 65535) >>> 6) & 255;
 i126 = i413 << 1;
 f183 = Math_fround(Math_fround(f369 * f369) + Math_fround(-.5));
 f184 = Math_fround(Math_fround(f373 * f373) + Math_fround(-.5));
 f185 = Math_fround(Math_fround(f377 * f377) + Math_fround(-.5));
 f186 = Math_fround(Math_fround(f381 * f381) + Math_fround(-.5));
 f187 = Math_fround(Math_fround(f385 * f385) + Math_fround(-.5));
 f188 = Math_fround(Math_fround(f389 * f389) + Math_fround(-.5));
 f189 = Math_fround(Math_fround(f393 * f393) + Math_fround(-.5));
 f190 = Math_fround(Math_fround(f397 * f397) + Math_fround(-.5));
 i134 = i413 + 128 | 0;
 i164 = i413 + 132 | 0;
 i165 = i413 + 136 | 0;
 i166 = i413 + 140 | 0;
 i135 = i413 + 144 | 0;
 i167 = i413 + 148 | 0;
 i168 = i413 + 152 | 0;
 i169 = i413 + 156 | 0;
 i136 = i413 + 160 | 0;
 i170 = i413 + 164 | 0;
 i171 = i413 + 168 | 0;
 i172 = i413 + 172 | 0;
 i137 = i413 + 176 | 0;
 i173 = i413 + 180 | 0;
 i174 = i413 + 184 | 0;
 i175 = i413 + 188 | 0;
 i138 = i413 + 192 | 0;
 i176 = i413 + 196 | 0;
 i177 = i413 + 200 | 0;
 i178 = i413 + 204 | 0;
 i139 = i413 + 208 | 0;
 i179 = i413 + 212 | 0;
 i180 = i413 + 216 | 0;
 i181 = i413 + 220 | 0;
 i140 = i413 | 4;
 i141 = i413 | 8;
 i142 = i413 | 12;
 i127 = i413 | 16;
 i143 = i413 | 20;
 i144 = i413 | 24;
 i145 = i413 | 28;
 i128 = i413 + 32 | 0;
 i146 = i413 + 36 | 0;
 i147 = i413 + 40 | 0;
 i148 = i413 + 44 | 0;
 i129 = i413 + 48 | 0;
 i149 = i413 + 52 | 0;
 i150 = i413 + 56 | 0;
 i151 = i413 + 60 | 0;
 i130 = i413 + 64 | 0;
 i152 = i413 + 68 | 0;
 i153 = i413 + 72 | 0;
 i154 = i413 + 76 | 0;
 i131 = i413 + 80 | 0;
 i155 = i413 + 84 | 0;
 i156 = i413 + 88 | 0;
 i157 = i413 + 92 | 0;
 i132 = i413 + 96 | 0;
 i158 = i413 + 100 | 0;
 i159 = i413 + 104 | 0;
 i160 = i413 + 108 | 0;
 i133 = i413 + 112 | 0;
 i161 = i413 + 116 | 0;
 i162 = i413 + 120 | 0;
 i163 = i413 + 124 | 0;
 i191 = i425 + 172 | 0;
 i192 = i425 + 116 | 0;
 i193 = i425 + 60 | 0;
 i194 = i425 + 4 | 0;
 i195 = i413 << 1;
 i42 = 0;
 i31 = 0;
 i37 = 0;
 i44 = 0;
 i29 = 0;
 i22 = 0;
 i33 = 0;
 i39 = 0;
 i1 = 0;
 i2 = 0;
 i3 = 0;
 i4 = 0;
 i6 = 0;
 i7 = 0;
 i8 = 0;
 i9 = 0;
 i5 = 0;
 do {
  i115 = i5 >>> 0 >= (HEAP32[i398 >> 2] | 0) >>> 0;
  i116 = i5 >>> 0 >= (HEAP32[i399 >> 2] | 0) >>> 0;
  i119 = i5 >>> 0 >= (HEAP32[i400 >> 2] | 0) >>> 0;
  i121 = i5 >>> 0 >= (HEAP32[i401 >> 2] | 0) >>> 0;
  if (!i115) i1 = (HEAP32[i194 >> 2] | 0) + i5 | 0;
  if (!i116) i2 = (HEAP32[i193 >> 2] | 0) + i5 | 0;
  if (!i119) i3 = (HEAP32[i192 >> 2] | 0) + i5 | 0;
  if (!i121) i4 = (HEAP32[i191 >> 2] | 0) + i5 | 0;
  if (i115) i14 = 0; else i14 = HEAP32[i427 + 8336 + (i1 << 2) >> 2] | 0;
  if (i116) i12 = 0; else i12 = HEAP32[i427 + 8336 + (i2 << 2) >> 2] | 0;
  if (i119) i10 = 0; else i10 = HEAP32[i427 + 8336 + (i3 << 2) >> 2] | 0;
  if (i121) i11 = 0; else i11 = HEAP32[i427 + 8336 + (i4 << 2) >> 2] | 0;
  i15 = HEAP32[i427 + 8464 + (i1 << 2) >> 2] | 0;
  i16 = HEAP32[i427 + 8464 + (i2 << 2) >> 2] | 0;
  i17 = HEAP32[i427 + 8464 + (i3 << 2) >> 2] | 0;
  i18 = HEAP32[i427 + 8464 + (i4 << 2) >> 2] | 0;
  i122 = HEAPU16[i427 + 4496 + (i15 * 12 | 0) >> 1] | 0;
  i123 = HEAPU16[i427 + 4496 + (i16 * 12 | 0) >> 1] | 0;
  i124 = HEAPU16[i427 + 4496 + (i17 * 12 | 0) >> 1] | 0;
  i125 = HEAPU16[i427 + 4496 + (i18 * 12 | 0) >> 1] | 0;
  f20 = Math_fround(HEAPF32[i427 + 384 + (i122 << 6) + 60 >> 2]);
  f21 = Math_fround(HEAPF32[i427 + 384 + (i123 << 6) + 60 >> 2]);
  f23 = Math_fround(HEAPF32[i427 + 384 + (i124 << 6) + 60 >> 2]);
  f24 = Math_fround(HEAPF32[i427 + 384 + (i125 << 6) + 60 >> 2]);
  f83 = Math_fround(-f20);
  f84 = Math_fround(-f21);
  f85 = Math_fround(-f23);
  f86 = Math_fround(-f24);
  HEAP8[i13 + 4 >> 0] = i419;
  HEAP8[i13 + 5 >> 0] = i414;
  HEAP8[i13 + 6 >> 0] = i416;
  HEAP8[i13 + 7 >> 0] = i418;
  HEAP8[i13 + 3 >> 0] = i403;
  i113 = i10 >>> 0 < i11 >>> 0 ? i11 : i10;
  i113 = i12 >>> 0 < i113 >>> 0 ? i113 : i12;
  i113 = i14 >>> 0 < i113 >>> 0 ? i113 : i14;
  i114 = i113 << 4;
  i117 = i114 + 144 | 0;
  i101 = i13 + i117 | 0;
  _memset(i13 + 144 | 0, 0, i114 | 0) | 0;
  HEAP8[i13 + 1 >> 0] = i113;
  HEAP8[i13 + 8 >> 0] = i14;
  HEAP8[i13 + 9 >> 0] = i12;
  HEAP8[i13 + 10 >> 0] = i10;
  HEAP8[i13 + 11 >> 0] = i11;
  HEAPF32[i13 + 64 >> 2] = f257;
  HEAPF32[i13 + 68 >> 2] = f258;
  HEAPF32[i13 + 72 >> 2] = f259;
  HEAPF32[i13 + 76 >> 2] = f260;
  HEAPF32[i13 + 80 >> 2] = f262;
  HEAPF32[i13 + 84 >> 2] = f264;
  HEAPF32[i13 + 88 >> 2] = f266;
  HEAPF32[i13 + 92 >> 2] = f268;
  i113 = i13 + (i117 + (Math_imul(i113, i412) | 0)) | 0;
  HEAPF32[i13 + 16 >> 2] = f83;
  HEAPF32[i13 + 20 >> 2] = f84;
  HEAPF32[i13 + 24 >> 2] = f85;
  HEAPF32[i13 + 28 >> 2] = f86;
  i117 = i427 + 384 + (i122 << 6) | 0;
  i105 = HEAP32[i117 >> 2] | 0;
  i109 = HEAP32[i117 + 4 >> 2] | 0;
  i117 = HEAP32[i117 + 8 >> 2] | 0;
  i118 = i427 + 384 + (i123 << 6) | 0;
  i106 = HEAP32[i118 >> 2] | 0;
  i110 = HEAP32[i118 + 4 >> 2] | 0;
  i118 = HEAP32[i118 + 8 >> 2] | 0;
  i120 = i427 + 384 + (i124 << 6) | 0;
  i107 = HEAP32[i120 >> 2] | 0;
  i111 = HEAP32[i120 + 4 >> 2] | 0;
  i120 = HEAP32[i120 + 8 >> 2] | 0;
  i100 = i427 + 384 + (i125 << 6) | 0;
  i108 = HEAP32[i100 >> 2] | 0;
  i112 = HEAP32[i100 + 4 >> 2] | 0;
  i100 = HEAP32[i100 + 8 >> 2] | 0;
  HEAP32[i13 + 96 >> 2] = i105;
  HEAP32[i13 + 100 >> 2] = i106;
  HEAP32[i13 + 104 >> 2] = i107;
  HEAP32[i13 + 108 >> 2] = i108;
  HEAP32[i13 + 112 >> 2] = i109;
  HEAP32[i13 + 116 >> 2] = i110;
  HEAP32[i13 + 120 >> 2] = i111;
  HEAP32[i13 + 124 >> 2] = i112;
  HEAP32[i13 + 128 >> 2] = i117;
  HEAP32[i13 + 132 >> 2] = i118;
  HEAP32[i13 + 136 >> 2] = i120;
  HEAP32[i13 + 140 >> 2] = i100;
  f95 = (HEAP32[tempDoublePtr >> 2] = i105, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(f197 * f95);
  f97 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f88 = Math_fround(f200 * f97);
  f99 = (HEAP32[tempDoublePtr >> 2] = i107, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f89 = Math_fround(f203 * f99);
  f103 = (HEAP32[tempDoublePtr >> 2] = i108, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f90 = Math_fround(f206 * f103);
  f96 = (HEAP32[tempDoublePtr >> 2] = i109, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f98 = (HEAP32[tempDoublePtr >> 2] = i110, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f102 = (HEAP32[tempDoublePtr >> 2] = i111, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f104 = (HEAP32[tempDoublePtr >> 2] = i112, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(f87 + Math_fround(f198 * f96));
  f88 = Math_fround(f88 + Math_fround(f201 * f98));
  f89 = Math_fround(f89 + Math_fround(f204 * f102));
  f90 = Math_fround(f90 + Math_fround(f207 * f104));
  f91 = (HEAP32[tempDoublePtr >> 2] = i117, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f92 = (HEAP32[tempDoublePtr >> 2] = i118, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f93 = (HEAP32[tempDoublePtr >> 2] = i120, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f94 = (HEAP32[tempDoublePtr >> 2] = i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(Math_fround(Math_fround(f199 * f91) + f87) - Math_fround(Math_fround(f211 * f91) + Math_fround(Math_fround(f209 * f95) + Math_fround(f210 * f96))));
  f88 = Math_fround(Math_fround(Math_fround(f202 * f92) + f88) - Math_fround(Math_fround(f214 * f92) + Math_fround(Math_fround(f212 * f97) + Math_fround(f213 * f98))));
  f89 = Math_fround(Math_fround(Math_fround(f205 * f93) + f89) - Math_fround(Math_fround(f217 * f93) + Math_fround(Math_fround(f215 * f99) + Math_fround(f216 * f102))));
  f90 = Math_fround(Math_fround(Math_fround(f208 * f94) + f90) - Math_fround(Math_fround(f220 * f94) + Math_fround(Math_fround(f218 * f103) + Math_fround(f219 * f104))));
  i100 = (i116 & 1) << 1 | i115 & 1 | (i119 & 1) << 2 | (i121 & 1) << 3;
  L43 : do if ((i15 | 0) == 65535) i10 = 65535; else {
   i10 = i15;
   do {
    if (HEAP16[i427 + 4496 + (i10 * 12 | 0) + 2 >> 1] | 0) break L43;
    i120 = HEAP16[i427 + 4496 + (i10 * 12 | 0) + 4 >> 1] | 0;
    i10 = i120 & 65535;
   } while (i120 << 16 >> 16 != -1);
  } while (0);
  L48 : do if ((i16 | 0) == 65535) i11 = 65535; else {
   i11 = i16;
   do {
    if (HEAP16[i427 + 4496 + (i11 * 12 | 0) + 2 >> 1] | 0) break L48;
    i120 = HEAP16[i427 + 4496 + (i11 * 12 | 0) + 4 >> 1] | 0;
    i11 = i120 & 65535;
   } while (i120 << 16 >> 16 != -1);
  } while (0);
  L53 : do if ((i17 | 0) == 65535) i12 = 65535; else {
   i12 = i17;
   do {
    if (HEAP16[i427 + 4496 + (i12 * 12 | 0) + 2 >> 1] | 0) break L53;
    i120 = HEAP16[i427 + 4496 + (i12 * 12 | 0) + 4 >> 1] | 0;
    i12 = i120 & 65535;
   } while (i120 << 16 >> 16 != -1);
  } while (0);
  L58 : do if ((i18 | 0) == 65535) i14 = 65535; else {
   i14 = i18;
   do {
    if (HEAP16[i427 + 4496 + (i14 * 12 | 0) + 2 >> 1] | 0) break L58;
    i120 = HEAP16[i427 + 4496 + (i14 * 12 | 0) + 4 >> 1] | 0;
    i14 = i120 & 65535;
   } while (i120 << 16 >> 16 != -1);
  } while (0);
  L63 : do if (i115) i16 = 0; else if ((i10 | 0) == 65535) {
   i39 = 0;
   i44 = 65535;
   i10 = 65535;
   i16 = 1;
  } else {
   i16 = 1;
   i15 = i10;
   while (1) {
    if ((i16 | 0) != (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i39 = 0;
     i44 = i10;
     i10 = i15;
     break L63;
    }
    i120 = HEAP16[i427 + 4496 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i120 & 65535;
    if (i120 << 16 >> 16 == -1) {
     i39 = 0;
     i44 = i10;
     i10 = i15;
     i16 = 0;
     break;
    } else i16 = 0;
   }
  } while (0);
  L69 : do if (i116) i17 = 0; else {
   if ((i11 | 0) == 65535) {
    i33 = 0;
    i37 = 65535;
    i11 = 65535;
    i17 = 1;
    break;
   } else {
    i17 = 1;
    i15 = i11;
   }
   while (1) {
    if ((i17 | 0) != (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i33 = 0;
     i37 = i11;
     i11 = i15;
     break L69;
    }
    i120 = HEAP16[i427 + 4496 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i120 & 65535;
    if (i120 << 16 >> 16 == -1) {
     i33 = 0;
     i37 = i11;
     i11 = i15;
     i17 = 0;
     break;
    } else i17 = 0;
   }
  } while (0);
  L75 : do if (i119) i18 = 0; else {
   if ((i12 | 0) == 65535) {
    i22 = 0;
    i31 = 65535;
    i12 = 65535;
    i18 = 1;
    break;
   } else {
    i18 = 1;
    i15 = i12;
   }
   while (1) {
    if ((i18 | 0) != (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i22 = 0;
     i31 = i12;
     i12 = i15;
     break L75;
    }
    i120 = HEAP16[i427 + 4496 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i120 & 65535;
    if (i120 << 16 >> 16 == -1) {
     i22 = 0;
     i31 = i12;
     i12 = i15;
     i18 = 0;
     break;
    } else i18 = 0;
   }
  } while (0);
  L81 : do if (i121) i43 = 0; else {
   if ((i14 | 0) == 65535) {
    i29 = 0;
    i42 = 65535;
    i14 = 65535;
    i43 = 1;
    break;
   } else {
    i19 = 1;
    i15 = i14;
   }
   while (1) {
    if ((i19 | 0) != (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i29 = 0;
     i42 = i14;
     i14 = i15;
     i43 = i19;
     break L81;
    }
    i120 = HEAP16[i427 + 4496 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i120 & 65535;
    if (i120 << 16 >> 16 == -1) {
     i29 = 0;
     i42 = i14;
     i14 = i15;
     i43 = 0;
     break;
    } else i19 = 0;
   }
  } while (0);
  if (i115) i15 = 1; else {
   if ((i10 | 0) == 65535) i15 = 0; else i15 = i16 >>> 0 < (HEAPU16[i427 + 4496 + (i10 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i19 = i15 & 1;
  if (i116) i15 = 1; else {
   if ((i11 | 0) == 65535) i15 = 0; else i15 = i17 >>> 0 < (HEAPU16[i427 + 4496 + (i11 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i19 = (i15 & 1) << 1 | i19;
  if (i119) i15 = 1; else {
   if ((i12 | 0) == 65535) i15 = 0; else i15 = i18 >>> 0 < (HEAPU16[i427 + 4496 + (i12 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i35 = i19 | (i15 & 1) << 2;
  if (i121) i19 = 1; else {
   if ((i14 | 0) == 65535) i15 = 0; else i15 = i43 >>> 0 < (HEAPU16[i427 + 4496 + (i14 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i19 = i15 ^ 1;
  }
  i112 = f20 > Math_fround(-0.0);
  i111 = f21 > Math_fround(-0.0);
  i110 = f23 > Math_fround(-0.0);
  i109 = f24 > Math_fround(-0.0);
  i107 = i29;
  i106 = i42;
  i47 = i10;
  i108 = i43;
  i42 = 0;
  i15 = i100;
  i19 = i35 | (i19 & 1) << 3;
  i10 = i101;
  L111 : while (1) {
   i105 = i427 + 4496 + (i106 * 12 | 0) | 0;
   i35 = i22;
   i100 = i42;
   i43 = i19;
   while (1) {
    if ((i15 | 0) == 15) {
     i22 = i35;
     i29 = i107;
     i42 = i106;
     break L111;
    }
    i42 = i100 + 1 | 0;
    i101 = i10 + i412 | 0;
    i15 = (HEAPU16[i427 + 4496 + (i44 * 12 | 0) >> 1] | 0) + i39 | 0;
    i19 = (HEAPU16[i427 + 4496 + (i37 * 12 | 0) >> 1] | 0) + i33 | 0;
    i22 = (HEAPU16[i427 + 4496 + (i31 * 12 | 0) >> 1] | 0) + i35 | 0;
    i29 = (HEAPU16[i105 >> 1] | 0) + i107 | 0;
    i120 = i427 + 384 + (i15 << 6) + 16 | 0;
    f30 = Math_fround(HEAPF32[i120 >> 2]);
    f38 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f46 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i19 << 6) + 16 | 0;
    f32 = Math_fround(HEAPF32[i120 >> 2]);
    f40 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f48 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i22 << 6) + 16 | 0;
    f34 = Math_fround(HEAPF32[i120 >> 2]);
    f41 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f49 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i29 << 6) + 16 | 0;
    f36 = Math_fround(HEAPF32[i120 >> 2]);
    f45 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f50 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i15 << 6) + 32 | 0;
    f70 = Math_fround(HEAPF32[i120 >> 2]);
    f69 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f55 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i19 << 6) + 32 | 0;
    f68 = Math_fround(HEAPF32[i120 >> 2]);
    f67 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f56 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i22 << 6) + 32 | 0;
    f71 = Math_fround(HEAPF32[i120 >> 2]);
    f72 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f57 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    i120 = i427 + 384 + (i29 << 6) + 32 | 0;
    f73 = Math_fround(HEAPF32[i120 >> 2]);
    f74 = Math_fround(HEAPF32[i120 + 4 >> 2]);
    f58 = Math_fround(HEAPF32[i120 + 8 >> 2]);
    f51 = Math_fround(HEAPF32[i427 + 384 + (i15 << 6) + 12 >> 2]);
    f52 = Math_fround(HEAPF32[i427 + 384 + (i19 << 6) + 12 >> 2]);
    f53 = Math_fround(HEAPF32[i427 + 384 + (i22 << 6) + 12 >> 2]);
    f54 = Math_fround(HEAPF32[i427 + 384 + (i29 << 6) + 12 >> 2]);
    f55 = Math_fround(Math_fround(f95 * f70) + Math_fround(Math_fround(f96 * f69) + Math_fround(f91 * f55)));
    f56 = Math_fround(Math_fround(f97 * f68) + Math_fround(Math_fround(f98 * f67) + Math_fround(f92 * f56)));
    f57 = Math_fround(Math_fround(f99 * f71) + Math_fround(Math_fround(f102 * f72) + Math_fround(f93 * f57)));
    f58 = Math_fround(Math_fround(f103 * f73) + Math_fround(Math_fround(f104 * f74) + Math_fround(f94 * f58)));
    f74 = Math_fround(f30 - f342);
    f73 = Math_fround(f32 - f345);
    f72 = Math_fround(f34 - f348);
    f71 = Math_fround(f36 - f351);
    f67 = Math_fround(f38 - f343);
    f68 = Math_fround(f40 - f346);
    f69 = Math_fround(f41 - f349);
    f70 = Math_fround(f45 - f352);
    f63 = Math_fround(f46 - f344);
    f64 = Math_fround(f48 - f347);
    f65 = Math_fround(f49 - f350);
    f66 = Math_fround(f50 - f353);
    f30 = Math_fround(f30 - f354);
    f32 = Math_fround(f32 - f357);
    f34 = Math_fround(f34 - f360);
    f36 = Math_fround(f36 - f363);
    f38 = Math_fround(f38 - f355);
    f40 = Math_fround(f40 - f358);
    f41 = Math_fround(f41 - f361);
    f45 = Math_fround(f45 - f364);
    f46 = Math_fround(f46 - f356);
    f48 = Math_fround(f48 - f359);
    f49 = Math_fround(f49 - f362);
    f50 = Math_fround(f50 - f365);
    f59 = Math_fround(Math_fround(f91 * f67) - Math_fround(f96 * f63));
    f60 = Math_fround(Math_fround(f92 * f68) - Math_fround(f98 * f64));
    f61 = Math_fround(Math_fround(f93 * f69) - Math_fround(f102 * f65));
    f62 = Math_fround(Math_fround(f94 * f70) - Math_fround(f104 * f66));
    f63 = Math_fround(Math_fround(f95 * f63) - Math_fround(f91 * f74));
    f64 = Math_fround(Math_fround(f97 * f64) - Math_fround(f92 * f73));
    f65 = Math_fround(Math_fround(f99 * f65) - Math_fround(f93 * f72));
    f66 = Math_fround(Math_fround(f103 * f66) - Math_fround(f94 * f71));
    f67 = Math_fround(Math_fround(f96 * f74) - Math_fround(f95 * f67));
    f68 = Math_fround(Math_fround(f98 * f73) - Math_fround(f97 * f68));
    f69 = Math_fround(Math_fround(f102 * f72) - Math_fround(f99 * f69));
    f70 = Math_fround(Math_fround(f104 * f71) - Math_fround(f103 * f70));
    f71 = Math_fround(Math_fround(f277 * f67) + Math_fround(Math_fround(f273 * f63) + Math_fround(f269 * f59)));
    f72 = Math_fround(Math_fround(f278 * f68) + Math_fround(Math_fround(f274 * f64) + Math_fround(f270 * f60)));
    f73 = Math_fround(Math_fround(f279 * f69) + Math_fround(Math_fround(f275 * f65) + Math_fround(f271 * f61)));
    f74 = Math_fround(Math_fround(f280 * f70) + Math_fround(Math_fround(f276 * f66) + Math_fround(f272 * f62)));
    f75 = Math_fround(Math_fround(f289 * f67) + Math_fround(Math_fround(f285 * f63) + Math_fround(f281 * f59)));
    f76 = Math_fround(Math_fround(f290 * f68) + Math_fround(Math_fround(f286 * f64) + Math_fround(f282 * f60)));
    f77 = Math_fround(Math_fround(f291 * f69) + Math_fround(Math_fround(f287 * f65) + Math_fround(f283 * f61)));
    f78 = Math_fround(Math_fround(f292 * f70) + Math_fround(Math_fround(f288 * f66) + Math_fround(f284 * f62)));
    f79 = Math_fround(Math_fround(f301 * f67) + Math_fround(Math_fround(f297 * f63) + Math_fround(f293 * f59)));
    f80 = Math_fround(Math_fround(f302 * f68) + Math_fround(Math_fround(f298 * f64) + Math_fround(f294 * f60)));
    f81 = Math_fround(Math_fround(f303 * f69) + Math_fround(Math_fround(f299 * f65) + Math_fround(f295 * f61)));
    f82 = Math_fround(Math_fround(f304 * f70) + Math_fround(Math_fround(f300 * f66) + Math_fround(f296 * f62)));
    f28 = Math_fround(f257 + Math_fround(Math_fround(f67 * f79) + Math_fround(Math_fround(f63 * f75) + Math_fround(f59 * f71))));
    f27 = Math_fround(f258 + Math_fround(Math_fround(f68 * f80) + Math_fround(Math_fround(f64 * f76) + Math_fround(f60 * f72))));
    f26 = Math_fround(f259 + Math_fround(Math_fround(f69 * f81) + Math_fround(Math_fround(f65 * f77) + Math_fround(f61 * f73))));
    f25 = Math_fround(f260 + Math_fround(Math_fround(f70 * f82) + Math_fround(Math_fround(f66 * f78) + Math_fround(f62 * f74))));
    f24 = Math_fround(f87 + Math_fround(Math_fround(f223 * f67) + Math_fround(Math_fround(f222 * f63) + Math_fround(f221 * f59))));
    f23 = Math_fround(f88 + Math_fround(Math_fround(f226 * f68) + Math_fround(Math_fround(f225 * f64) + Math_fround(f224 * f60))));
    f21 = Math_fround(f89 + Math_fround(Math_fround(f229 * f69) + Math_fround(Math_fround(f228 * f65) + Math_fround(f227 * f61))));
    f20 = Math_fround(f90 + Math_fround(Math_fround(f232 * f70) + Math_fround(Math_fround(f231 * f66) + Math_fround(f230 * f62))));
    if (i411) {
     f440 = Math_fround(Math_fround(f91 * f38) - Math_fround(f96 * f46));
     f439 = Math_fround(Math_fround(f92 * f40) - Math_fround(f98 * f48));
     f438 = Math_fround(Math_fround(f93 * f41) - Math_fround(f102 * f49));
     f437 = Math_fround(Math_fround(f94 * f45) - Math_fround(f104 * f50));
     f436 = Math_fround(Math_fround(f95 * f46) - Math_fround(f91 * f30));
     f435 = Math_fround(Math_fround(f97 * f48) - Math_fround(f92 * f32));
     f434 = Math_fround(Math_fround(f99 * f49) - Math_fround(f93 * f34));
     f433 = Math_fround(Math_fround(f103 * f50) - Math_fround(f94 * f36));
     f432 = Math_fround(Math_fround(f96 * f30) - Math_fround(f95 * f38));
     f431 = Math_fround(Math_fround(f98 * f32) - Math_fround(f97 * f40));
     f430 = Math_fround(Math_fround(f102 * f34) - Math_fround(f99 * f41));
     f429 = Math_fround(Math_fround(f104 * f36) - Math_fround(f103 * f45));
     f30 = Math_fround(Math_fround(f313 * f432) + Math_fround(Math_fround(f309 * f436) + Math_fround(f305 * f440)));
     f32 = Math_fround(Math_fround(f314 * f431) + Math_fround(Math_fround(f310 * f435) + Math_fround(f306 * f439)));
     f34 = Math_fround(Math_fround(f315 * f430) + Math_fround(Math_fround(f311 * f434) + Math_fround(f307 * f438)));
     f36 = Math_fround(Math_fround(f316 * f429) + Math_fround(Math_fround(f312 * f433) + Math_fround(f308 * f437)));
     f38 = Math_fround(Math_fround(f325 * f432) + Math_fround(Math_fround(f321 * f436) + Math_fround(f317 * f440)));
     f40 = Math_fround(Math_fround(f326 * f431) + Math_fround(Math_fround(f322 * f435) + Math_fround(f318 * f439)));
     f41 = Math_fround(Math_fround(f327 * f430) + Math_fround(Math_fround(f323 * f434) + Math_fround(f319 * f438)));
     f45 = Math_fround(Math_fround(f328 * f429) + Math_fround(Math_fround(f324 * f433) + Math_fround(f320 * f437)));
     f46 = Math_fround(Math_fround(f337 * f432) + Math_fround(Math_fround(f333 * f436) + Math_fround(f329 * f440)));
     f48 = Math_fround(Math_fround(f338 * f431) + Math_fround(Math_fround(f334 * f435) + Math_fround(f330 * f439)));
     f49 = Math_fround(Math_fround(f339 * f430) + Math_fround(Math_fround(f335 * f434) + Math_fround(f331 * f438)));
     f50 = Math_fround(Math_fround(f340 * f429) + Math_fround(Math_fround(f336 * f433) + Math_fround(f332 * f437)));
     f28 = Math_fround(f28 + Math_fround(f261 + Math_fround(Math_fround(f432 * f46) + Math_fround(Math_fround(f436 * f38) + Math_fround(f440 * f30)))));
     f27 = Math_fround(f27 + Math_fround(f263 + Math_fround(Math_fround(f431 * f48) + Math_fround(Math_fround(f435 * f40) + Math_fround(f439 * f32)))));
     f26 = Math_fround(f26 + Math_fround(f265 + Math_fround(Math_fround(f430 * f49) + Math_fround(Math_fround(f434 * f41) + Math_fround(f438 * f34)))));
     f25 = Math_fround(f25 + Math_fround(f267 + Math_fround(Math_fround(f429 * f50) + Math_fround(Math_fround(f433 * f45) + Math_fround(f437 * f36)))));
     f24 = Math_fround(f24 - Math_fround(Math_fround(f235 * f432) + Math_fround(Math_fround(f234 * f436) + Math_fround(f233 * f440))));
     f23 = Math_fround(f23 - Math_fround(Math_fround(f238 * f431) + Math_fround(Math_fround(f237 * f435) + Math_fround(f236 * f439))));
     f21 = Math_fround(f21 - Math_fround(Math_fround(f241 * f430) + Math_fround(Math_fround(f240 * f434) + Math_fround(f239 * f438))));
     f20 = Math_fround(f20 - Math_fround(Math_fround(f244 * f429) + Math_fround(Math_fround(f243 * f433) + Math_fround(f242 * f437))));
     HEAPF32[i10 + 144 >> 2] = f440;
     HEAPF32[i10 + 148 >> 2] = f439;
     HEAPF32[i10 + 152 >> 2] = f438;
     HEAPF32[i10 + 156 >> 2] = f437;
     HEAPF32[i10 + 160 >> 2] = f436;
     HEAPF32[i10 + 164 >> 2] = f435;
     HEAPF32[i10 + 168 >> 2] = f434;
     HEAPF32[i10 + 172 >> 2] = f433;
     HEAPF32[i10 + 176 >> 2] = f432;
     HEAPF32[i10 + 180 >> 2] = f431;
     HEAPF32[i10 + 184 >> 2] = f430;
     HEAPF32[i10 + 188 >> 2] = f429;
     f32 = Math_fround(-f32);
     f34 = Math_fround(-f34);
     f36 = Math_fround(-f36);
     HEAPF32[i10 + 192 >> 2] = Math_fround(-f30);
     HEAPF32[i10 + 196 >> 2] = f32;
     HEAPF32[i10 + 200 >> 2] = f34;
     HEAPF32[i10 + 204 >> 2] = f36;
     f40 = Math_fround(-f40);
     f41 = Math_fround(-f41);
     f45 = Math_fround(-f45);
     HEAPF32[i10 + 208 >> 2] = Math_fround(-f38);
     HEAPF32[i10 + 212 >> 2] = f40;
     HEAPF32[i10 + 216 >> 2] = f41;
     HEAPF32[i10 + 220 >> 2] = f45;
     f48 = Math_fround(-f48);
     f49 = Math_fround(-f49);
     f50 = Math_fround(-f50);
     HEAPF32[i10 + 224 >> 2] = Math_fround(-f46);
     HEAPF32[i10 + 228 >> 2] = f48;
     HEAPF32[i10 + 232 >> 2] = f49;
     HEAPF32[i10 + 236 >> 2] = f50;
    }
    i117 = f28 > Math_fround(0.0);
    i118 = f27 > Math_fround(0.0);
    i120 = f26 > Math_fround(0.0);
    i441 = f25 > Math_fround(0.0);
    f46 = Math_fround(Math_fround(1.0) / f28);
    f48 = Math_fround(Math_fround(1.0) / f27);
    f49 = Math_fround(Math_fround(1.0) / f26);
    f50 = Math_fround(Math_fround(1.0) / f25);
    f46 = i117 ? f46 : Math_fround(0.0);
    f48 = i118 ? f48 : Math_fround(0.0);
    f49 = i120 ? f49 : Math_fround(0.0);
    f50 = i441 ? f50 : Math_fround(0.0);
    f440 = Math_fround(f51 - f406);
    f439 = Math_fround(f52 - f405);
    f438 = Math_fround(f53 - f404);
    f437 = Math_fround(f54 - f196);
    f433 = Math_fround(f341 * f440);
    f434 = Math_fround(f341 * f439);
    f435 = Math_fround(f341 * f438);
    f436 = Math_fround(f341 * f437);
    i441 = Math_fround(f440 * f426) < Math_fround(-f24) & (i112 & f24 < f424);
    i120 = Math_fround(f439 * f426) < Math_fround(-f23) & (i111 & f23 < f424);
    i118 = Math_fround(f438 * f426) < Math_fround(-f21) & (i110 & f21 < f424);
    i117 = Math_fround(f437 * f426) < Math_fround(-f20) & (i109 & f20 < f424);
    f433 = Math_fround(-Math_fround((f407 > f433 ? f407 : f433) * f46));
    f434 = Math_fround(-Math_fround((f408 > f434 ? f408 : f434) * f48));
    f435 = Math_fround(-Math_fround((f409 > f435 ? f409 : f435) * f49));
    f436 = Math_fround(-Math_fround((f410 > f436 ? f410 : f436) * f50));
    f437 = i441 ? Math_fround(0.0) : f433;
    f438 = i120 ? Math_fround(0.0) : f434;
    f439 = i118 ? Math_fround(0.0) : f435;
    f440 = i117 ? Math_fround(0.0) : f436;
    f432 = Math_fround(Math_fround(f24 * f83) * f46);
    f429 = Math_fround(Math_fround(f23 * f84) * f48);
    f430 = Math_fround(Math_fround(f21 * f85) * f49);
    f431 = Math_fround(Math_fround(f20 * f86) * f50);
    HEAPF32[i10 >> 2] = f59;
    HEAPF32[i10 + 4 >> 2] = f60;
    HEAPF32[i10 + 8 >> 2] = f61;
    HEAPF32[i10 + 12 >> 2] = f62;
    HEAPF32[i10 + 16 >> 2] = f63;
    HEAPF32[i10 + 20 >> 2] = f64;
    HEAPF32[i10 + 24 >> 2] = f65;
    HEAPF32[i10 + 28 >> 2] = f66;
    HEAPF32[i10 + 32 >> 2] = f67;
    HEAPF32[i10 + 36 >> 2] = f68;
    HEAPF32[i10 + 40 >> 2] = f69;
    HEAPF32[i10 + 44 >> 2] = f70;
    HEAPF32[i10 + 96 >> 2] = f46;
    HEAPF32[i10 + 100 >> 2] = f48;
    HEAPF32[i10 + 104 >> 2] = f49;
    HEAPF32[i10 + 108 >> 2] = f50;
    f434 = Math_fround(f56 + (i120 ? f429 : f434));
    f435 = Math_fround(f57 + (i118 ? f430 : f435));
    f436 = Math_fround(f58 + (i117 ? f431 : f436));
    HEAPF32[i10 + 128 >> 2] = Math_fround(f55 + (i441 ? f432 : f433));
    HEAPF32[i10 + 132 >> 2] = f434;
    HEAPF32[i10 + 136 >> 2] = f435;
    HEAPF32[i10 + 140 >> 2] = f436;
    i441 = f437 <= Math_fround(0.0);
    i117 = f438 <= Math_fround(0.0);
    i118 = f439 <= Math_fround(0.0);
    i120 = f440 <= Math_fround(0.0);
    f437 = i441 ? Math_fround(0.0) : f437;
    f438 = i117 ? Math_fround(0.0) : f438;
    f439 = i118 ? Math_fround(0.0) : f439;
    f440 = i120 ? Math_fround(0.0) : f440;
    HEAPF32[i10 + 112 >> 2] = f437;
    HEAPF32[i10 + 116 >> 2] = f438;
    HEAPF32[i10 + 120 >> 2] = f439;
    HEAPF32[i10 + 124 >> 2] = f440;
    HEAPF32[i10 + 48 >> 2] = f71;
    HEAPF32[i10 + 52 >> 2] = f72;
    HEAPF32[i10 + 56 >> 2] = f73;
    HEAPF32[i10 + 60 >> 2] = f74;
    HEAPF32[i10 + 64 >> 2] = f75;
    HEAPF32[i10 + 68 >> 2] = f76;
    HEAPF32[i10 + 72 >> 2] = f77;
    HEAPF32[i10 + 76 >> 2] = f78;
    HEAPF32[i10 + 80 >> 2] = f79;
    HEAPF32[i10 + 84 >> 2] = f80;
    HEAPF32[i10 + 88 >> 2] = f81;
    HEAPF32[i10 + 92 >> 2] = f82;
    if (i422) {
     i118 = HEAP32[i427 + 384 + (i19 << 6) + 28 >> 2] | 0;
     i120 = HEAP32[i427 + 384 + (i22 << 6) + 28 >> 2] | 0;
     i441 = HEAP32[i427 + 384 + (i29 << 6) + 28 >> 2] | 0;
     HEAP32[i113 + (i100 << 4) >> 2] = HEAP32[i427 + 384 + (i15 << 6) + 28 >> 2];
     HEAP32[i113 + (i100 << 4) + 4 >> 2] = i118;
     HEAP32[i113 + (i100 << 4) + 8 >> 2] = i120;
     HEAP32[i113 + (i100 << 4) + 12 >> 2] = i441;
    }
    if (!(i43 & 1)) {
     i10 = i16 + 1 | 0;
     do if ((i47 | 0) == 65535) {
      i19 = 0;
      i15 = 65535;
     } else {
      i15 = i47;
      while (1) {
       if ((i10 | 0) != (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0)) break;
       i441 = HEAP16[i427 + 4496 + (i15 * 12 | 0) + 4 >> 1] | 0;
       i15 = i441 & 65535;
       if (i441 << 16 >> 16 == -1) {
        i10 = 0;
        break;
       } else i10 = 0;
      }
      if ((i15 | 0) == 65535) {
       i19 = 0;
       i15 = 65535;
       break;
      }
      i19 = i10 >>> 0 < (HEAPU16[i427 + 4496 + (i15 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i39 = i16;
     i44 = i47;
     i16 = i10;
     i29 = i19 & 1 ^ 1 | i43;
    } else {
     i15 = i47;
     i29 = i43;
    }
    if (!(i43 & 2)) {
     i10 = i17 + 1 | 0;
     do if ((i11 | 0) == 65535) {
      i22 = 0;
      i19 = 65535;
     } else {
      i19 = i11;
      while (1) {
       if ((i10 | 0) != (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0)) break;
       i441 = HEAP16[i427 + 4496 + (i19 * 12 | 0) + 4 >> 1] | 0;
       i19 = i441 & 65535;
       if (i441 << 16 >> 16 == -1) {
        i10 = 0;
        break;
       } else i10 = 0;
      }
      if ((i19 | 0) == 65535) {
       i22 = 0;
       i19 = 65535;
       break;
      }
      i22 = i10 >>> 0 < (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i33 = i17;
     i37 = i11;
     i17 = i10;
     i11 = i19;
     i29 = (i22 & 1) << 1 ^ 2 | i29;
    }
    if (!(i43 & 4)) {
     i10 = i18 + 1 | 0;
     do if ((i12 | 0) == 65535) {
      i22 = 0;
      i19 = 65535;
     } else {
      i19 = i12;
      while (1) {
       if ((i10 | 0) != (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0)) break;
       i441 = HEAP16[i427 + 4496 + (i19 * 12 | 0) + 4 >> 1] | 0;
       i19 = i441 & 65535;
       if (i441 << 16 >> 16 == -1) {
        i10 = 0;
        break;
       } else i10 = 0;
      }
      if ((i19 | 0) == 65535) {
       i22 = 0;
       i19 = 65535;
       break;
      }
      i22 = i10 >>> 0 < (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i35 = i18;
     i31 = i12;
     i18 = i10;
     i12 = i19;
     i29 = (i22 & 1) << 2 ^ 4 | i29;
    }
    if (!(i43 & 8)) {
     i10 = i101;
     i47 = i15;
     i22 = i35;
     break;
    } else {
     i441 = i43;
     i47 = i15;
     i100 = i42;
     i43 = i29;
     i10 = i101;
     i15 = i441;
    }
   }
   i15 = i108 + 1 | 0;
   do if ((i14 | 0) == 65535) {
    i35 = 0;
    i19 = 65535;
   } else {
    i19 = i14;
    while (1) {
     if ((i15 | 0) != (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0)) break;
     i441 = HEAP16[i427 + 4496 + (i19 * 12 | 0) + 4 >> 1] | 0;
     i19 = i441 & 65535;
     if (i441 << 16 >> 16 == -1) {
      i15 = 0;
      break;
     } else i15 = 0;
    }
    if ((i19 | 0) == 65535) {
     i35 = 0;
     i19 = 65535;
     break;
    }
    i35 = i15 >>> 0 < (HEAPU16[i427 + 4496 + (i19 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   } while (0);
   i106 = i14;
   i107 = i108;
   i108 = i15;
   i14 = i19;
   i15 = i43;
   i19 = (i35 & 1) << 3 ^ 8 | i29;
  }
  i120 = i422 ? i10 + i114 | 0 : i10;
  i114 = HEAP32[i427 + 384 + (i122 << 6) + 44 >> 2] | 0;
  i117 = HEAP32[i427 + 384 + (i123 << 6) + 44 >> 2] | 0;
  i118 = HEAP32[i427 + 384 + (i124 << 6) + 44 >> 2] | 0;
  i441 = HEAP32[i427 + 384 + (i125 << 6) + 44 >> 2] | 0;
  i111 = HEAP32[i427 + 384 + (i123 << 6) + 56 >> 2] | 0;
  i112 = HEAP32[i427 + 384 + (i124 << 6) + 56 >> 2] | 0;
  i113 = HEAP32[i427 + 384 + (i125 << 6) + 56 >> 2] | 0;
  HEAP32[i13 + 48 >> 2] = HEAP32[i427 + 384 + (i122 << 6) + 56 >> 2];
  HEAP32[i13 + 52 >> 2] = i111;
  HEAP32[i13 + 56 >> 2] = i112;
  HEAP32[i13 + 60 >> 2] = i113;
  HEAP32[i13 + 32 >> 2] = i114;
  HEAP32[i13 + 36 >> 2] = i117;
  HEAP32[i13 + 40 >> 2] = i118;
  HEAP32[i13 + 44 >> 2] = i441;
  if (i115) i118 = 0; else i118 = HEAP32[i427 + 384 + (i122 << 6) + 52 >> 2] & 1 | 0 ? 0 : HEAPU16[i427 + 5264 + (i1 * 96 | 0) + 16 >> 1] | 0;
  if (i116) i117 = 0; else i117 = HEAP32[i427 + 384 + (i123 << 6) + 52 >> 2] & 1 | 0 ? 0 : HEAPU16[i427 + 5264 + (i2 * 96 | 0) + 16 >> 1] | 0;
  if (i119) i116 = 0; else i116 = HEAP32[i427 + 384 + (i124 << 6) + 52 >> 2] & 1 | 0 ? 0 : HEAPU16[i427 + 5264 + (i3 * 96 | 0) + 16 >> 1] | 0;
  if (i121) i115 = 0; else i115 = HEAP32[i427 + 384 + (i125 << 6) + 52 >> 2] & 1 | 0 ? 0 : HEAPU16[i427 + 5264 + (i4 * 96 | 0) + 16 >> 1] | 0;
  i119 = i116 >>> 0 < i115 >>> 0 ? i115 : i116;
  i119 = i117 >>> 0 < i119 >>> 0 ? i119 : i117;
  i119 = i118 >>> 0 < i119 >>> 0 ? i119 : i118;
  i10 = i13 + 2 | 0;
  HEAP8[i10 >> 0] = i119 << 1;
  HEAP8[i13 + 12 >> 0] = i118 << 1;
  HEAP8[i13 + 13 >> 0] = i117 << 1;
  HEAP8[i13 + 14 >> 0] = i116 << 1;
  HEAP8[i13 + 15 >> 0] = i115 << 1;
  HEAP8[i13 >> 0] = i182;
  if (!i119) i13 = i120; else {
   f52 = Math_fround(-f95);
   f53 = Math_fround(-f97);
   f54 = Math_fround(-f99);
   f51 = Math_fround(-f103);
   i111 = (f95 > f52 ? f95 : f52) < Math_fround(.707106769);
   i110 = (f97 > f53 ? f97 : f53) < Math_fround(.707106769);
   i109 = (f99 > f54 ? f99 : f54) < Math_fround(.707106769);
   i114 = (f103 > f51 ? f103 : f51) < Math_fround(.707106769);
   f51 = Math_fround(-f96);
   f54 = Math_fround(-f98);
   f53 = Math_fround(-f102);
   f52 = Math_fround(-f104);
   f51 = i111 ? Math_fround(0.0) : f51;
   f54 = i110 ? Math_fround(0.0) : f54;
   f53 = i109 ? Math_fround(0.0) : f53;
   f52 = i114 ? Math_fround(0.0) : f52;
   f50 = Math_fround(-f91);
   f49 = Math_fround(-f92);
   f48 = Math_fround(-f93);
   f46 = Math_fround(-f94);
   f30 = i111 ? f96 : Math_fround(0.0);
   f32 = i110 ? f98 : Math_fround(0.0);
   f34 = i109 ? f102 : Math_fround(0.0);
   f36 = i114 ? f104 : Math_fround(0.0);
   f20 = Math_fround(f245 - Math_fround(f95 * f87));
   f21 = Math_fround(f246 - Math_fround(f97 * f88));
   f23 = Math_fround(f247 - Math_fround(f99 * f89));
   f24 = Math_fround(f248 - Math_fround(f103 * f90));
   f25 = Math_fround(f249 - Math_fround(f96 * f87));
   f26 = Math_fround(f250 - Math_fround(f98 * f88));
   f27 = Math_fround(f251 - Math_fround(f102 * f89));
   f28 = Math_fround(f252 - Math_fround(f104 * f90));
   f38 = Math_fround(f253 - Math_fround(f91 * f87));
   f40 = Math_fround(f254 - Math_fround(f92 * f88));
   f41 = Math_fround(f255 - Math_fround(f93 * f89));
   f45 = Math_fround(f256 - Math_fround(f94 * f90));
   i105 = Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f25 * f25) + Math_fround(f38 * f38))) > Math_fround(.100000001);
   i113 = Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f26 * f26) + Math_fround(f40 * f40))) > Math_fround(.100000001);
   i112 = Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f27 * f27) + Math_fround(f41 * f41))) > Math_fround(.100000001);
   i43 = Math_fround(Math_fround(f24 * f24) + Math_fround(Math_fround(f28 * f28) + Math_fround(f45 * f45))) > Math_fround(.100000001);
   f51 = i105 ? f20 : f51;
   f54 = i113 ? f21 : f54;
   f53 = i112 ? f23 : f53;
   f52 = i43 ? f24 : f52;
   f50 = i105 ? f25 : i111 ? f50 : f95;
   f49 = i113 ? f26 : i110 ? f49 : f97;
   f48 = i112 ? f27 : i109 ? f48 : f99;
   f46 = i43 ? f28 : i114 ? f46 : f103;
   f30 = i105 ? f38 : f30;
   f32 = i113 ? f40 : f32;
   f34 = i112 ? f41 : f34;
   f36 = i43 ? f45 : f36;
   f45 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f30 * f30) + Math_fround(Math_fround(f50 * f50) + Math_fround(f51 * f51))))));
   f41 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f49 * f49) + Math_fround(f54 * f54))))));
   f40 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f48 * f48) + Math_fround(f53 * f53))))));
   f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f36 * f36) + Math_fround(Math_fround(f46 * f46) + Math_fround(f52 * f52))))));
   f51 = Math_fround(f51 * f45);
   f54 = Math_fround(f54 * f41);
   f53 = Math_fround(f53 * f40);
   f52 = Math_fround(f52 * f38);
   f50 = Math_fround(f50 * f45);
   f49 = Math_fround(f49 * f41);
   f48 = Math_fround(f48 * f40);
   f46 = Math_fround(f46 * f38);
   f45 = Math_fround(f30 * f45);
   f41 = Math_fround(f32 * f41);
   f40 = Math_fround(f34 * f40);
   f38 = Math_fround(f36 * f38);
   f36 = Math_fround(Math_fround(f96 * f45) - Math_fround(f91 * f50));
   f34 = Math_fround(Math_fround(f98 * f41) - Math_fround(f92 * f49));
   f32 = Math_fround(Math_fround(f102 * f40) - Math_fround(f93 * f48));
   f30 = Math_fround(Math_fround(f104 * f38) - Math_fround(f94 * f46));
   f28 = Math_fround(Math_fround(f91 * f51) - Math_fround(f95 * f45));
   f27 = Math_fround(Math_fround(f92 * f54) - Math_fround(f97 * f41));
   f26 = Math_fround(Math_fround(f93 * f53) - Math_fround(f99 * f40));
   f25 = Math_fround(Math_fround(f94 * f52) - Math_fround(f103 * f38));
   f24 = Math_fround(Math_fround(f95 * f50) - Math_fround(f96 * f51));
   f23 = Math_fround(Math_fround(f97 * f49) - Math_fround(f98 * f54));
   f21 = Math_fround(Math_fround(f99 * f48) - Math_fround(f102 * f53));
   f20 = Math_fround(Math_fround(f103 * f46) - Math_fround(f104 * f52));
   i43 = (HEAP32[(HEAP32[i425 >> 2] | 0) + 40 >> 2] | 0) + (i6 * 96 | 0) | 0;
   i112 = (HEAP32[(HEAP32[i420 >> 2] | 0) + 40 >> 2] | 0) + (i7 * 96 | 0) | 0;
   i113 = (HEAP32[(HEAP32[i415 >> 2] | 0) + 40 >> 2] | 0) + (i8 * 96 | 0) | 0;
   i105 = (HEAP32[(HEAP32[i417 >> 2] | 0) + 40 >> 2] | 0) + (i9 * 96 | 0) | 0;
   HEAP32[i120 >> 2] = HEAP32[i423 >> 2];
   HEAP32[i120 + 4 >> 2] = HEAP32[i423 + 4 >> 2];
   HEAP32[i120 + 8 >> 2] = HEAP32[i423 + 8 >> 2];
   HEAP32[i120 + 12 >> 2] = HEAP32[i423 + 12 >> 2];
   HEAP32[i120 + 16 >> 2] = i43;
   HEAP32[i120 + 20 >> 2] = i112;
   HEAP32[i120 + 24 >> 2] = i113;
   HEAP32[i120 + 28 >> 2] = i105;
   HEAPF32[i120 + 32 >> 2] = f51;
   HEAPF32[i120 + 36 >> 2] = f54;
   HEAPF32[i120 + 40 >> 2] = f53;
   HEAPF32[i120 + 44 >> 2] = f52;
   HEAPF32[i120 + 64 >> 2] = f50;
   HEAPF32[i120 + 68 >> 2] = f49;
   HEAPF32[i120 + 72 >> 2] = f48;
   HEAPF32[i120 + 76 >> 2] = f46;
   HEAPF32[i120 + 96 >> 2] = f45;
   HEAPF32[i120 + 100 >> 2] = f41;
   HEAPF32[i120 + 104 >> 2] = f40;
   HEAPF32[i120 + 108 >> 2] = f38;
   HEAPF32[i120 + 48 >> 2] = f36;
   HEAPF32[i120 + 52 >> 2] = f34;
   HEAPF32[i120 + 56 >> 2] = f32;
   HEAPF32[i120 + 60 >> 2] = f30;
   HEAPF32[i120 + 80 >> 2] = f28;
   HEAPF32[i120 + 84 >> 2] = f27;
   HEAPF32[i120 + 88 >> 2] = f26;
   HEAPF32[i120 + 92 >> 2] = f25;
   HEAPF32[i120 + 112 >> 2] = f24;
   HEAPF32[i120 + 116 >> 2] = f23;
   HEAPF32[i120 + 120 >> 2] = f21;
   HEAPF32[i120 + 124 >> 2] = f20;
   i105 = HEAPU8[i10 >> 0] | 0;
   i113 = i105 << 4;
   i112 = i113 + 128 | 0;
   i43 = i120 + i112 | 0;
   _memset(i120 + 128 | 0, 0, i113 | 0) | 0;
   i10 = i120 + ((Math_imul(HEAPU8[i10 >> 0] | 0, i413) | 0) + i112) | 0;
   i112 = i427 + 384 + (i122 << 6) + 32 | 0;
   i113 = i112 + 4 | 0;
   i114 = i112 + 8 | 0;
   i109 = i427 + 384 + (i123 << 6) + 32 | 0;
   i110 = i109 + 4 | 0;
   i111 = i109 + 8 | 0;
   i106 = i427 + 384 + (i124 << 6) + 32 | 0;
   i107 = i106 + 4 | 0;
   i108 = i106 + 8 | 0;
   i47 = i427 + 384 + (i125 << 6) + 32 | 0;
   i100 = i47 + 4 | 0;
   i101 = i47 + 8 | 0;
   i441 = i116 >>> 0 > i115 >>> 0 ? i116 : i115;
   i441 = i441 >>> 0 > i117 >>> 0 ? i441 : i117;
   i105 = (Math_imul(i195, i441 >>> 0 > i118 >>> 0 ? i441 : i118) | 0) + (i105 << 4) | 0;
   if (i411) {
    i17 = 1065353216;
    i18 = 1065353216;
    i19 = 1065353216;
    i35 = 1065353216;
    f104 = f54;
    f103 = f53;
    f102 = f52;
    i12 = 0;
    i13 = 0;
    i14 = 0;
    i15 = 0;
    i16 = 0;
    i11 = i43;
    while (1) {
     i441 = i16 >>> 0 < i118 >>> 0;
     i12 = i441 ? i16 : i12;
     i125 = i16 >>> 0 < i117 >>> 0;
     i13 = i125 ? i16 : i13;
     i124 = i16 >>> 0 < i116 >>> 0;
     i14 = i124 ? i16 : i14;
     i123 = i16 >>> 0 < i115 >>> 0;
     i15 = i123 ? i16 : i15;
     i17 = i441 ? i17 : 0;
     i18 = i125 ? i18 : 0;
     i19 = i124 ? i19 : 0;
     i35 = i123 ? i35 : 0;
     f60 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f51 = Math_fround(f51 * f60);
     f85 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f104 = Math_fround(f104 * f85);
     f86 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f103 = Math_fround(f103 * f86);
     f87 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f102 = Math_fround(f102 * f87);
     f50 = Math_fround(f50 * f60);
     f49 = Math_fround(f49 * f85);
     f48 = Math_fround(f48 * f86);
     f46 = Math_fround(f46 * f87);
     f45 = Math_fround(f45 * f60);
     f41 = Math_fround(f41 * f85);
     f40 = Math_fround(f40 * f86);
     f38 = Math_fround(f38 * f87);
     f36 = Math_fround(f36 * f60);
     f34 = Math_fround(f34 * f85);
     f32 = Math_fround(f32 * f86);
     f30 = Math_fround(f30 * f87);
     f28 = Math_fround(f28 * f60);
     f27 = Math_fround(f27 * f85);
     f26 = Math_fround(f26 * f86);
     f25 = Math_fround(f25 * f87);
     f24 = Math_fround(f24 * f60);
     f23 = Math_fround(f23 * f85);
     f21 = Math_fround(f21 * f86);
     f20 = Math_fround(f20 * f87);
     f66 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) >> 2]);
     f64 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) + 4 >> 2]);
     f65 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) + 8 >> 2]);
     f69 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) >> 2]);
     f67 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) + 4 >> 2]);
     f68 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) + 8 >> 2]);
     f72 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) >> 2]);
     f70 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) + 4 >> 2]);
     f71 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) + 8 >> 2]);
     f88 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) >> 2]);
     f89 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) + 4 >> 2]);
     f90 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) + 8 >> 2]);
     f63 = Math_fround(Math_fround(Math_fround(f366 * f66) + Math_fround(f367 * f64)) + Math_fround(f368 * f65));
     f61 = Math_fround(Math_fround(Math_fround(f366 * f63) + Math_fround(Math_fround(f183 * f66) + Math_fround(f369 * Math_fround(Math_fround(f367 * f65) - Math_fround(f368 * f64))))) * Math_fround(2.0));
     f62 = Math_fround(Math_fround(Math_fround(f367 * f63) + Math_fround(Math_fround(f183 * f64) + Math_fround(f369 * Math_fround(Math_fround(f368 * f66) - Math_fround(f366 * f65))))) * Math_fround(2.0));
     f63 = Math_fround(Math_fround(Math_fround(Math_fround(f183 * f65) + Math_fround(f369 * Math_fround(Math_fround(f366 * f64) - Math_fround(f367 * f66)))) + Math_fround(f368 * f63)) * Math_fround(2.0));
     f66 = Math_fround(Math_fround(Math_fround(f370 * f69) + Math_fround(f371 * f67)) + Math_fround(f372 * f68));
     f64 = Math_fround(Math_fround(Math_fround(f370 * f66) + Math_fround(Math_fround(f184 * f69) + Math_fround(f373 * Math_fround(Math_fround(f371 * f68) - Math_fround(f372 * f67))))) * Math_fround(2.0));
     f65 = Math_fround(Math_fround(Math_fround(f371 * f66) + Math_fround(Math_fround(f184 * f67) + Math_fround(f373 * Math_fround(Math_fround(f372 * f69) - Math_fround(f370 * f68))))) * Math_fround(2.0));
     f66 = Math_fround(Math_fround(Math_fround(Math_fround(f184 * f68) + Math_fround(f373 * Math_fround(Math_fround(f370 * f67) - Math_fround(f371 * f69)))) + Math_fround(f372 * f66)) * Math_fround(2.0));
     f69 = Math_fround(Math_fround(Math_fround(f374 * f72) + Math_fround(f375 * f70)) + Math_fround(f376 * f71));
     f67 = Math_fround(Math_fround(Math_fround(f374 * f69) + Math_fround(Math_fround(f185 * f72) + Math_fround(f377 * Math_fround(Math_fround(f375 * f71) - Math_fround(f376 * f70))))) * Math_fround(2.0));
     f68 = Math_fround(Math_fround(Math_fround(f375 * f69) + Math_fround(Math_fround(f185 * f70) + Math_fround(f377 * Math_fround(Math_fround(f376 * f72) - Math_fround(f374 * f71))))) * Math_fround(2.0));
     f69 = Math_fround(Math_fround(Math_fround(Math_fround(f185 * f71) + Math_fround(f377 * Math_fround(Math_fround(f374 * f70) - Math_fround(f375 * f72)))) + Math_fround(f376 * f69)) * Math_fround(2.0));
     f72 = Math_fround(Math_fround(Math_fround(f378 * f88) + Math_fround(f379 * f89)) + Math_fround(f380 * f90));
     f70 = Math_fround(Math_fround(Math_fround(f378 * f72) + Math_fround(Math_fround(f186 * f88) + Math_fround(f381 * Math_fround(Math_fround(f379 * f90) - Math_fround(f380 * f89))))) * Math_fround(2.0));
     f71 = Math_fround(Math_fround(Math_fround(f379 * f72) + Math_fround(Math_fround(f186 * f89) + Math_fround(f381 * Math_fround(Math_fround(f380 * f88) - Math_fround(f378 * f90))))) * Math_fround(2.0));
     f72 = Math_fround(Math_fround(Math_fround(Math_fround(f186 * f90) + Math_fround(f381 * Math_fround(Math_fround(f378 * f89) - Math_fround(f379 * f88)))) + Math_fround(f380 * f72)) * Math_fround(2.0));
     f88 = Math_fround(f342 + f61);
     f89 = Math_fround(f345 + f64);
     f90 = Math_fround(f348 + f67);
     f91 = Math_fround(f351 + f70);
     f92 = Math_fround(f343 + f62);
     f93 = Math_fround(f346 + f65);
     f94 = Math_fround(f349 + f68);
     f95 = Math_fround(f352 + f71);
     f96 = Math_fround(f344 + f63);
     f97 = Math_fround(f347 + f66);
     f98 = Math_fround(f350 + f69);
     f99 = Math_fround(f353 + f72);
     f78 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) >> 2]);
     f76 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) + 4 >> 2]);
     f77 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) + 8 >> 2]);
     f81 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) >> 2]);
     f79 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) + 4 >> 2]);
     f80 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) + 8 >> 2]);
     f84 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) >> 2]);
     f82 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) + 4 >> 2]);
     f83 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) + 8 >> 2]);
     f457 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) >> 2]);
     f456 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) + 4 >> 2]);
     f455 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) + 8 >> 2]);
     f75 = Math_fround(Math_fround(Math_fround(f382 * f78) + Math_fround(f383 * f76)) + Math_fround(f384 * f77));
     f73 = Math_fround(Math_fround(Math_fround(f382 * f75) + Math_fround(Math_fround(f187 * f78) + Math_fround(f385 * Math_fround(Math_fround(f383 * f77) - Math_fround(f384 * f76))))) * Math_fround(2.0));
     f74 = Math_fround(Math_fround(Math_fround(f383 * f75) + Math_fround(Math_fround(f187 * f76) + Math_fround(f385 * Math_fround(Math_fround(f384 * f78) - Math_fround(f382 * f77))))) * Math_fround(2.0));
     f75 = Math_fround(Math_fround(Math_fround(Math_fround(f187 * f77) + Math_fround(f385 * Math_fround(Math_fround(f382 * f76) - Math_fround(f383 * f78)))) + Math_fround(f384 * f75)) * Math_fround(2.0));
     f78 = Math_fround(Math_fround(Math_fround(f386 * f81) + Math_fround(f387 * f79)) + Math_fround(f388 * f80));
     f76 = Math_fround(Math_fround(Math_fround(f386 * f78) + Math_fround(Math_fround(f188 * f81) + Math_fround(f389 * Math_fround(Math_fround(f387 * f80) - Math_fround(f388 * f79))))) * Math_fround(2.0));
     f77 = Math_fround(Math_fround(Math_fround(f387 * f78) + Math_fround(Math_fround(f188 * f79) + Math_fround(f389 * Math_fround(Math_fround(f388 * f81) - Math_fround(f386 * f80))))) * Math_fround(2.0));
     f78 = Math_fround(Math_fround(Math_fround(Math_fround(f188 * f80) + Math_fround(f389 * Math_fround(Math_fround(f386 * f79) - Math_fround(f387 * f81)))) + Math_fround(f388 * f78)) * Math_fround(2.0));
     f81 = Math_fround(Math_fround(Math_fround(f390 * f84) + Math_fround(f391 * f82)) + Math_fround(f392 * f83));
     f79 = Math_fround(Math_fround(Math_fround(f390 * f81) + Math_fround(Math_fround(f189 * f84) + Math_fround(f393 * Math_fround(Math_fround(f391 * f83) - Math_fround(f392 * f82))))) * Math_fround(2.0));
     f80 = Math_fround(Math_fround(Math_fround(f391 * f81) + Math_fround(Math_fround(f189 * f82) + Math_fround(f393 * Math_fround(Math_fround(f392 * f84) - Math_fround(f390 * f83))))) * Math_fround(2.0));
     f81 = Math_fround(Math_fround(Math_fround(Math_fround(f189 * f83) + Math_fround(f393 * Math_fround(Math_fround(f390 * f82) - Math_fround(f391 * f84)))) + Math_fround(f392 * f81)) * Math_fround(2.0));
     f84 = Math_fround(Math_fround(Math_fround(f394 * f457) + Math_fround(f395 * f456)) + Math_fround(f396 * f455));
     f82 = Math_fround(Math_fround(Math_fround(f394 * f84) + Math_fround(Math_fround(f190 * f457) + Math_fround(f397 * Math_fround(Math_fround(f395 * f455) - Math_fround(f396 * f456))))) * Math_fround(2.0));
     f83 = Math_fround(Math_fround(Math_fround(f395 * f84) + Math_fround(Math_fround(f190 * f456) + Math_fround(f397 * Math_fround(Math_fround(f396 * f457) - Math_fround(f394 * f455))))) * Math_fround(2.0));
     f84 = Math_fround(Math_fround(Math_fround(Math_fround(f190 * f455) + Math_fround(f397 * Math_fround(Math_fround(f394 * f456) - Math_fround(f395 * f457)))) + Math_fround(f396 * f84)) * Math_fround(2.0));
     f88 = Math_fround(f88 - Math_fround(f354 + f73));
     f89 = Math_fround(f89 - Math_fround(f357 + f76));
     f90 = Math_fround(f90 - Math_fround(f360 + f79));
     f91 = Math_fround(f91 - Math_fround(f363 + f82));
     f92 = Math_fround(f92 - Math_fround(f355 + f74));
     f93 = Math_fround(f93 - Math_fround(f358 + f77));
     f94 = Math_fround(f94 - Math_fround(f361 + f80));
     f95 = Math_fround(f95 - Math_fround(f364 + f83));
     f96 = Math_fround(f96 - Math_fround(f356 + f75));
     f97 = Math_fround(f97 - Math_fround(f359 + f78));
     f98 = Math_fround(f98 - Math_fround(f362 + f81));
     f99 = Math_fround(f99 - Math_fround(f365 + f84));
     f457 = Math_fround(Math_fround(f45 * f62) - Math_fround(f50 * f63));
     f456 = Math_fround(Math_fround(f41 * f65) - Math_fround(f49 * f66));
     f455 = Math_fround(Math_fround(f40 * f68) - Math_fround(f48 * f69));
     f454 = Math_fround(Math_fround(f38 * f71) - Math_fround(f46 * f72));
     f453 = Math_fround(Math_fround(f51 * f63) - Math_fround(f45 * f61));
     f452 = Math_fround(Math_fround(f104 * f66) - Math_fround(f41 * f64));
     f451 = Math_fround(Math_fround(f103 * f69) - Math_fround(f40 * f67));
     f450 = Math_fround(Math_fround(f102 * f72) - Math_fround(f38 * f70));
     f449 = Math_fround(Math_fround(f50 * f61) - Math_fround(f51 * f62));
     f448 = Math_fround(Math_fround(f49 * f64) - Math_fround(f104 * f65));
     f447 = Math_fround(Math_fround(f48 * f67) - Math_fround(f103 * f68));
     f446 = Math_fround(Math_fround(f46 * f70) - Math_fround(f102 * f71));
     f445 = Math_fround(Math_fround(f277 * f449) + Math_fround(Math_fround(f273 * f453) + Math_fround(f269 * f457)));
     f444 = Math_fround(Math_fround(f278 * f448) + Math_fround(Math_fround(f274 * f452) + Math_fround(f270 * f456)));
     f443 = Math_fround(Math_fround(f279 * f447) + Math_fround(Math_fround(f275 * f451) + Math_fround(f271 * f455)));
     f442 = Math_fround(Math_fround(f280 * f446) + Math_fround(Math_fround(f276 * f450) + Math_fround(f272 * f454)));
     f429 = Math_fround(Math_fround(f289 * f449) + Math_fround(Math_fround(f285 * f453) + Math_fround(f281 * f457)));
     f430 = Math_fround(Math_fround(f290 * f448) + Math_fround(Math_fround(f286 * f452) + Math_fround(f282 * f456)));
     f431 = Math_fround(Math_fround(f291 * f447) + Math_fround(Math_fround(f287 * f451) + Math_fround(f283 * f455)));
     f432 = Math_fround(Math_fround(f292 * f446) + Math_fround(Math_fround(f288 * f450) + Math_fround(f284 * f454)));
     f433 = Math_fround(Math_fround(f301 * f449) + Math_fround(Math_fround(f297 * f453) + Math_fround(f293 * f457)));
     f434 = Math_fround(Math_fround(f302 * f448) + Math_fround(Math_fround(f298 * f452) + Math_fround(f294 * f456)));
     f435 = Math_fround(Math_fround(f303 * f447) + Math_fround(Math_fround(f299 * f451) + Math_fround(f295 * f455)));
     f436 = Math_fround(Math_fround(f304 * f446) + Math_fround(Math_fround(f300 * f450) + Math_fround(f296 * f454)));
     f473 = Math_fround(Math_fround(f45 * f74) - Math_fround(f50 * f75));
     f472 = Math_fround(Math_fround(f41 * f77) - Math_fround(f49 * f78));
     f471 = Math_fround(Math_fround(f40 * f80) - Math_fround(f48 * f81));
     f470 = Math_fround(Math_fround(f38 * f83) - Math_fround(f46 * f84));
     f469 = Math_fround(Math_fround(f51 * f75) - Math_fround(f45 * f73));
     f468 = Math_fround(Math_fround(f104 * f78) - Math_fround(f41 * f76));
     f467 = Math_fround(Math_fround(f103 * f81) - Math_fround(f40 * f79));
     f466 = Math_fround(Math_fround(f102 * f84) - Math_fround(f38 * f82));
     f465 = Math_fround(Math_fround(f50 * f73) - Math_fround(f51 * f74));
     f464 = Math_fround(Math_fround(f49 * f76) - Math_fround(f104 * f77));
     f463 = Math_fround(Math_fround(f48 * f79) - Math_fround(f103 * f80));
     f462 = Math_fround(Math_fround(f46 * f82) - Math_fround(f102 * f83));
     f461 = Math_fround(Math_fround(f313 * f465) + Math_fround(Math_fround(f309 * f469) + Math_fround(f305 * f473)));
     f59 = Math_fround(Math_fround(f314 * f464) + Math_fround(Math_fround(f310 * f468) + Math_fround(f306 * f472)));
     f437 = Math_fround(Math_fround(f315 * f463) + Math_fround(Math_fround(f311 * f467) + Math_fround(f307 * f471)));
     f439 = Math_fround(Math_fround(f316 * f462) + Math_fround(Math_fround(f312 * f466) + Math_fround(f308 * f470)));
     f58 = Math_fround(Math_fround(f325 * f465) + Math_fround(Math_fround(f321 * f469) + Math_fround(f317 * f473)));
     f438 = Math_fround(Math_fround(f326 * f464) + Math_fround(Math_fround(f322 * f468) + Math_fround(f318 * f472)));
     f458 = Math_fround(Math_fround(f327 * f463) + Math_fround(Math_fround(f323 * f467) + Math_fround(f319 * f471)));
     f57 = Math_fround(Math_fround(f328 * f462) + Math_fround(Math_fround(f324 * f466) + Math_fround(f320 * f470)));
     f440 = Math_fround(Math_fround(f337 * f465) + Math_fround(Math_fround(f333 * f469) + Math_fround(f329 * f473)));
     f460 = Math_fround(Math_fround(f338 * f464) + Math_fround(Math_fround(f334 * f468) + Math_fround(f330 * f472)));
     f56 = Math_fround(Math_fround(f339 * f463) + Math_fround(Math_fround(f335 * f467) + Math_fround(f331 * f471)));
     f459 = Math_fround(Math_fround(f340 * f462) + Math_fround(Math_fround(f336 * f466) + Math_fround(f332 * f470)));
     f52 = Math_fround(Math_fround(f257 + Math_fround(Math_fround(f449 * f433) + Math_fround(Math_fround(f453 * f429) + Math_fround(f457 * f445)))) + Math_fround(f261 + Math_fround(Math_fround(f465 * f440) + Math_fround(Math_fround(f469 * f58) + Math_fround(f473 * f461)))));
     f53 = Math_fround(Math_fround(f258 + Math_fround(Math_fround(f448 * f434) + Math_fround(Math_fround(f452 * f430) + Math_fround(f456 * f444)))) + Math_fround(f263 + Math_fround(Math_fround(f464 * f460) + Math_fround(Math_fround(f468 * f438) + Math_fround(f472 * f59)))));
     f54 = Math_fround(Math_fround(f259 + Math_fround(Math_fround(f447 * f435) + Math_fround(Math_fround(f451 * f431) + Math_fround(f455 * f443)))) + Math_fround(f265 + Math_fround(Math_fround(f463 * f56) + Math_fround(Math_fround(f467 * f458) + Math_fround(f471 * f437)))));
     f55 = Math_fround(Math_fround(f260 + Math_fround(Math_fround(f446 * f436) + Math_fround(Math_fround(f450 * f432) + Math_fround(f454 * f442)))) + Math_fround(f267 + Math_fround(Math_fround(f462 * f459) + Math_fround(Math_fround(f466 * f57) + Math_fround(f470 * f439)))));
     HEAPF32[i11 + 128 >> 2] = f473;
     HEAPF32[i11 + 132 >> 2] = f472;
     HEAPF32[i11 + 136 >> 2] = f471;
     HEAPF32[i11 + 140 >> 2] = f470;
     HEAPF32[i11 + 144 >> 2] = f469;
     HEAPF32[i11 + 148 >> 2] = f468;
     HEAPF32[i11 + 152 >> 2] = f467;
     HEAPF32[i11 + 156 >> 2] = f466;
     HEAPF32[i11 + 160 >> 2] = f465;
     HEAPF32[i11 + 164 >> 2] = f464;
     HEAPF32[i11 + 168 >> 2] = f463;
     HEAPF32[i11 + 172 >> 2] = f462;
     f59 = Math_fround(-f59);
     f437 = Math_fround(-f437);
     f439 = Math_fround(-f439);
     HEAPF32[i11 + 176 >> 2] = Math_fround(-f461);
     HEAPF32[i11 + 180 >> 2] = f59;
     HEAPF32[i11 + 184 >> 2] = f437;
     HEAPF32[i11 + 188 >> 2] = f439;
     f438 = Math_fround(-f438);
     f458 = Math_fround(-f458);
     f57 = Math_fround(-f57);
     HEAPF32[i11 + 192 >> 2] = Math_fround(-f58);
     HEAPF32[i11 + 196 >> 2] = f438;
     HEAPF32[i11 + 200 >> 2] = f458;
     HEAPF32[i11 + 204 >> 2] = f57;
     f460 = Math_fround(-f460);
     f56 = Math_fround(-f56);
     f459 = Math_fround(-f459);
     HEAPF32[i11 + 208 >> 2] = Math_fround(-f440);
     HEAPF32[i11 + 212 >> 2] = f460;
     HEAPF32[i11 + 216 >> 2] = f56;
     HEAPF32[i11 + 220 >> 2] = f459;
     i123 = f52 > Math_fround(0.0);
     i124 = f53 > Math_fround(0.0);
     i125 = f54 > Math_fround(0.0);
     i441 = f55 > Math_fround(0.0);
     f52 = Math_fround(Math_fround(.800000011) / f52);
     f53 = Math_fround(Math_fround(.800000011) / f53);
     f54 = Math_fround(Math_fround(.800000011) / f54);
     f55 = Math_fround(Math_fround(.800000011) / f55);
     f52 = i123 ? f52 : Math_fround(0.0);
     f53 = i124 ? f53 : Math_fround(0.0);
     f54 = i125 ? f54 : Math_fround(0.0);
     f52 = Math_fround(f60 * f52);
     f53 = Math_fround(f85 * f53);
     f54 = Math_fround(f86 * f54);
     f55 = Math_fround(f87 * (i441 ? f55 : Math_fround(0.0)));
     f459 = Math_fround(HEAPF32[i112 >> 2]);
     f56 = Math_fround(HEAPF32[i113 >> 2]);
     f460 = Math_fround(HEAPF32[i114 >> 2]);
     f440 = Math_fround(HEAPF32[i109 >> 2]);
     f57 = Math_fround(HEAPF32[i110 >> 2]);
     f458 = Math_fround(HEAPF32[i111 >> 2]);
     f438 = Math_fround(HEAPF32[i106 >> 2]);
     f58 = Math_fround(HEAPF32[i107 >> 2]);
     f439 = Math_fround(HEAPF32[i108 >> 2]);
     f437 = Math_fround(HEAPF32[i47 >> 2]);
     f59 = Math_fround(HEAPF32[i100 >> 2]);
     f56 = Math_fround(Math_fround(f45 * f460) + Math_fround(Math_fround(f51 * f459) + Math_fround(f50 * f56)));
     f57 = Math_fround(Math_fround(f41 * f458) + Math_fround(Math_fround(f104 * f440) + Math_fround(f49 * f57)));
     f58 = Math_fround(Math_fround(f40 * f439) + Math_fround(Math_fround(f103 * f438) + Math_fround(f48 * f58)));
     f59 = Math_fround(Math_fround(f38 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f102 * f437) + Math_fround(f46 * f59)));
     f437 = Math_fround(Math_fround(Math_fround(f45 * f96) + Math_fround(Math_fround(f50 * f92) + Math_fround(f51 * f88))) * f426);
     f438 = Math_fround(Math_fround(Math_fround(f41 * f97) + Math_fround(Math_fround(f49 * f93) + Math_fround(f104 * f89))) * f426);
     f439 = Math_fround(Math_fround(Math_fround(f40 * f98) + Math_fround(Math_fround(f48 * f94) + Math_fround(f103 * f90))) * f426);
     f440 = Math_fround(Math_fround(Math_fround(f38 * f99) + Math_fround(Math_fround(f46 * f95) + Math_fround(f102 * f91))) * f426);
     HEAPF32[i11 >> 2] = f457;
     HEAPF32[i11 + 4 >> 2] = f456;
     HEAPF32[i11 + 8 >> 2] = f455;
     HEAPF32[i11 + 12 >> 2] = f454;
     HEAPF32[i11 + 16 >> 2] = f453;
     HEAPF32[i11 + 20 >> 2] = f452;
     HEAPF32[i11 + 24 >> 2] = f451;
     HEAPF32[i11 + 28 >> 2] = f450;
     HEAPF32[i11 + 32 >> 2] = f449;
     HEAPF32[i11 + 36 >> 2] = f448;
     HEAPF32[i11 + 40 >> 2] = f447;
     HEAPF32[i11 + 44 >> 2] = f446;
     HEAPF32[i11 + 48 >> 2] = f445;
     HEAPF32[i11 + 52 >> 2] = f444;
     HEAPF32[i11 + 56 >> 2] = f443;
     HEAPF32[i11 + 60 >> 2] = f442;
     HEAPF32[i11 + 64 >> 2] = f429;
     HEAPF32[i11 + 68 >> 2] = f430;
     HEAPF32[i11 + 72 >> 2] = f431;
     HEAPF32[i11 + 76 >> 2] = f432;
     HEAPF32[i11 + 80 >> 2] = f433;
     HEAPF32[i11 + 84 >> 2] = f434;
     HEAPF32[i11 + 88 >> 2] = f435;
     HEAPF32[i11 + 92 >> 2] = f436;
     f438 = Math_fround(f53 * Math_fround(f438 - f57));
     f439 = Math_fround(f54 * Math_fround(f439 - f58));
     f440 = Math_fround(f55 * Math_fround(f440 - f59));
     HEAPF32[i11 + 96 >> 2] = Math_fround(f52 * Math_fround(f437 - f56));
     HEAPF32[i11 + 100 >> 2] = f438;
     HEAPF32[i11 + 104 >> 2] = f439;
     HEAPF32[i11 + 108 >> 2] = f440;
     HEAPF32[i11 + 112 >> 2] = f52;
     HEAPF32[i11 + 116 >> 2] = f53;
     HEAPF32[i11 + 120 >> 2] = f54;
     HEAPF32[i11 + 124 >> 2] = f55;
     if (i421) {
      f471 = Math_fround(-Math_fround(f53 * f57));
      f472 = Math_fround(-Math_fround(f54 * f58));
      f473 = Math_fround(-Math_fround(f55 * f59));
      HEAPF32[i10 >> 2] = Math_fround(-Math_fround(f52 * f56));
      HEAPF32[i10 + 4 >> 2] = f471;
      HEAPF32[i10 + 8 >> 2] = f472;
      HEAPF32[i10 + 12 >> 2] = f473;
      i10 = i10 + 16 | 0;
     }
     f446 = Math_fround(Math_fround(f24 * f62) - Math_fround(f28 * f63));
     f447 = Math_fround(Math_fround(f23 * f65) - Math_fround(f27 * f66));
     f448 = Math_fround(Math_fround(f21 * f68) - Math_fround(f26 * f69));
     f449 = Math_fround(Math_fround(f20 * f71) - Math_fround(f25 * f72));
     f450 = Math_fround(Math_fround(f36 * f63) - Math_fround(f24 * f61));
     f451 = Math_fround(Math_fround(f34 * f66) - Math_fround(f23 * f64));
     f452 = Math_fround(Math_fround(f32 * f69) - Math_fround(f21 * f67));
     f453 = Math_fround(Math_fround(f30 * f72) - Math_fround(f20 * f70));
     f454 = Math_fround(Math_fround(f28 * f61) - Math_fround(f36 * f62));
     f455 = Math_fround(Math_fround(f27 * f64) - Math_fround(f34 * f65));
     f456 = Math_fround(Math_fround(f26 * f67) - Math_fround(f32 * f68));
     f457 = Math_fround(Math_fround(f25 * f70) - Math_fround(f30 * f71));
     f458 = Math_fround(Math_fround(f277 * f454) + Math_fround(Math_fround(f273 * f450) + Math_fround(f269 * f446)));
     f459 = Math_fround(Math_fround(f278 * f455) + Math_fround(Math_fround(f274 * f451) + Math_fround(f270 * f447)));
     f460 = Math_fround(Math_fround(f279 * f456) + Math_fround(Math_fround(f275 * f452) + Math_fround(f271 * f448)));
     f461 = Math_fround(Math_fround(f280 * f457) + Math_fround(Math_fround(f276 * f453) + Math_fround(f272 * f449)));
     f462 = Math_fround(Math_fround(f289 * f454) + Math_fround(Math_fround(f285 * f450) + Math_fround(f281 * f446)));
     f463 = Math_fround(Math_fround(f290 * f455) + Math_fround(Math_fround(f286 * f451) + Math_fround(f282 * f447)));
     f464 = Math_fround(Math_fround(f291 * f456) + Math_fround(Math_fround(f287 * f452) + Math_fround(f283 * f448)));
     f465 = Math_fround(Math_fround(f292 * f457) + Math_fround(Math_fround(f288 * f453) + Math_fround(f284 * f449)));
     f466 = Math_fround(Math_fround(f301 * f454) + Math_fround(Math_fround(f297 * f450) + Math_fround(f293 * f446)));
     f467 = Math_fround(Math_fround(f302 * f455) + Math_fround(Math_fround(f298 * f451) + Math_fround(f294 * f447)));
     f468 = Math_fround(Math_fround(f303 * f456) + Math_fround(Math_fround(f299 * f452) + Math_fround(f295 * f448)));
     f469 = Math_fround(Math_fround(f304 * f457) + Math_fround(Math_fround(f300 * f453) + Math_fround(f296 * f449)));
     f429 = Math_fround(Math_fround(f24 * f74) - Math_fround(f28 * f75));
     f430 = Math_fround(Math_fround(f23 * f77) - Math_fround(f27 * f78));
     f431 = Math_fround(Math_fround(f21 * f80) - Math_fround(f26 * f81));
     f432 = Math_fround(Math_fround(f20 * f83) - Math_fround(f25 * f84));
     f433 = Math_fround(Math_fround(f36 * f75) - Math_fround(f24 * f73));
     f434 = Math_fround(Math_fround(f34 * f78) - Math_fround(f23 * f76));
     f435 = Math_fround(Math_fround(f32 * f81) - Math_fround(f21 * f79));
     f436 = Math_fround(Math_fround(f30 * f84) - Math_fround(f20 * f82));
     f437 = Math_fround(Math_fround(f28 * f73) - Math_fround(f36 * f74));
     f438 = Math_fround(Math_fround(f27 * f76) - Math_fround(f34 * f77));
     f439 = Math_fround(Math_fround(f26 * f79) - Math_fround(f32 * f80));
     f440 = Math_fround(Math_fround(f25 * f82) - Math_fround(f30 * f83));
     f442 = Math_fround(Math_fround(f313 * f437) + Math_fround(Math_fround(f309 * f433) + Math_fround(f305 * f429)));
     f56 = Math_fround(Math_fround(f314 * f438) + Math_fround(Math_fround(f310 * f434) + Math_fround(f306 * f430)));
     f470 = Math_fround(Math_fround(f315 * f439) + Math_fround(Math_fround(f311 * f435) + Math_fround(f307 * f431)));
     f472 = Math_fround(Math_fround(f316 * f440) + Math_fround(Math_fround(f312 * f436) + Math_fround(f308 * f432)));
     f55 = Math_fround(Math_fround(f325 * f437) + Math_fround(Math_fround(f321 * f433) + Math_fround(f317 * f429)));
     f471 = Math_fround(Math_fround(f326 * f438) + Math_fround(Math_fround(f322 * f434) + Math_fround(f318 * f430)));
     f445 = Math_fround(Math_fround(f327 * f439) + Math_fround(Math_fround(f323 * f435) + Math_fround(f319 * f431)));
     f54 = Math_fround(Math_fround(f328 * f440) + Math_fround(Math_fround(f324 * f436) + Math_fround(f320 * f432)));
     f473 = Math_fround(Math_fround(f337 * f437) + Math_fround(Math_fround(f333 * f433) + Math_fround(f329 * f429)));
     f443 = Math_fround(Math_fround(f338 * f438) + Math_fround(Math_fround(f334 * f434) + Math_fround(f330 * f430)));
     f53 = Math_fround(Math_fround(f339 * f439) + Math_fround(Math_fround(f335 * f435) + Math_fround(f331 * f431)));
     f444 = Math_fround(Math_fround(f340 * f440) + Math_fround(Math_fround(f336 * f436) + Math_fround(f332 * f432)));
     f59 = Math_fround(Math_fround(f257 + Math_fround(Math_fround(f454 * f466) + Math_fround(Math_fround(f450 * f462) + Math_fround(f446 * f458)))) + Math_fround(f261 + Math_fround(Math_fround(f437 * f473) + Math_fround(Math_fround(f433 * f55) + Math_fround(f429 * f442)))));
     f58 = Math_fround(Math_fround(f258 + Math_fround(Math_fround(f455 * f467) + Math_fround(Math_fround(f451 * f463) + Math_fround(f447 * f459)))) + Math_fround(f263 + Math_fround(Math_fround(f438 * f443) + Math_fround(Math_fround(f434 * f471) + Math_fround(f430 * f56)))));
     f57 = Math_fround(Math_fround(f259 + Math_fround(Math_fround(f456 * f468) + Math_fround(Math_fround(f452 * f464) + Math_fround(f448 * f460)))) + Math_fround(f265 + Math_fround(Math_fround(f439 * f53) + Math_fround(Math_fround(f435 * f445) + Math_fround(f431 * f470)))));
     f52 = Math_fround(Math_fround(f260 + Math_fround(Math_fround(f457 * f469) + Math_fround(Math_fround(f453 * f465) + Math_fround(f449 * f461)))) + Math_fround(f267 + Math_fround(Math_fround(f440 * f444) + Math_fround(Math_fround(f436 * f54) + Math_fround(f432 * f472)))));
     HEAPF32[i11 + i134 >> 2] = f429;
     HEAPF32[i11 + i164 >> 2] = f430;
     HEAPF32[i11 + i165 >> 2] = f431;
     HEAPF32[i11 + i166 >> 2] = f432;
     HEAPF32[i11 + i135 >> 2] = f433;
     HEAPF32[i11 + i167 >> 2] = f434;
     HEAPF32[i11 + i168 >> 2] = f435;
     HEAPF32[i11 + i169 >> 2] = f436;
     HEAPF32[i11 + i136 >> 2] = f437;
     HEAPF32[i11 + i170 >> 2] = f438;
     HEAPF32[i11 + i171 >> 2] = f439;
     HEAPF32[i11 + i172 >> 2] = f440;
     f56 = Math_fround(-f56);
     f470 = Math_fround(-f470);
     f472 = Math_fround(-f472);
     HEAPF32[i11 + i137 >> 2] = Math_fround(-f442);
     HEAPF32[i11 + i173 >> 2] = f56;
     HEAPF32[i11 + i174 >> 2] = f470;
     HEAPF32[i11 + i175 >> 2] = f472;
     f471 = Math_fround(-f471);
     f445 = Math_fround(-f445);
     f54 = Math_fround(-f54);
     HEAPF32[i11 + i138 >> 2] = Math_fround(-f55);
     HEAPF32[i11 + i176 >> 2] = f471;
     HEAPF32[i11 + i177 >> 2] = f445;
     HEAPF32[i11 + i178 >> 2] = f54;
     f443 = Math_fround(-f443);
     f53 = Math_fround(-f53);
     f444 = Math_fround(-f444);
     HEAPF32[i11 + i139 >> 2] = Math_fround(-f473);
     HEAPF32[i11 + i179 >> 2] = f443;
     HEAPF32[i11 + i180 >> 2] = f53;
     HEAPF32[i11 + i181 >> 2] = f444;
     i123 = f59 > Math_fround(0.0);
     i124 = f58 > Math_fround(0.0);
     i125 = f57 > Math_fround(0.0);
     i441 = f52 > Math_fround(0.0);
     f59 = Math_fround(Math_fround(.800000011) / f59);
     f58 = Math_fround(Math_fround(.800000011) / f58);
     f57 = Math_fround(Math_fround(.800000011) / f57);
     f52 = Math_fround(Math_fround(.800000011) / f52);
     f59 = i123 ? f59 : Math_fround(0.0);
     f58 = i124 ? f58 : Math_fround(0.0);
     f57 = i125 ? f57 : Math_fround(0.0);
     f59 = Math_fround(f60 * f59);
     f58 = Math_fround(f85 * f58);
     f57 = Math_fround(f86 * f57);
     f52 = Math_fround(f87 * (i441 ? f52 : Math_fround(0.0)));
     f444 = Math_fround(HEAPF32[i112 >> 2]);
     f53 = Math_fround(HEAPF32[i113 >> 2]);
     f443 = Math_fround(HEAPF32[i114 >> 2]);
     f473 = Math_fround(HEAPF32[i109 >> 2]);
     f54 = Math_fround(HEAPF32[i110 >> 2]);
     f445 = Math_fround(HEAPF32[i111 >> 2]);
     f471 = Math_fround(HEAPF32[i106 >> 2]);
     f55 = Math_fround(HEAPF32[i107 >> 2]);
     f472 = Math_fround(HEAPF32[i108 >> 2]);
     f470 = Math_fround(HEAPF32[i47 >> 2]);
     f56 = Math_fround(HEAPF32[i100 >> 2]);
     f53 = Math_fround(Math_fround(f24 * f443) + Math_fround(Math_fround(f36 * f444) + Math_fround(f28 * f53)));
     f54 = Math_fround(Math_fround(f23 * f445) + Math_fround(Math_fround(f34 * f473) + Math_fround(f27 * f54)));
     f55 = Math_fround(Math_fround(f21 * f472) + Math_fround(Math_fround(f32 * f471) + Math_fround(f26 * f55)));
     f56 = Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f30 * f470) + Math_fround(f25 * f56)));
     f470 = Math_fround(Math_fround(Math_fround(f24 * f96) + Math_fround(Math_fround(f28 * f92) + Math_fround(f36 * f88))) * f426);
     f471 = Math_fround(Math_fround(Math_fround(f23 * f97) + Math_fround(Math_fround(f27 * f93) + Math_fround(f34 * f89))) * f426);
     f472 = Math_fround(Math_fround(Math_fround(f21 * f98) + Math_fround(Math_fround(f26 * f94) + Math_fround(f32 * f90))) * f426);
     f473 = Math_fround(Math_fround(Math_fround(f20 * f99) + Math_fround(Math_fround(f25 * f95) + Math_fround(f30 * f91))) * f426);
     HEAPF32[i11 + i413 >> 2] = f446;
     HEAPF32[i11 + i140 >> 2] = f447;
     HEAPF32[i11 + i141 >> 2] = f448;
     HEAPF32[i11 + i142 >> 2] = f449;
     HEAPF32[i11 + i127 >> 2] = f450;
     HEAPF32[i11 + i143 >> 2] = f451;
     HEAPF32[i11 + i144 >> 2] = f452;
     HEAPF32[i11 + i145 >> 2] = f453;
     HEAPF32[i11 + i128 >> 2] = f454;
     HEAPF32[i11 + i146 >> 2] = f455;
     HEAPF32[i11 + i147 >> 2] = f456;
     HEAPF32[i11 + i148 >> 2] = f457;
     HEAPF32[i11 + i129 >> 2] = f458;
     HEAPF32[i11 + i149 >> 2] = f459;
     HEAPF32[i11 + i150 >> 2] = f460;
     HEAPF32[i11 + i151 >> 2] = f461;
     HEAPF32[i11 + i130 >> 2] = f462;
     HEAPF32[i11 + i152 >> 2] = f463;
     HEAPF32[i11 + i153 >> 2] = f464;
     HEAPF32[i11 + i154 >> 2] = f465;
     HEAPF32[i11 + i131 >> 2] = f466;
     HEAPF32[i11 + i155 >> 2] = f467;
     HEAPF32[i11 + i156 >> 2] = f468;
     HEAPF32[i11 + i157 >> 2] = f469;
     f471 = Math_fround(f58 * Math_fround(f471 - f54));
     f472 = Math_fround(f57 * Math_fround(f472 - f55));
     f473 = Math_fround(f52 * Math_fround(f473 - f56));
     HEAPF32[i11 + i132 >> 2] = Math_fround(f59 * Math_fround(f470 - f53));
     HEAPF32[i11 + i158 >> 2] = f471;
     HEAPF32[i11 + i159 >> 2] = f472;
     HEAPF32[i11 + i160 >> 2] = f473;
     HEAPF32[i11 + i133 >> 2] = f59;
     HEAPF32[i11 + i161 >> 2] = f58;
     HEAPF32[i11 + i162 >> 2] = f57;
     HEAPF32[i11 + i163 >> 2] = f52;
     if (i421) {
      f471 = Math_fround(-Math_fround(f58 * f54));
      f472 = Math_fround(-Math_fround(f57 * f55));
      f473 = Math_fround(-Math_fround(f52 * f56));
      HEAPF32[i10 >> 2] = Math_fround(-Math_fround(f59 * f53));
      HEAPF32[i10 + 4 >> 2] = f471;
      HEAPF32[i10 + 8 >> 2] = f472;
      HEAPF32[i10 + 12 >> 2] = f473;
      i10 = i10 + 16 | 0;
     }
     i16 = i16 + 1 | 0;
     if (i16 >>> 0 >= i119 >>> 0) break; else i11 = i11 + i126 | 0;
    }
   } else if (i421) {
    i17 = 1065353216;
    i18 = 1065353216;
    i19 = 1065353216;
    i35 = 1065353216;
    i12 = 0;
    i13 = 0;
    i14 = 0;
    i15 = 0;
    i16 = 0;
    i11 = i43;
    while (1) {
     i123 = i16 >>> 0 < i118 >>> 0;
     i12 = i123 ? i16 : i12;
     i124 = i16 >>> 0 < i117 >>> 0;
     i13 = i124 ? i16 : i13;
     i125 = i16 >>> 0 < i116 >>> 0;
     i14 = i125 ? i16 : i14;
     i441 = i16 >>> 0 < i115 >>> 0;
     i15 = i441 ? i16 : i15;
     i17 = i123 ? i17 : 0;
     i18 = i124 ? i18 : 0;
     i19 = i125 ? i19 : 0;
     i35 = i441 ? i35 : 0;
     f99 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f51 = Math_fround(f51 * f99);
     f96 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f54 = Math_fround(f54 * f96);
     f470 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = Math_fround(f53 * f470);
     f97 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f52 = Math_fround(f52 * f97);
     f50 = Math_fround(f50 * f99);
     f49 = Math_fround(f49 * f96);
     f48 = Math_fround(f48 * f470);
     f46 = Math_fround(f46 * f97);
     f45 = Math_fround(f45 * f99);
     f41 = Math_fround(f41 * f96);
     f40 = Math_fround(f40 * f470);
     f38 = Math_fround(f38 * f97);
     f36 = Math_fround(f36 * f99);
     f34 = Math_fround(f34 * f96);
     f32 = Math_fround(f32 * f470);
     f30 = Math_fround(f30 * f97);
     f28 = Math_fround(f28 * f99);
     f27 = Math_fround(f27 * f96);
     f26 = Math_fround(f26 * f470);
     f25 = Math_fround(f25 * f97);
     f24 = Math_fround(f24 * f99);
     f23 = Math_fround(f23 * f96);
     f21 = Math_fround(f21 * f470);
     f20 = Math_fround(f20 * f97);
     f443 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) >> 2]);
     f452 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) + 4 >> 2]);
     f447 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i12 * 12 | 0) + 8 >> 2]);
     f444 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) >> 2]);
     f451 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) + 4 >> 2]);
     f448 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i13 * 12 | 0) + 8 >> 2]);
     f445 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) >> 2]);
     f450 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) + 4 >> 2]);
     f449 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i14 * 12 | 0) + 8 >> 2]);
     f462 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) >> 2]);
     f463 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) + 4 >> 2]);
     f464 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i15 * 12 | 0) + 8 >> 2]);
     f442 = Math_fround(Math_fround(Math_fround(f366 * f443) + Math_fround(f367 * f452)) + Math_fround(f368 * f447));
     f453 = Math_fround(Math_fround(Math_fround(f366 * f442) + Math_fround(Math_fround(f183 * f443) + Math_fround(f369 * Math_fround(Math_fround(f367 * f447) - Math_fround(f368 * f452))))) * Math_fround(2.0));
     f446 = Math_fround(Math_fround(Math_fround(f367 * f442) + Math_fround(Math_fround(f183 * f452) + Math_fround(f369 * Math_fround(Math_fround(f368 * f443) - Math_fround(f366 * f447))))) * Math_fround(2.0));
     f442 = Math_fround(Math_fround(Math_fround(Math_fround(f183 * f447) + Math_fround(f369 * Math_fround(Math_fround(f366 * f452) - Math_fround(f367 * f443)))) + Math_fround(f368 * f442)) * Math_fround(2.0));
     f443 = Math_fround(Math_fround(Math_fround(f370 * f444) + Math_fround(f371 * f451)) + Math_fround(f372 * f448));
     f452 = Math_fround(Math_fround(Math_fround(f370 * f443) + Math_fround(Math_fround(f184 * f444) + Math_fround(f373 * Math_fround(Math_fround(f371 * f448) - Math_fround(f372 * f451))))) * Math_fround(2.0));
     f447 = Math_fround(Math_fround(Math_fround(f371 * f443) + Math_fround(Math_fround(f184 * f451) + Math_fround(f373 * Math_fround(Math_fround(f372 * f444) - Math_fround(f370 * f448))))) * Math_fround(2.0));
     f443 = Math_fround(Math_fround(Math_fround(Math_fround(f184 * f448) + Math_fround(f373 * Math_fround(Math_fround(f370 * f451) - Math_fround(f371 * f444)))) + Math_fround(f372 * f443)) * Math_fround(2.0));
     f444 = Math_fround(Math_fround(Math_fround(f374 * f445) + Math_fround(f375 * f450)) + Math_fround(f376 * f449));
     f451 = Math_fround(Math_fround(Math_fround(f374 * f444) + Math_fround(Math_fround(f185 * f445) + Math_fround(f377 * Math_fround(Math_fround(f375 * f449) - Math_fround(f376 * f450))))) * Math_fround(2.0));
     f448 = Math_fround(Math_fround(Math_fround(f375 * f444) + Math_fround(Math_fround(f185 * f450) + Math_fround(f377 * Math_fround(Math_fround(f376 * f445) - Math_fround(f374 * f449))))) * Math_fround(2.0));
     f444 = Math_fround(Math_fround(Math_fround(Math_fround(f185 * f449) + Math_fround(f377 * Math_fround(Math_fround(f374 * f450) - Math_fround(f375 * f445)))) + Math_fround(f376 * f444)) * Math_fround(2.0));
     f445 = Math_fround(Math_fround(Math_fround(f378 * f462) + Math_fround(f379 * f463)) + Math_fround(f380 * f464));
     f450 = Math_fround(Math_fround(Math_fround(f378 * f445) + Math_fround(Math_fround(f186 * f462) + Math_fround(f381 * Math_fround(Math_fround(f379 * f464) - Math_fround(f380 * f463))))) * Math_fround(2.0));
     f449 = Math_fround(Math_fround(Math_fround(f379 * f445) + Math_fround(Math_fround(f186 * f463) + Math_fround(f381 * Math_fround(Math_fround(f380 * f462) - Math_fround(f378 * f464))))) * Math_fround(2.0));
     f445 = Math_fround(Math_fround(Math_fround(Math_fround(f186 * f464) + Math_fround(f381 * Math_fround(Math_fround(f378 * f463) - Math_fround(f379 * f462)))) + Math_fround(f380 * f445)) * Math_fround(2.0));
     f462 = Math_fround(f342 + f453);
     f463 = Math_fround(f345 + f452);
     f464 = Math_fround(f348 + f451);
     f465 = Math_fround(f351 + f450);
     f430 = Math_fround(f343 + f446);
     f432 = Math_fround(f346 + f447);
     f434 = Math_fround(f349 + f448);
     f436 = Math_fround(f352 + f449);
     f102 = Math_fround(f344 + f442);
     f94 = Math_fround(f347 + f443);
     f90 = Math_fround(f350 + f444);
     f86 = Math_fround(f353 + f445);
     f95 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) >> 2]);
     f473 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) + 4 >> 2]);
     f104 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i12 * 12 | 0) + 8 >> 2]);
     f91 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) >> 2]);
     f92 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) + 4 >> 2]);
     f93 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i13 * 12 | 0) + 8 >> 2]);
     f87 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) >> 2]);
     f88 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) + 4 >> 2]);
     f89 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i14 * 12 | 0) + 8 >> 2]);
     f83 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) >> 2]);
     f84 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) + 4 >> 2]);
     f85 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i15 * 12 | 0) + 8 >> 2]);
     f429 = Math_fround(Math_fround(Math_fround(f382 * f95) + Math_fround(f383 * f473)) + Math_fround(f384 * f104));
     f431 = Math_fround(Math_fround(Math_fround(f386 * f91) + Math_fround(f387 * f92)) + Math_fround(f388 * f93));
     f433 = Math_fround(Math_fround(Math_fround(f390 * f87) + Math_fround(f391 * f88)) + Math_fround(f392 * f89));
     f435 = Math_fround(Math_fround(Math_fround(f394 * f83) + Math_fround(f395 * f84)) + Math_fround(f396 * f85));
     f462 = Math_fround(f462 - Math_fround(f354 + Math_fround(Math_fround(Math_fround(f382 * f429) + Math_fround(Math_fround(f187 * f95) + Math_fround(f385 * Math_fround(Math_fround(f383 * f104) - Math_fround(f384 * f473))))) * Math_fround(2.0))));
     f463 = Math_fround(f463 - Math_fround(f357 + Math_fround(Math_fround(Math_fround(f386 * f431) + Math_fround(Math_fround(f188 * f91) + Math_fround(f389 * Math_fround(Math_fround(f387 * f93) - Math_fround(f388 * f92))))) * Math_fround(2.0))));
     f464 = Math_fround(f464 - Math_fround(f360 + Math_fround(Math_fround(Math_fround(f390 * f433) + Math_fround(Math_fround(f189 * f87) + Math_fround(f393 * Math_fround(Math_fround(f391 * f89) - Math_fround(f392 * f88))))) * Math_fround(2.0))));
     f465 = Math_fround(f465 - Math_fround(f363 + Math_fround(Math_fround(Math_fround(f394 * f435) + Math_fround(Math_fround(f190 * f83) + Math_fround(f397 * Math_fround(Math_fround(f395 * f85) - Math_fround(f396 * f84))))) * Math_fround(2.0))));
     f430 = Math_fround(f430 - Math_fround(f355 + Math_fround(Math_fround(Math_fround(f383 * f429) + Math_fround(Math_fround(f187 * f473) + Math_fround(f385 * Math_fround(Math_fround(f384 * f95) - Math_fround(f382 * f104))))) * Math_fround(2.0))));
     f432 = Math_fround(f432 - Math_fround(f358 + Math_fround(Math_fround(Math_fround(f387 * f431) + Math_fround(Math_fround(f188 * f92) + Math_fround(f389 * Math_fround(Math_fround(f388 * f91) - Math_fround(f386 * f93))))) * Math_fround(2.0))));
     f434 = Math_fround(f434 - Math_fround(f361 + Math_fround(Math_fround(Math_fround(f391 * f433) + Math_fround(Math_fround(f189 * f88) + Math_fround(f393 * Math_fround(Math_fround(f392 * f87) - Math_fround(f390 * f89))))) * Math_fround(2.0))));
     f436 = Math_fround(f436 - Math_fround(f364 + Math_fround(Math_fround(Math_fround(f395 * f435) + Math_fround(Math_fround(f190 * f84) + Math_fround(f397 * Math_fround(Math_fround(f396 * f83) - Math_fround(f394 * f85))))) * Math_fround(2.0))));
     f429 = Math_fround(f102 - Math_fround(f356 + Math_fround(Math_fround(Math_fround(Math_fround(f187 * f104) + Math_fround(f385 * Math_fround(Math_fround(f382 * f473) - Math_fround(f383 * f95)))) + Math_fround(f384 * f429)) * Math_fround(2.0))));
     f431 = Math_fround(f94 - Math_fround(f359 + Math_fround(Math_fround(Math_fround(Math_fround(f188 * f93) + Math_fround(f389 * Math_fround(Math_fround(f386 * f92) - Math_fround(f387 * f91)))) + Math_fround(f388 * f431)) * Math_fround(2.0))));
     f433 = Math_fround(f90 - Math_fround(f362 + Math_fround(Math_fround(Math_fround(Math_fround(f189 * f89) + Math_fround(f393 * Math_fround(Math_fround(f390 * f88) - Math_fround(f391 * f87)))) + Math_fround(f392 * f433)) * Math_fround(2.0))));
     f435 = Math_fround(f86 - Math_fround(f365 + Math_fround(Math_fround(Math_fround(Math_fround(f190 * f85) + Math_fround(f397 * Math_fround(Math_fround(f394 * f84) - Math_fround(f395 * f83)))) + Math_fround(f396 * f435)) * Math_fround(2.0))));
     f83 = Math_fround(Math_fround(f45 * f446) - Math_fround(f50 * f442));
     f84 = Math_fround(Math_fround(f41 * f447) - Math_fround(f49 * f443));
     f85 = Math_fround(Math_fround(f40 * f448) - Math_fround(f48 * f444));
     f86 = Math_fround(Math_fround(f38 * f449) - Math_fround(f46 * f445));
     f87 = Math_fround(Math_fround(f51 * f442) - Math_fround(f45 * f453));
     f88 = Math_fround(Math_fround(f54 * f443) - Math_fround(f41 * f452));
     f89 = Math_fround(Math_fround(f53 * f444) - Math_fround(f40 * f451));
     f90 = Math_fround(Math_fround(f52 * f445) - Math_fround(f38 * f450));
     f91 = Math_fround(Math_fround(f50 * f453) - Math_fround(f51 * f446));
     f92 = Math_fround(Math_fround(f49 * f452) - Math_fround(f54 * f447));
     f93 = Math_fround(Math_fround(f48 * f451) - Math_fround(f53 * f448));
     f94 = Math_fround(Math_fround(f46 * f450) - Math_fround(f52 * f449));
     f95 = Math_fround(Math_fround(f277 * f91) + Math_fround(Math_fround(f273 * f87) + Math_fround(f269 * f83)));
     f473 = Math_fround(Math_fround(f278 * f92) + Math_fround(Math_fround(f274 * f88) + Math_fround(f270 * f84)));
     f104 = Math_fround(Math_fround(f279 * f93) + Math_fround(Math_fround(f275 * f89) + Math_fround(f271 * f85)));
     f102 = Math_fround(Math_fround(f280 * f94) + Math_fround(Math_fround(f276 * f90) + Math_fround(f272 * f86)));
     f472 = Math_fround(Math_fround(f289 * f91) + Math_fround(Math_fround(f285 * f87) + Math_fround(f281 * f83)));
     f103 = Math_fround(Math_fround(f290 * f92) + Math_fround(Math_fround(f286 * f88) + Math_fround(f282 * f84)));
     f98 = Math_fround(Math_fround(f291 * f93) + Math_fround(Math_fround(f287 * f89) + Math_fround(f283 * f85)));
     f471 = Math_fround(Math_fround(f292 * f94) + Math_fround(Math_fround(f288 * f90) + Math_fround(f284 * f86)));
     f468 = Math_fround(Math_fround(f301 * f91) + Math_fround(Math_fround(f297 * f87) + Math_fround(f293 * f83)));
     f467 = Math_fround(Math_fround(f302 * f92) + Math_fround(Math_fround(f298 * f88) + Math_fround(f294 * f84)));
     f466 = Math_fround(Math_fround(f303 * f93) + Math_fround(Math_fround(f299 * f89) + Math_fround(f295 * f85)));
     f469 = Math_fround(Math_fround(f304 * f94) + Math_fround(Math_fround(f300 * f90) + Math_fround(f296 * f86)));
     f454 = Math_fround(f257 + Math_fround(Math_fround(f91 * f468) + Math_fround(Math_fround(f87 * f472) + Math_fround(f83 * f95))));
     f457 = Math_fround(f258 + Math_fround(Math_fround(f92 * f467) + Math_fround(Math_fround(f88 * f103) + Math_fround(f84 * f473))));
     f456 = Math_fround(f259 + Math_fround(Math_fround(f93 * f466) + Math_fround(Math_fround(f89 * f98) + Math_fround(f85 * f104))));
     f455 = Math_fround(f260 + Math_fround(Math_fround(f94 * f469) + Math_fround(Math_fround(f90 * f471) + Math_fround(f86 * f102))));
     i441 = f454 > Math_fround(0.0);
     i125 = f457 > Math_fround(0.0);
     i124 = f456 > Math_fround(0.0);
     i123 = f455 > Math_fround(0.0);
     f454 = Math_fround(Math_fround(.800000011) / f454);
     f457 = Math_fround(Math_fround(.800000011) / f457);
     f456 = Math_fround(Math_fround(.800000011) / f456);
     f455 = Math_fround(Math_fround(.800000011) / f455);
     f454 = i441 ? f454 : Math_fround(0.0);
     f457 = i125 ? f457 : Math_fround(0.0);
     f456 = i124 ? f456 : Math_fround(0.0);
     f454 = Math_fround(f99 * f454);
     f457 = Math_fround(f96 * f457);
     f456 = Math_fround(f470 * f456);
     f455 = Math_fround(f97 * (i123 ? f455 : Math_fround(0.0)));
     f81 = Math_fround(HEAPF32[i112 >> 2]);
     f440 = Math_fround(HEAPF32[i113 >> 2]);
     f80 = Math_fround(HEAPF32[i114 >> 2]);
     f458 = Math_fround(HEAPF32[i109 >> 2]);
     f439 = Math_fround(HEAPF32[i110 >> 2]);
     f82 = Math_fround(HEAPF32[i111 >> 2]);
     f460 = Math_fround(HEAPF32[i106 >> 2]);
     f438 = Math_fround(HEAPF32[i107 >> 2]);
     f459 = Math_fround(HEAPF32[i108 >> 2]);
     f461 = Math_fround(HEAPF32[i47 >> 2]);
     f437 = Math_fround(HEAPF32[i100 >> 2]);
     f440 = Math_fround(Math_fround(f45 * f80) + Math_fround(Math_fround(f51 * f81) + Math_fround(f50 * f440)));
     f439 = Math_fround(Math_fround(f41 * f82) + Math_fround(Math_fround(f54 * f458) + Math_fround(f49 * f439)));
     f438 = Math_fround(Math_fround(f40 * f459) + Math_fround(Math_fround(f53 * f460) + Math_fround(f48 * f438)));
     f437 = Math_fround(Math_fround(f38 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f52 * f461) + Math_fround(f46 * f437)));
     f461 = Math_fround(Math_fround(Math_fround(f45 * f429) + Math_fround(Math_fround(f50 * f430) + Math_fround(f51 * f462))) * f426);
     f460 = Math_fround(Math_fround(Math_fround(f41 * f431) + Math_fround(Math_fround(f49 * f432) + Math_fround(f54 * f463))) * f426);
     f459 = Math_fround(Math_fround(Math_fround(f40 * f433) + Math_fround(Math_fround(f48 * f434) + Math_fround(f53 * f464))) * f426);
     f458 = Math_fround(Math_fround(Math_fround(f38 * f435) + Math_fround(Math_fround(f46 * f436) + Math_fround(f52 * f465))) * f426);
     HEAPF32[i11 >> 2] = f83;
     HEAPF32[i11 + 4 >> 2] = f84;
     HEAPF32[i11 + 8 >> 2] = f85;
     HEAPF32[i11 + 12 >> 2] = f86;
     HEAPF32[i11 + 16 >> 2] = f87;
     HEAPF32[i11 + 20 >> 2] = f88;
     HEAPF32[i11 + 24 >> 2] = f89;
     HEAPF32[i11 + 28 >> 2] = f90;
     HEAPF32[i11 + 32 >> 2] = f91;
     HEAPF32[i11 + 36 >> 2] = f92;
     HEAPF32[i11 + 40 >> 2] = f93;
     HEAPF32[i11 + 44 >> 2] = f94;
     HEAPF32[i11 + 48 >> 2] = f95;
     HEAPF32[i11 + 52 >> 2] = f473;
     HEAPF32[i11 + 56 >> 2] = f104;
     HEAPF32[i11 + 60 >> 2] = f102;
     HEAPF32[i11 + 64 >> 2] = f472;
     HEAPF32[i11 + 68 >> 2] = f103;
     HEAPF32[i11 + 72 >> 2] = f98;
     HEAPF32[i11 + 76 >> 2] = f471;
     HEAPF32[i11 + 80 >> 2] = f468;
     HEAPF32[i11 + 84 >> 2] = f467;
     HEAPF32[i11 + 88 >> 2] = f466;
     HEAPF32[i11 + 92 >> 2] = f469;
     f460 = Math_fround(f457 * Math_fround(f460 - f439));
     f459 = Math_fround(f456 * Math_fround(f459 - f438));
     f458 = Math_fround(f455 * Math_fround(f458 - f437));
     HEAPF32[i11 + 96 >> 2] = Math_fround(f454 * Math_fround(f461 - f440));
     HEAPF32[i11 + 100 >> 2] = f460;
     HEAPF32[i11 + 104 >> 2] = f459;
     HEAPF32[i11 + 108 >> 2] = f458;
     HEAPF32[i11 + 112 >> 2] = f454;
     HEAPF32[i11 + 116 >> 2] = f457;
     HEAPF32[i11 + 120 >> 2] = f456;
     HEAPF32[i11 + 124 >> 2] = f455;
     f439 = Math_fround(-Math_fround(f457 * f439));
     f438 = Math_fround(-Math_fround(f456 * f438));
     f437 = Math_fround(-Math_fround(f455 * f437));
     HEAPF32[i10 >> 2] = Math_fround(-Math_fround(f454 * f440));
     HEAPF32[i10 + 4 >> 2] = f439;
     HEAPF32[i10 + 8 >> 2] = f438;
     HEAPF32[i10 + 12 >> 2] = f437;
     f437 = Math_fround(Math_fround(f24 * f446) - Math_fround(f28 * f442));
     f438 = Math_fround(Math_fround(f23 * f447) - Math_fround(f27 * f443));
     f439 = Math_fround(Math_fround(f21 * f448) - Math_fround(f26 * f444));
     f440 = Math_fround(Math_fround(f20 * f449) - Math_fround(f25 * f445));
     f442 = Math_fround(Math_fround(f36 * f442) - Math_fround(f24 * f453));
     f443 = Math_fround(Math_fround(f34 * f443) - Math_fround(f23 * f452));
     f444 = Math_fround(Math_fround(f32 * f444) - Math_fround(f21 * f451));
     f445 = Math_fround(Math_fround(f30 * f445) - Math_fround(f20 * f450));
     f446 = Math_fround(Math_fround(f28 * f453) - Math_fround(f36 * f446));
     f447 = Math_fround(Math_fround(f27 * f452) - Math_fround(f34 * f447));
     f448 = Math_fround(Math_fround(f26 * f451) - Math_fround(f32 * f448));
     f449 = Math_fround(Math_fround(f25 * f450) - Math_fround(f30 * f449));
     f450 = Math_fround(Math_fround(f277 * f446) + Math_fround(Math_fround(f273 * f442) + Math_fround(f269 * f437)));
     f451 = Math_fround(Math_fround(f278 * f447) + Math_fround(Math_fround(f274 * f443) + Math_fround(f270 * f438)));
     f452 = Math_fround(Math_fround(f279 * f448) + Math_fround(Math_fround(f275 * f444) + Math_fround(f271 * f439)));
     f453 = Math_fround(Math_fround(f280 * f449) + Math_fround(Math_fround(f276 * f445) + Math_fround(f272 * f440)));
     f454 = Math_fround(Math_fround(f289 * f446) + Math_fround(Math_fround(f285 * f442) + Math_fround(f281 * f437)));
     f455 = Math_fround(Math_fround(f290 * f447) + Math_fround(Math_fround(f286 * f443) + Math_fround(f282 * f438)));
     f456 = Math_fround(Math_fround(f291 * f448) + Math_fround(Math_fround(f287 * f444) + Math_fround(f283 * f439)));
     f457 = Math_fround(Math_fround(f292 * f449) + Math_fround(Math_fround(f288 * f445) + Math_fround(f284 * f440)));
     f458 = Math_fround(Math_fround(f301 * f446) + Math_fround(Math_fround(f297 * f442) + Math_fround(f293 * f437)));
     f459 = Math_fround(Math_fround(f302 * f447) + Math_fround(Math_fround(f298 * f443) + Math_fround(f294 * f438)));
     f460 = Math_fround(Math_fround(f303 * f448) + Math_fround(Math_fround(f299 * f444) + Math_fround(f295 * f439)));
     f461 = Math_fround(Math_fround(f304 * f449) + Math_fround(Math_fround(f300 * f445) + Math_fround(f296 * f440)));
     f469 = Math_fround(f257 + Math_fround(Math_fround(f446 * f458) + Math_fround(Math_fround(f442 * f454) + Math_fround(f437 * f450))));
     f466 = Math_fround(f258 + Math_fround(Math_fround(f447 * f459) + Math_fround(Math_fround(f443 * f455) + Math_fround(f438 * f451))));
     f467 = Math_fround(f259 + Math_fround(Math_fround(f448 * f460) + Math_fround(Math_fround(f444 * f456) + Math_fround(f439 * f452))));
     f468 = Math_fround(f260 + Math_fround(Math_fround(f449 * f461) + Math_fround(Math_fround(f445 * f457) + Math_fround(f440 * f453))));
     i123 = f469 > Math_fround(0.0);
     i124 = f466 > Math_fround(0.0);
     i125 = f467 > Math_fround(0.0);
     i441 = f468 > Math_fround(0.0);
     f469 = Math_fround(Math_fround(.800000011) / f469);
     f466 = Math_fround(Math_fround(.800000011) / f466);
     f467 = Math_fround(Math_fround(.800000011) / f467);
     f468 = Math_fround(Math_fround(.800000011) / f468);
     f469 = i123 ? f469 : Math_fround(0.0);
     f466 = i124 ? f466 : Math_fround(0.0);
     f467 = i125 ? f467 : Math_fround(0.0);
     f469 = Math_fround(f99 * f469);
     f466 = Math_fround(f96 * f466);
     f467 = Math_fround(f470 * f467);
     f468 = Math_fround(f97 * (i441 ? f468 : Math_fround(0.0)));
     f97 = Math_fround(HEAPF32[i112 >> 2]);
     f470 = Math_fround(HEAPF32[i113 >> 2]);
     f96 = Math_fround(HEAPF32[i114 >> 2]);
     f99 = Math_fround(HEAPF32[i109 >> 2]);
     f471 = Math_fround(HEAPF32[i110 >> 2]);
     f98 = Math_fround(HEAPF32[i111 >> 2]);
     f103 = Math_fround(HEAPF32[i106 >> 2]);
     f472 = Math_fround(HEAPF32[i107 >> 2]);
     f102 = Math_fround(HEAPF32[i108 >> 2]);
     f104 = Math_fround(HEAPF32[i47 >> 2]);
     f473 = Math_fround(HEAPF32[i100 >> 2]);
     f470 = Math_fround(Math_fround(f24 * f96) + Math_fround(Math_fround(f36 * f97) + Math_fround(f28 * f470)));
     f471 = Math_fround(Math_fround(f23 * f98) + Math_fround(Math_fround(f34 * f99) + Math_fround(f27 * f471)));
     f472 = Math_fround(Math_fround(f21 * f102) + Math_fround(Math_fround(f32 * f103) + Math_fround(f26 * f472)));
     f473 = Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f30 * f104) + Math_fround(f25 * f473)));
     f462 = Math_fround(Math_fround(Math_fround(f24 * f429) + Math_fround(Math_fround(f28 * f430) + Math_fround(f36 * f462))) * f426);
     f463 = Math_fround(Math_fround(Math_fround(f23 * f431) + Math_fround(Math_fround(f27 * f432) + Math_fround(f34 * f463))) * f426);
     f464 = Math_fround(Math_fround(Math_fround(f21 * f433) + Math_fround(Math_fround(f26 * f434) + Math_fround(f32 * f464))) * f426);
     f465 = Math_fround(Math_fround(Math_fround(f20 * f435) + Math_fround(Math_fround(f25 * f436) + Math_fround(f30 * f465))) * f426);
     HEAPF32[i11 + i413 >> 2] = f437;
     HEAPF32[i11 + i140 >> 2] = f438;
     HEAPF32[i11 + i141 >> 2] = f439;
     HEAPF32[i11 + i142 >> 2] = f440;
     HEAPF32[i11 + i127 >> 2] = f442;
     HEAPF32[i11 + i143 >> 2] = f443;
     HEAPF32[i11 + i144 >> 2] = f444;
     HEAPF32[i11 + i145 >> 2] = f445;
     HEAPF32[i11 + i128 >> 2] = f446;
     HEAPF32[i11 + i146 >> 2] = f447;
     HEAPF32[i11 + i147 >> 2] = f448;
     HEAPF32[i11 + i148 >> 2] = f449;
     HEAPF32[i11 + i129 >> 2] = f450;
     HEAPF32[i11 + i149 >> 2] = f451;
     HEAPF32[i11 + i150 >> 2] = f452;
     HEAPF32[i11 + i151 >> 2] = f453;
     HEAPF32[i11 + i130 >> 2] = f454;
     HEAPF32[i11 + i152 >> 2] = f455;
     HEAPF32[i11 + i153 >> 2] = f456;
     HEAPF32[i11 + i154 >> 2] = f457;
     HEAPF32[i11 + i131 >> 2] = f458;
     HEAPF32[i11 + i155 >> 2] = f459;
     HEAPF32[i11 + i156 >> 2] = f460;
     HEAPF32[i11 + i157 >> 2] = f461;
     f463 = Math_fround(f466 * Math_fround(f463 - f471));
     f464 = Math_fround(f467 * Math_fround(f464 - f472));
     f465 = Math_fround(f468 * Math_fround(f465 - f473));
     HEAPF32[i11 + i132 >> 2] = Math_fround(f469 * Math_fround(f462 - f470));
     HEAPF32[i11 + i158 >> 2] = f463;
     HEAPF32[i11 + i159 >> 2] = f464;
     HEAPF32[i11 + i160 >> 2] = f465;
     HEAPF32[i11 + i133 >> 2] = f469;
     HEAPF32[i11 + i161 >> 2] = f466;
     HEAPF32[i11 + i162 >> 2] = f467;
     HEAPF32[i11 + i163 >> 2] = f468;
     f471 = Math_fround(-Math_fround(f466 * f471));
     f472 = Math_fround(-Math_fround(f467 * f472));
     f473 = Math_fround(-Math_fround(f468 * f473));
     HEAPF32[i10 + 16 >> 2] = Math_fround(-Math_fround(f469 * f470));
     HEAPF32[i10 + 20 >> 2] = f471;
     HEAPF32[i10 + 24 >> 2] = f472;
     HEAPF32[i10 + 28 >> 2] = f473;
     i16 = i16 + 1 | 0;
     if (i16 >>> 0 >= i119 >>> 0) break; else {
      i11 = i11 + i126 | 0;
      i10 = i10 + 32 | 0;
     }
    }
   } else {
    i16 = 1065353216;
    i17 = 1065353216;
    i18 = 1065353216;
    i19 = 1065353216;
    i11 = 0;
    i12 = 0;
    i13 = 0;
    i14 = 0;
    i15 = 0;
    i10 = i43;
    while (1) {
     i123 = i15 >>> 0 < i118 >>> 0;
     i11 = i123 ? i15 : i11;
     i124 = i15 >>> 0 < i117 >>> 0;
     i12 = i124 ? i15 : i12;
     i125 = i15 >>> 0 < i116 >>> 0;
     i13 = i125 ? i15 : i13;
     i441 = i15 >>> 0 < i115 >>> 0;
     i14 = i441 ? i15 : i14;
     i16 = i123 ? i16 : 0;
     i17 = i124 ? i17 : 0;
     i18 = i125 ? i18 : 0;
     i19 = i441 ? i19 : 0;
     f99 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f51 = Math_fround(f51 * f99);
     f96 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f54 = Math_fround(f54 * f96);
     f466 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = Math_fround(f53 * f466);
     f97 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f52 = Math_fround(f52 * f97);
     f50 = Math_fround(f50 * f99);
     f49 = Math_fround(f49 * f96);
     f48 = Math_fround(f48 * f466);
     f46 = Math_fround(f46 * f97);
     f45 = Math_fround(f45 * f99);
     f41 = Math_fround(f41 * f96);
     f40 = Math_fround(f40 * f466);
     f38 = Math_fround(f38 * f97);
     f36 = Math_fround(f36 * f99);
     f34 = Math_fround(f34 * f96);
     f32 = Math_fround(f32 * f466);
     f30 = Math_fround(f30 * f97);
     f28 = Math_fround(f28 * f99);
     f27 = Math_fround(f27 * f96);
     f26 = Math_fround(f26 * f466);
     f25 = Math_fround(f25 * f97);
     f24 = Math_fround(f24 * f99);
     f23 = Math_fround(f23 * f96);
     f21 = Math_fround(f21 * f466);
     f20 = Math_fround(f20 * f97);
     f443 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i11 * 12 | 0) >> 2]);
     f452 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i11 * 12 | 0) + 4 >> 2]);
     f447 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 48 + (i11 * 12 | 0) + 8 >> 2]);
     f444 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i12 * 12 | 0) >> 2]);
     f451 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i12 * 12 | 0) + 4 >> 2]);
     f448 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 48 + (i12 * 12 | 0) + 8 >> 2]);
     f445 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i13 * 12 | 0) >> 2]);
     f450 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i13 * 12 | 0) + 4 >> 2]);
     f449 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 48 + (i13 * 12 | 0) + 8 >> 2]);
     f465 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i14 * 12 | 0) >> 2]);
     f462 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i14 * 12 | 0) + 4 >> 2]);
     f463 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 48 + (i14 * 12 | 0) + 8 >> 2]);
     f442 = Math_fround(Math_fround(Math_fround(f366 * f443) + Math_fround(f367 * f452)) + Math_fround(f368 * f447));
     f453 = Math_fround(Math_fround(Math_fround(f366 * f442) + Math_fround(Math_fround(f183 * f443) + Math_fround(f369 * Math_fround(Math_fround(f367 * f447) - Math_fround(f368 * f452))))) * Math_fround(2.0));
     f446 = Math_fround(Math_fround(Math_fround(f367 * f442) + Math_fround(Math_fround(f183 * f452) + Math_fround(f369 * Math_fround(Math_fround(f368 * f443) - Math_fround(f366 * f447))))) * Math_fround(2.0));
     f442 = Math_fround(Math_fround(Math_fround(Math_fround(f183 * f447) + Math_fround(f369 * Math_fround(Math_fround(f366 * f452) - Math_fround(f367 * f443)))) + Math_fround(f368 * f442)) * Math_fround(2.0));
     f443 = Math_fround(Math_fround(Math_fround(f370 * f444) + Math_fround(f371 * f451)) + Math_fround(f372 * f448));
     f452 = Math_fround(Math_fround(Math_fround(f370 * f443) + Math_fround(Math_fround(f184 * f444) + Math_fround(f373 * Math_fround(Math_fround(f371 * f448) - Math_fround(f372 * f451))))) * Math_fround(2.0));
     f447 = Math_fround(Math_fround(Math_fround(f371 * f443) + Math_fround(Math_fround(f184 * f451) + Math_fround(f373 * Math_fround(Math_fround(f372 * f444) - Math_fround(f370 * f448))))) * Math_fround(2.0));
     f443 = Math_fround(Math_fround(Math_fround(Math_fround(f184 * f448) + Math_fround(f373 * Math_fround(Math_fround(f370 * f451) - Math_fround(f371 * f444)))) + Math_fround(f372 * f443)) * Math_fround(2.0));
     f444 = Math_fround(Math_fround(Math_fround(f374 * f445) + Math_fround(f375 * f450)) + Math_fround(f376 * f449));
     f451 = Math_fround(Math_fround(Math_fround(f374 * f444) + Math_fround(Math_fround(f185 * f445) + Math_fround(f377 * Math_fround(Math_fround(f375 * f449) - Math_fround(f376 * f450))))) * Math_fround(2.0));
     f448 = Math_fround(Math_fround(Math_fround(f375 * f444) + Math_fround(Math_fround(f185 * f450) + Math_fround(f377 * Math_fround(Math_fround(f376 * f445) - Math_fround(f374 * f449))))) * Math_fround(2.0));
     f444 = Math_fround(Math_fround(Math_fround(Math_fround(f185 * f449) + Math_fround(f377 * Math_fround(Math_fround(f374 * f450) - Math_fround(f375 * f445)))) + Math_fround(f376 * f444)) * Math_fround(2.0));
     f445 = Math_fround(Math_fround(Math_fround(f378 * f465) + Math_fround(f379 * f462)) + Math_fround(f380 * f463));
     f450 = Math_fround(Math_fround(Math_fround(f378 * f445) + Math_fround(Math_fround(f186 * f465) + Math_fround(f381 * Math_fround(Math_fround(f379 * f463) - Math_fround(f380 * f462))))) * Math_fround(2.0));
     f449 = Math_fround(Math_fround(Math_fround(f379 * f445) + Math_fround(Math_fround(f186 * f462) + Math_fround(f381 * Math_fround(Math_fround(f380 * f465) - Math_fround(f378 * f463))))) * Math_fround(2.0));
     f445 = Math_fround(Math_fround(Math_fround(Math_fround(f186 * f463) + Math_fround(f381 * Math_fround(Math_fround(f378 * f462) - Math_fround(f379 * f465)))) + Math_fround(f380 * f445)) * Math_fround(2.0));
     f465 = Math_fround(f342 + f453);
     f462 = Math_fround(f345 + f452);
     f463 = Math_fround(f348 + f451);
     f464 = Math_fround(f351 + f450);
     f430 = Math_fround(f343 + f446);
     f432 = Math_fround(f346 + f447);
     f434 = Math_fround(f349 + f448);
     f436 = Math_fround(f352 + f449);
     f102 = Math_fround(f344 + f442);
     f94 = Math_fround(f347 + f443);
     f90 = Math_fround(f350 + f444);
     f86 = Math_fround(f353 + f445);
     f95 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i11 * 12 | 0) >> 2]);
     f469 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i11 * 12 | 0) + 4 >> 2]);
     f104 = Math_fround(HEAPF32[i427 + 5264 + (i1 * 96 | 0) + 72 + (i11 * 12 | 0) + 8 >> 2]);
     f91 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i12 * 12 | 0) >> 2]);
     f92 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i12 * 12 | 0) + 4 >> 2]);
     f93 = Math_fround(HEAPF32[i427 + 5264 + (i2 * 96 | 0) + 72 + (i12 * 12 | 0) + 8 >> 2]);
     f87 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i13 * 12 | 0) >> 2]);
     f88 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i13 * 12 | 0) + 4 >> 2]);
     f89 = Math_fround(HEAPF32[i427 + 5264 + (i3 * 96 | 0) + 72 + (i13 * 12 | 0) + 8 >> 2]);
     f83 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i14 * 12 | 0) >> 2]);
     f84 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i14 * 12 | 0) + 4 >> 2]);
     f85 = Math_fround(HEAPF32[i427 + 5264 + (i4 * 96 | 0) + 72 + (i14 * 12 | 0) + 8 >> 2]);
     f429 = Math_fround(Math_fround(Math_fround(f382 * f95) + Math_fround(f383 * f469)) + Math_fround(f384 * f104));
     f431 = Math_fround(Math_fround(Math_fround(f386 * f91) + Math_fround(f387 * f92)) + Math_fround(f388 * f93));
     f433 = Math_fround(Math_fround(Math_fround(f390 * f87) + Math_fround(f391 * f88)) + Math_fround(f392 * f89));
     f435 = Math_fround(Math_fround(Math_fround(f394 * f83) + Math_fround(f395 * f84)) + Math_fround(f396 * f85));
     f465 = Math_fround(f465 - Math_fround(f354 + Math_fround(Math_fround(Math_fround(f382 * f429) + Math_fround(Math_fround(f187 * f95) + Math_fround(f385 * Math_fround(Math_fround(f383 * f104) - Math_fround(f384 * f469))))) * Math_fround(2.0))));
     f462 = Math_fround(f462 - Math_fround(f357 + Math_fround(Math_fround(Math_fround(f386 * f431) + Math_fround(Math_fround(f188 * f91) + Math_fround(f389 * Math_fround(Math_fround(f387 * f93) - Math_fround(f388 * f92))))) * Math_fround(2.0))));
     f463 = Math_fround(f463 - Math_fround(f360 + Math_fround(Math_fround(Math_fround(f390 * f433) + Math_fround(Math_fround(f189 * f87) + Math_fround(f393 * Math_fround(Math_fround(f391 * f89) - Math_fround(f392 * f88))))) * Math_fround(2.0))));
     f464 = Math_fround(f464 - Math_fround(f363 + Math_fround(Math_fround(Math_fround(f394 * f435) + Math_fround(Math_fround(f190 * f83) + Math_fround(f397 * Math_fround(Math_fround(f395 * f85) - Math_fround(f396 * f84))))) * Math_fround(2.0))));
     f430 = Math_fround(f430 - Math_fround(f355 + Math_fround(Math_fround(Math_fround(f383 * f429) + Math_fround(Math_fround(f187 * f469) + Math_fround(f385 * Math_fround(Math_fround(f384 * f95) - Math_fround(f382 * f104))))) * Math_fround(2.0))));
     f432 = Math_fround(f432 - Math_fround(f358 + Math_fround(Math_fround(Math_fround(f387 * f431) + Math_fround(Math_fround(f188 * f92) + Math_fround(f389 * Math_fround(Math_fround(f388 * f91) - Math_fround(f386 * f93))))) * Math_fround(2.0))));
     f434 = Math_fround(f434 - Math_fround(f361 + Math_fround(Math_fround(Math_fround(f391 * f433) + Math_fround(Math_fround(f189 * f88) + Math_fround(f393 * Math_fround(Math_fround(f392 * f87) - Math_fround(f390 * f89))))) * Math_fround(2.0))));
     f436 = Math_fround(f436 - Math_fround(f364 + Math_fround(Math_fround(Math_fround(f395 * f435) + Math_fround(Math_fround(f190 * f84) + Math_fround(f397 * Math_fround(Math_fround(f396 * f83) - Math_fround(f394 * f85))))) * Math_fround(2.0))));
     f429 = Math_fround(f102 - Math_fround(f356 + Math_fround(Math_fround(Math_fround(Math_fround(f187 * f104) + Math_fround(f385 * Math_fround(Math_fround(f382 * f469) - Math_fround(f383 * f95)))) + Math_fround(f384 * f429)) * Math_fround(2.0))));
     f431 = Math_fround(f94 - Math_fround(f359 + Math_fround(Math_fround(Math_fround(Math_fround(f188 * f93) + Math_fround(f389 * Math_fround(Math_fround(f386 * f92) - Math_fround(f387 * f91)))) + Math_fround(f388 * f431)) * Math_fround(2.0))));
     f433 = Math_fround(f90 - Math_fround(f362 + Math_fround(Math_fround(Math_fround(Math_fround(f189 * f89) + Math_fround(f393 * Math_fround(Math_fround(f390 * f88) - Math_fround(f391 * f87)))) + Math_fround(f392 * f433)) * Math_fround(2.0))));
     f435 = Math_fround(f86 - Math_fround(f365 + Math_fround(Math_fround(Math_fround(Math_fround(f190 * f85) + Math_fround(f397 * Math_fround(Math_fround(f394 * f84) - Math_fround(f395 * f83)))) + Math_fround(f396 * f435)) * Math_fround(2.0))));
     f83 = Math_fround(Math_fround(f45 * f446) - Math_fround(f50 * f442));
     f84 = Math_fround(Math_fround(f41 * f447) - Math_fround(f49 * f443));
     f85 = Math_fround(Math_fround(f40 * f448) - Math_fround(f48 * f444));
     f86 = Math_fround(Math_fround(f38 * f449) - Math_fround(f46 * f445));
     f87 = Math_fround(Math_fround(f51 * f442) - Math_fround(f45 * f453));
     f88 = Math_fround(Math_fround(f54 * f443) - Math_fround(f41 * f452));
     f89 = Math_fround(Math_fround(f53 * f444) - Math_fround(f40 * f451));
     f90 = Math_fround(Math_fround(f52 * f445) - Math_fround(f38 * f450));
     f91 = Math_fround(Math_fround(f50 * f453) - Math_fround(f51 * f446));
     f92 = Math_fround(Math_fround(f49 * f452) - Math_fround(f54 * f447));
     f93 = Math_fround(Math_fround(f48 * f451) - Math_fround(f53 * f448));
     f94 = Math_fround(Math_fround(f46 * f450) - Math_fround(f52 * f449));
     f95 = Math_fround(Math_fround(f277 * f91) + Math_fround(Math_fround(f273 * f87) + Math_fround(f269 * f83)));
     f469 = Math_fround(Math_fround(f278 * f92) + Math_fround(Math_fround(f274 * f88) + Math_fround(f270 * f84)));
     f104 = Math_fround(Math_fround(f279 * f93) + Math_fround(Math_fround(f275 * f89) + Math_fround(f271 * f85)));
     f102 = Math_fround(Math_fround(f280 * f94) + Math_fround(Math_fround(f276 * f90) + Math_fround(f272 * f86)));
     f468 = Math_fround(Math_fround(f289 * f91) + Math_fround(Math_fround(f285 * f87) + Math_fround(f281 * f83)));
     f103 = Math_fround(Math_fround(f290 * f92) + Math_fround(Math_fround(f286 * f88) + Math_fround(f282 * f84)));
     f98 = Math_fround(Math_fround(f291 * f93) + Math_fround(Math_fround(f287 * f89) + Math_fround(f283 * f85)));
     f467 = Math_fround(Math_fround(f292 * f94) + Math_fround(Math_fround(f288 * f90) + Math_fround(f284 * f86)));
     f473 = Math_fround(Math_fround(f301 * f91) + Math_fround(Math_fround(f297 * f87) + Math_fround(f293 * f83)));
     f472 = Math_fround(Math_fround(f302 * f92) + Math_fround(Math_fround(f298 * f88) + Math_fround(f294 * f84)));
     f471 = Math_fround(Math_fround(f303 * f93) + Math_fround(Math_fround(f299 * f89) + Math_fround(f295 * f85)));
     f470 = Math_fround(Math_fround(f304 * f94) + Math_fround(Math_fround(f300 * f90) + Math_fround(f296 * f86)));
     f440 = Math_fround(f257 + Math_fround(Math_fround(f91 * f473) + Math_fround(Math_fround(f87 * f468) + Math_fround(f83 * f95))));
     f439 = Math_fround(f258 + Math_fround(Math_fround(f92 * f472) + Math_fround(Math_fround(f88 * f103) + Math_fround(f84 * f469))));
     f438 = Math_fround(f259 + Math_fround(Math_fround(f93 * f471) + Math_fround(Math_fround(f89 * f98) + Math_fround(f85 * f104))));
     f437 = Math_fround(f260 + Math_fround(Math_fround(f94 * f470) + Math_fround(Math_fround(f90 * f467) + Math_fround(f86 * f102))));
     i441 = f440 > Math_fround(0.0);
     i125 = f439 > Math_fround(0.0);
     i124 = f438 > Math_fround(0.0);
     i123 = f437 > Math_fround(0.0);
     f440 = Math_fround(Math_fround(.800000011) / f440);
     f439 = Math_fround(Math_fround(.800000011) / f439);
     f438 = Math_fround(Math_fround(.800000011) / f438);
     f437 = Math_fround(Math_fround(.800000011) / f437);
     f440 = i441 ? f440 : Math_fround(0.0);
     f439 = i125 ? f439 : Math_fround(0.0);
     f438 = i124 ? f438 : Math_fround(0.0);
     f440 = Math_fround(f99 * f440);
     f439 = Math_fround(f96 * f439);
     f438 = Math_fround(f466 * f438);
     f437 = Math_fround(f97 * (i123 ? f437 : Math_fround(0.0)));
     f81 = Math_fround(HEAPF32[i112 >> 2]);
     f457 = Math_fround(HEAPF32[i113 >> 2]);
     f80 = Math_fround(HEAPF32[i114 >> 2]);
     f459 = Math_fround(HEAPF32[i109 >> 2]);
     f456 = Math_fround(HEAPF32[i110 >> 2]);
     f82 = Math_fround(HEAPF32[i111 >> 2]);
     f461 = Math_fround(HEAPF32[i106 >> 2]);
     f455 = Math_fround(HEAPF32[i107 >> 2]);
     f460 = Math_fround(HEAPF32[i108 >> 2]);
     f458 = Math_fround(HEAPF32[i47 >> 2]);
     f454 = Math_fround(HEAPF32[i100 >> 2]);
     f457 = Math_fround(Math_fround(f45 * f80) + Math_fround(Math_fround(f51 * f81) + Math_fround(f50 * f457)));
     f456 = Math_fround(Math_fround(f41 * f82) + Math_fround(Math_fround(f54 * f459) + Math_fround(f49 * f456)));
     f455 = Math_fround(Math_fround(f40 * f460) + Math_fround(Math_fround(f53 * f461) + Math_fround(f48 * f455)));
     f454 = Math_fround(Math_fround(f38 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f52 * f458) + Math_fround(f46 * f454)));
     f458 = Math_fround(Math_fround(Math_fround(f45 * f429) + Math_fround(Math_fround(f50 * f430) + Math_fround(f51 * f465))) * f426);
     f461 = Math_fround(Math_fround(Math_fround(f41 * f431) + Math_fround(Math_fround(f49 * f432) + Math_fround(f54 * f462))) * f426);
     f460 = Math_fround(Math_fround(Math_fround(f40 * f433) + Math_fround(Math_fround(f48 * f434) + Math_fround(f53 * f463))) * f426);
     f459 = Math_fround(Math_fround(Math_fround(f38 * f435) + Math_fround(Math_fround(f46 * f436) + Math_fround(f52 * f464))) * f426);
     HEAPF32[i10 >> 2] = f83;
     HEAPF32[i10 + 4 >> 2] = f84;
     HEAPF32[i10 + 8 >> 2] = f85;
     HEAPF32[i10 + 12 >> 2] = f86;
     HEAPF32[i10 + 16 >> 2] = f87;
     HEAPF32[i10 + 20 >> 2] = f88;
     HEAPF32[i10 + 24 >> 2] = f89;
     HEAPF32[i10 + 28 >> 2] = f90;
     HEAPF32[i10 + 32 >> 2] = f91;
     HEAPF32[i10 + 36 >> 2] = f92;
     HEAPF32[i10 + 40 >> 2] = f93;
     HEAPF32[i10 + 44 >> 2] = f94;
     HEAPF32[i10 + 48 >> 2] = f95;
     HEAPF32[i10 + 52 >> 2] = f469;
     HEAPF32[i10 + 56 >> 2] = f104;
     HEAPF32[i10 + 60 >> 2] = f102;
     HEAPF32[i10 + 64 >> 2] = f468;
     HEAPF32[i10 + 68 >> 2] = f103;
     HEAPF32[i10 + 72 >> 2] = f98;
     HEAPF32[i10 + 76 >> 2] = f467;
     HEAPF32[i10 + 80 >> 2] = f473;
     HEAPF32[i10 + 84 >> 2] = f472;
     HEAPF32[i10 + 88 >> 2] = f471;
     HEAPF32[i10 + 92 >> 2] = f470;
     f456 = Math_fround(f439 * Math_fround(f461 - f456));
     f455 = Math_fround(f438 * Math_fround(f460 - f455));
     f454 = Math_fround(f437 * Math_fround(f459 - f454));
     HEAPF32[i10 + 96 >> 2] = Math_fround(f440 * Math_fround(f458 - f457));
     HEAPF32[i10 + 100 >> 2] = f456;
     HEAPF32[i10 + 104 >> 2] = f455;
     HEAPF32[i10 + 108 >> 2] = f454;
     HEAPF32[i10 + 112 >> 2] = f440;
     HEAPF32[i10 + 116 >> 2] = f439;
     HEAPF32[i10 + 120 >> 2] = f438;
     HEAPF32[i10 + 124 >> 2] = f437;
     f437 = Math_fround(Math_fround(f24 * f446) - Math_fround(f28 * f442));
     f438 = Math_fround(Math_fround(f23 * f447) - Math_fround(f27 * f443));
     f439 = Math_fround(Math_fround(f21 * f448) - Math_fround(f26 * f444));
     f440 = Math_fround(Math_fround(f20 * f449) - Math_fround(f25 * f445));
     f442 = Math_fround(Math_fround(f36 * f442) - Math_fround(f24 * f453));
     f443 = Math_fround(Math_fround(f34 * f443) - Math_fround(f23 * f452));
     f444 = Math_fround(Math_fround(f32 * f444) - Math_fround(f21 * f451));
     f445 = Math_fround(Math_fround(f30 * f445) - Math_fround(f20 * f450));
     f446 = Math_fround(Math_fround(f28 * f453) - Math_fround(f36 * f446));
     f447 = Math_fround(Math_fround(f27 * f452) - Math_fround(f34 * f447));
     f448 = Math_fround(Math_fround(f26 * f451) - Math_fround(f32 * f448));
     f449 = Math_fround(Math_fround(f25 * f450) - Math_fround(f30 * f449));
     f450 = Math_fround(Math_fround(f277 * f446) + Math_fround(Math_fround(f273 * f442) + Math_fround(f269 * f437)));
     f451 = Math_fround(Math_fround(f278 * f447) + Math_fround(Math_fround(f274 * f443) + Math_fround(f270 * f438)));
     f452 = Math_fround(Math_fround(f279 * f448) + Math_fround(Math_fround(f275 * f444) + Math_fround(f271 * f439)));
     f453 = Math_fround(Math_fround(f280 * f449) + Math_fround(Math_fround(f276 * f445) + Math_fround(f272 * f440)));
     f454 = Math_fround(Math_fround(f289 * f446) + Math_fround(Math_fround(f285 * f442) + Math_fround(f281 * f437)));
     f455 = Math_fround(Math_fround(f290 * f447) + Math_fround(Math_fround(f286 * f443) + Math_fround(f282 * f438)));
     f456 = Math_fround(Math_fround(f291 * f448) + Math_fround(Math_fround(f287 * f444) + Math_fround(f283 * f439)));
     f457 = Math_fround(Math_fround(f292 * f449) + Math_fround(Math_fround(f288 * f445) + Math_fround(f284 * f440)));
     f458 = Math_fround(Math_fround(f301 * f446) + Math_fround(Math_fround(f297 * f442) + Math_fround(f293 * f437)));
     f459 = Math_fround(Math_fround(f302 * f447) + Math_fround(Math_fround(f298 * f443) + Math_fround(f294 * f438)));
     f460 = Math_fround(Math_fround(f303 * f448) + Math_fround(Math_fround(f299 * f444) + Math_fround(f295 * f439)));
     f461 = Math_fround(Math_fround(f304 * f449) + Math_fround(Math_fround(f300 * f445) + Math_fround(f296 * f440)));
     f470 = Math_fround(f257 + Math_fround(Math_fround(f446 * f458) + Math_fround(Math_fround(f442 * f454) + Math_fround(f437 * f450))));
     f471 = Math_fround(f258 + Math_fround(Math_fround(f447 * f459) + Math_fround(Math_fround(f443 * f455) + Math_fround(f438 * f451))));
     f472 = Math_fround(f259 + Math_fround(Math_fround(f448 * f460) + Math_fround(Math_fround(f444 * f456) + Math_fround(f439 * f452))));
     f473 = Math_fround(f260 + Math_fround(Math_fround(f449 * f461) + Math_fround(Math_fround(f445 * f457) + Math_fround(f440 * f453))));
     i123 = f470 > Math_fround(0.0);
     i124 = f471 > Math_fround(0.0);
     i125 = f472 > Math_fround(0.0);
     i441 = f473 > Math_fround(0.0);
     f470 = Math_fround(Math_fround(.800000011) / f470);
     f471 = Math_fround(Math_fround(.800000011) / f471);
     f472 = Math_fround(Math_fround(.800000011) / f472);
     f473 = Math_fround(Math_fround(.800000011) / f473);
     f470 = i123 ? f470 : Math_fround(0.0);
     f471 = i124 ? f471 : Math_fround(0.0);
     f472 = i125 ? f472 : Math_fround(0.0);
     f470 = Math_fround(f99 * f470);
     f471 = Math_fround(f96 * f471);
     f472 = Math_fround(f466 * f472);
     f473 = Math_fround(f97 * (i441 ? f473 : Math_fround(0.0)));
     f97 = Math_fround(HEAPF32[i112 >> 2]);
     f466 = Math_fround(HEAPF32[i113 >> 2]);
     f96 = Math_fround(HEAPF32[i114 >> 2]);
     f99 = Math_fround(HEAPF32[i109 >> 2]);
     f467 = Math_fround(HEAPF32[i110 >> 2]);
     f98 = Math_fround(HEAPF32[i111 >> 2]);
     f103 = Math_fround(HEAPF32[i106 >> 2]);
     f468 = Math_fround(HEAPF32[i107 >> 2]);
     f102 = Math_fround(HEAPF32[i108 >> 2]);
     f104 = Math_fround(HEAPF32[i47 >> 2]);
     f469 = Math_fround(HEAPF32[i100 >> 2]);
     f466 = Math_fround(Math_fround(f24 * f96) + Math_fround(Math_fround(f36 * f97) + Math_fround(f28 * f466)));
     f467 = Math_fround(Math_fround(f23 * f98) + Math_fround(Math_fround(f34 * f99) + Math_fround(f27 * f467)));
     f468 = Math_fround(Math_fround(f21 * f102) + Math_fround(Math_fround(f32 * f103) + Math_fround(f26 * f468)));
     f469 = Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i101 >> 2])) + Math_fround(Math_fround(f30 * f104) + Math_fround(f25 * f469)));
     f465 = Math_fround(Math_fround(Math_fround(f24 * f429) + Math_fround(Math_fround(f28 * f430) + Math_fround(f36 * f465))) * f426);
     f462 = Math_fround(Math_fround(Math_fround(f23 * f431) + Math_fround(Math_fround(f27 * f432) + Math_fround(f34 * f462))) * f426);
     f463 = Math_fround(Math_fround(Math_fround(f21 * f433) + Math_fround(Math_fround(f26 * f434) + Math_fround(f32 * f463))) * f426);
     f464 = Math_fround(Math_fround(Math_fround(f20 * f435) + Math_fround(Math_fround(f25 * f436) + Math_fround(f30 * f464))) * f426);
     HEAPF32[i10 + i413 >> 2] = f437;
     HEAPF32[i10 + i140 >> 2] = f438;
     HEAPF32[i10 + i141 >> 2] = f439;
     HEAPF32[i10 + i142 >> 2] = f440;
     HEAPF32[i10 + i127 >> 2] = f442;
     HEAPF32[i10 + i143 >> 2] = f443;
     HEAPF32[i10 + i144 >> 2] = f444;
     HEAPF32[i10 + i145 >> 2] = f445;
     HEAPF32[i10 + i128 >> 2] = f446;
     HEAPF32[i10 + i146 >> 2] = f447;
     HEAPF32[i10 + i147 >> 2] = f448;
     HEAPF32[i10 + i148 >> 2] = f449;
     HEAPF32[i10 + i129 >> 2] = f450;
     HEAPF32[i10 + i149 >> 2] = f451;
     HEAPF32[i10 + i150 >> 2] = f452;
     HEAPF32[i10 + i151 >> 2] = f453;
     HEAPF32[i10 + i130 >> 2] = f454;
     HEAPF32[i10 + i152 >> 2] = f455;
     HEAPF32[i10 + i153 >> 2] = f456;
     HEAPF32[i10 + i154 >> 2] = f457;
     HEAPF32[i10 + i131 >> 2] = f458;
     HEAPF32[i10 + i155 >> 2] = f459;
     HEAPF32[i10 + i156 >> 2] = f460;
     HEAPF32[i10 + i157 >> 2] = f461;
     f467 = Math_fround(f471 * Math_fround(f462 - f467));
     f468 = Math_fround(f472 * Math_fround(f463 - f468));
     f469 = Math_fround(f473 * Math_fround(f464 - f469));
     HEAPF32[i10 + i132 >> 2] = Math_fround(f470 * Math_fround(f465 - f466));
     HEAPF32[i10 + i158 >> 2] = f467;
     HEAPF32[i10 + i159 >> 2] = f468;
     HEAPF32[i10 + i160 >> 2] = f469;
     HEAPF32[i10 + i133 >> 2] = f470;
     HEAPF32[i10 + i161 >> 2] = f471;
     HEAPF32[i10 + i162 >> 2] = f472;
     HEAPF32[i10 + i163 >> 2] = f473;
     i15 = i15 + 1 | 0;
     if (i15 >>> 0 >= i119 >>> 0) break; else i10 = i10 + i126 | 0;
    }
   }
   i13 = i105 + 128 | 0;
   i6 = i6 + 1 | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
   i9 = i9 + 1 | 0;
   i13 = i421 ? i120 + (i13 + (i119 << 5)) | 0 : i120 + i13 | 0;
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i402 >>> 0);
 STACKTOP = i428;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i641, i646) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i641 = i641 | 0;
 i646 = i646 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, i564 = 0, i565 = 0, i566 = 0, i567 = 0, i568 = 0, i569 = 0, i570 = 0, i571 = 0, i572 = 0, i573 = 0, i574 = 0, i575 = 0, i576 = 0, i577 = 0, i578 = 0, i579 = 0, i580 = 0, i581 = 0, i582 = 0, i583 = 0, f584 = f0, f585 = f0, f586 = f0, f587 = f0, f588 = f0, f589 = f0, f590 = f0, f591 = f0, f592 = f0, f593 = f0, f594 = f0, f595 = f0, f596 = f0, f597 = f0, f598 = f0, f599 = f0, f600 = f0, f601 = f0, i602 = 0, i603 = 0, i604 = 0, i605 = 0, i606 = 0, i607 = 0, f608 = f0, f609 = f0, f610 = f0, f611 = f0, f612 = f0, f613 = f0, f614 = f0, f615 = f0, f616 = f0, f617 = f0, i618 = 0, i619 = 0, i620 = 0, i621 = 0, i622 = 0, i623 = 0, i624 = 0, i625 = 0, i626 = 0, i627 = 0, i628 = 0, i629 = 0, i630 = 0, i631 = 0, i632 = 0, i633 = 0, i634 = 0, f635 = f0, f636 = f0, f637 = f0, f638 = f0, f639 = f0, f640 = f0, f642 = f0, f643 = f0, f644 = f0, f645 = f0, f647 = f0, i648 = 0, i649 = 0, i650 = 0, i651 = 0, f652 = f0, f653 = f0, f654 = f0, f655 = f0, f656 = f0, f657 = f0, f658 = f0, f659 = f0, f660 = f0, f661 = f0, f662 = f0, f663 = f0, f664 = f0, f665 = f0, f666 = f0, f667 = f0, f668 = f0, f669 = f0, f670 = f0, f671 = f0, f672 = f0, f673 = f0, f674 = f0, f675 = f0, f676 = f0, f677 = f0, f678 = f0, f679 = f0, f680 = f0, f681 = f0, f682 = f0, f683 = f0, f684 = f0, f685 = f0, f686 = f0, f687 = f0, f688 = f0, f689 = f0, f690 = f0, f691 = f0, f692 = f0, f693 = f0, f694 = f0, f695 = f0, f696 = f0, f697 = f0, f698 = f0, f699 = f0, f700 = f0, i701 = 0;
 i651 = STACKTOP;
 STACKTOP = STACKTOP + 1632 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i648 = i651 + 1560 | 0;
 i649 = i651 + 1432 | 0;
 i650 = i651 + 1176 | 0;
 i6 = i651 + 1112 | 0;
 i4 = i651 + 1072 | 0;
 i618 = i651 + 1056 | 0;
 i619 = i651 + 1008 | 0;
 i620 = i651 + 960 | 0;
 i621 = i651 + 912 | 0;
 i622 = i651 + 896 | 0;
 i623 = i651 + 880 | 0;
 i624 = i651 + 864 | 0;
 i625 = i651 + 848 | 0;
 i626 = i651 + 832 | 0;
 i627 = i651 + 640 | 0;
 i628 = i651 + 592 | 0;
 i629 = i651 + 400 | 0;
 i630 = i651 + 256 | 0;
 i631 = i651 + 112 | 0;
 i632 = i651 + 64 | 0;
 i633 = i651;
 i634 = i3 + 332 | 0;
 f635 = Math_fround((HEAP32[i634 >> 2] & 4095) >>> 0);
 f636 = Math_fround(Math_fround(1.0) / f635);
 f637 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f638 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f639 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f640 = Math_fround(Math_fround(1.0) - f639);
 i5 = i3 + 420 | 0;
 f642 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f616 = Math_fround(HEAPF32[i2 >> 2]);
 f610 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f612 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f643 = Math_fround(HEAPF32[i2 >> 2]);
 f644 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f645 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f647 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f615 = Math_fround(HEAPF32[i2 >> 2]);
 f609 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f614 = Math_fround(HEAPF32[i2 >> 2]);
 f608 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 36 | 0;
 f617 = Math_fround(HEAPF32[i7 >> 2]);
 f611 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f613 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f584 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f585 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f586 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f587 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f588 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f589 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f590 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f591 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f592 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f593 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f594 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f595 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 f596 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f597 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f598 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f599 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f600 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f601 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 i602 = i648 + 12 | 0;
 i603 = i648 + 8 | 0;
 i604 = i648 + 4 | 0;
 i605 = i648 + 28 | 0;
 HEAP32[i648 >> 2] = 0;
 HEAP32[i648 + 4 >> 2] = 0;
 HEAP32[i648 + 8 >> 2] = 0;
 HEAP32[i648 + 12 >> 2] = 0;
 HEAP32[i605 >> 2] = 1;
 i606 = i648 + 24 | 0;
 HEAP32[i606 >> 2] = 1;
 i607 = i648 + 20 | 0;
 HEAP32[i607 >> 2] = 1;
 i575 = i648 + 16 | 0;
 HEAP32[i575 >> 2] = 1;
 i576 = i648 + 44 | 0;
 HEAP32[i576 >> 2] = 2;
 i577 = i648 + 40 | 0;
 HEAP32[i577 >> 2] = 2;
 i578 = i648 + 36 | 0;
 HEAP32[i578 >> 2] = 2;
 i579 = i648 + 32 | 0;
 HEAP32[i579 >> 2] = 2;
 i580 = i648 + 60 | 0;
 HEAP32[i580 >> 2] = 3;
 i581 = i648 + 56 | 0;
 HEAP32[i581 >> 2] = 3;
 i582 = i648 + 52 | 0;
 HEAP32[i582 >> 2] = 3;
 i583 = i648 + 48 | 0;
 HEAP32[i583 >> 2] = 3;
 i526 = i649 + 4 | 0;
 i550 = i649 + 8 | 0;
 i574 = i649 + 12 | 0;
 i502 = i649 + 16 | 0;
 HEAP32[i649 >> 2] = 0;
 HEAP32[i649 + 4 >> 2] = 0;
 HEAP32[i649 + 8 >> 2] = 0;
 HEAP32[i649 + 12 >> 2] = 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i525 = i649 + 20 | 0;
 HEAPF32[i525 >> 2] = Math_fround(1.0);
 i549 = i649 + 24 | 0;
 HEAPF32[i549 >> 2] = Math_fround(1.0);
 i573 = i649 + 28 | 0;
 HEAPF32[i573 >> 2] = Math_fround(1.0);
 i501 = i649 + 32 | 0;
 HEAPF32[i501 >> 2] = Math_fround(1.0);
 i524 = i649 + 36 | 0;
 HEAPF32[i524 >> 2] = Math_fround(1.0);
 i548 = i649 + 40 | 0;
 HEAPF32[i548 >> 2] = Math_fround(1.0);
 i572 = i649 + 44 | 0;
 HEAPF32[i572 >> 2] = Math_fround(1.0);
 i500 = i649 + 48 | 0;
 HEAPF32[i500 >> 2] = Math_fround(1.0);
 i523 = i649 + 52 | 0;
 HEAPF32[i523 >> 2] = Math_fround(1.0);
 i547 = i649 + 56 | 0;
 HEAPF32[i547 >> 2] = Math_fround(1.0);
 i571 = i649 + 60 | 0;
 HEAPF32[i571 >> 2] = Math_fround(1.0);
 i499 = i649 + 64 | 0;
 HEAPF32[i499 >> 2] = Math_fround(1.0);
 i522 = i649 + 68 | 0;
 HEAPF32[i522 >> 2] = Math_fround(1.0);
 i546 = i649 + 72 | 0;
 HEAPF32[i546 >> 2] = Math_fround(1.0);
 i570 = i649 + 76 | 0;
 HEAPF32[i570 >> 2] = Math_fround(1.0);
 i498 = i649 + 80 | 0;
 i521 = i649 + 84 | 0;
 i545 = i649 + 88 | 0;
 i569 = i649 + 92 | 0;
 i497 = i649 + 96 | 0;
 i520 = i649 + 100 | 0;
 i544 = i649 + 104 | 0;
 i568 = i649 + 108 | 0;
 i496 = i649 + 112 | 0;
 i519 = i649 + 116 | 0;
 i543 = i649 + 120 | 0;
 i567 = i649 + 124 | 0;
 i10 = i498;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i518 = i650 + 4 | 0;
 i542 = i650 + 8 | 0;
 i566 = i650 + 12 | 0;
 i495 = i650 + 16 | 0;
 HEAP32[i650 >> 2] = 0;
 HEAP32[i650 + 4 >> 2] = 0;
 HEAP32[i650 + 8 >> 2] = 0;
 HEAP32[i650 + 12 >> 2] = 0;
 HEAPF32[i495 >> 2] = Math_fround(1.0);
 i517 = i650 + 20 | 0;
 HEAPF32[i517 >> 2] = Math_fround(1.0);
 i541 = i650 + 24 | 0;
 HEAPF32[i541 >> 2] = Math_fround(1.0);
 i565 = i650 + 28 | 0;
 HEAPF32[i565 >> 2] = Math_fround(1.0);
 i494 = i650 + 32 | 0;
 i516 = i650 + 36 | 0;
 i540 = i650 + 40 | 0;
 i564 = i650 + 44 | 0;
 i493 = i650 + 48 | 0;
 i515 = i650 + 52 | 0;
 i539 = i650 + 56 | 0;
 i563 = i650 + 60 | 0;
 i492 = i650 + 64 | 0;
 HEAP32[i494 >> 2] = 0;
 HEAP32[i494 + 4 >> 2] = 0;
 HEAP32[i494 + 8 >> 2] = 0;
 HEAP32[i494 + 12 >> 2] = 0;
 HEAP32[i494 + 16 >> 2] = 0;
 HEAP32[i494 + 20 >> 2] = 0;
 HEAP32[i494 + 24 >> 2] = 0;
 HEAP32[i494 + 28 >> 2] = 0;
 HEAPF32[i492 >> 2] = Math_fround(1.0);
 i514 = i650 + 68 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i650 + 72 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i650 + 76 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i491 = i650 + 80 | 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i513 = i650 + 84 | 0;
 HEAPF32[i513 >> 2] = Math_fround(1.0);
 i537 = i650 + 88 | 0;
 HEAPF32[i537 >> 2] = Math_fround(1.0);
 i561 = i650 + 92 | 0;
 HEAPF32[i561 >> 2] = Math_fround(1.0);
 i490 = i650 + 96 | 0;
 i512 = i650 + 100 | 0;
 i536 = i650 + 104 | 0;
 i560 = i650 + 108 | 0;
 i489 = i650 + 112 | 0;
 i511 = i650 + 116 | 0;
 i535 = i650 + 120 | 0;
 i559 = i650 + 124 | 0;
 i488 = i650 + 128 | 0;
 HEAP32[i490 >> 2] = 0;
 HEAP32[i490 + 4 >> 2] = 0;
 HEAP32[i490 + 8 >> 2] = 0;
 HEAP32[i490 + 12 >> 2] = 0;
 HEAP32[i490 + 16 >> 2] = 0;
 HEAP32[i490 + 20 >> 2] = 0;
 HEAP32[i490 + 24 >> 2] = 0;
 HEAP32[i490 + 28 >> 2] = 0;
 HEAPF32[i488 >> 2] = Math_fround(1.0);
 i510 = i650 + 132 | 0;
 HEAPF32[i510 >> 2] = Math_fround(1.0);
 i534 = i650 + 136 | 0;
 HEAPF32[i534 >> 2] = Math_fround(1.0);
 i558 = i650 + 140 | 0;
 HEAPF32[i558 >> 2] = Math_fround(1.0);
 i487 = i650 + 144 | 0;
 i509 = i650 + 148 | 0;
 i533 = i650 + 152 | 0;
 i557 = i650 + 156 | 0;
 i486 = i650 + 160 | 0;
 i508 = i650 + 164 | 0;
 i532 = i650 + 168 | 0;
 i556 = i650 + 172 | 0;
 i485 = i650 + 176 | 0;
 i507 = i650 + 180 | 0;
 i531 = i650 + 184 | 0;
 i555 = i650 + 188 | 0;
 i484 = i650 + 192 | 0;
 i506 = i650 + 196 | 0;
 i530 = i650 + 200 | 0;
 i554 = i650 + 204 | 0;
 i483 = i650 + 208 | 0;
 i505 = i650 + 212 | 0;
 i529 = i650 + 216 | 0;
 i553 = i650 + 220 | 0;
 i482 = i650 + 224 | 0;
 i504 = i650 + 228 | 0;
 i528 = i650 + 232 | 0;
 i552 = i650 + 236 | 0;
 i481 = i650 + 240 | 0;
 i503 = i650 + 244 | 0;
 i527 = i650 + 248 | 0;
 i551 = i650 + 252 | 0;
 i10 = i487;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f73 = Math_fround(HEAPF32[i5 >> 2]);
 f55 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f72 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f74 = Math_fround(HEAPF32[i4 >> 2]);
 i475 = i4 + 4 | 0;
 f77 = Math_fround(HEAPF32[i475 >> 2]);
 i476 = i4 + 8 | 0;
 f78 = Math_fround(HEAPF32[i476 >> 2]);
 i477 = i4 + 12 | 0;
 f58 = Math_fround(HEAPF32[i477 >> 2]);
 i478 = i4 + 16 | 0;
 f54 = Math_fround(HEAPF32[i478 >> 2]);
 i479 = i4 + 20 | 0;
 f81 = Math_fround(HEAPF32[i479 >> 2]);
 i480 = i4 + 24 | 0;
 f60 = Math_fround(HEAPF32[i480 >> 2]);
 i186 = i4 + 28 | 0;
 f56 = Math_fround(HEAPF32[i186 >> 2]);
 i185 = i4 + 32 | 0;
 f84 = Math_fround(HEAPF32[i185 >> 2]);
 f75 = Math_fround(f77 * Math_fround(0.0));
 f76 = Math_fround(f78 * Math_fround(0.0));
 f59 = Math_fround(f54 * Math_fround(0.0));
 f80 = Math_fround(f81 * Math_fround(0.0));
 f79 = Math_fround(Math_fround(Math_fround(f73 * f58) + f59) + f80);
 f61 = Math_fround(f56 * Math_fround(0.0));
 f83 = Math_fround(f84 * Math_fround(0.0));
 f82 = Math_fround(Math_fround(Math_fround(f73 * f60) + f61) + f83);
 f57 = Math_fround(f74 * Math_fround(0.0));
 f77 = Math_fround(Math_fround(f57 + Math_fround(f55 * f77)) + f76);
 f58 = Math_fround(f58 * Math_fround(0.0));
 f80 = Math_fround(Math_fround(f58 + Math_fround(f55 * f54)) + f80);
 f60 = Math_fround(f60 * Math_fround(0.0));
 f83 = Math_fround(Math_fround(f60 + Math_fround(f55 * f56)) + f83);
 f78 = Math_fround(Math_fround(f57 + f75) + Math_fround(f72 * f78));
 f81 = Math_fround(Math_fround(f58 + f59) + Math_fround(f72 * f81));
 f84 = Math_fround(Math_fround(f60 + f61) + Math_fround(f72 * f84));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f73 * f74) + f75) + f76);
 HEAPF32[i475 >> 2] = f77;
 HEAPF32[i476 >> 2] = f78;
 HEAPF32[i477 >> 2] = f79;
 HEAPF32[i478 >> 2] = f80;
 HEAPF32[i479 >> 2] = f81;
 HEAPF32[i480 >> 2] = f82;
 HEAPF32[i186 >> 2] = f83;
 HEAPF32[i185 >> 2] = f84;
 i185 = (i7 | 0) == 27;
 HEAP32[i618 >> 2] = 0;
 HEAP32[i618 + 4 >> 2] = 0;
 HEAP32[i618 + 8 >> 2] = 0;
 HEAP32[i618 + 12 >> 2] = 0;
 i186 = HEAP32[i641 + 12 >> 2] | 0;
 if (!i186) {
  STACKTOP = i651;
  return;
 }
 i187 = i619 + 12 | 0;
 i188 = i619 + 8 | 0;
 i189 = i619 + 4 | 0;
 i190 = i619 + 16 | 0;
 i191 = i619 + 28 | 0;
 i192 = i619 + 24 | 0;
 i193 = i619 + 20 | 0;
 i194 = i619 + 32 | 0;
 i195 = i619 + 44 | 0;
 i196 = i619 + 40 | 0;
 i197 = i619 + 36 | 0;
 i198 = i620 + 12 | 0;
 i199 = i620 + 8 | 0;
 i200 = i620 + 4 | 0;
 i201 = i620 + 16 | 0;
 i202 = i620 + 28 | 0;
 i203 = i620 + 24 | 0;
 i204 = i620 + 20 | 0;
 i205 = i620 + 32 | 0;
 i206 = i620 + 44 | 0;
 i207 = i620 + 40 | 0;
 i208 = i620 + 36 | 0;
 i209 = i621 + 12 | 0;
 i210 = i621 + 8 | 0;
 i211 = i621 + 4 | 0;
 i212 = i621 + 28 | 0;
 i213 = i621 + 24 | 0;
 i214 = i621 + 20 | 0;
 i215 = i621 + 44 | 0;
 i216 = i621 + 40 | 0;
 i217 = i621 + 36 | 0;
 i218 = i646 + 20 | 0;
 i219 = i641 + 20 | 0;
 i220 = i641 + 40 | 0;
 i221 = i641 + 300 | 0;
 i222 = i641 + 320 | 0;
 i223 = i641 + 340 | 0;
 i224 = i641 + 60 | 0;
 i225 = i641 + 80 | 0;
 i226 = i641 + 100 | 0;
 i227 = i641 + 120 | 0;
 i228 = i641 + 140 | 0;
 i229 = i641 + 160 | 0;
 i230 = i621 + 16 | 0;
 i231 = i621 + 32 | 0;
 i232 = i646 + 4 | 0;
 i233 = i622 + 4 | 0;
 i234 = i622 + 8 | 0;
 i235 = i622 + 12 | 0;
 i236 = i646 + 8 | 0;
 i237 = i623 + 4 | 0;
 i238 = i623 + 8 | 0;
 i239 = i623 + 12 | 0;
 i240 = i641 + 520 | 0;
 i241 = i624 + 4 | 0;
 i242 = i624 + 8 | 0;
 i243 = i624 + 12 | 0;
 i244 = i641 + 500 | 0;
 i245 = i625 + 4 | 0;
 i246 = i625 + 8 | 0;
 i247 = i625 + 12 | 0;
 i248 = i646 + 16 | 0;
 i249 = i626 + 4 | 0;
 i250 = i626 + 8 | 0;
 i251 = i626 + 12 | 0;
 i252 = i619 + 16 | 0;
 i253 = i619 + 32 | 0;
 i254 = i628 + 4 | 0;
 i255 = i628 + 8 | 0;
 i256 = i628 + 12 | 0;
 i257 = i628 + 16 | 0;
 i258 = i628 + 20 | 0;
 i259 = i628 + 24 | 0;
 i260 = i628 + 28 | 0;
 i261 = i628 + 32 | 0;
 i262 = i628 + 36 | 0;
 i263 = i628 + 40 | 0;
 i264 = i628 + 44 | 0;
 i265 = i629 + 96 | 0;
 i266 = i629 + 100 | 0;
 i267 = i629 + 104 | 0;
 i268 = i629 + 108 | 0;
 i269 = i629 + 112 | 0;
 i270 = i629 + 116 | 0;
 i271 = i629 + 120 | 0;
 i272 = i629 + 124 | 0;
 i273 = i629 + 128 | 0;
 i274 = i629 + 132 | 0;
 i275 = i629 + 136 | 0;
 i276 = i629 + 140 | 0;
 i277 = i629 + 128 | 0;
 i278 = i629 + 112 | 0;
 i279 = i629 + 4 | 0;
 i280 = i629 + 8 | 0;
 i281 = i629 + 12 | 0;
 i282 = i629 + 16 | 0;
 i283 = i629 + 20 | 0;
 i284 = i629 + 24 | 0;
 i285 = i629 + 28 | 0;
 i286 = i629 + 32 | 0;
 i287 = i629 + 36 | 0;
 i288 = i629 + 40 | 0;
 i289 = i629 + 44 | 0;
 i290 = i629 + 16 | 0;
 i291 = i629 + 32 | 0;
 i292 = i629 + 48 | 0;
 i293 = i629 + 52 | 0;
 i294 = i629 + 56 | 0;
 i295 = i629 + 60 | 0;
 i296 = i629 + 64 | 0;
 i297 = i629 + 68 | 0;
 i298 = i629 + 72 | 0;
 i299 = i629 + 76 | 0;
 i300 = i629 + 80 | 0;
 i301 = i629 + 84 | 0;
 i302 = i629 + 88 | 0;
 i303 = i629 + 92 | 0;
 i304 = i620 + 16 | 0;
 i305 = i620 + 32 | 0;
 i306 = i630 + 4 | 0;
 i307 = i630 + 8 | 0;
 i308 = i630 + 12 | 0;
 i309 = i630 + 48 | 0;
 i310 = i630 + 52 | 0;
 i311 = i630 + 56 | 0;
 i312 = i630 + 60 | 0;
 i313 = i630 + 96 | 0;
 i314 = i630 + 100 | 0;
 i315 = i630 + 104 | 0;
 i316 = i630 + 108 | 0;
 i317 = i630 + 16 | 0;
 i318 = i630 + 20 | 0;
 i319 = i630 + 24 | 0;
 i320 = i630 + 28 | 0;
 i321 = i630 + 64 | 0;
 i322 = i630 + 68 | 0;
 i323 = i630 + 72 | 0;
 i324 = i630 + 76 | 0;
 i325 = i630 + 112 | 0;
 i326 = i630 + 116 | 0;
 i327 = i630 + 120 | 0;
 i328 = i630 + 124 | 0;
 i329 = i630 + 32 | 0;
 i330 = i630 + 36 | 0;
 i331 = i630 + 40 | 0;
 i332 = i630 + 44 | 0;
 i333 = i630 + 80 | 0;
 i334 = i630 + 84 | 0;
 i335 = i630 + 88 | 0;
 i336 = i630 + 92 | 0;
 i337 = i630 + 128 | 0;
 i338 = i630 + 132 | 0;
 i339 = i630 + 136 | 0;
 i340 = i630 + 140 | 0;
 i341 = i629 + 96 | 0;
 i342 = i631 + 4 | 0;
 i343 = i631 + 8 | 0;
 i344 = i631 + 12 | 0;
 i345 = i631 + 48 | 0;
 i346 = i631 + 52 | 0;
 i347 = i631 + 56 | 0;
 i348 = i631 + 60 | 0;
 i349 = i631 + 96 | 0;
 i350 = i631 + 100 | 0;
 i351 = i631 + 104 | 0;
 i352 = i631 + 108 | 0;
 i353 = i631 + 16 | 0;
 i354 = i631 + 20 | 0;
 i355 = i631 + 24 | 0;
 i356 = i631 + 28 | 0;
 i357 = i631 + 64 | 0;
 i358 = i631 + 68 | 0;
 i359 = i631 + 72 | 0;
 i360 = i631 + 76 | 0;
 i361 = i631 + 112 | 0;
 i362 = i631 + 116 | 0;
 i363 = i631 + 120 | 0;
 i364 = i631 + 124 | 0;
 i365 = i631 + 32 | 0;
 i366 = i631 + 36 | 0;
 i367 = i631 + 40 | 0;
 i368 = i631 + 44 | 0;
 i369 = i631 + 80 | 0;
 i370 = i631 + 84 | 0;
 i371 = i631 + 88 | 0;
 i372 = i631 + 92 | 0;
 i373 = i631 + 128 | 0;
 i374 = i631 + 132 | 0;
 i375 = i631 + 136 | 0;
 i376 = i631 + 140 | 0;
 i377 = i627 + 4 | 0;
 i378 = i627 + 8 | 0;
 i379 = i627 + 12 | 0;
 i380 = i627 + 16 | 0;
 i381 = i627 + 20 | 0;
 i382 = i627 + 24 | 0;
 i383 = i627 + 28 | 0;
 i384 = i627 + 32 | 0;
 i385 = i627 + 36 | 0;
 i386 = i627 + 40 | 0;
 i387 = i627 + 44 | 0;
 i388 = i627 + 48 | 0;
 i389 = i627 + 52 | 0;
 i390 = i627 + 56 | 0;
 i391 = i627 + 60 | 0;
 i392 = i627 + 64 | 0;
 i393 = i627 + 68 | 0;
 i394 = i627 + 72 | 0;
 i395 = i627 + 76 | 0;
 i396 = i627 + 80 | 0;
 i397 = i627 + 84 | 0;
 i398 = i627 + 88 | 0;
 i399 = i627 + 92 | 0;
 i400 = i627 + 96 | 0;
 i401 = i627 + 100 | 0;
 i402 = i627 + 104 | 0;
 i403 = i627 + 108 | 0;
 i404 = i627 + 112 | 0;
 i405 = i627 + 116 | 0;
 i406 = i627 + 120 | 0;
 i407 = i627 + 124 | 0;
 i408 = i627 + 128 | 0;
 i409 = i627 + 132 | 0;
 i410 = i627 + 136 | 0;
 i411 = i627 + 140 | 0;
 i412 = i627 + 144 | 0;
 i413 = i627 + 148 | 0;
 i414 = i627 + 152 | 0;
 i415 = i627 + 156 | 0;
 i416 = i627 + 160 | 0;
 i417 = i627 + 164 | 0;
 i418 = i627 + 168 | 0;
 i419 = i627 + 172 | 0;
 i420 = i627 + 176 | 0;
 i421 = i627 + 180 | 0;
 i422 = i627 + 184 | 0;
 i423 = i627 + 188 | 0;
 i424 = (i7 & 48 | 0) == 0;
 i147 = i629 + 4 | 0;
 i164 = i629 + 8 | 0;
 i181 = i629 + 12 | 0;
 i425 = i629 + 16 | 0;
 i142 = i629 + 20 | 0;
 i159 = i629 + 24 | 0;
 i176 = i629 + 28 | 0;
 i426 = i629 + 32 | 0;
 i137 = i629 + 36 | 0;
 i154 = i629 + 40 | 0;
 i171 = i629 + 44 | 0;
 i427 = i629 + 48 | 0;
 i146 = i629 + 52 | 0;
 i163 = i629 + 56 | 0;
 i180 = i629 + 60 | 0;
 i428 = i629 + 64 | 0;
 i141 = i629 + 68 | 0;
 i158 = i629 + 72 | 0;
 i175 = i629 + 76 | 0;
 i429 = i629 + 80 | 0;
 i136 = i629 + 84 | 0;
 i153 = i629 + 88 | 0;
 i170 = i629 + 92 | 0;
 i430 = i629 + 96 | 0;
 i145 = i629 + 100 | 0;
 i162 = i629 + 104 | 0;
 i179 = i629 + 108 | 0;
 i431 = i629 + 112 | 0;
 i140 = i629 + 116 | 0;
 i157 = i629 + 120 | 0;
 i174 = i629 + 124 | 0;
 i432 = i629 + 128 | 0;
 i135 = i629 + 132 | 0;
 i152 = i629 + 136 | 0;
 i169 = i629 + 140 | 0;
 i433 = i629 + 144 | 0;
 i144 = i629 + 148 | 0;
 i161 = i629 + 152 | 0;
 i178 = i629 + 156 | 0;
 i434 = i629 + 160 | 0;
 i139 = i629 + 164 | 0;
 i156 = i629 + 168 | 0;
 i173 = i629 + 172 | 0;
 i435 = i629 + 176 | 0;
 i134 = i629 + 180 | 0;
 i151 = i629 + 184 | 0;
 i168 = i629 + 188 | 0;
 i148 = i630 + 4 | 0;
 i165 = i630 + 8 | 0;
 i182 = i630 + 12 | 0;
 i436 = i630 + 16 | 0;
 i143 = i630 + 20 | 0;
 i160 = i630 + 24 | 0;
 i177 = i630 + 28 | 0;
 i437 = i630 + 32 | 0;
 i138 = i630 + 36 | 0;
 i155 = i630 + 40 | 0;
 i172 = i630 + 44 | 0;
 i150 = i631 + 4 | 0;
 i167 = i631 + 8 | 0;
 i184 = i631 + 12 | 0;
 i438 = i631 + 16 | 0;
 i149 = i631 + 20 | 0;
 i166 = i631 + 24 | 0;
 i183 = i631 + 28 | 0;
 i133 = i631 + 32 | 0;
 i439 = (i7 & 512 | 0) != 0;
 i440 = i621 + 16 | 0;
 i441 = i621 + 32 | 0;
 i442 = i632 + 4 | 0;
 i443 = i632 + 8 | 0;
 i444 = i632 + 12 | 0;
 i445 = i632 + 16 | 0;
 i446 = i632 + 20 | 0;
 i447 = i632 + 24 | 0;
 i448 = i632 + 28 | 0;
 i449 = i632 + 32 | 0;
 i450 = i632 + 36 | 0;
 i451 = i632 + 40 | 0;
 i452 = i632 + 44 | 0;
 i453 = (i7 & 8192 | 0) != 0;
 i454 = i633 + 4 | 0;
 i455 = i633 + 8 | 0;
 i456 = i633 + 12 | 0;
 i457 = i633 + 16 | 0;
 i458 = i633 + 20 | 0;
 i459 = i633 + 24 | 0;
 i460 = i633 + 28 | 0;
 i461 = i633 + 32 | 0;
 i462 = i633 + 36 | 0;
 i463 = i633 + 40 | 0;
 i464 = i633 + 44 | 0;
 i465 = i633 + 48 | 0;
 i466 = i633 + 52 | 0;
 i467 = i633 + 56 | 0;
 i468 = i633 + 60 | 0;
 i469 = (i7 & 2 | 0) == 0;
 i470 = (i7 & 8 | 0) == 0;
 i471 = (i7 & 16 | 0) == 0;
 i472 = (i7 & 32 | 0) == 0;
 i473 = (i7 & 64 | 0) == 0;
 i474 = (i7 & 128 | 0) == 0;
 i475 = (i7 & 256 | 0) == 0;
 i476 = i632 + 16 | 0;
 i477 = i632 + 32 | 0;
 i478 = (i7 & 1024 | 0) == 0;
 i479 = (i7 & 2048 | 0) == 0;
 i480 = (i7 & 4096 | 0) == 0;
 i121 = (i7 & 4 | 0) == 0;
 i122 = i630 + 16 | 0;
 i123 = i630 + 32 | 0;
 i124 = i641 + 864 | 0;
 i125 = i641 + 848 | 0;
 i126 = i641 + 844 | 0;
 i127 = i641 + 828 | 0;
 i128 = i641 + 540 | 0;
 i129 = i631 + 16 | 0;
 i130 = i631 + 32 | 0;
 i131 = i628 + 16 | 0;
 i132 = i628 + 32 | 0;
 i86 = i8 + 32 | 0;
 i87 = i627 + 16 | 0;
 i88 = i627 + 32 | 0;
 i89 = i629 + 16 | 0;
 i90 = i629 + 32 | 0;
 i91 = i627 + 48 | 0;
 i92 = i91 + 16 | 0;
 i93 = i91 + 32 | 0;
 i94 = i427 + 16 | 0;
 i95 = i427 + 32 | 0;
 i96 = i400 + 16 | 0;
 i97 = i400 + 32 | 0;
 i98 = i430 + 16 | 0;
 i99 = i430 + 32 | 0;
 i100 = i412 + 16 | 0;
 i101 = i412 + 32 | 0;
 i102 = i433 + 16 | 0;
 i103 = i433 + 32 | 0;
 i104 = i627 + 16 | 0;
 i105 = i627 + 32 | 0;
 i106 = i629 + 16 | 0;
 i107 = i629 + 32 | 0;
 i108 = i627 + 48 | 0;
 i109 = i108 + 16 | 0;
 i110 = i108 + 32 | 0;
 i111 = i427 + 16 | 0;
 i112 = i427 + 32 | 0;
 i113 = i400 + 16 | 0;
 i114 = i400 + 32 | 0;
 i115 = i430 + 16 | 0;
 i116 = i430 + 32 | 0;
 i117 = i412 + 16 | 0;
 i118 = i412 + 32 | 0;
 i119 = i433 + 16 | 0;
 i120 = i433 + 32 | 0;
 i85 = 0;
 i1 = i9;
 do {
  i10 = i619;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i620;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i621;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i622 >> 2] = 0;
  HEAP32[i622 + 4 >> 2] = 0;
  HEAP32[i622 + 8 >> 2] = 0;
  HEAP32[i622 + 12 >> 2] = 0;
  HEAP32[i623 >> 2] = 0;
  HEAP32[i623 + 4 >> 2] = 0;
  HEAP32[i623 + 8 >> 2] = 0;
  HEAP32[i623 + 12 >> 2] = 0;
  HEAP32[i624 >> 2] = 0;
  HEAP32[i624 + 4 >> 2] = 0;
  HEAP32[i624 + 8 >> 2] = 0;
  HEAP32[i624 + 12 >> 2] = 0;
  HEAP32[i625 >> 2] = 0;
  HEAP32[i625 + 4 >> 2] = 0;
  HEAP32[i625 + 8 >> 2] = 0;
  HEAP32[i625 + 12 >> 2] = 0;
  HEAP32[i626 >> 2] = 0;
  HEAP32[i626 + 4 >> 2] = 0;
  HEAP32[i626 + 8 >> 2] = 0;
  HEAP32[i626 + 12 >> 2] = 0;
  i20 = HEAP32[i218 >> 2] | 0;
  if (!i20) {
   i70 = (HEAP32[i641 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i70 + 4 >> 2] | 0;
   i68 = HEAP32[i70 + 8 >> 2] | 0;
   i71 = HEAP32[i70 + 12 >> 2] | 0;
   i67 = (HEAP32[i219 >> 2] | 0) + (i85 << 2) | 0;
   i66 = HEAP32[i67 >> 2] | 0;
   i65 = HEAP32[i67 + 4 >> 2] | 0;
   i64 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   i51 = (HEAP32[i220 >> 2] | 0) + (i85 << 2) | 0;
   i63 = HEAP32[i51 >> 2] | 0;
   i62 = HEAP32[i51 + 4 >> 2] | 0;
   i52 = HEAP32[i51 + 8 >> 2] | 0;
   i51 = HEAP32[i51 + 12 >> 2] | 0;
   HEAP32[i619 >> 2] = HEAP32[i70 >> 2];
   HEAP32[i189 >> 2] = i69;
   HEAP32[i188 >> 2] = i68;
   HEAP32[i187 >> 2] = i71;
   HEAP32[i190 >> 2] = i66;
   HEAP32[i193 >> 2] = i65;
   HEAP32[i192 >> 2] = i64;
   HEAP32[i191 >> 2] = i67;
   HEAP32[i194 >> 2] = i63;
   HEAP32[i197 >> 2] = i62;
   HEAP32[i196 >> 2] = i52;
   HEAP32[i195 >> 2] = i51;
   i51 = (HEAP32[i221 >> 2] | 0) + (i85 << 2) | 0;
   i52 = HEAP32[i51 + 4 >> 2] | 0;
   i62 = HEAP32[i51 + 8 >> 2] | 0;
   i63 = HEAP32[i51 + 12 >> 2] | 0;
   i67 = (HEAP32[i222 >> 2] | 0) + (i85 << 2) | 0;
   i64 = HEAP32[i67 >> 2] | 0;
   i65 = HEAP32[i67 + 4 >> 2] | 0;
   i66 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   i71 = (HEAP32[i223 >> 2] | 0) + (i85 << 2) | 0;
   i68 = HEAP32[i71 >> 2] | 0;
   i69 = HEAP32[i71 + 4 >> 2] | 0;
   i70 = HEAP32[i71 + 8 >> 2] | 0;
   i71 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i620 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i200 >> 2] = i52;
   HEAP32[i199 >> 2] = i62;
   HEAP32[i198 >> 2] = i63;
   HEAP32[i201 >> 2] = i64;
   HEAP32[i204 >> 2] = i65;
   HEAP32[i203 >> 2] = i66;
   HEAP32[i202 >> 2] = i67;
   HEAP32[i205 >> 2] = i68;
   HEAP32[i208 >> 2] = i69;
   HEAP32[i207 >> 2] = i70;
   HEAP32[i206 >> 2] = i71;
   i71 = (HEAP32[i224 >> 2] | 0) + (i85 << 2) | 0;
   f72 = Math_fround(HEAPF32[i71 >> 2]);
   f46 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f54 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i225 >> 2] | 0) + (i85 << 2) | 0;
   f55 = Math_fround(HEAPF32[i71 >> 2]);
   f56 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f58 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i226 >> 2] | 0) + (i85 << 2) | 0;
   f59 = Math_fround(HEAPF32[i71 >> 2]);
   f60 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f84 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i227 >> 2] | 0) + (i85 << 2) | 0;
   f73 = Math_fround(HEAPF32[i71 >> 2]);
   f74 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f75 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f76 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i228 >> 2] | 0) + (i85 << 2) | 0;
   f77 = Math_fround(HEAPF32[i71 >> 2]);
   f78 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f79 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f80 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i229 >> 2] | 0) + (i85 << 2) | 0;
   f81 = Math_fround(HEAPF32[i71 >> 2]);
   f82 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f83 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f74 = Math_fround(f46 + f74);
   f75 = Math_fround(f53 + f75);
   f76 = Math_fround(f54 + f76);
   f77 = Math_fround(f55 + f77);
   f78 = Math_fround(f56 + f78);
   f79 = Math_fround(f57 + f79);
   f80 = Math_fround(f58 + f80);
   f81 = Math_fround(f59 + f81);
   f82 = Math_fround(f60 + f82);
   f83 = Math_fround(f61 + f83);
   f84 = Math_fround(f84 + Math_fround(HEAPF32[i71 + 12 >> 2]));
   HEAPF32[i621 >> 2] = Math_fround(f72 + f73);
   HEAPF32[i211 >> 2] = f74;
   HEAPF32[i210 >> 2] = f75;
   HEAPF32[i209 >> 2] = f76;
   HEAPF32[i230 >> 2] = f77;
   HEAPF32[i214 >> 2] = f78;
   HEAPF32[i213 >> 2] = f79;
   HEAPF32[i212 >> 2] = f80;
   HEAPF32[i231 >> 2] = f81;
   HEAPF32[i217 >> 2] = f82;
   HEAPF32[i216 >> 2] = f83;
   HEAPF32[i215 >> 2] = f84;
   i71 = (HEAP32[i232 >> 2] | 0) + (i85 << 2) | 0;
   i70 = HEAP32[i71 + 4 >> 2] | 0;
   i69 = HEAP32[i71 + 8 >> 2] | 0;
   i68 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i622 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i233 >> 2] = i70;
   HEAP32[i234 >> 2] = i69;
   HEAP32[i235 >> 2] = i68;
   i68 = (HEAP32[i236 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i68 + 4 >> 2] | 0;
   i70 = HEAP32[i68 + 8 >> 2] | 0;
   i71 = HEAP32[i68 + 12 >> 2] | 0;
   HEAP32[i623 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i237 >> 2] = i69;
   HEAP32[i238 >> 2] = i70;
   HEAP32[i239 >> 2] = i71;
   i71 = (HEAP32[i240 >> 2] | 0) + (i85 << 2) | 0;
   i70 = HEAP32[i71 + 4 >> 2] | 0;
   i69 = HEAP32[i71 + 8 >> 2] | 0;
   i68 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i624 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i241 >> 2] = i70;
   HEAP32[i242 >> 2] = i69;
   HEAP32[i243 >> 2] = i68;
   i68 = (HEAP32[i244 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i68 + 4 >> 2] | 0;
   i70 = HEAP32[i68 + 8 >> 2] | 0;
   i71 = HEAP32[i68 + 12 >> 2] | 0;
   HEAP32[i625 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i245 >> 2] = i69;
   HEAP32[i246 >> 2] = i70;
   HEAP32[i247 >> 2] = i71;
   if (HEAP32[i634 >> 2] & 268435456 | 0) {
    i68 = (HEAP32[i248 >> 2] | 0) + (i85 << 2) | 0;
    i69 = HEAP32[i68 + 4 >> 2] | 0;
    i70 = HEAP32[i68 + 8 >> 2] | 0;
    i71 = HEAP32[i68 + 12 >> 2] | 0;
    HEAP32[i626 >> 2] = HEAP32[i68 >> 2];
    HEAP32[i249 >> 2] = i69;
    HEAP32[i250 >> 2] = i70;
    HEAP32[i251 >> 2] = i71;
   }
  } else {
   i3 = HEAP32[i224 >> 2] | 0;
   i4 = HEAP32[i227 >> 2] | 0;
   i5 = HEAP32[i219 >> 2] | 0;
   i6 = HEAP32[i222 >> 2] | 0;
   i7 = HEAP32[i225 >> 2] | 0;
   i8 = HEAP32[i228 >> 2] | 0;
   i9 = HEAP32[i220 >> 2] | 0;
   i10 = HEAP32[i223 >> 2] | 0;
   i11 = HEAP32[i226 >> 2] | 0;
   i13 = HEAP32[i229 >> 2] | 0;
   i14 = HEAP32[i232 >> 2] | 0;
   i15 = HEAP32[i236 >> 2] | 0;
   i16 = HEAP32[i240 >> 2] | 0;
   i17 = HEAP32[i244 >> 2] | 0;
   i18 = HEAP32[i641 >> 2] | 0;
   i19 = HEAP32[i221 >> 2] | 0;
   i21 = (HEAP32[i634 >> 2] & 268435456 | 0) == 0;
   i22 = HEAP32[i248 >> 2] | 0;
   i2 = 0;
   do {
    i23 = HEAP32[i20 + (i2 + i85 << 3) >> 2] | 0;
    HEAP32[i619 + (i2 << 2) >> 2] = HEAP32[i18 + (i23 << 2) >> 2];
    HEAP32[i620 + (i2 << 2) >> 2] = HEAP32[i19 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i3 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i2 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i4 + (i23 << 2) >> 2]));
    i71 = i2 + 4 | 0;
    HEAP32[i619 + (i71 << 2) >> 2] = HEAP32[i5 + (i23 << 2) >> 2];
    HEAP32[i620 + (i71 << 2) >> 2] = HEAP32[i6 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i7 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i71 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i8 + (i23 << 2) >> 2]));
    i71 = i2 + 8 | 0;
    HEAP32[i619 + (i71 << 2) >> 2] = HEAP32[i9 + (i23 << 2) >> 2];
    HEAP32[i620 + (i71 << 2) >> 2] = HEAP32[i10 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i11 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i71 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i13 + (i23 << 2) >> 2]));
    HEAP32[i622 + (i2 << 2) >> 2] = HEAP32[i14 + (i23 << 2) >> 2];
    HEAP32[i623 + (i2 << 2) >> 2] = HEAP32[i15 + (i23 << 2) >> 2];
    HEAP32[i624 + (i2 << 2) >> 2] = HEAP32[i16 + (i23 << 2) >> 2];
    HEAP32[i625 + (i2 << 2) >> 2] = HEAP32[i17 + (i23 << 2) >> 2];
    if (!i21) HEAP32[i626 + (i2 << 2) >> 2] = HEAP32[i22 + (i23 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f40 = Math_fround(HEAPF32[i619 >> 2]);
  f25 = Math_fround(f584 * f40);
  f37 = Math_fround(HEAPF32[i189 >> 2]);
  f39 = Math_fround(f584 * f37);
  f84 = Math_fround(HEAPF32[i188 >> 2]);
  f24 = Math_fround(f584 * f84);
  f82 = Math_fround(HEAPF32[i187 >> 2]);
  f31 = Math_fround(f584 * f82);
  f34 = Math_fround(HEAPF32[i252 >> 2]);
  f28 = Math_fround(f587 * f34);
  f33 = Math_fround(HEAPF32[i193 >> 2]);
  f29 = Math_fround(f587 * f33);
  f83 = Math_fround(HEAPF32[i192 >> 2]);
  f35 = Math_fround(f587 * f83);
  f81 = Math_fround(HEAPF32[i191 >> 2]);
  f28 = Math_fround(f25 + f28);
  f29 = Math_fround(f39 + f29);
  f35 = Math_fround(f24 + f35);
  f31 = Math_fround(f31 + Math_fround(f587 * f81));
  f24 = Math_fround(HEAPF32[i253 >> 2]);
  f39 = Math_fround(f590 * f24);
  f25 = Math_fround(HEAPF32[i197 >> 2]);
  f32 = Math_fround(f590 * f25);
  f26 = Math_fround(HEAPF32[i196 >> 2]);
  f36 = Math_fround(f590 * f26);
  f30 = Math_fround(HEAPF32[i195 >> 2]);
  f32 = Math_fround(f593 + Math_fround(f29 + f32));
  f36 = Math_fround(f593 + Math_fround(f35 + f36));
  f31 = Math_fround(f593 + Math_fround(f31 + Math_fround(f590 * f30)));
  HEAPF32[i628 >> 2] = Math_fround(f593 + Math_fround(f28 + f39));
  HEAPF32[i254 >> 2] = f32;
  HEAPF32[i255 >> 2] = f36;
  HEAPF32[i256 >> 2] = f31;
  f31 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f37) + Math_fround(f588 * f33)) + Math_fround(f591 * f25)));
  f36 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f84) + Math_fround(f588 * f83)) + Math_fround(f591 * f26)));
  f32 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f82) + Math_fround(f588 * f81)) + Math_fround(f591 * f30)));
  HEAPF32[i257 >> 2] = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f40) + Math_fround(f588 * f34)) + Math_fround(f591 * f24)));
  HEAPF32[i258 >> 2] = f31;
  HEAPF32[i259 >> 2] = f36;
  HEAPF32[i260 >> 2] = f32;
  f32 = Math_fround(f595 + Math_fround(Math_fround(f592 * f25) + Math_fround(Math_fround(f589 * f33) + Math_fround(f586 * f37))));
  f36 = Math_fround(f595 + Math_fround(Math_fround(f592 * f26) + Math_fround(Math_fround(f589 * f83) + Math_fround(f586 * f84))));
  f31 = Math_fround(f595 + Math_fround(Math_fround(f592 * f30) + Math_fround(Math_fround(f589 * f81) + Math_fround(f586 * f82))));
  HEAPF32[i261 >> 2] = Math_fround(f595 + Math_fround(Math_fround(f592 * f24) + Math_fround(Math_fround(f589 * f34) + Math_fround(f586 * f40))));
  HEAPF32[i262 >> 2] = f32;
  HEAPF32[i263 >> 2] = f36;
  HEAPF32[i264 >> 2] = f31;
  f24 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f40) + Math_fround(f644 * f34)) + Math_fround(f645 * f24)));
  f25 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f37) + Math_fround(f644 * f33)) + Math_fround(f645 * f25)));
  f26 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f84) + Math_fround(f644 * f83)) + Math_fround(f645 * f26)));
  f30 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f82) + Math_fround(f644 * f81)) + Math_fround(f645 * f30)));
  f81 = Math_fround(f614 + Math_fround(f615 * f24));
  f82 = Math_fround(f614 + Math_fround(f615 * f25));
  f83 = Math_fround(f614 + Math_fround(f615 * f26));
  f84 = Math_fround(f614 + Math_fround(f615 * f30));
  f24 = Math_fround(f608 + Math_fround(f609 * f24));
  f25 = Math_fround(f608 + Math_fround(f609 * f25));
  f26 = Math_fround(f608 + Math_fround(f609 * f26));
  f30 = Math_fround(f608 + Math_fround(f609 * f30));
  f33 = Math_fround(HEAPF32[i622 >> 2]);
  f37 = Math_fround(HEAPF32[i233 >> 2]);
  f34 = Math_fround(HEAPF32[i234 >> 2]);
  f40 = Math_fround(HEAPF32[i235 >> 2]);
  f31 = Math_fround(HEAPF32[i623 >> 2]);
  f36 = Math_fround(HEAPF32[i237 >> 2]);
  f32 = Math_fround(HEAPF32[i238 >> 2]);
  f39 = Math_fround(HEAPF32[i239 >> 2]);
  f28 = f33 > f31 ? f33 : f31;
  f35 = f37 > f36 ? f37 : f36;
  f29 = f34 > f32 ? f34 : f32;
  f38 = f40 > f39 ? f40 : f39;
  f78 = Math_fround((f28 > f81 ? f28 : f81) * Math_fround(.5));
  f79 = Math_fround((f35 > f82 ? f35 : f82) * Math_fround(.5));
  f80 = Math_fround((f29 > f83 ? f29 : f83) * Math_fround(.5));
  f12 = Math_fround((f38 > f84 ? f38 : f84) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f81 >= Math_fround(0.0);
  i69 = f82 >= Math_fround(0.0);
  i70 = f83 >= Math_fround(0.0);
  i71 = f84 >= Math_fround(0.0);
  i9 = i68 ? i9 : 0;
  i10 = i69 ? i10 : 0;
  i11 = i70 ? i11 : 0;
  i5 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f80 = Math_fround(f24 * Math_fround(.5));
  f82 = Math_fround(f25 * Math_fround(.5));
  f84 = Math_fround(f26 * Math_fround(.5));
  f12 = Math_fround(f30 * Math_fround(.5));
  f79 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f83 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f79 < f80 ? f79 : f80, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f81 < f82 ? f81 : f82, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f83 < f84 ? f83 : f84, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f24 >= Math_fround(0.0);
  i3 = f25 >= Math_fround(0.0);
  i2 = f26 >= Math_fround(0.0);
  i71 = f30 >= Math_fround(0.0);
  i15 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f27 < f12 ? f27 : f12, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f28 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f29);
  f24 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f33 * f30);
  f29 = Math_fround(f34 * f41);
  f30 = Math_fround(f31 * f30);
  f41 = Math_fround(f32 * f41);
  f26 = Math_fround(HEAPF32[i624 >> 2]);
  f54 = Math_fround(HEAPF32[i241 >> 2]);
  f82 = Math_fround(HEAPF32[i242 >> 2]);
  f79 = Math_fround(f617 * f33);
  f80 = Math_fround(f617 * f34);
  f84 = Math_fround(f611 * f31);
  f83 = Math_fround(f611 * f32);
  f42 = Math_fround(f613 * f33);
  f34 = Math_fround(f613 * f34);
  f28 = Math_fround(f28 / f35);
  f25 = Math_fround(f37 * f28);
  f28 = Math_fround(f36 * f28);
  i15 = f26 < Math_fround(100.0);
  i17 = f82 < Math_fround(100.0);
  f35 = Math_fround(f617 * f37);
  f82 = Math_fround(f611 * f36);
  f32 = Math_fround(f613 * f37);
  f24 = Math_fround(f24 / f38);
  f26 = Math_fround(f39 * f24);
  i16 = Math_fround(HEAPF32[i243 >> 2]) < Math_fround(100.0);
  f81 = Math_fround(f611 * f39);
  f24 = Math_fround(f40 * f24);
  i14 = f54 < Math_fround(100.0);
  f33 = Math_fround(f617 * f40);
  f31 = Math_fround(f613 * f40);
  f54 = Math_fround(Math_fround(HEAPF32[i628 >> 2]) - f596);
  f55 = Math_fround(Math_fround(HEAPF32[i254 >> 2]) - f596);
  f56 = Math_fround(Math_fround(HEAPF32[i255 >> 2]) - f596);
  f57 = Math_fround(Math_fround(HEAPF32[i256 >> 2]) - f596);
  f58 = Math_fround(Math_fround(HEAPF32[i257 >> 2]) - f597);
  f59 = Math_fround(Math_fround(HEAPF32[i258 >> 2]) - f597);
  f60 = Math_fround(Math_fround(HEAPF32[i259 >> 2]) - f597);
  f61 = Math_fround(Math_fround(HEAPF32[i260 >> 2]) - f597);
  f44 = Math_fround(Math_fround(HEAPF32[i261 >> 2]) - f598);
  f45 = Math_fround(Math_fround(HEAPF32[i262 >> 2]) - f598);
  f46 = Math_fround(Math_fround(HEAPF32[i263 >> 2]) - f598);
  f53 = Math_fround(Math_fround(HEAPF32[i264 >> 2]) - f598);
  f75 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f44 * f44));
  f76 = Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f45 * f45));
  f77 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f46 * f46));
  f78 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f53 * f53));
  f72 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
  f73 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
  f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f77))));
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f78))));
  f54 = Math_fround(f54 * f72);
  f55 = Math_fround(f55 * f73);
  f56 = Math_fround(f56 * f74);
  f57 = Math_fround(f57 * f12);
  f58 = Math_fround(f58 * f72);
  f59 = Math_fround(f59 * f73);
  f60 = Math_fround(f60 * f74);
  f61 = Math_fround(f61 * f12);
  f72 = Math_fround(f44 * f72);
  f73 = Math_fround(f45 * f73);
  f74 = Math_fround(f46 * f74);
  f12 = Math_fround(f53 * f12);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f75 > Math_fround(9.99999974e-06);
  i69 = f76 > Math_fround(9.99999974e-06);
  i70 = f77 > Math_fround(9.99999974e-06);
  i71 = f78 > Math_fround(9.99999974e-06);
  i2 = i68 ? i2 : 0;
  i3 = i69 ? i3 : 0;
  i4 = i70 ? i4 : 0;
  i5 = i71 ? i5 : 0;
  i6 = i68 ? i6 : 0;
  i7 = i69 ? i7 : 0;
  i8 = i70 ? i8 : 0;
  i9 = i71 ? i9 : 0;
  i10 = i68 ? i10 : 1065353216;
  i11 = i69 ? i11 : 1065353216;
  i13 = i70 ? i13 : 1065353216;
  i68 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i265 >> 2] = i2;
  HEAP32[i266 >> 2] = i3;
  HEAP32[i267 >> 2] = i4;
  HEAP32[i268 >> 2] = i5;
  HEAP32[i269 >> 2] = i6;
  HEAP32[i270 >> 2] = i7;
  HEAP32[i271 >> 2] = i8;
  HEAP32[i272 >> 2] = i9;
  HEAP32[i273 >> 2] = i10;
  HEAP32[i274 >> 2] = i11;
  HEAP32[i275 >> 2] = i13;
  HEAP32[i276 >> 2] = i68;
  f58 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f45 = Math_fround(f600 * f58);
  f59 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f600 * f59);
  f60 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = Math_fround(f600 * f60);
  f61 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = Math_fround(f600 * f61);
  f78 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f601 * f78);
  f77 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = Math_fround(f601 * f77);
  f76 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = Math_fround(f601 * f76);
  f75 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f45 - f54);
  f55 = Math_fround(f74 - f55);
  f56 = Math_fround(f44 - f56);
  f57 = Math_fround(f57 - Math_fround(f601 * f75));
  f44 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f601 * f44);
  f45 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f73 = Math_fround(f601 * f45);
  f46 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f72 = Math_fround(f601 * f46);
  f53 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f74 - Math_fround(f599 * f58));
  f59 = Math_fround(f73 - Math_fround(f599 * f59));
  f60 = Math_fround(f72 - Math_fround(f599 * f60));
  f61 = Math_fround(Math_fround(f601 * f53) - Math_fround(f599 * f61));
  f44 = Math_fround(Math_fround(f599 * f78) - Math_fround(f600 * f44));
  f45 = Math_fround(Math_fround(f599 * f77) - Math_fround(f600 * f45));
  f46 = Math_fround(Math_fround(f599 * f76) - Math_fround(f600 * f46));
  f53 = Math_fround(Math_fround(f599 * f75) - Math_fround(f600 * f53));
  f75 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f44 * f44));
  f76 = Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f45 * f45));
  f77 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f46 * f46));
  f78 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f53 * f53));
  f72 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
  f73 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
  f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f77))));
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f78))));
  f54 = Math_fround(f54 * f72);
  f55 = Math_fround(f55 * f73);
  f56 = Math_fround(f56 * f74);
  f57 = Math_fround(f57 * f12);
  f58 = Math_fround(f58 * f72);
  f59 = Math_fround(f59 * f73);
  f60 = Math_fround(f60 * f74);
  f61 = Math_fround(f61 * f12);
  f72 = Math_fround(f44 * f72);
  f73 = Math_fround(f45 * f73);
  f74 = Math_fround(f46 * f74);
  f12 = Math_fround(f53 * f12);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f75 > Math_fround(9.99999974e-06);
  i69 = f76 > Math_fround(9.99999974e-06);
  i70 = f77 > Math_fround(9.99999974e-06);
  i71 = f78 > Math_fround(9.99999974e-06);
  i2 = i68 ? i2 : 1065353216;
  i3 = i69 ? i3 : 1065353216;
  i4 = i70 ? i4 : 1065353216;
  i5 = i71 ? i5 : 1065353216;
  i6 = i68 ? i6 : 0;
  i7 = i69 ? i7 : 0;
  i8 = i70 ? i8 : 0;
  i9 = i71 ? i9 : 0;
  i10 = i68 ? i10 : 0;
  i11 = i69 ? i11 : 0;
  i13 = i70 ? i13 : 0;
  i71 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i629 >> 2] = i2;
  HEAP32[i279 >> 2] = i3;
  HEAP32[i280 >> 2] = i4;
  HEAP32[i281 >> 2] = i5;
  HEAP32[i282 >> 2] = i6;
  HEAP32[i283 >> 2] = i7;
  HEAP32[i284 >> 2] = i8;
  HEAP32[i285 >> 2] = i9;
  HEAP32[i286 >> 2] = i10;
  HEAP32[i287 >> 2] = i11;
  HEAP32[i288 >> 2] = i13;
  HEAP32[i289 >> 2] = i71;
  f73 = Math_fround(HEAPF32[i278 >> 2]);
  f695 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f698 = Math_fround(f73 * f695);
  f683 = Math_fround(HEAPF32[i270 >> 2]);
  f692 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f683 * f692);
  f674 = Math_fround(HEAPF32[i271 >> 2]);
  f689 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f681 = Math_fround(f674 * f689);
  f697 = Math_fround(HEAPF32[i272 >> 2]);
  f684 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f676 = Math_fround(f697 * f684);
  f670 = Math_fround(HEAPF32[i277 >> 2]);
  f672 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f670 * f672);
  f693 = Math_fround(HEAPF32[i274 >> 2]);
  f74 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f671 = Math_fround(f693 * f74);
  f699 = Math_fround(HEAPF32[i275 >> 2]);
  f673 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f40 = Math_fround(f699 * f673);
  f77 = Math_fround(HEAPF32[i276 >> 2]);
  f78 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f698 - f39);
  f671 = Math_fround(f54 - f671);
  f40 = Math_fround(f681 - f40);
  f676 = Math_fround(f676 - Math_fround(f77 * f78));
  f681 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f670 = Math_fround(f670 * f681);
  f54 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f693 = Math_fround(f693 * f54);
  f698 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f699 = Math_fround(f699 * f698);
  f76 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f77 = Math_fround(f77 * f76);
  f700 = Math_fround(HEAPF32[i265 >> 2]);
  f695 = Math_fround(f695 * f700);
  f75 = Math_fround(HEAPF32[i266 >> 2]);
  f692 = Math_fround(f692 * f75);
  f53 = Math_fround(HEAPF32[i267 >> 2]);
  f689 = Math_fround(f689 * f53);
  f675 = Math_fround(HEAPF32[i268 >> 2]);
  f695 = Math_fround(f670 - f695);
  f692 = Math_fround(f693 - f692);
  f689 = Math_fround(f699 - f689);
  f684 = Math_fround(f77 - Math_fround(f684 * f675));
  f681 = Math_fround(Math_fround(f672 * f700) - Math_fround(f73 * f681));
  f54 = Math_fround(Math_fround(f74 * f75) - Math_fround(f683 * f54));
  f698 = Math_fround(Math_fround(f673 * f53) - Math_fround(f674 * f698));
  f76 = Math_fround(Math_fround(f78 * f675) - Math_fround(f697 * f76));
  HEAPF32[i292 >> 2] = f39;
  HEAPF32[i293 >> 2] = f671;
  HEAPF32[i294 >> 2] = f40;
  HEAPF32[i295 >> 2] = f676;
  HEAPF32[i296 >> 2] = f695;
  HEAPF32[i297 >> 2] = f692;
  HEAPF32[i298 >> 2] = f689;
  HEAPF32[i299 >> 2] = f684;
  HEAPF32[i300 >> 2] = f681;
  HEAPF32[i301 >> 2] = f54;
  HEAPF32[i302 >> 2] = f698;
  HEAPF32[i303 >> 2] = f76;
  f76 = Math_fround(HEAPF32[i620 >> 2]);
  f698 = Math_fround(HEAPF32[i200 >> 2]);
  f54 = Math_fround(HEAPF32[i199 >> 2]);
  f681 = Math_fround(HEAPF32[i198 >> 2]);
  f684 = Math_fround(HEAPF32[i304 >> 2]);
  f689 = Math_fround(HEAPF32[i204 >> 2]);
  f692 = Math_fround(HEAPF32[i203 >> 2]);
  f695 = Math_fround(HEAPF32[i202 >> 2]);
  f676 = Math_fround(HEAPF32[i305 >> 2]);
  f40 = Math_fround(HEAPF32[i208 >> 2]);
  f671 = Math_fround(HEAPF32[i207 >> 2]);
  f39 = Math_fround(HEAPF32[i206 >> 2]);
  f76 = Math_fround(f76 * Math_fround(-.159154937));
  f698 = Math_fround(f698 * Math_fround(-.159154937));
  f54 = Math_fround(f54 * Math_fround(-.159154937));
  f681 = Math_fround(f681 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f76));
  f675 = Math_fround(+_roundf(+f698));
  f78 = Math_fround(+_roundf(+f54));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f76 - f697))));
  f675 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f698 - f675))));
  f78 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f54 - f78))));
  f674 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f681 - Math_fround(+_roundf(+f681))))));
  f53 = Math_fround(f697 * f697);
  f673 = Math_fround(f675 * f675);
  f683 = Math_fround(f78 * f78);
  f75 = Math_fround(f674 * f674);
  f74 = Math_fround(f53 * f53);
  f73 = Math_fround(f673 * f673);
  f700 = Math_fround(f683 * f683);
  f672 = Math_fround(f75 * f75);
  f53 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f53 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f53 * Math_fround(76.5686187)))))));
  f673 = Math_fround(f675 * Math_fround(Math_fround(Math_fround(f73 * f73) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f673 * Math_fround(41.3416595))) + Math_fround(f73 * Math_fround(Math_fround(81.6018218) - Math_fround(f673 * Math_fround(76.5686187)))))));
  f683 = Math_fround(f78 * Math_fround(Math_fround(Math_fround(f700 * f700) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f683 * Math_fround(41.3416595))) + Math_fround(f700 * Math_fround(Math_fround(81.6018218) - Math_fround(f683 * Math_fround(76.5686187)))))));
  f75 = Math_fround(f674 * Math_fround(Math_fround(Math_fround(f672 * f672) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f75 * Math_fround(41.3416595))) + Math_fround(f672 * Math_fround(Math_fround(81.6018218) - Math_fround(f75 * Math_fround(76.5686187)))))));
  f76 = Math_fround(f76 + Math_fround(-.25));
  f698 = Math_fround(f698 + Math_fround(-.25));
  f54 = Math_fround(f54 + Math_fround(-.25));
  f681 = Math_fround(f681 + Math_fround(-.25));
  f672 = Math_fround(+_roundf(+f76));
  f674 = Math_fround(+_roundf(+f698));
  f700 = Math_fround(+_roundf(+f54));
  f672 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f76 - f672))));
  f674 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f698 - f674))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f54 - f700))));
  f681 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f681 - Math_fround(+_roundf(+f681))))));
  f54 = Math_fround(f672 * f672);
  f698 = Math_fround(f674 * f674);
  f76 = Math_fround(f700 * f700);
  f78 = Math_fround(f681 * f681);
  f73 = Math_fround(f54 * f54);
  f675 = Math_fround(f698 * f698);
  f74 = Math_fround(f76 * f76);
  f697 = Math_fround(f78 * f78);
  f54 = Math_fround(f672 * Math_fround(Math_fround(Math_fround(f73 * f73) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f73 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
  f698 = Math_fround(f674 * Math_fround(Math_fround(Math_fround(f675 * f675) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f698 * Math_fround(41.3416595))) + Math_fround(f675 * Math_fround(Math_fround(81.6018218) - Math_fround(f698 * Math_fround(76.5686187)))))));
  f76 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f76 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f76 * Math_fround(76.5686187)))))));
  f78 = Math_fround(f681 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f78 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f78 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f684 * Math_fround(-.159154937));
  f689 = Math_fround(f689 * Math_fround(-.159154937));
  f692 = Math_fround(f692 * Math_fround(-.159154937));
  f695 = Math_fround(f695 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f684));
  f681 = Math_fround(+_roundf(+f689));
  f74 = Math_fround(+_roundf(+f692));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f684 - f697))));
  f681 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f689 - f681))));
  f74 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f692 - f74))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f695 - Math_fround(+_roundf(+f695))))));
  f675 = Math_fround(f697 * f697);
  f674 = Math_fround(f681 * f681);
  f73 = Math_fround(f74 * f74);
  f672 = Math_fround(f700 * f700);
  f77 = Math_fround(f675 * f675);
  f699 = Math_fround(f674 * f674);
  f693 = Math_fround(f73 * f73);
  f670 = Math_fround(f672 * f672);
  f675 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f77 * f77) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f675 * Math_fround(41.3416595))) + Math_fround(f77 * Math_fround(Math_fround(81.6018218) - Math_fround(f675 * Math_fround(76.5686187)))))));
  f674 = Math_fround(f681 * Math_fround(Math_fround(Math_fround(f699 * f699) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f674 * Math_fround(41.3416595))) + Math_fround(f699 * Math_fround(Math_fround(81.6018218) - Math_fround(f674 * Math_fround(76.5686187)))))));
  f73 = Math_fround(f74 * Math_fround(Math_fround(Math_fround(f693 * f693) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f73 * Math_fround(41.3416595))) + Math_fround(f693 * Math_fround(Math_fround(81.6018218) - Math_fround(f73 * Math_fround(76.5686187)))))));
  f672 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f670 * f670) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f672 * Math_fround(41.3416595))) + Math_fround(f670 * Math_fround(Math_fround(81.6018218) - Math_fround(f672 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f684 + Math_fround(-.25));
  f689 = Math_fround(f689 + Math_fround(-.25));
  f692 = Math_fround(f692 + Math_fround(-.25));
  f695 = Math_fround(f695 + Math_fround(-.25));
  f670 = Math_fround(+_roundf(+f684));
  f700 = Math_fround(+_roundf(+f689));
  f693 = Math_fround(+_roundf(+f692));
  f670 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f684 - f670))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f689 - f700))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f692 - f693))));
  f695 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f695 - Math_fround(+_roundf(+f695))))));
  f692 = Math_fround(f670 * f670);
  f689 = Math_fround(f700 * f700);
  f684 = Math_fround(f693 * f693);
  f74 = Math_fround(f695 * f695);
  f699 = Math_fround(f692 * f692);
  f681 = Math_fround(f689 * f689);
  f77 = Math_fround(f684 * f684);
  f697 = Math_fround(f74 * f74);
  f692 = Math_fround(f670 * Math_fround(Math_fround(Math_fround(f699 * f699) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f692 * Math_fround(41.3416595))) + Math_fround(f699 * Math_fround(Math_fround(81.6018218) - Math_fround(f692 * Math_fround(76.5686187)))))));
  f689 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f681 * f681) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f689 * Math_fround(41.3416595))) + Math_fround(f681 * Math_fround(Math_fround(81.6018218) - Math_fround(f689 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f77 * f77) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f684 * Math_fround(41.3416595))) + Math_fround(f77 * Math_fround(Math_fround(81.6018218) - Math_fround(f684 * Math_fround(76.5686187)))))));
  f74 = Math_fround(f695 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f74 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f74 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f676 * Math_fround(-.159154937));
  f40 = Math_fround(f40 * Math_fround(-.159154937));
  f671 = Math_fround(f671 * Math_fround(-.159154937));
  f39 = Math_fround(f39 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f676));
  f695 = Math_fround(+_roundf(+f40));
  f77 = Math_fround(+_roundf(+f671));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f676 - f697))));
  f695 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f695))));
  f77 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f77))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
  f681 = Math_fround(f697 * f697);
  f700 = Math_fround(f695 * f695);
  f699 = Math_fround(f77 * f77);
  f670 = Math_fround(f693 * f693);
  f72 = Math_fround(f681 * f681);
  f682 = Math_fround(f700 * f700);
  f685 = Math_fround(f699 * f699);
  f694 = Math_fround(f670 * f670);
  f681 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f681 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f681 * Math_fround(76.5686187)))))));
  f700 = Math_fround(f695 * Math_fround(Math_fround(Math_fround(f682 * f682) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f700 * Math_fround(41.3416595))) + Math_fround(f682 * Math_fround(Math_fround(81.6018218) - Math_fround(f700 * Math_fround(76.5686187)))))));
  f699 = Math_fround(f77 * Math_fround(Math_fround(Math_fround(f685 * f685) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f699 * Math_fround(41.3416595))) + Math_fround(f685 * Math_fround(Math_fround(81.6018218) - Math_fround(f699 * Math_fround(76.5686187)))))));
  f670 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f694 * f694) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f670 * Math_fround(41.3416595))) + Math_fround(f694 * Math_fround(Math_fround(81.6018218) - Math_fround(f670 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f676 + Math_fround(-.25));
  f40 = Math_fround(f40 + Math_fround(-.25));
  f671 = Math_fround(f671 + Math_fround(-.25));
  f39 = Math_fround(f39 + Math_fround(-.25));
  f694 = Math_fround(+_roundf(+f676));
  f693 = Math_fround(+_roundf(+f40));
  f685 = Math_fround(+_roundf(+f671));
  f694 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f676 - f694))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f693))));
  f685 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f685))));
  f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
  f671 = Math_fround(f694 * f694);
  f40 = Math_fround(f693 * f693);
  f676 = Math_fround(f685 * f685);
  f77 = Math_fround(f39 * f39);
  f682 = Math_fround(f671 * f671);
  f695 = Math_fround(f40 * f40);
  f72 = Math_fround(f676 * f676);
  f697 = Math_fround(f77 * f77);
  f671 = Math_fround(f694 * Math_fround(Math_fround(Math_fround(f682 * f682) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f671 * Math_fround(41.3416595))) + Math_fround(f682 * Math_fround(Math_fround(81.6018218) - Math_fround(f671 * Math_fround(76.5686187)))))));
  f40 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f695 * f695) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f695 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f685 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f676 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f676 * Math_fround(76.5686187)))))));
  f77 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f77 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f77 * Math_fround(76.5686187)))))));
  f697 = Math_fround(f675 * f681);
  f39 = Math_fround(f674 * f700);
  f72 = Math_fround(f73 * f699);
  f685 = Math_fround(f672 * f670);
  f695 = Math_fround(f39 + Math_fround(Math_fround(f698 * f689) * f40));
  f693 = Math_fround(f72 + Math_fround(Math_fround(f76 * f684) * f676));
  f682 = Math_fround(f685 + Math_fround(Math_fround(f78 * f74) * f77));
  HEAPF32[i630 >> 2] = Math_fround(f697 + Math_fround(Math_fround(f54 * f692) * f671));
  HEAPF32[i306 >> 2] = f695;
  HEAPF32[i307 >> 2] = f693;
  HEAPF32[i308 >> 2] = f682;
  f682 = Math_fround(Math_fround(f689 * Math_fround(f698 * f700)) - Math_fround(f674 * f40));
  f693 = Math_fround(Math_fround(f684 * Math_fround(f76 * f699)) - Math_fround(f73 * f676));
  f695 = Math_fround(Math_fround(f74 * Math_fround(f78 * f670)) - Math_fround(f672 * f77));
  HEAPF32[i309 >> 2] = Math_fround(Math_fround(f692 * Math_fround(f54 * f681)) - Math_fround(f675 * f671));
  HEAPF32[i310 >> 2] = f682;
  HEAPF32[i311 >> 2] = f693;
  HEAPF32[i312 >> 2] = f695;
  f695 = Math_fround(f673 * f689);
  f693 = Math_fround(f683 * f684);
  f682 = Math_fround(f75 * f74);
  HEAPF32[i313 >> 2] = Math_fround(f53 * f692);
  HEAPF32[i314 >> 2] = f695;
  HEAPF32[i315 >> 2] = f693;
  HEAPF32[i316 >> 2] = f682;
  f682 = Math_fround(f53 * f671);
  f693 = Math_fround(f673 * f40);
  f695 = Math_fround(f683 * f676);
  f694 = Math_fround(f75 * f77);
  HEAPF32[i317 >> 2] = f682;
  HEAPF32[i318 >> 2] = f693;
  HEAPF32[i319 >> 2] = f695;
  HEAPF32[i320 >> 2] = f694;
  f55 = Math_fround(f673 * f700);
  f56 = Math_fround(f683 * f699);
  f57 = Math_fround(f75 * f670);
  HEAPF32[i321 >> 2] = Math_fround(f53 * f681);
  HEAPF32[i322 >> 2] = f55;
  HEAPF32[i323 >> 2] = f56;
  HEAPF32[i324 >> 2] = f57;
  f57 = Math_fround(-f698);
  f56 = Math_fround(-f76);
  f55 = Math_fround(-f78);
  HEAPF32[i325 >> 2] = Math_fround(-f54);
  HEAPF32[i326 >> 2] = f57;
  HEAPF32[i327 >> 2] = f56;
  HEAPF32[i328 >> 2] = f55;
  f681 = Math_fround(Math_fround(Math_fround(f54 * f675) * f671) - Math_fround(f692 * f681));
  f700 = Math_fround(Math_fround(Math_fround(f698 * f674) * f40) - Math_fround(f689 * f700));
  f699 = Math_fround(Math_fround(Math_fround(f76 * f73) * f676) - Math_fround(f684 * f699));
  f670 = Math_fround(Math_fround(Math_fround(f78 * f672) * f77) - Math_fround(f74 * f670));
  HEAPF32[i329 >> 2] = f681;
  HEAPF32[i330 >> 2] = f700;
  HEAPF32[i331 >> 2] = f699;
  HEAPF32[i332 >> 2] = f670;
  f671 = Math_fround(Math_fround(f54 * f697) + Math_fround(f692 * f671));
  f40 = Math_fround(Math_fround(f698 * f39) + Math_fround(f689 * f40));
  f676 = Math_fround(Math_fround(f76 * f72) + Math_fround(f684 * f676));
  f77 = Math_fround(Math_fround(f78 * f685) + Math_fround(f74 * f77));
  HEAPF32[i333 >> 2] = f671;
  HEAPF32[i334 >> 2] = f40;
  HEAPF32[i335 >> 2] = f676;
  HEAPF32[i336 >> 2] = f77;
  f675 = Math_fround(f53 * f675);
  f674 = Math_fround(f673 * f674);
  f73 = Math_fround(f683 * f73);
  f672 = Math_fround(f75 * f672);
  HEAPF32[i337 >> 2] = f675;
  HEAPF32[i338 >> 2] = f674;
  HEAPF32[i339 >> 2] = f73;
  HEAPF32[i340 >> 2] = f672;
  f75 = Math_fround(HEAPF32[i629 >> 2]);
  f683 = Math_fround(f75 * Math_fround(HEAPF32[i630 >> 2]));
  f673 = Math_fround(HEAPF32[i279 >> 2]);
  f53 = Math_fround(f673 * Math_fround(HEAPF32[i306 >> 2]));
  f74 = Math_fround(HEAPF32[i280 >> 2]);
  f685 = Math_fround(f74 * Math_fround(HEAPF32[i307 >> 2]));
  f78 = Math_fround(HEAPF32[i281 >> 2]);
  f684 = Math_fround(f78 * Math_fround(HEAPF32[i308 >> 2]));
  f72 = Math_fround(HEAPF32[i292 >> 2]);
  f682 = Math_fround(f72 * f682);
  f76 = Math_fround(HEAPF32[i293 >> 2]);
  f693 = Math_fround(f76 * f693);
  f689 = Math_fround(HEAPF32[i294 >> 2]);
  f695 = Math_fround(f689 * f695);
  f39 = Math_fround(HEAPF32[i295 >> 2]);
  f682 = Math_fround(f683 + f682);
  f693 = Math_fround(f53 + f693);
  f695 = Math_fround(f685 + f695);
  f694 = Math_fround(f684 + Math_fround(f39 * f694));
  f684 = Math_fround(HEAPF32[i341 >> 2]);
  f681 = Math_fround(f684 * f681);
  f685 = Math_fround(HEAPF32[i266 >> 2]);
  f700 = Math_fround(f685 * f700);
  f53 = Math_fround(HEAPF32[i267 >> 2]);
  f699 = Math_fround(f53 * f699);
  f683 = Math_fround(HEAPF32[i268 >> 2]);
  f700 = Math_fround(f693 + f700);
  f699 = Math_fround(f695 + f699);
  f670 = Math_fround(f694 + Math_fround(f683 * f670));
  HEAPF32[i631 >> 2] = Math_fround(f682 + f681);
  HEAPF32[i342 >> 2] = f700;
  HEAPF32[i343 >> 2] = f699;
  HEAPF32[i344 >> 2] = f670;
  f670 = Math_fround(f75 * Math_fround(HEAPF32[i309 >> 2]));
  f699 = Math_fround(f673 * Math_fround(HEAPF32[i310 >> 2]));
  f700 = Math_fround(f74 * Math_fround(HEAPF32[i311 >> 2]));
  f681 = Math_fround(f78 * Math_fround(HEAPF32[i312 >> 2]));
  f682 = Math_fround(f72 * Math_fround(HEAPF32[i321 >> 2]));
  f694 = Math_fround(f76 * Math_fround(HEAPF32[i322 >> 2]));
  f695 = Math_fround(f689 * Math_fround(HEAPF32[i323 >> 2]));
  f40 = Math_fround(Math_fround(f699 + f694) + Math_fround(f685 * f40));
  f676 = Math_fround(Math_fround(f700 + f695) + Math_fround(f53 * f676));
  f77 = Math_fround(Math_fround(f681 + Math_fround(f39 * Math_fround(HEAPF32[i324 >> 2]))) + Math_fround(f683 * f77));
  HEAPF32[i345 >> 2] = Math_fround(Math_fround(f670 + f682) + Math_fround(f684 * f671));
  HEAPF32[i346 >> 2] = f40;
  HEAPF32[i347 >> 2] = f676;
  HEAPF32[i348 >> 2] = f77;
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i313 >> 2]));
  f673 = Math_fround(f673 * Math_fround(HEAPF32[i314 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i315 >> 2]));
  f78 = Math_fround(f78 * Math_fround(HEAPF32[i316 >> 2]));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i325 >> 2]));
  f76 = Math_fround(f76 * Math_fround(HEAPF32[i326 >> 2]));
  f689 = Math_fround(f689 * Math_fround(HEAPF32[i327 >> 2]));
  f674 = Math_fround(Math_fround(f673 + f76) + Math_fround(f685 * f674));
  f73 = Math_fround(Math_fround(f74 + f689) + Math_fround(f53 * f73));
  f672 = Math_fround(Math_fround(f78 + Math_fround(f39 * Math_fround(HEAPF32[i328 >> 2]))) + Math_fround(f683 * f672));
  HEAPF32[i349 >> 2] = Math_fround(Math_fround(f75 + f72) + Math_fround(f684 * f675));
  HEAPF32[i350 >> 2] = f674;
  HEAPF32[i351 >> 2] = f73;
  HEAPF32[i352 >> 2] = f672;
  f672 = Math_fround(HEAPF32[i290 >> 2]);
  f73 = Math_fround(f672 * Math_fround(HEAPF32[i630 >> 2]));
  f674 = Math_fround(HEAPF32[i283 >> 2]);
  f675 = Math_fround(f674 * Math_fround(HEAPF32[i306 >> 2]));
  f684 = Math_fround(HEAPF32[i284 >> 2]);
  f72 = Math_fround(f684 * Math_fround(HEAPF32[i307 >> 2]));
  f75 = Math_fround(HEAPF32[i285 >> 2]);
  f683 = Math_fround(f75 * Math_fround(HEAPF32[i308 >> 2]));
  f39 = Math_fround(HEAPF32[i296 >> 2]);
  f78 = Math_fround(f39 * Math_fround(HEAPF32[i317 >> 2]));
  f53 = Math_fround(HEAPF32[i297 >> 2]);
  f689 = Math_fround(f53 * Math_fround(HEAPF32[i318 >> 2]));
  f74 = Math_fround(HEAPF32[i298 >> 2]);
  f685 = Math_fround(f74 * Math_fround(HEAPF32[i319 >> 2]));
  f76 = Math_fround(HEAPF32[i299 >> 2]);
  f78 = Math_fround(f73 + f78);
  f689 = Math_fround(f675 + f689);
  f685 = Math_fround(f72 + f685);
  f683 = Math_fround(f683 + Math_fround(f76 * Math_fround(HEAPF32[i320 >> 2])));
  f72 = Math_fround(HEAPF32[i278 >> 2]);
  f675 = Math_fround(f72 * Math_fround(HEAPF32[i329 >> 2]));
  f73 = Math_fround(HEAPF32[i270 >> 2]);
  f673 = Math_fround(f73 * Math_fround(HEAPF32[i330 >> 2]));
  f77 = Math_fround(HEAPF32[i271 >> 2]);
  f676 = Math_fround(f77 * Math_fround(HEAPF32[i331 >> 2]));
  f40 = Math_fround(HEAPF32[i272 >> 2]);
  f673 = Math_fround(f689 + f673);
  f676 = Math_fround(f685 + f676);
  f683 = Math_fround(f683 + Math_fround(f40 * Math_fround(HEAPF32[i332 >> 2])));
  HEAPF32[i353 >> 2] = Math_fround(f78 + f675);
  HEAPF32[i354 >> 2] = f673;
  HEAPF32[i355 >> 2] = f676;
  HEAPF32[i356 >> 2] = f683;
  f683 = Math_fround(f672 * Math_fround(HEAPF32[i309 >> 2]));
  f676 = Math_fround(f674 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f684 * Math_fround(HEAPF32[i311 >> 2]));
  f675 = Math_fround(f75 * Math_fround(HEAPF32[i312 >> 2]));
  f78 = Math_fround(f39 * Math_fround(HEAPF32[i321 >> 2]));
  f685 = Math_fround(f53 * Math_fround(HEAPF32[i322 >> 2]));
  f689 = Math_fround(f74 * Math_fround(HEAPF32[i323 >> 2]));
  f78 = Math_fround(f683 + f78);
  f685 = Math_fround(f676 + f685);
  f689 = Math_fround(f673 + f689);
  f675 = Math_fround(f675 + Math_fround(f76 * Math_fround(HEAPF32[i324 >> 2])));
  f673 = Math_fround(f72 * Math_fround(HEAPF32[i333 >> 2]));
  f676 = Math_fround(f73 * Math_fround(HEAPF32[i334 >> 2]));
  f683 = Math_fround(f77 * Math_fround(HEAPF32[i335 >> 2]));
  f676 = Math_fround(f685 + f676);
  f683 = Math_fround(f689 + f683);
  f675 = Math_fround(f675 + Math_fround(f40 * Math_fround(HEAPF32[i336 >> 2])));
  HEAPF32[i357 >> 2] = Math_fround(f78 + f673);
  HEAPF32[i358 >> 2] = f676;
  HEAPF32[i359 >> 2] = f683;
  HEAPF32[i360 >> 2] = f675;
  f672 = Math_fround(f672 * Math_fround(HEAPF32[i313 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i314 >> 2]));
  f684 = Math_fround(f684 * Math_fround(HEAPF32[i315 >> 2]));
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i316 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i325 >> 2]));
  f53 = Math_fround(f53 * Math_fround(HEAPF32[i326 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i327 >> 2]));
  f39 = Math_fround(f672 + f39);
  f53 = Math_fround(f674 + f53);
  f74 = Math_fround(f684 + f74);
  f76 = Math_fround(f75 + Math_fround(f76 * Math_fround(HEAPF32[i328 >> 2])));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i337 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i338 >> 2]));
  f77 = Math_fround(f77 * Math_fround(HEAPF32[i339 >> 2]));
  f73 = Math_fround(f53 + f73);
  f77 = Math_fround(f74 + f77);
  f40 = Math_fround(f76 + Math_fround(f40 * Math_fround(HEAPF32[i340 >> 2])));
  HEAPF32[i361 >> 2] = Math_fround(f39 + f72);
  HEAPF32[i362 >> 2] = f73;
  HEAPF32[i363 >> 2] = f77;
  HEAPF32[i364 >> 2] = f40;
  f40 = Math_fround(HEAPF32[i291 >> 2]);
  f77 = Math_fround(f40 * Math_fround(HEAPF32[i630 >> 2]));
  f73 = Math_fround(HEAPF32[i287 >> 2]);
  f72 = Math_fround(f73 * Math_fround(HEAPF32[i306 >> 2]));
  f39 = Math_fround(HEAPF32[i288 >> 2]);
  f76 = Math_fround(f39 * Math_fround(HEAPF32[i307 >> 2]));
  f74 = Math_fround(HEAPF32[i289 >> 2]);
  f53 = Math_fround(f74 * Math_fround(HEAPF32[i308 >> 2]));
  f75 = Math_fround(HEAPF32[i300 >> 2]);
  f684 = Math_fround(f75 * Math_fround(HEAPF32[i317 >> 2]));
  f674 = Math_fround(HEAPF32[i301 >> 2]);
  f672 = Math_fround(f674 * Math_fround(HEAPF32[i318 >> 2]));
  f675 = Math_fround(HEAPF32[i302 >> 2]);
  f683 = Math_fround(f675 * Math_fround(HEAPF32[i319 >> 2]));
  f676 = Math_fround(HEAPF32[i303 >> 2]);
  f684 = Math_fround(f77 + f684);
  f672 = Math_fround(f72 + f672);
  f683 = Math_fround(f76 + f683);
  f53 = Math_fround(f53 + Math_fround(f676 * Math_fround(HEAPF32[i320 >> 2])));
  f76 = Math_fround(HEAPF32[i277 >> 2]);
  f72 = Math_fround(f76 * Math_fround(HEAPF32[i329 >> 2]));
  f77 = Math_fround(HEAPF32[i274 >> 2]);
  f673 = Math_fround(f77 * Math_fround(HEAPF32[i330 >> 2]));
  f78 = Math_fround(HEAPF32[i275 >> 2]);
  f689 = Math_fround(f78 * Math_fround(HEAPF32[i331 >> 2]));
  f685 = Math_fround(HEAPF32[i276 >> 2]);
  f673 = Math_fround(f672 + f673);
  f689 = Math_fround(f683 + f689);
  f53 = Math_fround(f53 + Math_fround(f685 * Math_fround(HEAPF32[i332 >> 2])));
  HEAPF32[i365 >> 2] = Math_fround(f684 + f72);
  HEAPF32[i366 >> 2] = f673;
  HEAPF32[i367 >> 2] = f689;
  HEAPF32[i368 >> 2] = f53;
  f53 = Math_fround(f40 * Math_fround(HEAPF32[i309 >> 2]));
  f689 = Math_fround(f73 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f39 * Math_fround(HEAPF32[i311 >> 2]));
  f72 = Math_fround(f74 * Math_fround(HEAPF32[i312 >> 2]));
  f684 = Math_fround(f75 * Math_fround(HEAPF32[i321 >> 2]));
  f683 = Math_fround(f674 * Math_fround(HEAPF32[i322 >> 2]));
  f672 = Math_fround(f675 * Math_fround(HEAPF32[i323 >> 2]));
  f684 = Math_fround(f53 + f684);
  f683 = Math_fround(f689 + f683);
  f672 = Math_fround(f673 + f672);
  f72 = Math_fround(f72 + Math_fround(f676 * Math_fround(HEAPF32[i324 >> 2])));
  f673 = Math_fround(f76 * Math_fround(HEAPF32[i333 >> 2]));
  f689 = Math_fround(f77 * Math_fround(HEAPF32[i334 >> 2]));
  f53 = Math_fround(f78 * Math_fround(HEAPF32[i335 >> 2]));
  f689 = Math_fround(f683 + f689);
  f53 = Math_fround(f672 + f53);
  f72 = Math_fround(f72 + Math_fround(f685 * Math_fround(HEAPF32[i336 >> 2])));
  HEAPF32[i369 >> 2] = Math_fround(f684 + f673);
  HEAPF32[i370 >> 2] = f689;
  HEAPF32[i371 >> 2] = f53;
  HEAPF32[i372 >> 2] = f72;
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i313 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i314 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i315 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i316 >> 2]));
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i325 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i326 >> 2]));
  f675 = Math_fround(f675 * Math_fround(HEAPF32[i327 >> 2]));
  f75 = Math_fround(f40 + f75);
  f674 = Math_fround(f73 + f674);
  f675 = Math_fround(f39 + f675);
  f676 = Math_fround(f74 + Math_fround(f676 * Math_fround(HEAPF32[i328 >> 2])));
  f76 = Math_fround(f76 * Math_fround(HEAPF32[i337 >> 2]));
  f77 = Math_fround(f77 * Math_fround(HEAPF32[i338 >> 2]));
  f78 = Math_fround(f78 * Math_fround(HEAPF32[i339 >> 2]));
  f77 = Math_fround(f674 + f77);
  f78 = Math_fround(f675 + f78);
  f685 = Math_fround(f676 + Math_fround(f685 * Math_fround(HEAPF32[i340 >> 2])));
  HEAPF32[i373 >> 2] = Math_fround(f75 + f76);
  HEAPF32[i374 >> 2] = f77;
  HEAPF32[i375 >> 2] = f78;
  HEAPF32[i376 >> 2] = f685;
  f78 = i15 ? f27 : Math_fround(0.0);
  f77 = i14 ? f25 : Math_fround(0.0);
  f76 = i17 ? f29 : Math_fround(0.0);
  f75 = i16 ? f24 : Math_fround(0.0);
  f676 = Math_fround(f79 - f78);
  f675 = Math_fround(f35 - f77);
  f674 = Math_fround(f80 - f76);
  f25 = Math_fround(f33 - f75);
  f74 = i15 ? f30 : Math_fround(0.0);
  f39 = Math_fround(f84 + f74);
  f73 = i14 ? f28 : Math_fround(0.0);
  f40 = Math_fround(f82 + f73);
  f72 = i17 ? f41 : Math_fround(0.0);
  f41 = Math_fround(f83 + f72);
  f53 = i16 ? f26 : Math_fround(0.0);
  f689 = Math_fround(f81 + f53);
  f673 = Math_fround(HEAPF32[i631 >> 2]);
  f684 = Math_fround(f676 * f673);
  f672 = Math_fround(HEAPF32[i342 >> 2]);
  f683 = Math_fround(f675 * f672);
  f671 = Math_fround(HEAPF32[i343 >> 2]);
  f682 = Math_fround(f674 * f671);
  f670 = Math_fround(HEAPF32[i344 >> 2]);
  f681 = Math_fround(f25 * f670);
  f695 = Math_fround(HEAPF32[i345 >> 2]);
  f700 = Math_fround(f39 * f695);
  f694 = Math_fround(HEAPF32[i346 >> 2]);
  f699 = Math_fround(f40 * f694);
  f693 = Math_fround(HEAPF32[i347 >> 2]);
  f698 = Math_fround(f41 * f693);
  f692 = Math_fround(HEAPF32[i348 >> 2]);
  f697 = Math_fround(f689 * f692);
  f54 = Math_fround(f684 + f700);
  f55 = Math_fround(f683 + f699);
  f56 = Math_fround(f682 + f698);
  f57 = Math_fround(f681 + f697);
  f24 = Math_fround(f42 * Math_fround(HEAPF32[i349 >> 2]));
  f661 = Math_fround(f32 * Math_fround(HEAPF32[i350 >> 2]));
  f660 = Math_fround(f34 * Math_fround(HEAPF32[i351 >> 2]));
  f659 = Math_fround(f31 * Math_fround(HEAPF32[i352 >> 2]));
  f54 = Math_fround(f54 + f24);
  f55 = Math_fround(f55 + f661);
  f56 = Math_fround(f56 + f660);
  f57 = Math_fround(f57 + f659);
  f669 = Math_fround(HEAPF32[i353 >> 2]);
  f680 = Math_fround(f676 * f669);
  f668 = Math_fround(HEAPF32[i354 >> 2]);
  f679 = Math_fround(f675 * f668);
  f667 = Math_fround(HEAPF32[i355 >> 2]);
  f678 = Math_fround(f674 * f667);
  f666 = Math_fround(HEAPF32[i356 >> 2]);
  f677 = Math_fround(f25 * f666);
  f691 = Math_fround(HEAPF32[i357 >> 2]);
  f696 = Math_fround(f39 * f691);
  f690 = Math_fround(HEAPF32[i358 >> 2]);
  f36 = Math_fround(f40 * f690);
  f30 = Math_fround(HEAPF32[i359 >> 2]);
  f37 = Math_fround(f41 * f30);
  f29 = Math_fround(HEAPF32[i360 >> 2]);
  f38 = Math_fround(f689 * f29);
  f58 = Math_fround(f680 + f696);
  f59 = Math_fround(f679 + f36);
  f60 = Math_fround(f678 + f37);
  f61 = Math_fround(f677 + f38);
  f658 = Math_fround(f42 * Math_fround(HEAPF32[i361 >> 2]));
  f657 = Math_fround(f32 * Math_fround(HEAPF32[i362 >> 2]));
  f656 = Math_fround(f34 * Math_fround(HEAPF32[i363 >> 2]));
  f655 = Math_fround(f31 * Math_fround(HEAPF32[i364 >> 2]));
  f58 = Math_fround(f58 + f658);
  f59 = Math_fround(f59 + f657);
  f60 = Math_fround(f60 + f656);
  f61 = Math_fround(f61 + f655);
  f665 = Math_fround(HEAPF32[i365 >> 2]);
  f676 = Math_fround(f676 * f665);
  f664 = Math_fround(HEAPF32[i366 >> 2]);
  f675 = Math_fround(f675 * f664);
  f663 = Math_fround(HEAPF32[i367 >> 2]);
  f674 = Math_fround(f674 * f663);
  f662 = Math_fround(HEAPF32[i368 >> 2]);
  f25 = Math_fround(f25 * f662);
  f28 = Math_fround(HEAPF32[i369 >> 2]);
  f39 = Math_fround(f39 * f28);
  f27 = Math_fround(HEAPF32[i370 >> 2]);
  f40 = Math_fround(f40 * f27);
  f26 = Math_fround(HEAPF32[i371 >> 2]);
  f41 = Math_fround(f41 * f26);
  f12 = Math_fround(HEAPF32[i372 >> 2]);
  f689 = Math_fround(f689 * f12);
  f43 = Math_fround(f676 + f39);
  f44 = Math_fround(f675 + f40);
  f45 = Math_fround(f674 + f41);
  f46 = Math_fround(f25 + f689);
  f654 = Math_fround(f42 * Math_fround(HEAPF32[i373 >> 2]));
  f653 = Math_fround(f32 * Math_fround(HEAPF32[i374 >> 2]));
  f652 = Math_fround(f34 * Math_fround(HEAPF32[i375 >> 2]));
  f685 = Math_fround(f31 * f685);
  f43 = Math_fround(f43 + f654);
  f44 = Math_fround(f44 + f653);
  f45 = Math_fround(f45 + f652);
  f46 = Math_fround(f685 + f46);
  f686 = Math_fround(f79 + f78);
  f687 = Math_fround(f35 + f77);
  f688 = Math_fround(f80 + f76);
  f42 = Math_fround(f33 + f75);
  f673 = Math_fround(f686 * f673);
  f672 = Math_fround(f687 * f672);
  f671 = Math_fround(f688 * f671);
  f670 = Math_fround(f42 * f670);
  f31 = Math_fround(Math_fround(f673 + f700) + f24);
  f32 = Math_fround(Math_fround(f672 + f699) + f661);
  f33 = Math_fround(Math_fround(f671 + f698) + f660);
  f34 = Math_fround(Math_fround(f670 + f697) + f659);
  f669 = Math_fround(f686 * f669);
  f668 = Math_fround(f687 * f668);
  f667 = Math_fround(f688 * f667);
  f666 = Math_fround(f42 * f666);
  f35 = Math_fround(Math_fround(f669 + f696) + f658);
  f36 = Math_fround(Math_fround(f668 + f36) + f657);
  f37 = Math_fround(Math_fround(f667 + f37) + f656);
  f38 = Math_fround(Math_fround(f666 + f38) + f655);
  f665 = Math_fround(f686 * f665);
  f664 = Math_fround(f687 * f664);
  f663 = Math_fround(f688 * f663);
  f662 = Math_fround(f42 * f662);
  f39 = Math_fround(Math_fround(f665 + f39) + f654);
  f40 = Math_fround(Math_fround(f664 + f40) + f653);
  f41 = Math_fround(Math_fround(f663 + f41) + f652);
  f42 = Math_fround(f685 + Math_fround(f662 + f689));
  f689 = Math_fround(f84 - f74);
  f688 = Math_fround(f82 - f73);
  f687 = Math_fround(f83 - f72);
  f686 = Math_fround(f81 - f53);
  f84 = Math_fround(f689 * f695);
  f83 = Math_fround(f688 * f694);
  f82 = Math_fround(f687 * f693);
  f81 = Math_fround(f686 * f692);
  f673 = Math_fround(Math_fround(f673 + f84) + f24);
  f672 = Math_fround(Math_fround(f672 + f83) + f661);
  f671 = Math_fround(Math_fround(f671 + f82) + f660);
  f670 = Math_fround(Math_fround(f670 + f81) + f659);
  f80 = Math_fround(f689 * f691);
  f79 = Math_fround(f688 * f690);
  f30 = Math_fround(f687 * f30);
  f29 = Math_fround(f686 * f29);
  f669 = Math_fround(Math_fround(f669 + f80) + f658);
  f668 = Math_fround(Math_fround(f668 + f79) + f657);
  f667 = Math_fround(Math_fround(f667 + f30) + f656);
  f666 = Math_fround(Math_fround(f666 + f29) + f655);
  f28 = Math_fround(f689 * f28);
  f27 = Math_fround(f688 * f27);
  f26 = Math_fround(f687 * f26);
  f12 = Math_fround(f686 * f12);
  f665 = Math_fround(Math_fround(f665 + f28) + f654);
  f664 = Math_fround(Math_fround(f664 + f27) + f653);
  f663 = Math_fround(Math_fround(f663 + f26) + f652);
  f662 = Math_fround(f685 + Math_fround(f662 + f12));
  f24 = Math_fround(Math_fround(f684 + f84) + f24);
  f661 = Math_fround(Math_fround(f683 + f83) + f661);
  f660 = Math_fround(Math_fround(f682 + f82) + f660);
  f659 = Math_fround(Math_fround(f681 + f81) + f659);
  f658 = Math_fround(Math_fround(f680 + f80) + f658);
  f657 = Math_fround(Math_fround(f679 + f79) + f657);
  f656 = Math_fround(Math_fround(f678 + f30) + f656);
  f655 = Math_fround(Math_fround(f677 + f29) + f655);
  f654 = Math_fround(Math_fround(f676 + f28) + f654);
  f653 = Math_fround(Math_fround(f675 + f27) + f653);
  f652 = Math_fround(Math_fround(f674 + f26) + f652);
  f12 = Math_fround(f685 + Math_fround(f25 + f12));
  f25 = Math_fround(HEAPF32[i628 >> 2]);
  f685 = Math_fround(f54 + f25);
  f26 = Math_fround(HEAPF32[i254 >> 2]);
  f674 = Math_fround(f55 + f26);
  f27 = Math_fround(HEAPF32[i255 >> 2]);
  f675 = Math_fround(f56 + f27);
  f28 = Math_fround(HEAPF32[i256 >> 2]);
  f676 = Math_fround(f57 + f28);
  f29 = Math_fround(HEAPF32[i257 >> 2]);
  f677 = Math_fround(f58 + f29);
  f30 = Math_fround(HEAPF32[i258 >> 2]);
  f678 = Math_fround(f59 + f30);
  f79 = Math_fround(HEAPF32[i259 >> 2]);
  f679 = Math_fround(f60 + f79);
  f80 = Math_fround(HEAPF32[i260 >> 2]);
  f680 = Math_fround(f61 + f80);
  f81 = Math_fround(HEAPF32[i261 >> 2]);
  f681 = Math_fround(f43 + f81);
  f82 = Math_fround(HEAPF32[i262 >> 2]);
  f682 = Math_fround(f44 + f82);
  f83 = Math_fround(HEAPF32[i263 >> 2]);
  f683 = Math_fround(f45 + f83);
  f84 = Math_fround(HEAPF32[i264 >> 2]);
  f684 = Math_fround(f46 + f84);
  HEAPF32[i627 >> 2] = f685;
  HEAPF32[i377 >> 2] = f674;
  HEAPF32[i378 >> 2] = f675;
  HEAPF32[i379 >> 2] = f676;
  HEAPF32[i380 >> 2] = f677;
  HEAPF32[i381 >> 2] = f678;
  HEAPF32[i382 >> 2] = f679;
  HEAPF32[i383 >> 2] = f680;
  HEAPF32[i384 >> 2] = f681;
  HEAPF32[i385 >> 2] = f682;
  HEAPF32[i386 >> 2] = f683;
  HEAPF32[i387 >> 2] = f684;
  f684 = Math_fround(f32 + f26);
  f683 = Math_fround(f33 + f27);
  f682 = Math_fround(f34 + f28);
  f681 = Math_fround(f35 + f29);
  f680 = Math_fround(f36 + f30);
  f679 = Math_fround(f37 + f79);
  f678 = Math_fround(f38 + f80);
  f677 = Math_fround(f39 + f81);
  f676 = Math_fround(f40 + f82);
  f675 = Math_fround(f41 + f83);
  f674 = Math_fround(f42 + f84);
  HEAPF32[i388 >> 2] = Math_fround(f31 + f25);
  HEAPF32[i389 >> 2] = f684;
  HEAPF32[i390 >> 2] = f683;
  HEAPF32[i391 >> 2] = f682;
  HEAPF32[i392 >> 2] = f681;
  HEAPF32[i393 >> 2] = f680;
  HEAPF32[i394 >> 2] = f679;
  HEAPF32[i395 >> 2] = f678;
  HEAPF32[i396 >> 2] = f677;
  HEAPF32[i397 >> 2] = f676;
  HEAPF32[i398 >> 2] = f675;
  HEAPF32[i399 >> 2] = f674;
  f672 = Math_fround(f672 + f26);
  f671 = Math_fround(f671 + f27);
  f670 = Math_fround(f670 + f28);
  f669 = Math_fround(f669 + f29);
  f668 = Math_fround(f668 + f30);
  f667 = Math_fround(f667 + f79);
  f666 = Math_fround(f666 + f80);
  f665 = Math_fround(f665 + f81);
  f664 = Math_fround(f664 + f82);
  f663 = Math_fround(f663 + f83);
  f662 = Math_fround(f662 + f84);
  HEAPF32[i400 >> 2] = Math_fround(f673 + f25);
  HEAPF32[i401 >> 2] = f672;
  HEAPF32[i402 >> 2] = f671;
  HEAPF32[i403 >> 2] = f670;
  HEAPF32[i404 >> 2] = f669;
  HEAPF32[i405 >> 2] = f668;
  HEAPF32[i406 >> 2] = f667;
  HEAPF32[i407 >> 2] = f666;
  HEAPF32[i408 >> 2] = f665;
  HEAPF32[i409 >> 2] = f664;
  HEAPF32[i410 >> 2] = f663;
  HEAPF32[i411 >> 2] = f662;
  f26 = Math_fround(f661 + f26);
  f27 = Math_fround(f660 + f27);
  f28 = Math_fround(f659 + f28);
  f29 = Math_fround(f658 + f29);
  f30 = Math_fround(f657 + f30);
  f79 = Math_fround(f656 + f79);
  f80 = Math_fround(f655 + f80);
  f81 = Math_fround(f654 + f81);
  f82 = Math_fround(f653 + f82);
  f83 = Math_fround(f652 + f83);
  f84 = Math_fround(f12 + f84);
  HEAPF32[i412 >> 2] = Math_fround(f24 + f25);
  HEAPF32[i413 >> 2] = f26;
  HEAPF32[i414 >> 2] = f27;
  HEAPF32[i415 >> 2] = f28;
  HEAPF32[i416 >> 2] = f29;
  HEAPF32[i417 >> 2] = f30;
  HEAPF32[i418 >> 2] = f79;
  HEAPF32[i419 >> 2] = f80;
  HEAPF32[i420 >> 2] = f81;
  HEAPF32[i421 >> 2] = f82;
  HEAPF32[i422 >> 2] = f83;
  HEAPF32[i423 >> 2] = f84;
  if (!i424) {
   i2 = HEAP32[i634 >> 2] | 0;
   if (i2 & 536870912) {
    i52 = HEAP32[i86 >> 2] | 0;
    f700 = Math_fround(HEAPF32[i52 + 564 >> 2]);
    i50 = HEAP32[i625 >> 2] | 0;
    i62 = i50 + 693089735 | 0;
    i48 = HEAP32[i245 >> 2] | 0;
    i70 = i48 + 693089735 | 0;
    i23 = HEAP32[i246 >> 2] | 0;
    i67 = i23 + 693089735 | 0;
    i21 = HEAP32[i247 >> 2] | 0;
    i64 = i21 + 693089735 | 0;
    i22 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i47 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
    i49 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i62 = i62 << 11 ^ i62;
    i70 = i70 << 11 ^ i70;
    i67 = i67 << 11 ^ i67;
    i64 = i64 << 11 ^ i64;
    i22 = Math_fround(Math_fround((i22 ^ i62 ^ i62 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i47 = Math_fround(Math_fround((i47 ^ i70 ^ i70 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i49 = Math_fround(Math_fround((i49 ^ i67 ^ i67 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i51 = Math_fround(Math_fround((i51 ^ i64 ^ i64 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    f700 = Math_fround(HEAPF32[i52 + 568 >> 2]);
    i50 = i50 + 13945730 | 0;
    i48 = i48 + 13945730 | 0;
    i23 = i23 + 13945730 | 0;
    i21 = i21 + 13945730 | 0;
    i52 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i64 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
    i50 = i50 << 11 ^ i50;
    i48 = i48 << 11 ^ i48;
    i23 = i23 << 11 ^ i23;
    i21 = i21 << 11 ^ i21;
    i52 = Math_fround(Math_fround((i52 ^ i50 ^ i50 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i64 = Math_fround(Math_fround((i64 ^ i48 ^ i48 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i67 = Math_fround(Math_fround((i67 ^ i23 ^ i23 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i70 = Math_fround(Math_fround((i70 ^ i21 ^ i21 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i21 = i22 & 1;
    i23 = i47 & 1;
    i48 = i49 & 1;
    i50 = i51 & 1;
    i62 = i22 & 1 ^ 1;
    i65 = i47 & 1 ^ 1;
    i68 = i49 & 1 ^ 1;
    i71 = i51 & 1 ^ 1;
    i63 = i22 ? 3 : 2;
    i66 = i47 ? 3 : 2;
    i69 = i49 ? 3 : 2;
    i2 = i51 ? 3 : 2;
    i22 = i22 ? 2 : 3;
    i47 = i47 ? 2 : 3;
    i49 = i49 ? 2 : 3;
    i51 = i51 ? 2 : 3;
    HEAP32[i648 >> 2] = i52 ? i22 : i21;
    HEAP32[i604 >> 2] = i64 ? i47 : i23;
    HEAP32[i603 >> 2] = i67 ? i49 : i48;
    HEAP32[i602 >> 2] = i70 ? i51 : i50;
    HEAP32[i583 >> 2] = i52 ? i21 : i22;
    HEAP32[i582 >> 2] = i64 ? i23 : i47;
    HEAP32[i581 >> 2] = i67 ? i48 : i49;
    HEAP32[i580 >> 2] = i70 ? i50 : i51;
    HEAP32[i575 >> 2] = i52 ? i63 : i62;
    HEAP32[i607 >> 2] = i64 ? i66 : i65;
    HEAP32[i606 >> 2] = i67 ? i69 : i68;
    HEAP32[i605 >> 2] = i70 ? i2 : i71;
    HEAP32[i579 >> 2] = i52 ? i62 : i63;
    HEAP32[i578 >> 2] = i64 ? i65 : i66;
    HEAP32[i577 >> 2] = i67 ? i68 : i69;
    HEAP32[i576 >> 2] = i70 ? i71 : i2;
    i2 = HEAP32[i634 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f12 = Math_fround(f637 * Math_fround(HEAPF32[i626 >> 2]));
    f24 = Math_fround(f637 * Math_fround(HEAPF32[i249 >> 2]));
    f25 = Math_fround(f637 * Math_fround(HEAPF32[i250 >> 2]));
    f26 = Math_fround(f637 * Math_fround(HEAPF32[i251 >> 2]));
    f27 = Math_fround(Math_floor(Math_fround(f12)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    f30 = Math_fround(Math_floor(Math_fround(f26)));
    if (i2 & 16777216 | 0) {
     f697 = Math_fround(Math_floor(Math_fround(f636 * f27)));
     f698 = Math_fround(Math_floor(Math_fround(f636 * f28)));
     f699 = Math_fround(Math_floor(Math_fround(f636 * f29)));
     f700 = Math_fround(Math_floor(Math_fround(f636 * f30)));
     f693 = Math_fround(f638 * Math_fround(f27 - Math_fround(f635 * f697)));
     f694 = Math_fround(f638 * Math_fround(f28 - Math_fround(f635 * f698)));
     f695 = Math_fround(f638 * Math_fround(f29 - Math_fround(f635 * f699)));
     f696 = Math_fround(f638 * Math_fround(f30 - Math_fround(f635 * f700)));
     f697 = Math_fround(f640 - Math_fround(f639 * f697));
     f698 = Math_fround(f640 - Math_fround(f639 * f698));
     f699 = Math_fround(f640 - Math_fround(f639 * f699));
     f700 = Math_fround(f640 - Math_fround(f639 * f700));
     f685 = Math_fround(f639 + f697);
     f686 = Math_fround(f639 + f698);
     f687 = Math_fround(f639 + f699);
     f688 = Math_fround(f639 + f700);
     HEAPF32[i649 >> 2] = f693;
     HEAPF32[i526 >> 2] = f694;
     HEAPF32[i550 >> 2] = f695;
     HEAPF32[i574 >> 2] = f696;
     HEAPF32[i502 >> 2] = f685;
     HEAPF32[i525 >> 2] = f686;
     HEAPF32[i549 >> 2] = f687;
     HEAPF32[i573 >> 2] = f688;
     f689 = Math_fround(f638 + f693);
     f690 = Math_fround(f638 + f694);
     f691 = Math_fround(f638 + f695);
     f692 = Math_fround(f638 + f696);
     HEAPF32[i501 >> 2] = f689;
     HEAPF32[i524 >> 2] = f690;
     HEAPF32[i548 >> 2] = f691;
     HEAPF32[i572 >> 2] = f692;
     HEAPF32[i500 >> 2] = f685;
     HEAPF32[i523 >> 2] = f686;
     HEAPF32[i547 >> 2] = f687;
     HEAPF32[i571 >> 2] = f688;
     HEAPF32[i499 >> 2] = f689;
     HEAPF32[i522 >> 2] = f690;
     HEAPF32[i546 >> 2] = f691;
     HEAPF32[i570 >> 2] = f692;
     HEAPF32[i498 >> 2] = f697;
     HEAPF32[i521 >> 2] = f698;
     HEAPF32[i545 >> 2] = f699;
     HEAPF32[i569 >> 2] = f700;
     HEAPF32[i497 >> 2] = f693;
     HEAPF32[i520 >> 2] = f694;
     HEAPF32[i544 >> 2] = f695;
     HEAPF32[i568 >> 2] = f696;
     HEAPF32[i496 >> 2] = f697;
     HEAPF32[i519 >> 2] = f698;
     HEAPF32[i543 >> 2] = f699;
     HEAPF32[i567 >> 2] = f700;
    }
    if (i2 & 33554432 | 0) {
     f689 = Math_fround(f27 + Math_fround(1.0));
     f690 = Math_fround(f28 + Math_fround(1.0));
     f691 = Math_fround(f29 + Math_fround(1.0));
     f692 = Math_fround(f30 + Math_fround(1.0));
     f697 = Math_fround(f12 - f27);
     f698 = Math_fround(f24 - f28);
     f699 = Math_fround(f25 - f29);
     f700 = Math_fround(f26 - f30);
     f693 = Math_fround(Math_floor(Math_fround(f636 * f689)));
     f694 = Math_fround(Math_floor(Math_fround(f636 * f690)));
     f695 = Math_fround(Math_floor(Math_fround(f636 * f691)));
     f696 = Math_fround(Math_floor(Math_fround(f636 * f692)));
     f689 = Math_fround(f638 * Math_fround(f689 - Math_fround(f635 * f693)));
     f690 = Math_fround(f638 * Math_fround(f690 - Math_fround(f635 * f694)));
     f691 = Math_fround(f638 * Math_fround(f691 - Math_fround(f635 * f695)));
     f692 = Math_fround(f638 * Math_fround(f692 - Math_fround(f635 * f696)));
     f693 = Math_fround(f640 - Math_fround(f639 * f693));
     f694 = Math_fround(f640 - Math_fround(f639 * f694));
     f695 = Math_fround(f640 - Math_fround(f639 * f695));
     f696 = Math_fround(f640 - Math_fround(f639 * f696));
     f681 = Math_fround(f639 + f693);
     f682 = Math_fround(f639 + f694);
     f683 = Math_fround(f639 + f695);
     f684 = Math_fround(f639 + f696);
     HEAPF32[i650 >> 2] = f689;
     HEAPF32[i518 >> 2] = f690;
     HEAPF32[i542 >> 2] = f691;
     HEAPF32[i566 >> 2] = f692;
     HEAPF32[i495 >> 2] = f681;
     HEAPF32[i517 >> 2] = f682;
     HEAPF32[i541 >> 2] = f683;
     HEAPF32[i565 >> 2] = f684;
     HEAPF32[i494 >> 2] = f697;
     HEAPF32[i516 >> 2] = f698;
     HEAPF32[i540 >> 2] = f699;
     HEAPF32[i564 >> 2] = f700;
     HEAPF32[i493 >> 2] = f12;
     HEAPF32[i515 >> 2] = f24;
     HEAPF32[i539 >> 2] = f25;
     HEAPF32[i563 >> 2] = f26;
     f685 = Math_fround(f638 + f689);
     f686 = Math_fround(f638 + f690);
     f687 = Math_fround(f638 + f691);
     f688 = Math_fround(f638 + f692);
     HEAPF32[i492 >> 2] = f685;
     HEAPF32[i514 >> 2] = f686;
     HEAPF32[i538 >> 2] = f687;
     HEAPF32[i562 >> 2] = f688;
     HEAPF32[i491 >> 2] = f681;
     HEAPF32[i513 >> 2] = f682;
     HEAPF32[i537 >> 2] = f683;
     HEAPF32[i561 >> 2] = f684;
     HEAPF32[i490 >> 2] = f697;
     HEAPF32[i512 >> 2] = f698;
     HEAPF32[i536 >> 2] = f699;
     HEAPF32[i560 >> 2] = f700;
     HEAPF32[i489 >> 2] = f12;
     HEAPF32[i511 >> 2] = f24;
     HEAPF32[i535 >> 2] = f25;
     HEAPF32[i559 >> 2] = f26;
     HEAPF32[i488 >> 2] = f685;
     HEAPF32[i510 >> 2] = f686;
     HEAPF32[i534 >> 2] = f687;
     HEAPF32[i558 >> 2] = f688;
     HEAPF32[i487 >> 2] = f693;
     HEAPF32[i509 >> 2] = f694;
     HEAPF32[i533 >> 2] = f695;
     HEAPF32[i557 >> 2] = f696;
     HEAPF32[i486 >> 2] = f697;
     HEAPF32[i508 >> 2] = f698;
     HEAPF32[i532 >> 2] = f699;
     HEAPF32[i556 >> 2] = f700;
     HEAPF32[i485 >> 2] = f12;
     HEAPF32[i507 >> 2] = f24;
     HEAPF32[i531 >> 2] = f25;
     HEAPF32[i555 >> 2] = f26;
     HEAPF32[i484 >> 2] = f689;
     HEAPF32[i506 >> 2] = f690;
     HEAPF32[i530 >> 2] = f691;
     HEAPF32[i554 >> 2] = f692;
     HEAPF32[i483 >> 2] = f693;
     HEAPF32[i505 >> 2] = f694;
     HEAPF32[i529 >> 2] = f695;
     HEAPF32[i553 >> 2] = f696;
     HEAPF32[i482 >> 2] = f697;
     HEAPF32[i504 >> 2] = f698;
     HEAPF32[i528 >> 2] = f699;
     HEAPF32[i552 >> 2] = f700;
     HEAPF32[i481 >> 2] = f12;
     HEAPF32[i503 >> 2] = f24;
     HEAPF32[i527 >> 2] = f25;
     HEAPF32[i551 >> 2] = f26;
    }
   }
  }
  f685 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f43 * f43)))));
  f686 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f44 * f44)))));
  f687 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f45 * f45)))));
  f688 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f46 * f46)))));
  f677 = Math_fround(f642 * Math_fround(f54 * f685));
  f678 = Math_fround(f642 * Math_fround(f55 * f686));
  f679 = Math_fround(f642 * Math_fround(f56 * f687));
  f680 = Math_fround(f642 * Math_fround(f57 * f688));
  f681 = Math_fround(f642 * Math_fround(f58 * f685));
  f682 = Math_fround(f642 * Math_fround(f59 * f686));
  f683 = Math_fround(f642 * Math_fround(f60 * f687));
  f684 = Math_fround(f642 * Math_fround(f61 * f688));
  f685 = Math_fround(f642 * Math_fround(f43 * f685));
  f686 = Math_fround(f642 * Math_fround(f44 * f686));
  f687 = Math_fround(f642 * Math_fround(f45 * f687));
  f688 = Math_fround(f642 * Math_fround(f46 * f688));
  f697 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35)) + Math_fround(f39 * f39)))));
  f698 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f36 * f36)) + Math_fround(f40 * f40)))));
  f699 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f37 * f37)) + Math_fround(f41 * f41)))));
  f700 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f38 * f38)) + Math_fround(f42 * f42)))));
  f689 = Math_fround(f642 * Math_fround(f31 * f697));
  f690 = Math_fround(f642 * Math_fround(f32 * f698));
  f691 = Math_fround(f642 * Math_fround(f33 * f699));
  f692 = Math_fround(f642 * Math_fround(f34 * f700));
  f693 = Math_fround(f642 * Math_fround(f35 * f697));
  f694 = Math_fround(f642 * Math_fround(f36 * f698));
  f695 = Math_fround(f642 * Math_fround(f37 * f699));
  f696 = Math_fround(f642 * Math_fround(f38 * f700));
  f697 = Math_fround(f642 * Math_fround(f39 * f697));
  f698 = Math_fround(f642 * Math_fround(f40 * f698));
  f699 = Math_fround(f642 * Math_fround(f41 * f699));
  f700 = Math_fround(f642 * Math_fround(f42 * f700));
  f676 = Math_fround(f616 + f678);
  f675 = Math_fround(f616 + f679);
  f674 = Math_fround(f616 + f680);
  f673 = Math_fround(f610 + f681);
  f672 = Math_fround(f610 + f682);
  f671 = Math_fround(f610 + f683);
  f670 = Math_fround(f610 + f684);
  f669 = Math_fround(f612 + f685);
  f668 = Math_fround(f612 + f686);
  f667 = Math_fround(f612 + f687);
  f666 = Math_fround(f612 + f688);
  HEAPF32[i629 >> 2] = Math_fround(f616 + f677);
  HEAPF32[i147 >> 2] = f676;
  HEAPF32[i164 >> 2] = f675;
  HEAPF32[i181 >> 2] = f674;
  HEAPF32[i425 >> 2] = f673;
  HEAPF32[i142 >> 2] = f672;
  HEAPF32[i159 >> 2] = f671;
  HEAPF32[i176 >> 2] = f670;
  HEAPF32[i426 >> 2] = f669;
  HEAPF32[i137 >> 2] = f668;
  HEAPF32[i154 >> 2] = f667;
  HEAPF32[i171 >> 2] = f666;
  f666 = Math_fround(f616 + f690);
  f667 = Math_fround(f616 + f691);
  f668 = Math_fround(f616 + f692);
  f669 = Math_fround(f610 + f693);
  f670 = Math_fround(f610 + f694);
  f671 = Math_fround(f610 + f695);
  f672 = Math_fround(f610 + f696);
  f673 = Math_fround(f612 + f697);
  f674 = Math_fround(f612 + f698);
  f675 = Math_fround(f612 + f699);
  f676 = Math_fround(f612 + f700);
  HEAPF32[i427 >> 2] = Math_fround(f616 + f689);
  HEAPF32[i146 >> 2] = f666;
  HEAPF32[i163 >> 2] = f667;
  HEAPF32[i180 >> 2] = f668;
  HEAPF32[i428 >> 2] = f669;
  HEAPF32[i141 >> 2] = f670;
  HEAPF32[i158 >> 2] = f671;
  HEAPF32[i175 >> 2] = f672;
  HEAPF32[i429 >> 2] = f673;
  HEAPF32[i136 >> 2] = f674;
  HEAPF32[i153 >> 2] = f675;
  HEAPF32[i170 >> 2] = f676;
  f678 = Math_fround(f616 - f678);
  f679 = Math_fround(f616 - f679);
  f680 = Math_fround(f616 - f680);
  f681 = Math_fround(f610 - f681);
  f682 = Math_fround(f610 - f682);
  f683 = Math_fround(f610 - f683);
  f684 = Math_fround(f610 - f684);
  f685 = Math_fround(f612 - f685);
  f686 = Math_fround(f612 - f686);
  f687 = Math_fround(f612 - f687);
  f688 = Math_fround(f612 - f688);
  HEAPF32[i430 >> 2] = Math_fround(f616 - f677);
  HEAPF32[i145 >> 2] = f678;
  HEAPF32[i162 >> 2] = f679;
  HEAPF32[i179 >> 2] = f680;
  HEAPF32[i431 >> 2] = f681;
  HEAPF32[i140 >> 2] = f682;
  HEAPF32[i157 >> 2] = f683;
  HEAPF32[i174 >> 2] = f684;
  HEAPF32[i432 >> 2] = f685;
  HEAPF32[i135 >> 2] = f686;
  HEAPF32[i152 >> 2] = f687;
  HEAPF32[i169 >> 2] = f688;
  f690 = Math_fround(f616 - f690);
  f691 = Math_fround(f616 - f691);
  f692 = Math_fround(f616 - f692);
  f693 = Math_fround(f610 - f693);
  f694 = Math_fround(f610 - f694);
  f695 = Math_fround(f610 - f695);
  f696 = Math_fround(f610 - f696);
  f697 = Math_fround(f612 - f697);
  f698 = Math_fround(f612 - f698);
  f699 = Math_fround(f612 - f699);
  f700 = Math_fround(f612 - f700);
  HEAPF32[i433 >> 2] = Math_fround(f616 - f689);
  HEAPF32[i144 >> 2] = f690;
  HEAPF32[i161 >> 2] = f691;
  HEAPF32[i178 >> 2] = f692;
  HEAPF32[i434 >> 2] = f693;
  HEAPF32[i139 >> 2] = f694;
  HEAPF32[i156 >> 2] = f695;
  HEAPF32[i173 >> 2] = f696;
  HEAPF32[i435 >> 2] = f697;
  HEAPF32[i134 >> 2] = f698;
  HEAPF32[i151 >> 2] = f699;
  HEAPF32[i168 >> 2] = f700;
  do if (i185) {
   i4 = HEAP32[i218 >> 2] | 0;
   i5 = HEAP32[i646 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i71 = i5 + (i2 + i85 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i627 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i629 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i427 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i400 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i430 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i412 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i433 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i71 >> 2];
     i71 = i649 + (HEAP32[i648 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i71 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i71 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i71 = i5 + (HEAP32[i4 + (i2 + i85 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i627 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i629 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i427 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i400 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i430 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i412 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i118 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i433 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i119 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i120 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i71 >> 2];
     i71 = i649 + (HEAP32[i648 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i71 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i71 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f688 = Math_fround(HEAPF32[i388 >> 2]);
   f688 = Math_fround(f688 - Math_fround(HEAPF32[i627 >> 2]));
   f690 = Math_fround(HEAPF32[i389 >> 2]);
   f690 = Math_fround(f690 - Math_fround(HEAPF32[i377 >> 2]));
   f691 = Math_fround(HEAPF32[i390 >> 2]);
   f691 = Math_fround(f691 - Math_fround(HEAPF32[i378 >> 2]));
   f692 = Math_fround(HEAPF32[i391 >> 2]);
   f692 = Math_fround(f692 - Math_fround(HEAPF32[i379 >> 2]));
   f693 = Math_fround(HEAPF32[i392 >> 2]);
   f693 = Math_fround(f693 - Math_fround(HEAPF32[i380 >> 2]));
   f700 = Math_fround(HEAPF32[i393 >> 2]);
   f700 = Math_fround(f700 - Math_fround(HEAPF32[i381 >> 2]));
   f699 = Math_fround(HEAPF32[i394 >> 2]);
   f699 = Math_fround(f699 - Math_fround(HEAPF32[i382 >> 2]));
   f698 = Math_fround(HEAPF32[i395 >> 2]);
   f698 = Math_fround(f698 - Math_fround(HEAPF32[i383 >> 2]));
   f697 = Math_fround(HEAPF32[i396 >> 2]);
   f697 = Math_fround(f697 - Math_fround(HEAPF32[i384 >> 2]));
   f685 = Math_fround(HEAPF32[i397 >> 2]);
   f685 = Math_fround(f685 - Math_fround(HEAPF32[i385 >> 2]));
   f686 = Math_fround(HEAPF32[i398 >> 2]);
   f686 = Math_fround(f686 - Math_fround(HEAPF32[i386 >> 2]));
   f687 = Math_fround(HEAPF32[i399 >> 2]);
   f687 = Math_fround(f687 - Math_fround(HEAPF32[i387 >> 2]));
   f689 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f688 * f688) + Math_fround(f693 * f693)) + Math_fround(f697 * f697)))));
   f696 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f690 * f690) + Math_fround(f700 * f700)) + Math_fround(f685 * f685)))));
   f695 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f691 * f691) + Math_fround(f699 * f699)) + Math_fround(f686 * f686)))));
   f694 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f692 * f692) + Math_fround(f698 * f698)) + Math_fround(f687 * f687)))));
   f690 = Math_fround(f690 * f696);
   f691 = Math_fround(f691 * f695);
   f692 = Math_fround(f692 * f694);
   f693 = Math_fround(f693 * f689);
   f700 = Math_fround(f700 * f696);
   f699 = Math_fround(f699 * f695);
   f698 = Math_fround(f698 * f694);
   f697 = Math_fround(f697 * f689);
   f696 = Math_fround(f685 * f696);
   f695 = Math_fround(f686 * f695);
   f694 = Math_fround(f687 * f694);
   HEAPF32[i630 >> 2] = Math_fround(f688 * f689);
   HEAPF32[i148 >> 2] = f690;
   HEAPF32[i165 >> 2] = f691;
   HEAPF32[i182 >> 2] = f692;
   HEAPF32[i436 >> 2] = f693;
   HEAPF32[i143 >> 2] = f700;
   HEAPF32[i160 >> 2] = f699;
   HEAPF32[i177 >> 2] = f698;
   HEAPF32[i437 >> 2] = f697;
   HEAPF32[i138 >> 2] = f696;
   HEAPF32[i155 >> 2] = f695;
   HEAPF32[i172 >> 2] = f694;
   f694 = Math_fround(f77 * Math_fround(2.0));
   f695 = Math_fround(f76 * Math_fround(2.0));
   f696 = Math_fround(f75 * Math_fround(2.0));
   f697 = Math_fround(f74 * Math_fround(2.0));
   f698 = Math_fround(f73 * Math_fround(2.0));
   f699 = Math_fround(f72 * Math_fround(2.0));
   f700 = Math_fround(f53 * Math_fround(2.0));
   HEAPF32[i631 >> 2] = Math_fround(f78 * Math_fround(2.0));
   HEAPF32[i150 >> 2] = f694;
   HEAPF32[i167 >> 2] = f695;
   HEAPF32[i184 >> 2] = f696;
   HEAPF32[i438 >> 2] = f697;
   HEAPF32[i149 >> 2] = f698;
   HEAPF32[i166 >> 2] = f699;
   HEAPF32[i183 >> 2] = f700;
   HEAP32[i133 >> 2] = 0;
   HEAP32[i133 + 4 >> 2] = 0;
   HEAP32[i133 + 8 >> 2] = 0;
   HEAP32[i133 + 12 >> 2] = 0;
   if (i439) {
    f680 = Math_fround(HEAPF32[i621 >> 2]);
    f698 = Math_fround(f584 * f680);
    f682 = Math_fround(HEAPF32[i211 >> 2]);
    f689 = Math_fround(f584 * f682);
    f684 = Math_fround(HEAPF32[i210 >> 2]);
    f697 = Math_fround(f584 * f684);
    f686 = Math_fround(HEAPF32[i209 >> 2]);
    f692 = Math_fround(f584 * f686);
    f681 = Math_fround(HEAPF32[i440 >> 2]);
    f688 = Math_fround(f587 * f681);
    f683 = Math_fround(HEAPF32[i214 >> 2]);
    f694 = Math_fround(f587 * f683);
    f685 = Math_fround(HEAPF32[i213 >> 2]);
    f693 = Math_fround(f587 * f685);
    f687 = Math_fround(HEAPF32[i212 >> 2]);
    f688 = Math_fround(f698 + f688);
    f694 = Math_fround(f689 + f694);
    f693 = Math_fround(f697 + f693);
    f692 = Math_fround(f692 + Math_fround(f587 * f687));
    f697 = Math_fround(HEAPF32[i441 >> 2]);
    f689 = Math_fround(f590 * f697);
    f698 = Math_fround(HEAPF32[i217 >> 2]);
    f690 = Math_fround(f590 * f698);
    f699 = Math_fround(HEAPF32[i216 >> 2]);
    f691 = Math_fround(f590 * f699);
    f700 = Math_fround(HEAPF32[i215 >> 2]);
    f690 = Math_fround(f694 + f690);
    f691 = Math_fround(f693 + f691);
    f692 = Math_fround(f692 + Math_fround(f590 * f700));
    f693 = Math_fround(Math_fround(Math_fround(f585 * f680) + Math_fround(f588 * f681)) + Math_fround(f591 * f697));
    f694 = Math_fround(Math_fround(Math_fround(f585 * f682) + Math_fround(f588 * f683)) + Math_fround(f591 * f698));
    f695 = Math_fround(Math_fround(Math_fround(f585 * f684) + Math_fround(f588 * f685)) + Math_fround(f591 * f699));
    f696 = Math_fround(Math_fround(Math_fround(f585 * f686) + Math_fround(f588 * f687)) + Math_fround(f591 * f700));
    f697 = Math_fround(Math_fround(Math_fround(f586 * f680) + Math_fround(f589 * f681)) + Math_fround(f592 * f697));
    f698 = Math_fround(Math_fround(Math_fround(f586 * f682) + Math_fround(f589 * f683)) + Math_fround(f592 * f698));
    f699 = Math_fround(Math_fround(Math_fround(f586 * f684) + Math_fround(f589 * f685)) + Math_fround(f592 * f699));
    f700 = Math_fround(Math_fround(Math_fround(f586 * f686) + Math_fround(f589 * f687)) + Math_fround(f592 * f700));
    HEAPF32[i632 >> 2] = Math_fround(f688 + f689);
    HEAPF32[i442 >> 2] = f690;
    HEAPF32[i443 >> 2] = f691;
    HEAPF32[i444 >> 2] = f692;
    HEAPF32[i445 >> 2] = f693;
    HEAPF32[i446 >> 2] = f694;
    HEAPF32[i447 >> 2] = f695;
    HEAPF32[i448 >> 2] = f696;
    HEAPF32[i449 >> 2] = f697;
    HEAPF32[i450 >> 2] = f698;
    HEAPF32[i451 >> 2] = f699;
    HEAPF32[i452 >> 2] = f700;
   }
   if (i453) {
    i65 = HEAP32[i625 >> 2] | 0;
    i68 = i65 + 1068538453 | 0;
    i69 = HEAP32[i245 >> 2] | 0;
    i67 = i69 + 1068538453 | 0;
    i62 = HEAP32[i246 >> 2] | 0;
    i52 = i62 + 1068538453 | 0;
    i51 = HEAP32[i247 >> 2] | 0;
    i64 = i51 + 1068538453 | 0;
    i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i66 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i68 = i68 << 11 ^ i68;
    i67 = i67 << 11 ^ i67;
    i52 = i52 << 11 ^ i52;
    i64 = i64 << 11 ^ i64;
    f698 = Math_fround(Math_fround((i63 ^ i67 ^ i67 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i71 ^ i52 ^ i52 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i66 ^ i64 ^ i64 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i633 >> 2] = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = f698;
    HEAPF32[i455 >> 2] = f699;
    HEAPF32[i456 >> 2] = f700;
    i65 = i65 + 1068538454 | 0;
    i69 = i69 + 1068538454 | 0;
    i62 = i62 + 1068538454 | 0;
    i51 = i51 + 1068538454 | 0;
    i70 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
    i68 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i66 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i64 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i65 = i65 << 11 ^ i65;
    i69 = i69 << 11 ^ i69;
    i62 = i62 << 11 ^ i62;
    i51 = i51 << 11 ^ i51;
    f700 = Math_fround(Math_fround((i68 ^ i69 ^ i69 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i66 ^ i62 ^ i62 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f698 = Math_fround(Math_fround((i64 ^ i51 ^ i51 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i457 >> 2] = Math_fround(Math_fround((i70 ^ i65 ^ i65 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i458 >> 2] = f700;
    HEAPF32[i459 >> 2] = f699;
    HEAPF32[i460 >> 2] = f698;
    i70 = HEAP32[i625 >> 2] | 0;
    i65 = i70 + 1068538455 | 0;
    i64 = HEAP32[i245 >> 2] | 0;
    i51 = i64 + 1068538455 | 0;
    i66 = HEAP32[i246 >> 2] | 0;
    i62 = i66 + 1068538455 | 0;
    i68 = HEAP32[i247 >> 2] | 0;
    i69 = i68 + 1068538455 | 0;
    i71 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
    i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i65 = i65 << 11 ^ i65;
    i51 = i51 << 11 ^ i51;
    i62 = i62 << 11 ^ i62;
    i69 = i69 << 11 ^ i69;
    f698 = Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i63 ^ i62 ^ i62 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i67 ^ i69 ^ i69 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i461 >> 2] = Math_fround(Math_fround((i71 ^ i65 ^ i65 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i462 >> 2] = f698;
    HEAPF32[i463 >> 2] = f699;
    HEAPF32[i464 >> 2] = f700;
    f700 = Math_fround(Math_fround(HEAPF32[i624 >> 2]) * Math_fround(1.0e5));
    f699 = Math_fround(Math_fround(HEAPF32[i241 >> 2]) * Math_fround(1.0e5));
    f698 = Math_fround(Math_fround(HEAPF32[i242 >> 2]) * Math_fround(1.0e5));
    i70 = i70 + 1068538453 + ~~f700 | 0;
    i64 = i64 + 1068538453 + ~~f699 | 0;
    i66 = i66 + 1068538453 + ~~f698 | 0;
    i68 = i68 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i243 >> 2]) * Math_fround(1.0e5)) | 0;
    i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
    i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
    i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i70 = i70 << 11 ^ i70;
    i64 = i64 << 11 ^ i64;
    i66 = i66 << 11 ^ i66;
    i68 = i68 << 11 ^ i68;
    f698 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i465 >> 2] = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i466 >> 2] = f698;
    HEAPF32[i467 >> 2] = f699;
    HEAPF32[i468 >> 2] = f700;
   }
   i62 = HEAP32[i218 >> 2] | 0;
   i63 = (i62 | 0) == 0;
   i64 = HEAP32[i125 >> 2] | 0;
   i65 = HEAP32[i127 >> 2] | 0;
   i66 = HEAP32[i240 >> 2] | 0;
   i67 = HEAP32[i128 >> 2] | 0;
   i68 = HEAP32[i221 >> 2] | 0;
   i69 = HEAP32[i222 >> 2] | 0;
   i70 = HEAP32[i223 >> 2] | 0;
   i71 = HEAP32[i646 >> 2] | 0;
   i52 = 0;
   do {
    i2 = i52 + i85 | 0;
    if (!i63) i2 = HEAP32[i62 + (i2 << 3) >> 2] | 0;
    i5 = i632 + (i52 << 2) | 0;
    i6 = i476 + (i52 << 2) | 0;
    i7 = i477 + (i52 << 2) | 0;
    i8 = i633 + (i52 << 2) | 0;
    i9 = i457 + (i52 << 2) | 0;
    i10 = i461 + (i52 << 2) | 0;
    i11 = i465 + (i52 << 2) | 0;
    i13 = i630 + (i52 << 2) | 0;
    i14 = i122 + (i52 << 2) | 0;
    i15 = i123 + (i52 << 2) | 0;
    i16 = i64 + (i2 << 4) | 0;
    i17 = i65 + (i2 << 4) | 0;
    i18 = i66 + (i2 << 2) | 0;
    i19 = i67 + (i2 << 2) | 0;
    i20 = i68 + (i2 << 2) | 0;
    i21 = i69 + (i2 << 2) | 0;
    i22 = i70 + (i2 << 2) | 0;
    i23 = i631 + (i52 << 2) | 0;
    i47 = i129 + (i52 << 2) | 0;
    i48 = i130 + (i52 << 2) | 0;
    i49 = i628 + (i52 << 2) | 0;
    i50 = i131 + (i52 << 2) | 0;
    i51 = i132 + (i52 << 2) | 0;
    i4 = i71 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i627 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i52 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i52 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i52 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i469) {
      i701 = i629 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i701 + 32 + (i52 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i470) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i471) {
      i701 = i649 + (HEAP32[i648 + ((i3 << 2) + i52 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i472) {
      i701 = i650 + (HEAP32[i648 + ((i3 << 2) + i52 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 32 + (i52 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 48 + (i52 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i473) {
      f700 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i49 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i50 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i51 >> 2];
      HEAPF32[i1 + 12 >> 2] = f700;
      i1 = i1 + 16 | 0;
     }
     if (!i474) {
      HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i47 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i48 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i475) {
      i2 = HEAP32[i21 >> 2] | 0;
      i701 = HEAP32[i22 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = i2;
      HEAP32[i1 + 8 >> 2] = i701;
      i1 = i1 + 12 | 0;
     }
     if (i439) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i478) {
      f700 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.00999999977));
      i701 = HEAP32[i19 >> 2] | 0;
      HEAPF32[i1 >> 2] = f700;
      HEAP32[i1 + 4 >> 2] = i701;
      i1 = i1 + 8 | 0;
     }
     if (!i479) {
      i701 = (HEAP32[i126 >> 2] & 2147483647 | 0) == 0 ? i618 : i17;
      HEAP32[i1 >> 2] = HEAP32[i701 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i480) {
      i701 = (HEAP32[i124 >> 2] & 2147483647 | 0) == 0 ? i618 : i16;
      HEAP32[i1 >> 2] = HEAP32[i701 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i453) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i121) {
      HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i15 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i52 = i52 + 1 | 0;
   } while ((i52 | 0) != 4);
  } while (0);
  i85 = i85 + 4 | 0;
 } while (i85 >>> 0 < i186 >>> 0);
 STACKTOP = i651;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i641, i646) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i641 = i641 | 0;
 i646 = i646 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, i564 = 0, i565 = 0, i566 = 0, i567 = 0, i568 = 0, i569 = 0, i570 = 0, i571 = 0, i572 = 0, i573 = 0, i574 = 0, i575 = 0, i576 = 0, i577 = 0, i578 = 0, i579 = 0, i580 = 0, i581 = 0, i582 = 0, i583 = 0, f584 = f0, f585 = f0, f586 = f0, f587 = f0, f588 = f0, f589 = f0, f590 = f0, f591 = f0, f592 = f0, f593 = f0, f594 = f0, f595 = f0, f596 = f0, f597 = f0, f598 = f0, f599 = f0, f600 = f0, f601 = f0, i602 = 0, i603 = 0, i604 = 0, i605 = 0, i606 = 0, i607 = 0, f608 = f0, f609 = f0, f610 = f0, f611 = f0, f612 = f0, f613 = f0, f614 = f0, f615 = f0, f616 = f0, f617 = f0, i618 = 0, i619 = 0, i620 = 0, i621 = 0, i622 = 0, i623 = 0, i624 = 0, i625 = 0, i626 = 0, i627 = 0, i628 = 0, i629 = 0, i630 = 0, i631 = 0, i632 = 0, i633 = 0, i634 = 0, f635 = f0, f636 = f0, f637 = f0, f638 = f0, f639 = f0, f640 = f0, f642 = f0, f643 = f0, f644 = f0, f645 = f0, f647 = f0, i648 = 0, i649 = 0, i650 = 0, i651 = 0, f652 = f0, f653 = f0, f654 = f0, f655 = f0, f656 = f0, f657 = f0, f658 = f0, f659 = f0, f660 = f0, f661 = f0, f662 = f0, f663 = f0, f664 = f0, f665 = f0, f666 = f0, f667 = f0, f668 = f0, f669 = f0, f670 = f0, f671 = f0, f672 = f0, f673 = f0, f674 = f0, f675 = f0, f676 = f0, f677 = f0, f678 = f0, f679 = f0, f680 = f0, f681 = f0, f682 = f0, f683 = f0, f684 = f0, f685 = f0, f686 = f0, f687 = f0, f688 = f0, f689 = f0, f690 = f0, f691 = f0, f692 = f0, f693 = f0, f694 = f0, f695 = f0, f696 = f0, f697 = f0, f698 = f0, f699 = f0, f700 = f0, i701 = 0;
 i651 = STACKTOP;
 STACKTOP = STACKTOP + 1632 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i648 = i651 + 1560 | 0;
 i649 = i651 + 1432 | 0;
 i650 = i651 + 1176 | 0;
 i6 = i651 + 1112 | 0;
 i4 = i651 + 1072 | 0;
 i618 = i651 + 1056 | 0;
 i619 = i651 + 1008 | 0;
 i620 = i651 + 960 | 0;
 i621 = i651 + 912 | 0;
 i622 = i651 + 896 | 0;
 i623 = i651 + 880 | 0;
 i624 = i651 + 864 | 0;
 i625 = i651 + 848 | 0;
 i626 = i651 + 832 | 0;
 i627 = i651 + 640 | 0;
 i628 = i651 + 592 | 0;
 i629 = i651 + 400 | 0;
 i630 = i651 + 256 | 0;
 i631 = i651 + 112 | 0;
 i632 = i651 + 64 | 0;
 i633 = i651;
 i634 = i3 + 332 | 0;
 f635 = Math_fround((HEAP32[i634 >> 2] & 4095) >>> 0);
 f636 = Math_fround(Math_fround(1.0) / f635);
 f637 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f638 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f639 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f640 = Math_fround(Math_fround(1.0) - f639);
 i5 = i3 + 420 | 0;
 f642 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f616 = Math_fround(HEAPF32[i2 >> 2]);
 f610 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f612 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f643 = Math_fround(HEAPF32[i2 >> 2]);
 f644 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f645 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f647 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f615 = Math_fround(HEAPF32[i2 >> 2]);
 f609 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f614 = Math_fround(HEAPF32[i2 >> 2]);
 f608 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 36 | 0;
 f617 = Math_fround(HEAPF32[i7 >> 2]);
 f611 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f613 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f584 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f585 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f586 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f587 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f588 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f589 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f590 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f591 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f592 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f593 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f594 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f595 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 f596 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f597 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f598 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f599 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f600 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f601 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 i602 = i648 + 12 | 0;
 i603 = i648 + 8 | 0;
 i604 = i648 + 4 | 0;
 i605 = i648 + 28 | 0;
 HEAP32[i648 >> 2] = 0;
 HEAP32[i648 + 4 >> 2] = 0;
 HEAP32[i648 + 8 >> 2] = 0;
 HEAP32[i648 + 12 >> 2] = 0;
 HEAP32[i605 >> 2] = 1;
 i606 = i648 + 24 | 0;
 HEAP32[i606 >> 2] = 1;
 i607 = i648 + 20 | 0;
 HEAP32[i607 >> 2] = 1;
 i575 = i648 + 16 | 0;
 HEAP32[i575 >> 2] = 1;
 i576 = i648 + 44 | 0;
 HEAP32[i576 >> 2] = 2;
 i577 = i648 + 40 | 0;
 HEAP32[i577 >> 2] = 2;
 i578 = i648 + 36 | 0;
 HEAP32[i578 >> 2] = 2;
 i579 = i648 + 32 | 0;
 HEAP32[i579 >> 2] = 2;
 i580 = i648 + 60 | 0;
 HEAP32[i580 >> 2] = 3;
 i581 = i648 + 56 | 0;
 HEAP32[i581 >> 2] = 3;
 i582 = i648 + 52 | 0;
 HEAP32[i582 >> 2] = 3;
 i583 = i648 + 48 | 0;
 HEAP32[i583 >> 2] = 3;
 i526 = i649 + 4 | 0;
 i550 = i649 + 8 | 0;
 i574 = i649 + 12 | 0;
 i502 = i649 + 16 | 0;
 HEAP32[i649 >> 2] = 0;
 HEAP32[i649 + 4 >> 2] = 0;
 HEAP32[i649 + 8 >> 2] = 0;
 HEAP32[i649 + 12 >> 2] = 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i525 = i649 + 20 | 0;
 HEAPF32[i525 >> 2] = Math_fround(1.0);
 i549 = i649 + 24 | 0;
 HEAPF32[i549 >> 2] = Math_fround(1.0);
 i573 = i649 + 28 | 0;
 HEAPF32[i573 >> 2] = Math_fround(1.0);
 i501 = i649 + 32 | 0;
 HEAPF32[i501 >> 2] = Math_fround(1.0);
 i524 = i649 + 36 | 0;
 HEAPF32[i524 >> 2] = Math_fround(1.0);
 i548 = i649 + 40 | 0;
 HEAPF32[i548 >> 2] = Math_fround(1.0);
 i572 = i649 + 44 | 0;
 HEAPF32[i572 >> 2] = Math_fround(1.0);
 i500 = i649 + 48 | 0;
 HEAPF32[i500 >> 2] = Math_fround(1.0);
 i523 = i649 + 52 | 0;
 HEAPF32[i523 >> 2] = Math_fround(1.0);
 i547 = i649 + 56 | 0;
 HEAPF32[i547 >> 2] = Math_fround(1.0);
 i571 = i649 + 60 | 0;
 HEAPF32[i571 >> 2] = Math_fround(1.0);
 i499 = i649 + 64 | 0;
 HEAPF32[i499 >> 2] = Math_fround(1.0);
 i522 = i649 + 68 | 0;
 HEAPF32[i522 >> 2] = Math_fround(1.0);
 i546 = i649 + 72 | 0;
 HEAPF32[i546 >> 2] = Math_fround(1.0);
 i570 = i649 + 76 | 0;
 HEAPF32[i570 >> 2] = Math_fround(1.0);
 i498 = i649 + 80 | 0;
 i521 = i649 + 84 | 0;
 i545 = i649 + 88 | 0;
 i569 = i649 + 92 | 0;
 i497 = i649 + 96 | 0;
 i520 = i649 + 100 | 0;
 i544 = i649 + 104 | 0;
 i568 = i649 + 108 | 0;
 i496 = i649 + 112 | 0;
 i519 = i649 + 116 | 0;
 i543 = i649 + 120 | 0;
 i567 = i649 + 124 | 0;
 i10 = i498;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i518 = i650 + 4 | 0;
 i542 = i650 + 8 | 0;
 i566 = i650 + 12 | 0;
 i495 = i650 + 16 | 0;
 HEAP32[i650 >> 2] = 0;
 HEAP32[i650 + 4 >> 2] = 0;
 HEAP32[i650 + 8 >> 2] = 0;
 HEAP32[i650 + 12 >> 2] = 0;
 HEAPF32[i495 >> 2] = Math_fround(1.0);
 i517 = i650 + 20 | 0;
 HEAPF32[i517 >> 2] = Math_fround(1.0);
 i541 = i650 + 24 | 0;
 HEAPF32[i541 >> 2] = Math_fround(1.0);
 i565 = i650 + 28 | 0;
 HEAPF32[i565 >> 2] = Math_fround(1.0);
 i494 = i650 + 32 | 0;
 i516 = i650 + 36 | 0;
 i540 = i650 + 40 | 0;
 i564 = i650 + 44 | 0;
 i493 = i650 + 48 | 0;
 i515 = i650 + 52 | 0;
 i539 = i650 + 56 | 0;
 i563 = i650 + 60 | 0;
 i492 = i650 + 64 | 0;
 HEAP32[i494 >> 2] = 0;
 HEAP32[i494 + 4 >> 2] = 0;
 HEAP32[i494 + 8 >> 2] = 0;
 HEAP32[i494 + 12 >> 2] = 0;
 HEAP32[i494 + 16 >> 2] = 0;
 HEAP32[i494 + 20 >> 2] = 0;
 HEAP32[i494 + 24 >> 2] = 0;
 HEAP32[i494 + 28 >> 2] = 0;
 HEAPF32[i492 >> 2] = Math_fround(1.0);
 i514 = i650 + 68 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i650 + 72 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i650 + 76 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i491 = i650 + 80 | 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i513 = i650 + 84 | 0;
 HEAPF32[i513 >> 2] = Math_fround(1.0);
 i537 = i650 + 88 | 0;
 HEAPF32[i537 >> 2] = Math_fround(1.0);
 i561 = i650 + 92 | 0;
 HEAPF32[i561 >> 2] = Math_fround(1.0);
 i490 = i650 + 96 | 0;
 i512 = i650 + 100 | 0;
 i536 = i650 + 104 | 0;
 i560 = i650 + 108 | 0;
 i489 = i650 + 112 | 0;
 i511 = i650 + 116 | 0;
 i535 = i650 + 120 | 0;
 i559 = i650 + 124 | 0;
 i488 = i650 + 128 | 0;
 HEAP32[i490 >> 2] = 0;
 HEAP32[i490 + 4 >> 2] = 0;
 HEAP32[i490 + 8 >> 2] = 0;
 HEAP32[i490 + 12 >> 2] = 0;
 HEAP32[i490 + 16 >> 2] = 0;
 HEAP32[i490 + 20 >> 2] = 0;
 HEAP32[i490 + 24 >> 2] = 0;
 HEAP32[i490 + 28 >> 2] = 0;
 HEAPF32[i488 >> 2] = Math_fround(1.0);
 i510 = i650 + 132 | 0;
 HEAPF32[i510 >> 2] = Math_fround(1.0);
 i534 = i650 + 136 | 0;
 HEAPF32[i534 >> 2] = Math_fround(1.0);
 i558 = i650 + 140 | 0;
 HEAPF32[i558 >> 2] = Math_fround(1.0);
 i487 = i650 + 144 | 0;
 i509 = i650 + 148 | 0;
 i533 = i650 + 152 | 0;
 i557 = i650 + 156 | 0;
 i486 = i650 + 160 | 0;
 i508 = i650 + 164 | 0;
 i532 = i650 + 168 | 0;
 i556 = i650 + 172 | 0;
 i485 = i650 + 176 | 0;
 i507 = i650 + 180 | 0;
 i531 = i650 + 184 | 0;
 i555 = i650 + 188 | 0;
 i484 = i650 + 192 | 0;
 i506 = i650 + 196 | 0;
 i530 = i650 + 200 | 0;
 i554 = i650 + 204 | 0;
 i483 = i650 + 208 | 0;
 i505 = i650 + 212 | 0;
 i529 = i650 + 216 | 0;
 i553 = i650 + 220 | 0;
 i482 = i650 + 224 | 0;
 i504 = i650 + 228 | 0;
 i528 = i650 + 232 | 0;
 i552 = i650 + 236 | 0;
 i481 = i650 + 240 | 0;
 i503 = i650 + 244 | 0;
 i527 = i650 + 248 | 0;
 i551 = i650 + 252 | 0;
 i10 = i487;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f73 = Math_fround(HEAPF32[i5 >> 2]);
 f55 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f72 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f74 = Math_fround(HEAPF32[i4 >> 2]);
 i475 = i4 + 4 | 0;
 f77 = Math_fround(HEAPF32[i475 >> 2]);
 i476 = i4 + 8 | 0;
 f78 = Math_fround(HEAPF32[i476 >> 2]);
 i477 = i4 + 12 | 0;
 f58 = Math_fround(HEAPF32[i477 >> 2]);
 i478 = i4 + 16 | 0;
 f54 = Math_fround(HEAPF32[i478 >> 2]);
 i479 = i4 + 20 | 0;
 f81 = Math_fround(HEAPF32[i479 >> 2]);
 i480 = i4 + 24 | 0;
 f60 = Math_fround(HEAPF32[i480 >> 2]);
 i186 = i4 + 28 | 0;
 f56 = Math_fround(HEAPF32[i186 >> 2]);
 i185 = i4 + 32 | 0;
 f84 = Math_fround(HEAPF32[i185 >> 2]);
 f75 = Math_fround(f77 * Math_fround(0.0));
 f76 = Math_fround(f78 * Math_fround(0.0));
 f59 = Math_fround(f54 * Math_fround(0.0));
 f80 = Math_fround(f81 * Math_fround(0.0));
 f79 = Math_fround(Math_fround(Math_fround(f73 * f58) + f59) + f80);
 f61 = Math_fround(f56 * Math_fround(0.0));
 f83 = Math_fround(f84 * Math_fround(0.0));
 f82 = Math_fround(Math_fround(Math_fround(f73 * f60) + f61) + f83);
 f57 = Math_fround(f74 * Math_fround(0.0));
 f77 = Math_fround(Math_fround(f57 + Math_fround(f55 * f77)) + f76);
 f58 = Math_fround(f58 * Math_fround(0.0));
 f80 = Math_fround(Math_fround(f58 + Math_fround(f55 * f54)) + f80);
 f60 = Math_fround(f60 * Math_fround(0.0));
 f83 = Math_fround(Math_fround(f60 + Math_fround(f55 * f56)) + f83);
 f78 = Math_fround(Math_fround(f57 + f75) + Math_fround(f72 * f78));
 f81 = Math_fround(Math_fround(f58 + f59) + Math_fround(f72 * f81));
 f84 = Math_fround(Math_fround(f60 + f61) + Math_fround(f72 * f84));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f73 * f74) + f75) + f76);
 HEAPF32[i475 >> 2] = f77;
 HEAPF32[i476 >> 2] = f78;
 HEAPF32[i477 >> 2] = f79;
 HEAPF32[i478 >> 2] = f80;
 HEAPF32[i479 >> 2] = f81;
 HEAPF32[i480 >> 2] = f82;
 HEAPF32[i186 >> 2] = f83;
 HEAPF32[i185 >> 2] = f84;
 i185 = (i7 | 0) == 27;
 HEAP32[i618 >> 2] = 0;
 HEAP32[i618 + 4 >> 2] = 0;
 HEAP32[i618 + 8 >> 2] = 0;
 HEAP32[i618 + 12 >> 2] = 0;
 i186 = HEAP32[i641 + 12 >> 2] | 0;
 if (!i186) {
  STACKTOP = i651;
  return;
 }
 i187 = i619 + 12 | 0;
 i188 = i619 + 8 | 0;
 i189 = i619 + 4 | 0;
 i190 = i619 + 16 | 0;
 i191 = i619 + 28 | 0;
 i192 = i619 + 24 | 0;
 i193 = i619 + 20 | 0;
 i194 = i619 + 32 | 0;
 i195 = i619 + 44 | 0;
 i196 = i619 + 40 | 0;
 i197 = i619 + 36 | 0;
 i198 = i620 + 12 | 0;
 i199 = i620 + 8 | 0;
 i200 = i620 + 4 | 0;
 i201 = i620 + 16 | 0;
 i202 = i620 + 28 | 0;
 i203 = i620 + 24 | 0;
 i204 = i620 + 20 | 0;
 i205 = i620 + 32 | 0;
 i206 = i620 + 44 | 0;
 i207 = i620 + 40 | 0;
 i208 = i620 + 36 | 0;
 i209 = i621 + 12 | 0;
 i210 = i621 + 8 | 0;
 i211 = i621 + 4 | 0;
 i212 = i621 + 28 | 0;
 i213 = i621 + 24 | 0;
 i214 = i621 + 20 | 0;
 i215 = i621 + 44 | 0;
 i216 = i621 + 40 | 0;
 i217 = i621 + 36 | 0;
 i218 = i646 + 20 | 0;
 i219 = i641 + 20 | 0;
 i220 = i641 + 40 | 0;
 i221 = i641 + 300 | 0;
 i222 = i641 + 320 | 0;
 i223 = i641 + 340 | 0;
 i224 = i641 + 60 | 0;
 i225 = i641 + 80 | 0;
 i226 = i641 + 100 | 0;
 i227 = i641 + 120 | 0;
 i228 = i641 + 140 | 0;
 i229 = i641 + 160 | 0;
 i230 = i621 + 16 | 0;
 i231 = i621 + 32 | 0;
 i232 = i646 + 4 | 0;
 i233 = i622 + 4 | 0;
 i234 = i622 + 8 | 0;
 i235 = i622 + 12 | 0;
 i236 = i646 + 8 | 0;
 i237 = i623 + 4 | 0;
 i238 = i623 + 8 | 0;
 i239 = i623 + 12 | 0;
 i240 = i641 + 520 | 0;
 i241 = i624 + 4 | 0;
 i242 = i624 + 8 | 0;
 i243 = i624 + 12 | 0;
 i244 = i641 + 500 | 0;
 i245 = i625 + 4 | 0;
 i246 = i625 + 8 | 0;
 i247 = i625 + 12 | 0;
 i248 = i646 + 16 | 0;
 i249 = i626 + 4 | 0;
 i250 = i626 + 8 | 0;
 i251 = i626 + 12 | 0;
 i252 = i619 + 16 | 0;
 i253 = i619 + 32 | 0;
 i254 = i628 + 4 | 0;
 i255 = i628 + 8 | 0;
 i256 = i628 + 12 | 0;
 i257 = i628 + 16 | 0;
 i258 = i628 + 20 | 0;
 i259 = i628 + 24 | 0;
 i260 = i628 + 28 | 0;
 i261 = i628 + 32 | 0;
 i262 = i628 + 36 | 0;
 i263 = i628 + 40 | 0;
 i264 = i628 + 44 | 0;
 i265 = i629 + 96 | 0;
 i266 = i629 + 100 | 0;
 i267 = i629 + 104 | 0;
 i268 = i629 + 108 | 0;
 i269 = i629 + 112 | 0;
 i270 = i629 + 116 | 0;
 i271 = i629 + 120 | 0;
 i272 = i629 + 124 | 0;
 i273 = i629 + 128 | 0;
 i274 = i629 + 132 | 0;
 i275 = i629 + 136 | 0;
 i276 = i629 + 140 | 0;
 i277 = i629 + 128 | 0;
 i278 = i629 + 112 | 0;
 i279 = i629 + 4 | 0;
 i280 = i629 + 8 | 0;
 i281 = i629 + 12 | 0;
 i282 = i629 + 16 | 0;
 i283 = i629 + 20 | 0;
 i284 = i629 + 24 | 0;
 i285 = i629 + 28 | 0;
 i286 = i629 + 32 | 0;
 i287 = i629 + 36 | 0;
 i288 = i629 + 40 | 0;
 i289 = i629 + 44 | 0;
 i290 = i629 + 16 | 0;
 i291 = i629 + 32 | 0;
 i292 = i629 + 48 | 0;
 i293 = i629 + 52 | 0;
 i294 = i629 + 56 | 0;
 i295 = i629 + 60 | 0;
 i296 = i629 + 64 | 0;
 i297 = i629 + 68 | 0;
 i298 = i629 + 72 | 0;
 i299 = i629 + 76 | 0;
 i300 = i629 + 80 | 0;
 i301 = i629 + 84 | 0;
 i302 = i629 + 88 | 0;
 i303 = i629 + 92 | 0;
 i304 = i620 + 16 | 0;
 i305 = i620 + 32 | 0;
 i306 = i630 + 4 | 0;
 i307 = i630 + 8 | 0;
 i308 = i630 + 12 | 0;
 i309 = i630 + 48 | 0;
 i310 = i630 + 52 | 0;
 i311 = i630 + 56 | 0;
 i312 = i630 + 60 | 0;
 i313 = i630 + 96 | 0;
 i314 = i630 + 100 | 0;
 i315 = i630 + 104 | 0;
 i316 = i630 + 108 | 0;
 i317 = i630 + 16 | 0;
 i318 = i630 + 20 | 0;
 i319 = i630 + 24 | 0;
 i320 = i630 + 28 | 0;
 i321 = i630 + 64 | 0;
 i322 = i630 + 68 | 0;
 i323 = i630 + 72 | 0;
 i324 = i630 + 76 | 0;
 i325 = i630 + 112 | 0;
 i326 = i630 + 116 | 0;
 i327 = i630 + 120 | 0;
 i328 = i630 + 124 | 0;
 i329 = i630 + 32 | 0;
 i330 = i630 + 36 | 0;
 i331 = i630 + 40 | 0;
 i332 = i630 + 44 | 0;
 i333 = i630 + 80 | 0;
 i334 = i630 + 84 | 0;
 i335 = i630 + 88 | 0;
 i336 = i630 + 92 | 0;
 i337 = i630 + 128 | 0;
 i338 = i630 + 132 | 0;
 i339 = i630 + 136 | 0;
 i340 = i630 + 140 | 0;
 i341 = i629 + 96 | 0;
 i342 = i631 + 4 | 0;
 i343 = i631 + 8 | 0;
 i344 = i631 + 12 | 0;
 i345 = i631 + 48 | 0;
 i346 = i631 + 52 | 0;
 i347 = i631 + 56 | 0;
 i348 = i631 + 60 | 0;
 i349 = i631 + 96 | 0;
 i350 = i631 + 100 | 0;
 i351 = i631 + 104 | 0;
 i352 = i631 + 108 | 0;
 i353 = i631 + 16 | 0;
 i354 = i631 + 20 | 0;
 i355 = i631 + 24 | 0;
 i356 = i631 + 28 | 0;
 i357 = i631 + 64 | 0;
 i358 = i631 + 68 | 0;
 i359 = i631 + 72 | 0;
 i360 = i631 + 76 | 0;
 i361 = i631 + 112 | 0;
 i362 = i631 + 116 | 0;
 i363 = i631 + 120 | 0;
 i364 = i631 + 124 | 0;
 i365 = i631 + 32 | 0;
 i366 = i631 + 36 | 0;
 i367 = i631 + 40 | 0;
 i368 = i631 + 44 | 0;
 i369 = i631 + 80 | 0;
 i370 = i631 + 84 | 0;
 i371 = i631 + 88 | 0;
 i372 = i631 + 92 | 0;
 i373 = i631 + 128 | 0;
 i374 = i631 + 132 | 0;
 i375 = i631 + 136 | 0;
 i376 = i631 + 140 | 0;
 i377 = i627 + 4 | 0;
 i378 = i627 + 8 | 0;
 i379 = i627 + 12 | 0;
 i380 = i627 + 16 | 0;
 i381 = i627 + 20 | 0;
 i382 = i627 + 24 | 0;
 i383 = i627 + 28 | 0;
 i384 = i627 + 32 | 0;
 i385 = i627 + 36 | 0;
 i386 = i627 + 40 | 0;
 i387 = i627 + 44 | 0;
 i388 = i627 + 48 | 0;
 i389 = i627 + 52 | 0;
 i390 = i627 + 56 | 0;
 i391 = i627 + 60 | 0;
 i392 = i627 + 64 | 0;
 i393 = i627 + 68 | 0;
 i394 = i627 + 72 | 0;
 i395 = i627 + 76 | 0;
 i396 = i627 + 80 | 0;
 i397 = i627 + 84 | 0;
 i398 = i627 + 88 | 0;
 i399 = i627 + 92 | 0;
 i400 = i627 + 96 | 0;
 i401 = i627 + 100 | 0;
 i402 = i627 + 104 | 0;
 i403 = i627 + 108 | 0;
 i404 = i627 + 112 | 0;
 i405 = i627 + 116 | 0;
 i406 = i627 + 120 | 0;
 i407 = i627 + 124 | 0;
 i408 = i627 + 128 | 0;
 i409 = i627 + 132 | 0;
 i410 = i627 + 136 | 0;
 i411 = i627 + 140 | 0;
 i412 = i627 + 144 | 0;
 i413 = i627 + 148 | 0;
 i414 = i627 + 152 | 0;
 i415 = i627 + 156 | 0;
 i416 = i627 + 160 | 0;
 i417 = i627 + 164 | 0;
 i418 = i627 + 168 | 0;
 i419 = i627 + 172 | 0;
 i420 = i627 + 176 | 0;
 i421 = i627 + 180 | 0;
 i422 = i627 + 184 | 0;
 i423 = i627 + 188 | 0;
 i424 = (i7 & 48 | 0) == 0;
 i147 = i629 + 4 | 0;
 i164 = i629 + 8 | 0;
 i181 = i629 + 12 | 0;
 i425 = i629 + 16 | 0;
 i142 = i629 + 20 | 0;
 i159 = i629 + 24 | 0;
 i176 = i629 + 28 | 0;
 i426 = i629 + 32 | 0;
 i137 = i629 + 36 | 0;
 i154 = i629 + 40 | 0;
 i171 = i629 + 44 | 0;
 i427 = i629 + 48 | 0;
 i146 = i629 + 52 | 0;
 i163 = i629 + 56 | 0;
 i180 = i629 + 60 | 0;
 i428 = i629 + 64 | 0;
 i141 = i629 + 68 | 0;
 i158 = i629 + 72 | 0;
 i175 = i629 + 76 | 0;
 i429 = i629 + 80 | 0;
 i136 = i629 + 84 | 0;
 i153 = i629 + 88 | 0;
 i170 = i629 + 92 | 0;
 i430 = i629 + 96 | 0;
 i145 = i629 + 100 | 0;
 i162 = i629 + 104 | 0;
 i179 = i629 + 108 | 0;
 i431 = i629 + 112 | 0;
 i140 = i629 + 116 | 0;
 i157 = i629 + 120 | 0;
 i174 = i629 + 124 | 0;
 i432 = i629 + 128 | 0;
 i135 = i629 + 132 | 0;
 i152 = i629 + 136 | 0;
 i169 = i629 + 140 | 0;
 i433 = i629 + 144 | 0;
 i144 = i629 + 148 | 0;
 i161 = i629 + 152 | 0;
 i178 = i629 + 156 | 0;
 i434 = i629 + 160 | 0;
 i139 = i629 + 164 | 0;
 i156 = i629 + 168 | 0;
 i173 = i629 + 172 | 0;
 i435 = i629 + 176 | 0;
 i134 = i629 + 180 | 0;
 i151 = i629 + 184 | 0;
 i168 = i629 + 188 | 0;
 i148 = i630 + 4 | 0;
 i165 = i630 + 8 | 0;
 i182 = i630 + 12 | 0;
 i436 = i630 + 16 | 0;
 i143 = i630 + 20 | 0;
 i160 = i630 + 24 | 0;
 i177 = i630 + 28 | 0;
 i437 = i630 + 32 | 0;
 i138 = i630 + 36 | 0;
 i155 = i630 + 40 | 0;
 i172 = i630 + 44 | 0;
 i150 = i631 + 4 | 0;
 i167 = i631 + 8 | 0;
 i184 = i631 + 12 | 0;
 i438 = i631 + 16 | 0;
 i149 = i631 + 20 | 0;
 i166 = i631 + 24 | 0;
 i183 = i631 + 28 | 0;
 i133 = i631 + 32 | 0;
 i439 = (i7 & 512 | 0) != 0;
 i440 = i621 + 16 | 0;
 i441 = i621 + 32 | 0;
 i442 = i632 + 4 | 0;
 i443 = i632 + 8 | 0;
 i444 = i632 + 12 | 0;
 i445 = i632 + 16 | 0;
 i446 = i632 + 20 | 0;
 i447 = i632 + 24 | 0;
 i448 = i632 + 28 | 0;
 i449 = i632 + 32 | 0;
 i450 = i632 + 36 | 0;
 i451 = i632 + 40 | 0;
 i452 = i632 + 44 | 0;
 i453 = (i7 & 8192 | 0) != 0;
 i454 = i633 + 4 | 0;
 i455 = i633 + 8 | 0;
 i456 = i633 + 12 | 0;
 i457 = i633 + 16 | 0;
 i458 = i633 + 20 | 0;
 i459 = i633 + 24 | 0;
 i460 = i633 + 28 | 0;
 i461 = i633 + 32 | 0;
 i462 = i633 + 36 | 0;
 i463 = i633 + 40 | 0;
 i464 = i633 + 44 | 0;
 i465 = i633 + 48 | 0;
 i466 = i633 + 52 | 0;
 i467 = i633 + 56 | 0;
 i468 = i633 + 60 | 0;
 i469 = (i7 & 2 | 0) == 0;
 i470 = (i7 & 8 | 0) == 0;
 i471 = (i7 & 16 | 0) == 0;
 i472 = (i7 & 32 | 0) == 0;
 i473 = (i7 & 64 | 0) == 0;
 i474 = (i7 & 128 | 0) == 0;
 i475 = (i7 & 256 | 0) == 0;
 i476 = i632 + 16 | 0;
 i477 = i632 + 32 | 0;
 i478 = (i7 & 1024 | 0) == 0;
 i479 = (i7 & 2048 | 0) == 0;
 i480 = (i7 & 4096 | 0) == 0;
 i121 = (i7 & 4 | 0) == 0;
 i122 = i630 + 16 | 0;
 i123 = i630 + 32 | 0;
 i124 = i641 + 864 | 0;
 i125 = i641 + 848 | 0;
 i126 = i641 + 844 | 0;
 i127 = i641 + 828 | 0;
 i128 = i641 + 540 | 0;
 i129 = i631 + 16 | 0;
 i130 = i631 + 32 | 0;
 i131 = i628 + 16 | 0;
 i132 = i628 + 32 | 0;
 i86 = i8 + 32 | 0;
 i87 = i627 + 16 | 0;
 i88 = i627 + 32 | 0;
 i89 = i629 + 16 | 0;
 i90 = i629 + 32 | 0;
 i91 = i627 + 48 | 0;
 i92 = i91 + 16 | 0;
 i93 = i91 + 32 | 0;
 i94 = i427 + 16 | 0;
 i95 = i427 + 32 | 0;
 i96 = i400 + 16 | 0;
 i97 = i400 + 32 | 0;
 i98 = i430 + 16 | 0;
 i99 = i430 + 32 | 0;
 i100 = i412 + 16 | 0;
 i101 = i412 + 32 | 0;
 i102 = i433 + 16 | 0;
 i103 = i433 + 32 | 0;
 i104 = i627 + 16 | 0;
 i105 = i627 + 32 | 0;
 i106 = i629 + 16 | 0;
 i107 = i629 + 32 | 0;
 i108 = i627 + 48 | 0;
 i109 = i108 + 16 | 0;
 i110 = i108 + 32 | 0;
 i111 = i427 + 16 | 0;
 i112 = i427 + 32 | 0;
 i113 = i400 + 16 | 0;
 i114 = i400 + 32 | 0;
 i115 = i430 + 16 | 0;
 i116 = i430 + 32 | 0;
 i117 = i412 + 16 | 0;
 i118 = i412 + 32 | 0;
 i119 = i433 + 16 | 0;
 i120 = i433 + 32 | 0;
 i85 = 0;
 i1 = i9;
 do {
  i10 = i619;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i620;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i621;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i622 >> 2] = 0;
  HEAP32[i622 + 4 >> 2] = 0;
  HEAP32[i622 + 8 >> 2] = 0;
  HEAP32[i622 + 12 >> 2] = 0;
  HEAP32[i623 >> 2] = 0;
  HEAP32[i623 + 4 >> 2] = 0;
  HEAP32[i623 + 8 >> 2] = 0;
  HEAP32[i623 + 12 >> 2] = 0;
  HEAP32[i624 >> 2] = 0;
  HEAP32[i624 + 4 >> 2] = 0;
  HEAP32[i624 + 8 >> 2] = 0;
  HEAP32[i624 + 12 >> 2] = 0;
  HEAP32[i625 >> 2] = 0;
  HEAP32[i625 + 4 >> 2] = 0;
  HEAP32[i625 + 8 >> 2] = 0;
  HEAP32[i625 + 12 >> 2] = 0;
  HEAP32[i626 >> 2] = 0;
  HEAP32[i626 + 4 >> 2] = 0;
  HEAP32[i626 + 8 >> 2] = 0;
  HEAP32[i626 + 12 >> 2] = 0;
  i20 = HEAP32[i218 >> 2] | 0;
  if (!i20) {
   i70 = (HEAP32[i641 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i70 + 4 >> 2] | 0;
   i68 = HEAP32[i70 + 8 >> 2] | 0;
   i71 = HEAP32[i70 + 12 >> 2] | 0;
   i67 = (HEAP32[i219 >> 2] | 0) + (i85 << 2) | 0;
   i66 = HEAP32[i67 >> 2] | 0;
   i65 = HEAP32[i67 + 4 >> 2] | 0;
   i64 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   i51 = (HEAP32[i220 >> 2] | 0) + (i85 << 2) | 0;
   i63 = HEAP32[i51 >> 2] | 0;
   i62 = HEAP32[i51 + 4 >> 2] | 0;
   i52 = HEAP32[i51 + 8 >> 2] | 0;
   i51 = HEAP32[i51 + 12 >> 2] | 0;
   HEAP32[i619 >> 2] = HEAP32[i70 >> 2];
   HEAP32[i189 >> 2] = i69;
   HEAP32[i188 >> 2] = i68;
   HEAP32[i187 >> 2] = i71;
   HEAP32[i190 >> 2] = i66;
   HEAP32[i193 >> 2] = i65;
   HEAP32[i192 >> 2] = i64;
   HEAP32[i191 >> 2] = i67;
   HEAP32[i194 >> 2] = i63;
   HEAP32[i197 >> 2] = i62;
   HEAP32[i196 >> 2] = i52;
   HEAP32[i195 >> 2] = i51;
   i51 = (HEAP32[i221 >> 2] | 0) + (i85 << 2) | 0;
   i52 = HEAP32[i51 + 4 >> 2] | 0;
   i62 = HEAP32[i51 + 8 >> 2] | 0;
   i63 = HEAP32[i51 + 12 >> 2] | 0;
   i67 = (HEAP32[i222 >> 2] | 0) + (i85 << 2) | 0;
   i64 = HEAP32[i67 >> 2] | 0;
   i65 = HEAP32[i67 + 4 >> 2] | 0;
   i66 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   i71 = (HEAP32[i223 >> 2] | 0) + (i85 << 2) | 0;
   i68 = HEAP32[i71 >> 2] | 0;
   i69 = HEAP32[i71 + 4 >> 2] | 0;
   i70 = HEAP32[i71 + 8 >> 2] | 0;
   i71 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i620 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i200 >> 2] = i52;
   HEAP32[i199 >> 2] = i62;
   HEAP32[i198 >> 2] = i63;
   HEAP32[i201 >> 2] = i64;
   HEAP32[i204 >> 2] = i65;
   HEAP32[i203 >> 2] = i66;
   HEAP32[i202 >> 2] = i67;
   HEAP32[i205 >> 2] = i68;
   HEAP32[i208 >> 2] = i69;
   HEAP32[i207 >> 2] = i70;
   HEAP32[i206 >> 2] = i71;
   i71 = (HEAP32[i224 >> 2] | 0) + (i85 << 2) | 0;
   f72 = Math_fround(HEAPF32[i71 >> 2]);
   f46 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f54 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i225 >> 2] | 0) + (i85 << 2) | 0;
   f55 = Math_fround(HEAPF32[i71 >> 2]);
   f56 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f58 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i226 >> 2] | 0) + (i85 << 2) | 0;
   f59 = Math_fround(HEAPF32[i71 >> 2]);
   f60 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f84 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i227 >> 2] | 0) + (i85 << 2) | 0;
   f73 = Math_fround(HEAPF32[i71 >> 2]);
   f74 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f75 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f76 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i228 >> 2] | 0) + (i85 << 2) | 0;
   f77 = Math_fround(HEAPF32[i71 >> 2]);
   f78 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f79 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f80 = Math_fround(HEAPF32[i71 + 12 >> 2]);
   i71 = (HEAP32[i229 >> 2] | 0) + (i85 << 2) | 0;
   f81 = Math_fround(HEAPF32[i71 >> 2]);
   f82 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f83 = Math_fround(HEAPF32[i71 + 8 >> 2]);
   f74 = Math_fround(f46 + f74);
   f75 = Math_fround(f53 + f75);
   f76 = Math_fround(f54 + f76);
   f77 = Math_fround(f55 + f77);
   f78 = Math_fround(f56 + f78);
   f79 = Math_fround(f57 + f79);
   f80 = Math_fround(f58 + f80);
   f81 = Math_fround(f59 + f81);
   f82 = Math_fround(f60 + f82);
   f83 = Math_fround(f61 + f83);
   f84 = Math_fround(f84 + Math_fround(HEAPF32[i71 + 12 >> 2]));
   HEAPF32[i621 >> 2] = Math_fround(f72 + f73);
   HEAPF32[i211 >> 2] = f74;
   HEAPF32[i210 >> 2] = f75;
   HEAPF32[i209 >> 2] = f76;
   HEAPF32[i230 >> 2] = f77;
   HEAPF32[i214 >> 2] = f78;
   HEAPF32[i213 >> 2] = f79;
   HEAPF32[i212 >> 2] = f80;
   HEAPF32[i231 >> 2] = f81;
   HEAPF32[i217 >> 2] = f82;
   HEAPF32[i216 >> 2] = f83;
   HEAPF32[i215 >> 2] = f84;
   i71 = (HEAP32[i232 >> 2] | 0) + (i85 << 2) | 0;
   i70 = HEAP32[i71 + 4 >> 2] | 0;
   i69 = HEAP32[i71 + 8 >> 2] | 0;
   i68 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i622 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i233 >> 2] = i70;
   HEAP32[i234 >> 2] = i69;
   HEAP32[i235 >> 2] = i68;
   i68 = (HEAP32[i236 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i68 + 4 >> 2] | 0;
   i70 = HEAP32[i68 + 8 >> 2] | 0;
   i71 = HEAP32[i68 + 12 >> 2] | 0;
   HEAP32[i623 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i237 >> 2] = i69;
   HEAP32[i238 >> 2] = i70;
   HEAP32[i239 >> 2] = i71;
   i71 = (HEAP32[i240 >> 2] | 0) + (i85 << 2) | 0;
   i70 = HEAP32[i71 + 4 >> 2] | 0;
   i69 = HEAP32[i71 + 8 >> 2] | 0;
   i68 = HEAP32[i71 + 12 >> 2] | 0;
   HEAP32[i624 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i241 >> 2] = i70;
   HEAP32[i242 >> 2] = i69;
   HEAP32[i243 >> 2] = i68;
   i68 = (HEAP32[i244 >> 2] | 0) + (i85 << 2) | 0;
   i69 = HEAP32[i68 + 4 >> 2] | 0;
   i70 = HEAP32[i68 + 8 >> 2] | 0;
   i71 = HEAP32[i68 + 12 >> 2] | 0;
   HEAP32[i625 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i245 >> 2] = i69;
   HEAP32[i246 >> 2] = i70;
   HEAP32[i247 >> 2] = i71;
   if (HEAP32[i634 >> 2] & 268435456 | 0) {
    i68 = (HEAP32[i248 >> 2] | 0) + (i85 << 2) | 0;
    i69 = HEAP32[i68 + 4 >> 2] | 0;
    i70 = HEAP32[i68 + 8 >> 2] | 0;
    i71 = HEAP32[i68 + 12 >> 2] | 0;
    HEAP32[i626 >> 2] = HEAP32[i68 >> 2];
    HEAP32[i249 >> 2] = i69;
    HEAP32[i250 >> 2] = i70;
    HEAP32[i251 >> 2] = i71;
   }
  } else {
   i3 = HEAP32[i224 >> 2] | 0;
   i4 = HEAP32[i227 >> 2] | 0;
   i5 = HEAP32[i219 >> 2] | 0;
   i6 = HEAP32[i222 >> 2] | 0;
   i7 = HEAP32[i225 >> 2] | 0;
   i8 = HEAP32[i228 >> 2] | 0;
   i9 = HEAP32[i220 >> 2] | 0;
   i10 = HEAP32[i223 >> 2] | 0;
   i11 = HEAP32[i226 >> 2] | 0;
   i13 = HEAP32[i229 >> 2] | 0;
   i14 = HEAP32[i232 >> 2] | 0;
   i15 = HEAP32[i236 >> 2] | 0;
   i16 = HEAP32[i240 >> 2] | 0;
   i17 = HEAP32[i244 >> 2] | 0;
   i18 = HEAP32[i641 >> 2] | 0;
   i19 = HEAP32[i221 >> 2] | 0;
   i21 = (HEAP32[i634 >> 2] & 268435456 | 0) == 0;
   i22 = HEAP32[i248 >> 2] | 0;
   i2 = 0;
   do {
    i23 = HEAP32[i20 + (i2 + i85 << 3) >> 2] | 0;
    HEAP32[i619 + (i2 << 2) >> 2] = HEAP32[i18 + (i23 << 2) >> 2];
    HEAP32[i620 + (i2 << 2) >> 2] = HEAP32[i19 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i3 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i2 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i4 + (i23 << 2) >> 2]));
    i71 = i2 + 4 | 0;
    HEAP32[i619 + (i71 << 2) >> 2] = HEAP32[i5 + (i23 << 2) >> 2];
    HEAP32[i620 + (i71 << 2) >> 2] = HEAP32[i6 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i7 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i71 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i8 + (i23 << 2) >> 2]));
    i71 = i2 + 8 | 0;
    HEAP32[i619 + (i71 << 2) >> 2] = HEAP32[i9 + (i23 << 2) >> 2];
    HEAP32[i620 + (i71 << 2) >> 2] = HEAP32[i10 + (i23 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i11 + (i23 << 2) >> 2]);
    HEAPF32[i621 + (i71 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i13 + (i23 << 2) >> 2]));
    HEAP32[i622 + (i2 << 2) >> 2] = HEAP32[i14 + (i23 << 2) >> 2];
    HEAP32[i623 + (i2 << 2) >> 2] = HEAP32[i15 + (i23 << 2) >> 2];
    HEAP32[i624 + (i2 << 2) >> 2] = HEAP32[i16 + (i23 << 2) >> 2];
    HEAP32[i625 + (i2 << 2) >> 2] = HEAP32[i17 + (i23 << 2) >> 2];
    if (!i21) HEAP32[i626 + (i2 << 2) >> 2] = HEAP32[i22 + (i23 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f40 = Math_fround(HEAPF32[i619 >> 2]);
  f25 = Math_fround(f584 * f40);
  f37 = Math_fround(HEAPF32[i189 >> 2]);
  f39 = Math_fround(f584 * f37);
  f84 = Math_fround(HEAPF32[i188 >> 2]);
  f24 = Math_fround(f584 * f84);
  f82 = Math_fround(HEAPF32[i187 >> 2]);
  f31 = Math_fround(f584 * f82);
  f34 = Math_fround(HEAPF32[i252 >> 2]);
  f28 = Math_fround(f587 * f34);
  f33 = Math_fround(HEAPF32[i193 >> 2]);
  f29 = Math_fround(f587 * f33);
  f83 = Math_fround(HEAPF32[i192 >> 2]);
  f35 = Math_fround(f587 * f83);
  f81 = Math_fround(HEAPF32[i191 >> 2]);
  f28 = Math_fround(f25 + f28);
  f29 = Math_fround(f39 + f29);
  f35 = Math_fround(f24 + f35);
  f31 = Math_fround(f31 + Math_fround(f587 * f81));
  f24 = Math_fround(HEAPF32[i253 >> 2]);
  f39 = Math_fround(f590 * f24);
  f25 = Math_fround(HEAPF32[i197 >> 2]);
  f32 = Math_fround(f590 * f25);
  f26 = Math_fround(HEAPF32[i196 >> 2]);
  f36 = Math_fround(f590 * f26);
  f30 = Math_fround(HEAPF32[i195 >> 2]);
  f32 = Math_fround(f593 + Math_fround(f29 + f32));
  f36 = Math_fround(f593 + Math_fround(f35 + f36));
  f31 = Math_fround(f593 + Math_fround(f31 + Math_fround(f590 * f30)));
  HEAPF32[i628 >> 2] = Math_fround(f593 + Math_fround(f28 + f39));
  HEAPF32[i254 >> 2] = f32;
  HEAPF32[i255 >> 2] = f36;
  HEAPF32[i256 >> 2] = f31;
  f31 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f37) + Math_fround(f588 * f33)) + Math_fround(f591 * f25)));
  f36 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f84) + Math_fround(f588 * f83)) + Math_fround(f591 * f26)));
  f32 = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f82) + Math_fround(f588 * f81)) + Math_fround(f591 * f30)));
  HEAPF32[i257 >> 2] = Math_fround(f594 + Math_fround(Math_fround(Math_fround(f585 * f40) + Math_fround(f588 * f34)) + Math_fround(f591 * f24)));
  HEAPF32[i258 >> 2] = f31;
  HEAPF32[i259 >> 2] = f36;
  HEAPF32[i260 >> 2] = f32;
  f32 = Math_fround(f595 + Math_fround(Math_fround(f592 * f25) + Math_fround(Math_fround(f589 * f33) + Math_fround(f586 * f37))));
  f36 = Math_fround(f595 + Math_fround(Math_fround(f592 * f26) + Math_fround(Math_fround(f589 * f83) + Math_fround(f586 * f84))));
  f31 = Math_fround(f595 + Math_fround(Math_fround(f592 * f30) + Math_fround(Math_fround(f589 * f81) + Math_fround(f586 * f82))));
  HEAPF32[i261 >> 2] = Math_fround(f595 + Math_fround(Math_fround(f592 * f24) + Math_fround(Math_fround(f589 * f34) + Math_fround(f586 * f40))));
  HEAPF32[i262 >> 2] = f32;
  HEAPF32[i263 >> 2] = f36;
  HEAPF32[i264 >> 2] = f31;
  f24 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f40) + Math_fround(f644 * f34)) + Math_fround(f645 * f24)));
  f25 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f37) + Math_fround(f644 * f33)) + Math_fround(f645 * f25)));
  f26 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f84) + Math_fround(f644 * f83)) + Math_fround(f645 * f26)));
  f30 = Math_fround(f647 + Math_fround(Math_fround(Math_fround(f643 * f82) + Math_fround(f644 * f81)) + Math_fround(f645 * f30)));
  f81 = Math_fround(f614 + Math_fround(f615 * f24));
  f82 = Math_fround(f614 + Math_fround(f615 * f25));
  f83 = Math_fround(f614 + Math_fround(f615 * f26));
  f84 = Math_fround(f614 + Math_fround(f615 * f30));
  f24 = Math_fround(f608 + Math_fround(f609 * f24));
  f25 = Math_fround(f608 + Math_fround(f609 * f25));
  f26 = Math_fround(f608 + Math_fround(f609 * f26));
  f30 = Math_fround(f608 + Math_fround(f609 * f30));
  f33 = Math_fround(HEAPF32[i622 >> 2]);
  f37 = Math_fround(HEAPF32[i233 >> 2]);
  f34 = Math_fround(HEAPF32[i234 >> 2]);
  f40 = Math_fround(HEAPF32[i235 >> 2]);
  f31 = Math_fround(HEAPF32[i623 >> 2]);
  f36 = Math_fround(HEAPF32[i237 >> 2]);
  f32 = Math_fround(HEAPF32[i238 >> 2]);
  f39 = Math_fround(HEAPF32[i239 >> 2]);
  f28 = f33 > f31 ? f33 : f31;
  f35 = f37 > f36 ? f37 : f36;
  f29 = f34 > f32 ? f34 : f32;
  f38 = f40 > f39 ? f40 : f39;
  f78 = Math_fround((f28 > f81 ? f28 : f81) * Math_fround(.5));
  f79 = Math_fround((f35 > f82 ? f35 : f82) * Math_fround(.5));
  f80 = Math_fround((f29 > f83 ? f29 : f83) * Math_fround(.5));
  f12 = Math_fround((f38 > f84 ? f38 : f84) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f81 >= Math_fround(0.0);
  i69 = f82 >= Math_fround(0.0);
  i70 = f83 >= Math_fround(0.0);
  i71 = f84 >= Math_fround(0.0);
  i9 = i68 ? i9 : 0;
  i10 = i69 ? i10 : 0;
  i11 = i70 ? i11 : 0;
  i5 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f80 = Math_fround(f24 * Math_fround(.5));
  f82 = Math_fround(f25 * Math_fround(.5));
  f84 = Math_fround(f26 * Math_fround(.5));
  f12 = Math_fround(f30 * Math_fround(.5));
  f79 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f83 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f79 < f80 ? f79 : f80, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f81 < f82 ? f81 : f82, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f83 < f84 ? f83 : f84, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f24 >= Math_fround(0.0);
  i3 = f25 >= Math_fround(0.0);
  i2 = f26 >= Math_fround(0.0);
  i71 = f30 >= Math_fround(0.0);
  i15 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f27 < f12 ? f27 : f12, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f28 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f29);
  f24 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f33 * f30);
  f29 = Math_fround(f34 * f41);
  f30 = Math_fround(f31 * f30);
  f41 = Math_fround(f32 * f41);
  f26 = Math_fround(HEAPF32[i624 >> 2]);
  f54 = Math_fround(HEAPF32[i241 >> 2]);
  f82 = Math_fround(HEAPF32[i242 >> 2]);
  f79 = Math_fround(f617 * f33);
  f80 = Math_fround(f617 * f34);
  f84 = Math_fround(f611 * f31);
  f83 = Math_fround(f611 * f32);
  f42 = Math_fround(f613 * f33);
  f34 = Math_fround(f613 * f34);
  f28 = Math_fround(f28 / f35);
  f25 = Math_fround(f37 * f28);
  f28 = Math_fround(f36 * f28);
  i15 = f26 < Math_fround(100.0);
  i17 = f82 < Math_fround(100.0);
  f35 = Math_fround(f617 * f37);
  f82 = Math_fround(f611 * f36);
  f32 = Math_fround(f613 * f37);
  f24 = Math_fround(f24 / f38);
  f26 = Math_fround(f39 * f24);
  i16 = Math_fround(HEAPF32[i243 >> 2]) < Math_fround(100.0);
  f81 = Math_fround(f611 * f39);
  f24 = Math_fround(f40 * f24);
  i14 = f54 < Math_fround(100.0);
  f33 = Math_fround(f617 * f40);
  f31 = Math_fround(f613 * f40);
  f54 = Math_fround(Math_fround(HEAPF32[i628 >> 2]) - f596);
  f55 = Math_fround(Math_fround(HEAPF32[i254 >> 2]) - f596);
  f56 = Math_fround(Math_fround(HEAPF32[i255 >> 2]) - f596);
  f57 = Math_fround(Math_fround(HEAPF32[i256 >> 2]) - f596);
  f58 = Math_fround(Math_fround(HEAPF32[i257 >> 2]) - f597);
  f59 = Math_fround(Math_fround(HEAPF32[i258 >> 2]) - f597);
  f60 = Math_fround(Math_fround(HEAPF32[i259 >> 2]) - f597);
  f61 = Math_fround(Math_fround(HEAPF32[i260 >> 2]) - f597);
  f44 = Math_fround(Math_fround(HEAPF32[i261 >> 2]) - f598);
  f45 = Math_fround(Math_fround(HEAPF32[i262 >> 2]) - f598);
  f46 = Math_fround(Math_fround(HEAPF32[i263 >> 2]) - f598);
  f53 = Math_fround(Math_fround(HEAPF32[i264 >> 2]) - f598);
  f75 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f44 * f44));
  f76 = Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f45 * f45));
  f77 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f46 * f46));
  f78 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f53 * f53));
  f72 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
  f73 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
  f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f77))));
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f78))));
  f54 = Math_fround(f54 * f72);
  f55 = Math_fround(f55 * f73);
  f56 = Math_fround(f56 * f74);
  f57 = Math_fround(f57 * f12);
  f58 = Math_fround(f58 * f72);
  f59 = Math_fround(f59 * f73);
  f60 = Math_fround(f60 * f74);
  f61 = Math_fround(f61 * f12);
  f72 = Math_fround(f44 * f72);
  f73 = Math_fround(f45 * f73);
  f74 = Math_fround(f46 * f74);
  f12 = Math_fround(f53 * f12);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f75 > Math_fround(9.99999974e-06);
  i69 = f76 > Math_fround(9.99999974e-06);
  i70 = f77 > Math_fround(9.99999974e-06);
  i71 = f78 > Math_fround(9.99999974e-06);
  i2 = i68 ? i2 : 0;
  i3 = i69 ? i3 : 0;
  i4 = i70 ? i4 : 0;
  i5 = i71 ? i5 : 0;
  i6 = i68 ? i6 : 0;
  i7 = i69 ? i7 : 0;
  i8 = i70 ? i8 : 0;
  i9 = i71 ? i9 : 0;
  i10 = i68 ? i10 : 1065353216;
  i11 = i69 ? i11 : 1065353216;
  i13 = i70 ? i13 : 1065353216;
  i68 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i265 >> 2] = i2;
  HEAP32[i266 >> 2] = i3;
  HEAP32[i267 >> 2] = i4;
  HEAP32[i268 >> 2] = i5;
  HEAP32[i269 >> 2] = i6;
  HEAP32[i270 >> 2] = i7;
  HEAP32[i271 >> 2] = i8;
  HEAP32[i272 >> 2] = i9;
  HEAP32[i273 >> 2] = i10;
  HEAP32[i274 >> 2] = i11;
  HEAP32[i275 >> 2] = i13;
  HEAP32[i276 >> 2] = i68;
  f58 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f45 = Math_fround(f600 * f58);
  f59 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f600 * f59);
  f60 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = Math_fround(f600 * f60);
  f61 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = Math_fround(f600 * f61);
  f78 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f601 * f78);
  f77 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = Math_fround(f601 * f77);
  f76 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = Math_fround(f601 * f76);
  f75 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f45 - f54);
  f55 = Math_fround(f74 - f55);
  f56 = Math_fround(f44 - f56);
  f57 = Math_fround(f57 - Math_fround(f601 * f75));
  f44 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f601 * f44);
  f45 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f73 = Math_fround(f601 * f45);
  f46 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f72 = Math_fround(f601 * f46);
  f53 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f74 - Math_fround(f599 * f58));
  f59 = Math_fround(f73 - Math_fround(f599 * f59));
  f60 = Math_fround(f72 - Math_fround(f599 * f60));
  f61 = Math_fround(Math_fround(f601 * f53) - Math_fround(f599 * f61));
  f44 = Math_fround(Math_fround(f599 * f78) - Math_fround(f600 * f44));
  f45 = Math_fround(Math_fround(f599 * f77) - Math_fround(f600 * f45));
  f46 = Math_fround(Math_fround(f599 * f76) - Math_fround(f600 * f46));
  f53 = Math_fround(Math_fround(f599 * f75) - Math_fround(f600 * f53));
  f75 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f44 * f44));
  f76 = Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f45 * f45));
  f77 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f46 * f46));
  f78 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f53 * f53));
  f72 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
  f73 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
  f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f77))));
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f78))));
  f54 = Math_fround(f54 * f72);
  f55 = Math_fround(f55 * f73);
  f56 = Math_fround(f56 * f74);
  f57 = Math_fround(f57 * f12);
  f58 = Math_fround(f58 * f72);
  f59 = Math_fround(f59 * f73);
  f60 = Math_fround(f60 * f74);
  f61 = Math_fround(f61 * f12);
  f72 = Math_fround(f44 * f72);
  f73 = Math_fround(f45 * f73);
  f74 = Math_fround(f46 * f74);
  f12 = Math_fround(f53 * f12);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = f75 > Math_fround(9.99999974e-06);
  i69 = f76 > Math_fround(9.99999974e-06);
  i70 = f77 > Math_fround(9.99999974e-06);
  i71 = f78 > Math_fround(9.99999974e-06);
  i2 = i68 ? i2 : 1065353216;
  i3 = i69 ? i3 : 1065353216;
  i4 = i70 ? i4 : 1065353216;
  i5 = i71 ? i5 : 1065353216;
  i6 = i68 ? i6 : 0;
  i7 = i69 ? i7 : 0;
  i8 = i70 ? i8 : 0;
  i9 = i71 ? i9 : 0;
  i10 = i68 ? i10 : 0;
  i11 = i69 ? i11 : 0;
  i13 = i70 ? i13 : 0;
  i71 = i71 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i629 >> 2] = i2;
  HEAP32[i279 >> 2] = i3;
  HEAP32[i280 >> 2] = i4;
  HEAP32[i281 >> 2] = i5;
  HEAP32[i282 >> 2] = i6;
  HEAP32[i283 >> 2] = i7;
  HEAP32[i284 >> 2] = i8;
  HEAP32[i285 >> 2] = i9;
  HEAP32[i286 >> 2] = i10;
  HEAP32[i287 >> 2] = i11;
  HEAP32[i288 >> 2] = i13;
  HEAP32[i289 >> 2] = i71;
  f73 = Math_fround(HEAPF32[i278 >> 2]);
  f695 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f698 = Math_fround(f73 * f695);
  f683 = Math_fround(HEAPF32[i270 >> 2]);
  f692 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = Math_fround(f683 * f692);
  f674 = Math_fround(HEAPF32[i271 >> 2]);
  f689 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f681 = Math_fround(f674 * f689);
  f697 = Math_fround(HEAPF32[i272 >> 2]);
  f684 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f676 = Math_fround(f697 * f684);
  f670 = Math_fround(HEAPF32[i277 >> 2]);
  f672 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f670 * f672);
  f693 = Math_fround(HEAPF32[i274 >> 2]);
  f74 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f671 = Math_fround(f693 * f74);
  f699 = Math_fround(HEAPF32[i275 >> 2]);
  f673 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f40 = Math_fround(f699 * f673);
  f77 = Math_fround(HEAPF32[i276 >> 2]);
  f78 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f698 - f39);
  f671 = Math_fround(f54 - f671);
  f40 = Math_fround(f681 - f40);
  f676 = Math_fround(f676 - Math_fround(f77 * f78));
  f681 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f670 = Math_fround(f670 * f681);
  f54 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f693 = Math_fround(f693 * f54);
  f698 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f699 = Math_fround(f699 * f698);
  f76 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f77 = Math_fround(f77 * f76);
  f700 = Math_fround(HEAPF32[i265 >> 2]);
  f695 = Math_fround(f695 * f700);
  f75 = Math_fround(HEAPF32[i266 >> 2]);
  f692 = Math_fround(f692 * f75);
  f53 = Math_fround(HEAPF32[i267 >> 2]);
  f689 = Math_fround(f689 * f53);
  f675 = Math_fround(HEAPF32[i268 >> 2]);
  f695 = Math_fround(f670 - f695);
  f692 = Math_fround(f693 - f692);
  f689 = Math_fround(f699 - f689);
  f684 = Math_fround(f77 - Math_fround(f684 * f675));
  f681 = Math_fround(Math_fround(f672 * f700) - Math_fround(f73 * f681));
  f54 = Math_fround(Math_fround(f74 * f75) - Math_fround(f683 * f54));
  f698 = Math_fround(Math_fround(f673 * f53) - Math_fround(f674 * f698));
  f76 = Math_fround(Math_fround(f78 * f675) - Math_fround(f697 * f76));
  HEAPF32[i292 >> 2] = f39;
  HEAPF32[i293 >> 2] = f671;
  HEAPF32[i294 >> 2] = f40;
  HEAPF32[i295 >> 2] = f676;
  HEAPF32[i296 >> 2] = f695;
  HEAPF32[i297 >> 2] = f692;
  HEAPF32[i298 >> 2] = f689;
  HEAPF32[i299 >> 2] = f684;
  HEAPF32[i300 >> 2] = f681;
  HEAPF32[i301 >> 2] = f54;
  HEAPF32[i302 >> 2] = f698;
  HEAPF32[i303 >> 2] = f76;
  f76 = Math_fround(HEAPF32[i620 >> 2]);
  f698 = Math_fround(HEAPF32[i200 >> 2]);
  f54 = Math_fround(HEAPF32[i199 >> 2]);
  f681 = Math_fround(HEAPF32[i198 >> 2]);
  f684 = Math_fround(HEAPF32[i304 >> 2]);
  f689 = Math_fround(HEAPF32[i204 >> 2]);
  f692 = Math_fround(HEAPF32[i203 >> 2]);
  f695 = Math_fround(HEAPF32[i202 >> 2]);
  f676 = Math_fround(HEAPF32[i305 >> 2]);
  f40 = Math_fround(HEAPF32[i208 >> 2]);
  f671 = Math_fround(HEAPF32[i207 >> 2]);
  f39 = Math_fround(HEAPF32[i206 >> 2]);
  f76 = Math_fround(f76 * Math_fround(-.159154937));
  f698 = Math_fround(f698 * Math_fround(-.159154937));
  f54 = Math_fround(f54 * Math_fround(-.159154937));
  f681 = Math_fround(f681 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f76));
  f675 = Math_fround(+_roundf(+f698));
  f78 = Math_fround(+_roundf(+f54));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f76 - f697))));
  f675 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f698 - f675))));
  f78 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f54 - f78))));
  f674 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f681 - Math_fround(+_roundf(+f681))))));
  f53 = Math_fround(f697 * f697);
  f673 = Math_fround(f675 * f675);
  f683 = Math_fround(f78 * f78);
  f75 = Math_fround(f674 * f674);
  f74 = Math_fround(f53 * f53);
  f73 = Math_fround(f673 * f673);
  f700 = Math_fround(f683 * f683);
  f672 = Math_fround(f75 * f75);
  f53 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f53 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f53 * Math_fround(76.5686187)))))));
  f673 = Math_fround(f675 * Math_fround(Math_fround(Math_fround(f73 * f73) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f673 * Math_fround(41.3416595))) + Math_fround(f73 * Math_fround(Math_fround(81.6018218) - Math_fround(f673 * Math_fround(76.5686187)))))));
  f683 = Math_fround(f78 * Math_fround(Math_fround(Math_fround(f700 * f700) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f683 * Math_fround(41.3416595))) + Math_fround(f700 * Math_fround(Math_fround(81.6018218) - Math_fround(f683 * Math_fround(76.5686187)))))));
  f75 = Math_fround(f674 * Math_fround(Math_fround(Math_fround(f672 * f672) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f75 * Math_fround(41.3416595))) + Math_fround(f672 * Math_fround(Math_fround(81.6018218) - Math_fround(f75 * Math_fround(76.5686187)))))));
  f76 = Math_fround(f76 + Math_fround(-.25));
  f698 = Math_fround(f698 + Math_fround(-.25));
  f54 = Math_fround(f54 + Math_fround(-.25));
  f681 = Math_fround(f681 + Math_fround(-.25));
  f672 = Math_fround(+_roundf(+f76));
  f674 = Math_fround(+_roundf(+f698));
  f700 = Math_fround(+_roundf(+f54));
  f672 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f76 - f672))));
  f674 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f698 - f674))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f54 - f700))));
  f681 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f681 - Math_fround(+_roundf(+f681))))));
  f54 = Math_fround(f672 * f672);
  f698 = Math_fround(f674 * f674);
  f76 = Math_fround(f700 * f700);
  f78 = Math_fround(f681 * f681);
  f73 = Math_fround(f54 * f54);
  f675 = Math_fround(f698 * f698);
  f74 = Math_fround(f76 * f76);
  f697 = Math_fround(f78 * f78);
  f54 = Math_fround(f672 * Math_fround(Math_fround(Math_fround(f73 * f73) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f73 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
  f698 = Math_fround(f674 * Math_fround(Math_fround(Math_fround(f675 * f675) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f698 * Math_fround(41.3416595))) + Math_fround(f675 * Math_fround(Math_fround(81.6018218) - Math_fround(f698 * Math_fround(76.5686187)))))));
  f76 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f76 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f76 * Math_fround(76.5686187)))))));
  f78 = Math_fround(f681 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f78 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f78 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f684 * Math_fround(-.159154937));
  f689 = Math_fround(f689 * Math_fround(-.159154937));
  f692 = Math_fround(f692 * Math_fround(-.159154937));
  f695 = Math_fround(f695 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f684));
  f681 = Math_fround(+_roundf(+f689));
  f74 = Math_fround(+_roundf(+f692));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f684 - f697))));
  f681 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f689 - f681))));
  f74 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f692 - f74))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f695 - Math_fround(+_roundf(+f695))))));
  f675 = Math_fround(f697 * f697);
  f674 = Math_fround(f681 * f681);
  f73 = Math_fround(f74 * f74);
  f672 = Math_fround(f700 * f700);
  f77 = Math_fround(f675 * f675);
  f699 = Math_fround(f674 * f674);
  f693 = Math_fround(f73 * f73);
  f670 = Math_fround(f672 * f672);
  f675 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f77 * f77) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f675 * Math_fround(41.3416595))) + Math_fround(f77 * Math_fround(Math_fround(81.6018218) - Math_fround(f675 * Math_fround(76.5686187)))))));
  f674 = Math_fround(f681 * Math_fround(Math_fround(Math_fround(f699 * f699) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f674 * Math_fround(41.3416595))) + Math_fround(f699 * Math_fround(Math_fround(81.6018218) - Math_fround(f674 * Math_fround(76.5686187)))))));
  f73 = Math_fround(f74 * Math_fround(Math_fround(Math_fround(f693 * f693) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f73 * Math_fround(41.3416595))) + Math_fround(f693 * Math_fround(Math_fround(81.6018218) - Math_fround(f73 * Math_fround(76.5686187)))))));
  f672 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f670 * f670) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f672 * Math_fround(41.3416595))) + Math_fround(f670 * Math_fround(Math_fround(81.6018218) - Math_fround(f672 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f684 + Math_fround(-.25));
  f689 = Math_fround(f689 + Math_fround(-.25));
  f692 = Math_fround(f692 + Math_fround(-.25));
  f695 = Math_fround(f695 + Math_fround(-.25));
  f670 = Math_fround(+_roundf(+f684));
  f700 = Math_fround(+_roundf(+f689));
  f693 = Math_fround(+_roundf(+f692));
  f670 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f684 - f670))));
  f700 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f689 - f700))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f692 - f693))));
  f695 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f695 - Math_fround(+_roundf(+f695))))));
  f692 = Math_fround(f670 * f670);
  f689 = Math_fround(f700 * f700);
  f684 = Math_fround(f693 * f693);
  f74 = Math_fround(f695 * f695);
  f699 = Math_fround(f692 * f692);
  f681 = Math_fround(f689 * f689);
  f77 = Math_fround(f684 * f684);
  f697 = Math_fround(f74 * f74);
  f692 = Math_fround(f670 * Math_fround(Math_fround(Math_fround(f699 * f699) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f692 * Math_fround(41.3416595))) + Math_fround(f699 * Math_fround(Math_fround(81.6018218) - Math_fround(f692 * Math_fround(76.5686187)))))));
  f689 = Math_fround(f700 * Math_fround(Math_fround(Math_fround(f681 * f681) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f689 * Math_fround(41.3416595))) + Math_fround(f681 * Math_fround(Math_fround(81.6018218) - Math_fround(f689 * Math_fround(76.5686187)))))));
  f684 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f77 * f77) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f684 * Math_fround(41.3416595))) + Math_fround(f77 * Math_fround(Math_fround(81.6018218) - Math_fround(f684 * Math_fround(76.5686187)))))));
  f74 = Math_fround(f695 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f74 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f74 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f676 * Math_fround(-.159154937));
  f40 = Math_fround(f40 * Math_fround(-.159154937));
  f671 = Math_fround(f671 * Math_fround(-.159154937));
  f39 = Math_fround(f39 * Math_fround(-.159154937));
  f697 = Math_fround(+_roundf(+f676));
  f695 = Math_fround(+_roundf(+f40));
  f77 = Math_fround(+_roundf(+f671));
  f697 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f676 - f697))));
  f695 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f695))));
  f77 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f77))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
  f681 = Math_fround(f697 * f697);
  f700 = Math_fround(f695 * f695);
  f699 = Math_fround(f77 * f77);
  f670 = Math_fround(f693 * f693);
  f72 = Math_fround(f681 * f681);
  f682 = Math_fround(f700 * f700);
  f685 = Math_fround(f699 * f699);
  f694 = Math_fround(f670 * f670);
  f681 = Math_fround(f697 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f681 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f681 * Math_fround(76.5686187)))))));
  f700 = Math_fround(f695 * Math_fround(Math_fround(Math_fround(f682 * f682) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f700 * Math_fround(41.3416595))) + Math_fround(f682 * Math_fround(Math_fround(81.6018218) - Math_fround(f700 * Math_fround(76.5686187)))))));
  f699 = Math_fround(f77 * Math_fround(Math_fround(Math_fround(f685 * f685) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f699 * Math_fround(41.3416595))) + Math_fround(f685 * Math_fround(Math_fround(81.6018218) - Math_fround(f699 * Math_fround(76.5686187)))))));
  f670 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f694 * f694) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f670 * Math_fround(41.3416595))) + Math_fround(f694 * Math_fround(Math_fround(81.6018218) - Math_fround(f670 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f676 + Math_fround(-.25));
  f40 = Math_fround(f40 + Math_fround(-.25));
  f671 = Math_fround(f671 + Math_fround(-.25));
  f39 = Math_fround(f39 + Math_fround(-.25));
  f694 = Math_fround(+_roundf(+f676));
  f693 = Math_fround(+_roundf(+f40));
  f685 = Math_fround(+_roundf(+f671));
  f694 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f676 - f694))));
  f693 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f693))));
  f685 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f685))));
  f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
  f671 = Math_fround(f694 * f694);
  f40 = Math_fround(f693 * f693);
  f676 = Math_fround(f685 * f685);
  f77 = Math_fround(f39 * f39);
  f682 = Math_fround(f671 * f671);
  f695 = Math_fround(f40 * f40);
  f72 = Math_fround(f676 * f676);
  f697 = Math_fround(f77 * f77);
  f671 = Math_fround(f694 * Math_fround(Math_fround(Math_fround(f682 * f682) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f671 * Math_fround(41.3416595))) + Math_fround(f682 * Math_fround(Math_fround(81.6018218) - Math_fround(f671 * Math_fround(76.5686187)))))));
  f40 = Math_fround(f693 * Math_fround(Math_fround(Math_fround(f695 * f695) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f695 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
  f676 = Math_fround(f685 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f676 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f676 * Math_fround(76.5686187)))))));
  f77 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f697 * f697) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f77 * Math_fround(41.3416595))) + Math_fround(f697 * Math_fround(Math_fround(81.6018218) - Math_fround(f77 * Math_fround(76.5686187)))))));
  f697 = Math_fround(f675 * f681);
  f39 = Math_fround(f674 * f700);
  f72 = Math_fround(f73 * f699);
  f685 = Math_fround(f672 * f670);
  f695 = Math_fround(f39 + Math_fround(Math_fround(f698 * f689) * f40));
  f693 = Math_fround(f72 + Math_fround(Math_fround(f76 * f684) * f676));
  f682 = Math_fround(f685 + Math_fround(Math_fround(f78 * f74) * f77));
  HEAPF32[i630 >> 2] = Math_fround(f697 + Math_fround(Math_fround(f54 * f692) * f671));
  HEAPF32[i306 >> 2] = f695;
  HEAPF32[i307 >> 2] = f693;
  HEAPF32[i308 >> 2] = f682;
  f682 = Math_fround(Math_fround(f689 * Math_fround(f698 * f700)) - Math_fround(f674 * f40));
  f693 = Math_fround(Math_fround(f684 * Math_fround(f76 * f699)) - Math_fround(f73 * f676));
  f695 = Math_fround(Math_fround(f74 * Math_fround(f78 * f670)) - Math_fround(f672 * f77));
  HEAPF32[i309 >> 2] = Math_fround(Math_fround(f692 * Math_fround(f54 * f681)) - Math_fround(f675 * f671));
  HEAPF32[i310 >> 2] = f682;
  HEAPF32[i311 >> 2] = f693;
  HEAPF32[i312 >> 2] = f695;
  f695 = Math_fround(f673 * f689);
  f693 = Math_fround(f683 * f684);
  f682 = Math_fround(f75 * f74);
  HEAPF32[i313 >> 2] = Math_fround(f53 * f692);
  HEAPF32[i314 >> 2] = f695;
  HEAPF32[i315 >> 2] = f693;
  HEAPF32[i316 >> 2] = f682;
  f682 = Math_fround(f53 * f671);
  f693 = Math_fround(f673 * f40);
  f695 = Math_fround(f683 * f676);
  f694 = Math_fround(f75 * f77);
  HEAPF32[i317 >> 2] = f682;
  HEAPF32[i318 >> 2] = f693;
  HEAPF32[i319 >> 2] = f695;
  HEAPF32[i320 >> 2] = f694;
  f55 = Math_fround(f673 * f700);
  f56 = Math_fround(f683 * f699);
  f57 = Math_fround(f75 * f670);
  HEAPF32[i321 >> 2] = Math_fround(f53 * f681);
  HEAPF32[i322 >> 2] = f55;
  HEAPF32[i323 >> 2] = f56;
  HEAPF32[i324 >> 2] = f57;
  f57 = Math_fround(-f698);
  f56 = Math_fround(-f76);
  f55 = Math_fround(-f78);
  HEAPF32[i325 >> 2] = Math_fround(-f54);
  HEAPF32[i326 >> 2] = f57;
  HEAPF32[i327 >> 2] = f56;
  HEAPF32[i328 >> 2] = f55;
  f681 = Math_fround(Math_fround(Math_fround(f54 * f675) * f671) - Math_fround(f692 * f681));
  f700 = Math_fround(Math_fround(Math_fround(f698 * f674) * f40) - Math_fround(f689 * f700));
  f699 = Math_fround(Math_fround(Math_fround(f76 * f73) * f676) - Math_fround(f684 * f699));
  f670 = Math_fround(Math_fround(Math_fround(f78 * f672) * f77) - Math_fround(f74 * f670));
  HEAPF32[i329 >> 2] = f681;
  HEAPF32[i330 >> 2] = f700;
  HEAPF32[i331 >> 2] = f699;
  HEAPF32[i332 >> 2] = f670;
  f671 = Math_fround(Math_fround(f54 * f697) + Math_fround(f692 * f671));
  f40 = Math_fround(Math_fround(f698 * f39) + Math_fround(f689 * f40));
  f676 = Math_fround(Math_fround(f76 * f72) + Math_fround(f684 * f676));
  f77 = Math_fround(Math_fround(f78 * f685) + Math_fround(f74 * f77));
  HEAPF32[i333 >> 2] = f671;
  HEAPF32[i334 >> 2] = f40;
  HEAPF32[i335 >> 2] = f676;
  HEAPF32[i336 >> 2] = f77;
  f675 = Math_fround(f53 * f675);
  f674 = Math_fround(f673 * f674);
  f73 = Math_fround(f683 * f73);
  f672 = Math_fround(f75 * f672);
  HEAPF32[i337 >> 2] = f675;
  HEAPF32[i338 >> 2] = f674;
  HEAPF32[i339 >> 2] = f73;
  HEAPF32[i340 >> 2] = f672;
  f75 = Math_fround(HEAPF32[i629 >> 2]);
  f683 = Math_fround(f75 * Math_fround(HEAPF32[i630 >> 2]));
  f673 = Math_fround(HEAPF32[i279 >> 2]);
  f53 = Math_fround(f673 * Math_fround(HEAPF32[i306 >> 2]));
  f74 = Math_fround(HEAPF32[i280 >> 2]);
  f685 = Math_fround(f74 * Math_fround(HEAPF32[i307 >> 2]));
  f78 = Math_fround(HEAPF32[i281 >> 2]);
  f684 = Math_fround(f78 * Math_fround(HEAPF32[i308 >> 2]));
  f72 = Math_fround(HEAPF32[i292 >> 2]);
  f682 = Math_fround(f72 * f682);
  f76 = Math_fround(HEAPF32[i293 >> 2]);
  f693 = Math_fround(f76 * f693);
  f689 = Math_fround(HEAPF32[i294 >> 2]);
  f695 = Math_fround(f689 * f695);
  f39 = Math_fround(HEAPF32[i295 >> 2]);
  f682 = Math_fround(f683 + f682);
  f693 = Math_fround(f53 + f693);
  f695 = Math_fround(f685 + f695);
  f694 = Math_fround(f684 + Math_fround(f39 * f694));
  f684 = Math_fround(HEAPF32[i341 >> 2]);
  f681 = Math_fround(f684 * f681);
  f685 = Math_fround(HEAPF32[i266 >> 2]);
  f700 = Math_fround(f685 * f700);
  f53 = Math_fround(HEAPF32[i267 >> 2]);
  f699 = Math_fround(f53 * f699);
  f683 = Math_fround(HEAPF32[i268 >> 2]);
  f700 = Math_fround(f693 + f700);
  f699 = Math_fround(f695 + f699);
  f670 = Math_fround(f694 + Math_fround(f683 * f670));
  HEAPF32[i631 >> 2] = Math_fround(f682 + f681);
  HEAPF32[i342 >> 2] = f700;
  HEAPF32[i343 >> 2] = f699;
  HEAPF32[i344 >> 2] = f670;
  f670 = Math_fround(f75 * Math_fround(HEAPF32[i309 >> 2]));
  f699 = Math_fround(f673 * Math_fround(HEAPF32[i310 >> 2]));
  f700 = Math_fround(f74 * Math_fround(HEAPF32[i311 >> 2]));
  f681 = Math_fround(f78 * Math_fround(HEAPF32[i312 >> 2]));
  f682 = Math_fround(f72 * Math_fround(HEAPF32[i321 >> 2]));
  f694 = Math_fround(f76 * Math_fround(HEAPF32[i322 >> 2]));
  f695 = Math_fround(f689 * Math_fround(HEAPF32[i323 >> 2]));
  f40 = Math_fround(Math_fround(f699 + f694) + Math_fround(f685 * f40));
  f676 = Math_fround(Math_fround(f700 + f695) + Math_fround(f53 * f676));
  f77 = Math_fround(Math_fround(f681 + Math_fround(f39 * Math_fround(HEAPF32[i324 >> 2]))) + Math_fround(f683 * f77));
  HEAPF32[i345 >> 2] = Math_fround(Math_fround(f670 + f682) + Math_fround(f684 * f671));
  HEAPF32[i346 >> 2] = f40;
  HEAPF32[i347 >> 2] = f676;
  HEAPF32[i348 >> 2] = f77;
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i313 >> 2]));
  f673 = Math_fround(f673 * Math_fround(HEAPF32[i314 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i315 >> 2]));
  f78 = Math_fround(f78 * Math_fround(HEAPF32[i316 >> 2]));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i325 >> 2]));
  f76 = Math_fround(f76 * Math_fround(HEAPF32[i326 >> 2]));
  f689 = Math_fround(f689 * Math_fround(HEAPF32[i327 >> 2]));
  f674 = Math_fround(Math_fround(f673 + f76) + Math_fround(f685 * f674));
  f73 = Math_fround(Math_fround(f74 + f689) + Math_fround(f53 * f73));
  f672 = Math_fround(Math_fround(f78 + Math_fround(f39 * Math_fround(HEAPF32[i328 >> 2]))) + Math_fround(f683 * f672));
  HEAPF32[i349 >> 2] = Math_fround(Math_fround(f75 + f72) + Math_fround(f684 * f675));
  HEAPF32[i350 >> 2] = f674;
  HEAPF32[i351 >> 2] = f73;
  HEAPF32[i352 >> 2] = f672;
  f672 = Math_fround(HEAPF32[i290 >> 2]);
  f73 = Math_fround(f672 * Math_fround(HEAPF32[i630 >> 2]));
  f674 = Math_fround(HEAPF32[i283 >> 2]);
  f675 = Math_fround(f674 * Math_fround(HEAPF32[i306 >> 2]));
  f684 = Math_fround(HEAPF32[i284 >> 2]);
  f72 = Math_fround(f684 * Math_fround(HEAPF32[i307 >> 2]));
  f75 = Math_fround(HEAPF32[i285 >> 2]);
  f683 = Math_fround(f75 * Math_fround(HEAPF32[i308 >> 2]));
  f39 = Math_fround(HEAPF32[i296 >> 2]);
  f78 = Math_fround(f39 * Math_fround(HEAPF32[i317 >> 2]));
  f53 = Math_fround(HEAPF32[i297 >> 2]);
  f689 = Math_fround(f53 * Math_fround(HEAPF32[i318 >> 2]));
  f74 = Math_fround(HEAPF32[i298 >> 2]);
  f685 = Math_fround(f74 * Math_fround(HEAPF32[i319 >> 2]));
  f76 = Math_fround(HEAPF32[i299 >> 2]);
  f78 = Math_fround(f73 + f78);
  f689 = Math_fround(f675 + f689);
  f685 = Math_fround(f72 + f685);
  f683 = Math_fround(f683 + Math_fround(f76 * Math_fround(HEAPF32[i320 >> 2])));
  f72 = Math_fround(HEAPF32[i278 >> 2]);
  f675 = Math_fround(f72 * Math_fround(HEAPF32[i329 >> 2]));
  f73 = Math_fround(HEAPF32[i270 >> 2]);
  f673 = Math_fround(f73 * Math_fround(HEAPF32[i330 >> 2]));
  f77 = Math_fround(HEAPF32[i271 >> 2]);
  f676 = Math_fround(f77 * Math_fround(HEAPF32[i331 >> 2]));
  f40 = Math_fround(HEAPF32[i272 >> 2]);
  f673 = Math_fround(f689 + f673);
  f676 = Math_fround(f685 + f676);
  f683 = Math_fround(f683 + Math_fround(f40 * Math_fround(HEAPF32[i332 >> 2])));
  HEAPF32[i353 >> 2] = Math_fround(f78 + f675);
  HEAPF32[i354 >> 2] = f673;
  HEAPF32[i355 >> 2] = f676;
  HEAPF32[i356 >> 2] = f683;
  f683 = Math_fround(f672 * Math_fround(HEAPF32[i309 >> 2]));
  f676 = Math_fround(f674 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f684 * Math_fround(HEAPF32[i311 >> 2]));
  f675 = Math_fround(f75 * Math_fround(HEAPF32[i312 >> 2]));
  f78 = Math_fround(f39 * Math_fround(HEAPF32[i321 >> 2]));
  f685 = Math_fround(f53 * Math_fround(HEAPF32[i322 >> 2]));
  f689 = Math_fround(f74 * Math_fround(HEAPF32[i323 >> 2]));
  f78 = Math_fround(f683 + f78);
  f685 = Math_fround(f676 + f685);
  f689 = Math_fround(f673 + f689);
  f675 = Math_fround(f675 + Math_fround(f76 * Math_fround(HEAPF32[i324 >> 2])));
  f673 = Math_fround(f72 * Math_fround(HEAPF32[i333 >> 2]));
  f676 = Math_fround(f73 * Math_fround(HEAPF32[i334 >> 2]));
  f683 = Math_fround(f77 * Math_fround(HEAPF32[i335 >> 2]));
  f676 = Math_fround(f685 + f676);
  f683 = Math_fround(f689 + f683);
  f675 = Math_fround(f675 + Math_fround(f40 * Math_fround(HEAPF32[i336 >> 2])));
  HEAPF32[i357 >> 2] = Math_fround(f78 + f673);
  HEAPF32[i358 >> 2] = f676;
  HEAPF32[i359 >> 2] = f683;
  HEAPF32[i360 >> 2] = f675;
  f672 = Math_fround(f672 * Math_fround(HEAPF32[i313 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i314 >> 2]));
  f684 = Math_fround(f684 * Math_fround(HEAPF32[i315 >> 2]));
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i316 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i325 >> 2]));
  f53 = Math_fround(f53 * Math_fround(HEAPF32[i326 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i327 >> 2]));
  f39 = Math_fround(f672 + f39);
  f53 = Math_fround(f674 + f53);
  f74 = Math_fround(f684 + f74);
  f76 = Math_fround(f75 + Math_fround(f76 * Math_fround(HEAPF32[i328 >> 2])));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i337 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i338 >> 2]));
  f77 = Math_fround(f77 * Math_fround(HEAPF32[i339 >> 2]));
  f73 = Math_fround(f53 + f73);
  f77 = Math_fround(f74 + f77);
  f40 = Math_fround(f76 + Math_fround(f40 * Math_fround(HEAPF32[i340 >> 2])));
  HEAPF32[i361 >> 2] = Math_fround(f39 + f72);
  HEAPF32[i362 >> 2] = f73;
  HEAPF32[i363 >> 2] = f77;
  HEAPF32[i364 >> 2] = f40;
  f40 = Math_fround(HEAPF32[i291 >> 2]);
  f77 = Math_fround(f40 * Math_fround(HEAPF32[i630 >> 2]));
  f73 = Math_fround(HEAPF32[i287 >> 2]);
  f72 = Math_fround(f73 * Math_fround(HEAPF32[i306 >> 2]));
  f39 = Math_fround(HEAPF32[i288 >> 2]);
  f76 = Math_fround(f39 * Math_fround(HEAPF32[i307 >> 2]));
  f74 = Math_fround(HEAPF32[i289 >> 2]);
  f53 = Math_fround(f74 * Math_fround(HEAPF32[i308 >> 2]));
  f75 = Math_fround(HEAPF32[i300 >> 2]);
  f684 = Math_fround(f75 * Math_fround(HEAPF32[i317 >> 2]));
  f674 = Math_fround(HEAPF32[i301 >> 2]);
  f672 = Math_fround(f674 * Math_fround(HEAPF32[i318 >> 2]));
  f675 = Math_fround(HEAPF32[i302 >> 2]);
  f683 = Math_fround(f675 * Math_fround(HEAPF32[i319 >> 2]));
  f676 = Math_fround(HEAPF32[i303 >> 2]);
  f684 = Math_fround(f77 + f684);
  f672 = Math_fround(f72 + f672);
  f683 = Math_fround(f76 + f683);
  f53 = Math_fround(f53 + Math_fround(f676 * Math_fround(HEAPF32[i320 >> 2])));
  f76 = Math_fround(HEAPF32[i277 >> 2]);
  f72 = Math_fround(f76 * Math_fround(HEAPF32[i329 >> 2]));
  f77 = Math_fround(HEAPF32[i274 >> 2]);
  f673 = Math_fround(f77 * Math_fround(HEAPF32[i330 >> 2]));
  f78 = Math_fround(HEAPF32[i275 >> 2]);
  f689 = Math_fround(f78 * Math_fround(HEAPF32[i331 >> 2]));
  f685 = Math_fround(HEAPF32[i276 >> 2]);
  f673 = Math_fround(f672 + f673);
  f689 = Math_fround(f683 + f689);
  f53 = Math_fround(f53 + Math_fround(f685 * Math_fround(HEAPF32[i332 >> 2])));
  HEAPF32[i365 >> 2] = Math_fround(f684 + f72);
  HEAPF32[i366 >> 2] = f673;
  HEAPF32[i367 >> 2] = f689;
  HEAPF32[i368 >> 2] = f53;
  f53 = Math_fround(f40 * Math_fround(HEAPF32[i309 >> 2]));
  f689 = Math_fround(f73 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f39 * Math_fround(HEAPF32[i311 >> 2]));
  f72 = Math_fround(f74 * Math_fround(HEAPF32[i312 >> 2]));
  f684 = Math_fround(f75 * Math_fround(HEAPF32[i321 >> 2]));
  f683 = Math_fround(f674 * Math_fround(HEAPF32[i322 >> 2]));
  f672 = Math_fround(f675 * Math_fround(HEAPF32[i323 >> 2]));
  f684 = Math_fround(f53 + f684);
  f683 = Math_fround(f689 + f683);
  f672 = Math_fround(f673 + f672);
  f72 = Math_fround(f72 + Math_fround(f676 * Math_fround(HEAPF32[i324 >> 2])));
  f673 = Math_fround(f76 * Math_fround(HEAPF32[i333 >> 2]));
  f689 = Math_fround(f77 * Math_fround(HEAPF32[i334 >> 2]));
  f53 = Math_fround(f78 * Math_fround(HEAPF32[i335 >> 2]));
  f689 = Math_fround(f683 + f689);
  f53 = Math_fround(f672 + f53);
  f72 = Math_fround(f72 + Math_fround(f685 * Math_fround(HEAPF32[i336 >> 2])));
  HEAPF32[i369 >> 2] = Math_fround(f684 + f673);
  HEAPF32[i370 >> 2] = f689;
  HEAPF32[i371 >> 2] = f53;
  HEAPF32[i372 >> 2] = f72;
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i313 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i314 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i315 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i316 >> 2]));
  f75 = Math_fround(f75 * Math_fround(HEAPF32[i325 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i326 >> 2]));
  f675 = Math_fround(f675 * Math_fround(HEAPF32[i327 >> 2]));
  f75 = Math_fround(f40 + f75);
  f674 = Math_fround(f73 + f674);
  f675 = Math_fround(f39 + f675);
  f676 = Math_fround(f74 + Math_fround(f676 * Math_fround(HEAPF32[i328 >> 2])));
  f76 = Math_fround(f76 * Math_fround(HEAPF32[i337 >> 2]));
  f77 = Math_fround(f77 * Math_fround(HEAPF32[i338 >> 2]));
  f78 = Math_fround(f78 * Math_fround(HEAPF32[i339 >> 2]));
  f77 = Math_fround(f674 + f77);
  f78 = Math_fround(f675 + f78);
  f685 = Math_fround(f676 + Math_fround(f685 * Math_fround(HEAPF32[i340 >> 2])));
  HEAPF32[i373 >> 2] = Math_fround(f75 + f76);
  HEAPF32[i374 >> 2] = f77;
  HEAPF32[i375 >> 2] = f78;
  HEAPF32[i376 >> 2] = f685;
  f78 = i15 ? f27 : Math_fround(0.0);
  f77 = i14 ? f25 : Math_fround(0.0);
  f76 = i17 ? f29 : Math_fround(0.0);
  f75 = i16 ? f24 : Math_fround(0.0);
  f676 = Math_fround(f79 - f78);
  f675 = Math_fround(f35 - f77);
  f674 = Math_fround(f80 - f76);
  f25 = Math_fround(f33 - f75);
  f74 = i15 ? f30 : Math_fround(0.0);
  f39 = Math_fround(f84 + f74);
  f73 = i14 ? f28 : Math_fround(0.0);
  f40 = Math_fround(f82 + f73);
  f72 = i17 ? f41 : Math_fround(0.0);
  f41 = Math_fround(f83 + f72);
  f53 = i16 ? f26 : Math_fround(0.0);
  f689 = Math_fround(f81 + f53);
  f673 = Math_fround(HEAPF32[i631 >> 2]);
  f684 = Math_fround(f676 * f673);
  f672 = Math_fround(HEAPF32[i342 >> 2]);
  f683 = Math_fround(f675 * f672);
  f671 = Math_fround(HEAPF32[i343 >> 2]);
  f682 = Math_fround(f674 * f671);
  f670 = Math_fround(HEAPF32[i344 >> 2]);
  f681 = Math_fround(f25 * f670);
  f695 = Math_fround(HEAPF32[i345 >> 2]);
  f700 = Math_fround(f39 * f695);
  f694 = Math_fround(HEAPF32[i346 >> 2]);
  f699 = Math_fround(f40 * f694);
  f693 = Math_fround(HEAPF32[i347 >> 2]);
  f698 = Math_fround(f41 * f693);
  f692 = Math_fround(HEAPF32[i348 >> 2]);
  f697 = Math_fround(f689 * f692);
  f54 = Math_fround(f684 + f700);
  f55 = Math_fround(f683 + f699);
  f56 = Math_fround(f682 + f698);
  f57 = Math_fround(f681 + f697);
  f24 = Math_fround(f42 * Math_fround(HEAPF32[i349 >> 2]));
  f661 = Math_fround(f32 * Math_fround(HEAPF32[i350 >> 2]));
  f660 = Math_fround(f34 * Math_fround(HEAPF32[i351 >> 2]));
  f659 = Math_fround(f31 * Math_fround(HEAPF32[i352 >> 2]));
  f54 = Math_fround(f54 + f24);
  f55 = Math_fround(f55 + f661);
  f56 = Math_fround(f56 + f660);
  f57 = Math_fround(f57 + f659);
  f669 = Math_fround(HEAPF32[i353 >> 2]);
  f680 = Math_fround(f676 * f669);
  f668 = Math_fround(HEAPF32[i354 >> 2]);
  f679 = Math_fround(f675 * f668);
  f667 = Math_fround(HEAPF32[i355 >> 2]);
  f678 = Math_fround(f674 * f667);
  f666 = Math_fround(HEAPF32[i356 >> 2]);
  f677 = Math_fround(f25 * f666);
  f691 = Math_fround(HEAPF32[i357 >> 2]);
  f696 = Math_fround(f39 * f691);
  f690 = Math_fround(HEAPF32[i358 >> 2]);
  f36 = Math_fround(f40 * f690);
  f30 = Math_fround(HEAPF32[i359 >> 2]);
  f37 = Math_fround(f41 * f30);
  f29 = Math_fround(HEAPF32[i360 >> 2]);
  f38 = Math_fround(f689 * f29);
  f58 = Math_fround(f680 + f696);
  f59 = Math_fround(f679 + f36);
  f60 = Math_fround(f678 + f37);
  f61 = Math_fround(f677 + f38);
  f658 = Math_fround(f42 * Math_fround(HEAPF32[i361 >> 2]));
  f657 = Math_fround(f32 * Math_fround(HEAPF32[i362 >> 2]));
  f656 = Math_fround(f34 * Math_fround(HEAPF32[i363 >> 2]));
  f655 = Math_fround(f31 * Math_fround(HEAPF32[i364 >> 2]));
  f58 = Math_fround(f58 + f658);
  f59 = Math_fround(f59 + f657);
  f60 = Math_fround(f60 + f656);
  f61 = Math_fround(f61 + f655);
  f665 = Math_fround(HEAPF32[i365 >> 2]);
  f676 = Math_fround(f676 * f665);
  f664 = Math_fround(HEAPF32[i366 >> 2]);
  f675 = Math_fround(f675 * f664);
  f663 = Math_fround(HEAPF32[i367 >> 2]);
  f674 = Math_fround(f674 * f663);
  f662 = Math_fround(HEAPF32[i368 >> 2]);
  f25 = Math_fround(f25 * f662);
  f28 = Math_fround(HEAPF32[i369 >> 2]);
  f39 = Math_fround(f39 * f28);
  f27 = Math_fround(HEAPF32[i370 >> 2]);
  f40 = Math_fround(f40 * f27);
  f26 = Math_fround(HEAPF32[i371 >> 2]);
  f41 = Math_fround(f41 * f26);
  f12 = Math_fround(HEAPF32[i372 >> 2]);
  f689 = Math_fround(f689 * f12);
  f43 = Math_fround(f676 + f39);
  f44 = Math_fround(f675 + f40);
  f45 = Math_fround(f674 + f41);
  f46 = Math_fround(f25 + f689);
  f654 = Math_fround(f42 * Math_fround(HEAPF32[i373 >> 2]));
  f653 = Math_fround(f32 * Math_fround(HEAPF32[i374 >> 2]));
  f652 = Math_fround(f34 * Math_fround(HEAPF32[i375 >> 2]));
  f685 = Math_fround(f31 * f685);
  f43 = Math_fround(f43 + f654);
  f44 = Math_fround(f44 + f653);
  f45 = Math_fround(f45 + f652);
  f46 = Math_fround(f685 + f46);
  f686 = Math_fround(f79 + f78);
  f687 = Math_fround(f35 + f77);
  f688 = Math_fround(f80 + f76);
  f42 = Math_fround(f33 + f75);
  f673 = Math_fround(f686 * f673);
  f672 = Math_fround(f687 * f672);
  f671 = Math_fround(f688 * f671);
  f670 = Math_fround(f42 * f670);
  f31 = Math_fround(Math_fround(f673 + f700) + f24);
  f32 = Math_fround(Math_fround(f672 + f699) + f661);
  f33 = Math_fround(Math_fround(f671 + f698) + f660);
  f34 = Math_fround(Math_fround(f670 + f697) + f659);
  f669 = Math_fround(f686 * f669);
  f668 = Math_fround(f687 * f668);
  f667 = Math_fround(f688 * f667);
  f666 = Math_fround(f42 * f666);
  f35 = Math_fround(Math_fround(f669 + f696) + f658);
  f36 = Math_fround(Math_fround(f668 + f36) + f657);
  f37 = Math_fround(Math_fround(f667 + f37) + f656);
  f38 = Math_fround(Math_fround(f666 + f38) + f655);
  f665 = Math_fround(f686 * f665);
  f664 = Math_fround(f687 * f664);
  f663 = Math_fround(f688 * f663);
  f662 = Math_fround(f42 * f662);
  f39 = Math_fround(Math_fround(f665 + f39) + f654);
  f40 = Math_fround(Math_fround(f664 + f40) + f653);
  f41 = Math_fround(Math_fround(f663 + f41) + f652);
  f42 = Math_fround(f685 + Math_fround(f662 + f689));
  f689 = Math_fround(f84 - f74);
  f688 = Math_fround(f82 - f73);
  f687 = Math_fround(f83 - f72);
  f686 = Math_fround(f81 - f53);
  f84 = Math_fround(f689 * f695);
  f83 = Math_fround(f688 * f694);
  f82 = Math_fround(f687 * f693);
  f81 = Math_fround(f686 * f692);
  f673 = Math_fround(Math_fround(f673 + f84) + f24);
  f672 = Math_fround(Math_fround(f672 + f83) + f661);
  f671 = Math_fround(Math_fround(f671 + f82) + f660);
  f670 = Math_fround(Math_fround(f670 + f81) + f659);
  f80 = Math_fround(f689 * f691);
  f79 = Math_fround(f688 * f690);
  f30 = Math_fround(f687 * f30);
  f29 = Math_fround(f686 * f29);
  f669 = Math_fround(Math_fround(f669 + f80) + f658);
  f668 = Math_fround(Math_fround(f668 + f79) + f657);
  f667 = Math_fround(Math_fround(f667 + f30) + f656);
  f666 = Math_fround(Math_fround(f666 + f29) + f655);
  f28 = Math_fround(f689 * f28);
  f27 = Math_fround(f688 * f27);
  f26 = Math_fround(f687 * f26);
  f12 = Math_fround(f686 * f12);
  f665 = Math_fround(Math_fround(f665 + f28) + f654);
  f664 = Math_fround(Math_fround(f664 + f27) + f653);
  f663 = Math_fround(Math_fround(f663 + f26) + f652);
  f662 = Math_fround(f685 + Math_fround(f662 + f12));
  f24 = Math_fround(Math_fround(f684 + f84) + f24);
  f661 = Math_fround(Math_fround(f683 + f83) + f661);
  f660 = Math_fround(Math_fround(f682 + f82) + f660);
  f659 = Math_fround(Math_fround(f681 + f81) + f659);
  f658 = Math_fround(Math_fround(f680 + f80) + f658);
  f657 = Math_fround(Math_fround(f679 + f79) + f657);
  f656 = Math_fround(Math_fround(f678 + f30) + f656);
  f655 = Math_fround(Math_fround(f677 + f29) + f655);
  f654 = Math_fround(Math_fround(f676 + f28) + f654);
  f653 = Math_fround(Math_fround(f675 + f27) + f653);
  f652 = Math_fround(Math_fround(f674 + f26) + f652);
  f12 = Math_fround(f685 + Math_fround(f25 + f12));
  f25 = Math_fround(HEAPF32[i628 >> 2]);
  f685 = Math_fround(f54 + f25);
  f26 = Math_fround(HEAPF32[i254 >> 2]);
  f674 = Math_fround(f55 + f26);
  f27 = Math_fround(HEAPF32[i255 >> 2]);
  f675 = Math_fround(f56 + f27);
  f28 = Math_fround(HEAPF32[i256 >> 2]);
  f676 = Math_fround(f57 + f28);
  f29 = Math_fround(HEAPF32[i257 >> 2]);
  f677 = Math_fround(f58 + f29);
  f30 = Math_fround(HEAPF32[i258 >> 2]);
  f678 = Math_fround(f59 + f30);
  f79 = Math_fround(HEAPF32[i259 >> 2]);
  f679 = Math_fround(f60 + f79);
  f80 = Math_fround(HEAPF32[i260 >> 2]);
  f680 = Math_fround(f61 + f80);
  f81 = Math_fround(HEAPF32[i261 >> 2]);
  f681 = Math_fround(f43 + f81);
  f82 = Math_fround(HEAPF32[i262 >> 2]);
  f682 = Math_fround(f44 + f82);
  f83 = Math_fround(HEAPF32[i263 >> 2]);
  f683 = Math_fround(f45 + f83);
  f84 = Math_fround(HEAPF32[i264 >> 2]);
  f684 = Math_fround(f46 + f84);
  HEAPF32[i627 >> 2] = f685;
  HEAPF32[i377 >> 2] = f674;
  HEAPF32[i378 >> 2] = f675;
  HEAPF32[i379 >> 2] = f676;
  HEAPF32[i380 >> 2] = f677;
  HEAPF32[i381 >> 2] = f678;
  HEAPF32[i382 >> 2] = f679;
  HEAPF32[i383 >> 2] = f680;
  HEAPF32[i384 >> 2] = f681;
  HEAPF32[i385 >> 2] = f682;
  HEAPF32[i386 >> 2] = f683;
  HEAPF32[i387 >> 2] = f684;
  f684 = Math_fround(f32 + f26);
  f683 = Math_fround(f33 + f27);
  f682 = Math_fround(f34 + f28);
  f681 = Math_fround(f35 + f29);
  f680 = Math_fround(f36 + f30);
  f679 = Math_fround(f37 + f79);
  f678 = Math_fround(f38 + f80);
  f677 = Math_fround(f39 + f81);
  f676 = Math_fround(f40 + f82);
  f675 = Math_fround(f41 + f83);
  f674 = Math_fround(f42 + f84);
  HEAPF32[i388 >> 2] = Math_fround(f31 + f25);
  HEAPF32[i389 >> 2] = f684;
  HEAPF32[i390 >> 2] = f683;
  HEAPF32[i391 >> 2] = f682;
  HEAPF32[i392 >> 2] = f681;
  HEAPF32[i393 >> 2] = f680;
  HEAPF32[i394 >> 2] = f679;
  HEAPF32[i395 >> 2] = f678;
  HEAPF32[i396 >> 2] = f677;
  HEAPF32[i397 >> 2] = f676;
  HEAPF32[i398 >> 2] = f675;
  HEAPF32[i399 >> 2] = f674;
  f672 = Math_fround(f672 + f26);
  f671 = Math_fround(f671 + f27);
  f670 = Math_fround(f670 + f28);
  f669 = Math_fround(f669 + f29);
  f668 = Math_fround(f668 + f30);
  f667 = Math_fround(f667 + f79);
  f666 = Math_fround(f666 + f80);
  f665 = Math_fround(f665 + f81);
  f664 = Math_fround(f664 + f82);
  f663 = Math_fround(f663 + f83);
  f662 = Math_fround(f662 + f84);
  HEAPF32[i400 >> 2] = Math_fround(f673 + f25);
  HEAPF32[i401 >> 2] = f672;
  HEAPF32[i402 >> 2] = f671;
  HEAPF32[i403 >> 2] = f670;
  HEAPF32[i404 >> 2] = f669;
  HEAPF32[i405 >> 2] = f668;
  HEAPF32[i406 >> 2] = f667;
  HEAPF32[i407 >> 2] = f666;
  HEAPF32[i408 >> 2] = f665;
  HEAPF32[i409 >> 2] = f664;
  HEAPF32[i410 >> 2] = f663;
  HEAPF32[i411 >> 2] = f662;
  f26 = Math_fround(f661 + f26);
  f27 = Math_fround(f660 + f27);
  f28 = Math_fround(f659 + f28);
  f29 = Math_fround(f658 + f29);
  f30 = Math_fround(f657 + f30);
  f79 = Math_fround(f656 + f79);
  f80 = Math_fround(f655 + f80);
  f81 = Math_fround(f654 + f81);
  f82 = Math_fround(f653 + f82);
  f83 = Math_fround(f652 + f83);
  f84 = Math_fround(f12 + f84);
  HEAPF32[i412 >> 2] = Math_fround(f24 + f25);
  HEAPF32[i413 >> 2] = f26;
  HEAPF32[i414 >> 2] = f27;
  HEAPF32[i415 >> 2] = f28;
  HEAPF32[i416 >> 2] = f29;
  HEAPF32[i417 >> 2] = f30;
  HEAPF32[i418 >> 2] = f79;
  HEAPF32[i419 >> 2] = f80;
  HEAPF32[i420 >> 2] = f81;
  HEAPF32[i421 >> 2] = f82;
  HEAPF32[i422 >> 2] = f83;
  HEAPF32[i423 >> 2] = f84;
  if (!i424) {
   i2 = HEAP32[i634 >> 2] | 0;
   if (i2 & 536870912) {
    i52 = HEAP32[i86 >> 2] | 0;
    f700 = Math_fround(HEAPF32[i52 + 564 >> 2]);
    i50 = HEAP32[i625 >> 2] | 0;
    i62 = i50 + 693089735 | 0;
    i48 = HEAP32[i245 >> 2] | 0;
    i70 = i48 + 693089735 | 0;
    i23 = HEAP32[i246 >> 2] | 0;
    i67 = i23 + 693089735 | 0;
    i21 = HEAP32[i247 >> 2] | 0;
    i64 = i21 + 693089735 | 0;
    i22 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i47 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
    i49 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i62 = i62 << 11 ^ i62;
    i70 = i70 << 11 ^ i70;
    i67 = i67 << 11 ^ i67;
    i64 = i64 << 11 ^ i64;
    i22 = Math_fround(Math_fround((i22 ^ i62 ^ i62 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i47 = Math_fround(Math_fround((i47 ^ i70 ^ i70 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i49 = Math_fround(Math_fround((i49 ^ i67 ^ i67 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i51 = Math_fround(Math_fround((i51 ^ i64 ^ i64 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    f700 = Math_fround(HEAPF32[i52 + 568 >> 2]);
    i50 = i50 + 13945730 | 0;
    i48 = i48 + 13945730 | 0;
    i23 = i23 + 13945730 | 0;
    i21 = i21 + 13945730 | 0;
    i52 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i64 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
    i50 = i50 << 11 ^ i50;
    i48 = i48 << 11 ^ i48;
    i23 = i23 << 11 ^ i23;
    i21 = i21 << 11 ^ i21;
    i52 = Math_fround(Math_fround((i52 ^ i50 ^ i50 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i64 = Math_fround(Math_fround((i64 ^ i48 ^ i48 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i67 = Math_fround(Math_fround((i67 ^ i23 ^ i23 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i70 = Math_fround(Math_fround((i70 ^ i21 ^ i21 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f700;
    i21 = i22 & 1;
    i23 = i47 & 1;
    i48 = i49 & 1;
    i50 = i51 & 1;
    i62 = i22 & 1 ^ 1;
    i65 = i47 & 1 ^ 1;
    i68 = i49 & 1 ^ 1;
    i71 = i51 & 1 ^ 1;
    i63 = i22 ? 3 : 2;
    i66 = i47 ? 3 : 2;
    i69 = i49 ? 3 : 2;
    i2 = i51 ? 3 : 2;
    i22 = i22 ? 2 : 3;
    i47 = i47 ? 2 : 3;
    i49 = i49 ? 2 : 3;
    i51 = i51 ? 2 : 3;
    HEAP32[i648 >> 2] = i52 ? i22 : i21;
    HEAP32[i604 >> 2] = i64 ? i47 : i23;
    HEAP32[i603 >> 2] = i67 ? i49 : i48;
    HEAP32[i602 >> 2] = i70 ? i51 : i50;
    HEAP32[i583 >> 2] = i52 ? i21 : i22;
    HEAP32[i582 >> 2] = i64 ? i23 : i47;
    HEAP32[i581 >> 2] = i67 ? i48 : i49;
    HEAP32[i580 >> 2] = i70 ? i50 : i51;
    HEAP32[i575 >> 2] = i52 ? i63 : i62;
    HEAP32[i607 >> 2] = i64 ? i66 : i65;
    HEAP32[i606 >> 2] = i67 ? i69 : i68;
    HEAP32[i605 >> 2] = i70 ? i2 : i71;
    HEAP32[i579 >> 2] = i52 ? i62 : i63;
    HEAP32[i578 >> 2] = i64 ? i65 : i66;
    HEAP32[i577 >> 2] = i67 ? i68 : i69;
    HEAP32[i576 >> 2] = i70 ? i71 : i2;
    i2 = HEAP32[i634 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f12 = Math_fround(f637 * Math_fround(HEAPF32[i626 >> 2]));
    f24 = Math_fround(f637 * Math_fround(HEAPF32[i249 >> 2]));
    f25 = Math_fround(f637 * Math_fround(HEAPF32[i250 >> 2]));
    f26 = Math_fround(f637 * Math_fround(HEAPF32[i251 >> 2]));
    f27 = Math_fround(Math_floor(Math_fround(f12)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    f30 = Math_fround(Math_floor(Math_fround(f26)));
    if (i2 & 16777216 | 0) {
     f697 = Math_fround(Math_floor(Math_fround(f636 * f27)));
     f698 = Math_fround(Math_floor(Math_fround(f636 * f28)));
     f699 = Math_fround(Math_floor(Math_fround(f636 * f29)));
     f700 = Math_fround(Math_floor(Math_fround(f636 * f30)));
     f693 = Math_fround(f638 * Math_fround(f27 - Math_fround(f635 * f697)));
     f694 = Math_fround(f638 * Math_fround(f28 - Math_fround(f635 * f698)));
     f695 = Math_fround(f638 * Math_fround(f29 - Math_fround(f635 * f699)));
     f696 = Math_fround(f638 * Math_fround(f30 - Math_fround(f635 * f700)));
     f697 = Math_fround(f640 - Math_fround(f639 * f697));
     f698 = Math_fround(f640 - Math_fround(f639 * f698));
     f699 = Math_fround(f640 - Math_fround(f639 * f699));
     f700 = Math_fround(f640 - Math_fround(f639 * f700));
     f685 = Math_fround(f639 + f697);
     f686 = Math_fround(f639 + f698);
     f687 = Math_fround(f639 + f699);
     f688 = Math_fround(f639 + f700);
     HEAPF32[i649 >> 2] = f693;
     HEAPF32[i526 >> 2] = f694;
     HEAPF32[i550 >> 2] = f695;
     HEAPF32[i574 >> 2] = f696;
     HEAPF32[i502 >> 2] = f685;
     HEAPF32[i525 >> 2] = f686;
     HEAPF32[i549 >> 2] = f687;
     HEAPF32[i573 >> 2] = f688;
     f689 = Math_fround(f638 + f693);
     f690 = Math_fround(f638 + f694);
     f691 = Math_fround(f638 + f695);
     f692 = Math_fround(f638 + f696);
     HEAPF32[i501 >> 2] = f689;
     HEAPF32[i524 >> 2] = f690;
     HEAPF32[i548 >> 2] = f691;
     HEAPF32[i572 >> 2] = f692;
     HEAPF32[i500 >> 2] = f685;
     HEAPF32[i523 >> 2] = f686;
     HEAPF32[i547 >> 2] = f687;
     HEAPF32[i571 >> 2] = f688;
     HEAPF32[i499 >> 2] = f689;
     HEAPF32[i522 >> 2] = f690;
     HEAPF32[i546 >> 2] = f691;
     HEAPF32[i570 >> 2] = f692;
     HEAPF32[i498 >> 2] = f697;
     HEAPF32[i521 >> 2] = f698;
     HEAPF32[i545 >> 2] = f699;
     HEAPF32[i569 >> 2] = f700;
     HEAPF32[i497 >> 2] = f693;
     HEAPF32[i520 >> 2] = f694;
     HEAPF32[i544 >> 2] = f695;
     HEAPF32[i568 >> 2] = f696;
     HEAPF32[i496 >> 2] = f697;
     HEAPF32[i519 >> 2] = f698;
     HEAPF32[i543 >> 2] = f699;
     HEAPF32[i567 >> 2] = f700;
    }
    if (i2 & 33554432 | 0) {
     f689 = Math_fround(f27 + Math_fround(1.0));
     f690 = Math_fround(f28 + Math_fround(1.0));
     f691 = Math_fround(f29 + Math_fround(1.0));
     f692 = Math_fround(f30 + Math_fround(1.0));
     f697 = Math_fround(f12 - f27);
     f698 = Math_fround(f24 - f28);
     f699 = Math_fround(f25 - f29);
     f700 = Math_fround(f26 - f30);
     f693 = Math_fround(Math_floor(Math_fround(f636 * f689)));
     f694 = Math_fround(Math_floor(Math_fround(f636 * f690)));
     f695 = Math_fround(Math_floor(Math_fround(f636 * f691)));
     f696 = Math_fround(Math_floor(Math_fround(f636 * f692)));
     f689 = Math_fround(f638 * Math_fround(f689 - Math_fround(f635 * f693)));
     f690 = Math_fround(f638 * Math_fround(f690 - Math_fround(f635 * f694)));
     f691 = Math_fround(f638 * Math_fround(f691 - Math_fround(f635 * f695)));
     f692 = Math_fround(f638 * Math_fround(f692 - Math_fround(f635 * f696)));
     f693 = Math_fround(f640 - Math_fround(f639 * f693));
     f694 = Math_fround(f640 - Math_fround(f639 * f694));
     f695 = Math_fround(f640 - Math_fround(f639 * f695));
     f696 = Math_fround(f640 - Math_fround(f639 * f696));
     f681 = Math_fround(f639 + f693);
     f682 = Math_fround(f639 + f694);
     f683 = Math_fround(f639 + f695);
     f684 = Math_fround(f639 + f696);
     HEAPF32[i650 >> 2] = f689;
     HEAPF32[i518 >> 2] = f690;
     HEAPF32[i542 >> 2] = f691;
     HEAPF32[i566 >> 2] = f692;
     HEAPF32[i495 >> 2] = f681;
     HEAPF32[i517 >> 2] = f682;
     HEAPF32[i541 >> 2] = f683;
     HEAPF32[i565 >> 2] = f684;
     HEAPF32[i494 >> 2] = f697;
     HEAPF32[i516 >> 2] = f698;
     HEAPF32[i540 >> 2] = f699;
     HEAPF32[i564 >> 2] = f700;
     HEAPF32[i493 >> 2] = f12;
     HEAPF32[i515 >> 2] = f24;
     HEAPF32[i539 >> 2] = f25;
     HEAPF32[i563 >> 2] = f26;
     f685 = Math_fround(f638 + f689);
     f686 = Math_fround(f638 + f690);
     f687 = Math_fround(f638 + f691);
     f688 = Math_fround(f638 + f692);
     HEAPF32[i492 >> 2] = f685;
     HEAPF32[i514 >> 2] = f686;
     HEAPF32[i538 >> 2] = f687;
     HEAPF32[i562 >> 2] = f688;
     HEAPF32[i491 >> 2] = f681;
     HEAPF32[i513 >> 2] = f682;
     HEAPF32[i537 >> 2] = f683;
     HEAPF32[i561 >> 2] = f684;
     HEAPF32[i490 >> 2] = f697;
     HEAPF32[i512 >> 2] = f698;
     HEAPF32[i536 >> 2] = f699;
     HEAPF32[i560 >> 2] = f700;
     HEAPF32[i489 >> 2] = f12;
     HEAPF32[i511 >> 2] = f24;
     HEAPF32[i535 >> 2] = f25;
     HEAPF32[i559 >> 2] = f26;
     HEAPF32[i488 >> 2] = f685;
     HEAPF32[i510 >> 2] = f686;
     HEAPF32[i534 >> 2] = f687;
     HEAPF32[i558 >> 2] = f688;
     HEAPF32[i487 >> 2] = f693;
     HEAPF32[i509 >> 2] = f694;
     HEAPF32[i533 >> 2] = f695;
     HEAPF32[i557 >> 2] = f696;
     HEAPF32[i486 >> 2] = f697;
     HEAPF32[i508 >> 2] = f698;
     HEAPF32[i532 >> 2] = f699;
     HEAPF32[i556 >> 2] = f700;
     HEAPF32[i485 >> 2] = f12;
     HEAPF32[i507 >> 2] = f24;
     HEAPF32[i531 >> 2] = f25;
     HEAPF32[i555 >> 2] = f26;
     HEAPF32[i484 >> 2] = f689;
     HEAPF32[i506 >> 2] = f690;
     HEAPF32[i530 >> 2] = f691;
     HEAPF32[i554 >> 2] = f692;
     HEAPF32[i483 >> 2] = f693;
     HEAPF32[i505 >> 2] = f694;
     HEAPF32[i529 >> 2] = f695;
     HEAPF32[i553 >> 2] = f696;
     HEAPF32[i482 >> 2] = f697;
     HEAPF32[i504 >> 2] = f698;
     HEAPF32[i528 >> 2] = f699;
     HEAPF32[i552 >> 2] = f700;
     HEAPF32[i481 >> 2] = f12;
     HEAPF32[i503 >> 2] = f24;
     HEAPF32[i527 >> 2] = f25;
     HEAPF32[i551 >> 2] = f26;
    }
   }
  }
  f685 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f43 * f43)))));
  f686 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f44 * f44)))));
  f687 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f60 * f60)) + Math_fround(f45 * f45)))));
  f688 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f61 * f61)) + Math_fround(f46 * f46)))));
  f677 = Math_fround(f642 * Math_fround(f54 * f685));
  f678 = Math_fround(f642 * Math_fround(f55 * f686));
  f679 = Math_fround(f642 * Math_fround(f56 * f687));
  f680 = Math_fround(f642 * Math_fround(f57 * f688));
  f681 = Math_fround(f642 * Math_fround(f58 * f685));
  f682 = Math_fround(f642 * Math_fround(f59 * f686));
  f683 = Math_fround(f642 * Math_fround(f60 * f687));
  f684 = Math_fround(f642 * Math_fround(f61 * f688));
  f685 = Math_fround(f642 * Math_fround(f43 * f685));
  f686 = Math_fround(f642 * Math_fround(f44 * f686));
  f687 = Math_fround(f642 * Math_fround(f45 * f687));
  f688 = Math_fround(f642 * Math_fround(f46 * f688));
  f697 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35)) + Math_fround(f39 * f39)))));
  f698 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f36 * f36)) + Math_fround(f40 * f40)))));
  f699 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f37 * f37)) + Math_fround(f41 * f41)))));
  f700 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f38 * f38)) + Math_fround(f42 * f42)))));
  f689 = Math_fround(f642 * Math_fround(f31 * f697));
  f690 = Math_fround(f642 * Math_fround(f32 * f698));
  f691 = Math_fround(f642 * Math_fround(f33 * f699));
  f692 = Math_fround(f642 * Math_fround(f34 * f700));
  f693 = Math_fround(f642 * Math_fround(f35 * f697));
  f694 = Math_fround(f642 * Math_fround(f36 * f698));
  f695 = Math_fround(f642 * Math_fround(f37 * f699));
  f696 = Math_fround(f642 * Math_fround(f38 * f700));
  f697 = Math_fround(f642 * Math_fround(f39 * f697));
  f698 = Math_fround(f642 * Math_fround(f40 * f698));
  f699 = Math_fround(f642 * Math_fround(f41 * f699));
  f700 = Math_fround(f642 * Math_fround(f42 * f700));
  f676 = Math_fround(f616 + f678);
  f675 = Math_fround(f616 + f679);
  f674 = Math_fround(f616 + f680);
  f673 = Math_fround(f610 + f681);
  f672 = Math_fround(f610 + f682);
  f671 = Math_fround(f610 + f683);
  f670 = Math_fround(f610 + f684);
  f669 = Math_fround(f612 + f685);
  f668 = Math_fround(f612 + f686);
  f667 = Math_fround(f612 + f687);
  f666 = Math_fround(f612 + f688);
  HEAPF32[i629 >> 2] = Math_fround(f616 + f677);
  HEAPF32[i147 >> 2] = f676;
  HEAPF32[i164 >> 2] = f675;
  HEAPF32[i181 >> 2] = f674;
  HEAPF32[i425 >> 2] = f673;
  HEAPF32[i142 >> 2] = f672;
  HEAPF32[i159 >> 2] = f671;
  HEAPF32[i176 >> 2] = f670;
  HEAPF32[i426 >> 2] = f669;
  HEAPF32[i137 >> 2] = f668;
  HEAPF32[i154 >> 2] = f667;
  HEAPF32[i171 >> 2] = f666;
  f666 = Math_fround(f616 + f690);
  f667 = Math_fround(f616 + f691);
  f668 = Math_fround(f616 + f692);
  f669 = Math_fround(f610 + f693);
  f670 = Math_fround(f610 + f694);
  f671 = Math_fround(f610 + f695);
  f672 = Math_fround(f610 + f696);
  f673 = Math_fround(f612 + f697);
  f674 = Math_fround(f612 + f698);
  f675 = Math_fround(f612 + f699);
  f676 = Math_fround(f612 + f700);
  HEAPF32[i427 >> 2] = Math_fround(f616 + f689);
  HEAPF32[i146 >> 2] = f666;
  HEAPF32[i163 >> 2] = f667;
  HEAPF32[i180 >> 2] = f668;
  HEAPF32[i428 >> 2] = f669;
  HEAPF32[i141 >> 2] = f670;
  HEAPF32[i158 >> 2] = f671;
  HEAPF32[i175 >> 2] = f672;
  HEAPF32[i429 >> 2] = f673;
  HEAPF32[i136 >> 2] = f674;
  HEAPF32[i153 >> 2] = f675;
  HEAPF32[i170 >> 2] = f676;
  f678 = Math_fround(f616 - f678);
  f679 = Math_fround(f616 - f679);
  f680 = Math_fround(f616 - f680);
  f681 = Math_fround(f610 - f681);
  f682 = Math_fround(f610 - f682);
  f683 = Math_fround(f610 - f683);
  f684 = Math_fround(f610 - f684);
  f685 = Math_fround(f612 - f685);
  f686 = Math_fround(f612 - f686);
  f687 = Math_fround(f612 - f687);
  f688 = Math_fround(f612 - f688);
  HEAPF32[i430 >> 2] = Math_fround(f616 - f677);
  HEAPF32[i145 >> 2] = f678;
  HEAPF32[i162 >> 2] = f679;
  HEAPF32[i179 >> 2] = f680;
  HEAPF32[i431 >> 2] = f681;
  HEAPF32[i140 >> 2] = f682;
  HEAPF32[i157 >> 2] = f683;
  HEAPF32[i174 >> 2] = f684;
  HEAPF32[i432 >> 2] = f685;
  HEAPF32[i135 >> 2] = f686;
  HEAPF32[i152 >> 2] = f687;
  HEAPF32[i169 >> 2] = f688;
  f690 = Math_fround(f616 - f690);
  f691 = Math_fround(f616 - f691);
  f692 = Math_fround(f616 - f692);
  f693 = Math_fround(f610 - f693);
  f694 = Math_fround(f610 - f694);
  f695 = Math_fround(f610 - f695);
  f696 = Math_fround(f610 - f696);
  f697 = Math_fround(f612 - f697);
  f698 = Math_fround(f612 - f698);
  f699 = Math_fround(f612 - f699);
  f700 = Math_fround(f612 - f700);
  HEAPF32[i433 >> 2] = Math_fround(f616 - f689);
  HEAPF32[i144 >> 2] = f690;
  HEAPF32[i161 >> 2] = f691;
  HEAPF32[i178 >> 2] = f692;
  HEAPF32[i434 >> 2] = f693;
  HEAPF32[i139 >> 2] = f694;
  HEAPF32[i156 >> 2] = f695;
  HEAPF32[i173 >> 2] = f696;
  HEAPF32[i435 >> 2] = f697;
  HEAPF32[i134 >> 2] = f698;
  HEAPF32[i151 >> 2] = f699;
  HEAPF32[i168 >> 2] = f700;
  do if (i185) {
   i4 = HEAP32[i218 >> 2] | 0;
   i5 = HEAP32[i646 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i71 = i5 + (i2 + i85 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i627 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i629 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i427 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i400 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i430 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i412 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i433 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i71 >> 2];
     i71 = i649 + (HEAP32[i648 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i71 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i71 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i71 = i5 + (HEAP32[i4 + (i2 + i85 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i627 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i629 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i427 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i400 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i430 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i71 >> 2];
     i70 = i649 + (HEAP32[i648 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i70 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i70 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i412 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i118 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i433 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i119 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i120 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i71 >> 2];
     i71 = i649 + (HEAP32[i648 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i71 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i71 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f688 = Math_fround(HEAPF32[i388 >> 2]);
   f688 = Math_fround(f688 - Math_fround(HEAPF32[i627 >> 2]));
   f690 = Math_fround(HEAPF32[i389 >> 2]);
   f690 = Math_fround(f690 - Math_fround(HEAPF32[i377 >> 2]));
   f691 = Math_fround(HEAPF32[i390 >> 2]);
   f691 = Math_fround(f691 - Math_fround(HEAPF32[i378 >> 2]));
   f692 = Math_fround(HEAPF32[i391 >> 2]);
   f692 = Math_fround(f692 - Math_fround(HEAPF32[i379 >> 2]));
   f693 = Math_fround(HEAPF32[i392 >> 2]);
   f693 = Math_fround(f693 - Math_fround(HEAPF32[i380 >> 2]));
   f700 = Math_fround(HEAPF32[i393 >> 2]);
   f700 = Math_fround(f700 - Math_fround(HEAPF32[i381 >> 2]));
   f699 = Math_fround(HEAPF32[i394 >> 2]);
   f699 = Math_fround(f699 - Math_fround(HEAPF32[i382 >> 2]));
   f698 = Math_fround(HEAPF32[i395 >> 2]);
   f698 = Math_fround(f698 - Math_fround(HEAPF32[i383 >> 2]));
   f697 = Math_fround(HEAPF32[i396 >> 2]);
   f697 = Math_fround(f697 - Math_fround(HEAPF32[i384 >> 2]));
   f685 = Math_fround(HEAPF32[i397 >> 2]);
   f685 = Math_fround(f685 - Math_fround(HEAPF32[i385 >> 2]));
   f686 = Math_fround(HEAPF32[i398 >> 2]);
   f686 = Math_fround(f686 - Math_fround(HEAPF32[i386 >> 2]));
   f687 = Math_fround(HEAPF32[i399 >> 2]);
   f687 = Math_fround(f687 - Math_fround(HEAPF32[i387 >> 2]));
   f689 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f688 * f688) + Math_fround(f693 * f693)) + Math_fround(f697 * f697)))));
   f696 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f690 * f690) + Math_fround(f700 * f700)) + Math_fround(f685 * f685)))));
   f695 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f691 * f691) + Math_fround(f699 * f699)) + Math_fround(f686 * f686)))));
   f694 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f692 * f692) + Math_fround(f698 * f698)) + Math_fround(f687 * f687)))));
   f690 = Math_fround(f690 * f696);
   f691 = Math_fround(f691 * f695);
   f692 = Math_fround(f692 * f694);
   f693 = Math_fround(f693 * f689);
   f700 = Math_fround(f700 * f696);
   f699 = Math_fround(f699 * f695);
   f698 = Math_fround(f698 * f694);
   f697 = Math_fround(f697 * f689);
   f696 = Math_fround(f685 * f696);
   f695 = Math_fround(f686 * f695);
   f694 = Math_fround(f687 * f694);
   HEAPF32[i630 >> 2] = Math_fround(f688 * f689);
   HEAPF32[i148 >> 2] = f690;
   HEAPF32[i165 >> 2] = f691;
   HEAPF32[i182 >> 2] = f692;
   HEAPF32[i436 >> 2] = f693;
   HEAPF32[i143 >> 2] = f700;
   HEAPF32[i160 >> 2] = f699;
   HEAPF32[i177 >> 2] = f698;
   HEAPF32[i437 >> 2] = f697;
   HEAPF32[i138 >> 2] = f696;
   HEAPF32[i155 >> 2] = f695;
   HEAPF32[i172 >> 2] = f694;
   f694 = Math_fround(f77 * Math_fround(2.0));
   f695 = Math_fround(f76 * Math_fround(2.0));
   f696 = Math_fround(f75 * Math_fround(2.0));
   f697 = Math_fround(f74 * Math_fround(2.0));
   f698 = Math_fround(f73 * Math_fround(2.0));
   f699 = Math_fround(f72 * Math_fround(2.0));
   f700 = Math_fround(f53 * Math_fround(2.0));
   HEAPF32[i631 >> 2] = Math_fround(f78 * Math_fround(2.0));
   HEAPF32[i150 >> 2] = f694;
   HEAPF32[i167 >> 2] = f695;
   HEAPF32[i184 >> 2] = f696;
   HEAPF32[i438 >> 2] = f697;
   HEAPF32[i149 >> 2] = f698;
   HEAPF32[i166 >> 2] = f699;
   HEAPF32[i183 >> 2] = f700;
   HEAP32[i133 >> 2] = 0;
   HEAP32[i133 + 4 >> 2] = 0;
   HEAP32[i133 + 8 >> 2] = 0;
   HEAP32[i133 + 12 >> 2] = 0;
   if (i439) {
    f680 = Math_fround(HEAPF32[i621 >> 2]);
    f698 = Math_fround(f584 * f680);
    f682 = Math_fround(HEAPF32[i211 >> 2]);
    f689 = Math_fround(f584 * f682);
    f684 = Math_fround(HEAPF32[i210 >> 2]);
    f697 = Math_fround(f584 * f684);
    f686 = Math_fround(HEAPF32[i209 >> 2]);
    f692 = Math_fround(f584 * f686);
    f681 = Math_fround(HEAPF32[i440 >> 2]);
    f688 = Math_fround(f587 * f681);
    f683 = Math_fround(HEAPF32[i214 >> 2]);
    f694 = Math_fround(f587 * f683);
    f685 = Math_fround(HEAPF32[i213 >> 2]);
    f693 = Math_fround(f587 * f685);
    f687 = Math_fround(HEAPF32[i212 >> 2]);
    f688 = Math_fround(f698 + f688);
    f694 = Math_fround(f689 + f694);
    f693 = Math_fround(f697 + f693);
    f692 = Math_fround(f692 + Math_fround(f587 * f687));
    f697 = Math_fround(HEAPF32[i441 >> 2]);
    f689 = Math_fround(f590 * f697);
    f698 = Math_fround(HEAPF32[i217 >> 2]);
    f690 = Math_fround(f590 * f698);
    f699 = Math_fround(HEAPF32[i216 >> 2]);
    f691 = Math_fround(f590 * f699);
    f700 = Math_fround(HEAPF32[i215 >> 2]);
    f690 = Math_fround(f694 + f690);
    f691 = Math_fround(f693 + f691);
    f692 = Math_fround(f692 + Math_fround(f590 * f700));
    f693 = Math_fround(Math_fround(Math_fround(f585 * f680) + Math_fround(f588 * f681)) + Math_fround(f591 * f697));
    f694 = Math_fround(Math_fround(Math_fround(f585 * f682) + Math_fround(f588 * f683)) + Math_fround(f591 * f698));
    f695 = Math_fround(Math_fround(Math_fround(f585 * f684) + Math_fround(f588 * f685)) + Math_fround(f591 * f699));
    f696 = Math_fround(Math_fround(Math_fround(f585 * f686) + Math_fround(f588 * f687)) + Math_fround(f591 * f700));
    f697 = Math_fround(Math_fround(Math_fround(f586 * f680) + Math_fround(f589 * f681)) + Math_fround(f592 * f697));
    f698 = Math_fround(Math_fround(Math_fround(f586 * f682) + Math_fround(f589 * f683)) + Math_fround(f592 * f698));
    f699 = Math_fround(Math_fround(Math_fround(f586 * f684) + Math_fround(f589 * f685)) + Math_fround(f592 * f699));
    f700 = Math_fround(Math_fround(Math_fround(f586 * f686) + Math_fround(f589 * f687)) + Math_fround(f592 * f700));
    HEAPF32[i632 >> 2] = Math_fround(f688 + f689);
    HEAPF32[i442 >> 2] = f690;
    HEAPF32[i443 >> 2] = f691;
    HEAPF32[i444 >> 2] = f692;
    HEAPF32[i445 >> 2] = f693;
    HEAPF32[i446 >> 2] = f694;
    HEAPF32[i447 >> 2] = f695;
    HEAPF32[i448 >> 2] = f696;
    HEAPF32[i449 >> 2] = f697;
    HEAPF32[i450 >> 2] = f698;
    HEAPF32[i451 >> 2] = f699;
    HEAPF32[i452 >> 2] = f700;
   }
   if (i453) {
    i65 = HEAP32[i625 >> 2] | 0;
    i68 = i65 + 1068538453 | 0;
    i69 = HEAP32[i245 >> 2] | 0;
    i67 = i69 + 1068538453 | 0;
    i62 = HEAP32[i246 >> 2] | 0;
    i52 = i62 + 1068538453 | 0;
    i51 = HEAP32[i247 >> 2] | 0;
    i64 = i51 + 1068538453 | 0;
    i70 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i66 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i68 = i68 << 11 ^ i68;
    i67 = i67 << 11 ^ i67;
    i52 = i52 << 11 ^ i52;
    i64 = i64 << 11 ^ i64;
    f698 = Math_fround(Math_fround((i63 ^ i67 ^ i67 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i71 ^ i52 ^ i52 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i66 ^ i64 ^ i64 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i633 >> 2] = Math_fround(Math_fround((i70 ^ i68 ^ i68 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = f698;
    HEAPF32[i455 >> 2] = f699;
    HEAPF32[i456 >> 2] = f700;
    i65 = i65 + 1068538454 | 0;
    i69 = i69 + 1068538454 | 0;
    i62 = i62 + 1068538454 | 0;
    i51 = i51 + 1068538454 | 0;
    i70 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
    i68 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i66 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i64 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i65 = i65 << 11 ^ i65;
    i69 = i69 << 11 ^ i69;
    i62 = i62 << 11 ^ i62;
    i51 = i51 << 11 ^ i51;
    f700 = Math_fround(Math_fround((i68 ^ i69 ^ i69 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i66 ^ i62 ^ i62 >>> 8) & 8388607 ^ i66 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f698 = Math_fround(Math_fround((i64 ^ i51 ^ i51 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i457 >> 2] = Math_fround(Math_fround((i70 ^ i65 ^ i65 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i458 >> 2] = f700;
    HEAPF32[i459 >> 2] = f699;
    HEAPF32[i460 >> 2] = f698;
    i70 = HEAP32[i625 >> 2] | 0;
    i65 = i70 + 1068538455 | 0;
    i64 = HEAP32[i245 >> 2] | 0;
    i51 = i64 + 1068538455 | 0;
    i66 = HEAP32[i246 >> 2] | 0;
    i62 = i66 + 1068538455 | 0;
    i68 = HEAP32[i247 >> 2] | 0;
    i69 = i68 + 1068538455 | 0;
    i71 = (Math_imul(i65, 1790253981) | 0) + 1900727103 | 0;
    i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i65 = i65 << 11 ^ i65;
    i51 = i51 << 11 ^ i51;
    i62 = i62 << 11 ^ i62;
    i69 = i69 << 11 ^ i69;
    f698 = Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i63 ^ i62 ^ i62 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i67 ^ i69 ^ i69 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i461 >> 2] = Math_fround(Math_fround((i71 ^ i65 ^ i65 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i462 >> 2] = f698;
    HEAPF32[i463 >> 2] = f699;
    HEAPF32[i464 >> 2] = f700;
    f700 = Math_fround(Math_fround(HEAPF32[i624 >> 2]) * Math_fround(1.0e5));
    f699 = Math_fround(Math_fround(HEAPF32[i241 >> 2]) * Math_fround(1.0e5));
    f698 = Math_fround(Math_fround(HEAPF32[i242 >> 2]) * Math_fround(1.0e5));
    i70 = i70 + 1068538453 + ~~f700 | 0;
    i64 = i64 + 1068538453 + ~~f699 | 0;
    i66 = i66 + 1068538453 + ~~f698 | 0;
    i68 = i68 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i243 >> 2]) * Math_fround(1.0e5)) | 0;
    i71 = (Math_imul(i70, 1790253981) | 0) + 1900727103 | 0;
    i65 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
    i69 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i70 = i70 << 11 ^ i70;
    i64 = i64 << 11 ^ i64;
    i66 = i66 << 11 ^ i66;
    i68 = i68 << 11 ^ i68;
    f698 = Math_fround(Math_fround((i65 ^ i64 ^ i64 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f699 = Math_fround(Math_fround((i67 ^ i66 ^ i66 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f700 = Math_fround(Math_fround((i69 ^ i68 ^ i68 >>> 8) & 8388607 ^ i69 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i465 >> 2] = Math_fround(Math_fround((i71 ^ i70 ^ i70 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i466 >> 2] = f698;
    HEAPF32[i467 >> 2] = f699;
    HEAPF32[i468 >> 2] = f700;
   }
   i62 = HEAP32[i218 >> 2] | 0;
   i63 = (i62 | 0) == 0;
   i64 = HEAP32[i125 >> 2] | 0;
   i65 = HEAP32[i127 >> 2] | 0;
   i66 = HEAP32[i240 >> 2] | 0;
   i67 = HEAP32[i128 >> 2] | 0;
   i68 = HEAP32[i221 >> 2] | 0;
   i69 = HEAP32[i222 >> 2] | 0;
   i70 = HEAP32[i223 >> 2] | 0;
   i71 = HEAP32[i646 >> 2] | 0;
   i52 = 0;
   do {
    i2 = i52 + i85 | 0;
    if (!i63) i2 = HEAP32[i62 + (i2 << 3) >> 2] | 0;
    i5 = i632 + (i52 << 2) | 0;
    i6 = i476 + (i52 << 2) | 0;
    i7 = i477 + (i52 << 2) | 0;
    i8 = i633 + (i52 << 2) | 0;
    i9 = i457 + (i52 << 2) | 0;
    i10 = i461 + (i52 << 2) | 0;
    i11 = i465 + (i52 << 2) | 0;
    i13 = i630 + (i52 << 2) | 0;
    i14 = i122 + (i52 << 2) | 0;
    i15 = i123 + (i52 << 2) | 0;
    i16 = i64 + (i2 << 4) | 0;
    i17 = i65 + (i2 << 4) | 0;
    i18 = i66 + (i2 << 2) | 0;
    i19 = i67 + (i2 << 2) | 0;
    i20 = i68 + (i2 << 2) | 0;
    i21 = i69 + (i2 << 2) | 0;
    i22 = i70 + (i2 << 2) | 0;
    i23 = i631 + (i52 << 2) | 0;
    i47 = i129 + (i52 << 2) | 0;
    i48 = i130 + (i52 << 2) | 0;
    i49 = i628 + (i52 << 2) | 0;
    i50 = i131 + (i52 << 2) | 0;
    i51 = i132 + (i52 << 2) | 0;
    i4 = i71 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i627 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i52 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i52 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i52 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i469) {
      i701 = i629 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i701 + 32 + (i52 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i470) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i471) {
      i701 = i649 + (HEAP32[i648 + ((i3 << 2) + i52 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i472) {
      i701 = i650 + (HEAP32[i648 + ((i3 << 2) + i52 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i701 + (i52 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 16 + (i52 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 32 + (i52 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 48 + (i52 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i473) {
      f700 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i49 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i50 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i51 >> 2];
      HEAPF32[i1 + 12 >> 2] = f700;
      i1 = i1 + 16 | 0;
     }
     if (!i474) {
      HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i47 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i48 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i475) {
      i2 = HEAP32[i21 >> 2] | 0;
      i701 = HEAP32[i22 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = i2;
      HEAP32[i1 + 8 >> 2] = i701;
      i1 = i1 + 12 | 0;
     }
     if (i439) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i478) {
      f700 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.00999999977));
      i701 = HEAP32[i19 >> 2] | 0;
      HEAPF32[i1 >> 2] = f700;
      HEAP32[i1 + 4 >> 2] = i701;
      i1 = i1 + 8 | 0;
     }
     if (!i479) {
      i701 = (HEAP32[i126 >> 2] & 2147483647 | 0) == 0 ? i618 : i17;
      HEAP32[i1 >> 2] = HEAP32[i701 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i480) {
      i701 = (HEAP32[i124 >> 2] & 2147483647 | 0) == 0 ? i618 : i16;
      HEAP32[i1 >> 2] = HEAP32[i701 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i701 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i701 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i701 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i453) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i121) {
      HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i15 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i52 = i52 + 1 | 0;
   } while ((i52 | 0) != 4);
  } while (0);
  i85 = i85 + 4 | 0;
 } while (i85 >>> 0 < i186 >>> 0);
 STACKTOP = i651;
 return;
}

function __ZL32TransformParticleMeshAnimatedUVsILb1EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i2, i99, i3, i91, i1, i89, i25, i27, i28, i29, i90, i101) {
 i2 = i2 | 0;
 i99 = i99 | 0;
 i3 = i3 | 0;
 i91 = i91 | 0;
 i1 = i1 | 0;
 i89 = i89 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i90 = i90 | 0;
 i101 = i101 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, f92 = f0, f93 = f0, i94 = 0, f95 = f0, i96 = 0, i97 = 0, f98 = f0, i100 = 0, i102 = 0, f103 = f0, f104 = f0, f105 = f0, f106 = f0;
 i102 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i102 + 64 | 0;
 i6 = i102 + 48 | 0;
 i24 = i102 + 40 | 0;
 i21 = i102 + 32 | 0;
 i100 = i102;
 i88 = HEAP32[i1 >> 2] | 0;
 i32 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = (i89 & 8 | 0) == 0;
 i2 = (i89 & 4 | 0) == 0;
 i94 = i25 & 65535;
 f95 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 i96 = i3 + 332 | 0;
 i97 = HEAP32[i96 >> 2] & 4095;
 f98 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f92 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f93 = Math_fround(Math_fround(1.0) - f92);
 if (!(i89 & 2)) {
  if (i1) {
   if (i2) {
    HEAPF32[i4 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
    i5 = i32 + 8 | 0;
    i6 = HEAP32[i32 + 92 >> 2] | 0;
    i1 = (i6 | 0) == 0;
    if (i1) {
     i10 = 0;
     i70 = 1;
    } else if (!(HEAP8[i32 + 11 >> 0] | 0)) {
     i10 = 0;
     i70 = 1;
    } else {
     i10 = HEAP16[i5 >> 1] | 0;
     i10 = i6 + (((i10 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i70 = HEAPU8[i5 + 32 + ((HEAPU8[i5 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    HEAP32[i100 >> 2] = 0;
    HEAP32[i100 + 4 >> 2] = 1;
    HEAP32[i100 + 8 >> 2] = 0;
    HEAP32[i100 + 12 >> 2] = 1;
    HEAP32[i100 + 16 >> 2] = 0;
    HEAP32[i100 + 20 >> 2] = 1;
    HEAP32[i100 + 24 >> 2] = 0;
    HEAP32[i100 + 28 >> 2] = 1;
    i69 = i25 << 16 >> 16 == 0;
    L11 : do if (!i69) {
     if (i1) {
      i1 = 0;
      while (1) {
       HEAP32[i100 + (i1 << 3) >> 2] = i4;
       HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i94 | 0)) break L11;
      }
     } else i3 = 0;
     do {
      i2 = i100 + (i3 << 3) | 0;
      i1 = i3 + 3 | 0;
      if (!(HEAP8[i5 + (i1 << 2) + 3 >> 0] | 0)) {
       HEAP32[i2 >> 2] = 0;
       i1 = i100 + (i3 << 3) + 4 | 0;
       HEAP32[i1 >> 2] = 1;
       i26 = 420;
      } else {
       i87 = HEAPU8[i5 + 32 + ((HEAPU8[i5 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i88 = HEAP16[i5 + (i1 << 2) >> 1] | 0;
       i88 = i6 + (((i88 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i88 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
       HEAP32[i2 >> 2] = i88;
       i1 = i100 + (i3 << 3) + 4 | 0;
       HEAP32[i1 >> 2] = i87;
       if (!i88) i26 = 420;
      }
      if ((i26 | 0) == 420) {
       i26 = 0;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i1 >> 2] = 0;
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i94 | 0));
    } while (0);
    f58 = Math_fround(HEAPF32[i27 >> 2]);
    f59 = Math_fround(HEAPF32[i27 + 4 >> 2]);
    f60 = Math_fround(HEAPF32[i27 + 8 >> 2]);
    f61 = Math_fround(HEAPF32[i27 + 16 >> 2]);
    f62 = Math_fround(HEAPF32[i27 + 20 >> 2]);
    f63 = Math_fround(HEAPF32[i27 + 24 >> 2]);
    f64 = Math_fround(HEAPF32[i27 + 32 >> 2]);
    f65 = Math_fround(HEAPF32[i27 + 36 >> 2]);
    f66 = Math_fround(HEAPF32[i27 + 40 >> 2]);
    i67 = HEAP32[i27 + 48 >> 2] | 0;
    i68 = HEAP32[i27 + 52 >> 2] | 0;
    i57 = HEAP32[i27 + 56 >> 2] | 0;
    f20 = Math_fround(HEAPF32[i28 >> 2]);
    f16 = Math_fround(HEAPF32[i28 + 4 >> 2]);
    f17 = Math_fround(HEAPF32[i28 + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i28 + 12 >> 2]);
    f14 = Math_fround(HEAPF32[i28 + 16 >> 2]);
    f15 = Math_fround(HEAPF32[i28 + 20 >> 2]);
    f18 = Math_fround(HEAPF32[i28 + 24 >> 2]);
    f13 = Math_fround(HEAPF32[i28 + 28 >> 2]);
    f12 = Math_fround(HEAPF32[i28 + 32 >> 2]);
    f56 = Math_fround(HEAPF32[i29 >> 2]);
    f55 = Math_fround(HEAPF32[i29 + 4 >> 2]);
    f51 = Math_fround(HEAPF32[i29 + 8 >> 2]);
    i1 = HEAP32[i101 >> 2] | 0;
    i54 = i89 >>> 0 > 63;
    if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
     i46 = 0;
     i48 = 0;
     i50 = 0;
     i53 = 0;
    } else {
     i53 = HEAP32[i90 + 828 >> 2] | 0;
     i46 = HEAP32[i53 + (i99 << 4) >> 2] | 0;
     i48 = HEAP32[i53 + (i99 << 4) + 4 >> 2] | 0;
     i50 = HEAP32[i53 + (i99 << 4) + 8 >> 2] | 0;
     i53 = HEAP32[i53 + (i99 << 4) + 12 >> 2] | 0;
    }
    if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
     i45 = 0;
     i47 = 0;
     i49 = 0;
     i52 = 0;
    } else {
     i52 = HEAP32[i90 + 848 >> 2] | 0;
     i45 = HEAP32[i52 + (i99 << 4) >> 2] | 0;
     i47 = HEAP32[i52 + (i99 << 4) + 4 >> 2] | 0;
     i49 = HEAP32[i52 + (i99 << 4) + 8 >> 2] | 0;
     i52 = HEAP32[i52 + (i99 << 4) + 12 >> 2] | 0;
    }
    if (i54) {
     if (!(i89 & 512)) {
      i2 = 0;
      i3 = 0;
      i4 = 0;
     } else {
      f77 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
      f76 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
      f78 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
      f103 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
      f75 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
      f103 = Math_fround(f77 + f103);
      f75 = Math_fround(f76 + f75);
      f78 = Math_fround(f78 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
      f76 = Math_fround(Math_fround(f20 * f103) + Math_fround(Math_fround(f19 * f75) + Math_fround(f18 * f78)));
      f77 = Math_fround(Math_fround(f16 * f103) + Math_fround(Math_fround(f14 * f75) + Math_fround(f13 * f78)));
      f78 = Math_fround(Math_fround(f17 * f103) + Math_fround(Math_fround(f15 * f75) + Math_fround(f12 * f78)));
      i2 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
     }
     if (!(i89 & 8192)) {
      i44 = 0;
      i43 = 0;
      i42 = 0;
      i41 = 0;
     } else {
      i85 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i87 = i85 + 1 | 0;
      i41 = i85 + 2 | 0;
      i43 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i85 | 0;
      i86 = (Math_imul(i85, 1790253981) | 0) + 1900727103 | 0;
      i88 = (Math_imul(i87, 1790253981) | 0) + 1900727103 | 0;
      i42 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
      i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
      i85 = i85 << 11 ^ i85;
      i87 = i87 << 11 ^ i87;
      i41 = i41 << 11 ^ i41;
      i43 = i43 << 11 ^ i43;
      f76 = Math_fround(Math_fround((i86 ^ i85 ^ i85 >>> 8) & 8388607 ^ i86 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f77 = Math_fround(Math_fround((i88 ^ i87 ^ i87 >>> 8) & 8388607 ^ i88 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f78 = Math_fround(Math_fround((i42 ^ i41 ^ i41 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f103 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
      i44 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
      i43 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
      i42 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
      i41 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     }
    } else {
     i44 = 0;
     i2 = 0;
     i43 = 0;
     i3 = 0;
     i42 = 0;
     i4 = 0;
     i41 = 0;
    }
    i29 = HEAP32[i32 + 100 >> 2] | 0;
    if (i29) {
     f13 = (HEAP32[tempDoublePtr >> 2] = i67, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i30 = (i89 & 64 | 0) == 0;
     i31 = i90 + 871 | 0;
     i32 = (i89 & 128 | 0) != 0;
     i33 = i90 + 420 | 0;
     i34 = i90 + 870 | 0;
     i35 = (i89 & 256 | 0) != 0;
     i36 = i90 + 340 | 0;
     i37 = (i89 & 512 | 0) == 0;
     i38 = (i89 & 1024 | 0) == 0;
     i39 = (i89 & 2048 | 0) == 0;
     i40 = (i89 & 4096 | 0) == 0;
     i23 = (i89 & 8192 | 0) == 0;
     i24 = i90 + 520 | 0;
     i25 = i90 + 540 | 0;
     i26 = i90 + 300 | 0;
     i27 = i90 + 320 | 0;
     i28 = i90 + 440 | 0;
     i22 = i90 + 460 | 0;
     i21 = i91 + (i99 << 2) | 0;
     i11 = 0;
     do {
      f75 = Math_fround(HEAPF32[i10 >> 2]);
      f76 = Math_fround(HEAPF32[i10 + 4 >> 2]);
      f75 = Math_fround(f56 + f75);
      f76 = Math_fround(f55 + f76);
      f77 = Math_fround(f51 + Math_fround(HEAPF32[i10 + 8 >> 2]));
      f78 = Math_fround(Math_fround(Math_fround(f59 * f75) + Math_fround(f62 * f76)) + Math_fround(f14 + Math_fround(f65 * f77)));
      f103 = Math_fround(Math_fround(Math_fround(f60 * f75) + Math_fround(f63 * f76)) + Math_fround(f15 + Math_fround(f66 * f77)));
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f58 * f75) + Math_fround(f61 * f76)) + Math_fround(f13 + Math_fround(f64 * f77)));
      HEAPF32[i1 + 4 >> 2] = f78;
      HEAPF32[i1 + 8 >> 2] = f103;
      i10 = i10 + i70 | 0;
      i1 = i1 + 12 | 0;
      if (!i69) {
       i9 = 0;
       do {
        i7 = i100 + (i9 << 3) | 0;
        i8 = HEAP32[i7 >> 2] | 0;
        if (!(1 << i9 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
         HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
         i5 = i1 + 8 | 0;
         HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
         if ((i9 | 0) == 1) {
          HEAPF32[i5 >> 2] = Math_fround(0.0);
          HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
          i1 = i1 + 16 | 0;
         } else i1 = i5;
        } else {
         f12 = Math_fround(f95 * Math_fround(HEAPF32[i21 >> 2]));
         i5 = ~~f12 >>> 0;
         i6 = (i5 | 0) / (i97 | 0) | 0;
         f78 = Math_fround(f98 * Math_fround(i5 - (Math_imul(i6, i97) | 0) | 0));
         f103 = Math_fround(f93 - Math_fround(f92 * Math_fround(i6 | 0)));
         HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i8 >> 2])) + f78);
         i6 = i1 + 8 | 0;
         HEAPF32[i1 + 4 >> 2] = Math_fround(f103 + Math_fround(f92 * Math_fround(HEAPF32[i8 + 4 >> 2])));
         if ((i9 | 0) == 1) {
          HEAPF32[i6 >> 2] = Math_fround(f12 - Math_fround(i5 | 0));
          HEAPF32[i1 + 12 >> 2] = f12;
          i1 = i1 + 16 | 0;
         } else i1 = i6;
        }
        HEAP32[i7 >> 2] = i8 + (HEAP32[i100 + (i9 << 3) + 4 >> 2] | 0);
        i9 = i9 + 1 | 0;
       } while ((i9 | 0) != (i94 | 0));
      }
      do if (i54) {
       if (!i30) {
        HEAP32[i1 >> 2] = i67;
        HEAP32[i1 + 4 >> 2] = i68;
        HEAP32[i1 + 8 >> 2] = i57;
        HEAPF32[i1 + 12 >> 2] = Math_fround(i11 | 0);
        i1 = i1 + 16 | 0;
       }
       do if (!(HEAP8[i31 >> 0] | 0)) {
        if (!i32) break;
        i91 = (HEAP32[i33 >> 2] | 0) + (i99 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
        i1 = i1 + 12 | 0;
       } else {
        if (!i32) break;
        i90 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i99 << 2) >> 2] | 0;
        i91 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i99 << 2) >> 2] | 0;
        HEAP32[i1 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i99 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = i90;
        HEAP32[i1 + 8 >> 2] = i91;
        i1 = i1 + 12 | 0;
       } while (0);
       do if (!(HEAP8[i34 >> 0] | 0)) {
        if (!i35) break;
        i91 = (HEAP32[i36 >> 2] | 0) + (i99 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
        i1 = i1 + 12 | 0;
       } else {
        if (!i35) break;
        i90 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i99 << 2) >> 2] | 0;
        i91 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i99 << 2) >> 2] | 0;
        HEAP32[i1 >> 2] = HEAP32[(HEAP32[i26 >> 2] | 0) + (i99 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = i90;
        HEAP32[i1 + 8 >> 2] = i91;
        i1 = i1 + 12 | 0;
       } while (0);
       if (!i37) {
        HEAP32[i1 >> 2] = i2;
        HEAP32[i1 + 4 >> 2] = i3;
        HEAP32[i1 + 8 >> 2] = i4;
        i1 = i1 + 12 | 0;
       }
       if (!i38) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
        HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i25 >> 2] | 0) + (i99 << 2) >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i39) {
        HEAP32[i1 >> 2] = i46;
        HEAP32[i1 + 4 >> 2] = i48;
        HEAP32[i1 + 8 >> 2] = i50;
        HEAP32[i1 + 12 >> 2] = i53;
        i1 = i1 + 16 | 0;
       }
       if (!i40) {
        HEAP32[i1 >> 2] = i45;
        HEAP32[i1 + 4 >> 2] = i47;
        HEAP32[i1 + 8 >> 2] = i49;
        HEAP32[i1 + 12 >> 2] = i52;
        i1 = i1 + 16 | 0;
       }
       if (i23) break;
       HEAP32[i1 >> 2] = i44;
       HEAP32[i1 + 4 >> 2] = i43;
       HEAP32[i1 + 8 >> 2] = i42;
       HEAP32[i1 + 12 >> 2] = i41;
       i1 = i1 + 16 | 0;
      } while (0);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i29 | 0));
    }
    HEAP32[i101 >> 2] = i1;
    STACKTOP = i102;
    return;
   };
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i32 + 8 | 0;
   i8 = HEAP32[i32 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i50 = 0;
    i1 = 1;
    i2 = 1;
   } else {
    if (!(HEAP8[i32 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i32 + 39 >> 0] | 0)) {
     i3 = 0;
     i50 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i32 + 36 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i50 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i32 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i100 >> 2] = 0;
   HEAP32[i100 + 4 >> 2] = 1;
   HEAP32[i100 + 8 >> 2] = 0;
   HEAP32[i100 + 12 >> 2] = 1;
   HEAP32[i100 + 16 >> 2] = 0;
   HEAP32[i100 + 20 >> 2] = 1;
   HEAP32[i100 + 24 >> 2] = 0;
   HEAP32[i100 + 28 >> 2] = 1;
   i74 = (i3 | 0) == 0;
   i31 = i74 ? i4 : i3;
   i74 = i74 ? 0 : i1;
   i73 = i25 << 16 >> 16 == 0;
   L93 : do if (!i73) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i100 + (i1 << 3) >> 2] = i6;
      HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i94 | 0)) break L93;
     }
    } else i4 = 0;
    do {
     i3 = i100 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 366;
     } else {
      i87 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i88 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i88 = i8 + (((i88 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i88 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i88;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i87;
      if (!i88) i26 = 366;
     }
     if ((i26 | 0) == 366) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i94 | 0));
   } while (0);
   f62 = Math_fround(HEAPF32[i27 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i71 = HEAP32[i27 + 48 >> 2] | 0;
   i72 = HEAP32[i27 + 52 >> 2] | 0;
   i70 = HEAP32[i27 + 56 >> 2] | 0;
   i6 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i28 + 4 >> 2] | 0;
   i8 = HEAP32[i28 + 8 >> 2] | 0;
   i21 = HEAP32[i28 + 12 >> 2] | 0;
   i22 = HEAP32[i28 + 16 >> 2] | 0;
   i23 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = HEAP32[i28 + 24 >> 2] | 0;
   i10 = HEAP32[i28 + 28 >> 2] | 0;
   i11 = HEAP32[i28 + 32 >> 2] | 0;
   f61 = Math_fround(HEAPF32[i29 >> 2]);
   f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i101 >> 2] | 0;
   i69 = i89 >>> 0 > 63;
   if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
    i49 = 0;
    i53 = 0;
    i57 = 0;
    i68 = 0;
   } else {
    i68 = HEAP32[i90 + 828 >> 2] | 0;
    i49 = HEAP32[i68 + (i99 << 4) >> 2] | 0;
    i53 = HEAP32[i68 + (i99 << 4) + 4 >> 2] | 0;
    i57 = HEAP32[i68 + (i99 << 4) + 8 >> 2] | 0;
    i68 = HEAP32[i68 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
    i48 = 0;
    i52 = 0;
    i54 = 0;
    i67 = 0;
   } else {
    i67 = HEAP32[i90 + 848 >> 2] | 0;
    i48 = HEAP32[i67 + (i99 << 4) >> 2] | 0;
    i52 = HEAP32[i67 + (i99 << 4) + 4 >> 2] | 0;
    i54 = HEAP32[i67 + (i99 << 4) + 8 >> 2] | 0;
    i67 = HEAP32[i67 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (i69) {
    if (!(i89 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f19 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
     f17 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
     f103 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
     f51 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
     f55 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
     f51 = Math_fround(f19 + f51);
     f55 = Math_fround(f17 + f55);
     f103 = Math_fround(f103 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
     f17 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f19 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = Math_fround(f17 * f51);
     f19 = Math_fround(f19 * f51);
     f51 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f51);
     f56 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f58 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f56 = Math_fround(f56 * f103);
     f58 = Math_fround(f58 * f103);
     f103 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103);
     f18 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f56 = Math_fround(f17 + Math_fround(Math_fround(f18 * f55) + f56));
     f58 = Math_fround(f19 + Math_fround(Math_fround(f20 * f55) + f58));
     f103 = Math_fround(f51 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f55) + f103));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i89 & 8192)) {
     i47 = 0;
     i46 = 0;
     i45 = 0;
     i44 = 0;
    } else {
     i85 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     i87 = i85 + 1 | 0;
     i44 = i85 + 2 | 0;
     i46 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i85 | 0;
     i86 = (Math_imul(i85, 1790253981) | 0) + 1900727103 | 0;
     i88 = (Math_imul(i87, 1790253981) | 0) + 1900727103 | 0;
     i45 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
     i47 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
     i85 = i85 << 11 ^ i85;
     i87 = i87 << 11 ^ i87;
     i44 = i44 << 11 ^ i44;
     i46 = i46 << 11 ^ i46;
     f55 = Math_fround(Math_fround((i86 ^ i85 ^ i85 >>> 8) & 8388607 ^ i86 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f56 = Math_fround(Math_fround((i88 ^ i87 ^ i87 >>> 8) & 8388607 ^ i88 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f58 = Math_fround(Math_fround((i45 ^ i44 ^ i44 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f103 = Math_fround(Math_fround((i47 ^ i46 ^ i46 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i47 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
     i46 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
     i45 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
     i44 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i47 = 0;
    i3 = 0;
    i46 = 0;
    i4 = 0;
    i45 = 0;
    i5 = 0;
    i44 = 0;
   }
   i32 = HEAP32[i32 + 100 >> 2] | 0;
   if (i32) {
    f55 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f58 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i33 = (i89 & 64 | 0) == 0;
    i34 = i90 + 871 | 0;
    i35 = (i89 & 128 | 0) != 0;
    i36 = i90 + 420 | 0;
    i37 = i90 + 870 | 0;
    i38 = (i89 & 256 | 0) != 0;
    i39 = i90 + 340 | 0;
    i40 = (i89 & 512 | 0) == 0;
    i41 = (i89 & 1024 | 0) == 0;
    i42 = (i89 & 2048 | 0) == 0;
    i43 = (i89 & 4096 | 0) == 0;
    i25 = (i89 & 8192 | 0) == 0;
    i26 = i90 + 520 | 0;
    i27 = i90 + 540 | 0;
    i28 = i90 + 300 | 0;
    i29 = i90 + 320 | 0;
    i30 = i90 + 440 | 0;
    i24 = i90 + 460 | 0;
    f51 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i23 = i91 + (i99 << 2) | 0;
    i22 = 0;
    i21 = i31;
    i11 = i50;
    while (1) {
     f106 = Math_fround(HEAPF32[i11 >> 2]);
     f105 = Math_fround(HEAPF32[i11 + 4 >> 2]);
     f106 = Math_fround(f61 + f106);
     f105 = Math_fround(f60 + f105);
     f104 = Math_fround(f59 + Math_fround(HEAPF32[i11 + 8 >> 2]));
     f12 = Math_fround(Math_fround(Math_fround(f63 * f106) + Math_fround(f66 * f105)) + Math_fround(f56 + Math_fround(f77 * f104)));
     f103 = Math_fround(Math_fround(Math_fround(f64 * f106) + Math_fround(f75 * f105)) + Math_fround(f58 + Math_fround(f78 * f104)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f106) + Math_fround(f65 * f105)) + Math_fround(f55 + Math_fround(f76 * f104)));
     HEAPF32[i1 + 4 >> 2] = f12;
     HEAPF32[i1 + 8 >> 2] = f103;
     i11 = i11 + i2 | 0;
     i1 = i1 + 12 | 0;
     if (!i73) {
      i10 = 0;
      do {
       i8 = i100 + (i10 << 3) | 0;
       i9 = HEAP32[i8 >> 2] | 0;
       if (!(1 << i10 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
        HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
        i6 = i1 + 8 | 0;
        HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
        if ((i10 | 0) == 1) {
         HEAPF32[i6 >> 2] = Math_fround(0.0);
         HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
         i1 = i1 + 16 | 0;
        } else i1 = i6;
       } else {
        f12 = Math_fround(f95 * Math_fround(HEAPF32[i23 >> 2]));
        i6 = ~~f12 >>> 0;
        i7 = (i6 | 0) / (i97 | 0) | 0;
        f105 = Math_fround(f98 * Math_fround(i6 - (Math_imul(i7, i97) | 0) | 0));
        f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i7 | 0)));
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i9 >> 2])) + f105);
        i7 = i1 + 8 | 0;
        HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i9 + 4 >> 2])));
        if ((i10 | 0) == 1) {
         HEAPF32[i7 >> 2] = Math_fround(f12 - Math_fround(i6 | 0));
         HEAPF32[i1 + 12 >> 2] = f12;
         i1 = i1 + 16 | 0;
        } else i1 = i7;
       }
       HEAP32[i8 >> 2] = i9 + (HEAP32[i100 + (i10 << 3) + 4 >> 2] | 0);
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i94 | 0));
     }
     do if (i69) {
      if (!i33) {
       HEAP32[i1 >> 2] = i71;
       HEAP32[i1 + 4 >> 2] = i72;
       HEAP32[i1 + 8 >> 2] = i70;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
       i1 = i1 + 16 | 0;
      }
      if (!(HEAP8[i34 >> 0] | 0)) {
       if (i35) {
        i91 = (HEAP32[i36 >> 2] | 0) + (i99 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i35) {
       i90 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i36 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      }
      do if (!(HEAP8[i37 >> 0] | 0)) {
       if (!i38) break;
       i91 = (HEAP32[i39 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i38) break;
       i90 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i39 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i28 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i40) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i41) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i26 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + (i99 << 2) >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i42) {
       HEAP32[i1 >> 2] = i49;
       HEAP32[i1 + 4 >> 2] = i53;
       HEAP32[i1 + 8 >> 2] = i57;
       HEAP32[i1 + 12 >> 2] = i68;
       i1 = i1 + 16 | 0;
      }
      if (!i43) {
       HEAP32[i1 >> 2] = i48;
       HEAP32[i1 + 4 >> 2] = i52;
       HEAP32[i1 + 8 >> 2] = i54;
       HEAP32[i1 + 12 >> 2] = i67;
       i1 = i1 + 16 | 0;
      }
      if (i25) break;
      HEAP32[i1 >> 2] = i47;
      HEAP32[i1 + 4 >> 2] = i46;
      HEAP32[i1 + 8 >> 2] = i45;
      HEAP32[i1 + 12 >> 2] = i44;
      i1 = i1 + 16 | 0;
     } while (0);
     i91 = i21;
     f12 = Math_fround(HEAPF32[i91 >> 2]);
     f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
     f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
     f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
     f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
     HEAPF32[i1 + 4 >> 2] = f105;
     HEAPF32[i1 + 8 >> 2] = f106;
     HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     i1 = i1 + 16 | 0;
     i22 = i22 + 1 | 0;
     if ((i22 | 0) == (i32 | 0)) break; else i21 = i21 + i74 | 0;
    }
   }
   HEAP32[i101 >> 2] = i1;
   STACKTOP = i102;
   return;
  }
  if (i2) {
   HEAP32[i4 >> 2] = -1;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i32 + 8 | 0;
   i8 = HEAP32[i32 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i11 = 0;
    i2 = 1;
    i1 = 1;
   } else {
    if (!(HEAP8[i32 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i32 + 19 >> 0] | 0)) {
     i3 = 0;
     i11 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i32 + 16 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i11 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i32 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i100 >> 2] = 0;
   HEAP32[i100 + 4 >> 2] = 1;
   HEAP32[i100 + 8 >> 2] = 0;
   HEAP32[i100 + 12 >> 2] = 1;
   HEAP32[i100 + 16 >> 2] = 0;
   HEAP32[i100 + 20 >> 2] = 1;
   HEAP32[i100 + 24 >> 2] = 0;
   HEAP32[i100 + 28 >> 2] = 1;
   i80 = (i3 | 0) == 0;
   i21 = i80 ? i4 : i3;
   i80 = i80 ? 0 : i1;
   i79 = i25 << 16 >> 16 == 0;
   L177 : do if (!i79) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i100 + (i1 << 3) >> 2] = i6;
      HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i94 | 0)) break L177;
     }
    } else i4 = 0;
    do {
     i3 = i100 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 309;
     } else {
      i86 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i87 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i87 = i8 + (((i87 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i87 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i87;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i86;
      if (!i87) i26 = 309;
     }
     if ((i26 | 0) == 309) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i94 | 0));
   } while (0);
   f58 = Math_fround(HEAPF32[i27 >> 2]);
   f59 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f60 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f61 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f62 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f65 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f66 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i73 = HEAP32[i27 + 48 >> 2] | 0;
   i74 = HEAP32[i27 + 52 >> 2] | 0;
   i72 = HEAP32[i27 + 56 >> 2] | 0;
   f20 = Math_fround(HEAPF32[i28 >> 2]);
   f16 = Math_fround(HEAPF32[i28 + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i28 + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i28 + 12 >> 2]);
   f14 = Math_fround(HEAPF32[i28 + 16 >> 2]);
   f15 = Math_fround(HEAPF32[i28 + 20 >> 2]);
   f18 = Math_fround(HEAPF32[i28 + 24 >> 2]);
   f13 = Math_fround(HEAPF32[i28 + 28 >> 2]);
   f12 = Math_fround(HEAPF32[i28 + 32 >> 2]);
   f56 = Math_fround(HEAPF32[i29 >> 2]);
   f55 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f51 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i101 >> 2] | 0;
   i71 = i89 >>> 0 > 63;
   if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
    i53 = 0;
    i57 = 0;
    i68 = 0;
    i70 = 0;
   } else {
    i70 = HEAP32[i90 + 828 >> 2] | 0;
    i53 = HEAP32[i70 + (i99 << 4) >> 2] | 0;
    i57 = HEAP32[i70 + (i99 << 4) + 4 >> 2] | 0;
    i68 = HEAP32[i70 + (i99 << 4) + 8 >> 2] | 0;
    i70 = HEAP32[i70 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
    i52 = 0;
    i54 = 0;
    i67 = 0;
    i69 = 0;
   } else {
    i69 = HEAP32[i90 + 848 >> 2] | 0;
    i52 = HEAP32[i69 + (i99 << 4) >> 2] | 0;
    i54 = HEAP32[i69 + (i99 << 4) + 4 >> 2] | 0;
    i67 = HEAP32[i69 + (i99 << 4) + 8 >> 2] | 0;
    i69 = HEAP32[i69 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (i71) {
    if (!(i89 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f105 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
     f104 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
     f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
     f78 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
     f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
     f78 = Math_fround(f105 + f78);
     f103 = Math_fround(f104 + f103);
     f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
     f104 = Math_fround(Math_fround(f20 * f78) + Math_fround(Math_fround(f19 * f103) + Math_fround(f18 * f106)));
     f105 = Math_fround(Math_fround(f16 * f78) + Math_fround(Math_fround(f14 * f103) + Math_fround(f13 * f106)));
     f106 = Math_fround(Math_fround(f17 * f78) + Math_fround(Math_fround(f15 * f103) + Math_fround(f12 * f106)));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i89 & 8192)) {
     i50 = 0;
     i49 = 0;
     i48 = 0;
     i47 = 0;
    } else {
     i84 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     i86 = i84 + 1 | 0;
     i47 = i84 + 2 | 0;
     i49 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i84 | 0;
     i85 = (Math_imul(i84, 1790253981) | 0) + 1900727103 | 0;
     i87 = (Math_imul(i86, 1790253981) | 0) + 1900727103 | 0;
     i48 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
     i50 = (Math_imul(i49, 1790253981) | 0) + 1900727103 | 0;
     i84 = i84 << 11 ^ i84;
     i86 = i86 << 11 ^ i86;
     i47 = i47 << 11 ^ i47;
     i49 = i49 << 11 ^ i49;
     f103 = Math_fround(Math_fround((i85 ^ i84 ^ i84 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f104 = Math_fround(Math_fround((i87 ^ i86 ^ i86 >>> 8) & 8388607 ^ i87 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f105 = Math_fround(Math_fround((i48 ^ i47 ^ i47 >>> 8) & 8388607 ^ i48 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f106 = Math_fround(Math_fround((i50 ^ i49 ^ i49 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i50 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i49 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i48 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i47 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i50 = 0;
    i3 = 0;
    i49 = 0;
    i4 = 0;
    i48 = 0;
    i5 = 0;
    i47 = 0;
   }
   i35 = i32 + 100 | 0;
   if (HEAP32[i35 >> 2] | 0) {
    f13 = (HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i36 = (i89 & 64 | 0) == 0;
    i37 = i90 + 871 | 0;
    i38 = (i89 & 128 | 0) != 0;
    i39 = i90 + 420 | 0;
    i40 = i90 + 870 | 0;
    i41 = (i89 & 256 | 0) != 0;
    i42 = i90 + 340 | 0;
    i43 = (i89 & 512 | 0) == 0;
    i44 = (i89 & 1024 | 0) == 0;
    i45 = (i89 & 2048 | 0) == 0;
    i46 = (i89 & 4096 | 0) == 0;
    i29 = (i89 & 8192 | 0) == 0;
    i30 = i90 + 520 | 0;
    i31 = i90 + 540 | 0;
    i32 = i90 + 300 | 0;
    i33 = i90 + 320 | 0;
    i34 = i90 + 440 | 0;
    i28 = i90 + 460 | 0;
    i25 = i91 + (i99 << 2) | 0;
    i26 = i88 & 255;
    i24 = i88 >>> 8;
    i27 = i24 & 255;
    i23 = i88 & 16711680;
    i24 = i24 & 16711680;
    i22 = 0;
    do {
     f78 = Math_fround(HEAPF32[i11 >> 2]);
     f103 = Math_fround(HEAPF32[i11 + 4 >> 2]);
     f78 = Math_fround(f56 + f78);
     f103 = Math_fround(f55 + f103);
     f104 = Math_fround(f51 + Math_fround(HEAPF32[i11 + 8 >> 2]));
     f105 = Math_fround(Math_fround(Math_fround(f59 * f78) + Math_fround(f62 * f103)) + Math_fround(f14 + Math_fround(f65 * f104)));
     f106 = Math_fround(Math_fround(Math_fround(f60 * f78) + Math_fround(f63 * f103)) + Math_fround(f15 + Math_fround(f66 * f104)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f58 * f78) + Math_fround(f61 * f103)) + Math_fround(f13 + Math_fround(f64 * f104)));
     HEAPF32[i1 + 4 >> 2] = f105;
     HEAPF32[i1 + 8 >> 2] = f106;
     i11 = i11 + i2 | 0;
     i91 = HEAP32[i21 >> 2] | 0;
     HEAP32[i1 + 12 >> 2] = (Math_imul((i91 >>> 8 & 255) + 1 | 0, i27) | 0) & 65280 | (Math_imul((i91 >>> 24) + 1 | 0, i24) | 0) & -16777216 | (Math_imul((i91 & 255) + 1 | 0, i26) | 0) >>> 8 & 255 | (Math_imul((i91 >>> 16 & 255) + 1 | 0, i23) | 0) >>> 8 & 16711680;
     i21 = i21 + i80 | 0;
     i1 = i1 + 16 | 0;
     if (!i79) {
      i10 = 0;
      do {
       i8 = i100 + (i10 << 3) | 0;
       i9 = HEAP32[i8 >> 2] | 0;
       if (!(1 << i10 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
        HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
        i6 = i1 + 8 | 0;
        HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
        if ((i10 | 0) == 1) {
         HEAPF32[i6 >> 2] = Math_fround(0.0);
         HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
         i1 = i1 + 16 | 0;
        } else i1 = i6;
       } else {
        f12 = Math_fround(f95 * Math_fround(HEAPF32[i25 >> 2]));
        i6 = ~~f12 >>> 0;
        i7 = (i6 | 0) / (i97 | 0) | 0;
        f105 = Math_fround(f98 * Math_fround(i6 - (Math_imul(i7, i97) | 0) | 0));
        f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i7 | 0)));
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i9 >> 2])) + f105);
        i7 = i1 + 8 | 0;
        HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i9 + 4 >> 2])));
        if ((i10 | 0) == 1) {
         HEAPF32[i7 >> 2] = Math_fround(f12 - Math_fround(i6 | 0));
         HEAPF32[i1 + 12 >> 2] = f12;
         i1 = i1 + 16 | 0;
        } else i1 = i7;
       }
       HEAP32[i8 >> 2] = i9 + (HEAP32[i100 + (i10 << 3) + 4 >> 2] | 0);
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i94 | 0));
     }
     do if (i71) {
      if (!i36) {
       HEAP32[i1 >> 2] = i73;
       HEAP32[i1 + 4 >> 2] = i74;
       HEAP32[i1 + 8 >> 2] = i72;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
       i1 = i1 + 16 | 0;
      }
      if (!(HEAP8[i37 >> 0] | 0)) {
       if (i38) {
        i91 = (HEAP32[i39 >> 2] | 0) + (i99 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i38) {
       i90 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i39 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      }
      do if (!(HEAP8[i40 >> 0] | 0)) {
       if (!i41) break;
       i91 = (HEAP32[i42 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i41) break;
       i90 = HEAP32[(HEAP32[i33 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i32 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i43) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i44) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i30 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i31 >> 2] | 0) + (i99 << 2) >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i45) {
       HEAP32[i1 >> 2] = i53;
       HEAP32[i1 + 4 >> 2] = i57;
       HEAP32[i1 + 8 >> 2] = i68;
       HEAP32[i1 + 12 >> 2] = i70;
       i1 = i1 + 16 | 0;
      }
      if (!i46) {
       HEAP32[i1 >> 2] = i52;
       HEAP32[i1 + 4 >> 2] = i54;
       HEAP32[i1 + 8 >> 2] = i67;
       HEAP32[i1 + 12 >> 2] = i69;
       i1 = i1 + 16 | 0;
      }
      if (i29) break;
      HEAP32[i1 >> 2] = i50;
      HEAP32[i1 + 4 >> 2] = i49;
      HEAP32[i1 + 8 >> 2] = i48;
      HEAP32[i1 + 12 >> 2] = i47;
      i1 = i1 + 16 | 0;
     } while (0);
     i22 = i22 + 1 | 0;
    } while (i22 >>> 0 < (HEAP32[i35 >> 2] | 0) >>> 0);
   }
   HEAP32[i101 >> 2] = i1;
   STACKTOP = i102;
   return;
  };
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = -1;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i32 + 8 | 0;
  i11 = HEAP32[i32 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 1;
   i5 = 1;
   i7 = 1;
  } else {
   if (!(HEAP8[i32 + 11 >> 0] | 0)) {
    i2 = 0;
    i5 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 39 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i1 = HEAP16[i32 + 36 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 19 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i32 + 16 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i100 >> 2] = 0;
  HEAP32[i100 + 4 >> 2] = 1;
  HEAP32[i100 + 8 >> 2] = 0;
  HEAP32[i100 + 12 >> 2] = 1;
  HEAP32[i100 + 16 >> 2] = 0;
  HEAP32[i100 + 20 >> 2] = 1;
  HEAP32[i100 + 24 >> 2] = 0;
  HEAP32[i100 + 28 >> 2] = 1;
  i84 = (i1 | 0) == 0;
  i52 = i84 ? i4 : i1;
  i84 = i84 ? 0 : i3;
  i83 = (i8 | 0) == 0;
  i30 = i83 ? i6 : i8;
  i83 = i83 ? 0 : i7;
  i82 = i25 << 16 >> 16 == 0;
  L262 : do if (!i82) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i100 + (i1 << 3) >> 2] = i6;
     HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i94 | 0)) break L262;
    }
   } else i4 = 0;
   do {
    i3 = i100 + (i4 << 3) | 0;
    i1 = i4 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i3 >> 2] = 0;
     i1 = i100 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 253;
    } else {
     i86 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i87 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i87 = i11 + (((i87 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i87 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i3 >> 2] = i87;
     i1 = i100 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i86;
     if (!i87) i26 = 253;
    }
    if ((i26 | 0) == 253) {
     i26 = 0;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i94 | 0));
  } while (0);
  f62 = Math_fround(HEAPF32[i27 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i80 = HEAP32[i27 + 48 >> 2] | 0;
  i81 = HEAP32[i27 + 52 >> 2] | 0;
  i79 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i21 = HEAP32[i28 + 32 >> 2] | 0;
  f61 = Math_fround(HEAPF32[i29 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i101 >> 2] | 0;
  i74 = i89 >>> 0 > 63;
  if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
   i67 = 0;
   i69 = 0;
   i71 = 0;
   i73 = 0;
  } else {
   i73 = HEAP32[i90 + 828 >> 2] | 0;
   i67 = HEAP32[i73 + (i99 << 4) >> 2] | 0;
   i69 = HEAP32[i73 + (i99 << 4) + 4 >> 2] | 0;
   i71 = HEAP32[i73 + (i99 << 4) + 8 >> 2] | 0;
   i73 = HEAP32[i73 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
   i57 = 0;
   i68 = 0;
   i70 = 0;
   i72 = 0;
  } else {
   i72 = HEAP32[i90 + 848 >> 2] | 0;
   i57 = HEAP32[i72 + (i99 << 4) >> 2] | 0;
   i68 = HEAP32[i72 + (i99 << 4) + 4 >> 2] | 0;
   i70 = HEAP32[i72 + (i99 << 4) + 8 >> 2] | 0;
   i72 = HEAP32[i72 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (i74) {
   if (!(i89 & 512)) {
    i3 = 0;
    i4 = 0;
    i6 = 0;
   } else {
    f55 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
    f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
    f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(f55 + f58);
    f103 = Math_fround(f20 + f103);
    f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f20 * f58);
    f55 = Math_fround(f55 * f58);
    f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
    f104 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f105 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f104 * f106);
    f105 = Math_fround(f105 * f106);
    f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
    f51 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f20 + Math_fround(Math_fround(f51 * f103) + f104));
    f105 = Math_fround(f55 + Math_fround(Math_fround(f56 * f103) + f105));
    f106 = Math_fround(f58 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103) + f106));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i89 & 8192)) {
    i54 = 0;
    i53 = 0;
    i50 = 0;
    i49 = 0;
   } else {
    i48 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
    i86 = i48 + 1 | 0;
    i49 = i48 + 2 | 0;
    i53 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i48 | 0;
    i85 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i87 = (Math_imul(i86, 1790253981) | 0) + 1900727103 | 0;
    i50 = (Math_imul(i49, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
    i48 = i48 << 11 ^ i48;
    i86 = i86 << 11 ^ i86;
    i49 = i49 << 11 ^ i49;
    i53 = i53 << 11 ^ i53;
    f103 = Math_fround(Math_fround((i85 ^ i48 ^ i48 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f104 = Math_fround(Math_fround((i87 ^ i86 ^ i86 >>> 8) & 8388607 ^ i87 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f105 = Math_fround(Math_fround((i50 ^ i49 ^ i49 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f106 = Math_fround(Math_fround((i54 ^ i53 ^ i53 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i54 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    i53 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i50 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i49 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i54 = 0;
   i3 = 0;
   i53 = 0;
   i4 = 0;
   i50 = 0;
   i6 = 0;
   i49 = 0;
  }
  i37 = i32 + 100 | 0;
  if (HEAP32[i37 >> 2] | 0) {
   f55 = (HEAP32[tempDoublePtr >> 2] = i80, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = (HEAP32[tempDoublePtr >> 2] = i81, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f58 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i38 = (i89 & 64 | 0) == 0;
   i39 = i90 + 871 | 0;
   i40 = (i89 & 128 | 0) != 0;
   i41 = i90 + 420 | 0;
   i42 = i90 + 870 | 0;
   i43 = (i89 & 256 | 0) != 0;
   i44 = i90 + 340 | 0;
   i45 = (i89 & 512 | 0) == 0;
   i46 = (i89 & 1024 | 0) == 0;
   i47 = (i89 & 2048 | 0) == 0;
   i48 = (i89 & 4096 | 0) == 0;
   i31 = (i89 & 8192 | 0) == 0;
   i32 = i90 + 520 | 0;
   i33 = i90 + 540 | 0;
   i34 = i90 + 300 | 0;
   i35 = i90 + 320 | 0;
   i36 = i90 + 440 | 0;
   i29 = i90 + 460 | 0;
   f51 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i26 = i91 + (i99 << 2) | 0;
   i27 = i88 & 255;
   i25 = i88 >>> 8;
   i28 = i25 & 255;
   i24 = i88 & 16711680;
   i25 = i25 & 16711680;
   i23 = 0;
   i22 = i30;
   i21 = i52;
   while (1) {
    f12 = Math_fround(HEAPF32[i2 >> 2]);
    f103 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f12 = Math_fround(f61 + f12);
    f103 = Math_fround(f60 + f103);
    f104 = Math_fround(f59 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f105 = Math_fround(Math_fround(Math_fround(f63 * f12) + Math_fround(f66 * f103)) + Math_fround(f56 + Math_fround(f77 * f104)));
    f106 = Math_fround(Math_fround(Math_fround(f64 * f12) + Math_fround(f75 * f103)) + Math_fround(f58 + Math_fround(f78 * f104)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f12) + Math_fround(f65 * f103)) + Math_fround(f55 + Math_fround(f76 * f104)));
    HEAPF32[i1 + 4 >> 2] = f105;
    HEAPF32[i1 + 8 >> 2] = f106;
    i2 = i2 + i5 | 0;
    i91 = HEAP32[i22 >> 2] | 0;
    HEAP32[i1 + 12 >> 2] = (Math_imul((i91 >>> 8 & 255) + 1 | 0, i28) | 0) & 65280 | (Math_imul((i91 >>> 24) + 1 | 0, i25) | 0) & -16777216 | (Math_imul((i91 & 255) + 1 | 0, i27) | 0) >>> 8 & 255 | (Math_imul((i91 >>> 16 & 255) + 1 | 0, i24) | 0) >>> 8 & 16711680;
    i22 = i22 + i83 | 0;
    i1 = i1 + 16 | 0;
    if (!i82) {
     i11 = 0;
     do {
      i9 = i100 + (i11 << 3) | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      if (!(1 << i11 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
       HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
       i7 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
       if ((i11 | 0) == 1) {
        HEAPF32[i7 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i7;
      } else {
       f12 = Math_fround(f95 * Math_fround(HEAPF32[i26 >> 2]));
       i7 = ~~f12 >>> 0;
       i8 = (i7 | 0) / (i97 | 0) | 0;
       f105 = Math_fround(f98 * Math_fround(i7 - (Math_imul(i8, i97) | 0) | 0));
       f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i8 | 0)));
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i10 >> 2])) + f105);
       i8 = i1 + 8 | 0;
       HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i10 + 4 >> 2])));
       if ((i11 | 0) == 1) {
        HEAPF32[i8 >> 2] = Math_fround(f12 - Math_fround(i7 | 0));
        HEAPF32[i1 + 12 >> 2] = f12;
        i1 = i1 + 16 | 0;
       } else i1 = i8;
      }
      HEAP32[i9 >> 2] = i10 + (HEAP32[i100 + (i11 << 3) + 4 >> 2] | 0);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i94 | 0));
    }
    do if (i74) {
     if (!i38) {
      HEAP32[i1 >> 2] = i80;
      HEAP32[i1 + 4 >> 2] = i81;
      HEAP32[i1 + 8 >> 2] = i79;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i23 | 0);
      i1 = i1 + 16 | 0;
     }
     if (!(HEAP8[i39 >> 0] | 0)) {
      if (i40) {
       i91 = (HEAP32[i41 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i40) {
      i90 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i41 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!(HEAP8[i42 >> 0] | 0)) {
      if (i43) {
       i91 = (HEAP32[i44 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i43) {
      i90 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i44 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i34 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!i45) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i1 + 4 >> 2] = i4;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i46) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i99 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i47) {
      HEAP32[i1 >> 2] = i67;
      HEAP32[i1 + 4 >> 2] = i69;
      HEAP32[i1 + 8 >> 2] = i71;
      HEAP32[i1 + 12 >> 2] = i73;
      i1 = i1 + 16 | 0;
     }
     if (!i48) {
      HEAP32[i1 >> 2] = i57;
      HEAP32[i1 + 4 >> 2] = i68;
      HEAP32[i1 + 8 >> 2] = i70;
      HEAP32[i1 + 12 >> 2] = i72;
      i1 = i1 + 16 | 0;
     }
     if (i31) break;
     HEAP32[i1 >> 2] = i54;
     HEAP32[i1 + 4 >> 2] = i53;
     HEAP32[i1 + 8 >> 2] = i50;
     HEAP32[i1 + 12 >> 2] = i49;
     i1 = i1 + 16 | 0;
    } while (0);
    i91 = i21;
    f12 = Math_fround(HEAPF32[i91 >> 2]);
    f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
    f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
    f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
    f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
    HEAPF32[i1 + 4 >> 2] = f105;
    HEAPF32[i1 + 8 >> 2] = f106;
    HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    i1 = i1 + 16 | 0;
    i23 = i23 + 1 | 0;
    if (i23 >>> 0 >= (HEAP32[i37 >> 2] | 0) >>> 0) break; else i21 = i21 + i84 | 0;
   }
  }
  HEAP32[i101 >> 2] = i1;
  STACKTOP = i102;
  return;
 }
 if (i1) {
  if (i2) {
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i32 + 8 | 0;
   i8 = HEAP32[i32 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i69 = 0;
    i2 = 1;
    i1 = 1;
   } else {
    if (!(HEAP8[i32 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i32 + 15 >> 0] | 0)) {
     i3 = 0;
     i69 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i32 + 12 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i69 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i32 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i100 >> 2] = 0;
   HEAP32[i100 + 4 >> 2] = 1;
   HEAP32[i100 + 8 >> 2] = 0;
   HEAP32[i100 + 12 >> 2] = 1;
   HEAP32[i100 + 16 >> 2] = 0;
   HEAP32[i100 + 20 >> 2] = 1;
   HEAP32[i100 + 24 >> 2] = 0;
   HEAP32[i100 + 28 >> 2] = 1;
   i74 = (i3 | 0) == 0;
   i43 = i74 ? i4 : i3;
   i74 = i74 ? 0 : i1;
   i73 = i25 << 16 >> 16 == 0;
   L348 : do if (!i73) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i100 + (i1 << 3) >> 2] = i6;
      HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i94 | 0)) break L348;
     }
    } else i4 = 0;
    do {
     i3 = i100 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 193;
     } else {
      i87 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i88 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i88 = i8 + (((i88 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i88 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i88;
      i1 = i100 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i87;
      if (!i88) i26 = 193;
     }
     if ((i26 | 0) == 193) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i94 | 0));
   } while (0);
   f62 = Math_fround(HEAPF32[i27 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i71 = HEAP32[i27 + 48 >> 2] | 0;
   i72 = HEAP32[i27 + 52 >> 2] | 0;
   i70 = HEAP32[i27 + 56 >> 2] | 0;
   i6 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i28 + 4 >> 2] | 0;
   i8 = HEAP32[i28 + 8 >> 2] | 0;
   i21 = HEAP32[i28 + 12 >> 2] | 0;
   i22 = HEAP32[i28 + 16 >> 2] | 0;
   i23 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = HEAP32[i28 + 24 >> 2] | 0;
   i10 = HEAP32[i28 + 28 >> 2] | 0;
   i11 = HEAP32[i28 + 32 >> 2] | 0;
   f61 = Math_fround(HEAPF32[i29 >> 2]);
   f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i101 >> 2] | 0;
   i68 = i89 >>> 0 > 63;
   if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
    i49 = 0;
    i52 = 0;
    i54 = 0;
    i67 = 0;
   } else {
    i67 = HEAP32[i90 + 828 >> 2] | 0;
    i49 = HEAP32[i67 + (i99 << 4) >> 2] | 0;
    i52 = HEAP32[i67 + (i99 << 4) + 4 >> 2] | 0;
    i54 = HEAP32[i67 + (i99 << 4) + 8 >> 2] | 0;
    i67 = HEAP32[i67 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
    i48 = 0;
    i50 = 0;
    i53 = 0;
    i57 = 0;
   } else {
    i57 = HEAP32[i90 + 848 >> 2] | 0;
    i48 = HEAP32[i57 + (i99 << 4) >> 2] | 0;
    i50 = HEAP32[i57 + (i99 << 4) + 4 >> 2] | 0;
    i53 = HEAP32[i57 + (i99 << 4) + 8 >> 2] | 0;
    i57 = HEAP32[i57 + (i99 << 4) + 12 >> 2] | 0;
   }
   if (i68) {
    if (!(i89 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f55 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
     f20 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
     f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
     f58 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
     f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
     f58 = Math_fround(f55 + f58);
     f103 = Math_fround(f20 + f103);
     f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
     f20 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f55 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = Math_fround(f20 * f58);
     f55 = Math_fround(f55 * f58);
     f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
     f104 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f105 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f104 = Math_fround(f104 * f106);
     f105 = Math_fround(f105 * f106);
     f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
     f51 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f56 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f104 = Math_fround(f20 + Math_fround(Math_fround(f51 * f103) + f104));
     f105 = Math_fround(f55 + Math_fround(Math_fround(f56 * f103) + f105));
     f106 = Math_fround(f58 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103) + f106));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i89 & 8192)) {
     i47 = 0;
     i46 = 0;
     i45 = 0;
     i44 = 0;
    } else {
     i85 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     i87 = i85 + 1 | 0;
     i44 = i85 + 2 | 0;
     i46 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i85 | 0;
     i86 = (Math_imul(i85, 1790253981) | 0) + 1900727103 | 0;
     i88 = (Math_imul(i87, 1790253981) | 0) + 1900727103 | 0;
     i45 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
     i47 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
     i85 = i85 << 11 ^ i85;
     i87 = i87 << 11 ^ i87;
     i44 = i44 << 11 ^ i44;
     i46 = i46 << 11 ^ i46;
     f103 = Math_fround(Math_fround((i86 ^ i85 ^ i85 >>> 8) & 8388607 ^ i86 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f104 = Math_fround(Math_fround((i88 ^ i87 ^ i87 >>> 8) & 8388607 ^ i88 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f105 = Math_fround(Math_fround((i45 ^ i44 ^ i44 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f106 = Math_fround(Math_fround((i47 ^ i46 ^ i46 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i47 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i46 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i45 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i44 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i47 = 0;
    i3 = 0;
    i46 = 0;
    i4 = 0;
    i45 = 0;
    i5 = 0;
    i44 = 0;
   }
   i42 = HEAP32[i32 + 100 >> 2] | 0;
   if (i42) {
    f55 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f58 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f51 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i31 = (i89 & 64 | 0) == 0;
    i32 = i90 + 871 | 0;
    i33 = (i89 & 128 | 0) != 0;
    i34 = i90 + 420 | 0;
    i35 = i90 + 870 | 0;
    i36 = (i89 & 256 | 0) != 0;
    i37 = i90 + 340 | 0;
    i38 = (i89 & 512 | 0) == 0;
    i39 = (i89 & 1024 | 0) == 0;
    i40 = (i89 & 2048 | 0) == 0;
    i41 = (i89 & 4096 | 0) == 0;
    i25 = (i89 & 8192 | 0) == 0;
    i26 = i90 + 520 | 0;
    i27 = i90 + 540 | 0;
    i28 = i90 + 300 | 0;
    i29 = i90 + 320 | 0;
    i30 = i90 + 440 | 0;
    i24 = i90 + 460 | 0;
    i23 = i91 + (i99 << 2) | 0;
    i22 = 0;
    i21 = i43;
    i11 = i69;
    do {
     f106 = Math_fround(HEAPF32[i11 >> 2]);
     f105 = Math_fround(HEAPF32[i11 + 4 >> 2]);
     f106 = Math_fround(f61 + f106);
     f105 = Math_fround(f60 + f105);
     f104 = Math_fround(f59 + Math_fround(HEAPF32[i11 + 8 >> 2]));
     f103 = Math_fround(Math_fround(Math_fround(f63 * f106) + Math_fround(f66 * f105)) + Math_fround(f56 + Math_fround(f77 * f104)));
     f12 = Math_fround(Math_fround(Math_fround(f64 * f106) + Math_fround(f75 * f105)) + Math_fround(f58 + Math_fround(f78 * f104)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f106) + Math_fround(f65 * f105)) + Math_fround(f55 + Math_fround(f76 * f104)));
     HEAPF32[i1 + 4 >> 2] = f103;
     HEAPF32[i1 + 8 >> 2] = f12;
     i11 = i11 + i2 | 0;
     i91 = i21;
     f12 = Math_fround(HEAPF32[i91 >> 2]);
     f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
     f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
     f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
     f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
     HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
     HEAPF32[i1 + 16 >> 2] = f105;
     HEAPF32[i1 + 20 >> 2] = f106;
     i21 = i21 + i74 | 0;
     i1 = i1 + 24 | 0;
     if (!i73) {
      i10 = 0;
      do {
       i8 = i100 + (i10 << 3) | 0;
       i9 = HEAP32[i8 >> 2] | 0;
       if (!(1 << i10 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
        HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
        i6 = i1 + 8 | 0;
        HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
        if ((i10 | 0) == 1) {
         HEAPF32[i6 >> 2] = Math_fround(0.0);
         HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
         i1 = i1 + 16 | 0;
        } else i1 = i6;
       } else {
        f12 = Math_fround(f95 * Math_fround(HEAPF32[i23 >> 2]));
        i6 = ~~f12 >>> 0;
        i7 = (i6 | 0) / (i97 | 0) | 0;
        f105 = Math_fround(f98 * Math_fround(i6 - (Math_imul(i7, i97) | 0) | 0));
        f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i7 | 0)));
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i9 >> 2])) + f105);
        i7 = i1 + 8 | 0;
        HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i9 + 4 >> 2])));
        if ((i10 | 0) == 1) {
         HEAPF32[i7 >> 2] = Math_fround(f12 - Math_fround(i6 | 0));
         HEAPF32[i1 + 12 >> 2] = f12;
         i1 = i1 + 16 | 0;
        } else i1 = i7;
       }
       HEAP32[i8 >> 2] = i9 + (HEAP32[i100 + (i10 << 3) + 4 >> 2] | 0);
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i94 | 0));
     }
     do if (i68) {
      if (!i31) {
       HEAP32[i1 >> 2] = i71;
       HEAP32[i1 + 4 >> 2] = i72;
       HEAP32[i1 + 8 >> 2] = i70;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
       i1 = i1 + 16 | 0;
      }
      if (!(HEAP8[i32 >> 0] | 0)) {
       if (i33) {
        i91 = (HEAP32[i34 >> 2] | 0) + (i99 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i33) {
       i90 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i34 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      }
      do if (!(HEAP8[i35 >> 0] | 0)) {
       if (!i36) break;
       i91 = (HEAP32[i37 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i36) break;
       i90 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       i91 = HEAP32[(HEAP32[i37 >> 2] | 0) + (i99 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i28 >> 2] | 0) + (i99 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i90;
       HEAP32[i1 + 8 >> 2] = i91;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i38) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i39) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i26 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + (i99 << 2) >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i40) {
       HEAP32[i1 >> 2] = i49;
       HEAP32[i1 + 4 >> 2] = i52;
       HEAP32[i1 + 8 >> 2] = i54;
       HEAP32[i1 + 12 >> 2] = i67;
       i1 = i1 + 16 | 0;
      }
      if (!i41) {
       HEAP32[i1 >> 2] = i48;
       HEAP32[i1 + 4 >> 2] = i50;
       HEAP32[i1 + 8 >> 2] = i53;
       HEAP32[i1 + 12 >> 2] = i57;
       i1 = i1 + 16 | 0;
      }
      if (i25) break;
      HEAP32[i1 >> 2] = i47;
      HEAP32[i1 + 4 >> 2] = i46;
      HEAP32[i1 + 8 >> 2] = i45;
      HEAP32[i1 + 12 >> 2] = i44;
      i1 = i1 + 16 | 0;
     } while (0);
     i22 = i22 + 1 | 0;
    } while ((i22 | 0) != (i42 | 0));
   }
   HEAP32[i101 >> 2] = i1;
   STACKTOP = i102;
   return;
  }
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i32 + 8 | 0;
  i11 = HEAP32[i32 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i7 = 1;
   i5 = 1;
   i3 = 1;
  } else {
   if (!(HEAP8[i32 + 11 >> 0] | 0)) {
    i2 = 0;
    i5 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 15 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i1 = HEAP16[i32 + 12 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 39 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i32 + 36 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i100 >> 2] = 0;
  HEAP32[i100 + 4 >> 2] = 1;
  HEAP32[i100 + 8 >> 2] = 0;
  HEAP32[i100 + 12 >> 2] = 1;
  HEAP32[i100 + 16 >> 2] = 0;
  HEAP32[i100 + 20 >> 2] = 1;
  HEAP32[i100 + 24 >> 2] = 0;
  HEAP32[i100 + 28 >> 2] = 1;
  i80 = (i1 | 0) == 0;
  i47 = i80 ? i4 : i1;
  i80 = i80 ? 0 : i3;
  i79 = (i8 | 0) == 0;
  i43 = i79 ? i6 : i8;
  i79 = i79 ? 0 : i7;
  i74 = i25 << 16 >> 16 == 0;
  L433 : do if (!i74) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i100 + (i1 << 3) >> 2] = i6;
     HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i94 | 0)) break L433;
    }
   } else i4 = 0;
   do {
    i3 = i100 + (i4 << 3) | 0;
    i1 = i4 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i3 >> 2] = 0;
     i1 = i100 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 137;
    } else {
     i87 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i88 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i88 = i11 + (((i88 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i88 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i3 >> 2] = i88;
     i1 = i100 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i87;
     if (!i88) i26 = 137;
    }
    if ((i26 | 0) == 137) {
     i26 = 0;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i94 | 0));
  } while (0);
  f62 = Math_fround(HEAPF32[i27 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i72 = HEAP32[i27 + 48 >> 2] | 0;
  i73 = HEAP32[i27 + 52 >> 2] | 0;
  i71 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i21 = HEAP32[i28 + 32 >> 2] | 0;
  f61 = Math_fround(HEAPF32[i29 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i101 >> 2] | 0;
  i70 = i89 >>> 0 > 63;
  if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
   i52 = 0;
   i54 = 0;
   i67 = 0;
   i69 = 0;
  } else {
   i69 = HEAP32[i90 + 828 >> 2] | 0;
   i52 = HEAP32[i69 + (i99 << 4) >> 2] | 0;
   i54 = HEAP32[i69 + (i99 << 4) + 4 >> 2] | 0;
   i67 = HEAP32[i69 + (i99 << 4) + 8 >> 2] | 0;
   i69 = HEAP32[i69 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
   i50 = 0;
   i53 = 0;
   i57 = 0;
   i68 = 0;
  } else {
   i68 = HEAP32[i90 + 848 >> 2] | 0;
   i50 = HEAP32[i68 + (i99 << 4) >> 2] | 0;
   i53 = HEAP32[i68 + (i99 << 4) + 4 >> 2] | 0;
   i57 = HEAP32[i68 + (i99 << 4) + 8 >> 2] | 0;
   i68 = HEAP32[i68 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (i70) {
   if (!(i89 & 512)) {
    i3 = 0;
    i4 = 0;
    i6 = 0;
   } else {
    f55 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
    f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
    f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(f55 + f58);
    f103 = Math_fround(f20 + f103);
    f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f20 * f58);
    f55 = Math_fround(f55 * f58);
    f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
    f104 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f105 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f104 * f106);
    f105 = Math_fround(f105 * f106);
    f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
    f51 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f20 + Math_fround(Math_fround(f51 * f103) + f104));
    f105 = Math_fround(f55 + Math_fround(Math_fround(f56 * f103) + f105));
    f106 = Math_fround(f58 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103) + f106));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i89 & 8192)) {
    i49 = 0;
    i48 = 0;
    i46 = 0;
    i45 = 0;
   } else {
    i85 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
    i87 = i85 + 1 | 0;
    i45 = i85 + 2 | 0;
    i48 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i85 | 0;
    i86 = (Math_imul(i85, 1790253981) | 0) + 1900727103 | 0;
    i88 = (Math_imul(i87, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i49 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i85 = i85 << 11 ^ i85;
    i87 = i87 << 11 ^ i87;
    i45 = i45 << 11 ^ i45;
    i48 = i48 << 11 ^ i48;
    f103 = Math_fround(Math_fround((i86 ^ i85 ^ i85 >>> 8) & 8388607 ^ i86 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f104 = Math_fround(Math_fround((i88 ^ i87 ^ i87 >>> 8) & 8388607 ^ i88 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f105 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f106 = Math_fround(Math_fround((i49 ^ i48 ^ i48 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i49 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    i48 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i46 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i45 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i49 = 0;
   i3 = 0;
   i48 = 0;
   i4 = 0;
   i46 = 0;
   i6 = 0;
   i45 = 0;
  }
  i44 = HEAP32[i32 + 100 >> 2] | 0;
  if (i44) {
   f55 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = (HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f58 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f51 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i32 = (i89 & 64 | 0) == 0;
   i33 = i90 + 871 | 0;
   i34 = (i89 & 128 | 0) != 0;
   i35 = i90 + 420 | 0;
   i36 = i90 + 870 | 0;
   i37 = (i89 & 256 | 0) != 0;
   i38 = i90 + 340 | 0;
   i39 = (i89 & 512 | 0) == 0;
   i40 = (i89 & 1024 | 0) == 0;
   i41 = (i89 & 2048 | 0) == 0;
   i42 = (i89 & 4096 | 0) == 0;
   i26 = (i89 & 8192 | 0) == 0;
   i27 = i90 + 520 | 0;
   i28 = i90 + 540 | 0;
   i29 = i90 + 300 | 0;
   i30 = i90 + 320 | 0;
   i31 = i90 + 440 | 0;
   i25 = i90 + 460 | 0;
   i24 = i91 + (i99 << 2) | 0;
   i23 = 0;
   i22 = i43;
   i21 = i47;
   while (1) {
    f106 = Math_fround(HEAPF32[i2 >> 2]);
    f105 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f106 = Math_fround(f61 + f106);
    f105 = Math_fround(f60 + f105);
    f104 = Math_fround(f59 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f103 = Math_fround(Math_fround(Math_fround(f63 * f106) + Math_fround(f66 * f105)) + Math_fround(f56 + Math_fround(f77 * f104)));
    f12 = Math_fround(Math_fround(Math_fround(f64 * f106) + Math_fround(f75 * f105)) + Math_fround(f58 + Math_fround(f78 * f104)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f106) + Math_fround(f65 * f105)) + Math_fround(f55 + Math_fround(f76 * f104)));
    HEAPF32[i1 + 4 >> 2] = f103;
    HEAPF32[i1 + 8 >> 2] = f12;
    i2 = i2 + i5 | 0;
    i91 = i21;
    f12 = Math_fround(HEAPF32[i91 >> 2]);
    f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
    f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
    f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
    f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
    HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
    HEAPF32[i1 + 16 >> 2] = f105;
    HEAPF32[i1 + 20 >> 2] = f106;
    i21 = i21 + i80 | 0;
    i1 = i1 + 24 | 0;
    if (!i74) {
     i11 = 0;
     do {
      i9 = i100 + (i11 << 3) | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      if (!(1 << i11 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
       HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
       i7 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
       if ((i11 | 0) == 1) {
        HEAPF32[i7 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i7;
      } else {
       f12 = Math_fround(f95 * Math_fround(HEAPF32[i24 >> 2]));
       i7 = ~~f12 >>> 0;
       i8 = (i7 | 0) / (i97 | 0) | 0;
       f105 = Math_fround(f98 * Math_fround(i7 - (Math_imul(i8, i97) | 0) | 0));
       f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i8 | 0)));
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i10 >> 2])) + f105);
       i8 = i1 + 8 | 0;
       HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i10 + 4 >> 2])));
       if ((i11 | 0) == 1) {
        HEAPF32[i8 >> 2] = Math_fround(f12 - Math_fround(i7 | 0));
        HEAPF32[i1 + 12 >> 2] = f12;
        i1 = i1 + 16 | 0;
       } else i1 = i8;
      }
      HEAP32[i9 >> 2] = i10 + (HEAP32[i100 + (i11 << 3) + 4 >> 2] | 0);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i94 | 0));
    }
    do if (i70) {
     if (!i32) {
      HEAP32[i1 >> 2] = i72;
      HEAP32[i1 + 4 >> 2] = i73;
      HEAP32[i1 + 8 >> 2] = i71;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i23 | 0);
      i1 = i1 + 16 | 0;
     }
     if (!(HEAP8[i33 >> 0] | 0)) {
      if (i34) {
       i91 = (HEAP32[i35 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i34) {
      i90 = HEAP32[(HEAP32[i31 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i35 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!(HEAP8[i36 >> 0] | 0)) {
      if (i37) {
       i91 = (HEAP32[i38 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i37) {
      i90 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i38 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i29 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!i39) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i1 + 4 >> 2] = i4;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i40) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i27 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i28 >> 2] | 0) + (i99 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i41) {
      HEAP32[i1 >> 2] = i52;
      HEAP32[i1 + 4 >> 2] = i54;
      HEAP32[i1 + 8 >> 2] = i67;
      HEAP32[i1 + 12 >> 2] = i69;
      i1 = i1 + 16 | 0;
     }
     if (!i42) {
      HEAP32[i1 >> 2] = i50;
      HEAP32[i1 + 4 >> 2] = i53;
      HEAP32[i1 + 8 >> 2] = i57;
      HEAP32[i1 + 12 >> 2] = i68;
      i1 = i1 + 16 | 0;
     }
     if (i26) break;
     HEAP32[i1 >> 2] = i49;
     HEAP32[i1 + 4 >> 2] = i48;
     HEAP32[i1 + 8 >> 2] = i46;
     HEAP32[i1 + 12 >> 2] = i45;
     i1 = i1 + 16 | 0;
    } while (0);
    i91 = i22;
    f12 = Math_fround(HEAPF32[i91 >> 2]);
    f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
    f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
    f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
    f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
    HEAPF32[i1 + 4 >> 2] = f105;
    HEAPF32[i1 + 8 >> 2] = f106;
    HEAP32[i1 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
    i1 = i1 + 16 | 0;
    i23 = i23 + 1 | 0;
    if ((i23 | 0) == (i44 | 0)) break; else i22 = i22 + i79 | 0;
   }
  }
  HEAP32[i101 >> 2] = i1;
  STACKTOP = i102;
  return;
 }
 if (i2) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i6 >> 2] = -1;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i32 + 8 | 0;
  i11 = HEAP32[i32 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 1;
   i7 = 1;
   i5 = 1;
  } else {
   if (!(HEAP8[i32 + 11 >> 0] | 0)) {
    i2 = 0;
    i3 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 15 >> 0] | 0)) {
    i1 = 0;
    i5 = 1;
   } else {
    i1 = HEAP16[i32 + 12 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i32 + 19 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i32 + 16 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i32 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i100 >> 2] = 0;
  HEAP32[i100 + 4 >> 2] = 1;
  HEAP32[i100 + 8 >> 2] = 0;
  HEAP32[i100 + 12 >> 2] = 1;
  HEAP32[i100 + 16 >> 2] = 0;
  HEAP32[i100 + 20 >> 2] = 1;
  HEAP32[i100 + 24 >> 2] = 0;
  HEAP32[i100 + 28 >> 2] = 1;
  i84 = (i1 | 0) == 0;
  i53 = i84 ? i4 : i1;
  i84 = i84 ? 0 : i5;
  i83 = (i8 | 0) == 0;
  i47 = i83 ? i6 : i8;
  i83 = i83 ? 0 : i7;
  i82 = i25 << 16 >> 16 == 0;
  L520 : do if (!i82) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i100 + (i1 << 3) >> 2] = i6;
     HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i94 | 0)) break L520;
    }
   } else i5 = 0;
   do {
    i4 = i100 + (i5 << 3) | 0;
    i1 = i5 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i4 >> 2] = 0;
     i1 = i100 + (i5 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 78;
    } else {
     i86 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i87 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i87 = i11 + (((i87 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i87 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i4 >> 2] = i87;
     i1 = i100 + (i5 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i86;
     if (!i87) i26 = 78;
    }
    if ((i26 | 0) == 78) {
     i26 = 0;
     HEAP32[i4 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i94 | 0));
  } while (0);
  f62 = Math_fround(HEAPF32[i27 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i80 = HEAP32[i27 + 48 >> 2] | 0;
  i81 = HEAP32[i27 + 52 >> 2] | 0;
  i79 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i21 = HEAP32[i28 + 32 >> 2] | 0;
  f61 = Math_fround(HEAPF32[i29 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i101 >> 2] | 0;
  i74 = i89 >>> 0 > 63;
  if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
   i67 = 0;
   i69 = 0;
   i71 = 0;
   i73 = 0;
  } else {
   i73 = HEAP32[i90 + 828 >> 2] | 0;
   i67 = HEAP32[i73 + (i99 << 4) >> 2] | 0;
   i69 = HEAP32[i73 + (i99 << 4) + 4 >> 2] | 0;
   i71 = HEAP32[i73 + (i99 << 4) + 8 >> 2] | 0;
   i73 = HEAP32[i73 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
   i57 = 0;
   i68 = 0;
   i70 = 0;
   i72 = 0;
  } else {
   i72 = HEAP32[i90 + 848 >> 2] | 0;
   i57 = HEAP32[i72 + (i99 << 4) >> 2] | 0;
   i68 = HEAP32[i72 + (i99 << 4) + 4 >> 2] | 0;
   i70 = HEAP32[i72 + (i99 << 4) + 8 >> 2] | 0;
   i72 = HEAP32[i72 + (i99 << 4) + 12 >> 2] | 0;
  }
  if (i74) {
   if (!(i89 & 512)) {
    i4 = 0;
    i5 = 0;
    i6 = 0;
   } else {
    f55 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
    f20 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
    f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
    f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
    f58 = Math_fround(f55 + f58);
    f103 = Math_fround(f20 + f103);
    f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f20 * f58);
    f55 = Math_fround(f55 * f58);
    f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
    f104 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f105 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f104 * f106);
    f105 = Math_fround(f105 * f106);
    f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
    f51 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f104 = Math_fround(f20 + Math_fround(Math_fround(f51 * f103) + f104));
    f105 = Math_fround(f55 + Math_fround(Math_fround(f56 * f103) + f105));
    f106 = Math_fround(f58 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103) + f106));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i89 & 8192)) {
    i54 = 0;
    i52 = 0;
    i50 = 0;
    i49 = 0;
   } else {
    i48 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
    i86 = i48 + 1 | 0;
    i49 = i48 + 2 | 0;
    i52 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i48 | 0;
    i85 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i87 = (Math_imul(i86, 1790253981) | 0) + 1900727103 | 0;
    i50 = (Math_imul(i49, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i48 = i48 << 11 ^ i48;
    i86 = i86 << 11 ^ i86;
    i49 = i49 << 11 ^ i49;
    i52 = i52 << 11 ^ i52;
    f103 = Math_fround(Math_fround((i85 ^ i48 ^ i48 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f104 = Math_fround(Math_fround((i87 ^ i86 ^ i86 >>> 8) & 8388607 ^ i87 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f105 = Math_fround(Math_fround((i50 ^ i49 ^ i49 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f106 = Math_fround(Math_fround((i54 ^ i52 ^ i52 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i54 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    i52 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i50 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i49 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i54 = 0;
   i4 = 0;
   i52 = 0;
   i5 = 0;
   i50 = 0;
   i6 = 0;
   i49 = 0;
  }
  i48 = i32 + 100 | 0;
  if (HEAP32[i48 >> 2] | 0) {
   f55 = (HEAP32[tempDoublePtr >> 2] = i80, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = (HEAP32[tempDoublePtr >> 2] = i81, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f58 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f51 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i36 = (i89 & 64 | 0) == 0;
   i37 = i90 + 871 | 0;
   i38 = (i89 & 128 | 0) != 0;
   i39 = i90 + 420 | 0;
   i40 = i90 + 870 | 0;
   i41 = (i89 & 256 | 0) != 0;
   i42 = i90 + 340 | 0;
   i43 = (i89 & 512 | 0) == 0;
   i44 = (i89 & 1024 | 0) == 0;
   i45 = (i89 & 2048 | 0) == 0;
   i46 = (i89 & 4096 | 0) == 0;
   i30 = (i89 & 8192 | 0) == 0;
   i31 = i90 + 520 | 0;
   i32 = i90 + 540 | 0;
   i33 = i90 + 300 | 0;
   i34 = i90 + 320 | 0;
   i35 = i90 + 440 | 0;
   i29 = i90 + 460 | 0;
   i26 = i91 + (i99 << 2) | 0;
   i27 = i88 & 255;
   i25 = i88 >>> 8;
   i28 = i25 & 255;
   i24 = i88 & 16711680;
   i25 = i25 & 16711680;
   i23 = 0;
   i22 = i47;
   i21 = i53;
   do {
    f106 = Math_fround(HEAPF32[i2 >> 2]);
    f105 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f106 = Math_fround(f61 + f106);
    f105 = Math_fround(f60 + f105);
    f104 = Math_fround(f59 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f103 = Math_fround(Math_fround(Math_fround(f63 * f106) + Math_fround(f66 * f105)) + Math_fround(f56 + Math_fround(f77 * f104)));
    f12 = Math_fround(Math_fround(Math_fround(f64 * f106) + Math_fround(f75 * f105)) + Math_fround(f58 + Math_fround(f78 * f104)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f106) + Math_fround(f65 * f105)) + Math_fround(f55 + Math_fround(f76 * f104)));
    HEAPF32[i1 + 4 >> 2] = f103;
    HEAPF32[i1 + 8 >> 2] = f12;
    i2 = i2 + i3 | 0;
    i91 = i21;
    f12 = Math_fround(HEAPF32[i91 >> 2]);
    f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
    f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
    f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
    f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
    HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
    HEAPF32[i1 + 16 >> 2] = f105;
    HEAPF32[i1 + 20 >> 2] = f106;
    i21 = i21 + i84 | 0;
    i91 = HEAP32[i22 >> 2] | 0;
    HEAP32[i1 + 24 >> 2] = (Math_imul((i91 >>> 8 & 255) + 1 | 0, i28) | 0) & 65280 | (Math_imul((i91 >>> 24) + 1 | 0, i25) | 0) & -16777216 | (Math_imul((i91 & 255) + 1 | 0, i27) | 0) >>> 8 & 255 | (Math_imul((i91 >>> 16 & 255) + 1 | 0, i24) | 0) >>> 8 & 16711680;
    i22 = i22 + i83 | 0;
    i1 = i1 + 28 | 0;
    if (!i82) {
     i11 = 0;
     do {
      i9 = i100 + (i11 << 3) | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      if (!(1 << i11 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
       HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
       i7 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
       if ((i11 | 0) == 1) {
        HEAPF32[i7 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i7;
      } else {
       f12 = Math_fround(f95 * Math_fround(HEAPF32[i26 >> 2]));
       i8 = ~~f12 >>> 0;
       i7 = (i8 | 0) / (i97 | 0) | 0;
       f105 = Math_fround(f98 * Math_fround(i8 - (Math_imul(i7, i97) | 0) | 0));
       f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i7 | 0)));
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i10 >> 2])) + f105);
       i7 = i1 + 8 | 0;
       HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i10 + 4 >> 2])));
       if ((i11 | 0) == 1) {
        HEAPF32[i7 >> 2] = Math_fround(f12 - Math_fround(i8 | 0));
        HEAPF32[i1 + 12 >> 2] = f12;
        i1 = i1 + 16 | 0;
       } else i1 = i7;
      }
      HEAP32[i9 >> 2] = i10 + (HEAP32[i100 + (i11 << 3) + 4 >> 2] | 0);
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) != (i94 | 0));
    }
    do if (i74) {
     if (!i36) {
      HEAP32[i1 >> 2] = i80;
      HEAP32[i1 + 4 >> 2] = i81;
      HEAP32[i1 + 8 >> 2] = i79;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i23 | 0);
      i1 = i1 + 16 | 0;
     }
     if (!(HEAP8[i37 >> 0] | 0)) {
      if (i38) {
       i91 = (HEAP32[i39 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i38) {
      i90 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i39 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!(HEAP8[i40 >> 0] | 0)) {
      if (i41) {
       i91 = (HEAP32[i42 >> 2] | 0) + (i99 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i41) {
      i90 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      i91 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i99 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i99 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i90;
      HEAP32[i1 + 8 >> 2] = i91;
      i1 = i1 + 12 | 0;
     }
     if (!i43) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i1 + 4 >> 2] = i5;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i44) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i32 >> 2] | 0) + (i99 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i45) {
      HEAP32[i1 >> 2] = i67;
      HEAP32[i1 + 4 >> 2] = i69;
      HEAP32[i1 + 8 >> 2] = i71;
      HEAP32[i1 + 12 >> 2] = i73;
      i1 = i1 + 16 | 0;
     }
     if (!i46) {
      HEAP32[i1 >> 2] = i57;
      HEAP32[i1 + 4 >> 2] = i68;
      HEAP32[i1 + 8 >> 2] = i70;
      HEAP32[i1 + 12 >> 2] = i72;
      i1 = i1 + 16 | 0;
     }
     if (i30) break;
     HEAP32[i1 >> 2] = i54;
     HEAP32[i1 + 4 >> 2] = i52;
     HEAP32[i1 + 8 >> 2] = i50;
     HEAP32[i1 + 12 >> 2] = i49;
     i1 = i1 + 16 | 0;
    } while (0);
    i23 = i23 + 1 | 0;
   } while (i23 >>> 0 < (HEAP32[i48 >> 2] | 0) >>> 0);
  }
  HEAP32[i101 >> 2] = i1;
  STACKTOP = i102;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i24 >> 2] = -1;
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 HEAPF32[i21 + 4 >> 2] = Math_fround(0.0);
 i22 = i32 + 8 | 0;
 i23 = HEAP32[i32 + 92 >> 2] | 0;
 i11 = (i23 | 0) == 0;
 if (i11) {
  i10 = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
  i7 = 1;
  i8 = 1;
  i9 = 1;
  i5 = 1;
 } else {
  if (!(HEAP8[i32 + 11 >> 0] | 0)) {
   i3 = 0;
   i8 = 1;
  } else {
   i3 = HEAP16[i22 >> 1] | 0;
   i3 = i23 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i8 = HEAPU8[i22 + 32 + ((HEAPU8[i22 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i32 + 15 >> 0] | 0)) {
   i2 = 0;
   i5 = 1;
  } else {
   i2 = HEAP16[i32 + 12 >> 1] | 0;
   i2 = i23 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i22 + 32 + ((HEAPU8[i32 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i32 + 39 >> 0] | 0)) {
   i1 = 0;
   i7 = 1;
  } else {
   i1 = HEAP16[i32 + 36 >> 1] | 0;
   i1 = i23 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i7 = HEAPU8[i22 + 32 + ((HEAPU8[i32 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i32 + 19 >> 0] | 0)) {
   i10 = 0;
   i9 = 1;
  } else {
   i10 = HEAP16[i32 + 16 >> 1] | 0;
   i10 = i23 + (((i10 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i9 = HEAPU8[i22 + 32 + ((HEAPU8[i32 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 HEAP32[i100 >> 2] = 0;
 HEAP32[i100 + 4 >> 2] = 1;
 HEAP32[i100 + 8 >> 2] = 0;
 HEAP32[i100 + 12 >> 2] = 1;
 HEAP32[i100 + 16 >> 2] = 0;
 HEAP32[i100 + 20 >> 2] = 1;
 HEAP32[i100 + 24 >> 2] = 0;
 HEAP32[i100 + 28 >> 2] = 1;
 i87 = (i2 | 0) == 0;
 i80 = i87 ? i4 : i2;
 i87 = i87 ? 0 : i5;
 i86 = (i1 | 0) == 0;
 i52 = i86 ? i6 : i1;
 i86 = i86 ? 0 : i7;
 i85 = (i10 | 0) == 0;
 i48 = i85 ? i24 : i10;
 i85 = i85 ? 0 : i9;
 i84 = i25 << 16 >> 16 == 0;
 L608 : do if (!i84) {
  i5 = i21;
  if (i11) {
   i1 = 0;
   while (1) {
    HEAP32[i100 + (i1 << 3) >> 2] = i5;
    HEAP32[i100 + (i1 << 3) + 4 >> 2] = 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i94 | 0)) break L608;
   }
  } else i4 = 0;
  do {
   i2 = i100 + (i4 << 3) | 0;
   i1 = i4 + 3 | 0;
   if (!(HEAP8[i22 + (i1 << 2) + 3 >> 0] | 0)) {
    HEAP32[i2 >> 2] = 0;
    i1 = i100 + (i4 << 3) + 4 | 0;
    HEAP32[i1 >> 2] = 1;
    i26 = 20;
   } else {
    i82 = HEAPU8[i22 + 32 + ((HEAPU8[i22 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i83 = HEAP16[i22 + (i1 << 2) >> 1] | 0;
    i83 = i23 + (((i83 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i83 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    HEAP32[i2 >> 2] = i83;
    i1 = i100 + (i4 << 3) + 4 | 0;
    HEAP32[i1 >> 2] = i82;
    if (!i83) i26 = 20;
   }
   if ((i26 | 0) == 20) {
    i26 = 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i1 >> 2] = 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i94 | 0));
 } while (0);
 f62 = Math_fround(HEAPF32[i27 >> 2]);
 f63 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f64 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f65 = Math_fround(HEAPF32[i27 + 16 >> 2]);
 f66 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f75 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f76 = Math_fround(HEAPF32[i27 + 32 >> 2]);
 f77 = Math_fround(HEAPF32[i27 + 36 >> 2]);
 f78 = Math_fround(HEAPF32[i27 + 40 >> 2]);
 i82 = HEAP32[i27 + 48 >> 2] | 0;
 i83 = HEAP32[i27 + 52 >> 2] | 0;
 i81 = HEAP32[i27 + 56 >> 2] | 0;
 i6 = HEAP32[i28 >> 2] | 0;
 i7 = HEAP32[i28 + 4 >> 2] | 0;
 i9 = HEAP32[i28 + 8 >> 2] | 0;
 i22 = HEAP32[i28 + 12 >> 2] | 0;
 i23 = HEAP32[i28 + 16 >> 2] | 0;
 i24 = HEAP32[i28 + 20 >> 2] | 0;
 i10 = HEAP32[i28 + 24 >> 2] | 0;
 i11 = HEAP32[i28 + 28 >> 2] | 0;
 i21 = HEAP32[i28 + 32 >> 2] | 0;
 f61 = Math_fround(HEAPF32[i29 >> 2]);
 f60 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f59 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 i1 = HEAP32[i101 >> 2] | 0;
 i79 = i89 >>> 0 > 63;
 if (!(HEAP32[i90 + 844 >> 2] & 2147483647)) {
  i68 = 0;
  i70 = 0;
  i72 = 0;
  i74 = 0;
 } else {
  i74 = HEAP32[i90 + 828 >> 2] | 0;
  i68 = HEAP32[i74 + (i99 << 4) >> 2] | 0;
  i70 = HEAP32[i74 + (i99 << 4) + 4 >> 2] | 0;
  i72 = HEAP32[i74 + (i99 << 4) + 8 >> 2] | 0;
  i74 = HEAP32[i74 + (i99 << 4) + 12 >> 2] | 0;
 }
 if (!(HEAP32[i90 + 864 >> 2] & 2147483647)) {
  i67 = 0;
  i69 = 0;
  i71 = 0;
  i73 = 0;
 } else {
  i73 = HEAP32[i90 + 848 >> 2] | 0;
  i67 = HEAP32[i73 + (i99 << 4) >> 2] | 0;
  i69 = HEAP32[i73 + (i99 << 4) + 4 >> 2] | 0;
  i71 = HEAP32[i73 + (i99 << 4) + 8 >> 2] | 0;
  i73 = HEAP32[i73 + (i99 << 4) + 12 >> 2] | 0;
 }
 if (i79) {
  if (!(i89 & 512)) {
   i2 = 0;
   i4 = 0;
   i5 = 0;
  } else {
   f55 = Math_fround(HEAPF32[(HEAP32[i90 + 60 >> 2] | 0) + (i99 << 2) >> 2]);
   f20 = Math_fround(HEAPF32[(HEAP32[i90 + 80 >> 2] | 0) + (i99 << 2) >> 2]);
   f106 = Math_fround(HEAPF32[(HEAP32[i90 + 100 >> 2] | 0) + (i99 << 2) >> 2]);
   f58 = Math_fround(HEAPF32[(HEAP32[i90 + 120 >> 2] | 0) + (i99 << 2) >> 2]);
   f103 = Math_fround(HEAPF32[(HEAP32[i90 + 140 >> 2] | 0) + (i99 << 2) >> 2]);
   f58 = Math_fround(f55 + f58);
   f103 = Math_fround(f20 + f103);
   f106 = Math_fround(f106 + Math_fround(HEAPF32[(HEAP32[i90 + 160 >> 2] | 0) + (i99 << 2) >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f55 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f20 * f58);
   f55 = Math_fround(f55 * f58);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
   f104 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f105 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f104 = Math_fround(f104 * f106);
   f105 = Math_fround(f105 * f106);
   f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
   f51 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f104 = Math_fround(f20 + Math_fround(Math_fround(f51 * f103) + f104));
   f105 = Math_fround(f55 + Math_fround(Math_fround(f56 * f103) + f105));
   f106 = Math_fround(f58 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f103) + f106));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
  }
  if (!(i89 & 8192)) {
   i57 = 0;
   i54 = 0;
   i53 = 0;
   i50 = 0;
  } else {
   i45 = HEAP32[(HEAP32[i90 + 500 >> 2] | 0) + (i99 << 2) >> 2] | 0;
   i47 = i45 + 1 | 0;
   i50 = i45 + 2 | 0;
   i54 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i90 + 520 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(1.0e5)) + i45 | 0;
   i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
   i49 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
   i53 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
   i57 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
   i45 = i45 << 11 ^ i45;
   i47 = i47 << 11 ^ i47;
   i50 = i50 << 11 ^ i50;
   i54 = i54 << 11 ^ i54;
   f103 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f104 = Math_fround(Math_fround((i49 ^ i47 ^ i47 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f105 = Math_fround(Math_fround((i53 ^ i50 ^ i50 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f106 = Math_fround(Math_fround((i57 ^ i54 ^ i54 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07));
   i57 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
   i54 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i53 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
   i50 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
  }
 } else {
  i57 = 0;
  i2 = 0;
  i54 = 0;
  i4 = 0;
  i53 = 0;
  i5 = 0;
  i50 = 0;
 }
 i49 = i32 + 100 | 0;
 if (HEAP32[i49 >> 2] | 0) {
  f55 = (HEAP32[tempDoublePtr >> 2] = i82, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = (HEAP32[tempDoublePtr >> 2] = i83, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = (HEAP32[tempDoublePtr >> 2] = i81, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f51 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i37 = (i89 & 64 | 0) == 0;
  i38 = i90 + 871 | 0;
  i39 = (i89 & 128 | 0) != 0;
  i40 = i90 + 420 | 0;
  i41 = i90 + 870 | 0;
  i42 = (i89 & 256 | 0) != 0;
  i43 = i90 + 340 | 0;
  i44 = (i89 & 512 | 0) == 0;
  i45 = (i89 & 1024 | 0) == 0;
  i46 = (i89 & 2048 | 0) == 0;
  i47 = (i89 & 4096 | 0) == 0;
  i31 = (i89 & 8192 | 0) == 0;
  i32 = i90 + 520 | 0;
  i33 = i90 + 540 | 0;
  i34 = i90 + 300 | 0;
  i35 = i90 + 320 | 0;
  i36 = i90 + 440 | 0;
  i30 = i90 + 460 | 0;
  i27 = i91 + (i99 << 2) | 0;
  i28 = i88 & 255;
  i26 = i88 >>> 8;
  i29 = i26 & 255;
  i25 = i88 & 16711680;
  i26 = i26 & 16711680;
  i24 = 0;
  i23 = i48;
  i22 = i52;
  i21 = i80;
  while (1) {
   f106 = Math_fround(HEAPF32[i3 >> 2]);
   f105 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f106 = Math_fround(f61 + f106);
   f105 = Math_fround(f60 + f105);
   f104 = Math_fround(f59 + Math_fround(HEAPF32[i3 + 8 >> 2]));
   f103 = Math_fround(Math_fround(Math_fround(f63 * f106) + Math_fround(f66 * f105)) + Math_fround(f56 + Math_fround(f77 * f104)));
   f12 = Math_fround(Math_fround(Math_fround(f64 * f106) + Math_fround(f75 * f105)) + Math_fround(f58 + Math_fround(f78 * f104)));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f62 * f106) + Math_fround(f65 * f105)) + Math_fround(f55 + Math_fround(f76 * f104)));
   HEAPF32[i1 + 4 >> 2] = f103;
   HEAPF32[i1 + 8 >> 2] = f12;
   i3 = i3 + i8 | 0;
   i91 = i21;
   f12 = Math_fround(HEAPF32[i91 >> 2]);
   f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
   f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
   f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
   f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
   HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
   HEAPF32[i1 + 16 >> 2] = f105;
   HEAPF32[i1 + 20 >> 2] = f106;
   i21 = i21 + i87 | 0;
   i91 = HEAP32[i23 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = (Math_imul((i91 >>> 8 & 255) + 1 | 0, i29) | 0) & 65280 | (Math_imul((i91 >>> 24) + 1 | 0, i26) | 0) & -16777216 | (Math_imul((i91 & 255) + 1 | 0, i28) | 0) >>> 8 & 255 | (Math_imul((i91 >>> 16 & 255) + 1 | 0, i25) | 0) >>> 8 & 16711680;
   i23 = i23 + i85 | 0;
   i1 = i1 + 28 | 0;
   if (!i84) {
    i11 = 0;
    do {
     i9 = i100 + (i11 << 3) | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     if (!(1 << i11 & 15 & (HEAP32[i96 >> 2] | 0) >>> 24)) {
      HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
      i6 = i1 + 8 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      if ((i11 | 0) == 1) {
       HEAPF32[i6 >> 2] = Math_fround(0.0);
       HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
       i1 = i1 + 16 | 0;
      } else i1 = i6;
     } else {
      f12 = Math_fround(f95 * Math_fround(HEAPF32[i27 >> 2]));
      i6 = ~~f12 >>> 0;
      i7 = (i6 | 0) / (i97 | 0) | 0;
      f105 = Math_fround(f98 * Math_fround(i6 - (Math_imul(i7, i97) | 0) | 0));
      f106 = Math_fround(f93 - Math_fround(f92 * Math_fround(i7 | 0)));
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(f98 * Math_fround(HEAPF32[i10 >> 2])) + f105);
      i7 = i1 + 8 | 0;
      HEAPF32[i1 + 4 >> 2] = Math_fround(f106 + Math_fround(f92 * Math_fround(HEAPF32[i10 + 4 >> 2])));
      if ((i11 | 0) == 1) {
       HEAPF32[i7 >> 2] = Math_fround(f12 - Math_fround(i6 | 0));
       HEAPF32[i1 + 12 >> 2] = f12;
       i1 = i1 + 16 | 0;
      } else i1 = i7;
     }
     HEAP32[i9 >> 2] = i10 + (HEAP32[i100 + (i11 << 3) + 4 >> 2] | 0);
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i94 | 0));
   }
   do if (i79) {
    if (!i37) {
     HEAP32[i1 >> 2] = i82;
     HEAP32[i1 + 4 >> 2] = i83;
     HEAP32[i1 + 8 >> 2] = i81;
     HEAPF32[i1 + 12 >> 2] = Math_fround(i24 | 0);
     i1 = i1 + 16 | 0;
    }
    if (!(HEAP8[i38 >> 0] | 0)) {
     if (i39) {
      i91 = (HEAP32[i40 >> 2] | 0) + (i99 << 2) | 0;
      HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
      i1 = i1 + 12 | 0;
     }
    } else if (i39) {
     i90 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     i91 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[(HEAP32[i40 >> 2] | 0) + (i99 << 2) >> 2];
     HEAP32[i1 + 4 >> 2] = i90;
     HEAP32[i1 + 8 >> 2] = i91;
     i1 = i1 + 12 | 0;
    }
    if (!(HEAP8[i41 >> 0] | 0)) {
     if (i42) {
      i91 = (HEAP32[i43 >> 2] | 0) + (i99 << 2) | 0;
      HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i91 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i91 >> 2];
      i1 = i1 + 12 | 0;
     }
    } else if (i42) {
     i90 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     i91 = HEAP32[(HEAP32[i43 >> 2] | 0) + (i99 << 2) >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[(HEAP32[i34 >> 2] | 0) + (i99 << 2) >> 2];
     HEAP32[i1 + 4 >> 2] = i90;
     HEAP32[i1 + 8 >> 2] = i91;
     i1 = i1 + 12 | 0;
    }
    if (!i44) {
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 4 >> 2] = i4;
     HEAP32[i1 + 8 >> 2] = i5;
     i1 = i1 + 12 | 0;
    }
    if (!i45) {
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + (i99 << 2) >> 2]) * Math_fround(.00999999977));
     HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i99 << 2) >> 2];
     i1 = i1 + 8 | 0;
    }
    if (!i46) {
     HEAP32[i1 >> 2] = i68;
     HEAP32[i1 + 4 >> 2] = i70;
     HEAP32[i1 + 8 >> 2] = i72;
     HEAP32[i1 + 12 >> 2] = i74;
     i1 = i1 + 16 | 0;
    }
    if (!i47) {
     HEAP32[i1 >> 2] = i67;
     HEAP32[i1 + 4 >> 2] = i69;
     HEAP32[i1 + 8 >> 2] = i71;
     HEAP32[i1 + 12 >> 2] = i73;
     i1 = i1 + 16 | 0;
    }
    if (i31) break;
    HEAP32[i1 >> 2] = i57;
    HEAP32[i1 + 4 >> 2] = i54;
    HEAP32[i1 + 8 >> 2] = i53;
    HEAP32[i1 + 12 >> 2] = i50;
    i1 = i1 + 16 | 0;
   } while (0);
   i91 = i22;
   f12 = Math_fround(HEAPF32[i91 >> 2]);
   f103 = Math_fround(HEAPF32[i91 + 4 >> 2]);
   f104 = Math_fround(HEAPF32[i91 + 8 >> 2]);
   f105 = Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f14 * f103) + Math_fround(f17 * f104)));
   f106 = Math_fround(Math_fround(f19 * f12) + Math_fround(Math_fround(f13 * f103) + Math_fround(f16 * f104)));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(f51 * f12) + Math_fround(Math_fround(f15 * f103) + Math_fround(f18 * f104)));
   HEAPF32[i1 + 4 >> 2] = f105;
   HEAPF32[i1 + 8 >> 2] = f106;
   HEAP32[i1 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   i1 = i1 + 16 | 0;
   i24 = i24 + 1 | 0;
   if (i24 >>> 0 >= (HEAP32[i49 >> 2] | 0) >>> 0) break; else i22 = i22 + i86 | 0;
  }
 }
 HEAP32[i101 >> 2] = i1;
 STACKTOP = i102;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i625, i630) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i625 = i625 | 0;
 i630 = i630 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, f564 = f0, f565 = f0, f566 = f0, f567 = f0, f568 = f0, f569 = f0, f570 = f0, f571 = f0, f572 = f0, f573 = f0, f574 = f0, f575 = f0, i576 = 0, i577 = 0, i578 = 0, i579 = 0, i580 = 0, i581 = 0, i582 = 0, i583 = 0, i584 = 0, i585 = 0, i586 = 0, i587 = 0, i588 = 0, i589 = 0, i590 = 0, f591 = f0, f592 = f0, f593 = f0, f594 = f0, f595 = f0, f596 = f0, f597 = f0, f598 = f0, f599 = f0, f600 = f0, i601 = 0, i602 = 0, i603 = 0, i604 = 0, i605 = 0, i606 = 0, i607 = 0, i608 = 0, i609 = 0, i610 = 0, i611 = 0, i612 = 0, i613 = 0, i614 = 0, i615 = 0, i616 = 0, i617 = 0, i618 = 0, f619 = f0, f620 = f0, f621 = f0, f622 = f0, f623 = f0, f624 = f0, f626 = f0, f627 = f0, f628 = f0, f629 = f0, f631 = f0, i632 = 0, i633 = 0, i634 = 0, i635 = 0, f636 = f0, f637 = f0, f638 = f0, f639 = f0, f640 = f0, f641 = f0, f642 = f0, f643 = f0, f644 = f0, f645 = f0, f646 = f0, f647 = f0, f648 = f0, f649 = f0, f650 = f0, f651 = f0, f652 = f0, f653 = f0, f654 = f0, f655 = f0, f656 = f0, f657 = f0, f658 = f0, f659 = f0, f660 = f0, f661 = f0, f662 = f0, f663 = f0, f664 = f0, f665 = f0, f666 = f0, f667 = f0, f668 = f0, f669 = f0, f670 = f0, f671 = f0, f672 = f0, f673 = f0, f674 = f0, f675 = f0, f676 = f0, f677 = f0, f678 = f0, f679 = f0, f680 = f0, f681 = f0, f682 = f0, f683 = f0, f684 = f0, i685 = 0;
 i635 = STACKTOP;
 STACKTOP = STACKTOP + 1680 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i632 = i635 + 1608 | 0;
 i633 = i635 + 1480 | 0;
 i634 = i635 + 1224 | 0;
 i6 = i635 + 1160 | 0;
 i4 = i635 + 1120 | 0;
 i601 = i635 + 976 | 0;
 i602 = i635 + 960 | 0;
 i603 = i635 + 912 | 0;
 i604 = i635 + 864 | 0;
 i605 = i635 + 816 | 0;
 i606 = i635 + 800 | 0;
 i607 = i635 + 784 | 0;
 i608 = i635 + 768 | 0;
 i609 = i635 + 752 | 0;
 i610 = i635 + 736 | 0;
 i611 = i635 + 544 | 0;
 i612 = i635 + 496 | 0;
 i613 = i635 + 304 | 0;
 i614 = i635 + 160 | 0;
 i615 = i635 + 112 | 0;
 i616 = i635 + 64 | 0;
 i617 = i635;
 i618 = i3 + 332 | 0;
 f619 = Math_fround((HEAP32[i618 >> 2] & 4095) >>> 0);
 f620 = Math_fround(Math_fround(1.0) / f619);
 f621 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f622 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f623 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f624 = Math_fround(Math_fround(1.0) - f623);
 i5 = i3 + 420 | 0;
 f626 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f599 = Math_fround(HEAPF32[i2 >> 2]);
 f593 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f595 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f627 = Math_fround(HEAPF32[i2 >> 2]);
 f628 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f629 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f631 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f598 = Math_fround(HEAPF32[i2 >> 2]);
 f592 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f597 = Math_fround(HEAPF32[i2 >> 2]);
 f591 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 36 | 0;
 f600 = Math_fround(HEAPF32[i7 >> 2]);
 f594 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f596 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f564 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f565 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f566 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f567 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f568 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f569 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f570 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f571 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f572 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f573 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f574 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f575 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 i576 = i632 + 12 | 0;
 i577 = i632 + 8 | 0;
 i578 = i632 + 4 | 0;
 i579 = i632 + 28 | 0;
 HEAP32[i632 >> 2] = 0;
 HEAP32[i632 + 4 >> 2] = 0;
 HEAP32[i632 + 8 >> 2] = 0;
 HEAP32[i632 + 12 >> 2] = 0;
 HEAP32[i579 >> 2] = 1;
 i580 = i632 + 24 | 0;
 HEAP32[i580 >> 2] = 1;
 i581 = i632 + 20 | 0;
 HEAP32[i581 >> 2] = 1;
 i582 = i632 + 16 | 0;
 HEAP32[i582 >> 2] = 1;
 i583 = i632 + 44 | 0;
 HEAP32[i583 >> 2] = 2;
 i584 = i632 + 40 | 0;
 HEAP32[i584 >> 2] = 2;
 i585 = i632 + 36 | 0;
 HEAP32[i585 >> 2] = 2;
 i586 = i632 + 32 | 0;
 HEAP32[i586 >> 2] = 2;
 i587 = i632 + 60 | 0;
 HEAP32[i587 >> 2] = 3;
 i588 = i632 + 56 | 0;
 HEAP32[i588 >> 2] = 3;
 i589 = i632 + 52 | 0;
 HEAP32[i589 >> 2] = 3;
 i590 = i632 + 48 | 0;
 HEAP32[i590 >> 2] = 3;
 i515 = i633 + 4 | 0;
 i539 = i633 + 8 | 0;
 i563 = i633 + 12 | 0;
 i491 = i633 + 16 | 0;
 HEAP32[i633 >> 2] = 0;
 HEAP32[i633 + 4 >> 2] = 0;
 HEAP32[i633 + 8 >> 2] = 0;
 HEAP32[i633 + 12 >> 2] = 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i514 = i633 + 20 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i633 + 24 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i633 + 28 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i490 = i633 + 32 | 0;
 HEAPF32[i490 >> 2] = Math_fround(1.0);
 i513 = i633 + 36 | 0;
 HEAPF32[i513 >> 2] = Math_fround(1.0);
 i537 = i633 + 40 | 0;
 HEAPF32[i537 >> 2] = Math_fround(1.0);
 i561 = i633 + 44 | 0;
 HEAPF32[i561 >> 2] = Math_fround(1.0);
 i489 = i633 + 48 | 0;
 HEAPF32[i489 >> 2] = Math_fround(1.0);
 i512 = i633 + 52 | 0;
 HEAPF32[i512 >> 2] = Math_fround(1.0);
 i536 = i633 + 56 | 0;
 HEAPF32[i536 >> 2] = Math_fround(1.0);
 i560 = i633 + 60 | 0;
 HEAPF32[i560 >> 2] = Math_fround(1.0);
 i488 = i633 + 64 | 0;
 HEAPF32[i488 >> 2] = Math_fround(1.0);
 i511 = i633 + 68 | 0;
 HEAPF32[i511 >> 2] = Math_fround(1.0);
 i535 = i633 + 72 | 0;
 HEAPF32[i535 >> 2] = Math_fround(1.0);
 i559 = i633 + 76 | 0;
 HEAPF32[i559 >> 2] = Math_fround(1.0);
 i487 = i633 + 80 | 0;
 i510 = i633 + 84 | 0;
 i534 = i633 + 88 | 0;
 i558 = i633 + 92 | 0;
 i486 = i633 + 96 | 0;
 i509 = i633 + 100 | 0;
 i533 = i633 + 104 | 0;
 i557 = i633 + 108 | 0;
 i485 = i633 + 112 | 0;
 i508 = i633 + 116 | 0;
 i532 = i633 + 120 | 0;
 i556 = i633 + 124 | 0;
 i10 = i487;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i507 = i634 + 4 | 0;
 i531 = i634 + 8 | 0;
 i555 = i634 + 12 | 0;
 i484 = i634 + 16 | 0;
 HEAP32[i634 >> 2] = 0;
 HEAP32[i634 + 4 >> 2] = 0;
 HEAP32[i634 + 8 >> 2] = 0;
 HEAP32[i634 + 12 >> 2] = 0;
 HEAPF32[i484 >> 2] = Math_fround(1.0);
 i506 = i634 + 20 | 0;
 HEAPF32[i506 >> 2] = Math_fround(1.0);
 i530 = i634 + 24 | 0;
 HEAPF32[i530 >> 2] = Math_fround(1.0);
 i554 = i634 + 28 | 0;
 HEAPF32[i554 >> 2] = Math_fround(1.0);
 i483 = i634 + 32 | 0;
 i505 = i634 + 36 | 0;
 i529 = i634 + 40 | 0;
 i553 = i634 + 44 | 0;
 i482 = i634 + 48 | 0;
 i504 = i634 + 52 | 0;
 i528 = i634 + 56 | 0;
 i552 = i634 + 60 | 0;
 i481 = i634 + 64 | 0;
 HEAP32[i483 >> 2] = 0;
 HEAP32[i483 + 4 >> 2] = 0;
 HEAP32[i483 + 8 >> 2] = 0;
 HEAP32[i483 + 12 >> 2] = 0;
 HEAP32[i483 + 16 >> 2] = 0;
 HEAP32[i483 + 20 >> 2] = 0;
 HEAP32[i483 + 24 >> 2] = 0;
 HEAP32[i483 + 28 >> 2] = 0;
 HEAPF32[i481 >> 2] = Math_fround(1.0);
 i503 = i634 + 68 | 0;
 HEAPF32[i503 >> 2] = Math_fround(1.0);
 i527 = i634 + 72 | 0;
 HEAPF32[i527 >> 2] = Math_fround(1.0);
 i551 = i634 + 76 | 0;
 HEAPF32[i551 >> 2] = Math_fround(1.0);
 i480 = i634 + 80 | 0;
 HEAPF32[i480 >> 2] = Math_fround(1.0);
 i502 = i634 + 84 | 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i526 = i634 + 88 | 0;
 HEAPF32[i526 >> 2] = Math_fround(1.0);
 i550 = i634 + 92 | 0;
 HEAPF32[i550 >> 2] = Math_fround(1.0);
 i479 = i634 + 96 | 0;
 i501 = i634 + 100 | 0;
 i525 = i634 + 104 | 0;
 i549 = i634 + 108 | 0;
 i478 = i634 + 112 | 0;
 i500 = i634 + 116 | 0;
 i524 = i634 + 120 | 0;
 i548 = i634 + 124 | 0;
 i477 = i634 + 128 | 0;
 HEAP32[i479 >> 2] = 0;
 HEAP32[i479 + 4 >> 2] = 0;
 HEAP32[i479 + 8 >> 2] = 0;
 HEAP32[i479 + 12 >> 2] = 0;
 HEAP32[i479 + 16 >> 2] = 0;
 HEAP32[i479 + 20 >> 2] = 0;
 HEAP32[i479 + 24 >> 2] = 0;
 HEAP32[i479 + 28 >> 2] = 0;
 HEAPF32[i477 >> 2] = Math_fround(1.0);
 i499 = i634 + 132 | 0;
 HEAPF32[i499 >> 2] = Math_fround(1.0);
 i523 = i634 + 136 | 0;
 HEAPF32[i523 >> 2] = Math_fround(1.0);
 i547 = i634 + 140 | 0;
 HEAPF32[i547 >> 2] = Math_fround(1.0);
 i476 = i634 + 144 | 0;
 i498 = i634 + 148 | 0;
 i522 = i634 + 152 | 0;
 i546 = i634 + 156 | 0;
 i475 = i634 + 160 | 0;
 i497 = i634 + 164 | 0;
 i521 = i634 + 168 | 0;
 i545 = i634 + 172 | 0;
 i474 = i634 + 176 | 0;
 i496 = i634 + 180 | 0;
 i520 = i634 + 184 | 0;
 i544 = i634 + 188 | 0;
 i473 = i634 + 192 | 0;
 i495 = i634 + 196 | 0;
 i519 = i634 + 200 | 0;
 i543 = i634 + 204 | 0;
 i472 = i634 + 208 | 0;
 i494 = i634 + 212 | 0;
 i518 = i634 + 216 | 0;
 i542 = i634 + 220 | 0;
 i471 = i634 + 224 | 0;
 i493 = i634 + 228 | 0;
 i517 = i634 + 232 | 0;
 i541 = i634 + 236 | 0;
 i470 = i634 + 240 | 0;
 i492 = i634 + 244 | 0;
 i516 = i634 + 248 | 0;
 i540 = i634 + 252 | 0;
 i10 = i476;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f62 = Math_fround(HEAPF32[i5 >> 2]);
 f45 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f53 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f47 = Math_fround(HEAPF32[i4 >> 2]);
 i184 = i4 + 4 | 0;
 f43 = Math_fround(HEAPF32[i184 >> 2]);
 i183 = i4 + 8 | 0;
 f58 = Math_fround(HEAPF32[i183 >> 2]);
 i182 = i4 + 12 | 0;
 f49 = Math_fround(HEAPF32[i182 >> 2]);
 i181 = i4 + 16 | 0;
 f44 = Math_fround(HEAPF32[i181 >> 2]);
 i180 = i4 + 20 | 0;
 f61 = Math_fround(HEAPF32[i180 >> 2]);
 i179 = i4 + 24 | 0;
 f51 = Math_fround(HEAPF32[i179 >> 2]);
 i203 = i4 + 28 | 0;
 f46 = Math_fround(HEAPF32[i203 >> 2]);
 i206 = i4 + 32 | 0;
 f55 = Math_fround(HEAPF32[i206 >> 2]);
 f48 = Math_fround(f43 * Math_fround(0.0));
 f57 = Math_fround(f58 * Math_fround(0.0));
 f56 = Math_fround(Math_fround(Math_fround(f62 * f47) + f48) + f57);
 f50 = Math_fround(f44 * Math_fround(0.0));
 f60 = Math_fround(f61 * Math_fround(0.0));
 f59 = Math_fround(Math_fround(Math_fround(f62 * f49) + f50) + f60);
 f52 = Math_fround(f46 * Math_fround(0.0));
 f54 = Math_fround(f55 * Math_fround(0.0));
 f62 = Math_fround(Math_fround(Math_fround(f62 * f51) + f52) + f54);
 f47 = Math_fround(f47 * Math_fround(0.0));
 f57 = Math_fround(Math_fround(f47 + Math_fround(f45 * f43)) + f57);
 f49 = Math_fround(f49 * Math_fround(0.0));
 f60 = Math_fround(Math_fround(f49 + Math_fround(f45 * f44)) + f60);
 f51 = Math_fround(f51 * Math_fround(0.0));
 f54 = Math_fround(Math_fround(f51 + Math_fround(f45 * f46)) + f54);
 f58 = Math_fround(Math_fround(f47 + f48) + Math_fround(f53 * f58));
 f61 = Math_fround(Math_fround(f49 + f50) + Math_fround(f53 * f61));
 f55 = Math_fround(Math_fround(f51 + f52) + Math_fround(f53 * f55));
 HEAPF32[i4 >> 2] = f56;
 HEAPF32[i184 >> 2] = f57;
 HEAPF32[i183 >> 2] = f58;
 HEAPF32[i182 >> 2] = f59;
 HEAPF32[i181 >> 2] = f60;
 HEAPF32[i180 >> 2] = f61;
 HEAPF32[i179 >> 2] = f62;
 HEAPF32[i203 >> 2] = f54;
 HEAPF32[i206 >> 2] = f55;
 HEAPF32[i601 >> 2] = f56;
 i179 = i601 + 4 | 0;
 HEAPF32[i179 >> 2] = f56;
 i180 = i601 + 8 | 0;
 HEAPF32[i180 >> 2] = f56;
 i181 = i601 + 12 | 0;
 HEAPF32[i181 >> 2] = f56;
 HEAPF32[i601 + 16 >> 2] = f57;
 i182 = i601 + 20 | 0;
 HEAPF32[i182 >> 2] = f57;
 i183 = i601 + 24 | 0;
 HEAPF32[i183 >> 2] = f57;
 i184 = i601 + 28 | 0;
 HEAPF32[i184 >> 2] = f57;
 HEAPF32[i601 + 32 >> 2] = f58;
 i185 = i601 + 36 | 0;
 HEAPF32[i185 >> 2] = f58;
 i186 = i601 + 40 | 0;
 HEAPF32[i186 >> 2] = f58;
 i187 = i601 + 44 | 0;
 HEAPF32[i187 >> 2] = f58;
 HEAPF32[i601 + 48 >> 2] = f59;
 i188 = i601 + 52 | 0;
 HEAPF32[i188 >> 2] = f59;
 i189 = i601 + 56 | 0;
 HEAPF32[i189 >> 2] = f59;
 i190 = i601 + 60 | 0;
 HEAPF32[i190 >> 2] = f59;
 HEAPF32[i601 + 64 >> 2] = f60;
 i191 = i601 + 68 | 0;
 HEAPF32[i191 >> 2] = f60;
 i192 = i601 + 72 | 0;
 HEAPF32[i192 >> 2] = f60;
 i193 = i601 + 76 | 0;
 HEAPF32[i193 >> 2] = f60;
 HEAPF32[i601 + 80 >> 2] = f61;
 i194 = i601 + 84 | 0;
 HEAPF32[i194 >> 2] = f61;
 i195 = i601 + 88 | 0;
 HEAPF32[i195 >> 2] = f61;
 i196 = i601 + 92 | 0;
 HEAPF32[i196 >> 2] = f61;
 HEAPF32[i601 + 96 >> 2] = f62;
 i197 = i601 + 100 | 0;
 HEAPF32[i197 >> 2] = f62;
 i198 = i601 + 104 | 0;
 HEAPF32[i198 >> 2] = f62;
 i199 = i601 + 108 | 0;
 HEAPF32[i199 >> 2] = f62;
 i203 = HEAP32[i203 >> 2] | 0;
 HEAP32[i601 + 112 >> 2] = i203;
 i200 = i601 + 116 | 0;
 HEAP32[i200 >> 2] = i203;
 i201 = i601 + 120 | 0;
 HEAP32[i201 >> 2] = i203;
 i202 = i601 + 124 | 0;
 HEAP32[i202 >> 2] = i203;
 i206 = HEAP32[i206 >> 2] | 0;
 HEAP32[i601 + 128 >> 2] = i206;
 i203 = i601 + 132 | 0;
 HEAP32[i203 >> 2] = i206;
 i204 = i601 + 136 | 0;
 HEAP32[i204 >> 2] = i206;
 i205 = i601 + 140 | 0;
 HEAP32[i205 >> 2] = i206;
 i206 = (i7 | 0) == 27;
 HEAP32[i602 >> 2] = 0;
 HEAP32[i602 + 4 >> 2] = 0;
 HEAP32[i602 + 8 >> 2] = 0;
 HEAP32[i602 + 12 >> 2] = 0;
 i207 = HEAP32[i625 + 12 >> 2] | 0;
 if (!i207) {
  STACKTOP = i635;
  return;
 }
 i208 = i603 + 12 | 0;
 i209 = i603 + 8 | 0;
 i210 = i603 + 4 | 0;
 i211 = i603 + 16 | 0;
 i212 = i603 + 28 | 0;
 i213 = i603 + 24 | 0;
 i214 = i603 + 20 | 0;
 i215 = i603 + 32 | 0;
 i216 = i603 + 44 | 0;
 i217 = i603 + 40 | 0;
 i218 = i603 + 36 | 0;
 i219 = i604 + 12 | 0;
 i220 = i604 + 8 | 0;
 i221 = i604 + 4 | 0;
 i222 = i604 + 16 | 0;
 i223 = i604 + 28 | 0;
 i224 = i604 + 24 | 0;
 i225 = i604 + 20 | 0;
 i226 = i604 + 32 | 0;
 i227 = i604 + 44 | 0;
 i228 = i604 + 40 | 0;
 i229 = i604 + 36 | 0;
 i230 = i605 + 12 | 0;
 i231 = i605 + 8 | 0;
 i232 = i605 + 4 | 0;
 i233 = i605 + 28 | 0;
 i234 = i605 + 24 | 0;
 i235 = i605 + 20 | 0;
 i236 = i605 + 44 | 0;
 i237 = i605 + 40 | 0;
 i238 = i605 + 36 | 0;
 i239 = i630 + 20 | 0;
 i240 = i625 + 20 | 0;
 i241 = i625 + 40 | 0;
 i242 = i625 + 300 | 0;
 i243 = i625 + 320 | 0;
 i244 = i625 + 340 | 0;
 i245 = i625 + 60 | 0;
 i246 = i625 + 80 | 0;
 i247 = i625 + 100 | 0;
 i248 = i625 + 120 | 0;
 i249 = i625 + 140 | 0;
 i250 = i625 + 160 | 0;
 i251 = i605 + 16 | 0;
 i252 = i605 + 32 | 0;
 i253 = i630 + 4 | 0;
 i254 = i606 + 4 | 0;
 i255 = i606 + 8 | 0;
 i256 = i606 + 12 | 0;
 i257 = i630 + 8 | 0;
 i258 = i607 + 4 | 0;
 i259 = i607 + 8 | 0;
 i260 = i607 + 12 | 0;
 i261 = i625 + 520 | 0;
 i262 = i608 + 4 | 0;
 i263 = i608 + 8 | 0;
 i264 = i608 + 12 | 0;
 i265 = i625 + 500 | 0;
 i266 = i609 + 4 | 0;
 i267 = i609 + 8 | 0;
 i268 = i609 + 12 | 0;
 i269 = i630 + 16 | 0;
 i270 = i610 + 4 | 0;
 i271 = i610 + 8 | 0;
 i272 = i610 + 12 | 0;
 i273 = i603 + 16 | 0;
 i274 = i603 + 32 | 0;
 i275 = i612 + 4 | 0;
 i276 = i612 + 8 | 0;
 i277 = i612 + 12 | 0;
 i278 = i612 + 16 | 0;
 i279 = i612 + 20 | 0;
 i280 = i612 + 24 | 0;
 i281 = i612 + 28 | 0;
 i282 = i612 + 32 | 0;
 i283 = i612 + 36 | 0;
 i284 = i612 + 40 | 0;
 i285 = i612 + 44 | 0;
 i286 = i604 + 16 | 0;
 i287 = i604 + 32 | 0;
 i288 = i614 + 4 | 0;
 i289 = i614 + 8 | 0;
 i290 = i614 + 12 | 0;
 i291 = i614 + 48 | 0;
 i292 = i614 + 52 | 0;
 i293 = i614 + 56 | 0;
 i294 = i614 + 60 | 0;
 i295 = i614 + 96 | 0;
 i296 = i614 + 100 | 0;
 i297 = i614 + 104 | 0;
 i298 = i614 + 108 | 0;
 i299 = i614 + 16 | 0;
 i300 = i614 + 20 | 0;
 i301 = i614 + 24 | 0;
 i302 = i614 + 28 | 0;
 i303 = i614 + 64 | 0;
 i304 = i614 + 68 | 0;
 i305 = i614 + 72 | 0;
 i306 = i614 + 76 | 0;
 i307 = i614 + 112 | 0;
 i308 = i614 + 116 | 0;
 i309 = i614 + 120 | 0;
 i310 = i614 + 124 | 0;
 i311 = i614 + 32 | 0;
 i312 = i614 + 36 | 0;
 i313 = i614 + 40 | 0;
 i314 = i614 + 44 | 0;
 i315 = i614 + 80 | 0;
 i316 = i614 + 84 | 0;
 i317 = i614 + 88 | 0;
 i318 = i614 + 92 | 0;
 i319 = i614 + 128 | 0;
 i320 = i614 + 132 | 0;
 i321 = i614 + 136 | 0;
 i322 = i614 + 140 | 0;
 i323 = i601 + 48 | 0;
 i324 = i601 + 96 | 0;
 i325 = i613 + 4 | 0;
 i326 = i613 + 8 | 0;
 i327 = i613 + 12 | 0;
 i328 = i613 + 48 | 0;
 i329 = i613 + 52 | 0;
 i330 = i613 + 56 | 0;
 i331 = i613 + 60 | 0;
 i332 = i613 + 96 | 0;
 i333 = i613 + 100 | 0;
 i334 = i613 + 104 | 0;
 i335 = i613 + 108 | 0;
 i336 = i601 + 16 | 0;
 i337 = i601 + 64 | 0;
 i338 = i601 + 112 | 0;
 i339 = i613 + 16 | 0;
 i340 = i613 + 20 | 0;
 i341 = i613 + 24 | 0;
 i342 = i613 + 28 | 0;
 i343 = i613 + 64 | 0;
 i344 = i613 + 68 | 0;
 i345 = i613 + 72 | 0;
 i346 = i613 + 76 | 0;
 i347 = i613 + 112 | 0;
 i348 = i613 + 116 | 0;
 i349 = i613 + 120 | 0;
 i350 = i613 + 124 | 0;
 i351 = i601 + 32 | 0;
 i352 = i601 + 80 | 0;
 i353 = i601 + 128 | 0;
 i354 = i613 + 32 | 0;
 i355 = i613 + 36 | 0;
 i356 = i613 + 40 | 0;
 i357 = i613 + 44 | 0;
 i358 = i613 + 80 | 0;
 i359 = i613 + 84 | 0;
 i360 = i613 + 88 | 0;
 i361 = i613 + 92 | 0;
 i362 = i613 + 128 | 0;
 i363 = i613 + 132 | 0;
 i364 = i613 + 136 | 0;
 i365 = i613 + 140 | 0;
 i366 = i611 + 4 | 0;
 i367 = i611 + 8 | 0;
 i368 = i611 + 12 | 0;
 i369 = i611 + 16 | 0;
 i370 = i611 + 20 | 0;
 i371 = i611 + 24 | 0;
 i372 = i611 + 28 | 0;
 i373 = i611 + 32 | 0;
 i374 = i611 + 36 | 0;
 i375 = i611 + 40 | 0;
 i376 = i611 + 44 | 0;
 i377 = i611 + 48 | 0;
 i378 = i611 + 52 | 0;
 i379 = i611 + 56 | 0;
 i380 = i611 + 60 | 0;
 i381 = i611 + 64 | 0;
 i382 = i611 + 68 | 0;
 i383 = i611 + 72 | 0;
 i384 = i611 + 76 | 0;
 i385 = i611 + 80 | 0;
 i386 = i611 + 84 | 0;
 i387 = i611 + 88 | 0;
 i388 = i611 + 92 | 0;
 i389 = i611 + 96 | 0;
 i390 = i611 + 100 | 0;
 i391 = i611 + 104 | 0;
 i392 = i611 + 108 | 0;
 i393 = i611 + 112 | 0;
 i394 = i611 + 116 | 0;
 i395 = i611 + 120 | 0;
 i396 = i611 + 124 | 0;
 i397 = i611 + 128 | 0;
 i398 = i611 + 132 | 0;
 i399 = i611 + 136 | 0;
 i400 = i611 + 140 | 0;
 i401 = i611 + 144 | 0;
 i402 = i611 + 148 | 0;
 i403 = i611 + 152 | 0;
 i404 = i611 + 156 | 0;
 i405 = i611 + 160 | 0;
 i406 = i611 + 164 | 0;
 i407 = i611 + 168 | 0;
 i408 = i611 + 172 | 0;
 i409 = i611 + 176 | 0;
 i410 = i611 + 180 | 0;
 i411 = i611 + 184 | 0;
 i412 = i611 + 188 | 0;
 i413 = (i7 & 48 | 0) == 0;
 i141 = i613 + 4 | 0;
 i158 = i613 + 8 | 0;
 i175 = i613 + 12 | 0;
 i414 = i613 + 16 | 0;
 i136 = i613 + 20 | 0;
 i153 = i613 + 24 | 0;
 i170 = i613 + 28 | 0;
 i415 = i613 + 32 | 0;
 i131 = i613 + 36 | 0;
 i148 = i613 + 40 | 0;
 i165 = i613 + 44 | 0;
 i416 = i613 + 48 | 0;
 i140 = i613 + 52 | 0;
 i157 = i613 + 56 | 0;
 i174 = i613 + 60 | 0;
 i417 = i613 + 64 | 0;
 i135 = i613 + 68 | 0;
 i152 = i613 + 72 | 0;
 i169 = i613 + 76 | 0;
 i418 = i613 + 80 | 0;
 i130 = i613 + 84 | 0;
 i147 = i613 + 88 | 0;
 i164 = i613 + 92 | 0;
 i419 = i613 + 96 | 0;
 i139 = i613 + 100 | 0;
 i156 = i613 + 104 | 0;
 i173 = i613 + 108 | 0;
 i420 = i613 + 112 | 0;
 i134 = i613 + 116 | 0;
 i151 = i613 + 120 | 0;
 i168 = i613 + 124 | 0;
 i421 = i613 + 128 | 0;
 i129 = i613 + 132 | 0;
 i146 = i613 + 136 | 0;
 i163 = i613 + 140 | 0;
 i422 = i613 + 144 | 0;
 i138 = i613 + 148 | 0;
 i155 = i613 + 152 | 0;
 i172 = i613 + 156 | 0;
 i423 = i613 + 160 | 0;
 i133 = i613 + 164 | 0;
 i150 = i613 + 168 | 0;
 i167 = i613 + 172 | 0;
 i424 = i613 + 176 | 0;
 i128 = i613 + 180 | 0;
 i145 = i613 + 184 | 0;
 i162 = i613 + 188 | 0;
 i142 = i614 + 4 | 0;
 i159 = i614 + 8 | 0;
 i176 = i614 + 12 | 0;
 i425 = i614 + 16 | 0;
 i137 = i614 + 20 | 0;
 i154 = i614 + 24 | 0;
 i171 = i614 + 28 | 0;
 i426 = i614 + 32 | 0;
 i132 = i614 + 36 | 0;
 i149 = i614 + 40 | 0;
 i166 = i614 + 44 | 0;
 i144 = i615 + 4 | 0;
 i161 = i615 + 8 | 0;
 i178 = i615 + 12 | 0;
 i427 = i615 + 16 | 0;
 i143 = i615 + 20 | 0;
 i160 = i615 + 24 | 0;
 i177 = i615 + 28 | 0;
 i127 = i615 + 32 | 0;
 i428 = (i7 & 512 | 0) != 0;
 i429 = i605 + 16 | 0;
 i430 = i605 + 32 | 0;
 i431 = i616 + 4 | 0;
 i432 = i616 + 8 | 0;
 i433 = i616 + 12 | 0;
 i434 = i616 + 16 | 0;
 i435 = i616 + 20 | 0;
 i436 = i616 + 24 | 0;
 i437 = i616 + 28 | 0;
 i438 = i616 + 32 | 0;
 i439 = i616 + 36 | 0;
 i440 = i616 + 40 | 0;
 i441 = i616 + 44 | 0;
 i442 = (i7 & 8192 | 0) != 0;
 i443 = i617 + 4 | 0;
 i444 = i617 + 8 | 0;
 i445 = i617 + 12 | 0;
 i446 = i617 + 16 | 0;
 i447 = i617 + 20 | 0;
 i448 = i617 + 24 | 0;
 i449 = i617 + 28 | 0;
 i450 = i617 + 32 | 0;
 i451 = i617 + 36 | 0;
 i452 = i617 + 40 | 0;
 i453 = i617 + 44 | 0;
 i454 = i617 + 48 | 0;
 i455 = i617 + 52 | 0;
 i456 = i617 + 56 | 0;
 i457 = i617 + 60 | 0;
 i458 = (i7 & 2 | 0) == 0;
 i459 = (i7 & 8 | 0) == 0;
 i460 = (i7 & 16 | 0) == 0;
 i461 = (i7 & 32 | 0) == 0;
 i462 = (i7 & 64 | 0) == 0;
 i463 = (i7 & 128 | 0) == 0;
 i464 = (i7 & 256 | 0) == 0;
 i465 = i616 + 16 | 0;
 i466 = i616 + 32 | 0;
 i467 = (i7 & 1024 | 0) == 0;
 i468 = (i7 & 2048 | 0) == 0;
 i469 = (i7 & 4096 | 0) == 0;
 i115 = (i7 & 4 | 0) == 0;
 i116 = i614 + 16 | 0;
 i117 = i614 + 32 | 0;
 i118 = i625 + 864 | 0;
 i119 = i625 + 848 | 0;
 i120 = i625 + 844 | 0;
 i121 = i625 + 828 | 0;
 i122 = i625 + 540 | 0;
 i123 = i615 + 16 | 0;
 i124 = i615 + 32 | 0;
 i125 = i612 + 16 | 0;
 i126 = i612 + 32 | 0;
 i80 = i8 + 32 | 0;
 i81 = i611 + 16 | 0;
 i82 = i611 + 32 | 0;
 i83 = i613 + 16 | 0;
 i84 = i613 + 32 | 0;
 i85 = i611 + 48 | 0;
 i86 = i85 + 16 | 0;
 i87 = i85 + 32 | 0;
 i88 = i416 + 16 | 0;
 i89 = i416 + 32 | 0;
 i90 = i389 + 16 | 0;
 i91 = i389 + 32 | 0;
 i92 = i419 + 16 | 0;
 i93 = i419 + 32 | 0;
 i94 = i401 + 16 | 0;
 i95 = i401 + 32 | 0;
 i96 = i422 + 16 | 0;
 i97 = i422 + 32 | 0;
 i98 = i611 + 16 | 0;
 i99 = i611 + 32 | 0;
 i100 = i613 + 16 | 0;
 i101 = i613 + 32 | 0;
 i102 = i611 + 48 | 0;
 i103 = i102 + 16 | 0;
 i104 = i102 + 32 | 0;
 i105 = i416 + 16 | 0;
 i106 = i416 + 32 | 0;
 i107 = i389 + 16 | 0;
 i108 = i389 + 32 | 0;
 i109 = i419 + 16 | 0;
 i110 = i419 + 32 | 0;
 i111 = i401 + 16 | 0;
 i112 = i401 + 32 | 0;
 i113 = i422 + 16 | 0;
 i114 = i422 + 32 | 0;
 i79 = 0;
 i1 = i9;
 do {
  i10 = i603;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i604;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i605;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i606 >> 2] = 0;
  HEAP32[i606 + 4 >> 2] = 0;
  HEAP32[i606 + 8 >> 2] = 0;
  HEAP32[i606 + 12 >> 2] = 0;
  HEAP32[i607 >> 2] = 0;
  HEAP32[i607 + 4 >> 2] = 0;
  HEAP32[i607 + 8 >> 2] = 0;
  HEAP32[i607 + 12 >> 2] = 0;
  HEAP32[i608 >> 2] = 0;
  HEAP32[i608 + 4 >> 2] = 0;
  HEAP32[i608 + 8 >> 2] = 0;
  HEAP32[i608 + 12 >> 2] = 0;
  HEAP32[i609 >> 2] = 0;
  HEAP32[i609 + 4 >> 2] = 0;
  HEAP32[i609 + 8 >> 2] = 0;
  HEAP32[i609 + 12 >> 2] = 0;
  HEAP32[i610 >> 2] = 0;
  HEAP32[i610 + 4 >> 2] = 0;
  HEAP32[i610 + 8 >> 2] = 0;
  HEAP32[i610 + 12 >> 2] = 0;
  i20 = HEAP32[i239 >> 2] | 0;
  if (!i20) {
   i77 = (HEAP32[i625 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i77 + 4 >> 2] | 0;
   i75 = HEAP32[i77 + 8 >> 2] | 0;
   i78 = HEAP32[i77 + 12 >> 2] | 0;
   i74 = (HEAP32[i240 >> 2] | 0) + (i79 << 2) | 0;
   i73 = HEAP32[i74 >> 2] | 0;
   i72 = HEAP32[i74 + 4 >> 2] | 0;
   i71 = HEAP32[i74 + 8 >> 2] | 0;
   i74 = HEAP32[i74 + 12 >> 2] | 0;
   i67 = (HEAP32[i241 >> 2] | 0) + (i79 << 2) | 0;
   i70 = HEAP32[i67 >> 2] | 0;
   i69 = HEAP32[i67 + 4 >> 2] | 0;
   i68 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   HEAP32[i603 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i210 >> 2] = i76;
   HEAP32[i209 >> 2] = i75;
   HEAP32[i208 >> 2] = i78;
   HEAP32[i211 >> 2] = i73;
   HEAP32[i214 >> 2] = i72;
   HEAP32[i213 >> 2] = i71;
   HEAP32[i212 >> 2] = i74;
   HEAP32[i215 >> 2] = i70;
   HEAP32[i218 >> 2] = i69;
   HEAP32[i217 >> 2] = i68;
   HEAP32[i216 >> 2] = i67;
   i67 = (HEAP32[i242 >> 2] | 0) + (i79 << 2) | 0;
   i68 = HEAP32[i67 + 4 >> 2] | 0;
   i69 = HEAP32[i67 + 8 >> 2] | 0;
   i70 = HEAP32[i67 + 12 >> 2] | 0;
   i74 = (HEAP32[i243 >> 2] | 0) + (i79 << 2) | 0;
   i71 = HEAP32[i74 >> 2] | 0;
   i72 = HEAP32[i74 + 4 >> 2] | 0;
   i73 = HEAP32[i74 + 8 >> 2] | 0;
   i74 = HEAP32[i74 + 12 >> 2] | 0;
   i78 = (HEAP32[i244 >> 2] | 0) + (i79 << 2) | 0;
   i75 = HEAP32[i78 >> 2] | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = HEAP32[i78 + 8 >> 2] | 0;
   i78 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i604 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i221 >> 2] = i68;
   HEAP32[i220 >> 2] = i69;
   HEAP32[i219 >> 2] = i70;
   HEAP32[i222 >> 2] = i71;
   HEAP32[i225 >> 2] = i72;
   HEAP32[i224 >> 2] = i73;
   HEAP32[i223 >> 2] = i74;
   HEAP32[i226 >> 2] = i75;
   HEAP32[i229 >> 2] = i76;
   HEAP32[i228 >> 2] = i77;
   HEAP32[i227 >> 2] = i78;
   i78 = (HEAP32[i245 >> 2] | 0) + (i79 << 2) | 0;
   f50 = Math_fround(HEAPF32[i78 >> 2]);
   f40 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f41 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f42 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i246 >> 2] | 0) + (i79 << 2) | 0;
   f43 = Math_fround(HEAPF32[i78 >> 2]);
   f44 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f45 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f46 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i247 >> 2] | 0) + (i79 << 2) | 0;
   f47 = Math_fround(HEAPF32[i78 >> 2]);
   f48 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f49 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i248 >> 2] | 0) + (i79 << 2) | 0;
   f51 = Math_fround(HEAPF32[i78 >> 2]);
   f52 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f54 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i249 >> 2] | 0) + (i79 << 2) | 0;
   f55 = Math_fround(HEAPF32[i78 >> 2]);
   f56 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f58 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i250 >> 2] | 0) + (i79 << 2) | 0;
   f59 = Math_fround(HEAPF32[i78 >> 2]);
   f60 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f52 = Math_fround(f40 + f52);
   f53 = Math_fround(f41 + f53);
   f54 = Math_fround(f42 + f54);
   f55 = Math_fround(f43 + f55);
   f56 = Math_fround(f44 + f56);
   f57 = Math_fround(f45 + f57);
   f58 = Math_fround(f46 + f58);
   f59 = Math_fround(f47 + f59);
   f60 = Math_fround(f48 + f60);
   f61 = Math_fround(f49 + f61);
   f62 = Math_fround(f62 + Math_fround(HEAPF32[i78 + 12 >> 2]));
   HEAPF32[i605 >> 2] = Math_fround(f50 + f51);
   HEAPF32[i232 >> 2] = f52;
   HEAPF32[i231 >> 2] = f53;
   HEAPF32[i230 >> 2] = f54;
   HEAPF32[i251 >> 2] = f55;
   HEAPF32[i235 >> 2] = f56;
   HEAPF32[i234 >> 2] = f57;
   HEAPF32[i233 >> 2] = f58;
   HEAPF32[i252 >> 2] = f59;
   HEAPF32[i238 >> 2] = f60;
   HEAPF32[i237 >> 2] = f61;
   HEAPF32[i236 >> 2] = f62;
   i78 = (HEAP32[i253 >> 2] | 0) + (i79 << 2) | 0;
   i77 = HEAP32[i78 + 4 >> 2] | 0;
   i76 = HEAP32[i78 + 8 >> 2] | 0;
   i75 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i606 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i254 >> 2] = i77;
   HEAP32[i255 >> 2] = i76;
   HEAP32[i256 >> 2] = i75;
   i75 = (HEAP32[i257 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i75 + 4 >> 2] | 0;
   i77 = HEAP32[i75 + 8 >> 2] | 0;
   i78 = HEAP32[i75 + 12 >> 2] | 0;
   HEAP32[i607 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i258 >> 2] = i76;
   HEAP32[i259 >> 2] = i77;
   HEAP32[i260 >> 2] = i78;
   i78 = (HEAP32[i261 >> 2] | 0) + (i79 << 2) | 0;
   i77 = HEAP32[i78 + 4 >> 2] | 0;
   i76 = HEAP32[i78 + 8 >> 2] | 0;
   i75 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i608 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i262 >> 2] = i77;
   HEAP32[i263 >> 2] = i76;
   HEAP32[i264 >> 2] = i75;
   i75 = (HEAP32[i265 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i75 + 4 >> 2] | 0;
   i77 = HEAP32[i75 + 8 >> 2] | 0;
   i78 = HEAP32[i75 + 12 >> 2] | 0;
   HEAP32[i609 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i266 >> 2] = i76;
   HEAP32[i267 >> 2] = i77;
   HEAP32[i268 >> 2] = i78;
   if (HEAP32[i618 >> 2] & 268435456 | 0) {
    i75 = (HEAP32[i269 >> 2] | 0) + (i79 << 2) | 0;
    i76 = HEAP32[i75 + 4 >> 2] | 0;
    i77 = HEAP32[i75 + 8 >> 2] | 0;
    i78 = HEAP32[i75 + 12 >> 2] | 0;
    HEAP32[i610 >> 2] = HEAP32[i75 >> 2];
    HEAP32[i270 >> 2] = i76;
    HEAP32[i271 >> 2] = i77;
    HEAP32[i272 >> 2] = i78;
   }
  } else {
   i3 = HEAP32[i245 >> 2] | 0;
   i4 = HEAP32[i248 >> 2] | 0;
   i5 = HEAP32[i240 >> 2] | 0;
   i6 = HEAP32[i243 >> 2] | 0;
   i7 = HEAP32[i246 >> 2] | 0;
   i8 = HEAP32[i249 >> 2] | 0;
   i9 = HEAP32[i241 >> 2] | 0;
   i10 = HEAP32[i244 >> 2] | 0;
   i11 = HEAP32[i247 >> 2] | 0;
   i13 = HEAP32[i250 >> 2] | 0;
   i14 = HEAP32[i253 >> 2] | 0;
   i15 = HEAP32[i257 >> 2] | 0;
   i16 = HEAP32[i261 >> 2] | 0;
   i17 = HEAP32[i265 >> 2] | 0;
   i18 = HEAP32[i625 >> 2] | 0;
   i19 = HEAP32[i242 >> 2] | 0;
   i21 = (HEAP32[i618 >> 2] & 268435456 | 0) == 0;
   i22 = HEAP32[i269 >> 2] | 0;
   i2 = 0;
   do {
    i23 = HEAP32[i20 + (i2 + i79 << 3) >> 2] | 0;
    HEAP32[i603 + (i2 << 2) >> 2] = HEAP32[i18 + (i23 << 2) >> 2];
    HEAP32[i604 + (i2 << 2) >> 2] = HEAP32[i19 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i3 + (i23 << 2) >> 2]);
    HEAPF32[i605 + (i2 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i4 + (i23 << 2) >> 2]));
    i78 = i2 + 4 | 0;
    HEAP32[i603 + (i78 << 2) >> 2] = HEAP32[i5 + (i23 << 2) >> 2];
    HEAP32[i604 + (i78 << 2) >> 2] = HEAP32[i6 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i7 + (i23 << 2) >> 2]);
    HEAPF32[i605 + (i78 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i8 + (i23 << 2) >> 2]));
    i78 = i2 + 8 | 0;
    HEAP32[i603 + (i78 << 2) >> 2] = HEAP32[i9 + (i23 << 2) >> 2];
    HEAP32[i604 + (i78 << 2) >> 2] = HEAP32[i10 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i11 + (i23 << 2) >> 2]);
    HEAPF32[i605 + (i78 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i13 + (i23 << 2) >> 2]));
    HEAP32[i606 + (i2 << 2) >> 2] = HEAP32[i14 + (i23 << 2) >> 2];
    HEAP32[i607 + (i2 << 2) >> 2] = HEAP32[i15 + (i23 << 2) >> 2];
    HEAP32[i608 + (i2 << 2) >> 2] = HEAP32[i16 + (i23 << 2) >> 2];
    HEAP32[i609 + (i2 << 2) >> 2] = HEAP32[i17 + (i23 << 2) >> 2];
    if (!i21) HEAP32[i610 + (i2 << 2) >> 2] = HEAP32[i22 + (i23 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f31 = Math_fround(HEAPF32[i603 >> 2]);
  f25 = Math_fround(f564 * f31);
  f36 = Math_fround(HEAPF32[i210 >> 2]);
  f35 = Math_fround(f564 * f36);
  f62 = Math_fround(HEAPF32[i209 >> 2]);
  f24 = Math_fround(f564 * f62);
  f60 = Math_fround(HEAPF32[i208 >> 2]);
  f32 = Math_fround(f564 * f60);
  f37 = Math_fround(HEAPF32[i273 >> 2]);
  f28 = Math_fround(f567 * f37);
  f30 = Math_fround(HEAPF32[i214 >> 2]);
  f29 = Math_fround(f567 * f30);
  f61 = Math_fround(HEAPF32[i213 >> 2]);
  f39 = Math_fround(f567 * f61);
  f59 = Math_fround(HEAPF32[i212 >> 2]);
  f28 = Math_fround(f25 + f28);
  f29 = Math_fround(f35 + f29);
  f39 = Math_fround(f24 + f39);
  f32 = Math_fround(f32 + Math_fround(f567 * f59));
  f24 = Math_fround(HEAPF32[i274 >> 2]);
  f35 = Math_fround(f570 * f24);
  f25 = Math_fround(HEAPF32[i218 >> 2]);
  f34 = Math_fround(f570 * f25);
  f26 = Math_fround(HEAPF32[i217 >> 2]);
  f33 = Math_fround(f570 * f26);
  f38 = Math_fround(HEAPF32[i216 >> 2]);
  f34 = Math_fround(f573 + Math_fround(f29 + f34));
  f33 = Math_fround(f573 + Math_fround(f39 + f33));
  f32 = Math_fround(f573 + Math_fround(f32 + Math_fround(f570 * f38)));
  HEAPF32[i612 >> 2] = Math_fround(f573 + Math_fround(f28 + f35));
  HEAPF32[i275 >> 2] = f34;
  HEAPF32[i276 >> 2] = f33;
  HEAPF32[i277 >> 2] = f32;
  f32 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f36) + Math_fround(f568 * f30)) + Math_fround(f571 * f25)));
  f33 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f62) + Math_fround(f568 * f61)) + Math_fround(f571 * f26)));
  f34 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f60) + Math_fround(f568 * f59)) + Math_fround(f571 * f38)));
  HEAPF32[i278 >> 2] = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f31) + Math_fround(f568 * f37)) + Math_fround(f571 * f24)));
  HEAPF32[i279 >> 2] = f32;
  HEAPF32[i280 >> 2] = f33;
  HEAPF32[i281 >> 2] = f34;
  f34 = Math_fround(f575 + Math_fround(Math_fround(f572 * f25) + Math_fround(Math_fround(f569 * f30) + Math_fround(f566 * f36))));
  f33 = Math_fround(f575 + Math_fround(Math_fround(f572 * f26) + Math_fround(Math_fround(f569 * f61) + Math_fround(f566 * f62))));
  f32 = Math_fround(f575 + Math_fround(Math_fround(f572 * f38) + Math_fround(Math_fround(f569 * f59) + Math_fround(f566 * f60))));
  HEAPF32[i282 >> 2] = Math_fround(f575 + Math_fround(Math_fround(f572 * f24) + Math_fround(Math_fround(f569 * f37) + Math_fround(f566 * f31))));
  HEAPF32[i283 >> 2] = f34;
  HEAPF32[i284 >> 2] = f33;
  HEAPF32[i285 >> 2] = f32;
  f24 = Math_fround(f631 + Math_fround(Math_fround(Math_fround(f627 * f31) + Math_fround(f628 * f37)) + Math_fround(f629 * f24)));
  f25 = Math_fround(f631 + Math_fround(Math_fround(Math_fround(f627 * f36) + Math_fround(f628 * f30)) + Math_fround(f629 * f25)));
  f26 = Math_fround(f631 + Math_fround(Math_fround(Math_fround(f627 * f62) + Math_fround(f628 * f61)) + Math_fround(f629 * f26)));
  f38 = Math_fround(f631 + Math_fround(Math_fround(Math_fround(f627 * f60) + Math_fround(f628 * f59)) + Math_fround(f629 * f38)));
  f59 = Math_fround(f597 + Math_fround(f598 * f24));
  f60 = Math_fround(f597 + Math_fround(f598 * f25));
  f61 = Math_fround(f597 + Math_fround(f598 * f26));
  f62 = Math_fround(f597 + Math_fround(f598 * f38));
  f24 = Math_fround(f591 + Math_fround(f592 * f24));
  f25 = Math_fround(f591 + Math_fround(f592 * f25));
  f26 = Math_fround(f591 + Math_fround(f592 * f26));
  f38 = Math_fround(f591 + Math_fround(f592 * f38));
  f30 = Math_fround(HEAPF32[i606 >> 2]);
  f36 = Math_fround(HEAPF32[i254 >> 2]);
  f37 = Math_fround(HEAPF32[i255 >> 2]);
  f31 = Math_fround(HEAPF32[i256 >> 2]);
  f32 = Math_fround(HEAPF32[i607 >> 2]);
  f33 = Math_fround(HEAPF32[i258 >> 2]);
  f34 = Math_fround(HEAPF32[i259 >> 2]);
  f35 = Math_fround(HEAPF32[i260 >> 2]);
  f28 = f30 > f32 ? f30 : f32;
  f39 = f36 > f33 ? f36 : f33;
  f29 = f37 > f34 ? f37 : f34;
  f40 = f31 > f35 ? f31 : f35;
  f56 = Math_fround((f28 > f59 ? f28 : f59) * Math_fround(.5));
  f57 = Math_fround((f39 > f60 ? f39 : f60) * Math_fround(.5));
  f58 = Math_fround((f29 > f61 ? f29 : f61) * Math_fround(.5));
  f12 = Math_fround((f40 > f62 ? f40 : f62) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = f59 >= Math_fround(0.0);
  i76 = f60 >= Math_fround(0.0);
  i77 = f61 >= Math_fround(0.0);
  i78 = f62 >= Math_fround(0.0);
  i9 = i75 ? i9 : 0;
  i10 = i76 ? i10 : 0;
  i11 = i77 ? i11 : 0;
  i5 = i78 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f58 = Math_fround(f24 * Math_fround(.5));
  f60 = Math_fround(f25 * Math_fround(.5));
  f62 = Math_fround(f26 * Math_fround(.5));
  f12 = Math_fround(f38 * Math_fround(.5));
  f57 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f57 < f58 ? f57 : f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59 < f60 ? f59 : f60, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f61 < f62 ? f61 : f62, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f24 >= Math_fround(0.0);
  i3 = f25 >= Math_fround(0.0);
  i2 = f26 >= Math_fround(0.0);
  i78 = f38 >= Math_fround(0.0);
  i75 = i78 ? (HEAPF32[tempDoublePtr >> 2] = f27 < f12 ? f27 : f12, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f59 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f60 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f29);
  f38 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f665 = Math_fround(f30 * f59);
  f666 = Math_fround(f37 * f61);
  f59 = Math_fround(f32 * f59);
  f61 = Math_fround(f34 * f61);
  f678 = Math_fround(HEAPF32[i608 >> 2]);
  f680 = Math_fround(HEAPF32[i262 >> 2]);
  f682 = Math_fround(HEAPF32[i263 >> 2]);
  f683 = Math_fround(f600 * f30);
  f681 = Math_fround(f600 * f37);
  f679 = Math_fround(f594 * f32);
  f677 = Math_fround(f594 * f34);
  f644 = Math_fround(f596 * f30);
  f642 = Math_fround(f596 * f37);
  f60 = Math_fround(f60 / f39);
  f32 = Math_fround(f36 * f60);
  f60 = Math_fround(f33 * f60);
  i75 = f678 < Math_fround(100.0);
  i77 = f682 < Math_fround(100.0);
  f682 = Math_fround(f600 * f36);
  f678 = Math_fround(f594 * f33);
  f643 = Math_fround(f596 * f36);
  f38 = Math_fround(f38 / f40);
  f34 = Math_fround(f31 * f38);
  f38 = Math_fround(f35 * f38);
  i76 = f680 < Math_fround(100.0);
  i78 = Math_fround(HEAPF32[i264 >> 2]) < Math_fround(100.0);
  f680 = Math_fround(f600 * f31);
  f676 = Math_fround(f594 * f35);
  f684 = Math_fround(f596 * f31);
  f664 = Math_fround(HEAPF32[i604 >> 2]);
  f42 = Math_fround(HEAPF32[i221 >> 2]);
  f650 = Math_fround(HEAPF32[i220 >> 2]);
  f53 = Math_fround(HEAPF32[i219 >> 2]);
  f671 = Math_fround(HEAPF32[i286 >> 2]);
  f672 = Math_fround(HEAPF32[i225 >> 2]);
  f640 = Math_fround(HEAPF32[i224 >> 2]);
  f27 = Math_fround(HEAPF32[i223 >> 2]);
  f35 = Math_fround(HEAPF32[i287 >> 2]);
  f662 = Math_fround(HEAPF32[i229 >> 2]);
  f29 = Math_fround(HEAPF32[i228 >> 2]);
  f663 = Math_fround(HEAPF32[i227 >> 2]);
  f664 = Math_fround(f664 * Math_fround(-.159154937));
  f42 = Math_fround(f42 * Math_fround(-.159154937));
  f650 = Math_fround(f650 * Math_fround(-.159154937));
  f53 = Math_fround(f53 * Math_fround(-.159154937));
  f651 = Math_fround(+_roundf(+f664));
  f36 = Math_fround(+_roundf(+f42));
  f31 = Math_fround(+_roundf(+f650));
  f651 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f664 - f651))));
  f36 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f42 - f36))));
  f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f650 - f31))));
  f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f53 - Math_fround(+_roundf(+f53))))));
  f661 = Math_fround(f651 * f651);
  f660 = Math_fround(f36 * f36);
  f51 = Math_fround(f31 * f31);
  f639 = Math_fround(f37 * f37);
  f62 = Math_fround(f661 * f661);
  f674 = Math_fround(f660 * f660);
  f54 = Math_fround(f51 * f51);
  f30 = Math_fround(f639 * f639);
  f661 = Math_fround(f651 * Math_fround(Math_fround(Math_fround(f62 * f62) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f661 * Math_fround(41.3416595))) + Math_fround(f62 * Math_fround(Math_fround(81.6018218) - Math_fround(f661 * Math_fround(76.5686187)))))));
  f660 = Math_fround(f36 * Math_fround(Math_fround(Math_fround(f674 * f674) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f660 * Math_fround(41.3416595))) + Math_fround(f674 * Math_fround(Math_fround(81.6018218) - Math_fround(f660 * Math_fround(76.5686187)))))));
  f51 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f54 * f54) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f54 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
  f639 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f639 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f639 * Math_fround(76.5686187)))))));
  f664 = Math_fround(f664 + Math_fround(-.25));
  f42 = Math_fround(f42 + Math_fround(-.25));
  f650 = Math_fround(f650 + Math_fround(-.25));
  f53 = Math_fround(f53 + Math_fround(-.25));
  f30 = Math_fround(+_roundf(+f664));
  f37 = Math_fround(+_roundf(+f42));
  f54 = Math_fround(+_roundf(+f650));
  f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f664 - f30))));
  f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f42 - f37))));
  f54 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f650 - f54))));
  f53 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f53 - Math_fround(+_roundf(+f53))))));
  f650 = Math_fround(f30 * f30);
  f42 = Math_fround(f37 * f37);
  f664 = Math_fround(f54 * f54);
  f31 = Math_fround(f53 * f53);
  f674 = Math_fround(f650 * f650);
  f36 = Math_fround(f42 * f42);
  f62 = Math_fround(f664 * f664);
  f651 = Math_fround(f31 * f31);
  f650 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f674 * f674) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f650 * Math_fround(41.3416595))) + Math_fround(f674 * Math_fround(Math_fround(81.6018218) - Math_fround(f650 * Math_fround(76.5686187)))))));
  f42 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f42 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f42 * Math_fround(76.5686187)))))));
  f664 = Math_fround(f54 * Math_fround(Math_fround(Math_fround(f62 * f62) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f664 * Math_fround(41.3416595))) + Math_fround(f62 * Math_fround(Math_fround(81.6018218) - Math_fround(f664 * Math_fround(76.5686187)))))));
  f31 = Math_fround(f53 * Math_fround(Math_fround(Math_fround(f651 * f651) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f651 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187)))))));
  f671 = Math_fround(f671 * Math_fround(-.159154937));
  f672 = Math_fround(f672 * Math_fround(-.159154937));
  f640 = Math_fround(f640 * Math_fround(-.159154937));
  f27 = Math_fround(f27 * Math_fround(-.159154937));
  f651 = Math_fround(+_roundf(+f671));
  f53 = Math_fround(+_roundf(+f672));
  f62 = Math_fround(+_roundf(+f640));
  f651 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f651))));
  f53 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f672 - f53))));
  f62 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f640 - f62))));
  f54 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - Math_fround(+_roundf(+f27))))));
  f36 = Math_fround(f651 * f651);
  f37 = Math_fround(f53 * f53);
  f674 = Math_fround(f62 * f62);
  f30 = Math_fround(f54 * f54);
  f33 = Math_fround(f36 * f36);
  f40 = Math_fround(f37 * f37);
  f41 = Math_fround(f674 * f674);
  f28 = Math_fround(f30 * f30);
  f36 = Math_fround(f651 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f36 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f36 * Math_fround(76.5686187)))))));
  f37 = Math_fround(f53 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187)))))));
  f674 = Math_fround(f62 * Math_fround(Math_fround(Math_fround(f41 * f41) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f674 * Math_fround(41.3416595))) + Math_fround(f41 * Math_fround(Math_fround(81.6018218) - Math_fround(f674 * Math_fround(76.5686187)))))));
  f30 = Math_fround(f54 * Math_fround(Math_fround(Math_fround(f28 * f28) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f30 * Math_fround(41.3416595))) + Math_fround(f28 * Math_fround(Math_fround(81.6018218) - Math_fround(f30 * Math_fround(76.5686187)))))));
  f671 = Math_fround(f671 + Math_fround(-.25));
  f672 = Math_fround(f672 + Math_fround(-.25));
  f640 = Math_fround(f640 + Math_fround(-.25));
  f27 = Math_fround(f27 + Math_fround(-.25));
  f28 = Math_fround(+_roundf(+f671));
  f54 = Math_fround(+_roundf(+f672));
  f41 = Math_fround(+_roundf(+f640));
  f28 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f671 - f28))));
  f54 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f672 - f54))));
  f41 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f640 - f41))));
  f27 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - Math_fround(+_roundf(+f27))))));
  f640 = Math_fround(f28 * f28);
  f672 = Math_fround(f54 * f54);
  f671 = Math_fround(f41 * f41);
  f62 = Math_fround(f27 * f27);
  f40 = Math_fround(f640 * f640);
  f53 = Math_fround(f672 * f672);
  f33 = Math_fround(f671 * f671);
  f651 = Math_fround(f62 * f62);
  f640 = Math_fround(f28 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f640 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f640 * Math_fround(76.5686187)))))));
  f672 = Math_fround(f54 * Math_fround(Math_fround(Math_fround(f53 * f53) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f672 * Math_fround(41.3416595))) + Math_fround(f53 * Math_fround(Math_fround(81.6018218) - Math_fround(f672 * Math_fround(76.5686187)))))));
  f671 = Math_fround(f41 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f671 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f671 * Math_fround(76.5686187)))))));
  f62 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(f651 * f651) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f62 * Math_fround(41.3416595))) + Math_fround(f651 * Math_fround(Math_fround(81.6018218) - Math_fround(f62 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f35 * Math_fround(-.159154937));
  f662 = Math_fround(f662 * Math_fround(-.159154937));
  f29 = Math_fround(f29 * Math_fround(-.159154937));
  f663 = Math_fround(f663 * Math_fround(-.159154937));
  f651 = Math_fround(+_roundf(+f35));
  f27 = Math_fround(+_roundf(+f662));
  f33 = Math_fround(+_roundf(+f29));
  f651 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - f651))));
  f27 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f662 - f27))));
  f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - f33))));
  f41 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f663 - Math_fround(+_roundf(+f663))))));
  f53 = Math_fround(f651 * f651);
  f54 = Math_fround(f27 * f27);
  f40 = Math_fround(f33 * f33);
  f28 = Math_fround(f41 * f41);
  f673 = Math_fround(f53 * f53);
  f52 = Math_fround(f54 * f54);
  f675 = Math_fround(f40 * f40);
  f39 = Math_fround(f28 * f28);
  f53 = Math_fround(f651 * Math_fround(Math_fround(Math_fround(f673 * f673) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f53 * Math_fround(41.3416595))) + Math_fround(f673 * Math_fround(Math_fround(81.6018218) - Math_fround(f53 * Math_fround(76.5686187)))))));
  f54 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(f52 * f52) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f54 * Math_fround(41.3416595))) + Math_fround(f52 * Math_fround(Math_fround(81.6018218) - Math_fround(f54 * Math_fround(76.5686187)))))));
  f40 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f675 * f675) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f675 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f41 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f35 + Math_fround(-.25));
  f662 = Math_fround(f662 + Math_fround(-.25));
  f29 = Math_fround(f29 + Math_fround(-.25));
  f663 = Math_fround(f663 + Math_fround(-.25));
  f39 = Math_fround(+_roundf(+f35));
  f41 = Math_fround(+_roundf(+f662));
  f675 = Math_fround(+_roundf(+f29));
  f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - f39))));
  f41 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f662 - f41))));
  f675 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - f675))));
  f663 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f663 - Math_fround(+_roundf(+f663))))));
  f29 = Math_fround(f39 * f39);
  f662 = Math_fround(f41 * f41);
  f35 = Math_fround(f675 * f675);
  f33 = Math_fround(f663 * f663);
  f52 = Math_fround(f29 * f29);
  f27 = Math_fround(f662 * f662);
  f673 = Math_fround(f35 * f35);
  f651 = Math_fround(f33 * f33);
  f29 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f52 * f52) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f29 * Math_fround(41.3416595))) + Math_fround(f52 * Math_fround(Math_fround(81.6018218) - Math_fround(f29 * Math_fround(76.5686187)))))));
  f662 = Math_fround(f41 * Math_fround(Math_fround(Math_fround(f27 * f27) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f662 * Math_fround(41.3416595))) + Math_fround(f27 * Math_fround(Math_fround(81.6018218) - Math_fround(f662 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f675 * Math_fround(Math_fround(Math_fround(f673 * f673) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f35 * Math_fround(41.3416595))) + Math_fround(f673 * Math_fround(Math_fround(81.6018218) - Math_fround(f35 * Math_fround(76.5686187)))))));
  f33 = Math_fround(f663 * Math_fround(Math_fround(Math_fround(f651 * f651) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f651 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187)))))));
  f651 = Math_fround(f36 * f53);
  f663 = Math_fround(f37 * f54);
  f673 = Math_fround(f674 * f40);
  f675 = Math_fround(f30 * f28);
  f27 = Math_fround(f663 + Math_fround(Math_fround(f42 * f672) * f662));
  f41 = Math_fround(f673 + Math_fround(Math_fround(f664 * f671) * f35));
  f52 = Math_fround(f675 + Math_fround(Math_fround(f31 * f62) * f33));
  HEAPF32[i614 >> 2] = Math_fround(f651 + Math_fround(Math_fround(f650 * f640) * f29));
  HEAPF32[i288 >> 2] = f27;
  HEAPF32[i289 >> 2] = f41;
  HEAPF32[i290 >> 2] = f52;
  f52 = Math_fround(Math_fround(f672 * Math_fround(f42 * f54)) - Math_fround(f37 * f662));
  f41 = Math_fround(Math_fround(f671 * Math_fround(f664 * f40)) - Math_fround(f674 * f35));
  f27 = Math_fround(Math_fround(f62 * Math_fround(f31 * f28)) - Math_fround(f30 * f33));
  HEAPF32[i291 >> 2] = Math_fround(Math_fround(f640 * Math_fround(f650 * f53)) - Math_fround(f36 * f29));
  HEAPF32[i292 >> 2] = f52;
  HEAPF32[i293 >> 2] = f41;
  HEAPF32[i294 >> 2] = f27;
  f27 = Math_fround(f660 * f672);
  f41 = Math_fround(f51 * f671);
  f52 = Math_fround(f639 * f62);
  HEAPF32[i295 >> 2] = Math_fround(f661 * f640);
  HEAPF32[i296 >> 2] = f27;
  HEAPF32[i297 >> 2] = f41;
  HEAPF32[i298 >> 2] = f52;
  f52 = Math_fround(f661 * f29);
  f41 = Math_fround(f660 * f662);
  f27 = Math_fround(f51 * f35);
  f39 = Math_fround(f639 * f33);
  HEAPF32[i299 >> 2] = f52;
  HEAPF32[i300 >> 2] = f41;
  HEAPF32[i301 >> 2] = f27;
  HEAPF32[i302 >> 2] = f39;
  f649 = Math_fround(f660 * f54);
  f659 = Math_fround(f51 * f40);
  f670 = Math_fround(f639 * f28);
  HEAPF32[i303 >> 2] = Math_fround(f661 * f53);
  HEAPF32[i304 >> 2] = f649;
  HEAPF32[i305 >> 2] = f659;
  HEAPF32[i306 >> 2] = f670;
  f670 = Math_fround(-f42);
  f659 = Math_fround(-f664);
  f649 = Math_fround(-f31);
  HEAPF32[i307 >> 2] = Math_fround(-f650);
  HEAPF32[i308 >> 2] = f670;
  HEAPF32[i309 >> 2] = f659;
  HEAPF32[i310 >> 2] = f649;
  f53 = Math_fround(Math_fround(Math_fround(f650 * f36) * f29) - Math_fround(f640 * f53));
  f54 = Math_fround(Math_fround(Math_fround(f42 * f37) * f662) - Math_fround(f672 * f54));
  f40 = Math_fround(Math_fround(Math_fround(f664 * f674) * f35) - Math_fround(f671 * f40));
  f28 = Math_fround(Math_fround(Math_fround(f31 * f30) * f33) - Math_fround(f62 * f28));
  HEAPF32[i311 >> 2] = f53;
  HEAPF32[i312 >> 2] = f54;
  HEAPF32[i313 >> 2] = f40;
  HEAPF32[i314 >> 2] = f28;
  f29 = Math_fround(Math_fround(f650 * f651) + Math_fround(f640 * f29));
  f662 = Math_fround(Math_fround(f42 * f663) + Math_fround(f672 * f662));
  f35 = Math_fround(Math_fround(f664 * f673) + Math_fround(f671 * f35));
  f33 = Math_fround(Math_fround(f31 * f675) + Math_fround(f62 * f33));
  HEAPF32[i315 >> 2] = f29;
  HEAPF32[i316 >> 2] = f662;
  HEAPF32[i317 >> 2] = f35;
  HEAPF32[i318 >> 2] = f33;
  f36 = Math_fround(f661 * f36);
  f37 = Math_fround(f660 * f37);
  f674 = Math_fround(f51 * f674);
  f30 = Math_fround(f639 * f30);
  HEAPF32[i319 >> 2] = f36;
  HEAPF32[i320 >> 2] = f37;
  HEAPF32[i321 >> 2] = f674;
  HEAPF32[i322 >> 2] = f30;
  f639 = Math_fround(HEAPF32[i601 >> 2]);
  f51 = Math_fround(f639 * Math_fround(HEAPF32[i614 >> 2]));
  f660 = Math_fround(HEAPF32[i179 >> 2]);
  f661 = Math_fround(f660 * Math_fround(HEAPF32[i288 >> 2]));
  f62 = Math_fround(HEAPF32[i180 >> 2]);
  f675 = Math_fround(f62 * Math_fround(HEAPF32[i289 >> 2]));
  f31 = Math_fround(HEAPF32[i181 >> 2]);
  f671 = Math_fround(f31 * Math_fround(HEAPF32[i290 >> 2]));
  f673 = Math_fround(HEAPF32[i323 >> 2]);
  f52 = Math_fround(f673 * f52);
  f664 = Math_fround(HEAPF32[i188 >> 2]);
  f41 = Math_fround(f664 * f41);
  f672 = Math_fround(HEAPF32[i189 >> 2]);
  f27 = Math_fround(f672 * f27);
  f663 = Math_fround(HEAPF32[i190 >> 2]);
  f52 = Math_fround(f51 + f52);
  f41 = Math_fround(f661 + f41);
  f27 = Math_fround(f675 + f27);
  f39 = Math_fround(f671 + Math_fround(f663 * f39));
  f671 = Math_fround(HEAPF32[i324 >> 2]);
  f53 = Math_fround(f671 * f53);
  f675 = Math_fround(HEAPF32[i197 >> 2]);
  f54 = Math_fround(f675 * f54);
  f661 = Math_fround(HEAPF32[i198 >> 2]);
  f40 = Math_fround(f661 * f40);
  f51 = Math_fround(HEAPF32[i199 >> 2]);
  f54 = Math_fround(f41 + f54);
  f40 = Math_fround(f27 + f40);
  f28 = Math_fround(f39 + Math_fround(f51 * f28));
  HEAPF32[i613 >> 2] = Math_fround(f52 + f53);
  HEAPF32[i325 >> 2] = f54;
  HEAPF32[i326 >> 2] = f40;
  HEAPF32[i327 >> 2] = f28;
  f28 = Math_fround(f639 * Math_fround(HEAPF32[i291 >> 2]));
  f40 = Math_fround(f660 * Math_fround(HEAPF32[i292 >> 2]));
  f54 = Math_fround(f62 * Math_fround(HEAPF32[i293 >> 2]));
  f53 = Math_fround(f31 * Math_fround(HEAPF32[i294 >> 2]));
  f52 = Math_fround(f673 * Math_fround(HEAPF32[i303 >> 2]));
  f39 = Math_fround(f664 * Math_fround(HEAPF32[i304 >> 2]));
  f27 = Math_fround(f672 * Math_fround(HEAPF32[i305 >> 2]));
  f662 = Math_fround(Math_fround(f40 + f39) + Math_fround(f675 * f662));
  f35 = Math_fround(Math_fround(f54 + f27) + Math_fround(f661 * f35));
  f33 = Math_fround(Math_fround(f53 + Math_fround(f663 * Math_fround(HEAPF32[i306 >> 2]))) + Math_fround(f51 * f33));
  HEAPF32[i328 >> 2] = Math_fround(Math_fround(f28 + f52) + Math_fround(f671 * f29));
  HEAPF32[i329 >> 2] = f662;
  HEAPF32[i330 >> 2] = f35;
  HEAPF32[i331 >> 2] = f33;
  f639 = Math_fround(f639 * Math_fround(HEAPF32[i295 >> 2]));
  f660 = Math_fround(f660 * Math_fround(HEAPF32[i296 >> 2]));
  f62 = Math_fround(f62 * Math_fround(HEAPF32[i297 >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i298 >> 2]));
  f673 = Math_fround(f673 * Math_fround(HEAPF32[i307 >> 2]));
  f664 = Math_fround(f664 * Math_fround(HEAPF32[i308 >> 2]));
  f672 = Math_fround(f672 * Math_fround(HEAPF32[i309 >> 2]));
  f37 = Math_fround(Math_fround(f660 + f664) + Math_fround(f675 * f37));
  f674 = Math_fround(Math_fround(f62 + f672) + Math_fround(f661 * f674));
  f30 = Math_fround(Math_fround(f31 + Math_fround(f663 * Math_fround(HEAPF32[i310 >> 2]))) + Math_fround(f51 * f30));
  HEAPF32[i332 >> 2] = Math_fround(Math_fround(f639 + f673) + Math_fround(f671 * f36));
  HEAPF32[i333 >> 2] = f37;
  HEAPF32[i334 >> 2] = f674;
  HEAPF32[i335 >> 2] = f30;
  f30 = Math_fround(HEAPF32[i336 >> 2]);
  f674 = Math_fround(f30 * Math_fround(HEAPF32[i614 >> 2]));
  f37 = Math_fround(HEAPF32[i182 >> 2]);
  f36 = Math_fround(f37 * Math_fround(HEAPF32[i288 >> 2]));
  f671 = Math_fround(HEAPF32[i183 >> 2]);
  f673 = Math_fround(f671 * Math_fround(HEAPF32[i289 >> 2]));
  f639 = Math_fround(HEAPF32[i184 >> 2]);
  f51 = Math_fround(f639 * Math_fround(HEAPF32[i290 >> 2]));
  f663 = Math_fround(HEAPF32[i337 >> 2]);
  f31 = Math_fround(f663 * Math_fround(HEAPF32[i299 >> 2]));
  f661 = Math_fround(HEAPF32[i191 >> 2]);
  f672 = Math_fround(f661 * Math_fround(HEAPF32[i300 >> 2]));
  f62 = Math_fround(HEAPF32[i192 >> 2]);
  f675 = Math_fround(f62 * Math_fround(HEAPF32[i301 >> 2]));
  f664 = Math_fround(HEAPF32[i193 >> 2]);
  f31 = Math_fround(f674 + f31);
  f672 = Math_fround(f36 + f672);
  f675 = Math_fround(f673 + f675);
  f51 = Math_fround(f51 + Math_fround(f664 * Math_fround(HEAPF32[i302 >> 2])));
  f673 = Math_fround(HEAPF32[i338 >> 2]);
  f36 = Math_fround(f673 * Math_fround(HEAPF32[i311 >> 2]));
  f674 = Math_fround(HEAPF32[i200 >> 2]);
  f660 = Math_fround(f674 * Math_fround(HEAPF32[i312 >> 2]));
  f33 = Math_fround(HEAPF32[i201 >> 2]);
  f35 = Math_fround(f33 * Math_fround(HEAPF32[i313 >> 2]));
  f662 = Math_fround(HEAPF32[i202 >> 2]);
  f660 = Math_fround(f672 + f660);
  f35 = Math_fround(f675 + f35);
  f51 = Math_fround(f51 + Math_fround(f662 * Math_fround(HEAPF32[i314 >> 2])));
  HEAPF32[i339 >> 2] = Math_fround(f31 + f36);
  HEAPF32[i340 >> 2] = f660;
  HEAPF32[i341 >> 2] = f35;
  HEAPF32[i342 >> 2] = f51;
  f51 = Math_fround(f30 * Math_fround(HEAPF32[i291 >> 2]));
  f35 = Math_fround(f37 * Math_fround(HEAPF32[i292 >> 2]));
  f660 = Math_fround(f671 * Math_fround(HEAPF32[i293 >> 2]));
  f36 = Math_fround(f639 * Math_fround(HEAPF32[i294 >> 2]));
  f31 = Math_fround(f663 * Math_fround(HEAPF32[i303 >> 2]));
  f675 = Math_fround(f661 * Math_fround(HEAPF32[i304 >> 2]));
  f672 = Math_fround(f62 * Math_fround(HEAPF32[i305 >> 2]));
  f31 = Math_fround(f51 + f31);
  f675 = Math_fround(f35 + f675);
  f672 = Math_fround(f660 + f672);
  f36 = Math_fround(f36 + Math_fround(f664 * Math_fround(HEAPF32[i306 >> 2])));
  f660 = Math_fround(f673 * Math_fround(HEAPF32[i315 >> 2]));
  f35 = Math_fround(f674 * Math_fround(HEAPF32[i316 >> 2]));
  f51 = Math_fround(f33 * Math_fround(HEAPF32[i317 >> 2]));
  f35 = Math_fround(f675 + f35);
  f51 = Math_fround(f672 + f51);
  f36 = Math_fround(f36 + Math_fround(f662 * Math_fround(HEAPF32[i318 >> 2])));
  HEAPF32[i343 >> 2] = Math_fround(f31 + f660);
  HEAPF32[i344 >> 2] = f35;
  HEAPF32[i345 >> 2] = f51;
  HEAPF32[i346 >> 2] = f36;
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i295 >> 2]));
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i296 >> 2]));
  f671 = Math_fround(f671 * Math_fround(HEAPF32[i297 >> 2]));
  f639 = Math_fround(f639 * Math_fround(HEAPF32[i298 >> 2]));
  f663 = Math_fround(f663 * Math_fround(HEAPF32[i307 >> 2]));
  f661 = Math_fround(f661 * Math_fround(HEAPF32[i308 >> 2]));
  f62 = Math_fround(f62 * Math_fround(HEAPF32[i309 >> 2]));
  f663 = Math_fround(f30 + f663);
  f661 = Math_fround(f37 + f661);
  f62 = Math_fround(f671 + f62);
  f664 = Math_fround(f639 + Math_fround(f664 * Math_fround(HEAPF32[i310 >> 2])));
  f673 = Math_fround(f673 * Math_fround(HEAPF32[i319 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i320 >> 2]));
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i321 >> 2]));
  f674 = Math_fround(f661 + f674);
  f33 = Math_fround(f62 + f33);
  f662 = Math_fround(f664 + Math_fround(f662 * Math_fround(HEAPF32[i322 >> 2])));
  HEAPF32[i347 >> 2] = Math_fround(f663 + f673);
  HEAPF32[i348 >> 2] = f674;
  HEAPF32[i349 >> 2] = f33;
  HEAPF32[i350 >> 2] = f662;
  f662 = Math_fround(HEAPF32[i351 >> 2]);
  f33 = Math_fround(f662 * Math_fround(HEAPF32[i614 >> 2]));
  f674 = Math_fround(HEAPF32[i185 >> 2]);
  f673 = Math_fround(f674 * Math_fround(HEAPF32[i288 >> 2]));
  f663 = Math_fround(HEAPF32[i186 >> 2]);
  f664 = Math_fround(f663 * Math_fround(HEAPF32[i289 >> 2]));
  f62 = Math_fround(HEAPF32[i187 >> 2]);
  f661 = Math_fround(f62 * Math_fround(HEAPF32[i290 >> 2]));
  f639 = Math_fround(HEAPF32[i352 >> 2]);
  f671 = Math_fround(f639 * Math_fround(HEAPF32[i299 >> 2]));
  f37 = Math_fround(HEAPF32[i194 >> 2]);
  f30 = Math_fround(f37 * Math_fround(HEAPF32[i300 >> 2]));
  f36 = Math_fround(HEAPF32[i195 >> 2]);
  f51 = Math_fround(f36 * Math_fround(HEAPF32[i301 >> 2]));
  f35 = Math_fround(HEAPF32[i196 >> 2]);
  f671 = Math_fround(f33 + f671);
  f30 = Math_fround(f673 + f30);
  f51 = Math_fround(f664 + f51);
  f661 = Math_fround(f661 + Math_fround(f35 * Math_fround(HEAPF32[i302 >> 2])));
  f664 = Math_fround(HEAPF32[i353 >> 2]);
  f673 = Math_fround(f664 * Math_fround(HEAPF32[i311 >> 2]));
  f33 = Math_fround(HEAPF32[i203 >> 2]);
  f660 = Math_fround(f33 * Math_fround(HEAPF32[i312 >> 2]));
  f31 = Math_fround(HEAPF32[i204 >> 2]);
  f672 = Math_fround(f31 * Math_fround(HEAPF32[i313 >> 2]));
  f675 = Math_fround(HEAPF32[i205 >> 2]);
  f660 = Math_fround(f30 + f660);
  f672 = Math_fround(f51 + f672);
  f661 = Math_fround(f661 + Math_fround(f675 * Math_fround(HEAPF32[i314 >> 2])));
  HEAPF32[i354 >> 2] = Math_fround(f671 + f673);
  HEAPF32[i355 >> 2] = f660;
  HEAPF32[i356 >> 2] = f672;
  HEAPF32[i357 >> 2] = f661;
  f661 = Math_fround(f662 * Math_fround(HEAPF32[i291 >> 2]));
  f672 = Math_fround(f674 * Math_fround(HEAPF32[i292 >> 2]));
  f660 = Math_fround(f663 * Math_fround(HEAPF32[i293 >> 2]));
  f673 = Math_fround(f62 * Math_fround(HEAPF32[i294 >> 2]));
  f671 = Math_fround(f639 * Math_fround(HEAPF32[i303 >> 2]));
  f51 = Math_fround(f37 * Math_fround(HEAPF32[i304 >> 2]));
  f30 = Math_fround(f36 * Math_fround(HEAPF32[i305 >> 2]));
  f671 = Math_fround(f661 + f671);
  f51 = Math_fround(f672 + f51);
  f30 = Math_fround(f660 + f30);
  f673 = Math_fround(f673 + Math_fround(f35 * Math_fround(HEAPF32[i306 >> 2])));
  f660 = Math_fround(f664 * Math_fround(HEAPF32[i315 >> 2]));
  f672 = Math_fround(f33 * Math_fround(HEAPF32[i316 >> 2]));
  f661 = Math_fround(f31 * Math_fround(HEAPF32[i317 >> 2]));
  f672 = Math_fround(f51 + f672);
  f661 = Math_fround(f30 + f661);
  f673 = Math_fround(f673 + Math_fround(f675 * Math_fround(HEAPF32[i318 >> 2])));
  HEAPF32[i358 >> 2] = Math_fround(f671 + f660);
  HEAPF32[i359 >> 2] = f672;
  HEAPF32[i360 >> 2] = f661;
  HEAPF32[i361 >> 2] = f673;
  f662 = Math_fround(f662 * Math_fround(HEAPF32[i295 >> 2]));
  f674 = Math_fround(f674 * Math_fround(HEAPF32[i296 >> 2]));
  f663 = Math_fround(f663 * Math_fround(HEAPF32[i297 >> 2]));
  f62 = Math_fround(f62 * Math_fround(HEAPF32[i298 >> 2]));
  f639 = Math_fround(f639 * Math_fround(HEAPF32[i307 >> 2]));
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i308 >> 2]));
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i309 >> 2]));
  f639 = Math_fround(f662 + f639);
  f37 = Math_fround(f674 + f37);
  f36 = Math_fround(f663 + f36);
  f35 = Math_fround(f62 + Math_fround(f35 * Math_fround(HEAPF32[i310 >> 2])));
  f664 = Math_fround(f664 * Math_fround(HEAPF32[i319 >> 2]));
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i320 >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i321 >> 2]));
  f33 = Math_fround(f37 + f33);
  f31 = Math_fround(f36 + f31);
  f675 = Math_fround(f35 + Math_fround(f675 * Math_fround(HEAPF32[i322 >> 2])));
  HEAPF32[i362 >> 2] = Math_fround(f639 + f664);
  HEAPF32[i363 >> 2] = f33;
  HEAPF32[i364 >> 2] = f31;
  HEAPF32[i365 >> 2] = f675;
  f31 = i75 ? f665 : Math_fround(0.0);
  f32 = i76 ? f32 : Math_fround(0.0);
  f33 = i77 ? f666 : Math_fround(0.0);
  f34 = i78 ? f34 : Math_fround(0.0);
  f666 = Math_fround(f683 - f31);
  f665 = Math_fround(f682 - f32);
  f664 = Math_fround(f681 - f33);
  f639 = Math_fround(f680 - f34);
  f35 = i75 ? f59 : Math_fround(0.0);
  f59 = Math_fround(f679 + f35);
  f36 = i76 ? f60 : Math_fround(0.0);
  f60 = Math_fround(f678 + f36);
  f37 = i77 ? f61 : Math_fround(0.0);
  f61 = Math_fround(f677 + f37);
  f38 = i78 ? f38 : Math_fround(0.0);
  f62 = Math_fround(f676 + f38);
  f663 = Math_fround(HEAPF32[i613 >> 2]);
  f674 = Math_fround(f666 * f663);
  f662 = Math_fround(HEAPF32[i325 >> 2]);
  f673 = Math_fround(f665 * f662);
  f661 = Math_fround(HEAPF32[i326 >> 2]);
  f672 = Math_fround(f664 * f661);
  f660 = Math_fround(HEAPF32[i327 >> 2]);
  f671 = Math_fround(f639 * f660);
  f30 = Math_fround(HEAPF32[i328 >> 2]);
  f51 = Math_fround(f59 * f30);
  f29 = Math_fround(HEAPF32[i329 >> 2]);
  f52 = Math_fround(f60 * f29);
  f28 = Math_fround(HEAPF32[i330 >> 2]);
  f53 = Math_fround(f61 * f28);
  f27 = Math_fround(HEAPF32[i331 >> 2]);
  f54 = Math_fround(f62 * f27);
  f39 = Math_fround(f674 + f51);
  f40 = Math_fround(f673 + f52);
  f41 = Math_fround(f672 + f53);
  f42 = Math_fround(f671 + f54);
  f640 = Math_fround(f644 * Math_fround(HEAPF32[i332 >> 2]));
  f651 = Math_fround(f643 * Math_fround(HEAPF32[i333 >> 2]));
  f650 = Math_fround(f642 * Math_fround(HEAPF32[i334 >> 2]));
  f649 = Math_fround(f684 * Math_fround(HEAPF32[i335 >> 2]));
  f39 = Math_fround(f39 + f640);
  f40 = Math_fround(f40 + f651);
  f41 = Math_fround(f41 + f650);
  f42 = Math_fround(f42 + f649);
  f659 = Math_fround(HEAPF32[i339 >> 2]);
  f670 = Math_fround(f666 * f659);
  f658 = Math_fround(HEAPF32[i340 >> 2]);
  f669 = Math_fround(f665 * f658);
  f657 = Math_fround(HEAPF32[i341 >> 2]);
  f668 = Math_fround(f664 * f657);
  f656 = Math_fround(HEAPF32[i342 >> 2]);
  f667 = Math_fround(f639 * f656);
  f26 = Math_fround(HEAPF32[i343 >> 2]);
  f55 = Math_fround(f59 * f26);
  f25 = Math_fround(HEAPF32[i344 >> 2]);
  f56 = Math_fround(f60 * f25);
  f24 = Math_fround(HEAPF32[i345 >> 2]);
  f57 = Math_fround(f61 * f24);
  f12 = Math_fround(HEAPF32[i346 >> 2]);
  f58 = Math_fround(f62 * f12);
  f43 = Math_fround(f670 + f55);
  f44 = Math_fround(f669 + f56);
  f45 = Math_fround(f668 + f57);
  f46 = Math_fround(f667 + f58);
  f648 = Math_fround(f644 * Math_fround(HEAPF32[i347 >> 2]));
  f647 = Math_fround(f643 * Math_fround(HEAPF32[i348 >> 2]));
  f646 = Math_fround(f642 * Math_fround(HEAPF32[i349 >> 2]));
  f645 = Math_fround(f684 * Math_fround(HEAPF32[i350 >> 2]));
  f43 = Math_fround(f43 + f648);
  f44 = Math_fround(f44 + f647);
  f45 = Math_fround(f45 + f646);
  f46 = Math_fround(f46 + f645);
  f655 = Math_fround(HEAPF32[i354 >> 2]);
  f666 = Math_fround(f666 * f655);
  f654 = Math_fround(HEAPF32[i355 >> 2]);
  f665 = Math_fround(f665 * f654);
  f653 = Math_fround(HEAPF32[i356 >> 2]);
  f664 = Math_fround(f664 * f653);
  f652 = Math_fround(HEAPF32[i357 >> 2]);
  f639 = Math_fround(f639 * f652);
  f636 = Math_fround(HEAPF32[i358 >> 2]);
  f59 = Math_fround(f59 * f636);
  f637 = Math_fround(HEAPF32[i359 >> 2]);
  f60 = Math_fround(f60 * f637);
  f638 = Math_fround(HEAPF32[i360 >> 2]);
  f61 = Math_fround(f61 * f638);
  f641 = Math_fround(HEAPF32[i361 >> 2]);
  f62 = Math_fround(f62 * f641);
  f47 = Math_fround(f666 + f59);
  f48 = Math_fround(f665 + f60);
  f49 = Math_fround(f664 + f61);
  f50 = Math_fround(f639 + f62);
  f644 = Math_fround(f644 * Math_fround(HEAPF32[i362 >> 2]));
  f643 = Math_fround(f643 * Math_fround(HEAPF32[i363 >> 2]));
  f642 = Math_fround(f642 * Math_fround(HEAPF32[i364 >> 2]));
  f675 = Math_fround(f684 * f675);
  f47 = Math_fround(f47 + f644);
  f48 = Math_fround(f48 + f643);
  f49 = Math_fround(f49 + f642);
  f50 = Math_fround(f675 + f50);
  f683 = Math_fround(f683 + f31);
  f682 = Math_fround(f682 + f32);
  f681 = Math_fround(f681 + f33);
  f680 = Math_fround(f680 + f34);
  f663 = Math_fround(f683 * f663);
  f662 = Math_fround(f682 * f662);
  f661 = Math_fround(f681 * f661);
  f660 = Math_fround(f680 * f660);
  f51 = Math_fround(Math_fround(f663 + f51) + f640);
  f52 = Math_fround(Math_fround(f662 + f52) + f651);
  f53 = Math_fround(Math_fround(f661 + f53) + f650);
  f54 = Math_fround(Math_fround(f660 + f54) + f649);
  f659 = Math_fround(f683 * f659);
  f658 = Math_fround(f682 * f658);
  f657 = Math_fround(f681 * f657);
  f656 = Math_fround(f680 * f656);
  f55 = Math_fround(Math_fround(f659 + f55) + f648);
  f56 = Math_fround(Math_fround(f658 + f56) + f647);
  f57 = Math_fround(Math_fround(f657 + f57) + f646);
  f58 = Math_fround(Math_fround(f656 + f58) + f645);
  f655 = Math_fround(f683 * f655);
  f654 = Math_fround(f682 * f654);
  f653 = Math_fround(f681 * f653);
  f652 = Math_fround(f680 * f652);
  f59 = Math_fround(Math_fround(f655 + f59) + f644);
  f60 = Math_fround(Math_fround(f654 + f60) + f643);
  f61 = Math_fround(Math_fround(f653 + f61) + f642);
  f62 = Math_fround(f675 + Math_fround(f652 + f62));
  f679 = Math_fround(f679 - f35);
  f678 = Math_fround(f678 - f36);
  f677 = Math_fround(f677 - f37);
  f676 = Math_fround(f676 - f38);
  f30 = Math_fround(f679 * f30);
  f29 = Math_fround(f678 * f29);
  f28 = Math_fround(f677 * f28);
  f27 = Math_fround(f676 * f27);
  f663 = Math_fround(Math_fround(f663 + f30) + f640);
  f662 = Math_fround(Math_fround(f662 + f29) + f651);
  f661 = Math_fround(Math_fround(f661 + f28) + f650);
  f660 = Math_fround(Math_fround(f660 + f27) + f649);
  f26 = Math_fround(f679 * f26);
  f25 = Math_fround(f678 * f25);
  f24 = Math_fround(f677 * f24);
  f12 = Math_fround(f676 * f12);
  f659 = Math_fround(Math_fround(f659 + f26) + f648);
  f658 = Math_fround(Math_fround(f658 + f25) + f647);
  f657 = Math_fround(Math_fround(f657 + f24) + f646);
  f656 = Math_fround(Math_fround(f656 + f12) + f645);
  f636 = Math_fround(f679 * f636);
  f637 = Math_fround(f678 * f637);
  f638 = Math_fround(f677 * f638);
  f641 = Math_fround(f676 * f641);
  f655 = Math_fround(Math_fround(f655 + f636) + f644);
  f654 = Math_fround(Math_fround(f654 + f637) + f643);
  f653 = Math_fround(Math_fround(f653 + f638) + f642);
  f652 = Math_fround(f675 + Math_fround(f652 + f641));
  f640 = Math_fround(Math_fround(f674 + f30) + f640);
  f651 = Math_fround(Math_fround(f673 + f29) + f651);
  f650 = Math_fround(Math_fround(f672 + f28) + f650);
  f649 = Math_fround(Math_fround(f671 + f27) + f649);
  f648 = Math_fround(Math_fround(f670 + f26) + f648);
  f647 = Math_fround(Math_fround(f669 + f25) + f647);
  f646 = Math_fround(Math_fround(f668 + f24) + f646);
  f645 = Math_fround(Math_fround(f667 + f12) + f645);
  f644 = Math_fround(Math_fround(f666 + f636) + f644);
  f643 = Math_fround(Math_fround(f665 + f637) + f643);
  f642 = Math_fround(Math_fround(f664 + f638) + f642);
  f641 = Math_fround(f675 + Math_fround(f639 + f641));
  f639 = Math_fround(HEAPF32[i612 >> 2]);
  f675 = Math_fround(f39 + f639);
  f638 = Math_fround(HEAPF32[i275 >> 2]);
  f664 = Math_fround(f40 + f638);
  f637 = Math_fround(HEAPF32[i276 >> 2]);
  f665 = Math_fround(f41 + f637);
  f636 = Math_fround(HEAPF32[i277 >> 2]);
  f666 = Math_fround(f42 + f636);
  f12 = Math_fround(HEAPF32[i278 >> 2]);
  f667 = Math_fround(f43 + f12);
  f24 = Math_fround(HEAPF32[i279 >> 2]);
  f668 = Math_fround(f44 + f24);
  f25 = Math_fround(HEAPF32[i280 >> 2]);
  f669 = Math_fround(f45 + f25);
  f26 = Math_fround(HEAPF32[i281 >> 2]);
  f670 = Math_fround(f46 + f26);
  f27 = Math_fround(HEAPF32[i282 >> 2]);
  f671 = Math_fround(f47 + f27);
  f28 = Math_fround(HEAPF32[i283 >> 2]);
  f672 = Math_fround(f48 + f28);
  f29 = Math_fround(HEAPF32[i284 >> 2]);
  f673 = Math_fround(f49 + f29);
  f30 = Math_fround(HEAPF32[i285 >> 2]);
  f674 = Math_fround(f50 + f30);
  HEAPF32[i611 >> 2] = f675;
  HEAPF32[i366 >> 2] = f664;
  HEAPF32[i367 >> 2] = f665;
  HEAPF32[i368 >> 2] = f666;
  HEAPF32[i369 >> 2] = f667;
  HEAPF32[i370 >> 2] = f668;
  HEAPF32[i371 >> 2] = f669;
  HEAPF32[i372 >> 2] = f670;
  HEAPF32[i373 >> 2] = f671;
  HEAPF32[i374 >> 2] = f672;
  HEAPF32[i375 >> 2] = f673;
  HEAPF32[i376 >> 2] = f674;
  f674 = Math_fround(f52 + f638);
  f673 = Math_fround(f53 + f637);
  f672 = Math_fround(f54 + f636);
  f671 = Math_fround(f55 + f12);
  f670 = Math_fround(f56 + f24);
  f669 = Math_fround(f57 + f25);
  f668 = Math_fround(f58 + f26);
  f667 = Math_fround(f59 + f27);
  f666 = Math_fround(f60 + f28);
  f665 = Math_fround(f61 + f29);
  f664 = Math_fround(f62 + f30);
  HEAPF32[i377 >> 2] = Math_fround(f51 + f639);
  HEAPF32[i378 >> 2] = f674;
  HEAPF32[i379 >> 2] = f673;
  HEAPF32[i380 >> 2] = f672;
  HEAPF32[i381 >> 2] = f671;
  HEAPF32[i382 >> 2] = f670;
  HEAPF32[i383 >> 2] = f669;
  HEAPF32[i384 >> 2] = f668;
  HEAPF32[i385 >> 2] = f667;
  HEAPF32[i386 >> 2] = f666;
  HEAPF32[i387 >> 2] = f665;
  HEAPF32[i388 >> 2] = f664;
  f662 = Math_fround(f662 + f638);
  f661 = Math_fround(f661 + f637);
  f660 = Math_fround(f660 + f636);
  f659 = Math_fround(f659 + f12);
  f658 = Math_fround(f658 + f24);
  f657 = Math_fround(f657 + f25);
  f656 = Math_fround(f656 + f26);
  f655 = Math_fround(f655 + f27);
  f654 = Math_fround(f654 + f28);
  f653 = Math_fround(f653 + f29);
  f652 = Math_fround(f652 + f30);
  HEAPF32[i389 >> 2] = Math_fround(f663 + f639);
  HEAPF32[i390 >> 2] = f662;
  HEAPF32[i391 >> 2] = f661;
  HEAPF32[i392 >> 2] = f660;
  HEAPF32[i393 >> 2] = f659;
  HEAPF32[i394 >> 2] = f658;
  HEAPF32[i395 >> 2] = f657;
  HEAPF32[i396 >> 2] = f656;
  HEAPF32[i397 >> 2] = f655;
  HEAPF32[i398 >> 2] = f654;
  HEAPF32[i399 >> 2] = f653;
  HEAPF32[i400 >> 2] = f652;
  f638 = Math_fround(f651 + f638);
  f637 = Math_fround(f650 + f637);
  f636 = Math_fround(f649 + f636);
  f12 = Math_fround(f648 + f12);
  f24 = Math_fround(f647 + f24);
  f25 = Math_fround(f646 + f25);
  f26 = Math_fround(f645 + f26);
  f27 = Math_fround(f644 + f27);
  f28 = Math_fround(f643 + f28);
  f29 = Math_fround(f642 + f29);
  f30 = Math_fround(f641 + f30);
  HEAPF32[i401 >> 2] = Math_fround(f640 + f639);
  HEAPF32[i402 >> 2] = f638;
  HEAPF32[i403 >> 2] = f637;
  HEAPF32[i404 >> 2] = f636;
  HEAPF32[i405 >> 2] = f12;
  HEAPF32[i406 >> 2] = f24;
  HEAPF32[i407 >> 2] = f25;
  HEAPF32[i408 >> 2] = f26;
  HEAPF32[i409 >> 2] = f27;
  HEAPF32[i410 >> 2] = f28;
  HEAPF32[i411 >> 2] = f29;
  HEAPF32[i412 >> 2] = f30;
  if (!i413) {
   i2 = HEAP32[i618 >> 2] | 0;
   if (i2 & 536870912) {
    i68 = HEAP32[i80 >> 2] | 0;
    f684 = Math_fround(HEAPF32[i68 + 564 >> 2]);
    i66 = HEAP32[i609 >> 2] | 0;
    i69 = i66 + 693089735 | 0;
    i64 = HEAP32[i266 >> 2] | 0;
    i77 = i64 + 693089735 | 0;
    i23 = HEAP32[i267 >> 2] | 0;
    i74 = i23 + 693089735 | 0;
    i21 = HEAP32[i268 >> 2] | 0;
    i71 = i21 + 693089735 | 0;
    i22 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
    i65 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i69 = i69 << 11 ^ i69;
    i77 = i77 << 11 ^ i77;
    i74 = i74 << 11 ^ i74;
    i71 = i71 << 11 ^ i71;
    i22 = Math_fround(Math_fround((i22 ^ i69 ^ i69 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i63 = Math_fround(Math_fround((i63 ^ i77 ^ i77 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i65 = Math_fround(Math_fround((i65 ^ i74 ^ i74 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i67 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    f684 = Math_fround(HEAPF32[i68 + 568 >> 2]);
    i66 = i66 + 13945730 | 0;
    i64 = i64 + 13945730 | 0;
    i23 = i23 + 13945730 | 0;
    i21 = i21 + 13945730 | 0;
    i68 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
    i77 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
    i66 = i66 << 11 ^ i66;
    i64 = i64 << 11 ^ i64;
    i23 = i23 << 11 ^ i23;
    i21 = i21 << 11 ^ i21;
    i68 = Math_fround(Math_fround((i68 ^ i66 ^ i66 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i71 = Math_fround(Math_fround((i71 ^ i64 ^ i64 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i77 = Math_fround(Math_fround((i77 ^ i21 ^ i21 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f684;
    i21 = i22 & 1;
    i23 = i63 & 1;
    i64 = i65 & 1;
    i66 = i67 & 1;
    i69 = i22 & 1 ^ 1;
    i72 = i63 & 1 ^ 1;
    i75 = i65 & 1 ^ 1;
    i78 = i67 & 1 ^ 1;
    i70 = i22 ? 3 : 2;
    i73 = i63 ? 3 : 2;
    i76 = i65 ? 3 : 2;
    i2 = i67 ? 3 : 2;
    i22 = i22 ? 2 : 3;
    i63 = i63 ? 2 : 3;
    i65 = i65 ? 2 : 3;
    i67 = i67 ? 2 : 3;
    HEAP32[i632 >> 2] = i68 ? i22 : i21;
    HEAP32[i578 >> 2] = i71 ? i63 : i23;
    HEAP32[i577 >> 2] = i74 ? i65 : i64;
    HEAP32[i576 >> 2] = i77 ? i67 : i66;
    HEAP32[i590 >> 2] = i68 ? i21 : i22;
    HEAP32[i589 >> 2] = i71 ? i23 : i63;
    HEAP32[i588 >> 2] = i74 ? i64 : i65;
    HEAP32[i587 >> 2] = i77 ? i66 : i67;
    HEAP32[i582 >> 2] = i68 ? i70 : i69;
    HEAP32[i581 >> 2] = i71 ? i73 : i72;
    HEAP32[i580 >> 2] = i74 ? i76 : i75;
    HEAP32[i579 >> 2] = i77 ? i2 : i78;
    HEAP32[i586 >> 2] = i68 ? i69 : i70;
    HEAP32[i585 >> 2] = i71 ? i72 : i73;
    HEAP32[i584 >> 2] = i74 ? i75 : i76;
    HEAP32[i583 >> 2] = i77 ? i78 : i2;
    i2 = HEAP32[i618 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f12 = Math_fround(f621 * Math_fround(HEAPF32[i610 >> 2]));
    f24 = Math_fround(f621 * Math_fround(HEAPF32[i270 >> 2]));
    f25 = Math_fround(f621 * Math_fround(HEAPF32[i271 >> 2]));
    f26 = Math_fround(f621 * Math_fround(HEAPF32[i272 >> 2]));
    f27 = Math_fround(Math_floor(Math_fround(f12)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    f30 = Math_fround(Math_floor(Math_fround(f26)));
    if (i2 & 16777216 | 0) {
     f681 = Math_fround(Math_floor(Math_fround(f620 * f27)));
     f682 = Math_fround(Math_floor(Math_fround(f620 * f28)));
     f683 = Math_fround(Math_floor(Math_fround(f620 * f29)));
     f684 = Math_fround(Math_floor(Math_fround(f620 * f30)));
     f677 = Math_fround(f622 * Math_fround(f27 - Math_fround(f619 * f681)));
     f678 = Math_fround(f622 * Math_fround(f28 - Math_fround(f619 * f682)));
     f679 = Math_fround(f622 * Math_fround(f29 - Math_fround(f619 * f683)));
     f680 = Math_fround(f622 * Math_fround(f30 - Math_fround(f619 * f684)));
     f681 = Math_fround(f624 - Math_fround(f623 * f681));
     f682 = Math_fround(f624 - Math_fround(f623 * f682));
     f683 = Math_fround(f624 - Math_fround(f623 * f683));
     f684 = Math_fround(f624 - Math_fround(f623 * f684));
     f669 = Math_fround(f623 + f681);
     f670 = Math_fround(f623 + f682);
     f671 = Math_fround(f623 + f683);
     f672 = Math_fround(f623 + f684);
     HEAPF32[i633 >> 2] = f677;
     HEAPF32[i515 >> 2] = f678;
     HEAPF32[i539 >> 2] = f679;
     HEAPF32[i563 >> 2] = f680;
     HEAPF32[i491 >> 2] = f669;
     HEAPF32[i514 >> 2] = f670;
     HEAPF32[i538 >> 2] = f671;
     HEAPF32[i562 >> 2] = f672;
     f673 = Math_fround(f622 + f677);
     f674 = Math_fround(f622 + f678);
     f675 = Math_fround(f622 + f679);
     f676 = Math_fround(f622 + f680);
     HEAPF32[i490 >> 2] = f673;
     HEAPF32[i513 >> 2] = f674;
     HEAPF32[i537 >> 2] = f675;
     HEAPF32[i561 >> 2] = f676;
     HEAPF32[i489 >> 2] = f669;
     HEAPF32[i512 >> 2] = f670;
     HEAPF32[i536 >> 2] = f671;
     HEAPF32[i560 >> 2] = f672;
     HEAPF32[i488 >> 2] = f673;
     HEAPF32[i511 >> 2] = f674;
     HEAPF32[i535 >> 2] = f675;
     HEAPF32[i559 >> 2] = f676;
     HEAPF32[i487 >> 2] = f681;
     HEAPF32[i510 >> 2] = f682;
     HEAPF32[i534 >> 2] = f683;
     HEAPF32[i558 >> 2] = f684;
     HEAPF32[i486 >> 2] = f677;
     HEAPF32[i509 >> 2] = f678;
     HEAPF32[i533 >> 2] = f679;
     HEAPF32[i557 >> 2] = f680;
     HEAPF32[i485 >> 2] = f681;
     HEAPF32[i508 >> 2] = f682;
     HEAPF32[i532 >> 2] = f683;
     HEAPF32[i556 >> 2] = f684;
    }
    if (i2 & 33554432 | 0) {
     f673 = Math_fround(f27 + Math_fround(1.0));
     f674 = Math_fround(f28 + Math_fround(1.0));
     f675 = Math_fround(f29 + Math_fround(1.0));
     f676 = Math_fround(f30 + Math_fround(1.0));
     f681 = Math_fround(f12 - f27);
     f682 = Math_fround(f24 - f28);
     f683 = Math_fround(f25 - f29);
     f684 = Math_fround(f26 - f30);
     f677 = Math_fround(Math_floor(Math_fround(f620 * f673)));
     f678 = Math_fround(Math_floor(Math_fround(f620 * f674)));
     f679 = Math_fround(Math_floor(Math_fround(f620 * f675)));
     f680 = Math_fround(Math_floor(Math_fround(f620 * f676)));
     f673 = Math_fround(f622 * Math_fround(f673 - Math_fround(f619 * f677)));
     f674 = Math_fround(f622 * Math_fround(f674 - Math_fround(f619 * f678)));
     f675 = Math_fround(f622 * Math_fround(f675 - Math_fround(f619 * f679)));
     f676 = Math_fround(f622 * Math_fround(f676 - Math_fround(f619 * f680)));
     f677 = Math_fround(f624 - Math_fround(f623 * f677));
     f678 = Math_fround(f624 - Math_fround(f623 * f678));
     f679 = Math_fround(f624 - Math_fround(f623 * f679));
     f680 = Math_fround(f624 - Math_fround(f623 * f680));
     f665 = Math_fround(f623 + f677);
     f666 = Math_fround(f623 + f678);
     f667 = Math_fround(f623 + f679);
     f668 = Math_fround(f623 + f680);
     HEAPF32[i634 >> 2] = f673;
     HEAPF32[i507 >> 2] = f674;
     HEAPF32[i531 >> 2] = f675;
     HEAPF32[i555 >> 2] = f676;
     HEAPF32[i484 >> 2] = f665;
     HEAPF32[i506 >> 2] = f666;
     HEAPF32[i530 >> 2] = f667;
     HEAPF32[i554 >> 2] = f668;
     HEAPF32[i483 >> 2] = f681;
     HEAPF32[i505 >> 2] = f682;
     HEAPF32[i529 >> 2] = f683;
     HEAPF32[i553 >> 2] = f684;
     HEAPF32[i482 >> 2] = f12;
     HEAPF32[i504 >> 2] = f24;
     HEAPF32[i528 >> 2] = f25;
     HEAPF32[i552 >> 2] = f26;
     f669 = Math_fround(f622 + f673);
     f670 = Math_fround(f622 + f674);
     f671 = Math_fround(f622 + f675);
     f672 = Math_fround(f622 + f676);
     HEAPF32[i481 >> 2] = f669;
     HEAPF32[i503 >> 2] = f670;
     HEAPF32[i527 >> 2] = f671;
     HEAPF32[i551 >> 2] = f672;
     HEAPF32[i480 >> 2] = f665;
     HEAPF32[i502 >> 2] = f666;
     HEAPF32[i526 >> 2] = f667;
     HEAPF32[i550 >> 2] = f668;
     HEAPF32[i479 >> 2] = f681;
     HEAPF32[i501 >> 2] = f682;
     HEAPF32[i525 >> 2] = f683;
     HEAPF32[i549 >> 2] = f684;
     HEAPF32[i478 >> 2] = f12;
     HEAPF32[i500 >> 2] = f24;
     HEAPF32[i524 >> 2] = f25;
     HEAPF32[i548 >> 2] = f26;
     HEAPF32[i477 >> 2] = f669;
     HEAPF32[i499 >> 2] = f670;
     HEAPF32[i523 >> 2] = f671;
     HEAPF32[i547 >> 2] = f672;
     HEAPF32[i476 >> 2] = f677;
     HEAPF32[i498 >> 2] = f678;
     HEAPF32[i522 >> 2] = f679;
     HEAPF32[i546 >> 2] = f680;
     HEAPF32[i475 >> 2] = f681;
     HEAPF32[i497 >> 2] = f682;
     HEAPF32[i521 >> 2] = f683;
     HEAPF32[i545 >> 2] = f684;
     HEAPF32[i474 >> 2] = f12;
     HEAPF32[i496 >> 2] = f24;
     HEAPF32[i520 >> 2] = f25;
     HEAPF32[i544 >> 2] = f26;
     HEAPF32[i473 >> 2] = f673;
     HEAPF32[i495 >> 2] = f674;
     HEAPF32[i519 >> 2] = f675;
     HEAPF32[i543 >> 2] = f676;
     HEAPF32[i472 >> 2] = f677;
     HEAPF32[i494 >> 2] = f678;
     HEAPF32[i518 >> 2] = f679;
     HEAPF32[i542 >> 2] = f680;
     HEAPF32[i471 >> 2] = f681;
     HEAPF32[i493 >> 2] = f682;
     HEAPF32[i517 >> 2] = f683;
     HEAPF32[i541 >> 2] = f684;
     HEAPF32[i470 >> 2] = f12;
     HEAPF32[i492 >> 2] = f24;
     HEAPF32[i516 >> 2] = f25;
     HEAPF32[i540 >> 2] = f26;
    }
   }
  }
  f669 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f43 * f43)) + Math_fround(f47 * f47)))));
  f670 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f44 * f44)) + Math_fround(f48 * f48)))));
  f671 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f45 * f45)) + Math_fround(f49 * f49)))));
  f672 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f46 * f46)) + Math_fround(f50 * f50)))));
  f661 = Math_fround(f626 * Math_fround(f39 * f669));
  f662 = Math_fround(f626 * Math_fround(f40 * f670));
  f663 = Math_fround(f626 * Math_fround(f41 * f671));
  f664 = Math_fround(f626 * Math_fround(f42 * f672));
  f665 = Math_fround(f626 * Math_fround(f43 * f669));
  f666 = Math_fround(f626 * Math_fround(f44 * f670));
  f667 = Math_fround(f626 * Math_fround(f45 * f671));
  f668 = Math_fround(f626 * Math_fround(f46 * f672));
  f669 = Math_fround(f626 * Math_fround(f47 * f669));
  f670 = Math_fround(f626 * Math_fround(f48 * f670));
  f671 = Math_fround(f626 * Math_fround(f49 * f671));
  f672 = Math_fround(f626 * Math_fround(f50 * f672));
  f681 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(f55 * f55)) + Math_fround(f59 * f59)))));
  f682 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f56 * f56)) + Math_fround(f60 * f60)))));
  f683 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f57 * f57)) + Math_fround(f61 * f61)))));
  f684 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f62 * f62)))));
  f673 = Math_fround(f626 * Math_fround(f51 * f681));
  f674 = Math_fround(f626 * Math_fround(f52 * f682));
  f675 = Math_fround(f626 * Math_fround(f53 * f683));
  f676 = Math_fround(f626 * Math_fround(f54 * f684));
  f677 = Math_fround(f626 * Math_fround(f55 * f681));
  f678 = Math_fround(f626 * Math_fround(f56 * f682));
  f679 = Math_fround(f626 * Math_fround(f57 * f683));
  f680 = Math_fround(f626 * Math_fround(f58 * f684));
  f681 = Math_fround(f626 * Math_fround(f59 * f681));
  f682 = Math_fround(f626 * Math_fround(f60 * f682));
  f683 = Math_fround(f626 * Math_fround(f61 * f683));
  f684 = Math_fround(f626 * Math_fround(f62 * f684));
  f660 = Math_fround(f599 + f662);
  f659 = Math_fround(f599 + f663);
  f658 = Math_fround(f599 + f664);
  f657 = Math_fround(f593 + f665);
  f656 = Math_fround(f593 + f666);
  f655 = Math_fround(f593 + f667);
  f654 = Math_fround(f593 + f668);
  f653 = Math_fround(f595 + f669);
  f652 = Math_fround(f595 + f670);
  f651 = Math_fround(f595 + f671);
  f650 = Math_fround(f595 + f672);
  HEAPF32[i613 >> 2] = Math_fround(f599 + f661);
  HEAPF32[i141 >> 2] = f660;
  HEAPF32[i158 >> 2] = f659;
  HEAPF32[i175 >> 2] = f658;
  HEAPF32[i414 >> 2] = f657;
  HEAPF32[i136 >> 2] = f656;
  HEAPF32[i153 >> 2] = f655;
  HEAPF32[i170 >> 2] = f654;
  HEAPF32[i415 >> 2] = f653;
  HEAPF32[i131 >> 2] = f652;
  HEAPF32[i148 >> 2] = f651;
  HEAPF32[i165 >> 2] = f650;
  f650 = Math_fround(f599 + f674);
  f651 = Math_fround(f599 + f675);
  f652 = Math_fround(f599 + f676);
  f653 = Math_fround(f593 + f677);
  f654 = Math_fround(f593 + f678);
  f655 = Math_fround(f593 + f679);
  f656 = Math_fround(f593 + f680);
  f657 = Math_fround(f595 + f681);
  f658 = Math_fround(f595 + f682);
  f659 = Math_fround(f595 + f683);
  f660 = Math_fround(f595 + f684);
  HEAPF32[i416 >> 2] = Math_fround(f599 + f673);
  HEAPF32[i140 >> 2] = f650;
  HEAPF32[i157 >> 2] = f651;
  HEAPF32[i174 >> 2] = f652;
  HEAPF32[i417 >> 2] = f653;
  HEAPF32[i135 >> 2] = f654;
  HEAPF32[i152 >> 2] = f655;
  HEAPF32[i169 >> 2] = f656;
  HEAPF32[i418 >> 2] = f657;
  HEAPF32[i130 >> 2] = f658;
  HEAPF32[i147 >> 2] = f659;
  HEAPF32[i164 >> 2] = f660;
  f662 = Math_fround(f599 - f662);
  f663 = Math_fround(f599 - f663);
  f664 = Math_fround(f599 - f664);
  f665 = Math_fround(f593 - f665);
  f666 = Math_fround(f593 - f666);
  f667 = Math_fround(f593 - f667);
  f668 = Math_fround(f593 - f668);
  f669 = Math_fround(f595 - f669);
  f670 = Math_fround(f595 - f670);
  f671 = Math_fround(f595 - f671);
  f672 = Math_fround(f595 - f672);
  HEAPF32[i419 >> 2] = Math_fround(f599 - f661);
  HEAPF32[i139 >> 2] = f662;
  HEAPF32[i156 >> 2] = f663;
  HEAPF32[i173 >> 2] = f664;
  HEAPF32[i420 >> 2] = f665;
  HEAPF32[i134 >> 2] = f666;
  HEAPF32[i151 >> 2] = f667;
  HEAPF32[i168 >> 2] = f668;
  HEAPF32[i421 >> 2] = f669;
  HEAPF32[i129 >> 2] = f670;
  HEAPF32[i146 >> 2] = f671;
  HEAPF32[i163 >> 2] = f672;
  f674 = Math_fround(f599 - f674);
  f675 = Math_fround(f599 - f675);
  f676 = Math_fround(f599 - f676);
  f677 = Math_fround(f593 - f677);
  f678 = Math_fround(f593 - f678);
  f679 = Math_fround(f593 - f679);
  f680 = Math_fround(f593 - f680);
  f681 = Math_fround(f595 - f681);
  f682 = Math_fround(f595 - f682);
  f683 = Math_fround(f595 - f683);
  f684 = Math_fround(f595 - f684);
  HEAPF32[i422 >> 2] = Math_fround(f599 - f673);
  HEAPF32[i138 >> 2] = f674;
  HEAPF32[i155 >> 2] = f675;
  HEAPF32[i172 >> 2] = f676;
  HEAPF32[i423 >> 2] = f677;
  HEAPF32[i133 >> 2] = f678;
  HEAPF32[i150 >> 2] = f679;
  HEAPF32[i167 >> 2] = f680;
  HEAPF32[i424 >> 2] = f681;
  HEAPF32[i128 >> 2] = f682;
  HEAPF32[i145 >> 2] = f683;
  HEAPF32[i162 >> 2] = f684;
  do if (i206) {
   i4 = HEAP32[i239 >> 2] | 0;
   i5 = HEAP32[i630 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i78 = i5 + (i2 + i79 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i611 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i81 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i82 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i613 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i83 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i84 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i85 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i86 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i416 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i389 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i401 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i78 >> 2];
     i78 = i633 + (HEAP32[i632 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i78 = i5 + (HEAP32[i4 + (i2 + i79 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i611 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i613 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i416 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i389 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i78 >> 2];
     i77 = i633 + (HEAP32[i632 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i401 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i78 >> 2];
     i78 = i633 + (HEAP32[i632 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f672 = Math_fround(HEAPF32[i377 >> 2]);
   f672 = Math_fround(f672 - Math_fround(HEAPF32[i611 >> 2]));
   f674 = Math_fround(HEAPF32[i378 >> 2]);
   f674 = Math_fround(f674 - Math_fround(HEAPF32[i366 >> 2]));
   f675 = Math_fround(HEAPF32[i379 >> 2]);
   f675 = Math_fround(f675 - Math_fround(HEAPF32[i367 >> 2]));
   f676 = Math_fround(HEAPF32[i380 >> 2]);
   f676 = Math_fround(f676 - Math_fround(HEAPF32[i368 >> 2]));
   f677 = Math_fround(HEAPF32[i381 >> 2]);
   f677 = Math_fround(f677 - Math_fround(HEAPF32[i369 >> 2]));
   f684 = Math_fround(HEAPF32[i382 >> 2]);
   f684 = Math_fround(f684 - Math_fround(HEAPF32[i370 >> 2]));
   f683 = Math_fround(HEAPF32[i383 >> 2]);
   f683 = Math_fround(f683 - Math_fround(HEAPF32[i371 >> 2]));
   f682 = Math_fround(HEAPF32[i384 >> 2]);
   f682 = Math_fround(f682 - Math_fround(HEAPF32[i372 >> 2]));
   f681 = Math_fround(HEAPF32[i385 >> 2]);
   f681 = Math_fround(f681 - Math_fround(HEAPF32[i373 >> 2]));
   f669 = Math_fround(HEAPF32[i386 >> 2]);
   f669 = Math_fround(f669 - Math_fround(HEAPF32[i374 >> 2]));
   f670 = Math_fround(HEAPF32[i387 >> 2]);
   f670 = Math_fround(f670 - Math_fround(HEAPF32[i375 >> 2]));
   f671 = Math_fround(HEAPF32[i388 >> 2]);
   f671 = Math_fround(f671 - Math_fround(HEAPF32[i376 >> 2]));
   f673 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f672 * f672) + Math_fround(f677 * f677)) + Math_fround(f681 * f681)))));
   f680 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f674 * f674) + Math_fround(f684 * f684)) + Math_fround(f669 * f669)))));
   f679 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f675 * f675) + Math_fround(f683 * f683)) + Math_fround(f670 * f670)))));
   f678 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f676 * f676) + Math_fround(f682 * f682)) + Math_fround(f671 * f671)))));
   f674 = Math_fround(f674 * f680);
   f675 = Math_fround(f675 * f679);
   f676 = Math_fround(f676 * f678);
   f677 = Math_fround(f677 * f673);
   f684 = Math_fround(f684 * f680);
   f683 = Math_fround(f683 * f679);
   f682 = Math_fround(f682 * f678);
   f681 = Math_fround(f681 * f673);
   f680 = Math_fround(f669 * f680);
   f679 = Math_fround(f670 * f679);
   f678 = Math_fround(f671 * f678);
   HEAPF32[i614 >> 2] = Math_fround(f672 * f673);
   HEAPF32[i142 >> 2] = f674;
   HEAPF32[i159 >> 2] = f675;
   HEAPF32[i176 >> 2] = f676;
   HEAPF32[i425 >> 2] = f677;
   HEAPF32[i137 >> 2] = f684;
   HEAPF32[i154 >> 2] = f683;
   HEAPF32[i171 >> 2] = f682;
   HEAPF32[i426 >> 2] = f681;
   HEAPF32[i132 >> 2] = f680;
   HEAPF32[i149 >> 2] = f679;
   HEAPF32[i166 >> 2] = f678;
   f678 = Math_fround(f32 * Math_fround(2.0));
   f679 = Math_fround(f33 * Math_fround(2.0));
   f680 = Math_fround(f34 * Math_fround(2.0));
   f681 = Math_fround(f35 * Math_fround(2.0));
   f682 = Math_fround(f36 * Math_fround(2.0));
   f683 = Math_fround(f37 * Math_fround(2.0));
   f684 = Math_fround(f38 * Math_fround(2.0));
   HEAPF32[i615 >> 2] = Math_fround(f31 * Math_fround(2.0));
   HEAPF32[i144 >> 2] = f678;
   HEAPF32[i161 >> 2] = f679;
   HEAPF32[i178 >> 2] = f680;
   HEAPF32[i427 >> 2] = f681;
   HEAPF32[i143 >> 2] = f682;
   HEAPF32[i160 >> 2] = f683;
   HEAPF32[i177 >> 2] = f684;
   HEAP32[i127 >> 2] = 0;
   HEAP32[i127 + 4 >> 2] = 0;
   HEAP32[i127 + 8 >> 2] = 0;
   HEAP32[i127 + 12 >> 2] = 0;
   if (i428) {
    f664 = Math_fround(HEAPF32[i605 >> 2]);
    f682 = Math_fround(f564 * f664);
    f666 = Math_fround(HEAPF32[i232 >> 2]);
    f673 = Math_fround(f564 * f666);
    f668 = Math_fround(HEAPF32[i231 >> 2]);
    f681 = Math_fround(f564 * f668);
    f670 = Math_fround(HEAPF32[i230 >> 2]);
    f676 = Math_fround(f564 * f670);
    f665 = Math_fround(HEAPF32[i429 >> 2]);
    f672 = Math_fround(f567 * f665);
    f667 = Math_fround(HEAPF32[i235 >> 2]);
    f678 = Math_fround(f567 * f667);
    f669 = Math_fround(HEAPF32[i234 >> 2]);
    f677 = Math_fround(f567 * f669);
    f671 = Math_fround(HEAPF32[i233 >> 2]);
    f672 = Math_fround(f682 + f672);
    f678 = Math_fround(f673 + f678);
    f677 = Math_fround(f681 + f677);
    f676 = Math_fround(f676 + Math_fround(f567 * f671));
    f681 = Math_fround(HEAPF32[i430 >> 2]);
    f673 = Math_fround(f570 * f681);
    f682 = Math_fround(HEAPF32[i238 >> 2]);
    f674 = Math_fround(f570 * f682);
    f683 = Math_fround(HEAPF32[i237 >> 2]);
    f675 = Math_fround(f570 * f683);
    f684 = Math_fround(HEAPF32[i236 >> 2]);
    f674 = Math_fround(f678 + f674);
    f675 = Math_fround(f677 + f675);
    f676 = Math_fround(f676 + Math_fround(f570 * f684));
    f677 = Math_fround(Math_fround(Math_fround(f565 * f664) + Math_fround(f568 * f665)) + Math_fround(f571 * f681));
    f678 = Math_fround(Math_fround(Math_fround(f565 * f666) + Math_fround(f568 * f667)) + Math_fround(f571 * f682));
    f679 = Math_fround(Math_fround(Math_fround(f565 * f668) + Math_fround(f568 * f669)) + Math_fround(f571 * f683));
    f680 = Math_fround(Math_fround(Math_fround(f565 * f670) + Math_fround(f568 * f671)) + Math_fround(f571 * f684));
    f681 = Math_fround(Math_fround(Math_fround(f566 * f664) + Math_fround(f569 * f665)) + Math_fround(f572 * f681));
    f682 = Math_fround(Math_fround(Math_fround(f566 * f666) + Math_fround(f569 * f667)) + Math_fround(f572 * f682));
    f683 = Math_fround(Math_fround(Math_fround(f566 * f668) + Math_fround(f569 * f669)) + Math_fround(f572 * f683));
    f684 = Math_fround(Math_fround(Math_fround(f566 * f670) + Math_fround(f569 * f671)) + Math_fround(f572 * f684));
    HEAPF32[i616 >> 2] = Math_fround(f672 + f673);
    HEAPF32[i431 >> 2] = f674;
    HEAPF32[i432 >> 2] = f675;
    HEAPF32[i433 >> 2] = f676;
    HEAPF32[i434 >> 2] = f677;
    HEAPF32[i435 >> 2] = f678;
    HEAPF32[i436 >> 2] = f679;
    HEAPF32[i437 >> 2] = f680;
    HEAPF32[i438 >> 2] = f681;
    HEAPF32[i439 >> 2] = f682;
    HEAPF32[i440 >> 2] = f683;
    HEAPF32[i441 >> 2] = f684;
   }
   if (i442) {
    i72 = HEAP32[i609 >> 2] | 0;
    i75 = i72 + 1068538453 | 0;
    i76 = HEAP32[i266 >> 2] | 0;
    i74 = i76 + 1068538453 | 0;
    i69 = HEAP32[i267 >> 2] | 0;
    i68 = i69 + 1068538453 | 0;
    i67 = HEAP32[i268 >> 2] | 0;
    i71 = i67 + 1068538453 | 0;
    i77 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
    i78 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i73 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i75 = i75 << 11 ^ i75;
    i74 = i74 << 11 ^ i74;
    i68 = i68 << 11 ^ i68;
    i71 = i71 << 11 ^ i71;
    f682 = Math_fround(Math_fround((i70 ^ i74 ^ i74 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f683 = Math_fround(Math_fround((i78 ^ i68 ^ i68 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f684 = Math_fround(Math_fround((i73 ^ i71 ^ i71 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i617 >> 2] = Math_fround(Math_fround((i77 ^ i75 ^ i75 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i443 >> 2] = f682;
    HEAPF32[i444 >> 2] = f683;
    HEAPF32[i445 >> 2] = f684;
    i72 = i72 + 1068538454 | 0;
    i76 = i76 + 1068538454 | 0;
    i69 = i69 + 1068538454 | 0;
    i67 = i67 + 1068538454 | 0;
    i77 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
    i75 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
    i73 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i72 = i72 << 11 ^ i72;
    i76 = i76 << 11 ^ i76;
    i69 = i69 << 11 ^ i69;
    i67 = i67 << 11 ^ i67;
    f684 = Math_fround(Math_fround((i75 ^ i76 ^ i76 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f683 = Math_fround(Math_fround((i73 ^ i69 ^ i69 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f682 = Math_fround(Math_fround((i71 ^ i67 ^ i67 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i446 >> 2] = Math_fround(Math_fround((i77 ^ i72 ^ i72 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i447 >> 2] = f684;
    HEAPF32[i448 >> 2] = f683;
    HEAPF32[i449 >> 2] = f682;
    i77 = HEAP32[i609 >> 2] | 0;
    i72 = i77 + 1068538455 | 0;
    i71 = HEAP32[i266 >> 2] | 0;
    i67 = i71 + 1068538455 | 0;
    i73 = HEAP32[i267 >> 2] | 0;
    i69 = i73 + 1068538455 | 0;
    i75 = HEAP32[i268 >> 2] | 0;
    i76 = i75 + 1068538455 | 0;
    i78 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
    i68 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
    i72 = i72 << 11 ^ i72;
    i67 = i67 << 11 ^ i67;
    i69 = i69 << 11 ^ i69;
    i76 = i76 << 11 ^ i76;
    f682 = Math_fround(Math_fround((i68 ^ i67 ^ i67 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f683 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f684 = Math_fround(Math_fround((i74 ^ i76 ^ i76 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i450 >> 2] = Math_fround(Math_fround((i78 ^ i72 ^ i72 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i451 >> 2] = f682;
    HEAPF32[i452 >> 2] = f683;
    HEAPF32[i453 >> 2] = f684;
    f684 = Math_fround(Math_fround(HEAPF32[i608 >> 2]) * Math_fround(1.0e5));
    f683 = Math_fround(Math_fround(HEAPF32[i262 >> 2]) * Math_fround(1.0e5));
    f682 = Math_fround(Math_fround(HEAPF32[i263 >> 2]) * Math_fround(1.0e5));
    i77 = i77 + 1068538453 + ~~f684 | 0;
    i71 = i71 + 1068538453 + ~~f683 | 0;
    i73 = i73 + 1068538453 + ~~f682 | 0;
    i75 = i75 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i264 >> 2]) * Math_fround(1.0e5)) | 0;
    i78 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
    i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
    i76 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
    i77 = i77 << 11 ^ i77;
    i71 = i71 << 11 ^ i71;
    i73 = i73 << 11 ^ i73;
    i75 = i75 << 11 ^ i75;
    f682 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f683 = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f684 = Math_fround(Math_fround((i76 ^ i75 ^ i75 >>> 8) & 8388607 ^ i76 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = Math_fround(Math_fround((i78 ^ i77 ^ i77 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i455 >> 2] = f682;
    HEAPF32[i456 >> 2] = f683;
    HEAPF32[i457 >> 2] = f684;
   }
   i69 = HEAP32[i239 >> 2] | 0;
   i70 = (i69 | 0) == 0;
   i71 = HEAP32[i119 >> 2] | 0;
   i72 = HEAP32[i121 >> 2] | 0;
   i73 = HEAP32[i261 >> 2] | 0;
   i74 = HEAP32[i122 >> 2] | 0;
   i75 = HEAP32[i242 >> 2] | 0;
   i76 = HEAP32[i243 >> 2] | 0;
   i77 = HEAP32[i244 >> 2] | 0;
   i78 = HEAP32[i630 >> 2] | 0;
   i68 = 0;
   do {
    i2 = i68 + i79 | 0;
    if (!i70) i2 = HEAP32[i69 + (i2 << 3) >> 2] | 0;
    i5 = i616 + (i68 << 2) | 0;
    i6 = i465 + (i68 << 2) | 0;
    i7 = i466 + (i68 << 2) | 0;
    i8 = i617 + (i68 << 2) | 0;
    i9 = i446 + (i68 << 2) | 0;
    i10 = i450 + (i68 << 2) | 0;
    i11 = i454 + (i68 << 2) | 0;
    i13 = i614 + (i68 << 2) | 0;
    i14 = i116 + (i68 << 2) | 0;
    i15 = i117 + (i68 << 2) | 0;
    i16 = i71 + (i2 << 4) | 0;
    i17 = i72 + (i2 << 4) | 0;
    i18 = i73 + (i2 << 2) | 0;
    i19 = i74 + (i2 << 2) | 0;
    i20 = i75 + (i2 << 2) | 0;
    i21 = i76 + (i2 << 2) | 0;
    i22 = i77 + (i2 << 2) | 0;
    i23 = i615 + (i68 << 2) | 0;
    i63 = i123 + (i68 << 2) | 0;
    i64 = i124 + (i68 << 2) | 0;
    i65 = i612 + (i68 << 2) | 0;
    i66 = i125 + (i68 << 2) | 0;
    i67 = i126 + (i68 << 2) | 0;
    i4 = i78 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i611 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i68 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i68 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i68 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i458) {
      i685 = i613 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i685 + (i68 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i685 + 16 + (i68 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i685 + 32 + (i68 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i459) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i460) {
      i685 = i633 + (HEAP32[i632 + ((i3 << 2) + i68 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i685 + (i68 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i685 + 16 + (i68 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i461) {
      i685 = i634 + (HEAP32[i632 + ((i3 << 2) + i68 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i685 + (i68 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i685 + 16 + (i68 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i685 + 32 + (i68 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i685 + 48 + (i68 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i462) {
      f684 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i65 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i66 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i67 >> 2];
      HEAPF32[i1 + 12 >> 2] = f684;
      i1 = i1 + 16 | 0;
     }
     if (!i463) {
      HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i63 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i64 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i464) {
      i2 = HEAP32[i21 >> 2] | 0;
      i685 = HEAP32[i22 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = i2;
      HEAP32[i1 + 8 >> 2] = i685;
      i1 = i1 + 12 | 0;
     }
     if (i428) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i467) {
      f684 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.00999999977));
      i685 = HEAP32[i19 >> 2] | 0;
      HEAPF32[i1 >> 2] = f684;
      HEAP32[i1 + 4 >> 2] = i685;
      i1 = i1 + 8 | 0;
     }
     if (!i468) {
      i685 = (HEAP32[i120 >> 2] & 2147483647 | 0) == 0 ? i602 : i17;
      HEAP32[i1 >> 2] = HEAP32[i685 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i685 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i685 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i685 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i469) {
      i685 = (HEAP32[i118 >> 2] & 2147483647 | 0) == 0 ? i602 : i16;
      HEAP32[i1 >> 2] = HEAP32[i685 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i685 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i685 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i685 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i442) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i115) {
      HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i15 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i68 = i68 + 1 | 0;
   } while ((i68 | 0) != 4);
  } while (0);
  i79 = i79 + 4 | 0;
 } while (i79 >>> 0 < i207 >>> 0);
 STACKTOP = i635;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i633, i638) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i633 = i633 | 0;
 i638 = i638 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, i564 = 0, i565 = 0, i566 = 0, i567 = 0, i568 = 0, i569 = 0, i570 = 0, i571 = 0, i572 = 0, i573 = 0, i574 = 0, i575 = 0, f576 = f0, f577 = f0, f578 = f0, f579 = f0, f580 = f0, f581 = f0, f582 = f0, f583 = f0, f584 = f0, f585 = f0, f586 = f0, f587 = f0, f588 = f0, f589 = f0, f590 = f0, f591 = f0, f592 = f0, f593 = f0, i594 = 0, i595 = 0, i596 = 0, i597 = 0, i598 = 0, i599 = 0, f600 = f0, f601 = f0, f602 = f0, f603 = f0, f604 = f0, f605 = f0, f606 = f0, f607 = f0, f608 = f0, f609 = f0, i610 = 0, i611 = 0, i612 = 0, i613 = 0, i614 = 0, i615 = 0, i616 = 0, i617 = 0, i618 = 0, i619 = 0, i620 = 0, i621 = 0, i622 = 0, i623 = 0, i624 = 0, i625 = 0, i626 = 0, f627 = f0, f628 = f0, f629 = f0, f630 = f0, f631 = f0, f632 = f0, f634 = f0, f635 = f0, f636 = f0, f637 = f0, f639 = f0, i640 = 0, i641 = 0, i642 = 0, i643 = 0, f644 = f0, f645 = f0, f646 = f0, f647 = f0, f648 = f0, f649 = f0, f650 = f0, f651 = f0, f652 = f0, f653 = f0, f654 = f0, f655 = f0, f656 = f0, f657 = f0, f658 = f0, f659 = f0, f660 = f0, f661 = f0, f662 = f0, f663 = f0, f664 = f0, f665 = f0, f666 = f0, f667 = f0, f668 = f0, f669 = f0, f670 = f0, f671 = f0, f672 = f0, f673 = f0, f674 = f0, f675 = f0, f676 = f0, f677 = f0, f678 = f0, f679 = f0, f680 = f0, f681 = f0, f682 = f0, f683 = f0, f684 = f0, f685 = f0, f686 = f0, f687 = f0, i688 = 0;
 i643 = STACKTOP;
 STACKTOP = STACKTOP + 1632 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i640 = i643 + 1560 | 0;
 i641 = i643 + 1432 | 0;
 i642 = i643 + 1176 | 0;
 i6 = i643 + 1112 | 0;
 i4 = i643 + 1072 | 0;
 i610 = i643 + 1056 | 0;
 i611 = i643 + 1008 | 0;
 i612 = i643 + 960 | 0;
 i613 = i643 + 912 | 0;
 i614 = i643 + 896 | 0;
 i615 = i643 + 880 | 0;
 i616 = i643 + 864 | 0;
 i617 = i643 + 848 | 0;
 i618 = i643 + 832 | 0;
 i619 = i643 + 640 | 0;
 i620 = i643 + 592 | 0;
 i621 = i643 + 400 | 0;
 i622 = i643 + 256 | 0;
 i623 = i643 + 112 | 0;
 i624 = i643 + 64 | 0;
 i625 = i643;
 i626 = i3 + 332 | 0;
 f627 = Math_fround((HEAP32[i626 >> 2] & 4095) >>> 0);
 f628 = Math_fround(Math_fround(1.0) / f627);
 f629 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f630 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f631 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f632 = Math_fround(Math_fround(1.0) - f631);
 i5 = i3 + 420 | 0;
 f634 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f608 = Math_fround(HEAPF32[i2 >> 2]);
 f602 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f604 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f635 = Math_fround(HEAPF32[i2 >> 2]);
 f636 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f637 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f639 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f607 = Math_fround(HEAPF32[i2 >> 2]);
 f601 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f606 = Math_fround(HEAPF32[i2 >> 2]);
 f600 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 36 | 0;
 f609 = Math_fround(HEAPF32[i7 >> 2]);
 f603 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f605 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f576 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f577 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f578 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f579 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f580 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f581 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f582 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f583 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f584 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f585 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f586 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f587 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 f588 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f589 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f590 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f591 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f592 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f593 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 i594 = i640 + 12 | 0;
 i595 = i640 + 8 | 0;
 i596 = i640 + 4 | 0;
 i597 = i640 + 28 | 0;
 HEAP32[i640 >> 2] = 0;
 HEAP32[i640 + 4 >> 2] = 0;
 HEAP32[i640 + 8 >> 2] = 0;
 HEAP32[i640 + 12 >> 2] = 0;
 HEAP32[i597 >> 2] = 1;
 i598 = i640 + 24 | 0;
 HEAP32[i598 >> 2] = 1;
 i599 = i640 + 20 | 0;
 HEAP32[i599 >> 2] = 1;
 i567 = i640 + 16 | 0;
 HEAP32[i567 >> 2] = 1;
 i568 = i640 + 44 | 0;
 HEAP32[i568 >> 2] = 2;
 i569 = i640 + 40 | 0;
 HEAP32[i569 >> 2] = 2;
 i570 = i640 + 36 | 0;
 HEAP32[i570 >> 2] = 2;
 i571 = i640 + 32 | 0;
 HEAP32[i571 >> 2] = 2;
 i572 = i640 + 60 | 0;
 HEAP32[i572 >> 2] = 3;
 i573 = i640 + 56 | 0;
 HEAP32[i573 >> 2] = 3;
 i574 = i640 + 52 | 0;
 HEAP32[i574 >> 2] = 3;
 i575 = i640 + 48 | 0;
 HEAP32[i575 >> 2] = 3;
 i518 = i641 + 4 | 0;
 i542 = i641 + 8 | 0;
 i566 = i641 + 12 | 0;
 i494 = i641 + 16 | 0;
 HEAP32[i641 >> 2] = 0;
 HEAP32[i641 + 4 >> 2] = 0;
 HEAP32[i641 + 8 >> 2] = 0;
 HEAP32[i641 + 12 >> 2] = 0;
 HEAPF32[i494 >> 2] = Math_fround(1.0);
 i517 = i641 + 20 | 0;
 HEAPF32[i517 >> 2] = Math_fround(1.0);
 i541 = i641 + 24 | 0;
 HEAPF32[i541 >> 2] = Math_fround(1.0);
 i565 = i641 + 28 | 0;
 HEAPF32[i565 >> 2] = Math_fround(1.0);
 i493 = i641 + 32 | 0;
 HEAPF32[i493 >> 2] = Math_fround(1.0);
 i516 = i641 + 36 | 0;
 HEAPF32[i516 >> 2] = Math_fround(1.0);
 i540 = i641 + 40 | 0;
 HEAPF32[i540 >> 2] = Math_fround(1.0);
 i564 = i641 + 44 | 0;
 HEAPF32[i564 >> 2] = Math_fround(1.0);
 i492 = i641 + 48 | 0;
 HEAPF32[i492 >> 2] = Math_fround(1.0);
 i515 = i641 + 52 | 0;
 HEAPF32[i515 >> 2] = Math_fround(1.0);
 i539 = i641 + 56 | 0;
 HEAPF32[i539 >> 2] = Math_fround(1.0);
 i563 = i641 + 60 | 0;
 HEAPF32[i563 >> 2] = Math_fround(1.0);
 i491 = i641 + 64 | 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i514 = i641 + 68 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i641 + 72 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i641 + 76 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i490 = i641 + 80 | 0;
 i513 = i641 + 84 | 0;
 i537 = i641 + 88 | 0;
 i561 = i641 + 92 | 0;
 i489 = i641 + 96 | 0;
 i512 = i641 + 100 | 0;
 i536 = i641 + 104 | 0;
 i560 = i641 + 108 | 0;
 i488 = i641 + 112 | 0;
 i511 = i641 + 116 | 0;
 i535 = i641 + 120 | 0;
 i559 = i641 + 124 | 0;
 i10 = i490;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i510 = i642 + 4 | 0;
 i534 = i642 + 8 | 0;
 i558 = i642 + 12 | 0;
 i487 = i642 + 16 | 0;
 HEAP32[i642 >> 2] = 0;
 HEAP32[i642 + 4 >> 2] = 0;
 HEAP32[i642 + 8 >> 2] = 0;
 HEAP32[i642 + 12 >> 2] = 0;
 HEAPF32[i487 >> 2] = Math_fround(1.0);
 i509 = i642 + 20 | 0;
 HEAPF32[i509 >> 2] = Math_fround(1.0);
 i533 = i642 + 24 | 0;
 HEAPF32[i533 >> 2] = Math_fround(1.0);
 i557 = i642 + 28 | 0;
 HEAPF32[i557 >> 2] = Math_fround(1.0);
 i486 = i642 + 32 | 0;
 i508 = i642 + 36 | 0;
 i532 = i642 + 40 | 0;
 i556 = i642 + 44 | 0;
 i485 = i642 + 48 | 0;
 i507 = i642 + 52 | 0;
 i531 = i642 + 56 | 0;
 i555 = i642 + 60 | 0;
 i484 = i642 + 64 | 0;
 HEAP32[i486 >> 2] = 0;
 HEAP32[i486 + 4 >> 2] = 0;
 HEAP32[i486 + 8 >> 2] = 0;
 HEAP32[i486 + 12 >> 2] = 0;
 HEAP32[i486 + 16 >> 2] = 0;
 HEAP32[i486 + 20 >> 2] = 0;
 HEAP32[i486 + 24 >> 2] = 0;
 HEAP32[i486 + 28 >> 2] = 0;
 HEAPF32[i484 >> 2] = Math_fround(1.0);
 i506 = i642 + 68 | 0;
 HEAPF32[i506 >> 2] = Math_fround(1.0);
 i530 = i642 + 72 | 0;
 HEAPF32[i530 >> 2] = Math_fround(1.0);
 i554 = i642 + 76 | 0;
 HEAPF32[i554 >> 2] = Math_fround(1.0);
 i483 = i642 + 80 | 0;
 HEAPF32[i483 >> 2] = Math_fround(1.0);
 i505 = i642 + 84 | 0;
 HEAPF32[i505 >> 2] = Math_fround(1.0);
 i529 = i642 + 88 | 0;
 HEAPF32[i529 >> 2] = Math_fround(1.0);
 i553 = i642 + 92 | 0;
 HEAPF32[i553 >> 2] = Math_fround(1.0);
 i482 = i642 + 96 | 0;
 i504 = i642 + 100 | 0;
 i528 = i642 + 104 | 0;
 i552 = i642 + 108 | 0;
 i481 = i642 + 112 | 0;
 i503 = i642 + 116 | 0;
 i527 = i642 + 120 | 0;
 i551 = i642 + 124 | 0;
 i480 = i642 + 128 | 0;
 HEAP32[i482 >> 2] = 0;
 HEAP32[i482 + 4 >> 2] = 0;
 HEAP32[i482 + 8 >> 2] = 0;
 HEAP32[i482 + 12 >> 2] = 0;
 HEAP32[i482 + 16 >> 2] = 0;
 HEAP32[i482 + 20 >> 2] = 0;
 HEAP32[i482 + 24 >> 2] = 0;
 HEAP32[i482 + 28 >> 2] = 0;
 HEAPF32[i480 >> 2] = Math_fround(1.0);
 i502 = i642 + 132 | 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i526 = i642 + 136 | 0;
 HEAPF32[i526 >> 2] = Math_fround(1.0);
 i550 = i642 + 140 | 0;
 HEAPF32[i550 >> 2] = Math_fround(1.0);
 i479 = i642 + 144 | 0;
 i501 = i642 + 148 | 0;
 i525 = i642 + 152 | 0;
 i549 = i642 + 156 | 0;
 i478 = i642 + 160 | 0;
 i500 = i642 + 164 | 0;
 i524 = i642 + 168 | 0;
 i548 = i642 + 172 | 0;
 i477 = i642 + 176 | 0;
 i499 = i642 + 180 | 0;
 i523 = i642 + 184 | 0;
 i547 = i642 + 188 | 0;
 i476 = i642 + 192 | 0;
 i498 = i642 + 196 | 0;
 i522 = i642 + 200 | 0;
 i546 = i642 + 204 | 0;
 i475 = i642 + 208 | 0;
 i497 = i642 + 212 | 0;
 i521 = i642 + 216 | 0;
 i545 = i642 + 220 | 0;
 i474 = i642 + 224 | 0;
 i496 = i642 + 228 | 0;
 i520 = i642 + 232 | 0;
 i544 = i642 + 236 | 0;
 i473 = i642 + 240 | 0;
 i495 = i642 + 244 | 0;
 i519 = i642 + 248 | 0;
 i543 = i642 + 252 | 0;
 i10 = i479;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f73 = Math_fround(HEAPF32[i5 >> 2]);
 f65 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f72 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f74 = Math_fround(HEAPF32[i4 >> 2]);
 i467 = i4 + 4 | 0;
 f77 = Math_fround(HEAPF32[i467 >> 2]);
 i468 = i4 + 8 | 0;
 f78 = Math_fround(HEAPF32[i468 >> 2]);
 i469 = i4 + 12 | 0;
 f68 = Math_fround(HEAPF32[i469 >> 2]);
 i470 = i4 + 16 | 0;
 f64 = Math_fround(HEAPF32[i470 >> 2]);
 i471 = i4 + 20 | 0;
 f81 = Math_fround(HEAPF32[i471 >> 2]);
 i472 = i4 + 24 | 0;
 f70 = Math_fround(HEAPF32[i472 >> 2]);
 i186 = i4 + 28 | 0;
 f66 = Math_fround(HEAPF32[i186 >> 2]);
 i185 = i4 + 32 | 0;
 f84 = Math_fround(HEAPF32[i185 >> 2]);
 f75 = Math_fround(f77 * Math_fround(0.0));
 f76 = Math_fround(f78 * Math_fround(0.0));
 f69 = Math_fround(f64 * Math_fround(0.0));
 f80 = Math_fround(f81 * Math_fround(0.0));
 f79 = Math_fround(Math_fround(Math_fround(f73 * f68) + f69) + f80);
 f71 = Math_fround(f66 * Math_fround(0.0));
 f83 = Math_fround(f84 * Math_fround(0.0));
 f82 = Math_fround(Math_fround(Math_fround(f73 * f70) + f71) + f83);
 f67 = Math_fround(f74 * Math_fround(0.0));
 f77 = Math_fround(Math_fround(f67 + Math_fround(f65 * f77)) + f76);
 f68 = Math_fround(f68 * Math_fround(0.0));
 f80 = Math_fround(Math_fround(f68 + Math_fround(f65 * f64)) + f80);
 f70 = Math_fround(f70 * Math_fround(0.0));
 f83 = Math_fround(Math_fround(f70 + Math_fround(f65 * f66)) + f83);
 f78 = Math_fround(Math_fround(f67 + f75) + Math_fround(f72 * f78));
 f81 = Math_fround(Math_fround(f68 + f69) + Math_fround(f72 * f81));
 f84 = Math_fround(Math_fround(f70 + f71) + Math_fround(f72 * f84));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f73 * f74) + f75) + f76);
 HEAPF32[i467 >> 2] = f77;
 HEAPF32[i468 >> 2] = f78;
 HEAPF32[i469 >> 2] = f79;
 HEAPF32[i470 >> 2] = f80;
 HEAPF32[i471 >> 2] = f81;
 HEAPF32[i472 >> 2] = f82;
 HEAPF32[i186 >> 2] = f83;
 HEAPF32[i185 >> 2] = f84;
 i185 = (i7 | 0) == 27;
 HEAP32[i610 >> 2] = 0;
 HEAP32[i610 + 4 >> 2] = 0;
 HEAP32[i610 + 8 >> 2] = 0;
 HEAP32[i610 + 12 >> 2] = 0;
 i186 = HEAP32[i633 + 12 >> 2] | 0;
 if (!i186) {
  STACKTOP = i643;
  return;
 }
 i187 = i611 + 12 | 0;
 i188 = i611 + 8 | 0;
 i189 = i611 + 4 | 0;
 i190 = i611 + 16 | 0;
 i191 = i611 + 28 | 0;
 i192 = i611 + 24 | 0;
 i193 = i611 + 20 | 0;
 i194 = i611 + 32 | 0;
 i195 = i611 + 44 | 0;
 i196 = i611 + 40 | 0;
 i197 = i611 + 36 | 0;
 i198 = i612 + 32 | 0;
 i199 = i612 + 44 | 0;
 i200 = i612 + 40 | 0;
 i201 = i612 + 36 | 0;
 i202 = i613 + 12 | 0;
 i203 = i613 + 8 | 0;
 i204 = i613 + 4 | 0;
 i205 = i613 + 28 | 0;
 i206 = i613 + 24 | 0;
 i207 = i613 + 20 | 0;
 i208 = i613 + 44 | 0;
 i209 = i613 + 40 | 0;
 i210 = i613 + 36 | 0;
 i211 = i638 + 20 | 0;
 i212 = i633 + 20 | 0;
 i213 = i633 + 40 | 0;
 i214 = i633 + 340 | 0;
 i215 = i633 + 60 | 0;
 i216 = i633 + 80 | 0;
 i217 = i633 + 100 | 0;
 i218 = i633 + 120 | 0;
 i219 = i633 + 140 | 0;
 i220 = i633 + 160 | 0;
 i221 = i613 + 16 | 0;
 i222 = i613 + 32 | 0;
 i223 = i638 + 4 | 0;
 i224 = i614 + 4 | 0;
 i225 = i614 + 8 | 0;
 i226 = i614 + 12 | 0;
 i227 = i638 + 8 | 0;
 i228 = i615 + 4 | 0;
 i229 = i615 + 8 | 0;
 i230 = i615 + 12 | 0;
 i231 = i633 + 520 | 0;
 i232 = i616 + 4 | 0;
 i233 = i616 + 8 | 0;
 i234 = i616 + 12 | 0;
 i235 = i633 + 500 | 0;
 i236 = i617 + 4 | 0;
 i237 = i617 + 8 | 0;
 i238 = i617 + 12 | 0;
 i239 = i638 + 16 | 0;
 i240 = i618 + 4 | 0;
 i241 = i618 + 8 | 0;
 i242 = i618 + 12 | 0;
 i243 = i611 + 16 | 0;
 i244 = i611 + 32 | 0;
 i245 = i620 + 4 | 0;
 i246 = i620 + 8 | 0;
 i247 = i620 + 12 | 0;
 i248 = i620 + 16 | 0;
 i249 = i620 + 20 | 0;
 i250 = i620 + 24 | 0;
 i251 = i620 + 28 | 0;
 i252 = i620 + 32 | 0;
 i253 = i620 + 36 | 0;
 i254 = i620 + 40 | 0;
 i255 = i620 + 44 | 0;
 i256 = i621 + 96 | 0;
 i257 = i621 + 100 | 0;
 i258 = i621 + 104 | 0;
 i259 = i621 + 108 | 0;
 i260 = i621 + 112 | 0;
 i261 = i621 + 116 | 0;
 i262 = i621 + 120 | 0;
 i263 = i621 + 124 | 0;
 i264 = i621 + 128 | 0;
 i265 = i621 + 132 | 0;
 i266 = i621 + 136 | 0;
 i267 = i621 + 140 | 0;
 i268 = i621 + 128 | 0;
 i269 = i621 + 112 | 0;
 i270 = i621 + 4 | 0;
 i271 = i621 + 8 | 0;
 i272 = i621 + 12 | 0;
 i273 = i621 + 16 | 0;
 i274 = i621 + 20 | 0;
 i275 = i621 + 24 | 0;
 i276 = i621 + 28 | 0;
 i277 = i621 + 32 | 0;
 i278 = i621 + 36 | 0;
 i279 = i621 + 40 | 0;
 i280 = i621 + 44 | 0;
 i281 = i621 + 16 | 0;
 i282 = i621 + 32 | 0;
 i283 = i621 + 48 | 0;
 i284 = i621 + 52 | 0;
 i285 = i621 + 56 | 0;
 i286 = i621 + 60 | 0;
 i287 = i621 + 64 | 0;
 i288 = i621 + 68 | 0;
 i289 = i621 + 72 | 0;
 i290 = i621 + 76 | 0;
 i291 = i621 + 80 | 0;
 i292 = i621 + 84 | 0;
 i293 = i621 + 88 | 0;
 i294 = i621 + 92 | 0;
 i295 = i622 + 4 | 0;
 i296 = i622 + 8 | 0;
 i297 = i622 + 12 | 0;
 i298 = i622 + 16 | 0;
 i299 = i622 + 20 | 0;
 i300 = i622 + 24 | 0;
 i301 = i622 + 28 | 0;
 i302 = i622 + 32 | 0;
 i303 = i622 + 36 | 0;
 i304 = i622 + 40 | 0;
 i305 = i622 + 44 | 0;
 i306 = i622 + 48 | 0;
 i307 = i622 + 52 | 0;
 i308 = i622 + 56 | 0;
 i309 = i622 + 60 | 0;
 i310 = i622 + 64 | 0;
 i311 = i622 + 68 | 0;
 i312 = i622 + 72 | 0;
 i313 = i622 + 76 | 0;
 i314 = i622 + 80 | 0;
 i315 = i622 + 84 | 0;
 i316 = i622 + 88 | 0;
 i317 = i622 + 92 | 0;
 i318 = i622 + 100 | 0;
 i319 = i622 + 104 | 0;
 i320 = i622 + 108 | 0;
 i321 = i622 + 116 | 0;
 i322 = i622 + 120 | 0;
 i323 = i622 + 124 | 0;
 i324 = i622 + 128 | 0;
 i325 = i622 + 132 | 0;
 i326 = i622 + 136 | 0;
 i327 = i622 + 140 | 0;
 i328 = i621 + 96 | 0;
 i329 = i622 + 32 | 0;
 i330 = i623 + 4 | 0;
 i331 = i623 + 8 | 0;
 i332 = i623 + 12 | 0;
 i333 = i622 + 80 | 0;
 i334 = i623 + 48 | 0;
 i335 = i623 + 52 | 0;
 i336 = i623 + 56 | 0;
 i337 = i623 + 60 | 0;
 i338 = i622 + 96 | 0;
 i339 = i622 + 112 | 0;
 i340 = i622 + 128 | 0;
 i341 = i623 + 96 | 0;
 i342 = i623 + 100 | 0;
 i343 = i623 + 104 | 0;
 i344 = i623 + 108 | 0;
 i345 = i623 + 16 | 0;
 i346 = i623 + 20 | 0;
 i347 = i623 + 24 | 0;
 i348 = i623 + 28 | 0;
 i349 = i623 + 64 | 0;
 i350 = i623 + 68 | 0;
 i351 = i623 + 72 | 0;
 i352 = i623 + 76 | 0;
 i353 = i623 + 112 | 0;
 i354 = i623 + 116 | 0;
 i355 = i623 + 120 | 0;
 i356 = i623 + 124 | 0;
 i357 = i623 + 32 | 0;
 i358 = i623 + 36 | 0;
 i359 = i623 + 40 | 0;
 i360 = i623 + 44 | 0;
 i361 = i623 + 80 | 0;
 i362 = i623 + 84 | 0;
 i363 = i623 + 88 | 0;
 i364 = i623 + 92 | 0;
 i365 = i623 + 128 | 0;
 i366 = i623 + 132 | 0;
 i367 = i623 + 136 | 0;
 i368 = i623 + 140 | 0;
 i369 = i619 + 4 | 0;
 i370 = i619 + 8 | 0;
 i371 = i619 + 12 | 0;
 i372 = i619 + 16 | 0;
 i373 = i619 + 20 | 0;
 i374 = i619 + 24 | 0;
 i375 = i619 + 28 | 0;
 i376 = i619 + 32 | 0;
 i377 = i619 + 36 | 0;
 i378 = i619 + 40 | 0;
 i379 = i619 + 44 | 0;
 i380 = i619 + 48 | 0;
 i381 = i619 + 52 | 0;
 i382 = i619 + 56 | 0;
 i383 = i619 + 60 | 0;
 i384 = i619 + 64 | 0;
 i385 = i619 + 68 | 0;
 i386 = i619 + 72 | 0;
 i387 = i619 + 76 | 0;
 i388 = i619 + 80 | 0;
 i389 = i619 + 84 | 0;
 i390 = i619 + 88 | 0;
 i391 = i619 + 92 | 0;
 i392 = i619 + 96 | 0;
 i393 = i619 + 100 | 0;
 i394 = i619 + 104 | 0;
 i395 = i619 + 108 | 0;
 i396 = i619 + 112 | 0;
 i397 = i619 + 116 | 0;
 i398 = i619 + 120 | 0;
 i399 = i619 + 124 | 0;
 i400 = i619 + 128 | 0;
 i401 = i619 + 132 | 0;
 i402 = i619 + 136 | 0;
 i403 = i619 + 140 | 0;
 i404 = i619 + 144 | 0;
 i405 = i619 + 148 | 0;
 i406 = i619 + 152 | 0;
 i407 = i619 + 156 | 0;
 i408 = i619 + 160 | 0;
 i409 = i619 + 164 | 0;
 i410 = i619 + 168 | 0;
 i411 = i619 + 172 | 0;
 i412 = i619 + 176 | 0;
 i413 = i619 + 180 | 0;
 i414 = i619 + 184 | 0;
 i415 = i619 + 188 | 0;
 i416 = (i7 & 48 | 0) == 0;
 i147 = i621 + 4 | 0;
 i164 = i621 + 8 | 0;
 i181 = i621 + 12 | 0;
 i417 = i621 + 16 | 0;
 i142 = i621 + 20 | 0;
 i159 = i621 + 24 | 0;
 i176 = i621 + 28 | 0;
 i418 = i621 + 32 | 0;
 i137 = i621 + 36 | 0;
 i154 = i621 + 40 | 0;
 i171 = i621 + 44 | 0;
 i419 = i621 + 48 | 0;
 i146 = i621 + 52 | 0;
 i163 = i621 + 56 | 0;
 i180 = i621 + 60 | 0;
 i420 = i621 + 64 | 0;
 i141 = i621 + 68 | 0;
 i158 = i621 + 72 | 0;
 i175 = i621 + 76 | 0;
 i421 = i621 + 80 | 0;
 i136 = i621 + 84 | 0;
 i153 = i621 + 88 | 0;
 i170 = i621 + 92 | 0;
 i422 = i621 + 96 | 0;
 i145 = i621 + 100 | 0;
 i162 = i621 + 104 | 0;
 i179 = i621 + 108 | 0;
 i423 = i621 + 112 | 0;
 i140 = i621 + 116 | 0;
 i157 = i621 + 120 | 0;
 i174 = i621 + 124 | 0;
 i424 = i621 + 128 | 0;
 i135 = i621 + 132 | 0;
 i152 = i621 + 136 | 0;
 i169 = i621 + 140 | 0;
 i425 = i621 + 144 | 0;
 i144 = i621 + 148 | 0;
 i161 = i621 + 152 | 0;
 i178 = i621 + 156 | 0;
 i426 = i621 + 160 | 0;
 i139 = i621 + 164 | 0;
 i156 = i621 + 168 | 0;
 i173 = i621 + 172 | 0;
 i427 = i621 + 176 | 0;
 i134 = i621 + 180 | 0;
 i151 = i621 + 184 | 0;
 i168 = i621 + 188 | 0;
 i148 = i622 + 4 | 0;
 i165 = i622 + 8 | 0;
 i182 = i622 + 12 | 0;
 i428 = i622 + 16 | 0;
 i143 = i622 + 20 | 0;
 i160 = i622 + 24 | 0;
 i177 = i622 + 28 | 0;
 i429 = i622 + 32 | 0;
 i138 = i622 + 36 | 0;
 i155 = i622 + 40 | 0;
 i172 = i622 + 44 | 0;
 i150 = i623 + 4 | 0;
 i167 = i623 + 8 | 0;
 i184 = i623 + 12 | 0;
 i430 = i623 + 16 | 0;
 i149 = i623 + 20 | 0;
 i166 = i623 + 24 | 0;
 i183 = i623 + 28 | 0;
 i133 = i623 + 32 | 0;
 i431 = (i7 & 512 | 0) != 0;
 i432 = i613 + 16 | 0;
 i433 = i613 + 32 | 0;
 i434 = i624 + 4 | 0;
 i435 = i624 + 8 | 0;
 i436 = i624 + 12 | 0;
 i437 = i624 + 16 | 0;
 i438 = i624 + 20 | 0;
 i439 = i624 + 24 | 0;
 i440 = i624 + 28 | 0;
 i441 = i624 + 32 | 0;
 i442 = i624 + 36 | 0;
 i443 = i624 + 40 | 0;
 i444 = i624 + 44 | 0;
 i445 = (i7 & 8192 | 0) != 0;
 i446 = i625 + 4 | 0;
 i447 = i625 + 8 | 0;
 i448 = i625 + 12 | 0;
 i449 = i625 + 16 | 0;
 i450 = i625 + 20 | 0;
 i451 = i625 + 24 | 0;
 i452 = i625 + 28 | 0;
 i453 = i625 + 32 | 0;
 i454 = i625 + 36 | 0;
 i455 = i625 + 40 | 0;
 i456 = i625 + 44 | 0;
 i457 = i625 + 48 | 0;
 i458 = i625 + 52 | 0;
 i459 = i625 + 56 | 0;
 i460 = i625 + 60 | 0;
 i461 = (i7 & 2 | 0) == 0;
 i462 = (i7 & 8 | 0) == 0;
 i463 = (i7 & 16 | 0) == 0;
 i464 = (i7 & 32 | 0) == 0;
 i465 = (i7 & 64 | 0) == 0;
 i466 = (i7 & 128 | 0) == 0;
 i467 = (i7 & 256 | 0) == 0;
 i468 = i624 + 16 | 0;
 i469 = i624 + 32 | 0;
 i470 = (i7 & 1024 | 0) == 0;
 i471 = (i7 & 2048 | 0) == 0;
 i472 = (i7 & 4096 | 0) == 0;
 i121 = (i7 & 4 | 0) == 0;
 i122 = i622 + 16 | 0;
 i123 = i622 + 32 | 0;
 i124 = i633 + 864 | 0;
 i125 = i633 + 848 | 0;
 i126 = i633 + 844 | 0;
 i127 = i633 + 828 | 0;
 i128 = i633 + 540 | 0;
 i129 = i623 + 16 | 0;
 i130 = i623 + 32 | 0;
 i131 = i620 + 16 | 0;
 i132 = i620 + 32 | 0;
 i86 = i8 + 32 | 0;
 i87 = i619 + 16 | 0;
 i88 = i619 + 32 | 0;
 i89 = i621 + 16 | 0;
 i90 = i621 + 32 | 0;
 i91 = i619 + 48 | 0;
 i92 = i91 + 16 | 0;
 i93 = i91 + 32 | 0;
 i94 = i419 + 16 | 0;
 i95 = i419 + 32 | 0;
 i96 = i392 + 16 | 0;
 i97 = i392 + 32 | 0;
 i98 = i422 + 16 | 0;
 i99 = i422 + 32 | 0;
 i100 = i404 + 16 | 0;
 i101 = i404 + 32 | 0;
 i102 = i425 + 16 | 0;
 i103 = i425 + 32 | 0;
 i104 = i619 + 16 | 0;
 i105 = i619 + 32 | 0;
 i106 = i621 + 16 | 0;
 i107 = i621 + 32 | 0;
 i108 = i619 + 48 | 0;
 i109 = i108 + 16 | 0;
 i110 = i108 + 32 | 0;
 i111 = i419 + 16 | 0;
 i112 = i419 + 32 | 0;
 i113 = i392 + 16 | 0;
 i114 = i392 + 32 | 0;
 i115 = i422 + 16 | 0;
 i116 = i422 + 32 | 0;
 i117 = i404 + 16 | 0;
 i118 = i404 + 32 | 0;
 i119 = i425 + 16 | 0;
 i120 = i425 + 32 | 0;
 i85 = 0;
 i1 = i9;
 do {
  i10 = i611;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i612;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i613;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i614 >> 2] = 0;
  HEAP32[i614 + 4 >> 2] = 0;
  HEAP32[i614 + 8 >> 2] = 0;
  HEAP32[i614 + 12 >> 2] = 0;
  HEAP32[i615 >> 2] = 0;
  HEAP32[i615 + 4 >> 2] = 0;
  HEAP32[i615 + 8 >> 2] = 0;
  HEAP32[i615 + 12 >> 2] = 0;
  HEAP32[i616 >> 2] = 0;
  HEAP32[i616 + 4 >> 2] = 0;
  HEAP32[i616 + 8 >> 2] = 0;
  HEAP32[i616 + 12 >> 2] = 0;
  HEAP32[i617 >> 2] = 0;
  HEAP32[i617 + 4 >> 2] = 0;
  HEAP32[i617 + 8 >> 2] = 0;
  HEAP32[i617 + 12 >> 2] = 0;
  HEAP32[i618 >> 2] = 0;
  HEAP32[i618 + 4 >> 2] = 0;
  HEAP32[i618 + 8 >> 2] = 0;
  HEAP32[i618 + 12 >> 2] = 0;
  i15 = HEAP32[i211 >> 2] | 0;
  i16 = HEAP32[i633 >> 2] | 0;
  if (!i15) {
   i43 = i16 + (i85 << 2) | 0;
   i44 = HEAP32[i43 + 4 >> 2] | 0;
   i45 = HEAP32[i43 + 8 >> 2] | 0;
   i46 = HEAP32[i43 + 12 >> 2] | 0;
   i54 = (HEAP32[i212 >> 2] | 0) + (i85 << 2) | 0;
   i51 = HEAP32[i54 >> 2] | 0;
   i52 = HEAP32[i54 + 4 >> 2] | 0;
   i53 = HEAP32[i54 + 8 >> 2] | 0;
   i54 = HEAP32[i54 + 12 >> 2] | 0;
   i55 = (HEAP32[i213 >> 2] | 0) + (i85 << 2) | 0;
   i58 = HEAP32[i55 >> 2] | 0;
   i57 = HEAP32[i55 + 4 >> 2] | 0;
   i56 = HEAP32[i55 + 8 >> 2] | 0;
   i55 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i611 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i189 >> 2] = i44;
   HEAP32[i188 >> 2] = i45;
   HEAP32[i187 >> 2] = i46;
   HEAP32[i190 >> 2] = i51;
   HEAP32[i193 >> 2] = i52;
   HEAP32[i192 >> 2] = i53;
   HEAP32[i191 >> 2] = i54;
   HEAP32[i194 >> 2] = i58;
   HEAP32[i197 >> 2] = i57;
   HEAP32[i196 >> 2] = i56;
   HEAP32[i195 >> 2] = i55;
   i55 = (HEAP32[i214 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i198 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i201 >> 2] = i56;
   HEAP32[i200 >> 2] = i57;
   HEAP32[i199 >> 2] = i58;
   i58 = (HEAP32[i215 >> 2] | 0) + (i85 << 2) | 0;
   f72 = Math_fround(HEAPF32[i58 >> 2]);
   f62 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f63 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f64 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i216 >> 2] | 0) + (i85 << 2) | 0;
   f65 = Math_fround(HEAPF32[i58 >> 2]);
   f66 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f67 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f68 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i217 >> 2] | 0) + (i85 << 2) | 0;
   f69 = Math_fround(HEAPF32[i58 >> 2]);
   f70 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f71 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f84 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i218 >> 2] | 0) + (i85 << 2) | 0;
   f73 = Math_fround(HEAPF32[i58 >> 2]);
   f74 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f75 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f76 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i219 >> 2] | 0) + (i85 << 2) | 0;
   f77 = Math_fround(HEAPF32[i58 >> 2]);
   f78 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f79 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f80 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i220 >> 2] | 0) + (i85 << 2) | 0;
   f81 = Math_fround(HEAPF32[i58 >> 2]);
   f82 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f83 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f74 = Math_fround(f62 + f74);
   f75 = Math_fround(f63 + f75);
   f76 = Math_fround(f64 + f76);
   f77 = Math_fround(f65 + f77);
   f78 = Math_fround(f66 + f78);
   f79 = Math_fround(f67 + f79);
   f80 = Math_fround(f68 + f80);
   f81 = Math_fround(f69 + f81);
   f82 = Math_fround(f70 + f82);
   f83 = Math_fround(f71 + f83);
   f84 = Math_fround(f84 + Math_fround(HEAPF32[i58 + 12 >> 2]));
   HEAPF32[i613 >> 2] = Math_fround(f72 + f73);
   HEAPF32[i204 >> 2] = f74;
   HEAPF32[i203 >> 2] = f75;
   HEAPF32[i202 >> 2] = f76;
   HEAPF32[i221 >> 2] = f77;
   HEAPF32[i207 >> 2] = f78;
   HEAPF32[i206 >> 2] = f79;
   HEAPF32[i205 >> 2] = f80;
   HEAPF32[i222 >> 2] = f81;
   HEAPF32[i210 >> 2] = f82;
   HEAPF32[i209 >> 2] = f83;
   HEAPF32[i208 >> 2] = f84;
   i58 = (HEAP32[i223 >> 2] | 0) + (i85 << 2) | 0;
   i57 = HEAP32[i58 + 4 >> 2] | 0;
   i56 = HEAP32[i58 + 8 >> 2] | 0;
   i55 = HEAP32[i58 + 12 >> 2] | 0;
   HEAP32[i614 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i224 >> 2] = i57;
   HEAP32[i225 >> 2] = i56;
   HEAP32[i226 >> 2] = i55;
   i55 = (HEAP32[i227 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i615 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i228 >> 2] = i56;
   HEAP32[i229 >> 2] = i57;
   HEAP32[i230 >> 2] = i58;
   i58 = (HEAP32[i231 >> 2] | 0) + (i85 << 2) | 0;
   i57 = HEAP32[i58 + 4 >> 2] | 0;
   i56 = HEAP32[i58 + 8 >> 2] | 0;
   i55 = HEAP32[i58 + 12 >> 2] | 0;
   HEAP32[i616 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i232 >> 2] = i57;
   HEAP32[i233 >> 2] = i56;
   HEAP32[i234 >> 2] = i55;
   i55 = (HEAP32[i235 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i617 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i236 >> 2] = i56;
   HEAP32[i237 >> 2] = i57;
   HEAP32[i238 >> 2] = i58;
   if (HEAP32[i626 >> 2] & 268435456 | 0) {
    i55 = (HEAP32[i239 >> 2] | 0) + (i85 << 2) | 0;
    i56 = HEAP32[i55 + 4 >> 2] | 0;
    i57 = HEAP32[i55 + 8 >> 2] | 0;
    i58 = HEAP32[i55 + 12 >> 2] | 0;
    HEAP32[i618 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i240 >> 2] = i56;
    HEAP32[i241 >> 2] = i57;
    HEAP32[i242 >> 2] = i58;
   }
  } else {
   i3 = HEAP32[i215 >> 2] | 0;
   i4 = HEAP32[i218 >> 2] | 0;
   i5 = HEAP32[i212 >> 2] | 0;
   i6 = HEAP32[i216 >> 2] | 0;
   i7 = HEAP32[i219 >> 2] | 0;
   i8 = HEAP32[i213 >> 2] | 0;
   i9 = HEAP32[i217 >> 2] | 0;
   i10 = HEAP32[i220 >> 2] | 0;
   i11 = HEAP32[i223 >> 2] | 0;
   i12 = HEAP32[i227 >> 2] | 0;
   i13 = HEAP32[i231 >> 2] | 0;
   i14 = HEAP32[i235 >> 2] | 0;
   i17 = (HEAP32[i626 >> 2] & 268435456 | 0) == 0;
   i18 = HEAP32[i214 >> 2] | 0;
   i19 = HEAP32[i239 >> 2] | 0;
   i2 = 0;
   do {
    i20 = HEAP32[i15 + (i2 + i85 << 3) >> 2] | 0;
    HEAP32[i611 + (i2 << 2) >> 2] = HEAP32[i16 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i3 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i2 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i4 + (i20 << 2) >> 2]));
    i21 = i2 + 4 | 0;
    HEAP32[i611 + (i21 << 2) >> 2] = HEAP32[i5 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i6 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i21 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i7 + (i20 << 2) >> 2]));
    i21 = i2 + 8 | 0;
    HEAP32[i611 + (i21 << 2) >> 2] = HEAP32[i8 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i9 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i21 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i10 + (i20 << 2) >> 2]));
    HEAP32[i614 + (i2 << 2) >> 2] = HEAP32[i11 + (i20 << 2) >> 2];
    HEAP32[i615 + (i2 << 2) >> 2] = HEAP32[i12 + (i20 << 2) >> 2];
    HEAP32[i616 + (i2 << 2) >> 2] = HEAP32[i13 + (i20 << 2) >> 2];
    HEAP32[i617 + (i2 << 2) >> 2] = HEAP32[i14 + (i20 << 2) >> 2];
    if (!i17) HEAP32[i618 + (i2 << 2) >> 2] = HEAP32[i19 + (i20 << 2) >> 2];
    HEAP32[i612 + (i21 << 2) >> 2] = HEAP32[i18 + (i20 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f39 = Math_fround(HEAPF32[i611 >> 2]);
  f24 = Math_fround(f576 * f39);
  f36 = Math_fround(HEAPF32[i189 >> 2]);
  f38 = Math_fround(f576 * f36);
  f84 = Math_fround(HEAPF32[i188 >> 2]);
  f23 = Math_fround(f576 * f84);
  f82 = Math_fround(HEAPF32[i187 >> 2]);
  f30 = Math_fround(f576 * f82);
  f33 = Math_fround(HEAPF32[i243 >> 2]);
  f27 = Math_fround(f579 * f33);
  f32 = Math_fround(HEAPF32[i193 >> 2]);
  f28 = Math_fround(f579 * f32);
  f83 = Math_fround(HEAPF32[i192 >> 2]);
  f34 = Math_fround(f579 * f83);
  f81 = Math_fround(HEAPF32[i191 >> 2]);
  f27 = Math_fround(f24 + f27);
  f28 = Math_fround(f38 + f28);
  f34 = Math_fround(f23 + f34);
  f30 = Math_fround(f30 + Math_fround(f579 * f81));
  f23 = Math_fround(HEAPF32[i244 >> 2]);
  f38 = Math_fround(f582 * f23);
  f24 = Math_fround(HEAPF32[i197 >> 2]);
  f31 = Math_fround(f582 * f24);
  f25 = Math_fround(HEAPF32[i196 >> 2]);
  f35 = Math_fround(f582 * f25);
  f29 = Math_fround(HEAPF32[i195 >> 2]);
  f31 = Math_fround(f585 + Math_fround(f28 + f31));
  f35 = Math_fround(f585 + Math_fround(f34 + f35));
  f30 = Math_fround(f585 + Math_fround(f30 + Math_fround(f582 * f29)));
  HEAPF32[i620 >> 2] = Math_fround(f585 + Math_fround(f27 + f38));
  HEAPF32[i245 >> 2] = f31;
  HEAPF32[i246 >> 2] = f35;
  HEAPF32[i247 >> 2] = f30;
  f30 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f36) + Math_fround(f580 * f32)) + Math_fround(f583 * f24)));
  f35 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f84) + Math_fround(f580 * f83)) + Math_fround(f583 * f25)));
  f31 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f82) + Math_fround(f580 * f81)) + Math_fround(f583 * f29)));
  HEAPF32[i248 >> 2] = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f39) + Math_fround(f580 * f33)) + Math_fround(f583 * f23)));
  HEAPF32[i249 >> 2] = f30;
  HEAPF32[i250 >> 2] = f35;
  HEAPF32[i251 >> 2] = f31;
  f31 = Math_fround(f587 + Math_fround(Math_fround(f584 * f24) + Math_fround(Math_fround(f581 * f32) + Math_fround(f578 * f36))));
  f35 = Math_fround(f587 + Math_fround(Math_fround(f584 * f25) + Math_fround(Math_fround(f581 * f83) + Math_fround(f578 * f84))));
  f30 = Math_fround(f587 + Math_fround(Math_fround(f584 * f29) + Math_fround(Math_fround(f581 * f81) + Math_fround(f578 * f82))));
  HEAPF32[i252 >> 2] = Math_fround(f587 + Math_fround(Math_fround(f584 * f23) + Math_fround(Math_fround(f581 * f33) + Math_fround(f578 * f39))));
  HEAPF32[i253 >> 2] = f31;
  HEAPF32[i254 >> 2] = f35;
  HEAPF32[i255 >> 2] = f30;
  f23 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f39) + Math_fround(f636 * f33)) + Math_fround(f637 * f23)));
  f24 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f36) + Math_fround(f636 * f32)) + Math_fround(f637 * f24)));
  f25 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f84) + Math_fround(f636 * f83)) + Math_fround(f637 * f25)));
  f29 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f82) + Math_fround(f636 * f81)) + Math_fround(f637 * f29)));
  f81 = Math_fround(f606 + Math_fround(f607 * f23));
  f82 = Math_fround(f606 + Math_fround(f607 * f24));
  f83 = Math_fround(f606 + Math_fround(f607 * f25));
  f84 = Math_fround(f606 + Math_fround(f607 * f29));
  f23 = Math_fround(f600 + Math_fround(f601 * f23));
  f24 = Math_fround(f600 + Math_fround(f601 * f24));
  f25 = Math_fround(f600 + Math_fround(f601 * f25));
  f29 = Math_fround(f600 + Math_fround(f601 * f29));
  f32 = Math_fround(HEAPF32[i614 >> 2]);
  f36 = Math_fround(HEAPF32[i224 >> 2]);
  f33 = Math_fround(HEAPF32[i225 >> 2]);
  f39 = Math_fround(HEAPF32[i226 >> 2]);
  f30 = Math_fround(HEAPF32[i615 >> 2]);
  f35 = Math_fround(HEAPF32[i228 >> 2]);
  f31 = Math_fround(HEAPF32[i229 >> 2]);
  f38 = Math_fround(HEAPF32[i230 >> 2]);
  f27 = f32 > f30 ? f32 : f30;
  f34 = f36 > f35 ? f36 : f35;
  f28 = f33 > f31 ? f33 : f31;
  f37 = f39 > f38 ? f39 : f38;
  f78 = Math_fround((f27 > f81 ? f27 : f81) * Math_fround(.5));
  f79 = Math_fround((f34 > f82 ? f34 : f82) * Math_fround(.5));
  f80 = Math_fround((f28 > f83 ? f28 : f83) * Math_fround(.5));
  f22 = Math_fround((f37 > f84 ? f37 : f84) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f81 >= Math_fround(0.0);
  i56 = f82 >= Math_fround(0.0);
  i57 = f83 >= Math_fround(0.0);
  i58 = f84 >= Math_fround(0.0);
  i9 = i55 ? i9 : 0;
  i10 = i56 ? i10 : 0;
  i11 = i57 ? i11 : 0;
  i5 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f80 = Math_fround(f23 * Math_fround(.5));
  f82 = Math_fround(f24 * Math_fround(.5));
  f84 = Math_fround(f25 * Math_fround(.5));
  f22 = Math_fround(f29 * Math_fround(.5));
  f79 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f83 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f79 < f80 ? f79 : f80, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f81 < f82 ? f81 : f82, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f83 < f84 ? f83 : f84, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f23 >= Math_fround(0.0);
  i3 = f24 >= Math_fround(0.0);
  i2 = f25 >= Math_fround(0.0);
  i58 = f29 >= Math_fround(0.0);
  i14 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f26 < f22 ? f26 : f22, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f27);
  f47 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f50 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f81 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround(f32 * f49);
  f48 = Math_fround(f33 * f50);
  f49 = Math_fround(f30 * f49);
  f50 = Math_fround(f31 * f50);
  f82 = Math_fround(HEAPF32[i616 >> 2]);
  f60 = Math_fround(HEAPF32[i232 >> 2]);
  f78 = Math_fround(HEAPF32[i233 >> 2]);
  f79 = Math_fround(f609 * f32);
  f80 = Math_fround(f609 * f33);
  f84 = Math_fround(f603 * f30);
  f83 = Math_fround(f603 * f31);
  f77 = Math_fround(f605 * f32);
  f76 = Math_fround(f605 * f33);
  f47 = Math_fround(f47 / f34);
  f40 = Math_fround(f36 * f47);
  f47 = Math_fround(f35 * f47);
  i14 = f82 < Math_fround(100.0);
  i16 = f78 < Math_fround(100.0);
  f78 = Math_fround(f609 * f36);
  f82 = Math_fround(f603 * f35);
  f75 = Math_fround(f605 * f36);
  f34 = Math_fround(f81 / f37);
  f35 = Math_fround(f38 * f34);
  i15 = Math_fround(HEAPF32[i234 >> 2]) < Math_fround(100.0);
  f81 = Math_fround(f603 * f38);
  f34 = Math_fround(f39 * f34);
  i13 = f60 < Math_fround(100.0);
  f37 = Math_fround(f609 * f39);
  f36 = Math_fround(f605 * f39);
  f60 = Math_fround(Math_fround(HEAPF32[i620 >> 2]) - f588);
  f61 = Math_fround(Math_fround(HEAPF32[i245 >> 2]) - f588);
  f62 = Math_fround(Math_fround(HEAPF32[i246 >> 2]) - f588);
  f63 = Math_fround(Math_fround(HEAPF32[i247 >> 2]) - f588);
  f64 = Math_fround(Math_fround(HEAPF32[i248 >> 2]) - f589);
  f65 = Math_fround(Math_fround(HEAPF32[i249 >> 2]) - f589);
  f66 = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f589);
  f67 = Math_fround(Math_fround(HEAPF32[i251 >> 2]) - f589);
  f33 = Math_fround(Math_fround(HEAPF32[i252 >> 2]) - f590);
  f38 = Math_fround(Math_fround(HEAPF32[i253 >> 2]) - f590);
  f39 = Math_fround(Math_fround(HEAPF32[i254 >> 2]) - f590);
  f59 = Math_fround(Math_fround(HEAPF32[i255 >> 2]) - f590);
  f71 = Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f33 * f33));
  f72 = Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f38 * f38));
  f73 = Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f39 * f39));
  f74 = Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f59 * f59));
  f68 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f71))));
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f72))));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f73))));
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f74))));
  f60 = Math_fround(f60 * f68);
  f61 = Math_fround(f61 * f69);
  f62 = Math_fround(f62 * f70);
  f63 = Math_fround(f63 * f22);
  f64 = Math_fround(f64 * f68);
  f65 = Math_fround(f65 * f69);
  f66 = Math_fround(f66 * f70);
  f67 = Math_fround(f67 * f22);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f38 * f69);
  f70 = Math_fround(f39 * f70);
  f22 = Math_fround(f59 * f22);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f71 > Math_fround(9.99999974e-06);
  i56 = f72 > Math_fround(9.99999974e-06);
  i57 = f73 > Math_fround(9.99999974e-06);
  i58 = f74 > Math_fround(9.99999974e-06);
  i2 = i55 ? i2 : 0;
  i3 = i56 ? i3 : 0;
  i4 = i57 ? i4 : 0;
  i5 = i58 ? i5 : 0;
  i6 = i55 ? i6 : 0;
  i7 = i56 ? i7 : 0;
  i8 = i57 ? i8 : 0;
  i9 = i58 ? i9 : 0;
  i10 = i55 ? i10 : 1065353216;
  i11 = i56 ? i11 : 1065353216;
  i12 = i57 ? i12 : 1065353216;
  i55 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i256 >> 2] = i2;
  HEAP32[i257 >> 2] = i3;
  HEAP32[i258 >> 2] = i4;
  HEAP32[i259 >> 2] = i5;
  HEAP32[i260 >> 2] = i6;
  HEAP32[i261 >> 2] = i7;
  HEAP32[i262 >> 2] = i8;
  HEAP32[i263 >> 2] = i9;
  HEAP32[i264 >> 2] = i10;
  HEAP32[i265 >> 2] = i11;
  HEAP32[i266 >> 2] = i12;
  HEAP32[i267 >> 2] = i55;
  f64 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = Math_fround(f592 * f64);
  f65 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f70 = Math_fround(f592 * f65);
  f66 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f592 * f66);
  f67 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(f592 * f67);
  f74 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f593 * f74);
  f73 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f593 * f73);
  f72 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f593 * f72);
  f71 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f38 - f60);
  f61 = Math_fround(f70 - f61);
  f62 = Math_fround(f33 - f62);
  f63 = Math_fround(f63 - Math_fround(f593 * f71));
  f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f70 = Math_fround(f593 * f33);
  f38 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f69 = Math_fround(f593 * f38);
  f39 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f68 = Math_fround(f593 * f39);
  f59 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f70 - Math_fround(f591 * f64));
  f65 = Math_fround(f69 - Math_fround(f591 * f65));
  f66 = Math_fround(f68 - Math_fround(f591 * f66));
  f67 = Math_fround(Math_fround(f593 * f59) - Math_fround(f591 * f67));
  f33 = Math_fround(Math_fround(f591 * f74) - Math_fround(f592 * f33));
  f38 = Math_fround(Math_fround(f591 * f73) - Math_fround(f592 * f38));
  f39 = Math_fround(Math_fround(f591 * f72) - Math_fround(f592 * f39));
  f59 = Math_fround(Math_fround(f591 * f71) - Math_fround(f592 * f59));
  f71 = Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f33 * f33));
  f72 = Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f38 * f38));
  f73 = Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f39 * f39));
  f74 = Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f59 * f59));
  f68 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f71))));
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f72))));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f73))));
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f74))));
  f60 = Math_fround(f60 * f68);
  f61 = Math_fround(f61 * f69);
  f62 = Math_fround(f62 * f70);
  f63 = Math_fround(f63 * f22);
  f64 = Math_fround(f64 * f68);
  f65 = Math_fround(f65 * f69);
  f66 = Math_fround(f66 * f70);
  f67 = Math_fround(f67 * f22);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f38 * f69);
  f70 = Math_fround(f39 * f70);
  f22 = Math_fround(f59 * f22);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f71 > Math_fround(9.99999974e-06);
  i56 = f72 > Math_fround(9.99999974e-06);
  i57 = f73 > Math_fround(9.99999974e-06);
  i58 = f74 > Math_fround(9.99999974e-06);
  i2 = i55 ? i2 : 1065353216;
  i3 = i56 ? i3 : 1065353216;
  i4 = i57 ? i4 : 1065353216;
  i5 = i58 ? i5 : 1065353216;
  i6 = i55 ? i6 : 0;
  i7 = i56 ? i7 : 0;
  i8 = i57 ? i8 : 0;
  i9 = i58 ? i9 : 0;
  i10 = i55 ? i10 : 0;
  i11 = i56 ? i11 : 0;
  i12 = i57 ? i12 : 0;
  i58 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i621 >> 2] = i2;
  HEAP32[i270 >> 2] = i3;
  HEAP32[i271 >> 2] = i4;
  HEAP32[i272 >> 2] = i5;
  HEAP32[i273 >> 2] = i6;
  HEAP32[i274 >> 2] = i7;
  HEAP32[i275 >> 2] = i8;
  HEAP32[i276 >> 2] = i9;
  HEAP32[i277 >> 2] = i10;
  HEAP32[i278 >> 2] = i11;
  HEAP32[i279 >> 2] = i12;
  HEAP32[i280 >> 2] = i58;
  f65 = Math_fround(HEAPF32[i269 >> 2]);
  f73 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f65 * f73);
  f68 = Math_fround(HEAPF32[i261 >> 2]);
  f29 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f68 * f29);
  f71 = Math_fround(HEAPF32[i262 >> 2]);
  f74 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f71 * f74);
  f32 = Math_fround(HEAPF32[i263 >> 2]);
  f30 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f32 * f30);
  f59 = Math_fround(HEAPF32[i268 >> 2]);
  f63 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f59 * f63);
  f60 = Math_fround(HEAPF32[i265 >> 2]);
  f66 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = Math_fround(f60 * f66);
  f61 = Math_fround(HEAPF32[i266 >> 2]);
  f69 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(f61 * f69);
  f62 = Math_fround(HEAPF32[i267 >> 2]);
  f33 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f27 - f25);
  f24 = Math_fround(f26 - f24);
  f23 = Math_fround(f31 - f23);
  f22 = Math_fround(f22 - Math_fround(f62 * f33));
  f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(f59 * f31);
  f26 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f60 * f26);
  f27 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f61 * f27);
  f28 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f62 * f28);
  f64 = Math_fround(HEAPF32[i256 >> 2]);
  f73 = Math_fround(f73 * f64);
  f67 = Math_fround(HEAPF32[i257 >> 2]);
  f29 = Math_fround(f29 * f67);
  f70 = Math_fround(HEAPF32[i258 >> 2]);
  f74 = Math_fround(f74 * f70);
  f72 = Math_fround(HEAPF32[i259 >> 2]);
  f73 = Math_fround(f59 - f73);
  f29 = Math_fround(f60 - f29);
  f74 = Math_fround(f61 - f74);
  f30 = Math_fround(f62 - Math_fround(f30 * f72));
  f31 = Math_fround(Math_fround(f63 * f64) - Math_fround(f65 * f31));
  f26 = Math_fround(Math_fround(f66 * f67) - Math_fround(f68 * f26));
  f27 = Math_fround(Math_fround(f69 * f70) - Math_fround(f71 * f27));
  f28 = Math_fround(Math_fround(f33 * f72) - Math_fround(f32 * f28));
  HEAPF32[i283 >> 2] = f25;
  HEAPF32[i284 >> 2] = f24;
  HEAPF32[i285 >> 2] = f23;
  HEAPF32[i286 >> 2] = f22;
  HEAPF32[i287 >> 2] = f73;
  HEAPF32[i288 >> 2] = f29;
  HEAPF32[i289 >> 2] = f74;
  HEAPF32[i290 >> 2] = f30;
  HEAPF32[i291 >> 2] = f31;
  HEAPF32[i292 >> 2] = f26;
  HEAPF32[i293 >> 2] = f27;
  HEAPF32[i294 >> 2] = f28;
  f28 = Math_fround(Math_fround(HEAPF32[i198 >> 2]) * Math_fround(.159154937));
  f27 = Math_fround(Math_fround(HEAPF32[i201 >> 2]) * Math_fround(.159154937));
  f26 = Math_fround(Math_fround(HEAPF32[i200 >> 2]) * Math_fround(.159154937));
  f31 = Math_fround(Math_fround(HEAPF32[i199 >> 2]) * Math_fround(.159154937));
  f30 = Math_fround(+_roundf(+f28));
  f74 = Math_fround(+_roundf(+f27));
  f29 = Math_fround(+_roundf(+f26));
  f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f30))));
  f74 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f74))));
  f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f29))));
  f73 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
  f22 = Math_fround(f30 * f30);
  f23 = Math_fround(f74 * f74);
  f24 = Math_fround(f29 * f29);
  f25 = Math_fround(f73 * f73);
  f32 = Math_fround(f22 * f22);
  f72 = Math_fround(f23 * f23);
  f33 = Math_fround(f24 * f24);
  f71 = Math_fround(f25 * f25);
  f22 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f22 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f22 * Math_fround(76.5686187)))))));
  f23 = Math_fround(f74 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f23 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f23 * Math_fround(76.5686187)))))));
  f24 = Math_fround(f29 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f24 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f24 * Math_fround(76.5686187)))))));
  f25 = Math_fround(f73 * Math_fround(Math_fround(Math_fround(f71 * f71) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f25 * Math_fround(41.3416595))) + Math_fround(f71 * Math_fround(Math_fround(81.6018218) - Math_fround(f25 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f28 + Math_fround(-.25));
  f27 = Math_fround(f27 + Math_fround(-.25));
  f26 = Math_fround(f26 + Math_fround(-.25));
  f31 = Math_fround(f31 + Math_fround(-.25));
  f71 = Math_fround(+_roundf(+f28));
  f73 = Math_fround(+_roundf(+f27));
  f33 = Math_fround(+_roundf(+f26));
  f71 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f71))));
  f73 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f73))));
  f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f33))));
  f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
  f26 = Math_fround(f71 * f71);
  f27 = Math_fround(f73 * f73);
  f28 = Math_fround(f33 * f33);
  f29 = Math_fround(f31 * f31);
  f72 = Math_fround(f26 * f26);
  f74 = Math_fround(f27 * f27);
  f32 = Math_fround(f28 * f28);
  f30 = Math_fround(f29 * f29);
  f26 = Math_fround(f71 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f26 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f26 * Math_fround(76.5686187)))))));
  f27 = Math_fround(f73 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
  f29 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f29 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f29 * Math_fround(76.5686187)))))));
  f30 = Math_fround(-f26);
  f31 = Math_fround(-f27);
  f32 = Math_fround(-f28);
  f33 = Math_fround(-f29);
  HEAPF32[i622 >> 2] = f22;
  HEAPF32[i295 >> 2] = f23;
  HEAPF32[i296 >> 2] = f24;
  HEAPF32[i297 >> 2] = f25;
  HEAPF32[i298 >> 2] = f30;
  HEAPF32[i299 >> 2] = f31;
  HEAPF32[i300 >> 2] = f32;
  HEAPF32[i301 >> 2] = f33;
  HEAP32[i302 >> 2] = 0;
  HEAP32[i302 + 4 >> 2] = 0;
  HEAP32[i302 + 8 >> 2] = 0;
  HEAP32[i302 + 12 >> 2] = 0;
  HEAPF32[i306 >> 2] = f26;
  HEAPF32[i307 >> 2] = f27;
  HEAPF32[i308 >> 2] = f28;
  HEAPF32[i309 >> 2] = f29;
  HEAPF32[i310 >> 2] = f22;
  HEAPF32[i311 >> 2] = f23;
  HEAPF32[i312 >> 2] = f24;
  HEAPF32[i313 >> 2] = f25;
  i10 = i314;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i324 >> 2] = 1065353216;
  HEAP32[i325 >> 2] = 1065353216;
  HEAP32[i326 >> 2] = 1065353216;
  HEAP32[i327 >> 2] = 1065353216;
  f39 = Math_fround(HEAPF32[i621 >> 2]);
  f662 = Math_fround(f39 * f22);
  f59 = Math_fround(HEAPF32[i270 >> 2]);
  f661 = Math_fround(f59 * f23);
  f74 = Math_fround(HEAPF32[i271 >> 2]);
  f663 = Math_fround(f74 * f24);
  f671 = Math_fround(HEAPF32[i272 >> 2]);
  f664 = Math_fround(f671 * f25);
  f672 = Math_fround(HEAPF32[i283 >> 2]);
  f670 = Math_fround(f672 * f30);
  f68 = Math_fround(HEAPF32[i284 >> 2]);
  f659 = Math_fround(f68 * f31);
  f70 = Math_fround(HEAPF32[i285 >> 2]);
  f69 = Math_fround(f70 * f32);
  f71 = Math_fround(HEAPF32[i286 >> 2]);
  f670 = Math_fround(f662 + f670);
  f659 = Math_fround(f661 + f659);
  f69 = Math_fround(f663 + f69);
  f664 = Math_fround(f664 + Math_fround(f71 * f33));
  f663 = Math_fround(HEAPF32[i328 >> 2]);
  f661 = Math_fround(f663 * Math_fround(0.0));
  f662 = Math_fround(HEAPF32[i257 >> 2]);
  f72 = Math_fround(f662 * Math_fround(0.0));
  f38 = Math_fround(HEAPF32[i258 >> 2]);
  f673 = Math_fround(f38 * Math_fround(0.0));
  f660 = Math_fround(HEAPF32[i259 >> 2]);
  f73 = Math_fround(f660 * Math_fround(0.0));
  f659 = Math_fround(f659 + f72);
  f69 = Math_fround(f69 + f673);
  f664 = Math_fround(f664 + f73);
  HEAPF32[i623 >> 2] = Math_fround(f670 + f661);
  HEAPF32[i330 >> 2] = f659;
  HEAPF32[i331 >> 2] = f69;
  HEAPF32[i332 >> 2] = f664;
  f72 = Math_fround(Math_fround(Math_fround(f59 * f27) + Math_fround(f68 * f23)) + f72);
  f673 = Math_fround(Math_fround(Math_fround(f74 * f28) + Math_fround(f70 * f24)) + f673);
  f28 = Math_fround(Math_fround(Math_fround(f671 * f29) + Math_fround(f71 * f25)) + f73);
  HEAPF32[i334 >> 2] = Math_fround(Math_fround(Math_fround(f39 * f26) + Math_fround(f672 * f22)) + f661);
  HEAPF32[i335 >> 2] = f72;
  HEAPF32[i336 >> 2] = f673;
  HEAPF32[i337 >> 2] = f28;
  f662 = Math_fround(Math_fround(Math_fround(f59 * Math_fround(0.0)) + Math_fround(f68 * Math_fround(0.0))) + f662);
  f38 = Math_fround(Math_fround(Math_fround(f74 * Math_fround(0.0)) + Math_fround(f70 * Math_fround(0.0))) + f38);
  f660 = Math_fround(Math_fround(Math_fround(f671 * Math_fround(0.0)) + Math_fround(f71 * Math_fround(0.0))) + f660);
  HEAPF32[i341 >> 2] = Math_fround(Math_fround(Math_fround(f39 * Math_fround(0.0)) + Math_fround(f672 * Math_fround(0.0))) + f663);
  HEAPF32[i342 >> 2] = f662;
  HEAPF32[i343 >> 2] = f38;
  HEAPF32[i344 >> 2] = f660;
  f660 = Math_fround(HEAPF32[i281 >> 2]);
  f38 = Math_fround(f660 * Math_fround(HEAPF32[i622 >> 2]));
  f662 = Math_fround(HEAPF32[i274 >> 2]);
  f663 = Math_fround(f662 * Math_fround(HEAPF32[i295 >> 2]));
  f672 = Math_fround(HEAPF32[i275 >> 2]);
  f39 = Math_fround(f672 * Math_fround(HEAPF32[i296 >> 2]));
  f71 = Math_fround(HEAPF32[i276 >> 2]);
  f671 = Math_fround(f71 * Math_fround(HEAPF32[i297 >> 2]));
  f70 = Math_fround(HEAPF32[i287 >> 2]);
  f74 = Math_fround(f70 * Math_fround(HEAPF32[i298 >> 2]));
  f68 = Math_fround(HEAPF32[i288 >> 2]);
  f59 = Math_fround(f68 * Math_fround(HEAPF32[i299 >> 2]));
  f28 = Math_fround(HEAPF32[i289 >> 2]);
  f673 = Math_fround(f28 * Math_fround(HEAPF32[i300 >> 2]));
  f72 = Math_fround(HEAPF32[i290 >> 2]);
  f74 = Math_fround(f38 + f74);
  f59 = Math_fround(f663 + f59);
  f673 = Math_fround(f39 + f673);
  f671 = Math_fround(f671 + Math_fround(f72 * Math_fround(HEAPF32[i301 >> 2])));
  f39 = Math_fround(HEAPF32[i269 >> 2]);
  f663 = Math_fround(f39 * Math_fround(HEAPF32[i329 >> 2]));
  f38 = Math_fround(HEAPF32[i261 >> 2]);
  f661 = Math_fround(f38 * Math_fround(HEAPF32[i303 >> 2]));
  f73 = Math_fround(HEAPF32[i262 >> 2]);
  f664 = Math_fround(f73 * Math_fround(HEAPF32[i304 >> 2]));
  f69 = Math_fround(HEAPF32[i263 >> 2]);
  f661 = Math_fround(f59 + f661);
  f664 = Math_fround(f673 + f664);
  f671 = Math_fround(f671 + Math_fround(f69 * Math_fround(HEAPF32[i305 >> 2])));
  HEAPF32[i345 >> 2] = Math_fround(f74 + f663);
  HEAPF32[i346 >> 2] = f661;
  HEAPF32[i347 >> 2] = f664;
  HEAPF32[i348 >> 2] = f671;
  f671 = Math_fround(f660 * Math_fround(HEAPF32[i306 >> 2]));
  f664 = Math_fround(f662 * Math_fround(HEAPF32[i307 >> 2]));
  f661 = Math_fround(f672 * Math_fround(HEAPF32[i308 >> 2]));
  f663 = Math_fround(f71 * Math_fround(HEAPF32[i309 >> 2]));
  f74 = Math_fround(f70 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f68 * Math_fround(HEAPF32[i311 >> 2]));
  f59 = Math_fround(f28 * Math_fround(HEAPF32[i312 >> 2]));
  f74 = Math_fround(f671 + f74);
  f673 = Math_fround(f664 + f673);
  f59 = Math_fround(f661 + f59);
  f663 = Math_fround(f663 + Math_fround(f72 * Math_fround(HEAPF32[i313 >> 2])));
  f661 = Math_fround(f39 * Math_fround(HEAPF32[i333 >> 2]));
  f664 = Math_fround(f38 * Math_fround(HEAPF32[i315 >> 2]));
  f671 = Math_fround(f73 * Math_fround(HEAPF32[i316 >> 2]));
  f664 = Math_fround(f673 + f664);
  f671 = Math_fround(f59 + f671);
  f663 = Math_fround(f663 + Math_fround(f69 * Math_fround(HEAPF32[i317 >> 2])));
  HEAPF32[i349 >> 2] = Math_fround(f74 + f661);
  HEAPF32[i350 >> 2] = f664;
  HEAPF32[i351 >> 2] = f671;
  HEAPF32[i352 >> 2] = f663;
  f660 = Math_fround(f660 * Math_fround(HEAPF32[i338 >> 2]));
  f662 = Math_fround(f662 * Math_fround(HEAPF32[i318 >> 2]));
  f672 = Math_fround(f672 * Math_fround(HEAPF32[i319 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i320 >> 2]));
  f70 = Math_fround(f70 * Math_fround(HEAPF32[i339 >> 2]));
  f68 = Math_fround(f68 * Math_fround(HEAPF32[i321 >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i322 >> 2]));
  f70 = Math_fround(f660 + f70);
  f68 = Math_fround(f662 + f68);
  f28 = Math_fround(f672 + f28);
  f72 = Math_fround(f71 + Math_fround(f72 * Math_fround(HEAPF32[i323 >> 2])));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i340 >> 2]));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i325 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i326 >> 2]));
  f38 = Math_fround(f68 + f38);
  f73 = Math_fround(f28 + f73);
  f69 = Math_fround(f72 + Math_fround(f69 * Math_fround(HEAPF32[i327 >> 2])));
  HEAPF32[i353 >> 2] = Math_fround(f70 + f39);
  HEAPF32[i354 >> 2] = f38;
  HEAPF32[i355 >> 2] = f73;
  HEAPF32[i356 >> 2] = f69;
  f69 = Math_fround(HEAPF32[i282 >> 2]);
  f73 = Math_fround(f69 * Math_fround(HEAPF32[i622 >> 2]));
  f38 = Math_fround(HEAPF32[i278 >> 2]);
  f39 = Math_fround(f38 * Math_fround(HEAPF32[i295 >> 2]));
  f70 = Math_fround(HEAPF32[i279 >> 2]);
  f72 = Math_fround(f70 * Math_fround(HEAPF32[i296 >> 2]));
  f28 = Math_fround(HEAPF32[i280 >> 2]);
  f68 = Math_fround(f28 * Math_fround(HEAPF32[i297 >> 2]));
  f71 = Math_fround(HEAPF32[i291 >> 2]);
  f672 = Math_fround(f71 * Math_fround(HEAPF32[i298 >> 2]));
  f662 = Math_fround(HEAPF32[i292 >> 2]);
  f660 = Math_fround(f662 * Math_fround(HEAPF32[i299 >> 2]));
  f663 = Math_fround(HEAPF32[i293 >> 2]);
  f671 = Math_fround(f663 * Math_fround(HEAPF32[i300 >> 2]));
  f664 = Math_fround(HEAPF32[i294 >> 2]);
  f672 = Math_fround(f73 + f672);
  f660 = Math_fround(f39 + f660);
  f671 = Math_fround(f72 + f671);
  f68 = Math_fround(f68 + Math_fround(f664 * Math_fround(HEAPF32[i301 >> 2])));
  f72 = Math_fround(HEAPF32[i268 >> 2]);
  f39 = Math_fround(f72 * Math_fround(HEAPF32[i329 >> 2]));
  f73 = Math_fround(HEAPF32[i265 >> 2]);
  f661 = Math_fround(f73 * Math_fround(HEAPF32[i303 >> 2]));
  f74 = Math_fround(HEAPF32[i266 >> 2]);
  f59 = Math_fround(f74 * Math_fround(HEAPF32[i304 >> 2]));
  f673 = Math_fround(HEAPF32[i267 >> 2]);
  f661 = Math_fround(f660 + f661);
  f59 = Math_fround(f671 + f59);
  f68 = Math_fround(f68 + Math_fround(f673 * Math_fround(HEAPF32[i305 >> 2])));
  HEAPF32[i357 >> 2] = Math_fround(f672 + f39);
  HEAPF32[i358 >> 2] = f661;
  HEAPF32[i359 >> 2] = f59;
  HEAPF32[i360 >> 2] = f68;
  f68 = Math_fround(f69 * Math_fround(HEAPF32[i306 >> 2]));
  f59 = Math_fround(f38 * Math_fround(HEAPF32[i307 >> 2]));
  f661 = Math_fround(f70 * Math_fround(HEAPF32[i308 >> 2]));
  f39 = Math_fround(f28 * Math_fround(HEAPF32[i309 >> 2]));
  f672 = Math_fround(f71 * Math_fround(HEAPF32[i310 >> 2]));
  f671 = Math_fround(f662 * Math_fround(HEAPF32[i311 >> 2]));
  f660 = Math_fround(f663 * Math_fround(HEAPF32[i312 >> 2]));
  f672 = Math_fround(f68 + f672);
  f671 = Math_fround(f59 + f671);
  f660 = Math_fround(f661 + f660);
  f39 = Math_fround(f39 + Math_fround(f664 * Math_fround(HEAPF32[i313 >> 2])));
  f661 = Math_fround(f72 * Math_fround(HEAPF32[i333 >> 2]));
  f59 = Math_fround(f73 * Math_fround(HEAPF32[i315 >> 2]));
  f68 = Math_fround(f74 * Math_fround(HEAPF32[i316 >> 2]));
  f59 = Math_fround(f671 + f59);
  f68 = Math_fround(f660 + f68);
  f39 = Math_fround(f39 + Math_fround(f673 * Math_fround(HEAPF32[i317 >> 2])));
  HEAPF32[i361 >> 2] = Math_fround(f672 + f661);
  HEAPF32[i362 >> 2] = f59;
  HEAPF32[i363 >> 2] = f68;
  HEAPF32[i364 >> 2] = f39;
  f69 = Math_fround(f69 * Math_fround(HEAPF32[i338 >> 2]));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i318 >> 2]));
  f70 = Math_fround(f70 * Math_fround(HEAPF32[i319 >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i320 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i339 >> 2]));
  f662 = Math_fround(f662 * Math_fround(HEAPF32[i321 >> 2]));
  f663 = Math_fround(f663 * Math_fround(HEAPF32[i322 >> 2]));
  f71 = Math_fround(f69 + f71);
  f662 = Math_fround(f38 + f662);
  f663 = Math_fround(f70 + f663);
  f664 = Math_fround(f28 + Math_fround(f664 * Math_fround(HEAPF32[i323 >> 2])));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i340 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i325 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i326 >> 2]));
  f73 = Math_fround(f662 + f73);
  f74 = Math_fround(f663 + f74);
  f673 = Math_fround(f664 + Math_fround(f673 * Math_fround(HEAPF32[i327 >> 2])));
  HEAPF32[i365 >> 2] = Math_fround(f71 + f72);
  HEAPF32[i366 >> 2] = f73;
  HEAPF32[i367 >> 2] = f74;
  HEAPF32[i368 >> 2] = f673;
  f74 = i14 ? f41 : Math_fround(0.0);
  f73 = i13 ? f40 : Math_fround(0.0);
  f72 = i16 ? f48 : Math_fround(0.0);
  f71 = i15 ? f34 : Math_fround(0.0);
  f664 = Math_fround(f79 - f74);
  f663 = Math_fround(f78 - f73);
  f662 = Math_fround(f80 - f72);
  f28 = Math_fround(f37 - f71);
  f70 = i14 ? f49 : Math_fround(0.0);
  f38 = Math_fround(f84 + f70);
  f69 = i13 ? f47 : Math_fround(0.0);
  f39 = Math_fround(f82 + f69);
  f68 = i16 ? f50 : Math_fround(0.0);
  f40 = Math_fround(f83 + f68);
  f59 = i15 ? f35 : Math_fround(0.0);
  f41 = Math_fround(f81 + f59);
  f661 = Math_fround(HEAPF32[i623 >> 2]);
  f672 = Math_fround(f664 * f661);
  f660 = Math_fround(HEAPF32[i330 >> 2]);
  f671 = Math_fround(f663 * f660);
  f659 = Math_fround(HEAPF32[i331 >> 2]);
  f670 = Math_fround(f662 * f659);
  f658 = Math_fround(HEAPF32[i332 >> 2]);
  f669 = Math_fround(f28 * f658);
  f685 = Math_fround(HEAPF32[i334 >> 2]);
  f30 = Math_fround(f38 * f685);
  f684 = Math_fround(HEAPF32[i335 >> 2]);
  f31 = Math_fround(f39 * f684);
  f683 = Math_fround(HEAPF32[i336 >> 2]);
  f32 = Math_fround(f40 * f683);
  f682 = Math_fround(HEAPF32[i337 >> 2]);
  f33 = Math_fround(f41 * f682);
  f60 = Math_fround(f672 + f30);
  f61 = Math_fround(f671 + f31);
  f62 = Math_fround(f670 + f32);
  f63 = Math_fround(f669 + f33);
  f27 = Math_fround(f77 * Math_fround(HEAPF32[i341 >> 2]));
  f649 = Math_fround(f75 * Math_fround(HEAPF32[i342 >> 2]));
  f648 = Math_fround(f76 * Math_fround(HEAPF32[i343 >> 2]));
  f647 = Math_fround(f36 * Math_fround(HEAPF32[i344 >> 2]));
  f60 = Math_fround(f60 + f27);
  f61 = Math_fround(f61 + f649);
  f62 = Math_fround(f62 + f648);
  f63 = Math_fround(f63 + f647);
  f657 = Math_fround(HEAPF32[i345 >> 2]);
  f668 = Math_fround(f664 * f657);
  f656 = Math_fround(HEAPF32[i346 >> 2]);
  f667 = Math_fround(f663 * f656);
  f655 = Math_fround(HEAPF32[i347 >> 2]);
  f666 = Math_fround(f662 * f655);
  f654 = Math_fround(HEAPF32[i348 >> 2]);
  f665 = Math_fround(f28 * f654);
  f681 = Math_fround(HEAPF32[i349 >> 2]);
  f34 = Math_fround(f38 * f681);
  f680 = Math_fround(HEAPF32[i350 >> 2]);
  f35 = Math_fround(f39 * f680);
  f679 = Math_fround(HEAPF32[i351 >> 2]);
  f687 = Math_fround(f40 * f679);
  f678 = Math_fround(HEAPF32[i352 >> 2]);
  f686 = Math_fround(f41 * f678);
  f64 = Math_fround(f668 + f34);
  f65 = Math_fround(f667 + f35);
  f66 = Math_fround(f666 + f687);
  f67 = Math_fround(f665 + f686);
  f646 = Math_fround(f77 * Math_fround(HEAPF32[i353 >> 2]));
  f645 = Math_fround(f75 * Math_fround(HEAPF32[i354 >> 2]));
  f644 = Math_fround(f76 * Math_fround(HEAPF32[i355 >> 2]));
  f22 = Math_fround(f36 * Math_fround(HEAPF32[i356 >> 2]));
  f64 = Math_fround(f64 + f646);
  f65 = Math_fround(f65 + f645);
  f66 = Math_fround(f66 + f644);
  f67 = Math_fround(f67 + f22);
  f653 = Math_fround(HEAPF32[i357 >> 2]);
  f664 = Math_fround(f664 * f653);
  f652 = Math_fround(HEAPF32[i358 >> 2]);
  f663 = Math_fround(f663 * f652);
  f651 = Math_fround(HEAPF32[i359 >> 2]);
  f662 = Math_fround(f662 * f651);
  f650 = Math_fround(HEAPF32[i360 >> 2]);
  f28 = Math_fround(f28 * f650);
  f677 = Math_fround(HEAPF32[i361 >> 2]);
  f38 = Math_fround(f38 * f677);
  f676 = Math_fround(HEAPF32[i362 >> 2]);
  f39 = Math_fround(f39 * f676);
  f29 = Math_fround(HEAPF32[i363 >> 2]);
  f40 = Math_fround(f40 * f29);
  f26 = Math_fround(HEAPF32[i364 >> 2]);
  f41 = Math_fround(f41 * f26);
  f47 = Math_fround(f664 + f38);
  f48 = Math_fround(f663 + f39);
  f49 = Math_fround(f662 + f40);
  f50 = Math_fround(f28 + f41);
  f23 = Math_fround(f77 * Math_fround(HEAPF32[i365 >> 2]));
  f24 = Math_fround(f75 * Math_fround(HEAPF32[i366 >> 2]));
  f25 = Math_fround(f76 * Math_fround(HEAPF32[i367 >> 2]));
  f673 = Math_fround(f36 * f673);
  f47 = Math_fround(f47 + f23);
  f48 = Math_fround(f48 + f24);
  f49 = Math_fround(f49 + f25);
  f50 = Math_fround(f673 + f50);
  f674 = Math_fround(f79 + f74);
  f675 = Math_fround(f78 + f73);
  f75 = Math_fround(f80 + f72);
  f76 = Math_fround(f37 + f71);
  f661 = Math_fround(f674 * f661);
  f660 = Math_fround(f675 * f660);
  f659 = Math_fround(f75 * f659);
  f658 = Math_fround(f76 * f658);
  f30 = Math_fround(Math_fround(f661 + f30) + f27);
  f31 = Math_fround(Math_fround(f660 + f31) + f649);
  f32 = Math_fround(Math_fround(f659 + f32) + f648);
  f33 = Math_fround(Math_fround(f658 + f33) + f647);
  f657 = Math_fround(f674 * f657);
  f656 = Math_fround(f675 * f656);
  f655 = Math_fround(f75 * f655);
  f654 = Math_fround(f76 * f654);
  f34 = Math_fround(Math_fround(f657 + f34) + f646);
  f35 = Math_fround(Math_fround(f656 + f35) + f645);
  f36 = Math_fround(Math_fround(f655 + f687) + f644);
  f37 = Math_fround(Math_fround(f654 + f686) + f22);
  f653 = Math_fround(f674 * f653);
  f652 = Math_fround(f675 * f652);
  f651 = Math_fround(f75 * f651);
  f650 = Math_fround(f76 * f650);
  f38 = Math_fround(Math_fround(f653 + f38) + f23);
  f39 = Math_fround(Math_fround(f652 + f39) + f24);
  f40 = Math_fround(Math_fround(f651 + f40) + f25);
  f41 = Math_fround(f673 + Math_fround(f650 + f41));
  f76 = Math_fround(f84 - f70);
  f75 = Math_fround(f82 - f69);
  f675 = Math_fround(f83 - f68);
  f674 = Math_fround(f81 - f59);
  f84 = Math_fround(f76 * f685);
  f83 = Math_fround(f75 * f684);
  f82 = Math_fround(f675 * f683);
  f81 = Math_fround(f674 * f682);
  f661 = Math_fround(Math_fround(f661 + f84) + f27);
  f660 = Math_fround(Math_fround(f660 + f83) + f649);
  f659 = Math_fround(Math_fround(f659 + f82) + f648);
  f658 = Math_fround(Math_fround(f658 + f81) + f647);
  f80 = Math_fround(f76 * f681);
  f79 = Math_fround(f75 * f680);
  f78 = Math_fround(f675 * f679);
  f77 = Math_fround(f674 * f678);
  f657 = Math_fround(Math_fround(f657 + f80) + f646);
  f656 = Math_fround(Math_fround(f656 + f79) + f645);
  f655 = Math_fround(Math_fround(f655 + f78) + f644);
  f654 = Math_fround(Math_fround(f654 + f77) + f22);
  f76 = Math_fround(f76 * f677);
  f75 = Math_fround(f75 * f676);
  f29 = Math_fround(f675 * f29);
  f26 = Math_fround(f674 * f26);
  f653 = Math_fround(Math_fround(f653 + f76) + f23);
  f652 = Math_fround(Math_fround(f652 + f75) + f24);
  f651 = Math_fround(Math_fround(f651 + f29) + f25);
  f650 = Math_fround(f673 + Math_fround(f650 + f26));
  f27 = Math_fround(Math_fround(f672 + f84) + f27);
  f649 = Math_fround(Math_fround(f671 + f83) + f649);
  f648 = Math_fround(Math_fround(f670 + f82) + f648);
  f647 = Math_fround(Math_fround(f669 + f81) + f647);
  f646 = Math_fround(Math_fround(f668 + f80) + f646);
  f645 = Math_fround(Math_fround(f667 + f79) + f645);
  f644 = Math_fround(Math_fround(f666 + f78) + f644);
  f22 = Math_fround(Math_fround(f665 + f77) + f22);
  f23 = Math_fround(Math_fround(f664 + f76) + f23);
  f24 = Math_fround(Math_fround(f663 + f75) + f24);
  f25 = Math_fround(Math_fround(f662 + f29) + f25);
  f26 = Math_fround(f673 + Math_fround(f28 + f26));
  f28 = Math_fround(HEAPF32[i620 >> 2]);
  f673 = Math_fround(f60 + f28);
  f29 = Math_fround(HEAPF32[i245 >> 2]);
  f662 = Math_fround(f61 + f29);
  f75 = Math_fround(HEAPF32[i246 >> 2]);
  f663 = Math_fround(f62 + f75);
  f76 = Math_fround(HEAPF32[i247 >> 2]);
  f664 = Math_fround(f63 + f76);
  f77 = Math_fround(HEAPF32[i248 >> 2]);
  f665 = Math_fround(f64 + f77);
  f78 = Math_fround(HEAPF32[i249 >> 2]);
  f666 = Math_fround(f65 + f78);
  f79 = Math_fround(HEAPF32[i250 >> 2]);
  f667 = Math_fround(f66 + f79);
  f80 = Math_fround(HEAPF32[i251 >> 2]);
  f668 = Math_fround(f67 + f80);
  f81 = Math_fround(HEAPF32[i252 >> 2]);
  f669 = Math_fround(f47 + f81);
  f82 = Math_fround(HEAPF32[i253 >> 2]);
  f670 = Math_fround(f48 + f82);
  f83 = Math_fround(HEAPF32[i254 >> 2]);
  f671 = Math_fround(f49 + f83);
  f84 = Math_fround(HEAPF32[i255 >> 2]);
  f672 = Math_fround(f50 + f84);
  HEAPF32[i619 >> 2] = f673;
  HEAPF32[i369 >> 2] = f662;
  HEAPF32[i370 >> 2] = f663;
  HEAPF32[i371 >> 2] = f664;
  HEAPF32[i372 >> 2] = f665;
  HEAPF32[i373 >> 2] = f666;
  HEAPF32[i374 >> 2] = f667;
  HEAPF32[i375 >> 2] = f668;
  HEAPF32[i376 >> 2] = f669;
  HEAPF32[i377 >> 2] = f670;
  HEAPF32[i378 >> 2] = f671;
  HEAPF32[i379 >> 2] = f672;
  f672 = Math_fround(f31 + f29);
  f671 = Math_fround(f32 + f75);
  f670 = Math_fround(f33 + f76);
  f669 = Math_fround(f34 + f77);
  f668 = Math_fround(f35 + f78);
  f667 = Math_fround(f36 + f79);
  f666 = Math_fround(f37 + f80);
  f665 = Math_fround(f38 + f81);
  f664 = Math_fround(f39 + f82);
  f663 = Math_fround(f40 + f83);
  f662 = Math_fround(f41 + f84);
  HEAPF32[i380 >> 2] = Math_fround(f30 + f28);
  HEAPF32[i381 >> 2] = f672;
  HEAPF32[i382 >> 2] = f671;
  HEAPF32[i383 >> 2] = f670;
  HEAPF32[i384 >> 2] = f669;
  HEAPF32[i385 >> 2] = f668;
  HEAPF32[i386 >> 2] = f667;
  HEAPF32[i387 >> 2] = f666;
  HEAPF32[i388 >> 2] = f665;
  HEAPF32[i389 >> 2] = f664;
  HEAPF32[i390 >> 2] = f663;
  HEAPF32[i391 >> 2] = f662;
  f660 = Math_fround(f660 + f29);
  f659 = Math_fround(f659 + f75);
  f658 = Math_fround(f658 + f76);
  f657 = Math_fround(f657 + f77);
  f656 = Math_fround(f656 + f78);
  f655 = Math_fround(f655 + f79);
  f654 = Math_fround(f654 + f80);
  f653 = Math_fround(f653 + f81);
  f652 = Math_fround(f652 + f82);
  f651 = Math_fround(f651 + f83);
  f650 = Math_fround(f650 + f84);
  HEAPF32[i392 >> 2] = Math_fround(f661 + f28);
  HEAPF32[i393 >> 2] = f660;
  HEAPF32[i394 >> 2] = f659;
  HEAPF32[i395 >> 2] = f658;
  HEAPF32[i396 >> 2] = f657;
  HEAPF32[i397 >> 2] = f656;
  HEAPF32[i398 >> 2] = f655;
  HEAPF32[i399 >> 2] = f654;
  HEAPF32[i400 >> 2] = f653;
  HEAPF32[i401 >> 2] = f652;
  HEAPF32[i402 >> 2] = f651;
  HEAPF32[i403 >> 2] = f650;
  f29 = Math_fround(f649 + f29);
  f75 = Math_fround(f648 + f75);
  f76 = Math_fround(f647 + f76);
  f77 = Math_fround(f646 + f77);
  f78 = Math_fround(f645 + f78);
  f79 = Math_fround(f644 + f79);
  f80 = Math_fround(f22 + f80);
  f81 = Math_fround(f23 + f81);
  f82 = Math_fround(f24 + f82);
  f83 = Math_fround(f25 + f83);
  f84 = Math_fround(f26 + f84);
  HEAPF32[i404 >> 2] = Math_fround(f27 + f28);
  HEAPF32[i405 >> 2] = f29;
  HEAPF32[i406 >> 2] = f75;
  HEAPF32[i407 >> 2] = f76;
  HEAPF32[i408 >> 2] = f77;
  HEAPF32[i409 >> 2] = f78;
  HEAPF32[i410 >> 2] = f79;
  HEAPF32[i411 >> 2] = f80;
  HEAPF32[i412 >> 2] = f81;
  HEAPF32[i413 >> 2] = f82;
  HEAPF32[i414 >> 2] = f83;
  HEAPF32[i415 >> 2] = f84;
  if (!i416) {
   i2 = HEAP32[i626 >> 2] | 0;
   if (i2 & 536870912) {
    i44 = HEAP32[i86 >> 2] | 0;
    f687 = Math_fround(HEAPF32[i44 + 564 >> 2]);
    i42 = HEAP32[i617 >> 2] | 0;
    i45 = i42 + 693089735 | 0;
    i20 = HEAP32[i236 >> 2] | 0;
    i57 = i20 + 693089735 | 0;
    i18 = HEAP32[i237 >> 2] | 0;
    i54 = i18 + 693089735 | 0;
    i16 = HEAP32[i238 >> 2] | 0;
    i51 = i16 + 693089735 | 0;
    i17 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i19 = (Math_imul(i57, 1790253981) | 0) + 1900727103 | 0;
    i21 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i43 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i45 = i45 << 11 ^ i45;
    i57 = i57 << 11 ^ i57;
    i54 = i54 << 11 ^ i54;
    i51 = i51 << 11 ^ i51;
    i17 = Math_fround(Math_fround((i17 ^ i45 ^ i45 >>> 8) & 8388607 ^ i17 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i19 = Math_fround(Math_fround((i19 ^ i57 ^ i57 >>> 8) & 8388607 ^ i19 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i21 = Math_fround(Math_fround((i21 ^ i54 ^ i54 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i43 = Math_fround(Math_fround((i43 ^ i51 ^ i51 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    f687 = Math_fround(HEAPF32[i44 + 568 >> 2]);
    i42 = i42 + 13945730 | 0;
    i20 = i20 + 13945730 | 0;
    i18 = i18 + 13945730 | 0;
    i16 = i16 + 13945730 | 0;
    i44 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i18, 1790253981) | 0) + 1900727103 | 0;
    i57 = (Math_imul(i16, 1790253981) | 0) + 1900727103 | 0;
    i42 = i42 << 11 ^ i42;
    i20 = i20 << 11 ^ i20;
    i18 = i18 << 11 ^ i18;
    i16 = i16 << 11 ^ i16;
    i44 = Math_fround(Math_fround((i44 ^ i42 ^ i42 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i51 = Math_fround(Math_fround((i51 ^ i20 ^ i20 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i54 = Math_fround(Math_fround((i54 ^ i18 ^ i18 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i57 = Math_fround(Math_fround((i57 ^ i16 ^ i16 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i16 = i17 & 1;
    i18 = i19 & 1;
    i20 = i21 & 1;
    i42 = i43 & 1;
    i45 = i17 & 1 ^ 1;
    i52 = i19 & 1 ^ 1;
    i55 = i21 & 1 ^ 1;
    i58 = i43 & 1 ^ 1;
    i46 = i17 ? 3 : 2;
    i53 = i19 ? 3 : 2;
    i56 = i21 ? 3 : 2;
    i2 = i43 ? 3 : 2;
    i17 = i17 ? 2 : 3;
    i19 = i19 ? 2 : 3;
    i21 = i21 ? 2 : 3;
    i43 = i43 ? 2 : 3;
    HEAP32[i640 >> 2] = i44 ? i17 : i16;
    HEAP32[i596 >> 2] = i51 ? i19 : i18;
    HEAP32[i595 >> 2] = i54 ? i21 : i20;
    HEAP32[i594 >> 2] = i57 ? i43 : i42;
    HEAP32[i575 >> 2] = i44 ? i16 : i17;
    HEAP32[i574 >> 2] = i51 ? i18 : i19;
    HEAP32[i573 >> 2] = i54 ? i20 : i21;
    HEAP32[i572 >> 2] = i57 ? i42 : i43;
    HEAP32[i567 >> 2] = i44 ? i46 : i45;
    HEAP32[i599 >> 2] = i51 ? i53 : i52;
    HEAP32[i598 >> 2] = i54 ? i56 : i55;
    HEAP32[i597 >> 2] = i57 ? i2 : i58;
    HEAP32[i571 >> 2] = i44 ? i45 : i46;
    HEAP32[i570 >> 2] = i51 ? i52 : i53;
    HEAP32[i569 >> 2] = i54 ? i55 : i56;
    HEAP32[i568 >> 2] = i57 ? i58 : i2;
    i2 = HEAP32[i626 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f22 = Math_fround(f629 * Math_fround(HEAPF32[i618 >> 2]));
    f23 = Math_fround(f629 * Math_fround(HEAPF32[i240 >> 2]));
    f24 = Math_fround(f629 * Math_fround(HEAPF32[i241 >> 2]));
    f25 = Math_fround(f629 * Math_fround(HEAPF32[i242 >> 2]));
    f26 = Math_fround(Math_floor(Math_fround(f22)));
    f27 = Math_fround(Math_floor(Math_fround(f23)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    if (i2 & 16777216 | 0) {
     f684 = Math_fround(Math_floor(Math_fround(f628 * f26)));
     f685 = Math_fround(Math_floor(Math_fround(f628 * f27)));
     f686 = Math_fround(Math_floor(Math_fround(f628 * f28)));
     f687 = Math_fround(Math_floor(Math_fround(f628 * f29)));
     f680 = Math_fround(f630 * Math_fround(f26 - Math_fround(f627 * f684)));
     f681 = Math_fround(f630 * Math_fround(f27 - Math_fround(f627 * f685)));
     f682 = Math_fround(f630 * Math_fround(f28 - Math_fround(f627 * f686)));
     f683 = Math_fround(f630 * Math_fround(f29 - Math_fround(f627 * f687)));
     f684 = Math_fround(f632 - Math_fround(f631 * f684));
     f685 = Math_fround(f632 - Math_fround(f631 * f685));
     f686 = Math_fround(f632 - Math_fround(f631 * f686));
     f687 = Math_fround(f632 - Math_fround(f631 * f687));
     f672 = Math_fround(f631 + f684);
     f673 = Math_fround(f631 + f685);
     f674 = Math_fround(f631 + f686);
     f675 = Math_fround(f631 + f687);
     HEAPF32[i641 >> 2] = f680;
     HEAPF32[i518 >> 2] = f681;
     HEAPF32[i542 >> 2] = f682;
     HEAPF32[i566 >> 2] = f683;
     HEAPF32[i494 >> 2] = f672;
     HEAPF32[i517 >> 2] = f673;
     HEAPF32[i541 >> 2] = f674;
     HEAPF32[i565 >> 2] = f675;
     f676 = Math_fround(f630 + f680);
     f677 = Math_fround(f630 + f681);
     f678 = Math_fround(f630 + f682);
     f679 = Math_fround(f630 + f683);
     HEAPF32[i493 >> 2] = f676;
     HEAPF32[i516 >> 2] = f677;
     HEAPF32[i540 >> 2] = f678;
     HEAPF32[i564 >> 2] = f679;
     HEAPF32[i492 >> 2] = f672;
     HEAPF32[i515 >> 2] = f673;
     HEAPF32[i539 >> 2] = f674;
     HEAPF32[i563 >> 2] = f675;
     HEAPF32[i491 >> 2] = f676;
     HEAPF32[i514 >> 2] = f677;
     HEAPF32[i538 >> 2] = f678;
     HEAPF32[i562 >> 2] = f679;
     HEAPF32[i490 >> 2] = f684;
     HEAPF32[i513 >> 2] = f685;
     HEAPF32[i537 >> 2] = f686;
     HEAPF32[i561 >> 2] = f687;
     HEAPF32[i489 >> 2] = f680;
     HEAPF32[i512 >> 2] = f681;
     HEAPF32[i536 >> 2] = f682;
     HEAPF32[i560 >> 2] = f683;
     HEAPF32[i488 >> 2] = f684;
     HEAPF32[i511 >> 2] = f685;
     HEAPF32[i535 >> 2] = f686;
     HEAPF32[i559 >> 2] = f687;
    }
    if (i2 & 33554432 | 0) {
     f676 = Math_fround(f26 + Math_fround(1.0));
     f677 = Math_fround(f27 + Math_fround(1.0));
     f678 = Math_fround(f28 + Math_fround(1.0));
     f679 = Math_fround(f29 + Math_fround(1.0));
     f684 = Math_fround(f22 - f26);
     f685 = Math_fround(f23 - f27);
     f686 = Math_fround(f24 - f28);
     f687 = Math_fround(f25 - f29);
     f680 = Math_fround(Math_floor(Math_fround(f628 * f676)));
     f681 = Math_fround(Math_floor(Math_fround(f628 * f677)));
     f682 = Math_fround(Math_floor(Math_fround(f628 * f678)));
     f683 = Math_fround(Math_floor(Math_fround(f628 * f679)));
     f676 = Math_fround(f630 * Math_fround(f676 - Math_fround(f627 * f680)));
     f677 = Math_fround(f630 * Math_fround(f677 - Math_fround(f627 * f681)));
     f678 = Math_fround(f630 * Math_fround(f678 - Math_fround(f627 * f682)));
     f679 = Math_fround(f630 * Math_fround(f679 - Math_fround(f627 * f683)));
     f680 = Math_fround(f632 - Math_fround(f631 * f680));
     f681 = Math_fround(f632 - Math_fround(f631 * f681));
     f682 = Math_fround(f632 - Math_fround(f631 * f682));
     f683 = Math_fround(f632 - Math_fround(f631 * f683));
     f668 = Math_fround(f631 + f680);
     f669 = Math_fround(f631 + f681);
     f670 = Math_fround(f631 + f682);
     f671 = Math_fround(f631 + f683);
     HEAPF32[i642 >> 2] = f676;
     HEAPF32[i510 >> 2] = f677;
     HEAPF32[i534 >> 2] = f678;
     HEAPF32[i558 >> 2] = f679;
     HEAPF32[i487 >> 2] = f668;
     HEAPF32[i509 >> 2] = f669;
     HEAPF32[i533 >> 2] = f670;
     HEAPF32[i557 >> 2] = f671;
     HEAPF32[i486 >> 2] = f684;
     HEAPF32[i508 >> 2] = f685;
     HEAPF32[i532 >> 2] = f686;
     HEAPF32[i556 >> 2] = f687;
     HEAPF32[i485 >> 2] = f22;
     HEAPF32[i507 >> 2] = f23;
     HEAPF32[i531 >> 2] = f24;
     HEAPF32[i555 >> 2] = f25;
     f672 = Math_fround(f630 + f676);
     f673 = Math_fround(f630 + f677);
     f674 = Math_fround(f630 + f678);
     f675 = Math_fround(f630 + f679);
     HEAPF32[i484 >> 2] = f672;
     HEAPF32[i506 >> 2] = f673;
     HEAPF32[i530 >> 2] = f674;
     HEAPF32[i554 >> 2] = f675;
     HEAPF32[i483 >> 2] = f668;
     HEAPF32[i505 >> 2] = f669;
     HEAPF32[i529 >> 2] = f670;
     HEAPF32[i553 >> 2] = f671;
     HEAPF32[i482 >> 2] = f684;
     HEAPF32[i504 >> 2] = f685;
     HEAPF32[i528 >> 2] = f686;
     HEAPF32[i552 >> 2] = f687;
     HEAPF32[i481 >> 2] = f22;
     HEAPF32[i503 >> 2] = f23;
     HEAPF32[i527 >> 2] = f24;
     HEAPF32[i551 >> 2] = f25;
     HEAPF32[i480 >> 2] = f672;
     HEAPF32[i502 >> 2] = f673;
     HEAPF32[i526 >> 2] = f674;
     HEAPF32[i550 >> 2] = f675;
     HEAPF32[i479 >> 2] = f680;
     HEAPF32[i501 >> 2] = f681;
     HEAPF32[i525 >> 2] = f682;
     HEAPF32[i549 >> 2] = f683;
     HEAPF32[i478 >> 2] = f684;
     HEAPF32[i500 >> 2] = f685;
     HEAPF32[i524 >> 2] = f686;
     HEAPF32[i548 >> 2] = f687;
     HEAPF32[i477 >> 2] = f22;
     HEAPF32[i499 >> 2] = f23;
     HEAPF32[i523 >> 2] = f24;
     HEAPF32[i547 >> 2] = f25;
     HEAPF32[i476 >> 2] = f676;
     HEAPF32[i498 >> 2] = f677;
     HEAPF32[i522 >> 2] = f678;
     HEAPF32[i546 >> 2] = f679;
     HEAPF32[i475 >> 2] = f680;
     HEAPF32[i497 >> 2] = f681;
     HEAPF32[i521 >> 2] = f682;
     HEAPF32[i545 >> 2] = f683;
     HEAPF32[i474 >> 2] = f684;
     HEAPF32[i496 >> 2] = f685;
     HEAPF32[i520 >> 2] = f686;
     HEAPF32[i544 >> 2] = f687;
     HEAPF32[i473 >> 2] = f22;
     HEAPF32[i495 >> 2] = f23;
     HEAPF32[i519 >> 2] = f24;
     HEAPF32[i543 >> 2] = f25;
    }
   }
  }
  f672 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f47 * f47)))));
  f673 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f48 * f48)))));
  f674 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f49 * f49)))));
  f675 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f50 * f50)))));
  f664 = Math_fround(f634 * Math_fround(f60 * f672));
  f665 = Math_fround(f634 * Math_fround(f61 * f673));
  f666 = Math_fround(f634 * Math_fround(f62 * f674));
  f667 = Math_fround(f634 * Math_fround(f63 * f675));
  f668 = Math_fround(f634 * Math_fround(f64 * f672));
  f669 = Math_fround(f634 * Math_fround(f65 * f673));
  f670 = Math_fround(f634 * Math_fround(f66 * f674));
  f671 = Math_fround(f634 * Math_fround(f67 * f675));
  f672 = Math_fround(f634 * Math_fround(f47 * f672));
  f673 = Math_fround(f634 * Math_fround(f48 * f673));
  f674 = Math_fround(f634 * Math_fround(f49 * f674));
  f675 = Math_fround(f634 * Math_fround(f50 * f675));
  f684 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f34 * f34)) + Math_fround(f38 * f38)))));
  f685 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35)) + Math_fround(f39 * f39)))));
  f686 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f36 * f36)) + Math_fround(f40 * f40)))));
  f687 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f37 * f37)) + Math_fround(f41 * f41)))));
  f676 = Math_fround(f634 * Math_fround(f30 * f684));
  f677 = Math_fround(f634 * Math_fround(f31 * f685));
  f678 = Math_fround(f634 * Math_fround(f32 * f686));
  f679 = Math_fround(f634 * Math_fround(f33 * f687));
  f680 = Math_fround(f634 * Math_fround(f34 * f684));
  f681 = Math_fround(f634 * Math_fround(f35 * f685));
  f682 = Math_fround(f634 * Math_fround(f36 * f686));
  f683 = Math_fround(f634 * Math_fround(f37 * f687));
  f684 = Math_fround(f634 * Math_fround(f38 * f684));
  f685 = Math_fround(f634 * Math_fround(f39 * f685));
  f686 = Math_fround(f634 * Math_fround(f40 * f686));
  f687 = Math_fround(f634 * Math_fround(f41 * f687));
  f663 = Math_fround(f608 + f665);
  f662 = Math_fround(f608 + f666);
  f661 = Math_fround(f608 + f667);
  f660 = Math_fround(f602 + f668);
  f659 = Math_fround(f602 + f669);
  f658 = Math_fround(f602 + f670);
  f657 = Math_fround(f602 + f671);
  f656 = Math_fround(f604 + f672);
  f655 = Math_fround(f604 + f673);
  f654 = Math_fround(f604 + f674);
  f653 = Math_fround(f604 + f675);
  HEAPF32[i621 >> 2] = Math_fround(f608 + f664);
  HEAPF32[i147 >> 2] = f663;
  HEAPF32[i164 >> 2] = f662;
  HEAPF32[i181 >> 2] = f661;
  HEAPF32[i417 >> 2] = f660;
  HEAPF32[i142 >> 2] = f659;
  HEAPF32[i159 >> 2] = f658;
  HEAPF32[i176 >> 2] = f657;
  HEAPF32[i418 >> 2] = f656;
  HEAPF32[i137 >> 2] = f655;
  HEAPF32[i154 >> 2] = f654;
  HEAPF32[i171 >> 2] = f653;
  f653 = Math_fround(f608 + f677);
  f654 = Math_fround(f608 + f678);
  f655 = Math_fround(f608 + f679);
  f656 = Math_fround(f602 + f680);
  f657 = Math_fround(f602 + f681);
  f658 = Math_fround(f602 + f682);
  f659 = Math_fround(f602 + f683);
  f660 = Math_fround(f604 + f684);
  f661 = Math_fround(f604 + f685);
  f662 = Math_fround(f604 + f686);
  f663 = Math_fround(f604 + f687);
  HEAPF32[i419 >> 2] = Math_fround(f608 + f676);
  HEAPF32[i146 >> 2] = f653;
  HEAPF32[i163 >> 2] = f654;
  HEAPF32[i180 >> 2] = f655;
  HEAPF32[i420 >> 2] = f656;
  HEAPF32[i141 >> 2] = f657;
  HEAPF32[i158 >> 2] = f658;
  HEAPF32[i175 >> 2] = f659;
  HEAPF32[i421 >> 2] = f660;
  HEAPF32[i136 >> 2] = f661;
  HEAPF32[i153 >> 2] = f662;
  HEAPF32[i170 >> 2] = f663;
  f665 = Math_fround(f608 - f665);
  f666 = Math_fround(f608 - f666);
  f667 = Math_fround(f608 - f667);
  f668 = Math_fround(f602 - f668);
  f669 = Math_fround(f602 - f669);
  f670 = Math_fround(f602 - f670);
  f671 = Math_fround(f602 - f671);
  f672 = Math_fround(f604 - f672);
  f673 = Math_fround(f604 - f673);
  f674 = Math_fround(f604 - f674);
  f675 = Math_fround(f604 - f675);
  HEAPF32[i422 >> 2] = Math_fround(f608 - f664);
  HEAPF32[i145 >> 2] = f665;
  HEAPF32[i162 >> 2] = f666;
  HEAPF32[i179 >> 2] = f667;
  HEAPF32[i423 >> 2] = f668;
  HEAPF32[i140 >> 2] = f669;
  HEAPF32[i157 >> 2] = f670;
  HEAPF32[i174 >> 2] = f671;
  HEAPF32[i424 >> 2] = f672;
  HEAPF32[i135 >> 2] = f673;
  HEAPF32[i152 >> 2] = f674;
  HEAPF32[i169 >> 2] = f675;
  f677 = Math_fround(f608 - f677);
  f678 = Math_fround(f608 - f678);
  f679 = Math_fround(f608 - f679);
  f680 = Math_fround(f602 - f680);
  f681 = Math_fround(f602 - f681);
  f682 = Math_fround(f602 - f682);
  f683 = Math_fround(f602 - f683);
  f684 = Math_fround(f604 - f684);
  f685 = Math_fround(f604 - f685);
  f686 = Math_fround(f604 - f686);
  f687 = Math_fround(f604 - f687);
  HEAPF32[i425 >> 2] = Math_fround(f608 - f676);
  HEAPF32[i144 >> 2] = f677;
  HEAPF32[i161 >> 2] = f678;
  HEAPF32[i178 >> 2] = f679;
  HEAPF32[i426 >> 2] = f680;
  HEAPF32[i139 >> 2] = f681;
  HEAPF32[i156 >> 2] = f682;
  HEAPF32[i173 >> 2] = f683;
  HEAPF32[i427 >> 2] = f684;
  HEAPF32[i134 >> 2] = f685;
  HEAPF32[i151 >> 2] = f686;
  HEAPF32[i168 >> 2] = f687;
  do if (i185) {
   i4 = HEAP32[i211 >> 2] | 0;
   i5 = HEAP32[i638 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i58 = i5 + (i2 + i85 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i619 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i621 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i392 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i404 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i425 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i58 >> 2];
     i58 = i641 + (HEAP32[i640 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i58 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i58 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i58 = i5 + (HEAP32[i4 + (i2 + i85 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i619 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i621 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i392 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i404 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i118 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i425 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i119 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i120 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i58 >> 2];
     i58 = i641 + (HEAP32[i640 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i58 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i58 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f675 = Math_fround(HEAPF32[i380 >> 2]);
   f675 = Math_fround(f675 - Math_fround(HEAPF32[i619 >> 2]));
   f677 = Math_fround(HEAPF32[i381 >> 2]);
   f677 = Math_fround(f677 - Math_fround(HEAPF32[i369 >> 2]));
   f678 = Math_fround(HEAPF32[i382 >> 2]);
   f678 = Math_fround(f678 - Math_fround(HEAPF32[i370 >> 2]));
   f679 = Math_fround(HEAPF32[i383 >> 2]);
   f679 = Math_fround(f679 - Math_fround(HEAPF32[i371 >> 2]));
   f680 = Math_fround(HEAPF32[i384 >> 2]);
   f680 = Math_fround(f680 - Math_fround(HEAPF32[i372 >> 2]));
   f687 = Math_fround(HEAPF32[i385 >> 2]);
   f687 = Math_fround(f687 - Math_fround(HEAPF32[i373 >> 2]));
   f686 = Math_fround(HEAPF32[i386 >> 2]);
   f686 = Math_fround(f686 - Math_fround(HEAPF32[i374 >> 2]));
   f685 = Math_fround(HEAPF32[i387 >> 2]);
   f685 = Math_fround(f685 - Math_fround(HEAPF32[i375 >> 2]));
   f684 = Math_fround(HEAPF32[i388 >> 2]);
   f684 = Math_fround(f684 - Math_fround(HEAPF32[i376 >> 2]));
   f672 = Math_fround(HEAPF32[i389 >> 2]);
   f672 = Math_fround(f672 - Math_fround(HEAPF32[i377 >> 2]));
   f673 = Math_fround(HEAPF32[i390 >> 2]);
   f673 = Math_fround(f673 - Math_fround(HEAPF32[i378 >> 2]));
   f674 = Math_fround(HEAPF32[i391 >> 2]);
   f674 = Math_fround(f674 - Math_fround(HEAPF32[i379 >> 2]));
   f676 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f675 * f675) + Math_fround(f680 * f680)) + Math_fround(f684 * f684)))));
   f683 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f677 * f677) + Math_fround(f687 * f687)) + Math_fround(f672 * f672)))));
   f682 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f678 * f678) + Math_fround(f686 * f686)) + Math_fround(f673 * f673)))));
   f681 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f679 * f679) + Math_fround(f685 * f685)) + Math_fround(f674 * f674)))));
   f677 = Math_fround(f677 * f683);
   f678 = Math_fround(f678 * f682);
   f679 = Math_fround(f679 * f681);
   f680 = Math_fround(f680 * f676);
   f687 = Math_fround(f687 * f683);
   f686 = Math_fround(f686 * f682);
   f685 = Math_fround(f685 * f681);
   f684 = Math_fround(f684 * f676);
   f683 = Math_fround(f672 * f683);
   f682 = Math_fround(f673 * f682);
   f681 = Math_fround(f674 * f681);
   HEAPF32[i622 >> 2] = Math_fround(f675 * f676);
   HEAPF32[i148 >> 2] = f677;
   HEAPF32[i165 >> 2] = f678;
   HEAPF32[i182 >> 2] = f679;
   HEAPF32[i428 >> 2] = f680;
   HEAPF32[i143 >> 2] = f687;
   HEAPF32[i160 >> 2] = f686;
   HEAPF32[i177 >> 2] = f685;
   HEAPF32[i429 >> 2] = f684;
   HEAPF32[i138 >> 2] = f683;
   HEAPF32[i155 >> 2] = f682;
   HEAPF32[i172 >> 2] = f681;
   f681 = Math_fround(f73 * Math_fround(2.0));
   f682 = Math_fround(f72 * Math_fround(2.0));
   f683 = Math_fround(f71 * Math_fround(2.0));
   f684 = Math_fround(f70 * Math_fround(2.0));
   f685 = Math_fround(f69 * Math_fround(2.0));
   f686 = Math_fround(f68 * Math_fround(2.0));
   f687 = Math_fround(f59 * Math_fround(2.0));
   HEAPF32[i623 >> 2] = Math_fround(f74 * Math_fround(2.0));
   HEAPF32[i150 >> 2] = f681;
   HEAPF32[i167 >> 2] = f682;
   HEAPF32[i184 >> 2] = f683;
   HEAPF32[i430 >> 2] = f684;
   HEAPF32[i149 >> 2] = f685;
   HEAPF32[i166 >> 2] = f686;
   HEAPF32[i183 >> 2] = f687;
   HEAP32[i133 >> 2] = 0;
   HEAP32[i133 + 4 >> 2] = 0;
   HEAP32[i133 + 8 >> 2] = 0;
   HEAP32[i133 + 12 >> 2] = 0;
   if (i431) {
    f667 = Math_fround(HEAPF32[i613 >> 2]);
    f685 = Math_fround(f576 * f667);
    f669 = Math_fround(HEAPF32[i204 >> 2]);
    f676 = Math_fround(f576 * f669);
    f671 = Math_fround(HEAPF32[i203 >> 2]);
    f684 = Math_fround(f576 * f671);
    f673 = Math_fround(HEAPF32[i202 >> 2]);
    f679 = Math_fround(f576 * f673);
    f668 = Math_fround(HEAPF32[i432 >> 2]);
    f675 = Math_fround(f579 * f668);
    f670 = Math_fround(HEAPF32[i207 >> 2]);
    f681 = Math_fround(f579 * f670);
    f672 = Math_fround(HEAPF32[i206 >> 2]);
    f680 = Math_fround(f579 * f672);
    f674 = Math_fround(HEAPF32[i205 >> 2]);
    f675 = Math_fround(f685 + f675);
    f681 = Math_fround(f676 + f681);
    f680 = Math_fround(f684 + f680);
    f679 = Math_fround(f679 + Math_fround(f579 * f674));
    f684 = Math_fround(HEAPF32[i433 >> 2]);
    f676 = Math_fround(f582 * f684);
    f685 = Math_fround(HEAPF32[i210 >> 2]);
    f677 = Math_fround(f582 * f685);
    f686 = Math_fround(HEAPF32[i209 >> 2]);
    f678 = Math_fround(f582 * f686);
    f687 = Math_fround(HEAPF32[i208 >> 2]);
    f677 = Math_fround(f681 + f677);
    f678 = Math_fround(f680 + f678);
    f679 = Math_fround(f679 + Math_fround(f582 * f687));
    f680 = Math_fround(Math_fround(Math_fround(f577 * f667) + Math_fround(f580 * f668)) + Math_fround(f583 * f684));
    f681 = Math_fround(Math_fround(Math_fround(f577 * f669) + Math_fround(f580 * f670)) + Math_fround(f583 * f685));
    f682 = Math_fround(Math_fround(Math_fround(f577 * f671) + Math_fround(f580 * f672)) + Math_fround(f583 * f686));
    f683 = Math_fround(Math_fround(Math_fround(f577 * f673) + Math_fround(f580 * f674)) + Math_fround(f583 * f687));
    f684 = Math_fround(Math_fround(Math_fround(f578 * f667) + Math_fround(f581 * f668)) + Math_fround(f584 * f684));
    f685 = Math_fround(Math_fround(Math_fround(f578 * f669) + Math_fround(f581 * f670)) + Math_fround(f584 * f685));
    f686 = Math_fround(Math_fround(Math_fround(f578 * f671) + Math_fround(f581 * f672)) + Math_fround(f584 * f686));
    f687 = Math_fround(Math_fround(Math_fround(f578 * f673) + Math_fround(f581 * f674)) + Math_fround(f584 * f687));
    HEAPF32[i624 >> 2] = Math_fround(f675 + f676);
    HEAPF32[i434 >> 2] = f677;
    HEAPF32[i435 >> 2] = f678;
    HEAPF32[i436 >> 2] = f679;
    HEAPF32[i437 >> 2] = f680;
    HEAPF32[i438 >> 2] = f681;
    HEAPF32[i439 >> 2] = f682;
    HEAPF32[i440 >> 2] = f683;
    HEAPF32[i441 >> 2] = f684;
    HEAPF32[i442 >> 2] = f685;
    HEAPF32[i443 >> 2] = f686;
    HEAPF32[i444 >> 2] = f687;
   }
   if (i445) {
    i52 = HEAP32[i617 >> 2] | 0;
    i55 = i52 + 1068538453 | 0;
    i56 = HEAP32[i236 >> 2] | 0;
    i54 = i56 + 1068538453 | 0;
    i45 = HEAP32[i237 >> 2] | 0;
    i44 = i45 + 1068538453 | 0;
    i43 = HEAP32[i238 >> 2] | 0;
    i51 = i43 + 1068538453 | 0;
    i57 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i58 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i55 = i55 << 11 ^ i55;
    i54 = i54 << 11 ^ i54;
    i44 = i44 << 11 ^ i44;
    i51 = i51 << 11 ^ i51;
    f685 = Math_fround(Math_fround((i46 ^ i54 ^ i54 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i58 ^ i44 ^ i44 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i53 ^ i51 ^ i51 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i625 >> 2] = Math_fround(Math_fround((i57 ^ i55 ^ i55 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i446 >> 2] = f685;
    HEAPF32[i447 >> 2] = f686;
    HEAPF32[i448 >> 2] = f687;
    i52 = i52 + 1068538454 | 0;
    i56 = i56 + 1068538454 | 0;
    i45 = i45 + 1068538454 | 0;
    i43 = i43 + 1068538454 | 0;
    i57 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i55 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
    i52 = i52 << 11 ^ i52;
    i56 = i56 << 11 ^ i56;
    i45 = i45 << 11 ^ i45;
    i43 = i43 << 11 ^ i43;
    f687 = Math_fround(Math_fround((i55 ^ i56 ^ i56 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i53 ^ i45 ^ i45 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f685 = Math_fround(Math_fround((i51 ^ i43 ^ i43 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i449 >> 2] = Math_fround(Math_fround((i57 ^ i52 ^ i52 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i450 >> 2] = f687;
    HEAPF32[i451 >> 2] = f686;
    HEAPF32[i452 >> 2] = f685;
    i57 = HEAP32[i617 >> 2] | 0;
    i52 = i57 + 1068538455 | 0;
    i51 = HEAP32[i236 >> 2] | 0;
    i43 = i51 + 1068538455 | 0;
    i53 = HEAP32[i237 >> 2] | 0;
    i45 = i53 + 1068538455 | 0;
    i55 = HEAP32[i238 >> 2] | 0;
    i56 = i55 + 1068538455 | 0;
    i58 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i52 = i52 << 11 ^ i52;
    i43 = i43 << 11 ^ i43;
    i45 = i45 << 11 ^ i45;
    i56 = i56 << 11 ^ i56;
    f685 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i54 ^ i56 ^ i56 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i453 >> 2] = Math_fround(Math_fround((i58 ^ i52 ^ i52 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = f685;
    HEAPF32[i455 >> 2] = f686;
    HEAPF32[i456 >> 2] = f687;
    f687 = Math_fround(Math_fround(HEAPF32[i616 >> 2]) * Math_fround(1.0e5));
    f686 = Math_fround(Math_fround(HEAPF32[i232 >> 2]) * Math_fround(1.0e5));
    f685 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) * Math_fround(1.0e5));
    i57 = i57 + 1068538453 + ~~f687 | 0;
    i51 = i51 + 1068538453 + ~~f686 | 0;
    i53 = i53 + 1068538453 + ~~f685 | 0;
    i55 = i55 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i234 >> 2]) * Math_fround(1.0e5)) | 0;
    i58 = (Math_imul(i57, 1790253981) | 0) + 1900727103 | 0;
    i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
    i56 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
    i57 = i57 << 11 ^ i57;
    i51 = i51 << 11 ^ i51;
    i53 = i53 << 11 ^ i53;
    i55 = i55 << 11 ^ i55;
    f685 = Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i54 ^ i53 ^ i53 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i56 ^ i55 ^ i55 >>> 8) & 8388607 ^ i56 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i457 >> 2] = Math_fround(Math_fround((i58 ^ i57 ^ i57 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i458 >> 2] = f685;
    HEAPF32[i459 >> 2] = f686;
    HEAPF32[i460 >> 2] = f687;
   }
   i51 = HEAP32[i211 >> 2] | 0;
   i52 = (i51 | 0) == 0;
   i53 = HEAP32[i125 >> 2] | 0;
   i54 = HEAP32[i127 >> 2] | 0;
   i55 = HEAP32[i231 >> 2] | 0;
   i56 = HEAP32[i128 >> 2] | 0;
   i57 = HEAP32[i214 >> 2] | 0;
   i58 = HEAP32[i638 >> 2] | 0;
   i46 = 0;
   do {
    i2 = i46 + i85 | 0;
    if (!i52) i2 = HEAP32[i51 + (i2 << 3) >> 2] | 0;
    i5 = i624 + (i46 << 2) | 0;
    i6 = i468 + (i46 << 2) | 0;
    i7 = i469 + (i46 << 2) | 0;
    i8 = i625 + (i46 << 2) | 0;
    i9 = i449 + (i46 << 2) | 0;
    i10 = i453 + (i46 << 2) | 0;
    i11 = i457 + (i46 << 2) | 0;
    i12 = i622 + (i46 << 2) | 0;
    i13 = i122 + (i46 << 2) | 0;
    i14 = i123 + (i46 << 2) | 0;
    i15 = i53 + (i2 << 4) | 0;
    i16 = i54 + (i2 << 4) | 0;
    i17 = i55 + (i2 << 2) | 0;
    i18 = i56 + (i2 << 2) | 0;
    i19 = i57 + (i2 << 2) | 0;
    i20 = i623 + (i46 << 2) | 0;
    i21 = i129 + (i46 << 2) | 0;
    i42 = i130 + (i46 << 2) | 0;
    i43 = i620 + (i46 << 2) | 0;
    i44 = i131 + (i46 << 2) | 0;
    i45 = i132 + (i46 << 2) | 0;
    i4 = i58 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i619 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i46 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i46 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i46 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i461) {
      i688 = i621 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i688 + 32 + (i46 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i462) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i463) {
      i688 = i641 + (HEAP32[i640 + ((i3 << 2) + i46 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i464) {
      i688 = i642 + (HEAP32[i640 + ((i3 << 2) + i46 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 32 + (i46 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 48 + (i46 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i465) {
      f687 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i44 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i45 >> 2];
      HEAPF32[i1 + 12 >> 2] = f687;
      i1 = i1 + 16 | 0;
     }
     if (!i466) {
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i42 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i467) {
      i688 = HEAP32[i19 >> 2] | 0;
      HEAP32[i1 >> 2] = i688;
      HEAP32[i1 + 4 >> 2] = i688;
      HEAP32[i1 + 8 >> 2] = i688;
      i1 = i1 + 12 | 0;
     }
     if (i431) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i470) {
      f687 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(.00999999977));
      i688 = HEAP32[i18 >> 2] | 0;
      HEAPF32[i1 >> 2] = f687;
      HEAP32[i1 + 4 >> 2] = i688;
      i1 = i1 + 8 | 0;
     }
     if (!i471) {
      i688 = (HEAP32[i126 >> 2] & 2147483647 | 0) == 0 ? i610 : i16;
      HEAP32[i1 >> 2] = HEAP32[i688 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i472) {
      i688 = (HEAP32[i124 >> 2] & 2147483647 | 0) == 0 ? i610 : i15;
      HEAP32[i1 >> 2] = HEAP32[i688 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i445) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i121) {
      HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i14 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i46 = i46 + 1 | 0;
   } while ((i46 | 0) != 4);
  } while (0);
  i85 = i85 + 4 | 0;
 } while (i85 >>> 0 < i186 >>> 0);
 STACKTOP = i643;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i633, i638) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i633 = i633 | 0;
 i638 = i638 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, i564 = 0, i565 = 0, i566 = 0, i567 = 0, i568 = 0, i569 = 0, i570 = 0, i571 = 0, i572 = 0, i573 = 0, i574 = 0, i575 = 0, f576 = f0, f577 = f0, f578 = f0, f579 = f0, f580 = f0, f581 = f0, f582 = f0, f583 = f0, f584 = f0, f585 = f0, f586 = f0, f587 = f0, f588 = f0, f589 = f0, f590 = f0, f591 = f0, f592 = f0, f593 = f0, i594 = 0, i595 = 0, i596 = 0, i597 = 0, i598 = 0, i599 = 0, f600 = f0, f601 = f0, f602 = f0, f603 = f0, f604 = f0, f605 = f0, f606 = f0, f607 = f0, f608 = f0, f609 = f0, i610 = 0, i611 = 0, i612 = 0, i613 = 0, i614 = 0, i615 = 0, i616 = 0, i617 = 0, i618 = 0, i619 = 0, i620 = 0, i621 = 0, i622 = 0, i623 = 0, i624 = 0, i625 = 0, i626 = 0, f627 = f0, f628 = f0, f629 = f0, f630 = f0, f631 = f0, f632 = f0, f634 = f0, f635 = f0, f636 = f0, f637 = f0, f639 = f0, i640 = 0, i641 = 0, i642 = 0, i643 = 0, f644 = f0, f645 = f0, f646 = f0, f647 = f0, f648 = f0, f649 = f0, f650 = f0, f651 = f0, f652 = f0, f653 = f0, f654 = f0, f655 = f0, f656 = f0, f657 = f0, f658 = f0, f659 = f0, f660 = f0, f661 = f0, f662 = f0, f663 = f0, f664 = f0, f665 = f0, f666 = f0, f667 = f0, f668 = f0, f669 = f0, f670 = f0, f671 = f0, f672 = f0, f673 = f0, f674 = f0, f675 = f0, f676 = f0, f677 = f0, f678 = f0, f679 = f0, f680 = f0, f681 = f0, f682 = f0, f683 = f0, f684 = f0, f685 = f0, f686 = f0, f687 = f0, i688 = 0;
 i643 = STACKTOP;
 STACKTOP = STACKTOP + 1632 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i640 = i643 + 1560 | 0;
 i641 = i643 + 1432 | 0;
 i642 = i643 + 1176 | 0;
 i6 = i643 + 1112 | 0;
 i4 = i643 + 1072 | 0;
 i610 = i643 + 1056 | 0;
 i611 = i643 + 1008 | 0;
 i612 = i643 + 960 | 0;
 i613 = i643 + 912 | 0;
 i614 = i643 + 896 | 0;
 i615 = i643 + 880 | 0;
 i616 = i643 + 864 | 0;
 i617 = i643 + 848 | 0;
 i618 = i643 + 832 | 0;
 i619 = i643 + 640 | 0;
 i620 = i643 + 592 | 0;
 i621 = i643 + 400 | 0;
 i622 = i643 + 256 | 0;
 i623 = i643 + 112 | 0;
 i624 = i643 + 64 | 0;
 i625 = i643;
 i626 = i3 + 332 | 0;
 f627 = Math_fround((HEAP32[i626 >> 2] & 4095) >>> 0);
 f628 = Math_fround(Math_fround(1.0) / f627);
 f629 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f630 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f631 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f632 = Math_fround(Math_fround(1.0) - f631);
 i5 = i3 + 420 | 0;
 f634 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f608 = Math_fround(HEAPF32[i2 >> 2]);
 f602 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f604 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f635 = Math_fround(HEAPF32[i2 >> 2]);
 f636 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f637 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f639 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f607 = Math_fround(HEAPF32[i2 >> 2]);
 f601 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f606 = Math_fround(HEAPF32[i2 >> 2]);
 f600 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 36 | 0;
 f609 = Math_fround(HEAPF32[i7 >> 2]);
 f603 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f605 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f576 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f577 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f578 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f579 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f580 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f581 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f582 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f583 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f584 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f585 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f586 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f587 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 f588 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f589 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f590 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f591 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f592 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f593 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 i594 = i640 + 12 | 0;
 i595 = i640 + 8 | 0;
 i596 = i640 + 4 | 0;
 i597 = i640 + 28 | 0;
 HEAP32[i640 >> 2] = 0;
 HEAP32[i640 + 4 >> 2] = 0;
 HEAP32[i640 + 8 >> 2] = 0;
 HEAP32[i640 + 12 >> 2] = 0;
 HEAP32[i597 >> 2] = 1;
 i598 = i640 + 24 | 0;
 HEAP32[i598 >> 2] = 1;
 i599 = i640 + 20 | 0;
 HEAP32[i599 >> 2] = 1;
 i567 = i640 + 16 | 0;
 HEAP32[i567 >> 2] = 1;
 i568 = i640 + 44 | 0;
 HEAP32[i568 >> 2] = 2;
 i569 = i640 + 40 | 0;
 HEAP32[i569 >> 2] = 2;
 i570 = i640 + 36 | 0;
 HEAP32[i570 >> 2] = 2;
 i571 = i640 + 32 | 0;
 HEAP32[i571 >> 2] = 2;
 i572 = i640 + 60 | 0;
 HEAP32[i572 >> 2] = 3;
 i573 = i640 + 56 | 0;
 HEAP32[i573 >> 2] = 3;
 i574 = i640 + 52 | 0;
 HEAP32[i574 >> 2] = 3;
 i575 = i640 + 48 | 0;
 HEAP32[i575 >> 2] = 3;
 i518 = i641 + 4 | 0;
 i542 = i641 + 8 | 0;
 i566 = i641 + 12 | 0;
 i494 = i641 + 16 | 0;
 HEAP32[i641 >> 2] = 0;
 HEAP32[i641 + 4 >> 2] = 0;
 HEAP32[i641 + 8 >> 2] = 0;
 HEAP32[i641 + 12 >> 2] = 0;
 HEAPF32[i494 >> 2] = Math_fround(1.0);
 i517 = i641 + 20 | 0;
 HEAPF32[i517 >> 2] = Math_fround(1.0);
 i541 = i641 + 24 | 0;
 HEAPF32[i541 >> 2] = Math_fround(1.0);
 i565 = i641 + 28 | 0;
 HEAPF32[i565 >> 2] = Math_fround(1.0);
 i493 = i641 + 32 | 0;
 HEAPF32[i493 >> 2] = Math_fround(1.0);
 i516 = i641 + 36 | 0;
 HEAPF32[i516 >> 2] = Math_fround(1.0);
 i540 = i641 + 40 | 0;
 HEAPF32[i540 >> 2] = Math_fround(1.0);
 i564 = i641 + 44 | 0;
 HEAPF32[i564 >> 2] = Math_fround(1.0);
 i492 = i641 + 48 | 0;
 HEAPF32[i492 >> 2] = Math_fround(1.0);
 i515 = i641 + 52 | 0;
 HEAPF32[i515 >> 2] = Math_fround(1.0);
 i539 = i641 + 56 | 0;
 HEAPF32[i539 >> 2] = Math_fround(1.0);
 i563 = i641 + 60 | 0;
 HEAPF32[i563 >> 2] = Math_fround(1.0);
 i491 = i641 + 64 | 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i514 = i641 + 68 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i641 + 72 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i641 + 76 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i490 = i641 + 80 | 0;
 i513 = i641 + 84 | 0;
 i537 = i641 + 88 | 0;
 i561 = i641 + 92 | 0;
 i489 = i641 + 96 | 0;
 i512 = i641 + 100 | 0;
 i536 = i641 + 104 | 0;
 i560 = i641 + 108 | 0;
 i488 = i641 + 112 | 0;
 i511 = i641 + 116 | 0;
 i535 = i641 + 120 | 0;
 i559 = i641 + 124 | 0;
 i10 = i490;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i510 = i642 + 4 | 0;
 i534 = i642 + 8 | 0;
 i558 = i642 + 12 | 0;
 i487 = i642 + 16 | 0;
 HEAP32[i642 >> 2] = 0;
 HEAP32[i642 + 4 >> 2] = 0;
 HEAP32[i642 + 8 >> 2] = 0;
 HEAP32[i642 + 12 >> 2] = 0;
 HEAPF32[i487 >> 2] = Math_fround(1.0);
 i509 = i642 + 20 | 0;
 HEAPF32[i509 >> 2] = Math_fround(1.0);
 i533 = i642 + 24 | 0;
 HEAPF32[i533 >> 2] = Math_fround(1.0);
 i557 = i642 + 28 | 0;
 HEAPF32[i557 >> 2] = Math_fround(1.0);
 i486 = i642 + 32 | 0;
 i508 = i642 + 36 | 0;
 i532 = i642 + 40 | 0;
 i556 = i642 + 44 | 0;
 i485 = i642 + 48 | 0;
 i507 = i642 + 52 | 0;
 i531 = i642 + 56 | 0;
 i555 = i642 + 60 | 0;
 i484 = i642 + 64 | 0;
 HEAP32[i486 >> 2] = 0;
 HEAP32[i486 + 4 >> 2] = 0;
 HEAP32[i486 + 8 >> 2] = 0;
 HEAP32[i486 + 12 >> 2] = 0;
 HEAP32[i486 + 16 >> 2] = 0;
 HEAP32[i486 + 20 >> 2] = 0;
 HEAP32[i486 + 24 >> 2] = 0;
 HEAP32[i486 + 28 >> 2] = 0;
 HEAPF32[i484 >> 2] = Math_fround(1.0);
 i506 = i642 + 68 | 0;
 HEAPF32[i506 >> 2] = Math_fround(1.0);
 i530 = i642 + 72 | 0;
 HEAPF32[i530 >> 2] = Math_fround(1.0);
 i554 = i642 + 76 | 0;
 HEAPF32[i554 >> 2] = Math_fround(1.0);
 i483 = i642 + 80 | 0;
 HEAPF32[i483 >> 2] = Math_fround(1.0);
 i505 = i642 + 84 | 0;
 HEAPF32[i505 >> 2] = Math_fround(1.0);
 i529 = i642 + 88 | 0;
 HEAPF32[i529 >> 2] = Math_fround(1.0);
 i553 = i642 + 92 | 0;
 HEAPF32[i553 >> 2] = Math_fround(1.0);
 i482 = i642 + 96 | 0;
 i504 = i642 + 100 | 0;
 i528 = i642 + 104 | 0;
 i552 = i642 + 108 | 0;
 i481 = i642 + 112 | 0;
 i503 = i642 + 116 | 0;
 i527 = i642 + 120 | 0;
 i551 = i642 + 124 | 0;
 i480 = i642 + 128 | 0;
 HEAP32[i482 >> 2] = 0;
 HEAP32[i482 + 4 >> 2] = 0;
 HEAP32[i482 + 8 >> 2] = 0;
 HEAP32[i482 + 12 >> 2] = 0;
 HEAP32[i482 + 16 >> 2] = 0;
 HEAP32[i482 + 20 >> 2] = 0;
 HEAP32[i482 + 24 >> 2] = 0;
 HEAP32[i482 + 28 >> 2] = 0;
 HEAPF32[i480 >> 2] = Math_fround(1.0);
 i502 = i642 + 132 | 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i526 = i642 + 136 | 0;
 HEAPF32[i526 >> 2] = Math_fround(1.0);
 i550 = i642 + 140 | 0;
 HEAPF32[i550 >> 2] = Math_fround(1.0);
 i479 = i642 + 144 | 0;
 i501 = i642 + 148 | 0;
 i525 = i642 + 152 | 0;
 i549 = i642 + 156 | 0;
 i478 = i642 + 160 | 0;
 i500 = i642 + 164 | 0;
 i524 = i642 + 168 | 0;
 i548 = i642 + 172 | 0;
 i477 = i642 + 176 | 0;
 i499 = i642 + 180 | 0;
 i523 = i642 + 184 | 0;
 i547 = i642 + 188 | 0;
 i476 = i642 + 192 | 0;
 i498 = i642 + 196 | 0;
 i522 = i642 + 200 | 0;
 i546 = i642 + 204 | 0;
 i475 = i642 + 208 | 0;
 i497 = i642 + 212 | 0;
 i521 = i642 + 216 | 0;
 i545 = i642 + 220 | 0;
 i474 = i642 + 224 | 0;
 i496 = i642 + 228 | 0;
 i520 = i642 + 232 | 0;
 i544 = i642 + 236 | 0;
 i473 = i642 + 240 | 0;
 i495 = i642 + 244 | 0;
 i519 = i642 + 248 | 0;
 i543 = i642 + 252 | 0;
 i10 = i479;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f73 = Math_fround(HEAPF32[i5 >> 2]);
 f65 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f72 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f74 = Math_fround(HEAPF32[i4 >> 2]);
 i467 = i4 + 4 | 0;
 f77 = Math_fround(HEAPF32[i467 >> 2]);
 i468 = i4 + 8 | 0;
 f78 = Math_fround(HEAPF32[i468 >> 2]);
 i469 = i4 + 12 | 0;
 f68 = Math_fround(HEAPF32[i469 >> 2]);
 i470 = i4 + 16 | 0;
 f64 = Math_fround(HEAPF32[i470 >> 2]);
 i471 = i4 + 20 | 0;
 f81 = Math_fround(HEAPF32[i471 >> 2]);
 i472 = i4 + 24 | 0;
 f70 = Math_fround(HEAPF32[i472 >> 2]);
 i186 = i4 + 28 | 0;
 f66 = Math_fround(HEAPF32[i186 >> 2]);
 i185 = i4 + 32 | 0;
 f84 = Math_fround(HEAPF32[i185 >> 2]);
 f75 = Math_fround(f77 * Math_fround(0.0));
 f76 = Math_fround(f78 * Math_fround(0.0));
 f69 = Math_fround(f64 * Math_fround(0.0));
 f80 = Math_fround(f81 * Math_fround(0.0));
 f79 = Math_fround(Math_fround(Math_fround(f73 * f68) + f69) + f80);
 f71 = Math_fround(f66 * Math_fround(0.0));
 f83 = Math_fround(f84 * Math_fround(0.0));
 f82 = Math_fround(Math_fround(Math_fround(f73 * f70) + f71) + f83);
 f67 = Math_fround(f74 * Math_fround(0.0));
 f77 = Math_fround(Math_fround(f67 + Math_fround(f65 * f77)) + f76);
 f68 = Math_fround(f68 * Math_fround(0.0));
 f80 = Math_fround(Math_fround(f68 + Math_fround(f65 * f64)) + f80);
 f70 = Math_fround(f70 * Math_fround(0.0));
 f83 = Math_fround(Math_fround(f70 + Math_fround(f65 * f66)) + f83);
 f78 = Math_fround(Math_fround(f67 + f75) + Math_fround(f72 * f78));
 f81 = Math_fround(Math_fround(f68 + f69) + Math_fround(f72 * f81));
 f84 = Math_fround(Math_fround(f70 + f71) + Math_fround(f72 * f84));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f73 * f74) + f75) + f76);
 HEAPF32[i467 >> 2] = f77;
 HEAPF32[i468 >> 2] = f78;
 HEAPF32[i469 >> 2] = f79;
 HEAPF32[i470 >> 2] = f80;
 HEAPF32[i471 >> 2] = f81;
 HEAPF32[i472 >> 2] = f82;
 HEAPF32[i186 >> 2] = f83;
 HEAPF32[i185 >> 2] = f84;
 i185 = (i7 | 0) == 27;
 HEAP32[i610 >> 2] = 0;
 HEAP32[i610 + 4 >> 2] = 0;
 HEAP32[i610 + 8 >> 2] = 0;
 HEAP32[i610 + 12 >> 2] = 0;
 i186 = HEAP32[i633 + 12 >> 2] | 0;
 if (!i186) {
  STACKTOP = i643;
  return;
 }
 i187 = i611 + 12 | 0;
 i188 = i611 + 8 | 0;
 i189 = i611 + 4 | 0;
 i190 = i611 + 16 | 0;
 i191 = i611 + 28 | 0;
 i192 = i611 + 24 | 0;
 i193 = i611 + 20 | 0;
 i194 = i611 + 32 | 0;
 i195 = i611 + 44 | 0;
 i196 = i611 + 40 | 0;
 i197 = i611 + 36 | 0;
 i198 = i612 + 32 | 0;
 i199 = i612 + 44 | 0;
 i200 = i612 + 40 | 0;
 i201 = i612 + 36 | 0;
 i202 = i613 + 12 | 0;
 i203 = i613 + 8 | 0;
 i204 = i613 + 4 | 0;
 i205 = i613 + 28 | 0;
 i206 = i613 + 24 | 0;
 i207 = i613 + 20 | 0;
 i208 = i613 + 44 | 0;
 i209 = i613 + 40 | 0;
 i210 = i613 + 36 | 0;
 i211 = i638 + 20 | 0;
 i212 = i633 + 20 | 0;
 i213 = i633 + 40 | 0;
 i214 = i633 + 340 | 0;
 i215 = i633 + 60 | 0;
 i216 = i633 + 80 | 0;
 i217 = i633 + 100 | 0;
 i218 = i633 + 120 | 0;
 i219 = i633 + 140 | 0;
 i220 = i633 + 160 | 0;
 i221 = i613 + 16 | 0;
 i222 = i613 + 32 | 0;
 i223 = i638 + 4 | 0;
 i224 = i614 + 4 | 0;
 i225 = i614 + 8 | 0;
 i226 = i614 + 12 | 0;
 i227 = i638 + 8 | 0;
 i228 = i615 + 4 | 0;
 i229 = i615 + 8 | 0;
 i230 = i615 + 12 | 0;
 i231 = i633 + 520 | 0;
 i232 = i616 + 4 | 0;
 i233 = i616 + 8 | 0;
 i234 = i616 + 12 | 0;
 i235 = i633 + 500 | 0;
 i236 = i617 + 4 | 0;
 i237 = i617 + 8 | 0;
 i238 = i617 + 12 | 0;
 i239 = i638 + 16 | 0;
 i240 = i618 + 4 | 0;
 i241 = i618 + 8 | 0;
 i242 = i618 + 12 | 0;
 i243 = i611 + 16 | 0;
 i244 = i611 + 32 | 0;
 i245 = i620 + 4 | 0;
 i246 = i620 + 8 | 0;
 i247 = i620 + 12 | 0;
 i248 = i620 + 16 | 0;
 i249 = i620 + 20 | 0;
 i250 = i620 + 24 | 0;
 i251 = i620 + 28 | 0;
 i252 = i620 + 32 | 0;
 i253 = i620 + 36 | 0;
 i254 = i620 + 40 | 0;
 i255 = i620 + 44 | 0;
 i256 = i621 + 96 | 0;
 i257 = i621 + 100 | 0;
 i258 = i621 + 104 | 0;
 i259 = i621 + 108 | 0;
 i260 = i621 + 112 | 0;
 i261 = i621 + 116 | 0;
 i262 = i621 + 120 | 0;
 i263 = i621 + 124 | 0;
 i264 = i621 + 128 | 0;
 i265 = i621 + 132 | 0;
 i266 = i621 + 136 | 0;
 i267 = i621 + 140 | 0;
 i268 = i621 + 128 | 0;
 i269 = i621 + 112 | 0;
 i270 = i621 + 4 | 0;
 i271 = i621 + 8 | 0;
 i272 = i621 + 12 | 0;
 i273 = i621 + 16 | 0;
 i274 = i621 + 20 | 0;
 i275 = i621 + 24 | 0;
 i276 = i621 + 28 | 0;
 i277 = i621 + 32 | 0;
 i278 = i621 + 36 | 0;
 i279 = i621 + 40 | 0;
 i280 = i621 + 44 | 0;
 i281 = i621 + 16 | 0;
 i282 = i621 + 32 | 0;
 i283 = i621 + 48 | 0;
 i284 = i621 + 52 | 0;
 i285 = i621 + 56 | 0;
 i286 = i621 + 60 | 0;
 i287 = i621 + 64 | 0;
 i288 = i621 + 68 | 0;
 i289 = i621 + 72 | 0;
 i290 = i621 + 76 | 0;
 i291 = i621 + 80 | 0;
 i292 = i621 + 84 | 0;
 i293 = i621 + 88 | 0;
 i294 = i621 + 92 | 0;
 i295 = i622 + 4 | 0;
 i296 = i622 + 8 | 0;
 i297 = i622 + 12 | 0;
 i298 = i622 + 16 | 0;
 i299 = i622 + 20 | 0;
 i300 = i622 + 24 | 0;
 i301 = i622 + 28 | 0;
 i302 = i622 + 32 | 0;
 i303 = i622 + 36 | 0;
 i304 = i622 + 40 | 0;
 i305 = i622 + 44 | 0;
 i306 = i622 + 48 | 0;
 i307 = i622 + 52 | 0;
 i308 = i622 + 56 | 0;
 i309 = i622 + 60 | 0;
 i310 = i622 + 64 | 0;
 i311 = i622 + 68 | 0;
 i312 = i622 + 72 | 0;
 i313 = i622 + 76 | 0;
 i314 = i622 + 80 | 0;
 i315 = i622 + 84 | 0;
 i316 = i622 + 88 | 0;
 i317 = i622 + 92 | 0;
 i318 = i622 + 100 | 0;
 i319 = i622 + 104 | 0;
 i320 = i622 + 108 | 0;
 i321 = i622 + 116 | 0;
 i322 = i622 + 120 | 0;
 i323 = i622 + 124 | 0;
 i324 = i622 + 128 | 0;
 i325 = i622 + 132 | 0;
 i326 = i622 + 136 | 0;
 i327 = i622 + 140 | 0;
 i328 = i621 + 96 | 0;
 i329 = i622 + 32 | 0;
 i330 = i623 + 4 | 0;
 i331 = i623 + 8 | 0;
 i332 = i623 + 12 | 0;
 i333 = i622 + 80 | 0;
 i334 = i623 + 48 | 0;
 i335 = i623 + 52 | 0;
 i336 = i623 + 56 | 0;
 i337 = i623 + 60 | 0;
 i338 = i622 + 96 | 0;
 i339 = i622 + 112 | 0;
 i340 = i622 + 128 | 0;
 i341 = i623 + 96 | 0;
 i342 = i623 + 100 | 0;
 i343 = i623 + 104 | 0;
 i344 = i623 + 108 | 0;
 i345 = i623 + 16 | 0;
 i346 = i623 + 20 | 0;
 i347 = i623 + 24 | 0;
 i348 = i623 + 28 | 0;
 i349 = i623 + 64 | 0;
 i350 = i623 + 68 | 0;
 i351 = i623 + 72 | 0;
 i352 = i623 + 76 | 0;
 i353 = i623 + 112 | 0;
 i354 = i623 + 116 | 0;
 i355 = i623 + 120 | 0;
 i356 = i623 + 124 | 0;
 i357 = i623 + 32 | 0;
 i358 = i623 + 36 | 0;
 i359 = i623 + 40 | 0;
 i360 = i623 + 44 | 0;
 i361 = i623 + 80 | 0;
 i362 = i623 + 84 | 0;
 i363 = i623 + 88 | 0;
 i364 = i623 + 92 | 0;
 i365 = i623 + 128 | 0;
 i366 = i623 + 132 | 0;
 i367 = i623 + 136 | 0;
 i368 = i623 + 140 | 0;
 i369 = i619 + 4 | 0;
 i370 = i619 + 8 | 0;
 i371 = i619 + 12 | 0;
 i372 = i619 + 16 | 0;
 i373 = i619 + 20 | 0;
 i374 = i619 + 24 | 0;
 i375 = i619 + 28 | 0;
 i376 = i619 + 32 | 0;
 i377 = i619 + 36 | 0;
 i378 = i619 + 40 | 0;
 i379 = i619 + 44 | 0;
 i380 = i619 + 48 | 0;
 i381 = i619 + 52 | 0;
 i382 = i619 + 56 | 0;
 i383 = i619 + 60 | 0;
 i384 = i619 + 64 | 0;
 i385 = i619 + 68 | 0;
 i386 = i619 + 72 | 0;
 i387 = i619 + 76 | 0;
 i388 = i619 + 80 | 0;
 i389 = i619 + 84 | 0;
 i390 = i619 + 88 | 0;
 i391 = i619 + 92 | 0;
 i392 = i619 + 96 | 0;
 i393 = i619 + 100 | 0;
 i394 = i619 + 104 | 0;
 i395 = i619 + 108 | 0;
 i396 = i619 + 112 | 0;
 i397 = i619 + 116 | 0;
 i398 = i619 + 120 | 0;
 i399 = i619 + 124 | 0;
 i400 = i619 + 128 | 0;
 i401 = i619 + 132 | 0;
 i402 = i619 + 136 | 0;
 i403 = i619 + 140 | 0;
 i404 = i619 + 144 | 0;
 i405 = i619 + 148 | 0;
 i406 = i619 + 152 | 0;
 i407 = i619 + 156 | 0;
 i408 = i619 + 160 | 0;
 i409 = i619 + 164 | 0;
 i410 = i619 + 168 | 0;
 i411 = i619 + 172 | 0;
 i412 = i619 + 176 | 0;
 i413 = i619 + 180 | 0;
 i414 = i619 + 184 | 0;
 i415 = i619 + 188 | 0;
 i416 = (i7 & 48 | 0) == 0;
 i147 = i621 + 4 | 0;
 i164 = i621 + 8 | 0;
 i181 = i621 + 12 | 0;
 i417 = i621 + 16 | 0;
 i142 = i621 + 20 | 0;
 i159 = i621 + 24 | 0;
 i176 = i621 + 28 | 0;
 i418 = i621 + 32 | 0;
 i137 = i621 + 36 | 0;
 i154 = i621 + 40 | 0;
 i171 = i621 + 44 | 0;
 i419 = i621 + 48 | 0;
 i146 = i621 + 52 | 0;
 i163 = i621 + 56 | 0;
 i180 = i621 + 60 | 0;
 i420 = i621 + 64 | 0;
 i141 = i621 + 68 | 0;
 i158 = i621 + 72 | 0;
 i175 = i621 + 76 | 0;
 i421 = i621 + 80 | 0;
 i136 = i621 + 84 | 0;
 i153 = i621 + 88 | 0;
 i170 = i621 + 92 | 0;
 i422 = i621 + 96 | 0;
 i145 = i621 + 100 | 0;
 i162 = i621 + 104 | 0;
 i179 = i621 + 108 | 0;
 i423 = i621 + 112 | 0;
 i140 = i621 + 116 | 0;
 i157 = i621 + 120 | 0;
 i174 = i621 + 124 | 0;
 i424 = i621 + 128 | 0;
 i135 = i621 + 132 | 0;
 i152 = i621 + 136 | 0;
 i169 = i621 + 140 | 0;
 i425 = i621 + 144 | 0;
 i144 = i621 + 148 | 0;
 i161 = i621 + 152 | 0;
 i178 = i621 + 156 | 0;
 i426 = i621 + 160 | 0;
 i139 = i621 + 164 | 0;
 i156 = i621 + 168 | 0;
 i173 = i621 + 172 | 0;
 i427 = i621 + 176 | 0;
 i134 = i621 + 180 | 0;
 i151 = i621 + 184 | 0;
 i168 = i621 + 188 | 0;
 i148 = i622 + 4 | 0;
 i165 = i622 + 8 | 0;
 i182 = i622 + 12 | 0;
 i428 = i622 + 16 | 0;
 i143 = i622 + 20 | 0;
 i160 = i622 + 24 | 0;
 i177 = i622 + 28 | 0;
 i429 = i622 + 32 | 0;
 i138 = i622 + 36 | 0;
 i155 = i622 + 40 | 0;
 i172 = i622 + 44 | 0;
 i150 = i623 + 4 | 0;
 i167 = i623 + 8 | 0;
 i184 = i623 + 12 | 0;
 i430 = i623 + 16 | 0;
 i149 = i623 + 20 | 0;
 i166 = i623 + 24 | 0;
 i183 = i623 + 28 | 0;
 i133 = i623 + 32 | 0;
 i431 = (i7 & 512 | 0) != 0;
 i432 = i613 + 16 | 0;
 i433 = i613 + 32 | 0;
 i434 = i624 + 4 | 0;
 i435 = i624 + 8 | 0;
 i436 = i624 + 12 | 0;
 i437 = i624 + 16 | 0;
 i438 = i624 + 20 | 0;
 i439 = i624 + 24 | 0;
 i440 = i624 + 28 | 0;
 i441 = i624 + 32 | 0;
 i442 = i624 + 36 | 0;
 i443 = i624 + 40 | 0;
 i444 = i624 + 44 | 0;
 i445 = (i7 & 8192 | 0) != 0;
 i446 = i625 + 4 | 0;
 i447 = i625 + 8 | 0;
 i448 = i625 + 12 | 0;
 i449 = i625 + 16 | 0;
 i450 = i625 + 20 | 0;
 i451 = i625 + 24 | 0;
 i452 = i625 + 28 | 0;
 i453 = i625 + 32 | 0;
 i454 = i625 + 36 | 0;
 i455 = i625 + 40 | 0;
 i456 = i625 + 44 | 0;
 i457 = i625 + 48 | 0;
 i458 = i625 + 52 | 0;
 i459 = i625 + 56 | 0;
 i460 = i625 + 60 | 0;
 i461 = (i7 & 2 | 0) == 0;
 i462 = (i7 & 8 | 0) == 0;
 i463 = (i7 & 16 | 0) == 0;
 i464 = (i7 & 32 | 0) == 0;
 i465 = (i7 & 64 | 0) == 0;
 i466 = (i7 & 128 | 0) == 0;
 i467 = (i7 & 256 | 0) == 0;
 i468 = i624 + 16 | 0;
 i469 = i624 + 32 | 0;
 i470 = (i7 & 1024 | 0) == 0;
 i471 = (i7 & 2048 | 0) == 0;
 i472 = (i7 & 4096 | 0) == 0;
 i121 = (i7 & 4 | 0) == 0;
 i122 = i622 + 16 | 0;
 i123 = i622 + 32 | 0;
 i124 = i633 + 864 | 0;
 i125 = i633 + 848 | 0;
 i126 = i633 + 844 | 0;
 i127 = i633 + 828 | 0;
 i128 = i633 + 540 | 0;
 i129 = i623 + 16 | 0;
 i130 = i623 + 32 | 0;
 i131 = i620 + 16 | 0;
 i132 = i620 + 32 | 0;
 i86 = i8 + 32 | 0;
 i87 = i619 + 16 | 0;
 i88 = i619 + 32 | 0;
 i89 = i621 + 16 | 0;
 i90 = i621 + 32 | 0;
 i91 = i619 + 48 | 0;
 i92 = i91 + 16 | 0;
 i93 = i91 + 32 | 0;
 i94 = i419 + 16 | 0;
 i95 = i419 + 32 | 0;
 i96 = i392 + 16 | 0;
 i97 = i392 + 32 | 0;
 i98 = i422 + 16 | 0;
 i99 = i422 + 32 | 0;
 i100 = i404 + 16 | 0;
 i101 = i404 + 32 | 0;
 i102 = i425 + 16 | 0;
 i103 = i425 + 32 | 0;
 i104 = i619 + 16 | 0;
 i105 = i619 + 32 | 0;
 i106 = i621 + 16 | 0;
 i107 = i621 + 32 | 0;
 i108 = i619 + 48 | 0;
 i109 = i108 + 16 | 0;
 i110 = i108 + 32 | 0;
 i111 = i419 + 16 | 0;
 i112 = i419 + 32 | 0;
 i113 = i392 + 16 | 0;
 i114 = i392 + 32 | 0;
 i115 = i422 + 16 | 0;
 i116 = i422 + 32 | 0;
 i117 = i404 + 16 | 0;
 i118 = i404 + 32 | 0;
 i119 = i425 + 16 | 0;
 i120 = i425 + 32 | 0;
 i85 = 0;
 i1 = i9;
 do {
  i10 = i611;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i612;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i613;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i614 >> 2] = 0;
  HEAP32[i614 + 4 >> 2] = 0;
  HEAP32[i614 + 8 >> 2] = 0;
  HEAP32[i614 + 12 >> 2] = 0;
  HEAP32[i615 >> 2] = 0;
  HEAP32[i615 + 4 >> 2] = 0;
  HEAP32[i615 + 8 >> 2] = 0;
  HEAP32[i615 + 12 >> 2] = 0;
  HEAP32[i616 >> 2] = 0;
  HEAP32[i616 + 4 >> 2] = 0;
  HEAP32[i616 + 8 >> 2] = 0;
  HEAP32[i616 + 12 >> 2] = 0;
  HEAP32[i617 >> 2] = 0;
  HEAP32[i617 + 4 >> 2] = 0;
  HEAP32[i617 + 8 >> 2] = 0;
  HEAP32[i617 + 12 >> 2] = 0;
  HEAP32[i618 >> 2] = 0;
  HEAP32[i618 + 4 >> 2] = 0;
  HEAP32[i618 + 8 >> 2] = 0;
  HEAP32[i618 + 12 >> 2] = 0;
  i15 = HEAP32[i211 >> 2] | 0;
  i16 = HEAP32[i633 >> 2] | 0;
  if (!i15) {
   i43 = i16 + (i85 << 2) | 0;
   i44 = HEAP32[i43 + 4 >> 2] | 0;
   i45 = HEAP32[i43 + 8 >> 2] | 0;
   i46 = HEAP32[i43 + 12 >> 2] | 0;
   i54 = (HEAP32[i212 >> 2] | 0) + (i85 << 2) | 0;
   i51 = HEAP32[i54 >> 2] | 0;
   i52 = HEAP32[i54 + 4 >> 2] | 0;
   i53 = HEAP32[i54 + 8 >> 2] | 0;
   i54 = HEAP32[i54 + 12 >> 2] | 0;
   i55 = (HEAP32[i213 >> 2] | 0) + (i85 << 2) | 0;
   i58 = HEAP32[i55 >> 2] | 0;
   i57 = HEAP32[i55 + 4 >> 2] | 0;
   i56 = HEAP32[i55 + 8 >> 2] | 0;
   i55 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i611 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i189 >> 2] = i44;
   HEAP32[i188 >> 2] = i45;
   HEAP32[i187 >> 2] = i46;
   HEAP32[i190 >> 2] = i51;
   HEAP32[i193 >> 2] = i52;
   HEAP32[i192 >> 2] = i53;
   HEAP32[i191 >> 2] = i54;
   HEAP32[i194 >> 2] = i58;
   HEAP32[i197 >> 2] = i57;
   HEAP32[i196 >> 2] = i56;
   HEAP32[i195 >> 2] = i55;
   i55 = (HEAP32[i214 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i198 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i201 >> 2] = i56;
   HEAP32[i200 >> 2] = i57;
   HEAP32[i199 >> 2] = i58;
   i58 = (HEAP32[i215 >> 2] | 0) + (i85 << 2) | 0;
   f72 = Math_fround(HEAPF32[i58 >> 2]);
   f62 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f63 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f64 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i216 >> 2] | 0) + (i85 << 2) | 0;
   f65 = Math_fround(HEAPF32[i58 >> 2]);
   f66 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f67 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f68 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i217 >> 2] | 0) + (i85 << 2) | 0;
   f69 = Math_fround(HEAPF32[i58 >> 2]);
   f70 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f71 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f84 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i218 >> 2] | 0) + (i85 << 2) | 0;
   f73 = Math_fround(HEAPF32[i58 >> 2]);
   f74 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f75 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f76 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i219 >> 2] | 0) + (i85 << 2) | 0;
   f77 = Math_fround(HEAPF32[i58 >> 2]);
   f78 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f79 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f80 = Math_fround(HEAPF32[i58 + 12 >> 2]);
   i58 = (HEAP32[i220 >> 2] | 0) + (i85 << 2) | 0;
   f81 = Math_fround(HEAPF32[i58 >> 2]);
   f82 = Math_fround(HEAPF32[i58 + 4 >> 2]);
   f83 = Math_fround(HEAPF32[i58 + 8 >> 2]);
   f74 = Math_fround(f62 + f74);
   f75 = Math_fround(f63 + f75);
   f76 = Math_fround(f64 + f76);
   f77 = Math_fround(f65 + f77);
   f78 = Math_fround(f66 + f78);
   f79 = Math_fround(f67 + f79);
   f80 = Math_fround(f68 + f80);
   f81 = Math_fround(f69 + f81);
   f82 = Math_fround(f70 + f82);
   f83 = Math_fround(f71 + f83);
   f84 = Math_fround(f84 + Math_fround(HEAPF32[i58 + 12 >> 2]));
   HEAPF32[i613 >> 2] = Math_fround(f72 + f73);
   HEAPF32[i204 >> 2] = f74;
   HEAPF32[i203 >> 2] = f75;
   HEAPF32[i202 >> 2] = f76;
   HEAPF32[i221 >> 2] = f77;
   HEAPF32[i207 >> 2] = f78;
   HEAPF32[i206 >> 2] = f79;
   HEAPF32[i205 >> 2] = f80;
   HEAPF32[i222 >> 2] = f81;
   HEAPF32[i210 >> 2] = f82;
   HEAPF32[i209 >> 2] = f83;
   HEAPF32[i208 >> 2] = f84;
   i58 = (HEAP32[i223 >> 2] | 0) + (i85 << 2) | 0;
   i57 = HEAP32[i58 + 4 >> 2] | 0;
   i56 = HEAP32[i58 + 8 >> 2] | 0;
   i55 = HEAP32[i58 + 12 >> 2] | 0;
   HEAP32[i614 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i224 >> 2] = i57;
   HEAP32[i225 >> 2] = i56;
   HEAP32[i226 >> 2] = i55;
   i55 = (HEAP32[i227 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i615 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i228 >> 2] = i56;
   HEAP32[i229 >> 2] = i57;
   HEAP32[i230 >> 2] = i58;
   i58 = (HEAP32[i231 >> 2] | 0) + (i85 << 2) | 0;
   i57 = HEAP32[i58 + 4 >> 2] | 0;
   i56 = HEAP32[i58 + 8 >> 2] | 0;
   i55 = HEAP32[i58 + 12 >> 2] | 0;
   HEAP32[i616 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i232 >> 2] = i57;
   HEAP32[i233 >> 2] = i56;
   HEAP32[i234 >> 2] = i55;
   i55 = (HEAP32[i235 >> 2] | 0) + (i85 << 2) | 0;
   i56 = HEAP32[i55 + 4 >> 2] | 0;
   i57 = HEAP32[i55 + 8 >> 2] | 0;
   i58 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i617 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i236 >> 2] = i56;
   HEAP32[i237 >> 2] = i57;
   HEAP32[i238 >> 2] = i58;
   if (HEAP32[i626 >> 2] & 268435456 | 0) {
    i55 = (HEAP32[i239 >> 2] | 0) + (i85 << 2) | 0;
    i56 = HEAP32[i55 + 4 >> 2] | 0;
    i57 = HEAP32[i55 + 8 >> 2] | 0;
    i58 = HEAP32[i55 + 12 >> 2] | 0;
    HEAP32[i618 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i240 >> 2] = i56;
    HEAP32[i241 >> 2] = i57;
    HEAP32[i242 >> 2] = i58;
   }
  } else {
   i3 = HEAP32[i215 >> 2] | 0;
   i4 = HEAP32[i218 >> 2] | 0;
   i5 = HEAP32[i212 >> 2] | 0;
   i6 = HEAP32[i216 >> 2] | 0;
   i7 = HEAP32[i219 >> 2] | 0;
   i8 = HEAP32[i213 >> 2] | 0;
   i9 = HEAP32[i217 >> 2] | 0;
   i10 = HEAP32[i220 >> 2] | 0;
   i11 = HEAP32[i223 >> 2] | 0;
   i12 = HEAP32[i227 >> 2] | 0;
   i13 = HEAP32[i231 >> 2] | 0;
   i14 = HEAP32[i235 >> 2] | 0;
   i17 = (HEAP32[i626 >> 2] & 268435456 | 0) == 0;
   i18 = HEAP32[i214 >> 2] | 0;
   i19 = HEAP32[i239 >> 2] | 0;
   i2 = 0;
   do {
    i20 = HEAP32[i15 + (i2 + i85 << 3) >> 2] | 0;
    HEAP32[i611 + (i2 << 2) >> 2] = HEAP32[i16 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i3 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i2 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i4 + (i20 << 2) >> 2]));
    i21 = i2 + 4 | 0;
    HEAP32[i611 + (i21 << 2) >> 2] = HEAP32[i5 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i6 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i21 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i7 + (i20 << 2) >> 2]));
    i21 = i2 + 8 | 0;
    HEAP32[i611 + (i21 << 2) >> 2] = HEAP32[i8 + (i20 << 2) >> 2];
    f84 = Math_fround(HEAPF32[i9 + (i20 << 2) >> 2]);
    HEAPF32[i613 + (i21 << 2) >> 2] = Math_fround(f84 + Math_fround(HEAPF32[i10 + (i20 << 2) >> 2]));
    HEAP32[i614 + (i2 << 2) >> 2] = HEAP32[i11 + (i20 << 2) >> 2];
    HEAP32[i615 + (i2 << 2) >> 2] = HEAP32[i12 + (i20 << 2) >> 2];
    HEAP32[i616 + (i2 << 2) >> 2] = HEAP32[i13 + (i20 << 2) >> 2];
    HEAP32[i617 + (i2 << 2) >> 2] = HEAP32[i14 + (i20 << 2) >> 2];
    if (!i17) HEAP32[i618 + (i2 << 2) >> 2] = HEAP32[i19 + (i20 << 2) >> 2];
    HEAP32[i612 + (i21 << 2) >> 2] = HEAP32[i18 + (i20 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f39 = Math_fround(HEAPF32[i611 >> 2]);
  f24 = Math_fround(f576 * f39);
  f36 = Math_fround(HEAPF32[i189 >> 2]);
  f38 = Math_fround(f576 * f36);
  f84 = Math_fround(HEAPF32[i188 >> 2]);
  f23 = Math_fround(f576 * f84);
  f82 = Math_fround(HEAPF32[i187 >> 2]);
  f30 = Math_fround(f576 * f82);
  f33 = Math_fround(HEAPF32[i243 >> 2]);
  f27 = Math_fround(f579 * f33);
  f32 = Math_fround(HEAPF32[i193 >> 2]);
  f28 = Math_fround(f579 * f32);
  f83 = Math_fround(HEAPF32[i192 >> 2]);
  f34 = Math_fround(f579 * f83);
  f81 = Math_fround(HEAPF32[i191 >> 2]);
  f27 = Math_fround(f24 + f27);
  f28 = Math_fround(f38 + f28);
  f34 = Math_fround(f23 + f34);
  f30 = Math_fround(f30 + Math_fround(f579 * f81));
  f23 = Math_fround(HEAPF32[i244 >> 2]);
  f38 = Math_fround(f582 * f23);
  f24 = Math_fround(HEAPF32[i197 >> 2]);
  f31 = Math_fround(f582 * f24);
  f25 = Math_fround(HEAPF32[i196 >> 2]);
  f35 = Math_fround(f582 * f25);
  f29 = Math_fround(HEAPF32[i195 >> 2]);
  f31 = Math_fround(f585 + Math_fround(f28 + f31));
  f35 = Math_fround(f585 + Math_fround(f34 + f35));
  f30 = Math_fround(f585 + Math_fround(f30 + Math_fround(f582 * f29)));
  HEAPF32[i620 >> 2] = Math_fround(f585 + Math_fround(f27 + f38));
  HEAPF32[i245 >> 2] = f31;
  HEAPF32[i246 >> 2] = f35;
  HEAPF32[i247 >> 2] = f30;
  f30 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f36) + Math_fround(f580 * f32)) + Math_fround(f583 * f24)));
  f35 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f84) + Math_fround(f580 * f83)) + Math_fround(f583 * f25)));
  f31 = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f82) + Math_fround(f580 * f81)) + Math_fround(f583 * f29)));
  HEAPF32[i248 >> 2] = Math_fround(f586 + Math_fround(Math_fround(Math_fround(f577 * f39) + Math_fround(f580 * f33)) + Math_fround(f583 * f23)));
  HEAPF32[i249 >> 2] = f30;
  HEAPF32[i250 >> 2] = f35;
  HEAPF32[i251 >> 2] = f31;
  f31 = Math_fround(f587 + Math_fround(Math_fround(f584 * f24) + Math_fround(Math_fround(f581 * f32) + Math_fround(f578 * f36))));
  f35 = Math_fround(f587 + Math_fround(Math_fround(f584 * f25) + Math_fround(Math_fround(f581 * f83) + Math_fround(f578 * f84))));
  f30 = Math_fround(f587 + Math_fround(Math_fround(f584 * f29) + Math_fround(Math_fround(f581 * f81) + Math_fround(f578 * f82))));
  HEAPF32[i252 >> 2] = Math_fround(f587 + Math_fround(Math_fround(f584 * f23) + Math_fround(Math_fround(f581 * f33) + Math_fround(f578 * f39))));
  HEAPF32[i253 >> 2] = f31;
  HEAPF32[i254 >> 2] = f35;
  HEAPF32[i255 >> 2] = f30;
  f23 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f39) + Math_fround(f636 * f33)) + Math_fround(f637 * f23)));
  f24 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f36) + Math_fround(f636 * f32)) + Math_fround(f637 * f24)));
  f25 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f84) + Math_fround(f636 * f83)) + Math_fround(f637 * f25)));
  f29 = Math_fround(f639 + Math_fround(Math_fround(Math_fround(f635 * f82) + Math_fround(f636 * f81)) + Math_fround(f637 * f29)));
  f81 = Math_fround(f606 + Math_fround(f607 * f23));
  f82 = Math_fround(f606 + Math_fround(f607 * f24));
  f83 = Math_fround(f606 + Math_fround(f607 * f25));
  f84 = Math_fround(f606 + Math_fround(f607 * f29));
  f23 = Math_fround(f600 + Math_fround(f601 * f23));
  f24 = Math_fround(f600 + Math_fround(f601 * f24));
  f25 = Math_fround(f600 + Math_fround(f601 * f25));
  f29 = Math_fround(f600 + Math_fround(f601 * f29));
  f32 = Math_fround(HEAPF32[i614 >> 2]);
  f36 = Math_fround(HEAPF32[i224 >> 2]);
  f33 = Math_fround(HEAPF32[i225 >> 2]);
  f39 = Math_fround(HEAPF32[i226 >> 2]);
  f30 = Math_fround(HEAPF32[i615 >> 2]);
  f35 = Math_fround(HEAPF32[i228 >> 2]);
  f31 = Math_fround(HEAPF32[i229 >> 2]);
  f38 = Math_fround(HEAPF32[i230 >> 2]);
  f27 = f32 > f30 ? f32 : f30;
  f34 = f36 > f35 ? f36 : f35;
  f28 = f33 > f31 ? f33 : f31;
  f37 = f39 > f38 ? f39 : f38;
  f78 = Math_fround((f27 > f81 ? f27 : f81) * Math_fround(.5));
  f79 = Math_fround((f34 > f82 ? f34 : f82) * Math_fround(.5));
  f80 = Math_fround((f28 > f83 ? f28 : f83) * Math_fround(.5));
  f22 = Math_fround((f37 > f84 ? f37 : f84) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f81 >= Math_fround(0.0);
  i56 = f82 >= Math_fround(0.0);
  i57 = f83 >= Math_fround(0.0);
  i58 = f84 >= Math_fround(0.0);
  i9 = i55 ? i9 : 0;
  i10 = i56 ? i10 : 0;
  i11 = i57 ? i11 : 0;
  i5 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f80 = Math_fround(f23 * Math_fround(.5));
  f82 = Math_fround(f24 * Math_fround(.5));
  f84 = Math_fround(f25 * Math_fround(.5));
  f22 = Math_fround(f29 * Math_fround(.5));
  f79 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f83 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f79 < f80 ? f79 : f80, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f81 < f82 ? f81 : f82, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f83 < f84 ? f83 : f84, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f23 >= Math_fround(0.0);
  i3 = f24 >= Math_fround(0.0);
  i2 = f25 >= Math_fround(0.0);
  i58 = f29 >= Math_fround(0.0);
  i14 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f26 < f22 ? f26 : f22, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f27);
  f47 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f50 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f81 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround(f32 * f49);
  f48 = Math_fround(f33 * f50);
  f49 = Math_fround(f30 * f49);
  f50 = Math_fround(f31 * f50);
  f82 = Math_fround(HEAPF32[i616 >> 2]);
  f60 = Math_fround(HEAPF32[i232 >> 2]);
  f78 = Math_fround(HEAPF32[i233 >> 2]);
  f79 = Math_fround(f609 * f32);
  f80 = Math_fround(f609 * f33);
  f84 = Math_fround(f603 * f30);
  f83 = Math_fround(f603 * f31);
  f77 = Math_fround(f605 * f32);
  f76 = Math_fround(f605 * f33);
  f47 = Math_fround(f47 / f34);
  f40 = Math_fround(f36 * f47);
  f47 = Math_fround(f35 * f47);
  i14 = f82 < Math_fround(100.0);
  i16 = f78 < Math_fround(100.0);
  f78 = Math_fround(f609 * f36);
  f82 = Math_fround(f603 * f35);
  f75 = Math_fround(f605 * f36);
  f34 = Math_fround(f81 / f37);
  f35 = Math_fround(f38 * f34);
  i15 = Math_fround(HEAPF32[i234 >> 2]) < Math_fround(100.0);
  f81 = Math_fround(f603 * f38);
  f34 = Math_fround(f39 * f34);
  i13 = f60 < Math_fround(100.0);
  f37 = Math_fround(f609 * f39);
  f36 = Math_fround(f605 * f39);
  f60 = Math_fround(Math_fround(HEAPF32[i620 >> 2]) - f588);
  f61 = Math_fround(Math_fround(HEAPF32[i245 >> 2]) - f588);
  f62 = Math_fround(Math_fround(HEAPF32[i246 >> 2]) - f588);
  f63 = Math_fround(Math_fround(HEAPF32[i247 >> 2]) - f588);
  f64 = Math_fround(Math_fround(HEAPF32[i248 >> 2]) - f589);
  f65 = Math_fround(Math_fround(HEAPF32[i249 >> 2]) - f589);
  f66 = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f589);
  f67 = Math_fround(Math_fround(HEAPF32[i251 >> 2]) - f589);
  f33 = Math_fround(Math_fround(HEAPF32[i252 >> 2]) - f590);
  f38 = Math_fround(Math_fround(HEAPF32[i253 >> 2]) - f590);
  f39 = Math_fround(Math_fround(HEAPF32[i254 >> 2]) - f590);
  f59 = Math_fround(Math_fround(HEAPF32[i255 >> 2]) - f590);
  f71 = Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f33 * f33));
  f72 = Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f38 * f38));
  f73 = Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f39 * f39));
  f74 = Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f59 * f59));
  f68 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f71))));
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f72))));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f73))));
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f74))));
  f60 = Math_fround(f60 * f68);
  f61 = Math_fround(f61 * f69);
  f62 = Math_fround(f62 * f70);
  f63 = Math_fround(f63 * f22);
  f64 = Math_fround(f64 * f68);
  f65 = Math_fround(f65 * f69);
  f66 = Math_fround(f66 * f70);
  f67 = Math_fround(f67 * f22);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f38 * f69);
  f70 = Math_fround(f39 * f70);
  f22 = Math_fround(f59 * f22);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f71 > Math_fround(9.99999974e-06);
  i56 = f72 > Math_fround(9.99999974e-06);
  i57 = f73 > Math_fround(9.99999974e-06);
  i58 = f74 > Math_fround(9.99999974e-06);
  i2 = i55 ? i2 : 0;
  i3 = i56 ? i3 : 0;
  i4 = i57 ? i4 : 0;
  i5 = i58 ? i5 : 0;
  i6 = i55 ? i6 : 0;
  i7 = i56 ? i7 : 0;
  i8 = i57 ? i8 : 0;
  i9 = i58 ? i9 : 0;
  i10 = i55 ? i10 : 1065353216;
  i11 = i56 ? i11 : 1065353216;
  i12 = i57 ? i12 : 1065353216;
  i55 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i256 >> 2] = i2;
  HEAP32[i257 >> 2] = i3;
  HEAP32[i258 >> 2] = i4;
  HEAP32[i259 >> 2] = i5;
  HEAP32[i260 >> 2] = i6;
  HEAP32[i261 >> 2] = i7;
  HEAP32[i262 >> 2] = i8;
  HEAP32[i263 >> 2] = i9;
  HEAP32[i264 >> 2] = i10;
  HEAP32[i265 >> 2] = i11;
  HEAP32[i266 >> 2] = i12;
  HEAP32[i267 >> 2] = i55;
  f64 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = Math_fround(f592 * f64);
  f65 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f70 = Math_fround(f592 * f65);
  f66 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f592 * f66);
  f67 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(f592 * f67);
  f74 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f593 * f74);
  f73 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f593 * f73);
  f72 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f593 * f72);
  f71 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f38 - f60);
  f61 = Math_fround(f70 - f61);
  f62 = Math_fround(f33 - f62);
  f63 = Math_fround(f63 - Math_fround(f593 * f71));
  f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f70 = Math_fround(f593 * f33);
  f38 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f69 = Math_fround(f593 * f38);
  f39 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f68 = Math_fround(f593 * f39);
  f59 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f70 - Math_fround(f591 * f64));
  f65 = Math_fround(f69 - Math_fround(f591 * f65));
  f66 = Math_fround(f68 - Math_fround(f591 * f66));
  f67 = Math_fround(Math_fround(f593 * f59) - Math_fround(f591 * f67));
  f33 = Math_fround(Math_fround(f591 * f74) - Math_fround(f592 * f33));
  f38 = Math_fround(Math_fround(f591 * f73) - Math_fround(f592 * f38));
  f39 = Math_fround(Math_fround(f591 * f72) - Math_fround(f592 * f39));
  f59 = Math_fround(Math_fround(f591 * f71) - Math_fround(f592 * f59));
  f71 = Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f33 * f33));
  f72 = Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f38 * f38));
  f73 = Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f39 * f39));
  f74 = Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f59 * f59));
  f68 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f71))));
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f72))));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f73))));
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f74))));
  f60 = Math_fround(f60 * f68);
  f61 = Math_fround(f61 * f69);
  f62 = Math_fround(f62 * f70);
  f63 = Math_fround(f63 * f22);
  f64 = Math_fround(f64 * f68);
  f65 = Math_fround(f65 * f69);
  f66 = Math_fround(f66 * f70);
  f67 = Math_fround(f67 * f22);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f38 * f69);
  f70 = Math_fround(f39 * f70);
  f22 = Math_fround(f59 * f22);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = f71 > Math_fround(9.99999974e-06);
  i56 = f72 > Math_fround(9.99999974e-06);
  i57 = f73 > Math_fround(9.99999974e-06);
  i58 = f74 > Math_fround(9.99999974e-06);
  i2 = i55 ? i2 : 1065353216;
  i3 = i56 ? i3 : 1065353216;
  i4 = i57 ? i4 : 1065353216;
  i5 = i58 ? i5 : 1065353216;
  i6 = i55 ? i6 : 0;
  i7 = i56 ? i7 : 0;
  i8 = i57 ? i8 : 0;
  i9 = i58 ? i9 : 0;
  i10 = i55 ? i10 : 0;
  i11 = i56 ? i11 : 0;
  i12 = i57 ? i12 : 0;
  i58 = i58 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i621 >> 2] = i2;
  HEAP32[i270 >> 2] = i3;
  HEAP32[i271 >> 2] = i4;
  HEAP32[i272 >> 2] = i5;
  HEAP32[i273 >> 2] = i6;
  HEAP32[i274 >> 2] = i7;
  HEAP32[i275 >> 2] = i8;
  HEAP32[i276 >> 2] = i9;
  HEAP32[i277 >> 2] = i10;
  HEAP32[i278 >> 2] = i11;
  HEAP32[i279 >> 2] = i12;
  HEAP32[i280 >> 2] = i58;
  f65 = Math_fround(HEAPF32[i269 >> 2]);
  f73 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f65 * f73);
  f68 = Math_fround(HEAPF32[i261 >> 2]);
  f29 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f68 * f29);
  f71 = Math_fround(HEAPF32[i262 >> 2]);
  f74 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f71 * f74);
  f32 = Math_fround(HEAPF32[i263 >> 2]);
  f30 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f32 * f30);
  f59 = Math_fround(HEAPF32[i268 >> 2]);
  f63 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f59 * f63);
  f60 = Math_fround(HEAPF32[i265 >> 2]);
  f66 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = Math_fround(f60 * f66);
  f61 = Math_fround(HEAPF32[i266 >> 2]);
  f69 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(f61 * f69);
  f62 = Math_fround(HEAPF32[i267 >> 2]);
  f33 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f27 - f25);
  f24 = Math_fround(f26 - f24);
  f23 = Math_fround(f31 - f23);
  f22 = Math_fround(f22 - Math_fround(f62 * f33));
  f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(f59 * f31);
  f26 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f60 * f26);
  f27 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f61 * f27);
  f28 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f62 * f28);
  f64 = Math_fround(HEAPF32[i256 >> 2]);
  f73 = Math_fround(f73 * f64);
  f67 = Math_fround(HEAPF32[i257 >> 2]);
  f29 = Math_fround(f29 * f67);
  f70 = Math_fround(HEAPF32[i258 >> 2]);
  f74 = Math_fround(f74 * f70);
  f72 = Math_fround(HEAPF32[i259 >> 2]);
  f73 = Math_fround(f59 - f73);
  f29 = Math_fround(f60 - f29);
  f74 = Math_fround(f61 - f74);
  f30 = Math_fround(f62 - Math_fround(f30 * f72));
  f31 = Math_fround(Math_fround(f63 * f64) - Math_fround(f65 * f31));
  f26 = Math_fround(Math_fround(f66 * f67) - Math_fround(f68 * f26));
  f27 = Math_fround(Math_fround(f69 * f70) - Math_fround(f71 * f27));
  f28 = Math_fround(Math_fround(f33 * f72) - Math_fround(f32 * f28));
  HEAPF32[i283 >> 2] = f25;
  HEAPF32[i284 >> 2] = f24;
  HEAPF32[i285 >> 2] = f23;
  HEAPF32[i286 >> 2] = f22;
  HEAPF32[i287 >> 2] = f73;
  HEAPF32[i288 >> 2] = f29;
  HEAPF32[i289 >> 2] = f74;
  HEAPF32[i290 >> 2] = f30;
  HEAPF32[i291 >> 2] = f31;
  HEAPF32[i292 >> 2] = f26;
  HEAPF32[i293 >> 2] = f27;
  HEAPF32[i294 >> 2] = f28;
  f28 = Math_fround(Math_fround(HEAPF32[i198 >> 2]) * Math_fround(.159154937));
  f27 = Math_fround(Math_fround(HEAPF32[i201 >> 2]) * Math_fround(.159154937));
  f26 = Math_fround(Math_fround(HEAPF32[i200 >> 2]) * Math_fround(.159154937));
  f31 = Math_fround(Math_fround(HEAPF32[i199 >> 2]) * Math_fround(.159154937));
  f30 = Math_fround(+_roundf(+f28));
  f74 = Math_fround(+_roundf(+f27));
  f29 = Math_fround(+_roundf(+f26));
  f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f30))));
  f74 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f74))));
  f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f29))));
  f73 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
  f22 = Math_fround(f30 * f30);
  f23 = Math_fround(f74 * f74);
  f24 = Math_fround(f29 * f29);
  f25 = Math_fround(f73 * f73);
  f32 = Math_fround(f22 * f22);
  f72 = Math_fround(f23 * f23);
  f33 = Math_fround(f24 * f24);
  f71 = Math_fround(f25 * f25);
  f22 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f22 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f22 * Math_fround(76.5686187)))))));
  f23 = Math_fround(f74 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f23 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f23 * Math_fround(76.5686187)))))));
  f24 = Math_fround(f29 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f24 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f24 * Math_fround(76.5686187)))))));
  f25 = Math_fround(f73 * Math_fround(Math_fround(Math_fround(f71 * f71) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f25 * Math_fround(41.3416595))) + Math_fround(f71 * Math_fround(Math_fround(81.6018218) - Math_fround(f25 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f28 + Math_fround(-.25));
  f27 = Math_fround(f27 + Math_fround(-.25));
  f26 = Math_fround(f26 + Math_fround(-.25));
  f31 = Math_fround(f31 + Math_fround(-.25));
  f71 = Math_fround(+_roundf(+f28));
  f73 = Math_fround(+_roundf(+f27));
  f33 = Math_fround(+_roundf(+f26));
  f71 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f71))));
  f73 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f73))));
  f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f33))));
  f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
  f26 = Math_fround(f71 * f71);
  f27 = Math_fround(f73 * f73);
  f28 = Math_fround(f33 * f33);
  f29 = Math_fround(f31 * f31);
  f72 = Math_fround(f26 * f26);
  f74 = Math_fround(f27 * f27);
  f32 = Math_fround(f28 * f28);
  f30 = Math_fround(f29 * f29);
  f26 = Math_fround(f71 * Math_fround(Math_fround(Math_fround(f72 * f72) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f26 * Math_fround(41.3416595))) + Math_fround(f72 * Math_fround(Math_fround(81.6018218) - Math_fround(f26 * Math_fround(76.5686187)))))));
  f27 = Math_fround(f73 * Math_fround(Math_fround(Math_fround(f74 * f74) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f74 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
  f29 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f29 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f29 * Math_fround(76.5686187)))))));
  f30 = Math_fround(-f26);
  f31 = Math_fround(-f27);
  f32 = Math_fround(-f28);
  f33 = Math_fround(-f29);
  HEAPF32[i622 >> 2] = f22;
  HEAPF32[i295 >> 2] = f23;
  HEAPF32[i296 >> 2] = f24;
  HEAPF32[i297 >> 2] = f25;
  HEAPF32[i298 >> 2] = f30;
  HEAPF32[i299 >> 2] = f31;
  HEAPF32[i300 >> 2] = f32;
  HEAPF32[i301 >> 2] = f33;
  HEAP32[i302 >> 2] = 0;
  HEAP32[i302 + 4 >> 2] = 0;
  HEAP32[i302 + 8 >> 2] = 0;
  HEAP32[i302 + 12 >> 2] = 0;
  HEAPF32[i306 >> 2] = f26;
  HEAPF32[i307 >> 2] = f27;
  HEAPF32[i308 >> 2] = f28;
  HEAPF32[i309 >> 2] = f29;
  HEAPF32[i310 >> 2] = f22;
  HEAPF32[i311 >> 2] = f23;
  HEAPF32[i312 >> 2] = f24;
  HEAPF32[i313 >> 2] = f25;
  i10 = i314;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i324 >> 2] = 1065353216;
  HEAP32[i325 >> 2] = 1065353216;
  HEAP32[i326 >> 2] = 1065353216;
  HEAP32[i327 >> 2] = 1065353216;
  f39 = Math_fround(HEAPF32[i621 >> 2]);
  f662 = Math_fround(f39 * f22);
  f59 = Math_fround(HEAPF32[i270 >> 2]);
  f661 = Math_fround(f59 * f23);
  f74 = Math_fround(HEAPF32[i271 >> 2]);
  f663 = Math_fround(f74 * f24);
  f671 = Math_fround(HEAPF32[i272 >> 2]);
  f664 = Math_fround(f671 * f25);
  f672 = Math_fround(HEAPF32[i283 >> 2]);
  f670 = Math_fround(f672 * f30);
  f68 = Math_fround(HEAPF32[i284 >> 2]);
  f659 = Math_fround(f68 * f31);
  f70 = Math_fround(HEAPF32[i285 >> 2]);
  f69 = Math_fround(f70 * f32);
  f71 = Math_fround(HEAPF32[i286 >> 2]);
  f670 = Math_fround(f662 + f670);
  f659 = Math_fround(f661 + f659);
  f69 = Math_fround(f663 + f69);
  f664 = Math_fround(f664 + Math_fround(f71 * f33));
  f663 = Math_fround(HEAPF32[i328 >> 2]);
  f661 = Math_fround(f663 * Math_fround(0.0));
  f662 = Math_fround(HEAPF32[i257 >> 2]);
  f72 = Math_fround(f662 * Math_fround(0.0));
  f38 = Math_fround(HEAPF32[i258 >> 2]);
  f673 = Math_fround(f38 * Math_fround(0.0));
  f660 = Math_fround(HEAPF32[i259 >> 2]);
  f73 = Math_fround(f660 * Math_fround(0.0));
  f659 = Math_fround(f659 + f72);
  f69 = Math_fround(f69 + f673);
  f664 = Math_fround(f664 + f73);
  HEAPF32[i623 >> 2] = Math_fround(f670 + f661);
  HEAPF32[i330 >> 2] = f659;
  HEAPF32[i331 >> 2] = f69;
  HEAPF32[i332 >> 2] = f664;
  f72 = Math_fround(Math_fround(Math_fround(f59 * f27) + Math_fround(f68 * f23)) + f72);
  f673 = Math_fround(Math_fround(Math_fround(f74 * f28) + Math_fround(f70 * f24)) + f673);
  f28 = Math_fround(Math_fround(Math_fround(f671 * f29) + Math_fround(f71 * f25)) + f73);
  HEAPF32[i334 >> 2] = Math_fround(Math_fround(Math_fround(f39 * f26) + Math_fround(f672 * f22)) + f661);
  HEAPF32[i335 >> 2] = f72;
  HEAPF32[i336 >> 2] = f673;
  HEAPF32[i337 >> 2] = f28;
  f662 = Math_fround(Math_fround(Math_fround(f59 * Math_fround(0.0)) + Math_fround(f68 * Math_fround(0.0))) + f662);
  f38 = Math_fround(Math_fround(Math_fround(f74 * Math_fround(0.0)) + Math_fround(f70 * Math_fround(0.0))) + f38);
  f660 = Math_fround(Math_fround(Math_fround(f671 * Math_fround(0.0)) + Math_fround(f71 * Math_fround(0.0))) + f660);
  HEAPF32[i341 >> 2] = Math_fround(Math_fround(Math_fround(f39 * Math_fround(0.0)) + Math_fround(f672 * Math_fround(0.0))) + f663);
  HEAPF32[i342 >> 2] = f662;
  HEAPF32[i343 >> 2] = f38;
  HEAPF32[i344 >> 2] = f660;
  f660 = Math_fround(HEAPF32[i281 >> 2]);
  f38 = Math_fround(f660 * Math_fround(HEAPF32[i622 >> 2]));
  f662 = Math_fround(HEAPF32[i274 >> 2]);
  f663 = Math_fround(f662 * Math_fround(HEAPF32[i295 >> 2]));
  f672 = Math_fround(HEAPF32[i275 >> 2]);
  f39 = Math_fround(f672 * Math_fround(HEAPF32[i296 >> 2]));
  f71 = Math_fround(HEAPF32[i276 >> 2]);
  f671 = Math_fround(f71 * Math_fround(HEAPF32[i297 >> 2]));
  f70 = Math_fround(HEAPF32[i287 >> 2]);
  f74 = Math_fround(f70 * Math_fround(HEAPF32[i298 >> 2]));
  f68 = Math_fround(HEAPF32[i288 >> 2]);
  f59 = Math_fround(f68 * Math_fround(HEAPF32[i299 >> 2]));
  f28 = Math_fround(HEAPF32[i289 >> 2]);
  f673 = Math_fround(f28 * Math_fround(HEAPF32[i300 >> 2]));
  f72 = Math_fround(HEAPF32[i290 >> 2]);
  f74 = Math_fround(f38 + f74);
  f59 = Math_fround(f663 + f59);
  f673 = Math_fround(f39 + f673);
  f671 = Math_fround(f671 + Math_fround(f72 * Math_fround(HEAPF32[i301 >> 2])));
  f39 = Math_fround(HEAPF32[i269 >> 2]);
  f663 = Math_fround(f39 * Math_fround(HEAPF32[i329 >> 2]));
  f38 = Math_fround(HEAPF32[i261 >> 2]);
  f661 = Math_fround(f38 * Math_fround(HEAPF32[i303 >> 2]));
  f73 = Math_fround(HEAPF32[i262 >> 2]);
  f664 = Math_fround(f73 * Math_fround(HEAPF32[i304 >> 2]));
  f69 = Math_fround(HEAPF32[i263 >> 2]);
  f661 = Math_fround(f59 + f661);
  f664 = Math_fround(f673 + f664);
  f671 = Math_fround(f671 + Math_fround(f69 * Math_fround(HEAPF32[i305 >> 2])));
  HEAPF32[i345 >> 2] = Math_fround(f74 + f663);
  HEAPF32[i346 >> 2] = f661;
  HEAPF32[i347 >> 2] = f664;
  HEAPF32[i348 >> 2] = f671;
  f671 = Math_fround(f660 * Math_fround(HEAPF32[i306 >> 2]));
  f664 = Math_fround(f662 * Math_fround(HEAPF32[i307 >> 2]));
  f661 = Math_fround(f672 * Math_fround(HEAPF32[i308 >> 2]));
  f663 = Math_fround(f71 * Math_fround(HEAPF32[i309 >> 2]));
  f74 = Math_fround(f70 * Math_fround(HEAPF32[i310 >> 2]));
  f673 = Math_fround(f68 * Math_fround(HEAPF32[i311 >> 2]));
  f59 = Math_fround(f28 * Math_fround(HEAPF32[i312 >> 2]));
  f74 = Math_fround(f671 + f74);
  f673 = Math_fround(f664 + f673);
  f59 = Math_fround(f661 + f59);
  f663 = Math_fround(f663 + Math_fround(f72 * Math_fround(HEAPF32[i313 >> 2])));
  f661 = Math_fround(f39 * Math_fround(HEAPF32[i333 >> 2]));
  f664 = Math_fround(f38 * Math_fround(HEAPF32[i315 >> 2]));
  f671 = Math_fround(f73 * Math_fround(HEAPF32[i316 >> 2]));
  f664 = Math_fround(f673 + f664);
  f671 = Math_fround(f59 + f671);
  f663 = Math_fround(f663 + Math_fround(f69 * Math_fround(HEAPF32[i317 >> 2])));
  HEAPF32[i349 >> 2] = Math_fround(f74 + f661);
  HEAPF32[i350 >> 2] = f664;
  HEAPF32[i351 >> 2] = f671;
  HEAPF32[i352 >> 2] = f663;
  f660 = Math_fround(f660 * Math_fround(HEAPF32[i338 >> 2]));
  f662 = Math_fround(f662 * Math_fround(HEAPF32[i318 >> 2]));
  f672 = Math_fround(f672 * Math_fround(HEAPF32[i319 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i320 >> 2]));
  f70 = Math_fround(f70 * Math_fround(HEAPF32[i339 >> 2]));
  f68 = Math_fround(f68 * Math_fround(HEAPF32[i321 >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i322 >> 2]));
  f70 = Math_fround(f660 + f70);
  f68 = Math_fround(f662 + f68);
  f28 = Math_fround(f672 + f28);
  f72 = Math_fround(f71 + Math_fround(f72 * Math_fround(HEAPF32[i323 >> 2])));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i340 >> 2]));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i325 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i326 >> 2]));
  f38 = Math_fround(f68 + f38);
  f73 = Math_fround(f28 + f73);
  f69 = Math_fround(f72 + Math_fround(f69 * Math_fround(HEAPF32[i327 >> 2])));
  HEAPF32[i353 >> 2] = Math_fround(f70 + f39);
  HEAPF32[i354 >> 2] = f38;
  HEAPF32[i355 >> 2] = f73;
  HEAPF32[i356 >> 2] = f69;
  f69 = Math_fround(HEAPF32[i282 >> 2]);
  f73 = Math_fround(f69 * Math_fround(HEAPF32[i622 >> 2]));
  f38 = Math_fround(HEAPF32[i278 >> 2]);
  f39 = Math_fround(f38 * Math_fround(HEAPF32[i295 >> 2]));
  f70 = Math_fround(HEAPF32[i279 >> 2]);
  f72 = Math_fround(f70 * Math_fround(HEAPF32[i296 >> 2]));
  f28 = Math_fround(HEAPF32[i280 >> 2]);
  f68 = Math_fround(f28 * Math_fround(HEAPF32[i297 >> 2]));
  f71 = Math_fround(HEAPF32[i291 >> 2]);
  f672 = Math_fround(f71 * Math_fround(HEAPF32[i298 >> 2]));
  f662 = Math_fround(HEAPF32[i292 >> 2]);
  f660 = Math_fround(f662 * Math_fround(HEAPF32[i299 >> 2]));
  f663 = Math_fround(HEAPF32[i293 >> 2]);
  f671 = Math_fround(f663 * Math_fround(HEAPF32[i300 >> 2]));
  f664 = Math_fround(HEAPF32[i294 >> 2]);
  f672 = Math_fround(f73 + f672);
  f660 = Math_fround(f39 + f660);
  f671 = Math_fround(f72 + f671);
  f68 = Math_fround(f68 + Math_fround(f664 * Math_fround(HEAPF32[i301 >> 2])));
  f72 = Math_fround(HEAPF32[i268 >> 2]);
  f39 = Math_fround(f72 * Math_fround(HEAPF32[i329 >> 2]));
  f73 = Math_fround(HEAPF32[i265 >> 2]);
  f661 = Math_fround(f73 * Math_fround(HEAPF32[i303 >> 2]));
  f74 = Math_fround(HEAPF32[i266 >> 2]);
  f59 = Math_fround(f74 * Math_fround(HEAPF32[i304 >> 2]));
  f673 = Math_fround(HEAPF32[i267 >> 2]);
  f661 = Math_fround(f660 + f661);
  f59 = Math_fround(f671 + f59);
  f68 = Math_fround(f68 + Math_fround(f673 * Math_fround(HEAPF32[i305 >> 2])));
  HEAPF32[i357 >> 2] = Math_fround(f672 + f39);
  HEAPF32[i358 >> 2] = f661;
  HEAPF32[i359 >> 2] = f59;
  HEAPF32[i360 >> 2] = f68;
  f68 = Math_fround(f69 * Math_fround(HEAPF32[i306 >> 2]));
  f59 = Math_fround(f38 * Math_fround(HEAPF32[i307 >> 2]));
  f661 = Math_fround(f70 * Math_fround(HEAPF32[i308 >> 2]));
  f39 = Math_fround(f28 * Math_fround(HEAPF32[i309 >> 2]));
  f672 = Math_fround(f71 * Math_fround(HEAPF32[i310 >> 2]));
  f671 = Math_fround(f662 * Math_fround(HEAPF32[i311 >> 2]));
  f660 = Math_fround(f663 * Math_fround(HEAPF32[i312 >> 2]));
  f672 = Math_fround(f68 + f672);
  f671 = Math_fround(f59 + f671);
  f660 = Math_fround(f661 + f660);
  f39 = Math_fround(f39 + Math_fround(f664 * Math_fround(HEAPF32[i313 >> 2])));
  f661 = Math_fround(f72 * Math_fround(HEAPF32[i333 >> 2]));
  f59 = Math_fround(f73 * Math_fround(HEAPF32[i315 >> 2]));
  f68 = Math_fround(f74 * Math_fround(HEAPF32[i316 >> 2]));
  f59 = Math_fround(f671 + f59);
  f68 = Math_fround(f660 + f68);
  f39 = Math_fround(f39 + Math_fround(f673 * Math_fround(HEAPF32[i317 >> 2])));
  HEAPF32[i361 >> 2] = Math_fround(f672 + f661);
  HEAPF32[i362 >> 2] = f59;
  HEAPF32[i363 >> 2] = f68;
  HEAPF32[i364 >> 2] = f39;
  f69 = Math_fround(f69 * Math_fround(HEAPF32[i338 >> 2]));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i318 >> 2]));
  f70 = Math_fround(f70 * Math_fround(HEAPF32[i319 >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i320 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i339 >> 2]));
  f662 = Math_fround(f662 * Math_fround(HEAPF32[i321 >> 2]));
  f663 = Math_fround(f663 * Math_fround(HEAPF32[i322 >> 2]));
  f71 = Math_fround(f69 + f71);
  f662 = Math_fround(f38 + f662);
  f663 = Math_fround(f70 + f663);
  f664 = Math_fround(f28 + Math_fround(f664 * Math_fround(HEAPF32[i323 >> 2])));
  f72 = Math_fround(f72 * Math_fround(HEAPF32[i340 >> 2]));
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i325 >> 2]));
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i326 >> 2]));
  f73 = Math_fround(f662 + f73);
  f74 = Math_fround(f663 + f74);
  f673 = Math_fround(f664 + Math_fround(f673 * Math_fround(HEAPF32[i327 >> 2])));
  HEAPF32[i365 >> 2] = Math_fround(f71 + f72);
  HEAPF32[i366 >> 2] = f73;
  HEAPF32[i367 >> 2] = f74;
  HEAPF32[i368 >> 2] = f673;
  f74 = i14 ? f41 : Math_fround(0.0);
  f73 = i13 ? f40 : Math_fround(0.0);
  f72 = i16 ? f48 : Math_fround(0.0);
  f71 = i15 ? f34 : Math_fround(0.0);
  f664 = Math_fround(f79 - f74);
  f663 = Math_fround(f78 - f73);
  f662 = Math_fround(f80 - f72);
  f28 = Math_fround(f37 - f71);
  f70 = i14 ? f49 : Math_fround(0.0);
  f38 = Math_fround(f84 + f70);
  f69 = i13 ? f47 : Math_fround(0.0);
  f39 = Math_fround(f82 + f69);
  f68 = i16 ? f50 : Math_fround(0.0);
  f40 = Math_fround(f83 + f68);
  f59 = i15 ? f35 : Math_fround(0.0);
  f41 = Math_fround(f81 + f59);
  f661 = Math_fround(HEAPF32[i623 >> 2]);
  f672 = Math_fround(f664 * f661);
  f660 = Math_fround(HEAPF32[i330 >> 2]);
  f671 = Math_fround(f663 * f660);
  f659 = Math_fround(HEAPF32[i331 >> 2]);
  f670 = Math_fround(f662 * f659);
  f658 = Math_fround(HEAPF32[i332 >> 2]);
  f669 = Math_fround(f28 * f658);
  f685 = Math_fround(HEAPF32[i334 >> 2]);
  f30 = Math_fround(f38 * f685);
  f684 = Math_fround(HEAPF32[i335 >> 2]);
  f31 = Math_fround(f39 * f684);
  f683 = Math_fround(HEAPF32[i336 >> 2]);
  f32 = Math_fround(f40 * f683);
  f682 = Math_fround(HEAPF32[i337 >> 2]);
  f33 = Math_fround(f41 * f682);
  f60 = Math_fround(f672 + f30);
  f61 = Math_fround(f671 + f31);
  f62 = Math_fround(f670 + f32);
  f63 = Math_fround(f669 + f33);
  f27 = Math_fround(f77 * Math_fround(HEAPF32[i341 >> 2]));
  f649 = Math_fround(f75 * Math_fround(HEAPF32[i342 >> 2]));
  f648 = Math_fround(f76 * Math_fround(HEAPF32[i343 >> 2]));
  f647 = Math_fround(f36 * Math_fround(HEAPF32[i344 >> 2]));
  f60 = Math_fround(f60 + f27);
  f61 = Math_fround(f61 + f649);
  f62 = Math_fround(f62 + f648);
  f63 = Math_fround(f63 + f647);
  f657 = Math_fround(HEAPF32[i345 >> 2]);
  f668 = Math_fround(f664 * f657);
  f656 = Math_fround(HEAPF32[i346 >> 2]);
  f667 = Math_fround(f663 * f656);
  f655 = Math_fround(HEAPF32[i347 >> 2]);
  f666 = Math_fround(f662 * f655);
  f654 = Math_fround(HEAPF32[i348 >> 2]);
  f665 = Math_fround(f28 * f654);
  f681 = Math_fround(HEAPF32[i349 >> 2]);
  f34 = Math_fround(f38 * f681);
  f680 = Math_fround(HEAPF32[i350 >> 2]);
  f35 = Math_fround(f39 * f680);
  f679 = Math_fround(HEAPF32[i351 >> 2]);
  f687 = Math_fround(f40 * f679);
  f678 = Math_fround(HEAPF32[i352 >> 2]);
  f686 = Math_fround(f41 * f678);
  f64 = Math_fround(f668 + f34);
  f65 = Math_fround(f667 + f35);
  f66 = Math_fround(f666 + f687);
  f67 = Math_fround(f665 + f686);
  f646 = Math_fround(f77 * Math_fround(HEAPF32[i353 >> 2]));
  f645 = Math_fround(f75 * Math_fround(HEAPF32[i354 >> 2]));
  f644 = Math_fround(f76 * Math_fround(HEAPF32[i355 >> 2]));
  f22 = Math_fround(f36 * Math_fround(HEAPF32[i356 >> 2]));
  f64 = Math_fround(f64 + f646);
  f65 = Math_fround(f65 + f645);
  f66 = Math_fround(f66 + f644);
  f67 = Math_fround(f67 + f22);
  f653 = Math_fround(HEAPF32[i357 >> 2]);
  f664 = Math_fround(f664 * f653);
  f652 = Math_fround(HEAPF32[i358 >> 2]);
  f663 = Math_fround(f663 * f652);
  f651 = Math_fround(HEAPF32[i359 >> 2]);
  f662 = Math_fround(f662 * f651);
  f650 = Math_fround(HEAPF32[i360 >> 2]);
  f28 = Math_fround(f28 * f650);
  f677 = Math_fround(HEAPF32[i361 >> 2]);
  f38 = Math_fround(f38 * f677);
  f676 = Math_fround(HEAPF32[i362 >> 2]);
  f39 = Math_fround(f39 * f676);
  f29 = Math_fround(HEAPF32[i363 >> 2]);
  f40 = Math_fround(f40 * f29);
  f26 = Math_fround(HEAPF32[i364 >> 2]);
  f41 = Math_fround(f41 * f26);
  f47 = Math_fround(f664 + f38);
  f48 = Math_fround(f663 + f39);
  f49 = Math_fround(f662 + f40);
  f50 = Math_fround(f28 + f41);
  f23 = Math_fround(f77 * Math_fround(HEAPF32[i365 >> 2]));
  f24 = Math_fround(f75 * Math_fround(HEAPF32[i366 >> 2]));
  f25 = Math_fround(f76 * Math_fround(HEAPF32[i367 >> 2]));
  f673 = Math_fround(f36 * f673);
  f47 = Math_fround(f47 + f23);
  f48 = Math_fround(f48 + f24);
  f49 = Math_fround(f49 + f25);
  f50 = Math_fround(f673 + f50);
  f674 = Math_fround(f79 + f74);
  f675 = Math_fround(f78 + f73);
  f75 = Math_fround(f80 + f72);
  f76 = Math_fround(f37 + f71);
  f661 = Math_fround(f674 * f661);
  f660 = Math_fround(f675 * f660);
  f659 = Math_fround(f75 * f659);
  f658 = Math_fround(f76 * f658);
  f30 = Math_fround(Math_fround(f661 + f30) + f27);
  f31 = Math_fround(Math_fround(f660 + f31) + f649);
  f32 = Math_fround(Math_fround(f659 + f32) + f648);
  f33 = Math_fround(Math_fround(f658 + f33) + f647);
  f657 = Math_fround(f674 * f657);
  f656 = Math_fround(f675 * f656);
  f655 = Math_fround(f75 * f655);
  f654 = Math_fround(f76 * f654);
  f34 = Math_fround(Math_fround(f657 + f34) + f646);
  f35 = Math_fround(Math_fround(f656 + f35) + f645);
  f36 = Math_fround(Math_fround(f655 + f687) + f644);
  f37 = Math_fround(Math_fround(f654 + f686) + f22);
  f653 = Math_fround(f674 * f653);
  f652 = Math_fround(f675 * f652);
  f651 = Math_fround(f75 * f651);
  f650 = Math_fround(f76 * f650);
  f38 = Math_fround(Math_fround(f653 + f38) + f23);
  f39 = Math_fround(Math_fround(f652 + f39) + f24);
  f40 = Math_fround(Math_fround(f651 + f40) + f25);
  f41 = Math_fround(f673 + Math_fround(f650 + f41));
  f76 = Math_fround(f84 - f70);
  f75 = Math_fround(f82 - f69);
  f675 = Math_fround(f83 - f68);
  f674 = Math_fround(f81 - f59);
  f84 = Math_fround(f76 * f685);
  f83 = Math_fround(f75 * f684);
  f82 = Math_fround(f675 * f683);
  f81 = Math_fround(f674 * f682);
  f661 = Math_fround(Math_fround(f661 + f84) + f27);
  f660 = Math_fround(Math_fround(f660 + f83) + f649);
  f659 = Math_fround(Math_fround(f659 + f82) + f648);
  f658 = Math_fround(Math_fround(f658 + f81) + f647);
  f80 = Math_fround(f76 * f681);
  f79 = Math_fround(f75 * f680);
  f78 = Math_fround(f675 * f679);
  f77 = Math_fround(f674 * f678);
  f657 = Math_fround(Math_fround(f657 + f80) + f646);
  f656 = Math_fround(Math_fround(f656 + f79) + f645);
  f655 = Math_fround(Math_fround(f655 + f78) + f644);
  f654 = Math_fround(Math_fround(f654 + f77) + f22);
  f76 = Math_fround(f76 * f677);
  f75 = Math_fround(f75 * f676);
  f29 = Math_fround(f675 * f29);
  f26 = Math_fround(f674 * f26);
  f653 = Math_fround(Math_fround(f653 + f76) + f23);
  f652 = Math_fround(Math_fround(f652 + f75) + f24);
  f651 = Math_fround(Math_fround(f651 + f29) + f25);
  f650 = Math_fround(f673 + Math_fround(f650 + f26));
  f27 = Math_fround(Math_fround(f672 + f84) + f27);
  f649 = Math_fround(Math_fround(f671 + f83) + f649);
  f648 = Math_fround(Math_fround(f670 + f82) + f648);
  f647 = Math_fround(Math_fround(f669 + f81) + f647);
  f646 = Math_fround(Math_fround(f668 + f80) + f646);
  f645 = Math_fround(Math_fround(f667 + f79) + f645);
  f644 = Math_fround(Math_fround(f666 + f78) + f644);
  f22 = Math_fround(Math_fround(f665 + f77) + f22);
  f23 = Math_fround(Math_fround(f664 + f76) + f23);
  f24 = Math_fround(Math_fround(f663 + f75) + f24);
  f25 = Math_fround(Math_fround(f662 + f29) + f25);
  f26 = Math_fround(f673 + Math_fround(f28 + f26));
  f28 = Math_fround(HEAPF32[i620 >> 2]);
  f673 = Math_fround(f60 + f28);
  f29 = Math_fround(HEAPF32[i245 >> 2]);
  f662 = Math_fround(f61 + f29);
  f75 = Math_fround(HEAPF32[i246 >> 2]);
  f663 = Math_fround(f62 + f75);
  f76 = Math_fround(HEAPF32[i247 >> 2]);
  f664 = Math_fround(f63 + f76);
  f77 = Math_fround(HEAPF32[i248 >> 2]);
  f665 = Math_fround(f64 + f77);
  f78 = Math_fround(HEAPF32[i249 >> 2]);
  f666 = Math_fround(f65 + f78);
  f79 = Math_fround(HEAPF32[i250 >> 2]);
  f667 = Math_fround(f66 + f79);
  f80 = Math_fround(HEAPF32[i251 >> 2]);
  f668 = Math_fround(f67 + f80);
  f81 = Math_fround(HEAPF32[i252 >> 2]);
  f669 = Math_fround(f47 + f81);
  f82 = Math_fround(HEAPF32[i253 >> 2]);
  f670 = Math_fround(f48 + f82);
  f83 = Math_fround(HEAPF32[i254 >> 2]);
  f671 = Math_fround(f49 + f83);
  f84 = Math_fround(HEAPF32[i255 >> 2]);
  f672 = Math_fround(f50 + f84);
  HEAPF32[i619 >> 2] = f673;
  HEAPF32[i369 >> 2] = f662;
  HEAPF32[i370 >> 2] = f663;
  HEAPF32[i371 >> 2] = f664;
  HEAPF32[i372 >> 2] = f665;
  HEAPF32[i373 >> 2] = f666;
  HEAPF32[i374 >> 2] = f667;
  HEAPF32[i375 >> 2] = f668;
  HEAPF32[i376 >> 2] = f669;
  HEAPF32[i377 >> 2] = f670;
  HEAPF32[i378 >> 2] = f671;
  HEAPF32[i379 >> 2] = f672;
  f672 = Math_fround(f31 + f29);
  f671 = Math_fround(f32 + f75);
  f670 = Math_fround(f33 + f76);
  f669 = Math_fround(f34 + f77);
  f668 = Math_fround(f35 + f78);
  f667 = Math_fround(f36 + f79);
  f666 = Math_fround(f37 + f80);
  f665 = Math_fround(f38 + f81);
  f664 = Math_fround(f39 + f82);
  f663 = Math_fround(f40 + f83);
  f662 = Math_fround(f41 + f84);
  HEAPF32[i380 >> 2] = Math_fround(f30 + f28);
  HEAPF32[i381 >> 2] = f672;
  HEAPF32[i382 >> 2] = f671;
  HEAPF32[i383 >> 2] = f670;
  HEAPF32[i384 >> 2] = f669;
  HEAPF32[i385 >> 2] = f668;
  HEAPF32[i386 >> 2] = f667;
  HEAPF32[i387 >> 2] = f666;
  HEAPF32[i388 >> 2] = f665;
  HEAPF32[i389 >> 2] = f664;
  HEAPF32[i390 >> 2] = f663;
  HEAPF32[i391 >> 2] = f662;
  f660 = Math_fround(f660 + f29);
  f659 = Math_fround(f659 + f75);
  f658 = Math_fround(f658 + f76);
  f657 = Math_fround(f657 + f77);
  f656 = Math_fround(f656 + f78);
  f655 = Math_fround(f655 + f79);
  f654 = Math_fround(f654 + f80);
  f653 = Math_fround(f653 + f81);
  f652 = Math_fround(f652 + f82);
  f651 = Math_fround(f651 + f83);
  f650 = Math_fround(f650 + f84);
  HEAPF32[i392 >> 2] = Math_fround(f661 + f28);
  HEAPF32[i393 >> 2] = f660;
  HEAPF32[i394 >> 2] = f659;
  HEAPF32[i395 >> 2] = f658;
  HEAPF32[i396 >> 2] = f657;
  HEAPF32[i397 >> 2] = f656;
  HEAPF32[i398 >> 2] = f655;
  HEAPF32[i399 >> 2] = f654;
  HEAPF32[i400 >> 2] = f653;
  HEAPF32[i401 >> 2] = f652;
  HEAPF32[i402 >> 2] = f651;
  HEAPF32[i403 >> 2] = f650;
  f29 = Math_fround(f649 + f29);
  f75 = Math_fround(f648 + f75);
  f76 = Math_fround(f647 + f76);
  f77 = Math_fround(f646 + f77);
  f78 = Math_fround(f645 + f78);
  f79 = Math_fround(f644 + f79);
  f80 = Math_fround(f22 + f80);
  f81 = Math_fround(f23 + f81);
  f82 = Math_fround(f24 + f82);
  f83 = Math_fround(f25 + f83);
  f84 = Math_fround(f26 + f84);
  HEAPF32[i404 >> 2] = Math_fround(f27 + f28);
  HEAPF32[i405 >> 2] = f29;
  HEAPF32[i406 >> 2] = f75;
  HEAPF32[i407 >> 2] = f76;
  HEAPF32[i408 >> 2] = f77;
  HEAPF32[i409 >> 2] = f78;
  HEAPF32[i410 >> 2] = f79;
  HEAPF32[i411 >> 2] = f80;
  HEAPF32[i412 >> 2] = f81;
  HEAPF32[i413 >> 2] = f82;
  HEAPF32[i414 >> 2] = f83;
  HEAPF32[i415 >> 2] = f84;
  if (!i416) {
   i2 = HEAP32[i626 >> 2] | 0;
   if (i2 & 536870912) {
    i44 = HEAP32[i86 >> 2] | 0;
    f687 = Math_fround(HEAPF32[i44 + 564 >> 2]);
    i42 = HEAP32[i617 >> 2] | 0;
    i45 = i42 + 693089735 | 0;
    i20 = HEAP32[i236 >> 2] | 0;
    i57 = i20 + 693089735 | 0;
    i18 = HEAP32[i237 >> 2] | 0;
    i54 = i18 + 693089735 | 0;
    i16 = HEAP32[i238 >> 2] | 0;
    i51 = i16 + 693089735 | 0;
    i17 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i19 = (Math_imul(i57, 1790253981) | 0) + 1900727103 | 0;
    i21 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i43 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i45 = i45 << 11 ^ i45;
    i57 = i57 << 11 ^ i57;
    i54 = i54 << 11 ^ i54;
    i51 = i51 << 11 ^ i51;
    i17 = Math_fround(Math_fround((i17 ^ i45 ^ i45 >>> 8) & 8388607 ^ i17 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i19 = Math_fround(Math_fround((i19 ^ i57 ^ i57 >>> 8) & 8388607 ^ i19 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i21 = Math_fround(Math_fround((i21 ^ i54 ^ i54 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i43 = Math_fround(Math_fround((i43 ^ i51 ^ i51 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    f687 = Math_fround(HEAPF32[i44 + 568 >> 2]);
    i42 = i42 + 13945730 | 0;
    i20 = i20 + 13945730 | 0;
    i18 = i18 + 13945730 | 0;
    i16 = i16 + 13945730 | 0;
    i44 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i18, 1790253981) | 0) + 1900727103 | 0;
    i57 = (Math_imul(i16, 1790253981) | 0) + 1900727103 | 0;
    i42 = i42 << 11 ^ i42;
    i20 = i20 << 11 ^ i20;
    i18 = i18 << 11 ^ i18;
    i16 = i16 << 11 ^ i16;
    i44 = Math_fround(Math_fround((i44 ^ i42 ^ i42 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i51 = Math_fround(Math_fround((i51 ^ i20 ^ i20 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i54 = Math_fround(Math_fround((i54 ^ i18 ^ i18 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i57 = Math_fround(Math_fround((i57 ^ i16 ^ i16 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f687;
    i16 = i17 & 1;
    i18 = i19 & 1;
    i20 = i21 & 1;
    i42 = i43 & 1;
    i45 = i17 & 1 ^ 1;
    i52 = i19 & 1 ^ 1;
    i55 = i21 & 1 ^ 1;
    i58 = i43 & 1 ^ 1;
    i46 = i17 ? 3 : 2;
    i53 = i19 ? 3 : 2;
    i56 = i21 ? 3 : 2;
    i2 = i43 ? 3 : 2;
    i17 = i17 ? 2 : 3;
    i19 = i19 ? 2 : 3;
    i21 = i21 ? 2 : 3;
    i43 = i43 ? 2 : 3;
    HEAP32[i640 >> 2] = i44 ? i17 : i16;
    HEAP32[i596 >> 2] = i51 ? i19 : i18;
    HEAP32[i595 >> 2] = i54 ? i21 : i20;
    HEAP32[i594 >> 2] = i57 ? i43 : i42;
    HEAP32[i575 >> 2] = i44 ? i16 : i17;
    HEAP32[i574 >> 2] = i51 ? i18 : i19;
    HEAP32[i573 >> 2] = i54 ? i20 : i21;
    HEAP32[i572 >> 2] = i57 ? i42 : i43;
    HEAP32[i567 >> 2] = i44 ? i46 : i45;
    HEAP32[i599 >> 2] = i51 ? i53 : i52;
    HEAP32[i598 >> 2] = i54 ? i56 : i55;
    HEAP32[i597 >> 2] = i57 ? i2 : i58;
    HEAP32[i571 >> 2] = i44 ? i45 : i46;
    HEAP32[i570 >> 2] = i51 ? i52 : i53;
    HEAP32[i569 >> 2] = i54 ? i55 : i56;
    HEAP32[i568 >> 2] = i57 ? i58 : i2;
    i2 = HEAP32[i626 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f22 = Math_fround(f629 * Math_fround(HEAPF32[i618 >> 2]));
    f23 = Math_fround(f629 * Math_fround(HEAPF32[i240 >> 2]));
    f24 = Math_fround(f629 * Math_fround(HEAPF32[i241 >> 2]));
    f25 = Math_fround(f629 * Math_fround(HEAPF32[i242 >> 2]));
    f26 = Math_fround(Math_floor(Math_fround(f22)));
    f27 = Math_fround(Math_floor(Math_fround(f23)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    if (i2 & 16777216 | 0) {
     f684 = Math_fround(Math_floor(Math_fround(f628 * f26)));
     f685 = Math_fround(Math_floor(Math_fround(f628 * f27)));
     f686 = Math_fround(Math_floor(Math_fround(f628 * f28)));
     f687 = Math_fround(Math_floor(Math_fround(f628 * f29)));
     f680 = Math_fround(f630 * Math_fround(f26 - Math_fround(f627 * f684)));
     f681 = Math_fround(f630 * Math_fround(f27 - Math_fround(f627 * f685)));
     f682 = Math_fround(f630 * Math_fround(f28 - Math_fround(f627 * f686)));
     f683 = Math_fround(f630 * Math_fround(f29 - Math_fround(f627 * f687)));
     f684 = Math_fround(f632 - Math_fround(f631 * f684));
     f685 = Math_fround(f632 - Math_fround(f631 * f685));
     f686 = Math_fround(f632 - Math_fround(f631 * f686));
     f687 = Math_fround(f632 - Math_fround(f631 * f687));
     f672 = Math_fround(f631 + f684);
     f673 = Math_fround(f631 + f685);
     f674 = Math_fround(f631 + f686);
     f675 = Math_fround(f631 + f687);
     HEAPF32[i641 >> 2] = f680;
     HEAPF32[i518 >> 2] = f681;
     HEAPF32[i542 >> 2] = f682;
     HEAPF32[i566 >> 2] = f683;
     HEAPF32[i494 >> 2] = f672;
     HEAPF32[i517 >> 2] = f673;
     HEAPF32[i541 >> 2] = f674;
     HEAPF32[i565 >> 2] = f675;
     f676 = Math_fround(f630 + f680);
     f677 = Math_fround(f630 + f681);
     f678 = Math_fround(f630 + f682);
     f679 = Math_fround(f630 + f683);
     HEAPF32[i493 >> 2] = f676;
     HEAPF32[i516 >> 2] = f677;
     HEAPF32[i540 >> 2] = f678;
     HEAPF32[i564 >> 2] = f679;
     HEAPF32[i492 >> 2] = f672;
     HEAPF32[i515 >> 2] = f673;
     HEAPF32[i539 >> 2] = f674;
     HEAPF32[i563 >> 2] = f675;
     HEAPF32[i491 >> 2] = f676;
     HEAPF32[i514 >> 2] = f677;
     HEAPF32[i538 >> 2] = f678;
     HEAPF32[i562 >> 2] = f679;
     HEAPF32[i490 >> 2] = f684;
     HEAPF32[i513 >> 2] = f685;
     HEAPF32[i537 >> 2] = f686;
     HEAPF32[i561 >> 2] = f687;
     HEAPF32[i489 >> 2] = f680;
     HEAPF32[i512 >> 2] = f681;
     HEAPF32[i536 >> 2] = f682;
     HEAPF32[i560 >> 2] = f683;
     HEAPF32[i488 >> 2] = f684;
     HEAPF32[i511 >> 2] = f685;
     HEAPF32[i535 >> 2] = f686;
     HEAPF32[i559 >> 2] = f687;
    }
    if (i2 & 33554432 | 0) {
     f676 = Math_fround(f26 + Math_fround(1.0));
     f677 = Math_fround(f27 + Math_fround(1.0));
     f678 = Math_fround(f28 + Math_fround(1.0));
     f679 = Math_fround(f29 + Math_fround(1.0));
     f684 = Math_fround(f22 - f26);
     f685 = Math_fround(f23 - f27);
     f686 = Math_fround(f24 - f28);
     f687 = Math_fround(f25 - f29);
     f680 = Math_fround(Math_floor(Math_fround(f628 * f676)));
     f681 = Math_fround(Math_floor(Math_fround(f628 * f677)));
     f682 = Math_fround(Math_floor(Math_fround(f628 * f678)));
     f683 = Math_fround(Math_floor(Math_fround(f628 * f679)));
     f676 = Math_fround(f630 * Math_fround(f676 - Math_fround(f627 * f680)));
     f677 = Math_fround(f630 * Math_fround(f677 - Math_fround(f627 * f681)));
     f678 = Math_fround(f630 * Math_fround(f678 - Math_fround(f627 * f682)));
     f679 = Math_fround(f630 * Math_fround(f679 - Math_fround(f627 * f683)));
     f680 = Math_fround(f632 - Math_fround(f631 * f680));
     f681 = Math_fround(f632 - Math_fround(f631 * f681));
     f682 = Math_fround(f632 - Math_fround(f631 * f682));
     f683 = Math_fround(f632 - Math_fround(f631 * f683));
     f668 = Math_fround(f631 + f680);
     f669 = Math_fround(f631 + f681);
     f670 = Math_fround(f631 + f682);
     f671 = Math_fround(f631 + f683);
     HEAPF32[i642 >> 2] = f676;
     HEAPF32[i510 >> 2] = f677;
     HEAPF32[i534 >> 2] = f678;
     HEAPF32[i558 >> 2] = f679;
     HEAPF32[i487 >> 2] = f668;
     HEAPF32[i509 >> 2] = f669;
     HEAPF32[i533 >> 2] = f670;
     HEAPF32[i557 >> 2] = f671;
     HEAPF32[i486 >> 2] = f684;
     HEAPF32[i508 >> 2] = f685;
     HEAPF32[i532 >> 2] = f686;
     HEAPF32[i556 >> 2] = f687;
     HEAPF32[i485 >> 2] = f22;
     HEAPF32[i507 >> 2] = f23;
     HEAPF32[i531 >> 2] = f24;
     HEAPF32[i555 >> 2] = f25;
     f672 = Math_fround(f630 + f676);
     f673 = Math_fround(f630 + f677);
     f674 = Math_fround(f630 + f678);
     f675 = Math_fround(f630 + f679);
     HEAPF32[i484 >> 2] = f672;
     HEAPF32[i506 >> 2] = f673;
     HEAPF32[i530 >> 2] = f674;
     HEAPF32[i554 >> 2] = f675;
     HEAPF32[i483 >> 2] = f668;
     HEAPF32[i505 >> 2] = f669;
     HEAPF32[i529 >> 2] = f670;
     HEAPF32[i553 >> 2] = f671;
     HEAPF32[i482 >> 2] = f684;
     HEAPF32[i504 >> 2] = f685;
     HEAPF32[i528 >> 2] = f686;
     HEAPF32[i552 >> 2] = f687;
     HEAPF32[i481 >> 2] = f22;
     HEAPF32[i503 >> 2] = f23;
     HEAPF32[i527 >> 2] = f24;
     HEAPF32[i551 >> 2] = f25;
     HEAPF32[i480 >> 2] = f672;
     HEAPF32[i502 >> 2] = f673;
     HEAPF32[i526 >> 2] = f674;
     HEAPF32[i550 >> 2] = f675;
     HEAPF32[i479 >> 2] = f680;
     HEAPF32[i501 >> 2] = f681;
     HEAPF32[i525 >> 2] = f682;
     HEAPF32[i549 >> 2] = f683;
     HEAPF32[i478 >> 2] = f684;
     HEAPF32[i500 >> 2] = f685;
     HEAPF32[i524 >> 2] = f686;
     HEAPF32[i548 >> 2] = f687;
     HEAPF32[i477 >> 2] = f22;
     HEAPF32[i499 >> 2] = f23;
     HEAPF32[i523 >> 2] = f24;
     HEAPF32[i547 >> 2] = f25;
     HEAPF32[i476 >> 2] = f676;
     HEAPF32[i498 >> 2] = f677;
     HEAPF32[i522 >> 2] = f678;
     HEAPF32[i546 >> 2] = f679;
     HEAPF32[i475 >> 2] = f680;
     HEAPF32[i497 >> 2] = f681;
     HEAPF32[i521 >> 2] = f682;
     HEAPF32[i545 >> 2] = f683;
     HEAPF32[i474 >> 2] = f684;
     HEAPF32[i496 >> 2] = f685;
     HEAPF32[i520 >> 2] = f686;
     HEAPF32[i544 >> 2] = f687;
     HEAPF32[i473 >> 2] = f22;
     HEAPF32[i495 >> 2] = f23;
     HEAPF32[i519 >> 2] = f24;
     HEAPF32[i543 >> 2] = f25;
    }
   }
  }
  f672 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(f64 * f64)) + Math_fround(f47 * f47)))));
  f673 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f65 * f65)) + Math_fround(f48 * f48)))));
  f674 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f66 * f66)) + Math_fround(f49 * f49)))));
  f675 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f67 * f67)) + Math_fround(f50 * f50)))));
  f664 = Math_fround(f634 * Math_fround(f60 * f672));
  f665 = Math_fround(f634 * Math_fround(f61 * f673));
  f666 = Math_fround(f634 * Math_fround(f62 * f674));
  f667 = Math_fround(f634 * Math_fround(f63 * f675));
  f668 = Math_fround(f634 * Math_fround(f64 * f672));
  f669 = Math_fround(f634 * Math_fround(f65 * f673));
  f670 = Math_fround(f634 * Math_fround(f66 * f674));
  f671 = Math_fround(f634 * Math_fround(f67 * f675));
  f672 = Math_fround(f634 * Math_fround(f47 * f672));
  f673 = Math_fround(f634 * Math_fround(f48 * f673));
  f674 = Math_fround(f634 * Math_fround(f49 * f674));
  f675 = Math_fround(f634 * Math_fround(f50 * f675));
  f684 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f34 * f34)) + Math_fround(f38 * f38)))));
  f685 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f35 * f35)) + Math_fround(f39 * f39)))));
  f686 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f36 * f36)) + Math_fround(f40 * f40)))));
  f687 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f37 * f37)) + Math_fround(f41 * f41)))));
  f676 = Math_fround(f634 * Math_fround(f30 * f684));
  f677 = Math_fround(f634 * Math_fround(f31 * f685));
  f678 = Math_fround(f634 * Math_fround(f32 * f686));
  f679 = Math_fround(f634 * Math_fround(f33 * f687));
  f680 = Math_fround(f634 * Math_fround(f34 * f684));
  f681 = Math_fround(f634 * Math_fround(f35 * f685));
  f682 = Math_fround(f634 * Math_fround(f36 * f686));
  f683 = Math_fround(f634 * Math_fround(f37 * f687));
  f684 = Math_fround(f634 * Math_fround(f38 * f684));
  f685 = Math_fround(f634 * Math_fround(f39 * f685));
  f686 = Math_fround(f634 * Math_fround(f40 * f686));
  f687 = Math_fround(f634 * Math_fround(f41 * f687));
  f663 = Math_fround(f608 + f665);
  f662 = Math_fround(f608 + f666);
  f661 = Math_fround(f608 + f667);
  f660 = Math_fround(f602 + f668);
  f659 = Math_fround(f602 + f669);
  f658 = Math_fround(f602 + f670);
  f657 = Math_fround(f602 + f671);
  f656 = Math_fround(f604 + f672);
  f655 = Math_fround(f604 + f673);
  f654 = Math_fround(f604 + f674);
  f653 = Math_fround(f604 + f675);
  HEAPF32[i621 >> 2] = Math_fround(f608 + f664);
  HEAPF32[i147 >> 2] = f663;
  HEAPF32[i164 >> 2] = f662;
  HEAPF32[i181 >> 2] = f661;
  HEAPF32[i417 >> 2] = f660;
  HEAPF32[i142 >> 2] = f659;
  HEAPF32[i159 >> 2] = f658;
  HEAPF32[i176 >> 2] = f657;
  HEAPF32[i418 >> 2] = f656;
  HEAPF32[i137 >> 2] = f655;
  HEAPF32[i154 >> 2] = f654;
  HEAPF32[i171 >> 2] = f653;
  f653 = Math_fround(f608 + f677);
  f654 = Math_fround(f608 + f678);
  f655 = Math_fround(f608 + f679);
  f656 = Math_fround(f602 + f680);
  f657 = Math_fround(f602 + f681);
  f658 = Math_fround(f602 + f682);
  f659 = Math_fround(f602 + f683);
  f660 = Math_fround(f604 + f684);
  f661 = Math_fround(f604 + f685);
  f662 = Math_fround(f604 + f686);
  f663 = Math_fround(f604 + f687);
  HEAPF32[i419 >> 2] = Math_fround(f608 + f676);
  HEAPF32[i146 >> 2] = f653;
  HEAPF32[i163 >> 2] = f654;
  HEAPF32[i180 >> 2] = f655;
  HEAPF32[i420 >> 2] = f656;
  HEAPF32[i141 >> 2] = f657;
  HEAPF32[i158 >> 2] = f658;
  HEAPF32[i175 >> 2] = f659;
  HEAPF32[i421 >> 2] = f660;
  HEAPF32[i136 >> 2] = f661;
  HEAPF32[i153 >> 2] = f662;
  HEAPF32[i170 >> 2] = f663;
  f665 = Math_fround(f608 - f665);
  f666 = Math_fround(f608 - f666);
  f667 = Math_fround(f608 - f667);
  f668 = Math_fround(f602 - f668);
  f669 = Math_fround(f602 - f669);
  f670 = Math_fround(f602 - f670);
  f671 = Math_fround(f602 - f671);
  f672 = Math_fround(f604 - f672);
  f673 = Math_fround(f604 - f673);
  f674 = Math_fround(f604 - f674);
  f675 = Math_fround(f604 - f675);
  HEAPF32[i422 >> 2] = Math_fround(f608 - f664);
  HEAPF32[i145 >> 2] = f665;
  HEAPF32[i162 >> 2] = f666;
  HEAPF32[i179 >> 2] = f667;
  HEAPF32[i423 >> 2] = f668;
  HEAPF32[i140 >> 2] = f669;
  HEAPF32[i157 >> 2] = f670;
  HEAPF32[i174 >> 2] = f671;
  HEAPF32[i424 >> 2] = f672;
  HEAPF32[i135 >> 2] = f673;
  HEAPF32[i152 >> 2] = f674;
  HEAPF32[i169 >> 2] = f675;
  f677 = Math_fround(f608 - f677);
  f678 = Math_fround(f608 - f678);
  f679 = Math_fround(f608 - f679);
  f680 = Math_fround(f602 - f680);
  f681 = Math_fround(f602 - f681);
  f682 = Math_fround(f602 - f682);
  f683 = Math_fround(f602 - f683);
  f684 = Math_fround(f604 - f684);
  f685 = Math_fround(f604 - f685);
  f686 = Math_fround(f604 - f686);
  f687 = Math_fround(f604 - f687);
  HEAPF32[i425 >> 2] = Math_fround(f608 - f676);
  HEAPF32[i144 >> 2] = f677;
  HEAPF32[i161 >> 2] = f678;
  HEAPF32[i178 >> 2] = f679;
  HEAPF32[i426 >> 2] = f680;
  HEAPF32[i139 >> 2] = f681;
  HEAPF32[i156 >> 2] = f682;
  HEAPF32[i173 >> 2] = f683;
  HEAPF32[i427 >> 2] = f684;
  HEAPF32[i134 >> 2] = f685;
  HEAPF32[i151 >> 2] = f686;
  HEAPF32[i168 >> 2] = f687;
  do if (i185) {
   i4 = HEAP32[i211 >> 2] | 0;
   i5 = HEAP32[i638 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i58 = i5 + (i2 + i85 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i619 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i621 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i392 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i404 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i425 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i58 >> 2];
     i58 = i641 + (HEAP32[i640 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i58 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i58 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i58 = i5 + (HEAP32[i4 + (i2 + i85 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i619 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i621 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i392 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i115 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i116 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i58 >> 2];
     i57 = i641 + (HEAP32[i640 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i57 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i57 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i404 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i117 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i118 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i425 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i119 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i120 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i58 >> 2];
     i58 = i641 + (HEAP32[i640 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i58 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i58 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f675 = Math_fround(HEAPF32[i380 >> 2]);
   f675 = Math_fround(f675 - Math_fround(HEAPF32[i619 >> 2]));
   f677 = Math_fround(HEAPF32[i381 >> 2]);
   f677 = Math_fround(f677 - Math_fround(HEAPF32[i369 >> 2]));
   f678 = Math_fround(HEAPF32[i382 >> 2]);
   f678 = Math_fround(f678 - Math_fround(HEAPF32[i370 >> 2]));
   f679 = Math_fround(HEAPF32[i383 >> 2]);
   f679 = Math_fround(f679 - Math_fround(HEAPF32[i371 >> 2]));
   f680 = Math_fround(HEAPF32[i384 >> 2]);
   f680 = Math_fround(f680 - Math_fround(HEAPF32[i372 >> 2]));
   f687 = Math_fround(HEAPF32[i385 >> 2]);
   f687 = Math_fround(f687 - Math_fround(HEAPF32[i373 >> 2]));
   f686 = Math_fround(HEAPF32[i386 >> 2]);
   f686 = Math_fround(f686 - Math_fround(HEAPF32[i374 >> 2]));
   f685 = Math_fround(HEAPF32[i387 >> 2]);
   f685 = Math_fround(f685 - Math_fround(HEAPF32[i375 >> 2]));
   f684 = Math_fround(HEAPF32[i388 >> 2]);
   f684 = Math_fround(f684 - Math_fround(HEAPF32[i376 >> 2]));
   f672 = Math_fround(HEAPF32[i389 >> 2]);
   f672 = Math_fround(f672 - Math_fround(HEAPF32[i377 >> 2]));
   f673 = Math_fround(HEAPF32[i390 >> 2]);
   f673 = Math_fround(f673 - Math_fround(HEAPF32[i378 >> 2]));
   f674 = Math_fround(HEAPF32[i391 >> 2]);
   f674 = Math_fround(f674 - Math_fround(HEAPF32[i379 >> 2]));
   f676 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f675 * f675) + Math_fround(f680 * f680)) + Math_fround(f684 * f684)))));
   f683 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f677 * f677) + Math_fround(f687 * f687)) + Math_fround(f672 * f672)))));
   f682 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f678 * f678) + Math_fround(f686 * f686)) + Math_fround(f673 * f673)))));
   f681 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f679 * f679) + Math_fround(f685 * f685)) + Math_fround(f674 * f674)))));
   f677 = Math_fround(f677 * f683);
   f678 = Math_fround(f678 * f682);
   f679 = Math_fround(f679 * f681);
   f680 = Math_fround(f680 * f676);
   f687 = Math_fround(f687 * f683);
   f686 = Math_fround(f686 * f682);
   f685 = Math_fround(f685 * f681);
   f684 = Math_fround(f684 * f676);
   f683 = Math_fround(f672 * f683);
   f682 = Math_fround(f673 * f682);
   f681 = Math_fround(f674 * f681);
   HEAPF32[i622 >> 2] = Math_fround(f675 * f676);
   HEAPF32[i148 >> 2] = f677;
   HEAPF32[i165 >> 2] = f678;
   HEAPF32[i182 >> 2] = f679;
   HEAPF32[i428 >> 2] = f680;
   HEAPF32[i143 >> 2] = f687;
   HEAPF32[i160 >> 2] = f686;
   HEAPF32[i177 >> 2] = f685;
   HEAPF32[i429 >> 2] = f684;
   HEAPF32[i138 >> 2] = f683;
   HEAPF32[i155 >> 2] = f682;
   HEAPF32[i172 >> 2] = f681;
   f681 = Math_fround(f73 * Math_fround(2.0));
   f682 = Math_fround(f72 * Math_fround(2.0));
   f683 = Math_fround(f71 * Math_fround(2.0));
   f684 = Math_fround(f70 * Math_fround(2.0));
   f685 = Math_fround(f69 * Math_fround(2.0));
   f686 = Math_fround(f68 * Math_fround(2.0));
   f687 = Math_fround(f59 * Math_fround(2.0));
   HEAPF32[i623 >> 2] = Math_fround(f74 * Math_fround(2.0));
   HEAPF32[i150 >> 2] = f681;
   HEAPF32[i167 >> 2] = f682;
   HEAPF32[i184 >> 2] = f683;
   HEAPF32[i430 >> 2] = f684;
   HEAPF32[i149 >> 2] = f685;
   HEAPF32[i166 >> 2] = f686;
   HEAPF32[i183 >> 2] = f687;
   HEAP32[i133 >> 2] = 0;
   HEAP32[i133 + 4 >> 2] = 0;
   HEAP32[i133 + 8 >> 2] = 0;
   HEAP32[i133 + 12 >> 2] = 0;
   if (i431) {
    f667 = Math_fround(HEAPF32[i613 >> 2]);
    f685 = Math_fround(f576 * f667);
    f669 = Math_fround(HEAPF32[i204 >> 2]);
    f676 = Math_fround(f576 * f669);
    f671 = Math_fround(HEAPF32[i203 >> 2]);
    f684 = Math_fround(f576 * f671);
    f673 = Math_fround(HEAPF32[i202 >> 2]);
    f679 = Math_fround(f576 * f673);
    f668 = Math_fround(HEAPF32[i432 >> 2]);
    f675 = Math_fround(f579 * f668);
    f670 = Math_fround(HEAPF32[i207 >> 2]);
    f681 = Math_fround(f579 * f670);
    f672 = Math_fround(HEAPF32[i206 >> 2]);
    f680 = Math_fround(f579 * f672);
    f674 = Math_fround(HEAPF32[i205 >> 2]);
    f675 = Math_fround(f685 + f675);
    f681 = Math_fround(f676 + f681);
    f680 = Math_fround(f684 + f680);
    f679 = Math_fround(f679 + Math_fround(f579 * f674));
    f684 = Math_fround(HEAPF32[i433 >> 2]);
    f676 = Math_fround(f582 * f684);
    f685 = Math_fround(HEAPF32[i210 >> 2]);
    f677 = Math_fround(f582 * f685);
    f686 = Math_fround(HEAPF32[i209 >> 2]);
    f678 = Math_fround(f582 * f686);
    f687 = Math_fround(HEAPF32[i208 >> 2]);
    f677 = Math_fround(f681 + f677);
    f678 = Math_fround(f680 + f678);
    f679 = Math_fround(f679 + Math_fround(f582 * f687));
    f680 = Math_fround(Math_fround(Math_fround(f577 * f667) + Math_fround(f580 * f668)) + Math_fround(f583 * f684));
    f681 = Math_fround(Math_fround(Math_fround(f577 * f669) + Math_fround(f580 * f670)) + Math_fround(f583 * f685));
    f682 = Math_fround(Math_fround(Math_fround(f577 * f671) + Math_fround(f580 * f672)) + Math_fround(f583 * f686));
    f683 = Math_fround(Math_fround(Math_fround(f577 * f673) + Math_fround(f580 * f674)) + Math_fround(f583 * f687));
    f684 = Math_fround(Math_fround(Math_fround(f578 * f667) + Math_fround(f581 * f668)) + Math_fround(f584 * f684));
    f685 = Math_fround(Math_fround(Math_fround(f578 * f669) + Math_fround(f581 * f670)) + Math_fround(f584 * f685));
    f686 = Math_fround(Math_fround(Math_fround(f578 * f671) + Math_fround(f581 * f672)) + Math_fround(f584 * f686));
    f687 = Math_fround(Math_fround(Math_fround(f578 * f673) + Math_fround(f581 * f674)) + Math_fround(f584 * f687));
    HEAPF32[i624 >> 2] = Math_fround(f675 + f676);
    HEAPF32[i434 >> 2] = f677;
    HEAPF32[i435 >> 2] = f678;
    HEAPF32[i436 >> 2] = f679;
    HEAPF32[i437 >> 2] = f680;
    HEAPF32[i438 >> 2] = f681;
    HEAPF32[i439 >> 2] = f682;
    HEAPF32[i440 >> 2] = f683;
    HEAPF32[i441 >> 2] = f684;
    HEAPF32[i442 >> 2] = f685;
    HEAPF32[i443 >> 2] = f686;
    HEAPF32[i444 >> 2] = f687;
   }
   if (i445) {
    i52 = HEAP32[i617 >> 2] | 0;
    i55 = i52 + 1068538453 | 0;
    i56 = HEAP32[i236 >> 2] | 0;
    i54 = i56 + 1068538453 | 0;
    i45 = HEAP32[i237 >> 2] | 0;
    i44 = i45 + 1068538453 | 0;
    i43 = HEAP32[i238 >> 2] | 0;
    i51 = i43 + 1068538453 | 0;
    i57 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i58 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i55 = i55 << 11 ^ i55;
    i54 = i54 << 11 ^ i54;
    i44 = i44 << 11 ^ i44;
    i51 = i51 << 11 ^ i51;
    f685 = Math_fround(Math_fround((i46 ^ i54 ^ i54 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i58 ^ i44 ^ i44 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i53 ^ i51 ^ i51 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i625 >> 2] = Math_fround(Math_fround((i57 ^ i55 ^ i55 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i446 >> 2] = f685;
    HEAPF32[i447 >> 2] = f686;
    HEAPF32[i448 >> 2] = f687;
    i52 = i52 + 1068538454 | 0;
    i56 = i56 + 1068538454 | 0;
    i45 = i45 + 1068538454 | 0;
    i43 = i43 + 1068538454 | 0;
    i57 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i55 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
    i52 = i52 << 11 ^ i52;
    i56 = i56 << 11 ^ i56;
    i45 = i45 << 11 ^ i45;
    i43 = i43 << 11 ^ i43;
    f687 = Math_fround(Math_fround((i55 ^ i56 ^ i56 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i53 ^ i45 ^ i45 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f685 = Math_fround(Math_fround((i51 ^ i43 ^ i43 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i449 >> 2] = Math_fround(Math_fround((i57 ^ i52 ^ i52 >>> 8) & 8388607 ^ i57 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i450 >> 2] = f687;
    HEAPF32[i451 >> 2] = f686;
    HEAPF32[i452 >> 2] = f685;
    i57 = HEAP32[i617 >> 2] | 0;
    i52 = i57 + 1068538455 | 0;
    i51 = HEAP32[i236 >> 2] | 0;
    i43 = i51 + 1068538455 | 0;
    i53 = HEAP32[i237 >> 2] | 0;
    i45 = i53 + 1068538455 | 0;
    i55 = HEAP32[i238 >> 2] | 0;
    i56 = i55 + 1068538455 | 0;
    i58 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i52 = i52 << 11 ^ i52;
    i43 = i43 << 11 ^ i43;
    i45 = i45 << 11 ^ i45;
    i56 = i56 << 11 ^ i56;
    f685 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i54 ^ i56 ^ i56 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i453 >> 2] = Math_fround(Math_fround((i58 ^ i52 ^ i52 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = f685;
    HEAPF32[i455 >> 2] = f686;
    HEAPF32[i456 >> 2] = f687;
    f687 = Math_fround(Math_fround(HEAPF32[i616 >> 2]) * Math_fround(1.0e5));
    f686 = Math_fround(Math_fround(HEAPF32[i232 >> 2]) * Math_fround(1.0e5));
    f685 = Math_fround(Math_fround(HEAPF32[i233 >> 2]) * Math_fround(1.0e5));
    i57 = i57 + 1068538453 + ~~f687 | 0;
    i51 = i51 + 1068538453 + ~~f686 | 0;
    i53 = i53 + 1068538453 + ~~f685 | 0;
    i55 = i55 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i234 >> 2]) * Math_fround(1.0e5)) | 0;
    i58 = (Math_imul(i57, 1790253981) | 0) + 1900727103 | 0;
    i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
    i56 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
    i57 = i57 << 11 ^ i57;
    i51 = i51 << 11 ^ i51;
    i53 = i53 << 11 ^ i53;
    i55 = i55 << 11 ^ i55;
    f685 = Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f686 = Math_fround(Math_fround((i54 ^ i53 ^ i53 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f687 = Math_fround(Math_fround((i56 ^ i55 ^ i55 >>> 8) & 8388607 ^ i56 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i457 >> 2] = Math_fround(Math_fround((i58 ^ i57 ^ i57 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i458 >> 2] = f685;
    HEAPF32[i459 >> 2] = f686;
    HEAPF32[i460 >> 2] = f687;
   }
   i51 = HEAP32[i211 >> 2] | 0;
   i52 = (i51 | 0) == 0;
   i53 = HEAP32[i125 >> 2] | 0;
   i54 = HEAP32[i127 >> 2] | 0;
   i55 = HEAP32[i231 >> 2] | 0;
   i56 = HEAP32[i128 >> 2] | 0;
   i57 = HEAP32[i214 >> 2] | 0;
   i58 = HEAP32[i638 >> 2] | 0;
   i46 = 0;
   do {
    i2 = i46 + i85 | 0;
    if (!i52) i2 = HEAP32[i51 + (i2 << 3) >> 2] | 0;
    i5 = i624 + (i46 << 2) | 0;
    i6 = i468 + (i46 << 2) | 0;
    i7 = i469 + (i46 << 2) | 0;
    i8 = i625 + (i46 << 2) | 0;
    i9 = i449 + (i46 << 2) | 0;
    i10 = i453 + (i46 << 2) | 0;
    i11 = i457 + (i46 << 2) | 0;
    i12 = i622 + (i46 << 2) | 0;
    i13 = i122 + (i46 << 2) | 0;
    i14 = i123 + (i46 << 2) | 0;
    i15 = i53 + (i2 << 4) | 0;
    i16 = i54 + (i2 << 4) | 0;
    i17 = i55 + (i2 << 2) | 0;
    i18 = i56 + (i2 << 2) | 0;
    i19 = i57 + (i2 << 2) | 0;
    i20 = i623 + (i46 << 2) | 0;
    i21 = i129 + (i46 << 2) | 0;
    i42 = i130 + (i46 << 2) | 0;
    i43 = i620 + (i46 << 2) | 0;
    i44 = i131 + (i46 << 2) | 0;
    i45 = i132 + (i46 << 2) | 0;
    i4 = i58 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i619 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i46 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i46 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i46 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i461) {
      i688 = i621 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i688 + 32 + (i46 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i462) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i463) {
      i688 = i641 + (HEAP32[i640 + ((i3 << 2) + i46 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i464) {
      i688 = i642 + (HEAP32[i640 + ((i3 << 2) + i46 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i688 + (i46 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 16 + (i46 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 32 + (i46 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 48 + (i46 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i465) {
      f687 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i44 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i45 >> 2];
      HEAPF32[i1 + 12 >> 2] = f687;
      i1 = i1 + 16 | 0;
     }
     if (!i466) {
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i42 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i467) {
      i688 = HEAP32[i19 >> 2] | 0;
      HEAP32[i1 >> 2] = i688;
      HEAP32[i1 + 4 >> 2] = i688;
      HEAP32[i1 + 8 >> 2] = i688;
      i1 = i1 + 12 | 0;
     }
     if (i431) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i470) {
      f687 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(.00999999977));
      i688 = HEAP32[i18 >> 2] | 0;
      HEAPF32[i1 >> 2] = f687;
      HEAP32[i1 + 4 >> 2] = i688;
      i1 = i1 + 8 | 0;
     }
     if (!i471) {
      i688 = (HEAP32[i126 >> 2] & 2147483647 | 0) == 0 ? i610 : i16;
      HEAP32[i1 >> 2] = HEAP32[i688 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i472) {
      i688 = (HEAP32[i124 >> 2] & 2147483647 | 0) == 0 ? i610 : i15;
      HEAP32[i1 >> 2] = HEAP32[i688 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i688 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i688 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i688 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i445) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i121) {
      HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i14 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i46 = i46 + 1 | 0;
   } while ((i46 | 0) != 4);
  } while (0);
  i85 = i85 + 4 | 0;
 } while (i85 >>> 0 < i186 >>> 0);
 STACKTOP = i643;
 return;
}

function __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i9, i3, i1, i8, i622, i627) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i622 = i622 | 0;
 i627 = i627 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, i456 = 0, i457 = 0, i458 = 0, i459 = 0, i460 = 0, i461 = 0, i462 = 0, i463 = 0, i464 = 0, i465 = 0, i466 = 0, i467 = 0, i468 = 0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, i478 = 0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i517 = 0, i518 = 0, i519 = 0, i520 = 0, i521 = 0, i522 = 0, i523 = 0, i524 = 0, i525 = 0, i526 = 0, i527 = 0, i528 = 0, i529 = 0, i530 = 0, i531 = 0, i532 = 0, i533 = 0, i534 = 0, i535 = 0, i536 = 0, i537 = 0, i538 = 0, i539 = 0, i540 = 0, i541 = 0, i542 = 0, i543 = 0, i544 = 0, i545 = 0, i546 = 0, i547 = 0, i548 = 0, i549 = 0, i550 = 0, i551 = 0, i552 = 0, i553 = 0, i554 = 0, i555 = 0, i556 = 0, i557 = 0, i558 = 0, i559 = 0, i560 = 0, i561 = 0, i562 = 0, i563 = 0, f564 = f0, f565 = f0, f566 = f0, f567 = f0, f568 = f0, f569 = f0, f570 = f0, f571 = f0, f572 = f0, f573 = f0, f574 = f0, f575 = f0, i576 = 0, i577 = 0, i578 = 0, i579 = 0, i580 = 0, i581 = 0, i582 = 0, i583 = 0, i584 = 0, i585 = 0, i586 = 0, i587 = 0, i588 = 0, i589 = 0, i590 = 0, f591 = f0, f592 = f0, f593 = f0, f594 = f0, f595 = f0, f596 = f0, f597 = f0, i598 = 0, i599 = 0, i600 = 0, i601 = 0, i602 = 0, i603 = 0, i604 = 0, i605 = 0, i606 = 0, i607 = 0, i608 = 0, i609 = 0, i610 = 0, i611 = 0, i612 = 0, i613 = 0, i614 = 0, i615 = 0, f616 = f0, f617 = f0, f618 = f0, f619 = f0, f620 = f0, f621 = f0, f623 = f0, f624 = f0, f625 = f0, f626 = f0, f628 = f0, i629 = 0, i630 = 0, i631 = 0, i632 = 0, f633 = f0, f634 = f0, f635 = f0, f636 = f0, f637 = f0, f638 = f0, f639 = f0, f640 = f0, f641 = f0, f642 = f0, f643 = f0, f644 = f0, f645 = f0, f646 = f0, f647 = f0, f648 = f0, i649 = 0;
 i632 = STACKTOP;
 STACKTOP = STACKTOP + 1680 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i629 = i632 + 1608 | 0;
 i630 = i632 + 1480 | 0;
 i631 = i632 + 1224 | 0;
 i6 = i632 + 1160 | 0;
 i4 = i632 + 1120 | 0;
 i598 = i632 + 976 | 0;
 i599 = i632 + 960 | 0;
 i600 = i632 + 912 | 0;
 i601 = i632 + 864 | 0;
 i602 = i632 + 816 | 0;
 i603 = i632 + 800 | 0;
 i604 = i632 + 784 | 0;
 i605 = i632 + 768 | 0;
 i606 = i632 + 752 | 0;
 i607 = i632 + 736 | 0;
 i608 = i632 + 544 | 0;
 i609 = i632 + 496 | 0;
 i610 = i632 + 304 | 0;
 i611 = i632 + 160 | 0;
 i612 = i632 + 112 | 0;
 i613 = i632 + 64 | 0;
 i614 = i632;
 i615 = i3 + 332 | 0;
 f616 = Math_fround((HEAP32[i615 >> 2] & 4095) >>> 0);
 f617 = Math_fround(Math_fround(1.0) / f616);
 f618 = Math_fround(HEAPF32[i3 + 368 >> 2]);
 f619 = Math_fround(HEAPF32[i3 + 372 >> 2]);
 f620 = Math_fround(HEAPF32[i3 + 376 >> 2]);
 f621 = Math_fround(Math_fround(1.0) - f620);
 i5 = i3 + 420 | 0;
 f623 = Math_fround(HEAPF32[i3 + 404 >> 2]);
 i2 = i3 + 408 | 0;
 f597 = Math_fround(HEAPF32[i2 >> 2]);
 f593 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f594 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i3 + 336 | 0;
 f624 = Math_fround(HEAPF32[i2 >> 2]);
 f625 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f626 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f628 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i3 + 352 | 0;
 f596 = Math_fround(HEAPF32[i2 >> 2]);
 f592 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 360 | 0;
 f595 = Math_fround(HEAPF32[i2 >> 2]);
 f591 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 f564 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f565 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f566 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f567 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f568 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f569 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f570 = Math_fround(HEAPF32[i3 + 160 >> 2]);
 f571 = Math_fround(HEAPF32[i3 + 164 >> 2]);
 f572 = Math_fround(HEAPF32[i3 + 168 >> 2]);
 f573 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f574 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f575 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 i576 = i629 + 12 | 0;
 i577 = i629 + 8 | 0;
 i578 = i629 + 4 | 0;
 i579 = i629 + 28 | 0;
 HEAP32[i629 >> 2] = 0;
 HEAP32[i629 + 4 >> 2] = 0;
 HEAP32[i629 + 8 >> 2] = 0;
 HEAP32[i629 + 12 >> 2] = 0;
 HEAP32[i579 >> 2] = 1;
 i580 = i629 + 24 | 0;
 HEAP32[i580 >> 2] = 1;
 i581 = i629 + 20 | 0;
 HEAP32[i581 >> 2] = 1;
 i582 = i629 + 16 | 0;
 HEAP32[i582 >> 2] = 1;
 i583 = i629 + 44 | 0;
 HEAP32[i583 >> 2] = 2;
 i584 = i629 + 40 | 0;
 HEAP32[i584 >> 2] = 2;
 i585 = i629 + 36 | 0;
 HEAP32[i585 >> 2] = 2;
 i586 = i629 + 32 | 0;
 HEAP32[i586 >> 2] = 2;
 i587 = i629 + 60 | 0;
 HEAP32[i587 >> 2] = 3;
 i588 = i629 + 56 | 0;
 HEAP32[i588 >> 2] = 3;
 i589 = i629 + 52 | 0;
 HEAP32[i589 >> 2] = 3;
 i590 = i629 + 48 | 0;
 HEAP32[i590 >> 2] = 3;
 i515 = i630 + 4 | 0;
 i539 = i630 + 8 | 0;
 i563 = i630 + 12 | 0;
 i491 = i630 + 16 | 0;
 HEAP32[i630 >> 2] = 0;
 HEAP32[i630 + 4 >> 2] = 0;
 HEAP32[i630 + 8 >> 2] = 0;
 HEAP32[i630 + 12 >> 2] = 0;
 HEAPF32[i491 >> 2] = Math_fround(1.0);
 i514 = i630 + 20 | 0;
 HEAPF32[i514 >> 2] = Math_fround(1.0);
 i538 = i630 + 24 | 0;
 HEAPF32[i538 >> 2] = Math_fround(1.0);
 i562 = i630 + 28 | 0;
 HEAPF32[i562 >> 2] = Math_fround(1.0);
 i490 = i630 + 32 | 0;
 HEAPF32[i490 >> 2] = Math_fround(1.0);
 i513 = i630 + 36 | 0;
 HEAPF32[i513 >> 2] = Math_fround(1.0);
 i537 = i630 + 40 | 0;
 HEAPF32[i537 >> 2] = Math_fround(1.0);
 i561 = i630 + 44 | 0;
 HEAPF32[i561 >> 2] = Math_fround(1.0);
 i489 = i630 + 48 | 0;
 HEAPF32[i489 >> 2] = Math_fround(1.0);
 i512 = i630 + 52 | 0;
 HEAPF32[i512 >> 2] = Math_fround(1.0);
 i536 = i630 + 56 | 0;
 HEAPF32[i536 >> 2] = Math_fround(1.0);
 i560 = i630 + 60 | 0;
 HEAPF32[i560 >> 2] = Math_fround(1.0);
 i488 = i630 + 64 | 0;
 HEAPF32[i488 >> 2] = Math_fround(1.0);
 i511 = i630 + 68 | 0;
 HEAPF32[i511 >> 2] = Math_fround(1.0);
 i535 = i630 + 72 | 0;
 HEAPF32[i535 >> 2] = Math_fround(1.0);
 i559 = i630 + 76 | 0;
 HEAPF32[i559 >> 2] = Math_fround(1.0);
 i487 = i630 + 80 | 0;
 i510 = i630 + 84 | 0;
 i534 = i630 + 88 | 0;
 i558 = i630 + 92 | 0;
 i486 = i630 + 96 | 0;
 i509 = i630 + 100 | 0;
 i533 = i630 + 104 | 0;
 i557 = i630 + 108 | 0;
 i485 = i630 + 112 | 0;
 i508 = i630 + 116 | 0;
 i532 = i630 + 120 | 0;
 i556 = i630 + 124 | 0;
 i10 = i487;
 i11 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i507 = i631 + 4 | 0;
 i531 = i631 + 8 | 0;
 i555 = i631 + 12 | 0;
 i484 = i631 + 16 | 0;
 HEAP32[i631 >> 2] = 0;
 HEAP32[i631 + 4 >> 2] = 0;
 HEAP32[i631 + 8 >> 2] = 0;
 HEAP32[i631 + 12 >> 2] = 0;
 HEAPF32[i484 >> 2] = Math_fround(1.0);
 i506 = i631 + 20 | 0;
 HEAPF32[i506 >> 2] = Math_fround(1.0);
 i530 = i631 + 24 | 0;
 HEAPF32[i530 >> 2] = Math_fround(1.0);
 i554 = i631 + 28 | 0;
 HEAPF32[i554 >> 2] = Math_fround(1.0);
 i483 = i631 + 32 | 0;
 i505 = i631 + 36 | 0;
 i529 = i631 + 40 | 0;
 i553 = i631 + 44 | 0;
 i482 = i631 + 48 | 0;
 i504 = i631 + 52 | 0;
 i528 = i631 + 56 | 0;
 i552 = i631 + 60 | 0;
 i481 = i631 + 64 | 0;
 HEAP32[i483 >> 2] = 0;
 HEAP32[i483 + 4 >> 2] = 0;
 HEAP32[i483 + 8 >> 2] = 0;
 HEAP32[i483 + 12 >> 2] = 0;
 HEAP32[i483 + 16 >> 2] = 0;
 HEAP32[i483 + 20 >> 2] = 0;
 HEAP32[i483 + 24 >> 2] = 0;
 HEAP32[i483 + 28 >> 2] = 0;
 HEAPF32[i481 >> 2] = Math_fround(1.0);
 i503 = i631 + 68 | 0;
 HEAPF32[i503 >> 2] = Math_fround(1.0);
 i527 = i631 + 72 | 0;
 HEAPF32[i527 >> 2] = Math_fround(1.0);
 i551 = i631 + 76 | 0;
 HEAPF32[i551 >> 2] = Math_fround(1.0);
 i480 = i631 + 80 | 0;
 HEAPF32[i480 >> 2] = Math_fround(1.0);
 i502 = i631 + 84 | 0;
 HEAPF32[i502 >> 2] = Math_fround(1.0);
 i526 = i631 + 88 | 0;
 HEAPF32[i526 >> 2] = Math_fround(1.0);
 i550 = i631 + 92 | 0;
 HEAPF32[i550 >> 2] = Math_fround(1.0);
 i479 = i631 + 96 | 0;
 i501 = i631 + 100 | 0;
 i525 = i631 + 104 | 0;
 i549 = i631 + 108 | 0;
 i478 = i631 + 112 | 0;
 i500 = i631 + 116 | 0;
 i524 = i631 + 120 | 0;
 i548 = i631 + 124 | 0;
 i477 = i631 + 128 | 0;
 HEAP32[i479 >> 2] = 0;
 HEAP32[i479 + 4 >> 2] = 0;
 HEAP32[i479 + 8 >> 2] = 0;
 HEAP32[i479 + 12 >> 2] = 0;
 HEAP32[i479 + 16 >> 2] = 0;
 HEAP32[i479 + 20 >> 2] = 0;
 HEAP32[i479 + 24 >> 2] = 0;
 HEAP32[i479 + 28 >> 2] = 0;
 HEAPF32[i477 >> 2] = Math_fround(1.0);
 i499 = i631 + 132 | 0;
 HEAPF32[i499 >> 2] = Math_fround(1.0);
 i523 = i631 + 136 | 0;
 HEAPF32[i523 >> 2] = Math_fround(1.0);
 i547 = i631 + 140 | 0;
 HEAPF32[i547 >> 2] = Math_fround(1.0);
 i476 = i631 + 144 | 0;
 i498 = i631 + 148 | 0;
 i522 = i631 + 152 | 0;
 i546 = i631 + 156 | 0;
 i475 = i631 + 160 | 0;
 i497 = i631 + 164 | 0;
 i521 = i631 + 168 | 0;
 i545 = i631 + 172 | 0;
 i474 = i631 + 176 | 0;
 i496 = i631 + 180 | 0;
 i520 = i631 + 184 | 0;
 i544 = i631 + 188 | 0;
 i473 = i631 + 192 | 0;
 i495 = i631 + 196 | 0;
 i519 = i631 + 200 | 0;
 i543 = i631 + 204 | 0;
 i472 = i631 + 208 | 0;
 i494 = i631 + 212 | 0;
 i518 = i631 + 216 | 0;
 i542 = i631 + 220 | 0;
 i471 = i631 + 224 | 0;
 i493 = i631 + 228 | 0;
 i517 = i631 + 232 | 0;
 i541 = i631 + 236 | 0;
 i470 = i631 + 240 | 0;
 i492 = i631 + 244 | 0;
 i516 = i631 + 248 | 0;
 i540 = i631 + 252 | 0;
 i10 = i476;
 i11 = i10 + 112 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 switch (i2 | 0) {
 case 1:
  {
   i10 = i6;
   i1 = gb + 1162292 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 case 2:
  {
   i10 = i6;
   i1 = i3 + 256 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
   break;
  }
 default:
  {
   i10 = i6;
   i1 = i3 + 64 | 0;
   i11 = i10 + 64 | 0;
   do {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    i10 = i10 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i10 | 0) < (i11 | 0));
  }
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i6);
 f62 = Math_fround(HEAPF32[i5 >> 2]);
 f45 = Math_fround(HEAPF32[i3 + 428 >> 2]);
 f53 = Math_fround(HEAPF32[i3 + 424 >> 2]);
 f47 = Math_fround(HEAPF32[i4 >> 2]);
 i184 = i4 + 4 | 0;
 f43 = Math_fround(HEAPF32[i184 >> 2]);
 i183 = i4 + 8 | 0;
 f58 = Math_fround(HEAPF32[i183 >> 2]);
 i182 = i4 + 12 | 0;
 f49 = Math_fround(HEAPF32[i182 >> 2]);
 i181 = i4 + 16 | 0;
 f44 = Math_fround(HEAPF32[i181 >> 2]);
 i180 = i4 + 20 | 0;
 f61 = Math_fround(HEAPF32[i180 >> 2]);
 i179 = i4 + 24 | 0;
 f51 = Math_fround(HEAPF32[i179 >> 2]);
 i203 = i4 + 28 | 0;
 f46 = Math_fround(HEAPF32[i203 >> 2]);
 i206 = i4 + 32 | 0;
 f55 = Math_fround(HEAPF32[i206 >> 2]);
 f48 = Math_fround(f43 * Math_fround(0.0));
 f57 = Math_fround(f58 * Math_fround(0.0));
 f56 = Math_fround(Math_fround(Math_fround(f62 * f47) + f48) + f57);
 f50 = Math_fround(f44 * Math_fround(0.0));
 f60 = Math_fround(f61 * Math_fround(0.0));
 f59 = Math_fround(Math_fround(Math_fround(f62 * f49) + f50) + f60);
 f52 = Math_fround(f46 * Math_fround(0.0));
 f54 = Math_fround(f55 * Math_fround(0.0));
 f62 = Math_fround(Math_fround(Math_fround(f62 * f51) + f52) + f54);
 f47 = Math_fround(f47 * Math_fround(0.0));
 f57 = Math_fround(Math_fround(f47 + Math_fround(f45 * f43)) + f57);
 f49 = Math_fround(f49 * Math_fround(0.0));
 f60 = Math_fround(Math_fround(f49 + Math_fround(f45 * f44)) + f60);
 f51 = Math_fround(f51 * Math_fround(0.0));
 f54 = Math_fround(Math_fround(f51 + Math_fround(f45 * f46)) + f54);
 f58 = Math_fround(Math_fround(f47 + f48) + Math_fround(f53 * f58));
 f61 = Math_fround(Math_fround(f49 + f50) + Math_fround(f53 * f61));
 f55 = Math_fround(Math_fround(f51 + f52) + Math_fround(f53 * f55));
 HEAPF32[i4 >> 2] = f56;
 HEAPF32[i184 >> 2] = f57;
 HEAPF32[i183 >> 2] = f58;
 HEAPF32[i182 >> 2] = f59;
 HEAPF32[i181 >> 2] = f60;
 HEAPF32[i180 >> 2] = f61;
 HEAPF32[i179 >> 2] = f62;
 HEAPF32[i203 >> 2] = f54;
 HEAPF32[i206 >> 2] = f55;
 HEAPF32[i598 >> 2] = f56;
 i179 = i598 + 4 | 0;
 HEAPF32[i179 >> 2] = f56;
 i180 = i598 + 8 | 0;
 HEAPF32[i180 >> 2] = f56;
 i181 = i598 + 12 | 0;
 HEAPF32[i181 >> 2] = f56;
 HEAPF32[i598 + 16 >> 2] = f57;
 i182 = i598 + 20 | 0;
 HEAPF32[i182 >> 2] = f57;
 i183 = i598 + 24 | 0;
 HEAPF32[i183 >> 2] = f57;
 i184 = i598 + 28 | 0;
 HEAPF32[i184 >> 2] = f57;
 HEAPF32[i598 + 32 >> 2] = f58;
 i185 = i598 + 36 | 0;
 HEAPF32[i185 >> 2] = f58;
 i186 = i598 + 40 | 0;
 HEAPF32[i186 >> 2] = f58;
 i187 = i598 + 44 | 0;
 HEAPF32[i187 >> 2] = f58;
 HEAPF32[i598 + 48 >> 2] = f59;
 i188 = i598 + 52 | 0;
 HEAPF32[i188 >> 2] = f59;
 i189 = i598 + 56 | 0;
 HEAPF32[i189 >> 2] = f59;
 i190 = i598 + 60 | 0;
 HEAPF32[i190 >> 2] = f59;
 HEAPF32[i598 + 64 >> 2] = f60;
 i191 = i598 + 68 | 0;
 HEAPF32[i191 >> 2] = f60;
 i192 = i598 + 72 | 0;
 HEAPF32[i192 >> 2] = f60;
 i193 = i598 + 76 | 0;
 HEAPF32[i193 >> 2] = f60;
 HEAPF32[i598 + 80 >> 2] = f61;
 i194 = i598 + 84 | 0;
 HEAPF32[i194 >> 2] = f61;
 i195 = i598 + 88 | 0;
 HEAPF32[i195 >> 2] = f61;
 i196 = i598 + 92 | 0;
 HEAPF32[i196 >> 2] = f61;
 HEAPF32[i598 + 96 >> 2] = f62;
 i197 = i598 + 100 | 0;
 HEAPF32[i197 >> 2] = f62;
 i198 = i598 + 104 | 0;
 HEAPF32[i198 >> 2] = f62;
 i199 = i598 + 108 | 0;
 HEAPF32[i199 >> 2] = f62;
 i203 = HEAP32[i203 >> 2] | 0;
 HEAP32[i598 + 112 >> 2] = i203;
 i200 = i598 + 116 | 0;
 HEAP32[i200 >> 2] = i203;
 i201 = i598 + 120 | 0;
 HEAP32[i201 >> 2] = i203;
 i202 = i598 + 124 | 0;
 HEAP32[i202 >> 2] = i203;
 i206 = HEAP32[i206 >> 2] | 0;
 HEAP32[i598 + 128 >> 2] = i206;
 i203 = i598 + 132 | 0;
 HEAP32[i203 >> 2] = i206;
 i204 = i598 + 136 | 0;
 HEAP32[i204 >> 2] = i206;
 i205 = i598 + 140 | 0;
 HEAP32[i205 >> 2] = i206;
 i206 = (i7 | 0) == 27;
 HEAP32[i599 >> 2] = 0;
 HEAP32[i599 + 4 >> 2] = 0;
 HEAP32[i599 + 8 >> 2] = 0;
 HEAP32[i599 + 12 >> 2] = 0;
 i207 = HEAP32[i622 + 12 >> 2] | 0;
 if (!i207) {
  STACKTOP = i632;
  return;
 }
 i208 = i600 + 12 | 0;
 i209 = i600 + 8 | 0;
 i210 = i600 + 4 | 0;
 i211 = i600 + 16 | 0;
 i212 = i600 + 28 | 0;
 i213 = i600 + 24 | 0;
 i214 = i600 + 20 | 0;
 i215 = i600 + 32 | 0;
 i216 = i600 + 44 | 0;
 i217 = i600 + 40 | 0;
 i218 = i600 + 36 | 0;
 i219 = i601 + 12 | 0;
 i220 = i601 + 8 | 0;
 i221 = i601 + 4 | 0;
 i222 = i601 + 16 | 0;
 i223 = i601 + 28 | 0;
 i224 = i601 + 24 | 0;
 i225 = i601 + 20 | 0;
 i226 = i601 + 32 | 0;
 i227 = i601 + 44 | 0;
 i228 = i601 + 40 | 0;
 i229 = i601 + 36 | 0;
 i230 = i602 + 12 | 0;
 i231 = i602 + 8 | 0;
 i232 = i602 + 4 | 0;
 i233 = i602 + 28 | 0;
 i234 = i602 + 24 | 0;
 i235 = i602 + 20 | 0;
 i236 = i602 + 44 | 0;
 i237 = i602 + 40 | 0;
 i238 = i602 + 36 | 0;
 i239 = i627 + 20 | 0;
 i240 = i622 + 20 | 0;
 i241 = i622 + 40 | 0;
 i242 = i622 + 300 | 0;
 i243 = i622 + 320 | 0;
 i244 = i622 + 340 | 0;
 i245 = i622 + 60 | 0;
 i246 = i622 + 80 | 0;
 i247 = i622 + 100 | 0;
 i248 = i622 + 120 | 0;
 i249 = i622 + 140 | 0;
 i250 = i622 + 160 | 0;
 i251 = i602 + 16 | 0;
 i252 = i602 + 32 | 0;
 i253 = i627 + 4 | 0;
 i254 = i603 + 4 | 0;
 i255 = i603 + 8 | 0;
 i256 = i603 + 12 | 0;
 i257 = i627 + 8 | 0;
 i258 = i604 + 4 | 0;
 i259 = i604 + 8 | 0;
 i260 = i604 + 12 | 0;
 i261 = i622 + 520 | 0;
 i262 = i605 + 4 | 0;
 i263 = i605 + 8 | 0;
 i264 = i605 + 12 | 0;
 i265 = i622 + 500 | 0;
 i266 = i606 + 4 | 0;
 i267 = i606 + 8 | 0;
 i268 = i606 + 12 | 0;
 i269 = i627 + 16 | 0;
 i270 = i607 + 4 | 0;
 i271 = i607 + 8 | 0;
 i272 = i607 + 12 | 0;
 i273 = i600 + 16 | 0;
 i274 = i600 + 32 | 0;
 i275 = i609 + 4 | 0;
 i276 = i609 + 8 | 0;
 i277 = i609 + 12 | 0;
 i278 = i609 + 16 | 0;
 i279 = i609 + 20 | 0;
 i280 = i609 + 24 | 0;
 i281 = i609 + 28 | 0;
 i282 = i609 + 32 | 0;
 i283 = i609 + 36 | 0;
 i284 = i609 + 40 | 0;
 i285 = i609 + 44 | 0;
 i286 = i601 + 16 | 0;
 i287 = i601 + 32 | 0;
 i288 = i611 + 4 | 0;
 i289 = i611 + 8 | 0;
 i290 = i611 + 12 | 0;
 i291 = i611 + 48 | 0;
 i292 = i611 + 52 | 0;
 i293 = i611 + 56 | 0;
 i294 = i611 + 60 | 0;
 i295 = i611 + 96 | 0;
 i296 = i611 + 100 | 0;
 i297 = i611 + 104 | 0;
 i298 = i611 + 108 | 0;
 i299 = i611 + 16 | 0;
 i300 = i611 + 20 | 0;
 i301 = i611 + 24 | 0;
 i302 = i611 + 28 | 0;
 i303 = i611 + 64 | 0;
 i304 = i611 + 68 | 0;
 i305 = i611 + 72 | 0;
 i306 = i611 + 76 | 0;
 i307 = i611 + 112 | 0;
 i308 = i611 + 116 | 0;
 i309 = i611 + 120 | 0;
 i310 = i611 + 124 | 0;
 i311 = i611 + 32 | 0;
 i312 = i611 + 36 | 0;
 i313 = i611 + 40 | 0;
 i314 = i611 + 44 | 0;
 i315 = i611 + 80 | 0;
 i316 = i611 + 84 | 0;
 i317 = i611 + 88 | 0;
 i318 = i611 + 92 | 0;
 i319 = i611 + 128 | 0;
 i320 = i611 + 132 | 0;
 i321 = i611 + 136 | 0;
 i322 = i611 + 140 | 0;
 i323 = i598 + 48 | 0;
 i324 = i598 + 96 | 0;
 i325 = i610 + 4 | 0;
 i326 = i610 + 8 | 0;
 i327 = i610 + 12 | 0;
 i328 = i610 + 48 | 0;
 i329 = i610 + 52 | 0;
 i330 = i610 + 56 | 0;
 i331 = i610 + 60 | 0;
 i332 = i610 + 96 | 0;
 i333 = i610 + 100 | 0;
 i334 = i610 + 104 | 0;
 i335 = i610 + 108 | 0;
 i336 = i598 + 16 | 0;
 i337 = i598 + 64 | 0;
 i338 = i598 + 112 | 0;
 i339 = i610 + 16 | 0;
 i340 = i610 + 20 | 0;
 i341 = i610 + 24 | 0;
 i342 = i610 + 28 | 0;
 i343 = i610 + 64 | 0;
 i344 = i610 + 68 | 0;
 i345 = i610 + 72 | 0;
 i346 = i610 + 76 | 0;
 i347 = i610 + 112 | 0;
 i348 = i610 + 116 | 0;
 i349 = i610 + 120 | 0;
 i350 = i610 + 124 | 0;
 i351 = i598 + 32 | 0;
 i352 = i598 + 80 | 0;
 i353 = i598 + 128 | 0;
 i354 = i610 + 32 | 0;
 i355 = i610 + 36 | 0;
 i356 = i610 + 40 | 0;
 i357 = i610 + 44 | 0;
 i358 = i610 + 80 | 0;
 i359 = i610 + 84 | 0;
 i360 = i610 + 88 | 0;
 i361 = i610 + 92 | 0;
 i362 = i610 + 128 | 0;
 i363 = i610 + 132 | 0;
 i364 = i610 + 136 | 0;
 i365 = i610 + 140 | 0;
 i366 = i608 + 4 | 0;
 i367 = i608 + 8 | 0;
 i368 = i608 + 12 | 0;
 i369 = i608 + 16 | 0;
 i370 = i608 + 20 | 0;
 i371 = i608 + 24 | 0;
 i372 = i608 + 28 | 0;
 i373 = i608 + 32 | 0;
 i374 = i608 + 36 | 0;
 i375 = i608 + 40 | 0;
 i376 = i608 + 44 | 0;
 i377 = i608 + 48 | 0;
 i378 = i608 + 52 | 0;
 i379 = i608 + 56 | 0;
 i380 = i608 + 60 | 0;
 i381 = i608 + 64 | 0;
 i382 = i608 + 68 | 0;
 i383 = i608 + 72 | 0;
 i384 = i608 + 76 | 0;
 i385 = i608 + 80 | 0;
 i386 = i608 + 84 | 0;
 i387 = i608 + 88 | 0;
 i388 = i608 + 92 | 0;
 i389 = i608 + 96 | 0;
 i390 = i608 + 100 | 0;
 i391 = i608 + 104 | 0;
 i392 = i608 + 108 | 0;
 i393 = i608 + 112 | 0;
 i394 = i608 + 116 | 0;
 i395 = i608 + 120 | 0;
 i396 = i608 + 124 | 0;
 i397 = i608 + 128 | 0;
 i398 = i608 + 132 | 0;
 i399 = i608 + 136 | 0;
 i400 = i608 + 140 | 0;
 i401 = i608 + 144 | 0;
 i402 = i608 + 148 | 0;
 i403 = i608 + 152 | 0;
 i404 = i608 + 156 | 0;
 i405 = i608 + 160 | 0;
 i406 = i608 + 164 | 0;
 i407 = i608 + 168 | 0;
 i408 = i608 + 172 | 0;
 i409 = i608 + 176 | 0;
 i410 = i608 + 180 | 0;
 i411 = i608 + 184 | 0;
 i412 = i608 + 188 | 0;
 i413 = (i7 & 48 | 0) == 0;
 i141 = i610 + 4 | 0;
 i158 = i610 + 8 | 0;
 i175 = i610 + 12 | 0;
 i414 = i610 + 16 | 0;
 i136 = i610 + 20 | 0;
 i153 = i610 + 24 | 0;
 i170 = i610 + 28 | 0;
 i415 = i610 + 32 | 0;
 i131 = i610 + 36 | 0;
 i148 = i610 + 40 | 0;
 i165 = i610 + 44 | 0;
 i416 = i610 + 48 | 0;
 i140 = i610 + 52 | 0;
 i157 = i610 + 56 | 0;
 i174 = i610 + 60 | 0;
 i417 = i610 + 64 | 0;
 i135 = i610 + 68 | 0;
 i152 = i610 + 72 | 0;
 i169 = i610 + 76 | 0;
 i418 = i610 + 80 | 0;
 i130 = i610 + 84 | 0;
 i147 = i610 + 88 | 0;
 i164 = i610 + 92 | 0;
 i419 = i610 + 96 | 0;
 i139 = i610 + 100 | 0;
 i156 = i610 + 104 | 0;
 i173 = i610 + 108 | 0;
 i420 = i610 + 112 | 0;
 i134 = i610 + 116 | 0;
 i151 = i610 + 120 | 0;
 i168 = i610 + 124 | 0;
 i421 = i610 + 128 | 0;
 i129 = i610 + 132 | 0;
 i146 = i610 + 136 | 0;
 i163 = i610 + 140 | 0;
 i422 = i610 + 144 | 0;
 i138 = i610 + 148 | 0;
 i155 = i610 + 152 | 0;
 i172 = i610 + 156 | 0;
 i423 = i610 + 160 | 0;
 i133 = i610 + 164 | 0;
 i150 = i610 + 168 | 0;
 i167 = i610 + 172 | 0;
 i424 = i610 + 176 | 0;
 i128 = i610 + 180 | 0;
 i145 = i610 + 184 | 0;
 i162 = i610 + 188 | 0;
 i142 = i611 + 4 | 0;
 i159 = i611 + 8 | 0;
 i176 = i611 + 12 | 0;
 i425 = i611 + 16 | 0;
 i137 = i611 + 20 | 0;
 i154 = i611 + 24 | 0;
 i171 = i611 + 28 | 0;
 i426 = i611 + 32 | 0;
 i132 = i611 + 36 | 0;
 i149 = i611 + 40 | 0;
 i166 = i611 + 44 | 0;
 i144 = i612 + 4 | 0;
 i161 = i612 + 8 | 0;
 i178 = i612 + 12 | 0;
 i427 = i612 + 16 | 0;
 i143 = i612 + 20 | 0;
 i160 = i612 + 24 | 0;
 i177 = i612 + 28 | 0;
 i127 = i612 + 32 | 0;
 i428 = (i7 & 512 | 0) != 0;
 i429 = i602 + 16 | 0;
 i430 = i602 + 32 | 0;
 i431 = i613 + 4 | 0;
 i432 = i613 + 8 | 0;
 i433 = i613 + 12 | 0;
 i434 = i613 + 16 | 0;
 i435 = i613 + 20 | 0;
 i436 = i613 + 24 | 0;
 i437 = i613 + 28 | 0;
 i438 = i613 + 32 | 0;
 i439 = i613 + 36 | 0;
 i440 = i613 + 40 | 0;
 i441 = i613 + 44 | 0;
 i442 = (i7 & 8192 | 0) != 0;
 i443 = i614 + 4 | 0;
 i444 = i614 + 8 | 0;
 i445 = i614 + 12 | 0;
 i446 = i614 + 16 | 0;
 i447 = i614 + 20 | 0;
 i448 = i614 + 24 | 0;
 i449 = i614 + 28 | 0;
 i450 = i614 + 32 | 0;
 i451 = i614 + 36 | 0;
 i452 = i614 + 40 | 0;
 i453 = i614 + 44 | 0;
 i454 = i614 + 48 | 0;
 i455 = i614 + 52 | 0;
 i456 = i614 + 56 | 0;
 i457 = i614 + 60 | 0;
 i458 = (i7 & 2 | 0) == 0;
 i459 = (i7 & 8 | 0) == 0;
 i460 = (i7 & 16 | 0) == 0;
 i461 = (i7 & 32 | 0) == 0;
 i462 = (i7 & 64 | 0) == 0;
 i463 = (i7 & 128 | 0) == 0;
 i464 = (i7 & 256 | 0) == 0;
 i465 = i613 + 16 | 0;
 i466 = i613 + 32 | 0;
 i467 = (i7 & 1024 | 0) == 0;
 i468 = (i7 & 2048 | 0) == 0;
 i469 = (i7 & 4096 | 0) == 0;
 i115 = (i7 & 4 | 0) == 0;
 i116 = i611 + 16 | 0;
 i117 = i611 + 32 | 0;
 i118 = i622 + 864 | 0;
 i119 = i622 + 848 | 0;
 i120 = i622 + 844 | 0;
 i121 = i622 + 828 | 0;
 i122 = i622 + 540 | 0;
 i123 = i612 + 16 | 0;
 i124 = i612 + 32 | 0;
 i125 = i609 + 16 | 0;
 i126 = i609 + 32 | 0;
 i80 = i8 + 32 | 0;
 i81 = i608 + 16 | 0;
 i82 = i608 + 32 | 0;
 i83 = i610 + 16 | 0;
 i84 = i610 + 32 | 0;
 i85 = i608 + 48 | 0;
 i86 = i85 + 16 | 0;
 i87 = i85 + 32 | 0;
 i88 = i416 + 16 | 0;
 i89 = i416 + 32 | 0;
 i90 = i389 + 16 | 0;
 i91 = i389 + 32 | 0;
 i92 = i419 + 16 | 0;
 i93 = i419 + 32 | 0;
 i94 = i401 + 16 | 0;
 i95 = i401 + 32 | 0;
 i96 = i422 + 16 | 0;
 i97 = i422 + 32 | 0;
 i98 = i608 + 16 | 0;
 i99 = i608 + 32 | 0;
 i100 = i610 + 16 | 0;
 i101 = i610 + 32 | 0;
 i102 = i608 + 48 | 0;
 i103 = i102 + 16 | 0;
 i104 = i102 + 32 | 0;
 i105 = i416 + 16 | 0;
 i106 = i416 + 32 | 0;
 i107 = i389 + 16 | 0;
 i108 = i389 + 32 | 0;
 i109 = i419 + 16 | 0;
 i110 = i419 + 32 | 0;
 i111 = i401 + 16 | 0;
 i112 = i401 + 32 | 0;
 i113 = i422 + 16 | 0;
 i114 = i422 + 32 | 0;
 i79 = 0;
 i1 = i9;
 do {
  i10 = i600;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i601;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  i10 = i602;
  i11 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i10 = i10 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i603 >> 2] = 0;
  HEAP32[i603 + 4 >> 2] = 0;
  HEAP32[i603 + 8 >> 2] = 0;
  HEAP32[i603 + 12 >> 2] = 0;
  HEAP32[i604 >> 2] = 0;
  HEAP32[i604 + 4 >> 2] = 0;
  HEAP32[i604 + 8 >> 2] = 0;
  HEAP32[i604 + 12 >> 2] = 0;
  HEAP32[i605 >> 2] = 0;
  HEAP32[i605 + 4 >> 2] = 0;
  HEAP32[i605 + 8 >> 2] = 0;
  HEAP32[i605 + 12 >> 2] = 0;
  HEAP32[i606 >> 2] = 0;
  HEAP32[i606 + 4 >> 2] = 0;
  HEAP32[i606 + 8 >> 2] = 0;
  HEAP32[i606 + 12 >> 2] = 0;
  HEAP32[i607 >> 2] = 0;
  HEAP32[i607 + 4 >> 2] = 0;
  HEAP32[i607 + 8 >> 2] = 0;
  HEAP32[i607 + 12 >> 2] = 0;
  i20 = HEAP32[i239 >> 2] | 0;
  if (!i20) {
   i77 = (HEAP32[i622 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i77 + 4 >> 2] | 0;
   i75 = HEAP32[i77 + 8 >> 2] | 0;
   i78 = HEAP32[i77 + 12 >> 2] | 0;
   i74 = (HEAP32[i240 >> 2] | 0) + (i79 << 2) | 0;
   i73 = HEAP32[i74 >> 2] | 0;
   i72 = HEAP32[i74 + 4 >> 2] | 0;
   i71 = HEAP32[i74 + 8 >> 2] | 0;
   i74 = HEAP32[i74 + 12 >> 2] | 0;
   i67 = (HEAP32[i241 >> 2] | 0) + (i79 << 2) | 0;
   i70 = HEAP32[i67 >> 2] | 0;
   i69 = HEAP32[i67 + 4 >> 2] | 0;
   i68 = HEAP32[i67 + 8 >> 2] | 0;
   i67 = HEAP32[i67 + 12 >> 2] | 0;
   HEAP32[i600 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i210 >> 2] = i76;
   HEAP32[i209 >> 2] = i75;
   HEAP32[i208 >> 2] = i78;
   HEAP32[i211 >> 2] = i73;
   HEAP32[i214 >> 2] = i72;
   HEAP32[i213 >> 2] = i71;
   HEAP32[i212 >> 2] = i74;
   HEAP32[i215 >> 2] = i70;
   HEAP32[i218 >> 2] = i69;
   HEAP32[i217 >> 2] = i68;
   HEAP32[i216 >> 2] = i67;
   i67 = (HEAP32[i242 >> 2] | 0) + (i79 << 2) | 0;
   i68 = HEAP32[i67 + 4 >> 2] | 0;
   i69 = HEAP32[i67 + 8 >> 2] | 0;
   i70 = HEAP32[i67 + 12 >> 2] | 0;
   i74 = (HEAP32[i243 >> 2] | 0) + (i79 << 2) | 0;
   i71 = HEAP32[i74 >> 2] | 0;
   i72 = HEAP32[i74 + 4 >> 2] | 0;
   i73 = HEAP32[i74 + 8 >> 2] | 0;
   i74 = HEAP32[i74 + 12 >> 2] | 0;
   i78 = (HEAP32[i244 >> 2] | 0) + (i79 << 2) | 0;
   i75 = HEAP32[i78 >> 2] | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = HEAP32[i78 + 8 >> 2] | 0;
   i78 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i601 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i221 >> 2] = i68;
   HEAP32[i220 >> 2] = i69;
   HEAP32[i219 >> 2] = i70;
   HEAP32[i222 >> 2] = i71;
   HEAP32[i225 >> 2] = i72;
   HEAP32[i224 >> 2] = i73;
   HEAP32[i223 >> 2] = i74;
   HEAP32[i226 >> 2] = i75;
   HEAP32[i229 >> 2] = i76;
   HEAP32[i228 >> 2] = i77;
   HEAP32[i227 >> 2] = i78;
   i78 = (HEAP32[i245 >> 2] | 0) + (i79 << 2) | 0;
   f50 = Math_fround(HEAPF32[i78 >> 2]);
   f40 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f41 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f42 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i246 >> 2] | 0) + (i79 << 2) | 0;
   f43 = Math_fround(HEAPF32[i78 >> 2]);
   f44 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f45 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f46 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i247 >> 2] | 0) + (i79 << 2) | 0;
   f47 = Math_fround(HEAPF32[i78 >> 2]);
   f48 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f49 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i248 >> 2] | 0) + (i79 << 2) | 0;
   f51 = Math_fround(HEAPF32[i78 >> 2]);
   f52 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f54 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i249 >> 2] | 0) + (i79 << 2) | 0;
   f55 = Math_fround(HEAPF32[i78 >> 2]);
   f56 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f58 = Math_fround(HEAPF32[i78 + 12 >> 2]);
   i78 = (HEAP32[i250 >> 2] | 0) + (i79 << 2) | 0;
   f59 = Math_fround(HEAPF32[i78 >> 2]);
   f60 = Math_fround(HEAPF32[i78 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i78 + 8 >> 2]);
   f52 = Math_fround(f40 + f52);
   f53 = Math_fround(f41 + f53);
   f54 = Math_fround(f42 + f54);
   f55 = Math_fround(f43 + f55);
   f56 = Math_fround(f44 + f56);
   f57 = Math_fround(f45 + f57);
   f58 = Math_fround(f46 + f58);
   f59 = Math_fround(f47 + f59);
   f60 = Math_fround(f48 + f60);
   f61 = Math_fround(f49 + f61);
   f62 = Math_fround(f62 + Math_fround(HEAPF32[i78 + 12 >> 2]));
   HEAPF32[i602 >> 2] = Math_fround(f50 + f51);
   HEAPF32[i232 >> 2] = f52;
   HEAPF32[i231 >> 2] = f53;
   HEAPF32[i230 >> 2] = f54;
   HEAPF32[i251 >> 2] = f55;
   HEAPF32[i235 >> 2] = f56;
   HEAPF32[i234 >> 2] = f57;
   HEAPF32[i233 >> 2] = f58;
   HEAPF32[i252 >> 2] = f59;
   HEAPF32[i238 >> 2] = f60;
   HEAPF32[i237 >> 2] = f61;
   HEAPF32[i236 >> 2] = f62;
   i78 = (HEAP32[i253 >> 2] | 0) + (i79 << 2) | 0;
   i77 = HEAP32[i78 + 4 >> 2] | 0;
   i76 = HEAP32[i78 + 8 >> 2] | 0;
   i75 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i603 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i254 >> 2] = i77;
   HEAP32[i255 >> 2] = i76;
   HEAP32[i256 >> 2] = i75;
   i75 = (HEAP32[i257 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i75 + 4 >> 2] | 0;
   i77 = HEAP32[i75 + 8 >> 2] | 0;
   i78 = HEAP32[i75 + 12 >> 2] | 0;
   HEAP32[i604 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i258 >> 2] = i76;
   HEAP32[i259 >> 2] = i77;
   HEAP32[i260 >> 2] = i78;
   i78 = (HEAP32[i261 >> 2] | 0) + (i79 << 2) | 0;
   i77 = HEAP32[i78 + 4 >> 2] | 0;
   i76 = HEAP32[i78 + 8 >> 2] | 0;
   i75 = HEAP32[i78 + 12 >> 2] | 0;
   HEAP32[i605 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i262 >> 2] = i77;
   HEAP32[i263 >> 2] = i76;
   HEAP32[i264 >> 2] = i75;
   i75 = (HEAP32[i265 >> 2] | 0) + (i79 << 2) | 0;
   i76 = HEAP32[i75 + 4 >> 2] | 0;
   i77 = HEAP32[i75 + 8 >> 2] | 0;
   i78 = HEAP32[i75 + 12 >> 2] | 0;
   HEAP32[i606 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i266 >> 2] = i76;
   HEAP32[i267 >> 2] = i77;
   HEAP32[i268 >> 2] = i78;
   if (HEAP32[i615 >> 2] & 268435456 | 0) {
    i75 = (HEAP32[i269 >> 2] | 0) + (i79 << 2) | 0;
    i76 = HEAP32[i75 + 4 >> 2] | 0;
    i77 = HEAP32[i75 + 8 >> 2] | 0;
    i78 = HEAP32[i75 + 12 >> 2] | 0;
    HEAP32[i607 >> 2] = HEAP32[i75 >> 2];
    HEAP32[i270 >> 2] = i76;
    HEAP32[i271 >> 2] = i77;
    HEAP32[i272 >> 2] = i78;
   }
  } else {
   i3 = HEAP32[i245 >> 2] | 0;
   i4 = HEAP32[i248 >> 2] | 0;
   i5 = HEAP32[i240 >> 2] | 0;
   i6 = HEAP32[i243 >> 2] | 0;
   i7 = HEAP32[i246 >> 2] | 0;
   i8 = HEAP32[i249 >> 2] | 0;
   i9 = HEAP32[i241 >> 2] | 0;
   i10 = HEAP32[i244 >> 2] | 0;
   i11 = HEAP32[i247 >> 2] | 0;
   i13 = HEAP32[i250 >> 2] | 0;
   i14 = HEAP32[i253 >> 2] | 0;
   i15 = HEAP32[i257 >> 2] | 0;
   i16 = HEAP32[i261 >> 2] | 0;
   i17 = HEAP32[i265 >> 2] | 0;
   i18 = HEAP32[i622 >> 2] | 0;
   i19 = HEAP32[i242 >> 2] | 0;
   i21 = (HEAP32[i615 >> 2] & 268435456 | 0) == 0;
   i22 = HEAP32[i269 >> 2] | 0;
   i2 = 0;
   do {
    i23 = HEAP32[i20 + (i2 + i79 << 3) >> 2] | 0;
    HEAP32[i600 + (i2 << 2) >> 2] = HEAP32[i18 + (i23 << 2) >> 2];
    HEAP32[i601 + (i2 << 2) >> 2] = HEAP32[i19 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i3 + (i23 << 2) >> 2]);
    HEAPF32[i602 + (i2 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i4 + (i23 << 2) >> 2]));
    i78 = i2 + 4 | 0;
    HEAP32[i600 + (i78 << 2) >> 2] = HEAP32[i5 + (i23 << 2) >> 2];
    HEAP32[i601 + (i78 << 2) >> 2] = HEAP32[i6 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i7 + (i23 << 2) >> 2]);
    HEAPF32[i602 + (i78 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i8 + (i23 << 2) >> 2]));
    i78 = i2 + 8 | 0;
    HEAP32[i600 + (i78 << 2) >> 2] = HEAP32[i9 + (i23 << 2) >> 2];
    HEAP32[i601 + (i78 << 2) >> 2] = HEAP32[i10 + (i23 << 2) >> 2];
    f62 = Math_fround(HEAPF32[i11 + (i23 << 2) >> 2]);
    HEAPF32[i602 + (i78 << 2) >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i13 + (i23 << 2) >> 2]));
    HEAP32[i603 + (i2 << 2) >> 2] = HEAP32[i14 + (i23 << 2) >> 2];
    HEAP32[i604 + (i2 << 2) >> 2] = HEAP32[i15 + (i23 << 2) >> 2];
    HEAP32[i605 + (i2 << 2) >> 2] = HEAP32[i16 + (i23 << 2) >> 2];
    HEAP32[i606 + (i2 << 2) >> 2] = HEAP32[i17 + (i23 << 2) >> 2];
    if (!i21) HEAP32[i607 + (i2 << 2) >> 2] = HEAP32[i22 + (i23 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 4);
  }
  f37 = Math_fround(HEAPF32[i600 >> 2]);
  f25 = Math_fround(f564 * f37);
  f35 = Math_fround(HEAPF32[i210 >> 2]);
  f34 = Math_fround(f564 * f35);
  f62 = Math_fround(HEAPF32[i209 >> 2]);
  f24 = Math_fround(f564 * f62);
  f60 = Math_fround(HEAPF32[i208 >> 2]);
  f31 = Math_fround(f564 * f60);
  f36 = Math_fround(HEAPF32[i273 >> 2]);
  f28 = Math_fround(f567 * f36);
  f30 = Math_fround(HEAPF32[i214 >> 2]);
  f29 = Math_fround(f567 * f30);
  f61 = Math_fround(HEAPF32[i213 >> 2]);
  f39 = Math_fround(f567 * f61);
  f59 = Math_fround(HEAPF32[i212 >> 2]);
  f28 = Math_fround(f25 + f28);
  f29 = Math_fround(f34 + f29);
  f39 = Math_fround(f24 + f39);
  f31 = Math_fround(f31 + Math_fround(f567 * f59));
  f24 = Math_fround(HEAPF32[i274 >> 2]);
  f34 = Math_fround(f570 * f24);
  f25 = Math_fround(HEAPF32[i218 >> 2]);
  f33 = Math_fround(f570 * f25);
  f26 = Math_fround(HEAPF32[i217 >> 2]);
  f32 = Math_fround(f570 * f26);
  f38 = Math_fround(HEAPF32[i216 >> 2]);
  f33 = Math_fround(f573 + Math_fround(f29 + f33));
  f32 = Math_fround(f573 + Math_fround(f39 + f32));
  f31 = Math_fround(f573 + Math_fround(f31 + Math_fround(f570 * f38)));
  HEAPF32[i609 >> 2] = Math_fround(f573 + Math_fround(f28 + f34));
  HEAPF32[i275 >> 2] = f33;
  HEAPF32[i276 >> 2] = f32;
  HEAPF32[i277 >> 2] = f31;
  f31 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f35) + Math_fround(f568 * f30)) + Math_fround(f571 * f25)));
  f32 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f62) + Math_fround(f568 * f61)) + Math_fround(f571 * f26)));
  f33 = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f60) + Math_fround(f568 * f59)) + Math_fround(f571 * f38)));
  HEAPF32[i278 >> 2] = Math_fround(f574 + Math_fround(Math_fround(Math_fround(f565 * f37) + Math_fround(f568 * f36)) + Math_fround(f571 * f24)));
  HEAPF32[i279 >> 2] = f31;
  HEAPF32[i280 >> 2] = f32;
  HEAPF32[i281 >> 2] = f33;
  f33 = Math_fround(f575 + Math_fround(Math_fround(f572 * f25) + Math_fround(Math_fround(f569 * f30) + Math_fround(f566 * f35))));
  f32 = Math_fround(f575 + Math_fround(Math_fround(f572 * f26) + Math_fround(Math_fround(f569 * f61) + Math_fround(f566 * f62))));
  f31 = Math_fround(f575 + Math_fround(Math_fround(f572 * f38) + Math_fround(Math_fround(f569 * f59) + Math_fround(f566 * f60))));
  HEAPF32[i282 >> 2] = Math_fround(f575 + Math_fround(Math_fround(f572 * f24) + Math_fround(Math_fround(f569 * f36) + Math_fround(f566 * f37))));
  HEAPF32[i283 >> 2] = f33;
  HEAPF32[i284 >> 2] = f32;
  HEAPF32[i285 >> 2] = f31;
  f24 = Math_fround(f628 + Math_fround(Math_fround(Math_fround(f624 * f37) + Math_fround(f625 * f36)) + Math_fround(f626 * f24)));
  f25 = Math_fround(f628 + Math_fround(Math_fround(Math_fround(f624 * f35) + Math_fround(f625 * f30)) + Math_fround(f626 * f25)));
  f26 = Math_fround(f628 + Math_fround(Math_fround(Math_fround(f624 * f62) + Math_fround(f625 * f61)) + Math_fround(f626 * f26)));
  f38 = Math_fround(f628 + Math_fround(Math_fround(Math_fround(f624 * f60) + Math_fround(f625 * f59)) + Math_fround(f626 * f38)));
  f59 = Math_fround(f595 + Math_fround(f596 * f24));
  f60 = Math_fround(f595 + Math_fround(f596 * f25));
  f61 = Math_fround(f595 + Math_fround(f596 * f26));
  f62 = Math_fround(f595 + Math_fround(f596 * f38));
  f24 = Math_fround(f591 + Math_fround(f592 * f24));
  f25 = Math_fround(f591 + Math_fround(f592 * f25));
  f26 = Math_fround(f591 + Math_fround(f592 * f26));
  f38 = Math_fround(f591 + Math_fround(f592 * f38));
  f30 = Math_fround(HEAPF32[i603 >> 2]);
  f35 = Math_fround(HEAPF32[i254 >> 2]);
  f36 = Math_fround(HEAPF32[i255 >> 2]);
  f37 = Math_fround(HEAPF32[i256 >> 2]);
  f31 = Math_fround(HEAPF32[i604 >> 2]);
  f32 = Math_fround(HEAPF32[i258 >> 2]);
  f33 = Math_fround(HEAPF32[i259 >> 2]);
  f34 = Math_fround(HEAPF32[i260 >> 2]);
  f28 = f30 > f31 ? f30 : f31;
  f39 = f35 > f32 ? f35 : f32;
  f29 = f36 > f33 ? f36 : f33;
  f40 = f37 > f34 ? f37 : f34;
  f56 = Math_fround((f28 > f59 ? f28 : f59) * Math_fround(.5));
  f57 = Math_fround((f39 > f60 ? f39 : f60) * Math_fround(.5));
  f58 = Math_fround((f29 > f61 ? f29 : f61) * Math_fround(.5));
  f12 = Math_fround((f40 > f62 ? f40 : f62) * Math_fround(.5));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = f59 >= Math_fround(0.0);
  i76 = f60 >= Math_fround(0.0);
  i77 = f61 >= Math_fround(0.0);
  i78 = f62 >= Math_fround(0.0);
  i9 = i75 ? i9 : 0;
  i10 = i76 ? i10 : 0;
  i11 = i77 ? i11 : 0;
  i5 = i78 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  f58 = Math_fround(f24 * Math_fround(.5));
  f60 = Math_fround(f25 * Math_fround(.5));
  f62 = Math_fround(f26 * Math_fround(.5));
  f12 = Math_fround(f38 * Math_fround(.5));
  f57 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f57 < f58 ? f57 : f58, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f59 < f60 ? f59 : f60, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f61 < f62 ? f61 : f62, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f24 >= Math_fround(0.0);
  i3 = f25 >= Math_fround(0.0);
  i2 = f26 >= Math_fround(0.0);
  i78 = f38 >= Math_fround(0.0);
  i75 = i78 ? (HEAPF32[tempDoublePtr >> 2] = f27 < f12 ? f27 : f12, HEAP32[tempDoublePtr >> 2] | 0) : i5;
  f638 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f28);
  f48 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f637 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i8 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f29);
  f38 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f47 = Math_fround(f30 * f638);
  f49 = Math_fround(f36 * f637);
  f638 = Math_fround(f31 * f638);
  f637 = Math_fround(f33 * f637);
  f46 = Math_fround(HEAPF32[i605 >> 2]);
  f33 = Math_fround(HEAPF32[i262 >> 2]);
  f50 = Math_fround(HEAPF32[i263 >> 2]);
  f36 = Math_fround(f48 / f39);
  f48 = Math_fround(f35 * f36);
  f36 = Math_fround(f32 * f36);
  i75 = f46 < Math_fround(100.0);
  i77 = f50 < Math_fround(100.0);
  f38 = Math_fround(f38 / f40);
  f50 = Math_fround(f37 * f38);
  f38 = Math_fround(f34 * f38);
  i76 = f33 < Math_fround(100.0);
  i78 = Math_fround(HEAPF32[i264 >> 2]) < Math_fround(100.0);
  f33 = Math_fround(HEAPF32[i601 >> 2]);
  f46 = Math_fround(HEAPF32[i221 >> 2]);
  f24 = Math_fround(HEAPF32[i220 >> 2]);
  f43 = Math_fround(HEAPF32[i219 >> 2]);
  f27 = Math_fround(HEAPF32[i286 >> 2]);
  f29 = Math_fround(HEAPF32[i225 >> 2]);
  f26 = Math_fround(HEAPF32[i224 >> 2]);
  f642 = Math_fround(HEAPF32[i223 >> 2]);
  f35 = Math_fround(HEAPF32[i287 >> 2]);
  f640 = Math_fround(HEAPF32[i229 >> 2]);
  f53 = Math_fround(HEAPF32[i228 >> 2]);
  f639 = Math_fround(HEAPF32[i227 >> 2]);
  f33 = Math_fround(f33 * Math_fround(-.159154937));
  f46 = Math_fround(f46 * Math_fround(-.159154937));
  f24 = Math_fround(f24 * Math_fround(-.159154937));
  f43 = Math_fround(f43 * Math_fround(-.159154937));
  f25 = Math_fround(+_roundf(+f33));
  f37 = Math_fround(+_roundf(+f46));
  f31 = Math_fround(+_roundf(+f24));
  f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f33 - f25))));
  f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f46 - f37))));
  f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f24 - f31))));
  f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f43 - Math_fround(+_roundf(+f43))))));
  f30 = Math_fround(f25 * f25);
  f28 = Math_fround(f37 * f37);
  f52 = Math_fround(f31 * f31);
  f34 = Math_fround(f39 * f39);
  f40 = Math_fround(f30 * f30);
  f41 = Math_fround(f28 * f28);
  f44 = Math_fround(f52 * f52);
  f51 = Math_fround(f34 * f34);
  f30 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f30 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f30 * Math_fround(76.5686187)))))));
  f28 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f41 * f41) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f41 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
  f52 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f44 * f44) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f52 * Math_fround(41.3416595))) + Math_fround(f44 * Math_fround(Math_fround(81.6018218) - Math_fround(f52 * Math_fround(76.5686187)))))));
  f34 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f51 * f51) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f34 * Math_fround(41.3416595))) + Math_fround(f51 * Math_fround(Math_fround(81.6018218) - Math_fround(f34 * Math_fround(76.5686187)))))));
  f33 = Math_fround(f33 + Math_fround(-.25));
  f46 = Math_fround(f46 + Math_fround(-.25));
  f24 = Math_fround(f24 + Math_fround(-.25));
  f43 = Math_fround(f43 + Math_fround(-.25));
  f51 = Math_fround(+_roundf(+f33));
  f39 = Math_fround(+_roundf(+f46));
  f44 = Math_fround(+_roundf(+f24));
  f51 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f33 - f51))));
  f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f46 - f39))));
  f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f24 - f44))));
  f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f43 - Math_fround(+_roundf(+f43))))));
  f24 = Math_fround(f51 * f51);
  f46 = Math_fround(f39 * f39);
  f33 = Math_fround(f44 * f44);
  f31 = Math_fround(f43 * f43);
  f41 = Math_fround(f24 * f24);
  f37 = Math_fround(f46 * f46);
  f40 = Math_fround(f33 * f33);
  f25 = Math_fround(f31 * f31);
  f24 = Math_fround(f51 * Math_fround(Math_fround(Math_fround(f41 * f41) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f24 * Math_fround(41.3416595))) + Math_fround(f41 * Math_fround(Math_fround(81.6018218) - Math_fround(f24 * Math_fround(76.5686187)))))));
  f46 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f46 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f46 * Math_fround(76.5686187)))))));
  f33 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187)))))));
  f31 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187)))))));
  f27 = Math_fround(f27 * Math_fround(-.159154937));
  f29 = Math_fround(f29 * Math_fround(-.159154937));
  f26 = Math_fround(f26 * Math_fround(-.159154937));
  f642 = Math_fround(f642 * Math_fround(-.159154937));
  f25 = Math_fround(+_roundf(+f27));
  f43 = Math_fround(+_roundf(+f29));
  f40 = Math_fround(+_roundf(+f26));
  f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f25))));
  f43 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - f43))));
  f40 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f40))));
  f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f642 - Math_fround(+_roundf(+f642))))));
  f37 = Math_fround(f25 * f25);
  f39 = Math_fround(f43 * f43);
  f41 = Math_fround(f40 * f40);
  f51 = Math_fround(f44 * f44);
  f32 = Math_fround(f37 * f37);
  f45 = Math_fround(f39 * f39);
  f644 = Math_fround(f41 * f41);
  f641 = Math_fround(f51 * f51);
  f37 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187)))))));
  f39 = Math_fround(f43 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187)))))));
  f41 = Math_fround(f40 * Math_fround(Math_fround(Math_fround(f644 * f644) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f41 * Math_fround(41.3416595))) + Math_fround(f644 * Math_fround(Math_fround(81.6018218) - Math_fround(f41 * Math_fround(76.5686187)))))));
  f51 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f641 * f641) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f641 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
  f27 = Math_fround(f27 + Math_fround(-.25));
  f29 = Math_fround(f29 + Math_fround(-.25));
  f26 = Math_fround(f26 + Math_fround(-.25));
  f642 = Math_fround(f642 + Math_fround(-.25));
  f641 = Math_fround(+_roundf(+f27));
  f44 = Math_fround(+_roundf(+f29));
  f644 = Math_fround(+_roundf(+f26));
  f641 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f641))));
  f44 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - f44))));
  f644 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f26 - f644))));
  f642 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f642 - Math_fround(+_roundf(+f642))))));
  f26 = Math_fround(f641 * f641);
  f29 = Math_fround(f44 * f44);
  f27 = Math_fround(f644 * f644);
  f40 = Math_fround(f642 * f642);
  f45 = Math_fround(f26 * f26);
  f43 = Math_fround(f29 * f29);
  f32 = Math_fround(f27 * f27);
  f25 = Math_fround(f40 * f40);
  f26 = Math_fround(f641 * Math_fround(Math_fround(Math_fround(f45 * f45) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f26 * Math_fround(41.3416595))) + Math_fround(f45 * Math_fround(Math_fround(81.6018218) - Math_fround(f26 * Math_fround(76.5686187)))))));
  f29 = Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f43) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f29 * Math_fround(41.3416595))) + Math_fround(f43 * Math_fround(Math_fround(81.6018218) - Math_fround(f29 * Math_fround(76.5686187)))))));
  f27 = Math_fround(f644 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187)))))));
  f40 = Math_fround(f642 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f35 * Math_fround(-.159154937));
  f640 = Math_fround(f640 * Math_fround(-.159154937));
  f53 = Math_fround(f53 * Math_fround(-.159154937));
  f639 = Math_fround(f639 * Math_fround(-.159154937));
  f25 = Math_fround(+_roundf(+f35));
  f642 = Math_fround(+_roundf(+f640));
  f32 = Math_fround(+_roundf(+f53));
  f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - f25))));
  f642 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f640 - f642))));
  f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f53 - f32))));
  f644 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f639 - Math_fround(+_roundf(+f639))))));
  f43 = Math_fround(f25 * f25);
  f44 = Math_fround(f642 * f642);
  f45 = Math_fround(f32 * f32);
  f641 = Math_fround(f644 * f644);
  f42 = Math_fround(f43 * f43);
  f54 = Math_fround(f44 * f44);
  f648 = Math_fround(f45 * f45);
  f643 = Math_fround(f641 * f641);
  f43 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f42 * f42) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f43 * Math_fround(41.3416595))) + Math_fround(f42 * Math_fround(Math_fround(81.6018218) - Math_fround(f43 * Math_fround(76.5686187)))))));
  f44 = Math_fround(f642 * Math_fround(Math_fround(Math_fround(f54 * f54) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f44 * Math_fround(41.3416595))) + Math_fround(f54 * Math_fround(Math_fround(81.6018218) - Math_fround(f44 * Math_fround(76.5686187)))))));
  f45 = Math_fround(f32 * Math_fround(Math_fround(Math_fround(f648 * f648) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f45 * Math_fround(41.3416595))) + Math_fround(f648 * Math_fround(Math_fround(81.6018218) - Math_fround(f45 * Math_fround(76.5686187)))))));
  f641 = Math_fround(f644 * Math_fround(Math_fround(Math_fround(f643 * f643) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f641 * Math_fround(41.3416595))) + Math_fround(f643 * Math_fround(Math_fround(81.6018218) - Math_fround(f641 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f35 + Math_fround(-.25));
  f640 = Math_fround(f640 + Math_fround(-.25));
  f53 = Math_fround(f53 + Math_fround(-.25));
  f639 = Math_fround(f639 + Math_fround(-.25));
  f643 = Math_fround(+_roundf(+f35));
  f644 = Math_fround(+_roundf(+f640));
  f648 = Math_fround(+_roundf(+f53));
  f643 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - f643))));
  f644 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f640 - f644))));
  f648 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f53 - f648))));
  f639 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f639 - Math_fround(+_roundf(+f639))))));
  f53 = Math_fround(f643 * f643);
  f640 = Math_fround(f644 * f644);
  f35 = Math_fround(f648 * f648);
  f32 = Math_fround(f639 * f639);
  f54 = Math_fround(f53 * f53);
  f642 = Math_fround(f640 * f640);
  f42 = Math_fround(f35 * f35);
  f25 = Math_fround(f32 * f32);
  f53 = Math_fround(f643 * Math_fround(Math_fround(Math_fround(f54 * f54) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f53 * Math_fround(41.3416595))) + Math_fround(f54 * Math_fround(Math_fround(81.6018218) - Math_fround(f53 * Math_fround(76.5686187)))))));
  f640 = Math_fround(f644 * Math_fround(Math_fround(Math_fround(f642 * f642) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f640 * Math_fround(41.3416595))) + Math_fround(f642 * Math_fround(Math_fround(81.6018218) - Math_fround(f640 * Math_fround(76.5686187)))))));
  f35 = Math_fround(f648 * Math_fround(Math_fround(Math_fround(f42 * f42) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f35 * Math_fround(41.3416595))) + Math_fround(f42 * Math_fround(Math_fround(81.6018218) - Math_fround(f35 * Math_fround(76.5686187)))))));
  f32 = Math_fround(f639 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187)))))));
  f25 = Math_fround(f37 * f43);
  f639 = Math_fround(f39 * f44);
  f42 = Math_fround(f41 * f45);
  f648 = Math_fround(f51 * f641);
  f642 = Math_fround(f639 + Math_fround(Math_fround(f46 * f29) * f640));
  f644 = Math_fround(f42 + Math_fround(Math_fround(f33 * f27) * f35));
  f54 = Math_fround(f648 + Math_fround(Math_fround(f31 * f40) * f32));
  HEAPF32[i611 >> 2] = Math_fround(f25 + Math_fround(Math_fround(f24 * f26) * f53));
  HEAPF32[i288 >> 2] = f642;
  HEAPF32[i289 >> 2] = f644;
  HEAPF32[i290 >> 2] = f54;
  f54 = Math_fround(Math_fround(f29 * Math_fround(f46 * f44)) - Math_fround(f39 * f640));
  f644 = Math_fround(Math_fround(f27 * Math_fround(f33 * f45)) - Math_fround(f41 * f35));
  f642 = Math_fround(Math_fround(f40 * Math_fround(f31 * f641)) - Math_fround(f51 * f32));
  HEAPF32[i291 >> 2] = Math_fround(Math_fround(f26 * Math_fround(f24 * f43)) - Math_fround(f37 * f53));
  HEAPF32[i292 >> 2] = f54;
  HEAPF32[i293 >> 2] = f644;
  HEAPF32[i294 >> 2] = f642;
  f642 = Math_fround(f28 * f29);
  f644 = Math_fround(f52 * f27);
  f54 = Math_fround(f34 * f40);
  HEAPF32[i295 >> 2] = Math_fround(f30 * f26);
  HEAPF32[i296 >> 2] = f642;
  HEAPF32[i297 >> 2] = f644;
  HEAPF32[i298 >> 2] = f54;
  f54 = Math_fround(f30 * f53);
  f644 = Math_fround(f28 * f640);
  f642 = Math_fround(f52 * f35);
  f643 = Math_fround(f34 * f32);
  HEAPF32[i299 >> 2] = f54;
  HEAPF32[i300 >> 2] = f644;
  HEAPF32[i301 >> 2] = f642;
  HEAPF32[i302 >> 2] = f643;
  f12 = Math_fround(f28 * f44);
  f55 = Math_fround(f52 * f45);
  f56 = Math_fround(f34 * f641);
  HEAPF32[i303 >> 2] = Math_fround(f30 * f43);
  HEAPF32[i304 >> 2] = f12;
  HEAPF32[i305 >> 2] = f55;
  HEAPF32[i306 >> 2] = f56;
  f56 = Math_fround(-f46);
  f55 = Math_fround(-f33);
  f12 = Math_fround(-f31);
  HEAPF32[i307 >> 2] = Math_fround(-f24);
  HEAPF32[i308 >> 2] = f56;
  HEAPF32[i309 >> 2] = f55;
  HEAPF32[i310 >> 2] = f12;
  f43 = Math_fround(Math_fround(Math_fround(f24 * f37) * f53) - Math_fround(f26 * f43));
  f44 = Math_fround(Math_fround(Math_fround(f46 * f39) * f640) - Math_fround(f29 * f44));
  f45 = Math_fround(Math_fround(Math_fround(f33 * f41) * f35) - Math_fround(f27 * f45));
  f641 = Math_fround(Math_fround(Math_fround(f31 * f51) * f32) - Math_fround(f40 * f641));
  HEAPF32[i311 >> 2] = f43;
  HEAPF32[i312 >> 2] = f44;
  HEAPF32[i313 >> 2] = f45;
  HEAPF32[i314 >> 2] = f641;
  f53 = Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f53));
  f640 = Math_fround(Math_fround(f46 * f639) + Math_fround(f29 * f640));
  f35 = Math_fround(Math_fround(f33 * f42) + Math_fround(f27 * f35));
  f32 = Math_fround(Math_fround(f31 * f648) + Math_fround(f40 * f32));
  HEAPF32[i315 >> 2] = f53;
  HEAPF32[i316 >> 2] = f640;
  HEAPF32[i317 >> 2] = f35;
  HEAPF32[i318 >> 2] = f32;
  f37 = Math_fround(f30 * f37);
  f39 = Math_fround(f28 * f39);
  f41 = Math_fround(f52 * f41);
  f51 = Math_fround(f34 * f51);
  HEAPF32[i319 >> 2] = f37;
  HEAPF32[i320 >> 2] = f39;
  HEAPF32[i321 >> 2] = f41;
  HEAPF32[i322 >> 2] = f51;
  f34 = Math_fround(HEAPF32[i598 >> 2]);
  f52 = Math_fround(f34 * Math_fround(HEAPF32[i611 >> 2]));
  f28 = Math_fround(HEAPF32[i179 >> 2]);
  f30 = Math_fround(f28 * Math_fround(HEAPF32[i288 >> 2]));
  f40 = Math_fround(HEAPF32[i180 >> 2]);
  f648 = Math_fround(f40 * Math_fround(HEAPF32[i289 >> 2]));
  f31 = Math_fround(HEAPF32[i181 >> 2]);
  f27 = Math_fround(f31 * Math_fround(HEAPF32[i290 >> 2]));
  f42 = Math_fround(HEAPF32[i323 >> 2]);
  f54 = Math_fround(f42 * f54);
  f33 = Math_fround(HEAPF32[i188 >> 2]);
  f644 = Math_fround(f33 * f644);
  f29 = Math_fround(HEAPF32[i189 >> 2]);
  f642 = Math_fround(f29 * f642);
  f639 = Math_fround(HEAPF32[i190 >> 2]);
  f54 = Math_fround(f52 + f54);
  f644 = Math_fround(f30 + f644);
  f642 = Math_fround(f648 + f642);
  f643 = Math_fround(f27 + Math_fround(f639 * f643));
  f27 = Math_fround(HEAPF32[i324 >> 2]);
  f43 = Math_fround(f27 * f43);
  f648 = Math_fround(HEAPF32[i197 >> 2]);
  f44 = Math_fround(f648 * f44);
  f30 = Math_fround(HEAPF32[i198 >> 2]);
  f45 = Math_fround(f30 * f45);
  f52 = Math_fround(HEAPF32[i199 >> 2]);
  f44 = Math_fround(f644 + f44);
  f45 = Math_fround(f642 + f45);
  f641 = Math_fround(f643 + Math_fround(f52 * f641));
  HEAPF32[i610 >> 2] = Math_fround(f54 + f43);
  HEAPF32[i325 >> 2] = f44;
  HEAPF32[i326 >> 2] = f45;
  HEAPF32[i327 >> 2] = f641;
  f641 = Math_fround(f34 * Math_fround(HEAPF32[i291 >> 2]));
  f45 = Math_fround(f28 * Math_fround(HEAPF32[i292 >> 2]));
  f44 = Math_fround(f40 * Math_fround(HEAPF32[i293 >> 2]));
  f43 = Math_fround(f31 * Math_fround(HEAPF32[i294 >> 2]));
  f54 = Math_fround(f42 * Math_fround(HEAPF32[i303 >> 2]));
  f643 = Math_fround(f33 * Math_fround(HEAPF32[i304 >> 2]));
  f642 = Math_fround(f29 * Math_fround(HEAPF32[i305 >> 2]));
  f640 = Math_fround(Math_fround(f45 + f643) + Math_fround(f648 * f640));
  f35 = Math_fround(Math_fround(f44 + f642) + Math_fround(f30 * f35));
  f32 = Math_fround(Math_fround(f43 + Math_fround(f639 * Math_fround(HEAPF32[i306 >> 2]))) + Math_fround(f52 * f32));
  HEAPF32[i328 >> 2] = Math_fround(Math_fround(f641 + f54) + Math_fround(f27 * f53));
  HEAPF32[i329 >> 2] = f640;
  HEAPF32[i330 >> 2] = f35;
  HEAPF32[i331 >> 2] = f32;
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i295 >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i296 >> 2]));
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i297 >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i298 >> 2]));
  f42 = Math_fround(f42 * Math_fround(HEAPF32[i307 >> 2]));
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i308 >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i309 >> 2]));
  f39 = Math_fround(Math_fround(f28 + f33) + Math_fround(f648 * f39));
  f41 = Math_fround(Math_fround(f40 + f29) + Math_fround(f30 * f41));
  f51 = Math_fround(Math_fround(f31 + Math_fround(f639 * Math_fround(HEAPF32[i310 >> 2]))) + Math_fround(f52 * f51));
  HEAPF32[i332 >> 2] = Math_fround(Math_fround(f34 + f42) + Math_fround(f27 * f37));
  HEAPF32[i333 >> 2] = f39;
  HEAPF32[i334 >> 2] = f41;
  HEAPF32[i335 >> 2] = f51;
  f51 = Math_fround(HEAPF32[i336 >> 2]);
  f41 = Math_fround(f51 * Math_fround(HEAPF32[i611 >> 2]));
  f39 = Math_fround(HEAPF32[i182 >> 2]);
  f37 = Math_fround(f39 * Math_fround(HEAPF32[i288 >> 2]));
  f27 = Math_fround(HEAPF32[i183 >> 2]);
  f42 = Math_fround(f27 * Math_fround(HEAPF32[i289 >> 2]));
  f34 = Math_fround(HEAPF32[i184 >> 2]);
  f52 = Math_fround(f34 * Math_fround(HEAPF32[i290 >> 2]));
  f639 = Math_fround(HEAPF32[i337 >> 2]);
  f31 = Math_fround(f639 * Math_fround(HEAPF32[i299 >> 2]));
  f30 = Math_fround(HEAPF32[i191 >> 2]);
  f29 = Math_fround(f30 * Math_fround(HEAPF32[i300 >> 2]));
  f40 = Math_fround(HEAPF32[i192 >> 2]);
  f648 = Math_fround(f40 * Math_fround(HEAPF32[i301 >> 2]));
  f33 = Math_fround(HEAPF32[i193 >> 2]);
  f31 = Math_fround(f41 + f31);
  f29 = Math_fround(f37 + f29);
  f648 = Math_fround(f42 + f648);
  f52 = Math_fround(f52 + Math_fround(f33 * Math_fround(HEAPF32[i302 >> 2])));
  f42 = Math_fround(HEAPF32[i338 >> 2]);
  f37 = Math_fround(f42 * Math_fround(HEAPF32[i311 >> 2]));
  f41 = Math_fround(HEAPF32[i200 >> 2]);
  f28 = Math_fround(f41 * Math_fround(HEAPF32[i312 >> 2]));
  f32 = Math_fround(HEAPF32[i201 >> 2]);
  f35 = Math_fround(f32 * Math_fround(HEAPF32[i313 >> 2]));
  f640 = Math_fround(HEAPF32[i202 >> 2]);
  f28 = Math_fround(f29 + f28);
  f35 = Math_fround(f648 + f35);
  f52 = Math_fround(f52 + Math_fround(f640 * Math_fround(HEAPF32[i314 >> 2])));
  HEAPF32[i339 >> 2] = Math_fround(f31 + f37);
  HEAPF32[i340 >> 2] = f28;
  HEAPF32[i341 >> 2] = f35;
  HEAPF32[i342 >> 2] = f52;
  f52 = Math_fround(f51 * Math_fround(HEAPF32[i291 >> 2]));
  f35 = Math_fround(f39 * Math_fround(HEAPF32[i292 >> 2]));
  f28 = Math_fround(f27 * Math_fround(HEAPF32[i293 >> 2]));
  f37 = Math_fround(f34 * Math_fround(HEAPF32[i294 >> 2]));
  f31 = Math_fround(f639 * Math_fround(HEAPF32[i303 >> 2]));
  f648 = Math_fround(f30 * Math_fround(HEAPF32[i304 >> 2]));
  f29 = Math_fround(f40 * Math_fround(HEAPF32[i305 >> 2]));
  f31 = Math_fround(f52 + f31);
  f648 = Math_fround(f35 + f648);
  f29 = Math_fround(f28 + f29);
  f37 = Math_fround(f37 + Math_fround(f33 * Math_fround(HEAPF32[i306 >> 2])));
  f28 = Math_fround(f42 * Math_fround(HEAPF32[i315 >> 2]));
  f35 = Math_fround(f41 * Math_fround(HEAPF32[i316 >> 2]));
  f52 = Math_fround(f32 * Math_fround(HEAPF32[i317 >> 2]));
  f35 = Math_fround(f648 + f35);
  f52 = Math_fround(f29 + f52);
  f37 = Math_fround(f37 + Math_fround(f640 * Math_fround(HEAPF32[i318 >> 2])));
  HEAPF32[i343 >> 2] = Math_fround(f31 + f28);
  HEAPF32[i344 >> 2] = f35;
  HEAPF32[i345 >> 2] = f52;
  HEAPF32[i346 >> 2] = f37;
  f51 = Math_fround(f51 * Math_fround(HEAPF32[i295 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i296 >> 2]));
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i297 >> 2]));
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i298 >> 2]));
  f639 = Math_fround(f639 * Math_fround(HEAPF32[i307 >> 2]));
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i308 >> 2]));
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i309 >> 2]));
  f639 = Math_fround(f51 + f639);
  f30 = Math_fround(f39 + f30);
  f40 = Math_fround(f27 + f40);
  f33 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i310 >> 2])));
  f42 = Math_fround(f42 * Math_fround(HEAPF32[i319 >> 2]));
  f41 = Math_fround(f41 * Math_fround(HEAPF32[i320 >> 2]));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i321 >> 2]));
  f41 = Math_fround(f30 + f41);
  f32 = Math_fround(f40 + f32);
  f640 = Math_fround(f33 + Math_fround(f640 * Math_fround(HEAPF32[i322 >> 2])));
  HEAPF32[i347 >> 2] = Math_fround(f639 + f42);
  HEAPF32[i348 >> 2] = f41;
  HEAPF32[i349 >> 2] = f32;
  HEAPF32[i350 >> 2] = f640;
  f640 = Math_fround(HEAPF32[i351 >> 2]);
  f32 = Math_fround(f640 * Math_fround(HEAPF32[i611 >> 2]));
  f41 = Math_fround(HEAPF32[i185 >> 2]);
  f42 = Math_fround(f41 * Math_fround(HEAPF32[i288 >> 2]));
  f639 = Math_fround(HEAPF32[i186 >> 2]);
  f33 = Math_fround(f639 * Math_fround(HEAPF32[i289 >> 2]));
  f40 = Math_fround(HEAPF32[i187 >> 2]);
  f30 = Math_fround(f40 * Math_fround(HEAPF32[i290 >> 2]));
  f34 = Math_fround(HEAPF32[i352 >> 2]);
  f27 = Math_fround(f34 * Math_fround(HEAPF32[i299 >> 2]));
  f39 = Math_fround(HEAPF32[i194 >> 2]);
  f51 = Math_fround(f39 * Math_fround(HEAPF32[i300 >> 2]));
  f37 = Math_fround(HEAPF32[i195 >> 2]);
  f52 = Math_fround(f37 * Math_fround(HEAPF32[i301 >> 2]));
  f35 = Math_fround(HEAPF32[i196 >> 2]);
  f27 = Math_fround(f32 + f27);
  f51 = Math_fround(f42 + f51);
  f52 = Math_fround(f33 + f52);
  f30 = Math_fround(f30 + Math_fround(f35 * Math_fround(HEAPF32[i302 >> 2])));
  f33 = Math_fround(HEAPF32[i353 >> 2]);
  f42 = Math_fround(f33 * Math_fround(HEAPF32[i311 >> 2]));
  f32 = Math_fround(HEAPF32[i203 >> 2]);
  f28 = Math_fround(f32 * Math_fround(HEAPF32[i312 >> 2]));
  f31 = Math_fround(HEAPF32[i204 >> 2]);
  f29 = Math_fround(f31 * Math_fround(HEAPF32[i313 >> 2]));
  f648 = Math_fround(HEAPF32[i205 >> 2]);
  f28 = Math_fround(f51 + f28);
  f29 = Math_fround(f52 + f29);
  f30 = Math_fround(f30 + Math_fround(f648 * Math_fround(HEAPF32[i314 >> 2])));
  HEAPF32[i354 >> 2] = Math_fround(f27 + f42);
  HEAPF32[i355 >> 2] = f28;
  HEAPF32[i356 >> 2] = f29;
  HEAPF32[i357 >> 2] = f30;
  f30 = Math_fround(f640 * Math_fround(HEAPF32[i291 >> 2]));
  f29 = Math_fround(f41 * Math_fround(HEAPF32[i292 >> 2]));
  f28 = Math_fround(f639 * Math_fround(HEAPF32[i293 >> 2]));
  f42 = Math_fround(f40 * Math_fround(HEAPF32[i294 >> 2]));
  f27 = Math_fround(f34 * Math_fround(HEAPF32[i303 >> 2]));
  f52 = Math_fround(f39 * Math_fround(HEAPF32[i304 >> 2]));
  f51 = Math_fround(f37 * Math_fround(HEAPF32[i305 >> 2]));
  f27 = Math_fround(f30 + f27);
  f52 = Math_fround(f29 + f52);
  f51 = Math_fround(f28 + f51);
  f42 = Math_fround(f42 + Math_fround(f35 * Math_fround(HEAPF32[i306 >> 2])));
  f28 = Math_fround(f33 * Math_fround(HEAPF32[i315 >> 2]));
  f29 = Math_fround(f32 * Math_fround(HEAPF32[i316 >> 2]));
  f30 = Math_fround(f31 * Math_fround(HEAPF32[i317 >> 2]));
  f29 = Math_fround(f52 + f29);
  f30 = Math_fround(f51 + f30);
  f42 = Math_fround(f42 + Math_fround(f648 * Math_fround(HEAPF32[i318 >> 2])));
  HEAPF32[i358 >> 2] = Math_fround(f27 + f28);
  HEAPF32[i359 >> 2] = f29;
  HEAPF32[i360 >> 2] = f30;
  HEAPF32[i361 >> 2] = f42;
  f640 = Math_fround(f640 * Math_fround(HEAPF32[i295 >> 2]));
  f41 = Math_fround(f41 * Math_fround(HEAPF32[i296 >> 2]));
  f639 = Math_fround(f639 * Math_fround(HEAPF32[i297 >> 2]));
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i298 >> 2]));
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i307 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i308 >> 2]));
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i309 >> 2]));
  f34 = Math_fround(f640 + f34);
  f39 = Math_fround(f41 + f39);
  f37 = Math_fround(f639 + f37);
  f35 = Math_fround(f40 + Math_fround(f35 * Math_fround(HEAPF32[i310 >> 2])));
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i319 >> 2]));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i320 >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i321 >> 2]));
  f32 = Math_fround(f39 + f32);
  f31 = Math_fround(f37 + f31);
  f648 = Math_fround(f35 + Math_fround(f648 * Math_fround(HEAPF32[i322 >> 2])));
  HEAPF32[i362 >> 2] = Math_fround(f34 + f33);
  HEAPF32[i363 >> 2] = f32;
  HEAPF32[i364 >> 2] = f31;
  HEAPF32[i365 >> 2] = f648;
  f31 = i75 ? f47 : Math_fround(0.0);
  f47 = Math_fround(-f31);
  f32 = i76 ? f48 : Math_fround(0.0);
  f48 = Math_fround(-f32);
  f33 = i77 ? f49 : Math_fround(0.0);
  f49 = Math_fround(-f33);
  f34 = i78 ? f50 : Math_fround(0.0);
  f50 = Math_fround(-f34);
  f35 = i75 ? f638 : Math_fround(0.0);
  f36 = i76 ? f36 : Math_fround(0.0);
  f37 = i77 ? f637 : Math_fround(0.0);
  f38 = i78 ? f38 : Math_fround(0.0);
  f637 = Math_fround(HEAPF32[i610 >> 2]);
  f39 = Math_fround(f637 * f47);
  f638 = Math_fround(HEAPF32[i325 >> 2]);
  f40 = Math_fround(f638 * f48);
  f639 = Math_fround(HEAPF32[i326 >> 2]);
  f41 = Math_fround(f639 * f49);
  f640 = Math_fround(HEAPF32[i327 >> 2]);
  f42 = Math_fround(f640 * f50);
  f30 = Math_fround(f35 * Math_fround(HEAPF32[i328 >> 2]));
  f29 = Math_fround(f36 * Math_fround(HEAPF32[i329 >> 2]));
  f28 = Math_fround(f37 * Math_fround(HEAPF32[i330 >> 2]));
  f27 = Math_fround(f38 * Math_fround(HEAPF32[i331 >> 2]));
  f39 = Math_fround(f39 + f30);
  f40 = Math_fround(f40 + f29);
  f41 = Math_fround(f41 + f28);
  f42 = Math_fround(f42 + f27);
  f51 = Math_fround(Math_fround(HEAPF32[i332 >> 2]) * Math_fround(0.0));
  f52 = Math_fround(Math_fround(HEAPF32[i333 >> 2]) * Math_fround(0.0));
  f53 = Math_fround(Math_fround(HEAPF32[i334 >> 2]) * Math_fround(0.0));
  f54 = Math_fround(Math_fround(HEAPF32[i335 >> 2]) * Math_fround(0.0));
  f39 = Math_fround(f39 + f51);
  f40 = Math_fround(f40 + f52);
  f41 = Math_fround(f41 + f53);
  f42 = Math_fround(f42 + f54);
  f641 = Math_fround(HEAPF32[i339 >> 2]);
  f43 = Math_fround(f641 * f47);
  f642 = Math_fround(HEAPF32[i340 >> 2]);
  f44 = Math_fround(f642 * f48);
  f643 = Math_fround(HEAPF32[i341 >> 2]);
  f45 = Math_fround(f643 * f49);
  f644 = Math_fround(HEAPF32[i342 >> 2]);
  f46 = Math_fround(f644 * f50);
  f26 = Math_fround(f35 * Math_fround(HEAPF32[i343 >> 2]));
  f25 = Math_fround(f36 * Math_fround(HEAPF32[i344 >> 2]));
  f24 = Math_fround(f37 * Math_fround(HEAPF32[i345 >> 2]));
  f12 = Math_fround(f38 * Math_fround(HEAPF32[i346 >> 2]));
  f43 = Math_fround(f43 + f26);
  f44 = Math_fround(f44 + f25);
  f45 = Math_fround(f45 + f24);
  f46 = Math_fround(f46 + f12);
  f55 = Math_fround(Math_fround(HEAPF32[i347 >> 2]) * Math_fround(0.0));
  f56 = Math_fround(Math_fround(HEAPF32[i348 >> 2]) * Math_fround(0.0));
  f57 = Math_fround(Math_fround(HEAPF32[i349 >> 2]) * Math_fround(0.0));
  f58 = Math_fround(Math_fround(HEAPF32[i350 >> 2]) * Math_fround(0.0));
  f43 = Math_fround(f43 + f55);
  f44 = Math_fround(f44 + f56);
  f45 = Math_fround(f45 + f57);
  f46 = Math_fround(f46 + f58);
  f645 = Math_fround(HEAPF32[i354 >> 2]);
  f47 = Math_fround(f645 * f47);
  f646 = Math_fround(HEAPF32[i355 >> 2]);
  f48 = Math_fround(f646 * f48);
  f647 = Math_fround(HEAPF32[i356 >> 2]);
  f49 = Math_fround(f647 * f49);
  f636 = Math_fround(HEAPF32[i357 >> 2]);
  f50 = Math_fround(f636 * f50);
  f633 = Math_fround(f35 * Math_fround(HEAPF32[i358 >> 2]));
  f634 = Math_fround(f36 * Math_fround(HEAPF32[i359 >> 2]));
  f635 = Math_fround(f37 * Math_fround(HEAPF32[i360 >> 2]));
  f62 = Math_fround(f38 * Math_fround(HEAPF32[i361 >> 2]));
  f47 = Math_fround(f47 + f633);
  f48 = Math_fround(f48 + f634);
  f49 = Math_fround(f49 + f635);
  f50 = Math_fround(f50 + f62);
  f59 = Math_fround(Math_fround(HEAPF32[i362 >> 2]) * Math_fround(0.0));
  f60 = Math_fround(Math_fround(HEAPF32[i363 >> 2]) * Math_fround(0.0));
  f61 = Math_fround(Math_fround(HEAPF32[i364 >> 2]) * Math_fround(0.0));
  f648 = Math_fround(f648 * Math_fround(0.0));
  f47 = Math_fround(f47 + f59);
  f48 = Math_fround(f48 + f60);
  f49 = Math_fround(f49 + f61);
  f50 = Math_fround(f648 + f50);
  f51 = Math_fround(Math_fround(Math_fround(f31 * f637) + f30) + f51);
  f52 = Math_fround(Math_fround(Math_fround(f32 * f638) + f29) + f52);
  f53 = Math_fround(Math_fround(Math_fround(f33 * f639) + f28) + f53);
  f54 = Math_fround(Math_fround(Math_fround(f34 * f640) + f27) + f54);
  f55 = Math_fround(Math_fround(Math_fround(f31 * f641) + f26) + f55);
  f56 = Math_fround(Math_fround(Math_fround(f32 * f642) + f25) + f56);
  f57 = Math_fround(Math_fround(Math_fround(f33 * f643) + f24) + f57);
  f58 = Math_fround(Math_fround(Math_fround(f34 * f644) + f12) + f58);
  f59 = Math_fround(Math_fround(Math_fround(f31 * f645) + f633) + f59);
  f60 = Math_fround(Math_fround(Math_fround(f32 * f646) + f634) + f60);
  f61 = Math_fround(Math_fround(Math_fround(f33 * f647) + f635) + f61);
  f62 = Math_fround(f648 + Math_fround(Math_fround(f34 * f636) + f62));
  f636 = Math_fround(HEAPF32[i609 >> 2]);
  f648 = Math_fround(f39 + f636);
  f635 = Math_fround(HEAPF32[i275 >> 2]);
  f647 = Math_fround(f40 + f635);
  f634 = Math_fround(HEAPF32[i276 >> 2]);
  f646 = Math_fround(f41 + f634);
  f633 = Math_fround(HEAPF32[i277 >> 2]);
  f645 = Math_fround(f42 + f633);
  f12 = Math_fround(HEAPF32[i278 >> 2]);
  f644 = Math_fround(f43 + f12);
  f24 = Math_fround(HEAPF32[i279 >> 2]);
  f643 = Math_fround(f44 + f24);
  f25 = Math_fround(HEAPF32[i280 >> 2]);
  f642 = Math_fround(f45 + f25);
  f26 = Math_fround(HEAPF32[i281 >> 2]);
  f641 = Math_fround(f46 + f26);
  f27 = Math_fround(HEAPF32[i282 >> 2]);
  f640 = Math_fround(f47 + f27);
  f28 = Math_fround(HEAPF32[i283 >> 2]);
  f639 = Math_fround(f48 + f28);
  f29 = Math_fround(HEAPF32[i284 >> 2]);
  f638 = Math_fround(f49 + f29);
  f30 = Math_fround(HEAPF32[i285 >> 2]);
  f637 = Math_fround(f50 + f30);
  HEAPF32[i608 >> 2] = f648;
  HEAPF32[i366 >> 2] = f647;
  HEAPF32[i367 >> 2] = f646;
  HEAPF32[i368 >> 2] = f645;
  HEAPF32[i369 >> 2] = f644;
  HEAPF32[i370 >> 2] = f643;
  HEAPF32[i371 >> 2] = f642;
  HEAPF32[i372 >> 2] = f641;
  HEAPF32[i373 >> 2] = f640;
  HEAPF32[i374 >> 2] = f639;
  HEAPF32[i375 >> 2] = f638;
  HEAPF32[i376 >> 2] = f637;
  f637 = Math_fround(f52 + f635);
  f638 = Math_fround(f53 + f634);
  f639 = Math_fround(f54 + f633);
  f640 = Math_fround(f55 + f12);
  f641 = Math_fround(f56 + f24);
  f642 = Math_fround(f57 + f25);
  f643 = Math_fround(f58 + f26);
  f644 = Math_fround(f59 + f27);
  f645 = Math_fround(f60 + f28);
  f646 = Math_fround(f61 + f29);
  f647 = Math_fround(f62 + f30);
  HEAPF32[i377 >> 2] = Math_fround(f51 + f636);
  HEAPF32[i378 >> 2] = f637;
  HEAPF32[i379 >> 2] = f638;
  HEAPF32[i380 >> 2] = f639;
  HEAPF32[i381 >> 2] = f640;
  HEAPF32[i382 >> 2] = f641;
  HEAPF32[i383 >> 2] = f642;
  HEAPF32[i384 >> 2] = f643;
  HEAPF32[i385 >> 2] = f644;
  HEAPF32[i386 >> 2] = f645;
  HEAPF32[i387 >> 2] = f646;
  HEAPF32[i388 >> 2] = f647;
  f647 = Math_fround(f635 - f40);
  f646 = Math_fround(f634 - f41);
  f645 = Math_fround(f633 - f42);
  f644 = Math_fround(f12 - f43);
  f643 = Math_fround(f24 - f44);
  f642 = Math_fround(f25 - f45);
  f641 = Math_fround(f26 - f46);
  f640 = Math_fround(f27 - f47);
  f639 = Math_fround(f28 - f48);
  f638 = Math_fround(f29 - f49);
  f637 = Math_fround(f30 - f50);
  HEAPF32[i389 >> 2] = Math_fround(f636 - f39);
  HEAPF32[i390 >> 2] = f647;
  HEAPF32[i391 >> 2] = f646;
  HEAPF32[i392 >> 2] = f645;
  HEAPF32[i393 >> 2] = f644;
  HEAPF32[i394 >> 2] = f643;
  HEAPF32[i395 >> 2] = f642;
  HEAPF32[i396 >> 2] = f641;
  HEAPF32[i397 >> 2] = f640;
  HEAPF32[i398 >> 2] = f639;
  HEAPF32[i399 >> 2] = f638;
  HEAPF32[i400 >> 2] = f637;
  f635 = Math_fround(f635 - f52);
  f634 = Math_fround(f634 - f53);
  f633 = Math_fround(f633 - f54);
  f12 = Math_fround(f12 - f55);
  f24 = Math_fround(f24 - f56);
  f25 = Math_fround(f25 - f57);
  f26 = Math_fround(f26 - f58);
  f27 = Math_fround(f27 - f59);
  f28 = Math_fround(f28 - f60);
  f29 = Math_fround(f29 - f61);
  f30 = Math_fround(f30 - f62);
  HEAPF32[i401 >> 2] = Math_fround(f636 - f51);
  HEAPF32[i402 >> 2] = f635;
  HEAPF32[i403 >> 2] = f634;
  HEAPF32[i404 >> 2] = f633;
  HEAPF32[i405 >> 2] = f12;
  HEAPF32[i406 >> 2] = f24;
  HEAPF32[i407 >> 2] = f25;
  HEAPF32[i408 >> 2] = f26;
  HEAPF32[i409 >> 2] = f27;
  HEAPF32[i410 >> 2] = f28;
  HEAPF32[i411 >> 2] = f29;
  HEAPF32[i412 >> 2] = f30;
  if (!i413) {
   i2 = HEAP32[i615 >> 2] | 0;
   if (i2 & 536870912) {
    i68 = HEAP32[i80 >> 2] | 0;
    f648 = Math_fround(HEAPF32[i68 + 564 >> 2]);
    i66 = HEAP32[i606 >> 2] | 0;
    i69 = i66 + 693089735 | 0;
    i64 = HEAP32[i266 >> 2] | 0;
    i77 = i64 + 693089735 | 0;
    i23 = HEAP32[i267 >> 2] | 0;
    i74 = i23 + 693089735 | 0;
    i21 = HEAP32[i268 >> 2] | 0;
    i71 = i21 + 693089735 | 0;
    i22 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i63 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
    i65 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
    i67 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i69 = i69 << 11 ^ i69;
    i77 = i77 << 11 ^ i77;
    i74 = i74 << 11 ^ i74;
    i71 = i71 << 11 ^ i71;
    i22 = Math_fround(Math_fround((i22 ^ i69 ^ i69 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i63 = Math_fround(Math_fround((i63 ^ i77 ^ i77 >>> 8) & 8388607 ^ i63 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i65 = Math_fround(Math_fround((i65 ^ i74 ^ i74 >>> 8) & 8388607 ^ i65 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i67 = Math_fround(Math_fround((i67 ^ i71 ^ i71 >>> 8) & 8388607 ^ i67 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    f648 = Math_fround(HEAPF32[i68 + 568 >> 2]);
    i66 = i66 + 13945730 | 0;
    i64 = i64 + 13945730 | 0;
    i23 = i23 + 13945730 | 0;
    i21 = i21 + 13945730 | 0;
    i68 = (Math_imul(i66, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i64, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
    i77 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
    i66 = i66 << 11 ^ i66;
    i64 = i64 << 11 ^ i64;
    i23 = i23 << 11 ^ i23;
    i21 = i21 << 11 ^ i21;
    i68 = Math_fround(Math_fround((i68 ^ i66 ^ i66 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i71 = Math_fround(Math_fround((i71 ^ i64 ^ i64 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i74 = Math_fround(Math_fround((i74 ^ i23 ^ i23 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i77 = Math_fround(Math_fround((i77 ^ i21 ^ i21 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07)) < f648;
    i21 = i22 & 1;
    i23 = i63 & 1;
    i64 = i65 & 1;
    i66 = i67 & 1;
    i69 = i22 & 1 ^ 1;
    i72 = i63 & 1 ^ 1;
    i75 = i65 & 1 ^ 1;
    i78 = i67 & 1 ^ 1;
    i70 = i22 ? 3 : 2;
    i73 = i63 ? 3 : 2;
    i76 = i65 ? 3 : 2;
    i2 = i67 ? 3 : 2;
    i22 = i22 ? 2 : 3;
    i63 = i63 ? 2 : 3;
    i65 = i65 ? 2 : 3;
    i67 = i67 ? 2 : 3;
    HEAP32[i629 >> 2] = i68 ? i22 : i21;
    HEAP32[i578 >> 2] = i71 ? i63 : i23;
    HEAP32[i577 >> 2] = i74 ? i65 : i64;
    HEAP32[i576 >> 2] = i77 ? i67 : i66;
    HEAP32[i590 >> 2] = i68 ? i21 : i22;
    HEAP32[i589 >> 2] = i71 ? i23 : i63;
    HEAP32[i588 >> 2] = i74 ? i64 : i65;
    HEAP32[i587 >> 2] = i77 ? i66 : i67;
    HEAP32[i582 >> 2] = i68 ? i70 : i69;
    HEAP32[i581 >> 2] = i71 ? i73 : i72;
    HEAP32[i580 >> 2] = i74 ? i76 : i75;
    HEAP32[i579 >> 2] = i77 ? i2 : i78;
    HEAP32[i586 >> 2] = i68 ? i69 : i70;
    HEAP32[i585 >> 2] = i71 ? i72 : i73;
    HEAP32[i584 >> 2] = i74 ? i75 : i76;
    HEAP32[i583 >> 2] = i77 ? i78 : i2;
    i2 = HEAP32[i615 >> 2] | 0;
   }
   if (i2 & 268435456 | 0) {
    f12 = Math_fround(f618 * Math_fround(HEAPF32[i607 >> 2]));
    f24 = Math_fround(f618 * Math_fround(HEAPF32[i270 >> 2]));
    f25 = Math_fround(f618 * Math_fround(HEAPF32[i271 >> 2]));
    f26 = Math_fround(f618 * Math_fround(HEAPF32[i272 >> 2]));
    f27 = Math_fround(Math_floor(Math_fround(f12)));
    f28 = Math_fround(Math_floor(Math_fround(f24)));
    f29 = Math_fround(Math_floor(Math_fround(f25)));
    f30 = Math_fround(Math_floor(Math_fround(f26)));
    if (i2 & 16777216 | 0) {
     f645 = Math_fround(Math_floor(Math_fround(f617 * f27)));
     f646 = Math_fround(Math_floor(Math_fround(f617 * f28)));
     f647 = Math_fround(Math_floor(Math_fround(f617 * f29)));
     f648 = Math_fround(Math_floor(Math_fround(f617 * f30)));
     f641 = Math_fround(f619 * Math_fround(f27 - Math_fround(f616 * f645)));
     f642 = Math_fround(f619 * Math_fround(f28 - Math_fround(f616 * f646)));
     f643 = Math_fround(f619 * Math_fround(f29 - Math_fround(f616 * f647)));
     f644 = Math_fround(f619 * Math_fround(f30 - Math_fround(f616 * f648)));
     f645 = Math_fround(f621 - Math_fround(f620 * f645));
     f646 = Math_fround(f621 - Math_fround(f620 * f646));
     f647 = Math_fround(f621 - Math_fround(f620 * f647));
     f648 = Math_fround(f621 - Math_fround(f620 * f648));
     f633 = Math_fround(f620 + f645);
     f634 = Math_fround(f620 + f646);
     f635 = Math_fround(f620 + f647);
     f636 = Math_fround(f620 + f648);
     HEAPF32[i630 >> 2] = f641;
     HEAPF32[i515 >> 2] = f642;
     HEAPF32[i539 >> 2] = f643;
     HEAPF32[i563 >> 2] = f644;
     HEAPF32[i491 >> 2] = f633;
     HEAPF32[i514 >> 2] = f634;
     HEAPF32[i538 >> 2] = f635;
     HEAPF32[i562 >> 2] = f636;
     f637 = Math_fround(f619 + f641);
     f638 = Math_fround(f619 + f642);
     f639 = Math_fround(f619 + f643);
     f640 = Math_fround(f619 + f644);
     HEAPF32[i490 >> 2] = f637;
     HEAPF32[i513 >> 2] = f638;
     HEAPF32[i537 >> 2] = f639;
     HEAPF32[i561 >> 2] = f640;
     HEAPF32[i489 >> 2] = f633;
     HEAPF32[i512 >> 2] = f634;
     HEAPF32[i536 >> 2] = f635;
     HEAPF32[i560 >> 2] = f636;
     HEAPF32[i488 >> 2] = f637;
     HEAPF32[i511 >> 2] = f638;
     HEAPF32[i535 >> 2] = f639;
     HEAPF32[i559 >> 2] = f640;
     HEAPF32[i487 >> 2] = f645;
     HEAPF32[i510 >> 2] = f646;
     HEAPF32[i534 >> 2] = f647;
     HEAPF32[i558 >> 2] = f648;
     HEAPF32[i486 >> 2] = f641;
     HEAPF32[i509 >> 2] = f642;
     HEAPF32[i533 >> 2] = f643;
     HEAPF32[i557 >> 2] = f644;
     HEAPF32[i485 >> 2] = f645;
     HEAPF32[i508 >> 2] = f646;
     HEAPF32[i532 >> 2] = f647;
     HEAPF32[i556 >> 2] = f648;
    }
    if (i2 & 33554432 | 0) {
     f637 = Math_fround(f27 + Math_fround(1.0));
     f638 = Math_fround(f28 + Math_fround(1.0));
     f639 = Math_fround(f29 + Math_fround(1.0));
     f640 = Math_fround(f30 + Math_fround(1.0));
     f645 = Math_fround(f12 - f27);
     f646 = Math_fround(f24 - f28);
     f647 = Math_fround(f25 - f29);
     f648 = Math_fround(f26 - f30);
     f641 = Math_fround(Math_floor(Math_fround(f617 * f637)));
     f642 = Math_fround(Math_floor(Math_fround(f617 * f638)));
     f643 = Math_fround(Math_floor(Math_fround(f617 * f639)));
     f644 = Math_fround(Math_floor(Math_fround(f617 * f640)));
     f637 = Math_fround(f619 * Math_fround(f637 - Math_fround(f616 * f641)));
     f638 = Math_fround(f619 * Math_fround(f638 - Math_fround(f616 * f642)));
     f639 = Math_fround(f619 * Math_fround(f639 - Math_fround(f616 * f643)));
     f640 = Math_fround(f619 * Math_fround(f640 - Math_fround(f616 * f644)));
     f641 = Math_fround(f621 - Math_fround(f620 * f641));
     f642 = Math_fround(f621 - Math_fround(f620 * f642));
     f643 = Math_fround(f621 - Math_fround(f620 * f643));
     f644 = Math_fround(f621 - Math_fround(f620 * f644));
     f27 = Math_fround(f620 + f641);
     f28 = Math_fround(f620 + f642);
     f29 = Math_fround(f620 + f643);
     f30 = Math_fround(f620 + f644);
     HEAPF32[i631 >> 2] = f637;
     HEAPF32[i507 >> 2] = f638;
     HEAPF32[i531 >> 2] = f639;
     HEAPF32[i555 >> 2] = f640;
     HEAPF32[i484 >> 2] = f27;
     HEAPF32[i506 >> 2] = f28;
     HEAPF32[i530 >> 2] = f29;
     HEAPF32[i554 >> 2] = f30;
     HEAPF32[i483 >> 2] = f645;
     HEAPF32[i505 >> 2] = f646;
     HEAPF32[i529 >> 2] = f647;
     HEAPF32[i553 >> 2] = f648;
     HEAPF32[i482 >> 2] = f12;
     HEAPF32[i504 >> 2] = f24;
     HEAPF32[i528 >> 2] = f25;
     HEAPF32[i552 >> 2] = f26;
     f633 = Math_fround(f619 + f637);
     f634 = Math_fround(f619 + f638);
     f635 = Math_fround(f619 + f639);
     f636 = Math_fround(f619 + f640);
     HEAPF32[i481 >> 2] = f633;
     HEAPF32[i503 >> 2] = f634;
     HEAPF32[i527 >> 2] = f635;
     HEAPF32[i551 >> 2] = f636;
     HEAPF32[i480 >> 2] = f27;
     HEAPF32[i502 >> 2] = f28;
     HEAPF32[i526 >> 2] = f29;
     HEAPF32[i550 >> 2] = f30;
     HEAPF32[i479 >> 2] = f645;
     HEAPF32[i501 >> 2] = f646;
     HEAPF32[i525 >> 2] = f647;
     HEAPF32[i549 >> 2] = f648;
     HEAPF32[i478 >> 2] = f12;
     HEAPF32[i500 >> 2] = f24;
     HEAPF32[i524 >> 2] = f25;
     HEAPF32[i548 >> 2] = f26;
     HEAPF32[i477 >> 2] = f633;
     HEAPF32[i499 >> 2] = f634;
     HEAPF32[i523 >> 2] = f635;
     HEAPF32[i547 >> 2] = f636;
     HEAPF32[i476 >> 2] = f641;
     HEAPF32[i498 >> 2] = f642;
     HEAPF32[i522 >> 2] = f643;
     HEAPF32[i546 >> 2] = f644;
     HEAPF32[i475 >> 2] = f645;
     HEAPF32[i497 >> 2] = f646;
     HEAPF32[i521 >> 2] = f647;
     HEAPF32[i545 >> 2] = f648;
     HEAPF32[i474 >> 2] = f12;
     HEAPF32[i496 >> 2] = f24;
     HEAPF32[i520 >> 2] = f25;
     HEAPF32[i544 >> 2] = f26;
     HEAPF32[i473 >> 2] = f637;
     HEAPF32[i495 >> 2] = f638;
     HEAPF32[i519 >> 2] = f639;
     HEAPF32[i543 >> 2] = f640;
     HEAPF32[i472 >> 2] = f641;
     HEAPF32[i494 >> 2] = f642;
     HEAPF32[i518 >> 2] = f643;
     HEAPF32[i542 >> 2] = f644;
     HEAPF32[i471 >> 2] = f645;
     HEAPF32[i493 >> 2] = f646;
     HEAPF32[i517 >> 2] = f647;
     HEAPF32[i541 >> 2] = f648;
     HEAPF32[i470 >> 2] = f12;
     HEAPF32[i492 >> 2] = f24;
     HEAPF32[i516 >> 2] = f25;
     HEAPF32[i540 >> 2] = f26;
    }
   }
  }
  f633 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f43 * f43)) + Math_fround(f47 * f47)))));
  f634 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f44 * f44)) + Math_fround(f48 * f48)))));
  f635 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f45 * f45)) + Math_fround(f49 * f49)))));
  f636 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f46 * f46)) + Math_fround(f50 * f50)))));
  f39 = Math_fround(f623 * Math_fround(f39 * f633));
  f40 = Math_fround(f623 * Math_fround(f40 * f634));
  f41 = Math_fround(f623 * Math_fround(f41 * f635));
  f42 = Math_fround(f623 * Math_fround(f42 * f636));
  f43 = Math_fround(f623 * Math_fround(f43 * f633));
  f44 = Math_fround(f623 * Math_fround(f44 * f634));
  f45 = Math_fround(f623 * Math_fround(f45 * f635));
  f46 = Math_fround(f623 * Math_fround(f46 * f636));
  f633 = Math_fround(f623 * Math_fround(f47 * f633));
  f634 = Math_fround(f623 * Math_fround(f48 * f634));
  f635 = Math_fround(f623 * Math_fround(f49 * f635));
  f636 = Math_fround(f623 * Math_fround(f50 * f636));
  f645 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(f55 * f55)) + Math_fround(f59 * f59)))));
  f646 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f56 * f56)) + Math_fround(f60 * f60)))));
  f647 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f57 * f57)) + Math_fround(f61 * f61)))));
  f648 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f58 * f58)) + Math_fround(f62 * f62)))));
  f637 = Math_fround(f623 * Math_fround(f51 * f645));
  f638 = Math_fround(f623 * Math_fround(f52 * f646));
  f639 = Math_fround(f623 * Math_fround(f53 * f647));
  f640 = Math_fround(f623 * Math_fround(f54 * f648));
  f641 = Math_fround(f623 * Math_fround(f55 * f645));
  f642 = Math_fround(f623 * Math_fround(f56 * f646));
  f643 = Math_fround(f623 * Math_fround(f57 * f647));
  f644 = Math_fround(f623 * Math_fround(f58 * f648));
  f645 = Math_fround(f623 * Math_fround(f59 * f645));
  f646 = Math_fround(f623 * Math_fround(f60 * f646));
  f647 = Math_fround(f623 * Math_fround(f61 * f647));
  f648 = Math_fround(f623 * Math_fround(f62 * f648));
  f56 = Math_fround(f597 + f40);
  f57 = Math_fround(f597 + f41);
  f58 = Math_fround(f597 + f42);
  f59 = Math_fround(f593 + f43);
  f60 = Math_fround(f593 + f44);
  f61 = Math_fround(f593 + f45);
  f62 = Math_fround(f593 + f46);
  f55 = Math_fround(f594 + f633);
  f54 = Math_fround(f594 + f634);
  f53 = Math_fround(f594 + f635);
  f52 = Math_fround(f594 + f636);
  HEAPF32[i610 >> 2] = Math_fround(f597 + f39);
  HEAPF32[i141 >> 2] = f56;
  HEAPF32[i158 >> 2] = f57;
  HEAPF32[i175 >> 2] = f58;
  HEAPF32[i414 >> 2] = f59;
  HEAPF32[i136 >> 2] = f60;
  HEAPF32[i153 >> 2] = f61;
  HEAPF32[i170 >> 2] = f62;
  HEAPF32[i415 >> 2] = f55;
  HEAPF32[i131 >> 2] = f54;
  HEAPF32[i148 >> 2] = f53;
  HEAPF32[i165 >> 2] = f52;
  f52 = Math_fround(f597 + f638);
  f53 = Math_fround(f597 + f639);
  f54 = Math_fround(f597 + f640);
  f55 = Math_fround(f593 + f641);
  f62 = Math_fround(f593 + f642);
  f61 = Math_fround(f593 + f643);
  f60 = Math_fround(f593 + f644);
  f59 = Math_fround(f594 + f645);
  f58 = Math_fround(f594 + f646);
  f57 = Math_fround(f594 + f647);
  f56 = Math_fround(f594 + f648);
  HEAPF32[i416 >> 2] = Math_fround(f597 + f637);
  HEAPF32[i140 >> 2] = f52;
  HEAPF32[i157 >> 2] = f53;
  HEAPF32[i174 >> 2] = f54;
  HEAPF32[i417 >> 2] = f55;
  HEAPF32[i135 >> 2] = f62;
  HEAPF32[i152 >> 2] = f61;
  HEAPF32[i169 >> 2] = f60;
  HEAPF32[i418 >> 2] = f59;
  HEAPF32[i130 >> 2] = f58;
  HEAPF32[i147 >> 2] = f57;
  HEAPF32[i164 >> 2] = f56;
  f56 = Math_fround(f597 - f40);
  f57 = Math_fround(f597 - f41);
  f58 = Math_fround(f597 - f42);
  f59 = Math_fround(f593 - f43);
  f60 = Math_fround(f593 - f44);
  f61 = Math_fround(f593 - f45);
  f62 = Math_fround(f593 - f46);
  f633 = Math_fround(f594 - f633);
  f634 = Math_fround(f594 - f634);
  f635 = Math_fround(f594 - f635);
  f636 = Math_fround(f594 - f636);
  HEAPF32[i419 >> 2] = Math_fround(f597 - f39);
  HEAPF32[i139 >> 2] = f56;
  HEAPF32[i156 >> 2] = f57;
  HEAPF32[i173 >> 2] = f58;
  HEAPF32[i420 >> 2] = f59;
  HEAPF32[i134 >> 2] = f60;
  HEAPF32[i151 >> 2] = f61;
  HEAPF32[i168 >> 2] = f62;
  HEAPF32[i421 >> 2] = f633;
  HEAPF32[i129 >> 2] = f634;
  HEAPF32[i146 >> 2] = f635;
  HEAPF32[i163 >> 2] = f636;
  f638 = Math_fround(f597 - f638);
  f639 = Math_fround(f597 - f639);
  f640 = Math_fround(f597 - f640);
  f641 = Math_fround(f593 - f641);
  f642 = Math_fround(f593 - f642);
  f643 = Math_fround(f593 - f643);
  f644 = Math_fround(f593 - f644);
  f645 = Math_fround(f594 - f645);
  f646 = Math_fround(f594 - f646);
  f647 = Math_fround(f594 - f647);
  f648 = Math_fround(f594 - f648);
  HEAPF32[i422 >> 2] = Math_fround(f597 - f637);
  HEAPF32[i138 >> 2] = f638;
  HEAPF32[i155 >> 2] = f639;
  HEAPF32[i172 >> 2] = f640;
  HEAPF32[i423 >> 2] = f641;
  HEAPF32[i133 >> 2] = f642;
  HEAPF32[i150 >> 2] = f643;
  HEAPF32[i167 >> 2] = f644;
  HEAPF32[i424 >> 2] = f645;
  HEAPF32[i128 >> 2] = f646;
  HEAPF32[i145 >> 2] = f647;
  HEAPF32[i162 >> 2] = f648;
  do if (i206) {
   i4 = HEAP32[i239 >> 2] | 0;
   i5 = HEAP32[i627 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i3 = i1;
    while (1) {
     i78 = i5 + (i2 + i79 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i608 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i81 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i82 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i610 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i83 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i84 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i85 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i86 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i87 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i416 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i88 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i89 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i389 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i90 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i91 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i92 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i93 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i401 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i95 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i96 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i97 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i78 >> 2];
     i78 = i630 + (HEAP32[i629 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   } else {
    i2 = 0;
    i3 = i1;
    while (1) {
     i78 = i5 + (HEAP32[i4 + (i2 + i79 << 3) >> 2] << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i608 + (i2 << 2) >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i98 + (i2 << 2) >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i99 + (i2 << 2) >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i610 + (i2 << 2) >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i100 + (i2 << 2) >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i101 + (i2 << 2) >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 36 >> 2] = HEAP32[i102 + (i2 << 2) >> 2];
     HEAP32[i3 + 40 >> 2] = HEAP32[i103 + (i2 << 2) >> 2];
     HEAP32[i3 + 44 >> 2] = HEAP32[i104 + (i2 << 2) >> 2];
     HEAP32[i3 + 48 >> 2] = HEAP32[i416 + (i2 << 2) >> 2];
     HEAP32[i3 + 52 >> 2] = HEAP32[i105 + (i2 << 2) >> 2];
     HEAP32[i3 + 56 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i3 + 60 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 + 4 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 64 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 68 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 72 >> 2] = HEAP32[i389 + (i2 << 2) >> 2];
     HEAP32[i3 + 76 >> 2] = HEAP32[i107 + (i2 << 2) >> 2];
     HEAP32[i3 + 80 >> 2] = HEAP32[i108 + (i2 << 2) >> 2];
     HEAP32[i3 + 84 >> 2] = HEAP32[i419 + (i2 << 2) >> 2];
     HEAP32[i3 + 88 >> 2] = HEAP32[i109 + (i2 << 2) >> 2];
     HEAP32[i3 + 92 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i3 + 96 >> 2] = HEAP32[i78 >> 2];
     i77 = i630 + (HEAP32[i629 + (i2 + 8 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 100 >> 2] = HEAP32[i77 + (i2 << 2) >> 2];
     HEAP32[i3 + 104 >> 2] = HEAP32[i77 + 16 + (i2 << 2) >> 2];
     HEAP32[i3 + 108 >> 2] = HEAP32[i401 + (i2 << 2) >> 2];
     HEAP32[i3 + 112 >> 2] = HEAP32[i111 + (i2 << 2) >> 2];
     HEAP32[i3 + 116 >> 2] = HEAP32[i112 + (i2 << 2) >> 2];
     HEAP32[i3 + 120 >> 2] = HEAP32[i422 + (i2 << 2) >> 2];
     HEAP32[i3 + 124 >> 2] = HEAP32[i113 + (i2 << 2) >> 2];
     HEAP32[i3 + 128 >> 2] = HEAP32[i114 + (i2 << 2) >> 2];
     HEAP32[i3 + 132 >> 2] = HEAP32[i78 >> 2];
     i78 = i630 + (HEAP32[i629 + (i2 + 12 << 2) >> 2] << 5) | 0;
     HEAP32[i3 + 136 >> 2] = HEAP32[i78 + (i2 << 2) >> 2];
     HEAP32[i3 + 140 >> 2] = HEAP32[i78 + 16 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 4) break; else i3 = i3 + 144 | 0;
    }
    i1 = i1 + 576 | 0;
    break;
   }
  } else {
   f636 = Math_fround(HEAPF32[i377 >> 2]);
   f636 = Math_fround(f636 - Math_fround(HEAPF32[i608 >> 2]));
   f638 = Math_fround(HEAPF32[i378 >> 2]);
   f638 = Math_fround(f638 - Math_fround(HEAPF32[i366 >> 2]));
   f639 = Math_fround(HEAPF32[i379 >> 2]);
   f639 = Math_fround(f639 - Math_fround(HEAPF32[i367 >> 2]));
   f640 = Math_fround(HEAPF32[i380 >> 2]);
   f640 = Math_fround(f640 - Math_fround(HEAPF32[i368 >> 2]));
   f641 = Math_fround(HEAPF32[i381 >> 2]);
   f641 = Math_fround(f641 - Math_fround(HEAPF32[i369 >> 2]));
   f648 = Math_fround(HEAPF32[i382 >> 2]);
   f648 = Math_fround(f648 - Math_fround(HEAPF32[i370 >> 2]));
   f647 = Math_fround(HEAPF32[i383 >> 2]);
   f647 = Math_fround(f647 - Math_fround(HEAPF32[i371 >> 2]));
   f646 = Math_fround(HEAPF32[i384 >> 2]);
   f646 = Math_fround(f646 - Math_fround(HEAPF32[i372 >> 2]));
   f645 = Math_fround(HEAPF32[i385 >> 2]);
   f645 = Math_fround(f645 - Math_fround(HEAPF32[i373 >> 2]));
   f633 = Math_fround(HEAPF32[i386 >> 2]);
   f633 = Math_fround(f633 - Math_fround(HEAPF32[i374 >> 2]));
   f634 = Math_fround(HEAPF32[i387 >> 2]);
   f634 = Math_fround(f634 - Math_fround(HEAPF32[i375 >> 2]));
   f635 = Math_fround(HEAPF32[i388 >> 2]);
   f635 = Math_fround(f635 - Math_fround(HEAPF32[i376 >> 2]));
   f637 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f636 * f636) + Math_fround(f641 * f641)) + Math_fround(f645 * f645)))));
   f644 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f638 * f638) + Math_fround(f648 * f648)) + Math_fround(f633 * f633)))));
   f643 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f639 * f639) + Math_fround(f647 * f647)) + Math_fround(f634 * f634)))));
   f642 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f640 * f640) + Math_fround(f646 * f646)) + Math_fround(f635 * f635)))));
   f638 = Math_fround(f638 * f644);
   f639 = Math_fround(f639 * f643);
   f640 = Math_fround(f640 * f642);
   f641 = Math_fround(f641 * f637);
   f648 = Math_fround(f648 * f644);
   f647 = Math_fround(f647 * f643);
   f646 = Math_fround(f646 * f642);
   f645 = Math_fround(f645 * f637);
   f644 = Math_fround(f633 * f644);
   f643 = Math_fround(f634 * f643);
   f642 = Math_fround(f635 * f642);
   HEAPF32[i611 >> 2] = Math_fround(f636 * f637);
   HEAPF32[i142 >> 2] = f638;
   HEAPF32[i159 >> 2] = f639;
   HEAPF32[i176 >> 2] = f640;
   HEAPF32[i425 >> 2] = f641;
   HEAPF32[i137 >> 2] = f648;
   HEAPF32[i154 >> 2] = f647;
   HEAPF32[i171 >> 2] = f646;
   HEAPF32[i426 >> 2] = f645;
   HEAPF32[i132 >> 2] = f644;
   HEAPF32[i149 >> 2] = f643;
   HEAPF32[i166 >> 2] = f642;
   f642 = Math_fround(f32 * Math_fround(2.0));
   f643 = Math_fround(f33 * Math_fround(2.0));
   f644 = Math_fround(f34 * Math_fround(2.0));
   f645 = Math_fround(f35 * Math_fround(2.0));
   f646 = Math_fround(f36 * Math_fround(2.0));
   f647 = Math_fround(f37 * Math_fround(2.0));
   f648 = Math_fround(f38 * Math_fround(2.0));
   HEAPF32[i612 >> 2] = Math_fround(f31 * Math_fround(2.0));
   HEAPF32[i144 >> 2] = f642;
   HEAPF32[i161 >> 2] = f643;
   HEAPF32[i178 >> 2] = f644;
   HEAPF32[i427 >> 2] = f645;
   HEAPF32[i143 >> 2] = f646;
   HEAPF32[i160 >> 2] = f647;
   HEAPF32[i177 >> 2] = f648;
   HEAP32[i127 >> 2] = 0;
   HEAP32[i127 + 4 >> 2] = 0;
   HEAP32[i127 + 8 >> 2] = 0;
   HEAP32[i127 + 12 >> 2] = 0;
   if (i428) {
    f58 = Math_fround(HEAPF32[i602 >> 2]);
    f646 = Math_fround(f564 * f58);
    f60 = Math_fround(HEAPF32[i232 >> 2]);
    f637 = Math_fround(f564 * f60);
    f62 = Math_fround(HEAPF32[i231 >> 2]);
    f645 = Math_fround(f564 * f62);
    f634 = Math_fround(HEAPF32[i230 >> 2]);
    f640 = Math_fround(f564 * f634);
    f59 = Math_fround(HEAPF32[i429 >> 2]);
    f636 = Math_fround(f567 * f59);
    f61 = Math_fround(HEAPF32[i235 >> 2]);
    f642 = Math_fround(f567 * f61);
    f633 = Math_fround(HEAPF32[i234 >> 2]);
    f641 = Math_fround(f567 * f633);
    f635 = Math_fround(HEAPF32[i233 >> 2]);
    f636 = Math_fround(f646 + f636);
    f642 = Math_fround(f637 + f642);
    f641 = Math_fround(f645 + f641);
    f640 = Math_fround(f640 + Math_fround(f567 * f635));
    f645 = Math_fround(HEAPF32[i430 >> 2]);
    f637 = Math_fround(f570 * f645);
    f646 = Math_fround(HEAPF32[i238 >> 2]);
    f638 = Math_fround(f570 * f646);
    f647 = Math_fround(HEAPF32[i237 >> 2]);
    f639 = Math_fround(f570 * f647);
    f648 = Math_fround(HEAPF32[i236 >> 2]);
    f638 = Math_fround(f642 + f638);
    f639 = Math_fround(f641 + f639);
    f640 = Math_fround(f640 + Math_fround(f570 * f648));
    f641 = Math_fround(Math_fround(Math_fround(f565 * f58) + Math_fround(f568 * f59)) + Math_fround(f571 * f645));
    f642 = Math_fround(Math_fround(Math_fround(f565 * f60) + Math_fround(f568 * f61)) + Math_fround(f571 * f646));
    f643 = Math_fround(Math_fround(Math_fround(f565 * f62) + Math_fround(f568 * f633)) + Math_fround(f571 * f647));
    f644 = Math_fround(Math_fround(Math_fround(f565 * f634) + Math_fround(f568 * f635)) + Math_fround(f571 * f648));
    f645 = Math_fround(Math_fround(Math_fround(f566 * f58) + Math_fround(f569 * f59)) + Math_fround(f572 * f645));
    f646 = Math_fround(Math_fround(Math_fround(f566 * f60) + Math_fround(f569 * f61)) + Math_fround(f572 * f646));
    f647 = Math_fround(Math_fround(Math_fround(f566 * f62) + Math_fround(f569 * f633)) + Math_fround(f572 * f647));
    f648 = Math_fround(Math_fround(Math_fround(f566 * f634) + Math_fround(f569 * f635)) + Math_fround(f572 * f648));
    HEAPF32[i613 >> 2] = Math_fround(f636 + f637);
    HEAPF32[i431 >> 2] = f638;
    HEAPF32[i432 >> 2] = f639;
    HEAPF32[i433 >> 2] = f640;
    HEAPF32[i434 >> 2] = f641;
    HEAPF32[i435 >> 2] = f642;
    HEAPF32[i436 >> 2] = f643;
    HEAPF32[i437 >> 2] = f644;
    HEAPF32[i438 >> 2] = f645;
    HEAPF32[i439 >> 2] = f646;
    HEAPF32[i440 >> 2] = f647;
    HEAPF32[i441 >> 2] = f648;
   }
   if (i442) {
    i72 = HEAP32[i606 >> 2] | 0;
    i75 = i72 + 1068538453 | 0;
    i76 = HEAP32[i266 >> 2] | 0;
    i74 = i76 + 1068538453 | 0;
    i69 = HEAP32[i267 >> 2] | 0;
    i68 = i69 + 1068538453 | 0;
    i67 = HEAP32[i268 >> 2] | 0;
    i71 = i67 + 1068538453 | 0;
    i77 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i74, 1790253981) | 0) + 1900727103 | 0;
    i78 = (Math_imul(i68, 1790253981) | 0) + 1900727103 | 0;
    i73 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i75 = i75 << 11 ^ i75;
    i74 = i74 << 11 ^ i74;
    i68 = i68 << 11 ^ i68;
    i71 = i71 << 11 ^ i71;
    f646 = Math_fround(Math_fround((i70 ^ i74 ^ i74 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f647 = Math_fround(Math_fround((i78 ^ i68 ^ i68 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f648 = Math_fround(Math_fround((i73 ^ i71 ^ i71 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i614 >> 2] = Math_fround(Math_fround((i77 ^ i75 ^ i75 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i443 >> 2] = f646;
    HEAPF32[i444 >> 2] = f647;
    HEAPF32[i445 >> 2] = f648;
    i72 = i72 + 1068538454 | 0;
    i76 = i76 + 1068538454 | 0;
    i69 = i69 + 1068538454 | 0;
    i67 = i67 + 1068538454 | 0;
    i77 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
    i75 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
    i73 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i71 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i72 = i72 << 11 ^ i72;
    i76 = i76 << 11 ^ i76;
    i69 = i69 << 11 ^ i69;
    i67 = i67 << 11 ^ i67;
    f648 = Math_fround(Math_fround((i75 ^ i76 ^ i76 >>> 8) & 8388607 ^ i75 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f647 = Math_fround(Math_fround((i73 ^ i69 ^ i69 >>> 8) & 8388607 ^ i73 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f646 = Math_fround(Math_fround((i71 ^ i67 ^ i67 >>> 8) & 8388607 ^ i71 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i446 >> 2] = Math_fround(Math_fround((i77 ^ i72 ^ i72 >>> 8) & 8388607 ^ i77 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i447 >> 2] = f648;
    HEAPF32[i448 >> 2] = f647;
    HEAPF32[i449 >> 2] = f646;
    i77 = HEAP32[i606 >> 2] | 0;
    i72 = i77 + 1068538455 | 0;
    i71 = HEAP32[i266 >> 2] | 0;
    i67 = i71 + 1068538455 | 0;
    i73 = HEAP32[i267 >> 2] | 0;
    i69 = i73 + 1068538455 | 0;
    i75 = HEAP32[i268 >> 2] | 0;
    i76 = i75 + 1068538455 | 0;
    i78 = (Math_imul(i72, 1790253981) | 0) + 1900727103 | 0;
    i68 = (Math_imul(i67, 1790253981) | 0) + 1900727103 | 0;
    i70 = (Math_imul(i69, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i76, 1790253981) | 0) + 1900727103 | 0;
    i72 = i72 << 11 ^ i72;
    i67 = i67 << 11 ^ i67;
    i69 = i69 << 11 ^ i69;
    i76 = i76 << 11 ^ i76;
    f646 = Math_fround(Math_fround((i68 ^ i67 ^ i67 >>> 8) & 8388607 ^ i68 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f647 = Math_fround(Math_fround((i70 ^ i69 ^ i69 >>> 8) & 8388607 ^ i70 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f648 = Math_fround(Math_fround((i74 ^ i76 ^ i76 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i450 >> 2] = Math_fround(Math_fround((i78 ^ i72 ^ i72 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i451 >> 2] = f646;
    HEAPF32[i452 >> 2] = f647;
    HEAPF32[i453 >> 2] = f648;
    f648 = Math_fround(Math_fround(HEAPF32[i605 >> 2]) * Math_fround(1.0e5));
    f647 = Math_fround(Math_fround(HEAPF32[i262 >> 2]) * Math_fround(1.0e5));
    f646 = Math_fround(Math_fround(HEAPF32[i263 >> 2]) * Math_fround(1.0e5));
    i77 = i77 + 1068538453 + ~~f648 | 0;
    i71 = i71 + 1068538453 + ~~f647 | 0;
    i73 = i73 + 1068538453 + ~~f646 | 0;
    i75 = i75 + 1068538453 + ~~Math_fround(Math_fround(HEAPF32[i264 >> 2]) * Math_fround(1.0e5)) | 0;
    i78 = (Math_imul(i77, 1790253981) | 0) + 1900727103 | 0;
    i72 = (Math_imul(i71, 1790253981) | 0) + 1900727103 | 0;
    i74 = (Math_imul(i73, 1790253981) | 0) + 1900727103 | 0;
    i76 = (Math_imul(i75, 1790253981) | 0) + 1900727103 | 0;
    i77 = i77 << 11 ^ i77;
    i71 = i71 << 11 ^ i71;
    i73 = i73 << 11 ^ i73;
    i75 = i75 << 11 ^ i75;
    f646 = Math_fround(Math_fround((i72 ^ i71 ^ i71 >>> 8) & 8388607 ^ i72 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f647 = Math_fround(Math_fround((i74 ^ i73 ^ i73 >>> 8) & 8388607 ^ i74 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f648 = Math_fround(Math_fround((i76 ^ i75 ^ i75 >>> 8) & 8388607 ^ i76 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i454 >> 2] = Math_fround(Math_fround((i78 ^ i77 ^ i77 >>> 8) & 8388607 ^ i78 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i455 >> 2] = f646;
    HEAPF32[i456 >> 2] = f647;
    HEAPF32[i457 >> 2] = f648;
   }
   i69 = HEAP32[i239 >> 2] | 0;
   i70 = (i69 | 0) == 0;
   i71 = HEAP32[i119 >> 2] | 0;
   i72 = HEAP32[i121 >> 2] | 0;
   i73 = HEAP32[i261 >> 2] | 0;
   i74 = HEAP32[i122 >> 2] | 0;
   i75 = HEAP32[i242 >> 2] | 0;
   i76 = HEAP32[i243 >> 2] | 0;
   i77 = HEAP32[i244 >> 2] | 0;
   i78 = HEAP32[i627 >> 2] | 0;
   i68 = 0;
   do {
    i2 = i68 + i79 | 0;
    if (!i70) i2 = HEAP32[i69 + (i2 << 3) >> 2] | 0;
    i5 = i613 + (i68 << 2) | 0;
    i6 = i465 + (i68 << 2) | 0;
    i7 = i466 + (i68 << 2) | 0;
    i8 = i614 + (i68 << 2) | 0;
    i9 = i446 + (i68 << 2) | 0;
    i10 = i450 + (i68 << 2) | 0;
    i11 = i454 + (i68 << 2) | 0;
    i13 = i611 + (i68 << 2) | 0;
    i14 = i116 + (i68 << 2) | 0;
    i15 = i117 + (i68 << 2) | 0;
    i16 = i71 + (i2 << 4) | 0;
    i17 = i72 + (i2 << 4) | 0;
    i18 = i73 + (i2 << 2) | 0;
    i19 = i74 + (i2 << 2) | 0;
    i20 = i75 + (i2 << 2) | 0;
    i21 = i76 + (i2 << 2) | 0;
    i22 = i77 + (i2 << 2) | 0;
    i23 = i612 + (i68 << 2) | 0;
    i63 = i123 + (i68 << 2) | 0;
    i64 = i124 + (i68 << 2) | 0;
    i65 = i609 + (i68 << 2) | 0;
    i66 = i125 + (i68 << 2) | 0;
    i67 = i126 + (i68 << 2) | 0;
    i4 = i78 + (i2 << 2) | 0;
    i3 = 0;
    i2 = i1;
    while (1) {
     i1 = i608 + (i3 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i1 + (i68 << 2) >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 + (i68 << 2) >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 32 + (i68 << 2) >> 2];
     i1 = i2 + 12 | 0;
     if (!i458) {
      i649 = i610 + (i3 * 48 | 0) | 0;
      HEAP32[i1 >> 2] = HEAP32[i649 + (i68 << 2) >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i649 + 16 + (i68 << 2) >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i649 + 32 + (i68 << 2) >> 2];
      i1 = i2 + 24 | 0;
     }
     if (!i459) {
      HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
      i1 = i1 + 4 | 0;
     }
     if (!i460) {
      i649 = i630 + (HEAP32[i629 + ((i3 << 2) + i68 << 2) >> 2] << 5) | 0;
      HEAP32[i1 >> 2] = HEAP32[i649 + (i68 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i649 + 16 + (i68 << 2) >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i461) {
      i649 = i631 + (HEAP32[i629 + ((i3 << 2) + i68 << 2) >> 2] << 6) | 0;
      HEAP32[i1 >> 2] = HEAP32[i649 + (i68 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i649 + 16 + (i68 << 2) >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i649 + 32 + (i68 << 2) >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i649 + 48 + (i68 << 2) >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i462) {
      f648 = Math_fround(i3 | 0);
      HEAP32[i1 >> 2] = HEAP32[i65 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i66 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i67 >> 2];
      HEAPF32[i1 + 12 >> 2] = f648;
      i1 = i1 + 16 | 0;
     }
     if (!i463) {
      HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i63 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i64 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i464) {
      i2 = HEAP32[i21 >> 2] | 0;
      i649 = HEAP32[i22 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = i2;
      HEAP32[i1 + 8 >> 2] = i649;
      i1 = i1 + 12 | 0;
     }
     if (i428) {
      HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 >> 2];
      i1 = i1 + 12 | 0;
     }
     if (!i467) {
      f648 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.00999999977));
      i649 = HEAP32[i19 >> 2] | 0;
      HEAPF32[i1 >> 2] = f648;
      HEAP32[i1 + 4 >> 2] = i649;
      i1 = i1 + 8 | 0;
     }
     if (!i468) {
      i649 = (HEAP32[i120 >> 2] & 2147483647 | 0) == 0 ? i599 : i17;
      HEAP32[i1 >> 2] = HEAP32[i649 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i649 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i649 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i649 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i469) {
      i649 = (HEAP32[i118 >> 2] & 2147483647 | 0) == 0 ? i599 : i16;
      HEAP32[i1 >> 2] = HEAP32[i649 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i649 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i649 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i649 + 12 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (i442) {
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
      i1 = i1 + 16 | 0;
     }
     if (!i115) {
      HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i15 >> 2];
      HEAPF32[i1 + 12 >> 2] = Math_fround(-1.0);
      i1 = i1 + 16 | 0;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 4) break; else i2 = i1;
    }
    i68 = i68 + 1 | 0;
   } while ((i68 | 0) != 4);
  } while (0);
  i79 = i79 + 4 | 0;
 } while (i79 >>> 0 < i207 >>> 0);
 STACKTOP = i632;
 return;
}

function __ZL32TransformParticleMeshAnimatedUVsILb0EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i2, i89, i1, i86, i25, i27, i28, i29, i87, i91) {
 i2 = i2 | 0;
 i89 = i89 | 0;
 i1 = i1 | 0;
 i86 = i86 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i87 = i87 | 0;
 i91 = i91 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i88 = 0, i90 = 0, i92 = 0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i92 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i92 + 64 | 0;
 i6 = i92 + 48 | 0;
 i24 = i92 + 40 | 0;
 i13 = i92 + 32 | 0;
 i90 = i92;
 i85 = HEAP32[i1 >> 2] | 0;
 i30 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = (i86 & 8 | 0) == 0;
 i2 = (i86 & 4 | 0) == 0;
 i88 = i25 & 65535;
 if (!(i86 & 2)) {
  if (i1) {
   if (i2) {
    HEAPF32[i4 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
    i5 = i30 + 8 | 0;
    i6 = HEAP32[i30 + 92 >> 2] | 0;
    i1 = (i6 | 0) == 0;
    if (i1) {
     i9 = 0;
     i68 = 1;
    } else if (!(HEAP8[i30 + 11 >> 0] | 0)) {
     i9 = 0;
     i68 = 1;
    } else {
     i9 = HEAP16[i5 >> 1] | 0;
     i9 = i6 + (((i9 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i9 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i68 = HEAPU8[i5 + 32 + ((HEAPU8[i5 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    HEAP32[i90 >> 2] = 0;
    HEAP32[i90 + 4 >> 2] = 1;
    HEAP32[i90 + 8 >> 2] = 0;
    HEAP32[i90 + 12 >> 2] = 1;
    HEAP32[i90 + 16 >> 2] = 0;
    HEAP32[i90 + 20 >> 2] = 1;
    HEAP32[i90 + 24 >> 2] = 0;
    HEAP32[i90 + 28 >> 2] = 1;
    i67 = i25 << 16 >> 16 == 0;
    L11 : do if (!i67) {
     if (i1) {
      i1 = 0;
      while (1) {
       HEAP32[i90 + (i1 << 3) >> 2] = i4;
       HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i88 | 0)) break L11;
      }
     } else i3 = 0;
     do {
      i2 = i90 + (i3 << 3) | 0;
      i1 = i3 + 3 | 0;
      if (!(HEAP8[i5 + (i1 << 2) + 3 >> 0] | 0)) {
       HEAP32[i2 >> 2] = 0;
       i1 = i90 + (i3 << 3) + 4 | 0;
       HEAP32[i1 >> 2] = 1;
       i26 = 399;
      } else {
       i84 = HEAPU8[i5 + 32 + ((HEAPU8[i5 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i85 = HEAP16[i5 + (i1 << 2) >> 1] | 0;
       i85 = i6 + (((i85 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i85 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
       HEAP32[i2 >> 2] = i85;
       i1 = i90 + (i3 << 3) + 4 | 0;
       HEAP32[i1 >> 2] = i84;
       if (!i85) i26 = 399;
      }
      if ((i26 | 0) == 399) {
       i26 = 0;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i1 >> 2] = 0;
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i88 | 0));
    } while (0);
    f56 = Math_fround(HEAPF32[i27 >> 2]);
    f57 = Math_fround(HEAPF32[i27 + 4 >> 2]);
    f58 = Math_fround(HEAPF32[i27 + 8 >> 2]);
    f59 = Math_fround(HEAPF32[i27 + 16 >> 2]);
    f60 = Math_fround(HEAPF32[i27 + 20 >> 2]);
    f61 = Math_fround(HEAPF32[i27 + 24 >> 2]);
    f62 = Math_fround(HEAPF32[i27 + 32 >> 2]);
    f63 = Math_fround(HEAPF32[i27 + 36 >> 2]);
    f64 = Math_fround(HEAPF32[i27 + 40 >> 2]);
    i65 = HEAP32[i27 + 48 >> 2] | 0;
    i66 = HEAP32[i27 + 52 >> 2] | 0;
    i55 = HEAP32[i27 + 56 >> 2] | 0;
    f21 = Math_fround(HEAPF32[i28 >> 2]);
    f17 = Math_fround(HEAPF32[i28 + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i28 + 8 >> 2]);
    f20 = Math_fround(HEAPF32[i28 + 12 >> 2]);
    f15 = Math_fround(HEAPF32[i28 + 16 >> 2]);
    f16 = Math_fround(HEAPF32[i28 + 20 >> 2]);
    f19 = Math_fround(HEAPF32[i28 + 24 >> 2]);
    f14 = Math_fround(HEAPF32[i28 + 28 >> 2]);
    f12 = Math_fround(HEAPF32[i28 + 32 >> 2]);
    f54 = Math_fround(HEAPF32[i29 >> 2]);
    f53 = Math_fround(HEAPF32[i29 + 4 >> 2]);
    f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
    i1 = HEAP32[i91 >> 2] | 0;
    i52 = i86 >>> 0 > 63;
    if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
     i44 = 0;
     i46 = 0;
     i48 = 0;
     i51 = 0;
    } else {
     i51 = HEAP32[i87 + 828 >> 2] | 0;
     i44 = HEAP32[i51 + (i89 << 4) >> 2] | 0;
     i46 = HEAP32[i51 + (i89 << 4) + 4 >> 2] | 0;
     i48 = HEAP32[i51 + (i89 << 4) + 8 >> 2] | 0;
     i51 = HEAP32[i51 + (i89 << 4) + 12 >> 2] | 0;
    }
    if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
     i43 = 0;
     i45 = 0;
     i47 = 0;
     i50 = 0;
    } else {
     i50 = HEAP32[i87 + 848 >> 2] | 0;
     i43 = HEAP32[i50 + (i89 << 4) >> 2] | 0;
     i45 = HEAP32[i50 + (i89 << 4) + 4 >> 2] | 0;
     i47 = HEAP32[i50 + (i89 << 4) + 8 >> 2] | 0;
     i50 = HEAP32[i50 + (i89 << 4) + 12 >> 2] | 0;
    }
    if (i52) {
     if (!(i86 & 512)) {
      i2 = 0;
      i3 = 0;
      i4 = 0;
     } else {
      f74 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
      f73 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
      f75 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
      f94 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
      f93 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
      f94 = Math_fround(f74 + f94);
      f93 = Math_fround(f73 + f93);
      f75 = Math_fround(f75 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
      f73 = Math_fround(Math_fround(f21 * f94) + Math_fround(Math_fround(f20 * f93) + Math_fround(f19 * f75)));
      f74 = Math_fround(Math_fround(f17 * f94) + Math_fround(Math_fround(f15 * f93) + Math_fround(f14 * f75)));
      f75 = Math_fround(Math_fround(f18 * f94) + Math_fround(Math_fround(f16 * f93) + Math_fround(f12 * f75)));
      i2 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
     }
     if (!(i86 & 8192)) {
      i42 = 0;
      i41 = 0;
      i40 = 0;
      i39 = 0;
     } else {
      i82 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
      i84 = i82 + 1 | 0;
      i39 = i82 + 2 | 0;
      i41 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i82 | 0;
      i83 = (Math_imul(i82, 1790253981) | 0) + 1900727103 | 0;
      i85 = (Math_imul(i84, 1790253981) | 0) + 1900727103 | 0;
      i40 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
      i42 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
      i82 = i82 << 11 ^ i82;
      i84 = i84 << 11 ^ i84;
      i39 = i39 << 11 ^ i39;
      i41 = i41 << 11 ^ i41;
      f74 = Math_fround(Math_fround((i83 ^ i82 ^ i82 >>> 8) & 8388607 ^ i83 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f75 = Math_fround(Math_fround((i85 ^ i84 ^ i84 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f93 = Math_fround(Math_fround((i40 ^ i39 ^ i39 >>> 8) & 8388607 ^ i40 >>> 19 | 0) * Math_fround(1.19209304e-07));
      f94 = Math_fround(Math_fround((i42 ^ i41 ^ i41 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
      i42 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
      i41 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
      i40 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
      i39 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
     }
    } else {
     i42 = 0;
     i2 = 0;
     i41 = 0;
     i3 = 0;
     i40 = 0;
     i4 = 0;
     i39 = 0;
    }
    i27 = HEAP32[i30 + 100 >> 2] | 0;
    if (i27) {
     f12 = (HEAP32[tempDoublePtr >> 2] = i65, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = (HEAP32[tempDoublePtr >> 2] = i66, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i28 = (i86 & 64 | 0) == 0;
     i29 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
     i30 = (i86 & 128 | 0) != 0;
     i31 = i87 + 420 | 0;
     i32 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
     i33 = (i86 & 256 | 0) != 0;
     i34 = i87 + 340 | 0;
     i35 = (i86 & 512 | 0) == 0;
     i36 = (i86 & 1024 | 0) == 0;
     i37 = (i86 & 2048 | 0) == 0;
     i38 = (i86 & 4096 | 0) == 0;
     i13 = (i86 & 8192 | 0) == 0;
     i22 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
     i23 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
     i24 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
     i25 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
     i26 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
     i11 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
     i10 = 0;
     do {
      f73 = Math_fround(HEAPF32[i9 >> 2]);
      f74 = Math_fround(HEAPF32[i9 + 4 >> 2]);
      f73 = Math_fround(f54 + f73);
      f74 = Math_fround(f53 + f74);
      f75 = Math_fround(f49 + Math_fround(HEAPF32[i9 + 8 >> 2]));
      f93 = Math_fround(Math_fround(Math_fround(f57 * f73) + Math_fround(f60 * f74)) + Math_fround(f14 + Math_fround(f63 * f75)));
      f94 = Math_fround(Math_fround(Math_fround(f58 * f73) + Math_fround(f61 * f74)) + Math_fround(f15 + Math_fround(f64 * f75)));
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f56 * f73) + Math_fround(f59 * f74)) + Math_fround(f12 + Math_fround(f62 * f75)));
      HEAPF32[i1 + 4 >> 2] = f93;
      HEAPF32[i1 + 8 >> 2] = f94;
      i9 = i9 + i68 | 0;
      i1 = i1 + 12 | 0;
      if (!i67) {
       i8 = 0;
       do {
        i6 = i90 + (i8 << 3) | 0;
        i7 = HEAP32[i6 >> 2] | 0;
        HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
        i5 = i1 + 8 | 0;
        HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
        if ((i8 | 0) == 1) {
         HEAPF32[i5 >> 2] = Math_fround(0.0);
         HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
         i1 = i1 + 16 | 0;
        } else i1 = i5;
        HEAP32[i6 >> 2] = i7 + (HEAP32[i90 + (i8 << 3) + 4 >> 2] | 0);
        i8 = i8 + 1 | 0;
       } while ((i8 | 0) != (i88 | 0));
      }
      do if (i52) {
       if (!i28) {
        HEAP32[i1 >> 2] = i65;
        HEAP32[i1 + 4 >> 2] = i66;
        HEAP32[i1 + 8 >> 2] = i55;
        HEAPF32[i1 + 12 >> 2] = Math_fround(i10 | 0);
        i1 = i1 + 16 | 0;
       }
       do if (i29) {
        if (!i30) break;
        i87 = (HEAP32[i31 >> 2] | 0) + (i89 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
        i1 = i1 + 12 | 0;
       } else {
        if (!i30) break;
        i86 = HEAP32[i26 >> 2] | 0;
        i87 = HEAP32[i11 >> 2] | 0;
        HEAP32[i1 >> 2] = HEAP32[(HEAP32[i31 >> 2] | 0) + (i89 << 2) >> 2];
        HEAP32[i1 + 4 >> 2] = i86;
        HEAP32[i1 + 8 >> 2] = i87;
        i1 = i1 + 12 | 0;
       } while (0);
       do if (i32) {
        if (!i33) break;
        i87 = (HEAP32[i34 >> 2] | 0) + (i89 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
        i1 = i1 + 12 | 0;
       } else {
        if (!i33) break;
        i86 = HEAP32[i25 >> 2] | 0;
        i87 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i89 << 2) >> 2] | 0;
        HEAP32[i1 >> 2] = HEAP32[i24 >> 2];
        HEAP32[i1 + 4 >> 2] = i86;
        HEAP32[i1 + 8 >> 2] = i87;
        i1 = i1 + 12 | 0;
       } while (0);
       if (!i35) {
        HEAP32[i1 >> 2] = i2;
        HEAP32[i1 + 4 >> 2] = i3;
        HEAP32[i1 + 8 >> 2] = i4;
        i1 = i1 + 12 | 0;
       }
       if (!i36) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(.00999999977));
        HEAP32[i1 + 4 >> 2] = HEAP32[i23 >> 2];
        i1 = i1 + 8 | 0;
       }
       if (!i37) {
        HEAP32[i1 >> 2] = i44;
        HEAP32[i1 + 4 >> 2] = i46;
        HEAP32[i1 + 8 >> 2] = i48;
        HEAP32[i1 + 12 >> 2] = i51;
        i1 = i1 + 16 | 0;
       }
       if (!i38) {
        HEAP32[i1 >> 2] = i43;
        HEAP32[i1 + 4 >> 2] = i45;
        HEAP32[i1 + 8 >> 2] = i47;
        HEAP32[i1 + 12 >> 2] = i50;
        i1 = i1 + 16 | 0;
       }
       if (i13) break;
       HEAP32[i1 >> 2] = i42;
       HEAP32[i1 + 4 >> 2] = i41;
       HEAP32[i1 + 8 >> 2] = i40;
       HEAP32[i1 + 12 >> 2] = i39;
       i1 = i1 + 16 | 0;
      } while (0);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i27 | 0));
    }
    HEAP32[i91 >> 2] = i1;
    STACKTOP = i92;
    return;
   };
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i30 + 8 | 0;
   i8 = HEAP32[i30 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i70 = 0;
    i1 = 1;
    i2 = 1;
   } else {
    if (!(HEAP8[i30 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i30 + 39 >> 0] | 0)) {
     i3 = 0;
     i70 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i30 + 36 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i70 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i30 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i90 >> 2] = 0;
   HEAP32[i90 + 4 >> 2] = 1;
   HEAP32[i90 + 8 >> 2] = 0;
   HEAP32[i90 + 12 >> 2] = 1;
   HEAP32[i90 + 16 >> 2] = 0;
   HEAP32[i90 + 20 >> 2] = 1;
   HEAP32[i90 + 24 >> 2] = 0;
   HEAP32[i90 + 28 >> 2] = 1;
   i77 = (i3 | 0) == 0;
   i45 = i77 ? i4 : i3;
   i77 = i77 ? 0 : i1;
   i76 = i25 << 16 >> 16 == 0;
   L90 : do if (!i76) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i90 + (i1 << 3) >> 2] = i6;
      HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i88 | 0)) break L90;
     }
    } else i4 = 0;
    do {
     i3 = i90 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 348;
     } else {
      i84 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i85 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i85 = i8 + (((i85 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i85 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i85;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i84;
      if (!i85) i26 = 348;
     }
     if ((i26 | 0) == 348) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i88 | 0));
   } while (0);
   f59 = Math_fround(HEAPF32[i27 >> 2]);
   f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i71 = HEAP32[i27 + 48 >> 2] | 0;
   i72 = HEAP32[i27 + 52 >> 2] | 0;
   i69 = HEAP32[i27 + 56 >> 2] | 0;
   i6 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i28 + 4 >> 2] | 0;
   i8 = HEAP32[i28 + 8 >> 2] | 0;
   i13 = HEAP32[i28 + 12 >> 2] | 0;
   i22 = HEAP32[i28 + 16 >> 2] | 0;
   i23 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = HEAP32[i28 + 24 >> 2] | 0;
   i10 = HEAP32[i28 + 28 >> 2] | 0;
   i11 = HEAP32[i28 + 32 >> 2] | 0;
   f58 = Math_fround(HEAPF32[i29 >> 2]);
   f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i91 >> 2] | 0;
   i68 = i86 >>> 0 > 63;
   if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
    i50 = 0;
    i52 = 0;
    i65 = 0;
    i67 = 0;
   } else {
    i67 = HEAP32[i87 + 828 >> 2] | 0;
    i50 = HEAP32[i67 + (i89 << 4) >> 2] | 0;
    i52 = HEAP32[i67 + (i89 << 4) + 4 >> 2] | 0;
    i65 = HEAP32[i67 + (i89 << 4) + 8 >> 2] | 0;
    i67 = HEAP32[i67 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
    i48 = 0;
    i51 = 0;
    i55 = 0;
    i66 = 0;
   } else {
    i66 = HEAP32[i87 + 848 >> 2] | 0;
    i48 = HEAP32[i66 + (i89 << 4) >> 2] | 0;
    i51 = HEAP32[i66 + (i89 << 4) + 4 >> 2] | 0;
    i55 = HEAP32[i66 + (i89 << 4) + 8 >> 2] | 0;
    i66 = HEAP32[i66 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (i68) {
    if (!(i86 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f20 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
     f18 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
     f94 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
     f49 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
     f53 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
     f49 = Math_fround(f20 + f49);
     f53 = Math_fround(f18 + f53);
     f94 = Math_fround(f94 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
     f18 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f18 = Math_fround(f18 * f49);
     f20 = Math_fround(f20 * f49);
     f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f49);
     f54 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f93 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f54 = Math_fround(f54 * f94);
     f93 = Math_fround(f93 * f94);
     f94 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94);
     f19 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f21 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f54 = Math_fround(f18 + Math_fround(Math_fround(f19 * f53) + f54));
     f93 = Math_fround(f20 + Math_fround(Math_fround(f21 * f53) + f93));
     f94 = Math_fround(f49 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f53) + f94));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i86 & 8192)) {
     i47 = 0;
     i46 = 0;
     i44 = 0;
     i43 = 0;
    } else {
     i82 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
     i84 = i82 + 1 | 0;
     i43 = i82 + 2 | 0;
     i46 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i82 | 0;
     i83 = (Math_imul(i82, 1790253981) | 0) + 1900727103 | 0;
     i85 = (Math_imul(i84, 1790253981) | 0) + 1900727103 | 0;
     i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
     i47 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
     i82 = i82 << 11 ^ i82;
     i84 = i84 << 11 ^ i84;
     i43 = i43 << 11 ^ i43;
     i46 = i46 << 11 ^ i46;
     f53 = Math_fround(Math_fround((i83 ^ i82 ^ i82 >>> 8) & 8388607 ^ i83 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f54 = Math_fround(Math_fround((i85 ^ i84 ^ i84 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f93 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f94 = Math_fround(Math_fround((i47 ^ i46 ^ i46 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i47 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
     i46 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
     i44 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0);
     i43 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i47 = 0;
    i3 = 0;
    i46 = 0;
    i4 = 0;
    i44 = 0;
    i5 = 0;
    i43 = 0;
   }
   i31 = HEAP32[i30 + 100 >> 2] | 0;
   if (i31) {
    f49 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i32 = (i86 & 64 | 0) == 0;
    i33 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
    i34 = (i86 & 128 | 0) != 0;
    i35 = i87 + 420 | 0;
    i36 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
    i37 = (i86 & 256 | 0) != 0;
    i38 = i87 + 340 | 0;
    i39 = (i86 & 512 | 0) == 0;
    i40 = (i86 & 1024 | 0) == 0;
    i41 = (i86 & 2048 | 0) == 0;
    i42 = (i86 & 4096 | 0) == 0;
    i25 = (i86 & 8192 | 0) == 0;
    i26 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
    i27 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
    i28 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
    i29 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
    i30 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
    i24 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
    f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i13 = 0;
    i11 = i45;
    i10 = i70;
    while (1) {
     f97 = Math_fround(HEAPF32[i10 >> 2]);
     f96 = Math_fround(HEAPF32[i10 + 4 >> 2]);
     f97 = Math_fround(f58 + f97);
     f96 = Math_fround(f57 + f96);
     f95 = Math_fround(f56 + Math_fround(HEAPF32[i10 + 8 >> 2]));
     f93 = Math_fround(Math_fround(Math_fround(f60 * f97) + Math_fround(f63 * f96)) + Math_fround(f53 + Math_fround(f74 * f95)));
     f94 = Math_fround(Math_fround(Math_fround(f61 * f97) + Math_fround(f64 * f96)) + Math_fround(f54 + Math_fround(f75 * f95)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f97) + Math_fround(f62 * f96)) + Math_fround(f49 + Math_fround(f73 * f95)));
     HEAPF32[i1 + 4 >> 2] = f93;
     HEAPF32[i1 + 8 >> 2] = f94;
     i10 = i10 + i2 | 0;
     i1 = i1 + 12 | 0;
     if (!i76) {
      i9 = 0;
      do {
       i7 = i90 + (i9 << 3) | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
       i6 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       if ((i9 | 0) == 1) {
        HEAPF32[i6 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i6;
       HEAP32[i7 >> 2] = i8 + (HEAP32[i90 + (i9 << 3) + 4 >> 2] | 0);
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i88 | 0));
     }
     do if (i68) {
      if (!i32) {
       HEAP32[i1 >> 2] = i71;
       HEAP32[i1 + 4 >> 2] = i72;
       HEAP32[i1 + 8 >> 2] = i69;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i13 | 0);
       i1 = i1 + 16 | 0;
      }
      if (i33) {
       if (i34) {
        i87 = (HEAP32[i35 >> 2] | 0) + (i89 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i34) {
       i86 = HEAP32[i30 >> 2] | 0;
       i87 = HEAP32[i24 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i35 >> 2] | 0) + (i89 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      }
      do if (i36) {
       if (!i37) break;
       i87 = (HEAP32[i38 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i37) break;
       i86 = HEAP32[i29 >> 2] | 0;
       i87 = HEAP32[(HEAP32[i38 >> 2] | 0) + (i89 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i39) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i40) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[i27 >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i41) {
       HEAP32[i1 >> 2] = i50;
       HEAP32[i1 + 4 >> 2] = i52;
       HEAP32[i1 + 8 >> 2] = i65;
       HEAP32[i1 + 12 >> 2] = i67;
       i1 = i1 + 16 | 0;
      }
      if (!i42) {
       HEAP32[i1 >> 2] = i48;
       HEAP32[i1 + 4 >> 2] = i51;
       HEAP32[i1 + 8 >> 2] = i55;
       HEAP32[i1 + 12 >> 2] = i66;
       i1 = i1 + 16 | 0;
      }
      if (i25) break;
      HEAP32[i1 >> 2] = i47;
      HEAP32[i1 + 4 >> 2] = i46;
      HEAP32[i1 + 8 >> 2] = i44;
      HEAP32[i1 + 12 >> 2] = i43;
      i1 = i1 + 16 | 0;
     } while (0);
     i87 = i11;
     f93 = Math_fround(HEAPF32[i87 >> 2]);
     f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
     f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
     f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
     f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
     HEAPF32[i1 + 4 >> 2] = f96;
     HEAPF32[i1 + 8 >> 2] = f97;
     HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     i1 = i1 + 16 | 0;
     i13 = i13 + 1 | 0;
     if ((i13 | 0) == (i31 | 0)) break; else i11 = i11 + i77 | 0;
    }
   }
   HEAP32[i91 >> 2] = i1;
   STACKTOP = i92;
   return;
  }
  if (i2) {
   HEAP32[i4 >> 2] = -1;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i30 + 8 | 0;
   i8 = HEAP32[i30 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i10 = 0;
    i2 = 1;
    i1 = 1;
   } else {
    if (!(HEAP8[i30 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i30 + 19 >> 0] | 0)) {
     i3 = 0;
     i10 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i30 + 16 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i10 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i30 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i90 >> 2] = 0;
   HEAP32[i90 + 4 >> 2] = 1;
   HEAP32[i90 + 8 >> 2] = 0;
   HEAP32[i90 + 12 >> 2] = 1;
   HEAP32[i90 + 16 >> 2] = 0;
   HEAP32[i90 + 20 >> 2] = 1;
   HEAP32[i90 + 24 >> 2] = 0;
   HEAP32[i90 + 28 >> 2] = 1;
   i77 = (i3 | 0) == 0;
   i11 = i77 ? i4 : i3;
   i77 = i77 ? 0 : i1;
   i76 = i25 << 16 >> 16 == 0;
   L171 : do if (!i76) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i90 + (i1 << 3) >> 2] = i6;
      HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i88 | 0)) break L171;
     }
    } else i4 = 0;
    do {
     i3 = i90 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 294;
     } else {
      i83 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i84 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i84 = i8 + (((i84 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i84 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i84;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i83;
      if (!i84) i26 = 294;
     }
     if ((i26 | 0) == 294) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i88 | 0));
   } while (0);
   f56 = Math_fround(HEAPF32[i27 >> 2]);
   f57 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f58 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f59 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f60 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f61 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f62 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i71 = HEAP32[i27 + 48 >> 2] | 0;
   i72 = HEAP32[i27 + 52 >> 2] | 0;
   i70 = HEAP32[i27 + 56 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i28 >> 2]);
   f17 = Math_fround(HEAPF32[i28 + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i28 + 8 >> 2]);
   f20 = Math_fround(HEAPF32[i28 + 12 >> 2]);
   f15 = Math_fround(HEAPF32[i28 + 16 >> 2]);
   f16 = Math_fround(HEAPF32[i28 + 20 >> 2]);
   f19 = Math_fround(HEAPF32[i28 + 24 >> 2]);
   f14 = Math_fround(HEAPF32[i28 + 28 >> 2]);
   f12 = Math_fround(HEAPF32[i28 + 32 >> 2]);
   f54 = Math_fround(HEAPF32[i29 >> 2]);
   f53 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i91 >> 2] | 0;
   i69 = i86 >>> 0 > 63;
   if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
    i51 = 0;
    i55 = 0;
    i66 = 0;
    i68 = 0;
   } else {
    i68 = HEAP32[i87 + 828 >> 2] | 0;
    i51 = HEAP32[i68 + (i89 << 4) >> 2] | 0;
    i55 = HEAP32[i68 + (i89 << 4) + 4 >> 2] | 0;
    i66 = HEAP32[i68 + (i89 << 4) + 8 >> 2] | 0;
    i68 = HEAP32[i68 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
    i50 = 0;
    i52 = 0;
    i65 = 0;
    i67 = 0;
   } else {
    i67 = HEAP32[i87 + 848 >> 2] | 0;
    i50 = HEAP32[i67 + (i89 << 4) >> 2] | 0;
    i52 = HEAP32[i67 + (i89 << 4) + 4 >> 2] | 0;
    i65 = HEAP32[i67 + (i89 << 4) + 8 >> 2] | 0;
    i67 = HEAP32[i67 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (i69) {
    if (!(i86 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f96 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
     f95 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
     f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
     f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
     f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
     f93 = Math_fround(f96 + f93);
     f94 = Math_fround(f95 + f94);
     f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
     f95 = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f20 * f94) + Math_fround(f19 * f97)));
     f96 = Math_fround(Math_fround(f17 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f14 * f97)));
     f97 = Math_fround(Math_fround(f18 * f93) + Math_fround(Math_fround(f16 * f94) + Math_fround(f12 * f97)));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i86 & 8192)) {
     i48 = 0;
     i47 = 0;
     i46 = 0;
     i45 = 0;
    } else {
     i81 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
     i83 = i81 + 1 | 0;
     i45 = i81 + 2 | 0;
     i47 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i81 | 0;
     i82 = (Math_imul(i81, 1790253981) | 0) + 1900727103 | 0;
     i84 = (Math_imul(i83, 1790253981) | 0) + 1900727103 | 0;
     i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
     i48 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
     i81 = i81 << 11 ^ i81;
     i83 = i83 << 11 ^ i83;
     i45 = i45 << 11 ^ i45;
     i47 = i47 << 11 ^ i47;
     f94 = Math_fround(Math_fround((i82 ^ i81 ^ i81 >>> 8) & 8388607 ^ i82 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f95 = Math_fround(Math_fround((i84 ^ i83 ^ i83 >>> 8) & 8388607 ^ i84 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f96 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f97 = Math_fround(Math_fround((i48 ^ i47 ^ i47 >>> 8) & 8388607 ^ i48 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i48 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
     i47 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
     i46 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
     i45 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i48 = 0;
    i3 = 0;
    i47 = 0;
    i4 = 0;
    i46 = 0;
    i5 = 0;
    i45 = 0;
   }
   i33 = i30 + 100 | 0;
   if (HEAP32[i33 >> 2] | 0) {
    f12 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i34 = (i86 & 64 | 0) == 0;
    i35 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
    i36 = (i86 & 128 | 0) != 0;
    i37 = i87 + 420 | 0;
    i38 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
    i39 = (i86 & 256 | 0) != 0;
    i40 = i87 + 340 | 0;
    i41 = (i86 & 512 | 0) == 0;
    i42 = (i86 & 1024 | 0) == 0;
    i43 = (i86 & 2048 | 0) == 0;
    i44 = (i86 & 4096 | 0) == 0;
    i27 = (i86 & 8192 | 0) == 0;
    i28 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
    i29 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
    i30 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
    i31 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
    i32 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
    i24 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
    i25 = i85 & 255;
    i23 = i85 >>> 8;
    i26 = i23 & 255;
    i22 = i85 & 16711680;
    i23 = i23 & 16711680;
    i13 = 0;
    do {
     f93 = Math_fround(HEAPF32[i10 >> 2]);
     f94 = Math_fround(HEAPF32[i10 + 4 >> 2]);
     f93 = Math_fround(f54 + f93);
     f94 = Math_fround(f53 + f94);
     f95 = Math_fround(f49 + Math_fround(HEAPF32[i10 + 8 >> 2]));
     f96 = Math_fround(Math_fround(Math_fround(f57 * f93) + Math_fround(f60 * f94)) + Math_fround(f14 + Math_fround(f63 * f95)));
     f97 = Math_fround(Math_fround(Math_fround(f58 * f93) + Math_fround(f61 * f94)) + Math_fround(f15 + Math_fround(f64 * f95)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f56 * f93) + Math_fround(f59 * f94)) + Math_fround(f12 + Math_fround(f62 * f95)));
     HEAPF32[i1 + 4 >> 2] = f96;
     HEAPF32[i1 + 8 >> 2] = f97;
     i10 = i10 + i2 | 0;
     i87 = HEAP32[i11 >> 2] | 0;
     HEAP32[i1 + 12 >> 2] = (Math_imul((i87 >>> 8 & 255) + 1 | 0, i26) | 0) & 65280 | (Math_imul((i87 >>> 24) + 1 | 0, i23) | 0) & -16777216 | (Math_imul((i87 & 255) + 1 | 0, i25) | 0) >>> 8 & 255 | (Math_imul((i87 >>> 16 & 255) + 1 | 0, i22) | 0) >>> 8 & 16711680;
     i11 = i11 + i77 | 0;
     i1 = i1 + 16 | 0;
     if (!i76) {
      i9 = 0;
      do {
       i7 = i90 + (i9 << 3) | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
       i6 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       if ((i9 | 0) == 1) {
        HEAPF32[i6 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i6;
       HEAP32[i7 >> 2] = i8 + (HEAP32[i90 + (i9 << 3) + 4 >> 2] | 0);
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i88 | 0));
     }
     do if (i69) {
      if (!i34) {
       HEAP32[i1 >> 2] = i71;
       HEAP32[i1 + 4 >> 2] = i72;
       HEAP32[i1 + 8 >> 2] = i70;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i13 | 0);
       i1 = i1 + 16 | 0;
      }
      if (i35) {
       if (i36) {
        i87 = (HEAP32[i37 >> 2] | 0) + (i89 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i36) {
       i86 = HEAP32[i32 >> 2] | 0;
       i87 = HEAP32[i24 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i37 >> 2] | 0) + (i89 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      }
      do if (i38) {
       if (!i39) break;
       i87 = (HEAP32[i40 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i39) break;
       i86 = HEAP32[i31 >> 2] | 0;
       i87 = HEAP32[(HEAP32[i40 >> 2] | 0) + (i89 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i41) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i42) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[i29 >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i43) {
       HEAP32[i1 >> 2] = i51;
       HEAP32[i1 + 4 >> 2] = i55;
       HEAP32[i1 + 8 >> 2] = i66;
       HEAP32[i1 + 12 >> 2] = i68;
       i1 = i1 + 16 | 0;
      }
      if (!i44) {
       HEAP32[i1 >> 2] = i50;
       HEAP32[i1 + 4 >> 2] = i52;
       HEAP32[i1 + 8 >> 2] = i65;
       HEAP32[i1 + 12 >> 2] = i67;
       i1 = i1 + 16 | 0;
      }
      if (i27) break;
      HEAP32[i1 >> 2] = i48;
      HEAP32[i1 + 4 >> 2] = i47;
      HEAP32[i1 + 8 >> 2] = i46;
      HEAP32[i1 + 12 >> 2] = i45;
      i1 = i1 + 16 | 0;
     } while (0);
     i13 = i13 + 1 | 0;
    } while (i13 >>> 0 < (HEAP32[i33 >> 2] | 0) >>> 0);
   }
   HEAP32[i91 >> 2] = i1;
   STACKTOP = i92;
   return;
  };
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = -1;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i30 + 8 | 0;
  i11 = HEAP32[i30 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 1;
   i5 = 1;
   i7 = 1;
  } else {
   if (!(HEAP8[i30 + 11 >> 0] | 0)) {
    i2 = 0;
    i5 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 39 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i1 = HEAP16[i30 + 36 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 19 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i30 + 16 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i90 >> 2] = 0;
  HEAP32[i90 + 4 >> 2] = 1;
  HEAP32[i90 + 8 >> 2] = 0;
  HEAP32[i90 + 12 >> 2] = 1;
  HEAP32[i90 + 16 >> 2] = 0;
  HEAP32[i90 + 20 >> 2] = 1;
  HEAP32[i90 + 24 >> 2] = 0;
  HEAP32[i90 + 28 >> 2] = 1;
  i81 = (i1 | 0) == 0;
  i72 = i81 ? i4 : i1;
  i81 = i81 ? 0 : i3;
  i80 = (i8 | 0) == 0;
  i47 = i80 ? i6 : i8;
  i80 = i80 ? 0 : i7;
  i79 = i25 << 16 >> 16 == 0;
  L253 : do if (!i79) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i90 + (i1 << 3) >> 2] = i6;
     HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i88 | 0)) break L253;
    }
   } else i4 = 0;
   do {
    i3 = i90 + (i4 << 3) | 0;
    i1 = i4 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i3 >> 2] = 0;
     i1 = i90 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 241;
    } else {
     i83 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i84 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i84 = i11 + (((i84 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i84 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i3 >> 2] = i84;
     i1 = i90 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i83;
     if (!i84) i26 = 241;
    }
    if ((i26 | 0) == 241) {
     i26 = 0;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i88 | 0));
  } while (0);
  f59 = Math_fround(HEAPF32[i27 >> 2]);
  f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i77 = HEAP32[i27 + 48 >> 2] | 0;
  i78 = HEAP32[i27 + 52 >> 2] | 0;
  i76 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i13 = HEAP32[i28 + 32 >> 2] | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i91 >> 2] | 0;
  i71 = i86 >>> 0 > 63;
  if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
   i55 = 0;
   i66 = 0;
   i68 = 0;
   i70 = 0;
  } else {
   i70 = HEAP32[i87 + 828 >> 2] | 0;
   i55 = HEAP32[i70 + (i89 << 4) >> 2] | 0;
   i66 = HEAP32[i70 + (i89 << 4) + 4 >> 2] | 0;
   i68 = HEAP32[i70 + (i89 << 4) + 8 >> 2] | 0;
   i70 = HEAP32[i70 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
   i52 = 0;
   i65 = 0;
   i67 = 0;
   i69 = 0;
  } else {
   i69 = HEAP32[i87 + 848 >> 2] | 0;
   i52 = HEAP32[i69 + (i89 << 4) >> 2] | 0;
   i65 = HEAP32[i69 + (i89 << 4) + 4 >> 2] | 0;
   i67 = HEAP32[i69 + (i89 << 4) + 8 >> 2] | 0;
   i69 = HEAP32[i69 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (i71) {
   if (!(i86 & 512)) {
    i3 = 0;
    i4 = 0;
    i6 = 0;
   } else {
    f53 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
    f21 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
    f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
    f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(f53 + f93);
    f94 = Math_fround(f21 + f94);
    f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
    f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f21 * f93);
    f53 = Math_fround(f53 * f93);
    f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f93);
    f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f96 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f95 * f97);
    f96 = Math_fround(f96 * f97);
    f97 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f97);
    f49 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f21 + Math_fround(Math_fround(f49 * f94) + f95));
    f96 = Math_fround(f53 + Math_fround(Math_fround(f54 * f94) + f96));
    f97 = Math_fround(f93 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94) + f97));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i86 & 8192)) {
    i51 = 0;
    i50 = 0;
    i48 = 0;
    i46 = 0;
   } else {
    i45 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
    i83 = i45 + 1 | 0;
    i46 = i45 + 2 | 0;
    i50 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i45 | 0;
    i82 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i84 = (Math_imul(i83, 1790253981) | 0) + 1900727103 | 0;
    i48 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i45 = i45 << 11 ^ i45;
    i83 = i83 << 11 ^ i83;
    i46 = i46 << 11 ^ i46;
    i50 = i50 << 11 ^ i50;
    f94 = Math_fround(Math_fround((i82 ^ i45 ^ i45 >>> 8) & 8388607 ^ i82 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f95 = Math_fround(Math_fround((i84 ^ i83 ^ i83 >>> 8) & 8388607 ^ i84 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f96 = Math_fround(Math_fround((i48 ^ i46 ^ i46 >>> 8) & 8388607 ^ i48 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f97 = Math_fround(Math_fround((i51 ^ i50 ^ i50 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i51 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
    i50 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i48 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i46 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i51 = 0;
   i3 = 0;
   i50 = 0;
   i4 = 0;
   i48 = 0;
   i6 = 0;
   i46 = 0;
  }
  i34 = i30 + 100 | 0;
  if (HEAP32[i34 >> 2] | 0) {
   f49 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f54 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i35 = (i86 & 64 | 0) == 0;
   i36 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
   i37 = (i86 & 128 | 0) != 0;
   i38 = i87 + 420 | 0;
   i39 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
   i40 = (i86 & 256 | 0) != 0;
   i41 = i87 + 340 | 0;
   i42 = (i86 & 512 | 0) == 0;
   i43 = (i86 & 1024 | 0) == 0;
   i44 = (i86 & 2048 | 0) == 0;
   i45 = (i86 & 4096 | 0) == 0;
   i28 = (i86 & 8192 | 0) == 0;
   i29 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
   i30 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
   i31 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
   i32 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
   i33 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
   i27 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
   f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i25 = i85 & 255;
   i24 = i85 >>> 8;
   i26 = i24 & 255;
   i23 = i85 & 16711680;
   i24 = i24 & 16711680;
   i22 = 0;
   i13 = i47;
   i11 = i72;
   while (1) {
    f93 = Math_fround(HEAPF32[i2 >> 2]);
    f94 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f93 = Math_fround(f58 + f93);
    f94 = Math_fround(f57 + f94);
    f95 = Math_fround(f56 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f96 = Math_fround(Math_fround(Math_fround(f60 * f93) + Math_fround(f63 * f94)) + Math_fround(f53 + Math_fround(f74 * f95)));
    f97 = Math_fround(Math_fround(Math_fround(f61 * f93) + Math_fround(f64 * f94)) + Math_fround(f54 + Math_fround(f75 * f95)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f93) + Math_fround(f62 * f94)) + Math_fround(f49 + Math_fround(f73 * f95)));
    HEAPF32[i1 + 4 >> 2] = f96;
    HEAPF32[i1 + 8 >> 2] = f97;
    i2 = i2 + i5 | 0;
    i87 = HEAP32[i13 >> 2] | 0;
    HEAP32[i1 + 12 >> 2] = (Math_imul((i87 >>> 8 & 255) + 1 | 0, i26) | 0) & 65280 | (Math_imul((i87 >>> 24) + 1 | 0, i24) | 0) & -16777216 | (Math_imul((i87 & 255) + 1 | 0, i25) | 0) >>> 8 & 255 | (Math_imul((i87 >>> 16 & 255) + 1 | 0, i23) | 0) >>> 8 & 16711680;
    i13 = i13 + i80 | 0;
    i1 = i1 + 16 | 0;
    if (!i79) {
     i10 = 0;
     do {
      i8 = i90 + (i10 << 3) | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
      i7 = i1 + 8 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      if ((i10 | 0) == 1) {
       HEAPF32[i7 >> 2] = Math_fround(0.0);
       HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
       i1 = i1 + 16 | 0;
      } else i1 = i7;
      HEAP32[i8 >> 2] = i9 + (HEAP32[i90 + (i10 << 3) + 4 >> 2] | 0);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i88 | 0));
    }
    do if (i71) {
     if (!i35) {
      HEAP32[i1 >> 2] = i77;
      HEAP32[i1 + 4 >> 2] = i78;
      HEAP32[i1 + 8 >> 2] = i76;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
      i1 = i1 + 16 | 0;
     }
     if (i36) {
      if (i37) {
       i87 = (HEAP32[i38 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i37) {
      i86 = HEAP32[i33 >> 2] | 0;
      i87 = HEAP32[i27 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i38 >> 2] | 0) + (i89 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (i39) {
      if (i40) {
       i87 = (HEAP32[i41 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i40) {
      i86 = HEAP32[i32 >> 2] | 0;
      i87 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i89 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (!i42) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i1 + 4 >> 2] = i4;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i43) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[i30 >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i44) {
      HEAP32[i1 >> 2] = i55;
      HEAP32[i1 + 4 >> 2] = i66;
      HEAP32[i1 + 8 >> 2] = i68;
      HEAP32[i1 + 12 >> 2] = i70;
      i1 = i1 + 16 | 0;
     }
     if (!i45) {
      HEAP32[i1 >> 2] = i52;
      HEAP32[i1 + 4 >> 2] = i65;
      HEAP32[i1 + 8 >> 2] = i67;
      HEAP32[i1 + 12 >> 2] = i69;
      i1 = i1 + 16 | 0;
     }
     if (i28) break;
     HEAP32[i1 >> 2] = i51;
     HEAP32[i1 + 4 >> 2] = i50;
     HEAP32[i1 + 8 >> 2] = i48;
     HEAP32[i1 + 12 >> 2] = i46;
     i1 = i1 + 16 | 0;
    } while (0);
    i87 = i11;
    f93 = Math_fround(HEAPF32[i87 >> 2]);
    f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
    f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
    f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
    f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
    HEAPF32[i1 + 4 >> 2] = f96;
    HEAPF32[i1 + 8 >> 2] = f97;
    HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    i1 = i1 + 16 | 0;
    i22 = i22 + 1 | 0;
    if (i22 >>> 0 >= (HEAP32[i34 >> 2] | 0) >>> 0) break; else i11 = i11 + i81 | 0;
   }
  }
  HEAP32[i91 >> 2] = i1;
  STACKTOP = i92;
  return;
 }
 if (i1) {
  if (i2) {
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   i7 = i30 + 8 | 0;
   i8 = HEAP32[i30 + 92 >> 2] | 0;
   i5 = (i8 | 0) == 0;
   if (i5) {
    i3 = 0;
    i70 = 0;
    i2 = 1;
    i1 = 1;
   } else {
    if (!(HEAP8[i30 + 11 >> 0] | 0)) {
     i1 = 0;
     i2 = 1;
    } else {
     i1 = HEAP16[i7 >> 1] | 0;
     i1 = i8 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i2 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    if (!(HEAP8[i30 + 15 >> 0] | 0)) {
     i3 = 0;
     i70 = i1;
     i1 = 1;
    } else {
     i3 = HEAP16[i30 + 12 >> 1] | 0;
     i3 = i8 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i70 = i1;
     i1 = HEAPU8[i7 + 32 + ((HEAPU8[i30 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   HEAP32[i90 >> 2] = 0;
   HEAP32[i90 + 4 >> 2] = 1;
   HEAP32[i90 + 8 >> 2] = 0;
   HEAP32[i90 + 12 >> 2] = 1;
   HEAP32[i90 + 16 >> 2] = 0;
   HEAP32[i90 + 20 >> 2] = 1;
   HEAP32[i90 + 24 >> 2] = 0;
   HEAP32[i90 + 28 >> 2] = 1;
   i72 = (i3 | 0) == 0;
   i44 = i72 ? i4 : i3;
   i72 = i72 ? 0 : i1;
   i71 = i25 << 16 >> 16 == 0;
   L336 : do if (!i71) {
    if (i5) {
     i1 = 0;
     while (1) {
      HEAP32[i90 + (i1 << 3) >> 2] = i6;
      HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i88 | 0)) break L336;
     }
    } else i4 = 0;
    do {
     i3 = i90 + (i4 << 3) | 0;
     i1 = i4 + 3 | 0;
     if (!(HEAP8[i7 + (i1 << 2) + 3 >> 0] | 0)) {
      HEAP32[i3 >> 2] = 0;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = 1;
      i26 = 184;
     } else {
      i84 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      i85 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
      i85 = i8 + (((i85 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i85 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      HEAP32[i3 >> 2] = i85;
      i1 = i90 + (i4 << 3) + 4 | 0;
      HEAP32[i1 >> 2] = i84;
      if (!i85) i26 = 184;
     }
     if ((i26 | 0) == 184) {
      i26 = 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i88 | 0));
   } while (0);
   f59 = Math_fround(HEAPF32[i27 >> 2]);
   f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
   f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
   f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
   f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
   f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
   f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
   i68 = HEAP32[i27 + 48 >> 2] | 0;
   i69 = HEAP32[i27 + 52 >> 2] | 0;
   i67 = HEAP32[i27 + 56 >> 2] | 0;
   i6 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i28 + 4 >> 2] | 0;
   i8 = HEAP32[i28 + 8 >> 2] | 0;
   i13 = HEAP32[i28 + 12 >> 2] | 0;
   i22 = HEAP32[i28 + 16 >> 2] | 0;
   i23 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = HEAP32[i28 + 24 >> 2] | 0;
   i10 = HEAP32[i28 + 28 >> 2] | 0;
   i11 = HEAP32[i28 + 32 >> 2] | 0;
   f58 = Math_fround(HEAPF32[i29 >> 2]);
   f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   i1 = HEAP32[i91 >> 2] | 0;
   i66 = i86 >>> 0 > 63;
   if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
    i47 = 0;
    i50 = 0;
    i52 = 0;
    i65 = 0;
   } else {
    i65 = HEAP32[i87 + 828 >> 2] | 0;
    i47 = HEAP32[i65 + (i89 << 4) >> 2] | 0;
    i50 = HEAP32[i65 + (i89 << 4) + 4 >> 2] | 0;
    i52 = HEAP32[i65 + (i89 << 4) + 8 >> 2] | 0;
    i65 = HEAP32[i65 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
    i46 = 0;
    i48 = 0;
    i51 = 0;
    i55 = 0;
   } else {
    i55 = HEAP32[i87 + 848 >> 2] | 0;
    i46 = HEAP32[i55 + (i89 << 4) >> 2] | 0;
    i48 = HEAP32[i55 + (i89 << 4) + 4 >> 2] | 0;
    i51 = HEAP32[i55 + (i89 << 4) + 8 >> 2] | 0;
    i55 = HEAP32[i55 + (i89 << 4) + 12 >> 2] | 0;
   }
   if (i66) {
    if (!(i86 & 512)) {
     i3 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     f53 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
     f21 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
     f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
     f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
     f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
     f93 = Math_fround(f53 + f93);
     f94 = Math_fround(f21 + f94);
     f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
     f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f21 = Math_fround(f21 * f93);
     f53 = Math_fround(f53 * f93);
     f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f93);
     f95 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f96 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f95 = Math_fround(f95 * f97);
     f96 = Math_fround(f96 * f97);
     f97 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f97);
     f49 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f54 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f95 = Math_fround(f21 + Math_fround(Math_fround(f49 * f94) + f95));
     f96 = Math_fround(f53 + Math_fround(Math_fround(f54 * f94) + f96));
     f97 = Math_fround(f93 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94) + f97));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    }
    if (!(i86 & 8192)) {
     i45 = 0;
     i43 = 0;
     i42 = 0;
     i41 = 0;
    } else {
     i82 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
     i84 = i82 + 1 | 0;
     i41 = i82 + 2 | 0;
     i43 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i82 | 0;
     i83 = (Math_imul(i82, 1790253981) | 0) + 1900727103 | 0;
     i85 = (Math_imul(i84, 1790253981) | 0) + 1900727103 | 0;
     i42 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
     i45 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
     i82 = i82 << 11 ^ i82;
     i84 = i84 << 11 ^ i84;
     i41 = i41 << 11 ^ i41;
     i43 = i43 << 11 ^ i43;
     f94 = Math_fround(Math_fround((i83 ^ i82 ^ i82 >>> 8) & 8388607 ^ i83 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f95 = Math_fround(Math_fround((i85 ^ i84 ^ i84 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f96 = Math_fround(Math_fround((i42 ^ i41 ^ i41 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
     f97 = Math_fround(Math_fround((i45 ^ i43 ^ i43 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
     i45 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
     i43 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
     i42 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
     i41 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } else {
    i45 = 0;
    i3 = 0;
    i43 = 0;
    i4 = 0;
    i42 = 0;
    i5 = 0;
    i41 = 0;
   }
   i40 = HEAP32[i30 + 100 >> 2] | 0;
   if (i40) {
    f49 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = (HEAP32[tempDoublePtr >> 2] = i67, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i29 = (i86 & 64 | 0) == 0;
    i30 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
    i31 = (i86 & 128 | 0) != 0;
    i32 = i87 + 420 | 0;
    i33 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
    i34 = (i86 & 256 | 0) != 0;
    i35 = i87 + 340 | 0;
    i36 = (i86 & 512 | 0) == 0;
    i37 = (i86 & 1024 | 0) == 0;
    i38 = (i86 & 2048 | 0) == 0;
    i39 = (i86 & 4096 | 0) == 0;
    i23 = (i86 & 8192 | 0) == 0;
    i24 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
    i25 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
    i26 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
    i27 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
    i28 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
    i22 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
    i13 = 0;
    i11 = i44;
    i10 = i70;
    do {
     f97 = Math_fround(HEAPF32[i10 >> 2]);
     f96 = Math_fround(HEAPF32[i10 + 4 >> 2]);
     f97 = Math_fround(f58 + f97);
     f96 = Math_fround(f57 + f96);
     f95 = Math_fround(f56 + Math_fround(HEAPF32[i10 + 8 >> 2]));
     f94 = Math_fround(Math_fround(Math_fround(f60 * f97) + Math_fround(f63 * f96)) + Math_fround(f53 + Math_fround(f74 * f95)));
     f93 = Math_fround(Math_fround(Math_fround(f61 * f97) + Math_fround(f64 * f96)) + Math_fround(f54 + Math_fround(f75 * f95)));
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f97) + Math_fround(f62 * f96)) + Math_fround(f49 + Math_fround(f73 * f95)));
     HEAPF32[i1 + 4 >> 2] = f94;
     HEAPF32[i1 + 8 >> 2] = f93;
     i10 = i10 + i2 | 0;
     i87 = i11;
     f93 = Math_fround(HEAPF32[i87 >> 2]);
     f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
     f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
     f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
     f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
     HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
     HEAPF32[i1 + 16 >> 2] = f96;
     HEAPF32[i1 + 20 >> 2] = f97;
     i11 = i11 + i72 | 0;
     i1 = i1 + 24 | 0;
     if (!i71) {
      i9 = 0;
      do {
       i7 = i90 + (i9 << 3) | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
       i6 = i1 + 8 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       if ((i9 | 0) == 1) {
        HEAPF32[i6 >> 2] = Math_fround(0.0);
        HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
        i1 = i1 + 16 | 0;
       } else i1 = i6;
       HEAP32[i7 >> 2] = i8 + (HEAP32[i90 + (i9 << 3) + 4 >> 2] | 0);
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i88 | 0));
     }
     do if (i66) {
      if (!i29) {
       HEAP32[i1 >> 2] = i68;
       HEAP32[i1 + 4 >> 2] = i69;
       HEAP32[i1 + 8 >> 2] = i67;
       HEAPF32[i1 + 12 >> 2] = Math_fround(i13 | 0);
       i1 = i1 + 16 | 0;
      }
      if (i30) {
       if (i31) {
        i87 = (HEAP32[i32 >> 2] | 0) + (i89 << 2) | 0;
        HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
        i1 = i1 + 12 | 0;
       }
      } else if (i31) {
       i86 = HEAP32[i28 >> 2] | 0;
       i87 = HEAP32[i22 >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[(HEAP32[i32 >> 2] | 0) + (i89 << 2) >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      }
      do if (i33) {
       if (!i34) break;
       i87 = (HEAP32[i35 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      } else {
       if (!i34) break;
       i86 = HEAP32[i27 >> 2] | 0;
       i87 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i89 << 2) >> 2] | 0;
       HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i1 + 4 >> 2] = i86;
       HEAP32[i1 + 8 >> 2] = i87;
       i1 = i1 + 12 | 0;
      } while (0);
      if (!i36) {
       HEAP32[i1 >> 2] = i3;
       HEAP32[i1 + 4 >> 2] = i4;
       HEAP32[i1 + 8 >> 2] = i5;
       i1 = i1 + 12 | 0;
      }
      if (!i37) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * Math_fround(.00999999977));
       HEAP32[i1 + 4 >> 2] = HEAP32[i25 >> 2];
       i1 = i1 + 8 | 0;
      }
      if (!i38) {
       HEAP32[i1 >> 2] = i47;
       HEAP32[i1 + 4 >> 2] = i50;
       HEAP32[i1 + 8 >> 2] = i52;
       HEAP32[i1 + 12 >> 2] = i65;
       i1 = i1 + 16 | 0;
      }
      if (!i39) {
       HEAP32[i1 >> 2] = i46;
       HEAP32[i1 + 4 >> 2] = i48;
       HEAP32[i1 + 8 >> 2] = i51;
       HEAP32[i1 + 12 >> 2] = i55;
       i1 = i1 + 16 | 0;
      }
      if (i23) break;
      HEAP32[i1 >> 2] = i45;
      HEAP32[i1 + 4 >> 2] = i43;
      HEAP32[i1 + 8 >> 2] = i42;
      HEAP32[i1 + 12 >> 2] = i41;
      i1 = i1 + 16 | 0;
     } while (0);
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != (i40 | 0));
   }
   HEAP32[i91 >> 2] = i1;
   STACKTOP = i92;
   return;
  }
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i30 + 8 | 0;
  i11 = HEAP32[i30 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i7 = 1;
   i5 = 1;
   i3 = 1;
  } else {
   if (!(HEAP8[i30 + 11 >> 0] | 0)) {
    i2 = 0;
    i5 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 15 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i1 = HEAP16[i30 + 12 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 39 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i30 + 36 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i90 >> 2] = 0;
  HEAP32[i90 + 4 >> 2] = 1;
  HEAP32[i90 + 8 >> 2] = 0;
  HEAP32[i90 + 12 >> 2] = 1;
  HEAP32[i90 + 16 >> 2] = 0;
  HEAP32[i90 + 20 >> 2] = 1;
  HEAP32[i90 + 24 >> 2] = 0;
  HEAP32[i90 + 28 >> 2] = 1;
  i77 = (i1 | 0) == 0;
  i68 = i77 ? i4 : i1;
  i77 = i77 ? 0 : i3;
  i76 = (i8 | 0) == 0;
  i43 = i76 ? i6 : i8;
  i76 = i76 ? 0 : i7;
  i72 = i25 << 16 >> 16 == 0;
  L418 : do if (!i72) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i90 + (i1 << 3) >> 2] = i6;
     HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i88 | 0)) break L418;
    }
   } else i4 = 0;
   do {
    i3 = i90 + (i4 << 3) | 0;
    i1 = i4 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i3 >> 2] = 0;
     i1 = i90 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 131;
    } else {
     i84 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i85 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i85 = i11 + (((i85 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i85 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i3 >> 2] = i85;
     i1 = i90 + (i4 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i84;
     if (!i85) i26 = 131;
    }
    if ((i26 | 0) == 131) {
     i26 = 0;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i88 | 0));
  } while (0);
  f59 = Math_fround(HEAPF32[i27 >> 2]);
  f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i70 = HEAP32[i27 + 48 >> 2] | 0;
  i71 = HEAP32[i27 + 52 >> 2] | 0;
  i69 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i13 = HEAP32[i28 + 32 >> 2] | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i91 >> 2] | 0;
  i67 = i86 >>> 0 > 63;
  if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
   i48 = 0;
   i51 = 0;
   i55 = 0;
   i66 = 0;
  } else {
   i66 = HEAP32[i87 + 828 >> 2] | 0;
   i48 = HEAP32[i66 + (i89 << 4) >> 2] | 0;
   i51 = HEAP32[i66 + (i89 << 4) + 4 >> 2] | 0;
   i55 = HEAP32[i66 + (i89 << 4) + 8 >> 2] | 0;
   i66 = HEAP32[i66 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
   i47 = 0;
   i50 = 0;
   i52 = 0;
   i65 = 0;
  } else {
   i65 = HEAP32[i87 + 848 >> 2] | 0;
   i47 = HEAP32[i65 + (i89 << 4) >> 2] | 0;
   i50 = HEAP32[i65 + (i89 << 4) + 4 >> 2] | 0;
   i52 = HEAP32[i65 + (i89 << 4) + 8 >> 2] | 0;
   i65 = HEAP32[i65 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (i67) {
   if (!(i86 & 512)) {
    i3 = 0;
    i4 = 0;
    i6 = 0;
   } else {
    f53 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
    f21 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
    f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
    f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(f53 + f93);
    f94 = Math_fround(f21 + f94);
    f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
    f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f21 * f93);
    f53 = Math_fround(f53 * f93);
    f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f93);
    f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f96 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f95 * f97);
    f96 = Math_fround(f96 * f97);
    f97 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f97);
    f49 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f21 + Math_fround(Math_fround(f49 * f94) + f95));
    f96 = Math_fround(f53 + Math_fround(Math_fround(f54 * f94) + f96));
    f97 = Math_fround(f93 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94) + f97));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i86 & 8192)) {
    i46 = 0;
    i45 = 0;
    i44 = 0;
    i42 = 0;
   } else {
    i82 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
    i84 = i82 + 1 | 0;
    i42 = i82 + 2 | 0;
    i45 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i82 | 0;
    i83 = (Math_imul(i82, 1790253981) | 0) + 1900727103 | 0;
    i85 = (Math_imul(i84, 1790253981) | 0) + 1900727103 | 0;
    i44 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i82 = i82 << 11 ^ i82;
    i84 = i84 << 11 ^ i84;
    i42 = i42 << 11 ^ i42;
    i45 = i45 << 11 ^ i45;
    f94 = Math_fround(Math_fround((i83 ^ i82 ^ i82 >>> 8) & 8388607 ^ i83 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f95 = Math_fround(Math_fround((i85 ^ i84 ^ i84 >>> 8) & 8388607 ^ i85 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f96 = Math_fround(Math_fround((i44 ^ i42 ^ i42 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f97 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i46 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
    i45 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i44 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i42 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i46 = 0;
   i3 = 0;
   i45 = 0;
   i4 = 0;
   i44 = 0;
   i6 = 0;
   i42 = 0;
  }
  i41 = HEAP32[i30 + 100 >> 2] | 0;
  if (i41) {
   f49 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f54 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i30 = (i86 & 64 | 0) == 0;
   i31 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
   i32 = (i86 & 128 | 0) != 0;
   i33 = i87 + 420 | 0;
   i34 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
   i35 = (i86 & 256 | 0) != 0;
   i36 = i87 + 340 | 0;
   i37 = (i86 & 512 | 0) == 0;
   i38 = (i86 & 1024 | 0) == 0;
   i39 = (i86 & 2048 | 0) == 0;
   i40 = (i86 & 4096 | 0) == 0;
   i24 = (i86 & 8192 | 0) == 0;
   i25 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
   i26 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
   i27 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
   i28 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
   i29 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
   i23 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
   i22 = 0;
   i13 = i43;
   i11 = i68;
   while (1) {
    f97 = Math_fround(HEAPF32[i2 >> 2]);
    f96 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f97 = Math_fround(f58 + f97);
    f96 = Math_fround(f57 + f96);
    f95 = Math_fround(f56 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f94 = Math_fround(Math_fround(Math_fround(f60 * f97) + Math_fround(f63 * f96)) + Math_fround(f53 + Math_fround(f74 * f95)));
    f93 = Math_fround(Math_fround(Math_fround(f61 * f97) + Math_fround(f64 * f96)) + Math_fround(f54 + Math_fround(f75 * f95)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f97) + Math_fround(f62 * f96)) + Math_fround(f49 + Math_fround(f73 * f95)));
    HEAPF32[i1 + 4 >> 2] = f94;
    HEAPF32[i1 + 8 >> 2] = f93;
    i2 = i2 + i5 | 0;
    i87 = i11;
    f93 = Math_fround(HEAPF32[i87 >> 2]);
    f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
    f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
    f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
    f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
    HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
    HEAPF32[i1 + 16 >> 2] = f96;
    HEAPF32[i1 + 20 >> 2] = f97;
    i11 = i11 + i77 | 0;
    i1 = i1 + 24 | 0;
    if (!i72) {
     i10 = 0;
     do {
      i8 = i90 + (i10 << 3) | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
      i7 = i1 + 8 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      if ((i10 | 0) == 1) {
       HEAPF32[i7 >> 2] = Math_fround(0.0);
       HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
       i1 = i1 + 16 | 0;
      } else i1 = i7;
      HEAP32[i8 >> 2] = i9 + (HEAP32[i90 + (i10 << 3) + 4 >> 2] | 0);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i88 | 0));
    }
    do if (i67) {
     if (!i30) {
      HEAP32[i1 >> 2] = i70;
      HEAP32[i1 + 4 >> 2] = i71;
      HEAP32[i1 + 8 >> 2] = i69;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
      i1 = i1 + 16 | 0;
     }
     if (i31) {
      if (i32) {
       i87 = (HEAP32[i33 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i32) {
      i86 = HEAP32[i29 >> 2] | 0;
      i87 = HEAP32[i23 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i89 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (i34) {
      if (i35) {
       i87 = (HEAP32[i36 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i35) {
      i86 = HEAP32[i28 >> 2] | 0;
      i87 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i89 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (!i37) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i1 + 4 >> 2] = i4;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i38) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[i26 >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i39) {
      HEAP32[i1 >> 2] = i48;
      HEAP32[i1 + 4 >> 2] = i51;
      HEAP32[i1 + 8 >> 2] = i55;
      HEAP32[i1 + 12 >> 2] = i66;
      i1 = i1 + 16 | 0;
     }
     if (!i40) {
      HEAP32[i1 >> 2] = i47;
      HEAP32[i1 + 4 >> 2] = i50;
      HEAP32[i1 + 8 >> 2] = i52;
      HEAP32[i1 + 12 >> 2] = i65;
      i1 = i1 + 16 | 0;
     }
     if (i24) break;
     HEAP32[i1 >> 2] = i46;
     HEAP32[i1 + 4 >> 2] = i45;
     HEAP32[i1 + 8 >> 2] = i44;
     HEAP32[i1 + 12 >> 2] = i42;
     i1 = i1 + 16 | 0;
    } while (0);
    i87 = i13;
    f93 = Math_fround(HEAPF32[i87 >> 2]);
    f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
    f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
    f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
    f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
    HEAPF32[i1 + 4 >> 2] = f96;
    HEAPF32[i1 + 8 >> 2] = f97;
    HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    i1 = i1 + 16 | 0;
    i22 = i22 + 1 | 0;
    if ((i22 | 0) == (i41 | 0)) break; else i13 = i13 + i76 | 0;
   }
  }
  HEAP32[i91 >> 2] = i1;
  STACKTOP = i92;
  return;
 }
 if (i2) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i6 >> 2] = -1;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
  i10 = i30 + 8 | 0;
  i11 = HEAP32[i30 + 92 >> 2] | 0;
  i9 = (i11 | 0) == 0;
  if (i9) {
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 1;
   i7 = 1;
   i5 = 1;
  } else {
   if (!(HEAP8[i30 + 11 >> 0] | 0)) {
    i2 = 0;
    i3 = 1;
   } else {
    i2 = HEAP16[i10 >> 1] | 0;
    i2 = i11 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i10 + 32 + ((HEAPU8[i10 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 15 >> 0] | 0)) {
    i1 = 0;
    i5 = 1;
   } else {
    i1 = HEAP16[i30 + 12 >> 1] | 0;
    i1 = i11 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
   if (!(HEAP8[i30 + 19 >> 0] | 0)) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = HEAP16[i30 + 16 >> 1] | 0;
    i8 = i11 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i7 = HEAPU8[i10 + 32 + ((HEAPU8[i30 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  HEAP32[i90 >> 2] = 0;
  HEAP32[i90 + 4 >> 2] = 1;
  HEAP32[i90 + 8 >> 2] = 0;
  HEAP32[i90 + 12 >> 2] = 1;
  HEAP32[i90 + 16 >> 2] = 0;
  HEAP32[i90 + 20 >> 2] = 1;
  HEAP32[i90 + 24 >> 2] = 0;
  HEAP32[i90 + 28 >> 2] = 1;
  i81 = (i1 | 0) == 0;
  i76 = i81 ? i4 : i1;
  i81 = i81 ? 0 : i5;
  i80 = (i8 | 0) == 0;
  i48 = i80 ? i6 : i8;
  i80 = i80 ? 0 : i7;
  i79 = i25 << 16 >> 16 == 0;
  L502 : do if (!i79) {
   i6 = i24;
   if (i9) {
    i1 = 0;
    while (1) {
     HEAP32[i90 + (i1 << 3) >> 2] = i6;
     HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i88 | 0)) break L502;
    }
   } else i5 = 0;
   do {
    i4 = i90 + (i5 << 3) | 0;
    i1 = i5 + 3 | 0;
    if (!(HEAP8[i10 + (i1 << 2) + 3 >> 0] | 0)) {
     HEAP32[i4 >> 2] = 0;
     i1 = i90 + (i5 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = 1;
     i26 = 75;
    } else {
     i83 = HEAPU8[i10 + 32 + ((HEAPU8[i10 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i84 = HEAP16[i10 + (i1 << 2) >> 1] | 0;
     i84 = i11 + (((i84 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i84 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     HEAP32[i4 >> 2] = i84;
     i1 = i90 + (i5 << 3) + 4 | 0;
     HEAP32[i1 >> 2] = i83;
     if (!i84) i26 = 75;
    }
    if ((i26 | 0) == 75) {
     i26 = 0;
     HEAP32[i4 >> 2] = i6;
     HEAP32[i1 >> 2] = 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i88 | 0));
  } while (0);
  f59 = Math_fround(HEAPF32[i27 >> 2]);
  f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  i77 = HEAP32[i27 + 48 >> 2] | 0;
  i78 = HEAP32[i27 + 52 >> 2] | 0;
  i72 = HEAP32[i27 + 56 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i28 + 4 >> 2] | 0;
  i9 = HEAP32[i28 + 8 >> 2] | 0;
  i22 = HEAP32[i28 + 12 >> 2] | 0;
  i23 = HEAP32[i28 + 16 >> 2] | 0;
  i24 = HEAP32[i28 + 20 >> 2] | 0;
  i10 = HEAP32[i28 + 24 >> 2] | 0;
  i11 = HEAP32[i28 + 28 >> 2] | 0;
  i13 = HEAP32[i28 + 32 >> 2] | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i1 = HEAP32[i91 >> 2] | 0;
  i71 = i86 >>> 0 > 63;
  if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
   i55 = 0;
   i66 = 0;
   i68 = 0;
   i70 = 0;
  } else {
   i70 = HEAP32[i87 + 828 >> 2] | 0;
   i55 = HEAP32[i70 + (i89 << 4) >> 2] | 0;
   i66 = HEAP32[i70 + (i89 << 4) + 4 >> 2] | 0;
   i68 = HEAP32[i70 + (i89 << 4) + 8 >> 2] | 0;
   i70 = HEAP32[i70 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
   i52 = 0;
   i65 = 0;
   i67 = 0;
   i69 = 0;
  } else {
   i69 = HEAP32[i87 + 848 >> 2] | 0;
   i52 = HEAP32[i69 + (i89 << 4) >> 2] | 0;
   i65 = HEAP32[i69 + (i89 << 4) + 4 >> 2] | 0;
   i67 = HEAP32[i69 + (i89 << 4) + 8 >> 2] | 0;
   i69 = HEAP32[i69 + (i89 << 4) + 12 >> 2] | 0;
  }
  if (i71) {
   if (!(i86 & 512)) {
    i4 = 0;
    i5 = 0;
    i6 = 0;
   } else {
    f53 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
    f21 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
    f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
    f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
    f93 = Math_fround(f53 + f93);
    f94 = Math_fround(f21 + f94);
    f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
    f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f21 * f93);
    f53 = Math_fround(f53 * f93);
    f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f93);
    f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f96 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f95 * f97);
    f96 = Math_fround(f96 * f97);
    f97 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f97);
    f49 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f95 = Math_fround(f21 + Math_fround(Math_fround(f49 * f94) + f95));
    f96 = Math_fround(f53 + Math_fround(Math_fround(f54 * f94) + f96));
    f97 = Math_fround(f93 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94) + f97));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
   if (!(i86 & 8192)) {
    i51 = 0;
    i50 = 0;
    i47 = 0;
    i46 = 0;
   } else {
    i45 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
    i83 = i45 + 1 | 0;
    i46 = i45 + 2 | 0;
    i50 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i45 | 0;
    i82 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i84 = (Math_imul(i83, 1790253981) | 0) + 1900727103 | 0;
    i47 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i45 = i45 << 11 ^ i45;
    i83 = i83 << 11 ^ i83;
    i46 = i46 << 11 ^ i46;
    i50 = i50 << 11 ^ i50;
    f94 = Math_fround(Math_fround((i82 ^ i45 ^ i45 >>> 8) & 8388607 ^ i82 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f95 = Math_fround(Math_fround((i84 ^ i83 ^ i83 >>> 8) & 8388607 ^ i84 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f96 = Math_fround(Math_fround((i47 ^ i46 ^ i46 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f97 = Math_fround(Math_fround((i51 ^ i50 ^ i50 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    i51 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
    i50 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    i47 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i46 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i51 = 0;
   i4 = 0;
   i50 = 0;
   i5 = 0;
   i47 = 0;
   i6 = 0;
   i46 = 0;
  }
  i45 = i30 + 100 | 0;
  if (HEAP32[i45 >> 2] | 0) {
   f49 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f54 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i34 = (i86 & 64 | 0) == 0;
   i35 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
   i36 = (i86 & 128 | 0) != 0;
   i37 = i87 + 420 | 0;
   i38 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
   i39 = (i86 & 256 | 0) != 0;
   i40 = i87 + 340 | 0;
   i41 = (i86 & 512 | 0) == 0;
   i42 = (i86 & 1024 | 0) == 0;
   i43 = (i86 & 2048 | 0) == 0;
   i44 = (i86 & 4096 | 0) == 0;
   i28 = (i86 & 8192 | 0) == 0;
   i29 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
   i30 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
   i31 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
   i32 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
   i33 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
   i25 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
   i26 = i85 & 255;
   i24 = i85 >>> 8;
   i27 = i24 & 255;
   i23 = i85 & 16711680;
   i24 = i24 & 16711680;
   i22 = 0;
   i13 = i48;
   i11 = i76;
   do {
    f97 = Math_fround(HEAPF32[i2 >> 2]);
    f96 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f97 = Math_fround(f58 + f97);
    f96 = Math_fround(f57 + f96);
    f95 = Math_fround(f56 + Math_fround(HEAPF32[i2 + 8 >> 2]));
    f94 = Math_fround(Math_fround(Math_fround(f60 * f97) + Math_fround(f63 * f96)) + Math_fround(f53 + Math_fround(f74 * f95)));
    f93 = Math_fround(Math_fround(Math_fround(f61 * f97) + Math_fround(f64 * f96)) + Math_fround(f54 + Math_fround(f75 * f95)));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f97) + Math_fround(f62 * f96)) + Math_fround(f49 + Math_fround(f73 * f95)));
    HEAPF32[i1 + 4 >> 2] = f94;
    HEAPF32[i1 + 8 >> 2] = f93;
    i2 = i2 + i3 | 0;
    i87 = i11;
    f93 = Math_fround(HEAPF32[i87 >> 2]);
    f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
    f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
    f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
    f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
    HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
    HEAPF32[i1 + 16 >> 2] = f96;
    HEAPF32[i1 + 20 >> 2] = f97;
    i11 = i11 + i81 | 0;
    i87 = HEAP32[i13 >> 2] | 0;
    HEAP32[i1 + 24 >> 2] = (Math_imul((i87 >>> 8 & 255) + 1 | 0, i27) | 0) & 65280 | (Math_imul((i87 >>> 24) + 1 | 0, i24) | 0) & -16777216 | (Math_imul((i87 & 255) + 1 | 0, i26) | 0) >>> 8 & 255 | (Math_imul((i87 >>> 16 & 255) + 1 | 0, i23) | 0) >>> 8 & 16711680;
    i13 = i13 + i80 | 0;
    i1 = i1 + 28 | 0;
    if (!i79) {
     i10 = 0;
     do {
      i8 = i90 + (i10 << 3) | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
      i7 = i1 + 8 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      if ((i10 | 0) == 1) {
       HEAPF32[i7 >> 2] = Math_fround(0.0);
       HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
       i1 = i1 + 16 | 0;
      } else i1 = i7;
      HEAP32[i8 >> 2] = i9 + (HEAP32[i90 + (i10 << 3) + 4 >> 2] | 0);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i88 | 0));
    }
    do if (i71) {
     if (!i34) {
      HEAP32[i1 >> 2] = i77;
      HEAP32[i1 + 4 >> 2] = i78;
      HEAP32[i1 + 8 >> 2] = i72;
      HEAPF32[i1 + 12 >> 2] = Math_fround(i22 | 0);
      i1 = i1 + 16 | 0;
     }
     if (i35) {
      if (i36) {
       i87 = (HEAP32[i37 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i36) {
      i86 = HEAP32[i33 >> 2] | 0;
      i87 = HEAP32[i25 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[(HEAP32[i37 >> 2] | 0) + (i89 << 2) >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (i38) {
      if (i39) {
       i87 = (HEAP32[i40 >> 2] | 0) + (i89 << 2) | 0;
       HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
       i1 = i1 + 12 | 0;
      }
     } else if (i39) {
      i86 = HEAP32[i32 >> 2] | 0;
      i87 = HEAP32[(HEAP32[i40 >> 2] | 0) + (i89 << 2) >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i1 + 4 >> 2] = i86;
      HEAP32[i1 + 8 >> 2] = i87;
      i1 = i1 + 12 | 0;
     }
     if (!i41) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i1 + 4 >> 2] = i5;
      HEAP32[i1 + 8 >> 2] = i6;
      i1 = i1 + 12 | 0;
     }
     if (!i42) {
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(.00999999977));
      HEAP32[i1 + 4 >> 2] = HEAP32[i30 >> 2];
      i1 = i1 + 8 | 0;
     }
     if (!i43) {
      HEAP32[i1 >> 2] = i55;
      HEAP32[i1 + 4 >> 2] = i66;
      HEAP32[i1 + 8 >> 2] = i68;
      HEAP32[i1 + 12 >> 2] = i70;
      i1 = i1 + 16 | 0;
     }
     if (!i44) {
      HEAP32[i1 >> 2] = i52;
      HEAP32[i1 + 4 >> 2] = i65;
      HEAP32[i1 + 8 >> 2] = i67;
      HEAP32[i1 + 12 >> 2] = i69;
      i1 = i1 + 16 | 0;
     }
     if (i28) break;
     HEAP32[i1 >> 2] = i51;
     HEAP32[i1 + 4 >> 2] = i50;
     HEAP32[i1 + 8 >> 2] = i47;
     HEAP32[i1 + 12 >> 2] = i46;
     i1 = i1 + 16 | 0;
    } while (0);
    i22 = i22 + 1 | 0;
   } while (i22 >>> 0 < (HEAP32[i45 >> 2] | 0) >>> 0);
  }
  HEAP32[i91 >> 2] = i1;
  STACKTOP = i92;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i24 >> 2] = -1;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 i22 = i30 + 8 | 0;
 i23 = HEAP32[i30 + 92 >> 2] | 0;
 i11 = (i23 | 0) == 0;
 if (i11) {
  i10 = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
  i7 = 1;
  i8 = 1;
  i9 = 1;
  i5 = 1;
 } else {
  if (!(HEAP8[i30 + 11 >> 0] | 0)) {
   i3 = 0;
   i8 = 1;
  } else {
   i3 = HEAP16[i22 >> 1] | 0;
   i3 = i23 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i8 = HEAPU8[i22 + 32 + ((HEAPU8[i22 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i30 + 15 >> 0] | 0)) {
   i2 = 0;
   i5 = 1;
  } else {
   i2 = HEAP16[i30 + 12 >> 1] | 0;
   i2 = i23 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i22 + 32 + ((HEAPU8[i30 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i30 + 39 >> 0] | 0)) {
   i1 = 0;
   i7 = 1;
  } else {
   i1 = HEAP16[i30 + 36 >> 1] | 0;
   i1 = i23 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i7 = HEAPU8[i22 + 32 + ((HEAPU8[i30 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
  if (!(HEAP8[i30 + 19 >> 0] | 0)) {
   i10 = 0;
   i9 = 1;
  } else {
   i10 = HEAP16[i30 + 16 >> 1] | 0;
   i10 = i23 + (((i10 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i9 = HEAPU8[i22 + 32 + ((HEAPU8[i30 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 HEAP32[i90 >> 2] = 0;
 HEAP32[i90 + 4 >> 2] = 1;
 HEAP32[i90 + 8 >> 2] = 0;
 HEAP32[i90 + 12 >> 2] = 1;
 HEAP32[i90 + 16 >> 2] = 0;
 HEAP32[i90 + 20 >> 2] = 1;
 HEAP32[i90 + 24 >> 2] = 0;
 HEAP32[i90 + 28 >> 2] = 1;
 i84 = (i2 | 0) == 0;
 i80 = i84 ? i4 : i2;
 i84 = i84 ? 0 : i5;
 i83 = (i1 | 0) == 0;
 i76 = i83 ? i6 : i1;
 i83 = i83 ? 0 : i7;
 i82 = (i10 | 0) == 0;
 i47 = i82 ? i24 : i10;
 i82 = i82 ? 0 : i9;
 i81 = i25 << 16 >> 16 == 0;
 L587 : do if (!i81) {
  i5 = i13;
  if (i11) {
   i1 = 0;
   while (1) {
    HEAP32[i90 + (i1 << 3) >> 2] = i5;
    HEAP32[i90 + (i1 << 3) + 4 >> 2] = 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i88 | 0)) break L587;
   }
  } else i4 = 0;
  do {
   i2 = i90 + (i4 << 3) | 0;
   i1 = i4 + 3 | 0;
   if (!(HEAP8[i22 + (i1 << 2) + 3 >> 0] | 0)) {
    HEAP32[i2 >> 2] = 0;
    i1 = i90 + (i4 << 3) + 4 | 0;
    HEAP32[i1 >> 2] = 1;
    i26 = 20;
   } else {
    i78 = HEAPU8[i22 + 32 + ((HEAPU8[i22 + (i1 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i79 = HEAP16[i22 + (i1 << 2) >> 1] | 0;
    i79 = i23 + (((i79 & 65535) >>> 8 & 65535) + (HEAP32[i22 + 32 + ((i79 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    HEAP32[i2 >> 2] = i79;
    i1 = i90 + (i4 << 3) + 4 | 0;
    HEAP32[i1 >> 2] = i78;
    if (!i79) i26 = 20;
   }
   if ((i26 | 0) == 20) {
    i26 = 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i1 >> 2] = 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i88 | 0));
 } while (0);
 f59 = Math_fround(HEAPF32[i27 >> 2]);
 f60 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f61 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f62 = Math_fround(HEAPF32[i27 + 16 >> 2]);
 f63 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f64 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f73 = Math_fround(HEAPF32[i27 + 32 >> 2]);
 f74 = Math_fround(HEAPF32[i27 + 36 >> 2]);
 f75 = Math_fround(HEAPF32[i27 + 40 >> 2]);
 i78 = HEAP32[i27 + 48 >> 2] | 0;
 i79 = HEAP32[i27 + 52 >> 2] | 0;
 i77 = HEAP32[i27 + 56 >> 2] | 0;
 i6 = HEAP32[i28 >> 2] | 0;
 i7 = HEAP32[i28 + 4 >> 2] | 0;
 i9 = HEAP32[i28 + 8 >> 2] | 0;
 i22 = HEAP32[i28 + 12 >> 2] | 0;
 i23 = HEAP32[i28 + 16 >> 2] | 0;
 i24 = HEAP32[i28 + 20 >> 2] | 0;
 i10 = HEAP32[i28 + 24 >> 2] | 0;
 i11 = HEAP32[i28 + 28 >> 2] | 0;
 i13 = HEAP32[i28 + 32 >> 2] | 0;
 f58 = Math_fround(HEAPF32[i29 >> 2]);
 f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f56 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 i1 = HEAP32[i91 >> 2] | 0;
 i72 = i86 >>> 0 > 63;
 if (!(HEAP32[i87 + 844 >> 2] & 2147483647)) {
  i65 = 0;
  i67 = 0;
  i69 = 0;
  i71 = 0;
 } else {
  i71 = HEAP32[i87 + 828 >> 2] | 0;
  i65 = HEAP32[i71 + (i89 << 4) >> 2] | 0;
  i67 = HEAP32[i71 + (i89 << 4) + 4 >> 2] | 0;
  i69 = HEAP32[i71 + (i89 << 4) + 8 >> 2] | 0;
  i71 = HEAP32[i71 + (i89 << 4) + 12 >> 2] | 0;
 }
 if (!(HEAP32[i87 + 864 >> 2] & 2147483647)) {
  i55 = 0;
  i66 = 0;
  i68 = 0;
  i70 = 0;
 } else {
  i70 = HEAP32[i87 + 848 >> 2] | 0;
  i55 = HEAP32[i70 + (i89 << 4) >> 2] | 0;
  i66 = HEAP32[i70 + (i89 << 4) + 4 >> 2] | 0;
  i68 = HEAP32[i70 + (i89 << 4) + 8 >> 2] | 0;
  i70 = HEAP32[i70 + (i89 << 4) + 12 >> 2] | 0;
 }
 if (i72) {
  if (!(i86 & 512)) {
   i2 = 0;
   i4 = 0;
   i5 = 0;
  } else {
   f53 = Math_fround(HEAPF32[(HEAP32[i87 + 60 >> 2] | 0) + (i89 << 2) >> 2]);
   f21 = Math_fround(HEAPF32[(HEAP32[i87 + 80 >> 2] | 0) + (i89 << 2) >> 2]);
   f97 = Math_fround(HEAPF32[(HEAP32[i87 + 100 >> 2] | 0) + (i89 << 2) >> 2]);
   f93 = Math_fround(HEAPF32[(HEAP32[i87 + 120 >> 2] | 0) + (i89 << 2) >> 2]);
   f94 = Math_fround(HEAPF32[(HEAP32[i87 + 140 >> 2] | 0) + (i89 << 2) >> 2]);
   f93 = Math_fround(f53 + f93);
   f94 = Math_fround(f21 + f94);
   f97 = Math_fround(f97 + Math_fround(HEAPF32[(HEAP32[i87 + 160 >> 2] | 0) + (i89 << 2) >> 2]));
   f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(f21 * f93);
   f53 = Math_fround(f53 * f93);
   f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f93);
   f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f96 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f95 = Math_fround(f95 * f97);
   f96 = Math_fround(f96 * f97);
   f97 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f97);
   f49 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f54 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f95 = Math_fround(f21 + Math_fround(Math_fround(f49 * f94) + f95));
   f96 = Math_fround(f53 + Math_fround(Math_fround(f54 * f94) + f96));
   f97 = Math_fround(f93 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f94) + f97));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
  }
  if (!(i86 & 8192)) {
   i52 = 0;
   i51 = 0;
   i50 = 0;
   i48 = 0;
  } else {
   i43 = HEAP32[(HEAP32[i87 + 500 >> 2] | 0) + (i89 << 2) >> 2] | 0;
   i45 = i43 + 1 | 0;
   i48 = i43 + 2 | 0;
   i51 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) >> 2]) * Math_fround(1.0e5)) + i43 | 0;
   i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
   i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
   i50 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
   i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
   i43 = i43 << 11 ^ i43;
   i45 = i45 << 11 ^ i45;
   i48 = i48 << 11 ^ i48;
   i51 = i51 << 11 ^ i51;
   f94 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f95 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f96 = Math_fround(Math_fround((i50 ^ i48 ^ i48 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f97 = Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
   i52 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
   i51 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
   i50 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
   i48 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
  }
 } else {
  i52 = 0;
  i2 = 0;
  i51 = 0;
  i4 = 0;
  i50 = 0;
  i5 = 0;
  i48 = 0;
 }
 i46 = i30 + 100 | 0;
 if (HEAP32[i46 >> 2] | 0) {
  f49 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f53 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f54 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i35 = (i86 & 64 | 0) == 0;
  i36 = (HEAP8[i87 + 871 >> 0] | 0) == 0;
  i37 = (i86 & 128 | 0) != 0;
  i38 = i87 + 420 | 0;
  i39 = (HEAP8[i87 + 870 >> 0] | 0) == 0;
  i40 = (i86 & 256 | 0) != 0;
  i41 = i87 + 340 | 0;
  i42 = (i86 & 512 | 0) == 0;
  i43 = (i86 & 1024 | 0) == 0;
  i44 = (i86 & 2048 | 0) == 0;
  i45 = (i86 & 4096 | 0) == 0;
  i29 = (i86 & 8192 | 0) == 0;
  i30 = (HEAP32[i87 + 520 >> 2] | 0) + (i89 << 2) | 0;
  i31 = (HEAP32[i87 + 540 >> 2] | 0) + (i89 << 2) | 0;
  i32 = (HEAP32[i87 + 300 >> 2] | 0) + (i89 << 2) | 0;
  i33 = (HEAP32[i87 + 320 >> 2] | 0) + (i89 << 2) | 0;
  i34 = (HEAP32[i87 + 440 >> 2] | 0) + (i89 << 2) | 0;
  i26 = (HEAP32[i87 + 460 >> 2] | 0) + (i89 << 2) | 0;
  i27 = i85 & 255;
  i25 = i85 >>> 8;
  i28 = i25 & 255;
  i24 = i85 & 16711680;
  i25 = i25 & 16711680;
  i23 = 0;
  i22 = i47;
  i13 = i76;
  i11 = i80;
  while (1) {
   f97 = Math_fround(HEAPF32[i3 >> 2]);
   f96 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f97 = Math_fround(f58 + f97);
   f96 = Math_fround(f57 + f96);
   f95 = Math_fround(f56 + Math_fround(HEAPF32[i3 + 8 >> 2]));
   f94 = Math_fround(Math_fround(Math_fround(f60 * f97) + Math_fround(f63 * f96)) + Math_fround(f53 + Math_fround(f74 * f95)));
   f93 = Math_fround(Math_fround(Math_fround(f61 * f97) + Math_fround(f64 * f96)) + Math_fround(f54 + Math_fround(f75 * f95)));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f59 * f97) + Math_fround(f62 * f96)) + Math_fround(f49 + Math_fround(f73 * f95)));
   HEAPF32[i1 + 4 >> 2] = f94;
   HEAPF32[i1 + 8 >> 2] = f93;
   i3 = i3 + i8 | 0;
   i87 = i11;
   f93 = Math_fround(HEAPF32[i87 >> 2]);
   f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
   f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
   f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
   f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
   HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
   HEAPF32[i1 + 16 >> 2] = f96;
   HEAPF32[i1 + 20 >> 2] = f97;
   i11 = i11 + i84 | 0;
   i87 = HEAP32[i22 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = (Math_imul((i87 >>> 8 & 255) + 1 | 0, i28) | 0) & 65280 | (Math_imul((i87 >>> 24) + 1 | 0, i25) | 0) & -16777216 | (Math_imul((i87 & 255) + 1 | 0, i27) | 0) >>> 8 & 255 | (Math_imul((i87 >>> 16 & 255) + 1 | 0, i24) | 0) >>> 8 & 16711680;
   i22 = i22 + i82 | 0;
   i1 = i1 + 28 | 0;
   if (!i81) {
    i10 = 0;
    do {
     i7 = i90 + (i10 << 3) | 0;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
     i6 = i1 + 8 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     if ((i10 | 0) == 1) {
      HEAPF32[i6 >> 2] = Math_fround(0.0);
      HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
      i1 = i1 + 16 | 0;
     } else i1 = i6;
     HEAP32[i7 >> 2] = i9 + (HEAP32[i90 + (i10 << 3) + 4 >> 2] | 0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i88 | 0));
   }
   do if (i72) {
    if (!i35) {
     HEAP32[i1 >> 2] = i78;
     HEAP32[i1 + 4 >> 2] = i79;
     HEAP32[i1 + 8 >> 2] = i77;
     HEAPF32[i1 + 12 >> 2] = Math_fround(i23 | 0);
     i1 = i1 + 16 | 0;
    }
    if (i36) {
     if (i37) {
      i87 = (HEAP32[i38 >> 2] | 0) + (i89 << 2) | 0;
      HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
      i1 = i1 + 12 | 0;
     }
    } else if (i37) {
     i86 = HEAP32[i34 >> 2] | 0;
     i87 = HEAP32[i26 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[(HEAP32[i38 >> 2] | 0) + (i89 << 2) >> 2];
     HEAP32[i1 + 4 >> 2] = i86;
     HEAP32[i1 + 8 >> 2] = i87;
     i1 = i1 + 12 | 0;
    }
    if (i39) {
     if (i40) {
      i87 = (HEAP32[i41 >> 2] | 0) + (i89 << 2) | 0;
      HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i87 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i87 >> 2];
      i1 = i1 + 12 | 0;
     }
    } else if (i40) {
     i86 = HEAP32[i33 >> 2] | 0;
     i87 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i89 << 2) >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i32 >> 2];
     HEAP32[i1 + 4 >> 2] = i86;
     HEAP32[i1 + 8 >> 2] = i87;
     i1 = i1 + 12 | 0;
    }
    if (!i42) {
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 4 >> 2] = i4;
     HEAP32[i1 + 8 >> 2] = i5;
     i1 = i1 + 12 | 0;
    }
    if (!i43) {
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * Math_fround(.00999999977));
     HEAP32[i1 + 4 >> 2] = HEAP32[i31 >> 2];
     i1 = i1 + 8 | 0;
    }
    if (!i44) {
     HEAP32[i1 >> 2] = i65;
     HEAP32[i1 + 4 >> 2] = i67;
     HEAP32[i1 + 8 >> 2] = i69;
     HEAP32[i1 + 12 >> 2] = i71;
     i1 = i1 + 16 | 0;
    }
    if (!i45) {
     HEAP32[i1 >> 2] = i55;
     HEAP32[i1 + 4 >> 2] = i66;
     HEAP32[i1 + 8 >> 2] = i68;
     HEAP32[i1 + 12 >> 2] = i70;
     i1 = i1 + 16 | 0;
    }
    if (i29) break;
    HEAP32[i1 >> 2] = i52;
    HEAP32[i1 + 4 >> 2] = i51;
    HEAP32[i1 + 8 >> 2] = i50;
    HEAP32[i1 + 12 >> 2] = i48;
    i1 = i1 + 16 | 0;
   } while (0);
   i87 = i13;
   f93 = Math_fround(HEAPF32[i87 >> 2]);
   f94 = Math_fround(HEAPF32[i87 + 4 >> 2]);
   f95 = Math_fround(HEAPF32[i87 + 8 >> 2]);
   f96 = Math_fround(Math_fround(f20 * f93) + Math_fround(Math_fround(f14 * f94) + Math_fround(f17 * f95)));
   f97 = Math_fround(Math_fround(f19 * f93) + Math_fround(Math_fround(f12 * f94) + Math_fround(f16 * f95)));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(f21 * f93) + Math_fround(Math_fround(f15 * f94) + Math_fround(f18 * f95)));
   HEAPF32[i1 + 4 >> 2] = f96;
   HEAPF32[i1 + 8 >> 2] = f97;
   HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i1 = i1 + 16 | 0;
   i23 = i23 + 1 | 0;
   if (i23 >>> 0 >= (HEAP32[i46 >> 2] | 0) >>> 0) break; else i13 = i13 + i83 | 0;
  }
 }
 HEAP32[i91 >> 2] = i1;
 STACKTOP = i92;
 return;
}

function __ZN5Umbra8QueryExt24queryStaticShadowCastersERKNS_15ShadowCullerExtERNS_9IndexListEPKNS_20ObjectDistanceParamsEiiPS4_(i1, i5, i12, i13, i167, i168, i16) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i167 = i167 | 0;
 i168 = i168 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, f146 = f0, i147 = 0, i148 = 0, f149 = f0, f150 = f0, f151 = f0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, f191 = f0, f192 = f0;
 i173 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i169 = i173 + 208 | 0;
 i170 = i173 + 192 | 0;
 i172 = i173 + 96 | 0;
 i164 = i173;
 i165 = i173 + 176 | 0;
 i166 = i173 + 160 | 0;
 i163 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i172 >> 2] = i163;
 i2 = HEAP32[i163 + 76 >> 2] | 0;
 HEAP32[i172 + 4 >> 2] = i2;
 i162 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i162 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i162 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i172 + 8 >> 2] = i1;
 i15 = i1 + i4 | 0;
 HEAP32[i172 + 12 >> 2] = i15;
 i162 = i172 + 16 | 0;
 HEAP32[i162 >> 2] = i1;
 HEAP32[i172 + 20 >> 2] = i4;
 i161 = i172 + 24 | 0;
 HEAP32[i161 >> 2] = 0;
 HEAP32[i161 + 4 >> 2] = 0;
 HEAP32[i161 + 8 >> 2] = 0;
 HEAP32[i161 + 12 >> 2] = 0;
 HEAP32[i172 + 40 >> 2] = -1;
 i161 = HEAP32[i163 + 84 >> 2] | 0;
 HEAP32[i172 + 44 >> 2] = i161;
 i11 = i172 + 48 | 0;
 HEAP32[i11 >> 2] = i161;
 HEAP32[i172 + 52 >> 2] = 0;
 HEAP32[i172 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i3 = 0; else {
  i2 = i1 + 80 | 0;
  HEAP32[i162 >> 2] = i2;
  if (!i1) {
   i3 = 0;
   i1 = i2;
  } else {
   HEAP32[i1 >> 2] = 13;
   i3 = i1 + 16 | 0;
   i1 = i2;
  }
 }
 HEAP32[i172 + 60 >> 2] = i3;
 i2 = i3;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i7 = HEAP32[i163 >> 2] | 0;
 i19 = i7;
 if (!i7) {
  i171 = 6;
  __ZN5Umbra12QueryContextD2Ev(i172);
  STACKTOP = i173;
  return i171 | 0;
 }
 if (!((i167 | 0) > -1 & (i167 | 0) < (i168 | 0))) {
  i171 = 3;
  __ZN5Umbra12QueryContextD2Ev(i172);
  STACKTOP = i173;
  return i171 | 0;
 }
 i160 = i5 + 15 & -16;
 i9 = HEAP32[i160 + 34448 >> 2] | 0;
 i10 = HEAP32[i160 + 34452 >> 2] | 0;
 i8 = HEAP32[i160 + 34456 >> 2] | 0;
 i161 = i160 + 34480 | 0;
 if (!i16) {
  i3 = 0;
  i159 = 0;
 } else {
  i4 = HEAP32[i161 >> 2] | 0;
  if (!i4) {
   i171 = 3;
   __ZN5Umbra12QueryContextD2Ev(i172);
   STACKTOP = i173;
   return i171 | 0;
  }
  i2 = i1 + (i4 * 96 | 0) | 0;
  if (i2 >>> 0 > i15 >>> 0) i3 = 0; else {
   HEAP32[i162 >> 2] = i2;
   i3 = i1;
   i1 = i2;
  }
  if ((i4 | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i3 + (i2 * 96 | 0) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i159 = 1;
  } else i159 = 1;
 }
 i14 = HEAP32[i160 + 34476 >> 2] | 0;
 i158 = i163 + 4 | 0;
 i2 = HEAP32[i158 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  i5 = 1;
  i18 = 0;
  i11 = 1;
 } else if (!(HEAP8[i2 + 24 >> 0] | 0)) {
  i4 = 0;
  i5 = 1;
  i18 = 0;
  i11 = 1;
 } else {
  i2 = HEAP32[i2 + 44 >> 2] | 0;
  do if ((i168 | 0) == 0 | (i2 | 0) == 0) {
   i5 = 0;
   i6 = 0;
  } else {
   i4 = (i2 | 0) / (i168 | 0) | 0;
   i2 = i2 - (Math_imul(i4, i168) | 0) | 0;
   if ((i2 | 0) > -1) {
    i156 = (i2 | 0) > (i167 | 0);
    i5 = i4 + 1 | 0;
    i157 = Math_imul(i5, i167) | 0;
    i6 = i2 + (Math_imul(i4, i167) | 0) | 0;
    i5 = i156 ? i5 : i4;
    i6 = i156 ? i157 : i6;
    break;
   } else {
    i6 = Math_imul(i4, i167) | 0;
    i157 = i2 + i168 | 0;
    i5 = i2 - (Math_imul(i2, i4) | 0) | 0;
    i5 = ((i157 | 0) > (i167 | 0) ? i4 : 0) + ((i157 + -1 | 0) == (i167 | 0) ? i5 : 0) | 0;
    break;
   }
  } while (0);
  if (i159) {
   i2 = i1 + 48 | 0;
   if (i2 >>> 0 > i15 >>> 0) i4 = 0; else {
    HEAP32[i162 >> 2] = i2;
    i4 = i1;
    i1 = i2;
   }
   i18 = HEAP32[i7 + 68 >> 2] | 0;
   i157 = HEAP32[i7 + 64 >> 2] | 0;
   HEAP32[i4 >> 2] = i172 + 4;
   HEAP32[i4 + 12 >> 2] = i172 + 44;
   i156 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i156 + 1;
   HEAP32[i4 + 16 >> 2] = i156;
   HEAP32[i4 + 20 >> 2] = 24;
   HEAP32[i4 + 32 >> 2] = i157;
   HEAP32[i4 + 4 >> 2] = (i18 | 0) == 0 ? 0 : i7 + i18 | 0;
   i18 = i6;
   i11 = 0;
  } else {
   i4 = 0;
   i18 = i6;
   i11 = 0;
  }
 }
 i156 = i12 + 3 & -4;
 i157 = i156 + 8 | 0;
 HEAP32[i157 >> 2] = 0;
 i2 = i13 + 3 & -4;
 i6 = i2;
 if ((i13 | 0) == 0 | (i2 | 0) == 0) i7 = 1065353216; else {
  f151 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  i7 = !(f151 <= Math_fround(0.0));
  f151 = i7 ? f151 : Math_fround(1.0);
  f151 = Math_fround(f151 * f151);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0);
  if (HEAP8[i6 + 16 >> 0] | 0) {
   i9 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i6 + 4 >> 2] | 0;
   i8 = HEAP32[i6 + 8 >> 2] | 0;
  }
 }
 f149 = Math_fround(-Math_fround(HEAPF32[i160 + 34460 >> 2]));
 f150 = Math_fround(-Math_fround(HEAPF32[i160 + 34464 >> 2]));
 f151 = Math_fround(-Math_fround(HEAPF32[i160 + 34468 >> 2]));
 HEAPF32[i170 >> 2] = f149;
 HEAPF32[i170 + 4 >> 2] = f150;
 HEAPF32[i170 + 8 >> 2] = f151;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f149, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 i155 = (HEAPF32[tempDoublePtr >> 2] = f150, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 HEAP32[i169 >> 2] = i6;
 HEAP32[i169 + 4 >> 2] = i155;
 HEAP32[i169 + 8 >> 2] = i2;
 i2 = i6 >>> 0 < i155 >>> 0 ? (i155 >>> 0 >= i2 >>> 0 ? 1 : 2) : i6 >>> 0 >= i2 >>> 0 ? 0 : 2;
 i6 = 1 << i2 & 3;
 if (!(HEAP32[i169 + (i2 << 2) >> 2] | 0)) {
  i155 = 0;
  i12 = 0;
  i13 = 0;
 } else {
  i155 = HEAP32[i170 + (i2 << 2) >> 2] | 0;
  f151 = Math_fround(Math_fround(8.0) / Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i155, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  i13 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i170 + (i6 << 2) >> 2]) * f151) + Math_fround(8.0));
  i155 = (i155 >>> 31 | i2 << 1) ^ 1;
  i12 = ~~Math_fround(Math_fround(f151 * Math_fround(HEAPF32[i170 + ((1 << i6 & 3) << 2) >> 2])) + Math_fround(8.0)) << 4;
 }
 i2 = HEAP32[i158 >> 2] | 0;
 if (!i2) i1 = 0; else if ((HEAP32[i2 + 44 >> 2] | 0) > 1) {
  i2 = (HEAP32[(HEAP32[i163 >> 2] | 0) + 64 >> 2] | 0) + 31 >> 5 << 2;
  i6 = i1 + (i2 + 15 & -16) | 0;
  if (i6 >>> 0 > i15 >>> 0) i1 = 0; else {
   HEAP32[i162 >> 2] = i6;
   if (i1) _memset(i1 | 0, 0, i2 | 0) | 0;
  }
 } else i1 = 0;
 i152 = i11 << 24 >> 24 != 0;
 i153 = (i1 | 0) != 0;
 i154 = i160 + 34474 | 0;
 f151 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f150 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f149 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f146 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i147 = i160 + 34472 | 0;
 i148 = (i4 | 0) == 0;
 i144 = (i14 & 16 | 0) == 0;
 i89 = (i16 | 0) == 0 ? 0 : i16 + 3 & -4;
 i90 = i89 + 8 | 0;
 i91 = i89 + 4 | 0;
 i145 = i156 + 4 | 0;
 i92 = i169 + 4 | 0;
 i93 = i169 + 8 | 0;
 i94 = i169 + 12 | 0;
 i95 = i170 + 4 | 0;
 i96 = i170 + 8 | 0;
 i97 = i170 + 12 | 0;
 i98 = i4 + 4 | 0;
 i99 = i4 + 20 | 0;
 i100 = i160 + 64 | 0;
 i101 = i160 + 68 | 0;
 i102 = i160 + 72 | 0;
 i103 = i160 + 80 | 0;
 i104 = i160 + 84 | 0;
 i105 = i160 + 88 | 0;
 i106 = i160 + 96 | 0;
 i107 = i160 + 100 | 0;
 i108 = i160 + 104 | 0;
 i109 = i160 + 112 | 0;
 i110 = i160 + 116 | 0;
 i111 = i160 + 120 | 0;
 i112 = i160 + 192 | 0;
 i113 = i160 + 196 | 0;
 i114 = i160 + 200 | 0;
 i115 = i160 + 204 | 0;
 i116 = i160 + 208 | 0;
 i117 = i160 + 212 | 0;
 i118 = i160 + 216 | 0;
 i119 = i160 + 220 | 0;
 i120 = i160 + 224 | 0;
 i121 = i164 + 4 | 0;
 i122 = i160 + 34372 | 0;
 i123 = i160 + 34376 | 0;
 i124 = i160 + 34380 | 0;
 i125 = i160 + 34384 | 0;
 i126 = i160 + 34356 | 0;
 i127 = i160 + 34360 | 0;
 i128 = i160 + 34364 | 0;
 i129 = i160 + 34368 | 0;
 i130 = i160 + 34473 | 0;
 i131 = i169 + 4 | 0;
 i132 = i169 + 8 | 0;
 i133 = i169 + 12 | 0;
 i134 = i170 + 4 | 0;
 i135 = i170 + 8 | 0;
 i136 = i170 + 12 | 0;
 i137 = i160 + 33008 | 0;
 i138 = i160 + 33012 | 0;
 i139 = i160 + 33016 | 0;
 i140 = i160 + 33024 | 0;
 i141 = i160 + 33028 | 0;
 i142 = i160 + 33032 | 0;
 i143 = i160 + 33036 | 0;
 i67 = i11 << 24 >> 24 == 0;
 i60 = i163 + 92 | 0;
 i61 = i163 + 96 | 0;
 i62 = i163 + 100 | 0;
 i63 = i163 + 104 | 0;
 i64 = i163 + 108 | 0;
 i65 = i163 + 112 | 0;
 i66 = i163 + 116 | 0;
 i68 = i160 + 33040 | 0;
 i69 = i165 + 4 | 0;
 i70 = i165 + 8 | 0;
 i71 = i165 + 12 | 0;
 i72 = i166 + 4 | 0;
 i73 = i166 + 8 | 0;
 i74 = i166 + 12 | 0;
 i75 = i169 + 4 | 0;
 i76 = i169 + 8 | 0;
 i77 = i169 + 12 | 0;
 i78 = i170 + 4 | 0;
 i79 = i170 + 8 | 0;
 i80 = i170 + 12 | 0;
 i81 = i169 + 4 | 0;
 i82 = i169 + 8 | 0;
 i83 = i169 + 12 | 0;
 i84 = i170 + 4 | 0;
 i85 = i170 + 8 | 0;
 i86 = i170 + 12 | 0;
 i87 = (i168 | 0) == 0;
 i88 = (i168 + -1 | 0) == (i167 | 0);
 i59 = i12 + i13 | 0;
 i58 = i59 << 2;
 i59 = i59 + (i155 << 8) | 0;
 i15 = 0;
 i47 = 0;
 f48 = Math_fround(0.0);
 f49 = Math_fround(0.0);
 f50 = Math_fround(0.0);
 f51 = Math_fround(0.0);
 f52 = Math_fround(0.0);
 f53 = Math_fround(0.0);
 f54 = Math_fround(0.0);
 f55 = Math_fround(3402823469999999843913219.0e14);
 i7 = 0;
 i45 = 0;
 i46 = 0;
 i6 = 0;
 i9 = 0;
 i8 = 0;
 i2 = i18;
 i44 = 0;
 i11 = i19;
 i13 = 0;
 i12 = 0;
 i43 = 0;
 i14 = 0;
 L52 : while (1) {
  i10 = (i8 | 0) == 0;
  do if (!i5) if (i10) break L52; else {
   i57 = i15;
   i5 = 0;
   i10 = i12;
  } else if (i10) {
   i10 = i9;
   while (1) {
    L59 : do if (i67) {
     i57 = HEAP32[i158 >> 2] | 0;
     i7 = i57 + 40 | 0;
     i10 = i57 + 32 | 0;
     if (!i57) {
      i10 = HEAP32[i163 >> 2] | 0;
      i12 = i10;
      i6 = i12 + 64 | 0;
      while (1) {
       HEAP32[i60 >> 2] = 0;
       HEAP32[i61 >> 2] = 0;
       HEAP32[i62 >> 2] = i10;
       HEAP32[i63 >> 2] = i10;
       HEAP32[i64 >> 2] = 0;
       HEAP32[i65 >> 2] = 0;
       HEAP32[i66 >> 2] = 0;
       i8 = HEAP32[i6 >> 2] | 0;
       i2 = i2 + 1 | 0;
       i5 = i5 + -1 | 0;
       if ((i5 | 0) == 0 | (i8 | 0) != 0) {
        i7 = 0;
        i6 = 0;
        i9 = i10;
        i11 = i10;
        break L59;
       }
      }
     }
     do {
      do if ((i2 | 0) == -1) i171 = 44; else {
       i6 = (HEAP32[i10 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) + (i2 << 5)) | 0;
       if (!i6) {
        i171 = 44;
        break;
       }
       i11 = HEAP32[i6 >> 2] | 0;
       i9 = HEAP32[i163 >> 2] | 0;
       i35 = HEAP32[i9 + (HEAP32[i9 + 180 >> 2] | 0) + (i2 << 2) >> 2] | 0;
       i56 = i9 + (HEAP32[i9 + 184 >> 2] | 0) | 0;
       i42 = HEAP32[i56 + (i2 << 2) >> 2] | 0;
       i57 = i2 + 1 | 0;
       i56 = (HEAP32[i56 + (i57 << 2) >> 2] | 0) - i42 | 0;
       HEAP32[i60 >> 2] = i2;
       HEAP32[i61 >> 2] = i6;
       HEAP32[i62 >> 2] = i11;
       HEAP32[i63 >> 2] = i9;
       HEAP32[i64 >> 2] = i35;
       HEAP32[i65 >> 2] = i42;
       HEAP32[i66 >> 2] = i56;
       i2 = i57;
      } while (0);
      if ((i171 | 0) == 44) {
       i171 = 0;
       i9 = HEAP32[i163 >> 2] | 0;
       HEAP32[i60 >> 2] = 0;
       HEAP32[i61 >> 2] = 0;
       HEAP32[i62 >> 2] = i9;
       HEAP32[i63 >> 2] = i9;
       HEAP32[i64 >> 2] = 0;
       HEAP32[i65 >> 2] = 0;
       HEAP32[i66 >> 2] = 0;
       i2 = i2 + 1 | 0;
       i6 = 0;
       i11 = i9;
      }
      i12 = i11;
      i8 = HEAP32[i12 + 64 >> 2] | 0;
      i5 = i5 + -1 | 0;
     } while (!((i5 | 0) == 0 | (i8 | 0) != 0));
     i7 = 0;
    } else {
     i12 = i11;
     i7 = HEAP32[i12 + 64 >> 2] | 0;
     do if (i87 | (i7 | 0) == 0) {
      i7 = 0;
      i8 = 0;
     } else {
      i9 = (i7 | 0) % 2 | 0;
      i7 = i7 - i9 | 0;
      i57 = (i7 | 0) / (i168 | 0) | 0;
      i8 = (i57 | 0) % 2 | 0;
      i8 = (i8 | 0) == 0 ? i57 : i57 + 2 - i8 | 0;
      i7 = i7 - (Math_imul(i8, i168) | 0) | 0;
      if ((i7 | 0) > -1) {
       i56 = (i7 >>> 1 | 0) > (i167 | 0);
       i57 = i8 + 2 | 0;
       i42 = Math_imul(i57, i167) | 0;
       i7 = i7 + (Math_imul(i8, i167) | 0) | 0;
       i7 = i56 ? i42 : i7;
       i8 = (i56 ? i57 : i8) + (i88 ? i9 : 0) | 0;
       break;
      } else {
       i42 = Math_imul(i8, i167) | 0;
       i57 = (i7 | 0) / 2 | 0;
       i56 = i57 + i168 | 0;
       i57 = i7 + i9 - (Math_imul(i57, i8) | 0) | 0;
       i7 = i42;
       i8 = ((i56 | 0) > (i167 | 0) ? i8 : 0) + ((i56 + -1 | 0) == (i167 | 0) ? i57 : 0) | 0;
       break;
      }
     } while (0);
     i9 = i10;
     i5 = i5 + -1 | 0;
    } while (0);
    i34 = HEAP32[i12 + 68 >> 2] | 0;
    i35 = HEAP32[i12 + 72 >> 2] | 0;
    i42 = i11;
    i28 = HEAP32[i42 + 20 >> 2] | 0;
    i29 = HEAP32[i42 + 24 >> 2] | 0;
    i30 = HEAP32[i42 + 28 >> 2] | 0;
    i31 = HEAP32[i42 + 32 >> 2] | 0;
    i32 = HEAP32[i42 + 36 >> 2] | 0;
    i33 = HEAP32[i42 + 40 >> 2] | 0;
    HEAP32[i165 >> 2] = i28;
    HEAP32[i69 >> 2] = i29;
    HEAP32[i70 >> 2] = i30;
    HEAP32[i71 >> 2] = 1065353216;
    HEAP32[i166 >> 2] = i31;
    HEAP32[i72 >> 2] = i32;
    HEAP32[i73 >> 2] = i33;
    HEAP32[i74 >> 2] = 1065353216;
    if (__ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i68, i165, i166) | 0) {
     HEAP32[i169 >> 2] = i28;
     HEAP32[i75 >> 2] = i29;
     HEAP32[i76 >> 2] = i30;
     HEAP32[i77 >> 2] = 1065353216;
     HEAP32[i170 >> 2] = i31;
     HEAP32[i78 >> 2] = i32;
     HEAP32[i79 >> 2] = i33;
     HEAP32[i80 >> 2] = 1065353216;
     __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i68, i164, 0, i169, i170) | 0;
     if (!i159) break;
     if ((HEAP32[i161 >> 2] | 0) > 0) {
      f36 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f38 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f39 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i26 = 0;
      i27 = 0;
      do {
       i13 = i3 + (i26 * 96 | 0) | 0;
       HEAP32[i169 >> 2] = i28;
       HEAP32[i81 >> 2] = i29;
       HEAP32[i82 >> 2] = i30;
       HEAP32[i83 >> 2] = 1065353216;
       HEAP32[i170 >> 2] = i31;
       HEAP32[i84 >> 2] = i32;
       HEAP32[i85 >> 2] = i33;
       HEAP32[i86 >> 2] = 1065353216;
       __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i160 + 34496 + (i26 * 1408 | 0) | 0, i13, 0, i169, i170) | 0;
       i10 = (i13 | 0) == 0;
       i13 = HEAP32[(i10 ? i160 + 34496 + (i26 * 1408 | 0) + 1196 | 0 : i13) >> 2] | 0;
       do if (!i13) i10 = 1; else {
        i10 = i10 ? i160 + 34496 + (i26 * 1408 | 0) + 1228 | 0 : i3 + (i26 * 96 | 0) + 4 | 0;
        i18 = f36 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1332 >> 2]);
        i56 = f37 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1336 >> 2]);
        i57 = f38 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1340 >> 2]);
        i25 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1344 >> 2]) < Math_fround(1.0);
        i19 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1316 >> 2]) > f39;
        i23 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1320 >> 2]) > f40;
        i24 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1324 >> 2]) > f41;
        i19 = i18 | i19;
        i23 = i56 | i23;
        i24 = i57 | i24;
        i25 = i25 | Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1328 >> 2]) > Math_fround(1.0);
        if ((i13 | 0) > 3) {
         i15 = i13 + -4 | 0;
         i16 = i15 & -4;
         i18 = i16 + 4 | 0;
         i14 = i10;
         f22 = Math_fround(0.0);
         f21 = Math_fround(0.0);
         f20 = Math_fround(0.0);
         f17 = Math_fround(0.0);
         while (1) {
          i183 = HEAP32[i14 >> 2] | 0;
          i182 = HEAP32[i14 + 4 >> 2] | 0;
          i181 = HEAP32[i14 + 8 >> 2] | 0;
          i57 = HEAP32[i14 + 12 >> 2] | 0;
          i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) >> 2] | 0;
          i56 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) + 4 >> 2] | 0;
          i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i184 | i184 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) >> 2]));
          f177 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i56 | i56 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 4 >> 2]));
          f175 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i180 | i180 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 8 >> 2]));
          f177 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 12 >> 2]) + Math_fround(f175 + Math_fround(f178 + f177)));
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) >> 2] | 0;
          i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) + 4 >> 2] | 0;
          i56 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i183 | i183 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) >> 2]));
          f175 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i180 | i180 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 4 >> 2]));
          f176 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i56 | i56 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f176 = Math_fround(f176 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 8 >> 2]));
          f175 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 12 >> 2]) + Math_fround(f176 + Math_fround(f178 + f175)));
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) >> 2] | 0;
          i56 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 4 >> 2] | 0;
          i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i182 | i182 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) >> 2]));
          f176 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i56 | i56 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f176 = Math_fround(f176 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 4 >> 2]));
          f174 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i180 | i180 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f174 = Math_fround(f174 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 8 >> 2]));
          f176 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 12 >> 2]) + Math_fround(f174 + Math_fround(f178 + f176)));
          i181 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i57 << 4) >> 2] | 0;
          i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i57 << 4) + 4 >> 2] | 0;
          i56 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i57 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i181 | i181 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i57 << 4) >> 2]));
          f174 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i180 | i180 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f174 = Math_fround(f174 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i57 << 4) + 4 >> 2]));
          f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i56 | i56 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i57 << 4) + 8 >> 2]));
          f174 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i57 << 4) + 12 >> 2]) + Math_fround(f179 + Math_fround(f178 + f174)));
          f175 = f177 <= f175 ? f177 : f175;
          f174 = f176 <= f174 ? f176 : f174;
          f174 = f175 <= f174 ? f175 : f174;
          f22 = f22 <= f174 ? f22 : f174;
          f21 = f21 <= f174 ? f21 : f174;
          f20 = f20 <= f174 ? f20 : f174;
          f17 = f17 <= f174 ? f17 : f174;
          i13 = i13 + -4 | 0;
          if ((i13 | 0) <= 3) break; else i14 = i14 + 16 | 0;
         }
         i13 = i15 - i16 | 0;
         i10 = i10 + (i18 << 2) | 0;
        } else {
         f22 = Math_fround(0.0);
         f21 = Math_fround(0.0);
         f20 = Math_fround(0.0);
         f17 = Math_fround(0.0);
        }
        switch (i13 | 0) {
        case 3:
         {
          i171 = HEAP32[i10 >> 2] | 0;
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 4 >> 2] | 0;
          i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 8 >> 2] | 0;
          f178 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28 & ~i182 | i182 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) >> 2]));
          f179 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29 & ~i183 | i183 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 4 >> 2]));
          f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 8 >> 2]));
          f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
          i10 = i10 + 4 | 0;
          f22 = f22 <= f179 ? f22 : f179;
          f21 = f21 <= f179 ? f21 : f179;
          f20 = f20 <= f179 ? f20 : f179;
          f17 = f17 <= f179 ? f17 : f179;
          i171 = 63;
          break;
         }
        case 2:
         {
          i171 = 63;
          break;
         }
        case 1:
         {
          i171 = 64;
          break;
         }
        default:
         {}
        }
        if ((i171 | 0) == 63) {
         i184 = HEAP32[i10 >> 2] | 0;
         i181 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) >> 2] | 0;
         i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 4 >> 2] | 0;
         i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 8 >> 2] | 0;
         f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i181 | i181 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) >> 2]));
         f179 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i182 | i182 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 4 >> 2]));
         f177 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 8 >> 2]));
         f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
         i10 = i10 + 4 | 0;
         f22 = f22 <= f179 ? f22 : f179;
         f21 = f21 <= f179 ? f21 : f179;
         f20 = f20 <= f179 ? f20 : f179;
         f17 = f17 <= f179 ? f17 : f179;
         i171 = 64;
        }
        if ((i171 | 0) == 64) {
         i171 = 0;
         i184 = HEAP32[i10 >> 2] | 0;
         i181 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) >> 2] | 0;
         i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 4 >> 2] | 0;
         i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 8 >> 2] | 0;
         f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i181 | i181 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) >> 2]));
         f179 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i182 | i182 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 4 >> 2]));
         f177 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 8 >> 2]));
         f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
         f22 = f22 <= f179 ? f22 : f179;
         f21 = f21 <= f179 ? f21 : f179;
         f20 = f20 <= f179 ? f20 : f179;
         f17 = f17 <= f179 ? f17 : f179;
        }
        if (i19 | f22 < Math_fround(0.0) | (i23 | f21 < Math_fround(0.0)) | (i24 | f20 < Math_fround(0.0))) {
         i10 = 0;
         break;
        }
        i10 = (i25 | f17 < Math_fround(0.0)) ^ 1;
       } while (0);
       HEAP8[i3 + (i26 * 96 | 0) + 92 >> 0] = i10 & 1;
       i27 = i27 | i10;
       i26 = i26 + 1 | 0;
      } while ((i26 | 0) < (HEAP32[i161 >> 2] | 0));
      if (i27) break;
     }
    }
    if (!i5) break L52; else i10 = i9;
   }
   i15 = (i34 | 0) == 0 ? 0 : i34 + (i7 * 24 | 0) | 0;
   i14 = (i35 | 0) == 0 ? 0 : i35 + (i7 << 5) | 0;
   i184 = (i14 | 0) == 0;
   i13 = i184 & 1 ^ 1;
   i15 = (i15 | 0) == 0 ? 0 : i12 + i15 | 0;
   i14 = i184 ? 0 : i12 + i14 | 0;
   if (!(i5 | i8)) break L52;
   i10 = HEAP32[i42 + 16 >> 2] | 0;
   if (!(i10 & 3)) {
    i57 = 0;
    i10 = i15;
   } else {
    i12 = HEAP32[i42 + 320 >> 2] | 0;
    if (!(i10 & 2)) {
     i47 = HEAP32[i42 + 316 >> 2] | 0;
     i184 = i11;
     i43 = HEAP32[i42 + 324 >> 2] | 0;
     i57 = 1;
     i47 = (i47 | 0) == 0 ? 0 : i184 + i47 | 0;
     i45 = Math_imul(i58, HEAP32[i42 + 328 >> 2] | 0) | 0;
     i44 = (i12 | 0) == 0 ? 0 : i184 + i12 | 0;
     i10 = i15;
     i43 = (i43 | 0) == 0 ? 0 : i184 + i43 | 0;
     break;
    } else {
     i57 = 1;
     i45 = Math_imul(HEAP32[i42 + 64 >> 2] | 0, i59) | 0;
     i46 = i11 + i12 | 0;
     i10 = i15;
     break;
    }
   }
  } else {
   i57 = i15;
   i10 = i12;
  } while (0);
  if (i152 | (i6 | 0) == 0) i35 = i7; else i35 = HEAP32[i9 + (HEAP32[i6 + 8 >> 2] | 0) + (i7 << 2) >> 2] | 0;
  i42 = i7 + 1 | 0;
  i8 = i8 + -1 | 0;
  i56 = i10 + 24 | 0;
  i26 = HEAP32[i10 >> 2] | 0;
  i30 = HEAP32[i10 + 4 >> 2] | 0;
  i28 = HEAP32[i10 + 8 >> 2] | 0;
  i25 = HEAP32[i10 + 12 >> 2] | 0;
  i29 = HEAP32[i10 + 16 >> 2] | 0;
  i27 = HEAP32[i10 + 20 >> 2] | 0;
  i15 = i13 << 24 >> 24 == 0;
  if (!i15) {
   f48 = Math_fround(HEAPF32[i14 >> 2]);
   f49 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f50 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f51 = Math_fround(HEAPF32[i14 + 12 >> 2]);
   f52 = Math_fround(HEAPF32[i14 + 16 >> 2]);
   f53 = Math_fround(HEAPF32[i14 + 20 >> 2]);
   f54 = Math_fround(HEAPF32[i14 + 24 >> 2]);
   f55 = Math_fround(HEAPF32[i14 + 28 >> 2]);
   i14 = i14 + 32 | 0;
  }
  if (i153) if (HEAP32[i1 + (i35 >> 5 << 2) >> 2] & 1 << (i35 & 31) | 0) {
   i15 = i57;
   i7 = i42;
   i12 = i56;
   continue;
  }
  do if (!(HEAP8[i154 >> 0] | 0)) i171 = 140; else {
   i10 = i35 >> 5;
   i12 = 1 << (i35 & 31);
   if (!(HEAP32[i160 + 45760 + (i10 << 2) >> 2] & i12)) i171 = 140; else {
    if (HEAP8[i130 >> 0] | 0) {
     i182 = HEAP32[i137 >> 2] | 0;
     i183 = HEAP32[i138 >> 2] | 0;
     i184 = HEAP32[i139 >> 2] | 0;
     f178 = Math_fround(HEAPF32[i140 >> 2]);
     f178 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26 & ~i182 | i182 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f178);
     f179 = Math_fround(HEAPF32[i141 >> 2]);
     f179 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f179);
     f177 = Math_fround(HEAPF32[i142 >> 2]);
     f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28 & ~i184 | i184 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f177);
     if (Math_fround(Math_fround(HEAPF32[i143 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179))) < Math_fround(0.0)) break;
    }
    do if (i57) if (!i46) {
     i184 = (HEAP32[i47 + (i7 << 6) + (i155 << 3) >> 2] << 2) + i45 | 0;
     if ((HEAP16[i43 + (HEAP32[i47 + (i7 << 6) + (i155 << 3) + 4 >> 2] << 1) + (((HEAP32[i44 + (i184 >> 5 << 2) >> 2] | 0) >>> (i184 & 31) & 15) << 1) >> 1] | 0) == 32639) break; else {
      i15 = 1;
      i7 = i42;
      i46 = 0;
      i12 = i56;
      continue L52;
     }
    } else {
     i184 = i7 + i45 | 0;
     if (!(HEAP32[i46 + (i184 >> 5 << 2) >> 2] & 1 << (i184 & 31))) {
      i15 = 1;
      i7 = i42;
      i12 = i56;
      continue L52;
     } else break;
    } while (0);
    i7 = i1 + (i10 << 2) | 0;
    if (i153) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i12;
    if (!i159) {
     i7 = HEAP32[i157 >> 2] | 0;
     if ((i7 | 0) >= (HEAP32[i145 >> 2] | 0)) {
      i171 = 138;
      break L52;
     }
     HEAP32[(HEAP32[i156 >> 2] | 0) + (i7 << 2) >> 2] = i35;
     HEAP32[i157 >> 2] = (HEAP32[i157 >> 2] | 0) + 1;
     i15 = i57;
     i7 = i42;
     i12 = i56;
     continue L52;
    }
    if (i148) {
     i34 = i25;
     i33 = i26;
     i32 = i27;
     i31 = i28;
    } else {
     i30 = (HEAP32[i98 >> 2] | 0) + (Math_imul(HEAP32[i99 >> 2] | 0, i35) | 0) | 0;
     i34 = HEAP32[i30 + 12 >> 2] | 0;
     i33 = HEAP32[i30 >> 2] | 0;
     i32 = HEAP32[i30 + 20 >> 2] | 0;
     i31 = HEAP32[i30 + 8 >> 2] | 0;
     i29 = HEAP32[i30 + 16 >> 2] | 0;
     i30 = HEAP32[i30 + 4 >> 2] | 0;
    }
    L144 : do if (i144) {
     i27 = HEAP32[i161 >> 2] | 0;
     if ((i27 | 0) <= 0) {
      i15 = i57;
      i7 = i42;
      i12 = i56;
      continue L52;
     }
     f36 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f37 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f38 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f39 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f41 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i26 = 0;
     i10 = 0;
     do {
      do if (HEAP8[i3 + (i26 * 96 | 0) + 92 >> 0] | 0) {
       i12 = i3 + (i26 * 96 | 0) | 0;
       i7 = (i12 | 0) == 0;
       i12 = HEAP32[(i7 ? i160 + 34496 + (i26 * 1408 | 0) + 1196 | 0 : i12) >> 2] | 0;
       if (i12 | 0) {
        i16 = i7 ? i160 + 34496 + (i26 * 1408 | 0) + 1228 | 0 : i3 + (i26 * 96 | 0) + 4 | 0;
        i182 = f36 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1332 >> 2]);
        i183 = f37 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1336 >> 2]);
        i184 = f38 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1340 >> 2]);
        i25 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1344 >> 2]) < Math_fround(1.0);
        i19 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1316 >> 2]) > f39;
        i23 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1320 >> 2]) > f40;
        i24 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1324 >> 2]) > f41;
        i19 = i182 | i19;
        i23 = i183 | i23;
        i24 = i184 | i24;
        i25 = i25 | Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1328 >> 2]) > Math_fround(1.0);
        if ((i12 | 0) > 3) {
         i15 = i12 + -4 | 0;
         i18 = i15 & -4;
         i7 = i16;
         f22 = Math_fround(0.0);
         f21 = Math_fround(0.0);
         f20 = Math_fround(0.0);
         f17 = Math_fround(0.0);
         while (1) {
          i28 = HEAP32[i7 >> 2] | 0;
          i180 = HEAP32[i7 + 4 >> 2] | 0;
          i181 = HEAP32[i7 + 8 >> 2] | 0;
          i184 = HEAP32[i7 + 12 >> 2] | 0;
          i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i28 << 4) >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i28 << 4) + 4 >> 2] | 0;
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i28 << 4) + 8 >> 2] | 0;
          f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i185 | i185 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i28 << 4) >> 2]));
          f176 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f176 = Math_fround(f176 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i28 << 4) + 4 >> 2]));
          f178 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i182 | i182 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i28 << 4) + 8 >> 2]));
          f176 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i28 << 4) + 12 >> 2]) + Math_fround(f178 + Math_fround(f175 + f176)));
          i28 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i180 << 4) >> 2] | 0;
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i180 << 4) + 4 >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i180 << 4) + 8 >> 2] | 0;
          f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i28 | i28 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i180 << 4) >> 2]));
          f178 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i182 | i182 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i180 << 4) + 4 >> 2]));
          f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i183 | i183 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i180 << 4) + 8 >> 2]));
          f178 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i180 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f175 + f178)));
          i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 4 >> 2] | 0;
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 8 >> 2] | 0;
          f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i180 | i180 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) >> 2]));
          f177 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 4 >> 2]));
          f179 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i182 | i182 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 8 >> 2]));
          f177 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 12 >> 2]) + Math_fround(f179 + Math_fround(f175 + f177)));
          i181 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) >> 2] | 0;
          i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 4 >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i184 << 4) + 8 >> 2] | 0;
          f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i181 | i181 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) >> 2]));
          f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i182 | i182 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 4 >> 2]));
          f174 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i183 | i183 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f174 = Math_fround(f174 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 8 >> 2]));
          f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i184 << 4) + 12 >> 2]) + Math_fround(f174 + Math_fround(f175 + f179)));
          f178 = f176 <= f178 ? f176 : f178;
          f179 = f177 <= f179 ? f177 : f179;
          f179 = f178 <= f179 ? f178 : f179;
          f22 = f22 <= f179 ? f22 : f179;
          f21 = f21 <= f179 ? f21 : f179;
          f20 = f20 <= f179 ? f20 : f179;
          f17 = f17 <= f179 ? f17 : f179;
          i12 = i12 + -4 | 0;
          if ((i12 | 0) <= 3) break; else i7 = i7 + 16 | 0;
         }
         i12 = i15 - i18 | 0;
         i7 = i16 + (i18 + 4 << 2) | 0;
        } else {
         i7 = i16;
         f22 = Math_fround(0.0);
         f21 = Math_fround(0.0);
         f20 = Math_fround(0.0);
         f17 = Math_fround(0.0);
        }
        switch (i12 | 0) {
        case 3:
         {
          i171 = HEAP32[i7 >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) >> 2] | 0;
          i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 4 >> 2] | 0;
          i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 8 >> 2] | 0;
          f178 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) >> 2]));
          f179 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 4 >> 2]));
          f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 8 >> 2]));
          f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
          i7 = i7 + 4 | 0;
          f22 = f22 <= f179 ? f22 : f179;
          f21 = f21 <= f179 ? f21 : f179;
          f20 = f20 <= f179 ? f20 : f179;
          f17 = f17 <= f179 ? f17 : f179;
          i171 = 126;
          break;
         }
        case 2:
         {
          i171 = 126;
          break;
         }
        case 1:
         {
          i171 = 127;
          break;
         }
        default:
         {}
        }
        if ((i171 | 0) == 126) {
         i185 = HEAP32[i7 >> 2] | 0;
         i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) >> 2] | 0;
         i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) + 4 >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) + 8 >> 2] | 0;
         f178 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i182 | i182 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) >> 2]));
         f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 4 >> 2]));
         f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 8 >> 2]));
         f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
         i7 = i7 + 4 | 0;
         f22 = f22 <= f179 ? f22 : f179;
         f21 = f21 <= f179 ? f21 : f179;
         f20 = f20 <= f179 ? f20 : f179;
         f17 = f17 <= f179 ? f17 : f179;
         i171 = 127;
        }
        if ((i171 | 0) == 127) {
         i171 = 0;
         i185 = HEAP32[i7 >> 2] | 0;
         i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) >> 2] | 0;
         i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) + 4 >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i185 << 4) + 8 >> 2] | 0;
         f178 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i182 | i182 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) >> 2]));
         f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 4 >> 2]));
         f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 8 >> 2]));
         f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i185 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
         f22 = f22 <= f179 ? f22 : f179;
         f21 = f21 <= f179 ? f21 : f179;
         f20 = f20 <= f179 ? f20 : f179;
         f17 = f17 <= f179 ? f17 : f179;
        }
        if (i19 | f22 < Math_fround(0.0) | (i23 | f21 < Math_fround(0.0)) | (i24 | f20 < Math_fround(0.0)) | (i25 | f17 < Math_fround(0.0))) break;
       }
       i10 = 1 << i26 | i10;
      } while (0);
      i26 = i26 + 1 | 0;
     } while ((i26 | 0) != (i27 | 0));
     if (!i10) {
      i15 = i57;
      i7 = i42;
      i12 = i56;
      continue L52;
     }
     i7 = HEAP32[i90 >> 2] | 0;
     if ((i7 | 0) < (HEAP32[i91 >> 2] | 0)) {
      HEAP32[(HEAP32[i89 >> 2] | 0) + (i7 << 2) >> 2] = i10;
      i7 = HEAP32[i90 >> 2] | 0;
     }
     HEAP32[i90 >> 2] = i7 + 1;
    } else {
     do if ((HEAP32[i161 >> 2] | 0) > 0) {
      f36 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f38 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f39 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i28 = 0;
      i10 = 0;
      L176 : while (1) {
       do if (HEAP8[i3 + (i28 * 96 | 0) + 92 >> 0] | 0) {
        i26 = i160 + 34496 + (i28 * 1408 | 0) | 0;
        i27 = i3 + (i28 * 96 | 0) | 0;
        i7 = (i27 | 0) == 0;
        i12 = HEAP32[(i7 ? i160 + 34496 + (i28 * 1408 | 0) + 1196 | 0 : i27) >> 2] | 0;
        if (i12 | 0) {
         i16 = i7 ? i160 + 34496 + (i28 * 1408 | 0) + 1228 | 0 : i3 + (i28 * 96 | 0) + 4 | 0;
         i183 = f36 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1332 >> 2]);
         i184 = f37 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1336 >> 2]);
         i185 = f38 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1340 >> 2]);
         i25 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1344 >> 2]) < Math_fround(1.0);
         i19 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1316 >> 2]) > f39;
         i23 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1320 >> 2]) > f40;
         i24 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1324 >> 2]) > f41;
         i19 = i183 | i19;
         i23 = i184 | i23;
         i24 = i185 | i24;
         i25 = i25 | Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1328 >> 2]) > Math_fround(1.0);
         if ((i12 | 0) > 3) {
          i15 = i12 + -4 | 0;
          i18 = i15 & -4;
          i7 = i16;
          f22 = Math_fround(0.0);
          f21 = Math_fround(0.0);
          f20 = Math_fround(0.0);
          f17 = Math_fround(0.0);
          while (1) {
           i180 = HEAP32[i7 >> 2] | 0;
           i181 = HEAP32[i7 + 4 >> 2] | 0;
           i182 = HEAP32[i7 + 8 >> 2] | 0;
           i185 = HEAP32[i7 + 12 >> 2] | 0;
           i186 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i180 << 4) >> 2] | 0;
           i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i180 << 4) + 4 >> 2] | 0;
           i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i180 << 4) + 8 >> 2] | 0;
           f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i186 | i186 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i180 << 4) >> 2]));
           f176 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f176 = Math_fround(f176 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i180 << 4) + 4 >> 2]));
           f178 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i183 | i183 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i180 << 4) + 8 >> 2]));
           f176 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i180 << 4) + 12 >> 2]) + Math_fround(f178 + Math_fround(f175 + f176)));
           i180 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) >> 2] | 0;
           i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) + 4 >> 2] | 0;
           i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) + 8 >> 2] | 0;
           f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i180 | i180 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) >> 2]));
           f178 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 4 >> 2]));
           f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 8 >> 2]));
           f178 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f175 + f178)));
           i181 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) >> 2] | 0;
           i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) + 4 >> 2] | 0;
           i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) + 8 >> 2] | 0;
           f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i181 | i181 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) >> 2]));
           f177 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 4 >> 2]));
           f179 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i183 | i183 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 8 >> 2]));
           f177 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 12 >> 2]) + Math_fround(f179 + Math_fround(f175 + f177)));
           i182 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i185 << 4) >> 2] | 0;
           i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i185 << 4) + 4 >> 2] | 0;
           i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i185 << 4) + 8 >> 2] | 0;
           f175 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i182 | i182 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i185 << 4) >> 2]));
           f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i183 | i183 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i185 << 4) + 4 >> 2]));
           f174 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f174 = Math_fround(f174 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i185 << 4) + 8 >> 2]));
           f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i185 << 4) + 12 >> 2]) + Math_fround(f174 + Math_fround(f175 + f179)));
           f178 = f176 <= f178 ? f176 : f178;
           f179 = f177 <= f179 ? f177 : f179;
           f179 = f178 <= f179 ? f178 : f179;
           f22 = f22 <= f179 ? f22 : f179;
           f21 = f21 <= f179 ? f21 : f179;
           f20 = f20 <= f179 ? f20 : f179;
           f17 = f17 <= f179 ? f17 : f179;
           i12 = i12 + -4 | 0;
           if ((i12 | 0) <= 3) break; else i7 = i7 + 16 | 0;
          }
          i12 = i15 - i18 | 0;
          i7 = i16 + (i18 + 4 << 2) | 0;
         } else {
          i7 = i16;
          f22 = Math_fround(0.0);
          f21 = Math_fround(0.0);
          f20 = Math_fround(0.0);
          f17 = Math_fround(0.0);
         }
         switch (i12 | 0) {
         case 3:
          {
           i171 = HEAP32[i7 >> 2] | 0;
           i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) >> 2] | 0;
           i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) + 4 >> 2] | 0;
           i186 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) + 8 >> 2] | 0;
           f178 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33 & ~i184 | i184 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) >> 2]));
           f179 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 4 >> 2]));
           f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31 & ~i186 | i186 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 8 >> 2]));
           f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
           i7 = i7 + 4 | 0;
           f22 = f22 <= f179 ? f22 : f179;
           f21 = f21 <= f179 ? f21 : f179;
           f20 = f20 <= f179 ? f20 : f179;
           f17 = f17 <= f179 ? f17 : f179;
           i171 = 105;
           break;
          }
         case 2:
          {
           i171 = 105;
           break;
          }
         case 1:
          {
           i171 = 106;
           break;
          }
         default:
          {}
         }
         if ((i171 | 0) == 105) {
          i186 = HEAP32[i7 >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
          i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
          i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
          f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
          f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
          f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
          i7 = i7 + 4 | 0;
          f22 = f22 <= f179 ? f22 : f179;
          f21 = f21 <= f179 ? f21 : f179;
          f20 = f20 <= f179 ? f20 : f179;
          f17 = f17 <= f179 ? f17 : f179;
          i171 = 106;
         }
         if ((i171 | 0) == 106) {
          i171 = 0;
          i186 = HEAP32[i7 >> 2] | 0;
          i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
          i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
          i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
          f178 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
          f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
          f177 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
          f179 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
          f22 = f22 <= f179 ? f22 : f179;
          f21 = f21 <= f179 ? f21 : f179;
          f20 = f20 <= f179 ? f20 : f179;
          f17 = f17 <= f179 ? f17 : f179;
         }
         if (i19 | f22 < Math_fround(0.0) | (i23 | f21 < Math_fround(0.0)) | (i24 | f20 < Math_fround(0.0)) | (i25 | f17 < Math_fround(0.0))) break;
        }
        i10 = 1 << i28 | i10;
        HEAP32[i169 >> 2] = i33;
        HEAP32[i131 >> 2] = i30;
        HEAP32[i132 >> 2] = i31;
        HEAP32[i133 >> 2] = 1065353216;
        HEAP32[i170 >> 2] = i34;
        HEAP32[i134 >> 2] = i29;
        HEAP32[i135 >> 2] = i32;
        HEAP32[i136 >> 2] = 1065353216;
        if (__ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_(i26, i27, i169, i170) | 0) break L176;
       } while (0);
       i28 = i28 + 1 | 0;
       if ((i28 | 0) >= (HEAP32[i161 >> 2] | 0)) {
        i171 = 110;
        break;
       }
      }
      if ((i171 | 0) == 110) {
       i171 = 0;
       if (!i10) break;
      }
      i7 = HEAP32[i90 >> 2] | 0;
      if ((i7 | 0) < (HEAP32[i91 >> 2] | 0)) {
       HEAP32[(HEAP32[i89 >> 2] | 0) + (i7 << 2) >> 2] = i10;
       i7 = HEAP32[i90 >> 2] | 0;
      }
      HEAP32[i90 >> 2] = i7 + 1;
      break L144;
     } while (0);
     i15 = i57;
     i7 = i42;
     i12 = i56;
     continue L52;
    } while (0);
    i7 = HEAP32[i157 >> 2] | 0;
    if ((i7 | 0) >= (HEAP32[i145 >> 2] | 0)) {
     i171 = 135;
     break L52;
    }
    HEAP32[(HEAP32[i156 >> 2] | 0) + (i7 << 2) >> 2] = i35;
    HEAP32[i157 >> 2] = (HEAP32[i157 >> 2] | 0) + 1;
    i15 = i57;
    i7 = i42;
    i12 = i56;
    continue L52;
   }
  } while (0);
  if ((i171 | 0) == 140) {
   i171 = 0;
   if (!i15) {
    f178 = f48 >= f151 ? f48 : f151;
    f179 = f49 >= f150 ? f49 : f150;
    f177 = f50 >= f149 ? f50 : f149;
    f178 = Math_fround((f52 <= f178 ? f52 : f178) - f151);
    f179 = Math_fround((f53 <= f179 ? f53 : f179) - f150);
    f177 = Math_fround((f54 <= f177 ? f54 : f177) - f149);
    f179 = Math_fround(f146 * Math_fround(Math_fround(Math_fround(f177 * f177) + Math_fround(Math_fround(f178 * f178) + Math_fround(f179 * f179))) + Math_fround(0.0)));
    if (f179 >= f55 | f51 > f179) {
     i15 = i57;
     i7 = i42;
     i12 = i56;
     continue;
    }
   }
  }
  i10 = HEAP32[i164 >> 2] | 0;
  if (i10 | 0) {
   f179 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i184 = f179 > Math_fround(HEAPF32[i122 >> 2]);
   f179 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i185 = f179 > Math_fround(HEAPF32[i123 >> 2]);
   f179 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i186 = f179 > Math_fround(HEAPF32[i124 >> 2]);
   i24 = Math_fround(HEAPF32[i125 >> 2]) < Math_fround(1.0);
   f179 = Math_fround(HEAPF32[i126 >> 2]);
   i18 = f179 > (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f179 = Math_fround(HEAPF32[i127 >> 2]);
   i19 = f179 > (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f179 = Math_fround(HEAPF32[i128 >> 2]);
   i23 = f179 > (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i18 = i184 | i18;
   i19 = i185 | i19;
   i23 = i186 | i23;
   i24 = i24 | Math_fround(HEAPF32[i129 >> 2]) > Math_fround(1.0);
   if ((i10 | 0) > 3) {
    i15 = i10 + -4 | 0;
    i16 = i15 & -4;
    i12 = i121;
    f22 = Math_fround(0.0);
    f21 = Math_fround(0.0);
    f20 = Math_fround(0.0);
    f17 = Math_fround(0.0);
    while (1) {
     i181 = HEAP32[i12 >> 2] | 0;
     i182 = HEAP32[i12 + 4 >> 2] | 0;
     i183 = HEAP32[i12 + 8 >> 2] | 0;
     i186 = HEAP32[i12 + 12 >> 2] | 0;
     i180 = HEAP32[i160 + 33872 + (i181 << 4) >> 2] | 0;
     i185 = HEAP32[i160 + 33872 + (i181 << 4) + 4 >> 2] | 0;
     i184 = HEAP32[i160 + 33872 + (i181 << 4) + 8 >> 2] | 0;
     f175 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i180 | i180 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 33520 + (i181 << 4) >> 2]));
     f176 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f176 = Math_fround(f176 * Math_fround(HEAPF32[i160 + 33520 + (i181 << 4) + 4 >> 2]));
     f178 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i184 | i184 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 33520 + (i181 << 4) + 8 >> 2]));
     f176 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i181 << 4) + 12 >> 2]) + Math_fround(f178 + Math_fround(f175 + f176)));
     i181 = HEAP32[i160 + 33872 + (i182 << 4) >> 2] | 0;
     i184 = HEAP32[i160 + 33872 + (i182 << 4) + 4 >> 2] | 0;
     i185 = HEAP32[i160 + 33872 + (i182 << 4) + 8 >> 2] | 0;
     f175 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i181 | i181 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 33520 + (i182 << 4) >> 2]));
     f178 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 33520 + (i182 << 4) + 4 >> 2]));
     f177 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i185 | i185 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 33520 + (i182 << 4) + 8 >> 2]));
     f178 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i182 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f175 + f178)));
     i182 = HEAP32[i160 + 33872 + (i183 << 4) >> 2] | 0;
     i185 = HEAP32[i160 + 33872 + (i183 << 4) + 4 >> 2] | 0;
     i184 = HEAP32[i160 + 33872 + (i183 << 4) + 8 >> 2] | 0;
     f175 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i182 | i182 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 33520 + (i183 << 4) >> 2]));
     f177 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 33520 + (i183 << 4) + 4 >> 2]));
     f179 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i184 | i184 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 33520 + (i183 << 4) + 8 >> 2]));
     f177 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i183 << 4) + 12 >> 2]) + Math_fround(f179 + Math_fround(f175 + f177)));
     i183 = HEAP32[i160 + 33872 + (i186 << 4) >> 2] | 0;
     i184 = HEAP32[i160 + 33872 + (i186 << 4) + 4 >> 2] | 0;
     i185 = HEAP32[i160 + 33872 + (i186 << 4) + 8 >> 2] | 0;
     f175 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i183 | i183 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f175 = Math_fround(f175 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) >> 2]));
     f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 4 >> 2]));
     f174 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i185 | i185 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f174 = Math_fround(f174 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 8 >> 2]));
     f179 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 12 >> 2]) + Math_fround(f174 + Math_fround(f175 + f179)));
     f178 = f176 <= f178 ? f176 : f178;
     f179 = f177 <= f179 ? f177 : f179;
     f179 = f178 <= f179 ? f178 : f179;
     f22 = f22 <= f179 ? f22 : f179;
     f21 = f21 <= f179 ? f21 : f179;
     f20 = f20 <= f179 ? f20 : f179;
     f17 = f17 <= f179 ? f17 : f179;
     i10 = i10 + -4 | 0;
     if ((i10 | 0) <= 3) break; else i12 = i12 + 16 | 0;
    }
    i10 = i15 - i16 | 0;
    i12 = i164 + 4 + (i16 + 4 << 2) | 0;
   } else {
    i12 = i121;
    f22 = Math_fround(0.0);
    f21 = Math_fround(0.0);
    f20 = Math_fround(0.0);
    f17 = Math_fround(0.0);
   }
   switch (i10 | 0) {
   case 3:
    {
     i10 = HEAP32[i12 >> 2] | 0;
     i185 = HEAP32[i160 + 33872 + (i10 << 4) >> 2] | 0;
     i186 = HEAP32[i160 + 33872 + (i10 << 4) + 4 >> 2] | 0;
     i171 = HEAP32[i160 + 33872 + (i10 << 4) + 8 >> 2] | 0;
     f178 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26 & ~i185 | i185 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 33520 + (i10 << 4) >> 2]));
     f179 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i186 | i186 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 33520 + (i10 << 4) + 4 >> 2]));
     f177 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28 & ~i171 | i171 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 33520 + (i10 << 4) + 8 >> 2]));
     f179 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i10 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
     i10 = i12 + 4 | 0;
     f22 = f22 <= f179 ? f22 : f179;
     f21 = f21 <= f179 ? f21 : f179;
     f20 = f20 <= f179 ? f20 : f179;
     f17 = f17 <= f179 ? f17 : f179;
     i171 = 149;
     break;
    }
   case 2:
    {
     i10 = i12;
     i171 = 149;
     break;
    }
   case 1:
    {
     i171 = 150;
     break;
    }
   default:
    {}
   }
   if ((i171 | 0) == 149) {
    i12 = HEAP32[i10 >> 2] | 0;
    i184 = HEAP32[i160 + 33872 + (i12 << 4) >> 2] | 0;
    i185 = HEAP32[i160 + 33872 + (i12 << 4) + 4 >> 2] | 0;
    i186 = HEAP32[i160 + 33872 + (i12 << 4) + 8 >> 2] | 0;
    f178 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i184 | i184 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 33520 + (i12 << 4) >> 2]));
    f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 33520 + (i12 << 4) + 4 >> 2]));
    f177 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i186 | i186 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 33520 + (i12 << 4) + 8 >> 2]));
    f179 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i12 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
    i12 = i10 + 4 | 0;
    f22 = f22 <= f179 ? f22 : f179;
    f21 = f21 <= f179 ? f21 : f179;
    f20 = f20 <= f179 ? f20 : f179;
    f17 = f17 <= f179 ? f17 : f179;
    i171 = 150;
   }
   if ((i171 | 0) == 150) {
    i171 = 0;
    i186 = HEAP32[i12 >> 2] | 0;
    i183 = HEAP32[i160 + 33872 + (i186 << 4) >> 2] | 0;
    i184 = HEAP32[i160 + 33872 + (i186 << 4) + 4 >> 2] | 0;
    i185 = HEAP32[i160 + 33872 + (i186 << 4) + 8 >> 2] | 0;
    f178 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i183 | i183 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(f178 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) >> 2]));
    f179 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f179 = Math_fround(f179 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 4 >> 2]));
    f177 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i185 | i185 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f177 = Math_fround(f177 * Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 8 >> 2]));
    f179 = Math_fround(Math_fround(HEAPF32[i160 + 33520 + (i186 << 4) + 12 >> 2]) + Math_fround(f177 + Math_fround(f178 + f179)));
    f22 = f22 <= f179 ? f22 : f179;
    f21 = f21 <= f179 ? f21 : f179;
    f20 = f20 <= f179 ? f20 : f179;
    f17 = f17 <= f179 ? f17 : f179;
   }
   if (i18 | f22 < Math_fround(0.0) | (i19 | f21 < Math_fround(0.0)) | (i23 | f20 < Math_fround(0.0)) | (i24 | f17 < Math_fround(0.0))) {
    i15 = i57;
    i7 = i42;
    i12 = i56;
    continue;
   }
  }
  do if (i57) if (!i46) {
   i186 = (HEAP32[i47 + (i7 << 6) + (i155 << 3) >> 2] << 2) + i45 | 0;
   if ((HEAP16[i43 + (HEAP32[i47 + (i7 << 6) + (i155 << 3) + 4 >> 2] << 1) + (((HEAP32[i44 + (i186 >> 5 << 2) >> 2] | 0) >>> (i186 & 31) & 15) << 1) >> 1] | 0) == 32639) break; else {
    i15 = 1;
    i7 = i42;
    i46 = 0;
    i12 = i56;
    continue L52;
   }
  } else {
   i186 = i7 + i45 | 0;
   if (!(HEAP32[i46 + (i186 >> 5 << 2) >> 2] & 1 << (i186 & 31))) {
    i15 = 1;
    i7 = i42;
    i12 = i56;
    continue L52;
   } else break;
  } while (0);
  L232 : do if (HEAP8[i147 >> 0] | 0) {
   f190 = Math_fround(HEAPF32[i100 >> 2]);
   f188 = Math_fround(HEAPF32[i101 >> 2]);
   f37 = Math_fround(HEAPF32[i102 >> 2]);
   f17 = Math_fround(HEAPF32[i103 >> 2]);
   f21 = Math_fround(HEAPF32[i104 >> 2]);
   f178 = Math_fround(HEAPF32[i105 >> 2]);
   f36 = Math_fround(HEAPF32[i106 >> 2]);
   f40 = Math_fround(HEAPF32[i107 >> 2]);
   f175 = Math_fround(HEAPF32[i108 >> 2]);
   f176 = Math_fround(HEAPF32[i109 >> 2]);
   f39 = Math_fround(HEAPF32[i110 >> 2]);
   f179 = Math_fround(HEAPF32[i111 >> 2]);
   f38 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f191 = Math_fround(f38 * f190);
   f189 = Math_fround(f38 * f188);
   f38 = Math_fround(f38 * f37);
   i24 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
   i33 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
   f41 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f187 = Math_fround(f41 * f17);
   f20 = Math_fround(f41 * f21);
   f41 = Math_fround(f41 * f178);
   i181 = (HEAPF32[tempDoublePtr >> 2] = f187, HEAP32[tempDoublePtr >> 2] | 0);
   i184 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   f177 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(f177 * f36);
   f174 = Math_fround(f177 * f40);
   f177 = Math_fround(f177 * f175);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
   f192 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f190 = Math_fround(f192 * f190);
   f188 = Math_fround(f192 * f188);
   f37 = Math_fround(f192 * f37);
   i31 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
   i34 = (HEAPF32[tempDoublePtr >> 2] = f188, HEAP32[tempDoublePtr >> 2] | 0);
   f192 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f192 * f17);
   f21 = Math_fround(f192 * f21);
   f178 = Math_fround(f192 * f178);
   i182 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i185 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   f192 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f36 = Math_fround(f192 * f36);
   f40 = Math_fround(f192 * f40);
   f175 = Math_fround(f192 * f175);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   i23 = f191 > f190;
   i32 = f189 > f188;
   i180 = f187 > f17;
   i183 = f20 > f21;
   i186 = f22 > f36;
   i16 = f174 > f40;
   f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23 ? i31 : i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f176);
   f174 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32 ? i34 : i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f39);
   f179 = Math_fround((f38 > f37 ? f37 : f38) + f179);
   f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i180 ? i182 : i181, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f40);
   f174 = Math_fround((HEAP32[tempDoublePtr >> 2] = i183 ? i185 : i184, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f174);
   f179 = Math_fround((f41 > f178 ? f178 : f41) + f179);
   f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i186 ? i18 : i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f40);
   f174 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i15 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f174);
   f179 = Math_fround((f177 > f175 ? f175 : f177) + f179);
   f176 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23 ? i24 : i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f176);
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32 ? i33 : i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f39);
   f176 = Math_fround((HEAP32[tempDoublePtr >> 2] = i180 ? i181 : i182, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f176);
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i183 ? i184 : i185, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f39);
   f176 = Math_fround((HEAP32[tempDoublePtr >> 2] = i186 ? i19 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f176);
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i7 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f39);
   f177 = Math_fround(HEAPF32[i112 >> 2]);
   f40 = Math_fround(f177 * f40);
   f175 = Math_fround(HEAPF32[i113 >> 2]);
   f174 = Math_fround(f175 * f174);
   f41 = Math_fround(HEAPF32[i114 >> 2]);
   f176 = Math_fround(f176 * f41);
   f178 = Math_fround(HEAPF32[i115 >> 2]);
   f40 = Math_fround(Math_fround(f177 + Math_fround(0.0)) + f40);
   f174 = Math_fround(Math_fround(f175 + Math_fround(0.0)) + f174);
   f176 = Math_fround(Math_fround(f41 + Math_fround(1.0)) + f176);
   f178 = Math_fround(Math_fround(f178 + Math_fround(1.0)) + Math_fround(f39 * f178));
   i15 = f40 <= Math_fround(0.0);
   f40 = i15 ? Math_fround(0.0) : f40;
   i15 = f174 <= Math_fround(0.0);
   f174 = i15 ? Math_fround(0.0) : f174;
   i15 = f176 <= Math_fround(0.0);
   f176 = i15 ? Math_fround(0.0) : f176;
   i15 = f178 <= Math_fround(0.0);
   f178 = i15 ? Math_fround(0.0) : f178;
   f39 = Math_fround(HEAPF32[i116 >> 2]);
   f41 = Math_fround(HEAPF32[i117 >> 2]);
   f175 = Math_fround(HEAPF32[i118 >> 2]);
   f177 = Math_fround(HEAPF32[i119 >> 2]);
   i15 = ~~(f39 <= f40 ? f39 : f40);
   i7 = ~~(f41 <= f174 ? f41 : f174);
   i16 = ~~(f175 <= f176 ? f175 : f176);
   i18 = ~~(f177 <= f178 ? f177 : f178);
   f178 = Math_fround(HEAPF32[i120 >> 2]);
   f179 = Math_fround(f179 * f178);
   i19 = f179 <= Math_fround(0.0);
   f179 = i19 ? Math_fround(0.0) : f179;
   i19 = ~~(f178 <= f179 ? f178 : f179);
   if (!((i15 | 0) < (i16 | 0) & (i7 | 0) < (i18 | 0))) {
    i15 = i57;
    i7 = i42;
    i12 = i56;
    continue L52;
   }
   while (1) {
    i12 = i7 << 7;
    i10 = i15;
    do {
     if ((i19 | 0) < (HEAPU16[i160 + 240 + (i10 + i12 << 1) >> 1] | 0)) break L232;
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) < (i16 | 0));
    i7 = i7 + 1 | 0;
    if ((i7 | 0) >= (i18 | 0)) {
     i15 = i57;
     i7 = i42;
     i12 = i56;
     continue L52;
    }
   }
  } while (0);
  i7 = i1 + (i35 >> 5 << 2) | 0;
  if (i153) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i35 & 31);
  if (!i159) {
   i7 = HEAP32[i157 >> 2] | 0;
   if ((i7 | 0) >= (HEAP32[i145 >> 2] | 0)) {
    i171 = 211;
    break;
   }
   HEAP32[(HEAP32[i156 >> 2] | 0) + (i7 << 2) >> 2] = i35;
   HEAP32[i157 >> 2] = (HEAP32[i157 >> 2] | 0) + 1;
   i15 = i57;
   i7 = i42;
   i12 = i56;
   continue;
  }
  if (i148) {
   i34 = i25;
   i33 = i26;
   i32 = i27;
   i31 = i28;
  } else {
   i30 = (HEAP32[i98 >> 2] | 0) + (Math_imul(HEAP32[i99 >> 2] | 0, i35) | 0) | 0;
   i34 = HEAP32[i30 + 12 >> 2] | 0;
   i33 = HEAP32[i30 >> 2] | 0;
   i32 = HEAP32[i30 + 20 >> 2] | 0;
   i31 = HEAP32[i30 + 8 >> 2] | 0;
   i29 = HEAP32[i30 + 16 >> 2] | 0;
   i30 = HEAP32[i30 + 4 >> 2] | 0;
  }
  L251 : do if (i144) {
   i27 = HEAP32[i161 >> 2] | 0;
   if ((i27 | 0) <= 0) {
    i15 = i57;
    i7 = i42;
    i12 = i56;
    continue L52;
   }
   f36 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f41 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i26 = 0;
   i10 = 0;
   do {
    do if (HEAP8[i3 + (i26 * 96 | 0) + 92 >> 0] | 0) {
     i12 = i3 + (i26 * 96 | 0) | 0;
     i7 = (i12 | 0) == 0;
     i12 = HEAP32[(i7 ? i160 + 34496 + (i26 * 1408 | 0) + 1196 | 0 : i12) >> 2] | 0;
     if (i12 | 0) {
      i16 = i7 ? i160 + 34496 + (i26 * 1408 | 0) + 1228 | 0 : i3 + (i26 * 96 | 0) + 4 | 0;
      i184 = f36 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1332 >> 2]);
      i185 = f37 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1336 >> 2]);
      i186 = f38 > Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1340 >> 2]);
      i25 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1344 >> 2]) < Math_fround(1.0);
      i19 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1316 >> 2]) > f39;
      i23 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1320 >> 2]) > f40;
      i24 = Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1324 >> 2]) > f41;
      i19 = i184 | i19;
      i23 = i185 | i23;
      i24 = i186 | i24;
      i25 = i25 | Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 1328 >> 2]) > Math_fround(1.0);
      if ((i12 | 0) > 3) {
       i15 = i12 + -4 | 0;
       i18 = i15 & -4;
       i7 = i16;
       f22 = Math_fround(0.0);
       f21 = Math_fround(0.0);
       f20 = Math_fround(0.0);
       f17 = Math_fround(0.0);
       while (1) {
        i181 = HEAP32[i7 >> 2] | 0;
        i182 = HEAP32[i7 + 4 >> 2] | 0;
        i183 = HEAP32[i7 + 8 >> 2] | 0;
        i186 = HEAP32[i7 + 12 >> 2] | 0;
        i180 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 4 >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i181 << 4) + 8 >> 2] | 0;
        f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i180 | i180 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) >> 2]));
        f189 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f189 = Math_fround(f189 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 4 >> 2]));
        f191 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 8 >> 2]));
        f189 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i181 << 4) + 12 >> 2]) + Math_fround(f191 + Math_fround(f188 + f189)));
        i181 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i182 << 4) + 8 >> 2] | 0;
        f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i181 | i181 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) >> 2]));
        f191 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 4 >> 2]));
        f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 8 >> 2]));
        f191 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i182 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f188 + f191)));
        i182 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) + 4 >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i183 << 4) + 8 >> 2] | 0;
        f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i182 | i182 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) >> 2]));
        f190 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 4 >> 2]));
        f192 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 8 >> 2]));
        f190 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i183 << 4) + 12 >> 2]) + Math_fround(f192 + Math_fround(f188 + f190)));
        i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
        f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
        f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
        f187 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f187 = Math_fround(f187 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
        f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f187 + Math_fround(f188 + f192)));
        f191 = f189 <= f191 ? f189 : f191;
        f192 = f190 <= f192 ? f190 : f192;
        f192 = f191 <= f192 ? f191 : f192;
        f22 = f22 <= f192 ? f22 : f192;
        f21 = f21 <= f192 ? f21 : f192;
        f20 = f20 <= f192 ? f20 : f192;
        f17 = f17 <= f192 ? f17 : f192;
        i12 = i12 + -4 | 0;
        if ((i12 | 0) <= 3) break; else i7 = i7 + 16 | 0;
       }
       i12 = i15 - i18 | 0;
       i7 = i16 + (i18 + 4 << 2) | 0;
      } else {
       i7 = i16;
       f22 = Math_fround(0.0);
       f21 = Math_fround(0.0);
       f20 = Math_fround(0.0);
       f17 = Math_fround(0.0);
      }
      switch (i12 | 0) {
      case 3:
       {
        i171 = HEAP32[i7 >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 4 >> 2] | 0;
        i186 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i171 << 4) + 8 >> 2] | 0;
        f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33 & ~i184 | i184 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) >> 2]));
        f192 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 4 >> 2]));
        f190 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31 & ~i186 | i186 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 8 >> 2]));
        f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i171 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
        i7 = i7 + 4 | 0;
        f22 = f22 <= f192 ? f22 : f192;
        f21 = f21 <= f192 ? f21 : f192;
        f20 = f20 <= f192 ? f20 : f192;
        f17 = f17 <= f192 ? f17 : f192;
        i171 = 199;
        break;
       }
      case 2:
       {
        i171 = 199;
        break;
       }
      case 1:
       {
        i171 = 200;
        break;
       }
      default:
       {}
      }
      if ((i171 | 0) == 199) {
       i186 = HEAP32[i7 >> 2] | 0;
       i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
       i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
       i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
       f191 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
       f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
       f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
       f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
       i7 = i7 + 4 | 0;
       f22 = f22 <= f192 ? f22 : f192;
       f21 = f21 <= f192 ? f21 : f192;
       f20 = f20 <= f192 ? f20 : f192;
       f17 = f17 <= f192 ? f17 : f192;
       i171 = 200;
      }
      if ((i171 | 0) == 200) {
       i171 = 0;
       i186 = HEAP32[i7 >> 2] | 0;
       i183 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
       i184 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
       i185 = HEAP32[i160 + 34496 + (i26 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
       f191 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
       f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
       f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
       f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i26 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
       f22 = f22 <= f192 ? f22 : f192;
       f21 = f21 <= f192 ? f21 : f192;
       f20 = f20 <= f192 ? f20 : f192;
       f17 = f17 <= f192 ? f17 : f192;
      }
      if (i19 | f22 < Math_fround(0.0) | (i23 | f21 < Math_fround(0.0)) | (i24 | f20 < Math_fround(0.0)) | (i25 | f17 < Math_fround(0.0))) break;
     }
     i10 = 1 << i26 | i10;
    } while (0);
    i26 = i26 + 1 | 0;
   } while ((i26 | 0) != (i27 | 0));
   if (!i10) {
    i15 = i57;
    i7 = i42;
    i12 = i56;
    continue L52;
   }
   i7 = HEAP32[i90 >> 2] | 0;
   if ((i7 | 0) < (HEAP32[i91 >> 2] | 0)) {
    HEAP32[(HEAP32[i89 >> 2] | 0) + (i7 << 2) >> 2] = i10;
    i7 = HEAP32[i90 >> 2] | 0;
   }
   HEAP32[i90 >> 2] = i7 + 1;
  } else {
   do if ((HEAP32[i161 >> 2] | 0) > 0) {
    f36 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f41 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i28 = 0;
    i10 = 0;
    L283 : while (1) {
     do if (HEAP8[i3 + (i28 * 96 | 0) + 92 >> 0] | 0) {
      i26 = i160 + 34496 + (i28 * 1408 | 0) | 0;
      i27 = i3 + (i28 * 96 | 0) | 0;
      i7 = (i27 | 0) == 0;
      i12 = HEAP32[(i7 ? i160 + 34496 + (i28 * 1408 | 0) + 1196 | 0 : i27) >> 2] | 0;
      if (i12 | 0) {
       i16 = i7 ? i160 + 34496 + (i28 * 1408 | 0) + 1228 | 0 : i3 + (i28 * 96 | 0) + 4 | 0;
       i184 = f36 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1332 >> 2]);
       i185 = f37 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1336 >> 2]);
       i186 = f38 > Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1340 >> 2]);
       i25 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1344 >> 2]) < Math_fround(1.0);
       i19 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1316 >> 2]) > f39;
       i23 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1320 >> 2]) > f40;
       i24 = Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1324 >> 2]) > f41;
       i19 = i184 | i19;
       i23 = i185 | i23;
       i24 = i186 | i24;
       i25 = i25 | Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 1328 >> 2]) > Math_fround(1.0);
       if ((i12 | 0) > 3) {
        i15 = i12 + -4 | 0;
        i18 = i15 & -4;
        i7 = i16;
        f22 = Math_fround(0.0);
        f21 = Math_fround(0.0);
        f20 = Math_fround(0.0);
        f17 = Math_fround(0.0);
        while (1) {
         i181 = HEAP32[i7 >> 2] | 0;
         i182 = HEAP32[i7 + 4 >> 2] | 0;
         i183 = HEAP32[i7 + 8 >> 2] | 0;
         i186 = HEAP32[i7 + 12 >> 2] | 0;
         i180 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) >> 2] | 0;
         i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) + 4 >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i181 << 4) + 8 >> 2] | 0;
         f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i180 | i180 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) >> 2]));
         f189 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f189 = Math_fround(f189 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 4 >> 2]));
         f191 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 8 >> 2]));
         f189 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i181 << 4) + 12 >> 2]) + Math_fround(f191 + Math_fround(f188 + f189)));
         i181 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) + 4 >> 2] | 0;
         i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i182 << 4) + 8 >> 2] | 0;
         f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i181 | i181 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) >> 2]));
         f191 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 4 >> 2]));
         f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 8 >> 2]));
         f191 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i182 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f188 + f191)));
         i182 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i183 << 4) >> 2] | 0;
         i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i183 << 4) + 4 >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i183 << 4) + 8 >> 2] | 0;
         f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i182 | i182 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i183 << 4) >> 2]));
         f190 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i183 << 4) + 4 >> 2]));
         f192 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i184 | i184 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i183 << 4) + 8 >> 2]));
         f190 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i183 << 4) + 12 >> 2]) + Math_fround(f192 + Math_fround(f188 + f190)));
         i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
         i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
         f188 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f188 = Math_fround(f188 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
         f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
         f187 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f187 = Math_fround(f187 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
         f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f187 + Math_fround(f188 + f192)));
         f191 = f189 <= f191 ? f189 : f191;
         f192 = f190 <= f192 ? f190 : f192;
         f192 = f191 <= f192 ? f191 : f192;
         f22 = f22 <= f192 ? f22 : f192;
         f21 = f21 <= f192 ? f21 : f192;
         f20 = f20 <= f192 ? f20 : f192;
         f17 = f17 <= f192 ? f17 : f192;
         i12 = i12 + -4 | 0;
         if ((i12 | 0) <= 3) break; else i7 = i7 + 16 | 0;
        }
        i12 = i15 - i18 | 0;
        i7 = i16 + (i18 + 4 << 2) | 0;
       } else {
        i7 = i16;
        f22 = Math_fround(0.0);
        f21 = Math_fround(0.0);
        f20 = Math_fround(0.0);
        f17 = Math_fround(0.0);
       }
       switch (i12 | 0) {
       case 3:
        {
         i171 = HEAP32[i7 >> 2] | 0;
         i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) >> 2] | 0;
         i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) + 4 >> 2] | 0;
         i186 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i171 << 4) + 8 >> 2] | 0;
         f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33 & ~i184 | i184 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) >> 2]));
         f192 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 4 >> 2]));
         f190 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31 & ~i186 | i186 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 8 >> 2]));
         f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i171 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
         i7 = i7 + 4 | 0;
         f22 = f22 <= f192 ? f22 : f192;
         f21 = f21 <= f192 ? f21 : f192;
         f20 = f20 <= f192 ? f20 : f192;
         f17 = f17 <= f192 ? f17 : f192;
         i171 = 178;
         break;
        }
       case 2:
        {
         i171 = 178;
         break;
        }
       case 1:
        {
         i171 = 179;
         break;
        }
       default:
        {}
       }
       if ((i171 | 0) == 178) {
        i186 = HEAP32[i7 >> 2] | 0;
        i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
        f191 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
        f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
        f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
        f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
        i7 = i7 + 4 | 0;
        f22 = f22 <= f192 ? f22 : f192;
        f21 = f21 <= f192 ? f21 : f192;
        f20 = f20 <= f192 ? f20 : f192;
        f17 = f17 <= f192 ? f17 : f192;
        i171 = 179;
       }
       if ((i171 | 0) == 179) {
        i171 = 0;
        i186 = HEAP32[i7 >> 2] | 0;
        i183 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) >> 2] | 0;
        i184 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i160 + 34496 + (i28 * 1408 | 0) + 832 + (i186 << 4) + 8 >> 2] | 0;
        f191 = (HEAP32[tempDoublePtr >> 2] = i33 & ~i183 | i183 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f191 = Math_fround(f191 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) >> 2]));
        f192 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i184 | i184 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f192 = Math_fround(f192 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 4 >> 2]));
        f190 = (HEAP32[tempDoublePtr >> 2] = i31 & ~i185 | i185 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f190 = Math_fround(f190 * Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 8 >> 2]));
        f192 = Math_fround(Math_fround(HEAPF32[i160 + 34496 + (i28 * 1408 | 0) + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f190 + Math_fround(f191 + f192)));
        f22 = f22 <= f192 ? f22 : f192;
        f21 = f21 <= f192 ? f21 : f192;
        f20 = f20 <= f192 ? f20 : f192;
        f17 = f17 <= f192 ? f17 : f192;
       }
       if (i19 | f22 < Math_fround(0.0) | (i23 | f21 < Math_fround(0.0)) | (i24 | f20 < Math_fround(0.0)) | (i25 | f17 < Math_fround(0.0))) break;
      }
      i10 = 1 << i28 | i10;
      HEAP32[i169 >> 2] = i33;
      HEAP32[i92 >> 2] = i30;
      HEAP32[i93 >> 2] = i31;
      HEAP32[i94 >> 2] = 1065353216;
      HEAP32[i170 >> 2] = i34;
      HEAP32[i95 >> 2] = i29;
      HEAP32[i96 >> 2] = i32;
      HEAP32[i97 >> 2] = 1065353216;
      if (__ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_(i26, i27, i169, i170) | 0) break L283;
     } while (0);
     i28 = i28 + 1 | 0;
     if ((i28 | 0) >= (HEAP32[i161 >> 2] | 0)) {
      i171 = 183;
      break;
     }
    }
    if ((i171 | 0) == 183) {
     i171 = 0;
     if (!i10) break;
    }
    i7 = HEAP32[i90 >> 2] | 0;
    if ((i7 | 0) < (HEAP32[i91 >> 2] | 0)) {
     HEAP32[(HEAP32[i89 >> 2] | 0) + (i7 << 2) >> 2] = i10;
     i7 = HEAP32[i90 >> 2] | 0;
    }
    HEAP32[i90 >> 2] = i7 + 1;
    break L251;
   } while (0);
   i15 = i57;
   i7 = i42;
   i12 = i56;
   continue L52;
  } while (0);
  i7 = HEAP32[i157 >> 2] | 0;
  if ((i7 | 0) >= (HEAP32[i145 >> 2] | 0)) {
   i171 = 208;
   break;
  }
  HEAP32[(HEAP32[i156 >> 2] | 0) + (i7 << 2) >> 2] = i35;
  HEAP32[i157 >> 2] = (HEAP32[i157 >> 2] | 0) + 1;
  i15 = i57;
  i7 = i42;
  i12 = i56;
 }
 if ((i171 | 0) == 135) HEAP32[i157 >> 2] = i7 + 1; else if ((i171 | 0) == 138) HEAP32[i157 >> 2] = i7 + 1; else if ((i171 | 0) == 208) HEAP32[i157 >> 2] = i7 + 1; else if ((i171 | 0) == 211) HEAP32[i157 >> 2] = i7 + 1;
 if (i1 | 0) HEAP32[i162 >> 2] = i1;
 if (!i148) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i162 >> 2] = i4;
 }
 if (i3 | 0) HEAP32[i162 >> 2] = i3;
 i186 = (HEAP32[i157 >> 2] | 0) > (HEAP32[i145 >> 2] | 0) ? 2 : 0;
 __ZN5Umbra12QueryContextD2Ev(i172);
 STACKTOP = i173;
 return i186 | 0;
}

function __ZN5physx15PxVehicleUpdate13updateDrive4WEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDrive4WEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f52, i15, f53, f54, i14, i521, i517, i522) {
 f52 = Math_fround(f52);
 i15 = i15 | 0;
 f53 = Math_fround(f53);
 f54 = Math_fround(f54);
 i14 = i14 | 0;
 i521 = i521 | 0;
 i517 = i517 | 0;
 i522 = i522 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, i362 = 0, i363 = 0, i364 = 0, i365 = 0, i366 = 0, i367 = 0, i368 = 0, i369 = 0, i370 = 0, i371 = 0, i372 = 0, i373 = 0, i374 = 0, i375 = 0, i376 = 0, i377 = 0, i378 = 0, i379 = 0, i380 = 0, i381 = 0, i382 = 0, i383 = 0, i384 = 0, i385 = 0, i386 = 0, i387 = 0, i388 = 0, i389 = 0, i390 = 0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, i395 = 0, i396 = 0, i397 = 0, i398 = 0, i399 = 0, i400 = 0, i401 = 0, i402 = 0, i403 = 0, i404 = 0, i405 = 0, i406 = 0, i407 = 0, i408 = 0, i409 = 0, i410 = 0, i411 = 0, i412 = 0, i413 = 0, i414 = 0, i415 = 0, i416 = 0, i417 = 0, i418 = 0, i419 = 0, i420 = 0, i421 = 0, i422 = 0, i423 = 0, i424 = 0, i425 = 0, i426 = 0, i427 = 0, i428 = 0, i429 = 0, i430 = 0, i431 = 0, i432 = 0, i433 = 0, i434 = 0, i435 = 0, i436 = 0, i437 = 0, i438 = 0, i439 = 0, i440 = 0, i441 = 0, i442 = 0, i443 = 0, i444 = 0, i445 = 0, i446 = 0, i447 = 0, i448 = 0, i449 = 0, i450 = 0, i451 = 0, i452 = 0, i453 = 0, i454 = 0, i455 = 0, f456 = f0, f457 = f0, i458 = 0, i459 = 0, i460 = 0, f461 = f0, i462 = 0, i463 = 0, f464 = f0, i465 = 0, i466 = 0, f467 = f0, f468 = f0, i469 = 0, i470 = 0, i471 = 0, i472 = 0, i473 = 0, i474 = 0, i475 = 0, i476 = 0, i477 = 0, f478 = f0, i479 = 0, i480 = 0, i481 = 0, i482 = 0, i483 = 0, i484 = 0, i485 = 0, i486 = 0, i487 = 0, i488 = 0, i489 = 0, i490 = 0, i491 = 0, i492 = 0, i493 = 0, i494 = 0, i495 = 0, i496 = 0, i497 = 0, i498 = 0, i499 = 0, i500 = 0, i501 = 0, i502 = 0, i503 = 0, i504 = 0, i505 = 0, i506 = 0, i507 = 0, i508 = 0, i509 = 0, i510 = 0, i511 = 0, i512 = 0, i513 = 0, i514 = 0, i515 = 0, i516 = 0, i518 = 0, i519 = 0, i520 = 0, i523 = 0, f524 = f0, i525 = 0, i526 = 0;
 i523 = STACKTOP;
 STACKTOP = STACKTOP + 6544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i494 = i523 + 5960 | 0;
 i6 = i523 + 4840 | 0;
 i519 = i523 + 4800 | 0;
 i515 = i523 + 4780 | 0;
 i506 = i523 + 4680 | 0;
 i520 = i523 + 1720 | 0;
 i514 = i523 + 1640 | 0;
 i489 = i523 + 368 | 0;
 i502 = i523 + 280 | 0;
 i508 = i523 + 268 | 0;
 i507 = i523 + 256 | 0;
 i7 = i523 + 228 | 0;
 i8 = i523 + 200 | 0;
 i9 = i523 + 188 | 0;
 i10 = i523 + 176 | 0;
 i11 = i523 + 164 | 0;
 i486 = i523 + 160 | 0;
 i487 = i523 + 144 | 0;
 i503 = i523 + 136 | 0;
 i505 = i523 + 120 | 0;
 i492 = i523 + 1672 | 0;
 i490 = i523 + 108 | 0;
 i491 = i523 + 96 | 0;
 i488 = i523 + 80 | 0;
 i504 = i523 + 72 | 0;
 i509 = i523 + 1528 | 0;
 i516 = i523 + 400 | 0;
 i493 = i523 + 56 | 0;
 i500 = i523 + 296 | 0;
 i501 = i523 + 48 | 0;
 i498 = i523 + 32 | 0;
 i499 = i523 + 16 | 0;
 i495 = i523 + 12 | 0;
 i496 = i523 + 8 | 0;
 i497 = i523 + 4 | 0;
 i518 = i523;
 i485 = i521 + 8 | 0;
 i513 = HEAP32[i521 + 44 >> 2] | 0;
 i12 = (i513 | 0) == 0;
 if (!i12) {
  i1 = HEAP32[i521 + 72 >> 2] | 0;
  i4 = 0;
  do {
   i2 = i4 << 2;
   i3 = HEAP32[gb + 1458456 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) {
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 1) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 4 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 2) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 8 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 3) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 12 >> 2];
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i513 >>> 0);
 }
 i483 = i521 + 128 | 0;
 i484 = i521 + 204 | 0;
 i1 = HEAP32[gb + 1458536 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i484 >> 2];
 i510 = HEAP32[i521 + 40 >> 2] | 0;
 i5 = i521 + 72 | 0;
 i511 = HEAP32[i5 >> 2] | 0;
 i512 = HEAP32[i521 + 48 >> 2] | 0;
 i2 = 4 - (i513 << 2) | 0;
 i482 = HEAP32[i521 + 288 >> 2] | 0;
 _memcpy(i494 | 0, i521 + 224 | 0, i482 << 3 | 0) | 0;
 i481 = i494 + 64 | 0;
 HEAP32[i481 >> 2] = i482;
 i482 = i494 + 80 | 0;
 i3 = i521 + 304 | 0;
 HEAP32[i482 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i482 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i482 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i482 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i482 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i482 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i482 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i482 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 _memcpy(i494 + 112 | 0, i521 + 336 | 0, 416) | 0;
 i482 = i494 + 528 | 0;
 i3 = i482;
 i1 = i521 + 752 | 0;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i13 = HEAP32[i521 + 104 >> 2] | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 i1 = i6 + 60 | 0;
 i3 = i6 + 16 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 i1 = i6 + 116 | 0;
 i3 = i6 + 72 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 i1 = i6 + 172 | 0;
 i3 = i6 + 128 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 180 >> 2] = Math_fround(1.0);
 i1 = i6 + 228 | 0;
 i3 = i6 + 184 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 236 >> 2] = Math_fround(1.0);
 i1 = i6 + 284 | 0;
 i3 = i6 + 240 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 292 >> 2] = Math_fround(1.0);
 i1 = i6 + 340 | 0;
 i3 = i6 + 296 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 348 >> 2] = Math_fround(1.0);
 i1 = i6 + 396 | 0;
 i3 = i6 + 352 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 404 >> 2] = Math_fround(1.0);
 i1 = i6 + 452 | 0;
 i3 = i6 + 408 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 456 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 460 >> 2] = Math_fround(1.0);
 i1 = i6 + 508 | 0;
 i3 = i6 + 464 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 512 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 516 >> 2] = Math_fround(1.0);
 i1 = i6 + 564 | 0;
 i3 = i6 + 520 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 568 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 572 >> 2] = Math_fround(1.0);
 i1 = i6 + 620 | 0;
 i3 = i6 + 576 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 624 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 628 >> 2] = Math_fround(1.0);
 i1 = i6 + 676 | 0;
 i3 = i6 + 632 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 680 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 684 >> 2] = Math_fround(1.0);
 i1 = i6 + 732 | 0;
 i3 = i6 + 688 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 740 >> 2] = Math_fround(1.0);
 i1 = i6 + 788 | 0;
 i3 = i6 + 744 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 792 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 796 >> 2] = Math_fround(1.0);
 i1 = i6 + 844 | 0;
 i3 = i6 + 800 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 848 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 852 >> 2] = Math_fround(1.0);
 i1 = i6 + 900 | 0;
 i3 = i6 + 856 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 904 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 908 >> 2] = Math_fround(1.0);
 i1 = i6 + 956 | 0;
 i3 = i6 + 912 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 960 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 964 >> 2] = Math_fround(1.0);
 i1 = i6 + 1012 | 0;
 i3 = i6 + 968 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1016 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1020 >> 2] = Math_fround(1.0);
 i1 = i6 + 1068 | 0;
 i3 = i6 + 1024 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1072 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1076 >> 2] = Math_fround(1.0);
 i3 = i6 + 1080 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i3 = i2 + i512 | 0;
 HEAP32[i519 >> 2] = 0;
 HEAP32[i519 + 4 >> 2] = 0;
 HEAP32[i519 + 8 >> 2] = 0;
 HEAP32[i519 + 12 >> 2] = 0;
 HEAP32[i519 + 16 >> 2] = 0;
 HEAP32[i519 + 20 >> 2] = 0;
 HEAP32[i519 + 24 >> 2] = 0;
 HEAP32[i519 + 28 >> 2] = 0;
 HEAP16[i519 + 32 >> 1] = 0;
 HEAP32[i519 + 4 >> 2] = i512;
 HEAP32[i519 >> 2] = i6;
 if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i483, 3)) != Math_fround(0.0)) i480 = 13; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i483, 4)) != Math_fround(0.0)) i480 = 13; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i483, 0)) != Math_fround(0.0)) i480 = 13; else if (!(HEAP8[i521 + 194 >> 0] | 0)) if (!(HEAP8[i521 + 193 >> 0] | 0)) i1 = 0; else i480 = 13; else i480 = 13;
 if ((i480 | 0) == 13) i1 = 1;
 do if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 256 >> 2] | 0, i13 | 0) | 0) {
  if (i1) {
   HEAP8[i519 + 33 >> 0] = 1;
   break;
  }
  if (__ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE(i485, i5) | 0) {
   HEAP8[i519 + 33 >> 0] = 1;
   break;
  }
  i3 = ((HEAP32[i521 + 88 >> 2] | 0) + 3 | 0) >>> 2;
  i1 = HEAP32[i521 + 72 >> 2] | 0;
  if (i3 | 0) {
   i2 = 0;
   do {
    HEAPF32[i1 + (i2 * 224 | 0) >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  HEAPF32[i484 >> 2] = Math_fround(0.0);
  if (!i522) {
   STACKTOP = i523;
   return;
  }
  HEAP8[i522 + 32 >> 0] = 1;
  STACKTOP = i523;
  return;
 } while (0);
 HEAP32[i515 >> 2] = 0;
 HEAP32[i515 + 4 >> 2] = 0;
 HEAP32[i515 + 8 >> 2] = 0;
 HEAP32[i515 + 12 >> 2] = 0;
 HEAP32[i515 + 16 >> 2] = 0;
 HEAP32[i515 >> 2] = i512 >>> 0 < 4 ? i512 : 4;
 i1 = i513 + -1 | 0;
 if (i1 >>> 0 > 1) {
  i2 = 1;
  do {
   HEAP32[i515 + (i2 << 2) >> 2] = 4;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i515 + (i1 << 2) >> 2] = i3;
 if (!i12) {
  i1 = HEAP32[i521 + 76 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = 0;
  do {
   i479 = i3 << 2;
   HEAP32[i506 + (i3 * 20 | 0) >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + (i479 << 2) >> 2];
   HEAP32[i506 + (i3 * 20 | 0) + 4 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i479 | 1) << 2) >> 2];
   HEAP32[i506 + (i3 * 20 | 0) + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i479 | 2) << 2) >> 2];
   HEAP32[i506 + (i3 * 20 | 0) + 12 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i479 | 3) << 2) >> 2];
   HEAP32[i506 + (i3 * 20 | 0) + 16 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i513 | 0));
  if (!i12) {
   i1 = 0;
   do {
    i479 = HEAP32[(HEAP32[i511 + (i1 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i479 >> 2] | 0) + 36 >> 2] | 0, i479 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i513 | 0));
  }
 }
 i1 = i520 + 2960 | 0;
 i2 = i520;
 do {
  _memset(i2 | 0, 0, 140) | 0;
  HEAP8[i2 + 28 >> 0] = 1;
  HEAP32[i2 + 44 >> 2] = -1;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP32[i2 + 124 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 1065353216;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 140 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = 0;
  i2 = i2 + 148 | 0;
 } while ((i2 | 0) != (i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 124 >> 2] | 0, i7 | 0, i13 | 0);
 i475 = HEAP32[i7 >> 2] | 0;
 HEAP32[i514 >> 2] = i475;
 i472 = i514 + 4 | 0;
 HEAP32[i472 >> 2] = HEAP32[i7 + 4 >> 2];
 i473 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i514 + 8 >> 2] = i473;
 i474 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i514 + 12 >> 2] = i474;
 i459 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i514 + 16 >> 2] = i459;
 i477 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i514 + 20 >> 2] = i477;
 i476 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i514 + 24 >> 2] = i476;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 84 >> 2] | 0, i8 | 0, i13 | 0);
 f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i459, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f47 = Math_fround((HEAP32[tempDoublePtr >> 2] = i477, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i476, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f467 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f468 = Math_fround(Math_fround(f467 * f467) + Math_fround(-.5));
 f46 = Math_fround(HEAPF32[i8 >> 2]);
 f478 = Math_fround(f45 * f46);
 f44 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f478 = Math_fround(f478 + Math_fround(f47 * f44));
 f49 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f478 = Math_fround(f478 + Math_fround(f38 * f49));
 f48 = Math_fround(Math_fround(f46 * f478) + Math_fround(Math_fround(f45 * f468) + Math_fround(f467 * Math_fround(Math_fround(f38 * f44) - Math_fround(f47 * f49)))));
 f34 = Math_fround(Math_fround(f44 * f478) + Math_fround(Math_fround(f47 * f468) + Math_fround(f467 * Math_fround(Math_fround(f45 * f49) - Math_fround(f38 * f46)))));
 f478 = Math_fround(Math_fround(Math_fround(f38 * f468) + Math_fround(f467 * Math_fround(Math_fround(f47 * f46) - Math_fround(f45 * f44)))) + Math_fround(f49 * f478));
 f48 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) + f48);
 f34 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) + f34);
 f478 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) + f478);
 f45 = (HEAP32[tempDoublePtr >> 2] = i475, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f467 * f45);
 f468 = (HEAP32[tempDoublePtr >> 2] = i474, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f47 + Math_fround(f46 * f468));
 f38 = (HEAP32[tempDoublePtr >> 2] = i473, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f47 + Math_fround(f44 * f38));
 f51 = Math_fround(HEAPF32[i472 >> 2]);
 f47 = Math_fround(f47 - Math_fround(f49 * f51));
 f36 = Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(Math_fround(f44 * f468) + Math_fround(f467 * f51))) - Math_fround(f46 * f38));
 f50 = Math_fround(Math_fround(Math_fround(f46 * f51) + Math_fround(Math_fround(f49 * f468) + Math_fround(f467 * f38))) - Math_fround(f44 * f45));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f467 * f468) - Math_fround(f46 * f45)) - Math_fround(f44 * f51)) - Math_fround(f49 * f38));
 HEAPF32[i489 >> 2] = f47;
 i472 = i489 + 4 | 0;
 HEAPF32[i472 >> 2] = f36;
 i473 = i489 + 8 | 0;
 HEAPF32[i473 >> 2] = f50;
 i474 = i489 + 12 | 0;
 HEAPF32[i474 >> 2] = f38;
 i475 = i489 + 16 | 0;
 HEAPF32[i475 >> 2] = f48;
 i476 = i489 + 20 | 0;
 HEAPF32[i476 >> 2] = f34;
 i477 = i489 + 24 | 0;
 HEAPF32[i477 >> 2] = f478;
 f478 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i13 >> 2] | 0) + 136 >> 2] | 0, i13 | 0));
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i9 | 0, i13 | 0);
 HEAP32[i502 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i502 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i502 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0, i10 | 0, i13 | 0);
 i459 = HEAP32[i10 >> 2] | 0;
 HEAP32[i508 >> 2] = i459;
 i460 = HEAP32[i10 + 4 >> 2] | 0;
 i479 = i508 + 4 | 0;
 HEAP32[i479 >> 2] = i460;
 i462 = HEAP32[i10 + 8 >> 2] | 0;
 i470 = i508 + 8 | 0;
 HEAP32[i470 >> 2] = i462;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 160 >> 2] | 0, i11 | 0, i13 | 0);
 i463 = HEAP32[i11 >> 2] | 0;
 HEAP32[i507 >> 2] = i463;
 i465 = HEAP32[i11 + 4 >> 2] | 0;
 i471 = i507 + 4 | 0;
 HEAP32[i471 >> 2] = i465;
 i466 = HEAP32[i11 + 8 >> 2] | 0;
 i469 = i507 + 8 | 0;
 HEAP32[i469 >> 2] = i466;
 f34 = Math_fround(HEAPF32[i483 >> 2]);
 f48 = (HEAP32[tempDoublePtr >> 2] = i459, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = (HEAP32[tempDoublePtr >> 2] = i460, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i462, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i463, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i465, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i466, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (HEAP8[i521 + 192 >> 0] | 0) {
  i1 = HEAP32[i521 + 196 >> 2] | 0;
  i466 = HEAP32[i521 + 200 >> 2] | 0;
  f34 = (i1 | 0) == 1 & (i466 | 0) != (i1 | 0) ? Math_fround(0.0) : f34;
  i3 = i521 + 212 | 0;
  f35 = Math_fround(HEAPF32[i3 >> 2]);
  if ((i466 | 0) == (i1 | 0)) if (f35 > Math_fround(HEAPF32[i494 + 400 >> 2])) {
   f468 = Math_fround(HEAPF32[i484 >> 2]);
   f468 = Math_fround(f468 * Math_fround(HEAPF32[i494 + 108 >> 2]));
   i2 = i1 | 0 ? f468 > Math_fround(HEAPF32[i494 + 272 + (i1 << 2) >> 2]) : 0;
   i1 = i1 >>> 0 > 2 ? f468 < Math_fround(HEAPF32[i494 + 400 + (i1 << 2) >> 2]) : 0;
   if (!(i2 | i1)) break;
   HEAP8[i521 + 193 >> 0] = i2 & 1;
   HEAP8[i521 + 194 >> 0] = i1 & 1;
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   break;
  }
  HEAPF32[i3 >> 2] = Math_fround(f35 + f52);
 } while (0);
 i6 = i521 + 193 | 0;
 do if (!(HEAP8[i6 >> 0] | 0)) {
  i1 = i521 + 196 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i1 = (HEAP32[i494 + 244 >> 2] | 0) + -1 | 0;
  i2 = i521 + 196 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i1 = i521 + 200 | 0;
   if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) {
    if (!i3) {
     HEAPF32[i521 + 208 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
    HEAPF32[i521 + 208 >> 2] = Math_fround(0.0);
    if ((i3 | 0) == 1) {
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    } else {
     HEAP32[i1 >> 2] = i3 + 1;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
   } else i1 = i3;
  }
 } while (0);
 i5 = i521 + 194 | 0;
 do if (HEAP8[i5 >> 0] | 0) if (!i1) i1 = 0; else {
  i3 = i521 + 200 | 0;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   if ((i1 | 0) == 2) {
    HEAPF32[i521 + 208 >> 2] = Math_fround(0.0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
   HEAPF32[i521 + 208 >> 2] = Math_fround(0.0);
   if ((i1 | 0) == 1) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   } else {
    HEAP32[i3 >> 2] = i1 + -1;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
  }
 } while (0);
 i3 = HEAP32[i521 + 200 >> 2] | 0;
 do if ((i1 | 0) != (i3 | 0)) {
  i4 = i521 + 208 | 0;
  f35 = Math_fround(HEAPF32[i4 >> 2]);
  if (f35 > Math_fround(HEAPF32[i494 + 248 >> 2])) {
   HEAP32[i2 >> 2] = i3;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
   i1 = i3;
   break;
  } else {
   HEAPF32[i4 >> 2] = Math_fround(f35 + f52);
   break;
  }
 } while (0);
 i460 = (i1 | 0) == 1;
 f461 = Math_fround(HEAPF32[i494 + 256 >> 2]);
 f461 = i460 ? Math_fround(0.0) : f461;
 i462 = HEAP32[i494 + 260 >> 2] | 0;
 i463 = HEAP32[i494 + 264 >> 2] | 0;
 f464 = Math_fround(HEAPF32[i494 + 112 + (i1 << 2) >> 2]);
 f464 = Math_fround(f464 * Math_fround(HEAPF32[i494 + 240 >> 2]));
 i2 = HEAP32[gb + 1458536 >> 2] | 0;
 i3 = (i2 | 0) == 0;
 if (!i3) HEAPF32[i2 + 32 >> 2] = f464;
 i465 = HEAP32[i521 + 132 >> 2] | 0;
 i466 = HEAP32[i521 + 136 >> 2] | 0;
 f35 = Math_fround(HEAPF32[i521 + 140 >> 2]);
 f37 = Math_fround(HEAPF32[i521 + 144 >> 2]);
 f43 = Math_fround(f37 - f35);
 i4 = f34 > Math_fround(0.0);
 f467 = (HEAP32[tempDoublePtr >> 2] = i465, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = i4 & f467 == Math_fround(0.0);
 f468 = (HEAP32[tempDoublePtr >> 2] = i466, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = (i1 | 0) != 1 & (i4 & f468 == Math_fround(0.0));
 if (!i3) {
  HEAPF32[i2 + 12 >> 2] = f34;
  HEAP32[i2 + 16 >> 2] = i465;
  HEAP32[i2 + 20 >> 2] = i466;
  HEAPF32[i2 + 24 >> 2] = f35;
  HEAPF32[i2 + 28 >> 2] = f37;
 }
 HEAP32[i486 >> 2] = 0;
 i1 = HEAP32[i521 + 52 >> 2] | 0;
 if (i1 & 1 | 0) HEAP8[i486 >> 0] = 1;
 if (i1 & 2 | 0) HEAP8[i486 + 1 >> 0] = 1;
 if (i1 & 4 | 0) HEAP8[i486 + 2 >> 0] = 1;
 if (i1 & 8 | 0) HEAP8[i486 + 3 >> 0] = 1;
 HEAP32[i487 >> 2] = 0;
 HEAP32[i487 + 4 >> 2] = 0;
 HEAP32[i487 + 8 >> 2] = 0;
 HEAP32[i487 + 12 >> 2] = 0;
 i1 = HEAP32[i494 + 552 >> 2] | 0;
 L107 : do if (f468 > Math_fround(0.0)) switch (i1 | 0) {
 case 0:
  {
   i1 = 1;
   break L107;
  }
 case 3:
  {
   i1 = 4;
   break L107;
  }
 default:
  break L107;
 } while (0);
 f40 = Math_fround(HEAPF32[i482 >> 2]);
 f41 = Math_fround(HEAPF32[i494 + 532 >> 2]);
 f37 = Math_fround(HEAPF32[i494 + 536 >> 2]);
 f42 = Math_fround(Math_fround(1.0) - f40);
 f39 = Math_fround(Math_fround(1.0) - f41);
 f35 = Math_fround(Math_fround(1.0) - f37);
 switch (i1 | 0) {
 case 3:
 case 0:
  {
   f41 = Math_fround(f40 * f41);
   HEAPF32[i487 >> 2] = f41;
   f39 = Math_fround(f40 * f39);
   HEAPF32[i487 + 4 >> 2] = f39;
   f37 = Math_fround(f42 * f37);
   HEAPF32[i487 + 8 >> 2] = f37;
   f35 = Math_fround(f42 * f35);
   HEAPF32[i487 + 12 >> 2] = f35;
   break;
  }
 case 4:
 case 1:
  {
   HEAPF32[i487 >> 2] = f41;
   HEAPF32[i487 + 4 >> 2] = f39;
   HEAPF32[i487 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i487 + 12 >> 2] = Math_fround(0.0);
   f37 = Math_fround(0.0);
   f35 = Math_fround(0.0);
   break;
  }
 case 5:
 case 2:
  {
   HEAPF32[i487 >> 2] = Math_fround(0.0);
   HEAPF32[i487 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i487 + 8 >> 2] = f37;
   HEAPF32[i487 + 12 >> 2] = f35;
   f41 = Math_fround(0.0);
   f39 = Math_fround(0.0);
   break;
  }
 default:
  {
   f41 = Math_fround(0.0);
   f39 = Math_fround(0.0);
   f37 = Math_fround(0.0);
   f35 = Math_fround(0.0);
  }
 }
 if (!i3) {
  f457 = Math_fround(HEAPF32[i484 >> 2]);
  f456 = Math_fround(Math_fround(Math_fround(HEAPF32[i511 >> 2]) * f41) + Math_fround(0.0));
  f456 = Math_fround(f456 + Math_fround(Math_fround(HEAPF32[i511 + 4 >> 2]) * f39));
  f456 = Math_fround(f456 + Math_fround(Math_fround(HEAPF32[i511 + 8 >> 2]) * f37));
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(f464 * Math_fround(f456 + Math_fround(Math_fround(HEAPF32[i511 + 12 >> 2]) * f35))) - f457);
 }
 HEAP32[i503 >> 2] = 0;
 if (i4) {
  HEAP8[i503 >> 0] = Math_fround(HEAPF32[i487 >> 2]) != Math_fround(0.0) & 1;
  HEAP8[i503 + 1 >> 0] = Math_fround(HEAPF32[i487 + 4 >> 2]) != Math_fround(0.0) & 1;
  HEAP8[i503 + 2 >> 0] = Math_fround(HEAPF32[i487 + 8 >> 2]) != Math_fround(0.0) & 1;
  HEAP8[i503 + 3 >> 0] = Math_fround(HEAPF32[i487 + 12 >> 2]) != Math_fround(0.0) & 1;
 };
 HEAP32[i505 >> 2] = 0;
 HEAP32[i505 + 4 >> 2] = 0;
 HEAP32[i505 + 8 >> 2] = 0;
 HEAP32[i505 + 12 >> 2] = 0;
 __ZN5physx36computeAckermannCorrectedSteerAnglesERKNS_23PxVehicleDriveSimData4WERKNS_23PxVehicleWheels4SimDataEfPf(i494, i510, f43, i505);
 if (i12) {
  i458 = i507;
  i459 = i508;
  f37 = f47;
  f35 = f50;
 } else {
  i3 = 0;
  do {
   i1 = i3 << 2;
   i2 = i520 + (i1 * 148 | 0) | 0;
   if (!(HEAP32[i511 + (i3 * 224 | 0) + 212 >> 2] | 0)) {
    i455 = i520 + ((i1 | 1) * 148 | 0) | 0;
    i458 = i520 + ((i1 | 2) * 148 | 0) | 0;
    i459 = i520 + ((i1 | 3) * 148 | 0) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i455 >> 2] = 0;
    HEAP32[i455 + 4 >> 2] = 0;
    HEAP32[i455 + 8 >> 2] = 0;
    HEAP32[i455 + 12 >> 2] = 0;
    HEAP32[i455 + 16 >> 2] = 0;
    HEAP32[i455 + 20 >> 2] = 0;
    HEAP32[i455 + 24 >> 2] = 0;
    HEAP32[i458 >> 2] = 0;
    HEAP32[i458 + 4 >> 2] = 0;
    HEAP32[i458 + 8 >> 2] = 0;
    HEAP32[i458 + 12 >> 2] = 0;
    HEAP32[i458 + 16 >> 2] = 0;
    HEAP32[i458 + 20 >> 2] = 0;
    HEAP32[i458 + 24 >> 2] = 0;
    HEAP32[i459 >> 2] = 0;
    HEAP32[i459 + 4 >> 2] = 0;
    HEAP32[i459 + 8 >> 2] = 0;
    HEAP32[i459 + 12 >> 2] = 0;
    HEAP32[i459 + 16 >> 2] = 0;
    HEAP32[i459 + 20 >> 2] = 0;
    HEAP32[i459 + 24 >> 2] = 0;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 96 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 4 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 100 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 8 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 104 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 12 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 144 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 16 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 148 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 20 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 152 >> 2];
    HEAP32[i520 + (i1 * 148 | 0) + 24 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 192 >> 2];
    i459 = i1 | 1;
    HEAP32[i520 + (i459 * 148 | 0) >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 108 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 4 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 112 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 8 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 116 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 12 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 156 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 16 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 160 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 20 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 164 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 24 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 196 >> 2];
    i459 = i1 | 2;
    HEAP32[i520 + (i459 * 148 | 0) >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 120 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 4 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 124 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 8 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 128 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 12 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 168 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 16 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 172 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 20 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 176 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 24 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 200 >> 2];
    i459 = i1 | 3;
    HEAP32[i520 + (i459 * 148 | 0) >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 132 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 4 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 136 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 8 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 140 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 12 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 180 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 16 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 184 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 20 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 188 >> 2];
    HEAP32[i520 + (i459 * 148 | 0) + 24 >> 2] = HEAP32[i511 + (i3 * 224 | 0) + 204 >> 2];
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i513 | 0));
  f48 = Math_fround(HEAPF32[i508 >> 2]);
  f49 = Math_fround(HEAPF32[i479 >> 2]);
  f51 = Math_fround(HEAPF32[i470 >> 2]);
  f44 = Math_fround(HEAPF32[i507 >> 2]);
  f45 = Math_fround(HEAPF32[i471 >> 2]);
  f46 = Math_fround(HEAPF32[i469 >> 2]);
  f38 = Math_fround(HEAPF32[i474 >> 2]);
  f37 = Math_fround(HEAPF32[i489 >> 2]);
  f36 = Math_fround(HEAPF32[i472 >> 2]);
  i458 = i507;
  i459 = i508;
  f35 = Math_fround(HEAPF32[i473 >> 2]);
 }
 f47 = Math_fround(Math_fround(HEAPF32[gb + 158860 >> 2]) * Math_fround(2.0));
 f457 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 4 >> 2]) * Math_fround(2.0));
 f456 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 8 >> 2]) * Math_fround(2.0));
 f50 = Math_fround(Math_fround(f38 * f38) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f47 * f37) + Math_fround(f457 * f36)) + Math_fround(f456 * f35));
 f456 = Math_fround(Math_abs(Math_fround(Math_fround(f51 * Math_fround(Math_fround(Math_fround(f456 * f50) + Math_fround(f38 * Math_fround(Math_fround(f457 * f37) - Math_fround(f47 * f36)))) + Math_fround(f35 * f43))) + Math_fround(Math_fround(f48 * Math_fround(Math_fround(f37 * f43) + Math_fround(Math_fround(f47 * f50) + Math_fround(f38 * Math_fround(Math_fround(f456 * f36) - Math_fround(f457 * f35)))))) + Math_fround(f49 * Math_fround(Math_fround(f36 * f43) + Math_fround(Math_fround(f457 * f50) + Math_fround(f38 * Math_fround(Math_fround(f47 * f35) - Math_fround(f456 * f37))))))))));
 f47 = Math_fround(HEAPF32[i521 + 56 >> 2]);
 i455 = f456 < f47 ? HEAP32[i521 + 60 >> 2] | 0 : HEAP32[i521 + 64 >> 2] | 0;
 f47 = Math_fround(Math_fround(1.0) / Math_fround(i455 >>> 0));
 f456 = Math_fround(f47 * f52);
 f50 = Math_fround(Math_fround(1.0) / f456);
 f457 = Math_fround(Math_fround(1.0) / f52);
 i454 = HEAP32[i521 + 68 >> 2] | 0;
 HEAPF32[i492 >> 2] = f47;
 HEAPF32[i492 + 4 >> 2] = f456;
 HEAPF32[i492 + 8 >> 2] = f50;
 HEAP32[i492 + 12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i492 + 16 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i492 + 20 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAPF32[i492 + 24 >> 2] = f53;
 HEAPF32[i492 + 28 >> 2] = f54;
 HEAP8[i492 + 32 >> 0] = 0;
 HEAP32[i492 + 36 >> 2] = i454;
 HEAP32[i492 + 40 >> 2] = i13;
 HEAP32[i492 + 44 >> 2] = i14;
 L134 : do if (i455 | 0) {
  i434 = i490 + 4 | 0;
  i435 = i490 + 8 | 0;
  i436 = i491 + 4 | 0;
  i437 = i491 + 8 | 0;
  f52 = Math_fround(-f467);
  i438 = i510 + 212 | 0;
  i439 = i510 + 216 | 0;
  i440 = i511 + 4 | 0;
  i441 = i510 + 260 | 0;
  i442 = i510 + 264 | 0;
  i443 = i488 + 4 | 0;
  i444 = i504 + 1 | 0;
  i445 = i511 + 8 | 0;
  i446 = i510 + 308 | 0;
  i447 = i510 + 312 | 0;
  i448 = i488 + 8 | 0;
  i449 = i504 + 2 | 0;
  i450 = i511 + 12 | 0;
  i451 = i510 + 356 | 0;
  i452 = i510 + 360 | 0;
  i453 = i488 + 12 | 0;
  i454 = i504 + 3 | 0;
  i212 = i4 & 1;
  i213 = i509 + 4 | 0;
  i214 = i509 + 8 | 0;
  i215 = i509 + 12 | 0;
  i216 = i509 + 16 | 0;
  i217 = i509 + 20 | 0;
  i218 = i509 + 24 | 0;
  i219 = i509 + 28 | 0;
  i220 = i509 + 32 | 0;
  i221 = i509 + 36 | 0;
  i222 = i509 + 40 | 0;
  i223 = i509 + 44 | 0;
  i224 = i509 + 48 | 0;
  i225 = i509 + 52 | 0;
  i226 = i509 + 56 | 0;
  i227 = i509 + 60 | 0;
  i228 = i509 + 64 | 0;
  i229 = i509 + 68 | 0;
  i230 = i509 + 72 | 0;
  i231 = i509 + 76 | 0;
  i232 = i509 + 80 | 0;
  i233 = i509 + 84 | 0;
  i234 = i509 + 88 | 0;
  i235 = HEAP32[i515 >> 2] | 0;
  i236 = i516 + 112 | 0;
  i237 = i516 + 164 | 0;
  i238 = i516 + 113 | 0;
  i239 = i516 + 168 | 0;
  i240 = i516 + 114 | 0;
  i241 = i516 + 172 | 0;
  i242 = i516 + 115 | 0;
  i243 = i516 + 176 | 0;
  i244 = i516 + 508 | 0;
  i245 = i516 + 512 | 0;
  i246 = i516 + 516 | 0;
  i247 = i516 + 520 | 0;
  i248 = i516 + 524 | 0;
  i249 = i516 + 528 | 0;
  i250 = i516 + 532 | 0;
  i251 = i516 + 536 | 0;
  i252 = i516 + 292 | 0;
  i253 = i455 + -1 | 0;
  i254 = i516 + 904 | 0;
  i255 = i516 + 920 | 0;
  i256 = i516 + 984 | 0;
  i257 = i516 + 1e3 | 0;
  i258 = i511 + 212 | 0;
  i259 = i511 + 96 | 0;
  i260 = i511 + 192 | 0;
  i261 = i511 + 176 | 0;
  i262 = i511 + 160 | 0;
  i263 = i516 + 924 | 0;
  i264 = i511 + 100 | 0;
  i265 = i516 + 928 | 0;
  i266 = i511 + 104 | 0;
  i267 = i516 + 932 | 0;
  i268 = i511 + 108 | 0;
  i269 = i516 + 908 | 0;
  i270 = i511 + 194 | 0;
  i271 = i511 + 112 | 0;
  i272 = i516 + 936 | 0;
  i273 = i516 + 940 | 0;
  i274 = i511 + 116 | 0;
  i275 = i516 + 944 | 0;
  i276 = i511 + 120 | 0;
  i277 = i516 + 948 | 0;
  i278 = i511 + 124 | 0;
  i279 = i516 + 988 | 0;
  i280 = i511 + 180 | 0;
  i281 = i516 + 1004 | 0;
  i282 = i511 + 164 | 0;
  i283 = i516 + 912 | 0;
  i284 = i511 + 196 | 0;
  i285 = i511 + 128 | 0;
  i286 = i516 + 952 | 0;
  i287 = i516 + 956 | 0;
  i288 = i511 + 132 | 0;
  i289 = i516 + 960 | 0;
  i290 = i511 + 136 | 0;
  i291 = i516 + 964 | 0;
  i292 = i511 + 140 | 0;
  i293 = i516 + 992 | 0;
  i294 = i511 + 184 | 0;
  i295 = i516 + 1008 | 0;
  i296 = i511 + 168 | 0;
  i297 = i516 + 916 | 0;
  i298 = i511 + 198 | 0;
  i299 = i511 + 144 | 0;
  i300 = i516 + 968 | 0;
  i301 = i516 + 972 | 0;
  i302 = i511 + 148 | 0;
  i303 = i516 + 976 | 0;
  i304 = i511 + 152 | 0;
  i305 = i516 + 980 | 0;
  i306 = i511 + 156 | 0;
  i307 = i516 + 996 | 0;
  i308 = i511 + 188 | 0;
  i309 = i516 + 1012 | 0;
  i310 = i511 + 172 | 0;
  i311 = i511 + 216 | 0;
  i312 = i516 + 484 | 0;
  i313 = i516 + 488 | 0;
  i314 = i516 + 492 | 0;
  i315 = i516 + 496 | 0;
  i316 = i516 + 500 | 0;
  i317 = i516 + 504 | 0;
  i318 = i511 + 208 | 0;
  i319 = i516 + 540 | 0;
  i320 = i516 + 544 | 0;
  i321 = i516 + 548 | 0;
  i322 = i516 + 552 | 0;
  i323 = i516 + 556 | 0;
  i324 = i516 + 560 | 0;
  i325 = i516 + 564 | 0;
  i326 = i516 + 568 | 0;
  i327 = i516 + 572 | 0;
  i328 = i516 + 576 | 0;
  i329 = i516 + 580 | 0;
  i330 = i516 + 584 | 0;
  i331 = i516 + 588 | 0;
  i332 = i516 + 592 | 0;
  i333 = i516 + 596 | 0;
  i334 = i516 + 600 | 0;
  i335 = i516 + 604 | 0;
  i336 = i516 + 608 | 0;
  i337 = i516 + 612 | 0;
  i338 = i516 + 616 | 0;
  i339 = i516 + 620 | 0;
  i340 = i516 + 624 | 0;
  i341 = i516 + 628 | 0;
  i342 = i516 + 632 | 0;
  i343 = i516 + 636 | 0;
  i344 = i516 + 656 | 0;
  i345 = i516 + 660 | 0;
  i346 = i516 + 664 | 0;
  i347 = i516 + 668 | 0;
  i348 = i516 + 672 | 0;
  i349 = i516 + 676 | 0;
  i350 = i516 + 680 | 0;
  i351 = i516 + 684 | 0;
  i352 = i516 + 688 | 0;
  i353 = i516 + 692 | 0;
  i354 = i516 + 696 | 0;
  i355 = i516 + 700 | 0;
  i356 = i516 + 704 | 0;
  i357 = i516 + 708 | 0;
  i358 = i516 + 712 | 0;
  i359 = i516 + 716 | 0;
  i360 = i516 + 720 | 0;
  i361 = i516 + 724 | 0;
  i362 = i516 + 728 | 0;
  i363 = i516 + 732 | 0;
  i364 = i516 + 736 | 0;
  i365 = i516 + 740 | 0;
  i366 = i516 + 744 | 0;
  i367 = i516 + 748 | 0;
  i368 = i516 + 752 | 0;
  i369 = i516 + 772 | 0;
  i370 = i516 + 776 | 0;
  i371 = i516 + 780 | 0;
  i372 = i516 + 784 | 0;
  i373 = i516 + 788 | 0;
  i374 = i516 + 792 | 0;
  i375 = i516 + 796 | 0;
  i376 = i516 + 800 | 0;
  i377 = i516 + 804 | 0;
  i378 = i516 + 808 | 0;
  i379 = i516 + 812 | 0;
  i380 = i516 + 816 | 0;
  i381 = i516 + 820 | 0;
  i382 = i516 + 824 | 0;
  i383 = i516 + 828 | 0;
  i384 = i516 + 832 | 0;
  i385 = i516 + 836 | 0;
  i386 = i516 + 840 | 0;
  i387 = i516 + 844 | 0;
  i388 = i516 + 848 | 0;
  i389 = i516 + 852 | 0;
  i390 = i516 + 856 | 0;
  i391 = i516 + 860 | 0;
  i392 = i516 + 864 | 0;
  i393 = i516 + 868 | 0;
  i394 = i516 + 888 | 0;
  i395 = i516 + 892 | 0;
  i396 = i516 + 896 | 0;
  i397 = i516 + 900 | 0;
  i398 = HEAP32[i515 >> 2] | 0;
  i399 = (i398 | 0) == 0;
  i400 = i494 + 84 | 0;
  i401 = i494 + 108 | 0;
  i402 = i494 + 4 | 0;
  i403 = i494 + 92 | 0;
  i404 = i494 + 96 | 0;
  i405 = i494 + 100 | 0;
  i406 = i500 + 4 | 0;
  i407 = i500 + 8 | 0;
  i408 = i500 + 12 | 0;
  i409 = i500 + 16 | 0;
  i410 = i500 + 20 | 0;
  i411 = i500 + 24 | 0;
  i412 = i500 + 28 | 0;
  i413 = i500 + 32 | 0;
  i414 = i500 + 36 | 0;
  i415 = i500 + 40 | 0;
  i416 = i500 + 44 | 0;
  i417 = i500 + 48 | 0;
  i418 = i500 + 52 | 0;
  i419 = i516 + 468 | 0;
  i420 = i500 + 56 | 0;
  i421 = i500 + 60 | 0;
  i422 = i500 + 64 | 0;
  i423 = i500 + 68 | 0;
  i424 = i501 + 4 | 0;
  f50 = Math_fround(f461 * f464);
  i425 = i513 >>> 0 > 1;
  i426 = i498 + 4 | 0;
  i427 = i498 + 8 | 0;
  i428 = i498 + 12 | 0;
  i429 = i496 + 1 | 0;
  i430 = i496 + 2 | 0;
  i431 = i496 + 3 | 0;
  i432 = i509 + 4 | 0;
  i33 = i509 + 8 | 0;
  i55 = i509 + 12 | 0;
  i56 = i509 + 16 | 0;
  i57 = i509 + 20 | 0;
  i58 = i509 + 24 | 0;
  i59 = i509 + 28 | 0;
  i60 = i509 + 32 | 0;
  i61 = i509 + 36 | 0;
  i62 = i509 + 40 | 0;
  i63 = i509 + 44 | 0;
  i64 = i509 + 48 | 0;
  i65 = i509 + 52 | 0;
  i66 = i509 + 56 | 0;
  i67 = i509 + 60 | 0;
  i68 = i509 + 64 | 0;
  i69 = i509 + 68 | 0;
  i70 = i509 + 72 | 0;
  i71 = i509 + 76 | 0;
  i72 = i509 + 80 | 0;
  i73 = i509 + 84 | 0;
  i74 = i509 + 88 | 0;
  i75 = i516 + 112 | 0;
  i76 = i516 + 164 | 0;
  i77 = i516 + 113 | 0;
  i78 = i516 + 168 | 0;
  i79 = i516 + 114 | 0;
  i80 = i516 + 172 | 0;
  i81 = i516 + 115 | 0;
  i82 = i516 + 176 | 0;
  i83 = i516 + 508 | 0;
  i84 = i516 + 512 | 0;
  i85 = i516 + 516 | 0;
  i86 = i516 + 520 | 0;
  i87 = i516 + 524 | 0;
  i88 = i516 + 528 | 0;
  i89 = i516 + 532 | 0;
  i90 = i516 + 536 | 0;
  i91 = i516 + 292 | 0;
  i92 = i516 + 904 | 0;
  i93 = i516 + 920 | 0;
  i94 = i516 + 984 | 0;
  i95 = i516 + 1e3 | 0;
  i96 = i516 + 924 | 0;
  i97 = i516 + 928 | 0;
  i98 = i516 + 932 | 0;
  i99 = i516 + 908 | 0;
  i100 = i516 + 936 | 0;
  i101 = i516 + 940 | 0;
  i102 = i516 + 944 | 0;
  i103 = i516 + 948 | 0;
  i104 = i516 + 988 | 0;
  i105 = i516 + 1004 | 0;
  i106 = i516 + 912 | 0;
  i107 = i516 + 952 | 0;
  i108 = i516 + 956 | 0;
  i109 = i516 + 960 | 0;
  i110 = i516 + 964 | 0;
  i111 = i516 + 992 | 0;
  i112 = i516 + 1008 | 0;
  i113 = i516 + 916 | 0;
  i114 = i516 + 968 | 0;
  i115 = i516 + 972 | 0;
  i116 = i516 + 976 | 0;
  i117 = i516 + 980 | 0;
  i118 = i516 + 996 | 0;
  i119 = i516 + 1012 | 0;
  i120 = i516 + 484 | 0;
  i121 = i516 + 488 | 0;
  i122 = i516 + 492 | 0;
  i123 = i516 + 496 | 0;
  i124 = i516 + 500 | 0;
  i125 = i516 + 504 | 0;
  i126 = i516 + 540 | 0;
  i127 = i516 + 544 | 0;
  i128 = i516 + 548 | 0;
  i129 = i516 + 552 | 0;
  i130 = i516 + 556 | 0;
  i131 = i516 + 560 | 0;
  i132 = i516 + 564 | 0;
  i133 = i516 + 568 | 0;
  i134 = i516 + 572 | 0;
  i135 = i516 + 576 | 0;
  i136 = i516 + 580 | 0;
  i137 = i516 + 584 | 0;
  i138 = i516 + 588 | 0;
  i139 = i516 + 592 | 0;
  i140 = i516 + 596 | 0;
  i141 = i516 + 600 | 0;
  i142 = i516 + 604 | 0;
  i143 = i516 + 608 | 0;
  i144 = i516 + 612 | 0;
  i145 = i516 + 616 | 0;
  i146 = i516 + 620 | 0;
  i147 = i516 + 624 | 0;
  i148 = i516 + 628 | 0;
  i149 = i516 + 632 | 0;
  i150 = i516 + 636 | 0;
  i151 = i516 + 656 | 0;
  i152 = i516 + 660 | 0;
  i153 = i516 + 664 | 0;
  i154 = i516 + 668 | 0;
  i155 = i516 + 672 | 0;
  i156 = i516 + 676 | 0;
  i157 = i516 + 680 | 0;
  i158 = i516 + 684 | 0;
  i159 = i516 + 688 | 0;
  i160 = i516 + 692 | 0;
  i161 = i516 + 696 | 0;
  i162 = i516 + 700 | 0;
  i163 = i516 + 704 | 0;
  i164 = i516 + 708 | 0;
  i165 = i516 + 712 | 0;
  i166 = i516 + 716 | 0;
  i167 = i516 + 720 | 0;
  i168 = i516 + 724 | 0;
  i169 = i516 + 728 | 0;
  i170 = i516 + 732 | 0;
  i171 = i516 + 736 | 0;
  i172 = i516 + 740 | 0;
  i173 = i516 + 744 | 0;
  i174 = i516 + 748 | 0;
  i175 = i516 + 752 | 0;
  i176 = i516 + 772 | 0;
  i177 = i516 + 776 | 0;
  i178 = i516 + 780 | 0;
  i179 = i516 + 784 | 0;
  i180 = i516 + 788 | 0;
  i181 = i516 + 792 | 0;
  i182 = i516 + 796 | 0;
  i183 = i516 + 800 | 0;
  i184 = i516 + 804 | 0;
  i185 = i516 + 808 | 0;
  i186 = i516 + 812 | 0;
  i187 = i516 + 816 | 0;
  i188 = i516 + 820 | 0;
  i189 = i516 + 824 | 0;
  i190 = i516 + 828 | 0;
  i191 = i516 + 832 | 0;
  i192 = i516 + 836 | 0;
  i193 = i516 + 840 | 0;
  i194 = i516 + 844 | 0;
  i195 = i516 + 848 | 0;
  i196 = i516 + 852 | 0;
  i197 = i516 + 856 | 0;
  i198 = i516 + 860 | 0;
  i199 = i516 + 864 | 0;
  i200 = i516 + 868 | 0;
  i201 = i516 + 888 | 0;
  i202 = i516 + 892 | 0;
  i203 = i516 + 896 | 0;
  i204 = i516 + 900 | 0;
  i205 = i516 + 468 | 0;
  i206 = i516 + 472 | 0;
  i207 = i516 + 476 | 0;
  i208 = i516 + 480 | 0;
  i209 = i497 + 3 | 0;
  i210 = i497 + 2 | 0;
  i211 = i497 + 1 | 0;
  i433 = 0;
  while (1) {
   HEAPF32[i490 >> 2] = Math_fround(0.0);
   HEAPF32[i434 >> 2] = Math_fround(0.0);
   HEAPF32[i435 >> 2] = Math_fround(0.0);
   HEAPF32[i491 >> 2] = Math_fround(0.0);
   HEAPF32[i436 >> 2] = Math_fround(0.0);
   HEAPF32[i437 >> 2] = Math_fround(0.0);
   HEAP32[i488 >> 2] = 0;
   HEAP32[i488 + 4 >> 2] = 0;
   HEAP32[i488 + 8 >> 2] = 0;
   HEAP32[i504 >> 2] = 0;
   f54 = Math_fround(HEAPF32[i511 >> 2]);
   i31 = f54 <= Math_fround(-0.0);
   f53 = i31 ? Math_fround(0.0) : Math_fround(1.0);
   i31 = f54 >= Math_fround(0.0);
   f53 = i31 ? f53 : Math_fround(-1.0);
   f54 = Math_fround(f53 * f52);
   f47 = Math_fround(HEAPF32[i438 >> 2]);
   f54 = Math_fround(f47 * f54);
   f53 = Math_fround(f468 * f53);
   f43 = Math_fround(HEAPF32[i439 >> 2]);
   HEAPF32[i488 >> 2] = Math_fround(f54 - Math_fround(f43 * f53));
   HEAP8[i504 >> 0] = Math_fround(Math_fround(f467 * f47) + Math_fround(f468 * f43)) != Math_fround(0.0) & 1;
   f43 = Math_fround(HEAPF32[i440 >> 2]);
   i31 = f43 <= Math_fround(-0.0);
   f47 = i31 ? Math_fround(0.0) : Math_fround(1.0);
   i31 = f43 >= Math_fround(0.0);
   f47 = i31 ? f47 : Math_fround(-1.0);
   f43 = Math_fround(f47 * f52);
   f53 = Math_fround(HEAPF32[i441 >> 2]);
   f43 = Math_fround(f53 * f43);
   f47 = Math_fround(f468 * f47);
   f54 = Math_fround(HEAPF32[i442 >> 2]);
   HEAPF32[i443 >> 2] = Math_fround(f43 - Math_fround(f54 * f47));
   HEAP8[i444 >> 0] = Math_fround(Math_fround(f467 * f53) + Math_fround(f468 * f54)) != Math_fround(0.0) & 1;
   f54 = Math_fround(HEAPF32[i445 >> 2]);
   i31 = f54 <= Math_fround(-0.0);
   f53 = i31 ? Math_fround(0.0) : Math_fround(1.0);
   i31 = f54 >= Math_fround(0.0);
   f53 = i31 ? f53 : Math_fround(-1.0);
   f54 = Math_fround(f53 * f52);
   f47 = Math_fround(HEAPF32[i446 >> 2]);
   f54 = Math_fround(f47 * f54);
   f53 = Math_fround(f468 * f53);
   f43 = Math_fround(HEAPF32[i447 >> 2]);
   HEAPF32[i448 >> 2] = Math_fround(f54 - Math_fround(f43 * f53));
   HEAP8[i449 >> 0] = Math_fround(Math_fround(f467 * f47) + Math_fround(f468 * f43)) != Math_fround(0.0) & 1;
   f43 = Math_fround(HEAPF32[i450 >> 2]);
   i31 = f43 <= Math_fround(-0.0);
   f47 = i31 ? Math_fround(0.0) : Math_fround(1.0);
   i31 = f43 >= Math_fround(0.0);
   f47 = i31 ? f47 : Math_fround(-1.0);
   f43 = Math_fround(f47 * f52);
   f53 = Math_fround(HEAPF32[i451 >> 2]);
   f43 = Math_fround(f53 * f43);
   f47 = Math_fround(f468 * f47);
   f54 = Math_fround(HEAPF32[i452 >> 2]);
   HEAPF32[i453 >> 2] = Math_fround(f43 - Math_fround(f54 * f47));
   HEAP8[i454 >> 0] = Math_fround(Math_fround(f467 * f53) + Math_fround(f468 * f54)) != Math_fround(0.0) & 1;
   HEAP8[i509 >> 0] = i212;
   HEAP32[i213 >> 2] = i503;
   HEAP32[i214 >> 2] = i504;
   HEAP32[i215 >> 2] = i505;
   HEAP32[i216 >> 2] = i486;
   HEAP32[i217 >> 2] = HEAP32[i489 >> 2];
   HEAP32[i218 >> 2] = HEAP32[i472 >> 2];
   HEAP32[i219 >> 2] = HEAP32[i473 >> 2];
   HEAP32[i220 >> 2] = HEAP32[i474 >> 2];
   HEAP32[i221 >> 2] = HEAP32[i475 >> 2];
   HEAP32[i222 >> 2] = HEAP32[i476 >> 2];
   HEAP32[i223 >> 2] = HEAP32[i477 >> 2];
   HEAP32[i224 >> 2] = HEAP32[i508 >> 2];
   HEAP32[i225 >> 2] = HEAP32[i479 >> 2];
   HEAP32[i226 >> 2] = HEAP32[i470 >> 2];
   HEAP32[i227 >> 2] = HEAP32[i507 >> 2];
   HEAP32[i228 >> 2] = HEAP32[i471 >> 2];
   HEAP32[i229 >> 2] = HEAP32[i469 >> 2];
   HEAP32[i230 >> 2] = i510;
   HEAP32[i231 >> 2] = i511;
   HEAP32[i232 >> 2] = i506;
   HEAP32[i233 >> 2] = i485;
   HEAP32[i234 >> 2] = i235;
   _memset(i516 | 0, 0, 1128) | 0;
   HEAP8[i236 >> 0] = 1;
   HEAP32[i237 >> 2] = -1;
   HEAP8[i238 >> 0] = 1;
   HEAP32[i239 >> 2] = -1;
   HEAP8[i240 >> 0] = 1;
   HEAP32[i241 >> 2] = -1;
   HEAP8[i242 >> 0] = 1;
   HEAP32[i243 >> 2] = -1;
   __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(0, i492, i509, i516);
   i31 = HEAP32[i231 >> 2] | 0;
   i32 = i31 + 48 | 0;
   f54 = Math_fround(HEAPF32[i244 >> 2]);
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i245 >> 2]);
   i32 = i31 + 52 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i246 >> 2]);
   i32 = i31 + 56 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i247 >> 2]);
   i32 = i31 + 60 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   i32 = i31 + 64 | 0;
   f54 = Math_fround(HEAPF32[i248 >> 2]);
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i249 >> 2]);
   i32 = i31 + 68 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i250 >> 2]);
   i32 = i31 + 72 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   f54 = Math_fround(HEAPF32[i251 >> 2]);
   i32 = i31 + 76 | 0;
   i30 = f54 != Math_fround(HEAPF32[i32 >> 2]);
   HEAPF32[i32 >> 2] = i30 ? f54 : Math_fround(0.0);
   i31 = i31 + 80 | 0;
   HEAP32[i31 >> 2] = HEAP32[i252 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i252 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i252 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i252 + 12 >> 2];
   i31 = (i253 | 0) == (i433 | 0);
   if (i31) {
    if (HEAP32[i258 >> 2] | 0) HEAP8[i311 >> 0] = 1;
    HEAP16[i260 >> 1] = HEAP32[i254 >> 2];
    HEAP32[i259 >> 2] = HEAP32[i255 >> 2];
    HEAP32[i264 >> 2] = HEAP32[i263 >> 2];
    HEAP32[i266 >> 2] = HEAP32[i265 >> 2];
    HEAP32[i268 >> 2] = HEAP32[i267 >> 2];
    HEAP32[i261 >> 2] = HEAP32[i256 >> 2];
    HEAP32[i262 >> 2] = HEAP32[i257 >> 2];
    HEAP16[i270 >> 1] = HEAP32[i269 >> 2];
    HEAP32[i271 >> 2] = HEAP32[i272 >> 2];
    HEAP32[i274 >> 2] = HEAP32[i273 >> 2];
    HEAP32[i276 >> 2] = HEAP32[i275 >> 2];
    HEAP32[i278 >> 2] = HEAP32[i277 >> 2];
    HEAP32[i280 >> 2] = HEAP32[i279 >> 2];
    HEAP32[i282 >> 2] = HEAP32[i281 >> 2];
    HEAP16[i284 >> 1] = HEAP32[i283 >> 2];
    HEAP32[i285 >> 2] = HEAP32[i286 >> 2];
    HEAP32[i288 >> 2] = HEAP32[i287 >> 2];
    HEAP32[i290 >> 2] = HEAP32[i289 >> 2];
    HEAP32[i292 >> 2] = HEAP32[i291 >> 2];
    HEAP32[i294 >> 2] = HEAP32[i293 >> 2];
    HEAP32[i296 >> 2] = HEAP32[i295 >> 2];
    HEAP16[i298 >> 1] = HEAP32[i297 >> 2];
    HEAP32[i299 >> 2] = HEAP32[i300 >> 2];
    HEAP32[i302 >> 2] = HEAP32[i301 >> 2];
    HEAP32[i304 >> 2] = HEAP32[i303 >> 2];
    HEAP32[i306 >> 2] = HEAP32[i305 >> 2];
    HEAP32[i308 >> 2] = HEAP32[i307 >> 2];
    HEAP32[i310 >> 2] = HEAP32[i309 >> 2];
   }
   f54 = Math_fround(HEAPF32[i312 >> 2]);
   HEAPF32[i490 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i490 >> 2]));
   f54 = Math_fround(HEAPF32[i313 >> 2]);
   HEAPF32[i434 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i434 >> 2]));
   f54 = Math_fround(HEAPF32[i314 >> 2]);
   HEAPF32[i435 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i435 >> 2]));
   f54 = Math_fround(HEAPF32[i315 >> 2]);
   HEAPF32[i491 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i491 >> 2]));
   f54 = Math_fround(HEAPF32[i316 >> 2]);
   HEAPF32[i436 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i436 >> 2]));
   f54 = Math_fround(HEAPF32[i317 >> 2]);
   HEAPF32[i437 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i437 >> 2]));
   i32 = (i433 | 0) == 0;
   if (i32) {
    i30 = HEAP32[i318 >> 2] | 0;
    HEAP32[i30 + 4 >> 2] = HEAP32[i319 >> 2];
    HEAP32[i30 + 8 >> 2] = HEAP32[i320 >> 2];
    HEAP32[i30 + 12 >> 2] = HEAP32[i321 >> 2];
    HEAP32[i30 + 16 >> 2] = HEAP32[i322 >> 2];
    HEAP32[i30 + 20 >> 2] = HEAP32[i323 >> 2];
    HEAP32[i30 + 24 >> 2] = HEAP32[i324 >> 2];
    HEAP32[i30 + 28 >> 2] = HEAP32[i325 >> 2];
    HEAP32[i30 + 32 >> 2] = HEAP32[i326 >> 2];
    HEAP32[i30 + 36 >> 2] = HEAP32[i327 >> 2];
    HEAP32[i30 + 40 >> 2] = HEAP32[i328 >> 2];
    HEAP32[i30 + 44 >> 2] = HEAP32[i329 >> 2];
    HEAP32[i30 + 48 >> 2] = HEAP32[i330 >> 2];
    HEAP32[i30 + 52 >> 2] = HEAP32[i331 >> 2];
    HEAP32[i30 + 56 >> 2] = HEAP32[i332 >> 2];
    HEAP32[i30 + 60 >> 2] = HEAP32[i333 >> 2];
    HEAP32[i30 + 64 >> 2] = HEAP32[i334 >> 2];
    HEAP32[i30 + 68 >> 2] = HEAP32[i335 >> 2];
    HEAP32[i30 + 72 >> 2] = HEAP32[i336 >> 2];
    HEAP32[i30 + 76 >> 2] = HEAP32[i337 >> 2];
    HEAP32[i30 + 80 >> 2] = HEAP32[i338 >> 2];
    HEAP32[i30 + 84 >> 2] = HEAP32[i339 >> 2];
    HEAP32[i30 + 88 >> 2] = HEAP32[i340 >> 2];
    HEAP32[i30 + 92 >> 2] = HEAP32[i341 >> 2];
    HEAP32[i30 + 96 >> 2] = HEAP32[i342 >> 2];
    i29 = i30 + 100 | 0;
    HEAP32[i29 >> 2] = HEAP32[i343 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i343 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i343 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i343 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i343 + 16 >> 2];
    HEAP32[i30 + 120 >> 2] = HEAP32[i344 >> 2];
    HEAP32[i30 + 124 >> 2] = HEAP32[i345 >> 2];
    HEAP32[i30 + 128 >> 2] = HEAP32[i346 >> 2];
    HEAP32[i30 + 132 >> 2] = HEAP32[i347 >> 2];
    HEAP32[i30 + 136 >> 2] = HEAP32[i348 >> 2];
    HEAP32[i30 + 140 >> 2] = HEAP32[i349 >> 2];
    HEAP32[i30 + 144 >> 2] = HEAP32[i350 >> 2];
    HEAP32[i30 + 148 >> 2] = HEAP32[i351 >> 2];
    HEAP32[i30 + 152 >> 2] = HEAP32[i352 >> 2];
    HEAP32[i30 + 156 >> 2] = HEAP32[i353 >> 2];
    HEAP32[i30 + 160 >> 2] = HEAP32[i354 >> 2];
    HEAP32[i30 + 164 >> 2] = HEAP32[i355 >> 2];
    HEAP32[i30 + 168 >> 2] = HEAP32[i356 >> 2];
    HEAP32[i30 + 172 >> 2] = HEAP32[i357 >> 2];
    HEAP32[i30 + 176 >> 2] = HEAP32[i358 >> 2];
    HEAP32[i30 + 180 >> 2] = HEAP32[i359 >> 2];
    HEAP32[i30 + 184 >> 2] = HEAP32[i360 >> 2];
    HEAP32[i30 + 188 >> 2] = HEAP32[i361 >> 2];
    HEAP32[i30 + 192 >> 2] = HEAP32[i362 >> 2];
    HEAP32[i30 + 196 >> 2] = HEAP32[i363 >> 2];
    HEAP32[i30 + 200 >> 2] = HEAP32[i364 >> 2];
    HEAP32[i30 + 204 >> 2] = HEAP32[i365 >> 2];
    HEAP32[i30 + 208 >> 2] = HEAP32[i366 >> 2];
    HEAP32[i30 + 212 >> 2] = HEAP32[i367 >> 2];
    i29 = i30 + 216 | 0;
    HEAP32[i29 >> 2] = HEAP32[i368 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i368 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i368 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i368 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i368 + 16 >> 2];
    HEAP32[i30 + 236 >> 2] = HEAP32[i369 >> 2];
    HEAP32[i30 + 240 >> 2] = HEAP32[i370 >> 2];
    HEAP32[i30 + 244 >> 2] = HEAP32[i371 >> 2];
    HEAP32[i30 + 248 >> 2] = HEAP32[i372 >> 2];
    HEAP32[i30 + 252 >> 2] = HEAP32[i373 >> 2];
    HEAP32[i30 + 256 >> 2] = HEAP32[i374 >> 2];
    HEAP32[i30 + 260 >> 2] = HEAP32[i375 >> 2];
    HEAP32[i30 + 264 >> 2] = HEAP32[i376 >> 2];
    HEAP32[i30 + 268 >> 2] = HEAP32[i377 >> 2];
    HEAP32[i30 + 272 >> 2] = HEAP32[i378 >> 2];
    HEAP32[i30 + 276 >> 2] = HEAP32[i379 >> 2];
    HEAP32[i30 + 280 >> 2] = HEAP32[i380 >> 2];
    HEAP32[i30 + 284 >> 2] = HEAP32[i381 >> 2];
    HEAP32[i30 + 288 >> 2] = HEAP32[i382 >> 2];
    HEAP32[i30 + 292 >> 2] = HEAP32[i383 >> 2];
    HEAP32[i30 + 296 >> 2] = HEAP32[i384 >> 2];
    HEAP32[i30 + 300 >> 2] = HEAP32[i385 >> 2];
    HEAP32[i30 + 304 >> 2] = HEAP32[i386 >> 2];
    HEAP32[i30 + 308 >> 2] = HEAP32[i387 >> 2];
    HEAP32[i30 + 312 >> 2] = HEAP32[i388 >> 2];
    HEAP32[i30 + 316 >> 2] = HEAP32[i389 >> 2];
    HEAP32[i30 + 320 >> 2] = HEAP32[i390 >> 2];
    HEAP32[i30 + 324 >> 2] = HEAP32[i391 >> 2];
    HEAP32[i30 + 328 >> 2] = HEAP32[i392 >> 2];
    i29 = i30 + 332 | 0;
    HEAP32[i29 >> 2] = HEAP32[i393 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i393 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i393 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i393 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i393 + 16 >> 2];
    HEAP32[i30 + 352 >> 2] = HEAP32[i394 >> 2];
    HEAP32[i30 + 356 >> 2] = HEAP32[i395 >> 2];
    HEAP32[i30 + 360 >> 2] = HEAP32[i396 >> 2];
    HEAP32[i30 + 364 >> 2] = HEAP32[i397 >> 2];
   }
   __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i516, HEAP32[i215 >> 2] | 0, i520, i398);
   i1 = HEAP32[i519 >> 2] | 0;
   if (!i399) {
    i2 = 0;
    do {
     HEAP32[i1 + (i2 * 56 | 0) + 28 >> 2] = HEAP32[i516 + 1016 + (i2 << 2) >> 2];
     f54 = Math_fround(HEAPF32[i516 + 1032 + (i2 * 12 | 0) >> 2]);
     i30 = i1 + (i2 * 56 | 0) + 32 | 0;
     HEAPF32[i30 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i30 >> 2]));
     f54 = Math_fround(HEAPF32[i516 + 1032 + (i2 * 12 | 0) + 4 >> 2]);
     i30 = i1 + (i2 * 56 | 0) + 36 | 0;
     HEAPF32[i30 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i30 >> 2]));
     f54 = Math_fround(HEAPF32[i516 + 1032 + (i2 * 12 | 0) + 8 >> 2]);
     i30 = i1 + (i2 * 56 | 0) + 40 | 0;
     HEAPF32[i30 >> 2] = Math_fround(f54 + Math_fround(HEAPF32[i30 >> 2]));
     HEAP32[i1 + (i2 * 56 | 0) + 44 >> 2] = HEAP32[i516 + 1080 + (i2 * 12 | 0) >> 2];
     HEAP32[i1 + (i2 * 56 | 0) + 48 >> 2] = HEAP32[i516 + 1080 + (i2 * 12 | 0) + 4 >> 2];
     HEAP32[i1 + (i2 * 56 | 0) + 52 >> 2] = HEAP32[i516 + 1080 + (i2 * 12 | 0) + 8 >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i398 | 0));
   };
   HEAP32[i493 >> 2] = 0;
   HEAP32[i493 + 4 >> 2] = 0;
   HEAP32[i493 + 8 >> 2] = 0;
   HEAP32[i493 + 12 >> 2] = 0;
   __ZN5physx23computeDiffTorqueRatiosERKNS_27PxVehicleDifferential4WDataEfPKfPf(i482, f468, i511, i493);
   f39 = Math_fround(HEAPF32[i484 >> 2]);
   f40 = Math_fround(f34 * Math_fround(HEAPF32[i400 >> 2]));
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i401 >> 2]));
   i2 = HEAP32[i481 >> 2] | 0;
   L151 : do switch (i2 | 0) {
   case 0:
    {
     f35 = Math_fround(0.0);
     break;
    }
   case 1:
    {
     i480 = 102;
     break;
    }
   default:
    {
     f35 = Math_fround(HEAPF32[i494 >> 2]);
     if (f35 > f39) {
      i480 = 102;
      break L151;
     }
     i1 = 1;
     f38 = Math_fround(HEAPF32[i402 >> 2]);
     while (1) {
      i480 = i1 << 1;
      f37 = f35;
      f35 = Math_fround(HEAPF32[i494 + (i480 << 2) >> 2]);
      f36 = f38;
      f38 = Math_fround(HEAPF32[i494 + ((i480 | 1) << 2) >> 2]);
      i1 = i1 + 1 | 0;
      if (f37 <= f39 & f35 > f39) {
       i480 = 106;
       break;
      }
      if (i1 >>> 0 >= i2 >>> 0) {
       i480 = 107;
       break;
      }
     }
     if ((i480 | 0) == 106) {
      i480 = 0;
      f35 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f39 - f37) * Math_fround(f38 - f36)) / Math_fround(f35 - f37)));
      break L151;
     } else if ((i480 | 0) == 107) {
      i480 = 0;
      f35 = Math_fround(HEAPF32[i494 + (((i2 << 1) + -2 | 1) << 2) >> 2]);
      break L151;
     }
    }
   } while (0);
   if ((i480 | 0) == 102) {
    i480 = 0;
    f35 = Math_fround(HEAPF32[i402 >> 2]);
   }
   f38 = Math_fround(f40 * f35);
   i1 = HEAP32[gb + 1458536 >> 2] | 0;
   if (i1 | 0) HEAPF32[i1 + 4 >> 2] = f38;
   f53 = Math_fround(HEAPF32[i403 >> 2]);
   f47 = Math_fround(HEAPF32[i405 >> 2]);
   f54 = Math_fround(HEAPF32[i404 >> 2]);
   f54 = i460 ? f47 : f54;
   f54 = Math_fround(f54 + Math_fround(f34 * Math_fround(f53 - f54)));
   HEAPF32[i500 >> 2] = f456;
   HEAP32[i406 >> 2] = i465;
   HEAP32[i407 >> 2] = i466;
   HEAPF32[i408 >> 2] = f461;
   HEAPF32[i409 >> 2] = f464;
   HEAP32[i410 >> 2] = i462;
   HEAP32[i411 >> 2] = i463;
   HEAPF32[i412 >> 2] = f38;
   HEAPF32[i413 >> 2] = f54;
   HEAP32[i414 >> 2] = i493;
   HEAP32[i415 >> 2] = i487;
   HEAP32[i416 >> 2] = i488;
   HEAP32[i417 >> 2] = i504;
   HEAP32[i418 >> 2] = i419;
   HEAP32[i420 >> 2] = 1;
   HEAP32[i421 >> 2] = 4;
   HEAP32[i422 >> 2] = i510;
   HEAP32[i423 >> 2] = i494;
   HEAP32[i501 >> 2] = i511;
   HEAP32[i424 >> 2] = i483;
   __ZN5physx49solveDrive4WInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE(i500, i501);
   i1 = 0;
   do {
    f35 = Math_fround(HEAPF32[i511 + (i1 << 2) >> 2]);
    f54 = Math_fround(HEAPF32[i516 + 292 + (i1 << 2) >> 2]);
    do if (f54 > Math_fround(-Math_fround(HEAPF32[i510 + (i1 * 48 | 0) + 12 >> 2]))) {
     if (HEAP8[i504 + i1 >> 0] | 0) break;
     if (!(Math_fround(f38 * Math_fround(f50 * Math_fround(HEAPF32[i493 + (i1 << 2) >> 2]))) == Math_fround(0.0))) break;
     f36 = Math_fround(HEAPF32[i516 + 452 + (i1 << 2) >> 2]);
     f37 = Math_fround(Math_abs(Math_fround(f36)));
     if (!(f37 < Math_fround(HEAPF32[gb + 1458420 >> 2]))) break;
     f53 = Math_fround(HEAPF32[i510 + 192 + (i1 * 48 | 0) + 36 >> 2]);
     f54 = Math_fround(f37 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
     f35 = Math_fround(Math_fround(f35 * f54) + Math_fround(Math_fround(f36 * f53) * Math_fround(Math_fround(1.0) - f54)));
    } while (0);
    i30 = i511 + 32 + (i1 << 2) | 0;
    f54 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + Math_fround(f456 * f35));
    f47 = Math_fround(f54 + Math_fround(-31.4159279));
    f53 = Math_fround(f54 + Math_fround(31.4159279));
    i29 = Math_fround(Math_fround(-31.4159279) - f54) >= Math_fround(0.0);
    i28 = f47 >= Math_fround(0.0);
    HEAPF32[i30 >> 2] = i28 ? f47 : i29 ? f53 : f54;
    HEAPF32[i511 + 16 + (i1 << 2) >> 2] = f35;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   if (i425) {
    i17 = HEAP32[i489 >> 2] | 0;
    i18 = HEAP32[i472 >> 2] | 0;
    i19 = HEAP32[i473 >> 2] | 0;
    i20 = HEAP32[i474 >> 2] | 0;
    i21 = HEAP32[i475 >> 2] | 0;
    i22 = HEAP32[i476 >> 2] | 0;
    i23 = HEAP32[i477 >> 2] | 0;
    i24 = HEAP32[i508 >> 2] | 0;
    i25 = HEAP32[i479 >> 2] | 0;
    i26 = HEAP32[i470 >> 2] | 0;
    i27 = HEAP32[i507 >> 2] | 0;
    i28 = HEAP32[i471 >> 2] | 0;
    i29 = HEAP32[i469 >> 2] | 0;
    f40 = Math_fround(HEAPF32[i490 >> 2]);
    f39 = Math_fround(HEAPF32[i434 >> 2]);
    f38 = Math_fround(HEAPF32[i435 >> 2]);
    f37 = Math_fround(HEAPF32[i491 >> 2]);
    f36 = Math_fround(HEAPF32[i436 >> 2]);
    f35 = Math_fround(HEAPF32[i437 >> 2]);
    i30 = 1;
    do {
     i6 = HEAP32[i510 + (i30 * 944 | 0) + 272 >> 2] | 0;
     i5 = HEAP32[i510 + (i30 * 944 | 0) + 320 >> 2] | 0;
     i4 = HEAP32[i510 + (i30 * 944 | 0) + 368 >> 2] | 0;
     HEAP32[i498 >> 2] = HEAP32[i510 + (i30 * 944 | 0) + 224 >> 2];
     HEAP32[i426 >> 2] = i6;
     HEAP32[i427 >> 2] = i5;
     HEAP32[i428 >> 2] = i4;
     HEAP32[i499 >> 2] = 0;
     HEAP32[i499 + 4 >> 2] = 0;
     HEAP32[i499 + 8 >> 2] = 0;
     HEAP32[i499 + 12 >> 2] = 0;
     HEAP32[i495 >> 2] = 0;
     HEAP32[i496 >> 2] = 0;
     i4 = i511 + (i30 * 224 | 0) | 0;
     f43 = Math_fround(HEAPF32[i4 >> 2]);
     i5 = f43 <= Math_fround(-0.0);
     f41 = i5 ? Math_fround(0.0) : Math_fround(1.0);
     i5 = f43 >= Math_fround(0.0);
     f41 = i5 ? f41 : Math_fround(-1.0);
     f43 = Math_fround(f41 * f52);
     i5 = i510 + (i30 * 944 | 0) + 212 | 0;
     f42 = Math_fround(HEAPF32[i5 >> 2]);
     f43 = Math_fround(f42 * f43);
     f41 = Math_fround(f468 * f41);
     i6 = i510 + (i30 * 944 | 0) + 216 | 0;
     f47 = Math_fround(HEAPF32[i6 >> 2]);
     f41 = Math_fround(f43 - Math_fround(f47 * f41));
     HEAP8[i496 >> 0] = Math_fround(Math_fround(f467 * f42) + Math_fround(f468 * f47)) != Math_fround(0.0) & 1;
     i7 = i511 + (i30 * 224 | 0) + 4 | 0;
     f47 = Math_fround(HEAPF32[i7 >> 2]);
     i8 = f47 <= Math_fround(-0.0);
     f42 = i8 ? Math_fround(0.0) : Math_fround(1.0);
     i8 = f47 >= Math_fround(0.0);
     f42 = i8 ? f42 : Math_fround(-1.0);
     f47 = Math_fround(f42 * f52);
     i8 = i510 + (i30 * 944 | 0) + 260 | 0;
     f43 = Math_fround(HEAPF32[i8 >> 2]);
     f47 = Math_fround(f43 * f47);
     f42 = Math_fround(f468 * f42);
     i9 = i510 + (i30 * 944 | 0) + 264 | 0;
     f53 = Math_fround(HEAPF32[i9 >> 2]);
     f42 = Math_fround(f47 - Math_fround(f53 * f42));
     HEAP8[i429 >> 0] = Math_fround(Math_fround(f467 * f43) + Math_fround(f468 * f53)) != Math_fround(0.0) & 1;
     i10 = i511 + (i30 * 224 | 0) + 8 | 0;
     f53 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = f53 <= Math_fround(-0.0);
     f43 = i11 ? Math_fround(0.0) : Math_fround(1.0);
     i11 = f53 >= Math_fround(0.0);
     f43 = i11 ? f43 : Math_fround(-1.0);
     f53 = Math_fround(f43 * f52);
     i11 = i510 + (i30 * 944 | 0) + 308 | 0;
     f47 = Math_fround(HEAPF32[i11 >> 2]);
     f53 = Math_fround(f47 * f53);
     f43 = Math_fround(f468 * f43);
     i12 = i510 + (i30 * 944 | 0) + 312 | 0;
     f524 = Math_fround(HEAPF32[i12 >> 2]);
     f43 = Math_fround(f53 - Math_fround(f524 * f43));
     HEAP8[i430 >> 0] = Math_fround(Math_fround(f467 * f47) + Math_fround(f468 * f524)) != Math_fround(0.0) & 1;
     i13 = i511 + (i30 * 224 | 0) + 12 | 0;
     f524 = Math_fround(HEAPF32[i13 >> 2]);
     i14 = f524 <= Math_fround(-0.0);
     f47 = i14 ? Math_fround(0.0) : Math_fround(1.0);
     i14 = f524 >= Math_fround(0.0);
     f47 = i14 ? f47 : Math_fround(-1.0);
     f524 = Math_fround(f47 * f52);
     i14 = i510 + (i30 * 944 | 0) + 356 | 0;
     f53 = Math_fround(HEAPF32[i14 >> 2]);
     f524 = Math_fround(f53 * f524);
     f47 = Math_fround(f468 * f47);
     i15 = i510 + (i30 * 944 | 0) + 360 | 0;
     f54 = Math_fround(HEAPF32[i15 >> 2]);
     f47 = Math_fround(f524 - Math_fround(f54 * f47));
     HEAP8[i431 >> 0] = Math_fround(Math_fround(f467 * f53) + Math_fround(f468 * f54)) != Math_fround(0.0) & 1;
     HEAP32[i497 >> 2] = 0;
     i16 = i30 << 2;
     i1 = HEAP32[i521 + 52 + ((i30 >>> 3 & 134217727) << 2) >> 2] | 0;
     i2 = i16 & 28;
     if (i1 & 1 << i2 | 0) HEAP8[i497 >> 0] = 1;
     if (i1 & 1 << (i2 | 1) | 0) HEAP8[i211 >> 0] = 1;
     if (i1 & 1 << (i2 | 2) | 0) HEAP8[i210 >> 0] = 1;
     if (i1 & 1 << (i2 | 3) | 0) HEAP8[i209 >> 0] = 1;
     HEAP8[i509 >> 0] = i212;
     HEAP32[i432 >> 2] = i495;
     HEAP32[i33 >> 2] = i496;
     HEAP32[i55 >> 2] = i498;
     HEAP32[i56 >> 2] = i497;
     HEAP32[i57 >> 2] = i17;
     HEAP32[i58 >> 2] = i18;
     HEAP32[i59 >> 2] = i19;
     HEAP32[i60 >> 2] = i20;
     HEAP32[i61 >> 2] = i21;
     HEAP32[i62 >> 2] = i22;
     HEAP32[i63 >> 2] = i23;
     HEAP32[i64 >> 2] = i24;
     HEAP32[i65 >> 2] = i25;
     HEAP32[i66 >> 2] = i26;
     HEAP32[i67 >> 2] = i27;
     HEAP32[i68 >> 2] = i28;
     HEAP32[i69 >> 2] = i29;
     HEAP32[i70 >> 2] = i510 + (i30 * 944 | 0);
     HEAP32[i71 >> 2] = i4;
     HEAP32[i72 >> 2] = i506 + (i30 * 20 | 0);
     HEAP32[i73 >> 2] = i485;
     i1 = i515 + (i30 << 2) | 0;
     HEAP32[i74 >> 2] = HEAP32[i1 >> 2];
     _memset(i516 | 0, 0, 1128) | 0;
     HEAP8[i75 >> 0] = 1;
     HEAP32[i76 >> 2] = -1;
     HEAP8[i77 >> 0] = 1;
     HEAP32[i78 >> 2] = -1;
     HEAP8[i79 >> 0] = 1;
     HEAP32[i80 >> 2] = -1;
     HEAP8[i81 >> 0] = 1;
     HEAP32[i82 >> 2] = -1;
     __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(i16, i492, i509, i516);
     i3 = HEAP32[i71 >> 2] | 0;
     i2 = i3 + 48 | 0;
     f524 = Math_fround(HEAPF32[i83 >> 2]);
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i84 >> 2]);
     i2 = i3 + 52 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i85 >> 2]);
     i2 = i3 + 56 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i86 >> 2]);
     i2 = i3 + 60 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     i2 = i3 + 64 | 0;
     f524 = Math_fround(HEAPF32[i87 >> 2]);
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i88 >> 2]);
     i2 = i3 + 68 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i89 >> 2]);
     i2 = i3 + 72 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     f524 = Math_fround(HEAPF32[i90 >> 2]);
     i2 = i3 + 76 | 0;
     i525 = f524 != Math_fround(HEAPF32[i2 >> 2]);
     HEAPF32[i2 >> 2] = i525 ? f524 : Math_fround(0.0);
     i3 = i3 + 80 | 0;
     HEAP32[i3 >> 2] = HEAP32[i91 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i91 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i91 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i91 + 12 >> 2];
     if (i31) {
      if (HEAP32[i511 + (i30 * 224 | 0) + 212 >> 2] | 0) HEAP8[i511 + (i30 * 224 | 0) + 216 >> 0] = 1;
      HEAP16[i511 + (i30 * 224 | 0) + 192 >> 1] = HEAP32[i92 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 96 >> 2] = HEAP32[i93 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 100 >> 2] = HEAP32[i96 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 104 >> 2] = HEAP32[i97 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 108 >> 2] = HEAP32[i98 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 176 >> 2] = HEAP32[i94 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 160 >> 2] = HEAP32[i95 >> 2];
      HEAP16[i511 + (i30 * 224 | 0) + 194 >> 1] = HEAP32[i99 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 112 >> 2] = HEAP32[i100 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 116 >> 2] = HEAP32[i101 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 120 >> 2] = HEAP32[i102 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 124 >> 2] = HEAP32[i103 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 180 >> 2] = HEAP32[i104 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 164 >> 2] = HEAP32[i105 >> 2];
      HEAP16[i511 + (i30 * 224 | 0) + 196 >> 1] = HEAP32[i106 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 128 >> 2] = HEAP32[i107 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 132 >> 2] = HEAP32[i108 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 136 >> 2] = HEAP32[i109 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 140 >> 2] = HEAP32[i110 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 184 >> 2] = HEAP32[i111 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 168 >> 2] = HEAP32[i112 >> 2];
      HEAP16[i511 + (i30 * 224 | 0) + 198 >> 1] = HEAP32[i113 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 144 >> 2] = HEAP32[i114 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 148 >> 2] = HEAP32[i115 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 152 >> 2] = HEAP32[i116 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 156 >> 2] = HEAP32[i117 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 188 >> 2] = HEAP32[i118 >> 2];
      HEAP32[i511 + (i30 * 224 | 0) + 172 >> 2] = HEAP32[i119 >> 2];
     }
     f40 = Math_fround(Math_fround(HEAPF32[i120 >> 2]) + f40);
     f39 = Math_fround(Math_fround(HEAPF32[i121 >> 2]) + f39);
     f38 = Math_fround(Math_fround(HEAPF32[i122 >> 2]) + f38);
     f37 = Math_fround(Math_fround(HEAPF32[i123 >> 2]) + f37);
     f36 = Math_fround(Math_fround(HEAPF32[i124 >> 2]) + f36);
     f35 = Math_fround(Math_fround(HEAPF32[i125 >> 2]) + f35);
     if (i32) {
      i525 = HEAP32[i511 + (i30 * 224 | 0) + 208 >> 2] | 0;
      HEAP32[i525 + 4 >> 2] = HEAP32[i126 >> 2];
      HEAP32[i525 + 8 >> 2] = HEAP32[i127 >> 2];
      HEAP32[i525 + 12 >> 2] = HEAP32[i128 >> 2];
      HEAP32[i525 + 16 >> 2] = HEAP32[i129 >> 2];
      HEAP32[i525 + 20 >> 2] = HEAP32[i130 >> 2];
      HEAP32[i525 + 24 >> 2] = HEAP32[i131 >> 2];
      HEAP32[i525 + 28 >> 2] = HEAP32[i132 >> 2];
      HEAP32[i525 + 32 >> 2] = HEAP32[i133 >> 2];
      HEAP32[i525 + 36 >> 2] = HEAP32[i134 >> 2];
      HEAP32[i525 + 40 >> 2] = HEAP32[i135 >> 2];
      HEAP32[i525 + 44 >> 2] = HEAP32[i136 >> 2];
      HEAP32[i525 + 48 >> 2] = HEAP32[i137 >> 2];
      HEAP32[i525 + 52 >> 2] = HEAP32[i138 >> 2];
      HEAP32[i525 + 56 >> 2] = HEAP32[i139 >> 2];
      HEAP32[i525 + 60 >> 2] = HEAP32[i140 >> 2];
      HEAP32[i525 + 64 >> 2] = HEAP32[i141 >> 2];
      HEAP32[i525 + 68 >> 2] = HEAP32[i142 >> 2];
      HEAP32[i525 + 72 >> 2] = HEAP32[i143 >> 2];
      HEAP32[i525 + 76 >> 2] = HEAP32[i144 >> 2];
      HEAP32[i525 + 80 >> 2] = HEAP32[i145 >> 2];
      HEAP32[i525 + 84 >> 2] = HEAP32[i146 >> 2];
      HEAP32[i525 + 88 >> 2] = HEAP32[i147 >> 2];
      HEAP32[i525 + 92 >> 2] = HEAP32[i148 >> 2];
      HEAP32[i525 + 96 >> 2] = HEAP32[i149 >> 2];
      i3 = i525 + 100 | 0;
      HEAP32[i3 >> 2] = HEAP32[i150 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i150 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i150 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i150 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i150 + 16 >> 2];
      HEAP32[i525 + 120 >> 2] = HEAP32[i151 >> 2];
      HEAP32[i525 + 124 >> 2] = HEAP32[i152 >> 2];
      HEAP32[i525 + 128 >> 2] = HEAP32[i153 >> 2];
      HEAP32[i525 + 132 >> 2] = HEAP32[i154 >> 2];
      HEAP32[i525 + 136 >> 2] = HEAP32[i155 >> 2];
      HEAP32[i525 + 140 >> 2] = HEAP32[i156 >> 2];
      HEAP32[i525 + 144 >> 2] = HEAP32[i157 >> 2];
      HEAP32[i525 + 148 >> 2] = HEAP32[i158 >> 2];
      HEAP32[i525 + 152 >> 2] = HEAP32[i159 >> 2];
      HEAP32[i525 + 156 >> 2] = HEAP32[i160 >> 2];
      HEAP32[i525 + 160 >> 2] = HEAP32[i161 >> 2];
      HEAP32[i525 + 164 >> 2] = HEAP32[i162 >> 2];
      HEAP32[i525 + 168 >> 2] = HEAP32[i163 >> 2];
      HEAP32[i525 + 172 >> 2] = HEAP32[i164 >> 2];
      HEAP32[i525 + 176 >> 2] = HEAP32[i165 >> 2];
      HEAP32[i525 + 180 >> 2] = HEAP32[i166 >> 2];
      HEAP32[i525 + 184 >> 2] = HEAP32[i167 >> 2];
      HEAP32[i525 + 188 >> 2] = HEAP32[i168 >> 2];
      HEAP32[i525 + 192 >> 2] = HEAP32[i169 >> 2];
      HEAP32[i525 + 196 >> 2] = HEAP32[i170 >> 2];
      HEAP32[i525 + 200 >> 2] = HEAP32[i171 >> 2];
      HEAP32[i525 + 204 >> 2] = HEAP32[i172 >> 2];
      HEAP32[i525 + 208 >> 2] = HEAP32[i173 >> 2];
      HEAP32[i525 + 212 >> 2] = HEAP32[i174 >> 2];
      i3 = i525 + 216 | 0;
      HEAP32[i3 >> 2] = HEAP32[i175 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i175 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i175 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i175 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i175 + 16 >> 2];
      HEAP32[i525 + 236 >> 2] = HEAP32[i176 >> 2];
      HEAP32[i525 + 240 >> 2] = HEAP32[i177 >> 2];
      HEAP32[i525 + 244 >> 2] = HEAP32[i178 >> 2];
      HEAP32[i525 + 248 >> 2] = HEAP32[i179 >> 2];
      HEAP32[i525 + 252 >> 2] = HEAP32[i180 >> 2];
      HEAP32[i525 + 256 >> 2] = HEAP32[i181 >> 2];
      HEAP32[i525 + 260 >> 2] = HEAP32[i182 >> 2];
      HEAP32[i525 + 264 >> 2] = HEAP32[i183 >> 2];
      HEAP32[i525 + 268 >> 2] = HEAP32[i184 >> 2];
      HEAP32[i525 + 272 >> 2] = HEAP32[i185 >> 2];
      HEAP32[i525 + 276 >> 2] = HEAP32[i186 >> 2];
      HEAP32[i525 + 280 >> 2] = HEAP32[i187 >> 2];
      HEAP32[i525 + 284 >> 2] = HEAP32[i188 >> 2];
      HEAP32[i525 + 288 >> 2] = HEAP32[i189 >> 2];
      HEAP32[i525 + 292 >> 2] = HEAP32[i190 >> 2];
      HEAP32[i525 + 296 >> 2] = HEAP32[i191 >> 2];
      HEAP32[i525 + 300 >> 2] = HEAP32[i192 >> 2];
      HEAP32[i525 + 304 >> 2] = HEAP32[i193 >> 2];
      HEAP32[i525 + 308 >> 2] = HEAP32[i194 >> 2];
      HEAP32[i525 + 312 >> 2] = HEAP32[i195 >> 2];
      HEAP32[i525 + 316 >> 2] = HEAP32[i196 >> 2];
      HEAP32[i525 + 320 >> 2] = HEAP32[i197 >> 2];
      HEAP32[i525 + 324 >> 2] = HEAP32[i198 >> 2];
      HEAP32[i525 + 328 >> 2] = HEAP32[i199 >> 2];
      i3 = i525 + 332 | 0;
      HEAP32[i3 >> 2] = HEAP32[i200 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i200 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i200 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i200 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i200 + 16 >> 2];
      HEAP32[i525 + 352 >> 2] = HEAP32[i201 >> 2];
      HEAP32[i525 + 356 >> 2] = HEAP32[i202 >> 2];
      HEAP32[i525 + 360 >> 2] = HEAP32[i203 >> 2];
      HEAP32[i525 + 364 >> 2] = HEAP32[i204 >> 2];
     }
     i1 = HEAP32[i1 >> 2] | 0;
     __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i516, HEAP32[i55 >> 2] | 0, i520 + (i16 * 148 | 0) | 0, i1);
     i2 = HEAP32[i519 >> 2] | 0;
     if (i1 | 0) {
      i3 = 0;
      do {
       i525 = i3 + i16 | 0;
       HEAP32[i2 + (i525 * 56 | 0) + 28 >> 2] = HEAP32[i516 + 1016 + (i3 << 2) >> 2];
       f524 = Math_fround(HEAPF32[i516 + 1032 + (i3 * 12 | 0) >> 2]);
       i526 = i2 + (i525 * 56 | 0) + 32 | 0;
       HEAPF32[i526 >> 2] = Math_fround(f524 + Math_fround(HEAPF32[i526 >> 2]));
       f524 = Math_fround(HEAPF32[i516 + 1032 + (i3 * 12 | 0) + 4 >> 2]);
       i526 = i2 + (i525 * 56 | 0) + 36 | 0;
       HEAPF32[i526 >> 2] = Math_fround(f524 + Math_fround(HEAPF32[i526 >> 2]));
       f524 = Math_fround(HEAPF32[i516 + 1032 + (i3 * 12 | 0) + 8 >> 2]);
       i526 = i2 + (i525 * 56 | 0) + 40 | 0;
       HEAPF32[i526 >> 2] = Math_fround(f524 + Math_fround(HEAPF32[i526 >> 2]));
       HEAP32[i2 + (i525 * 56 | 0) + 44 >> 2] = HEAP32[i516 + 1080 + (i3 * 12 | 0) >> 2];
       HEAP32[i2 + (i525 * 56 | 0) + 48 >> 2] = HEAP32[i516 + 1080 + (i3 * 12 | 0) + 4 >> 2];
       HEAP32[i2 + (i525 * 56 | 0) + 52 >> 2] = HEAP32[i516 + 1080 + (i3 * 12 | 0) + 8 >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i1 | 0));
     }
     f53 = Math_fround(HEAPF32[i4 >> 2]);
     f524 = Math_fround(f456 * Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 232 >> 2]));
     f54 = Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 208 >> 2]);
     f524 = Math_fround(Math_fround(f53 + Math_fround(f524 * Math_fround(f41 + Math_fround(HEAPF32[i205 >> 2])))) / Math_fround(Math_fround(f54 * f524) + Math_fround(1.0)));
     f54 = Math_fround(HEAPF32[i5 >> 2]);
     i1 = Math_fround(f53 * f524) <= Math_fround(0.0) ? Math_fround(Math_fround(f467 * f54) + Math_fround(f468 * Math_fround(HEAPF32[i6 >> 2]))) != Math_fround(0.0) : 0;
     HEAPF32[i4 >> 2] = i1 ? Math_fround(0.0) : f524;
     f524 = Math_fround(HEAPF32[i7 >> 2]);
     f54 = Math_fround(f456 * Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 280 >> 2]));
     f53 = Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 256 >> 2]);
     f54 = Math_fround(Math_fround(f524 + Math_fround(f54 * Math_fround(f42 + Math_fround(HEAPF32[i206 >> 2])))) / Math_fround(Math_fround(f53 * f54) + Math_fround(1.0)));
     f53 = Math_fround(HEAPF32[i8 >> 2]);
     i1 = Math_fround(f524 * f54) <= Math_fround(0.0) ? Math_fround(Math_fround(f467 * f53) + Math_fround(f468 * Math_fround(HEAPF32[i9 >> 2]))) != Math_fround(0.0) : 0;
     HEAPF32[i7 >> 2] = i1 ? Math_fround(0.0) : f54;
     f54 = Math_fround(HEAPF32[i10 >> 2]);
     f53 = Math_fround(f456 * Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 328 >> 2]));
     f524 = Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 304 >> 2]);
     f53 = Math_fround(Math_fround(f54 + Math_fround(f53 * Math_fround(f43 + Math_fround(HEAPF32[i207 >> 2])))) / Math_fround(Math_fround(f524 * f53) + Math_fround(1.0)));
     f524 = Math_fround(HEAPF32[i11 >> 2]);
     i1 = Math_fround(f54 * f53) <= Math_fround(0.0) ? Math_fround(Math_fround(f467 * f524) + Math_fround(f468 * Math_fround(HEAPF32[i12 >> 2]))) != Math_fround(0.0) : 0;
     HEAPF32[i10 >> 2] = i1 ? Math_fround(0.0) : f53;
     f53 = Math_fround(HEAPF32[i13 >> 2]);
     f524 = Math_fround(f456 * Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 376 >> 2]));
     f54 = Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 352 >> 2]);
     f524 = Math_fround(Math_fround(f53 + Math_fround(f524 * Math_fround(f47 + Math_fround(HEAPF32[i208 >> 2])))) / Math_fround(Math_fround(f54 * f524) + Math_fround(1.0)));
     f54 = Math_fround(HEAPF32[i14 >> 2]);
     i1 = Math_fround(f53 * f524) <= Math_fround(0.0) ? Math_fround(Math_fround(f467 * f54) + Math_fround(f468 * Math_fround(HEAPF32[i15 >> 2]))) != Math_fround(0.0) : 0;
     HEAPF32[i13 >> 2] = i1 ? Math_fround(0.0) : f524;
     i1 = 0;
     do {
      f41 = Math_fround(HEAPF32[i511 + (i30 * 224 | 0) + (i1 << 2) >> 2]);
      f524 = Math_fround(HEAPF32[i516 + 292 + (i1 << 2) >> 2]);
      do if (f524 > Math_fround(-Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + (i1 * 48 | 0) + 12 >> 2]))) {
       if (HEAP8[i496 + i1 >> 0] | 0) break;
       if (!(Math_fround(Math_fround(Math_fround(HEAPF32[i499 + (i1 << 2) >> 2]) * Math_fround(0.0)) * Math_fround(0.0)) == Math_fround(0.0))) break;
       f42 = Math_fround(HEAPF32[i516 + 452 + (i1 << 2) >> 2]);
       f43 = Math_fround(Math_abs(Math_fround(f42)));
       if (!(f43 < Math_fround(HEAPF32[gb + 1458420 >> 2]))) break;
       f54 = Math_fround(HEAPF32[i510 + (i30 * 944 | 0) + 192 + (i1 * 48 | 0) + 36 >> 2]);
       f524 = Math_fround(f43 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
       f41 = Math_fround(Math_fround(f41 * f524) + Math_fround(Math_fround(f42 * f54) * Math_fround(Math_fround(1.0) - f524)));
      } while (0);
      i526 = i511 + (i30 * 224 | 0) + 32 + (i1 << 2) | 0;
      f524 = Math_fround(Math_fround(HEAPF32[i526 >> 2]) + Math_fround(f456 * f41));
      f53 = Math_fround(f524 + Math_fround(-31.4159279));
      f54 = Math_fround(f524 + Math_fround(31.4159279));
      i525 = Math_fround(Math_fround(-31.4159279) - f524) >= Math_fround(0.0);
      i16 = f53 >= Math_fround(0.0);
      HEAPF32[i526 >> 2] = i16 ? f53 : i525 ? f54 : f524;
      HEAPF32[i511 + (i30 * 224 | 0) + 16 + (i1 << 2) >> 2] = f41;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 4);
     i30 = i30 + 1 | 0;
    } while ((i30 | 0) != (i513 | 0));
    HEAPF32[i490 >> 2] = f40;
    HEAPF32[i434 >> 2] = f39;
    HEAPF32[i435 >> 2] = f38;
    HEAPF32[i491 >> 2] = f37;
    HEAPF32[i436 >> 2] = f36;
    HEAPF32[i437 >> 2] = f35;
   }
   __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE(f478, i502, i490, i491, f456, i508, i507, i489);
   i433 = i433 + 1 | 0;
   if ((i433 | 0) == (i455 | 0)) break L134;
  }
 } while (0);
 i33 = i519 + 8 | 0;
 if (!(HEAP8[gb + 1552705 >> 0] | 0)) {
  HEAP32[i33 >> 2] = HEAP32[i508 >> 2];
  HEAP32[i519 + 12 >> 2] = HEAP32[i479 >> 2];
  HEAP32[i519 + 16 >> 2] = HEAP32[i470 >> 2];
  HEAP32[i519 + 20 >> 2] = HEAP32[i507 >> 2];
  HEAP32[i519 + 24 >> 2] = HEAP32[i471 >> 2];
  HEAP32[i519 + 28 >> 2] = HEAP32[i469 >> 2];
 } else {
  f524 = Math_fround(Math_fround(HEAPF32[i459 >> 2]) - f48);
  f478 = Math_fround(Math_fround(HEAPF32[i479 >> 2]) - f49);
  f478 = Math_fround(f457 * f478);
  f468 = Math_fround(f457 * Math_fround(Math_fround(HEAPF32[i470 >> 2]) - f51));
  HEAPF32[i33 >> 2] = Math_fround(f457 * f524);
  HEAPF32[i519 + 12 >> 2] = f478;
  HEAPF32[i519 + 16 >> 2] = f468;
  f468 = Math_fround(Math_fround(HEAPF32[i458 >> 2]) - f44);
  f478 = Math_fround(Math_fround(HEAPF32[i471 >> 2]) - f45);
  f478 = Math_fround(f457 * f478);
  f524 = Math_fround(f457 * Math_fround(Math_fround(HEAPF32[i469 >> 2]) - f46));
  HEAPF32[i519 + 20 >> 2] = Math_fround(f457 * f468);
  HEAPF32[i519 + 24 >> 2] = f478;
  HEAPF32[i519 + 28 >> 2] = f524;
 }
 HEAPF32[i509 >> 2] = Math_fround(0.0);
 i483 = i509 + 4 | 0;
 HEAPF32[i483 >> 2] = Math_fround(0.0);
 i484 = i509 + 8 | 0;
 HEAPF32[i484 >> 2] = Math_fround(0.0);
 i485 = i509 + 12 | 0;
 HEAPF32[i485 >> 2] = Math_fround(1.0);
 i508 = i509 + 16 | 0;
 i487 = i509 + 20 | 0;
 i488 = i509 + 24 | 0;
 i489 = i509 + 28 | 0;
 i490 = i509 + 32 | 0;
 i491 = i509 + 36 | 0;
 i492 = i509 + 40 | 0;
 HEAP32[i508 >> 2] = 0;
 HEAP32[i508 + 4 >> 2] = 0;
 HEAP32[i508 + 8 >> 2] = 0;
 HEAP32[i508 + 12 >> 2] = 0;
 HEAP32[i508 + 16 >> 2] = 0;
 HEAP32[i508 + 20 >> 2] = 0;
 HEAPF32[i492 >> 2] = Math_fround(1.0);
 i508 = i509 + 44 | 0;
 i494 = i509 + 48 | 0;
 i495 = i509 + 52 | 0;
 i496 = i509 + 56 | 0;
 i497 = i509 + 60 | 0;
 i498 = i509 + 64 | 0;
 i499 = i509 + 68 | 0;
 HEAP32[i508 >> 2] = 0;
 HEAP32[i508 + 4 >> 2] = 0;
 HEAP32[i508 + 8 >> 2] = 0;
 HEAP32[i508 + 12 >> 2] = 0;
 HEAP32[i508 + 16 >> 2] = 0;
 HEAP32[i508 + 20 >> 2] = 0;
 HEAPF32[i499 >> 2] = Math_fround(1.0);
 i508 = i509 + 72 | 0;
 i501 = i509 + 76 | 0;
 i502 = i509 + 80 | 0;
 i503 = i509 + 84 | 0;
 i504 = i509 + 88 | 0;
 i505 = i509 + 92 | 0;
 i506 = i509 + 96 | 0;
 HEAP32[i508 >> 2] = 0;
 HEAP32[i508 + 4 >> 2] = 0;
 HEAP32[i508 + 8 >> 2] = 0;
 HEAP32[i508 + 12 >> 2] = 0;
 HEAP32[i508 + 16 >> 2] = 0;
 HEAP32[i508 + 20 >> 2] = 0;
 HEAPF32[i506 >> 2] = Math_fround(1.0);
 HEAPF32[i509 + 100 >> 2] = Math_fround(0.0);
 i508 = i509 + 104 | 0;
 HEAPF32[i508 >> 2] = Math_fround(0.0);
 i525 = i509 + 108 | 0;
 HEAPF32[i525 >> 2] = Math_fround(0.0);
 __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i510, i511, i520, HEAP32[i515 >> 2] | 0, i514, i509);
 HEAP32[i520 + 120 >> 2] = HEAP32[i509 >> 2];
 HEAP32[i520 + 124 >> 2] = HEAP32[i483 >> 2];
 HEAP32[i520 + 128 >> 2] = HEAP32[i484 >> 2];
 HEAP32[i520 + 132 >> 2] = HEAP32[i485 >> 2];
 i486 = i509 + 16 | 0;
 HEAP32[i520 + 136 >> 2] = HEAP32[i486 >> 2];
 HEAP32[i520 + 140 >> 2] = HEAP32[i487 >> 2];
 HEAP32[i520 + 144 >> 2] = HEAP32[i488 >> 2];
 HEAP32[i520 + 268 >> 2] = HEAP32[i489 >> 2];
 HEAP32[i520 + 272 >> 2] = HEAP32[i490 >> 2];
 HEAP32[i520 + 276 >> 2] = HEAP32[i491 >> 2];
 HEAP32[i520 + 280 >> 2] = HEAP32[i492 >> 2];
 i493 = i509 + 44 | 0;
 HEAP32[i520 + 284 >> 2] = HEAP32[i493 >> 2];
 HEAP32[i520 + 288 >> 2] = HEAP32[i494 >> 2];
 HEAP32[i520 + 292 >> 2] = HEAP32[i495 >> 2];
 HEAP32[i520 + 416 >> 2] = HEAP32[i496 >> 2];
 HEAP32[i520 + 420 >> 2] = HEAP32[i497 >> 2];
 HEAP32[i520 + 424 >> 2] = HEAP32[i498 >> 2];
 HEAP32[i520 + 428 >> 2] = HEAP32[i499 >> 2];
 i500 = i509 + 72 | 0;
 HEAP32[i520 + 432 >> 2] = HEAP32[i500 >> 2];
 HEAP32[i520 + 436 >> 2] = HEAP32[i501 >> 2];
 HEAP32[i520 + 440 >> 2] = HEAP32[i502 >> 2];
 HEAP32[i520 + 564 >> 2] = HEAP32[i503 >> 2];
 HEAP32[i520 + 568 >> 2] = HEAP32[i504 >> 2];
 HEAP32[i520 + 572 >> 2] = HEAP32[i505 >> 2];
 HEAP32[i520 + 576 >> 2] = HEAP32[i506 >> 2];
 i507 = i509 + 100 | 0;
 HEAP32[i520 + 580 >> 2] = HEAP32[i507 >> 2];
 HEAP32[i520 + 584 >> 2] = HEAP32[i508 >> 2];
 HEAP32[i520 + 588 >> 2] = HEAP32[i525 >> 2];
 i526 = HEAP32[i519 >> 2] | 0;
 HEAP32[i526 >> 2] = HEAP32[i509 >> 2];
 HEAP32[i526 + 4 >> 2] = HEAP32[i483 >> 2];
 HEAP32[i526 + 8 >> 2] = HEAP32[i484 >> 2];
 HEAP32[i526 + 12 >> 2] = HEAP32[i485 >> 2];
 HEAP32[i526 + 16 >> 2] = HEAP32[i486 >> 2];
 HEAP32[i526 + 20 >> 2] = HEAP32[i487 >> 2];
 HEAP32[i526 + 24 >> 2] = HEAP32[i488 >> 2];
 HEAP32[i526 + 56 >> 2] = HEAP32[i489 >> 2];
 HEAP32[i526 + 60 >> 2] = HEAP32[i490 >> 2];
 HEAP32[i526 + 64 >> 2] = HEAP32[i491 >> 2];
 HEAP32[i526 + 68 >> 2] = HEAP32[i492 >> 2];
 HEAP32[i526 + 72 >> 2] = HEAP32[i493 >> 2];
 HEAP32[i526 + 76 >> 2] = HEAP32[i494 >> 2];
 HEAP32[i526 + 80 >> 2] = HEAP32[i495 >> 2];
 HEAP32[i526 + 112 >> 2] = HEAP32[i496 >> 2];
 HEAP32[i526 + 116 >> 2] = HEAP32[i497 >> 2];
 HEAP32[i526 + 120 >> 2] = HEAP32[i498 >> 2];
 HEAP32[i526 + 124 >> 2] = HEAP32[i499 >> 2];
 HEAP32[i526 + 128 >> 2] = HEAP32[i500 >> 2];
 HEAP32[i526 + 132 >> 2] = HEAP32[i501 >> 2];
 HEAP32[i526 + 136 >> 2] = HEAP32[i502 >> 2];
 HEAP32[i526 + 168 >> 2] = HEAP32[i503 >> 2];
 HEAP32[i526 + 172 >> 2] = HEAP32[i504 >> 2];
 HEAP32[i526 + 176 >> 2] = HEAP32[i505 >> 2];
 HEAP32[i526 + 180 >> 2] = HEAP32[i506 >> 2];
 HEAP32[i526 + 184 >> 2] = HEAP32[i507 >> 2];
 HEAP32[i526 + 188 >> 2] = HEAP32[i508 >> 2];
 HEAP32[i526 + 192 >> 2] = HEAP32[i525 >> 2];
 if (i513 >>> 0 > 1) {
  i1 = i516 + 4 | 0;
  i2 = i516 + 8 | 0;
  i3 = i516 + 12 | 0;
  i4 = i516 + 16 | 0;
  i5 = i516 + 20 | 0;
  i6 = i516 + 24 | 0;
  i7 = i516 + 28 | 0;
  i8 = i516 + 32 | 0;
  i9 = i516 + 36 | 0;
  i10 = i516 + 40 | 0;
  i11 = i516 + 44 | 0;
  i12 = i516 + 48 | 0;
  i13 = i516 + 52 | 0;
  i14 = i516 + 56 | 0;
  i15 = i516 + 60 | 0;
  i16 = i516 + 64 | 0;
  i17 = i516 + 68 | 0;
  i18 = i516 + 72 | 0;
  i19 = i516 + 76 | 0;
  i20 = i516 + 80 | 0;
  i21 = i516 + 84 | 0;
  i22 = i516 + 88 | 0;
  i23 = i516 + 92 | 0;
  i24 = i516 + 96 | 0;
  i25 = i516 + 100 | 0;
  i26 = i516 + 104 | 0;
  i27 = i516 + 108 | 0;
  i28 = i516 + 16 | 0;
  i29 = i516 + 44 | 0;
  i30 = i516 + 72 | 0;
  i31 = i516 + 100 | 0;
  i32 = 1;
  do {
   HEAPF32[i516 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAPF32[i17 >> 2] = Math_fround(1.0);
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 20 >> 2] = 0;
   HEAPF32[i24 >> 2] = Math_fround(1.0);
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   i507 = i32 << 2;
   __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i510 + (i32 * 944 | 0) | 0, i511 + (i32 * 224 | 0) | 0, i520 + (i507 * 148 | 0) | 0, HEAP32[i515 + (i32 << 2) >> 2] | 0, i514, i516);
   HEAP32[i520 + (i507 * 148 | 0) + 120 >> 2] = HEAP32[i516 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 124 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 128 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 132 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 136 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 140 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i520 + (i507 * 148 | 0) + 144 >> 2] = HEAP32[i6 >> 2];
   i508 = i507 | 1;
   HEAP32[i520 + (i508 * 148 | 0) + 120 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 124 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 128 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 132 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 136 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 140 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i520 + (i508 * 148 | 0) + 144 >> 2] = HEAP32[i13 >> 2];
   i509 = i507 | 2;
   HEAP32[i520 + (i509 * 148 | 0) + 120 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 124 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 128 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 132 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 136 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 140 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i520 + (i509 * 148 | 0) + 144 >> 2] = HEAP32[i20 >> 2];
   i526 = i507 | 3;
   HEAP32[i520 + (i526 * 148 | 0) + 120 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 124 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 128 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 132 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 136 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 140 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i520 + (i526 * 148 | 0) + 144 >> 2] = HEAP32[i27 >> 2];
   i525 = HEAP32[i519 >> 2] | 0;
   HEAP32[i525 + (i507 * 56 | 0) >> 2] = HEAP32[i516 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 20 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i525 + (i507 * 56 | 0) + 24 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) >> 2] = HEAP32[i7 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 16 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 20 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i525 + (i508 * 56 | 0) + 24 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 12 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 16 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i525 + (i509 * 56 | 0) + 24 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 4 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 8 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 12 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 20 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i525 + (i526 * 56 | 0) + 24 >> 2] = HEAP32[i27 >> 2];
   i32 = i32 + 1 | 0;
  } while ((i32 | 0) != (i513 | 0));
 }
 do if (i517 | 0) {
  i1 = HEAP32[i517 >> 2] | 0;
  if (!i1) break;
  _memcpy(i1 | 0, i520 | 0, i512 * 148 | 0) | 0;
 } while (0);
 if (!i522) {
  HEAP32[i518 >> 2] = i521;
  __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i519, 1, i518);
 } else {
  _memcpy(HEAP32[i522 >> 2] | 0, HEAP32[i519 >> 2] | 0, i512 * 56 | 0) | 0;
  HEAP32[i522 + 8 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i522 + 12 >> 2] = HEAP32[i519 + 12 >> 2];
  HEAP32[i522 + 16 >> 2] = HEAP32[i519 + 16 >> 2];
  HEAP32[i522 + 20 >> 2] = HEAP32[i519 + 20 >> 2];
  HEAP32[i522 + 24 >> 2] = HEAP32[i519 + 24 >> 2];
  HEAP32[i522 + 28 >> 2] = HEAP32[i519 + 28 >> 2];
  i526 = HEAP16[i519 + 32 >> 1] | 0;
  HEAP8[i522 + 32 >> 0] = i526;
  HEAP8[i522 + 33 >> 0] = (i526 & 65535) >>> 8;
 }
 STACKTOP = i523;
 return;
}

function _UNITY_TT_RunIns(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0;
 i141 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i141 + 8 | 0;
 i64 = i141 + 44 | 0;
 i69 = i141 + 4 | 0;
 i80 = i141;
 HEAP32[i17 + 256 >> 2] = 0;
 i63 = HEAP32[i17 + 216 >> 2] | 0;
 i63 = (i63 & 65535) << 16 >> 16 == (i63 >>> 16 & 65535) << 16 >> 16;
 i39 = i17 + 592 | 0;
 HEAP32[i39 >> 2] = i63 ? fb + 2645 | 0 : fb + 2646 | 0;
 i50 = i17 + 596 | 0;
 HEAP32[i50 >> 2] = i63 ? fb + 1097 | 0 : fb + 1098 | 0;
 i61 = i17 + 600 | 0;
 HEAP32[i61 >> 2] = i63 ? fb + 971 | 0 : fb + 972 | 0;
 i62 = i17 + 604 | 0;
 HEAP32[i62 >> 2] = i63 ? fb + 973 | 0 : fb + 974 | 0;
 _Compute_Funcs(i17);
 i63 = i17 + 312 | 0;
 switch ((HEAP32[i63 >> 2] & 255) << 24 >> 24) {
 case 5:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 457;
   break;
  }
 case 1:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 458;
   break;
  }
 case 4:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 459;
   break;
  }
 case 3:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 460;
   break;
  }
 case 0:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 461;
   break;
  }
 case 2:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 462;
   break;
  }
 case 6:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 463;
   break;
  }
 case 7:
  {
   i16 = i17 + 568 | 0;
   HEAP32[i16 >> 2] = fb + 464;
   break;
  }
 default:
  i16 = i17 + 568 | 0;
 }
 i66 = i17 + 360 | 0;
 i67 = i17 + 356 | 0;
 i68 = i17 + 368 | 0;
 i70 = i17 + 372 | 0;
 i71 = i17 + 364 | 0;
 i72 = i17 + 16 | 0;
 i73 = i17 + 28 | 0;
 i74 = i17 + 561 | 0;
 i75 = i17 + 24 | 0;
 i76 = i17 + 32 | 0;
 i77 = i17 + 20 | 0;
 i78 = i17 + 376 | 0;
 i79 = i17 + 12 | 0;
 i81 = i17 + 308 | 0;
 i82 = i17 + 320 | 0;
 i83 = i17 + 72 | 0;
 i84 = i17 + 80 | 0;
 i85 = i17 + 380 | 0;
 i86 = i17 + 284 | 0;
 i87 = i17 + 44 | 0;
 i88 = i17 + 328 | 0;
 i89 = i17 + 324 | 0;
 i90 = i17 + 346 | 0;
 i91 = i17 + 48 | 0;
 i92 = i17 + 298 | 0;
 i93 = i17 + 84 | 0;
 i94 = i17 + 300 | 0;
 i95 = i17 + 88 | 0;
 i96 = i17 + 576 | 0;
 i97 = i17 + 572 | 0;
 i98 = i17 + 52 | 0;
 i99 = i17 + 316 | 0;
 i100 = i17 + 584 | 0;
 i101 = i17 + 344 | 0;
 i102 = i17 + 286 | 0;
 i103 = i17 + 288 | 0;
 i104 = i17 + 92 | 0;
 i105 = i17 + 56 | 0;
 i106 = i17 + 220 | 0;
 i107 = i17 + 224 | 0;
 i108 = i17 + 488 | 0;
 i109 = i17 + 416 | 0;
 i110 = i17 + 408 | 0;
 i111 = i17 + 428 | 0;
 i112 = i17 + 432 | 0;
 i113 = i17 + 436 | 0;
 i114 = i17 + 352 | 0;
 i115 = i17 + 294 | 0;
 i116 = i17 + 296 | 0;
 i117 = i17 + 290 | 0;
 i118 = i17 + 292 | 0;
 i119 = i17 + 294 | 0;
 i120 = i17 + 116 | 0;
 i121 = i17 + 124 | 0;
 i122 = i17 + 290 | 0;
 i123 = i18 + 4 | 0;
 i124 = i18 + 4 | 0;
 i125 = i18 + 4 | 0;
 i126 = i18 + 4 | 0;
 i127 = i17 + 298 | 0;
 i128 = i17 + 132 | 0;
 i129 = i17 + 284 | 0;
 i130 = i17 + 36 | 0;
 i131 = i17 + 180 | 0;
 i132 = i17 + 144 | 0;
 i133 = i17 + 108 | 0;
 i134 = i17 + 348 | 0;
 i135 = i17 + 304 | 0;
 i136 = i17 + 260 | 0;
 i137 = i17 + 60 | 0;
 i138 = i17 + 420 | 0;
 i139 = i17 + 404 | 0;
 i140 = i17 + 396 | 0;
 i19 = i17 + 400 | 0;
 i20 = i17 + 264 | 0;
 i21 = i17 + 154 | 0;
 i22 = i17 + 156 | 0;
 i23 = i17 + 160 | 0;
 i24 = i18 + 4 | 0;
 i25 = i17 + 164 | 0;
 i26 = i18 + 8 | 0;
 i27 = i17 + 152 | 0;
 i28 = i18 + 12 | 0;
 i29 = i17 + 172 | 0;
 i30 = i17 + 176 | 0;
 i31 = i17 + 168 | 0;
 i32 = i18 + 16 | 0;
 i33 = i17 + 136 | 0;
 i34 = i17 + 140 | 0;
 i35 = i17 + 118 | 0;
 i36 = i18 + 16 | 0;
 i37 = i17 + 120 | 0;
 i38 = i17 + 128 | 0;
 i40 = i17 + 588 | 0;
 i41 = i17 + 468 | 0;
 i42 = i17 + 472 | 0;
 i43 = i17 + 332 | 0;
 i44 = i17 + 334 | 0;
 i45 = i17 + 384 | 0;
 i46 = i17 + 476 | 0;
 i47 = i17 + 480 | 0;
 i48 = i17 + 484 | 0;
 i49 = i17 + 282 | 0;
 i51 = i17 + 337 | 0;
 i52 = i17 + 281 | 0;
 i53 = i17 + 252 | 0;
 i54 = i18 + 4 | 0;
 i55 = i18 + 4 | 0;
 i56 = i17 + 608 | 0;
 i57 = i17 + 412 | 0;
 i58 = i17 + 424 | 0;
 i59 = i17 + 340 | 0;
 i60 = i17 + 336 | 0;
 i15 = 0;
 i4 = HEAP32[i66 >> 2] | 0;
 L12 : while (1) {
  i11 = HEAP32[i67 >> 2] | 0;
  i10 = HEAP8[i11 + i4 >> 0] | 0;
  HEAP8[i68 >> 0] = i10;
  i7 = i10 & 255;
  i2 = HEAP8[gb + 1007030 + i7 >> 0] | 0;
  HEAP32[i70 >> 2] = i2;
  if ((i7 | 1 | 0) == 65) {
   i3 = i4 + 1 | 0;
   i1 = HEAP32[i71 >> 2] | 0;
   if ((i3 | 0) >= (i1 | 0)) {
    i12 = 747;
    break;
   }
   i8 = 2 - (Math_imul(HEAPU8[i11 + i3 >> 0] | 0, i2) | 0) | 0;
   HEAP32[i70 >> 2] = i8;
  } else {
   i8 = i2;
   i1 = HEAP32[i71 >> 2] | 0;
  }
  if ((i8 + i4 | 0) > (i1 | 0)) {
   i12 = 747;
   break;
  }
  i2 = HEAP8[gb + 1007286 + i7 >> 0] | 0;
  i5 = i2 & 255;
  i4 = i5 >>> 4;
  i1 = (HEAP32[i72 >> 2] | 0) - i4 | 0;
  HEAP32[i73 >> 2] = i1;
  if ((i1 | 0) < 0) {
   if (HEAP8[i74 >> 0] | 0) {
    i12 = 21;
    break;
   }
   if ((i2 & 255) > 15) {
    i2 = HEAP32[i75 >> 2] | 0;
    i1 = 0;
    i3 = 0;
    do {
     HEAP32[i2 + (i3 << 2) >> 2] = 0;
     i1 = i1 + 1 << 16 >> 16;
     i3 = i1 & 65535;
    } while (i3 >>> 0 < i4 >>> 0);
   }
   HEAP32[i73 >> 2] = 0;
   i1 = 0;
  }
  i5 = (i5 & 15) + i1 | 0;
  HEAP32[i76 >> 2] = i5;
  i6 = HEAP32[i77 >> 2] | 0;
  if ((i5 | 0) > (i6 | 0)) {
   i12 = 25;
   break;
  }
  HEAP8[i78 >> 0] = 1;
  HEAP32[i79 >> 2] = 0;
  i3 = HEAP32[i75 >> 2] | 0;
  i9 = i3 + (i1 << 2) | 0;
  L30 : do switch (i10 << 24 >> 24) {
  case 79:
   {
    i12 = 440;
    break L12;
   }
  case 5:
  case 4:
  case 3:
  case 2:
  case 1:
  case 0:
   {
    i2 = i7 << 14 & 16384;
    i1 = i2 & 65535;
    i2 = (i2 ^ 16384) & 65535;
    if ((i10 & 255) < 4) {
     HEAP16[i115 >> 1] = i1;
     HEAP16[i116 >> 1] = i2;
     HEAP16[i117 >> 1] = i1;
     HEAP16[i118 >> 1] = i2;
    }
    if (!(i7 & 2)) {
     HEAP16[i92 >> 1] = i1;
     HEAP16[i94 >> 1] = i2;
    }
    _Compute_Funcs(i17);
    i12 = 725;
    break;
   }
  case 7:
  case 6:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i14 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = i14 & 65535;
    if ((HEAPU16[i120 >> 1] | 0) > (i14 & 65535)) if ((HEAPU16[i84 >> 1] | 0) > (i2 & 65535)) {
     i13 = i2 & 65535;
     i12 = HEAP32[i95 >> 2] | 0;
     i2 = HEAP32[i121 >> 2] | 0;
     i14 = (HEAP32[i12 + (i13 << 3) >> 2] | 0) - (HEAP32[i2 + (i1 << 3) >> 2] | 0) | 0;
     i2 = (HEAP32[i12 + (i13 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) | 0;
     i13 = (i2 | i14 | 0) == 0;
     i14 = i13 ? 16384 : i14;
     i13 = (i10 & 1) == 0 | i13;
     i1 = i13 ? i2 : i14;
     i2 = i13 ? i14 : 0 - i2 | 0;
     if (i1 | i2 | 0) {
      HEAP32[i18 >> 2] = i2;
      HEAP32[i123 >> 2] = i1;
      _UNITY_FT_Vector_NormLen(i18) | 0;
      HEAP16[i119 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
      HEAP16[i116 >> 1] = (HEAP32[i123 >> 2] | 0) / 4 | 0;
     }
     i12 = HEAPU16[i119 >> 1] | HEAPU16[i119 + 2 >> 1] << 16;
     HEAP16[i122 >> 1] = i12;
     HEAP16[i122 + 2 >> 1] = i12 >>> 16;
     _Compute_Funcs(i17);
     i12 = 725;
     break L30;
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 35;
     break L12;
    }
    break;
   }
  case 9:
  case 8:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i14 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = i14 & 65535;
    if ((HEAPU16[i120 >> 1] | 0) > (i14 & 65535)) if ((HEAPU16[i84 >> 1] | 0) > (i2 & 65535)) {
     i13 = i2 & 65535;
     i12 = HEAP32[i95 >> 2] | 0;
     i2 = HEAP32[i121 >> 2] | 0;
     i14 = (HEAP32[i12 + (i13 << 3) >> 2] | 0) - (HEAP32[i2 + (i1 << 3) >> 2] | 0) | 0;
     i2 = (HEAP32[i12 + (i13 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) | 0;
     i13 = (i2 | i14 | 0) == 0;
     i14 = i13 ? 16384 : i14;
     i13 = (i10 & 1) == 0 | i13;
     i1 = i13 ? i2 : i14;
     i2 = i13 ? i14 : 0 - i2 | 0;
     if (i1 | i2 | 0) {
      HEAP32[i18 >> 2] = i2;
      HEAP32[i124 >> 2] = i1;
      _UNITY_FT_Vector_NormLen(i18) | 0;
      HEAP16[i92 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
      HEAP16[i94 >> 1] = (HEAP32[i124 >> 2] | 0) / 4 | 0;
     }
     _Compute_Funcs(i17);
     i12 = 725;
     break L30;
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 42;
     break L12;
    }
    break;
   }
  case 10:
   {
    i2 = HEAP32[i9 + 4 >> 2] << 16 >> 16;
    i1 = HEAP32[i9 >> 2] << 16 >> 16;
    if (i2 | i1 | 0) {
     HEAP32[i18 >> 2] = i1;
     HEAP32[i125 >> 2] = i2;
     _UNITY_FT_Vector_NormLen(i18) | 0;
     HEAP16[i119 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
     HEAP16[i116 >> 1] = (HEAP32[i125 >> 2] | 0) / 4 | 0;
    }
    i12 = HEAPU16[i119 >> 1] | HEAPU16[i119 + 2 >> 1] << 16;
    HEAP16[i122 >> 1] = i12;
    HEAP16[i122 + 2 >> 1] = i12 >>> 16;
    _Compute_Funcs(i17);
    i12 = 725;
    break;
   }
  case 11:
   {
    i2 = HEAP32[i9 + 4 >> 2] << 16 >> 16;
    i1 = HEAP32[i9 >> 2] << 16 >> 16;
    if (i2 | i1 | 0) {
     HEAP32[i18 >> 2] = i1;
     HEAP32[i126 >> 2] = i2;
     _UNITY_FT_Vector_NormLen(i18) | 0;
     HEAP16[i92 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
     HEAP16[i94 >> 1] = (HEAP32[i126 >> 2] | 0) / 4 | 0;
    }
    _Compute_Funcs(i17);
    i12 = 725;
    break;
   }
  case 12:
   {
    i12 = HEAP16[i116 >> 1] | 0;
    HEAP32[i9 >> 2] = HEAP16[i115 >> 1];
    HEAP32[i9 + 4 >> 2] = i12 << 16 >> 16;
    i12 = 725;
    break;
   }
  case 13:
   {
    i12 = HEAP16[i94 >> 1] | 0;
    HEAP32[i9 >> 2] = HEAP16[i92 >> 1];
    HEAP32[i9 + 4 >> 2] = i12 << 16 >> 16;
    i12 = 725;
    break;
   }
  case 14:
   {
    i12 = HEAPU16[i119 >> 1] | HEAPU16[i119 + 2 >> 1] << 16;
    HEAP16[i127 >> 1] = i12;
    HEAP16[i127 + 2 >> 1] = i12 >>> 16;
    _Compute_Funcs(i17);
    i12 = 725;
    break;
   }
  case 15:
   {
    i4 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i3 = HEAP32[i9 + 8 >> 2] | 0;
    i14 = HEAP32[i9 + 12 >> 2] & 65535;
    i2 = HEAPU16[i87 >> 1] | 0;
    if (i14 >>> 0 < i2 >>> 0) {
     i13 = HEAP32[i9 + 16 >> 2] & 65535;
     if (i13 >>> 0 < i2 >>> 0) {
      i12 = i1 & 65535;
      i1 = HEAPU16[i84 >> 1] | 0;
      if (i12 >>> 0 < i1 >>> 0) {
       i11 = i3 & 65535;
       if (i11 >>> 0 < i1 >>> 0) {
        i1 = i4 & 65535;
        if (i1 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) {
         i143 = HEAP32[i98 >> 2] | 0;
         i2 = HEAP32[i143 + (i14 << 3) >> 2] | 0;
         i3 = (HEAP32[i143 + (i13 << 3) >> 2] | 0) - i2 | 0;
         i4 = HEAP32[i143 + (i14 << 3) + 4 >> 2] | 0;
         i143 = (HEAP32[i143 + (i13 << 3) + 4 >> 2] | 0) - i4 | 0;
         i8 = HEAP32[i95 >> 2] | 0;
         i5 = HEAP32[i8 + (i12 << 3) >> 2] | 0;
         i6 = (HEAP32[i8 + (i11 << 3) >> 2] | 0) - i5 | 0;
         i7 = HEAP32[i8 + (i12 << 3) + 4 >> 2] | 0;
         i8 = (HEAP32[i8 + (i11 << 3) + 4 >> 2] | 0) - i7 | 0;
         i9 = 0 - i143 | 0;
         i10 = _UNITY_FT_MulDiv(i6, i9, 64) | 0;
         i10 = (_UNITY_FT_MulDiv(i8, i3, 64) | 0) + i10 | 0;
         i142 = _UNITY_FT_MulDiv(i6, i3, 64) | 0;
         i142 = (_UNITY_FT_MulDiv(i8, i143, 64) | 0) + i142 | 0;
         if ((((i10 | 0) < 0 ? 0 - i10 | 0 : i10) * 19 | 0) > (((i142 | 0) < 0 ? 0 - i142 | 0 : i142) | 0)) {
          i142 = _UNITY_FT_MulDiv(i2 - i5 | 0, i9, 64) | 0;
          i142 = (_UNITY_FT_MulDiv(i4 - i7 | 0, i3, 64) | 0) + i142 | 0;
          i13 = _UNITY_FT_MulDiv(i142, i6, i10) | 0;
          i142 = _UNITY_FT_MulDiv(i142, i8, i10) | 0;
          i14 = HEAP32[i95 >> 2] | 0;
          i143 = HEAP32[i121 >> 2] | 0;
          HEAP32[i143 + (i1 << 3) >> 2] = (HEAP32[i14 + (i12 << 3) >> 2] | 0) + i13;
          HEAP32[i143 + (i1 << 3) + 4 >> 2] = (HEAP32[i14 + (i12 << 3) + 4 >> 2] | 0) + i142;
         } else {
          i10 = HEAP32[i95 >> 2] | 0;
          i142 = HEAP32[i98 >> 2] | 0;
          i143 = HEAP32[i121 >> 2] | 0;
          HEAP32[i143 + (i1 << 3) >> 2] = ((HEAP32[i10 + (i11 << 3) >> 2] | 0) + (HEAP32[i10 + (i12 << 3) >> 2] | 0) + (HEAP32[i142 + (i14 << 3) >> 2] | 0) + (HEAP32[i142 + (i13 << 3) >> 2] | 0) | 0) / 4 | 0;
          HEAP32[i143 + (i1 << 3) + 4 >> 2] = ((HEAP32[i10 + (i11 << 3) + 4 >> 2] | 0) + (HEAP32[i10 + (i12 << 3) + 4 >> 2] | 0) + (HEAP32[i142 + (i14 << 3) + 4 >> 2] | 0) + (HEAP32[i142 + (i13 << 3) + 4 >> 2] | 0) | 0) / 4 | 0;
         }
         i12 = (HEAP32[i128 >> 2] | 0) + i1 | 0;
         HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 24;
         i12 = 725;
         break L30;
        }
       }
      }
     }
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 61;
     break L12;
    }
    break;
   }
  case 16:
   {
    HEAP16[i129 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 17:
   {
    HEAP16[i102 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 18:
   {
    HEAP16[i103 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 19:
   {
    switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      i1 = i130;
      i2 = i131;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    case 1:
     {
      i1 = i130;
      i2 = i132;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    default:
     if (!(HEAP8[i74 >> 0] | 0)) {
      i12 = 725;
      break L30;
     } else {
      i12 = 73;
      break L12;
     }
    }
    HEAP16[i101 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 20:
   {
    switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      i1 = i83;
      i2 = i131;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    case 1:
     {
      i1 = i83;
      i2 = i132;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    default:
     if (!(HEAP8[i74 >> 0] | 0)) {
      i12 = 725;
      break L30;
     } else {
      i12 = 79;
      break L12;
     }
    }
    HEAP16[i90 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 21:
   {
    switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      i1 = i133;
      i2 = i131;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    case 1:
     {
      i1 = i133;
      i2 = i132;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    default:
     if (!(HEAP8[i74 >> 0] | 0)) {
      i12 = 725;
      break L30;
     } else {
      i12 = 85;
      break L12;
     }
    }
    HEAP16[i134 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 22:
   {
    switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      i1 = i130;
      i2 = i131;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    case 1:
     {
      i1 = i130;
      i2 = i132;
      i3 = i1 + 36 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     }
    default:
     if (!(HEAP8[i74 >> 0] | 0)) {
      i12 = 725;
      break L30;
     } else {
      i12 = 91;
      break L12;
     }
    }
    i1 = i83;
    i2 = i130;
    i3 = i1 + 36 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    i1 = i133;
    i2 = i130;
    i3 = i1 + 36 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    i12 = HEAP32[i9 >> 2] & 65535;
    HEAP16[i101 >> 1] = i12;
    HEAP16[i90 >> 1] = i12;
    HEAP16[i134 >> 1] = i12;
    i12 = 725;
    break;
   }
  case 23:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) < 0) {
     i12 = 94;
     break L12;
    }
    HEAP32[i135 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 24:
   {
    HEAP32[i63 >> 2] = 1;
    HEAP32[i16 >> 2] = fb + 458;
    i12 = 725;
    break;
   }
  case 25:
   {
    HEAP32[i63 >> 2] = 0;
    HEAP32[i16 >> 2] = fb + 461;
    i12 = 725;
    break;
   }
  case 26:
   {
    HEAP32[i81 >> 2] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 27:
   {
    i6 = HEAP32[i71 >> 2] | 0;
    i2 = 1;
    i3 = i8;
    i1 = HEAP32[i66 >> 2] | 0;
    while (1) {
     L196 : while (1) {
      i1 = i3 + i1 | 0;
      HEAP32[i66 >> 2] = i1;
      if ((i1 | 0) >= (i6 | 0)) {
       i12 = 106;
       break L12;
      }
      i5 = HEAP8[i11 + i1 >> 0] | 0;
      HEAP8[i68 >> 0] = i5;
      i143 = i5 & 255;
      i3 = HEAP8[gb + 1007030 + i143 >> 0] | 0;
      HEAP32[i70 >> 2] = i3;
      if ((i143 | 1 | 0) == 65) {
       i4 = i1 + 1 | 0;
       if ((i4 | 0) >= (i6 | 0)) {
        i12 = 106;
        break L12;
       }
       i3 = 2 - (Math_imul(HEAPU8[i11 + i4 >> 0] | 0, i3) | 0) | 0;
       HEAP32[i70 >> 2] = i3;
      }
      if ((i3 + i1 | 0) > (i6 | 0)) {
       i12 = 106;
       break L12;
      }
      switch (i5 << 24 >> 24) {
      case 88:
       {
        i12 = 108;
        break L196;
       }
      case 89:
       {
        i12 = 109;
        break L196;
       }
      default:
       {}
      }
     }
     if ((i12 | 0) == 108) i2 = i2 + 1 | 0; else if ((i12 | 0) == 109) i2 = i2 + -1 | 0;
     if (!i2) {
      i12 = 725;
      break;
     }
    }
    break;
   }
  case 28:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    if (!(i2 | i1)) HEAP32[i79 >> 2] = 132;
    i1 = (HEAP32[i66 >> 2] | 0) + i2 | 0;
    HEAP32[i66 >> 2] = i1;
    if ((i1 | 0) < 0) i12 = 116; else {
     i2 = HEAP32[i111 >> 2] | 0;
     if ((i2 | 0) > 0) if ((i1 | 0) > (HEAP32[(HEAP32[(HEAP32[i113 >> 2] | 0) + (i2 + -1 << 4) + 12 >> 2] | 0) + 8 >> 2] | 0)) i12 = 116;
    }
    if ((i12 | 0) == 116) HEAP32[i79 >> 2] = 132;
    HEAP8[i78 >> 0] = 0;
    i12 = 725;
    break;
   }
  case 29:
   {
    HEAP32[i82 >> 2] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 30:
   {
    HEAP32[i89 >> 2] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 31:
   {
    HEAP32[i88 >> 2] = _UNITY_FT_MulFix(HEAP32[i9 >> 2] | 0, HEAP32[i136 >> 2] | 0) | 0;
    i12 = 725;
    break;
   }
  case 32:
   {
    HEAP32[i9 + 4 >> 2] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 127:
  case 126:
  case 89:
  case 33:
   {
    i12 = 740;
    break;
   }
  case 34:
   {
    HEAP32[i76 >> 2] = 0;
    i12 = 725;
    break;
   }
  case 35:
   {
    i143 = HEAP32[i9 >> 2] | 0;
    i12 = i9 + 4 | 0;
    HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i12 >> 2] = i143;
    i12 = 725;
    break;
   }
  case 36:
   {
    HEAP32[i9 >> 2] = HEAP32[i72 >> 2];
    i12 = 725;
    break;
   }
  case 37:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) < 1 | (i1 | 0) < (i2 | 0)) if (!(HEAP8[i74 >> 0] | 0)) i1 = 0; else {
     HEAP32[i79 >> 2] = 134;
     i1 = 0;
    } else i1 = HEAP32[i3 + (i1 - i2 << 2) >> 2] | 0;
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 38:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) < 1 | (i1 | 0) < (i2 | 0)) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 132;
     break L12;
    } else {
     i143 = i1 - i2 | 0;
     i142 = i3 + (i143 << 2) | 0;
     i12 = HEAP32[i142 >> 2] | 0;
     _memmove(i142 | 0, i3 + (i143 + 1 << 2) | 0, (i2 << 2) + -4 | 0) | 0;
     HEAP32[(HEAP32[i75 >> 2] | 0) + ((HEAP32[i73 >> 2] | 0) + -1 << 2) >> 2] = i12;
     i12 = 725;
     break L30;
    }
   }
  case 39:
   {
    i4 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i2 = i4 & 65535;
    i3 = i1 & 65535;
    i4 = i4 & 65535;
    if (i4 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
     i1 = i1 & 65535;
     if (i1 >>> 0 < (HEAPU16[i87 >> 1] | 0) >>> 0) {
      i143 = HEAP32[i98 >> 2] | 0;
      i12 = HEAP32[i95 >> 2] | 0;
      i12 = (mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i143 + (i1 << 3) >> 2] | 0) - (HEAP32[i12 + (i4 << 3) >> 2] | 0) | 0, (HEAP32[i143 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i12 + (i4 << 3) + 4 >> 2] | 0) | 0) | 0) / 2 | 0;
      mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i83 | 0, i2 | 0, i12 | 0);
      mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i130 | 0, i3 | 0, 0 - i12 | 0);
      i12 = 725;
      break L30;
     }
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 137;
     break L12;
    }
    break;
   }
  case 40:
   {
    _Ins_UNKNOWN(i17);
    i12 = 725;
    break;
   }
  case 41:
   {
    i1 = HEAP32[i9 >> 2] & 65535;
    if (i1 >>> 0 < (HEAPU16[i87 >> 1] | 0) >>> 0) {
     i143 = (HEAP16[i92 >> 1] | 0) == 0 ? -1 : -9;
     i12 = (HEAP32[i137 >> 2] | 0) + i1 | 0;
     HEAP8[i12 >> 0] = ((HEAP16[i94 >> 1] | 0) == 0 ? i143 : i143 & 239) & HEAP8[i12 >> 0];
     i12 = 725;
     break L30;
    } else if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 142;
     break L12;
    }
   }
  case 42:
   {
    i4 = HEAP32[i9 + 4 >> 2] | 0;
    i2 = (HEAP32[i138 >> 2] | 0) + 1 | 0;
    if (i4 >>> 0 >= i2 >>> 0) {
     i12 = 163;
     break L12;
    }
    i1 = HEAP32[i139 >> 2] | 0;
    i3 = HEAP32[i140 >> 2] | 0;
    if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i1 + (i4 * 24 | 0) + 12 >> 2] | 0) == (i4 | 0)) i1 = i1 + (i4 * 24 | 0) | 0; else i12 = 147; else i12 = 147;
    if ((i12 | 0) == 147) {
     i2 = i1 + (i3 * 24 | 0) | 0;
     L251 : do if ((i3 | 0) > 0) do {
      if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 | 0)) break L251;
      i1 = i1 + 24 | 0;
     } while (i1 >>> 0 < i2 >>> 0); while (0);
     if ((i1 | 0) == (i2 | 0)) {
      i12 = 163;
      break L12;
     }
    }
    if (!(HEAP8[i1 + 16 >> 0] | 0)) {
     i12 = 163;
     break L12;
    }
    i2 = HEAP32[i111 >> 2] | 0;
    if ((i2 | 0) >= (HEAP32[i112 >> 2] | 0)) {
     i12 = 153;
     break L12;
    }
    if ((HEAP32[i9 >> 2] | 0) > 0) {
     i4 = HEAP32[i113 >> 2] | 0;
     HEAP32[i4 + (i2 << 4) >> 2] = HEAP32[i114 >> 2];
     HEAP32[i4 + (i2 << 4) + 4 >> 2] = (HEAP32[i66 >> 2] | 0) + 1;
     HEAP32[i4 + (i2 << 4) + 8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i4 + (i2 << 4) + 12 >> 2] = i1;
     HEAP32[i111 >> 2] = i2 + 1;
     i4 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     i1 = i4 + -1 | 0;
     do if (i1 >>> 0 > 2) HEAP32[i79 >> 2] = 132; else {
      i3 = HEAP32[i17 + 444 + (i1 << 3) >> 2] | 0;
      if (!i3) {
       HEAP32[i79 >> 2] = 138;
       break;
      }
      i1 = HEAP32[i17 + 444 + (i1 << 3) + 4 >> 2] | 0;
      if ((i1 | 0) < (i2 | 0)) {
       HEAP32[i79 >> 2] = 131;
       break;
      } else {
       HEAP32[i67 >> 2] = i3;
       HEAP32[i71 >> 2] = i1;
       HEAP32[i66 >> 2] = i2;
       HEAP32[i114 >> 2] = i4;
       break;
      }
     } while (0);
     HEAP8[i78 >> 0] = 0;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case 43:
   {
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = (HEAP32[i138 >> 2] | 0) + 1 | 0;
    if (i2 >>> 0 <= i4 >>> 0) {
     i12 = 182;
     break L12;
    }
    i1 = HEAP32[i139 >> 2] | 0;
    i3 = HEAP32[i140 >> 2] | 0;
    if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i1 + (i4 * 24 | 0) + 12 >> 2] | 0) == (i4 | 0)) i1 = i1 + (i4 * 24 | 0) | 0; else i12 = 167; else i12 = 167;
    if ((i12 | 0) == 167) {
     i2 = i1 + (i3 * 24 | 0) | 0;
     L276 : do if ((i3 | 0) > 0) do {
      if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 | 0)) break L276;
      i1 = i1 + 24 | 0;
     } while (i1 >>> 0 < i2 >>> 0); while (0);
     if ((i1 | 0) == (i2 | 0)) {
      i12 = 182;
      break L12;
     }
    }
    if (!(HEAP8[i1 + 16 >> 0] | 0)) {
     i12 = 182;
     break L12;
    }
    i2 = HEAP32[i111 >> 2] | 0;
    if ((i2 | 0) >= (HEAP32[i112 >> 2] | 0)) {
     i12 = 173;
     break L12;
    }
    i4 = HEAP32[i113 >> 2] | 0;
    HEAP32[i4 + (i2 << 4) >> 2] = HEAP32[i114 >> 2];
    HEAP32[i4 + (i2 << 4) + 4 >> 2] = (HEAP32[i66 >> 2] | 0) + 1;
    HEAP32[i4 + (i2 << 4) + 8 >> 2] = 1;
    HEAP32[i4 + (i2 << 4) + 12 >> 2] = i1;
    HEAP32[i111 >> 2] = i2 + 1;
    i4 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i1 = i4 + -1 | 0;
    do if (i1 >>> 0 > 2) HEAP32[i79 >> 2] = 132; else {
     i3 = HEAP32[i17 + 444 + (i1 << 3) >> 2] | 0;
     if (!i3) {
      HEAP32[i79 >> 2] = 138;
      break;
     }
     i1 = HEAP32[i17 + 444 + (i1 << 3) + 4 >> 2] | 0;
     if ((i1 | 0) < (i2 | 0)) {
      HEAP32[i79 >> 2] = 131;
      break;
     } else {
      HEAP32[i67 >> 2] = i3;
      HEAP32[i71 >> 2] = i1;
      HEAP32[i66 >> 2] = i2;
      HEAP32[i114 >> 2] = i4;
      break;
     }
    } while (0);
    HEAP8[i78 >> 0] = 0;
    i12 = 725;
    break;
   }
  case 44:
   {
    i4 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i139 >> 2] | 0;
    i2 = HEAP32[i140 >> 2] | 0;
    i3 = i1 + (i2 * 24 | 0) | 0;
    L295 : do if ((i2 | 0) > 0) while (1) {
     if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 | 0)) {
      i6 = i1;
      break L295;
     }
     i1 = i1 + 24 | 0;
     if (i1 >>> 0 >= i3 >>> 0) {
      i6 = i1;
      break;
     }
    } else i6 = i1; while (0);
    if ((i6 | 0) == (i3 | 0)) {
     if (i2 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) {
      i12 = 188;
      break L12;
     }
     HEAP32[i140 >> 2] = i2 + 1;
    }
    if (i4 >>> 0 > 65535) {
     i12 = 191;
     break L12;
    }
    HEAP32[i6 >> 2] = HEAP32[i114 >> 2];
    i2 = i4 & 65535;
    HEAP32[i6 + 12 >> 2] = i2;
    i1 = HEAP32[i66 >> 2] | 0;
    HEAP32[i6 + 4 >> 2] = i1 + 1;
    HEAP8[i6 + 16 >> 0] = 1;
    HEAP8[i6 + 17 >> 0] = 0;
    HEAP32[i6 + 20 >> 2] = 0;
    if ((HEAP32[i138 >> 2] | 0) >>> 0 < i4 >>> 0) HEAP32[i138 >> 2] = i2;
    i5 = HEAP32[i71 >> 2] | 0;
    i2 = i8;
    L308 : while (1) {
     i1 = i2 + i1 | 0;
     HEAP32[i66 >> 2] = i1;
     if ((i1 | 0) >= (i5 | 0)) {
      i12 = 200;
      break L12;
     }
     i4 = HEAP8[i11 + i1 >> 0] | 0;
     HEAP8[i68 >> 0] = i4;
     i143 = i4 & 255;
     i2 = HEAP8[gb + 1007030 + i143 >> 0] | 0;
     HEAP32[i70 >> 2] = i2;
     if ((i143 | 1 | 0) == 65) {
      i3 = i1 + 1 | 0;
      if ((i3 | 0) >= (i5 | 0)) {
       i12 = 200;
       break L12;
      }
      i2 = 2 - (Math_imul(HEAPU8[i11 + i3 >> 0] | 0, i2) | 0) | 0;
      HEAP32[i70 >> 2] = i2;
     }
     if ((i2 + i1 | 0) > (i5 | 0)) {
      i12 = 200;
      break L12;
     }
     switch (i4 << 24 >> 24) {
     case 44:
     case -119:
      {
       i12 = 202;
       break L12;
      }
     case 45:
      break L308;
     default:
      {}
     }
    }
    HEAP32[i6 + 8 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 45:
   {
    i1 = HEAP32[i111 >> 2] | 0;
    if ((i1 | 0) < 1) {
     i12 = 205;
     break L12;
    }
    i2 = i1 + -1 | 0;
    HEAP32[i111 >> 2] = i2;
    i3 = HEAP32[i113 >> 2] | 0;
    i142 = i3 + (i2 << 4) + 8 | 0;
    i143 = HEAP32[i142 >> 2] | 0;
    HEAP32[i142 >> 2] = i143 + -1;
    HEAP8[i78 >> 0] = 0;
    if ((i143 | 0) > 1) {
     HEAP32[i111 >> 2] = i1;
     HEAP32[i66 >> 2] = HEAP32[(HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0) + 4 >> 2];
     i12 = 725;
     break L30;
    }
    i4 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
    i2 = HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0;
    i1 = i4 + -1 | 0;
    if (i1 >>> 0 > 2) {
     i12 = 209;
     break L12;
    }
    i3 = HEAP32[i17 + 444 + (i1 << 3) >> 2] | 0;
    if (!i3) {
     i12 = 211;
     break L12;
    }
    i1 = HEAP32[i17 + 444 + (i1 << 3) + 4 >> 2] | 0;
    if ((i1 | 0) < (i2 | 0)) {
     i12 = 213;
     break L12;
    }
    HEAP32[i67 >> 2] = i3;
    HEAP32[i71 >> 2] = i1;
    HEAP32[i66 >> 2] = i2;
    HEAP32[i114 >> 2] = i4;
    i12 = 725;
    break;
   }
  case 47:
  case 46:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1 & 65535;
    i1 = i1 & 65535;
    if (i1 >>> 0 >= (HEAPU16[i87 >> 1] | 0) >>> 0) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 217;
     break L12;
    }
    if (!(i10 & 1)) i1 = 0; else {
     i143 = HEAP32[i98 >> 2] | 0;
     i1 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, HEAP32[i143 + (i1 << 3) >> 2] | 0, HEAP32[i143 + (i1 << 3) + 4 >> 2] | 0) | 0;
     i1 = (mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, i1 | 0, HEAP32[i20 >> 2] | 0) | 0) - i1 | 0;
    }
    mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i130 | 0, i2 | 0, i1 | 0);
    HEAP16[i129 >> 1] = i2;
    HEAP16[i102 >> 1] = i2;
    i12 = 725;
    break;
   }
  case 49:
  case 48:
   {
    L333 : do if (HEAP16[i21 >> 1] | 0) {
     if (!(i10 & 1)) {
      i1 = (HEAP32[i22 >> 2] | 0) + 4 | 0;
      HEAP32[i18 >> 2] = i1;
      i2 = (HEAP32[i23 >> 2] | 0) + 4 | 0;
      HEAP32[i24 >> 2] = i2;
      HEAP32[i26 >> 2] = (HEAP32[i25 >> 2] | 0) + 4;
      i10 = 16;
     } else {
      i1 = HEAP32[i22 >> 2] | 0;
      HEAP32[i18 >> 2] = i1;
      i2 = HEAP32[i23 >> 2] | 0;
      HEAP32[i24 >> 2] = i2;
      HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
      i10 = 8;
     }
     i5 = HEAP16[i27 >> 1] | 0;
     HEAP32[i28 >> 2] = i5 & 65535;
     i3 = 0;
     i4 = 0;
     while (1) {
      i143 = (HEAPU16[(HEAP32[i29 >> 2] | 0) + (i3 << 16 >> 16 << 1) >> 1] | 0) - (HEAPU16[i30 >> 1] | 0) | 0;
      i9 = i5 & 65535;
      i9 = i143 >>> 0 < i9 >>> 0 ? i143 : i9 + -1 | 0;
      L341 : do if (i4 >>> 0 <= i9 >>> 0) {
       i6 = HEAP32[i31 >> 2] | 0;
       i5 = i4;
       while (1) {
        if ((HEAP8[i6 + i5 >> 0] & i10) << 24 >> 24) {
         i6 = i5;
         break;
        }
        i5 = i5 + 1 | 0;
        if (i5 >>> 0 > i9 >>> 0) {
         i4 = i5;
         break L341;
        }
       }
       L346 : while (1) {
        i7 = i6;
        while (1) {
         i8 = i7 + 1 | 0;
         if (i8 >>> 0 > i9 >>> 0) break L346;
         if (!((HEAP8[(HEAP32[i31 >> 2] | 0) + i8 >> 0] & i10) << 24 >> 24)) i7 = i8; else break;
        }
        __iup_worker_interpolate(i18, i6 + 1 | 0, i7, i6, i8);
        i6 = i8;
       }
       if ((i6 | 0) != (i5 | 0)) {
        __iup_worker_interpolate(i18, i6 + 1 & 65535, i9, i6, i5);
        if (!i5) {
         i4 = i8;
         break;
        }
        __iup_worker_interpolate(i18, i4, i5 + -1 | 0, i6, i5);
        i4 = i8;
        break;
       }
       i6 = (HEAP32[i2 + (i5 << 3) >> 2] | 0) - (HEAP32[i1 + (i5 << 3) >> 2] | 0) | 0;
       if (!i6) i4 = i8; else {
        if (i4 >>> 0 < i5 >>> 0) do {
         i143 = i2 + (i4 << 3) | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i6;
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) != (i5 | 0));
        i4 = i5 + 1 | 0;
        if (i4 >>> 0 > i9 >>> 0) i4 = i8; else {
         do {
          i143 = i2 + (i4 << 3) | 0;
          HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i6;
          i4 = i4 + 1 | 0;
         } while (i4 >>> 0 <= i9 >>> 0);
         i4 = i8;
        }
       }
      } while (0);
      i3 = i3 + 1 << 16 >> 16;
      if (i3 << 16 >> 16 >= (HEAP16[i21 >> 1] | 0)) break L333;
      i5 = HEAP16[i27 >> 1] | 0;
     }
    } while (0);
    i12 = 725;
    break;
   }
  case 51:
  case 50:
   {
    L368 : do if ((HEAP32[i72 >> 2] | 0) < (HEAP32[i135 >> 2] | 0)) if (!(HEAP8[i74 >> 0] | 0)) i12 = 259; else {
     HEAP32[i79 >> 2] = 134;
     i12 = 259;
    } else if (!((_Compute_Point_Displacement(i17, i69, i80, i18, i64) | 0) << 24 >> 24)) if ((HEAP32[i135 >> 2] | 0) > 0) {
     i1 = HEAP32[i80 >> 2] | 0;
     i2 = HEAP32[i69 >> 2] | 0;
     while (1) {
      i3 = (HEAP32[i73 >> 2] | 0) + -1 | 0;
      HEAP32[i73 >> 2] = i3;
      i3 = HEAP32[(HEAP32[i75 >> 2] | 0) + (i3 << 2) >> 2] & 65535;
      if (i3 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) {
       if (HEAP16[i92 >> 1] | 0) {
        i143 = (HEAP32[i121 >> 2] | 0) + (i3 << 3) | 0;
        HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i2;
        i143 = (HEAP32[i128 >> 2] | 0) + i3 | 0;
        HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 8;
       }
       if (HEAP16[i94 >> 1] | 0) {
        i143 = (HEAP32[i121 >> 2] | 0) + (i3 << 3) + 4 | 0;
        HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i1;
        i143 = (HEAP32[i128 >> 2] | 0) + i3 | 0;
        HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 16;
       }
      } else if (HEAP8[i74 >> 0] | 0) break;
      i143 = HEAP32[i135 >> 2] | 0;
      HEAP32[i135 >> 2] = i143 + -1;
      if ((i143 | 0) <= 1) {
       i12 = 259;
       break L368;
      }
     }
     HEAP32[i79 >> 2] = 134;
    } else i12 = 259; while (0);
    if ((i12 | 0) == 259) {
     HEAP32[i135 >> 2] = 1;
     HEAP32[i76 >> 2] = HEAP32[i73 >> 2];
    }
    i12 = 725;
    break;
   }
  case 53:
  case 52:
   {
    if (!(HEAP16[i134 >> 1] | 0)) i2 = 1; else i2 = HEAP16[i35 >> 1] | 0;
    i1 = HEAP32[i9 >> 2] << 16 >> 16;
    if (i1 >>> 0 < i2 << 16 >> 16 >>> 0) {
     if (!((_Compute_Point_Displacement(i17, i69, i80, i18, i64) | 0) << 24 >> 24)) {
      if (!i1) i2 = 0; else i2 = (HEAPU16[(HEAP32[i33 >> 2] | 0) + (i1 + -1 << 1) >> 1] | 0) + 1 - (HEAPU16[i34 >> 1] | 0) & 65535;
      if (!(HEAP16[i134 >> 1] | 0)) i3 = HEAP16[i120 >> 1] | 0; else i3 = (HEAPU16[(HEAP32[i33 >> 2] | 0) + (i1 << 1) >> 1] | 0) + 1 - (HEAPU16[i34 >> 1] | 0) & 65535;
      if ((i2 & 65535) < (i3 & 65535)) {
       i4 = HEAP32[i32 >> 2] | 0;
       i5 = HEAP32[i80 >> 2] | 0;
       i6 = HEAP32[i69 >> 2] | 0;
       i7 = HEAPU16[i64 >> 1] | 0;
       i2 = i2 & 65535;
       do {
        i1 = HEAP32[i121 >> 2] | 0;
        if (!((i7 | 0) == (i2 | 0) & (i4 | 0) == (i1 | 0))) {
         if (HEAP16[i92 >> 1] | 0) {
          i143 = i1 + (i2 << 3) | 0;
          HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i6;
          i143 = (HEAP32[i128 >> 2] | 0) + i2 | 0;
          HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 8;
         }
         if (HEAP16[i94 >> 1] | 0) {
          i143 = (HEAP32[i121 >> 2] | 0) + (i2 << 3) + 4 | 0;
          HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i5;
          i143 = (HEAP32[i128 >> 2] | 0) + i2 | 0;
          HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 16;
         }
        }
        i2 = i2 + 1 | 0;
       } while ((i2 & 65535) << 16 >> 16 != i3 << 16 >> 16);
      }
     }
    } else if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134;
    i12 = 725;
    break;
   }
  case 55:
  case 54:
   {
    L416 : do if ((HEAP32[i9 >> 2] | 0) >>> 0 > 1) {
     if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134;
    } else if (!((_Compute_Point_Displacement(i17, i69, i80, i18, i64) | 0) << 24 >> 24)) {
     switch (HEAP16[i134 >> 1] | 0) {
     case 0:
      {
       i7 = HEAP16[i120 >> 1] | 0;
       break;
      }
     case 1:
      {
       i1 = HEAP16[i35 >> 1] | 0;
       if (i1 << 16 >> 16 <= 0) break L416;
       i7 = (HEAPU16[(HEAP32[i33 >> 2] | 0) + ((i1 << 16 >> 16) + -1 << 1) >> 1] | 0) + 1 & 65535;
       break;
      }
     default:
      break L416;
     }
     if (i7 << 16 >> 16) {
      i4 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i121 >> 2] | 0;
      i5 = HEAP32[i80 >> 2] | 0;
      i6 = HEAP32[i69 >> 2] | 0;
      if ((i4 | 0) != (i2 | 0)) {
       i1 = (HEAP16[i94 >> 1] | 0) == 0;
       if (!(HEAP16[i92 >> 1] | 0)) {
        if (i1) break; else i1 = 0;
        while (1) {
         i143 = i2 + (i1 << 3) + 4 | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i5;
         i1 = i1 + 1 | 0;
         if ((i1 & 65535) << 16 >> 16 == i7 << 16 >> 16) break L416;
        }
       }
       if (i1) {
        i1 = 0;
        while (1) {
         i143 = i2 + (i1 << 3) | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i6;
         i1 = i1 + 1 | 0;
         if ((i1 & 65535) << 16 >> 16 == i7 << 16 >> 16) break L416;
        }
       } else {
        i1 = 0;
        while (1) {
         i143 = i2 + (i1 << 3) | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i6;
         i143 = i2 + (i1 << 3) + 4 | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i5;
         i1 = i1 + 1 | 0;
         if ((i1 & 65535) << 16 >> 16 == i7 << 16 >> 16) break L416;
        }
       }
      }
      i2 = HEAPU16[i64 >> 1] | 0;
      i3 = 0;
      do {
       if ((i2 | 0) != (i3 | 0)) {
        i1 = i4 + (i3 << 3) | 0;
        if (HEAP16[i92 >> 1] | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i6;
        i1 = i4 + (i3 << 3) + 4 | 0;
        if (HEAP16[i94 >> 1] | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i5;
       }
       i3 = i3 + 1 | 0;
      } while ((i3 & 65535) << 16 >> 16 != i7 << 16 >> 16);
     }
    } while (0);
    i12 = 725;
    break;
   }
  case 56:
   {
    i2 = HEAP32[i135 >> 2] | 0;
    L451 : do if ((HEAP32[i72 >> 2] | 0) > (i2 | 0)) {
     i143 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP16[i92 >> 1] | 0;
     i12 = i5 << 16 >> 16;
     i4 = (i143 | 0) < 0 ? 0 - i143 | 0 : i143;
     i5 = i5 << 16 >> 16 < 0 ? 0 - i12 | 0 : i12;
     i14 = i4 >>> 16;
     i4 = i4 & 65535;
     i142 = Math_imul(i14, i5) | 0;
     i13 = i142 << 16 | 8192;
     i5 = i13 + (Math_imul(i4, i5) | 0) | 0;
     i5 = (i5 >>> 0 < i13 >>> 0 & 1) + (i142 >>> 16) << 18 | i5 >>> 14;
     i5 = (i12 ^ i143 | 0) > -1 ? i5 : 0 - i5 | 0;
     i12 = HEAP16[i94 >> 1] | 0;
     i142 = i12 << 16 >> 16;
     i12 = i12 << 16 >> 16 < 0 ? 0 - i142 | 0 : i142;
     i14 = Math_imul(i12, i14) | 0;
     i13 = i14 << 16 | 8192;
     i4 = i13 + (Math_imul(i12, i4) | 0) | 0;
     i4 = (i4 >>> 0 < i13 >>> 0 & 1) + (i14 >>> 16) << 18 | i4 >>> 14;
     i4 = (i142 ^ i143 | 0) > -1 ? i4 : 0 - i4 | 0;
     if ((i2 | 0) > 0) {
      i2 = i3;
      while (1) {
       i1 = i1 + -1 | 0;
       HEAP32[i73 >> 2] = i1;
       i1 = HEAP32[i2 + (i1 << 2) >> 2] & 65535;
       if (i1 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) {
        if (HEAP16[i92 >> 1] | 0) {
         i143 = (HEAP32[i121 >> 2] | 0) + (i1 << 3) | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i5;
         i143 = (HEAP32[i128 >> 2] | 0) + i1 | 0;
         HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 8;
        }
        if (HEAP16[i94 >> 1] | 0) {
         i143 = (HEAP32[i121 >> 2] | 0) + (i1 << 3) + 4 | 0;
         HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + i4;
         i143 = (HEAP32[i128 >> 2] | 0) + i1 | 0;
         HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 16;
        }
       } else if (HEAP8[i74 >> 0] | 0) {
        i12 = 311;
        break L12;
       }
       i143 = HEAP32[i135 >> 2] | 0;
       HEAP32[i135 >> 2] = i143 + -1;
       i1 = HEAP32[i73 >> 2] | 0;
       if ((i143 | 0) <= 1) break L451;
       i2 = HEAP32[i75 >> 2] | 0;
      }
     }
    } else if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134; while (0);
    HEAP32[i135 >> 2] = 1;
    HEAP32[i76 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 57:
   {
    i3 = HEAP32[i135 >> 2] | 0;
    do if ((HEAP32[i72 >> 2] | 0) < (i3 | 0)) {
     if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134;
    } else {
     i143 = HEAP32[i101 >> 2] | 0;
     if (i143 >>> 0 < 65536 | (i143 & 65535) << 16 >> 16 == 0) i10 = 1; else i10 = (HEAP16[i134 >> 1] | 0) == 0;
     i143 = HEAP16[i102 >> 1] | 0;
     i5 = i143 & 65535;
     if ((i143 & 65535) >= (HEAPU16[i87 >> 1] | 0)) {
      if (!(HEAP8[i74 >> 0] | 0)) break;
      HEAP32[i79 >> 2] = 134;
      break;
     }
     i4 = HEAP32[(i10 ? i91 : i105) >> 2] | 0;
     i9 = i4 + (i5 << 3) | 0;
     i6 = HEAP32[i98 >> 2] | 0;
     i11 = i6 + (i5 << 3) | 0;
     i143 = HEAP16[i103 >> 1] | 0;
     i2 = i143 & 65535;
     if ((i143 & 65535) < (HEAPU16[i84 >> 1] | 0)) {
      do if (i10) {
       i1 = HEAP32[i93 >> 2] | 0;
       i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i1 + (i2 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, (HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0) | 0) | 0;
      } else {
       i1 = HEAP32[i106 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i107 >> 2] | 0)) {
        i1 = HEAP32[i104 >> 2] | 0;
        i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i1 + (i2 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, (HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0) | 0) | 0;
        break;
       } else {
        i143 = _UNITY_FT_MulFix((HEAP32[(HEAP32[i104 >> 2] | 0) + (i2 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, i1) | 0;
        i1 = _UNITY_FT_MulFix((HEAP32[(HEAP32[i104 >> 2] | 0) + (HEAPU16[i103 >> 1] << 3) + 4 >> 2] | 0) - (HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0) | 0, HEAP32[i107 >> 2] | 0) | 0;
        i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i143 | 0, i1 | 0) | 0;
        break;
       }
      } while (0);
      i8 = HEAPU16[i103 >> 1] | 0;
      i3 = HEAP32[i95 >> 2] | 0;
      i8 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i3 + (i8 << 3) >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0, (HEAP32[i3 + (i8 << 3) + 4 >> 2] | 0) - (HEAP32[i6 + (i5 << 3) + 4 >> 2] | 0) | 0) | 0;
      i3 = HEAP32[i135 >> 2] | 0;
     } else {
      i8 = 0;
      i1 = 0;
     }
     if ((i3 | 0) > 0) {
      i7 = i4 + (i5 << 3) + 4 | 0;
      i5 = i6 + (i5 << 3) + 4 | 0;
      i6 = (i1 | 0) == 0;
      do {
       i4 = (HEAP32[i73 >> 2] | 0) + -1 | 0;
       HEAP32[i73 >> 2] = i4;
       i4 = HEAP32[(HEAP32[i75 >> 2] | 0) + (i4 << 2) >> 2] | 0;
       if (i4 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) {
        do if (i10) {
         i2 = HEAP32[i37 >> 2] | 0;
         i2 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i2 + (i4 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, (HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0) | 0;
        } else {
         i2 = HEAP32[i106 >> 2] | 0;
         if ((i2 | 0) == (HEAP32[i107 >> 2] | 0)) {
          i2 = HEAP32[i38 >> 2] | 0;
          i2 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i2 + (i4 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, (HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0) | 0;
          break;
         } else {
          i143 = _UNITY_FT_MulFix((HEAP32[(HEAP32[i38 >> 2] | 0) + (i4 << 3) >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0, i2) | 0;
          i2 = _UNITY_FT_MulFix((HEAP32[(HEAP32[i38 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0, HEAP32[i107 >> 2] | 0) | 0;
          i2 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i143 | 0, i2 | 0) | 0;
          break;
         }
        } while (0);
        i3 = HEAP32[i121 >> 2] | 0;
        i3 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i3 + (i4 << 3) >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0, (HEAP32[i3 + (i4 << 3) + 4 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) | 0;
        if (!(i6 | (i2 | 0) == 0)) i2 = _UNITY_FT_MulDiv(i2, i8, i1) | 0;
        mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i133 | 0, i4 & 65535 | 0, i2 - i3 | 0);
        i2 = HEAP32[i135 >> 2] | 0;
       } else if (!(HEAP8[i74 >> 0] | 0)) i2 = i3; else {
        i12 = 346;
        break L12;
       }
       i3 = i2 + -1 | 0;
       HEAP32[i135 >> 2] = i3;
      } while ((i2 | 0) > 1);
     }
    } while (0);
    HEAP32[i135 >> 2] = 1;
    HEAP32[i76 >> 2] = HEAP32[i73 >> 2];
    i12 = 725;
    break;
   }
  case 59:
  case 58:
   {
    i4 = HEAP32[i9 >> 2] | 0;
    i3 = i4 & 65535;
    i4 = i4 & 65535;
    if (i4 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
     i1 = HEAP16[i129 >> 1] | 0;
     i2 = i1 & 65535;
     if ((i1 & 65535) < (HEAPU16[i87 >> 1] | 0)) {
      if (!(HEAP16[i90 >> 1] | 0)) {
       i143 = (HEAP32[i91 >> 2] | 0) + (i2 << 3) | 0;
       i142 = HEAP32[i143 + 4 >> 2] | 0;
       i2 = (HEAP32[i93 >> 2] | 0) + (i4 << 3) | 0;
       HEAP32[i2 >> 2] = HEAP32[i143 >> 2];
       HEAP32[i2 + 4 >> 2] = i142;
       i2 = i9 + 4 | 0;
       mftCall_viiii(HEAP32[i40 >> 2] | 0, i17 | 0, i83 | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
       i142 = (HEAP32[i93 >> 2] | 0) + (i4 << 3) | 0;
       i143 = HEAP32[i142 + 4 >> 2] | 0;
       i1 = (HEAP32[i95 >> 2] | 0) + (i4 << 3) | 0;
       HEAP32[i1 >> 2] = HEAP32[i142 >> 2];
       HEAP32[i1 + 4 >> 2] = i143;
       i1 = HEAP16[i129 >> 1] | 0;
      } else i2 = i9 + 4 | 0;
      i14 = HEAP32[i95 >> 2] | 0;
      i142 = HEAP32[i98 >> 2] | 0;
      i143 = i1 & 65535;
      i143 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i14 + (i4 << 3) >> 2] | 0) - (HEAP32[i142 + (i143 << 3) >> 2] | 0) | 0, (HEAP32[i14 + (i4 << 3) + 4 >> 2] | 0) - (HEAP32[i142 + (i143 << 3) + 4 >> 2] | 0) | 0) | 0;
      mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i83 | 0, i3 | 0, (HEAP32[i2 >> 2] | 0) - i143 | 0);
      HEAP16[i102 >> 1] = HEAP16[i129 >> 1] | 0;
      HEAP16[i103 >> 1] = i3;
      if (!(HEAP8[i68 >> 0] & 1)) {
       i12 = 725;
       break L30;
      }
      HEAP16[i129 >> 1] = i3;
      i12 = 725;
      break L30;
     }
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 352;
     break L12;
    }
    break;
   }
  case 60:
   {
    i2 = HEAP32[i135 >> 2] | 0;
    L518 : do if ((HEAP32[i72 >> 2] | 0) < (i2 | 0)) i12 = 360; else if ((HEAPU16[i129 >> 1] | 0) < (HEAPU16[i87 >> 1] | 0)) {
     if ((i2 | 0) > 0) {
      i4 = i2;
      while (1) {
       i1 = i1 + -1 | 0;
       HEAP32[i73 >> 2] = i1;
       i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
       i2 = i1 & 65535;
       if (i2 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
        i14 = HEAP32[i95 >> 2] | 0;
        i142 = HEAP32[i98 >> 2] | 0;
        i143 = HEAPU16[i129 >> 1] | 0;
        i2 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i14 + (i2 << 3) >> 2] | 0) - (HEAP32[i142 + (i143 << 3) >> 2] | 0) | 0, (HEAP32[i14 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i142 + (i143 << 3) + 4 >> 2] | 0) | 0) | 0;
        mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i83 | 0, i1 & 65535 | 0, 0 - i2 | 0);
        i2 = HEAP32[i135 >> 2] | 0;
       } else if (!(HEAP8[i74 >> 0] | 0)) i2 = i4; else {
        i12 = 365;
        break L12;
       }
       i4 = i2 + -1 | 0;
       HEAP32[i135 >> 2] = i4;
       i1 = HEAP32[i73 >> 2] | 0;
       if ((i2 | 0) <= 1) break L518;
       i3 = HEAP32[i75 >> 2] | 0;
      }
     }
    } else i12 = 360; while (0);
    if ((i12 | 0) == 360) if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134;
    HEAP32[i135 >> 2] = 1;
    HEAP32[i76 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 61:
   {
    HEAP32[i63 >> 2] = 2;
    HEAP32[i16 >> 2] = fb + 462;
    i12 = 725;
    break;
   }
  case 63:
  case 62:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i3 = HEAP32[i82 >> 2] | 0;
    i4 = i2 & 65535;
    i2 = i2 & 65535;
    if (i2 >>> 0 < (HEAPU16[i87 >> 1] | 0) >>> 0) if ((HEAP32[i85 >> 2] | 0) >>> 0 > i1 >>> 0) {
     i1 = mftCall_iii(HEAP32[i50 >> 2] | 0, i17 | 0, i1 | 0) | 0;
     if (!(HEAP16[i101 >> 1] | 0)) {
      i10 = HEAP16[i92 >> 1] | 0;
      i143 = i10 << 16 >> 16;
      i142 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
      i10 = i10 << 16 >> 16 < 0 ? 0 - i143 | 0 : i143;
      i13 = i142 >>> 16;
      i142 = i142 & 65535;
      i14 = Math_imul(i10, i13) | 0;
      i11 = i14 << 16 | 8192;
      i10 = i11 + (Math_imul(i10, i142) | 0) | 0;
      i10 = (i10 >>> 0 < i11 >>> 0 & 1) + (i14 >>> 16) << 18 | i10 >>> 14;
      i14 = HEAP32[i91 >> 2] | 0;
      HEAP32[i14 + (i2 << 3) >> 2] = (i143 ^ i1 | 0) > -1 ? i10 : 0 - i10 | 0;
      i10 = HEAP16[i94 >> 1] | 0;
      i143 = i10 << 16 >> 16;
      i10 = i10 << 16 >> 16 < 0 ? 0 - i143 | 0 : i143;
      i13 = Math_imul(i10, i13) | 0;
      i11 = i13 << 16 | 8192;
      i142 = i11 + (Math_imul(i10, i142) | 0) | 0;
      i142 = (i142 >>> 0 < i11 >>> 0 & 1) + (i13 >>> 16) << 18 | i142 >>> 14;
      HEAP32[i14 + (i2 << 3) + 4 >> 2] = (i143 ^ i1 | 0) > -1 ? i142 : 0 - i142 | 0;
      i14 = i14 + (i2 << 3) | 0;
      i142 = HEAP32[i14 + 4 >> 2] | 0;
      i143 = (HEAP32[i98 >> 2] | 0) + (i2 << 3) | 0;
      HEAP32[i143 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i143 + 4 >> 2] = i142;
     }
     i143 = HEAP32[i98 >> 2] | 0;
     i2 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, HEAP32[i143 + (i2 << 3) >> 2] | 0, HEAP32[i143 + (i2 << 3) + 4 >> 2] | 0) | 0;
     if (HEAP8[i68 >> 0] & 1) {
      i143 = i1 - i2 | 0;
      i1 = mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, ((((i143 | 0) < 0 ? 0 - i143 | 0 : i143) | 0) > (i3 | 0) ? i2 : i1) | 0, HEAP32[i20 >> 2] | 0) | 0;
     }
     mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i130 | 0, i4 | 0, i1 - i2 | 0);
    } else i12 = 373; else i12 = 373;
    if ((i12 | 0) == 373) if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 134;
    HEAP16[i129 >> 1] = i4;
    HEAP16[i102 >> 1] = i4;
    i12 = 725;
    break;
   }
  case 64:
   {
    i1 = HEAP32[i66 >> 2] | 0;
    i2 = HEAP8[i11 + (i1 + 1) >> 0] | 0;
    i3 = i2 & 255;
    if (i3 >>> 0 >= (i6 + 1 - (HEAP32[i72 >> 2] | 0) | 0) >>> 0) {
     i12 = 384;
     break L12;
    }
    if (i2 << 24 >> 24) {
     HEAP32[i9 >> 2] = HEAPU8[i11 + (i1 + 2) >> 0];
     if (i2 << 24 >> 24 != 1) {
      i1 = 2;
      i2 = 2;
      do {
       HEAP32[i9 + (i1 + -1 << 2) >> 2] = HEAPU8[i11 + ((HEAP32[i66 >> 2] | 0) + 1 + i1) >> 0];
       i2 = i2 + 1 << 16 >> 16;
       i1 = i2 & 65535;
      } while (i1 >>> 0 <= i3 >>> 0);
     }
    }
    HEAP32[i76 >> 2] = (HEAP32[i76 >> 2] | 0) + i3;
    i12 = 725;
    break;
   }
  case 65:
   {
    i1 = HEAP32[i66 >> 2] | 0;
    i3 = HEAP8[i11 + (i1 + 1) >> 0] | 0;
    i4 = i3 & 255;
    if (i4 >>> 0 >= (i6 + 1 - (HEAP32[i72 >> 2] | 0) | 0) >>> 0) {
     i12 = 388;
     break L12;
    }
    i2 = i1 + 2 | 0;
    HEAP32[i66 >> 2] = i2;
    if (!(i3 << 24 >> 24)) i1 = i5; else {
     i1 = 0;
     i3 = i2;
     i2 = 0;
     while (1) {
      HEAP32[i66 >> 2] = i3 + 2;
      HEAP32[i9 + (i2 << 2) >> 2] = (HEAPU8[i11 + i3 >> 0] << 8 | HEAPU8[i11 + (i3 + 1) >> 0]) << 16 >> 16;
      i1 = i1 + 1 << 16 >> 16;
      i2 = i1 & 65535;
      if (i2 >>> 0 >= i4 >>> 0) break;
      i3 = HEAP32[i66 >> 2] | 0;
     }
     i1 = HEAP32[i76 >> 2] | 0;
    }
    HEAP8[i78 >> 0] = 0;
    HEAP32[i76 >> 2] = i1 + i4;
    i12 = 725;
    break;
   }
  case 66:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 < (HEAPU16[i41 >> 1] | 0) >>> 0) {
     HEAP32[(HEAP32[i42 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i9 + 4 >> 2];
     i12 = 725;
     break L30;
    } else if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 396;
     break L12;
    }
   }
  case 67:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 < (HEAPU16[i41 >> 1] | 0) >>> 0) i1 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i1 << 2) >> 2] | 0; else if (!(HEAP8[i74 >> 0] | 0)) i1 = 0; else {
     i12 = 400;
     break L12;
    }
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 68:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 < (HEAP32[i85 >> 2] | 0) >>> 0) {
     mftCall_viii(HEAP32[i61 >> 2] | 0, i17 | 0, i1 | 0, HEAP32[i9 + 4 >> 2] | 0);
     i12 = 725;
     break L30;
    } else if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 405;
     break L12;
    }
   }
  case 69:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 < (HEAP32[i85 >> 2] | 0) >>> 0) i1 = mftCall_iii(HEAP32[i50 >> 2] | 0, i17 | 0, i1 | 0) | 0; else if (!(HEAP8[i74 >> 0] | 0)) i1 = 0; else {
     i12 = 409;
     break L12;
    }
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 71:
  case 70:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    do if (i1 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) if (!(i10 & 1)) {
     i143 = HEAP32[i121 >> 2] | 0;
     i1 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, HEAP32[i143 + (i1 << 3) >> 2] | 0, HEAP32[i143 + (i1 << 3) + 4 >> 2] | 0) | 0;
     break;
    } else {
     i143 = HEAP32[i37 >> 2] | 0;
     i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, HEAP32[i143 + (i1 << 3) >> 2] | 0, HEAP32[i143 + (i1 << 3) + 4 >> 2] | 0) | 0;
     break;
    } else if (!(HEAP8[i74 >> 0] | 0)) i1 = 0; else {
     HEAP32[i79 >> 2] = 134;
     i1 = 0;
    } while (0);
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 72:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1 & 65535;
    if (i2 >>> 0 >= (HEAPU16[i120 >> 1] | 0) >>> 0) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 421;
     break L12;
    }
    i143 = HEAP32[i121 >> 2] | 0;
    i143 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, HEAP32[i143 + (i2 << 3) >> 2] | 0, HEAP32[i143 + (i2 << 3) + 4 >> 2] | 0) | 0;
    mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i133 | 0, i1 & 65535 | 0, (HEAP32[i9 + 4 >> 2] | 0) - i143 | 0);
    if (!(HEAP16[i134 >> 1] | 0)) {
     i142 = (HEAP32[i121 >> 2] | 0) + (i2 << 3) | 0;
     i143 = HEAP32[i142 + 4 >> 2] | 0;
     i12 = (HEAP32[i37 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i12 >> 2] = HEAP32[i142 >> 2];
     HEAP32[i12 + 4 >> 2] = i143;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case 74:
  case 73:
   {
    i6 = HEAP32[i9 >> 2] & 65535;
    do if (i6 >>> 0 < (HEAPU16[i87 >> 1] | 0) >>> 0) {
     i7 = HEAP32[i9 + 4 >> 2] & 65535;
     if (i7 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
      if (i10 & 1) {
       i143 = HEAP32[i98 >> 2] | 0;
       i1 = HEAP32[i95 >> 2] | 0;
       i1 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i143 + (i6 << 3) >> 2] | 0) - (HEAP32[i1 + (i7 << 3) >> 2] | 0) | 0, (HEAP32[i143 + (i6 << 3) + 4 >> 2] | 0) - (HEAP32[i1 + (i7 << 3) + 4 >> 2] | 0) | 0) | 0;
       break;
      }
      i143 = HEAP32[i101 >> 2] | 0;
      if (i143 >>> 0 < 65536 | (i143 & 65535) << 16 >> 16 == 0) {
       i143 = HEAP32[i91 >> 2] | 0;
       i1 = HEAP32[i93 >> 2] | 0;
       i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i143 + (i6 << 3) >> 2] | 0) - (HEAP32[i1 + (i7 << 3) >> 2] | 0) | 0, (HEAP32[i143 + (i6 << 3) + 4 >> 2] | 0) - (HEAP32[i1 + (i7 << 3) + 4 >> 2] | 0) | 0) | 0;
       break;
      }
      i1 = HEAP32[i105 >> 2] | 0;
      i2 = HEAP32[i104 >> 2] | 0;
      i3 = HEAP32[i106 >> 2] | 0;
      i4 = HEAP32[i1 + (i6 << 3) >> 2] | 0;
      i5 = HEAP32[i2 + (i7 << 3) >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i107 >> 2] | 0)) {
       i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i4 - i5 | 0, (HEAP32[i1 + (i6 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i7 << 3) + 4 >> 2] | 0) | 0) | 0;
       i1 = _UNITY_FT_MulFix(i1, HEAP32[i106 >> 2] | 0) | 0;
       break;
      } else {
       i143 = _UNITY_FT_MulFix(i4 - i5 | 0, i3) | 0;
       i1 = _UNITY_FT_MulFix((HEAP32[i1 + (i6 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i7 << 3) + 4 >> 2] | 0) | 0, HEAP32[i107 >> 2] | 0) | 0;
       i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i143 | 0, i1 | 0) | 0;
       break;
      }
     } else i12 = 426;
    } else i12 = 426; while (0);
    if ((i12 | 0) == 426) if (!(HEAP8[i74 >> 0] | 0)) i1 = 0; else {
     HEAP32[i79 >> 2] = 134;
     i1 = 0;
    }
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 75:
   {
    HEAP32[i9 >> 2] = mftCall_ii(HEAP32[i39 >> 2] | 0, i17 | 0) | 0;
    i12 = 725;
    break;
   }
  case 76:
   {
    HEAP32[i9 >> 2] = mftCall_ii(HEAP32[i39 >> 2] | 0, i17 | 0) | 0;
    i12 = 725;
    break;
   }
  case 77:
   {
    HEAP8[i99 >> 0] = 1;
    i12 = 725;
    break;
   }
  case 78:
   {
    HEAP8[i99 >> 0] = 0;
    i12 = 725;
    break;
   }
  case 80:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) < (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 81:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) <= (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 82:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) > (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 83:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) >= (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 84:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) == (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 85:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) != (HEAP32[i9 + 4 >> 2] | 0) & 1;
    i12 = 725;
    break;
   }
  case 86:
   {
    HEAP32[i9 >> 2] = ((mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, HEAP32[i9 >> 2] | 0, 0) | 0) & 127 | 0) == 64 & 1;
    i12 = 725;
    break;
   }
  case 87:
   {
    HEAP32[i9 >> 2] = ((mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, HEAP32[i9 >> 2] | 0, 0) | 0) & 127 | 0) == 0 & 1;
    i12 = 725;
    break;
   }
  case 88:
   {
    if (!(HEAP32[i9 >> 2] | 0)) {
     i6 = HEAP32[i71 >> 2] | 0;
     i2 = 1;
     i3 = i8;
     i1 = HEAP32[i66 >> 2] | 0;
     while (1) {
      L627 : do if ((i2 | 0) == 1) while (1) {
       i1 = i3 + i1 | 0;
       HEAP32[i66 >> 2] = i1;
       if ((i1 | 0) >= (i6 | 0)) {
        i12 = 464;
        break L12;
       }
       i5 = HEAP8[i11 + i1 >> 0] | 0;
       HEAP8[i68 >> 0] = i5;
       i143 = i5 & 255;
       i3 = HEAP8[gb + 1007030 + i143 >> 0] | 0;
       HEAP32[i70 >> 2] = i3;
       if ((i143 | 1 | 0) == 65) {
        i4 = i1 + 1 | 0;
        if ((i4 | 0) >= (i6 | 0)) {
         i12 = 464;
         break L12;
        }
        i3 = 2 - (Math_imul(HEAPU8[i11 + i4 >> 0] | 0, i3) | 0) | 0;
        HEAP32[i70 >> 2] = i3;
       }
       if ((i3 + i1 | 0) > (i6 | 0)) {
        i12 = 464;
        break L12;
       }
       switch (i5 << 24 >> 24) {
       case 27:
        {
         i12 = 725;
         break L30;
        }
       case 88:
        {
         i12 = 466;
         break L627;
        }
       case 89:
        {
         i12 = 467;
         break L627;
        }
       default:
        {}
       }
      } else L636 : while (1) while (1) {
       i1 = i3 + i1 | 0;
       HEAP32[i66 >> 2] = i1;
       if ((i1 | 0) >= (i6 | 0)) {
        i12 = 464;
        break L12;
       }
       i5 = HEAP8[i11 + i1 >> 0] | 0;
       HEAP8[i68 >> 0] = i5;
       i143 = i5 & 255;
       i3 = HEAP8[gb + 1007030 + i143 >> 0] | 0;
       HEAP32[i70 >> 2] = i3;
       if ((i143 | 1 | 0) == 65) {
        i4 = i1 + 1 | 0;
        if ((i4 | 0) >= (i6 | 0)) {
         i12 = 464;
         break L12;
        }
        i3 = 2 - (Math_imul(HEAPU8[i11 + i4 >> 0] | 0, i3) | 0) | 0;
        HEAP32[i70 >> 2] = i3;
       }
       if ((i3 + i1 | 0) > (i6 | 0)) {
        i12 = 464;
        break L12;
       }
       switch (i5 << 24 >> 24) {
       case 88:
        {
         i12 = 466;
         break L627;
        }
       case 89:
        {
         i12 = 467;
         break L627;
        }
       case 27:
        continue L636;
       default:
        {}
       }
      } while (0);
      if ((i12 | 0) == 466) {
       i2 = i2 + 1 | 0;
       continue;
      } else if ((i12 | 0) == 467) {
       i2 = i2 + -1 | 0;
       if (!i2) {
        i12 = 725;
        break;
       } else continue;
      }
     }
    } else i12 = 725;
    break;
   }
  case 90:
   {
    if (!(HEAP32[i9 >> 2] | 0)) i1 = 0; else i1 = (HEAP32[i9 + 4 >> 2] | 0) != 0;
    HEAP32[i9 >> 2] = i1 & 1;
    i12 = 725;
    break;
   }
  case 91:
   {
    if (!(HEAP32[i9 >> 2] | 0)) i1 = (HEAP32[i9 + 4 >> 2] | 0) != 0; else i1 = 1;
    HEAP32[i9 >> 2] = i1 & 1;
    i12 = 725;
    break;
   }
  case 92:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) == 0 & 1;
    i12 = 725;
    break;
   }
  case 93:
   {
    _Ins_DELTAP(i17, i9);
    i12 = 725;
    break;
   }
  case 94:
   {
    HEAP16[i43 >> 1] = HEAP32[i9 >> 2];
    i12 = 725;
    break;
   }
  case 95:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 > 6) {
     i12 = 478;
     break L12;
    }
    HEAP16[i44 >> 1] = i1;
    i12 = 725;
    break;
   }
  case 96:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (HEAP32[i9 + 4 >> 2] | 0);
    i12 = 725;
    break;
   }
  case 97:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - (HEAP32[i9 + 4 >> 2] | 0);
    i12 = 725;
    break;
   }
  case 98:
   {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    if (!i1) {
     i12 = 483;
     break L12;
    }
    HEAP32[i9 >> 2] = _UNITY_FT_MulDiv_No_Round(HEAP32[i9 >> 2] | 0, 64, i1) | 0;
    i12 = 725;
    break;
   }
  case 99:
   {
    HEAP32[i9 >> 2] = _UNITY_FT_MulDiv(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, 64) | 0;
    i12 = 725;
    break;
   }
  case 100:
   {
    i12 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = (i12 | 0) < 0 ? 0 - i12 | 0 : i12;
    i12 = 725;
    break;
   }
  case 101:
   {
    HEAP32[i9 >> 2] = 0 - (HEAP32[i9 >> 2] | 0);
    i12 = 725;
    break;
   }
  case 102:
   {
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & -64;
    i12 = 725;
    break;
   }
  case 103:
   {
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 63 & -64;
    i12 = 725;
    break;
   }
  case 107:
  case 106:
  case 105:
  case 104:
   {
    HEAP32[i9 >> 2] = mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i17 + 264 + (i7 + -104 << 2) >> 2] | 0) | 0;
    i12 = 725;
    break;
   }
  case 111:
  case 110:
  case 109:
  case 108:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i17 + 264 + (i7 + -108 << 2) >> 2] | 0;
    if ((i2 | 0) > -1) {
     i1 = i1 + i2 | 0;
     i1 = (i1 | 0) < 0 ? 0 : i1;
    } else {
     i1 = i2 - i1 | 0;
     i1 = (i1 | 0) > 0 ? 0 : i1;
    }
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case 112:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 < (HEAP32[i85 >> 2] | 0) >>> 0) {
     i12 = _UNITY_FT_MulFix(HEAP32[i9 + 4 >> 2] | 0, HEAP32[i136 >> 2] | 0) | 0;
     HEAP32[(HEAP32[i45 >> 2] | 0) + (i1 << 2) >> 2] = i12;
     i12 = 725;
     break L30;
    } else if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 497;
     break L12;
    }
   }
  case 114:
  case 113:
   {
    _Ins_DELTAP(i17, i9);
    i12 = 725;
    break;
   }
  case 117:
  case 116:
  case 115:
   {
    i7 = mftCall_ii(HEAP32[i39 >> 2] | 0, i17 | 0) | 0;
    i6 = HEAP32[i9 >> 2] | 0;
    L683 : do if (i6 | 0) {
     i5 = 1;
     while (1) {
      i1 = HEAP32[i73 >> 2] | 0;
      if ((i1 | 0) < 2) break;
      i4 = i1 + -2 | 0;
      HEAP32[i73 >> 2] = i4;
      i143 = HEAP32[i75 >> 2] | 0;
      i3 = HEAP32[i143 + (i1 + -1 << 2) >> 2] | 0;
      i4 = HEAP32[i143 + (i4 << 2) >> 2] | 0;
      if (i3 >>> 0 < (HEAP32[i85 >> 2] | 0) >>> 0) {
       i1 = i4 >>> 4 & 15;
       switch (HEAP8[i68 >> 0] | 0) {
       case 117:
        {
         i1 = i1 | 32;
         break;
        }
       case 116:
        {
         i1 = i1 | 16;
         break;
        }
       default:
        {}
       }
       i2 = HEAP32[i43 >> 2] | 0;
       if ((i7 | 0) == ((i2 & 65535) + i1 | 0)) {
        i142 = i4 & 15;
        i143 = i142 + -8 | 0;
        mftCall_viii(HEAP32[i62 >> 2] | 0, i17 | 0, i3 | 0, ((i143 | 0) > -1 ? i142 + -7 | 0 : i143) << 6 - (i2 >>> 16) | 0);
       }
      } else if (HEAP8[i74 >> 0] | 0) {
       i12 = 507;
       break L12;
      }
      i5 = i5 + 1 | 0;
      if (i5 >>> 0 > i6 >>> 0) break L683;
     }
     if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 129;
     HEAP32[i73 >> 2] = 0;
    } while (0);
    HEAP32[i76 >> 2] = HEAP32[i73 >> 2];
    i12 = 725;
    break;
   }
  case 118:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    switch ((i1 & 192) << 24 >> 24) {
    case 0:
     {
      HEAP32[i46 >> 2] = 8192;
      i2 = 8192;
      break;
     }
    case 64:
     {
      HEAP32[i46 >> 2] = 16384;
      i2 = 16384;
      break;
     }
    case -128:
     {
      HEAP32[i46 >> 2] = 32768;
      i2 = 32768;
      break;
     }
    case -64:
     {
      HEAP32[i46 >> 2] = 16384;
      i2 = 16384;
      break;
     }
    default:
     {
      i12 = 520;
      break L12;
     }
    }
    switch (i1 & 48) {
    case 0:
     {
      HEAP32[i47 >> 2] = 0;
      i3 = 0;
      break;
     }
    case 16:
     {
      i3 = i2 >>> 2;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    case 32:
     {
      i3 = i2 >>> 1;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    case 48:
     {
      i3 = (i2 * 3 | 0) >>> 2;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    default:
     {
      i12 = 526;
      break L12;
     }
    }
    i1 = i1 & 15;
    if (!i1) i1 = i2 + -1 | 0; else i1 = (Math_imul(i2, i1 + -4 | 0) | 0) / 8 | 0;
    HEAP32[i46 >> 2] = i2 >>> 8;
    HEAP32[i47 >> 2] = i3 >>> 8;
    HEAP32[i48 >> 2] = i1 >> 8;
    HEAP32[i63 >> 2] = 6;
    HEAP32[i16 >> 2] = fb + 463;
    i12 = 725;
    break;
   }
  case 119:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    switch ((i1 & 192) << 24 >> 24) {
    case 0:
     {
      HEAP32[i46 >> 2] = 5792;
      i2 = 5792;
      break;
     }
    case 64:
     {
      HEAP32[i46 >> 2] = 11585;
      i2 = 11585;
      break;
     }
    case -128:
     {
      HEAP32[i46 >> 2] = 23170;
      i2 = 23170;
      break;
     }
    case -64:
     {
      HEAP32[i46 >> 2] = 11585;
      i2 = 11585;
      break;
     }
    default:
     {
      i12 = 536;
      break L12;
     }
    }
    switch (i1 & 48) {
    case 0:
     {
      HEAP32[i47 >> 2] = 0;
      i3 = 0;
      break;
     }
    case 16:
     {
      i3 = i2 >>> 2;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    case 32:
     {
      i3 = i2 >>> 1;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    case 48:
     {
      i3 = (i2 * 3 | 0) >>> 2;
      HEAP32[i47 >> 2] = i3;
      break;
     }
    default:
     {
      i12 = 542;
      break L12;
     }
    }
    i1 = i1 & 15;
    if (!i1) i1 = i2 + -1 | 0; else i1 = (Math_imul(i2, i1 + -4 | 0) | 0) / 8 | 0;
    HEAP32[i46 >> 2] = i2 >>> 8;
    HEAP32[i47 >> 2] = i3 >>> 8;
    HEAP32[i48 >> 2] = i1 >> 8;
    HEAP32[i63 >> 2] = 7;
    HEAP32[i16 >> 2] = fb + 464;
    i12 = 725;
    break;
   }
  case 120:
   {
    if (!(HEAP32[i9 + 4 >> 2] | 0)) i12 = 725; else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (!(i2 | i1)) HEAP32[i79 >> 2] = 132;
     i1 = (HEAP32[i66 >> 2] | 0) + i2 | 0;
     HEAP32[i66 >> 2] = i1;
     if ((i1 | 0) < 0) i12 = 553; else {
      i2 = HEAP32[i111 >> 2] | 0;
      if ((i2 | 0) > 0) if ((i1 | 0) > (HEAP32[(HEAP32[(HEAP32[i113 >> 2] | 0) + (i2 + -1 << 4) + 12 >> 2] | 0) + 8 >> 2] | 0)) i12 = 553;
     }
     if ((i12 | 0) == 553) HEAP32[i79 >> 2] = 132;
     HEAP8[i78 >> 0] = 0;
     i12 = 725;
    }
    break;
   }
  case 121:
   {
    if (!(HEAP32[i9 + 4 >> 2] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     if (!(i2 | i1)) HEAP32[i79 >> 2] = 132;
     i1 = (HEAP32[i66 >> 2] | 0) + i2 | 0;
     HEAP32[i66 >> 2] = i1;
     if ((i1 | 0) < 0) i12 = 561; else {
      i2 = HEAP32[i111 >> 2] | 0;
      if ((i2 | 0) > 0) if ((i1 | 0) > (HEAP32[(HEAP32[(HEAP32[i113 >> 2] | 0) + (i2 + -1 << 4) + 12 >> 2] | 0) + 8 >> 2] | 0)) i12 = 561;
     }
     if ((i12 | 0) == 561) HEAP32[i79 >> 2] = 132;
     HEAP8[i78 >> 0] = 0;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case 122:
   {
    HEAP32[i63 >> 2] = 5;
    HEAP32[i16 >> 2] = fb + 457;
    i12 = 725;
    break;
   }
  case 123:
   {
    _Ins_UNKNOWN(i17);
    i12 = 725;
    break;
   }
  case 124:
   {
    HEAP32[i63 >> 2] = 4;
    HEAP32[i16 >> 2] = fb + 459;
    i12 = 725;
    break;
   }
  case 125:
   {
    HEAP32[i63 >> 2] = 3;
    HEAP32[i16 >> 2] = fb + 460;
    i12 = 725;
    break;
   }
  case -128:
   {
    i2 = HEAP32[i135 >> 2] | 0;
    L762 : do if ((HEAP32[i72 >> 2] | 0) < (i2 | 0)) {
     if (HEAP8[i74 >> 0] | 0) HEAP32[i79 >> 2] = 129;
    } else if ((i2 | 0) > 0) while (1) {
     i1 = i1 + -1 | 0;
     HEAP32[i73 >> 2] = i1;
     i1 = HEAP32[i3 + (i1 << 2) >> 2] & 65535;
     if (i1 >>> 0 < (HEAPU16[i27 >> 1] | 0) >>> 0) {
      i2 = (HEAP32[i31 >> 2] | 0) + i1 | 0;
      HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ 1;
      i2 = HEAP32[i135 >> 2] | 0;
     } else if (HEAP8[i74 >> 0] | 0) {
      i12 = 573;
      break L12;
     }
     i4 = i2 + -1 | 0;
     HEAP32[i135 >> 2] = i4;
     i1 = HEAP32[i73 >> 2] | 0;
     if ((i2 | 0) <= 1) break L762;
     i3 = HEAP32[i75 >> 2] | 0;
     i2 = i4;
    } while (0);
    HEAP32[i135 >> 2] = 1;
    HEAP32[i76 >> 2] = i1;
    i12 = 725;
    break;
   }
  case -127:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i9 + 4 >> 2] & 65535;
    i143 = HEAPU16[i27 >> 1] | 0;
    i1 = i2 & 65535;
    if (!(i3 >>> 0 < i143 >>> 0 & i1 >>> 0 < i143 >>> 0)) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 582;
     break L12;
    }
    if (i1 >>> 0 > i3 >>> 0) i12 = 725; else {
     i2 = i2 & 65535;
     do {
      i143 = (HEAP32[i31 >> 2] | 0) + i1 | 0;
      HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] | 1;
      i2 = i2 + 1 << 16 >> 16;
      i1 = i2 & 65535;
     } while (i1 >>> 0 <= i3 >>> 0);
     i12 = 725;
    }
    break;
   }
  case -126:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i9 + 4 >> 2] & 65535;
    i143 = HEAPU16[i27 >> 1] | 0;
    i1 = i2 & 65535;
    if (!(i3 >>> 0 < i143 >>> 0 & i1 >>> 0 < i143 >>> 0)) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 588;
     break L12;
    }
    if (i1 >>> 0 > i3 >>> 0) i12 = 725; else {
     i2 = i2 & 65535;
     do {
      i143 = (HEAP32[i31 >> 2] | 0) + i1 | 0;
      HEAP8[i143 >> 0] = HEAPU8[i143 >> 0] & 254;
      i2 = i2 + 1 << 16 >> 16;
      i1 = i2 & 65535;
     } while (i1 >>> 0 <= i3 >>> 0);
     i12 = 725;
    }
    break;
   }
  case -124:
  case -125:
   {
    _Ins_UNKNOWN(i17);
    i12 = 725;
    break;
   }
  case -123:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1 & 255;
    switch ((i1 & 255) << 24 >> 24) {
    case -1:
     {
      HEAP8[i51 >> 0] = 1;
      i12 = 725;
      break L30;
     }
    case 0:
     {
      HEAP8[i51 >> 0] = 0;
      i12 = 725;
      break L30;
     }
    default:
     {
      if (i1 & 256 | 0) if ((HEAPU16[i53 >> 1] | 0) >>> 0 <= i2 >>> 0) HEAP8[i51 >> 0] = 1;
      if (i1 & 512 | 0) if (HEAP8[i52 >> 0] | 0) HEAP8[i51 >> 0] = 1;
      if (i1 & 1024 | 0) if (HEAP8[i49 >> 0] | 0) HEAP8[i51 >> 0] = 1;
      if (i1 & 2048 | 0) if ((HEAPU16[i53 >> 1] | 0) >>> 0 > i2 >>> 0) HEAP8[i51 >> 0] = 0;
      if (i1 & 4096 | 0) if (HEAP8[i52 >> 0] | 0) HEAP8[i51 >> 0] = 0;
      if (!(i1 & 8192)) {
       i12 = 725;
       break L30;
      }
      if (!(HEAP8[i49 >> 0] | 0)) {
       i12 = 725;
       break L30;
      }
      HEAP8[i51 >> 0] = 0;
      i12 = 725;
      break L30;
     }
    }
   }
  case -121:
  case -122:
   {
    i5 = HEAP32[i9 >> 2] & 65535;
    if (i5 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
     i4 = HEAP32[i9 + 4 >> 2] & 65535;
     if (i4 >>> 0 < (HEAPU16[i120 >> 1] | 0) >>> 0) {
      i3 = HEAP32[i93 >> 2] | 0;
      i2 = HEAP32[i37 >> 2] | 0;
      i143 = (HEAP32[i3 + (i5 << 3) >> 2] | 0) - (HEAP32[i2 + (i4 << 3) >> 2] | 0) | 0;
      i2 = (HEAP32[i3 + (i5 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0) | 0;
      i3 = (i2 | i143 | 0) == 0;
      i143 = i3 ? 16384 : i143;
      i3 = (i10 & 1) == 0 | i3;
      i1 = i3 ? i2 : i143;
      i2 = i3 ? i143 : 0 - i2 | 0;
      if (i1 | i2 | 0) {
       HEAP32[i18 >> 2] = i2;
       HEAP32[i55 >> 2] = i1;
       _UNITY_FT_Vector_NormLen(i18) | 0;
       HEAP16[i117 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
       HEAP16[i118 >> 1] = (HEAP32[i55 >> 2] | 0) / 4 | 0;
      }
      i142 = HEAP32[i95 >> 2] | 0;
      i2 = HEAP32[i121 >> 2] | 0;
      i143 = (HEAP32[i142 + (i5 << 3) >> 2] | 0) - (HEAP32[i2 + (i4 << 3) >> 2] | 0) | 0;
      i2 = (HEAP32[i142 + (i5 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0) | 0;
      i142 = (i2 | i143 | 0) == 0;
      i143 = i142 ? 16384 : i143;
      i142 = i3 | i142;
      i1 = i142 ? i2 : i143;
      i2 = i142 ? i143 : 0 - i2 | 0;
      if (i1 | i2 | 0) {
       HEAP32[i18 >> 2] = i2;
       HEAP32[i54 >> 2] = i1;
       _UNITY_FT_Vector_NormLen(i18) | 0;
       HEAP16[i115 >> 1] = (HEAP32[i18 >> 2] | 0) / 4 | 0;
       HEAP16[i116 >> 1] = (HEAP32[i54 >> 2] | 0) / 4 | 0;
      }
      _Compute_Funcs(i17);
      i12 = 725;
      break L30;
     }
    }
    if (!(HEAP8[i74 >> 0] | 0)) i12 = 725; else {
     i12 = 615;
     break L12;
    }
    break;
   }
  case -120:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = i2 & 1 | 0 ? 35 : 0;
    if (i2 & 2) i1 = (HEAP8[i52 >> 0] | 0) == 0 ? i1 : i1 | 128;
    if (i2 & 4) i1 = (HEAP8[i49 >> 0] | 0) == 0 ? i1 : i1 | 256;
    if (i2 & 32) i1 = (HEAP8[i56 >> 0] | 0) == 0 ? i1 : i1 | 4096;
    HEAP32[i9 >> 2] = i1;
    i12 = 725;
    break;
   }
  case -119:
   {
    i1 = HEAP32[i109 >> 2] | 0;
    i3 = HEAP32[i110 >> 2] | 0;
    i4 = i1 + (i3 * 24 | 0) | 0;
    L838 : do if ((i3 | 0) > 0) {
     i2 = HEAP32[i9 >> 2] | 0;
     while (1) {
      if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 | 0)) {
       i2 = i1;
       break L838;
      }
      i1 = i1 + 24 | 0;
      if (i1 >>> 0 >= i4 >>> 0) {
       i2 = i1;
       break;
      }
     }
    } else i2 = i1; while (0);
    if ((i2 | 0) == (i4 | 0)) {
     if (i3 >>> 0 >= (HEAP32[i57 >> 2] | 0) >>> 0) {
      i12 = 634;
      break L12;
     }
     HEAP32[i110 >> 2] = i3 + 1;
    }
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 > 255) {
     i12 = 637;
     break L12;
    }
    HEAP32[i2 + 12 >> 2] = i1 & 255;
    i3 = HEAP32[i66 >> 2] | 0;
    HEAP32[i2 + 4 >> 2] = i3 + 1;
    HEAP32[i2 >> 2] = HEAP32[i114 >> 2];
    HEAP8[i2 + 16 >> 0] = 1;
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 >>> 0 > (HEAP32[i58 >> 2] | 0) >>> 0) HEAP32[i58 >> 2] = i1 & 255;
    i5 = HEAP32[i71 >> 2] | 0;
    i2 = i8;
    i1 = i3;
    while (1) {
     i1 = i2 + i1 | 0;
     HEAP32[i66 >> 2] = i1;
     if ((i1 | 0) >= (i5 | 0)) {
      i12 = 646;
      break L12;
     }
     i4 = HEAP8[i11 + i1 >> 0] | 0;
     HEAP8[i68 >> 0] = i4;
     i143 = i4 & 255;
     i2 = HEAP8[gb + 1007030 + i143 >> 0] | 0;
     HEAP32[i70 >> 2] = i2;
     if ((i143 | 1 | 0) == 65) {
      i3 = i1 + 1 | 0;
      if ((i3 | 0) >= (i5 | 0)) {
       i12 = 646;
       break L12;
      }
      i2 = 2 - (Math_imul(HEAPU8[i11 + i3 >> 0] | 0, i2) | 0) | 0;
      HEAP32[i70 >> 2] = i2;
     }
     if ((i2 + i1 | 0) > (i5 | 0)) {
      i12 = 646;
      break L12;
     }
     switch (i4 << 24 >> 24) {
     case 44:
     case -119:
      {
       i12 = 648;
       break L12;
      }
     case 45:
      {
       i12 = 725;
       break L30;
      }
     default:
      {}
     }
    }
   }
  case -118:
   {
    i14 = i9 + 8 | 0;
    i142 = HEAP32[i14 >> 2] | 0;
    i143 = i9 + 4 | 0;
    i12 = HEAP32[i143 >> 2] | 0;
    HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i143 >> 2] = i142;
    HEAP32[i9 >> 2] = i12;
    i12 = 725;
    break;
   }
  case -117:
   {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    if ((i1 | 0) > (HEAP32[i9 >> 2] | 0)) {
     HEAP32[i9 >> 2] = i1;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case -116:
   {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    if ((i1 | 0) < (HEAP32[i9 >> 2] | 0)) {
     HEAP32[i9 >> 2] = i1;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case -115:
   {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) > -1) {
     HEAP32[i59 >> 2] = i1;
     i12 = 725;
    } else i12 = 725;
    break;
   }
  case -114:
   {
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = (HEAP32[i9 + 4 >> 2] | 0) + -1 | 0;
    if (i1 >>> 0 > 2) if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 658;
     break L12;
    }
    i1 = 1 << i1;
    if ((i2 | 0) == 0 | (i1 | 0) == (i2 | 0)) {
     HEAP8[i60 >> 0] = HEAPU8[i60 >> 0] & (i1 ^ 255) | i2;
     i12 = 725;
     break L30;
    } else if (!(HEAP8[i74 >> 0] | 0)) {
     i12 = 725;
     break L30;
    } else {
     i12 = 661;
     break L12;
    }
   }
  case -113:
   {
    _Ins_UNKNOWN(i17);
    i12 = 725;
    break;
   }
  default:
   {
    if ((i10 & 255) > 223) {
     i3 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i9 + 4 >> 2] | 0;
     i7 = HEAP32[i81 >> 2] | 0;
     i4 = HEAP32[i82 >> 2] | 0;
     i8 = i3 & 65535;
     i2 = i1 + 1 | 0;
     i3 = i3 & 65535;
     if (i3 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) if (i2 >>> 0 < ((HEAP32[i85 >> 2] | 0) + 1 | 0) >>> 0) if ((HEAPU16[i86 >> 1] | 0) < (HEAPU16[i87 >> 1] | 0)) {
      if (!i2) i1 = 0; else i1 = mftCall_iii(HEAP32[i50 >> 2] | 0, i17 | 0, i1 | 0) | 0;
      i143 = HEAP32[i88 >> 2] | 0;
      i142 = i1 - i143 | 0;
      i1 = (((i142 | 0) < 0 ? 0 - i142 | 0 : i142) | 0) < (HEAP32[i89 >> 2] | 0) ? ((i1 | 0) > -1 ? i143 : 0 - i143 | 0) : i1;
      if (!(HEAP16[i90 >> 1] | 0)) {
       i142 = HEAPU16[i86 >> 1] | 0;
       i143 = HEAP32[i91 >> 2] | 0;
       i6 = HEAP16[i92 >> 1] | 0;
       i11 = i6 << 16 >> 16;
       i2 = 0 - i1 | 0;
       i13 = (i1 | 0) < 0 ? i2 : i1;
       i6 = i6 << 16 >> 16 < 0 ? 0 - i11 | 0 : i11;
       i10 = i13 >>> 16;
       i13 = i13 & 65535;
       i14 = Math_imul(i6, i10) | 0;
       i9 = i14 << 16 | 8192;
       i6 = i9 + (Math_imul(i6, i13) | 0) | 0;
       i6 = (i6 >>> 0 < i9 >>> 0 & 1) + (i14 >>> 16) << 18 | i6 >>> 14;
       i14 = HEAP32[i93 >> 2] | 0;
       HEAP32[i14 + (i3 << 3) >> 2] = ((i11 ^ i1 | 0) > -1 ? i6 : 0 - i6 | 0) + (HEAP32[i143 + (i142 << 3) >> 2] | 0);
       i6 = HEAP16[i94 >> 1] | 0;
       i11 = i6 << 16 >> 16;
       i6 = i6 << 16 >> 16 < 0 ? 0 - i11 | 0 : i11;
       i10 = Math_imul(i6, i10) | 0;
       i9 = i10 << 16 | 8192;
       i13 = i9 + (Math_imul(i6, i13) | 0) | 0;
       i13 = (i13 >>> 0 < i9 >>> 0 & 1) + (i10 >>> 16) << 18 | i13 >>> 14;
       HEAP32[i14 + (i3 << 3) + 4 >> 2] = ((i11 ^ i1 | 0) > -1 ? i13 : 0 - i13 | 0) + (HEAP32[i143 + (i142 << 3) + 4 >> 2] | 0);
       i14 = i14 + (i3 << 3) | 0;
       i142 = HEAP32[i14 + 4 >> 2] | 0;
       i143 = (HEAP32[i95 >> 2] | 0) + (i3 << 3) | 0;
       HEAP32[i143 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i143 + 4 >> 2] = i142;
      } else i2 = 0 - i1 | 0;
      i6 = HEAP32[i93 >> 2] | 0;
      i5 = HEAPU16[i86 >> 1] | 0;
      i142 = HEAP32[i91 >> 2] | 0;
      i5 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i6 + (i3 << 3) >> 2] | 0) - (HEAP32[i142 + (i5 << 3) >> 2] | 0) | 0, (HEAP32[i6 + (i3 << 3) + 4 >> 2] | 0) - (HEAP32[i142 + (i5 << 3) + 4 >> 2] | 0) | 0) | 0;
      i142 = HEAP32[i95 >> 2] | 0;
      i6 = HEAPU16[i86 >> 1] | 0;
      i143 = HEAP32[i98 >> 2] | 0;
      i6 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i142 + (i3 << 3) >> 2] | 0) - (HEAP32[i143 + (i6 << 3) >> 2] | 0) | 0, (HEAP32[i142 + (i3 << 3) + 4 >> 2] | 0) - (HEAP32[i143 + (i6 << 3) + 4 >> 2] | 0) | 0) | 0;
      i1 = (i5 ^ i1 | 0) < 0 & (HEAP8[i99 >> 0] | 0) != 0 ? i2 : i1;
      i2 = HEAP8[i68 >> 0] | 0;
      i3 = i2 & 255;
      do if (!(i3 & 4)) {
       i3 = HEAP32[i17 + 264 + ((i3 & 3) << 2) >> 2] | 0;
       if ((i1 | 0) > -1) {
        i1 = i3 + i1 | 0;
        i1 = (i1 | 0) < 0 ? 0 : i1;
        break;
       } else {
        i1 = i1 - i3 | 0;
        i1 = (i1 | 0) > 0 ? 0 : i1;
        break;
       }
      } else {
       i143 = HEAP32[i101 >> 2] | 0;
       i2 = i1 - i5 | 0;
       if ((i143 & 65535) << 16 >> 16 == (i143 >>> 16 & 65535) << 16 >> 16) i1 = (((i2 | 0) < 0 ? 0 - i2 | 0 : i2) | 0) > (i4 | 0) ? i5 : i1;
       i1 = mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, i1 | 0, HEAP32[i17 + 264 + ((i3 & 3) << 2) >> 2] | 0) | 0;
       i2 = HEAP8[i68 >> 0] | 0;
      } while (0);
      do if (i2 & 8) if ((i5 | 0) > -1) {
       i1 = (i1 | 0) < (i7 | 0) ? i7 : i1;
       break;
      } else {
       i143 = 0 - i7 | 0;
       i1 = (i1 | 0) > (i143 | 0) ? i143 : i1;
       break;
      } while (0);
      mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i83 | 0, i8 | 0, i1 - i6 | 0);
      i1 = HEAP8[i68 >> 0] | 0;
     } else i12 = 668; else i12 = 668; else i12 = 668;
     if ((i12 | 0) == 668) if (!(HEAP8[i74 >> 0] | 0)) i1 = i10; else {
      HEAP32[i79 >> 2] = 134;
      i1 = i10;
     }
     HEAP16[i102 >> 1] = HEAP16[i86 >> 1] | 0;
     if (i1 & 16) HEAP16[i86 >> 1] = i8;
     HEAP16[i103 >> 1] = i8;
     i12 = 725;
     break L30;
    }
    if ((i10 & 255) <= 191) if ((i10 & 255) > 183) {
     i4 = i7 + 65353 & 65535;
     if (i4 >>> 0 >= (i6 + 1 - (HEAP32[i72 >> 2] | 0) | 0) >>> 0) {
      i12 = 714;
      break L12;
     }
     i1 = (HEAP32[i66 >> 2] | 0) + 1 | 0;
     HEAP32[i66 >> 2] = i1;
     L74 : do if (i4 | 0) {
      i3 = 0;
      i2 = 0;
      while (1) {
       HEAP32[i66 >> 2] = i1 + 2;
       HEAP32[i9 + (i2 << 2) >> 2] = (HEAPU8[i11 + i1 >> 0] << 8 | HEAPU8[i11 + (i1 + 1) >> 0]) << 16 >> 16;
       i1 = i3 + 1 << 16 >> 16;
       i2 = i1 & 65535;
       if (i2 >>> 0 >= i4 >>> 0) break L74;
       i3 = i1;
       i1 = HEAP32[i66 >> 2] | 0;
      }
     } while (0);
     HEAP8[i78 >> 0] = 0;
     i12 = 725;
     break L30;
    } else {
     if ((i10 & 255) <= 175) {
      _Ins_UNKNOWN(i17);
      i12 = 725;
      break L30;
     }
     i3 = i7 + 65361 & 65535;
     if (i3 >>> 0 >= (i6 + 1 - (HEAP32[i72 >> 2] | 0) | 0) >>> 0) {
      i12 = 722;
      break L12;
     }
     if (!i3) {
      i12 = 725;
      break L30;
     } else {
      i1 = 1;
      i2 = 1;
     }
     while (1) {
      HEAP32[i9 + (i2 + -1 << 2) >> 2] = HEAPU8[i11 + ((HEAP32[i66 >> 2] | 0) + i2) >> 0];
      i1 = i1 + 1 << 16 >> 16;
      i2 = i1 & 65535;
      if (i2 >>> 0 > i3 >>> 0) {
       i12 = 725;
       break L30;
      }
     }
    }
    i8 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i81 >> 2] | 0;
    i9 = i8 & 65535;
    i8 = i8 & 65535;
    if (i8 >>> 0 < (HEAPU16[i84 >> 1] | 0) >>> 0) {
     i143 = HEAP16[i86 >> 1] | 0;
     i6 = i143 & 65535;
     if ((i143 & 65535) < (HEAPU16[i87 >> 1] | 0)) {
      i143 = HEAP32[i101 >> 2] | 0;
      do if (i143 >>> 0 < 65536 | (i143 & 65535) << 16 >> 16 == 0) {
       i143 = HEAP32[i93 >> 2] | 0;
       i1 = HEAP32[i91 >> 2] | 0;
       i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, (HEAP32[i143 + (i8 << 3) >> 2] | 0) - (HEAP32[i1 + (i6 << 3) >> 2] | 0) | 0, (HEAP32[i143 + (i8 << 3) + 4 >> 2] | 0) - (HEAP32[i1 + (i6 << 3) + 4 >> 2] | 0) | 0) | 0;
      } else {
       i1 = HEAP32[i104 >> 2] | 0;
       i2 = HEAP32[i105 >> 2] | 0;
       i3 = HEAP32[i106 >> 2] | 0;
       i4 = HEAP32[i1 + (i8 << 3) >> 2] | 0;
       i5 = HEAP32[i2 + (i6 << 3) >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i107 >> 2] | 0)) {
        i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i4 - i5 | 0, (HEAP32[i1 + (i8 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i6 << 3) + 4 >> 2] | 0) | 0) | 0;
        i1 = _UNITY_FT_MulFix(i1, HEAP32[i106 >> 2] | 0) | 0;
        break;
       } else {
        i143 = _UNITY_FT_MulFix(i4 - i5 | 0, i3) | 0;
        i1 = _UNITY_FT_MulFix((HEAP32[i1 + (i8 << 3) + 4 >> 2] | 0) - (HEAP32[i2 + (i6 << 3) + 4 >> 2] | 0) | 0, HEAP32[i107 >> 2] | 0) | 0;
        i1 = mftCall_iiii(HEAP32[i96 >> 2] | 0, i17 | 0, i143 | 0, i1 | 0) | 0;
        break;
       }
      } while (0);
      i3 = HEAP32[i88 >> 2] | 0;
      i2 = i1 - i3 | 0;
      i3 = (((i2 | 0) < 0 ? 0 - i2 | 0 : i2) | 0) < (HEAP32[i89 >> 2] | 0) ? ((i1 | 0) > -1 ? i3 : 0 - i3 | 0) : i1;
      i2 = HEAP8[i68 >> 0] | 0;
      i1 = i2 & 255;
      do if (!(i1 & 4)) {
       i1 = HEAP32[i17 + 264 + ((i1 & 3) << 2) >> 2] | 0;
       if ((i3 | 0) > -1) {
        i1 = i1 + i3 | 0;
        i1 = (i1 | 0) < 0 ? 0 : i1;
        break;
       } else {
        i1 = i3 - i1 | 0;
        i1 = (i1 | 0) > 0 ? 0 : i1;
        break;
       }
      } else {
       i1 = mftCall_iiii(HEAP32[i16 >> 2] | 0, i17 | 0, i3 | 0, HEAP32[i17 + 264 + ((i1 & 3) << 2) >> 2] | 0) | 0;
       i2 = HEAP8[i68 >> 0] | 0;
      } while (0);
      do if (i2 & 8) if ((i3 | 0) > -1) {
       i1 = (i1 | 0) < (i7 | 0) ? i7 : i1;
       break;
      } else {
       i143 = 0 - i7 | 0;
       i1 = (i1 | 0) > (i143 | 0) ? i143 : i1;
       break;
      } while (0);
      i14 = HEAP32[i95 >> 2] | 0;
      i142 = HEAP32[i98 >> 2] | 0;
      i143 = HEAPU16[i86 >> 1] | 0;
      i143 = mftCall_iiii(HEAP32[i97 >> 2] | 0, i17 | 0, (HEAP32[i14 + (i8 << 3) >> 2] | 0) - (HEAP32[i142 + (i143 << 3) >> 2] | 0) | 0, (HEAP32[i14 + (i8 << 3) + 4 >> 2] | 0) - (HEAP32[i142 + (i143 << 3) + 4 >> 2] | 0) | 0) | 0;
      mftCall_viiii(HEAP32[i100 >> 2] | 0, i17 | 0, i83 | 0, i9 | 0, i1 - i143 | 0);
      i1 = HEAP8[i68 >> 0] | 0;
     } else i12 = 693;
    } else i12 = 693;
    if ((i12 | 0) == 693) if (!(HEAP8[i74 >> 0] | 0)) i1 = i10; else {
     HEAP32[i79 >> 2] = 134;
     i1 = i10;
    }
    HEAP16[i102 >> 1] = HEAP16[i86 >> 1] | 0;
    HEAP16[i103 >> 1] = i9;
    if (!(i1 & 16)) i12 = 725; else {
     HEAP16[i86 >> 1] = i9;
     i12 = 725;
    }
   }
  } while (0);
  L875 : do if ((i12 | 0) == 725) {
   i12 = 0;
   i1 = HEAP32[i79 >> 2] | 0;
   switch (i1 | 0) {
   case 0:
    {
     i12 = 740;
     break L875;
    }
   case 128:
    break;
   default:
    {
     i12 = 748;
     break L12;
    }
   }
   i1 = HEAP32[i109 >> 2] | 0;
   i143 = HEAP32[i110 >> 2] | 0;
   i2 = i1 + (i143 * 24 | 0) | 0;
   if ((i143 | 0) <= 0) {
    i12 = 739;
    break L12;
   }
   while (1) {
    if (HEAP8[i1 + 16 >> 0] | 0) if ((HEAP8[i68 >> 0] | 0) == (HEAP32[i1 + 12 >> 2] & 255) << 24 >> 24) break;
    i1 = i1 + 24 | 0;
    if (i1 >>> 0 >= i2 >>> 0) {
     i12 = 739;
     break L12;
    }
   }
   i2 = HEAP32[i111 >> 2] | 0;
   if ((i2 | 0) >= (HEAP32[i112 >> 2] | 0)) {
    i12 = 730;
    break L12;
   }
   i4 = HEAP32[i113 >> 2] | 0;
   HEAP32[i4 + (i2 << 4) >> 2] = HEAP32[i114 >> 2];
   HEAP32[i4 + (i2 << 4) + 4 >> 2] = (HEAP32[i66 >> 2] | 0) + 1;
   HEAP32[i4 + (i2 << 4) + 8 >> 2] = 1;
   HEAP32[i4 + (i2 << 4) + 12 >> 2] = i1;
   i4 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i4 + -1 | 0;
   if (i1 >>> 0 > 2) {
    i12 = 732;
    break L12;
   }
   i3 = HEAP32[i17 + 444 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i12 = 734;
    break L12;
   }
   i1 = HEAP32[i17 + 444 + (i1 << 3) + 4 >> 2] | 0;
   if ((i1 | 0) < (i2 | 0)) {
    i12 = 737;
    break L12;
   }
   HEAP32[i67 >> 2] = i3;
   HEAP32[i71 >> 2] = i1;
   HEAP32[i66 >> 2] = i2;
   HEAP32[i114 >> 2] = i4;
   i1 = i15;
  } while (0);
  if ((i12 | 0) == 740) {
   i12 = 0;
   HEAP32[i72 >> 2] = HEAP32[i76 >> 2];
   if (HEAP8[i78 >> 0] | 0) HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + (HEAP32[i70 >> 2] | 0);
   if ((i15 | 0) > 999999) {
    i1 = 139;
    i12 = 752;
    break;
   } else i1 = i15 + 1 | 0;
  }
  i4 = HEAP32[i66 >> 2] | 0;
  if ((i4 | 0) >= (HEAP32[i71 >> 2] | 0)) {
   i12 = 744;
   break;
  }
  if (HEAP8[i108 >> 0] | 0) {
   i1 = 0;
   i12 = 752;
   break;
  } else i15 = i1;
 }
 switch (i12 | 0) {
 case 21:
  {
   HEAP32[i79 >> 2] = 129;
   i65 = 129;
   break;
  }
 case 25:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 35:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 42:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 61:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 73:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 79:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 85:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 91:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 94:
  {
   HEAP32[i79 >> 2] = 132;
   i65 = 132;
   break;
  }
 case 106:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 132:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 137:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 142:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 153:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 163:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 173:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 182:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 188:
  {
   HEAP32[i79 >> 2] = 140;
   i65 = 140;
   break;
  }
 case 191:
  {
   HEAP32[i79 >> 2] = 140;
   i65 = 140;
   break;
  }
 case 200:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 202:
  {
   HEAP32[i79 >> 2] = 137;
   i65 = 137;
   break;
  }
 case 205:
  {
   HEAP32[i79 >> 2] = 136;
   i65 = 136;
   break;
  }
 case 209:
  {
   HEAP32[i79 >> 2] = 132;
   i65 = 132;
   break;
  }
 case 211:
  {
   HEAP32[i79 >> 2] = 138;
   i65 = 138;
   break;
  }
 case 213:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 217:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 311:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 346:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 352:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 365:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 384:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 388:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 396:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 400:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 405:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 409:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 421:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 440:
  {
   HEAP32[i79 >> 2] = 135;
   i65 = 135;
   break;
  }
 case 464:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 478:
  {
   HEAP32[i79 >> 2] = 132;
   i65 = 132;
   break;
  }
 case 483:
  {
   HEAP32[i79 >> 2] = 133;
   i65 = 133;
   break;
  }
 case 497:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 507:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 520:
  break;
 case 526:
  break;
 case 536:
  break;
 case 542:
  break;
 case 573:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 582:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 588:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 615:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 634:
  {
   HEAP32[i79 >> 2] = 141;
   i65 = 141;
   break;
  }
 case 637:
  {
   HEAP32[i79 >> 2] = 141;
   i65 = 141;
   break;
  }
 case 646:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 648:
  {
   HEAP32[i79 >> 2] = 137;
   i65 = 137;
   break;
  }
 case 658:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 661:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 714:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 722:
  {
   HEAP32[i79 >> 2] = 130;
   i65 = 130;
   break;
  }
 case 730:
  {
   HEAP32[i79 >> 2] = 134;
   i65 = 134;
   break;
  }
 case 732:
  {
   HEAP32[i79 >> 2] = 132;
   i65 = 132;
   break;
  }
 case 734:
  {
   HEAP32[i79 >> 2] = 138;
   i65 = 138;
   break;
  }
 case 737:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 739:
  {
   HEAP32[i79 >> 2] = 128;
   i65 = 128;
   break;
  }
 case 744:
  if ((HEAP32[i111 >> 2] | 0) > 0) {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  } else {
   i143 = 0;
   STACKTOP = i141;
   return i143 | 0;
  }
 case 747:
  {
   HEAP32[i79 >> 2] = 131;
   i65 = 131;
   break;
  }
 case 748:
  {
   if (!i1) {
    i143 = 0;
    STACKTOP = i141;
    return i143 | 0;
   } else i65 = i1;
   break;
  }
 case 752:
  {
   STACKTOP = i141;
   return i1 | 0;
  }
 }
 if (HEAP8[i108 >> 0] | 0) {
  i143 = i65;
  STACKTOP = i141;
  return i143 | 0;
 }
 if ((HEAP32[i114 >> 2] | 0) != 3) {
  i143 = i65;
  STACKTOP = i141;
  return i143 | 0;
 }
 i143 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i143 + 296 >> 2] = -1;
 HEAP32[i143 + 300 >> 2] = -1;
 i143 = i65;
 STACKTOP = i141;
 return i143 | 0;
}

function __Z16CarveNavMeshTilePPhPiPKhijPK16NavMeshCarveDatafff(i124, i104, i123, i1, i90, i91, f38, f92, f93) {
 i124 = i124 | 0;
 i104 = i104 | 0;
 i123 = i123 | 0;
 i1 = i1 | 0;
 i90 = i90 | 0;
 i91 = i91 | 0;
 f38 = Math_fround(f38);
 f92 = Math_fround(f92);
 f93 = Math_fround(f93);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, f142 = f0, f143 = f0, f144 = f0;
 i141 = STACKTOP;
 STACKTOP = STACKTOP + 9248 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i129 = i141 + 16 | 0;
 i112 = i141;
 i118 = i141 + 9216 | 0;
 i122 = i141 + 9184 | 0;
 i102 = i141 + 9148 | 0;
 i103 = i141 + 8864 | 0;
 i99 = i141 + 8580 | 0;
 i100 = i141 + 8560 | 0;
 i101 = i141 + 8520 | 0;
 i126 = i141 + 232 | 0;
 i125 = i141 + 212 | 0;
 i115 = i141 + 200 | 0;
 i1 = i141 + 9208 | 0;
 i140 = i141 + 120 | 0;
 i25 = i141 + 9204 | 0;
 i136 = i141 + 96 | 0;
 i137 = i141 + 80 | 0;
 i85 = i141 + 56 | 0;
 i86 = i141 + 40 | 0;
 i87 = i141 + 9180 | 0;
 i88 = i141 + 9176 | 0;
 i89 = i141 + 9172 | 0;
 i97 = i141 + 9168 | 0;
 HEAP32[i124 >> 2] = 0;
 HEAP32[i104 >> 2] = 0;
 if (!i90) {
  i140 = 1;
  STACKTOP = i141;
  return i140 | 0;
 }
 if ((HEAP32[i123 >> 2] | 0) != 1145979222) {
  i140 = 2;
  STACKTOP = i141;
  return i140 | 0;
 }
 if ((HEAP32[i123 + 4 >> 2] | 0) != 16) {
  i140 = 2;
  STACKTOP = i141;
  return i140 | 0;
 }
 i94 = i123 + 24 | 0;
 i95 = i123 + 20 | 0;
 i6 = i123 + 28 | 0;
 i2 = i123 + 32 | 0;
 i96 = i123 + 72 | 0;
 i105 = i96 + ((HEAP32[i94 >> 2] | 0) * 12 | 0) | 0;
 i119 = i105 + (HEAP32[i95 >> 2] << 5) | 0;
 i120 = i119 + ((HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
 i121 = i120 + ((HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
 i106 = i123 + 44 | 0;
 f33 = Math_fround(HEAPF32[i106 >> 2]);
 f18 = Math_fround(HEAPF32[i123 + 48 >> 2]);
 i107 = i123 + 52 | 0;
 f36 = Math_fround(HEAPF32[i107 >> 2]);
 i108 = i123 + 56 | 0;
 f34 = Math_fround(HEAPF32[i108 >> 2]);
 f35 = Math_fround(HEAPF32[i123 + 60 >> 2]);
 i109 = i123 + 64 | 0;
 f35 = Math_fround(Math_fround(f18 + f35) * Math_fround(.5));
 f36 = Math_fround(Math_fround(f36 + Math_fround(HEAPF32[i109 >> 2])) * Math_fround(.5));
 HEAPF32[i115 >> 2] = Math_fround(Math_fround(f33 + f34) * Math_fround(.5));
 i116 = i115 + 4 | 0;
 HEAPF32[i116 >> 2] = f35;
 i117 = i115 + 8 | 0;
 HEAPF32[i117 >> 2] = f36;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i129 >> 2] = HEAP32[i1 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459140 | 0, i129);
 i134 = gb + 64016 | 0;
 i135 = HEAP32[i134 >> 2] | 0;
 i134 = HEAP32[i134 + 4 >> 2] | 0;
 i20 = i112;
 HEAP32[i20 >> 2] = i135;
 HEAP32[i20 + 4 >> 2] = i134;
 HEAP32[i140 >> 2] = 0;
 i20 = i140 + 12 | 0;
 HEAP32[i20 >> 2] = 0;
 i138 = i140 + 16 | 0;
 HEAP32[i138 >> 2] = 0;
 i139 = i140 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
 i131 = i129;
 i130 = HEAP32[i131 + 4 >> 2] | 0;
 i3 = i139;
 HEAP32[i3 >> 2] = HEAP32[i131 >> 2];
 HEAP32[i3 + 4 >> 2] = i130;
 i3 = i112;
 HEAP32[i3 >> 2] = i135;
 HEAP32[i3 + 4 >> 2] = i134;
 HEAP32[i140 + 20 >> 2] = 0;
 i3 = i140 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 i130 = i140 + 36 | 0;
 HEAP32[i130 >> 2] = 0;
 i131 = i140 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
 i132 = i129;
 i5 = HEAP32[i132 + 4 >> 2] | 0;
 i98 = i131;
 HEAP32[i98 >> 2] = HEAP32[i132 >> 2];
 HEAP32[i98 + 4 >> 2] = i5;
 i98 = i112;
 HEAP32[i98 >> 2] = i135;
 HEAP32[i98 + 4 >> 2] = i134;
 i98 = i140 + 40 | 0;
 HEAP32[i98 >> 2] = 0;
 i5 = i140 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 i132 = i140 + 56 | 0;
 HEAP32[i132 >> 2] = 0;
 i133 = i140 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
 i4 = i129;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i23 = i133;
 HEAP32[i23 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i23 + 4 >> 2] = i1;
 i23 = i112;
 HEAP32[i23 >> 2] = i135;
 HEAP32[i23 + 4 >> 2] = i134;
 HEAP32[i140 + 60 >> 2] = 0;
 i23 = i140 + 72 | 0;
 HEAP32[i23 >> 2] = 0;
 i134 = i140 + 76 | 0;
 HEAP32[i134 >> 2] = 0;
 i135 = i140 + 64 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
 i1 = i129;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i24 = i135;
 HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i24 + 4 >> 2] = i4;
 i24 = HEAP32[i95 >> 2] | 0;
 i4 = HEAP32[i123 + 36 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + (HEAP32[i94 >> 2] | 0) | 0;
 i2 = HEAP32[i138 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i138 >> 2] = i1;
  HEAP32[i140 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i140 >> 2] | 0, i1 * 12 | 0, 4, i139, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i128 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i139, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i128 | 0, HEAP32[i140 >> 2] | 0, (HEAP32[i20 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i138 >> 2] = i1;
  HEAP32[i140 >> 2] = i128;
  break;
 } while (0);
 i128 = i140 + 20 | 0;
 i1 = i4 << 2;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i130 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i130 >> 2] = i1;
  HEAP32[i128 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i128 >> 2] | 0, i4 << 3, 2, i131, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i127 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 2, i131, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i127 | 0, HEAP32[i128 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  HEAP32[i130 >> 2] = i1;
  HEAP32[i128 >> 2] = i127;
  break;
 } while (0);
 i127 = i140 + 40 | 0;
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[i132 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i132 >> 2] = i6;
  HEAP32[i127 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i127 >> 2] | 0, i6 * 24 | 0, 4, i133, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i114 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 24 | 0, 4, i133, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i114 | 0, HEAP32[i127 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i132 >> 2] = i6;
  HEAP32[i127 >> 2] = i114;
  break;
 } while (0);
 if ((i24 | 0) > 0) {
  i12 = i129 + 4 | 0;
  i13 = i129 + 8 | 0;
  i14 = i129 + 4 | 0;
  i15 = i129 + 8 | 0;
  f9 = Math_fround(HEAPF32[i115 >> 2]);
  f10 = Math_fround(HEAPF32[i116 >> 2]);
  f11 = Math_fround(HEAPF32[i117 >> 2]);
  i19 = 0;
  i8 = 0;
  i22 = 0;
  do {
   i7 = HEAP32[i127 >> 2] | 0;
   HEAP32[i7 + (i8 * 24 | 0) + 16 >> 2] = 0;
   HEAP32[i7 + (i8 * 24 | 0) + 20 >> 2] = 0;
   HEAP32[i7 + (i8 * 24 | 0) >> 2] = HEAP32[i20 >> 2];
   i2 = i105 + (i8 << 5) + 28 | 0;
   i114 = HEAP8[i2 >> 0] | 0;
   i3 = i119 + (i8 * 12 | 0) + 8 | 0;
   i1 = HEAP16[i3 >> 1] | 0;
   HEAP32[i7 + (i8 * 24 | 0) + 4 >> 2] = (i1 & 65535) + (i114 & 255);
   if (i114 << 24 >> 24) {
    i1 = 0;
    do {
     i114 = i96 + ((HEAPU16[i105 + (i8 << 5) + (i1 << 1) >> 1] | 0) * 3 << 2) | 0;
     f34 = Math_fround(HEAPF32[i114 >> 2]);
     f35 = Math_fround(HEAPF32[i114 + 4 >> 2]);
     f35 = Math_fround(f35 - f10);
     f36 = Math_fround(Math_fround(HEAPF32[i114 + 8 >> 2]) - f11);
     HEAPF32[i129 >> 2] = Math_fround(f34 - f9);
     HEAPF32[i14 >> 2] = f35;
     HEAPF32[i15 >> 2] = f36;
     __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i140, i129);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAPU8[i2 >> 0] | 0));
    i1 = HEAP16[i3 >> 1] | 0;
   }
   if (i1 << 16 >> 16) {
    i2 = i119 + (i8 * 12 | 0) | 0;
    i1 = 0;
    do {
     i114 = i120 + (((HEAP32[i2 >> 2] | 0) + i1 | 0) * 3 << 2) | 0;
     f34 = Math_fround(HEAPF32[i114 >> 2]);
     f35 = Math_fround(HEAPF32[i114 + 4 >> 2]);
     f35 = Math_fround(f35 - f10);
     f36 = Math_fround(Math_fround(HEAPF32[i114 + 8 >> 2]) - f11);
     HEAPF32[i129 >> 2] = Math_fround(f34 - f9);
     HEAPF32[i12 >> 2] = f35;
     HEAPF32[i13 >> 2] = f36;
     __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i140, i129);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAPU16[i3 >> 1] | 0));
   }
   i3 = HEAP32[i119 + (i8 * 12 | 0) + 4 >> 2] | 0;
   HEAP32[i7 + (i8 * 24 | 0) + 8 >> 2] = i3;
   i4 = i119 + (i8 * 12 | 0) + 10 | 0;
   i5 = HEAP16[i4 >> 1] | 0;
   i6 = i5 & 65535;
   HEAP32[i7 + (i8 * 24 | 0) + 12 >> 2] = i6;
   if (i5 << 16 >> 16) {
    i2 = HEAP32[i128 >> 2] | 0;
    i1 = 0;
    do {
     i114 = i1 + i3 << 2;
     i113 = i121 + (i114 << 1) | 0;
     HEAP16[i2 + (i114 << 1) >> 1] = HEAP16[i113 >> 1] | 0;
     HEAP16[i2 + ((i114 | 1) << 1) >> 1] = HEAP16[i113 + 2 >> 1] | 0;
     HEAP16[i2 + ((i114 | 2) << 1) >> 1] = HEAP16[i113 + 4 >> 1] | 0;
     HEAP16[i2 + ((i114 | 3) << 1) >> 1] = HEAP16[i113 + 6 >> 1] | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAPU16[i4 >> 1] | 0));
   }
   i114 = (i5 & 65535) > 6;
   i22 = i114 & (i22 | 0) < (i6 | 0) ? i6 : i22;
   i19 = (i114 ? i6 : 0) + i19 | 0;
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i24 | 0));
  if ((i19 | 0) > 0) {
   i21 = i140 + 60 | 0;
   i1 = i19 << 1;
   i2 = HEAP32[i134 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i134 >> 2] = i1;
    HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i19 * 56 | 0, 4, i135, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i114 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19 * 56 | 0, 4, i135, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i114 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i23 >> 2] | 0) * 28 | 0) | 0;
    HEAP32[i134 >> 2] = i1;
    HEAP32[i21 >> 2] = i114;
    break;
   } while (0);
   i20 = gb + 64016 | 0;
   i19 = HEAP32[i20 + 4 >> 2] | 0;
   i15 = i112;
   HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i15 + 4 >> 2] = i19;
   HEAP32[i122 >> 2] = 0;
   i15 = i122 + 12 | 0;
   HEAP32[i15 >> 2] = 0;
   i19 = i122 + 16 | 0;
   HEAP32[i19 >> 2] = 0;
   i20 = i122 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i111 = i129;
   i113 = HEAP32[i111 + 4 >> 2] | 0;
   i114 = i20;
   HEAP32[i114 >> 2] = HEAP32[i111 >> 2];
   HEAP32[i114 + 4 >> 2] = i113;
   if (!i22) i8 = i122; else {
    HEAP32[i19 >> 2] = i22;
    HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i22 * 28 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
    i8 = i122;
   }
   i12 = i118 + 12 | 0;
   i13 = i118 + 16 | 0;
   i14 = i118 + 4 | 0;
   i7 = 0;
   do {
    i6 = HEAP32[i127 >> 2] | 0;
    i3 = HEAP32[i6 + (i7 * 24 | 0) + 12 >> 2] | 0;
    if ((i3 | 0) > 6) {
     i4 = (HEAP32[i140 >> 2] | 0) + ((HEAP32[i6 + (i7 * 24 | 0) >> 2] | 0) * 12 | 0) | 0;
     i5 = (HEAP32[i128 >> 2] | 0) + (HEAP32[i6 + (i7 * 24 | 0) + 8 >> 2] << 2 << 1) | 0;
     if ((HEAP32[i19 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i20);
      HEAP32[i122 >> 2] = 0;
     }
     HEAP32[i122 >> 2] = 0;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i19 >> 2] = 0;
     i2 = gb + 64016 | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     i114 = i112;
     HEAP32[i114 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i114 + 4 >> 2] = i1;
     HEAP32[i118 >> 2] = 0;
     HEAP32[i13 >> 2] = 0;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
     i114 = i129;
     i1 = HEAP32[i114 + 4 >> 2] | 0;
     i2 = i14;
     HEAP32[i2 >> 2] = HEAP32[i114 >> 2];
     HEAP32[i2 + 4 >> 2] = i1;
     HEAP32[i12 >> 2] = i3;
     HEAP32[i13 >> 2] = i3;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i3 * 28 | 0, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i118 >> 2] = i2;
     i1 = 0;
     while (1) {
      i84 = i5 + (i1 << 2 << 1) | 0;
      i81 = i2 + (i1 * 28 | 0) | 0;
      HEAP32[i2 + (i1 * 28 | 0) + 24 >> 2] = i1;
      i113 = i2 + (i1 * 28 | 0) + 12 | 0;
      i111 = i4 + ((HEAPU16[i84 >> 1] | 0) * 12 | 0) | 0;
      HEAP32[i113 >> 2] = HEAP32[i111 >> 2];
      HEAP32[i113 + 4 >> 2] = HEAP32[i111 + 4 >> 2];
      HEAP32[i113 + 8 >> 2] = HEAP32[i111 + 8 >> 2];
      _memmove(i81 | 0, i111 | 0, 12) | 0;
      i111 = i84 + 2 | 0;
      i114 = HEAPU16[i111 >> 1] | 0;
      f11 = Math_fround(HEAPF32[i81 >> 2]);
      f35 = Math_fround(HEAPF32[i4 + (i114 * 12 | 0) >> 2]);
      f11 = f35 < f11 ? f35 : f11;
      i82 = i2 + (i1 * 28 | 0) + 4 | 0;
      f35 = Math_fround(HEAPF32[i82 >> 2]);
      f17 = Math_fround(HEAPF32[i4 + (i114 * 12 | 0) + 4 >> 2]);
      f35 = f17 < f35 ? f17 : f35;
      i83 = i2 + (i1 * 28 | 0) + 8 | 0;
      f17 = Math_fround(HEAPF32[i83 >> 2]);
      f18 = Math_fround(HEAPF32[i4 + (i114 * 12 | 0) + 8 >> 2]);
      f17 = f18 < f17 ? f18 : f17;
      HEAPF32[i81 >> 2] = f11;
      HEAPF32[i82 >> 2] = f35;
      HEAPF32[i83 >> 2] = f17;
      i111 = HEAPU16[i111 >> 1] | 0;
      f18 = Math_fround(HEAPF32[i113 >> 2]);
      f34 = Math_fround(HEAPF32[i4 + (i111 * 12 | 0) >> 2]);
      f18 = f18 < f34 ? f34 : f18;
      i113 = i2 + (i1 * 28 | 0) + 16 | 0;
      f34 = Math_fround(HEAPF32[i113 >> 2]);
      f36 = Math_fround(HEAPF32[i4 + (i111 * 12 | 0) + 4 >> 2]);
      f34 = f34 < f36 ? f36 : f34;
      i114 = i2 + (i1 * 28 | 0) + 20 | 0;
      f36 = Math_fround(HEAPF32[i114 >> 2]);
      f10 = Math_fround(HEAPF32[i4 + (i111 * 12 | 0) + 8 >> 2]);
      f36 = f36 < f10 ? f10 : f36;
      i111 = i2 + (i1 * 28 | 0) + 12 | 0;
      HEAPF32[i111 >> 2] = f18;
      HEAPF32[i113 >> 2] = f34;
      HEAPF32[i114 >> 2] = f36;
      i84 = i84 + 4 | 0;
      i80 = HEAPU16[i84 >> 1] | 0;
      f10 = Math_fround(HEAPF32[i4 + (i80 * 12 | 0) >> 2]);
      f16 = Math_fround(HEAPF32[i4 + (i80 * 12 | 0) + 4 >> 2]);
      f33 = Math_fround(HEAPF32[i4 + (i80 * 12 | 0) + 8 >> 2]);
      HEAPF32[i81 >> 2] = f10 < f11 ? f10 : f11;
      HEAPF32[i82 >> 2] = f16 < f35 ? f16 : f35;
      HEAPF32[i83 >> 2] = f33 < f17 ? f33 : f17;
      i84 = HEAPU16[i84 >> 1] | 0;
      f17 = Math_fround(HEAPF32[i4 + (i84 * 12 | 0) >> 2]);
      f33 = Math_fround(HEAPF32[i4 + (i84 * 12 | 0) + 4 >> 2]);
      f35 = Math_fround(HEAPF32[i4 + (i84 * 12 | 0) + 8 >> 2]);
      HEAPF32[i111 >> 2] = f18 < f17 ? f17 : f18;
      HEAPF32[i113 >> 2] = f34 < f33 ? f33 : f34;
      HEAPF32[i114 >> 2] = f36 < f35 ? f35 : f36;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i3 | 0)) break;
      i2 = HEAP32[i118 >> 2] | 0;
     }
     __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii(i122, i118, 0, i3);
     if ((HEAP32[i13 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i14);
      HEAP32[i118 >> 2] = 0;
     }
     i3 = HEAP32[i15 >> 2] | 0;
     if ((i3 | 0) > 0) {
      i1 = HEAP32[i23 >> 2] | 0;
      i4 = i6 + (i7 * 24 | 0) + 16 | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i6 + (i7 * 24 | 0) + 20 >> 2] = i3;
      i1 = i1 + i3 | 0;
      HEAP32[i23 >> 2] = i1;
      i2 = HEAP32[i134 >> 2] | 0;
      do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
       HEAP32[i134 >> 2] = i1;
       HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1 * 28 | 0, 4, i135, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i114 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i135, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i114 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i23 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i134 >> 2] = i1;
       HEAP32[i21 >> 2] = i114;
       break;
      } while (0);
      i2 = HEAP32[i122 >> 2] | 0;
      i1 = 0;
      do {
       i114 = (HEAP32[i21 >> 2] | 0) + (((HEAP32[i4 >> 2] | 0) + i1 | 0) * 28 | 0) | 0;
       i113 = i2 + (i1 * 28 | 0) | 0;
       HEAP32[i114 >> 2] = HEAP32[i113 >> 2];
       HEAP32[i114 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
       HEAP32[i114 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
       HEAP32[i114 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
       HEAP32[i114 + 16 >> 2] = HEAP32[i113 + 16 >> 2];
       HEAP32[i114 + 20 >> 2] = HEAP32[i113 + 20 >> 2];
       HEAP32[i114 + 24 >> 2] = HEAP32[i113 + 24 >> 2];
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i24 | 0));
   if ((HEAP32[i19 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i20);
    HEAP32[i122 >> 2] = 0;
   }
  }
 }
 __Z12profiler_endP19ProfilerInformation(gb + 1459140 | 0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i129 >> 2] = HEAP32[i25 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459116 | 0, i129);
 i114 = gb + 64016 | 0;
 i113 = HEAP32[i114 + 4 >> 2] | 0;
 i1 = i112;
 HEAP32[i1 >> 2] = HEAP32[i114 >> 2];
 HEAP32[i1 + 4 >> 2] = i113;
 HEAP32[i136 >> 2] = 0;
 i1 = i136 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i113 = i136 + 16 | 0;
 HEAP32[i113 >> 2] = 0;
 i114 = i136 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
 i84 = i129;
 i111 = HEAP32[i84 + 4 >> 2] | 0;
 i2 = i114;
 HEAP32[i2 >> 2] = HEAP32[i84 >> 2];
 HEAP32[i2 + 4 >> 2] = i111;
 i2 = HEAP32[i113 >> 2] | 0;
 do if ((i2 & 2147483616) >>> 0 < 32) if ((i2 | 0) > -1) {
  HEAP32[i113 >> 2] = 32;
  HEAP32[i136 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i136 >> 2] | 0, 512, 4, i114, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i111 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(512, 4, i114, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i111 | 0, HEAP32[i136 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
  HEAP32[i113 >> 2] = 32;
  HEAP32[i136 >> 2] = i111;
  break;
 } while (0);
 HEAP32[i137 >> 2] = 0;
 i111 = i137 + 4 | 0;
 HEAP32[i111 >> 2] = 0;
 HEAP32[i137 + 8 >> 2] = 0;
 HEAP32[i137 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i22 = i85 + 4 | 0;
 i23 = i85 + 8 | 0;
 i24 = i85 + 12 | 0;
 i25 = i85 + 16 | 0;
 i26 = i85 + 20 | 0;
 f33 = Math_fround(f92 * Math_fround(-1.41499996));
 f34 = Math_fround(f38 * Math_fround(1.41499996));
 f35 = Math_fround(f92 * Math_fround(1.41499996));
 i27 = i86 + 4 | 0;
 i28 = i86 + 8 | 0;
 i29 = i86 + 12 | 0;
 i30 = i118 + 12 | 0;
 i31 = i118 + 16 | 0;
 i32 = i118 + 4 | 0;
 i37 = i122 + 12 | 0;
 i39 = i122 + 16 | 0;
 i40 = i122 + 4 | 0;
 i41 = i102 + 12 | 0;
 i42 = i102 + 16 | 0;
 i43 = i102 + 4 | 0;
 i44 = i103 + 4 | 0;
 i45 = i103 + 8 | 0;
 i46 = i103 + 20 | 0;
 i47 = i103 + 24 | 0;
 i48 = i103 + 12 | 0;
 i84 = i103 + 28 | 0;
 i49 = i99 + 12 | 0;
 i50 = i99 + 16 | 0;
 i51 = i99 + 4 | 0;
 i19 = i129 + 12 | 0;
 i20 = i129 + 16 | 0;
 i21 = i129 + 20 | 0;
 i52 = i129 + 12 | 0;
 i53 = i129 + 4 | 0;
 i54 = i129 + 8 | 0;
 i55 = i100 + 12 | 0;
 i56 = i100 + 16 | 0;
 i57 = i100 + 4 | 0;
 i58 = i101 + 12 | 0;
 i59 = i101 + 16 | 0;
 i60 = i101 + 4 | 0;
 i61 = i101 + 20 | 0;
 i62 = i101 + 32 | 0;
 i63 = i101 + 36 | 0;
 i64 = i101 + 24 | 0;
 i65 = i86 + 8 | 0;
 i66 = i101 + 20 | 0;
 i67 = i103 + 8 | 0;
 i68 = i86 + 12 | 0;
 i69 = i129 + 4 | 0;
 i70 = i101 + 12 | 0;
 i71 = i101 + 16 | 0;
 i72 = i101 + 4 | 0;
 i73 = i126 + 12 | 0;
 i74 = i126 + 16 | 0;
 i75 = i126 + 4 | 0;
 i76 = i125 + 12 | 0;
 i77 = i125 + 16 | 0;
 i78 = i125 + 4 | 0;
 f36 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i79 = i129 + 4 | 0;
 i80 = i129 + 8 | 0;
 i81 = i129 + 12 | 0;
 i82 = i129 + 16 | 0;
 i83 = i129 + 20 | 0;
 i15 = 0;
 do {
  i1 = i91 + (i15 * 88 | 0) | 0;
  switch (HEAP32[i1 >> 2] | 0) {
  case 0:
   {
    if (__ZL20CalculateCapsuleHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i136, i1, i115, f38, f92) | 0) i110 = 74;
    break;
   }
  case 1:
   {
    if (__ZL16CalculateBoxHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i136, i1, i115, f38, f92) | 0) i110 = 74;
    break;
   }
  default:
   {}
  }
  if ((i110 | 0) == 74) {
   i110 = 0;
   f9 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 64 >> 2]);
   f10 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 68 >> 2]);
   f11 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 72 >> 2]);
   f144 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 76 >> 2]);
   f143 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 80 >> 2]);
   f142 = Math_fround(HEAPF32[i91 + (i15 * 88 | 0) + 84 >> 2]);
   f16 = Math_fround(HEAPF32[i115 >> 2]);
   f9 = Math_fround(f9 - f16);
   f17 = Math_fround(HEAPF32[i116 >> 2]);
   f10 = Math_fround(f10 - f17);
   f18 = Math_fround(HEAPF32[i117 >> 2]);
   f11 = Math_fround(f11 - f18);
   f16 = Math_fround(f144 - f16);
   f17 = Math_fround(f143 - f17);
   f18 = Math_fround(f142 - f18);
   HEAPF32[i85 >> 2] = Math_fround(f33 + f9);
   HEAPF32[i22 >> 2] = Math_fround(f10 - f34);
   HEAPF32[i23 >> 2] = Math_fround(f33 + f11);
   HEAPF32[i24 >> 2] = Math_fround(f35 + f16);
   HEAPF32[i25 >> 2] = Math_fround(f17 + Math_fround(0.0));
   HEAPF32[i26 >> 2] = Math_fround(f35 + f18);
   HEAP32[i86 >> 2] = 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i29 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i14 = HEAP32[i95 >> 2] | 0;
   i1 = gb + 64016 | 0;
   i13 = HEAP32[i1 + 4 >> 2] | 0;
   i12 = i112;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP32[i118 >> 2] = 0;
   HEAP32[i30 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i12 = i129;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i32;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = gb + 64016 | 0;
   i13 = HEAP32[i1 + 4 >> 2] | 0;
   i12 = i112;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP32[i122 >> 2] = 0;
   HEAP32[i37 >> 2] = 0;
   HEAP32[i39 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i12 = i129;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i40;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = gb + 64016 | 0;
   i13 = HEAP32[i1 + 4 >> 2] | 0;
   i12 = i112;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP32[i102 >> 2] = 0;
   HEAP32[i41 >> 2] = 0;
   HEAP32[i42 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i12 = i129;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i43;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i13;
   HEAP32[i31 >> 2] = 32;
   HEAP32[i118 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 384, 4, i32, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i39 >> 2] | 0;
   do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
    HEAP32[i39 >> 2] = 32;
    HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i122 >> 2] | 0, 384, 4, i40, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i40, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i122 >> 2] | 0, (HEAP32[i37 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i39 >> 2] = 32;
    HEAP32[i122 >> 2] = i13;
    break;
   } while (0);
   i1 = HEAP32[i42 >> 2] | 0;
   do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
    HEAP32[i42 >> 2] = 32;
    HEAP32[i102 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i102 >> 2] | 0, 384, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i102 >> 2] | 0, (HEAP32[i41 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i42 >> 2] = 32;
    HEAP32[i102 >> 2] = i13;
    break;
   } while (0);
   i1 = gb + 64016 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAPF32[i103 >> 2] = Math_fround(.00999999977);
   HEAP32[i44 >> 2] = i102;
   i13 = i112;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 4 >> 2] = i1;
   HEAP32[i45 >> 2] = 0;
   HEAP32[i46 >> 2] = 0;
   HEAP32[i47 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i13 = i129;
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   i2 = i48;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   _memset(i84 | 0, -1, 256) | 0;
   i2 = gb + 64016 | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = i112;
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = i1;
   HEAP32[i99 >> 2] = 0;
   HEAP32[i49 >> 2] = 0;
   HEAP32[i50 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i13 = i129;
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   i2 = i51;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   i2 = HEAP32[i49 >> 2] | 0;
   HEAP32[i49 >> 2] = i14;
   i1 = HEAP32[i50 >> 2] | 0;
   do if ((i1 & 2147483647) >>> 0 < i14 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i50 >> 2] = i14;
    HEAP32[i99 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i99 >> 2] | 0, i14, 1, i51, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 1, i51, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i99 >> 2] | 0, HEAP32[i49 >> 2] | 0) | 0;
    HEAP32[i50 >> 2] = i14;
    HEAP32[i99 >> 2] = i13;
    break;
   } while (0);
   if (i14 >>> 0 > i2 >>> 0) {
    i1 = i14 - i2 | 0;
    if (i1 | 0) _memset((HEAP32[i99 >> 2] | 0) + i2 | 0, 0, i1 | 0) | 0;
   }
   i7 = (i14 | 0) > 0;
   if (i7) {
    i1 = 0;
    i6 = 0;
    do {
     HEAP32[i129 >> 2] = HEAP32[gb + 62500 >> 2];
     HEAP32[i129 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
     HEAP32[i129 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
     f142 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
     f143 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
     f144 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
     HEAPF32[i19 >> 2] = f142;
     HEAPF32[i20 >> 2] = f143;
     HEAPF32[i21 >> 2] = f144;
     i5 = HEAP32[i98 >> 2] | 0;
     i2 = i5 + (i6 * 24 | 0) | 0;
     i4 = HEAP32[i140 >> 2] | 0;
     i13 = i4 + ((HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i52 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i52 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i52 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     _memmove(i129 | 0, i13 | 0, 12) | 0;
     i5 = i5 + (i6 * 24 | 0) + 4 | 0;
     if ((HEAP32[i5 >> 2] | 0) > 1) {
      i3 = HEAP32[i2 >> 2] | 0;
      f9 = Math_fround(HEAPF32[i129 >> 2]);
      f10 = Math_fround(HEAPF32[i53 >> 2]);
      f11 = Math_fround(HEAPF32[i54 >> 2]);
      f16 = Math_fround(HEAPF32[i19 >> 2]);
      f17 = Math_fround(HEAPF32[i20 >> 2]);
      i2 = 1;
      f18 = Math_fround(HEAPF32[i21 >> 2]);
      do {
       i13 = i2 + i3 | 0;
       i8 = i4 + (i13 * 12 | 0) | 0;
       f144 = Math_fround(HEAPF32[i8 >> 2]);
       f9 = f144 < f9 ? f144 : f9;
       i12 = i4 + (i13 * 12 | 0) + 4 | 0;
       f144 = Math_fround(HEAPF32[i12 >> 2]);
       f10 = f144 < f10 ? f144 : f10;
       i13 = i4 + (i13 * 12 | 0) + 8 | 0;
       f144 = Math_fround(HEAPF32[i13 >> 2]);
       f11 = f144 < f11 ? f144 : f11;
       HEAPF32[i129 >> 2] = f9;
       HEAPF32[i53 >> 2] = f10;
       HEAPF32[i54 >> 2] = f11;
       f144 = Math_fround(HEAPF32[i8 >> 2]);
       f16 = f16 < f144 ? f144 : f16;
       f144 = Math_fround(HEAPF32[i12 >> 2]);
       f17 = f17 < f144 ? f144 : f17;
       f144 = Math_fround(HEAPF32[i13 >> 2]);
       f18 = f18 < f144 ? f144 : f18;
       HEAPF32[i19 >> 2] = f16;
       HEAPF32[i20 >> 2] = f17;
       HEAPF32[i21 >> 2] = f18;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (HEAP32[i5 >> 2] | 0));
     }
     if (__Z17IntersectAABBAABBRK10MinMaxAABBS1_(i85, i129) | 0) {
      HEAP8[(HEAP32[i99 >> 2] | 0) + i6 >> 0] = 1;
      i1 = i1 + 1 | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i14 | 0));
   } else i1 = 0;
   i13 = gb + 64016 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = i112;
   HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i8 + 4 >> 2] = i12;
   HEAP32[i100 >> 2] = 0;
   HEAP32[i55 >> 2] = 0;
   HEAP32[i56 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i8 = i129;
   i12 = HEAP32[i8 + 4 >> 2] | 0;
   i13 = i57;
   HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj(i86, i1);
   if (i7) {
    i13 = 0;
    do {
     if ((HEAP8[(HEAP32[i99 >> 2] | 0) + i13 >> 0] | 0) == 1) {
      i2 = gb + 64016 | 0;
      i12 = HEAP32[i2 + 4 >> 2] | 0;
      i8 = i112;
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i8 + 4 >> 2] = i12;
      HEAP32[i101 >> 2] = 0;
      HEAP32[i58 >> 2] = 0;
      HEAP32[i59 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
      i8 = i129;
      i12 = HEAP32[i8 + 4 >> 2] | 0;
      i2 = i60;
      HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i2 + 4 >> 2] = i12;
      i2 = gb + 64016 | 0;
      i12 = HEAP32[i2 + 4 >> 2] | 0;
      i8 = i112;
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i8 + 4 >> 2] = i12;
      HEAP32[i61 >> 2] = 0;
      HEAP32[i62 >> 2] = 0;
      HEAP32[i63 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
      i8 = i129;
      i12 = HEAP32[i8 + 4 >> 2] | 0;
      i2 = i64;
      HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i2 + 4 >> 2] = i12;
      HEAP32[i55 >> 2] = 0;
      i2 = HEAP32[i56 >> 2] | 0;
      do if (!(i2 & 2147483647)) {
       i1 = i2 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if ((i2 | 0) > -1) {
        HEAP32[i56 >> 2] = i1;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i100 >> 2] | 0, i1 << 2, 4, i57, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i100 >> 2] = i2;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i57, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i100 >> 2] | 0, HEAP32[i55 >> 2] << 2 | 0) | 0;
        HEAP32[i56 >> 2] = i1;
        HEAP32[i100 >> 2] = i2;
        break;
       }
      } else i2 = HEAP32[i100 >> 2] | 0; while (0);
      HEAP32[i55 >> 2] = 1;
      HEAP32[i2 >> 2] = i13;
      i1 = HEAP32[i55 >> 2] | 0;
      L147 : do if (i1 | 0) while (1) {
       i3 = i1 + -1 | 0;
       i12 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
       HEAP32[i55 >> 2] = i3;
       i2 = HEAP32[i62 >> 2] | 0;
       i3 = i2 + 1 | 0;
       i4 = HEAP32[i63 >> 2] | 0;
       i5 = i4 & 2147483647;
       do if (i3 >>> 0 > i5 >>> 0) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i63 >> 2] = i1;
         HEAP32[i66 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i66 >> 2] | 0, i1 << 2, 4, i64, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i64, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i66 >> 2] | 0, HEAP32[i62 >> 2] << 2 | 0) | 0;
         HEAP32[i63 >> 2] = i1;
         HEAP32[i66 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i62 >> 2] = i3;
       HEAP32[(HEAP32[i66 >> 2] | 0) + (i2 << 2) >> 2] = i12;
       i8 = i105 + (i12 << 5) + 28 | 0;
       i1 = HEAP8[i8 >> 0] | 0;
       if (i1 << 24 >> 24) {
        i7 = 0;
        do {
         i2 = HEAP16[i105 + (i12 << 5) + 12 + (i7 << 1) >> 1] | 0;
         do if (i2 << 16 >> 16 >= 1) {
          i6 = (i2 & 65535) + -1 | 0;
          i2 = (HEAP32[i99 >> 2] | 0) + i6 | 0;
          if ((HEAP8[i2 >> 0] | 0) != 1) break;
          HEAP8[i2 >> 0] = 2;
          i2 = HEAP32[i55 >> 2] | 0;
          i3 = i2 + 1 | 0;
          i4 = HEAP32[i56 >> 2] | 0;
          i5 = i4 & 2147483647;
          do if (i3 >>> 0 > i5 >>> 0) {
           i1 = i4 << 1;
           i1 = (i1 | 0) == 0 ? 1 : i1;
           if (i5 >>> 0 >= i1 >>> 0) break;
           if ((i4 | 0) > -1) {
            HEAP32[i56 >> 2] = i1;
            HEAP32[i100 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i100 >> 2] | 0, i1 << 2, 4, i57, 0, gb + 1047584 | 0, 464) | 0;
            break;
           } else {
            i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i57, 0, gb + 1047584 | 0, 446) | 0;
            _memcpy(i5 | 0, HEAP32[i100 >> 2] | 0, HEAP32[i55 >> 2] << 2 | 0) | 0;
            HEAP32[i56 >> 2] = i1;
            HEAP32[i100 >> 2] = i5;
            break;
           }
          } while (0);
          HEAP32[i55 >> 2] = i3;
          HEAP32[(HEAP32[i100 >> 2] | 0) + (i2 << 2) >> 2] = i6;
          i1 = HEAP8[i8 >> 0] | 0;
         } while (0);
         i7 = i7 + 1 | 0;
        } while ((i7 | 0) < (i1 & 255 | 0));
       }
       i1 = HEAP32[i55 >> 2] | 0;
       if (!i1) break L147;
       i2 = HEAP32[i100 >> 2] | 0;
      } while (0);
      i1 = HEAP32[i27 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i65 >> 2] | 0)) __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i86, i101); else {
       __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i1, i101);
       __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i1 + 20 | 0, i66);
       HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + 40;
      }
      if ((HEAP32[i63 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i66 >> 2] | 0, i64);
       HEAP32[i66 >> 2] = 0;
      }
      if ((HEAP32[i59 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i101 >> 2] | 0, i60);
       HEAP32[i101 >> 2] = 0;
      }
     }
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != (i14 | 0));
   }
   if ((HEAP32[i86 >> 2] | 0) == (HEAP32[i27 >> 2] | 0)) i1 = 0; else {
    i1 = gb + 64016 | 0;
    i14 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = i112;
    HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i13 + 4 >> 2] = i14;
    HEAP32[i101 >> 2] = 0;
    HEAP32[i70 >> 2] = 0;
    HEAP32[i71 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
    i13 = i129;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i1 = i72;
    HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    i1 = gb + 64016 | 0;
    i14 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = i112;
    HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i13 + 4 >> 2] = i14;
    HEAP32[i126 >> 2] = 0;
    HEAP32[i73 >> 2] = 0;
    HEAP32[i74 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
    i13 = i129;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i1 = i75;
    HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    i1 = gb + 64016 | 0;
    i14 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = i112;
    HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i13 + 4 >> 2] = i14;
    HEAP32[i125 >> 2] = 0;
    HEAP32[i76 >> 2] = 0;
    HEAP32[i77 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
    i13 = i129;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i1 = i78;
    HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    i1 = HEAP32[i71 >> 2] | 0;
    do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
     HEAP32[i71 >> 2] = 32;
     HEAP32[i101 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i101 >> 2] | 0, 256, 4, i72, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i72, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i14 | 0, HEAP32[i101 >> 2] | 0, HEAP32[i70 >> 2] << 3 | 0) | 0;
     HEAP32[i71 >> 2] = 32;
     HEAP32[i101 >> 2] = i14;
     break;
    } while (0);
    i1 = HEAP32[i74 >> 2] | 0;
    do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
     HEAP32[i74 >> 2] = 32;
     HEAP32[i126 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i126 >> 2] | 0, 256, 4, i75, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i75, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i14 | 0, HEAP32[i126 >> 2] | 0, HEAP32[i73 >> 2] << 3 | 0) | 0;
     HEAP32[i74 >> 2] = 32;
     HEAP32[i126 >> 2] = i14;
     break;
    } while (0);
    i1 = HEAP32[i77 >> 2] | 0;
    do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
     HEAP32[i77 >> 2] = 32;
     HEAP32[i125 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i125 >> 2] | 0, 256, 4, i78, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i78, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i14 | 0, HEAP32[i125 >> 2] | 0, HEAP32[i76 >> 2] << 3 | 0) | 0;
     HEAP32[i77 >> 2] = 32;
     HEAP32[i125 >> 2] = i14;
     break;
    } while (0);
    i2 = HEAP32[i86 >> 2] | 0;
    i14 = (HEAP32[i27 >> 2] | 0) - i2 | 0;
    i13 = (i14 | 0) / 40 | 0;
    L206 : do if ((i14 | 0) > 0) {
     i1 = 0;
     while (1) {
      HEAP32[i41 >> 2] = 0;
      _memset(i84 | 0, -1, 256) | 0;
      HEAP32[i129 >> 2] = 0;
      __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i67, 0, i129, 1);
      i6 = i2 + (i1 * 40 | 0) + 20 | 0;
      i5 = i2 + (i1 * 40 | 0) + 32 | 0;
      if (HEAP32[i5 >> 2] | 0) {
       i3 = 0;
       do {
        i4 = (HEAP32[i98 >> 2] | 0) + ((HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0) * 24 | 0) | 0;
        HEAP32[i129 >> 2] = gb + 169980 + 8;
        HEAP32[i79 >> 2] = i136;
        HEAP32[i80 >> 2] = i103;
        HEAP32[i81 >> 2] = i118;
        HEAP32[i82 >> 2] = i122;
        HEAP8[i83 >> 0] = 0;
        __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback(i140, i4, i85, i24, i129);
        i4 = HEAP32[i5 >> 2] | 0;
        if (!(HEAP8[i83 >> 0] | 0)) {
         i14 = HEAP32[i6 >> 2] | 0;
         HEAP32[i14 + (i3 << 2) >> 2] = HEAP32[i14 + (i4 + -1 << 2) >> 2];
         i4 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
         HEAP32[i5 >> 2] = i4;
         i3 = i3 + -1 | 0;
        }
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i4 >>> 0);
      }
      i3 = HEAP32[i41 >> 2] | 0;
      do if (!i3) {
       HEAP32[i129 >> 2] = 0;
       __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i6, 0, i129, 1);
      } else {
       HEAP32[i70 >> 2] = i3;
       i4 = HEAP32[i71 >> 2] | 0;
       do if ((i4 & 2147483647) >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i71 >> 2] = i3;
        HEAP32[i101 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i101 >> 2] | 0, i3 << 3, 4, i72, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i72, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i14 | 0, HEAP32[i101 >> 2] | 0, HEAP32[i70 >> 2] << 3 | 0) | 0;
        HEAP32[i71 >> 2] = i3;
        HEAP32[i101 >> 2] = i14;
        break;
       } while (0);
       if (HEAP32[i41 >> 2] | 0) {
        i3 = 0;
        do {
         i14 = HEAP32[i101 >> 2] | 0;
         i8 = HEAP32[i102 >> 2] | 0;
         i12 = HEAP32[i8 + (i3 * 12 | 0) + 8 >> 2] | 0;
         HEAP32[i14 + (i3 << 3) >> 2] = HEAP32[i8 + (i3 * 12 | 0) >> 2];
         HEAP32[i14 + (i3 << 3) + 4 >> 2] = i12;
         i3 = i3 + 1 | 0;
        } while (i3 >>> 0 < (HEAP32[i41 >> 2] | 0) >>> 0);
       }
       __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i126, i101);
       __ZL16SimplifyPolylineR13dynamic_arrayI8Vector2fLj4EEf(i126, Math_fround(.00999999977));
       i3 = HEAP32[i73 >> 2] | 0;
       if (i3 >>> 0 < 3) {
        HEAP32[i129 >> 2] = 0;
        __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i6, 0, i129, 1);
        break;
       }
       i6 = HEAP32[i126 >> 2] | 0;
       i3 = i3 << 3;
       i4 = i3 >> 3;
       HEAP32[i76 >> 2] = i4;
       i5 = HEAP32[i77 >> 2] | 0;
       do if ((i5 & 2147483647) >>> 0 < i4 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i77 >> 2] = i4;
        i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i125 >> 2] | 0, i3, 4, i78, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i125 >> 2] = i3;
        break;
       } else {
        i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i78, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i3 | 0, HEAP32[i125 >> 2] | 0, HEAP32[i76 >> 2] << 3 | 0) | 0;
        HEAP32[i77 >> 2] = i4;
        HEAP32[i125 >> 2] = i3;
        break;
       } else i3 = HEAP32[i125 >> 2] | 0; while (0);
       _memcpy(i3 | 0, i6 | 0, HEAP32[i76 >> 2] << 3 | 0) | 0;
       i12 = i2 + (i1 * 40 | 0) | 0;
       i3 = HEAP32[i76 >> 2] | 0;
       i4 = i2 + (i1 * 40 | 0) + 12 | 0;
       HEAP32[i4 >> 2] = i3;
       i5 = i2 + (i1 * 40 | 0) + 16 | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       do if ((i6 & 2147483647) >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i5 >> 2] = i3;
        HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i3 << 4, 4, i2 + (i1 * 40 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i2 + (i1 * 40 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i14 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] << 4 | 0) | 0;
        HEAP32[i5 >> 2] = i3;
        HEAP32[i12 >> 2] = i14;
        break;
       } while (0);
       i7 = HEAP32[i76 >> 2] | 0;
       if ((i7 | 0) <= 0) break;
       i5 = 0;
       do {
        i4 = HEAP32[i125 >> 2] | 0;
        f16 = Math_fround(HEAPF32[i4 + (i5 << 3) >> 2]);
        f17 = Math_fround(HEAPF32[i4 + (i5 << 3) + 4 >> 2]);
        i6 = i5;
        i5 = i5 + 1 | 0;
        i8 = (i5 | 0) == (i7 | 0);
        i14 = i8 ? 0 : i5;
        f9 = Math_fround(Math_fround(HEAPF32[i4 + (i14 << 3) >> 2]) - f16);
        f10 = Math_fround(Math_fround(HEAPF32[i4 + (i14 << 3) + 4 >> 2]) - f17);
        f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)))));
        if (f11 > f36) {
         f144 = Math_fround(Math_fround(-f10) / f11);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
         f144 = Math_fround(Math_fround(0.0) / f11);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
         f144 = Math_fround(f9 / f11);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i2 = HEAP32[gb + 1162364 >> 2] | 0;
         i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
         i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
        }
        i14 = HEAP32[i12 >> 2] | 0;
        HEAP32[i14 + (i6 << 4) >> 2] = i2;
        HEAP32[i14 + (i6 << 4) + 4 >> 2] = i3;
        HEAP32[i14 + (i6 << 4) + 8 >> 2] = i4;
        f144 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
        f144 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0)) + f144);
        HEAPF32[i14 + (i6 << 4) + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f144));
       } while (!i8);
      } while (0);
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= (i13 | 0)) break L206;
      i2 = HEAP32[i86 >> 2] | 0;
     }
    } while (0);
    if ((HEAP32[i77 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i125 >> 2] | 0, i78);
     HEAP32[i125 >> 2] = 0;
    }
    if ((HEAP32[i74 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i126 >> 2] | 0, i75);
     HEAP32[i126 >> 2] = 0;
    }
    if ((HEAP32[i71 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i101 >> 2] | 0, i72);
     HEAP32[i101 >> 2] = 0;
    }
    i1 = 1;
   }
   if ((HEAP32[i56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i100 >> 2] | 0, i57);
    HEAP32[i100 >> 2] = 0;
   }
   if ((HEAP32[i50 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i99 >> 2] | 0, i51);
    HEAP32[i99 >> 2] = 0;
   }
   if ((HEAP32[i47 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i67 >> 2] | 0, i48);
    HEAP32[i67 >> 2] = 0;
   }
   if ((HEAP32[i42 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i102 >> 2] | 0, i43);
    HEAP32[i102 >> 2] = 0;
   }
   if ((HEAP32[i39 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i122 >> 2] | 0, i40);
    HEAP32[i122 >> 2] = 0;
   }
   if ((HEAP32[i31 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i32);
    HEAP32[i118 >> 2] = 0;
   }
   if (i1) {
    HEAP32[i87 >> 2] = HEAP32[i111 >> 2];
    HEAP32[i88 >> 2] = HEAP32[i86 >> 2];
    HEAP32[i89 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i118 >> 2] = HEAP32[i87 >> 2];
    HEAP32[i112 >> 2] = HEAP32[i88 >> 2];
    HEAP32[i129 >> 2] = HEAP32[i89 >> 2];
    __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6insertINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueESA_E4typeENS8_IPKS2_EESC_SC_(i137, i118, i112, i129) | 0;
   }
   i1 = HEAP32[i86 >> 2] | 0;
   if (i1 | 0) {
    i2 = HEAP32[i27 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) {
     do {
      i3 = i2 + -40 | 0;
      HEAP32[i27 >> 2] = i3;
      i4 = i2 + -20 | 0;
      if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
       HEAP32[i4 >> 2] = 0;
      }
      if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -36 | 0);
       HEAP32[i3 >> 2] = 0;
      }
      i2 = HEAP32[i27 >> 2] | 0;
     } while ((i2 | 0) != (i1 | 0));
     i1 = HEAP32[i86 >> 2] | 0;
    }
    i14 = HEAP32[i68 >> 2] | 0;
    HEAP32[i129 >> 2] = 1;
    HEAP32[i69 >> 2] = i14;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i129);
   }
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != (i90 | 0));
 __Z12profiler_endP19ProfilerInformation(gb + 1459116 | 0);
 f16 = Math_fround(f93 * Math_fround(.0000610351563));
 __ZN11DynamicMeshC2Ef(i126, f16);
 if ((HEAP16[gb + 1459152 + 6 >> 1] | 0) > -1) {
  HEAP32[i112 >> 2] = 0;
  HEAP32[i129 >> 2] = HEAP32[i112 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459152 | 0, i129);
  i7 = gb + 1459152 | 0;
 } else i7 = 0;
 i5 = HEAP32[i94 >> 2] | 0;
 i6 = HEAP32[i95 >> 2] | 0;
 __ZN11DynamicMesh7ReserveEii(i126, i5, i6);
 if ((i5 | 0) > 0) {
  i2 = i129 + 4 | 0;
  i3 = i129 + 8 | 0;
  i4 = i126 + 60 | 0;
  f9 = Math_fround(HEAPF32[i115 >> 2]);
  f10 = Math_fround(HEAPF32[i116 >> 2]);
  f11 = Math_fround(HEAPF32[i117 >> 2]);
  i1 = 0;
  do {
   i95 = i96 + (i1 * 3 << 2) | 0;
   f142 = Math_fround(HEAPF32[i95 >> 2]);
   f143 = Math_fround(HEAPF32[i95 + 4 >> 2]);
   f143 = Math_fround(f143 - f10);
   f144 = Math_fround(Math_fround(HEAPF32[i95 + 8 >> 2]) - f11);
   HEAPF32[i129 >> 2] = Math_fround(f142 - f9);
   HEAPF32[i2 >> 2] = f143;
   HEAPF32[i3 >> 2] = f144;
   __ZN12VertexWelderILi2048EE4PushERK8Vector3f(i4, i129) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i129 >> 2] = 0;
 if ((i6 | 0) > 0) {
  i1 = 0;
  do {
   __ZN11DynamicMesh10AddPolygonEPKtRKij(i126, i105 + (i1 << 5) | 0, i129, HEAPU8[i105 + (i1 << 5) + 28 >> 0] | 0);
   i1 = i1 + 1 | 0;
   HEAP32[i129 >> 2] = i1;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (i7 | 0) __Z12profiler_endP19ProfilerInformation(i7);
 if (__ZN11DynamicMesh9ClipPolysERKNSt3__26vectorINS_10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEE(i126, i137) | 0) {
  i51 = i126 + 12 | 0;
  if (!(HEAP32[i51 >> 2] | 0)) i5 = 0; else {
   HEAP32[i97 >> 2] = 0;
   HEAP32[i129 >> 2] = HEAP32[i97 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459128 | 0, i129);
   i50 = i126 + 32 | 0;
   i19 = HEAP32[i50 >> 2] | 0;
   i4 = HEAP32[i51 >> 2] | 0;
   i95 = gb + 64016 | 0;
   i21 = HEAP32[i95 + 4 >> 2] | 0;
   i20 = i112;
   HEAP32[i20 >> 2] = HEAP32[i95 >> 2];
   HEAP32[i20 + 4 >> 2] = i21;
   HEAP32[i122 >> 2] = 0;
   HEAP32[i122 + 12 >> 2] = 0;
   i20 = i122 + 16 | 0;
   HEAP32[i20 >> 2] = 0;
   i21 = i122 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i95 = i129;
   i96 = HEAP32[i95 + 4 >> 2] | 0;
   i97 = i21;
   HEAP32[i97 >> 2] = HEAP32[i95 >> 2];
   HEAP32[i97 + 4 >> 2] = i96;
   HEAP32[i129 >> 2] = -1;
   __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i122, i19, i129, 1);
   if ((i4 | 0) > 0) {
    i5 = HEAP32[i126 >> 2] | 0;
    i6 = HEAP32[i126 + 40 >> 2] | 0;
    i7 = HEAP32[i122 >> 2] | 0;
    i3 = 0;
    do {
     do if (HEAP8[i5 + (i3 * 26 | 0) + 25 >> 0] | 0) {
      i8 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
      i1 = HEAP8[i5 + (i3 * 26 | 0) + 24 >> 0] | 0;
      if (!(i1 << 24 >> 24)) break;
      i2 = i1 & 255;
      i1 = 0;
      do {
       HEAP32[i7 + (HEAPU16[i5 + (i3 * 26 | 0) + 12 + (i1 << 1) >> 1] << 2) >> 2] = i8;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i2 | 0));
     } while (0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i4 | 0));
   }
   if ((i19 | 0) > 0) {
    i2 = i126 + 20 | 0;
    i3 = i129 + 4 | 0;
    i4 = i129 + 8 | 0;
    i5 = i112 + 4 | 0;
    i6 = i112 + 8 | 0;
    i7 = i118 + 4 | 0;
    i8 = i118 + 8 | 0;
    i12 = i118 + 12 | 0;
    i13 = i118 + 16 | 0;
    i14 = i118 + 20 | 0;
    i1 = 0;
    do {
     i15 = HEAP32[(HEAP32[i122 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     if ((i15 | 0) != -1) {
      i96 = (HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) | 0;
      i94 = HEAP32[i96 >> 2] | 0;
      i97 = HEAP32[i96 + 4 >> 2] | 0;
      i96 = HEAP32[i96 + 8 >> 2] | 0;
      i95 = (HEAP32[i98 >> 2] | 0) + (i15 * 24 | 0) | 0;
      f142 = (HEAP32[tempDoublePtr >> 2] = i94, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f93 = Math_fround(f142 + Math_fround(-.100000001));
      f144 = (HEAP32[tempDoublePtr >> 2] = i96, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f143 = Math_fround(f144 + Math_fround(-.100000001));
      HEAPF32[i129 >> 2] = f93;
      HEAP32[i3 >> 2] = i97;
      HEAPF32[i4 >> 2] = f143;
      f142 = Math_fround(f142 + Math_fround(.100000001));
      f143 = Math_fround((HEAP32[tempDoublePtr >> 2] = i97, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
      f144 = Math_fround(f144 + Math_fround(.100000001));
      HEAPF32[i112 >> 2] = f142;
      HEAPF32[i5 >> 2] = f143;
      HEAPF32[i6 >> 2] = f144;
      HEAP32[i118 >> 2] = gb + 169992 + 8;
      HEAP32[i7 >> 2] = i94;
      HEAP32[i8 >> 2] = i97;
      HEAP32[i12 >> 2] = i96;
      HEAP32[i13 >> 2] = i97;
      HEAPF32[i14 >> 2] = Math_fround(3402823469999999843913219.0e14);
      __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback(i140, i95, i129, i112, i118);
      i95 = HEAP32[i13 >> 2] | 0;
      i97 = HEAP32[i2 >> 2] | 0;
      HEAP32[i97 + (i1 * 12 | 0) >> 2] = i94;
      HEAP32[i97 + (i1 * 12 | 0) + 4 >> 2] = i95;
      HEAP32[i97 + (i1 * 12 | 0) + 8 >> 2] = i96;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i19 | 0));
   }
   if ((HEAP32[i20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i122 >> 2] | 0, i21);
    HEAP32[i122 >> 2] = 0;
   }
   __Z12profiler_endP19ProfilerInformation(gb + 1459128 | 0);
   if ((HEAP16[gb + 1459044 + 6 >> 1] | 0) > -1) {
    HEAP32[i112 >> 2] = 0;
    HEAP32[i129 >> 2] = HEAP32[i112 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459044 | 0, i129);
    i8 = gb + 1459044 | 0;
   } else i8 = 0;
   __ZN11DynamicMesh24RemoveDegeneratePolygonsEv(i126);
   i1 = HEAP32[i51 >> 2] | 0;
   if (i1 | 0) {
    i12 = i126 + 52 | 0;
    i13 = i126 + 40 | 0;
    i2 = 0;
    do {
     i7 = HEAP32[i126 >> 2] | 0;
     i6 = i7 + (i2 * 26 | 0) + 24 | 0;
     i3 = HEAP8[i6 >> 0] | 0;
     if (!(i3 << 24 >> 24)) i110 = 236; else {
      i5 = 0;
      i4 = i3 & 255;
      do {
       i97 = i5 + 1 | 0;
       i4 = (i97 | 0) < (i4 | 0) ? i97 : 0;
       if ((HEAP16[i7 + (i2 * 26 | 0) + 12 + (i5 << 1) >> 1] | 0) == (HEAP16[i7 + (i2 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0)) {
        if ((i4 | 0) < ((i3 & 255) + -1 | 0)) do {
         i3 = i4;
         i4 = i4 + 1 | 0;
         HEAP16[i7 + (i2 * 26 | 0) + 12 + (i3 << 1) >> 1] = HEAP16[i7 + (i2 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0;
         i3 = HEAP8[i6 >> 0] | 0;
        } while ((i4 | 0) < ((i3 & 255) + -1 | 0));
        i3 = i3 + -1 << 24 >> 24;
        HEAP8[i6 >> 0] = i3;
        i4 = i5 + -1 | 0;
       } else i4 = i5;
       i5 = i4 + 1 | 0;
       i4 = i3 & 255;
      } while ((i5 | 0) < (i4 | 0));
      if ((i3 & 255) < 3) i110 = 236;
     }
     if ((i110 | 0) == 236) {
      i110 = 0;
      i6 = i7 + (i2 * 26 | 0) | 0;
      i3 = i7 + (((HEAP32[i51 >> 2] | 0) + -1 | 0) * 26 | 0) | 0;
      i5 = i6 + 26 | 0;
      do {
       HEAP16[i6 >> 1] = HEAP16[i3 >> 1] | 0;
       i6 = i6 + 2 | 0;
       i3 = i3 + 2 | 0;
      } while ((i6 | 0) < (i5 | 0));
      HEAP32[i51 >> 2] = (HEAP32[i51 >> 2] | 0) + -1;
      i97 = HEAP32[i13 >> 2] | 0;
      HEAP32[i97 + (i2 << 2) >> 2] = HEAP32[i97 + ((HEAP32[i12 >> 2] | 0) + -1 << 2) >> 2];
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
      i1 = i1 + -1 | 0;
      i2 = i2 + -1 | 0;
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i1 >>> 0);
   }
   __ZN11DynamicMesh20RemoveUnusedVerticesEv(i126);
   __ZN11DynamicMesh15ConnectPolygonsEv(i126);
   if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
   i54 = gb + 64016 | 0;
   i53 = HEAP32[i54 + 4 >> 2] | 0;
   i52 = i112;
   HEAP32[i52 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i52 + 4 >> 2] = i53;
   HEAP32[i125 >> 2] = 0;
   i52 = i125 + 12 | 0;
   HEAP32[i52 >> 2] = 0;
   i53 = i125 + 16 | 0;
   HEAP32[i53 >> 2] = 0;
   i54 = i125 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i3 = i129;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i1 = i54;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = i2;
   i1 = HEAP32[i51 >> 2] | 0;
   i2 = HEAP32[i52 >> 2] | 0;
   HEAP32[i52 >> 2] = i1;
   i3 = HEAP32[i53 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i53 >> 2] = i1;
    HEAP32[i125 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i125 >> 2] | 0, i1 << 2, 4, i54, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i54, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i97 | 0, HEAP32[i125 >> 2] | 0, HEAP32[i52 >> 2] << 2 | 0) | 0;
    HEAP32[i53 >> 2] = i1;
    HEAP32[i125 >> 2] = i97;
    break;
   } while (0);
   if (i1 >>> 0 > i2 >>> 0) _memset((HEAP32[i125 >> 2] | 0) + (i2 << 2) | 0, 0, i1 - i2 << 2 | 0) | 0;
   if ((HEAP16[gb + 1459188 + 6 >> 1] | 0) > -1) {
    HEAP32[i112 >> 2] = 0;
    HEAP32[i129 >> 2] = HEAP32[i112 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459188 | 0, i129);
    i41 = gb + 1459188 | 0;
   } else i41 = 0;
   f38 = Math_fround(f16 * Math_fround(2.0));
   i37 = HEAP32[i51 >> 2] | 0;
   i43 = gb + 64016 | 0;
   i42 = HEAP32[i43 + 4 >> 2] | 0;
   i39 = i112;
   HEAP32[i39 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i39 + 4 >> 2] = i42;
   HEAP32[i118 >> 2] = 0;
   i39 = i118 + 12 | 0;
   HEAP32[i39 >> 2] = 0;
   i42 = i118 + 16 | 0;
   HEAP32[i42 >> 2] = 0;
   i43 = i118 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i40 = i129;
   i44 = HEAP32[i40 + 4 >> 2] | 0;
   i45 = i43;
   HEAP32[i45 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i45 + 4 >> 2] = i44;
   i45 = gb + 64016 | 0;
   i44 = HEAP32[i45 + 4 >> 2] | 0;
   i40 = i112;
   HEAP32[i40 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i40 + 4 >> 2] = i44;
   HEAP32[i122 >> 2] = 0;
   i40 = i122 + 12 | 0;
   HEAP32[i40 >> 2] = 0;
   i44 = i122 + 16 | 0;
   HEAP32[i44 >> 2] = 0;
   i45 = i122 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i2 = i129;
   i46 = HEAP32[i2 + 4 >> 2] | 0;
   i47 = i45;
   HEAP32[i47 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i47 + 4 >> 2] = i46;
   i47 = gb + 64016 | 0;
   i46 = HEAP32[i47 + 4 >> 2] | 0;
   i2 = i112;
   HEAP32[i2 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i2 + 4 >> 2] = i46;
   HEAP32[i102 >> 2] = 0;
   i2 = i102 + 12 | 0;
   HEAP32[i2 >> 2] = 0;
   i46 = i102 + 16 | 0;
   HEAP32[i46 >> 2] = 0;
   i47 = i102 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i3 = i129;
   i48 = HEAP32[i3 + 4 >> 2] | 0;
   i49 = i47;
   HEAP32[i49 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i49 + 4 >> 2] = i48;
   i49 = gb + 64016 | 0;
   i48 = HEAP32[i49 + 4 >> 2] | 0;
   i3 = i112;
   HEAP32[i3 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i3 + 4 >> 2] = i48;
   HEAP32[i103 >> 2] = 0;
   i3 = i103 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   i48 = i103 + 16 | 0;
   HEAP32[i48 >> 2] = 0;
   i49 = i103 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i96 = i129;
   i97 = HEAP32[i96 + 4 >> 2] | 0;
   i1 = i49;
   HEAP32[i1 >> 2] = HEAP32[i96 >> 2];
   HEAP32[i1 + 4 >> 2] = i97;
   i1 = HEAP32[i42 >> 2] | 0;
   do if ((i1 & 2147483640) >>> 0 < 8) if ((i1 | 0) > -1) {
    HEAP32[i42 >> 2] = 8;
    HEAP32[i118 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i118 >> 2] | 0, 128, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(128, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i97 | 0, HEAP32[i118 >> 2] | 0, HEAP32[i39 >> 2] << 4 | 0) | 0;
    HEAP32[i42 >> 2] = 8;
    HEAP32[i118 >> 2] = i97;
    break;
   } while (0);
   i1 = HEAP32[i44 >> 2] | 0;
   do if ((i1 & 2147483640) >>> 0 < 8) if ((i1 | 0) > -1) {
    HEAP32[i44 >> 2] = 8;
    HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i122 >> 2] | 0, 96, 4, i45, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 4, i45, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i97 | 0, HEAP32[i122 >> 2] | 0, (HEAP32[i40 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i44 >> 2] = 8;
    HEAP32[i122 >> 2] = i97;
    break;
   } while (0);
   i1 = HEAP32[i46 >> 2] | 0;
   do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
    HEAP32[i46 >> 2] = 32;
    HEAP32[i102 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i102 >> 2] | 0, 384, 4, i47, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i47, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i97 | 0, HEAP32[i102 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i46 >> 2] = 32;
    HEAP32[i102 >> 2] = i97;
    break;
   } while (0);
   i1 = HEAP32[i48 >> 2] | 0;
   do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
    HEAP32[i48 >> 2] = 32;
    HEAP32[i103 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i103 >> 2] | 0, 384, 4, i49, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i49, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i97 | 0, HEAP32[i103 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i48 >> 2] = 32;
    HEAP32[i103 >> 2] = i97;
    break;
   } while (0);
   i31 = gb + 64016 | 0;
   i32 = HEAP32[i31 >> 2] | 0;
   i31 = HEAP32[i31 + 4 >> 2] | 0;
   HEAPF32[i99 >> 2] = f16;
   i14 = i99 + 4 | 0;
   HEAP32[i14 >> 2] = 0;
   i30 = i112;
   HEAP32[i30 >> 2] = i32;
   HEAP32[i30 + 4 >> 2] = i31;
   i30 = i99 + 8 | 0;
   HEAP32[i30 >> 2] = 0;
   HEAP32[i99 + 20 >> 2] = 0;
   i31 = i99 + 24 | 0;
   HEAP32[i31 >> 2] = 0;
   i32 = i99 + 12 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
   i96 = i129;
   i97 = HEAP32[i96 + 4 >> 2] | 0;
   i29 = i32;
   HEAP32[i29 >> 2] = HEAP32[i96 >> 2];
   HEAP32[i29 + 4 >> 2] = i97;
   i29 = i99 + 28 | 0;
   _memset(i29 | 0, -1, 256) | 0;
   if ((i37 | 0) > 0) {
    i15 = i126 + 40 | 0;
    f33 = Math_fround(HEAPF32[gb + 62452 >> 2]);
    i19 = i100 + 8 | 0;
    i20 = i101 + 4 | 0;
    i21 = i101 + 8 | 0;
    i1 = i99 + 8 | 0;
    i22 = i129 + 4 | 0;
    i23 = i129 + 8 | 0;
    i24 = i129 + 12 | 0;
    i25 = i129 + 16 | 0;
    i26 = i129 + 20 | 0;
    i27 = i100 + 4 | 0;
    i28 = i126 + 20 | 0;
    f34 = Math_fround(HEAPF32[i115 >> 2]);
    f35 = Math_fround(HEAPF32[i116 >> 2]);
    f36 = Math_fround(HEAPF32[i117 >> 2]);
    i13 = 0;
    do {
     i4 = HEAP32[i126 >> 2] | 0;
     do if (HEAP8[i4 + (i13 * 26 | 0) + 25 >> 0] | 0) {
      i97 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i13 << 2) >> 2] | 0;
      i96 = HEAP32[i98 >> 2] | 0;
      i12 = i96 + (i97 * 24 | 0) | 0;
      i5 = i4 + (i13 * 26 | 0) + 24 | 0;
      i2 = HEAPU8[i5 >> 0] | 0;
      if ((HEAP32[i96 + (i97 * 24 | 0) + 4 >> 2] | 0) == (i2 | 0)) break;
      HEAP32[i40 >> 2] = i2;
      i3 = HEAP32[i44 >> 2] | 0;
      do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i44 >> 2] = i2;
       HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i122 >> 2] | 0, i2 * 12 | 0, 4, i45, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i45, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i97 | 0, HEAP32[i122 >> 2] | 0, (HEAP32[i40 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i44 >> 2] = i2;
       HEAP32[i122 >> 2] = i97;
       break;
      } while (0);
      if (HEAP8[i5 >> 0] | 0) {
       i2 = 0;
       do {
        i97 = HEAP32[i122 >> 2] | 0;
        i94 = (HEAP32[i28 >> 2] | 0) + ((HEAPU16[i4 + (i13 * 26 | 0) + 12 + (i2 << 1) >> 1] | 0) * 12 | 0) | 0;
        i95 = HEAP32[i94 + 4 >> 2] | 0;
        i96 = HEAP32[i94 + 8 >> 2] | 0;
        HEAP32[i97 + (i2 * 12 | 0) >> 2] = HEAP32[i94 >> 2];
        HEAP32[i97 + (i2 * 12 | 0) + 4 >> 2] = i95;
        HEAP32[i97 + (i2 * 12 | 0) + 8 >> 2] = i96;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (HEAPU8[i5 >> 0] | 0));
      }
      i8 = HEAP32[i40 >> 2] | 0;
      HEAP32[i39 >> 2] = i8;
      i2 = HEAP32[i42 >> 2] | 0;
      do if ((i2 & 2147483647) >>> 0 < i8 >>> 0) if ((i2 | 0) > -1) {
       HEAP32[i42 >> 2] = i8;
       HEAP32[i118 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i118 >> 2] | 0, i8 << 4, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 4, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i97 | 0, HEAP32[i118 >> 2] | 0, HEAP32[i39 >> 2] << 4 | 0) | 0;
       HEAP32[i42 >> 2] = i8;
       HEAP32[i118 >> 2] = i97;
       break;
      } while (0);
      if ((i8 | 0) > 0) {
       i5 = 0;
       do {
        i96 = HEAP32[i122 >> 2] | 0;
        f16 = Math_fround(HEAPF32[i96 + (i5 * 12 | 0) >> 2]);
        f17 = Math_fround(HEAPF32[i96 + (i5 * 12 | 0) + 4 >> 2]);
        f18 = Math_fround(HEAPF32[i96 + (i5 * 12 | 0) + 8 >> 2]);
        i6 = i5;
        i5 = i5 + 1 | 0;
        i7 = (i5 | 0) == (i8 | 0);
        i97 = i7 ? 0 : i5;
        f9 = Math_fround(Math_fround(HEAPF32[i96 + (i97 * 12 | 0) >> 2]) - f16);
        f10 = Math_fround(Math_fround(HEAPF32[i96 + (i97 * 12 | 0) + 8 >> 2]) - f18);
        f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)))));
        if (f11 > f33) {
         f144 = Math_fround(Math_fround(-f10) / f11);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
         f144 = Math_fround(Math_fround(0.0) / f11);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
         f144 = Math_fround(f9 / f11);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i2 = HEAP32[gb + 1162364 >> 2] | 0;
         i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
         i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
        }
        i97 = HEAP32[i118 >> 2] | 0;
        HEAP32[i97 + (i6 << 4) >> 2] = i2;
        HEAP32[i97 + (i6 << 4) + 4 >> 2] = i3;
        HEAP32[i97 + (i6 << 4) + 8 >> 2] = i4;
        f144 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
        f144 = Math_fround(Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f144);
        HEAPF32[i97 + (i6 << 4) + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f18 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f144));
       } while (!i7);
      }
      i3 = HEAP32[i122 >> 2] | 0;
      HEAP32[i101 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i101 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i101 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i100 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i100 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i100 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      i4 = HEAP32[i40 >> 2] | 0;
      f9 = Math_fround(HEAPF32[i100 >> 2]);
      if ((i4 | 0) > 0) {
       f18 = Math_fround(HEAPF32[i27 >> 2]);
       f17 = Math_fround(HEAPF32[i19 >> 2]);
       f16 = Math_fround(HEAPF32[i101 >> 2]);
       f11 = Math_fround(HEAPF32[i20 >> 2]);
       i2 = 0;
       f10 = Math_fround(HEAPF32[i21 >> 2]);
       do {
        f142 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) >> 2]);
        f9 = f142 < f9 ? f142 : f9;
        f143 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 4 >> 2]);
        f18 = f143 < f18 ? f143 : f18;
        f144 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2]);
        f17 = f144 < f17 ? f144 : f17;
        f16 = f16 < f142 ? f142 : f16;
        f11 = f11 < f143 ? f143 : f11;
        f10 = f10 < f144 ? f144 : f10;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i4 | 0));
       HEAPF32[i100 >> 2] = f9;
       HEAPF32[i27 >> 2] = f18;
       HEAPF32[i19 >> 2] = f17;
       HEAPF32[i101 >> 2] = f16;
       HEAPF32[i20 >> 2] = f11;
       HEAPF32[i21 >> 2] = f10;
      } else {
       f17 = Math_fround(HEAPF32[i19 >> 2]);
       f16 = Math_fround(HEAPF32[i101 >> 2]);
       f11 = Math_fround(HEAPF32[i20 >> 2]);
       f10 = Math_fround(HEAPF32[i21 >> 2]);
      }
      HEAPF32[i100 >> 2] = Math_fround(f9 - f38);
      HEAPF32[i19 >> 2] = Math_fround(f17 - f38);
      HEAPF32[i101 >> 2] = Math_fround(f38 + f16);
      HEAPF32[i20 >> 2] = Math_fround(f11 + Math_fround(0.0));
      HEAPF32[i21 >> 2] = Math_fround(f38 + f10);
      i97 = __ZnwjRK10MemLabelIdiPKci(44, gb + 64016 | 0, 16, gb + 846428 | 0, 1112) | 0;
      i95 = gb + 64016 | 0;
      i96 = HEAP32[i95 >> 2] | 0;
      i95 = HEAP32[i95 + 4 >> 2] | 0;
      HEAP32[i97 >> 2] = 0;
      i2 = i112;
      HEAP32[i2 >> 2] = i96;
      HEAP32[i2 + 4 >> 2] = i95;
      i2 = i97 + 4 | 0;
      HEAP32[i2 >> 2] = 0;
      i4 = i97 + 16 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i97 + 20 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
      i90 = i129;
      i91 = HEAP32[i90 + 4 >> 2] | 0;
      i94 = i97 + 8 | 0;
      HEAP32[i94 >> 2] = HEAP32[i90 >> 2];
      HEAP32[i94 + 4 >> 2] = i91;
      i94 = i112;
      HEAP32[i94 >> 2] = i96;
      HEAP32[i94 + 4 >> 2] = i95;
      HEAP32[i97 + 24 >> 2] = 0;
      HEAP32[i97 + 36 >> 2] = 0;
      HEAP32[i97 + 40 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
      i94 = i129;
      i95 = HEAP32[i94 + 4 >> 2] | 0;
      i96 = i97 + 28 | 0;
      HEAP32[i96 >> 2] = HEAP32[i94 >> 2];
      HEAP32[i96 + 4 >> 2] = i95;
      HEAP32[i97 >> 2] = i13;
      HEAP32[(HEAP32[i125 >> 2] | 0) + (i13 << 2) >> 2] = i97;
      HEAP32[i14 >> 2] = i2;
      _memset(i29 | 0, -1, 256) | 0;
      HEAP32[i129 >> 2] = 0;
      __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i1, 0, i129, 1);
      HEAP32[i129 >> 2] = gb + 170004 + 8;
      HEAP32[i22 >> 2] = i97;
      HEAP32[i23 >> 2] = i118;
      HEAP32[i24 >> 2] = i99;
      HEAP32[i25 >> 2] = i102;
      HEAP32[i26 >> 2] = i103;
      __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback(i140, i12, i100, i101, i129);
      i4 = HEAP32[i4 >> 2] | 0;
      if ((i4 | 0) > 0) {
       i3 = HEAP32[i2 >> 2] | 0;
       i2 = 0;
       do {
        i97 = i3 + (i2 * 12 | 0) | 0;
        HEAPF32[i97 >> 2] = Math_fround(f34 + Math_fround(HEAPF32[i97 >> 2]));
        i97 = i3 + (i2 * 12 | 0) + 4 | 0;
        HEAPF32[i97 >> 2] = Math_fround(f35 + Math_fround(HEAPF32[i97 >> 2]));
        i97 = i3 + (i2 * 12 | 0) + 8 | 0;
        HEAPF32[i97 >> 2] = Math_fround(f36 + Math_fround(HEAPF32[i97 >> 2]));
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i4 | 0));
      }
     } while (0);
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != (i37 | 0));
   } else i1 = i99 + 8 | 0;
   if ((HEAP32[i31 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i32);
    HEAP32[i30 >> 2] = 0;
   }
   if ((HEAP32[i48 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i103 >> 2] | 0, i49);
    HEAP32[i103 >> 2] = 0;
   }
   if ((HEAP32[i46 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i102 >> 2] | 0, i47);
    HEAP32[i102 >> 2] = 0;
   }
   if ((HEAP32[i44 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i122 >> 2] | 0, i45);
    HEAP32[i122 >> 2] = 0;
   }
   if ((HEAP32[i42 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i43);
    HEAP32[i118 >> 2] = 0;
   }
   if (i41 | 0) __Z12profiler_endP19ProfilerInformation(i41);
   if ((HEAP16[gb + 1459164 + 6 >> 1] | 0) > -1) {
    HEAP32[i112 >> 2] = 0;
    HEAP32[i129 >> 2] = HEAP32[i112 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459164 | 0, i129);
    i45 = gb + 1459164 | 0;
   } else i45 = 0;
   i43 = HEAP32[i50 >> 2] | 0;
   i44 = HEAP32[i51 >> 2] | 0;
   i6 = HEAP32[i126 >> 2] | 0;
   i42 = i126 + 40 | 0;
   i7 = HEAP32[i42 >> 2] | 0;
   i8 = HEAP32[i125 >> 2] | 0;
   i12 = (i44 | 0) > 0;
   if (i12) {
    i1 = 0;
    i2 = 0;
    i5 = 0;
    while (1) {
     do if (!(HEAP8[i6 + (i5 * 26 | 0) + 25 >> 0] | 0)) {
      i103 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
      i4 = (HEAPU16[i119 + (i103 * 12 | 0) + 8 >> 1] | 0) + i1 | 0;
      i1 = HEAPU16[i119 + (i103 * 12 | 0) + 10 >> 1] | 0;
     } else {
      i3 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
      if (!i3) {
       i4 = i1;
       i1 = (HEAPU8[i6 + (i5 * 26 | 0) + 24 >> 0] | 0) + -2 | 0;
       break;
      } else {
       i4 = (HEAP32[i3 + 16 >> 2] | 0) + i1 | 0;
       i1 = ((HEAP32[i3 + 36 >> 2] | 0) >>> 0) / 3 | 0;
       break;
      }
     } while (0);
     i2 = i1 + i2 | 0;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i44 | 0)) {
      i41 = i2;
      break;
     } else i1 = i4;
    }
   } else {
    i4 = 0;
    i41 = 0;
   }
   i6 = i4 * 12 | 0;
   i3 = (i43 * 12 | 0) + 72 | 0;
   i5 = i3 + (i44 << 5) | 0;
   i7 = i5 + (i44 * 12 | 0) | 0;
   i2 = (i41 << 3) + i7 + i6 | 0;
   i1 = __Z7dtAlloci(i2) | 0;
   if (!i1) {
    HEAP32[i104 >> 2] = 0;
    i1 = 0;
   } else {
    HEAP32[i104 >> 2] = i2;
    _memset(i1 | 0, 0, i2 | 0) | 0;
    i14 = i1 + 72 | 0;
    i13 = i1 + i3 | 0;
    i39 = i1 + i5 | 0;
    i40 = i1 + i7 | 0;
    i37 = i1 + (i6 + i7) | 0;
    if ((i43 | 0) > 0) {
     i3 = HEAP32[i126 + 20 >> 2] | 0;
     f9 = Math_fround(HEAPF32[i115 >> 2]);
     f10 = Math_fround(HEAPF32[i116 >> 2]);
     f11 = Math_fround(HEAPF32[i117 >> 2]);
     i2 = 0;
     do {
      i103 = i3 + (i2 * 12 | 0) | 0;
      i104 = i2 * 3 | 0;
      HEAPF32[i14 + (i104 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i103 >> 2]) + f9);
      HEAPF32[i14 + (i104 + 1 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i103 + 4 >> 2]) + f10);
      HEAPF32[i14 + (i104 + 2 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i103 + 8 >> 2]) + f11);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i43 | 0));
    }
    if (i12) {
     i2 = 0;
     do {
      i104 = HEAP32[i126 >> 2] | 0;
      i101 = i104 + (i2 * 26 | 0) | 0;
      i103 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      i102 = i13 + (i2 << 5) | 0;
      i100 = i104 + (i2 * 26 | 0) + 12 | 0;
      HEAP16[i102 >> 1] = HEAP16[i100 >> 1] | 0;
      HEAP16[i102 + 2 >> 1] = HEAP16[i100 + 2 >> 1] | 0;
      HEAP16[i102 + 4 >> 1] = HEAP16[i100 + 4 >> 1] | 0;
      HEAP16[i102 + 6 >> 1] = HEAP16[i100 + 6 >> 1] | 0;
      HEAP16[i102 + 8 >> 1] = HEAP16[i100 + 8 >> 1] | 0;
      HEAP16[i102 + 10 >> 1] = HEAP16[i100 + 10 >> 1] | 0;
      i102 = i13 + (i2 << 5) + 12 | 0;
      HEAP16[i102 >> 1] = HEAP16[i101 >> 1] | 0;
      HEAP16[i102 + 2 >> 1] = HEAP16[i101 + 2 >> 1] | 0;
      HEAP16[i102 + 4 >> 1] = HEAP16[i101 + 4 >> 1] | 0;
      HEAP16[i102 + 6 >> 1] = HEAP16[i101 + 6 >> 1] | 0;
      HEAP16[i102 + 8 >> 1] = HEAP16[i101 + 8 >> 1] | 0;
      HEAP16[i102 + 10 >> 1] = HEAP16[i101 + 10 >> 1] | 0;
      i103 = HEAP8[i105 + (i103 << 5) + 29 >> 0] | 0;
      HEAP32[i13 + (i2 << 5) + 24 >> 2] = 1 << (i103 & 255);
      HEAP8[i13 + (i2 << 5) + 29 >> 0] = i103;
      HEAP8[i13 + (i2 << 5) + 28 >> 0] = HEAP8[i104 + (i2 * 26 | 0) + 24 >> 0] | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i44 | 0));
     i7 = 0;
     do {
      i8 = i13 + (i7 << 5) + 28 | 0;
      i2 = HEAP8[i8 >> 0] | 0;
      if (i2 << 24 >> 24) {
       i3 = 0;
       i5 = i2 & 255;
       do {
        i6 = i13 + (i7 << 5) + 12 + (i3 << 1) | 0;
        if (!(HEAP16[i6 >> 1] | 0)) {
         i105 = i14 + ((HEAPU16[i13 + (i7 << 5) + (i3 << 1) >> 1] | 0) * 3 << 2) | 0;
         i3 = i3 + 1 | 0;
         i104 = i14 + ((HEAPU16[i13 + (i7 << 5) + (((i3 | 0) == (i5 | 0) ? 0 : i3) << 1) >> 1] | 0) * 3 << 2) | 0;
         f9 = Math_fround(HEAPF32[i104 >> 2]);
         f10 = Math_fround(HEAPF32[i105 >> 2]);
         f11 = Math_fround(f9 - f10);
         f16 = Math_fround(HEAPF32[i104 + 8 >> 2]);
         f17 = Math_fround(HEAPF32[i105 + 8 >> 2]);
         f18 = Math_fround(f16 - f17);
         if (f18 < Math_fround(0.0)) {
          f144 = Math_fround(HEAPF32[i108 >> 2]);
          f143 = Math_fround(f10 - f144);
          i105 = f143 < Math_fround(0.0);
          f142 = Math_fround(-f143);
          f143 = i105 ? f142 : f143;
          f144 = Math_fround(f9 - f144);
          i105 = f144 < Math_fround(0.0);
          f142 = Math_fround(-f144);
          f144 = i105 ? f142 : f144;
          if ((f143 > f144 ? f143 : f144) < Math_fround(.00999999977)) i2 = -32768; else i110 = 328;
         } else i110 = 328;
         do if ((i110 | 0) == 328) {
          i110 = 0;
          if (f11 > Math_fround(0.0)) {
           f144 = Math_fround(HEAPF32[i109 >> 2]);
           f143 = Math_fround(f17 - f144);
           i105 = f143 < Math_fround(0.0);
           f142 = Math_fround(-f143);
           f143 = i105 ? f142 : f143;
           f144 = Math_fround(f16 - f144);
           i105 = f144 < Math_fround(0.0);
           f142 = Math_fround(-f144);
           f144 = i105 ? f142 : f144;
           if ((f143 > f144 ? f143 : f144) < Math_fround(.00999999977)) {
            i2 = -32766;
            break;
           }
          }
          if (f18 > Math_fround(0.0)) {
           f144 = Math_fround(HEAPF32[i106 >> 2]);
           f143 = Math_fround(f10 - f144);
           i105 = f143 < Math_fround(0.0);
           f142 = Math_fround(-f143);
           f143 = i105 ? f142 : f143;
           f144 = Math_fround(f9 - f144);
           i105 = f144 < Math_fround(0.0);
           f142 = Math_fround(-f144);
           f144 = i105 ? f142 : f144;
           if ((f143 > f144 ? f143 : f144) < Math_fround(.00999999977)) {
            i2 = -32764;
            break;
           }
          }
          if (!(f11 < Math_fround(0.0))) {
           i2 = 0;
           break;
          }
          f144 = Math_fround(HEAPF32[i107 >> 2]);
          f143 = Math_fround(f17 - f144);
          i105 = f143 < Math_fround(0.0);
          f142 = Math_fround(-f143);
          f143 = i105 ? f142 : f143;
          f144 = Math_fround(f16 - f144);
          i105 = f144 < Math_fround(0.0);
          f142 = Math_fround(-f144);
          f144 = i105 ? f142 : f144;
          if (!((f143 > f144 ? f143 : f144) < Math_fround(.00999999977))) {
           i2 = 0;
           break;
          }
          i2 = -32762;
         } while (0);
         HEAP16[i6 >> 1] = i2;
         i2 = HEAP8[i8 >> 0] | 0;
        } else i3 = i3 + 1 | 0;
        i5 = i2 & 255;
       } while ((i3 | 0) < (i5 | 0));
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i44 | 0));
    }
    if ((HEAP16[gb + 1459176 + 6 >> 1] | 0) > -1) {
     HEAP32[i112 >> 2] = 0;
     HEAP32[i129 >> 2] = HEAP32[i112 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459176 | 0, i129);
     i26 = gb + 1459176 | 0;
    } else i26 = 0;
    i29 = gb + 64016 | 0;
    i28 = HEAP32[i29 + 4 >> 2] | 0;
    i27 = i112;
    HEAP32[i27 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i27 + 4 >> 2] = i28;
    HEAP32[i118 >> 2] = 0;
    i27 = i118 + 12 | 0;
    HEAP32[i27 >> 2] = 0;
    i28 = i118 + 16 | 0;
    HEAP32[i28 >> 2] = 0;
    i29 = i118 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
    i30 = i129;
    i31 = HEAP32[i30 + 4 >> 2] | 0;
    i32 = i29;
    HEAP32[i32 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i32 + 4 >> 2] = i31;
    i32 = gb + 64016 | 0;
    i31 = HEAP32[i32 + 4 >> 2] | 0;
    i30 = i112;
    HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
    HEAP32[i30 + 4 >> 2] = i31;
    HEAP32[i122 >> 2] = 0;
    i30 = i122 + 12 | 0;
    HEAP32[i30 >> 2] = 0;
    i31 = i122 + 16 | 0;
    HEAP32[i31 >> 2] = 0;
    i32 = i122 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i112);
    i110 = i129;
    i112 = HEAP32[i110 + 4 >> 2] | 0;
    i2 = i32;
    HEAP32[i2 >> 2] = HEAP32[i110 >> 2];
    HEAP32[i2 + 4 >> 2] = i112;
    i2 = HEAP32[i31 >> 2] | 0;
    do if ((i2 & 2147483646) >>> 0 < 6) if ((i2 | 0) > -1) {
     HEAP32[i31 >> 2] = 6;
     HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i122 >> 2] | 0, 72, 4, i32, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i112 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i32, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i112 | 0, HEAP32[i122 >> 2] | 0, (HEAP32[i30 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i31 >> 2] = 6;
     HEAP32[i122 >> 2] = i112;
     break;
    } while (0);
    i24 = HEAP32[i51 >> 2] | 0;
    if ((i24 | 0) > 0) {
     i25 = i126 + 20 | 0;
     f11 = Math_fround(HEAPF32[i115 >> 2]);
     f10 = Math_fround(HEAPF32[i116 >> 2]);
     f9 = Math_fround(HEAPF32[i117 >> 2]);
     i2 = 0;
     i23 = 0;
     i3 = 0;
     do {
      i7 = i39 + (i23 * 12 | 0) | 0;
      i6 = HEAP32[i126 >> 2] | 0;
      do if (!(HEAP8[i6 + (i23 * 26 | 0) + 25 >> 0] | 0)) {
       i115 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i23 << 2) >> 2] | 0;
       HEAP32[i7 >> 2] = i3;
       i116 = i119 + (i115 * 12 | 0) + 8 | 0;
       HEAP16[i39 + (i23 * 12 | 0) + 8 >> 1] = HEAP16[i116 >> 1] | 0;
       HEAP32[i39 + (i23 * 12 | 0) + 4 >> 2] = i2;
       i117 = i119 + (i115 * 12 | 0) + 10 | 0;
       HEAP16[i39 + (i23 * 12 | 0) + 10 >> 1] = HEAP16[i117 >> 1] | 0;
       _memcpy(i40 + (i3 * 3 << 2) | 0, i120 + ((HEAP32[i119 + (i115 * 12 | 0) >> 2] | 0) * 3 << 2) | 0, (HEAPU16[i116 >> 1] | 0) * 12 | 0) | 0;
       _memcpy(i37 + (i2 << 2 << 1) | 0, i121 + (HEAP32[i119 + (i115 * 12 | 0) + 4 >> 2] << 2 << 1) | 0, HEAPU16[i117 >> 1] << 3 | 0) | 0;
       i3 = (HEAPU16[i116 >> 1] | 0) + i3 | 0;
       i2 = (HEAPU16[i117 >> 1] | 0) + i2 | 0;
      } else {
       i22 = i6 + (i23 * 26 | 0) + 24 | 0;
       i5 = HEAP8[i22 >> 0] | 0;
       i8 = i5 & 255;
       if (!(HEAP32[(HEAP32[i125 >> 2] | 0) + (i23 << 2) >> 2] | 0)) {
        HEAP32[i7 >> 2] = 0;
        HEAP16[i39 + (i23 * 12 | 0) + 8 >> 1] = 0;
        HEAP32[i39 + (i23 * 12 | 0) + 4 >> 2] = i2;
        HEAP16[i39 + (i23 * 12 | 0) + 10 >> 1] = i8 + 65534;
        if ((i5 & 255) <= 2) break;
        i7 = i8 + -1 | 0;
        i5 = 2;
        i6 = i2;
        while (1) {
         i117 = i37 + (i6 << 2 << 1) | 0;
         HEAP16[i117 >> 1] = 0;
         HEAP16[i117 + 2 >> 1] = i5 + 65535;
         HEAP16[i117 + 4 >> 1] = i5;
         i116 = (i5 | 0) == 2 ? 5 : 4;
         HEAP16[i117 + 6 >> 1] = (i5 | 0) == (i7 | 0) ? (i116 & 65535 | 16) & 65535 : i116;
         i5 = i5 + 1 | 0;
         if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 1 | 0;
        }
        i2 = i2 + -2 + i8 | 0;
        break;
       }
       HEAP32[i30 >> 2] = i8;
       i5 = HEAP32[i31 >> 2] | 0;
       do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i31 >> 2] = i8;
        HEAP32[i122 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i122 >> 2] | 0, i8 * 12 | 0, 4, i32, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i117 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 12 | 0, 4, i32, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i117 | 0, HEAP32[i122 >> 2] | 0, (HEAP32[i30 >> 2] | 0) * 12 | 0) | 0;
        HEAP32[i31 >> 2] = i8;
        HEAP32[i122 >> 2] = i117;
        break;
       } while (0);
       if (HEAP8[i22 >> 0] | 0) {
        i5 = 0;
        do {
         i117 = HEAP32[i122 >> 2] | 0;
         i116 = (HEAP32[i25 >> 2] | 0) + ((HEAPU16[i6 + (i23 * 26 | 0) + 12 + (i5 << 1) >> 1] | 0) * 12 | 0) | 0;
         f142 = Math_fround(HEAPF32[i116 >> 2]);
         f143 = Math_fround(HEAPF32[i116 + 4 >> 2]);
         f143 = Math_fround(f143 + f10);
         f144 = Math_fround(Math_fround(HEAPF32[i116 + 8 >> 2]) + f9);
         HEAPF32[i117 + (i5 * 12 | 0) >> 2] = Math_fround(f142 + f11);
         HEAPF32[i117 + (i5 * 12 | 0) + 4 >> 2] = f143;
         HEAPF32[i117 + (i5 * 12 | 0) + 8 >> 2] = f144;
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) < (HEAPU8[i22 >> 0] | 0));
       }
       i14 = HEAP32[(HEAP32[i125 >> 2] | 0) + (i23 << 2) >> 2] | 0;
       i15 = i14 + 4 | 0;
       i20 = HEAP32[i14 + 16 >> 2] | 0;
       i19 = HEAP32[i14 + 36 >> 2] | 0;
       i21 = (i19 >>> 0) / 3 | 0;
       HEAP32[i7 >> 2] = i3;
       HEAP16[i39 + (i23 * 12 | 0) + 8 >> 1] = i20;
       HEAP32[i39 + (i23 * 12 | 0) + 4 >> 2] = i2;
       HEAP16[i39 + (i23 * 12 | 0) + 10 >> 1] = i21;
       i7 = (i20 | 0) > 0;
       if (i7) {
        i6 = HEAP32[i15 >> 2] | 0;
        i5 = 0;
        do {
         i117 = i40 + ((i5 + i3 | 0) * 3 << 2) | 0;
         i116 = i6 + (i5 * 12 | 0) | 0;
         HEAP32[i117 >> 2] = HEAP32[i116 >> 2];
         HEAP32[i117 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
         HEAP32[i117 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i20 | 0));
       }
       HEAP32[i27 >> 2] = i20;
       i5 = HEAP32[i28 >> 2] | 0;
       do if ((i5 & 2147483647) >>> 0 < i20 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i28 >> 2] = i20;
        HEAP32[i118 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i118 >> 2] | 0, i20, 1, i29, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i117 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20, 1, i29, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i117 | 0, HEAP32[i118 >> 2] | 0, HEAP32[i27 >> 2] | 0) | 0;
        HEAP32[i28 >> 2] = i20;
        HEAP32[i118 >> 2] = i117;
        break;
       } while (0);
       if (i7) {
        i13 = 0;
        do {
         i5 = HEAP32[i15 >> 2] | 0;
         if (!(HEAP8[gb + 1552708 >> 0] | 0)) {
          HEAPF32[gb + 1459544 >> 2] = Math_fround(.0000999999974);
          HEAP8[gb + 1552708 >> 0] = 1;
         }
         i12 = HEAP32[i30 >> 2] | 0;
         if ((i12 | 0) > 0) {
          i8 = i5 + (i13 * 12 | 0) | 0;
          i7 = 0;
          i5 = 0;
          i6 = i12 + -1 | 0;
          while (1) {
           i117 = HEAP32[i122 >> 2] | 0;
           f144 = Math_fround(__Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i8, i117 + (i6 * 12 | 0) | 0, i117 + (i7 * 12 | 0) | 0, i129));
           i117 = f144 < Math_fround(HEAPF32[gb + 1459544 >> 2]);
           i5 = i117 ? (i5 & 255 | 1 << i6) & 255 : i5;
           i6 = i7 + 1 | 0;
           if ((i6 | 0) == (i12 | 0)) break; else {
            i117 = i7;
            i7 = i6;
            i6 = i117;
           }
          }
         } else i5 = 0;
         HEAP8[(HEAP32[i118 >> 2] | 0) + i13 >> 0] = i5;
         i13 = i13 + 1 | 0;
        } while ((i13 | 0) != (i20 | 0));
       }
       if (i19 >>> 0 > 2) {
        i7 = HEAP32[i14 + 24 >> 2] | 0;
        i8 = HEAP32[i118 >> 2] | 0;
        i6 = HEAPU8[i22 >> 0] | 0;
        i5 = 0;
        do {
         i117 = i37 + (i5 + i2 << 2 << 1) | 0;
         i112 = i5 * 3 | 0;
         i115 = i7 + (i112 << 1) | 0;
         HEAP16[i117 >> 1] = (HEAPU16[i115 >> 1] | 0) + i6;
         i110 = i7 + (i112 + 1 << 1) | 0;
         HEAP16[i117 + 2 >> 1] = (HEAPU16[i110 >> 1] | 0) + i6;
         i112 = i7 + (i112 + 2 << 1) | 0;
         HEAP16[i117 + 4 >> 1] = (HEAPU16[i112 >> 1] | 0) + i6;
         i115 = HEAP8[i8 + (HEAPU16[i115 >> 1] | 0) >> 0] | 0;
         i110 = HEAP8[i8 + (HEAPU16[i110 >> 1] | 0) >> 0] | 0;
         i112 = HEAP8[i8 + (HEAPU16[i112 >> 1] | 0) >> 0] | 0;
         i116 = (i110 & i115) << 24 >> 24 != 0;
         i116 = (i112 & i110) << 24 >> 24 == 0 ? i116 & 1 : (i116 & 1 | 4) & 255;
         HEAP16[i117 + 6 >> 1] = ((i112 & i115) << 24 >> 24 == 0 ? i116 : (i116 & 255 | 16) & 255) & 255;
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) < (i21 | 0));
       }
       i3 = i20 + i3 | 0;
       i2 = i21 + i2 | 0;
      } while (0);
      i23 = i23 + 1 | 0;
     } while ((i23 | 0) != (i24 | 0));
    }
    if ((HEAP32[i31 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i122 >> 2] | 0, i32);
     HEAP32[i122 >> 2] = 0;
    }
    if ((HEAP32[i28 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i29);
     HEAP32[i118 >> 2] = 0;
    }
    if (i26 | 0) __Z12profiler_endP19ProfilerInformation(i26);
    i6 = i1;
    i3 = i123;
    i5 = i6 + 72 | 0;
    do {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     i6 = i6 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i6 | 0) < (i5 | 0));
    HEAP32[i1 + 20 >> 2] = i44;
    HEAP32[i1 + 24 >> 2] = i43;
    HEAP32[i1 + 28 >> 2] = i44;
    HEAP32[i1 + 32 >> 2] = i4;
    HEAP32[i1 + 36 >> 2] = i41;
    HEAP32[i1 + 40 >> 2] = 0;
   }
   if (i45 | 0) __Z12profiler_endP19ProfilerInformation(i45);
   HEAP32[i124 >> 2] = i1;
   i1 = HEAP32[i52 >> 2] | 0;
   if (i1 | 0) {
    i3 = 0;
    do {
     i2 = HEAP32[(HEAP32[i125 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if (i2) {
      i1 = i2 + 24 | 0;
      if ((HEAP32[i2 + 40 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 28 | 0);
       HEAP32[i1 >> 2] = 0;
      }
      i1 = i2 + 4 | 0;
      if ((HEAP32[i2 + 20 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 8 | 0);
       HEAP32[i1 >> 2] = 0;
      }
      __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
      HEAP32[(HEAP32[i125 >> 2] | 0) + (i3 << 2) >> 2] = 0;
      i1 = HEAP32[i52 >> 2] | 0;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   if ((HEAP32[i53 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i125 >> 2] | 0, i54);
    HEAP32[i125 >> 2] = 0;
   }
   i5 = 0;
  }
 } else i5 = 1;
 i1 = i126 + 68 | 0;
 if ((HEAP32[i126 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i126 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i126 + 40 | 0;
 if ((HEAP32[i126 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i126 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i126 + 20 | 0;
 if ((HEAP32[i126 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i126 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i126 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i126 >> 2] | 0, i126 + 4 | 0);
  HEAP32[i126 >> 2] = 0;
 }
 i1 = HEAP32[i137 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i111 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -40 | 0;
    HEAP32[i111 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -36 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    i2 = HEAP32[i111 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i137 >> 2] | 0;
  }
  i137 = HEAP32[i137 + 12 >> 2] | 0;
  HEAP32[i129 >> 2] = 1;
  HEAP32[i129 + 4 >> 2] = i137;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i129);
 }
 if ((HEAP32[i113 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i136 >> 2] | 0, i114);
  HEAP32[i136 >> 2] = 0;
 }
 i1 = i140 + 60 | 0;
 if ((HEAP32[i134 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i135);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i132 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i127 >> 2] | 0, i133);
  HEAP32[i127 >> 2] = 0;
 }
 if ((HEAP32[i130 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i128 >> 2] | 0, i131);
  HEAP32[i128 >> 2] = 0;
 }
 if ((HEAP32[i138 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i140 >> 2] | 0, i139);
  HEAP32[i140 >> 2] = 0;
 }
 i140 = i5;
 STACKTOP = i141;
 return i140 | 0;
}

function __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb(i64, i1, i2, i73, i3, i65, i74) {
 i64 = i64 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i73 = i73 | 0;
 i3 = i3 | 0;
 i65 = i65 | 0;
 i74 = i74 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, i83 = 0, f84 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, f94 = f0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i67 = i72 + 324 | 0;
 i70 = i72 + 312 | 0;
 i63 = i72 + 304 | 0;
 i71 = i72 + 256 | 0;
 i69 = i72 + 96 | 0;
 i62 = i72 + 48 | 0;
 i29 = i72;
 i30 = i72 + 208 | 0;
 i15 = i72 + 160 | 0;
 i16 = i72 + 144 | 0;
 if ((HEAP16[gb + 1452128 + 6 >> 1] | 0) > -1) {
  HEAP32[i70 >> 2] = 0;
  HEAP32[i67 >> 2] = HEAP32[i70 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452128 | 0, i67);
  i68 = gb + 1452128 | 0;
 } else i68 = 0;
 i66 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i67 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i67 + 4 >> 2] = i66;
 HEAP32[i67 + 8 >> 2] = i1;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i66 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i67 + 12 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i67 + 16 >> 2] = i1;
 HEAP32[i67 + 20 >> 2] = i66;
 i66 = HEAP32[i3 + 36 >> 2] | 0;
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 HEAP32[i67 + 24 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i67 + 28 >> 2] = i66;
 HEAP32[i67 + 32 >> 2] = i1;
 HEAP32[i70 >> 2] = HEAP32[i2 + 304 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i2 + 308 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i2 + 312 >> 2];
 i1 = HEAP32[i64 + 8 >> 2] | 0;
 switch (i1 | 0) {
 case 14:
 case 13:
 case 6:
  {
   if (HEAP32[i64 + 72 >> 2] | 0) {
    i2 = HEAP32[i64 + 100 >> 2] | 0;
    if (i2 | 0) {
     i13 = i64 + 104 | 0;
     i14 = i64 + 116 | 0;
     i12 = HEAP32[i14 >> 2] | 0;
     if (i12 | 0) {
      i3 = i2 + 8 | 0;
      i4 = HEAP32[i2 + 92 >> 2] | 0;
      if (!i4) {
       HEAP32[i63 >> 2] = 0;
       HEAP32[i63 + 4 >> 2] = 1;
       HEAP32[i71 >> 2] = 0;
       HEAP32[i71 + 4 >> 2] = 1;
       i1 = 0;
       i5 = 17;
      } else {
       if (!(HEAP8[i2 + 11 >> 0] | 0)) {
        HEAP32[i63 >> 2] = 0;
        HEAP32[i63 + 4 >> 2] = 1;
       } else {
        i66 = HEAPU8[i3 + 32 + ((HEAPU8[i3 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i51 = HEAP16[i3 >> 1] | 0;
        HEAP32[i63 >> 2] = i4 + (((i51 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i51 & 255) * 12 | 0) + 4 >> 2] | 0));
        HEAP32[i63 + 4 >> 2] = i66;
       }
       if (!(HEAP8[i2 + 15 >> 0] | 0)) {
        HEAP32[i71 >> 2] = 0;
        HEAP32[i71 + 4 >> 2] = 1;
        i1 = 0;
       } else {
        i66 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i1 = HEAP16[i2 + 12 >> 1] | 0;
        i1 = i4 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        HEAP32[i71 >> 2] = i1;
        HEAP32[i71 + 4 >> 2] = i66;
       }
       if (!(HEAP8[i2 + 19 >> 0] | 0)) i5 = 17; else {
        i66 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i2 = HEAP16[i2 + 16 >> 1] | 0;
        i2 = i4 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        HEAP32[i69 >> 2] = i2;
        HEAP32[i69 + 4 >> 2] = i66;
       }
      }
      if ((i5 | 0) == 17) {
       HEAP32[i69 >> 2] = 0;
       HEAP32[i69 + 4 >> 2] = 1;
       i2 = 0;
      }
      HEAP32[i62 >> 2] = HEAP32[gb + 1162364 >> 2];
      HEAP32[i62 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
      HEAP32[i62 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
      HEAP32[i29 >> 2] = -1;
      if (!i1) {
       HEAP32[i71 >> 2] = i62;
       HEAP32[i71 + 4 >> 2] = 0;
      }
      if (!i2) i5 = 22; else if (!(HEAP8[i64 + 214 >> 0] | 0)) i5 = 22;
      if ((i5 | 0) == 22) {
       HEAP32[i69 >> 2] = i29;
       HEAP32[i69 + 4 >> 2] = 0;
      }
      i11 = HEAP32[i73 + 12 >> 2] | 0;
      L105 : do switch (HEAP32[i64 + 40 >> 2] | 0) {
      case 0:
       {
        if (i11 >>> 0 > i65 >>> 0) {
         i4 = i64 + 68 | 0;
         i5 = i64 + 60 | 0;
         i6 = i64 + 64 | 0;
         i7 = i64 + 140 | 0;
         i8 = i64 + 136 | 0;
         i9 = i64 + 204 | 0;
         i10 = i64 + 208 | 0;
         i3 = i64 + 212 | 0;
         i1 = i65;
         i2 = i12;
         while (1) {
          __Z15GetPositionMeshIL20MeshDistributionMode0ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i30, i15, i16, i63, i71, i69, HEAP32[i13 >> 2] | 0, i2, i4, i5, i6, i7, HEAP32[i8 >> 2] | 0);
          f60 = Math_fround(HEAPF32[i9 >> 2]);
          f61 = Math_fround(HEAPF32[i10 >> 2]);
          __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb(i67, i70, i73, i1, i30, i15, i16, i7, f60, f61, (HEAP8[i3 >> 0] | 0) != 0, i74);
          i1 = i1 + 4 | 0;
          if (i1 >>> 0 >= i11 >>> 0) break L105;
          i2 = HEAP32[i14 >> 2] | 0;
         }
        }
        break;
       }
      case 1:
       {
        if (i11 >>> 0 > i65 >>> 0) {
         i4 = i64 + 68 | 0;
         i5 = i64 + 60 | 0;
         i6 = i64 + 64 | 0;
         i7 = i64 + 140 | 0;
         i8 = i64 + 136 | 0;
         i9 = i64 + 204 | 0;
         i10 = i64 + 208 | 0;
         i3 = i64 + 212 | 0;
         i1 = i65;
         i2 = i12;
         while (1) {
          __Z15GetPositionMeshIL20MeshDistributionMode1ELb1EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i30, i15, i16, i63, i71, i69, HEAP32[i13 >> 2] | 0, i2, i4, i5, i6, i7, HEAP32[i8 >> 2] | 0);
          f60 = Math_fround(HEAPF32[i9 >> 2]);
          f61 = Math_fround(HEAPF32[i10 >> 2]);
          __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb(i67, i70, i73, i1, i30, i15, i16, i7, f60, f61, (HEAP8[i3 >> 0] | 0) != 0, i74);
          i1 = i1 + 4 | 0;
          if (i1 >>> 0 >= i11 >>> 0) break L105;
          i2 = HEAP32[i14 >> 2] | 0;
         }
        }
        break;
       }
      case 2:
       {
        if (i11 >>> 0 > i65 >>> 0) {
         i4 = i64 + 68 | 0;
         i5 = i64 + 60 | 0;
         i6 = i64 + 64 | 0;
         i7 = i64 + 140 | 0;
         i8 = i64 + 136 | 0;
         i9 = i64 + 204 | 0;
         i10 = i64 + 208 | 0;
         i3 = i64 + 212 | 0;
         i1 = i65;
         i2 = i12;
         while (1) {
          __Z15GetPositionMeshIL20MeshDistributionMode1ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i30, i15, i16, i63, i71, i69, HEAP32[i13 >> 2] | 0, i2, i4, i5, i6, i7, HEAP32[i8 >> 2] | 0);
          f60 = Math_fround(HEAPF32[i9 >> 2]);
          f61 = Math_fround(HEAPF32[i10 >> 2]);
          __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb(i67, i70, i73, i1, i30, i15, i16, i7, f60, f61, (HEAP8[i3 >> 0] | 0) != 0, i74);
          i1 = i1 + 4 | 0;
          if (i1 >>> 0 >= i11 >>> 0) break L105;
          i2 = HEAP32[i14 >> 2] | 0;
         }
        }
        break;
       }
      default:
       {}
      } while (0);
     }
    }
   }
   break;
  }
 default:
  {
   i2 = HEAP32[i64 + 12 >> 2] | 0;
   f61 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i64 + 16 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
   f52 = Math_fround(HEAPF32[i64 + 20 >> 2]);
   f60 = Math_fround(+Math_cos(+f61));
   f61 = Math_fround(+Math_sin(+f61));
   HEAPF32[i63 >> 2] = Math_fround(.00499999989);
   i66 = HEAP32[i73 + 12 >> 2] | 0;
   do switch (i1 | 0) {
   case 0:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i33 = i64 + 140 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = i69 + 4 | 0;
      i13 = i69 + 8 | 0;
      i14 = i69 + 12 | 0;
      i15 = i69 + 16 | 0;
      i16 = i69 + 20 | 0;
      i17 = i69 + 24 | 0;
      i18 = i69 + 28 | 0;
      i19 = i69 + 32 | 0;
      i20 = i69 + 36 | 0;
      i21 = i69 + 40 | 0;
      i22 = i69 + 44 | 0;
      i5 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i11 = i71 + 12 | 0;
      i23 = i71 + 16 | 0;
      i4 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i10 = i71 + 28 | 0;
      i24 = i71 + 32 | 0;
      i3 = i71 + 36 | 0;
      i6 = i71 + 40 | 0;
      i9 = i71 + 44 | 0;
      i25 = i69 + 16 | 0;
      i26 = i71 + 16 | 0;
      i29 = i69 + 32 | 0;
      i30 = i71 + 32 | 0;
      i31 = i64 + 204 | 0;
      i32 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       HEAPF32[i62 >> 2] = Math_fround(1.0);
       __Z23RandomPointInsideSphereR5RandNRKfS2_(i69, i33, i63, i62);
       f75 = Math_fround(f27 * Math_fround(HEAPF32[i69 >> 2]));
       f28 = Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2]));
       f52 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
       f53 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
       f54 = Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2]));
       f55 = Math_fround(f27 * Math_fround(HEAPF32[i16 >> 2]));
       f56 = Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2]));
       f57 = Math_fround(f27 * Math_fround(HEAPF32[i18 >> 2]));
       f58 = Math_fround(f27 * Math_fround(HEAPF32[i19 >> 2]));
       f59 = Math_fround(f27 * Math_fround(HEAPF32[i20 >> 2]));
       f61 = Math_fround(f27 * Math_fround(HEAPF32[i21 >> 2]));
       f60 = Math_fround(f27 * Math_fround(HEAPF32[i22 >> 2]));
       HEAPF32[i71 >> 2] = f75;
       HEAPF32[i5 >> 2] = f28;
       HEAPF32[i8 >> 2] = f52;
       HEAPF32[i11 >> 2] = f53;
       HEAPF32[i23 >> 2] = f54;
       HEAPF32[i4 >> 2] = f55;
       HEAPF32[i7 >> 2] = f56;
       HEAPF32[i10 >> 2] = f57;
       HEAPF32[i24 >> 2] = f58;
       HEAPF32[i3 >> 2] = f59;
       HEAPF32[i6 >> 2] = f61;
       HEAPF32[i9 >> 2] = f60;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
       HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
       HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
       f60 = Math_fround(HEAPF32[i31 >> 2]);
       f61 = Math_fround(HEAPF32[i32 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i33, f60, f61, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 1:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i33 = i64 + 140 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = i69 + 4 | 0;
      i13 = i69 + 8 | 0;
      i14 = i69 + 12 | 0;
      i15 = i69 + 16 | 0;
      i16 = i69 + 20 | 0;
      i17 = i69 + 24 | 0;
      i18 = i69 + 28 | 0;
      i19 = i69 + 32 | 0;
      i20 = i69 + 36 | 0;
      i21 = i69 + 40 | 0;
      i22 = i69 + 44 | 0;
      i5 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i11 = i71 + 12 | 0;
      i23 = i71 + 16 | 0;
      i4 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i10 = i71 + 28 | 0;
      i24 = i71 + 32 | 0;
      i3 = i71 + 36 | 0;
      i6 = i71 + 40 | 0;
      i9 = i71 + 44 | 0;
      i25 = i69 + 16 | 0;
      i26 = i71 + 16 | 0;
      i29 = i69 + 32 | 0;
      i30 = i71 + 32 | 0;
      i31 = i64 + 204 | 0;
      i32 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       __Z16RandomUnitVectorR5RandN(i69, i33);
       f28 = Math_fround(f27 * Math_fround(HEAPF32[i69 >> 2]));
       f52 = Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2]));
       f53 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
       f54 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
       f55 = Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2]));
       f56 = Math_fround(f27 * Math_fround(HEAPF32[i16 >> 2]));
       f57 = Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2]));
       f58 = Math_fround(f27 * Math_fround(HEAPF32[i18 >> 2]));
       f59 = Math_fround(f27 * Math_fround(HEAPF32[i19 >> 2]));
       f60 = Math_fround(f27 * Math_fround(HEAPF32[i20 >> 2]));
       f75 = Math_fround(f27 * Math_fround(HEAPF32[i21 >> 2]));
       f61 = Math_fround(f27 * Math_fround(HEAPF32[i22 >> 2]));
       HEAPF32[i71 >> 2] = f28;
       HEAPF32[i5 >> 2] = f52;
       HEAPF32[i8 >> 2] = f53;
       HEAPF32[i11 >> 2] = f54;
       HEAPF32[i23 >> 2] = f55;
       HEAPF32[i4 >> 2] = f56;
       HEAPF32[i7 >> 2] = f57;
       HEAPF32[i10 >> 2] = f58;
       HEAPF32[i24 >> 2] = f59;
       HEAPF32[i3 >> 2] = f60;
       HEAPF32[i6 >> 2] = f75;
       HEAPF32[i9 >> 2] = f61;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
       HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
       HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
       f61 = Math_fround(HEAPF32[i31 >> 2]);
       f75 = Math_fround(HEAPF32[i32 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i33, f61, f75, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 2:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i32 = i64 + 140 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = i69 + 4 | 0;
      i13 = i69 + 8 | 0;
      i14 = i69 + 12 | 0;
      i15 = i69 + 16 | 0;
      i16 = i69 + 20 | 0;
      i17 = i69 + 24 | 0;
      i18 = i69 + 28 | 0;
      i19 = i69 + 32 | 0;
      i20 = i69 + 36 | 0;
      i21 = i69 + 40 | 0;
      i22 = i69 + 44 | 0;
      i5 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i11 = i71 + 12 | 0;
      i23 = i71 + 16 | 0;
      i4 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i10 = i71 + 28 | 0;
      i3 = i71 + 36 | 0;
      i6 = i71 + 40 | 0;
      i9 = i71 + 44 | 0;
      i24 = i71 + 32 | 0;
      i25 = i69 + 16 | 0;
      i26 = i71 + 16 | 0;
      i29 = i69 + 32 | 0;
      i30 = i64 + 204 | 0;
      i31 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       HEAPF32[i62 >> 2] = Math_fround(1.0);
       __Z23RandomPointInsideSphereR5RandNRKfS2_(i69, i32, i63, i62);
       f28 = Math_fround(f27 * Math_fround(HEAPF32[i69 >> 2]));
       f52 = Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2]));
       f53 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
       f54 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
       f55 = Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2]));
       f56 = Math_fround(f27 * Math_fround(HEAPF32[i16 >> 2]));
       f57 = Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2]));
       f58 = Math_fround(f27 * Math_fround(HEAPF32[i18 >> 2]));
       f59 = Math_fround(f27 * Math_fround(HEAPF32[i19 >> 2]));
       f60 = Math_fround(f27 * Math_fround(HEAPF32[i20 >> 2]));
       f75 = Math_fround(f27 * Math_fround(HEAPF32[i21 >> 2]));
       f61 = Math_fround(f27 * Math_fround(HEAPF32[i22 >> 2]));
       HEAPF32[i71 >> 2] = f28;
       HEAPF32[i5 >> 2] = f52;
       HEAPF32[i8 >> 2] = f53;
       HEAPF32[i11 >> 2] = f54;
       HEAPF32[i23 >> 2] = f55;
       HEAPF32[i4 >> 2] = f56;
       HEAPF32[i7 >> 2] = f57;
       HEAPF32[i10 >> 2] = f58;
       f60 = Math_fround(Math_abs(Math_fround(f60)));
       f75 = Math_fround(Math_abs(Math_fround(f75)));
       f61 = Math_fround(Math_abs(Math_fround(f61)));
       HEAPF32[i24 >> 2] = Math_fround(Math_abs(Math_fround(f59)));
       HEAPF32[i3 >> 2] = f60;
       HEAPF32[i6 >> 2] = f75;
       HEAPF32[i9 >> 2] = f61;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
       HEAP32[i29 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i29 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
       f61 = Math_fround(HEAPF32[i30 >> 2]);
       f75 = Math_fround(HEAPF32[i31 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i32, f61, f75, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 3:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i32 = i64 + 140 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = i69 + 4 | 0;
      i13 = i69 + 8 | 0;
      i14 = i69 + 12 | 0;
      i15 = i69 + 16 | 0;
      i16 = i69 + 20 | 0;
      i17 = i69 + 24 | 0;
      i18 = i69 + 28 | 0;
      i19 = i69 + 32 | 0;
      i20 = i69 + 36 | 0;
      i21 = i69 + 40 | 0;
      i22 = i69 + 44 | 0;
      i5 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i11 = i71 + 12 | 0;
      i23 = i71 + 16 | 0;
      i4 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i10 = i71 + 28 | 0;
      i3 = i71 + 36 | 0;
      i6 = i71 + 40 | 0;
      i9 = i71 + 44 | 0;
      i24 = i71 + 32 | 0;
      i25 = i69 + 16 | 0;
      i26 = i71 + 16 | 0;
      i29 = i69 + 32 | 0;
      i30 = i64 + 204 | 0;
      i31 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       __Z16RandomUnitVectorR5RandN(i69, i32);
       f28 = Math_fround(f27 * Math_fround(HEAPF32[i69 >> 2]));
       f52 = Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2]));
       f53 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
       f54 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
       f55 = Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2]));
       f56 = Math_fround(f27 * Math_fround(HEAPF32[i16 >> 2]));
       f57 = Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2]));
       f58 = Math_fround(f27 * Math_fround(HEAPF32[i18 >> 2]));
       f59 = Math_fround(f27 * Math_fround(HEAPF32[i19 >> 2]));
       f60 = Math_fround(f27 * Math_fround(HEAPF32[i20 >> 2]));
       f75 = Math_fround(f27 * Math_fround(HEAPF32[i21 >> 2]));
       f61 = Math_fround(f27 * Math_fround(HEAPF32[i22 >> 2]));
       HEAPF32[i71 >> 2] = f28;
       HEAPF32[i5 >> 2] = f52;
       HEAPF32[i8 >> 2] = f53;
       HEAPF32[i11 >> 2] = f54;
       HEAPF32[i23 >> 2] = f55;
       HEAPF32[i4 >> 2] = f56;
       HEAPF32[i7 >> 2] = f57;
       HEAPF32[i10 >> 2] = f58;
       f60 = Math_fround(Math_abs(Math_fround(f60)));
       f75 = Math_fround(Math_abs(Math_fround(f75)));
       f61 = Math_fround(Math_abs(Math_fround(f61)));
       HEAPF32[i24 >> 2] = Math_fround(Math_abs(Math_fround(f59)));
       HEAPF32[i3 >> 2] = f60;
       HEAPF32[i6 >> 2] = f75;
       HEAPF32[i9 >> 2] = f61;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
       HEAP32[i29 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i29 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
       f61 = Math_fround(HEAPF32[i30 >> 2]);
       f75 = Math_fround(HEAPF32[i31 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i32, f61, f75, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 4:
    {
     i33 = i64 + 204 | 0;
     f59 = Math_fround(HEAPF32[i33 >> 2]);
     if (i66 >>> 0 > i65 >>> 0) {
      i34 = i64 + 140 | 0;
      i35 = i69 + 4 | 0;
      i36 = i71 + 4 | 0;
      i37 = i69 + 8 | 0;
      i38 = i71 + 8 | 0;
      i39 = i69 + 12 | 0;
      i40 = i71 + 12 | 0;
      i41 = i69 + 16 | 0;
      i42 = i71 + 16 | 0;
      i43 = i69 + 20 | 0;
      i44 = i71 + 20 | 0;
      i45 = i69 + 24 | 0;
      i46 = i71 + 24 | 0;
      i47 = i69 + 28 | 0;
      i48 = i71 + 28 | 0;
      i32 = i69 + 4 | 0;
      i22 = i69 + 8 | 0;
      i23 = i69 + 12 | 0;
      i49 = i69 + 16 | 0;
      i24 = i69 + 20 | 0;
      i25 = i69 + 24 | 0;
      i26 = i69 + 28 | 0;
      i21 = i69 + 32 | 0;
      i29 = i69 + 36 | 0;
      i30 = i69 + 40 | 0;
      i31 = i69 + 44 | 0;
      f58 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i14 = i62 + 4 | 0;
      i16 = i62 + 8 | 0;
      i18 = i62 + 12 | 0;
      i19 = i62 + 16 | 0;
      i13 = i62 + 20 | 0;
      i15 = i62 + 24 | 0;
      i17 = i62 + 28 | 0;
      i12 = i62 + 32 | 0;
      i20 = i64 + 208 | 0;
      i10 = i64 + 212 | 0;
      i11 = i71 + 16 | 0;
      i1 = i65;
      do {
       HEAPF32[i69 >> 2] = Math_fround(1.0);
       __Z23RandomPointInsideCircleR5RandNRKfS2_(i71, i34, i63, i69);
       if (Math_fround(HEAPF32[i33 >> 2]) > Math_fround(0.0)) {
        HEAPF32[i62 >> 2] = Math_fround(1.0);
        __Z23RandomPointInsideCircleR5RandNRKfS2_(i69, i34, i63, i62);
        f82 = Math_fround(HEAPF32[i69 >> 2]);
        f27 = Math_fround(HEAPF32[i71 >> 2]);
        f82 = Math_fround(f82 - f27);
        f81 = Math_fround(HEAPF32[i35 >> 2]);
        f28 = Math_fround(HEAPF32[i36 >> 2]);
        f81 = Math_fround(f81 - f28);
        f80 = Math_fround(HEAPF32[i37 >> 2]);
        f52 = Math_fround(HEAPF32[i38 >> 2]);
        f80 = Math_fround(f80 - f52);
        f79 = Math_fround(HEAPF32[i39 >> 2]);
        f53 = Math_fround(HEAPF32[i40 >> 2]);
        f82 = Math_fround(f27 + Math_fround(f59 * f82));
        f81 = Math_fround(f28 + Math_fround(f59 * f81));
        f80 = Math_fround(f52 + Math_fround(f59 * f80));
        f79 = Math_fround(f53 + Math_fround(f59 * Math_fround(f79 - f53)));
        f78 = Math_fround(HEAPF32[i41 >> 2]);
        f54 = Math_fround(HEAPF32[i42 >> 2]);
        f78 = Math_fround(f78 - f54);
        f77 = Math_fround(HEAPF32[i43 >> 2]);
        f55 = Math_fround(HEAPF32[i44 >> 2]);
        f77 = Math_fround(f77 - f55);
        f76 = Math_fround(HEAPF32[i45 >> 2]);
        f56 = Math_fround(HEAPF32[i46 >> 2]);
        f76 = Math_fround(f76 - f56);
        f75 = Math_fround(HEAPF32[i47 >> 2]);
        f57 = Math_fround(HEAPF32[i48 >> 2]);
        f78 = Math_fround(f54 + Math_fround(f59 * f78));
        f77 = Math_fround(f55 + Math_fround(f59 * f77));
        f76 = Math_fround(f56 + Math_fround(f59 * f76));
        f75 = Math_fround(f57 + Math_fround(f59 * Math_fround(f75 - f57)));
        i2 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
        i7 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
        i8 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        i2 = HEAP32[i71 >> 2] | 0;
        i9 = HEAP32[i36 >> 2] | 0;
        i3 = HEAP32[i38 >> 2] | 0;
        i4 = HEAP32[i40 >> 2] | 0;
        i5 = HEAP32[i11 >> 2] | 0;
        i6 = HEAP32[i44 >> 2] | 0;
        i7 = HEAP32[i46 >> 2] | 0;
        i65 = HEAP32[i48 >> 2] | 0;
        f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f28 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f52 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f54 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f55 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f56 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i8 = i65;
        f57 = (HEAP32[tempDoublePtr >> 2] = i65, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       }
       f75 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f82 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f81 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f80 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f79 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f78 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f77 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f76 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       HEAPF32[i69 >> 2] = f75;
       HEAPF32[i32 >> 2] = f82;
       HEAPF32[i22 >> 2] = f81;
       HEAPF32[i23 >> 2] = f80;
       HEAPF32[i49 >> 2] = f79;
       HEAPF32[i24 >> 2] = f78;
       HEAPF32[i25 >> 2] = f77;
       HEAPF32[i26 >> 2] = f76;
       HEAPF32[i21 >> 2] = f60;
       HEAPF32[i29 >> 2] = f60;
       HEAPF32[i30 >> 2] = f60;
       HEAPF32[i31 >> 2] = f60;
       f76 = Math_fround(f58 * f28);
       f77 = Math_fround(f58 * f52);
       f78 = Math_fround(f58 * f53);
       f79 = Math_fround(f58 * f54);
       f80 = Math_fround(f58 * f55);
       f81 = Math_fround(f58 * f56);
       f82 = Math_fround(f58 * f57);
       HEAPF32[i62 >> 2] = Math_fround(f58 * f27);
       HEAPF32[i14 >> 2] = f76;
       HEAPF32[i16 >> 2] = f77;
       HEAPF32[i18 >> 2] = f78;
       HEAPF32[i19 >> 2] = f79;
       HEAPF32[i13 >> 2] = f80;
       HEAPF32[i15 >> 2] = f81;
       HEAPF32[i17 >> 2] = f82;
       HEAP32[i12 >> 2] = 0;
       HEAP32[i12 + 4 >> 2] = 0;
       HEAP32[i12 + 8 >> 2] = 0;
       HEAP32[i12 + 12 >> 2] = 0;
       f82 = Math_fround(HEAPF32[i20 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i62, i69, i34, Math_fround(0.0), f82, (HEAP8[i10 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 7:
    {
     i32 = i64 + 204 | 0;
     f59 = Math_fround(HEAPF32[i32 >> 2]);
     if (i66 >>> 0 > i65 >>> 0) {
      i33 = i64 + 140 | 0;
      i34 = i71 + 4 | 0;
      i35 = i71 + 8 | 0;
      i36 = i71 + 12 | 0;
      i37 = i71 + 16 | 0;
      i38 = i71 + 20 | 0;
      i39 = i71 + 24 | 0;
      i40 = i71 + 28 | 0;
      i41 = i71 + 4 | 0;
      i42 = i71 + 8 | 0;
      i43 = i71 + 12 | 0;
      i44 = i71 + 16 | 0;
      i45 = i71 + 20 | 0;
      i46 = i71 + 24 | 0;
      i47 = i71 + 28 | 0;
      i31 = i71 + 4 | 0;
      i21 = i71 + 8 | 0;
      i22 = i71 + 12 | 0;
      i48 = i71 + 16 | 0;
      i23 = i71 + 20 | 0;
      i24 = i71 + 24 | 0;
      i25 = i71 + 28 | 0;
      i20 = i71 + 32 | 0;
      i26 = i71 + 36 | 0;
      i29 = i71 + 40 | 0;
      i30 = i71 + 44 | 0;
      f58 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i13 = i69 + 4 | 0;
      i15 = i69 + 8 | 0;
      i17 = i69 + 12 | 0;
      i18 = i69 + 16 | 0;
      i12 = i69 + 20 | 0;
      i14 = i69 + 24 | 0;
      i16 = i69 + 28 | 0;
      i11 = i69 + 32 | 0;
      i19 = i64 + 208 | 0;
      i10 = i64 + 212 | 0;
      i9 = i65;
      do {
       __Z17RandomUnitVector2R5RandN(i71, i33);
       f55 = Math_fround(HEAPF32[i71 >> 2]);
       f78 = Math_fround(f55 * f55);
       f56 = Math_fround(HEAPF32[i34 >> 2]);
       f77 = Math_fround(f56 * f56);
       f57 = Math_fround(HEAPF32[i35 >> 2]);
       f76 = Math_fround(f57 * f57);
       f75 = Math_fround(HEAPF32[i36 >> 2]);
       f82 = Math_fround(f75 * f75);
       f28 = Math_fround(HEAPF32[i37 >> 2]);
       f79 = Math_fround(f28 * f28);
       f52 = Math_fround(HEAPF32[i38 >> 2]);
       f80 = Math_fround(f52 * f52);
       f53 = Math_fround(HEAPF32[i39 >> 2]);
       f81 = Math_fround(f53 * f53);
       f54 = Math_fround(HEAPF32[i40 >> 2]);
       f79 = Math_fround(f78 + f79);
       f80 = Math_fround(f77 + f80);
       f81 = Math_fround(f76 + f81);
       f82 = Math_fround(f82 + Math_fround(f54 * f54));
       f76 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f79))));
       f77 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f80))));
       f78 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f82))));
       f55 = Math_fround(f55 * f76);
       f56 = Math_fround(f56 * f77);
       f57 = Math_fround(f57 * f78);
       f75 = Math_fround(f75 * f27);
       f76 = Math_fround(f28 * f76);
       f77 = Math_fround(f52 * f77);
       f78 = Math_fround(f53 * f78);
       f27 = Math_fround(f54 * f27);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
       i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
       i7 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
       i8 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
       i6 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
       i51 = f79 > Math_fround(9.99999974e-06);
       i62 = f80 > Math_fround(9.99999974e-06);
       i64 = f81 > Math_fround(9.99999974e-06);
       i65 = f82 > Math_fround(9.99999974e-06);
       i3 = i51 ? i3 : 0;
       i1 = i62 ? i1 : 0;
       i5 = i64 ? i5 : 0;
       i7 = i65 ? i7 : 0;
       i8 = i51 ? i8 : 0;
       i6 = i62 ? i6 : 0;
       i4 = i64 ? i4 : 0;
       i2 = i65 ? (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) : 0;
       if (Math_fround(HEAPF32[i32 >> 2]) > Math_fround(0.0)) {
        HEAPF32[i69 >> 2] = Math_fround(1.0);
        __Z23RandomPointInsideCircleR5RandNRKfS2_(i71, i33, i63, i69);
        f75 = Math_fround(HEAPF32[i71 >> 2]);
        f57 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f75 = Math_fround(f75 - f57);
        f76 = Math_fround(HEAPF32[i41 >> 2]);
        f27 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f76 = Math_fround(f76 - f27);
        f77 = Math_fround(HEAPF32[i42 >> 2]);
        f28 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f77 = Math_fround(f77 - f28);
        f78 = Math_fround(HEAPF32[i43 >> 2]);
        f52 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f75 = Math_fround(f57 + Math_fround(f59 * f75));
        f76 = Math_fround(f27 + Math_fround(f59 * f76));
        f77 = Math_fround(f28 + Math_fround(f59 * f77));
        f78 = Math_fround(f52 + Math_fround(f59 * Math_fround(f78 - f52)));
        f79 = Math_fround(HEAPF32[i44 >> 2]);
        f53 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f79 = Math_fround(f79 - f53);
        f80 = Math_fround(HEAPF32[i45 >> 2]);
        f54 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f80 = Math_fround(f80 - f54);
        f81 = Math_fround(HEAPF32[i46 >> 2]);
        f55 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f81 = Math_fround(f81 - f55);
        f82 = Math_fround(HEAPF32[i47 >> 2]);
        f56 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f79 = Math_fround(f53 + Math_fround(f59 * f79));
        f80 = Math_fround(f54 + Math_fround(f59 * f80));
        f81 = Math_fround(f55 + Math_fround(f59 * f81));
        f82 = Math_fround(f56 + Math_fround(f59 * Math_fround(f82 - f56)));
        i3 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
        i1 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
        i7 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
        i8 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
        i2 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        f57 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f27 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f28 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f52 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f54 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f55 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f56 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       }
       f75 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f82 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f81 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f80 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f79 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f78 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f77 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f76 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       HEAPF32[i71 >> 2] = f75;
       HEAPF32[i31 >> 2] = f82;
       HEAPF32[i21 >> 2] = f81;
       HEAPF32[i22 >> 2] = f80;
       HEAPF32[i48 >> 2] = f79;
       HEAPF32[i23 >> 2] = f78;
       HEAPF32[i24 >> 2] = f77;
       HEAPF32[i25 >> 2] = f76;
       HEAPF32[i20 >> 2] = f60;
       HEAPF32[i26 >> 2] = f60;
       HEAPF32[i29 >> 2] = f60;
       HEAPF32[i30 >> 2] = f60;
       f76 = Math_fround(f58 * f27);
       f77 = Math_fround(f58 * f28);
       f78 = Math_fround(f58 * f52);
       f79 = Math_fround(f58 * f53);
       f80 = Math_fround(f58 * f54);
       f81 = Math_fround(f58 * f55);
       f82 = Math_fround(f58 * f56);
       HEAPF32[i69 >> 2] = Math_fround(f58 * f57);
       HEAPF32[i13 >> 2] = f76;
       HEAPF32[i15 >> 2] = f77;
       HEAPF32[i17 >> 2] = f78;
       HEAPF32[i18 >> 2] = f79;
       HEAPF32[i12 >> 2] = f80;
       HEAPF32[i14 >> 2] = f81;
       HEAPF32[i16 >> 2] = f82;
       HEAP32[i11 >> 2] = 0;
       HEAP32[i11 + 4 >> 2] = 0;
       HEAP32[i11 + 8 >> 2] = 0;
       HEAP32[i11 + 12 >> 2] = 0;
       f82 = Math_fround(HEAPF32[i19 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i9, i69, i71, i33, Math_fround(0.0), f82, (HEAP8[i10 >> 0] | 0) != 0, i74);
       i9 = i9 + 4 | 0;
      } while (i9 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 8:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i51 = i64 + 140 | 0;
      i39 = i71 + 4 | 0;
      i42 = i71 + 8 | 0;
      i45 = i71 + 12 | 0;
      i47 = i71 + 16 | 0;
      i49 = i71 + 20 | 0;
      i34 = i71 + 24 | 0;
      i36 = i71 + 28 | 0;
      i40 = i69 + 4 | 0;
      i43 = i69 + 8 | 0;
      i46 = i69 + 12 | 0;
      i48 = i69 + 16 | 0;
      i50 = i69 + 20 | 0;
      i35 = i69 + 24 | 0;
      i37 = i69 + 28 | 0;
      i33 = i69 + 32 | 0;
      i38 = i69 + 36 | 0;
      i41 = i69 + 40 | 0;
      i44 = i69 + 44 | 0;
      f28 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i6 = i62 + 4 | 0;
      i9 = i62 + 8 | 0;
      i12 = i62 + 12 | 0;
      i13 = i62 + 16 | 0;
      i5 = i62 + 20 | 0;
      i8 = i62 + 24 | 0;
      i11 = i62 + 28 | 0;
      i3 = i62 + 32 | 0;
      i4 = i62 + 36 | 0;
      i7 = i62 + 40 | 0;
      i10 = i62 + 44 | 0;
      i14 = i64 + 144 | 0;
      i15 = i64 + 148 | 0;
      i16 = i64 + 152 | 0;
      i17 = i64 + 156 | 0;
      i18 = i64 + 160 | 0;
      i19 = i64 + 164 | 0;
      i20 = i64 + 168 | 0;
      i21 = i64 + 172 | 0;
      i22 = i64 + 176 | 0;
      i23 = i64 + 180 | 0;
      i24 = i64 + 184 | 0;
      i25 = i64 + 188 | 0;
      i26 = i64 + 192 | 0;
      i29 = i64 + 196 | 0;
      i30 = i64 + 200 | 0;
      i31 = i64 + 204 | 0;
      i32 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      f27 = Math_fround(f60 * f60);
      i1 = i65;
      do {
       HEAPF32[i69 >> 2] = Math_fround(1.0);
       __Z23RandomPointInsideCircleR5RandNRKfS2_(i71, i51, i63, i69);
       f55 = Math_fround(HEAPF32[i71 >> 2]);
       f54 = Math_fround(HEAPF32[i39 >> 2]);
       f53 = Math_fround(HEAPF32[i42 >> 2]);
       f84 = Math_fround(HEAPF32[i45 >> 2]);
       f79 = Math_fround(HEAPF32[i47 >> 2]);
       f80 = Math_fround(HEAPF32[i49 >> 2]);
       f82 = Math_fround(HEAPF32[i34 >> 2]);
       f81 = Math_fround(HEAPF32[i36 >> 2]);
       f56 = Math_fround(f61 * f55);
       f57 = Math_fround(f61 * f54);
       f58 = Math_fround(f61 * f53);
       f59 = Math_fround(f61 * f84);
       f75 = Math_fround(f61 * f79);
       f76 = Math_fround(f61 * f80);
       f77 = Math_fround(f61 * f82);
       f78 = Math_fround(f61 * f81);
       HEAPF32[i69 >> 2] = f56;
       HEAPF32[i40 >> 2] = f57;
       HEAPF32[i43 >> 2] = f58;
       HEAPF32[i46 >> 2] = f59;
       HEAPF32[i48 >> 2] = f75;
       HEAPF32[i50 >> 2] = f76;
       HEAPF32[i35 >> 2] = f77;
       HEAPF32[i37 >> 2] = f78;
       HEAPF32[i33 >> 2] = f60;
       HEAPF32[i38 >> 2] = f60;
       HEAPF32[i41 >> 2] = f60;
       HEAPF32[i44 >> 2] = f60;
       f54 = Math_fround(f28 * f54);
       f53 = Math_fround(f28 * f53);
       f84 = Math_fround(f28 * f84);
       f79 = Math_fround(f28 * f79);
       f80 = Math_fround(f28 * f80);
       f82 = Math_fround(f28 * f82);
       f81 = Math_fround(f28 * f81);
       HEAPF32[i62 >> 2] = Math_fround(f28 * f55);
       HEAPF32[i6 >> 2] = f54;
       HEAPF32[i9 >> 2] = f53;
       HEAPF32[i12 >> 2] = f84;
       HEAPF32[i13 >> 2] = f79;
       HEAPF32[i5 >> 2] = f80;
       HEAPF32[i8 >> 2] = f82;
       HEAPF32[i11 >> 2] = f81;
       f81 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f75 * f75)) + f27);
       f82 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f76 * f76)) + f27);
       f80 = Math_fround(Math_fround(Math_fround(f58 * f58) + Math_fround(f77 * f77)) + f27);
       f79 = Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f78 * f78)) + f27);
       f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f53 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f82))));
       f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f80))));
       f55 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f79))));
       f56 = Math_fround(f56 * f84);
       f57 = Math_fround(f57 * f53);
       f58 = Math_fround(f58 * f54);
       f59 = Math_fround(f59 * f55);
       f75 = Math_fround(f75 * f84);
       f76 = Math_fround(f76 * f53);
       f77 = Math_fround(f77 * f54);
       f78 = Math_fround(f78 * f55);
       f84 = Math_fround(f60 * f84);
       f53 = Math_fround(f60 * f53);
       f54 = Math_fround(f60 * f54);
       f55 = Math_fround(f60 * f55);
       i85 = f81 > Math_fround(9.99999974e-06);
       i83 = f82 > Math_fround(9.99999974e-06);
       i64 = f80 > Math_fround(9.99999974e-06);
       i65 = f79 > Math_fround(9.99999974e-06);
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       i93 = HEAP32[i51 >> 2] | 0;
       i92 = HEAP32[i14 >> 2] | 0;
       i91 = HEAP32[i15 >> 2] | 0;
       i90 = HEAP32[i16 >> 2] | 0;
       i93 = i93 << 11 ^ i93;
       i92 = i92 << 11 ^ i92;
       i91 = i91 << 11 ^ i91;
       i90 = i90 << 11 ^ i90;
       i89 = HEAP32[i18 >> 2] | 0;
       i88 = HEAP32[i19 >> 2] | 0;
       i87 = HEAP32[i20 >> 2] | 0;
       HEAP32[i51 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i14 >> 2] = i89;
       HEAP32[i15 >> 2] = i88;
       HEAP32[i16 >> 2] = i87;
       i87 = HEAP32[i22 >> 2] | 0;
       i88 = HEAP32[i23 >> 2] | 0;
       i89 = HEAP32[i24 >> 2] | 0;
       HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i18 >> 2] = i87;
       HEAP32[i19 >> 2] = i88;
       HEAP32[i20 >> 2] = i89;
       i89 = HEAP32[i25 >> 2] | 0;
       i88 = HEAP32[i26 >> 2] | 0;
       i87 = HEAP32[i29 >> 2] | 0;
       i86 = HEAP32[i30 >> 2] | 0;
       HEAP32[i21 >> 2] = i89;
       HEAP32[i22 >> 2] = i88;
       HEAP32[i23 >> 2] = i87;
       HEAP32[i24 >> 2] = i86;
       i89 = i93 >>> 8 ^ i93 ^ i89 ^ i89 >>> 19;
       i88 = i92 >>> 8 ^ i92 ^ i88 ^ i88 >>> 19;
       i87 = i91 >>> 8 ^ i91 ^ i87 ^ i87 >>> 19;
       i86 = i90 >>> 8 ^ i90 ^ i86 ^ i86 >>> 19;
       HEAP32[i25 >> 2] = i89;
       HEAP32[i26 >> 2] = i88;
       HEAP32[i29 >> 2] = i87;
       HEAP32[i30 >> 2] = i86;
       f79 = Math_fround(f52 * Math_fround(Math_fround(i89 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f80 = Math_fround(f52 * Math_fround(Math_fround(i88 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f82 = Math_fround(f52 * Math_fround(Math_fround(i87 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f81 = Math_fround(f52 * Math_fround(Math_fround(i86 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f56 = Math_fround((i85 ? f56 : Math_fround(0.0)) * f79);
       f57 = Math_fround((i83 ? f57 : Math_fround(0.0)) * f80);
       f58 = Math_fround((i64 ? f58 : Math_fround(0.0)) * f82);
       f59 = Math_fround((i65 ? f59 : Math_fround(0.0)) * f81);
       f75 = Math_fround((i85 ? f75 : Math_fround(0.0)) * f79);
       f76 = Math_fround((i83 ? f76 : Math_fround(0.0)) * f80);
       f77 = Math_fround((i64 ? f77 : Math_fround(0.0)) * f82);
       f78 = Math_fround((i65 ? f78 : Math_fround(0.0)) * f81);
       f79 = Math_fround((i85 ? f84 : Math_fround(0.0)) * f79);
       f80 = Math_fround((i83 ? f53 : Math_fround(0.0)) * f80);
       f82 = Math_fround((i64 ? f54 : Math_fround(0.0)) * f82);
       f81 = Math_fround((i65 ? f55 : Math_fround(0.0)) * f81);
       f56 = Math_fround(f56 + Math_fround(HEAPF32[i62 >> 2]));
       f57 = Math_fround(f57 + Math_fround(HEAPF32[i6 >> 2]));
       f58 = Math_fround(f58 + Math_fround(HEAPF32[i9 >> 2]));
       f59 = Math_fround(f59 + Math_fround(HEAPF32[i12 >> 2]));
       HEAPF32[i62 >> 2] = f56;
       HEAPF32[i6 >> 2] = f57;
       HEAPF32[i9 >> 2] = f58;
       HEAPF32[i12 >> 2] = f59;
       f75 = Math_fround(f75 + Math_fround(HEAPF32[i13 >> 2]));
       f76 = Math_fround(f76 + Math_fround(HEAPF32[i5 >> 2]));
       f77 = Math_fround(f77 + Math_fround(HEAPF32[i8 >> 2]));
       f78 = Math_fround(f78 + Math_fround(HEAPF32[i11 >> 2]));
       HEAPF32[i13 >> 2] = f75;
       HEAPF32[i5 >> 2] = f76;
       HEAPF32[i8 >> 2] = f77;
       HEAPF32[i11 >> 2] = f78;
       f79 = Math_fround(f79 + Math_fround(HEAPF32[i3 >> 2]));
       f80 = Math_fround(f80 + Math_fround(HEAPF32[i4 >> 2]));
       f82 = Math_fround(f82 + Math_fround(HEAPF32[i7 >> 2]));
       f81 = Math_fround(f81 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i3 >> 2] = f79;
       HEAPF32[i4 >> 2] = f80;
       HEAPF32[i7 >> 2] = f82;
       HEAPF32[i10 >> 2] = f81;
       f81 = Math_fround(HEAPF32[i31 >> 2]);
       f82 = Math_fround(HEAPF32[i32 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i62, i69, i51, f81, f82, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 9:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i44 = i64 + 140 | 0;
      i45 = i71 + 4 | 0;
      i46 = i71 + 8 | 0;
      i47 = i71 + 12 | 0;
      i48 = i71 + 16 | 0;
      i49 = i71 + 20 | 0;
      i50 = i71 + 24 | 0;
      i51 = i71 + 28 | 0;
      i37 = i71 + 4 | 0;
      i39 = i71 + 8 | 0;
      i41 = i71 + 12 | 0;
      i42 = i71 + 16 | 0;
      i43 = i71 + 20 | 0;
      i34 = i71 + 24 | 0;
      i35 = i71 + 28 | 0;
      i33 = i71 + 32 | 0;
      i36 = i71 + 36 | 0;
      i38 = i71 + 40 | 0;
      i40 = i71 + 44 | 0;
      f28 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i6 = i69 + 4 | 0;
      i9 = i69 + 8 | 0;
      i12 = i69 + 12 | 0;
      i13 = i69 + 16 | 0;
      i5 = i69 + 20 | 0;
      i8 = i69 + 24 | 0;
      i11 = i69 + 28 | 0;
      i3 = i69 + 32 | 0;
      i4 = i69 + 36 | 0;
      i7 = i69 + 40 | 0;
      i10 = i69 + 44 | 0;
      i14 = i64 + 144 | 0;
      i15 = i64 + 148 | 0;
      i16 = i64 + 152 | 0;
      i17 = i64 + 156 | 0;
      i18 = i64 + 160 | 0;
      i19 = i64 + 164 | 0;
      i20 = i64 + 168 | 0;
      i21 = i64 + 172 | 0;
      i22 = i64 + 176 | 0;
      i23 = i64 + 180 | 0;
      i24 = i64 + 184 | 0;
      i25 = i64 + 188 | 0;
      i26 = i64 + 192 | 0;
      i29 = i64 + 196 | 0;
      i30 = i64 + 200 | 0;
      i31 = i64 + 204 | 0;
      i32 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      f27 = Math_fround(f60 * f60);
      i1 = i65;
      do {
       __Z17RandomUnitVector2R5RandN(i71, i44);
       f56 = Math_fround(HEAPF32[i71 >> 2]);
       f84 = Math_fround(f56 * f56);
       f55 = Math_fround(HEAPF32[i45 >> 2]);
       f81 = Math_fround(f55 * f55);
       f54 = Math_fround(HEAPF32[i46 >> 2]);
       f80 = Math_fround(f54 * f54);
       f53 = Math_fround(HEAPF32[i47 >> 2]);
       f57 = Math_fround(f53 * f53);
       f79 = Math_fround(HEAPF32[i48 >> 2]);
       f75 = Math_fround(f79 * f79);
       f78 = Math_fround(HEAPF32[i49 >> 2]);
       f59 = Math_fround(f78 * f78);
       f77 = Math_fround(HEAPF32[i50 >> 2]);
       f58 = Math_fround(f77 * f77);
       f76 = Math_fround(HEAPF32[i51 >> 2]);
       f75 = Math_fround(f84 + f75);
       f59 = Math_fround(f81 + f59);
       f58 = Math_fround(f80 + f58);
       f57 = Math_fround(f57 + Math_fround(f76 * f76));
       f80 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
       f81 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f59))));
       f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f58))));
       f82 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f57))));
       f56 = Math_fround(f56 * f80);
       f55 = Math_fround(f55 * f81);
       f54 = Math_fround(f54 * f84);
       f53 = Math_fround(f53 * f82);
       f80 = Math_fround(f79 * f80);
       f81 = Math_fround(f78 * f81);
       f84 = Math_fround(f77 * f84);
       f82 = Math_fround(f76 * f82);
       i93 = f75 > Math_fround(9.99999974e-06);
       i92 = f59 > Math_fround(9.99999974e-06);
       i91 = f58 > Math_fround(9.99999974e-06);
       i90 = f57 > Math_fround(9.99999974e-06);
       f56 = i93 ? f56 : Math_fround(0.0);
       f55 = i92 ? f55 : Math_fround(0.0);
       f54 = i91 ? f54 : Math_fround(0.0);
       f53 = i90 ? f53 : Math_fround(0.0);
       f80 = i93 ? f80 : Math_fround(0.0);
       f81 = i92 ? f81 : Math_fround(0.0);
       f84 = i91 ? f84 : Math_fround(0.0);
       f82 = i90 ? f82 : Math_fround(0.0);
       f57 = Math_fround(f61 * f56);
       f58 = Math_fround(f61 * f55);
       f59 = Math_fround(f61 * f54);
       f75 = Math_fround(f61 * f53);
       f76 = Math_fround(f61 * f80);
       f77 = Math_fround(f61 * f81);
       f78 = Math_fround(f61 * f84);
       f79 = Math_fround(f61 * f82);
       HEAPF32[i71 >> 2] = f57;
       HEAPF32[i37 >> 2] = f58;
       HEAPF32[i39 >> 2] = f59;
       HEAPF32[i41 >> 2] = f75;
       HEAPF32[i42 >> 2] = f76;
       HEAPF32[i43 >> 2] = f77;
       HEAPF32[i34 >> 2] = f78;
       HEAPF32[i35 >> 2] = f79;
       HEAPF32[i33 >> 2] = f60;
       HEAPF32[i36 >> 2] = f60;
       HEAPF32[i38 >> 2] = f60;
       HEAPF32[i40 >> 2] = f60;
       f55 = Math_fround(f28 * f55);
       f54 = Math_fround(f28 * f54);
       f53 = Math_fround(f28 * f53);
       f80 = Math_fround(f28 * f80);
       f81 = Math_fround(f28 * f81);
       f84 = Math_fround(f28 * f84);
       f82 = Math_fround(f28 * f82);
       HEAPF32[i69 >> 2] = Math_fround(f28 * f56);
       HEAPF32[i6 >> 2] = f55;
       HEAPF32[i9 >> 2] = f54;
       HEAPF32[i12 >> 2] = f53;
       HEAPF32[i13 >> 2] = f80;
       HEAPF32[i5 >> 2] = f81;
       HEAPF32[i8 >> 2] = f84;
       HEAPF32[i11 >> 2] = f82;
       f82 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f76 * f76)) + f27);
       f84 = Math_fround(Math_fround(Math_fround(f58 * f58) + Math_fround(f77 * f77)) + f27);
       f81 = Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f78 * f78)) + f27);
       f80 = Math_fround(Math_fround(Math_fround(f75 * f75) + Math_fround(f79 * f79)) + f27);
       f53 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f82))));
       f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f84))));
       f55 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f80))));
       f57 = Math_fround(f57 * f53);
       f58 = Math_fround(f58 * f54);
       f59 = Math_fround(f59 * f55);
       f75 = Math_fround(f75 * f56);
       f76 = Math_fround(f76 * f53);
       f77 = Math_fround(f77 * f54);
       f78 = Math_fround(f78 * f55);
       f79 = Math_fround(f79 * f56);
       f53 = Math_fround(f60 * f53);
       f54 = Math_fround(f60 * f54);
       f55 = Math_fround(f60 * f55);
       f56 = Math_fround(f60 * f56);
       i90 = f82 > Math_fround(9.99999974e-06);
       i91 = f84 > Math_fround(9.99999974e-06);
       i92 = f81 > Math_fround(9.99999974e-06);
       i93 = f80 > Math_fround(9.99999974e-06);
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       i64 = HEAP32[i44 >> 2] | 0;
       i65 = HEAP32[i14 >> 2] | 0;
       i83 = HEAP32[i15 >> 2] | 0;
       i85 = HEAP32[i16 >> 2] | 0;
       i64 = i64 << 11 ^ i64;
       i65 = i65 << 11 ^ i65;
       i83 = i83 << 11 ^ i83;
       i85 = i85 << 11 ^ i85;
       i86 = HEAP32[i18 >> 2] | 0;
       i87 = HEAP32[i19 >> 2] | 0;
       i88 = HEAP32[i20 >> 2] | 0;
       HEAP32[i44 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i14 >> 2] = i86;
       HEAP32[i15 >> 2] = i87;
       HEAP32[i16 >> 2] = i88;
       i88 = HEAP32[i22 >> 2] | 0;
       i87 = HEAP32[i23 >> 2] | 0;
       i86 = HEAP32[i24 >> 2] | 0;
       HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i18 >> 2] = i88;
       HEAP32[i19 >> 2] = i87;
       HEAP32[i20 >> 2] = i86;
       i86 = HEAP32[i25 >> 2] | 0;
       i87 = HEAP32[i26 >> 2] | 0;
       i88 = HEAP32[i29 >> 2] | 0;
       i89 = HEAP32[i30 >> 2] | 0;
       HEAP32[i21 >> 2] = i86;
       HEAP32[i22 >> 2] = i87;
       HEAP32[i23 >> 2] = i88;
       HEAP32[i24 >> 2] = i89;
       i86 = i64 >>> 8 ^ i64 ^ i86 ^ i86 >>> 19;
       i87 = i65 >>> 8 ^ i65 ^ i87 ^ i87 >>> 19;
       i88 = i83 >>> 8 ^ i83 ^ i88 ^ i88 >>> 19;
       i89 = i85 >>> 8 ^ i85 ^ i89 ^ i89 >>> 19;
       HEAP32[i25 >> 2] = i86;
       HEAP32[i26 >> 2] = i87;
       HEAP32[i29 >> 2] = i88;
       HEAP32[i30 >> 2] = i89;
       f80 = Math_fround(f52 * Math_fround(Math_fround(i86 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f81 = Math_fround(f52 * Math_fround(Math_fround(i87 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f84 = Math_fround(f52 * Math_fround(Math_fround(i88 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f82 = Math_fround(f52 * Math_fround(Math_fround(i89 & 8388607 | 0) * Math_fround(1.19209304e-07)));
       f57 = Math_fround((i90 ? f57 : Math_fround(0.0)) * f80);
       f58 = Math_fround((i91 ? f58 : Math_fround(0.0)) * f81);
       f59 = Math_fround((i92 ? f59 : Math_fround(0.0)) * f84);
       f75 = Math_fround((i93 ? f75 : Math_fround(0.0)) * f82);
       f76 = Math_fround((i90 ? f76 : Math_fround(0.0)) * f80);
       f77 = Math_fround((i91 ? f77 : Math_fround(0.0)) * f81);
       f78 = Math_fround((i92 ? f78 : Math_fround(0.0)) * f84);
       f79 = Math_fround((i93 ? f79 : Math_fround(0.0)) * f82);
       f80 = Math_fround((i90 ? f53 : Math_fround(0.0)) * f80);
       f81 = Math_fround((i91 ? f54 : Math_fround(0.0)) * f81);
       f84 = Math_fround((i92 ? f55 : Math_fround(0.0)) * f84);
       f82 = Math_fround((i93 ? f56 : Math_fround(0.0)) * f82);
       f57 = Math_fround(f57 + Math_fround(HEAPF32[i69 >> 2]));
       f58 = Math_fround(f58 + Math_fround(HEAPF32[i6 >> 2]));
       f59 = Math_fround(f59 + Math_fround(HEAPF32[i9 >> 2]));
       f75 = Math_fround(f75 + Math_fround(HEAPF32[i12 >> 2]));
       HEAPF32[i69 >> 2] = f57;
       HEAPF32[i6 >> 2] = f58;
       HEAPF32[i9 >> 2] = f59;
       HEAPF32[i12 >> 2] = f75;
       f76 = Math_fround(f76 + Math_fround(HEAPF32[i13 >> 2]));
       f77 = Math_fround(f77 + Math_fround(HEAPF32[i5 >> 2]));
       f78 = Math_fround(f78 + Math_fround(HEAPF32[i8 >> 2]));
       f79 = Math_fround(f79 + Math_fround(HEAPF32[i11 >> 2]));
       HEAPF32[i13 >> 2] = f76;
       HEAPF32[i5 >> 2] = f77;
       HEAPF32[i8 >> 2] = f78;
       HEAPF32[i11 >> 2] = f79;
       f80 = Math_fround(f80 + Math_fround(HEAPF32[i3 >> 2]));
       f81 = Math_fround(f81 + Math_fround(HEAPF32[i4 >> 2]));
       f84 = Math_fround(f84 + Math_fround(HEAPF32[i7 >> 2]));
       f82 = Math_fround(f82 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i3 >> 2] = f80;
       HEAPF32[i4 >> 2] = f81;
       HEAPF32[i7 >> 2] = f84;
       HEAPF32[i10 >> 2] = f82;
       f82 = Math_fround(HEAPF32[i31 >> 2]);
       f84 = Math_fround(HEAPF32[i32 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i69, i71, i44, f82, f84, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 10:
    {
     f28 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i64 + 36 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
     if (i66 >>> 0 > i65 >>> 0) {
      i16 = i64 + 140 | 0;
      i17 = i64 + 144 | 0;
      i18 = i64 + 148 | 0;
      i19 = i64 + 152 | 0;
      i20 = i64 + 156 | 0;
      i21 = i64 + 160 | 0;
      i22 = i64 + 164 | 0;
      i23 = i64 + 168 | 0;
      i24 = i64 + 172 | 0;
      i25 = i64 + 176 | 0;
      i26 = i64 + 180 | 0;
      i29 = i64 + 184 | 0;
      i30 = i64 + 188 | 0;
      i31 = i64 + 192 | 0;
      i32 = i64 + 196 | 0;
      i33 = i64 + 200 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i6 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i10 = i71 + 12 | 0;
      i4 = i71 + 16 | 0;
      i5 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i9 = i71 + 28 | 0;
      i3 = i71 + 32 | 0;
      i11 = i69 + 16 | 0;
      i12 = i69 + 32 | 0;
      i13 = i71 + 32 | 0;
      i14 = i64 + 204 | 0;
      i15 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       i90 = HEAP32[i16 >> 2] | 0;
       i91 = HEAP32[i17 >> 2] | 0;
       i92 = HEAP32[i18 >> 2] | 0;
       i93 = HEAP32[i19 >> 2] | 0;
       i90 = i90 << 11 ^ i90;
       i91 = i91 << 11 ^ i91;
       i92 = i92 << 11 ^ i92;
       i93 = i93 << 11 ^ i93;
       i64 = HEAP32[i20 >> 2] | 0;
       i83 = HEAP32[i21 >> 2] | 0;
       i86 = HEAP32[i22 >> 2] | 0;
       i88 = HEAP32[i23 >> 2] | 0;
       i46 = HEAP32[i25 >> 2] | 0;
       i47 = HEAP32[i26 >> 2] | 0;
       i48 = HEAP32[i29 >> 2] | 0;
       i49 = HEAP32[i30 >> 2] | 0;
       i50 = HEAP32[i31 >> 2] | 0;
       i51 = HEAP32[i32 >> 2] | 0;
       i62 = HEAP32[i33 >> 2] | 0;
       i90 = i90 >>> 8 ^ i90 ^ i49;
       i65 = i90 ^ i49 >>> 19;
       i91 = i91 >>> 8 ^ i91 ^ i50;
       i85 = i91 ^ i50 >>> 19;
       i92 = i92 >>> 8 ^ i92 ^ i51;
       i87 = i92 ^ i51 >>> 19;
       i93 = i93 >>> 8 ^ i93 ^ i62;
       i89 = i93 ^ i62 >>> 19;
       f84 = Math_fround(Math_fround(i65 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f81 = Math_fround(Math_fround(i85 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f80 = Math_fround(Math_fround(i87 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f61 = Math_fround(Math_fround(i89 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f84 = Math_fround(Math_fround(f84 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f84)));
       f81 = Math_fround(Math_fround(f81 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f81)));
       f80 = Math_fround(Math_fround(f80 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f80)));
       f61 = Math_fround(Math_fround(f61 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f61)));
       i64 = i64 << 11 ^ i64;
       i83 = i83 << 11 ^ i83;
       i86 = i86 << 11 ^ i86;
       i88 = i88 << 11 ^ i88;
       HEAP32[i16 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i17 >> 2] = i46;
       HEAP32[i18 >> 2] = i47;
       HEAP32[i19 >> 2] = i48;
       HEAP32[i20 >> 2] = i49;
       HEAP32[i21 >> 2] = i50;
       HEAP32[i22 >> 2] = i51;
       HEAP32[i23 >> 2] = i62;
       HEAP32[i24 >> 2] = i65;
       HEAP32[i25 >> 2] = i85;
       HEAP32[i26 >> 2] = i87;
       HEAP32[i29 >> 2] = i89;
       i90 = i64 >>> 8 ^ i64 ^ i65 ^ i90 >>> 19;
       i91 = i83 >>> 8 ^ i83 ^ i85 ^ i91 >>> 19;
       i92 = i86 >>> 8 ^ i86 ^ i87 ^ i92 >>> 19;
       i93 = i88 >>> 8 ^ i88 ^ i89 ^ i93 >>> 19;
       HEAP32[i30 >> 2] = i90;
       HEAP32[i31 >> 2] = i91;
       HEAP32[i32 >> 2] = i92;
       HEAP32[i33 >> 2] = i93;
       f94 = Math_fround(Math_fround(i90 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f54 = Math_fround(Math_fround(i91 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f57 = Math_fround(Math_fround(i92 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f75 = Math_fround(Math_fround(i93 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f60 = Math_fround(HEAPF32[i63 >> 2]);
       f94 = Math_fround(Math_fround(f27 * Math_fround(Math_fround(1.0) - f94)) + Math_fround(f94 * f60));
       f54 = Math_fround(Math_fround(f27 * Math_fround(Math_fround(1.0) - f54)) + Math_fround(f54 * f60));
       f57 = Math_fround(Math_fround(f27 * Math_fround(Math_fround(1.0) - f57)) + Math_fround(f57 * f60));
       f60 = Math_fround(Math_fround(f27 * Math_fround(Math_fround(1.0) - f75)) + Math_fround(f75 * f60));
       f84 = Math_fround(f84 * Math_fround(.159154937));
       f81 = Math_fround(f81 * Math_fround(.159154937));
       f80 = Math_fround(f80 * Math_fround(.159154937));
       f61 = Math_fround(f61 * Math_fround(.159154937));
       f75 = Math_fround(+_roundf(+f84));
       f56 = Math_fround(+_roundf(+f81));
       f82 = Math_fround(+_roundf(+f80));
       f75 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f84 - f75))));
       f56 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f81 - f56))));
       f82 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f80 - f82))));
       f55 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f61 - Math_fround(+_roundf(+f61))))));
       f76 = Math_fround(f75 * f75);
       f77 = Math_fround(f56 * f56);
       f78 = Math_fround(f82 * f82);
       f79 = Math_fround(f55 * f55);
       f59 = Math_fround(f76 * f76);
       f53 = Math_fround(f77 * f77);
       f58 = Math_fround(f78 * f78);
       f52 = Math_fround(f79 * f79);
       f76 = Math_fround(f94 * Math_fround(f75 * Math_fround(Math_fround(Math_fround(f59 * f59) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f76 * Math_fround(41.3416595))) + Math_fround(f59 * Math_fround(Math_fround(81.6018218) - Math_fround(f76 * Math_fround(76.5686187))))))));
       f77 = Math_fround(f54 * Math_fround(f56 * Math_fround(Math_fround(Math_fround(f53 * f53) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f77 * Math_fround(41.3416595))) + Math_fround(f53 * Math_fround(Math_fround(81.6018218) - Math_fround(f77 * Math_fround(76.5686187))))))));
       f78 = Math_fround(f57 * Math_fround(f82 * Math_fround(Math_fround(Math_fround(f58 * f58) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f78 * Math_fround(41.3416595))) + Math_fround(f58 * Math_fround(Math_fround(81.6018218) - Math_fround(f78 * Math_fround(76.5686187))))))));
       f79 = Math_fround(f60 * Math_fround(f55 * Math_fround(Math_fround(Math_fround(f52 * f52) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f79 * Math_fround(41.3416595))) + Math_fround(f52 * Math_fround(Math_fround(81.6018218) - Math_fround(f79 * Math_fround(76.5686187))))))));
       f84 = Math_fround(f84 + Math_fround(-.25));
       f81 = Math_fround(f81 + Math_fround(-.25));
       f80 = Math_fround(f80 + Math_fround(-.25));
       f61 = Math_fround(f61 + Math_fround(-.25));
       f52 = Math_fround(+_roundf(+f84));
       f55 = Math_fround(+_roundf(+f81));
       f58 = Math_fround(+_roundf(+f80));
       f52 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f84 - f52))));
       f55 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f81 - f55))));
       f58 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f80 - f58))));
       f61 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f61 - Math_fround(+_roundf(+f61))))));
       f80 = Math_fround(f52 * f52);
       f81 = Math_fround(f55 * f55);
       f84 = Math_fround(f58 * f58);
       f82 = Math_fround(f61 * f61);
       f53 = Math_fround(f80 * f80);
       f56 = Math_fround(f81 * f81);
       f59 = Math_fround(f84 * f84);
       f75 = Math_fround(f82 * f82);
       f80 = Math_fround(f94 * Math_fround(f52 * Math_fround(Math_fround(Math_fround(f53 * f53) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f80 * Math_fround(41.3416595))) + Math_fround(f53 * Math_fround(Math_fround(81.6018218) - Math_fround(f80 * Math_fround(76.5686187))))))));
       f81 = Math_fround(f54 * Math_fround(f55 * Math_fround(Math_fround(Math_fround(f56 * f56) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f81 * Math_fround(41.3416595))) + Math_fround(f56 * Math_fround(Math_fround(81.6018218) - Math_fround(f81 * Math_fround(76.5686187))))))));
       f84 = Math_fround(f57 * Math_fround(f58 * Math_fround(Math_fround(Math_fround(f59 * f59) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f84 * Math_fround(41.3416595))) + Math_fround(f59 * Math_fround(Math_fround(81.6018218) - Math_fround(f84 * Math_fround(76.5686187))))))));
       f82 = Math_fround(f60 * Math_fround(f61 * Math_fround(Math_fround(Math_fround(f75 * f75) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f82 * Math_fround(41.3416595))) + Math_fround(f75 * Math_fround(Math_fround(81.6018218) - Math_fround(f82 * Math_fround(76.5686187))))))));
       HEAPF32[i71 >> 2] = f76;
       HEAPF32[i6 >> 2] = f77;
       HEAPF32[i8 >> 2] = f78;
       HEAPF32[i10 >> 2] = f79;
       HEAPF32[i4 >> 2] = f80;
       HEAPF32[i5 >> 2] = f81;
       HEAPF32[i7 >> 2] = f84;
       HEAPF32[i9 >> 2] = f82;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i11 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
       f82 = Math_fround(HEAPF32[i14 >> 2]);
       f84 = Math_fround(HEAPF32[i15 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i16, f82, f84, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 11:
    {
     f28 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i64 + 36 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
     if (i66 >>> 0 > i65 >>> 0) {
      i16 = i64 + 140 | 0;
      i17 = i64 + 144 | 0;
      i18 = i64 + 148 | 0;
      i19 = i64 + 152 | 0;
      i20 = i64 + 156 | 0;
      i21 = i64 + 160 | 0;
      i22 = i64 + 164 | 0;
      i23 = i64 + 168 | 0;
      i24 = i64 + 172 | 0;
      i25 = i64 + 176 | 0;
      i26 = i64 + 180 | 0;
      i29 = i64 + 184 | 0;
      i30 = i64 + 188 | 0;
      i31 = i64 + 192 | 0;
      i32 = i64 + 196 | 0;
      i33 = i64 + 200 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i6 = i71 + 4 | 0;
      i8 = i71 + 8 | 0;
      i10 = i71 + 12 | 0;
      i4 = i71 + 16 | 0;
      i5 = i71 + 20 | 0;
      i7 = i71 + 24 | 0;
      i9 = i71 + 28 | 0;
      i3 = i71 + 32 | 0;
      i11 = i69 + 16 | 0;
      i12 = i69 + 32 | 0;
      i13 = i71 + 32 | 0;
      i14 = i64 + 204 | 0;
      i15 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       i86 = HEAP32[i16 >> 2] | 0;
       i87 = HEAP32[i17 >> 2] | 0;
       i88 = HEAP32[i18 >> 2] | 0;
       i89 = HEAP32[i19 >> 2] | 0;
       i86 = i86 << 11 ^ i86;
       i87 = i87 << 11 ^ i87;
       i88 = i88 << 11 ^ i88;
       i89 = i89 << 11 ^ i89;
       i90 = HEAP32[i21 >> 2] | 0;
       i91 = HEAP32[i22 >> 2] | 0;
       i92 = HEAP32[i23 >> 2] | 0;
       HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i17 >> 2] = i90;
       HEAP32[i18 >> 2] = i91;
       HEAP32[i19 >> 2] = i92;
       i92 = HEAP32[i25 >> 2] | 0;
       i91 = HEAP32[i26 >> 2] | 0;
       i90 = HEAP32[i29 >> 2] | 0;
       HEAP32[i20 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i21 >> 2] = i92;
       HEAP32[i22 >> 2] = i91;
       HEAP32[i23 >> 2] = i90;
       i90 = HEAP32[i30 >> 2] | 0;
       i91 = HEAP32[i31 >> 2] | 0;
       i92 = HEAP32[i32 >> 2] | 0;
       i93 = HEAP32[i33 >> 2] | 0;
       HEAP32[i24 >> 2] = i90;
       HEAP32[i25 >> 2] = i91;
       HEAP32[i26 >> 2] = i92;
       HEAP32[i29 >> 2] = i93;
       i90 = i86 >>> 8 ^ i86 ^ i90 ^ i90 >>> 19;
       i91 = i87 >>> 8 ^ i87 ^ i91 ^ i91 >>> 19;
       i92 = i88 >>> 8 ^ i88 ^ i92 ^ i92 >>> 19;
       i93 = i89 >>> 8 ^ i89 ^ i93 ^ i93 >>> 19;
       HEAP32[i30 >> 2] = i90;
       HEAP32[i31 >> 2] = i91;
       HEAP32[i32 >> 2] = i92;
       HEAP32[i33 >> 2] = i93;
       f94 = Math_fround(Math_fround(i90 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f82 = Math_fround(Math_fround(i91 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f81 = Math_fround(Math_fround(i92 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f75 = Math_fround(Math_fround(i93 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f94 = Math_fround(Math_fround(Math_fround(f94 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f94))) * Math_fround(.159154937));
       f82 = Math_fround(Math_fround(Math_fround(f82 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f82))) * Math_fround(.159154937));
       f81 = Math_fround(Math_fround(Math_fround(f81 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f81))) * Math_fround(.159154937));
       f75 = Math_fround(Math_fround(Math_fround(f75 * Math_fround(0.0)) + Math_fround(f28 * Math_fround(Math_fround(1.0) - f75))) * Math_fround(.159154937));
       f76 = Math_fround(+_roundf(+f94));
       f59 = Math_fround(+_roundf(+f82));
       f84 = Math_fround(+_roundf(+f81));
       f76 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f94 - f76))));
       f59 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f82 - f59))));
       f84 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f81 - f84))));
       f58 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f75 - Math_fround(+_roundf(+f75))))));
       f77 = Math_fround(f76 * f76);
       f78 = Math_fround(f59 * f59);
       f79 = Math_fround(f84 * f84);
       f80 = Math_fround(f58 * f58);
       f61 = Math_fround(f77 * f77);
       f57 = Math_fround(f78 * f78);
       f60 = Math_fround(f79 * f79);
       f56 = Math_fround(f80 * f80);
       f77 = Math_fround(f27 * Math_fround(f76 * Math_fround(Math_fround(Math_fround(f61 * f61) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f77 * Math_fround(41.3416595))) + Math_fround(f61 * Math_fround(Math_fround(81.6018218) - Math_fround(f77 * Math_fround(76.5686187))))))));
       f78 = Math_fround(f27 * Math_fround(f59 * Math_fround(Math_fround(Math_fround(f57 * f57) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f78 * Math_fround(41.3416595))) + Math_fround(f57 * Math_fround(Math_fround(81.6018218) - Math_fround(f78 * Math_fround(76.5686187))))))));
       f79 = Math_fround(f27 * Math_fround(f84 * Math_fround(Math_fround(Math_fround(f60 * f60) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f79 * Math_fround(41.3416595))) + Math_fround(f60 * Math_fround(Math_fround(81.6018218) - Math_fround(f79 * Math_fround(76.5686187))))))));
       f80 = Math_fround(f27 * Math_fround(f58 * Math_fround(Math_fround(Math_fround(f56 * f56) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f80 * Math_fround(41.3416595))) + Math_fround(f56 * Math_fround(Math_fround(81.6018218) - Math_fround(f80 * Math_fround(76.5686187))))))));
       f94 = Math_fround(f94 + Math_fround(-.25));
       f82 = Math_fround(f82 + Math_fround(-.25));
       f81 = Math_fround(f81 + Math_fround(-.25));
       f75 = Math_fround(f75 + Math_fround(-.25));
       f56 = Math_fround(+_roundf(+f94));
       f58 = Math_fround(+_roundf(+f82));
       f60 = Math_fround(+_roundf(+f81));
       f56 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f94 - f56))));
       f58 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f82 - f58))));
       f60 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f81 - f60))));
       f75 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f75 - Math_fround(+_roundf(+f75))))));
       f81 = Math_fround(f56 * f56);
       f82 = Math_fround(f58 * f58);
       f94 = Math_fround(f60 * f60);
       f84 = Math_fround(f75 * f75);
       f57 = Math_fround(f81 * f81);
       f59 = Math_fround(f82 * f82);
       f61 = Math_fround(f94 * f94);
       f76 = Math_fround(f84 * f84);
       f81 = Math_fround(f27 * Math_fround(f56 * Math_fround(Math_fround(Math_fround(f57 * f57) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f81 * Math_fround(41.3416595))) + Math_fround(f57 * Math_fround(Math_fround(81.6018218) - Math_fround(f81 * Math_fround(76.5686187))))))));
       f82 = Math_fround(f27 * Math_fround(f58 * Math_fround(Math_fround(Math_fround(f59 * f59) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f82 * Math_fround(41.3416595))) + Math_fround(f59 * Math_fround(Math_fround(81.6018218) - Math_fround(f82 * Math_fround(76.5686187))))))));
       f94 = Math_fround(f27 * Math_fround(f60 * Math_fround(Math_fround(Math_fround(f61 * f61) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f94 * Math_fround(41.3416595))) + Math_fround(f61 * Math_fround(Math_fround(81.6018218) - Math_fround(f94 * Math_fround(76.5686187))))))));
       f84 = Math_fround(f27 * Math_fround(f75 * Math_fround(Math_fround(Math_fround(f76 * f76) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f84 * Math_fround(41.3416595))) + Math_fround(f76 * Math_fround(Math_fround(81.6018218) - Math_fround(f84 * Math_fround(76.5686187))))))));
       HEAPF32[i71 >> 2] = f77;
       HEAPF32[i6 >> 2] = f78;
       HEAPF32[i8 >> 2] = f79;
       HEAPF32[i10 >> 2] = f80;
       HEAPF32[i4 >> 2] = f81;
       HEAPF32[i5 >> 2] = f82;
       HEAPF32[i7 >> 2] = f94;
       HEAPF32[i9 >> 2] = f84;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP32[i69 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i69 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i69 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i69 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i11 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
       f84 = Math_fround(HEAPF32[i14 >> 2]);
       f94 = Math_fround(HEAPF32[i15 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i16, f84, f94, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 12:
    {
     if (i66 >>> 0 > i65 >>> 0) {
      i31 = i64 + 140 | 0;
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f28 = Math_fround(-f27);
      i12 = i64 + 144 | 0;
      i13 = i64 + 148 | 0;
      i14 = i64 + 152 | 0;
      i15 = i64 + 156 | 0;
      i16 = i64 + 160 | 0;
      i17 = i64 + 164 | 0;
      i18 = i64 + 168 | 0;
      i19 = i64 + 172 | 0;
      i20 = i64 + 176 | 0;
      i21 = i64 + 180 | 0;
      i22 = i64 + 184 | 0;
      i23 = i64 + 188 | 0;
      i24 = i64 + 192 | 0;
      i25 = i64 + 196 | 0;
      i26 = i64 + 200 | 0;
      i7 = i71 + 4 | 0;
      i9 = i71 + 8 | 0;
      i11 = i71 + 12 | 0;
      i5 = i71 + 16 | 0;
      i4 = i69 + 16 | 0;
      i6 = i69 + 20 | 0;
      i8 = i69 + 24 | 0;
      i10 = i69 + 28 | 0;
      i3 = i69 + 32 | 0;
      i29 = i64 + 204 | 0;
      i30 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       i86 = HEAP32[i31 >> 2] | 0;
       i87 = HEAP32[i12 >> 2] | 0;
       i88 = HEAP32[i13 >> 2] | 0;
       i89 = HEAP32[i14 >> 2] | 0;
       i86 = i86 << 11 ^ i86;
       i87 = i87 << 11 ^ i87;
       i88 = i88 << 11 ^ i88;
       i89 = i89 << 11 ^ i89;
       i90 = HEAP32[i16 >> 2] | 0;
       i91 = HEAP32[i17 >> 2] | 0;
       i92 = HEAP32[i18 >> 2] | 0;
       HEAP32[i31 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i12 >> 2] = i90;
       HEAP32[i13 >> 2] = i91;
       HEAP32[i14 >> 2] = i92;
       i92 = HEAP32[i20 >> 2] | 0;
       i91 = HEAP32[i21 >> 2] | 0;
       i90 = HEAP32[i22 >> 2] | 0;
       HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i16 >> 2] = i92;
       HEAP32[i17 >> 2] = i91;
       HEAP32[i18 >> 2] = i90;
       i90 = HEAP32[i23 >> 2] | 0;
       i91 = HEAP32[i24 >> 2] | 0;
       i92 = HEAP32[i25 >> 2] | 0;
       i93 = HEAP32[i26 >> 2] | 0;
       HEAP32[i19 >> 2] = i90;
       HEAP32[i20 >> 2] = i91;
       HEAP32[i21 >> 2] = i92;
       HEAP32[i22 >> 2] = i93;
       i90 = i86 >>> 8 ^ i86 ^ i90 ^ i90 >>> 19;
       i91 = i87 >>> 8 ^ i87 ^ i91 ^ i91 >>> 19;
       i92 = i88 >>> 8 ^ i88 ^ i92 ^ i92 >>> 19;
       i93 = i89 >>> 8 ^ i89 ^ i93 ^ i93 >>> 19;
       HEAP32[i23 >> 2] = i90;
       HEAP32[i24 >> 2] = i91;
       HEAP32[i25 >> 2] = i92;
       HEAP32[i26 >> 2] = i93;
       f81 = Math_fround(Math_fround(i90 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f82 = Math_fround(Math_fround(i91 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f94 = Math_fround(Math_fround(i92 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f84 = Math_fround(Math_fround(i93 & 8388607 | 0) * Math_fround(1.19209304e-07));
       f82 = Math_fround(Math_fround(f82 * f28) + Math_fround(f27 * Math_fround(Math_fround(1.0) - f82)));
       f94 = Math_fround(Math_fround(f94 * f28) + Math_fround(f27 * Math_fround(Math_fround(1.0) - f94)));
       f84 = Math_fround(Math_fround(f84 * f28) + Math_fround(f27 * Math_fround(Math_fround(1.0) - f84)));
       HEAPF32[i71 >> 2] = Math_fround(Math_fround(f81 * f28) + Math_fround(f27 * Math_fround(Math_fround(1.0) - f81)));
       HEAPF32[i7 >> 2] = f82;
       HEAPF32[i9 >> 2] = f94;
       HEAPF32[i11 >> 2] = f84;
       HEAP32[i5 >> 2] = 0;
       HEAP32[i5 + 4 >> 2] = 0;
       HEAP32[i5 + 8 >> 2] = 0;
       HEAP32[i5 + 12 >> 2] = 0;
       HEAP32[i5 + 16 >> 2] = 0;
       HEAP32[i5 + 20 >> 2] = 0;
       HEAP32[i5 + 24 >> 2] = 0;
       HEAP32[i5 + 28 >> 2] = 0;
       HEAP32[i69 >> 2] = 0;
       HEAP32[i69 + 4 >> 2] = 0;
       HEAP32[i69 + 8 >> 2] = 0;
       HEAP32[i69 + 12 >> 2] = 0;
       HEAPF32[i4 >> 2] = Math_fround(1.0);
       HEAPF32[i6 >> 2] = Math_fround(1.0);
       HEAPF32[i8 >> 2] = Math_fround(1.0);
       HEAPF32[i10 >> 2] = Math_fround(1.0);
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       f84 = Math_fround(HEAPF32[i29 >> 2]);
       f94 = Math_fround(HEAPF32[i30 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i71, i69, i31, f84, f94, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 5:
    {
     HEAPF32[i71 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 24 >> 2]) * Math_fround(.5));
     HEAPF32[i71 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 28 >> 2]) * Math_fround(.5));
     HEAPF32[i71 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 32 >> 2]) * Math_fround(.5));
     if (i66 >>> 0 > i65 >>> 0) {
      i8 = i64 + 140 | 0;
      i4 = i62 + 16 | 0;
      i3 = i62 + 32 | 0;
      i5 = i62 + 36 | 0;
      i6 = i62 + 40 | 0;
      i7 = i62 + 44 | 0;
      i9 = i64 + 204 | 0;
      i10 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       __Z21RandomPointInsideCubeR5RandNPKf(i69, i8, i71);
       HEAP32[i62 >> 2] = 0;
       HEAP32[i62 + 4 >> 2] = 0;
       HEAP32[i62 + 8 >> 2] = 0;
       HEAP32[i62 + 12 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = 0;
       HEAP32[i4 + 12 >> 2] = 0;
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAPF32[i5 >> 2] = Math_fround(1.0);
       HEAPF32[i6 >> 2] = Math_fround(1.0);
       HEAPF32[i7 >> 2] = Math_fround(1.0);
       f84 = Math_fround(HEAPF32[i9 >> 2]);
       f94 = Math_fround(HEAPF32[i10 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i69, i62, i8, f84, f94, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 15:
    {
     HEAPF32[i71 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 24 >> 2]) * Math_fround(.5));
     i8 = i71 + 4 | 0;
     HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 28 >> 2]) * Math_fround(.5));
     i9 = i71 + 8 | 0;
     HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 32 >> 2]) * Math_fround(.5));
     if (i66 >>> 0 > i65 >>> 0) {
      i10 = i64 + 140 | 0;
      i11 = i69 + 4 | 0;
      i12 = i69 + 8 | 0;
      i13 = i69 + 12 | 0;
      i14 = i62 + 4 | 0;
      i15 = i62 + 8 | 0;
      i16 = i62 + 12 | 0;
      i17 = i69 + 16 | 0;
      i18 = i69 + 20 | 0;
      i19 = i69 + 24 | 0;
      i20 = i69 + 28 | 0;
      i21 = i69 + 32 | 0;
      i22 = i69 + 36 | 0;
      i23 = i69 + 40 | 0;
      i24 = i69 + 44 | 0;
      i4 = i29 + 16 | 0;
      i3 = i29 + 32 | 0;
      i5 = i29 + 36 | 0;
      i6 = i29 + 40 | 0;
      i7 = i29 + 44 | 0;
      i25 = i64 + 204 | 0;
      i26 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       __Z21RandomPointInsideCubeR5RandNPKf(i69, i10, i71);
       HEAP32[i29 >> 2] = 0;
       HEAP32[i30 >> 2] = 3;
       __Z12RangedRandomR5RandNRKiS2_(i62, i10, i29, i30);
       i93 = HEAP32[i71 >> 2] | 0;
       i92 = HEAP32[i69 >> 2] | 0;
       i88 = HEAP32[i11 >> 2] | 0;
       i90 = HEAP32[i12 >> 2] | 0;
       i86 = HEAP32[i13 >> 2] | 0;
       i85 = HEAP32[i62 >> 2] | 0;
       i87 = HEAP32[i14 >> 2] | 0;
       i89 = HEAP32[i15 >> 2] | 0;
       i91 = HEAP32[i16 >> 2] | 0;
       HEAP32[i69 >> 2] = (i85 | 0) == 0 ? i92 & -2147483648 ^ i93 : i92;
       HEAP32[i11 >> 2] = (i87 | 0) == 0 ? i88 & -2147483648 ^ i93 : i88;
       HEAP32[i12 >> 2] = (i89 | 0) == 0 ? i90 & -2147483648 ^ i93 : i90;
       HEAP32[i13 >> 2] = (i91 | 0) == 0 ? i86 & -2147483648 ^ i93 : i86;
       i86 = HEAP32[i8 >> 2] | 0;
       i93 = HEAP32[i17 >> 2] | 0;
       i90 = HEAP32[i18 >> 2] | 0;
       i88 = HEAP32[i19 >> 2] | 0;
       i92 = HEAP32[i20 >> 2] | 0;
       HEAP32[i17 >> 2] = (i85 | 0) == 1 ? i93 & -2147483648 ^ i86 : i93;
       HEAP32[i18 >> 2] = (i87 | 0) == 1 ? i90 & -2147483648 ^ i86 : i90;
       HEAP32[i19 >> 2] = (i89 | 0) == 1 ? i88 & -2147483648 ^ i86 : i88;
       HEAP32[i20 >> 2] = (i91 | 0) == 1 ? i92 & -2147483648 ^ i86 : i92;
       i92 = HEAP32[i9 >> 2] | 0;
       i86 = HEAP32[i21 >> 2] | 0;
       i88 = HEAP32[i22 >> 2] | 0;
       i90 = HEAP32[i23 >> 2] | 0;
       i93 = HEAP32[i24 >> 2] | 0;
       HEAP32[i21 >> 2] = (i85 | 0) == 2 ? i86 & -2147483648 ^ i92 : i86;
       HEAP32[i22 >> 2] = (i87 | 0) == 2 ? i88 & -2147483648 ^ i92 : i88;
       HEAP32[i23 >> 2] = (i89 | 0) == 2 ? i90 & -2147483648 ^ i92 : i90;
       HEAP32[i24 >> 2] = (i91 | 0) == 2 ? i93 & -2147483648 ^ i92 : i93;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i29 + 4 >> 2] = 0;
       HEAP32[i29 + 8 >> 2] = 0;
       HEAP32[i29 + 12 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = 0;
       HEAP32[i4 + 12 >> 2] = 0;
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAPF32[i5 >> 2] = Math_fround(1.0);
       HEAPF32[i6 >> 2] = Math_fround(1.0);
       HEAPF32[i7 >> 2] = Math_fround(1.0);
       f84 = Math_fround(HEAPF32[i25 >> 2]);
       f94 = Math_fround(HEAPF32[i26 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i69, i29, i10, f84, f94, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   case 16:
    {
     HEAPF32[i71 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 24 >> 2]) * Math_fround(.5));
     i8 = i71 + 4 | 0;
     HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 28 >> 2]) * Math_fround(.5));
     i9 = i71 + 8 | 0;
     HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i64 + 32 >> 2]) * Math_fround(.5));
     if (i66 >>> 0 > i65 >>> 0) {
      i10 = i64 + 140 | 0;
      i11 = i69 + 4 | 0;
      i12 = i69 + 8 | 0;
      i13 = i69 + 12 | 0;
      i14 = i62 + 4 | 0;
      i15 = i62 + 8 | 0;
      i16 = i62 + 12 | 0;
      i17 = i69 + 16 | 0;
      i18 = i69 + 20 | 0;
      i19 = i69 + 24 | 0;
      i20 = i69 + 28 | 0;
      i21 = i69 + 32 | 0;
      i22 = i69 + 36 | 0;
      i23 = i69 + 40 | 0;
      i24 = i69 + 44 | 0;
      i4 = i29 + 16 | 0;
      i3 = i29 + 32 | 0;
      i5 = i29 + 36 | 0;
      i6 = i29 + 40 | 0;
      i7 = i29 + 44 | 0;
      i25 = i64 + 204 | 0;
      i26 = i64 + 208 | 0;
      i2 = i64 + 212 | 0;
      i1 = i65;
      do {
       __Z21RandomPointInsideCubeR5RandNPKf(i69, i10, i71);
       HEAP32[i29 >> 2] = 0;
       HEAP32[i30 >> 2] = 3;
       __Z12RangedRandomR5RandNRKiS2_(i62, i10, i29, i30);
       i93 = HEAP32[i71 >> 2] | 0;
       i92 = HEAP32[i69 >> 2] | 0;
       i88 = HEAP32[i11 >> 2] | 0;
       i90 = HEAP32[i12 >> 2] | 0;
       i86 = HEAP32[i13 >> 2] | 0;
       i85 = HEAP32[i62 >> 2] | 0;
       i87 = HEAP32[i14 >> 2] | 0;
       i89 = HEAP32[i15 >> 2] | 0;
       i91 = HEAP32[i16 >> 2] | 0;
       HEAP32[i69 >> 2] = i85 | 0 ? i92 & -2147483648 ^ i93 : i92;
       HEAP32[i11 >> 2] = i87 | 0 ? i88 & -2147483648 ^ i93 : i88;
       HEAP32[i12 >> 2] = i89 | 0 ? i90 & -2147483648 ^ i93 : i90;
       HEAP32[i13 >> 2] = i91 | 0 ? i86 & -2147483648 ^ i93 : i86;
       i86 = HEAP32[i8 >> 2] | 0;
       i93 = HEAP32[i17 >> 2] | 0;
       i90 = HEAP32[i18 >> 2] | 0;
       i88 = HEAP32[i19 >> 2] | 0;
       i92 = HEAP32[i20 >> 2] | 0;
       HEAP32[i17 >> 2] = (i85 | 0) != 1 ? i93 & -2147483648 ^ i86 : i93;
       HEAP32[i18 >> 2] = (i87 | 0) != 1 ? i90 & -2147483648 ^ i86 : i90;
       HEAP32[i19 >> 2] = (i89 | 0) != 1 ? i88 & -2147483648 ^ i86 : i88;
       HEAP32[i20 >> 2] = (i91 | 0) != 1 ? i92 & -2147483648 ^ i86 : i92;
       i92 = HEAP32[i9 >> 2] | 0;
       i86 = HEAP32[i21 >> 2] | 0;
       i88 = HEAP32[i22 >> 2] | 0;
       i90 = HEAP32[i23 >> 2] | 0;
       i93 = HEAP32[i24 >> 2] | 0;
       HEAP32[i21 >> 2] = (i85 | 0) != 2 ? i86 & -2147483648 ^ i92 : i86;
       HEAP32[i22 >> 2] = (i87 | 0) != 2 ? i88 & -2147483648 ^ i92 : i88;
       HEAP32[i23 >> 2] = (i89 | 0) != 2 ? i90 & -2147483648 ^ i92 : i90;
       HEAP32[i24 >> 2] = (i91 | 0) != 2 ? i93 & -2147483648 ^ i92 : i93;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i29 + 4 >> 2] = 0;
       HEAP32[i29 + 8 >> 2] = 0;
       HEAP32[i29 + 12 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = 0;
       HEAP32[i4 + 12 >> 2] = 0;
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAPF32[i5 >> 2] = Math_fround(1.0);
       HEAPF32[i6 >> 2] = Math_fround(1.0);
       HEAPF32[i7 >> 2] = Math_fround(1.0);
       f84 = Math_fround(HEAPF32[i25 >> 2]);
       f94 = Math_fround(HEAPF32[i26 >> 2]);
       __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i67, i70, i73, i1, i69, i29, i10, f84, f94, (HEAP8[i2 >> 0] | 0) != 0, i74);
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i66 >>> 0);
     }
     break;
    }
   default:
    {}
   } while (0);
  }
 }
 if (!i68) {
  STACKTOP = i72;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i68);
 STACKTOP = i72;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i52) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i52 = i52 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i53 + 904 | 0;
 i50 = i53 + 880 | 0;
 i44 = i53 + 860 | 0;
 i45 = i53 + 840 | 0;
 i46 = i53 + 820 | 0;
 i47 = i53 + 800 | 0;
 i48 = i53 + 780 | 0;
 i6 = i53 + 760 | 0;
 i7 = i53 + 740 | 0;
 i8 = i53 + 720 | 0;
 i9 = i53 + 700 | 0;
 i10 = i53 + 680 | 0;
 i11 = i53 + 660 | 0;
 i12 = i53 + 640 | 0;
 i13 = i53 + 620 | 0;
 i14 = i53 + 600 | 0;
 i15 = i53 + 580 | 0;
 i16 = i53 + 560 | 0;
 i17 = i53 + 540 | 0;
 i18 = i53 + 520 | 0;
 i19 = i53 + 500 | 0;
 i20 = i53 + 480 | 0;
 i21 = i53 + 460 | 0;
 i22 = i53 + 440 | 0;
 i23 = i53 + 420 | 0;
 i24 = i53 + 400 | 0;
 i25 = i53 + 380 | 0;
 i26 = i53 + 360 | 0;
 i27 = i53 + 340 | 0;
 i28 = i53 + 320 | 0;
 i29 = i53 + 300 | 0;
 i30 = i53 + 280 | 0;
 i31 = i53 + 260 | 0;
 i32 = i53 + 240 | 0;
 i33 = i53 + 220 | 0;
 i34 = i53 + 200 | 0;
 i49 = i53 + 180 | 0;
 i35 = i53 + 160 | 0;
 i36 = i53 + 140 | 0;
 i37 = i53 + 120 | 0;
 i38 = i53 + 100 | 0;
 i39 = i53 + 80 | 0;
 i40 = i53 + 60 | 0;
 i41 = i53 + 40 | 0;
 i42 = i53 + 20 | 0;
 i43 = i53;
 L1 : do if ((i2 - i1 | 0) > 1) {
  L3 : do switch (HEAP8[i1 >> 0] | 0) {
  case 97:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 97:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086618 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i43, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i43 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i43);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i43);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 110:
   case 100:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086629 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i42, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i42 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i42);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i42);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 78:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086639 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i41, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i41 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i41);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i41);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 83:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086650 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i40, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i40 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i40);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i40);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 99:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 108:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086660 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i39, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i39 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i39);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i39);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 109:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086671 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i38, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i38 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i38);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i38);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 111:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086681 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i37, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i37 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i37);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i37);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 118:
    {
     i50 = i52 + 63 | 0;
     i49 = HEAP8[i50 >> 0] | 0;
     HEAP8[i50 >> 0] = 0;
     i51 = i1 + 2 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i51, i2, i52) | 0;
     HEAP8[i50 >> 0] = i49;
     if ((i2 | 0) == (i51 | 0)) break L1;
     i3 = HEAP32[i52 + 4 >> 2] | 0;
     if ((HEAP32[i52 >> 2] | 0) == (i3 | 0)) break L1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i3 + -24 | 0, 0, gb + 1086691 | 0) | 0;
     HEAP8[i52 + 60 >> 0] = 1;
     i1 = i2;
     break L1;
    }
   default:
    break L1;
   }
  case 100:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 97:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc(i51, gb + 1086701 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i36, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i36 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i36);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i36);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 101:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086719 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i35, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i35 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i35);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i35);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 108:
    {
     i2 = _malloc(16) | 0;
     HEAP32[i51 >> 2] = i2;
     HEAP32[i51 + 8 >> 2] = -2147483632;
     HEAP32[i51 + 4 >> 2] = 15;
     i3 = i2;
     i4 = gb + 1086729 | 0;
     i5 = i3 + 15 | 0;
     do {
      HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     } while ((i3 | 0) < (i5 | 0));
     HEAP8[i2 + 15 >> 0] = 0;
     i3 = i51 + 12 | 0;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     i2 = 0;
     while (1) {
      if ((i2 | 0) == 3) break;
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     }
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i48 = (i5 - i4 | 0) / 24 | 0;
       i50 = i48 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i49, i48 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i49 + 8 | 0;
       i48 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i48, i51);
       HEAP32[i50 >> 2] = i48 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i49);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i49);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 118:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086745 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i34, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i34 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i34);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i34);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 86:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086755 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i33 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i33);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 101:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 111:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086766 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i32, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i32 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i32);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i32);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 79:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086776 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i31, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i31 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i31);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i31);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 113:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086787 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i30, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i30 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i30);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i30);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 103:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 101:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086798 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i29, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i29 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i29);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 116:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086809 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i28, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i28 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i28);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i28);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 105:
   {
    if ((HEAP8[i1 + 1 >> 0] | 0) != 120) break L1;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086819 | 0);
    i2 = i52 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i50 = HEAP32[i52 + 8 >> 2] | 0;
    i5 = i50;
    do if (i3 >>> 0 < i50 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i52 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i52 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
      break L3;
     } else {
      i49 = (i5 - i4 | 0) / 24 | 0;
      i50 = i49 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i27, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
      i50 = i27 + 8 | 0;
      i49 = HEAP32[i50 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
      HEAP32[i50 >> 2] = i49 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i27);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i27);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 108:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 101:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086830 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i26 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i26);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 105:
    {
     i51 = i1 + 2 | 0;
     i2 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i51, i2, i52) | 0;
     if ((i2 | 0) == (i51 | 0)) break L1;
     i3 = HEAP32[i52 + 4 >> 2] | 0;
     if ((HEAP32[i52 >> 2] | 0) == (i3 | 0)) break L1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i3 + -24 | 0, 0, gb + 1086841 | 0) | 0;
     i1 = i2;
     break L1;
    }
   case 115:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086853 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i25, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i25 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i25);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i25);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 83:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i51, gb + 1086864 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i24, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i24 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i24);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i24);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 116:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086876 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i23, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i23 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i23);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i23);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 109:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 105:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086886 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i22, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i22 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i22);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i22);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 73:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086896 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i21, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i21 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i21);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i21);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 108:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086719 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i20, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i20 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i20);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i20);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 76:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086907 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i19, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i19 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i19);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i19);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 109:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086918 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i18, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i18 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i18);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i18);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 110:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 97:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc(i51, gb + 1086929 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i17, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i17 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i17);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i17);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 101:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086944 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i16, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i16 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i16);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i16);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 103:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086886 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i15 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i15);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 116:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086955 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i14, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i14 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i14);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i14);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 119:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc(i51, gb + 1086965 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i13, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i13 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i13);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i13);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 111:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 111:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086978 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i12, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i12 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i12);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i12);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 114:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1086989 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i11, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i11 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i11);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 82:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1086999 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i10, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i10 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i10);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i10);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 112:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 109:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i51, gb + 1087010 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i9 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i9);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 108:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1087022 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i8, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i8 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i8);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i8);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 76:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1087032 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i7, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i7 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i7);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i7);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 112:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1087043 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i6, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i6 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i6);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i6);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 115:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1087022 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i48, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i48 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i48);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i48);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 116:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1087054 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i47, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i47 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i47);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 113:
   {
    if ((HEAP8[i1 + 1 >> 0] | 0) != 117) break L1;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1087065 | 0);
    i2 = i52 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i50 = HEAP32[i52 + 8 >> 2] | 0;
    i5 = i50;
    do if (i3 >>> 0 < i50 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i52 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i52 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
      break L3;
     } else {
      i49 = (i5 - i4 | 0) / 24 | 0;
      i50 = i49 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i46, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
      i50 = i46 + 8 | 0;
      i49 = HEAP32[i50 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
      HEAP32[i50 >> 2] = i49 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i46);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i46);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 114:
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 109:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i51, gb + 1087075 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i45, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i45 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i45);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i45);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 77:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1087085 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i50 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i50;
     do if (i3 >>> 0 < i50 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i49 = (i5 - i4 | 0) / 24 | 0;
       i50 = i49 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i44, i49 >>> 0 < 89478485 ? (i50 >>> 0 < i3 >>> 0 ? i3 : i50) : 178956970, i2, i52 + 12 | 0);
       i50 = i44 + 8 | 0;
       i49 = HEAP32[i50 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i49, i51);
       HEAP32[i50 >> 2] = i49 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i44);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i44);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 115:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i51, gb + 1087096 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i49 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i49;
     do if (i3 >>> 0 < i49 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i51);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
       break L3;
      } else {
       i48 = (i5 - i4 | 0) / 24 | 0;
       i49 = i48 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i50, i48 >>> 0 < 89478485 ? (i49 >>> 0 < i3 >>> 0 ? i3 : i49) : 178956970, i2, i52 + 12 | 0);
       i49 = i50 + 8 | 0;
       i48 = HEAP32[i49 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i48, i51);
       HEAP32[i49 >> 2] = i48 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i50);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i50);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i51);
     i1 = i1 + 2 | 0;
     break L1;
    }
   case 83:
    {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i50, gb + 1087107 | 0);
     i2 = i52 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i49 = HEAP32[i52 + 8 >> 2] | 0;
     i5 = i49;
     do if (i3 >>> 0 < i49 >>> 0) {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i50);
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     } else {
      i4 = HEAP32[i52 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       __THREW__ = 0;
       invoke_vi(fb + 4014 | 0, i52 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i50);
       break L3;
      } else {
       i48 = (i5 - i4 | 0) / 24 | 0;
       i49 = i48 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i51, i48 >>> 0 < 89478485 ? (i49 >>> 0 < i3 >>> 0 ? i3 : i49) : 178956970, i2, i52 + 12 | 0);
       i49 = i51 + 8 | 0;
       i48 = HEAP32[i49 >> 2] | 0;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i48, i50);
       HEAP32[i49 >> 2] = i48 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i52, i51);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i51);
       break;
      }
     } while (0);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i50);
     i1 = i1 + 2 | 0;
     break L1;
    }
   default:
    break L1;
   }
  case 118:
   {
    if (((HEAP8[i1 + 1 >> 0] | 0) + -48 | 0) >>> 0 >= 10) break L1;
    i51 = i1 + 2 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i51, i2, i52) | 0;
    if ((i2 | 0) == (i51 | 0)) break L1;
    i3 = HEAP32[i52 + 4 >> 2] | 0;
    if ((HEAP32[i52 >> 2] | 0) == (i3 | 0)) break L1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i3 + -24 | 0, 0, gb + 1086691 | 0) | 0;
    i1 = i2;
    break L1;
   }
  default:
   break L1;
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i53;
 return i1 | 0;
}

function _PxGetPhysicsBinaryMetaData(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 608 | 0;
 i6 = i2 + 576 | 0;
 i5 = i2 + 544 | 0;
 i4 = i2 + 512 | 0;
 i3 = i2 + 480 | 0;
 i9 = i2 + 448 | 0;
 i8 = i2 + 416 | 0;
 i10 = i2 + 384 | 0;
 i22 = i2 + 352 | 0;
 i21 = i2 + 320 | 0;
 i20 = i2 + 288 | 0;
 i19 = i2 + 256 | 0;
 i18 = i2 + 224 | 0;
 i17 = i2 + 192 | 0;
 i16 = i2 + 160 | 0;
 i15 = i2 + 128 | 0;
 i14 = i2 + 96 | 0;
 i13 = i2 + 64 | 0;
 i12 = i2 + 32 | 0;
 i11 = i2;
 HEAP32[i22 >> 2] = HEAP32[gb + 120100 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 120100 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 120100 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 120100 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 120100 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 120100 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 120100 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 120100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 120132 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 120132 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 120132 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 120132 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 120132 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 120132 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 120132 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 120132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 120164 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 120164 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 120164 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 120164 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 120164 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 120164 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 120164 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 120164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 120196 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 120196 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 120196 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 120196 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 120196 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 120196 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 120196 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 120196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 120228 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 120228 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 120228 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 120228 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 120228 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 120228 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 120228 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 120228 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 120260 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 120260 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 120260 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 120260 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 120260 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 120260 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 120260 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 120260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 120292 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 120292 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 120292 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 120292 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 120292 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 120292 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 120292 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 120292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120324 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120324 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120324 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120324 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120324 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120324 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120324 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120356 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120356 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120356 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120356 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120356 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120356 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120356 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120388 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120388 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120388 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120388 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120388 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120388 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120388 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 120420 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 120420 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 120420 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 120420 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 120420 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 120420 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 120420 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 120420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120452 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120452 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120452 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120452 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120452 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120452 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120452 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120452 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120356 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120356 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120356 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120356 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120356 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120356 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120356 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120388 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120388 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120388 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120388 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120388 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120388 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120388 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 120420 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 120420 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 120420 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 120420 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 120420 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 120420 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 120420 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 120420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 120484 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 120484 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 120484 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 120484 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 120484 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 120484 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 120484 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 120484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120516 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120516 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120516 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120516 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120516 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120516 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120516 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120516 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120356 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120356 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120356 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120356 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120356 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120356 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120356 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120388 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120388 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120388 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120388 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120388 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120388 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120388 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 120420 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 120420 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 120420 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 120420 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 120420 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 120420 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 120420 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 120420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 120484 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 120484 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 120484 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 120484 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 120484 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 120484 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 120484 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 120484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120548 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120548 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120548 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120548 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120548 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120548 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120548 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120548 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120580 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120580 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120580 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120580 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120580 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120580 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120580 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120612 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120612 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120612 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120612 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120612 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120612 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120612 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120644 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120644 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120644 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120644 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120644 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120644 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120644 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120644 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120676 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120676 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120676 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120676 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120676 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120676 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120676 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120676 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120708 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120708 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120708 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120708 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120708 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120708 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120708 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120708 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120740 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120740 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120740 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120740 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120740 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120740 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120740 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120740 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120772 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120772 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120772 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120772 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120772 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120772 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120772 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120804 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120804 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120804 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120804 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120804 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120804 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120804 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120804 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 120836 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 120836 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 120836 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 120836 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 120836 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 120836 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 120836 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 120836 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 120868 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 120868 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 120868 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 120868 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 120868 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 120868 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 120868 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 120868 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 120900 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 120900 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 120900 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 120900 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 120900 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 120900 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 120900 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 120900 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 120932 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 120932 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 120932 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 120932 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 120932 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 120932 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 120932 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 120932 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 120964 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 120964 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 120964 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 120964 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 120964 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 120964 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 120964 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 120964 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 120996 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 120996 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 120996 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 120996 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 120996 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 120996 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 120996 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 120996 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121028 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121028 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121028 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121028 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121028 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121028 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121028 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121028 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 121060 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 121060 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 121060 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 121060 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 121060 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 121060 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 121060 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 121060 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 121092 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 121092 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 121092 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 121092 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 121092 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 121092 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 121092 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 121092 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 __ZN5physx2Cm8PtrTable17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i7 >> 2] = HEAP32[gb + 121124 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121124 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121124 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121124 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121124 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121124 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121124 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121124 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121156 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121156 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121156 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121156 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121156 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121156 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121156 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121156 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121188 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121188 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121188 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121188 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121188 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121188 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121188 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121188 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 121220 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121220 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121220 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121220 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121220 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121220 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121220 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121220 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121252 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121252 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121252 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121252 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121252 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121252 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121252 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121252 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121284 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121284 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121284 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121284 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121284 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121284 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121284 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121284 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 121316 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 121316 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 121316 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 121316 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 121316 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 121316 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 121316 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 121316 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121348 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121348 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121348 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121348 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121348 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121348 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121348 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121348 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 121380 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121380 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121380 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121380 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121380 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121380 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121380 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121412 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121412 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121412 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121412 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121412 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121412 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121412 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121444 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121444 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121444 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121444 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121444 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121444 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121444 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 121476 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 121476 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 121476 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 121476 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 121476 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 121476 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 121476 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 121476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121508 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121508 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121508 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121508 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121508 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121508 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121508 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 121540 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121540 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121540 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121540 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121540 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121540 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121540 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121572 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121572 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121572 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121572 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121572 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121572 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121572 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 121604 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121604 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121604 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121604 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121604 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121604 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121604 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121604 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121636 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121636 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121636 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121636 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121636 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121636 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121636 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121636 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121668 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121668 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121668 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121668 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121668 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121668 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121668 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121668 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 121700 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121700 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121700 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121700 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121700 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121700 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121700 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121700 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121732 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121732 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121732 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121732 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121732 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121732 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121732 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121732 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121764 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121764 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121764 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121764 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121764 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121764 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121764 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121764 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 121796 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 121796 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 121796 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 121796 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 121796 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 121796 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 121796 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 121796 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121828 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121828 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121828 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121828 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121828 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121828 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121828 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 121860 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 121860 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 121860 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 121860 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 121860 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 121860 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 121860 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 121860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 121892 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 121892 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 121892 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 121892 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 121892 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 121892 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 121892 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 121892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 121924 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 121924 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 121924 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 121924 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 121924 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 121924 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 121924 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 121924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 121956 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 121956 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 121956 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 121956 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 121956 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 121956 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 121956 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 121956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 121988 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 121988 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 121988 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 121988 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 121988 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 121988 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 121988 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 121988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 122020 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 122020 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 122020 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 122020 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 122020 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 122020 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 122020 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 122020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 122052 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 122052 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 122052 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 122052 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 122052 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 122052 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 122052 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 122052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 122084 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 122084 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 122084 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 122084 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 122084 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 122084 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 122084 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 122084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 122116 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 122116 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 122116 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 122116 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 122116 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 122116 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 122116 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 122116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 122148 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 122148 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 122148 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 122148 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 122148 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 122148 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 122148 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 122148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 122180 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 122180 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 122180 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 122180 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 122180 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 122180 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 122180 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 122180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 122212 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 122212 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 122212 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 122212 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 122212 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 122212 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 122212 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 122212 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 122244 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 122244 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 122244 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 122244 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 122244 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 122244 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 122244 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 122244 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 122276 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 122276 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 122276 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 122276 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 122276 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 122276 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 122276 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 122276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 122308 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 122308 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 122308 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 122308 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 122308 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 122308 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 122308 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 122308 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 __ZN5physx21MaterialIndicesStruct17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Gu13GeometryUnion17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Gu10ConvexMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Gu12TriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Gu11HeightField17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc9ActorCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc9RigidCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc10StaticCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc8BodyCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc12MaterialCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc9ShapeCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc14ConstraintCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc16ArticulationCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc21ArticulationJointCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc15ClothFabricCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc9ClothCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx2Sc18ParticleSystemCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb4Base17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb5Actor17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb11RigidObject17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb11RigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb4Body17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb5Shape17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb10Constraint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb12Articulation17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb17ArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb9Aggregate17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb5Cloth17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Scb14ParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i7 >> 2] = HEAP32[gb + 122340 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122340 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122340 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122340 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122340 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122340 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122340 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122372 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122372 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122372 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122372 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122372 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122372 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122372 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122404 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122404 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122404 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122404 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122404 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122404 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122404 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122436 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122436 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122436 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122436 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122436 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122436 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122436 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 122468 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122468 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122468 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122468 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122468 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122468 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122468 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122500 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122500 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122500 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122500 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122500 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122532 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122532 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122532 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122532 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122532 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122532 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122532 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122564 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122564 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122564 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122564 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122564 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122564 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122564 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122596 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122596 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122596 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122596 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122596 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122596 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122596 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 122628 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 122628 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 122628 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 122628 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 122628 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 122628 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 122628 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 122628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122660 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122660 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122660 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122660 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122660 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122660 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122660 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 122692 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 122692 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 122692 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 122692 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 122692 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 122692 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 122692 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 122692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 122724 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122724 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122724 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122724 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122724 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122724 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122724 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122756 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122756 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122756 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122756 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122756 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122756 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122756 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122788 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122788 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122788 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122788 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122788 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122788 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122788 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 122820 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122820 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122820 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122820 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122820 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122820 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122820 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754681;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 64;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754681;
 HEAP32[i5 + 4 >> 2] = gb + 752142;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 64;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122884 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122884 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122884 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122884 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122884 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122884 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122884 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 __ZN5physx14NpRigidDynamic17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx13NpRigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx7NpShape17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i7 >> 2] = HEAP32[gb + 122916 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122916 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122916 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122916 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122916 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122916 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122916 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754692;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 132;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122948 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122948 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122948 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122948 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122948 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122948 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122948 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122980 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122980 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122980 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122980 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122980 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122980 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122980 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123012 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123012 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123012 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123012 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123012 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123012 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123012 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 123044 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 123044 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 123044 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 123044 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 123044 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 123044 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 123044 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 123044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 123076 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 123076 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 123076 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 123076 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 123076 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 123076 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 123076 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 123076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123108 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123108 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123108 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123108 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123108 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123108 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123108 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754717;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 108;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123140 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123140 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123140 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123140 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123140 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123140 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123140 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123172 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123172 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123172 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123172 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123172 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123172 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123172 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123172 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 123204 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 123204 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 123204 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 123204 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 123204 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 123204 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 123204 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 123204 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 123236 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 123236 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 123236 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 123236 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 123236 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 123236 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 123236 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 123236 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 __ZN5physx18NpArticulationLink17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i7 >> 2] = HEAP32[gb + 123300 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123300 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123300 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123300 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123300 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123300 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123300 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123300 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754751;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 204;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123332 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123332 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123332 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123332 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123332 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123332 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123332 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123332 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123364 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123364 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123364 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123364 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123364 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123364 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123396 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123396 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123396 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123396 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123396 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123396 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123396 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123396 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123428 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123428 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123428 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123428 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123428 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123428 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123428 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123428 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 123460 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123460 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123460 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123460 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123460 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123460 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123460 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123460 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123492 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123492 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123492 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123492 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123492 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123492 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123492 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123492 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123524 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123524 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123524 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123524 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123524 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123524 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123524 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123524 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123556 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123556 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123556 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123556 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123556 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123556 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123556 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123556 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 123588 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 123588 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 123588 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 123588 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 123588 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 123588 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 123588 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 123588 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 123620 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 123620 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 123620 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 123620 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 123620 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 123620 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 123620 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 123620 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 123652 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 123652 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 123652 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 123652 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 123652 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 123652 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 123652 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 123652 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123684 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123684 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123684 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123684 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123684 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123684 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123684 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123684 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 123716 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123716 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123716 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123716 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123716 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123716 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123716 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123716 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123748 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123748 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123748 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123748 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123748 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123748 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123748 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123748 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123780 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123780 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123780 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123780 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123780 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123780 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123780 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123780 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754705;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 44;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123812 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123812 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123812 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123812 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123812 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123812 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123812 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123812 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123844 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123844 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123844 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123844 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123844 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123844 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123844 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123844 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123876 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123876 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123876 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123876 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123876 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123876 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123876 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123876 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 123908 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 123908 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 123908 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 123908 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 123908 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 123908 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 123908 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 123908 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123940 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123940 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123940 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123940 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123940 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123940 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123940 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123940 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754779;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 36;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754779;
 HEAP32[i5 + 4 >> 2] = gb + 752142;
 HEAP32[i5 + 8 >> 2] = 8;
 HEAP32[i5 + 12 >> 2] = 36;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123972 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123972 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123972 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123972 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123972 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123972 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123972 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123972 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124004 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124004 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124004 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124004 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124004 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124004 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124004 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124004 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754771;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 152;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754771;
 HEAP32[i5 + 4 >> 2] = gb + 747076;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 152;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124036 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124036 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124036 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124036 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124036 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124036 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124036 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124036 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 124068 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 124068 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 124068 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 124068 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 124068 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 124068 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 124068 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 124068 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 124100 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 124100 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 124100 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 124100 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 124100 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 124100 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 124100 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 124100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124132 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124132 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124132 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124132 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124132 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124132 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124132 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754793;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 200;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754793;
 HEAP32[i5 + 4 >> 2] = gb + 747076;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 200;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124164 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124164 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124164 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124164 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124164 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124164 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124164 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124196 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124196 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124196 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124196 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124196 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124196 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124196 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754810;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 200;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754810;
 HEAP32[i5 + 4 >> 2] = gb + 747076;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 200;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124164 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124164 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124164 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124164 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124164 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124164 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124164 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN14PlayerSettings8TransferI14SafeBinaryReadEEvRT_(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i10, i12);
 __ZN14SafeBinaryRead10SetVersionEi(i12, 10);
 i2 = i10 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448100 | 0, gb + 863904 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 280 | 0;
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448112 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 284 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448128 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i7 = 21; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 21; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 21) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448153 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i7 = 32; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 32; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 32) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448166 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 296 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448187 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i7 = 52; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 52; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 96 | 0;
 i8 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448210 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448222 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 268 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448234 | 0, gb + 1034905 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448248 | 0, HEAP32[gb + 37320 >> 2] | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __ZN26PlayerSettingsSplashScreen8TransferI14SafeBinaryReadEEvRT_(i10 + 144 | 0, i12);
 i2 = i10 + 264 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448262 | 0, gb + 1034905 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 300 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448294 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 93; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 93; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 93) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 304 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448313 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 104; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 104; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 104) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448333 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 115; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 115; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 115) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 312 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448355 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 126; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 126;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 126) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 328 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448378 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 137; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 137;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 137) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 332 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448400 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 148; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 148;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 148) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448419 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L210 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L210;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 337 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448433 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L222 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L222;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 340 | 0;
 i5 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448453 | 0, i5, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i12, i2, 0); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 364 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448471 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 183; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 183;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 183) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 360 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448505 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 194; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 194;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 194) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448543 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 205; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 205;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 205) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448579 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 216; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 216;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 216) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 316 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448606 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 227; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 227;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 227) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 376 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448630 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L317 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L317;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 377 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448651 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L329 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L329;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 378 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448679 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L341 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L341;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 379 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448717 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L353 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L353;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 380 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448751 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L365 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L365;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 381 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448784 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L377 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L377;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 382 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448802 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L389 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L389;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 384 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448824 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L401 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L401;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 386 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448854 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L413 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L413;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 387 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448874 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L425 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L425;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 388 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448900 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L437 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L437;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 389 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448916 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L449 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L449;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 390 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448936 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L461 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L461;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 391 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448958 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L473 : do if ((i1 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   do if (i1 >>> 0 >= i4 >>> 0) {
    if ((i1 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L473;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 392 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 448984 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L485 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L485;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 393 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449e3 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L497 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L497;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 394 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449013 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L509 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L509;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 412 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449033 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L521 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L521;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 413 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449053 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L533 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L533;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 395 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449069 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L545 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L545;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 414 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449094 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L557 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L557;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 415 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449106 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L569 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L569;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 416 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449119 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L581 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L581;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 417 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449141 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L593 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L593;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 418 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449158 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L605 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L605;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 419 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449175 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L617 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L617;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 424 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449204 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L629 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L629;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 396 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449222 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L641 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L641;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 397 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449242 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L653 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L653;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 400 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449264 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 499; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 499;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 499) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = 1;
 i4 = i10 + 404 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449282 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 512; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 512;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 512) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 408 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449301 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 523; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 523;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 523) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 420 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449321 | 0, HEAP32[gb + 37304 >> 2] | 0, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 534; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 534;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 534) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 425 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449334 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L728 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L728;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 426 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449360 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L740 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L740;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 427 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449376 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L752 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L752;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 428 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449398 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L764 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L764;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 429 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449426 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L776 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L776;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 430 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449450 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L788 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L788;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 383 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449466 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L800 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L800;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 385 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449488 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L812 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L812;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 432 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449505 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 617; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 617;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 617) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 436 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449523 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 628; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 628;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 628) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 440 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449547 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 639; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 639;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 639) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 444 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449567 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 650; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 650;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 650) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 448 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449595 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 661; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 661;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 661) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 452 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449609 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L899 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L899;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 504 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449624 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 681; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 681;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 681) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 508 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449641 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 692; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 692;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 692) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 512 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449657 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L941 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L941;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 513 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449677 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L953 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L953;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 514 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449707 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L965 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L965;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 515 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449732 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L977 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L977;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 516 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449755 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L989 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L989;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 517 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449781 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L1001 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L1001;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 520 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449804 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 757; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i7 = 757;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 757) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 320 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449824 | 0, gb + 449848 | 0, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN15SerializeTraitsI12AspectRatiosE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 556 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449861 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 572 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449878 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 604 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449892 | 0, i5, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i12, i2, 0); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14WSAInputSourceEvRT_RT0_PKc17TransferMetaFlags(i12, i10 + 624 | 0, gb + 449908 | 0, 0);
 i3 = i10 + 628 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449925 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L1060 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L1060;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 629 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449958 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L1072 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L1072;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 630 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 449993 | 0, i9, i11, 0) | 0;
 if (i1 | 0) {
  L1084 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L1084;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 450015 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 450030 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 450042 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i2, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i10 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 450057 | 0, i9, i11, 0) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 L1121 : do if ((i1 | 0) > 0) {
  i1 = i12 + 16 | 0;
  i11 = HEAP32[i12 + 20 >> 2] | 0;
  i2 = i11 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i11 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L1121;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 STACKTOP = i13;
 return;
}

function __ZN5physx38setupFinalizeSolverConstraintsCoulomb4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRNS_27PxcCorrelationBufferCoulombEjjjRKNS_6shdfnd3aos5Vec4VESB_SB_SB_(i6, i366, i12, f364, f362, i363, i365, i7, i1, i4, i2, i5, i3) {
 i6 = i6 | 0;
 i366 = i366 | 0;
 i12 = i12 | 0;
 f364 = Math_fround(f364);
 f362 = Math_fround(f362);
 i363 = i363 | 0;
 i365 = i365 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, f107 = f0, i108 = 0, f109 = f0, i110 = 0, f111 = f0, i112 = 0, f113 = f0, i114 = 0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, f173 = f0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, f191 = f0, f192 = f0, f193 = f0, f194 = f0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, f202 = f0, f203 = f0, f204 = f0, f205 = f0, f206 = f0, f207 = f0, f208 = f0, f209 = f0, f210 = f0, f211 = f0, f212 = f0, f213 = f0, f214 = f0, f215 = f0, f216 = f0, f217 = f0, f218 = f0, f219 = f0, f220 = f0, f221 = f0, f222 = f0, f223 = f0, f224 = f0, f225 = f0, f226 = f0, f227 = f0, f228 = f0, f229 = f0, f230 = f0, f231 = f0, f232 = f0, f233 = f0, f234 = f0, f235 = f0, f236 = f0, f237 = f0, f238 = f0, f239 = f0, f240 = f0, f241 = f0, f242 = f0, f243 = f0, f244 = f0, f245 = f0, f246 = f0, f247 = f0, f248 = f0, f249 = f0, f250 = f0, f251 = f0, f252 = f0, f253 = f0, f254 = f0, f255 = f0, f256 = f0, f257 = f0, f258 = f0, f259 = f0, f260 = f0, f261 = f0, f262 = f0, f263 = f0, f264 = f0, f265 = f0, f266 = f0, f267 = f0, f268 = f0, f269 = f0, f270 = f0, f271 = f0, f272 = f0, f273 = f0, f274 = f0, f275 = f0, f276 = f0, f277 = f0, f278 = f0, f279 = f0, f280 = f0, f281 = f0, f282 = f0, f283 = f0, f284 = f0, f285 = f0, f286 = f0, f287 = f0, f288 = f0, f289 = f0, f290 = f0, f291 = f0, f292 = f0, f293 = f0, f294 = f0, f295 = f0, f296 = f0, f297 = f0, f298 = f0, f299 = f0, f300 = f0, f301 = f0, f302 = f0, f303 = f0, f304 = f0, f305 = f0, f306 = f0, f307 = f0, f308 = f0, f309 = f0, f310 = f0, f311 = f0, f312 = f0, f313 = f0, f314 = f0, f315 = f0, f316 = f0, f317 = f0, f318 = f0, f319 = f0, f320 = f0, f321 = f0, f322 = f0, f323 = f0, f324 = f0, f325 = f0, f326 = f0, f327 = f0, f328 = f0, f329 = f0, f330 = f0, f331 = f0, f332 = f0, f333 = f0, f334 = f0, f335 = f0, f336 = f0, f337 = f0, f338 = f0, f339 = f0, f340 = f0, f341 = f0, f342 = f0, f343 = f0, f344 = f0, f345 = f0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i351 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, i358 = 0, i359 = 0, i360 = 0, i361 = 0, f367 = f0, f368 = f0, f369 = f0, f370 = f0, f371 = f0, f372 = f0, f373 = f0, f374 = f0, f375 = f0, f376 = f0, f377 = f0, f378 = f0, f379 = f0, f380 = f0, f381 = f0, f382 = f0, f383 = f0, f384 = f0, f385 = f0, f386 = f0, f387 = f0, f388 = f0, f389 = f0, f390 = f0, i391 = 0, i392 = 0, i393 = 0, i394 = 0, f395 = f0, f396 = f0, f397 = f0, f398 = f0, f399 = f0, f400 = f0, f401 = f0, f402 = f0, f403 = f0, f404 = f0, f405 = f0, f406 = f0;
 i361 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i358 = i361 + 64 | 0;
 i359 = i361 + 32 | 0;
 i360 = i361;
 i169 = HEAP32[i6 >> 2] | 0;
 i355 = HEAP16[i169 + 22 >> 1] | 0;
 i357 = (i355 & 65535) >>> 8 & 1;
 i168 = HEAP32[i6 + 56 >> 2] | 0;
 i356 = HEAP16[i168 + 22 >> 1] | 0;
 i351 = (i356 & 65535) >>> 8 & 1;
 i167 = HEAP32[i6 + 112 >> 2] | 0;
 i354 = HEAP16[i167 + 22 >> 1] | 0;
 i352 = (i354 & 65535) >>> 8 & 1;
 i166 = HEAP32[i6 + 168 >> 2] | 0;
 i1 = HEAP16[i166 + 22 >> 1] | 0;
 i353 = (i1 & 65535) >>> 8 & 1;
 i1 = (i356 | i355 | i354 | i1) & 64;
 i354 = i1 << 16 >> 16 != 0;
 i355 = i354 ? 272 : 176;
 i356 = i354 ? 288 : 192;
 f321 = Math_fround(HEAPF32[i169 + 84 >> 2]);
 f322 = Math_fround(HEAPF32[i168 + 84 >> 2]);
 f323 = Math_fround(HEAPF32[i167 + 84 >> 2]);
 f324 = Math_fround(HEAPF32[i166 + 84 >> 2]);
 f178 = Math_fround(HEAPF32[i169 + 88 >> 2]);
 f179 = Math_fround(HEAPF32[i168 + 88 >> 2]);
 f180 = Math_fround(HEAPF32[i167 + 88 >> 2]);
 f320 = Math_fround(HEAPF32[i166 + 88 >> 2]);
 f273 = Math_fround(HEAPF32[i4 >> 2]);
 f269 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f265 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f273 = Math_fround(f321 * f273);
 f269 = Math_fround(f322 * f269);
 f265 = Math_fround(f323 * f265);
 f261 = Math_fround(f324 * Math_fround(HEAPF32[i4 + 12 >> 2]));
 f257 = Math_fround(HEAPF32[i5 >> 2]);
 f253 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f249 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f257 = Math_fround(f178 * f257);
 f253 = Math_fround(f179 * f253);
 f249 = Math_fround(f180 * f249);
 f248 = Math_fround(f320 * Math_fround(HEAPF32[i5 + 12 >> 2]));
 f327 = Math_fround(HEAPF32[i2 >> 2]);
 f326 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f325 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f327 = Math_fround(f321 * f327);
 f326 = Math_fround(f322 * f326);
 f325 = Math_fround(f323 * f325);
 f324 = Math_fround(f324 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f323 = Math_fround(HEAPF32[i3 >> 2]);
 f322 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f321 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f323 = Math_fround(f178 * f323);
 f322 = Math_fround(f179 * f322);
 f321 = Math_fround(f180 * f321);
 f320 = Math_fround(f320 * Math_fround(HEAPF32[i3 + 12 >> 2]));
 i5 = HEAP32[i6 + 44 >> 2] | 0;
 f180 = Math_fround(HEAPF32[i5 + 52 >> 2]);
 i349 = HEAP32[i6 + 100 >> 2] | 0;
 f179 = Math_fround(HEAPF32[i349 + 52 >> 2]);
 i4 = HEAP32[i6 + 156 >> 2] | 0;
 f178 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 i348 = HEAP32[i6 + 212 >> 2] | 0;
 f177 = Math_fround(HEAPF32[i348 + 52 >> 2]);
 i3 = HEAP32[i6 + 48 >> 2] | 0;
 f173 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 i347 = HEAP32[i6 + 104 >> 2] | 0;
 f174 = Math_fround(HEAPF32[i347 + 52 >> 2]);
 i2 = HEAP32[i6 + 160 >> 2] | 0;
 f175 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 i346 = HEAP32[i6 + 216 >> 2] | 0;
 f176 = Math_fround(HEAPF32[i346 + 52 >> 2]);
 f173 = f180 > f173 ? f180 : f173;
 f174 = f179 > f174 ? f179 : f174;
 f175 = f178 > f175 ? f178 : f175;
 f176 = f177 > f176 ? f177 : f176;
 f177 = Math_fround(HEAPF32[i169 + 92 >> 2]);
 f178 = Math_fround(HEAPF32[i168 + 92 >> 2]);
 f179 = Math_fround(HEAPF32[i167 + 92 >> 2]);
 f180 = Math_fround(HEAPF32[i166 + 92 >> 2]);
 i166 = HEAP32[i6 + 36 >> 2] | 0;
 f181 = Math_fround(HEAPF32[i166 >> 2]);
 f182 = Math_fround(HEAPF32[i166 + 4 >> 2]);
 f183 = Math_fround(HEAPF32[i166 + 8 >> 2]);
 i167 = HEAP32[i6 + 92 >> 2] | 0;
 f184 = Math_fround(HEAPF32[i167 >> 2]);
 f185 = Math_fround(HEAPF32[i167 + 4 >> 2]);
 f186 = Math_fround(HEAPF32[i167 + 8 >> 2]);
 i168 = HEAP32[i6 + 148 >> 2] | 0;
 f187 = Math_fround(HEAPF32[i168 >> 2]);
 f188 = Math_fround(HEAPF32[i168 + 4 >> 2]);
 f189 = Math_fround(HEAPF32[i168 + 8 >> 2]);
 i169 = HEAP32[i6 + 204 >> 2] | 0;
 f190 = Math_fround(HEAPF32[i169 >> 2]);
 f191 = Math_fround(HEAPF32[i169 + 4 >> 2]);
 f192 = Math_fround(HEAPF32[i169 + 8 >> 2]);
 i170 = HEAP32[i6 + 40 >> 2] | 0;
 f193 = Math_fround(HEAPF32[i170 >> 2]);
 f194 = Math_fround(HEAPF32[i170 + 4 >> 2]);
 f195 = Math_fround(HEAPF32[i170 + 8 >> 2]);
 i171 = HEAP32[i6 + 96 >> 2] | 0;
 f196 = Math_fround(HEAPF32[i171 >> 2]);
 f197 = Math_fround(HEAPF32[i171 + 4 >> 2]);
 f198 = Math_fround(HEAPF32[i171 + 8 >> 2]);
 i172 = HEAP32[i6 + 152 >> 2] | 0;
 f199 = Math_fround(HEAPF32[i172 >> 2]);
 f200 = Math_fround(HEAPF32[i172 + 4 >> 2]);
 f201 = Math_fround(HEAPF32[i172 + 8 >> 2]);
 i350 = HEAP32[i6 + 208 >> 2] | 0;
 f202 = Math_fround(HEAPF32[i350 >> 2]);
 f203 = Math_fround(HEAPF32[i350 + 4 >> 2]);
 f204 = Math_fround(HEAPF32[i350 + 8 >> 2]);
 i166 = i166 + 16 | 0;
 f205 = Math_fround(HEAPF32[i166 >> 2]);
 f206 = Math_fround(HEAPF32[i166 + 4 >> 2]);
 f207 = Math_fround(HEAPF32[i166 + 8 >> 2]);
 i167 = i167 + 16 | 0;
 f208 = Math_fround(HEAPF32[i167 >> 2]);
 f209 = Math_fround(HEAPF32[i167 + 4 >> 2]);
 f210 = Math_fround(HEAPF32[i167 + 8 >> 2]);
 i168 = i168 + 16 | 0;
 f211 = Math_fround(HEAPF32[i168 >> 2]);
 f212 = Math_fround(HEAPF32[i168 + 4 >> 2]);
 f213 = Math_fround(HEAPF32[i168 + 8 >> 2]);
 i169 = i169 + 16 | 0;
 f214 = Math_fround(HEAPF32[i169 >> 2]);
 f215 = Math_fround(HEAPF32[i169 + 4 >> 2]);
 f216 = Math_fround(HEAPF32[i169 + 8 >> 2]);
 i170 = i170 + 16 | 0;
 f217 = Math_fround(HEAPF32[i170 >> 2]);
 f218 = Math_fround(HEAPF32[i170 + 4 >> 2]);
 f219 = Math_fround(HEAPF32[i170 + 8 >> 2]);
 i171 = i171 + 16 | 0;
 f220 = Math_fround(HEAPF32[i171 >> 2]);
 f221 = Math_fround(HEAPF32[i171 + 4 >> 2]);
 f222 = Math_fround(HEAPF32[i171 + 8 >> 2]);
 i172 = i172 + 16 | 0;
 f223 = Math_fround(HEAPF32[i172 >> 2]);
 f224 = Math_fround(HEAPF32[i172 + 4 >> 2]);
 f225 = Math_fround(HEAPF32[i172 + 8 >> 2]);
 i350 = i350 + 16 | 0;
 f226 = Math_fround(HEAPF32[i350 >> 2]);
 f227 = Math_fround(HEAPF32[i350 + 4 >> 2]);
 f228 = Math_fround(HEAPF32[i350 + 8 >> 2]);
 f229 = Math_fround(f181 - f193);
 f230 = Math_fround(f184 - f196);
 f231 = Math_fround(f187 - f199);
 f232 = Math_fround(f190 - f202);
 f233 = Math_fround(f182 - f194);
 f234 = Math_fround(f185 - f197);
 f235 = Math_fround(f188 - f200);
 f236 = Math_fround(f191 - f203);
 f237 = Math_fround(f183 - f195);
 f238 = Math_fround(f186 - f198);
 f239 = Math_fround(f189 - f201);
 f240 = Math_fround(f192 - f204);
 f241 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 f242 = Math_fround(HEAPF32[i349 + 48 >> 2]);
 f243 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f244 = Math_fround(HEAPF32[i348 + 48 >> 2]);
 f245 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f246 = Math_fround(HEAPF32[i347 + 48 >> 2]);
 f247 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f241 = Math_fround(f273 * f241);
 f242 = Math_fround(f269 * f242);
 f243 = Math_fround(f265 * f243);
 f244 = Math_fround(f261 * f244);
 f245 = Math_fround(-Math_fround(f257 * f245));
 f246 = Math_fround(-Math_fround(f253 * f246));
 f247 = Math_fround(-Math_fround(f249 * f247));
 f248 = Math_fround(-Math_fround(f248 * Math_fround(HEAPF32[i346 + 48 >> 2])));
 f249 = Math_fround(HEAPF32[i5 >> 2]);
 f253 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f257 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f261 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f265 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f269 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f273 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f277 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f281 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f250 = Math_fround(HEAPF32[i349 >> 2]);
 f254 = Math_fround(HEAPF32[i349 + 4 >> 2]);
 f258 = Math_fround(HEAPF32[i349 + 8 >> 2]);
 f262 = Math_fround(HEAPF32[i349 + 12 >> 2]);
 f266 = Math_fround(HEAPF32[i349 + 16 >> 2]);
 f270 = Math_fround(HEAPF32[i349 + 20 >> 2]);
 f274 = Math_fround(HEAPF32[i349 + 24 >> 2]);
 f278 = Math_fround(HEAPF32[i349 + 28 >> 2]);
 f282 = Math_fround(HEAPF32[i349 + 32 >> 2]);
 f251 = Math_fround(HEAPF32[i4 >> 2]);
 f255 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f259 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f263 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f267 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f271 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f275 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f279 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f283 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f252 = Math_fround(HEAPF32[i348 >> 2]);
 f256 = Math_fround(HEAPF32[i348 + 4 >> 2]);
 f260 = Math_fround(HEAPF32[i348 + 8 >> 2]);
 f264 = Math_fround(HEAPF32[i348 + 12 >> 2]);
 f268 = Math_fround(HEAPF32[i348 + 16 >> 2]);
 f272 = Math_fround(HEAPF32[i348 + 20 >> 2]);
 f276 = Math_fround(HEAPF32[i348 + 24 >> 2]);
 f280 = Math_fround(HEAPF32[i348 + 28 >> 2]);
 f284 = Math_fround(HEAPF32[i348 + 32 >> 2]);
 f285 = Math_fround(HEAPF32[i3 >> 2]);
 f289 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f293 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f297 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f301 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f305 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f309 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f313 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f317 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f286 = Math_fround(HEAPF32[i347 >> 2]);
 f290 = Math_fround(HEAPF32[i347 + 4 >> 2]);
 f294 = Math_fround(HEAPF32[i347 + 8 >> 2]);
 f298 = Math_fround(HEAPF32[i347 + 12 >> 2]);
 f302 = Math_fround(HEAPF32[i347 + 16 >> 2]);
 f306 = Math_fround(HEAPF32[i347 + 20 >> 2]);
 f310 = Math_fround(HEAPF32[i347 + 24 >> 2]);
 f314 = Math_fround(HEAPF32[i347 + 28 >> 2]);
 f318 = Math_fround(HEAPF32[i347 + 32 >> 2]);
 f287 = Math_fround(HEAPF32[i2 >> 2]);
 f291 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f295 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f299 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f303 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f307 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f311 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f315 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f319 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f288 = Math_fround(HEAPF32[i346 >> 2]);
 f292 = Math_fround(HEAPF32[i346 + 4 >> 2]);
 f296 = Math_fround(HEAPF32[i346 + 8 >> 2]);
 f300 = Math_fround(HEAPF32[i346 + 12 >> 2]);
 f304 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f308 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f312 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 f316 = Math_fround(HEAPF32[i346 + 28 >> 2]);
 f249 = Math_fround(f327 * f249);
 f250 = Math_fround(f326 * f250);
 f251 = Math_fround(f325 * f251);
 f252 = Math_fround(f324 * f252);
 f253 = Math_fround(f327 * f253);
 f254 = Math_fround(f326 * f254);
 f255 = Math_fround(f325 * f255);
 f256 = Math_fround(f324 * f256);
 f257 = Math_fround(f327 * f257);
 f258 = Math_fround(f326 * f258);
 f259 = Math_fround(f325 * f259);
 f260 = Math_fround(f324 * f260);
 f261 = Math_fround(f327 * f261);
 f262 = Math_fround(f326 * f262);
 f263 = Math_fround(f325 * f263);
 f264 = Math_fround(f324 * f264);
 f265 = Math_fround(f327 * f265);
 f266 = Math_fround(f326 * f266);
 f267 = Math_fround(f325 * f267);
 f268 = Math_fround(f324 * f268);
 f269 = Math_fround(f327 * f269);
 f270 = Math_fround(f326 * f270);
 f271 = Math_fround(f325 * f271);
 f272 = Math_fround(f324 * f272);
 f273 = Math_fround(f327 * f273);
 f274 = Math_fround(f326 * f274);
 f275 = Math_fround(f325 * f275);
 f276 = Math_fround(f324 * f276);
 f277 = Math_fround(f327 * f277);
 f278 = Math_fround(f326 * f278);
 f279 = Math_fround(f325 * f279);
 f280 = Math_fround(f324 * f280);
 f281 = Math_fround(f327 * f281);
 f282 = Math_fround(f326 * f282);
 f283 = Math_fround(f325 * f283);
 f284 = Math_fround(f324 * f284);
 f285 = Math_fround(f323 * f285);
 f286 = Math_fround(f322 * f286);
 f287 = Math_fround(f321 * f287);
 f288 = Math_fround(f320 * f288);
 f289 = Math_fround(f323 * f289);
 f290 = Math_fround(f322 * f290);
 f291 = Math_fround(f321 * f291);
 f292 = Math_fround(f320 * f292);
 f293 = Math_fround(f323 * f293);
 f294 = Math_fround(f322 * f294);
 f295 = Math_fround(f321 * f295);
 f296 = Math_fround(f320 * f296);
 f297 = Math_fround(f323 * f297);
 f298 = Math_fround(f322 * f298);
 f299 = Math_fround(f321 * f299);
 f300 = Math_fround(f320 * f300);
 f301 = Math_fround(f323 * f301);
 f302 = Math_fround(f322 * f302);
 f303 = Math_fround(f321 * f303);
 f304 = Math_fround(f320 * f304);
 f305 = Math_fround(f323 * f305);
 f306 = Math_fround(f322 * f306);
 f307 = Math_fround(f321 * f307);
 f308 = Math_fround(f320 * f308);
 f309 = Math_fround(f323 * f309);
 f310 = Math_fround(f322 * f310);
 f311 = Math_fround(f321 * f311);
 f312 = Math_fround(f320 * f312);
 f313 = Math_fround(f323 * f313);
 f314 = Math_fround(f322 * f314);
 f315 = Math_fround(f321 * f315);
 f316 = Math_fround(f320 * f316);
 f317 = Math_fround(f323 * f317);
 f318 = Math_fround(f322 * f318);
 f319 = Math_fround(f321 * f319);
 f320 = Math_fround(f320 * Math_fround(HEAPF32[i346 + 32 >> 2]));
 f321 = Math_fround(f364 * Math_fround(.800000011));
 i346 = HEAP32[i6 + 28 >> 2] | 0;
 f322 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f323 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f324 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 84 >> 2] | 0;
 f325 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f326 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f327 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 140 >> 2] | 0;
 f328 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f329 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f330 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 196 >> 2] | 0;
 f331 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f332 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f333 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 32 >> 2] | 0;
 f334 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f335 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f336 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 88 >> 2] | 0;
 f337 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f338 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f339 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 144 >> 2] | 0;
 f340 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f341 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f342 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = HEAP32[i6 + 200 >> 2] | 0;
 f343 = Math_fround(HEAPF32[i346 + 16 >> 2]);
 f344 = Math_fround(HEAPF32[i346 + 20 >> 2]);
 f345 = Math_fround(HEAPF32[i346 + 24 >> 2]);
 i346 = i6 + 8 | 0;
 i2 = HEAP32[i346 >> 2] | 0;
 i347 = i6 + 64 | 0;
 i3 = HEAP32[i347 >> 2] | 0;
 i348 = i6 + 120 | 0;
 i4 = HEAP32[i348 >> 2] | 0;
 i349 = i6 + 176 | 0;
 i5 = HEAP32[i349 >> 2] | 0;
 i350 = i4 >>> 0 < i5 >>> 0 ? i5 : i4;
 i350 = i3 >>> 0 < i350 >>> 0 ? i350 : i3;
 i350 = i2 >>> 0 < i350 >>> 0 ? i350 : i2;
 if (!i350) {
  STACKTOP = i361;
  return 1;
 }
 i146 = (i1 & 65535) >>> 6;
 i145 = 8 - i146 & 255;
 i146 = 14 - i146 & 255;
 i147 = (i365 | 0) == 2 & 1;
 i148 = i358 + 4 | 0;
 i149 = i358 + 8 | 0;
 i150 = i358 + 12 | 0;
 i151 = i358 + 16 | 0;
 i152 = i358 + 20 | 0;
 i153 = i358 + 24 | 0;
 i154 = i358 + 28 | 0;
 i155 = i359 + 4 | 0;
 i156 = i359 + 8 | 0;
 i157 = i359 + 12 | 0;
 i158 = i359 + 16 | 0;
 i159 = i359 + 20 | 0;
 i160 = i359 + 24 | 0;
 i161 = i359 + 28 | 0;
 i162 = i360 + 4 | 0;
 i163 = i360 + 8 | 0;
 i164 = i360 + 12 | 0;
 i165 = i360 + 16 | 0;
 i166 = i360 + 20 | 0;
 i167 = i360 + 24 | 0;
 i168 = i360 + 28 | 0;
 i169 = (i365 | 0) == 0;
 i170 = i6 + 172 | 0;
 i171 = i6 + 116 | 0;
 i172 = i6 + 60 | 0;
 i143 = i6 + 4 | 0;
 i144 = Math_imul(i356, i365) | 0;
 i8 = 0;
 i9 = 0;
 i10 = 0;
 i11 = 0;
 i1 = 0;
 i16 = i12;
 i7 = i12 + ((i350 * 112 | 0) + (Math_imul(i355, i7) | 0)) | 0;
 while (1) {
  i23 = i1 >>> 0 >= i2 >>> 0;
  i24 = i1 >>> 0 >= i3 >>> 0;
  i25 = i1 >>> 0 >= i4 >>> 0;
  i27 = i1 >>> 0 >= i5 >>> 0;
  if (!i23) i8 = (HEAP32[i143 >> 2] | 0) + i1 | 0;
  if (!i24) i9 = (HEAP32[i172 >> 2] | 0) + i1 | 0;
  if (!i25) i10 = (HEAP32[i171 >> 2] | 0) + i1 | 0;
  if (!i27) i11 = (HEAP32[i170 >> 2] | 0) + i1 | 0;
  if (i23) i5 = 0; else i5 = HEAP32[i363 + 1408 + (i8 << 2) >> 2] | 0;
  if (i24) i4 = 0; else i4 = HEAP32[i363 + 1408 + (i9 << 2) >> 2] | 0;
  if (i25) i2 = 0; else i2 = HEAP32[i363 + 1408 + (i10 << 2) >> 2] | 0;
  if (i27) i3 = 0; else i3 = HEAP32[i363 + 1408 + (i11 << 2) >> 2] | 0;
  if (i23) i15 = 0; else i15 = HEAPU16[i363 + 768 + (i8 * 20 | 0) + 16 >> 1] | 0;
  if (i24) i14 = 0; else i14 = HEAPU16[i363 + 768 + (i9 * 20 | 0) + 16 >> 1] | 0;
  if (i25) i12 = 0; else i12 = HEAPU16[i363 + 768 + (i10 * 20 | 0) + 16 >> 1] | 0;
  if (i27) i13 = 0; else i13 = HEAPU16[i363 + 768 + (i11 * 20 | 0) + 16 >> 1] | 0;
  i74 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i74 = i4 >>> 0 < i74 >>> 0 ? i74 : i4;
  i74 = i5 >>> 0 < i74 >>> 0 ? i74 : i5;
  i100 = i12 >>> 0 < i13 >>> 0 ? i13 : i12;
  i100 = i14 >>> 0 < i100 >>> 0 ? i100 : i14;
  i17 = HEAP32[i363 + 1536 + (i8 << 2) >> 2] | 0;
  i18 = HEAP32[i363 + 1536 + (i9 << 2) >> 2] | 0;
  i19 = HEAP32[i363 + 1536 + (i10 << 2) >> 2] | 0;
  i20 = HEAP32[i363 + 1536 + (i11 << 2) >> 2] | 0;
  i108 = HEAPU16[i363 + (i17 * 12 | 0) >> 1] | 0;
  i106 = HEAPU16[i363 + (i18 * 12 | 0) >> 1] | 0;
  i105 = HEAPU16[i363 + (i19 * 12 | 0) >> 1] | 0;
  i104 = HEAPU16[i363 + (i20 * 12 | 0) >> 1] | 0;
  i26 = HEAP32[i366 + 384 + (i108 << 6) + 60 >> 2] | 0;
  i28 = HEAP32[i366 + 384 + (i106 << 6) + 60 >> 2] | 0;
  i30 = HEAP32[i366 + 384 + (i105 << 6) + 60 >> 2] | 0;
  i33 = HEAP32[i366 + 384 + (i104 << 6) + 60 >> 2] | 0;
  i102 = HEAP32[i366 + 384 + (i108 << 6) + 44 >> 2] | 0;
  i114 = HEAP32[i366 + 384 + (i106 << 6) + 44 >> 2] | 0;
  i101 = HEAP32[i366 + 384 + (i105 << 6) + 44 >> 2] | 0;
  i22 = HEAP32[i366 + 384 + (i104 << 6) + 44 >> 2] | 0;
  HEAP16[i16 + 2 >> 1] = i7 - i16;
  i6 = i16 + 112 | 0;
  i43 = i7 + ((i74 << 4) + 64) | 0;
  i99 = i5 & 255;
  HEAP8[i16 + 4 >> 0] = i99;
  i110 = i4 & 255;
  HEAP8[i16 + 5 >> 0] = i110;
  i103 = i2 & 255;
  HEAP8[i16 + 6 >> 0] = i103;
  i112 = i3 & 255;
  HEAP8[i16 + 7 >> 0] = i112;
  i74 = i74 & 255;
  HEAP8[i16 + 1 >> 0] = i74;
  HEAPF32[i16 + 80 >> 2] = f241;
  HEAPF32[i16 + 84 >> 2] = f242;
  HEAPF32[i16 + 88 >> 2] = f243;
  HEAPF32[i16 + 92 >> 2] = f244;
  HEAPF32[i16 + 96 >> 2] = f245;
  HEAPF32[i16 + 100 >> 2] = f246;
  HEAPF32[i16 + 104 >> 2] = f247;
  HEAPF32[i16 + 108 >> 2] = f248;
  HEAP32[i16 + 16 >> 2] = i26;
  HEAP32[i16 + 20 >> 2] = i28;
  HEAP32[i16 + 24 >> 2] = i30;
  HEAP32[i16 + 28 >> 2] = i33;
  HEAP8[i16 + 8 >> 0] = i357;
  HEAP8[i16 + 9 >> 0] = i351;
  HEAP8[i16 + 10 >> 0] = i352;
  HEAP8[i16 + 11 >> 0] = i353;
  HEAP8[i16 >> 0] = i145;
  HEAPF32[i7 + 32 >> 2] = f241;
  HEAPF32[i7 + 36 >> 2] = f242;
  HEAPF32[i7 + 40 >> 2] = f243;
  HEAPF32[i7 + 44 >> 2] = f244;
  HEAPF32[i7 + 48 >> 2] = f245;
  HEAPF32[i7 + 52 >> 2] = f246;
  HEAPF32[i7 + 56 >> 2] = f247;
  HEAPF32[i7 + 60 >> 2] = f248;
  HEAP8[i7 + 7 >> 0] = i15;
  HEAP8[i7 + 8 >> 0] = i14;
  HEAP8[i7 + 9 >> 0] = i12;
  HEAP8[i7 + 10 >> 0] = i13;
  HEAP8[i7 + 1 >> 0] = i74;
  HEAP8[i7 + 3 >> 0] = i99;
  HEAP8[i7 + 4 >> 0] = i110;
  HEAP8[i7 + 5 >> 0] = i103;
  HEAP8[i7 + 6 >> 0] = i112;
  HEAP8[i7 >> 0] = i146;
  HEAP32[i7 + 16 >> 2] = i102;
  HEAP32[i7 + 20 >> 2] = i114;
  HEAP32[i7 + 24 >> 2] = i101;
  HEAP32[i7 + 28 >> 2] = i22;
  HEAP32[i7 + 12 >> 2] = i147;
  HEAP8[i7 + 2 >> 0] = i15 >>> 0 < i100 >>> 0 ? i100 : i15;
  i108 = i366 + 384 + (i108 << 6) | 0;
  i100 = HEAP32[i108 >> 2] | 0;
  i22 = HEAP32[i108 + 4 >> 2] | 0;
  i108 = HEAP32[i108 + 8 >> 2] | 0;
  i106 = i366 + 384 + (i106 << 6) | 0;
  i101 = HEAP32[i106 >> 2] | 0;
  i114 = HEAP32[i106 + 4 >> 2] | 0;
  i106 = HEAP32[i106 + 8 >> 2] | 0;
  i105 = i366 + 384 + (i105 << 6) | 0;
  i102 = HEAP32[i105 >> 2] | 0;
  i112 = HEAP32[i105 + 4 >> 2] | 0;
  i105 = HEAP32[i105 + 8 >> 2] | 0;
  i104 = i366 + 384 + (i104 << 6) | 0;
  i103 = HEAP32[i104 >> 2] | 0;
  i110 = HEAP32[i104 + 4 >> 2] | 0;
  i104 = HEAP32[i104 + 8 >> 2] | 0;
  HEAP32[i16 + 32 >> 2] = i100;
  HEAP32[i16 + 36 >> 2] = i101;
  HEAP32[i16 + 40 >> 2] = i102;
  HEAP32[i16 + 44 >> 2] = i103;
  HEAP32[i16 + 48 >> 2] = i22;
  HEAP32[i16 + 52 >> 2] = i114;
  HEAP32[i16 + 56 >> 2] = i112;
  HEAP32[i16 + 60 >> 2] = i110;
  HEAP32[i16 + 64 >> 2] = i108;
  HEAP32[i16 + 68 >> 2] = i106;
  HEAP32[i16 + 72 >> 2] = i105;
  HEAP32[i16 + 76 >> 2] = i104;
  f115 = (HEAP32[tempDoublePtr >> 2] = i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f139 = Math_fround(f115 * f115);
  f116 = (HEAP32[tempDoublePtr >> 2] = i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f140 = Math_fround(f116 * f116);
  f117 = (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f141 = Math_fround(f117 * f117);
  f118 = (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f142 = Math_fround(f118 * f118);
  f119 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f120 = (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f121 = (HEAP32[tempDoublePtr >> 2] = i112, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f122 = (HEAP32[tempDoublePtr >> 2] = i110, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f139 = Math_fround(f139 + Math_fround(f119 * f119));
  f140 = Math_fround(f140 + Math_fround(f120 * f120));
  f141 = Math_fround(f141 + Math_fround(f121 * f121));
  f142 = Math_fround(f142 + Math_fround(f122 * f122));
  f123 = (HEAP32[tempDoublePtr >> 2] = i108, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f124 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f125 = (HEAP32[tempDoublePtr >> 2] = i105, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f126 = (HEAP32[tempDoublePtr >> 2] = i104, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f139 = Math_fround(Math_fround(f123 * f123) + f139);
  f140 = Math_fround(Math_fround(f124 * f124) + f140);
  f141 = Math_fround(Math_fround(f125 * f125) + f141);
  f142 = Math_fround(Math_fround(f126 * f126) + f142);
  f127 = Math_fround(Math_fround(f183 * f123) + Math_fround(Math_fround(f181 * f115) + Math_fround(f182 * f119)));
  f128 = Math_fround(Math_fround(f186 * f124) + Math_fround(Math_fround(f184 * f116) + Math_fround(f185 * f120)));
  f129 = Math_fround(Math_fround(f189 * f125) + Math_fround(Math_fround(f187 * f117) + Math_fround(f188 * f121)));
  f130 = Math_fround(Math_fround(f192 * f126) + Math_fround(Math_fround(f190 * f118) + Math_fround(f191 * f122)));
  f131 = Math_fround(Math_fround(f195 * f123) + Math_fround(Math_fround(f193 * f115) + Math_fround(f194 * f119)));
  f132 = Math_fround(Math_fround(f198 * f124) + Math_fround(Math_fround(f196 * f116) + Math_fround(f197 * f120)));
  f133 = Math_fround(Math_fround(f201 * f125) + Math_fround(Math_fround(f199 * f117) + Math_fround(f200 * f121)));
  f134 = Math_fround(Math_fround(f204 * f126) + Math_fround(Math_fround(f202 * f118) + Math_fround(f203 * f122)));
  f135 = Math_fround(f241 * f139);
  f136 = Math_fround(f242 * f140);
  f137 = Math_fround(f243 * f141);
  f138 = Math_fround(f244 * f142);
  f139 = Math_fround(f139 * f245);
  f140 = Math_fround(f140 * f246);
  f141 = Math_fround(f141 * f247);
  f142 = Math_fround(f142 * f248);
  f82 = Math_fround(-f115);
  f81 = Math_fround(-f116);
  f80 = Math_fround(-f117);
  f79 = Math_fround(-f118);
  i104 = (f115 > f82 ? f115 : f82) < Math_fround(.707106769);
  i105 = (f116 > f81 ? f116 : f81) < Math_fround(.707106769);
  i106 = (f117 > f80 ? f117 : f80) < Math_fround(.707106769);
  i108 = (f118 > f79 ? f118 : f79) < Math_fround(.707106769);
  f79 = Math_fround(-f119);
  f80 = Math_fround(-f120);
  f81 = Math_fround(-f121);
  f82 = Math_fround(-f122);
  f79 = i104 ? Math_fround(0.0) : f79;
  f80 = i105 ? Math_fround(0.0) : f80;
  f81 = i106 ? Math_fround(0.0) : f81;
  f82 = i108 ? Math_fround(0.0) : f82;
  f87 = Math_fround(-f123);
  f88 = Math_fround(-f124);
  f89 = Math_fround(-f125);
  f90 = Math_fround(-f126);
  f86 = i104 ? f119 : Math_fround(0.0);
  f85 = i105 ? f120 : Math_fround(0.0);
  f97 = i106 ? f121 : Math_fround(0.0);
  f98 = i108 ? f122 : Math_fround(0.0);
  f83 = Math_fround(Math_fround(f237 * f123) + Math_fround(Math_fround(f229 * f115) + Math_fround(f233 * f119)));
  f84 = Math_fround(Math_fround(f238 * f124) + Math_fround(Math_fround(f230 * f116) + Math_fround(f234 * f120)));
  f96 = Math_fround(Math_fround(f239 * f125) + Math_fround(Math_fround(f231 * f117) + Math_fround(f235 * f121)));
  f95 = Math_fround(Math_fround(f240 * f126) + Math_fround(Math_fround(f232 * f118) + Math_fround(f236 * f122)));
  f113 = Math_fround(f229 - Math_fround(f115 * f83));
  f111 = Math_fround(f230 - Math_fround(f116 * f84));
  f109 = Math_fround(f231 - Math_fround(f117 * f96));
  f107 = Math_fround(f232 - Math_fround(f118 * f95));
  f94 = Math_fround(f233 - Math_fround(f119 * f83));
  f93 = Math_fround(f234 - Math_fround(f120 * f84));
  f92 = Math_fround(f235 - Math_fround(f121 * f96));
  f91 = Math_fround(f236 - Math_fround(f122 * f95));
  f83 = Math_fround(f237 - Math_fround(f123 * f83));
  f84 = Math_fround(f238 - Math_fround(f124 * f84));
  f96 = Math_fround(f239 - Math_fround(f125 * f96));
  f95 = Math_fround(f240 - Math_fround(f126 * f95));
  i110 = Math_fround(Math_fround(f113 * f113) + Math_fround(Math_fround(f94 * f94) + Math_fround(f83 * f83))) > Math_fround(.100000001);
  i112 = Math_fround(Math_fround(f111 * f111) + Math_fround(Math_fround(f93 * f93) + Math_fround(f84 * f84))) > Math_fround(.100000001);
  i114 = Math_fround(Math_fround(f109 * f109) + Math_fround(Math_fround(f92 * f92) + Math_fround(f96 * f96))) > Math_fround(.100000001);
  i22 = Math_fround(Math_fround(f107 * f107) + Math_fround(Math_fround(f91 * f91) + Math_fround(f95 * f95))) > Math_fround(.100000001);
  f79 = i110 ? f113 : f79;
  f80 = i112 ? f111 : f80;
  f81 = i114 ? f109 : f81;
  f82 = i22 ? f107 : f82;
  f87 = i110 ? f94 : i104 ? f87 : f115;
  f88 = i112 ? f93 : i105 ? f88 : f116;
  f89 = i114 ? f92 : i106 ? f89 : f117;
  f90 = i22 ? f91 : i108 ? f90 : f118;
  f86 = i110 ? f83 : f86;
  f85 = i112 ? f84 : f85;
  f97 = i114 ? f96 : f97;
  f98 = i22 ? f95 : f98;
  f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f79 * f79) + Math_fround(Math_fround(f87 * f87) + Math_fround(f86 * f86))))));
  f96 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f80 * f80) + Math_fround(Math_fround(f88 * f88) + Math_fround(f85 * f85))))));
  f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f81 * f81) + Math_fround(Math_fround(f89 * f89) + Math_fround(f97 * f97))))));
  f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f82 * f82) + Math_fround(Math_fround(f90 * f90) + Math_fround(f98 * f98))))));
  f79 = Math_fround(f79 * f95);
  f80 = Math_fround(f80 * f96);
  f81 = Math_fround(f84 * f81);
  f82 = Math_fround(f83 * f82);
  f87 = Math_fround(f87 * f95);
  f88 = Math_fround(f88 * f96);
  f89 = Math_fround(f84 * f89);
  f90 = Math_fround(f83 * f90);
  f95 = Math_fround(f86 * f95);
  f96 = Math_fround(f85 * f96);
  f97 = Math_fround(f84 * f97);
  f98 = Math_fround(f83 * f98);
  f83 = Math_fround(Math_fround(f119 * f95) - Math_fround(f123 * f87));
  f84 = Math_fround(Math_fround(f120 * f96) - Math_fround(f124 * f88));
  f85 = Math_fround(Math_fround(f121 * f97) - Math_fround(f125 * f89));
  f86 = Math_fround(Math_fround(f122 * f98) - Math_fround(f126 * f90));
  f91 = Math_fround(Math_fround(f123 * f79) - Math_fround(f115 * f95));
  f92 = Math_fround(Math_fround(f124 * f80) - Math_fround(f116 * f96));
  f93 = Math_fround(Math_fround(f125 * f81) - Math_fround(f117 * f97));
  f94 = Math_fround(Math_fround(f126 * f82) - Math_fround(f118 * f98));
  f107 = Math_fround(Math_fround(f115 * f87) - Math_fround(f119 * f79));
  f109 = Math_fround(Math_fround(f116 * f88) - Math_fround(f120 * f80));
  f111 = Math_fround(Math_fround(f117 * f89) - Math_fround(f121 * f81));
  f113 = Math_fround(Math_fround(f118 * f90) - Math_fround(f122 * f82));
  HEAPF32[i358 >> 2] = f79;
  HEAPF32[i148 >> 2] = f80;
  HEAPF32[i149 >> 2] = f81;
  HEAPF32[i150 >> 2] = f82;
  HEAPF32[i151 >> 2] = f83;
  HEAPF32[i152 >> 2] = f84;
  HEAPF32[i153 >> 2] = f85;
  HEAPF32[i154 >> 2] = f86;
  HEAPF32[i359 >> 2] = f87;
  HEAPF32[i155 >> 2] = f88;
  HEAPF32[i156 >> 2] = f89;
  HEAPF32[i157 >> 2] = f90;
  HEAPF32[i158 >> 2] = f91;
  HEAPF32[i159 >> 2] = f92;
  HEAPF32[i160 >> 2] = f93;
  HEAPF32[i161 >> 2] = f94;
  HEAPF32[i360 >> 2] = f95;
  HEAPF32[i162 >> 2] = f96;
  HEAPF32[i163 >> 2] = f97;
  HEAPF32[i164 >> 2] = f98;
  HEAPF32[i165 >> 2] = f107;
  HEAPF32[i166 >> 2] = f109;
  HEAPF32[i167 >> 2] = f111;
  HEAPF32[i168 >> 2] = f113;
  i22 = (i24 & 1) << 1 | i23 & 1 | (i25 & 1) << 2 | (i27 & 1) << 3;
  L42 : do if ((i17 | 0) == 65535) i2 = 65535; else {
   i2 = i17;
   do {
    if (HEAP16[i363 + (i2 * 12 | 0) + 2 >> 1] | 0) break L42;
    i114 = HEAP16[i363 + (i2 * 12 | 0) + 4 >> 1] | 0;
    i2 = i114 & 65535;
   } while (i114 << 16 >> 16 != -1);
  } while (0);
  L47 : do if ((i18 | 0) == 65535) i3 = 65535; else {
   i3 = i18;
   do {
    if (HEAP16[i363 + (i3 * 12 | 0) + 2 >> 1] | 0) break L47;
    i114 = HEAP16[i363 + (i3 * 12 | 0) + 4 >> 1] | 0;
    i3 = i114 & 65535;
   } while (i114 << 16 >> 16 != -1);
  } while (0);
  L52 : do if ((i19 | 0) == 65535) i4 = 65535; else {
   i4 = i19;
   do {
    if (HEAP16[i363 + (i4 * 12 | 0) + 2 >> 1] | 0) break L52;
    i114 = HEAP16[i363 + (i4 * 12 | 0) + 4 >> 1] | 0;
    i4 = i114 & 65535;
   } while (i114 << 16 >> 16 != -1);
  } while (0);
  L57 : do if ((i20 | 0) == 65535) i5 = 65535; else {
   i5 = i20;
   do {
    if (HEAP16[i363 + (i5 * 12 | 0) + 2 >> 1] | 0) break L57;
    i114 = HEAP16[i363 + (i5 * 12 | 0) + 4 >> 1] | 0;
    i5 = i114 & 65535;
   } while (i114 << 16 >> 16 != -1);
  } while (0);
  L62 : do if ((i2 | 0) == 65535) {
   i12 = 1;
   i7 = 65535;
  } else {
   i12 = 1;
   i7 = i2;
   while (1) {
    if ((i12 | 0) != (HEAPU16[i363 + (i7 * 12 | 0) + 2 >> 1] | 0)) break L62;
    i114 = HEAP16[i363 + (i7 * 12 | 0) + 4 >> 1] | 0;
    i7 = i114 & 65535;
    if (i114 << 16 >> 16 == -1) {
     i12 = 0;
     break;
    } else i12 = 0;
   }
  } while (0);
  L67 : do if ((i3 | 0) == 65535) {
   i14 = 1;
   i13 = 65535;
  } else {
   i14 = 1;
   i13 = i3;
   while (1) {
    if ((i14 | 0) != (HEAPU16[i363 + (i13 * 12 | 0) + 2 >> 1] | 0)) break L67;
    i114 = HEAP16[i363 + (i13 * 12 | 0) + 4 >> 1] | 0;
    i13 = i114 & 65535;
    if (i114 << 16 >> 16 == -1) {
     i14 = 0;
     break;
    } else i14 = 0;
   }
  } while (0);
  L72 : do if ((i4 | 0) == 65535) {
   i16 = 1;
   i18 = 65535;
  } else {
   i16 = 1;
   i15 = i4;
   while (1) {
    if ((i16 | 0) != (HEAPU16[i363 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i18 = i15;
     break L72;
    }
    i114 = HEAP16[i363 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i114 & 65535;
    if (i114 << 16 >> 16 == -1) {
     i16 = 0;
     i18 = i15;
     break;
    } else i16 = 0;
   }
  } while (0);
  L77 : do if ((i5 | 0) == 65535) {
   i21 = 1;
   i20 = 65535;
  } else {
   i17 = 1;
   i15 = i5;
   while (1) {
    if ((i17 | 0) != (HEAPU16[i363 + (i15 * 12 | 0) + 2 >> 1] | 0)) {
     i21 = i17;
     i20 = i15;
     break L77;
    }
    i114 = HEAP16[i363 + (i15 * 12 | 0) + 4 >> 1] | 0;
    i15 = i114 & 65535;
    if (i114 << 16 >> 16 == -1) {
     i21 = 0;
     i20 = i15;
     break;
    } else i17 = 0;
   }
  } while (0);
  if (i23) i15 = 1; else {
   if ((i7 | 0) == 65535) i15 = 0; else i15 = i12 >>> 0 < (HEAPU16[i363 + (i7 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i17 = i15 & 1;
  if (i24) i15 = 1; else {
   if ((i13 | 0) == 65535) i15 = 0; else i15 = i14 >>> 0 < (HEAPU16[i363 + (i13 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i17 = (i15 & 1) << 1 | i17;
  if (i25) i15 = 1; else {
   if ((i18 | 0) == 65535) i15 = 0; else i15 = i16 >>> 0 < (HEAPU16[i363 + (i18 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  i19 = i17 | (i15 & 1) << 2;
  if (i27) i15 = 1; else {
   if ((i20 | 0) == 65535) i15 = 0; else i15 = i21 >>> 0 < (HEAPU16[i363 + (i20 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   i15 = i15 ^ 1;
  }
  f113 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i114 = f113 > Math_fround(0.0);
  f111 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i112 = f111 > Math_fround(0.0);
  f109 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i110 = f109 > Math_fround(0.0);
  f107 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i108 = f107 > Math_fround(0.0);
  i23 = i7;
  i106 = i20;
  i24 = 0;
  i26 = 0;
  i17 = 0;
  i105 = 0;
  i20 = 0;
  i15 = i19 | (i15 & 1) << 3;
  i7 = i43;
  L106 : while (1) {
   i104 = i363 + (i5 * 12 | 0) | 0;
   i99 = i12;
   i100 = i14;
   i101 = i13;
   i103 = i16;
   i12 = i22;
   i5 = i20;
   i22 = i15;
   while (1) {
    if ((i12 | 0) == 15) break L106;
    i102 = i6 + i355 | 0;
    i13 = (HEAPU16[i363 + (i2 * 12 | 0) >> 1] | 0) + i24 | 0;
    i14 = (HEAPU16[i363 + (i3 * 12 | 0) >> 1] | 0) + i26 | 0;
    i15 = (HEAPU16[i363 + (i4 * 12 | 0) >> 1] | 0) + i17 | 0;
    i16 = (HEAPU16[i104 >> 1] | 0) + i105 | 0;
    i12 = i366 + 384 + (i13 << 6) + 16 | 0;
    f75 = Math_fround(HEAPF32[i12 >> 2]);
    f79 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f83 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    i12 = i366 + 384 + (i14 << 6) + 16 | 0;
    f76 = Math_fround(HEAPF32[i12 >> 2]);
    f80 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f84 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    i12 = i366 + 384 + (i15 << 6) + 16 | 0;
    f77 = Math_fround(HEAPF32[i12 >> 2]);
    f81 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f85 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    i12 = i366 + 384 + (i16 << 6) + 16 | 0;
    f78 = Math_fround(HEAPF32[i12 >> 2]);
    f82 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f86 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    i12 = i366 + 384 + (i13 << 6) + 32 | 0;
    f94 = Math_fround(HEAPF32[i12 >> 2]);
    i19 = i12 + 4 | 0;
    f93 = Math_fround(HEAPF32[i19 >> 2]);
    i20 = i12 + 8 | 0;
    f44 = Math_fround(HEAPF32[i20 >> 2]);
    i25 = i366 + 384 + (i14 << 6) + 32 | 0;
    f92 = Math_fround(HEAPF32[i25 >> 2]);
    i27 = i25 + 4 | 0;
    f91 = Math_fround(HEAPF32[i27 >> 2]);
    i28 = i25 + 8 | 0;
    f45 = Math_fround(HEAPF32[i28 >> 2]);
    i30 = i366 + 384 + (i15 << 6) + 32 | 0;
    f90 = Math_fround(HEAPF32[i30 >> 2]);
    i33 = i30 + 4 | 0;
    f89 = Math_fround(HEAPF32[i33 >> 2]);
    i43 = i30 + 8 | 0;
    f46 = Math_fround(HEAPF32[i43 >> 2]);
    i72 = i366 + 384 + (i16 << 6) + 32 | 0;
    f88 = Math_fround(HEAPF32[i72 >> 2]);
    i73 = i72 + 4 | 0;
    f87 = Math_fround(HEAPF32[i73 >> 2]);
    i74 = i72 + 8 | 0;
    f47 = Math_fround(HEAPF32[i74 >> 2]);
    f39 = Math_fround(HEAPF32[i366 + 384 + (i13 << 6) + 12 >> 2]);
    f40 = Math_fround(HEAPF32[i366 + 384 + (i14 << 6) + 12 >> 2]);
    f41 = Math_fround(HEAPF32[i366 + 384 + (i15 << 6) + 12 >> 2]);
    f42 = Math_fround(HEAPF32[i366 + 384 + (i16 << 6) + 12 >> 2]);
    i13 = HEAP32[i366 + 384 + (i13 << 6) + 28 >> 2] | 0;
    i14 = HEAP32[i366 + 384 + (i14 << 6) + 28 >> 2] | 0;
    i15 = HEAP32[i366 + 384 + (i15 << 6) + 28 >> 2] | 0;
    i16 = HEAP32[i366 + 384 + (i16 << 6) + 28 >> 2] | 0;
    f44 = Math_fround(Math_fround(f115 * f94) + Math_fround(Math_fround(f119 * f93) + Math_fround(f123 * f44)));
    f45 = Math_fround(Math_fround(f116 * f92) + Math_fround(Math_fround(f120 * f91) + Math_fround(f124 * f45)));
    f46 = Math_fround(Math_fround(f117 * f90) + Math_fround(Math_fround(f121 * f89) + Math_fround(f125 * f46)));
    f47 = Math_fround(Math_fround(f118 * f88) + Math_fround(Math_fround(f122 * f87) + Math_fround(f126 * f47)));
    f87 = Math_fround(f75 - f322);
    f88 = Math_fround(f76 - f325);
    f89 = Math_fround(f77 - f328);
    f90 = Math_fround(f78 - f331);
    f91 = Math_fround(f79 - f323);
    f92 = Math_fround(f80 - f326);
    f93 = Math_fround(f81 - f329);
    f94 = Math_fround(f82 - f332);
    f95 = Math_fround(f83 - f324);
    f96 = Math_fround(f84 - f327);
    f97 = Math_fround(f85 - f330);
    f98 = Math_fround(f86 - f333);
    f75 = Math_fround(f75 - f334);
    f76 = Math_fround(f76 - f337);
    f77 = Math_fround(f77 - f340);
    f78 = Math_fround(f78 - f343);
    f79 = Math_fround(f79 - f335);
    f80 = Math_fround(f80 - f338);
    f81 = Math_fround(f81 - f341);
    f82 = Math_fround(f82 - f344);
    f83 = Math_fround(f83 - f336);
    f84 = Math_fround(f84 - f339);
    f85 = Math_fround(f85 - f342);
    f86 = Math_fround(f86 - f345);
    f48 = Math_fround(Math_fround(f123 * f91) - Math_fround(f119 * f95));
    f49 = Math_fround(Math_fround(f124 * f92) - Math_fround(f120 * f96));
    f50 = Math_fround(Math_fround(f125 * f93) - Math_fround(f121 * f97));
    f51 = Math_fround(Math_fround(f126 * f94) - Math_fround(f122 * f98));
    f52 = Math_fround(Math_fround(f115 * f95) - Math_fround(f123 * f87));
    f53 = Math_fround(Math_fround(f116 * f96) - Math_fround(f124 * f88));
    f54 = Math_fround(Math_fround(f117 * f97) - Math_fround(f125 * f89));
    f55 = Math_fround(Math_fround(f118 * f98) - Math_fround(f126 * f90));
    f56 = Math_fround(Math_fround(f119 * f87) - Math_fround(f115 * f91));
    f57 = Math_fround(Math_fround(f120 * f88) - Math_fround(f116 * f92));
    f58 = Math_fround(Math_fround(f121 * f89) - Math_fround(f117 * f93));
    f59 = Math_fround(Math_fround(f122 * f90) - Math_fround(f118 * f94));
    f60 = Math_fround(Math_fround(f257 * f56) + Math_fround(Math_fround(f253 * f52) + Math_fround(f249 * f48)));
    f61 = Math_fround(Math_fround(f258 * f57) + Math_fround(Math_fround(f254 * f53) + Math_fround(f250 * f49)));
    f62 = Math_fround(Math_fround(f259 * f58) + Math_fround(Math_fround(f255 * f54) + Math_fround(f251 * f50)));
    f63 = Math_fround(Math_fround(f260 * f59) + Math_fround(Math_fround(f256 * f55) + Math_fround(f252 * f51)));
    f64 = Math_fround(Math_fround(f269 * f56) + Math_fround(Math_fround(f265 * f52) + Math_fround(f261 * f48)));
    f65 = Math_fround(Math_fround(f270 * f57) + Math_fround(Math_fround(f266 * f53) + Math_fround(f262 * f49)));
    f66 = Math_fround(Math_fround(f271 * f58) + Math_fround(Math_fround(f267 * f54) + Math_fround(f263 * f50)));
    f67 = Math_fround(Math_fround(f272 * f59) + Math_fround(Math_fround(f268 * f55) + Math_fround(f264 * f51)));
    f68 = Math_fround(Math_fround(f281 * f56) + Math_fround(Math_fround(f277 * f52) + Math_fround(f273 * f48)));
    f69 = Math_fround(Math_fround(f282 * f57) + Math_fround(Math_fround(f278 * f53) + Math_fround(f274 * f49)));
    f70 = Math_fround(Math_fround(f283 * f58) + Math_fround(Math_fround(f279 * f54) + Math_fround(f275 * f50)));
    f71 = Math_fround(Math_fround(f284 * f59) + Math_fround(Math_fround(f280 * f55) + Math_fround(f276 * f51)));
    f29 = Math_fround(f135 + Math_fround(Math_fround(f56 * f68) + Math_fround(Math_fround(f52 * f64) + Math_fround(f48 * f60))));
    f32 = Math_fround(f136 + Math_fround(Math_fround(f57 * f69) + Math_fround(Math_fround(f53 * f65) + Math_fround(f49 * f61))));
    f35 = Math_fround(f137 + Math_fround(Math_fround(f58 * f70) + Math_fround(Math_fround(f54 * f66) + Math_fround(f50 * f62))));
    f37 = Math_fround(f138 + Math_fround(Math_fround(f59 * f71) + Math_fround(Math_fround(f55 * f67) + Math_fround(f51 * f63))));
    f38 = Math_fround(f127 + Math_fround(Math_fround(f207 * f56) + Math_fround(Math_fround(f206 * f52) + Math_fround(f205 * f48))));
    f36 = Math_fround(f128 + Math_fround(Math_fround(f210 * f57) + Math_fround(Math_fround(f209 * f53) + Math_fround(f208 * f49))));
    f34 = Math_fround(f129 + Math_fround(Math_fround(f213 * f58) + Math_fround(Math_fround(f212 * f54) + Math_fround(f211 * f50))));
    f31 = Math_fround(f130 + Math_fround(Math_fround(f216 * f59) + Math_fround(Math_fround(f215 * f55) + Math_fround(f214 * f51))));
    if (i354) {
     f390 = Math_fround(Math_fround(f123 * f79) - Math_fround(f119 * f83));
     f389 = Math_fround(Math_fround(f124 * f80) - Math_fround(f120 * f84));
     f388 = Math_fround(Math_fround(f125 * f81) - Math_fround(f121 * f85));
     f387 = Math_fround(Math_fround(f126 * f82) - Math_fround(f122 * f86));
     f386 = Math_fround(Math_fround(f115 * f83) - Math_fround(f123 * f75));
     f385 = Math_fround(Math_fround(f116 * f84) - Math_fround(f124 * f76));
     f384 = Math_fround(Math_fround(f117 * f85) - Math_fround(f125 * f77));
     f383 = Math_fround(Math_fround(f118 * f86) - Math_fround(f126 * f78));
     f382 = Math_fround(Math_fround(f119 * f75) - Math_fround(f115 * f79));
     f381 = Math_fround(Math_fround(f120 * f76) - Math_fround(f116 * f80));
     f380 = Math_fround(Math_fround(f121 * f77) - Math_fround(f117 * f81));
     f379 = Math_fround(Math_fround(f122 * f78) - Math_fround(f118 * f82));
     f378 = Math_fround(Math_fround(f293 * f382) + Math_fround(Math_fround(f289 * f386) + Math_fround(f285 * f390)));
     f377 = Math_fround(Math_fround(f294 * f381) + Math_fround(Math_fround(f290 * f385) + Math_fround(f286 * f389)));
     f376 = Math_fround(Math_fround(f295 * f380) + Math_fround(Math_fround(f291 * f384) + Math_fround(f287 * f388)));
     f375 = Math_fround(Math_fround(f296 * f379) + Math_fround(Math_fround(f292 * f383) + Math_fround(f288 * f387)));
     f374 = Math_fround(Math_fround(f305 * f382) + Math_fround(Math_fround(f301 * f386) + Math_fround(f297 * f390)));
     f373 = Math_fround(Math_fround(f306 * f381) + Math_fround(Math_fround(f302 * f385) + Math_fround(f298 * f389)));
     f372 = Math_fround(Math_fround(f307 * f380) + Math_fround(Math_fround(f303 * f384) + Math_fround(f299 * f388)));
     f371 = Math_fround(Math_fround(f308 * f379) + Math_fround(Math_fround(f304 * f383) + Math_fround(f300 * f387)));
     f370 = Math_fround(Math_fround(f317 * f382) + Math_fround(Math_fround(f313 * f386) + Math_fround(f309 * f390)));
     f369 = Math_fround(Math_fround(f318 * f381) + Math_fround(Math_fround(f314 * f385) + Math_fround(f310 * f389)));
     f368 = Math_fround(Math_fround(f319 * f380) + Math_fround(Math_fround(f315 * f384) + Math_fround(f311 * f388)));
     f367 = Math_fround(Math_fround(f320 * f379) + Math_fround(Math_fround(f316 * f383) + Math_fround(f312 * f387)));
     f29 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f382 * f370) + Math_fround(Math_fround(f386 * f374) + Math_fround(f390 * f378))) - f139));
     f32 = Math_fround(f32 + Math_fround(Math_fround(Math_fround(f381 * f369) + Math_fround(Math_fround(f385 * f373) + Math_fround(f389 * f377))) - f140));
     f35 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f380 * f368) + Math_fround(Math_fround(f384 * f372) + Math_fround(f388 * f376))) - f141));
     f37 = Math_fround(f37 + Math_fround(Math_fround(Math_fround(f379 * f367) + Math_fround(Math_fround(f383 * f371) + Math_fround(f387 * f375))) - f142));
     f38 = Math_fround(f38 - Math_fround(f131 + Math_fround(Math_fround(f219 * f382) + Math_fround(Math_fround(f218 * f386) + Math_fround(f217 * f390)))));
     f36 = Math_fround(f36 - Math_fround(f132 + Math_fround(Math_fround(f222 * f381) + Math_fround(Math_fround(f221 * f385) + Math_fround(f220 * f389)))));
     f34 = Math_fround(f34 - Math_fround(f133 + Math_fround(Math_fround(f225 * f380) + Math_fround(Math_fround(f224 * f384) + Math_fround(f223 * f388)))));
     f31 = Math_fround(f31 - Math_fround(f134 + Math_fround(Math_fround(f228 * f379) + Math_fround(Math_fround(f227 * f383) + Math_fround(f226 * f387)))));
     HEAPF32[i6 + 176 >> 2] = f390;
     HEAPF32[i6 + 180 >> 2] = f389;
     HEAPF32[i6 + 184 >> 2] = f388;
     HEAPF32[i6 + 188 >> 2] = f387;
     HEAPF32[i6 + 192 >> 2] = f386;
     HEAPF32[i6 + 196 >> 2] = f385;
     HEAPF32[i6 + 200 >> 2] = f384;
     HEAPF32[i6 + 204 >> 2] = f383;
     HEAPF32[i6 + 208 >> 2] = f382;
     HEAPF32[i6 + 212 >> 2] = f381;
     HEAPF32[i6 + 216 >> 2] = f380;
     HEAPF32[i6 + 220 >> 2] = f379;
     f377 = Math_fround(-f377);
     f376 = Math_fround(-f376);
     f375 = Math_fround(-f375);
     HEAPF32[i6 + 224 >> 2] = Math_fround(-f378);
     HEAPF32[i6 + 228 >> 2] = f377;
     HEAPF32[i6 + 232 >> 2] = f376;
     HEAPF32[i6 + 236 >> 2] = f375;
     f373 = Math_fround(-f373);
     f372 = Math_fround(-f372);
     f371 = Math_fround(-f371);
     HEAPF32[i6 + 240 >> 2] = Math_fround(-f374);
     HEAPF32[i6 + 244 >> 2] = f373;
     HEAPF32[i6 + 248 >> 2] = f372;
     HEAPF32[i6 + 252 >> 2] = f371;
     f369 = Math_fround(-f369);
     f368 = Math_fround(-f368);
     f367 = Math_fround(-f367);
     HEAPF32[i6 + 256 >> 2] = Math_fround(-f370);
     HEAPF32[i6 + 260 >> 2] = f369;
     HEAPF32[i6 + 264 >> 2] = f368;
     HEAPF32[i6 + 268 >> 2] = f367;
    }
    i391 = f29 > Math_fround(0.0);
    i392 = f32 > Math_fround(0.0);
    i393 = f35 > Math_fround(0.0);
    i394 = f37 > Math_fround(0.0);
    f389 = Math_fround(Math_fround(1.0) / f29);
    f390 = Math_fround(Math_fround(1.0) / f32);
    f29 = Math_fround(Math_fround(1.0) / f35);
    f32 = Math_fround(Math_fround(1.0) / f37);
    f389 = i391 ? f389 : Math_fround(0.0);
    f390 = i392 ? f390 : Math_fround(0.0);
    f29 = i393 ? f29 : Math_fround(0.0);
    f32 = i394 ? f32 : Math_fround(0.0);
    f383 = Math_fround(f39 - f177);
    f384 = Math_fround(f40 - f178);
    f385 = Math_fround(f41 - f179);
    f386 = Math_fround(f42 - f180);
    f35 = Math_fround(f321 * f383);
    f387 = Math_fround(f321 * f384);
    f37 = Math_fround(f321 * f385);
    f388 = Math_fround(f321 * f386);
    f35 = Math_fround((f173 > f35 ? f173 : f35) * f389);
    f387 = Math_fround((f174 > f387 ? f174 : f387) * f390);
    f37 = Math_fround((f175 > f37 ? f175 : f37) * f29);
    f388 = Math_fround((f176 > f388 ? f176 : f388) * f32);
    f39 = Math_fround(-f38);
    f40 = Math_fround(-f36);
    f41 = Math_fround(-f34);
    f42 = Math_fround(-f31);
    i394 = Math_fround(f383 * f364) < f39 & (i114 & f38 < f362);
    i393 = Math_fround(f384 * f364) < f40 & (i112 & f36 < f362);
    i392 = Math_fround(f385 * f364) < f41 & (i110 & f34 < f362);
    i391 = Math_fround(f386 * f364) < f42 & (i108 & f31 < f362);
    f35 = i394 ? Math_fround(0.0) : f35;
    f36 = i393 ? Math_fround(0.0) : f387;
    f37 = i392 ? Math_fround(0.0) : f37;
    f38 = i391 ? Math_fround(0.0) : f388;
    f39 = Math_fround(f113 * f39);
    f40 = Math_fround(f111 * f40);
    f41 = Math_fround(f109 * f41);
    f42 = Math_fround(f107 * f42);
    f39 = i394 ? f39 : Math_fround(0.0);
    f40 = i393 ? f40 : Math_fround(0.0);
    f41 = i392 ? f41 : Math_fround(0.0);
    f39 = Math_fround(f44 + f39);
    f40 = Math_fround(f45 + f40);
    f41 = Math_fround(f46 + f41);
    f42 = Math_fround(f47 + (i391 ? f42 : Math_fround(0.0)));
    HEAPF32[i6 >> 2] = f48;
    HEAPF32[i6 + 4 >> 2] = f49;
    HEAPF32[i6 + 8 >> 2] = f50;
    HEAPF32[i6 + 12 >> 2] = f51;
    HEAPF32[i6 + 16 >> 2] = f52;
    HEAPF32[i6 + 20 >> 2] = f53;
    HEAPF32[i6 + 24 >> 2] = f54;
    HEAPF32[i6 + 28 >> 2] = f55;
    HEAPF32[i6 + 32 >> 2] = f56;
    HEAPF32[i6 + 36 >> 2] = f57;
    HEAPF32[i6 + 40 >> 2] = f58;
    HEAPF32[i6 + 44 >> 2] = f59;
    HEAPF32[i6 + 112 >> 2] = f389;
    HEAPF32[i6 + 116 >> 2] = f390;
    HEAPF32[i6 + 120 >> 2] = f29;
    HEAPF32[i6 + 124 >> 2] = f32;
    i391 = i6 + 96 | 0;
    HEAP32[i391 >> 2] = 0;
    HEAP32[i391 + 4 >> 2] = 0;
    HEAP32[i391 + 8 >> 2] = 0;
    HEAP32[i391 + 12 >> 2] = 0;
    HEAPF32[i6 + 144 >> 2] = f35;
    HEAPF32[i6 + 148 >> 2] = f36;
    HEAPF32[i6 + 152 >> 2] = f37;
    HEAPF32[i6 + 156 >> 2] = f38;
    HEAPF32[i6 + 128 >> 2] = f39;
    HEAPF32[i6 + 132 >> 2] = f40;
    HEAPF32[i6 + 136 >> 2] = f41;
    HEAPF32[i6 + 140 >> 2] = f42;
    HEAP32[i6 + 160 >> 2] = i13;
    HEAP32[i6 + 164 >> 2] = i14;
    HEAP32[i6 + 168 >> 2] = i15;
    HEAP32[i6 + 172 >> 2] = i16;
    HEAPF32[i6 + 48 >> 2] = f60;
    HEAPF32[i6 + 52 >> 2] = f61;
    HEAPF32[i6 + 56 >> 2] = f62;
    HEAPF32[i6 + 60 >> 2] = f63;
    HEAPF32[i6 + 64 >> 2] = f64;
    HEAPF32[i6 + 68 >> 2] = f65;
    HEAPF32[i6 + 72 >> 2] = f66;
    HEAPF32[i6 + 76 >> 2] = f67;
    HEAPF32[i6 + 80 >> 2] = f68;
    HEAPF32[i6 + 84 >> 2] = f69;
    HEAPF32[i6 + 88 >> 2] = f70;
    HEAPF32[i6 + 92 >> 2] = f71;
    f42 = Math_fround(HEAPF32[i12 >> 2]);
    f41 = Math_fround(HEAPF32[i19 >> 2]);
    f40 = Math_fround(HEAPF32[i20 >> 2]);
    f39 = Math_fround(HEAPF32[i25 >> 2]);
    f38 = Math_fround(HEAPF32[i27 >> 2]);
    f37 = Math_fround(HEAPF32[i28 >> 2]);
    f36 = Math_fround(HEAPF32[i30 >> 2]);
    f35 = Math_fround(HEAPF32[i33 >> 2]);
    f34 = Math_fround(HEAPF32[i43 >> 2]);
    f32 = Math_fround(HEAPF32[i72 >> 2]);
    f31 = Math_fround(HEAPF32[i73 >> 2]);
    f29 = Math_fround(HEAPF32[i74 >> 2]);
    if (!i169) {
     if (i354) {
      i12 = 0;
      i6 = i7;
      while (1) {
       f379 = Math_fround(HEAPF32[i358 + (i5 << 4) >> 2]);
       f380 = Math_fround(HEAPF32[i358 + (i5 << 4) + 4 >> 2]);
       f381 = Math_fround(HEAPF32[i358 + (i5 << 4) + 8 >> 2]);
       f382 = Math_fround(HEAPF32[i358 + (i5 << 4) + 12 >> 2]);
       f383 = Math_fround(HEAPF32[i359 + (i5 << 4) >> 2]);
       f384 = Math_fround(HEAPF32[i359 + (i5 << 4) + 4 >> 2]);
       f385 = Math_fround(HEAPF32[i359 + (i5 << 4) + 8 >> 2]);
       f386 = Math_fround(HEAPF32[i359 + (i5 << 4) + 12 >> 2]);
       f387 = Math_fround(HEAPF32[i360 + (i5 << 4) >> 2]);
       f388 = Math_fround(HEAPF32[i360 + (i5 << 4) + 4 >> 2]);
       f389 = Math_fround(HEAPF32[i360 + (i5 << 4) + 8 >> 2]);
       f390 = Math_fround(HEAPF32[i360 + (i5 << 4) + 12 >> 2]);
       i5 = 1 - i5 | 0;
       f68 = Math_fround(Math_fround(f91 * f387) - Math_fround(f95 * f383));
       f69 = Math_fround(Math_fround(f92 * f388) - Math_fround(f96 * f384));
       f70 = Math_fround(Math_fround(f93 * f389) - Math_fround(f97 * f385));
       f71 = Math_fround(Math_fround(f94 * f390) - Math_fround(f98 * f386));
       f367 = Math_fround(Math_fround(f95 * f379) - Math_fround(f87 * f387));
       f368 = Math_fround(Math_fround(f96 * f380) - Math_fround(f88 * f388));
       f369 = Math_fround(Math_fround(f97 * f381) - Math_fround(f89 * f389));
       f370 = Math_fround(Math_fround(f98 * f382) - Math_fround(f90 * f390));
       f371 = Math_fround(Math_fround(f87 * f383) - Math_fround(f91 * f379));
       f372 = Math_fround(Math_fround(f88 * f384) - Math_fround(f92 * f380));
       f373 = Math_fround(Math_fround(f89 * f385) - Math_fround(f93 * f381));
       f374 = Math_fround(Math_fround(f90 * f386) - Math_fround(f94 * f382));
       f56 = Math_fround(Math_fround(f257 * f371) + Math_fround(Math_fround(f253 * f367) + Math_fround(f249 * f68)));
       f57 = Math_fround(Math_fround(f258 * f372) + Math_fround(Math_fround(f254 * f368) + Math_fround(f250 * f69)));
       f58 = Math_fround(Math_fround(f259 * f373) + Math_fround(Math_fround(f255 * f369) + Math_fround(f251 * f70)));
       f59 = Math_fround(Math_fround(f260 * f374) + Math_fround(Math_fround(f256 * f370) + Math_fround(f252 * f71)));
       f60 = Math_fround(Math_fround(f269 * f371) + Math_fround(Math_fround(f265 * f367) + Math_fround(f261 * f68)));
       f61 = Math_fround(Math_fround(f270 * f372) + Math_fround(Math_fround(f266 * f368) + Math_fround(f262 * f69)));
       f62 = Math_fround(Math_fround(f271 * f373) + Math_fround(Math_fround(f267 * f369) + Math_fround(f263 * f70)));
       f63 = Math_fround(Math_fround(f272 * f374) + Math_fround(Math_fround(f268 * f370) + Math_fround(f264 * f71)));
       f64 = Math_fround(Math_fround(f281 * f371) + Math_fround(Math_fround(f277 * f367) + Math_fround(f273 * f68)));
       f65 = Math_fround(Math_fround(f282 * f372) + Math_fround(Math_fround(f278 * f368) + Math_fround(f274 * f69)));
       f66 = Math_fround(Math_fround(f283 * f373) + Math_fround(Math_fround(f279 * f369) + Math_fround(f275 * f70)));
       f67 = Math_fround(Math_fround(f284 * f374) + Math_fround(Math_fround(f280 * f370) + Math_fround(f276 * f71)));
       f406 = Math_fround(Math_fround(f79 * f387) - Math_fround(f83 * f383));
       f405 = Math_fround(Math_fround(f80 * f388) - Math_fround(f84 * f384));
       f404 = Math_fround(Math_fround(f81 * f389) - Math_fround(f85 * f385));
       f403 = Math_fround(Math_fround(f82 * f390) - Math_fround(f86 * f386));
       f402 = Math_fround(Math_fround(f83 * f379) - Math_fround(f75 * f387));
       f401 = Math_fround(Math_fround(f84 * f380) - Math_fround(f76 * f388));
       f400 = Math_fround(Math_fround(f85 * f381) - Math_fround(f77 * f389));
       f399 = Math_fround(Math_fround(f86 * f382) - Math_fround(f78 * f390));
       f398 = Math_fround(Math_fround(f75 * f383) - Math_fround(f79 * f379));
       f397 = Math_fround(Math_fround(f76 * f384) - Math_fround(f80 * f380));
       f396 = Math_fround(Math_fround(f77 * f385) - Math_fround(f81 * f381));
       f395 = Math_fround(Math_fround(f78 * f386) - Math_fround(f82 * f382));
       f44 = Math_fround(Math_fround(f293 * f398) + Math_fround(Math_fround(f289 * f402) + Math_fround(f285 * f406)));
       f45 = Math_fround(Math_fround(f294 * f397) + Math_fround(Math_fround(f290 * f401) + Math_fround(f286 * f405)));
       f46 = Math_fround(Math_fround(f295 * f396) + Math_fround(Math_fround(f291 * f400) + Math_fround(f287 * f404)));
       f47 = Math_fround(Math_fround(f296 * f395) + Math_fround(Math_fround(f292 * f399) + Math_fround(f288 * f403)));
       f48 = Math_fround(Math_fround(f305 * f398) + Math_fround(Math_fround(f301 * f402) + Math_fround(f297 * f406)));
       f49 = Math_fround(Math_fround(f306 * f397) + Math_fround(Math_fround(f302 * f401) + Math_fround(f298 * f405)));
       f50 = Math_fround(Math_fround(f307 * f396) + Math_fround(Math_fround(f303 * f400) + Math_fround(f299 * f404)));
       f51 = Math_fround(Math_fround(f308 * f395) + Math_fround(Math_fround(f304 * f399) + Math_fround(f300 * f403)));
       f52 = Math_fround(Math_fround(f317 * f398) + Math_fround(Math_fround(f313 * f402) + Math_fround(f309 * f406)));
       f53 = Math_fround(Math_fround(f318 * f397) + Math_fround(Math_fround(f314 * f401) + Math_fround(f310 * f405)));
       f54 = Math_fround(Math_fround(f319 * f396) + Math_fround(Math_fround(f315 * f400) + Math_fround(f311 * f404)));
       f55 = Math_fround(Math_fround(f320 * f395) + Math_fround(Math_fround(f316 * f399) + Math_fround(f312 * f403)));
       f375 = Math_fround(Math_fround(f241 + Math_fround(Math_fround(f371 * f64) + Math_fround(Math_fround(f367 * f60) + Math_fround(f68 * f56)))) + Math_fround(Math_fround(Math_fround(f398 * f52) + Math_fround(Math_fround(f402 * f48) + Math_fround(f406 * f44))) - f139));
       f378 = Math_fround(Math_fround(f242 + Math_fround(Math_fround(f372 * f65) + Math_fround(Math_fround(f368 * f61) + Math_fround(f69 * f57)))) + Math_fround(Math_fround(Math_fround(f397 * f53) + Math_fround(Math_fround(f401 * f49) + Math_fround(f405 * f45))) - f140));
       f377 = Math_fround(Math_fround(f243 + Math_fround(Math_fround(f373 * f66) + Math_fround(Math_fround(f369 * f62) + Math_fround(f70 * f58)))) + Math_fround(Math_fround(Math_fround(f396 * f54) + Math_fround(Math_fround(f400 * f50) + Math_fround(f404 * f46))) - f141));
       f376 = Math_fround(Math_fround(f244 + Math_fround(Math_fround(f374 * f67) + Math_fround(Math_fround(f370 * f63) + Math_fround(f71 * f59)))) + Math_fround(Math_fround(Math_fround(f395 * f55) + Math_fround(Math_fround(f399 * f51) + Math_fround(f403 * f47))) - f142));
       HEAPF32[i6 + 192 >> 2] = f406;
       HEAPF32[i6 + 196 >> 2] = f405;
       HEAPF32[i6 + 200 >> 2] = f404;
       HEAPF32[i6 + 204 >> 2] = f403;
       HEAPF32[i6 + 208 >> 2] = f402;
       HEAPF32[i6 + 212 >> 2] = f401;
       HEAPF32[i6 + 216 >> 2] = f400;
       HEAPF32[i6 + 220 >> 2] = f399;
       HEAPF32[i6 + 224 >> 2] = f398;
       HEAPF32[i6 + 228 >> 2] = f397;
       HEAPF32[i6 + 232 >> 2] = f396;
       HEAPF32[i6 + 236 >> 2] = f395;
       f45 = Math_fround(-f45);
       f46 = Math_fround(-f46);
       f47 = Math_fround(-f47);
       HEAPF32[i6 + 240 >> 2] = Math_fround(-f44);
       HEAPF32[i6 + 244 >> 2] = f45;
       HEAPF32[i6 + 248 >> 2] = f46;
       HEAPF32[i6 + 252 >> 2] = f47;
       f49 = Math_fround(-f49);
       f50 = Math_fround(-f50);
       f51 = Math_fround(-f51);
       HEAPF32[i6 + 256 >> 2] = Math_fround(-f48);
       HEAPF32[i6 + 260 >> 2] = f49;
       HEAPF32[i6 + 264 >> 2] = f50;
       HEAPF32[i6 + 268 >> 2] = f51;
       f53 = Math_fround(-f53);
       f54 = Math_fround(-f54);
       f55 = Math_fround(-f55);
       HEAPF32[i6 + 272 >> 2] = Math_fround(-f52);
       HEAPF32[i6 + 276 >> 2] = f53;
       HEAPF32[i6 + 280 >> 2] = f54;
       HEAPF32[i6 + 284 >> 2] = f55;
       i391 = f375 > Math_fround(0.0);
       i392 = f378 > Math_fround(0.0);
       i393 = f377 > Math_fround(0.0);
       i394 = f376 > Math_fround(0.0);
       f378 = Math_fround(Math_fround(1.0) / f378);
       f377 = Math_fround(Math_fround(1.0) / f377);
       f376 = Math_fround(Math_fround(1.0) / f376);
       f375 = Math_fround(-Math_fround(Math_fround(1.0) / f375));
       f375 = i391 ? f375 : Math_fround(-0.0);
       f378 = Math_fround(-f378);
       f378 = i392 ? f378 : Math_fround(-0.0);
       f377 = Math_fround(-f377);
       f377 = i393 ? f377 : Math_fround(-0.0);
       f376 = Math_fround(-f376);
       f376 = i394 ? f376 : Math_fround(-0.0);
       i394 = i6 + 144 | 0;
       HEAP32[i394 >> 2] = 0;
       HEAP32[i394 + 4 >> 2] = 0;
       HEAP32[i394 + 8 >> 2] = 0;
       HEAP32[i394 + 12 >> 2] = 0;
       HEAPF32[i6 + 96 >> 2] = f56;
       HEAPF32[i6 + 100 >> 2] = f57;
       HEAPF32[i6 + 104 >> 2] = f58;
       HEAPF32[i6 + 108 >> 2] = f59;
       HEAPF32[i6 + 112 >> 2] = f60;
       HEAPF32[i6 + 116 >> 2] = f61;
       HEAPF32[i6 + 120 >> 2] = f62;
       HEAPF32[i6 + 124 >> 2] = f63;
       HEAPF32[i6 + 128 >> 2] = f64;
       HEAPF32[i6 + 132 >> 2] = f65;
       HEAPF32[i6 + 136 >> 2] = f66;
       HEAPF32[i6 + 140 >> 2] = f67;
       HEAPF32[i6 + 48 >> 2] = f68;
       HEAPF32[i6 + 52 >> 2] = f69;
       HEAPF32[i6 + 56 >> 2] = f70;
       HEAPF32[i6 + 60 >> 2] = f71;
       HEAPF32[i6 + 64 >> 2] = f367;
       HEAPF32[i6 + 68 >> 2] = f368;
       HEAPF32[i6 + 72 >> 2] = f369;
       HEAPF32[i6 + 76 >> 2] = f370;
       HEAPF32[i6 + 80 >> 2] = f371;
       HEAPF32[i6 + 84 >> 2] = f372;
       HEAPF32[i6 + 88 >> 2] = f373;
       HEAPF32[i6 + 92 >> 2] = f374;
       HEAPF32[i6 + 160 >> 2] = f375;
       HEAPF32[i6 + 164 >> 2] = f378;
       HEAPF32[i6 + 168 >> 2] = f377;
       HEAPF32[i6 + 172 >> 2] = f376;
       f376 = Math_fround(Math_fround(Math_fround(f39 * f380) + Math_fround(f38 * f384)) + Math_fround(f37 * f388));
       f377 = Math_fround(Math_fround(Math_fround(f36 * f381) + Math_fround(f35 * f385)) + Math_fround(f34 * f389));
       f378 = Math_fround(Math_fround(Math_fround(f32 * f382) + Math_fround(f31 * f386)) + Math_fround(f29 * f390));
       HEAPF32[i6 + 176 >> 2] = Math_fround(Math_fround(Math_fround(f42 * f379) + Math_fround(f41 * f383)) + Math_fround(f40 * f387));
       HEAPF32[i6 + 180 >> 2] = f376;
       HEAPF32[i6 + 184 >> 2] = f377;
       HEAPF32[i6 + 188 >> 2] = f378;
       HEAPF32[i6 >> 2] = f379;
       HEAPF32[i6 + 4 >> 2] = f380;
       HEAPF32[i6 + 8 >> 2] = f381;
       HEAPF32[i6 + 12 >> 2] = f382;
       HEAPF32[i6 + 16 >> 2] = f383;
       HEAPF32[i6 + 20 >> 2] = f384;
       HEAPF32[i6 + 24 >> 2] = f385;
       HEAPF32[i6 + 28 >> 2] = f386;
       HEAPF32[i6 + 32 >> 2] = f387;
       HEAPF32[i6 + 36 >> 2] = f388;
       HEAPF32[i6 + 40 >> 2] = f389;
       HEAPF32[i6 + 44 >> 2] = f390;
       i12 = i12 + 1 | 0;
       if ((i12 | 0) == (i365 | 0)) break; else i6 = i6 + i356 | 0;
      }
     } else {
      i12 = 0;
      i6 = i7;
      while (1) {
       f395 = Math_fround(HEAPF32[i358 + (i5 << 4) >> 2]);
       f396 = Math_fround(HEAPF32[i358 + (i5 << 4) + 4 >> 2]);
       f397 = Math_fround(HEAPF32[i358 + (i5 << 4) + 8 >> 2]);
       f398 = Math_fround(HEAPF32[i358 + (i5 << 4) + 12 >> 2]);
       f399 = Math_fround(HEAPF32[i359 + (i5 << 4) >> 2]);
       f400 = Math_fround(HEAPF32[i359 + (i5 << 4) + 4 >> 2]);
       f401 = Math_fround(HEAPF32[i359 + (i5 << 4) + 8 >> 2]);
       f402 = Math_fround(HEAPF32[i359 + (i5 << 4) + 12 >> 2]);
       f403 = Math_fround(HEAPF32[i360 + (i5 << 4) >> 2]);
       f404 = Math_fround(HEAPF32[i360 + (i5 << 4) + 4 >> 2]);
       f405 = Math_fround(HEAPF32[i360 + (i5 << 4) + 8 >> 2]);
       f406 = Math_fround(HEAPF32[i360 + (i5 << 4) + 12 >> 2]);
       i5 = 1 - i5 | 0;
       f375 = Math_fround(Math_fround(f91 * f403) - Math_fround(f95 * f399));
       f376 = Math_fround(Math_fround(f92 * f404) - Math_fround(f96 * f400));
       f377 = Math_fround(Math_fround(f93 * f405) - Math_fround(f97 * f401));
       f378 = Math_fround(Math_fround(f94 * f406) - Math_fround(f98 * f402));
       f379 = Math_fround(Math_fround(f95 * f395) - Math_fround(f87 * f403));
       f380 = Math_fround(Math_fround(f96 * f396) - Math_fround(f88 * f404));
       f381 = Math_fround(Math_fround(f97 * f397) - Math_fround(f89 * f405));
       f382 = Math_fround(Math_fround(f98 * f398) - Math_fround(f90 * f406));
       f383 = Math_fround(Math_fround(f87 * f399) - Math_fround(f91 * f395));
       f384 = Math_fround(Math_fround(f88 * f400) - Math_fround(f92 * f396));
       f385 = Math_fround(Math_fround(f89 * f401) - Math_fround(f93 * f397));
       f386 = Math_fround(Math_fround(f90 * f402) - Math_fround(f94 * f398));
       f83 = Math_fround(Math_fround(f257 * f383) + Math_fround(Math_fround(f253 * f379) + Math_fround(f249 * f375)));
       f84 = Math_fround(Math_fround(f258 * f384) + Math_fround(Math_fround(f254 * f380) + Math_fround(f250 * f376)));
       f85 = Math_fround(Math_fround(f259 * f385) + Math_fround(Math_fround(f255 * f381) + Math_fround(f251 * f377)));
       f86 = Math_fround(Math_fround(f260 * f386) + Math_fround(Math_fround(f256 * f382) + Math_fround(f252 * f378)));
       f367 = Math_fround(Math_fround(f269 * f383) + Math_fround(Math_fround(f265 * f379) + Math_fround(f261 * f375)));
       f368 = Math_fround(Math_fround(f270 * f384) + Math_fround(Math_fround(f266 * f380) + Math_fround(f262 * f376)));
       f369 = Math_fround(Math_fround(f271 * f385) + Math_fround(Math_fround(f267 * f381) + Math_fround(f263 * f377)));
       f370 = Math_fround(Math_fround(f272 * f386) + Math_fround(Math_fround(f268 * f382) + Math_fround(f264 * f378)));
       f371 = Math_fround(Math_fround(f281 * f383) + Math_fround(Math_fround(f277 * f379) + Math_fround(f273 * f375)));
       f372 = Math_fround(Math_fround(f282 * f384) + Math_fround(Math_fround(f278 * f380) + Math_fround(f274 * f376)));
       f373 = Math_fround(Math_fround(f283 * f385) + Math_fround(Math_fround(f279 * f381) + Math_fround(f275 * f377)));
       f374 = Math_fround(Math_fround(f284 * f386) + Math_fround(Math_fround(f280 * f382) + Math_fround(f276 * f378)));
       f387 = Math_fround(f241 + Math_fround(Math_fround(f383 * f371) + Math_fround(Math_fround(f379 * f367) + Math_fround(f375 * f83))));
       f390 = Math_fround(f242 + Math_fround(Math_fround(f384 * f372) + Math_fround(Math_fround(f380 * f368) + Math_fround(f376 * f84))));
       f389 = Math_fround(f243 + Math_fround(Math_fround(f385 * f373) + Math_fround(Math_fround(f381 * f369) + Math_fround(f377 * f85))));
       f388 = Math_fround(f244 + Math_fround(Math_fround(f386 * f374) + Math_fround(Math_fround(f382 * f370) + Math_fround(f378 * f86))));
       i391 = f387 > Math_fround(0.0);
       i392 = f390 > Math_fround(0.0);
       i393 = f389 > Math_fround(0.0);
       i394 = f388 > Math_fround(0.0);
       f390 = Math_fround(Math_fround(1.0) / f390);
       f389 = Math_fround(Math_fround(1.0) / f389);
       f388 = Math_fround(Math_fround(1.0) / f388);
       f387 = Math_fround(-Math_fround(Math_fround(1.0) / f387));
       f387 = i391 ? f387 : Math_fround(-0.0);
       f390 = Math_fround(-f390);
       f390 = i392 ? f390 : Math_fround(-0.0);
       f389 = Math_fround(-f389);
       f389 = i393 ? f389 : Math_fround(-0.0);
       f388 = Math_fround(-f388);
       f388 = i394 ? f388 : Math_fround(-0.0);
       i394 = i6 + 144 | 0;
       HEAP32[i394 >> 2] = 0;
       HEAP32[i394 + 4 >> 2] = 0;
       HEAP32[i394 + 8 >> 2] = 0;
       HEAP32[i394 + 12 >> 2] = 0;
       HEAPF32[i6 + 96 >> 2] = f83;
       HEAPF32[i6 + 100 >> 2] = f84;
       HEAPF32[i6 + 104 >> 2] = f85;
       HEAPF32[i6 + 108 >> 2] = f86;
       HEAPF32[i6 + 112 >> 2] = f367;
       HEAPF32[i6 + 116 >> 2] = f368;
       HEAPF32[i6 + 120 >> 2] = f369;
       HEAPF32[i6 + 124 >> 2] = f370;
       HEAPF32[i6 + 128 >> 2] = f371;
       HEAPF32[i6 + 132 >> 2] = f372;
       HEAPF32[i6 + 136 >> 2] = f373;
       HEAPF32[i6 + 140 >> 2] = f374;
       HEAPF32[i6 + 48 >> 2] = f375;
       HEAPF32[i6 + 52 >> 2] = f376;
       HEAPF32[i6 + 56 >> 2] = f377;
       HEAPF32[i6 + 60 >> 2] = f378;
       HEAPF32[i6 + 64 >> 2] = f379;
       HEAPF32[i6 + 68 >> 2] = f380;
       HEAPF32[i6 + 72 >> 2] = f381;
       HEAPF32[i6 + 76 >> 2] = f382;
       HEAPF32[i6 + 80 >> 2] = f383;
       HEAPF32[i6 + 84 >> 2] = f384;
       HEAPF32[i6 + 88 >> 2] = f385;
       HEAPF32[i6 + 92 >> 2] = f386;
       HEAPF32[i6 + 160 >> 2] = f387;
       HEAPF32[i6 + 164 >> 2] = f390;
       HEAPF32[i6 + 168 >> 2] = f389;
       HEAPF32[i6 + 172 >> 2] = f388;
       f388 = Math_fround(Math_fround(Math_fround(f39 * f396) + Math_fround(f38 * f400)) + Math_fround(f37 * f404));
       f389 = Math_fround(Math_fround(Math_fround(f36 * f397) + Math_fround(f35 * f401)) + Math_fround(f34 * f405));
       f390 = Math_fround(Math_fround(Math_fround(f32 * f398) + Math_fround(f31 * f402)) + Math_fround(f29 * f406));
       HEAPF32[i6 + 176 >> 2] = Math_fround(Math_fround(Math_fround(f42 * f395) + Math_fround(f41 * f399)) + Math_fround(f40 * f403));
       HEAPF32[i6 + 180 >> 2] = f388;
       HEAPF32[i6 + 184 >> 2] = f389;
       HEAPF32[i6 + 188 >> 2] = f390;
       HEAPF32[i6 >> 2] = f395;
       HEAPF32[i6 + 4 >> 2] = f396;
       HEAPF32[i6 + 8 >> 2] = f397;
       HEAPF32[i6 + 12 >> 2] = f398;
       HEAPF32[i6 + 16 >> 2] = f399;
       HEAPF32[i6 + 20 >> 2] = f400;
       HEAPF32[i6 + 24 >> 2] = f401;
       HEAPF32[i6 + 28 >> 2] = f402;
       HEAPF32[i6 + 32 >> 2] = f403;
       HEAPF32[i6 + 36 >> 2] = f404;
       HEAPF32[i6 + 40 >> 2] = f405;
       HEAPF32[i6 + 44 >> 2] = f406;
       i12 = i12 + 1 | 0;
       if ((i12 | 0) == (i365 | 0)) break; else i6 = i6 + i356 | 0;
      }
     }
     i7 = i7 + i144 | 0;
    }
    if (!(i22 & 1)) {
     i12 = i99 + 1 | 0;
     do if ((i23 | 0) == 65535) {
      i6 = 0;
      i2 = 65535;
     } else {
      i2 = i23;
      while (1) {
       if ((i12 | 0) != (HEAPU16[i363 + (i2 * 12 | 0) + 2 >> 1] | 0)) break;
       i394 = HEAP16[i363 + (i2 * 12 | 0) + 4 >> 1] | 0;
       i2 = i394 & 65535;
       if (i394 << 16 >> 16 == -1) {
        i12 = 0;
        break;
       } else i12 = 0;
      }
      if ((i2 | 0) == 65535) {
       i6 = 0;
       i2 = 65535;
       break;
      }
      i6 = i12 >>> 0 < (HEAPU16[i363 + (i2 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i20 = i2;
     i24 = i99;
     i2 = i23;
     i15 = i6 & 1 ^ 1 | i22;
    } else {
     i12 = i99;
     i20 = i23;
     i15 = i22;
    }
    if (!(i22 & 2)) {
     i14 = i100 + 1 | 0;
     do if ((i101 | 0) == 65535) {
      i6 = 0;
      i13 = 65535;
     } else {
      i13 = i101;
      while (1) {
       if ((i14 | 0) != (HEAPU16[i363 + (i13 * 12 | 0) + 2 >> 1] | 0)) break;
       i394 = HEAP16[i363 + (i13 * 12 | 0) + 4 >> 1] | 0;
       i13 = i394 & 65535;
       if (i394 << 16 >> 16 == -1) {
        i14 = 0;
        break;
       } else i14 = 0;
      }
      if ((i13 | 0) == 65535) {
       i6 = 0;
       i13 = 65535;
       break;
      }
      i6 = i14 >>> 0 < (HEAPU16[i363 + (i13 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i26 = i100;
     i3 = i101;
     i15 = (i6 & 1) << 1 ^ 2 | i15;
    } else {
     i14 = i100;
     i13 = i101;
    }
    if (!(i22 & 4)) {
     i16 = i103 + 1 | 0;
     do if ((i18 | 0) == 65535) {
      i6 = 0;
      i4 = 65535;
     } else {
      i4 = i18;
      while (1) {
       if ((i16 | 0) != (HEAPU16[i363 + (i4 * 12 | 0) + 2 >> 1] | 0)) break;
       i394 = HEAP16[i363 + (i4 * 12 | 0) + 4 >> 1] | 0;
       i4 = i394 & 65535;
       if (i394 << 16 >> 16 == -1) {
        i16 = 0;
        break;
       } else i16 = 0;
      }
      if ((i4 | 0) == 65535) {
       i6 = 0;
       i4 = 65535;
       break;
      }
      i6 = i16 >>> 0 < (HEAPU16[i363 + (i4 * 12 | 0) + 2 >> 1] | 0) >>> 0;
     } while (0);
     i19 = i4;
     i17 = i103;
     i4 = i18;
     i15 = (i6 & 1) << 2 ^ 4 | i15;
    } else {
     i16 = i103;
     i19 = i18;
    }
    if (!(i22 & 8)) {
     i6 = i102;
     i23 = i20;
     i18 = i19;
     i20 = i17;
     i25 = i15;
     break;
    } else {
     i394 = i22;
     i99 = i12;
     i23 = i20;
     i100 = i14;
     i101 = i13;
     i103 = i16;
     i18 = i19;
     i22 = i15;
     i6 = i102;
     i12 = i394;
    }
   }
   i15 = i21 + 1 | 0;
   do if ((i106 | 0) == 65535) {
    i19 = 0;
    i17 = 65535;
   } else {
    i17 = i106;
    while (1) {
     if ((i15 | 0) != (HEAPU16[i363 + (i17 * 12 | 0) + 2 >> 1] | 0)) break;
     i394 = HEAP16[i363 + (i17 * 12 | 0) + 4 >> 1] | 0;
     i17 = i394 & 65535;
     if (i394 << 16 >> 16 == -1) {
      i15 = 0;
      break;
     } else i15 = 0;
    }
    if ((i17 | 0) == 65535) {
     i19 = 0;
     i17 = 65535;
     break;
    }
    i19 = i15 >>> 0 < (HEAPU16[i363 + (i17 * 12 | 0) + 2 >> 1] | 0) >>> 0;
   } while (0);
   i394 = i106;
   i105 = i21;
   i21 = i15;
   i106 = i17;
   i17 = i20;
   i20 = i5;
   i15 = (i19 & 1) << 3 ^ 8 | i25;
   i5 = i394;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i350 >>> 0) break;
  i2 = HEAP32[i346 >> 2] | 0;
  i3 = HEAP32[i347 >> 2] | 0;
  i4 = HEAP32[i348 >> 2] | 0;
  i5 = HEAP32[i349 >> 2] | 0;
  i16 = i6;
 }
 STACKTOP = i361;
 return 1;
}

function __ZN5Umbra9RasterOps15rasterizePortalERNS_17BlockRasterBufferERKNS_8Vector4iERKNS_5VQuadERKNS_11AxisNormalsERKS1_(i119, i3, i1, i2, i122) {
 i119 = i119 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i122 = i122 | 0;
 var i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i120 = 0, i121 = 0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, f194 = f0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 f104 = Math_fround(HEAPF32[i1 >> 2]);
 f113 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f105 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f127 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f100 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f128 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f99 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f123 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f126 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f125 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f124 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f107 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f130 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f129 = Math_fround(HEAPF32[i2 >> 2]);
 f109 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f108 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f129 = Math_fround(f104 * f129);
 f109 = Math_fround(f113 * f109);
 f108 = Math_fround(f10 * f108);
 f103 = Math_fround(f105 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f111 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f110 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f106 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f111 = Math_fround(f127 * f111);
 f110 = Math_fround(f100 * f110);
 f106 = Math_fround(f128 * f106);
 f8 = Math_fround(f99 * Math_fround(HEAPF32[i2 + 28 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f112 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f114 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 i116 = Math_fround(f129 + Math_fround(f111 + Math_fround(f123 * f9))) > Math_fround(0.0);
 i117 = Math_fround(f109 + Math_fround(f110 + Math_fround(f126 * f112))) > Math_fround(0.0);
 i121 = Math_fround(f108 + Math_fround(f106 + Math_fround(f125 * f114))) > Math_fround(0.0);
 i120 = Math_fround(f103 + Math_fround(f8 + Math_fround(f124 * Math_fround(HEAPF32[i2 + 44 >> 2])))) > Math_fround(0.0);
 f8 = i116 ? f107 : Math_fround(0.0);
 f103 = Math_fround(f104 + f8);
 f114 = i117 ? f107 : Math_fround(0.0);
 f106 = Math_fround(f113 + f114);
 f108 = i121 ? f107 : Math_fround(0.0);
 f112 = Math_fround(f10 + f108);
 f107 = i120 ? f107 : Math_fround(0.0);
 f110 = Math_fround(f105 + f107);
 f8 = Math_fround(f113 + f8);
 f114 = Math_fround(f10 + f114);
 f108 = Math_fround(f105 + f108);
 f107 = Math_fround(f104 + f107);
 f104 = i116 ? f6 : Math_fround(0.0);
 f105 = Math_fround(f127 + f104);
 f10 = i117 ? f6 : Math_fround(0.0);
 f113 = Math_fround(f100 + f10);
 f109 = i121 ? f6 : Math_fround(0.0);
 f9 = Math_fround(f128 + f109);
 f6 = i120 ? f6 : Math_fround(0.0);
 f111 = Math_fround(f99 + f6);
 f104 = Math_fround(f100 + f104);
 f10 = Math_fround(f128 + f10);
 f109 = Math_fround(f99 + f109);
 f6 = Math_fround(f127 + f6);
 f127 = i116 ? f130 : Math_fround(0.0);
 f99 = Math_fround(f123 + f127);
 f128 = i117 ? f130 : Math_fround(0.0);
 f100 = Math_fround(f126 + f128);
 f129 = i121 ? f130 : Math_fround(0.0);
 f101 = Math_fround(f125 + f129);
 f130 = i120 ? f130 : Math_fround(0.0);
 f102 = Math_fround(f124 + f130);
 f127 = Math_fround(f126 + f127);
 f128 = Math_fround(f125 + f128);
 f129 = Math_fround(f124 + f129);
 f130 = Math_fround(f123 + f130);
 f123 = Math_fround(Math_fround(f105 * f127) - Math_fround(f99 * f104));
 f124 = Math_fround(Math_fround(f113 * f128) - Math_fround(f100 * f10));
 f125 = Math_fround(Math_fround(f9 * f129) - Math_fround(f101 * f109));
 f126 = Math_fround(Math_fround(f111 * f130) - Math_fround(f102 * f6));
 f127 = Math_fround(Math_fround(f99 * f8) - Math_fround(f103 * f127));
 f128 = Math_fround(Math_fround(f100 * f114) - Math_fround(f106 * f128));
 f129 = Math_fround(Math_fround(f101 * f108) - Math_fround(f112 * f129));
 f130 = Math_fround(Math_fround(f102 * f107) - Math_fround(f110 * f130));
 f8 = Math_fround(Math_fround(f103 * f104) - Math_fround(f105 * f8));
 f114 = Math_fround(Math_fround(f106 * f10) - Math_fround(f113 * f114));
 f108 = Math_fround(Math_fround(f112 * f109) - Math_fround(f9 * f108));
 f107 = Math_fround(Math_fround(f110 * f6) - Math_fround(f111 * f107));
 f111 = Math_fround(HEAPF32[gb + 1451464 >> 2]);
 f123 = Math_fround(f111 * f123);
 f6 = Math_fround(HEAPF32[gb + 1451464 + 4 >> 2]);
 f124 = Math_fround(f6 * f124);
 f110 = Math_fround(HEAPF32[gb + 1451464 + 8 >> 2]);
 f125 = Math_fround(f110 * f125);
 f9 = Math_fround(HEAPF32[gb + 1451464 + 12 >> 2]);
 f126 = Math_fround(f9 * f126);
 f127 = Math_fround(f111 * f127);
 f128 = Math_fround(f6 * f128);
 f129 = Math_fround(f110 * f129);
 f130 = Math_fround(f9 * f130);
 f9 = Math_fround(HEAPF32[gb + 1451480 >> 2]);
 f110 = Math_fround(f9 * f123);
 f6 = Math_fround(HEAPF32[gb + 1451480 + 4 >> 2]);
 f111 = Math_fround(f6 * f124);
 f109 = Math_fround(HEAPF32[gb + 1451480 + 8 >> 2]);
 f112 = Math_fround(f109 * f125);
 f113 = Math_fround(HEAPF32[gb + 1451480 + 12 >> 2]);
 f110 = Math_fround(Math_fround(f9 * f127) + Math_fround(f8 + f110));
 f111 = Math_fround(Math_fround(f6 * f128) + Math_fround(f114 + f111));
 f112 = Math_fround(Math_fround(f109 * f129) + Math_fround(f108 + f112));
 f113 = Math_fround(Math_fround(f113 * f130) + Math_fround(f107 + Math_fround(f113 * f126)));
 f107 = Math_fround(Math_fround(Math_abs(Math_fround(f123))) + Math_fround(Math_abs(Math_fround(f127))));
 f108 = Math_fround(Math_fround(Math_abs(Math_fround(f124))) + Math_fround(Math_abs(Math_fround(f128))));
 f109 = Math_fround(Math_fround(Math_abs(Math_fround(f125))) + Math_fround(Math_abs(Math_fround(f129))));
 f114 = Math_fround(Math_fround(Math_abs(Math_fround(f126))) + Math_fround(Math_abs(Math_fround(f130))));
 f6 = Math_fround(HEAPF32[gb + 1451528 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 1451528 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 1451528 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[gb + 1451528 + 12 >> 2]);
 f6 = Math_fround((f107 >= f6 ? f107 : f6) * Math_fround(HEAPF32[gb + 1451512 >> 2]));
 f8 = Math_fround((f108 >= f8 ? f108 : f8) * Math_fround(HEAPF32[gb + 1451512 + 4 >> 2]));
 f9 = Math_fround((f109 >= f9 ? f109 : f9) * Math_fround(HEAPF32[gb + 1451512 + 8 >> 2]));
 f6 = Math_fround(f110 + f6);
 f8 = Math_fround(f111 + f8);
 f9 = Math_fround(f112 + f9);
 f10 = Math_fround(f113 + Math_fround((f114 >= f10 ? f114 : f10) * Math_fround(HEAPF32[gb + 1451512 + 12 >> 2])));
 i120 = i4 >> 2;
 i121 = i5 >> 2;
 i117 = (HEAP32[i3 + 8 >> 2] | 0) + 3 >> 2;
 i116 = (HEAP32[i3 + 12 >> 2] | 0) + 3 >> 2;
 i7 = i117 - i120 | 0;
 i115 = i116 - i121 | 0;
 i16 = Math_imul(i115, i7) | 0;
 if ((i115 | 0) == 1 | ((i7 | 0) == 1 | (i16 | 0) < 11)) {
  f21 = Math_fround(i120 | 0);
  f33 = Math_fround(i121 | 0);
  f44 = Math_fround(HEAPF32[gb + 1451448 >> 2]);
  f40 = Math_fround(f123 * f44);
  f45 = Math_fround(HEAPF32[gb + 1451448 + 4 >> 2]);
  f41 = Math_fround(f124 * f45);
  f46 = Math_fround(HEAPF32[gb + 1451448 + 8 >> 2]);
  f42 = Math_fround(f125 * f46);
  f47 = Math_fround(HEAPF32[gb + 1451448 + 12 >> 2]);
  f43 = Math_fround(f126 * f47);
  f44 = Math_fround(f127 * f44);
  f45 = Math_fround(f128 * f45);
  f46 = Math_fround(f129 * f46);
  f47 = Math_fround(f130 * f47);
  f12 = Math_fround(Math_fround(f33 * f44) + Math_fround(f6 + Math_fround(f21 * f40)));
  f14 = Math_fround(Math_fround(f33 * f45) + Math_fround(f8 + Math_fround(f21 * f41)));
  f15 = Math_fround(Math_fround(f33 * f46) + Math_fround(f9 + Math_fround(f21 * f42)));
  f6 = Math_fround(Math_fround(f33 * f47) + Math_fround(f10 + Math_fround(f21 * f43)));
  i150 = HEAP32[i119 >> 2] | 0;
  i36 = i150 & 255;
  i2 = (HEAP32[i119 + 4 >> 2] | 0) + (i120 - (i36 << 1) + (Math_imul((HEAPU8[i119 + 2 >> 0] | 0) - i36 << 1, i121 - (i150 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i146 = HEAP32[i122 >> 2] | 0;
  i32 = i146 & 255;
  i1 = (HEAP32[i122 + 4 >> 2] | 0) + (i120 - (i32 << 1) + (Math_imul((HEAPU8[i122 + 2 >> 0] | 0) - i32 << 1, i121 - (i146 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i37 = 1 - i7 | 0;
  i36 = ((i150 >>> 16 & 255) - i36 << 1) + i37 | 0;
  i37 = ((i146 >>> 16 & 255) - i32 << 1) + i37 | 0;
  i32 = i7 + -1 | 0;
  f21 = Math_fround(HEAPF32[gb + 1451544 >> 2]);
  f33 = Math_fround(f123 * f21);
  f22 = Math_fround(HEAPF32[gb + 1451544 + 4 >> 2]);
  f34 = Math_fround(f123 * f22);
  f23 = Math_fround(HEAPF32[gb + 1451544 + 8 >> 2]);
  f35 = Math_fround(f123 * f23);
  f19 = Math_fround(HEAPF32[gb + 1451544 + 12 >> 2]);
  f28 = Math_fround(f123 * f19);
  f108 = Math_fround(f12 + f33);
  f109 = Math_fround(f12 + f34);
  f110 = Math_fround(f12 + f35);
  f111 = Math_fround(f12 + f28);
  f112 = Math_fround(f127 + f108);
  f113 = Math_fround(f127 + f109);
  f123 = Math_fround(f127 + f110);
  f114 = Math_fround(f127 + f111);
  f25 = Math_fround(f127 + f112);
  f26 = Math_fround(f127 + f113);
  f27 = Math_fround(f127 + f123);
  f20 = Math_fround(f127 + f114);
  f24 = Math_fround(f127 + f25);
  f31 = Math_fround(f127 + f26);
  f30 = Math_fround(f127 + f27);
  f29 = Math_fround(f127 + f20);
  i146 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
  i150 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
  i142 = (HEAPF32[tempDoublePtr >> 2] = f110, HEAP32[tempDoublePtr >> 2] | 0);
  i138 = (HEAPF32[tempDoublePtr >> 2] = f111, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
  i134 = (HEAPF32[tempDoublePtr >> 2] = f113, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i52 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
  i68 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i64 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i72 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i116 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i92 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i120 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  f29 = Math_fround(f124 * f21);
  f30 = Math_fround(f124 * f22);
  f31 = Math_fround(f124 * f23);
  f24 = Math_fround(f124 * f19);
  f20 = Math_fround(f14 + f29);
  f27 = Math_fround(f14 + f30);
  f26 = Math_fround(f14 + f31);
  f25 = Math_fround(f14 + f24);
  i147 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i151 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i143 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i139 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  f20 = Math_fround(f128 + f20);
  f27 = Math_fround(f128 + f27);
  f26 = Math_fround(f128 + f26);
  f25 = Math_fround(f128 + f25);
  i131 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i135 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  f20 = Math_fround(f128 + f20);
  f27 = Math_fround(f128 + f27);
  f26 = Math_fround(f128 + f26);
  f25 = Math_fround(f128 + f25);
  i67 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i63 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i71 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  f20 = Math_fround(f128 + f20);
  f27 = Math_fround(f128 + f27);
  f26 = Math_fround(f128 + f26);
  f25 = Math_fround(f128 + f25);
  i115 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i91 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i119 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) & i3;
  f25 = Math_fround(f125 * f21);
  f26 = Math_fround(f125 * f22);
  f27 = Math_fround(f125 * f23);
  f20 = Math_fround(f125 * f19);
  f114 = Math_fround(f15 + f25);
  f125 = Math_fround(f15 + f26);
  f124 = Math_fround(f15 + f27);
  f123 = Math_fround(f15 + f20);
  i145 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
  i149 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i141 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i137 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f114 = Math_fround(f129 + f114);
  f125 = Math_fround(f129 + f125);
  f124 = Math_fround(f129 + f124);
  f123 = Math_fround(f129 + f123);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
  i133 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i53 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f114 = Math_fround(f129 + f114);
  f125 = Math_fround(f129 + f125);
  f124 = Math_fround(f129 + f124);
  f123 = Math_fround(f129 + f123);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
  i65 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i73 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i77 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f114 = Math_fround(f129 + f114);
  f125 = Math_fround(f129 + f125);
  f124 = Math_fround(f129 + f124);
  f123 = Math_fround(f129 + f123);
  i117 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
  i93 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i121 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = i3 & (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround(f126 * f21);
  f22 = Math_fround(f126 * f22);
  f23 = Math_fround(f126 * f23);
  f19 = Math_fround(f126 * f19);
  f123 = Math_fround(f6 + f21);
  f124 = Math_fround(f6 + f22);
  f125 = Math_fround(f6 + f23);
  f126 = Math_fround(f6 + f19);
  i144 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i148 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i140 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i136 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
  f123 = Math_fround(f130 + f123);
  f124 = Math_fround(f130 + f124);
  f125 = Math_fround(f130 + f125);
  f126 = Math_fround(f130 + f126);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i132 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i39 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i62 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
  f123 = Math_fround(f130 + f123);
  f124 = Math_fround(f130 + f124);
  f125 = Math_fround(f130 + f125);
  f126 = Math_fround(f130 + f126);
  i70 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i66 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i74 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i78 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
  f123 = Math_fround(f130 + f123);
  f124 = Math_fround(f130 + f124);
  f125 = Math_fround(f130 + f125);
  f126 = Math_fround(f130 + f126);
  i118 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i94 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i122 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (i151 & i150 & i149 & i148) >> 31 & 2 | (i147 & i146 & i145 & i144) >>> 31 | (i143 & i142 & i141 & i140) >> 31 & 4 | (i139 & i138 & i137 & i136) >> 31 & 8 | ((i135 & i134 & i133 & i132) >> 31 & 2 | (i131 & i4 & i5 & i7) >>> 31 | (i17 & i18 & i38 & i39) >> 31 & 4 | (i48 & i52 & i53 & i62) >> 31 & 8) << 4 | ((i63 & i64 & i65 & i66) >> 31 & 2 | (i67 & i68 & i69 & i70) >>> 31 | (i71 & i72 & i73 & i74) >> 31 & 4 | (i75 & i76 & i77 & i78) >> 31 & 8) << 8 | ((i91 & i92 & i93 & i94) >> 31 & 2 | (i115 & i116 & i117 & i118) >>> 31 | (i119 & i120 & i121 & i122) >> 31 & 4 | (i3 & (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0)) >> 31 & 8) << 12;
  if ((i16 | 0) == 1) i4 = 0; else {
   i4 = 0;
   i18 = i16 + -2 | 0;
   i17 = i2;
   f8 = f12;
   f9 = f15;
   f10 = f6;
   f11 = f14;
   f13 = f6;
   f6 = f15;
   i5 = i32;
   while (1) {
    if (!i5) {
     f12 = Math_fround(f44 + f12);
     f14 = Math_fround(f45 + f14);
     f6 = Math_fround(f46 + f6);
     f13 = Math_fround(f47 + f13);
     i2 = i17 + (i36 << 1) | 0;
     f8 = f12;
     f9 = f6;
     f10 = f13;
     f11 = f14;
     i7 = i32;
     i16 = i1 + (i37 << 1) | 0;
    } else {
     i2 = i17 + 2 | 0;
     f8 = Math_fround(f40 + f8);
     f9 = Math_fround(f42 + f9);
     f10 = Math_fround(f43 + f10);
     f11 = Math_fround(f41 + f11);
     i7 = i5 + -1 | 0;
     i16 = i1 + 2 | 0;
    }
    f103 = Math_fround(f33 + f8);
    f104 = Math_fround(f34 + f8);
    f105 = Math_fround(f35 + f8);
    f106 = Math_fround(f28 + f8);
    f107 = Math_fround(f127 + f103);
    f108 = Math_fround(f127 + f104);
    f109 = Math_fround(f127 + f105);
    f110 = Math_fround(f127 + f106);
    f111 = Math_fround(f127 + f107);
    f112 = Math_fround(f127 + f108);
    f113 = Math_fround(f127 + f109);
    f114 = Math_fround(f127 + f110);
    f126 = Math_fround(f127 + f111);
    f125 = Math_fround(f127 + f112);
    f124 = Math_fround(f127 + f113);
    f123 = Math_fround(f127 + f114);
    i38 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    i155 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i53 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i65 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    i73 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
    i69 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
    i77 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
    i93 = (HEAPF32[tempDoublePtr >> 2] = f110, HEAP32[tempDoublePtr >> 2] | 0);
    i121 = (HEAPF32[tempDoublePtr >> 2] = f111, HEAP32[tempDoublePtr >> 2] | 0);
    i117 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
    i133 = (HEAPF32[tempDoublePtr >> 2] = f113, HEAP32[tempDoublePtr >> 2] | 0);
    i137 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
    i145 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i141 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i149 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f29 + f11);
    f124 = Math_fround(f30 + f11);
    f125 = Math_fround(f31 + f11);
    f126 = Math_fround(f24 + f11);
    i152 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i156 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i52 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i64 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f128 + f123);
    f124 = Math_fround(f128 + f124);
    f125 = Math_fround(f128 + f125);
    f126 = Math_fround(f128 + f126);
    i72 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i68 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i76 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i92 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f128 + f123);
    f124 = Math_fround(f128 + f124);
    f125 = Math_fround(f128 + f125);
    f126 = Math_fround(f128 + f126);
    i120 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i116 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i132 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i136 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f128 + f123);
    f124 = Math_fround(f128 + f124);
    f125 = Math_fround(f128 + f125);
    f126 = Math_fround(f128 + f126);
    i144 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i140 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i148 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0) & i5;
    f126 = Math_fround(f25 + f9);
    f125 = Math_fround(f26 + f9);
    f124 = Math_fround(f27 + f9);
    f123 = Math_fround(f20 + f9);
    i39 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i154 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i62 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i66 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f126 = Math_fround(f129 + f126);
    f125 = Math_fround(f129 + f125);
    f124 = Math_fround(f129 + f124);
    f123 = Math_fround(f129 + f123);
    i74 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i70 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i78 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i94 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f126 = Math_fround(f129 + f126);
    f125 = Math_fround(f129 + f125);
    f124 = Math_fround(f129 + f124);
    f123 = Math_fround(f129 + f123);
    i122 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i118 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i134 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i138 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f126 = Math_fround(f129 + f126);
    f125 = Math_fround(f129 + f125);
    f124 = Math_fround(f129 + f124);
    f123 = Math_fround(f129 + f123);
    i146 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i142 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i150 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = i5 & (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f21 + f10);
    f124 = Math_fround(f22 + f10);
    f125 = Math_fround(f23 + f10);
    f126 = Math_fround(f19 + f10);
    i48 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i153 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i63 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i67 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f130 + f123);
    f124 = Math_fround(f130 + f124);
    f125 = Math_fround(f130 + f125);
    f126 = Math_fround(f130 + f126);
    i75 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i71 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i91 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i115 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f130 + f123);
    f124 = Math_fround(f130 + f124);
    f125 = Math_fround(f130 + f125);
    f126 = Math_fround(f130 + f126);
    i131 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i119 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i135 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i139 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f130 + f123);
    f124 = Math_fround(f130 + f124);
    f125 = Math_fround(f130 + f125);
    f126 = Math_fround(f130 + f126);
    i147 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i143 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i151 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (i156 & i155 & i154 & i153) >> 31 & 2 | (i152 & i38 & i39 & i48) >>> 31 | (i52 & i53 & i62 & i63) >> 31 & 4 | (i64 & i65 & i66 & i67) >> 31 & 8 | ((i68 & i69 & i70 & i71) >> 31 & 2 | (i72 & i73 & i74 & i75) >>> 31 | (i76 & i77 & i78 & i91) >> 31 & 4 | (i92 & i93 & i94 & i115) >> 31 & 8) << 4 | ((i116 & i117 & i118 & i119) >> 31 & 2 | (i120 & i121 & i122 & i131) >>> 31 | (i132 & i133 & i134 & i135) >> 31 & 4 | (i136 & i137 & i138 & i139) >> 31 & 8) << 8 | ((i140 & i141 & i142 & i143) >> 31 & 2 | (i144 & i145 & i146 & i147) >>> 31 | (i148 & i149 & i150 & i151) >> 31 & 4 | (i5 & (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0)) >> 31 & 8) << 12;
    i151 = HEAPU16[i17 >> 1] | 0;
    i150 = i151 | (HEAPU16[i1 >> 1] | 0) & i3;
    HEAP16[i17 >> 1] = i150;
    i4 = i150 ^ i151 | i4;
    if (!i18) {
     i3 = i5;
     i1 = i16;
     break;
    } else {
     i3 = i5;
     i18 = i18 + -1 | 0;
     i17 = i2;
     i5 = i7;
     i1 = i16;
    }
   }
  }
  i156 = HEAPU16[i2 >> 1] | 0;
  i155 = i156 | (HEAPU16[i1 >> 1] | 0) & i3;
  HEAP16[i2 >> 1] = i155;
  i156 = i155 ^ i156 | i4;
  i156 = (i156 | 0) != 0;
  return i156 | 0;
 }
 if ((i16 | 0) < 41) {
  f14 = Math_fround(i120 | 0);
  f111 = Math_fround(i121 | 0);
  f58 = Math_fround(HEAPF32[gb + 1451448 >> 2]);
  f54 = Math_fround(f123 * f58);
  f59 = Math_fround(HEAPF32[gb + 1451448 + 4 >> 2]);
  f55 = Math_fround(f124 * f59);
  f60 = Math_fround(HEAPF32[gb + 1451448 + 8 >> 2]);
  f56 = Math_fround(f125 * f60);
  f61 = Math_fround(HEAPF32[gb + 1451448 + 12 >> 2]);
  f57 = Math_fround(f126 * f61);
  f58 = Math_fround(f127 * f58);
  f59 = Math_fround(f128 * f59);
  f60 = Math_fround(f129 * f60);
  f61 = Math_fround(f130 * f61);
  f6 = Math_fround(Math_fround(f111 * f58) + Math_fround(f6 + Math_fround(f14 * f54)));
  f12 = Math_fround(Math_fround(f111 * f59) + Math_fround(f8 + Math_fround(f14 * f55)));
  f13 = Math_fround(Math_fround(f111 * f60) + Math_fround(f9 + Math_fround(f14 * f56)));
  f14 = Math_fround(Math_fround(f111 * f61) + Math_fround(f10 + Math_fround(f14 * f57)));
  i48 = HEAP32[i119 >> 2] | 0;
  i52 = i48 & 255;
  i2 = (HEAP32[i119 + 4 >> 2] | 0) + (i120 - (i52 << 1) + (Math_imul((HEAPU8[i119 + 2 >> 0] | 0) - i52 << 1, i121 - (i48 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i1 = HEAP32[i122 >> 2] | 0;
  i3 = i1 & 255;
  i53 = 1 - i7 | 0;
  i52 = ((i48 >>> 16 & 255) - i52 << 1) + i53 | 0;
  i53 = ((i1 >>> 16 & 255) - i3 << 1) + i53 | 0;
  i48 = i7 + -1 | 0;
  f111 = Math_fround(f54 - f123);
  f112 = Math_fround(f55 - f124);
  f113 = Math_fround(f56 - f125);
  f114 = Math_fround(f57 - f126);
  f47 = Math_fround(f58 - f127);
  f49 = Math_fround(f59 - f128);
  f50 = Math_fround(f60 - f129);
  f51 = Math_fround(f61 - f130);
  i149 = f123 < Math_fround(0.0);
  i151 = f124 < Math_fround(0.0);
  i153 = f125 < Math_fround(0.0);
  i155 = f126 < Math_fround(0.0);
  i150 = f127 < Math_fround(0.0);
  i152 = f128 < Math_fround(0.0);
  i154 = f129 < Math_fround(0.0);
  i156 = f130 < Math_fround(0.0);
  f43 = i149 ? f111 : Math_fround(0.0);
  f43 = Math_fround(f43 + (i150 ? f47 : Math_fround(0.0)));
  f44 = i151 ? f112 : Math_fround(0.0);
  f44 = Math_fround(f44 + (i152 ? f49 : Math_fround(0.0)));
  f45 = i153 ? f113 : Math_fround(0.0);
  f45 = Math_fround(f45 + (i154 ? f50 : Math_fround(0.0)));
  f46 = i155 ? f114 : Math_fround(0.0);
  f46 = Math_fround(f46 + (i156 ? f51 : Math_fround(0.0)));
  f111 = i149 ? Math_fround(0.0) : f111;
  f47 = Math_fround(f111 + (i150 ? Math_fround(0.0) : f47));
  f112 = i151 ? Math_fround(0.0) : f112;
  f49 = Math_fround(f112 + (i152 ? Math_fround(0.0) : f49));
  f113 = i153 ? Math_fround(0.0) : f113;
  f50 = Math_fround(f113 + (i154 ? Math_fround(0.0) : f50));
  f114 = i155 ? Math_fround(0.0) : f114;
  f51 = Math_fround(f114 + (i156 ? Math_fround(0.0) : f51));
  if (!i16) {
   i4 = 0;
   i3 = 0;
   i1 = 0;
  } else {
   i1 = (HEAP32[i122 + 4 >> 2] | 0) + (i120 - (i3 << 1) + (Math_imul(i121 - (i1 >>> 8 & 255) << 1, (HEAPU8[i122 + 2 >> 0] | 0) - i3 | 0) | 0) << 1) | 0;
   f8 = Math_fround(f49 + f12);
   i39 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
   f8 = Math_fround(f47 + f6);
   i39 = i39 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
   f8 = Math_fround(f50 + f13);
   i39 = i39 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
   f8 = Math_fround(f51 + f14);
   i39 = i39 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
   f8 = Math_fround(f44 + f12);
   i38 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
   f8 = Math_fround(f43 + f6);
   i38 = i38 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
   f8 = Math_fround(f45 + f13);
   i38 = i38 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
   f8 = Math_fround(f46 + f14);
   f24 = Math_fround(HEAPF32[gb + 1451544 >> 2]);
   f25 = Math_fround(HEAPF32[gb + 1451544 + 4 >> 2]);
   f26 = Math_fround(HEAPF32[gb + 1451544 + 8 >> 2]);
   f22 = Math_fround(HEAPF32[gb + 1451544 + 12 >> 2]);
   f40 = Math_fround(f123 * f24);
   f41 = Math_fround(f123 * f25);
   f42 = Math_fround(f123 * f26);
   f31 = Math_fround(f123 * f22);
   f33 = Math_fround(f124 * f24);
   f34 = Math_fround(f124 * f25);
   f35 = Math_fround(f124 * f26);
   f27 = Math_fround(f124 * f22);
   f28 = Math_fround(f125 * f24);
   f29 = Math_fround(f125 * f25);
   f30 = Math_fround(f125 * f26);
   f23 = Math_fround(f125 * f22);
   f24 = Math_fround(f126 * f24);
   f25 = Math_fround(f126 * f25);
   f26 = Math_fround(f126 * f26);
   f22 = Math_fround(f126 * f22);
   i36 = 0;
   i18 = i2;
   i37 = 0;
   i38 = i38 | (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
   i4 = 0;
   i32 = i16;
   f8 = f6;
   f9 = f14;
   f10 = f12;
   f11 = f13;
   i7 = i48;
   f21 = f6;
   f20 = f12;
   f12 = f13;
   f6 = f14;
   while (1) {
    i32 = i32 + -1 | 0;
    i5 = HEAP16[i1 >> 1] | 0;
    i3 = i5 & 65535;
    if (!i7) {
     f8 = Math_fround(f58 + f8);
     f10 = Math_fround(f59 + f10);
     f11 = Math_fround(f60 + f11);
     f9 = Math_fround(f61 + f9);
     i17 = i2 + (i52 << 1) | 0;
     f13 = f8;
     f14 = f11;
     f15 = f9;
     f19 = f10;
     i7 = i48;
     i16 = i1 + (i53 << 1) | 0;
    } else {
     i17 = i2 + 2 | 0;
     f13 = Math_fround(f54 + f21);
     f14 = Math_fround(f56 + f12);
     f15 = Math_fround(f57 + f6);
     f19 = Math_fround(f55 + f20);
     i7 = i7 + -1 | 0;
     i16 = i1 + 2 | 0;
    }
    f126 = Math_fround(f43 + f13);
    f125 = Math_fround(f44 + f19);
    f124 = Math_fround(f45 + f14);
    f123 = Math_fround(f46 + f15);
    i151 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i150 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i152 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    f123 = Math_fround(f47 + f13);
    f124 = Math_fround(f49 + f19);
    f125 = Math_fround(f50 + f14);
    f126 = Math_fround(f51 + f15);
    i154 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
    i153 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i155 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i156 = i38;
    i38 = i150 >> 31 & 2 | i151 >>> 31 | i152 >> 31 & 4 | i1 >> 31 & 8;
    i1 = i39;
    i39 = i153 >> 31 & 2 | i154 >>> 31 | i155 >> 31 & 4 | (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
    if ((i156 | 0) == 15 & i5 << 16 >> 16 != 0) if ((i1 | 0) == 15) i1 = 65535; else {
     f103 = Math_fround(f40 + f21);
     f104 = Math_fround(f41 + f21);
     f105 = Math_fround(f42 + f21);
     f106 = Math_fround(f31 + f21);
     f107 = Math_fround(f127 + f103);
     f108 = Math_fround(f127 + f104);
     f109 = Math_fround(f127 + f105);
     f110 = Math_fround(f127 + f106);
     f111 = Math_fround(f127 + f107);
     f112 = Math_fround(f127 + f108);
     f113 = Math_fround(f127 + f109);
     f114 = Math_fround(f127 + f110);
     f126 = Math_fround(f127 + f111);
     f125 = Math_fround(f127 + f112);
     f124 = Math_fround(f127 + f113);
     f123 = Math_fround(f127 + f114);
     i62 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i159 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i66 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i70 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
     i78 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
     i74 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
     i94 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
     i118 = (HEAPF32[tempDoublePtr >> 2] = f110, HEAP32[tempDoublePtr >> 2] | 0);
     i134 = (HEAPF32[tempDoublePtr >> 2] = f111, HEAP32[tempDoublePtr >> 2] | 0);
     i122 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
     i138 = (HEAPF32[tempDoublePtr >> 2] = f113, HEAP32[tempDoublePtr >> 2] | 0);
     i142 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
     i150 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i146 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i154 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f33 + f20);
     f124 = Math_fround(f34 + f20);
     f125 = Math_fround(f35 + f20);
     f126 = Math_fround(f27 + f20);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i160 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i65 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i69 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f128 + f123);
     f124 = Math_fround(f128 + f124);
     f125 = Math_fround(f128 + f125);
     f126 = Math_fround(f128 + f126);
     i77 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i73 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i93 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i117 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f128 + f123);
     f124 = Math_fround(f128 + f124);
     f125 = Math_fround(f128 + f125);
     f126 = Math_fround(f128 + f126);
     i133 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i121 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i137 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i141 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f128 + f123);
     f124 = Math_fround(f128 + f124);
     f125 = Math_fround(f128 + f125);
     f126 = Math_fround(f128 + f126);
     i149 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i145 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i153 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i156 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f126 = Math_fround(f28 + f12);
     f125 = Math_fround(f29 + f12);
     f124 = Math_fround(f30 + f12);
     f123 = Math_fround(f23 + f12);
     i158 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i162 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i63 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i67 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     f126 = Math_fround(f129 + f126);
     f125 = Math_fround(f129 + f125);
     f124 = Math_fround(f129 + f124);
     f123 = Math_fround(f129 + f123);
     i75 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i71 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i91 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i115 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     f126 = Math_fround(f129 + f126);
     f125 = Math_fround(f129 + f125);
     f124 = Math_fround(f129 + f124);
     f123 = Math_fround(f129 + f123);
     i131 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i119 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i135 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i139 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     f126 = Math_fround(f129 + f126);
     f125 = Math_fround(f129 + f125);
     f124 = Math_fround(f129 + f124);
     f123 = Math_fround(f129 + f123);
     i147 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i143 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i151 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i155 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f24 + f6);
     f124 = Math_fround(f25 + f6);
     f125 = Math_fround(f26 + f6);
     f126 = Math_fround(f22 + f6);
     i157 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i161 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i64 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i68 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f130 + f123);
     f124 = Math_fround(f130 + f124);
     f125 = Math_fround(f130 + f125);
     f126 = Math_fround(f130 + f126);
     i76 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i72 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i92 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i116 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f130 + f123);
     f124 = Math_fround(f130 + f124);
     f125 = Math_fround(f130 + f125);
     f126 = Math_fround(f130 + f126);
     i132 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i120 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i136 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i140 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     f123 = Math_fround(f130 + f123);
     f124 = Math_fround(f130 + f124);
     f125 = Math_fround(f130 + f125);
     f126 = Math_fround(f130 + f126);
     i148 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
     i144 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i152 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (i162 & i161 & i160 & i159) >> 31 & 2 | (i158 & i157 & i5 & i62) >>> 31 | (i63 & i64 & i65 & i66) >> 31 & 4 | (i67 & i68 & i69 & i70) >> 31 & 8 | ((i71 & i72 & i73 & i74) >> 31 & 2 | (i75 & i76 & i77 & i78) >>> 31 | (i91 & i92 & i93 & i94) >> 31 & 4 | (i115 & i116 & i117 & i118) >> 31 & 8) << 4 | ((i119 & i120 & i121 & i122) >> 31 & 2 | (i131 & i132 & i133 & i134) >>> 31 | (i135 & i136 & i137 & i138) >> 31 & 4 | (i139 & i140 & i141 & i142) >> 31 & 8) << 8 | ((i143 & i144 & i145 & i146) >> 31 & 2 | (i147 & i148 & i149 & i150) >>> 31 | (i151 & i152 & i153 & i154) >> 31 & 4 | (i155 & (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0) & i156 & i1) >> 31 & 8) << 12;
    } else i1 = 0;
    i162 = HEAPU16[i18 >> 1] | 0;
    i161 = i162 | i37 & i36;
    HEAP16[i18 >> 1] = i161;
    i4 = i161 ^ i162 | i4;
    if (!i32) break; else {
     i18 = i2;
     i36 = i3;
     i37 = i1;
     i2 = i17;
     f21 = f13;
     f20 = f19;
     f12 = f14;
     f6 = f15;
     i1 = i16;
    }
   }
  }
  i162 = HEAPU16[i2 >> 1] | 0;
  i161 = i162 | i3 & i1;
  HEAP16[i2 >> 1] = i161;
  i162 = i161 ^ i162 | i4;
  i162 = (i162 | 0) != 0;
  return i162 | 0;
 }
 i115 = i4 >> 4;
 i7 = i117 + 3 >> 2;
 i5 = i5 >> 4;
 f20 = Math_fround(i115 | 0);
 f22 = Math_fround(i5 | 0);
 f99 = Math_fround(HEAPF32[gb + 1451496 >> 2]);
 f95 = Math_fround(f123 * f99);
 f100 = Math_fround(HEAPF32[gb + 1451496 + 4 >> 2]);
 f96 = Math_fround(f124 * f100);
 f101 = Math_fround(HEAPF32[gb + 1451496 + 8 >> 2]);
 f97 = Math_fround(f125 * f101);
 f102 = Math_fround(HEAPF32[gb + 1451496 + 12 >> 2]);
 f98 = Math_fround(f126 * f102);
 f99 = Math_fround(f127 * f99);
 f100 = Math_fround(f128 * f100);
 f101 = Math_fround(f129 * f101);
 f102 = Math_fround(f130 * f102);
 f107 = Math_fround(HEAPF32[gb + 1451448 >> 2]);
 f103 = Math_fround(f123 * f107);
 f108 = Math_fround(HEAPF32[gb + 1451448 + 4 >> 2]);
 f104 = Math_fround(f124 * f108);
 f109 = Math_fround(HEAPF32[gb + 1451448 + 8 >> 2]);
 f105 = Math_fround(f125 * f109);
 f110 = Math_fround(HEAPF32[gb + 1451448 + 12 >> 2]);
 f106 = Math_fround(f126 * f110);
 f107 = Math_fround(f127 * f107);
 f108 = Math_fround(f128 * f108);
 f109 = Math_fround(f129 * f109);
 f110 = Math_fround(f130 * f110);
 f114 = Math_fround(i120 & 3 | 0);
 f111 = Math_fround(f114 * f103);
 f112 = Math_fround(f114 * f104);
 f113 = Math_fround(f114 * f105);
 f114 = Math_fround(f114 * f106);
 f14 = Math_fround(i121 & 3 | 0);
 f11 = Math_fround(f14 * f107);
 f12 = Math_fround(f14 * f108);
 f13 = Math_fround(f14 * f109);
 f14 = Math_fround(f14 * f110);
 f15 = Math_fround(Math_fround(f22 * f99) + Math_fround(f6 + Math_fround(f20 * f95)));
 f21 = Math_fround(Math_fround(f22 * f100) + Math_fround(f8 + Math_fround(f20 * f96)));
 f19 = Math_fround(Math_fround(f22 * f101) + Math_fround(f9 + Math_fround(f20 * f97)));
 f20 = Math_fround(Math_fround(f22 * f102) + Math_fround(f10 + Math_fround(f20 * f98)));
 i78 = i7 + -1 | 0;
 i7 = Math_imul((i116 + 3 >> 2) - i5 | 0, i7 - i115 | 0) | 0;
 f22 = Math_fround(f111 + f11);
 f25 = Math_fround(f112 + f12);
 f23 = Math_fround(f113 + f13);
 f24 = Math_fround(f114 + f14);
 f6 = Math_fround(f95 - f123);
 f8 = Math_fround(f96 - f124);
 f9 = Math_fround(f97 - f125);
 f10 = Math_fround(f98 - f126);
 f79 = Math_fround(f99 - f127);
 f80 = Math_fround(f100 - f128);
 f81 = Math_fround(f101 - f129);
 f82 = Math_fround(f102 - f130);
 i91 = f123 < Math_fround(0.0);
 i159 = f124 < Math_fround(0.0);
 i3 = f125 < Math_fround(0.0);
 i161 = f126 < Math_fround(0.0);
 i2 = f127 < Math_fround(0.0);
 i160 = f128 < Math_fround(0.0);
 i4 = f129 < Math_fround(0.0);
 i162 = f130 < Math_fround(0.0);
 f58 = i91 ? f6 : Math_fround(0.0);
 f58 = Math_fround(f58 + (i2 ? f79 : Math_fround(0.0)));
 f59 = i159 ? f8 : Math_fround(0.0);
 f59 = Math_fround(f59 + (i160 ? f80 : Math_fround(0.0)));
 f60 = i3 ? f9 : Math_fround(0.0);
 f60 = Math_fround(f60 + (i4 ? f81 : Math_fround(0.0)));
 f61 = i161 ? f10 : Math_fround(0.0);
 f61 = Math_fround(f61 + (i162 ? f82 : Math_fround(0.0)));
 f6 = i91 ? Math_fround(0.0) : f6;
 f79 = Math_fround(f6 + (i2 ? Math_fround(0.0) : f79));
 f8 = i159 ? Math_fround(0.0) : f8;
 f80 = Math_fround(f8 + (i160 ? Math_fround(0.0) : f80));
 f9 = i3 ? Math_fround(0.0) : f9;
 f81 = Math_fround(f9 + (i4 ? Math_fround(0.0) : f81));
 f10 = i161 ? Math_fround(0.0) : f10;
 f82 = Math_fround(f10 + (i162 ? Math_fround(0.0) : f82));
 f10 = Math_fround(f103 - f123);
 f9 = Math_fround(f104 - f124);
 f8 = Math_fround(f105 - f125);
 f6 = Math_fround(f106 - f126);
 f87 = Math_fround(f107 - f127);
 f88 = Math_fround(f108 - f128);
 f89 = Math_fround(f109 - f129);
 f90 = Math_fround(f110 - f130);
 f83 = i91 ? f10 : Math_fround(0.0);
 f83 = Math_fround(f83 + (i2 ? f87 : Math_fround(0.0)));
 f84 = i159 ? f9 : Math_fround(0.0);
 f84 = Math_fround(f84 + (i160 ? f88 : Math_fround(0.0)));
 f85 = i3 ? f8 : Math_fround(0.0);
 f85 = Math_fround(f85 + (i4 ? f89 : Math_fround(0.0)));
 f86 = i161 ? f6 : Math_fround(0.0);
 f86 = Math_fround(f86 + (i162 ? f90 : Math_fround(0.0)));
 f10 = i91 ? Math_fround(0.0) : f10;
 f87 = Math_fround(f10 + (i2 ? Math_fround(0.0) : f87));
 f9 = i159 ? Math_fround(0.0) : f9;
 f88 = Math_fround(f9 + (i160 ? Math_fround(0.0) : f88));
 f8 = i3 ? Math_fround(0.0) : f8;
 f89 = Math_fround(f8 + (i4 ? Math_fround(0.0) : f89));
 f6 = i161 ? Math_fround(0.0) : f6;
 f90 = Math_fround(f6 + (i162 ? Math_fround(0.0) : f90));
 f6 = Math_fround(f15 + f58);
 f8 = Math_fround(f21 + f59);
 f9 = Math_fround(f19 + f60);
 f10 = Math_fround(f20 + f61);
 i162 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i161 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 f10 = Math_fround(f15 + f79);
 f9 = Math_fround(f21 + f80);
 f8 = Math_fround(f19 + f81);
 f6 = Math_fround(f20 + f82);
 i160 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i159 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i91 = i119 + 2 | 0;
 i92 = i122 + 2 | 0;
 i93 = i122 + 4 | 0;
 i94 = i119 + 4 | 0;
 i1 = 0;
 i2 = i159 >> 31 & 2 | i160 >>> 31 | i2 >> 31 & 4 | (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
 i3 = i161 >> 31 & 2 | i162 >>> 31 | i4 >> 31 & 4 | i3 >> 31 & 8;
 f6 = f15;
 f8 = f21;
 f9 = f19;
 f10 = f20;
 i4 = i115;
 L31 : while (1) {
  while (1) {
   i16 = i2;
   i75 = i3;
   i77 = i7;
   while (1) {
    i162 = i77;
    i77 = i77 + -1 | 0;
    if (!i162) break L31;
    if ((i4 | 0) == (i78 | 0)) {
     f15 = Math_fround(f99 + f15);
     f21 = Math_fround(f100 + f21);
     f19 = Math_fround(f101 + f19);
     f20 = Math_fround(f102 + f20);
     f43 = f15;
     f44 = f21;
     f45 = f19;
     f46 = f20;
     f47 = Math_fround(0.0);
     f49 = Math_fround(0.0);
     f50 = Math_fround(0.0);
     f51 = Math_fround(0.0);
     i74 = i115;
     i76 = i5 + 1 | 0;
     f54 = f111;
     f55 = f113;
     f56 = f114;
     f57 = f112;
    } else {
     f43 = Math_fround(f95 + f6);
     f44 = Math_fround(f96 + f8);
     f45 = Math_fround(f97 + f9);
     f46 = Math_fround(f98 + f10);
     f47 = f11;
     f49 = f12;
     f50 = f13;
     f51 = f14;
     i74 = i4 + 1 | 0;
     i76 = i5;
     f54 = f11;
     f55 = f13;
     f56 = f14;
     f57 = f12;
    }
    f42 = Math_fround(f58 + f43);
    f41 = Math_fround(f59 + f44);
    f40 = Math_fround(f60 + f45);
    f35 = Math_fround(f61 + f46);
    i157 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    i156 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
    i158 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
    i159 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f79 + f43);
    f40 = Math_fround(f80 + f44);
    f41 = Math_fround(f81 + f45);
    f42 = Math_fround(f82 + f46);
    i161 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    i160 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
    i73 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
    i162 = i75;
    i75 = i156 >> 31 & 2 | i157 >>> 31 | i158 >> 31 & 4 | i159 >> 31 & 8;
    i73 = i160 >> 31 & 2 | i161 >>> 31 | i73 >> 31 & 4 | (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
    if ((i162 | 0) == 15) break; else {
     i16 = i73;
     f6 = f43;
     f8 = f44;
     f9 = f45;
     f10 = f46;
     f11 = f47;
     f12 = f49;
     f13 = f50;
     f14 = f51;
     i4 = i74;
     i5 = i76;
     f22 = f54;
     f23 = f55;
     f24 = f56;
     f25 = f57;
    }
   }
   i2 = i4 << 2;
   i5 = i5 << 2;
   i7 = (i2 | 0) <= (i120 | 0) ? i120 : i2;
   i36 = (i5 | 0) <= (i121 | 0) ? i121 : i5;
   i2 = i2 + 4 | 0;
   i2 = (i2 | 0) >= (i117 | 0) ? i117 : i2;
   i5 = i5 + 4 | 0;
   i5 = (i5 | 0) >= (i116 | 0) ? i116 : i5;
   if ((i16 | 0) != 15) break;
   i3 = i7 >> 1;
   i32 = (i2 + 1 >> 1) - i3 | 0;
   i2 = i5 - i36 | 0;
   if ((i2 | 0) == 0 | (i32 | 0) == 0) {
    i2 = i73;
    i3 = i75;
    f6 = f43;
    f8 = f44;
    f9 = f45;
    f10 = f46;
    f11 = f47;
    f12 = f49;
    f13 = f50;
    f14 = f51;
    i4 = i74;
    i5 = i76;
    i7 = i77;
    f22 = f54;
    f23 = f55;
    f24 = f56;
    f25 = f57;
   } else {
    i118 = 30;
    break;
   }
  }
  if ((i118 | 0) == 30) {
   i118 = 0;
   i162 = HEAPU8[i91 >> 0] | 0;
   i161 = HEAP16[i119 >> 1] | 0;
   i7 = i161 & 255;
   i160 = HEAPU8[i92 >> 0] | 0;
   i159 = HEAP16[i122 >> 1] | 0;
   i16 = i159 & 255;
   i17 = i162 - i32 - i7 | 0;
   i18 = i160 - i32 - i16 | 0;
   i16 = (HEAP32[i93 >> 2] | 0) + (i3 - i16 + (Math_imul(i36 - ((i159 & 65535) >>> 8 & 65535) | 0, i160 - i16 | 0) | 0) << 2) | 0;
   i7 = (HEAP32[i94 >> 2] | 0) + (i3 - i7 + (Math_imul(i36 - ((i161 & 65535) >>> 8 & 65535) | 0, i162 - i7 | 0) | 0) << 2) | 0;
   while (1) {
    i3 = i32;
    i4 = i16;
    i5 = i7;
    while (1) {
     i3 = i3 + -1 | 0;
     i161 = HEAP32[i5 >> 2] | 0;
     i162 = HEAP32[i4 >> 2] | i161;
     i1 = i162 ^ i161 | i1;
     HEAP32[i5 >> 2] = i162;
     if (!i3) break; else {
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     }
    }
    i2 = i2 + -1 | 0;
    if (!i2) {
     i2 = i73;
     i3 = i75;
     f6 = f43;
     f8 = f44;
     f9 = f45;
     f10 = f46;
     f11 = f47;
     f12 = f49;
     f13 = f50;
     f14 = f51;
     i4 = i74;
     i5 = i76;
     i7 = i77;
     f22 = f54;
     f23 = f55;
     f24 = f56;
     f25 = f57;
     continue L31;
    } else {
     i16 = i16 + (i32 << 2) + (i18 << 2) | 0;
     i7 = i7 + (i32 << 2) + (i17 << 2) | 0;
    }
   }
  }
  f12 = Math_fround(f22 + f6);
  f11 = Math_fround(f25 + f8);
  f8 = Math_fround(f23 + f9);
  f6 = Math_fround(f24 + f10);
  i70 = i2 - i7 | 0;
  i16 = HEAP32[i119 >> 2] | 0;
  i71 = i16 & 255;
  i3 = (HEAP32[i94 >> 2] | 0) + (i7 - (i71 << 1) + (Math_imul((HEAPU8[i91 >> 0] | 0) - i71 << 1, i36 - (i16 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i2 = HEAP32[i122 >> 2] | 0;
  i4 = i2 & 255;
  i72 = 1 - i70 | 0;
  i71 = ((i16 >>> 16 & 255) - i71 << 1) + i72 | 0;
  i72 = ((i2 >>> 16 & 255) - i4 << 1) + i72 | 0;
  i16 = Math_imul(i5 - i36 | 0, i70) | 0;
  i70 = i70 + -1 | 0;
  L52 : do if (!i16) {
   i5 = 0;
   i4 = 0;
   i2 = 0;
  } else {
   i17 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i32 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i162 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAP32[i93 >> 2] | 0) + (i7 - (i4 << 1) + (Math_imul(i36 - (i2 >>> 8 & 255) << 1, (HEAPU8[i92 >> 0] | 0) - i4 | 0) | 0) << 1) | 0;
   f14 = Math_fround(f88 + f11);
   i67 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
   f14 = Math_fround(f87 + f12);
   i67 = i67 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
   f14 = Math_fround(f89 + f8);
   i67 = i67 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
   f14 = Math_fround(f90 + f6);
   i67 = i67 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
   f14 = Math_fround(f84 + f11);
   i66 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
   f14 = Math_fround(f83 + f12);
   i66 = i66 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
   f14 = Math_fround(f85 + f8);
   i66 = i66 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
   f14 = Math_fround(f86 + f6);
   f35 = Math_fround(HEAPF32[gb + 1451544 >> 2]);
   f40 = Math_fround(HEAPF32[gb + 1451544 + 4 >> 2]);
   f41 = Math_fround(HEAPF32[gb + 1451544 + 8 >> 2]);
   f42 = Math_fround(HEAPF32[gb + 1451544 + 12 >> 2]);
   f22 = Math_fround(f123 * f35);
   f23 = Math_fround(f123 * f40);
   f24 = Math_fround(f123 * f41);
   f25 = Math_fround(f123 * f42);
   f26 = Math_fround(f124 * f35);
   f27 = Math_fround(f124 * f40);
   f28 = Math_fround(f124 * f41);
   f29 = Math_fround(f124 * f42);
   f30 = Math_fround(f125 * f35);
   f31 = Math_fround(f125 * f40);
   f33 = Math_fround(f125 * f41);
   f34 = Math_fround(f125 * f42);
   f35 = Math_fround(f126 * f35);
   f40 = Math_fround(f126 * f40);
   f41 = Math_fround(f126 * f41);
   f42 = Math_fround(f126 * f42);
   i68 = 0;
   i65 = i3;
   i69 = 0;
   i66 = i66 | (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
   i5 = 0;
   i7 = i162;
   i36 = i70;
   f14 = f12;
   while (1) {
    i16 = i16 + -1 | 0;
    i37 = HEAP16[i2 >> 1] | 0;
    i4 = i37 & 65535;
    if (!i36) {
     f9 = Math_fround(f107 + (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f10 = Math_fround(f108 + (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f12 = Math_fround(f109 + (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f13 = Math_fround(f110 + (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i52 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     i18 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     i32 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i53 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i63 = i3 + (i71 << 1) | 0;
     i38 = i52;
     i39 = i32;
     i64 = i53;
     i48 = i18;
     i36 = i70;
     i62 = i2 + (i72 << 1) | 0;
    } else {
     f9 = Math_fround(f103 + f14);
     f10 = Math_fround(f104 + f11);
     f12 = Math_fround(f105 + f8);
     f13 = Math_fround(f106 + f6);
     i38 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     i48 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     i39 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i63 = i3 + 2 | 0;
     i64 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i52 = i7;
     i53 = i17;
     i36 = i36 + -1 | 0;
     i62 = i2 + 2 | 0;
    }
    f166 = Math_fround(f83 + f9);
    f165 = Math_fround(f84 + f10);
    f164 = Math_fround(f85 + f12);
    f163 = Math_fround(f86 + f13);
    i160 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
    i158 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
    i159 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
    f9 = Math_fround(f87 + f9);
    f10 = Math_fround(f88 + f10);
    f12 = Math_fround(f89 + f12);
    f13 = Math_fround(f90 + f13);
    i162 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
    i17 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    i161 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = i158 >> 31 & 4 | i159 >> 31 & 8 | i160 >>> 31 | i7 >> 31 & 2;
    i17 = i161 >> 31 & 4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8 | i162 >>> 31 | i17 >> 31 & 2;
    if ((i66 | 0) == 15 & i37 << 16 >> 16 != 0) if ((i67 | 0) == 15) i2 = 65535; else {
     f200 = Math_fround(f22 + f14);
     f199 = Math_fround(f23 + f14);
     f198 = Math_fround(f24 + f14);
     f197 = Math_fround(f25 + f14);
     f196 = Math_fround(f127 + f200);
     f195 = Math_fround(f127 + f199);
     f194 = Math_fround(f127 + f198);
     f9 = Math_fround(f127 + f197);
     f10 = Math_fround(f127 + f196);
     f12 = Math_fround(f127 + f195);
     f13 = Math_fround(f127 + f194);
     f14 = Math_fround(f127 + f9);
     f166 = Math_fround(f127 + f10);
     f165 = Math_fround(f127 + f12);
     f164 = Math_fround(f127 + f13);
     f163 = Math_fround(f127 + f14);
     i186 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
     i190 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
     i182 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
     i178 = (HEAPF32[tempDoublePtr >> 2] = f197, HEAP32[tempDoublePtr >> 2] | 0);
     i170 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
     i174 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
     i37 = (HEAPF32[tempDoublePtr >> 2] = f194, HEAP32[tempDoublePtr >> 2] | 0);
     i132 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     i140 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     i136 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i144 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i148 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i156 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i152 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i160 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f26 + f11);
     f164 = Math_fround(f27 + f11);
     f165 = Math_fround(f28 + f11);
     f166 = Math_fround(f29 + f11);
     i187 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i191 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i183 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i179 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f128 + f163);
     f164 = Math_fround(f128 + f164);
     f165 = Math_fround(f128 + f165);
     f166 = Math_fround(f128 + f166);
     i171 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i175 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i167 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i131 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f128 + f163);
     f164 = Math_fround(f128 + f164);
     f165 = Math_fround(f128 + f165);
     f166 = Math_fround(f128 + f166);
     i139 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i135 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i143 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i147 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f128 + f163);
     f164 = Math_fround(f128 + f164);
     f165 = Math_fround(f128 + f165);
     f166 = Math_fround(f128 + f166);
     i155 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i151 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i159 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i162 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f166 = Math_fround(f30 + f8);
     f165 = Math_fround(f31 + f8);
     f164 = Math_fround(f33 + f8);
     f163 = Math_fround(f34 + f8);
     i189 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i193 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i185 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i181 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     f166 = Math_fround(f129 + f166);
     f165 = Math_fround(f129 + f165);
     f164 = Math_fround(f129 + f164);
     f163 = Math_fround(f129 + f163);
     i173 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i177 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i169 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i66 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     f166 = Math_fround(f129 + f166);
     f165 = Math_fround(f129 + f165);
     f164 = Math_fround(f129 + f164);
     f163 = Math_fround(f129 + f163);
     i137 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i133 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i141 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i145 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     f166 = Math_fround(f129 + f166);
     f165 = Math_fround(f129 + f165);
     f164 = Math_fround(f129 + f164);
     f163 = Math_fround(f129 + f163);
     i153 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i149 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i157 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i161 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f35 + f6);
     f164 = Math_fround(f40 + f6);
     f165 = Math_fround(f41 + f6);
     f166 = Math_fround(f42 + f6);
     i188 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i192 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i184 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i180 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f130 + f163);
     f164 = Math_fround(f130 + f164);
     f165 = Math_fround(f130 + f165);
     f166 = Math_fround(f130 + f166);
     i172 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i176 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i168 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i67 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f130 + f163);
     f164 = Math_fround(f130 + f164);
     f165 = Math_fround(f130 + f165);
     f166 = Math_fround(f130 + f166);
     i138 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i134 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i142 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i146 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f163 = Math_fround(f130 + f163);
     f164 = Math_fround(f130 + f164);
     f165 = Math_fround(f130 + f165);
     f166 = Math_fround(f130 + f166);
     i154 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
     i150 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
     i158 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (i193 & i192 & i191 & i190) >> 31 & 2 | (i189 & i188 & i187 & i186) >>> 31 | (i185 & i184 & i183 & i182) >> 31 & 4 | (i181 & i180 & i179 & i178) >> 31 & 8 | ((i177 & i176 & i175 & i174) >> 31 & 2 | (i173 & i172 & i171 & i170) >>> 31 | (i169 & i168 & i167 & i37) >> 31 & 4 | (i66 & i67 & i131 & i132) >> 31 & 8) << 4 | ((i133 & i134 & i135 & i136) >> 31 & 2 | (i137 & i138 & i139 & i140) >>> 31 | (i141 & i142 & i143 & i144) >> 31 & 4 | (i145 & i146 & i147 & i148) >> 31 & 8) << 8 | ((i149 & i150 & i151 & i152) >> 31 & 2 | (i153 & i154 & i155 & i156) >>> 31 | (i157 & i158 & i159 & i160) >> 31 & 4 | (i161 & (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0) & i162 & i2) >> 31 & 8) << 12;
    } else i2 = 0;
    i193 = HEAPU16[i65 >> 1] | 0;
    i192 = i193 | i69 & i68;
    HEAP16[i65 >> 1] = i192;
    i5 = i192 ^ i193 | i5;
    if (!i16) break L52;
    f14 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f8 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i65 = i3;
    i68 = i4;
    i69 = i2;
    i66 = i7;
    i67 = i17;
    i7 = i52;
    i17 = i53;
    i3 = i63;
    f6 = (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i2 = i62;
   }
  } while (0);
  i7 = HEAPU16[i3 >> 1] | 0;
  i2 = i7 | i4 & i2;
  HEAP16[i3 >> 1] = i2;
  i1 = i5 | i1 | i2 ^ i7;
  i2 = i73;
  i3 = i75;
  f6 = f43;
  f8 = f44;
  f9 = f45;
  f10 = f46;
  f11 = f47;
  f12 = f49;
  f13 = f50;
  f14 = f51;
  i4 = i74;
  i5 = i76;
  i7 = i77;
  f22 = f54;
  f23 = f55;
  f24 = f56;
  f25 = f57;
 }
 i193 = (i1 | 0) != 0;
 return i193 | 0;
}

function __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i3, i64, i65, i1, i2, f66, i67) {
 i3 = i3 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f66 = Math_fround(f66);
 i67 = i67 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i68 = 0, i69 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i69;
 i63 = HEAP32[i3 + 72 + (i1 << 2) >> 2] | 0;
 i62 = HEAP32[i3 + 72 + (i2 << 2) >> 2] | 0;
 i56 = i3 + 40 | 0;
 i57 = i56;
 i58 = (HEAP32[i56 >> 2] | 0) + i57 | 0;
 i36 = i58 + 4 | 0;
 i36 = i36 + (HEAP32[i36 >> 2] | 0) | 0;
 i60 = HEAP32[i36 + (i63 << 3) >> 2] | 0;
 i58 = i58 + 16 | 0;
 i3 = HEAP32[i36 + (i63 << 3) + 4 >> 2] | 0;
 i58 = (HEAP32[i58 >> 2] | 0) + i58 | 0;
 f10 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) >> 2]);
 f12 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 12 >> 2]);
 i34 = HEAP32[i58 + (i3 * 76 | 0) + 16 >> 2] | 0;
 i35 = HEAP32[i58 + (i3 * 76 | 0) + 20 >> 2] | 0;
 i33 = HEAP32[i58 + (i3 * 76 | 0) + 24 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 28 >> 2]);
 i15 = HEAP32[i58 + (i3 * 76 | 0) + 32 >> 2] | 0;
 i16 = HEAP32[i58 + (i3 * 76 | 0) + 36 >> 2] | 0;
 i17 = HEAP32[i58 + (i3 * 76 | 0) + 40 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 56 >> 2]);
 f8 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 60 >> 2]);
 f9 = Math_fround(HEAPF32[i58 + (i3 * 76 | 0) + 64 >> 2]);
 i3 = HEAP32[i58 + (i3 * 76 | 0) + 68 + 4 >> 2] | 0;
 i36 = HEAP32[i36 + (i62 << 3) + 4 >> 2] | 0;
 i49 = HEAP32[i58 + (i36 * 76 | 0) >> 2] | 0;
 i47 = HEAP32[i58 + (i36 * 76 | 0) + 4 >> 2] | 0;
 i48 = HEAP32[i58 + (i36 * 76 | 0) + 8 >> 2] | 0;
 f51 = Math_fround(HEAPF32[i58 + (i36 * 76 | 0) + 12 >> 2]);
 i44 = HEAP32[i58 + (i36 * 76 | 0) + 16 >> 2] | 0;
 i45 = HEAP32[i58 + (i36 * 76 | 0) + 20 >> 2] | 0;
 i46 = HEAP32[i58 + (i36 * 76 | 0) + 24 >> 2] | 0;
 f52 = Math_fround(HEAPF32[i58 + (i36 * 76 | 0) + 28 >> 2]);
 i41 = HEAP32[i58 + (i36 * 76 | 0) + 32 >> 2] | 0;
 i42 = HEAP32[i58 + (i36 * 76 | 0) + 36 >> 2] | 0;
 i43 = HEAP32[i58 + (i36 * 76 | 0) + 40 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i58 + (i36 * 76 | 0) + 56 >> 2]);
 f19 = Math_fround(HEAPF32[i58 + (i36 * 76 | 0) + 60 >> 2]);
 f20 = Math_fround(HEAPF32[i58 + (i36 * 76 | 0) + 64 >> 2]);
 i36 = HEAP32[i58 + (i36 * 76 | 0) + 68 + 4 >> 2] | 0;
 i58 = i65 + 4 | 0;
 i59 = i58;
 i61 = (HEAP32[i58 >> 2] | 0) + i59 | 0;
 HEAP32[i61 + (i60 * 40 | 0) + 12 >> 2] = 0;
 HEAP32[i61 + (i60 * 40 | 0) + 16 >> 2] = 0;
 HEAP32[i61 + (i60 * 40 | 0) + 20 >> 2] = 0;
 HEAP32[i61 + (i60 * 40 | 0) + 24 >> 2] = 1065353216;
 i60 = HEAP32[i56 >> 2] | 0;
 __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i60 | 0) == 0 ? 0 : i60 + i57 | 0, i64, i65, i62, i63);
 i60 = i64 + 4 | 0;
 i61 = i60;
 i55 = (HEAP32[i60 >> 2] | 0) + i61 + (i63 * 40 | 0) + 12 | 0;
 HEAP32[i68 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
 HEAP32[i68 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
 i55 = (HEAP32[i58 >> 2] | 0) + i59 | 0;
 i50 = HEAP32[i55 + (i62 * 40 | 0) + 12 >> 2] | 0;
 i53 = HEAP32[i55 + (i62 * 40 | 0) + 16 >> 2] | 0;
 i54 = HEAP32[i55 + (i62 * 40 | 0) + 20 >> 2] | 0;
 i55 = HEAP32[i55 + (i62 * 40 | 0) + 24 >> 2] | 0;
 switch (i3 | 0) {
 case 3:
  {
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(0.0) - Math_fround(+_roundf(0.0))))));
   f40 = Math_fround(f39 * f39);
   f7 = Math_fround(f40 * f40);
   f40 = Math_fround(f39 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
   f7 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(-.25) - Math_fround(+_roundf(-.25))))));
   f39 = Math_fround(f7 * f7);
   f6 = Math_fround(f39 * f39);
   f39 = Math_fround(f7 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187)))))));
   f6 = Math_fround(f40 * f39);
   f7 = Math_fround(f39 * f39);
   f38 = Math_fround(f40 * f40);
   f5 = Math_fround(f40 * f6);
   f4 = Math_fround(Math_fround(Math_fround(Math_fround(-1.0) * f39) * f6) + Math_fround(Math_fround(1.0) * f5));
   f5 = Math_fround(Math_fround(f6 * Math_fround(Math_fround(-1.0) * f39)) + Math_fround(Math_fround(1.0) * f5));
   f6 = Math_fround(Math_fround(Math_fround(f40 * f38) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(1.0) * f39) * f7));
   f7 = Math_fround(Math_fround(f38 * Math_fround(Math_fround(1.0) * f39)) + Math_fround(Math_fround(f40 * f7) * Math_fround(1.0)));
   break;
  }
 case 1:
  {
   f4 = Math_fround(f7 * Math_fround(0.0));
   f5 = Math_fround(f8 * Math_fround(0.0));
   f6 = Math_fround(f9 * Math_fround(0.0));
   i2 = f7 > Math_fround(0.0);
   i1 = f8 > Math_fround(0.0);
   i3 = f9 > Math_fround(0.0);
   i2 = i2 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i3 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f38 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(Math_fround(Math_abs(Math_fround(f38))) + Math_fround(3.14159274));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f32 = Math_fround(f30 / Math_fround(6.28318548));
   f31 = Math_fround(f6 / Math_fround(6.28318548));
   f39 = Math_fround(_truncf(Math_fround(f38 / Math_fround(6.28318548))));
   f39 = Math_fround(Math_fround(f38 - Math_fround(f39 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f32 = Math_fround(Math_fround(f30 - Math_fround(Math_fround(_truncf(f32)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f31 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f31)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i70 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i3 & -2147483648;
   f31 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f31 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f31 = Math_fround(f31 * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f31));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f6))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f40 = Math_fround(f6 * f6);
   f5 = Math_fround(f30 * f30);
   f4 = Math_fround(f38 * f38);
   f37 = Math_fround(f40 * f40);
   f7 = Math_fround(f5 * f5);
   f29 = Math_fround(f4 * f4);
   f40 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
   f5 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f38 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f29 = Math_fround(+_roundf(+f31));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f29))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f31 = Math_fround(f29 * f29);
   f38 = Math_fround(f32 * f32);
   f7 = Math_fround(f39 * f39);
   f30 = Math_fround(f31 * f31);
   f37 = Math_fround(f38 * f38);
   f6 = Math_fround(f7 * f7);
   f40 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f40);
   f5 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f5);
   f4 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i16 & -2147483648;
   i17 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i17 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f5 + Math_fround(f4 * f40));
   f5 = Math_fround(f40 - Math_fround(f4 * f5));
   f40 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f40 * f4);
   f5 = Math_fround(f40 * f5);
   f6 = f40;
   f7 = Math_fround(f40 * f7);
   break;
  }
 case 2:
  {
   f4 = Math_fround(f7 * Math_fround(0.0));
   f5 = Math_fround(f8 * Math_fround(0.0));
   f6 = Math_fround(f9 * Math_fround(0.0));
   i70 = f7 > Math_fround(0.0);
   i1 = f8 > Math_fround(0.0);
   i3 = f9 > Math_fround(0.0);
   i2 = i70 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i70 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f38 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(Math_fround(Math_abs(Math_fround(f38))) + Math_fround(3.14159274));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f32 = Math_fround(f30 / Math_fround(6.28318548));
   f31 = Math_fround(f6 / Math_fround(6.28318548));
   f39 = Math_fround(_truncf(Math_fround(f38 / Math_fround(6.28318548))));
   f39 = Math_fround(Math_fround(f38 - Math_fround(f39 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f32 = Math_fround(Math_fround(f30 - Math_fround(Math_fround(_truncf(f32)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f31 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f31)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i70 & -2147483648;
   f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f31 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f31 = Math_fround(f31 * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f31));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f6))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f5 = Math_fround(f6 * f6);
   f40 = Math_fround(f30 * f30);
   f4 = Math_fround(f38 * f38);
   f37 = Math_fround(f5 * f5);
   f7 = Math_fround(f40 * f40);
   f29 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f40 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f38 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f29 = Math_fround(+_roundf(+f31));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f29))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f31 = Math_fround(f29 * f29);
   f38 = Math_fround(f32 * f32);
   f7 = Math_fround(f39 * f39);
   f30 = Math_fround(f31 * f31);
   f37 = Math_fround(f38 * f38);
   f6 = Math_fround(f7 * f7);
   f5 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f5);
   f40 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f40);
   f4 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) ^ i16 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i17 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f40 - Math_fround(f4 * f5));
   f5 = Math_fround(Math_fround(f4 * f40) + f5);
   f40 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f40 * f4);
   f5 = Math_fround(f40 * f5);
   f6 = f40;
   f7 = Math_fround(f40 * f7);
   break;
  }
 default:
  {
   f4 = Math_fround(f7 * Math_fround(0.0));
   f5 = Math_fround(f8 * Math_fround(0.0));
   f6 = Math_fround(f9 * Math_fround(0.0));
   i70 = f7 > Math_fround(0.0);
   i1 = f8 > Math_fround(0.0);
   i3 = f9 > Math_fround(0.0);
   i2 = i70 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i70 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f38 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(Math_fround(Math_abs(Math_fround(f38))) + Math_fround(3.14159274));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f32 = Math_fround(f30 / Math_fround(6.28318548));
   f31 = Math_fround(f6 / Math_fround(6.28318548));
   f39 = Math_fround(_truncf(Math_fround(f38 / Math_fround(6.28318548))));
   f39 = Math_fround(Math_fround(f38 - Math_fround(f39 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f32 = Math_fround(Math_fround(f30 - Math_fround(Math_fround(_truncf(f32)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f31 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f31)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i70 & -2147483648;
   f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f31 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f31 = Math_fround(f31 * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f31));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f6))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f5 = Math_fround(f6 * f6);
   f7 = Math_fround(f30 * f30);
   f4 = Math_fround(f38 * f38);
   f37 = Math_fround(f5 * f5);
   f40 = Math_fround(f7 * f7);
   f29 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f7 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f38 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f29 = Math_fround(+_roundf(+f31));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - f29))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f31 = Math_fround(f29 * f29);
   f38 = Math_fround(f32 * f32);
   f40 = Math_fround(f39 * f39);
   f30 = Math_fround(f31 * f31);
   f37 = Math_fround(f38 * f38);
   f6 = Math_fround(f40 * f40);
   f5 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f5);
   f7 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f7);
   f4 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187))))))) / f4);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i16 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i17 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(1.0))))));
   f4 = Math_fround(f40 * f4);
   f5 = Math_fround(f40 * f5);
   f6 = f40;
   f7 = Math_fround(f40 * f7);
  }
 }
 f31 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(f31 * f7);
 f37 = Math_fround(f11 * f6);
 f39 = (HEAP32[tempDoublePtr >> 2] = i35 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f39 * f5);
 f32 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(Math_fround(Math_fround(f40 - Math_fround(f32 * f6)) - Math_fround(f11 * f5)) - Math_fround(f39 * f4));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f31 * f4)) - Math_fround(f32 * f5)) - Math_fround(f39 * f7));
 f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f32 * f7)) - Math_fround(f31 * f6)) - Math_fround(f11 * f4));
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f4) - Math_fround(f31 * f5)) - Math_fround(f39 * f6)) - Math_fround(f11 * f7));
 i70 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f39 = (HEAP32[tempDoublePtr >> 2] = i35 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f12 * f39);
 f40 = Math_fround(f14 * f37);
 f31 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(f13 * f31);
 f30 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f14 * f30)) - Math_fround(f13 * f37)) - Math_fround(f10 * f31));
 f40 = Math_fround(Math_fround(Math_fround(f40 - Math_fround(f10 * f39)) - Math_fround(f13 * f30)) - Math_fround(f12 * f31));
 f32 = Math_fround(Math_fround(Math_fround(f32 - Math_fround(f12 * f30)) - Math_fround(f14 * f39)) - Math_fround(f10 * f37));
 f37 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f30) - Math_fround(f13 * f39)) - Math_fround(f14 * f31)) - Math_fround(f12 * f37));
 i70 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f37 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(f37 * f37);
 f38 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f38 * f38);
 f39 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f39 * f39)) + Math_fround(f31 + f32)))));
 f37 = Math_fround(f32 * f37);
 f38 = Math_fround(f32 * f38);
 f39 = Math_fround(f32 * f39);
 f40 = Math_fround(f32 * f40);
 switch (i36 | 0) {
 case 3:
  {
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(0.0) - Math_fround(+_roundf(0.0))))));
   f32 = Math_fround(f31 * f31);
   f7 = Math_fround(f32 * f32);
   f32 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187)))))));
   f7 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(-.25) - Math_fround(+_roundf(-.25))))));
   f31 = Math_fround(f7 * f7);
   f6 = Math_fround(f31 * f31);
   f31 = Math_fround(f7 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187)))))));
   f6 = Math_fround(f32 * f31);
   f7 = Math_fround(f31 * f31);
   f30 = Math_fround(f32 * f32);
   f5 = Math_fround(f32 * f6);
   f4 = Math_fround(Math_fround(Math_fround(Math_fround(-1.0) * f31) * f6) + Math_fround(Math_fround(1.0) * f5));
   f5 = Math_fround(Math_fround(f6 * Math_fround(Math_fround(-1.0) * f31)) + Math_fround(Math_fround(1.0) * f5));
   f6 = Math_fround(Math_fround(Math_fround(f32 * f30) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(1.0) * f31) * f7));
   f7 = Math_fround(Math_fround(f30 * Math_fround(Math_fround(1.0) * f31)) + Math_fround(Math_fround(f32 * f7) * Math_fround(1.0)));
   break;
  }
 case 1:
  {
   f4 = Math_fround(f18 * Math_fround(0.0));
   f5 = Math_fround(f19 * Math_fround(0.0));
   f6 = Math_fround(f20 * Math_fround(0.0));
   i70 = f18 > Math_fround(0.0);
   i1 = f19 > Math_fround(0.0);
   i3 = f20 > Math_fround(0.0);
   i2 = i70 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i70 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f30 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround(f30))) + Math_fround(3.14159274));
   f26 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f28 = Math_fround(f26 / Math_fround(6.28318548));
   f27 = Math_fround(f6 / Math_fround(6.28318548));
   f31 = Math_fround(_truncf(Math_fround(f30 / Math_fround(6.28318548))));
   f31 = Math_fround(Math_fround(f30 - Math_fround(f31 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f26 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f27 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f27)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i35 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) ^ i70 & -2147483648;
   f27 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f27 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f27 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f27 = Math_fround(f27 * Math_fround(.159154937));
   f28 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f28, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f31 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f31, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f27));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f6))));
   f26 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f32 = Math_fround(f6 * f6);
   f5 = Math_fround(f26 * f26);
   f4 = Math_fround(f30 * f30);
   f29 = Math_fround(f32 * f32);
   f7 = Math_fround(f5 * f5);
   f25 = Math_fround(f4 * f4);
   f32 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187)))))));
   f5 = Math_fround(f26 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f27 = Math_fround(f27 + Math_fround(-.25));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f25 = Math_fround(+_roundf(+f27));
   f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f25))));
   f28 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f27 = Math_fround(f25 * f25);
   f30 = Math_fround(f28 * f28);
   f7 = Math_fround(f31 * f31);
   f26 = Math_fround(f27 * f27);
   f29 = Math_fround(f30 * f30);
   f6 = Math_fround(f7 * f7);
   f32 = Math_fround(Math_fround(f25 * Math_fround(Math_fround(Math_fround(f26 * f26) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f26 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187))))))) / f32);
   f5 = Math_fround(Math_fround(f28 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f30 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f30 * Math_fround(76.5686187))))))) / f5);
   f4 = Math_fround(Math_fround(f31 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i41 & -2147483648;
   i42 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i42 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i43 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f5 + Math_fround(f4 * f32));
   f5 = Math_fround(f32 - Math_fround(f4 * f5));
   f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f32 * f4);
   f5 = Math_fround(f32 * f5);
   f6 = f32;
   f7 = Math_fround(f32 * f7);
   break;
  }
 case 2:
  {
   f4 = Math_fround(f18 * Math_fround(0.0));
   f5 = Math_fround(f19 * Math_fround(0.0));
   f6 = Math_fround(f20 * Math_fround(0.0));
   i70 = f18 > Math_fround(0.0);
   i1 = f19 > Math_fround(0.0);
   i3 = f20 > Math_fround(0.0);
   i2 = i70 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i70 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f30 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround(f30))) + Math_fround(3.14159274));
   f26 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f28 = Math_fround(f26 / Math_fround(6.28318548));
   f27 = Math_fround(f6 / Math_fround(6.28318548));
   f31 = Math_fround(_truncf(Math_fround(f30 / Math_fround(6.28318548))));
   f31 = Math_fround(Math_fround(f30 - Math_fround(f31 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f26 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f27 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f27)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i35 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) ^ i70 & -2147483648;
   f27 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f27 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f27 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f27 = Math_fround(f27 * Math_fround(.159154937));
   f28 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f28, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f31 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f31, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f27));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f6))));
   f26 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f5 = Math_fround(f6 * f6);
   f32 = Math_fround(f26 * f26);
   f4 = Math_fround(f30 * f30);
   f29 = Math_fround(f5 * f5);
   f7 = Math_fround(f32 * f32);
   f25 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f32 = Math_fround(f26 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f27 = Math_fround(f27 + Math_fround(-.25));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f25 = Math_fround(+_roundf(+f27));
   f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f25))));
   f28 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f27 = Math_fround(f25 * f25);
   f30 = Math_fround(f28 * f28);
   f7 = Math_fround(f31 * f31);
   f26 = Math_fround(f27 * f27);
   f29 = Math_fround(f30 * f30);
   f6 = Math_fround(f7 * f7);
   f5 = Math_fround(Math_fround(f25 * Math_fround(Math_fround(Math_fround(f26 * f26) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f26 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187))))))) / f5);
   f32 = Math_fround(Math_fround(f28 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f30 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f30 * Math_fround(76.5686187))))))) / f32);
   f4 = Math_fround(Math_fround(f31 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i41 & -2147483648;
   i42 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i42 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i43 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f32 - Math_fround(f4 * f5));
   f5 = Math_fround(Math_fround(f4 * f32) + f5);
   f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f32 * f4);
   f5 = Math_fround(f32 * f5);
   f6 = f32;
   f7 = Math_fround(f32 * f7);
   break;
  }
 default:
  {
   f4 = Math_fround(f18 * Math_fround(0.0));
   f5 = Math_fround(f19 * Math_fround(0.0));
   f6 = Math_fround(f20 * Math_fround(0.0));
   i70 = f18 > Math_fround(0.0);
   i1 = f19 > Math_fround(0.0);
   i3 = f20 > Math_fround(0.0);
   i2 = i70 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i70 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   f30 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(Math_fround(Math_abs(Math_fround(f30))) + Math_fround(3.14159274));
   f26 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f28 = Math_fround(f26 / Math_fround(6.28318548));
   f27 = Math_fround(f6 / Math_fround(6.28318548));
   f31 = Math_fround(_truncf(Math_fround(f30 / Math_fround(6.28318548))));
   f31 = Math_fround(Math_fround(f30 - Math_fround(f31 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f26 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f27 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f27)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i35 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) ^ i70 & -2147483648;
   f27 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f27 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f27 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f27 = Math_fround(f27 * Math_fround(.159154937));
   f28 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f28, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f31 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f31, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f27));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f6))));
   f26 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f5 = Math_fround(f6 * f6);
   f7 = Math_fround(f26 * f26);
   f4 = Math_fround(f30 * f30);
   f29 = Math_fround(f5 * f5);
   f32 = Math_fround(f7 * f7);
   f25 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f7 = Math_fround(f26 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f27 = Math_fround(f27 + Math_fround(-.25));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f25 = Math_fround(+_roundf(+f27));
   f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f25))));
   f28 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - Math_fround(+_roundf(+f28))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f27 = Math_fround(f25 * f25);
   f30 = Math_fround(f28 * f28);
   f32 = Math_fround(f31 * f31);
   f26 = Math_fround(f27 * f27);
   f29 = Math_fround(f30 * f30);
   f6 = Math_fround(f32 * f32);
   f5 = Math_fround(Math_fround(f25 * Math_fround(Math_fround(Math_fround(f26 * f26) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f26 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187))))))) / f5);
   f7 = Math_fround(Math_fround(f28 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f30 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f30 * Math_fround(76.5686187))))))) / f7);
   f4 = Math_fround(Math_fround(f31 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187))))))) / f4);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i41 & -2147483648;
   i42 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i42 & -2147483648;
   i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i43 & -2147483648;
   f4 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(1.0))))));
   f4 = Math_fround(f32 * f4);
   f5 = Math_fround(f32 * f5);
   f6 = f32;
   f7 = Math_fround(f32 * f7);
  }
 }
 f30 = (HEAP32[tempDoublePtr >> 2] = i44 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f30 * f7);
 f26 = Math_fround(f52 * f6);
 f31 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f31 * f5);
 f32 = (HEAP32[tempDoublePtr >> 2] = i46 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(Math_fround(Math_fround(f27 - Math_fround(f32 * f6)) - Math_fround(f52 * f5)) - Math_fround(f31 * f4));
 f26 = Math_fround(Math_fround(Math_fround(f26 - Math_fround(f30 * f4)) - Math_fround(f32 * f5)) - Math_fround(f31 * f7));
 f28 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(f32 * f7)) - Math_fround(f30 * f6)) - Math_fround(f52 * f4));
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f4) - Math_fround(f30 * f5)) - Math_fround(f31 * f6)) - Math_fround(f52 * f7));
 i70 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i43 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i42 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f23 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i43 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f23 * f28);
 f29 = Math_fround(f51 * f26);
 f24 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f24 * f21);
 f25 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(Math_fround(Math_fround(f27 - Math_fround(f51 * f20)) - Math_fround(f24 * f26)) - Math_fround(f25 * f21));
 f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f25 * f28)) - Math_fround(f24 * f20)) - Math_fround(f23 * f21));
 f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f23 * f20)) - Math_fround(f51 * f28)) - Math_fround(f25 * f26));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f20) - Math_fround(f24 * f28)) - Math_fround(f51 * f21)) - Math_fround(f23 * f26));
 i70 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i42 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i43 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f26 = (HEAP32[tempDoublePtr >> 2] = i42 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f26 * f26);
 f27 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(f27 * f27);
 f28 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f28 * f28)) + Math_fround(f21 + f22)))));
 f26 = Math_fround(f22 * f26);
 f27 = Math_fround(f22 * f27);
 f28 = Math_fround(f22 * f28);
 f29 = Math_fround(f22 * f29);
 if ((i67 | 0) <= 0) {
  STACKTOP = i69;
  return;
 }
 f22 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i47 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i48 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i49 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(360.0);
 i1 = 0;
 while (1) {
  i2 = (HEAP32[i60 >> 2] | 0) + i61 | 0;
  i3 = i2 + (i62 * 40 | 0) + 16 | 0;
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f7 = Math_fround(f22 * f5);
  i15 = i2 + (i62 * 40 | 0) + 24 | 0;
  f71 = Math_fround(HEAPF32[i15 >> 2]);
  f8 = Math_fround(f52 * f71);
  i16 = i2 + (i62 * 40 | 0) + 20 | 0;
  f6 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(f21 * f6);
  i17 = i2 + (i62 * 40 | 0) + 12 | 0;
  f72 = Math_fround(HEAPF32[i17 >> 2]);
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f20 * f71)) - Math_fround(f52 * f6)) - Math_fround(f21 * f72));
  f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f22 * f72)) - Math_fround(f20 * f6)) - Math_fround(f21 * f5));
  f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f20 * f5)) - Math_fround(f22 * f71)) - Math_fround(f52 * f72));
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f72) - Math_fround(f22 * f6)) - Math_fround(f21 * f71)) - Math_fround(f52 * f5));
  i70 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i49 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f5 = (HEAP32[tempDoublePtr >> 2] = i49 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(f19 * f5);
  f7 = Math_fround(f51 * f8);
  f71 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f18 * f71);
  f72 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f51 * f72)) - Math_fround(f18 * f8)) - Math_fround(f10 * f71));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f10 * f5)) - Math_fround(f18 * f72)) - Math_fround(f19 * f71));
  f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f19 * f72)) - Math_fround(f51 * f5)) - Math_fround(f10 * f8));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f72) - Math_fround(f18 * f5)) - Math_fround(f51 * f71)) - Math_fround(f19 * f8));
  i70 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i49 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f8 = (HEAP32[tempDoublePtr >> 2] = i48 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f8 * f8);
  f4 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f71 = Math_fround(f4 * f4);
  f5 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5)) + Math_fround(f71 + f6)))));
  f7 = Math_fround(f6 * f7);
  f8 = Math_fround(Math_fround(f6 * f8) / f7);
  f71 = f9;
  f9 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(+Math_atan(+f8)) * Math_fround(2.0)) * Math_fround(57.2957802))));
  if (f9 < f66 | (i1 | 0) > 1 & f9 > f71) {
   i1 = 18;
   break;
  }
  f72 = Math_fround(Math_fround(f6 * f4) / f7);
  f71 = Math_fround(Math_fround(f6 * f5) / f7);
  f4 = Math_fround(Math_fround(f8 * f8) + Math_fround(1.0));
  f5 = Math_fround(Math_fround(f72 - Math_fround(f71 * f8)) / f4);
  f4 = Math_fround(Math_fround(f71 + Math_fround(f72 * f8)) / f4);
  if (!i1) {
   HEAPF32[i2 + (i63 * 40 | 0) + 12 >> 2] = f37;
   HEAPF32[i2 + (i63 * 40 | 0) + 16 >> 2] = f38;
   HEAPF32[i2 + (i63 * 40 | 0) + 20 >> 2] = f39;
   HEAPF32[i2 + (i63 * 40 | 0) + 24 >> 2] = f40;
   i70 = (HEAP32[i60 >> 2] | 0) + i61 | 0;
   HEAPF32[i70 + (i62 * 40 | 0) + 12 >> 2] = f26;
   HEAPF32[i70 + (i62 * 40 | 0) + 16 >> 2] = f27;
   HEAPF32[i70 + (i62 * 40 | 0) + 20 >> 2] = f28;
   HEAPF32[i70 + (i62 * 40 | 0) + 24 >> 2] = f29;
   i70 = HEAP32[i56 >> 2] | 0;
   __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i70 | 0) == 0 ? 0 : i70 + i57 | 0, i64, i65, i62, i63);
  } else {
   f71 = Math_fround(f5 + Math_fround(f4 * Math_fround(0.0)));
   f6 = Math_fround(f4 - Math_fround(f5 * Math_fround(0.0)));
   f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(1.0)) + Math_fround(Math_fround(f71 * f71) + Math_fround(0.0))))));
   f4 = Math_fround(f5 * Math_fround(0.0));
   f71 = Math_fround(f71 * f5);
   f6 = Math_fround(f6 * f5);
   f72 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f71) - Math_fround(f32 * f5)) - Math_fround(f52 * f6)) - Math_fround(f31 * f4));
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f52 * f5) - Math_fround(f30 * f4)) - Math_fround(f32 * f6)) - Math_fround(f31 * f71));
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f6) - Math_fround(f32 * f71)) - Math_fround(f30 * f5)) - Math_fround(f52 * f4));
   f71 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f4) - Math_fround(f30 * f6)) - Math_fround(f31 * f5)) - Math_fround(f52 * f71));
   i70 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
   i49 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i48 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f71 = (HEAP32[tempDoublePtr >> 2] = i49 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = Math_fround(f23 * f71);
   f72 = Math_fround(f51 * f7);
   f5 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f24 * f5);
   f4 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f51 * f4)) - Math_fround(f24 * f7)) - Math_fround(f25 * f5));
   f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f25 * f71)) - Math_fround(f24 * f4)) - Math_fround(f23 * f5));
   f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f23 * f4)) - Math_fround(f51 * f71)) - Math_fround(f25 * f7));
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f4) - Math_fround(f24 * f71)) - Math_fround(f51 * f5)) - Math_fround(f23 * f7));
   i70 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i48 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i49 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f7 = (HEAP32[tempDoublePtr >> 2] = i48 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f7 * f7);
   f8 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(f8 * f8);
   f71 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f72 * f72) + Math_fround(f71 * f71)) + Math_fround(f5 + f6)))));
   f8 = Math_fround(f6 * f8);
   f71 = Math_fround(f6 * f71);
   f72 = Math_fround(f6 * f72);
   HEAPF32[i17 >> 2] = Math_fround(f6 * f7);
   HEAPF32[i3 >> 2] = f8;
   HEAPF32[i16 >> 2] = f71;
   HEAPF32[i15 >> 2] = f72;
   i70 = HEAP32[i56 >> 2] | 0;
   __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i70 | 0) == 0 ? 0 : i70 + i57 | 0, i64, i65, i62, i62);
  }
  i47 = (HEAP32[i58 >> 2] | 0) + i59 | 0;
  f7 = Math_fround(HEAPF32[i47 + (i62 * 40 | 0) + 24 >> 2]);
  f72 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + (i62 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(f11 * f72);
  f4 = Math_fround(f12 * f7);
  f6 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + (i62 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f13 * f6);
  f73 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + (i62 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f12 * f73)) - Math_fround(f13 * f7)) - Math_fround(f14 * f6));
  f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f14 * f72)) - Math_fround(f13 * f73)) - Math_fround(f11 * f6));
  f74 = Math_fround(Math_fround(Math_fround(f74 - Math_fround(f11 * f73)) - Math_fround(f12 * f72)) - Math_fround(f14 * f7));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f73) - Math_fround(f13 * f72)) - Math_fround(f12 * f6)) - Math_fround(f11 * f7));
  i47 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i46 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAP32[i60 >> 2] | 0) + i61 | 0;
  i70 = i48 + (i63 * 40 | 0) + 12 | 0;
  f7 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(HEAPF32[i70 >> 2]);
  f8 = Math_fround(f74 * f7);
  i49 = i48 + (i63 * 40 | 0) + 24 | 0;
  f6 = Math_fround(HEAPF32[i49 >> 2]);
  f72 = Math_fround(f6 * f4);
  f73 = (HEAP32[tempDoublePtr >> 2] = i47 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i47 = i48 + (i63 * 40 | 0) + 16 | 0;
  f71 = Math_fround(HEAPF32[i47 >> 2]);
  f5 = Math_fround(f71 * f73);
  f75 = (HEAP32[tempDoublePtr >> 2] = i46 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i48 = i48 + (i63 * 40 | 0) + 20 | 0;
  f76 = Math_fround(HEAPF32[i48 >> 2]);
  f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f4 * f76)) - Math_fround(f6 * f73)) - Math_fround(f71 * f75));
  f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f74 * f75)) - Math_fround(f76 * f73)) - Math_fround(f71 * f7));
  f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f76 * f7)) - Math_fround(f74 * f4)) - Math_fround(f6 * f75));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f76 * f75) - Math_fround(f74 * f73)) - Math_fround(f4 * f71)) - Math_fround(f6 * f7));
  i46 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i44 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f7 = (HEAP32[tempDoublePtr >> 2] = i44 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f7 * f7);
  f8 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f8 * f8);
  f71 = (HEAP32[tempDoublePtr >> 2] = i46 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 + f6) + Math_fround(Math_fround(f72 * f72) + Math_fround(f71 * f71))))));
  f8 = Math_fround(f6 * f8);
  f71 = Math_fround(f6 * f71);
  f72 = Math_fround(f6 * f72);
  HEAPF32[i70 >> 2] = Math_fround(f6 * f7);
  HEAPF32[i47 >> 2] = f8;
  HEAPF32[i48 >> 2] = f71;
  HEAPF32[i49 >> 2] = f72;
  i49 = HEAP32[i56 >> 2] | 0;
  __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i((i49 | 0) == 0 ? 0 : i49 + i57 | 0, i68, i70, i63);
  i70 = HEAP32[i56 >> 2] | 0;
  __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i70 | 0) == 0 ? 0 : i70 + i57 | 0, i64, i65, i62, i63);
  i70 = (HEAP32[i58 >> 2] | 0) + i59 | 0;
  HEAP32[i70 + (i62 * 40 | 0) + 12 >> 2] = i50;
  HEAP32[i70 + (i62 * 40 | 0) + 16 >> 2] = i53;
  HEAP32[i70 + (i62 * 40 | 0) + 20 >> 2] = i54;
  HEAP32[i70 + (i62 * 40 | 0) + 24 >> 2] = i55;
  i70 = HEAP32[i56 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i70 | 0) == 0 ? 0 : i70 + i57 | 0, i65, i64, i62, i62);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i67 | 0)) {
   i1 = 18;
   break;
  }
 }
 if ((i1 | 0) == 18) {
  STACKTOP = i69;
  return;
 }
}

function __ZN5physx2Sc8ClothSim24updateRigidBodyPositionsEv(i88) {
 i88 = i88 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f105 = f0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0;
 i112 = STACKTOP;
 STACKTOP = STACKTOP + 880 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i101 = i112 + 832 | 0;
 i100 = i112 + 820 | 0;
 i111 = i112 + 808 | 0;
 i3 = i112 + 780 | 0;
 i4 = i112 + 752 | 0;
 i7 = i112 + 736 | 0;
 i40 = i112 + 708 | 0;
 i41 = i112 + 680 | 0;
 i42 = i112 + 664 | 0;
 i43 = i112 + 648 | 0;
 i45 = i112 + 640 | 0;
 i109 = i112 + 624 | 0;
 i46 = i112 + 596 | 0;
 i47 = i112 + 568 | 0;
 i48 = i112 + 552 | 0;
 i52 = i112 + 524 | 0;
 i53 = i112 + 496 | 0;
 i54 = i112 + 480 | 0;
 i55 = i112 + 464 | 0;
 i56 = i112 + 448 | 0;
 i57 = i112 + 432 | 0;
 i58 = i112 + 416 | 0;
 i72 = i112 + 400 | 0;
 i73 = i112 + 372 | 0;
 i74 = i112 + 344 | 0;
 i75 = i112 + 316 | 0;
 i77 = i112 + 296 | 0;
 i76 = i112 + 280 | 0;
 i78 = i112 + 272 | 0;
 i108 = i112 + 256 | 0;
 i99 = i112 + 244 | 0;
 i86 = i112 + 216 | 0;
 i87 = i112 + 188 | 0;
 i79 = i112 + 160 | 0;
 i85 = i112 + 148 | 0;
 i107 = i112 + 136 | 0;
 i106 = i112 + 124 | 0;
 i94 = i112 + 96 | 0;
 i95 = i112 + 68 | 0;
 i91 = i112 + 56 | 0;
 i92 = i112 + 44 | 0;
 i93 = i112 + 40 | 0;
 i96 = i112 + 28 | 0;
 i97 = i112 + 16 | 0;
 i102 = i112 + 8 | 0;
 i103 = i112;
 i104 = HEAP32[i88 + 52 >> 2] | 0;
 if (!((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(i104) | 0) & 4)) {
  STACKTOP = i112;
  return;
 }
 f105 = Math_fround(__ZNK5physx2Sc9ClothCore13getRestOffsetEv(i104));
 i1 = HEAP32[i88 + 116 >> 2] | 0;
 HEAP32[i111 >> 2] = 0;
 i44 = i111 + 4 | 0;
 HEAP32[i44 >> 2] = 0;
 i110 = i111 + 8 | 0;
 HEAP32[i110 >> 2] = 0;
 i8 = i88 + 84 | 0;
 L4 : do if (HEAP32[i8 >> 2] | 0) {
  i9 = i4 + 16 | 0;
  i14 = i3 + 16 | 0;
  i15 = i4 + 20 | 0;
  i16 = i3 + 20 | 0;
  i17 = i4 + 24 | 0;
  i18 = i3 + 24 | 0;
  i19 = i3 + 12 | 0;
  i20 = i3 + 4 | 0;
  i21 = i3 + 8 | 0;
  i22 = i7 + 4 | 0;
  i23 = i7 + 8 | 0;
  i24 = i7 + 12 | 0;
  i5 = 0;
  i6 = 0;
  i2 = 0;
  while (1) {
   i89 = HEAP32[i1 >> 2] | 0;
   i90 = HEAP32[i89 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i3, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i4, i89);
   f69 = Math_fround(HEAPF32[i9 >> 2]);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i14 >> 2]));
   f67 = Math_fround(HEAPF32[i15 >> 2]);
   f67 = Math_fround(f67 - Math_fround(HEAPF32[i16 >> 2]));
   f64 = Math_fround(HEAPF32[i17 >> 2]);
   f69 = Math_fround(f69 * Math_fround(2.0));
   f67 = Math_fround(f67 * Math_fround(2.0));
   f64 = Math_fround(Math_fround(f64 - Math_fround(HEAPF32[i18 >> 2])) * Math_fround(2.0));
   f66 = Math_fround(HEAPF32[i19 >> 2]);
   f65 = Math_fround(Math_fround(f66 * f66) + Math_fround(-.5));
   f68 = Math_fround(HEAPF32[i3 >> 2]);
   f12 = Math_fround(f69 * f68);
   f70 = Math_fround(HEAPF32[i20 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f67 * f70));
   f13 = Math_fround(HEAPF32[i21 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f64 * f13));
   f10 = Math_fround(Math_fround(f68 * f12) + Math_fround(Math_fround(f69 * f65) - Math_fround(f66 * Math_fround(Math_fround(f64 * f70) - Math_fround(f67 * f13)))));
   f11 = Math_fround(Math_fround(f70 * f12) + Math_fround(Math_fround(f67 * f65) - Math_fround(f66 * Math_fround(Math_fround(f69 * f13) - Math_fround(f64 * f68)))));
   f12 = Math_fround(Math_fround(Math_fround(f64 * f65) - Math_fround(f66 * Math_fround(Math_fround(f67 * f68) - Math_fround(f69 * f70)))) + Math_fround(f13 * f12));
   f13 = Math_fround(f105 + Math_fround(HEAPF32[i90 + 72 >> 2]));
   HEAPF32[i7 >> 2] = f10;
   HEAPF32[i22 >> 2] = f11;
   HEAPF32[i23 >> 2] = f12;
   HEAPF32[i24 >> 2] = f13;
   if ((i5 & 2147483647) >>> 0 > i6 >>> 0) {
    i90 = HEAP32[i111 >> 2] | 0;
    HEAPF32[i90 + (i6 << 4) >> 2] = f10;
    HEAPF32[i90 + (i6 << 4) + 4 >> 2] = f11;
    HEAPF32[i90 + (i6 << 4) + 8 >> 2] = f12;
    HEAPF32[i90 + (i6 << 4) + 12 >> 2] = f13;
    HEAP32[i44 >> 2] = i6 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i111, i7) | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 4 | 0;
   if (i2 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) break L4;
   i5 = HEAP32[i110 >> 2] | 0;
   i6 = HEAP32[i44 >> 2] | 0;
  }
 } while (0);
 i4 = i88 + 88 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i40 + 4 | 0;
  i6 = i40 + 8 | 0;
  i7 = i40 + 12 | 0;
  i8 = i41 + 16 | 0;
  i9 = i40 + 16 | 0;
  i14 = i41 + 20 | 0;
  i15 = i40 + 20 | 0;
  i16 = i41 + 24 | 0;
  i17 = i40 + 24 | 0;
  i18 = i41 + 12 | 0;
  i19 = i41 + 8 | 0;
  i20 = i41 + 4 | 0;
  i21 = i42 + 4 | 0;
  i22 = i42 + 8 | 0;
  i23 = i42 + 12 | 0;
  i24 = i43 + 4 | 0;
  i36 = i43 + 8 | 0;
  i37 = i43 + 12 | 0;
  i38 = 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i40, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i41, i3);
   f25 = Math_fround(-Math_fround(HEAPF32[i40 >> 2]));
   f69 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
   f70 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
   f67 = Math_fround(HEAPF32[i7 >> 2]);
   f29 = Math_fround(HEAPF32[i8 >> 2]);
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i9 >> 2]));
   f12 = Math_fround(HEAPF32[i14 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i15 >> 2]));
   f68 = Math_fround(HEAPF32[i16 >> 2]);
   f29 = Math_fround(f29 * Math_fround(2.0));
   f12 = Math_fround(f12 * Math_fround(2.0));
   f68 = Math_fround(Math_fround(f68 - Math_fround(HEAPF32[i17 >> 2])) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(f67 * f67) + Math_fround(-.5));
   f28 = Math_fround(Math_fround(Math_fround(f29 * f25) + Math_fround(f12 * f69)) + Math_fround(f68 * f70));
   f13 = Math_fround(Math_fround(f28 * f25) + Math_fround(Math_fround(f11 * f29) + Math_fround(f67 * Math_fround(Math_fround(f68 * f69) - Math_fround(f12 * f70)))));
   f26 = Math_fround(Math_fround(f28 * f69) + Math_fround(Math_fround(f11 * f12) + Math_fround(f67 * Math_fround(Math_fround(f29 * f70) - Math_fround(f68 * f25)))));
   f28 = Math_fround(Math_fround(Math_fround(f11 * f68) + Math_fround(f67 * Math_fround(Math_fround(f12 * f25) - Math_fround(f29 * f69)))) + Math_fround(f28 * f70));
   f29 = Math_fround(HEAPF32[i41 >> 2]);
   f12 = Math_fround(f67 * f29);
   f68 = Math_fround(HEAPF32[i18 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f68 * f25));
   f11 = Math_fround(HEAPF32[i19 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f11 * f69));
   f27 = Math_fround(HEAPF32[i20 >> 2]);
   f12 = Math_fround(f12 - Math_fround(f27 * f70));
   f10 = Math_fround(Math_fround(Math_fround(f29 * f70) + Math_fround(Math_fround(f68 * f69) + Math_fround(f67 * f27))) - Math_fround(f11 * f25));
   f30 = Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(Math_fround(f68 * f70) + Math_fround(f67 * f11))) - Math_fround(f29 * f69));
   f70 = Math_fround(Math_fround(Math_fround(Math_fround(f67 * f68) - Math_fround(f29 * f25)) - Math_fround(f27 * f69)) - Math_fround(f11 * f70));
   f11 = Math_fround(Math_fround(HEAPF32[i2 + 76 >> 2]) * Math_fround(2.0));
   f69 = Math_fround(Math_fround(f70 * f70) + Math_fround(-.5));
   f27 = Math_fround(f10 * Math_fround(0.0));
   f25 = Math_fround(f30 * Math_fround(0.0));
   f29 = Math_fround(f25 + Math_fround(Math_fround(f11 * f12) + f27));
   f25 = Math_fround(Math_fround(f12 * f29) + Math_fround(Math_fround(f11 * f69) + Math_fround(f70 * Math_fround(f27 - f25))));
   f69 = Math_fround(f69 * Math_fround(0.0));
   f12 = Math_fround(f12 * Math_fround(0.0));
   f27 = Math_fround(Math_fround(f69 + Math_fround(f70 * Math_fround(Math_fround(f11 * f30) - f12))) + Math_fround(f10 * f29));
   f29 = Math_fround(Math_fround(f69 + Math_fround(f70 * Math_fround(f12 - Math_fround(f11 * f10)))) + Math_fround(f30 * f29));
   f30 = Math_fround(f105 + Math_fround(HEAPF32[i2 + 72 >> 2]));
   f10 = Math_fround(f13 - f25);
   f11 = Math_fround(f26 - f27);
   f12 = Math_fround(f28 - f29);
   HEAPF32[i42 >> 2] = f10;
   HEAPF32[i21 >> 2] = f11;
   HEAPF32[i22 >> 2] = f12;
   HEAPF32[i23 >> 2] = f30;
   i2 = HEAP32[i110 >> 2] | 0;
   i3 = HEAP32[i44 >> 2] | 0;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i90 = HEAP32[i111 >> 2] | 0;
    HEAPF32[i90 + (i3 << 4) >> 2] = f10;
    HEAPF32[i90 + (i3 << 4) + 4 >> 2] = f11;
    HEAPF32[i90 + (i3 << 4) + 8 >> 2] = f12;
    HEAPF32[i90 + (i3 << 4) + 12 >> 2] = f30;
    i3 = i3 + 1 | 0;
    HEAP32[i44 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i111, i42) | 0;
    i2 = HEAP32[i110 >> 2] | 0;
    i3 = HEAP32[i44 >> 2] | 0;
   }
   f12 = Math_fround(f13 + f25);
   f11 = Math_fround(f26 + f27);
   f10 = Math_fround(f28 + f29);
   HEAPF32[i43 >> 2] = f12;
   HEAPF32[i24 >> 2] = f11;
   HEAPF32[i36 >> 2] = f10;
   HEAPF32[i37 >> 2] = f30;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i90 = HEAP32[i111 >> 2] | 0;
    HEAPF32[i90 + (i3 << 4) >> 2] = f12;
    HEAPF32[i90 + (i3 << 4) + 4 >> 2] = f11;
    HEAPF32[i90 + (i3 << 4) + 8 >> 2] = f10;
    HEAPF32[i90 + (i3 << 4) + 12 >> 2] = f30;
    HEAP32[i44 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i111, i43) | 0;
   i38 = i38 + 1 | 0;
   i1 = i1 + 4 | 0;
  } while (i38 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i71 = HEAP32[i104 + 72 >> 2] | 0;
 i90 = HEAP32[i44 >> 2] | 0;
 i89 = i104 + 28 | 0;
 i3 = HEAP32[i89 >> 2] | 0;
 i84 = HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0;
 i83 = HEAP32[i111 >> 2] | 0;
 HEAP32[i45 >> 2] = i83;
 HEAP32[i45 + 4 >> 2] = i83 + (i90 << 4);
 HEAP32[i101 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i101 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 mftCall_viiii(i84 | 0, i3 | 0, i101 | 0, i71 | 0, i90 + i71 | 0);
 HEAP32[i109 >> 2] = 0;
 i71 = i109 + 4 | 0;
 HEAP32[i71 >> 2] = 0;
 i90 = i109 + 8 | 0;
 HEAP32[i90 >> 2] = 0;
 i3 = i88 + 92 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i46 + 4 | 0;
  i5 = i46 + 8 | 0;
  i6 = i46 + 12 | 0;
  i7 = i47 + 16 | 0;
  i8 = i46 + 16 | 0;
  i9 = i47 + 20 | 0;
  i14 = i46 + 20 | 0;
  i15 = i47 + 24 | 0;
  i16 = i46 + 24 | 0;
  i17 = i47 + 12 | 0;
  i18 = i47 + 8 | 0;
  i19 = i47 + 4 | 0;
  i20 = i48 + 4 | 0;
  i21 = i48 + 8 | 0;
  i22 = i48 + 12 | 0;
  i23 = 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i46, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i47, i2);
   f12 = Math_fround(-Math_fround(HEAPF32[i46 >> 2]));
   f11 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
   f65 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
   f61 = Math_fround(HEAPF32[i6 >> 2]);
   f63 = Math_fround(HEAPF32[i7 >> 2]);
   f63 = Math_fround(f63 - Math_fround(HEAPF32[i8 >> 2]));
   f66 = Math_fround(HEAPF32[i9 >> 2]);
   f66 = Math_fround(f66 - Math_fround(HEAPF32[i14 >> 2]));
   f62 = Math_fround(HEAPF32[i15 >> 2]);
   f63 = Math_fround(f63 * Math_fround(2.0));
   f66 = Math_fround(f66 * Math_fround(2.0));
   f62 = Math_fround(Math_fround(f62 - Math_fround(HEAPF32[i16 >> 2])) * Math_fround(2.0));
   f64 = Math_fround(Math_fround(f61 * f61) + Math_fround(-.5));
   f69 = Math_fround(Math_fround(Math_fround(f63 * f12) + Math_fround(f66 * f11)) + Math_fround(f62 * f65));
   f70 = Math_fround(Math_fround(f69 * f12) + Math_fround(Math_fround(f64 * f63) + Math_fround(f61 * Math_fround(Math_fround(f62 * f11) - Math_fround(f66 * f65)))));
   f13 = Math_fround(Math_fround(f69 * f11) + Math_fround(Math_fround(f64 * f66) + Math_fround(f61 * Math_fround(Math_fround(f63 * f65) - Math_fround(f62 * f12)))));
   f69 = Math_fround(Math_fround(Math_fround(f64 * f62) + Math_fround(f61 * Math_fround(Math_fround(f66 * f12) - Math_fround(f63 * f11)))) + Math_fround(f69 * f65));
   f63 = Math_fround(HEAPF32[i47 >> 2]);
   f66 = Math_fround(f61 * f63);
   f62 = Math_fround(HEAPF32[i17 >> 2]);
   f66 = Math_fround(f66 + Math_fround(f62 * f12));
   f64 = Math_fround(HEAPF32[i18 >> 2]);
   f66 = Math_fround(f66 + Math_fround(f64 * f11));
   f10 = Math_fround(HEAPF32[i19 >> 2]);
   f66 = Math_fround(f66 - Math_fround(f10 * f65));
   f67 = Math_fround(Math_fround(Math_fround(f63 * f65) + Math_fround(Math_fround(f62 * f11) + Math_fround(f61 * f10))) - Math_fround(f64 * f12));
   f68 = Math_fround(Math_fround(Math_fround(f10 * f12) + Math_fround(Math_fround(f62 * f65) + Math_fround(f61 * f64))) - Math_fround(f63 * f11));
   f65 = Math_fround(Math_fround(Math_fround(Math_fround(f61 * f62) - Math_fround(f63 * f12)) - Math_fround(f10 * f11)) - Math_fround(f64 * f65));
   f64 = Math_fround(Math_fround(f65 * f65) + Math_fround(-.5));
   f11 = Math_fround(f67 * Math_fround(0.0));
   f10 = Math_fround(f68 * Math_fround(0.0));
   f12 = Math_fround(f10 + Math_fround(Math_fround(f66 * Math_fround(2.0)) + f11));
   f10 = Math_fround(Math_fround(f66 * f12) + Math_fround(Math_fround(f64 * Math_fround(2.0)) + Math_fround(f65 * Math_fround(f11 - f10))));
   f64 = Math_fround(f64 * Math_fround(0.0));
   f66 = Math_fround(f66 * Math_fround(0.0));
   f11 = Math_fround(Math_fround(f64 + Math_fround(f65 * Math_fround(Math_fround(f68 * Math_fround(2.0)) - f66))) + Math_fround(f67 * f12));
   f12 = Math_fround(Math_fround(f64 + Math_fround(f65 * Math_fround(f66 - Math_fround(f67 * Math_fround(2.0))))) + Math_fround(f68 * f12));
   f13 = Math_fround(Math_fround(0.0) - Math_fround(Math_fround(f69 * f12) + Math_fround(Math_fround(f70 * f10) + Math_fround(f13 * f11))));
   HEAPF32[i48 >> 2] = f10;
   HEAPF32[i20 >> 2] = f11;
   HEAPF32[i21 >> 2] = f12;
   f13 = Math_fround(f13 - f105);
   HEAPF32[i22 >> 2] = f13;
   i2 = HEAP32[i71 >> 2] | 0;
   if ((HEAP32[i90 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i2 << 4) >> 2] = f10;
    HEAPF32[i84 + (i2 << 4) + 4 >> 2] = f11;
    HEAPF32[i84 + (i2 << 4) + 8 >> 2] = f12;
    HEAPF32[i84 + (i2 << 4) + 12 >> 2] = f13;
    HEAP32[i71 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i48) | 0;
   i23 = i23 + 1 | 0;
   i1 = i1 + 4 | 0;
  } while (i23 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i4 = i88 + 96 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i52 + 4 | 0;
  i6 = i52 + 8 | 0;
  i7 = i52 + 12 | 0;
  i8 = i53 + 16 | 0;
  i9 = i52 + 16 | 0;
  i14 = i53 + 20 | 0;
  i15 = i52 + 20 | 0;
  i16 = i53 + 24 | 0;
  i17 = i52 + 24 | 0;
  i18 = i53 + 12 | 0;
  i19 = i53 + 8 | 0;
  i20 = i53 + 4 | 0;
  i21 = i54 + 4 | 0;
  i22 = i54 + 8 | 0;
  i23 = i54 + 12 | 0;
  i24 = i55 + 4 | 0;
  i36 = i55 + 8 | 0;
  i37 = i55 + 12 | 0;
  i38 = i56 + 4 | 0;
  i40 = i56 + 8 | 0;
  i41 = i56 + 12 | 0;
  i42 = i57 + 4 | 0;
  i43 = i57 + 8 | 0;
  i44 = i57 + 12 | 0;
  i45 = i58 + 4 | 0;
  i46 = i58 + 8 | 0;
  i47 = i58 + 12 | 0;
  i48 = i72 + 4 | 0;
  i49 = i72 + 8 | 0;
  i50 = i72 + 12 | 0;
  i51 = 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i52, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i53, i3);
   f25 = Math_fround(-Math_fround(HEAPF32[i52 >> 2]));
   f28 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
   f64 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
   f65 = Math_fround(HEAPF32[i7 >> 2]);
   f34 = Math_fround(HEAPF32[i8 >> 2]);
   f34 = Math_fround(f34 - Math_fround(HEAPF32[i9 >> 2]));
   f62 = Math_fround(HEAPF32[i14 >> 2]);
   f62 = Math_fround(f62 - Math_fround(HEAPF32[i15 >> 2]));
   f35 = Math_fround(HEAPF32[i16 >> 2]);
   f34 = Math_fround(f34 * Math_fround(2.0));
   f62 = Math_fround(f62 * Math_fround(2.0));
   f35 = Math_fround(Math_fround(f35 - Math_fround(HEAPF32[i17 >> 2])) * Math_fround(2.0));
   f27 = Math_fround(Math_fround(f65 * f65) + Math_fround(-.5));
   f70 = Math_fround(Math_fround(Math_fround(f34 * f25) + Math_fround(f62 * f28)) + Math_fround(f35 * f64));
   f68 = Math_fround(Math_fround(f70 * f25) + Math_fround(Math_fround(f27 * f34) + Math_fround(f65 * Math_fround(Math_fround(f35 * f28) - Math_fround(f62 * f64)))));
   f69 = Math_fround(Math_fround(f70 * f28) + Math_fround(Math_fround(f27 * f62) + Math_fround(f65 * Math_fround(Math_fround(f34 * f64) - Math_fround(f35 * f25)))));
   f70 = Math_fround(Math_fround(Math_fround(f27 * f35) + Math_fround(f65 * Math_fround(Math_fround(f62 * f25) - Math_fround(f34 * f28)))) + Math_fround(f70 * f64));
   f34 = Math_fround(HEAPF32[i53 >> 2]);
   f62 = Math_fround(f65 * f34);
   f35 = Math_fround(HEAPF32[i18 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f35 * f25));
   f27 = Math_fround(HEAPF32[i19 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f27 * f28));
   f29 = Math_fround(HEAPF32[i20 >> 2]);
   f62 = Math_fround(f62 - Math_fround(f29 * f64));
   f63 = Math_fround(Math_fround(Math_fround(f34 * f64) + Math_fround(Math_fround(f35 * f28) + Math_fround(f65 * f29))) - Math_fround(f27 * f25));
   f67 = Math_fround(Math_fround(Math_fround(f29 * f25) + Math_fround(Math_fround(f35 * f64) + Math_fround(f65 * f27))) - Math_fround(f34 * f28));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f65 * f35) - Math_fround(f34 * f25)) - Math_fround(f29 * f28)) - Math_fround(f27 * f64));
   f27 = Math_fround(f105 + Math_fround(HEAPF32[i2 + 72 >> 2]));
   f28 = Math_fround(f105 + Math_fround(HEAPF32[i2 + 76 >> 2]));
   f29 = Math_fround(f105 + Math_fround(HEAPF32[i2 + 80 >> 2]));
   f27 = Math_fround(-f27);
   f25 = Math_fround(Math_fround(f64 * f64) + Math_fround(-.5));
   f34 = Math_fround(f62 * Math_fround(2.0));
   f35 = Math_fround(f63 * Math_fround(0.0));
   f65 = Math_fround(f67 * Math_fround(0.0));
   f12 = Math_fround(f65 + Math_fround(f34 + f35));
   f61 = Math_fround(f25 * Math_fround(2.0));
   f26 = Math_fround(f64 * Math_fround(f35 - f65));
   f10 = Math_fround(Math_fround(f62 * f12) + Math_fround(f61 + f26));
   f66 = Math_fround(f25 * Math_fround(0.0));
   f32 = Math_fround(f67 * Math_fround(2.0));
   f39 = Math_fround(f62 * Math_fround(0.0));
   f11 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f32 - f39))) + Math_fround(f63 * f12));
   f33 = Math_fround(f63 * Math_fround(2.0));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f39 - f33))) + Math_fround(f67 * f12));
   f13 = Math_fround(f27 - Math_fround(Math_fround(f70 * f12) + Math_fround(Math_fround(f68 * f10) + Math_fround(f69 * f11))));
   HEAPF32[i54 >> 2] = f10;
   HEAPF32[i21 >> 2] = f11;
   HEAPF32[i22 >> 2] = f12;
   HEAPF32[i23 >> 2] = f13;
   i2 = HEAP32[i90 >> 2] | 0;
   i3 = HEAP32[i71 >> 2] | 0;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f10;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f11;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f13;
    i3 = i3 + 1 | 0;
    HEAP32[i71 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i54) | 0;
    i2 = HEAP32[i90 >> 2] | 0;
    i3 = HEAP32[i71 >> 2] | 0;
   }
   f59 = Math_fround(f62 * Math_fround(-2.0));
   f13 = Math_fround(f65 + Math_fround(f59 + f35));
   f60 = Math_fround(f25 * Math_fround(-2.0));
   f11 = Math_fround(Math_fround(f62 * f13) + Math_fround(f60 + f26));
   f30 = Math_fround(f67 * Math_fround(-2.0));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f30 - f39))) + Math_fround(f63 * f13));
   f31 = Math_fround(f63 * Math_fround(-2.0));
   f13 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f39 - f31))) + Math_fround(f67 * f13));
   f10 = Math_fround(f27 - Math_fround(Math_fround(f70 * f13) + Math_fround(Math_fround(f68 * f11) + Math_fround(f69 * f12))));
   HEAPF32[i55 >> 2] = f11;
   HEAPF32[i24 >> 2] = f12;
   HEAPF32[i36 >> 2] = f13;
   HEAPF32[i37 >> 2] = f10;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f11;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f13;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f10;
    i3 = i3 + 1 | 0;
    HEAP32[i71 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i55) | 0;
    i2 = HEAP32[i90 >> 2] | 0;
    i3 = HEAP32[i71 >> 2] | 0;
   }
   f26 = Math_fround(-f28);
   f12 = Math_fround(f65 + Math_fround(f39 + f33));
   f10 = Math_fround(Math_fround(f62 * f12) + Math_fround(f66 + Math_fround(f64 * Math_fround(f35 - f32))));
   f25 = Math_fround(f64 * Math_fround(f65 - f39));
   f11 = Math_fround(Math_fround(f61 + f25) + Math_fround(f63 * f12));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f34 - f35))) + Math_fround(f67 * f12));
   f13 = Math_fround(f26 - Math_fround(Math_fround(f70 * f12) + Math_fround(Math_fround(f68 * f10) + Math_fround(f69 * f11))));
   HEAPF32[i56 >> 2] = f10;
   HEAPF32[i38 >> 2] = f11;
   HEAPF32[i40 >> 2] = f12;
   HEAPF32[i41 >> 2] = f13;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f10;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f11;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f13;
    i3 = i3 + 1 | 0;
    HEAP32[i71 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i56) | 0;
    i2 = HEAP32[i90 >> 2] | 0;
    i3 = HEAP32[i71 >> 2] | 0;
   }
   f12 = Math_fround(f65 + Math_fround(f39 + f31));
   f13 = Math_fround(Math_fround(f62 * f12) + Math_fround(f66 + Math_fround(f64 * Math_fround(f35 - f30))));
   f11 = Math_fround(Math_fround(f60 + f25) + Math_fround(f63 * f12));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f59 - f35))) + Math_fround(f67 * f12));
   f10 = Math_fround(f26 - Math_fround(Math_fround(f70 * f12) + Math_fround(Math_fround(f68 * f13) + Math_fround(f69 * f11))));
   HEAPF32[i57 >> 2] = f13;
   HEAPF32[i42 >> 2] = f11;
   HEAPF32[i43 >> 2] = f12;
   HEAPF32[i44 >> 2] = f10;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f13;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f11;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f10;
    i3 = i3 + 1 | 0;
    HEAP32[i71 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i57) | 0;
    i2 = HEAP32[i90 >> 2] | 0;
    i3 = HEAP32[i71 >> 2] | 0;
   }
   f27 = Math_fround(-f29);
   f26 = Math_fround(f39 + f35);
   f10 = Math_fround(f32 + f26);
   f13 = Math_fround(Math_fround(f62 * f10) + Math_fround(f66 + Math_fround(f64 * Math_fround(f33 - f65))));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f65 - f34))) + Math_fround(f63 * f10));
   f25 = Math_fround(f64 * Math_fround(f39 - f35));
   f10 = Math_fround(Math_fround(f61 + f25) + Math_fround(f67 * f10));
   f11 = Math_fround(f27 - Math_fround(Math_fround(f70 * f10) + Math_fround(Math_fround(f68 * f13) + Math_fround(f69 * f12))));
   HEAPF32[i58 >> 2] = f13;
   HEAPF32[i45 >> 2] = f12;
   HEAPF32[i46 >> 2] = f10;
   HEAPF32[i47 >> 2] = f11;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f13;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f10;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f11;
    i3 = i3 + 1 | 0;
    HEAP32[i71 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i58) | 0;
    i2 = HEAP32[i90 >> 2] | 0;
    i3 = HEAP32[i71 >> 2] | 0;
   }
   f11 = Math_fround(f30 + f26);
   f13 = Math_fround(Math_fround(f62 * f11) + Math_fround(f66 + Math_fround(f64 * Math_fround(f31 - f65))));
   f12 = Math_fround(Math_fround(f66 + Math_fround(f64 * Math_fround(f65 - f59))) + Math_fround(f63 * f11));
   f11 = Math_fround(Math_fround(f60 + f25) + Math_fround(f67 * f11));
   f10 = Math_fround(f27 - Math_fround(Math_fround(f70 * f11) + Math_fround(Math_fround(f68 * f13) + Math_fround(f69 * f12))));
   HEAPF32[i72 >> 2] = f13;
   HEAPF32[i48 >> 2] = f12;
   HEAPF32[i49 >> 2] = f11;
   HEAPF32[i50 >> 2] = f10;
   if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
    i84 = HEAP32[i109 >> 2] | 0;
    HEAPF32[i84 + (i3 << 4) >> 2] = f13;
    HEAPF32[i84 + (i3 << 4) + 4 >> 2] = f12;
    HEAPF32[i84 + (i3 << 4) + 8 >> 2] = f11;
    HEAPF32[i84 + (i3 << 4) + 12 >> 2] = f10;
    HEAP32[i71 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i72) | 0;
   i51 = i51 + 1 | 0;
   i1 = i1 + 4 | 0;
  } while (i51 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i6 = i88 + 100 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i74 + 4 | 0;
  i8 = i74 + 8 | 0;
  i9 = i74 + 12 | 0;
  i14 = i75 + 16 | 0;
  i15 = i74 + 16 | 0;
  i16 = i75 + 20 | 0;
  i17 = i74 + 20 | 0;
  i18 = i75 + 24 | 0;
  i19 = i74 + 24 | 0;
  i20 = i75 + 12 | 0;
  i21 = i75 + 8 | 0;
  i22 = i75 + 4 | 0;
  i23 = i73 + 4 | 0;
  i24 = i73 + 8 | 0;
  i36 = i73 + 12 | 0;
  i37 = i73 + 16 | 0;
  i38 = i73 + 20 | 0;
  i40 = i73 + 24 | 0;
  i41 = i101 + 4 | 0;
  i42 = i101 + 8 | 0;
  i43 = i77 + 4 | 0;
  i44 = i101 + 12 | 0;
  i45 = i101 + 16 | 0;
  i46 = i101 + 20 | 0;
  i47 = i77 + 8 | 0;
  i48 = i101 + 24 | 0;
  i49 = i101 + 28 | 0;
  i50 = i101 + 32 | 0;
  i51 = i77 + 12 | 0;
  i52 = i101 + 36 | 0;
  i53 = i101 + 40 | 0;
  i54 = i101 + 44 | 0;
  i55 = i76 + 4 | 0;
  i56 = i76 + 8 | 0;
  i57 = i76 + 12 | 0;
  i58 = 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i74, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i75, i3);
   f60 = Math_fround(-Math_fround(HEAPF32[i74 >> 2]));
   f61 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
   f64 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
   f35 = Math_fround(HEAPF32[i9 >> 2]);
   f59 = Math_fround(HEAPF32[i14 >> 2]);
   f59 = Math_fround(f59 - Math_fround(HEAPF32[i15 >> 2]));
   f62 = Math_fround(HEAPF32[i16 >> 2]);
   f62 = Math_fround(f62 - Math_fround(HEAPF32[i17 >> 2]));
   f39 = Math_fround(HEAPF32[i18 >> 2]);
   f59 = Math_fround(f59 * Math_fround(2.0));
   f62 = Math_fround(f62 * Math_fround(2.0));
   f39 = Math_fround(Math_fround(f39 - Math_fround(HEAPF32[i19 >> 2])) * Math_fround(2.0));
   f67 = Math_fround(Math_fround(f35 * f35) + Math_fround(-.5));
   f70 = Math_fround(Math_fround(Math_fround(f59 * f60) + Math_fround(f62 * f61)) + Math_fround(f39 * f64));
   f68 = Math_fround(Math_fround(f70 * f60) + Math_fround(Math_fround(f67 * f59) + Math_fround(f35 * Math_fround(Math_fround(f39 * f61) - Math_fround(f62 * f64)))));
   f69 = Math_fround(Math_fround(f70 * f61) + Math_fround(Math_fround(f67 * f62) + Math_fround(f35 * Math_fround(Math_fround(f59 * f64) - Math_fround(f39 * f60)))));
   f70 = Math_fround(Math_fround(Math_fround(f67 * f39) + Math_fround(f35 * Math_fround(Math_fround(f62 * f60) - Math_fround(f59 * f61)))) + Math_fround(f70 * f64));
   f59 = Math_fround(HEAPF32[i75 >> 2]);
   f62 = Math_fround(f35 * f59);
   f39 = Math_fround(HEAPF32[i20 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f39 * f60));
   f67 = Math_fround(HEAPF32[i21 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f67 * f61));
   f63 = Math_fround(HEAPF32[i22 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f59 * f64) + Math_fround(Math_fround(f39 * f61) + Math_fround(f35 * f63))) - Math_fround(f67 * f60));
   f66 = Math_fround(Math_fround(Math_fround(f63 * f60) + Math_fround(Math_fround(f39 * f64) + Math_fround(f35 * f67))) - Math_fround(f59 * f61));
   f67 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f39) - Math_fround(f59 * f60)) - Math_fround(f63 * f61)) - Math_fround(f67 * f64));
   HEAPF32[i73 >> 2] = Math_fround(f62 - Math_fround(f63 * f64));
   HEAPF32[i23 >> 2] = f65;
   HEAPF32[i24 >> 2] = f66;
   HEAPF32[i36 >> 2] = f67;
   HEAPF32[i37 >> 2] = f68;
   HEAPF32[i38 >> 2] = f69;
   HEAPF32[i40 >> 2] = f70;
   __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i101, i73, i2 + 72 | 0);
   i2 = i2 + 100 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
   if (i3 | 0) {
    f10 = Math_fround(HEAPF32[i101 >> 2]);
    f11 = Math_fround(HEAPF32[i41 >> 2]);
    f12 = Math_fround(HEAPF32[i42 >> 2]);
    f13 = Math_fround(HEAPF32[i44 >> 2]);
    f25 = Math_fround(HEAPF32[i45 >> 2]);
    f26 = Math_fround(HEAPF32[i46 >> 2]);
    f27 = Math_fround(HEAPF32[i48 >> 2]);
    f28 = Math_fround(HEAPF32[i49 >> 2]);
    f29 = Math_fround(HEAPF32[i50 >> 2]);
    f30 = Math_fround(HEAPF32[i52 >> 2]);
    f31 = Math_fround(HEAPF32[i53 >> 2]);
    f32 = Math_fround(HEAPF32[i54 >> 2]);
    i5 = 0;
    do {
     i4 = HEAP32[i2 >> 2] | 0;
     mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i5 | 0, i77 | 0) | 0;
     f35 = Math_fround(HEAPF32[i77 >> 2]);
     f33 = Math_fround(f35 * f10);
     f34 = Math_fround(f35 * f11);
     f35 = Math_fround(f35 * f12);
     f39 = Math_fround(HEAPF32[i43 >> 2]);
     f33 = Math_fround(f33 + Math_fround(f39 * f13));
     f34 = Math_fround(f34 + Math_fround(f39 * f25));
     f39 = Math_fround(f35 + Math_fround(f39 * f26));
     f35 = Math_fround(HEAPF32[i47 >> 2]);
     f33 = Math_fround(f33 + Math_fround(f35 * f27));
     f34 = Math_fround(f34 + Math_fround(f35 * f28));
     f35 = Math_fround(f39 + Math_fround(f35 * f29));
     f39 = Math_fround(Math_fround(Math_fround(HEAPF32[i51 >> 2]) - Math_fround(Math_fround(Math_fround(f33 * f30) + Math_fround(f34 * f31)) + Math_fround(f35 * f32))) - f105);
     HEAPF32[i76 >> 2] = f33;
     HEAPF32[i55 >> 2] = f34;
     HEAPF32[i56 >> 2] = f35;
     HEAPF32[i57 >> 2] = f39;
     i4 = HEAP32[i71 >> 2] | 0;
     if ((HEAP32[i90 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i84 = HEAP32[i109 >> 2] | 0;
      HEAPF32[i84 + (i4 << 4) >> 2] = f33;
      HEAPF32[i84 + (i4 << 4) + 4 >> 2] = f34;
      HEAPF32[i84 + (i4 << 4) + 8 >> 2] = f35;
      HEAPF32[i84 + (i4 << 4) + 12 >> 2] = f39;
      HEAP32[i71 >> 2] = i4 + 1;
     } else __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i109, i76) | 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i3 | 0));
   }
   i58 = i58 + 1 | 0;
   i1 = i1 + 4 | 0;
  } while (i58 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i80 = HEAP32[i104 + 80 >> 2] | 0;
 i83 = HEAP32[i71 >> 2] | 0;
 i81 = HEAP32[i89 >> 2] | 0;
 i84 = HEAP32[(HEAP32[i81 >> 2] | 0) + 180 >> 2] | 0;
 i82 = HEAP32[i109 >> 2] | 0;
 HEAP32[i78 >> 2] = i82;
 HEAP32[i78 + 4 >> 2] = i82 + (i83 << 4);
 HEAP32[i101 >> 2] = HEAP32[i78 >> 2];
 HEAP32[i101 + 4 >> 2] = HEAP32[i78 + 4 >> 2];
 mftCall_viiii(i84 | 0, i81 | 0, i101 | 0, i80 | 0, i83 + i80 | 0);
 HEAP32[i108 >> 2] = 0;
 i80 = i108 + 4 | 0;
 HEAP32[i80 >> 2] = 0;
 i83 = i108 + 8 | 0;
 HEAP32[i83 >> 2] = 0;
 HEAP32[i99 >> 2] = 0;
 i81 = i99 + 4 | 0;
 HEAP32[i81 >> 2] = 0;
 i84 = i99 + 8 | 0;
 HEAP32[i84 >> 2] = 0;
 i82 = i88 + 104 | 0;
 if (HEAP32[i82 >> 2] | 0) {
  i74 = i86 + 4 | 0;
  i16 = i86 + 8 | 0;
  i17 = i86 + 12 | 0;
  i18 = i87 + 16 | 0;
  i19 = i86 + 16 | 0;
  i20 = i87 + 20 | 0;
  i21 = i86 + 20 | 0;
  i22 = i87 + 24 | 0;
  i23 = i86 + 24 | 0;
  i24 = i87 + 12 | 0;
  i36 = i87 + 8 | 0;
  i37 = i87 + 4 | 0;
  i38 = i79 + 4 | 0;
  i40 = i79 + 8 | 0;
  i41 = i79 + 12 | 0;
  i42 = i79 + 16 | 0;
  i43 = i79 + 20 | 0;
  i44 = i79 + 24 | 0;
  i45 = i88 + 128 | 0;
  i46 = i101 + 4 | 0;
  i47 = i101 + 8 | 0;
  i48 = i101 + 12 | 0;
  i49 = i101 + 16 | 0;
  i50 = i101 + 20 | 0;
  i51 = i101 + 24 | 0;
  i52 = i101 + 28 | 0;
  i53 = i101 + 32 | 0;
  i54 = i101 + 36 | 0;
  i55 = i101 + 40 | 0;
  i56 = i101 + 44 | 0;
  i57 = i101 + 12 | 0;
  i58 = i101 + 24 | 0;
  i71 = i101 + 36 | 0;
  i72 = i85 + 4 | 0;
  i73 = i85 + 8 | 0;
  i75 = 0;
  do {
   i15 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i15 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i86, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i87, i15);
   f60 = Math_fround(-Math_fround(HEAPF32[i86 >> 2]));
   f61 = Math_fround(-Math_fround(HEAPF32[i74 >> 2]));
   f64 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
   f35 = Math_fround(HEAPF32[i17 >> 2]);
   f59 = Math_fround(HEAPF32[i18 >> 2]);
   f59 = Math_fround(f59 - Math_fround(HEAPF32[i19 >> 2]));
   f62 = Math_fround(HEAPF32[i20 >> 2]);
   f62 = Math_fround(f62 - Math_fround(HEAPF32[i21 >> 2]));
   f39 = Math_fround(HEAPF32[i22 >> 2]);
   f59 = Math_fround(f59 * Math_fround(2.0));
   f62 = Math_fround(f62 * Math_fround(2.0));
   f39 = Math_fround(Math_fround(f39 - Math_fround(HEAPF32[i23 >> 2])) * Math_fround(2.0));
   f67 = Math_fround(Math_fround(f35 * f35) + Math_fround(-.5));
   f70 = Math_fround(Math_fround(Math_fround(f59 * f60) + Math_fround(f62 * f61)) + Math_fround(f39 * f64));
   f68 = Math_fround(Math_fround(f70 * f60) + Math_fround(Math_fround(f67 * f59) + Math_fround(f35 * Math_fround(Math_fround(f39 * f61) - Math_fround(f62 * f64)))));
   f69 = Math_fround(Math_fround(f70 * f61) + Math_fround(Math_fround(f67 * f62) + Math_fround(f35 * Math_fround(Math_fround(f59 * f64) - Math_fround(f39 * f60)))));
   f70 = Math_fround(Math_fround(Math_fround(f67 * f39) + Math_fround(f35 * Math_fround(Math_fround(f62 * f60) - Math_fround(f59 * f61)))) + Math_fround(f70 * f64));
   f59 = Math_fround(HEAPF32[i87 >> 2]);
   f62 = Math_fround(f35 * f59);
   f39 = Math_fround(HEAPF32[i24 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f39 * f60));
   f67 = Math_fround(HEAPF32[i36 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f67 * f61));
   f63 = Math_fround(HEAPF32[i37 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f59 * f64) + Math_fround(Math_fround(f39 * f61) + Math_fround(f35 * f63))) - Math_fround(f67 * f60));
   f66 = Math_fround(Math_fround(Math_fround(f63 * f60) + Math_fround(Math_fround(f39 * f64) + Math_fround(f35 * f67))) - Math_fround(f59 * f61));
   f67 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f39) - Math_fround(f59 * f60)) - Math_fround(f63 * f61)) - Math_fround(f67 * f64));
   HEAPF32[i79 >> 2] = Math_fround(f62 - Math_fround(f63 * f64));
   HEAPF32[i38 >> 2] = f65;
   HEAPF32[i40 >> 2] = f66;
   HEAPF32[i41 >> 2] = f67;
   HEAPF32[i42 >> 2] = f68;
   HEAPF32[i43 >> 2] = f69;
   HEAPF32[i44 >> 2] = f70;
   __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i101, i79, i2 + 72 | 0);
   i15 = HEAP32[i80 >> 2] | 0;
   i2 = i2 + 104 | 0;
   i78 = HEAP32[i2 >> 2] | 0;
   i78 = ((mftCall_ii(HEAP32[(HEAP32[i78 >> 2] | 0) + 40 >> 2] | 0, i78 | 0) | 0) & 2) == 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0;
   i14 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
   if (i78) {
    i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0;
    if (i9 | 0) {
     i8 = 0;
     do {
      i6 = i8 * 3 | 0;
      i2 = HEAP32[i14 + (i6 << 2) >> 2] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      i4 = HEAP32[i83 >> 2] | 0;
      i5 = HEAP32[i80 >> 2] | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       i5 = i5 + 1 | 0;
       HEAP32[i80 >> 2] = i5;
      } else {
       __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
       i4 = HEAP32[i83 >> 2] | 0;
       i5 = HEAP32[i80 >> 2] | 0;
      }
      i2 = HEAP32[i14 + (i6 + 1 << 2) >> 2] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       i5 = i5 + 1 | 0;
       HEAP32[i80 >> 2] = i5;
      } else {
       __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
       i4 = HEAP32[i83 >> 2] | 0;
       i5 = HEAP32[i80 >> 2] | 0;
      }
      i2 = HEAP32[i14 + (i6 + 2 << 2) >> 2] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       HEAP32[i80 >> 2] = i5 + 1;
      } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i9 | 0));
    }
   } else {
    i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0;
    if (i9 | 0) {
     i8 = 0;
     do {
      i6 = i8 * 3 | 0;
      i2 = HEAPU16[i14 + (i6 << 1) >> 1] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      i4 = HEAP32[i83 >> 2] | 0;
      i5 = HEAP32[i80 >> 2] | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       i5 = i5 + 1 | 0;
       HEAP32[i80 >> 2] = i5;
      } else {
       __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
       i4 = HEAP32[i83 >> 2] | 0;
       i5 = HEAP32[i80 >> 2] | 0;
      }
      i2 = HEAPU16[i14 + (i6 + 1 << 1) >> 1] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       i5 = i5 + 1 | 0;
       HEAP32[i80 >> 2] = i5;
      } else {
       __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
       i4 = HEAP32[i83 >> 2] | 0;
       i5 = HEAP32[i80 >> 2] | 0;
      }
      i2 = HEAPU16[i14 + (i6 + 2 << 1) >> 1] | 0;
      i3 = i7 + (i2 * 12 | 0) | 0;
      if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
       i78 = HEAP32[i108 >> 2] | 0;
       HEAP32[i78 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i78 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2];
       HEAP32[i80 >> 2] = i5 + 1;
      } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i9 | 0));
    }
   }
   i3 = HEAP32[i45 >> 2] | 0;
   i113 = i3 + (i75 * 48 | 0) | 0;
   f39 = Math_fround(HEAPF32[i113 >> 2]);
   i4 = i3 + (i75 * 48 | 0) + 4 | 0;
   f59 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i3 + (i75 * 48 | 0) + 8 | 0;
   f60 = Math_fround(HEAPF32[i5 >> 2]);
   i6 = i3 + (i75 * 48 | 0) + 12 | 0;
   f61 = Math_fround(HEAPF32[i6 >> 2]);
   i7 = i3 + (i75 * 48 | 0) + 16 | 0;
   f62 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i3 + (i75 * 48 | 0) + 20 | 0;
   f63 = Math_fround(HEAPF32[i8 >> 2]);
   i9 = i3 + (i75 * 48 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i9 >> 2]);
   i14 = i3 + (i75 * 48 | 0) + 28 | 0;
   f65 = Math_fround(HEAPF32[i14 >> 2]);
   i76 = i3 + (i75 * 48 | 0) + 32 | 0;
   f66 = Math_fround(HEAPF32[i76 >> 2]);
   i77 = i3 + (i75 * 48 | 0) + 36 | 0;
   f67 = Math_fround(HEAPF32[i77 >> 2]);
   i78 = i3 + (i75 * 48 | 0) + 40 | 0;
   f68 = Math_fround(HEAPF32[i78 >> 2]);
   i3 = i3 + (i75 * 48 | 0) + 44 | 0;
   f69 = Math_fround(HEAPF32[i3 >> 2]);
   i114 = HEAP32[i101 >> 2] | 0;
   HEAP32[i113 >> 2] = i114;
   i113 = HEAP32[i46 >> 2] | 0;
   HEAP32[i4 >> 2] = i113;
   i4 = HEAP32[i47 >> 2] | 0;
   HEAP32[i5 >> 2] = i4;
   i5 = HEAP32[i48 >> 2] | 0;
   HEAP32[i6 >> 2] = i5;
   i6 = HEAP32[i49 >> 2] | 0;
   HEAP32[i7 >> 2] = i6;
   i7 = HEAP32[i50 >> 2] | 0;
   HEAP32[i8 >> 2] = i7;
   i8 = HEAP32[i51 >> 2] | 0;
   HEAP32[i9 >> 2] = i8;
   i9 = HEAP32[i52 >> 2] | 0;
   HEAP32[i14 >> 2] = i9;
   i14 = HEAP32[i53 >> 2] | 0;
   HEAP32[i76 >> 2] = i14;
   i76 = HEAP32[i54 >> 2] | 0;
   HEAP32[i77 >> 2] = i76;
   i77 = HEAP32[i55 >> 2] | 0;
   HEAP32[i78 >> 2] = i77;
   i78 = HEAP32[i56 >> 2] | 0;
   HEAP32[i3 >> 2] = i78;
   i3 = HEAP32[i80 >> 2] | 0;
   i2 = HEAP32[i108 >> 2] | 0;
   f32 = (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = (HEAP32[tempDoublePtr >> 2] = i113, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i15 >>> 0 < i3 >>> 0) {
    i5 = i15;
    do {
     f35 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
     f33 = Math_fround(f39 * f35);
     f34 = Math_fround(f59 * f35);
     f35 = Math_fround(f60 * f35);
     f70 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
     f33 = Math_fround(f33 + Math_fround(f61 * f70));
     f34 = Math_fround(f34 + Math_fround(f62 * f70));
     f70 = Math_fround(f35 + Math_fround(f63 * f70));
     f35 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
     f33 = Math_fround(f67 + Math_fround(f33 + Math_fround(f64 * f35)));
     f34 = Math_fround(f68 + Math_fround(f34 + Math_fround(f65 * f35)));
     f35 = Math_fround(f69 + Math_fround(f70 + Math_fround(f66 * f35)));
     HEAPF32[i85 >> 2] = f33;
     HEAPF32[i72 >> 2] = f34;
     HEAPF32[i73 >> 2] = f35;
     i4 = HEAP32[i81 >> 2] | 0;
     if ((HEAP32[i84 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i114 = HEAP32[i99 >> 2] | 0;
      HEAPF32[i114 + (i4 * 12 | 0) >> 2] = f33;
      HEAPF32[i114 + (i4 * 12 | 0) + 4 >> 2] = f34;
      HEAPF32[i114 + (i4 * 12 | 0) + 8 >> 2] = f35;
      HEAP32[i81 >> 2] = i4 + 1;
     } else {
      __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i99, i85) | 0;
      i2 = HEAP32[i108 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i3 | 0));
    i3 = HEAP32[i80 >> 2] | 0;
   }
   i4 = i2 + (i3 * 12 | 0) | 0;
   L124 : do if ((i15 | 0) < (i3 | 0)) {
    i2 = i2 + (i15 * 12 | 0) | 0;
    while (1) {
     f68 = Math_fround(HEAPF32[i2 >> 2]);
     f67 = Math_fround(f68 * f32);
     f69 = Math_fround(f68 * f31);
     f68 = Math_fround(f68 * f30);
     i113 = i2 + 4 | 0;
     f70 = Math_fround(HEAPF32[i113 >> 2]);
     f67 = Math_fround(f67 + Math_fround(f70 * f29));
     f69 = Math_fround(f69 + Math_fround(f70 * f28));
     f70 = Math_fround(f68 + Math_fround(f70 * f27));
     i114 = i2 + 8 | 0;
     f68 = Math_fround(HEAPF32[i114 >> 2]);
     f69 = Math_fround(Math_fround(f69 + Math_fround(f68 * f25)) + f11);
     f70 = Math_fround(Math_fround(f70 + Math_fround(f68 * f13)) + f10);
     HEAPF32[i2 >> 2] = Math_fround(Math_fround(f67 + Math_fround(f68 * f26)) + f12);
     HEAPF32[i113 >> 2] = f69;
     HEAPF32[i114 >> 2] = f70;
     i2 = i2 + 12 | 0;
     if (i2 >>> 0 >= i4 >>> 0) break L124;
     f32 = Math_fround(HEAPF32[i101 >> 2]);
     f31 = Math_fround(HEAPF32[i46 >> 2]);
     f30 = Math_fround(HEAPF32[i47 >> 2]);
     f29 = Math_fround(HEAPF32[i57 >> 2]);
     f28 = Math_fround(HEAPF32[i49 >> 2]);
     f27 = Math_fround(HEAPF32[i50 >> 2]);
     f26 = Math_fround(HEAPF32[i58 >> 2]);
     f25 = Math_fround(HEAPF32[i52 >> 2]);
     f13 = Math_fround(HEAPF32[i53 >> 2]);
     f12 = Math_fround(HEAPF32[i71 >> 2]);
     f11 = Math_fround(HEAPF32[i55 >> 2]);
     f10 = Math_fround(HEAPF32[i56 >> 2]);
    }
   } while (0);
   i75 = i75 + 1 | 0;
   i1 = i1 + 4 | 0;
  } while (i75 >>> 0 < (HEAP32[i82 >> 2] | 0) >>> 0);
 }
 HEAP32[i107 >> 2] = 0;
 i50 = i107 + 4 | 0;
 HEAP32[i50 >> 2] = 0;
 i79 = i107 + 8 | 0;
 HEAP32[i79 >> 2] = 0;
 HEAP32[i106 >> 2] = 0;
 HEAP32[i106 + 4 >> 2] = 0;
 i78 = i106 + 8 | 0;
 HEAP32[i78 >> 2] = 0;
 i51 = i88 + 108 | 0;
 if (HEAP32[i51 >> 2] | 0) {
  i52 = i94 + 4 | 0;
  i53 = i94 + 8 | 0;
  i54 = i94 + 12 | 0;
  i55 = i95 + 16 | 0;
  i56 = i94 + 16 | 0;
  i57 = i95 + 20 | 0;
  i58 = i94 + 20 | 0;
  i71 = i95 + 24 | 0;
  i72 = i94 + 24 | 0;
  i73 = i95 + 12 | 0;
  i74 = i95 + 8 | 0;
  i75 = i95 + 4 | 0;
  i76 = i101 + 2 | 0;
  i77 = i101 + 3 | 0;
  i42 = i88 + 128 | 0;
  i43 = i93 + 2 | 0;
  i44 = i93 + 3 | 0;
  i45 = i91 + 4 | 0;
  i46 = i91 + 8 | 0;
  i47 = i100 + 4 | 0;
  i48 = i100 + 8 | 0;
  i49 = 0;
  while (1) {
   i114 = HEAP32[i1 >> 2] | 0;
   i8 = HEAP32[i114 + 28 >> 2] | 0;
   __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i94, i104);
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i95, i114);
   f68 = Math_fround(-Math_fround(HEAPF32[i94 >> 2]));
   f69 = Math_fround(-Math_fround(HEAPF32[i52 >> 2]));
   f64 = Math_fround(-Math_fround(HEAPF32[i53 >> 2]));
   f34 = Math_fround(HEAPF32[i54 >> 2]);
   f67 = Math_fround(HEAPF32[i55 >> 2]);
   f67 = Math_fround(f67 - Math_fround(HEAPF32[i56 >> 2]));
   f66 = Math_fround(HEAPF32[i57 >> 2]);
   f66 = Math_fround(f66 - Math_fround(HEAPF32[i58 >> 2]));
   f33 = Math_fround(HEAPF32[i71 >> 2]);
   f67 = Math_fround(f67 * Math_fround(2.0));
   f66 = Math_fround(f66 * Math_fround(2.0));
   f33 = Math_fround(Math_fround(f33 - Math_fround(HEAPF32[i72 >> 2])) * Math_fround(2.0));
   f70 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
   f60 = Math_fround(Math_fround(Math_fround(f67 * f68) + Math_fround(f66 * f69)) + Math_fround(f33 * f64));
   f39 = Math_fround(Math_fround(f60 * f68) + Math_fround(Math_fround(f70 * f67) + Math_fround(f34 * Math_fround(Math_fround(f33 * f69) - Math_fround(f66 * f64)))));
   f59 = Math_fround(Math_fround(f60 * f69) + Math_fround(Math_fround(f70 * f66) + Math_fround(f34 * Math_fround(Math_fround(f67 * f64) - Math_fround(f33 * f68)))));
   f60 = Math_fround(Math_fround(Math_fround(f70 * f33) + Math_fround(f34 * Math_fround(Math_fround(f66 * f68) - Math_fround(f67 * f69)))) + Math_fround(f60 * f64));
   f67 = Math_fround(HEAPF32[i95 >> 2]);
   f66 = Math_fround(f34 * f67);
   f33 = Math_fround(HEAPF32[i73 >> 2]);
   f66 = Math_fround(f66 + Math_fround(f33 * f68));
   f70 = Math_fround(HEAPF32[i74 >> 2]);
   f66 = Math_fround(f66 + Math_fround(f70 * f69));
   f65 = Math_fround(HEAPF32[i75 >> 2]);
   f66 = Math_fround(f66 - Math_fround(f65 * f64));
   f35 = Math_fround(Math_fround(Math_fround(f67 * f64) + Math_fround(Math_fround(f33 * f69) + Math_fround(f34 * f65))) - Math_fround(f70 * f68));
   f61 = Math_fround(Math_fround(Math_fround(f65 * f68) + Math_fround(Math_fround(f33 * f64) + Math_fround(f34 * f70))) - Math_fround(f67 * f69));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f33) - Math_fround(f67 * f68)) - Math_fround(f65 * f69)) - Math_fround(f70 * f64));
   f70 = Math_fround(f66 + f66);
   f69 = Math_fround(f35 + f35);
   f65 = Math_fround(f61 + f61);
   f68 = Math_fround(f70 * f64);
   f67 = Math_fround(f64 * f69);
   f64 = Math_fround(f64 * f65);
   f33 = Math_fround(f66 * f69);
   f34 = Math_fround(f66 * f65);
   f69 = Math_fround(f35 * f69);
   f35 = Math_fround(f35 * f65);
   f65 = Math_fround(f61 * f65);
   f61 = Math_fround(Math_fround(Math_fround(1.0) - f69) - f65);
   f62 = Math_fround(f64 + f33);
   f63 = Math_fround(f34 - f67);
   f64 = Math_fround(f33 - f64);
   f70 = Math_fround(Math_fround(1.0) - Math_fround(f66 * f70));
   f65 = Math_fround(f70 - f65);
   f66 = Math_fround(f68 + f35);
   f67 = Math_fround(f34 + f67);
   f68 = Math_fround(f35 - f68);
   f69 = Math_fround(f70 - f69);
   f70 = Math_fround(HEAPF32[i8 + 80 >> 2]);
   f61 = Math_fround(f70 * f61);
   f62 = Math_fround(f70 * f62);
   f63 = Math_fround(f70 * f63);
   f70 = Math_fround(HEAPF32[i8 + 76 >> 2]);
   f64 = Math_fround(f70 * f64);
   f65 = Math_fround(f70 * f65);
   f66 = Math_fround(f70 * f66);
   f70 = Math_fround(HEAPF32[i8 + 84 >> 2]);
   f67 = Math_fround(f70 * f67);
   f68 = Math_fround(f70 * f68);
   f69 = Math_fround(f70 * f69);
   i8 = i8 + 72 | 0;
   i114 = HEAP32[i8 >> 2] | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i114 >> 2] | 0) + 36 >> 2] | 0, i114 | 0) | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i114 >> 2] | 0) + 32 >> 2] | 0, i114 | 0) | 0;
   i2 = Math_imul(i7, i6) | 0;
   HEAP32[i101 >> 2] = 0;
   HEAP8[i76 >> 0] = 0;
   HEAP8[i77 >> 0] = 0;
   __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i106, i2, i101);
   i40 = HEAP32[i106 >> 2] | 0;
   mftCall_iiii(HEAP32[(HEAP32[i114 >> 2] | 0) + 24 >> 2] | 0, i114 | 0, i40 | 0, i2 << 2 | 0) | 0;
   if ((HEAP32[i79 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i107, i2);
   if (!((i7 | 0) == 0 | (i6 | 0) == 0)) {
    i4 = 0;
    do {
     f12 = Math_fround(i4 >>> 0);
     i2 = Math_imul(i4, i6) | 0;
     i5 = 0;
     do {
      f10 = Math_fround(HEAP16[i40 + (i5 + i2 << 2) >> 1] | 0);
      f11 = Math_fround(i5 >>> 0);
      HEAPF32[i100 >> 2] = f12;
      HEAPF32[i47 >> 2] = f10;
      HEAPF32[i48 >> 2] = f11;
      i3 = HEAP32[i50 >> 2] | 0;
      if ((HEAP32[i79 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       i114 = HEAP32[i107 >> 2] | 0;
       HEAPF32[i114 + (i3 * 12 | 0) >> 2] = f12;
       HEAPF32[i114 + (i3 * 12 | 0) + 4 >> 2] = f10;
       HEAPF32[i114 + (i3 * 12 | 0) + 8 >> 2] = f11;
       HEAP32[i50 >> 2] = i3 + 1;
      } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i107, i100) | 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i6 | 0));
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i7 | 0));
   }
   i41 = HEAP32[i80 >> 2] | 0;
   i22 = HEAP32[i8 >> 2] | 0;
   i23 = HEAP32[i107 >> 2] | 0;
   i24 = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0;
   i36 = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] | 0, i22 | 0) | 0;
   i37 = i36 + -1 | 0;
   i38 = i24 + -1 | 0;
   i2 = (Math_imul(i38 * 6 | 0, i37) | 0) + (HEAP32[i80 >> 2] | 0) | 0;
   if ((HEAP32[i83 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i108, i2);
   if (i38 | 0) {
    i21 = (i37 | 0) == 0;
    i19 = 0;
    while (1) {
     if (i21) i2 = i19 + 1 | 0; else {
      i17 = Math_imul(i19, i36) | 0;
      i2 = i19 + 1 | 0;
      i18 = Math_imul(i2, i36) | 0;
      i20 = 0;
      do {
       i7 = (Math_imul(i20, i24) | 0) + i19 | 0;
       i14 = (HEAPU8[i40 + (i7 << 2) + 2 >> 0] | 0) >>> 7;
       i15 = i20 + i17 | 0;
       i8 = i15 + 1 | 0;
       i16 = i20 + i18 | 0;
       i9 = i16 + 1 | 0;
       i7 = i7 << 1;
       do if ((mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 68 >> 2] | 0, i22 | 0, i7 | 0) | 0) << 16 >> 16 != 127) {
        i3 = i23 + (i16 * 12 | 0) | 0;
        i4 = HEAP32[i83 >> 2] | 0;
        i5 = HEAP32[i80 >> 2] | 0;
        if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
         i114 = HEAP32[i108 >> 2] | 0;
         HEAP32[i114 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
         HEAP32[i114 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i16 * 12 | 0) + 4 >> 2];
         HEAP32[i114 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i16 * 12 | 0) + 8 >> 2];
         i5 = i5 + 1 | 0;
         HEAP32[i80 >> 2] = i5;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
         i4 = HEAP32[i83 >> 2] | 0;
         i5 = HEAP32[i80 >> 2] | 0;
        }
        i3 = i23 + (i15 * 12 | 0) | 0;
        if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
         i6 = HEAP32[i108 >> 2] | 0;
         HEAP32[i6 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
         HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i15 * 12 | 0) + 4 >> 2];
         HEAP32[i6 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i15 * 12 | 0) + 8 >> 2];
         i6 = i5 + 1 | 0;
         HEAP32[i80 >> 2] = i6;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
         i4 = HEAP32[i83 >> 2] | 0;
         i6 = HEAP32[i80 >> 2] | 0;
        }
        i3 = i14 << 24 >> 24 ? i9 : i8;
        i5 = i23 + (i3 * 12 | 0) | 0;
        if ((i4 & 2147483647) >>> 0 > i6 >>> 0) {
         i114 = HEAP32[i108 >> 2] | 0;
         HEAP32[i114 + (i6 * 12 | 0) >> 2] = HEAP32[i5 >> 2];
         HEAP32[i114 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i3 * 12 | 0) + 4 >> 2];
         HEAP32[i114 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i3 * 12 | 0) + 8 >> 2];
         HEAP32[i80 >> 2] = i6 + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i5) | 0;
         break;
        }
       } while (0);
       do if ((mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 68 >> 2] | 0, i22 | 0, i7 | 1 | 0) | 0) << 16 >> 16 != 127) {
        i3 = i23 + (i8 * 12 | 0) | 0;
        i4 = HEAP32[i83 >> 2] | 0;
        i5 = HEAP32[i80 >> 2] | 0;
        if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
         i114 = HEAP32[i108 >> 2] | 0;
         HEAP32[i114 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
         HEAP32[i114 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i8 * 12 | 0) + 4 >> 2];
         HEAP32[i114 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i8 * 12 | 0) + 8 >> 2];
         i5 = i5 + 1 | 0;
         HEAP32[i80 >> 2] = i5;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
         i4 = HEAP32[i83 >> 2] | 0;
         i5 = HEAP32[i80 >> 2] | 0;
        }
        i3 = i23 + (i9 * 12 | 0) | 0;
        if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
         i6 = HEAP32[i108 >> 2] | 0;
         HEAP32[i6 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
         HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i9 * 12 | 0) + 4 >> 2];
         HEAP32[i6 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i9 * 12 | 0) + 8 >> 2];
         i6 = i5 + 1 | 0;
         HEAP32[i80 >> 2] = i6;
         i5 = i4;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i3) | 0;
         i5 = HEAP32[i83 >> 2] | 0;
         i6 = HEAP32[i80 >> 2] | 0;
        }
        i3 = i14 << 24 >> 24 ? i15 : i16;
        i4 = i23 + (i3 * 12 | 0) | 0;
        if ((i5 & 2147483647) >>> 0 > i6 >>> 0) {
         i114 = HEAP32[i108 >> 2] | 0;
         HEAP32[i114 + (i6 * 12 | 0) >> 2] = HEAP32[i4 >> 2];
         HEAP32[i114 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i23 + (i3 * 12 | 0) + 4 >> 2];
         HEAP32[i114 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i23 + (i3 * 12 | 0) + 8 >> 2];
         HEAP32[i80 >> 2] = i6 + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i108, i4) | 0;
         break;
        }
       } while (0);
       i20 = i20 + 1 | 0;
      } while ((i20 | 0) != (i37 | 0));
     }
     if ((i2 | 0) == (i38 | 0)) break; else i19 = i2;
    }
   }
   i3 = (HEAP32[i82 >> 2] | 0) + i49 | 0;
   i24 = HEAP32[i42 >> 2] | 0;
   i36 = i24 + (i3 * 48 | 0) | 0;
   f13 = Math_fround(HEAPF32[i36 >> 2]);
   i37 = i24 + (i3 * 48 | 0) + 4 | 0;
   f25 = Math_fround(HEAPF32[i37 >> 2]);
   i38 = i24 + (i3 * 48 | 0) + 8 | 0;
   f26 = Math_fround(HEAPF32[i38 >> 2]);
   i40 = i24 + (i3 * 48 | 0) + 12 | 0;
   f27 = Math_fround(HEAPF32[i40 >> 2]);
   i85 = i24 + (i3 * 48 | 0) + 16 | 0;
   f28 = Math_fround(HEAPF32[i85 >> 2]);
   i86 = i24 + (i3 * 48 | 0) + 20 | 0;
   f29 = Math_fround(HEAPF32[i86 >> 2]);
   i87 = i24 + (i3 * 48 | 0) + 24 | 0;
   f30 = Math_fround(HEAPF32[i87 >> 2]);
   i88 = i24 + (i3 * 48 | 0) + 28 | 0;
   f31 = Math_fround(HEAPF32[i88 >> 2]);
   i113 = i24 + (i3 * 48 | 0) + 32 | 0;
   f32 = Math_fround(HEAPF32[i113 >> 2]);
   i114 = i24 + (i3 * 48 | 0) + 36 | 0;
   f33 = Math_fround(HEAPF32[i114 >> 2]);
   i2 = i24 + (i3 * 48 | 0) + 40 | 0;
   f34 = Math_fround(HEAPF32[i2 >> 2]);
   i3 = i24 + (i3 * 48 | 0) + 44 | 0;
   f35 = Math_fround(HEAPF32[i3 >> 2]);
   HEAPF32[i36 >> 2] = f61;
   HEAPF32[i37 >> 2] = f62;
   HEAPF32[i38 >> 2] = f63;
   HEAPF32[i40 >> 2] = f64;
   HEAPF32[i85 >> 2] = f65;
   HEAPF32[i86 >> 2] = f66;
   HEAPF32[i87 >> 2] = f67;
   HEAPF32[i88 >> 2] = f68;
   HEAPF32[i113 >> 2] = f69;
   HEAPF32[i114 >> 2] = f39;
   HEAPF32[i2 >> 2] = f59;
   HEAPF32[i3 >> 2] = f60;
   i3 = HEAP32[i80 >> 2] | 0;
   i2 = HEAP32[i108 >> 2] | 0;
   if (i41 >>> 0 < i3 >>> 0) {
    i5 = i41;
    do {
     f12 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
     f10 = Math_fround(f13 * f12);
     f11 = Math_fround(f25 * f12);
     f12 = Math_fround(f26 * f12);
     f70 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
     f10 = Math_fround(f10 + Math_fround(f27 * f70));
     f11 = Math_fround(f11 + Math_fround(f28 * f70));
     f70 = Math_fround(f12 + Math_fround(f29 * f70));
     f12 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
     f10 = Math_fround(f33 + Math_fround(f10 + Math_fround(f30 * f12)));
     f11 = Math_fround(f34 + Math_fround(f11 + Math_fround(f31 * f12)));
     f12 = Math_fround(f35 + Math_fround(f70 + Math_fround(f32 * f12)));
     HEAPF32[i91 >> 2] = f10;
     HEAPF32[i45 >> 2] = f11;
     HEAPF32[i46 >> 2] = f12;
     i4 = HEAP32[i81 >> 2] | 0;
     if ((HEAP32[i84 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i114 = HEAP32[i99 >> 2] | 0;
      HEAPF32[i114 + (i4 * 12 | 0) >> 2] = f10;
      HEAPF32[i114 + (i4 * 12 | 0) + 4 >> 2] = f11;
      HEAPF32[i114 + (i4 * 12 | 0) + 8 >> 2] = f12;
      HEAP32[i81 >> 2] = i4 + 1;
     } else {
      __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i99, i91) | 0;
      i2 = HEAP32[i108 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i3 | 0));
    i3 = HEAP32[i80 >> 2] | 0;
   }
   i4 = i2 + (i3 * 12 | 0) | 0;
   if ((i41 | 0) < (i3 | 0)) {
    i2 = i2 + (i41 * 12 | 0) | 0;
    do {
     f34 = Math_fround(HEAPF32[i2 >> 2]);
     f33 = Math_fround(f61 * f34);
     f35 = Math_fround(f62 * f34);
     f34 = Math_fround(f63 * f34);
     i113 = i2 + 4 | 0;
     f70 = Math_fround(HEAPF32[i113 >> 2]);
     f33 = Math_fround(f33 + Math_fround(f64 * f70));
     f35 = Math_fround(f35 + Math_fround(f65 * f70));
     f70 = Math_fround(f34 + Math_fround(f66 * f70));
     i114 = i2 + 8 | 0;
     f34 = Math_fround(HEAPF32[i114 >> 2]);
     f35 = Math_fround(f59 + Math_fround(f35 + Math_fround(f68 * f34)));
     f70 = Math_fround(f60 + Math_fround(f70 + Math_fround(f69 * f34)));
     HEAPF32[i2 >> 2] = Math_fround(f39 + Math_fround(f33 + Math_fround(f67 * f34)));
     HEAPF32[i113 >> 2] = f35;
     HEAPF32[i114 >> 2] = f70;
     i2 = i2 + 12 | 0;
    } while (i2 >>> 0 < i4 >>> 0);
   }
   __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i107, 0, i92);
   HEAP32[i93 >> 2] = 0;
   HEAP8[i43 >> 0] = 0;
   HEAP8[i44 >> 0] = 0;
   __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i106, 0, i93);
   i49 = i49 + 1 | 0;
   if (i49 >>> 0 >= (HEAP32[i51 >> 2] | 0) >>> 0) break; else i1 = i1 + 4 | 0;
  }
 }
 i7 = HEAP32[i89 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 352 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i96 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i96 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i96 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i7 = HEAP32[i89 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 356 >> 2] | 0, i7 | 0) | 0;
 f70 = Math_fround(__ZNK5physx2Sc9ClothCore16getContactOffsetEv(i104));
 f68 = Math_fround(f70 + Math_fround(HEAPF32[i7 >> 2]));
 f69 = Math_fround(f70 + Math_fround(HEAPF32[i7 + 4 >> 2]));
 f70 = Math_fround(f70 + Math_fround(HEAPF32[i7 + 8 >> 2]));
 HEAPF32[i97 >> 2] = f68;
 HEAPF32[i97 + 4 >> 2] = f69;
 HEAPF32[i97 + 8 >> 2] = f70;
 i7 = HEAP32[i80 >> 2] | 0;
 if (!i7) i1 = 0; else {
  i8 = HEAP32[i99 >> 2] | 0;
  i9 = 0;
  i1 = 0;
  do {
   i114 = HEAP32[i108 >> 2] | 0;
   i2 = i9 + 1 | 0;
   i3 = i9 + 2 | 0;
   i4 = i8 + (i9 * 12 | 0) | 0;
   i5 = i8 + (i2 * 12 | 0) | 0;
   i6 = i8 + (i3 * 12 | 0) | 0;
   if (!(__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i96, i97, i114 + (i9 * 12 | 0) | 0, i114 + (i2 * 12 | 0) | 0, i114 + (i3 * 12 | 0) | 0) | 0)) {
    if (__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i96, i97, i4, i5, i6) | 0) i98 = 144;
   } else i98 = 144;
   if ((i98 | 0) == 144) {
    i98 = 0;
    i95 = HEAP32[i108 >> 2] | 0;
    HEAP32[i95 + (i1 * 12 | 0) >> 2] = HEAP32[i95 + (i9 * 12 | 0) >> 2];
    HEAP32[i95 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i95 + (i9 * 12 | 0) + 4 >> 2];
    HEAP32[i95 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i95 + (i9 * 12 | 0) + 8 >> 2];
    i113 = i1 + 1 | 0;
    HEAP32[i95 + (i113 * 12 | 0) >> 2] = HEAP32[i95 + (i2 * 12 | 0) >> 2];
    HEAP32[i95 + (i113 * 12 | 0) + 4 >> 2] = HEAP32[i95 + (i2 * 12 | 0) + 4 >> 2];
    HEAP32[i95 + (i113 * 12 | 0) + 8 >> 2] = HEAP32[i95 + (i2 * 12 | 0) + 8 >> 2];
    i114 = i1 + 2 | 0;
    HEAP32[i95 + (i114 * 12 | 0) >> 2] = HEAP32[i95 + (i3 * 12 | 0) >> 2];
    HEAP32[i95 + (i114 * 12 | 0) + 4 >> 2] = HEAP32[i95 + (i3 * 12 | 0) + 4 >> 2];
    HEAP32[i95 + (i114 * 12 | 0) + 8 >> 2] = HEAP32[i95 + (i3 * 12 | 0) + 8 >> 2];
    HEAP32[i8 + (i1 * 12 | 0) >> 2] = HEAP32[i4 >> 2];
    HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i8 + (i9 * 12 | 0) + 4 >> 2];
    HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i8 + (i9 * 12 | 0) + 8 >> 2];
    HEAP32[i8 + (i113 * 12 | 0) >> 2] = HEAP32[i5 >> 2];
    HEAP32[i8 + (i113 * 12 | 0) + 4 >> 2] = HEAP32[i8 + (i2 * 12 | 0) + 4 >> 2];
    HEAP32[i8 + (i113 * 12 | 0) + 8 >> 2] = HEAP32[i8 + (i2 * 12 | 0) + 8 >> 2];
    HEAP32[i8 + (i114 * 12 | 0) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + (i114 * 12 | 0) + 4 >> 2] = HEAP32[i8 + (i3 * 12 | 0) + 4 >> 2];
    HEAP32[i8 + (i114 * 12 | 0) + 8 >> 2] = HEAP32[i8 + (i3 * 12 | 0) + 8 >> 2];
    i1 = i1 + 3 | 0;
   }
   i9 = i9 + 3 | 0;
  } while (i9 >>> 0 < i7 >>> 0);
 }
 i2 = HEAP32[i99 >> 2] | 0;
 i97 = i2 + (i1 * 12 | 0) | 0;
 i98 = HEAP32[i108 >> 2] | 0;
 i114 = i98 + (i1 * 12 | 0) | 0;
 __ZN12_GLOBAL__N_115offsetTrianglesEPN5physx6PxVec3ES2_f(i2, i97, f105);
 __ZN12_GLOBAL__N_115offsetTrianglesEPN5physx6PxVec3ES2_f(i98, i114, f105);
 i113 = HEAP32[i89 >> 2] | 0;
 i99 = HEAP32[(HEAP32[i113 >> 2] | 0) + 200 >> 2] | 0;
 HEAP32[i102 >> 2] = i2;
 HEAP32[i102 + 4 >> 2] = i97;
 HEAP32[i103 >> 2] = i98;
 HEAP32[i103 + 4 >> 2] = i114;
 i114 = HEAP32[i104 + 88 >> 2] | 0;
 HEAP32[i100 >> 2] = HEAP32[i102 >> 2];
 HEAP32[i100 + 4 >> 2] = HEAP32[i102 + 4 >> 2];
 HEAP32[i101 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i101 + 4 >> 2] = HEAP32[i103 + 4 >> 2];
 mftCall_viiii(i99 | 0, i113 | 0, i100 | 0, i101 | 0, i114 | 0);
 i114 = HEAP32[i78 >> 2] | 0;
 if ((i114 | 0) > -1 & (i114 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i106 >> 2] | 0;
  if (i1 | 0) {
   i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i1 | 0);
  }
 }
 i114 = HEAP32[i79 >> 2] | 0;
 if ((i114 | 0) > -1 & (i114 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i107 >> 2] | 0;
  if (i1 | 0) {
   i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i1 | 0);
  }
 }
 i114 = HEAP32[i84 >> 2] | 0;
 if (!((i114 & 2147483647 | 0) == 0 | (i114 | 0) < 0 | (i2 | 0) == 0)) {
  i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i2 | 0);
 }
 i114 = HEAP32[i83 >> 2] | 0;
 if ((i114 | 0) > -1 & (i114 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i108 >> 2] | 0;
  if (i1 | 0) {
   i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i1 | 0);
  }
 }
 i114 = HEAP32[i90 >> 2] | 0;
 if ((i114 | 0) > -1 & (i114 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i109 >> 2] | 0;
  if (i1 | 0) {
   i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i1 | 0);
  }
 }
 i114 = HEAP32[i110 >> 2] | 0;
 if (!((i114 | 0) > -1 & (i114 & 2147483647 | 0) != 0)) {
  STACKTOP = i112;
  return;
 }
 i1 = HEAP32[i111 >> 2] | 0;
 if (!i1) {
  STACKTOP = i112;
  return;
 }
 i114 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i114 >> 2] | 0) + 12 >> 2] | 0, i114 | 0, i1 | 0);
 STACKTOP = i112;
 return;
}

function __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i156, i130) {
 i156 = i156 | 0;
 i130 = i130 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, i106 = 0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, i115 = 0, i116 = 0, i117 = 0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i157 = 0, f158 = f0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, f167 = f0, f168 = f0, f169 = f0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, f191 = f0, f192 = f0, f193 = f0, f194 = f0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0;
 i157 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i131 = i157;
 i132 = HEAP32[i156 >> 2] | 0;
 i141 = HEAP32[i156 + 4 >> 2] | 0;
 i145 = HEAP32[i156 + 32 >> 2] | 0;
 i149 = HEAP32[i156 + 36 >> 2] | 0;
 i152 = HEAP32[i156 + 64 >> 2] | 0;
 i133 = HEAP32[i156 + 68 >> 2] | 0;
 i137 = HEAP32[i156 + 96 >> 2] | 0;
 i140 = HEAP32[i156 + 100 >> 2] | 0;
 i19 = HEAP32[i132 >> 2] | 0;
 i37 = HEAP32[i132 + 4 >> 2] | 0;
 i29 = HEAP32[i132 + 8 >> 2] | 0;
 i142 = HEAP32[i132 + 12 >> 2] | 0;
 i45 = HEAP32[i141 >> 2] | 0;
 i53 = HEAP32[i141 + 4 >> 2] | 0;
 i43 = HEAP32[i141 + 8 >> 2] | 0;
 i143 = HEAP32[i141 + 12 >> 2] | 0;
 i144 = i132 + 16 | 0;
 i28 = HEAP32[i144 >> 2] | 0;
 i17 = HEAP32[i144 + 4 >> 2] | 0;
 i13 = HEAP32[i144 + 8 >> 2] | 0;
 i144 = HEAP32[i144 + 12 >> 2] | 0;
 i146 = i141 + 16 | 0;
 i9 = HEAP32[i146 >> 2] | 0;
 i5 = HEAP32[i146 + 4 >> 2] | 0;
 i1 = HEAP32[i146 + 8 >> 2] | 0;
 i146 = HEAP32[i146 + 12 >> 2] | 0;
 i20 = HEAP32[i145 >> 2] | 0;
 i38 = HEAP32[i145 + 4 >> 2] | 0;
 i27 = HEAP32[i145 + 8 >> 2] | 0;
 i147 = HEAP32[i145 + 12 >> 2] | 0;
 i46 = HEAP32[i149 >> 2] | 0;
 i52 = HEAP32[i149 + 4 >> 2] | 0;
 i47 = HEAP32[i149 + 8 >> 2] | 0;
 i148 = HEAP32[i149 + 12 >> 2] | 0;
 i150 = i145 + 16 | 0;
 i31 = HEAP32[i150 >> 2] | 0;
 i22 = HEAP32[i150 + 4 >> 2] | 0;
 i14 = HEAP32[i150 + 8 >> 2] | 0;
 i150 = HEAP32[i150 + 12 >> 2] | 0;
 i151 = i149 + 16 | 0;
 i10 = HEAP32[i151 >> 2] | 0;
 i6 = HEAP32[i151 + 4 >> 2] | 0;
 i2 = HEAP32[i151 + 8 >> 2] | 0;
 i151 = HEAP32[i151 + 12 >> 2] | 0;
 i21 = HEAP32[i152 >> 2] | 0;
 i39 = HEAP32[i152 + 4 >> 2] | 0;
 i25 = HEAP32[i152 + 8 >> 2] | 0;
 i153 = HEAP32[i152 + 12 >> 2] | 0;
 i48 = HEAP32[i133 >> 2] | 0;
 i51 = HEAP32[i133 + 4 >> 2] | 0;
 i41 = HEAP32[i133 + 8 >> 2] | 0;
 i154 = HEAP32[i133 + 12 >> 2] | 0;
 i155 = i152 + 16 | 0;
 i35 = HEAP32[i155 >> 2] | 0;
 i24 = HEAP32[i155 + 4 >> 2] | 0;
 i15 = HEAP32[i155 + 8 >> 2] | 0;
 i155 = HEAP32[i155 + 12 >> 2] | 0;
 i134 = i133 + 16 | 0;
 i11 = HEAP32[i134 >> 2] | 0;
 i7 = HEAP32[i134 + 4 >> 2] | 0;
 i3 = HEAP32[i134 + 8 >> 2] | 0;
 i134 = HEAP32[i134 + 12 >> 2] | 0;
 i18 = HEAP32[i137 >> 2] | 0;
 i36 = HEAP32[i137 + 4 >> 2] | 0;
 i23 = HEAP32[i137 + 8 >> 2] | 0;
 i135 = HEAP32[i137 + 12 >> 2] | 0;
 i44 = HEAP32[i140 >> 2] | 0;
 i50 = HEAP32[i140 + 4 >> 2] | 0;
 i33 = HEAP32[i140 + 8 >> 2] | 0;
 i136 = HEAP32[i140 + 12 >> 2] | 0;
 i138 = i137 + 16 | 0;
 i42 = HEAP32[i138 >> 2] | 0;
 i26 = HEAP32[i138 + 4 >> 2] | 0;
 i16 = HEAP32[i138 + 8 >> 2] | 0;
 i138 = HEAP32[i138 + 12 >> 2] | 0;
 i139 = i140 + 16 | 0;
 i12 = HEAP32[i139 >> 2] | 0;
 i8 = HEAP32[i139 + 4 >> 2] | 0;
 i4 = HEAP32[i139 + 8 >> 2] | 0;
 i139 = HEAP32[i139 + 12 >> 2] | 0;
 i49 = HEAP32[i156 + 16 >> 2] | 0;
 i129 = HEAP16[i156 + 26 >> 1] | 0;
 i128 = i49 + ((i129 & 65535) << 4) | 0;
 HEAP32[i131 >> 2] = 2139095039;
 HEAP32[i131 + 4 >> 2] = 2139095039;
 HEAP32[i131 + 8 >> 2] = 2139095039;
 HEAP32[i131 + 12 >> 2] = 2139095039;
 if (!(i129 << 16 >> 16)) i49 = i53; else {
  i129 = i130 + 1 | 0;
  i127 = i49;
  i49 = i49 + 384 | 0;
  do {
   i56 = i127 + 144 | 0;
   i106 = HEAP8[i127 + 1 >> 0] | 0;
   i70 = i106 & 255;
   i71 = HEAP8[i127 + 2 >> 0] | 0;
   i116 = i71 & 255;
   i77 = HEAPU8[i127 + 3 >> 0] | 0;
   i54 = (i77 & 1 | 0) == 0;
   i126 = i70 << 4;
   i60 = i127 + (i126 + 144) | 0;
   i115 = i60 + (i70 * 240 | 0) | 0;
   i69 = i54 ? i131 : i115;
   i126 = i54 ? i115 : i115 + i126 | 0;
   i71 = i71 << 24 >> 24 != 0;
   i115 = i71 ? i126 + 128 | 0 : i126;
   i117 = i115 + (i116 << 4) | 0;
   i72 = i127;
   i127 = i115 + ((i77 & 2 | 0) == 0 ? i116 * 240 | 0 : i116 << 8) | 0;
   f118 = Math_fround(HEAPF32[i72 + 64 >> 2]);
   f119 = Math_fround(HEAPF32[i72 + 68 >> 2]);
   f120 = Math_fround(HEAPF32[i72 + 72 >> 2]);
   f121 = Math_fround(HEAPF32[i72 + 76 >> 2]);
   f122 = Math_fround(HEAPF32[i72 + 80 >> 2]);
   f123 = Math_fround(HEAPF32[i72 + 84 >> 2]);
   f124 = Math_fround(HEAPF32[i72 + 88 >> 2]);
   f125 = Math_fround(HEAPF32[i72 + 92 >> 2]);
   f102 = Math_fround(HEAPF32[i72 + 96 >> 2]);
   f103 = Math_fround(HEAPF32[i72 + 100 >> 2]);
   f104 = Math_fround(HEAPF32[i72 + 104 >> 2]);
   f105 = Math_fround(HEAPF32[i72 + 108 >> 2]);
   f107 = Math_fround(HEAPF32[i72 + 112 >> 2]);
   f108 = Math_fround(HEAPF32[i72 + 116 >> 2]);
   f109 = Math_fround(HEAPF32[i72 + 120 >> 2]);
   f110 = Math_fround(HEAPF32[i72 + 124 >> 2]);
   f111 = Math_fround(HEAPF32[i72 + 128 >> 2]);
   f112 = Math_fround(HEAPF32[i72 + 132 >> 2]);
   f113 = Math_fround(HEAPF32[i72 + 136 >> 2]);
   f114 = Math_fround(HEAPF32[i72 + 140 >> 2]);
   f96 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f68 = Math_fround(f96 * f102);
   f90 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(f90 * f103);
   f84 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f66 = Math_fround(f84 * f104);
   f78 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f78 * f105);
   f97 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f97 * f102);
   f91 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f91 * f103);
   f85 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f85 * f104);
   f79 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround(f79 * f105);
   f98 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f92 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f86 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f80 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f68 = Math_fround(f68 + Math_fround(f98 * f107));
   f67 = Math_fround(f67 + Math_fround(f92 * f108));
   f66 = Math_fround(f66 + Math_fround(f86 * f109));
   f65 = Math_fround(f65 + Math_fround(f80 * f110));
   f99 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f93 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f87 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f81 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f64 + Math_fround(f99 * f107));
   f63 = Math_fround(f63 + Math_fround(f93 * f108));
   f62 = Math_fround(f62 + Math_fround(f87 * f109));
   f61 = Math_fround(f61 + Math_fround(f81 * f110));
   f100 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f94 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f88 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f82 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f68 = Math_fround(f68 + Math_fround(f100 * f111));
   f67 = Math_fround(f67 + Math_fround(f94 * f112));
   f66 = Math_fround(f66 + Math_fround(f88 * f113));
   f65 = Math_fround(f65 + Math_fround(f82 * f114));
   f101 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f95 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f89 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f83 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f64 + Math_fround(f101 * f111));
   f63 = Math_fround(f63 + Math_fround(f95 * f112));
   f62 = Math_fround(f62 + Math_fround(f89 * f113));
   f61 = Math_fround(f61 + Math_fround(f83 * f114));
   if (!(i106 << 24 >> 24)) {
    f59 = Math_fround(0.0);
    f58 = Math_fround(0.0);
    f57 = Math_fround(0.0);
    f55 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f30 = Math_fround(0.0);
    i106 = i49;
   } else {
    if (i54) {
     i21 = i69 + 4 | 0;
     i23 = i69 + 8 | 0;
     i25 = i69 + 12 | 0;
     i18 = i42;
     f30 = Math_fround(0.0);
     f32 = Math_fround(0.0);
     f34 = Math_fround(0.0);
     f40 = Math_fround(0.0);
     f55 = Math_fround(0.0);
     f57 = Math_fround(0.0);
     f58 = Math_fround(0.0);
     f59 = Math_fround(0.0);
     i19 = 0;
     i20 = i49;
     while (1) {
      i75 = i56 + (i19 << 4) | 0;
      f171 = Math_fround(HEAPF32[i75 >> 2]);
      i76 = i56 + (i19 << 4) + 4 | 0;
      f169 = Math_fround(HEAPF32[i76 >> 2]);
      i77 = i56 + (i19 << 4) + 8 | 0;
      f167 = Math_fround(HEAPF32[i77 >> 2]);
      i106 = i56 + (i19 << 4) + 12 | 0;
      f162 = Math_fround(HEAPF32[i106 >> 2]);
      f161 = Math_fround(HEAPF32[i69 >> 2]);
      f160 = Math_fround(HEAPF32[i21 >> 2]);
      f159 = Math_fround(HEAPF32[i23 >> 2]);
      f158 = Math_fround(HEAPF32[i25 >> 2]);
      f197 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 4 >> 2]);
      f200 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 8 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 12 >> 2]);
      f192 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f197 = Math_fround(f192 * f197);
      f191 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f195 = Math_fround(f191 * f195);
      f190 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f200 = Math_fround(f190 * f200);
      f185 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f163 = Math_fround(f185 * f163);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 144 >> 2]);
      f194 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 148 >> 2]);
      f198 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 152 >> 2]);
      f201 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 156 >> 2]);
      f188 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f196 = Math_fround(f188 * f196);
      f187 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f194 = Math_fround(f187 * f194);
      f186 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f198 = Math_fround(f186 * f198);
      f181 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f201 = Math_fround(f181 * f201);
      f193 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 16 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 20 >> 2]);
      f189 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 24 >> 2]);
      f199 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 28 >> 2]);
      f184 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f183 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f182 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f177 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f193 = Math_fround(f197 + Math_fround(f184 * f193));
      f164 = Math_fround(f195 + Math_fround(f183 * f164));
      f189 = Math_fround(f200 + Math_fround(f182 * f189));
      f199 = Math_fround(f163 + Math_fround(f177 * f199));
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 160 >> 2]);
      f200 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 164 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 168 >> 2]);
      f197 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 172 >> 2]);
      f180 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f179 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f178 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f173 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f163 = Math_fround(f196 + Math_fround(f180 * f163));
      f200 = Math_fround(f194 + Math_fround(f179 * f200));
      f195 = Math_fround(f198 + Math_fround(f178 * f195));
      f197 = Math_fround(f201 + Math_fround(f173 * f197));
      f201 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 32 >> 2]);
      f198 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 36 >> 2]);
      f194 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 40 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 44 >> 2]);
      f176 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f175 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f174 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f165 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f201 = Math_fround(f193 + Math_fround(f176 * f201));
      f198 = Math_fround(f164 + Math_fround(f175 * f198));
      f194 = Math_fround(f189 + Math_fround(f174 * f194));
      f196 = Math_fround(f199 + Math_fround(f165 * f196));
      f199 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 176 >> 2]);
      f189 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 180 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 184 >> 2]);
      f193 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 188 >> 2]);
      f172 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f170 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f168 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f166 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f199 = Math_fround(Math_fround(f68 + f201) - Math_fround(f64 + Math_fround(f163 + Math_fround(f172 * f199))));
      f189 = Math_fround(Math_fround(f67 + f198) - Math_fround(f63 + Math_fround(f200 + Math_fround(f170 * f189))));
      f164 = Math_fround(Math_fround(f66 + f194) - Math_fround(f62 + Math_fround(f195 + Math_fround(f168 * f164))));
      f193 = Math_fround(Math_fround(f65 + f196) - Math_fround(f61 + Math_fround(f197 + Math_fround(f166 * f193))));
      f197 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 96 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 100 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 104 >> 2]);
      f194 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 108 >> 2]);
      f200 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 128 >> 2]);
      f198 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 132 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 136 >> 2]);
      f197 = Math_fround(f200 - Math_fround(f199 * f197));
      f196 = Math_fround(f198 - Math_fround(f189 * f196));
      f195 = Math_fround(f163 - Math_fround(f164 * f195));
      f194 = Math_fround(Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 140 >> 2]) - Math_fround(f193 * f194));
      f193 = Math_fround(-f171);
      f164 = Math_fround(-f169);
      f163 = Math_fround(-f167);
      f189 = Math_fround(-f162);
      f193 = Math_fround(f171 + (f197 > f193 ? f197 : f193));
      f164 = Math_fround(f169 + (f196 > f164 ? f196 : f164));
      f163 = Math_fround(f167 + (f195 > f163 ? f195 : f163));
      f189 = Math_fround(f162 + (f194 > f189 ? f194 : f189));
      f161 = f193 < f161 ? f193 : f161;
      f160 = f164 < f160 ? f164 : f160;
      f159 = f163 < f159 ? f163 : f159;
      f158 = f189 < f158 ? f189 : f158;
      f171 = Math_fround(f161 - f171);
      f169 = Math_fround(f160 - f169);
      f167 = Math_fround(f159 - f167);
      f162 = Math_fround(f158 - f162);
      f30 = Math_fround(f30 + f171);
      f32 = Math_fround(f32 + f169);
      f34 = Math_fround(f34 + f167);
      f40 = Math_fround(f40 + f162);
      f68 = Math_fround(f68 + Math_fround(f118 * f171));
      f67 = Math_fround(f67 + Math_fround(f119 * f169));
      f66 = Math_fround(f66 + Math_fround(f120 * f167));
      f65 = Math_fround(f65 + Math_fround(f121 * f162));
      f64 = Math_fround(f64 + Math_fround(f122 * f171));
      f63 = Math_fround(f63 + Math_fround(f123 * f169));
      f62 = Math_fround(f62 + Math_fround(f124 * f167));
      f61 = Math_fround(f61 + Math_fround(f125 * f162));
      f189 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 48 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 52 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 56 >> 2]);
      f189 = Math_fround(f192 + Math_fround(f189 * f171));
      f163 = Math_fround(f191 + Math_fround(f163 * f169));
      f164 = Math_fround(f190 + Math_fround(f164 * f167));
      f185 = Math_fround(f185 + Math_fround(Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 60 >> 2]) * f162));
      i28 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
      i31 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i35 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i18 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
      f185 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 192 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 196 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 200 >> 2]);
      f185 = Math_fround(f188 + Math_fround(f171 * f185));
      f164 = Math_fround(f187 + Math_fround(f169 * f164));
      f163 = Math_fround(f186 + Math_fround(f167 * f163));
      f181 = Math_fround(f181 + Math_fround(f162 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 204 >> 2])));
      i9 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
      f181 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 64 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 68 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 72 >> 2]);
      f181 = Math_fround(f184 + Math_fround(f171 * f181));
      f163 = Math_fround(f183 + Math_fround(f169 * f163));
      f164 = Math_fround(f182 + Math_fround(f167 * f164));
      f177 = Math_fround(f177 + Math_fround(f162 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 76 >> 2])));
      i17 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
      i22 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i24 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i26 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
      f177 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 208 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 212 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 216 >> 2]);
      f177 = Math_fround(f180 + Math_fround(f171 * f177));
      f164 = Math_fround(f179 + Math_fround(f169 * f164));
      f163 = Math_fround(f178 + Math_fround(f167 * f163));
      f173 = Math_fround(f173 + Math_fround(f162 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 220 >> 2])));
      i5 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f173, HEAP32[tempDoublePtr >> 2] | 0);
      f173 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 80 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 84 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 88 >> 2]);
      f173 = Math_fround(f176 + Math_fround(f171 * f173));
      f163 = Math_fround(f175 + Math_fround(f169 * f163));
      f164 = Math_fround(f174 + Math_fround(f167 * f164));
      f165 = Math_fround(f165 + Math_fround(f162 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 92 >> 2])));
      i13 = (HEAPF32[tempDoublePtr >> 2] = f173, HEAP32[tempDoublePtr >> 2] | 0);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i15 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i16 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
      f165 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 224 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 228 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 232 >> 2]);
      f165 = Math_fround(f172 + Math_fround(f171 * f165));
      f164 = Math_fround(f170 + Math_fround(f169 * f164));
      f163 = Math_fround(f168 + Math_fround(f167 * f163));
      f162 = Math_fround(f166 + Math_fround(f162 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 236 >> 2])));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f165, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f164, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f162, HEAP32[tempDoublePtr >> 2] | 0);
      HEAPF32[i75 >> 2] = f161;
      HEAPF32[i76 >> 2] = f160;
      HEAPF32[i77 >> 2] = f159;
      HEAPF32[i106 >> 2] = f158;
      f55 = Math_fround(f55 + f161);
      f57 = Math_fround(f57 + f160);
      f58 = Math_fround(f58 + f159);
      f59 = Math_fround(f59 + f158);
      i19 = i19 + 1 | 0;
      if ((i19 | 0) == (i70 | 0)) break; else i20 = i20 + 256 | 0;
     }
    } else {
     f55 = Math_fround(0.0);
     f57 = Math_fround(0.0);
     f58 = Math_fround(0.0);
     f59 = Math_fround(0.0);
     i18 = i42;
     f30 = Math_fround(0.0);
     f32 = Math_fround(0.0);
     f34 = Math_fround(0.0);
     f40 = Math_fround(0.0);
     i19 = 0;
     i20 = i49;
     while (1) {
      i75 = i56 + (i19 << 4) | 0;
      f188 = Math_fround(HEAPF32[i75 >> 2]);
      i76 = i56 + (i19 << 4) + 4 | 0;
      f190 = Math_fround(HEAPF32[i76 >> 2]);
      i77 = i56 + (i19 << 4) + 8 | 0;
      f192 = Math_fround(HEAPF32[i77 >> 2]);
      i106 = i56 + (i19 << 4) + 12 | 0;
      f197 = Math_fround(HEAPF32[i106 >> 2]);
      f198 = Math_fround(HEAPF32[i69 + (i19 << 4) >> 2]);
      f199 = Math_fround(HEAPF32[i69 + (i19 << 4) + 4 >> 2]);
      f200 = Math_fround(HEAPF32[i69 + (i19 << 4) + 8 >> 2]);
      f201 = Math_fround(HEAPF32[i69 + (i19 << 4) + 12 >> 2]);
      f162 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 4 >> 2]);
      f159 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 8 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 12 >> 2]);
      f167 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f162 = Math_fround(f167 * f162);
      f168 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f164 = Math_fround(f168 * f164);
      f169 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f159 = Math_fround(f169 * f159);
      f174 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f196 = Math_fround(f174 * f196);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 144 >> 2]);
      f165 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 148 >> 2]);
      f161 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 152 >> 2]);
      f158 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 156 >> 2]);
      f171 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f163 = Math_fround(f171 * f163);
      f172 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f165 = Math_fround(f172 * f165);
      f173 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f161 = Math_fround(f173 * f161);
      f178 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f158 = Math_fround(f178 * f158);
      f166 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 16 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 20 >> 2]);
      f170 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 24 >> 2]);
      f160 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 28 >> 2]);
      f175 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f176 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f177 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f182 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f166 = Math_fround(f162 + Math_fround(f175 * f166));
      f195 = Math_fround(f164 + Math_fround(f176 * f195));
      f170 = Math_fround(f159 + Math_fround(f177 * f170));
      f160 = Math_fround(f196 + Math_fround(f182 * f160));
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 160 >> 2]);
      f159 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 164 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 168 >> 2]);
      f162 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 172 >> 2]);
      f179 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f180 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f181 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f186 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f196 = Math_fround(f163 + Math_fround(f179 * f196));
      f159 = Math_fround(f165 + Math_fround(f180 * f159));
      f164 = Math_fround(f161 + Math_fround(f181 * f164));
      f162 = Math_fround(f158 + Math_fround(f186 * f162));
      f158 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 32 >> 2]);
      f161 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 36 >> 2]);
      f165 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 40 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 44 >> 2]);
      f183 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f184 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f185 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f194 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f158 = Math_fround(f166 + Math_fround(f183 * f158));
      f161 = Math_fround(f195 + Math_fround(f184 * f161));
      f165 = Math_fround(f170 + Math_fround(f185 * f165));
      f163 = Math_fround(f160 + Math_fround(f194 * f163));
      f160 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 176 >> 2]);
      f170 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 180 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 184 >> 2]);
      f166 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 188 >> 2]);
      f187 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f189 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f191 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f193 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f160 = Math_fround(Math_fround(f68 + f158) - Math_fround(f64 + Math_fround(f196 + Math_fround(f187 * f160))));
      f170 = Math_fround(Math_fround(f67 + f161) - Math_fround(f63 + Math_fround(f159 + Math_fround(f189 * f170))));
      f195 = Math_fround(Math_fround(f66 + f165) - Math_fround(f62 + Math_fround(f164 + Math_fround(f191 * f195))));
      f166 = Math_fround(Math_fround(f65 + f163) - Math_fround(f61 + Math_fround(f162 + Math_fround(f193 * f166))));
      f162 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 96 >> 2]);
      f163 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 100 >> 2]);
      f164 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 104 >> 2]);
      f165 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 108 >> 2]);
      f159 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 128 >> 2]);
      f161 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 132 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 136 >> 2]);
      f162 = Math_fround(f159 - Math_fround(f160 * f162));
      f163 = Math_fround(f161 - Math_fround(f170 * f163));
      f164 = Math_fround(f196 - Math_fround(f195 * f164));
      f165 = Math_fround(Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 140 >> 2]) - Math_fround(f166 * f165));
      f166 = Math_fround(-f188);
      f195 = Math_fround(-f190);
      f196 = Math_fround(-f192);
      f170 = Math_fround(-f197);
      f166 = Math_fround(f188 + (f162 > f166 ? f162 : f166));
      f195 = Math_fround(f190 + (f163 > f195 ? f163 : f195));
      f196 = Math_fround(f192 + (f164 > f196 ? f164 : f196));
      f170 = Math_fround(f197 + (f165 > f170 ? f165 : f170));
      f198 = f166 < f198 ? f166 : f198;
      f199 = f195 < f199 ? f195 : f199;
      f200 = f196 < f200 ? f196 : f200;
      f201 = f170 < f201 ? f170 : f201;
      f188 = Math_fround(f198 - f188);
      f190 = Math_fround(f199 - f190);
      f192 = Math_fround(f200 - f192);
      f197 = Math_fround(f201 - f197);
      f30 = Math_fround(f30 + f188);
      f32 = Math_fround(f32 + f190);
      f34 = Math_fround(f34 + f192);
      f40 = Math_fround(f40 + f197);
      f68 = Math_fround(f68 + Math_fround(f118 * f188));
      f67 = Math_fround(f67 + Math_fround(f119 * f190));
      f66 = Math_fround(f66 + Math_fround(f120 * f192));
      f65 = Math_fround(f65 + Math_fround(f121 * f197));
      f64 = Math_fround(f64 + Math_fround(f122 * f188));
      f63 = Math_fround(f63 + Math_fround(f123 * f190));
      f62 = Math_fround(f62 + Math_fround(f124 * f192));
      f61 = Math_fround(f61 + Math_fround(f125 * f197));
      f170 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 48 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 52 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 56 >> 2]);
      f170 = Math_fround(f167 + Math_fround(f170 * f188));
      f196 = Math_fround(f168 + Math_fround(f196 * f190));
      f195 = Math_fround(f169 + Math_fround(f195 * f192));
      f174 = Math_fround(f174 + Math_fround(Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 60 >> 2]) * f197));
      i28 = (HEAPF32[tempDoublePtr >> 2] = f170, HEAP32[tempDoublePtr >> 2] | 0);
      i31 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i35 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i18 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
      f174 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 192 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 196 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 200 >> 2]);
      f174 = Math_fround(f171 + Math_fround(f188 * f174));
      f195 = Math_fround(f172 + Math_fround(f190 * f195));
      f196 = Math_fround(f173 + Math_fround(f192 * f196));
      f178 = Math_fround(f178 + Math_fround(f197 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 204 >> 2])));
      i9 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = (HEAPF32[tempDoublePtr >> 2] = f178, HEAP32[tempDoublePtr >> 2] | 0);
      f178 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 64 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 68 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 72 >> 2]);
      f178 = Math_fround(f175 + Math_fround(f188 * f178));
      f196 = Math_fround(f176 + Math_fround(f190 * f196));
      f195 = Math_fround(f177 + Math_fround(f192 * f195));
      f182 = Math_fround(f182 + Math_fround(f197 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 76 >> 2])));
      i17 = (HEAPF32[tempDoublePtr >> 2] = f178, HEAP32[tempDoublePtr >> 2] | 0);
      i22 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i24 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i26 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
      f182 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 208 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 212 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 216 >> 2]);
      f182 = Math_fround(f179 + Math_fround(f188 * f182));
      f195 = Math_fround(f180 + Math_fround(f190 * f195));
      f196 = Math_fround(f181 + Math_fround(f192 * f196));
      f186 = Math_fround(f186 + Math_fround(f197 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 220 >> 2])));
      i5 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
      f186 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 80 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 84 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 88 >> 2]);
      f186 = Math_fround(f183 + Math_fround(f188 * f186));
      f196 = Math_fround(f184 + Math_fround(f190 * f196));
      f195 = Math_fround(f185 + Math_fround(f192 * f195));
      f194 = Math_fround(f194 + Math_fround(f197 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 92 >> 2])));
      i13 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i15 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i16 = (HEAPF32[tempDoublePtr >> 2] = f194, HEAP32[tempDoublePtr >> 2] | 0);
      f194 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 224 >> 2]);
      f195 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 228 >> 2]);
      f196 = Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 232 >> 2]);
      f194 = Math_fround(f187 + Math_fround(f188 * f194));
      f195 = Math_fround(f189 + Math_fround(f190 * f195));
      f196 = Math_fround(f191 + Math_fround(f192 * f196));
      f197 = Math_fround(f193 + Math_fround(f197 * Math_fround(HEAPF32[i60 + (i19 * 240 | 0) + 236 >> 2])));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f194, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f197, HEAP32[tempDoublePtr >> 2] | 0);
      HEAPF32[i75 >> 2] = f198;
      HEAPF32[i76 >> 2] = f199;
      HEAPF32[i77 >> 2] = f200;
      HEAPF32[i106 >> 2] = f201;
      f55 = Math_fround(f55 + f198);
      f57 = Math_fround(f57 + f199);
      f58 = Math_fround(f58 + f200);
      f59 = Math_fround(f59 + f201);
      i19 = i19 + 1 | 0;
      if ((i19 | 0) == (i70 | 0)) break; else i20 = i20 + 256 | 0;
     }
    }
    i42 = i18;
    i106 = i49 + (i70 << 8) | 0;
   }
   f194 = Math_fround(f118 * f30);
   f195 = Math_fround(f119 * f32);
   f196 = Math_fround(f120 * f34);
   f197 = Math_fround(f121 * f40);
   f198 = Math_fround(f122 * f30);
   f199 = Math_fround(f123 * f32);
   f200 = Math_fround(f124 * f34);
   f201 = Math_fround(f125 * f40);
   f193 = Math_fround(f96 + Math_fround(f102 * f194));
   f192 = Math_fround(f90 + Math_fround(f103 * f195));
   f191 = Math_fround(f84 + Math_fround(f104 * f196));
   f190 = Math_fround(f78 + Math_fround(f105 * f197));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
   f190 = Math_fround(f97 + Math_fround(f102 * f198));
   f191 = Math_fround(f91 + Math_fround(f103 * f199));
   f192 = Math_fround(f85 + Math_fround(f104 * f200));
   f193 = Math_fround(f79 + Math_fround(f105 * f201));
   i45 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
   i46 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
   i48 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
   i44 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
   f193 = Math_fround(f98 + Math_fround(f107 * f194));
   f192 = Math_fround(f92 + Math_fround(f108 * f195));
   f191 = Math_fround(f86 + Math_fround(f109 * f196));
   f190 = Math_fround(f80 + Math_fround(f110 * f197));
   i37 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
   i38 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
   i39 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
   i36 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
   f190 = Math_fround(f99 + Math_fround(f107 * f198));
   f191 = Math_fround(f93 + Math_fround(f108 * f199));
   f192 = Math_fround(f87 + Math_fround(f109 * f200));
   f193 = Math_fround(f81 + Math_fround(f110 * f201));
   i54 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
   i52 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
   i51 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
   i50 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
   f194 = Math_fround(f100 + Math_fround(f111 * f194));
   f195 = Math_fround(f94 + Math_fround(f112 * f195));
   f196 = Math_fround(f88 + Math_fround(f113 * f196));
   f197 = Math_fround(f82 + Math_fround(f114 * f197));
   i29 = (HEAPF32[tempDoublePtr >> 2] = f194, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f195, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f196, HEAP32[tempDoublePtr >> 2] | 0);
   i23 = (HEAPF32[tempDoublePtr >> 2] = f197, HEAP32[tempDoublePtr >> 2] | 0);
   f198 = Math_fround(f101 + Math_fround(f111 * f198));
   f199 = Math_fround(f95 + Math_fround(f112 * f199));
   f200 = Math_fround(f89 + Math_fround(f113 * f200));
   f201 = Math_fround(f83 + Math_fround(f114 * f201));
   i43 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
   i47 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
   i33 = (HEAPF32[tempDoublePtr >> 2] = f201, HEAP32[tempDoublePtr >> 2] | 0);
   if (i71 & (HEAP8[i130 >> 0] | 0) != 0) {
    f63 = Math_fround(HEAPF32[i72 + 32 >> 2]);
    f64 = Math_fround(HEAPF32[i72 + 36 >> 2]);
    f65 = Math_fround(HEAPF32[i72 + 40 >> 2]);
    f66 = Math_fround(HEAPF32[i72 + 44 >> 2]);
    f62 = Math_fround(HEAPF32[i72 + 48 >> 2]);
    f61 = Math_fround(HEAPF32[i72 + 52 >> 2]);
    f30 = Math_fround(HEAPF32[i72 + 56 >> 2]);
    f63 = Math_fround(f55 * f63);
    f64 = Math_fround(f57 * f64);
    f65 = Math_fround(f58 * f65);
    f66 = Math_fround(f59 * f66);
    f62 = Math_fround(f55 * f62);
    f61 = Math_fround(f57 * f61);
    f57 = Math_fround(f58 * f30);
    f30 = Math_fround(f59 * Math_fround(HEAPF32[i72 + 60 >> 2]));
    f32 = Math_fround(-f62);
    f34 = Math_fround(-f61);
    f40 = Math_fround(-f57);
    f55 = Math_fround(-f30);
    i74 = i126 + 4 | 0;
    i75 = i126 + 8 | 0;
    i76 = i126 + 12 | 0;
    i71 = i126 + 32 | 0;
    i72 = i126 + 64 | 0;
    i73 = i126 + 96 | 0;
    i77 = i116 << 8;
    i53 = i45;
    i56 = i46;
    i60 = i44;
    i49 = i43;
    i43 = HEAP32[i126 >> 2] | 0;
    i44 = HEAP32[i74 >> 2] | 0;
    i45 = HEAP32[i75 >> 2] | 0;
    i46 = HEAP32[i76 >> 2] | 0;
    i69 = 0;
    i70 = i106;
    while (1) {
     i205 = i115 + (i69 << 4) | 0;
     f192 = Math_fround(HEAPF32[i205 >> 2]);
     i204 = i115 + (i69 << 4) + 4 | 0;
     f194 = Math_fround(HEAPF32[i204 >> 2]);
     i203 = i115 + (i69 << 4) + 8 | 0;
     f196 = Math_fround(HEAPF32[i203 >> 2]);
     i202 = i115 + (i69 << 4) + 12 | 0;
     f201 = Math_fround(HEAPF32[i202 >> 2]);
     i206 = i69 & 1;
     f94 = Math_fround(HEAPF32[i71 + (i206 << 4) >> 2]);
     f103 = Math_fround(HEAPF32[i71 + (i206 << 4) + 4 >> 2]);
     f104 = Math_fround(HEAPF32[i71 + (i206 << 4) + 8 >> 2]);
     f98 = Math_fround(HEAPF32[i71 + (i206 << 4) + 12 >> 2]);
     f158 = Math_fround(HEAPF32[i72 + (i206 << 4) >> 2]);
     f167 = Math_fround(HEAPF32[i72 + (i206 << 4) + 4 >> 2]);
     f168 = Math_fround(HEAPF32[i72 + (i206 << 4) + 8 >> 2]);
     f162 = Math_fround(HEAPF32[i72 + (i206 << 4) + 12 >> 2]);
     f179 = Math_fround(HEAPF32[i73 + (i206 << 4) >> 2]);
     f181 = Math_fround(HEAPF32[i73 + (i206 << 4) + 4 >> 2]);
     f183 = Math_fround(HEAPF32[i73 + (i206 << 4) + 8 >> 2]);
     f185 = Math_fround(HEAPF32[i73 + (i206 << 4) + 12 >> 2]);
     f86 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f58 = Math_fround(f86 * f94);
     f87 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f78 = Math_fround(f87 * f103);
     f88 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f82 = Math_fround(f88 * f104);
     f89 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f190 = Math_fround(f89 * f98);
     f114 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) >> 2]);
     f113 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 4 >> 2]);
     f112 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 8 >> 2]);
     f111 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 12 >> 2]);
     f95 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f114 = Math_fround(f95 * f114);
     f96 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f113 = Math_fround(f96 * f113);
     f97 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f112 = Math_fround(f97 * f112);
     f102 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f111 = Math_fround(f102 * f111);
     f90 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f90 * f94);
     f91 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(f91 * f103);
     f92 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f176 = Math_fround(f92 * f104);
     f93 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f93 * f98);
     f173 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 128 >> 2]);
     f172 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 132 >> 2]);
     f171 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 136 >> 2]);
     f170 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 140 >> 2]);
     f99 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f173 = Math_fround(f99 * f173);
     f100 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f172 = Math_fround(f100 * f172);
     f101 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f171 = Math_fround(f101 * f171);
     f105 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f170 = Math_fround(f105 * f170);
     f107 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f108 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f109 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f110 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f58 = Math_fround(f58 + Math_fround(f107 * f158));
     f78 = Math_fround(f78 + Math_fround(f108 * f167));
     f82 = Math_fround(f82 + Math_fround(f109 * f168));
     f190 = Math_fround(f190 + Math_fround(f110 * f162));
     f184 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 16 >> 2]);
     f182 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 20 >> 2]);
     f180 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 24 >> 2]);
     f178 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 28 >> 2]);
     f159 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f160 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f161 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f166 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f184 = Math_fround(f114 + Math_fround(f159 * f184));
     f182 = Math_fround(f113 + Math_fround(f160 * f182));
     f180 = Math_fround(f112 + Math_fround(f161 * f180));
     f178 = Math_fround(f111 + Math_fround(f166 * f178));
     f111 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f112 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f113 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f114 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f67 + Math_fround(f111 * f158));
     f80 = Math_fround(f80 + Math_fround(f112 * f167));
     f176 = Math_fround(f176 + Math_fround(f113 * f168));
     f85 = Math_fround(f85 + Math_fround(f114 * f162));
     f68 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 144 >> 2]);
     f81 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 148 >> 2]);
     f177 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 152 >> 2]);
     f83 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 156 >> 2]);
     f163 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f164 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f165 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f169 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f68 = Math_fround(f173 + Math_fround(f163 * f68));
     f81 = Math_fround(f172 + Math_fround(f164 * f81));
     f177 = Math_fround(f171 + Math_fround(f165 * f177));
     f83 = Math_fround(f170 + Math_fround(f169 * f83));
     f170 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f171 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f172 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f173 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f58 = Math_fround(f58 + Math_fround(f170 * f179));
     f78 = Math_fround(f78 + Math_fround(f171 * f181));
     f82 = Math_fround(f82 + Math_fround(f172 * f183));
     f190 = Math_fround(f190 + Math_fround(f173 * f185));
     f59 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 32 >> 2]);
     f79 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 36 >> 2]);
     f175 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 40 >> 2]);
     f199 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 44 >> 2]);
     f187 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f188 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f189 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f198 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f59 = Math_fround(f184 + Math_fround(f187 * f59));
     f79 = Math_fround(f182 + Math_fround(f188 * f79));
     f175 = Math_fround(f180 + Math_fround(f189 * f175));
     f199 = Math_fround(f178 + Math_fround(f198 * f199));
     f178 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f180 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f182 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f184 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f67 + Math_fround(f178 * f179));
     f80 = Math_fround(f80 + Math_fround(f180 * f181));
     f176 = Math_fround(f176 + Math_fround(f182 * f183));
     f85 = Math_fround(f85 + Math_fround(f184 * f185));
     f84 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 160 >> 2]);
     f186 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 164 >> 2]);
     f200 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 168 >> 2]);
     f174 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 172 >> 2]);
     f191 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f193 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f195 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f197 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(Math_fround(f58 + f59) - Math_fround(f67 + Math_fround(f68 + Math_fround(f191 * f84))));
     f186 = Math_fround(Math_fround(f78 + f79) - Math_fround(f80 + Math_fround(f81 + Math_fround(f193 * f186))));
     f200 = Math_fround(Math_fround(f82 + f175) - Math_fround(f176 + Math_fround(f177 + Math_fround(f195 * f200))));
     f174 = Math_fround(Math_fround(f190 + f199) - Math_fround(f85 + Math_fround(f83 + Math_fround(f197 * f174))));
     f83 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 96 >> 2]);
     f85 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 100 >> 2]);
     f199 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 104 >> 2]);
     f83 = Math_fround(f192 - f83);
     f85 = Math_fround(f194 - f85);
     f199 = Math_fround(f196 - f199);
     f190 = Math_fround(f201 - Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 108 >> 2]));
     f177 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 112 >> 2]);
     f176 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 116 >> 2]);
     f175 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 120 >> 2]);
     f177 = Math_fround(f83 - Math_fround(f84 * f177));
     f176 = Math_fround(f85 - Math_fround(f186 * f176));
     f175 = Math_fround(f199 - Math_fround(f200 * f175));
     f174 = Math_fround(f190 - Math_fround(f174 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 124 >> 2])));
     f190 = Math_fround(-f177);
     f200 = Math_fround(-f176);
     f199 = Math_fround(-f175);
     f186 = Math_fround(-f174);
     i43 = (i43 | 0 ? 1 : (f177 > f190 ? f177 : f190) > f63) << 31 >> 31;
     i44 = (i44 | 0 ? 1 : (f176 > f200 ? f176 : f200) > f64) << 31 >> 31;
     i45 = (i45 | 0 ? 1 : (f175 > f199 ? f175 : f199) > f65) << 31 >> 31;
     i46 = (i46 | 0 ? 1 : (f174 > f186 ? f174 : f186) > f66) << 31 >> 31;
     f177 = f177 < f32 ? f32 : f177;
     f176 = f176 < f34 ? f34 : f176;
     f175 = f175 < f40 ? f40 : f175;
     f174 = f174 < f55 ? f55 : f174;
     f177 = f62 < f177 ? f62 : f177;
     f176 = f61 < f176 ? f61 : f176;
     f175 = f57 < f175 ? f57 : f175;
     f174 = f30 < f174 ? f30 : f174;
     f192 = Math_fround(f177 - f192);
     f194 = Math_fround(f176 - f194);
     f196 = Math_fround(f175 - f196);
     f201 = Math_fround(f174 - f201);
     HEAPF32[i205 >> 2] = f177;
     HEAPF32[i204 >> 2] = f176;
     HEAPF32[i203 >> 2] = f175;
     HEAPF32[i202 >> 2] = f174;
     f174 = Math_fround(f118 * f192);
     f175 = Math_fround(f119 * f194);
     f176 = Math_fround(f120 * f196);
     f177 = Math_fround(f121 * f201);
     f186 = Math_fround(f122 * f192);
     f199 = Math_fround(f123 * f194);
     f200 = Math_fround(f124 * f196);
     f190 = Math_fround(f125 * f201);
     f86 = Math_fround(f86 + Math_fround(f94 * f174));
     f87 = Math_fround(f87 + Math_fround(f103 * f175));
     f88 = Math_fround(f88 + Math_fround(f104 * f176));
     f89 = Math_fround(f89 + Math_fround(f98 * f177));
     i19 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
     i20 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
     i18 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
     f94 = Math_fround(f90 + Math_fround(f94 * f186));
     f103 = Math_fround(f91 + Math_fround(f103 * f199));
     f104 = Math_fround(f92 + Math_fround(f104 * f200));
     f98 = Math_fround(f93 + Math_fround(f98 * f190));
     i53 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
     i56 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i48 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i60 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
     f98 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 48 >> 2]);
     f104 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 52 >> 2]);
     f103 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 56 >> 2]);
     f98 = Math_fround(f95 + Math_fround(f98 * f192));
     f104 = Math_fround(f96 + Math_fround(f104 * f194));
     f103 = Math_fround(f97 + Math_fround(f103 * f196));
     f102 = Math_fround(f102 + Math_fround(Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 60 >> 2]) * f201));
     i28 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
     i31 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i35 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i42 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
     f102 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 176 >> 2]);
     f103 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 180 >> 2]);
     f104 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 184 >> 2]);
     f102 = Math_fround(f99 + Math_fround(f192 * f102));
     f103 = Math_fround(f100 + Math_fround(f194 * f103));
     f104 = Math_fround(f101 + Math_fround(f196 * f104));
     f105 = Math_fround(f105 + Math_fround(f201 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 188 >> 2])));
     i9 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     f107 = Math_fround(f107 + Math_fround(f158 * f174));
     f108 = Math_fround(f108 + Math_fround(f167 * f175));
     f109 = Math_fround(f109 + Math_fround(f168 * f176));
     f110 = Math_fround(f110 + Math_fround(f162 * f177));
     i37 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
     i38 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
     i39 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
     i36 = (HEAPF32[tempDoublePtr >> 2] = f110, HEAP32[tempDoublePtr >> 2] | 0);
     f158 = Math_fround(f111 + Math_fround(f158 * f186));
     f167 = Math_fround(f112 + Math_fround(f167 * f199));
     f168 = Math_fround(f113 + Math_fround(f168 * f200));
     f162 = Math_fround(f114 + Math_fround(f162 * f190));
     i54 = (HEAPF32[tempDoublePtr >> 2] = f158, HEAP32[tempDoublePtr >> 2] | 0);
     i52 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
     i51 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
     i50 = (HEAPF32[tempDoublePtr >> 2] = f162, HEAP32[tempDoublePtr >> 2] | 0);
     f162 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 64 >> 2]);
     f168 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 68 >> 2]);
     f167 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 72 >> 2]);
     f162 = Math_fround(f159 + Math_fround(f192 * f162));
     f168 = Math_fround(f160 + Math_fround(f194 * f168));
     f167 = Math_fround(f161 + Math_fround(f196 * f167));
     f166 = Math_fround(f166 + Math_fround(f201 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 76 >> 2])));
     i17 = (HEAPF32[tempDoublePtr >> 2] = f162, HEAP32[tempDoublePtr >> 2] | 0);
     i22 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
     i24 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
     i26 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     f166 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 192 >> 2]);
     f167 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 196 >> 2]);
     f168 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 200 >> 2]);
     f166 = Math_fround(f163 + Math_fround(f192 * f166));
     f167 = Math_fround(f164 + Math_fround(f194 * f167));
     f168 = Math_fround(f165 + Math_fround(f196 * f168));
     f169 = Math_fround(f169 + Math_fround(f201 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 204 >> 2])));
     i5 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f169, HEAP32[tempDoublePtr >> 2] | 0);
     f174 = Math_fround(f170 + Math_fround(f179 * f174));
     f175 = Math_fround(f171 + Math_fround(f181 * f175));
     f176 = Math_fround(f172 + Math_fround(f183 * f176));
     f177 = Math_fround(f173 + Math_fround(f185 * f177));
     i29 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
     i27 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
     i25 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
     i23 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
     f186 = Math_fround(f178 + Math_fround(f179 * f186));
     f199 = Math_fround(f180 + Math_fround(f181 * f199));
     f200 = Math_fround(f182 + Math_fround(f183 * f200));
     f190 = Math_fround(f184 + Math_fround(f185 * f190));
     i49 = (HEAPF32[tempDoublePtr >> 2] = f186, HEAP32[tempDoublePtr >> 2] | 0);
     i47 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
     i41 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
     i33 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
     f190 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 80 >> 2]);
     f200 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 84 >> 2]);
     f199 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 88 >> 2]);
     f190 = Math_fround(f187 + Math_fround(f192 * f190));
     f200 = Math_fround(f188 + Math_fround(f194 * f200));
     f199 = Math_fround(f189 + Math_fround(f196 * f199));
     f198 = Math_fround(f198 + Math_fround(f201 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 92 >> 2])));
     i13 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
     i15 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
     f198 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 208 >> 2]);
     f199 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 212 >> 2]);
     f200 = Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 216 >> 2]);
     f198 = Math_fround(f191 + Math_fround(f192 * f198));
     f199 = Math_fround(f193 + Math_fround(f194 * f199));
     f200 = Math_fround(f195 + Math_fround(f196 * f200));
     f201 = Math_fround(f197 + Math_fround(f201 * Math_fround(HEAPF32[i117 + (i69 * 224 | 0) + 220 >> 2])));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f201, HEAP32[tempDoublePtr >> 2] | 0);
     i69 = i69 + 1 | 0;
     if ((i69 | 0) == (i116 | 0)) break; else i70 = i70 + 256 | 0;
    }
    HEAP32[i126 >> 2] = i43;
    HEAP32[i74 >> 2] = i44;
    HEAP32[i75 >> 2] = i45;
    HEAP32[i76 >> 2] = i46;
    i44 = i60;
    i46 = i56;
    i45 = i53;
    i53 = i54;
    i43 = i49;
    i49 = i106 + i77 | 0;
   } else {
    i53 = i54;
    i49 = i106;
   }
  } while (i127 >>> 0 < i128 >>> 0);
  i49 = i53;
 }
 HEAP32[i132 >> 2] = i19;
 HEAP32[i132 + 4 >> 2] = i37;
 HEAP32[i132 + 8 >> 2] = i29;
 HEAP32[i132 + 12 >> 2] = i142;
 HEAP32[i132 + 16 >> 2] = i28;
 HEAP32[i132 + 20 >> 2] = i17;
 HEAP32[i132 + 24 >> 2] = i13;
 HEAP32[i132 + 28 >> 2] = i144;
 HEAP32[i145 >> 2] = i20;
 HEAP32[i145 + 4 >> 2] = i38;
 HEAP32[i145 + 8 >> 2] = i27;
 HEAP32[i145 + 12 >> 2] = i147;
 HEAP32[i145 + 16 >> 2] = i31;
 HEAP32[i145 + 20 >> 2] = i22;
 HEAP32[i145 + 24 >> 2] = i14;
 HEAP32[i145 + 28 >> 2] = i150;
 HEAP32[i152 >> 2] = i21;
 HEAP32[i152 + 4 >> 2] = i39;
 HEAP32[i152 + 8 >> 2] = i25;
 HEAP32[i152 + 12 >> 2] = i153;
 HEAP32[i152 + 16 >> 2] = i35;
 HEAP32[i152 + 20 >> 2] = i24;
 HEAP32[i152 + 24 >> 2] = i15;
 HEAP32[i152 + 28 >> 2] = i155;
 HEAP32[i137 >> 2] = i18;
 HEAP32[i137 + 4 >> 2] = i36;
 HEAP32[i137 + 8 >> 2] = i23;
 HEAP32[i137 + 12 >> 2] = i135;
 HEAP32[i137 + 16 >> 2] = i42;
 HEAP32[i137 + 20 >> 2] = i26;
 HEAP32[i137 + 24 >> 2] = i16;
 HEAP32[i137 + 28 >> 2] = i138;
 if (HEAP16[i156 + 14 >> 1] | 0) {
  HEAP32[i141 >> 2] = i45;
  HEAP32[i141 + 4 >> 2] = i49;
  HEAP32[i141 + 8 >> 2] = i43;
  HEAP32[i141 + 12 >> 2] = i143;
  HEAP32[i141 + 16 >> 2] = i9;
  HEAP32[i141 + 20 >> 2] = i5;
  HEAP32[i141 + 24 >> 2] = i1;
  HEAP32[i141 + 28 >> 2] = i146;
 }
 if (HEAP16[i156 + 46 >> 1] | 0) {
  HEAP32[i149 >> 2] = i46;
  HEAP32[i149 + 4 >> 2] = i52;
  HEAP32[i149 + 8 >> 2] = i47;
  HEAP32[i149 + 12 >> 2] = i148;
  HEAP32[i149 + 16 >> 2] = i10;
  HEAP32[i149 + 20 >> 2] = i6;
  HEAP32[i149 + 24 >> 2] = i2;
  HEAP32[i149 + 28 >> 2] = i151;
 }
 if (HEAP16[i156 + 78 >> 1] | 0) {
  HEAP32[i133 >> 2] = i48;
  HEAP32[i133 + 4 >> 2] = i51;
  HEAP32[i133 + 8 >> 2] = i41;
  HEAP32[i133 + 12 >> 2] = i154;
  HEAP32[i133 + 16 >> 2] = i11;
  HEAP32[i133 + 20 >> 2] = i7;
  HEAP32[i133 + 24 >> 2] = i3;
  HEAP32[i133 + 28 >> 2] = i134;
 }
 if (!(HEAP16[i156 + 110 >> 1] | 0)) {
  STACKTOP = i157;
  return;
 }
 HEAP32[i140 >> 2] = i44;
 HEAP32[i140 + 4 >> 2] = i50;
 HEAP32[i140 + 8 >> 2] = i33;
 HEAP32[i140 + 12 >> 2] = i136;
 HEAP32[i140 + 16 >> 2] = i12;
 HEAP32[i140 + 20 >> 2] = i8;
 HEAP32[i140 + 24 >> 2] = i4;
 HEAP32[i140 + 28 >> 2] = i139;
 STACKTOP = i157;
 return;
}

function __ZN5Umbra5Query22queryFrustumVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEfPKNS_20ObjectDistanceParamsEii(i1, i12, i9, i7, f4, i10, i15, i14) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 f4 = Math_fround(f4);
 i10 = i10 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f8 = f0, i11 = 0, i13 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, f91 = f0, f92 = f0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, f155 = f0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, f161 = f0, f162 = f0, f163 = f0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, f214 = f0, f215 = f0, f216 = f0, f217 = f0;
 i183 = STACKTOP;
 STACKTOP = STACKTOP + 1936 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i177 = i183 + 1920 | 0;
 i178 = i183 + 1904 | 0;
 i181 = i183 + 1840 | 0;
 i173 = i183 + 160 | 0;
 i182 = i183 + 1768 | 0;
 i174 = i183 + 1752 | 0;
 i175 = i183 + 1660 | 0;
 i13 = i183 + 1568 | 0;
 i176 = i183;
 i6 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i181 >> 2] = i6;
 i2 = HEAP32[i6 + 76 >> 2] | 0;
 HEAP32[i181 + 4 >> 2] = i2;
 i180 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = i180 + -16 - i1 & -16;
 i3 = i1 + i5 | 0;
 if (i3 >>> 0 > i180 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i181 + 8 >> 2] = i1;
 HEAP32[i181 + 12 >> 2] = i1 + i5;
 i2 = i181 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i181 + 20 >> 2] = i5;
 HEAP32[i181 + 24 >> 2] = 0;
 i180 = i181 + 28 | 0;
 HEAP32[i180 >> 2] = 0;
 HEAP32[i181 + 32 >> 2] = i12;
 HEAP32[i181 + 36 >> 2] = 0;
 HEAP32[i181 + 40 >> 2] = -1;
 i172 = HEAP32[i6 + 84 >> 2] | 0;
 HEAP32[i181 + 44 >> 2] = i172;
 HEAP32[i181 + 48 >> 2] = i172;
 HEAP32[i181 + 52 >> 2] = 0;
 HEAP32[i181 + 56 >> 2] = 0;
 if ((i5 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i181 + 60 >> 2] = i1;
 i3 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 if (!(HEAP32[i6 >> 2] | 0)) {
  i182 = 6;
  __ZN5Umbra12QueryContextD2Ev(i181);
  STACKTOP = i183;
  return i182 | 0;
 }
 if ((i14 + -1 | 0) >>> 0 > 15) {
  i182 = 3;
  __ZN5Umbra12QueryContextD2Ev(i181);
  STACKTOP = i183;
  return i182 | 0;
 }
 if ((i15 | 0) < 0 | (i15 | 0) >= (i14 | 0)) {
  i182 = 3;
  __ZN5Umbra12QueryContextD2Ev(i181);
  STACKTOP = i183;
  return i182 | 0;
 }
 i2 = i7 + 3 & -4;
 HEAPF32[i173 >> 2] = Math_fround(1.0);
 i167 = i173 + 4 | 0;
 HEAP32[i167 >> 2] = 0;
 HEAP32[i167 + 4 >> 2] = 0;
 HEAP32[i167 + 8 >> 2] = 0;
 HEAP32[i167 + 12 >> 2] = 0;
 HEAPF32[i173 + 20 >> 2] = Math_fround(1.0);
 i167 = i173 + 24 | 0;
 HEAP32[i167 >> 2] = 0;
 HEAP32[i167 + 4 >> 2] = 0;
 HEAP32[i167 + 8 >> 2] = 0;
 HEAP32[i167 + 12 >> 2] = 0;
 HEAPF32[i173 + 40 >> 2] = Math_fround(1.0);
 i167 = i173 + 44 | 0;
 HEAP32[i167 >> 2] = 0;
 HEAP32[i167 + 4 >> 2] = 0;
 HEAP32[i167 + 8 >> 2] = 0;
 HEAP32[i167 + 12 >> 2] = 0;
 HEAPF32[i173 + 60 >> 2] = Math_fround(1.0);
 i167 = i173 + 64 | 0;
 HEAPF32[i167 >> 2] = Math_fround(1.0);
 i168 = i173 + 68 | 0;
 i169 = i173 + 84 | 0;
 HEAP32[i168 >> 2] = 0;
 HEAP32[i168 + 4 >> 2] = 0;
 HEAP32[i168 + 8 >> 2] = 0;
 HEAP32[i168 + 12 >> 2] = 0;
 HEAPF32[i169 >> 2] = Math_fround(1.0);
 i170 = i173 + 88 | 0;
 HEAP32[i170 >> 2] = 0;
 HEAP32[i170 + 4 >> 2] = 0;
 HEAP32[i170 + 8 >> 2] = 0;
 HEAP32[i170 + 12 >> 2] = 0;
 HEAPF32[i173 + 104 >> 2] = Math_fround(1.0);
 i170 = i173 + 108 | 0;
 i171 = i173 + 124 | 0;
 HEAP32[i170 >> 2] = 0;
 HEAP32[i170 + 4 >> 2] = 0;
 HEAP32[i170 + 8 >> 2] = 0;
 HEAP32[i170 + 12 >> 2] = 0;
 HEAPF32[i171 >> 2] = Math_fround(1.0);
 i172 = i173 + 128 | 0;
 i1 = i173 + 1208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i173 + 1376 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 _memset(i172 | 0, 0, 1068) | 0;
 i1 = i173 + 1316 | 0;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF32[i177 >> 2] = f4;
 HEAPF32[i177 + 4 >> 2] = f4;
 HEAPF32[i177 + 8 >> 2] = f4;
 __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii(i173, i2, i177, 0, 1, 0);
 if (i12 & 512 | 0) __ZN5Umbra12QueryContext16visualizeFrustumERKNS_11TransformerE(i181, i173);
 __ZN5Umbra16VisibilityResultC2ERNS_12QueryContextERKNS_10VisibilityERKNS_11TransformerEb(i182, i181, i9, i173, 0);
 i11 = (i10 | 0) == 0;
 i10 = i10 + 3 & -4;
 i2 = i11 ? 0 : i10;
 i1 = (i2 | 0) == 0;
 if (i1) {
  f4 = Math_fround(0.0);
  i179 = 13;
 } else {
  f4 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  if (f4 > Math_fround(0.0)) i165 = 1; else i179 = 13;
 }
 if ((i179 | 0) == 13) i165 = (HEAP32[i182 + 52 >> 2] | 0) != 0;
 i166 = i182 + 4 | 0;
 if (!(HEAP32[i166 >> 2] | 0)) {
  if (HEAP32[i182 + 16 >> 2] | 0) i179 = 16;
 } else i179 = 16;
 if ((i179 | 0) == 16) {
  i9 = i173 + 1184 | 0;
  if (i1) {
   i6 = i173 + 1188 | 0;
   i7 = i173 + 1192 | 0;
   f8 = Math_fround(1.0);
   i1 = i7;
   i3 = i6;
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i7 >> 2] | 0;
  } else {
   i7 = (HEAP8[i2 + 16 >> 0] | 0) == 0;
   i3 = i173 + 1188 | 0;
   i1 = i173 + 1192 | 0;
   i5 = HEAP32[(i7 ? i9 : i2) >> 2] | 0;
   i6 = HEAP32[(i7 ? i3 : i2 + 4 | 0) >> 2] | 0;
   i7 = HEAP32[(i7 ? i1 : i2 + 8 | 0) >> 2] | 0;
   f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   if (f8 <= Math_fround(0.0)) f8 = Math_fround(1.0);
  }
  f163 = Math_fround(f8 * f8);
  i164 = (HEAP8[i173 + 1365 >> 0] | 0) != 0;
  f162 = Math_fround(HEAPF32[i9 >> 2]);
  f161 = Math_fround(HEAPF32[i3 >> 2]);
  f155 = Math_fround(HEAPF32[i1 >> 2]);
  f73 = Math_fround(HEAPF32[i172 >> 2]);
  i156 = i173 + 132 | 0;
  f91 = Math_fround(HEAPF32[i156 >> 2]);
  i157 = i173 + 136 | 0;
  i158 = i173 + 140 | 0;
  f91 = Math_fround(-f91);
  f92 = Math_fround(-Math_fround(HEAPF32[i157 >> 2]));
  HEAPF32[i174 >> 2] = Math_fround(-f73);
  i159 = i174 + 4 | 0;
  HEAPF32[i159 >> 2] = f91;
  i160 = i174 + 8 | 0;
  HEAPF32[i160 >> 2] = f92;
  HEAP32[i175 >> 2] = 0;
  i154 = (i12 & 8 | 0) == 0;
  i1 = HEAP32[i181 >> 2] | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) i13 = 0; else if ((HEAP32[i2 + 44 >> 2] | 0) > 1) {
   i148 = HEAP32[i1 >> 2] | 0;
   i149 = HEAP32[i148 + 24 >> 2] | 0;
   i150 = HEAP32[i148 + 28 >> 2] | 0;
   i151 = HEAP32[i148 + 32 >> 2] | 0;
   i152 = HEAP32[i148 + 36 >> 2] | 0;
   i153 = HEAP32[i148 + 40 >> 2] | 0;
   HEAP32[i177 >> 2] = HEAP32[i148 + 20 >> 2];
   HEAP32[i177 + 4 >> 2] = i149;
   HEAP32[i177 + 8 >> 2] = i150;
   HEAP32[i177 + 12 >> 2] = 1065353216;
   HEAP32[i178 >> 2] = i151;
   HEAP32[i178 + 4 >> 2] = i152;
   HEAP32[i178 + 8 >> 2] = i153;
   HEAP32[i178 + 12 >> 2] = 1065353216;
   __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i173, i13, 0, i177, i178) | 0;
  } else i13 = 0;
  if (i11) i153 = 0; else i153 = Math_fround(HEAPF32[i10 + 12 >> 2]) == Math_fround(0.0);
  i147 = i176 + 12 | 0;
  HEAP32[i147 >> 2] = i15;
  i148 = i176 + 16 | 0;
  HEAP32[i148 >> 2] = i14;
  HEAP32[i176 + 20 >> 2] = -1;
  i149 = i176 + 24 | 0;
  HEAP32[i149 >> 2] = 0;
  i150 = i176 + 28 | 0;
  HEAP32[i150 >> 2] = 0;
  i151 = i176 + 32 | 0;
  HEAP32[i151 >> 2] = 0;
  i152 = i176 + 104 | 0;
  i2 = i176 + 156 | 0;
  i1 = i152;
  i3 = i1 + 52 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i1 = HEAP32[i181 >> 2] | 0;
  HEAP32[i176 >> 2] = i1;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) i179 = 27; else if (!(HEAP8[i2 + 24 >> 0] | 0)) i179 = 27; else {
   i1 = HEAP32[i2 + 44 >> 2] | 0;
   HEAP32[i176 + 48 >> 2] = i1;
   i10 = i176 + 56 | 0;
   i3 = i176 + 52 | 0;
   do if ((i14 | 0) == 0 | (i1 | 0) == 0) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
   } else {
    i9 = (i1 | 0) / (i14 | 0) | 0;
    i2 = i1 - (Math_imul(i9, i14) | 0) | 0;
    if ((i2 | 0) > -1) {
     i145 = (i2 | 0) > (i15 | 0);
     i146 = i9 + 1 | 0;
     i143 = Math_imul(i146, i15) | 0;
     i144 = i2 + (Math_imul(i9, i15) | 0) | 0;
     HEAP32[i10 >> 2] = i145 ? i143 : i144;
     HEAP32[i3 >> 2] = i145 ? i146 : i9;
     break;
    }
    HEAP32[i10 >> 2] = Math_imul(i9, i15) | 0;
    i146 = i2 + i14 | 0;
    i1 = (i146 | 0) > (i15 | 0) ? i9 : 0;
    HEAP32[i3 >> 2] = i1;
    if ((i146 + -1 | 0) == (i15 | 0)) HEAP32[i3 >> 2] = i2 - (Math_imul(i2, i9) | 0) + i1;
   } while (0);
   i145 = i176 + 4 | 0;
   HEAP32[i145 >> 2] = 0;
   i146 = i176 + 64 | 0;
   HEAP8[i146 >> 0] = 0;
   i134 = i176 + 60 | 0;
  }
  if ((i179 | 0) == 27) {
   HEAP32[i176 + 48 >> 2] = 1;
   i10 = i176 + 56 | 0;
   HEAP32[i10 >> 2] = 0;
   i3 = i176 + 52 | 0;
   HEAP32[i3 >> 2] = 1;
   i145 = i176 + 4 | 0;
   HEAP32[i145 >> 2] = 0;
   i134 = i176 + 60 | 0;
   HEAP32[i134 >> 2] = HEAP32[i1 >> 2];
   i146 = i176 + 64 | 0;
   HEAP8[i146 >> 0] = 1;
  }
  i138 = i176 + 20 | 0;
  i135 = i176 + 36 | 0;
  i136 = i176 + 40 | 0;
  i137 = i176 + 44 | 0;
  i139 = i176 + 8 | 0;
  i140 = i176 + 76 | 0;
  i141 = i176 + 88 | 0;
  i142 = i176 + 84 | 0;
  i143 = i176 + 100 | 0;
  i144 = i176 + 96 | 0;
  i93 = (i13 | 0) == 0;
  i133 = i93 ? i173 + 1196 | 0 : i13;
  i93 = i93 ? i173 + 1228 | 0 : i13 + 4 | 0;
  i95 = i173 + 1332 | 0;
  i96 = i173 + 1336 | 0;
  i97 = i173 + 1340 | 0;
  i98 = i173 + 1344 | 0;
  i99 = i173 + 1316 | 0;
  i100 = i173 + 1320 | 0;
  i101 = i173 + 1324 | 0;
  i102 = i173 + 1328 | 0;
  i103 = i177 + 4 | 0;
  i104 = i177 + 8 | 0;
  i105 = i177 + 12 | 0;
  i106 = i178 + 4 | 0;
  i107 = i178 + 8 | 0;
  i108 = i178 + 12 | 0;
  i109 = i177 + 4 | 0;
  i110 = i177 + 8 | 0;
  i111 = i182 + 36 | 0;
  i112 = i176 + 68 | 0;
  i113 = i176 + 72 | 0;
  i114 = i182 + 12 | 0;
  i115 = i182 + 16 | 0;
  i94 = i164 ^ 1;
  i116 = i176 + 108 | 0;
  i117 = i176 + 112 | 0;
  i118 = i176 + 116 | 0;
  i119 = i176 + 120 | 0;
  i120 = i176 + 124 | 0;
  i121 = i176 + 128 | 0;
  i122 = i173 + 76 | 0;
  i123 = i173 + 80 | 0;
  i124 = i173 + 92 | 0;
  i125 = i173 + 96 | 0;
  i126 = i173 + 100 | 0;
  i127 = i173 + 112 | 0;
  i128 = i173 + 116 | 0;
  i129 = i182 + 52 | 0;
  i130 = i182 + 60 | 0;
  i131 = i182 + 56 | 0;
  i132 = i176 + 144 | 0;
  f92 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f91 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f73 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i74 = i182 + 44 | 0;
  i75 = i182 + 40 | 0;
  i76 = i177 + 4 | 0;
  i77 = i177 + 8 | 0;
  i78 = i177 + 12 | 0;
  i79 = i178 + 4 | 0;
  i80 = i178 + 8 | 0;
  i81 = i177 + 4 | 0;
  i82 = i177 + 8 | 0;
  i83 = i121 + 4 | 0;
  i84 = i121 + 8 | 0;
  i85 = i121 + 12 | 0;
  i86 = i176 + 144 | 0;
  i87 = i86 + 4 | 0;
  i88 = i86 + 8 | 0;
  i89 = i86 + 12 | 0;
  i90 = i175 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i145 >> 2] | 0;
  L55 : do if (i2 | i5 | 0) {
   i72 = 0;
   i1 = 0;
   i9 = 0;
   i6 = 0;
   i11 = 0;
   i14 = 0;
   i12 = 0;
   i13 = 0;
   L56 : while (1) {
    do if (!i5) {
     i32 = (HEAP8[i146 >> 0] | 0) == 0;
     i69 = HEAP32[i176 >> 2] | 0;
     i70 = i69 + 4 | 0;
     i71 = i69 + 92 | 0;
     while (1) {
      if (i32) {
       i7 = HEAP32[i10 >> 2] | 0;
       do {
        i5 = HEAP32[i70 >> 2] | 0;
        do if ((i7 | 0) != -1 & (i5 | 0) != 0) {
         i5 = (HEAP32[i5 + 32 >> 2] | 0) + ((HEAP32[i5 + 40 >> 2] | 0) + (i7 << 5)) | 0;
         if (!i5) {
          i179 = 49;
          break;
         }
         i30 = HEAP32[i5 >> 2] | 0;
         i26 = HEAP32[i69 >> 2] | 0;
         i27 = HEAP32[i26 + (HEAP32[i26 + 180 >> 2] | 0) + (i7 << 2) >> 2] | 0;
         i29 = i26 + (HEAP32[i26 + 184 >> 2] | 0) | 0;
         i28 = HEAP32[i29 + (i7 << 2) >> 2] | 0;
         i31 = i7 + 1 | 0;
         i29 = (HEAP32[i29 + (i31 << 2) >> 2] | 0) - i28 | 0;
         HEAP32[i138 >> 2] = i7;
         HEAP32[i149 >> 2] = i5;
         HEAP32[i150 >> 2] = i30;
         HEAP32[i151 >> 2] = i26;
         HEAP32[i135 >> 2] = i27;
         HEAP32[i136 >> 2] = i28;
         HEAP32[i137 >> 2] = i29;
         HEAP32[i71 >> 2] = HEAP32[i138 >> 2];
         HEAP32[i71 + 4 >> 2] = HEAP32[i138 + 4 >> 2];
         HEAP32[i71 + 8 >> 2] = HEAP32[i138 + 8 >> 2];
         HEAP32[i71 + 12 >> 2] = HEAP32[i138 + 12 >> 2];
         HEAP32[i71 + 16 >> 2] = HEAP32[i138 + 16 >> 2];
         HEAP32[i71 + 20 >> 2] = HEAP32[i138 + 20 >> 2];
         HEAP32[i71 + 24 >> 2] = HEAP32[i138 + 24 >> 2];
         i5 = i30;
         i7 = i31;
        } else i179 = 49; while (0);
        if ((i179 | 0) == 49) {
         i179 = 0;
         i5 = HEAP32[i69 >> 2] | 0;
         HEAP32[i138 >> 2] = 0;
         HEAP32[i149 >> 2] = 0;
         HEAP32[i150 >> 2] = i5;
         HEAP32[i151 >> 2] = i5;
         HEAP32[i135 >> 2] = 0;
         HEAP32[i136 >> 2] = 0;
         HEAP32[i137 >> 2] = 0;
         HEAP32[i71 >> 2] = HEAP32[i138 >> 2];
         HEAP32[i71 + 4 >> 2] = HEAP32[i138 + 4 >> 2];
         HEAP32[i71 + 8 >> 2] = HEAP32[i138 + 8 >> 2];
         HEAP32[i71 + 12 >> 2] = HEAP32[i138 + 12 >> 2];
         HEAP32[i71 + 16 >> 2] = HEAP32[i138 + 16 >> 2];
         HEAP32[i71 + 20 >> 2] = HEAP32[i138 + 20 >> 2];
         HEAP32[i71 + 24 >> 2] = HEAP32[i138 + 24 >> 2];
         i7 = i7 + 1 | 0;
        }
        HEAP32[i139 >> 2] = 0;
        i15 = HEAP32[i5 + 64 >> 2] | 0;
        HEAP32[i145 >> 2] = i15;
        HEAP32[i10 >> 2] = i7;
        i2 = i2 + -1 | 0;
        HEAP32[i3 >> 2] = i2;
       } while (!((i15 | 0) != 0 | (i2 | 0) == 0));
       HEAP32[i134 >> 2] = i5;
       i7 = 0;
       i19 = i15;
       i2 = i15;
      } else {
       i15 = HEAP32[i147 >> 2] | 0;
       i19 = HEAP32[i148 >> 2] | 0;
       i5 = HEAP32[i134 >> 2] | 0;
       i22 = HEAP32[i5 + 64 >> 2] | 0;
       do if ((i19 | 0) == 0 | (i22 | 0) == 0) {
        HEAP32[i139 >> 2] = 0;
        HEAP32[i145 >> 2] = 0;
        i15 = 0;
        i7 = 0;
       } else {
        i20 = (i22 | 0) % 2 | 0;
        i21 = i22 - i20 | 0;
        i31 = (i21 | 0) / (i19 | 0) | 0;
        i7 = (i31 | 0) % 2 | 0;
        i7 = (i7 | 0) == 0 ? i31 : i31 + 2 - i7 | 0;
        i21 = i21 - (Math_imul(i7, i19) | 0) | 0;
        if ((i21 | 0) > -1) {
         i29 = (i21 >>> 1 | 0) > (i15 | 0);
         i30 = i7 + 2 | 0;
         i28 = Math_imul(i30, i15) | 0;
         i31 = i21 + (Math_imul(i7, i15) | 0) | 0;
         i31 = i29 ? i28 : i31;
         HEAP32[i139 >> 2] = i31;
         i15 = (i29 ? i30 : i7) + ((i19 + -1 | 0) == (i15 | 0) ? i20 : 0) | 0;
         HEAP32[i145 >> 2] = i15;
         i7 = i31;
         break;
        } else {
         i31 = Math_imul(i7, i15) | 0;
         HEAP32[i139 >> 2] = i31;
         i30 = (i21 | 0) / 2 | 0;
         i29 = i30 + i19 | 0;
         i30 = i21 + i20 - (Math_imul(i30, i7) | 0) | 0;
         i15 = ((i29 | 0) > (i15 | 0) ? i7 : 0) + ((i29 + -1 | 0) == (i15 | 0) ? i30 : 0) | 0;
         HEAP32[i145 >> 2] = i15;
         i7 = i31;
         break;
        }
       } while (0);
       HEAP32[i3 >> 2] = i2 + -1;
       i19 = i22;
       i2 = i15;
      }
      i30 = HEAP32[i5 + 68 >> 2] | 0;
      i25 = HEAP32[i5 + 72 >> 2] | 0;
      i27 = (i30 | 0) == 0;
      i30 = i27 ? 0 : i30 + (i7 * 24 | 0) | 0;
      i26 = (i25 | 0) == 0;
      i25 = i26 ? 0 : i25 + (i7 << 5) | 0;
      i31 = (i25 | 0) == 0;
      i30 = (i30 | 0) == 0 ? 0 : i5 + i30 | 0;
      HEAP32[i141 >> 2] = (i30 | 0) == 0 ? 0 : i27 ? i19 : i2;
      i25 = i31 ? 0 : i5 + i25 | 0;
      HEAP32[i143 >> 2] = (i25 | 0) == 0 ? 0 : i26 ? i19 : i2;
      HEAP32[i144 >> 2] = i25;
      i25 = HEAP32[i5 + 20 >> 2] | 0;
      i26 = HEAP32[i5 + 24 >> 2] | 0;
      i27 = HEAP32[i5 + 28 >> 2] | 0;
      i28 = HEAP32[i5 + 32 >> 2] | 0;
      i29 = HEAP32[i5 + 36 >> 2] | 0;
      i20 = HEAP32[i5 + 40 >> 2] | 0;
      i2 = HEAP32[i133 >> 2] | 0;
      if (!i2) break;
      f68 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i7 = f68 > Math_fround(HEAPF32[i95 >> 2]);
      f68 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i15 = f68 > Math_fround(HEAPF32[i96 >> 2]);
      f68 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i19 = f68 > Math_fround(HEAPF32[i97 >> 2]);
      i24 = Math_fround(HEAPF32[i98 >> 2]) < Math_fround(1.0);
      f68 = Math_fround(HEAPF32[i99 >> 2]);
      i21 = f68 > (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f68 = Math_fround(HEAPF32[i100 >> 2]);
      i22 = f68 > (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f68 = Math_fround(HEAPF32[i101 >> 2]);
      i23 = f68 > (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i21 = i7 | i21;
      i22 = i15 | i22;
      i23 = i19 | i23;
      i24 = i24 | Math_fround(HEAPF32[i102 >> 2]) > Math_fround(1.0);
      if ((i2 | 0) > 3) {
       i7 = i2 + -4 | 0;
       i15 = i7 & -4;
       i19 = i15 + 4 | 0;
       i5 = i93;
       f18 = Math_fround(0.0);
       f17 = Math_fround(0.0);
       f16 = Math_fround(0.0);
       f8 = Math_fround(0.0);
       while (1) {
        i189 = HEAP32[i5 >> 2] | 0;
        i188 = HEAP32[i5 + 4 >> 2] | 0;
        i187 = HEAP32[i5 + 8 >> 2] | 0;
        i184 = HEAP32[i5 + 12 >> 2] | 0;
        i190 = HEAP32[i173 + 832 + (i189 << 4) >> 2] | 0;
        i185 = HEAP32[i173 + 832 + (i189 << 4) + 4 >> 2] | 0;
        i186 = HEAP32[i173 + 832 + (i189 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i190 | i190 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i189 << 4) >> 2]));
        f65 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f65 = Math_fround(f65 * Math_fround(HEAPF32[i173 + 480 + (i189 << 4) + 4 >> 2]));
        f67 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i186 | i186 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i189 << 4) + 8 >> 2]));
        f65 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i189 << 4) + 12 >> 2]) + Math_fround(f67 + Math_fround(f64 + f65)));
        i189 = HEAP32[i173 + 832 + (i188 << 4) >> 2] | 0;
        i186 = HEAP32[i173 + 832 + (i188 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i173 + 832 + (i188 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i189 | i189 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i188 << 4) >> 2]));
        f67 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i186 | i186 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i188 << 4) + 4 >> 2]));
        f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i185 | i185 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i188 << 4) + 8 >> 2]));
        f67 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i188 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f64 + f67)));
        i188 = HEAP32[i173 + 832 + (i187 << 4) >> 2] | 0;
        i185 = HEAP32[i173 + 832 + (i187 << 4) + 4 >> 2] | 0;
        i186 = HEAP32[i173 + 832 + (i187 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i188 | i188 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) >> 2]));
        f66 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i185 | i185 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 4 >> 2]));
        f68 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i186 | i186 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 8 >> 2]));
        f66 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 12 >> 2]) + Math_fround(f68 + Math_fround(f64 + f66)));
        i187 = HEAP32[i173 + 832 + (i184 << 4) >> 2] | 0;
        i186 = HEAP32[i173 + 832 + (i184 << 4) + 4 >> 2] | 0;
        i185 = HEAP32[i173 + 832 + (i184 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i187 | i187 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i184 << 4) >> 2]));
        f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i186 | i186 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i184 << 4) + 4 >> 2]));
        f63 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i185 | i185 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f63 = Math_fround(f63 * Math_fround(HEAPF32[i173 + 480 + (i184 << 4) + 8 >> 2]));
        f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i184 << 4) + 12 >> 2]) + Math_fround(f63 + Math_fround(f64 + f68)));
        f67 = f65 <= f67 ? f65 : f67;
        f68 = f66 <= f68 ? f66 : f68;
        f68 = f67 <= f68 ? f67 : f68;
        f18 = f18 <= f68 ? f18 : f68;
        f17 = f17 <= f68 ? f17 : f68;
        f16 = f16 <= f68 ? f16 : f68;
        f8 = f8 <= f68 ? f8 : f68;
        i2 = i2 + -4 | 0;
        if ((i2 | 0) <= 3) break; else i5 = i5 + 16 | 0;
       }
       i2 = i7 - i15 | 0;
       i5 = i93 + (i19 << 2) | 0;
      } else {
       i5 = i93;
       f18 = Math_fround(0.0);
       f17 = Math_fround(0.0);
       f16 = Math_fround(0.0);
       f8 = Math_fround(0.0);
      }
      switch (i2 | 0) {
      case 3:
       {
        i2 = HEAP32[i5 >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i2 << 4) >> 2] | 0;
        i190 = HEAP32[i173 + 832 + (i2 << 4) + 4 >> 2] | 0;
        i179 = HEAP32[i173 + 832 + (i2 << 4) + 8 >> 2] | 0;
        f67 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25 & ~i189 | i189 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i2 << 4) >> 2]));
        f68 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26 & ~i190 | i190 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i2 << 4) + 4 >> 2]));
        f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27 & ~i179 | i179 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i2 << 4) + 8 >> 2]));
        f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i2 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
        i2 = i5 + 4 | 0;
        f18 = f18 <= f68 ? f18 : f68;
        f17 = f17 <= f68 ? f17 : f68;
        f16 = f16 <= f68 ? f16 : f68;
        f8 = f8 <= f68 ? f8 : f68;
        i179 = 59;
        break;
       }
      case 2:
       {
        i2 = i5;
        i179 = 59;
        break;
       }
      case 1:
       {
        i179 = 60;
        break;
       }
      default:
       {}
      }
      if ((i179 | 0) == 59) {
       i5 = HEAP32[i2 >> 2] | 0;
       i188 = HEAP32[i173 + 832 + (i5 << 4) >> 2] | 0;
       i189 = HEAP32[i173 + 832 + (i5 << 4) + 4 >> 2] | 0;
       i190 = HEAP32[i173 + 832 + (i5 << 4) + 8 >> 2] | 0;
       f67 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i188 | i188 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i5 << 4) >> 2]));
       f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i189 | i189 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i5 << 4) + 4 >> 2]));
       f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i190 | i190 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i5 << 4) + 8 >> 2]));
       f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i5 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
       i5 = i2 + 4 | 0;
       f18 = f18 <= f68 ? f18 : f68;
       f17 = f17 <= f68 ? f17 : f68;
       f16 = f16 <= f68 ? f16 : f68;
       f8 = f8 <= f68 ? f8 : f68;
       i179 = 60;
      }
      if ((i179 | 0) == 60) {
       i179 = 0;
       i190 = HEAP32[i5 >> 2] | 0;
       i187 = HEAP32[i173 + 832 + (i190 << 4) >> 2] | 0;
       i188 = HEAP32[i173 + 832 + (i190 << 4) + 4 >> 2] | 0;
       i189 = HEAP32[i173 + 832 + (i190 << 4) + 8 >> 2] | 0;
       f67 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i187 | i187 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) >> 2]));
       f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i188 | i188 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 4 >> 2]));
       f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i189 | i189 & i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 8 >> 2]));
       f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
       f18 = f18 <= f68 ? f18 : f68;
       f17 = f17 <= f68 ? f17 : f68;
       f16 = f16 <= f68 ? f16 : f68;
       f8 = f8 <= f68 ? f8 : f68;
      }
      if (!(i21 | f18 < Math_fround(0.0) | (i22 | f17 < Math_fround(0.0)) | (i23 | f16 < Math_fround(0.0)) | (i24 | f8 < Math_fround(0.0)))) break;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) break L56;
     }
     HEAP8[i140 >> 0] = i31 & 1 ^ 1;
     HEAP32[i142 >> 2] = i30;
     HEAP32[i177 >> 2] = i25;
     HEAP32[i103 >> 2] = i26;
     HEAP32[i104 >> 2] = i27;
     HEAP32[i105 >> 2] = 1065353216;
     HEAP32[i178 >> 2] = i28;
     HEAP32[i106 >> 2] = i29;
     HEAP32[i107 >> 2] = i20;
     HEAP32[i108 >> 2] = 1065353216;
     __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i173, i175, 0, i177, i178) | 0;
     i5 = HEAP32[i145 >> 2] | 0;
     if (!(i5 | HEAP32[i3 >> 2])) break L55;
     if (i154) {
      i1 = HEAP32[i134 >> 2] | 0;
      i7 = (HEAP32[i1 + 16 >> 2] & 1 | 0) != 0;
      if (i7) {
       i9 = HEAP32[i1 + 316 >> 2] | 0;
       i12 = HEAP32[i1 + 320 >> 2] | 0;
       i13 = HEAP32[i1 + 324 >> 2] | 0;
       i9 = (i9 | 0) == 0 ? 0 : i1 + i9 | 0;
       i11 = HEAP32[i1 + 328 >> 2] | 0;
       i12 = (i12 | 0) == 0 ? 0 : i1 + i12 | 0;
       i13 = (i13 | 0) == 0 ? 0 : i1 + i13 | 0;
      }
      i2 = HEAP32[i174 >> 2] & 2147483647;
      i190 = HEAP32[i159 >> 2] & 2147483647;
      i1 = HEAP32[i160 >> 2] & 2147483647;
      HEAP32[i177 >> 2] = i2;
      HEAP32[i109 >> 2] = i190;
      HEAP32[i110 >> 2] = i1;
      i1 = i2 >>> 0 < i190 >>> 0 ? (i190 >>> 0 >= i1 >>> 0 ? 1 : 2) : i2 >>> 0 >= i1 >>> 0 ? 0 : 2;
      i2 = 1 << i1 & 3;
      if (!(HEAP32[i177 + (i1 << 2) >> 2] | 0)) {
       i6 = 0;
       i2 = 0;
       i1 = 0;
      } else {
       i6 = HEAP32[i174 + (i1 << 2) >> 2] | 0;
       f68 = Math_fround(Math_fround(8.0) / Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
       i190 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i174 + (i2 << 2) >> 2]) * f68) + Math_fround(8.0));
       i6 = (i6 >>> 31 | i1 << 1) ^ 1;
       i2 = ~~Math_fround(Math_fround(f68 * Math_fround(HEAPF32[i174 + ((1 << i2 & 3) << 2) >> 2])) + Math_fround(8.0));
       i1 = i190;
      }
      i15 = i7;
      i69 = i9;
     } else {
      i15 = i72;
      i69 = i9;
      i2 = i14;
     }
     if (HEAP32[i175 >> 2] | 0) {
      i9 = i69;
      i14 = i2;
      i179 = 106;
      break;
     }
     if (i15) {
      if (!i164) {
       i15 = 1;
       i9 = i69;
       i14 = i2;
       i179 = 106;
       break;
      }
     } else if ((HEAP32[(HEAP32[i134 >> 2] | 0) + 16 >> 2] & 2 | 0) == 0 | i94) {
      i15 = 0;
      i9 = i69;
      i14 = i2;
      i179 = 106;
      break;
     }
     if (!(i153 | (HEAP8[i140 >> 0] | 0) == 0)) {
      i9 = i69;
      i14 = i2;
      i179 = 106;
      break;
     }
     if (i165 | (HEAP32[i111 >> 2] | 0) != 0) {
      i9 = i69;
      i14 = i2;
      i179 = 106;
      break;
     }
     i9 = HEAP32[i134 >> 2] | 0;
     i7 = HEAP32[i9 + 320 >> 2] | 0;
     if (!(HEAP32[i9 + 16 >> 2] & 2)) {
      i22 = HEAP32[i9 + 316 >> 2] | 0;
      i20 = HEAP32[i9 + 324 >> 2] | 0;
      i22 = (i22 | 0) == 0 ? 0 : i9 + i22 | 0;
      i32 = Math_imul((i2 << 4) + i1 << 2, HEAP32[i9 + 328 >> 2] | 0) | 0;
      i23 = 0;
      i21 = (i7 | 0) == 0 ? 0 : i9 + i7 | 0;
      i20 = (i20 | 0) == 0 ? 0 : i9 + i20 | 0;
     } else {
      i22 = 0;
      i32 = Math_imul(HEAP32[i9 + 64 >> 2] | 0, (i2 << 4) + i1 + (i6 << 8) | 0) | 0;
      i23 = i9 + i7 | 0;
      i21 = 0;
      i20 = 0;
     }
     if (!i5) {
      i9 = i69;
      i14 = i2;
      i7 = i13;
      break;
     }
     i24 = HEAP32[i114 >> 2] | 0;
     i25 = HEAP32[i166 >> 2] | 0;
     i26 = (i25 | 0) == 0;
     i27 = HEAP32[i115 >> 2] | 0;
     i28 = (i27 | 0) == 0;
     i29 = i25 + 8 | 0;
     i30 = i25 + 4 | 0;
     i31 = (HEAP8[i146 >> 0] | 0) == 0;
     if (!i23) {
      do {
       i9 = HEAP32[i139 >> 2] | 0;
       HEAP32[i112 >> 2] = i9;
       do if (i31) {
        i7 = HEAP32[i149 >> 2] | 0;
        if (!i7) {
         i19 = i9;
         break;
        }
        i19 = HEAP32[(HEAP32[i151 >> 2] | 0) + (HEAP32[i7 + 8 >> 2] | 0) + (i9 << 2) >> 2] | 0;
       } else i19 = i9; while (0);
       HEAP32[i113 >> 2] = i19;
       HEAP32[i139 >> 2] = i9 + 1;
       HEAP32[i145 >> 2] = i5 + -1;
       i190 = (HEAP32[i22 + (i9 << 6) + (i6 << 3) >> 2] << 2) + i32 | 0;
       do if ((HEAP16[i20 + (HEAP32[i22 + (i9 << 6) + (i6 << 3) + 4 >> 2] << 1) + (((HEAP32[i21 + (i190 >> 5 << 2) >> 2] | 0) >>> (i190 & 31) & 15) << 1) >> 1] | 0) == 32639) {
        i9 = i19 >> 5;
        i5 = i24 + (i9 << 2) | 0;
        i7 = HEAP32[i5 >> 2] | 0;
        i14 = 1 << (i19 & 31);
        if (i7 & i14 | 0) break;
        HEAP32[i5 >> 2] = i7 | i14;
        if (!i26) {
         i5 = HEAP32[i29 >> 2] | 0;
         if ((i5 | 0) < (HEAP32[i30 >> 2] | 0)) {
          HEAP32[(HEAP32[i25 >> 2] | 0) + (i5 << 2) >> 2] = i19;
          i5 = HEAP32[i29 >> 2] | 0;
         }
         HEAP32[i29 >> 2] = i5 + 1;
        }
        i5 = i27 + (i9 << 2) | 0;
        if (i28) break;
        HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i14;
       } while (0);
       i5 = HEAP32[i145 >> 2] | 0;
      } while ((i5 | 0) != 0);
      i9 = i69;
      i14 = i2;
      i7 = i13;
     } else {
      do {
       i9 = HEAP32[i139 >> 2] | 0;
       HEAP32[i112 >> 2] = i9;
       do if (i31) {
        i7 = HEAP32[i149 >> 2] | 0;
        if (!i7) {
         i19 = i9;
         break;
        }
        i19 = HEAP32[(HEAP32[i151 >> 2] | 0) + (HEAP32[i7 + 8 >> 2] | 0) + (i9 << 2) >> 2] | 0;
       } else i19 = i9; while (0);
       HEAP32[i113 >> 2] = i19;
       HEAP32[i139 >> 2] = i9 + 1;
       HEAP32[i145 >> 2] = i5 + -1;
       i190 = i9 + i32 | 0;
       do if (HEAP32[i23 + (i190 >> 5 << 2) >> 2] & 1 << (i190 & 31) | 0) {
        i9 = i19 >> 5;
        i5 = i24 + (i9 << 2) | 0;
        i7 = HEAP32[i5 >> 2] | 0;
        i14 = 1 << (i19 & 31);
        if (i7 & i14 | 0) break;
        HEAP32[i5 >> 2] = i7 | i14;
        if (!i26) {
         i5 = HEAP32[i29 >> 2] | 0;
         if ((i5 | 0) < (HEAP32[i30 >> 2] | 0)) {
          HEAP32[(HEAP32[i25 >> 2] | 0) + (i5 << 2) >> 2] = i19;
          i5 = HEAP32[i29 >> 2] | 0;
         }
         HEAP32[i29 >> 2] = i5 + 1;
        }
        i5 = i27 + (i9 << 2) | 0;
        if (i28) break;
        HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i14;
       } while (0);
       i5 = HEAP32[i145 >> 2] | 0;
      } while ((i5 | 0) != 0);
      i9 = i69;
      i14 = i2;
      i7 = i13;
     }
    } else {
     i15 = i72;
     i179 = 106;
    } while (0);
    do if ((i179 | 0) == 106) {
     i179 = 0;
     i190 = (HEAP8[i146 >> 0] | 0) == 0;
     i31 = HEAP32[i139 >> 2] | 0;
     HEAP32[i112 >> 2] = i31;
     do if (i190) {
      i2 = HEAP32[i149 >> 2] | 0;
      if (!i2) {
       i69 = i31;
       break;
      }
      i69 = HEAP32[(HEAP32[i151 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (i31 << 2) >> 2] | 0;
     } else i69 = i31; while (0);
     HEAP32[i113 >> 2] = i69;
     HEAP32[i139 >> 2] = i31 + 1;
     HEAP32[i145 >> 2] = i5 + -1;
     HEAP32[i141 >> 2] = (HEAP32[i141 >> 2] | 0) + -1;
     i2 = HEAP32[i142 >> 2] | 0;
     HEAP32[i142 >> 2] = i2 + 24;
     HEAP32[i152 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i152 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i152 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i152 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i152 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i152 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     i2 = HEAP8[i140 >> 0] | 0;
     if (i2 << 24 >> 24) {
      HEAP32[i143 >> 2] = (HEAP32[i143 >> 2] | 0) + -1;
      i190 = HEAP32[i144 >> 2] | 0;
      HEAP32[i144 >> 2] = i190 + 32;
      HEAP32[i121 >> 2] = HEAP32[i190 >> 2];
      HEAP32[i121 + 4 >> 2] = HEAP32[i190 + 4 >> 2];
      HEAP32[i121 + 8 >> 2] = HEAP32[i190 + 8 >> 2];
      HEAP32[i121 + 12 >> 2] = HEAP32[i190 + 12 >> 2];
      HEAP32[i121 + 16 >> 2] = HEAP32[i190 + 16 >> 2];
      HEAP32[i121 + 20 >> 2] = HEAP32[i190 + 20 >> 2];
      HEAP32[i121 + 24 >> 2] = HEAP32[i190 + 24 >> 2];
      HEAP32[i121 + 28 >> 2] = HEAP32[i190 + 28 >> 2];
     }
     i32 = i69 >> 5;
     i70 = 1 << (i69 & 31);
     if (HEAP32[(HEAP32[i114 >> 2] | 0) + (i32 << 2) >> 2] & i70 | 0) {
      i7 = i13;
      break;
     }
     i25 = HEAP32[i152 >> 2] | 0;
     i26 = HEAP32[i116 >> 2] | 0;
     i27 = HEAP32[i117 >> 2] | 0;
     i28 = HEAP32[i118 >> 2] | 0;
     i29 = HEAP32[i119 >> 2] | 0;
     i30 = HEAP32[i120 >> 2] | 0;
     i5 = HEAP32[i175 >> 2] | 0;
     if (i5) {
      f68 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i188 = f68 > Math_fround(HEAPF32[i95 >> 2]);
      f68 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i189 = f68 > Math_fround(HEAPF32[i96 >> 2]);
      f68 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i190 = f68 > Math_fround(HEAPF32[i97 >> 2]);
      i24 = Math_fround(HEAPF32[i98 >> 2]) < Math_fround(1.0);
      f68 = Math_fround(HEAPF32[i99 >> 2]);
      i21 = f68 > (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f68 = Math_fround(HEAPF32[i100 >> 2]);
      i22 = f68 > (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f68 = Math_fround(HEAPF32[i101 >> 2]);
      i23 = f68 > (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i21 = i188 | i21;
      i22 = i189 | i22;
      i23 = i190 | i23;
      i24 = i24 | Math_fround(HEAPF32[i102 >> 2]) > Math_fround(1.0);
      if ((i5 | 0) > 3) {
       i7 = i5 + -4 | 0;
       i19 = i7 & -4;
       i20 = i19 + 4 | 0;
       i2 = i90;
       f18 = Math_fround(0.0);
       f17 = Math_fround(0.0);
       f16 = Math_fround(0.0);
       f8 = Math_fround(0.0);
       while (1) {
        i185 = HEAP32[i2 >> 2] | 0;
        i186 = HEAP32[i2 + 4 >> 2] | 0;
        i187 = HEAP32[i2 + 8 >> 2] | 0;
        i190 = HEAP32[i2 + 12 >> 2] | 0;
        i184 = HEAP32[i173 + 832 + (i185 << 4) >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i185 << 4) + 4 >> 2] | 0;
        i188 = HEAP32[i173 + 832 + (i185 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i184 | i184 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i185 << 4) >> 2]));
        f65 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i189 | i189 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f65 = Math_fround(f65 * Math_fround(HEAPF32[i173 + 480 + (i185 << 4) + 4 >> 2]));
        f67 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i188 | i188 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i185 << 4) + 8 >> 2]));
        f65 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i185 << 4) + 12 >> 2]) + Math_fround(f67 + Math_fround(f64 + f65)));
        i185 = HEAP32[i173 + 832 + (i186 << 4) >> 2] | 0;
        i188 = HEAP32[i173 + 832 + (i186 << 4) + 4 >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i186 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i185 | i185 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i186 << 4) >> 2]));
        f67 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i188 | i188 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i186 << 4) + 4 >> 2]));
        f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i189 | i189 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i186 << 4) + 8 >> 2]));
        f67 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i186 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f64 + f67)));
        i186 = HEAP32[i173 + 832 + (i187 << 4) >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i187 << 4) + 4 >> 2] | 0;
        i188 = HEAP32[i173 + 832 + (i187 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i186 | i186 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) >> 2]));
        f66 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i189 | i189 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 4 >> 2]));
        f68 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i188 | i188 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 8 >> 2]));
        f66 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i187 << 4) + 12 >> 2]) + Math_fround(f68 + Math_fround(f64 + f66)));
        i187 = HEAP32[i173 + 832 + (i190 << 4) >> 2] | 0;
        i188 = HEAP32[i173 + 832 + (i190 << 4) + 4 >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i190 << 4) + 8 >> 2] | 0;
        f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i187 | i187 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f64 = Math_fround(f64 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) >> 2]));
        f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i188 | i188 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 4 >> 2]));
        f63 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i189 | i189 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f63 = Math_fround(f63 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 8 >> 2]));
        f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 12 >> 2]) + Math_fround(f63 + Math_fround(f64 + f68)));
        f67 = f65 <= f67 ? f65 : f67;
        f68 = f66 <= f68 ? f66 : f68;
        f68 = f67 <= f68 ? f67 : f68;
        f18 = f18 <= f68 ? f18 : f68;
        f17 = f17 <= f68 ? f17 : f68;
        f16 = f16 <= f68 ? f16 : f68;
        f8 = f8 <= f68 ? f8 : f68;
        i5 = i5 + -4 | 0;
        if ((i5 | 0) <= 3) break; else i2 = i2 + 16 | 0;
       }
       i5 = i7 - i19 | 0;
       i2 = i175 + 4 + (i20 << 2) | 0;
      } else {
       i2 = i90;
       f18 = Math_fround(0.0);
       f17 = Math_fround(0.0);
       f16 = Math_fround(0.0);
       f8 = Math_fround(0.0);
      }
      switch (i5 | 0) {
      case 3:
       {
        i179 = HEAP32[i2 >> 2] | 0;
        i188 = HEAP32[i173 + 832 + (i179 << 4) >> 2] | 0;
        i189 = HEAP32[i173 + 832 + (i179 << 4) + 4 >> 2] | 0;
        i190 = HEAP32[i173 + 832 + (i179 << 4) + 8 >> 2] | 0;
        f67 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25 & ~i188 | i188 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i179 << 4) >> 2]));
        f68 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26 & ~i189 | i189 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i179 << 4) + 4 >> 2]));
        f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27 & ~i190 | i190 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i173 + 480 + (i179 << 4) + 8 >> 2]));
        f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i179 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
        i2 = i2 + 4 | 0;
        f18 = f18 <= f68 ? f18 : f68;
        f17 = f17 <= f68 ? f17 : f68;
        f16 = f16 <= f68 ? f16 : f68;
        f8 = f8 <= f68 ? f8 : f68;
        i179 = 119;
        break;
       }
      case 2:
       {
        i179 = 119;
        break;
       }
      case 1:
       {
        i179 = 120;
        break;
       }
      default:
       {}
      }
      if ((i179 | 0) == 119) {
       i190 = HEAP32[i2 >> 2] | 0;
       i187 = HEAP32[i173 + 832 + (i190 << 4) >> 2] | 0;
       i188 = HEAP32[i173 + 832 + (i190 << 4) + 4 >> 2] | 0;
       i189 = HEAP32[i173 + 832 + (i190 << 4) + 8 >> 2] | 0;
       f67 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i187 | i187 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) >> 2]));
       f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i188 | i188 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 4 >> 2]));
       f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i189 | i189 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 8 >> 2]));
       f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
       i2 = i2 + 4 | 0;
       f18 = f18 <= f68 ? f18 : f68;
       f17 = f17 <= f68 ? f17 : f68;
       f16 = f16 <= f68 ? f16 : f68;
       f8 = f8 <= f68 ? f8 : f68;
       i179 = 120;
      }
      if ((i179 | 0) == 120) {
       i179 = 0;
       i190 = HEAP32[i2 >> 2] | 0;
       i187 = HEAP32[i173 + 832 + (i190 << 4) >> 2] | 0;
       i188 = HEAP32[i173 + 832 + (i190 << 4) + 4 >> 2] | 0;
       i189 = HEAP32[i173 + 832 + (i190 << 4) + 8 >> 2] | 0;
       f67 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i187 | i187 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f67 = Math_fround(f67 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) >> 2]));
       f68 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i188 | i188 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f68 = Math_fround(f68 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 4 >> 2]));
       f66 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i189 | i189 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f66 = Math_fround(f66 * Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 8 >> 2]));
       f68 = Math_fround(Math_fround(HEAPF32[i173 + 480 + (i190 << 4) + 12 >> 2]) + Math_fround(f66 + Math_fround(f67 + f68)));
       f18 = f18 <= f68 ? f18 : f68;
       f17 = f17 <= f68 ? f17 : f68;
       f16 = f16 <= f68 ? f16 : f68;
       f8 = f8 <= f68 ? f8 : f68;
      }
      if (i21 | f18 < Math_fround(0.0) | (i22 | f17 < Math_fround(0.0)) | (i23 | f16 < Math_fround(0.0)) | (i24 | f8 < Math_fround(0.0))) {
       i7 = i13;
       break;
      }
      i2 = HEAP8[i140 >> 0] | 0;
     }
     if (!(i153 | i2 << 24 >> 24 == 0)) {
      f65 = Math_fround(HEAPF32[i121 >> 2]);
      f68 = Math_fround(HEAPF32[i83 >> 2]);
      f64 = Math_fround(HEAPF32[i84 >> 2]);
      f67 = Math_fround(HEAPF32[i85 >> 2]);
      f61 = Math_fround(HEAPF32[i86 >> 2]);
      f62 = Math_fround(HEAPF32[i87 >> 2]);
      f63 = Math_fround(HEAPF32[i88 >> 2]);
      f66 = Math_fround(HEAPF32[i89 >> 2]);
      f65 = f65 >= f92 ? f65 : f92;
      f68 = f68 >= f91 ? f68 : f91;
      f64 = f64 >= f73 ? f64 : f73;
      f65 = Math_fround((f61 <= f65 ? f61 : f65) - f92);
      f68 = Math_fround((f62 <= f68 ? f62 : f68) - f91);
      f64 = Math_fround((f63 <= f64 ? f63 : f64) - f73);
      f68 = Math_fround(f163 * Math_fround(Math_fround(Math_fround(f64 * f64) + Math_fround(Math_fround(f65 * f65) + Math_fround(f68 * f68))) + Math_fround(0.0)));
      if (f68 >= f66 | f67 > f68) {
       i7 = i13;
       break;
      }
     }
     i19 = i15 ^ 1;
     if (!(i164 | i19)) {
      f66 = Math_fround(f162 - Math_fround(HEAPF32[i9 + (i31 << 6) + 48 >> 2]));
      f67 = Math_fround(f161 - Math_fround(HEAPF32[i9 + (i31 << 6) + 52 >> 2]));
      f68 = Math_fround(f155 - Math_fround(HEAPF32[i9 + (i31 << 6) + 56 >> 2]));
      HEAPF32[i178 >> 2] = f66;
      HEAPF32[i79 >> 2] = f67;
      HEAPF32[i80 >> 2] = f68;
      i5 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
      i190 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
      i2 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
      HEAP32[i177 >> 2] = i5;
      HEAP32[i81 >> 2] = i190;
      HEAP32[i82 >> 2] = i2;
      i2 = i5 >>> 0 < i190 >>> 0 ? (i190 >>> 0 >= i2 >>> 0 ? 1 : 2) : i5 >>> 0 >= i2 >>> 0 ? 0 : 2;
      i5 = 1 << i2 & 3;
      if (!(HEAP32[i177 + (i2 << 2) >> 2] | 0)) {
       i7 = 0;
       i2 = 0;
       i5 = 0;
      } else {
       i7 = HEAP32[i178 + (i2 << 2) >> 2] | 0;
       f68 = Math_fround(Math_fround(8.0) / Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
       i190 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i178 + (i5 << 2) >> 2]) * f68) + Math_fround(8.0));
       i7 = (i7 >>> 31 | i2 << 1) ^ 1;
       i2 = ~~Math_fround(Math_fround(f68 * Math_fround(HEAPF32[i178 + ((1 << i5 & 3) << 2) >> 2])) + Math_fround(8.0)) << 4;
       i5 = i190;
      }
      i190 = (HEAP32[i9 + (i31 << 6) + (i7 << 3) >> 2] | 0) + (Math_imul(i2 + i5 | 0, i11) | 0) << 2;
      f68 = (HEAP32[tempDoublePtr >> 2] = HEAPU16[i13 + (HEAP32[i9 + (i31 << 6) + (i7 << 3) + 4 >> 2] << 1) + (((HEAP32[i12 + (i190 >> 5 << 2) >> 2] | 0) >>> (i190 & 28) & 15) << 1) >> 1] << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (!(Math_fround(Math_abs(Math_fround(HEAPF32[i178 + ((i7 >>> 1 & 3) << 2) >> 2]))) < Math_fround(f68 + Math_fround(0.0)))) {
       i7 = i13;
       break;
      }
     }
     if (!(i94 | i19)) {
      i187 = HEAP32[i172 >> 2] | 0;
      HEAP32[i177 >> 2] = i187;
      i188 = HEAP32[i156 >> 2] | 0;
      HEAP32[i76 >> 2] = i188;
      i189 = HEAP32[i157 >> 2] | 0;
      HEAP32[i77 >> 2] = i189;
      i190 = HEAP32[i158 >> 2] | 0;
      HEAP32[i78 >> 2] = i190;
      i186 = (HEAP32[i9 + (i31 << 6) + (i6 << 3) >> 2] | 0) + (Math_imul(i11, (i14 << 4) + i1 | 0) | 0) << 2;
      f68 = (HEAP32[tempDoublePtr >> 2] = HEAPU16[i13 + (HEAP32[i9 + (i31 << 6) + (i6 << 3) + 4 >> 2] << 1) + (((HEAP32[i12 + (i186 >> 5 << 2) >> 2] | 0) >>> (i186 & 28) & 15) << 1) >> 1] << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f67 = (HEAP32[tempDoublePtr >> 2] = i187, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f67 = Math_fround(f67 * Math_fround(HEAPF32[i9 + (i31 << 6) + 48 >> 2]));
      f66 = (HEAP32[tempDoublePtr >> 2] = i188, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f66 = Math_fround(f67 + Math_fround(f66 * Math_fround(HEAPF32[i9 + (i31 << 6) + 52 >> 2])));
      f67 = (HEAP32[tempDoublePtr >> 2] = i189, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f67 = Math_fround(f66 + Math_fround(f67 * Math_fround(HEAPF32[i9 + (i31 << 6) + 56 >> 2])));
      f67 = Math_fround((HEAP32[tempDoublePtr >> 2] = i190, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f67);
      if (!(Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i177 + ((i6 >>> 1 & 3) << 2) >> 2]) * f67))) < f68)) {
       i7 = i13;
       break;
      }
     }
     if (i165) {
      f34 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f47 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f34 = Math_fround(f34 - f47);
      f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f16 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = Math_fround(f40 - f16);
      f52 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f8 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f52 = Math_fround(f52 - f8);
      f46 = Math_fround(HEAPF32[i167 >> 2]);
      f42 = Math_fround(HEAPF32[i168 >> 2]);
      f36 = Math_fround(HEAPF32[i122 >> 2]);
      f18 = Math_fround(f34 * f46);
      f33 = Math_fround(f34 * f42);
      f34 = Math_fround(f34 * f36);
      f45 = Math_fround(HEAPF32[i123 >> 2]);
      f41 = Math_fround(HEAPF32[i169 >> 2]);
      f35 = Math_fround(HEAPF32[i124 >> 2]);
      f38 = Math_fround(f40 * f45);
      f39 = Math_fround(f40 * f41);
      f40 = Math_fround(f40 * f35);
      f43 = Math_fround(HEAPF32[i125 >> 2]);
      f37 = Math_fround(HEAPF32[i126 >> 2]);
      f17 = Math_fround(HEAPF32[i170 >> 2]);
      f44 = Math_fround(f52 * f43);
      f48 = Math_fround(f52 * f37);
      f52 = Math_fround(f52 * f17);
      f46 = Math_fround(f47 * f46);
      f42 = Math_fround(f47 * f42);
      f36 = Math_fround(f47 * f36);
      f45 = Math_fround(f16 * f45);
      f41 = Math_fround(f16 * f41);
      f35 = Math_fround(f16 * f35);
      f43 = Math_fround(f8 * f43);
      f37 = Math_fround(f8 * f37);
      f17 = Math_fround(f8 * f17);
      f8 = Math_fround(HEAPF32[i127 >> 2]);
      f16 = Math_fround(HEAPF32[i128 >> 2]);
      f8 = Math_fround(f46 + Math_fround(f45 + Math_fround(f43 + f8)));
      f16 = Math_fround(f42 + Math_fround(f41 + Math_fround(f37 + f16)));
      f17 = Math_fround(f36 + Math_fround(f35 + Math_fround(f17 + Math_fround(HEAPF32[i171 >> 2]))));
      f18 = Math_fround(f18 + f8);
      f33 = Math_fround(f33 + f16);
      f34 = Math_fround(f34 + f17);
      f35 = Math_fround(f38 + f18);
      f36 = Math_fround(f39 + f33);
      f37 = Math_fround(f40 + f34);
      f38 = Math_fround(f38 + f8);
      f39 = Math_fround(f39 + f16);
      f40 = Math_fround(f40 + f17);
      f41 = Math_fround(f44 + f8);
      f42 = Math_fround(f44 + f18);
      f43 = Math_fround(f44 + f35);
      f44 = Math_fround(f44 + f38);
      f45 = Math_fround(f48 + f16);
      f46 = Math_fround(f48 + f33);
      f47 = Math_fround(f48 + f36);
      f48 = Math_fround(f48 + f39);
      f49 = Math_fround(f52 + f17);
      f50 = Math_fround(f52 + f34);
      f51 = Math_fround(f52 + f37);
      f52 = Math_fround(f52 + f40);
      i190 = f17 == Math_fround(0.0);
      f57 = Math_fround(Math_fround(1.0) / f17);
      f57 = i190 ? Math_fround(1.0) : f57;
      i190 = f34 == Math_fround(0.0);
      f58 = Math_fround(Math_fround(1.0) / f34);
      f58 = i190 ? Math_fround(1.0) : f58;
      i190 = f37 == Math_fround(0.0);
      f59 = Math_fround(Math_fround(1.0) / f37);
      f59 = i190 ? Math_fround(1.0) : f59;
      i190 = f40 == Math_fround(0.0);
      f60 = Math_fround(Math_fround(1.0) / f40);
      f60 = i190 ? Math_fround(1.0) : f60;
      i190 = f49 == Math_fround(0.0);
      f65 = Math_fround(Math_fround(1.0) / f49);
      f65 = i190 ? Math_fround(1.0) : f65;
      i190 = f50 == Math_fround(0.0);
      f66 = Math_fround(Math_fround(1.0) / f50);
      f66 = i190 ? Math_fround(1.0) : f66;
      i190 = f51 == Math_fround(0.0);
      f67 = Math_fround(Math_fround(1.0) / f51);
      f67 = i190 ? Math_fround(1.0) : f67;
      i190 = f52 == Math_fround(0.0);
      f68 = Math_fround(Math_fround(1.0) / f52);
      f68 = i190 ? Math_fround(1.0) : f68;
      f53 = Math_fround(f8 * f57);
      f54 = Math_fround(f18 * f58);
      f55 = Math_fround(f35 * f59);
      f56 = Math_fround(f38 * f60);
      f57 = Math_fround(f16 * f57);
      f58 = Math_fround(f33 * f58);
      f59 = Math_fround(f36 * f59);
      f60 = Math_fround(f39 * f60);
      f61 = Math_fround(f41 * f65);
      f62 = Math_fround(f42 * f66);
      f63 = Math_fround(f43 * f67);
      f64 = Math_fround(f44 * f68);
      f65 = Math_fround(f45 * f65);
      f66 = Math_fround(f46 * f66);
      f67 = Math_fround(f47 * f67);
      f68 = Math_fround(f48 * f68);
      if (!((f40 <= f52 ? f40 : f52) < Math_fround(0.0)) & (((f17 <= f49 ? f17 : f49) < Math_fround(0.0) ? 0 : !((f34 <= f50 ? f34 : f50) < Math_fround(0.0))) & !((f37 <= f51 ? f37 : f51) < Math_fround(0.0)))) {
       f49 = f53 <= f61 ? f53 : f61;
       f17 = f54 <= f62 ? f54 : f62;
       f51 = f55 <= f63 ? f55 : f63;
       f8 = f56 <= f64 ? f56 : f64;
       f50 = f57 <= f65 ? f57 : f65;
       f16 = f58 <= f66 ? f58 : f66;
       f52 = f59 <= f67 ? f59 : f67;
       f18 = f60 <= f68 ? f60 : f68;
       f51 = f49 <= f51 ? f49 : f51;
       f52 = f50 <= f52 ? f50 : f52;
       f8 = f17 <= f8 ? f17 : f8;
       f18 = f16 <= f18 ? f16 : f18;
       f61 = f53 >= f61 ? f53 : f61;
       f62 = f54 >= f62 ? f54 : f62;
       f63 = f55 >= f63 ? f55 : f63;
       f16 = f56 >= f64 ? f56 : f64;
       f64 = f57 >= f65 ? f57 : f65;
       f66 = f58 >= f66 ? f58 : f66;
       f65 = f59 >= f67 ? f59 : f67;
       f17 = f60 >= f68 ? f60 : f68;
       f67 = f61 >= f63 ? f61 : f63;
       f68 = f64 >= f65 ? f64 : f65;
       f16 = f62 >= f16 ? f62 : f16;
       f17 = f66 >= f17 ? f66 : f17;
       f8 = f51 <= f8 ? f51 : f8;
       f16 = f67 >= f16 ? f67 : f16;
       f17 = f68 >= f17 ? f68 : f17;
       f18 = f52 <= f18 ? f52 : f18;
      } else {
       f217 = Math_fround(-f17);
       f216 = Math_fround(-f34);
       f215 = Math_fround(-f37);
       f214 = Math_fround(-f40);
       i213 = f8 > f217;
       i211 = f18 > f216;
       i209 = f35 > f215;
       i207 = f38 > f214;
       i204 = f17 > f8;
       i200 = f34 > f18;
       i196 = f37 > f35;
       i192 = f40 > f38;
       i5 = f16 > f217;
       i19 = f33 > f216;
       i21 = f36 > f215;
       i23 = f39 > f214;
       i26 = f17 > f16;
       i30 = f34 > f33;
       i184 = f37 > f36;
       i188 = f40 > f39;
       f17 = Math_fround(-f49);
       f18 = Math_fround(-f50);
       f8 = Math_fround(-f51);
       f16 = Math_fround(-f52);
       i212 = f41 > f17;
       i210 = f42 > f18;
       i208 = f43 > f8;
       i206 = f44 > f16;
       i202 = f49 > f41;
       i198 = f50 > f42;
       i194 = f51 > f43;
       i2 = f52 > f44;
       i7 = f45 > f17;
       i20 = f46 > f18;
       i22 = f47 > f8;
       i24 = f48 > f16;
       i28 = f49 > f45;
       i71 = f50 > f46;
       i186 = f51 > f47;
       i190 = f52 > f48;
       i205 = i204 & i213;
       i201 = i200 & i211;
       i197 = i196 & i209;
       i193 = i192 & i207;
       i25 = i26 & i5;
       i29 = i30 & i19;
       i72 = i184 & i21;
       i187 = i188 & i23;
       i203 = i202 & i212;
       i199 = i198 & i210;
       i195 = i194 & i208;
       i191 = i2 & i206;
       i27 = i28 & i7;
       i31 = i71 & i20;
       i185 = i186 & i22;
       i189 = i190 & i24;
       f16 = i205 ? f53 : Math_fround(1.0);
       f16 = i213 ? f16 : Math_fround(-1.0);
       f50 = i203 ? f61 : Math_fround(1.0);
       f50 = i212 ? f50 : Math_fround(-1.0);
       f50 = f16 <= f50 ? f16 : f50;
       f16 = i201 ? f54 : Math_fround(1.0);
       f16 = i211 ? f16 : Math_fround(-1.0);
       f52 = i199 ? f62 : Math_fround(1.0);
       f52 = i210 ? f52 : Math_fround(-1.0);
       f52 = f16 <= f52 ? f16 : f52;
       f16 = i197 ? f55 : Math_fround(1.0);
       f16 = i209 ? f16 : Math_fround(-1.0);
       f51 = i195 ? f63 : Math_fround(1.0);
       f51 = i208 ? f51 : Math_fround(-1.0);
       f51 = f16 <= f51 ? f16 : f51;
       f16 = i193 ? f56 : Math_fround(1.0);
       f16 = i207 ? f16 : Math_fround(-1.0);
       f8 = i191 ? f64 : Math_fround(1.0);
       f8 = i206 ? f8 : Math_fround(-1.0);
       f8 = f16 <= f8 ? f16 : f8;
       f16 = i205 ? f53 : Math_fround(-1.0);
       f16 = i204 ? f16 : Math_fround(1.0);
       f53 = i203 ? f61 : Math_fround(-1.0);
       f53 = i202 ? f53 : Math_fround(1.0);
       f53 = f16 >= f53 ? f16 : f53;
       f54 = i201 ? f54 : Math_fround(-1.0);
       f54 = i200 ? f54 : Math_fround(1.0);
       f62 = i199 ? f62 : Math_fround(-1.0);
       f62 = i198 ? f62 : Math_fround(1.0);
       f62 = f54 >= f62 ? f54 : f62;
       f54 = i197 ? f55 : Math_fround(-1.0);
       f54 = i196 ? f54 : Math_fround(1.0);
       f61 = i195 ? f63 : Math_fround(-1.0);
       f61 = i194 ? f61 : Math_fround(1.0);
       f61 = f54 >= f61 ? f54 : f61;
       f54 = i193 ? f56 : Math_fround(-1.0);
       f54 = i192 ? f54 : Math_fround(1.0);
       f16 = i191 ? f64 : Math_fround(-1.0);
       f16 = i2 ? f16 : Math_fround(1.0);
       f16 = f54 >= f16 ? f54 : f16;
       f64 = i25 ? f57 : Math_fround(1.0);
       f64 = i5 ? f64 : Math_fround(-1.0);
       f54 = i27 ? f65 : Math_fround(1.0);
       f54 = i7 ? f54 : Math_fround(-1.0);
       f54 = f64 <= f54 ? f64 : f54;
       f64 = i29 ? f58 : Math_fround(1.0);
       f64 = i19 ? f64 : Math_fround(-1.0);
       f56 = i31 ? f66 : Math_fround(1.0);
       f56 = i20 ? f56 : Math_fround(-1.0);
       f56 = f64 <= f56 ? f64 : f56;
       f64 = i72 ? f59 : Math_fround(1.0);
       f64 = i21 ? f64 : Math_fround(-1.0);
       f55 = i185 ? f67 : Math_fround(1.0);
       f55 = i22 ? f55 : Math_fround(-1.0);
       f55 = f64 <= f55 ? f64 : f55;
       f64 = i187 ? f60 : Math_fround(1.0);
       f64 = i23 ? f64 : Math_fround(-1.0);
       f18 = i189 ? f68 : Math_fround(1.0);
       f18 = i24 ? f18 : Math_fround(-1.0);
       f18 = f64 <= f18 ? f64 : f18;
       f64 = i25 ? f57 : Math_fround(-1.0);
       f64 = i26 ? f64 : Math_fround(1.0);
       f63 = i27 ? f65 : Math_fround(-1.0);
       f63 = i28 ? f63 : Math_fround(1.0);
       f63 = f64 >= f63 ? f64 : f63;
       f65 = i29 ? f58 : Math_fround(-1.0);
       f65 = i30 ? f65 : Math_fround(1.0);
       f64 = i31 ? f66 : Math_fround(-1.0);
       f64 = i71 ? f64 : Math_fround(1.0);
       f64 = f65 >= f64 ? f65 : f64;
       f65 = i72 ? f59 : Math_fround(-1.0);
       f65 = i184 ? f65 : Math_fround(1.0);
       f67 = i185 ? f67 : Math_fround(-1.0);
       f67 = i186 ? f67 : Math_fround(1.0);
       f67 = f65 >= f67 ? f65 : f67;
       f65 = i187 ? f60 : Math_fround(-1.0);
       f65 = i188 ? f65 : Math_fround(1.0);
       f17 = i189 ? f68 : Math_fround(-1.0);
       f17 = i190 ? f17 : Math_fround(1.0);
       f17 = f65 >= f17 ? f65 : f17;
       f65 = f50 <= f51 ? f50 : f51;
       f68 = f54 <= f55 ? f54 : f55;
       f8 = f52 <= f8 ? f52 : f8;
       f18 = f56 <= f18 ? f56 : f18;
       f66 = f53 >= f61 ? f53 : f61;
       f67 = f63 >= f67 ? f63 : f67;
       f16 = f62 >= f16 ? f62 : f16;
       f17 = f64 >= f17 ? f64 : f17;
       f8 = f65 <= f8 ? f65 : f8;
       f16 = f66 >= f16 ? f66 : f16;
       f17 = f67 >= f17 ? f67 : f17;
       f18 = f68 <= f18 ? f68 : f18;
      }
      i213 = f8 <= Math_fround(1.0);
      f216 = i213 ? f8 : Math_fround(1.0);
      i213 = f18 <= Math_fround(1.0);
      f8 = i213 ? f18 : Math_fround(1.0);
      i213 = f16 <= Math_fround(1.0);
      f215 = i213 ? f16 : Math_fround(1.0);
      i213 = f17 <= Math_fround(1.0);
      f217 = i213 ? f17 : Math_fround(1.0);
      i213 = f216 >= Math_fround(-1.0);
      f216 = i213 ? f216 : Math_fround(-1.0);
      i213 = f8 >= Math_fround(-1.0);
      f8 = i213 ? f8 : Math_fround(-1.0);
      i213 = f215 >= Math_fround(-1.0);
      f215 = i213 ? f215 : Math_fround(-1.0);
      i213 = f217 >= Math_fround(-1.0);
      f8 = Math_fround(Math_fround(Math_fround(f215 - f216) * Math_fround((i213 ? f217 : Math_fround(-1.0)) - f8)) * Math_fround(.25));
      if (!(f8 < f4)) i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0); else {
       i7 = i13;
       break;
      }
     } else i19 = 1065353216;
     i5 = (HEAP32[i114 >> 2] | 0) + (i32 << 2) | 0;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i70;
     i5 = HEAP32[i166 >> 2] | 0;
     if (i5 | 0) {
      i7 = i5 + 8 | 0;
      i2 = HEAP32[i7 >> 2] | 0;
      if ((i2 | 0) < (HEAP32[i5 + 4 >> 2] | 0)) {
       HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i69;
       i2 = HEAP32[i7 >> 2] | 0;
      }
      HEAP32[i7 >> 2] = i2 + 1;
     }
     i213 = HEAP32[i115 >> 2] | 0;
     i2 = i213 + (i32 << 2) | 0;
     if (i213 | 0) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i70;
     i2 = HEAP32[i111 >> 2] | 0;
     if (i2 | 0) {
      i5 = (HEAP8[i140 >> 0] | 0) != 0;
      i213 = i5 ? i121 : i152;
      f8 = Math_fround(HEAPF32[i213 >> 2]);
      f16 = Math_fround(HEAPF32[i213 + 4 >> 2]);
      f17 = Math_fround(HEAPF32[i213 + 8 >> 2]);
      i5 = i5 ? i132 : i118;
      f215 = Math_fround(HEAPF32[i5 >> 2]);
      f216 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f217 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f8 = f8 >= f92 ? f8 : f92;
      f16 = f16 >= f91 ? f16 : f91;
      f17 = f17 >= f73 ? f17 : f73;
      f8 = Math_fround((f215 <= f8 ? f215 : f8) - f92);
      f16 = Math_fround((f216 <= f16 ? f216 : f16) - f91);
      f17 = Math_fround((f217 <= f17 ? f217 : f17) - f73);
      i5 = HEAP32[i74 >> 2] | 0;
      if ((i5 | 0) < (HEAP32[i75 >> 2] | 0)) HEAPF32[i2 + (i5 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f8 * f8) + Math_fround(f16 * f16))) + Math_fround(0.0));
      HEAP32[i74 >> 2] = i5 + 1;
     }
     i2 = HEAP32[i129 >> 2] | 0;
     if (!i2) {
      i7 = i13;
      break;
     }
     i5 = HEAP32[i130 >> 2] | 0;
     if ((i5 | 0) < (HEAP32[i131 >> 2] | 0)) HEAP32[i2 + (i5 << 2) >> 2] = i19;
     HEAP32[i130 >> 2] = i5 + 1;
     i7 = i13;
    } while (0);
    i2 = HEAP32[i3 >> 2] | 0;
    i5 = HEAP32[i145 >> 2] | 0;
    if (!(i2 | i5)) break L55; else {
     i72 = i15;
     i13 = i7;
    }
   }
   HEAP8[i140 >> 0] = i31 & 1 ^ 1;
   HEAP32[i142 >> 2] = i30;
  } while (0);
 }
 i1 = HEAP32[i182 + 68 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i182 + 24 >> 2] | 0;
  _memcpy(i1 | 0, i2 | 0, 1424) | 0;
  if (i2 | 0) HEAP32[(HEAP32[i182 >> 2] | 0) + 16 >> 2] = i2;
 }
 i1 = HEAP32[i182 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i182 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i182 + 12 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i182 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i166 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 4 >> 2] | 0)) HEAP32[(HEAP32[i182 >> 2] | 0) + 28 >> 2] = 2;
 i1 = HEAP32[i182 + 8 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 4 >> 2] | 0)) HEAP32[(HEAP32[i182 >> 2] | 0) + 28 >> 2] = 2;
 i213 = HEAP32[i180 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i181);
 STACKTOP = i183;
 return i213 | 0;
}

function __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt(i26, i1, i262, i259, i251, i18, i255, i253) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i262 = i262 | 0;
 i259 = i259 | 0;
 i251 = i251 | 0;
 i18 = i18 | 0;
 i255 = i255 | 0;
 i253 = i253 | 0;
 var d2 = 0.0, d3 = 0.0, i4 = 0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i252 = 0, i254 = 0, i256 = 0, i257 = 0, i258 = 0, i260 = 0, i261 = 0, i263 = 0, i264 = 0, f265 = f0;
 i263 = STACKTOP;
 STACKTOP = STACKTOP + 2320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i257 = i263 + 2264 | 0;
 i258 = i263 + 2224 | 0;
 i248 = i263 + 2128 | 0;
 i249 = i263 + 2092 | 0;
 i254 = i263 + 1824 | 0;
 i260 = i263 + 1820 | 0;
 i250 = i263 + 1784 | 0;
 i261 = i263 + 1756 | 0;
 i247 = i263;
 i256 = i263 + 1760 | 0;
 i20 = i263 + 64 | 0;
 i24 = i263 + 1736 | 0;
 i25 = i263 + 24 | 0;
 i21 = i263 + 1720 | 0;
 i22 = i263 + 1692 | 0;
 i252 = i263 + 1664 | 0;
 i23 = HEAP32[i26 >> 2] | 0;
 i246 = HEAP32[i26 + 4 >> 2] | 0;
 d2 = +HEAPF64[i1 >> 3];
 d6 = +HEAPF64[i1 + 24 >> 3];
 d3 = +HEAPF64[i1 + 8 >> 3];
 d7 = +HEAPF64[i1 + 32 >> 3];
 d5 = +HEAPF64[i1 + 16 >> 3];
 d8 = +HEAPF64[i1 + 40 >> 3];
 i244 = i247 + 8 | 0;
 i245 = i247 + 16 | 0;
 HEAPF64[i247 >> 3] = (d2 + d6) * .5;
 HEAPF64[i244 >> 3] = (d3 + d7) * .5;
 HEAPF64[i245 >> 3] = (d5 + d8) * .5;
 i1 = HEAP8[i18 + 8 >> 0] | 0;
 if (!(HEAP8[i18 + 9 >> 0] | 0)) i1 = i1 & 255; else i1 = (i1 & 255 | 2) & 65535;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 if (i19) {
  if (HEAP8[i18 + 10 >> 0] | 0) i1 = (i1 & 65535 | 4) & 65535;
  if (HEAP8[i18 + 11 >> 0] | 0) i1 = (i1 & 65535 | 8) & 65535;
 }
 f14 = Math_fround(d2);
 f13 = Math_fround(d3);
 f12 = Math_fround(d5);
 f11 = Math_fround(d6);
 f9 = Math_fround(d7);
 f17 = Math_fround(d8);
 HEAPF32[i256 >> 2] = f14;
 i239 = i256 + 4 | 0;
 HEAPF32[i239 >> 2] = f13;
 i240 = i256 + 8 | 0;
 HEAPF32[i240 >> 2] = f12;
 i241 = i256 + 12 | 0;
 HEAPF32[i241 >> 2] = f11;
 i242 = i256 + 16 | 0;
 HEAPF32[i242 >> 2] = f9;
 i243 = i256 + 20 | 0;
 HEAPF32[i243 >> 2] = f17;
 f15 = Math_fround(Math_fround(f14 + f11) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f12 + f17) * Math_fround(.5));
 f12 = Math_fround(f17 - f12);
 f17 = Math_fround(Math_fround(f9 - f13) * Math_fround(.5));
 i4 = i20 + 1600 | 0;
 i10 = i20;
 do {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = -1;
  i10 = i10 + 16 | 0;
 } while ((i10 | 0) != (i4 | 0));
 f13 = Math_fround(Math_fround(f13 + f9) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f11 - f14) * Math_fround(.5));
 f9 = Math_fround(f12 * Math_fround(.5));
 i4 = HEAP32[i18 >> 2] | 0;
 if (!i4) {
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
 } else {
  HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 }
 HEAP8[i24 + 18 >> 0] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = -1;
 i236 = i25 + 20 | 0;
 HEAP8[i236 >> 0] = 0;
 i238 = i25 + 24 | 0;
 HEAP32[i238 >> 2] = i20;
 HEAP32[i25 + 28 >> 2] = 100;
 i237 = i25 + 32 | 0;
 HEAP32[i237 >> 2] = 0;
 HEAP32[i25 >> 2] = gb + 85608 + 8;
 HEAP16[i24 + 16 >> 1] = i1 & 65535 | 32;
 i235 = HEAP32[(HEAP32[i23 >> 2] | 0) + 356 >> 2] | 0;
 HEAP32[i21 >> 2] = 3;
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f17;
 HEAPF32[i21 + 12 >> 2] = f9;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i22 + 16 >> 2] = f15;
 HEAPF32[i22 + 20 >> 2] = f13;
 HEAPF32[i22 + 24 >> 2] = f16;
 mftCall_iiiiiii(i235 | 0, i23 | 0, i21 | 0, i22 | 0, i25 | 0, i24 | 0, i19 | 0) | 0;
 i236 = (HEAPU8[i236 >> 0] | 0) + (HEAP32[i237 >> 2] | 0) | 0;
 if (!i236) {
  STACKTOP = i263;
  return;
 }
 i235 = i25 + 4 | 0;
 i26 = i26 + 8 | 0;
 i37 = i258 + 16 | 0;
 i38 = i258 + 20 | 0;
 i39 = i258 + 24 | 0;
 i40 = i257 + 12 | 0;
 i41 = i257 + 4 | 0;
 i42 = i257 + 8 | 0;
 i43 = i257 + 16 | 0;
 i44 = i257 + 20 | 0;
 i45 = i257 + 24 | 0;
 i46 = i258 + 12 | 0;
 i47 = i258 + 8 | 0;
 i48 = i258 + 4 | 0;
 i49 = i252 + 4 | 0;
 i50 = i252 + 8 | 0;
 i51 = i252 + 12 | 0;
 i52 = i252 + 16 | 0;
 i53 = i252 + 20 | 0;
 i54 = i252 + 24 | 0;
 i55 = i257 + 4 | 0;
 i56 = i251 + 4 | 0;
 i57 = i257 + 4 | 0;
 i58 = i257 + 8 | 0;
 i59 = i258 + 4 | 0;
 i60 = i258 + 8 | 0;
 i61 = i258 + 12 | 0;
 i62 = i248 + 4 | 0;
 i63 = i248 + 8 | 0;
 i64 = i248 + 12 | 0;
 i65 = i248 + 16 | 0;
 i66 = i248 + 20 | 0;
 i67 = i248 + 24 | 0;
 i68 = i248 + 28 | 0;
 i69 = i248 + 32 | 0;
 i70 = i248 + 36 | 0;
 i71 = i248 + 40 | 0;
 i72 = i248 + 44 | 0;
 i73 = i248 + 48 | 0;
 i74 = i248 + 52 | 0;
 i75 = i248 + 56 | 0;
 i76 = i248 + 60 | 0;
 i77 = i248 + 64 | 0;
 i78 = i248 + 68 | 0;
 i79 = i248 + 72 | 0;
 i80 = i248 + 76 | 0;
 i81 = i248 + 80 | 0;
 i82 = i248 + 84 | 0;
 i83 = i248 + 88 | 0;
 i84 = i248 + 92 | 0;
 i85 = i262 + 4 | 0;
 i86 = i255 + 56 | 0;
 i87 = i259 + 8 | 0;
 i88 = i259 + 4 | 0;
 i89 = i249 + 4 | 0;
 i90 = i249 + 8 | 0;
 i91 = i249 + 12 | 0;
 i92 = i249 + 16 | 0;
 i93 = i249 + 20 | 0;
 i94 = i249 + 24 | 0;
 i95 = i249 + 28 | 0;
 i96 = i249 + 32 | 0;
 i97 = i257 + 4 | 0;
 i98 = i257 + 8 | 0;
 i99 = i257 + 12 | 0;
 i100 = i257 + 16 | 0;
 i101 = i257 + 20 | 0;
 i102 = i257 + 24 | 0;
 i103 = i257 + 28 | 0;
 i104 = i257 + 32 | 0;
 i105 = i257 + 36 | 0;
 i106 = i255 + 52 | 0;
 i107 = i257 + 40 | 0;
 i108 = i257 + 44 | 0;
 i109 = i258 + 4 | 0;
 i110 = i258 + 8 | 0;
 i111 = i258 + 12 | 0;
 i112 = i258 + 16 | 0;
 i113 = i258 + 20 | 0;
 i114 = i258 + 24 | 0;
 i115 = i258 + 28 | 0;
 i116 = i258 + 32 | 0;
 i117 = i248 + 4 | 0;
 i118 = i248 + 8 | 0;
 i119 = i248 + 12 | 0;
 i120 = i249 + 4 | 0;
 i121 = i249 + 8 | 0;
 i122 = i249 + 12 | 0;
 i123 = i249 + 16 | 0;
 i124 = i249 + 20 | 0;
 i125 = i249 + 24 | 0;
 i126 = i255 + 32 | 0;
 i127 = i250 + 4 | 0;
 i128 = i250 + 8 | 0;
 i129 = i250 + 12 | 0;
 i130 = i250 + 16 | 0;
 i131 = i250 + 20 | 0;
 i132 = i250 + 24 | 0;
 i133 = i250 + 28 | 0;
 i134 = i250 + 32 | 0;
 i135 = i257 + 4 | 0;
 i136 = i257 + 8 | 0;
 i137 = i257 + 12 | 0;
 i138 = i257 + 16 | 0;
 i139 = i257 + 20 | 0;
 i140 = i257 + 24 | 0;
 i141 = i257 + 28 | 0;
 i142 = i257 + 32 | 0;
 i143 = i257 + 36 | 0;
 i144 = i257 + 40 | 0;
 i145 = i257 + 44 | 0;
 i146 = i257 + 4 | 0;
 i147 = i257 + 8 | 0;
 i148 = i257 + 12 | 0;
 i149 = i257 + 16 | 0;
 i150 = i257 + 20 | 0;
 i151 = i257 + 24 | 0;
 i152 = i257 + 28 | 0;
 i153 = i257 + 32 | 0;
 i154 = i262 + 8 | 0;
 i23 = i255 + 20 | 0;
 i24 = i255 + 24 | 0;
 i25 = i255 + 28 | 0;
 i155 = i250 + 4 | 0;
 i156 = i250 + 8 | 0;
 i157 = i250 + 12 | 0;
 i158 = i250 + 16 | 0;
 i159 = i250 + 20 | 0;
 i160 = i250 + 24 | 0;
 i161 = i250 + 28 | 0;
 i162 = i250 + 32 | 0;
 i163 = i257 + 4 | 0;
 i164 = i257 + 8 | 0;
 i165 = i257 + 12 | 0;
 i166 = i257 + 16 | 0;
 i167 = i257 + 20 | 0;
 i168 = i257 + 24 | 0;
 i169 = i257 + 28 | 0;
 i170 = i257 + 32 | 0;
 i171 = i257 + 36 | 0;
 i172 = i257 + 40 | 0;
 i173 = i257 + 44 | 0;
 i174 = i258 + 4 | 0;
 i175 = i258 + 8 | 0;
 i176 = i258 + 12 | 0;
 i177 = i258 + 16 | 0;
 i178 = i258 + 20 | 0;
 i179 = i248 + 4 | 0;
 i180 = i248 + 8 | 0;
 i181 = i248 + 12 | 0;
 i182 = i249 + 4 | 0;
 i183 = i249 + 8 | 0;
 i184 = i249 + 12 | 0;
 i185 = i249 + 16 | 0;
 i186 = i249 + 20 | 0;
 i187 = i249 + 24 | 0;
 i188 = i250 + 4 | 0;
 i189 = i250 + 8 | 0;
 i190 = i250 + 12 | 0;
 i191 = i250 + 16 | 0;
 i192 = i250 + 20 | 0;
 i193 = i250 + 24 | 0;
 i194 = i250 + 28 | 0;
 i195 = i250 + 32 | 0;
 i196 = i257 + 4 | 0;
 i197 = i257 + 8 | 0;
 i198 = i257 + 12 | 0;
 i199 = i257 + 16 | 0;
 i200 = i257 + 20 | 0;
 i201 = i257 + 24 | 0;
 i202 = i257 + 28 | 0;
 i203 = i257 + 32 | 0;
 i204 = i257 + 36 | 0;
 i205 = i257 + 40 | 0;
 i206 = i257 + 44 | 0;
 i207 = i257 + 4 | 0;
 i208 = i257 + 8 | 0;
 i209 = i257 + 12 | 0;
 i210 = i257 + 16 | 0;
 i211 = i257 + 20 | 0;
 i212 = i257 + 24 | 0;
 i213 = i257 + 28 | 0;
 i214 = i257 + 32 | 0;
 i215 = i250 + 4 | 0;
 i216 = i250 + 8 | 0;
 i217 = i250 + 12 | 0;
 i218 = i250 + 16 | 0;
 i219 = i250 + 20 | 0;
 i220 = i250 + 24 | 0;
 i221 = i250 + 28 | 0;
 i222 = i250 + 32 | 0;
 i223 = i257 + 4 | 0;
 i224 = i257 + 8 | 0;
 i225 = i257 + 12 | 0;
 i226 = i257 + 16 | 0;
 i227 = i257 + 20 | 0;
 i228 = i257 + 24 | 0;
 i229 = i257 + 28 | 0;
 i230 = i257 + 32 | 0;
 i231 = i257 + 36 | 0;
 i232 = i257 + 40 | 0;
 i233 = i257 + 44 | 0;
 i234 = 0;
 do {
  i22 = (HEAP32[i237 >> 2] | 0) >>> 0 > i234 >>> 0 ? (HEAP32[i238 >> 2] | 0) + (i234 << 4) | 0 : i235;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  L23 : do if ((i21 | 0) != 0 & (i22 | 0) != 0) {
   i4 = HEAP32[i26 >> 2] | 0;
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   L25 : do if (i1 | 0) {
    i20 = i21;
    i20 = i20 + ~(i20 << 15) | 0;
    i20 = (i20 >>> 10 ^ i20) * 9 | 0;
    i20 = i20 >>> 6 ^ i20;
    i20 = i20 + ~(i20 << 11) | 0;
    i1 = HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + ((i1 + -1 & (i20 >>> 16 ^ i20)) << 2) >> 2] | 0;
    if ((i1 | 0) != -1) {
     i18 = HEAP32[i4 + 4 >> 2] | 0;
     i10 = i4 + 8 | 0;
     i4 = i1;
     while (1) {
      i1 = i18 + (i4 << 2) | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i21 | 0)) break;
      i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      if ((i4 | 0) == -1) break L25;
     }
     if (i1 | 0) break L23;
    }
   } while (0);
   if (!((mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 136 >> 2] | 0, i21 | 0) | 0) & 4)) {
    mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 84 >> 2] | 0, i257 | 0, i22 | 0);
    mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 72 >> 2] | 0, i258 | 0, i21 | 0);
    f17 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) * Math_fround(2.0));
    f28 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * Math_fround(2.0));
    f33 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) * Math_fround(2.0));
    f14 = Math_fround(HEAPF32[i40 >> 2]);
    f15 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
    f16 = Math_fround(HEAPF32[i257 >> 2]);
    f36 = Math_fround(f17 * f16);
    f27 = Math_fround(HEAPF32[i41 >> 2]);
    f36 = Math_fround(f36 + Math_fround(f28 * f27));
    f29 = Math_fround(HEAPF32[i42 >> 2]);
    f36 = Math_fround(f36 + Math_fround(f33 * f29));
    f34 = Math_fround(Math_fround(f16 * f36) + Math_fround(Math_fround(f17 * f15) + Math_fround(f14 * Math_fround(Math_fround(f33 * f27) - Math_fround(f28 * f29)))));
    f35 = Math_fround(Math_fround(f27 * f36) + Math_fround(Math_fround(f28 * f15) + Math_fround(f14 * Math_fround(Math_fround(f17 * f29) - Math_fround(f33 * f16)))));
    f36 = Math_fround(Math_fround(Math_fround(f33 * f15) + Math_fround(f14 * Math_fround(Math_fround(f28 * f16) - Math_fround(f17 * f27)))) + Math_fround(f29 * f36));
    f34 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f34);
    f35 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) + f35);
    f36 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) + f36);
    f17 = Math_fround(HEAPF32[i258 >> 2]);
    f28 = Math_fround(f14 * f17);
    f15 = Math_fround(HEAPF32[i46 >> 2]);
    f28 = Math_fround(f28 + Math_fround(f16 * f15));
    f33 = Math_fround(HEAPF32[i47 >> 2]);
    f28 = Math_fround(f28 + Math_fround(f27 * f33));
    f30 = Math_fround(HEAPF32[i48 >> 2]);
    f31 = Math_fround(Math_fround(Math_fround(f29 * f17) + Math_fround(Math_fround(f27 * f15) + Math_fround(f14 * f30))) - Math_fround(f16 * f33));
    f32 = Math_fround(Math_fround(Math_fround(f16 * f30) + Math_fround(Math_fround(f29 * f15) + Math_fround(f14 * f33))) - Math_fround(f27 * f17));
    f33 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f17)) - Math_fround(f27 * f30)) - Math_fround(f29 * f33));
    HEAPF32[i252 >> 2] = Math_fround(f28 - Math_fround(f29 * f30));
    HEAPF32[i49 >> 2] = f31;
    HEAPF32[i50 >> 2] = f32;
    HEAPF32[i51 >> 2] = f33;
    HEAPF32[i52 >> 2] = f34;
    HEAPF32[i53 >> 2] = f35;
    HEAPF32[i54 >> 2] = f36;
    switch (mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 24 >> 2] | 0, i21 | 0) | 0) {
    case 0:
     {
      HEAP32[i257 >> 2] = 0;
      HEAPF32[i55 >> 2] = Math_fround(0.0);
      mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 40 >> 2] | 0, i21 | 0, i257 | 0) | 0;
      i18 = HEAP32[i55 >> 2] | 0;
      d6 = +Math_fround(HEAPF32[i52 >> 2]);
      d7 = +Math_fround(HEAPF32[i53 >> 2]);
      d8 = +Math_fround(HEAPF32[i54 >> 2]);
      i20 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i20 + 14 | 0);
      i19 = HEAP32[i251 >> 2] | 0;
      HEAP32[i19 + (i20 << 2) >> 2] = 4;
      HEAP32[i19 + (i20 + 1 << 2) >> 2] = i21;
      HEAP32[i19 + (i20 + 2 << 2) >> 2] = i22;
      i22 = i19 + (i20 + 4 << 2) | 0;
      HEAP32[i22 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i22 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i22 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i22 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i22 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i22 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      HEAP32[i19 + (i20 + 13 << 2) >> 2] = i18;
      HEAPF32[i19 + (i20 + 10 << 2) >> 2] = Math_fround(d6 - +HEAPF64[i247 >> 3]);
      HEAPF32[i19 + (i20 + 11 << 2) >> 2] = Math_fround(d7 - +HEAPF64[i244 >> 3]);
      HEAPF32[i19 + (i20 + 12 << 2) >> 2] = Math_fround(d8 - +HEAPF64[i245 >> 3]);
      break L23;
     }
    case 2:
     {
      HEAP32[i257 >> 2] = 2;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      HEAPF32[i58 >> 2] = Math_fround(0.0);
      mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 44 >> 2] | 0, i21 | 0, i257 | 0) | 0;
      f32 = Math_fround(HEAPF32[i58 >> 2]);
      f31 = Math_fround(HEAPF32[i252 >> 2]);
      f29 = Math_fround(f31 * Math_fround(2.0));
      f34 = Math_fround(HEAPF32[i51 >> 2]);
      f28 = Math_fround(f34 * Math_fround(2.0));
      f34 = Math_fround(Math_fround(f31 * f29) + Math_fround(Math_fround(f34 * f28) + Math_fround(-1.0)));
      f31 = Math_fround(HEAPF32[i50 >> 2]);
      f35 = Math_fround(f31 * f28);
      f36 = Math_fround(HEAPF32[i49 >> 2]);
      f34 = Math_fround(f32 * f34);
      f35 = Math_fround(f32 * Math_fround(f35 + Math_fround(f29 * f36)));
      f36 = Math_fround(f32 * Math_fround(Math_fround(f29 * f31) - Math_fround(f28 * f36)));
      f28 = Math_fround(HEAPF32[i52 >> 2]);
      f31 = Math_fround(f28 + f34);
      f29 = Math_fround(HEAPF32[i53 >> 2]);
      f32 = Math_fround(f29 + f35);
      f30 = Math_fround(HEAPF32[i54 >> 2]);
      f33 = Math_fround(f30 + f36);
      f34 = Math_fround(f28 - f34);
      f35 = Math_fround(f29 - f35);
      f36 = Math_fround(f30 - f36);
      i18 = HEAP32[i57 >> 2] | 0;
      i20 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i20 + 18 | 0);
      i19 = HEAP32[i251 >> 2] | 0;
      HEAP32[i19 + (i20 << 2) >> 2] = 5;
      HEAP32[i19 + (i20 + 1 << 2) >> 2] = i21;
      HEAP32[i19 + (i20 + 2 << 2) >> 2] = i22;
      i22 = i19 + (i20 + 4 << 2) | 0;
      HEAP32[i22 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i22 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i22 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i22 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i22 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i22 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      HEAP32[i19 + (i20 + 16 << 2) >> 2] = i18;
      d6 = +HEAPF64[i247 >> 3];
      HEAPF32[i19 + (i20 + 10 << 2) >> 2] = Math_fround(+f31 - d6);
      d7 = +HEAPF64[i244 >> 3];
      HEAPF32[i19 + (i20 + 11 << 2) >> 2] = Math_fround(+f32 - d7);
      d8 = +HEAPF64[i245 >> 3];
      HEAPF32[i19 + (i20 + 12 << 2) >> 2] = Math_fround(+f33 - d8);
      HEAPF32[i19 + (i20 + 13 << 2) >> 2] = Math_fround(+f34 - d6);
      HEAPF32[i19 + (i20 + 14 << 2) >> 2] = Math_fround(+f35 - d7);
      HEAPF32[i19 + (i20 + 15 << 2) >> 2] = Math_fround(+f36 - d8);
      break L23;
     }
    case 3:
     {
      HEAP32[i258 >> 2] = 3;
      HEAPF32[i59 >> 2] = Math_fround(0.0);
      HEAPF32[i60 >> 2] = Math_fround(0.0);
      HEAPF32[i61 >> 2] = Math_fround(0.0);
      mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0, i258 | 0) | 0;
      f32 = Math_fround(HEAPF32[i59 >> 2]);
      f31 = Math_fround(HEAPF32[i60 >> 2]);
      f30 = Math_fround(HEAPF32[i61 >> 2]);
      f27 = Math_fround(-f32);
      f28 = Math_fround(-f31);
      f29 = Math_fround(-f30);
      HEAPF32[i248 >> 2] = f27;
      HEAPF32[i62 >> 2] = f28;
      HEAPF32[i63 >> 2] = f29;
      HEAPF32[i64 >> 2] = f32;
      HEAPF32[i65 >> 2] = f28;
      HEAPF32[i66 >> 2] = f29;
      HEAPF32[i67 >> 2] = f32;
      HEAPF32[i68 >> 2] = f31;
      HEAPF32[i69 >> 2] = f29;
      HEAPF32[i70 >> 2] = f27;
      HEAPF32[i71 >> 2] = f31;
      HEAPF32[i72 >> 2] = f29;
      HEAPF32[i73 >> 2] = f27;
      HEAPF32[i74 >> 2] = f28;
      HEAPF32[i75 >> 2] = f30;
      HEAPF32[i76 >> 2] = f32;
      HEAPF32[i77 >> 2] = f28;
      HEAPF32[i78 >> 2] = f30;
      HEAPF32[i79 >> 2] = f32;
      HEAPF32[i80 >> 2] = f31;
      HEAPF32[i81 >> 2] = f30;
      HEAPF32[i82 >> 2] = f27;
      HEAPF32[i83 >> 2] = f31;
      HEAPF32[i84 >> 2] = f30;
      f30 = Math_fround(+HEAPF64[i247 >> 3]);
      f31 = Math_fround(+HEAPF64[i244 >> 3]);
      f32 = Math_fround(+HEAPF64[i245 >> 3]);
      f9 = Math_fround(HEAPF32[i51 >> 2]);
      f11 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
      f12 = Math_fround(HEAPF32[i252 >> 2]);
      f13 = Math_fround(HEAPF32[i49 >> 2]);
      f14 = Math_fround(HEAPF32[i50 >> 2]);
      f15 = Math_fround(HEAPF32[i52 >> 2]);
      f16 = Math_fround(HEAPF32[i53 >> 2]);
      f17 = Math_fround(HEAPF32[i54 >> 2]);
      i1 = 0;
      while (1) {
       f27 = Math_fround(f27 * Math_fround(2.0));
       f33 = Math_fround(f28 * Math_fround(2.0));
       f29 = Math_fround(f29 * Math_fround(2.0));
       f34 = Math_fround(Math_fround(f14 * f29) + Math_fround(Math_fround(f13 * f33) + Math_fround(f12 * f27)));
       f35 = Math_fround(Math_fround(f16 + Math_fround(Math_fround(f13 * f34) + Math_fround(Math_fround(f11 * f33) + Math_fround(f9 * Math_fround(Math_fround(f14 * f27) - Math_fround(f12 * f29)))))) - f31);
       f36 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(Math_fround(f11 * f29) + Math_fround(f9 * Math_fround(Math_fround(f12 * f33) - Math_fround(f13 * f27)))) + Math_fround(f14 * f34))) - f32);
       HEAPF32[i248 + (i1 * 12 | 0) >> 2] = Math_fround(Math_fround(f15 + Math_fround(Math_fround(Math_fround(f11 * f27) + Math_fround(f9 * Math_fround(Math_fround(f13 * f29) - Math_fround(f14 * f33)))) + Math_fround(f12 * f34))) - f30);
       HEAPF32[i248 + (i1 * 12 | 0) + 4 >> 2] = f35;
       HEAPF32[i248 + (i1 * 12 | 0) + 8 >> 2] = f36;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == 8) break;
       f28 = Math_fround(HEAPF32[i248 + (i1 * 12 | 0) + 4 >> 2]);
       f29 = Math_fround(HEAPF32[i248 + (i1 * 12 | 0) + 8 >> 2]);
       f27 = Math_fround(HEAPF32[i248 + (i1 * 12 | 0) >> 2]);
      }
      i10 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i10 + 12 | 0);
      i19 = HEAP32[i251 >> 2] | 0;
      HEAP32[i19 + (i10 << 2) >> 2] = 2;
      HEAP32[i19 + (i10 + 1 << 2) >> 2] = i21;
      HEAP32[i19 + (i10 + 2 << 2) >> 2] = i22;
      i18 = i19 + (i10 + 4 << 2) | 0;
      HEAP32[i18 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i18 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i18 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i18 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      i18 = HEAP32[i85 >> 2] | 0;
      HEAP32[i19 + (i10 + 11 << 2) >> 2] = i18;
      if (!(HEAP8[i86 >> 0] | 0)) {
       HEAP32[i19 + (i10 + 10 << 2) >> 2] = 12;
       __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i262, i18 + 12 | 0);
       i1 = HEAP32[i262 >> 2] | 0;
       i10 = 0;
       do {
        i4 = i10 + i18 | 0;
        i22 = HEAP32[gb + 85632 + (i10 * 12 | 0) >> 2] | 0;
        HEAP32[i1 + (i4 * 36 | 0) >> 2] = HEAP32[i248 + (i22 * 12 | 0) >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 4 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 4 >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 8 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 8 >> 2];
        i22 = HEAP32[gb + 85632 + (i10 * 12 | 0) + 4 >> 2] | 0;
        HEAP32[i1 + (i4 * 36 | 0) + 12 >> 2] = HEAP32[i248 + (i22 * 12 | 0) >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 16 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 4 >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 20 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 8 >> 2];
        i22 = HEAP32[gb + 85632 + (i10 * 12 | 0) + 8 >> 2] | 0;
        HEAP32[i1 + (i4 * 36 | 0) + 24 >> 2] = HEAP32[i248 + (i22 * 12 | 0) >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 28 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 4 >> 2];
        HEAP32[i1 + (i4 * 36 | 0) + 32 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 8 >> 2];
        HEAP32[i254 >> 2] = -1;
        i4 = HEAP32[i88 >> 2] | 0;
        if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
         HEAP32[(HEAP32[i259 >> 2] | 0) + (i4 << 2) >> 2] = -1;
         HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
        } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i254) | 0;
        i10 = i10 + 1 | 0;
       } while ((i10 | 0) != 12);
      } else {
       f15 = Math_fround(HEAPF32[i241 >> 2]);
       f34 = Math_fround(HEAPF32[i256 >> 2]);
       f12 = Math_fround(f15 - f34);
       f14 = Math_fround(HEAPF32[i242 >> 2]);
       f35 = Math_fround(HEAPF32[i239 >> 2]);
       f11 = Math_fround(f14 - f35);
       f13 = Math_fround(HEAPF32[i243 >> 2]);
       f36 = Math_fround(HEAPF32[i240 >> 2]);
       f12 = Math_fround(f12 * Math_fround(.5));
       f11 = Math_fround(f11 * Math_fround(.5));
       f9 = Math_fround(Math_fround(f13 - f36) * Math_fround(.5));
       f34 = Math_fround(Math_fround(Math_fround(f15 + f34) * Math_fround(.5)) - f30);
       f35 = Math_fround(Math_fround(Math_fround(f14 + f35) * Math_fround(.5)) - f31);
       f36 = Math_fround(Math_fround(Math_fround(f13 + f36) * Math_fround(.5)) - f32);
       f13 = Math_fround(f34 - f12);
       f14 = Math_fround(f35 - f11);
       f15 = Math_fround(f36 - f9);
       f34 = Math_fround(f12 + f34);
       f35 = Math_fround(f11 + f35);
       f36 = Math_fround(f9 + f36);
       f9 = Math_fround(Math_fround(f13 + f34) * Math_fround(.5));
       f11 = Math_fround(Math_fround(f14 + f35) * Math_fround(.5));
       f12 = Math_fround(Math_fround(f15 + f36) * Math_fround(.5));
       f13 = Math_fround(Math_fround(f34 - f13) * Math_fround(.5));
       f14 = Math_fround(Math_fround(f35 - f14) * Math_fround(.5));
       f15 = Math_fround(Math_fround(f36 - f15) * Math_fround(.5));
       i4 = 0;
       i1 = 0;
       do {
        i20 = HEAP32[gb + 85632 + (i4 * 12 | 0) >> 2] | 0;
        i21 = HEAP32[gb + 85632 + (i4 * 12 | 0) + 4 >> 2] | 0;
        i22 = HEAP32[gb + 85632 + (i4 * 12 | 0) + 8 >> 2] | 0;
        HEAP32[i249 >> 2] = HEAP32[i248 + (i20 * 12 | 0) >> 2];
        HEAP32[i89 >> 2] = HEAP32[i248 + (i20 * 12 | 0) + 4 >> 2];
        HEAP32[i90 >> 2] = HEAP32[i248 + (i20 * 12 | 0) + 8 >> 2];
        HEAP32[i91 >> 2] = HEAP32[i248 + (i21 * 12 | 0) >> 2];
        HEAP32[i92 >> 2] = HEAP32[i248 + (i21 * 12 | 0) + 4 >> 2];
        HEAP32[i93 >> 2] = HEAP32[i248 + (i21 * 12 | 0) + 8 >> 2];
        HEAP32[i94 >> 2] = HEAP32[i248 + (i22 * 12 | 0) >> 2];
        HEAP32[i95 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 4 >> 2];
        HEAP32[i96 >> 2] = HEAP32[i248 + (i22 * 12 | 0) + 8 >> 2];
        HEAP32[i257 >> 2] = 0;
        HEAP32[i97 >> 2] = -1;
        HEAP32[i98 >> 2] = i262;
        HEAP32[i99 >> 2] = i259;
        HEAPF32[i100 >> 2] = f9;
        HEAPF32[i101 >> 2] = f11;
        HEAPF32[i102 >> 2] = f12;
        HEAPF32[i103 >> 2] = f13;
        HEAPF32[i104 >> 2] = f14;
        HEAPF32[i105 >> 2] = f15;
        HEAP32[i107 >> 2] = HEAP32[i106 >> 2];
        HEAP16[i108 >> 1] = 0;
        __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i257, i249, i91, i94);
        i22 = HEAP32[i257 >> 2] | 0;
        HEAP16[i253 >> 1] = (HEAPU16[i253 >> 1] | 0) + (HEAPU16[i108 >> 1] | 0);
        i1 = i22 + i1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != 12);
       HEAP32[i19 + (i10 + 10 << 2) >> 2] = i1;
      }
      break L23;
     }
    case 5:
     {
      HEAP32[i258 >> 2] = 5;
      HEAPF32[i109 >> 2] = Math_fround(1.0);
      HEAPF32[i110 >> 2] = Math_fround(1.0);
      HEAPF32[i111 >> 2] = Math_fround(1.0);
      HEAPF32[i112 >> 2] = Math_fround(0.0);
      HEAPF32[i113 >> 2] = Math_fround(0.0);
      HEAPF32[i114 >> 2] = Math_fround(0.0);
      HEAPF32[i115 >> 2] = Math_fround(1.0);
      i20 = i116;
      HEAP32[i20 >> 2] = 0;
      HEAP32[i20 + 4 >> 2] = 0;
      mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 56 >> 2] | 0, i21 | 0, i258 | 0) | 0;
      f34 = Math_fround(HEAPF32[i241 >> 2]);
      f30 = Math_fround(HEAPF32[i256 >> 2]);
      f28 = Math_fround(f34 - f30);
      f31 = Math_fround(HEAPF32[i242 >> 2]);
      f32 = Math_fround(HEAPF32[i239 >> 2]);
      f35 = Math_fround(f31 - f32);
      f33 = Math_fround(HEAPF32[i243 >> 2]);
      f29 = Math_fround(HEAPF32[i240 >> 2]);
      f28 = Math_fround(f28 * Math_fround(.5));
      f35 = Math_fround(f35 * Math_fround(.5));
      f36 = Math_fround(Math_fround(f33 - f29) * Math_fround(.5));
      HEAP32[i248 >> 2] = 3;
      HEAPF32[i117 >> 2] = f28;
      HEAPF32[i118 >> 2] = f35;
      HEAPF32[i119 >> 2] = f36;
      f30 = Math_fround(Math_fround(f34 + f30) * Math_fround(.5));
      f32 = Math_fround(Math_fround(f31 + f32) * Math_fround(.5));
      f29 = Math_fround(Math_fround(f33 + f29) * Math_fround(.5));
      HEAP32[i249 >> 2] = 0;
      HEAP32[i120 >> 2] = 0;
      HEAP32[i121 >> 2] = 0;
      HEAP32[i122 >> 2] = 1065353216;
      HEAPF32[i123 >> 2] = f30;
      HEAPF32[i124 >> 2] = f32;
      HEAPF32[i125 >> 2] = f29;
      __ZN5physx17PxMeshOverlapUtilC2Ev(i254);
      i20 = __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_(i254, i248, i249, i258, i252) | 0;
      f29 = Math_fround(+HEAPF64[i247 >> 3]);
      f32 = Math_fround(-f29);
      f30 = Math_fround(+HEAPF64[i244 >> 3]);
      f33 = Math_fround(-f30);
      f31 = Math_fround(+HEAPF64[i245 >> 3]);
      f34 = Math_fround(-f31);
      i19 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i19 + 12 | 0);
      i18 = HEAP32[i251 >> 2] | 0;
      HEAP32[i18 + (i19 << 2) >> 2] = 2;
      HEAP32[i18 + (i19 + 1 << 2) >> 2] = i21;
      HEAP32[i18 + (i19 + 2 << 2) >> 2] = i22;
      i21 = i18 + (i19 + 4 << 2) | 0;
      HEAP32[i21 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i21 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i21 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i21 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i21 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      i21 = i18 + (i19 + 10 << 2) | 0;
      HEAP32[i21 >> 2] = i20;
      i1 = HEAP32[i85 >> 2] | 0;
      i22 = i18 + (i19 + 11 << 2) | 0;
      HEAP32[i22 >> 2] = i1;
      i19 = HEAP32[i254 >> 2] | 0;
      i18 = Math_fround(HEAPF32[i126 >> 2]) != Math_fround(0.0);
      i4 = (HEAP8[i86 >> 0] | 0) != 0;
      do if (i18) {
       if (i4) {
        f28 = Math_fround(Math_fround(HEAPF32[i123 >> 2]) - f29);
        f35 = Math_fround(Math_fround(HEAPF32[i124 >> 2]) - f30);
        f36 = Math_fround(Math_fround(HEAPF32[i125 >> 2]) - f31);
        f11 = Math_fround(HEAPF32[i117 >> 2]);
        f9 = Math_fround(f28 - f11);
        f13 = Math_fround(HEAPF32[i118 >> 2]);
        f12 = Math_fround(f35 - f13);
        f15 = Math_fround(HEAPF32[i119 >> 2]);
        f14 = Math_fround(f36 - f15);
        f11 = Math_fround(f28 + f11);
        f13 = Math_fround(f35 + f13);
        f15 = Math_fround(f36 + f15);
        if (!i20) i1 = 0; else {
         f17 = Math_fround(Math_fround(f9 + f11) * Math_fround(.5));
         f27 = Math_fround(Math_fround(f12 + f13) * Math_fround(.5));
         f28 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
         f16 = Math_fround(Math_fround(f11 - f9) * Math_fround(.5));
         f11 = Math_fround(Math_fround(f13 - f12) * Math_fround(.5));
         f9 = Math_fround(Math_fround(f15 - f14) * Math_fround(.5));
         i10 = 0;
         i1 = 0;
         do {
          i4 = HEAP32[i19 + (i10 << 2) >> 2] | 0;
          __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i4, i250, 0, 0);
          HEAPF32[i250 >> 2] = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f29);
          HEAPF32[i127 >> 2] = Math_fround(Math_fround(HEAPF32[i127 >> 2]) - f30);
          HEAPF32[i128 >> 2] = Math_fround(Math_fround(HEAPF32[i128 >> 2]) - f31);
          HEAPF32[i129 >> 2] = Math_fround(Math_fround(HEAPF32[i129 >> 2]) - f29);
          HEAPF32[i130 >> 2] = Math_fround(Math_fround(HEAPF32[i130 >> 2]) - f30);
          HEAPF32[i131 >> 2] = Math_fround(Math_fround(HEAPF32[i131 >> 2]) - f31);
          HEAPF32[i132 >> 2] = Math_fround(Math_fround(HEAPF32[i132 >> 2]) - f29);
          HEAPF32[i133 >> 2] = Math_fround(Math_fround(HEAPF32[i133 >> 2]) - f30);
          HEAPF32[i134 >> 2] = Math_fround(Math_fround(HEAPF32[i134 >> 2]) - f31);
          i18 = __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE(i255, i250, i262, i259) | 0;
          i1 = i18 + i1 | 0;
          if (!i18) {
           HEAP32[i257 >> 2] = 0;
           HEAP32[i135 >> 2] = i4;
           HEAP32[i136 >> 2] = i262;
           HEAP32[i137 >> 2] = i259;
           HEAPF32[i138 >> 2] = f17;
           HEAPF32[i139 >> 2] = f27;
           HEAPF32[i140 >> 2] = f28;
           HEAPF32[i141 >> 2] = f16;
           HEAPF32[i142 >> 2] = f11;
           HEAPF32[i143 >> 2] = f9;
           HEAP32[i144 >> 2] = HEAP32[i106 >> 2];
           HEAP16[i145 >> 1] = 0;
           __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i257, i250, i129, i132);
           i18 = HEAP32[i257 >> 2] | 0;
           HEAP16[i253 >> 1] = (HEAPU16[i253 >> 1] | 0) + (HEAPU16[i145 >> 1] | 0);
           i1 = i18 + i1 | 0;
          }
          i10 = i10 + 1 | 0;
         } while ((i10 | 0) != (i20 | 0));
        }
        HEAP32[i21 >> 2] = i1;
        break;
       }
       if (!i20) i1 = 0; else {
        i18 = 0;
        i1 = 0;
        do {
         i10 = HEAP32[i19 + (i18 << 2) >> 2] | 0;
         HEAP32[i260 >> 2] = i10;
         __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i10, i257, 0, 0);
         HEAPF32[i257 >> 2] = Math_fround(Math_fround(HEAPF32[i257 >> 2]) - f29);
         HEAPF32[i146 >> 2] = Math_fround(Math_fround(HEAPF32[i146 >> 2]) - f30);
         HEAPF32[i147 >> 2] = Math_fround(Math_fround(HEAPF32[i147 >> 2]) - f31);
         HEAPF32[i148 >> 2] = Math_fround(Math_fround(HEAPF32[i148 >> 2]) - f29);
         HEAPF32[i149 >> 2] = Math_fround(Math_fround(HEAPF32[i149 >> 2]) - f30);
         HEAPF32[i150 >> 2] = Math_fround(Math_fround(HEAPF32[i150 >> 2]) - f31);
         HEAPF32[i151 >> 2] = Math_fround(Math_fround(HEAPF32[i151 >> 2]) - f29);
         HEAPF32[i152 >> 2] = Math_fround(Math_fround(HEAPF32[i152 >> 2]) - f30);
         HEAPF32[i153 >> 2] = Math_fround(Math_fround(HEAPF32[i153 >> 2]) - f31);
         i4 = __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE(i255, i257, i262, i259) | 0;
         i1 = i4 + i1 | 0;
         if (!i4) {
          i4 = HEAP32[i85 >> 2] | 0;
          if ((HEAP32[i154 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           i264 = HEAP32[i262 >> 2] | 0;
           HEAP32[i264 + (i4 * 36 | 0) >> 2] = HEAP32[i257 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 4 >> 2] = HEAP32[i146 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 8 >> 2] = HEAP32[i147 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 12 >> 2] = HEAP32[i148 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 16 >> 2] = HEAP32[i149 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 20 >> 2] = HEAP32[i150 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 24 >> 2] = HEAP32[i151 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 28 >> 2] = HEAP32[i152 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 32 >> 2] = HEAP32[i153 >> 2];
           HEAP32[i85 >> 2] = i4 + 1;
          } else __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i262, i257) | 0;
          i4 = HEAP32[i88 >> 2] | 0;
          if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           HEAP32[(HEAP32[i259 >> 2] | 0) + (i4 << 2) >> 2] = i10;
           HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
          } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i260) | 0;
          i1 = i1 + 1 | 0;
         }
         i18 = i18 + 1 | 0;
        } while ((i18 | 0) != (i20 | 0));
       }
       HEAP32[i21 >> 2] = i1;
      } else {
       if (i4) {
        f28 = Math_fround(Math_fround(HEAPF32[i123 >> 2]) - f29);
        f35 = Math_fround(Math_fround(HEAPF32[i124 >> 2]) - f30);
        f36 = Math_fround(Math_fround(HEAPF32[i125 >> 2]) - f31);
        f11 = Math_fround(HEAPF32[i117 >> 2]);
        f9 = Math_fround(f28 - f11);
        f13 = Math_fround(HEAPF32[i118 >> 2]);
        f12 = Math_fround(f35 - f13);
        f15 = Math_fround(HEAPF32[i119 >> 2]);
        f14 = Math_fround(f36 - f15);
        f11 = Math_fround(f28 + f11);
        f13 = Math_fround(f35 + f13);
        f15 = Math_fround(f36 + f15);
        if (!i20) i1 = 0; else {
         f17 = Math_fround(Math_fround(f9 + f11) * Math_fround(.5));
         f27 = Math_fround(Math_fround(f12 + f13) * Math_fround(.5));
         f28 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
         f16 = Math_fround(Math_fround(f11 - f9) * Math_fround(.5));
         f11 = Math_fround(Math_fround(f13 - f12) * Math_fround(.5));
         f9 = Math_fround(Math_fround(f15 - f14) * Math_fround(.5));
         i4 = 0;
         i1 = 0;
         do {
          i264 = HEAP32[i19 + (i4 << 2) >> 2] | 0;
          __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i264, i250, 0, 0);
          HEAPF32[i250 >> 2] = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f29);
          HEAPF32[i155 >> 2] = Math_fround(Math_fround(HEAPF32[i155 >> 2]) - f30);
          HEAPF32[i156 >> 2] = Math_fround(Math_fround(HEAPF32[i156 >> 2]) - f31);
          HEAPF32[i157 >> 2] = Math_fround(Math_fround(HEAPF32[i157 >> 2]) - f29);
          HEAPF32[i158 >> 2] = Math_fround(Math_fround(HEAPF32[i158 >> 2]) - f30);
          HEAPF32[i159 >> 2] = Math_fround(Math_fround(HEAPF32[i159 >> 2]) - f31);
          HEAPF32[i160 >> 2] = Math_fround(Math_fround(HEAPF32[i160 >> 2]) - f29);
          HEAPF32[i161 >> 2] = Math_fround(Math_fround(HEAPF32[i161 >> 2]) - f30);
          HEAPF32[i162 >> 2] = Math_fround(Math_fround(HEAPF32[i162 >> 2]) - f31);
          HEAP32[i257 >> 2] = 0;
          HEAP32[i163 >> 2] = i264;
          HEAP32[i164 >> 2] = i262;
          HEAP32[i165 >> 2] = i259;
          HEAPF32[i166 >> 2] = f17;
          HEAPF32[i167 >> 2] = f27;
          HEAPF32[i168 >> 2] = f28;
          HEAPF32[i169 >> 2] = f16;
          HEAPF32[i170 >> 2] = f11;
          HEAPF32[i171 >> 2] = f9;
          HEAP32[i172 >> 2] = HEAP32[i106 >> 2];
          HEAP16[i173 >> 1] = 0;
          __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i257, i250, i157, i160);
          i264 = HEAP32[i257 >> 2] | 0;
          HEAP16[i253 >> 1] = (HEAPU16[i253 >> 1] | 0) + (HEAPU16[i173 >> 1] | 0);
          i1 = i264 + i1 | 0;
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i20 | 0));
        }
        HEAP32[i21 >> 2] = i1;
        break;
       }
       __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i262, i1 + i20 | 0);
       if (i20 | 0) {
        i10 = (HEAP32[i262 >> 2] | 0) + (i1 * 36 | 0) | 0;
        i18 = 0;
        while (1) {
         i1 = HEAP32[i19 + (i18 << 2) >> 2] | 0;
         HEAP32[i261 >> 2] = i1;
         __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i1, i10, 0, 0);
         HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f29);
         i4 = i10 + 4 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 8 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = i10 + 12 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f29);
         i4 = i10 + 16 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 20 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = i10 + 24 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f29);
         i4 = i10 + 28 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 32 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = HEAP32[i88 >> 2] | 0;
         if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
          HEAP32[(HEAP32[i259 >> 2] | 0) + (i4 << 2) >> 2] = i1;
          HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
         } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i261) | 0;
         i18 = i18 + 1 | 0;
         if ((i18 | 0) == (i20 | 0)) break; else i10 = i10 + 36 | 0;
        }
       }
       i1 = HEAP32[i21 >> 2] | 0;
      } while (0);
      f35 = Math_fround(HEAPF32[i23 >> 2]);
      f36 = Math_fround(HEAPF32[i24 >> 2]);
      __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i1, HEAP32[i22 >> 2] | 0, HEAP32[i262 >> 2] | 0, i246, f32, f33, f34, f35, f36, Math_fround(HEAPF32[i25 >> 2]));
      __ZN5physx17PxMeshOverlapUtilD2Ev(i254);
      break L23;
     }
    case 6:
     {
      HEAP32[i258 >> 2] = 6;
      HEAP32[i174 >> 2] = 0;
      HEAPF32[i175 >> 2] = Math_fround(1.0);
      HEAPF32[i176 >> 2] = Math_fround(1.0);
      HEAPF32[i177 >> 2] = Math_fround(1.0);
      HEAP32[i178 >> 2] = 0;
      mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 60 >> 2] | 0, i21 | 0, i258 | 0) | 0;
      f34 = Math_fround(HEAPF32[i241 >> 2]);
      f30 = Math_fround(HEAPF32[i256 >> 2]);
      f28 = Math_fround(f34 - f30);
      f31 = Math_fround(HEAPF32[i242 >> 2]);
      f32 = Math_fround(HEAPF32[i239 >> 2]);
      f35 = Math_fround(f31 - f32);
      f33 = Math_fround(HEAPF32[i243 >> 2]);
      f29 = Math_fround(HEAPF32[i240 >> 2]);
      f28 = Math_fround(f28 * Math_fround(.5));
      f35 = Math_fround(f35 * Math_fround(.5));
      f36 = Math_fround(Math_fround(f33 - f29) * Math_fround(.5));
      HEAP32[i248 >> 2] = 3;
      HEAPF32[i179 >> 2] = f28;
      HEAPF32[i180 >> 2] = f35;
      HEAPF32[i181 >> 2] = f36;
      f30 = Math_fround(Math_fround(f34 + f30) * Math_fround(.5));
      f32 = Math_fround(Math_fround(f31 + f32) * Math_fround(.5));
      f29 = Math_fround(Math_fround(f33 + f29) * Math_fround(.5));
      HEAP32[i249 >> 2] = 0;
      HEAP32[i182 >> 2] = 0;
      HEAP32[i183 >> 2] = 0;
      HEAP32[i184 >> 2] = 1065353216;
      HEAPF32[i185 >> 2] = f30;
      HEAPF32[i186 >> 2] = f32;
      HEAPF32[i187 >> 2] = f29;
      __ZN5physx17PxMeshOverlapUtilC2Ev(i254);
      i20 = __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_(i254, i248, i249, i258, i252) | 0;
      f29 = Math_fround(+HEAPF64[i247 >> 3]);
      f32 = Math_fround(-f29);
      f30 = Math_fround(+HEAPF64[i244 >> 3]);
      f33 = Math_fround(-f30);
      f31 = Math_fround(+HEAPF64[i245 >> 3]);
      f34 = Math_fround(-f31);
      i19 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i19 + 12 | 0);
      i264 = HEAP32[i251 >> 2] | 0;
      HEAP32[i264 + (i19 << 2) >> 2] = 2;
      HEAP32[i264 + (i19 + 1 << 2) >> 2] = i21;
      HEAP32[i264 + (i19 + 2 << 2) >> 2] = i22;
      i21 = i264 + (i19 + 4 << 2) | 0;
      HEAP32[i21 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i21 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i21 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i21 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i21 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i21 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      i21 = i264 + (i19 + 10 << 2) | 0;
      HEAP32[i21 >> 2] = i20;
      i1 = HEAP32[i85 >> 2] | 0;
      i22 = i264 + (i19 + 11 << 2) | 0;
      HEAP32[i22 >> 2] = i1;
      i19 = HEAP32[i254 >> 2] | 0;
      i264 = Math_fround(HEAPF32[i126 >> 2]) != Math_fround(0.0);
      i4 = (HEAP8[i86 >> 0] | 0) != 0;
      do if (i264) {
       if (i4) {
        f28 = Math_fround(Math_fround(HEAPF32[i185 >> 2]) - f29);
        f35 = Math_fround(Math_fround(HEAPF32[i186 >> 2]) - f30);
        f36 = Math_fround(Math_fround(HEAPF32[i187 >> 2]) - f31);
        f11 = Math_fround(HEAPF32[i179 >> 2]);
        f9 = Math_fround(f28 - f11);
        f13 = Math_fround(HEAPF32[i180 >> 2]);
        f12 = Math_fround(f35 - f13);
        f15 = Math_fround(HEAPF32[i181 >> 2]);
        f14 = Math_fround(f36 - f15);
        f11 = Math_fround(f28 + f11);
        f13 = Math_fround(f35 + f13);
        f15 = Math_fround(f36 + f15);
        if (!i20) i1 = 0; else {
         f17 = Math_fround(Math_fround(f9 + f11) * Math_fround(.5));
         f27 = Math_fround(Math_fround(f12 + f13) * Math_fround(.5));
         f28 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
         f16 = Math_fround(Math_fround(f11 - f9) * Math_fround(.5));
         f11 = Math_fround(Math_fround(f13 - f12) * Math_fround(.5));
         f9 = Math_fround(Math_fround(f15 - f14) * Math_fround(.5));
         i10 = 0;
         i1 = 0;
         do {
          i4 = HEAP32[i19 + (i10 << 2) >> 2] | 0;
          __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i4, i250, 0, 0);
          HEAPF32[i250 >> 2] = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f29);
          HEAPF32[i188 >> 2] = Math_fround(Math_fround(HEAPF32[i188 >> 2]) - f30);
          HEAPF32[i189 >> 2] = Math_fround(Math_fround(HEAPF32[i189 >> 2]) - f31);
          HEAPF32[i190 >> 2] = Math_fround(Math_fround(HEAPF32[i190 >> 2]) - f29);
          HEAPF32[i191 >> 2] = Math_fround(Math_fround(HEAPF32[i191 >> 2]) - f30);
          HEAPF32[i192 >> 2] = Math_fround(Math_fround(HEAPF32[i192 >> 2]) - f31);
          HEAPF32[i193 >> 2] = Math_fround(Math_fround(HEAPF32[i193 >> 2]) - f29);
          HEAPF32[i194 >> 2] = Math_fround(Math_fround(HEAPF32[i194 >> 2]) - f30);
          HEAPF32[i195 >> 2] = Math_fround(Math_fround(HEAPF32[i195 >> 2]) - f31);
          i264 = __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE(i255, i250, i262, i259) | 0;
          i1 = i264 + i1 | 0;
          if (!i264) {
           HEAP32[i257 >> 2] = 0;
           HEAP32[i196 >> 2] = i4;
           HEAP32[i197 >> 2] = i262;
           HEAP32[i198 >> 2] = i259;
           HEAPF32[i199 >> 2] = f17;
           HEAPF32[i200 >> 2] = f27;
           HEAPF32[i201 >> 2] = f28;
           HEAPF32[i202 >> 2] = f16;
           HEAPF32[i203 >> 2] = f11;
           HEAPF32[i204 >> 2] = f9;
           HEAP32[i205 >> 2] = HEAP32[i106 >> 2];
           HEAP16[i206 >> 1] = 0;
           __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i257, i250, i190, i193);
           i264 = HEAP32[i257 >> 2] | 0;
           HEAP16[i253 >> 1] = (HEAPU16[i253 >> 1] | 0) + (HEAPU16[i206 >> 1] | 0);
           i1 = i264 + i1 | 0;
          }
          i10 = i10 + 1 | 0;
         } while ((i10 | 0) != (i20 | 0));
        }
        HEAP32[i21 >> 2] = i1;
        break;
       }
       if (!i20) i1 = 0; else {
        i18 = 0;
        i1 = 0;
        do {
         i10 = HEAP32[i19 + (i18 << 2) >> 2] | 0;
         HEAP32[i260 >> 2] = i10;
         __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i10, i257, 0, 0);
         HEAPF32[i257 >> 2] = Math_fround(Math_fround(HEAPF32[i257 >> 2]) - f29);
         HEAPF32[i207 >> 2] = Math_fround(Math_fround(HEAPF32[i207 >> 2]) - f30);
         HEAPF32[i208 >> 2] = Math_fround(Math_fround(HEAPF32[i208 >> 2]) - f31);
         HEAPF32[i209 >> 2] = Math_fround(Math_fround(HEAPF32[i209 >> 2]) - f29);
         HEAPF32[i210 >> 2] = Math_fround(Math_fround(HEAPF32[i210 >> 2]) - f30);
         HEAPF32[i211 >> 2] = Math_fround(Math_fround(HEAPF32[i211 >> 2]) - f31);
         HEAPF32[i212 >> 2] = Math_fround(Math_fround(HEAPF32[i212 >> 2]) - f29);
         HEAPF32[i213 >> 2] = Math_fround(Math_fround(HEAPF32[i213 >> 2]) - f30);
         HEAPF32[i214 >> 2] = Math_fround(Math_fround(HEAPF32[i214 >> 2]) - f31);
         i264 = __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE(i255, i257, i262, i259) | 0;
         i1 = i264 + i1 | 0;
         if (!i264) {
          i4 = HEAP32[i85 >> 2] | 0;
          if ((HEAP32[i154 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           i264 = HEAP32[i262 >> 2] | 0;
           HEAP32[i264 + (i4 * 36 | 0) >> 2] = HEAP32[i257 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 4 >> 2] = HEAP32[i207 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 8 >> 2] = HEAP32[i208 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 12 >> 2] = HEAP32[i209 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 16 >> 2] = HEAP32[i210 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 20 >> 2] = HEAP32[i211 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 24 >> 2] = HEAP32[i212 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 28 >> 2] = HEAP32[i213 >> 2];
           HEAP32[i264 + (i4 * 36 | 0) + 32 >> 2] = HEAP32[i214 >> 2];
           HEAP32[i85 >> 2] = i4 + 1;
          } else __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i262, i257) | 0;
          i4 = HEAP32[i88 >> 2] | 0;
          if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           HEAP32[(HEAP32[i259 >> 2] | 0) + (i4 << 2) >> 2] = i10;
           HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
          } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i260) | 0;
          i1 = i1 + 1 | 0;
         }
         i18 = i18 + 1 | 0;
        } while ((i18 | 0) != (i20 | 0));
       }
       HEAP32[i21 >> 2] = i1;
      } else {
       if (i4) {
        f28 = Math_fround(Math_fround(HEAPF32[i185 >> 2]) - f29);
        f35 = Math_fround(Math_fround(HEAPF32[i186 >> 2]) - f30);
        f36 = Math_fround(Math_fround(HEAPF32[i187 >> 2]) - f31);
        f11 = Math_fround(HEAPF32[i179 >> 2]);
        f9 = Math_fround(f28 - f11);
        f13 = Math_fround(HEAPF32[i180 >> 2]);
        f12 = Math_fround(f35 - f13);
        f15 = Math_fround(HEAPF32[i181 >> 2]);
        f14 = Math_fround(f36 - f15);
        f11 = Math_fround(f28 + f11);
        f13 = Math_fround(f35 + f13);
        f15 = Math_fround(f36 + f15);
        if (!i20) i1 = 0; else {
         f17 = Math_fround(Math_fround(f9 + f11) * Math_fround(.5));
         f27 = Math_fround(Math_fround(f12 + f13) * Math_fround(.5));
         f28 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
         f16 = Math_fround(Math_fround(f11 - f9) * Math_fround(.5));
         f11 = Math_fround(Math_fround(f13 - f12) * Math_fround(.5));
         f9 = Math_fround(Math_fround(f15 - f14) * Math_fround(.5));
         i4 = 0;
         i1 = 0;
         do {
          i264 = HEAP32[i19 + (i4 << 2) >> 2] | 0;
          __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i264, i250, 0, 0);
          HEAPF32[i250 >> 2] = Math_fround(Math_fround(HEAPF32[i250 >> 2]) - f29);
          HEAPF32[i215 >> 2] = Math_fround(Math_fround(HEAPF32[i215 >> 2]) - f30);
          HEAPF32[i216 >> 2] = Math_fround(Math_fround(HEAPF32[i216 >> 2]) - f31);
          HEAPF32[i217 >> 2] = Math_fround(Math_fround(HEAPF32[i217 >> 2]) - f29);
          HEAPF32[i218 >> 2] = Math_fround(Math_fround(HEAPF32[i218 >> 2]) - f30);
          HEAPF32[i219 >> 2] = Math_fround(Math_fround(HEAPF32[i219 >> 2]) - f31);
          HEAPF32[i220 >> 2] = Math_fround(Math_fround(HEAPF32[i220 >> 2]) - f29);
          HEAPF32[i221 >> 2] = Math_fround(Math_fround(HEAPF32[i221 >> 2]) - f30);
          HEAPF32[i222 >> 2] = Math_fround(Math_fround(HEAPF32[i222 >> 2]) - f31);
          HEAP32[i257 >> 2] = 0;
          HEAP32[i223 >> 2] = i264;
          HEAP32[i224 >> 2] = i262;
          HEAP32[i225 >> 2] = i259;
          HEAPF32[i226 >> 2] = f17;
          HEAPF32[i227 >> 2] = f27;
          HEAPF32[i228 >> 2] = f28;
          HEAPF32[i229 >> 2] = f16;
          HEAPF32[i230 >> 2] = f11;
          HEAPF32[i231 >> 2] = f9;
          HEAP32[i232 >> 2] = HEAP32[i106 >> 2];
          HEAP16[i233 >> 1] = 0;
          __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i257, i250, i217, i220);
          i264 = HEAP32[i257 >> 2] | 0;
          HEAP16[i253 >> 1] = (HEAPU16[i253 >> 1] | 0) + (HEAPU16[i233 >> 1] | 0);
          i1 = i264 + i1 | 0;
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i20 | 0));
        }
        HEAP32[i21 >> 2] = i1;
        break;
       }
       __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i262, i1 + i20 | 0);
       if (i20 | 0) {
        i10 = (HEAP32[i262 >> 2] | 0) + (i1 * 36 | 0) | 0;
        i18 = 0;
        while (1) {
         i1 = HEAP32[i19 + (i18 << 2) >> 2] | 0;
         HEAP32[i261 >> 2] = i1;
         __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i258, i252, i1, i10, 0, 0);
         HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f29);
         i4 = i10 + 4 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 8 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = i10 + 12 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f29);
         i4 = i10 + 16 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 20 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = i10 + 24 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f29);
         i4 = i10 + 28 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f30);
         i4 = i10 + 32 | 0;
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f31);
         i4 = HEAP32[i88 >> 2] | 0;
         if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
          HEAP32[(HEAP32[i259 >> 2] | 0) + (i4 << 2) >> 2] = i1;
          HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
         } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i261) | 0;
         i18 = i18 + 1 | 0;
         if ((i18 | 0) == (i20 | 0)) break; else i10 = i10 + 36 | 0;
        }
       }
       i1 = HEAP32[i21 >> 2] | 0;
      } while (0);
      f35 = Math_fround(HEAPF32[i23 >> 2]);
      f36 = Math_fround(HEAPF32[i24 >> 2]);
      __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i1, HEAP32[i22 >> 2] | 0, HEAP32[i262 >> 2] | 0, i246, f32, f33, f34, f35, f36, Math_fround(HEAPF32[i25 >> 2]));
      __ZN5physx17PxMeshOverlapUtilD2Ev(i254);
      break L23;
     }
    case 4:
     {
      __ZL20outputConvexToStreamPN5physx7PxShapeEPKNS_12PxRigidActorERKNS_11PxTransformERNS_6shdfnd5ArrayIjNS8_19ReflectionAllocatorIjEEEERNS9_INS_10PxTriangleENSA_ISE_EEEESD_RKNS_14PxExtendedVec3ERKNS_9PxBounds3ERKNS_3Cct9CCTParamsEPNS_2Cm12RenderBufferERt(i21, i22, i252, i251, i262, i259, i247, i256, i255, i246, i253);
      break L23;
     }
    case 1:
     {
      f35 = Math_fround(HEAPF32[i241 >> 2]);
      f35 = Math_fround(f35 - Math_fround(HEAPF32[i256 >> 2]));
      f34 = Math_fround(HEAPF32[i242 >> 2]);
      f34 = Math_fround(f34 - Math_fround(HEAPF32[i239 >> 2]));
      f14 = Math_fround(HEAPF32[i243 >> 2]);
      f14 = Math_fround(f14 - Math_fround(HEAPF32[i240 >> 2]));
      f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f34 * f34)) + Math_fround(f14 * f14))));
      f34 = Math_fround(+HEAPF64[i247 >> 3]);
      f35 = Math_fround(+HEAPF64[i244 >> 3]);
      f36 = Math_fround(+HEAPF64[i245 >> 3]);
      f31 = Math_fround(HEAPF32[i51 >> 2]);
      f30 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
      f32 = Math_fround(HEAPF32[i252 >> 2]);
      f17 = Math_fround(f32 * Math_fround(2.0));
      f33 = Math_fround(HEAPF32[i49 >> 2]);
      f16 = Math_fround(f33 * Math_fround(0.0));
      f17 = Math_fround(f17 + f16);
      f27 = Math_fround(HEAPF32[i50 >> 2]);
      f15 = Math_fround(f27 * Math_fround(0.0));
      f17 = Math_fround(f17 + f15);
      f15 = Math_fround(Math_fround(f32 * f17) + Math_fround(Math_fround(f30 * Math_fround(2.0)) + Math_fround(f31 * Math_fround(f16 - f15))));
      f30 = Math_fround(f30 * Math_fround(0.0));
      f32 = Math_fround(f32 * Math_fround(0.0));
      f16 = Math_fround(Math_fround(f33 * f17) + Math_fround(f30 + Math_fround(f31 * Math_fround(Math_fround(f27 * Math_fround(2.0)) - f32))));
      f17 = Math_fround(Math_fround(f30 + Math_fround(f31 * Math_fround(f32 - Math_fround(f33 * Math_fround(2.0))))) + Math_fround(f27 * f17));
      f27 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f15);
      f27 = Math_fround(f27 + Math_fround(Math_fround(HEAPF32[i53 >> 2]) * f16));
      f27 = Math_fround(Math_fround(0.0) - Math_fround(Math_fround(Math_fround(HEAPF32[i54 >> 2]) * f17) + f27));
      if (Math_fround(Math_abs(Math_fround(f16))) > Math_fround(.999899983)) {
       f9 = Math_fround(0.0);
       f12 = Math_fround(0.0);
       f13 = Math_fround(1.0);
       i10 = 1065353216;
       i4 = 0;
       i1 = 0;
      } else {
       f9 = Math_fround(f16 * Math_fround(0.0));
       f13 = Math_fround(f17 - f9);
       f12 = Math_fround(Math_fround(f15 * Math_fround(0.0)) - Math_fround(f17 * Math_fround(0.0)));
       f9 = Math_fround(f9 - f15);
       i10 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
       f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)))));
       if (f11 > Math_fround(0.0)) {
        f33 = Math_fround(Math_fround(1.0) / f11);
        f13 = Math_fround(f13 * f33);
        i10 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
        f12 = Math_fround(f12 * f33);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
        f33 = Math_fround(f9 * f33);
        f9 = f33;
        i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
       }
      }
      f28 = Math_fround(Math_fround(f16 * f9) - Math_fround(f17 * f12));
      f29 = Math_fround(Math_fround(f17 * f13) - Math_fround(f15 * f9));
      f30 = Math_fround(Math_fround(f15 * f12) - Math_fround(f16 * f13));
      f33 = Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f32 = Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f31 = Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f28 = Math_fround(f14 * f28);
      f29 = Math_fround(f14 * f29);
      f30 = Math_fround(f14 * f30);
      f13 = Math_fround(Math_fround(Math_fround(f36 * f17) + Math_fround(Math_fround(f34 * f15) + Math_fround(f35 * f16))) + f27);
      f265 = Math_fround(f34 - Math_fround(f15 * f13));
      f27 = Math_fround(f35 - Math_fround(f16 * f13));
      f16 = Math_fround(f36 - Math_fround(f17 * f13));
      f13 = Math_fround(f265 - f33);
      f14 = Math_fround(f27 - f32);
      f15 = Math_fround(f16 - f31);
      f9 = Math_fround(f13 + f28);
      f11 = Math_fround(f14 + f29);
      f12 = Math_fround(f15 + f30);
      f13 = Math_fround(f13 - f28);
      f14 = Math_fround(f14 - f29);
      f15 = Math_fround(f15 - f30);
      f33 = Math_fround(f265 + f33);
      f32 = Math_fround(f27 + f32);
      f31 = Math_fround(f16 + f31);
      f16 = Math_fround(f33 - f28);
      f17 = Math_fround(f32 - f29);
      f27 = Math_fround(f31 - f30);
      f28 = Math_fround(f33 + f28);
      f29 = Math_fround(f32 + f29);
      f30 = Math_fround(f31 + f30);
      f31 = Math_fround(-f34);
      f32 = Math_fround(-f35);
      f33 = Math_fround(-f36);
      i18 = HEAP32[i56 >> 2] | 0;
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i251, i18 + 12 | 0);
      i19 = HEAP32[i251 >> 2] | 0;
      HEAP32[i19 + (i18 << 2) >> 2] = 2;
      HEAP32[i19 + (i18 + 1 << 2) >> 2] = i21;
      HEAP32[i19 + (i18 + 2 << 2) >> 2] = i22;
      i4 = i19 + (i18 + 4 << 2) | 0;
      HEAP32[i4 >> 2] = HEAP32[i247 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i247 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i247 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i247 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i247 + 16 >> 2];
      HEAP32[i4 + 20 >> 2] = HEAP32[i247 + 20 >> 2];
      i4 = i19 + (i18 + 10 << 2) | 0;
      HEAP32[i4 >> 2] = 2;
      i10 = HEAP32[i85 >> 2] | 0;
      i18 = i19 + (i18 + 11 << 2) | 0;
      HEAP32[i18 >> 2] = i10;
      __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i262, i10 + 2 | 0);
      i19 = HEAP32[i262 >> 2] | 0;
      HEAP32[i257 >> 2] = 0;
      i1 = HEAP32[i88 >> 2] | 0;
      if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       HEAP32[(HEAP32[i259 >> 2] | 0) + (i1 << 2) >> 2] = 0;
       i1 = (HEAP32[i88 >> 2] | 0) + 1 | 0;
       HEAP32[i88 >> 2] = i1;
      } else {
       __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i257) | 0;
       i1 = HEAP32[i88 >> 2] | 0;
      }
      HEAP32[i258 >> 2] = 1;
      if ((HEAP32[i87 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       HEAP32[(HEAP32[i259 >> 2] | 0) + (i1 << 2) >> 2] = 1;
       HEAP32[i88 >> 2] = (HEAP32[i88 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i259, i258) | 0;
      f9 = Math_fround(f9 - f34);
      f11 = Math_fround(f11 - f35);
      f12 = Math_fround(f12 - f36);
      HEAPF32[i19 + (i10 * 36 | 0) >> 2] = f9;
      HEAPF32[i19 + (i10 * 36 | 0) + 4 >> 2] = f11;
      HEAPF32[i19 + (i10 * 36 | 0) + 8 >> 2] = f12;
      f14 = Math_fround(f14 - f35);
      f265 = Math_fround(f15 - f36);
      HEAPF32[i19 + (i10 * 36 | 0) + 12 >> 2] = Math_fround(f13 - f34);
      HEAPF32[i19 + (i10 * 36 | 0) + 16 >> 2] = f14;
      HEAPF32[i19 + (i10 * 36 | 0) + 20 >> 2] = f265;
      f16 = Math_fround(f16 - f34);
      f17 = Math_fround(f17 - f35);
      f265 = Math_fround(f27 - f36);
      HEAPF32[i19 + (i10 * 36 | 0) + 24 >> 2] = f16;
      HEAPF32[i19 + (i10 * 36 | 0) + 28 >> 2] = f17;
      HEAPF32[i19 + (i10 * 36 | 0) + 32 >> 2] = f265;
      i264 = i10 + 1 | 0;
      HEAPF32[i19 + (i264 * 36 | 0) >> 2] = f9;
      HEAPF32[i19 + (i264 * 36 | 0) + 4 >> 2] = f11;
      HEAPF32[i19 + (i264 * 36 | 0) + 8 >> 2] = f12;
      HEAPF32[i19 + (i264 * 36 | 0) + 12 >> 2] = f16;
      HEAPF32[i19 + (i264 * 36 | 0) + 16 >> 2] = f17;
      HEAPF32[i19 + (i264 * 36 | 0) + 20 >> 2] = f265;
      f265 = Math_fround(f29 - f35);
      f36 = Math_fround(f30 - f36);
      HEAPF32[i19 + (i264 * 36 | 0) + 24 >> 2] = Math_fround(f28 - f34);
      HEAPF32[i19 + (i264 * 36 | 0) + 28 >> 2] = f265;
      HEAPF32[i19 + (i264 * 36 | 0) + 32 >> 2] = f36;
      f36 = Math_fround(HEAPF32[i23 >> 2]);
      f265 = Math_fround(HEAPF32[i24 >> 2]);
      __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(HEAP32[i4 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i262 >> 2] | 0, i246, f31, f32, f33, f36, f265, Math_fround(HEAPF32[i25 >> 2]));
      break L23;
     }
    default:
     break L23;
    }
   }
  } while (0);
  i234 = i234 + 1 | 0;
 } while ((i234 | 0) != (i236 | 0));
 STACKTOP = i263;
 return;
}

function __ZN5physx15PxVehicleUpdate13updateDriveNWEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDriveNWEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f49, i15, f50, f51, i14, i197, i193, i198) {
 f49 = Math_fround(f49);
 i15 = i15 | 0;
 f50 = Math_fround(f50);
 f51 = Math_fround(f51);
 i14 = i14 | 0;
 i197 = i197 | 0;
 i193 = i193 | 0;
 i198 = i198 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, f137 = f0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, f142 = f0, i143 = 0, i144 = 0, f145 = f0, i146 = 0, i147 = 0, f148 = f0, f149 = f0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, f159 = f0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i194 = 0, i195 = 0, i196 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0;
 i199 = STACKTOP;
 STACKTOP = STACKTOP + 11296 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i174 = i199 + 10688 | 0;
 i5 = i199 + 9568 | 0;
 i195 = i199 + 9528 | 0;
 i191 = i199 + 9408 | 0;
 i182 = i199 + 9428 | 0;
 i196 = i199 + 6448 | 0;
 i190 = i199 + 6260 | 0;
 i169 = i199 + 6232 | 0;
 i178 = i199 + 6092 | 0;
 i185 = i199 + 6080 | 0;
 i184 = i199 + 316 | 0;
 i6 = i199 + 288 | 0;
 i7 = i199 + 168 | 0;
 i8 = i199 + 80 | 0;
 i9 = i199 + 68 | 0;
 i10 = i199 + 56 | 0;
 i167 = i199 + 11272 | 0;
 i12 = i199 + 40 | 0;
 i168 = i199 + 6368 | 0;
 i179 = i199 + 11252 | 0;
 i181 = i199 + 6288 | 0;
 i173 = i199 + 6152 | 0;
 i172 = i199 + 6104 | 0;
 i170 = i199 + 28 | 0;
 i171 = i199 + 16 | 0;
 i183 = i199 + 5968 | 0;
 i180 = i199 + 11232 | 0;
 i192 = i199 + 328 | 0;
 i177 = i199 + 196 | 0;
 i175 = i199 + 96 | 0;
 i176 = i199 + 8 | 0;
 i194 = i199;
 i165 = i197 + 8 | 0;
 i189 = HEAP32[i197 + 44 >> 2] | 0;
 i166 = (i189 | 0) == 0;
 if (!i166) {
  i1 = HEAP32[i197 + 72 >> 2] | 0;
  i4 = 0;
  do {
   i2 = i4 << 2;
   i3 = HEAP32[gb + 1458456 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) {
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 1) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 4 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 2) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 8 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 3) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 12 >> 2];
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i189 >>> 0);
 }
 i163 = i197 + 128 | 0;
 i164 = i197 + 204 | 0;
 i1 = HEAP32[gb + 1458536 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i164 >> 2];
 i186 = HEAP32[i197 + 40 >> 2] | 0;
 i4 = i197 + 72 | 0;
 i187 = HEAP32[i4 >> 2] | 0;
 i188 = HEAP32[i197 + 48 >> 2] | 0;
 i2 = 4 - (i189 << 2) | 0;
 i11 = HEAP32[i197 + 288 >> 2] | 0;
 _memcpy(i174 | 0, i197 + 224 | 0, i11 << 3 | 0) | 0;
 i162 = i174 + 64 | 0;
 HEAP32[i162 >> 2] = i11;
 i11 = i174 + 80 | 0;
 i13 = i197 + 304 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
 _memcpy(i174 + 112 | 0, i197 + 336 | 0, 416) | 0;
 i11 = i174 + 528 | 0;
 i13 = i197 + 752 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i13 = HEAP32[i197 + 104 >> 2] | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 i1 = i5 + 60 | 0;
 i16 = i5 + 16 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 68 >> 2] = Math_fround(1.0);
 i1 = i5 + 116 | 0;
 i16 = i5 + 72 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 124 >> 2] = Math_fround(1.0);
 i1 = i5 + 172 | 0;
 i16 = i5 + 128 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 180 >> 2] = Math_fround(1.0);
 i1 = i5 + 228 | 0;
 i16 = i5 + 184 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 236 >> 2] = Math_fround(1.0);
 i1 = i5 + 284 | 0;
 i16 = i5 + 240 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 292 >> 2] = Math_fround(1.0);
 i1 = i5 + 340 | 0;
 i16 = i5 + 296 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 348 >> 2] = Math_fround(1.0);
 i1 = i5 + 396 | 0;
 i16 = i5 + 352 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 404 >> 2] = Math_fround(1.0);
 i1 = i5 + 452 | 0;
 i16 = i5 + 408 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 456 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 460 >> 2] = Math_fround(1.0);
 i1 = i5 + 508 | 0;
 i16 = i5 + 464 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 512 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 516 >> 2] = Math_fround(1.0);
 i1 = i5 + 564 | 0;
 i16 = i5 + 520 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 568 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 572 >> 2] = Math_fround(1.0);
 i1 = i5 + 620 | 0;
 i16 = i5 + 576 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 624 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 628 >> 2] = Math_fround(1.0);
 i1 = i5 + 676 | 0;
 i16 = i5 + 632 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 680 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 684 >> 2] = Math_fround(1.0);
 i1 = i5 + 732 | 0;
 i16 = i5 + 688 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 740 >> 2] = Math_fround(1.0);
 i1 = i5 + 788 | 0;
 i16 = i5 + 744 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 792 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 796 >> 2] = Math_fround(1.0);
 i1 = i5 + 844 | 0;
 i16 = i5 + 800 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 848 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 852 >> 2] = Math_fround(1.0);
 i1 = i5 + 900 | 0;
 i16 = i5 + 856 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 904 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 908 >> 2] = Math_fround(1.0);
 i1 = i5 + 956 | 0;
 i16 = i5 + 912 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 960 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 964 >> 2] = Math_fround(1.0);
 i1 = i5 + 1012 | 0;
 i16 = i5 + 968 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1016 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1020 >> 2] = Math_fround(1.0);
 i1 = i5 + 1068 | 0;
 i16 = i5 + 1024 | 0;
 i17 = i16 + 44 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1072 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1076 >> 2] = Math_fround(1.0);
 i16 = i5 + 1080 | 0;
 i17 = i16 + 40 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 i3 = i2 + i188 | 0;
 HEAP32[i195 >> 2] = 0;
 HEAP32[i195 + 4 >> 2] = 0;
 HEAP32[i195 + 8 >> 2] = 0;
 HEAP32[i195 + 12 >> 2] = 0;
 HEAP32[i195 + 16 >> 2] = 0;
 HEAP32[i195 + 20 >> 2] = 0;
 HEAP32[i195 + 24 >> 2] = 0;
 HEAP32[i195 + 28 >> 2] = 0;
 HEAP16[i195 + 32 >> 1] = 0;
 HEAP32[i195 + 4 >> 2] = i188;
 HEAP32[i195 >> 2] = i5;
 HEAP32[i191 >> 2] = 0;
 HEAP32[i191 + 4 >> 2] = 0;
 HEAP32[i191 + 8 >> 2] = 0;
 HEAP32[i191 + 12 >> 2] = 0;
 HEAP32[i191 + 16 >> 2] = 0;
 HEAP32[i191 >> 2] = i188 >>> 0 < 4 ? i188 : 4;
 i1 = i189 + -1 | 0;
 if (i1 >>> 0 > 1) {
  i2 = 1;
  do {
   HEAP32[i191 + (i2 << 2) >> 2] = 4;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i191 + (i1 << 2) >> 2] = i3;
 if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i163, 3)) != Math_fround(0.0)) i161 = 15; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i163, 4)) != Math_fround(0.0)) i161 = 15; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i163, 0)) != Math_fround(0.0)) i161 = 15; else if (!(HEAP8[i197 + 194 >> 0] | 0)) if (!(HEAP8[i197 + 193 >> 0] | 0)) i1 = 0; else i161 = 15; else i161 = 15;
 if ((i161 | 0) == 15) i1 = 1;
 do if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 256 >> 2] | 0, i13 | 0) | 0) {
  if (i1) {
   HEAP8[i195 + 33 >> 0] = 1;
   break;
  }
  if (__ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE(i165, i4) | 0) {
   HEAP8[i195 + 33 >> 0] = 1;
   break;
  }
  HEAPF32[i164 >> 2] = Math_fround(0.0);
  i3 = ((HEAP32[i197 + 88 >> 2] | 0) + 3 | 0) >>> 2;
  i1 = HEAP32[i197 + 72 >> 2] | 0;
  if (i3 | 0) {
   i2 = 0;
   do {
    HEAPF32[i1 + (i2 * 224 | 0) >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  HEAPF32[i164 >> 2] = Math_fround(0.0);
  if (!i198) {
   STACKTOP = i199;
   return;
  }
  HEAP8[i198 + 32 >> 0] = 1;
  STACKTOP = i199;
  return;
 } while (0);
 if (!i166) {
  i1 = HEAP32[i197 + 76 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = 0;
  do {
   i160 = i3 << 2;
   HEAP32[i182 + (i3 * 20 | 0) >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + (i160 << 2) >> 2];
   HEAP32[i182 + (i3 * 20 | 0) + 4 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i160 | 1) << 2) >> 2];
   HEAP32[i182 + (i3 * 20 | 0) + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i160 | 2) << 2) >> 2];
   HEAP32[i182 + (i3 * 20 | 0) + 12 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i160 | 3) << 2) >> 2];
   HEAP32[i182 + (i3 * 20 | 0) + 16 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i189 | 0));
  if (!i166) {
   i1 = 0;
   do {
    i160 = HEAP32[(HEAP32[i187 + (i1 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i160 >> 2] | 0) + 36 >> 2] | 0, i160 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i189 | 0));
  }
 }
 i1 = i196 + 2960 | 0;
 i2 = i196;
 do {
  _memset(i2 | 0, 0, 140) | 0;
  HEAP8[i2 + 28 >> 0] = 1;
  HEAP32[i2 + 44 >> 2] = -1;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP32[i2 + 124 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 1065353216;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 140 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = 0;
  i2 = i2 + 148 | 0;
 } while ((i2 | 0) != (i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 124 >> 2] | 0, i6 | 0, i13 | 0);
 i156 = HEAP32[i6 >> 2] | 0;
 HEAP32[i190 >> 2] = i156;
 i153 = i190 + 4 | 0;
 HEAP32[i153 >> 2] = HEAP32[i6 + 4 >> 2];
 i154 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i190 + 8 >> 2] = i154;
 i155 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i190 + 12 >> 2] = i155;
 i140 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i190 + 16 >> 2] = i140;
 i158 = HEAP32[i6 + 20 >> 2] | 0;
 HEAP32[i190 + 20 >> 2] = i158;
 i157 = HEAP32[i6 + 24 >> 2] | 0;
 HEAP32[i190 + 24 >> 2] = i157;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i13 | 0);
 f42 = Math_fround((HEAP32[tempDoublePtr >> 2] = i140, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f44 = Math_fround((HEAP32[tempDoublePtr >> 2] = i158, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i157, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f148 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f149 = Math_fround(Math_fround(f148 * f148) + Math_fround(-.5));
 f43 = Math_fround(HEAPF32[i7 >> 2]);
 f159 = Math_fround(f42 * f43);
 f41 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f159 = Math_fround(f159 + Math_fround(f44 * f41));
 f46 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f159 = Math_fround(f159 + Math_fround(f38 * f46));
 f45 = Math_fround(Math_fround(f43 * f159) + Math_fround(Math_fround(f42 * f149) + Math_fround(f148 * Math_fround(Math_fround(f38 * f41) - Math_fround(f44 * f46)))));
 f34 = Math_fround(Math_fround(f41 * f159) + Math_fround(Math_fround(f44 * f149) + Math_fround(f148 * Math_fround(Math_fround(f42 * f46) - Math_fround(f38 * f43)))));
 f159 = Math_fround(Math_fround(Math_fround(f38 * f149) + Math_fround(f148 * Math_fround(Math_fround(f44 * f43) - Math_fround(f42 * f41)))) + Math_fround(f46 * f159));
 f45 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f45);
 f34 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f34);
 f159 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f159);
 f42 = (HEAP32[tempDoublePtr >> 2] = i156, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = Math_fround(f148 * f42);
 f149 = (HEAP32[tempDoublePtr >> 2] = i155, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = Math_fround(f44 + Math_fround(f43 * f149));
 f38 = (HEAP32[tempDoublePtr >> 2] = i154, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = Math_fround(f44 + Math_fround(f41 * f38));
 f48 = Math_fround(HEAPF32[i153 >> 2]);
 f44 = Math_fround(f44 - Math_fround(f46 * f48));
 f36 = Math_fround(Math_fround(Math_fround(f46 * f42) + Math_fround(Math_fround(f41 * f149) + Math_fround(f148 * f48))) - Math_fround(f43 * f38));
 f47 = Math_fround(Math_fround(Math_fround(f43 * f48) + Math_fround(Math_fround(f46 * f149) + Math_fround(f148 * f38))) - Math_fround(f41 * f42));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f148 * f149) - Math_fround(f43 * f42)) - Math_fround(f41 * f48)) - Math_fround(f46 * f38));
 HEAPF32[i169 >> 2] = f44;
 i153 = i169 + 4 | 0;
 HEAPF32[i153 >> 2] = f36;
 i154 = i169 + 8 | 0;
 HEAPF32[i154 >> 2] = f47;
 i155 = i169 + 12 | 0;
 HEAPF32[i155 >> 2] = f38;
 i156 = i169 + 16 | 0;
 HEAPF32[i156 >> 2] = f45;
 i157 = i169 + 20 | 0;
 HEAPF32[i157 >> 2] = f34;
 i158 = i169 + 24 | 0;
 HEAPF32[i158 >> 2] = f159;
 f159 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i13 >> 2] | 0) + 136 >> 2] | 0, i13 | 0));
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i8 | 0, i13 | 0);
 HEAP32[i178 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i178 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i178 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i13 | 0);
 i140 = HEAP32[i9 >> 2] | 0;
 HEAP32[i185 >> 2] = i140;
 i141 = HEAP32[i9 + 4 >> 2] | 0;
 i160 = i185 + 4 | 0;
 HEAP32[i160 >> 2] = i141;
 i143 = HEAP32[i9 + 8 >> 2] | 0;
 i151 = i185 + 8 | 0;
 HEAP32[i151 >> 2] = i143;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i13 | 0);
 i144 = HEAP32[i10 >> 2] | 0;
 HEAP32[i184 >> 2] = i144;
 i146 = HEAP32[i10 + 4 >> 2] | 0;
 i152 = i184 + 4 | 0;
 HEAP32[i152 >> 2] = i146;
 i147 = HEAP32[i10 + 8 >> 2] | 0;
 i150 = i184 + 8 | 0;
 HEAP32[i150 >> 2] = i147;
 f34 = Math_fround(HEAPF32[i163 >> 2]);
 f45 = (HEAP32[tempDoublePtr >> 2] = i140, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i141, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i143, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i144, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i146, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i147, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (HEAP8[i197 + 192 >> 0] | 0) {
  i1 = HEAP32[i197 + 196 >> 2] | 0;
  i147 = HEAP32[i197 + 200 >> 2] | 0;
  f34 = (i1 | 0) == 1 & (i147 | 0) != (i1 | 0) ? Math_fround(0.0) : f34;
  i3 = i197 + 212 | 0;
  f35 = Math_fround(HEAPF32[i3 >> 2]);
  if ((i147 | 0) == (i1 | 0)) if (f35 > Math_fround(HEAPF32[i174 + 400 >> 2])) {
   f149 = Math_fround(HEAPF32[i164 >> 2]);
   f149 = Math_fround(f149 * Math_fround(HEAPF32[i174 + 108 >> 2]));
   i2 = i1 | 0 ? f149 > Math_fround(HEAPF32[i174 + 272 + (i1 << 2) >> 2]) : 0;
   i1 = i1 >>> 0 > 2 ? f149 < Math_fround(HEAPF32[i174 + 400 + (i1 << 2) >> 2]) : 0;
   if (!(i2 | i1)) break;
   HEAP8[i197 + 193 >> 0] = i2 & 1;
   HEAP8[i197 + 194 >> 0] = i1 & 1;
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   break;
  }
  HEAPF32[i3 >> 2] = Math_fround(f35 + f49);
 } while (0);
 i6 = i197 + 193 | 0;
 do if (!(HEAP8[i6 >> 0] | 0)) {
  i1 = i197 + 196 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i1 = (HEAP32[i174 + 244 >> 2] | 0) + -1 | 0;
  i2 = i197 + 196 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i1 = i197 + 200 | 0;
   if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) {
    if (!i3) {
     HEAPF32[i197 + 208 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
    HEAPF32[i197 + 208 >> 2] = Math_fround(0.0);
    if ((i3 | 0) == 1) {
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    } else {
     HEAP32[i1 >> 2] = i3 + 1;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
   } else i1 = i3;
  }
 } while (0);
 i5 = i197 + 194 | 0;
 do if (HEAP8[i5 >> 0] | 0) if (!i1) i1 = 0; else {
  i3 = i197 + 200 | 0;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   if ((i1 | 0) == 2) {
    HEAPF32[i197 + 208 >> 2] = Math_fround(0.0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
   HEAPF32[i197 + 208 >> 2] = Math_fround(0.0);
   if ((i1 | 0) == 1) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   } else {
    HEAP32[i3 >> 2] = i1 + -1;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
  }
 } while (0);
 i3 = HEAP32[i197 + 200 >> 2] | 0;
 do if ((i1 | 0) != (i3 | 0)) {
  i4 = i197 + 208 | 0;
  f35 = Math_fround(HEAPF32[i4 >> 2]);
  if (f35 > Math_fround(HEAPF32[i174 + 248 >> 2])) {
   HEAP32[i2 >> 2] = i3;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
   i1 = i3;
   break;
  } else {
   HEAPF32[i4 >> 2] = Math_fround(f35 + f49);
   break;
  }
 } while (0);
 i141 = (i1 | 0) == 1;
 f142 = Math_fround(HEAPF32[i174 + 256 >> 2]);
 f142 = i141 ? Math_fround(0.0) : f142;
 i143 = HEAP32[i174 + 260 >> 2] | 0;
 i144 = HEAP32[i174 + 264 >> 2] | 0;
 f145 = Math_fround(HEAPF32[i174 + 112 + (i1 << 2) >> 2]);
 f145 = Math_fround(f145 * Math_fround(HEAPF32[i174 + 240 >> 2]));
 i5 = HEAP32[gb + 1458536 >> 2] | 0;
 i2 = (i5 | 0) == 0;
 if (!i2) HEAPF32[i5 + 32 >> 2] = f145;
 i146 = HEAP32[i197 + 132 >> 2] | 0;
 i147 = HEAP32[i197 + 136 >> 2] | 0;
 f35 = Math_fround(HEAPF32[i197 + 140 >> 2]);
 f37 = Math_fround(HEAPF32[i197 + 144 >> 2]);
 f40 = Math_fround(f37 - f35);
 i6 = f34 > Math_fround(0.0);
 f148 = (HEAP32[tempDoublePtr >> 2] = i146, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i6 & f148 == Math_fround(0.0);
 f149 = (HEAP32[tempDoublePtr >> 2] = i147, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = (i1 | 0) != 1 & (i6 & f149 == Math_fround(0.0));
 if (!i2) {
  HEAPF32[i5 + 12 >> 2] = f34;
  HEAP32[i5 + 16 >> 2] = i146;
  HEAP32[i5 + 20 >> 2] = i147;
  HEAPF32[i5 + 24 >> 2] = f35;
  HEAPF32[i5 + 28 >> 2] = f37;
 }
 i16 = i167;
 i17 = i16 + 20 | 0;
 do {
  HEAP8[i16 >> 0] = 0;
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) < (i17 | 0));
 if (!i166) {
  i4 = 0;
  do {
   i1 = i4 << 2;
   i2 = HEAP32[i197 + 52 + ((i4 >>> 3 & 134217727) << 2) >> 2] | 0;
   i3 = i1 & 28;
   if (i2 & 1 << i3 | 0) HEAP8[i167 + i1 >> 0] = 1;
   if (i2 & 1 << (i3 | 1) | 0) HEAP8[i167 + (i1 | 1) >> 0] = 1;
   if (i2 & 1 << (i3 | 2) | 0) HEAP8[i167 + (i1 | 2) >> 0] = 1;
   if (i2 & 1 << (i3 | 3) | 0) HEAP8[i167 + (i1 | 3) >> 0] = 1;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i189 | 0));
 };
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f39 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 i16 = i168;
 i17 = i16 + 80 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 i3 = (i188 | 0) == 0;
 if (i3) i2 = i5; else {
  i1 = 0;
  do {
   i140 = __ZNK5physx27PxVehicleDifferentialNWData16getIsDrivenWheelEj(i12, i1) | 0;
   HEAPF32[i168 + (i1 << 2) >> 2] = i140 ? f39 : Math_fround(0.0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i188 | 0));
  i2 = HEAP32[gb + 1458536 >> 2] | 0;
 }
 f37 = Math_fround(HEAPF32[i164 >> 2]);
 if (i2 | 0) {
  if (i166) f35 = Math_fround(0.0); else {
   f35 = Math_fround(0.0);
   i1 = 0;
   do {
    f137 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) >> 2]);
    i140 = i1 << 2;
    f137 = Math_fround(f35 + Math_fround(f137 * Math_fround(HEAPF32[i168 + (i140 << 2) >> 2])));
    f35 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 4 >> 2]);
    f35 = Math_fround(f137 + Math_fround(f35 * Math_fround(HEAPF32[i168 + ((i140 | 1) << 2) >> 2])));
    f137 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 8 >> 2]);
    f137 = Math_fround(f35 + Math_fround(f137 * Math_fround(HEAPF32[i168 + ((i140 | 2) << 2) >> 2])));
    f35 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 12 >> 2]);
    f35 = Math_fround(f137 + Math_fround(f35 * Math_fround(HEAPF32[i168 + ((i140 | 3) << 2) >> 2])));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i189 | 0));
  }
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(f145 * f35) - f37);
 }
 i16 = i179;
 i17 = i16 + 20 | 0;
 do {
  HEAP8[i16 >> 0] = 0;
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) < (i17 | 0));
 if (!(i166 | i6 ^ 1)) {
  i1 = 0;
  do {
   i140 = i1 << 2;
   HEAP8[i179 + i140 >> 0] = Math_fround(HEAPF32[i168 + (i140 << 2) >> 2]) != Math_fround(0.0) & 1;
   i139 = i140 | 1;
   HEAP8[i179 + i139 >> 0] = Math_fround(HEAPF32[i168 + (i139 << 2) >> 2]) != Math_fround(0.0) & 1;
   i139 = i140 | 2;
   HEAP8[i179 + i139 >> 0] = Math_fround(HEAPF32[i168 + (i139 << 2) >> 2]) != Math_fround(0.0) & 1;
   i140 = i140 | 3;
   HEAP8[i179 + i140 >> 0] = Math_fround(HEAPF32[i168 + (i140 << 2) >> 2]) != Math_fround(0.0) & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i189 | 0));
 }
 i16 = i181;
 i17 = i16 + 80 | 0;
 do {
  HEAP32[i16 >> 2] = 0;
  i16 = i16 + 4 | 0;
 } while ((i16 | 0) < (i17 | 0));
 if (i3) {
  i16 = i173;
  i17 = i16 + 80 | 0;
  do {
   HEAP32[i16 >> 2] = 0;
   i16 = i16 + 4 | 0;
  } while ((i16 | 0) < (i17 | 0));
  i140 = i173;
 } else {
  i1 = 0;
  do {
   i140 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i165, i1) | 0;
   f137 = Math_fround(HEAPF32[i140 + 28 >> 2]);
   HEAPF32[i181 + (i1 << 2) >> 2] = Math_fround(Math_fround(f40 * f137) + Math_fround(HEAPF32[i140 + 32 >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i188 | 0));
  i16 = i173;
  i17 = i16 + 80 | 0;
  do {
   HEAP32[i16 >> 2] = 0;
   i16 = i16 + 4 | 0;
  } while ((i16 | 0) < (i17 | 0));
  if (i3) i140 = i173; else {
   i1 = 0;
   do {
    i140 = __ZNK5physx27PxVehicleDifferentialNWData16getIsDrivenWheelEj(i12, i1) | 0;
    HEAPF32[i173 + (i1 << 2) >> 2] = i140 ? f39 : Math_fround(0.0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i188 | 0));
   i140 = i173;
  }
 }
 if (i166) {
  i138 = i184;
  i139 = i185;
  f37 = f44;
  f35 = f47;
 } else {
  i3 = 0;
  do {
   i1 = i3 << 2;
   i2 = i196 + (i1 * 148 | 0) | 0;
   if (!(HEAP32[i187 + (i3 * 224 | 0) + 212 >> 2] | 0)) {
    i136 = i196 + ((i1 | 1) * 148 | 0) | 0;
    i138 = i196 + ((i1 | 2) * 148 | 0) | 0;
    i139 = i196 + ((i1 | 3) * 148 | 0) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i136 >> 2] = 0;
    HEAP32[i136 + 4 >> 2] = 0;
    HEAP32[i136 + 8 >> 2] = 0;
    HEAP32[i136 + 12 >> 2] = 0;
    HEAP32[i136 + 16 >> 2] = 0;
    HEAP32[i136 + 20 >> 2] = 0;
    HEAP32[i136 + 24 >> 2] = 0;
    HEAP32[i138 >> 2] = 0;
    HEAP32[i138 + 4 >> 2] = 0;
    HEAP32[i138 + 8 >> 2] = 0;
    HEAP32[i138 + 12 >> 2] = 0;
    HEAP32[i138 + 16 >> 2] = 0;
    HEAP32[i138 + 20 >> 2] = 0;
    HEAP32[i138 + 24 >> 2] = 0;
    HEAP32[i139 >> 2] = 0;
    HEAP32[i139 + 4 >> 2] = 0;
    HEAP32[i139 + 8 >> 2] = 0;
    HEAP32[i139 + 12 >> 2] = 0;
    HEAP32[i139 + 16 >> 2] = 0;
    HEAP32[i139 + 20 >> 2] = 0;
    HEAP32[i139 + 24 >> 2] = 0;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 96 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 4 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 100 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 8 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 104 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 12 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 144 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 16 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 148 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 20 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 152 >> 2];
    HEAP32[i196 + (i1 * 148 | 0) + 24 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 192 >> 2];
    i139 = i1 | 1;
    HEAP32[i196 + (i139 * 148 | 0) >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 108 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 4 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 112 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 8 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 116 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 12 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 156 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 16 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 160 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 20 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 164 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 24 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 196 >> 2];
    i139 = i1 | 2;
    HEAP32[i196 + (i139 * 148 | 0) >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 120 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 4 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 124 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 8 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 128 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 12 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 168 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 16 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 172 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 20 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 176 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 24 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 200 >> 2];
    i139 = i1 | 3;
    HEAP32[i196 + (i139 * 148 | 0) >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 132 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 4 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 136 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 8 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 140 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 12 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 180 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 16 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 184 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 20 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 188 >> 2];
    HEAP32[i196 + (i139 * 148 | 0) + 24 >> 2] = HEAP32[i187 + (i3 * 224 | 0) + 204 >> 2];
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i189 | 0));
  f45 = Math_fround(HEAPF32[i185 >> 2]);
  f46 = Math_fround(HEAPF32[i160 >> 2]);
  f48 = Math_fround(HEAPF32[i151 >> 2]);
  f41 = Math_fround(HEAPF32[i184 >> 2]);
  f42 = Math_fround(HEAPF32[i152 >> 2]);
  f43 = Math_fround(HEAPF32[i150 >> 2]);
  f38 = Math_fround(HEAPF32[i155 >> 2]);
  f37 = Math_fround(HEAPF32[i169 >> 2]);
  f36 = Math_fround(HEAPF32[i153 >> 2]);
  i138 = i184;
  i139 = i185;
  f35 = Math_fround(HEAPF32[i154 >> 2]);
 }
 f44 = Math_fround(Math_fround(HEAPF32[gb + 158860 >> 2]) * Math_fround(2.0));
 f40 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 4 >> 2]) * Math_fround(2.0));
 f137 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 8 >> 2]) * Math_fround(2.0));
 f47 = Math_fround(Math_fround(f38 * f38) + Math_fround(-.5));
 f39 = Math_fround(Math_fround(Math_fround(f44 * f37) + Math_fround(f40 * f36)) + Math_fround(f137 * f35));
 f137 = Math_fround(Math_abs(Math_fround(Math_fround(f48 * Math_fround(Math_fround(Math_fround(f137 * f47) + Math_fround(f38 * Math_fround(Math_fround(f40 * f37) - Math_fround(f44 * f36)))) + Math_fround(f35 * f39))) + Math_fround(Math_fround(f45 * Math_fround(Math_fround(f37 * f39) + Math_fround(Math_fround(f44 * f47) + Math_fround(f38 * Math_fround(Math_fround(f137 * f36) - Math_fround(f40 * f35)))))) + Math_fround(f46 * Math_fround(Math_fround(f36 * f39) + Math_fround(Math_fround(f40 * f47) + Math_fround(f38 * Math_fround(Math_fround(f44 * f35) - Math_fround(f137 * f37))))))))));
 f44 = Math_fround(HEAPF32[i197 + 56 >> 2]);
 i136 = f137 < f44 ? HEAP32[i197 + 60 >> 2] | 0 : HEAP32[i197 + 64 >> 2] | 0;
 f44 = Math_fround(Math_fround(1.0) / Math_fround(i136 >>> 0));
 f137 = Math_fround(f44 * f49);
 f47 = Math_fround(Math_fround(1.0) / f137);
 f49 = Math_fround(Math_fround(1.0) / f49);
 i135 = HEAP32[i197 + 68 >> 2] | 0;
 HEAPF32[i172 >> 2] = f44;
 HEAPF32[i172 + 4 >> 2] = f137;
 HEAPF32[i172 + 8 >> 2] = f47;
 HEAP32[i172 + 12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i172 + 16 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i172 + 20 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAPF32[i172 + 24 >> 2] = f50;
 HEAPF32[i172 + 28 >> 2] = f51;
 HEAP8[i172 + 32 >> 0] = 0;
 HEAP32[i172 + 36 >> 2] = i135;
 HEAP32[i172 + 40 >> 2] = i13;
 HEAP32[i172 + 44 >> 2] = i14;
 L145 : do if (i136 | 0) {
  i108 = i170 + 4 | 0;
  i109 = i170 + 8 | 0;
  i110 = i171 + 4 | 0;
  i111 = i171 + 8 | 0;
  i112 = i174 + 84 | 0;
  i113 = i174 + 108 | 0;
  i114 = i174 + 4 | 0;
  i115 = i174 + 92 | 0;
  i116 = i174 + 96 | 0;
  i117 = i174 + 100 | 0;
  i118 = i175 + 4 | 0;
  i119 = i175 + 8 | 0;
  i120 = i175 + 12 | 0;
  i121 = i175 + 16 | 0;
  i122 = i175 + 20 | 0;
  i123 = i175 + 24 | 0;
  i124 = i175 + 28 | 0;
  i125 = i175 + 32 | 0;
  i126 = i175 + 36 | 0;
  i127 = i175 + 40 | 0;
  i128 = i175 + 44 | 0;
  i129 = i175 + 48 | 0;
  i130 = i175 + 52 | 0;
  i131 = i175 + 56 | 0;
  i132 = i175 + 60 | 0;
  i133 = i175 + 64 | 0;
  i134 = i175 + 68 | 0;
  i135 = i176 + 4 | 0;
  f47 = Math_fround(f142 * f145);
  i21 = i6 & 1;
  i22 = i177 + 4 | 0;
  i23 = i177 + 8 | 0;
  i24 = i177 + 12 | 0;
  i25 = i177 + 16 | 0;
  i26 = i177 + 20 | 0;
  i27 = i177 + 24 | 0;
  i28 = i177 + 28 | 0;
  i29 = i177 + 32 | 0;
  i30 = i177 + 36 | 0;
  i31 = i177 + 40 | 0;
  i32 = i177 + 44 | 0;
  i33 = i177 + 48 | 0;
  i52 = i177 + 52 | 0;
  i53 = i177 + 56 | 0;
  i54 = i177 + 60 | 0;
  i55 = i177 + 64 | 0;
  i56 = i177 + 68 | 0;
  i57 = i177 + 72 | 0;
  i58 = i177 + 76 | 0;
  i59 = i177 + 80 | 0;
  i60 = i177 + 84 | 0;
  i61 = i177 + 88 | 0;
  i62 = i136 + -1 | 0;
  f44 = Math_fround(-f148);
  i63 = i192 + 112 | 0;
  i64 = i192 + 164 | 0;
  i65 = i192 + 113 | 0;
  i66 = i192 + 168 | 0;
  i67 = i192 + 114 | 0;
  i68 = i192 + 172 | 0;
  i69 = i192 + 115 | 0;
  i70 = i192 + 176 | 0;
  i71 = i192 + 1128 | 0;
  i72 = i192 + 1240 | 0;
  i73 = i192 + 1292 | 0;
  i74 = i192 + 1241 | 0;
  i75 = i192 + 1296 | 0;
  i76 = i192 + 1242 | 0;
  i77 = i192 + 1300 | 0;
  i78 = i192 + 1243 | 0;
  i79 = i192 + 1304 | 0;
  i80 = i192 + 2256 | 0;
  i81 = i192 + 2368 | 0;
  i82 = i192 + 2420 | 0;
  i83 = i192 + 2369 | 0;
  i84 = i192 + 2424 | 0;
  i85 = i192 + 2370 | 0;
  i86 = i192 + 2428 | 0;
  i87 = i192 + 2371 | 0;
  i88 = i192 + 2432 | 0;
  i89 = i192 + 3384 | 0;
  i90 = i192 + 3496 | 0;
  i91 = i192 + 3548 | 0;
  i92 = i192 + 3497 | 0;
  i93 = i192 + 3552 | 0;
  i94 = i192 + 3498 | 0;
  i95 = i192 + 3556 | 0;
  i96 = i192 + 3499 | 0;
  i97 = i192 + 3560 | 0;
  i98 = i192 + 4512 | 0;
  i99 = i192 + 4624 | 0;
  i100 = i192 + 4676 | 0;
  i101 = i192 + 4625 | 0;
  i102 = i192 + 4680 | 0;
  i103 = i192 + 4626 | 0;
  i104 = i192 + 4684 | 0;
  i105 = i192 + 4627 | 0;
  i106 = i192 + 4688 | 0;
  i107 = 0;
  while (1) {
   HEAPF32[i170 >> 2] = Math_fround(0.0);
   HEAPF32[i108 >> 2] = Math_fround(0.0);
   HEAPF32[i109 >> 2] = Math_fround(0.0);
   HEAPF32[i171 >> 2] = Math_fround(0.0);
   HEAPF32[i110 >> 2] = Math_fround(0.0);
   HEAPF32[i111 >> 2] = Math_fround(0.0);
   i16 = i183;
   i17 = i16 + 80 | 0;
   do {
    HEAP32[i16 >> 2] = 0;
    i16 = i16 + 4 | 0;
   } while ((i16 | 0) < (i17 | 0));
   i16 = i180;
   i17 = i16 + 20 | 0;
   do {
    HEAP8[i16 >> 0] = 0;
    i16 = i16 + 1 | 0;
   } while ((i16 | 0) < (i17 | 0));
   if (!i166) {
    i1 = 0;
    do {
     i20 = i1 << 2;
     f51 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) >> 2]);
     i19 = f51 <= Math_fround(-0.0);
     f50 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f51 >= Math_fround(0.0);
     f50 = i19 ? f50 : Math_fround(-1.0);
     f51 = Math_fround(f50 * f44);
     f40 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 212 >> 2]);
     f51 = Math_fround(f40 * f51);
     f50 = Math_fround(f149 * f50);
     f39 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 216 >> 2]);
     HEAPF32[i183 + (i20 << 2) >> 2] = Math_fround(f51 - Math_fround(f39 * f50));
     HEAP8[i180 + i20 >> 0] = Math_fround(Math_fround(f148 * f40) + Math_fround(f149 * f39)) != Math_fround(0.0) & 1;
     f39 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 4 >> 2]);
     i19 = f39 <= Math_fround(-0.0);
     f40 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f39 >= Math_fround(0.0);
     f40 = i19 ? f40 : Math_fround(-1.0);
     f39 = Math_fround(f40 * f44);
     f50 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 260 >> 2]);
     f39 = Math_fround(f50 * f39);
     f40 = Math_fround(f149 * f40);
     f51 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 264 >> 2]);
     i19 = i20 | 1;
     HEAPF32[i183 + (i19 << 2) >> 2] = Math_fround(f39 - Math_fround(f51 * f40));
     HEAP8[i180 + i19 >> 0] = Math_fround(Math_fround(f148 * f50) + Math_fround(f149 * f51)) != Math_fround(0.0) & 1;
     f51 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 8 >> 2]);
     i19 = f51 <= Math_fround(-0.0);
     f50 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f51 >= Math_fround(0.0);
     f50 = i19 ? f50 : Math_fround(-1.0);
     f51 = Math_fround(f50 * f44);
     f40 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 308 >> 2]);
     f51 = Math_fround(f40 * f51);
     f50 = Math_fround(f149 * f50);
     f39 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 312 >> 2]);
     i19 = i20 | 2;
     HEAPF32[i183 + (i19 << 2) >> 2] = Math_fround(f51 - Math_fround(f39 * f50));
     HEAP8[i180 + i19 >> 0] = Math_fround(Math_fround(f148 * f40) + Math_fround(f149 * f39)) != Math_fround(0.0) & 1;
     f39 = Math_fround(HEAPF32[i187 + (i1 * 224 | 0) + 12 >> 2]);
     i19 = f39 <= Math_fround(-0.0);
     f40 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f39 >= Math_fround(0.0);
     f40 = i19 ? f40 : Math_fround(-1.0);
     f39 = Math_fround(f40 * f44);
     f50 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 356 >> 2]);
     f39 = Math_fround(f50 * f39);
     f40 = Math_fround(f149 * f40);
     f51 = Math_fround(HEAPF32[i186 + (i1 * 944 | 0) + 360 >> 2]);
     i20 = i20 | 3;
     HEAPF32[i183 + (i20 << 2) >> 2] = Math_fround(f39 - Math_fround(f51 * f40));
     HEAP8[i180 + i20 >> 0] = Math_fround(Math_fround(f148 * f50) + Math_fround(f149 * f51)) != Math_fround(0.0) & 1;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i189 | 0));
   }
   _memset(i192 | 0, 0, 1128) | 0;
   HEAP8[i63 >> 0] = 1;
   HEAP32[i64 >> 2] = -1;
   HEAP8[i65 >> 0] = 1;
   HEAP32[i66 >> 2] = -1;
   HEAP8[i67 >> 0] = 1;
   HEAP32[i68 >> 2] = -1;
   HEAP8[i69 >> 0] = 1;
   HEAP32[i70 >> 2] = -1;
   _memset(i71 | 0, 0, 1128) | 0;
   HEAP8[i72 >> 0] = 1;
   HEAP32[i73 >> 2] = -1;
   HEAP8[i74 >> 0] = 1;
   HEAP32[i75 >> 2] = -1;
   HEAP8[i76 >> 0] = 1;
   HEAP32[i77 >> 2] = -1;
   HEAP8[i78 >> 0] = 1;
   HEAP32[i79 >> 2] = -1;
   _memset(i80 | 0, 0, 1128) | 0;
   HEAP8[i81 >> 0] = 1;
   HEAP32[i82 >> 2] = -1;
   HEAP8[i83 >> 0] = 1;
   HEAP32[i84 >> 2] = -1;
   HEAP8[i85 >> 0] = 1;
   HEAP32[i86 >> 2] = -1;
   HEAP8[i87 >> 0] = 1;
   HEAP32[i88 >> 2] = -1;
   _memset(i89 | 0, 0, 1128) | 0;
   HEAP8[i90 >> 0] = 1;
   HEAP32[i91 >> 2] = -1;
   HEAP8[i92 >> 0] = 1;
   HEAP32[i93 >> 2] = -1;
   HEAP8[i94 >> 0] = 1;
   HEAP32[i95 >> 2] = -1;
   HEAP8[i96 >> 0] = 1;
   HEAP32[i97 >> 2] = -1;
   _memset(i98 | 0, 0, 1128) | 0;
   HEAP8[i99 >> 0] = 1;
   HEAP32[i100 >> 2] = -1;
   HEAP8[i101 >> 0] = 1;
   HEAP32[i102 >> 2] = -1;
   HEAP8[i103 >> 0] = 1;
   HEAP32[i104 >> 2] = -1;
   HEAP8[i105 >> 0] = 1;
   HEAP32[i106 >> 2] = -1;
   do if (!i166) {
    i3 = HEAP32[i169 >> 2] | 0;
    i4 = HEAP32[i153 >> 2] | 0;
    i5 = HEAP32[i154 >> 2] | 0;
    i6 = HEAP32[i155 >> 2] | 0;
    i7 = HEAP32[i156 >> 2] | 0;
    i8 = HEAP32[i157 >> 2] | 0;
    i9 = HEAP32[i158 >> 2] | 0;
    i10 = HEAP32[i185 >> 2] | 0;
    i11 = HEAP32[i160 >> 2] | 0;
    i12 = HEAP32[i151 >> 2] | 0;
    i13 = HEAP32[i184 >> 2] | 0;
    i14 = HEAP32[i152 >> 2] | 0;
    i15 = HEAP32[i150 >> 2] | 0;
    i16 = (i62 | 0) == (i107 | 0);
    i17 = (i107 | 0) == 0;
    f40 = Math_fround(HEAPF32[i170 >> 2]);
    f39 = Math_fround(HEAPF32[i108 >> 2]);
    f38 = Math_fround(HEAPF32[i109 >> 2]);
    f37 = Math_fround(HEAPF32[i171 >> 2]);
    f36 = Math_fround(HEAPF32[i110 >> 2]);
    f35 = Math_fround(HEAPF32[i111 >> 2]);
    i20 = 0;
    do {
     HEAP8[i177 >> 0] = i21;
     i18 = i20 << 2;
     HEAP32[i22 >> 2] = i179 + i18;
     HEAP32[i23 >> 2] = i180 + i18;
     HEAP32[i24 >> 2] = i181 + (i18 << 2);
     HEAP32[i25 >> 2] = i167 + i18;
     HEAP32[i26 >> 2] = i3;
     HEAP32[i27 >> 2] = i4;
     HEAP32[i28 >> 2] = i5;
     HEAP32[i29 >> 2] = i6;
     HEAP32[i30 >> 2] = i7;
     HEAP32[i31 >> 2] = i8;
     HEAP32[i32 >> 2] = i9;
     HEAP32[i33 >> 2] = i10;
     HEAP32[i52 >> 2] = i11;
     HEAP32[i53 >> 2] = i12;
     HEAP32[i54 >> 2] = i13;
     HEAP32[i55 >> 2] = i14;
     HEAP32[i56 >> 2] = i15;
     HEAP32[i57 >> 2] = i186 + (i20 * 944 | 0);
     i1 = i187 + (i20 * 224 | 0) | 0;
     HEAP32[i58 >> 2] = i1;
     HEAP32[i59 >> 2] = i182 + (i20 * 20 | 0);
     HEAP32[i60 >> 2] = i165;
     i19 = HEAP32[i191 + (i20 << 2) >> 2] | 0;
     HEAP32[i61 >> 2] = i19;
     i2 = i192 + (i20 * 1128 | 0) | 0;
     __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(i18, i172, i177, i2);
     i200 = HEAP32[i58 >> 2] | 0;
     i201 = i200 + 48 | 0;
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 508 >> 2]);
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 512 >> 2]);
     i201 = i200 + 52 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 516 >> 2]);
     i201 = i200 + 56 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 520 >> 2]);
     i201 = i200 + 60 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     i201 = i200 + 64 | 0;
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 524 >> 2]);
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 528 >> 2]);
     i201 = i200 + 68 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 532 >> 2]);
     i201 = i200 + 72 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 536 >> 2]);
     i201 = i200 + 76 | 0;
     i202 = f51 != Math_fround(HEAPF32[i201 >> 2]);
     HEAPF32[i201 >> 2] = i202 ? f51 : Math_fround(0.0);
     i201 = i192 + (i20 * 1128 | 0) + 292 | 0;
     i200 = i200 + 80 | 0;
     HEAP32[i200 >> 2] = HEAP32[i201 >> 2];
     HEAP32[i200 + 4 >> 2] = HEAP32[i201 + 4 >> 2];
     HEAP32[i200 + 8 >> 2] = HEAP32[i201 + 8 >> 2];
     HEAP32[i200 + 12 >> 2] = HEAP32[i201 + 12 >> 2];
     if (i16) __ZN5physx19updateCachedHitDataEPKjPKNS_6PxVec4EPKfS6_PNS_23PxVehicleWheels4DynDataE(i192 + (i20 * 1128 | 0) + 904 | 0, i192 + (i20 * 1128 | 0) + 920 | 0, i192 + (i20 * 1128 | 0) + 984 | 0, i192 + (i20 * 1128 | 0) + 1e3 | 0, i1);
     f40 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 484 >> 2]) + f40);
     f39 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 488 >> 2]) + f39);
     f38 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 492 >> 2]) + f38);
     f37 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 496 >> 2]) + f37);
     f36 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 500 >> 2]) + f36);
     f35 = Math_fround(Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 504 >> 2]) + f35);
     if (i17) __ZN5physx25PxVehicleConstraintShader21VehicleConstraintDataaSERKS1_((HEAP32[i187 + (i20 * 224 | 0) + 208 >> 2] | 0) + 4 | 0, i192 + (i20 * 1128 | 0) + 540 | 0) | 0;
     __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i2, HEAP32[i24 >> 2] | 0, i196 + (i18 * 148 | 0) | 0, i19);
     i1 = HEAP32[i195 >> 2] | 0;
     if (i19 | 0) {
      i2 = 0;
      do {
       i202 = i2 + i18 | 0;
       HEAP32[i1 + (i202 * 56 | 0) + 28 >> 2] = HEAP32[i192 + (i20 * 1128 | 0) + 1016 + (i2 << 2) >> 2];
       f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) >> 2]);
       i201 = i1 + (i202 * 56 | 0) + 32 | 0;
       HEAPF32[i201 >> 2] = Math_fround(f51 + Math_fround(HEAPF32[i201 >> 2]));
       f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) + 4 >> 2]);
       i201 = i1 + (i202 * 56 | 0) + 36 | 0;
       HEAPF32[i201 >> 2] = Math_fround(f51 + Math_fround(HEAPF32[i201 >> 2]));
       f51 = Math_fround(HEAPF32[i192 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) + 8 >> 2]);
       i201 = i1 + (i202 * 56 | 0) + 40 | 0;
       HEAPF32[i201 >> 2] = Math_fround(f51 + Math_fround(HEAPF32[i201 >> 2]));
       HEAP32[i1 + (i202 * 56 | 0) + 44 >> 2] = HEAP32[i192 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) >> 2];
       HEAP32[i1 + (i202 * 56 | 0) + 48 >> 2] = HEAP32[i192 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i1 + (i202 * 56 | 0) + 52 >> 2] = HEAP32[i192 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) + 8 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i19 | 0));
     }
     i20 = i20 + 1 | 0;
    } while ((i20 | 0) != (i189 | 0));
    HEAPF32[i170 >> 2] = f40;
    HEAPF32[i108 >> 2] = f39;
    HEAPF32[i109 >> 2] = f38;
    HEAPF32[i171 >> 2] = f37;
    HEAPF32[i110 >> 2] = f36;
    HEAPF32[i111 >> 2] = f35;
    if (i166) break; else i1 = 0;
    do {
     i202 = i1 << 2;
     HEAP32[i177 + (i202 << 2) >> 2] = HEAP32[i192 + (i1 * 1128 | 0) + 468 >> 2];
     HEAP32[i177 + ((i202 | 1) << 2) >> 2] = HEAP32[i192 + (i1 * 1128 | 0) + 472 >> 2];
     HEAP32[i177 + ((i202 | 2) << 2) >> 2] = HEAP32[i192 + (i1 * 1128 | 0) + 476 >> 2];
     HEAP32[i177 + ((i202 | 3) << 2) >> 2] = HEAP32[i192 + (i1 * 1128 | 0) + 480 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i189 | 0));
   } while (0);
   f39 = Math_fround(HEAPF32[i164 >> 2]);
   f40 = Math_fround(f34 * Math_fround(HEAPF32[i112 >> 2]));
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i113 >> 2]));
   i2 = HEAP32[i162 >> 2] | 0;
   L172 : do switch (i2 | 0) {
   case 0:
    {
     f35 = Math_fround(0.0);
     break;
    }
   case 1:
    {
     i161 = 112;
     break;
    }
   default:
    {
     f35 = Math_fround(HEAPF32[i174 >> 2]);
     if (f35 > f39) {
      i161 = 112;
      break L172;
     }
     i1 = 1;
     f38 = Math_fround(HEAPF32[i114 >> 2]);
     while (1) {
      i202 = i1 << 1;
      f37 = f35;
      f35 = Math_fround(HEAPF32[i174 + (i202 << 2) >> 2]);
      f36 = f38;
      f38 = Math_fround(HEAPF32[i174 + ((i202 | 1) << 2) >> 2]);
      i1 = i1 + 1 | 0;
      if (f37 <= f39 & f35 > f39) {
       i161 = 116;
       break;
      }
      if (i1 >>> 0 >= i2 >>> 0) {
       i161 = 117;
       break;
      }
     }
     if ((i161 | 0) == 116) {
      i161 = 0;
      f35 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f39 - f37) * Math_fround(f38 - f36)) / Math_fround(f35 - f37)));
      break L172;
     } else if ((i161 | 0) == 117) {
      i161 = 0;
      f35 = Math_fround(HEAPF32[i174 + (((i2 << 1) + -2 | 1) << 2) >> 2]);
      break L172;
     }
    }
   } while (0);
   if ((i161 | 0) == 112) {
    i161 = 0;
    f35 = Math_fround(HEAPF32[i114 >> 2]);
   }
   f38 = Math_fround(f40 * f35);
   i1 = HEAP32[gb + 1458536 >> 2] | 0;
   if (i1 | 0) HEAPF32[i1 + 4 >> 2] = f38;
   f50 = Math_fround(HEAPF32[i115 >> 2]);
   f40 = Math_fround(HEAPF32[i117 >> 2]);
   f51 = Math_fround(HEAPF32[i116 >> 2]);
   f51 = i141 ? f40 : f51;
   f51 = Math_fround(f51 + Math_fround(f34 * Math_fround(f50 - f51)));
   HEAPF32[i175 >> 2] = f137;
   HEAP32[i118 >> 2] = i146;
   HEAP32[i119 >> 2] = i147;
   HEAPF32[i120 >> 2] = f142;
   HEAPF32[i121 >> 2] = f145;
   HEAP32[i122 >> 2] = i143;
   HEAP32[i123 >> 2] = i144;
   HEAPF32[i124 >> 2] = f38;
   HEAPF32[i125 >> 2] = f51;
   HEAP32[i126 >> 2] = i140;
   HEAP32[i127 >> 2] = i168;
   HEAP32[i128 >> 2] = i183;
   HEAP32[i129 >> 2] = i180;
   HEAP32[i130 >> 2] = i177;
   HEAP32[i131 >> 2] = i189;
   HEAP32[i132 >> 2] = i188;
   HEAP32[i133 >> 2] = i186;
   HEAP32[i134 >> 2] = i174;
   HEAP32[i176 >> 2] = i187;
   HEAP32[i135 >> 2] = i163;
   __ZN5physx50solveDriveNWInternalDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE(i175, i176);
   if (!i166) {
    i3 = 0;
    do {
     i2 = i3 << 2;
     i4 = 0;
     do {
      f35 = Math_fround(HEAPF32[i187 + (i3 * 224 | 0) + (i4 << 2) >> 2]);
      f51 = Math_fround(HEAPF32[i192 + (i3 * 1128 | 0) + 292 + (i4 << 2) >> 2]);
      do if (f51 > Math_fround(-Math_fround(HEAPF32[i186 + (i3 * 944 | 0) + (i4 * 48 | 0) + 12 >> 2]))) {
       i1 = i4 + i2 | 0;
       if (HEAP8[i180 + i1 >> 0] | 0) break;
       if (!(Math_fround(f38 * Math_fround(f47 * Math_fround(HEAPF32[i173 + (i1 << 2) >> 2]))) == Math_fround(0.0))) break;
       f36 = Math_fround(HEAPF32[i192 + (i3 * 1128 | 0) + 452 + (i4 << 2) >> 2]);
       f37 = Math_fround(Math_abs(Math_fround(f36)));
       if (!(f37 < Math_fround(HEAPF32[gb + 1458420 >> 2]))) break;
       f50 = Math_fround(HEAPF32[i186 + (i3 * 944 | 0) + 192 + (i4 * 48 | 0) + 36 >> 2]);
       f51 = Math_fround(f37 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
       f35 = Math_fround(Math_fround(f35 * f51) + Math_fround(Math_fround(f36 * f50) * Math_fround(Math_fround(1.0) - f51)));
      } while (0);
      i202 = i187 + (i3 * 224 | 0) + 32 + (i4 << 2) | 0;
      f51 = Math_fround(Math_fround(HEAPF32[i202 >> 2]) + Math_fround(f137 * f35));
      f40 = Math_fround(f51 + Math_fround(-31.4159279));
      f50 = Math_fround(f51 + Math_fround(31.4159279));
      i201 = Math_fround(Math_fround(-31.4159279) - f51) >= Math_fround(0.0);
      i200 = f40 >= Math_fround(0.0);
      HEAPF32[i202 >> 2] = i200 ? f40 : i201 ? f50 : f51;
      HEAPF32[i187 + (i3 * 224 | 0) + 16 + (i4 << 2) >> 2] = f35;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != 4);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i189 | 0));
   }
   __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE(f159, i178, i170, i171, f137, i185, i184, i169);
   i107 = i107 + 1 | 0;
   if ((i107 | 0) == (i136 | 0)) break L145;
  }
 } while (0);
 i33 = i195 + 8 | 0;
 if (!(HEAP8[gb + 1552705 >> 0] | 0)) {
  HEAP32[i33 >> 2] = HEAP32[i185 >> 2];
  HEAP32[i195 + 12 >> 2] = HEAP32[i160 >> 2];
  HEAP32[i195 + 16 >> 2] = HEAP32[i151 >> 2];
  HEAP32[i195 + 20 >> 2] = HEAP32[i184 >> 2];
  HEAP32[i195 + 24 >> 2] = HEAP32[i152 >> 2];
  HEAP32[i195 + 28 >> 2] = HEAP32[i150 >> 2];
 } else {
  f159 = Math_fround(Math_fround(HEAPF32[i139 >> 2]) - f45);
  f149 = Math_fround(Math_fround(HEAPF32[i160 >> 2]) - f46);
  f149 = Math_fround(f49 * f149);
  f148 = Math_fround(f49 * Math_fround(Math_fround(HEAPF32[i151 >> 2]) - f48));
  HEAPF32[i33 >> 2] = Math_fround(f49 * f159);
  HEAPF32[i195 + 12 >> 2] = f149;
  HEAPF32[i195 + 16 >> 2] = f148;
  f148 = Math_fround(Math_fround(HEAPF32[i138 >> 2]) - f41);
  f149 = Math_fround(Math_fround(HEAPF32[i152 >> 2]) - f42);
  f149 = Math_fround(f49 * f149);
  f159 = Math_fround(f49 * Math_fround(Math_fround(HEAPF32[i150 >> 2]) - f43));
  HEAPF32[i195 + 20 >> 2] = Math_fround(f49 * f148);
  HEAPF32[i195 + 24 >> 2] = f149;
  HEAPF32[i195 + 28 >> 2] = f159;
 }
 HEAPF32[i183 >> 2] = Math_fround(0.0);
 i160 = i183 + 4 | 0;
 HEAPF32[i160 >> 2] = Math_fround(0.0);
 i161 = i183 + 8 | 0;
 HEAPF32[i161 >> 2] = Math_fround(0.0);
 i162 = i183 + 12 | 0;
 HEAPF32[i162 >> 2] = Math_fround(1.0);
 i200 = i183 + 16 | 0;
 i164 = i183 + 20 | 0;
 i165 = i183 + 24 | 0;
 i166 = i183 + 28 | 0;
 i167 = i183 + 32 | 0;
 i168 = i183 + 36 | 0;
 i169 = i183 + 40 | 0;
 HEAP32[i200 >> 2] = 0;
 HEAP32[i200 + 4 >> 2] = 0;
 HEAP32[i200 + 8 >> 2] = 0;
 HEAP32[i200 + 12 >> 2] = 0;
 HEAP32[i200 + 16 >> 2] = 0;
 HEAP32[i200 + 20 >> 2] = 0;
 HEAPF32[i169 >> 2] = Math_fround(1.0);
 i200 = i183 + 44 | 0;
 i171 = i183 + 48 | 0;
 i172 = i183 + 52 | 0;
 i173 = i183 + 56 | 0;
 i174 = i183 + 60 | 0;
 i175 = i183 + 64 | 0;
 i176 = i183 + 68 | 0;
 HEAP32[i200 >> 2] = 0;
 HEAP32[i200 + 4 >> 2] = 0;
 HEAP32[i200 + 8 >> 2] = 0;
 HEAP32[i200 + 12 >> 2] = 0;
 HEAP32[i200 + 16 >> 2] = 0;
 HEAP32[i200 + 20 >> 2] = 0;
 HEAPF32[i176 >> 2] = Math_fround(1.0);
 i200 = i183 + 72 | 0;
 i178 = i183 + 76 | 0;
 i179 = i183 + 80 | 0;
 i180 = i183 + 84 | 0;
 i181 = i183 + 88 | 0;
 i182 = i183 + 92 | 0;
 i184 = i183 + 96 | 0;
 HEAP32[i200 >> 2] = 0;
 HEAP32[i200 + 4 >> 2] = 0;
 HEAP32[i200 + 8 >> 2] = 0;
 HEAP32[i200 + 12 >> 2] = 0;
 HEAP32[i200 + 16 >> 2] = 0;
 HEAP32[i200 + 20 >> 2] = 0;
 HEAPF32[i184 >> 2] = Math_fround(1.0);
 HEAPF32[i183 + 100 >> 2] = Math_fround(0.0);
 i200 = i183 + 104 | 0;
 HEAPF32[i200 >> 2] = Math_fround(0.0);
 i201 = i183 + 108 | 0;
 HEAPF32[i201 >> 2] = Math_fround(0.0);
 __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i186, i187, i196, HEAP32[i191 >> 2] | 0, i190, i183);
 HEAP32[i196 + 120 >> 2] = HEAP32[i183 >> 2];
 HEAP32[i196 + 124 >> 2] = HEAP32[i160 >> 2];
 HEAP32[i196 + 128 >> 2] = HEAP32[i161 >> 2];
 HEAP32[i196 + 132 >> 2] = HEAP32[i162 >> 2];
 i163 = i183 + 16 | 0;
 HEAP32[i196 + 136 >> 2] = HEAP32[i163 >> 2];
 HEAP32[i196 + 140 >> 2] = HEAP32[i164 >> 2];
 HEAP32[i196 + 144 >> 2] = HEAP32[i165 >> 2];
 HEAP32[i196 + 268 >> 2] = HEAP32[i166 >> 2];
 HEAP32[i196 + 272 >> 2] = HEAP32[i167 >> 2];
 HEAP32[i196 + 276 >> 2] = HEAP32[i168 >> 2];
 HEAP32[i196 + 280 >> 2] = HEAP32[i169 >> 2];
 i170 = i183 + 44 | 0;
 HEAP32[i196 + 284 >> 2] = HEAP32[i170 >> 2];
 HEAP32[i196 + 288 >> 2] = HEAP32[i171 >> 2];
 HEAP32[i196 + 292 >> 2] = HEAP32[i172 >> 2];
 HEAP32[i196 + 416 >> 2] = HEAP32[i173 >> 2];
 HEAP32[i196 + 420 >> 2] = HEAP32[i174 >> 2];
 HEAP32[i196 + 424 >> 2] = HEAP32[i175 >> 2];
 HEAP32[i196 + 428 >> 2] = HEAP32[i176 >> 2];
 i177 = i183 + 72 | 0;
 HEAP32[i196 + 432 >> 2] = HEAP32[i177 >> 2];
 HEAP32[i196 + 436 >> 2] = HEAP32[i178 >> 2];
 HEAP32[i196 + 440 >> 2] = HEAP32[i179 >> 2];
 HEAP32[i196 + 564 >> 2] = HEAP32[i180 >> 2];
 HEAP32[i196 + 568 >> 2] = HEAP32[i181 >> 2];
 HEAP32[i196 + 572 >> 2] = HEAP32[i182 >> 2];
 HEAP32[i196 + 576 >> 2] = HEAP32[i184 >> 2];
 i185 = i183 + 100 | 0;
 HEAP32[i196 + 580 >> 2] = HEAP32[i185 >> 2];
 HEAP32[i196 + 584 >> 2] = HEAP32[i200 >> 2];
 HEAP32[i196 + 588 >> 2] = HEAP32[i201 >> 2];
 i202 = HEAP32[i195 >> 2] | 0;
 HEAP32[i202 >> 2] = HEAP32[i183 >> 2];
 HEAP32[i202 + 4 >> 2] = HEAP32[i160 >> 2];
 HEAP32[i202 + 8 >> 2] = HEAP32[i161 >> 2];
 HEAP32[i202 + 12 >> 2] = HEAP32[i162 >> 2];
 HEAP32[i202 + 16 >> 2] = HEAP32[i163 >> 2];
 HEAP32[i202 + 20 >> 2] = HEAP32[i164 >> 2];
 HEAP32[i202 + 24 >> 2] = HEAP32[i165 >> 2];
 HEAP32[i202 + 56 >> 2] = HEAP32[i166 >> 2];
 HEAP32[i202 + 60 >> 2] = HEAP32[i167 >> 2];
 HEAP32[i202 + 64 >> 2] = HEAP32[i168 >> 2];
 HEAP32[i202 + 68 >> 2] = HEAP32[i169 >> 2];
 HEAP32[i202 + 72 >> 2] = HEAP32[i170 >> 2];
 HEAP32[i202 + 76 >> 2] = HEAP32[i171 >> 2];
 HEAP32[i202 + 80 >> 2] = HEAP32[i172 >> 2];
 HEAP32[i202 + 112 >> 2] = HEAP32[i173 >> 2];
 HEAP32[i202 + 116 >> 2] = HEAP32[i174 >> 2];
 HEAP32[i202 + 120 >> 2] = HEAP32[i175 >> 2];
 HEAP32[i202 + 124 >> 2] = HEAP32[i176 >> 2];
 HEAP32[i202 + 128 >> 2] = HEAP32[i177 >> 2];
 HEAP32[i202 + 132 >> 2] = HEAP32[i178 >> 2];
 HEAP32[i202 + 136 >> 2] = HEAP32[i179 >> 2];
 HEAP32[i202 + 168 >> 2] = HEAP32[i180 >> 2];
 HEAP32[i202 + 172 >> 2] = HEAP32[i181 >> 2];
 HEAP32[i202 + 176 >> 2] = HEAP32[i182 >> 2];
 HEAP32[i202 + 180 >> 2] = HEAP32[i184 >> 2];
 HEAP32[i202 + 184 >> 2] = HEAP32[i185 >> 2];
 HEAP32[i202 + 188 >> 2] = HEAP32[i200 >> 2];
 HEAP32[i202 + 192 >> 2] = HEAP32[i201 >> 2];
 if (i189 >>> 0 > 1) {
  i1 = i192 + 4 | 0;
  i2 = i192 + 8 | 0;
  i3 = i192 + 12 | 0;
  i4 = i192 + 16 | 0;
  i5 = i192 + 20 | 0;
  i6 = i192 + 24 | 0;
  i7 = i192 + 28 | 0;
  i8 = i192 + 32 | 0;
  i9 = i192 + 36 | 0;
  i10 = i192 + 40 | 0;
  i11 = i192 + 44 | 0;
  i12 = i192 + 48 | 0;
  i13 = i192 + 52 | 0;
  i14 = i192 + 56 | 0;
  i15 = i192 + 60 | 0;
  i16 = i192 + 64 | 0;
  i17 = i192 + 68 | 0;
  i18 = i192 + 72 | 0;
  i19 = i192 + 76 | 0;
  i20 = i192 + 80 | 0;
  i21 = i192 + 84 | 0;
  i22 = i192 + 88 | 0;
  i23 = i192 + 92 | 0;
  i24 = i192 + 96 | 0;
  i25 = i192 + 100 | 0;
  i26 = i192 + 104 | 0;
  i27 = i192 + 108 | 0;
  i28 = i192 + 16 | 0;
  i29 = i192 + 44 | 0;
  i30 = i192 + 72 | 0;
  i31 = i192 + 100 | 0;
  i32 = 1;
  do {
   HEAPF32[i192 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAPF32[i17 >> 2] = Math_fround(1.0);
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 20 >> 2] = 0;
   HEAPF32[i24 >> 2] = Math_fround(1.0);
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   i184 = i32 << 2;
   __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i186 + (i32 * 944 | 0) | 0, i187 + (i32 * 224 | 0) | 0, i196 + (i184 * 148 | 0) | 0, HEAP32[i191 + (i32 << 2) >> 2] | 0, i190, i192);
   HEAP32[i196 + (i184 * 148 | 0) + 120 >> 2] = HEAP32[i192 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 124 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 128 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 132 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 136 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 140 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i196 + (i184 * 148 | 0) + 144 >> 2] = HEAP32[i6 >> 2];
   i185 = i184 | 1;
   HEAP32[i196 + (i185 * 148 | 0) + 120 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 124 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 128 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 132 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 136 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 140 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i196 + (i185 * 148 | 0) + 144 >> 2] = HEAP32[i13 >> 2];
   i200 = i184 | 2;
   HEAP32[i196 + (i200 * 148 | 0) + 120 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 124 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 128 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 132 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 136 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 140 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i196 + (i200 * 148 | 0) + 144 >> 2] = HEAP32[i20 >> 2];
   i202 = i184 | 3;
   HEAP32[i196 + (i202 * 148 | 0) + 120 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 124 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 128 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 132 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 136 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 140 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i196 + (i202 * 148 | 0) + 144 >> 2] = HEAP32[i27 >> 2];
   i201 = HEAP32[i195 >> 2] | 0;
   HEAP32[i201 + (i184 * 56 | 0) >> 2] = HEAP32[i192 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 20 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i201 + (i184 * 56 | 0) + 24 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) >> 2] = HEAP32[i7 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 16 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 20 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i201 + (i185 * 56 | 0) + 24 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 12 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 16 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i201 + (i200 * 56 | 0) + 24 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 4 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 8 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 12 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 20 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i201 + (i202 * 56 | 0) + 24 >> 2] = HEAP32[i27 >> 2];
   i32 = i32 + 1 | 0;
  } while ((i32 | 0) != (i189 | 0));
 }
 do if (i193 | 0) {
  i1 = HEAP32[i193 >> 2] | 0;
  if (!i1) break;
  _memcpy(i1 | 0, i196 | 0, i188 * 148 | 0) | 0;
 } while (0);
 if (!i198) {
  HEAP32[i194 >> 2] = i197;
  __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i195, 1, i194);
 } else {
  _memcpy(HEAP32[i198 >> 2] | 0, HEAP32[i195 >> 2] | 0, i188 * 56 | 0) | 0;
  HEAP32[i198 + 8 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i198 + 12 >> 2] = HEAP32[i195 + 12 >> 2];
  HEAP32[i198 + 16 >> 2] = HEAP32[i195 + 16 >> 2];
  HEAP32[i198 + 20 >> 2] = HEAP32[i195 + 20 >> 2];
  HEAP32[i198 + 24 >> 2] = HEAP32[i195 + 24 >> 2];
  HEAP32[i198 + 28 >> 2] = HEAP32[i195 + 28 >> 2];
  i202 = HEAP16[i195 + 32 >> 1] | 0;
  HEAP8[i198 + 32 >> 0] = i202;
  HEAP8[i198 + 33 >> 0] = (i202 & 65535) >>> 8;
 }
 STACKTOP = i199;
 return;
}

function __ZN5physx2Gu16pcmContactBoxBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i6, i7, i8, i9, i5, i4, i130) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i130 = i130 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, f60 = f0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, i84 = 0, i85 = 0, i86 = 0, f87 = f0, f88 = f0, f89 = f0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f105 = f0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0;
 i132 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i96 = i132 + 1072 | 0;
 i101 = i132 + 912 | 0;
 i102 = i132 + 752 | 0;
 i64 = i132 + 736 | 0;
 i65 = i132 + 720 | 0;
 i66 = i132 + 704 | 0;
 i71 = i132 + 688 | 0;
 i72 = i132 + 624 | 0;
 i73 = i132 + 560 | 0;
 i57 = i132 + 544 | 0;
 i54 = i132 + 528 | 0;
 i58 = i132 + 512 | 0;
 i55 = i132 + 496 | 0;
 i59 = i132 + 480 | 0;
 i56 = i132 + 464 | 0;
 i62 = i132 + 448 | 0;
 i63 = i132 + 400 | 0;
 i61 = i132 + 368 | 0;
 i70 = i132 + 320 | 0;
 i100 = i132 + 432 | 0;
 i94 = i132 + 416 | 0;
 i95 = i132 + 384 | 0;
 i131 = i132 + 336 | 0;
 i118 = i132 + 240 | 0;
 i85 = i132 + 304 | 0;
 i97 = i132 + 176 | 0;
 i124 = i132 + 1100 | 0;
 i98 = i132 + 160 | 0;
 i99 = i132 + 144 | 0;
 i104 = i132 + 128 | 0;
 i119 = i132 + 112 | 0;
 i123 = i132 + 96 | 0;
 i117 = i132 + 80 | 0;
 i103 = i132 + 1088 | 0;
 i125 = i132 + 64 | 0;
 i121 = i132 + 48 | 0;
 i122 = i132 + 32 | 0;
 i120 = i132 + 16 | 0;
 i28 = i132;
 i129 = HEAP32[i4 >> 2] | 0;
 HEAP32[i100 >> 2] = HEAP32[i5 >> 2];
 i93 = HEAP32[i6 + 8 >> 2] | 0;
 i91 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i94 >> 2] = HEAP32[i6 + 4 >> 2];
 i92 = i94 + 4 | 0;
 HEAP32[i92 >> 2] = i93;
 i93 = i94 + 8 | 0;
 HEAP32[i93 >> 2] = i91;
 HEAPF32[i94 + 12 >> 2] = Math_fround(0.0);
 i91 = HEAP32[i7 + 8 >> 2] | 0;
 i112 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i95 >> 2] = HEAP32[i7 + 4 >> 2];
 i90 = i95 + 4 | 0;
 HEAP32[i90 >> 2] = i91;
 i91 = i95 + 8 | 0;
 HEAP32[i91 >> 2] = i112;
 HEAPF32[i95 + 12 >> 2] = Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 i112 = i8 + 16 | 0;
 f87 = Math_fround(HEAPF32[i112 >> 2]);
 f88 = Math_fround(HEAPF32[i112 + 4 >> 2]);
 f89 = Math_fround(HEAPF32[i112 + 8 >> 2]);
 i112 = HEAP32[i9 >> 2] | 0;
 i111 = HEAP32[i9 + 4 >> 2] | 0;
 i110 = HEAP32[i9 + 8 >> 2] | 0;
 i109 = HEAP32[i9 + 12 >> 2] | 0;
 i106 = i9 + 16 | 0;
 i108 = HEAP32[i106 >> 2] | 0;
 i107 = HEAP32[i106 + 4 >> 2] | 0;
 i106 = HEAP32[i106 + 8 >> 2] | 0;
 HEAP32[i131 >> 2] = i112;
 i126 = i131 + 4 | 0;
 HEAP32[i126 >> 2] = i111;
 i127 = i131 + 8 | 0;
 HEAP32[i127 >> 2] = i110;
 i128 = i131 + 12 | 0;
 HEAP32[i128 >> 2] = i109;
 i26 = i131 + 16 | 0;
 HEAP32[i26 >> 2] = i108;
 HEAP32[i131 + 20 >> 2] = i107;
 HEAP32[i131 + 24 >> 2] = i106;
 HEAPF32[i131 + 28 >> 2] = Math_fround(0.0);
 f79 = (HEAP32[tempDoublePtr >> 2] = i112, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f105 = (HEAP32[tempDoublePtr >> 2] = i111, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f82 = (HEAP32[tempDoublePtr >> 2] = i110, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i109, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f79 = Math_fround(-f79);
 f105 = Math_fround(-f105);
 f82 = Math_fround(-f82);
 f12 = (HEAP32[tempDoublePtr >> 2] = i108, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i107, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f87 - f12);
 f13 = Math_fround(f88 - f13);
 f14 = Math_fround(f89 - (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f75 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f3 = Math_fround(Math_fround(Math_fround(f12 * f79) + Math_fround(f13 * f105)) + Math_fround(f14 * f82));
 f1 = Math_fround(Math_fround(Math_fround(f3 * f79) + Math_fround(Math_fround(f75 * f12) + Math_fround(f15 * Math_fround(Math_fround(f14 * f105) - Math_fround(f13 * f82))))) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(Math_fround(f3 * f105) + Math_fround(Math_fround(f75 * f13) + Math_fround(f15 * Math_fround(Math_fround(f12 * f82) - Math_fround(f14 * f79))))) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f75 * f14) + Math_fround(f15 * Math_fround(Math_fround(f13 * f79) - Math_fround(f12 * f105)))) + Math_fround(f3 * f82)) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f19 * f15) - Math_fround(Math_fround(Math_fround(f16 * f79) + Math_fround(f17 * f105)) + Math_fround(f18 * f82)));
 f13 = Math_fround(Math_fround(Math_fround(f18 * f105) - Math_fround(f17 * f82)) + Math_fround(Math_fround(f19 * f79) + Math_fround(f16 * f15)));
 f14 = Math_fround(Math_fround(Math_fround(f16 * f82) - Math_fround(f18 * f79)) + Math_fround(Math_fround(f19 * f105) + Math_fround(f17 * f15)));
 f15 = Math_fround(Math_fround(Math_fround(f17 * f79) - Math_fround(f16 * f105)) + Math_fround(Math_fround(f19 * f82) + Math_fround(f18 * f15)));
 i106 = i118 + 48 | 0;
 HEAPF32[i106 >> 2] = f1;
 i107 = i118 + 52 | 0;
 HEAPF32[i107 >> 2] = f2;
 i108 = i118 + 56 | 0;
 HEAPF32[i108 >> 2] = f3;
 HEAPF32[i118 + 60 >> 2] = Math_fround(0.0);
 f82 = Math_fround(f13 + f13);
 f105 = Math_fround(f14 + f14);
 f79 = Math_fround(f15 + f15);
 f75 = Math_fround(f14 * f105);
 f76 = Math_fround(f15 * f79);
 f80 = Math_fround(f14 * f82);
 f68 = Math_fround(f15 * f82);
 f81 = Math_fround(f12 * f82);
 f69 = Math_fround(f15 * f105);
 f105 = Math_fround(f12 * f105);
 f79 = Math_fround(f12 * f79);
 f82 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f82));
 f77 = Math_fround(f80 + f79);
 f78 = Math_fround(f68 - f105);
 f79 = Math_fround(f80 - f79);
 f80 = Math_fround(f82 - f76);
 f83 = Math_fround(f69 + f81);
 f105 = Math_fround(f68 + f105);
 f81 = Math_fround(f69 - f81);
 f82 = Math_fround(f82 - f75);
 HEAPF32[i118 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f75) - f76);
 i109 = i118 + 4 | 0;
 HEAPF32[i109 >> 2] = f77;
 i110 = i118 + 8 | 0;
 HEAPF32[i110 >> 2] = f78;
 HEAPF32[i118 + 12 >> 2] = Math_fround(0.0);
 i111 = i118 + 16 | 0;
 HEAPF32[i111 >> 2] = f79;
 i112 = i118 + 20 | 0;
 HEAPF32[i112 >> 2] = f80;
 i113 = i118 + 24 | 0;
 HEAPF32[i113 >> 2] = f83;
 HEAPF32[i118 + 28 >> 2] = Math_fround(0.0);
 i114 = i118 + 32 | 0;
 HEAPF32[i114 >> 2] = f105;
 i115 = i118 + 36 | 0;
 HEAPF32[i115 >> 2] = f81;
 i116 = i118 + 40 | 0;
 HEAPF32[i116 >> 2] = f82;
 HEAPF32[i118 + 44 >> 2] = Math_fround(0.0);
 f82 = Math_fround(HEAPF32[i94 >> 2]);
 f81 = Math_fround(HEAPF32[i92 >> 2]);
 f105 = Math_fround(HEAPF32[i93 >> 2]);
 f81 = f82 <= f81 ? f82 : f81;
 f105 = Math_fround((f81 <= f105 ? f81 : f105) * Math_fround(.150000006));
 f81 = Math_fround(HEAPF32[i95 >> 2]);
 f82 = Math_fround(HEAPF32[i90 >> 2]);
 f83 = Math_fround(HEAPF32[i91 >> 2]);
 f82 = f81 <= f82 ? f81 : f82;
 f83 = Math_fround((f82 <= f83 ? f82 : f83) * Math_fround(.150000006));
 f105 = f105 > f83 ? f83 : f105;
 i86 = i129 + 32 | 0;
 i10 = HEAP8[i86 >> 0] | 0;
 HEAPF32[i85 >> 2] = Math_fround(f105 * Math_fround(.800000011));
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i129, i118, i85, i100);
 if ((HEAP8[i86 >> 0] | 0) == i10 << 24 >> 24) {
  i11 = i10 & 255;
  f79 = Math_fround(f105 * Math_fround(HEAPF32[gb + 105432 + (i11 << 2) >> 2]));
  i6 = i129 + 16 | 0;
  f83 = Math_fround(HEAPF32[i6 >> 2]);
  i5 = i129 + 20 | 0;
  f82 = Math_fround(HEAPF32[i5 >> 2]);
  i4 = i129 + 24 | 0;
  f83 = Math_fround(f1 - f83);
  f82 = Math_fround(f2 - f82);
  f81 = Math_fround(f3 - Math_fround(HEAPF32[i4 >> 2]));
  f78 = Math_fround(-f83);
  f77 = Math_fround(-f82);
  f80 = Math_fround(-f81);
  f78 = f83 > f78 ? f83 : f78;
  f77 = f82 > f77 ? f82 : f77;
  f77 = f78 >= f77 ? f78 : f77;
  i8 = (f81 > f80 ? f81 : f80) >= Math_fround(0.0);
  f78 = i8 ? f78 : Math_fround(0.0);
  f80 = Math_fround(HEAPF32[gb + 105452 + (i11 << 2) >> 2]);
  f81 = Math_fround(HEAPF32[i129 >> 2]);
  i8 = i129 + 4 | 0;
  f82 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i129 + 8 | 0;
  f83 = Math_fround(HEAPF32[i9 >> 2]);
  i7 = i129 + 12 | 0;
  if ((f77 >= f78 ? f77 : f78) > f79 ? 1 : f80 > Math_fround(Math_fround(Math_fround(Math_fround(f13 * f81) + Math_fround(f14 * f82)) + Math_fround(f15 * f83)) + Math_fround(f12 * Math_fround(HEAPF32[i7 >> 2])))) i10 = i129; else {
   if (!(i10 << 24 >> 24)) {
    i131 = 0;
    STACKTOP = i132;
    return i131 | 0;
   }
   i5 = HEAP32[i129 + 44 >> 2] | 0;
   f1 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f2 = Math_fround(HEAPF32[i5 + 36 >> 2]);
   f3 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   if ((i10 & 255) > 1) {
    i4 = 1;
    do {
     f89 = Math_fround(HEAPF32[i5 + (i4 * 48 | 0) + 32 >> 2]);
     f105 = Math_fround(HEAPF32[i5 + (i4 * 48 | 0) + 36 >> 2]);
     f1 = Math_fround(f1 + f89);
     f2 = Math_fround(f2 + f105);
     f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + (i4 * 48 | 0) + 40 >> 2]));
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i11 | 0));
   }
   f83 = Math_fround(HEAPF32[i131 >> 2]);
   f87 = Math_fround(HEAPF32[i126 >> 2]);
   f80 = Math_fround(HEAPF32[i127 >> 2]);
   f82 = Math_fround(HEAPF32[i128 >> 2]);
   f105 = Math_fround(Math_fround(f82 * f82) + Math_fround(-.5));
   f81 = Math_fround(Math_fround(Math_fround(f1 * f83) + Math_fround(f2 * f87)) + Math_fround(f3 * f80));
   f88 = Math_fround(Math_fround(Math_fround(f83 * f81) + Math_fround(Math_fround(f82 * Math_fround(Math_fround(f3 * f87) - Math_fround(f2 * f80))) + Math_fround(f1 * f105))) * Math_fround(2.0));
   f89 = Math_fround(Math_fround(Math_fround(f87 * f81) + Math_fround(Math_fround(f82 * Math_fround(Math_fround(f1 * f80) - Math_fround(f3 * f83))) + Math_fround(f2 * f105))) * Math_fround(2.0));
   f105 = Math_fround(Math_fround(Math_fround(f80 * f81) + Math_fround(Math_fround(f82 * Math_fround(Math_fround(f2 * f83) - Math_fround(f1 * f87))) + Math_fround(f3 * f105))) * Math_fround(2.0));
   f87 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f105 * f105) + Math_fround(Math_fround(f88 * f88) + Math_fround(f89 * f89))))));
   f89 = Math_fround(f87 * f89);
   f105 = Math_fround(f87 * f105);
   HEAPF32[i28 >> 2] = Math_fround(f87 * f88);
   HEAPF32[i28 + 4 >> 2] = f89;
   HEAPF32[i28 + 8 >> 2] = f105;
   HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i129, i130, i28, i131);
   i131 = 1;
   STACKTOP = i132;
   return i131 | 0;
  }
 } else {
  i10 = i129;
  i8 = i129 + 4 | 0;
  i9 = i129 + 8 | 0;
  i7 = i129 + 12 | 0;
  i6 = i129 + 16 | 0;
  i5 = i129 + 20 | 0;
  i4 = i129 + 24 | 0;
 }
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i8 >> 2] = f14;
 HEAPF32[i9 >> 2] = f15;
 HEAPF32[i7 >> 2] = f12;
 HEAPF32[i6 >> 2] = f1;
 HEAPF32[i5 >> 2] = f2;
 HEAPF32[i4 >> 2] = f3;
 HEAPF32[i129 + 28 >> 2] = Math_fround(0.0);
 f68 = Math_fround(f16 + f16);
 f81 = Math_fround(f17 + f17);
 f78 = Math_fround(f18 + f18);
 f83 = Math_fround(f17 * f81);
 f79 = Math_fround(f18 * f78);
 f80 = Math_fround(f68 * f17);
 f29 = Math_fround(f68 * f18);
 f82 = Math_fround(f68 * f19);
 f21 = Math_fround(f81 * f18);
 f81 = Math_fround(f81 * f19);
 f78 = Math_fround(f78 * f19);
 f68 = Math_fround(Math_fround(1.0) - Math_fround(f16 * f68));
 f75 = Math_fround(Math_fround(Math_fround(1.0) - f83) - f79);
 f76 = Math_fround(f80 + f78);
 f77 = Math_fround(f29 - f81);
 f78 = Math_fround(f80 - f78);
 f79 = Math_fround(f68 - f79);
 f80 = Math_fround(f21 + f82);
 f81 = Math_fround(f29 + f81);
 f82 = Math_fround(f21 - f82);
 f83 = Math_fround(f68 - f83);
 i9 = i97 + 48 | 0;
 HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 f68 = Math_fround(HEAPF32[i131 >> 2]);
 f21 = Math_fround(HEAPF32[i126 >> 2]);
 f29 = Math_fround(HEAPF32[i127 >> 2]);
 f14 = Math_fround(HEAPF32[i128 >> 2]);
 f39 = Math_fround(f68 + f68);
 f31 = Math_fround(f21 + f21);
 f69 = Math_fround(f29 + f29);
 f13 = Math_fround(f21 * f31);
 f67 = Math_fround(f29 * f69);
 f21 = Math_fround(f39 * f21);
 f16 = Math_fround(f39 * f29);
 f12 = Math_fround(f39 * f14);
 f29 = Math_fround(f31 * f29);
 f31 = Math_fround(f31 * f14);
 f14 = Math_fround(f69 * f14);
 f39 = Math_fround(Math_fround(1.0) - Math_fround(f68 * f39));
 f68 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f67);
 f69 = Math_fround(f21 + f14);
 f15 = Math_fround(f16 - f31);
 f14 = Math_fround(f21 - f14);
 f67 = Math_fround(f39 - f67);
 f21 = Math_fround(f29 + f12);
 f31 = Math_fround(f16 + f31);
 f12 = Math_fround(f29 - f12);
 f13 = Math_fround(f39 - f13);
 HEAPF32[i97 >> 2] = f68;
 i9 = i97 + 4 | 0;
 HEAPF32[i9 >> 2] = f69;
 i10 = i97 + 8 | 0;
 HEAPF32[i10 >> 2] = f15;
 HEAPF32[i97 + 12 >> 2] = Math_fround(0.0);
 i11 = i97 + 16 | 0;
 HEAPF32[i11 >> 2] = f14;
 i26 = i97 + 20 | 0;
 HEAPF32[i26 >> 2] = f67;
 i28 = i97 + 24 | 0;
 HEAPF32[i28 >> 2] = f21;
 HEAPF32[i97 + 28 >> 2] = Math_fround(0.0);
 i84 = i97 + 32 | 0;
 HEAPF32[i84 >> 2] = f31;
 i85 = i97 + 36 | 0;
 HEAPF32[i85 >> 2] = f12;
 i86 = i97 + 40 | 0;
 HEAPF32[i86 >> 2] = f13;
 HEAPF32[i97 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i124 >> 2] = 0;
 HEAP32[i96 >> 2] = HEAP32[i94 >> 2];
 HEAP32[i101 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i102 >> 2] = HEAP32[i93 >> 2];
 HEAP32[i64 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i65 >> 2] = HEAP32[i90 >> 2];
 HEAP32[i66 >> 2] = HEAP32[i91 >> 2];
 i6 = i97 + 48 | 0;
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i97 + 52 | 0;
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i97 + 56 | 0;
 f12 = Math_fround(f12 - f88);
 f31 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f89);
 f39 = Math_fround(f76 * f12);
 f29 = Math_fround(f77 * f31);
 f16 = Math_fround(f79 * f12);
 f30 = Math_fround(f80 * f31);
 f12 = Math_fround(f82 * f12);
 f31 = Math_fround(f83 * f31);
 f60 = Math_fround(Math_fround(Math_fround(f75 * f68) + Math_fround(f76 * f69)) + Math_fround(f77 * f15));
 f53 = Math_fround(Math_fround(Math_fround(f78 * f68) + Math_fround(f79 * f69)) + Math_fround(f80 * f15));
 f51 = Math_fround(Math_fround(Math_fround(f81 * f68) + Math_fround(f82 * f69)) + Math_fround(f83 * f15));
 f52 = Math_fround(Math_fround(Math_fround(f75 * f14) + Math_fround(f76 * f67)) + Math_fround(f77 * f21));
 f50 = Math_fround(Math_fround(Math_fround(f78 * f14) + Math_fround(f79 * f67)) + Math_fround(f80 * f21));
 f48 = Math_fround(Math_fround(Math_fround(f81 * f14) + Math_fround(f82 * f67)) + Math_fround(f83 * f21));
 f1 = Math_fround(HEAPF32[i84 >> 2]);
 f2 = Math_fround(HEAPF32[i85 >> 2]);
 f3 = Math_fround(HEAPF32[i86 >> 2]);
 f49 = Math_fround(Math_fround(Math_fround(f75 * f1) + Math_fround(f76 * f2)) + Math_fround(f77 * f3));
 f46 = Math_fround(Math_fround(Math_fround(f78 * f1) + Math_fround(f79 * f2)) + Math_fround(f80 * f3));
 f23 = Math_fround(Math_fround(Math_fround(f81 * f1) + Math_fround(f82 * f2)) + Math_fround(f83 * f3));
 f32 = Math_fround(-f60);
 f24 = Math_fround(-f53);
 f33 = Math_fround(-f51);
 f24 = Math_fround((f53 > f24 ? f53 : f24) + Math_fround(9.99999997e-07));
 f34 = Math_fround(-f52);
 f25 = Math_fround(-f50);
 f35 = Math_fround(-f48);
 f25 = Math_fround((f50 > f25 ? f50 : f25) + Math_fround(9.99999997e-07));
 f36 = Math_fround(-f49);
 f27 = Math_fround(-f46);
 f37 = Math_fround(-f23);
 f27 = Math_fround((f46 > f27 ? f46 : f27) + Math_fround(9.99999997e-07));
 f13 = Math_fround(f13 - f87);
 f29 = Math_fround(Math_fround(Math_fround(f75 * f13) + f39) + f29);
 f30 = Math_fround(Math_fround(Math_fround(f78 * f13) + f16) + f30);
 f31 = Math_fround(Math_fround(Math_fround(f81 * f13) + f12) + f31);
 f32 = Math_fround((f60 > f32 ? f60 : f32) + Math_fround(9.99999997e-07));
 f33 = Math_fround((f51 > f33 ? f51 : f33) + Math_fround(9.99999997e-07));
 f34 = Math_fround((f52 > f34 ? f52 : f34) + Math_fround(9.99999997e-07));
 f35 = Math_fround((f48 > f35 ? f48 : f35) + Math_fround(9.99999997e-07));
 f36 = Math_fround((f49 > f36 ? f49 : f36) + Math_fround(9.99999997e-07));
 f37 = Math_fround((f23 > f37 ? f23 : f37) + Math_fround(9.99999997e-07));
 f12 = Math_fround(HEAPF32[i95 >> 2]);
 f13 = Math_fround(HEAPF32[i90 >> 2]);
 f16 = Math_fround(HEAPF32[i91 >> 2]);
 f39 = Math_fround(Math_fround(f32 * f12) + Math_fround(Math_fround(f34 * f13) + Math_fround(f16 * f36)));
 f43 = Math_fround(HEAPF32[i96 >> 2]);
 f39 = Math_fround(Math_fround(f43 + f39) - Math_fround(Math_abs(Math_fround(f29))));
 f38 = Math_fround(HEAPF32[i100 >> 2]);
 f39 = Math_fround(f38 + f39);
 if (f39 < Math_fround(0.0)) i4 = 0; else {
  f40 = Math_fround(Math_fround(f24 * f12) + Math_fround(Math_fround(f25 * f13) + Math_fround(f16 * f27)));
  f44 = Math_fround(HEAPF32[i101 >> 2]);
  f40 = Math_fround(f38 + Math_fround(Math_fround(f40 + f44) - Math_fround(Math_abs(Math_fround(f30)))));
  if (f40 < Math_fround(0.0)) i4 = 0; else {
   f17 = Math_fround(Math_fround(f33 * f12) + Math_fround(Math_fround(f35 * f13) + Math_fround(f16 * f37)));
   f22 = Math_fround(HEAPF32[i102 >> 2]);
   f17 = Math_fround(f38 + Math_fround(Math_fround(f17 + f22) - Math_fround(Math_abs(Math_fround(f31)))));
   if (f17 < Math_fround(0.0)) i4 = 0; else {
    f41 = Math_fround(Math_fround(f31 * f51) + Math_fround(Math_fround(f29 * f60) + Math_fround(f30 * f53)));
    f12 = Math_fround(HEAPF32[i94 >> 2]);
    f13 = Math_fround(HEAPF32[i92 >> 2]);
    f16 = Math_fround(HEAPF32[i93 >> 2]);
    f18 = Math_fround(Math_fround(f32 * f12) + Math_fround(Math_fround(f24 * f13) + Math_fround(f33 * f16)));
    f47 = Math_fround(HEAPF32[i64 >> 2]);
    f18 = Math_fround(f38 + Math_fround(Math_fround(f47 + f18) - Math_fround(Math_abs(Math_fround(f41)))));
    if (f18 < Math_fround(0.0)) i4 = 0; else {
     f42 = Math_fround(Math_fround(f31 * f48) + Math_fround(Math_fround(f29 * f52) + Math_fround(f30 * f50)));
     f19 = Math_fround(Math_fround(f34 * f12) + Math_fround(Math_fround(f25 * f13) + Math_fround(f35 * f16)));
     f45 = Math_fround(HEAPF32[i65 >> 2]);
     f19 = Math_fround(f38 + Math_fround(Math_fround(f19 + f45) - Math_fround(Math_abs(Math_fround(f42)))));
     if (f19 < Math_fround(0.0)) i4 = 0; else {
      f20 = Math_fround(Math_fround(f31 * f23) + Math_fround(Math_fround(f29 * f49) + Math_fround(f30 * f46)));
      f12 = Math_fround(Math_fround(f36 * f12) + Math_fround(Math_fround(f27 * f13) + Math_fround(f37 * f16)));
      f16 = Math_fround(HEAPF32[i66 >> 2]);
      f12 = Math_fround(f38 + Math_fround(Math_fround(f12 + f16) - Math_fround(Math_abs(Math_fround(f20)))));
      if (f12 < Math_fround(0.0)) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f31 * f53) - Math_fround(f30 * f51)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f33 * f44) + Math_fround(f24 * f22)) + Math_fround(Math_fround(f36 * f45) + Math_fround(f34 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f31 * f50) - Math_fround(f30 * f48)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f35 * f44) + Math_fround(f25 * f22)) + Math_fround(Math_fround(f36 * f47) + Math_fround(f32 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f31 * f46) - Math_fround(f30 * f23)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f37 * f44) + Math_fround(f27 * f22)) + Math_fround(Math_fround(f34 * f47) + Math_fround(f32 * f45))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f29 * f51) - Math_fround(f31 * f60)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f33 * f43) + Math_fround(f32 * f22)) + Math_fround(Math_fround(f27 * f45) + Math_fround(f25 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f29 * f48) - Math_fround(f31 * f52)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f35 * f43) + Math_fround(f34 * f22)) + Math_fround(Math_fround(f27 * f47) + Math_fround(f24 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f29 * f23) - Math_fround(f31 * f49)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(f36 * f22)) + Math_fround(Math_fround(f25 * f47) + Math_fround(f24 * f45))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f30 * f60) - Math_fround(f29 * f53)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f24 * f43) + Math_fround(f32 * f44)) + Math_fround(Math_fround(f37 * f45) + Math_fround(f35 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f30 * f52) - Math_fround(f29 * f50)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f25 * f43) + Math_fround(f34 * f44)) + Math_fround(Math_fround(f37 * f47) + Math_fround(f33 * f16))))) i4 = 0; else if (Math_fround(Math_abs(Math_fround(Math_fround(f30 * f49) - Math_fround(f29 * f46)))) > Math_fround(f38 + Math_fround(Math_fround(Math_fround(f43 * f27) + Math_fround(f36 * f44)) + Math_fround(Math_fround(f35 * f47) + Math_fround(f33 * f45))))) i4 = 0; else {
       i5 = f39 > f40;
       f40 = i5 ? f40 : f39;
       i4 = f40 > f17;
       f40 = i4 ? f17 : f40;
       i133 = f40 > f18;
       f40 = i133 ? f18 : f40;
       i134 = f40 > f19;
       switch (((i134 ? f19 : f40) > f12 ? 5 : i134 ? 4 : i133 ? 3 : i4 ? 2 : i5 & 1) | 0) {
       case 0:
        {
         if (!(f29 <= Math_fround(0.0))) {
          f13 = Math_fround(f87 + Math_fround(f75 * f43));
          f12 = Math_fround(f88 + Math_fround(f76 * f43));
          f16 = Math_fround(f89 + Math_fround(f77 * f43));
          f17 = f81;
          f18 = f82;
          f19 = f83;
          f20 = Math_fround(-f75);
          f22 = Math_fround(-f76);
          f27 = Math_fround(-f77);
         } else {
          f13 = Math_fround(f87 - Math_fround(f75 * f43));
          f12 = Math_fround(f88 - Math_fround(f76 * f43));
          f16 = Math_fround(f89 - Math_fround(f77 * f43));
          f17 = Math_fround(-f81);
          f18 = Math_fround(-f82);
          f19 = Math_fround(-f83);
          f20 = f75;
          f22 = f76;
          f27 = f77;
         }
         f47 = Math_fround(HEAPF32[i6 >> 2]);
         f47 = Math_fround(f47 - f13);
         f48 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f12);
         f49 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f16);
         f51 = Math_fround(Math_fround(Math_fround(f78 * f47) + Math_fround(f79 * f48)) + Math_fround(f80 * f49));
         f52 = Math_fround(Math_fround(Math_fround(f20 * f47) + Math_fround(f22 * f48)) + Math_fround(f27 * f49));
         f60 = Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f69 * f18) + Math_fround(f68 * f17)));
         f69 = Math_fround(Math_fround(f15 * f27) + Math_fround(Math_fround(f69 * f22) + Math_fround(f68 * f20)));
         f15 = Math_fround(Math_fround(f21 * f19) + Math_fround(Math_fround(f67 * f18) + Math_fround(f14 * f17)));
         f41 = Math_fround(Math_fround(f21 * f27) + Math_fround(Math_fround(f67 * f22) + Math_fround(f14 * f20)));
         f14 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f2 * f18) + Math_fround(f1 * f17)));
         f3 = Math_fround(Math_fround(f3 * f27) + Math_fround(Math_fround(f2 * f22) + Math_fround(f1 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f47) + Math_fround(f18 * f48)) + Math_fround(f19 * f49));
         HEAPF32[i73 + 52 >> 2] = f51;
         HEAPF32[i73 + 56 >> 2] = f52;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f60;
         HEAPF32[i73 + 4 >> 2] = f53;
         HEAPF32[i73 + 8 >> 2] = f69;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f15;
         HEAPF32[i73 + 20 >> 2] = f50;
         HEAPF32[i73 + 24 >> 2] = f41;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f14;
         HEAPF32[i73 + 36 >> 2] = f46;
         HEAPF32[i73 + 40 >> 2] = f3;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f3 = Math_fround(Math_fround(f27 * f19) + Math_fround(Math_fround(f22 * f18) + Math_fround(f20 * f17)));
         f2 = Math_fround(Math_fround(f80 * f27) + Math_fround(Math_fround(f79 * f22) + Math_fround(f78 * f20)));
         f1 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f22 * f22) + Math_fround(f20 * f20)));
         HEAPF32[i57 >> 2] = f3;
         HEAPF32[i57 + 4 >> 2] = f2;
         HEAPF32[i57 + 8 >> 2] = f1;
         HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
         f2 = Math_fround(-f2);
         f1 = Math_fround(-f1);
         HEAPF32[i54 >> 2] = Math_fround(-f3);
         HEAPF32[i54 + 4 >> 2] = f2;
         HEAPF32[i54 + 8 >> 2] = f1;
         HEAPF32[i54 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i54, i73, i95);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i102, i101, i72, i71, i57, i130, i124, i100);
         f1 = f17;
         f2 = f18;
         f3 = f19;
         f14 = f78;
         f41 = f79;
         f15 = f80;
         f19 = f22;
         i74 = 46;
         break;
        }
       case 1:
        {
         if (!(f30 <= Math_fround(0.0))) {
          f13 = Math_fround(f87 + Math_fround(f78 * f44));
          f12 = Math_fround(f88 + Math_fround(f79 * f44));
          f16 = Math_fround(f89 + Math_fround(f80 * f44));
          f17 = f81;
          f18 = f82;
          f22 = f83;
          f20 = Math_fround(-f78);
          f19 = Math_fround(-f79);
          f27 = Math_fround(-f80);
         } else {
          f13 = Math_fround(f87 - Math_fround(f78 * f44));
          f12 = Math_fround(f88 - Math_fround(f79 * f44));
          f16 = Math_fround(f89 - Math_fround(f80 * f44));
          f17 = Math_fround(-f81);
          f18 = Math_fround(-f82);
          f22 = Math_fround(-f83);
          f20 = f78;
          f19 = f79;
          f27 = f80;
         }
         f46 = Math_fround(HEAPF32[i6 >> 2]);
         f46 = Math_fround(f46 - f13);
         f47 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f12);
         f48 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f16);
         f50 = Math_fround(Math_fround(Math_fround(f17 * f46) + Math_fround(f18 * f47)) + Math_fround(f22 * f48));
         f51 = Math_fround(Math_fround(Math_fround(f20 * f46) + Math_fround(f19 * f47)) + Math_fround(f27 * f48));
         f53 = Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f69 * f18) + Math_fround(f68 * f17)));
         f69 = Math_fround(Math_fround(f15 * f27) + Math_fround(Math_fround(f69 * f19) + Math_fround(f68 * f20)));
         f15 = Math_fround(Math_fround(f21 * f22) + Math_fround(Math_fround(f67 * f18) + Math_fround(f14 * f17)));
         f41 = Math_fround(Math_fround(f21 * f27) + Math_fround(Math_fround(f67 * f19) + Math_fround(f14 * f20)));
         f14 = Math_fround(Math_fround(f3 * f22) + Math_fround(Math_fround(f2 * f18) + Math_fround(f1 * f17)));
         f3 = Math_fround(Math_fround(f3 * f27) + Math_fround(Math_fround(f2 * f19) + Math_fround(f1 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f75 * f46) + Math_fround(f76 * f47)) + Math_fround(f77 * f48));
         HEAPF32[i73 + 52 >> 2] = f50;
         HEAPF32[i73 + 56 >> 2] = f51;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f60;
         HEAPF32[i73 + 4 >> 2] = f53;
         HEAPF32[i73 + 8 >> 2] = f69;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f52;
         HEAPF32[i73 + 20 >> 2] = f15;
         HEAPF32[i73 + 24 >> 2] = f41;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f49;
         HEAPF32[i73 + 36 >> 2] = f14;
         HEAPF32[i73 + 40 >> 2] = f3;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f3 = Math_fround(Math_fround(f77 * f27) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
         f2 = Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f19 * f18) + Math_fround(f20 * f17)));
         f1 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)));
         HEAPF32[i58 >> 2] = f3;
         HEAPF32[i58 + 4 >> 2] = f2;
         HEAPF32[i58 + 8 >> 2] = f1;
         HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
         f2 = Math_fround(-f2);
         f1 = Math_fround(-f1);
         HEAPF32[i55 >> 2] = Math_fround(-f3);
         HEAPF32[i55 + 4 >> 2] = f2;
         HEAPF32[i55 + 8 >> 2] = f1;
         HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i55, i73, i95);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i96, i102, i72, i71, i58, i130, i124, i100);
         f1 = f75;
         f2 = f76;
         f3 = f77;
         f14 = f17;
         f41 = f18;
         f15 = f22;
         i74 = 46;
         break;
        }
       case 2:
        {
         if (!(f31 <= Math_fround(0.0))) {
          f13 = Math_fround(f87 + Math_fround(f81 * f22));
          f12 = Math_fround(f88 + Math_fround(f82 * f22));
          f16 = Math_fround(f89 + Math_fround(f83 * f22));
          f17 = Math_fround(-f78);
          f18 = Math_fround(-f79);
          f22 = Math_fround(-f80);
          f20 = Math_fround(-f81);
          f19 = Math_fround(-f82);
          f27 = Math_fround(-f83);
         } else {
          f13 = Math_fround(f87 - Math_fround(f81 * f22));
          f12 = Math_fround(f88 - Math_fround(f82 * f22));
          f16 = Math_fround(f89 - Math_fround(f83 * f22));
          f17 = f78;
          f18 = f79;
          f22 = f80;
          f20 = f81;
          f19 = f82;
          f27 = f83;
         }
         f46 = Math_fround(HEAPF32[i6 >> 2]);
         f46 = Math_fround(f46 - f13);
         f47 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f12);
         f48 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f16);
         f50 = Math_fround(Math_fround(Math_fround(f17 * f46) + Math_fround(f18 * f47)) + Math_fround(f22 * f48));
         f51 = Math_fround(Math_fround(Math_fround(f20 * f46) + Math_fround(f19 * f47)) + Math_fround(f27 * f48));
         f53 = Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f69 * f18) + Math_fround(f68 * f17)));
         f69 = Math_fround(Math_fround(f15 * f27) + Math_fround(Math_fround(f69 * f19) + Math_fround(f68 * f20)));
         f15 = Math_fround(Math_fround(f21 * f22) + Math_fround(Math_fround(f67 * f18) + Math_fround(f14 * f17)));
         f41 = Math_fround(Math_fround(f21 * f27) + Math_fround(Math_fround(f67 * f19) + Math_fround(f14 * f20)));
         f14 = Math_fround(Math_fround(f3 * f22) + Math_fround(Math_fround(f2 * f18) + Math_fround(f1 * f17)));
         f3 = Math_fround(Math_fround(f3 * f27) + Math_fround(Math_fround(f2 * f19) + Math_fround(f1 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f75 * f46) + Math_fround(f76 * f47)) + Math_fround(f77 * f48));
         HEAPF32[i73 + 52 >> 2] = f50;
         HEAPF32[i73 + 56 >> 2] = f51;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f60;
         HEAPF32[i73 + 4 >> 2] = f53;
         HEAPF32[i73 + 8 >> 2] = f69;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f52;
         HEAPF32[i73 + 20 >> 2] = f15;
         HEAPF32[i73 + 24 >> 2] = f41;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f49;
         HEAPF32[i73 + 36 >> 2] = f14;
         HEAPF32[i73 + 40 >> 2] = f3;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f3 = Math_fround(Math_fround(f77 * f27) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
         f2 = Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f19 * f18) + Math_fround(f20 * f17)));
         f1 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)));
         HEAPF32[i59 >> 2] = f3;
         HEAPF32[i59 + 4 >> 2] = f2;
         HEAPF32[i59 + 8 >> 2] = f1;
         HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
         f2 = Math_fround(-f2);
         f1 = Math_fround(-f1);
         HEAPF32[i56 >> 2] = Math_fround(-f3);
         HEAPF32[i56 + 4 >> 2] = f2;
         HEAPF32[i56 + 8 >> 2] = f1;
         HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i56, i73, i95);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i96, i101, i72, i71, i59, i130, i124, i100);
         f1 = f75;
         f2 = f76;
         f3 = f77;
         f14 = f17;
         f41 = f18;
         f15 = f22;
         i74 = 46;
         break;
        }
       case 3:
        {
         f18 = Math_fround(-f68);
         f17 = Math_fround(-f69);
         f12 = Math_fround(-f15);
         if (!(f41 <= Math_fround(0.0))) {
          f1 = Math_fround(-f1);
          f2 = Math_fround(-f2);
          f3 = Math_fround(-f3);
          f13 = Math_fround(HEAPF32[i6 >> 2]);
          f60 = Math_fround(HEAPF32[i7 >> 2]);
          f16 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f15 * f47));
          f20 = f68;
          f19 = f69;
          f22 = f15;
          f15 = f12;
          f13 = Math_fround(f13 - Math_fround(f68 * f47));
          f12 = Math_fround(f60 - Math_fround(f69 * f47));
         } else {
          f13 = Math_fround(HEAPF32[i6 >> 2]);
          f60 = Math_fround(HEAPF32[i7 >> 2]);
          f16 = Math_fround(Math_fround(f15 * f47) + Math_fround(HEAPF32[i8 >> 2]));
          f20 = f18;
          f19 = f17;
          f22 = f12;
          f18 = f68;
          f17 = f69;
          f13 = Math_fround(Math_fround(f68 * f47) + f13);
          f12 = Math_fround(Math_fround(f69 * f47) + f60);
         }
         f45 = Math_fround(f87 - f13);
         f44 = Math_fround(f88 - f12);
         f43 = Math_fround(f89 - f16);
         f46 = Math_fround(Math_fround(f21 * f43) + Math_fround(Math_fround(f67 * f44) + Math_fround(f14 * f45)));
         f47 = Math_fround(Math_fround(f43 * f22) + Math_fround(Math_fround(f44 * f19) + Math_fround(f45 * f20)));
         f49 = Math_fround(Math_fround(f77 * f3) + Math_fround(Math_fround(f76 * f2) + Math_fround(f75 * f1)));
         f51 = Math_fround(Math_fround(f77 * f22) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
         f53 = Math_fround(Math_fround(f80 * f3) + Math_fround(Math_fround(f79 * f2) + Math_fround(f78 * f1)));
         f60 = Math_fround(Math_fround(f80 * f22) + Math_fround(Math_fround(f79 * f19) + Math_fround(f78 * f20)));
         f69 = Math_fround(Math_fround(f83 * f3) + Math_fround(Math_fround(f82 * f2) + Math_fround(f81 * f1)));
         f68 = Math_fround(Math_fround(f83 * f22) + Math_fround(Math_fround(f82 * f19) + Math_fround(f81 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(f43 * f3) + Math_fround(Math_fround(f44 * f2) + Math_fround(f45 * f1)));
         HEAPF32[i73 + 52 >> 2] = f46;
         HEAPF32[i73 + 56 >> 2] = f47;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f49;
         HEAPF32[i73 + 4 >> 2] = f52;
         HEAPF32[i73 + 8 >> 2] = f51;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f53;
         HEAPF32[i73 + 20 >> 2] = f50;
         HEAPF32[i73 + 24 >> 2] = f60;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f69;
         HEAPF32[i73 + 36 >> 2] = f48;
         HEAPF32[i73 + 40 >> 2] = f68;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f68 = Math_fround(Math_fround(f21 * f15) + Math_fround(Math_fround(f67 * f17) + Math_fround(f14 * f18)));
         f69 = Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * f20)));
         HEAPF32[i62 >> 2] = Math_fround(Math_fround(f15 * f3) + Math_fround(Math_fround(f17 * f2) + Math_fround(f18 * f1)));
         HEAPF32[i62 + 4 >> 2] = f68;
         HEAPF32[i62 + 8 >> 2] = f69;
         HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i62, i73, i94);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i66, i65, i72, i71, i62, i130, i124, i100);
         f17 = f22;
         f18 = f67;
         i74 = 44;
         break;
        }
       case 4:
        {
         f18 = Math_fround(-f14);
         f13 = Math_fround(-f67);
         f12 = Math_fround(-f21);
         if (!(f42 <= Math_fround(0.0))) {
          f1 = Math_fround(-f1);
          f2 = Math_fround(-f2);
          f3 = Math_fround(-f3);
          f23 = Math_fround(HEAPF32[i6 >> 2]);
          f22 = Math_fround(HEAPF32[i7 >> 2]);
          f23 = Math_fround(f23 - Math_fround(f14 * f45));
          f22 = Math_fround(f22 - Math_fround(f67 * f45));
          f16 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f21 * f45));
          f20 = f14;
          f19 = f67;
          f17 = f21;
          f14 = f18;
         } else {
          f23 = Math_fround(HEAPF32[i6 >> 2]);
          f22 = Math_fround(HEAPF32[i7 >> 2]);
          f23 = Math_fround(Math_fround(f14 * f45) + f23);
          f22 = Math_fround(Math_fround(f67 * f45) + f22);
          f16 = Math_fround(Math_fround(f21 * f45) + Math_fround(HEAPF32[i8 >> 2]));
          f20 = f18;
          f19 = f13;
          f17 = f12;
          f13 = f67;
          f12 = f21;
         }
         f46 = Math_fround(f87 - f23);
         f45 = Math_fround(f88 - f22);
         f44 = Math_fround(f89 - f16);
         f47 = Math_fround(Math_fround(f44 * f3) + Math_fround(Math_fround(f45 * f2) + Math_fround(f46 * f1)));
         f48 = Math_fround(Math_fround(f44 * f17) + Math_fround(Math_fround(f45 * f19) + Math_fround(f46 * f20)));
         f49 = Math_fround(Math_fround(f77 * f3) + Math_fround(Math_fround(f76 * f2) + Math_fround(f75 * f1)));
         f50 = Math_fround(Math_fround(f77 * f17) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
         f52 = Math_fround(Math_fround(f80 * f3) + Math_fround(Math_fround(f79 * f2) + Math_fround(f78 * f1)));
         f67 = Math_fround(Math_fround(f80 * f17) + Math_fround(Math_fround(f79 * f19) + Math_fround(f78 * f20)));
         f21 = Math_fround(Math_fround(f83 * f3) + Math_fround(Math_fround(f82 * f2) + Math_fround(f81 * f1)));
         f18 = Math_fround(Math_fround(f83 * f17) + Math_fround(Math_fround(f82 * f19) + Math_fround(f81 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(f15 * f44) + Math_fround(Math_fround(f69 * f45) + Math_fround(f68 * f46)));
         HEAPF32[i73 + 52 >> 2] = f47;
         HEAPF32[i73 + 56 >> 2] = f48;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f60;
         HEAPF32[i73 + 4 >> 2] = f49;
         HEAPF32[i73 + 8 >> 2] = f50;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f53;
         HEAPF32[i73 + 20 >> 2] = f52;
         HEAPF32[i73 + 24 >> 2] = f67;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f51;
         HEAPF32[i73 + 36 >> 2] = f21;
         HEAPF32[i73 + 40 >> 2] = f18;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f18 = Math_fround(Math_fround(f12 * f3) + Math_fround(Math_fround(f13 * f2) + Math_fround(f14 * f1)));
         f21 = Math_fround(Math_fround(f12 * f17) + Math_fround(Math_fround(f13 * f19) + Math_fround(f14 * f20)));
         HEAPF32[i63 >> 2] = Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f69 * f13) + Math_fround(f68 * f14)));
         HEAPF32[i63 + 4 >> 2] = f18;
         HEAPF32[i63 + 8 >> 2] = f21;
         HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i63, i73, i94);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i64, i66, i72, i71, i63, i130, i124, i100);
         f12 = f22;
         f13 = f23;
         f21 = f3;
         f18 = f2;
         f14 = f1;
         f3 = f15;
         f2 = f69;
         f1 = f68;
         i74 = 44;
         break;
        }
       case 5:
        {
         if (!(f20 <= Math_fround(0.0))) {
          f49 = Math_fround(-f1);
          f50 = Math_fround(-f2);
          f52 = Math_fround(-f3);
          f13 = Math_fround(HEAPF32[i6 >> 2]);
          f12 = Math_fround(HEAPF32[i7 >> 2]);
          f13 = Math_fround(f13 - Math_fround(f1 * f16));
          f12 = Math_fround(f12 - Math_fround(f2 * f16));
          f16 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f3 * f16));
          f18 = f67;
          f20 = f1;
          f19 = f2;
          f17 = f3;
          f1 = f49;
          f2 = f50;
          f3 = f52;
         } else {
          f14 = Math_fround(-f14);
          f18 = Math_fround(-f67);
          f21 = Math_fround(-f21);
          f20 = Math_fround(-f1);
          f19 = Math_fround(-f2);
          f17 = Math_fround(-f3);
          f13 = Math_fround(HEAPF32[i6 >> 2]);
          f12 = Math_fround(HEAPF32[i7 >> 2]);
          f13 = Math_fround(Math_fround(f1 * f16) + f13);
          f12 = Math_fround(Math_fround(f2 * f16) + f12);
          f16 = Math_fround(Math_fround(f3 * f16) + Math_fround(HEAPF32[i8 >> 2]));
         }
         f44 = Math_fround(f87 - f13);
         f43 = Math_fround(f88 - f12);
         f42 = Math_fround(f89 - f16);
         f45 = Math_fround(Math_fround(f42 * f21) + Math_fround(Math_fround(f43 * f18) + Math_fround(f44 * f14)));
         f46 = Math_fround(Math_fround(f42 * f17) + Math_fround(Math_fround(f43 * f19) + Math_fround(f44 * f20)));
         f47 = Math_fround(Math_fround(f77 * f21) + Math_fround(Math_fround(f76 * f18) + Math_fround(f75 * f14)));
         f48 = Math_fround(Math_fround(f77 * f17) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
         f49 = Math_fround(Math_fround(f80 * f21) + Math_fround(Math_fround(f79 * f18) + Math_fround(f78 * f14)));
         f50 = Math_fround(Math_fround(f80 * f17) + Math_fround(Math_fround(f79 * f19) + Math_fround(f78 * f20)));
         f52 = Math_fround(Math_fround(f83 * f21) + Math_fround(Math_fround(f82 * f18) + Math_fround(f81 * f14)));
         f67 = Math_fround(Math_fround(f83 * f17) + Math_fround(Math_fround(f82 * f19) + Math_fround(f81 * f20)));
         HEAPF32[i73 + 48 >> 2] = Math_fround(Math_fround(f15 * f42) + Math_fround(Math_fround(f69 * f43) + Math_fround(f68 * f44)));
         HEAPF32[i73 + 52 >> 2] = f45;
         HEAPF32[i73 + 56 >> 2] = f46;
         HEAPF32[i73 + 60 >> 2] = Math_fround(0.0);
         HEAPF32[i73 >> 2] = f60;
         HEAPF32[i73 + 4 >> 2] = f47;
         HEAPF32[i73 + 8 >> 2] = f48;
         HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 16 >> 2] = f53;
         HEAPF32[i73 + 20 >> 2] = f49;
         HEAPF32[i73 + 24 >> 2] = f50;
         HEAPF32[i73 + 28 >> 2] = Math_fround(0.0);
         HEAPF32[i73 + 32 >> 2] = f51;
         HEAPF32[i73 + 36 >> 2] = f52;
         HEAPF32[i73 + 40 >> 2] = f67;
         HEAPF32[i73 + 44 >> 2] = Math_fround(0.0);
         f60 = Math_fround(Math_fround(f3 * f21) + Math_fround(Math_fround(f2 * f18) + Math_fround(f1 * f14)));
         f67 = Math_fround(Math_fround(f3 * f17) + Math_fround(Math_fround(f2 * f19) + Math_fround(f1 * f20)));
         HEAPF32[i61 >> 2] = Math_fround(Math_fround(f15 * f3) + Math_fround(Math_fround(f69 * f2) + Math_fround(f68 * f1)));
         HEAPF32[i61 + 4 >> 2] = f60;
         HEAPF32[i61 + 8 >> 2] = f67;
         HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
         __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i72, i71, i61, i73, i94);
         __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i64, i65, i72, i71, i61, i130, i124, i100);
         f3 = f15;
         f2 = f69;
         f1 = f68;
         i74 = 44;
         break;
        }
       default:
        i4 = 0;
       }
       if ((i74 | 0) == 44) {
        i4 = HEAP32[i124 >> 2] | 0;
        if (!i4) {
         f41 = f18;
         f15 = f21;
         f27 = f17;
         i74 = 46;
        } else {
         i5 = 0;
         do {
          i133 = i130 + (i5 * 48 | 0) + 16 | 0;
          HEAP32[i70 >> 2] = HEAP32[i133 >> 2];
          HEAP32[i70 + 4 >> 2] = HEAP32[i133 + 4 >> 2];
          HEAP32[i70 + 8 >> 2] = HEAP32[i133 + 8 >> 2];
          HEAP32[i70 + 12 >> 2] = HEAP32[i133 + 12 >> 2];
          i134 = i130 + (i5 * 48 | 0) | 0;
          HEAP32[i133 >> 2] = HEAP32[i134 >> 2];
          HEAP32[i133 + 4 >> 2] = HEAP32[i134 + 4 >> 2];
          HEAP32[i133 + 8 >> 2] = HEAP32[i134 + 8 >> 2];
          HEAP32[i133 + 12 >> 2] = HEAP32[i134 + 12 >> 2];
          HEAP32[i134 >> 2] = HEAP32[i70 >> 2];
          HEAP32[i134 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
          HEAP32[i134 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
          HEAP32[i134 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
          i5 = i5 + 1 | 0;
         } while (i5 >>> 0 < i4 >>> 0);
         f41 = f18;
         f15 = f21;
         f27 = f17;
         i74 = 46;
        }
       }
       if ((i74 | 0) == 46) {
        f40 = Math_fround(HEAPF32[i6 >> 2]);
        f32 = Math_fround(HEAPF32[i7 >> 2]);
        f40 = Math_fround(f13 - f40);
        f32 = Math_fround(f12 - f32);
        f31 = Math_fround(f16 - Math_fround(HEAPF32[i8 >> 2]));
        f17 = Math_fround(HEAPF32[i97 >> 2]);
        f29 = Math_fround(f40 * f17);
        f22 = Math_fround(HEAPF32[i9 >> 2]);
        f29 = Math_fround(f29 + Math_fround(f32 * f22));
        f38 = Math_fround(HEAPF32[i10 >> 2]);
        f29 = Math_fround(f29 + Math_fround(f31 * f38));
        f21 = Math_fround(HEAPF32[i11 >> 2]);
        f30 = Math_fround(f40 * f21);
        f25 = Math_fround(HEAPF32[i26 >> 2]);
        f30 = Math_fround(f30 + Math_fround(f32 * f25));
        f39 = Math_fround(HEAPF32[i28 >> 2]);
        f30 = Math_fround(f30 + Math_fround(f31 * f39));
        f24 = Math_fround(HEAPF32[i84 >> 2]);
        f40 = Math_fround(f40 * f24);
        f23 = Math_fround(HEAPF32[i85 >> 2]);
        f32 = Math_fround(f40 + Math_fround(f32 * f23));
        f40 = Math_fround(HEAPF32[i86 >> 2]);
        f31 = Math_fround(f32 + Math_fround(f31 * f40));
        f32 = Math_fround(Math_fround(Math_fround(f1 * f17) + Math_fround(f2 * f22)) + Math_fround(f3 * f38));
        f33 = Math_fround(Math_fround(Math_fround(f1 * f21) + Math_fround(f2 * f25)) + Math_fround(f3 * f39));
        f34 = Math_fround(Math_fround(Math_fround(f1 * f24) + Math_fround(f2 * f23)) + Math_fround(f3 * f40));
        f35 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(f41 * f22)) + Math_fround(f15 * f38));
        f36 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f41 * f25)) + Math_fround(f15 * f39));
        f37 = Math_fround(Math_fround(Math_fround(f14 * f24) + Math_fround(f41 * f23)) + Math_fround(f15 * f40));
        f38 = Math_fround(Math_fround(Math_fround(f20 * f17) + Math_fround(f19 * f22)) + Math_fround(f27 * f38));
        f39 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(f19 * f25)) + Math_fround(f27 * f39));
        f40 = Math_fround(Math_fround(Math_fround(f20 * f24) + Math_fround(f19 * f23)) + Math_fround(f27 * f40));
        f23 = Math_fround(f13 - f87);
        f24 = Math_fround(f12 - f88);
        f25 = Math_fround(f16 - f89);
        f21 = Math_fround(Math_fround(f77 * f25) + Math_fround(Math_fround(f76 * f24) + Math_fround(f75 * f23)));
        f22 = Math_fround(Math_fround(f80 * f25) + Math_fround(Math_fround(f79 * f24) + Math_fround(f78 * f23)));
        f23 = Math_fround(Math_fround(f83 * f25) + Math_fround(Math_fround(f82 * f24) + Math_fround(f81 * f23)));
        f24 = Math_fround(Math_fround(f77 * f3) + Math_fround(Math_fround(f76 * f2) + Math_fround(f75 * f1)));
        f25 = Math_fround(Math_fround(f80 * f3) + Math_fround(Math_fround(f79 * f2) + Math_fround(f78 * f1)));
        f16 = Math_fround(Math_fround(f83 * f3) + Math_fround(Math_fround(f82 * f2) + Math_fround(f81 * f1)));
        f17 = Math_fround(Math_fround(f77 * f15) + Math_fround(Math_fround(f76 * f41) + Math_fround(f75 * f14)));
        f18 = Math_fround(Math_fround(f80 * f15) + Math_fround(Math_fround(f79 * f41) + Math_fround(f78 * f14)));
        f15 = Math_fround(Math_fround(f83 * f15) + Math_fround(Math_fround(f82 * f41) + Math_fround(f81 * f14)));
        f14 = Math_fround(Math_fround(f77 * f27) + Math_fround(Math_fround(f76 * f19) + Math_fround(f75 * f20)));
        f13 = Math_fround(Math_fround(f80 * f27) + Math_fround(Math_fround(f79 * f19) + Math_fround(f78 * f20)));
        f1 = Math_fround(Math_fround(f83 * f27) + Math_fround(Math_fround(f82 * f19) + Math_fround(f81 * f20)));
        f88 = Math_fround(HEAPF32[i130 + 32 >> 2]);
        f89 = Math_fround(HEAPF32[i130 + 36 >> 2]);
        f12 = Math_fround(HEAPF32[i130 + 40 >> 2]);
        f2 = Math_fround(Math_fround(Math_fround(f32 * f88) + Math_fround(f35 * f89)) + Math_fround(f38 * f12));
        f3 = Math_fround(Math_fround(Math_fround(f33 * f88) + Math_fround(f36 * f89)) + Math_fround(f39 * f12));
        f12 = Math_fround(Math_fround(Math_fround(f88 * f34) + Math_fround(f37 * f89)) + Math_fround(f40 * f12));
        i4 = HEAP32[i124 >> 2] | 0;
        if (!i4) i4 = 1; else {
         i5 = 0;
         do {
          i134 = i130 + (i5 * 48 | 0) | 0;
          f89 = Math_fround(HEAPF32[i134 >> 2]);
          i133 = i130 + (i5 * 48 | 0) + 4 | 0;
          f88 = Math_fround(HEAPF32[i133 >> 2]);
          i73 = i130 + (i5 * 48 | 0) + 8 | 0;
          f87 = Math_fround(HEAPF32[i73 >> 2]);
          f83 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f25 * f89) + Math_fround(f18 * f88)) + Math_fround(f13 * f87)));
          f82 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f16 * f89) + Math_fround(f15 * f88)) + Math_fround(f1 * f87)));
          HEAPF32[i134 >> 2] = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f24 * f89) + Math_fround(f17 * f88)) + Math_fround(f14 * f87)));
          HEAPF32[i133 >> 2] = f83;
          HEAPF32[i73 >> 2] = f82;
          HEAPF32[i130 + (i5 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
          i73 = i130 + (i5 * 48 | 0) + 16 | 0;
          f82 = Math_fround(HEAPF32[i73 >> 2]);
          i133 = i130 + (i5 * 48 | 0) + 20 | 0;
          f83 = Math_fround(HEAPF32[i133 >> 2]);
          i134 = i130 + (i5 * 48 | 0) + 24 | 0;
          f87 = Math_fround(HEAPF32[i134 >> 2]);
          f88 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f33 * f82) + Math_fround(f36 * f83)) + Math_fround(f39 * f87)));
          f89 = Math_fround(f31 + Math_fround(Math_fround(Math_fround(f34 * f82) + Math_fround(f37 * f83)) + Math_fround(f40 * f87)));
          HEAPF32[i73 >> 2] = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f32 * f82) + Math_fround(f35 * f83)) + Math_fround(f38 * f87)));
          HEAPF32[i133 >> 2] = f88;
          HEAPF32[i134 >> 2] = f89;
          HEAPF32[i130 + (i5 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
          HEAPF32[i130 + (i5 * 48 | 0) + 32 >> 2] = f2;
          HEAPF32[i130 + (i5 * 48 | 0) + 36 >> 2] = f3;
          HEAPF32[i130 + (i5 * 48 | 0) + 40 >> 2] = f12;
          i5 = i5 + 1 | 0;
         } while (i5 >>> 0 < i4 >>> 0);
         i4 = 1;
        }
       }
      }
     }
    }
   }
  }
 }
 L71 : do if (i4 | 0) {
  i4 = HEAP32[i124 >> 2] | 0;
  if (!i4) {
   HEAP32[i99 >> 2] = 0;
   HEAP32[i99 + 4 >> 2] = 0;
   HEAP32[i99 + 8 >> 2] = 0;
   HEAP32[i99 + 12 >> 2] = 0;
   i5 = i101 + 64 | 0;
   HEAP32[i101 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i101 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
   HEAP32[i101 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
   HEAP32[i101 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
   HEAP32[i101 + 80 >> 2] = 3;
   HEAP32[i96 >> 2] = 0;
   HEAP32[i96 + 4 >> 2] = 0;
   HEAP32[i96 + 8 >> 2] = 0;
   HEAP32[i96 + 12 >> 2] = 0;
   HEAP32[i5 >> 2] = HEAP32[i96 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i96 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i96 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i96 + 12 >> 2];
   i5 = i101 + 144 | 0;
   HEAP32[i5 >> 2] = HEAP32[i94 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i94 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i94 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i94 + 12 >> 2];
   f88 = Math_fround(HEAPF32[i94 >> 2]);
   f87 = Math_fround(HEAPF32[i92 >> 2]);
   f89 = Math_fround(HEAPF32[i93 >> 2]);
   f87 = f88 <= f87 ? f88 : f87;
   f89 = f87 <= f89 ? f87 : f89;
   f87 = Math_fround(f89 * Math_fround(.150000006));
   HEAPF32[i101 + 16 >> 2] = f87;
   HEAPF32[i101 + 32 >> 2] = Math_fround(f89 * Math_fround(.0500000007));
   f89 = Math_fround(f87 * f87);
   HEAPF32[i101 + 48 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(f89 + Math_fround(f89 + f89)))) - f87);
   i5 = i102 + 64 | 0;
   HEAP32[i102 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i102 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
   HEAP32[i102 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
   HEAP32[i102 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
   HEAP32[i102 + 80 >> 2] = 3;
   HEAP32[i96 >> 2] = 0;
   HEAP32[i96 + 4 >> 2] = 0;
   HEAP32[i96 + 8 >> 2] = 0;
   HEAP32[i96 + 12 >> 2] = 0;
   HEAP32[i5 >> 2] = HEAP32[i96 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i96 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i96 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i96 + 12 >> 2];
   i5 = i102 + 144 | 0;
   HEAP32[i5 >> 2] = HEAP32[i95 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
   f87 = Math_fround(HEAPF32[i95 >> 2]);
   f89 = Math_fround(HEAPF32[i90 >> 2]);
   f88 = Math_fround(HEAPF32[i91 >> 2]);
   f89 = f87 <= f89 ? f87 : f89;
   f88 = f89 <= f88 ? f89 : f88;
   f89 = Math_fround(f88 * Math_fround(.150000006));
   HEAPF32[i102 + 16 >> 2] = f89;
   HEAPF32[i102 + 32 >> 2] = Math_fround(f88 * Math_fround(.0500000007));
   f88 = Math_fround(f89 * f89);
   HEAPF32[i102 + 48 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(f88 + Math_fround(f88 + f88)))) - f89);
   HEAP32[i104 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i104 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
   HEAP32[i104 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
   HEAP32[i104 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
   HEAP32[i119 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i119 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
   HEAP32[i119 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
   HEAP32[i119 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
   HEAP32[i123 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i123 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
   HEAP32[i123 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
   HEAP32[i123 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
   HEAPF32[i117 >> 2] = Math_fround(0.0);
   i5 = i129 + 33 | 0;
   HEAP8[i5 >> 0] = 0;
   i6 = i129 + 34 | 0;
   i7 = i129 + 38 | 0;
   i4 = __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i101, i102, i118, i100, i104, i119, i123, i117, i6, i7, i5) | 0;
   if ((i4 | 0) == 6) {
    i4 = __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb(i101, i102, i118, i104, i119, i123, i117, i6, i7, i5, 0) | 0;
    if ((i4 | 0) == 6) {
     f83 = Math_fround(HEAPF32[i119 >> 2]);
     f87 = Math_fround(HEAPF32[i119 + 4 >> 2]);
     f82 = Math_fround(HEAPF32[i119 + 8 >> 2]);
     f1 = Math_fround(HEAPF32[i104 >> 2]);
     f2 = Math_fround(HEAPF32[i104 + 4 >> 2]);
     f3 = Math_fround(HEAPF32[i104 + 8 >> 2]);
     f83 = Math_fround(f83 - f1);
     f87 = Math_fround(f87 - f2);
     f82 = Math_fround(f82 - f3);
     f89 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f83 * f83) + Math_fround(f87 * f87)) + Math_fround(f82 * f82))));
     f88 = Math_fround(Math_fround(1.0) / f89);
     f83 = Math_fround(f83 * f88);
     f87 = Math_fround(f87 * f88);
     f88 = Math_fround(f82 * f88);
     HEAPF32[i123 >> 2] = f83;
     i5 = i123 + 4 | 0;
     HEAPF32[i5 >> 2] = f87;
     i6 = i123 + 8 | 0;
     HEAPF32[i6 >> 2] = f88;
     i7 = i123 + 12 | 0;
     HEAPF32[i7 >> 2] = Math_fround(0.0);
     f89 = Math_fround(-f89);
     HEAPF32[i117 >> 2] = f89;
     i9 = i117 + 4 | 0;
     HEAP32[i9 >> 2] = HEAP32[i103 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i103 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i103 + 8 >> 2];
     i9 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = i123;
     i4 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
    } else i74 = 55;
   } else i74 = 55;
   do if ((i74 | 0) == 55) if ((i4 | 0) == 1) {
    f1 = Math_fround(HEAPF32[i104 >> 2]);
    f2 = Math_fround(HEAPF32[i104 + 4 >> 2]);
    f3 = Math_fround(HEAPF32[i104 + 8 >> 2]);
    i10 = i123 + 4 | 0;
    i11 = i123 + 8 | 0;
    i5 = i10;
    i6 = i11;
    i7 = i123 + 12 | 0;
    i8 = i123;
    i9 = HEAP32[i123 >> 2] | 0;
    i10 = HEAP32[i10 >> 2] | 0;
    i11 = HEAP32[i11 >> 2] | 0;
    i4 = HEAP32[i117 >> 2] | 0;
    break;
   } else break L71; while (0);
   HEAPF32[i125 >> 2] = Math_fround(f105 * Math_fround(.0500000007));
   f79 = Math_fround(HEAPF32[i106 >> 2]);
   f81 = Math_fround(HEAPF32[i107 >> 2]);
   f79 = Math_fround(f1 - f79);
   f81 = Math_fround(f2 - f81);
   f77 = Math_fround(f3 - Math_fround(HEAPF32[i108 >> 2]));
   f87 = Math_fround(f79 * Math_fround(HEAPF32[i118 >> 2]));
   f87 = Math_fround(f87 + Math_fround(f81 * Math_fround(HEAPF32[i109 >> 2])));
   f87 = Math_fround(f87 + Math_fround(f77 * Math_fround(HEAPF32[i110 >> 2])));
   f82 = Math_fround(f79 * Math_fround(HEAPF32[i111 >> 2]));
   f82 = Math_fround(f82 + Math_fround(f81 * Math_fround(HEAPF32[i112 >> 2])));
   f82 = Math_fround(f82 + Math_fround(f77 * Math_fround(HEAPF32[i113 >> 2])));
   f79 = Math_fround(f79 * Math_fround(HEAPF32[i114 >> 2]));
   f81 = Math_fround(f79 + Math_fround(f81 * Math_fround(HEAPF32[i115 >> 2])));
   f77 = Math_fround(f81 + Math_fround(f77 * Math_fround(HEAPF32[i116 >> 2])));
   HEAPF32[i121 >> 2] = f87;
   HEAPF32[i121 + 4 >> 2] = f82;
   HEAPF32[i121 + 8 >> 2] = f77;
   HEAPF32[i121 + 12 >> 2] = Math_fround(0.0);
   HEAP32[i122 >> 2] = HEAP32[i119 >> 2];
   HEAP32[i122 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
   HEAP32[i122 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
   HEAP32[i122 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
   HEAP32[i120 >> 2] = i9;
   HEAP32[i120 + 4 >> 2] = i10;
   HEAP32[i120 + 8 >> 2] = i11;
   HEAP32[i120 + 12 >> 2] = i4;
   i134 = __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i129, i121, i122, i120, i125) | 0;
   HEAP32[i124 >> 2] = (HEAP32[i124 >> 2] | 0) + i134;
   f77 = Math_fround(HEAPF32[i131 >> 2]);
   f82 = Math_fround(HEAPF32[i126 >> 2]);
   f87 = Math_fround(HEAPF32[i127 >> 2]);
   f81 = Math_fround(HEAPF32[i128 >> 2]);
   f79 = Math_fround(HEAPF32[i8 >> 2]);
   f88 = Math_fround(HEAPF32[i5 >> 2]);
   f83 = Math_fround(HEAPF32[i6 >> 2]);
   f80 = Math_fround(Math_fround(f81 * f81) + Math_fround(-.5));
   f78 = Math_fround(Math_fround(Math_fround(f77 * f79) + Math_fround(f82 * f88)) + Math_fround(f87 * f83));
   f89 = Math_fround(Math_fround(Math_fround(f82 * f78) + Math_fround(Math_fround(f80 * f88) + Math_fround(f81 * Math_fround(Math_fround(f87 * f79) - Math_fround(f77 * f83))))) * Math_fround(2.0));
   f105 = Math_fround(Math_fround(Math_fround(Math_fround(f80 * f83) + Math_fround(f81 * Math_fround(Math_fround(f77 * f88) - Math_fround(f82 * f79)))) + Math_fround(f87 * f78)) * Math_fround(2.0));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f77 * f78) + Math_fround(Math_fround(f79 * f80) + Math_fround(f81 * Math_fround(Math_fround(f82 * f83) - Math_fround(f87 * f88))))) * Math_fround(2.0));
   HEAPF32[i5 >> 2] = f89;
   HEAPF32[i6 >> 2] = f105;
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i129, i130, i123, i131);
  } else {
   __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj(i129, i130, i4);
   i134 = HEAP32[i129 + 44 >> 2] | 0;
   f83 = Math_fround(HEAPF32[i134 + 32 >> 2]);
   f87 = Math_fround(HEAPF32[i134 + 36 >> 2]);
   f105 = Math_fround(HEAPF32[i134 + 40 >> 2]);
   f88 = Math_fround(f83 * Math_fround(HEAPF32[i97 >> 2]));
   f88 = Math_fround(f88 + Math_fround(f87 * Math_fround(HEAPF32[i11 >> 2])));
   f88 = Math_fround(f88 + Math_fround(f105 * Math_fround(HEAPF32[i84 >> 2])));
   f89 = Math_fround(f83 * Math_fround(HEAPF32[i9 >> 2]));
   f89 = Math_fround(f89 + Math_fround(f87 * Math_fround(HEAPF32[i26 >> 2])));
   f89 = Math_fround(f89 + Math_fround(f105 * Math_fround(HEAPF32[i85 >> 2])));
   f83 = Math_fround(f83 * Math_fround(HEAPF32[i10 >> 2]));
   f87 = Math_fround(f83 + Math_fround(f87 * Math_fround(HEAPF32[i28 >> 2])));
   f105 = Math_fround(f87 + Math_fround(f105 * Math_fround(HEAPF32[i86 >> 2])));
   HEAPF32[i98 >> 2] = f88;
   HEAPF32[i98 + 4 >> 2] = f89;
   HEAPF32[i98 + 8 >> 2] = f105;
   HEAPF32[i98 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_15PsMatTransformVE(i129, i130, i98, i97);
  }
  i134 = 1;
  STACKTOP = i132;
  return i134 | 0;
 } while (0);
 i134 = 0;
 STACKTOP = i132;
 return i134 | 0;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fEclEv(i206) {
 i206 = i206 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, f211 = f0, f212 = f0, f213 = f0, f214 = f0, f215 = f0, f216 = f0, f217 = f0, f218 = f0, f219 = f0, i220 = 0;
 i210 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i205 = i210 + 416 | 0;
 i171 = i210 + 480 | 0;
 i199 = i210 + 392 | 0;
 i190 = i210 + 368 | 0;
 i173 = i210 + 364 | 0;
 i178 = i210 + 360 | 0;
 i179 = i210 + 356 | 0;
 i180 = i210 + 352 | 0;
 i174 = i210 + 348 | 0;
 i175 = i210 + 344 | 0;
 i176 = i210 + 340 | 0;
 i177 = i210 + 336 | 0;
 i200 = i210 + 312 | 0;
 i189 = i210 + 288 | 0;
 i172 = i210 + 256 | 0;
 i181 = i210 + 252 | 0;
 i186 = i210 + 248 | 0;
 i187 = i210 + 244 | 0;
 i188 = i210 + 240 | 0;
 i182 = i210 + 236 | 0;
 i183 = i210 + 232 | 0;
 i184 = i210 + 228 | 0;
 i185 = i210 + 224 | 0;
 i143 = i210 + 220 | 0;
 i159 = i210 + 216 | 0;
 i165 = i210 + 212 | 0;
 i149 = i210 + 208 | 0;
 i150 = i210 + 204 | 0;
 i151 = i210 + 200 | 0;
 i152 = i210 + 196 | 0;
 i153 = i210 + 192 | 0;
 i193 = i210 + 176 | 0;
 i146 = i210 + 172 | 0;
 i157 = i210 + 168 | 0;
 i162 = i210 + 164 | 0;
 i169 = i210 + 160 | 0;
 i145 = i210 + 156 | 0;
 i156 = i210 + 152 | 0;
 i161 = i210 + 148 | 0;
 i168 = i210 + 144 | 0;
 i191 = i210 + 128 | 0;
 i144 = i210 + 124 | 0;
 i155 = i210 + 120 | 0;
 i160 = i210 + 116 | 0;
 i167 = i210 + 112 | 0;
 i201 = i210 + 108 | 0;
 i202 = i210 + 104 | 0;
 i203 = i210 + 100 | 0;
 i204 = i210 + 96 | 0;
 i194 = i210 + 80 | 0;
 i195 = i210 + 72 | 0;
 i196 = i210 + 68 | 0;
 i197 = i210 + 64 | 0;
 i198 = i210 + 48 | 0;
 i192 = i210 + 32 | 0;
 i148 = i210 + 28 | 0;
 i158 = i210 + 24 | 0;
 i164 = i210 + 20 | 0;
 i170 = i210 + 16 | 0;
 i147 = i210 + 12 | 0;
 i154 = i210 + 8 | 0;
 i163 = i210 + 4 | 0;
 i166 = i210;
 HEAP32[i206 + 140 >> 2] = 0;
 HEAP32[i206 + 136 >> 2] = 0;
 i209 = i206 + 128 | 0;
 i4 = HEAP32[i209 >> 2] | 0;
 i2 = i206 + 120 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 << 1;
 if (!i1) {
  i5 = 0;
  i1 = i3;
  i2 = i4;
 } else {
  i208 = i4 + 8 | 0;
  i5 = (HEAP32[i208 >> 2] | 0) + 23 & -16;
  i142 = i5 + -8 | 0;
  i207 = i4 + 12 | 0;
  HEAP32[i142 >> 2] = HEAP32[i207 >> 2];
  HEAP32[i5 + -4 >> 2] = i1 & 2147483646;
  HEAP32[i207 >> 2] = i142;
  HEAP32[i208 >> 2] = i5 + i1;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i209 >> 2] | 0;
 }
 i208 = i206 + 104 | 0;
 HEAP32[i208 >> 2] = i5;
 i1 = i1 << 2;
 if (!i1) i1 = 0; else {
  i142 = i2 + 8 | 0;
  i207 = (HEAP32[i142 >> 2] | 0) + 23 & -16;
  i141 = i207 + -8 | 0;
  i2 = i2 + 12 | 0;
  HEAP32[i141 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i207 + -4 >> 2] = i1 & 2147483644;
  HEAP32[i2 >> 2] = i141;
  HEAP32[i142 >> 2] = i207 + i1;
  i1 = i207;
  i2 = HEAP32[i209 >> 2] | 0;
 }
 i207 = i206 + 108 | 0;
 HEAP32[i207 >> 2] = i1;
 i142 = i206 + 100 | 0;
 i1 = HEAP32[i142 >> 2] << 2;
 if (!i1) i1 = 0; else {
  i140 = i2 + 8 | 0;
  i141 = (HEAP32[i140 >> 2] | 0) + 23 & -16;
  i138 = i141 + -8 | 0;
  i139 = i2 + 12 | 0;
  HEAP32[i138 >> 2] = HEAP32[i139 >> 2];
  HEAP32[i141 + -4 >> 2] = i1 & 2147483644;
  HEAP32[i139 >> 2] = i138;
  HEAP32[i140 >> 2] = i141 + i1;
  i1 = i141;
 }
 i140 = i206 + 116 | 0;
 HEAP32[i140 >> 2] = i1;
 i141 = i206 + 92 | 0;
 if (HEAP32[i141 >> 2] | 0) {
  i100 = i206 + 96 | 0;
  i101 = i206 + 32 | 0;
  i102 = i206 + 36 | 0;
  i103 = i206 + 40 | 0;
  i104 = i206 + 44 | 0;
  i105 = i206 + 124 | 0;
  i106 = i205 + 4 | 0;
  i107 = i206 + 112 | 0;
  i108 = i205 + 4 | 0;
  i109 = i205 + 8 | 0;
  i110 = i205 + 12 | 0;
  i111 = i205 + 48 | 0;
  i112 = i205 + 52 | 0;
  i113 = i205 + 56 | 0;
  i114 = i205 + 60 | 0;
  i115 = i205 + 16 | 0;
  i116 = i205 + 20 | 0;
  i117 = i205 + 24 | 0;
  i118 = i205 + 28 | 0;
  i119 = i205 + 32 | 0;
  i120 = i205 + 36 | 0;
  i121 = i205 + 40 | 0;
  i122 = i205 + 44 | 0;
  i123 = i193 + 4 | 0;
  i124 = i193 + 8 | 0;
  i125 = i193 + 12 | 0;
  i126 = i191 + 4 | 0;
  i127 = i191 + 8 | 0;
  i128 = i191 + 12 | 0;
  i129 = i194 + 4 | 0;
  i130 = i194 + 8 | 0;
  i131 = i194 + 12 | 0;
  i132 = i192 + 4 | 0;
  i133 = i192 + 8 | 0;
  i134 = i192 + 12 | 0;
  i135 = i198 + 4 | 0;
  i136 = i198 + 8 | 0;
  i137 = i198 + 12 | 0;
  i138 = i200 + 4 | 0;
  i75 = i200 + 8 | 0;
  i76 = i200 + 12 | 0;
  i77 = i200 + 16 | 0;
  i78 = i200 + 20 | 0;
  i79 = i172 + 4 | 0;
  i80 = i172 + 8 | 0;
  i81 = i172 + 12 | 0;
  i82 = i172 + 16 | 0;
  i83 = i172 + 20 | 0;
  i84 = i172 + 24 | 0;
  i85 = i189 + 4 | 0;
  i86 = i189 + 8 | 0;
  i87 = i189 + 12 | 0;
  i88 = i189 + 16 | 0;
  i89 = i189 + 20 | 0;
  i90 = i199 + 4 | 0;
  i91 = i199 + 8 | 0;
  i92 = i199 + 12 | 0;
  i93 = i199 + 16 | 0;
  i94 = i199 + 20 | 0;
  i95 = i190 + 4 | 0;
  i96 = i190 + 8 | 0;
  i97 = i190 + 12 | 0;
  i98 = i190 + 16 | 0;
  i99 = i190 + 20 | 0;
  i1 = 0;
  i139 = 0;
  do {
   i64 = HEAP32[i100 >> 2] | 0;
   i30 = HEAP32[i142 >> 2] | 0;
   i29 = HEAP32[i101 >> 2] | 0;
   f65 = Math_fround(HEAPF32[i102 >> 2]);
   f66 = Math_fround(HEAPF32[i103 >> 2]);
   f67 = Math_fround(HEAPF32[i104 >> 2]);
   i68 = HEAP32[i208 >> 2] | 0;
   i69 = HEAP32[i207 >> 2] | 0;
   i70 = HEAP32[i140 >> 2] | 0;
   i71 = HEAP32[i105 >> 2] | 0;
   i74 = HEAP32[i209 >> 2] | 0;
   i23 = i30 * 76 | 0;
   i72 = (i23 | 0) / 76 | 0;
   i2 = i72 << 5;
   i30 = (i30 | 0) == 0;
   if (i30) {
    i63 = 0;
    i62 = 0;
    i73 = 0;
    f11 = Math_fround(-3402823469999999843913219.0e14);
    f16 = Math_fround(3402823469999999843913219.0e14);
    f15 = Math_fround(-3402823469999999843913219.0e14);
    f12 = Math_fround(3402823469999999843913219.0e14);
    f10 = Math_fround(-3402823469999999843913219.0e14);
    f7 = Math_fround(3402823469999999843913219.0e14);
    i61 = 0;
    i60 = 0;
    i59 = 0;
   } else {
    i3 = i74 + 8 | 0;
    i21 = (HEAP32[i3 >> 2] | 0) + 23 & -16;
    i19 = i21;
    i20 = i19 + -8 | 0;
    i5 = i74 + 12 | 0;
    HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
    i4 = i2 & 2147483616;
    HEAP32[i19 + -4 >> 2] = i4;
    i22 = i19 + i2 + 23 & -16;
    i13 = i22;
    i8 = i13 + -8 | 0;
    HEAP32[i8 >> 2] = i20;
    HEAP32[i13 + -4 >> 2] = i4;
    i4 = i72 << 2;
    i20 = i13 + i2 + 23 & -16;
    i14 = i20;
    i6 = i14 + -8 | 0;
    HEAP32[i6 >> 2] = i8;
    HEAP32[i14 + -4 >> 2] = i4 & 2147483644;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i3 >> 2] = i14 + i4;
    f17 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i3 = 2139095039;
    i4 = 2139095039;
    i5 = 2139095039;
    i6 = -8388609;
    i8 = -8388609;
    i2 = -8388609;
    i9 = 0;
    while (1) {
     f54 = Math_fround(f17 + Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 56 >> 2]));
     f55 = Math_fround(f17 + Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 60 >> 2]));
     f56 = Math_fround(f17 + Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 64 >> 2]));
     f12 = Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 44 >> 2]);
     f10 = Math_fround(f12 - f54);
     f16 = Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 48 >> 2]);
     f15 = Math_fround(f16 - f55);
     f11 = Math_fround(HEAPF32[i64 + (i9 * 76 | 0) + 52 >> 2]);
     f7 = Math_fround(f11 - f56);
     f12 = Math_fround(f54 + f12);
     f16 = Math_fround(f55 + f16);
     f11 = Math_fround(f56 + f11);
     HEAPF32[i199 >> 2] = f10;
     HEAPF32[i90 >> 2] = f15;
     HEAPF32[i91 >> 2] = f7;
     HEAPF32[i92 >> 2] = f12;
     HEAPF32[i93 >> 2] = f16;
     HEAPF32[i94 >> 2] = f11;
     __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i190, i64 + (i9 * 76 | 0) + 16 | 0, i199);
     i59 = HEAP32[i190 >> 2] | 0;
     i60 = HEAP32[i95 >> 2] | 0;
     i61 = HEAP32[i96 >> 2] | 0;
     i62 = HEAP32[i97 >> 2] | 0;
     i63 = HEAP32[i98 >> 2] | 0;
     i73 = HEAP32[i99 >> 2] | 0;
     HEAP32[i20 + (i9 << 2) >> 2] = i9;
     HEAP32[i21 + (i9 << 5) >> 2] = i59;
     HEAP32[i21 + (i9 << 5) + 4 >> 2] = i60;
     HEAP32[i21 + (i9 << 5) + 8 >> 2] = i61;
     HEAP32[i21 + (i9 << 5) + 12 >> 2] = 0;
     HEAP32[i21 + (i9 << 5) + 16 >> 2] = i62;
     HEAP32[i21 + (i9 << 5) + 20 >> 2] = i63;
     HEAP32[i21 + (i9 << 5) + 24 >> 2] = i73;
     HEAP32[i21 + (i9 << 5) + 28 >> 2] = 0;
     f11 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f16 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f16 = f11 < f16 ? f11 : f16;
     f11 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = f11 < f12 ? f11 : f12;
     f11 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f7 = f11 < f7 ? f11 : f7;
     f11 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f11 = f11 < f15 ? f15 : f11;
     f15 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f10 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = f15 < f10 ? f10 : f15;
     f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f56 = (HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f10 = f10 < f56 ? f56 : f10;
     i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= i72 >>> 0) break; else i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    }
    i63 = i13;
    i62 = i14;
    i73 = i19;
    i61 = i20;
    i60 = i21;
    i59 = i22;
   }
   f54 = Math_fround(f11 - f16);
   f55 = Math_fround(f15 - f12);
   f56 = Math_fround(f10 - f7);
   i58 = f54 > f55 ? (f54 > f56 ? 0 : 2) : f55 > f56 ? 1 : 2;
   HEAP8[i106 >> 0] = 0;
   HEAP32[i205 >> 2] = i171;
   if ((i23 | 0) > 76) {
    i3 = 0;
    i2 = i171;
    i24 = 32;
    i6 = 0;
    i5 = 0;
    i4 = i72 + -1 | 0;
    L22 : while (1) {
     i13 = i6;
     while (1) {
      if ((i4 | 0) > (i5 | 0)) {
       if ((i4 - i5 | 0) >>> 0 >= 5) break;
       do {
        i9 = i5;
        i5 = i5 + 1 | 0;
        i8 = i5;
        i6 = i9;
        while (1) {
         f56 = Math_fround(HEAPF32[i60 + (HEAP32[i61 + (i8 << 2) >> 2] << 5) + (i58 << 2) >> 2]);
         i57 = f56 < Math_fround(HEAPF32[i60 + (HEAP32[i61 + (i6 << 2) >> 2] << 5) + (i58 << 2) >> 2]);
         i6 = i57 ? i8 : i6;
         if ((i8 | 0) < (i4 | 0)) i8 = i8 + 1 | 0; else break;
        }
        if ((i6 | 0) != (i9 | 0)) {
         i44 = i61 + (i6 << 2) | 0;
         i57 = i61 + (i9 << 2) | 0;
         i45 = HEAP32[i44 >> 2] | 0;
         HEAP32[i44 >> 2] = HEAP32[i57 >> 2];
         HEAP32[i57 >> 2] = i45;
        }
       } while ((i5 | 0) != (i4 | 0));
      }
      if (!i13) break L22;
      i57 = i13 + -2 | 0;
      i4 = HEAP32[i2 + (i13 + -1 << 2) >> 2] | 0;
      i5 = HEAP32[i2 + (i57 << 2) >> 2] | 0;
      i13 = i57;
     }
     i20 = i61 + (((i4 + i5 | 0) / 2 | 0) << 2) | 0;
     i6 = HEAP32[i20 >> 2] | 0;
     i14 = i61 + (i5 << 2) | 0;
     i8 = HEAP32[i14 >> 2] | 0;
     f56 = Math_fround(HEAPF32[i60 + (i6 << 5) + (i58 << 2) >> 2]);
     f7 = Math_fround(HEAPF32[i60 + (i8 << 5) + (i58 << 2) >> 2]);
     if (f56 < f7) {
      HEAP32[i14 >> 2] = i6;
      HEAP32[i20 >> 2] = i8;
      i9 = HEAP32[i14 >> 2] | 0;
      f7 = Math_fround(HEAPF32[i60 + (i9 << 5) + (i58 << 2) >> 2]);
      i6 = i8;
     } else i9 = i8;
     i19 = i61 + (i4 << 2) | 0;
     i8 = HEAP32[i19 >> 2] | 0;
     f10 = Math_fround(HEAPF32[i60 + (i8 << 5) + (i58 << 2) >> 2]);
     if (f10 < f7) {
      HEAP32[i14 >> 2] = i8;
      HEAP32[i19 >> 2] = i9;
      i6 = HEAP32[i20 >> 2] | 0;
      i8 = i9;
     } else f7 = f10;
     if (f7 < Math_fround(HEAPF32[i60 + (i6 << 5) + (i58 << 2) >> 2])) {
      HEAP32[i20 >> 2] = i8;
      HEAP32[i19 >> 2] = i6;
      i6 = HEAP32[i20 >> 2] | 0;
     }
     i14 = i4 + -1 | 0;
     i23 = i61 + (i14 << 2) | 0;
     HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i23 >> 2] = i6;
     i8 = i5;
     while (1) {
      f7 = Math_fround(HEAPF32[i60 + (i6 << 5) + (i58 << 2) >> 2]);
      i20 = i8;
      while (1) {
       i8 = i20 + 1 | 0;
       i19 = i61 + (i8 << 2) | 0;
       i9 = HEAP32[i19 >> 2] | 0;
       if (Math_fround(HEAPF32[i60 + (i9 << 5) + (i58 << 2) >> 2]) < f7) i20 = i8; else {
        i21 = i19;
        i22 = i20;
        break;
       }
      }
      do {
       i14 = i14 + -1 | 0;
       i20 = i61 + (i14 << 2) | 0;
       i19 = HEAP32[i20 >> 2] | 0;
      } while (f7 < Math_fround(HEAPF32[i60 + (i19 << 5) + (i58 << 2) >> 2]));
      if ((i8 | 0) >= (i14 | 0)) {
       i14 = i21;
       break;
      }
      HEAP32[i21 >> 2] = i19;
      HEAP32[i20 >> 2] = i9;
      i6 = HEAP32[i23 >> 2] | 0;
     }
     HEAP32[i14 >> 2] = i6;
     HEAP32[i23 >> 2] = i9;
     if ((i8 - i5 | 0) < (i4 - i8 | 0)) {
      if (i13 >>> 0 < (i24 + -1 | 0) >>> 0) i8 = i24; else {
       i6 = i24 << 3;
       if (!i6) i6 = 0; else {
        i45 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        i44 = HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0;
        i57 = _PxGetFoundation() | 0;
        i57 = mftCall_ii(HEAP32[(HEAP32[i57 >> 2] | 0) + 24 >> 2] | 0, i57 | 0) | 0;
        i6 = mftCall_iiiiii(i44 | 0, i45 | 0, i6 | 0, (i57 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
       }
       _memcpy(i6 | 0, i2 | 0, i13 << 2 | 0) | 0;
       if (!(i3 << 24 >> 24 == 0 | (i2 | 0) == 0)) {
        i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i57 >> 2] | 0) + 12 >> 2] | 0, i57 | 0, i2 | 0);
       }
       i3 = 1;
       i8 = i24 << 1;
       i2 = i6;
      }
      HEAP32[i2 + (i13 << 2) >> 2] = i5;
      HEAP32[i2 + (i13 + 1 << 2) >> 2] = i22;
      i6 = i8;
      i5 = i22 + 2 | 0;
     } else {
      i9 = i22 + 2 | 0;
      if (i13 >>> 0 < (i24 + -1 | 0) >>> 0) i6 = i24; else {
       i6 = i24 << 3;
       if (!i6) i8 = 0; else {
        i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        i45 = HEAP32[(HEAP32[i57 >> 2] | 0) + 8 >> 2] | 0;
        i8 = _PxGetFoundation() | 0;
        i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
        i8 = mftCall_iiiiii(i45 | 0, i57 | 0, i6 | 0, (i8 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
       }
       _memcpy(i8 | 0, i2 | 0, i13 << 2 | 0) | 0;
       if (!(i3 << 24 >> 24 == 0 | (i2 | 0) == 0)) {
        i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i57 >> 2] | 0) + 12 >> 2] | 0, i57 | 0, i2 | 0);
       }
       i3 = 1;
       i6 = i24 << 1;
       i2 = i8;
      }
      HEAP32[i2 + (i13 << 2) >> 2] = i9;
      HEAP32[i2 + (i13 + 1 << 2) >> 2] = i4;
      i4 = i22;
     }
     i24 = i6;
     i6 = i13 + 2 | 0;
    }
    if (!(i3 << 24 >> 24 == 0 | (i2 | 0) == 0)) {
     i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i57 >> 2] | 0) + 12 >> 2] | 0, i57 | 0, i2 | 0);
    }
   }
   if (HEAP8[i106 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i205, HEAP32[i205 >> 2] | 0);
   if (i30) {
    i22 = -8388609;
    i21 = 2139095039;
    i20 = -8388609;
    i19 = 2139095039;
    i14 = -8388609;
    i13 = 2139095039;
    i9 = -8388609;
    i8 = 2139095039;
    i6 = 0;
   } else {
    f56 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i9 = -8388609;
    i14 = -8388609;
    i20 = -8388609;
    i22 = -8388609;
    i8 = 2139095039;
    i13 = 2139095039;
    i19 = 2139095039;
    i21 = 2139095039;
    i57 = 0;
    i6 = 0;
    do {
     i35 = i61 + (i57 << 2) | 0;
     i37 = HEAP32[i35 >> 2] | 0;
     i36 = i64 + (i37 * 76 | 0) | 0;
     i3 = i64 + (i37 * 76 | 0) + 44 | 0;
     f53 = Math_fround(HEAPF32[i3 >> 2]);
     f52 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     f47 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     f50 = Math_fround(HEAPF32[i3 + 12 >> 2]);
     i3 = i64 + (i37 * 76 | 0) + 56 | 0;
     f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     f18 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     f10 = Math_fround(f56 + f50);
     f25 = Math_fround(f65 + f25);
     f18 = Math_fround(f66 + f18);
     f17 = Math_fround(f67 + Math_fround(HEAPF32[i3 + 12 >> 2]));
     f55 = Math_fround(f52 - f25);
     f49 = Math_fround(f47 - f18);
     f48 = Math_fround(f50 - f17);
     HEAPF32[i173 >> 2] = Math_fround(f53 - f10);
     HEAPF32[i178 >> 2] = f55;
     HEAPF32[i179 >> 2] = f49;
     HEAPF32[i180 >> 2] = f48;
     f25 = Math_fround(f52 + f25);
     f18 = Math_fround(f47 + f18);
     f17 = Math_fround(f50 + f17);
     HEAPF32[i174 >> 2] = Math_fround(f53 + f10);
     HEAPF32[i175 >> 2] = f25;
     HEAPF32[i176 >> 2] = f18;
     HEAPF32[i177 >> 2] = f17;
     f17 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 16 >> 2]);
     f18 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 20 >> 2]);
     f25 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 24 >> 2]);
     f10 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 28 >> 2]);
     f53 = Math_fround(f17 + f17);
     f50 = Math_fround(f18 + f18);
     f47 = Math_fround(f25 + f25);
     f52 = Math_fround(f18 * f50);
     f48 = Math_fround(f25 * f47);
     f49 = Math_fround(f53 * f18);
     f55 = Math_fround(f53 * f25);
     f51 = Math_fround(f53 * f10);
     f54 = Math_fround(f50 * f25);
     f50 = Math_fround(f50 * f10);
     f47 = Math_fround(f47 * f10);
     f27 = Math_fround(Math_fround(Math_fround(1.0) - f52) - f48);
     f28 = Math_fround(f49 + f47);
     f46 = Math_fround(f55 - f50);
     f47 = Math_fround(f49 - f47);
     f53 = Math_fround(Math_fround(1.0) - Math_fround(f17 * f53));
     f48 = Math_fround(f53 - f48);
     f49 = Math_fround(f54 + f51);
     f50 = Math_fround(f55 + f50);
     f51 = Math_fround(f54 - f51);
     f52 = Math_fround(f53 - f52);
     f53 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 32 >> 2]);
     f54 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 36 >> 2]);
     f55 = Math_fround(HEAPF32[i64 + (i37 * 76 | 0) + 40 >> 2]);
     f7 = Math_fround(f53 * Math_fround(-2.0));
     f26 = Math_fround(f54 * Math_fround(-2.0));
     f211 = Math_fround(f55 * Math_fround(-2.0));
     f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
     f16 = Math_fround(Math_fround(Math_fround(f17 * f7) + Math_fround(f18 * f26)) + Math_fround(f25 * f211));
     f12 = Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f7 * f11) - Math_fround(f10 * Math_fround(Math_fround(f18 * f211) - Math_fround(f25 * f26)))));
     f15 = Math_fround(Math_fround(f18 * f16) + Math_fround(Math_fround(f11 * f26) - Math_fround(f10 * Math_fround(Math_fround(f25 * f7) - Math_fround(f17 * f211)))));
     f16 = Math_fround(Math_fround(Math_fround(f11 * f211) - Math_fround(f10 * Math_fround(Math_fround(f17 * f26) - Math_fround(f18 * f7)))) + Math_fround(f25 * f16));
     f17 = Math_fround(-f17);
     f18 = Math_fround(-f18);
     f25 = Math_fround(-f25);
     i3 = HEAP32[i35 >> 2] | 0;
     f7 = Math_fround(HEAPF32[i60 + (i3 << 5) + (i58 << 2) >> 2]);
     f26 = Math_fround(HEAPF32[i60 + (i3 << 5) + 16 + (i58 << 2) >> 2]);
     L90 : do if (!i57) i2 = 0; else if (f26 > f7) {
      i2 = i57;
      do {
       i2 = i2 + -1 | 0;
       if (!i2) {
        i2 = 0;
        break L90;
       }
      } while (Math_fround(HEAPF32[i60 + (HEAP32[i61 + (i2 << 2) >> 2] << 5) + 16 + (i58 << 2) >> 2]) > f7);
     } else i2 = i57; while (0);
     if (i2 >>> 0 < i72 >>> 0) {
      i34 = i64 + (i37 * 76 | 0) + 72 | 0;
      i33 = i2;
      i3 = 0;
      i2 = 0;
      L98 : do {
       do if ((i57 | 0) != (i33 | 0)) {
        i4 = i61 + (i33 << 2) | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        if (Math_fround(HEAPF32[i60 + (i5 << 5) + (i58 << 2) >> 2]) > f26) break L98;
        if (mftCall_iii(i71 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i64 + (i5 * 76 | 0) + 72 >> 2] | 0) | 0) {
         i2 = 1 << HEAP32[i4 >> 2] | i2;
         f215 = Math_fround(f56 + Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 56 >> 2]));
         f216 = Math_fround(f56 + Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 60 >> 2]));
         f213 = Math_fround(f56 + Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 64 >> 2]));
         f219 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 44 >> 2]);
         f7 = Math_fround(f219 - f215);
         f217 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 48 >> 2]);
         f212 = Math_fround(f217 - f216);
         f218 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 52 >> 2]);
         f211 = Math_fround(f218 - f213);
         f219 = Math_fround(f215 + f219);
         f217 = Math_fround(f216 + f217);
         f218 = Math_fround(f213 + f218);
         HEAPF32[i200 >> 2] = f7;
         HEAPF32[i138 >> 2] = f212;
         HEAPF32[i75 >> 2] = f211;
         HEAPF32[i76 >> 2] = f219;
         HEAPF32[i77 >> 2] = f217;
         HEAPF32[i78 >> 2] = f218;
         f218 = Math_fround(Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 32 >> 2]) * Math_fround(2.0));
         f217 = Math_fround(Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 36 >> 2]) * Math_fround(2.0));
         f219 = Math_fround(Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 40 >> 2]) * Math_fround(2.0));
         f211 = Math_fround(Math_fround(Math_fround(f218 * f17) + Math_fround(f217 * f18)) + Math_fround(f219 * f25));
         f212 = Math_fround(f12 + Math_fround(Math_fround(f211 * f17) + Math_fround(Math_fround(f11 * f218) + Math_fround(f10 * Math_fround(Math_fround(f219 * f18) - Math_fround(f217 * f25))))));
         f7 = Math_fround(f15 + Math_fround(Math_fround(f211 * f18) + Math_fround(Math_fround(f11 * f217) + Math_fround(f10 * Math_fround(Math_fround(f218 * f25) - Math_fround(f219 * f17))))));
         f211 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f11 * f219) + Math_fround(f10 * Math_fround(Math_fround(f217 * f17) - Math_fround(f218 * f18)))) + Math_fround(f211 * f25)));
         f218 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 16 >> 2]);
         f217 = Math_fround(f10 * f218);
         f219 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 28 >> 2]);
         f217 = Math_fround(f217 + Math_fround(f219 * f17));
         f213 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 24 >> 2]);
         f217 = Math_fround(f217 + Math_fround(f213 * f18));
         f216 = Math_fround(HEAPF32[i64 + (i5 * 76 | 0) + 20 >> 2]);
         f215 = Math_fround(Math_fround(Math_fround(f218 * f25) + Math_fround(Math_fround(f219 * f18) + Math_fround(f10 * f216))) - Math_fround(f213 * f17));
         f214 = Math_fround(Math_fround(Math_fround(f216 * f17) + Math_fround(Math_fround(f219 * f25) + Math_fround(f10 * f213))) - Math_fround(f218 * f18));
         f213 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f219) - Math_fround(f218 * f17)) - Math_fround(f216 * f18)) - Math_fround(f213 * f25));
         HEAPF32[i172 >> 2] = Math_fround(f217 - Math_fround(f216 * f25));
         HEAPF32[i79 >> 2] = f215;
         HEAPF32[i80 >> 2] = f214;
         HEAPF32[i81 >> 2] = f213;
         HEAPF32[i82 >> 2] = f212;
         HEAPF32[i83 >> 2] = f7;
         HEAPF32[i84 >> 2] = f211;
         __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i189, i172, i200);
         i4 = HEAP32[i189 >> 2] | 0;
         i5 = HEAP32[i85 >> 2] | 0;
         i23 = HEAP32[i86 >> 2] | 0;
         HEAP32[i181 >> 2] = i4;
         HEAP32[i186 >> 2] = i5;
         HEAP32[i187 >> 2] = i23;
         HEAP32[i188 >> 2] = 0;
         i29 = HEAP32[i87 >> 2] | 0;
         i30 = HEAP32[i88 >> 2] | 0;
         i31 = HEAP32[i89 >> 2] | 0;
         HEAP32[i182 >> 2] = i29;
         HEAP32[i183 >> 2] = i30;
         HEAP32[i184 >> 2] = i31;
         HEAP32[i185 >> 2] = 0;
         f211 = Math_fround(HEAPF32[i173 >> 2]);
         i4 = f211 < (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f211 = Math_fround(HEAPF32[i178 >> 2]);
         i5 = f211 < (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f211 = Math_fround(HEAPF32[i179 >> 2]);
         i23 = f211 < (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         i24 = Math_fround(HEAPF32[i180 >> 2]) < Math_fround(0.0);
         f211 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         i29 = f211 < Math_fround(HEAPF32[i174 >> 2]);
         f211 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         i30 = f211 < Math_fround(HEAPF32[i175 >> 2]);
         f211 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         i31 = f211 < Math_fround(HEAPF32[i176 >> 2]);
         i32 = Math_fround(HEAPF32[i177 >> 2]) > Math_fround(0.0);
         i39 = HEAP32[gb + 1097600 >> 2] | 0;
         i41 = HEAP32[gb + 1097600 + 4 >> 2] | 0;
         i43 = HEAP32[gb + 1097600 + 8 >> 2] | 0;
         i45 = HEAP32[gb + 1097600 + 12 >> 2] | 0;
         i38 = HEAP32[gb + 1097616 >> 2] | 0;
         i40 = HEAP32[gb + 1097616 + 4 >> 2] | 0;
         i42 = HEAP32[gb + 1097616 + 8 >> 2] | 0;
         i44 = HEAP32[gb + 1097616 + 12 >> 2] | 0;
         i4 = i38 & -8388609 | i39 & HEAP32[(i4 ? i181 : i173) >> 2];
         i5 = i40 & -8388609 | i41 & HEAP32[(i5 ? i186 : i178) >> 2];
         i23 = i42 & -8388609 | i43 & HEAP32[(i23 ? i187 : i179) >> 2];
         i24 = i44 & -8388609 | i45 & HEAP32[(i24 ? i188 : i180) >> 2];
         i29 = i38 & 2139095039 | i39 & HEAP32[(i29 ? i182 : i174) >> 2];
         i30 = i40 & 2139095039 | i41 & HEAP32[(i30 ? i183 : i175) >> 2];
         i31 = i42 & 2139095039 | i43 & HEAP32[(i31 ? i184 : i176) >> 2];
         i32 = i44 & 2139095039 | i45 & HEAP32[(i32 ? i185 : i177) >> 2];
         f211 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f211 > (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]))) break;
         f219 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f219 > (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]))) break;
         f219 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f219 > (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]))) break;
         f219 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f219 > (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]))) break;
         HEAP32[i59 + (i3 << 5) >> 2] = i4;
         HEAP32[i59 + (i3 << 5) + 4 >> 2] = i5;
         HEAP32[i59 + (i3 << 5) + 8 >> 2] = i23;
         HEAP32[i59 + (i3 << 5) + 12 >> 2] = i24;
         HEAP32[i59 + (i3 << 5) + 16 >> 2] = i29;
         HEAP32[i59 + (i3 << 5) + 20 >> 2] = i30;
         HEAP32[i59 + (i3 << 5) + 24 >> 2] = i31;
         HEAP32[i59 + (i3 << 5) + 28 >> 2] = i32;
         i3 = i3 + 1 | 0;
        }
       } while (0);
       i33 = i33 + 1 | 0;
      } while (i33 >>> 0 < i72 >>> 0);
      i4 = HEAP32[i35 >> 2] | 0;
     } else {
      i4 = i3;
      i3 = 0;
      i2 = 0;
     }
     HEAP32[i70 + (i4 << 2) >> 2] = i2;
     i43 = HEAP32[i36 >> 2] | 0;
     i44 = HEAP32[i64 + (i37 * 76 | 0) + 4 >> 2] | 0;
     f15 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i64 + (i4 * 76 | 0) + 68 >> 2]));
     i45 = i64 + (i37 * 76 | 0) + 8 | 0;
     i2 = HEAP32[i45 >> 2] | 0;
     if (i2) {
      i39 = i64 + (i37 * 76 | 0) + 12 | 0;
      i40 = HEAP32[i39 >> 2] | 0;
      i41 = (i40 | 0) == 0;
      i42 = i59 + (i3 << 5) | 0;
      i38 = (i3 | 0) == 0;
      i37 = i4 & 65535;
      i36 = 0;
      do {
       if (i41) {
        i35 = i36;
        i4 = i43 + (i36 << 4) | 0;
        i5 = i36;
       } else {
        i5 = HEAP32[i40 + (i36 << 2) >> 2] | 0;
        i3 = HEAP32[i39 >> 2] | 0;
        i4 = i43 + (i5 << 4) | 0;
        if (!i3) i35 = i36; else i35 = HEAP32[i3 + (i36 << 2) >> 2] | 0;
       }
       i3 = i44 + (i35 << 4) | 0;
       i23 = HEAP32[i4 >> 2] | 0;
       i24 = i43 + (i5 << 4) + 4 | 0;
       i29 = HEAP32[i24 >> 2] | 0;
       i30 = i43 + (i5 << 4) + 8 | 0;
       i31 = HEAP32[i30 >> 2] | 0;
       i32 = i43 + (i5 << 4) + 12 | 0;
       i33 = HEAP32[i32 >> 2] | 0;
       L120 : do if (!i38) {
        f7 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f10 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f11 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f12 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i34 = i59;
        L122 : while (1) {
         do if (!(Math_fround(HEAPF32[i34 >> 2]) > f7)) {
          if (Math_fround(HEAPF32[i34 + 4 >> 2]) > f10) break;
          if (Math_fround(HEAPF32[i34 + 8 >> 2]) > f11) break;
          if (Math_fround(HEAPF32[i34 + 12 >> 2]) > f12) break;
          if (f7 > Math_fround(HEAPF32[i34 + 16 >> 2])) break;
          if (f10 > Math_fround(HEAPF32[i34 + 20 >> 2])) break;
          if (f11 > Math_fround(HEAPF32[i34 + 24 >> 2])) break;
          if (!(f12 > Math_fround(HEAPF32[i34 + 28 >> 2]))) break L122;
         } while (0);
         i34 = i34 + 32 | 0;
         if ((i34 | 0) == (i42 | 0)) break L120;
        }
        f216 = Math_fround(Math_fround(Math_fround(f53 + Math_fround(f27 * f7)) + Math_fround(f47 * f10)) + Math_fround(f50 * f11));
        f219 = Math_fround(Math_fround(Math_fround(f54 + Math_fround(f28 * f7)) + Math_fround(f48 * f10)) + Math_fround(f51 * f11));
        f215 = Math_fround(Math_fround(Math_fround(f55 + Math_fround(f46 * f7)) + Math_fround(f49 * f10)) + Math_fround(f52 * f11));
        f214 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * Math_fround(0.0)) + Math_fround(1.0)) + Math_fround(f10 * Math_fround(0.0))) + Math_fround(f11 * Math_fround(0.0)));
        i220 = (HEAPF32[tempDoublePtr >> 2] = f216, HEAP32[tempDoublePtr >> 2] | 0);
        i34 = (HEAPF32[tempDoublePtr >> 2] = f219, HEAP32[tempDoublePtr >> 2] | 0);
        i2 = (HEAPF32[tempDoublePtr >> 2] = f215, HEAP32[tempDoublePtr >> 2] | 0);
        i29 = HEAP32[gb + 1097600 + 4 >> 2] & (i34 ^ i29) ^ i29;
        i2 = HEAP32[gb + 1097600 + 8 >> 2] & (i2 ^ i31) ^ i31;
        i34 = HEAP32[gb + 1097600 + 12 >> 2] & ((HEAPF32[tempDoublePtr >> 2] = f214, HEAP32[tempDoublePtr >> 2] | 0) ^ i33) ^ i33;
        HEAP32[i4 >> 2] = HEAP32[gb + 1097600 >> 2] & (i220 ^ i23) ^ i23;
        HEAP32[i24 >> 2] = i29;
        HEAP32[i30 >> 2] = i2;
        HEAP32[i32 >> 2] = i34;
        f214 = Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2]));
        i32 = i44 + (i35 << 4) + 4 | 0;
        f215 = Math_fround(f10 - Math_fround(HEAPF32[i32 >> 2]));
        i34 = i44 + (i35 << 4) + 8 | 0;
        f219 = Math_fround(f11 - Math_fround(HEAPF32[i34 >> 2]));
        i2 = i44 + (i35 << 4) + 12 | 0;
        f214 = Math_fround(f15 * f214);
        f215 = Math_fround(f15 * f215);
        f219 = Math_fround(f15 * f219);
        f216 = Math_fround(f15 * Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2])));
        i30 = (HEAPF32[tempDoublePtr >> 2] = f214, HEAP32[tempDoublePtr >> 2] | 0);
        i31 = (HEAPF32[tempDoublePtr >> 2] = f215, HEAP32[tempDoublePtr >> 2] | 0);
        i33 = (HEAPF32[tempDoublePtr >> 2] = f219, HEAP32[tempDoublePtr >> 2] | 0);
        i35 = (HEAPF32[tempDoublePtr >> 2] = f216, HEAP32[tempDoublePtr >> 2] | 0);
        f216 = Math_fround(Math_fround(Math_fround(f27 * f214) + Math_fround(f47 * f215)) + Math_fround(f50 * f219));
        f217 = Math_fround(Math_fround(Math_fround(f28 * f214) + Math_fround(f48 * f215)) + Math_fround(f51 * f219));
        f218 = Math_fround(Math_fround(Math_fround(f46 * f214) + Math_fround(f49 * f215)) + Math_fround(f52 * f219));
        f219 = Math_fround(Math_fround(Math_fround(f214 * Math_fround(0.0)) + Math_fround(f215 * Math_fround(0.0))) + Math_fround(f219 * Math_fround(0.0)));
        i29 = (HEAPF32[tempDoublePtr >> 2] = f216, HEAP32[tempDoublePtr >> 2] | 0);
        i23 = (HEAPF32[tempDoublePtr >> 2] = f217, HEAP32[tempDoublePtr >> 2] | 0);
        i24 = (HEAPF32[tempDoublePtr >> 2] = f218, HEAP32[tempDoublePtr >> 2] | 0);
        i31 = (i23 ^ i31) & HEAP32[gb + 1097600 + 4 >> 2] ^ i31;
        i33 = (i24 ^ i33) & HEAP32[gb + 1097600 + 8 >> 2] ^ i33;
        i35 = ((HEAPF32[tempDoublePtr >> 2] = f219, HEAP32[tempDoublePtr >> 2] | 0) ^ i35) & HEAP32[gb + 1097600 + 12 >> 2] ^ i35;
        HEAP32[i3 >> 2] = (i29 ^ i30) & HEAP32[gb + 1097600 >> 2] ^ i30;
        HEAP32[i32 >> 2] = i31;
        HEAP32[i34 >> 2] = i33;
        HEAP32[i2 >> 2] = i35;
        i2 = i43 + (i5 + 1 << 4) | 0;
        HEAP32[i143 >> 2] = i21;
        HEAP32[i159 >> 2] = i19;
        HEAP32[i165 >> 2] = i13;
        HEAP32[i149 >> 2] = i8;
        HEAP32[i150 >> 2] = i22;
        HEAP32[i151 >> 2] = i20;
        HEAP32[i152 >> 2] = i14;
        HEAP32[i153 >> 2] = i9;
        if ((i4 | 0) != (i2 | 0)) {
         do {
          f215 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f217 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f219 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f211 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f212 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f214 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f216 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f218 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          f213 = Math_fround(HEAPF32[i4 >> 2]);
          i21 = HEAP32[(f213 < f215 ? i4 : i143) >> 2] | 0;
          i20 = i4 + 4 | 0;
          f215 = Math_fround(HEAPF32[i20 >> 2]);
          i19 = HEAP32[(f215 < f217 ? i20 : i159) >> 2] | 0;
          i14 = i4 + 8 | 0;
          f217 = Math_fround(HEAPF32[i14 >> 2]);
          i13 = HEAP32[(f217 < f219 ? i14 : i165) >> 2] | 0;
          i9 = i4 + 12 | 0;
          f219 = Math_fround(HEAPF32[i9 >> 2]);
          i8 = HEAP32[(f219 < f211 ? i9 : i149) >> 2] | 0;
          i22 = HEAP32[(f212 < f213 ? i4 : i150) >> 2] | 0;
          i20 = HEAP32[(f214 < f215 ? i20 : i151) >> 2] | 0;
          i14 = HEAP32[(f216 < f217 ? i14 : i152) >> 2] | 0;
          i9 = HEAP32[(f218 < f219 ? i9 : i153) >> 2] | 0;
          i4 = i4 + 16 | 0;
         } while ((i4 | 0) != (i2 | 0));
         HEAP32[i143 >> 2] = i21;
         HEAP32[i159 >> 2] = i19;
         HEAP32[i165 >> 2] = i13;
         HEAP32[i149 >> 2] = i8;
         HEAP32[i150 >> 2] = i22;
         HEAP32[i151 >> 2] = i20;
         HEAP32[i152 >> 2] = i14;
         HEAP32[i153 >> 2] = i9;
        }
        HEAP16[i68 + (i6 << 1) >> 1] = i37;
        HEAP32[i69 + (i6 << 2) >> 2] = i5 << 4 >> 4;
        i2 = HEAP32[i45 >> 2] | 0;
        i6 = i6 + 1 | 0;
       } while (0);
       i36 = i36 + 1 | 0;
      } while (i36 >>> 0 < i2 >>> 0);
     }
     i57 = i57 + 1 | 0;
    } while (i57 >>> 0 < i72 >>> 0);
   }
   L142 : do if (i62 | 0) {
    i3 = i62 + -4 | 0;
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | -2147483648;
    i3 = i74 + 12 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) {
     i4 = i74 + 8 | 0;
     i5 = i2;
     while (1) {
      if ((HEAP32[i5 + 4 >> 2] | 0) >= 0) break L142;
      HEAP32[i4 >> 2] = i5;
      i2 = HEAP32[i2 >> 2] | 0;
      HEAP32[i3 >> 2] = i2;
      if (!i2) break; else i5 = i2;
     }
    }
   } while (0);
   L149 : do if (i63 | 0) {
    i3 = i63 + -4 | 0;
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | -2147483648;
    i3 = i74 + 12 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) {
     i4 = i74 + 8 | 0;
     i5 = i2;
     while (1) {
      if ((HEAP32[i5 + 4 >> 2] | 0) >= 0) break L149;
      HEAP32[i4 >> 2] = i5;
      i2 = HEAP32[i2 >> 2] | 0;
      HEAP32[i3 >> 2] = i2;
      if (!i2) break; else i5 = i2;
     }
    }
   } while (0);
   L156 : do if (i73 | 0) {
    i5 = i73 + -4 | 0;
    HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | -2147483648;
    i5 = i74 + 12 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (i2 | 0) {
     i4 = i74 + 8 | 0;
     i3 = i2;
     while (1) {
      if ((HEAP32[i2 + 4 >> 2] | 0) >= 0) break L156;
      HEAP32[i4 >> 2] = i2;
      i2 = HEAP32[i3 >> 2] | 0;
      HEAP32[i5 >> 2] = i2;
      if (!i2) break; else i3 = i2;
     }
    }
   } while (0);
   HEAP32[i107 >> 2] = i6;
   L163 : do if (i6 | 0) {
    f25 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = Math_fround(f25 - f15);
    f26 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f26 - f16);
    f27 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f27 = Math_fround(f27 - f17);
    f28 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f28 = Math_fround(f28 - f18);
    HEAPF32[i146 >> 2] = f25;
    HEAPF32[i157 >> 2] = f26;
    HEAPF32[i162 >> 2] = f27;
    HEAPF32[i169 >> 2] = f28;
    i4 = HEAP32[gb + 1097632 >> 2] | 0;
    HEAP32[i145 >> 2] = i4;
    i220 = HEAP32[gb + 1097632 + 4 >> 2] | 0;
    HEAP32[i156 >> 2] = i220;
    i24 = HEAP32[gb + 1097632 + 8 >> 2] | 0;
    HEAP32[i161 >> 2] = i24;
    i3 = HEAP32[gb + 1097632 + 12 >> 2] | 0;
    HEAP32[i168 >> 2] = i3;
    i4 = f25 < (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i4 = HEAP32[(i4 ? i145 : i146) >> 2] | 0;
    i220 = f26 < (HEAP32[tempDoublePtr >> 2] = i220, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i220 = HEAP32[(i220 ? i156 : i157) >> 2] | 0;
    i24 = f27 < (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i24 = HEAP32[(i24 ? i161 : i162) >> 2] | 0;
    i3 = f28 < (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i3 = HEAP32[(i3 ? i168 : i169) >> 2] | 0;
    HEAP32[i193 >> 2] = i4;
    HEAP32[i123 >> 2] = i220;
    HEAP32[i124 >> 2] = i24;
    HEAP32[i125 >> 2] = i3;
    f28 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f27 = (HEAP32[tempDoublePtr >> 2] = i220, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i24 = f28 > f27 ? (f28 > f26 ? 0 : 2) : f27 > f26 ? 1 : 2;
    f28 = Math_fround(f28 * Math_fround(.00395256933));
    f27 = Math_fround(f27 * Math_fround(.00395256933));
    f26 = Math_fround(f26 * Math_fround(.00395256933));
    f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.00395256933));
    HEAPF32[i144 >> 2] = f28;
    HEAPF32[i155 >> 2] = f27;
    HEAPF32[i160 >> 2] = f26;
    HEAPF32[i167 >> 2] = f25;
    i3 = Math_fround(HEAPF32[i101 >> 2]) < f28;
    i220 = Math_fround(HEAPF32[i102 >> 2]) < f27;
    i220 = HEAP32[(i220 ? i155 : i102) >> 2] | 0;
    i4 = Math_fround(HEAPF32[i103 >> 2]) < f26;
    i4 = HEAP32[(i4 ? i160 : i103) >> 2] | 0;
    i2 = Math_fround(HEAPF32[i104 >> 2]) < f25;
    i2 = HEAP32[(i2 ? i167 : i104) >> 2] | 0;
    HEAP32[i191 >> 2] = HEAP32[(i3 ? i144 : i101) >> 2];
    HEAP32[i126 >> 2] = i220;
    HEAP32[i127 >> 2] = i4;
    HEAP32[i128 >> 2] = i2;
    HEAPF32[i191 + (i24 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i193 + (i24 << 2) >> 2]) / Math_fround(65533.0));
    HEAPF32[i201 >> 2] = Math_fround(1.0);
    HEAPF32[i202 >> 2] = Math_fround(1.0);
    HEAPF32[i203 >> 2] = Math_fround(1.0);
    HEAPF32[i204 >> 2] = Math_fround(1.0);
    HEAP32[i194 >> 2] = 1132331008;
    HEAP32[i129 >> 2] = 1132331008;
    HEAP32[i130 >> 2] = 1132331008;
    HEAP32[i131 >> 2] = 1132331008;
    HEAPF32[i194 + (i24 << 2) >> 2] = Math_fround(65534.0);
    f25 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i191 >> 2]));
    f26 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i126 >> 2]));
    f27 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i127 >> 2]));
    f28 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i128 >> 2]));
    f15 = Math_fround(Math_fround(1.0) - Math_fround(f15 * f25));
    f16 = Math_fround(Math_fround(1.0) - Math_fround(f16 * f26));
    f17 = Math_fround(Math_fround(1.0) - Math_fround(f17 * f27));
    f18 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f28));
    i2 = HEAP32[i209 >> 2] | 0;
    i4 = HEAP32[i107 >> 2] | 0;
    i220 = i4 << 2;
    i3 = i220 + 4096 | 0;
    i3 = (i3 >>> 0 < i220 >>> 0 ? i220 : i3) + (i4 << 3) | 0;
    if (!i3) i23 = 0; else {
     i4 = i2 + 8 | 0;
     i23 = (HEAP32[i4 >> 2] | 0) + 23 & -16;
     i74 = i23 + -8 | 0;
     i220 = i2 + 12 | 0;
     HEAP32[i74 >> 2] = HEAP32[i220 >> 2];
     HEAP32[i23 + -4 >> 2] = i3 & 2147483644;
     HEAP32[i220 >> 2] = i74;
     HEAP32[i4 >> 2] = i23 + i3;
     i4 = HEAP32[i107 >> 2] | 0;
    }
    i22 = i23 + (i4 << 2) | 0;
    i220 = i4 << 1;
    i21 = i23 + (i220 << 2) | 0;
    i220 = i23 + (i220 + 1024 << 2) | 0;
    i21 = i21 >>> 0 < i220 >>> 0 ? i220 : i21;
    if (!i4) i2 = 0; else {
     i3 = HEAP32[i208 >> 2] | 0;
     i5 = HEAP32[i207 >> 2] | 0;
     i6 = HEAP32[i100 >> 2] | 0;
     i8 = i198 + (i24 << 2) | 0;
     i9 = i198 + ((((i24 + 1 | 0) >>> 0) % 3 | 0) << 2) | 0;
     i13 = i198 + ((((i24 + 2 | 0) >>> 0) % 3 | 0) << 2) | 0;
     f7 = Math_fround(HEAPF32[i194 >> 2]);
     f10 = Math_fround(HEAPF32[i129 >> 2]);
     f11 = Math_fround(HEAPF32[i130 >> 2]);
     f12 = Math_fround(HEAPF32[i131 >> 2]);
     i14 = 0;
     do {
      i74 = HEAP32[i5 + (i14 << 2) >> 2] | 0;
      i220 = HEAP32[i6 + ((HEAPU16[i3 + (i14 << 1) >> 1] | 0) * 76 | 0) >> 2] | 0;
      f218 = Math_fround(f25 * Math_fround(HEAPF32[i220 + (i74 << 4) >> 2]));
      f214 = Math_fround(f26 * Math_fround(HEAPF32[i220 + (i74 << 4) + 4 >> 2]));
      f216 = Math_fround(f27 * Math_fround(HEAPF32[i220 + (i74 << 4) + 8 >> 2]));
      f218 = Math_fround(f15 + f218);
      f214 = Math_fround(f16 + f214);
      f216 = Math_fround(f17 + f216);
      f213 = Math_fround(f18 + Math_fround(f28 * Math_fround(HEAPF32[i220 + (i74 << 4) + 12 >> 2])));
      HEAPF32[i195 >> 2] = f214;
      HEAPF32[i196 >> 2] = f216;
      HEAPF32[i197 >> 2] = f213;
      f219 = Math_fround(HEAPF32[i194 >> 2]);
      f218 = f7 < f218 ? f219 : f218;
      f219 = Math_fround(HEAPF32[i129 >> 2]);
      f212 = Math_fround(HEAPF32[i195 >> 2]);
      f212 = f10 < f214 ? f219 : f212;
      f219 = Math_fround(HEAPF32[i130 >> 2]);
      f214 = Math_fround(HEAPF32[i196 >> 2]);
      f214 = f11 < f216 ? f219 : f214;
      f219 = Math_fround(HEAPF32[i131 >> 2]);
      f216 = Math_fround(HEAPF32[i197 >> 2]);
      f216 = f12 < f213 ? f219 : f216;
      f219 = Math_fround(HEAPF32[i201 >> 2]);
      f213 = Math_fround(HEAPF32[i202 >> 2]);
      f215 = Math_fround(HEAPF32[i203 >> 2]);
      f217 = Math_fround(HEAPF32[i204 >> 2]);
      i74 = ~~Math_fround(Math_floor(Math_fround(f213 < f212 ? f212 : f213)));
      i220 = ~~Math_fround(Math_floor(Math_fround(f215 < f214 ? f214 : f215)));
      i2 = ~~Math_fround(Math_floor(Math_fround(f217 < f216 ? f216 : f217)));
      HEAP32[i198 >> 2] = ~~Math_fround(Math_floor(Math_fround(f219 < f218 ? f218 : f219)));
      HEAP32[i135 >> 2] = i74;
      HEAP32[i136 >> 2] = i220;
      HEAP32[i137 >> 2] = i2;
      HEAP32[i21 + (i14 << 2) >> 2] = HEAP32[i9 >> 2] << 16 | HEAP32[i8 >> 2] | HEAP32[i13 >> 2] << 24;
      i14 = i14 + 1 | 0;
      i2 = HEAP32[i107 >> 2] | 0;
     } while (i14 >>> 0 < i2 >>> 0);
    }
    i3 = i21 + (i2 << 2) | 0;
    i9 = i2 << 2;
    i20 = i9 >> 2;
    i9 = i9 >> 1;
    i13 = i9 + 256 | 0;
    i14 = i9 + 512 | 0;
    i19 = i9 + 768 | 0;
    _memset(i23 + (i9 << 2) | 0, 0, 4096) | 0;
    if (!i2) {
     i2 = 0;
     i3 = 0;
     i5 = 0;
     i6 = 0;
     i8 = 0;
    } else {
     i2 = i21;
     do {
      i220 = HEAP32[i2 >> 2] | 0;
      i74 = i23 + ((i220 & 255) + i9 << 2) | 0;
      HEAP32[i74 >> 2] = (HEAP32[i74 >> 2] | 0) + 1;
      i74 = i23 + ((i220 >>> 8 & 255) + i13 << 2) | 0;
      HEAP32[i74 >> 2] = (HEAP32[i74 >> 2] | 0) + 1;
      i74 = i23 + ((i220 >>> 16 & 255) + i14 << 2) | 0;
      HEAP32[i74 >> 2] = (HEAP32[i74 >> 2] | 0) + 1;
      i220 = i23 + ((i220 >>> 24) + i19 << 2) | 0;
      HEAP32[i220 >> 2] = (HEAP32[i220 >> 2] | 0) + 1;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i3 | 0));
     i2 = 0;
     i3 = 0;
     i5 = 0;
     i6 = 0;
     i8 = 0;
    }
    do {
     i220 = i23 + (i2 + i9 << 2) | 0;
     i74 = i3;
     i3 = (HEAP32[i220 >> 2] | 0) + i3 | 0;
     HEAP32[i220 >> 2] = i74;
     i220 = i23 + (i2 + i13 << 2) | 0;
     i74 = i6;
     i6 = (HEAP32[i220 >> 2] | 0) + i6 | 0;
     HEAP32[i220 >> 2] = i74;
     i220 = i23 + (i2 + i14 << 2) | 0;
     i74 = i8;
     i8 = (HEAP32[i220 >> 2] | 0) + i8 | 0;
     HEAP32[i220 >> 2] = i74;
     i220 = i23 + (i2 + i19 << 2) | 0;
     i74 = i5;
     i5 = (HEAP32[i220 >> 2] | 0) + i5 | 0;
     HEAP32[i220 >> 2] = i74;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 256);
    if (i20 | 0) {
     i2 = 0;
     do {
      i74 = i23 + ((HEAP32[i21 + (i2 << 2) >> 2] & 255) + i9 << 2) | 0;
      i220 = HEAP32[i74 >> 2] | 0;
      HEAP32[i74 >> 2] = i220 + 1;
      HEAP32[i23 + (i220 + i20 << 2) >> 2] = i2;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i20 | 0));
     i3 = i20;
     i2 = 0;
     while (1) {
      i74 = HEAP32[i23 + (i3 << 2) >> 2] | 0;
      i73 = i23 + (((HEAP32[i21 + (i74 << 2) >> 2] | 0) >>> 8 & 255) + i13 << 2) | 0;
      i220 = HEAP32[i73 >> 2] | 0;
      HEAP32[i73 >> 2] = i220 + 1;
      HEAP32[i23 + (i220 << 2) >> 2] = i74;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) {
       i3 = i23;
       i2 = 0;
       break;
      } else i3 = i2 + i20 | 0;
     }
     while (1) {
      i74 = HEAP32[i3 >> 2] | 0;
      i73 = i23 + (((HEAP32[i21 + (i74 << 2) >> 2] | 0) >>> 16 & 255) + i14 << 2) | 0;
      i220 = HEAP32[i73 >> 2] | 0;
      HEAP32[i73 >> 2] = i220 + 1;
      HEAP32[i23 + (i220 + i20 << 2) >> 2] = i74;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) {
       i3 = i20;
       i2 = 0;
       break;
      } else i3 = i23 + (i2 << 2) | 0;
     }
     while (1) {
      i74 = HEAP32[i23 + (i3 << 2) >> 2] | 0;
      i73 = i23 + (((HEAP32[i21 + (i74 << 2) >> 2] | 0) >>> 24) + i19 << 2) | 0;
      i220 = HEAP32[i73 >> 2] | 0;
      HEAP32[i73 >> 2] = i220 + 1;
      HEAP32[i23 + (i220 << 2) >> 2] = i74;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else i3 = i2 + i20 | 0;
     }
    }
    i220 = HEAP32[i107 >> 2] | 0;
    i5 = HEAP32[i23 + ((i220 << 1) + 769 << 2) >> 2] | 0;
    if (!i220) i2 = 0; else {
     i3 = 0;
     do {
      HEAP32[i23 + (i3 + i4 << 2) >> 2] = HEAP32[i21 + (HEAP32[i23 + (i3 << 2) >> 2] << 2) >> 2];
      i3 = i3 + 1 | 0;
      i2 = HEAP32[i107 >> 2] | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
    HEAP32[i23 + (i2 + i4 << 2) >> 2] = -1;
    f219 = Math_fround(f25 * Math_fround(HEAPF32[i101 >> 2]));
    f217 = Math_fround(f26 * Math_fround(HEAPF32[i102 >> 2]));
    f218 = Math_fround(f27 * Math_fround(HEAPF32[i103 >> 2]));
    i3 = ~~Math_fround(Math_floor(Math_fround(f217)));
    i6 = ~~Math_fround(Math_floor(Math_fround(f218)));
    i2 = ~~Math_fround(Math_floor(Math_fround(f28 * Math_fround(HEAPF32[i104 >> 2]))));
    HEAP32[i192 >> 2] = ~~Math_fround(Math_floor(Math_fround(f219)));
    HEAP32[i132 >> 2] = i3;
    HEAP32[i133 >> 2] = i6;
    HEAP32[i134 >> 2] = i2;
    __ZN5physx5cloth16SwInterCollisionI8Scalar4fE16collideParticlesEPKjjS5_jj(i206, i22, i5, i23, HEAP32[i107 >> 2] | 0, (HEAP32[i192 + (i24 << 2) >> 2] | 0) + 2 | 0);
    i2 = HEAP32[i209 >> 2] | 0;
    i6 = i23 + -4 | 0;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | -2147483648;
    i6 = i2 + 12 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) break;
    i4 = i2 + 8 | 0;
    i5 = i3;
    i2 = i3;
    while (1) {
     if ((HEAP32[i5 + 4 >> 2] | 0) >= 0) break L163;
     HEAP32[i4 >> 2] = i5;
     i2 = HEAP32[i2 >> 2] | 0;
     HEAP32[i6 >> 2] = i2;
     if (!i2) break; else i5 = i2;
    }
   } while (0);
   if (HEAP32[i107 >> 2] | 0) {
    i5 = HEAP32[i208 >> 2] | 0;
    i6 = HEAP32[i100 >> 2] | 0;
    i8 = HEAP32[i207 >> 2] | 0;
    f7 = Math_fround(0.0);
    i4 = 0;
    i2 = -1;
    do {
     i220 = HEAP16[i5 + (i4 << 1) >> 1] | 0;
     i3 = i220 & 65535;
     if (i220 << 16 >> 16 != i2 << 16 >> 16) {
      f65 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 32 >> 2]);
      f54 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 36 >> 2]);
      f65 = Math_fround(f65 * Math_fround(-2.0));
      f54 = Math_fround(f54 * Math_fround(-2.0));
      f216 = Math_fround(Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 40 >> 2]) * Math_fround(-2.0));
      f7 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 28 >> 2]);
      f56 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
      f213 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 16 >> 2]);
      f219 = Math_fround(f65 * f213);
      f214 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 20 >> 2]);
      f219 = Math_fround(f219 + Math_fround(f54 * f214));
      f211 = Math_fround(HEAPF32[i6 + (i3 * 76 | 0) + 24 >> 2]);
      f219 = Math_fround(f219 + Math_fround(f216 * f211));
      f217 = Math_fround(Math_fround(f213 * f219) + Math_fround(Math_fround(f65 * f56) - Math_fround(f7 * Math_fround(Math_fround(f216 * f214) - Math_fround(f54 * f211)))));
      f218 = Math_fround(Math_fround(f214 * f219) + Math_fround(Math_fround(f54 * f56) - Math_fround(f7 * Math_fround(Math_fround(f65 * f211) - Math_fround(f216 * f213)))));
      f219 = Math_fround(Math_fround(Math_fround(f216 * f56) - Math_fround(f7 * Math_fround(Math_fround(f54 * f213) - Math_fround(f65 * f214)))) + Math_fround(f211 * f219));
      f65 = Math_fround(-f213);
      f54 = Math_fround(-f214);
      f56 = Math_fround(-f211);
      f213 = Math_fround(f65 - f213);
      f214 = Math_fround(f54 - f214);
      f211 = Math_fround(f56 - f211);
      f216 = Math_fround(f214 * f54);
      f212 = Math_fround(f211 * f56);
      f54 = Math_fround(f213 * f54);
      f55 = Math_fround(f213 * f56);
      f215 = Math_fround(f7 * f213);
      f56 = Math_fround(f214 * f56);
      f214 = Math_fround(f7 * f214);
      f211 = Math_fround(f7 * f211);
      f7 = Math_fround(Math_fround(Math_fround(1.0) - f216) - f212);
      f66 = Math_fround(f54 + f211);
      f67 = Math_fround(f55 - f214);
      f211 = Math_fround(f54 - f211);
      f65 = Math_fround(Math_fround(1.0) - Math_fround(f213 * f65));
      f212 = Math_fround(f65 - f212);
      f213 = Math_fround(f215 + f56);
      f214 = Math_fround(f55 + f214);
      f215 = Math_fround(f56 - f215);
      f216 = Math_fround(f65 - f216);
      HEAPF32[i205 >> 2] = f7;
      HEAPF32[i108 >> 2] = f66;
      HEAPF32[i109 >> 2] = f67;
      HEAP32[i110 >> 2] = 0;
      HEAPF32[i115 >> 2] = f211;
      HEAPF32[i116 >> 2] = f212;
      HEAPF32[i117 >> 2] = f213;
      HEAP32[i118 >> 2] = 0;
      HEAPF32[i119 >> 2] = f214;
      HEAPF32[i120 >> 2] = f215;
      HEAPF32[i121 >> 2] = f216;
      HEAP32[i122 >> 2] = 0;
      HEAPF32[i111 >> 2] = f217;
      HEAPF32[i112 >> 2] = f218;
      HEAPF32[i113 >> 2] = f219;
      HEAP32[i114 >> 2] = 1065353216;
      i1 = HEAP32[i6 + (i3 * 76 | 0) + 68 >> 2] | 0;
      i2 = HEAP16[(HEAP32[i208 >> 2] | 0) + (i4 << 1) >> 1] | 0;
     }
     i220 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
     i68 = HEAP32[i6 + (i3 * 76 | 0) >> 2] | 0;
     i74 = i68 + (i220 << 4) | 0;
     i58 = HEAP32[i6 + (i3 * 76 | 0) + 4 >> 2] | 0;
     i69 = i58 + (i220 << 4) | 0;
     i57 = HEAP32[i74 >> 2] | 0;
     f212 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f218 = Math_fround(f212 * f7);
     f215 = Math_fround(f212 * Math_fround(HEAPF32[i108 >> 2]));
     f219 = Math_fround(f212 * Math_fround(HEAPF32[i109 >> 2]));
     f212 = Math_fround(f212 * Math_fround(HEAPF32[i110 >> 2]));
     f218 = Math_fround(f218 + Math_fround(HEAPF32[i111 >> 2]));
     f215 = Math_fround(f215 + Math_fround(HEAPF32[i112 >> 2]));
     f219 = Math_fround(f219 + Math_fround(HEAPF32[i113 >> 2]));
     f212 = Math_fround(f212 + Math_fround(HEAPF32[i114 >> 2]));
     i72 = i68 + (i220 << 4) + 4 | 0;
     i59 = HEAP32[i72 >> 2] | 0;
     f55 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f56 = Math_fround(HEAPF32[i115 >> 2]);
     f54 = Math_fround(f55 * f56);
     f66 = Math_fround(HEAPF32[i116 >> 2]);
     f67 = Math_fround(f55 * f66);
     f211 = Math_fround(HEAPF32[i117 >> 2]);
     f65 = Math_fround(f55 * f211);
     f214 = Math_fround(HEAPF32[i118 >> 2]);
     f54 = Math_fround(f218 + f54);
     f67 = Math_fround(f215 + f67);
     f65 = Math_fround(f219 + f65);
     f55 = Math_fround(f212 + Math_fround(f55 * f214));
     i70 = i68 + (i220 << 4) + 8 | 0;
     i61 = HEAP32[i70 >> 2] | 0;
     f212 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f219 = Math_fround(HEAPF32[i119 >> 2]);
     f215 = Math_fround(f212 * f219);
     f218 = Math_fround(HEAPF32[i120 >> 2]);
     f213 = Math_fround(f212 * f218);
     f217 = Math_fround(HEAPF32[i121 >> 2]);
     f7 = Math_fround(f212 * f217);
     f216 = Math_fround(HEAPF32[i122 >> 2]);
     f215 = Math_fround(f54 + f215);
     f213 = Math_fround(f67 + f213);
     f7 = Math_fround(f65 + f7);
     f212 = Math_fround(f55 + Math_fround(f212 * f216));
     i60 = (HEAPF32[tempDoublePtr >> 2] = f215, HEAP32[tempDoublePtr >> 2] | 0);
     i73 = (HEAPF32[tempDoublePtr >> 2] = f213, HEAP32[tempDoublePtr >> 2] | 0);
     i71 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
     i68 = i68 + (i220 << 4) + 12 | 0;
     i63 = HEAP32[i68 >> 2] | 0;
     i57 = HEAP32[gb + 1097600 >> 2] & (i60 ^ i57) ^ i57;
     i59 = HEAP32[gb + 1097600 + 4 >> 2] & (i73 ^ i59) ^ i59;
     i61 = HEAP32[gb + 1097600 + 8 >> 2] & (i71 ^ i61) ^ i61;
     i63 = (i63 ^ (HEAPF32[tempDoublePtr >> 2] = f212, HEAP32[tempDoublePtr >> 2] | 0)) & HEAP32[gb + 1097600 + 12 >> 2] ^ i63;
     HEAP32[i74 >> 2] = i57;
     HEAP32[i72 >> 2] = i59;
     HEAP32[i70 >> 2] = i61;
     HEAP32[i68 >> 2] = i63;
     i68 = HEAP32[gb + 1097648 >> 2] | 0;
     HEAP32[i148 >> 2] = i68;
     i70 = HEAP32[gb + 1097648 + 4 >> 2] | 0;
     HEAP32[i158 >> 2] = i70;
     i72 = HEAP32[gb + 1097648 + 8 >> 2] | 0;
     HEAP32[i164 >> 2] = i72;
     i74 = HEAP32[gb + 1097648 + 12 >> 2] | 0;
     HEAP32[i170 >> 2] = i74;
     f212 = Math_fround(HEAPF32[i69 >> 2]);
     f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f212 = Math_fround(f7 * f212);
     i71 = i58 + (i220 << 4) + 4 | 0;
     f213 = Math_fround(f7 * Math_fround(HEAPF32[i71 >> 2]));
     i73 = i58 + (i220 << 4) + 8 | 0;
     f215 = Math_fround(f7 * Math_fround(HEAPF32[i73 >> 2]));
     i220 = i58 + (i220 << 4) + 12 | 0;
     f7 = Math_fround(f7 * Math_fround(HEAPF32[i220 >> 2]));
     i58 = (HEAPF32[tempDoublePtr >> 2] = f212, HEAP32[tempDoublePtr >> 2] | 0);
     i60 = (HEAPF32[tempDoublePtr >> 2] = f213, HEAP32[tempDoublePtr >> 2] | 0);
     i62 = (HEAPF32[tempDoublePtr >> 2] = f215, HEAP32[tempDoublePtr >> 2] | 0);
     i64 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
     f7 = Math_fround(HEAPF32[i205 >> 2]);
     f55 = Math_fround(f212 * f7);
     f65 = Math_fround(f212 * Math_fround(HEAPF32[i108 >> 2]));
     f67 = Math_fround(f212 * Math_fround(HEAPF32[i109 >> 2]));
     f219 = Math_fround(Math_fround(f55 + Math_fround(f213 * f56)) + Math_fround(f215 * f219));
     f218 = Math_fround(Math_fround(f65 + Math_fround(f213 * f66)) + Math_fround(f215 * f218));
     f217 = Math_fround(Math_fround(f67 + Math_fround(f213 * f211)) + Math_fround(f215 * f217));
     f216 = Math_fround(Math_fround(Math_fround(f212 * Math_fround(HEAPF32[i110 >> 2])) + Math_fround(f213 * f214)) + Math_fround(f215 * f216));
     i43 = (HEAPF32[tempDoublePtr >> 2] = f219, HEAP32[tempDoublePtr >> 2] | 0);
     i44 = (HEAPF32[tempDoublePtr >> 2] = f218, HEAP32[tempDoublePtr >> 2] | 0);
     i45 = (HEAPF32[tempDoublePtr >> 2] = f217, HEAP32[tempDoublePtr >> 2] | 0);
     i58 = HEAP32[gb + 1097600 >> 2] & (i43 ^ i58) ^ i58;
     i60 = HEAP32[gb + 1097600 + 4 >> 2] & (i44 ^ i60) ^ i60;
     i62 = HEAP32[gb + 1097600 + 8 >> 2] & (i45 ^ i62) ^ i62;
     i64 = ((HEAPF32[tempDoublePtr >> 2] = f216, HEAP32[tempDoublePtr >> 2] | 0) ^ i64) & HEAP32[gb + 1097600 + 12 >> 2] ^ i64;
     f216 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f216 = Math_fround(f216 - (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f217 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f217 = Math_fround(f217 - (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f218 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f218 = Math_fround(f218 - (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f219 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f219 = Math_fround(f219 - (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     HEAPF32[i147 >> 2] = f216;
     HEAPF32[i154 >> 2] = f217;
     HEAPF32[i163 >> 2] = f218;
     HEAPF32[i166 >> 2] = f219;
     i68 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f216;
     i70 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f217;
     i70 = HEAP32[(i70 ? i154 : i158) >> 2] | 0;
     i72 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f218;
     i72 = HEAP32[(i72 ? i163 : i164) >> 2] | 0;
     i74 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f219;
     i74 = HEAP32[(i74 ? i166 : i170) >> 2] | 0;
     HEAP32[i69 >> 2] = HEAP32[(i68 ? i147 : i148) >> 2];
     HEAP32[i71 >> 2] = i70;
     HEAP32[i73 >> 2] = i72;
     HEAP32[i220 >> 2] = i74;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (HEAP32[i107 >> 2] | 0) >>> 0);
   }
   i139 = i139 + 1 | 0;
  } while (i139 >>> 0 < (HEAP32[i141 >> 2] | 0) >>> 0);
  i1 = HEAP32[i140 >> 2] | 0;
 }
 i2 = HEAP32[i209 >> 2] | 0;
 L208 : do if (i1 | 0) {
  i4 = i1 + -4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | -2147483648;
  i4 = i2 + 12 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i2 = i2 + 8 | 0;
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 + 4 >> 2] | 0) >= 0) break L208;
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i1;
    if (!i1) break; else i3 = i1;
   }
  }
 } while (0);
 i2 = HEAP32[i209 >> 2] | 0;
 i1 = HEAP32[i207 >> 2] | 0;
 L215 : do if (i1 | 0) {
  i4 = i1 + -4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | -2147483648;
  i4 = i2 + 12 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i2 = i2 + 8 | 0;
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 + 4 >> 2] | 0) >= 0) break L215;
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i1;
    if (!i1) break; else i3 = i1;
   }
  }
 } while (0);
 i2 = HEAP32[i209 >> 2] | 0;
 i1 = HEAP32[i208 >> 2] | 0;
 if (!i1) {
  STACKTOP = i210;
  return;
 }
 i4 = i1 + -4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | -2147483648;
 i4 = i2 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i210;
  return;
 }
 i2 = i2 + 8 | 0;
 i3 = i1;
 while (1) {
  if ((HEAP32[i3 + 4 >> 2] | 0) >= 0) {
   i1 = 156;
   break;
  }
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  if (!i1) {
   i1 = 156;
   break;
  } else i3 = i1;
 }
 if ((i1 | 0) == 156) {
  STACKTOP = i210;
  return;
 }
}

function __ZN7mecanim5human13FullBodySolveEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESC_SC_(i51, i52, i54, i55, i56) {
 i51 = i51 | 0;
 i52 = i52 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i53 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i58 + 144 | 0;
 i48 = i58 + 140 | 0;
 i49 = i58 + 128 | 0;
 i57 = i58 + 112 | 0;
 i50 = i58 + 96 | 0;
 i41 = i58 + 80 | 0;
 i42 = i58 + 64 | 0;
 i43 = i58 + 48 | 0;
 i7 = i58 + 32 | 0;
 i8 = i58 + 16 | 0;
 i9 = i58;
 i53 = HEAP32[i51 + 72 >> 2] | 0;
 i10 = HEAP32[i51 + 104 >> 2] | 0;
 i44 = HEAP32[i51 + 100 >> 2] | 0;
 i12 = HEAP32[i51 + 108 >> 2] | 0;
 i45 = HEAP32[i51 + 112 >> 2] | 0;
 i46 = HEAP32[i51 + 156 >> 2] | 0;
 i47 = HEAP32[i51 + 160 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i52 + 52 >> 2]);
 i34 = f31 < Math_fround(0.0);
 f31 = i34 ? Math_fround(0.0) : f31;
 f5 = Math_fround(HEAPF32[i52 + 56 >> 2]);
 i34 = f5 < Math_fround(0.0);
 f5 = i34 ? Math_fround(0.0) : f5;
 f40 = Math_fround(HEAPF32[i52 + 60 >> 2]);
 i34 = f40 < Math_fround(0.0);
 f40 = i34 ? Math_fround(0.0) : f40;
 f39 = Math_fround(HEAPF32[i52 + 64 >> 2]);
 i34 = f39 < Math_fround(0.0);
 f39 = i34 ? Math_fround(0.0) : f39;
 i34 = f31 > Math_fround(1.0);
 f31 = i34 ? Math_fround(1.0) : f31;
 i34 = f5 > Math_fround(1.0);
 f5 = i34 ? Math_fround(1.0) : f5;
 i34 = f40 > Math_fround(1.0);
 f40 = i34 ? Math_fround(1.0) : f40;
 i34 = f39 > Math_fround(1.0);
 f39 = i34 ? Math_fround(1.0) : f39;
 HEAPF32[i11 >> 2] = f5;
 HEAPF32[i48 >> 2] = f39;
 i34 = i52 + 40 | 0;
 HEAP32[i49 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 if (f31 > Math_fround(0.0)) {
  i4 = i55 + 4 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i1 = HEAP32[i4 + (i45 * 40 | 0) >> 2] | 0;
  i2 = HEAP32[i4 + (i45 * 40 | 0) + 4 >> 2] | 0;
  i3 = HEAP32[i4 + (i45 * 40 | 0) + 8 >> 2] | 0;
  i34 = i51 + 40 | 0;
  i34 = (HEAP32[i34 >> 2] | 0) + i34 | 0;
  i30 = i34 + 16 | 0;
  i34 = i34 + 4 | 0;
  i34 = HEAP32[i34 + (HEAP32[i34 >> 2] | 0) + (i45 << 3) + 4 >> 2] | 0;
  i30 = i30 + (HEAP32[i30 >> 2] | 0) | 0;
  f18 = Math_fround(HEAPF32[i30 + (i34 * 76 | 0) + 16 >> 2]);
  f39 = Math_fround(HEAPF32[i30 + (i34 * 76 | 0) + 20 >> 2]);
  f37 = Math_fround(HEAPF32[i30 + (i34 * 76 | 0) + 24 >> 2]);
  f19 = Math_fround(HEAPF32[i30 + (i34 * 76 | 0) + 28 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 16 >> 2]);
  f20 = Math_fround(f18 * f5);
  f14 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 24 >> 2]);
  f17 = Math_fround(f19 * f14);
  f15 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 20 >> 2]);
  f38 = Math_fround(f39 * f15);
  f16 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 12 >> 2]);
  f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f37 * f14)) - Math_fround(f19 * f15)) - Math_fround(f39 * f16));
  f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f18 * f16)) - Math_fround(f37 * f15)) - Math_fround(f39 * f5));
  f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f37 * f5)) - Math_fround(f18 * f14)) - Math_fround(f19 * f16));
  f19 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f16) - Math_fround(f18 * f15)) - Math_fround(f39 * f14)) - Math_fround(f19 * f5));
  i34 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f19 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = Math_fround(f19 * f19);
  f20 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f20 * f20);
  f18 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f38 + f39)))));
  f19 = Math_fround(f39 * f19);
  f20 = Math_fround(f39 * f20);
  f18 = Math_fround(f39 * f18);
  f17 = Math_fround(f39 * f17);
  if ((i46 | 0) != -1 & (i47 | 0) != -1) {
   f64 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i51 + 44 | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 + 4 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   f35 = Math_fround(HEAPF32[i1 + (i46 * 40 | 0) >> 2]);
   f63 = Math_fround(HEAPF32[i1 + (i46 * 40 | 0) + 4 >> 2]);
   f60 = Math_fround(HEAPF32[i1 + (i46 * 40 | 0) + 8 >> 2]);
   f32 = Math_fround(HEAPF32[i1 + (i47 * 40 | 0) >> 2]);
   f65 = Math_fround(HEAPF32[i1 + (i47 * 40 | 0) + 4 >> 2]);
   f32 = Math_fround(Math_fround(f35 + f32) * Math_fround(.5));
   f65 = Math_fround(Math_fround(f63 + f65) * Math_fround(.5));
   f60 = Math_fround(Math_fround(f60 + Math_fround(HEAPF32[i1 + (i47 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   f63 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 28 >> 2]);
   f35 = Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 32 >> 2]);
   f63 = Math_fround(f32 * f63);
   f35 = Math_fround(f65 * f35);
   f60 = Math_fround(f60 * Math_fround(HEAPF32[i4 + (i45 * 40 | 0) + 36 >> 2]));
   f65 = Math_fround(f5 * Math_fround(-2.0));
   f32 = Math_fround(f5 * Math_fround(2.0));
   f62 = Math_fround(f65 * f14);
   f36 = Math_fround(f15 * Math_fround(2.0));
   f61 = Math_fround(f15 * Math_fround(-2.0));
   f66 = Math_fround(f14 * f61);
   f59 = Math_fround(f16 * Math_fround(-2.0));
   f38 = Math_fround(f16 * Math_fround(2.0));
   f39 = Math_fround(f14 * f59);
   f37 = Math_fround(f37 + Math_fround(Math_fround(f63 + Math_fround(f63 * Math_fround(Math_fround(f5 * f65) - Math_fround(f15 * f36)))) + Math_fround(Math_fround(f60 * Math_fround(Math_fround(f38 * f15) - f62)) + Math_fround(f35 * Math_fround(f66 - Math_fround(f5 * f59))))));
   f38 = Math_fround(f67 + Math_fround(Math_fround(f35 + Math_fround(f63 * Math_fround(Math_fround(f16 * f32) - f66))) + Math_fround(Math_fround(f60 * Math_fround(f39 - Math_fround(f65 * f15))) + Math_fround(f35 * Math_fround(Math_fround(f15 * f61) - Math_fround(f16 * f38))))));
   f39 = Math_fround(f64 + Math_fround(Math_fround(f60 + Math_fround(f63 * Math_fround(f62 - Math_fround(f16 * f61)))) + Math_fround(Math_fround(f60 * Math_fround(Math_fround(f16 * f59) - Math_fround(f5 * f32))) + Math_fround(f35 * Math_fround(Math_fround(f5 * f36) - f39)))));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f67 = Math_fround(HEAPF32[i49 >> 2]);
  i4 = i49 + 4 | 0;
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i49 + 8 | 0;
  f15 = Math_fround(HEAPF32[i6 >> 2]);
  f39 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f67 = Math_fround(f67 - f39);
  f16 = Math_fround(f16 - f38);
  f15 = Math_fround(f15 - f37);
  f66 = Math_fround(Math_fround(Math_fround(f67 * f67) + Math_fround(f16 * f16)) + Math_fround(Math_fround(f15 * f15) + Math_fround(0.0)));
  f60 = Math_fround(Math_sqrt(Math_fround(f66)));
  f32 = Math_fround(-f60);
  f61 = Math_fround(f20 * Math_fround(-2.0));
  f65 = Math_fround(f20 * Math_fround(2.0));
  f62 = Math_fround(f17 * f61);
  f14 = Math_fround(f18 * Math_fround(2.0));
  f63 = Math_fround(f18 * Math_fround(-2.0));
  f59 = Math_fround(f17 * f63);
  f64 = Math_fround(f19 * Math_fround(-2.0));
  f35 = Math_fround(f19 * Math_fround(2.0));
  f5 = Math_fround(f17 * f64);
  f36 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f20 * f61) - Math_fround(f18 * f14)) * Math_fround(0.0)) + Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(Math_fround(f18 * f35) - f62) * Math_fround(0.0)) + Math_fround(Math_fround(f59 - Math_fround(f20 * f64)) * f32)));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f19 * f65) - f59) * Math_fround(0.0)) - f60) + Math_fround(Math_fround(Math_fround(f5 - Math_fround(f18 * f61)) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(f18 * f63) - Math_fround(f19 * f35)) * f32)));
  f32 = Math_fround(Math_fround(Math_fround(Math_fround(f62 - Math_fround(f19 * f63)) * Math_fround(0.0)) + Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(Math_fround(f19 * f64) - Math_fround(f20 * f65)) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(f14 * f20) - f5) * f32)));
  f5 = Math_fround(Math_fround(f16 * f36) - Math_fround(f67 * f35));
  f18 = Math_fround(Math_fround(f15 * f35) - Math_fround(f16 * f32));
  f14 = Math_fround(Math_fround(f67 * f32) - Math_fround(f15 * f36));
  f15 = Math_fround(Math_fround(Math_sqrt(Math_fround(f66 * Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f35 * f35)) + Math_fround(Math_fround(f32 * f32) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f67 * f36) + Math_fround(f16 * f35)) + Math_fround(Math_fround(f15 * f32) + Math_fround(0.0))));
  f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f15 * f15))))));
  f18 = Math_fround(f19 * f18);
  f14 = Math_fround(f19 * f14);
  f5 = Math_fround(f19 * f5);
  f15 = Math_fround(f19 * f15);
  f19 = Math_fround(+Math_cos(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f31) * Math_fround(180.0)) * Math_fround(.0174532924)) * Math_fround(.5))));
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f15 * f15))))));
  f17 = Math_fround(f16 * f18);
  f20 = Math_fround(f16 * f14);
  f31 = Math_fround(f16 * f5);
  f16 = Math_fround(f16 * f15);
  f67 = Math_fround(-f16);
  i1 = f16 < Math_fround(0.0);
  f16 = i1 ? f67 : f16;
  if (f16 < f19) {
   f67 = Math_fround(-f31);
   f14 = Math_fround(-f20);
   f66 = Math_fround(-f17);
   f15 = Math_fround(Math_fround(f19 - f16) / f19);
   f5 = Math_fround(Math_fround(1.0) - f15);
   f16 = Math_fround((i1 ? f66 : f17) * f5);
   f15 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(1.0) - f19) * f15));
   f14 = Math_fround((i1 ? f14 : f20) * f5);
   f5 = Math_fround((i1 ? f67 : f31) * f5);
  } else f16 = f18;
  f60 = Math_fround(f14 * Math_fround(-2.0));
  f59 = Math_fround(f14 * Math_fround(2.0));
  f65 = Math_fround(f60 * f15);
  f61 = Math_fround(f5 * Math_fround(2.0));
  f31 = Math_fround(f5 * Math_fround(-2.0));
  f62 = Math_fround(f15 * f31);
  f63 = Math_fround(f16 * Math_fround(-2.0));
  f64 = Math_fround(f16 * Math_fround(2.0));
  f67 = Math_fround(f63 * f15);
  f66 = Math_fround(f38 + Math_fround(Math_fround(f35 + Math_fround(f36 * Math_fround(Math_fround(f16 * f59) - f62))) + Math_fround(Math_fround(f35 * Math_fround(Math_fround(f5 * f31) - Math_fround(f16 * f64))) + Math_fround(f32 * Math_fround(f67 - Math_fround(f5 * f60))))));
  f67 = Math_fround(f37 + Math_fround(Math_fround(f32 + Math_fround(f36 * Math_fround(f65 - Math_fround(f16 * f31)))) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f16 * f63) - Math_fround(f14 * f59))) + Math_fround(f35 * Math_fround(Math_fround(f14 * f61) - f67)))));
  HEAPF32[i49 >> 2] = Math_fround(f39 + Math_fround(Math_fround(f36 + Math_fround(f36 * Math_fround(Math_fround(f14 * f60) - Math_fround(f5 * f61)))) + Math_fround(Math_fround(f35 * Math_fround(f62 - Math_fround(f14 * f63))) + Math_fround(f32 * Math_fround(Math_fround(f64 * f5) - f65)))));
  HEAPF32[i4 >> 2] = f66;
  HEAPF32[i6 >> 2] = f67;
  f5 = Math_fround(HEAPF32[i11 >> 2]);
 }
 if (f5 > Math_fround(0.0)) {
  f62 = Math_fround(f5 * Math_fround(.5));
  i34 = (i10 | 0) != -1;
  HEAPF32[i57 >> 2] = i34 ? f62 : f5;
  i1 = i55 + 4 | 0;
  i2 = i1;
  i30 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
  i3 = i30 + (i45 * 40 | 0) | 0;
  HEAP32[i50 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = i51 + 40 | 0;
  i4 = i3;
  i33 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
  i28 = i33 + 16 | 0;
  i33 = i33 + 4 | 0;
  i33 = HEAP32[i33 + (HEAP32[i33 >> 2] | 0) + (i45 << 3) + 4 >> 2] | 0;
  i28 = i28 + (HEAP32[i28 >> 2] | 0) | 0;
  f62 = Math_fround(HEAPF32[i28 + (i33 * 76 | 0) + 16 >> 2]);
  f60 = Math_fround(HEAPF32[i28 + (i33 * 76 | 0) + 20 >> 2]);
  f39 = Math_fround(HEAPF32[i28 + (i33 * 76 | 0) + 24 >> 2]);
  f64 = Math_fround(HEAPF32[i28 + (i33 * 76 | 0) + 28 >> 2]);
  f61 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 16 >> 2]);
  f65 = Math_fround(f62 * f61);
  f59 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 24 >> 2]);
  f63 = Math_fround(f64 * f59);
  f66 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 20 >> 2]);
  f67 = Math_fround(f60 * f66);
  f38 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 12 >> 2]);
  f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f39 * f59)) - Math_fround(f64 * f66)) - Math_fround(f60 * f38));
  f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f62 * f38)) - Math_fround(f39 * f66)) - Math_fround(f60 * f61));
  f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f39 * f61)) - Math_fround(f62 * f59)) - Math_fround(f64 * f38));
  f61 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f38) - Math_fround(f62 * f66)) - Math_fround(f60 * f59)) - Math_fround(f64 * f61));
  i30 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f61 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f67 = Math_fround(f61 * f61);
  f65 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f65 * f65);
  f59 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f59 * f59)) + Math_fround(f67 + f64)))));
  f65 = Math_fround(f64 * f65);
  f59 = Math_fround(f64 * f59);
  f63 = Math_fround(f64 * f63);
  HEAPF32[i41 >> 2] = Math_fround(f64 * f61);
  HEAPF32[i41 + 4 >> 2] = f65;
  HEAPF32[i41 + 8 >> 2] = f59;
  HEAPF32[i41 + 12 >> 2] = f63;
  i30 = (HEAP32[i1 >> 2] | 0) + i2 + (i44 * 40 | 0) | 0;
  HEAPF32[i43 >> 2] = Math_fround(0.0);
  HEAPF32[i43 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i43 + 8 >> 2] = Math_fround(0.0);
  __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i42, i30, i50, i41, i43, i49, i57);
  i30 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
  f63 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  i28 = i30 + (i44 * 40 | 0) + 12 | 0;
  f59 = Math_fround(HEAPF32[i28 >> 2]);
  f65 = Math_fround(f63 * f59);
  f61 = Math_fround(HEAPF32[i42 + 12 >> 2]);
  i33 = i30 + (i44 * 40 | 0) + 24 | 0;
  f64 = Math_fround(HEAPF32[i33 >> 2]);
  f67 = Math_fround(f61 * f64);
  f60 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  i29 = i30 + (i44 * 40 | 0) + 16 | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f62 = Math_fround(f60 * f66);
  f38 = Math_fround(HEAPF32[i42 >> 2]);
  i30 = i30 + (i44 * 40 | 0) + 20 | 0;
  f39 = Math_fround(HEAPF32[i30 >> 2]);
  f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f39)) - Math_fround(f64 * f60)) - Math_fround(f66 * f38));
  f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f38)) - Math_fround(f60 * f39)) - Math_fround(f63 * f66));
  f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f39)) - Math_fround(f59 * f61)) - Math_fround(f64 * f38));
  f64 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
  i27 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f64 = (HEAP32[tempDoublePtr >> 2] = i25 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = Math_fround(f64 * f64);
  f65 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(f65 * f65);
  f66 = (HEAP32[tempDoublePtr >> 2] = i27 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
  f65 = Math_fround(f63 * f65);
  f66 = Math_fround(f63 * f66);
  f67 = Math_fround(f63 * f67);
  HEAPF32[i28 >> 2] = Math_fround(f63 * f64);
  HEAPF32[i29 >> 2] = f65;
  HEAPF32[i30 >> 2] = f66;
  HEAPF32[i33 >> 2] = f67;
  i33 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i33 | 0) == 0 ? 0 : i33 + i4 | 0, i55, i54, i44, i44);
  if (i34) {
   i33 = HEAP32[i3 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i33 | 0) == 0 ? 0 : i33 + i4 | 0, i54, i55, i45, i44);
   i33 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   i34 = i33 + (i45 * 40 | 0) | 0;
   HEAP32[i43 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   i34 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
   i29 = i34 + 16 | 0;
   i34 = i34 + 4 | 0;
   i34 = HEAP32[i34 + (HEAP32[i34 >> 2] | 0) + (i45 << 3) + 4 >> 2] | 0;
   i29 = i29 + (HEAP32[i29 >> 2] | 0) | 0;
   f62 = Math_fround(HEAPF32[i29 + (i34 * 76 | 0) + 16 >> 2]);
   f60 = Math_fround(HEAPF32[i29 + (i34 * 76 | 0) + 20 >> 2]);
   f39 = Math_fround(HEAPF32[i29 + (i34 * 76 | 0) + 24 >> 2]);
   f64 = Math_fround(HEAPF32[i29 + (i34 * 76 | 0) + 28 >> 2]);
   f61 = Math_fround(HEAPF32[i33 + (i45 * 40 | 0) + 16 >> 2]);
   f65 = Math_fround(f62 * f61);
   f59 = Math_fround(HEAPF32[i33 + (i45 * 40 | 0) + 24 >> 2]);
   f63 = Math_fround(f64 * f59);
   f66 = Math_fround(HEAPF32[i33 + (i45 * 40 | 0) + 20 >> 2]);
   f67 = Math_fround(f60 * f66);
   f38 = Math_fround(HEAPF32[i33 + (i45 * 40 | 0) + 12 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f39 * f59)) - Math_fround(f64 * f66)) - Math_fround(f60 * f38));
   f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f62 * f38)) - Math_fround(f39 * f66)) - Math_fround(f60 * f61));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f39 * f61)) - Math_fround(f62 * f59)) - Math_fround(f64 * f38));
   f61 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f38) - Math_fround(f62 * f66)) - Math_fround(f60 * f59)) - Math_fround(f64 * f61));
   i33 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i34 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f61 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(f61 * f61);
   f65 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f65 * f65);
   f59 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f59 * f59)) + Math_fround(f67 + f64)))));
   f65 = Math_fround(f64 * f65);
   f59 = Math_fround(f64 * f59);
   f63 = Math_fround(f64 * f63);
   HEAPF32[i7 >> 2] = Math_fround(f64 * f61);
   HEAPF32[i7 + 4 >> 2] = f65;
   HEAPF32[i7 + 8 >> 2] = f59;
   HEAPF32[i7 + 12 >> 2] = f63;
   i33 = (HEAP32[i1 >> 2] | 0) + i2 + (i10 * 40 | 0) | 0;
   HEAPF32[i9 >> 2] = Math_fround(0.0);
   HEAPF32[i9 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
   __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i8, i33, i43, i7, i9, i49, i11);
   i33 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   f63 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   i29 = i33 + (i10 * 40 | 0) + 12 | 0;
   f59 = Math_fround(HEAPF32[i29 >> 2]);
   f65 = Math_fround(f63 * f59);
   f61 = Math_fround(HEAPF32[i8 + 12 >> 2]);
   i34 = i33 + (i10 * 40 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i34 >> 2]);
   f67 = Math_fround(f61 * f64);
   f60 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   i30 = i33 + (i10 * 40 | 0) + 16 | 0;
   f66 = Math_fround(HEAPF32[i30 >> 2]);
   f62 = Math_fround(f60 * f66);
   f38 = Math_fround(HEAPF32[i8 >> 2]);
   i33 = i33 + (i10 * 40 | 0) + 20 | 0;
   f39 = Math_fround(HEAPF32[i33 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f39)) - Math_fround(f64 * f60)) - Math_fround(f66 * f38));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f38)) - Math_fround(f60 * f39)) - Math_fround(f63 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f39)) - Math_fround(f59 * f61)) - Math_fround(f64 * f38));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i28 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i26 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i26 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i29 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i30 >> 2] = f65;
   HEAPF32[i33 >> 2] = f66;
   HEAPF32[i34 >> 2] = f67;
   i34 = HEAP32[i3 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i34 | 0) == 0 ? 0 : i34 + i4 | 0, i55, i54, i10, i10);
  }
 }
 if (f40 > Math_fround(0.0)) {
  i33 = i51 + 40 | 0;
  i30 = HEAP32[i33 >> 2] | 0;
  i34 = i33;
  __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i30 | 0) == 0 ? 0 : i30 + i34 | 0, i54, i55, i45, i44);
  if ((i12 | 0) == -1) {
   i2 = i55 + 4 | 0;
   i1 = i2;
  } else {
   i2 = i55 + 4 | 0;
   i1 = i2;
   i30 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
   i28 = i30 + (i45 * 40 | 0) | 0;
   HEAP32[i57 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   i28 = (HEAP32[i33 >> 2] | 0) + i34 | 0;
   i29 = i28 + 16 | 0;
   i28 = i28 + 4 | 0;
   i28 = HEAP32[i28 + (HEAP32[i28 >> 2] | 0) + (i45 << 3) + 4 >> 2] | 0;
   i29 = i29 + (HEAP32[i29 >> 2] | 0) | 0;
   f59 = Math_fround(HEAPF32[i29 + (i28 * 76 | 0) + 16 >> 2]);
   f61 = Math_fround(HEAPF32[i29 + (i28 * 76 | 0) + 20 >> 2]);
   f38 = Math_fround(HEAPF32[i29 + (i28 * 76 | 0) + 24 >> 2]);
   f63 = Math_fround(HEAPF32[i29 + (i28 * 76 | 0) + 28 >> 2]);
   f64 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 16 >> 2]);
   f65 = Math_fround(f59 * f64);
   f66 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 24 >> 2]);
   f67 = Math_fround(f63 * f66);
   f60 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 20 >> 2]);
   f62 = Math_fround(f61 * f60);
   f39 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 12 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f38 * f66)) - Math_fround(f63 * f60)) - Math_fround(f61 * f39));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f39)) - Math_fround(f38 * f60)) - Math_fround(f61 * f64));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f38 * f64)) - Math_fround(f59 * f66)) - Math_fround(f63 * f39));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i30 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66)) + Math_fround(f62 + f63)))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i50 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i50 + 4 >> 2] = f65;
   HEAPF32[i50 + 8 >> 2] = f66;
   HEAPF32[i50 + 12 >> 2] = f67;
   if ((i46 | 0) != -1 & (i47 | 0) != -1) {
    i30 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
    i29 = i51 + 44 | 0;
    i29 = (HEAP32[i29 >> 2] | 0) + i29 + 4 | 0;
    i29 = i29 + (HEAP32[i29 >> 2] | 0) | 0;
    f62 = Math_fround(HEAPF32[i29 + (i46 * 40 | 0) >> 2]);
    f36 = Math_fround(HEAPF32[i29 + (i46 * 40 | 0) + 4 >> 2]);
    f39 = Math_fround(HEAPF32[i29 + (i46 * 40 | 0) + 8 >> 2]);
    f59 = Math_fround(HEAPF32[i29 + (i47 * 40 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i29 + (i47 * 40 | 0) + 4 >> 2]);
    f59 = Math_fround(Math_fround(f62 + f59) * Math_fround(.5));
    f63 = Math_fround(Math_fround(f36 + f63) * Math_fround(.5));
    f39 = Math_fround(Math_fround(f39 + Math_fround(HEAPF32[i29 + (i47 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
    f36 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 28 >> 2]);
    f62 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 32 >> 2]);
    f36 = Math_fround(f59 * f36);
    f62 = Math_fround(f63 * f62);
    f39 = Math_fround(f39 * Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 36 >> 2]));
    f63 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 16 >> 2]);
    f59 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 12 >> 2]);
    f67 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 24 >> 2]);
    f35 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 20 >> 2]);
    f32 = Math_fround(f63 * Math_fround(-2.0));
    f61 = Math_fround(f63 * Math_fround(2.0));
    f37 = Math_fround(f32 * f67);
    f64 = Math_fround(f35 * Math_fround(2.0));
    f38 = Math_fround(f35 * Math_fround(-2.0));
    f31 = Math_fround(f67 * f38);
    f60 = Math_fround(f59 * Math_fround(-2.0));
    f66 = Math_fround(f59 * Math_fround(2.0));
    f67 = Math_fround(f67 * f60);
    f65 = Math_fround(Math_fround(f36 + Math_fround(f36 * Math_fround(Math_fround(f63 * f32) - Math_fround(f35 * f64)))) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f66 * f35) - f37)) + Math_fround(f62 * Math_fround(f31 - Math_fround(f63 * f60)))));
    f66 = Math_fround(Math_fround(f62 + Math_fround(f36 * Math_fround(Math_fround(f59 * f61) - f31))) + Math_fround(Math_fround(f39 * Math_fround(f67 - Math_fround(f32 * f35))) + Math_fround(f62 * Math_fround(Math_fround(f35 * f38) - Math_fround(f59 * f66)))));
    f67 = Math_fround(Math_fround(f39 + Math_fround(f36 * Math_fround(f37 - Math_fround(f59 * f38)))) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f59 * f60) - Math_fround(f63 * f61))) + Math_fround(f62 * Math_fround(Math_fround(f63 * f64) - f67))));
    f64 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 4 >> 2]);
    f66 = Math_fround(f63 + f66);
    f67 = Math_fround(Math_fround(HEAPF32[i30 + (i45 * 40 | 0) + 8 >> 2]) + f67);
    HEAPF32[i57 >> 2] = Math_fround(f64 + f65);
    HEAPF32[i57 + 4 >> 2] = f66;
    HEAPF32[i57 + 8 >> 2] = f67;
   }
   i29 = (HEAP32[i2 >> 2] | 0) + i1 + (i12 * 40 | 0) | 0;
   HEAPF32[i42 >> 2] = Math_fround(0.0);
   HEAPF32[i42 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i43 >> 2] = Math_fround(f40 * Math_fround(.5));
   __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i41, i29, i57, i50, i42, i49, i43);
   i29 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
   f63 = Math_fround(HEAPF32[i41 + 4 >> 2]);
   i27 = i29 + (i12 * 40 | 0) + 12 | 0;
   f59 = Math_fround(HEAPF32[i27 >> 2]);
   f65 = Math_fround(f63 * f59);
   f61 = Math_fround(HEAPF32[i41 + 12 >> 2]);
   i30 = i29 + (i12 * 40 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i30 >> 2]);
   f67 = Math_fround(f61 * f64);
   f60 = Math_fround(HEAPF32[i41 + 8 >> 2]);
   i28 = i29 + (i12 * 40 | 0) + 16 | 0;
   f66 = Math_fround(HEAPF32[i28 >> 2]);
   f62 = Math_fround(f60 * f66);
   f38 = Math_fround(HEAPF32[i41 >> 2]);
   i29 = i29 + (i12 * 40 | 0) + 20 | 0;
   f39 = Math_fround(HEAPF32[i29 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f39)) - Math_fround(f64 * f60)) - Math_fround(f66 * f38));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f38)) - Math_fround(f60 * f39)) - Math_fround(f63 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f39)) - Math_fround(f59 * f61)) - Math_fround(f64 * f38));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i26 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i24 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i26 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i27 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i28 >> 2] = f65;
   HEAPF32[i29 >> 2] = f66;
   HEAPF32[i30 >> 2] = f67;
   i30 = HEAP32[i33 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i30 | 0) == 0 ? 0 : i30 + i34 | 0, i55, i54, i12, i12);
  }
  i21 = i50 + 4 | 0;
  i22 = i50 + 8 | 0;
  i23 = i50 + 12 | 0;
  i30 = (i46 | 0) != -1 & (i47 | 0) != -1;
  i24 = i51 + 44 | 0;
  i25 = i24;
  i26 = i57 + 4 | 0;
  i27 = i57 + 8 | 0;
  i28 = i42 + 4 | 0;
  i29 = i42 + 8 | 0;
  f5 = Math_fround(f40 * f40);
  i11 = i41 + 4 | 0;
  i12 = i41 + 12 | 0;
  i13 = i41 + 8 | 0;
  i10 = 0;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   i9 = i3 + i1 | 0;
   i4 = i9 + (i45 * 40 | 0) | 0;
   HEAP32[i57 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i4 = (HEAP32[i33 >> 2] | 0) + i34 | 0;
   i6 = i4 + 16 | 0;
   i4 = i4 + 4 | 0;
   i4 = HEAP32[i4 + (HEAP32[i4 >> 2] | 0) + (i45 << 3) + 4 >> 2] | 0;
   i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
   f59 = Math_fround(HEAPF32[i6 + (i4 * 76 | 0) + 16 >> 2]);
   f61 = Math_fround(HEAPF32[i6 + (i4 * 76 | 0) + 20 >> 2]);
   f39 = Math_fround(HEAPF32[i6 + (i4 * 76 | 0) + 24 >> 2]);
   f63 = Math_fround(HEAPF32[i6 + (i4 * 76 | 0) + 28 >> 2]);
   i4 = i9 + (i45 * 40 | 0) + 16 | 0;
   f64 = Math_fround(HEAPF32[i4 >> 2]);
   f65 = Math_fround(f59 * f64);
   i6 = i9 + (i45 * 40 | 0) + 24 | 0;
   f66 = Math_fround(HEAPF32[i6 >> 2]);
   f67 = Math_fround(f63 * f66);
   i7 = i9 + (i45 * 40 | 0) + 20 | 0;
   f60 = Math_fround(HEAPF32[i7 >> 2]);
   f62 = Math_fround(f61 * f60);
   i8 = i9 + (i45 * 40 | 0) + 12 | 0;
   f40 = Math_fround(HEAPF32[i8 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f39 * f66)) - Math_fround(f63 * f60)) - Math_fround(f61 * f40));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f40)) - Math_fround(f39 * f60)) - Math_fround(f61 * f64));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f39 * f64)) - Math_fround(f59 * f66)) - Math_fround(f63 * f40));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i68 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i70 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i68 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66)) + Math_fround(f62 + f63)))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i50 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i21 >> 2] = f65;
   HEAPF32[i22 >> 2] = f66;
   HEAPF32[i23 >> 2] = f67;
   if (i30) {
    i3 = (HEAP32[i24 >> 2] | 0) + i25 + 4 | 0;
    i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
    f62 = Math_fround(HEAPF32[i3 + (i46 * 40 | 0) >> 2]);
    f37 = Math_fround(HEAPF32[i3 + (i46 * 40 | 0) + 4 >> 2]);
    f40 = Math_fround(HEAPF32[i3 + (i46 * 40 | 0) + 8 >> 2]);
    f59 = Math_fround(HEAPF32[i3 + (i47 * 40 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i3 + (i47 * 40 | 0) + 4 >> 2]);
    f59 = Math_fround(Math_fround(f62 + f59) * Math_fround(.5));
    f63 = Math_fround(Math_fround(f37 + f63) * Math_fround(.5));
    f40 = Math_fround(Math_fround(f40 + Math_fround(HEAPF32[i3 + (i47 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
    f37 = Math_fround(HEAPF32[i9 + (i45 * 40 | 0) + 28 >> 2]);
    f62 = Math_fround(HEAPF32[i9 + (i45 * 40 | 0) + 32 >> 2]);
    f37 = Math_fround(f59 * f37);
    f62 = Math_fround(f63 * f62);
    f40 = Math_fround(f40 * Math_fround(HEAPF32[i9 + (i45 * 40 | 0) + 36 >> 2]));
    f63 = Math_fround(HEAPF32[i4 >> 2]);
    f59 = Math_fround(HEAPF32[i8 >> 2]);
    f67 = Math_fround(HEAPF32[i6 >> 2]);
    f36 = Math_fround(HEAPF32[i7 >> 2]);
    f35 = Math_fround(f63 * Math_fround(-2.0));
    f61 = Math_fround(f63 * Math_fround(2.0));
    f38 = Math_fround(f35 * f67);
    f64 = Math_fround(f36 * Math_fround(2.0));
    f39 = Math_fround(f36 * Math_fround(-2.0));
    f32 = Math_fround(f67 * f39);
    f60 = Math_fround(f59 * Math_fround(-2.0));
    f66 = Math_fround(f59 * Math_fround(2.0));
    f67 = Math_fround(f67 * f60);
    f65 = Math_fround(Math_fround(f37 + Math_fround(f37 * Math_fround(Math_fround(f63 * f35) - Math_fround(f36 * f64)))) + Math_fround(Math_fround(f40 * Math_fround(Math_fround(f66 * f36) - f38)) + Math_fround(f62 * Math_fround(f32 - Math_fround(f63 * f60)))));
    f66 = Math_fround(Math_fround(f62 + Math_fround(f37 * Math_fround(Math_fround(f59 * f61) - f32))) + Math_fround(Math_fround(f40 * Math_fround(f67 - Math_fround(f35 * f36))) + Math_fround(f62 * Math_fround(Math_fround(f36 * f39) - Math_fround(f59 * f66)))));
    f67 = Math_fround(Math_fround(f40 + Math_fround(f37 * Math_fround(f38 - Math_fround(f59 * f39)))) + Math_fround(Math_fround(f40 * Math_fround(Math_fround(f59 * f60) - Math_fround(f63 * f61))) + Math_fround(f62 * Math_fround(Math_fround(f63 * f64) - f67))));
    f64 = Math_fround(HEAPF32[i9 + (i45 * 40 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i9 + (i45 * 40 | 0) + 4 >> 2]);
    f66 = Math_fround(f63 + f66);
    f67 = Math_fround(Math_fround(HEAPF32[i9 + (i45 * 40 | 0) + 8 >> 2]) + f67);
    HEAPF32[i57 >> 2] = Math_fround(f64 + f65);
    HEAPF32[i26 >> 2] = f66;
    HEAPF32[i27 >> 2] = f67;
    i3 = HEAP32[i2 >> 2] | 0;
   }
   HEAPF32[i42 >> 2] = Math_fround(0.0);
   HEAPF32[i28 >> 2] = Math_fround(1.0);
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   HEAPF32[i43 >> 2] = f5;
   __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i41, i3 + i1 + (i45 * 40 | 0) | 0, i57, i50, i42, i49, i43);
   i69 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
   f63 = Math_fround(HEAPF32[i11 >> 2]);
   i9 = i69 + (i45 * 40 | 0) + 12 | 0;
   f59 = Math_fround(HEAPF32[i9 >> 2]);
   f65 = Math_fround(f63 * f59);
   f61 = Math_fround(HEAPF32[i12 >> 2]);
   i70 = i69 + (i45 * 40 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i70 >> 2]);
   f67 = Math_fround(f61 * f64);
   f60 = Math_fround(HEAPF32[i13 >> 2]);
   i68 = i69 + (i45 * 40 | 0) + 16 | 0;
   f66 = Math_fround(HEAPF32[i68 >> 2]);
   f62 = Math_fround(f60 * f66);
   f39 = Math_fround(HEAPF32[i41 >> 2]);
   i69 = i69 + (i45 * 40 | 0) + 20 | 0;
   f40 = Math_fround(HEAPF32[i69 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f40)) - Math_fround(f64 * f60)) - Math_fround(f66 * f39));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f39)) - Math_fround(f60 * f40)) - Math_fround(f63 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f40)) - Math_fround(f59 * f61)) - Math_fround(f64 * f39));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i8 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i9 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i68 >> 2] = f65;
   HEAPF32[i69 >> 2] = f66;
   HEAPF32[i70 >> 2] = f67;
   i70 = HEAP32[i33 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i70 | 0) == 0 ? 0 : i70 + i34 | 0, i55, i54, i45, i45);
   i70 = HEAP32[i33 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i70 | 0) == 0 ? 0 : i70 + i34 | 0, i54, i55, i45, i45);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != 3);
 }
 if (Math_fround(HEAPF32[i48 >> 2]) > Math_fround(0.0)) {
  if ((i46 | 0) != -1) {
   i69 = i51 + 40 | 0;
   i34 = HEAP32[i69 >> 2] | 0;
   i70 = i69;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i34 | 0) == 0 ? 0 : i34 + i70 | 0, i54, i55, i46, i44);
   i34 = i55 + 4 | 0;
   i45 = i34;
   i68 = (HEAP32[i34 >> 2] | 0) + i45 | 0;
   i33 = i68 + (i46 * 40 | 0) | 0;
   HEAP32[i57 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   i33 = (HEAP32[i69 >> 2] | 0) + i70 | 0;
   i43 = i33 + 16 | 0;
   i33 = i33 + 4 | 0;
   i33 = HEAP32[i33 + (HEAP32[i33 >> 2] | 0) + (i46 << 3) + 4 >> 2] | 0;
   i43 = i43 + (HEAP32[i43 >> 2] | 0) | 0;
   f62 = Math_fround(HEAPF32[i43 + (i33 * 76 | 0) + 16 >> 2]);
   f60 = Math_fround(HEAPF32[i43 + (i33 * 76 | 0) + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i43 + (i33 * 76 | 0) + 24 >> 2]);
   f64 = Math_fround(HEAPF32[i43 + (i33 * 76 | 0) + 28 >> 2]);
   f61 = Math_fround(HEAPF32[i68 + (i46 * 40 | 0) + 16 >> 2]);
   f65 = Math_fround(f62 * f61);
   f59 = Math_fround(HEAPF32[i68 + (i46 * 40 | 0) + 24 >> 2]);
   f63 = Math_fround(f64 * f59);
   f66 = Math_fround(HEAPF32[i68 + (i46 * 40 | 0) + 20 >> 2]);
   f67 = Math_fround(f60 * f66);
   f39 = Math_fround(HEAPF32[i68 + (i46 * 40 | 0) + 12 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f40 * f59)) - Math_fround(f64 * f66)) - Math_fround(f60 * f39));
   f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f62 * f39)) - Math_fround(f40 * f66)) - Math_fround(f60 * f61));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f40 * f61)) - Math_fround(f62 * f59)) - Math_fround(f64 * f39));
   f61 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) - Math_fround(f62 * f66)) - Math_fround(f60 * f59)) - Math_fround(f64 * f61));
   i68 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i33 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
   i43 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f61 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(f61 * f61);
   f65 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f65 * f65);
   f59 = (HEAP32[tempDoublePtr >> 2] = i68 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f59 * f59)) + Math_fround(f67 + f64)))));
   f65 = Math_fround(f64 * f65);
   f59 = Math_fround(f64 * f59);
   f63 = Math_fround(f64 * f63);
   HEAPF32[i50 >> 2] = Math_fround(f64 * f61);
   HEAPF32[i50 + 4 >> 2] = f65;
   HEAPF32[i50 + 8 >> 2] = f59;
   HEAPF32[i50 + 12 >> 2] = f63;
   i68 = (HEAP32[i34 >> 2] | 0) + i45 + (i46 * 40 | 0) | 0;
   HEAPF32[i42 >> 2] = Math_fround(-1.0);
   HEAPF32[i42 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
   __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i41, i68, i57, i50, i42, i49, i48);
   i45 = (HEAP32[i34 >> 2] | 0) + i45 | 0;
   f63 = Math_fround(HEAPF32[i41 + 4 >> 2]);
   i34 = i45 + (i46 * 40 | 0) + 12 | 0;
   f59 = Math_fround(HEAPF32[i34 >> 2]);
   f65 = Math_fround(f63 * f59);
   f61 = Math_fround(HEAPF32[i41 + 12 >> 2]);
   i68 = i45 + (i46 * 40 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i68 >> 2]);
   f67 = Math_fround(f61 * f64);
   f60 = Math_fround(HEAPF32[i41 + 8 >> 2]);
   i43 = i45 + (i46 * 40 | 0) + 16 | 0;
   f66 = Math_fround(HEAPF32[i43 >> 2]);
   f62 = Math_fround(f60 * f66);
   f39 = Math_fround(HEAPF32[i41 >> 2]);
   i45 = i45 + (i46 * 40 | 0) + 20 | 0;
   f40 = Math_fround(HEAPF32[i45 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f40)) - Math_fround(f64 * f60)) - Math_fround(f66 * f39));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f39)) - Math_fround(f60 * f40)) - Math_fround(f63 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f40)) - Math_fround(f59 * f61)) - Math_fround(f64 * f39));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i33 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i29 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i33 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i34 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i43 >> 2] = f65;
   HEAPF32[i45 >> 2] = f66;
   HEAPF32[i68 >> 2] = f67;
   i69 = HEAP32[i69 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i69 | 0) == 0 ? 0 : i69 + i70 | 0, i55, i54, i46, i46);
  }
  if ((i47 | 0) != -1) {
   i69 = i51 + 40 | 0;
   i68 = HEAP32[i69 >> 2] | 0;
   i70 = i69;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i68 | 0) == 0 ? 0 : i68 + i70 | 0, i54, i55, i47, i44);
   i68 = i55 + 4 | 0;
   i46 = i68;
   i45 = (HEAP32[i68 >> 2] | 0) + i46 | 0;
   i44 = i45 + (i47 * 40 | 0) | 0;
   HEAP32[i57 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   i44 = (HEAP32[i69 >> 2] | 0) + i70 | 0;
   i43 = i44 + 16 | 0;
   i44 = i44 + 4 | 0;
   i44 = HEAP32[i44 + (HEAP32[i44 >> 2] | 0) + (i47 << 3) + 4 >> 2] | 0;
   i43 = i43 + (HEAP32[i43 >> 2] | 0) | 0;
   f62 = Math_fround(HEAPF32[i43 + (i44 * 76 | 0) + 16 >> 2]);
   f60 = Math_fround(HEAPF32[i43 + (i44 * 76 | 0) + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i43 + (i44 * 76 | 0) + 24 >> 2]);
   f64 = Math_fround(HEAPF32[i43 + (i44 * 76 | 0) + 28 >> 2]);
   f61 = Math_fround(HEAPF32[i45 + (i47 * 40 | 0) + 16 >> 2]);
   f65 = Math_fround(f62 * f61);
   f59 = Math_fround(HEAPF32[i45 + (i47 * 40 | 0) + 24 >> 2]);
   f63 = Math_fround(f64 * f59);
   f66 = Math_fround(HEAPF32[i45 + (i47 * 40 | 0) + 20 >> 2]);
   f67 = Math_fround(f60 * f66);
   f39 = Math_fround(HEAPF32[i45 + (i47 * 40 | 0) + 12 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f40 * f59)) - Math_fround(f64 * f66)) - Math_fround(f60 * f39));
   f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f62 * f39)) - Math_fround(f40 * f66)) - Math_fround(f60 * f61));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f40 * f61)) - Math_fround(f62 * f59)) - Math_fround(f64 * f39));
   f61 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) - Math_fround(f62 * f66)) - Math_fround(f60 * f59)) - Math_fround(f64 * f61));
   i45 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i44 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
   i43 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f61 = (HEAP32[tempDoublePtr >> 2] = i44 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(f61 * f61);
   f65 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f65 * f65);
   f59 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f59 * f59)) + Math_fround(f67 + f64)))));
   f65 = Math_fround(f64 * f65);
   f59 = Math_fround(f64 * f59);
   f63 = Math_fround(f64 * f63);
   HEAPF32[i50 >> 2] = Math_fround(f64 * f61);
   HEAPF32[i50 + 4 >> 2] = f65;
   HEAPF32[i50 + 8 >> 2] = f59;
   HEAPF32[i50 + 12 >> 2] = f63;
   i45 = (HEAP32[i68 >> 2] | 0) + i46 + (i47 * 40 | 0) | 0;
   HEAPF32[i42 >> 2] = Math_fround(-1.0);
   HEAPF32[i42 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
   __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i41, i45, i57, i50, i42, i49, i48);
   i49 = (HEAP32[i68 >> 2] | 0) + i46 | 0;
   f63 = Math_fround(HEAPF32[i41 + 4 >> 2]);
   i46 = i49 + (i47 * 40 | 0) + 12 | 0;
   f59 = Math_fround(HEAPF32[i46 >> 2]);
   f65 = Math_fround(f63 * f59);
   f61 = Math_fround(HEAPF32[i41 + 12 >> 2]);
   i68 = i49 + (i47 * 40 | 0) + 24 | 0;
   f64 = Math_fround(HEAPF32[i68 >> 2]);
   f67 = Math_fround(f61 * f64);
   f60 = Math_fround(HEAPF32[i41 + 8 >> 2]);
   i48 = i49 + (i47 * 40 | 0) + 16 | 0;
   f66 = Math_fround(HEAPF32[i48 >> 2]);
   f62 = Math_fround(f60 * f66);
   f39 = Math_fround(HEAPF32[i41 >> 2]);
   i49 = i49 + (i47 * 40 | 0) + 20 | 0;
   f40 = Math_fround(HEAPF32[i49 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f61 * f40)) - Math_fround(f64 * f60)) - Math_fround(f66 * f39));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f39)) - Math_fround(f60 * f40)) - Math_fround(f63 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f63 * f40)) - Math_fround(f59 * f61)) - Math_fround(f64 * f39));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i45 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i43 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i44 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i43 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f62 + f63) + Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66))))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i46 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i48 >> 2] = f65;
   HEAPF32[i49 >> 2] = f66;
   HEAPF32[i68 >> 2] = f67;
   i69 = HEAP32[i69 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i69 | 0) == 0 ? 0 : i69 + i70 | 0, i55, i54, i47, i47);
  }
 }
 i10 = i51 + 40 | 0;
 i11 = i10;
 i12 = i55 + 4 | 0;
 i13 = i12;
 i2 = i57 + 4 | 0;
 i3 = i57 + 8 | 0;
 i4 = i51 + 384 | 0;
 i6 = i51 + 380 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i51 + 72 + (HEAP32[gb + 179492 + (i1 << 4) + 4 >> 2] << 2) >> 2] | 0;
  i8 = HEAP32[i51 + 72 + (HEAP32[gb + 179492 + (i1 << 4) + 8 >> 2] << 2) >> 2] | 0;
  i9 = HEAP32[i51 + 72 + (HEAP32[gb + 179492 + (i1 << 4) + 12 >> 2] << 2) >> 2] | 0;
  f5 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 40 >> 2]);
  if (f5 > Math_fround(0.0)) {
   f67 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f5))));
   i69 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i69 | 0) == 0 ? 0 : i69 + i11 | 0, i54, i55, i9, i53);
   i69 = (HEAP32[i12 >> 2] | 0) + i13 | 0;
   i70 = i52 + 68 + (i1 << 6) | 0;
   f63 = Math_fround(HEAPF32[i70 >> 2]);
   f61 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 4 >> 2]);
   f62 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 8 >> 2]);
   f64 = Math_fround(HEAPF32[i69 + (i9 * 40 | 0) >> 2]);
   f65 = Math_fround(HEAPF32[i69 + (i9 * 40 | 0) + 4 >> 2]);
   f66 = Math_fround(HEAPF32[i69 + (i9 * 40 | 0) + 8 >> 2]);
   f65 = Math_fround(f65 + Math_fround(f67 * Math_fround(f61 - f65)));
   f66 = Math_fround(f66 + Math_fround(f67 * Math_fround(f62 - f66)));
   HEAPF32[i57 >> 2] = Math_fround(f64 + Math_fround(f67 * Math_fround(f63 - f64)));
   HEAPF32[i2 >> 2] = f65;
   HEAPF32[i3 >> 2] = f66;
   i69 = HEAP32[i10 >> 2] | 0;
   HEAPF32[i50 >> 2] = Math_fround(f67 * Math_fround(HEAPF32[((i1 | 0) < 2 ? i4 : i6) >> 2]));
   __ZN7mecanim8skeleton25Skeleton2BoneAdjustLengthEPKNS0_8SkeletonEiiiRKN4math7_float3ERKfPNS0_13SkeletonPoseTINS4_4trsXEEESD_((i69 | 0) == 0 ? 0 : i69 + i11 | 0, i7, i8, i9, i57, i50, i54, i55);
   i69 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i69 | 0) == 0 ? 0 : i69 + i11 | 0, i54, i55, i9, i7);
   i69 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton15Skeleton2BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_((i69 | 0) == 0 ? 0 : i69 + i11 | 0, i7, i8, i9, i70, f67, i54, i55);
  }
  f5 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 60 >> 2]);
  if (f5 > Math_fround(0.0)) {
   f67 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f5))));
   i70 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i70 | 0) == 0 ? 0 : i70 + i11 | 0, i54, i55, i9, i7);
   i70 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton23Skeleton2BoneAdjustHintEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_f((i70 | 0) == 0 ? 0 : i70 + i11 | 0, i7, i8, i9, i52 + 68 + (i1 << 6) + 48 | 0, f67, i54, i55, Math_fround(.0500000007));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i2 = i57 + 4 | 0;
 i3 = i57 + 8 | 0;
 i4 = i57 + 12 | 0;
 i1 = 0;
 do {
  f5 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 44 >> 2]);
  if (f5 > Math_fround(0.0)) {
   i70 = HEAP32[i51 + 72 + (HEAP32[gb + 179492 + (i1 << 4) + 12 >> 2] << 2) >> 2] | 0;
   f63 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f5))));
   i69 = HEAP32[i10 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i69 | 0) == 0 ? 0 : i69 + i11 | 0, i54, i55, i70, i53);
   i70 = HEAP32[i51 + 72 + (HEAP32[gb + 179492 + (i1 << 4) >> 2] << 2) >> 2] | 0;
   i69 = (HEAP32[i12 >> 2] | 0) + i13 | 0;
   i50 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
   i49 = i50 + 16 | 0;
   i50 = i50 + 4 | 0;
   i50 = HEAP32[i50 + (HEAP32[i50 >> 2] | 0) + (i70 << 3) + 4 >> 2] | 0;
   i49 = i49 + (HEAP32[i49 >> 2] | 0) | 0;
   f64 = Math_fround(HEAPF32[i49 + (i50 * 76 | 0) + 16 >> 2]);
   f60 = Math_fround(HEAPF32[i49 + (i50 * 76 | 0) + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i49 + (i50 * 76 | 0) + 24 >> 2]);
   f61 = Math_fround(HEAPF32[i49 + (i50 * 76 | 0) + 28 >> 2]);
   f67 = Math_fround(HEAPF32[i69 + (i70 * 40 | 0) + 16 >> 2]);
   f65 = Math_fround(f64 * f67);
   f59 = Math_fround(HEAPF32[i69 + (i70 * 40 | 0) + 24 >> 2]);
   f66 = Math_fround(f61 * f59);
   f39 = Math_fround(HEAPF32[i69 + (i70 * 40 | 0) + 20 >> 2]);
   f38 = Math_fround(f60 * f39);
   f62 = Math_fround(HEAPF32[i69 + (i70 * 40 | 0) + 12 >> 2]);
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f40 * f59)) - Math_fround(f61 * f39)) - Math_fround(f60 * f62));
   f66 = Math_fround(Math_fround(Math_fround(f66 - Math_fround(f64 * f62)) - Math_fround(f40 * f39)) - Math_fround(f60 * f67));
   f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f40 * f67)) - Math_fround(f64 * f59)) - Math_fround(f61 * f62));
   f67 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f62) - Math_fround(f64 * f39)) - Math_fround(f60 * f59)) - Math_fround(f61 * f67));
   i69 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i50 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
   i49 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f67 = (HEAP32[tempDoublePtr >> 2] = i50 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(f67 * f67);
   f65 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround(f65 * f65);
   f59 = (HEAP32[tempDoublePtr >> 2] = i69 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f66 * f66) + Math_fround(f59 * f59)) + Math_fround(f38 + f61)))));
   f67 = Math_fround(f61 * f67);
   f65 = Math_fround(f61 * f65);
   f59 = Math_fround(f61 * f59);
   f66 = Math_fround(f61 * f66);
   f61 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 12 >> 2]);
   f38 = Math_fround(f67 * f61);
   f60 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 16 >> 2]);
   f39 = Math_fround(f65 * f60);
   f64 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 20 >> 2]);
   f62 = Math_fround(f59 * f64);
   f40 = Math_fround(HEAPF32[i52 + 68 + (i1 << 6) + 24 >> 2]);
   f62 = Math_fround(Math_fround(f38 + f39) + Math_fround(f62 + Math_fround(f66 * f40)));
   i69 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = i69 & -2147483648;
   i49 = i69 ^ (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
   i50 = i69 ^ (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
   i68 = i69 ^ (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = i69 ^ (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f67);
   f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f65);
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f59);
   f40 = Math_fround(f67 + Math_fround(f63 * f40));
   f64 = Math_fround(f65 + Math_fround(f63 * f64));
   f60 = Math_fround(f59 + Math_fround(f63 * f60));
   f66 = Math_fround(f66 + Math_fround(f63 * Math_fround((HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f66)));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f64 * f64)) + Math_fround(Math_fround(f60 * f60) + Math_fround(f66 * f66))))));
   f40 = Math_fround(f63 * f40);
   f64 = Math_fround(f63 * f64);
   f60 = Math_fround(f63 * f60);
   f66 = Math_fround(f63 * f66);
   i69 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
   i68 = i69 + 16 | 0;
   i69 = i69 + 4 | 0;
   i70 = HEAP32[i69 + (HEAP32[i69 >> 2] | 0) + (i70 << 3) + 4 >> 2] | 0;
   i68 = i68 + (HEAP32[i68 >> 2] | 0) | 0;
   f63 = Math_fround(HEAPF32[i68 + (i70 * 76 | 0) + 28 >> 2]);
   f59 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + (i70 * 76 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f59 * f64);
   f67 = Math_fround(f63 * f66);
   f61 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + (i70 * 76 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f61 * f60);
   f39 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + (i70 * 76 | 0) + 24 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f39 * f66)) - Math_fround(f63 * f60)) - Math_fround(f61 * f40));
   f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f59 * f40)) - Math_fround(f39 * f60)) - Math_fround(f61 * f64));
   f62 = Math_fround(Math_fround(Math_fround(f62 - Math_fround(f39 * f64)) - Math_fround(f59 * f66)) - Math_fround(f63 * f40));
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f59 * f60)) - Math_fround(f61 * f66)) - Math_fround(f63 * f64));
   i70 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   i68 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f64 = (HEAP32[tempDoublePtr >> 2] = i68 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f64 * f64);
   f65 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f65 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i70 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66)) + Math_fround(f62 + f63)))));
   f65 = Math_fround(f63 * f65);
   f66 = Math_fround(f63 * f66);
   f67 = Math_fround(f63 * f67);
   HEAPF32[i57 >> 2] = Math_fround(f63 * f64);
   HEAPF32[i2 >> 2] = f65;
   HEAPF32[i3 >> 2] = f66;
   HEAPF32[i4 >> 2] = f67;
   __ZN7mecanim5human17ReachGoalRotationEPKNS0_5HumanERKN4math7_float4EiPNS_8skeleton13SkeletonPoseTINS4_4trsXEEESC_SC_(i51, i57, i1, i54, i55, i56);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 STACKTOP = i58;
 return;
}

function __ZN13AvatarBuilder19BuildAvatarInternalER6AvatarRKNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERK10GameObjectRK16HumanDescriptionNS_7OptionsEb(i60, i61, i1, i45, i10, i36) {
 i60 = i60 | 0;
 i61 = i61 | 0;
 i1 = i1 | 0;
 i45 = i45 | 0;
 i10 = i10 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i62 + 200 | 0;
 i42 = i62 + 184 | 0;
 i43 = i62 + 168 | 0;
 i44 = i62 + 156 | 0;
 i53 = i62 + 96 | 0;
 i54 = i62 + 80 | 0;
 i55 = i62 + 40 | 0;
 i47 = i62 + 24 | 0;
 i46 = i62 + 12 | 0;
 i41 = i62;
 i32 = i62 + 144 | 0;
 i31 = i62 + 132 | 0;
 i30 = i62 + 120 | 0;
 HEAP32[i53 >> 2] = gb + 176376 + 8;
 i56 = i53 + 8 | 0;
 HEAP32[i56 >> 2] = 0;
 HEAP32[i53 + 12 >> 2] = 0;
 HEAP32[i53 + 20 >> 2] = 30720;
 HEAP32[i53 + 4 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i54 + 4 >> 2] = 0;
 HEAP32[i54 + 8 >> 2] = 0;
 i57 = i54 + 4 | 0;
 HEAP32[i54 >> 2] = i57;
 i58 = i61 + 4 | 0;
 i59 = __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE(((HEAP32[i58 >> 2] | 0) - (HEAP32[i61 >> 2] | 0) | 0) / 36 | 0, 0, i53) | 0;
 if (HEAP32[i59 >> 2] | 0) {
  i6 = i59 + 4 | 0;
  i7 = i6;
  i8 = i59 + 8 | 0;
  i9 = i8;
  i5 = 0;
  do {
   i4 = HEAP32[i61 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i4 + (i5 * 36 | 0) + 32 >> 2] | 0) + 100 >> 2] | 0;
   i2 = HEAP32[i58 >> 2] | 0;
   i1 = i4;
   L5 : do if ((i2 | 0) == (i1 | 0)) i1 = -1; else {
    i2 = (i2 - i1 | 0) / 36 | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i4 + (i1 * 36 | 0) + 32 >> 2] | 0) == (i3 | 0)) break L5;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) {
      i1 = -1;
      break;
     }
    }
   } while (0);
   i2 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
   HEAP32[i2 + (i5 << 3) >> 2] = i1;
   HEAP32[i2 + (i5 << 3) + 4 >> 2] = -1;
   i1 = i4 + (i5 * 36 | 0) + 16 | 0;
   i2 = HEAP8[i1 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i4 + (i5 * 36 | 0) + 20 >> 2] | 0;
   } else {
    i3 = i1;
    i1 = i2 & 255;
   };
   HEAP32[i48 >> 2] = 0;
   HEAP32[i48 + 4 >> 2] = 0;
   HEAP32[i48 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i48, i3, i1);
   i52 = __Z14ProccessStringRNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEERKNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEE(i54, i48) | 0;
   HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i5 << 2) >> 2] = i52;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i59 >> 2] | 0) >>> 0);
 }
 i51 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i59, i53) | 0;
 i52 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i59, i53) | 0;
 i35 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i59, i53) | 0;
 i50 = (HEAP32[i58 >> 2] | 0) - (HEAP32[i61 >> 2] | 0) | 0;
 i1 = (i50 | 0) / 36 | 0;
 if (!i50) i50 = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i53 >> 2] >> 2] | 0, i53 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) == (i3 + (i1 << 2) | 0)) i50 = i3; else {
   _memset(i3 | 0, 0, i2 | 0) | 0;
   i50 = i3;
  }
 }
 i1 = HEAP32[i61 >> 2] | 0;
 if ((HEAP32[i58 >> 2] | 0) != (i1 | 0)) {
  i4 = 0;
  do {
   i2 = i1 + (i4 * 36 | 0) + 16 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP8[i1 + (i4 * 36 | 0) + 16 + 11 >> 0] | 0;
   if (i3 << 24 >> 24 < 0) i1 = HEAP32[i1 + (i4 * 36 | 0) + 20 >> 2] | 0; else i1 = i3 & 255;
   i1 = __Z24GetLastPathNameComponentPKcj(i2, i1) | 0;
   i40 = _strlen(i1) | 0;
   i3 = i1 + i40 | 0;
   if ((i40 | 0) > 0) {
    i2 = -1;
    do {
     i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = ~i2;
   } else i1 = 0;
   HEAP32[i50 + (i4 << 2) >> 2] = i1;
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i61 >> 2] | 0;
  } while (i4 >>> 0 < (((HEAP32[i58 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0);
 }
 __ZN13AvatarBuilder36ReadFromLocalTransformToSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNSt3__26vectorINS_14NamedTransformENS7_9allocatorIS9_EEEE(i51, i61);
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(i51, i52);
 i6 = i45 + 12 | 0;
 i7 = i45 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = i3;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i52 + 4 | 0;
  i5 = i4;
  i25 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
  i40 = i25;
  i24 = i1 + 32 | 0;
  i39 = i1 + 60 | 0;
  i26 = HEAP32[i24 + 4 >> 2] | 0;
  i27 = HEAP32[i24 + 8 >> 2] | 0;
  i28 = HEAP32[i1 + 44 >> 2] | 0;
  i29 = HEAP32[i1 + 48 >> 2] | 0;
  i33 = HEAP32[i1 + 52 >> 2] | 0;
  i34 = HEAP32[i1 + 56 >> 2] | 0;
  i37 = HEAP32[i39 >> 2] | 0;
  i38 = HEAP32[i39 + 4 >> 2] | 0;
  i39 = HEAP32[i39 + 8 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i40 + 4 >> 2] = i26;
  HEAP32[i40 + 8 >> 2] = i27;
  HEAP32[i40 + 12 >> 2] = i28;
  HEAP32[i40 + 16 >> 2] = i29;
  HEAP32[i40 + 20 >> 2] = i33;
  HEAP32[i40 + 24 >> 2] = i34;
  HEAP32[i40 + 28 >> 2] = i37;
  HEAP32[i40 + 32 >> 2] = i38;
  HEAP32[i40 + 36 >> 2] = i39;
  if (((i2 - i3 | 0) / 72 | 0) >>> 0 > 1) {
   i3 = 1;
   do {
    i2 = (__ZN12_GLOBAL__N_1L20GetIndexFromBoneNameENSt3__211__wrap_iterIPKN13AvatarBuilder14NamedTransformEEES6_RK8UnityStr((HEAP32[i61 >> 2] | 0) + 36 | 0, HEAP32[i58 >> 2] | 0, i1 + (i3 * 72 | 0) | 0) | 0) + 1 | 0;
    if (i2 | 0) {
     i40 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
     i25 = i1 + (i3 * 72 | 0) + 32 | 0;
     i39 = i1 + (i3 * 72 | 0) + 60 | 0;
     i26 = HEAP32[i25 + 4 >> 2] | 0;
     i27 = HEAP32[i25 + 8 >> 2] | 0;
     i28 = HEAP32[i1 + (i3 * 72 | 0) + 44 >> 2] | 0;
     i29 = HEAP32[i1 + (i3 * 72 | 0) + 48 >> 2] | 0;
     i33 = HEAP32[i1 + (i3 * 72 | 0) + 52 >> 2] | 0;
     i34 = HEAP32[i1 + (i3 * 72 | 0) + 56 >> 2] | 0;
     i37 = HEAP32[i39 >> 2] | 0;
     i38 = HEAP32[i39 + 4 >> 2] | 0;
     i39 = HEAP32[i39 + 8 >> 2] | 0;
     HEAP32[i40 + (i2 * 40 | 0) >> 2] = HEAP32[i25 >> 2];
     HEAP32[i40 + (i2 * 40 | 0) + 4 >> 2] = i26;
     HEAP32[i40 + (i2 * 40 | 0) + 8 >> 2] = i27;
     HEAP32[i40 + (i2 * 40 | 0) + 12 >> 2] = i28;
     HEAP32[i40 + (i2 * 40 | 0) + 16 >> 2] = i29;
     HEAP32[i40 + (i2 * 40 | 0) + 20 >> 2] = i33;
     HEAP32[i40 + (i2 * 40 | 0) + 24 >> 2] = i34;
     HEAP32[i40 + (i2 * 40 | 0) + 28 >> 2] = i37;
     HEAP32[i40 + (i2 * 40 | 0) + 32 >> 2] = i38;
     HEAP32[i40 + (i2 * 40 | 0) + 36 >> 2] = i39;
    }
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   } while (i3 >>> 0 < (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 72 | 0) >>> 0);
  }
 }
 i1 = i55 + 24 | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i55 + 4 >> 2] = 0;
 HEAP32[i55 + 8 >> 2] = 0;
 HEAP32[i55 + 12 >> 2] = 0;
 HEAP32[i55 + 16 >> 2] = 0;
 HEAP32[i55 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i55 + 28 >> 2] = 1065353216;
 HEAP32[i55 + 32 >> 2] = 1065353216;
 HEAP32[i55 + 36 >> 2] = 1065353216;
 if ((HEAP32[i10 >> 2] | 0) == 3) {
  i1 = HEAP32[i59 >> 2] | 0;
  HEAP32[i47 >> 2] = 0;
  i40 = i47 + 4 | 0;
  HEAP32[i40 >> 2] = 0;
  HEAP32[i47 + 8 >> 2] = 0;
  if (!i1) i1 = 0; else {
   if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i47);
   i39 = i1 << 2;
   i38 = __Znwj(i39) | 0;
   HEAP32[i47 >> 2] = i38;
   i1 = i38 + (i1 << 2) | 0;
   HEAP32[i47 + 8 >> 2] = i1;
   _memset(i38 | 0, -1, i39 | 0) | 0;
   HEAP32[i40 >> 2] = i1;
   i1 = HEAP32[i59 >> 2] | 0;
  }
  HEAP32[i46 >> 2] = 0;
  i39 = i46 + 4 | 0;
  HEAP32[i39 >> 2] = 0;
  HEAP32[i46 + 8 >> 2] = 0;
  if (!i1) i1 = 0; else {
   if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i46);
   i38 = i1 << 2;
   i37 = __Znwj(i38) | 0;
   HEAP32[i46 >> 2] = i37;
   i1 = i37 + (i1 << 2) | 0;
   HEAP32[i46 + 8 >> 2] = i1;
   _memset(i37 | 0, -1, i38 | 0) | 0;
   HEAP32[i39 >> 2] = i1;
   i1 = HEAP32[i59 >> 2] | 0;
  }
  HEAP32[i41 >> 2] = 0;
  i38 = i41 + 4 | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  if (i1 | 0) {
   if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i41);
   i34 = i1 << 2;
   i33 = __Znwj(i34) | 0;
   HEAP32[i41 >> 2] = i33;
   i37 = i33 + (i1 << 2) | 0;
   HEAP32[i41 + 8 >> 2] = i37;
   _memset(i33 | 0, -1, i34 | 0) | 0;
   HEAP32[i38 >> 2] = i37;
  }
  i37 = i45 + 4 | 0;
  i12 = i44 + 11 | 0;
  i13 = i44 + 4 | 0;
  i14 = i43 + 12 | 0;
  i10 = i43 + 12 | 0;
  i15 = i48 + 4 | 0;
  i16 = i43 + 8 | 0;
  i17 = i43 + 4 | 0;
  i18 = i43 + 11 | 0;
  i19 = i42 + 12 | 0;
  i11 = i42 + 12 | 0;
  i20 = i48 + 4 | 0;
  i21 = i42 + 8 | 0;
  i22 = i42 + 4 | 0;
  i23 = i42 + 11 | 0;
  i24 = i48 + 4 | 0;
  i25 = i48 + 4 | 0;
  i9 = 0;
  i28 = HEAP32[i37 >> 2] | 0;
  do {
   i2 = HEAP32[i45 >> 2] | 0;
   i4 = __ZN7mecanim5human8BoneNameEj(i9) | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, i4, _strlen(i4) | 0);
   i4 = HEAP8[i12 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i4 = i1 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i14 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i10 >> 2] | 0;
    i49 = 48;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i18 >> 0] = i4;
    if (!i4) i1 = i43; else {
     i1 = i43;
     i49 = 50;
    }
   } else i49 = 48;
   if ((i49 | 0) == 48) {
    i34 = i4 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i15 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i16 >> 2] = i34 | -2147483648;
    HEAP32[i17 >> 2] = i4;
    i49 = 50;
   }
   if ((i49 | 0) == 50) {
    i49 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i4 = HEAP8[i18 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i4 = i1 ? HEAP32[i17 >> 2] | 0 : i4 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i19 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i11 >> 2] | 0;
    i49 = 54;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i23 >> 0] = i4;
    if (!i4) i1 = i42; else {
     i1 = i42;
     i49 = 56;
    }
   } else i49 = 54;
   if ((i49 | 0) == 54) {
    i34 = i4 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i20 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i21 >> 2] = i34 | -2147483648;
    HEAP32[i22 >> 2] = i4;
    i49 = 56;
   }
   if ((i49 | 0) == 56) {
    i49 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i8 = HEAP8[i23 >> 0] | 0;
   L86 : do if ((i2 | 0) == (i28 | 0)) i2 = i28; else {
    i34 = i8 << 24 >> 24 < 0;
    i4 = i8 & 255;
    i5 = HEAP32[i22 >> 2] | 0;
    i7 = i34 ? i5 : i4;
    i6 = HEAP32[i42 >> 2] | 0;
    if (i34) while (1) {
     i1 = i2 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i3 = i34 << 24 >> 24 < 0;
     if ((i7 | 0) == ((i3 ? HEAP32[i2 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i6, i3 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) break L86;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i28 | 0)) {
      i2 = i28;
      break;
     }
    } else while (1) {
     i1 = i2 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i3 = i34 << 24 >> 24 < 0;
     if ((i7 | 0) == ((i3 ? HEAP32[i2 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i42, i3 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0)) break L86;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i28 | 0)) {
      i2 = i28;
      break;
     }
    }
   } while (0);
   if (i8 << 24 >> 24 < 0) {
    i34 = HEAP32[i42 >> 2] | 0;
    i33 = HEAP32[i11 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i24 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   if ((HEAP8[i18 >> 0] | 0) < 0) {
    i34 = HEAP32[i43 >> 2] | 0;
    i33 = HEAP32[i10 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i25 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i28 = HEAP32[i37 >> 2] | 0;
   if ((i2 | 0) != (i28 | 0)) {
    i1 = HEAP32[i58 >> 2] | 0;
    i3 = HEAP32[i61 >> 2] | 0;
    i8 = i3;
    if ((i1 | 0) != (i3 | 0)) {
     i6 = i2 + 4 | 0;
     i34 = HEAP8[i2 + 11 >> 0] | 0;
     i5 = i34 & 255;
     i7 = (i1 - i3 | 0) / 36 | 0;
     if (i34 << 24 >> 24 < 0) {
      i1 = 0;
      do {
       i3 = i8 + (i1 * 36 | 0) | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       i34 = HEAP8[i3 + 11 >> 0] | 0;
       i5 = i34 << 24 >> 24 < 0;
       do if ((i4 | 0) == ((i5 ? HEAP32[i8 + (i1 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(HEAP32[i2 >> 2] | 0, i5 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0) break;
        HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] = i9;
       } while (0);
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < i7 >>> 0);
     } else {
      i1 = 0;
      do {
       i3 = i8 + (i1 * 36 | 0) | 0;
       i34 = HEAP8[i3 + 11 >> 0] | 0;
       i4 = i34 << 24 >> 24 < 0;
       do if ((i5 | 0) == ((i4 ? HEAP32[i8 + (i1 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(i2, i4 ? HEAP32[i3 >> 2] | 0 : i3, i5) | 0) break;
        HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] = i9;
       } while (0);
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < i7 >>> 0);
     }
    }
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != 24);
  i14 = i44 + 11 | 0;
  i15 = i44 + 4 | 0;
  i16 = i43 + 12 | 0;
  i13 = i43 + 12 | 0;
  i17 = i48 + 4 | 0;
  i18 = i43 + 8 | 0;
  i19 = i43 + 4 | 0;
  i20 = i43 + 11 | 0;
  i21 = i42 + 12 | 0;
  i12 = i42 + 12 | 0;
  i22 = i48 + 4 | 0;
  i23 = i42 + 8 | 0;
  i24 = i42 + 4 | 0;
  i25 = i42 + 11 | 0;
  i26 = i48 + 4 | 0;
  i27 = i48 + 4 | 0;
  i11 = 0;
  i10 = 0;
  i29 = i28;
  do {
   i2 = HEAP32[i45 >> 2] | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, gb + 908416 | 0, 5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand10FingerNameEj((i11 >>> 0) / 3 | 0) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, gb + 1086395 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand12PhalangeNameEj((i11 >>> 0) % 3 | 0) | 0) | 0;
   i4 = HEAP8[i14 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i4 = i1 ? HEAP32[i15 >> 2] | 0 : i4 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i13 >> 2] | 0;
    i49 = 85;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i20 >> 0] = i4;
    if (!i4) i1 = i43; else {
     i1 = i43;
     i49 = 87;
    }
   } else i49 = 85;
   if ((i49 | 0) == 85) {
    i34 = i4 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i17 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i18 >> 2] = i34 | -2147483648;
    HEAP32[i19 >> 2] = i4;
    i49 = 87;
   }
   if ((i49 | 0) == 87) {
    i49 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i4 = HEAP8[i20 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i4 = i1 ? HEAP32[i19 >> 2] | 0 : i4 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i21 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i12 >> 2] | 0;
    i49 = 91;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i25 >> 0] = i4;
    if (!i4) i1 = i42; else {
     i1 = i42;
     i49 = 93;
    }
   } else i49 = 91;
   if ((i49 | 0) == 91) {
    i34 = i4 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i22 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i23 >> 2] = i34 | -2147483648;
    HEAP32[i24 >> 2] = i4;
    i49 = 93;
   }
   if ((i49 | 0) == 93) {
    i49 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i8 = HEAP8[i25 >> 0] | 0;
   L144 : do if ((i2 | 0) == (i29 | 0)) i2 = i29; else {
    i34 = i8 << 24 >> 24 < 0;
    i4 = i8 & 255;
    i5 = HEAP32[i24 >> 2] | 0;
    i7 = i34 ? i5 : i4;
    i6 = HEAP32[i42 >> 2] | 0;
    if (i34) while (1) {
     i1 = i2 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i3 = i34 << 24 >> 24 < 0;
     if ((i7 | 0) == ((i3 ? HEAP32[i2 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i6, i3 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) break L144;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i29 | 0)) {
      i2 = i29;
      break;
     }
    } else while (1) {
     i1 = i2 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i3 = i34 << 24 >> 24 < 0;
     if ((i7 | 0) == ((i3 ? HEAP32[i2 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i42, i3 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0)) break L144;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i29 | 0)) {
      i2 = i29;
      break;
     }
    }
   } while (0);
   if (i8 << 24 >> 24 < 0) {
    i34 = HEAP32[i42 >> 2] | 0;
    i33 = HEAP32[i12 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i26 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i34 = HEAP32[i43 >> 2] | 0;
    i33 = HEAP32[i13 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i27 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i29 = HEAP32[i37 >> 2] | 0;
   if ((i2 | 0) != (i29 | 0)) {
    i1 = HEAP32[i58 >> 2] | 0;
    i3 = HEAP32[i61 >> 2] | 0;
    i9 = i3;
    if ((i1 | 0) != (i3 | 0)) {
     i7 = i2 + 4 | 0;
     i34 = HEAP8[i2 + 11 >> 0] | 0;
     i6 = i34 & 255;
     i8 = (i1 - i3 | 0) / 36 | 0;
     if (i34 << 24 >> 24 < 0) {
      i6 = 0;
      i1 = i10;
      do {
       i3 = i9 + (i6 * 36 | 0) | 0;
       i4 = HEAP32[i7 >> 2] | 0;
       i34 = HEAP8[i3 + 11 >> 0] | 0;
       i5 = i34 << 24 >> 24 < 0;
       do if ((i4 | 0) == ((i5 ? HEAP32[i9 + (i6 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(HEAP32[i2 >> 2] | 0, i5 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0) break;
        HEAP32[(HEAP32[i46 >> 2] | 0) + (i6 << 2) >> 2] = i11;
        i1 = i1 + 1 | 0;
       } while (0);
       i6 = i6 + 1 | 0;
      } while (i6 >>> 0 < i8 >>> 0);
      i10 = i1;
     } else {
      i5 = 0;
      i1 = i10;
      do {
       i3 = i9 + (i5 * 36 | 0) | 0;
       i34 = HEAP8[i3 + 11 >> 0] | 0;
       i4 = i34 << 24 >> 24 < 0;
       do if ((i6 | 0) == ((i4 ? HEAP32[i9 + (i5 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(i2, i4 ? HEAP32[i3 >> 2] | 0 : i3, i6) | 0) break;
        HEAP32[(HEAP32[i46 >> 2] | 0) + (i5 << 2) >> 2] = i11;
        i1 = i1 + 1 | 0;
       } while (0);
       i5 = i5 + 1 | 0;
      } while (i5 >>> 0 < i8 >>> 0);
      i10 = i1;
     }
    }
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != 15);
  i15 = i44 + 11 | 0;
  i16 = i44 + 4 | 0;
  i17 = i43 + 12 | 0;
  i14 = i43 + 12 | 0;
  i18 = i48 + 4 | 0;
  i19 = i43 + 8 | 0;
  i20 = i43 + 4 | 0;
  i21 = i43 + 11 | 0;
  i22 = i42 + 12 | 0;
  i13 = i42 + 12 | 0;
  i23 = i48 + 4 | 0;
  i24 = i42 + 8 | 0;
  i25 = i42 + 4 | 0;
  i26 = i42 + 11 | 0;
  i27 = i48 + 4 | 0;
  i28 = i48 + 4 | 0;
  i12 = 0;
  i1 = 0;
  i11 = i29;
  do {
   i3 = HEAP32[i45 >> 2] | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, gb + 908422 | 0, 6);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand10FingerNameEj((i12 >>> 0) / 3 | 0) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, gb + 1086395 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand12PhalangeNameEj((i12 >>> 0) % 3 | 0) | 0) | 0;
   i5 = HEAP8[i15 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i4 = i2 ? HEAP32[i44 >> 2] | 0 : i44;
   i5 = i2 ? HEAP32[i16 >> 2] | 0 : i5 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i17 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i2 = HEAP32[i14 >> 2] | 0;
    i49 = 122;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i21 >> 0] = i5;
    if (!i5) i2 = i43; else {
     i2 = i43;
     i49 = 124;
    }
   } else i49 = 122;
   if ((i49 | 0) == 122) {
    i34 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i18 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i2;
    HEAP32[i19 >> 2] = i34 | -2147483648;
    HEAP32[i20 >> 2] = i5;
    i49 = 124;
   }
   if ((i49 | 0) == 124) {
    i49 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   i5 = HEAP8[i21 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i4 = i2 ? HEAP32[i43 >> 2] | 0 : i43;
   i5 = i2 ? HEAP32[i20 >> 2] | 0 : i5 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i22 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i2 = HEAP32[i13 >> 2] | 0;
    i49 = 128;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i26 >> 0] = i5;
    if (!i5) i2 = i42; else {
     i2 = i42;
     i49 = 130;
    }
   } else i49 = 128;
   if ((i49 | 0) == 128) {
    i34 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i23 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i2;
    HEAP32[i24 >> 2] = i34 | -2147483648;
    HEAP32[i25 >> 2] = i5;
    i49 = 130;
   }
   if ((i49 | 0) == 130) {
    i49 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   i9 = HEAP8[i26 >> 0] | 0;
   L202 : do if ((i3 | 0) == (i11 | 0)) i3 = i11; else {
    i34 = i9 << 24 >> 24 < 0;
    i5 = i9 & 255;
    i6 = HEAP32[i25 >> 2] | 0;
    i8 = i34 ? i6 : i5;
    i7 = HEAP32[i42 >> 2] | 0;
    if (i34) while (1) {
     i2 = i3 + 16 | 0;
     i34 = HEAP8[i2 + 11 >> 0] | 0;
     i4 = i34 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i4 ? HEAP32[i3 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i7, i4 ? HEAP32[i2 >> 2] | 0 : i2, i6) | 0)) break L202;
     i3 = i3 + 76 | 0;
     if ((i3 | 0) == (i11 | 0)) {
      i3 = i11;
      break;
     }
    } else while (1) {
     i2 = i3 + 16 | 0;
     i34 = HEAP8[i2 + 11 >> 0] | 0;
     i4 = i34 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i4 ? HEAP32[i3 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i42, i4 ? HEAP32[i2 >> 2] | 0 : i2, i5) | 0)) break L202;
     i3 = i3 + 76 | 0;
     if ((i3 | 0) == (i11 | 0)) {
      i3 = i11;
      break;
     }
    }
   } while (0);
   if (i9 << 24 >> 24 < 0) {
    i34 = HEAP32[i42 >> 2] | 0;
    i33 = HEAP32[i13 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i27 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   if ((HEAP8[i21 >> 0] | 0) < 0) {
    i34 = HEAP32[i43 >> 2] | 0;
    i33 = HEAP32[i14 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i28 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i11 = HEAP32[i37 >> 2] | 0;
   if ((i3 | 0) != (i11 | 0)) {
    i2 = HEAP32[i58 >> 2] | 0;
    i4 = HEAP32[i61 >> 2] | 0;
    i9 = i4;
    if ((i2 | 0) != (i4 | 0)) {
     i7 = i3 + 4 | 0;
     i34 = HEAP8[i3 + 11 >> 0] | 0;
     i6 = i34 & 255;
     i8 = (i2 - i4 | 0) / 36 | 0;
     if (i34 << 24 >> 24 < 0) {
      i6 = 0;
      do {
       i2 = i9 + (i6 * 36 | 0) | 0;
       i4 = HEAP32[i7 >> 2] | 0;
       i34 = HEAP8[i2 + 11 >> 0] | 0;
       i5 = i34 << 24 >> 24 < 0;
       do if ((i4 | 0) == ((i5 ? HEAP32[i9 + (i6 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(HEAP32[i3 >> 2] | 0, i5 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0) break;
        HEAP32[(HEAP32[i41 >> 2] | 0) + (i6 << 2) >> 2] = i12;
        i1 = i1 + 1 | 0;
       } while (0);
       i6 = i6 + 1 | 0;
      } while (i6 >>> 0 < i8 >>> 0);
     } else {
      i5 = 0;
      do {
       i2 = i9 + (i5 * 36 | 0) | 0;
       i34 = HEAP8[i2 + 11 >> 0] | 0;
       i4 = i34 << 24 >> 24 < 0;
       do if ((i6 | 0) == ((i4 ? HEAP32[i9 + (i5 * 36 | 0) + 4 >> 2] | 0 : i34 & 255) | 0)) {
        if (_strncmp(i3, i4 ? HEAP32[i2 >> 2] | 0 : i2, i6) | 0) break;
        HEAP32[(HEAP32[i41 >> 2] | 0) + (i5 << 2) >> 2] = i12;
        i1 = i1 + 1 | 0;
       } while (0);
       i5 = i5 + 1 | 0;
      } while (i5 >>> 0 < i8 >>> 0);
     }
    }
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != 15);
  i20 = (i10 | 0) > 0;
  i19 = (i1 | 0) > 0;
  HEAP32[i32 >> 2] = 0;
  i18 = i32 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i32 + 8 >> 2] = 0;
  i2 = HEAP32[i40 >> 2] | 0;
  i1 = HEAP32[i47 >> 2] | 0;
  i3 = i2 - i1 | 0;
  i4 = i3 >> 2;
  if (i4 | 0) {
   if (i4 >>> 0 > 1073741823) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i32);
    i5 = HEAP32[i47 >> 2] | 0;
    i2 = HEAP32[i40 >> 2] | 0;
   } else i5 = i1;
   i3 = __Znwj(i3) | 0;
   HEAP32[i18 >> 2] = i3;
   HEAP32[i32 >> 2] = i3;
   HEAP32[i32 + 8 >> 2] = i3 + (i4 << 2);
   i1 = i2 - i5 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i5 | 0, i1 | 0) | 0;
    HEAP32[i18 >> 2] = i3 + (i1 >> 2 << 2);
   }
  }
  HEAP32[i31 >> 2] = 0;
  i17 = i31 + 4 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  i2 = HEAP32[i39 >> 2] | 0;
  i1 = HEAP32[i46 >> 2] | 0;
  i3 = i2 - i1 | 0;
  i4 = i3 >> 2;
  if (i4 | 0) {
   if (i4 >>> 0 > 1073741823) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i31);
    i5 = HEAP32[i46 >> 2] | 0;
    i2 = HEAP32[i39 >> 2] | 0;
   } else i5 = i1;
   i3 = __Znwj(i3) | 0;
   HEAP32[i17 >> 2] = i3;
   HEAP32[i31 >> 2] = i3;
   HEAP32[i31 + 8 >> 2] = i3 + (i4 << 2);
   i1 = i2 - i5 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i5 | 0, i1 | 0) | 0;
    HEAP32[i17 >> 2] = i3 + (i1 >> 2 << 2);
   }
  }
  HEAP32[i30 >> 2] = 0;
  i16 = i30 + 4 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  i2 = HEAP32[i38 >> 2] | 0;
  i1 = HEAP32[i41 >> 2] | 0;
  i3 = i2 - i1 | 0;
  i4 = i3 >> 2;
  if (!i4) i3 = 0; else {
   if (i4 >>> 0 > 1073741823) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i30);
    i5 = HEAP32[i41 >> 2] | 0;
    i2 = HEAP32[i38 >> 2] | 0;
   } else i5 = i1;
   i3 = __Znwj(i3) | 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i30 >> 2] = i3;
   HEAP32[i30 + 8 >> 2] = i3 + (i4 << 2);
   i1 = i2 - i5 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i5 | 0, i1 | 0) | 0;
    HEAP32[i16 >> 2] = i3 + (i1 >> 2 << 2);
   }
  }
  i10 = HEAP32[i59 >> 2] | 0;
  i9 = (i10 | 0) == 0;
  if (i9) {
   i15 = 0;
   i14 = 0;
   i13 = 0;
   i5 = -1;
  } else {
   i7 = HEAP32[i32 >> 2] | 0;
   i8 = HEAP32[i31 >> 2] | 0;
   i2 = 0;
   i4 = 0;
   i1 = 0;
   i6 = 0;
   i5 = -1;
   do {
    i34 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
    i1 = ((i34 | 0) != -1 & 1) + i1 | 0;
    i4 = ((HEAP32[i8 + (i6 << 2) >> 2] | 0) != -1 & 1) + i4 | 0;
    i2 = ((HEAP32[i3 + (i6 << 2) >> 2] | 0) != -1 & 1) + i2 | 0;
    i5 = (i34 | 0) == 0 ? i6 : i5;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i10 | 0));
   i15 = i2;
   i14 = i4;
   i13 = i1;
  }
  HEAP32[i48 >> 2] = 0;
  i12 = i48 + 4 | 0;
  HEAP32[i12 >> 2] = 0;
  i1 = i48 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  if (i9) {
   i2 = 0;
   i3 = 0;
   i11 = 0;
  } else {
   if ((i10 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i48);
   i2 = ((i10 + -1 | 0) >>> 5) + 1 | 0;
   i4 = __Znwj(i2 << 2) | 0;
   HEAP32[i48 >> 2] = i4;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i12 >> 2] = i10;
   i2 = i10 >>> 5;
   _memset(i4 | 0, 0, i2 << 2 | 0) | 0;
   i1 = i10 - (i2 << 5) | 0;
   i2 = i4 + (i2 << 2) | 0;
   if (!i1) {
    i2 = i4;
    i3 = i10;
    i11 = i4;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(-1 >>> (32 - i1 | 0));
    i2 = i4;
    i3 = i10;
    i11 = i4;
   }
  }
  if (HEAP32[i59 >> 2] | 0) {
   i6 = HEAP32[i32 >> 2] | 0;
   i7 = HEAP32[i31 >> 2] | 0;
   i8 = HEAP32[i30 >> 2] | 0;
   i9 = i59 + 4 | 0;
   i10 = i9;
   i4 = 0;
   i1 = i2;
   i3 = i2;
   while (1) {
    if ((HEAP32[i6 + (i4 << 2) >> 2] | 0) != -1) {
     i34 = i1 + (i4 >>> 5 << 2) | 0;
     HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | 1 << (i4 & 31);
     if ((i4 | 0) != (i5 | 0)) {
      i2 = i4;
      do {
       i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + i10 + (i2 << 3) >> 2] | 0;
       i34 = i1 + (i2 >>> 5 << 2) | 0;
       HEAP32[i34 >> 2] = 1 << (i2 & 31) | HEAP32[i34 >> 2];
      } while ((i2 | 0) != (i5 | 0));
     }
    }
    do if ((HEAP32[i7 + (i4 << 2) >> 2] | 0) != -1) {
     i34 = i3 + (i4 >>> 5 << 2) | 0;
     HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | 1 << (i4 & 31);
     if ((i4 | 0) == (i5 | 0)) {
      i1 = i3;
      break;
     } else i1 = i4;
     do {
      i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + i10 + (i1 << 3) >> 2] | 0;
      i34 = i3 + (i1 >>> 5 << 2) | 0;
      HEAP32[i34 >> 2] = 1 << (i1 & 31) | HEAP32[i34 >> 2];
     } while ((i1 | 0) != (i5 | 0));
     i1 = i3;
    } while (0);
    do if ((HEAP32[i8 + (i4 << 2) >> 2] | 0) == -1) i2 = i3; else {
     i34 = i11 + (i4 >>> 5 << 2) | 0;
     HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | 1 << (i4 & 31);
     if ((i4 | 0) == (i5 | 0)) {
      i2 = i11;
      i1 = i11;
      break;
     } else i1 = i4;
     do {
      i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + i10 + (i1 << 3) >> 2] | 0;
      i34 = i11 + (i1 >>> 5 << 2) | 0;
      HEAP32[i34 >> 2] = 1 << (i1 & 31) | HEAP32[i34 >> 2];
     } while ((i1 | 0) != (i5 | 0));
     i2 = i11;
     i1 = i11;
    } while (0);
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (HEAP32[i59 >> 2] | 0) >>> 0) break; else i3 = i2;
   }
   i3 = HEAP32[i12 >> 2] | 0;
  }
  if (!i3) i1 = 1; else {
   i4 = HEAP32[i48 >> 2] | 0;
   i1 = 0;
   i2 = 0;
   do {
    i2 = ((HEAP32[i4 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1) + i2 | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = i2 + 1 | 0;
  }
  i9 = __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE(i1, i15 + i14 + i13 | 0, i53) | 0;
  i10 = i59 + 8 | 0;
  i11 = i59 + 4 | 0;
  i12 = i11;
  i13 = i10;
  i14 = i9 + 8 | 0;
  i15 = i14;
  HEAP32[(HEAP32[i14 >> 2] | 0) + i15 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (HEAP32[(HEAP32[i11 >> 2] | 0) + i12 + (i5 << 3) >> 2] << 2) >> 2];
  i7 = i9 + 4 | 0;
  i8 = i7;
  i2 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
  HEAP32[i2 >> 2] = -1;
  HEAP32[i2 + 4 >> 2] = -1;
  i2 = HEAP32[i59 >> 2] | 0;
  i1 = HEAP32[i48 >> 2] | 0;
  if (i2) {
   i6 = 0;
   i5 = 0;
   i4 = 1;
   while (1) {
    if (!(HEAP32[i1 + (i6 >>> 5 << 2) >> 2] & 1 << (i6 & 31))) i3 = i5; else {
     HEAP32[(HEAP32[i14 >> 2] | 0) + i15 + (i4 << 2) >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i6 << 2) >> 2];
     i34 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (HEAP32[(HEAP32[i11 >> 2] | 0) + i12 + (i6 << 3) >> 2] << 2) >> 2] | 0) | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
     HEAP32[i2 + (i4 << 3) >> 2] = i34;
     do if ((HEAP32[(HEAP32[i32 >> 2] | 0) + (i6 << 2) >> 2] | 0) == -1) {
      if ((HEAP32[(HEAP32[i31 >> 2] | 0) + (i6 << 2) >> 2] | 0) != -1) {
       i49 = 202;
       break;
      }
      if ((HEAP32[(HEAP32[i30 >> 2] | 0) + (i6 << 2) >> 2] | 0) == -1) {
       i3 = i5;
       i1 = -1;
      } else i49 = 202;
     } else i49 = 202; while (0);
     if ((i49 | 0) == 202) {
      i49 = 0;
      i3 = i5 + 1 | 0;
      i1 = i5;
     }
     HEAP32[i2 + (i4 << 3) + 4 >> 2] = i1;
     i4 = i4 + 1 | 0;
     i1 = HEAP32[i48 >> 2] | 0;
     i2 = HEAP32[i59 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= i2 >>> 0) break; else i5 = i3;
   }
  }
  if (i1 | 0) __ZdlPv(i1);
  i1 = HEAP32[i30 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i16 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i16 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i31 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i17 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i32 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i18 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i18 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i3 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i9, i53) | 0;
  i5 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i9, i53) | 0;
  i3 = __ZN7mecanim5human11CreateHumanEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEEjjRNS_6memory9AllocatorE(i9, i3, 0, HEAP32[i9 + 12 >> 2] | 0, i53) | 0;
  if (i20) i2 = __ZN7mecanim4hand10CreateHandERNS_6memory9AllocatorE(i53) | 0; else i2 = 0;
  if (i19) i4 = __ZN7mecanim4hand10CreateHandERNS_6memory9AllocatorE(i53) | 0; else i4 = 0;
  i30 = i3 + 48 | 0;
  i31 = i30;
  HEAP32[i30 >> 2] = i2 | 0 ? i2 - i31 | 0 : 0;
  i28 = i3 + 392 | 0;
  HEAP8[i28 >> 0] = i20 & 1;
  i33 = i3 + 52 | 0;
  i34 = i33;
  HEAP32[i33 >> 2] = i4 | 0 ? i4 - i34 | 0 : 0;
  i32 = i3 + 393 | 0;
  HEAP8[i32 >> 0] = i19 & 1;
  L340 : do if (HEAP32[i59 >> 2] | 0) {
   if (i20) i1 = 0; else {
    i1 = 0;
    while (1) {
     if ((HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] | 0) != -1) {
      i29 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i1 << 2) >> 2] | 0) | 0;
      HEAP32[i3 + 72 + (HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] = i29;
     }
     do if (i19) {
      if ((HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] | 0) == -1) break;
      i29 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i1 << 2) >> 2] | 0) | 0;
      HEAP32[i4 + (HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] = i29;
     } while (0);
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= (HEAP32[i59 >> 2] | 0) >>> 0) break L340;
    }
   }
   do {
    if ((HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] | 0) != -1) {
     i29 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i1 << 2) >> 2] | 0) | 0;
     HEAP32[i3 + 72 + (HEAP32[(HEAP32[i47 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] = i29;
    }
    if ((HEAP32[(HEAP32[i46 >> 2] | 0) + (i1 << 2) >> 2] | 0) != -1) {
     i29 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i1 << 2) >> 2] | 0) | 0;
     HEAP32[i2 + (HEAP32[(HEAP32[i46 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] = i29;
    }
    do if (i19) {
     if ((HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] | 0) == -1) break;
     i29 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i9, HEAP32[(HEAP32[i10 >> 2] | 0) + i13 + (i1 << 2) >> 2] | 0) | 0;
     HEAP32[i4 + (HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] = i29;
    } while (0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i59 >> 2] | 0) >>> 0);
  } while (0);
  HEAP32[i3 + 364 >> 2] = HEAP32[i45 + 24 >> 2];
  HEAP32[i3 + 368 >> 2] = HEAP32[i45 + 28 >> 2];
  HEAP32[i3 + 372 >> 2] = HEAP32[i45 + 32 >> 2];
  HEAP32[i3 + 376 >> 2] = HEAP32[i45 + 36 >> 2];
  HEAP32[i3 + 380 >> 2] = HEAP32[i45 + 40 >> 2];
  HEAP32[i3 + 384 >> 2] = HEAP32[i45 + 44 >> 2];
  HEAP32[i3 + 388 >> 2] = HEAP32[i45 + 48 >> 2];
  HEAP8[i3 + 394 >> 0] = HEAP8[i45 + 84 >> 0] | 0;
  if (i36) {
   i36 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i59, HEAP32[(HEAP32[i14 >> 2] | 0) + i15 + (HEAP32[i3 + 72 >> 2] << 2) >> 2] | 0) | 0;
   i36 = HEAP32[(HEAP32[i11 >> 2] | 0) + i12 + (i36 << 3) >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i59, i51, i35, i36, 0);
   __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i59, i35, i52, i36, 0);
  }
  __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_(i59, i52, i35);
  __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE(i59, i35, i9, i5);
  i35 = i5 + 4 | 0;
  i35 = (HEAP32[i35 >> 2] | 0) + i35 | 0;
  i36 = i35;
  HEAP32[i35 >> 2] = 0;
  i35 = i36 + 4 | 0;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  HEAP32[i35 + 12 >> 2] = 0;
  HEAP32[i35 + 16 >> 2] = 0;
  HEAP32[i36 + 24 >> 2] = 1065353216;
  HEAP32[i36 + 28 >> 2] = 1065353216;
  HEAP32[i36 + 32 >> 2] = 1065353216;
  HEAP32[i36 + 36 >> 2] = 1065353216;
  __ZN7mecanim5human15HumanAdjustMassEPNS0_5HumanE(i3);
  __ZN7mecanim5human14HumanSetupAxesEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i3, i5);
  __ZN7mecanim5human18HumanSetupColliderEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i3, i5);
  if (i20) __ZN7mecanim4hand13HandSetupAxesEPKNS0_4HandEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS4_8SkeletonEb(i2, i5, i9, 1);
  if (i19) __ZN7mecanim4hand13HandSetupAxesEPKNS0_4HandEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS4_8SkeletonEb(i4, i5, i9, 0);
  i14 = i44 + 11 | 0;
  i15 = i44 + 4 | 0;
  i16 = i43 + 12 | 0;
  i13 = i43 + 12 | 0;
  i17 = i48 + 4 | 0;
  i18 = i43 + 8 | 0;
  i19 = i43 + 4 | 0;
  i20 = i43 + 11 | 0;
  i21 = i42 + 12 | 0;
  i12 = i42 + 12 | 0;
  i22 = i48 + 4 | 0;
  i23 = i42 + 8 | 0;
  i24 = i42 + 4 | 0;
  i25 = i42 + 11 | 0;
  i26 = i48 + 4 | 0;
  i27 = i48 + 4 | 0;
  i35 = i3 + 40 | 0;
  i36 = i35;
  i11 = 0;
  i10 = HEAP32[i37 >> 2] | 0;
  do {
   i4 = HEAP32[i45 >> 2] | 0;
   i5 = __ZN7mecanim5human8BoneNameEj(i11) | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, i5, _strlen(i5) | 0);
   i5 = HEAP8[i14 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i13 >> 2] | 0;
    i49 = 247;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 247;
     break;
    }
    HEAP8[i20 >> 0] = i5;
    if (!i5) i1 = i43; else {
     i1 = i43;
     i49 = 249;
    }
   } while (0);
   if ((i49 | 0) == 247) {
    i29 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i17 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i18 >> 2] = i29 | -2147483648;
    HEAP32[i19 >> 2] = i5;
    i49 = 249;
   }
   if ((i49 | 0) == 249) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i5 = HEAP8[i20 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i5 = i1 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i21 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i12 >> 2] | 0;
    i49 = 253;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 253;
     break;
    }
    HEAP8[i25 >> 0] = i5;
    if (!i5) i1 = i42; else {
     i1 = i42;
     i49 = 255;
    }
   } while (0);
   if ((i49 | 0) == 253) {
    i29 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i22 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i23 >> 2] = i29 | -2147483648;
    HEAP32[i24 >> 2] = i5;
    i49 = 255;
   }
   if ((i49 | 0) == 255) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i9 = HEAP8[i25 >> 0] | 0;
   L394 : do if ((i4 | 0) == (i10 | 0)) i4 = i10; else {
    i29 = i9 << 24 >> 24 < 0;
    i5 = i9 & 255;
    i6 = HEAP32[i24 >> 2] | 0;
    i8 = i29 ? i6 : i5;
    i7 = HEAP32[i42 >> 2] | 0;
    if (i29) while (1) {
     i1 = i4 + 16 | 0;
     i29 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i29 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i29 & 255) | 0)) if (!(_strncmp(i7, i2 ? HEAP32[i1 >> 2] | 0 : i1, i6) | 0)) break L394;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    } else while (1) {
     i1 = i4 + 16 | 0;
     i29 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i29 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i29 & 255) | 0)) if (!(_strncmp(i42, i2 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) break L394;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    }
   } while (0);
   if (i9 << 24 >> 24 < 0) {
    i29 = HEAP32[i42 >> 2] | 0;
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i26 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i29, i48);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i29 = HEAP32[i43 >> 2] | 0;
    i10 = HEAP32[i13 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i27 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i29, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i10 = HEAP32[i37 >> 2] | 0;
   do if ((i4 | 0) != (i10 | 0)) {
    i1 = HEAP32[i3 + 72 + (i11 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break;
    if (!(HEAP8[i4 + 72 >> 0] | 0)) break;
    i2 = (HEAP32[i35 >> 2] | 0) + i36 | 0;
    i29 = i2 + 4 | 0;
    i1 = HEAP32[i29 + (HEAP32[i29 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    if ((i1 | 0) == -1) break;
    i29 = i2 + 16 | 0;
    i29 = (HEAP32[i29 >> 2] | 0) + i29 | 0;
    i9 = i4 + 32 | 0;
    f68 = Math_fround(HEAPF32[i9 >> 2]);
    f67 = Math_fround(HEAPF32[i9 + 4 >> 2]);
    f68 = Math_fround(f68 * Math_fround(.0174532924));
    f67 = Math_fround(f67 * Math_fround(.0174532924));
    f66 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(.0174532924));
    i9 = i4 + 44 | 0;
    f65 = Math_fround(HEAPF32[i9 >> 2]);
    f64 = Math_fround(HEAPF32[i9 + 4 >> 2]);
    f65 = Math_fround(f65 * Math_fround(.0174532924));
    f64 = Math_fround(f64 * Math_fround(.0174532924));
    f63 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(.0174532924));
    HEAPF32[i29 + (i1 * 76 | 0) + 44 >> 2] = f68;
    HEAPF32[i29 + (i1 * 76 | 0) + 48 >> 2] = f67;
    HEAPF32[i29 + (i1 * 76 | 0) + 52 >> 2] = f66;
    HEAPF32[i29 + (i1 * 76 | 0) + 56 >> 2] = f65;
    HEAPF32[i29 + (i1 * 76 | 0) + 60 >> 2] = f64;
    HEAPF32[i29 + (i1 * 76 | 0) + 64 >> 2] = f63;
   } while (0);
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != 24);
  i29 = (HEAP8[i28 >> 0] | 0) == 0;
  if (i29) i28 = 0; else i28 = (HEAP32[i30 >> 2] | 0) + i31 | 0;
  i14 = i44 + 11 | 0;
  i15 = i44 + 4 | 0;
  i16 = i43 + 12 | 0;
  i13 = i43 + 12 | 0;
  i17 = i48 + 4 | 0;
  i18 = i43 + 8 | 0;
  i19 = i43 + 4 | 0;
  i20 = i43 + 11 | 0;
  i21 = i42 + 12 | 0;
  i12 = i42 + 12 | 0;
  i22 = i48 + 4 | 0;
  i23 = i42 + 8 | 0;
  i24 = i42 + 4 | 0;
  i25 = i42 + 11 | 0;
  i26 = i48 + 4 | 0;
  i27 = i48 + 4 | 0;
  i11 = 0;
  do {
   i4 = HEAP32[i45 >> 2] | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, gb + 908416 | 0, 5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand10FingerNameEj((i11 >>> 0) / 3 | 0) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, gb + 1086395 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand12PhalangeNameEj((i11 >>> 0) % 3 | 0) | 0) | 0;
   i5 = HEAP8[i14 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i13 >> 2] | 0;
    i49 = 280;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 280;
     break;
    }
    HEAP8[i20 >> 0] = i5;
    if (!i5) i1 = i43; else {
     i1 = i43;
     i49 = 282;
    }
   } while (0);
   if ((i49 | 0) == 280) {
    i31 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i17 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i31, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i18 >> 2] = i31 | -2147483648;
    HEAP32[i19 >> 2] = i5;
    i49 = 282;
   }
   if ((i49 | 0) == 282) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i5 = HEAP8[i20 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i5 = i1 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i21 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i12 >> 2] | 0;
    i49 = 286;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 286;
     break;
    }
    HEAP8[i25 >> 0] = i5;
    if (!i5) i1 = i42; else {
     i1 = i42;
     i49 = 288;
    }
   } while (0);
   if ((i49 | 0) == 286) {
    i31 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i22 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i31, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i23 >> 2] = i31 | -2147483648;
    HEAP32[i24 >> 2] = i5;
    i49 = 288;
   }
   if ((i49 | 0) == 288) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i9 = HEAP8[i25 >> 0] | 0;
   L444 : do if ((i4 | 0) == (i10 | 0)) i4 = i10; else {
    i31 = i9 << 24 >> 24 < 0;
    i5 = i9 & 255;
    i6 = HEAP32[i24 >> 2] | 0;
    i8 = i31 ? i6 : i5;
    i7 = HEAP32[i42 >> 2] | 0;
    if (i31) while (1) {
     i1 = i4 + 16 | 0;
     i31 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i31 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i31 & 255) | 0)) if (!(_strncmp(i7, i2 ? HEAP32[i1 >> 2] | 0 : i1, i6) | 0)) break L444;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    } else while (1) {
     i1 = i4 + 16 | 0;
     i31 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i31 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i31 & 255) | 0)) if (!(_strncmp(i42, i2 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) break L444;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    }
   } while (0);
   if (i9 << 24 >> 24 < 0) {
    i31 = HEAP32[i42 >> 2] | 0;
    i30 = HEAP32[i12 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i26 >> 2] = i30;
    __Z19free_alloc_internalPvRK10MemLabelId(i31, i48);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i31 = HEAP32[i43 >> 2] | 0;
    i30 = HEAP32[i13 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i27 >> 2] = i30;
    __Z19free_alloc_internalPvRK10MemLabelId(i31, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i10 = HEAP32[i37 >> 2] | 0;
   do if (!(i29 | (i4 | 0) == (i10 | 0))) {
    i1 = HEAP32[i28 + (i11 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break;
    if (!(HEAP8[i4 + 72 >> 0] | 0)) break;
    i2 = (HEAP32[i35 >> 2] | 0) + i36 | 0;
    i31 = i2 + 4 | 0;
    i1 = HEAP32[i31 + (HEAP32[i31 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    if ((i1 | 0) == -1) break;
    i31 = i2 + 16 | 0;
    i31 = (HEAP32[i31 >> 2] | 0) + i31 | 0;
    i30 = i4 + 32 | 0;
    f63 = Math_fround(HEAPF32[i30 >> 2]);
    f64 = Math_fround(HEAPF32[i30 + 4 >> 2]);
    f63 = Math_fround(f63 * Math_fround(.0174532924));
    f64 = Math_fround(f64 * Math_fround(.0174532924));
    f65 = Math_fround(Math_fround(HEAPF32[i30 + 8 >> 2]) * Math_fround(.0174532924));
    i30 = i4 + 44 | 0;
    f66 = Math_fround(HEAPF32[i30 >> 2]);
    f67 = Math_fround(HEAPF32[i30 + 4 >> 2]);
    f66 = Math_fround(f66 * Math_fround(.0174532924));
    f67 = Math_fround(f67 * Math_fround(.0174532924));
    f68 = Math_fround(Math_fround(HEAPF32[i30 + 8 >> 2]) * Math_fround(.0174532924));
    HEAPF32[i31 + (i1 * 76 | 0) + 44 >> 2] = f63;
    HEAPF32[i31 + (i1 * 76 | 0) + 48 >> 2] = f64;
    HEAPF32[i31 + (i1 * 76 | 0) + 52 >> 2] = f65;
    HEAPF32[i31 + (i1 * 76 | 0) + 56 >> 2] = f66;
    HEAPF32[i31 + (i1 * 76 | 0) + 60 >> 2] = f67;
    HEAPF32[i31 + (i1 * 76 | 0) + 64 >> 2] = f68;
   } while (0);
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != 15);
  i29 = (HEAP8[i32 >> 0] | 0) == 0;
  if (i29) i28 = 0; else i28 = (HEAP32[i33 >> 2] | 0) + i34 | 0;
  i14 = i44 + 11 | 0;
  i15 = i44 + 4 | 0;
  i16 = i43 + 12 | 0;
  i13 = i43 + 12 | 0;
  i17 = i48 + 4 | 0;
  i18 = i43 + 8 | 0;
  i19 = i43 + 4 | 0;
  i20 = i43 + 11 | 0;
  i21 = i42 + 12 | 0;
  i12 = i42 + 12 | 0;
  i22 = i48 + 4 | 0;
  i23 = i42 + 8 | 0;
  i24 = i42 + 4 | 0;
  i25 = i42 + 11 | 0;
  i26 = i48 + 4 | 0;
  i27 = i48 + 4 | 0;
  i11 = 0;
  do {
   i4 = HEAP32[i45 >> 2] | 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, gb + 908422 | 0, 6);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand10FingerNameEj((i11 >>> 0) / 3 | 0) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, gb + 1086395 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i44, __ZN7mecanim4hand12PhalangeNameEj((i11 >>> 0) % 3 | 0) | 0) | 0;
   i5 = HEAP8[i14 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i13 >> 2] | 0;
    i49 = 313;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 313;
     break;
    }
    HEAP8[i20 >> 0] = i5;
    if (!i5) i1 = i43; else {
     i1 = i43;
     i49 = 315;
    }
   } while (0);
   if ((i49 | 0) == 313) {
    i34 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i17 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i18 >> 2] = i34 | -2147483648;
    HEAP32[i19 >> 2] = i5;
    i49 = 315;
   }
   if ((i49 | 0) == 315) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i5 = HEAP8[i20 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i5 = i1 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i21 >> 2] = i1;
   do if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i12 >> 2] | 0;
    i49 = 319;
   } else {
    if (i5 >>> 0 >= 11) {
     i49 = 319;
     break;
    }
    HEAP8[i25 >> 0] = i5;
    if (!i5) i1 = i42; else {
     i1 = i42;
     i49 = 321;
    }
   } while (0);
   if ((i49 | 0) == 319) {
    i34 = i5 + 16 & -16;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i22 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i23 >> 2] = i34 | -2147483648;
    HEAP32[i24 >> 2] = i5;
    i49 = 321;
   }
   if ((i49 | 0) == 321) {
    i49 = 0;
    _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i9 = HEAP8[i25 >> 0] | 0;
   L494 : do if ((i4 | 0) == (i10 | 0)) i4 = i10; else {
    i34 = i9 << 24 >> 24 < 0;
    i5 = i9 & 255;
    i6 = HEAP32[i24 >> 2] | 0;
    i8 = i34 ? i6 : i5;
    i7 = HEAP32[i42 >> 2] | 0;
    if (i34) while (1) {
     i1 = i4 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i34 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i7, i2 ? HEAP32[i1 >> 2] | 0 : i1, i6) | 0)) break L494;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    } else while (1) {
     i1 = i4 + 16 | 0;
     i34 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i34 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i2 ? HEAP32[i4 + 20 >> 2] | 0 : i34 & 255) | 0)) if (!(_strncmp(i42, i2 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) break L494;
     i4 = i4 + 76 | 0;
     if ((i4 | 0) == (i10 | 0)) {
      i4 = i10;
      break;
     }
    }
   } while (0);
   if (i9 << 24 >> 24 < 0) {
    i34 = HEAP32[i42 >> 2] | 0;
    i33 = HEAP32[i12 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i26 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i34 = HEAP32[i43 >> 2] | 0;
    i33 = HEAP32[i13 >> 2] | 0;
    HEAP32[i48 >> 2] = 66;
    HEAP32[i27 >> 2] = i33;
    __Z19free_alloc_internalPvRK10MemLabelId(i34, i48);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   i10 = HEAP32[i37 >> 2] | 0;
   do if (!(i29 | (i4 | 0) == (i10 | 0))) {
    i1 = HEAP32[i28 + (i11 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break;
    if (!(HEAP8[i4 + 72 >> 0] | 0)) break;
    i2 = (HEAP32[i35 >> 2] | 0) + i36 | 0;
    i34 = i2 + 4 | 0;
    i1 = HEAP32[i34 + (HEAP32[i34 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    if ((i1 | 0) == -1) break;
    i34 = i2 + 16 | 0;
    i34 = (HEAP32[i34 >> 2] | 0) + i34 | 0;
    i33 = i4 + 32 | 0;
    f63 = Math_fround(HEAPF32[i33 >> 2]);
    f64 = Math_fround(HEAPF32[i33 + 4 >> 2]);
    f63 = Math_fround(f63 * Math_fround(.0174532924));
    f64 = Math_fround(f64 * Math_fround(.0174532924));
    f65 = Math_fround(Math_fround(HEAPF32[i33 + 8 >> 2]) * Math_fround(.0174532924));
    i33 = i4 + 44 | 0;
    f66 = Math_fround(HEAPF32[i33 >> 2]);
    f67 = Math_fround(HEAPF32[i33 + 4 >> 2]);
    f66 = Math_fround(f66 * Math_fround(.0174532924));
    f67 = Math_fround(f67 * Math_fround(.0174532924));
    f68 = Math_fround(Math_fround(HEAPF32[i33 + 8 >> 2]) * Math_fround(.0174532924));
    HEAPF32[i34 + (i1 * 76 | 0) + 44 >> 2] = f63;
    HEAPF32[i34 + (i1 * 76 | 0) + 48 >> 2] = f64;
    HEAPF32[i34 + (i1 * 76 | 0) + 52 >> 2] = f65;
    HEAPF32[i34 + (i1 * 76 | 0) + 56 >> 2] = f66;
    HEAPF32[i34 + (i1 * 76 | 0) + 60 >> 2] = f67;
    HEAPF32[i34 + (i1 * 76 | 0) + 64 >> 2] = f68;
   } while (0);
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != 15);
  i1 = HEAP32[i41 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i4 = HEAP32[i38 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i38 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i46 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i4 = HEAP32[i39 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i39 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i47 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i4 = HEAP32[i40 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i40 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i2 = -1;
  i1 = 0;
 } else {
  i2 = __ZN12_GLOBAL__N_1L20GetIndexFromBoneNameENSt3__211__wrap_iterIPKN13AvatarBuilder14NamedTransformEEES6_RK8UnityStr(HEAP32[i61 >> 2] | 0, HEAP32[i58 >> 2] | 0, i45 + 52 | 0) | 0;
  if ((i2 | 0) == -1) {
   i3 = 0;
   i2 = -1;
   i1 = 0;
  } else {
   i47 = HEAP32[i45 + 72 >> 2] | 0;
   i3 = HEAP32[i45 + 76 >> 2] | 0;
   i4 = HEAP32[i45 + 80 >> 2] | 0;
   HEAP32[i55 + 12 >> 2] = HEAP32[i45 + 68 >> 2];
   HEAP32[i55 + 16 >> 2] = i47;
   HEAP32[i55 + 20 >> 2] = i3;
   HEAP32[i1 >> 2] = i4;
   i4 = HEAP32[i59 >> 2] | 0;
   HEAP32[i48 >> 2] = 0;
   i1 = i48 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   i3 = i48 + 8 | 0;
   HEAP32[i3 >> 2] = 0;
   if ((i4 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i48);
   i47 = ((i4 + -1 | 0) >>> 5) + 1 | 0;
   i5 = __Znwj(i47 << 2) | 0;
   HEAP32[i48 >> 2] = i5;
   HEAP32[i3 >> 2] = i47;
   HEAP32[i1 >> 2] = i4;
   i3 = i4 >>> 5;
   _memset(i5 | 0, 0, i3 << 2 | 0) | 0;
   i1 = i4 - (i3 << 5) | 0;
   i3 = i5 + (i3 << 2) | 0;
   if (i1 | 0) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~(-1 >>> (32 - i1 | 0));
   i47 = i5 + (i2 >>> 5 << 2) | 0;
   HEAP32[i47 >> 2] = HEAP32[i47 >> 2] | 1 << (i2 & 31);
   if (i2 | 0) {
    i3 = i59 + 4 | 0;
    i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
    i1 = i2;
    do {
     i1 = HEAP32[i3 + (i1 << 3) >> 2] | 0;
     i47 = i5 + (i1 >>> 5 << 2) | 0;
     HEAP32[i47 >> 2] = 1 << (i1 & 31) | HEAP32[i47 >> 2];
    } while ((i1 | 0) != 0);
   }
   if (!i4) i1 = 0; else {
    i1 = 0;
    i3 = 0;
    do {
     i1 = ((1 << (i3 & 31) & HEAP32[i5 + (i3 >>> 5 << 2) >> 2] | 0) != 0 & 1) + i1 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i4 | 0));
   }
   i1 = __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE(i1, 0, i53) | 0;
   i4 = HEAP32[i59 >> 2] | 0;
   i12 = HEAP32[i48 >> 2] | 0;
   if (!i4) {
    if (i12 | 0) i49 = 366;
   } else {
    i6 = i59 + 8 | 0;
    i7 = i6;
    i8 = i1 + 8 | 0;
    i9 = i8;
    i10 = i1 + 4 | 0;
    i11 = i10;
    i3 = 0;
    i5 = 0;
    do {
     if (HEAP32[i12 + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31)) {
      HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i3 << 2) >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + i7 + (i5 << 2) >> 2];
      HEAP32[(HEAP32[i10 >> 2] | 0) + i11 + (i3 << 3) >> 2] = i3 + -1;
      i3 = i3 + 1 | 0;
      i4 = HEAP32[i59 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < i4 >>> 0);
    i49 = 366;
   }
   if ((i49 | 0) == 366) __ZdlPv(i12);
   i3 = 0;
  }
 }
 i1 = __ZN7mecanim9animation20CreateAvatarConstantEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEES8_PNS_5human5HumanES3_iRKS6_RNS_6memory9AllocatorE(i59, i52, i51, i3, i1, i2, i55, i53) | 0;
 HEAP32[i1 + 12 >> 2] = ((HEAP32[i58 >> 2] | 0) - (HEAP32[i61 >> 2] | 0) | 0) / 36 | 0;
 i61 = i1 + 16 | 0;
 HEAP32[i61 >> 2] = i50 | 0 ? i50 - i61 | 0 : 0;
 __ZN6Avatar8SetAssetEPN7mecanim9animation14AvatarConstantERKNSt3__23mapIj8UnityStrNS4_4lessIjEENS4_9allocatorINS4_4pairIKjS6_EEEEEE(i60, i1, i54);
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i54, HEAP32[i57 >> 2] | 0);
 HEAP32[i53 >> 2] = gb + 176376 + 8;
 i1 = HEAP32[i56 >> 2] | 0;
 if (!i1) {
  STACKTOP = i62;
  return;
 }
 do {
  i61 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i61, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 STACKTOP = i62;
 return;
}

function __ZN4gles8InitCapsEP7ApiGLESP12GraphicsCapsR16GfxDeviceLevelGL(i35, i36, i37) {
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i40 + 72 | 0;
 i32 = i40 + 32 | 0;
 i31 = i40 + 24 | 0;
 i38 = i40 + 8 | 0;
 i27 = i40;
 i24 = i40 + 112 | 0;
 i39 = i40 + 96 | 0;
 i8 = i40 + 80 | 0;
 HEAP32[gb + 1451148 >> 2] = i36 + 540;
 i34 = HEAP32[i37 >> 2] | 0;
 i1 = (i34 | 0) == 1;
 HEAP32[i36 + 728 >> 2] = i1 ? 2 : 3;
 HEAP32[i36 + 732 >> 2] = 0;
 i1 = (i34 | 0) < 5 ? (i1 ? 1 : 2) : i1 ? 12 : 5;
 i1 = (i1 | 0) > (i34 | 0) ? i34 : i1;
 HEAP32[i37 >> 2] = i1;
 HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] = i1;
 HEAP32[i36 + 96 >> 2] = 134;
 i1 = HEAP32[i37 >> 2] | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) i1 = 50; else if ((i1 + -8 | 0) >>> 0 < 5) i1 = 41; else if ((i1 + -5 | 0) >>> 0 < 8) i1 = 40; else if ((i1 + -3 | 0) >>> 0 < 2) i1 = 50; else i1 = (i1 + -2 | 0) >>> 0 < 3 ? 40 : 30;
 HEAP32[i36 + 88 >> 2] = i1;
 i26 = i36 + 16 | 0;
 i2 = i36 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE(i35, 0) | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i39 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
  i1 = HEAP32[i39 + 12 >> 2] | 0;
  i29 = 9;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i39 + 11 >> 0] = i3;
  if (!i3) i1 = i39; else {
   i1 = i39;
   i29 = 11;
  }
 } else i29 = 9;
 if ((i29 | 0) == 9) {
  i34 = i3 + 16 & -16;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i39 + 8 >> 2] = i34 | -2147483648;
  HEAP32[i39 + 4 >> 2] = i3;
  i29 = 11;
 }
 if ((i29 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i39 + 11 | 0;
 do if ((i26 | 0) != (i39 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i39 >> 2] | 0 : i39;
  i7 = i3 ? HEAP32[i39 + 4 >> 2] | 0 : i7 & 255;
  i3 = i26 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i36 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i36 + 20 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i26, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i26 >> 2] | 0; else i1 = i26;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i36 + 20 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i34 = HEAP32[i39 >> 2] | 0;
  i33 = HEAP32[i39 + 12 >> 2] | 0;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i33;
  __Z19free_alloc_internalPvRK10MemLabelId(i34, i24);
 }
 i2 = __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE(i35, 1) | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i39 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
  i1 = HEAP32[i39 + 12 >> 2] | 0;
  i29 = 33;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i39 + 11 >> 0] = i3;
  if (!i3) i1 = i39; else {
   i1 = i39;
   i29 = 35;
  }
 } else i29 = 33;
 if ((i29 | 0) == 33) {
  i34 = i3 + 16 & -16;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i39 + 8 >> 2] = i34 | -2147483648;
  HEAP32[i39 + 4 >> 2] = i3;
  i29 = 35;
 }
 if ((i29 | 0) == 35) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i39 + 11 | 0;
 do if ((i36 | 0) != (i39 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i39 >> 2] | 0 : i39;
  i7 = i3 ? HEAP32[i39 + 4 >> 2] | 0 : i7 & 255;
  i3 = i36 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i36 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i36 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i36, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i36 >> 2] | 0; else i1 = i36;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i36 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i34 = HEAP32[i39 >> 2] | 0;
  i33 = HEAP32[i39 + 12 >> 2] | 0;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i33;
  __Z19free_alloc_internalPvRK10MemLabelId(i34, i24);
 }
 i22 = i36 + 32 | 0;
 i2 = __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE(i35, 2) | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i39 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
  i1 = HEAP32[i39 + 12 >> 2] | 0;
  i29 = 57;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i39 + 11 >> 0] = i3;
  if (!i3) i1 = i39; else {
   i1 = i39;
   i29 = 59;
  }
 } else i29 = 57;
 if ((i29 | 0) == 57) {
  i34 = i3 + 16 & -16;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i39 + 8 >> 2] = i34 | -2147483648;
  HEAP32[i39 + 4 >> 2] = i3;
  i29 = 59;
 }
 if ((i29 | 0) == 59) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i39 + 11 | 0;
 do if ((i22 | 0) != (i39 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i39 >> 2] | 0 : i39;
  i7 = i3 ? HEAP32[i39 + 4 >> 2] | 0 : i7 & 255;
  i3 = i22 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i36 + 40 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i36 + 36 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i22, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i22 >> 2] | 0; else i1 = i22;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i36 + 36 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i34 = HEAP32[i39 >> 2] | 0;
  i33 = HEAP32[i39 + 12 >> 2] | 0;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i33;
  __Z19free_alloc_internalPvRK10MemLabelId(i34, i24);
 };
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, gb + 606220 | 0, 13);
 i30 = i36 + 544 | 0;
 HEAP8[i30 >> 0] = (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i24) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 i30 = HEAP8[i30 >> 0] | 0;
 i33 = i30 << 24 >> 24 != 0;
 i7 = i36 + 64 | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 HEAP32[i39 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i39 + 11 | 0;
 HEAP8[i3 >> 0] = 3;
 HEAP8[i39 >> 0] = HEAP8[gb + 606234 >> 0] | 0;
 HEAP8[i39 + 1 >> 0] = HEAP8[gb + 606234 + 1 >> 0] | 0;
 HEAP8[i39 + 2 >> 0] = HEAP8[gb + 606234 + 2 >> 0] | 0;
 HEAP8[i39 + 3 >> 0] = 0;
 L112 : do if ((i7 | 0) != (i39 | 0)) {
  i4 = i7 + 11 | 0;
  do if ((HEAP8[i4 >> 0] | 0) < 0) {
   i1 = HEAP32[i36 + 72 >> 2] & 2147483647;
   i2 = i1 + -1 | 0;
   if (i2 >>> 0 < 3) {
    i34 = HEAP32[i36 + 68 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i2, 4 - i1 | 0, i34, 0, i34, 3, i39);
    break L112;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    break;
   }
  } else i1 = i7; while (0);
  _memmove(i1 | 0, i39 | 0, 3) | 0;
  HEAP8[i1 + 3 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i36 + 68 >> 2] = 3;
   break;
  } else {
   HEAP8[i4 >> 0] = 3;
   break;
  }
 } while (0);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i34 = HEAP32[i39 >> 2] | 0;
  i29 = HEAP32[i39 + 12 >> 2] | 0;
  HEAP32[i24 >> 2] = 66;
  HEAP32[i24 + 4 >> 2] = i29;
  __Z19free_alloc_internalPvRK10MemLabelId(i34, i24);
 }
 i23 = i36 + 584 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 i34 = i39 + 4 | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 i19 = i22 + 11 | 0;
 i1 = HEAP8[i19 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i22 >> 2] | 0;
  i1 = HEAP32[i36 + 36 >> 2] | 0;
 } else {
  i2 = i22;
  i1 = i1 & 255;
 };
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, i2, i1);
 __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi(i24, 32, i39, 4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 i1 = HEAP32[i39 >> 2] | 0;
 i3 = (HEAP32[i34 >> 2] | 0) - i1 | 0;
 i2 = i1;
 do if ((i3 | 0) > 24) {
  i29 = HEAP8[i1 + 11 >> 0] | 0;
  if (((i29 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i29 & 255) | 0) == 6) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, gb + 606238 | 0, 6) | 0)) {
   i25 = HEAP32[i39 >> 2] | 0;
   i1 = i25 + 12 | 0;
   i29 = HEAP8[i1 + 11 >> 0] | 0;
   if (((i29 << 24 >> 24 < 0 ? HEAP32[i25 + 16 >> 2] | 0 : i29 & 255) | 0) == 2) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, gb + 606245 | 0, 2) | 0)) {
    i2 = HEAP32[i39 >> 2] | 0;
    i1 = i2 + 24 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i23 >> 2] = _atoi(i1) | 0;
    if ((i3 | 0) <= 36) {
     i29 = 117;
     break;
    }
    i6 = i2 + 36 | 0;
    i5 = HEAP8[i6 + 11 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i6 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
    i5 = i3 ? HEAP32[i2 + 40 >> 2] | 0 : i5 & 255;
    i3 = i7 + 11 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i4 = (HEAP32[i36 + 72 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i5 >>> 0 > i4 >>> 0) {
     if (i2) i1 = HEAP32[i36 + 68 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
     i29 = 117;
     break;
    }
    if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
    if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i3 >> 0] | 0) < 0) {
     HEAP32[i36 + 68 >> 2] = i5;
     i29 = 117;
     break;
    } else {
     HEAP8[i3 >> 0] = i5;
     i29 = 117;
     break;
    }
   } else i29 = 117; else i29 = 117;
  } else i29 = 117; else i29 = 117;
 } else if ((i3 | 0) > 0) i29 = 117; else i29 = 134; while (0);
 do if ((i29 | 0) == 117) {
  i1 = HEAP32[i39 >> 2] | 0;
  i25 = HEAP8[i1 + 11 >> 0] | 0;
  if (((i25 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i25 & 255) | 0) == 6) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, gb + 606238 | 0, 6) | 0)) {
   i1 = i36 + 48 | 0;
   i7 = HEAP8[i19 >> 0] | 0;
   i4 = i7 << 24 >> 24 < 0;
   i6 = i4 ? HEAP32[i22 >> 2] | 0 : i22;
   i7 = i4 ? HEAP32[i36 + 36 >> 2] | 0 : i7 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i36 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i7 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i36 + 52 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
    break;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i36 + 52 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } else i29 = 134; else i29 = 134;
 } while (0);
 do if ((i29 | 0) == 134) {
  i2 = i36 + 48 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i8 + 11 | 0;
  HEAP8[i4 >> 0] = 7;
  HEAP8[i8 >> 0] = HEAP8[gb + 606248 >> 0] | 0;
  HEAP8[i8 + 1 >> 0] = HEAP8[gb + 606248 + 1 >> 0] | 0;
  HEAP8[i8 + 2 >> 0] = HEAP8[gb + 606248 + 2 >> 0] | 0;
  HEAP8[i8 + 3 >> 0] = HEAP8[gb + 606248 + 3 >> 0] | 0;
  HEAP8[i8 + 4 >> 0] = HEAP8[gb + 606248 + 4 >> 0] | 0;
  HEAP8[i8 + 5 >> 0] = HEAP8[gb + 606248 + 5 >> 0] | 0;
  HEAP8[i8 + 6 >> 0] = HEAP8[gb + 606248 + 6 >> 0] | 0;
  HEAP8[i8 + 7 >> 0] = 0;
  L190 : do if ((i2 | 0) != (i8 | 0)) {
   i5 = i2 + 11 | 0;
   do if ((HEAP8[i5 >> 0] | 0) < 0) {
    i1 = HEAP32[i36 + 56 >> 2] & 2147483647;
    i3 = i1 + -1 | 0;
    if (i3 >>> 0 < 7) {
     i25 = HEAP32[i36 + 52 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i3, 8 - i1 | 0, i25, 0, i25, 7, i8);
     break L190;
    } else {
     i1 = HEAP32[i2 >> 2] | 0;
     break;
    }
   } else i1 = i2; while (0);
   _memmove(i1 | 0, i8 | 0, 7) | 0;
   HEAP8[i1 + 7 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i36 + 52 >> 2] = 7;
    break;
   } else {
    HEAP8[i5 >> 0] = 7;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i25 = HEAP32[i8 >> 2] | 0;
   i21 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i24 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i25, i24);
  }
  i6 = HEAP8[i19 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i22 >> 2] | 0 : i22;
  i6 = i7 ? HEAP32[i36 + 36 >> 2] | 0 : i6 & 255;
  i7 = i2 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) {
   i4 = (HEAP32[i36 + 56 >> 2] & 2147483647) + -1 | 0;
   i1 = HEAP32[i36 + 52 >> 2] | 0;
  } else {
   i4 = 10;
   i1 = i1 & 255;
  }
  if ((i4 - i1 | 0) >>> 0 < i6 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i4, i6 - i4 + i1 | 0, i1, i1, 0, i6, i5);
   break;
  }
  if (i6 | 0) {
   if (i3) i2 = HEAP32[i2 >> 2] | 0;
   _memcpy(i2 + i1 | 0, i5 | 0, i6 | 0) | 0;
   i1 = i1 + i6 | 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i36 + 52 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } while (0);
 HEAP32[i36 + 108 >> 2] = 1;
 HEAP8[i36 + 104 >> 0] = 1;
 i20 = i36 + 632 | 0;
 HEAP32[i20 >> 2] = 0;
 i25 = i36 + 11 | 0;
 i9 = HEAP8[i25 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 7) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L229 : do if ((i2 | 0) < 7) i1 = i5; else {
   i4 = i6 + -6 | 0;
   if ((i4 | 0) == (i1 | 0)) i1 = i5; else L231 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 80) {
      i2 = gb + 606256 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L229;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606256 + 7 | 0)) break L231;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L229;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 i15 = i36 + 640 | 0;
 HEAP8[i15 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 4) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L249 : do if ((i2 | 0) < 4) i1 = i5; else {
   i4 = i6 + -3 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L251 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 77) {
      i2 = gb + 606264 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L249;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606264 + 4 | 0)) break L251;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L249;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 HEAP8[i36 + 641 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 6) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L269 : do if ((i2 | 0) < 6) i1 = i5; else {
   i4 = i6 + -5 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L271 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 65) {
      i2 = gb + 606269 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L269;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606269 + 6 | 0)) break L271;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L269;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 i18 = i36 + 642 | 0;
 HEAP8[i18 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 5) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L289 : do if ((i2 | 0) < 5) i1 = i5; else {
   i4 = i6 + -4 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L291 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 84) {
      i2 = gb + 606276 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L289;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606276 + 5 | 0)) break L291;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L289;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 HEAP8[i36 + 643 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 5) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L309 : do if ((i2 | 0) < 5) i1 = i5; else {
   i4 = i6 + -4 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L311 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 73) {
      i2 = gb + 606282 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L309;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606282 + 5 | 0)) break L311;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L309;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 i17 = i36 + 644 | 0;
 HEAP8[i17 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 6) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L329 : do if ((i2 | 0) < 6) i1 = i5; else {
   i4 = i6 + -5 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L331 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 78) {
      i2 = gb + 606288 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L329;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606288 + 6 | 0)) break L331;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L329;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 HEAP8[i36 + 645 >> 0] = (i1 | 0) != -1 & 1;
 if (i8) {
  i2 = HEAP32[i36 + 4 >> 2] | 0;
  i1 = HEAP32[i36 >> 2] | 0;
 } else {
  i2 = i9 & 255;
  i1 = i36;
 }
 if (i2 >>> 0 < 3) i29 = 256; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L349 : do if ((i2 | 0) < 3) i1 = i5; else {
   i4 = i6 + -2 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L351 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 65) {
      i2 = gb + 606295 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L349;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606295 + 3 | 0)) break L351;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L349;
    }
   }
  } while (0);
  if ((i1 | 0) == (i6 | 0) | (i1 - i7 | 0) == -1) i29 = 256; else i1 = 1;
 }
 if ((i29 | 0) == 256) {
  if (i8) {
   i2 = HEAP32[i36 + 4 >> 2] | 0;
   i1 = HEAP32[i36 >> 2] | 0;
  } else {
   i2 = i9 & 255;
   i1 = i36;
  }
  if (i2 >>> 0 < 3) i1 = -1; else {
   i6 = i1 + i2 | 0;
   i5 = i6;
   i7 = i1;
   L370 : do if ((i2 | 0) < 3) i1 = i5; else {
    i4 = i6 + -2 | 0;
    if ((i4 | 0) == (i1 | 0)) {
     i1 = i5;
     break;
    }
    L372 : while (1) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == 65) {
       i2 = gb + 606299 | 0;
       i3 = i1;
       break;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i5;
       break L370;
      }
     }
     do {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (gb + 606299 + 3 | 0)) break L372;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L370;
     }
    }
   } while (0);
   i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
  }
  i1 = (i1 | 0) != -1;
 }
 i21 = i36 + 646 | 0;
 HEAP8[i21 >> 0] = i1 & 1;
 i14 = i26 + 11 | 0;
 i1 = HEAP8[i14 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i36 + 20 >> 2] | 0;
  i1 = HEAP32[i26 >> 2] | 0;
 } else {
  i2 = i1 & 255;
  i1 = i26;
 }
 if (i2 >>> 0 < 7) i1 = -1; else {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L391 : do if ((i2 | 0) < 7) i1 = i5; else {
   i4 = i6 + -6 | 0;
   if ((i4 | 0) == (i1 | 0)) {
    i1 = i5;
    break;
   }
   L393 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 86) {
      i2 = gb + 606303 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L391;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 606303 + 7 | 0)) break L393;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L391;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i7 | 0;
 }
 i16 = i36 + 647 | 0;
 HEAP8[i16 >> 0] = (i1 | 0) != -1 & 1;
 i3 = HEAP32[i37 >> 2] | 0;
 if (i8) {
  i2 = HEAP32[i36 >> 2] | 0;
  i1 = HEAP32[i36 + 4 >> 2] | 0;
 } else {
  i2 = i36;
  i1 = i9 & 255;
 };
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, i2, i1);
 L409 : do if ((i3 | 0) == 1) {
  i10 = HEAP8[i24 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i9 = i11 ? HEAP32[i24 >> 2] | 0 : i24;
  i10 = i11 ? HEAP32[i24 + 4 >> 2] | 0 : i10 & 255;
  i11 = i9 + i10 | 0;
  i12 = i11;
  i13 = i9;
  i8 = 0;
  while (1) {
   i6 = HEAP32[gb + 77224 + (i8 << 2) >> 2] | 0;
   i1 = _strlen(i6) | 0;
   if (i10 >>> 0 >= i1 >>> 0) {
    if (!i1) {
     i1 = 1;
     break L409;
    }
    i7 = i6 + i1 | 0;
    L416 : do if ((i10 | 0) < (i1 | 0)) i1 = i12; else {
     i4 = i11 + (1 - i1) | 0;
     if ((i4 | 0) == (i9 | 0)) {
      i1 = i12;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     i1 = i9;
     L419 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i6;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i12;
        break L416;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break L419;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i12;
       break L416;
      }
     }
    } while (0);
    if (!((i1 | 0) == (i11 | 0) | (i1 - i13 | 0) == -1)) {
     i1 = 1;
     break L409;
    }
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= 12) {
    i1 = 0;
    break;
   }
  }
 } else i1 = 0; while (0);
 HEAP8[i36 + 648 >> 0] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 & 16711935 | 0) == 0 & (HEAPU16[i15 >> 1] | 0) < 256) i1 = (HEAP8[i16 >> 0] | 0) != 0; else i1 = 1;
 HEAP8[i36 + 508 >> 0] = i1 & 1;
 HEAP8[i36 + 509 >> 0] = i2;
 HEAP8[i36 + 496 >> 0] = 0;
 HEAP8[i36 + 649 >> 0] = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 640 >> 0] | 0)) i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 641 >> 0] | 0) != 0; else i1 = 1;
 HEAP8[i36 + 650 >> 0] = i1 & 1;
 i29 = HEAP32[i37 >> 2] | 0;
 HEAP8[i36 + 726 >> 0] = (i29 | 0) != 1 & 1;
 HEAPF32[i36 + 100 >> 2] = Math_fround(512.0);
 if ((i29 + -5 | 0) >>> 0 < 8) i1 = (__ZNK7ApiGLES3GetEj(i35, 3123) | 0) == 1; else i1 = 0;
 HEAP8[i36 + 155 >> 0] = i1 & 1;
 do if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606311 | 0) | 0) {
  if (!(HEAP32[i35 + 404 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  if (!(HEAP32[i35 + 408 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  if (!(HEAP32[i35 + 412 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  if (!(HEAP32[i35 + 372 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  if (!(HEAP32[i35 + 376 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  if (!(HEAP32[i35 + 380 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  i1 = (HEAP32[i35 + 384 >> 2] | 0) != 0;
 } else i1 = 0; while (0);
 HEAP8[i36 + 662 >> 0] = i1 & 1;
 do if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606311 | 0) | 0) {
  if (!(HEAP32[i35 + 404 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 408 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 412 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 372 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 376 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 380 >> 2] | 0)) {
   i29 = 326;
   break;
  }
  if (!(HEAP32[i35 + 384 >> 2] | 0)) i29 = 326; else i29 = 327;
 } else i29 = 326; while (0);
 if ((i29 | 0) == 326) if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606324 | 0) | 0) i29 = 327; else i1 = 0;
 if ((i29 | 0) == 327) i1 = 1;
 HEAP8[i36 + 663 >> 0] = i1;
 do if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606311 | 0) | 0) {
  if (!(HEAP32[i35 + 404 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 408 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 412 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 372 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 376 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 380 >> 2] | 0)) {
   i29 = 336;
   break;
  }
  if (!(HEAP32[i35 + 384 >> 2] | 0)) i29 = 336; else i29 = 337;
 } else i29 = 336; while (0);
 if ((i29 | 0) == 336) if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606344 | 0) | 0) i29 = 337; else i1 = 0;
 if ((i29 | 0) == 337) i1 = 1;
 HEAP8[i36 + 664 >> 0] = i1;
 if (i33) {
  HEAP8[i36 + 723 >> 0] = 0;
  i1 = 0;
 } else {
  HEAP8[i36 + 723 >> 0] = (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606363 | 0) | 0) & 1;
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606385 | 0) | 0;
 }
 HEAP8[i36 + 725 >> 0] = i1 & 1;
 i3 = i36 + 148 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i37 >> 2] | 0;
 L480 : do if ((i1 + -10 | 0) >>> 0 < 3) {
  i1 = i36 + 494 | 0;
  HEAP8[i1 >> 0] = 1;
  i29 = 349;
 } else {
  i2 = (i1 + -3 | 0) >>> 0 < 2;
  if (i33 | i2) {
   i1 = i36 + 494 | 0;
   HEAP8[i1 >> 0] = i2 & 1;
   if (i2) {
    i29 = 349;
    break;
   } else {
    i15 = i1;
    break;
   }
  }
  do if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606407 | 0) | 0) {
   if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606429 | 0) | 0)) break;
   i24 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606460 | 0) | 0;
   i1 = i36 + 494 | 0;
   HEAP8[i1 >> 0] = i24 & 1;
   if (i24) {
    i29 = 349;
    break L480;
   } else {
    i15 = i1;
    break L480;
   }
  } while (0);
  i15 = i36 + 494 | 0;
  HEAP8[i15 >> 0] = 0;
 } while (0);
 if ((i29 | 0) == 349) {
  i15 = __ZNK7ApiGLES3GetEj(i35, 37085) | 0;
  i24 = i36 + 568 | 0;
  HEAP32[i24 >> 2] = (i15 | 0) > 24 ? 24 : i15;
  i15 = __ZNK7ApiGLES3GetEj(i35, 37596) | 0;
  HEAP32[i36 + 572 >> 2] = (i15 | 0) > 8 ? 8 : i15;
  i15 = __ZNK7ApiGLES3GetEj(i35, 36664) | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  HEAP32[i3 >> 2] = (i24 | 0) < (i15 | 0) ? i24 : i15;
  i15 = i1;
 }
 i2 = HEAP32[i37 >> 2] | 0;
 do if ((i2 + -7 | 0) >>> 0 < 6) i1 = 1; else {
  i1 = (i2 + -3 | 0) >>> 0 < 2;
  if (i33 | i1) break;
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606496 | 0) | 0;
  i2 = HEAP32[i37 >> 2] | 0;
 } while (0);
 HEAP8[i36 + 697 >> 0] = i1 & 1;
 i1 = (i2 + -5 | 0) >>> 0 < 8;
 do if (!(i33 | i1)) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606517 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606550 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606583 | 0) | 0;
 } while (0);
 HEAP8[i36 + 698 >> 0] = i1 & 1;
 if ((HEAP8[i25 >> 0] | 0) < 0) i1 = HEAP32[i36 >> 2] | 0; else i1 = i36;
 HEAP32[i27 >> 2] = i1;
 _printf_console(gb + 606616 | 0, i27);
 if ((HEAP8[i14 >> 0] | 0) < 0) i1 = HEAP32[i26 >> 2] | 0; else i1 = i26;
 HEAP32[i38 >> 2] = i1;
 _printf_console(gb + 606630 | 0, i38);
 if ((HEAP8[i19 >> 0] | 0) < 0) i1 = HEAP32[i22 >> 2] | 0; else i1 = i22;
 HEAP32[i31 >> 2] = i1;
 _printf_console(gb + 606644 | 0, i31);
 HEAP32[i32 >> 2] = HEAP32[i23 >> 2];
 _printf_console(gb + 606658 | 0, i32);
 __ZNK7ApiGLES18GetExtensionStringEv(i38, i35);
 i27 = HEAP8[i38 + 11 >> 0] | 0;
 i1 = i27 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i38 + 4 >> 2] | 0 : i27 & 255) | 0)) _printf_console(gb + 606672 | 0, i28); else __Z19DebugTextLineByLinePKci(i1 ? HEAP32[i38 >> 2] | 0 : i38, -1);
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -5 | 0) >>> 0 < 8) i29 = 373; else {
  i1 = (i1 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) if (i1) {
   i29 = 373;
   break;
  } else {
   i1 = 1;
   break;
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606709 | 0) | 0) {
   i29 = 373;
   break;
  } else {
   i1 = 1;
   break;
  }
 } while (0);
 if ((i29 | 0) == 373) i1 = 2;
 HEAP32[i36 + 636 >> 2] = i1;
 do if (i33) i1 = 0; else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606728 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606766 | 0) | 0;
 } while (0);
 i3 = i36 + 157 | 0;
 HEAP8[i3 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 L530 : do if ((i1 + -5 | 0) >>> 0 < 8) i29 = 386; else {
  i2 = (i1 + -2 | 0) >>> 0 < 3;
  do if (i33 | i2) {
   i1 = i36 + 156 | 0;
   HEAP8[i1 >> 0] = i2 & 1;
   if (i2) {
    i29 = 389;
    break L530;
   }
  } else {
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606728 | 0) | 0) {
    i29 = 386;
    break L530;
   }
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606766 | 0) | 0) {
    i29 = 386;
    break L530;
   }
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606804 | 0) | 0) {
    i29 = 386;
    break L530;
   }
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606830 | 0) | 0) {
    i29 = 386;
    break L530;
   }
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606863 | 0) | 0) {
    i28 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606893 | 0) | 0;
    i1 = i36 + 156 | 0;
    HEAP8[i1 >> 0] = i28 & 1;
    if (i28) {
     i29 = 389;
     break L530;
    } else break;
   } else {
    i1 = i36 + 156 | 0;
    HEAP8[i1 >> 0] = 0;
    break;
   }
  } while (0);
  if (HEAP8[i3 >> 0] | 0) {
   i29 = 389;
   break;
  }
  HEAP32[i36 + 552 >> 2] = 1;
 } while (0);
 if ((i29 | 0) == 386) {
  i1 = i36 + 156 | 0;
  HEAP8[i1 >> 0] = 1;
  i29 = 389;
 }
 do if ((i29 | 0) == 389) {
  i28 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606766 | 0) | 0;
  i28 = __ZNK7ApiGLES3GetEj(i35, i28 ? 37173 : 36183) | 0;
  i2 = i36 + 552 | 0;
  HEAP32[i2 >> 2] = i28;
  if (i28 | 0) break;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
  HEAP32[i2 >> 2] = 1;
 } while (0);
 if (i33) i1 = 0; else i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606916 | 0) | 0;
 HEAP8[i36 + 652 >> 0] = i1 & 1;
 i1 = ((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8;
 do if (!(i33 | i1)) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606943 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606969 | 0) | 0;
 } while (0);
 HEAP8[i36 + 653 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 i28 = (i1 + -5 | 0) >>> 0 < 8;
 HEAP8[i36 + 493 >> 0] = (i28 | (i1 + -2 | 0) >>> 0 < 3) & 1;
 HEAP8[i36 + 535 >> 0] = 0;
 HEAP8[i36 + 536 >> 0] = 0;
 HEAP8[i36 + 153 >> 0] = i28 & 1;
 if ((i1 | 0) == 1) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606993 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 HEAP8[i36 + 154 >> 0] = i2 & 1;
 HEAP8[i36 + 686 >> 0] = (i1 | 0) != 1 & 1;
 do if ((i1 + -5 | 0) >>> 0 < 8) i1 = 2; else {
  i1 = (i1 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) {
   i1 = i1 ? 2 : 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607020 | 0) | 0) {
   i1 = 2;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607040 | 0) | 0;
  i1 = i1 ? 2 : 1;
 } while (0);
 i6 = i36 + 484 | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i37 >> 2] | 0;
 do if ((i2 + -9 | 0) >>> 0 < 4) i1 = 1; else {
  i1 = (i2 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607072 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607095 | 0) | 0)) {
   i1 = 0;
   break;
  }
  if (!((i2 | 0) == 1 & (i2 + -1 | 0) >>> 0 < 4)) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606993 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = (HEAP32[i23 >> 2] | 0) > 2;
 } while (0);
 HEAP8[i36 + 684 >> 0] = i1 & 1;
 do if (i33) {
  HEAP32[i36 + 524 >> 2] = 0;
  i1 = 0;
 } else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607118 | 0) | 0) i1 = 1; else i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607140 | 0) | 0;
  HEAP32[i36 + 524 >> 2] = i1 & 1;
  if ((HEAP32[i37 >> 2] | 0) != 1) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607072 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607095 | 0) | 0)) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606993 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = (HEAP32[i23 >> 2] | 0) > 2;
 } while (0);
 HEAP8[i36 + 689 >> 0] = i1 & 1;
 i14 = i36 + 680 | 0;
 HEAP32[i14 >> 2] = 0;
 i1 = HEAP32[i37 >> 2] | 0;
 HEAP8[i36 + 685 >> 0] = (i1 + -2 | 0) >>> 0 > 2 & (i1 + -5 | 0) >>> 0 > 7 & 1;
 if ((i1 | 0) == 1) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607162 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 i5 = i36 + 481 | 0;
 HEAP8[i5 >> 0] = i2 & 1;
 do if (!(HEAP8[i16 >> 0] | 0)) {
  if ((i1 + -5 | 0) >>> 0 < 8) {
   i2 = 1;
   break;
  }
  i2 = (i1 + -2 | 0) >>> 0 < 3;
 } else i2 = 0; while (0);
 i4 = i36 + 482 | 0;
 HEAP8[i4 >> 0] = i2 & 1;
 i2 = (i1 + -7 | 0) >>> 0 < 6;
 if (!(i33 | i2)) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607180 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 }
 HEAP8[i36 + 483 >> 0] = i2 & 1;
 do if ((i1 + -10 | 0) >>> 0 < 3) i1 = 1; else {
  i1 = (i1 | 0) == 4;
  if (i33 | i1) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607210 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607228 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607246 | 0) | 0;
 } while (0);
 i3 = i36 + 687 | 0;
 HEAP8[i3 >> 0] = i1 & 1;
 do if ((HEAP32[i37 >> 2] | 0) == 1) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607264 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605976 | 0) | 0;
 } else i1 = 1; while (0);
 HEAP8[i36 + 476 >> 0] = i1 & 1;
 do if (((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8) i1 = 1; else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607297 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605976 | 0) | 0;
 } while (0);
 HEAP8[i36 + 477 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 HEAP8[i36 + 478 >> 0] = (i1 + -1 | 0) >>> 0 > 3 & 1;
 if ((i1 + -5 | 0) >>> 0 < 8) i2 = 1; else {
  HEAP32[i32 >> 2] = 0;
  HEAP32[i32 + 4 >> 2] = 0;
  HEAP32[i32 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i32, gb + 607325 | 0, 23);
  i2 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i32) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
  i1 = HEAP32[i37 >> 2] | 0;
 }
 HEAP8[i36 + 688 >> 0] = i2 & 1;
 do if ((i1 + -6 | 0) >>> 0 < 7) i2 = 1; else {
  i2 = (i1 + -2 | 0) >>> 0 < 3;
  if (i33 | i2) break;
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607349 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } while (0);
 HEAP8[i36 + 690 >> 0] = i2 & 1;
 i1 = (i1 + -10 | 0) >>> 0 < 3;
 if (!(i33 | i1)) i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607372 | 0) | 0;
 HEAP8[i36 + 722 >> 0] = i1 & 1;
 i27 = __ZNK7ApiGLES3GetEj(i35, 35661) | 0;
 i28 = i36 + 120 | 0;
 HEAP32[i28 >> 2] = (i27 | 0) > 32 ? 32 : i27;
 HEAP32[i36 + 556 >> 2] = (__ZNK7ApiGLES3GetEj(i35, 35660) | 0) > 0 & 1;
 HEAP32[i36 + 116 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i36 + 124 >> 2] = __ZNK7ApiGLES3GetEj(i35, 3379) | 0;
 HEAP32[i36 + 128 >> 2] = __ZNK7ApiGLES3GetEj(i35, 34076) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) i1 = 1; else i1 = __ZNK7ApiGLES3GetEj(i35, 35071) | 0;
 HEAP32[i36 + 136 >> 2] = i1;
 do if (i33) i1 = 1; else {
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607401 | 0) | 0)) if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607435 | 0) | 0)) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES3GetEj(i35, 34047) | 0;
 } while (0);
 HEAP32[i36 + 112 >> 2] = i1;
 HEAP8[i36 + 152 >> 0] = (i1 | 0) > 1 & 1;
 HEAP32[i36 + 528 >> 2] = (HEAP8[i3 >> 0] | 0) == 0 ? 0 : 31;
 HEAP32[i20 >> 2] = 0;
 if (((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 >= 8) {
  __ZNK7ApiGLES18GetFramebufferInfoEv(i32, i35);
  do if ((HEAP32[i32 >> 2] | 0) == 5) {
   if ((HEAP32[i32 + 4 >> 2] | 0) != 6) break;
   if ((HEAP32[i32 + 8 >> 2] | 0) != 5) break;
   HEAP32[i20 >> 2] = 4;
  } while (0);
 }
 HEAP8[i36 + 170 >> 0] = 1;
 if (!(HEAP8[i5 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[i4 >> 0] | 0) != 0;
 HEAP8[i36 + 501 >> 0] = i1 & 1;
 do if ((HEAP32[i37 >> 2] | 0) == 1) {
  if (HEAP8[i18 >> 0] | 0) if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607473 | 0) | 0)) {
   i1 = 1;
   break;
  }
  i1 = 0;
 } else i1 = 0; while (0);
 i2 = i36 + 715 | 0;
 HEAP8[i2 >> 0] = i1;
 do if ((HEAP32[i37 >> 2] | 0) == 1) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607503 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607524 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607548 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607568 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607591 | 0) | 0;
 } else i1 = 1; while (0);
 i4 = i36 + 505 | 0;
 HEAP8[i4 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -2 | 0) >>> 0 < 11) i1 = 1; else {
  if ((i1 | 0) != 1) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607612 | 0) | 0) {
   i1 = 1;
   break;
  }
  __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607640 | 0) | 0;
  i1 = 1;
 } while (0);
 HEAP8[i36 + 699 >> 0] = i1 & 1;
 if (!(HEAP8[i4 >> 0] | 0)) i1 = 0; else i1 = i1 & (HEAP8[i2 >> 0] | 0) == 0;
 HEAP8[i36 + 506 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -10 | 0) >>> 0 < 3) i1 = 1; else {
  i1 = (i1 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607668 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607694 | 0) | 0;
 } while (0);
 HEAP8[i36 + 673 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -5 | 0) >>> 0 < 8) i29 = 483; else {
  i1 = (i1 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) {
   HEAP8[i36 + 665 >> 0] = i1 & 1;
   if (i1) {
    i1 = 1;
    break;
   }
  } else {
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606893 | 0) | 0) if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607721 | 0) | 0) {
    i29 = 483;
    break;
   }
   i28 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607739 | 0) | 0;
   HEAP8[i36 + 665 >> 0] = i28 & 1;
   if (i28) {
    i1 = 1;
    break;
   }
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606830 | 0) | 0;
 } while (0);
 if ((i29 | 0) == 483) {
  HEAP8[i36 + 665 >> 0] = 1;
  i1 = 1;
 }
 i3 = i36 + 666 | 0;
 HEAP8[i3 >> 0] = i1 & 1;
 if (i33) i1 = 0; else i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607763 | 0) | 0;
 HEAP8[i36 + 672 >> 0] = i1 & 1;
 do if (((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8) {
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607806 | 0) | 0)) {
   i1 = 1;
   break;
  }
  i1 = HEAP32[i17 >> 2] | 0;
  if ((i1 & 255) << 24 >> 24) {
   i1 = 1;
   break;
  }
  i1 = (i1 & 16711680 | 0) != 0;
 } else i1 = 0; while (0);
 HEAP8[i36 + 675 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -2 | 0) >>> 0 < 11) i1 = 1; else {
  if ((i1 | 0) != 1) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607831 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607850 | 0) | 0)) {
   i1 = 0;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607869 | 0) | 0;
 } while (0);
 HEAP8[i36 + 674 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 if ((i1 | 0) == 1) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607897 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 HEAP8[i36 + 676 >> 0] = i2 & 1;
 HEAP8[i36 + 144 >> 0] = (i1 | 0) != 1 & 1;
 do if ((i1 + -2 | 0) >>> 0 < 11) i29 = 504; else {
  if ((i1 | 0) != 1) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607831 | 0) | 0) {
   i29 = 504;
   break;
  }
  if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607850 | 0) | 0)) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607869 | 0) | 0) i29 = 504; else i1 = 1;
 } while (0);
 do if ((i29 | 0) == 504) {
  i1 = __ZNK7ApiGLES3GetEj(i35, 36063) | 0;
  if ((i1 | 0) < 1) {
   i1 = 1;
   break;
  }
  i1 = (i1 | 0) > 8 ? 8 : i1;
 } while (0);
 HEAP32[i36 + 140 >> 2] = i1;
 HEAP32[i36 + 488 >> 2] = HEAP32[i6 >> 2];
 HEAP8[i36 + 532 >> 0] = 0;
 HEAP8[i36 + 510 >> 0] = 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -1 | 0) >>> 0 < 4) i1 = 1; else {
  if ((i1 + -8 | 0) >>> 0 < 5) {
   i1 = (HEAP8[i17 >> 0] | 0) == 0;
   break;
  }
  if (i33) {
   i1 = 0;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607806 | 0) | 0;
  i1 = i1 & (HEAP8[i17 >> 0] | 0) == 0;
 } while (0);
 HEAP8[i36 + 721 >> 0] = i1 & 1;
 HEAP8[i36 + 717 >> 0] = 1;
 if (!(HEAP8[i3 >> 0] | 0)) i1 = 36160; else i1 = HEAP8[i16 >> 0] | 0 ? 36009 : 36160;
 HEAP32[i36 + 668 >> 2] = i1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -8 | 0) >>> 0 < 5) i1 = 1; else {
  i1 = (i1 + -1 | 0) >>> 0 < 4;
  if (i33 | i1) break;
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607806 | 0) | 0;
 } while (0);
 HEAP8[i36 + 719 >> 0] = i1 & 1;
 HEAP32[i36 + 132 >> 2] = __ZNK7ApiGLES3GetEj(i35, 34024) | 0;
 i1 = i36 + 507 | 0;
 if ((HEAP32[i37 >> 2] | 0) == 1) {
  HEAP8[i1 >> 0] = 0;
  i1 = HEAP8[i4 >> 0] | 0;
 } else {
  HEAP8[i1 >> 0] = 1;
  i1 = 1;
 }
 i4 = i36 + 502 | 0;
 HEAP8[i4 >> 0] = i1;
 HEAP8[i36 + 691 >> 0] = 0;
 HEAP8[i36 + 692 >> 0] = 0;
 i2 = HEAP32[i37 >> 2] | 0;
 do if ((i2 + -5 | 0) >>> 0 < 8) i1 = 1; else {
  i1 = (i2 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) break;
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606709 | 0) | 0;
  i2 = HEAP32[i37 >> 2] | 0;
 } while (0);
 HEAP8[i36 + 693 >> 0] = i1 & 1;
 do if ((i2 + -5 | 0) >>> 0 < 8) {
  i1 = 1;
  i3 = i2;
 } else {
  i1 = (i2 + -2 | 0) >>> 0 < 3;
  if (i33 | i1) {
   i3 = i2;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607912 | 0) | 0;
  i3 = HEAP32[i37 >> 2] | 0;
 } while (0);
 HEAP8[i36 + 512 >> 0] = i1 & 1;
 HEAP8[i36 + 695 >> 0] = ((i3 + -5 | 0) >>> 0 < 8 | (i3 + -3 | 0) >>> 0 < 2) & 1;
 HEAP8[i36 + 694 >> 0] = 0;
 HEAP8[i36 + 503 >> 0] = HEAP8[i4 >> 0] | 0;
 i1 = HEAP8[i25 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i36 >> 2] | 0;
  i1 = HEAP32[i36 + 4 >> 2] | 0;
 } else {
  i2 = i36;
  i1 = i1 & 255;
 };
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i32, i2, i1);
 L732 : do if ((i3 + -1 | 0) >>> 0 < 4) {
  if ((i3 | 0) != 1) {
   i1 = 1;
   break;
  }
  i10 = HEAP8[i32 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i9 = i11 ? HEAP32[i32 >> 2] | 0 : i32;
  i10 = i11 ? HEAP32[i32 + 4 >> 2] | 0 : i10 & 255;
  i11 = i9 + i10 | 0;
  i12 = i11;
  i13 = i9;
  i8 = 0;
  while (1) {
   i6 = HEAP32[gb + 77224 + (i8 << 2) >> 2] | 0;
   i1 = _strlen(i6) | 0;
   if (i10 >>> 0 >= i1 >>> 0) {
    if (!i1) {
     i1 = 0;
     break L732;
    }
    i7 = i6 + i1 | 0;
    L740 : do if ((i10 | 0) < (i1 | 0)) i1 = i12; else {
     i4 = i11 + (1 - i1) | 0;
     if ((i4 | 0) == (i9 | 0)) {
      i1 = i12;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     i1 = i9;
     L743 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i6;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i12;
        break L740;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break L743;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i12;
       break L740;
      }
     }
    } while (0);
    if (!((i1 | 0) == (i11 | 0) | (i1 - i13 | 0) == -1)) {
     i1 = 0;
     break L732;
    }
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= 12) {
    i1 = 1;
    break;
   }
  }
 } else i1 = 2; while (0);
 HEAP32[i36 + 92 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
 HEAP8[i36 + 654 >> 0] = 0;
 i1 = HEAP32[i37 >> 2] | 0;
 if ((i1 + -5 | 0) >>> 0 < 8) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607937 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 0;
 HEAP8[i36 + 655 >> 0] = i2 & 1;
 if ((i1 + -5 | 0) >>> 0 < 8) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607962 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 0;
 HEAP8[i36 + 656 >> 0] = i2 & 1;
 if ((i1 | 0) == 1) {
  mftCall_viiii(HEAP32[i35 + 356 >> 2] | 0, 35632, 36338, i32 | 0, i31 | 0);
  i2 = (HEAP32[i32 >> 2] | HEAP32[i31 >> 2] | HEAP32[i32 + 4 >> 2] | 0) != 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 HEAP8[i36 + 703 >> 0] = i2 & 1;
 HEAP8[i36 + 479 >> 0] = (i1 + -1 | 0) >>> 0 < 4 & 1;
 if ((i1 | 0) == 1) {
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607989 | 0) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 HEAP8[i36 + 704 >> 0] = i2 & 1;
 HEAP8[i36 + 700 >> 0] = ((i1 + -5 | 0) >>> 0 < 8 | (i1 + -2 | 0) >>> 0 < 3) & 1;
 i3 = i36 + 709 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i36 + 710 >> 0] = 0;
 HEAP8[i36 + 711 >> 0] = 0;
 HEAP8[i36 + 712 >> 0] = HEAP8[i16 >> 0] | 0;
 i1 = i36 + 628 | 0;
 HEAP32[i1 >> 2] = 0;
 i32 = ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -5 | 0) >>> 0 < 8;
 i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0;
 do if (i32) {
  if ((i2 + -5 | 0) >>> 0 < 8) {
   i32 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i32 + 1;
   HEAP32[i36 + 588 + (i32 << 2) >> 2] = 6;
  }
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -8 | 0) >>> 0 < 5) {
   i32 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i32 + 1;
   HEAP32[i36 + 588 + (i32 << 2) >> 2] = 7;
  }
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -10 | 0) >>> 0 >= 3) break;
  i32 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i32 + 1;
  HEAP32[i36 + 588 + (i32 << 2) >> 2] = 8;
 } else {
  if ((i2 | 0) == 1) {
   i32 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i32 + 1;
   HEAP32[i36 + 588 + (i32 << 2) >> 2] = 5;
   break;
  }
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 >= 4) break;
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -2 | 0) >>> 0 < 3) {
   i32 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i32 + 1;
   HEAP32[i36 + 588 + (i32 << 2) >> 2] = 4;
  }
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
   i32 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i32 + 1;
   HEAP32[i36 + 588 + (i32 << 2) >> 2] = 3;
  }
  if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) != 4) break;
  i32 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i32 + 1;
  HEAP32[i36 + 588 + (i32 << 2) >> 2] = 2;
 } while (0);
 HEAP8[i36 + 657 >> 0] = 0;
 HEAP8[i36 + 658 >> 0] = 0;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -5 | 0) >>> 0 < 8) i1 = 1; else {
  if (!((i1 | 0) == 4 | i33 ^ 1)) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608015 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608039 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608062 | 0) | 0;
 } while (0);
 HEAP8[i36 + 659 >> 0] = i1 & 1;
 HEAP8[i36 + 701 >> 0] = 0;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -7 | 0) >>> 0 < 6) i1 = 1; else {
  if (!((i1 | 0) == 4 | i33 ^ 1)) {
   i1 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608085 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608112 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608139 | 0) | 0;
 } while (0);
 HEAP8[i36 + 660 >> 0] = i1 & 1;
 HEAP32[i36 + 564 >> 2] = 0;
 HEAP8[i36 + 511 >> 0] = 0;
 if ((HEAP32[i37 >> 2] | 0) == 1) i1 = (__ZNK7ApiGLES3GetEj(i35, 36347) | 0) << 2; else i1 = __ZNK7ApiGLES3GetEj(i35, 35658) | 0;
 HEAP32[i36 + 580 >> 2] = i1;
 L806 : do if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i37 >> 2] | 0;
  do if ((i1 + -5 | 0) >>> 0 < 8) {
   i1 = i36 + 661 | 0;
   HEAP8[i1 >> 0] = 1;
  } else {
   i2 = (i1 + -2 | 0) >>> 0 < 3;
   if (i33 | i2) {
    i1 = i36 + 661 | 0;
    HEAP8[i1 >> 0] = i2 & 1;
    if (i2) break; else break L806;
   } else {
    i32 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608166 | 0) | 0;
    i1 = i36 + 661 | 0;
    HEAP8[i1 >> 0] = i32 & 1;
    if (i32) break; else break L806;
   }
  } while (0);
  HEAP32[i36 + 576 >> 2] = __ZNK7ApiGLES3GetEj(i35, 35376) | 0;
  i32 = __ZNK7ApiGLES3GetEj(i35, 35375) | 0;
  HEAP32[i36 + 560 >> 2] = (i32 | 0) > 64 ? 64 : i32;
 } else {
  i1 = i36 + 661 | 0;
  HEAP8[i1 >> 0] = 0;
 } while (0);
 i2 = HEAP32[i37 >> 2] | 0;
 do if ((i2 + -5 | 0) >>> 0 < 8) i29 = 597; else {
  i2 = (i2 + -2 | 0) >>> 0 < 3;
  if (i33 | i2) if (i2) {
   i29 = 597;
   break;
  } else {
   i3 = 0;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608195 | 0) | 0) {
   i29 = 597;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608216 | 0) | 0) {
   i29 = 597;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608238 | 0) | 0) {
   i29 = 597;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608260 | 0) | 0) i29 = 597; else i3 = 0;
 } while (0);
 if ((i29 | 0) == 597) i3 = HEAP8[i1 >> 0] | 0;
 i1 = i36 + 495 | 0;
 HEAP8[i1 >> 0] = i3;
 i2 = HEAP32[i37 >> 2] | 0;
 if ((i2 + -5 | 0) >>> 0 < 8) HEAP8[i1 >> 0] = (i2 + -8 | 0) >>> 0 < 5 & (i3 & 255);
 i1 = __ZNK7ApiGLES3GetEj(i35, 34921) | 0;
 HEAP32[i36 + 548 >> 2] = (i1 | 0) > 15 ? 15 : i1;
 HEAP8[i36 + 716 >> 0] = 1;
 HEAP8[i36 + 161 >> 0] = 1;
 i1 = HEAP32[i37 >> 2] | 0;
 do if ((i1 + -7 | 0) >>> 0 < 6) i1 = 1; else {
  if ((i1 + -5 | 0) >>> 0 < 8) if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608283 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = 0;
 } while (0);
 HEAP8[i36 + 162 >> 0] = i1;
 HEAP8[i36 + 163 >> 0] = 1;
 i1 = HEAP32[i37 >> 2] | 0;
 if ((i1 | 0) == 1) {
  i2 = (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608309 | 0) | 0) & 1;
  i1 = HEAP32[i37 >> 2] | 0;
 } else i2 = 1;
 HEAP8[i36 + 164 >> 0] = i2;
 i5 = i33 ^ 1;
 do if ((i1 | 0) == 4 | i5) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608329 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608360 | 0) | 0;
 } else i1 = 0; while (0);
 HEAP8[i36 + 166 >> 0] = i1 & 1;
 do if (i33) i1 = 0; else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608390 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608430 | 0) | 0;
 } while (0);
 HEAP8[i36 + 167 >> 0] = i1 & 1;
 i1 = HEAP32[i37 >> 2] | 0;
 HEAP8[i36 + 718 >> 0] = (i1 + -5 | 0) >>> 0 < 8 & 1;
 i1 = (i1 + -6 | 0) >>> 0 < 7;
 do if (!(i33 | i1)) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608469 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608488 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 645 >> 0] | 0) {
   i1 = 0;
   break;
  }
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 643 >> 0] | 0) {
   i1 = 0;
   break;
  }
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | 0) {
   i1 = 0;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608506 | 0) | 0;
 } while (0);
 HEAP8[i36 + 169 >> 0] = i1 & 1;
 do if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 645 >> 0] | 0)) {
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 643 >> 0] | 0) {
   i1 = 0;
   break;
  }
  if ((HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | i30) << 24 >> 24) {
   i1 = 0;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608506 | 0) | 0;
 } else i1 = 0; while (0);
 HEAP8[i36 + 720 >> 0] = i1 & 1;
 i1 = ((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8;
 do if (!(i33 | i1)) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608534 | 0) | 0) {
   i1 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608566 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608596 | 0) | 0;
 } while (0);
 i2 = ((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8;
 do if (!(i33 | i2)) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608633 | 0) | 0) {
   i2 = 1;
   break;
  }
  i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608665 | 0) | 0;
 } while (0);
 i3 = ((HEAP32[i37 >> 2] | 0) + -9 | 0) >>> 0 < 4;
 if (!(i33 | i3)) i3 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608697 | 0) | 0;
 do if (i33) {
  i4 = 0;
  i10 = 0;
 } else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608729 | 0) | 0) i4 = 1; else i4 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608762 | 0) | 0;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608793 | 0) | 0) {
   i10 = 1;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608823 | 0) | 0) {
   i10 = 1;
   break;
  }
  i10 = (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608856 | 0) | 0) & 1;
 } while (0);
 do if ((HEAP32[i37 >> 2] | 0) == 4 | i5) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608885 | 0) | 0) {
   i11 = 1;
   break;
  }
  i11 = (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608921 | 0) | 0) & 1;
 } else i11 = 0; while (0);
 i5 = HEAP32[i37 >> 2] | 0;
 do if (!(HEAP8[i21 >> 0] | 0)) {
  if ((i5 + -10 | 0) >>> 0 < 3) {
   i5 = 1;
   break;
  }
  i5 = (i5 + -2 | 0) >>> 0 < 3;
  if (i33 | i5) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 607937 | 0) | 0) {
   i5 = 1;
   break;
  }
  i5 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608955 | 0) | 0;
 } else i5 = 0; while (0);
 i6 = HEAP32[i37 >> 2] | 0;
 do if ((i6 + -5 | 0) >>> 0 < 8) i6 = 1; else {
  i6 = (i6 + -2 | 0) >>> 0 < 3;
  if (i33 | i6) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605914 | 0) | 0) {
   i6 = 1;
   break;
  }
  i6 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605932 | 0) | 0;
 } while (0);
 i7 = HEAP32[i37 >> 2] | 0;
 do if ((i7 + -5 | 0) >>> 0 < 8) i7 = 1; else {
  i7 = (i7 + -2 | 0) >>> 0 < 3;
  if (i33 | i7) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605997 | 0) | 0) {
   i7 = 1;
   break;
  }
  i7 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605976 | 0) | 0;
 } while (0);
 i8 = HEAP32[i37 >> 2] | 0;
 do if ((i8 + -5 | 0) >>> 0 < 8) i8 = 1; else {
  i8 = (i8 + -2 | 0) >>> 0 < 3;
  if (i33 | i8) break;
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 606074 | 0) | 0) {
   i8 = 1;
   break;
  }
  i8 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 605976 | 0) | 0;
 } while (0);
 if (((HEAP32[i37 >> 2] | 0) + -1 | 0) >>> 0 < 4) i9 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 608984 | 0) | 0; else i9 = 1;
 HEAP8[i36 + 172 >> 0] = 1;
 HEAP8[i36 + 174 >> 0] = 1;
 HEAP8[i36 + 175 >> 0] = 1;
 HEAP8[i36 + 184 >> 0] = 1;
 HEAP8[i36 + 192 >> 0] = 1;
 i32 = i1 & 1;
 HEAP8[i36 + 181 >> 0] = i32;
 HEAP8[i36 + 182 >> 0] = i32;
 HEAP8[i36 + 183 >> 0] = i32;
 i32 = i2 & 1;
 HEAP8[i36 + 197 >> 0] = i32;
 HEAP8[i36 + 198 >> 0] = i32;
 i32 = i3 & 1;
 HEAP8[i36 + 195 >> 0] = i32;
 HEAP8[i36 + 196 >> 0] = i32;
 _memset(i36 + 201 | 0, i4 & 1 | 0, 4) | 0;
 HEAP8[i36 + 206 >> 0] = i10;
 HEAP8[i36 + 207 >> 0] = i10;
 _memset(i36 + 212 | 0, i5 & 1 | 0, 7) | 0;
 do if (i33) i1 = 0; else {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 609006 | 0) | 0) {
   i1 = 1;
   break;
  }
  i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i35, gb + 609042 | 0) | 0;
 } while (0);
 HEAP8[i36 + 205 >> 0] = (i5 | i1) & 1;
 _memset(i36 + 219 | 0, i11 | 0, 12) | 0;
 i1 = i6 & i8 & 1;
 HEAP8[i36 + 186 >> 0] = i1;
 HEAP8[i36 + 187 >> 0] = i1;
 HEAP8[i36 + 188 >> 0] = i8 & 1;
 i1 = i6 & i7 & 1;
 HEAP8[i36 + 189 >> 0] = i1;
 HEAP8[i36 + 190 >> 0] = i1;
 HEAP8[i36 + 191 >> 0] = i7 & 1;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP8[i36 + 180 >> 0] = i9 ? (i1 | 0) == 2 & 1 : 0;
 HEAP8[i36 + 176 >> 0] = 0;
 HEAP8[i36 + 173 >> 0] = 0;
 HEAP8[i36 + 178 >> 0] = 1;
 HEAP8[i36 + 177 >> 0] = 0;
 HEAP8[i36 + 179 >> 0] = ((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 < 8 & 1;
 HEAP8[i36 + 185 >> 0] = (i1 | 0) != 0 & 1;
 i1 = i36 + 256 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP16[i1 + 20 >> 1] = 0;
 HEAP8[i1 + 22 >> 0] = 0;
 do if (HEAP8[i15 >> 0] | 0) {
  HEAP8[i36 + 267 >> 0] = 1;
  HEAP8[i36 + 258 >> 0] = 1;
  HEAP8[i36 + 270 >> 0] = 1;
  HEAP8[i36 + 273 >> 0] = 1;
  HEAP8[i36 + 275 >> 0] = 1;
  HEAP8[i1 >> 0] = 1;
  if (!(HEAP8[i15 >> 0] | 0)) break;
  if (((HEAP32[i37 >> 2] | 0) + -5 | 0) >>> 0 >= 8) break;
  HEAP8[i36 + 268 >> 0] = 1;
  HEAP8[i36 + 269 >> 0] = 1;
  HEAP8[i36 + 271 >> 0] = 1;
  HEAP8[i36 + 274 >> 0] = 1;
  HEAP8[i36 + 264 >> 0] = 1;
  HEAP8[i36 + 272 >> 0] = 1;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
 i1 = HEAP32[i39 >> 2] | 0;
 if (!i1) {
  STACKTOP = i40;
  return;
 }
 i2 = HEAP32[i34 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i38 = i2 + -12 | 0;
   HEAP32[i34 >> 2] = i38;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
   i2 = HEAP32[i34 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i39 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i40;
 return;
}

function __ZNK6Avatar10GetZYPostQEiRK11QuaternionfS2_(i31, i5, i9, i11, i12) {
 i31 = i31 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i32 + 16 | 0;
 i16 = i32;
 i10 = HEAP32[i5 + 56 >> 2] | 0;
 if ((i9 | 0) < 0) {
  f2 = Math_fround(0.0);
  f1 = Math_fround(1.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f34 = Math_fround(f2 * f2);
  f14 = Math_fround(f3 * f3);
  f33 = Math_fround(f4 * f4);
  f26 = Math_fround(f1 * f1);
  f14 = Math_fround(f34 + f14);
  f26 = Math_fround(f33 + f26);
  f26 = Math_fround(f14 + f26);
  f14 = Math_fround(Math_sqrt(Math_fround(f26)));
  f2 = Math_fround(f2 / f14);
  f3 = Math_fround(f3 / f14);
  f4 = Math_fround(f4 / f14);
  f14 = Math_fround(f1 / f14);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = f26 > Math_fround(1.0e-30);
  i29 = i25 ? i29 : 0;
  i27 = i25 ? i27 : 0;
  i28 = i25 ? i28 : 0;
  i30 = i25 ? i30 : 1065353216;
  HEAP32[i31 >> 2] = i29;
  i29 = i31 + 4 | 0;
  HEAP32[i29 >> 2] = i27;
  i29 = i31 + 8 | 0;
  HEAP32[i29 >> 2] = i28;
  i31 = i31 + 12 | 0;
  HEAP32[i31 >> 2] = i30;
  STACKTOP = i32;
  return;
 }
 do if ((i9 | 0) < 24) {
  i5 = i10 + 20 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (!i6) {
   f4 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f14 = Math_fround(0.0);
   f26 = Math_fround(0.0);
   f1 = Math_fround(f4 * f4);
   f33 = Math_fround(f14 * f14);
   f2 = Math_fround(f26 * f26);
   f34 = Math_fround(f3 * f3);
   f33 = Math_fround(f1 + f33);
   f34 = Math_fround(f2 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f4 = Math_fround(f4 / f33);
   f14 = Math_fround(f14 / f33);
   f26 = Math_fround(f26 / f33);
   f33 = Math_fround(f3 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  }
  i7 = i6 + i5 | 0;
  i30 = i7 + 40 | 0;
  if (!(HEAP32[(HEAP32[i30 >> 2] | 0) + i30 >> 2] | 0)) i17 = 8; else i5 = i7 + 72 + (i9 << 2) | 0;
 } else {
  if ((i9 | 0) < 39) {
   i5 = i10 + 20 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if (!i6) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
   } else {
    i17 = 8;
    break;
   }
   f26 = Math_fround(f1 * f1);
   f33 = Math_fround(f3 * f3);
   f14 = Math_fround(f4 * f4);
   f34 = Math_fround(f2 * f2);
   f33 = Math_fround(f26 + f33);
   f34 = Math_fround(f14 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f1 = Math_fround(f1 / f33);
   f14 = Math_fround(f3 / f33);
   f26 = Math_fround(f4 / f33);
   f33 = Math_fround(f2 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  }
  if ((i9 | 0) >= 54) {
   f4 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f14 = Math_fround(0.0);
   f26 = Math_fround(0.0);
   f1 = Math_fround(f4 * f4);
   f33 = Math_fround(f14 * f14);
   f2 = Math_fround(f26 * f26);
   f34 = Math_fround(f3 * f3);
   f33 = Math_fround(f1 + f33);
   f34 = Math_fround(f2 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f4 = Math_fround(f4 / f33);
   f14 = Math_fround(f14 / f33);
   f26 = Math_fround(f26 / f33);
   f33 = Math_fround(f3 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  }
  i5 = i10 + 20 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (!i6) {
   f4 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f14 = Math_fround(0.0);
   f26 = Math_fround(0.0);
   f1 = Math_fround(f4 * f4);
   f33 = Math_fround(f14 * f14);
   f2 = Math_fround(f26 * f26);
   f34 = Math_fround(f3 * f3);
   f33 = Math_fround(f1 + f33);
   f34 = Math_fround(f2 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f4 = Math_fround(f4 / f33);
   f14 = Math_fround(f14 / f33);
   f26 = Math_fround(f26 / f33);
   f33 = Math_fround(f3 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  } else i17 = 13;
 } while (0);
 if ((i17 | 0) == 8) {
  i7 = i5 + i6 | 0;
  i30 = i7 + 40 | 0;
  if (!(HEAP32[i30 + (HEAP32[i30 >> 2] | 0) >> 2] | 0)) i17 = 13; else {
   i7 = i7 + 48 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   if (!i8) i17 = 13; else i5 = i8 + i7 + (i9 + -24 << 2) | 0;
  }
 }
 do if ((i17 | 0) == 13) {
  i5 = i5 + i6 | 0;
  i30 = i5 + 40 | 0;
  if (!(HEAP32[i30 + (HEAP32[i30 >> 2] | 0) >> 2] | 0)) {
   f4 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f14 = Math_fround(0.0);
   f26 = Math_fround(0.0);
   f1 = Math_fround(f4 * f4);
   f33 = Math_fround(f14 * f14);
   f2 = Math_fround(f26 * f26);
   f34 = Math_fround(f3 * f3);
   f33 = Math_fround(f1 + f33);
   f34 = Math_fround(f2 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f4 = Math_fround(f4 / f33);
   f14 = Math_fround(f14 / f33);
   f26 = Math_fround(f26 / f33);
   f33 = Math_fround(f3 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  }
  i5 = i5 + 52 | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  if (!i7) {
   f4 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f14 = Math_fround(0.0);
   f26 = Math_fround(0.0);
   f1 = Math_fround(f4 * f4);
   f33 = Math_fround(f14 * f14);
   f2 = Math_fround(f26 * f26);
   f34 = Math_fround(f3 * f3);
   f33 = Math_fround(f1 + f33);
   f34 = Math_fround(f2 + f34);
   f34 = Math_fround(f33 + f34);
   f33 = Math_fround(Math_sqrt(Math_fround(f34)));
   f4 = Math_fround(f4 / f33);
   f14 = Math_fround(f14 / f33);
   f26 = Math_fround(f26 / f33);
   f33 = Math_fround(f3 / f33);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = f34 > Math_fround(1.0e-30);
   i29 = i25 ? i29 : 0;
   i27 = i25 ? i27 : 0;
   i28 = i25 ? i28 : 0;
   i30 = i25 ? i30 : 1065353216;
   HEAP32[i31 >> 2] = i29;
   i29 = i31 + 4 | 0;
   HEAP32[i29 >> 2] = i27;
   i29 = i31 + 8 | 0;
   HEAP32[i29 >> 2] = i28;
   i31 = i31 + 12 | 0;
   HEAP32[i31 >> 2] = i30;
   STACKTOP = i32;
   return;
  } else {
   i5 = i7 + i5 + (i9 + -39 << 2) | 0;
   break;
  }
 } while (0);
 i5 = HEAP32[i5 >> 2] | 0;
 if ((i5 | 0) == -1) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f14 = Math_fround(0.0);
  f26 = Math_fround(0.0);
  f1 = Math_fround(f4 * f4);
  f33 = Math_fround(f14 * f14);
  f2 = Math_fround(f26 * f26);
  f34 = Math_fround(f3 * f3);
  f33 = Math_fround(f1 + f33);
  f34 = Math_fround(f2 + f34);
  f34 = Math_fround(f33 + f34);
  f33 = Math_fround(Math_sqrt(Math_fround(f34)));
  f4 = Math_fround(f4 / f33);
  f14 = Math_fround(f14 / f33);
  f26 = Math_fround(f26 / f33);
  f33 = Math_fround(f3 / f33);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = f34 > Math_fround(1.0e-30);
  i29 = i25 ? i29 : 0;
  i27 = i25 ? i27 : 0;
  i28 = i25 ? i28 : 0;
  i30 = i25 ? i30 : 1065353216;
  HEAP32[i31 >> 2] = i29;
  i29 = i31 + 4 | 0;
  HEAP32[i29 >> 2] = i27;
  i29 = i31 + 8 | 0;
  HEAP32[i29 >> 2] = i28;
  i31 = i31 + 12 | 0;
  HEAP32[i31 >> 2] = i30;
  STACKTOP = i32;
  return;
 }
 i6 = i6 + (i10 + 20) + 40 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
 i27 = i6 + 4 | 0;
 i27 = HEAP32[i27 + (HEAP32[i27 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
 if ((i27 | 0) == -1) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f14 = Math_fround(0.0);
  f26 = Math_fround(0.0);
  f1 = Math_fround(f4 * f4);
  f33 = Math_fround(f14 * f14);
  f2 = Math_fround(f26 * f26);
  f34 = Math_fround(f3 * f3);
  f33 = Math_fround(f1 + f33);
  f34 = Math_fround(f2 + f34);
  f34 = Math_fround(f33 + f34);
  f33 = Math_fround(Math_sqrt(Math_fround(f34)));
  f4 = Math_fround(f4 / f33);
  f14 = Math_fround(f14 / f33);
  f26 = Math_fround(f26 / f33);
  f33 = Math_fround(f3 / f33);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = f34 > Math_fround(1.0e-30);
  i29 = i25 ? i29 : 0;
  i27 = i25 ? i27 : 0;
  i28 = i25 ? i28 : 0;
  i30 = i25 ? i30 : 1065353216;
  HEAP32[i31 >> 2] = i29;
  i29 = i31 + 4 | 0;
  HEAP32[i29 >> 2] = i27;
  i29 = i31 + 8 | 0;
  HEAP32[i29 >> 2] = i28;
  i31 = i31 + 12 | 0;
  HEAP32[i31 >> 2] = i30;
  STACKTOP = i32;
  return;
 }
 i28 = HEAP32[i11 >> 2] | 0;
 i29 = HEAP32[i11 + 4 >> 2] | 0;
 i30 = HEAP32[i11 + 8 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f34 = Math_fround(HEAPF32[i12 >> 2]);
 f38 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 i18 = i6 + 16 | 0;
 i18 = (HEAP32[i18 >> 2] | 0) + i18 | 0;
 i19 = i18 + (i27 * 76 | 0) | 0;
 f14 = (HEAP32[tempDoublePtr >> 2] = i29 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f14 * f34);
 f3 = Math_fround(f26 * f39);
 f2 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f2 * f38);
 f36 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f26 * f1)) - Math_fround(f2 * f39)) - Math_fround(f36 * f38));
 f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f36 * f34)) - Math_fround(f2 * f1)) - Math_fround(f14 * f38));
 f33 = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f14 * f1)) - Math_fround(f26 * f34)) - Math_fround(f36 * f39));
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f1) - Math_fround(f34 * f2)) - Math_fround(f26 * f38)) - Math_fround(f14 * f39));
 i20 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f39 = (HEAP32[tempDoublePtr >> 2] = i22 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f39 * f39);
 f4 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f4 * f4);
 f38 = (HEAP32[tempDoublePtr >> 2] = i20 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f33 + f14) + Math_fround(Math_fround(f3 * f3) + Math_fround(f38 * f38))))));
 f39 = Math_fround(f14 * f39);
 f4 = Math_fround(f14 * f4);
 f38 = Math_fround(f14 * f38);
 f3 = Math_fround(f14 * f3);
 i20 = i18 + (i27 * 76 | 0) + 4 | 0;
 i21 = i18 + (i27 * 76 | 0) + 8 | 0;
 i22 = i18 + (i27 * 76 | 0) + 12 | 0;
 f14 = Math_fround(HEAPF32[i22 >> 2]);
 f33 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 16 >> 2]);
 f2 = Math_fround(f4 * f33);
 i23 = i18 + (i27 * 76 | 0) + 28 | 0;
 f34 = Math_fround(HEAPF32[i23 >> 2]);
 f1 = Math_fround(f3 * f34);
 i24 = i18 + (i27 * 76 | 0) + 20 | 0;
 f36 = Math_fround(HEAPF32[i24 >> 2]);
 f35 = Math_fround(f38 * f36);
 i25 = i18 + (i27 * 76 | 0) + 24 | 0;
 f37 = Math_fround(HEAPF32[i25 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f3 * f37)) - Math_fround(f38 * f34)) - Math_fround(f39 * f36));
 f1 = Math_fround(Math_fround(Math_fround(f1 - Math_fround(f39 * f33)) - Math_fround(f38 * f37)) - Math_fround(f4 * f36));
 f35 = Math_fround(Math_fround(Math_fround(f35 - Math_fround(f4 * f37)) - Math_fround(f3 * f33)) - Math_fround(f39 * f34));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f38 * f33)) - Math_fround(f3 * f36)) - Math_fround(f4 * f34));
 i15 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(f34 * f35);
 f4 = Math_fround(f14 * f1);
 f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f36 * f3);
 f38 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i19 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f14 * f37)) - Math_fround(f36 * f1)) - Math_fround(f38 * f3));
 f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f38 * f35)) - Math_fround(f36 * f37)) - Math_fround(f34 * f3));
 f33 = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f34 * f37)) - Math_fround(f14 * f35)) - Math_fround(f38 * f1));
 f1 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f37) - Math_fround(f36 * f35)) - Math_fround(f14 * f3)) - Math_fround(f34 * f1));
 i15 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f1 = (HEAP32[tempDoublePtr >> 2] = i17 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f1 * f1);
 f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f2 * f2);
 f3 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f33 + f34) + Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3))))));
 f1 = Math_fround(f34 * f1);
 f2 = Math_fround(f34 * f2);
 f3 = Math_fround(f34 * f3);
 f4 = Math_fround(f34 * f4);
 HEAPF32[i13 >> 2] = f1;
 HEAPF32[i13 + 4 >> 2] = f2;
 HEAPF32[i13 + 8 >> 2] = f3;
 HEAPF32[i13 + 12 >> 2] = f4;
 i15 = i18 + (i27 * 76 | 0) + 72 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 switch (i5 | 0) {
 case 3:
  {
   __ZN4mathL11quatToEulerERKNS_7_float4ENS_13RotationOrderE(i16, i13);
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
   i5 = f38 > Math_fround(0.0);
   i7 = f39 > Math_fround(0.0);
   i12 = HEAP32[i16 + 4 >> 2] | 0;
   i13 = HEAP32[i16 + 8 >> 2] | 0;
   f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f1 = Math_fround(Math_fround(-f4) / f38);
   f2 = Math_fround(Math_fround(-f3) / f39);
   i17 = f38 < Math_fround(0.0);
   i6 = f39 < Math_fround(0.0);
   i11 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i12 : 0;
   i8 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i7 ? i13 : 0;
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
   i6 = f38 < Math_fround(0.0);
   i9 = f39 < Math_fround(0.0);
   f1 = Math_fround(f4 / f38);
   f2 = Math_fround(f3 / f39);
   i7 = f38 > Math_fround(0.0);
   i10 = f39 > Math_fround(0.0);
   i17 = f4 < Math_fround(0.0);
   i5 = f3 < Math_fround(0.0);
   i16 = i17 ? i11 : i7 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i12 : 0;
   i13 = i5 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i13 : 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i17 = 23;
   break;
  }
 case 1:
  {
   f39 = Math_fround(f1 / f4);
   f38 = Math_fround(f2 / f4);
   f1 = Math_fround(f3 / f4);
   f3 = Math_fround(Math_fround(f39 * f39) + Math_fround(1.0));
   f4 = Math_fround(Math_fround(f38 - Math_fround(f39 * f1)) / f3);
   f3 = Math_fround(Math_fround(f1 + Math_fround(f39 * f38)) / f3);
   i13 = HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f4 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i12 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
   i5 = f38 > Math_fround(0.0);
   i6 = f39 > Math_fround(0.0);
   f1 = Math_fround(Math_fround(-f3) / f38);
   f2 = Math_fround(Math_fround(-f4) / f39);
   i17 = f38 < Math_fround(0.0);
   i7 = f39 < Math_fround(0.0);
   i11 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i12 : 0;
   i8 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i13 : 0;
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
   i6 = f38 < Math_fround(0.0);
   i9 = f39 < Math_fround(0.0);
   f1 = Math_fround(f3 / f38);
   f2 = Math_fround(f4 / f39);
   i7 = f38 > Math_fround(0.0);
   i10 = f39 > Math_fround(0.0);
   i17 = f3 < Math_fround(0.0);
   i5 = f4 < Math_fround(0.0);
   i15 = i17 ? i11 : i7 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i12 : 0;
   i12 = i5 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i13 : 0;
   i17 = 25;
   break;
  }
 case 2:
  {
   f39 = Math_fround(f1 / f4);
   f38 = Math_fround(f2 / f4);
   f1 = Math_fround(f3 / f4);
   f3 = Math_fround(Math_fround(f39 * f39) + Math_fround(1.0));
   f4 = Math_fround(Math_fround(f38 + Math_fround(f39 * f1)) / f3);
   f3 = Math_fround(Math_fround(f1 - Math_fround(f39 * f38)) / f3);
   i13 = HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f4 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i12 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
   i5 = f38 > Math_fround(0.0);
   i6 = f39 > Math_fround(0.0);
   f1 = Math_fround(Math_fround(-f3) / f38);
   f2 = Math_fround(Math_fround(-f4) / f39);
   i17 = f38 < Math_fround(0.0);
   i7 = f39 < Math_fround(0.0);
   i11 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i12 : 0;
   i8 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i13 : 0;
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
   i6 = f38 < Math_fround(0.0);
   i9 = f39 < Math_fround(0.0);
   f1 = Math_fround(f3 / f38);
   f2 = Math_fround(f4 / f39);
   i7 = f38 > Math_fround(0.0);
   i10 = f39 > Math_fround(0.0);
   i17 = f3 < Math_fround(0.0);
   i5 = f4 < Math_fround(0.0);
   i15 = i17 ? i11 : i7 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i12 : 0;
   i12 = i5 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i13 : 0;
   i17 = 26;
   break;
  }
 default:
  {
   f38 = Math_fround(f2 / f4);
   f3 = Math_fround(f3 / f4);
   i15 = HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f4 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
   i6 = f38 > Math_fround(0.0);
   i7 = f39 > Math_fround(0.0);
   f1 = Math_fround(Math_fround(-f3) / f38);
   f2 = Math_fround(Math_fround(-f4) / f39);
   i17 = f38 < Math_fround(0.0);
   i8 = f39 < Math_fround(0.0);
   i12 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i13 : 0;
   i9 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i7 ? i15 : 0;
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
   i7 = f38 < Math_fround(0.0);
   i10 = f39 < Math_fround(0.0);
   f1 = Math_fround(f3 / f38);
   f2 = Math_fround(f4 / f39);
   i8 = f38 > Math_fround(0.0);
   i11 = f39 > Math_fround(0.0);
   i17 = f3 < Math_fround(0.0);
   i6 = f4 < Math_fround(0.0);
   i16 = i17 ? i12 : i8 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i7 ? i13 : 0;
   i13 = i6 ? i9 : i11 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i10 ? i15 : 0;
   i17 = 23;
  }
 }
 L43 : do if ((i17 | 0) == 23) switch (i5 | 0) {
 case 1:
  {
   i15 = i16;
   i12 = i13;
   i17 = 25;
   break L43;
  }
 case 2:
  {
   i15 = i16;
   i12 = i13;
   i17 = 26;
   break L43;
  }
 case 3:
  {
   f34 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)) * Math_fround(.159154937));
   f2 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)) * Math_fround(.159154937));
   f36 = Math_fround(+_roundf(0.0));
   f36 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(0.0) - f36))));
   f1 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - Math_fround(+_roundf(+f34))))));
   f3 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f2 - Math_fround(+_roundf(+f2))))));
   f4 = Math_fround(f36 * f36);
   f33 = Math_fround(f1 * f1);
   f38 = Math_fround(f3 * f3);
   f39 = Math_fround(f4 * f4);
   f37 = Math_fround(f33 * f33);
   f14 = Math_fround(f38 * f38);
   f4 = Math_fround(f36 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f33 = Math_fround(f1 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187)))))));
   f38 = Math_fround(f3 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187)))))));
   f34 = Math_fround(f34 + Math_fround(-.25));
   f2 = Math_fround(f2 + Math_fround(-.25));
   f14 = Math_fround(+_roundf(-.25));
   f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(Math_fround(-.25) - f14))));
   f34 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - Math_fround(+_roundf(+f34))))));
   f2 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f2 - Math_fround(+_roundf(+f2))))));
   f3 = Math_fround(f14 * f14);
   f37 = Math_fround(f34 * f34);
   f1 = Math_fround(f2 * f2);
   f39 = Math_fround(f3 * f3);
   f36 = Math_fround(f37 * f37);
   f35 = Math_fround(f1 * f1);
   f3 = Math_fround(f14 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
   f37 = Math_fround(f34 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187)))))));
   f1 = Math_fround(f2 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f1 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f1 * Math_fround(76.5686187)))))));
   f35 = Math_fround(f38 * f3);
   f3 = Math_fround(f3 * f1);
   f1 = Math_fround(f4 * f1);
   f38 = Math_fround(f4 * f38);
   f4 = Math_fround(f33 * f3);
   f2 = Math_fround(f33 * f1);
   f36 = Math_fround(f33 * f38);
   f33 = Math_fround(Math_fround(f33 * f35) * Math_fround(HEAPF32[gb + 1477092 >> 2]));
   f4 = Math_fround(Math_fround(HEAPF32[gb + 1477096 >> 2]) * f4);
   f2 = Math_fround(Math_fround(HEAPF32[gb + 1477100 >> 2]) * f2);
   f36 = Math_fround(Math_fround(HEAPF32[gb + 1477104 >> 2]) * f36);
   f34 = Math_fround(Math_fround(HEAPF32[gb + 1477108 >> 2]) * f37);
   f39 = Math_fround(Math_fround(HEAPF32[gb + 1477112 >> 2]) * f37);
   f1 = Math_fround(f33 + Math_fround(f34 * f1));
   f2 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(HEAPF32[gb + 1477116 >> 2]) * f37)) + f2);
   f3 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(HEAPF32[gb + 1477120 >> 2]) * f37) * f3));
   f4 = Math_fround(Math_fround(f38 * f39) + f4);
   break L43;
  }
 default:
  {
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
   i5 = f38 > Math_fround(0.0);
   i6 = f39 > Math_fround(0.0);
   f14 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f1 = Math_fround(-Math_fround(f14 * f38));
   f2 = Math_fround(-Math_fround(f4 * f39));
   i15 = f38 < Math_fround(0.0);
   i7 = f39 < Math_fround(0.0);
   i12 = i15 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i16 : 0;
   i9 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i13 : 0;
   f37 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 56 >> 2]);
   f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
   f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
   i5 = f38 < Math_fround(0.0);
   i10 = f39 < Math_fround(0.0);
   f1 = Math_fround(f37 * Math_fround(0.0));
   f2 = Math_fround(f14 * f38);
   f3 = Math_fround(f4 * f39);
   i15 = f37 > Math_fround(0.0);
   i7 = f38 > Math_fround(0.0);
   i11 = f39 > Math_fround(0.0);
   i8 = i15 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
   i15 = f14 < Math_fround(0.0);
   i6 = f4 < Math_fround(0.0);
   i5 = i15 ? i12 : i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i16 : 0;
   i13 = i6 ? i9 : i11 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i10 ? i13 : 0;
   f37 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround(Math_fround(Math_abs(Math_fround(f37))) + Math_fround(3.14159274));
   f33 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f3 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f35 = Math_fround(f33 / Math_fround(6.28318548));
   f34 = Math_fround(f3 / Math_fround(6.28318548));
   f38 = Math_fround(_truncf(Math_fround(f37 / Math_fround(6.28318548))));
   f38 = Math_fround(Math_fround(f37 - Math_fround(f38 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f35 = Math_fround(Math_fround(f33 - Math_fround(Math_fround(_truncf(f35)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f34 = Math_fround(Math_fround(f3 - Math_fround(Math_fround(_truncf(f34)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i16 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i8 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0) ^ i5 & -2147483648;
   i13 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) ^ i13 & -2147483648;
   f34 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f35 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f34 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f34 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f34 = Math_fround(f34 * Math_fround(.159154937));
   f35 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f35, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f38 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f38, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f3 = Math_fround(+_roundf(+f34));
   f3 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f3))));
   f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - Math_fround(+_roundf(+f35))))));
   f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
   f2 = Math_fround(f3 * f3);
   f4 = Math_fround(f33 * f33);
   f1 = Math_fround(f37 * f37);
   f36 = Math_fround(f2 * f2);
   f39 = Math_fround(f4 * f4);
   f14 = Math_fround(f1 * f1);
   f2 = Math_fround(f3 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f2 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f2 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f1 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f1 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f1 * Math_fround(76.5686187)))))));
   f34 = Math_fround(f34 + Math_fround(-.25));
   f35 = Math_fround(f35 + Math_fround(-.25));
   f38 = Math_fround(f38 + Math_fround(-.25));
   f14 = Math_fround(+_roundf(+f34));
   f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f14))));
   f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f35 - Math_fround(+_roundf(+f35))))));
   f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
   f34 = Math_fround(f14 * f14);
   f37 = Math_fround(f35 * f35);
   f39 = Math_fround(f38 * f38);
   f33 = Math_fround(f34 * f34);
   f36 = Math_fround(f37 * f37);
   f3 = Math_fround(f39 * f39);
   f2 = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f34 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f34 * Math_fround(76.5686187))))))) / f2);
   f4 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187))))))) / f4);
   f1 = Math_fround(Math_fround(f38 * Math_fround(Math_fround(Math_fround(f3 * f3) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f3 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187))))))) / f1);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 32 >> 2] & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648;
   f1 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f2 * f2) + Math_fround(1.0))))));
   f1 = Math_fround(f39 * f1);
   f2 = Math_fround(f39 * f2);
   f3 = f39;
   f4 = Math_fround(f39 * f4);
   break L43;
  }
 } while (0);
 if ((i17 | 0) == 25) {
  f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
  f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
  i5 = f38 > Math_fround(0.0);
  i6 = f39 > Math_fround(0.0);
  f14 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(-Math_fround(f14 * f38));
  f2 = Math_fround(-Math_fround(f4 * f39));
  i17 = f38 < Math_fround(0.0);
  i7 = f39 < Math_fround(0.0);
  i11 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i15 : 0;
  i8 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i12 : 0;
  f37 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 56 >> 2]);
  f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
  f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
  i5 = f38 < Math_fround(0.0);
  i9 = f39 < Math_fround(0.0);
  f1 = Math_fround(f37 * Math_fround(0.0));
  f2 = Math_fround(f14 * f38);
  f3 = Math_fround(f4 * f39);
  i17 = f37 > Math_fround(0.0);
  i6 = f38 > Math_fround(0.0);
  i10 = f39 > Math_fround(0.0);
  i7 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  i5 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i15 : 0;
  i16 = f14 < Math_fround(0.0);
  i17 = f4 < Math_fround(0.0);
  i5 = i16 ? i11 : i5;
  i15 = i17 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i12 : 0;
  f35 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = Math_fround(Math_fround(Math_abs(Math_fround(f35))) + Math_fround(3.14159274));
  f33 = Math_fround(Math_fround(Math_abs(Math_fround(f33))) + Math_fround(3.14159274));
  f3 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
  f34 = Math_fround(f33 / Math_fround(6.28318548));
  f37 = Math_fround(f3 / Math_fround(6.28318548));
  f38 = Math_fround(_truncf(Math_fround(f35 / Math_fround(6.28318548))));
  f34 = Math_fround(_truncf(f34));
  f38 = Math_fround(Math_fround(f35 - Math_fround(f38 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f34 = Math_fround(Math_fround(f33 - Math_fround(f34 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f37 = Math_fround(Math_fround(f3 - Math_fround(Math_fround(_truncf(f37)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  i17 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i7 & -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) ^ i5 & -2147483648;
  i15 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
  f37 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f34 * Math_fround(.5));
  f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
  f37 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f37 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f34 = Math_fround(_fminf(Math_fround(_fmaxf(f34, Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f37 = Math_fround(f37 * Math_fround(.159154937));
  f34 = Math_fround(f34 * Math_fround(.159154937));
  f38 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f38, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
  f3 = Math_fround(+_roundf(+f37));
  f33 = Math_fround(+_roundf(+f34));
  f3 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f3))));
  f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f33))));
  f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
  f39 = Math_fround(f3 * f3);
  f2 = Math_fround(f33 * f33);
  f1 = Math_fround(f35 * f35);
  f36 = Math_fround(f39 * f39);
  f4 = Math_fround(f2 * f2);
  f14 = Math_fround(f1 * f1);
  f39 = Math_fround(f3 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187)))))));
  f2 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f4 * f4) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f2 * Math_fround(41.3416595))) + Math_fround(f4 * Math_fround(Math_fround(81.6018218) - Math_fround(f2 * Math_fround(76.5686187)))))));
  f1 = Math_fround(f35 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f1 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f1 * Math_fround(76.5686187)))))));
  f37 = Math_fround(f37 + Math_fround(-.25));
  f34 = Math_fround(f34 + Math_fround(-.25));
  f38 = Math_fround(f38 + Math_fround(-.25));
  f14 = Math_fround(+_roundf(+f37));
  f35 = Math_fround(+_roundf(+f34));
  f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f14))));
  f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f35))));
  f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
  f34 = Math_fround(f14 * f14);
  f37 = Math_fround(f35 * f35);
  f4 = Math_fround(f38 * f38);
  f33 = Math_fround(f34 * f34);
  f36 = Math_fround(f37 * f37);
  f3 = Math_fround(f4 * f4);
  f39 = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f34 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f34 * Math_fround(76.5686187))))))) / f39);
  f2 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187))))))) / f2);
  f1 = Math_fround(Math_fround(f38 * Math_fround(Math_fround(Math_fround(f3 * f3) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f3 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187))))))) / f1);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 32 >> 2] & -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648;
  i17 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648;
  f1 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(f2 + Math_fround(f1 * f39));
  f2 = Math_fround(f39 - Math_fround(f1 * f2));
  f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(1.0)) + Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4))))));
  f1 = Math_fround(f39 * f1);
  f2 = Math_fround(f39 * f2);
  f3 = f39;
  f4 = Math_fround(f39 * f4);
 } else if ((i17 | 0) == 26) {
  f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 48 >> 2]);
  f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 52 >> 2]);
  i5 = f38 > Math_fround(0.0);
  i6 = f39 > Math_fround(0.0);
  f14 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(-Math_fround(f14 * f38));
  f2 = Math_fround(-Math_fround(f4 * f39));
  i17 = f38 < Math_fround(0.0);
  i7 = f39 < Math_fround(0.0);
  i11 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i15 : 0;
  i8 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i12 : 0;
  f37 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 56 >> 2]);
  f38 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 60 >> 2]);
  f39 = Math_fround(HEAPF32[i18 + (i27 * 76 | 0) + 64 >> 2]);
  i5 = f38 < Math_fround(0.0);
  i9 = f39 < Math_fround(0.0);
  f1 = Math_fround(f37 * Math_fround(0.0));
  f2 = Math_fround(f14 * f38);
  f3 = Math_fround(f4 * f39);
  i17 = f37 > Math_fround(0.0);
  i6 = f38 > Math_fround(0.0);
  i10 = f39 > Math_fround(0.0);
  i7 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  i5 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i15 : 0;
  i16 = f14 < Math_fround(0.0);
  i17 = f4 < Math_fround(0.0);
  i5 = i16 ? i11 : i5;
  i15 = i17 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i12 : 0;
  f35 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = Math_fround(Math_fround(Math_abs(Math_fround(f35))) + Math_fround(3.14159274));
  f33 = Math_fround(Math_fround(Math_abs(Math_fround(f33))) + Math_fround(3.14159274));
  f3 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
  f34 = Math_fround(f33 / Math_fround(6.28318548));
  f37 = Math_fround(f3 / Math_fround(6.28318548));
  f38 = Math_fround(_truncf(Math_fround(f35 / Math_fround(6.28318548))));
  f34 = Math_fround(_truncf(f34));
  f38 = Math_fround(Math_fround(f35 - Math_fround(f38 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f34 = Math_fround(Math_fround(f33 - Math_fround(f34 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f37 = Math_fround(Math_fround(f3 - Math_fround(Math_fround(_truncf(f37)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  i17 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i7 & -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) ^ i5 & -2147483648;
  i15 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
  f37 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f34 * Math_fround(.5));
  f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
  f37 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f37 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f34 = Math_fround(_fminf(Math_fround(_fmaxf(f34, Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f37 = Math_fround(f37 * Math_fround(.159154937));
  f34 = Math_fround(f34 * Math_fround(.159154937));
  f38 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f38, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
  f3 = Math_fround(+_roundf(+f37));
  f33 = Math_fround(+_roundf(+f34));
  f3 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f3))));
  f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f33))));
  f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
  f2 = Math_fround(f3 * f3);
  f39 = Math_fround(f33 * f33);
  f1 = Math_fround(f35 * f35);
  f36 = Math_fround(f2 * f2);
  f4 = Math_fround(f39 * f39);
  f14 = Math_fround(f1 * f1);
  f2 = Math_fround(f3 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f2 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f2 * Math_fround(76.5686187)))))));
  f39 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f4 * f4) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f4 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187)))))));
  f1 = Math_fround(f35 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f1 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f1 * Math_fround(76.5686187)))))));
  f37 = Math_fround(f37 + Math_fround(-.25));
  f34 = Math_fround(f34 + Math_fround(-.25));
  f38 = Math_fround(f38 + Math_fround(-.25));
  f14 = Math_fround(+_roundf(+f37));
  f35 = Math_fround(+_roundf(+f34));
  f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f14))));
  f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f34 - f35))));
  f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
  f34 = Math_fround(f14 * f14);
  f37 = Math_fround(f35 * f35);
  f4 = Math_fround(f38 * f38);
  f33 = Math_fround(f34 * f34);
  f36 = Math_fround(f37 * f37);
  f3 = Math_fround(f4 * f4);
  f2 = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f34 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f34 * Math_fround(76.5686187))))))) / f2);
  f39 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187))))))) / f39);
  f1 = Math_fround(Math_fround(f38 * Math_fround(Math_fround(Math_fround(f3 * f3) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f3 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187))))))) / f1);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 32 >> 2] & -2147483648;
  i16 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 36 >> 2] & -2147483648;
  i17 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i27 * 76 | 0) + 40 >> 2] & -2147483648;
  f1 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(f39 - Math_fround(f1 * f2));
  f2 = Math_fround(Math_fround(f1 * f39) + f2);
  f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(1.0)) + Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4))))));
  f1 = Math_fround(f39 * f1);
  f2 = Math_fround(f39 * f2);
  f3 = f39;
  f4 = Math_fround(f39 * f4);
 }
 i27 = i18 + (i27 * 76 | 0) + 16 | 0;
 f34 = Math_fround(HEAPF32[i23 >> 2]);
 f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i27 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f4 * f14);
 f36 = Math_fround(f3 * f34);
 f35 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i24 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f2 * f35);
 f39 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i25 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f3 * f39)) - Math_fround(f2 * f34)) - Math_fround(f1 * f35));
 f36 = Math_fround(Math_fround(Math_fround(f36 - Math_fround(f1 * f14)) - Math_fround(f2 * f39)) - Math_fround(f4 * f35));
 f33 = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f4 * f39)) - Math_fround(f3 * f14)) - Math_fround(f1 * f34));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f39) - Math_fround(f2 * f14)) - Math_fround(f3 * f35)) - Math_fround(f4 * f34));
 i23 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f4 = Math_fround(HEAPF32[i20 >> 2]);
 f33 = (HEAP32[tempDoublePtr >> 2] = i17 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f4 * f33);
 f35 = Math_fround(HEAPF32[i22 >> 2]);
 f14 = Math_fround(f35 * f36);
 f39 = Math_fround(HEAPF32[i21 >> 2]);
 f38 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f39 * f38);
 f1 = Math_fround(HEAPF32[i19 >> 2]);
 f2 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f35 * f2)) - Math_fround(f39 * f36)) - Math_fround(f1 * f38));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f1 * f33)) - Math_fround(f39 * f2)) - Math_fround(f4 * f38));
 f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f4 * f2)) - Math_fround(f35 * f33)) - Math_fround(f1 * f36));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f2) - Math_fround(f39 * f33)) - Math_fround(f35 * f38)) - Math_fround(f4 * f36));
 i23 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f4 = (HEAP32[tempDoublePtr >> 2] = i21 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f4 * f4);
 f37 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(f37 * f37);
 f38 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f38 * f38)) + Math_fround(f36 + f3)))));
 f4 = Math_fround(f3 * f4);
 f37 = Math_fround(f3 * f37);
 f38 = Math_fround(f3 * f38);
 f14 = Math_fround(f3 * f14);
 f3 = Math_fround(HEAPF32[i27 >> 2]);
 f36 = Math_fround(f3 * f37);
 f35 = Math_fround(f34 * f14);
 f33 = Math_fround(HEAPF32[i24 >> 2]);
 f39 = Math_fround(f33 * f38);
 f2 = Math_fround(HEAPF32[i25 >> 2]);
 f36 = Math_fround(Math_fround(Math_fround(f36 - Math_fround(f2 * f14)) - Math_fround(f34 * f38)) - Math_fround(f33 * f4));
 f35 = Math_fround(Math_fround(Math_fround(f35 - Math_fround(f3 * f4)) - Math_fround(f2 * f38)) - Math_fround(f33 * f37));
 f39 = Math_fround(Math_fround(Math_fround(f39 - Math_fround(f2 * f37)) - Math_fround(f3 * f14)) - Math_fround(f34 * f4));
 f37 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f4) - Math_fround(f3 * f38)) - Math_fround(f33 * f14)) - Math_fround(f34 * f37));
 i27 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i24 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
 i25 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f37 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(f37 * f39);
 f34 = Math_fround(f26 * f35);
 f14 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f14 * f33);
 f3 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i27 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(Math_fround(Math_fround(f36 - Math_fround(f26 * f4)) - Math_fround(f14 * f35)) - Math_fround(f3 * f33));
 f34 = Math_fround(Math_fround(Math_fround(f34 - Math_fround(f3 * f39)) - Math_fround(f14 * f4)) - Math_fround(f37 * f33));
 f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f37 * f4)) - Math_fround(f26 * f39)) - Math_fround(f3 * f35));
 f35 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f4) - Math_fround(f14 * f39)) - Math_fround(f26 * f33)) - Math_fround(f37 * f35));
 i29 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i28 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i27 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f35 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f35 * f35);
 f36 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f36 * f36);
 f37 = (HEAP32[tempDoublePtr >> 2] = i29 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f38 + f26) + Math_fround(Math_fround(f34 * f34) + Math_fround(f37 * f37))))));
 f35 = Math_fround(f26 * f35);
 f34 = Math_fround(f26 * f34);
 f36 = Math_fround(f26 * f36);
 f37 = Math_fround(f26 * f37);
 f26 = Math_fround(f35 * f35);
 f38 = Math_fround(f36 * f36);
 f33 = Math_fround(f37 * f37);
 f39 = Math_fround(f34 * f34);
 f38 = Math_fround(f26 + f38);
 f39 = Math_fround(f33 + f39);
 f39 = Math_fround(f38 + f39);
 f38 = Math_fround(Math_sqrt(Math_fround(f39)));
 f35 = Math_fround(f35 / f38);
 f36 = Math_fround(f36 / f38);
 f37 = Math_fround(f37 / f38);
 f38 = Math_fround(f34 / f38);
 i29 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
 i27 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i28 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i30 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i25 = f39 > Math_fround(1.0e-30);
 i29 = i25 ? i29 : 0;
 i27 = i25 ? i27 : 0;
 i28 = i25 ? i28 : 0;
 i30 = i25 ? i30 : 1065353216;
 HEAP32[i31 >> 2] = i29;
 i29 = i31 + 4 | 0;
 HEAP32[i29 >> 2] = i27;
 i29 = i31 + 8 | 0;
 HEAP32[i29 >> 2] = i28;
 i31 = i31 + 12 | 0;
 HEAP32[i31 >> 2] = i30;
 STACKTOP = i32;
 return;
}

function __ZN5physx15PxVehicleUpdate10updateTankEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_18PxVehicleDriveTankEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f45, i14, f46, f47, i13, i192, i188, i193) {
 f45 = Math_fround(f45);
 i14 = i14 | 0;
 f46 = Math_fround(f46);
 f47 = Math_fround(f47);
 i13 = i13 | 0;
 i192 = i192 | 0;
 i188 = i188 | 0;
 i193 = i193 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, f132 = f0, i133 = 0, f134 = f0, f135 = f0, i136 = 0, i137 = 0, i138 = 0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, f153 = f0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i189 = 0, i190 = 0, i191 = 0, i194 = 0, f195 = f0, i196 = 0, i197 = 0, i198 = 0;
 i194 = STACKTOP;
 STACKTOP = STACKTOP + 11376 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i168 = i194 + 10784 | 0;
 i5 = i194 + 9664 | 0;
 i190 = i194 + 9624 | 0;
 i186 = i194 + 9604 | 0;
 i176 = i194 + 9504 | 0;
 i191 = i194 + 6544 | 0;
 i185 = i194 + 6356 | 0;
 i163 = i194 + 6328 | 0;
 i172 = i194 + 6232 | 0;
 i180 = i194 + 6092 | 0;
 i179 = i194 + 6080 | 0;
 i6 = i194 + 5936 | 0;
 i7 = i194 + 268 | 0;
 i8 = i194 + 148 | 0;
 i9 = i194 + 136 | 0;
 i10 = i194 + 52 | 0;
 i11 = i194 + 40 | 0;
 i161 = i194 + 11352 | 0;
 i162 = i194 + 6464 | 0;
 i167 = i194 + 6384 | 0;
 i177 = i194 + 6248 | 0;
 i173 = i194 + 11332 | 0;
 i175 = i194 + 6152 | 0;
 i166 = i194 + 6104 | 0;
 i164 = i194 + 28 | 0;
 i165 = i194 + 16 | 0;
 i178 = i194 + 5968 | 0;
 i174 = i194 + 11312 | 0;
 i187 = i194 + 296 | 0;
 i171 = i194 + 176 | 0;
 i169 = i194 + 64 | 0;
 i170 = i194 + 8 | 0;
 i189 = i194;
 i159 = i192 + 8 | 0;
 i184 = HEAP32[i192 + 44 >> 2] | 0;
 i160 = (i184 | 0) == 0;
 if (!i160) {
  i1 = HEAP32[i192 + 72 >> 2] | 0;
  i4 = 0;
  do {
   i2 = i4 << 2;
   i3 = HEAP32[gb + 1458456 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) {
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 1) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 4 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 2) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 8 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i2 | 3) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i1 + (i4 * 224 | 0) + 12 >> 2];
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i184 >>> 0);
 }
 i157 = i192 + 128 | 0;
 i158 = i192 + 204 | 0;
 i1 = HEAP32[gb + 1458536 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i158 >> 2];
 i181 = HEAP32[i192 + 40 >> 2] | 0;
 i4 = i192 + 72 | 0;
 i182 = HEAP32[i4 >> 2] | 0;
 i183 = HEAP32[i192 + 48 >> 2] | 0;
 i2 = 4 - (i184 << 2) | 0;
 i12 = HEAP32[i192 + 288 >> 2] | 0;
 _memcpy(i168 | 0, i192 + 224 | 0, i12 << 3 | 0) | 0;
 i156 = i168 + 64 | 0;
 HEAP32[i156 >> 2] = i12;
 i12 = i168 + 80 | 0;
 i1 = i192 + 304 | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 _memcpy(i168 + 112 | 0, i192 + 336 | 0, 416) | 0;
 i12 = HEAP32[i192 + 104 >> 2] | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 i1 = i5 + 60 | 0;
 i3 = i5 + 16 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 68 >> 2] = Math_fround(1.0);
 i1 = i5 + 116 | 0;
 i3 = i5 + 72 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 124 >> 2] = Math_fround(1.0);
 i1 = i5 + 172 | 0;
 i3 = i5 + 128 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 180 >> 2] = Math_fround(1.0);
 i1 = i5 + 228 | 0;
 i3 = i5 + 184 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 236 >> 2] = Math_fround(1.0);
 i1 = i5 + 284 | 0;
 i3 = i5 + 240 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 292 >> 2] = Math_fround(1.0);
 i1 = i5 + 340 | 0;
 i3 = i5 + 296 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 348 >> 2] = Math_fround(1.0);
 i1 = i5 + 396 | 0;
 i3 = i5 + 352 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 404 >> 2] = Math_fround(1.0);
 i1 = i5 + 452 | 0;
 i3 = i5 + 408 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 456 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 460 >> 2] = Math_fround(1.0);
 i1 = i5 + 508 | 0;
 i3 = i5 + 464 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 512 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 516 >> 2] = Math_fround(1.0);
 i1 = i5 + 564 | 0;
 i3 = i5 + 520 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 568 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 572 >> 2] = Math_fround(1.0);
 i1 = i5 + 620 | 0;
 i3 = i5 + 576 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 624 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 628 >> 2] = Math_fround(1.0);
 i1 = i5 + 676 | 0;
 i3 = i5 + 632 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 680 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 684 >> 2] = Math_fround(1.0);
 i1 = i5 + 732 | 0;
 i3 = i5 + 688 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 740 >> 2] = Math_fround(1.0);
 i1 = i5 + 788 | 0;
 i3 = i5 + 744 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 792 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 796 >> 2] = Math_fround(1.0);
 i1 = i5 + 844 | 0;
 i3 = i5 + 800 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 848 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 852 >> 2] = Math_fround(1.0);
 i1 = i5 + 900 | 0;
 i3 = i5 + 856 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 904 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 908 >> 2] = Math_fround(1.0);
 i1 = i5 + 956 | 0;
 i3 = i5 + 912 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 960 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 964 >> 2] = Math_fround(1.0);
 i1 = i5 + 1012 | 0;
 i3 = i5 + 968 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1016 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1020 >> 2] = Math_fround(1.0);
 i1 = i5 + 1068 | 0;
 i3 = i5 + 1024 | 0;
 i15 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1072 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1076 >> 2] = Math_fround(1.0);
 i3 = i5 + 1080 | 0;
 i15 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i3 = i2 + i183 | 0;
 HEAP32[i190 >> 2] = 0;
 HEAP32[i190 + 4 >> 2] = 0;
 HEAP32[i190 + 8 >> 2] = 0;
 HEAP32[i190 + 12 >> 2] = 0;
 HEAP32[i190 + 16 >> 2] = 0;
 HEAP32[i190 + 20 >> 2] = 0;
 HEAP32[i190 + 24 >> 2] = 0;
 HEAP32[i190 + 28 >> 2] = 0;
 HEAP16[i190 + 32 >> 1] = 0;
 HEAP32[i190 + 4 >> 2] = i183;
 HEAP32[i190 >> 2] = i5;
 if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i157, 3)) != Math_fround(0.0)) i155 = 13; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i157, 4)) != Math_fround(0.0)) i155 = 13; else if (Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i157, 0)) != Math_fround(0.0)) i155 = 13; else if (!(HEAP8[i192 + 194 >> 0] | 0)) if (!(HEAP8[i192 + 193 >> 0] | 0)) i1 = 0; else i155 = 13; else i155 = 13;
 if ((i155 | 0) == 13) i1 = 1;
 do if (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 256 >> 2] | 0, i12 | 0) | 0) {
  if (i1) {
   HEAP8[i190 + 33 >> 0] = 1;
   break;
  }
  if (__ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE(i159, i4) | 0) {
   HEAP8[i190 + 33 >> 0] = 1;
   break;
  }
  i3 = ((HEAP32[i192 + 88 >> 2] | 0) + 3 | 0) >>> 2;
  i1 = HEAP32[i192 + 72 >> 2] | 0;
  if (i3 | 0) {
   i2 = 0;
   do {
    HEAPF32[i1 + (i2 * 224 | 0) >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  HEAPF32[i158 >> 2] = Math_fround(0.0);
  if (!i193) {
   STACKTOP = i194;
   return;
  }
  HEAP8[i193 + 32 >> 0] = 1;
  STACKTOP = i194;
  return;
 } while (0);
 HEAP32[i186 >> 2] = 0;
 HEAP32[i186 + 4 >> 2] = 0;
 HEAP32[i186 + 8 >> 2] = 0;
 HEAP32[i186 + 12 >> 2] = 0;
 HEAP32[i186 + 16 >> 2] = 0;
 HEAP32[i186 >> 2] = i183 >>> 0 < 4 ? i183 : 4;
 i1 = i184 + -1 | 0;
 if (i1 >>> 0 > 1) {
  i2 = 1;
  do {
   HEAP32[i186 + (i2 << 2) >> 2] = 4;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i186 + (i1 << 2) >> 2] = i3;
 if (!i160) {
  i1 = HEAP32[i192 + 76 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = 0;
  do {
   i154 = i3 << 2;
   HEAP32[i176 + (i3 * 20 | 0) >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + (i154 << 2) >> 2];
   HEAP32[i176 + (i3 * 20 | 0) + 4 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i154 | 1) << 2) >> 2];
   HEAP32[i176 + (i3 * 20 | 0) + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i154 | 2) << 2) >> 2];
   HEAP32[i176 + (i3 * 20 | 0) + 12 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i154 | 3) << 2) >> 2];
   HEAP32[i176 + (i3 * 20 | 0) + 16 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i184 | 0));
  if (!i160) {
   i1 = 0;
   do {
    i154 = HEAP32[(HEAP32[i182 + (i1 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i154 >> 2] | 0) + 36 >> 2] | 0, i154 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i184 | 0));
  }
 }
 i1 = i191 + 2960 | 0;
 i2 = i191;
 do {
  _memset(i2 | 0, 0, 140) | 0;
  HEAP8[i2 + 28 >> 0] = 1;
  HEAP32[i2 + 44 >> 2] = -1;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP32[i2 + 124 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 1065353216;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 140 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = 0;
  i2 = i2 + 148 | 0;
 } while ((i2 | 0) != (i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 124 >> 2] | 0, i6 | 0, i12 | 0);
 HEAP32[i185 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i185 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i185 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i185 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i185 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i185 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i185 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 124 >> 2] | 0, i8 | 0, i12 | 0);
 f44 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) * Math_fround(2.0));
 f41 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) * Math_fround(2.0));
 f40 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f39 = Math_fround(Math_fround(f40 * f40) + Math_fround(-.5));
 f38 = Math_fround(HEAPF32[i7 >> 2]);
 f153 = Math_fround(f44 * f38);
 f42 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f153 = Math_fround(f153 + Math_fround(f41 * f42));
 f37 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f153 = Math_fround(f153 + Math_fround(f35 * f37));
 f142 = Math_fround(Math_fround(f38 * f153) + Math_fround(Math_fround(f44 * f39) + Math_fround(f40 * Math_fround(Math_fround(f35 * f42) - Math_fround(f41 * f37)))));
 f141 = Math_fround(Math_fround(f42 * f153) + Math_fround(Math_fround(f41 * f39) + Math_fround(f40 * Math_fround(Math_fround(f44 * f37) - Math_fround(f35 * f38)))));
 f153 = Math_fround(Math_fround(Math_fround(f35 * f39) + Math_fround(f40 * Math_fround(Math_fround(f41 * f38) - Math_fround(f44 * f42)))) + Math_fround(f37 * f153));
 f142 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f142);
 f141 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f141);
 f153 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f153);
 f44 = Math_fround(HEAPF32[i8 >> 2]);
 f41 = Math_fround(f40 * f44);
 f39 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f38 * f39));
 f35 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f42 * f35));
 f36 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f143 = Math_fround(Math_fround(Math_fround(f37 * f44) + Math_fround(Math_fround(f42 * f39) + Math_fround(f40 * f36))) - Math_fround(f38 * f35));
 f43 = Math_fround(Math_fround(Math_fround(f38 * f36) + Math_fround(Math_fround(f37 * f39) + Math_fround(f40 * f35))) - Math_fround(f42 * f44));
 f35 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) - Math_fround(f38 * f44)) - Math_fround(f42 * f36)) - Math_fround(f37 * f35));
 HEAPF32[i163 >> 2] = Math_fround(f41 - Math_fround(f37 * f36));
 i147 = i163 + 4 | 0;
 HEAPF32[i147 >> 2] = f143;
 i148 = i163 + 8 | 0;
 HEAPF32[i148 >> 2] = f43;
 i149 = i163 + 12 | 0;
 HEAPF32[i149 >> 2] = f35;
 i150 = i163 + 16 | 0;
 HEAPF32[i150 >> 2] = f142;
 i151 = i163 + 20 | 0;
 HEAPF32[i151 >> 2] = f141;
 i152 = i163 + 24 | 0;
 HEAPF32[i152 >> 2] = f153;
 f153 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i12 >> 2] | 0) + 136 >> 2] | 0, i12 | 0));
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 148 >> 2] | 0, i9 | 0, i12 | 0);
 HEAP32[i172 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i172 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i172 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 152 >> 2] | 0, i10 | 0, i12 | 0);
 i130 = HEAP32[i10 >> 2] | 0;
 HEAP32[i180 >> 2] = i130;
 i131 = HEAP32[i10 + 4 >> 2] | 0;
 i154 = i180 + 4 | 0;
 HEAP32[i154 >> 2] = i131;
 i133 = HEAP32[i10 + 8 >> 2] | 0;
 i145 = i180 + 8 | 0;
 HEAP32[i145 >> 2] = i133;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 160 >> 2] | 0, i11 | 0, i12 | 0);
 i136 = HEAP32[i11 >> 2] | 0;
 HEAP32[i179 >> 2] = i136;
 i137 = HEAP32[i11 + 4 >> 2] | 0;
 i146 = i179 + 4 | 0;
 HEAP32[i146 >> 2] = i137;
 i138 = HEAP32[i11 + 8 >> 2] | 0;
 i144 = i179 + 8 | 0;
 HEAP32[i144 >> 2] = i138;
 f141 = Math_fround(HEAPF32[i157 >> 2]);
 f142 = Math_fround(HEAPF32[i192 + 132 >> 2]);
 f143 = Math_fround(HEAPF32[i192 + 136 >> 2]);
 f36 = Math_fround(HEAPF32[i192 + 140 >> 2]);
 f37 = Math_fround(HEAPF32[i192 + 144 >> 2]);
 i7 = HEAP32[gb + 1458536 >> 2] | 0;
 i8 = (i7 | 0) == 0;
 f41 = (HEAP32[tempDoublePtr >> 2] = i130, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i131, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i133, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i136, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i137, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i138, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!i8) {
  HEAPF32[i7 + 12 >> 2] = f141;
  HEAPF32[i7 + 16 >> 2] = f142;
  HEAPF32[i7 + 20 >> 2] = f143;
  HEAPF32[i7 + 24 >> 2] = f36;
  HEAPF32[i7 + 28 >> 2] = f37;
 }
 i1 = (HEAP8[i192 + 192 >> 0] | 0) != 0;
 if ((HEAP32[i192 + 752 >> 2] | 0) == 1) {
  if (i1) if (!(Math_fround(f36 * f37) >= Math_fround(0.0))) {
   if (f36 == Math_fround(0.0) & f37 == Math_fround(0.0)) i155 = 39;
  } else i155 = 39;
 } else if (!(Math_fround(f143 * f36) > Math_fround(0.0)) & (i1 & !(Math_fround(f142 * f37) > Math_fround(0.0)))) i155 = 39;
 do if ((i155 | 0) == 39) {
  i1 = HEAP32[i192 + 196 >> 2] | 0;
  i3 = i192 + 212 | 0;
  f34 = Math_fround(HEAPF32[i3 >> 2]);
  if ((HEAP32[i192 + 200 >> 2] | 0) == (i1 | 0)) if (f34 > Math_fround(HEAPF32[i168 + 400 >> 2])) {
   f140 = Math_fround(HEAPF32[i158 >> 2]);
   f140 = Math_fround(f140 * Math_fround(HEAPF32[i168 + 108 >> 2]));
   i2 = i1 | 0 ? f140 > Math_fround(HEAPF32[i168 + 272 + (i1 << 2) >> 2]) : 0;
   i1 = i1 >>> 0 > 2 ? f140 < Math_fround(HEAPF32[i168 + 400 + (i1 << 2) >> 2]) : 0;
   if (!(i2 | i1)) break;
   HEAP8[i192 + 193 >> 0] = i2 & 1;
   HEAP8[i192 + 194 >> 0] = i1 & 1;
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   break;
  }
  HEAPF32[i3 >> 2] = Math_fround(f34 + f45);
 } while (0);
 i6 = i192 + 193 | 0;
 do if (!(HEAP8[i6 >> 0] | 0)) {
  i1 = i192 + 196 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i1 = (HEAP32[i168 + 244 >> 2] | 0) + -1 | 0;
  i2 = i192 + 196 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i1 = i192 + 200 | 0;
   if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) {
    if (!i3) {
     HEAPF32[i192 + 208 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
    HEAPF32[i192 + 208 >> 2] = Math_fround(0.0);
    if ((i3 | 0) == 1) {
     HEAP32[i1 >> 2] = 2;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    } else {
     HEAP32[i1 >> 2] = i3 + 1;
     HEAP32[i2 >> 2] = 1;
     i1 = 1;
     break;
    }
   } else i1 = i3;
  }
 } while (0);
 i5 = i192 + 194 | 0;
 do if (HEAP8[i5 >> 0] | 0) if (!i1) i1 = 0; else {
  i3 = i192 + 200 | 0;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   if ((i1 | 0) == 2) {
    HEAPF32[i192 + 208 >> 2] = Math_fround(0.0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
   HEAPF32[i192 + 208 >> 2] = Math_fround(0.0);
   if ((i1 | 0) == 1) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   } else {
    HEAP32[i3 >> 2] = i1 + -1;
    HEAP32[i2 >> 2] = 1;
    i1 = 1;
    break;
   }
  }
 } while (0);
 i3 = HEAP32[i192 + 200 >> 2] | 0;
 do if ((i1 | 0) != (i3 | 0)) {
  i4 = i192 + 208 | 0;
  f34 = Math_fround(HEAPF32[i4 >> 2]);
  if (f34 > Math_fround(HEAPF32[i168 + 248 >> 2])) {
   HEAP32[i2 >> 2] = i3;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i6 >> 0] = 0;
   i1 = i3;
   break;
  } else {
   HEAPF32[i4 >> 2] = Math_fround(f34 + f45);
   break;
  }
 } while (0);
 i138 = (i1 | 0) == 1;
 f139 = Math_fround(HEAPF32[i168 + 256 >> 2]);
 f139 = i138 ? Math_fround(0.0) : f139;
 f140 = Math_fround(HEAPF32[i168 + 112 + (i1 << 2) >> 2]);
 f140 = Math_fround(f140 * Math_fround(HEAPF32[i168 + 240 >> 2]));
 if (!i8) HEAPF32[i7 + 32 >> 2] = f140;
 i6 = Math_fround(f141 * Math_fround(Math_fround(Math_abs(Math_fround(f36))) + Math_fround(Math_abs(Math_fround(f37))))) > Math_fround(0.0);
 i5 = (i1 | 0) != 1;
 i7 = i5 & i6;
 i3 = i161;
 i15 = i3 + 20 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i15 | 0));
 if (!i160) {
  i4 = 0;
  do {
   i1 = i4 << 2;
   i2 = HEAP32[i192 + 52 + ((i4 >>> 3 & 134217727) << 2) >> 2] | 0;
   i3 = i1 & 28;
   if (i2 & 1 << i3 | 0) HEAP8[i161 + i1 >> 0] = 1;
   if (i2 & 1 << (i3 | 1) | 0) HEAP8[i161 + (i1 | 1) >> 0] = 1;
   if (i2 & 1 << (i3 | 2) | 0) HEAP8[i161 + (i1 | 2) >> 0] = 1;
   if (i2 & 1 << (i3 | 3) | 0) HEAP8[i161 + (i1 | 3) >> 0] = 1;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i184 | 0));
 }
 i3 = i162;
 i15 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i3 = i167;
 i15 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i3 = i177;
 i15 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 __ZN5physx15computeTankDiffEffjPKbPfS2_S2_(f36, f37, i183, i161, i162, i167, i177);
 i3 = i173;
 i15 = i3 + 20 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i15 | 0));
 if (!(i160 | i5 & i6 ^ 1)) {
  i1 = 0;
  do {
   i137 = i1 << 2;
   HEAP8[i173 + i137 >> 0] = Math_fround(HEAPF32[i162 + (i137 << 2) >> 2]) != Math_fround(0.0) & 1;
   i136 = i137 | 1;
   HEAP8[i173 + i136 >> 0] = Math_fround(HEAPF32[i162 + (i136 << 2) >> 2]) != Math_fround(0.0) & 1;
   i136 = i137 | 2;
   HEAP8[i173 + i136 >> 0] = Math_fround(HEAPF32[i162 + (i136 << 2) >> 2]) != Math_fround(0.0) & 1;
   i137 = i137 | 3;
   HEAP8[i173 + i137 >> 0] = Math_fround(HEAPF32[i162 + (i137 << 2) >> 2]) != Math_fround(0.0) & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i184 | 0));
 }
 i1 = HEAP32[gb + 1458536 >> 2] | 0;
 if (i1 | 0) {
  f135 = Math_fround(HEAPF32[i158 >> 2]);
  f132 = Math_fround(HEAPF32[i182 >> 2]);
  f132 = Math_fround(Math_fround(f132 * Math_fround(HEAPF32[i162 >> 2])) + Math_fround(0.0));
  f134 = Math_fround(HEAPF32[i182 + 4 >> 2]);
  f134 = Math_fround(f132 + Math_fround(f134 * Math_fround(HEAPF32[i162 + 4 >> 2])));
  f132 = Math_fround(HEAPF32[i182 + 8 >> 2]);
  f132 = Math_fround(f134 + Math_fround(f132 * Math_fround(HEAPF32[i162 + 8 >> 2])));
  f134 = Math_fround(HEAPF32[i182 + 12 >> 2]);
  HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f140 * Math_fround(f132 + Math_fround(f134 * Math_fround(HEAPF32[i162 + 12 >> 2])))) - f135);
 }
 i3 = i175;
 i15 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 if (i160) {
  i136 = i179;
  i137 = i180;
  f34 = f43;
 } else {
  i3 = 0;
  do {
   i1 = i3 << 2;
   i2 = i191 + (i1 * 148 | 0) | 0;
   if (!(HEAP32[i182 + (i3 * 224 | 0) + 212 >> 2] | 0)) {
    i133 = i191 + ((i1 | 1) * 148 | 0) | 0;
    i136 = i191 + ((i1 | 2) * 148 | 0) | 0;
    i137 = i191 + ((i1 | 3) * 148 | 0) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i133 >> 2] = 0;
    HEAP32[i133 + 4 >> 2] = 0;
    HEAP32[i133 + 8 >> 2] = 0;
    HEAP32[i133 + 12 >> 2] = 0;
    HEAP32[i133 + 16 >> 2] = 0;
    HEAP32[i133 + 20 >> 2] = 0;
    HEAP32[i133 + 24 >> 2] = 0;
    HEAP32[i136 >> 2] = 0;
    HEAP32[i136 + 4 >> 2] = 0;
    HEAP32[i136 + 8 >> 2] = 0;
    HEAP32[i136 + 12 >> 2] = 0;
    HEAP32[i136 + 16 >> 2] = 0;
    HEAP32[i136 + 20 >> 2] = 0;
    HEAP32[i136 + 24 >> 2] = 0;
    HEAP32[i137 >> 2] = 0;
    HEAP32[i137 + 4 >> 2] = 0;
    HEAP32[i137 + 8 >> 2] = 0;
    HEAP32[i137 + 12 >> 2] = 0;
    HEAP32[i137 + 16 >> 2] = 0;
    HEAP32[i137 + 20 >> 2] = 0;
    HEAP32[i137 + 24 >> 2] = 0;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 96 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 4 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 100 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 8 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 104 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 12 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 144 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 16 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 148 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 20 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 152 >> 2];
    HEAP32[i191 + (i1 * 148 | 0) + 24 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 192 >> 2];
    i137 = i1 | 1;
    HEAP32[i191 + (i137 * 148 | 0) >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 108 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 4 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 112 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 8 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 116 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 12 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 156 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 16 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 160 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 20 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 164 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 24 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 196 >> 2];
    i137 = i1 | 2;
    HEAP32[i191 + (i137 * 148 | 0) >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 120 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 4 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 124 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 8 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 128 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 12 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 168 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 16 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 172 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 20 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 176 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 24 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 200 >> 2];
    i137 = i1 | 3;
    HEAP32[i191 + (i137 * 148 | 0) >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 132 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 4 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 136 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 8 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 140 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 12 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 180 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 16 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 184 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 20 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 188 >> 2];
    HEAP32[i191 + (i137 * 148 | 0) + 24 >> 2] = HEAP32[i182 + (i3 * 224 | 0) + 204 >> 2];
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i184 | 0));
  f41 = Math_fround(HEAPF32[i180 >> 2]);
  f42 = Math_fround(HEAPF32[i154 >> 2]);
  f44 = Math_fround(HEAPF32[i145 >> 2]);
  f38 = Math_fround(HEAPF32[i179 >> 2]);
  f39 = Math_fround(HEAPF32[i146 >> 2]);
  f40 = Math_fround(HEAPF32[i144 >> 2]);
  f35 = Math_fround(HEAPF32[i149 >> 2]);
  i136 = i179;
  i137 = i180;
  f34 = Math_fround(HEAPF32[i148 >> 2]);
 }
 f132 = Math_fround(Math_fround(HEAPF32[gb + 158860 >> 2]) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 4 >> 2]) * Math_fround(2.0));
 f43 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 8 >> 2]) * Math_fround(2.0));
 f135 = Math_fround(Math_fround(f35 * f35) + Math_fround(-.5));
 f134 = Math_fround(HEAPF32[i163 >> 2]);
 f36 = Math_fround(f132 * f134);
 f195 = Math_fround(HEAPF32[i147 >> 2]);
 f36 = Math_fround(Math_fround(f36 + Math_fround(f37 * f195)) + Math_fround(f43 * f34));
 f134 = Math_fround(Math_abs(Math_fround(Math_fround(f44 * Math_fround(Math_fround(Math_fround(f43 * f135) + Math_fround(f35 * Math_fround(Math_fround(f37 * f134) - Math_fround(f132 * f195)))) + Math_fround(f34 * f36))) + Math_fround(Math_fround(f41 * Math_fround(Math_fround(f134 * f36) + Math_fround(Math_fround(f132 * f135) + Math_fround(f35 * Math_fround(Math_fround(f43 * f195) - Math_fround(f37 * f34)))))) + Math_fround(f42 * Math_fround(Math_fround(f195 * f36) + Math_fround(Math_fround(f37 * f135) + Math_fround(f35 * Math_fround(Math_fround(f132 * f34) - Math_fround(f43 * f134))))))))));
 f43 = Math_fround(HEAPF32[i192 + 56 >> 2]);
 i133 = f134 < f43 ? HEAP32[i192 + 60 >> 2] | 0 : HEAP32[i192 + 64 >> 2] | 0;
 f43 = Math_fround(Math_fround(1.0) / Math_fround(i133 >>> 0));
 f134 = Math_fround(f43 * f45);
 f132 = Math_fround(Math_fround(1.0) / f134);
 f135 = Math_fround(Math_fround(1.0) / f45);
 i131 = HEAP32[i192 + 68 >> 2] | 0;
 HEAPF32[i166 >> 2] = f43;
 HEAPF32[i166 + 4 >> 2] = f134;
 HEAPF32[i166 + 8 >> 2] = f132;
 HEAP32[i166 + 12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i166 + 16 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i166 + 20 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAPF32[i166 + 24 >> 2] = f46;
 HEAPF32[i166 + 28 >> 2] = f47;
 HEAP8[i166 + 32 >> 0] = 1;
 HEAP32[i166 + 36 >> 2] = i131;
 HEAP32[i166 + 40 >> 2] = i12;
 HEAP32[i166 + 44 >> 2] = i13;
 L133 : do if (i133 | 0) {
  i104 = i164 + 4 | 0;
  i105 = i164 + 8 | 0;
  i106 = i165 + 4 | 0;
  i107 = i165 + 8 | 0;
  i108 = i168 + 84 | 0;
  i109 = i168 + 108 | 0;
  i110 = i168 + 4 | 0;
  i111 = i168 + 92 | 0;
  i112 = i168 + 96 | 0;
  i113 = i168 + 100 | 0;
  i114 = i169 + 4 | 0;
  i115 = i169 + 8 | 0;
  i116 = i169 + 12 | 0;
  i117 = i169 + 16 | 0;
  i118 = i169 + 20 | 0;
  i119 = i169 + 24 | 0;
  i120 = i169 + 28 | 0;
  i121 = i169 + 32 | 0;
  i122 = i169 + 36 | 0;
  i123 = i169 + 40 | 0;
  i124 = i169 + 44 | 0;
  i125 = i169 + 48 | 0;
  i126 = i169 + 52 | 0;
  i127 = i169 + 56 | 0;
  i128 = i169 + 60 | 0;
  i129 = i169 + 64 | 0;
  i130 = i169 + 68 | 0;
  i131 = i170 + 4 | 0;
  f132 = Math_fround(f139 * f140);
  i21 = i7 & 1;
  i22 = i171 + 4 | 0;
  i23 = i171 + 8 | 0;
  i24 = i171 + 12 | 0;
  i25 = i171 + 16 | 0;
  i26 = i171 + 20 | 0;
  i27 = i171 + 24 | 0;
  i28 = i171 + 28 | 0;
  i29 = i171 + 32 | 0;
  i30 = i171 + 36 | 0;
  i31 = i171 + 40 | 0;
  i32 = i171 + 44 | 0;
  i33 = i171 + 48 | 0;
  i48 = i171 + 52 | 0;
  i49 = i171 + 56 | 0;
  i50 = i171 + 60 | 0;
  i51 = i171 + 64 | 0;
  i52 = i171 + 68 | 0;
  i53 = i171 + 72 | 0;
  i54 = i171 + 76 | 0;
  i55 = i171 + 80 | 0;
  i56 = i171 + 84 | 0;
  i57 = i171 + 88 | 0;
  i58 = i133 + -1 | 0;
  f46 = Math_fround(-f142);
  f47 = Math_fround(-f143);
  i59 = i187 + 112 | 0;
  i60 = i187 + 164 | 0;
  i61 = i187 + 113 | 0;
  i62 = i187 + 168 | 0;
  i63 = i187 + 114 | 0;
  i64 = i187 + 172 | 0;
  i65 = i187 + 115 | 0;
  i66 = i187 + 176 | 0;
  i67 = i187 + 1128 | 0;
  i68 = i187 + 1240 | 0;
  i69 = i187 + 1292 | 0;
  i70 = i187 + 1241 | 0;
  i71 = i187 + 1296 | 0;
  i72 = i187 + 1242 | 0;
  i73 = i187 + 1300 | 0;
  i74 = i187 + 1243 | 0;
  i75 = i187 + 1304 | 0;
  i76 = i187 + 2256 | 0;
  i77 = i187 + 2368 | 0;
  i78 = i187 + 2420 | 0;
  i79 = i187 + 2369 | 0;
  i80 = i187 + 2424 | 0;
  i81 = i187 + 2370 | 0;
  i82 = i187 + 2428 | 0;
  i83 = i187 + 2371 | 0;
  i84 = i187 + 2432 | 0;
  i85 = i187 + 3384 | 0;
  i86 = i187 + 3496 | 0;
  i87 = i187 + 3548 | 0;
  i88 = i187 + 3497 | 0;
  i89 = i187 + 3552 | 0;
  i90 = i187 + 3498 | 0;
  i91 = i187 + 3556 | 0;
  i92 = i187 + 3499 | 0;
  i93 = i187 + 3560 | 0;
  i94 = i187 + 4512 | 0;
  i95 = i187 + 4624 | 0;
  i96 = i187 + 4676 | 0;
  i97 = i187 + 4625 | 0;
  i98 = i187 + 4680 | 0;
  i99 = i187 + 4626 | 0;
  i100 = i187 + 4684 | 0;
  i101 = i187 + 4627 | 0;
  i102 = i187 + 4688 | 0;
  i103 = 0;
  while (1) {
   HEAPF32[i164 >> 2] = Math_fround(0.0);
   HEAPF32[i104 >> 2] = Math_fround(0.0);
   HEAPF32[i105 >> 2] = Math_fround(0.0);
   HEAPF32[i165 >> 2] = Math_fround(0.0);
   HEAPF32[i106 >> 2] = Math_fround(0.0);
   HEAPF32[i107 >> 2] = Math_fround(0.0);
   i3 = i178;
   i15 = i3 + 80 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i15 | 0));
   i3 = i174;
   i15 = i3 + 20 | 0;
   do {
    HEAP8[i3 >> 0] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i15 | 0));
   if (!i160) {
    i1 = 0;
    do {
     i20 = i1 << 2;
     f195 = Math_fround(HEAPF32[i182 + (i1 * 224 | 0) >> 2]);
     i19 = f195 <= Math_fround(-0.0);
     f45 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f195 >= Math_fround(0.0);
     f45 = Math_fround((i19 ? f45 : Math_fround(-1.0)) * f46);
     f195 = Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + 212 >> 2]);
     HEAPF32[i178 + (i20 << 2) >> 2] = Math_fround(f195 * f45);
     HEAP8[i174 + i20 >> 0] = Math_fround(f142 * f195) != Math_fround(0.0) & 1;
     f195 = Math_fround(HEAPF32[i182 + (i1 * 224 | 0) + 4 >> 2]);
     i19 = f195 <= Math_fround(-0.0);
     f45 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f195 >= Math_fround(0.0);
     f45 = Math_fround((i19 ? f45 : Math_fround(-1.0)) * f47);
     f195 = Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + 260 >> 2]);
     i19 = i20 | 1;
     HEAPF32[i178 + (i19 << 2) >> 2] = Math_fround(f195 * f45);
     HEAP8[i174 + i19 >> 0] = Math_fround(f143 * f195) != Math_fround(0.0) & 1;
     f195 = Math_fround(HEAPF32[i182 + (i1 * 224 | 0) + 8 >> 2]);
     i19 = f195 <= Math_fround(-0.0);
     f45 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f195 >= Math_fround(0.0);
     f45 = Math_fround((i19 ? f45 : Math_fround(-1.0)) * f46);
     f195 = Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + 308 >> 2]);
     i19 = i20 | 2;
     HEAPF32[i178 + (i19 << 2) >> 2] = Math_fround(f195 * f45);
     HEAP8[i174 + i19 >> 0] = Math_fround(f142 * f195) != Math_fround(0.0) & 1;
     f195 = Math_fround(HEAPF32[i182 + (i1 * 224 | 0) + 12 >> 2]);
     i19 = f195 <= Math_fround(-0.0);
     f45 = i19 ? Math_fround(0.0) : Math_fround(1.0);
     i19 = f195 >= Math_fround(0.0);
     f45 = Math_fround((i19 ? f45 : Math_fround(-1.0)) * f47);
     f195 = Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + 356 >> 2]);
     i20 = i20 | 3;
     HEAPF32[i178 + (i20 << 2) >> 2] = Math_fround(f195 * f45);
     HEAP8[i174 + i20 >> 0] = Math_fround(f143 * f195) != Math_fround(0.0) & 1;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i184 | 0));
   }
   _memset(i187 | 0, 0, 1128) | 0;
   HEAP8[i59 >> 0] = 1;
   HEAP32[i60 >> 2] = -1;
   HEAP8[i61 >> 0] = 1;
   HEAP32[i62 >> 2] = -1;
   HEAP8[i63 >> 0] = 1;
   HEAP32[i64 >> 2] = -1;
   HEAP8[i65 >> 0] = 1;
   HEAP32[i66 >> 2] = -1;
   _memset(i67 | 0, 0, 1128) | 0;
   HEAP8[i68 >> 0] = 1;
   HEAP32[i69 >> 2] = -1;
   HEAP8[i70 >> 0] = 1;
   HEAP32[i71 >> 2] = -1;
   HEAP8[i72 >> 0] = 1;
   HEAP32[i73 >> 2] = -1;
   HEAP8[i74 >> 0] = 1;
   HEAP32[i75 >> 2] = -1;
   _memset(i76 | 0, 0, 1128) | 0;
   HEAP8[i77 >> 0] = 1;
   HEAP32[i78 >> 2] = -1;
   HEAP8[i79 >> 0] = 1;
   HEAP32[i80 >> 2] = -1;
   HEAP8[i81 >> 0] = 1;
   HEAP32[i82 >> 2] = -1;
   HEAP8[i83 >> 0] = 1;
   HEAP32[i84 >> 2] = -1;
   _memset(i85 | 0, 0, 1128) | 0;
   HEAP8[i86 >> 0] = 1;
   HEAP32[i87 >> 2] = -1;
   HEAP8[i88 >> 0] = 1;
   HEAP32[i89 >> 2] = -1;
   HEAP8[i90 >> 0] = 1;
   HEAP32[i91 >> 2] = -1;
   HEAP8[i92 >> 0] = 1;
   HEAP32[i93 >> 2] = -1;
   _memset(i94 | 0, 0, 1128) | 0;
   HEAP8[i95 >> 0] = 1;
   HEAP32[i96 >> 2] = -1;
   HEAP8[i97 >> 0] = 1;
   HEAP32[i98 >> 2] = -1;
   HEAP8[i99 >> 0] = 1;
   HEAP32[i100 >> 2] = -1;
   HEAP8[i101 >> 0] = 1;
   HEAP32[i102 >> 2] = -1;
   do if (!i160) {
    i3 = HEAP32[i163 >> 2] | 0;
    i4 = HEAP32[i147 >> 2] | 0;
    i5 = HEAP32[i148 >> 2] | 0;
    i6 = HEAP32[i149 >> 2] | 0;
    i7 = HEAP32[i150 >> 2] | 0;
    i8 = HEAP32[i151 >> 2] | 0;
    i9 = HEAP32[i152 >> 2] | 0;
    i10 = HEAP32[i180 >> 2] | 0;
    i11 = HEAP32[i154 >> 2] | 0;
    i12 = HEAP32[i145 >> 2] | 0;
    i13 = HEAP32[i179 >> 2] | 0;
    i14 = HEAP32[i146 >> 2] | 0;
    i15 = HEAP32[i144 >> 2] | 0;
    i16 = (i58 | 0) == (i103 | 0);
    i17 = (i103 | 0) == 0;
    f45 = Math_fround(0.0);
    f43 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    i20 = 0;
    do {
     HEAP8[i171 >> 0] = i21;
     i18 = i20 << 2;
     HEAP32[i22 >> 2] = i173 + i18;
     HEAP32[i23 >> 2] = i174 + i18;
     HEAP32[i24 >> 2] = i175 + (i18 << 2);
     HEAP32[i25 >> 2] = i161 + i18;
     HEAP32[i26 >> 2] = i3;
     HEAP32[i27 >> 2] = i4;
     HEAP32[i28 >> 2] = i5;
     HEAP32[i29 >> 2] = i6;
     HEAP32[i30 >> 2] = i7;
     HEAP32[i31 >> 2] = i8;
     HEAP32[i32 >> 2] = i9;
     HEAP32[i33 >> 2] = i10;
     HEAP32[i48 >> 2] = i11;
     HEAP32[i49 >> 2] = i12;
     HEAP32[i50 >> 2] = i13;
     HEAP32[i51 >> 2] = i14;
     HEAP32[i52 >> 2] = i15;
     HEAP32[i53 >> 2] = i181 + (i20 * 944 | 0);
     i1 = i182 + (i20 * 224 | 0) | 0;
     HEAP32[i54 >> 2] = i1;
     HEAP32[i55 >> 2] = i176 + (i20 * 20 | 0);
     HEAP32[i56 >> 2] = i159;
     i19 = HEAP32[i186 + (i20 << 2) >> 2] | 0;
     HEAP32[i57 >> 2] = i19;
     i2 = i187 + (i20 * 1128 | 0) | 0;
     __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(i18, i166, i171, i2);
     i196 = HEAP32[i54 >> 2] | 0;
     i197 = i196 + 48 | 0;
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 508 >> 2]);
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 512 >> 2]);
     i197 = i196 + 52 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 516 >> 2]);
     i197 = i196 + 56 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 520 >> 2]);
     i197 = i196 + 60 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     i197 = i196 + 64 | 0;
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 524 >> 2]);
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 528 >> 2]);
     i197 = i196 + 68 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 532 >> 2]);
     i197 = i196 + 72 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 536 >> 2]);
     i197 = i196 + 76 | 0;
     i198 = f195 != Math_fround(HEAPF32[i197 >> 2]);
     HEAPF32[i197 >> 2] = i198 ? f195 : Math_fround(0.0);
     i197 = i187 + (i20 * 1128 | 0) + 292 | 0;
     i196 = i196 + 80 | 0;
     HEAP32[i196 >> 2] = HEAP32[i197 >> 2];
     HEAP32[i196 + 4 >> 2] = HEAP32[i197 + 4 >> 2];
     HEAP32[i196 + 8 >> 2] = HEAP32[i197 + 8 >> 2];
     HEAP32[i196 + 12 >> 2] = HEAP32[i197 + 12 >> 2];
     if (i16) __ZN5physx19updateCachedHitDataEPKjPKNS_6PxVec4EPKfS6_PNS_23PxVehicleWheels4DynDataE(i187 + (i20 * 1128 | 0) + 904 | 0, i187 + (i20 * 1128 | 0) + 920 | 0, i187 + (i20 * 1128 | 0) + 984 | 0, i187 + (i20 * 1128 | 0) + 1e3 | 0, i1);
     f45 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 484 >> 2]) + f45);
     f43 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 488 >> 2]) + f43);
     f37 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 492 >> 2]) + f37);
     f36 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 496 >> 2]) + f36);
     f35 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 500 >> 2]) + f35);
     f34 = Math_fround(Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 504 >> 2]) + f34);
     if (i17) __ZN5physx25PxVehicleConstraintShader21VehicleConstraintDataaSERKS1_((HEAP32[i182 + (i20 * 224 | 0) + 208 >> 2] | 0) + 4 | 0, i187 + (i20 * 1128 | 0) + 540 | 0) | 0;
     __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i2, HEAP32[i24 >> 2] | 0, i191 + (i18 * 148 | 0) | 0, i19);
     i1 = HEAP32[i190 >> 2] | 0;
     if (i19 | 0) {
      i2 = 0;
      do {
       i198 = i2 + i18 | 0;
       HEAP32[i1 + (i198 * 56 | 0) + 28 >> 2] = HEAP32[i187 + (i20 * 1128 | 0) + 1016 + (i2 << 2) >> 2];
       f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) >> 2]);
       i197 = i1 + (i198 * 56 | 0) + 32 | 0;
       HEAPF32[i197 >> 2] = Math_fround(f195 + Math_fround(HEAPF32[i197 >> 2]));
       f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) + 4 >> 2]);
       i197 = i1 + (i198 * 56 | 0) + 36 | 0;
       HEAPF32[i197 >> 2] = Math_fround(f195 + Math_fround(HEAPF32[i197 >> 2]));
       f195 = Math_fround(HEAPF32[i187 + (i20 * 1128 | 0) + 1032 + (i2 * 12 | 0) + 8 >> 2]);
       i197 = i1 + (i198 * 56 | 0) + 40 | 0;
       HEAPF32[i197 >> 2] = Math_fround(f195 + Math_fround(HEAPF32[i197 >> 2]));
       HEAP32[i1 + (i198 * 56 | 0) + 44 >> 2] = HEAP32[i187 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) >> 2];
       HEAP32[i1 + (i198 * 56 | 0) + 48 >> 2] = HEAP32[i187 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) + 4 >> 2];
       HEAP32[i1 + (i198 * 56 | 0) + 52 >> 2] = HEAP32[i187 + (i20 * 1128 | 0) + 1080 + (i2 * 12 | 0) + 8 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i19 | 0));
     }
     i20 = i20 + 1 | 0;
    } while ((i20 | 0) != (i184 | 0));
    HEAPF32[i164 >> 2] = f45;
    HEAPF32[i104 >> 2] = f43;
    HEAPF32[i105 >> 2] = f37;
    HEAPF32[i165 >> 2] = f36;
    HEAPF32[i106 >> 2] = f35;
    HEAPF32[i107 >> 2] = f34;
    if (i160) break; else i1 = 0;
    do {
     i198 = i1 << 2;
     HEAP32[i171 + (i198 << 2) >> 2] = HEAP32[i187 + (i1 * 1128 | 0) + 468 >> 2];
     HEAP32[i171 + ((i198 | 1) << 2) >> 2] = HEAP32[i187 + (i1 * 1128 | 0) + 472 >> 2];
     HEAP32[i171 + ((i198 | 2) << 2) >> 2] = HEAP32[i187 + (i1 * 1128 | 0) + 476 >> 2];
     HEAP32[i171 + ((i198 | 3) << 2) >> 2] = HEAP32[i187 + (i1 * 1128 | 0) + 480 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i184 | 0));
   } while (0);
   f43 = Math_fround(HEAPF32[i158 >> 2]);
   f45 = Math_fround(f141 * Math_fround(HEAPF32[i108 >> 2]));
   f43 = Math_fround(f43 * Math_fround(HEAPF32[i109 >> 2]));
   i2 = HEAP32[i156 >> 2] | 0;
   L160 : do switch (i2 | 0) {
   case 0:
    {
     f34 = Math_fround(0.0);
     break;
    }
   case 1:
    {
     i155 = 106;
     break;
    }
   default:
    {
     f34 = Math_fround(HEAPF32[i168 >> 2]);
     if (f34 > f43) {
      i155 = 106;
      break L160;
     }
     i1 = 1;
     f37 = Math_fround(HEAPF32[i110 >> 2]);
     while (1) {
      i198 = i1 << 1;
      f36 = f34;
      f34 = Math_fround(HEAPF32[i168 + (i198 << 2) >> 2]);
      f35 = f37;
      f37 = Math_fround(HEAPF32[i168 + ((i198 | 1) << 2) >> 2]);
      i1 = i1 + 1 | 0;
      if (f36 <= f43 & f34 > f43) {
       i155 = 110;
       break;
      }
      if (i1 >>> 0 >= i2 >>> 0) {
       i155 = 111;
       break;
      }
     }
     if ((i155 | 0) == 110) {
      i155 = 0;
      f34 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f43 - f36) * Math_fround(f37 - f35)) / Math_fround(f34 - f36)));
      break L160;
     } else if ((i155 | 0) == 111) {
      i155 = 0;
      f34 = Math_fround(HEAPF32[i168 + (((i2 << 1) + -2 | 1) << 2) >> 2]);
      break L160;
     }
    }
   } while (0);
   if ((i155 | 0) == 106) {
    i155 = 0;
    f34 = Math_fround(HEAPF32[i110 >> 2]);
   }
   f37 = Math_fround(f45 * f34);
   i1 = HEAP32[gb + 1458536 >> 2] | 0;
   if (i1 | 0) HEAPF32[i1 + 4 >> 2] = f37;
   f45 = Math_fround(HEAPF32[i111 >> 2]);
   f43 = Math_fround(HEAPF32[i113 >> 2]);
   f195 = Math_fround(HEAPF32[i112 >> 2]);
   f195 = i138 ? f43 : f195;
   f195 = Math_fround(f195 + Math_fround(f141 * Math_fround(f45 - f195)));
   HEAPF32[i169 >> 2] = f134;
   HEAPF32[i114 >> 2] = Math_fround(0.0);
   HEAPF32[i115 >> 2] = Math_fround(0.0);
   HEAPF32[i116 >> 2] = f139;
   HEAPF32[i117 >> 2] = f140;
   HEAP32[i118 >> 2] = 1;
   HEAP32[i119 >> 2] = 0;
   HEAPF32[i120 >> 2] = f37;
   HEAPF32[i121 >> 2] = f195;
   HEAP32[i122 >> 2] = i167;
   HEAP32[i123 >> 2] = i162;
   HEAP32[i124 >> 2] = i178;
   HEAP32[i125 >> 2] = i174;
   HEAP32[i126 >> 2] = i171;
   HEAP32[i127 >> 2] = i184;
   HEAP32[i128 >> 2] = i183;
   HEAP32[i129 >> 2] = i181;
   HEAP32[i130 >> 2] = i168;
   HEAP32[i170 >> 2] = i182;
   HEAP32[i131 >> 2] = i157;
   __ZN5physx46solveTankInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPKbPKfPNS_20ImplicitSolverOutputE(i169, i161, i177, i170);
   if (!i160) {
    i1 = 0;
    do {
     i2 = 0;
     do {
      f34 = Math_fround(HEAPF32[i182 + (i1 * 224 | 0) + (i2 << 2) >> 2]);
      f195 = Math_fround(HEAPF32[i187 + (i1 * 1128 | 0) + 292 + (i2 << 2) >> 2]);
      do if (f195 > Math_fround(-Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + (i2 * 48 | 0) + 12 >> 2]))) {
       if (HEAP8[i174 + i2 >> 0] | 0) break;
       if (!(Math_fround(f37 * Math_fround(f132 * Math_fround(HEAPF32[i167 + (i2 << 2) >> 2]))) == Math_fround(0.0))) break;
       f35 = Math_fround(HEAPF32[i187 + (i1 * 1128 | 0) + 452 + (i2 << 2) >> 2]);
       f36 = Math_fround(Math_abs(Math_fround(f35)));
       if (!(f36 < Math_fround(HEAPF32[gb + 1458420 >> 2]))) break;
       f45 = Math_fround(HEAPF32[i181 + (i1 * 944 | 0) + 192 + (i2 * 48 | 0) + 36 >> 2]);
       f195 = Math_fround(f36 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
       f34 = Math_fround(Math_fround(f34 * f195) + Math_fround(Math_fround(f35 * f45) * Math_fround(Math_fround(1.0) - f195)));
      } while (0);
      i198 = i182 + (i1 * 224 | 0) + 32 + (i2 << 2) | 0;
      f195 = Math_fround(Math_fround(HEAPF32[i198 >> 2]) + Math_fround(f134 * f34));
      f43 = Math_fround(f195 + Math_fround(-31.4159279));
      f45 = Math_fround(f195 + Math_fround(31.4159279));
      i197 = Math_fround(Math_fround(-31.4159279) - f195) >= Math_fround(0.0);
      i196 = f43 >= Math_fround(0.0);
      HEAPF32[i198 >> 2] = i196 ? f43 : i197 ? f45 : f195;
      HEAPF32[i182 + (i1 * 224 | 0) + 16 + (i2 << 2) >> 2] = f34;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 4);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i184 | 0));
   }
   __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE(f153, i172, i164, i165, f134, i180, i179, i163);
   i103 = i103 + 1 | 0;
   if ((i103 | 0) == (i133 | 0)) break L133;
  }
 } while (0);
 i33 = i190 + 8 | 0;
 if (!(HEAP8[gb + 1552705 >> 0] | 0)) {
  HEAP32[i33 >> 2] = HEAP32[i180 >> 2];
  HEAP32[i190 + 12 >> 2] = HEAP32[i154 >> 2];
  HEAP32[i190 + 16 >> 2] = HEAP32[i145 >> 2];
  HEAP32[i190 + 20 >> 2] = HEAP32[i179 >> 2];
  HEAP32[i190 + 24 >> 2] = HEAP32[i146 >> 2];
  HEAP32[i190 + 28 >> 2] = HEAP32[i144 >> 2];
 } else {
  f195 = Math_fround(Math_fround(HEAPF32[i137 >> 2]) - f41);
  f153 = Math_fround(Math_fround(HEAPF32[i154 >> 2]) - f42);
  f153 = Math_fround(f135 * f153);
  f143 = Math_fround(f135 * Math_fround(Math_fround(HEAPF32[i145 >> 2]) - f44));
  HEAPF32[i33 >> 2] = Math_fround(f135 * f195);
  HEAPF32[i190 + 12 >> 2] = f153;
  HEAPF32[i190 + 16 >> 2] = f143;
  f143 = Math_fround(Math_fround(HEAPF32[i136 >> 2]) - f38);
  f153 = Math_fround(Math_fround(HEAPF32[i146 >> 2]) - f39);
  f153 = Math_fround(f135 * f153);
  f195 = Math_fround(f135 * Math_fround(Math_fround(HEAPF32[i144 >> 2]) - f40));
  HEAPF32[i190 + 20 >> 2] = Math_fround(f135 * f143);
  HEAPF32[i190 + 24 >> 2] = f153;
  HEAPF32[i190 + 28 >> 2] = f195;
 }
 HEAPF32[i178 >> 2] = Math_fround(0.0);
 i155 = i178 + 4 | 0;
 HEAPF32[i155 >> 2] = Math_fround(0.0);
 i156 = i178 + 8 | 0;
 HEAPF32[i156 >> 2] = Math_fround(0.0);
 i157 = i178 + 12 | 0;
 HEAPF32[i157 >> 2] = Math_fround(1.0);
 i196 = i178 + 16 | 0;
 i159 = i178 + 20 | 0;
 i160 = i178 + 24 | 0;
 i161 = i178 + 28 | 0;
 i162 = i178 + 32 | 0;
 i163 = i178 + 36 | 0;
 i164 = i178 + 40 | 0;
 HEAP32[i196 >> 2] = 0;
 HEAP32[i196 + 4 >> 2] = 0;
 HEAP32[i196 + 8 >> 2] = 0;
 HEAP32[i196 + 12 >> 2] = 0;
 HEAP32[i196 + 16 >> 2] = 0;
 HEAP32[i196 + 20 >> 2] = 0;
 HEAPF32[i164 >> 2] = Math_fround(1.0);
 i196 = i178 + 44 | 0;
 i166 = i178 + 48 | 0;
 i167 = i178 + 52 | 0;
 i168 = i178 + 56 | 0;
 i169 = i178 + 60 | 0;
 i170 = i178 + 64 | 0;
 i171 = i178 + 68 | 0;
 HEAP32[i196 >> 2] = 0;
 HEAP32[i196 + 4 >> 2] = 0;
 HEAP32[i196 + 8 >> 2] = 0;
 HEAP32[i196 + 12 >> 2] = 0;
 HEAP32[i196 + 16 >> 2] = 0;
 HEAP32[i196 + 20 >> 2] = 0;
 HEAPF32[i171 >> 2] = Math_fround(1.0);
 i196 = i178 + 72 | 0;
 i173 = i178 + 76 | 0;
 i174 = i178 + 80 | 0;
 i175 = i178 + 84 | 0;
 i176 = i178 + 88 | 0;
 i177 = i178 + 92 | 0;
 i179 = i178 + 96 | 0;
 HEAP32[i196 >> 2] = 0;
 HEAP32[i196 + 4 >> 2] = 0;
 HEAP32[i196 + 8 >> 2] = 0;
 HEAP32[i196 + 12 >> 2] = 0;
 HEAP32[i196 + 16 >> 2] = 0;
 HEAP32[i196 + 20 >> 2] = 0;
 HEAPF32[i179 >> 2] = Math_fround(1.0);
 HEAPF32[i178 + 100 >> 2] = Math_fround(0.0);
 i196 = i178 + 104 | 0;
 HEAPF32[i196 >> 2] = Math_fround(0.0);
 i197 = i178 + 108 | 0;
 HEAPF32[i197 >> 2] = Math_fround(0.0);
 __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i181, i182, i191, HEAP32[i186 >> 2] | 0, i185, i178);
 HEAP32[i191 + 120 >> 2] = HEAP32[i178 >> 2];
 HEAP32[i191 + 124 >> 2] = HEAP32[i155 >> 2];
 HEAP32[i191 + 128 >> 2] = HEAP32[i156 >> 2];
 HEAP32[i191 + 132 >> 2] = HEAP32[i157 >> 2];
 i158 = i178 + 16 | 0;
 HEAP32[i191 + 136 >> 2] = HEAP32[i158 >> 2];
 HEAP32[i191 + 140 >> 2] = HEAP32[i159 >> 2];
 HEAP32[i191 + 144 >> 2] = HEAP32[i160 >> 2];
 HEAP32[i191 + 268 >> 2] = HEAP32[i161 >> 2];
 HEAP32[i191 + 272 >> 2] = HEAP32[i162 >> 2];
 HEAP32[i191 + 276 >> 2] = HEAP32[i163 >> 2];
 HEAP32[i191 + 280 >> 2] = HEAP32[i164 >> 2];
 i165 = i178 + 44 | 0;
 HEAP32[i191 + 284 >> 2] = HEAP32[i165 >> 2];
 HEAP32[i191 + 288 >> 2] = HEAP32[i166 >> 2];
 HEAP32[i191 + 292 >> 2] = HEAP32[i167 >> 2];
 HEAP32[i191 + 416 >> 2] = HEAP32[i168 >> 2];
 HEAP32[i191 + 420 >> 2] = HEAP32[i169 >> 2];
 HEAP32[i191 + 424 >> 2] = HEAP32[i170 >> 2];
 HEAP32[i191 + 428 >> 2] = HEAP32[i171 >> 2];
 i172 = i178 + 72 | 0;
 HEAP32[i191 + 432 >> 2] = HEAP32[i172 >> 2];
 HEAP32[i191 + 436 >> 2] = HEAP32[i173 >> 2];
 HEAP32[i191 + 440 >> 2] = HEAP32[i174 >> 2];
 HEAP32[i191 + 564 >> 2] = HEAP32[i175 >> 2];
 HEAP32[i191 + 568 >> 2] = HEAP32[i176 >> 2];
 HEAP32[i191 + 572 >> 2] = HEAP32[i177 >> 2];
 HEAP32[i191 + 576 >> 2] = HEAP32[i179 >> 2];
 i180 = i178 + 100 | 0;
 HEAP32[i191 + 580 >> 2] = HEAP32[i180 >> 2];
 HEAP32[i191 + 584 >> 2] = HEAP32[i196 >> 2];
 HEAP32[i191 + 588 >> 2] = HEAP32[i197 >> 2];
 i198 = HEAP32[i190 >> 2] | 0;
 HEAP32[i198 >> 2] = HEAP32[i178 >> 2];
 HEAP32[i198 + 4 >> 2] = HEAP32[i155 >> 2];
 HEAP32[i198 + 8 >> 2] = HEAP32[i156 >> 2];
 HEAP32[i198 + 12 >> 2] = HEAP32[i157 >> 2];
 HEAP32[i198 + 16 >> 2] = HEAP32[i158 >> 2];
 HEAP32[i198 + 20 >> 2] = HEAP32[i159 >> 2];
 HEAP32[i198 + 24 >> 2] = HEAP32[i160 >> 2];
 HEAP32[i198 + 56 >> 2] = HEAP32[i161 >> 2];
 HEAP32[i198 + 60 >> 2] = HEAP32[i162 >> 2];
 HEAP32[i198 + 64 >> 2] = HEAP32[i163 >> 2];
 HEAP32[i198 + 68 >> 2] = HEAP32[i164 >> 2];
 HEAP32[i198 + 72 >> 2] = HEAP32[i165 >> 2];
 HEAP32[i198 + 76 >> 2] = HEAP32[i166 >> 2];
 HEAP32[i198 + 80 >> 2] = HEAP32[i167 >> 2];
 HEAP32[i198 + 112 >> 2] = HEAP32[i168 >> 2];
 HEAP32[i198 + 116 >> 2] = HEAP32[i169 >> 2];
 HEAP32[i198 + 120 >> 2] = HEAP32[i170 >> 2];
 HEAP32[i198 + 124 >> 2] = HEAP32[i171 >> 2];
 HEAP32[i198 + 128 >> 2] = HEAP32[i172 >> 2];
 HEAP32[i198 + 132 >> 2] = HEAP32[i173 >> 2];
 HEAP32[i198 + 136 >> 2] = HEAP32[i174 >> 2];
 HEAP32[i198 + 168 >> 2] = HEAP32[i175 >> 2];
 HEAP32[i198 + 172 >> 2] = HEAP32[i176 >> 2];
 HEAP32[i198 + 176 >> 2] = HEAP32[i177 >> 2];
 HEAP32[i198 + 180 >> 2] = HEAP32[i179 >> 2];
 HEAP32[i198 + 184 >> 2] = HEAP32[i180 >> 2];
 HEAP32[i198 + 188 >> 2] = HEAP32[i196 >> 2];
 HEAP32[i198 + 192 >> 2] = HEAP32[i197 >> 2];
 if (i184 >>> 0 > 1) {
  i1 = i187 + 4 | 0;
  i2 = i187 + 8 | 0;
  i3 = i187 + 12 | 0;
  i4 = i187 + 16 | 0;
  i5 = i187 + 20 | 0;
  i6 = i187 + 24 | 0;
  i7 = i187 + 28 | 0;
  i8 = i187 + 32 | 0;
  i9 = i187 + 36 | 0;
  i10 = i187 + 40 | 0;
  i11 = i187 + 44 | 0;
  i12 = i187 + 48 | 0;
  i13 = i187 + 52 | 0;
  i14 = i187 + 56 | 0;
  i15 = i187 + 60 | 0;
  i16 = i187 + 64 | 0;
  i17 = i187 + 68 | 0;
  i18 = i187 + 72 | 0;
  i19 = i187 + 76 | 0;
  i20 = i187 + 80 | 0;
  i21 = i187 + 84 | 0;
  i22 = i187 + 88 | 0;
  i23 = i187 + 92 | 0;
  i24 = i187 + 96 | 0;
  i25 = i187 + 100 | 0;
  i26 = i187 + 104 | 0;
  i27 = i187 + 108 | 0;
  i28 = i187 + 16 | 0;
  i29 = i187 + 44 | 0;
  i30 = i187 + 72 | 0;
  i31 = i187 + 100 | 0;
  i32 = 1;
  do {
   HEAPF32[i187 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAPF32[i17 >> 2] = Math_fround(1.0);
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 20 >> 2] = 0;
   HEAPF32[i24 >> 2] = Math_fround(1.0);
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   i179 = i32 << 2;
   __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i181 + (i32 * 944 | 0) | 0, i182 + (i32 * 224 | 0) | 0, i191 + (i179 * 148 | 0) | 0, HEAP32[i186 + (i32 << 2) >> 2] | 0, i185, i187);
   HEAP32[i191 + (i179 * 148 | 0) + 120 >> 2] = HEAP32[i187 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 124 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 128 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 132 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 136 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 140 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i191 + (i179 * 148 | 0) + 144 >> 2] = HEAP32[i6 >> 2];
   i180 = i179 | 1;
   HEAP32[i191 + (i180 * 148 | 0) + 120 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 124 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 128 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 132 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 136 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 140 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i191 + (i180 * 148 | 0) + 144 >> 2] = HEAP32[i13 >> 2];
   i196 = i179 | 2;
   HEAP32[i191 + (i196 * 148 | 0) + 120 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 124 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 128 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 132 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 136 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 140 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i191 + (i196 * 148 | 0) + 144 >> 2] = HEAP32[i20 >> 2];
   i198 = i179 | 3;
   HEAP32[i191 + (i198 * 148 | 0) + 120 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 124 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 128 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 132 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 136 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 140 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i191 + (i198 * 148 | 0) + 144 >> 2] = HEAP32[i27 >> 2];
   i197 = HEAP32[i190 >> 2] | 0;
   HEAP32[i197 + (i179 * 56 | 0) >> 2] = HEAP32[i187 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 20 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i197 + (i179 * 56 | 0) + 24 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) >> 2] = HEAP32[i7 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 16 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 20 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i197 + (i180 * 56 | 0) + 24 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 12 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 16 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i197 + (i196 * 56 | 0) + 24 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 4 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 8 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 12 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 20 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i197 + (i198 * 56 | 0) + 24 >> 2] = HEAP32[i27 >> 2];
   i32 = i32 + 1 | 0;
  } while ((i32 | 0) != (i184 | 0));
 }
 do if (i188 | 0) {
  i1 = HEAP32[i188 >> 2] | 0;
  if (!i1) break;
  _memcpy(i1 | 0, i191 | 0, i183 * 148 | 0) | 0;
 } while (0);
 if (!i193) {
  HEAP32[i189 >> 2] = i192;
  __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i190, 1, i189);
 } else {
  _memcpy(HEAP32[i193 >> 2] | 0, HEAP32[i190 >> 2] | 0, i183 * 56 | 0) | 0;
  HEAP32[i193 + 8 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i193 + 12 >> 2] = HEAP32[i190 + 12 >> 2];
  HEAP32[i193 + 16 >> 2] = HEAP32[i190 + 16 >> 2];
  HEAP32[i193 + 20 >> 2] = HEAP32[i190 + 20 >> 2];
  HEAP32[i193 + 24 >> 2] = HEAP32[i190 + 24 >> 2];
  HEAP32[i193 + 28 >> 2] = HEAP32[i190 + 28 >> 2];
  i198 = HEAP16[i190 + 32 >> 1] | 0;
  HEAP8[i193 + 32 >> 0] = i198;
  HEAP8[i193 + 33 >> 0] = (i198 & 65535) >>> 8;
 }
 STACKTOP = i194;
 return;
}

function __ZN5physx15PxVehicleUpdate13updateNoDriveEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleNoDriveEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f48, i16, f49, f50, i15, i264, i260, i265) {
 f48 = Math_fround(f48);
 i16 = i16 | 0;
 f49 = Math_fround(f49);
 f50 = Math_fround(f50);
 i15 = i15 | 0;
 i264 = i264 | 0;
 i260 = i260 | 0;
 i265 = i265 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, f225 = f0, f226 = f0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, f239 = f0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i261 = 0, i262 = 0, i263 = 0, i266 = 0, f267 = f0, i268 = 0, f269 = f0, f270 = f0, f271 = f0, f272 = f0, f273 = f0, f274 = f0, f275 = f0, f276 = f0, f277 = f0;
 i266 = STACKTOP;
 STACKTOP = STACKTOP + 5760 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i266 + 4640 | 0;
 i262 = i266 + 4600 | 0;
 i258 = i266 + 4480 | 0;
 i251 = i266 + 4500 | 0;
 i263 = i266 + 1520 | 0;
 i257 = i266 + 1440 | 0;
 i244 = i266 + 168 | 0;
 i248 = i266 + 156 | 0;
 i253 = i266 + 144 | 0;
 i252 = i266 + 132 | 0;
 i9 = i266 + 104 | 0;
 i10 = i266 + 76 | 0;
 i11 = i266 + 64 | 0;
 i12 = i266 + 52 | 0;
 i13 = i266 + 40 | 0;
 i247 = i266 + 1472 | 0;
 i245 = i266 + 28 | 0;
 i246 = i266 + 16 | 0;
 i243 = i266 + 12 | 0;
 i250 = i266 + 8 | 0;
 i249 = i266 + 4 | 0;
 i254 = i266 + 1328 | 0;
 i259 = i266 + 200 | 0;
 i261 = i266;
 i242 = i264 + 8 | 0;
 i3 = HEAP32[i264 + 44 >> 2] | 0;
 if (!i3) {
  i5 = i264 + 72 | 0;
  i3 = 0;
  i7 = i5;
  i5 = HEAP32[i5 >> 2] | 0;
 } else {
  i5 = HEAP32[i264 + 72 >> 2] | 0;
  i4 = 0;
  do {
   i1 = i4 << 2;
   i2 = HEAP32[gb + 1458456 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) {
    HEAP32[i2 + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i1 | 1) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 4 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i1 | 2) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 8 >> 2];
    HEAP32[(HEAP32[gb + 1458456 + ((i1 | 3) << 2) >> 2] | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 12 >> 2];
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i3 >>> 0);
  i7 = i264 + 72 | 0;
 }
 i255 = HEAP32[i264 + 40 >> 2] | 0;
 i256 = HEAP32[i264 + 48 >> 2] | 0;
 i2 = 4 - (i3 << 2) | 0;
 i14 = HEAP32[i264 + 104 >> 2] | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 i1 = i8 + 60 | 0;
 i4 = i8 + 16 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 68 >> 2] = Math_fround(1.0);
 i1 = i8 + 116 | 0;
 i4 = i8 + 72 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 124 >> 2] = Math_fround(1.0);
 i1 = i8 + 172 | 0;
 i4 = i8 + 128 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 180 >> 2] = Math_fround(1.0);
 i1 = i8 + 228 | 0;
 i4 = i8 + 184 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 236 >> 2] = Math_fround(1.0);
 i1 = i8 + 284 | 0;
 i4 = i8 + 240 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 292 >> 2] = Math_fround(1.0);
 i1 = i8 + 340 | 0;
 i4 = i8 + 296 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 348 >> 2] = Math_fround(1.0);
 i1 = i8 + 396 | 0;
 i4 = i8 + 352 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 404 >> 2] = Math_fround(1.0);
 i1 = i8 + 452 | 0;
 i4 = i8 + 408 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 456 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 460 >> 2] = Math_fround(1.0);
 i1 = i8 + 508 | 0;
 i4 = i8 + 464 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 512 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 516 >> 2] = Math_fround(1.0);
 i1 = i8 + 564 | 0;
 i4 = i8 + 520 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 568 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 572 >> 2] = Math_fround(1.0);
 i1 = i8 + 620 | 0;
 i4 = i8 + 576 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 624 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 628 >> 2] = Math_fround(1.0);
 i1 = i8 + 676 | 0;
 i4 = i8 + 632 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 680 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 684 >> 2] = Math_fround(1.0);
 i1 = i8 + 732 | 0;
 i4 = i8 + 688 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 740 >> 2] = Math_fround(1.0);
 i1 = i8 + 788 | 0;
 i4 = i8 + 744 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 792 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 796 >> 2] = Math_fround(1.0);
 i1 = i8 + 844 | 0;
 i4 = i8 + 800 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 848 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 852 >> 2] = Math_fround(1.0);
 i1 = i8 + 900 | 0;
 i4 = i8 + 856 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 904 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 908 >> 2] = Math_fround(1.0);
 i1 = i8 + 956 | 0;
 i4 = i8 + 912 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 960 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 964 >> 2] = Math_fround(1.0);
 i1 = i8 + 1012 | 0;
 i4 = i8 + 968 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 1016 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 1020 >> 2] = Math_fround(1.0);
 i1 = i8 + 1068 | 0;
 i4 = i8 + 1024 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 1072 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 1076 >> 2] = Math_fround(1.0);
 i4 = i8 + 1080 | 0;
 i6 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i4 = i2 + i256 | 0;
 HEAP32[i262 >> 2] = 0;
 HEAP32[i262 + 4 >> 2] = 0;
 HEAP32[i262 + 8 >> 2] = 0;
 HEAP32[i262 + 12 >> 2] = 0;
 HEAP32[i262 + 16 >> 2] = 0;
 HEAP32[i262 + 20 >> 2] = 0;
 HEAP32[i262 + 24 >> 2] = 0;
 HEAP32[i262 + 28 >> 2] = 0;
 HEAP16[i262 + 32 >> 1] = 0;
 HEAP32[i262 + 4 >> 2] = i256;
 HEAP32[i262 >> 2] = i8;
 i6 = (i256 | 0) == 0;
 L11 : do if (i6) i1 = 0; else {
  i1 = 0;
  while (1) {
   if (Math_fround(__ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj(i264, i1)) != Math_fround(0.0)) {
    i1 = 1;
    break L11;
   }
   if (Math_fround(__ZNK5physx16PxVehicleNoDrive13getSteerAngleEj(i264, i1)) != Math_fround(0.0)) {
    i1 = 1;
    break L11;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i256 >>> 0) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 do if (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 256 >> 2] | 0, i14 | 0) | 0) {
  if (i1) {
   HEAP8[i262 + 33 >> 0] = 1;
   break;
  }
  if (__ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE(i242, i7) | 0) {
   HEAP8[i262 + 33 >> 0] = 1;
   break;
  }
  i3 = ((HEAP32[i264 + 88 >> 2] | 0) + 3 | 0) >>> 2;
  i1 = HEAP32[i264 + 72 >> 2] | 0;
  if (i3 | 0) {
   i2 = 0;
   do {
    HEAPF32[i1 + (i2 * 224 | 0) >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i1 + (i2 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i2 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  if (!i265) {
   STACKTOP = i266;
   return;
  }
  HEAP8[i265 + 32 >> 0] = 1;
  STACKTOP = i266;
  return;
 } while (0);
 HEAP32[i258 >> 2] = 0;
 HEAP32[i258 + 4 >> 2] = 0;
 HEAP32[i258 + 8 >> 2] = 0;
 HEAP32[i258 + 12 >> 2] = 0;
 HEAP32[i258 + 16 >> 2] = 0;
 HEAP32[i258 >> 2] = i256 >>> 0 < 4 ? i256 : 4;
 i1 = i3 + -1 | 0;
 if (i1 >>> 0 > 1) {
  i2 = 1;
  do {
   HEAP32[i258 + (i2 << 2) >> 2] = 4;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i258 + (i1 << 2) >> 2] = i4;
 i241 = (i3 | 0) == 0;
 if (!i241) {
  i1 = HEAP32[i264 + 76 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i4 = 0;
  do {
   i240 = i4 << 2;
   HEAP32[i251 + (i4 * 20 | 0) >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + (i240 << 2) >> 2];
   HEAP32[i251 + (i4 * 20 | 0) + 4 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i240 | 1) << 2) >> 2];
   HEAP32[i251 + (i4 * 20 | 0) + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i240 | 2) << 2) >> 2];
   HEAP32[i251 + (i4 * 20 | 0) + 12 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + ((i240 | 3) << 2) >> 2];
   HEAP32[i251 + (i4 * 20 | 0) + 16 >> 2] = HEAP32[i2 >> 2];
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
  if (!i241) {
   i1 = 0;
   do {
    i240 = HEAP32[(HEAP32[i5 + (i1 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i240 >> 2] | 0) + 36 >> 2] | 0, i240 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 i1 = i263 + 2960 | 0;
 i2 = i263;
 do {
  _memset(i2 | 0, 0, 140) | 0;
  HEAP8[i2 + 28 >> 0] = 1;
  HEAP32[i2 + 44 >> 2] = -1;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP32[i2 + 124 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 1065353216;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 140 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = 0;
  i2 = i2 + 148 | 0;
 } while ((i2 | 0) != (i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 124 >> 2] | 0, i9 | 0, i14 | 0);
 i235 = HEAP32[i9 + 16 >> 2] | 0;
 HEAP32[i257 + 16 >> 2] = i235;
 i234 = HEAP32[i9 + 20 >> 2] | 0;
 HEAP32[i257 + 20 >> 2] = i234;
 i233 = HEAP32[i9 + 24 >> 2] | 0;
 HEAP32[i257 + 24 >> 2] = i233;
 HEAP32[i257 >> 2] = 0;
 HEAP32[i257 + 4 >> 2] = 0;
 HEAP32[i257 + 8 >> 2] = 0;
 HEAP32[i257 + 12 >> 2] = 1065353216;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 84 >> 2] | 0, i10 | 0, i14 | 0);
 f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i235, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f47 = Math_fround((HEAP32[tempDoublePtr >> 2] = i234, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i233, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f41 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f39 = Math_fround(Math_fround(f41 * f41) + Math_fround(-.5));
 f40 = Math_fround(HEAPF32[i10 >> 2]);
 f239 = Math_fround(f46 * f40);
 f44 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f239 = Math_fround(f239 + Math_fround(f47 * f44));
 f42 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f239 = Math_fround(f239 + Math_fround(f37 * f42));
 f45 = Math_fround(Math_fround(f40 * f239) + Math_fround(Math_fround(f46 * f39) + Math_fround(f41 * Math_fround(Math_fround(f37 * f44) - Math_fround(f47 * f42)))));
 f43 = Math_fround(Math_fround(f44 * f239) + Math_fround(Math_fround(f47 * f39) + Math_fround(f41 * Math_fround(Math_fround(f46 * f42) - Math_fround(f37 * f40)))));
 f239 = Math_fround(Math_fround(Math_fround(f37 * f39) + Math_fround(f41 * Math_fround(Math_fround(f47 * f40) - Math_fround(f46 * f44)))) + Math_fround(f42 * f239));
 f45 = Math_fround(Math_fround(HEAPF32[i10 + 16 >> 2]) + f45);
 f43 = Math_fround(Math_fround(HEAPF32[i10 + 20 >> 2]) + f43);
 f239 = Math_fround(Math_fround(HEAPF32[i10 + 24 >> 2]) + f239);
 f46 = Math_fround(f41 * Math_fround(0.0));
 f47 = Math_fround(f44 * Math_fround(0.0));
 f39 = Math_fround(f42 * Math_fround(0.0));
 f37 = Math_fround(Math_fround(Math_fround(f46 + f40) + f47) - f39);
 f40 = Math_fround(f40 * Math_fround(0.0));
 f44 = Math_fround(Math_fround(f39 + Math_fround(f44 + f46)) - f40);
 f46 = Math_fround(Math_fround(f40 + Math_fround(f42 + f46)) - f47);
 f39 = Math_fround(Math_fround(Math_fround(f41 - f40) - f47) - f39);
 HEAPF32[i244 >> 2] = f37;
 i233 = i244 + 4 | 0;
 HEAPF32[i233 >> 2] = f44;
 i234 = i244 + 8 | 0;
 HEAPF32[i234 >> 2] = f46;
 i235 = i244 + 12 | 0;
 HEAPF32[i235 >> 2] = f39;
 i236 = i244 + 16 | 0;
 HEAPF32[i236 >> 2] = f45;
 i237 = i244 + 20 | 0;
 HEAPF32[i237 >> 2] = f43;
 i238 = i244 + 24 | 0;
 HEAPF32[i238 >> 2] = f239;
 f239 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0));
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 148 >> 2] | 0, i11 | 0, i14 | 0);
 HEAP32[i248 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i248 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i248 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 152 >> 2] | 0, i12 | 0, i14 | 0);
 i222 = HEAP32[i12 >> 2] | 0;
 HEAP32[i253 >> 2] = i222;
 i223 = HEAP32[i12 + 4 >> 2] | 0;
 i240 = i253 + 4 | 0;
 HEAP32[i240 >> 2] = i223;
 i224 = HEAP32[i12 + 8 >> 2] | 0;
 i231 = i253 + 8 | 0;
 HEAP32[i231 >> 2] = i224;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 160 >> 2] | 0, i13 | 0, i14 | 0);
 i227 = HEAP32[i13 >> 2] | 0;
 HEAP32[i252 >> 2] = i227;
 i228 = HEAP32[i13 + 4 >> 2] | 0;
 i232 = i252 + 4 | 0;
 HEAP32[i232 >> 2] = i228;
 i229 = HEAP32[i13 + 8 >> 2] | 0;
 i230 = i252 + 8 | 0;
 HEAP32[i230 >> 2] = i229;
 f43 = (HEAP32[tempDoublePtr >> 2] = i222, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i223, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i224, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i227, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i228, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i229, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i6) {
  i2 = 0;
  i1 = 1;
 } else {
  i1 = HEAP32[i264 + 132 >> 2] | 0;
  i2 = HEAP32[i264 + 136 >> 2] | 0;
  i4 = 0;
  f35 = Math_fround(0.0);
  f36 = Math_fround(0.0);
  do {
   f226 = Math_fround(Math_abs(Math_fround(HEAPF32[i1 + (i4 << 2) >> 2])));
   f35 = f226 > f35 ? f226 : f35;
   f226 = Math_fround(Math_abs(Math_fround(HEAPF32[i2 + (i4 << 2) >> 2])));
   f36 = f226 > f36 ? f226 : f36;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i256 | 0));
  i2 = f35 > Math_fround(0.0);
  i1 = f36 == Math_fround(0.0);
 }
 i229 = i1 & i2;
 if (i241) {
  i227 = i253;
  i228 = i252;
  f36 = f44;
  f35 = f46;
 } else {
  i4 = 0;
  do {
   i1 = i4 << 2;
   i2 = i263 + (i1 * 148 | 0) | 0;
   if (!(HEAP32[i5 + (i4 * 224 | 0) + 212 >> 2] | 0)) {
    i224 = i263 + ((i1 | 1) * 148 | 0) | 0;
    i227 = i263 + ((i1 | 2) * 148 | 0) | 0;
    i228 = i263 + ((i1 | 3) * 148 | 0) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    HEAP32[i224 + 16 >> 2] = 0;
    HEAP32[i224 + 20 >> 2] = 0;
    HEAP32[i224 + 24 >> 2] = 0;
    HEAP32[i227 >> 2] = 0;
    HEAP32[i227 + 4 >> 2] = 0;
    HEAP32[i227 + 8 >> 2] = 0;
    HEAP32[i227 + 12 >> 2] = 0;
    HEAP32[i227 + 16 >> 2] = 0;
    HEAP32[i227 + 20 >> 2] = 0;
    HEAP32[i227 + 24 >> 2] = 0;
    HEAP32[i228 >> 2] = 0;
    HEAP32[i228 + 4 >> 2] = 0;
    HEAP32[i228 + 8 >> 2] = 0;
    HEAP32[i228 + 12 >> 2] = 0;
    HEAP32[i228 + 16 >> 2] = 0;
    HEAP32[i228 + 20 >> 2] = 0;
    HEAP32[i228 + 24 >> 2] = 0;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 96 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 4 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 100 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 8 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 104 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 12 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 144 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 148 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 20 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 152 >> 2];
    HEAP32[i263 + (i1 * 148 | 0) + 24 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 192 >> 2];
    i228 = i1 | 1;
    HEAP32[i263 + (i228 * 148 | 0) >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 108 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 4 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 112 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 8 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 116 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 12 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 156 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 160 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 20 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 164 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 24 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 196 >> 2];
    i228 = i1 | 2;
    HEAP32[i263 + (i228 * 148 | 0) >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 120 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 4 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 124 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 8 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 128 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 12 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 168 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 172 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 20 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 176 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 24 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 200 >> 2];
    i228 = i1 | 3;
    HEAP32[i263 + (i228 * 148 | 0) >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 132 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 4 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 136 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 8 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 140 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 12 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 180 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 16 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 184 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 20 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 188 >> 2];
    HEAP32[i263 + (i228 * 148 | 0) + 24 >> 2] = HEAP32[i5 + (i4 * 224 | 0) + 204 >> 2];
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
  f43 = Math_fround(HEAPF32[i253 >> 2]);
  f45 = Math_fround(HEAPF32[i240 >> 2]);
  f47 = Math_fround(HEAPF32[i231 >> 2]);
  f40 = Math_fround(HEAPF32[i252 >> 2]);
  f41 = Math_fround(HEAPF32[i232 >> 2]);
  f42 = Math_fround(HEAPF32[i230 >> 2]);
  f39 = Math_fround(HEAPF32[i235 >> 2]);
  f37 = Math_fround(HEAPF32[i244 >> 2]);
  f36 = Math_fround(HEAPF32[i233 >> 2]);
  i227 = i253;
  i228 = i252;
  f35 = Math_fround(HEAPF32[i234 >> 2]);
 }
 f46 = Math_fround(Math_fround(HEAPF32[gb + 158860 >> 2]) * Math_fround(2.0));
 f226 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 4 >> 2]) * Math_fround(2.0));
 f225 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 8 >> 2]) * Math_fround(2.0));
 f51 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
 f44 = Math_fround(Math_fround(Math_fround(f46 * f37) + Math_fround(f226 * f36)) + Math_fround(f225 * f35));
 f225 = Math_fround(Math_abs(Math_fround(Math_fround(f47 * Math_fround(Math_fround(Math_fround(f225 * f51) + Math_fround(f39 * Math_fround(Math_fround(f226 * f37) - Math_fround(f46 * f36)))) + Math_fround(f35 * f44))) + Math_fround(Math_fround(f43 * Math_fround(Math_fround(f37 * f44) + Math_fround(Math_fround(f46 * f51) + Math_fround(f39 * Math_fround(Math_fround(f225 * f36) - Math_fround(f226 * f35)))))) + Math_fround(f45 * Math_fround(Math_fround(f36 * f44) + Math_fround(Math_fround(f226 * f51) + Math_fround(f39 * Math_fround(Math_fround(f46 * f35) - Math_fround(f225 * f37))))))))));
 f46 = Math_fround(HEAPF32[i264 + 56 >> 2]);
 i224 = f225 < f46 ? HEAP32[i264 + 60 >> 2] | 0 : HEAP32[i264 + 64 >> 2] | 0;
 f46 = Math_fround(Math_fround(1.0) / Math_fround(i224 >>> 0));
 f225 = Math_fround(f46 * f48);
 f51 = Math_fround(Math_fround(1.0) / f225);
 f226 = Math_fround(Math_fround(1.0) / f48);
 i223 = HEAP32[i264 + 68 >> 2] | 0;
 HEAPF32[i247 >> 2] = f46;
 HEAPF32[i247 + 4 >> 2] = f225;
 HEAPF32[i247 + 8 >> 2] = f51;
 HEAP32[i247 + 12 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i247 + 16 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i247 + 20 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAPF32[i247 + 24 >> 2] = f49;
 HEAPF32[i247 + 28 >> 2] = f50;
 HEAP8[i247 + 32 >> 0] = 0;
 HEAP32[i247 + 36 >> 2] = i223;
 HEAP32[i247 + 40 >> 2] = i14;
 HEAP32[i247 + 44 >> 2] = i15;
 if (i224 | 0) {
  i33 = i245 + 4 | 0;
  i34 = i245 + 8 | 0;
  i38 = i246 + 4 | 0;
  i52 = i246 + 8 | 0;
  i53 = i264 + 136 | 0;
  i54 = i264 + 128 | 0;
  i55 = i264 + 132 | 0;
  i56 = i250 + 1 | 0;
  i57 = i250 + 2 | 0;
  i58 = i250 + 3 | 0;
  i59 = i249 + 1 | 0;
  i60 = i249 + 2 | 0;
  i61 = i249 + 3 | 0;
  i62 = i229 & 1;
  i63 = i254 + 4 | 0;
  i64 = i254 + 8 | 0;
  i65 = i254 + 12 | 0;
  i66 = i254 + 16 | 0;
  i67 = i254 + 20 | 0;
  i68 = i254 + 24 | 0;
  i69 = i254 + 28 | 0;
  i70 = i254 + 32 | 0;
  i71 = i254 + 36 | 0;
  i72 = i254 + 40 | 0;
  i73 = i254 + 44 | 0;
  i74 = i254 + 48 | 0;
  i75 = i254 + 52 | 0;
  i76 = i254 + 56 | 0;
  i77 = i254 + 60 | 0;
  i78 = i254 + 64 | 0;
  i79 = i254 + 68 | 0;
  i80 = i254 + 72 | 0;
  i81 = i254 + 76 | 0;
  i82 = i254 + 80 | 0;
  i83 = i254 + 84 | 0;
  i84 = i254 + 88 | 0;
  i85 = i259 + 112 | 0;
  i86 = i259 + 164 | 0;
  i87 = i259 + 113 | 0;
  i88 = i259 + 168 | 0;
  i89 = i259 + 114 | 0;
  i90 = i259 + 172 | 0;
  i91 = i259 + 115 | 0;
  i92 = i259 + 176 | 0;
  i93 = i259 + 508 | 0;
  i94 = i259 + 512 | 0;
  i95 = i259 + 516 | 0;
  i96 = i259 + 520 | 0;
  i97 = i259 + 524 | 0;
  i98 = i259 + 528 | 0;
  i99 = i259 + 532 | 0;
  i100 = i259 + 536 | 0;
  i101 = i259 + 292 | 0;
  i102 = i224 + -1 | 0;
  i103 = i259 + 904 | 0;
  i104 = i259 + 920 | 0;
  i105 = i259 + 984 | 0;
  i106 = i259 + 1e3 | 0;
  i107 = i259 + 924 | 0;
  i108 = i259 + 928 | 0;
  i109 = i259 + 932 | 0;
  i110 = i259 + 908 | 0;
  i111 = i259 + 936 | 0;
  i112 = i259 + 940 | 0;
  i113 = i259 + 944 | 0;
  i114 = i259 + 948 | 0;
  i115 = i259 + 988 | 0;
  i116 = i259 + 1004 | 0;
  i117 = i259 + 912 | 0;
  i118 = i259 + 952 | 0;
  i119 = i259 + 956 | 0;
  i120 = i259 + 960 | 0;
  i121 = i259 + 964 | 0;
  i122 = i259 + 992 | 0;
  i123 = i259 + 1008 | 0;
  i124 = i259 + 916 | 0;
  i125 = i259 + 968 | 0;
  i126 = i259 + 972 | 0;
  i127 = i259 + 976 | 0;
  i128 = i259 + 980 | 0;
  i129 = i259 + 996 | 0;
  i130 = i259 + 1012 | 0;
  i131 = i259 + 484 | 0;
  i132 = i259 + 488 | 0;
  i133 = i259 + 492 | 0;
  i134 = i259 + 496 | 0;
  i135 = i259 + 500 | 0;
  i136 = i259 + 504 | 0;
  i137 = i259 + 540 | 0;
  i138 = i259 + 544 | 0;
  i139 = i259 + 548 | 0;
  i140 = i259 + 552 | 0;
  i141 = i259 + 556 | 0;
  i142 = i259 + 560 | 0;
  i143 = i259 + 564 | 0;
  i144 = i259 + 568 | 0;
  i145 = i259 + 572 | 0;
  i146 = i259 + 576 | 0;
  i147 = i259 + 580 | 0;
  i148 = i259 + 584 | 0;
  i149 = i259 + 588 | 0;
  i150 = i259 + 592 | 0;
  i151 = i259 + 596 | 0;
  i152 = i259 + 600 | 0;
  i153 = i259 + 604 | 0;
  i154 = i259 + 608 | 0;
  i155 = i259 + 612 | 0;
  i156 = i259 + 616 | 0;
  i157 = i259 + 620 | 0;
  i158 = i259 + 624 | 0;
  i159 = i259 + 628 | 0;
  i160 = i259 + 632 | 0;
  i161 = i259 + 636 | 0;
  i162 = i259 + 656 | 0;
  i163 = i259 + 660 | 0;
  i164 = i259 + 664 | 0;
  i165 = i259 + 668 | 0;
  i166 = i259 + 672 | 0;
  i167 = i259 + 676 | 0;
  i168 = i259 + 680 | 0;
  i169 = i259 + 684 | 0;
  i170 = i259 + 688 | 0;
  i171 = i259 + 692 | 0;
  i172 = i259 + 696 | 0;
  i173 = i259 + 700 | 0;
  i174 = i259 + 704 | 0;
  i175 = i259 + 708 | 0;
  i176 = i259 + 712 | 0;
  i177 = i259 + 716 | 0;
  i178 = i259 + 720 | 0;
  i179 = i259 + 724 | 0;
  i180 = i259 + 728 | 0;
  i181 = i259 + 732 | 0;
  i182 = i259 + 736 | 0;
  i183 = i259 + 740 | 0;
  i184 = i259 + 744 | 0;
  i185 = i259 + 748 | 0;
  i186 = i259 + 752 | 0;
  i187 = i259 + 772 | 0;
  i188 = i259 + 776 | 0;
  i189 = i259 + 780 | 0;
  i190 = i259 + 784 | 0;
  i191 = i259 + 788 | 0;
  i192 = i259 + 792 | 0;
  i193 = i259 + 796 | 0;
  i194 = i259 + 800 | 0;
  i195 = i259 + 804 | 0;
  i196 = i259 + 808 | 0;
  i197 = i259 + 812 | 0;
  i198 = i259 + 816 | 0;
  i199 = i259 + 820 | 0;
  i200 = i259 + 824 | 0;
  i201 = i259 + 828 | 0;
  i202 = i259 + 832 | 0;
  i203 = i259 + 836 | 0;
  i204 = i259 + 840 | 0;
  i205 = i259 + 844 | 0;
  i206 = i259 + 848 | 0;
  i207 = i259 + 852 | 0;
  i208 = i259 + 856 | 0;
  i209 = i259 + 860 | 0;
  i210 = i259 + 864 | 0;
  i211 = i259 + 868 | 0;
  i212 = i259 + 888 | 0;
  i213 = i259 + 892 | 0;
  i214 = i259 + 896 | 0;
  i215 = i259 + 900 | 0;
  i216 = i259 + 468 | 0;
  i217 = i259 + 472 | 0;
  i218 = i259 + 476 | 0;
  i219 = i259 + 480 | 0;
  i220 = i243 + 3 | 0;
  i221 = i243 + 2 | 0;
  i222 = i243 + 1 | 0;
  i223 = 0;
  do {
   HEAPF32[i245 >> 2] = Math_fround(0.0);
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   HEAPF32[i246 >> 2] = Math_fround(0.0);
   HEAPF32[i38 >> 2] = Math_fround(0.0);
   HEAPF32[i52 >> 2] = Math_fround(0.0);
   if (!i241) {
    i15 = HEAP32[i244 >> 2] | 0;
    i16 = HEAP32[i233 >> 2] | 0;
    i17 = HEAP32[i234 >> 2] | 0;
    i18 = HEAP32[i235 >> 2] | 0;
    i19 = HEAP32[i236 >> 2] | 0;
    i20 = HEAP32[i237 >> 2] | 0;
    i21 = HEAP32[i238 >> 2] | 0;
    i22 = HEAP32[i253 >> 2] | 0;
    i23 = HEAP32[i240 >> 2] | 0;
    i24 = HEAP32[i231 >> 2] | 0;
    i25 = HEAP32[i252 >> 2] | 0;
    i26 = HEAP32[i232 >> 2] | 0;
    i27 = HEAP32[i230 >> 2] | 0;
    i28 = (i102 | 0) == (i223 | 0);
    i29 = (i223 | 0) == 0;
    f46 = Math_fround(0.0);
    f44 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    i32 = 0;
    do {
     i30 = i32 << 2;
     i4 = HEAP32[i53 >> 2] | 0;
     i6 = (HEAP32[i54 >> 2] | 0) + (i30 << 2) | 0;
     i31 = HEAP32[i55 >> 2] | 0;
     i14 = i31 + (i30 << 2) | 0;
     HEAP32[i243 >> 2] = 0;
     i1 = HEAP32[i264 + 52 + ((i32 >>> 3 & 134217727) << 2) >> 2] | 0;
     i2 = i30 & 28;
     if (i1 & 1 << i2 | 0) HEAP8[i243 >> 0] = 1;
     if (i1 & 1 << (i2 | 1) | 0) HEAP8[i222 >> 0] = 1;
     if (i1 & 1 << (i2 | 2) | 0) HEAP8[i221 >> 0] = 1;
     if (i1 & 1 << (i2 | 3) | 0) HEAP8[i220 >> 0] = 1;
     i10 = i5 + (i32 * 224 | 0) | 0;
     HEAP32[i250 >> 2] = 0;
     f267 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = f267 <= Math_fround(-0.0);
     f49 = i11 ? Math_fround(0.0) : Math_fround(1.0);
     i11 = f267 >= Math_fround(0.0);
     f49 = i11 ? f49 : Math_fround(-1.0);
     f267 = Math_fround(HEAPF32[i4 + (i30 << 2) >> 2]);
     f49 = Math_fround(f267 * f49);
     HEAP8[i250 >> 0] = f267 != Math_fround(0.0) & 1;
     i11 = i5 + (i32 * 224 | 0) + 4 | 0;
     f267 = Math_fround(HEAPF32[i11 >> 2]);
     i7 = f267 <= Math_fround(-0.0);
     f50 = i7 ? Math_fround(0.0) : Math_fround(1.0);
     i7 = f267 >= Math_fround(0.0);
     f50 = i7 ? f50 : Math_fround(-1.0);
     i7 = i30 | 1;
     f267 = Math_fround(HEAPF32[i4 + (i7 << 2) >> 2]);
     f50 = Math_fround(f267 * f50);
     HEAP8[i56 >> 0] = f267 != Math_fround(0.0) & 1;
     i12 = i5 + (i32 * 224 | 0) + 8 | 0;
     f267 = Math_fround(HEAPF32[i12 >> 2]);
     i8 = f267 <= Math_fround(-0.0);
     f51 = i8 ? Math_fround(0.0) : Math_fround(1.0);
     i8 = f267 >= Math_fround(0.0);
     f51 = i8 ? f51 : Math_fround(-1.0);
     i8 = i30 | 2;
     f267 = Math_fround(HEAPF32[i4 + (i8 << 2) >> 2]);
     f51 = Math_fround(f267 * f51);
     HEAP8[i57 >> 0] = f267 != Math_fround(0.0) & 1;
     i13 = i5 + (i32 * 224 | 0) + 12 | 0;
     f267 = Math_fround(HEAPF32[i13 >> 2]);
     i9 = f267 <= Math_fround(-0.0);
     f48 = i9 ? Math_fround(0.0) : Math_fround(1.0);
     i9 = f267 >= Math_fround(0.0);
     f48 = i9 ? f48 : Math_fround(-1.0);
     i9 = i30 | 3;
     f267 = Math_fround(HEAPF32[i4 + (i9 << 2) >> 2]);
     f48 = Math_fround(f267 * f48);
     HEAP8[i58 >> 0] = f267 != Math_fround(0.0) & 1;
     HEAP32[i249 >> 2] = 0;
     if (i229) {
      HEAP8[i249 >> 0] = Math_fround(HEAPF32[i14 >> 2]) != Math_fround(0.0) & 1;
      HEAP8[i59 >> 0] = Math_fround(HEAPF32[i31 + (i7 << 2) >> 2]) != Math_fround(0.0) & 1;
      HEAP8[i60 >> 0] = Math_fround(HEAPF32[i31 + (i8 << 2) >> 2]) != Math_fround(0.0) & 1;
      HEAP8[i61 >> 0] = Math_fround(HEAPF32[i31 + (i9 << 2) >> 2]) != Math_fround(0.0) & 1;
     }
     HEAP8[i254 >> 0] = i62;
     HEAP32[i63 >> 2] = i249;
     HEAP32[i64 >> 2] = i250;
     HEAP32[i65 >> 2] = i6;
     HEAP32[i66 >> 2] = i243;
     HEAP32[i67 >> 2] = i15;
     HEAP32[i68 >> 2] = i16;
     HEAP32[i69 >> 2] = i17;
     HEAP32[i70 >> 2] = i18;
     HEAP32[i71 >> 2] = i19;
     HEAP32[i72 >> 2] = i20;
     HEAP32[i73 >> 2] = i21;
     HEAP32[i74 >> 2] = i22;
     HEAP32[i75 >> 2] = i23;
     HEAP32[i76 >> 2] = i24;
     HEAP32[i77 >> 2] = i25;
     HEAP32[i78 >> 2] = i26;
     HEAP32[i79 >> 2] = i27;
     HEAP32[i80 >> 2] = i255 + (i32 * 944 | 0);
     HEAP32[i81 >> 2] = i10;
     HEAP32[i82 >> 2] = i251 + (i32 * 20 | 0);
     HEAP32[i83 >> 2] = i242;
     i1 = i258 + (i32 << 2) | 0;
     HEAP32[i84 >> 2] = HEAP32[i1 >> 2];
     _memset(i259 | 0, 0, 1128) | 0;
     HEAP8[i85 >> 0] = 1;
     HEAP32[i86 >> 2] = -1;
     HEAP8[i87 >> 0] = 1;
     HEAP32[i88 >> 2] = -1;
     HEAP8[i89 >> 0] = 1;
     HEAP32[i90 >> 2] = -1;
     HEAP8[i91 >> 0] = 1;
     HEAP32[i92 >> 2] = -1;
     __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(i30, i247, i254, i259);
     i6 = HEAP32[i81 >> 2] | 0;
     i4 = i6 + 48 | 0;
     f267 = Math_fround(HEAPF32[i93 >> 2]);
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i94 >> 2]);
     i4 = i6 + 52 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i95 >> 2]);
     i4 = i6 + 56 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i96 >> 2]);
     i4 = i6 + 60 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     i4 = i6 + 64 | 0;
     f267 = Math_fround(HEAPF32[i97 >> 2]);
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i98 >> 2]);
     i4 = i6 + 68 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i99 >> 2]);
     i4 = i6 + 72 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     f267 = Math_fround(HEAPF32[i100 >> 2]);
     i4 = i6 + 76 | 0;
     i2 = f267 != Math_fround(HEAPF32[i4 >> 2]);
     HEAPF32[i4 >> 2] = i2 ? f267 : Math_fround(0.0);
     i6 = i6 + 80 | 0;
     HEAP32[i6 >> 2] = HEAP32[i101 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
     if (i28) {
      if (HEAP32[i5 + (i32 * 224 | 0) + 212 >> 2] | 0) HEAP8[i5 + (i32 * 224 | 0) + 216 >> 0] = 1;
      HEAP16[i5 + (i32 * 224 | 0) + 192 >> 1] = HEAP32[i103 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 96 >> 2] = HEAP32[i104 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 100 >> 2] = HEAP32[i107 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 104 >> 2] = HEAP32[i108 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 108 >> 2] = HEAP32[i109 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 176 >> 2] = HEAP32[i105 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 160 >> 2] = HEAP32[i106 >> 2];
      HEAP16[i5 + (i32 * 224 | 0) + 194 >> 1] = HEAP32[i110 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 112 >> 2] = HEAP32[i111 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 116 >> 2] = HEAP32[i112 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 120 >> 2] = HEAP32[i113 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 124 >> 2] = HEAP32[i114 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 180 >> 2] = HEAP32[i115 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 164 >> 2] = HEAP32[i116 >> 2];
      HEAP16[i5 + (i32 * 224 | 0) + 196 >> 1] = HEAP32[i117 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 128 >> 2] = HEAP32[i118 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 132 >> 2] = HEAP32[i119 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 136 >> 2] = HEAP32[i120 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 140 >> 2] = HEAP32[i121 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 184 >> 2] = HEAP32[i122 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 168 >> 2] = HEAP32[i123 >> 2];
      HEAP16[i5 + (i32 * 224 | 0) + 198 >> 1] = HEAP32[i124 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 144 >> 2] = HEAP32[i125 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 148 >> 2] = HEAP32[i126 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 152 >> 2] = HEAP32[i127 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 156 >> 2] = HEAP32[i128 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 188 >> 2] = HEAP32[i129 >> 2];
      HEAP32[i5 + (i32 * 224 | 0) + 172 >> 2] = HEAP32[i130 >> 2];
     }
     f46 = Math_fround(Math_fround(HEAPF32[i131 >> 2]) + f46);
     f44 = Math_fround(Math_fround(HEAPF32[i132 >> 2]) + f44);
     f39 = Math_fround(Math_fround(HEAPF32[i133 >> 2]) + f39);
     f37 = Math_fround(Math_fround(HEAPF32[i134 >> 2]) + f37);
     f36 = Math_fround(Math_fround(HEAPF32[i135 >> 2]) + f36);
     f35 = Math_fround(Math_fround(HEAPF32[i136 >> 2]) + f35);
     if (i29) {
      i6 = HEAP32[i5 + (i32 * 224 | 0) + 208 >> 2] | 0;
      HEAP32[i6 + 4 >> 2] = HEAP32[i137 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i138 >> 2];
      HEAP32[i6 + 12 >> 2] = HEAP32[i139 >> 2];
      HEAP32[i6 + 16 >> 2] = HEAP32[i140 >> 2];
      HEAP32[i6 + 20 >> 2] = HEAP32[i141 >> 2];
      HEAP32[i6 + 24 >> 2] = HEAP32[i142 >> 2];
      HEAP32[i6 + 28 >> 2] = HEAP32[i143 >> 2];
      HEAP32[i6 + 32 >> 2] = HEAP32[i144 >> 2];
      HEAP32[i6 + 36 >> 2] = HEAP32[i145 >> 2];
      HEAP32[i6 + 40 >> 2] = HEAP32[i146 >> 2];
      HEAP32[i6 + 44 >> 2] = HEAP32[i147 >> 2];
      HEAP32[i6 + 48 >> 2] = HEAP32[i148 >> 2];
      HEAP32[i6 + 52 >> 2] = HEAP32[i149 >> 2];
      HEAP32[i6 + 56 >> 2] = HEAP32[i150 >> 2];
      HEAP32[i6 + 60 >> 2] = HEAP32[i151 >> 2];
      HEAP32[i6 + 64 >> 2] = HEAP32[i152 >> 2];
      HEAP32[i6 + 68 >> 2] = HEAP32[i153 >> 2];
      HEAP32[i6 + 72 >> 2] = HEAP32[i154 >> 2];
      HEAP32[i6 + 76 >> 2] = HEAP32[i155 >> 2];
      HEAP32[i6 + 80 >> 2] = HEAP32[i156 >> 2];
      HEAP32[i6 + 84 >> 2] = HEAP32[i157 >> 2];
      HEAP32[i6 + 88 >> 2] = HEAP32[i158 >> 2];
      HEAP32[i6 + 92 >> 2] = HEAP32[i159 >> 2];
      HEAP32[i6 + 96 >> 2] = HEAP32[i160 >> 2];
      i4 = i6 + 100 | 0;
      HEAP32[i4 >> 2] = HEAP32[i161 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i161 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i161 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i161 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i161 + 16 >> 2];
      HEAP32[i6 + 120 >> 2] = HEAP32[i162 >> 2];
      HEAP32[i6 + 124 >> 2] = HEAP32[i163 >> 2];
      HEAP32[i6 + 128 >> 2] = HEAP32[i164 >> 2];
      HEAP32[i6 + 132 >> 2] = HEAP32[i165 >> 2];
      HEAP32[i6 + 136 >> 2] = HEAP32[i166 >> 2];
      HEAP32[i6 + 140 >> 2] = HEAP32[i167 >> 2];
      HEAP32[i6 + 144 >> 2] = HEAP32[i168 >> 2];
      HEAP32[i6 + 148 >> 2] = HEAP32[i169 >> 2];
      HEAP32[i6 + 152 >> 2] = HEAP32[i170 >> 2];
      HEAP32[i6 + 156 >> 2] = HEAP32[i171 >> 2];
      HEAP32[i6 + 160 >> 2] = HEAP32[i172 >> 2];
      HEAP32[i6 + 164 >> 2] = HEAP32[i173 >> 2];
      HEAP32[i6 + 168 >> 2] = HEAP32[i174 >> 2];
      HEAP32[i6 + 172 >> 2] = HEAP32[i175 >> 2];
      HEAP32[i6 + 176 >> 2] = HEAP32[i176 >> 2];
      HEAP32[i6 + 180 >> 2] = HEAP32[i177 >> 2];
      HEAP32[i6 + 184 >> 2] = HEAP32[i178 >> 2];
      HEAP32[i6 + 188 >> 2] = HEAP32[i179 >> 2];
      HEAP32[i6 + 192 >> 2] = HEAP32[i180 >> 2];
      HEAP32[i6 + 196 >> 2] = HEAP32[i181 >> 2];
      HEAP32[i6 + 200 >> 2] = HEAP32[i182 >> 2];
      HEAP32[i6 + 204 >> 2] = HEAP32[i183 >> 2];
      HEAP32[i6 + 208 >> 2] = HEAP32[i184 >> 2];
      HEAP32[i6 + 212 >> 2] = HEAP32[i185 >> 2];
      i4 = i6 + 216 | 0;
      HEAP32[i4 >> 2] = HEAP32[i186 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i186 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i186 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i186 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i186 + 16 >> 2];
      HEAP32[i6 + 236 >> 2] = HEAP32[i187 >> 2];
      HEAP32[i6 + 240 >> 2] = HEAP32[i188 >> 2];
      HEAP32[i6 + 244 >> 2] = HEAP32[i189 >> 2];
      HEAP32[i6 + 248 >> 2] = HEAP32[i190 >> 2];
      HEAP32[i6 + 252 >> 2] = HEAP32[i191 >> 2];
      HEAP32[i6 + 256 >> 2] = HEAP32[i192 >> 2];
      HEAP32[i6 + 260 >> 2] = HEAP32[i193 >> 2];
      HEAP32[i6 + 264 >> 2] = HEAP32[i194 >> 2];
      HEAP32[i6 + 268 >> 2] = HEAP32[i195 >> 2];
      HEAP32[i6 + 272 >> 2] = HEAP32[i196 >> 2];
      HEAP32[i6 + 276 >> 2] = HEAP32[i197 >> 2];
      HEAP32[i6 + 280 >> 2] = HEAP32[i198 >> 2];
      HEAP32[i6 + 284 >> 2] = HEAP32[i199 >> 2];
      HEAP32[i6 + 288 >> 2] = HEAP32[i200 >> 2];
      HEAP32[i6 + 292 >> 2] = HEAP32[i201 >> 2];
      HEAP32[i6 + 296 >> 2] = HEAP32[i202 >> 2];
      HEAP32[i6 + 300 >> 2] = HEAP32[i203 >> 2];
      HEAP32[i6 + 304 >> 2] = HEAP32[i204 >> 2];
      HEAP32[i6 + 308 >> 2] = HEAP32[i205 >> 2];
      HEAP32[i6 + 312 >> 2] = HEAP32[i206 >> 2];
      HEAP32[i6 + 316 >> 2] = HEAP32[i207 >> 2];
      HEAP32[i6 + 320 >> 2] = HEAP32[i208 >> 2];
      HEAP32[i6 + 324 >> 2] = HEAP32[i209 >> 2];
      HEAP32[i6 + 328 >> 2] = HEAP32[i210 >> 2];
      i4 = i6 + 332 | 0;
      HEAP32[i4 >> 2] = HEAP32[i211 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i211 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i211 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i211 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i211 + 16 >> 2];
      HEAP32[i6 + 352 >> 2] = HEAP32[i212 >> 2];
      HEAP32[i6 + 356 >> 2] = HEAP32[i213 >> 2];
      HEAP32[i6 + 360 >> 2] = HEAP32[i214 >> 2];
      HEAP32[i6 + 364 >> 2] = HEAP32[i215 >> 2];
     }
     i1 = HEAP32[i1 >> 2] | 0;
     __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i259, HEAP32[i65 >> 2] | 0, i263 + (i30 * 148 | 0) | 0, i1);
     i2 = HEAP32[i262 >> 2] | 0;
     if (i1 | 0) {
      i4 = 0;
      do {
       i6 = i4 + i30 | 0;
       HEAP32[i2 + (i6 * 56 | 0) + 28 >> 2] = HEAP32[i259 + 1016 + (i4 << 2) >> 2];
       f267 = Math_fround(HEAPF32[i259 + 1032 + (i4 * 12 | 0) >> 2]);
       i268 = i2 + (i6 * 56 | 0) + 32 | 0;
       HEAPF32[i268 >> 2] = Math_fround(f267 + Math_fround(HEAPF32[i268 >> 2]));
       f267 = Math_fround(HEAPF32[i259 + 1032 + (i4 * 12 | 0) + 4 >> 2]);
       i268 = i2 + (i6 * 56 | 0) + 36 | 0;
       HEAPF32[i268 >> 2] = Math_fround(f267 + Math_fround(HEAPF32[i268 >> 2]));
       f267 = Math_fround(HEAPF32[i259 + 1032 + (i4 * 12 | 0) + 8 >> 2]);
       i268 = i2 + (i6 * 56 | 0) + 40 | 0;
       HEAPF32[i268 >> 2] = Math_fround(f267 + Math_fround(HEAPF32[i268 >> 2]));
       HEAP32[i2 + (i6 * 56 | 0) + 44 >> 2] = HEAP32[i259 + 1080 + (i4 * 12 | 0) >> 2];
       HEAP32[i2 + (i6 * 56 | 0) + 48 >> 2] = HEAP32[i259 + 1080 + (i4 * 12 | 0) + 4 >> 2];
       HEAP32[i2 + (i6 * 56 | 0) + 52 >> 2] = HEAP32[i259 + 1080 + (i4 * 12 | 0) + 8 >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i1 | 0));
     }
     f276 = Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 208 >> 2]);
     f275 = Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 256 >> 2]);
     f274 = Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 304 >> 2]);
     f273 = Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 352 >> 2]);
     f271 = Math_fround(f225 * Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 232 >> 2]));
     f270 = Math_fround(f225 * Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 280 >> 2]));
     f269 = Math_fround(f225 * Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 328 >> 2]));
     f267 = Math_fround(f225 * Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 376 >> 2]));
     f272 = Math_fround(HEAPF32[i10 >> 2]);
     f277 = Math_fround(HEAPF32[i216 >> 2]);
     f49 = Math_fround(Math_fround(f272 + Math_fround(f271 * Math_fround(Math_fround(f277 + Math_fround(HEAPF32[i14 >> 2])) - f49))) / Math_fround(Math_fround(f276 * f271) + Math_fround(1.0)));
     f271 = Math_fround(HEAPF32[i11 >> 2]);
     f276 = Math_fround(HEAPF32[i217 >> 2]);
     f50 = Math_fround(Math_fround(f271 + Math_fround(f270 * Math_fround(Math_fround(f276 + Math_fround(HEAPF32[i31 + (i7 << 2) >> 2])) - f50))) / Math_fround(Math_fround(f275 * f270) + Math_fround(1.0)));
     f270 = Math_fround(HEAPF32[i12 >> 2]);
     f275 = Math_fround(HEAPF32[i218 >> 2]);
     f51 = Math_fround(Math_fround(f270 + Math_fround(f269 * Math_fround(Math_fround(f275 + Math_fround(HEAPF32[i31 + (i8 << 2) >> 2])) - f51))) / Math_fround(Math_fround(f274 * f269) + Math_fround(1.0)));
     f269 = Math_fround(HEAPF32[i13 >> 2]);
     f274 = Math_fround(HEAPF32[i219 >> 2]);
     f267 = Math_fround(Math_fround(f269 + Math_fround(f267 * Math_fround(Math_fround(f274 + Math_fround(HEAPF32[i31 + (i9 << 2) >> 2])) - f48))) / Math_fround(Math_fround(f273 * f267) + Math_fround(1.0)));
     i1 = HEAP32[i250 >> 2] | 0;
     i268 = !(Math_fround(f272 * f49) <= Math_fround(0.0)) | (i1 & 255) << 24 >> 24 == 0;
     f49 = i268 ? f49 : Math_fround(0.0);
     i268 = !(Math_fround(f271 * f50) <= Math_fround(0.0)) | (i1 & 65280 | 0) == 0;
     f50 = i268 ? f50 : Math_fround(0.0);
     i268 = !(Math_fround(f270 * f51) <= Math_fround(0.0)) | (i1 & 16711680 | 0) == 0;
     f51 = i268 ? f51 : Math_fround(0.0);
     i1 = !(Math_fround(f269 * f267) <= Math_fround(0.0)) | i1 >>> 0 < 16777216;
     f267 = i1 ? f267 : Math_fround(0.0);
     HEAPF32[i10 >> 2] = f49;
     HEAPF32[i11 >> 2] = f50;
     HEAPF32[i12 >> 2] = f51;
     HEAPF32[i13 >> 2] = f267;
     i1 = 0;
     do {
      f48 = Math_fround(HEAPF32[i5 + (i32 * 224 | 0) + (i1 << 2) >> 2]);
      f277 = Math_fround(HEAPF32[i259 + 292 + (i1 << 2) >> 2]);
      do if (f277 > Math_fround(-Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + (i1 * 48 | 0) + 12 >> 2]))) {
       if (HEAP8[i250 + i1 >> 0] | 0) break;
       if (!(Math_fround(HEAPF32[i31 + (i1 + i30 << 2) >> 2]) == Math_fround(0.0))) break;
       f49 = Math_fround(HEAPF32[i259 + 452 + (i1 << 2) >> 2]);
       f50 = Math_fround(Math_abs(Math_fround(f49)));
       if (!(f50 < Math_fround(HEAPF32[gb + 1458420 >> 2]))) break;
       f276 = Math_fround(HEAPF32[i255 + (i32 * 944 | 0) + 192 + (i1 * 48 | 0) + 36 >> 2]);
       f277 = Math_fround(f50 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
       f48 = Math_fround(Math_fround(f48 * f277) + Math_fround(Math_fround(f49 * f276) * Math_fround(Math_fround(1.0) - f277)));
      } while (0);
      i268 = i5 + (i32 * 224 | 0) + 32 + (i1 << 2) | 0;
      f277 = Math_fround(Math_fround(HEAPF32[i268 >> 2]) + Math_fround(f225 * f48));
      f275 = Math_fround(f277 + Math_fround(-31.4159279));
      f276 = Math_fround(f277 + Math_fround(31.4159279));
      i14 = Math_fround(Math_fround(-31.4159279) - f277) >= Math_fround(0.0);
      i13 = f275 >= Math_fround(0.0);
      HEAPF32[i268 >> 2] = i13 ? f275 : i14 ? f276 : f277;
      HEAPF32[i5 + (i32 * 224 | 0) + 16 + (i1 << 2) >> 2] = f48;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 4);
     i32 = i32 + 1 | 0;
    } while ((i32 | 0) != (i3 | 0));
    HEAPF32[i245 >> 2] = f46;
    HEAPF32[i33 >> 2] = f44;
    HEAPF32[i34 >> 2] = f39;
    HEAPF32[i246 >> 2] = f37;
    HEAPF32[i38 >> 2] = f36;
    HEAPF32[i52 >> 2] = f35;
   }
   __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE(f239, i248, i245, i246, f225, i253, i252, i244);
   i223 = i223 + 1 | 0;
  } while ((i223 | 0) != (i224 | 0));
 }
 i38 = i262 + 8 | 0;
 if (!(HEAP8[gb + 1552705 >> 0] | 0)) {
  HEAP32[i38 >> 2] = HEAP32[i253 >> 2];
  HEAP32[i262 + 12 >> 2] = HEAP32[i240 >> 2];
  HEAP32[i262 + 16 >> 2] = HEAP32[i231 >> 2];
  HEAP32[i262 + 20 >> 2] = HEAP32[i252 >> 2];
  HEAP32[i262 + 24 >> 2] = HEAP32[i232 >> 2];
  HEAP32[i262 + 28 >> 2] = HEAP32[i230 >> 2];
 } else {
  f277 = Math_fround(Math_fround(HEAPF32[i227 >> 2]) - f43);
  f276 = Math_fround(Math_fround(HEAPF32[i240 >> 2]) - f45);
  f276 = Math_fround(f226 * f276);
  f275 = Math_fround(f226 * Math_fround(Math_fround(HEAPF32[i231 >> 2]) - f47));
  HEAPF32[i38 >> 2] = Math_fround(f226 * f277);
  HEAPF32[i262 + 12 >> 2] = f276;
  HEAPF32[i262 + 16 >> 2] = f275;
  f275 = Math_fround(Math_fround(HEAPF32[i228 >> 2]) - f40);
  f276 = Math_fround(Math_fround(HEAPF32[i232 >> 2]) - f41);
  f276 = Math_fround(f226 * f276);
  f277 = Math_fround(f226 * Math_fround(Math_fround(HEAPF32[i230 >> 2]) - f42));
  HEAPF32[i262 + 20 >> 2] = Math_fround(f226 * f275);
  HEAPF32[i262 + 24 >> 2] = f276;
  HEAPF32[i262 + 28 >> 2] = f277;
 }
 HEAPF32[i254 >> 2] = Math_fround(0.0);
 i224 = i254 + 4 | 0;
 HEAPF32[i224 >> 2] = Math_fround(0.0);
 i227 = i254 + 8 | 0;
 HEAPF32[i227 >> 2] = Math_fround(0.0);
 i228 = i254 + 12 | 0;
 HEAPF32[i228 >> 2] = Math_fround(1.0);
 i252 = i254 + 16 | 0;
 i230 = i254 + 20 | 0;
 i231 = i254 + 24 | 0;
 i232 = i254 + 28 | 0;
 i233 = i254 + 32 | 0;
 i234 = i254 + 36 | 0;
 i235 = i254 + 40 | 0;
 HEAP32[i252 >> 2] = 0;
 HEAP32[i252 + 4 >> 2] = 0;
 HEAP32[i252 + 8 >> 2] = 0;
 HEAP32[i252 + 12 >> 2] = 0;
 HEAP32[i252 + 16 >> 2] = 0;
 HEAP32[i252 + 20 >> 2] = 0;
 HEAPF32[i235 >> 2] = Math_fround(1.0);
 i252 = i254 + 44 | 0;
 i237 = i254 + 48 | 0;
 i238 = i254 + 52 | 0;
 i240 = i254 + 56 | 0;
 i241 = i254 + 60 | 0;
 i242 = i254 + 64 | 0;
 i243 = i254 + 68 | 0;
 HEAP32[i252 >> 2] = 0;
 HEAP32[i252 + 4 >> 2] = 0;
 HEAP32[i252 + 8 >> 2] = 0;
 HEAP32[i252 + 12 >> 2] = 0;
 HEAP32[i252 + 16 >> 2] = 0;
 HEAP32[i252 + 20 >> 2] = 0;
 HEAPF32[i243 >> 2] = Math_fround(1.0);
 i252 = i254 + 72 | 0;
 i245 = i254 + 76 | 0;
 i246 = i254 + 80 | 0;
 i247 = i254 + 84 | 0;
 i248 = i254 + 88 | 0;
 i249 = i254 + 92 | 0;
 i250 = i254 + 96 | 0;
 HEAP32[i252 >> 2] = 0;
 HEAP32[i252 + 4 >> 2] = 0;
 HEAP32[i252 + 8 >> 2] = 0;
 HEAP32[i252 + 12 >> 2] = 0;
 HEAP32[i252 + 16 >> 2] = 0;
 HEAP32[i252 + 20 >> 2] = 0;
 HEAPF32[i250 >> 2] = Math_fround(1.0);
 HEAPF32[i254 + 100 >> 2] = Math_fround(0.0);
 i252 = i254 + 104 | 0;
 HEAPF32[i252 >> 2] = Math_fround(0.0);
 i253 = i254 + 108 | 0;
 HEAPF32[i253 >> 2] = Math_fround(0.0);
 __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i255, i5, i263, HEAP32[i258 >> 2] | 0, i257, i254);
 HEAP32[i263 + 120 >> 2] = HEAP32[i254 >> 2];
 HEAP32[i263 + 124 >> 2] = HEAP32[i224 >> 2];
 HEAP32[i263 + 128 >> 2] = HEAP32[i227 >> 2];
 HEAP32[i263 + 132 >> 2] = HEAP32[i228 >> 2];
 i229 = i254 + 16 | 0;
 HEAP32[i263 + 136 >> 2] = HEAP32[i229 >> 2];
 HEAP32[i263 + 140 >> 2] = HEAP32[i230 >> 2];
 HEAP32[i263 + 144 >> 2] = HEAP32[i231 >> 2];
 HEAP32[i263 + 268 >> 2] = HEAP32[i232 >> 2];
 HEAP32[i263 + 272 >> 2] = HEAP32[i233 >> 2];
 HEAP32[i263 + 276 >> 2] = HEAP32[i234 >> 2];
 HEAP32[i263 + 280 >> 2] = HEAP32[i235 >> 2];
 i236 = i254 + 44 | 0;
 HEAP32[i263 + 284 >> 2] = HEAP32[i236 >> 2];
 HEAP32[i263 + 288 >> 2] = HEAP32[i237 >> 2];
 HEAP32[i263 + 292 >> 2] = HEAP32[i238 >> 2];
 HEAP32[i263 + 416 >> 2] = HEAP32[i240 >> 2];
 HEAP32[i263 + 420 >> 2] = HEAP32[i241 >> 2];
 HEAP32[i263 + 424 >> 2] = HEAP32[i242 >> 2];
 HEAP32[i263 + 428 >> 2] = HEAP32[i243 >> 2];
 i244 = i254 + 72 | 0;
 HEAP32[i263 + 432 >> 2] = HEAP32[i244 >> 2];
 HEAP32[i263 + 436 >> 2] = HEAP32[i245 >> 2];
 HEAP32[i263 + 440 >> 2] = HEAP32[i246 >> 2];
 HEAP32[i263 + 564 >> 2] = HEAP32[i247 >> 2];
 HEAP32[i263 + 568 >> 2] = HEAP32[i248 >> 2];
 HEAP32[i263 + 572 >> 2] = HEAP32[i249 >> 2];
 HEAP32[i263 + 576 >> 2] = HEAP32[i250 >> 2];
 i251 = i254 + 100 | 0;
 HEAP32[i263 + 580 >> 2] = HEAP32[i251 >> 2];
 HEAP32[i263 + 584 >> 2] = HEAP32[i252 >> 2];
 HEAP32[i263 + 588 >> 2] = HEAP32[i253 >> 2];
 i268 = HEAP32[i262 >> 2] | 0;
 HEAP32[i268 >> 2] = HEAP32[i254 >> 2];
 HEAP32[i268 + 4 >> 2] = HEAP32[i224 >> 2];
 HEAP32[i268 + 8 >> 2] = HEAP32[i227 >> 2];
 HEAP32[i268 + 12 >> 2] = HEAP32[i228 >> 2];
 HEAP32[i268 + 16 >> 2] = HEAP32[i229 >> 2];
 HEAP32[i268 + 20 >> 2] = HEAP32[i230 >> 2];
 HEAP32[i268 + 24 >> 2] = HEAP32[i231 >> 2];
 HEAP32[i268 + 56 >> 2] = HEAP32[i232 >> 2];
 HEAP32[i268 + 60 >> 2] = HEAP32[i233 >> 2];
 HEAP32[i268 + 64 >> 2] = HEAP32[i234 >> 2];
 HEAP32[i268 + 68 >> 2] = HEAP32[i235 >> 2];
 HEAP32[i268 + 72 >> 2] = HEAP32[i236 >> 2];
 HEAP32[i268 + 76 >> 2] = HEAP32[i237 >> 2];
 HEAP32[i268 + 80 >> 2] = HEAP32[i238 >> 2];
 HEAP32[i268 + 112 >> 2] = HEAP32[i240 >> 2];
 HEAP32[i268 + 116 >> 2] = HEAP32[i241 >> 2];
 HEAP32[i268 + 120 >> 2] = HEAP32[i242 >> 2];
 HEAP32[i268 + 124 >> 2] = HEAP32[i243 >> 2];
 HEAP32[i268 + 128 >> 2] = HEAP32[i244 >> 2];
 HEAP32[i268 + 132 >> 2] = HEAP32[i245 >> 2];
 HEAP32[i268 + 136 >> 2] = HEAP32[i246 >> 2];
 HEAP32[i268 + 168 >> 2] = HEAP32[i247 >> 2];
 HEAP32[i268 + 172 >> 2] = HEAP32[i248 >> 2];
 HEAP32[i268 + 176 >> 2] = HEAP32[i249 >> 2];
 HEAP32[i268 + 180 >> 2] = HEAP32[i250 >> 2];
 HEAP32[i268 + 184 >> 2] = HEAP32[i251 >> 2];
 HEAP32[i268 + 188 >> 2] = HEAP32[i252 >> 2];
 HEAP32[i268 + 192 >> 2] = HEAP32[i253 >> 2];
 if (i3 >>> 0 > 1) {
  i1 = i259 + 4 | 0;
  i2 = i259 + 8 | 0;
  i4 = i259 + 12 | 0;
  i6 = i259 + 16 | 0;
  i7 = i259 + 20 | 0;
  i8 = i259 + 24 | 0;
  i9 = i259 + 28 | 0;
  i10 = i259 + 32 | 0;
  i11 = i259 + 36 | 0;
  i12 = i259 + 40 | 0;
  i13 = i259 + 44 | 0;
  i14 = i259 + 48 | 0;
  i15 = i259 + 52 | 0;
  i16 = i259 + 56 | 0;
  i17 = i259 + 60 | 0;
  i18 = i259 + 64 | 0;
  i19 = i259 + 68 | 0;
  i20 = i259 + 72 | 0;
  i21 = i259 + 76 | 0;
  i22 = i259 + 80 | 0;
  i23 = i259 + 84 | 0;
  i24 = i259 + 88 | 0;
  i25 = i259 + 92 | 0;
  i26 = i259 + 96 | 0;
  i27 = i259 + 100 | 0;
  i28 = i259 + 104 | 0;
  i29 = i259 + 108 | 0;
  i30 = i259 + 16 | 0;
  i31 = i259 + 44 | 0;
  i32 = i259 + 72 | 0;
  i33 = i259 + 100 | 0;
  i34 = 1;
  do {
   HEAPF32[i259 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i4 >> 2] = Math_fround(1.0);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAP32[i6 + 16 >> 2] = 0;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAPF32[i12 >> 2] = Math_fround(1.0);
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i13 + 12 >> 2] = 0;
   HEAP32[i13 + 16 >> 2] = 0;
   HEAP32[i13 + 20 >> 2] = 0;
   HEAPF32[i19 >> 2] = Math_fround(1.0);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   HEAP32[i20 + 12 >> 2] = 0;
   HEAP32[i20 + 16 >> 2] = 0;
   HEAP32[i20 + 20 >> 2] = 0;
   HEAPF32[i26 >> 2] = Math_fround(1.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   i251 = i34 << 2;
   __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i255 + (i34 * 944 | 0) | 0, i5 + (i34 * 224 | 0) | 0, i263 + (i251 * 148 | 0) | 0, HEAP32[i258 + (i34 << 2) >> 2] | 0, i257, i259);
   HEAP32[i263 + (i251 * 148 | 0) + 120 >> 2] = HEAP32[i259 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 124 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 128 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 132 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 136 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 140 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i263 + (i251 * 148 | 0) + 144 >> 2] = HEAP32[i8 >> 2];
   i252 = i251 | 1;
   HEAP32[i263 + (i252 * 148 | 0) + 120 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 124 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 128 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 132 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 136 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 140 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i263 + (i252 * 148 | 0) + 144 >> 2] = HEAP32[i15 >> 2];
   i253 = i251 | 2;
   HEAP32[i263 + (i253 * 148 | 0) + 120 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 124 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 128 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 132 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 136 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 140 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i263 + (i253 * 148 | 0) + 144 >> 2] = HEAP32[i22 >> 2];
   i268 = i251 | 3;
   HEAP32[i263 + (i268 * 148 | 0) + 120 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 124 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 128 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 132 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 136 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 140 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i263 + (i268 * 148 | 0) + 144 >> 2] = HEAP32[i29 >> 2];
   i254 = HEAP32[i262 >> 2] | 0;
   HEAP32[i254 + (i251 * 56 | 0) >> 2] = HEAP32[i259 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 16 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 20 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i254 + (i251 * 56 | 0) + 24 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) >> 2] = HEAP32[i9 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 8 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 12 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 20 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i254 + (i252 * 56 | 0) + 24 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 4 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 8 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 12 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 16 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 20 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i254 + (i253 * 56 | 0) + 24 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) >> 2] = HEAP32[i23 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 4 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 8 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 12 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 16 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 20 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i254 + (i268 * 56 | 0) + 24 >> 2] = HEAP32[i29 >> 2];
   i34 = i34 + 1 | 0;
  } while ((i34 | 0) != (i3 | 0));
 }
 if (i260 | 0) {
  i1 = HEAP32[i260 >> 2] | 0;
  if (i1 | 0) _memcpy(i1 | 0, i263 | 0, i256 * 148 | 0) | 0;
 }
 if (!i265) {
  HEAP32[i261 >> 2] = i264;
  __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i262, 1, i261);
 } else {
  _memcpy(HEAP32[i265 >> 2] | 0, HEAP32[i262 >> 2] | 0, i256 * 56 | 0) | 0;
  HEAP32[i265 + 8 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i265 + 12 >> 2] = HEAP32[i262 + 12 >> 2];
  HEAP32[i265 + 16 >> 2] = HEAP32[i262 + 16 >> 2];
  HEAP32[i265 + 20 >> 2] = HEAP32[i262 + 20 >> 2];
  HEAP32[i265 + 24 >> 2] = HEAP32[i262 + 24 >> 2];
  HEAP32[i265 + 28 >> 2] = HEAP32[i262 + 28 >> 2];
  i268 = HEAP16[i262 + 32 >> 1] | 0;
  HEAP8[i265 + 32 >> 0] = i268;
  HEAP8[i265 + 33 >> 0] = (i268 & 65535) >>> 8;
 }
 STACKTOP = i266;
 return;
}

function __ZL21computeMassAndInertiabRN5physx11PxRigidBodyEPKfS3_jbRNS_3Ext21InertiaTensorComputerE(i173, i1, i2, i172, i160, i4, i174) {
 i173 = i173 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i172 = i172 | 0;
 i160 = i160 | 0;
 i4 = i4 | 0;
 i174 = i174 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, f189 = f0, f190 = f0, f191 = f0;
 i180 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i171 = i180 + 24 | 0;
 i170 = i180 + 16 | 0;
 i169 = i180 + 8 | 0;
 i3 = i180;
 i151 = i180 + 496 | 0;
 i152 = i180 + 456 | 0;
 i153 = i180 + 440 | 0;
 i179 = i180 + 352 | 0;
 i150 = i180 + 492 | 0;
 i165 = i180 + 248 | 0;
 i161 = i180 + 432 | 0;
 i166 = i180 + 320 | 0;
 i162 = i180 + 304 | 0;
 i167 = i180 + 220 | 0;
 i163 = i180 + 172 | 0;
 i168 = i180 + 108 | 0;
 i164 = i180 + 184 | 0;
 i159 = i180 + 104 | 0;
 i158 = i180 + 136 | 0;
 i157 = i180 + 92 | 0;
 i154 = i180 + 56 | 0;
 i155 = i180 + 28 | 0;
 i178 = i179 + 64 | 0;
 i176 = i179 + 68 | 0;
 i156 = i179 + 72 | 0;
 HEAP32[i156 >> 2] = 0;
 i177 = i179 + 76 | 0;
 HEAP8[i178 >> 0] = 1;
 HEAP32[i176 >> 2] = i179;
 HEAP32[i177 >> 2] = 16;
 i149 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i150 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i179, i149, i150);
 mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, HEAP32[i176 >> 2] | 0, HEAP32[i156 >> 2] | 0, 0) | 0;
 i150 = (i2 | 0) != 0;
 i149 = i150 ? i2 : i172;
 f8 = Math_fround(HEAPF32[i149 >> 2]);
 L1 : do if (((HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040) {
  do if (!(HEAP32[i156 >> 2] | 0)) {
   i14 = 0;
   i13 = 0;
   i12 = 0;
   i11 = 0;
   i10 = 0;
   i9 = 0;
   i7 = 0;
   i6 = 0;
   i5 = 0;
   i4 = 0;
   i3 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   i74 = i161 + 4 | 0;
   i75 = i165 + 48 | 0;
   i76 = i165 + 4 | 0;
   i77 = i165 + 8 | 0;
   i78 = i165 + 12 | 0;
   i79 = i165 + 16 | 0;
   i80 = i165 + 20 | 0;
   i81 = i165 + 24 | 0;
   i82 = i165 + 28 | 0;
   i83 = i165 + 32 | 0;
   i84 = i165 + 36 | 0;
   i85 = i165 + 40 | 0;
   i86 = i165 + 44 | 0;
   i87 = i166 + 4 | 0;
   i88 = i166 + 8 | 0;
   i89 = i166 + 12 | 0;
   i90 = i151 + 4 | 0;
   i91 = i151 + 8 | 0;
   i92 = i151 + 12 | 0;
   i93 = i151 + 16 | 0;
   i94 = i151 + 20 | 0;
   i95 = i151 + 24 | 0;
   i96 = i151 + 28 | 0;
   i97 = i151 + 32 | 0;
   i98 = i166 + 16 | 0;
   i99 = i165 + 12 | 0;
   i100 = i165 + 24 | 0;
   i101 = i165 + 36 | 0;
   i102 = i162 + 4 | 0;
   i103 = i162 + 8 | 0;
   i104 = i162 + 12 | 0;
   i105 = i167 + 4 | 0;
   i106 = i167 + 8 | 0;
   i107 = i167 + 12 | 0;
   i108 = i151 + 4 | 0;
   i109 = i151 + 8 | 0;
   i110 = i151 + 12 | 0;
   i111 = i151 + 16 | 0;
   i112 = i151 + 20 | 0;
   i113 = i151 + 24 | 0;
   i114 = i151 + 28 | 0;
   i115 = i151 + 32 | 0;
   i116 = i167 + 16 | 0;
   i117 = i163 + 4 | 0;
   i118 = i163 + 8 | 0;
   i119 = i168 + 4 | 0;
   i120 = i168 + 8 | 0;
   i121 = i168 + 12 | 0;
   i122 = i151 + 4 | 0;
   i123 = i151 + 8 | 0;
   i124 = i151 + 12 | 0;
   i125 = i151 + 16 | 0;
   i126 = i151 + 20 | 0;
   i127 = i151 + 24 | 0;
   i128 = i151 + 28 | 0;
   i129 = i151 + 32 | 0;
   i130 = i168 + 16 | 0;
   i131 = i164 + 4 | 0;
   i132 = i164 + 8 | 0;
   i133 = i164 + 12 | 0;
   i134 = i164 + 16 | 0;
   i135 = i164 + 20 | 0;
   i136 = i164 + 24 | 0;
   i137 = i164 + 28 | 0;
   i138 = i164 + 32 | 0;
   i139 = i164 + 4 | 0;
   i140 = i158 + 4 | 0;
   i141 = i158 + 8 | 0;
   i142 = i158 + 12 | 0;
   i143 = i158 + 16 | 0;
   i144 = i158 + 20 | 0;
   i145 = i158 + 24 | 0;
   i146 = i158 + 28 | 0;
   i147 = i158 + 32 | 0;
   i148 = i157 + 4 | 0;
   i36 = i157 + 8 | 0;
   i37 = i155 + 4 | 0;
   i38 = i155 + 8 | 0;
   i39 = i155 + 12 | 0;
   i40 = i151 + 4 | 0;
   i41 = i151 + 8 | 0;
   i42 = i151 + 12 | 0;
   i43 = i151 + 16 | 0;
   i44 = i151 + 20 | 0;
   i45 = i151 + 24 | 0;
   i46 = i151 + 28 | 0;
   i47 = i151 + 32 | 0;
   i48 = i155 + 16 | 0;
   i49 = i164 + 16 | 0;
   i54 = i151 + 12 | 0;
   i50 = i54 + 4 | 0;
   i51 = i151 + 24 + 8 | 0;
   i52 = i151 + 4 | 0;
   i53 = i151 + 8 | 0;
   i54 = i54 + 8 | 0;
   i55 = i152 + 4 | 0;
   i56 = i152 + 8 | 0;
   i57 = i152 + 12 | 0;
   i58 = i152 + 16 | 0;
   i59 = i152 + 20 | 0;
   i60 = i152 + 24 | 0;
   i61 = i152 + 28 | 0;
   i62 = i152 + 32 | 0;
   i63 = i153 + 4 | 0;
   i64 = i153 + 8 | 0;
   i65 = i153 + 12 | 0;
   i66 = i154 + 4 | 0;
   i67 = i154 + 8 | 0;
   i68 = i154 + 12 | 0;
   i69 = i154 + 16 | 0;
   i70 = i154 + 20 | 0;
   i71 = i154 + 24 | 0;
   i72 = i154 + 28 | 0;
   i73 = i154 + 32 | 0;
   L5 : do if (i4) {
    i1 = 0;
    i12 = 0;
    i13 = 0;
    i14 = 0;
    i11 = 0;
    i10 = 0;
    i9 = 0;
    i7 = 0;
    i15 = 0;
    i5 = 0;
    i4 = 0;
    i3 = 0;
    i2 = 0;
    i35 = 0;
    i6 = 0;
    while (1) {
     i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 136 >> 2] | 0, i26 | 0) | 0;
     if (i173) {
      if (i6 >>> 0 >= i160 >>> 0) {
       i175 = 28;
       break L5;
      }
      f8 = Math_fround(HEAPF32[i149 + (i6 << 2) >> 2]);
      if (((HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 >= 2139095040) {
       i175 = 27;
       break L5;
      }
     }
     i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
     switch (mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 24 >> 2] | 0, i26 | 0) | 0) {
     case 0:
      {
       HEAP32[i161 >> 2] = 0;
       HEAPF32[i74 >> 2] = Math_fround(0.0);
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, i161 | 0) | 0;
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 72 >> 2] | 0, i166 | 0, i26 | 0);
       f30 = Math_fround(HEAPF32[i74 >> 2]);
       f16 = Math_fround(f30 * Math_fround(f30 * Math_fround(f30 * Math_fround(4.18879032))));
       f30 = Math_fround(Math_fround(f30 * Math_fround(f30 * f16)) * Math_fround(.400000006));
       HEAPF32[i75 >> 2] = f16;
       HEAPF32[i165 >> 2] = f30;
       HEAP32[i76 >> 2] = 0;
       HEAP32[i77 >> 2] = 0;
       HEAP32[i78 >> 2] = 0;
       HEAPF32[i79 >> 2] = f30;
       HEAP32[i80 >> 2] = 0;
       HEAP32[i81 >> 2] = 0;
       HEAP32[i82 >> 2] = 0;
       HEAPF32[i83 >> 2] = f30;
       HEAP32[i84 >> 2] = 0;
       HEAP32[i85 >> 2] = 0;
       HEAP32[i86 >> 2] = 0;
       f30 = Math_fround(HEAPF32[i166 >> 2]);
       f16 = Math_fround(HEAPF32[i87 >> 2]);
       f29 = Math_fround(HEAPF32[i88 >> 2]);
       f17 = Math_fround(HEAPF32[i89 >> 2]);
       f33 = Math_fround(f30 + f30);
       f32 = Math_fround(f16 + f16);
       f181 = Math_fround(f29 + f29);
       f30 = Math_fround(f30 * f33);
       f34 = Math_fround(f16 * f32);
       f27 = Math_fround(f29 * f181);
       f16 = Math_fround(f33 * f16);
       f31 = Math_fround(f33 * f29);
       f33 = Math_fround(f33 * f17);
       f29 = Math_fround(f32 * f29);
       f32 = Math_fround(f32 * f17);
       f17 = Math_fround(f181 * f17);
       f181 = Math_fround(f16 + f17);
       f28 = Math_fround(f31 - f32);
       HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f34) - f27);
       HEAPF32[i90 >> 2] = f181;
       HEAPF32[i91 >> 2] = f28;
       f30 = Math_fround(Math_fround(1.0) - f30);
       f27 = Math_fround(f30 - f27);
       f28 = Math_fround(f29 + f33);
       HEAPF32[i92 >> 2] = Math_fround(f16 - f17);
       HEAPF32[i93 >> 2] = f27;
       HEAPF32[i94 >> 2] = f28;
       f33 = Math_fround(f29 - f33);
       f34 = Math_fround(f30 - f34);
       HEAPF32[i95 >> 2] = Math_fround(f31 + f32);
       HEAPF32[i96 >> 2] = f33;
       HEAPF32[i97 >> 2] = f34;
       __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
       __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i98);
       break;
      }
     case 3:
      {
       HEAP32[i162 >> 2] = 3;
       HEAPF32[i102 >> 2] = Math_fround(0.0);
       HEAPF32[i103 >> 2] = Math_fround(0.0);
       HEAPF32[i104 >> 2] = Math_fround(0.0);
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0, i26 | 0, i162 | 0) | 0;
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 72 >> 2] | 0, i167 | 0, i26 | 0);
       f33 = Math_fround(HEAPF32[i102 >> 2]);
       i26 = f33 != Math_fround(0.0);
       f27 = i26 ? f33 : Math_fround(1.0);
       f34 = Math_fround(HEAPF32[i103 >> 2]);
       i26 = f34 != Math_fround(0.0);
       f17 = Math_fround(f34 * f27);
       f27 = i26 ? f17 : f27;
       f17 = Math_fround(HEAPF32[i104 >> 2]);
       i26 = f17 != Math_fround(0.0);
       f31 = Math_fround(f17 * f27);
       f27 = Math_fround((i26 ? f31 : f27) * Math_fround(8.0));
       f31 = Math_fround(f27 * Math_fround(.333333343));
       f33 = Math_fround(f33 * f33);
       f34 = Math_fround(f34 * f34);
       f17 = Math_fround(f17 * f17);
       f30 = Math_fround(Math_fround(f34 + f17) * f31);
       f17 = Math_fround(Math_fround(f33 + f17) * f31);
       f31 = Math_fround(Math_fround(f33 + f34) * f31);
       HEAPF32[i75 >> 2] = f27;
       HEAPF32[i165 >> 2] = f30;
       HEAP32[i76 >> 2] = 0;
       HEAP32[i77 >> 2] = 0;
       HEAP32[i78 >> 2] = 0;
       HEAPF32[i79 >> 2] = f17;
       HEAP32[i80 >> 2] = 0;
       HEAP32[i81 >> 2] = 0;
       HEAP32[i82 >> 2] = 0;
       HEAPF32[i83 >> 2] = f31;
       HEAP32[i84 >> 2] = 0;
       HEAP32[i85 >> 2] = 0;
       HEAP32[i86 >> 2] = 0;
       f31 = Math_fround(HEAPF32[i167 >> 2]);
       f17 = Math_fround(HEAPF32[i105 >> 2]);
       f30 = Math_fround(HEAPF32[i106 >> 2]);
       f27 = Math_fround(HEAPF32[i107 >> 2]);
       f34 = Math_fround(f31 + f31);
       f33 = Math_fround(f17 + f17);
       f16 = Math_fround(f30 + f30);
       f31 = Math_fround(f31 * f34);
       f181 = Math_fround(f17 * f33);
       f28 = Math_fround(f30 * f16);
       f17 = Math_fround(f34 * f17);
       f32 = Math_fround(f34 * f30);
       f34 = Math_fround(f34 * f27);
       f30 = Math_fround(f33 * f30);
       f33 = Math_fround(f33 * f27);
       f27 = Math_fround(f16 * f27);
       f16 = Math_fround(f17 + f27);
       f29 = Math_fround(f32 - f33);
       HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f181) - f28);
       HEAPF32[i108 >> 2] = f16;
       HEAPF32[i109 >> 2] = f29;
       f31 = Math_fround(Math_fround(1.0) - f31);
       f28 = Math_fround(f31 - f28);
       f29 = Math_fround(f30 + f34);
       HEAPF32[i110 >> 2] = Math_fround(f17 - f27);
       HEAPF32[i111 >> 2] = f28;
       HEAPF32[i112 >> 2] = f29;
       f34 = Math_fround(f30 - f34);
       f181 = Math_fround(f31 - f181);
       HEAPF32[i113 >> 2] = Math_fround(f32 + f33);
       HEAPF32[i114 >> 2] = f34;
       HEAPF32[i115 >> 2] = f181;
       __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
       __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i116);
       break;
      }
     case 2:
      {
       HEAP32[i163 >> 2] = 2;
       HEAPF32[i117 >> 2] = Math_fround(0.0);
       HEAPF32[i118 >> 2] = Math_fround(0.0);
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 44 >> 2] | 0, i26 | 0, i163 | 0) | 0;
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 72 >> 2] | 0, i168 | 0, i26 | 0);
       f34 = Math_fround(HEAPF32[i117 >> 2]);
       f30 = Math_fround(HEAPF32[i118 >> 2]);
       f27 = Math_fround(f34 * Math_fround(f34 * Math_fround(3.14159274)));
       f33 = Math_fround(Math_fround(Math_fround(f34 * Math_fround(f34 * f34)) * Math_fround(8.0)) / Math_fround(15.0));
       f31 = Math_fround(f34 * Math_fround(f34 * f30));
       f17 = Math_fround(f27 * Math_fround(f33 + f31));
       f16 = Math_fround(f30 * f30);
       f31 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(Math_fround(f30 * f16) * Math_fround(2.0)) / Math_fround(3.0)) + Math_fround(Math_fround(Math_fround(Math_fround(f34 * f16) * Math_fround(4.0)) / Math_fround(3.0)) + Math_fround(f33 + Math_fround(Math_fround(f31 * Math_fround(3.0)) * Math_fround(.5))))));
       HEAPF32[i75 >> 2] = Math_fround(Math_fround(f34 * Math_fround(f34 * Math_fround(f34 * Math_fround(4.18879032)))) + Math_fround(f27 * Math_fround(f30 * Math_fround(2.0))));
       HEAPF32[i165 >> 2] = f17;
       HEAP32[i76 >> 2] = 0;
       HEAP32[i77 >> 2] = 0;
       HEAP32[i78 >> 2] = 0;
       HEAPF32[i79 >> 2] = f31;
       HEAP32[i80 >> 2] = 0;
       HEAP32[i81 >> 2] = 0;
       HEAP32[i82 >> 2] = 0;
       HEAPF32[i83 >> 2] = f31;
       HEAP32[i84 >> 2] = 0;
       HEAP32[i85 >> 2] = 0;
       HEAP32[i86 >> 2] = 0;
       f31 = Math_fround(HEAPF32[i168 >> 2]);
       f17 = Math_fround(HEAPF32[i119 >> 2]);
       f30 = Math_fround(HEAPF32[i120 >> 2]);
       f27 = Math_fround(HEAPF32[i121 >> 2]);
       f34 = Math_fround(f31 + f31);
       f33 = Math_fround(f17 + f17);
       f16 = Math_fround(f30 + f30);
       f31 = Math_fround(f31 * f34);
       f181 = Math_fround(f17 * f33);
       f28 = Math_fround(f30 * f16);
       f17 = Math_fround(f34 * f17);
       f32 = Math_fround(f34 * f30);
       f34 = Math_fround(f34 * f27);
       f30 = Math_fround(f33 * f30);
       f33 = Math_fround(f33 * f27);
       f27 = Math_fround(f16 * f27);
       f16 = Math_fround(f17 + f27);
       f29 = Math_fround(f32 - f33);
       HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f181) - f28);
       HEAPF32[i122 >> 2] = f16;
       HEAPF32[i123 >> 2] = f29;
       f31 = Math_fround(Math_fround(1.0) - f31);
       f28 = Math_fround(f31 - f28);
       f29 = Math_fround(f30 + f34);
       HEAPF32[i124 >> 2] = Math_fround(f17 - f27);
       HEAPF32[i125 >> 2] = f28;
       HEAPF32[i126 >> 2] = f29;
       f34 = Math_fround(f30 - f34);
       f181 = Math_fround(f31 - f181);
       HEAPF32[i127 >> 2] = Math_fround(f32 + f33);
       HEAPF32[i128 >> 2] = f34;
       HEAPF32[i129 >> 2] = f181;
       __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
       __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i130);
       break;
      }
     case 4:
      {
       HEAP32[i164 >> 2] = 4;
       HEAPF32[i131 >> 2] = Math_fround(1.0);
       HEAPF32[i132 >> 2] = Math_fround(1.0);
       HEAPF32[i133 >> 2] = Math_fround(1.0);
       HEAPF32[i134 >> 2] = Math_fround(0.0);
       HEAPF32[i135 >> 2] = Math_fround(0.0);
       HEAPF32[i136 >> 2] = Math_fround(0.0);
       HEAPF32[i137 >> 2] = Math_fround(1.0);
       HEAP32[i138 >> 2] = 0;
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 52 >> 2] | 0, i26 | 0, i164 | 0) | 0;
       i26 = HEAP32[i138 >> 2] | 0;
       mftCall_viiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 48 >> 2] | 0, i26 | 0, i159 | 0, i158 | 0, i157 | 0);
       f17 = Math_fround(HEAPF32[i139 >> 2]);
       i26 = f17 == Math_fround(1.0);
       f16 = Math_fround(HEAPF32[i132 >> 2]);
       if (i26 & f16 == Math_fround(1.0)) if (Math_fround(HEAPF32[i133 >> 2]) == Math_fround(1.0)) {
        i18 = HEAP32[i158 >> 2] | 0;
        i19 = HEAP32[i140 >> 2] | 0;
        i20 = HEAP32[i141 >> 2] | 0;
        i21 = HEAP32[i142 >> 2] | 0;
        i22 = HEAP32[i143 >> 2] | 0;
        i23 = HEAP32[i144 >> 2] | 0;
        i24 = HEAP32[i145 >> 2] | 0;
        i25 = HEAP32[i146 >> 2] | 0;
        i26 = HEAP32[i147 >> 2] | 0;
       } else {
        f16 = Math_fround(1.0);
        i175 = 11;
       } else i175 = 11;
       if ((i175 | 0) == 11) {
        i175 = 0;
        f33 = Math_fround(f17 * f16);
        f184 = Math_fround(HEAPF32[i133 >> 2]);
        f33 = Math_fround(f33 * f184);
        HEAPF32[i159 >> 2] = Math_fround(Math_fround(HEAPF32[i159 >> 2]) * f33);
        f33 = Math_fround(Math_fround(HEAPF32[i157 >> 2]) * Math_fround(2.0));
        f31 = Math_fround(Math_fround(HEAPF32[i148 >> 2]) * Math_fround(2.0));
        f183 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(2.0));
        f30 = Math_fround(HEAPF32[i137 >> 2]);
        f27 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
        f182 = Math_fround(HEAPF32[i49 >> 2]);
        f34 = Math_fround(f33 * f182);
        f28 = Math_fround(HEAPF32[i135 >> 2]);
        f34 = Math_fround(f34 + Math_fround(f31 * f28));
        f29 = Math_fround(HEAPF32[i136 >> 2]);
        f34 = Math_fround(f34 + Math_fround(f183 * f29));
        f181 = Math_fround(Math_fround(f17 * Math_fround(Math_fround(f182 * f34) + Math_fround(Math_fround(f33 * f27) + Math_fround(f30 * Math_fround(Math_fround(f183 * f28) - Math_fround(f31 * f29)))))) * Math_fround(2.0));
        f32 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(f28 * f34) + Math_fround(Math_fround(f31 * f27) + Math_fround(f30 * Math_fround(Math_fround(f33 * f29) - Math_fround(f183 * f182)))))) * Math_fround(2.0));
        f34 = Math_fround(Math_fround(f184 * Math_fround(Math_fround(Math_fround(f183 * f27) + Math_fround(f30 * Math_fround(Math_fround(f31 * f182) - Math_fround(f33 * f28)))) + Math_fround(f29 * f34))) * Math_fround(2.0));
        f17 = Math_fround(Math_fround(f29 * f34) + Math_fround(Math_fround(f182 * f181) + Math_fround(f28 * f32)));
        f33 = Math_fround(Math_fround(f28 * f17) + Math_fround(Math_fround(f27 * f32) - Math_fround(f30 * Math_fround(Math_fround(f29 * f181) - Math_fround(f182 * f34)))));
        f31 = Math_fround(Math_fround(Math_fround(f27 * f34) - Math_fround(f30 * Math_fround(Math_fround(f182 * f32) - Math_fround(f28 * f181)))) + Math_fround(f29 * f17));
        HEAPF32[i157 >> 2] = Math_fround(Math_fround(f182 * f17) + Math_fround(Math_fround(f27 * f181) - Math_fround(f30 * Math_fround(Math_fround(f28 * f34) - Math_fround(f29 * f32)))));
        HEAPF32[i148 >> 2] = f33;
        HEAPF32[i36 >> 2] = f31;
        __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE(i151, i158, i49);
        f31 = Math_fround(HEAPF32[i151 >> 2]);
        f33 = Math_fround(HEAPF32[i50 >> 2]);
        f32 = Math_fround(HEAPF32[i51 >> 2]);
        f29 = Math_fround(Math_fround(Math_fround(f31 * Math_fround(.5)) + Math_fround(f33 * Math_fround(.5))) + Math_fround(f32 * Math_fround(.5)));
        f31 = Math_fround(f29 - f31);
        f33 = Math_fround(f29 - f33);
        f32 = Math_fround(f29 - f32);
        f29 = Math_fround(HEAPF32[i139 >> 2]);
        f31 = Math_fround(f29 * f31);
        f34 = Math_fround(HEAPF32[i132 >> 2]);
        f33 = Math_fround(f34 * f33);
        f28 = Math_fround(HEAPF32[i133 >> 2]);
        f31 = Math_fround(f29 * f31);
        f33 = Math_fround(f34 * f33);
        f32 = Math_fround(f28 * Math_fround(f32 * f28));
        f30 = Math_fround(f33 + f32);
        f32 = Math_fround(f32 + f31);
        f33 = Math_fround(f31 + f33);
        f31 = Math_fround(f34 * Math_fround(f29 * Math_fround(HEAPF32[i52 >> 2])));
        f181 = Math_fround(f28 * Math_fround(f29 * Math_fround(HEAPF32[i53 >> 2])));
        f29 = Math_fround(Math_fround(f29 * f34) * f28);
        f31 = Math_fround(f29 * f31);
        f181 = Math_fround(f29 * f181);
        f32 = Math_fround(f29 * f32);
        f34 = Math_fround(f29 * Math_fround(f28 * Math_fround(f34 * Math_fround(HEAPF32[i54 >> 2]))));
        f33 = Math_fround(f29 * f33);
        HEAPF32[i152 >> 2] = Math_fround(f29 * f30);
        HEAPF32[i55 >> 2] = f31;
        HEAPF32[i56 >> 2] = f181;
        HEAPF32[i57 >> 2] = f31;
        HEAPF32[i58 >> 2] = f32;
        HEAPF32[i59 >> 2] = f34;
        HEAPF32[i60 >> 2] = f181;
        HEAPF32[i61 >> 2] = f34;
        HEAPF32[i62 >> 2] = f33;
        f33 = Math_fround(-Math_fround(HEAPF32[i49 >> 2]));
        f34 = Math_fround(-Math_fround(HEAPF32[i135 >> 2]));
        f181 = Math_fround(-Math_fround(HEAPF32[i136 >> 2]));
        i18 = HEAP32[i137 >> 2] | 0;
        HEAPF32[i153 >> 2] = f33;
        HEAPF32[i63 >> 2] = f34;
        HEAPF32[i64 >> 2] = f181;
        HEAP32[i65 >> 2] = i18;
        __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE(i154, i152, i153);
        i18 = HEAP32[i154 >> 2] | 0;
        HEAP32[i158 >> 2] = i18;
        i19 = HEAP32[i66 >> 2] | 0;
        HEAP32[i140 >> 2] = i19;
        i20 = HEAP32[i67 >> 2] | 0;
        HEAP32[i141 >> 2] = i20;
        i21 = HEAP32[i68 >> 2] | 0;
        HEAP32[i142 >> 2] = i21;
        i22 = HEAP32[i69 >> 2] | 0;
        HEAP32[i143 >> 2] = i22;
        i23 = HEAP32[i70 >> 2] | 0;
        HEAP32[i144 >> 2] = i23;
        i24 = HEAP32[i71 >> 2] | 0;
        HEAP32[i145 >> 2] = i24;
        i25 = HEAP32[i72 >> 2] | 0;
        HEAP32[i146 >> 2] = i25;
        i26 = HEAP32[i73 >> 2] | 0;
        HEAP32[i147 >> 2] = i26;
       }
       i185 = HEAP32[i159 >> 2] | 0;
       i188 = HEAP32[i157 >> 2] | 0;
       i187 = HEAP32[i148 >> 2] | 0;
       i186 = HEAP32[i36 >> 2] | 0;
       HEAP32[i165 >> 2] = i18;
       HEAP32[i76 >> 2] = i19;
       HEAP32[i77 >> 2] = i20;
       HEAP32[i78 >> 2] = i21;
       HEAP32[i79 >> 2] = i22;
       HEAP32[i80 >> 2] = i23;
       HEAP32[i81 >> 2] = i24;
       HEAP32[i82 >> 2] = i25;
       HEAP32[i83 >> 2] = i26;
       HEAP32[i84 >> 2] = i188;
       HEAP32[i85 >> 2] = i187;
       HEAP32[i86 >> 2] = i186;
       HEAP32[i75 >> 2] = i185;
       i26 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 72 >> 2] | 0, i155 | 0, i26 | 0);
       f34 = Math_fround(HEAPF32[i155 >> 2]);
       f29 = Math_fround(HEAPF32[i37 >> 2]);
       f33 = Math_fround(HEAPF32[i38 >> 2]);
       f30 = Math_fround(HEAPF32[i39 >> 2]);
       f183 = Math_fround(f34 + f34);
       f182 = Math_fround(f29 + f29);
       f28 = Math_fround(f33 + f33);
       f34 = Math_fround(f34 * f183);
       f184 = Math_fround(f29 * f182);
       f31 = Math_fround(f33 * f28);
       f29 = Math_fround(f183 * f29);
       f181 = Math_fround(f183 * f33);
       f183 = Math_fround(f183 * f30);
       f33 = Math_fround(f182 * f33);
       f182 = Math_fround(f182 * f30);
       f30 = Math_fround(f28 * f30);
       f28 = Math_fround(f29 + f30);
       f32 = Math_fround(f181 - f182);
       HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f184) - f31);
       HEAPF32[i40 >> 2] = f28;
       HEAPF32[i41 >> 2] = f32;
       f34 = Math_fround(Math_fround(1.0) - f34);
       f31 = Math_fround(f34 - f31);
       f32 = Math_fround(f33 + f183);
       HEAPF32[i42 >> 2] = Math_fround(f29 - f30);
       HEAPF32[i43 >> 2] = f31;
       HEAPF32[i44 >> 2] = f32;
       f183 = Math_fround(f33 - f183);
       f184 = Math_fround(f34 - f184);
       HEAPF32[i45 >> 2] = Math_fround(f181 + f182);
       HEAPF32[i46 >> 2] = f183;
       HEAPF32[i47 >> 2] = f184;
       __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
       __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i48);
       break;
      }
     default:
      {
       i175 = 44;
       break L5;
      }
     }
     do if (i150) {
      f17 = Math_fround(f8 * Math_fround(HEAPF32[i165 >> 2]));
      HEAPF32[i165 >> 2] = f17;
      f27 = Math_fround(f8 * Math_fround(HEAPF32[i76 >> 2]));
      HEAPF32[i76 >> 2] = f27;
      f28 = Math_fround(f8 * Math_fround(HEAPF32[i77 >> 2]));
      HEAPF32[i77 >> 2] = f28;
      f29 = Math_fround(f8 * Math_fround(HEAPF32[i99 >> 2]));
      HEAPF32[i99 >> 2] = f29;
      f30 = Math_fround(f8 * Math_fround(HEAPF32[i79 >> 2]));
      HEAPF32[i79 >> 2] = f30;
      f31 = Math_fround(f8 * Math_fround(HEAPF32[i80 >> 2]));
      HEAPF32[i80 >> 2] = f31;
      f32 = Math_fround(f8 * Math_fround(HEAPF32[i100 >> 2]));
      HEAPF32[i100 >> 2] = f32;
      f33 = Math_fround(f8 * Math_fround(HEAPF32[i82 >> 2]));
      HEAPF32[i82 >> 2] = f33;
      f34 = Math_fround(f8 * Math_fround(HEAPF32[i83 >> 2]));
      HEAPF32[i83 >> 2] = f34;
      f16 = Math_fround(f8 * Math_fround(HEAPF32[i75 >> 2]));
      HEAPF32[i75 >> 2] = f16;
     } else {
      f16 = Math_fround(HEAPF32[i75 >> 2]);
      if (i173) {
       f184 = Math_fround(f8 / f16);
       f17 = Math_fround(f184 * Math_fround(HEAPF32[i165 >> 2]));
       HEAPF32[i165 >> 2] = f17;
       f27 = Math_fround(f184 * Math_fround(HEAPF32[i76 >> 2]));
       HEAPF32[i76 >> 2] = f27;
       f28 = Math_fround(f184 * Math_fround(HEAPF32[i77 >> 2]));
       HEAPF32[i77 >> 2] = f28;
       f29 = Math_fround(f184 * Math_fround(HEAPF32[i99 >> 2]));
       HEAPF32[i99 >> 2] = f29;
       f30 = Math_fround(f184 * Math_fround(HEAPF32[i79 >> 2]));
       HEAPF32[i79 >> 2] = f30;
       f31 = Math_fround(f184 * Math_fround(HEAPF32[i80 >> 2]));
       HEAPF32[i80 >> 2] = f31;
       f32 = Math_fround(f184 * Math_fround(HEAPF32[i100 >> 2]));
       HEAPF32[i100 >> 2] = f32;
       f33 = Math_fround(f184 * Math_fround(HEAPF32[i82 >> 2]));
       HEAPF32[i82 >> 2] = f33;
       f34 = Math_fround(f184 * Math_fround(HEAPF32[i83 >> 2]));
       HEAPF32[i83 >> 2] = f34;
       f16 = Math_fround(f184 * f16);
       HEAPF32[i75 >> 2] = f16;
       break;
      } else {
       f17 = Math_fround(HEAPF32[i165 >> 2]);
       f27 = Math_fround(HEAPF32[i76 >> 2]);
       f28 = Math_fround(HEAPF32[i77 >> 2]);
       f29 = Math_fround(HEAPF32[i99 >> 2]);
       f30 = Math_fround(HEAPF32[i79 >> 2]);
       f31 = Math_fround(HEAPF32[i80 >> 2]);
       f32 = Math_fround(HEAPF32[i100 >> 2]);
       f33 = Math_fround(HEAPF32[i82 >> 2]);
       f34 = Math_fround(HEAPF32[i83 >> 2]);
       break;
      }
     } while (0);
     f183 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f184 = Math_fround(f183 + f16);
     f191 = Math_fround(f183 * (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f190 = Math_fround(f183 * (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f183 = Math_fround(f183 * (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f181 = Math_fround(f16 * Math_fround(HEAPF32[i101 >> 2]));
     f182 = Math_fround(f16 * Math_fround(HEAPF32[i85 >> 2]));
     f189 = Math_fround(Math_fround(1.0) / f184);
     f181 = Math_fround(Math_fround(f191 + f181) * f189);
     f182 = Math_fround(f189 * Math_fround(f190 + f182));
     f183 = Math_fround(f189 * Math_fround(f183 + Math_fround(f16 * Math_fround(HEAPF32[i86 >> 2]))));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f181, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f17);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f27);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
     i15 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     f184 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = i6 + 1 | 0;
     i35 = i35 + 1 | 0;
     if (i35 >>> 0 >= (HEAP32[i156 >> 2] | 0) >>> 0) {
      i175 = 46;
      break L5;
     }
    }
   } else {
    i1 = 0;
    i12 = 0;
    i13 = 0;
    i14 = 0;
    i11 = 0;
    i10 = 0;
    i9 = 0;
    i7 = 0;
    i15 = 0;
    i5 = 0;
    i4 = 0;
    i3 = 0;
    i2 = 0;
    i35 = 0;
    i6 = 0;
    while (1) {
     i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
     if ((mftCall_ii(HEAP32[(HEAP32[i188 >> 2] | 0) + 136 >> 2] | 0, i188 | 0) | 0) & 1) {
      if (i173) {
       if (i6 >>> 0 >= i160 >>> 0) {
        i175 = 28;
        break L5;
       }
       f8 = Math_fround(HEAPF32[i149 + (i6 << 2) >> 2]);
       if (((HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 >= 2139095040) {
        i175 = 27;
        break L5;
       }
      }
      i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
      switch (mftCall_ii(HEAP32[(HEAP32[i188 >> 2] | 0) + 24 >> 2] | 0, i188 | 0) | 0) {
      case 0:
       {
        HEAP32[i161 >> 2] = 0;
        HEAPF32[i74 >> 2] = Math_fround(0.0);
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_iii(HEAP32[(HEAP32[i188 >> 2] | 0) + 40 >> 2] | 0, i188 | 0, i161 | 0) | 0;
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i188 >> 2] | 0) + 72 >> 2] | 0, i166 | 0, i188 | 0);
        f183 = Math_fround(HEAPF32[i74 >> 2]);
        f32 = Math_fround(f183 * Math_fround(f183 * Math_fround(f183 * Math_fround(4.18879032))));
        f183 = Math_fround(Math_fround(f183 * Math_fround(f183 * f32)) * Math_fround(.400000006));
        HEAPF32[i75 >> 2] = f32;
        HEAPF32[i165 >> 2] = f183;
        HEAP32[i76 >> 2] = 0;
        HEAP32[i77 >> 2] = 0;
        HEAP32[i78 >> 2] = 0;
        HEAPF32[i79 >> 2] = f183;
        HEAP32[i80 >> 2] = 0;
        HEAP32[i81 >> 2] = 0;
        HEAP32[i82 >> 2] = 0;
        HEAPF32[i83 >> 2] = f183;
        HEAP32[i84 >> 2] = 0;
        HEAP32[i85 >> 2] = 0;
        HEAP32[i86 >> 2] = 0;
        f183 = Math_fround(HEAPF32[i166 >> 2]);
        f32 = Math_fround(HEAPF32[i87 >> 2]);
        f182 = Math_fround(HEAPF32[i88 >> 2]);
        f33 = Math_fround(HEAPF32[i89 >> 2]);
        f190 = Math_fround(f183 + f183);
        f189 = Math_fround(f32 + f32);
        f31 = Math_fround(f182 + f182);
        f183 = Math_fround(f183 * f190);
        f191 = Math_fround(f32 * f189);
        f34 = Math_fround(f182 * f31);
        f32 = Math_fround(f190 * f32);
        f184 = Math_fround(f190 * f182);
        f190 = Math_fround(f190 * f33);
        f182 = Math_fround(f189 * f182);
        f189 = Math_fround(f189 * f33);
        f33 = Math_fround(f31 * f33);
        f31 = Math_fround(f32 + f33);
        f181 = Math_fround(f184 - f189);
        HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f191) - f34);
        HEAPF32[i90 >> 2] = f31;
        HEAPF32[i91 >> 2] = f181;
        f183 = Math_fround(Math_fround(1.0) - f183);
        f34 = Math_fround(f183 - f34);
        f181 = Math_fround(f182 + f190);
        HEAPF32[i92 >> 2] = Math_fround(f32 - f33);
        HEAPF32[i93 >> 2] = f34;
        HEAPF32[i94 >> 2] = f181;
        f190 = Math_fround(f182 - f190);
        f191 = Math_fround(f183 - f191);
        HEAPF32[i95 >> 2] = Math_fround(f184 + f189);
        HEAPF32[i96 >> 2] = f190;
        HEAPF32[i97 >> 2] = f191;
        __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
        __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i98);
        break;
       }
      case 3:
       {
        HEAP32[i162 >> 2] = 3;
        HEAPF32[i102 >> 2] = Math_fround(0.0);
        HEAPF32[i103 >> 2] = Math_fround(0.0);
        HEAPF32[i104 >> 2] = Math_fround(0.0);
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_iii(HEAP32[(HEAP32[i188 >> 2] | 0) + 36 >> 2] | 0, i188 | 0, i162 | 0) | 0;
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i188 >> 2] | 0) + 72 >> 2] | 0, i167 | 0, i188 | 0);
        f189 = Math_fround(HEAPF32[i102 >> 2]);
        i188 = f189 != Math_fround(0.0);
        f33 = i188 ? f189 : Math_fround(1.0);
        f190 = Math_fround(HEAPF32[i103 >> 2]);
        i188 = f190 != Math_fround(0.0);
        f32 = Math_fround(f190 * f33);
        f33 = i188 ? f32 : f33;
        f32 = Math_fround(HEAPF32[i104 >> 2]);
        i188 = f32 != Math_fround(0.0);
        f183 = Math_fround(f32 * f33);
        f33 = Math_fround((i188 ? f183 : f33) * Math_fround(8.0));
        f183 = Math_fround(f33 * Math_fround(.333333343));
        f189 = Math_fround(f189 * f189);
        f190 = Math_fround(f190 * f190);
        f32 = Math_fround(f32 * f32);
        f182 = Math_fround(Math_fround(f190 + f32) * f183);
        f32 = Math_fround(Math_fround(f189 + f32) * f183);
        f183 = Math_fround(Math_fround(f189 + f190) * f183);
        HEAPF32[i75 >> 2] = f33;
        HEAPF32[i165 >> 2] = f182;
        HEAP32[i76 >> 2] = 0;
        HEAP32[i77 >> 2] = 0;
        HEAP32[i78 >> 2] = 0;
        HEAPF32[i79 >> 2] = f32;
        HEAP32[i80 >> 2] = 0;
        HEAP32[i81 >> 2] = 0;
        HEAP32[i82 >> 2] = 0;
        HEAPF32[i83 >> 2] = f183;
        HEAP32[i84 >> 2] = 0;
        HEAP32[i85 >> 2] = 0;
        HEAP32[i86 >> 2] = 0;
        f183 = Math_fround(HEAPF32[i167 >> 2]);
        f32 = Math_fround(HEAPF32[i105 >> 2]);
        f182 = Math_fround(HEAPF32[i106 >> 2]);
        f33 = Math_fround(HEAPF32[i107 >> 2]);
        f190 = Math_fround(f183 + f183);
        f189 = Math_fround(f32 + f32);
        f31 = Math_fround(f182 + f182);
        f183 = Math_fround(f183 * f190);
        f191 = Math_fround(f32 * f189);
        f34 = Math_fround(f182 * f31);
        f32 = Math_fround(f190 * f32);
        f184 = Math_fround(f190 * f182);
        f190 = Math_fround(f190 * f33);
        f182 = Math_fround(f189 * f182);
        f189 = Math_fround(f189 * f33);
        f33 = Math_fround(f31 * f33);
        f31 = Math_fround(f32 + f33);
        f181 = Math_fround(f184 - f189);
        HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f191) - f34);
        HEAPF32[i108 >> 2] = f31;
        HEAPF32[i109 >> 2] = f181;
        f183 = Math_fround(Math_fround(1.0) - f183);
        f34 = Math_fround(f183 - f34);
        f181 = Math_fround(f182 + f190);
        HEAPF32[i110 >> 2] = Math_fround(f32 - f33);
        HEAPF32[i111 >> 2] = f34;
        HEAPF32[i112 >> 2] = f181;
        f190 = Math_fround(f182 - f190);
        f191 = Math_fround(f183 - f191);
        HEAPF32[i113 >> 2] = Math_fround(f184 + f189);
        HEAPF32[i114 >> 2] = f190;
        HEAPF32[i115 >> 2] = f191;
        __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
        __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i116);
        break;
       }
      case 2:
       {
        HEAP32[i163 >> 2] = 2;
        HEAPF32[i117 >> 2] = Math_fround(0.0);
        HEAPF32[i118 >> 2] = Math_fround(0.0);
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_iii(HEAP32[(HEAP32[i188 >> 2] | 0) + 44 >> 2] | 0, i188 | 0, i163 | 0) | 0;
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i188 >> 2] | 0) + 72 >> 2] | 0, i168 | 0, i188 | 0);
        f190 = Math_fround(HEAPF32[i117 >> 2]);
        f182 = Math_fround(HEAPF32[i118 >> 2]);
        f33 = Math_fround(f190 * Math_fround(f190 * Math_fround(3.14159274)));
        f189 = Math_fround(Math_fround(Math_fround(f190 * Math_fround(f190 * f190)) * Math_fround(8.0)) / Math_fround(15.0));
        f183 = Math_fround(f190 * Math_fround(f190 * f182));
        f32 = Math_fround(f33 * Math_fround(f189 + f183));
        f31 = Math_fround(f182 * f182);
        f183 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(Math_fround(f182 * f31) * Math_fround(2.0)) / Math_fround(3.0)) + Math_fround(Math_fround(Math_fround(Math_fround(f190 * f31) * Math_fround(4.0)) / Math_fround(3.0)) + Math_fround(f189 + Math_fround(Math_fround(f183 * Math_fround(3.0)) * Math_fround(.5))))));
        HEAPF32[i75 >> 2] = Math_fround(Math_fround(f190 * Math_fround(f190 * Math_fround(f190 * Math_fround(4.18879032)))) + Math_fround(f33 * Math_fround(f182 * Math_fround(2.0))));
        HEAPF32[i165 >> 2] = f32;
        HEAP32[i76 >> 2] = 0;
        HEAP32[i77 >> 2] = 0;
        HEAP32[i78 >> 2] = 0;
        HEAPF32[i79 >> 2] = f183;
        HEAP32[i80 >> 2] = 0;
        HEAP32[i81 >> 2] = 0;
        HEAP32[i82 >> 2] = 0;
        HEAPF32[i83 >> 2] = f183;
        HEAP32[i84 >> 2] = 0;
        HEAP32[i85 >> 2] = 0;
        HEAP32[i86 >> 2] = 0;
        f183 = Math_fround(HEAPF32[i168 >> 2]);
        f32 = Math_fround(HEAPF32[i119 >> 2]);
        f182 = Math_fround(HEAPF32[i120 >> 2]);
        f33 = Math_fround(HEAPF32[i121 >> 2]);
        f190 = Math_fround(f183 + f183);
        f189 = Math_fround(f32 + f32);
        f31 = Math_fround(f182 + f182);
        f183 = Math_fround(f183 * f190);
        f191 = Math_fround(f32 * f189);
        f34 = Math_fround(f182 * f31);
        f32 = Math_fround(f190 * f32);
        f184 = Math_fround(f190 * f182);
        f190 = Math_fround(f190 * f33);
        f182 = Math_fround(f189 * f182);
        f189 = Math_fround(f189 * f33);
        f33 = Math_fround(f31 * f33);
        f31 = Math_fround(f32 + f33);
        f181 = Math_fround(f184 - f189);
        HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f191) - f34);
        HEAPF32[i122 >> 2] = f31;
        HEAPF32[i123 >> 2] = f181;
        f183 = Math_fround(Math_fround(1.0) - f183);
        f34 = Math_fround(f183 - f34);
        f181 = Math_fround(f182 + f190);
        HEAPF32[i124 >> 2] = Math_fround(f32 - f33);
        HEAPF32[i125 >> 2] = f34;
        HEAPF32[i126 >> 2] = f181;
        f190 = Math_fround(f182 - f190);
        f191 = Math_fround(f183 - f191);
        HEAPF32[i127 >> 2] = Math_fround(f184 + f189);
        HEAPF32[i128 >> 2] = f190;
        HEAPF32[i129 >> 2] = f191;
        __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
        __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i130);
        break;
       }
      case 4:
       {
        HEAP32[i164 >> 2] = 4;
        HEAPF32[i131 >> 2] = Math_fround(1.0);
        HEAPF32[i132 >> 2] = Math_fround(1.0);
        HEAPF32[i133 >> 2] = Math_fround(1.0);
        HEAPF32[i134 >> 2] = Math_fround(0.0);
        HEAPF32[i135 >> 2] = Math_fround(0.0);
        HEAPF32[i136 >> 2] = Math_fround(0.0);
        HEAPF32[i137 >> 2] = Math_fround(1.0);
        HEAP32[i138 >> 2] = 0;
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_iii(HEAP32[(HEAP32[i188 >> 2] | 0) + 52 >> 2] | 0, i188 | 0, i164 | 0) | 0;
        i188 = HEAP32[i138 >> 2] | 0;
        mftCall_viiii(HEAP32[(HEAP32[i188 >> 2] | 0) + 48 >> 2] | 0, i188 | 0, i159 | 0, i158 | 0, i157 | 0);
        f17 = Math_fround(HEAPF32[i139 >> 2]);
        i188 = f17 == Math_fround(1.0);
        f16 = Math_fround(HEAPF32[i132 >> 2]);
        if (i188 & f16 == Math_fround(1.0)) if (Math_fround(HEAPF32[i133 >> 2]) == Math_fround(1.0)) {
         i18 = HEAP32[i158 >> 2] | 0;
         i19 = HEAP32[i140 >> 2] | 0;
         i20 = HEAP32[i141 >> 2] | 0;
         i21 = HEAP32[i142 >> 2] | 0;
         i22 = HEAP32[i143 >> 2] | 0;
         i23 = HEAP32[i144 >> 2] | 0;
         i24 = HEAP32[i145 >> 2] | 0;
         i25 = HEAP32[i146 >> 2] | 0;
         i26 = HEAP32[i147 >> 2] | 0;
        } else {
         f16 = Math_fround(1.0);
         i175 = 36;
        } else i175 = 36;
        if ((i175 | 0) == 36) {
         i175 = 0;
         f32 = Math_fround(f17 * f16);
         f30 = Math_fround(HEAPF32[i133 >> 2]);
         f32 = Math_fround(f32 * f30);
         HEAPF32[i159 >> 2] = Math_fround(Math_fround(HEAPF32[i159 >> 2]) * f32);
         f32 = Math_fround(Math_fround(HEAPF32[i157 >> 2]) * Math_fround(2.0));
         f189 = Math_fround(Math_fround(HEAPF32[i148 >> 2]) * Math_fround(2.0));
         f183 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(2.0));
         f182 = Math_fround(HEAPF32[i137 >> 2]);
         f33 = Math_fround(Math_fround(f182 * f182) + Math_fround(-.5));
         f31 = Math_fround(HEAPF32[i49 >> 2]);
         f190 = Math_fround(f32 * f31);
         f34 = Math_fround(HEAPF32[i135 >> 2]);
         f190 = Math_fround(f190 + Math_fround(f189 * f34));
         f181 = Math_fround(HEAPF32[i136 >> 2]);
         f190 = Math_fround(f190 + Math_fround(f183 * f181));
         f191 = Math_fround(Math_fround(f17 * Math_fround(Math_fround(f31 * f190) + Math_fround(Math_fround(f32 * f33) + Math_fround(f182 * Math_fround(Math_fround(f183 * f34) - Math_fround(f189 * f181)))))) * Math_fround(2.0));
         f184 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(f34 * f190) + Math_fround(Math_fround(f189 * f33) + Math_fround(f182 * Math_fround(Math_fround(f32 * f181) - Math_fround(f183 * f31)))))) * Math_fround(2.0));
         f190 = Math_fround(Math_fround(f30 * Math_fround(Math_fround(Math_fround(f183 * f33) + Math_fround(f182 * Math_fround(Math_fround(f189 * f31) - Math_fround(f32 * f34)))) + Math_fround(f181 * f190))) * Math_fround(2.0));
         f32 = Math_fround(Math_fround(f181 * f190) + Math_fround(Math_fround(f31 * f191) + Math_fround(f34 * f184)));
         f189 = Math_fround(Math_fround(f34 * f32) + Math_fround(Math_fround(f33 * f184) - Math_fround(f182 * Math_fround(Math_fround(f181 * f191) - Math_fround(f31 * f190)))));
         f183 = Math_fround(Math_fround(Math_fround(f33 * f190) - Math_fround(f182 * Math_fround(Math_fround(f31 * f184) - Math_fround(f34 * f191)))) + Math_fround(f181 * f32));
         HEAPF32[i157 >> 2] = Math_fround(Math_fround(f31 * f32) + Math_fround(Math_fround(f33 * f191) - Math_fround(f182 * Math_fround(Math_fround(f34 * f190) - Math_fround(f181 * f184)))));
         HEAPF32[i148 >> 2] = f189;
         HEAPF32[i36 >> 2] = f183;
         __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE(i151, i158, i49);
         f183 = Math_fround(HEAPF32[i151 >> 2]);
         f189 = Math_fround(HEAPF32[i50 >> 2]);
         f184 = Math_fround(HEAPF32[i51 >> 2]);
         f181 = Math_fround(Math_fround(Math_fround(f183 * Math_fround(.5)) + Math_fround(f189 * Math_fround(.5))) + Math_fround(f184 * Math_fround(.5)));
         f183 = Math_fround(f181 - f183);
         f189 = Math_fround(f181 - f189);
         f184 = Math_fround(f181 - f184);
         f181 = Math_fround(HEAPF32[i139 >> 2]);
         f183 = Math_fround(f181 * f183);
         f190 = Math_fround(HEAPF32[i132 >> 2]);
         f189 = Math_fround(f190 * f189);
         f34 = Math_fround(HEAPF32[i133 >> 2]);
         f183 = Math_fround(f181 * f183);
         f189 = Math_fround(f190 * f189);
         f184 = Math_fround(f34 * Math_fround(f184 * f34));
         f182 = Math_fround(f189 + f184);
         f184 = Math_fround(f184 + f183);
         f189 = Math_fround(f183 + f189);
         f183 = Math_fround(f190 * Math_fround(f181 * Math_fround(HEAPF32[i52 >> 2])));
         f191 = Math_fround(f34 * Math_fround(f181 * Math_fround(HEAPF32[i53 >> 2])));
         f181 = Math_fround(Math_fround(f181 * f190) * f34);
         f183 = Math_fround(f181 * f183);
         f191 = Math_fround(f181 * f191);
         f184 = Math_fround(f181 * f184);
         f190 = Math_fround(f181 * Math_fround(f34 * Math_fround(f190 * Math_fround(HEAPF32[i54 >> 2]))));
         f189 = Math_fround(f181 * f189);
         HEAPF32[i152 >> 2] = Math_fround(f181 * f182);
         HEAPF32[i55 >> 2] = f183;
         HEAPF32[i56 >> 2] = f191;
         HEAPF32[i57 >> 2] = f183;
         HEAPF32[i58 >> 2] = f184;
         HEAPF32[i59 >> 2] = f190;
         HEAPF32[i60 >> 2] = f191;
         HEAPF32[i61 >> 2] = f190;
         HEAPF32[i62 >> 2] = f189;
         f189 = Math_fround(-Math_fround(HEAPF32[i49 >> 2]));
         f190 = Math_fround(-Math_fround(HEAPF32[i135 >> 2]));
         f191 = Math_fround(-Math_fround(HEAPF32[i136 >> 2]));
         i18 = HEAP32[i137 >> 2] | 0;
         HEAPF32[i153 >> 2] = f189;
         HEAPF32[i63 >> 2] = f190;
         HEAPF32[i64 >> 2] = f191;
         HEAP32[i65 >> 2] = i18;
         __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE(i154, i152, i153);
         i18 = HEAP32[i154 >> 2] | 0;
         HEAP32[i158 >> 2] = i18;
         i19 = HEAP32[i66 >> 2] | 0;
         HEAP32[i140 >> 2] = i19;
         i20 = HEAP32[i67 >> 2] | 0;
         HEAP32[i141 >> 2] = i20;
         i21 = HEAP32[i68 >> 2] | 0;
         HEAP32[i142 >> 2] = i21;
         i22 = HEAP32[i69 >> 2] | 0;
         HEAP32[i143 >> 2] = i22;
         i23 = HEAP32[i70 >> 2] | 0;
         HEAP32[i144 >> 2] = i23;
         i24 = HEAP32[i71 >> 2] | 0;
         HEAP32[i145 >> 2] = i24;
         i25 = HEAP32[i72 >> 2] | 0;
         HEAP32[i146 >> 2] = i25;
         i26 = HEAP32[i73 >> 2] | 0;
         HEAP32[i147 >> 2] = i26;
        }
        i188 = HEAP32[i159 >> 2] | 0;
        i185 = HEAP32[i157 >> 2] | 0;
        i186 = HEAP32[i148 >> 2] | 0;
        i187 = HEAP32[i36 >> 2] | 0;
        HEAP32[i165 >> 2] = i18;
        HEAP32[i76 >> 2] = i19;
        HEAP32[i77 >> 2] = i20;
        HEAP32[i78 >> 2] = i21;
        HEAP32[i79 >> 2] = i22;
        HEAP32[i80 >> 2] = i23;
        HEAP32[i81 >> 2] = i24;
        HEAP32[i82 >> 2] = i25;
        HEAP32[i83 >> 2] = i26;
        HEAP32[i84 >> 2] = i185;
        HEAP32[i85 >> 2] = i186;
        HEAP32[i86 >> 2] = i187;
        HEAP32[i75 >> 2] = i188;
        i188 = HEAP32[(HEAP32[i176 >> 2] | 0) + (i35 << 2) >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i188 >> 2] | 0) + 72 >> 2] | 0, i155 | 0, i188 | 0);
        f183 = Math_fround(HEAPF32[i155 >> 2]);
        f32 = Math_fround(HEAPF32[i37 >> 2]);
        f182 = Math_fround(HEAPF32[i38 >> 2]);
        f33 = Math_fround(HEAPF32[i39 >> 2]);
        f190 = Math_fround(f183 + f183);
        f189 = Math_fround(f32 + f32);
        f31 = Math_fround(f182 + f182);
        f183 = Math_fround(f183 * f190);
        f191 = Math_fround(f32 * f189);
        f34 = Math_fround(f182 * f31);
        f32 = Math_fround(f190 * f32);
        f184 = Math_fround(f190 * f182);
        f190 = Math_fround(f190 * f33);
        f182 = Math_fround(f189 * f182);
        f189 = Math_fround(f189 * f33);
        f33 = Math_fround(f31 * f33);
        f31 = Math_fround(f32 + f33);
        f181 = Math_fround(f184 - f189);
        HEAPF32[i151 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f191) - f34);
        HEAPF32[i40 >> 2] = f31;
        HEAPF32[i41 >> 2] = f181;
        f183 = Math_fround(Math_fround(1.0) - f183);
        f34 = Math_fround(f183 - f34);
        f181 = Math_fround(f182 + f190);
        HEAPF32[i42 >> 2] = Math_fround(f32 - f33);
        HEAPF32[i43 >> 2] = f34;
        HEAPF32[i44 >> 2] = f181;
        f190 = Math_fround(f182 - f190);
        f191 = Math_fround(f183 - f191);
        HEAPF32[i45 >> 2] = Math_fround(f184 + f189);
        HEAPF32[i46 >> 2] = f190;
        HEAPF32[i47 >> 2] = f191;
        __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i165, i151);
        __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i165, i48);
        break;
       }
      default:
       {
        i175 = 44;
        break L5;
       }
      }
      do if (i150) {
       f17 = Math_fround(f8 * Math_fround(HEAPF32[i165 >> 2]));
       HEAPF32[i165 >> 2] = f17;
       f27 = Math_fround(f8 * Math_fround(HEAPF32[i76 >> 2]));
       HEAPF32[i76 >> 2] = f27;
       f28 = Math_fround(f8 * Math_fround(HEAPF32[i77 >> 2]));
       HEAPF32[i77 >> 2] = f28;
       f29 = Math_fround(f8 * Math_fround(HEAPF32[i99 >> 2]));
       HEAPF32[i99 >> 2] = f29;
       f30 = Math_fround(f8 * Math_fround(HEAPF32[i79 >> 2]));
       HEAPF32[i79 >> 2] = f30;
       f31 = Math_fround(f8 * Math_fround(HEAPF32[i80 >> 2]));
       HEAPF32[i80 >> 2] = f31;
       f32 = Math_fround(f8 * Math_fround(HEAPF32[i100 >> 2]));
       HEAPF32[i100 >> 2] = f32;
       f33 = Math_fround(f8 * Math_fround(HEAPF32[i82 >> 2]));
       HEAPF32[i82 >> 2] = f33;
       f34 = Math_fround(f8 * Math_fround(HEAPF32[i83 >> 2]));
       HEAPF32[i83 >> 2] = f34;
       f16 = Math_fround(f8 * Math_fround(HEAPF32[i75 >> 2]));
       HEAPF32[i75 >> 2] = f16;
      } else {
       f16 = Math_fround(HEAPF32[i75 >> 2]);
       if (i173) {
        f191 = Math_fround(f8 / f16);
        f17 = Math_fround(f191 * Math_fround(HEAPF32[i165 >> 2]));
        HEAPF32[i165 >> 2] = f17;
        f27 = Math_fround(f191 * Math_fround(HEAPF32[i76 >> 2]));
        HEAPF32[i76 >> 2] = f27;
        f28 = Math_fround(f191 * Math_fround(HEAPF32[i77 >> 2]));
        HEAPF32[i77 >> 2] = f28;
        f29 = Math_fround(f191 * Math_fround(HEAPF32[i99 >> 2]));
        HEAPF32[i99 >> 2] = f29;
        f30 = Math_fround(f191 * Math_fround(HEAPF32[i79 >> 2]));
        HEAPF32[i79 >> 2] = f30;
        f31 = Math_fround(f191 * Math_fround(HEAPF32[i80 >> 2]));
        HEAPF32[i80 >> 2] = f31;
        f32 = Math_fround(f191 * Math_fround(HEAPF32[i100 >> 2]));
        HEAPF32[i100 >> 2] = f32;
        f33 = Math_fround(f191 * Math_fround(HEAPF32[i82 >> 2]));
        HEAPF32[i82 >> 2] = f33;
        f34 = Math_fround(f191 * Math_fround(HEAPF32[i83 >> 2]));
        HEAPF32[i83 >> 2] = f34;
        f16 = Math_fround(f191 * f16);
        HEAPF32[i75 >> 2] = f16;
        break;
       } else {
        f17 = Math_fround(HEAPF32[i165 >> 2]);
        f27 = Math_fround(HEAPF32[i76 >> 2]);
        f28 = Math_fround(HEAPF32[i77 >> 2]);
        f29 = Math_fround(HEAPF32[i99 >> 2]);
        f30 = Math_fround(HEAPF32[i79 >> 2]);
        f31 = Math_fround(HEAPF32[i80 >> 2]);
        f32 = Math_fround(HEAPF32[i100 >> 2]);
        f33 = Math_fround(HEAPF32[i82 >> 2]);
        f34 = Math_fround(HEAPF32[i83 >> 2]);
        break;
       }
      } while (0);
      f190 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f191 = Math_fround(f190 + f16);
      f181 = Math_fround(f190 * (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f182 = Math_fround(f190 * (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f190 = Math_fround(f190 * (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f184 = Math_fround(f16 * Math_fround(HEAPF32[i101 >> 2]));
      f189 = Math_fround(f16 * Math_fround(HEAPF32[i85 >> 2]));
      f183 = Math_fround(Math_fround(1.0) / f191);
      f184 = Math_fround(Math_fround(f181 + f184) * f183);
      f189 = Math_fround(f183 * Math_fround(f182 + f189));
      f190 = Math_fround(f183 * Math_fround(f190 + Math_fround(f16 * Math_fround(HEAPF32[i86 >> 2]))));
      i12 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f17);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f27);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
      i9 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
      i15 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      f191 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
      i6 = i6 + 1 | 0;
     }
     i35 = i35 + 1 | 0;
     if (i35 >>> 0 >= (HEAP32[i156 >> 2] | 0) >>> 0) {
      i175 = 46;
      break;
     }
    }
   } while (0);
   if ((i175 | 0) == 27) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 659217 | 0, 131, gb + 659585 | 0, i169);
    i2 = 0;
    break L1;
   } else if ((i175 | 0) == 28) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 659217 | 0, 138, gb + 659652 | 0, i170);
    i2 = 0;
    break L1;
   } else if ((i175 | 0) == 44) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 659217 | 0, 217, gb + 659743 | 0, i171);
    i2 = 0;
    break L1;
   } else if ((i175 | 0) == 46) {
    if ((i172 | 0) == 0 | (i6 | 0) == 0 | i173) {
     i6 = i15;
     break;
    }
    f190 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f191 = Math_fround(f8 / f190);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f189 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f191);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f189, HEAP32[tempDoublePtr >> 2] | 0);
    f191 = Math_fround(f190 * f191);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  } while (0);
  HEAP32[i174 >> 2] = i11;
  HEAP32[i174 + 4 >> 2] = i10;
  HEAP32[i174 + 8 >> 2] = i9;
  HEAP32[i174 + 12 >> 2] = i7;
  HEAP32[i174 + 16 >> 2] = i6;
  HEAP32[i174 + 20 >> 2] = i5;
  HEAP32[i174 + 24 >> 2] = i4;
  HEAP32[i174 + 28 >> 2] = i3;
  HEAP32[i174 + 32 >> 2] = i2;
  HEAP32[i174 + 36 >> 2] = i12;
  HEAP32[i174 + 40 >> 2] = i13;
  HEAP32[i174 + 44 >> 2] = i14;
  HEAP32[i174 + 48 >> 2] = i1;
  i2 = 1;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 659217 | 0, 113, gb + 659585 | 0, i3);
  i2 = 0;
 } while (0);
 i188 = HEAP32[i177 >> 2] | 0;
 if (!((i188 | 0) > -1 & (i188 & 2147483647 | 0) != 0)) {
  STACKTOP = i180;
  return i2 | 0;
 }
 i1 = HEAP32[i176 >> 2] | 0;
 if ((i179 | 0) == (i1 | 0)) {
  HEAP8[i178 >> 0] = 0;
  STACKTOP = i180;
  return i2 | 0;
 }
 if (!i1) {
  STACKTOP = i180;
  return i2 | 0;
 }
 i188 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i188 >> 2] | 0) + 12 >> 2] | 0, i188 | 0, i1 | 0);
 STACKTOP = i180;
 return i2 | 0;
}

function __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i70, i67, i74, i75, i69, i71, i73, i72, i64, i63, i65, i61, i66) {
 i70 = i70 | 0;
 i67 = i67 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i69 = i69 | 0;
 i71 = i71 | 0;
 i73 = i73 | 0;
 i72 = i72 | 0;
 i64 = i64 | 0;
 i63 = i63 | 0;
 i65 = i65 | 0;
 i61 = i61 | 0;
 i66 = i66 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, f68 = f0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i76 + 176 | 0;
 i62 = i76 + 32 | 0;
 i60 = i76;
 if (i72 >>> 0 >= 8) {
  i1 = i72 + 7 & -4;
  HEAP32[i10 >> 2] = 2139095039;
  HEAP32[i10 + 4 >> 2] = 2139095039;
  HEAP32[i10 + 8 >> 2] = 2139095039;
  HEAPF32[i10 + 12 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i59 = i73 + (i72 << 2) | 0;
  if (i1 | 0) {
   i11 = i73;
   i12 = 0;
   i13 = 0;
   while (1) {
    if (i12 >>> 0 < i72 >>> 0) i2 = i75 + (HEAP32[i11 >> 2] << 5) | 0; else i2 = i10;
    if ((i12 | 1) >>> 0 < i72 >>> 0) i4 = i75 + (HEAP32[i11 + 4 >> 2] << 5) | 0; else i4 = i10;
    if ((i12 | 2) >>> 0 < i72 >>> 0) i5 = i75 + (HEAP32[i11 + 8 >> 2] << 5) | 0; else i5 = i10;
    if ((i12 | 3) >>> 0 < i72 >>> 0) i9 = i75 + (HEAP32[i11 + 12 >> 2] << 5) | 0; else i9 = i10;
    i50 = HEAP32[i2 + 4 >> 2] | 0;
    i54 = HEAP32[i2 + 8 >> 2] | 0;
    i48 = HEAP32[i4 >> 2] | 0;
    i51 = HEAP32[i4 + 4 >> 2] | 0;
    i55 = HEAP32[i4 + 8 >> 2] | 0;
    i49 = HEAP32[i5 >> 2] | 0;
    i52 = HEAP32[i5 + 4 >> 2] | 0;
    i56 = HEAP32[i5 + 8 >> 2] | 0;
    i58 = HEAP32[i9 >> 2] | 0;
    i53 = HEAP32[i9 + 4 >> 2] | 0;
    i57 = HEAP32[i9 + 8 >> 2] | 0;
    HEAP32[i61 + (i13 << 4) >> 2] = HEAP32[i2 >> 2];
    HEAP32[i61 + (i13 << 4) + 4 >> 2] = i48;
    HEAP32[i61 + (i13 << 4) + 8 >> 2] = i49;
    HEAP32[i61 + (i13 << 4) + 12 >> 2] = i58;
    i58 = i13 + 1 | 0;
    HEAP32[i61 + (i58 << 4) >> 2] = i50;
    HEAP32[i61 + (i58 << 4) + 4 >> 2] = i51;
    HEAP32[i61 + (i58 << 4) + 8 >> 2] = i52;
    HEAP32[i61 + (i58 << 4) + 12 >> 2] = i53;
    i58 = i13 + 2 | 0;
    HEAP32[i61 + (i58 << 4) >> 2] = i54;
    HEAP32[i61 + (i58 << 4) + 4 >> 2] = i55;
    HEAP32[i61 + (i58 << 4) + 8 >> 2] = i56;
    HEAP32[i61 + (i58 << 4) + 12 >> 2] = i57;
    i12 = i12 + 4 | 0;
    if (i12 >>> 0 >= i1 >>> 0) break; else {
     i11 = i11 + 16 | 0;
     i13 = i13 + 3 | 0;
    }
   }
  }
  i58 = HEAP32[i65 + 48 >> 2] | 0;
  HEAP32[i62 >> 2] = i58;
  HEAP32[i62 + 4 >> 2] = i58;
  HEAP32[i62 + 8 >> 2] = i58;
  HEAP32[i62 + 12 >> 2] = i58;
  i58 = i65 + 52 | 0;
  i56 = HEAP32[i58 >> 2] | 0;
  HEAP32[i62 + 16 >> 2] = i56;
  HEAP32[i62 + 20 >> 2] = i56;
  HEAP32[i62 + 24 >> 2] = i56;
  HEAP32[i62 + 28 >> 2] = i56;
  i56 = HEAP32[i65 + 24 >> 2] | 0;
  HEAP32[i62 + 32 >> 2] = i56;
  HEAP32[i62 + 36 >> 2] = i56;
  HEAP32[i62 + 40 >> 2] = i56;
  HEAP32[i62 + 44 >> 2] = i56;
  i56 = i65 + 28 | 0;
  i57 = HEAP32[i56 >> 2] | 0;
  HEAP32[i62 + 48 >> 2] = i57;
  HEAP32[i62 + 52 >> 2] = i57;
  HEAP32[i62 + 56 >> 2] = i57;
  HEAP32[i62 + 60 >> 2] = i57;
  i57 = i65 + 32 | 0;
  i55 = HEAP32[i57 >> 2] | 0;
  HEAP32[i62 + 64 >> 2] = i55;
  HEAP32[i62 + 68 >> 2] = i55;
  HEAP32[i62 + 72 >> 2] = i55;
  HEAP32[i62 + 76 >> 2] = i55;
  i55 = HEAP32[i65 + 36 >> 2] | 0;
  HEAP32[i62 + 80 >> 2] = i55;
  HEAP32[i62 + 84 >> 2] = i55;
  HEAP32[i62 + 88 >> 2] = i55;
  HEAP32[i62 + 92 >> 2] = i55;
  i55 = HEAP32[i65 + 40 >> 2] | 0;
  HEAP32[i62 + 96 >> 2] = i55;
  HEAP32[i62 + 100 >> 2] = i55;
  HEAP32[i62 + 104 >> 2] = i55;
  HEAP32[i62 + 108 >> 2] = i55;
  i55 = HEAP32[i65 + 44 >> 2] | 0;
  HEAP32[i62 + 112 >> 2] = i55;
  HEAP32[i62 + 116 >> 2] = i55;
  HEAP32[i62 + 120 >> 2] = i55;
  HEAP32[i62 + 124 >> 2] = i55;
  f25 = Math_fround(HEAPF32[i65 + 16 >> 2]);
  do if (i71 | 0) {
   i23 = i61 + 4 | 0;
   i24 = i61 + 8 | 0;
   i34 = i61 + 12 | 0;
   i35 = i61 + 16 | 0;
   i37 = i61 + 20 | 0;
   i38 = i61 + 24 | 0;
   i39 = i61 + 28 | 0;
   i40 = i61 + 32 | 0;
   i48 = i61 + 36 | 0;
   i49 = i61 + 40 | 0;
   i50 = i61 + 44 | 0;
   i51 = i60 + 4 | 0;
   i52 = i60 + 8 | 0;
   i53 = i60 + 12 | 0;
   i54 = (i72 | 0) == 0;
   i55 = i66 + 4 | 0;
   i21 = i69;
   i1 = 0;
   i22 = 0;
   while (1) {
    i13 = HEAP32[i21 >> 2] | 0;
    HEAP32[i66 + (i1 << 2) >> 2] = i13;
    i4 = i1 + 2 | 0;
    i2 = i66 + (i1 + 1 << 2) | 0;
    i13 = i74 + (i13 << 5) | 0;
    f18 = Math_fround(HEAPF32[i13 >> 2]);
    f19 = Math_fround(HEAPF32[i13 + 4 >> 2]);
    f20 = Math_fround(HEAPF32[i13 + 8 >> 2]);
    f31 = Math_fround(HEAPF32[i61 >> 2]);
    f33 = Math_fround(HEAPF32[i23 >> 2]);
    f41 = Math_fround(HEAPF32[i24 >> 2]);
    f43 = Math_fround(HEAPF32[i34 >> 2]);
    f32 = Math_fround(HEAPF32[i35 >> 2]);
    f36 = Math_fround(HEAPF32[i37 >> 2]);
    f42 = Math_fround(HEAPF32[i38 >> 2]);
    f44 = Math_fround(HEAPF32[i39 >> 2]);
    f68 = Math_fround(HEAPF32[i40 >> 2]);
    f45 = Math_fround(HEAPF32[i48 >> 2]);
    f46 = Math_fround(HEAPF32[i49 >> 2]);
    f31 = Math_fround(f18 - f31);
    f33 = Math_fround(f18 - f33);
    f41 = Math_fround(f18 - f41);
    f43 = Math_fround(f18 - f43);
    f32 = Math_fround(f19 - f32);
    f36 = Math_fround(f19 - f36);
    f42 = Math_fround(f19 - f42);
    f44 = Math_fround(f19 - f44);
    f68 = Math_fround(f20 - f68);
    f45 = Math_fround(f20 - f45);
    f46 = Math_fround(f20 - f46);
    f47 = Math_fround(f20 - Math_fround(HEAPF32[i50 >> 2]));
    f68 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f68 * f68));
    f45 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f36 * f36)) + Math_fround(f45 * f45));
    f46 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f46 * f46));
    f47 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f44 * f44)) + Math_fround(f47 * f47));
    i13 = f25 > f45 & f45 > Math_fround(0.0) & 1;
    i17 = f25 > f46 & f46 > Math_fround(0.0) & 1;
    i69 = f25 > f47 & f47 > Math_fround(0.0) & 1;
    HEAP32[i60 >> 2] = f25 > f68 & f68 > Math_fround(0.0) & 1;
    HEAP32[i51 >> 2] = i13;
    HEAP32[i52 >> 2] = i17;
    HEAP32[i53 >> 2] = i69;
    if (i54) i1 = i4; else {
     i17 = i73;
     i1 = i4;
     i12 = 0;
     i13 = i61;
     while (1) {
      f31 = Math_fround(HEAPF32[i13 + 48 >> 2]);
      f33 = Math_fround(HEAPF32[i13 + 52 >> 2]);
      f41 = Math_fround(HEAPF32[i13 + 56 >> 2]);
      f43 = Math_fround(HEAPF32[i13 + 60 >> 2]);
      f32 = Math_fround(HEAPF32[i13 + 64 >> 2]);
      f36 = Math_fround(HEAPF32[i13 + 68 >> 2]);
      f42 = Math_fround(HEAPF32[i13 + 72 >> 2]);
      f44 = Math_fround(HEAPF32[i13 + 76 >> 2]);
      f68 = Math_fround(HEAPF32[i13 + 80 >> 2]);
      f45 = Math_fround(HEAPF32[i13 + 84 >> 2]);
      f46 = Math_fround(HEAPF32[i13 + 88 >> 2]);
      f31 = Math_fround(f18 - f31);
      f33 = Math_fround(f18 - f33);
      f41 = Math_fround(f18 - f41);
      f43 = Math_fround(f18 - f43);
      f32 = Math_fround(f19 - f32);
      f36 = Math_fround(f19 - f36);
      f42 = Math_fround(f19 - f42);
      f44 = Math_fround(f19 - f44);
      f68 = Math_fround(f20 - f68);
      f45 = Math_fround(f20 - f45);
      f46 = Math_fround(f20 - f46);
      f47 = Math_fround(f20 - Math_fround(HEAPF32[i13 + 92 >> 2]));
      i13 = i13 + 48 | 0;
      f68 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f68 * f68));
      f45 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f36 * f36)) + Math_fround(f45 * f45));
      f46 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f46 * f46));
      f47 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f44 * f44)) + Math_fround(f47 * f47));
      i69 = f25 > f45 & f45 > Math_fround(0.0) & 1;
      i10 = f25 > f46 & f46 > Math_fround(0.0) & 1;
      i9 = f25 > f47 & f47 > Math_fround(0.0) & 1;
      i11 = i12;
      i12 = i12 + 4 | 0;
      i5 = i12 & 4;
      HEAP32[i60 + (i5 << 2) >> 2] = f25 > f68 & f68 > Math_fround(0.0) & 1;
      HEAP32[i60 + ((i5 | 1) << 2) >> 2] = i69;
      HEAP32[i60 + ((i5 | 2) << 2) >> 2] = i10;
      HEAP32[i60 + ((i5 | 3) << 2) >> 2] = i9;
      i11 = i11 & 4;
      i5 = HEAP32[i60 + (i11 << 2) >> 2] | 0;
      i9 = HEAP32[i60 + ((i11 | 1) << 2) >> 2] | 0;
      i10 = HEAP32[i60 + ((i11 | 2) << 2) >> 2] | 0;
      i11 = HEAP32[i60 + ((i11 | 3) << 2) >> 2] | 0;
      HEAP32[i66 + (i1 << 2) >> 2] = HEAP32[i17 >> 2];
      i5 = i5 + i1 | 0;
      i1 = i17 + 4 | 0;
      if (i1 >>> 0 < i59 >>> 0) i1 = HEAP32[i1 >> 2] | 0; else i1 = 0;
      HEAP32[i66 + (i5 << 2) >> 2] = i1;
      i5 = i5 + i9 | 0;
      i1 = i17 + 8 | 0;
      if (i1 >>> 0 < i59 >>> 0) i1 = HEAP32[i1 >> 2] | 0; else i1 = 0;
      HEAP32[i66 + (i5 << 2) >> 2] = i1;
      i5 = i5 + i10 | 0;
      i1 = i17 + 12 | 0;
      if (i1 >>> 0 < i59 >>> 0) i1 = HEAP32[i1 >> 2] | 0; else i1 = 0;
      HEAP32[i66 + (i5 << 2) >> 2] = i1;
      i1 = i5 + i11 | 0;
      if ((128 - i1 | 0) >>> 0 <= 5) {
       HEAP32[i2 >> 2] = i1 - i4;
       do if (i63) {
        f14 = Math_fround(HEAPF32[i56 >> 2]);
        f15 = Math_fround(HEAPF32[i57 >> 2]);
        f16 = Math_fround(HEAPF32[i58 >> 2]);
        i2 = (i1 | 0) == 0;
        if (i64) {
         if (i2) break; else i4 = 0;
         while (1) {
          i5 = HEAP32[i66 + (i4 << 2) >> 2] | 0;
          i2 = i4 + 2 | 0;
          i10 = HEAP32[i66 + (i4 + 1 << 2) >> 2] | 0;
          if (i10) {
           f6 = Math_fround(HEAPF32[i74 + (i5 << 5) >> 2]);
           f7 = Math_fround(HEAPF32[i74 + (i5 << 5) + 4 >> 2]);
           f8 = Math_fround(HEAPF32[i74 + (i5 << 5) + 8 >> 2]);
           i9 = i74 + (i5 << 5) + 12 | 0;
           f3 = Math_fround(HEAPF32[i9 >> 2]);
           i4 = 0;
           i5 = i2;
           while (1) {
            i69 = HEAP32[i66 + (i5 << 2) >> 2] | 0;
            f46 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i69 << 5) >> 2]));
            f47 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i69 << 5) + 4 >> 2]));
            f68 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i69 << 5) + 8 >> 2]));
            f68 = Math_fround(f14 - Math_fround(f16 * Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f68 * f68))));
            f68 = Math_fround(f68 * Math_fround(f68 * Math_fround(f15 * f68)));
            f3 = Math_fround(f3 + f68);
            i69 = i75 + (i69 << 5) + 12 | 0;
            HEAPF32[i69 >> 2] = Math_fround(Math_fround(HEAPF32[i69 >> 2]) + f68);
            i4 = i4 + 1 | 0;
            if ((i4 | 0) == (i10 | 0)) break; else i5 = i5 + 1 | 0;
           }
           HEAPF32[i9 >> 2] = f3;
           i2 = i10 + i2 | 0;
          }
          if (i2 >>> 0 < i1 >>> 0) i4 = i2; else break;
         }
        } else {
         if (i2) break; else i4 = 0;
         while (1) {
          i5 = HEAP32[i66 + (i4 << 2) >> 2] | 0;
          i2 = i4 + 2 | 0;
          i10 = HEAP32[i66 + (i4 + 1 << 2) >> 2] | 0;
          if (i10) {
           f6 = Math_fround(HEAPF32[i74 + (i5 << 5) >> 2]);
           f7 = Math_fround(HEAPF32[i74 + (i5 << 5) + 4 >> 2]);
           f8 = Math_fround(HEAPF32[i74 + (i5 << 5) + 8 >> 2]);
           i9 = i74 + (i5 << 5) + 12 | 0;
           f3 = Math_fround(HEAPF32[i9 >> 2]);
           i4 = 0;
           i5 = i2;
           while (1) {
            i69 = HEAP32[i66 + (i5 << 2) >> 2] | 0;
            f46 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i69 << 5) >> 2]));
            f47 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i69 << 5) + 4 >> 2]));
            f68 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i69 << 5) + 8 >> 2]));
            f68 = Math_fround(f14 - Math_fround(f16 * Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f68 * f68))));
            f3 = Math_fround(f3 + Math_fround(f68 * Math_fround(f68 * Math_fround(f15 * f68))));
            i4 = i4 + 1 | 0;
            if ((i4 | 0) == (i10 | 0)) break; else i5 = i5 + 1 | 0;
           }
           HEAPF32[i9 >> 2] = f3;
           i2 = i10 + i2 | 0;
          }
          if (i2 >>> 0 < i1 >>> 0) i4 = i2; else break;
         }
        }
       } else if (i64) {
        __ZN5physxL23updateStreamForceTwoWayEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i70, i67, i74, i75, i66, i1, i65, i62);
        break;
       } else {
        __ZN5physxL17updateStreamForceEPNS_6PxVec3EPNS_16PxsFluidParticleEPKS2_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i70, i74, i75, i66, i1, i65, i62);
        break;
       } while (0);
       HEAP32[i66 >> 2] = HEAP32[i21 >> 2];
       i1 = 2;
       i4 = 2;
       i2 = i55;
      }
      if (i12 >>> 0 >= i72 >>> 0) break; else i17 = i17 + 16 | 0;
     }
    }
    HEAP32[i2 >> 2] = i1 - i4;
    i22 = i22 + 1 | 0;
    if ((i22 | 0) == (i71 | 0)) {
     i10 = i1;
     break;
    } else i21 = i21 + 4 | 0;
   }
   if (i10 | 0) {
    if (!i63) if (i64) {
     __ZN5physxL23updateStreamForceTwoWayEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i70, i67, i74, i75, i66, i10, i65, i62);
     break;
    } else {
     __ZN5physxL17updateStreamForceEPNS_6PxVec3EPNS_16PxsFluidParticleEPKS2_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i70, i74, i75, i66, i10, i65, i62);
     break;
    }
    f16 = Math_fround(HEAPF32[i56 >> 2]);
    f15 = Math_fround(HEAPF32[i57 >> 2]);
    f14 = Math_fround(HEAPF32[i58 >> 2]);
    if (i64) {
     i2 = 0;
     while (1) {
      i4 = HEAP32[i66 + (i2 << 2) >> 2] | 0;
      i1 = i2 + 2 | 0;
      i9 = HEAP32[i66 + (i2 + 1 << 2) >> 2] | 0;
      if (i9) {
       f6 = Math_fround(HEAPF32[i74 + (i4 << 5) >> 2]);
       f7 = Math_fround(HEAPF32[i74 + (i4 << 5) + 4 >> 2]);
       f8 = Math_fround(HEAPF32[i74 + (i4 << 5) + 8 >> 2]);
       i5 = i74 + (i4 << 5) + 12 | 0;
       f3 = Math_fround(HEAPF32[i5 >> 2]);
       i2 = 0;
       i4 = i1;
       while (1) {
        i73 = HEAP32[i66 + (i4 << 2) >> 2] | 0;
        f46 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i73 << 5) >> 2]));
        f47 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i73 << 5) + 4 >> 2]));
        f68 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i73 << 5) + 8 >> 2]));
        f68 = Math_fround(f16 - Math_fround(f14 * Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f68 * f68))));
        f68 = Math_fround(f68 * Math_fround(f68 * Math_fround(f15 * f68)));
        f3 = Math_fround(f3 + f68);
        i73 = i75 + (i73 << 5) + 12 | 0;
        HEAPF32[i73 >> 2] = Math_fround(Math_fround(HEAPF32[i73 >> 2]) + f68);
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i9 | 0)) break; else i4 = i4 + 1 | 0;
       }
       HEAPF32[i5 >> 2] = f3;
       i1 = i9 + i1 | 0;
      }
      if (i1 >>> 0 < i10 >>> 0) i2 = i1; else break;
     }
    } else {
     i2 = 0;
     while (1) {
      i4 = HEAP32[i66 + (i2 << 2) >> 2] | 0;
      i1 = i2 + 2 | 0;
      i9 = HEAP32[i66 + (i2 + 1 << 2) >> 2] | 0;
      if (i9) {
       f6 = Math_fround(HEAPF32[i74 + (i4 << 5) >> 2]);
       f7 = Math_fround(HEAPF32[i74 + (i4 << 5) + 4 >> 2]);
       f8 = Math_fround(HEAPF32[i74 + (i4 << 5) + 8 >> 2]);
       i5 = i74 + (i4 << 5) + 12 | 0;
       f3 = Math_fround(HEAPF32[i5 >> 2]);
       i2 = 0;
       i4 = i1;
       while (1) {
        i73 = HEAP32[i66 + (i4 << 2) >> 2] | 0;
        f46 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i73 << 5) >> 2]));
        f47 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i73 << 5) + 4 >> 2]));
        f68 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i73 << 5) + 8 >> 2]));
        f68 = Math_fround(f16 - Math_fround(f14 * Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f68 * f68))));
        f3 = Math_fround(f3 + Math_fround(f68 * Math_fround(f68 * Math_fround(f15 * f68))));
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i9 | 0)) break; else i4 = i4 + 1 | 0;
       }
       HEAPF32[i5 >> 2] = f3;
       i1 = i9 + i1 | 0;
      }
      if (i1 >>> 0 < i10 >>> 0) i2 = i1; else break;
     }
    }
   }
  } while (0);
  STACKTOP = i76;
  return;
 }
 i48 = i72 & -4;
 i49 = HEAP32[i65 + 16 >> 2] | 0;
 i1 = (i71 | 0) == 0;
 f68 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!i63) if (i64) {
  if (i1) {
   STACKTOP = i76;
   return;
  }
  i39 = (i48 | 0) == 0;
  i40 = i48 >>> 0 < i72 >>> 0;
  f41 = Math_fround(HEAPF32[i65 + 52 >> 2]);
  f42 = Math_fround(HEAPF32[i65 + 24 >> 2]);
  f43 = Math_fround(HEAPF32[i65 + 44 >> 2]);
  f44 = Math_fround(HEAPF32[i65 + 28 >> 2]);
  f45 = Math_fround(f42 * Math_fround(2.0));
  f46 = Math_fround(HEAPF32[i65 + 36 >> 2]);
  f47 = Math_fround(HEAPF32[i65 + 48 >> 2]);
  f36 = Math_fround(HEAPF32[i65 + 40 >> 2]);
  i38 = 0;
  do {
   i35 = HEAP32[i69 + (i38 << 2) >> 2] | 0;
   i1 = i74 + (i35 << 5) | 0;
   i37 = i70 + (i35 * 12 | 0) | 0;
   if (!i39) {
    f3 = Math_fround(HEAPF32[i1 >> 2]);
    f6 = Math_fround(HEAPF32[i74 + (i35 << 5) + 4 >> 2]);
    f7 = Math_fround(HEAPF32[i74 + (i35 << 5) + 8 >> 2]);
    i2 = i74 + (i35 << 5) + 12 | 0;
    i4 = i74 + (i35 << 5) + 16 | 0;
    i5 = i74 + (i35 << 5) + 20 | 0;
    i9 = i74 + (i35 << 5) + 24 | 0;
    i10 = i70 + (i35 * 12 | 0) + 4 | 0;
    i11 = i70 + (i35 * 12 | 0) + 8 | 0;
    i34 = 0;
    do {
     i12 = HEAP32[i73 + (i34 << 2) >> 2] | 0;
     i13 = HEAP32[i73 + ((i34 | 1) << 2) >> 2] | 0;
     i17 = HEAP32[i73 + ((i34 | 2) << 2) >> 2] | 0;
     i21 = HEAP32[i73 + ((i34 | 3) << 2) >> 2] | 0;
     f8 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i12 << 5) >> 2]));
     f14 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i12 << 5) + 4 >> 2]));
     f15 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i12 << 5) + 8 >> 2]));
     f16 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i13 << 5) >> 2]));
     f18 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i13 << 5) + 4 >> 2]));
     f19 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i13 << 5) + 8 >> 2]));
     f20 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i17 << 5) >> 2]));
     f25 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i17 << 5) + 4 >> 2]));
     f26 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i17 << 5) + 8 >> 2]));
     f27 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i21 << 5) >> 2]));
     f28 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i21 << 5) + 4 >> 2]));
     f29 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i21 << 5) + 8 >> 2]));
     f30 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     f31 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f18 * f18)) + Math_fround(f19 * f19));
     f32 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
     f33 = Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28)) + Math_fround(f29 * f29));
     i66 = Math_fround(f68 - f30) >= Math_fround(0.0) | Math_fround(f68 - f31) >= Math_fround(0.0) | Math_fround(f68 - f32) >= Math_fround(0.0) | Math_fround(f68 - f33) >= Math_fround(0.0);
     if (!((i66 ? Math_fround(1.0) : Math_fround(0.0)) == Math_fround(0.0))) {
      i66 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
      i22 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
      i23 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
      i24 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
      if (i66 >>> 0 < i49 >>> 0 & (i66 | 0) != 0) {
       f82 = Math_fround(f41 * f30);
       f80 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f82))));
       f82 = Math_fround(f82 * f80);
       f79 = Math_fround(f42 - f82);
       f30 = Math_fround(HEAPF32[i2 >> 2]);
       f81 = Math_fround(f30 - f43);
       i66 = f81 > Math_fround(0.0);
       f81 = i66 ? f81 : Math_fround(0.0);
       f77 = Math_fround(HEAPF32[i75 + (i12 << 5) + 12 >> 2]);
       f78 = Math_fround(f77 - f43);
       i66 = f78 > Math_fround(0.0);
       f78 = Math_fround(Math_fround(f46 * Math_fround(f82 + Math_fround(Math_fround(f44 * f80) - f45))) * Math_fround(f81 + (i66 ? f78 : Math_fround(0.0))));
       f81 = Math_fround(f47 * Math_fround(f8 * f78));
       f80 = Math_fround(f47 * Math_fround(f14 * f78));
       f78 = Math_fround(f47 * Math_fround(f15 * f78));
       f79 = Math_fround(f36 * f79);
       f14 = Math_fround(HEAPF32[i75 + (i12 << 5) + 16 >> 2]);
       f14 = Math_fround(f14 - Math_fround(HEAPF32[i4 >> 2]));
       f15 = Math_fround(HEAPF32[i75 + (i12 << 5) + 20 >> 2]);
       f15 = Math_fround(f15 - Math_fround(HEAPF32[i5 >> 2]));
       f8 = Math_fround(HEAPF32[i75 + (i12 << 5) + 24 >> 2]);
       f14 = Math_fround(Math_fround(f79 * Math_fround(f47 * f14)) + f81);
       f15 = Math_fround(f80 + Math_fround(f79 * Math_fround(f47 * f15)));
       f8 = Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f8 - Math_fround(HEAPF32[i9 >> 2])))));
       f77 = Math_fround(Math_fround(1.0) / f77);
       f79 = Math_fround(f77 * f14);
       f78 = Math_fround(f77 * f15);
       f77 = Math_fround(f77 * f8);
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f79);
       HEAPF32[i10 >> 2] = Math_fround(f78 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f77);
       f30 = Math_fround(Math_fround(1.0) / f30);
       f14 = Math_fround(f14 * f30);
       f15 = Math_fround(f15 * f30);
       f30 = Math_fround(f8 * f30);
       i66 = i67 + (i12 * 12 | 0) | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f14);
       i66 = i67 + (i12 * 12 | 0) + 4 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f15);
       i66 = i67 + (i12 * 12 | 0) + 8 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f30);
      }
      if (i22 >>> 0 < i49 >>> 0 & (i22 | 0) != 0) {
       f81 = Math_fround(f41 * f31);
       f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f81 = Math_fround(f81 * f30);
       f31 = Math_fround(f42 - f81);
       f82 = Math_fround(HEAPF32[i2 >> 2]);
       f80 = Math_fround(f82 - f43);
       i66 = f80 > Math_fround(0.0);
       f80 = i66 ? f80 : Math_fround(0.0);
       f78 = Math_fround(HEAPF32[i75 + (i13 << 5) + 12 >> 2]);
       f77 = Math_fround(f78 - f43);
       i66 = f77 > Math_fround(0.0);
       f77 = Math_fround(Math_fround(f46 * Math_fround(f81 + Math_fround(Math_fround(f44 * f30) - f45))) * Math_fround(f80 + (i66 ? f77 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f16 * f77));
       f30 = Math_fround(f47 * Math_fround(f18 * f77));
       f77 = Math_fround(f47 * Math_fround(f19 * f77));
       f31 = Math_fround(f36 * f31);
       f19 = Math_fround(HEAPF32[i75 + (i13 << 5) + 16 >> 2]);
       f19 = Math_fround(f19 - Math_fround(HEAPF32[i4 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i13 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i5 >> 2]));
       f79 = Math_fround(HEAPF32[i75 + (i13 << 5) + 24 >> 2]);
       f80 = Math_fround(Math_fround(f31 * Math_fround(f47 * f19)) + f80);
       f81 = Math_fround(f30 + Math_fround(f31 * Math_fround(f47 * f81)));
       f79 = Math_fround(f77 + Math_fround(f31 * Math_fround(f47 * Math_fround(f79 - Math_fround(HEAPF32[i9 >> 2])))));
       f78 = Math_fround(Math_fround(1.0) / f78);
       f31 = Math_fround(f78 * f80);
       f77 = Math_fround(f78 * f81);
       f78 = Math_fround(f78 * f79);
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f31);
       HEAPF32[i10 >> 2] = Math_fround(f77 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f78);
       f82 = Math_fround(Math_fround(1.0) / f82);
       f80 = Math_fround(f80 * f82);
       f81 = Math_fround(f81 * f82);
       f82 = Math_fround(f79 * f82);
       i66 = i67 + (i13 * 12 | 0) | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f80);
       i66 = i67 + (i13 * 12 | 0) + 4 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f81);
       i66 = i67 + (i13 * 12 | 0) + 8 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f82);
      }
      if (i23 >>> 0 < i49 >>> 0 & (i23 | 0) != 0) {
       f30 = Math_fround(f41 * f32);
       f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f30))));
       f30 = Math_fround(f30 * f31);
       f32 = Math_fround(f42 - f30);
       f82 = Math_fround(HEAPF32[i2 >> 2]);
       f80 = Math_fround(f82 - f43);
       i66 = f80 > Math_fround(0.0);
       f80 = i66 ? f80 : Math_fround(0.0);
       f78 = Math_fround(HEAPF32[i75 + (i17 << 5) + 12 >> 2]);
       f77 = Math_fround(f78 - f43);
       i66 = f77 > Math_fround(0.0);
       f77 = Math_fround(Math_fround(f46 * Math_fround(f30 + Math_fround(Math_fround(f44 * f31) - f45))) * Math_fround(f80 + (i66 ? f77 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f20 * f77));
       f31 = Math_fround(f47 * Math_fround(f25 * f77));
       f77 = Math_fround(f47 * Math_fround(f26 * f77));
       f32 = Math_fround(f36 * f32);
       f30 = Math_fround(HEAPF32[i75 + (i17 << 5) + 16 >> 2]);
       f30 = Math_fround(f30 - Math_fround(HEAPF32[i4 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i17 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i5 >> 2]));
       f79 = Math_fround(HEAPF32[i75 + (i17 << 5) + 24 >> 2]);
       f80 = Math_fround(Math_fround(f32 * Math_fround(f47 * f30)) + f80);
       f81 = Math_fround(f31 + Math_fround(f32 * Math_fround(f47 * f81)));
       f79 = Math_fround(f77 + Math_fround(f32 * Math_fround(f47 * Math_fround(f79 - Math_fround(HEAPF32[i9 >> 2])))));
       f78 = Math_fround(Math_fround(1.0) / f78);
       f32 = Math_fround(f78 * f80);
       f77 = Math_fround(f78 * f81);
       f78 = Math_fround(f78 * f79);
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f32);
       HEAPF32[i10 >> 2] = Math_fround(f77 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f78);
       f82 = Math_fround(Math_fround(1.0) / f82);
       f80 = Math_fround(f80 * f82);
       f81 = Math_fround(f81 * f82);
       f82 = Math_fround(f79 * f82);
       i66 = i67 + (i17 * 12 | 0) | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f80);
       i66 = i67 + (i17 * 12 | 0) + 4 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f81);
       i66 = i67 + (i17 * 12 | 0) + 8 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f82);
      }
      if (i24 >>> 0 < i49 >>> 0 & (i24 | 0) != 0) {
       f31 = Math_fround(f41 * f33);
       f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f31))));
       f31 = Math_fround(f31 * f32);
       f33 = Math_fround(f42 - f31);
       f82 = Math_fround(HEAPF32[i2 >> 2]);
       f80 = Math_fround(f82 - f43);
       i66 = f80 > Math_fround(0.0);
       f80 = i66 ? f80 : Math_fround(0.0);
       f78 = Math_fround(HEAPF32[i75 + (i21 << 5) + 12 >> 2]);
       f77 = Math_fround(f78 - f43);
       i66 = f77 > Math_fround(0.0);
       f77 = Math_fround(Math_fround(f46 * Math_fround(f31 + Math_fround(Math_fround(f44 * f32) - f45))) * Math_fround(f80 + (i66 ? f77 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f27 * f77));
       f32 = Math_fround(f47 * Math_fround(f28 * f77));
       f77 = Math_fround(f47 * Math_fround(f29 * f77));
       f33 = Math_fround(f36 * f33);
       f31 = Math_fround(HEAPF32[i75 + (i21 << 5) + 16 >> 2]);
       f31 = Math_fround(f31 - Math_fround(HEAPF32[i4 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i21 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i5 >> 2]));
       f79 = Math_fround(HEAPF32[i75 + (i21 << 5) + 24 >> 2]);
       f80 = Math_fround(Math_fround(f33 * Math_fround(f47 * f31)) + f80);
       f81 = Math_fround(f32 + Math_fround(f33 * Math_fround(f47 * f81)));
       f79 = Math_fround(f77 + Math_fround(f33 * Math_fround(f47 * Math_fround(f79 - Math_fround(HEAPF32[i9 >> 2])))));
       f78 = Math_fround(Math_fround(1.0) / f78);
       f33 = Math_fround(f78 * f80);
       f77 = Math_fround(f78 * f81);
       f78 = Math_fround(f78 * f79);
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f33);
       HEAPF32[i10 >> 2] = Math_fround(f77 + Math_fround(HEAPF32[i10 >> 2]));
       HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f78);
       f82 = Math_fround(Math_fround(1.0) / f82);
       f80 = Math_fround(f80 * f82);
       f81 = Math_fround(f81 * f82);
       f82 = Math_fround(f79 * f82);
       i66 = i67 + (i21 * 12 | 0) | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f80);
       i66 = i67 + (i21 * 12 | 0) + 4 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f81);
       i66 = i67 + (i21 * 12 | 0) + 8 | 0;
       HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f82);
      }
     }
     i34 = i34 + 4 | 0;
    } while (i34 >>> 0 < i48 >>> 0);
   }
   if (i40) {
    f14 = Math_fround(HEAPF32[i1 >> 2]);
    f15 = Math_fround(HEAPF32[i74 + (i35 << 5) + 4 >> 2]);
    f16 = Math_fround(HEAPF32[i74 + (i35 << 5) + 8 >> 2]);
    i5 = i74 + (i35 << 5) + 12 | 0;
    i9 = i74 + (i35 << 5) + 16 | 0;
    i10 = i74 + (i35 << 5) + 20 | 0;
    i11 = i74 + (i35 << 5) + 24 | 0;
    i12 = i70 + (i35 * 12 | 0) + 4 | 0;
    i1 = i70 + (i35 * 12 | 0) + 8 | 0;
    i4 = i48;
    do {
     i2 = HEAP32[i73 + (i4 << 2) >> 2] | 0;
     f3 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i2 << 5) >> 2]));
     f6 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i2 << 5) + 4 >> 2]));
     f7 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i2 << 5) + 8 >> 2]));
     f8 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
     i66 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     if (i66 >>> 0 < i49 >>> 0 & (i66 | 0) != 0) {
      f31 = Math_fround(f41 * f8);
      f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f31))));
      f31 = Math_fround(f31 * f32);
      f33 = Math_fround(f42 - f31);
      f82 = Math_fround(HEAPF32[i5 >> 2]);
      f80 = Math_fround(f82 - f43);
      i66 = f80 > Math_fround(0.0);
      f80 = i66 ? f80 : Math_fround(0.0);
      f78 = Math_fround(HEAPF32[i75 + (i2 << 5) + 12 >> 2]);
      f77 = Math_fround(f78 - f43);
      i66 = f77 > Math_fround(0.0);
      f77 = Math_fround(Math_fround(f46 * Math_fround(f31 + Math_fround(Math_fround(f44 * f32) - f45))) * Math_fround(f80 + (i66 ? f77 : Math_fround(0.0))));
      f80 = Math_fround(f47 * Math_fround(f3 * f77));
      f32 = Math_fround(f47 * Math_fround(f6 * f77));
      f77 = Math_fround(f47 * Math_fround(f7 * f77));
      f33 = Math_fround(f36 * f33);
      f31 = Math_fround(HEAPF32[i75 + (i2 << 5) + 16 >> 2]);
      f31 = Math_fround(f31 - Math_fround(HEAPF32[i9 >> 2]));
      f81 = Math_fround(HEAPF32[i75 + (i2 << 5) + 20 >> 2]);
      f81 = Math_fround(f81 - Math_fround(HEAPF32[i10 >> 2]));
      f79 = Math_fround(HEAPF32[i75 + (i2 << 5) + 24 >> 2]);
      f80 = Math_fround(Math_fround(f33 * Math_fround(f47 * f31)) + f80);
      f81 = Math_fround(f32 + Math_fround(f33 * Math_fround(f47 * f81)));
      f79 = Math_fround(f77 + Math_fround(f33 * Math_fround(f47 * Math_fround(f79 - Math_fround(HEAPF32[i11 >> 2])))));
      f78 = Math_fround(Math_fround(1.0) / f78);
      f33 = Math_fround(f78 * f80);
      f77 = Math_fround(f78 * f81);
      f78 = Math_fround(f78 * f79);
      HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f33);
      HEAPF32[i12 >> 2] = Math_fround(f77 + Math_fround(HEAPF32[i12 >> 2]));
      HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f78);
      f82 = Math_fround(Math_fround(1.0) / f82);
      f80 = Math_fround(f80 * f82);
      f81 = Math_fround(f81 * f82);
      f82 = Math_fround(f79 * f82);
      i66 = i67 + (i2 * 12 | 0) | 0;
      HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f80);
      i66 = i67 + (i2 * 12 | 0) + 4 | 0;
      HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f81);
      i66 = i67 + (i2 * 12 | 0) + 8 | 0;
      HEAPF32[i66 >> 2] = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f82);
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i72 | 0));
   }
   i38 = i38 + 1 | 0;
  } while ((i38 | 0) != (i71 | 0));
  STACKTOP = i76;
  return;
 } else {
  if (i1) {
   STACKTOP = i76;
   return;
  }
  i39 = (i48 | 0) == 0;
  i40 = i48 >>> 0 < i72 >>> 0;
  f41 = Math_fround(HEAPF32[i65 + 52 >> 2]);
  f42 = Math_fround(HEAPF32[i65 + 24 >> 2]);
  f43 = Math_fround(HEAPF32[i65 + 44 >> 2]);
  f44 = Math_fround(HEAPF32[i65 + 28 >> 2]);
  f45 = Math_fround(f42 * Math_fround(2.0));
  f46 = Math_fround(HEAPF32[i65 + 36 >> 2]);
  f47 = Math_fround(HEAPF32[i65 + 48 >> 2]);
  f36 = Math_fround(HEAPF32[i65 + 40 >> 2]);
  i38 = 0;
  do {
   i35 = HEAP32[i69 + (i38 << 2) >> 2] | 0;
   i5 = i74 + (i35 << 5) | 0;
   i37 = i70 + (i35 * 12 | 0) | 0;
   if (!i39) {
    f8 = Math_fround(HEAPF32[i5 >> 2]);
    f14 = Math_fround(HEAPF32[i74 + (i35 << 5) + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i74 + (i35 << 5) + 8 >> 2]);
    i9 = i74 + (i35 << 5) + 12 | 0;
    i10 = i74 + (i35 << 5) + 16 | 0;
    i11 = i74 + (i35 << 5) + 20 | 0;
    i12 = i74 + (i35 << 5) + 24 | 0;
    i13 = i70 + (i35 * 12 | 0) + 4 | 0;
    i17 = i70 + (i35 * 12 | 0) + 8 | 0;
    i34 = 0;
    do {
     i21 = HEAP32[i73 + (i34 << 2) >> 2] | 0;
     i22 = HEAP32[i73 + ((i34 | 1) << 2) >> 2] | 0;
     i23 = HEAP32[i73 + ((i34 | 2) << 2) >> 2] | 0;
     i24 = HEAP32[i73 + ((i34 | 3) << 2) >> 2] | 0;
     f16 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i21 << 5) >> 2]));
     f18 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i21 << 5) + 4 >> 2]));
     f19 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i21 << 5) + 8 >> 2]));
     f20 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i22 << 5) >> 2]));
     f25 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i22 << 5) + 4 >> 2]));
     f26 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i22 << 5) + 8 >> 2]));
     f27 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i23 << 5) >> 2]));
     f28 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i23 << 5) + 4 >> 2]));
     f29 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i23 << 5) + 8 >> 2]));
     f30 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i24 << 5) >> 2]));
     f31 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i24 << 5) + 4 >> 2]));
     f32 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i24 << 5) + 8 >> 2]));
     f33 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f18 * f18)) + Math_fround(f19 * f19));
     f3 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
     f6 = Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28)) + Math_fround(f29 * f29));
     f7 = Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) + Math_fround(f32 * f32));
     i67 = Math_fround(f68 - f33) >= Math_fround(0.0) | Math_fround(f68 - f3) >= Math_fround(0.0) | Math_fround(f68 - f6) >= Math_fround(0.0) | Math_fround(f68 - f7) >= Math_fround(0.0);
     if (!((i67 ? Math_fround(1.0) : Math_fround(0.0)) == Math_fround(0.0))) {
      i67 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
      if (i67 >>> 0 < i49 >>> 0 & (i67 | 0) != 0) {
       f81 = Math_fround(f41 * f33);
       f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f81 = Math_fround(f81 * f33);
       f79 = Math_fround(f42 - f81);
       f80 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f43);
       i67 = f80 > Math_fround(0.0);
       f80 = i67 ? f80 : Math_fround(0.0);
       f77 = Math_fround(HEAPF32[i75 + (i21 << 5) + 12 >> 2]);
       f78 = Math_fround(f77 - f43);
       i67 = f78 > Math_fround(0.0);
       f78 = Math_fround(Math_fround(f46 * Math_fround(f81 + Math_fround(Math_fround(f44 * f33) - f45))) * Math_fround(f80 + (i67 ? f78 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f16 * f78));
       f33 = Math_fround(f47 * Math_fround(f18 * f78));
       f78 = Math_fround(f47 * Math_fround(f19 * f78));
       f79 = Math_fround(f36 * f79);
       f19 = Math_fround(HEAPF32[i75 + (i21 << 5) + 16 >> 2]);
       f19 = Math_fround(f19 - Math_fround(HEAPF32[i10 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i21 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i11 >> 2]));
       f82 = Math_fround(HEAPF32[i75 + (i21 << 5) + 24 >> 2]);
       f77 = Math_fround(Math_fround(1.0) / f77);
       f80 = Math_fround(f77 * Math_fround(Math_fround(f79 * Math_fround(f47 * f19)) + f80));
       f81 = Math_fround(f77 * Math_fround(f33 + Math_fround(f79 * Math_fround(f47 * f81))));
       f82 = Math_fround(f77 * Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f82 - Math_fround(HEAPF32[i12 >> 2]))))));
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f80);
       HEAPF32[i13 >> 2] = Math_fround(f81 + Math_fround(HEAPF32[i13 >> 2]));
       HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f82);
      }
      if (i1 >>> 0 < i49 >>> 0 & (i1 | 0) != 0) {
       f81 = Math_fround(f41 * f3);
       f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f81 = Math_fround(f81 * f33);
       f79 = Math_fround(f42 - f81);
       f80 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f43);
       i67 = f80 > Math_fround(0.0);
       f80 = i67 ? f80 : Math_fround(0.0);
       f77 = Math_fround(HEAPF32[i75 + (i22 << 5) + 12 >> 2]);
       f78 = Math_fround(f77 - f43);
       i67 = f78 > Math_fround(0.0);
       f78 = Math_fround(Math_fround(f46 * Math_fround(f81 + Math_fround(Math_fround(f44 * f33) - f45))) * Math_fround(f80 + (i67 ? f78 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f20 * f78));
       f33 = Math_fround(f47 * Math_fround(f25 * f78));
       f78 = Math_fround(f47 * Math_fround(f26 * f78));
       f79 = Math_fround(f36 * f79);
       f26 = Math_fround(HEAPF32[i75 + (i22 << 5) + 16 >> 2]);
       f26 = Math_fround(f26 - Math_fround(HEAPF32[i10 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i22 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i11 >> 2]));
       f82 = Math_fround(HEAPF32[i75 + (i22 << 5) + 24 >> 2]);
       f77 = Math_fround(Math_fround(1.0) / f77);
       f80 = Math_fround(f77 * Math_fround(Math_fround(f79 * Math_fround(f47 * f26)) + f80));
       f81 = Math_fround(f77 * Math_fround(f33 + Math_fround(f79 * Math_fround(f47 * f81))));
       f82 = Math_fround(f77 * Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f82 - Math_fround(HEAPF32[i12 >> 2]))))));
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f80);
       HEAPF32[i13 >> 2] = Math_fround(f81 + Math_fround(HEAPF32[i13 >> 2]));
       HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f82);
      }
      if (i2 >>> 0 < i49 >>> 0 & (i2 | 0) != 0) {
       f81 = Math_fround(f41 * f6);
       f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f81 = Math_fround(f81 * f33);
       f79 = Math_fround(f42 - f81);
       f80 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f43);
       i67 = f80 > Math_fround(0.0);
       f80 = i67 ? f80 : Math_fround(0.0);
       f77 = Math_fround(HEAPF32[i75 + (i23 << 5) + 12 >> 2]);
       f78 = Math_fround(f77 - f43);
       i67 = f78 > Math_fround(0.0);
       f78 = Math_fround(Math_fround(f46 * Math_fround(f81 + Math_fround(Math_fround(f44 * f33) - f45))) * Math_fround(f80 + (i67 ? f78 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f27 * f78));
       f33 = Math_fround(f47 * Math_fround(f28 * f78));
       f78 = Math_fround(f47 * Math_fround(f29 * f78));
       f79 = Math_fround(f36 * f79);
       f29 = Math_fround(HEAPF32[i75 + (i23 << 5) + 16 >> 2]);
       f29 = Math_fround(f29 - Math_fround(HEAPF32[i10 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i23 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i11 >> 2]));
       f82 = Math_fround(HEAPF32[i75 + (i23 << 5) + 24 >> 2]);
       f77 = Math_fround(Math_fround(1.0) / f77);
       f80 = Math_fround(f77 * Math_fround(Math_fround(f79 * Math_fround(f47 * f29)) + f80));
       f81 = Math_fround(f77 * Math_fround(f33 + Math_fround(f79 * Math_fround(f47 * f81))));
       f82 = Math_fround(f77 * Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f82 - Math_fround(HEAPF32[i12 >> 2]))))));
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f80);
       HEAPF32[i13 >> 2] = Math_fround(f81 + Math_fround(HEAPF32[i13 >> 2]));
       HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f82);
      }
      if (i4 >>> 0 < i49 >>> 0 & (i4 | 0) != 0) {
       f81 = Math_fround(f41 * f7);
       f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f81))));
       f81 = Math_fround(f81 * f33);
       f79 = Math_fround(f42 - f81);
       f80 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f43);
       i67 = f80 > Math_fround(0.0);
       f80 = i67 ? f80 : Math_fround(0.0);
       f77 = Math_fround(HEAPF32[i75 + (i24 << 5) + 12 >> 2]);
       f78 = Math_fround(f77 - f43);
       i67 = f78 > Math_fround(0.0);
       f78 = Math_fround(Math_fround(f46 * Math_fround(f81 + Math_fround(Math_fround(f44 * f33) - f45))) * Math_fround(f80 + (i67 ? f78 : Math_fround(0.0))));
       f80 = Math_fround(f47 * Math_fround(f30 * f78));
       f33 = Math_fround(f47 * Math_fround(f31 * f78));
       f78 = Math_fround(f47 * Math_fround(f32 * f78));
       f79 = Math_fround(f36 * f79);
       f32 = Math_fround(HEAPF32[i75 + (i24 << 5) + 16 >> 2]);
       f32 = Math_fround(f32 - Math_fround(HEAPF32[i10 >> 2]));
       f81 = Math_fround(HEAPF32[i75 + (i24 << 5) + 20 >> 2]);
       f81 = Math_fround(f81 - Math_fround(HEAPF32[i11 >> 2]));
       f82 = Math_fround(HEAPF32[i75 + (i24 << 5) + 24 >> 2]);
       f77 = Math_fround(Math_fround(1.0) / f77);
       f80 = Math_fround(f77 * Math_fround(Math_fround(f79 * Math_fround(f47 * f32)) + f80));
       f81 = Math_fround(f77 * Math_fround(f33 + Math_fround(f79 * Math_fround(f47 * f81))));
       f82 = Math_fround(f77 * Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f82 - Math_fround(HEAPF32[i12 >> 2]))))));
       HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f80);
       HEAPF32[i13 >> 2] = Math_fround(f81 + Math_fround(HEAPF32[i13 >> 2]));
       HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f82);
      }
     }
     i34 = i34 + 4 | 0;
    } while (i34 >>> 0 < i48 >>> 0);
   }
   if (i40) {
    f14 = Math_fround(HEAPF32[i5 >> 2]);
    f15 = Math_fround(HEAPF32[i74 + (i35 << 5) + 4 >> 2]);
    f16 = Math_fround(HEAPF32[i74 + (i35 << 5) + 8 >> 2]);
    i5 = i74 + (i35 << 5) + 12 | 0;
    i9 = i74 + (i35 << 5) + 16 | 0;
    i10 = i74 + (i35 << 5) + 20 | 0;
    i11 = i74 + (i35 << 5) + 24 | 0;
    i12 = i70 + (i35 * 12 | 0) + 4 | 0;
    i2 = i70 + (i35 * 12 | 0) + 8 | 0;
    i4 = i48;
    do {
     i1 = HEAP32[i73 + (i4 << 2) >> 2] | 0;
     f3 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i1 << 5) >> 2]));
     f6 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i1 << 5) + 4 >> 2]));
     f7 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i1 << 5) + 8 >> 2]));
     f8 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
     i67 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     if (i67 >>> 0 < i49 >>> 0 & (i67 | 0) != 0) {
      f32 = Math_fround(f41 * f8);
      f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f32))));
      f32 = Math_fround(f32 * f33);
      f79 = Math_fround(f42 - f32);
      f80 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f43);
      i67 = f80 > Math_fround(0.0);
      f80 = i67 ? f80 : Math_fround(0.0);
      f77 = Math_fround(HEAPF32[i75 + (i1 << 5) + 12 >> 2]);
      f78 = Math_fround(f77 - f43);
      i67 = f78 > Math_fround(0.0);
      f78 = Math_fround(Math_fround(f46 * Math_fround(f32 + Math_fround(Math_fround(f44 * f33) - f45))) * Math_fround(f80 + (i67 ? f78 : Math_fround(0.0))));
      f80 = Math_fround(f47 * Math_fround(f3 * f78));
      f33 = Math_fround(f47 * Math_fround(f6 * f78));
      f78 = Math_fround(f47 * Math_fround(f7 * f78));
      f79 = Math_fround(f36 * f79);
      f32 = Math_fround(HEAPF32[i75 + (i1 << 5) + 16 >> 2]);
      f32 = Math_fround(f32 - Math_fround(HEAPF32[i9 >> 2]));
      f81 = Math_fround(HEAPF32[i75 + (i1 << 5) + 20 >> 2]);
      f81 = Math_fround(f81 - Math_fround(HEAPF32[i10 >> 2]));
      f82 = Math_fround(HEAPF32[i75 + (i1 << 5) + 24 >> 2]);
      f77 = Math_fround(Math_fround(1.0) / f77);
      f80 = Math_fround(f77 * Math_fround(Math_fround(f79 * Math_fround(f47 * f32)) + f80));
      f81 = Math_fround(f77 * Math_fround(f33 + Math_fround(f79 * Math_fround(f47 * f81))));
      f82 = Math_fround(f77 * Math_fround(f78 + Math_fround(f79 * Math_fround(f47 * Math_fround(f82 - Math_fround(HEAPF32[i11 >> 2]))))));
      HEAPF32[i37 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f80);
      HEAPF32[i12 >> 2] = Math_fround(f81 + Math_fround(HEAPF32[i12 >> 2]));
      HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f82);
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i72 | 0));
   }
   i38 = i38 + 1 | 0;
  } while ((i38 | 0) != (i71 | 0));
  STACKTOP = i76;
  return;
 }
 if (!i64) {
  if (i1) {
   STACKTOP = i76;
   return;
  }
  i13 = (i48 | 0) == 0;
  i17 = i48 >>> 0 < i72 >>> 0;
  f19 = Math_fround(HEAPF32[i65 + 28 >> 2]);
  f20 = Math_fround(HEAPF32[i65 + 32 >> 2]);
  f18 = Math_fround(HEAPF32[i65 + 52 >> 2]);
  i12 = 0;
  do {
   i11 = HEAP32[i69 + (i12 << 2) >> 2] | 0;
   i1 = i74 + (i11 << 5) | 0;
   if (!i13) {
    f3 = Math_fround(HEAPF32[i1 >> 2]);
    f6 = Math_fround(HEAPF32[i74 + (i11 << 5) + 4 >> 2]);
    f7 = Math_fround(HEAPF32[i74 + (i11 << 5) + 8 >> 2]);
    i2 = i74 + (i11 << 5) + 12 | 0;
    i10 = 0;
    do {
     i65 = HEAP32[i73 + (i10 << 2) >> 2] | 0;
     i66 = HEAP32[i73 + ((i10 | 1) << 2) >> 2] | 0;
     i67 = HEAP32[i73 + ((i10 | 2) << 2) >> 2] | 0;
     i70 = HEAP32[i73 + ((i10 | 3) << 2) >> 2] | 0;
     f46 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i65 << 5) >> 2]));
     f47 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i65 << 5) + 4 >> 2]));
     f8 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i65 << 5) + 8 >> 2]));
     f77 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i66 << 5) >> 2]));
     f78 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i66 << 5) + 4 >> 2]));
     f14 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i66 << 5) + 8 >> 2]));
     f79 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i67 << 5) >> 2]));
     f80 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i67 << 5) + 4 >> 2]));
     f15 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i67 << 5) + 8 >> 2]));
     f81 = Math_fround(f3 - Math_fround(HEAPF32[i75 + (i70 << 5) >> 2]));
     f82 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i70 << 5) + 4 >> 2]));
     f16 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i70 << 5) + 8 >> 2]));
     f8 = Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f8 * f8));
     f14 = Math_fround(Math_fround(Math_fround(f77 * f77) + Math_fround(f78 * f78)) + Math_fround(f14 * f14));
     f15 = Math_fround(Math_fround(Math_fround(f79 * f79) + Math_fround(f80 * f80)) + Math_fround(f15 * f15));
     f16 = Math_fround(Math_fround(Math_fround(f81 * f81) + Math_fround(f82 * f82)) + Math_fround(f16 * f16));
     i70 = Math_fround(f68 - f8) >= Math_fround(0.0) | Math_fround(f68 - f14) >= Math_fround(0.0) | Math_fround(f68 - f15) >= Math_fround(0.0) | Math_fround(f68 - f16) >= Math_fround(0.0);
     if (!((i70 ? Math_fround(1.0) : Math_fround(0.0)) == Math_fround(0.0))) {
      i70 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
      i9 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
      if (i70 >>> 0 < i49 >>> 0 & (i70 | 0) != 0) {
       f82 = Math_fround(f19 - Math_fround(f18 * f8));
       f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
       HEAPF32[i2 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i2 >> 2]));
      }
      if (i4 >>> 0 < i49 >>> 0 & (i4 | 0) != 0) {
       f82 = Math_fround(f19 - Math_fround(f18 * f14));
       f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
       HEAPF32[i2 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i2 >> 2]));
      }
      if (i5 >>> 0 < i49 >>> 0 & (i5 | 0) != 0) {
       f82 = Math_fround(f19 - Math_fround(f18 * f15));
       f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
       HEAPF32[i2 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i2 >> 2]));
      }
      if (i9 >>> 0 < i49 >>> 0 & (i9 | 0) != 0) {
       f82 = Math_fround(f19 - Math_fround(f18 * f16));
       f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
       HEAPF32[i2 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i2 >> 2]));
      }
     }
     i10 = i10 + 4 | 0;
    } while (i10 >>> 0 < i48 >>> 0);
   }
   if (i17) {
    f6 = Math_fround(HEAPF32[i1 >> 2]);
    f7 = Math_fround(HEAPF32[i74 + (i11 << 5) + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i74 + (i11 << 5) + 8 >> 2]);
    i1 = i74 + (i11 << 5) + 12 | 0;
    i2 = i48;
    do {
     i70 = HEAP32[i73 + (i2 << 2) >> 2] | 0;
     f81 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i70 << 5) >> 2]));
     f82 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i70 << 5) + 4 >> 2]));
     f3 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i70 << 5) + 8 >> 2]));
     f3 = Math_fround(Math_fround(Math_fround(f81 * f81) + Math_fround(f82 * f82)) + Math_fround(f3 * f3));
     i70 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
     if (i70 >>> 0 < i49 >>> 0 & (i70 | 0) != 0) {
      f82 = Math_fround(f19 - Math_fround(f18 * f3));
      f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
      HEAPF32[i1 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i1 >> 2]));
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i72 | 0));
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i71 | 0));
  STACKTOP = i76;
  return;
 }
 if (i1) {
  STACKTOP = i76;
  return;
 }
 i21 = i48 >>> 0 < i72 >>> 0;
 f19 = Math_fround(HEAPF32[i65 + 28 >> 2]);
 f20 = Math_fround(HEAPF32[i65 + 32 >> 2]);
 f18 = Math_fround(HEAPF32[i65 + 52 >> 2]);
 if (!i48) {
  i5 = 0;
  do {
   i1 = HEAP32[i69 + (i5 << 2) >> 2] | 0;
   if (i21) {
    f6 = Math_fround(HEAPF32[i74 + (i1 << 5) >> 2]);
    f7 = Math_fround(HEAPF32[i74 + (i1 << 5) + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i74 + (i1 << 5) + 8 >> 2]);
    i1 = i74 + (i1 << 5) + 12 | 0;
    i4 = 0;
    do {
     i2 = HEAP32[i73 + (i4 << 2) >> 2] | 0;
     f81 = Math_fround(f6 - Math_fround(HEAPF32[i75 + (i2 << 5) >> 2]));
     f82 = Math_fround(f7 - Math_fround(HEAPF32[i75 + (i2 << 5) + 4 >> 2]));
     f3 = Math_fround(f8 - Math_fround(HEAPF32[i75 + (i2 << 5) + 8 >> 2]));
     f3 = Math_fround(Math_fround(Math_fround(f81 * f81) + Math_fround(f82 * f82)) + Math_fround(f3 * f3));
     i70 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
     if (i70 >>> 0 < i49 >>> 0 & (i70 | 0) != 0) {
      f82 = Math_fround(f19 - Math_fround(f18 * f3));
      f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
      HEAPF32[i1 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i1 >> 2]));
      i70 = i75 + (i2 << 5) + 12 | 0;
      HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i72 | 0));
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i71 | 0));
  STACKTOP = i76;
  return;
 } else i17 = 0;
 do {
  i13 = HEAP32[i69 + (i17 << 2) >> 2] | 0;
  f14 = Math_fround(HEAPF32[i74 + (i13 << 5) >> 2]);
  f15 = Math_fround(HEAPF32[i74 + (i13 << 5) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i74 + (i13 << 5) + 8 >> 2]);
  i13 = i74 + (i13 << 5) + 12 | 0;
  i12 = 0;
  do {
   i5 = HEAP32[i73 + (i12 << 2) >> 2] | 0;
   i9 = HEAP32[i73 + ((i12 | 1) << 2) >> 2] | 0;
   i10 = HEAP32[i73 + ((i12 | 2) << 2) >> 2] | 0;
   i11 = HEAP32[i73 + ((i12 | 3) << 2) >> 2] | 0;
   f46 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i5 << 5) >> 2]));
   f47 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i5 << 5) + 4 >> 2]));
   f7 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i5 << 5) + 8 >> 2]));
   f77 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i9 << 5) >> 2]));
   f78 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i9 << 5) + 4 >> 2]));
   f8 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i9 << 5) + 8 >> 2]));
   f79 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i10 << 5) >> 2]));
   f80 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i10 << 5) + 4 >> 2]));
   f3 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i10 << 5) + 8 >> 2]));
   f81 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i11 << 5) >> 2]));
   f82 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i11 << 5) + 4 >> 2]));
   f6 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i11 << 5) + 8 >> 2]));
   f7 = Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f47 * f47)) + Math_fround(f7 * f7));
   f8 = Math_fround(Math_fround(Math_fround(f77 * f77) + Math_fround(f78 * f78)) + Math_fround(f8 * f8));
   f3 = Math_fround(Math_fround(Math_fround(f79 * f79) + Math_fround(f80 * f80)) + Math_fround(f3 * f3));
   f6 = Math_fround(Math_fround(Math_fround(f81 * f81) + Math_fround(f82 * f82)) + Math_fround(f6 * f6));
   i70 = Math_fround(f68 - f7) >= Math_fround(0.0) | Math_fround(f68 - f8) >= Math_fround(0.0) | Math_fround(f68 - f3) >= Math_fround(0.0) | Math_fround(f68 - f6) >= Math_fround(0.0);
   if (!((i70 ? Math_fround(1.0) : Math_fround(0.0)) == Math_fround(0.0))) {
    i70 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    if (i70 >>> 0 < i49 >>> 0 & (i70 | 0) != 0) {
     f82 = Math_fround(f19 - Math_fround(f18 * f7));
     f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
     HEAPF32[i13 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i13 >> 2]));
     i70 = i75 + (i5 << 5) + 12 | 0;
     HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
    }
    if (i1 >>> 0 < i49 >>> 0 & (i1 | 0) != 0) {
     f82 = Math_fround(f19 - Math_fround(f18 * f8));
     f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
     HEAPF32[i13 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i13 >> 2]));
     i70 = i75 + (i9 << 5) + 12 | 0;
     HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
    }
    if (i2 >>> 0 < i49 >>> 0 & (i2 | 0) != 0) {
     f82 = Math_fround(f19 - Math_fround(f18 * f3));
     f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
     HEAPF32[i13 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i13 >> 2]));
     i70 = i75 + (i10 << 5) + 12 | 0;
     HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
    }
    if (i4 >>> 0 < i49 >>> 0 & (i4 | 0) != 0) {
     f82 = Math_fround(f19 - Math_fround(f18 * f6));
     f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
     HEAPF32[i13 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i13 >> 2]));
     i70 = i75 + (i11 << 5) + 12 | 0;
     HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
    }
   }
   i12 = i12 + 4 | 0;
  } while (i12 >>> 0 < i48 >>> 0);
  if (i21) {
   i2 = i48;
   do {
    i1 = HEAP32[i73 + (i2 << 2) >> 2] | 0;
    f81 = Math_fround(f14 - Math_fround(HEAPF32[i75 + (i1 << 5) >> 2]));
    f82 = Math_fround(f15 - Math_fround(HEAPF32[i75 + (i1 << 5) + 4 >> 2]));
    f3 = Math_fround(f16 - Math_fround(HEAPF32[i75 + (i1 << 5) + 8 >> 2]));
    f3 = Math_fround(Math_fround(Math_fround(f81 * f81) + Math_fround(f82 * f82)) + Math_fround(f3 * f3));
    i70 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    if (i70 >>> 0 < i49 >>> 0 & (i70 | 0) != 0) {
     f82 = Math_fround(f19 - Math_fround(f18 * f3));
     f82 = Math_fround(f82 * Math_fround(f82 * Math_fround(f20 * f82)));
     HEAPF32[i13 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i13 >> 2]));
     i70 = i75 + (i1 << 5) + 12 | 0;
     HEAPF32[i70 >> 2] = Math_fround(f82 + Math_fround(HEAPF32[i70 >> 2]));
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i72 | 0));
  }
  i17 = i17 + 1 | 0;
 } while ((i17 | 0) != (i71 | 0));
 STACKTOP = i76;
 return;
}

function __ZN5Umbra12PortalCuller12finalizeCellEt(i147, i1) {
 i147 = i147 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, f187 = f0, f188 = f0, f189 = f0, f190 = f0;
 i149 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i136 = i149;
 i142 = i149 + 176 | 0;
 i137 = i149 + 80 | 0;
 i138 = i149 + 64 | 0;
 i139 = i149 + 48 | 0;
 i140 = i149 + 32 | 0;
 i141 = i149 + 16 | 0;
 i145 = i1 & 65535;
 i143 = HEAP32[i147 + 2300 >> 2] | 0;
 i133 = (HEAP32[i147 + 2828 >> 2] | 0) + (Math_imul(HEAP32[i147 + 2844 >> 2] | 0, HEAPU16[i143 + (i145 << 4) + 4 >> 1] | 0) | 0) | 0;
 i3 = HEAP32[i133 + 8 >> 2] | 0;
 i13 = HEAP32[i133 + 12 >> 2] | 0;
 i2 = HEAP32[i133 + 16 >> 2] | 0;
 i148 = HEAP32[i133 + 20 >> 2] | 0;
 i134 = HEAP32[i133 + 24 >> 2] | 0;
 i132 = HEAP32[i133 + 28 >> 2] | 0;
 i133 = HEAP32[i133 + 32 >> 2] | 0;
 i146 = HEAP32[i147 + 2700 >> 2] | 0;
 i127 = HEAP32[i146 + 316 >> 2] | 0;
 i127 = (i127 | 0) == 0 ? 0 : i146 + i127 | 0;
 i128 = HEAP32[i146 + 320 >> 2] | 0;
 i128 = (i128 | 0) == 0 ? 0 : i146 + i128 | 0;
 i129 = HEAP32[i146 + 324 >> 2] | 0;
 i129 = (i129 | 0) == 0 ? 0 : i146 + i129 | 0;
 i130 = HEAP32[i146 + 328 >> 2] | 0;
 i144 = i147 + 8 | 0;
 i1 = HEAP32[i144 >> 2] | 0;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  if (HEAP32[i1 + 16 >> 2] | 0) i135 = 3;
 } else i135 = 3;
 if ((i135 | 0) == 3) {
  i131 = i147 + 2900 | 0;
  i12 = HEAP32[i146 + 84 >> 2] | 0;
  i11 = i12 & 31;
  i12 = i12 >>> 5 & 31;
  i8 = i12 + i11 | 0;
  i3 = Math_imul(i8, i3) | 0;
  i6 = ((Math_imul(i8, HEAP32[i146 + 92 >> 2] | 0) | 0) + 31 >> 5 << 5) - i3 | 0;
  if (i6 | 0) {
   HEAP32[i131 >> 2] = i146 + (HEAP32[i146 + 88 >> 2] | 0);
   HEAP32[i147 + 2904 >> 2] = i6;
   HEAP32[i147 + 2908 >> 2] = i3;
  }
  i126 = i147 + 2932 | 0;
  HEAP8[i126 >> 0] = i8 >>> 0 > 31 & 1;
  i125 = i147 + 2912 | 0;
  HEAP32[i125 >> 2] = i11;
  i124 = i147 + 2916 | 0;
  HEAP32[i124 >> 2] = i12;
  i112 = i147 + 2920 | 0;
  HEAP32[i112 >> 2] = i13;
  i113 = i147 + 2928 | 0;
  HEAP32[i113 >> 2] = 0;
  i114 = i147 + 20 | 0;
  i115 = (HEAP32[i114 >> 2] | 0) != 0;
  i116 = i143 + (i145 << 4) + 8 | 0;
  i120 = HEAP32[i116 >> 2] | 0;
  i117 = i120 << 3 & 2040;
  i118 = i120 >>> 6 & 1020;
  i119 = i120 >>> 13 & 2040;
  i120 = i120 >>> 24 << 2;
  i121 = (HEAP32[i147 + 2724 >> 2] | 0) == 0;
  i122 = i147 + 4 | 0;
  i110 = HEAP32[i122 >> 2] | 0;
  i123 = (HEAP8[i110 + 1365 >> 0] | 0) == 0;
  f63 = Math_fround(HEAPF32[i110 + 128 >> 2]);
  f64 = Math_fround(HEAPF32[i110 + 132 >> 2]);
  f64 = Math_fround(-f64);
  f65 = Math_fround(-Math_fround(HEAPF32[i110 + 136 >> 2]));
  HEAPF32[i137 >> 2] = Math_fround(-f63);
  i110 = i137 + 4 | 0;
  HEAPF32[i110 >> 2] = f64;
  i111 = i137 + 8 | 0;
  HEAPF32[i111 >> 2] = f65;
  if (i13) {
   i69 = i147 + 12 | 0;
   i70 = i147 + 28 | 0;
   i71 = i147 + 24 | 0;
   i72 = i147 + 16 | 0;
   i73 = i147 + 328 | 0;
   i74 = i147 + 332 | 0;
   i75 = i147 + 336 | 0;
   i76 = i147 + 312 | 0;
   i77 = i147 + 316 | 0;
   i78 = i147 + 320 | 0;
   i79 = i147 + 324 | 0;
   i80 = i147 + 2732 | 0;
   i81 = i147 + 7041 | 0;
   i82 = i136 + 4 | 0;
   i83 = i136 + 8 | 0;
   i84 = i136 + 12 | 0;
   i85 = i147 + 7044 | 0;
   i86 = i142 + 4 | 0;
   i87 = i142 + 8 | 0;
   i88 = i138 + 4 | 0;
   i89 = i138 + 8 | 0;
   i90 = i139 + 4 | 0;
   i91 = i139 + 8 | 0;
   i92 = i139 + 12 | 0;
   i93 = i147 + 392 | 0;
   i94 = i147 + 7036 | 0;
   i95 = i142 + 4 | 0;
   i96 = i142 + 8 | 0;
   i97 = i136 + 4 | 0;
   i98 = i136 + 8 | 0;
   i99 = i142 + 4 | 0;
   i100 = i142 + 8 | 0;
   i101 = i142 + 12 | 0;
   i102 = i136 + 4 | 0;
   i103 = i136 + 8 | 0;
   i104 = i147 + 2736 | 0;
   i105 = i147 + 2908 | 0;
   i106 = i147 + 2904 | 0;
   i107 = i147 + 2924 | 0;
   i108 = i147 + 2696 | 0;
   i109 = i147 + 2704 | 0;
   i1 = i13;
   i67 = i13;
   do {
    i68 = (i67 | 0) > 32 ? 32 : i67;
    if ((i67 | 0) > 0) {
     i20 = 0;
     i21 = 0;
     do {
      i3 = HEAP32[i113 >> 2] | 0;
      do if (!i3) {
       i13 = HEAP32[i125 >> 2] | 0;
       if (!(HEAP8[i126 >> 0] | 0)) {
        i6 = (HEAP32[i124 >> 2] | 0) + i13 | 0;
        i32 = HEAP32[i131 >> 2] | 0;
        i66 = HEAP32[i105 >> 2] | 0;
        i33 = i66 >> 5;
        i3 = i66 & 31;
        i3 = (HEAP32[i32 + (i33 + 1 << 2) >> 2] << 32 - i3 & -1 << (i3 ^ 31) | (HEAP32[i32 + (i33 << 2) >> 2] | 0) >>> i3) & (1 << i6) + -1;
        HEAP32[i105 >> 2] = i66 + i6;
        HEAP32[i106 >> 2] = (HEAP32[i106 >> 2] | 0) - i6;
        i6 = i3 & (1 << i13) + -1;
        HEAP32[i107 >> 2] = i6;
        i3 = i3 >>> i13;
        HEAP32[i113 >> 2] = i3;
        break;
       }
       i16 = HEAP32[i131 >> 2] | 0;
       i12 = HEAP32[i105 >> 2] | 0;
       i11 = i12 >> 5;
       i3 = i12 & 31;
       i6 = (HEAP32[i16 + (i11 << 2) >> 2] | 0) >>> i3;
       i8 = 32 - i3 | 0;
       i11 = HEAP32[i16 + (i11 + 1 << 2) >> 2] << i8;
       if ((i13 | 0) < 32) i6 = (i11 & -1 << (i3 ^ 31) | i6) & (1 << i13) + -1; else i6 = -1 << i8 & 0 - i3 >> 31 & i11 | i6;
       i15 = i12 + i13 | 0;
       HEAP32[i105 >> 2] = i15;
       i13 = (HEAP32[i106 >> 2] | 0) - i13 | 0;
       HEAP32[i106 >> 2] = i13;
       HEAP32[i107 >> 2] = i6;
       i14 = HEAP32[i124 >> 2] | 0;
       i3 = i15 >> 5;
       i8 = i15 & 31;
       i11 = (HEAP32[i16 + (i3 << 2) >> 2] | 0) >>> i8;
       i12 = 32 - i8 | 0;
       i3 = HEAP32[i16 + (i3 + 1 << 2) >> 2] << i12;
       if ((i14 | 0) < 32) i3 = (i3 & -1 << (i8 ^ 31) | i11) & (1 << i14) + -1; else i3 = -1 << i12 & 0 - i8 >> 31 & i3 | i11;
       HEAP32[i105 >> 2] = i14 + i15;
       HEAP32[i106 >> 2] = i13 - i14;
       HEAP32[i113 >> 2] = i3;
      } else i6 = HEAP32[i107 >> 2] | 0; while (0);
      HEAP32[i112 >> 2] = (HEAP32[i112 >> 2] | 0) + -1;
      HEAP32[i113 >> 2] = i3 + -1;
      HEAP32[i107 >> 2] = i6 + 1;
      i3 = HEAP32[i108 >> 2] | 0;
      if (!i3) i3 = i6; else i3 = HEAP32[(HEAP32[i109 >> 2] | 0) + (HEAP32[i3 + 8 >> 2] | 0) + (i6 << 2) >> 2] | 0;
      if (!(HEAP32[(HEAP32[(HEAP32[i144 >> 2] | 0) + 12 >> 2] | 0) + (i3 >> 5 << 2) >> 2] & 1 << (i3 & 31))) {
       HEAP32[i147 + 156 + (i20 << 2) >> 2] = i6;
       HEAP32[i147 + 28 + (i20 << 2) >> 2] = i3;
       i20 = i20 + 1 | 0;
      }
      i21 = i21 + 1 | 0;
     } while ((i21 | 0) < (i68 | 0));
     if (!i20) i135 = 26; else {
      if (i115) HEAP32[i71 >> 2] = i70;
      HEAP32[i72 >> 2] = i70;
      i1 = i1 - i68 | 0;
      if ((i20 | 0) > 0) {
       i66 = 0;
       do {
        i3 = HEAP32[(HEAP32[i147 >> 2] | 0) + 60 >> 2] | 0;
        i31 = i3 + 28 | 0;
        i22 = HEAP32[i31 >> 2] | 0;
        HEAP32[i31 >> 2] = ((i22 | 0) < 0 ? 0 : i22) + 1;
        i31 = HEAP32[i147 + 28 + (i66 << 2) >> 2] | 0;
        i22 = HEAP32[i147 + 156 + (i66 << 2) >> 2] | 0;
        do if (i115) {
         f61 = Math_fround(HEAPF32[i73 >> 2]);
         f7 = Math_fround(HEAPF32[i74 >> 2]);
         f60 = Math_fround(HEAPF32[i75 >> 2]);
         i32 = HEAP32[i114 >> 2] | 0;
         i33 = HEAP32[(HEAP32[i71 >> 2] | 0) + (i66 << 2) >> 2] | 0;
         f64 = Math_fround(HEAPF32[i76 >> 2]);
         f65 = Math_fround(HEAPF32[i77 >> 2]);
         f63 = Math_fround(HEAPF32[i78 >> 2]);
         f62 = Math_fround(HEAPF32[i79 >> 2]);
         i30 = i32 + (i33 << 5) | 0;
         f55 = Math_fround(HEAPF32[i30 >> 2]);
         f57 = Math_fround(HEAPF32[i30 + 4 >> 2]);
         f59 = Math_fround(HEAPF32[i30 + 8 >> 2]);
         f4 = Math_fround(HEAPF32[i30 + 12 >> 2]);
         i33 = i32 + (i33 << 5) + 16 | 0;
         f54 = Math_fround(HEAPF32[i33 >> 2]);
         f56 = Math_fround(HEAPF32[i33 + 4 >> 2]);
         f58 = Math_fround(HEAPF32[i33 + 8 >> 2]);
         f5 = Math_fround(HEAPF32[i33 + 12 >> 2]);
         f55 = f55 >= f61 ? f55 : f61;
         f57 = f57 >= f7 ? f57 : f7;
         f59 = f59 >= f60 ? f59 : f60;
         f61 = Math_fround((f54 <= f55 ? f54 : f55) - f61);
         f7 = Math_fround((f56 <= f57 ? f56 : f57) - f7);
         f60 = Math_fround((f58 <= f59 ? f58 : f59) - f60);
         f7 = Math_fround(Math_fround(Math_fround(f60 * f60) + Math_fround(Math_fround(f61 * f61) + Math_fround(f7 * f7))) + Math_fround(0.0));
         f64 = Math_fround(f64 * f7);
         f65 = Math_fround(f65 * f7);
         f63 = Math_fround(f63 * f7);
         f7 = Math_fround(f62 * f7);
         if (!(f63 >= f5 | f4 > f63 | (f64 >= f5 | f4 > f64 | (f65 >= f5 | f4 > f65)))) if (!(f4 > f7) & !(f7 >= f5)) {
          i135 = 34;
          break;
         }
         i33 = (HEAP32[(HEAP32[i144 >> 2] | 0) + 12 >> 2] | 0) + (i31 >> 5 << 2) | 0;
         HEAP32[i33 >> 2] = HEAP32[i33 >> 2] | 1 << (i31 & 31);
         i33 = i3 + 40 | 0;
         i32 = HEAP32[i33 >> 2] | 0;
         HEAP32[i33 >> 2] = ((i32 | 0) < 0 ? 0 : i32) + 1;
        } else i135 = 34; while (0);
        L48 : do if ((i135 | 0) == 34) {
         i135 = 0;
         i23 = HEAP32[i69 >> 2] | 0;
         i13 = HEAP32[(HEAP32[i72 >> 2] | 0) + (i66 << 2) >> 2] | 0;
         i32 = i23 + (i13 * 24 | 0) | 0;
         f10 = Math_fround(HEAPF32[i32 >> 2]);
         f17 = Math_fround(HEAPF32[i23 + (i13 * 24 | 0) + 4 >> 2]);
         f18 = Math_fround(HEAPF32[i23 + (i13 * 24 | 0) + 8 >> 2]);
         i33 = i23 + (i13 * 24 | 0) + 12 | 0;
         f63 = Math_fround(HEAPF32[i33 >> 2]);
         f64 = Math_fround(HEAPF32[i23 + (i13 * 24 | 0) + 16 >> 2]);
         f65 = Math_fround(HEAPF32[i23 + (i13 * 24 | 0) + 20 >> 2]);
         i13 = HEAP32[i122 >> 2] | 0;
         f19 = Math_fround(HEAPF32[i13 + 1208 >> 2]);
         f34 = Math_fround(HEAPF32[i13 + 1212 >> 2]);
         f35 = Math_fround(HEAPF32[i13 + 1216 >> 2]);
         f5 = Math_fround(HEAPF32[i13 + 1220 >> 2]);
         f10 = Math_fround(f10 - f19);
         f17 = Math_fround(f17 - f34);
         f18 = Math_fround(f18 - f35);
         f4 = Math_fround(Math_fround(1.0) - f5);
         i23 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
         i25 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
         i27 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
         i29 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
         f19 = Math_fround(f63 + f19);
         f34 = Math_fround(f64 + f34);
         f35 = Math_fround(f65 + f35);
         f5 = Math_fround(f5 + Math_fround(1.0));
         i24 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
         i26 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
         i28 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
         i30 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
         i3 = HEAP32[i80 >> 2] | 0;
         if (i3 | 0) {
          i8 = f10 > Math_fround(HEAPF32[i13 + 1332 >> 2]);
          i11 = f17 > Math_fround(HEAPF32[i13 + 1336 >> 2]);
          i12 = f18 > Math_fround(HEAPF32[i13 + 1340 >> 2]);
          i14 = f4 > Math_fround(HEAPF32[i13 + 1344 >> 2]);
          i15 = Math_fround(HEAPF32[i13 + 1316 >> 2]) > f19;
          i16 = Math_fround(HEAPF32[i13 + 1320 >> 2]) > f34;
          i21 = Math_fround(HEAPF32[i13 + 1324 >> 2]) > f35;
          i15 = i8 | i15;
          i16 = i11 | i16;
          i21 = i12 | i21;
          i14 = i14 | Math_fround(HEAPF32[i13 + 1328 >> 2]) > f5;
          if ((i3 | 0) > 3) {
           i8 = i3 + -4 | 0;
           i11 = i8 & -4;
           i12 = i11 + 4 | 0;
           i6 = i104;
           f9 = Math_fround(0.0);
           f7 = Math_fround(0.0);
           f5 = Math_fround(0.0);
           f4 = Math_fround(0.0);
           while (1) {
            i156 = HEAP32[i6 >> 2] | 0;
            i155 = HEAP32[i6 + 4 >> 2] | 0;
            i154 = HEAP32[i6 + 8 >> 2] | 0;
            i150 = HEAP32[i6 + 12 >> 2] | 0;
            i157 = HEAP32[i13 + 832 + (i156 << 4) >> 2] | 0;
            i151 = HEAP32[i13 + 832 + (i156 << 4) + 4 >> 2] | 0;
            i152 = HEAP32[i13 + 832 + (i156 << 4) + 8 >> 2] | 0;
            i153 = HEAP32[i13 + 832 + (i156 << 4) + 12 >> 2] | 0;
            f61 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i157 | i157 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f61 = Math_fround(f61 * Math_fround(HEAPF32[i13 + 480 + (i156 << 4) >> 2]));
            f62 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i151 | i151 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f62 = Math_fround(f62 * Math_fround(HEAPF32[i13 + 480 + (i156 << 4) + 4 >> 2]));
            f64 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i152 | i152 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f64 = Math_fround(f64 * Math_fround(HEAPF32[i13 + 480 + (i156 << 4) + 8 >> 2]));
            f63 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i153 | i153 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f62 = Math_fround(Math_fround(f63 * Math_fround(HEAPF32[i13 + 480 + (i156 << 4) + 12 >> 2])) + Math_fround(f64 + Math_fround(f61 + f62)));
            i156 = HEAP32[i13 + 832 + (i155 << 4) >> 2] | 0;
            i153 = HEAP32[i13 + 832 + (i155 << 4) + 4 >> 2] | 0;
            i152 = HEAP32[i13 + 832 + (i155 << 4) + 8 >> 2] | 0;
            i151 = HEAP32[i13 + 832 + (i155 << 4) + 12 >> 2] | 0;
            f61 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i156 | i156 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f61 = Math_fround(f61 * Math_fround(HEAPF32[i13 + 480 + (i155 << 4) >> 2]));
            f64 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i153 | i153 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f64 = Math_fround(f64 * Math_fround(HEAPF32[i13 + 480 + (i155 << 4) + 4 >> 2]));
            f63 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i152 | i152 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f63 = Math_fround(f63 * Math_fround(HEAPF32[i13 + 480 + (i155 << 4) + 8 >> 2]));
            f65 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i151 | i151 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f64 = Math_fround(Math_fround(f65 * Math_fround(HEAPF32[i13 + 480 + (i155 << 4) + 12 >> 2])) + Math_fround(f63 + Math_fround(f61 + f64)));
            i155 = HEAP32[i13 + 832 + (i154 << 4) >> 2] | 0;
            i151 = HEAP32[i13 + 832 + (i154 << 4) + 4 >> 2] | 0;
            i152 = HEAP32[i13 + 832 + (i154 << 4) + 8 >> 2] | 0;
            i153 = HEAP32[i13 + 832 + (i154 << 4) + 12 >> 2] | 0;
            f61 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i155 | i155 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f61 = Math_fround(f61 * Math_fround(HEAPF32[i13 + 480 + (i154 << 4) >> 2]));
            f63 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i151 | i151 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f63 = Math_fround(f63 * Math_fround(HEAPF32[i13 + 480 + (i154 << 4) + 4 >> 2]));
            f65 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i152 | i152 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f65 = Math_fround(f65 * Math_fround(HEAPF32[i13 + 480 + (i154 << 4) + 8 >> 2]));
            f60 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i153 | i153 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f63 = Math_fround(Math_fround(f60 * Math_fround(HEAPF32[i13 + 480 + (i154 << 4) + 12 >> 2])) + Math_fround(f65 + Math_fround(f61 + f63)));
            i154 = HEAP32[i13 + 832 + (i150 << 4) >> 2] | 0;
            i153 = HEAP32[i13 + 832 + (i150 << 4) + 4 >> 2] | 0;
            i152 = HEAP32[i13 + 832 + (i150 << 4) + 8 >> 2] | 0;
            i151 = HEAP32[i13 + 832 + (i150 << 4) + 12 >> 2] | 0;
            f61 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i154 | i154 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f61 = Math_fround(f61 * Math_fround(HEAPF32[i13 + 480 + (i150 << 4) >> 2]));
            f65 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i153 | i153 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f65 = Math_fround(f65 * Math_fround(HEAPF32[i13 + 480 + (i150 << 4) + 4 >> 2]));
            f60 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i152 | i152 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f60 = Math_fround(f60 * Math_fround(HEAPF32[i13 + 480 + (i150 << 4) + 8 >> 2]));
            f59 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i151 | i151 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
            f65 = Math_fround(Math_fround(f59 * Math_fround(HEAPF32[i13 + 480 + (i150 << 4) + 12 >> 2])) + Math_fround(f60 + Math_fround(f61 + f65)));
            f64 = f62 <= f64 ? f62 : f64;
            f65 = f63 <= f65 ? f63 : f65;
            f65 = f64 <= f65 ? f64 : f65;
            f9 = f9 <= f65 ? f9 : f65;
            f7 = f7 <= f65 ? f7 : f65;
            f5 = f5 <= f65 ? f5 : f65;
            f4 = f4 <= f65 ? f4 : f65;
            i3 = i3 + -4 | 0;
            if ((i3 | 0) <= 3) break; else i6 = i6 + 16 | 0;
           }
           i3 = i8 - i11 | 0;
           i6 = i147 + 2736 + (i12 << 2) | 0;
          } else {
           i6 = i104;
           f9 = Math_fround(0.0);
           f7 = Math_fround(0.0);
           f5 = Math_fround(0.0);
           f4 = Math_fround(0.0);
          }
          switch (i3 | 0) {
          case 3:
           {
            i3 = HEAP32[i6 >> 2] | 0;
            i155 = HEAP32[i13 + 832 + (i3 << 4) >> 2] | 0;
            i156 = HEAP32[i13 + 832 + (i3 << 4) + 4 >> 2] | 0;
            i157 = HEAP32[i13 + 832 + (i3 << 4) + 8 >> 2] | 0;
            i135 = HEAP32[i13 + 832 + (i3 << 4) + 12 >> 2] | 0;
            f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23 & ~i155 | i155 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i13 + 480 + (i3 << 4) >> 2]));
            f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25 & ~i156 | i156 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i13 + 480 + (i3 << 4) + 4 >> 2]));
            f63 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27 & ~i157 | i157 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i13 + 480 + (i3 << 4) + 8 >> 2]));
            f65 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i29 & ~i135 | i135 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i13 + 480 + (i3 << 4) + 12 >> 2])) + Math_fround(f63 + Math_fround(f64 + f65)));
            i3 = i6 + 4 | 0;
            f9 = f9 <= f65 ? f9 : f65;
            f7 = f7 <= f65 ? f7 : f65;
            f5 = f5 <= f65 ? f5 : f65;
            f4 = f4 <= f65 ? f4 : f65;
            i135 = 41;
            break;
           }
          case 2:
           {
            i3 = i6;
            i135 = 41;
            break;
           }
          case 1:
           {
            i135 = 42;
            break;
           }
          default:
           {}
          }
          if ((i135 | 0) == 41) {
           i6 = HEAP32[i3 >> 2] | 0;
           i154 = HEAP32[i13 + 832 + (i6 << 4) >> 2] | 0;
           i155 = HEAP32[i13 + 832 + (i6 << 4) + 4 >> 2] | 0;
           i156 = HEAP32[i13 + 832 + (i6 << 4) + 8 >> 2] | 0;
           i157 = HEAP32[i13 + 832 + (i6 << 4) + 12 >> 2] | 0;
           f64 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i154 | i154 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f64 = Math_fround(f64 * Math_fround(HEAPF32[i13 + 480 + (i6 << 4) >> 2]));
           f65 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i155 | i155 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f65 = Math_fround(f65 * Math_fround(HEAPF32[i13 + 480 + (i6 << 4) + 4 >> 2]));
           f63 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i156 | i156 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f63 = Math_fround(f63 * Math_fround(HEAPF32[i13 + 480 + (i6 << 4) + 8 >> 2]));
           f62 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i157 | i157 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f65 = Math_fround(Math_fround(f62 * Math_fround(HEAPF32[i13 + 480 + (i6 << 4) + 12 >> 2])) + Math_fround(f63 + Math_fround(f64 + f65)));
           i6 = i3 + 4 | 0;
           f9 = f9 <= f65 ? f9 : f65;
           f7 = f7 <= f65 ? f7 : f65;
           f5 = f5 <= f65 ? f5 : f65;
           f4 = f4 <= f65 ? f4 : f65;
           i135 = 42;
          }
          if ((i135 | 0) == 42) {
           i135 = 0;
           i157 = HEAP32[i6 >> 2] | 0;
           i153 = HEAP32[i13 + 832 + (i157 << 4) >> 2] | 0;
           i154 = HEAP32[i13 + 832 + (i157 << 4) + 4 >> 2] | 0;
           i155 = HEAP32[i13 + 832 + (i157 << 4) + 8 >> 2] | 0;
           i156 = HEAP32[i13 + 832 + (i157 << 4) + 12 >> 2] | 0;
           f64 = (HEAP32[tempDoublePtr >> 2] = i23 & ~i153 | i153 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f64 = Math_fround(f64 * Math_fround(HEAPF32[i13 + 480 + (i157 << 4) >> 2]));
           f65 = (HEAP32[tempDoublePtr >> 2] = i25 & ~i154 | i154 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f65 = Math_fround(f65 * Math_fround(HEAPF32[i13 + 480 + (i157 << 4) + 4 >> 2]));
           f63 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i155 | i155 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f63 = Math_fround(f63 * Math_fround(HEAPF32[i13 + 480 + (i157 << 4) + 8 >> 2]));
           f62 = (HEAP32[tempDoublePtr >> 2] = i29 & ~i156 | i156 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f65 = Math_fround(Math_fround(f62 * Math_fround(HEAPF32[i13 + 480 + (i157 << 4) + 12 >> 2])) + Math_fround(f63 + Math_fround(f64 + f65)));
           f9 = f9 <= f65 ? f9 : f65;
           f7 = f7 <= f65 ? f7 : f65;
           f5 = f5 <= f65 ? f5 : f65;
           f4 = f4 <= f65 ? f4 : f65;
          }
          if (i15 | f9 < Math_fround(0.0) | (i16 | f7 < Math_fround(0.0)) | (i21 | f5 < Math_fround(0.0)) | (i14 | f4 < Math_fround(0.0))) {
           i157 = (HEAP32[(HEAP32[i144 >> 2] | 0) + 12 >> 2] | 0) + (i31 >> 5 << 2) | 0;
           HEAP32[i157 >> 2] = HEAP32[i157 >> 2] | 1 << (i31 & 31);
           i157 = (HEAP32[(HEAP32[i147 >> 2] | 0) + 60 >> 2] | 0) + 36 | 0;
           i156 = HEAP32[i157 >> 2] | 0;
           HEAP32[i157 >> 2] = ((i156 | 0) < 0 ? 0 : i156) + 1;
           break;
          }
         }
         do if (!(HEAP8[i81 >> 0] | 0)) i3 = HEAP32[i122 >> 2] | 0; else {
          if (i123) {
           i3 = HEAP32[i122 >> 2] | 0;
           f4 = Math_fround(HEAPF32[i94 >> 2]);
           f63 = Math_fround(HEAPF32[i3 + 1184 >> 2]);
           f63 = Math_fround(f63 - Math_fround(HEAPF32[i127 + (i22 << 6) + 48 >> 2]));
           f64 = Math_fround(HEAPF32[i3 + 1188 >> 2]);
           f64 = Math_fround(f64 - Math_fround(HEAPF32[i127 + (i22 << 6) + 52 >> 2]));
           f65 = Math_fround(HEAPF32[i3 + 1192 >> 2]);
           f65 = Math_fround(f65 - Math_fround(HEAPF32[i127 + (i22 << 6) + 56 >> 2]));
           HEAPF32[i142 >> 2] = f63;
           HEAPF32[i95 >> 2] = f64;
           HEAPF32[i96 >> 2] = f65;
           i8 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
           i157 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
           i6 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
           HEAP32[i136 >> 2] = i8;
           HEAP32[i97 >> 2] = i157;
           HEAP32[i98 >> 2] = i6;
           i6 = i8 >>> 0 < i157 >>> 0 ? (i157 >>> 0 >= i6 >>> 0 ? 1 : 2) : i8 >>> 0 >= i6 >>> 0 ? 0 : 2;
           i8 = 1 << i6 & 3;
           if (!(HEAP32[i136 + (i6 << 2) >> 2] | 0)) {
            i11 = 0;
            i6 = 0;
            i8 = 0;
           } else {
            i11 = HEAP32[i142 + (i6 << 2) >> 2] | 0;
            f65 = Math_fround(Math_fround(8.0) / Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
            i157 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i142 + (i8 << 2) >> 2]) * f65) + Math_fround(8.0));
            i11 = (i11 >>> 31 | i6 << 1) ^ 1;
            i6 = ~~Math_fround(Math_fround(f65 * Math_fround(HEAPF32[i142 + ((1 << i8 & 3) << 2) >> 2])) + Math_fround(8.0)) << 4;
            i8 = i157;
           }
           i157 = (HEAP32[i127 + (i22 << 6) + (i11 << 3) >> 2] | 0) + (Math_imul(i6 + i8 | 0, i130) | 0) << 2;
           f65 = (HEAP32[tempDoublePtr >> 2] = HEAPU16[i129 + (HEAP32[i127 + (i22 << 6) + (i11 << 3) + 4 >> 2] << 1) + (((HEAP32[i128 + (i157 >> 5 << 2) >> 2] | 0) >>> (i157 & 28) & 15) << 1) >> 1] << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           if (Math_fround(Math_abs(Math_fround(HEAPF32[i142 + ((i11 >>> 1 & 3) << 2) >> 2]))) < Math_fround(f4 + f65)) break;
          } else {
           i3 = HEAP32[i122 >> 2] | 0;
           i154 = HEAP32[i3 + 128 >> 2] | 0;
           HEAP32[i142 >> 2] = i154;
           i155 = HEAP32[i3 + 132 >> 2] | 0;
           HEAP32[i99 >> 2] = i155;
           i156 = HEAP32[i3 + 136 >> 2] | 0;
           HEAP32[i100 >> 2] = i156;
           i157 = HEAP32[i3 + 140 >> 2] | 0;
           HEAP32[i101 >> 2] = i157;
           i8 = HEAP32[i137 >> 2] & 2147483647;
           i153 = HEAP32[i110 >> 2] & 2147483647;
           i6 = HEAP32[i111 >> 2] & 2147483647;
           HEAP32[i136 >> 2] = i8;
           HEAP32[i102 >> 2] = i153;
           HEAP32[i103 >> 2] = i6;
           i6 = i8 >>> 0 < i153 >>> 0 ? (i153 >>> 0 >= i6 >>> 0 ? 1 : 2) : i8 >>> 0 >= i6 >>> 0 ? 0 : 2;
           i8 = 1 << i6 & 3;
           f4 = (HEAP32[tempDoublePtr >> 2] = i154, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f5 = (HEAP32[tempDoublePtr >> 2] = i155, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f7 = (HEAP32[tempDoublePtr >> 2] = i156, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f9 = (HEAP32[tempDoublePtr >> 2] = i157, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           if (!(HEAP32[i136 + (i6 << 2) >> 2] | 0)) {
            i11 = 0;
            i6 = 0;
            i8 = 0;
           } else {
            i11 = HEAP32[i137 + (i6 << 2) >> 2] | 0;
            f65 = Math_fround(Math_fround(8.0) / Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
            i157 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i137 + (i8 << 2) >> 2]) * f65) + Math_fround(8.0));
            i11 = (i11 >>> 31 | i6 << 1) ^ 1;
            i6 = ~~Math_fround(Math_fround(f65 * Math_fround(HEAPF32[i137 + ((1 << i8 & 3) << 2) >> 2])) + Math_fround(8.0)) << 4;
            i8 = i157;
           }
           i157 = (HEAP32[i127 + (i22 << 6) + (i11 << 3) >> 2] | 0) + (Math_imul(i6 + i8 | 0, i130) | 0) << 2;
           f65 = (HEAP32[tempDoublePtr >> 2] = HEAPU16[i129 + (HEAP32[i127 + (i22 << 6) + (i11 << 3) + 4 >> 2] << 1) + (((HEAP32[i128 + (i157 >> 5 << 2) >> 2] | 0) >>> (i157 & 28) & 15) << 1) >> 1] << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f64 = Math_fround(f4 * Math_fround(HEAPF32[i127 + (i22 << 6) + 48 >> 2]));
           f64 = Math_fround(f64 + Math_fround(f5 * Math_fround(HEAPF32[i127 + (i22 << 6) + 52 >> 2])));
           f64 = Math_fround(f9 + Math_fround(f64 + Math_fround(f7 * Math_fround(HEAPF32[i127 + (i22 << 6) + 56 >> 2]))));
           if (Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i142 + ((i11 >>> 1 & 3) << 2) >> 2]) * f64))) < f65) break;
          }
          if (i121) {
           i157 = (HEAP32[(HEAP32[i144 >> 2] | 0) + 12 >> 2] | 0) + (i31 >> 5 << 2) | 0;
           HEAP32[i157 >> 2] = HEAP32[i157 >> 2] | 1 << (i31 & 31);
          }
          i157 = (HEAP32[(HEAP32[i147 >> 2] | 0) + 60 >> 2] | 0) + 44 | 0;
          i156 = HEAP32[i157 >> 2] | 0;
          HEAP32[i157 >> 2] = ((i156 | 0) < 0 ? 0 : i156) + 1;
          break L48;
         } while (0);
         HEAP32[i136 >> 2] = 0;
         HEAP32[i136 + 4 >> 2] = 0;
         HEAP32[i136 + 8 >> 2] = 0;
         HEAP32[i136 + 12 >> 2] = 0;
         f9 = Math_fround(f19 - f10);
         f40 = Math_fround(f34 - f17);
         f47 = Math_fround(f35 - f18);
         f42 = Math_fround(HEAPF32[i3 + 64 >> 2]);
         f38 = Math_fround(HEAPF32[i3 + 68 >> 2]);
         f36 = Math_fround(HEAPF32[i3 + 76 >> 2]);
         f5 = Math_fround(f9 * f42);
         f7 = Math_fround(f9 * f38);
         f9 = Math_fround(f9 * f36);
         f41 = Math_fround(HEAPF32[i3 + 80 >> 2]);
         f37 = Math_fround(HEAPF32[i3 + 84 >> 2]);
         f65 = Math_fround(HEAPF32[i3 + 92 >> 2]);
         f19 = Math_fround(f40 * f41);
         f34 = Math_fround(f40 * f37);
         f35 = Math_fround(f40 * f65);
         f40 = Math_fround(HEAPF32[i3 + 96 >> 2]);
         f64 = Math_fround(HEAPF32[i3 + 100 >> 2]);
         f4 = Math_fround(HEAPF32[i3 + 108 >> 2]);
         f39 = Math_fround(f47 * f40);
         f43 = Math_fround(f47 * f64);
         f47 = Math_fround(f47 * f4);
         f42 = Math_fround(f10 * f42);
         f38 = Math_fround(f10 * f38);
         f36 = Math_fround(f10 * f36);
         f41 = Math_fround(f17 * f41);
         f37 = Math_fround(f17 * f37);
         f10 = Math_fround(f17 * f65);
         f40 = Math_fround(f18 * f40);
         f17 = Math_fround(f18 * f64);
         f4 = Math_fround(f18 * f4);
         f64 = Math_fround(HEAPF32[i3 + 112 >> 2]);
         f65 = Math_fround(HEAPF32[i3 + 116 >> 2]);
         f64 = Math_fround(f42 + Math_fround(f41 + Math_fround(f40 + f64)));
         f65 = Math_fround(f38 + Math_fround(f37 + Math_fround(f17 + f65)));
         f4 = Math_fround(f36 + Math_fround(f10 + Math_fround(f4 + Math_fround(HEAPF32[i3 + 124 >> 2]))));
         f5 = Math_fround(f5 + f64);
         f7 = Math_fround(f7 + f65);
         f9 = Math_fround(f9 + f4);
         f10 = Math_fround(f19 + f5);
         f17 = Math_fround(f34 + f7);
         f18 = Math_fround(f35 + f9);
         f19 = Math_fround(f19 + f64);
         f34 = Math_fround(f34 + f65);
         f35 = Math_fround(f35 + f4);
         f36 = Math_fround(f39 + f64);
         f37 = Math_fround(f39 + f5);
         f38 = Math_fround(f39 + f10);
         f39 = Math_fround(f39 + f19);
         f40 = Math_fround(f43 + f65);
         f41 = Math_fround(f43 + f7);
         f42 = Math_fround(f43 + f17);
         f43 = Math_fround(f43 + f34);
         f44 = Math_fround(f47 + f4);
         f45 = Math_fround(f47 + f9);
         f46 = Math_fround(f47 + f18);
         f47 = Math_fround(f47 + f35);
         i157 = f4 == Math_fround(0.0);
         f52 = Math_fround(Math_fround(1.0) / f4);
         f52 = i157 ? Math_fround(1.0) : f52;
         i157 = f9 == Math_fround(0.0);
         f53 = Math_fround(Math_fround(1.0) / f9);
         f53 = i157 ? Math_fround(1.0) : f53;
         i157 = f18 == Math_fround(0.0);
         f54 = Math_fround(Math_fround(1.0) / f18);
         f54 = i157 ? Math_fround(1.0) : f54;
         i157 = f35 == Math_fround(0.0);
         f55 = Math_fround(Math_fround(1.0) / f35);
         f55 = i157 ? Math_fround(1.0) : f55;
         i157 = f44 == Math_fround(0.0);
         f60 = Math_fround(Math_fround(1.0) / f44);
         f60 = i157 ? Math_fround(1.0) : f60;
         i157 = f45 == Math_fround(0.0);
         f61 = Math_fround(Math_fround(1.0) / f45);
         f61 = i157 ? Math_fround(1.0) : f61;
         i157 = f46 == Math_fround(0.0);
         f62 = Math_fround(Math_fround(1.0) / f46);
         f62 = i157 ? Math_fround(1.0) : f62;
         i157 = f47 == Math_fround(0.0);
         f63 = Math_fround(Math_fround(1.0) / f47);
         f63 = i157 ? Math_fround(1.0) : f63;
         f48 = Math_fround(f64 * f52);
         f49 = Math_fround(f5 * f53);
         f50 = Math_fround(f10 * f54);
         f51 = Math_fround(f19 * f55);
         f52 = Math_fround(f65 * f52);
         f53 = Math_fround(f7 * f53);
         f54 = Math_fround(f17 * f54);
         f55 = Math_fround(f34 * f55);
         f56 = Math_fround(f36 * f60);
         f57 = Math_fround(f37 * f61);
         f58 = Math_fround(f38 * f62);
         f59 = Math_fround(f39 * f63);
         f60 = Math_fround(f40 * f60);
         f61 = Math_fround(f41 * f61);
         f62 = Math_fround(f42 * f62);
         f63 = Math_fround(f43 * f63);
         if (!((f35 <= f47 ? f35 : f47) < Math_fround(0.0)) & (((f4 <= f44 ? f4 : f44) < Math_fround(0.0) ? 0 : !((f9 <= f45 ? f9 : f45) < Math_fround(0.0))) & !((f18 <= f46 ? f18 : f46) < Math_fround(0.0)))) {
          f46 = f48 <= f56 ? f48 : f56;
          f64 = f49 <= f57 ? f49 : f57;
          f47 = f50 <= f58 ? f50 : f58;
          f4 = f51 <= f59 ? f51 : f59;
          f7 = f52 <= f60 ? f52 : f60;
          f5 = f53 <= f61 ? f53 : f61;
          f65 = f54 <= f62 ? f54 : f62;
          f9 = f55 <= f63 ? f55 : f63;
          f47 = f46 <= f47 ? f46 : f47;
          f65 = f7 <= f65 ? f7 : f65;
          f4 = f64 <= f4 ? f64 : f4;
          f9 = f5 <= f9 ? f5 : f9;
          f56 = f48 >= f56 ? f48 : f56;
          f57 = f49 >= f57 ? f49 : f57;
          f58 = f50 >= f58 ? f50 : f58;
          f5 = f51 >= f59 ? f51 : f59;
          f60 = f52 >= f60 ? f52 : f60;
          f61 = f53 >= f61 ? f53 : f61;
          f64 = f54 >= f62 ? f54 : f62;
          f7 = f55 >= f63 ? f55 : f63;
          f63 = f56 >= f58 ? f56 : f58;
          f64 = f60 >= f64 ? f60 : f64;
          f5 = f57 >= f5 ? f57 : f5;
          f7 = f61 >= f7 ? f61 : f7;
          f4 = f47 <= f4 ? f47 : f4;
          f5 = f63 >= f5 ? f63 : f5;
          f7 = f64 >= f7 ? f64 : f7;
          f9 = f65 <= f9 ? f65 : f9;
         } else {
          f190 = Math_fround(-f4);
          f189 = Math_fround(-f9);
          f188 = Math_fround(-f18);
          f187 = Math_fround(-f35);
          i186 = f64 > f190;
          i184 = f5 > f189;
          i182 = f10 > f188;
          i180 = f19 > f187;
          i177 = f4 > f64;
          i173 = f9 > f5;
          i169 = f18 > f10;
          i165 = f35 > f19;
          i162 = f65 > f190;
          i160 = f7 > f189;
          i158 = f17 > f188;
          i6 = f34 > f187;
          i12 = f4 > f65;
          i16 = f9 > f7;
          i151 = f18 > f17;
          i155 = f35 > f34;
          f65 = Math_fround(-f44);
          f5 = Math_fround(-f45);
          f4 = Math_fround(-f46);
          f7 = Math_fround(-f47);
          i185 = f36 > f65;
          i183 = f37 > f5;
          i181 = f38 > f4;
          i179 = f39 > f7;
          i175 = f44 > f36;
          i171 = f45 > f37;
          i167 = f46 > f38;
          i163 = f47 > f39;
          i161 = f40 > f65;
          i159 = f41 > f5;
          i3 = f42 > f4;
          i8 = f43 > f7;
          i14 = f44 > f40;
          i22 = f45 > f41;
          i153 = f46 > f42;
          i157 = f47 > f43;
          i178 = i177 & i186;
          i174 = i173 & i184;
          i170 = i169 & i182;
          i166 = i165 & i180;
          i11 = i12 & i162;
          i15 = i16 & i160;
          i150 = i151 & i158;
          i154 = i155 & i6;
          i176 = i175 & i185;
          i172 = i171 & i183;
          i168 = i167 & i181;
          i164 = i163 & i179;
          i13 = i14 & i161;
          i21 = i22 & i159;
          i152 = i153 & i3;
          i156 = i157 & i8;
          f7 = i178 ? f48 : Math_fround(1.0);
          f7 = i186 ? f7 : Math_fround(-1.0);
          f45 = i176 ? f56 : Math_fround(1.0);
          f45 = i185 ? f45 : Math_fround(-1.0);
          f45 = f7 <= f45 ? f7 : f45;
          f7 = i174 ? f49 : Math_fround(1.0);
          f7 = i184 ? f7 : Math_fround(-1.0);
          f47 = i172 ? f57 : Math_fround(1.0);
          f47 = i183 ? f47 : Math_fround(-1.0);
          f47 = f7 <= f47 ? f7 : f47;
          f7 = i170 ? f50 : Math_fround(1.0);
          f7 = i182 ? f7 : Math_fround(-1.0);
          f46 = i168 ? f58 : Math_fround(1.0);
          f46 = i181 ? f46 : Math_fround(-1.0);
          f46 = f7 <= f46 ? f7 : f46;
          f7 = i166 ? f51 : Math_fround(1.0);
          f7 = i180 ? f7 : Math_fround(-1.0);
          f4 = i164 ? f59 : Math_fround(1.0);
          f4 = i179 ? f4 : Math_fround(-1.0);
          f4 = f7 <= f4 ? f7 : f4;
          f7 = i178 ? f48 : Math_fround(-1.0);
          f7 = i177 ? f7 : Math_fround(1.0);
          f56 = i176 ? f56 : Math_fround(-1.0);
          f56 = i175 ? f56 : Math_fround(1.0);
          f56 = f7 >= f56 ? f7 : f56;
          f7 = i174 ? f49 : Math_fround(-1.0);
          f7 = i173 ? f7 : Math_fround(1.0);
          f57 = i172 ? f57 : Math_fround(-1.0);
          f57 = i171 ? f57 : Math_fround(1.0);
          f57 = f7 >= f57 ? f7 : f57;
          f7 = i170 ? f50 : Math_fround(-1.0);
          f7 = i169 ? f7 : Math_fround(1.0);
          f58 = i168 ? f58 : Math_fround(-1.0);
          f58 = i167 ? f58 : Math_fround(1.0);
          f58 = f7 >= f58 ? f7 : f58;
          f7 = i166 ? f51 : Math_fround(-1.0);
          f7 = i165 ? f7 : Math_fround(1.0);
          f5 = i164 ? f59 : Math_fround(-1.0);
          f5 = i163 ? f5 : Math_fround(1.0);
          f5 = f7 >= f5 ? f7 : f5;
          f7 = i11 ? f52 : Math_fround(1.0);
          f7 = i162 ? f7 : Math_fround(-1.0);
          f51 = i13 ? f60 : Math_fround(1.0);
          f51 = i161 ? f51 : Math_fround(-1.0);
          f51 = f7 <= f51 ? f7 : f51;
          f7 = i15 ? f53 : Math_fround(1.0);
          f7 = i160 ? f7 : Math_fround(-1.0);
          f59 = i21 ? f61 : Math_fround(1.0);
          f59 = i159 ? f59 : Math_fround(-1.0);
          f59 = f7 <= f59 ? f7 : f59;
          f7 = i150 ? f54 : Math_fround(1.0);
          f7 = i158 ? f7 : Math_fround(-1.0);
          f65 = i152 ? f62 : Math_fround(1.0);
          f65 = i3 ? f65 : Math_fround(-1.0);
          f65 = f7 <= f65 ? f7 : f65;
          f7 = i154 ? f55 : Math_fround(1.0);
          f7 = i6 ? f7 : Math_fround(-1.0);
          f9 = i156 ? f63 : Math_fround(1.0);
          f9 = i8 ? f9 : Math_fround(-1.0);
          f9 = f7 <= f9 ? f7 : f9;
          f7 = i11 ? f52 : Math_fround(-1.0);
          f7 = i12 ? f7 : Math_fround(1.0);
          f60 = i13 ? f60 : Math_fround(-1.0);
          f60 = i14 ? f60 : Math_fround(1.0);
          f60 = f7 >= f60 ? f7 : f60;
          f7 = i15 ? f53 : Math_fround(-1.0);
          f7 = i16 ? f7 : Math_fround(1.0);
          f61 = i21 ? f61 : Math_fround(-1.0);
          f61 = i22 ? f61 : Math_fround(1.0);
          f61 = f7 >= f61 ? f7 : f61;
          f7 = i150 ? f54 : Math_fround(-1.0);
          f7 = i151 ? f7 : Math_fround(1.0);
          f64 = i152 ? f62 : Math_fround(-1.0);
          f64 = i153 ? f64 : Math_fround(1.0);
          f64 = f7 >= f64 ? f7 : f64;
          f62 = i154 ? f55 : Math_fround(-1.0);
          f62 = i155 ? f62 : Math_fround(1.0);
          f7 = i156 ? f63 : Math_fround(-1.0);
          f7 = i157 ? f7 : Math_fround(1.0);
          f7 = f62 >= f7 ? f62 : f7;
          f62 = f45 <= f46 ? f45 : f46;
          f65 = f51 <= f65 ? f51 : f65;
          f4 = f47 <= f4 ? f47 : f4;
          f9 = f59 <= f9 ? f59 : f9;
          f63 = f56 >= f58 ? f56 : f58;
          f64 = f60 >= f64 ? f60 : f64;
          f5 = f57 >= f5 ? f57 : f5;
          f7 = f61 >= f7 ? f61 : f7;
          f4 = f62 <= f4 ? f62 : f4;
          f5 = f63 >= f5 ? f63 : f5;
          f7 = f64 >= f7 ? f64 : f7;
          f9 = f65 <= f9 ? f65 : f9;
         }
         i11 = f4 <= Math_fround(1.0);
         f189 = i11 ? f4 : Math_fround(1.0);
         i11 = f9 <= Math_fround(1.0);
         f17 = i11 ? f9 : Math_fround(1.0);
         i11 = f5 <= Math_fround(1.0);
         f188 = i11 ? f5 : Math_fround(1.0);
         i11 = f7 <= Math_fround(1.0);
         f190 = i11 ? f7 : Math_fround(1.0);
         i11 = f189 >= Math_fround(-1.0);
         f189 = i11 ? f189 : Math_fround(-1.0);
         i11 = f17 >= Math_fround(-1.0);
         f17 = i11 ? f17 : Math_fround(-1.0);
         i11 = f188 >= Math_fround(-1.0);
         f188 = i11 ? f188 : Math_fround(-1.0);
         i11 = f190 >= Math_fround(-1.0);
         f17 = Math_fround(Math_fround(Math_fround(f188 - f189) * Math_fround((i11 ? f190 : Math_fround(-1.0)) - f17)) * Math_fround(.25));
         i11 = ~~Math_fround(Math_fround(f4 * Math_fround(32.0)) + Math_fround(32.0));
         i8 = ~~Math_fround(Math_fround(f9 * Math_fround(32.0)) + Math_fround(32.0));
         i6 = ~~Math_fround(Math_fround(f5 * Math_fround(32.0)) + Math_fround(32.9999962));
         i3 = ~~Math_fround(Math_fround(f7 * Math_fround(32.0)) + Math_fround(32.9999962));
         i11 = (i11 | 0) >= (i117 | 0) ? i11 : i117;
         i8 = (i8 | 0) >= (i118 | 0) ? i8 : i118;
         i6 = (i6 | 0) <= (i119 | 0) ? i6 : i119;
         i3 = (i3 | 0) <= (i120 | 0) ? i3 : i120;
         HEAP32[i136 >> 2] = i11;
         HEAP32[i82 >> 2] = i8;
         HEAP32[i83 >> 2] = i6;
         HEAP32[i84 >> 2] = i3;
         do if (f17 < Math_fround(HEAPF32[i85 >> 2])) {
          i186 = (HEAP32[(HEAP32[i144 >> 2] | 0) + 12 >> 2] | 0) + (i31 >> 5 << 2) | 0;
          HEAP32[i186 >> 2] = HEAP32[i186 >> 2] | 1 << (i31 & 31);
          i186 = (HEAP32[(HEAP32[i147 >> 2] | 0) + 60 >> 2] | 0) + 48 | 0;
          i185 = HEAP32[i186 >> 2] | 0;
          HEAP32[i186 >> 2] = ((i185 | 0) < 0 ? 0 : i185) + 1;
         } else if ((i6 | 0) > (i11 | 0) & (i3 | 0) > (i8 | 0)) {
          i14 = HEAP32[i144 >> 2] | 0;
          if (!(HEAP32[i14 + 28 >> 2] | 0)) {
           if (!(__ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iE(i116, i136) | 0)) break;
          } else {
           i3 = HEAP32[i122 >> 2] | 0;
           i183 = HEAP32[i3 + 832 >> 2] | 0;
           i184 = HEAP32[i3 + 836 >> 2] | 0;
           i185 = HEAP32[i3 + 840 >> 2] | 0;
           i186 = HEAP32[i3 + 844 >> 2] | 0;
           f190 = Math_fround(HEAPF32[i3 + 32 >> 2]);
           f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
           f189 = Math_fround(HEAPF32[i3 + 40 >> 2]);
           f188 = Math_fround(HEAPF32[i3 + 44 >> 2]);
           f10 = (HEAP32[tempDoublePtr >> 2] = i24 & ~i183 | i183 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f190 = Math_fround(f10 * f190);
           f9 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i184 | i184 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f5 = Math_fround(f9 * f5);
           f7 = (HEAP32[tempDoublePtr >> 2] = i28 & ~i185 | i185 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f189 = Math_fround(f7 * f189);
           f4 = (HEAP32[tempDoublePtr >> 2] = i30 & ~i186 | i186 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f5 = Math_fround(Math_fround(f4 * f188) + Math_fround(f189 + Math_fround(f190 + f5)));
           if (!(f5 <= Math_fround(0.0))) {
            f189 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 60 >> 2]));
            f190 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 56 >> 2]));
            f4 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 48 >> 2]));
            f4 = Math_fround(f5 / Math_fround(f189 + Math_fround(f190 + Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 52 >> 2]))))));
           } else f4 = Math_fround(0.0);
           if (!(__ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf(i116, i136, i93, f4) | 0)) break;
          }
          i13 = HEAP32[i147 >> 2] | 0;
          i12 = (HEAP32[i13 + 60 >> 2] | 0) + 32 | 0;
          i8 = HEAP32[i12 >> 2] | 0;
          HEAP32[i12 >> 2] = ((i8 | 0) < 0 ? 0 : i8) + 1;
          i12 = 1 << (i31 & 31);
          i8 = i31 >> 5;
          i6 = (HEAP32[i14 + 12 >> 2] | 0) + (i8 << 2) | 0;
          HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i12;
          i6 = HEAP32[i14 + 4 >> 2] | 0;
          if (i6 | 0) {
           i11 = i6 + 8 | 0;
           i3 = HEAP32[i11 >> 2] | 0;
           if ((i3 | 0) < (HEAP32[i6 + 4 >> 2] | 0)) {
            HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i31;
            i3 = HEAP32[i11 >> 2] | 0;
           }
           HEAP32[i11 >> 2] = i3 + 1;
          }
          i186 = HEAP32[i14 + 16 >> 2] | 0;
          i3 = i186 + (i8 << 2) | 0;
          if (i186 | 0) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i12;
          i8 = HEAP32[i14 + 36 >> 2] | 0;
          if (i8 | 0) {
           if (i115) {
            i186 = HEAP32[i114 >> 2] | 0;
            i6 = HEAP32[(HEAP32[i71 >> 2] | 0) + (i66 << 2) >> 2] | 0;
            i3 = i186 + (i6 << 5) | 0;
            i6 = i186 + (i6 << 5) + 16 | 0;
           } else {
            i3 = i32;
            i6 = i33;
           }
           f65 = Math_fround(HEAPF32[i3 >> 2]);
           f188 = Math_fround(HEAPF32[i3 + 4 >> 2]);
           f190 = Math_fround(HEAPF32[i3 + 8 >> 2]);
           f64 = Math_fround(HEAPF32[i6 >> 2]);
           f187 = Math_fround(HEAPF32[i6 + 4 >> 2]);
           f189 = Math_fround(HEAPF32[i6 + 8 >> 2]);
           f4 = Math_fround(HEAPF32[i73 >> 2]);
           f5 = Math_fround(HEAPF32[i74 >> 2]);
           f7 = Math_fround(HEAPF32[i75 >> 2]);
           f65 = f65 >= f4 ? f65 : f4;
           f188 = f188 >= f5 ? f188 : f5;
           f190 = f190 >= f7 ? f190 : f7;
           f4 = Math_fround((f64 <= f65 ? f64 : f65) - f4);
           f5 = Math_fround((f187 <= f188 ? f187 : f188) - f5);
           f7 = Math_fround((f189 <= f190 ? f189 : f190) - f7);
           i3 = i14 + 44 | 0;
           i6 = HEAP32[i3 >> 2] | 0;
           if ((i6 | 0) < (HEAP32[i14 + 40 >> 2] | 0)) HEAPF32[i8 + (i6 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))) + Math_fround(0.0));
           HEAP32[i3 >> 2] = i6 + 1;
          }
          i3 = HEAP32[i14 + 52 >> 2] | 0;
          if (i3 | 0) {
           i6 = i14 + 60 | 0;
           i8 = HEAP32[i6 >> 2] | 0;
           if ((i8 | 0) < (HEAP32[i14 + 56 >> 2] | 0)) HEAPF32[i3 + (i8 << 2) >> 2] = f17;
           HEAP32[i6 >> 2] = i8 + 1;
          }
          i3 = HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0;
          if (!i3) break;
          if (!(HEAP32[i13 + 32 >> 2] & 128)) break;
          i186 = HEAP32[i32 + 4 >> 2] | 0;
          i185 = HEAP32[i32 + 8 >> 2] | 0;
          HEAP32[i142 >> 2] = HEAP32[i32 >> 2];
          HEAP32[i86 >> 2] = i186;
          HEAP32[i87 >> 2] = i185;
          i185 = HEAP32[i33 + 4 >> 2] | 0;
          i186 = HEAP32[i33 + 8 >> 2] | 0;
          HEAP32[i138 >> 2] = HEAP32[i33 >> 2];
          HEAP32[i88 >> 2] = i185;
          HEAP32[i89 >> 2] = i186;
          HEAPF32[i139 >> 2] = Math_fround(.100000001);
          HEAPF32[i90 >> 2] = Math_fround(0.0);
          HEAPF32[i91 >> 2] = Math_fround(1.20000005);
          HEAPF32[i92 >> 2] = Math_fround(1.0);
          mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i142 | 0, i138 | 0, i139 | 0);
         } while (0);
        } while (0);
        i66 = i66 + 1 | 0;
       } while ((i66 | 0) != (i20 | 0));
      }
     }
    } else i135 = 26;
    i67 = i67 - i68 | 0;
    if ((i135 | 0) == 26) {
     i135 = 0;
     i1 = i1 - i68 | 0;
    }
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i144 >> 2] | 0;
  }
 }
 if (!(HEAP32[i1 + 24 >> 2] | 0)) i11 = i1; else {
  f4 = Math_fround(i134 >>> 16 | 0);
  f5 = Math_fround(i134 & 65535 | 0);
  f7 = Math_fround(i132 >>> 16 | 0);
  f64 = Math_fround(i132 & 65535 | 0);
  f187 = Math_fround(i133 >>> 16 | 0);
  f189 = Math_fround(i133 & 65535 | 0);
  f19 = Math_fround(HEAPF32[i147 + 2352 >> 2]);
  f18 = Math_fround(HEAPF32[i147 + 2356 >> 2]);
  f17 = Math_fround(HEAPF32[i147 + 2360 >> 2]);
  f10 = Math_fround(HEAPF32[i147 + 2364 >> 2]);
  f63 = Math_fround(HEAPF32[i147 + 2308 >> 2]);
  f60 = Math_fround(f63 - f19);
  f65 = Math_fround(HEAPF32[i147 + 2312 >> 2]);
  f61 = Math_fround(f65 - f18);
  f188 = Math_fround(HEAPF32[i147 + 2316 >> 2]);
  f62 = Math_fround(f188 - f17);
  f190 = Math_fround(HEAPF32[i147 + 2320 >> 2]);
  f9 = Math_fround(f190 - f10);
  f63 = Math_fround(f19 + f63);
  f65 = Math_fround(f18 + f65);
  f188 = Math_fround(f17 + f188);
  f190 = Math_fround(f10 + f190);
  f10 = Math_fround(HEAPF32[i147 + 2324 >> 2]);
  f4 = Math_fround(f4 * f10);
  f17 = Math_fround(HEAPF32[i147 + 2328 >> 2]);
  f5 = Math_fround(f5 * f17);
  f18 = Math_fround(HEAPF32[i147 + 2332 >> 2]);
  f7 = Math_fround(f7 * f18);
  f19 = Math_fround(Math_fround(HEAPF32[i147 + 2336 >> 2]) * Math_fround(0.0));
  f4 = Math_fround(f60 + f4);
  f5 = Math_fround(f61 + f5);
  f7 = Math_fround(f62 + f7);
  f9 = Math_fround(f9 + f19);
  HEAPF32[i136 >> 2] = f4;
  i20 = i136 + 4 | 0;
  HEAPF32[i20 >> 2] = f5;
  i21 = i136 + 8 | 0;
  HEAPF32[i21 >> 2] = f7;
  i22 = i136 + 12 | 0;
  HEAPF32[i22 >> 2] = f9;
  f10 = Math_fround(f63 + Math_fround(f64 * f10));
  f17 = Math_fround(f65 + Math_fround(f187 * f17));
  f18 = Math_fround(f188 + Math_fround(f189 * f18));
  f19 = Math_fround(f190 + f19);
  HEAPF32[i142 >> 2] = f10;
  i23 = i142 + 4 | 0;
  HEAPF32[i23 >> 2] = f17;
  i24 = i142 + 8 | 0;
  HEAPF32[i24 >> 2] = f18;
  i25 = i142 + 12 | 0;
  HEAPF32[i25 >> 2] = f19;
  i15 = i147 + 2732 | 0;
  i14 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i16 = i147 + 4 | 0;
   i186 = HEAP32[i16 >> 2] | 0;
   HEAPF32[i138 >> 2] = f4;
   HEAPF32[i138 + 4 >> 2] = f5;
   HEAPF32[i138 + 8 >> 2] = f7;
   HEAPF32[i138 + 12 >> 2] = f9;
   HEAPF32[i139 >> 2] = f10;
   HEAPF32[i139 + 4 >> 2] = f17;
   HEAPF32[i139 + 8 >> 2] = f18;
   HEAPF32[i139 + 12 >> 2] = f19;
   __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i186, i137, i15, i138, i139) | 0;
   if ((HEAP32[i137 >> 2] | 0) > 0) {
    i14 = HEAP32[i16 >> 2] | 0;
    HEAPF32[i140 >> 2] = f4;
    HEAPF32[i140 + 4 >> 2] = f5;
    HEAPF32[i140 + 8 >> 2] = f7;
    HEAPF32[i140 + 12 >> 2] = f9;
    HEAPF32[i141 >> 2] = f10;
    HEAPF32[i141 + 4 >> 2] = f17;
    HEAPF32[i141 + 8 >> 2] = f18;
    HEAPF32[i141 + 12 >> 2] = f19;
    __ZNK5Umbra11Transformer16frustumShrinkBoxEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_RS4_S5_(i14, i137, i140, i141, i136, i142);
    i14 = HEAP32[i136 >> 2] | 0;
    i13 = HEAP32[i20 >> 2] | 0;
    i12 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    i3 = HEAP32[i142 >> 2] | 0;
    i8 = HEAP32[i23 >> 2] | 0;
    i11 = HEAP32[i24 >> 2] | 0;
    i6 = HEAP32[i25 >> 2] | 0;
   }
   i15 = i3;
  } else {
   i16 = i147 + 4 | 0;
   i15 = i3;
  }
  i3 = HEAP32[i16 >> 2] | 0;
  i183 = HEAP32[i3 + 832 >> 2] | 0;
  i184 = HEAP32[i3 + 836 >> 2] | 0;
  i185 = HEAP32[i3 + 840 >> 2] | 0;
  i186 = HEAP32[i3 + 844 >> 2] | 0;
  f190 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
  f189 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f188 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f10 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i183 | i183 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f190 = Math_fround(f10 * f190);
  f9 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i184 | i184 & i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f9 * f5);
  f7 = (HEAP32[tempDoublePtr >> 2] = i12 & ~i185 | i185 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f189 = Math_fround(f7 * f189);
  f4 = (HEAP32[tempDoublePtr >> 2] = i1 & ~i186 | i186 & i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(Math_fround(f4 * f188) + Math_fround(f189 + Math_fround(f190 + f5)));
  if (!(f5 <= Math_fround(0.0))) {
   f189 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 60 >> 2]));
   f190 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 56 >> 2]));
   f4 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 48 >> 2]));
   f4 = Math_fround(f5 / Math_fround(f189 + Math_fround(f190 + Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 52 >> 2]))))));
  } else f4 = Math_fround(0.0);
  i11 = f4 > Math_fround(1.0);
  __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf(i143 + (i145 << 4) + 8 | 0, i147 + 352 | 0, i11 ? Math_fround(1.0) : f4);
  i11 = HEAP32[i144 >> 2] | 0;
 }
 i33 = HEAP32[i11 + 8 >> 2] | 0;
 if (!i33) {
  STACKTOP = i149;
  return;
 }
 if (!i148) {
  if ((i2 | 0) != -1 & (HEAP32[i147 + 2696 >> 2] | 0) != 0) i2 = (HEAP32[i147 + 2708 >> 2] | 0) + i2 | 0;
  i184 = (HEAP32[i11 + 20 >> 2] | 0) + (i2 >> 5 << 2) | 0;
  i186 = 1 << (i2 & 31);
  i185 = HEAP32[i184 >> 2] | 0;
  HEAP32[i184 >> 2] = i185 | i186;
  if (i185 & i186 | 0) {
   STACKTOP = i149;
   return;
  }
  i3 = i33 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) < (HEAP32[i33 + 4 >> 2] | 0)) {
   HEAP32[(HEAP32[i33 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1 + 1;
  STACKTOP = i149;
  return;
 }
 i32 = i147 + 2900 | 0;
 i8 = HEAP32[i146 + 84 >> 2] | 0;
 i6 = i8 >>> 10 & 31;
 i8 = i8 >>> 15 & 31;
 i3 = i6 + i8 | 0;
 i1 = Math_imul(i3, i2) | 0;
 i2 = ((Math_imul(i3, HEAP32[i146 + 100 >> 2] | 0) | 0) + 31 >> 5 << 5) - i1 | 0;
 if (i2 | 0) {
  HEAP32[i32 >> 2] = i146 + (HEAP32[i146 + 96 >> 2] | 0);
  HEAP32[i147 + 2904 >> 2] = i2;
  HEAP32[i147 + 2908 >> 2] = i1;
 }
 i31 = i147 + 2932 | 0;
 HEAP8[i31 >> 0] = i3 >>> 0 > 31 & 1;
 i30 = i147 + 2912 | 0;
 HEAP32[i30 >> 2] = i6;
 i29 = i147 + 2916 | 0;
 HEAP32[i29 >> 2] = i8;
 i23 = i147 + 2920 | 0;
 HEAP32[i23 >> 2] = i148;
 i24 = i147 + 2928 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i147 + 2908 | 0;
 i26 = i147 + 2904 | 0;
 i27 = i147 + 2924 | 0;
 i28 = i147 + 2708 | 0;
 i22 = (HEAP32[i147 + 2696 >> 2] | 0) != 0;
 i16 = HEAP32[i11 + 20 >> 2] | 0;
 i20 = i33 + 8 | 0;
 i21 = i33 + 4 | 0;
 i1 = i148;
 i2 = 0;
 while (1) {
  i1 = i1 + -1 | 0;
  do if (!i2) {
   i12 = HEAP32[i30 >> 2] | 0;
   if (!(HEAP8[i31 >> 0] | 0)) {
    i3 = (HEAP32[i29 >> 2] | 0) + i12 | 0;
    i184 = HEAP32[i32 >> 2] | 0;
    i186 = HEAP32[i25 >> 2] | 0;
    i185 = i186 >> 5;
    i2 = i186 & 31;
    i2 = (HEAP32[i184 + (i185 + 1 << 2) >> 2] << 32 - i2 & -1 << (i2 ^ 31) | (HEAP32[i184 + (i185 << 2) >> 2] | 0) >>> i2) & (1 << i3) + -1;
    HEAP32[i25 >> 2] = i186 + i3;
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) - i3;
    i3 = i2 & (1 << i12) + -1;
    HEAP32[i27 >> 2] = i3;
    i2 = i2 >>> i12;
    HEAP32[i24 >> 2] = i2;
    break;
   }
   i15 = HEAP32[i32 >> 2] | 0;
   i11 = HEAP32[i25 >> 2] | 0;
   i8 = i11 >> 5;
   i2 = i11 & 31;
   i3 = (HEAP32[i15 + (i8 << 2) >> 2] | 0) >>> i2;
   i6 = 32 - i2 | 0;
   i8 = HEAP32[i15 + (i8 + 1 << 2) >> 2] << i6;
   if ((i12 | 0) < 32) i3 = (i8 & -1 << (i2 ^ 31) | i3) & (1 << i12) + -1; else i3 = -1 << i6 & 0 - i2 >> 31 & i8 | i3;
   i14 = i11 + i12 | 0;
   HEAP32[i25 >> 2] = i14;
   i12 = (HEAP32[i26 >> 2] | 0) - i12 | 0;
   HEAP32[i26 >> 2] = i12;
   HEAP32[i27 >> 2] = i3;
   i13 = HEAP32[i29 >> 2] | 0;
   i2 = i14 >> 5;
   i6 = i14 & 31;
   i8 = (HEAP32[i15 + (i2 << 2) >> 2] | 0) >>> i6;
   i11 = 32 - i6 | 0;
   i2 = HEAP32[i15 + (i2 + 1 << 2) >> 2] << i11;
   if ((i13 | 0) < 32) i2 = (i2 & -1 << (i6 ^ 31) | i8) & (1 << i13) + -1; else i2 = -1 << i11 & 0 - i6 >> 31 & i2 | i8;
   HEAP32[i25 >> 2] = i13 + i14;
   HEAP32[i26 >> 2] = i12 - i13;
   HEAP32[i24 >> 2] = i2;
  } else i3 = HEAP32[i27 >> 2] | 0; while (0);
  HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
  HEAP32[i24 >> 2] = i2 + -1;
  HEAP32[i27 >> 2] = i3 + 1;
  if ((i3 | 0) != -1 & i22) i3 = (HEAP32[i28 >> 2] | 0) + i3 | 0;
  i184 = i16 + (i3 >> 5 << 2) | 0;
  i186 = 1 << (i3 & 31);
  i185 = HEAP32[i184 >> 2] | 0;
  HEAP32[i184 >> 2] = i185 | i186;
  if (!(i185 & i186)) {
   i2 = HEAP32[i20 >> 2] | 0;
   if ((i2 | 0) < (HEAP32[i21 >> 2] | 0)) {
    HEAP32[(HEAP32[i33 >> 2] | 0) + (i2 << 2) >> 2] = i3;
    i2 = HEAP32[i20 >> 2] | 0;
   }
   HEAP32[i20 >> 2] = i2 + 1;
  }
  if (!i1) break;
  i2 = HEAP32[i24 >> 2] | 0;
 }
 STACKTOP = i149;
 return;
}

function __ZN5physx11HullLibrary9overhullvEPNS_6float3EiiRS2_RiRPiS4_ffif(i22, i3, i4, i5, i59, i58, i60, i62, f19, f11, i1, f10) {
 i22 = i22 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i59 = i59 | 0;
 i58 = i58 | 0;
 i60 = i60 | 0;
 i62 = i62 | 0;
 f19 = Math_fround(f19);
 f11 = Math_fround(f11);
 i1 = i1 | 0;
 f10 = Math_fround(f10);
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i20 = 0, i21 = 0, f23 = f0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i61 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 8272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i67 + 8265 | 0;
 i57 = i67 + 8264 | 0;
 i50 = i67;
 i52 = i67 + 6208 | 0;
 i55 = i67 + 7240 | 0;
 i53 = i67 + 4160 | 0;
 i54 = i67 + 48 | 0;
 i51 = i67 + 2112 | 0;
 i20 = i67 + 36 | 0;
 i18 = i67 + 24 | 0;
 i21 = i67 + 12 | 0;
 i56 = i67 + 7232 | 0;
 i66 = i67 + 2100 | 0;
 i24 = i67 + 2096 | 0;
 if (!i4) {
  i66 = 1;
  STACKTOP = i67;
  return i66 | 0;
 }
 i64 = i66 + 4 | 0;
 HEAP32[i64 >> 2] = 0;
 i65 = i66 + 8 | 0;
 HEAP32[i65 >> 2] = 0;
 HEAP32[i66 >> 2] = 0;
 i1 = __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif(i22, i3, i4, i1, f10) | 0;
 do if ((i1 & -3 | 0) != 1) {
  if ((i1 | 0) == 2) {
   __ZN5physx11HullLibrary10expandhullEPNS_6float3EiRS2_Rif(i22, i3, i4, i59, i58, f19) | 0;
   i1 = __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif(i22, HEAP32[i59 >> 2] | 0, HEAP32[i58 >> 2] | 0, 256, f10) | 0;
   if ((i1 & -3 | 0) == 1) break;
   HEAP32[i24 >> 2] = 0;
   i1 = HEAP32[i22 >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) > 0) {
    i5 = 0;
    i8 = 0;
    i4 = 0;
    i3 = i1;
    i1 = 0;
    i6 = 0;
    i9 = 0;
    i18 = 0;
    while (1) {
     i2 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i2 + (i18 << 2) >> 2] | 0;
     if (!i3) {
      i7 = i5;
      i2 = i9;
     } else {
      i7 = HEAP32[i3 >> 2] | 0;
      if ((i1 | 0) == (i6 | 0)) {
       i6 = (i1 | 0) == 0 ? 16 : i1 << 1;
       i3 = i9;
       i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i6 << 2, gb + 730303 | 0, 136) | 0;
       HEAP32[i24 >> 2] = i4;
       if ((i1 | 0) > 0) {
        i2 = 0;
        do {
         HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i1 | 0));
        i61 = 12;
       } else if (i9 | 0) i61 = 12;
       if ((i61 | 0) == 12) {
        i61 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i9);
       }
       i3 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
       i5 = i4;
       i8 = i4;
       i2 = i3;
       i3 = HEAP32[i3 + (i18 << 2) >> 2] | 0;
      }
      i13 = i1 + 1 | 0;
      HEAP32[i4 + (i1 << 2) >> 2] = i7;
      i9 = HEAP32[i3 + 4 >> 2] | 0;
      if ((i13 | 0) == (i6 | 0)) {
       i5 = (i6 | 0) == 0 ? 16 : i6 << 1;
       i3 = HEAP32[i24 >> 2] | 0;
       i4 = i3;
       i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i5 << 2, gb + 730303 | 0, 136) | 0;
       HEAP32[i24 >> 2] = i7;
       if ((i6 | 0) > 0) {
        i2 = 0;
        do {
         HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i6 | 0));
        i61 = 233;
       } else if (i3 | 0) i61 = 233;
       if ((i61 | 0) == 233) {
        i61 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i3);
       }
       i2 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
       i4 = i7;
       i3 = HEAP32[i2 + (i18 << 2) >> 2] | 0;
       i12 = i5;
       i5 = i7;
      } else {
       i4 = i8;
       i12 = i6;
      }
      i8 = i1 + 2 | 0;
      HEAP32[i4 + (i13 << 2) >> 2] = i9;
      i7 = HEAP32[i3 + 8 >> 2] | 0;
      if ((i8 | 0) == (i12 | 0)) {
       i6 = (i12 | 0) == 0 ? 16 : i12 << 1;
       i3 = HEAP32[i24 >> 2] | 0;
       i4 = i3;
       i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i6 << 2, gb + 730303 | 0, 136) | 0;
       HEAP32[i24 >> 2] = i5;
       if ((i12 | 0) > 0) {
        i2 = 0;
        do {
         HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i12 | 0));
        i61 = 239;
       } else if (i3 | 0) i61 = 239;
       if ((i61 | 0) == 239) {
        i61 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i3);
       }
       i3 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
       i2 = i3;
       i3 = HEAP32[i3 + (i18 << 2) >> 2] | 0;
      } else i6 = i12;
      HEAP32[i5 + (i8 << 2) >> 2] = i7;
      i1 = i1 + 3 | 0;
      HEAP32[i2 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
      i2 = i5;
      if (!i3) {
       i7 = i5;
       i8 = i5;
       i4 = i5;
      } else {
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i3);
       i7 = i5;
       i8 = i5;
       i4 = i5;
      }
     }
     i18 = i18 + 1 | 0;
     i3 = HEAP32[i22 >> 2] | 0;
     if ((i18 | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) break; else {
      i5 = i7;
      i9 = i2;
     }
    }
    i2 = HEAP32[i24 >> 2] | 0;
   } else {
    i1 = 0;
    i2 = 0;
   }
   HEAP32[i62 >> 2] = (i1 | 0) / 3 | 0;
   HEAP32[i60 >> 2] = i2;
   HEAP32[i24 >> 2] = 0;
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i2);
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   i1 = 2;
   break;
  }
  if ((__ZN5physx11HullLibrary12calchullpbevEPNS_6float3EiiRNS_12hullLibArray5ArrayINS_5PlaneEEEf(i22, i3, i4, 0, i66, f11) | 0) == 1) i1 = 1; else {
   i48 = HEAP32[i66 >> 2] | 0;
   i49 = HEAP32[i64 >> 2] | 0;
   if ((i4 | 0) < 4) i1 = 1; else {
    i2 = (i49 | 0) > (i5 | 0);
    HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i12 = i20 + 4 | 0;
    i13 = i20 + 8 | 0;
    i8 = i18 + 4 | 0;
    i9 = i18 + 8 | 0;
    f17 = Math_fround(HEAPF32[i20 >> 2]);
    f11 = Math_fround(HEAPF32[i12 >> 2]);
    f15 = Math_fround(HEAPF32[i13 >> 2]);
    f16 = Math_fround(HEAPF32[i18 >> 2]);
    f10 = Math_fround(HEAPF32[i8 >> 2]);
    f14 = Math_fround(HEAPF32[i9 >> 2]);
    i1 = 0;
    do {
     f23 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
     f26 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
     f17 = f17 < f23 ? f17 : f23;
     f11 = f11 < f26 ? f11 : f26;
     f15 = f15 < f27 ? f15 : f27;
     f16 = f16 > f23 ? f16 : f23;
     f10 = f10 > f26 ? f10 : f26;
     f14 = f14 > f27 ? f14 : f27;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i4 | 0));
    i7 = i2 ? i5 : i49;
    HEAPF32[i20 >> 2] = f17;
    HEAPF32[i12 >> 2] = f11;
    HEAPF32[i13 >> 2] = f15;
    HEAPF32[i18 >> 2] = f16;
    HEAPF32[i8 >> 2] = f10;
    HEAPF32[i9 >> 2] = f14;
    f26 = Math_fround(f16 - f17);
    f27 = Math_fround(f10 - f11);
    f10 = Math_fround(f14 - f15);
    f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f27 * f27)) + Math_fround(f10 * f10))));
    i6 = (i49 | 0) > 0;
    if (i6) {
     i1 = 0;
     do {
      i47 = i48 + (i1 << 4) + 12 | 0;
      HEAPF32[i47 >> 2] = Math_fround(Math_fround(HEAPF32[i47 >> 2]) - f19);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i49 | 0));
    }
    f27 = Math_fround(f10 * Math_fround(.00100000005));
    HEAPF32[gb + 110156 >> 2] = f27;
    i4 = i21 + 4 | 0;
    i5 = i21 + 8 | 0;
    f10 = Math_fround(f10 * Math_fround(.5));
    i3 = 0;
    do {
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     HEAPF32[i4 >> 2] = Math_fround(0.0);
     HEAPF32[i5 >> 2] = Math_fround(0.0);
     i1 = (i3 & 1 | 0) != 0;
     HEAPF32[i21 + (((i3 | 0) / 2 | 0) << 2) >> 2] = i1 ? Math_fround(1.0) : Math_fround(-1.0);
     L65 : do if (i6) {
      f11 = Math_fround(HEAPF32[i21 >> 2]);
      f14 = Math_fround(HEAPF32[i4 >> 2]);
      f15 = Math_fround(HEAPF32[i5 >> 2]);
      i2 = 0;
      while (1) {
       f26 = Math_fround(HEAPF32[i48 + (i2 << 4) >> 2]);
       f27 = Math_fround(HEAPF32[i48 + (i2 << 4) + 4 >> 2]);
       if (Math_fround(Math_fround(Math_fround(f11 * f26) + Math_fround(f14 * f27)) + Math_fround(f15 * Math_fround(HEAPF32[i48 + (i2 << 4) + 8 >> 2]))) > Math_fround(.99862951)) break;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) >= (i49 | 0)) break L65;
      }
      i47 = i1 ? i18 : i20;
      f23 = Math_fround(f10 * f11);
      f26 = Math_fround(f10 * f14);
      f27 = Math_fround(f10 * f15);
      HEAPF32[i47 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i47 >> 2]));
      i46 = i47 + 4 | 0;
      HEAPF32[i46 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i46 >> 2]));
      i47 = i47 + 8 | 0;
      HEAPF32[i47 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i47 >> 2]));
     } while (0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 6);
    i40 = HEAP32[i20 >> 2] | 0;
    i42 = HEAP32[i12 >> 2] | 0;
    i44 = HEAP32[i13 >> 2] | 0;
    i41 = HEAP32[i18 >> 2] | 0;
    i43 = HEAP32[i8 >> 2] | 0;
    i46 = HEAP32[i9 >> 2] | 0;
    i47 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i45 = HEAP32[(HEAP32[i47 >> 2] | 0) + 8 >> 2] | 0;
    i2 = _PxGetFoundation() | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
    i2 = mftCall_iiiiii(i45 | 0, i47 | 0, 36, (i2 ? gb + 730389 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 671) | 0;
    __ZN5physx7ConvexHC2Eiii(i2, 8, 24, 6);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 8 >> 2] = Math_fround(0.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 20 >> 2] = Math_fround(1.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 32 >> 2] = Math_fround(0.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 36 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 40 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 44 >> 2] = Math_fround(1.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 48 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 52 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 56 >> 2] = Math_fround(0.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 60 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 68 >> 2] = Math_fround(1.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 72 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 76 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 80 >> 2] = Math_fround(0.0);
    i47 = HEAP32[i2 >> 2] | 0;
    HEAPF32[i47 + 84 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 88 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 92 >> 2] = Math_fround(1.0);
    i47 = i2 + 24 | 0;
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 >> 2] = Math_fround(-1.0);
    HEAPF32[i45 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 12 >> 2] = Math_fround(0.0);
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 16 >> 2] = Math_fround(1.0);
    HEAPF32[i45 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 28 >> 2] = Math_fround(-1.0);
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 32 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 36 >> 2] = Math_fround(-1.0);
    HEAPF32[i45 + 40 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 44 >> 2] = Math_fround(0.0);
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 48 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 52 >> 2] = Math_fround(1.0);
    HEAPF32[i45 + 56 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 60 >> 2] = Math_fround(-1.0);
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 68 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 72 >> 2] = Math_fround(-1.0);
    HEAPF32[i45 + 76 >> 2] = Math_fround(0.0);
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 80 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 84 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 88 >> 2] = Math_fround(1.0);
    HEAPF32[i45 + 92 >> 2] = Math_fround(-1.0);
    i45 = i2 + 12 | 0;
    i39 = HEAP32[i45 >> 2] | 0;
    HEAP16[i39 >> 1] = 11;
    HEAP16[i39 + 2 >> 1] = 11 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 4 | 0;
    HEAP16[i39 >> 1] = 23;
    HEAP16[i39 + 2 >> 1] = 65559 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 8 | 0;
    HEAP16[i39 >> 1] = 15;
    HEAP16[i39 + 2 >> 1] = 196623 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 12 | 0;
    HEAP16[i39 >> 1] = 16;
    HEAP16[i39 + 2 >> 1] = 131088 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 16 | 0;
    HEAP16[i39 >> 1] = 13;
    HEAP16[i39 + 2 >> 1] = 17170445 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 20 | 0;
    HEAP16[i39 >> 1] = 21;
    HEAP16[i39 + 2 >> 1] = 17235989 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 24 | 0;
    HEAP16[i39 >> 1] = 9;
    HEAP16[i39 + 2 >> 1] = 17104905 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 28 | 0;
    HEAP16[i39 >> 1] = 18;
    HEAP16[i39 + 2 >> 1] = 17039378 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 32 | 0;
    HEAP16[i39 >> 1] = 19;
    HEAP16[i39 + 2 >> 1] = 33554451 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 36 | 0;
    HEAP16[i39 >> 1] = 6;
    HEAP16[i39 + 2 >> 1] = 33816582 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 40 | 0;
    HEAP16[i39 >> 1] = 20;
    HEAP16[i39 + 2 >> 1] = 33882132 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 44 | 0;
    HEAP16[i39 >> 1] = 0;
    HEAP16[i39 + 2 >> 1] = 33619968 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 48 | 0;
    HEAP16[i39 >> 1] = 22;
    HEAP16[i39 + 2 >> 1] = 50528278 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 52 | 0;
    HEAP16[i39 >> 1] = 4;
    HEAP16[i39 + 2 >> 1] = 50790404 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 56 | 0;
    HEAP16[i39 >> 1] = 17;
    HEAP16[i39 + 2 >> 1] = 50724881 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 60 | 0;
    HEAP16[i39 >> 1] = 2;
    HEAP16[i39 + 2 >> 1] = 50462722 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 64 | 0;
    HEAP16[i39 >> 1] = 3;
    HEAP16[i39 + 2 >> 1] = 67108867 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 68 | 0;
    HEAP16[i39 >> 1] = 14;
    HEAP16[i39 + 2 >> 1] = 67239950 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 72 | 0;
    HEAP16[i39 >> 1] = 7;
    HEAP16[i39 + 2 >> 1] = 67502087 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 76 | 0;
    HEAP16[i39 >> 1] = 8;
    HEAP16[i39 + 2 >> 1] = 67371016 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 80 | 0;
    HEAP16[i39 >> 1] = 10;
    HEAP16[i39 + 2 >> 1] = 83951626 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 84 | 0;
    HEAP16[i39 >> 1] = 5;
    HEAP16[i39 + 2 >> 1] = 84213765 >>> 16;
    i39 = (HEAP32[i45 >> 2] | 0) + 88 | 0;
    HEAP16[i39 >> 1] = 12;
    HEAP16[i39 + 2 >> 1] = 84344844 >>> 16;
    i45 = (HEAP32[i45 >> 2] | 0) + 92 | 0;
    HEAP16[i45 >> 1] = 1;
    HEAP16[i45 + 2 >> 1] = 84082689 >>> 16;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 >> 2] = i40;
    HEAP32[i45 + 4 >> 2] = i42;
    HEAP32[i45 + 8 >> 2] = i44;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 12 >> 2] = i40;
    HEAP32[i45 + 16 >> 2] = i42;
    HEAP32[i45 + 20 >> 2] = i46;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 24 >> 2] = i40;
    HEAP32[i45 + 28 >> 2] = i43;
    HEAP32[i45 + 32 >> 2] = i44;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 36 >> 2] = i40;
    HEAP32[i45 + 40 >> 2] = i43;
    HEAP32[i45 + 44 >> 2] = i46;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 48 >> 2] = i41;
    HEAP32[i45 + 52 >> 2] = i42;
    HEAP32[i45 + 56 >> 2] = i44;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 60 >> 2] = i41;
    HEAP32[i45 + 64 >> 2] = i42;
    HEAP32[i45 + 68 >> 2] = i46;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 72 >> 2] = i41;
    HEAP32[i45 + 76 >> 2] = i43;
    HEAP32[i45 + 80 >> 2] = i44;
    i45 = HEAP32[i2 >> 2] | 0;
    HEAP32[i45 + 84 >> 2] = i41;
    HEAP32[i45 + 88 >> 2] = i43;
    HEAP32[i45 + 92 >> 2] = i46;
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 >> 2] = Math_fround(-1.0);
    HEAPF32[i45 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 8 >> 2] = Math_fround(0.0);
    HEAP32[i45 + 12 >> 2] = i40;
    i45 = HEAP32[i47 >> 2] | 0;
    f27 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i45 + 16 >> 2] = Math_fround(1.0);
    HEAPF32[i45 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 28 >> 2] = f27;
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 32 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 36 >> 2] = Math_fround(-1.0);
    HEAPF32[i45 + 40 >> 2] = Math_fround(0.0);
    HEAP32[i45 + 44 >> 2] = i42;
    i45 = HEAP32[i47 >> 2] | 0;
    f27 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i45 + 48 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 52 >> 2] = Math_fround(1.0);
    HEAPF32[i45 + 56 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 60 >> 2] = f27;
    i45 = HEAP32[i47 >> 2] | 0;
    HEAPF32[i45 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 68 >> 2] = Math_fround(0.0);
    HEAPF32[i45 + 72 >> 2] = Math_fround(-1.0);
    HEAP32[i45 + 76 >> 2] = i44;
    i47 = HEAP32[i47 >> 2] | 0;
    f27 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i47 + 80 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 84 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + 88 >> 2] = Math_fround(1.0);
    HEAPF32[i47 + 92 >> 2] = f27;
    L73 : do if (i6 & (i7 | 0) != 0) {
     i47 = i7;
     L75 : while (1) {
      i46 = i2 + 4 | 0;
      i12 = HEAP32[i46 >> 2] | 0;
      i13 = (i12 | 0) > 0;
      f26 = Math_fround(HEAPF32[gb + 110156 >> 2]);
      i42 = i2 + 28 | 0;
      i43 = i2 + 24 | 0;
      i44 = i2 + 16 | 0;
      i45 = i2 + 12 | 0;
      i18 = 0;
      f23 = Math_fround(0.0);
      i1 = -1;
      while (1) {
       if (i13) {
        i3 = HEAP32[i2 >> 2] | 0;
        f14 = Math_fround(HEAPF32[i48 + (i18 << 4) >> 2]);
        f15 = Math_fround(HEAPF32[i48 + (i18 << 4) + 4 >> 2]);
        f16 = Math_fround(HEAPF32[i48 + (i18 << 4) + 8 >> 2]);
        f17 = Math_fround(HEAPF32[i48 + (i18 << 4) + 12 >> 2]);
        f11 = Math_fround(0.0);
        f10 = Math_fround(0.0);
        i4 = 0;
        do {
         f19 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) >> 2]);
         f27 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 4 >> 2]);
         f27 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f14 * f19) + Math_fround(f15 * f27)) + Math_fround(f16 * Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 8 >> 2]))));
         f11 = f11 > f27 ? f11 : f27;
         f10 = f10 < f27 ? f10 : f27;
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) != (i12 | 0));
       } else {
        f11 = Math_fround(0.0);
        f10 = Math_fround(0.0);
       }
       f10 = Math_fround(f11 - f10);
       f10 = Math_fround(f11 / (f10 < f26 ? Math_fround(1.0) : f10));
       if (!(f10 <= f23)) {
        i7 = HEAP32[i42 >> 2] | 0;
        if ((i7 | 0) > 0) {
         i8 = HEAP32[i43 >> 2] | 0;
         f16 = Math_fround(HEAPF32[i48 + (i18 << 4) >> 2]);
         i9 = i48 + (i18 << 4) + 12 | 0;
         f17 = Math_fround(HEAPF32[i48 + (i18 << 4) + 4 >> 2]);
         f19 = Math_fround(HEAPF32[i48 + (i18 << 4) + 8 >> 2]);
         i6 = 0;
         do {
          f11 = Math_fround(HEAPF32[i8 + (i6 << 4) >> 2]);
          f14 = Math_fround(HEAPF32[i8 + (i6 << 4) + 4 >> 2]);
          f15 = Math_fround(HEAPF32[i8 + (i6 << 4) + 8 >> 2]);
          if (f16 == f11 & f17 == f14 & f19 == f15) {
           f27 = Math_fround(HEAPF32[i9 >> 2]);
           if (f27 == Math_fround(HEAPF32[i8 + (i6 << 4) + 12 >> 2])) f10 = Math_fround(0.0); else i61 = 45;
          } else i61 = 45;
          L92 : do if ((i61 | 0) == 45) {
           i61 = 0;
           if (!(Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(f17 * f14)) + Math_fround(f19 * f15)) > Math_fround(.99862951))) break;
           i3 = HEAP32[i44 >> 2] | 0;
           if ((i3 | 0) <= 0) break;
           i4 = HEAP32[i45 >> 2] | 0;
           i5 = 0;
           do {
            if ((HEAPU8[i4 + (i5 << 2) + 3 >> 0] | 0) == (i6 | 0)) {
             i41 = HEAPU8[i4 + (i5 << 2) + 2 >> 0] | 0;
             i40 = HEAP32[i2 >> 2] | 0;
             f15 = Math_fround(HEAPF32[i40 + (i41 * 12 | 0) >> 2]);
             f27 = Math_fround(HEAPF32[i40 + (i41 * 12 | 0) + 4 >> 2]);
             f27 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f17 * f27)) + Math_fround(f19 * Math_fround(HEAPF32[i40 + (i41 * 12 | 0) + 8 >> 2])));
             if (Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f27) < Math_fround(0.0)) {
              f10 = Math_fround(0.0);
              break L92;
             }
            }
            i5 = i5 + 1 | 0;
           } while ((i5 | 0) < (i3 | 0));
          } while (0);
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i7 | 0));
        }
        if (f10 > f23) i1 = i18; else f10 = f23;
       } else f10 = f23;
       i18 = i18 + 1 | 0;
       if ((i18 | 0) == (i49 | 0)) break; else f23 = f10;
      }
      i47 = i47 + -1 | 0;
      i41 = f10 > Math_fround(.00999999977);
      i1 = i41 ? i1 : -1;
      if ((i1 | 0) <= -1) {
       i18 = i2;
       break L73;
      }
      i41 = i48 + (i1 << 4) | 0;
      _memset(i54 | 0, 0, 2048) | 0;
      i7 = HEAP32[i46 >> 2] | 0;
      L107 : do if ((i7 | 0) > 0) {
       i8 = HEAP32[i2 >> 2] | 0;
       f14 = Math_fround(HEAPF32[i41 >> 2]);
       i39 = i48 + (i1 << 4) + 4 | 0;
       f15 = Math_fround(HEAPF32[i39 >> 2]);
       i40 = i48 + (i1 << 4) + 8 | 0;
       f16 = Math_fround(HEAPF32[i40 >> 2]);
       i38 = i48 + (i1 << 4) + 12 | 0;
       f10 = Math_fround(HEAPF32[i38 >> 2]);
       f11 = Math_fround(-f26);
       i5 = 0;
       i1 = 0;
       i6 = 0;
       i4 = 0;
       do {
        f23 = Math_fround(HEAPF32[i8 + (i5 * 12 | 0) >> 2]);
        f27 = Math_fround(HEAPF32[i8 + (i5 * 12 | 0) + 4 >> 2]);
        f27 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f14 * f23) + Math_fround(f15 * f27)) + Math_fround(f16 * Math_fround(HEAPF32[i8 + (i5 * 12 | 0) + 8 >> 2]))));
        i3 = f27 > f26 ? 2 : f27 < f11 & 1;
        switch (i3 | 0) {
        case 0:
        case 2:
         {
          HEAP8[i55 + (i5 << 2) + 2 >> 0] = -1;
          HEAP8[i55 + (i5 << 2) + 3 >> 0] = -1;
          break;
         }
        case 1:
         {
          HEAP8[i55 + (i5 << 2) + 2 >> 0] = i4;
          HEAP8[i55 + (i5 << 2) + 3 >> 0] = -1;
          i4 = i4 + 1 << 16 >> 16;
          break;
         }
        default:
         {
          i3 = 0;
          i61 = 159;
          break L107;
         }
        }
        HEAP8[i55 + (i5 << 2) >> 0] = i3;
        i1 = i3 | i1;
        i6 = i6 + 1 << 16 >> 16;
        i5 = i6 & 65535;
       } while ((i5 | 0) < (i7 | 0));
       if (!(i1 & 2)) i61 = 64; else {
        L117 : do if ((HEAP32[i42 >> 2] | 0) > 0) {
         i7 = 0;
         i8 = 0;
         i1 = 0;
         i6 = 0;
         i5 = 0;
         i37 = 0;
         i13 = 0;
         i3 = 0;
         while (1) {
          i36 = i3 & 255;
          i33 = i7;
          i21 = i8;
          i9 = 255;
          i32 = i37;
          i18 = -1;
          i20 = 0;
          i8 = -1;
          i7 = -1;
          while (1) {
           i12 = i32 + 1 | 0;
           i28 = HEAP32[i45 >> 2] | 0;
           if ((i12 | 0) < (HEAP32[i44 >> 2] | 0)) if ((HEAPU8[i28 + (i12 << 2) + 3 >> 0] | 0) == (i5 | 0)) {
            i35 = i12;
            i12 = i18;
           } else i61 = 68; else i61 = 68;
           if ((i61 | 0) == 68) {
            i61 = 0;
            i35 = i37;
           }
           i31 = i28 + (i32 << 2) | 0;
           i25 = HEAP16[i31 >> 1] | 0;
           i29 = i28 + (i32 << 2) + 2 | 0;
           i24 = HEAPU8[i29 >> 0] | 0;
           i18 = HEAP8[i55 + (i24 << 2) >> 0] | 0;
           i34 = i18 & 255 | i20;
           i30 = i28 + (i35 << 2) + 2 | 0;
           i22 = (HEAP8[i55 + (HEAPU8[i30 >> 0] << 2) >> 0] | 0) == 1;
           do if (i18 << 24 >> 24 == 1) {
            HEAP16[i52 + (i32 << 1) >> 1] = i13;
            i20 = i13 & 65535;
            HEAP8[i53 + (i20 << 2) + 2 >> 0] = HEAP8[i55 + (i24 << 2) + 2 >> 0] | 0;
            HEAP8[i53 + (i20 << 2) + 3 >> 0] = i36;
            i18 = (i25 | 0) < (i32 | 0);
            if (i22) {
             if (i18) {
              HEAP16[i53 + (i20 << 2) >> 1] = HEAP16[i52 + (i25 << 1) >> 1] | 0;
              HEAP16[i53 + (HEAP16[i52 + (HEAP16[i31 >> 1] << 1) >> 1] << 2) >> 1] = i13;
             }
             i20 = i33;
             i13 = i13 + 1 << 16 >> 16;
             break;
            }
            do if (i18) {
             HEAP16[i53 + (i20 << 2) >> 1] = HEAP16[i52 + (i25 << 1) >> 1] | 0;
             HEAP16[i53 + (HEAP16[i52 + (HEAP16[i31 >> 1] << 1) >> 1] << 2) >> 1] = i13;
             i18 = i21;
             i20 = i33;
             i22 = i4;
             i7 = HEAP8[i53 + (HEAP16[i52 + (HEAP16[i31 >> 1] << 1) >> 1] << 2) + 2 >> 0] | 0;
            } else {
             i18 = HEAPU8[i30 >> 0] | 0;
             if (HEAP8[i55 + (i18 << 2) >> 0] | 0) {
              i30 = HEAPU8[i28 + (i32 << 2) + 3 >> 0] | 0;
              i31 = HEAP32[i43 >> 2] | 0;
              i32 = HEAPU8[i28 + (i25 << 2) + 3 >> 0] | 0;
              f14 = Math_fround(HEAPF32[i31 + (i30 << 4) >> 2]);
              f71 = Math_fround(HEAPF32[i31 + (i30 << 4) + 4 >> 2]);
              f16 = Math_fround(HEAPF32[i31 + (i30 << 4) + 8 >> 2]);
              f72 = Math_fround(HEAPF32[i31 + (i32 << 4) >> 2]);
              f17 = Math_fround(HEAPF32[i31 + (i32 << 4) + 4 >> 2]);
              f15 = Math_fround(HEAPF32[i31 + (i32 << 4) + 8 >> 2]);
              f70 = Math_fround(HEAPF32[i41 >> 2]);
              f23 = Math_fround(HEAPF32[i39 >> 2]);
              f74 = Math_fround(HEAPF32[i40 >> 2]);
              f26 = Math_fround(f14 * f17);
              f75 = Math_fround(f71 * f15);
              f73 = Math_fround(f16 * f72);
              f11 = Math_fround(f14 * f15);
              f19 = Math_fround(f71 * f72);
              f10 = Math_fround(f16 * f17);
              f27 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f73 * f23) + Math_fround(Math_fround(f75 * f70) + Math_fround(f26 * f74))) - Math_fround(f11 * f23)) - Math_fround(f19 * f74)) - Math_fround(f10 * f70));
              f69 = Math_fround(Math_fround(Math_fround(f17 * f74) - Math_fround(f15 * f23)) / f27);
              f68 = Math_fround(Math_fround(Math_fround(f16 * f23) - Math_fround(f71 * f74)) / f27);
              f10 = Math_fround(Math_fround(f75 - f10) / f27);
              f15 = Math_fround(Math_fround(Math_fround(f15 * f70) - Math_fround(f72 * f74)) / f27);
              f16 = Math_fround(Math_fround(Math_fround(f14 * f74) - Math_fround(f16 * f70)) / f27);
              f11 = Math_fround(Math_fround(f73 - f11) / f27);
              f17 = Math_fround(Math_fround(Math_fround(f72 * f23) - Math_fround(f17 * f70)) / f27);
              f23 = Math_fround(Math_fround(Math_fround(f71 * f70) - Math_fround(f14 * f23)) / f27);
              f27 = Math_fround(Math_fround(f26 - f19) / f27);
              f19 = Math_fround(HEAPF32[i31 + (i30 << 4) + 12 >> 2]);
              f26 = Math_fround(HEAPF32[i31 + (i32 << 4) + 12 >> 2]);
              f19 = Math_fround(-f19);
              f26 = Math_fround(-f26);
              f14 = Math_fround(-Math_fround(HEAPF32[i38 >> 2]));
              f10 = Math_fround(Math_fround(Math_fround(f69 * f19) + Math_fround(f68 * f26)) + Math_fround(f10 * f14));
              f11 = Math_fround(Math_fround(Math_fround(f15 * f19) + Math_fround(f16 * f26)) + Math_fround(f11 * f14));
              f14 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(f23 * f26)) + Math_fround(f27 * f14));
              if ((i33 | 0) == (i21 | 0)) {
               i18 = (i21 | 0) == 0 ? 16 : i21 << 1;
               i20 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i18 * 12 | 0, gb + 730303 | 0, 136) | 0;
               do if ((i21 | 0) > 0) {
                HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
                HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
                HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
                if ((i21 | 0) > 1) i7 = 1; else {
                 i61 = 90;
                 break;
                }
                do {
                 i61 = i20 + (i7 * 12 | 0) | 0;
                 i32 = i1 + (i7 * 12 | 0) | 0;
                 HEAP32[i61 >> 2] = HEAP32[i32 >> 2];
                 HEAP32[i61 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
                 HEAP32[i61 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
                 i7 = i7 + 1 | 0;
                } while ((i7 | 0) != (i21 | 0));
                i61 = 90;
               } else {
                if (!i1) break;
                i61 = 90;
               } while (0);
               if ((i61 | 0) == 90) {
                i61 = 0;
                __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i1);
               }
               i7 = i18;
               i1 = i20;
              } else i7 = i21;
              HEAPF32[i1 + (i33 * 12 | 0) >> 2] = f10;
              HEAPF32[i1 + (i33 * 12 | 0) + 4 >> 2] = f11;
              HEAPF32[i1 + (i33 * 12 | 0) + 8 >> 2] = f14;
              i18 = i7;
              i20 = i33 + 1 | 0;
              i22 = i4 + 1 << 16 >> 16;
              i7 = i4 & 255;
              break;
             }
             i7 = HEAP8[i55 + (i18 << 2) + 2 >> 0] | 0;
             if (i7 << 24 >> 24 != -1) {
              i18 = i21;
              i20 = i33;
              i22 = i4;
              break;
             }
             i32 = (HEAP32[i2 >> 2] | 0) + (i18 * 12 | 0) | 0;
             HEAP32[i50 >> 2] = HEAP32[i32 >> 2];
             HEAP32[i50 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
             HEAP32[i50 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
             if ((i33 | 0) == (i21 | 0)) {
              i18 = (i21 | 0) == 0 ? 16 : i21 << 1;
              i20 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i18 * 12 | 0, gb + 730303 | 0, 136) | 0;
              do if ((i21 | 0) > 0) {
               HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
               HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
               HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
               if ((i21 | 0) > 1) i7 = 1; else {
                i61 = 81;
                break;
               }
               do {
                i61 = i20 + (i7 * 12 | 0) | 0;
                i32 = i1 + (i7 * 12 | 0) | 0;
                HEAP32[i61 >> 2] = HEAP32[i32 >> 2];
                HEAP32[i61 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
                HEAP32[i61 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
                i7 = i7 + 1 | 0;
               } while ((i7 | 0) != (i21 | 0));
               i61 = 81;
              } else {
               if (!i1) break;
               i61 = 81;
              } while (0);
              if ((i61 | 0) == 81) {
               i61 = 0;
               __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i1);
              }
              i7 = i18;
              i1 = i20;
             } else i7 = i21;
             i32 = i1 + (i33 * 12 | 0) | 0;
             HEAP32[i32 >> 2] = HEAP32[i50 >> 2];
             HEAP32[i32 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
             HEAP32[i32 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
             i32 = i4 & 255;
             HEAP8[i55 + (HEAPU8[i30 >> 0] << 2) + 2 >> 0] = i32;
             i18 = i7;
             i20 = i33 + 1 | 0;
             i22 = i4 + 1 << 16 >> 16;
             i7 = i32;
            } while (0);
            i4 = i13 + 1 << 16 >> 16;
            if (i8 << 24 >> 24 == -1 ? 1 : i8 << 24 >> 24 == i7 << 24 >> 24) {
             i21 = i18;
             i13 = i4;
             i4 = i22;
             break;
            }
            i9 = i4 & 65535;
            HEAP8[i53 + (i9 << 2) + 2 >> 0] = i7;
            HEAP8[i53 + (i9 << 2) + 3 >> 0] = i36;
            HEAP16[i53 + (i9 << 2) >> 1] = 255;
            i21 = i18;
            i13 = i13 + 2 << 16 >> 16;
            i4 = i22;
           } else {
            if (!i22) {
             i20 = i33;
             break;
            }
            do if ((i25 | 0) < (i32 | 0)) {
             i8 = HEAP16[i52 + (i25 << 1) >> 1] | 0;
             i18 = i8 + 1 | 0;
             i20 = HEAP8[i53 + (i8 << 2) + 3 >> 0] | 0;
             if ((i18 | 0) < (i13 & 65535 | 0)) {
              if ((HEAP8[i53 + (i18 << 2) + 3 >> 0] | 0) != i20 << 24 >> 24) i61 = 99;
             } else i61 = 99;
             L174 : do if ((i61 | 0) == 99) while (1) {
              i61 = 0;
              i18 = i8 + -1 | 0;
              if ((i8 | 0) <= 1) break L174;
              if ((HEAP8[i53 + (i8 + -2 << 2) + 3 >> 0] | 0) == i20 << 24 >> 24) {
               i8 = i18;
               i61 = 99;
              } else break;
             } while (0);
             i20 = i33;
             i22 = i4;
             i8 = HEAP8[i53 + (i18 << 2) + 2 >> 0] | 0;
            } else {
             if (i18 << 24 >> 24) {
              i24 = HEAPU8[i28 + (i32 << 2) + 3 >> 0] | 0;
              i29 = HEAP32[i43 >> 2] | 0;
              i30 = HEAPU8[i28 + (i25 << 2) + 3 >> 0] | 0;
              f14 = Math_fround(HEAPF32[i29 + (i24 << 4) >> 2]);
              f23 = Math_fround(HEAPF32[i29 + (i24 << 4) + 4 >> 2]);
              f70 = Math_fround(HEAPF32[i29 + (i24 << 4) + 8 >> 2]);
              f19 = Math_fround(HEAPF32[i29 + (i30 << 4) >> 2]);
              f71 = Math_fround(HEAPF32[i29 + (i30 << 4) + 4 >> 2]);
              f69 = Math_fround(HEAPF32[i29 + (i30 << 4) + 8 >> 2]);
              f26 = Math_fround(HEAPF32[i41 >> 2]);
              f73 = Math_fround(HEAPF32[i39 >> 2]);
              f16 = Math_fround(HEAPF32[i40 >> 2]);
              f74 = Math_fround(f14 * f71);
              f15 = Math_fround(f23 * f69);
              f17 = Math_fround(f70 * f19);
              f11 = Math_fround(f14 * f69);
              f72 = Math_fround(f23 * f19);
              f10 = Math_fround(f70 * f71);
              f75 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f17 * f73) + Math_fround(Math_fround(f15 * f26) + Math_fround(f74 * f16))) - Math_fround(f11 * f73)) - Math_fround(f72 * f16)) - Math_fround(f10 * f26));
              f27 = Math_fround(Math_fround(Math_fround(f71 * f16) - Math_fround(f69 * f73)) / f75);
              f68 = Math_fround(Math_fround(Math_fround(f70 * f73) - Math_fround(f23 * f16)) / f75);
              f10 = Math_fround(Math_fround(f15 - f10) / f75);
              f69 = Math_fround(Math_fround(Math_fround(f69 * f26) - Math_fround(f19 * f16)) / f75);
              f70 = Math_fround(Math_fround(Math_fround(f14 * f16) - Math_fround(f70 * f26)) / f75);
              f11 = Math_fround(Math_fround(f17 - f11) / f75);
              f71 = Math_fround(Math_fround(Math_fround(f19 * f73) - Math_fround(f71 * f26)) / f75);
              f73 = Math_fround(Math_fround(Math_fround(f23 * f26) - Math_fround(f14 * f73)) / f75);
              f75 = Math_fround(Math_fround(f74 - f72) / f75);
              f72 = Math_fround(HEAPF32[i29 + (i24 << 4) + 12 >> 2]);
              f74 = Math_fround(HEAPF32[i29 + (i30 << 4) + 12 >> 2]);
              f72 = Math_fround(-f72);
              f74 = Math_fround(-f74);
              f14 = Math_fround(-Math_fround(HEAPF32[i38 >> 2]));
              f10 = Math_fround(Math_fround(Math_fround(f27 * f72) + Math_fround(f68 * f74)) + Math_fround(f10 * f14));
              f11 = Math_fround(Math_fround(Math_fround(f69 * f72) + Math_fround(f70 * f74)) + Math_fround(f11 * f14));
              f14 = Math_fround(Math_fround(Math_fround(f71 * f72) + Math_fround(f73 * f74)) + Math_fround(f75 * f14));
              if ((i33 | 0) == (i21 | 0)) {
               i18 = (i21 | 0) == 0 ? 16 : i21 << 1;
               i20 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i18 * 12 | 0, gb + 730303 | 0, 136) | 0;
               do if ((i21 | 0) > 0) {
                HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
                HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
                HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
                if ((i21 | 0) > 1) i8 = 1; else {
                 i61 = 119;
                 break;
                }
                do {
                 i61 = i20 + (i8 * 12 | 0) | 0;
                 i30 = i1 + (i8 * 12 | 0) | 0;
                 HEAP32[i61 >> 2] = HEAP32[i30 >> 2];
                 HEAP32[i61 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
                 HEAP32[i61 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
                 i8 = i8 + 1 | 0;
                } while ((i8 | 0) != (i21 | 0));
                i61 = 119;
               } else {
                if (!i1) break;
                i61 = 119;
               } while (0);
               if ((i61 | 0) == 119) {
                i61 = 0;
                __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i1);
               }
               i8 = i18;
               i1 = i20;
              } else i8 = i21;
              HEAPF32[i1 + (i33 * 12 | 0) >> 2] = f10;
              HEAPF32[i1 + (i33 * 12 | 0) + 4 >> 2] = f11;
              HEAPF32[i1 + (i33 * 12 | 0) + 8 >> 2] = f14;
              i21 = i8;
              i20 = i33 + 1 | 0;
              i22 = i4 + 1 << 16 >> 16;
              i8 = i4 & 255;
              break;
             }
             i8 = HEAP8[i55 + (i24 << 2) + 2 >> 0] | 0;
             if (i8 << 24 >> 24 != -1) {
              i20 = i33;
              i22 = i4;
              break;
             }
             i30 = (HEAP32[i2 >> 2] | 0) + (i24 * 12 | 0) | 0;
             HEAP32[i50 >> 2] = HEAP32[i30 >> 2];
             HEAP32[i50 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
             HEAP32[i50 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
             if ((i33 | 0) == (i21 | 0)) {
              i18 = (i21 | 0) == 0 ? 16 : i21 << 1;
              i20 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i63, i18 * 12 | 0, gb + 730303 | 0, 136) | 0;
              do if ((i21 | 0) > 0) {
               HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
               HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
               HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
               if ((i21 | 0) > 1) i8 = 1; else {
                i61 = 110;
                break;
               }
               do {
                i61 = i20 + (i8 * 12 | 0) | 0;
                i30 = i1 + (i8 * 12 | 0) | 0;
                HEAP32[i61 >> 2] = HEAP32[i30 >> 2];
                HEAP32[i61 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
                HEAP32[i61 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
                i8 = i8 + 1 | 0;
               } while ((i8 | 0) != (i21 | 0));
               i61 = 110;
              } else {
               if (!i1) break;
               i61 = 110;
              } while (0);
              if ((i61 | 0) == 110) {
               i61 = 0;
               __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i1);
              }
              i8 = i18;
              i1 = i20;
             } else i8 = i21;
             i30 = i1 + (i33 * 12 | 0) | 0;
             HEAP32[i30 >> 2] = HEAP32[i50 >> 2];
             HEAP32[i30 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
             HEAP32[i30 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
             i30 = i4 & 255;
             HEAP8[i55 + (HEAPU8[i29 >> 0] << 2) + 2 >> 0] = i30;
             i21 = i8;
             i20 = i33 + 1 | 0;
             i22 = i4 + 1 << 16 >> 16;
             i8 = i30;
            } while (0);
            if (!(i7 << 24 >> 24 == -1 ? 1 : i8 << 24 >> 24 == i7 << 24 >> 24)) {
             i9 = i13 & 65535;
             HEAP8[i53 + (i9 << 2) + 2 >> 0] = i7;
             HEAP8[i53 + (i9 << 2) + 3 >> 0] = i36;
             HEAP16[i53 + (i9 << 2) >> 1] = 255;
             i13 = i13 + 1 << 16 >> 16;
            }
            i4 = i13 & 65535;
            HEAP8[i53 + (i4 << 2) + 2 >> 0] = i8;
            HEAP8[i53 + (i4 << 2) + 3 >> 0] = i36;
            HEAP16[i52 + (i32 << 1) >> 1] = i13;
            i18 = HEAP16[i31 >> 1] | 0;
            if ((i18 | 0) < (i32 | 0)) {
             HEAP16[i53 + (i4 << 2) >> 1] = HEAP16[i52 + (i18 << 1) >> 1] | 0;
             HEAP16[i53 + (HEAP16[i52 + (HEAP16[i31 >> 1] << 1) >> 1] << 2) >> 1] = i13;
            }
            i13 = i13 + 1 << 16 >> 16;
            i4 = i22;
           } while (0);
           if ((i35 | 0) == (i37 | 0)) {
            i18 = i34;
            break;
           } else {
            i33 = i20;
            i32 = i35;
            i18 = i12;
            i20 = i34;
           }
          }
          if (i18 & 1) {
           i37 = i54 + ((i3 & 65535) << 4) | 0;
           i36 = (HEAP32[i43 >> 2] | 0) + (i5 << 4) | 0;
           HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
           HEAP32[i37 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
           HEAP32[i37 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
           HEAP32[i37 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
           i3 = i3 + 1 << 16 >> 16;
          }
          if ((i9 | 0) != 255) {
           HEAP16[i51 + (i6 << 2) >> 1] = i9 & 255;
           HEAP8[i51 + (i6 << 2) + 2 >> 0] = i8;
           HEAP8[i51 + (i6 << 2) + 3 >> 0] = i7;
           i6 = i6 + 1 | 0;
          }
          i5 = i5 + 1 | 0;
          if ((i5 | 0) < (HEAP32[i42 >> 2] | 0)) {
           i7 = i20;
           i8 = i21;
           i37 = i12;
          } else {
           i12 = i6;
           break;
          }
         }
         if ((i12 | 0) > 0) {
          i5 = i3 + 1 << 16 >> 16;
          i7 = i54 + ((i3 & 65535) << 4) | 0;
          HEAP32[i7 >> 2] = HEAP32[i41 >> 2];
          HEAP32[i7 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
          HEAP32[i7 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
          HEAP32[i7 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
          i7 = i12 + -1 | 0;
          if ((i12 | 0) > 1) {
           i3 = 0;
           i9 = 0;
           while (1) {
            i6 = HEAP8[i51 + (i3 << 2) + 3 >> 0] | 0;
            i41 = i3 + 1 | 0;
            i8 = i51 + (i41 << 2) | 0;
            if (i6 << 24 >> 24 != (HEAP8[i51 + (i41 << 2) + 2 >> 0] | 0)) {
             i3 = i3 + 2 | 0;
             if ((i3 | 0) >= (i12 | 0)) {
              i3 = 0;
              break L117;
             }
             while (1) {
              if (i6 << 24 >> 24 == (HEAP8[i51 + (i3 << 2) + 2 >> 0] | 0)) break;
              i3 = i3 + 1 | 0;
              if ((i3 | 0) >= (i12 | 0)) {
               i3 = 0;
               break L117;
              }
             }
             i41 = i51 + (i3 << 2) | 0;
             i40 = HEAPU16[i8 >> 1] | HEAPU16[i8 + 2 >> 1] << 16;
             i39 = HEAPU16[i41 >> 1] | HEAPU16[i41 + 2 >> 1] << 16;
             HEAP16[i8 >> 1] = i39;
             HEAP16[i8 + 2 >> 1] = i39 >>> 16;
             HEAP16[i41 >> 1] = i40;
             HEAP16[i41 + 2 >> 1] = i40 >>> 16;
            }
            i9 = i9 + 1 << 16 >> 16;
            i3 = i9 & 65535;
            if ((i3 | 0) >= (i7 | 0)) {
             i18 = 1;
             i6 = i13;
             i61 = 144;
             break;
            }
           }
          } else {
           i18 = 1;
           i12 = 1;
           i6 = i13;
           i61 = 144;
          }
         } else {
          i18 = 0;
          i6 = i13;
          i5 = i3;
          i61 = 144;
         }
        } else {
         i1 = 0;
         i18 = 0;
         i12 = 0;
         i6 = 0;
         i5 = 0;
         i61 = 144;
        } while (0);
        if ((i61 | 0) == 144) {
         i61 = 0;
         if (!(i4 << 16 >> 16)) i3 = 0; else {
          i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
          i13 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
          i3 = _PxGetFoundation() | 0;
          i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
          i3 = mftCall_iiiiii(i13 | 0, i8 | 0, 36, (i3 ? gb + 730389 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1129) | 0;
          i8 = i4 & 65535;
          i13 = i6 & 65535;
          i9 = i5 & 65535;
          __ZN5physx7ConvexHC2Eiii(i3, i8, i13 + i12 | 0, i9);
          i4 = HEAP32[i46 >> 2] | 0;
          if ((i4 | 0) > 0) {
           i6 = 0;
           i7 = 0;
           i5 = 0;
           do {
            if ((HEAP8[i55 + (i6 << 2) >> 0] | 0) == 1) {
             i4 = (HEAP32[i3 >> 2] | 0) + (i5 * 12 | 0) | 0;
             i41 = (HEAP32[i2 >> 2] | 0) + (i6 * 12 | 0) | 0;
             HEAP32[i4 >> 2] = HEAP32[i41 >> 2];
             HEAP32[i4 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
             HEAP32[i4 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
             i4 = HEAP32[i46 >> 2] | 0;
             i5 = i5 + 1 | 0;
            }
            i7 = i7 + 1 << 16 >> 16;
            i6 = i7 & 65535;
           } while ((i6 | 0) < (i4 | 0));
           i4 = i5;
          } else i4 = 0;
          if ((i4 | 0) < (i8 | 0)) {
           i5 = 0;
           while (1) {
            i41 = (HEAP32[i3 >> 2] | 0) + (i4 * 12 | 0) | 0;
            i4 = i4 + 1 | 0;
            i40 = i1 + ((i5 & 65535) * 12 | 0) | 0;
            HEAP32[i41 >> 2] = HEAP32[i40 >> 2];
            HEAP32[i41 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
            HEAP32[i41 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
            if ((i4 | 0) == (i8 | 0)) break; else i5 = i5 + 1 << 16 >> 16;
           }
          }
          if (i18) {
           i5 = i9 + 255 & 255;
           i4 = HEAP32[i3 + 12 >> 2] | 0;
           i6 = 0;
           i7 = 0;
           do {
            i41 = i6 + i13 | 0;
            HEAP8[i4 + (i41 << 2) + 3 >> 0] = i5;
            i40 = HEAP16[i51 + (i6 << 2) >> 1] | 0;
            HEAP16[i4 + (i41 << 2) >> 1] = i40;
            HEAP16[i53 + ((i40 & 65535) << 2) >> 1] = i41;
            HEAP8[i4 + (i41 << 2) + 2 >> 0] = HEAP8[i51 + (i6 << 2) + 2 >> 0] | 0;
            i7 = i7 + 1 << 16 >> 16;
            i6 = i7 & 65535;
           } while ((i6 | 0) < (i12 | 0));
          } else i4 = HEAP32[i3 + 12 >> 2] | 0;
          _memcpy(i4 | 0, i53 | 0, i13 << 2 | 0) | 0;
          _memcpy(HEAP32[i3 + 24 >> 2] | 0, i54 | 0, i9 << 4 | 0) | 0;
         }
        }
        if (i1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
       }
      } else i61 = 64; while (0);
      if ((i61 | 0) == 64) {
       i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       i40 = HEAP32[(HEAP32[i41 >> 2] | 0) + 8 >> 2] | 0;
       i3 = _PxGetFoundation() | 0;
       i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
       i3 = mftCall_iiiiii(i40 | 0, i41 | 0, 36, (i3 ? gb + 730389 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 573) | 0;
       __ZN5physx7ConvexHC2Eiii(i3, HEAP32[i46 >> 2] | 0, HEAP32[i44 >> 2] | 0, HEAP32[i42 >> 2] | 0);
       _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i46 >> 2] | 0) * 12 | 0) | 0;
       _memcpy(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i45 >> 2] | 0, HEAP32[i44 >> 2] << 2 | 0) | 0;
       _memcpy(HEAP32[i3 + 24 >> 2] | 0, HEAP32[i43 >> 2] | 0, HEAP32[i42 >> 2] << 4 | 0) | 0;
       i61 = 159;
      }
      if ((i61 | 0) == 159) i61 = 0;
      if (!i3) {
       i18 = i2;
       break L73;
      }
      i1 = i3 + 16 | 0;
      i24 = HEAP32[i1 >> 2] | 0;
      i6 = i3 + 12 | 0;
      i4 = HEAP32[i6 >> 2] | 0;
      i9 = 0;
      i12 = 0;
      while (1) {
       if ((i12 | 0) >= (i24 | 0)) break;
       i5 = HEAP8[i4 + (i12 << 2) + 3 >> 0] | 0;
       i9 = (HEAP8[i4 + (i9 << 2) + 3 >> 0] | 0) == i5 << 24 >> 24 ? i9 : i12;
       i7 = i12;
       i12 = i12 + 1 | 0;
       if ((i12 | 0) < (i24 | 0)) if ((HEAP8[i4 + (i12 << 2) + 3 >> 0] | 0) == i5 << 24 >> 24) i8 = i12; else i61 = 169; else i61 = 169;
       if ((i61 | 0) == 169) {
        i61 = 0;
        i8 = i9;
       }
       i5 = HEAP16[i4 + (i7 << 2) >> 1] | 0;
       switch (i5 << 16 >> 16) {
       case 255:
       case -1:
        {
         i61 = 186;
         break L75;
        }
       default:
        {}
       }
       if ((HEAP8[i4 + (i5 << 16 >> 16 << 2) + 2 >> 0] | 0) != (HEAP8[i4 + (i8 << 2) + 2 >> 0] | 0)) {
        i61 = 186;
        break L75;
       }
      }
      L275 : do if ((i24 | 0) > 0) {
       i7 = i3 + 24 | 0;
       i5 = HEAP32[i7 >> 2] | 0;
       i22 = HEAP32[i3 >> 2] | 0;
       f26 = Math_fround(HEAPF32[gb + 110156 >> 2]);
       f27 = Math_fround(-f26);
       i21 = 0;
       while (1) {
        i12 = HEAP8[i4 + (i21 << 2) + 3 >> 0] | 0;
        i41 = i12 & 255;
        i40 = HEAPU8[i4 + (i21 << 2) + 2 >> 0] | 0;
        f10 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) >> 2]);
        f11 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) + 4 >> 2]);
        f14 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) + 8 >> 2]);
        f17 = Math_fround(HEAPF32[i5 + (i41 << 4) >> 2]);
        f19 = Math_fround(HEAPF32[i5 + (i41 << 4) + 4 >> 2]);
        f23 = Math_fround(HEAPF32[i5 + (i41 << 4) + 8 >> 2]);
        f75 = Math_fround(Math_fround(Math_fround(f10 * f17) + Math_fround(f11 * f19)) + Math_fround(f14 * f23));
        f75 = Math_fround(Math_fround(HEAPF32[i5 + (i41 << 4) + 12 >> 2]) + f75);
        if (!(!(f75 > f26) & !(f75 < f27))) {
         i4 = i7;
         i61 = 173;
         break L75;
        }
        i9 = (HEAP8[i4 + (i9 << 2) + 3 >> 0] | 0) == i12 << 24 >> 24 ? i9 : i21;
        i13 = i21;
        i21 = i21 + 1 | 0;
        i20 = (i21 | 0) < (i24 | 0);
        if (i20) if ((HEAP8[i4 + (i21 << 2) + 3 >> 0] | 0) == i12 << 24 >> 24) i18 = i21; else i61 = 176; else i61 = 176;
        if ((i61 | 0) == 176) {
         i61 = 0;
         i18 = i9;
        }
        i8 = i18 + 1 | 0;
        if ((i8 | 0) < (i24 | 0)) {
         if ((HEAP8[i4 + (i8 << 2) + 3 >> 0] | 0) != i12 << 24 >> 24) i61 = 179;
        } else i61 = 179;
        if ((i61 | 0) == 179) {
         i61 = 0;
         i8 = i9;
        }
        if ((i13 | 0) == (i8 | 0)) if (i20) continue; else break L275;
        i40 = HEAPU8[i4 + (i18 << 2) + 2 >> 0] | 0;
        i41 = HEAPU8[i4 + (i8 << 2) + 2 >> 0] | 0;
        f72 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) >> 2]);
        f75 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i22 + (i40 * 12 | 0) + 8 >> 2]);
        f71 = Math_fround(HEAPF32[i22 + (i41 * 12 | 0) >> 2]);
        f16 = Math_fround(HEAPF32[i22 + (i41 * 12 | 0) + 4 >> 2]);
        f74 = Math_fround(f72 - f10);
        f11 = Math_fround(f75 - f11);
        f73 = Math_fround(f15 - f14);
        f10 = Math_fround(f71 - f72);
        f75 = Math_fround(f16 - f75);
        f15 = Math_fround(Math_fround(HEAPF32[i22 + (i41 * 12 | 0) + 8 >> 2]) - f15);
        f16 = Math_fround(Math_fround(f11 * f15) - Math_fround(f73 * f75));
        f15 = Math_fround(Math_fround(f73 * f10) - Math_fround(f74 * f15));
        f10 = Math_fround(Math_fround(f74 * f75) - Math_fround(f11 * f10));
        f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f16 * f16) + Math_fround(f15 * f15)))));
        if (f11 == Math_fround(0.0)) {
         f14 = Math_fround(0.0);
         f11 = Math_fround(0.0);
         f10 = Math_fround(1.0);
        } else {
         f75 = Math_fround(Math_fround(1.0) / f11);
         f14 = Math_fround(f10 * f75);
         f11 = Math_fround(f15 * f75);
         f10 = Math_fround(f16 * f75);
        }
        i8 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f19 * f11)) + Math_fround(f23 * f14)) <= Math_fround(0.0);
        if (i8 | i20 ^ 1) break;
       }
       if (i8) {
        i61 = 187;
        break L75;
       }
      } while (0);
      if (i2 | 0) {
       i1 = HEAP32[i43 >> 2] | 0;
       if (i1 | 0) {
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
        HEAP32[i43 >> 2] = 0;
       }
       HEAP32[i42 >> 2] = 0;
       HEAP32[i2 + 32 >> 2] = 0;
       HEAP32[i43 >> 2] = 0;
       i1 = HEAP32[i45 >> 2] | 0;
       if (i1 | 0) {
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
        HEAP32[i45 >> 2] = 0;
       }
       HEAP32[i44 >> 2] = 0;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i45 >> 2] = 0;
       i1 = HEAP32[i2 >> 2] | 0;
       if (i1 | 0) {
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
        HEAP32[i2 >> 2] = 0;
       }
       HEAP32[i46 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i2);
      }
      if (!i47) {
       i18 = i3;
       break L73;
      } else i2 = i3;
     }
     if ((i61 | 0) == 173) i61 = 188; else if ((i61 | 0) == 186) {
      i5 = i3 + 24 | 0;
      i7 = i5;
      i5 = HEAP32[i5 >> 2] | 0;
      i61 = 187;
     }
     if ((i61 | 0) == 187) if (!i5) i5 = i6; else {
      i4 = i7;
      i61 = 188;
     }
     if ((i61 | 0) == 188) {
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i5);
      HEAP32[i4 >> 2] = 0;
      i7 = i4;
      i4 = HEAP32[i6 >> 2] | 0;
      i5 = i6;
     }
     HEAP32[i3 + 28 >> 2] = 0;
     HEAP32[i3 + 32 >> 2] = 0;
     HEAP32[i7 >> 2] = 0;
     if (i4 | 0) {
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i4);
      HEAP32[i5 >> 2] = 0;
     }
     HEAP32[i1 >> 2] = 0;
     HEAP32[i3 + 20 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) {
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
      HEAP32[i3 >> 2] = 0;
     }
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i3);
     i18 = i2;
    } else i18 = i2; while (0);
    i12 = i18 + 28 | 0;
    i13 = i18 + 16 | 0;
    i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i56, (HEAP32[i12 >> 2] | 0) + 1 + (HEAP32[i13 >> 2] | 0) << 2, gb + 730220 | 0, 2072) | 0;
    HEAP32[i60 >> 2] = i9;
    HEAP32[i62 >> 2] = 1;
    HEAP32[i9 >> 2] = -1;
    i1 = HEAP32[i13 >> 2] | 0;
    if ((i1 | 0) > 0) {
     i8 = i18 + 12 | 0;
     i7 = i1;
     i2 = 0;
     i1 = 0;
     do {
      i3 = i2 + 1 | 0;
      if ((i3 | 0) < (i7 | 0)) {
       i6 = HEAP32[i8 >> 2] | 0;
       i5 = HEAP8[i6 + (i2 << 2) + 3 >> 0] | 0;
       i4 = i3;
       i3 = 1;
       do {
        if (i5 << 24 >> 24 != (HEAP8[i6 + (i4 << 2) + 3 >> 0] | 0)) break;
        i3 = i3 + 1 | 0;
        i4 = i3 + i2 | 0;
       } while ((i4 | 0) < (i7 | 0));
       i60 = HEAP32[i62 >> 2] | 0;
       HEAP32[i62 >> 2] = i60 + 1;
       HEAP32[i9 + (i60 << 2) >> 2] = i3;
       if (i3) i61 = 211;
      } else {
       i6 = HEAP32[i62 >> 2] | 0;
       HEAP32[i62 >> 2] = i6 + 1;
       HEAP32[i9 + (i6 << 2) >> 2] = 1;
       i6 = HEAP32[i8 >> 2] | 0;
       i3 = 1;
       i61 = 211;
      }
      if ((i61 | 0) == 211) {
       i61 = 0;
       i4 = i2;
       i5 = i3;
       while (1) {
        i5 = i5 + -1 | 0;
        i57 = HEAPU8[i6 + (i4 << 2) + 2 >> 0] | 0;
        i60 = HEAP32[i62 >> 2] | 0;
        HEAP32[i62 >> 2] = i60 + 1;
        HEAP32[i9 + (i60 << 2) >> 2] = i57;
        if (!i5) break; else i4 = i4 + 1 | 0;
       }
       i2 = i3 + i2 | 0;
      }
      i1 = i1 + 1 | 0;
      i7 = HEAP32[i13 >> 2] | 0;
     } while ((i2 | 0) < (i7 | 0));
    } else i1 = 0;
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[i18 >> 2] | 0;
    HEAP32[i59 >> 2] = i1;
    i4 = i18 + 4 | 0;
    HEAP32[i58 >> 2] = HEAP32[i4 >> 2];
    if ((HEAP32[i4 >> 2] | 0) > 0) {
     _memmove(i1 | 0, HEAP32[i18 >> 2] | 0, 12) | 0;
     if ((HEAP32[i4 >> 2] | 0) > 1) {
      i1 = 1;
      do {
       _memmove((HEAP32[i59 >> 2] | 0) + (i1 * 12 | 0) | 0, (HEAP32[i18 >> 2] | 0) + (i1 * 12 | 0) | 0, 12) | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
     }
    }
    i3 = i18 + 8 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    i1 = i18 + 24 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i2);
     HEAP32[i1 >> 2] = 0;
    }
    HEAP32[i12 >> 2] = 0;
    HEAP32[i18 + 32 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    i1 = i18 + 12 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i2);
     HEAP32[i1 >> 2] = 0;
    }
    HEAP32[i13 >> 2] = 0;
    HEAP32[i18 + 20 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i18 >> 2] | 0;
    if (i1 | 0) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i1);
     HEAP32[i18 >> 2] = 0;
    }
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i18);
    i1 = 0;
   }
  }
 } while (0);
 i2 = HEAP32[i66 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i63, i2);
  HEAP32[i66 >> 2] = 0;
 }
 HEAP32[i64 >> 2] = 0;
 HEAP32[i65 >> 2] = 0;
 HEAP32[i66 >> 2] = 0;
 i66 = i1;
 STACKTOP = i67;
 return i66 | 0;
}

function __ZN22BuiltinResourceManager19InitializeResourcesEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i3 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, HEAP32[gb + 64480 >> 2] | 0) | 0;
 HEAP32[i3 + 24 >> 2] = 63;
 HEAP8[i3 + 28 >> 0] = 1;
 HEAP32[i4 >> 2] = gb + 469921;
 HEAP32[i4 + 4 >> 2] = gb + 31552;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = 17;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 17, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i3 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 478044;
 HEAP32[i4 + 4 >> 2] = gb + 31552;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 68;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 68, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453268;
 HEAP32[i4 + 4 >> 2] = gb + 31552;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 69;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 69, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453292;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10001;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10001, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017543;
 HEAP32[i4 + 4 >> 2] = gb + 30792;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10100;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10100, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1008101;
 HEAP32[i4 + 4 >> 2] = gb + 31552;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10101;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10101, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017543;
 HEAP32[i4 + 4 >> 2] = gb + 64868;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10102;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10102, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017543;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10103;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10103, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453301;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10202;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10202, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453310;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10206;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10206, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453327;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10207;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10207, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453342;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10208;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10208, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453358;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10209;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10209, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1046309;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10210;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10210, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453372;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10211;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10211, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453386;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10212;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10212, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453402;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10213;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10213, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453414;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10200;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10200, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453425;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10203;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10203, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453438;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10204;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10204, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453448;
 HEAP32[i4 + 4 >> 2] = gb + 30832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10205;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10205, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453460;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10400;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10400, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453485;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10401;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10401, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453504;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10402;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10402, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453523;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10407;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10407, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453548;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10408;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10408, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453572;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10409;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10409, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453595;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10410;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10410, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453618;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10411;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10411, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453634;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10413;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10413, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453659;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10414;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10414, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1046259;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10403;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10403, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1046259;
 HEAP32[i4 + 4 >> 2] = gb + 31832;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 10404;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 10404, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1018575;
 HEAP32[i4 + 4 >> 2] = gb + 27592;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11e3;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11e3, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017790;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11001;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11001, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017711;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11002;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11002, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017685;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11003;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11003, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017761;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11004;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11004, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017738;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11005;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11005, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1017665;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11006;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11006, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453689;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11007;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11007, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453729;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11008;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11008, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453763;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11009;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11009, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453793;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11010;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11010, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453826;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11011;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11011, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453852;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11012;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11012, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453884;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11013;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11013, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453911;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11014;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11014, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453937;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11015;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11015, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453966;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11016;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11016, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 453989;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11017;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11017, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454019;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11018;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11018, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454039;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11019;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11019, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454077;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11020;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11020, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454109;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11021;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11021, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454137;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11022;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11022, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454160;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11023;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11023, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454180;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11024;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11024, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454203;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11025;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11025, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454229;
 HEAP32[i4 + 4 >> 2] = gb + 32032;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11026;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11026, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 454258;
 HEAP32[i4 + 4 >> 2] = gb + 27480;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11998;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11998, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 489306;
 HEAP32[i4 + 4 >> 2] = gb + 27480;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 11999;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 11999, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 HEAP32[i4 >> 2] = gb + 1018436;
 HEAP32[i4 + 4 >> 2] = gb + 27480;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 12001;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i2, 12001, 0) | 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i4);
  i6 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i5, i6, i4);
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i6 = (HEAP32[i5 >> 2] | 0) + 24 | 0;
  HEAP32[i5 >> 2] = i6;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i5, i6, i4);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx18PxFabricCookerImpl4cookERKNS_15PxClothMeshDescENS_6PxVec3Eb(i83, i79, i34, i84) {
 i83 = i83 | 0;
 i79 = i79 | 0;
 i34 = i34 | 0;
 i84 = i84 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i80 = 0, i81 = 0, i82 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i89 + 24 | 0;
 i72 = i89 + 360 | 0;
 i69 = i89 + 368 | 0;
 i30 = i89 + 344 | 0;
 i20 = i89 + 328 | 0;
 i56 = i89 + 312 | 0;
 i21 = i89 + 268 | 0;
 i37 = i89 + 256 | 0;
 i44 = i89 + 244 | 0;
 i23 = i89 + 240 | 0;
 i88 = i89 + 228 | 0;
 i24 = i89 + 224 | 0;
 i87 = i89 + 272 | 0;
 i25 = i89 + 216 | 0;
 i26 = i89 + 208 | 0;
 i43 = i89 + 196 | 0;
 i27 = i89 + 192 | 0;
 i28 = i89 + 188 | 0;
 i33 = i89 + 176 | 0;
 i59 = i89 + 172 | 0;
 i36 = i89 + 168 | 0;
 i35 = i89 + 164 | 0;
 i41 = i89 + 152 | 0;
 i38 = i89 + 148 | 0;
 i39 = i89 + 144 | 0;
 i42 = i89 + 132 | 0;
 i40 = i89 + 128 | 0;
 i86 = i89 + 116 | 0;
 i52 = i89 + 16 | 0;
 i53 = i89 + 8 | 0;
 i55 = i89;
 i54 = i89 + 112 | 0;
 i58 = i89 + 108 | 0;
 i60 = i89 + 104 | 0;
 i62 = i89 + 100 | 0;
 i85 = i89 + 88 | 0;
 i63 = i89 + 84 | 0;
 i80 = i89 + 72 | 0;
 i64 = i89 + 68 | 0;
 i71 = i89 + 56 | 0;
 i70 = i89 + 52 | 0;
 i81 = i89 + 48 | 0;
 i75 = i89 + 44 | 0;
 i76 = i89 + 40 | 0;
 i82 = i89 + 36 | 0;
 i77 = i89 + 32 | 0;
 i78 = i89 + 28 | 0;
 i4 = HEAP32[i79 + 8 >> 2] | 0;
 do if (i4 >>> 0 >= 3) {
  if (i4 >>> 0 > 65535) if (HEAP16[i79 + 48 >> 1] & 2) break;
  i5 = i79 + 4 | 0;
  if (HEAP32[i5 >> 2] | 0) if ((HEAP32[i79 >> 2] | 0) >>> 0 >= 12) {
   i6 = i79 + 16 | 0;
   if (HEAP32[i6 >> 2] | 0) {
    if ((HEAP32[i79 + 12 >> 2] | 0) >>> 0 < 4) break;
    if ((HEAP32[i79 + 20 >> 2] | 0) != (i4 | 0)) break;
   }
   i22 = i79 + 32 | 0;
   i2 = (HEAP32[i22 >> 2] | 0) == 0;
   if (i2) if (!(HEAP32[i79 + 44 >> 2] | 0)) break; else i74 = 14; else {
    if (!(HEAP32[i79 + 28 >> 2] | 0)) break;
    if (!(HEAP32[i79 + 44 >> 2] | 0)) {
     i2 = 1;
     i1 = (HEAP16[i79 + 48 >> 1] & 2 ^ 2) + 2 | 0;
     i74 = 16;
    } else i74 = 14;
   }
   if ((i74 | 0) == 14) {
    if (!(HEAP32[i79 + 40 >> 2] | 0)) break;
    i1 = (HEAP16[i79 + 48 >> 1] & 2 ^ 2) + 2 | 0;
    if (i2) i74 = 18; else {
     i2 = 0;
     i74 = 16;
    }
   }
   if ((i74 | 0) == 16) {
    if ((HEAP32[i79 + 24 >> 2] | 0) >>> 0 < (i1 * 3 | 0) >>> 0) break;
    if (!i2) i74 = 18;
   }
   if ((i74 | 0) == 18) if ((HEAP32[i79 + 36 >> 2] | 0) >>> 0 < i1 << 2 >>> 0) break;
   f11 = Math_fround(HEAPF32[i34 >> 2]);
   f8 = Math_fround(f11 * f11);
   i31 = i34 + 4 | 0;
   f10 = Math_fround(HEAPF32[i31 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f10 * f10));
   i32 = i34 + 8 | 0;
   f7 = Math_fround(HEAPF32[i32 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f7 * f7));
   if (f8 > Math_fround(0.0)) {
    f90 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
    f9 = Math_fround(f7 * f90);
    f8 = Math_fround(f10 * f90);
    f7 = Math_fround(f11 * f90);
   } else {
    f9 = Math_fround(0.0);
    f8 = Math_fround(0.0);
    f7 = Math_fround(0.0);
   }
   HEAPF32[i34 >> 2] = f7;
   HEAPF32[i31 >> 2] = f8;
   HEAPF32[i32 >> 2] = f9;
   HEAP32[i83 >> 2] = i4;
   HEAP32[i30 >> 2] = 0;
   i19 = i30 + 4 | 0;
   HEAP32[i19 >> 2] = 0;
   i73 = i30 + 8 | 0;
   HEAP32[i73 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i30, i4);
   i14 = HEAP32[i79 >> 2] | 0;
   i1 = HEAP32[i83 >> 2] | 0;
   i15 = HEAP32[i79 + 12 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i16 = i20 + 4 | 0;
    i17 = i20 + 8 | 0;
    i18 = i20 + 12 | 0;
    i13 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i12 = 0;
    while (1) {
     i3 = i13;
     if (!i2) {
      f7 = Math_fround(1.0);
      i2 = 0;
     } else {
      f7 = Math_fround(HEAPF32[i2 >> 2]);
      i2 = i2 + i15 | 0;
     }
     i5 = HEAP32[i13 >> 2] | 0;
     HEAP32[i20 >> 2] = i5;
     i6 = HEAP32[i3 + 4 >> 2] | 0;
     HEAP32[i16 >> 2] = i6;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
     HEAP32[i17 >> 2] = i3;
     HEAPF32[i18 >> 2] = f7;
     i4 = HEAP32[i19 >> 2] | 0;
     if ((HEAP32[i73 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i68 = HEAP32[i30 >> 2] | 0;
      HEAP32[i68 + (i4 << 4) >> 2] = i5;
      HEAP32[i68 + (i4 << 4) + 4 >> 2] = i6;
      HEAP32[i68 + (i4 << 4) + 8 >> 2] = i3;
      HEAPF32[i68 + (i4 << 4) + 12 >> 2] = f7;
      HEAP32[i19 >> 2] = i4 + 1;
     } else {
      __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i30, i20) | 0;
      i1 = HEAP32[i83 >> 2] | 0;
     }
     i12 = i12 + 1 | 0;
     if (i12 >>> 0 >= i1 >>> 0) break; else i13 = i13 + i14 | 0;
    }
   }
   HEAP32[i21 >> 2] = 0;
   HEAP32[i56 >> 2] = 0;
   i29 = i56 + 4 | 0;
   HEAP32[i29 >> 2] = 0;
   i68 = i56 + 8 | 0;
   HEAP32[i68 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i56, i1 + 1 | 0, i21);
   HEAP32[i37 >> 2] = 0;
   i16 = i37 + 4 | 0;
   HEAP32[i16 >> 2] = 0;
   i67 = i37 + 8 | 0;
   HEAP32[i67 >> 2] = 0;
   i5 = i79 + 24 | 0;
   i15 = i79 + 36 | 0;
   if (!(HEAP16[i79 + 48 >> 1] & 2)) {
    i6 = i79 + 28 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i2 = HEAP32[i56 >> 2] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i4 = 0;
     while (1) {
      i66 = i3;
      i65 = i2 + (HEAP32[i66 >> 2] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAP32[i66 + 4 >> 2] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i66 = i2 + (HEAP32[i66 + 8 >> 2] << 2) | 0;
      HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + 2;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i3 = i3 + i1 | 0;
     }
    }
    i12 = i79 + 40 | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i13 = i79 + 44 | 0;
    if (!(HEAP32[i13 >> 2] | 0)) i14 = HEAP32[i56 >> 2] | 0; else {
     i2 = HEAP32[i56 >> 2] | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     i4 = 0;
     while (1) {
      i66 = i3;
      i65 = i2 + (HEAP32[i66 >> 2] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAP32[i66 + 4 >> 2] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAP32[i66 + 8 >> 2] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i66 = i2 + (HEAP32[i66 + 12 >> 2] << 2) | 0;
      HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + 2;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) {
       i14 = i2;
       break;
      } else i3 = i3 + i1 | 0;
     }
    }
    i1 = HEAP32[i29 >> 2] | 0;
    i4 = i14 + (i1 << 2) | 0;
    if (!i1) {
     i2 = 0;
     i1 = -1;
    } else if ((i1 | 0) == 1) {
     i2 = 1;
     i1 = 0;
    } else {
     i1 = i14 + 4 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
     i3 = i14;
     do {
      i3 = i3 + 4 | 0;
      i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
      HEAP32[i3 >> 2] = i2;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) != (i4 | 0));
     i1 = HEAP32[i29 >> 2] | 0;
     i2 = i1;
     i1 = i1 + -1 | 0;
    }
    i4 = HEAP32[i14 + (i1 << 2) >> 2] | 0;
    HEAP32[i72 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i37, i4, i72);
    i4 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i5 = HEAP32[i37 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     i3 = 0;
     while (1) {
      i57 = i1;
      i65 = i57 + 4 | 0;
      i51 = HEAP32[i65 >> 2] | 0;
      i66 = i14 + (HEAP32[i57 >> 2] << 2) | 0;
      i61 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i61;
      HEAP32[i5 + (i61 << 2) >> 2] = i51;
      i61 = i57 + 8 | 0;
      i51 = HEAP32[i61 >> 2] | 0;
      i66 = i14 + (HEAP32[i57 >> 2] << 2) | 0;
      i50 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i50;
      HEAP32[i5 + (i50 << 2) >> 2] = i51;
      i50 = HEAP32[i61 >> 2] | 0;
      i51 = i14 + (HEAP32[i65 >> 2] << 2) | 0;
      i66 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i50;
      i66 = HEAP32[i57 >> 2] | 0;
      i50 = i14 + (HEAP32[i65 >> 2] << 2) | 0;
      i51 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i51;
      HEAP32[i5 + (i51 << 2) >> 2] = i66;
      i57 = HEAP32[i57 >> 2] | 0;
      i51 = i14 + (HEAP32[i61 >> 2] << 2) | 0;
      i66 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i57;
      i65 = HEAP32[i65 >> 2] | 0;
      i61 = i14 + (HEAP32[i61 >> 2] << 2) | 0;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i65;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
     }
    }
    i4 = HEAP32[i15 >> 2] | 0;
    if (HEAP32[i13 >> 2] | 0) {
     i5 = HEAP32[i37 >> 2] | 0;
     i1 = HEAP32[i12 >> 2] | 0;
     i3 = 0;
     while (1) {
      i57 = i1;
      i66 = i57 + 4 | 0;
      i50 = HEAP32[i66 >> 2] | 0;
      i51 = i14 + (HEAP32[i57 >> 2] << 2) | 0;
      i61 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i61;
      HEAP32[i5 + (i61 << 2) >> 2] = i50;
      i61 = i57 + 12 | 0;
      i50 = HEAP32[i61 >> 2] | 0;
      i51 = i14 + (HEAP32[i57 >> 2] << 2) | 0;
      i65 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i65;
      HEAP32[i5 + (i65 << 2) >> 2] = i50;
      i65 = i57 + 8 | 0;
      i50 = HEAP32[i65 >> 2] | 0;
      i51 = i14 + (HEAP32[i66 >> 2] << 2) | 0;
      i49 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i49;
      HEAP32[i5 + (i49 << 2) >> 2] = i50;
      i49 = HEAP32[i57 >> 2] | 0;
      i50 = i14 + (HEAP32[i66 >> 2] << 2) | 0;
      i51 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i51;
      HEAP32[i5 + (i51 << 2) >> 2] = i49;
      i51 = HEAP32[i61 >> 2] | 0;
      i49 = i14 + (HEAP32[i65 >> 2] << 2) | 0;
      i50 = (HEAP32[i49 >> 2] | 0) + -1 | 0;
      HEAP32[i49 >> 2] = i50;
      HEAP32[i5 + (i50 << 2) >> 2] = i51;
      i66 = HEAP32[i66 >> 2] | 0;
      i50 = i14 + (HEAP32[i65 >> 2] << 2) | 0;
      i51 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i51;
      HEAP32[i5 + (i51 << 2) >> 2] = i66;
      i57 = HEAP32[i57 >> 2] | 0;
      i51 = i14 + (HEAP32[i61 >> 2] << 2) | 0;
      i66 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i57;
      i65 = HEAP32[i65 >> 2] | 0;
      i61 = i14 + (HEAP32[i61 >> 2] << 2) | 0;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i65;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
     }
    }
   } else {
    i6 = i79 + 28 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i2 = HEAP32[i56 >> 2] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i4 = 0;
     while (1) {
      i66 = i3;
      i65 = i2 + (HEAPU16[i66 >> 1] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAPU16[i66 + 2 >> 1] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i66 = i2 + (HEAPU16[i66 + 4 >> 1] << 2) | 0;
      HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + 2;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i3 = i3 + i1 | 0;
     }
    }
    i12 = i79 + 40 | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i13 = i79 + 44 | 0;
    if (!(HEAP32[i13 >> 2] | 0)) i14 = HEAP32[i56 >> 2] | 0; else {
     i2 = HEAP32[i56 >> 2] | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     i4 = 0;
     while (1) {
      i66 = i3;
      i65 = i2 + (HEAPU16[i66 >> 1] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAPU16[i66 + 2 >> 1] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i65 = i2 + (HEAPU16[i66 + 4 >> 1] << 2) | 0;
      HEAP32[i65 >> 2] = (HEAP32[i65 >> 2] | 0) + 2;
      i66 = i2 + (HEAPU16[i66 + 6 >> 1] << 2) | 0;
      HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + 2;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) {
       i14 = i2;
       break;
      } else i3 = i3 + i1 | 0;
     }
    }
    i1 = HEAP32[i29 >> 2] | 0;
    i4 = i14 + (i1 << 2) | 0;
    if (!i1) {
     i2 = 0;
     i1 = -1;
    } else if ((i1 | 0) == 1) {
     i2 = 1;
     i1 = 0;
    } else {
     i1 = i14 + 4 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
     i3 = i14;
     do {
      i3 = i3 + 4 | 0;
      i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
      HEAP32[i3 >> 2] = i2;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) != (i4 | 0));
     i1 = HEAP32[i29 >> 2] | 0;
     i2 = i1;
     i1 = i1 + -1 | 0;
    }
    i4 = HEAP32[i14 + (i1 << 2) >> 2] | 0;
    HEAP32[i72 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i37, i4, i72);
    i4 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i5 = HEAP32[i37 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     i3 = 0;
     while (1) {
      i61 = i1;
      i65 = HEAPU16[i61 + 2 >> 1] | 0;
      i57 = HEAPU16[i61 >> 1] | 0;
      i66 = i14 + (i57 << 2) | 0;
      i51 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i51;
      HEAP32[i5 + (i51 << 2) >> 2] = i65;
      i61 = HEAPU16[i61 + 4 >> 1] | 0;
      i51 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i51;
      HEAP32[i5 + (i51 << 2) >> 2] = i61;
      i51 = i14 + (i65 << 2) | 0;
      i66 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i61;
      i66 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
      HEAP32[i51 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i57;
      i61 = i14 + (i61 << 2) | 0;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i57;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i65;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
     }
    }
    i4 = HEAP32[i15 >> 2] | 0;
    if (HEAP32[i13 >> 2] | 0) {
     i5 = HEAP32[i37 >> 2] | 0;
     i1 = HEAP32[i12 >> 2] | 0;
     i3 = 0;
     while (1) {
      i65 = i1;
      i51 = HEAPU16[i65 + 2 >> 1] | 0;
      i57 = HEAPU16[i65 >> 1] | 0;
      i50 = i14 + (i57 << 2) | 0;
      i61 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i61;
      HEAP32[i5 + (i61 << 2) >> 2] = i51;
      i61 = HEAPU16[i65 + 6 >> 1] | 0;
      i66 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i61;
      i65 = HEAPU16[i65 + 4 >> 1] | 0;
      i66 = i14 + (i51 << 2) | 0;
      i50 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i50;
      HEAP32[i5 + (i50 << 2) >> 2] = i65;
      i50 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
      HEAP32[i66 >> 2] = i50;
      HEAP32[i5 + (i50 << 2) >> 2] = i57;
      i50 = i14 + (i65 << 2) | 0;
      i66 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i61;
      i66 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
      HEAP32[i50 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i51;
      i61 = i14 + (i61 << 2) | 0;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i57;
      i66 = (HEAP32[i61 >> 2] | 0) + -1 | 0;
      HEAP32[i61 >> 2] = i66;
      HEAP32[i5 + (i66 << 2) >> 2] = i65;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
     }
    }
   }
   HEAP32[i23 >> 2] = 0;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   i66 = i44 + 8 | 0;
   HEAP32[i66 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i44, i2, i23);
   HEAP32[i88 >> 2] = 0;
   i13 = i88 + 4 | 0;
   HEAP32[i13 >> 2] = 0;
   i65 = i88 + 8 | 0;
   HEAP32[i65 >> 2] = 0;
   i1 = HEAP32[i16 >> 2] | 0;
   if (i1 | 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i88, i1);
   if (i2 >>> 0 > 1) {
    i4 = HEAP32[i37 >> 2] | 0;
    i5 = HEAP32[i44 >> 2] | 0;
    i12 = 1;
    i1 = 0;
    do {
     i6 = i14 + (i12 << 2) | 0;
     if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) do {
      i3 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
      HEAP32[i24 >> 2] = i3;
      i2 = i5 + (i3 << 2) | 0;
      do if ((HEAP32[i2 >> 2] | 0) != (i12 | 0)) {
       HEAP32[i2 >> 2] = i12;
       i2 = HEAP32[i13 >> 2] | 0;
       if ((HEAP32[i65 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
        HEAP32[(HEAP32[i88 >> 2] | 0) + (i2 << 2) >> 2] = i3;
        HEAP32[i13 >> 2] = i2 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i88, i24) | 0;
        break;
       }
      } while (0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
     HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
     i12 = i12 + 1 | 0;
    } while (i12 >>> 0 < (HEAP32[i29 >> 2] | 0) >>> 0);
   }
   HEAP32[i87 >> 2] = 0;
   HEAP32[i87 + 4 >> 2] = 0;
   HEAP32[i87 + 8 >> 2] = 0;
   HEAP32[i87 + 12 >> 2] = 0;
   HEAP32[i87 + 16 >> 2] = 0;
   HEAP32[i87 + 20 >> 2] = 0;
   HEAPF32[i87 + 24 >> 2] = Math_fround(.75);
   HEAP32[i87 + 28 >> 2] = -1;
   HEAP32[i87 + 32 >> 2] = 0;
   i24 = i87 + 36 | 0;
   HEAP32[i24 >> 2] = 0;
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEEN12_GLOBAL__N_14EdgeEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i87, 64);
   i1 = HEAP32[i83 >> 2] | 0;
   if (i1 | 0) {
    i19 = HEAP32[i30 >> 2] | 0;
    i20 = HEAP32[i88 >> 2] | 0;
    i21 = i25 + 4 | 0;
    i22 = i26 + 4 | 0;
    i23 = HEAP32[i56 >> 2] | 0;
    i18 = 0;
    do {
     f7 = Math_fround(HEAPF32[i19 + (i18 << 4) + 12 >> 2]);
     i17 = i18;
     i18 = i18 + 1 | 0;
     i16 = HEAP32[i23 + (i18 << 2) >> 2] | 0;
     i2 = HEAP32[i23 + (i17 << 2) >> 2] | 0;
     if (i2 >>> 0 < i16 >>> 0) {
      i13 = i19 + (i17 << 4) | 0;
      i14 = i19 + (i17 << 4) + 4 | 0;
      i15 = i19 + (i17 << 4) + 8 | 0;
      do {
       i1 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
       if (Math_fround(f7 + Math_fround(HEAPF32[i19 + (i1 << 4) + 12 >> 2])) > Math_fround(0.0)) {
        i61 = i17 >>> 0 < i1 >>> 0;
        HEAP32[i25 >> 2] = i61 ? i17 : i1;
        HEAP32[i21 >> 2] = i61 ? i1 : i17;
        i61 = __ZN5physx6shdfnd8internal11HashMapBaseINS0_4PairIjjEEN12_GLOBAL__N_14EdgeENS0_4HashIS4_EENS0_9AllocatorEEixERKS4_(i87, i25) | 0;
        HEAPF32[i61 >> 2] = Math_fround(Math_fround(HEAPF32[i61 >> 2]) + Math_fround(.100000001));
       }
       i5 = HEAP32[i23 + (i1 + 1 << 2) >> 2] | 0;
       i3 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
       if (i3 >>> 0 < i5 >>> 0) {
        i6 = i19 + (i1 << 4) | 0;
        i12 = i19 + (i1 << 4) + 4 | 0;
        i4 = i19 + (i1 << 4) + 8 | 0;
        do {
         i1 = HEAP32[i20 + (i3 << 2) >> 2] | 0;
         do if ((i1 | 0) != (i17 | 0)) {
          if (!(Math_fround(f7 + Math_fround(HEAPF32[i19 + (i1 << 4) + 12 >> 2])) > Math_fround(0.0))) break;
          i61 = i17 >>> 0 < i1 >>> 0;
          HEAP32[i26 >> 2] = i61 ? i17 : i1;
          HEAP32[i22 >> 2] = i61 ? i1 : i17;
          i61 = __ZN5physx6shdfnd8internal11HashMapBaseINS0_4PairIjjEEN12_GLOBAL__N_14EdgeENS0_4HashIS4_EENS0_9AllocatorEEixERKS4_(i87, i26) | 0;
          f91 = Math_fround(HEAPF32[i6 >> 2]);
          f10 = Math_fround(HEAPF32[i13 >> 2]);
          f97 = Math_fround(f91 - f10);
          f96 = Math_fround(HEAPF32[i12 >> 2]);
          f11 = Math_fround(HEAPF32[i14 >> 2]);
          f95 = Math_fround(f96 - f11);
          f9 = Math_fround(HEAPF32[i4 >> 2]);
          f90 = Math_fround(HEAPF32[i15 >> 2]);
          f98 = Math_fround(f9 - f90);
          f94 = Math_fround(HEAPF32[i19 + (i1 << 4) >> 2]);
          f91 = Math_fround(f94 - f91);
          f93 = Math_fround(HEAPF32[i19 + (i1 << 4) + 4 >> 2]);
          f96 = Math_fround(f93 - f96);
          f92 = Math_fround(HEAPF32[i19 + (i1 << 4) + 8 >> 2]);
          f9 = Math_fround(f92 - f9);
          f8 = Math_fround(Math_fround(f95 * f9) - Math_fround(f98 * f96));
          f9 = Math_fround(Math_fround(f98 * f91) - Math_fround(f97 * f9));
          f91 = Math_fround(Math_fround(f97 * f96) - Math_fround(f95 * f91));
          f10 = Math_fround(f94 - f10);
          f11 = Math_fround(f93 - f11);
          f90 = Math_fround(f92 - f90);
          f90 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f91 * f91) + Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9))))) / Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f90 * f90)));
          f11 = Math_fround(Math_fround(.150000006) - Math_fround(Math_abs(Math_fround(Math_fround(.449999988) - f90))));
          i57 = f11 < Math_fround(0.0);
          f11 = i57 ? Math_fround(0.0) : f11;
          i57 = i61 + 8 | 0;
          HEAPF32[i57 >> 2] = Math_fround(Math_fround(HEAPF32[i57 >> 2]) + f11);
          f90 = Math_fround(Math_fround(.100000001) - f90);
          i57 = f90 < Math_fround(0.0);
          f90 = Math_fround(f90 * Math_fround(3.0));
          f90 = i57 ? Math_fround(0.0) : f90;
          i61 = i61 + 4 | 0;
          HEAPF32[i61 >> 2] = Math_fround(Math_fround(HEAPF32[i61 >> 2]) + f90);
         } while (0);
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) != (i5 | 0));
       }
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i16 | 0));
      i1 = HEAP32[i83 >> 2] | 0;
     }
    } while (i18 >>> 0 < i1 >>> 0);
   }
   HEAP32[i43 >> 2] = 0;
   i19 = i43 + 4 | 0;
   HEAP32[i19 >> 2] = 0;
   i61 = i43 + 8 | 0;
   HEAP32[i61 >> 2] = 0;
   i1 = HEAP32[i24 >> 2] | 0;
   if (i1 | 0) __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE8recreateEj(i43, i1);
   HEAP32[i27 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i56, 0, i27);
   i18 = (HEAP32[i83 >> 2] | 0) + 1 | 0;
   HEAP32[i28 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i56, i18, i28);
   i18 = i87 + 12 | 0;
   L145 : do if (!(HEAP32[i87 + 16 >> 2] | 0)) {
    i1 = -1;
    i2 = 0;
   } else {
    i4 = HEAP32[i18 >> 2] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) == -1) {
     i3 = HEAP32[i87 + 20 >> 2] | 0;
     i1 = 0;
     while (1) {
      i2 = i1 + 1 | 0;
      if ((i2 | 0) == (i3 | 0)) {
       i1 = -1;
       i2 = i3;
       break L145;
      }
      i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      if ((i1 | 0) == -1) i1 = i2; else break;
     }
    } else i2 = 0;
   } while (0);
   i17 = i87 + 4 | 0;
   i15 = i33 + 4 | 0;
   i16 = i33 + 8 | 0;
   i57 = HEAP32[i30 >> 2] | 0;
   i13 = i87 + 8 | 0;
   i12 = i87 + 20 | 0;
   i14 = HEAP32[i56 >> 2] | 0;
   L152 : while (1) {
    do {
     if ((i1 | 0) == -1) break L152;
     i4 = HEAP32[i17 >> 2] | 0;
     i3 = i4 + (i1 * 20 | 0) | 0;
     f7 = Math_fround(HEAPF32[i4 + (i1 * 20 | 0) + 8 >> 2]);
     f8 = Math_fround(HEAPF32[i4 + (i1 * 20 | 0) + 12 >> 2]);
     f98 = Math_fround(f7 + f8);
     f9 = Math_fround(HEAPF32[i4 + (i1 * 20 | 0) + 16 >> 2]);
     do if (Math_fround(f98 + f9) > Math_fround(0.0)) {
      do if (f8 > (f7 > f9 ? f7 : f9)) i6 = 3; else {
       if (f9 > (f7 > f8 ? f7 : f8)) {
        i6 = 4;
        break;
       }
       i50 = HEAP32[i3 >> 2] | 0;
       i51 = HEAP32[i4 + (i1 * 20 | 0) + 4 >> 2] | 0;
       f11 = Math_fround(HEAPF32[i57 + (i50 << 4) >> 2]);
       f11 = Math_fround(f11 - Math_fround(HEAPF32[i57 + (i51 << 4) >> 2]));
       f10 = Math_fround(HEAPF32[i57 + (i50 << 4) + 4 >> 2]);
       f10 = Math_fround(f10 - Math_fround(HEAPF32[i57 + (i51 << 4) + 4 >> 2]));
       f7 = Math_fround(HEAPF32[i57 + (i50 << 4) + 8 >> 2]);
       f7 = Math_fround(f7 - Math_fround(HEAPF32[i57 + (i51 << 4) + 8 >> 2]));
       f8 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f7 * f7));
       if (f8 > Math_fround(0.0)) {
        f98 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
        f9 = Math_fround(f7 * f98);
        f8 = Math_fround(f10 * f98);
        f7 = Math_fround(f11 * f98);
       } else {
        f9 = Math_fround(0.0);
        f8 = Math_fround(0.0);
        f7 = Math_fround(0.0);
       }
       f98 = Math_fround(f7 * Math_fround(HEAPF32[i34 >> 2]));
       f98 = Math_fround(f98 + Math_fround(f8 * Math_fround(HEAPF32[i31 >> 2])));
       i6 = Math_fround(Math_abs(Math_fround(f98 + Math_fround(f9 * Math_fround(HEAPF32[i32 >> 2]))))) < Math_fround(.632455527);
       i6 = i6 ? 2 : 1;
      } while (0);
      i5 = i14 + (HEAP32[i3 >> 2] << 2) | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i4 = i4 + (i1 * 20 | 0) + 4 | 0;
      i5 = i14 + (HEAP32[i4 >> 2] << 2) | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i3 = HEAP32[i3 >> 2] | 0;
      HEAP32[i33 >> 2] = i3;
      i4 = HEAP32[i4 >> 2] | 0;
      HEAP32[i15 >> 2] = i4;
      HEAP32[i16 >> 2] = i6;
      i5 = HEAP32[i19 >> 2] | 0;
      if ((HEAP32[i61 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
       i51 = HEAP32[i43 >> 2] | 0;
       HEAP32[i51 + (i5 * 12 | 0) >> 2] = i3;
       HEAP32[i51 + (i5 * 12 | 0) + 4 >> 2] = i4;
       HEAP32[i51 + (i5 * 12 | 0) + 8 >> 2] = i6;
       HEAP32[i19 >> 2] = i5 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE15growAndPushBackERKS6_(i43, i33) | 0;
       break;
      }
     } while (0);
     i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    } while ((i1 | 0) != -1);
    i4 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i18 >> 2] | 0;
    while (1) {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i4 | 0)) {
      i1 = -1;
      i2 = i4;
      continue L152;
     }
     i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
     if ((i1 | 0) != -1) continue L152;
    }
   }
   i5 = HEAP32[i56 >> 2] | 0;
   i1 = HEAP32[i29 >> 2] | 0;
   i4 = i5 + (i1 << 2) | 0;
   if (!i1) i1 = 0; else if ((i1 | 0) == 1) i1 = 1; else {
    i1 = i5 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i5;
    do {
     i3 = i3 + 4 | 0;
     i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
     HEAP32[i3 >> 2] = i2;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i29 >> 2] | 0;
   }
   i29 = HEAP32[i19 >> 2] | 0;
   HEAP32[i59 >> 2] = i29;
   HEAP32[i36 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i37, 0, i36);
   i4 = HEAP32[i5 + (i1 + -1 << 2) >> 2] | 0;
   HEAP32[i35 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i37, i4, i35);
   i4 = (i29 | 0) == 0;
   if (i4) {
    i51 = HEAP32[i37 >> 2] | 0;
    i1 = 0;
   } else {
    i3 = HEAP32[i43 >> 2] | 0;
    i1 = HEAP32[i37 >> 2] | 0;
    i2 = 0;
    do {
     i51 = i5 + (HEAP32[i3 + (i2 * 12 | 0) >> 2] << 2) | 0;
     i50 = (HEAP32[i51 >> 2] | 0) + -1 | 0;
     HEAP32[i51 >> 2] = i50;
     HEAP32[i1 + (i50 << 2) >> 2] = i2;
     i50 = i5 + (HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] << 2) | 0;
     i51 = (HEAP32[i50 >> 2] | 0) + -1 | 0;
     HEAP32[i50 >> 2] = i51;
     HEAP32[i1 + (i51 << 2) >> 2] = i2;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i29 >>> 0);
    i51 = i1;
    i1 = i29;
   }
   HEAP32[i41 >> 2] = 0;
   HEAP32[i41 + 4 >> 2] = 0;
   i50 = i41 + 8 | 0;
   HEAP32[i50 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i41, i1, i59);
   HEAP32[i38 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i44, 0, i38);
   HEAP32[i39 >> 2] = -1;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i44, i29 + 1 | 0, i39);
   HEAP32[i40 >> 2] = 0;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   i49 = i42 + 8 | 0;
   HEAP32[i49 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i42, i29, i40);
   HEAP32[i86 >> 2] = 0;
   i27 = i86 + 4 | 0;
   HEAP32[i27 >> 2] = 0;
   i48 = i86 + 8 | 0;
   HEAP32[i48 >> 2] = 0;
   if (!i4) __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i86, i29);
   i47 = HEAP32[i41 >> 2] | 0;
   i46 = HEAP32[i42 >> 2] | 0;
   i26 = i52 + 4 | 0;
   i45 = HEAP32[i43 >> 2] | 0;
   i44 = HEAP32[i44 >> 2] | 0;
   i19 = i53 + 4 | 0;
   i20 = i83 + 4 | 0;
   i21 = i83 + 8 | 0;
   i22 = i55 + 4 | 0;
   i23 = i83 + 12 | 0;
   i42 = i83 + 16 | 0;
   i28 = i83 + 24 | 0;
   i43 = i83 + 20 | 0;
   i24 = i83 + 16 | 0;
   i25 = (i29 | 0) != 0;
   L191 : do if (i25) {
    i1 = i5;
    while (1) {
     i2 = 0;
     L194 : while (1) {
      if ((HEAP32[i47 + (i2 << 2) >> 2] | 0) == (i29 | 0)) {
       HEAP32[i27 >> 2] = 0;
       i41 = HEAP32[i46 + (i2 << 2) >> 2] | 0;
       HEAP32[i52 >> 2] = i2;
       HEAP32[i26 >> 2] = i41;
       if (HEAP32[i48 >> 2] & 2147483647 | 0) {
        i74 = 135;
        break;
       }
       __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i86, i52) | 0;
       i5 = HEAP32[i27 >> 2] | 0;
       i6 = HEAP32[i86 >> 2] | 0;
       L199 : do if ((i5 | 0) > 0) {
        i3 = (i5 << 3 >> 3) + -1 | 0;
        if (!i3) {
         i4 = i5;
         i3 = i6;
         break L194;
        }
        do {
         i4 = i3;
         i3 = (i3 + -1 | 0) >>> 1;
         if ((HEAP32[i6 + (i3 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i6 + (i4 << 3) + 4 >> 2] | 0) >>> 0) break L199;
         i41 = i6 + (i4 << 3) | 0;
         i38 = i6 + (i3 << 3) | 0;
         i40 = i38;
         i39 = HEAP32[i40 >> 2] | 0;
         i40 = HEAP32[i40 + 4 >> 2] | 0;
         i36 = i41;
         i37 = HEAP32[i36 + 4 >> 2] | 0;
         HEAP32[i38 >> 2] = HEAP32[i36 >> 2];
         HEAP32[i38 + 4 >> 2] = i37;
         HEAP32[i41 >> 2] = i39;
         HEAP32[i41 + 4 >> 2] = i40;
        } while ((i3 | 0) != 0);
       } while (0);
       if (!i5) i2 = 0; else {
        i4 = i5;
        i3 = i6;
        break;
       }
      } else i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i29 >>> 0) {
       i41 = i1;
       break L191;
      }
     }
     if ((i74 | 0) == 135) {
      i74 = 0;
      i3 = HEAP32[i86 >> 2] | 0;
      i40 = i52;
      i41 = HEAP32[i40 + 4 >> 2] | 0;
      i4 = i3;
      HEAP32[i4 >> 2] = HEAP32[i40 >> 2];
      HEAP32[i4 + 4 >> 2] = i41;
      HEAP32[i27 >> 2] = 1;
      i4 = 1;
     }
     i18 = HEAP32[i45 + (i2 * 12 | 0) + 8 >> 2] | 0;
     i2 = i4;
     do {
      i4 = i2 + -1 | 0;
      i41 = i3 + (i4 << 3) | 0;
      i40 = i3;
      i39 = HEAP32[i40 >> 2] | 0;
      i40 = HEAP32[i40 + 4 >> 2] | 0;
      i36 = i41;
      i37 = HEAP32[i36 + 4 >> 2] | 0;
      i38 = i3;
      HEAP32[i38 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i38 + 4 >> 2] = i37;
      HEAP32[i41 >> 2] = i39;
      HEAP32[i41 + 4 >> 2] = i40;
      L212 : do if ((i4 | 0) > 1) {
       i5 = 1;
       i6 = 0;
       while (1) {
        i2 = i5 + 1 | 0;
        if ((i2 | 0) < (i4 | 0)) i2 = (HEAP32[i3 + (i5 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0) >>> 0 ? i2 : i5; else i2 = i5;
        if ((HEAP32[i3 + (i6 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0) >>> 0) break L212;
        i5 = i3 + (i2 << 3) | 0;
        i39 = i3 + (i6 << 3) | 0;
        i41 = i39;
        i40 = HEAP32[i41 >> 2] | 0;
        i41 = HEAP32[i41 + 4 >> 2] | 0;
        i37 = i5;
        i38 = HEAP32[i37 + 4 >> 2] | 0;
        HEAP32[i39 >> 2] = HEAP32[i37 >> 2];
        HEAP32[i39 + 4 >> 2] = i38;
        HEAP32[i5 >> 2] = i40;
        HEAP32[i5 + 4 >> 2] = i41;
        i5 = i2 << 1 | 1;
        if ((i5 | 0) >= (i4 | 0)) break; else i6 = i2;
       }
      } while (0);
      i2 = (HEAP32[i27 >> 2] | 0) + -1 | 0;
      i3 = HEAP32[i86 >> 2] | 0;
      i16 = HEAP32[i3 + (i2 << 3) >> 2] | 0;
      HEAP32[i27 >> 2] = i2;
      i17 = i47 + (i16 << 2) | 0;
      if ((HEAP32[i17 >> 2] | 0) == (i29 | 0)) {
       i14 = i45 + (i16 * 12 | 0) | 0;
       i15 = i45 + (i16 * 12 | 0) + 4 | 0;
       i13 = 0;
       do {
        i4 = HEAP32[((i13 | 0) == 0 ? i15 : i14) >> 2] | 0;
        do if (!(Math_fround(HEAPF32[i57 + (i4 << 4) + 12 >> 2]) == Math_fround(0.0))) {
         i1 = HEAP32[i56 >> 2] | 0;
         i5 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
         i41 = HEAP32[i1 + (i4 + 1 << 2) >> 2] | 0;
         i12 = i51 + (i41 << 2) | 0;
         if ((i5 | 0) == (i41 | 0)) break;
         i6 = i51 + (i5 << 2) | 0;
         do {
          i4 = HEAP32[i6 >> 2] | 0;
          L229 : do if (!((i4 | 0) == (i16 | 0) ? 1 : (HEAP32[i45 + (i4 * 12 | 0) + 8 >> 2] | 0) != (i18 | 0))) {
           HEAP32[i44 + (HEAP32[i47 + (i4 << 2) >> 2] << 2) >> 2] = i16;
           i40 = i46 + (i4 << 2) | 0;
           i41 = (HEAP32[i40 >> 2] | 0) + 1 | 0;
           HEAP32[i40 >> 2] = i41;
           HEAP32[i53 >> 2] = i4;
           HEAP32[i19 >> 2] = i41;
           if ((HEAP32[i48 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
            i40 = i53;
            i41 = HEAP32[i40 + 4 >> 2] | 0;
            i2 = i3 + (i2 << 3) | 0;
            HEAP32[i2 >> 2] = HEAP32[i40 >> 2];
            HEAP32[i2 + 4 >> 2] = i41;
            i2 = (HEAP32[i27 >> 2] | 0) + 1 | 0;
            HEAP32[i27 >> 2] = i2;
           } else {
            __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i86, i53) | 0;
            i2 = HEAP32[i27 >> 2] | 0;
           }
           i3 = HEAP32[i86 >> 2] | 0;
           if ((i2 | 0) <= 0) break;
           i4 = (i2 << 3 >> 3) + -1 | 0;
           if (!i4) break;
           do {
            i5 = i4;
            i4 = (i4 + -1 | 0) >>> 1;
            if ((HEAP32[i3 + (i4 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i3 + (i5 << 3) + 4 >> 2] | 0) >>> 0) break L229;
            i41 = i3 + (i5 << 3) | 0;
            i38 = i3 + (i4 << 3) | 0;
            i40 = i38;
            i39 = HEAP32[i40 >> 2] | 0;
            i40 = HEAP32[i40 + 4 >> 2] | 0;
            i36 = i41;
            i37 = HEAP32[i36 + 4 >> 2] | 0;
            HEAP32[i38 >> 2] = HEAP32[i36 >> 2];
            HEAP32[i38 + 4 >> 2] = i37;
            HEAP32[i41 >> 2] = i39;
            HEAP32[i41 + 4 >> 2] = i40;
           } while ((i4 | 0) != 0);
          } while (0);
          i6 = i6 + 4 | 0;
         } while ((i6 | 0) != (i12 | 0));
        } while (0);
        i13 = i13 + 1 | 0;
       } while ((i13 | 0) != 2);
       i6 = HEAP32[i21 >> 2] | 0;
       i4 = 0;
       while (1) {
        if (i4 >>> 0 < i6 >>> 0) {
         if ((HEAP32[(HEAP32[i20 >> 2] | 0) + (i4 << 3) >> 2] | 0) == (i18 | 0)) i74 = 166;
        } else i74 = 166;
        if ((i74 | 0) == 166) {
         i74 = 0;
         if ((HEAP32[i44 + (i4 << 2) >> 2] | 0) != (i16 | 0)) {
          i5 = i4;
          break;
         }
        }
        i4 = i4 + 1 | 0;
       }
       do if ((i5 | 0) == (i6 | 0)) {
        HEAP32[i55 >> 2] = i18;
        HEAP32[i22 >> 2] = i6;
        if ((HEAP32[i23 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
         i39 = i55;
         i40 = HEAP32[i39 + 4 >> 2] | 0;
         i41 = (HEAP32[i20 >> 2] | 0) + (i6 << 3) | 0;
         HEAP32[i41 >> 2] = HEAP32[i39 >> 2];
         HEAP32[i41 + 4 >> 2] = i40;
         HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
        } else __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i20, i55) | 0;
        HEAP32[i54 >> 2] = 0;
        i4 = HEAP32[i43 >> 2] | 0;
        if ((HEAP32[i28 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
         HEAP32[(HEAP32[i42 >> 2] | 0) + (i4 << 2) >> 2] = 0;
         HEAP32[i43 >> 2] = (HEAP32[i43 >> 2] | 0) + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i42, i54) | 0;
         break;
        }
       } while (0);
       HEAP32[i17 >> 2] = i5;
       i41 = (HEAP32[i24 >> 2] | 0) + (i5 << 2) | 0;
       HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 1;
      }
     } while ((i2 | 0) != 0);
     if (!i25) {
      i41 = i1;
      break;
     }
    }
   } else i41 = i5; while (0);
   i5 = HEAP32[i42 >> 2] | 0;
   i1 = HEAP32[i43 >> 2] | 0;
   i4 = i5 + (i1 << 2) | 0;
   do if (!i1) i1 = 0; else {
    if ((i1 | 0) == 1) {
     i1 = 1;
     break;
    }
    i1 = i5 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i5;
    do {
     i3 = i3 + 4 | 0;
     i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
     HEAP32[i3 >> 2] = i2;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i43 >> 2] | 0;
   } while (0);
   i2 = HEAP32[i5 + (i1 + -1 << 2) >> 2] | 0;
   HEAP32[i58 >> 2] = i2;
   if ((HEAP32[i28 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[i5 + (i1 << 2) >> 2] = i2;
    HEAP32[i43 >> 2] = (HEAP32[i43 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i42, i58) | 0;
   i36 = i83 + 40 | 0;
   i5 = HEAP32[i59 >> 2] | 0;
   HEAP32[i60 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i36, i5 << 1, i60);
   i40 = i83 + 28 | 0;
   HEAPF32[i62 >> 2] = Math_fround(0.0);
   __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i40, i5, i62);
   if (i5 | 0) {
    i1 = HEAP32[i42 >> 2] | 0;
    i2 = HEAP32[i36 >> 2] | 0;
    i3 = HEAP32[i40 >> 2] | 0;
    i4 = 0;
    do {
     i60 = HEAP32[i45 + (i4 * 12 | 0) >> 2] | 0;
     i59 = HEAP32[i45 + (i4 * 12 | 0) + 4 >> 2] | 0;
     i58 = i1 + (HEAP32[i47 + (i4 << 2) >> 2] << 2) | 0;
     i62 = (HEAP32[i58 >> 2] | 0) + -1 | 0;
     HEAP32[i58 >> 2] = i62;
     i58 = i62 << 1;
     HEAP32[i2 + (i58 << 2) >> 2] = i60;
     HEAP32[i2 + ((i58 | 1) << 2) >> 2] = i59;
     f96 = Math_fround(HEAPF32[i57 + (i59 << 4) >> 2]);
     f96 = Math_fround(f96 - Math_fround(HEAPF32[i57 + (i60 << 4) >> 2]));
     f97 = Math_fround(HEAPF32[i57 + (i59 << 4) + 4 >> 2]);
     f97 = Math_fround(f97 - Math_fround(HEAPF32[i57 + (i60 << 4) + 4 >> 2]));
     f98 = Math_fround(HEAPF32[i57 + (i59 << 4) + 8 >> 2]);
     f98 = Math_fround(f98 - Math_fround(HEAPF32[i57 + (i60 << 4) + 8 >> 2]));
     HEAPF32[i3 + (i62 << 2) >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f96 * f96) + Math_fround(f97 * f97)) + Math_fround(f98 * f98))));
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i5 >>> 0);
   }
   i34 = i83 + 44 | 0;
   i37 = HEAP32[i34 >> 2] | 0;
   HEAP32[i63 >> 2] = 0;
   HEAP32[i85 >> 2] = 0;
   i33 = i85 + 4 | 0;
   HEAP32[i33 >> 2] = 0;
   i39 = i85 + 8 | 0;
   HEAP32[i39 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i85, i37, i63);
   i37 = i83 + 32 | 0;
   i63 = HEAP32[i37 >> 2] | 0;
   HEAPF32[i64 >> 2] = Math_fround(0.0);
   HEAP32[i80 >> 2] = 0;
   i35 = i80 + 4 | 0;
   HEAP32[i35 >> 2] = 0;
   i38 = i80 + 8 | 0;
   HEAP32[i38 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i80, i63, i64);
   if ((HEAP32[i43 >> 2] | 0) != 1) {
    i29 = i71 + 4 | 0;
    i30 = i71 + 8 | 0;
    i31 = i72 + 4 | 0;
    i32 = 0;
    do {
     i3 = i32;
     i32 = i32 + 1 | 0;
     i1 = HEAP32[i42 >> 2] | 0;
     i1 = (HEAP32[i1 + (i32 << 2) >> 2] | 0) - (HEAP32[i1 + (i3 << 2) >> 2] | 0) | 0;
     HEAP32[i70 >> 2] = 0;
     HEAP32[i71 >> 2] = 0;
     HEAP32[i29 >> 2] = 0;
     HEAP32[i30 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i71, i1, i70);
     i1 = HEAP32[i29 >> 2] | 0;
     i28 = HEAP32[i71 >> 2] | 0;
     if (!i1) i1 = 0; else {
      i2 = 0;
      do {
       HEAP32[i28 + (i2 << 2) >> 2] = i2;
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     i26 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     i27 = i26 << 1;
     i25 = HEAP32[i36 >> 2] | 0;
     HEAP8[i31 >> 0] = 0;
     HEAP32[i72 >> 2] = i69;
     i1 = i1 + -1 | 0;
     do if ((i1 | 0) > 0) {
      i2 = 0;
      i6 = 0;
      i4 = 0;
      i3 = i1;
      i1 = i69;
      i24 = 32;
      L288 : while (1) {
       i17 = i6;
       while (1) {
        if ((i3 | 0) > (i4 | 0)) {
         if ((i3 - i4 | 0) >>> 0 >= 5) break;
         do {
          i16 = i4;
          i4 = i4 + 1 | 0;
          i15 = i4;
          i5 = i16;
          while (1) {
           i6 = HEAP32[i28 + (i15 << 2) >> 2] << 1;
           i12 = HEAP32[i28 + (i5 << 2) >> 2] << 1;
           i13 = HEAP32[i25 + (i6 + i27 << 2) >> 2] | 0;
           i14 = HEAP32[i25 + (i12 + i27 << 2) >> 2] | 0;
           if ((i13 | 0) == (i14 | 0)) i6 = (HEAP32[i25 + ((i6 | 1) + i27 << 2) >> 2] | 0) >>> 0 < (HEAP32[i25 + ((i12 | 1) + i27 << 2) >> 2] | 0) >>> 0; else i6 = i13 >>> 0 < i14 >>> 0;
           i5 = i6 ? i15 : i5;
           if ((i15 | 0) < (i3 | 0)) i15 = i15 + 1 | 0; else break;
          }
          if ((i5 | 0) != (i16 | 0)) {
           i62 = i28 + (i5 << 2) | 0;
           i64 = i28 + (i16 << 2) | 0;
           i63 = HEAP32[i62 >> 2] | 0;
           HEAP32[i62 >> 2] = HEAP32[i64 >> 2];
           HEAP32[i64 >> 2] = i63;
          }
         } while ((i4 | 0) != (i3 | 0));
        }
        if (!i17) break L288;
        i64 = i17 + -2 | 0;
        i3 = HEAP32[i1 + (i17 + -1 << 2) >> 2] | 0;
        i4 = HEAP32[i1 + (i64 << 2) >> 2] | 0;
        i17 = i64;
       }
       i20 = i28 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
       i5 = HEAP32[i20 >> 2] | 0;
       i18 = i28 + (i4 << 2) | 0;
       i15 = HEAP32[i18 >> 2] | 0;
       i6 = i5 << 1;
       i12 = i15 << 1;
       i13 = HEAP32[i25 + (i6 + i27 << 2) >> 2] | 0;
       i14 = HEAP32[i25 + (i12 + i27 << 2) >> 2] | 0;
       if ((i13 | 0) == (i14 | 0)) if ((HEAP32[i25 + ((i6 | 1) + i27 << 2) >> 2] | 0) >>> 0 < (HEAP32[i25 + ((i12 | 1) + i27 << 2) >> 2] | 0) >>> 0) i74 = 207; else i16 = i15; else if (i13 >>> 0 < i14 >>> 0) i74 = 207; else i16 = i15;
       if ((i74 | 0) == 207) {
        i74 = 0;
        HEAP32[i18 >> 2] = i5;
        HEAP32[i20 >> 2] = i15;
        i16 = HEAP32[i18 >> 2] | 0;
        i5 = i15;
       }
       i19 = i28 + (i3 << 2) | 0;
       i15 = HEAP32[i19 >> 2] | 0;
       i6 = i15 << 1;
       i12 = i16 << 1;
       i13 = HEAP32[i25 + (i6 + i27 << 2) >> 2] | 0;
       i14 = HEAP32[i25 + (i12 + i27 << 2) >> 2] | 0;
       if ((i13 | 0) == (i14 | 0)) {
        if ((HEAP32[i25 + ((i6 | 1) + i27 << 2) >> 2] | 0) >>> 0 < (HEAP32[i25 + ((i12 | 1) + i27 << 2) >> 2] | 0) >>> 0) i74 = 211;
       } else if (i13 >>> 0 < i14 >>> 0) i74 = 211;
       if ((i74 | 0) == 211) {
        i74 = 0;
        HEAP32[i18 >> 2] = i15;
        HEAP32[i19 >> 2] = i16;
        i15 = i16;
        i5 = HEAP32[i20 >> 2] | 0;
       }
       i6 = i15 << 1;
       i12 = i5 << 1;
       i13 = HEAP32[i25 + (i6 + i27 << 2) >> 2] | 0;
       i14 = HEAP32[i25 + (i12 + i27 << 2) >> 2] | 0;
       if ((i13 | 0) == (i14 | 0)) {
        if ((HEAP32[i25 + ((i6 | 1) + i27 << 2) >> 2] | 0) >>> 0 < (HEAP32[i25 + ((i12 | 1) + i27 << 2) >> 2] | 0) >>> 0) i74 = 215;
       } else if (i13 >>> 0 < i14 >>> 0) i74 = 215;
       if ((i74 | 0) == 215) {
        i74 = 0;
        HEAP32[i20 >> 2] = i15;
        HEAP32[i19 >> 2] = i5;
        i5 = HEAP32[i20 >> 2] | 0;
       }
       i14 = i3 + -1 | 0;
       i23 = i28 + (i14 << 2) | 0;
       HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i23 >> 2] = i5;
       i6 = i4;
       while (1) {
        i21 = i5 << 1;
        i20 = HEAP32[i25 + (i21 + i27 << 2) >> 2] | 0;
        i21 = i25 + ((i21 | 1) + i27 << 2) | 0;
        i18 = i6;
        while (1) {
         i6 = i18 + 1 | 0;
         i13 = i28 + (i6 << 2) | 0;
         i12 = HEAP32[i13 >> 2] | 0;
         i15 = i12 << 1;
         i16 = HEAP32[i25 + (i15 + i27 << 2) >> 2] | 0;
         if ((i16 | 0) == (i20 | 0)) if ((HEAP32[i25 + ((i15 | 1) + i27 << 2) >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
          i18 = i6;
          continue;
         } else {
          i22 = i18;
          break;
         } else if (i16 >>> 0 < i20 >>> 0) {
          i18 = i6;
          continue;
         } else {
          i22 = i18;
          break;
         }
        }
        while (1) {
         i16 = i14 + -1 | 0;
         i15 = i28 + (i16 << 2) | 0;
         i14 = HEAP32[i15 >> 2] | 0;
         i18 = i14 << 1;
         i19 = HEAP32[i25 + (i18 + i27 << 2) >> 2] | 0;
         if ((i20 | 0) == (i19 | 0)) if ((HEAP32[i21 >> 2] | 0) >>> 0 < (HEAP32[i25 + ((i18 | 1) + i27 << 2) >> 2] | 0) >>> 0) {
          i14 = i16;
          continue;
         } else break; else if (i20 >>> 0 < i19 >>> 0) {
          i14 = i16;
          continue;
         } else break;
        }
        if ((i6 | 0) >= (i16 | 0)) {
         i14 = i22;
         break;
        }
        HEAP32[i13 >> 2] = i14;
        HEAP32[i15 >> 2] = i12;
        i5 = HEAP32[i23 >> 2] | 0;
        i14 = i16;
       }
       HEAP32[i13 >> 2] = i5;
       HEAP32[i23 >> 2] = i12;
       if ((i6 - i4 | 0) < (i3 - i6 | 0)) {
        if (i17 >>> 0 < (i24 + -1 | 0) >>> 0) i5 = i24; else {
         i5 = i24 << 3;
         if (!i5) i5 = 0; else {
          i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
          i62 = HEAP32[(HEAP32[i63 >> 2] | 0) + 8 >> 2] | 0;
          i64 = _PxGetFoundation() | 0;
          i64 = mftCall_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 24 >> 2] | 0, i64 | 0) | 0;
          i5 = mftCall_iiiiii(i62 | 0, i63 | 0, i5 | 0, (i64 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
         }
         _memcpy(i5 | 0, i1 | 0, i17 << 2 | 0) | 0;
         if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
          i64 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
          mftCall_vii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i1 | 0);
         }
         i1 = i5;
         i2 = 1;
         i5 = i24 << 1;
        }
        HEAP32[i1 + (i17 << 2) >> 2] = i4;
        HEAP32[i1 + (i17 + 1 << 2) >> 2] = i14;
        i4 = i14 + 2 | 0;
       } else {
        i6 = i14 + 2 | 0;
        if (i17 >>> 0 < (i24 + -1 | 0) >>> 0) i5 = i24; else {
         i5 = i24 << 3;
         if (!i5) i5 = 0; else {
          i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
          i62 = HEAP32[(HEAP32[i63 >> 2] | 0) + 8 >> 2] | 0;
          i64 = _PxGetFoundation() | 0;
          i64 = mftCall_ii(HEAP32[(HEAP32[i64 >> 2] | 0) + 24 >> 2] | 0, i64 | 0) | 0;
          i5 = mftCall_iiiiii(i62 | 0, i63 | 0, i5 | 0, (i64 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
         }
         _memcpy(i5 | 0, i1 | 0, i17 << 2 | 0) | 0;
         if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
          i64 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
          mftCall_vii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i1 | 0);
         }
         i1 = i5;
         i2 = 1;
         i5 = i24 << 1;
        }
        HEAP32[i1 + (i17 << 2) >> 2] = i6;
        HEAP32[i1 + (i17 + 1 << 2) >> 2] = i3;
        i3 = i14;
       }
       i6 = i17 + 2 | 0;
       i24 = i5;
      }
      if (i2 << 24 >> 24 == 0 | (i1 | 0) == 0) break;
      i64 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i1 | 0);
     } while (0);
     if (HEAP8[i31 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i72, HEAP32[i72 >> 2] | 0);
     i1 = HEAP32[i29 >> 2] | 0;
     if (i1 | 0) {
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = HEAP32[i85 >> 2] | 0;
      i4 = HEAP32[i40 >> 2] | 0;
      i5 = HEAP32[i80 >> 2] | 0;
      i6 = 0;
      do {
       i64 = i28 + (i6 << 2) | 0;
       i63 = (i6 << 1) + i27 | 0;
       HEAP32[i3 + (i63 << 2) >> 2] = HEAP32[i2 + ((HEAP32[i64 >> 2] << 1) + i27 << 2) >> 2];
       HEAP32[i3 + ((i63 | 1) << 2) >> 2] = HEAP32[i2 + (((HEAP32[i64 >> 2] << 1) + i27 | 1) << 2) >> 2];
       HEAP32[i5 + (i6 + i26 << 2) >> 2] = HEAP32[i4 + ((HEAP32[i64 >> 2] | 0) + i26 << 2) >> 2];
       i6 = i6 + 1 | 0;
      } while (i6 >>> 0 < i1 >>> 0);
     }
     i64 = HEAP32[i30 >> 2] | 0;
     if (!((i64 & 2147483647 | 0) == 0 | (i64 | 0) < 0 | (i28 | 0) == 0)) {
      i64 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i28 | 0);
     }
    } while (i32 >>> 0 < ((HEAP32[i43 >> 2] | 0) + -1 | 0) >>> 0);
   }
   if ((i85 | 0) != (i36 | 0)) {
    HEAP32[i34 >> 2] = 0;
    i1 = HEAP32[i33 >> 2] | 0;
    if ((HEAP32[i83 + 48 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i36, i1);
     i1 = HEAP32[i33 >> 2] | 0;
    }
    i2 = HEAP32[i36 >> 2] | 0;
    i3 = i2 + (i1 << 2) | 0;
    if ((i1 | 0) > 0) {
     i1 = i2;
     i2 = HEAP32[i85 >> 2] | 0;
     while (1) {
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      i1 = i1 + 4 | 0;
      if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
     }
     i1 = HEAP32[i33 >> 2] | 0;
    }
    HEAP32[i34 >> 2] = i1;
   }
   if ((i80 | 0) != (i40 | 0)) {
    HEAP32[i37 >> 2] = 0;
    i1 = HEAP32[i35 >> 2] | 0;
    if ((HEAP32[i83 + 36 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
     __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj(i40, i1);
     i1 = HEAP32[i35 >> 2] | 0;
    }
    i2 = HEAP32[i40 >> 2] | 0;
    i4 = i2 + (i1 << 2) | 0;
    if ((i1 | 0) > 0) {
     i3 = HEAP32[i80 >> 2] | 0;
     while (1) {
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i2 = i2 + 4 | 0;
      if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
     }
    }
    HEAP32[i37 >> 2] = i1;
   }
   do if (i84) {
    __ZN5physx27PxClothGeodesicTetherCookerC2ERKNS_15PxClothMeshDescE(i81, i79);
    if (!(__ZNK5physx27PxClothGeodesicTetherCooker15getCookerStatusEv(i81) | 0)) {
     i79 = __ZNK5physx27PxClothGeodesicTetherCooker23getNbTethersPerParticleEv(i81) | 0;
     i79 = Math_imul(HEAP32[i83 >> 2] | 0, i79) | 0;
     i82 = i83 + 52 | 0;
     HEAP32[i75 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i82, i79, i75);
     i84 = i83 + 64 | 0;
     HEAPF32[i76 >> 2] = Math_fround(0.0);
     __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i84, i79, i76);
     __ZNK5physx27PxClothGeodesicTetherCooker13getTetherDataEPjPf(i81, HEAP32[i82 >> 2] | 0, HEAP32[i84 >> 2] | 0);
     __ZN5physx27PxClothGeodesicTetherCookerD2Ev(i81);
     break;
    } else {
     __ZN5physx27PxClothGeodesicTetherCookerD2Ev(i81);
     i74 = 274;
     break;
    }
   } else i74 = 274; while (0);
   if ((i74 | 0) == 274) {
    __ZN5physx25PxClothSimpleTetherCookerC2ERKNS_15PxClothMeshDescE(i82, i79);
    if (!(__ZNK5physx25PxClothSimpleTetherCooker15getCookerStatusEv(i82) | 0)) {
     i81 = i83 + 52 | 0;
     i84 = HEAP32[i83 >> 2] | 0;
     HEAP32[i77 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i81, i84, i77);
     i84 = i83 + 64 | 0;
     i83 = HEAP32[i83 >> 2] | 0;
     HEAPF32[i78 >> 2] = Math_fround(0.0);
     __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i84, i83, i78);
     __ZNK5physx25PxClothSimpleTetherCooker13getTetherDataEPjPf(i82, HEAP32[i81 >> 2] | 0, HEAP32[i84 >> 2] | 0);
    }
    __ZN5physx25PxClothSimpleTetherCookerD2Ev(i82);
   }
   i84 = HEAP32[i38 >> 2] | 0;
   do if ((i84 | 0) > -1 & (i84 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i80 >> 2] | 0;
    if (!i1) break;
    i84 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i84 >> 2] | 0) + 12 >> 2] | 0, i84 | 0, i1 | 0);
   } while (0);
   i84 = HEAP32[i39 >> 2] | 0;
   do if ((i84 | 0) > -1 & (i84 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i85 >> 2] | 0;
    if (!i1) break;
    i85 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i85 >> 2] | 0) + 12 >> 2] | 0, i85 | 0, i1 | 0);
   } while (0);
   i85 = HEAP32[i48 >> 2] | 0;
   do if ((i85 | 0) > -1 & (i85 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i86 >> 2] | 0;
    if (!i1) break;
    i86 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i86 >> 2] | 0) + 12 >> 2] | 0, i86 | 0, i1 | 0);
   } while (0);
   i86 = HEAP32[i49 >> 2] | 0;
   if (!((i86 & 2147483647 | 0) == 0 | (i86 | 0) < 0 | (i46 | 0) == 0)) {
    i86 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i86 >> 2] | 0) + 12 >> 2] | 0, i86 | 0, i46 | 0);
   }
   i86 = HEAP32[i50 >> 2] | 0;
   if (!((i86 & 2147483647 | 0) == 0 | (i86 | 0) < 0 | (i47 | 0) == 0)) {
    i86 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i86 >> 2] | 0) + 12 >> 2] | 0, i86 | 0, i47 | 0);
   }
   i86 = HEAP32[i61 >> 2] | 0;
   if (!((i86 & 2147483647 | 0) == 0 | (i86 | 0) < 0 | (i45 | 0) == 0)) {
    i86 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i86 >> 2] | 0) + 12 >> 2] | 0, i86 | 0, i45 | 0);
   }
   i1 = HEAP32[i87 >> 2] | 0;
   if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i87, i1);
   i87 = HEAP32[i65 >> 2] | 0;
   do if ((i87 | 0) > -1 & (i87 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i88 >> 2] | 0;
    if (!i1) break;
    i88 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i1 | 0);
   } while (0);
   i88 = HEAP32[i66 >> 2] | 0;
   if (!((i88 & 2147483647 | 0) == 0 | (i88 | 0) < 0 | (i44 | 0) == 0)) {
    i88 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i44 | 0);
   }
   i88 = HEAP32[i67 >> 2] | 0;
   if (!((i88 & 2147483647 | 0) == 0 | (i88 | 0) < 0 | (i51 | 0) == 0)) {
    i88 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i51 | 0);
   }
   i88 = HEAP32[i68 >> 2] | 0;
   if (!((i88 & 2147483647 | 0) == 0 | (i88 | 0) < 0 | (i41 | 0) == 0)) {
    i88 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i41 | 0);
   }
   i88 = HEAP32[i73 >> 2] | 0;
   if ((i88 & 2147483647 | 0) == 0 | (i88 | 0) < 0 | (i57 | 0) == 0) {
    i88 = 1;
    STACKTOP = i89;
    return i88 | 0;
   }
   i88 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i57 | 0);
   i88 = 1;
   STACKTOP = i89;
   return i88 | 0;
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 738367 | 0, 267, gb + 738459 | 0, i3);
 i88 = 0;
 STACKTOP = i89;
 return i88 | 0;
}

function _UNITY_png_do_read_transformations(i25, i27) {
 i25 = i25 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i28;
 i26 = i25 + 380 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) _UNITY_png_error(i25, gb + 353528 | 0);
 i23 = i25 + 208 | 0;
 if ((HEAP32[i23 >> 2] & 16448 | 0) == 16384) _UNITY_png_error(i25, gb + 353544 | 0);
 i24 = i25 + 212 | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 do if (i2 & 4096 | 0) {
  i13 = i27 + 8 | 0;
  if ((HEAP8[i13 >> 0] | 0) != 3) {
   i1 = i1 + 1 | 0;
   if ((i2 & 33554432 | 0) == 0 | (HEAP16[i25 + 424 >> 1] | 0) == 0) {
    _UNITY_png_do_expand(i27, i1, 0);
    break;
   } else {
    _UNITY_png_do_expand(i27, i1, i25 + 528 | 0);
    break;
   }
  }
  i7 = i1 + 1 | 0;
  i10 = HEAP32[i25 + 412 >> 2] | 0;
  i8 = HEAP32[i25 + 524 >> 2] | 0;
  i6 = HEAP16[i25 + 424 >> 1] | 0;
  i9 = i6 & 65535;
  i11 = HEAP32[i27 >> 2] | 0;
  i21 = HEAP16[i13 >> 1] | 0;
  i1 = (i21 & 65535) >>> 8 & 255;
  if ((i21 & 255) << 24 >> 24 == 3) {
   i12 = i27 + 9 | 0;
   if ((i1 & 255) < 8) {
    switch (i1 << 24 >> 24) {
    case 1:
     {
      if (i11 | 0) {
       i1 = 0;
       i2 = i7 + i11 | 0;
       i3 = i7 + ((i11 + -1 | 0) >>> 3) | 0;
       i4 = i11 + 7 & 7 ^ 7;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP8[i2 >> 0] = (HEAPU8[i3 >> 0] & 1 << i4 | 0) != 0 & 1;
        i5 = (i4 | 0) == 7;
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i11 | 0)) break; else {
         i3 = i5 ? i3 + -1 | 0 : i3;
         i4 = i5 ? 0 : i4 + 1 | 0;
        }
       }
      }
      break;
     }
    case 2:
     {
      if (i11 | 0) {
       i1 = 0;
       i2 = i7 + i11 | 0;
       i3 = i7 + ((i11 + -1 | 0) >>> 2) | 0;
       i4 = (i11 << 1) + 6 & 6 ^ 6;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP8[i2 >> 0] = (HEAPU8[i3 >> 0] | 0) >>> i4 & 3;
        i5 = (i4 | 0) == 6;
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i11 | 0)) break; else {
         i3 = i5 ? i3 + -1 | 0 : i3;
         i4 = i5 ? 0 : i4 + 2 | 0;
        }
       }
      }
      break;
     }
    case 4:
     {
      if (i11 | 0) {
       i1 = 0;
       i2 = i7 + i11 | 0;
       i3 = i7 + ((i11 + -1 | 0) >>> 1) | 0;
       i4 = i11 << 2 & 4;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP8[i2 >> 0] = (HEAPU8[i3 >> 0] | 0) >>> i4 & 15;
        i5 = (i4 | 0) == 4;
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i11 | 0)) break; else {
         i3 = i5 ? i3 + -1 | 0 : i3;
         i4 = i5 ? 0 : i4 + 4 | 0;
        }
       }
      }
      break;
     }
    default:
     {}
    }
    HEAP8[i12 >> 0] = 8;
    HEAP8[i27 + 11 >> 0] = 8;
    HEAP32[i27 + 4 >> 2] = i11;
   } else if (i1 << 24 >> 24 != 8) break;
   i2 = i7 + i11 + -1 | 0;
   if (!(i6 << 16 >> 16)) {
    i4 = i11 * 3 | 0;
    if (i11 | 0) {
     i3 = 0;
     i1 = i7 + i4 | 0;
     while (1) {
      HEAP8[i1 + -1 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) + 2 >> 0] | 0;
      HEAP8[i1 + -2 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) + 1 >> 0] | 0;
      i1 = i1 + -3 | 0;
      HEAP8[i1 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) >> 0] | 0;
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i11 | 0)) break; else i2 = i2 + -1 | 0;
     }
    }
    HEAP8[i12 >> 0] = 8;
    HEAP8[i27 + 11 >> 0] = 24;
    HEAP32[i27 + 4 >> 2] = i4;
    HEAP8[i13 >> 0] = 2;
    HEAP8[i27 + 10 >> 0] = 3;
    break;
   }
   i5 = i11 << 2;
   if (i11 | 0) {
    i4 = 0;
    i3 = i7 + i5 | 0;
    while (1) {
     i1 = HEAPU8[i2 >> 0] | 0;
     if (i1 >>> 0 < i9 >>> 0) i1 = HEAP8[i8 + i1 >> 0] | 0; else i1 = -1;
     HEAP8[i3 + -1 >> 0] = i1;
     HEAP8[i3 + -2 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) + 2 >> 0] | 0;
     HEAP8[i3 + -3 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) + 1 >> 0] | 0;
     i3 = i3 + -4 | 0;
     HEAP8[i3 >> 0] = HEAP8[i10 + ((HEAPU8[i2 >> 0] | 0) * 3 | 0) >> 0] | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i11 | 0)) break; else i2 = i2 + -1 | 0;
    }
   }
   HEAP8[i12 >> 0] = 8;
   HEAP8[i27 + 11 >> 0] = 32;
   HEAP32[i27 + 4 >> 2] = i5;
   HEAP8[i13 >> 0] = 6;
   HEAP8[i27 + 10 >> 0] = 4;
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 L51 : do if ((i1 & 262272 | 0) == 262144) {
  switch (HEAP8[i27 + 8 >> 0] | 0) {
  case 4:
  case 6:
   break;
  default:
   break L51;
  }
  _UNITY_png_do_strip_channel(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0, 0);
  i1 = HEAP32[i24 >> 2] | 0;
 } while (0);
 if (i1 & 16384) if (!(HEAP32[i25 + 204 >> 2] & 2048)) {
  _UNITY_png_do_gray_to_rgb(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
 }
 L59 : do if (i1 & 128 | 0) {
  i2 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i12 = HEAP32[i25 + 488 >> 2] | 0;
  i9 = HEAP32[i25 + 496 >> 2] | 0;
  i10 = HEAP32[i25 + 500 >> 2] | 0;
  i18 = HEAP32[i25 + 492 >> 2] | 0;
  i15 = HEAP32[i25 + 504 >> 2] | 0;
  i16 = HEAP32[i25 + 508 >> 2] | 0;
  i19 = HEAP32[i25 + 480 >> 2] | 0;
  i17 = (HEAP32[i23 >> 2] & 8192 | 0) != 0;
  i21 = HEAP32[i27 >> 2] | 0;
  i14 = HEAP16[i27 + 8 >> 1] | 0;
  i1 = (i14 & 65535) >>> 8 & 255;
  switch ((i14 & 255) << 24 >> 24) {
  case 0:
   {
    switch (i1 << 24 >> 24) {
    case 1:
     {
      if (!i21) break L59;
      i5 = i25 + 456 | 0;
      i6 = HEAPU16[i25 + 536 >> 1] | 0;
      i3 = 0;
      i4 = 7;
      while (1) {
       i1 = HEAPU8[i2 >> 0] | 0;
       if ((i1 >>> i4 & 1 | 0) == (i6 | 0)) HEAP8[i2 >> 0] = HEAPU16[i5 >> 1] << i4 | i1 & 32639 >>> (7 - i4 | 0);
       i1 = (i4 | 0) == 0;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i21 | 0)) break; else {
        i4 = i1 ? 7 : i4 + -1 | 0;
        i2 = i1 ? i2 + 1 | 0 : i2;
       }
      }
      break;
     }
    case 2:
     {
      i1 = (i21 | 0) != 0;
      if (!i12) {
       if (!i1) break L59;
       i5 = i25 + 456 | 0;
       i6 = HEAPU16[i25 + 536 >> 1] | 0;
       i3 = 0;
       i4 = 6;
       while (1) {
        i1 = HEAPU8[i2 >> 0] | 0;
        if ((i1 >>> i4 & 3 | 0) == (i6 | 0)) HEAP8[i2 >> 0] = HEAPU16[i5 >> 1] << i4 | i1 & 16191 >>> (6 - i4 | 0);
        i1 = (i4 | 0) == 0;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i21 | 0)) break L59; else {
         i4 = i1 ? 6 : i4 + -2 | 0;
         i2 = i1 ? i2 + 1 | 0 : i2;
        }
       }
      }
      if (!i1) break L59;
      i6 = i25 + 456 | 0;
      i7 = HEAPU16[i25 + 536 >> 1] | 0;
      i4 = 0;
      i5 = 6;
      while (1) {
       i1 = HEAPU8[i2 >> 0] | 0;
       i3 = i1 >>> i5 & 3;
       if ((i3 | 0) == (i7 | 0)) i1 = HEAPU16[i6 >> 1] << i5 & 255 | i1 & 16191 >>> (6 - i5 | 0); else i1 = (HEAPU8[i12 + (i3 << 2 | i3 | i3 << 4 | i3 << 6) >> 0] | 0) >>> 6 << i5 | i1 & 16191 >>> (6 - i5 | 0);
       HEAP8[i2 >> 0] = i1;
       i1 = (i5 | 0) == 0;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i21 | 0)) break; else {
        i5 = i1 ? 6 : i5 + -2 | 0;
        i2 = i1 ? i2 + 1 | 0 : i2;
       }
      }
      break;
     }
    case 4:
     {
      i1 = (i21 | 0) != 0;
      if (!i12) {
       if (!i1) break L59;
       i5 = i25 + 456 | 0;
       i6 = HEAPU16[i25 + 536 >> 1] | 0;
       i3 = 0;
       i4 = 4;
       while (1) {
        i1 = HEAPU8[i2 >> 0] | 0;
        if ((i1 >>> i4 & 15 | 0) == (i6 | 0)) HEAP8[i2 >> 0] = HEAPU16[i5 >> 1] << i4 | i1 & 3855 >>> (4 - i4 | 0);
        i1 = (i4 | 0) == 0;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i21 | 0)) break L59; else {
         i4 = i1 ? 4 : i4 + -4 | 0;
         i2 = i1 ? i2 + 1 | 0 : i2;
        }
       }
      }
      if (!i1) break L59;
      i6 = i25 + 456 | 0;
      i7 = HEAPU16[i25 + 536 >> 1] | 0;
      i4 = 0;
      i5 = 4;
      while (1) {
       i1 = HEAPU8[i2 >> 0] | 0;
       i3 = i1 >>> i5 & 15;
       if ((i3 | 0) == (i7 | 0)) i1 = HEAPU16[i6 >> 1] << i5 & 255 | i1 & 3855 >>> (4 - i5 | 0); else i1 = (HEAPU8[i12 + (i3 << 4 | i3) >> 0] | 0) >>> 4 << i5 | i1 & 3855 >>> (4 - i5 | 0);
       HEAP8[i2 >> 0] = i1;
       i1 = (i5 | 0) == 0;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i21 | 0)) break; else {
        i5 = i1 ? 4 : i5 + -4 | 0;
        i2 = i1 ? i2 + 1 | 0 : i2;
       }
      }
      break;
     }
    case 8:
     {
      i1 = (i21 | 0) != 0;
      if (!i12) {
       if (!i1) break L59;
       i3 = i25 + 456 | 0;
       i4 = HEAPU16[i25 + 536 >> 1] | 0;
       i1 = i2;
       i2 = 0;
       while (1) {
        if ((HEAPU8[i1 >> 0] | 0) == (i4 | 0)) HEAP8[i1 >> 0] = HEAP16[i3 >> 1];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i21 | 0)) break L59; else i1 = i1 + 1 | 0;
       }
      }
      if (!i1) break L59;
      i4 = i25 + 456 | 0;
      i5 = HEAPU16[i25 + 536 >> 1] | 0;
      i3 = 0;
      while (1) {
       i1 = HEAPU8[i2 >> 0] | 0;
       if ((i1 | 0) == (i5 | 0)) i1 = HEAP16[i4 >> 1] & 255; else i1 = HEAP8[i12 + i1 >> 0] | 0;
       HEAP8[i2 >> 0] = i1;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i21 | 0)) break; else i2 = i2 + 1 | 0;
      }
      break;
     }
    case 16:
     {
      i1 = (i21 | 0) != 0;
      if (!i18) {
       if (!i1) break L59;
       i4 = i25 + 456 | 0;
       i5 = HEAPU16[i25 + 536 >> 1] | 0;
       i1 = i2;
       i2 = 0;
       while (1) {
        i3 = i1 + 1 | 0;
        if ((HEAPU8[i1 >> 0] << 8 | HEAPU8[i3 >> 0] | 0) == (i5 | 0)) {
         i20 = HEAP16[i4 >> 1] | 0;
         HEAP8[i1 >> 0] = (i20 & 65535) >>> 8;
         HEAP8[i3 >> 0] = i20;
        }
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i21 | 0)) break; else i1 = i1 + 2 | 0;
       }
      } else {
       if (!i1) break L59;
       i6 = i25 + 456 | 0;
       i7 = HEAPU16[i25 + 536 >> 1] | 0;
       i4 = 0;
       while (1) {
        i1 = HEAPU8[i2 >> 0] | 0;
        i5 = i2 + 1 | 0;
        i3 = HEAPU8[i5 >> 0] | 0;
        if ((i1 << 8 | i3 | 0) == (i7 | 0)) i1 = i6; else i1 = (HEAP32[i18 + (i3 >>> i19 << 2) >> 2] | 0) + (i1 << 1) | 0;
        i20 = HEAP16[i1 >> 1] | 0;
        HEAP8[i2 >> 0] = (i20 & 65535) >>> 8;
        HEAP8[i5 >> 0] = i20;
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (i21 | 0)) break; else i2 = i2 + 2 | 0;
       }
      }
      break;
     }
    default:
     break L59;
    }
    break;
   }
  case 2:
   {
    if (i1 << 24 >> 24 != 8) {
     i1 = (i21 | 0) != 0;
     if (!i18) {
      if (!i1) break L59;
      i8 = i25 + 532 | 0;
      i9 = i25 + 450 | 0;
      i10 = i25 + 452 | 0;
      i11 = HEAPU16[i25 + 530 >> 1] | 0;
      i7 = 0;
      while (1) {
       i1 = i2 + 1 | 0;
       i3 = i2 + 2 | 0;
       i4 = i2 + 3 | 0;
       i5 = i2 + 4 | 0;
       i6 = i2 + 5 | 0;
       if ((HEAPU8[i2 >> 0] << 8 | HEAPU8[i1 >> 0] | 0) == (i11 | 0)) {
        i20 = HEAP32[i8 >> 2] | 0;
        if ((HEAPU8[i3 >> 0] << 8 | HEAPU8[i4 >> 0] | 0) == (i20 & 65535 | 0) ? (HEAPU8[i5 >> 0] << 8 | HEAPU8[i6 >> 0] | 0) == (i20 >>> 16 | 0) : 0) {
         i20 = HEAP16[i9 >> 1] | 0;
         HEAP8[i2 >> 0] = (i20 & 65535) >>> 8;
         HEAP8[i1 >> 0] = i20;
         i20 = HEAP32[i10 >> 2] | 0;
         HEAP8[i3 >> 0] = (i20 & 65535) >>> 8;
         HEAP8[i4 >> 0] = i20;
         HEAP8[i5 >> 0] = i20 >>> 24;
         HEAP8[i6 >> 0] = i20 >>> 16;
        }
       }
       i7 = i7 + 1 | 0;
       if ((i7 | 0) == (i21 | 0)) break L59; else i2 = i2 + 6 | 0;
      }
     }
     if (!i1) break L59;
     i14 = i25 + 532 | 0;
     i15 = i25 + 450 | 0;
     i16 = i25 + 452 | 0;
     i17 = HEAPU16[i25 + 530 >> 1] | 0;
     i13 = 0;
     while (1) {
      i4 = HEAPU8[i2 >> 0] | 0;
      i5 = i2 + 1 | 0;
      i6 = HEAPU8[i5 >> 0] | 0;
      i7 = i2 + 2 | 0;
      i8 = i2 + 3 | 0;
      i9 = i2 + 4 | 0;
      i10 = HEAPU8[i9 >> 0] | 0;
      i12 = i2 + 5 | 0;
      i11 = HEAPU8[i12 >> 0] | 0;
      i1 = HEAP8[i7 >> 0] | 0;
      if ((i4 << 8 | i6 | 0) == (i17 | 0)) {
       i1 = i1 & 255;
       i3 = HEAP8[i8 >> 0] | 0;
       i29 = HEAP32[i14 >> 2] | 0;
       if ((i10 << 8 | i11 | 0) == (i29 >>> 16 | 0) ? (i3 & 255 | i1 << 8 | 0) == (i29 & 65535 | 0) : 0) {
        i1 = HEAP16[i15 >> 1] | 0;
        HEAP8[i2 >> 0] = (i1 & 65535) >>> 8;
        HEAP8[i5 >> 0] = i1;
        i1 = HEAP32[i16 >> 2] | 0;
        HEAP8[i7 >> 0] = (i1 & 65535) >>> 8;
        HEAP8[i8 >> 0] = i1;
        HEAP8[i9 >> 0] = i1 >>> 24;
        i1 = i1 >>> 16 & 255;
       } else i20 = 122;
      } else {
       i1 = i1 & 255;
       i3 = HEAP8[i8 >> 0] | 0;
       i20 = 122;
      }
      if ((i20 | 0) == 122) {
       i20 = 0;
       i29 = HEAP16[(HEAP32[i18 + (i6 >>> i19 << 2) >> 2] | 0) + (i4 << 1) >> 1] | 0;
       HEAP8[i2 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i5 >> 0] = i29;
       i1 = HEAP16[(HEAP32[i18 + ((i3 & 255) >>> i19 << 2) >> 2] | 0) + (i1 << 1) >> 1] | 0;
       HEAP8[i7 >> 0] = (i1 & 65535) >>> 8;
       HEAP8[i8 >> 0] = i1;
       i1 = HEAP16[(HEAP32[i18 + (i11 >>> i19 << 2) >> 2] | 0) + (i10 << 1) >> 1] | 0;
       HEAP8[i9 >> 0] = (i1 & 65535) >>> 8;
       i1 = i1 & 255;
      }
      HEAP8[i12 >> 0] = i1;
      i13 = i13 + 1 | 0;
      if ((i13 | 0) == (i21 | 0)) break L59; else i2 = i2 + 6 | 0;
     }
    }
    i1 = (i21 | 0) != 0;
    if (!i12) {
     if (!i1) break L59;
     i6 = i25 + 532 | 0;
     i7 = i25 + 450 | 0;
     i8 = i25 + 452 | 0;
     i9 = HEAPU16[i25 + 530 >> 1] | 0;
     i5 = 0;
     while (1) {
      if ((HEAPU8[i2 >> 0] | 0) == (i9 | 0)) {
       i1 = i2 + 1 | 0;
       i3 = HEAP32[i6 >> 2] | 0;
       if ((HEAPU8[i1 >> 0] | 0) == (i3 & 65535 | 0)) {
        i4 = i2 + 2 | 0;
        if ((HEAPU8[i4 >> 0] | 0) == (i3 >>> 16 | 0)) {
         HEAP8[i2 >> 0] = HEAP16[i7 >> 1];
         i29 = HEAP32[i8 >> 2] | 0;
         HEAP8[i1 >> 0] = i29;
         HEAP8[i4 >> 0] = i29 >>> 16;
        }
       }
      }
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i21 | 0)) break L59; else i2 = i2 + 3 | 0;
     }
    }
    if (!i1) break L59;
    i8 = i25 + 532 | 0;
    i9 = i25 + 450 | 0;
    i10 = i25 + 452 | 0;
    i11 = HEAPU16[i25 + 530 >> 1] | 0;
    i1 = 0;
    while (1) {
     i3 = HEAPU8[i2 >> 0] | 0;
     i4 = i2 + 1 | 0;
     i5 = HEAPU8[i4 >> 0] | 0;
     if ((i3 | 0) == (i11 | 0)) {
      i6 = HEAP32[i8 >> 2] | 0;
      if ((i5 | 0) == (i6 & 65535 | 0)) {
       i7 = i2 + 2 | 0;
       if ((HEAPU8[i7 >> 0] | 0) == (i6 >>> 16 | 0)) {
        HEAP8[i2 >> 0] = HEAP16[i9 >> 1];
        i29 = HEAP32[i10 >> 2] | 0;
        HEAP8[i4 >> 0] = i29;
        HEAP8[i7 >> 0] = i29 >>> 16;
       } else i20 = 106;
      } else i20 = 106;
     } else i20 = 106;
     if ((i20 | 0) == 106) {
      i20 = 0;
      HEAP8[i2 >> 0] = HEAP8[i12 + i3 >> 0] | 0;
      HEAP8[i4 >> 0] = HEAP8[i12 + i5 >> 0] | 0;
      i29 = i2 + 2 | 0;
      HEAP8[i29 >> 0] = HEAP8[i12 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i21 | 0)) break; else i2 = i2 + 3 | 0;
    }
    break;
   }
  case 4:
   if (i1 << 24 >> 24 == 8) {
    i1 = (i21 | 0) != 0;
    if (!((i12 | 0) != 0 & ((i9 | 0) != 0 & (i10 | 0) != 0))) {
     if (!i1) break L59;
     i4 = i25 + 456 | 0;
     i3 = 0;
     i1 = i2;
     while (1) {
      i2 = HEAP8[i1 + 1 >> 0] | 0;
      switch (i2 << 24 >> 24) {
      case 0:
       {
        HEAP8[i1 >> 0] = HEAP16[i4 >> 1];
        break;
       }
      case -1:
       break;
      default:
       {
        i29 = i2 & 255;
        i29 = (Math_imul(HEAPU8[i1 >> 0] | 0, i29) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i29 ^ 255) | 0) | 0;
        HEAP8[i1 >> 0] = ((i29 >>> 8 & 255) + i29 | 0) >>> 8;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i1 = i1 + 2 | 0;
     }
    }
    if (!i1) break L59;
    i4 = i25 + 466 | 0;
    i5 = i25 + 456 | 0;
    if (i17) {
     i3 = 0;
     while (1) {
      i29 = HEAP8[i2 + 1 >> 0] | 0;
      i1 = i29 & 255;
      switch (i29 << 24 >> 24) {
      case -1:
       {
        HEAP8[i2 >> 0] = HEAP8[i12 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0;
        break;
       }
      case 0:
       {
        HEAP8[i2 >> 0] = HEAP16[i5 >> 1];
        break;
       }
      default:
       {
        i29 = (Math_imul(HEAPU8[i10 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0, i1) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i1 ^ 255) | 0) | 0;
        HEAP8[i2 >> 0] = ((i29 >>> 8 & 255) + i29 | 0) >>> 8;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 2 | 0;
     }
    } else {
     i3 = 0;
     while (1) {
      i29 = HEAP8[i2 + 1 >> 0] | 0;
      i1 = i29 & 255;
      switch (i29 << 24 >> 24) {
      case -1:
       {
        HEAP8[i2 >> 0] = HEAP8[i12 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0;
        break;
       }
      case 0:
       {
        HEAP8[i2 >> 0] = HEAP16[i5 >> 1];
        break;
       }
      default:
       {
        i29 = (Math_imul(HEAPU8[i10 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0, i1) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i1 ^ 255) | 0) | 0;
        HEAP8[i2 >> 0] = HEAP8[i9 + (((i29 >>> 8 & 255) + i29 | 0) >>> 8 & 255) >> 0] | 0;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 2 | 0;
     }
    }
   } else {
    i1 = (i21 | 0) != 0;
    if (!((i18 | 0) != 0 & (i15 | 0) != 0 & (i16 | 0) != 0)) {
     if (!i1) break L59;
     i4 = i25 + 456 | 0;
     i3 = 0;
     i1 = i2;
     while (1) {
      i2 = HEAPU8[i1 + 2 >> 0] << 8 | HEAPU8[i1 + 3 >> 0];
      switch ((i2 & 65535) << 16 >> 16) {
      case 0:
       {
        i29 = HEAP16[i4 >> 1] | 0;
        HEAP8[i1 >> 0] = (i29 & 65535) >>> 8;
        HEAP8[i1 + 1 >> 0] = i29;
        break;
       }
      case -1:
       break;
      default:
       {
        i29 = i1 + 1 | 0;
        i20 = (Math_imul(HEAPU8[i1 >> 0] << 8 | HEAPU8[i29 >> 0], i2) | 0) + ((Math_imul(HEAPU16[i4 >> 1] | 0, i2 ^ 65535) | 0) + 32768) | 0;
        i20 = (i20 >>> 16) + i20 | 0;
        HEAP8[i1 >> 0] = i20 >>> 24;
        HEAP8[i29 >> 0] = i20 >>> 16;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i1 = i1 + 4 | 0;
     }
    }
    if (!i1) break L59;
    i4 = i25 + 466 | 0;
    i5 = i25 + 456 | 0;
    if (i17) {
     i3 = 0;
     while (1) {
      i1 = HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
      switch ((i1 & 65535) << 16 >> 16) {
      case -1:
       {
        i29 = i2 + 1 | 0;
        i20 = HEAP16[(HEAP32[i18 + ((HEAPU8[i29 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0;
        HEAP8[i2 >> 0] = (i20 & 65535) >>> 8;
        HEAP8[i29 >> 0] = i20;
        break;
       }
      case 0:
       {
        i29 = HEAP16[i5 >> 1] | 0;
        HEAP8[i2 >> 0] = (i29 & 65535) >>> 8;
        HEAP8[i2 + 1 >> 0] = i29;
        break;
       }
      default:
       {
        i29 = i2 + 1 | 0;
        i20 = (Math_imul(HEAPU16[(HEAP32[i16 + ((HEAPU8[i29 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0, i1) | 0) + 32768 + (Math_imul(HEAPU16[i4 >> 1] | 0, i1 ^ 65535) | 0) | 0;
        i20 = (i20 >>> 16) + i20 | 0;
        HEAP8[i2 >> 0] = i20 >>> 24;
        HEAP8[i29 >> 0] = i20 >>> 16;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 4 | 0;
     }
    } else {
     i3 = 0;
     while (1) {
      i1 = HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
      switch ((i1 & 65535) << 16 >> 16) {
      case -1:
       {
        i29 = i2 + 1 | 0;
        i20 = HEAP16[(HEAP32[i18 + ((HEAPU8[i29 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0;
        HEAP8[i2 >> 0] = (i20 & 65535) >>> 8;
        HEAP8[i29 >> 0] = i20;
        break;
       }
      case 0:
       {
        i29 = HEAP16[i5 >> 1] | 0;
        HEAP8[i2 >> 0] = (i29 & 65535) >>> 8;
        HEAP8[i2 + 1 >> 0] = i29;
        break;
       }
      default:
       {
        i29 = i2 + 1 | 0;
        i20 = (Math_imul(HEAPU16[(HEAP32[i16 + ((HEAPU8[i29 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0, i1) | 0) + 32768 + (Math_imul(HEAPU16[i4 >> 1] | 0, i1 ^ 65535) | 0) | 0;
        i20 = (i20 >>> 16) + i20 | 0;
        i20 = HEAP16[(HEAP32[i15 + ((i20 >>> 16 & 255) >>> i19 << 2) >> 2] | 0) + (i20 >>> 24 << 1) >> 1] | 0;
        HEAP8[i2 >> 0] = (i20 & 65535) >>> 8;
        HEAP8[i29 >> 0] = i20;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 4 | 0;
     }
    }
   }
  case 6:
   {
    if (i1 << 24 >> 24 == 8) {
     i1 = (i21 | 0) != 0;
     if (!((i12 | 0) != 0 & ((i9 | 0) != 0 & (i10 | 0) != 0))) {
      if (!i1) break L59;
      i4 = i25 + 450 | 0;
      i5 = i25 + 452 | 0;
      i3 = 0;
      i1 = i2;
      while (1) {
       i2 = HEAP8[i1 + 3 >> 0] | 0;
       switch (i2 << 24 >> 24) {
       case 0:
        {
         HEAP8[i1 >> 0] = HEAP16[i4 >> 1];
         i29 = HEAP32[i5 >> 2] | 0;
         HEAP8[i1 + 1 >> 0] = i29;
         HEAP8[i1 + 2 >> 0] = i29 >>> 16;
         break;
        }
       case -1:
        break;
       default:
        {
         i18 = i2 & 255;
         i20 = i18 ^ 255;
         i29 = (Math_imul(HEAPU8[i1 >> 0] | 0, i18) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i1 >> 0] = ((i29 >>> 8 & 255) + i29 | 0) >>> 8;
         i29 = i1 + 1 | 0;
         i17 = Math_imul(HEAPU8[i29 >> 0] | 0, i18) | 0;
         i19 = HEAP32[i5 >> 2] | 0;
         i17 = i17 + 128 + (Math_imul(i19 & 65535, i20) | 0) | 0;
         HEAP8[i29 >> 0] = ((i17 >>> 8 & 255) + i17 | 0) >>> 8;
         i29 = i1 + 2 | 0;
         i20 = (Math_imul(HEAPU8[i29 >> 0] | 0, i18) | 0) + 128 + (Math_imul(i19 >>> 16, i20) | 0) | 0;
         HEAP8[i29 >> 0] = ((i20 >>> 8 & 255) + i20 | 0) >>> 8;
        }
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i21 | 0)) break L59; else i1 = i1 + 4 | 0;
      }
     }
     if (!i1) break L59;
     i4 = i25 + 460 | 0;
     i5 = i25 + 462 | 0;
     i6 = i25 + 464 | 0;
     i7 = i25 + 450 | 0;
     i8 = i25 + 452 | 0;
     if (i17) {
      i3 = 0;
      while (1) {
       i1 = HEAP8[i2 + 3 >> 0] | 0;
       switch (i1 << 24 >> 24) {
       case -1:
        {
         HEAP8[i2 >> 0] = HEAP8[i12 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0;
         i29 = i2 + 1 | 0;
         HEAP8[i29 >> 0] = HEAP8[i12 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
         i29 = i2 + 2 | 0;
         HEAP8[i29 >> 0] = HEAP8[i12 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
         break;
        }
       case 0:
        {
         HEAP8[i2 >> 0] = HEAP16[i7 >> 1];
         i29 = HEAP32[i8 >> 2] | 0;
         HEAP8[i2 + 1 >> 0] = i29;
         HEAP8[i2 + 2 >> 0] = i29 >>> 16;
         break;
        }
       default:
        {
         i19 = i1 & 255;
         i20 = i19 ^ 255;
         i29 = (Math_imul(HEAPU8[i10 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i2 >> 0] = ((i29 >>> 8 & 255) + i29 | 0) >>> 8;
         i29 = i2 + 1 | 0;
         i18 = (Math_imul(HEAPU8[i10 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i5 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i29 >> 0] = ((i18 >>> 8 & 255) + i18 | 0) >>> 8;
         i29 = i2 + 2 | 0;
         i20 = (Math_imul(HEAPU8[i10 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i6 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i29 >> 0] = ((i20 >>> 8 & 255) + i20 | 0) >>> 8;
        }
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 4 | 0;
      }
     } else {
      i3 = 0;
      while (1) {
       i1 = HEAP8[i2 + 3 >> 0] | 0;
       switch (i1 << 24 >> 24) {
       case -1:
        {
         HEAP8[i2 >> 0] = HEAP8[i12 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0;
         i29 = i2 + 1 | 0;
         HEAP8[i29 >> 0] = HEAP8[i12 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
         i29 = i2 + 2 | 0;
         HEAP8[i29 >> 0] = HEAP8[i12 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
         break;
        }
       case 0:
        {
         HEAP8[i2 >> 0] = HEAP16[i7 >> 1];
         i29 = HEAP32[i8 >> 2] | 0;
         HEAP8[i2 + 1 >> 0] = i29;
         HEAP8[i2 + 2 >> 0] = i29 >>> 16;
         break;
        }
       default:
        {
         i19 = i1 & 255;
         i20 = i19 ^ 255;
         i29 = (Math_imul(HEAPU8[i10 + (HEAPU8[i2 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i4 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i2 >> 0] = HEAP8[i9 + (((i29 >>> 8 & 255) + i29 | 0) >>> 8 & 255) >> 0] | 0;
         i29 = i2 + 1 | 0;
         i18 = (Math_imul(HEAPU8[i10 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i5 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i29 >> 0] = HEAP8[i9 + (((i18 >>> 8 & 255) + i18 | 0) >>> 8 & 255) >> 0] | 0;
         i29 = i2 + 2 | 0;
         i20 = (Math_imul(HEAPU8[i10 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0, i19) | 0) + 128 + (Math_imul(HEAPU16[i6 >> 1] | 0, i20) | 0) | 0;
         HEAP8[i29 >> 0] = HEAP8[i9 + (((i20 >>> 8 & 255) + i20 | 0) >>> 8 & 255) >> 0] | 0;
        }
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i21 | 0)) break L59; else i2 = i2 + 4 | 0;
      }
     }
    }
    i1 = (i21 | 0) != 0;
    if (!((i18 | 0) != 0 & (i15 | 0) != 0 & (i16 | 0) != 0)) {
     if (!i1) break L59;
     i4 = i25 + 450 | 0;
     i5 = i25 + 452 | 0;
     i3 = 0;
     i1 = i2;
     while (1) {
      i2 = HEAPU8[i1 + 6 >> 0] << 8 | HEAPU8[i1 + 7 >> 0];
      switch ((i2 & 65535) << 16 >> 16) {
      case 0:
       {
        i29 = HEAP16[i4 >> 1] | 0;
        HEAP8[i1 >> 0] = (i29 & 65535) >>> 8;
        HEAP8[i1 + 1 >> 0] = i29;
        i29 = HEAP32[i5 >> 2] | 0;
        HEAP8[i1 + 2 >> 0] = (i29 & 65535) >>> 8;
        HEAP8[i1 + 3 >> 0] = i29;
        HEAP8[i1 + 4 >> 0] = i29 >>> 24;
        HEAP8[i1 + 5 >> 0] = i29 >>> 16;
        break;
       }
      case -1:
       break;
      default:
       {
        i18 = i1 + 1 | 0;
        i14 = i1 + 2 | 0;
        i16 = i1 + 3 | 0;
        i15 = HEAPU8[i14 >> 0] << 8 | HEAPU8[i16 >> 0];
        i19 = i1 + 4 | 0;
        i29 = i1 + 5 | 0;
        i17 = HEAPU8[i19 >> 0] << 8 | HEAPU8[i29 >> 0];
        i20 = i2 ^ 65535;
        i13 = (Math_imul(HEAPU8[i1 >> 0] << 8 | HEAPU8[i18 >> 0], i2) | 0) + 32768 + (Math_imul(HEAPU16[i4 >> 1] | 0, i20) | 0) | 0;
        i13 = (i13 >>> 16) + i13 | 0;
        HEAP8[i1 >> 0] = i13 >>> 24;
        HEAP8[i18 >> 0] = i13 >>> 16;
        i15 = Math_imul(i15, i2) | 0;
        i18 = HEAP32[i5 >> 2] | 0;
        i15 = i15 + 32768 + (Math_imul(i18 & 65535, i20) | 0) | 0;
        i15 = (i15 >>> 16) + i15 | 0;
        HEAP8[i14 >> 0] = i15 >>> 24;
        HEAP8[i16 >> 0] = i15 >>> 16;
        i20 = (Math_imul(i17, i2) | 0) + 32768 + (Math_imul(i18 >>> 16, i20) | 0) | 0;
        i20 = (i20 >>> 16) + i20 | 0;
        HEAP8[i19 >> 0] = i20 >>> 24;
        HEAP8[i29 >> 0] = i20 >>> 16;
       }
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break L59; else i1 = i1 + 8 | 0;
     }
    }
    if (!i1) break L59;
    i10 = i25 + 460 | 0;
    i11 = i25 + 462 | 0;
    i12 = i25 + 464 | 0;
    i13 = i25 + 450 | 0;
    i14 = i25 + 452 | 0;
    i9 = 0;
    while (1) {
     i7 = HEAPU8[i2 + 6 >> 0] << 8 | HEAPU8[i2 + 7 >> 0];
     switch ((i7 & 65535) << 16 >> 16) {
     case -1:
      {
       i20 = i2 + 1 | 0;
       i8 = HEAP16[(HEAP32[i18 + ((HEAPU8[i20 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0;
       HEAP8[i2 >> 0] = (i8 & 65535) >>> 8;
       HEAP8[i20 >> 0] = i8;
       i20 = i2 + 2 | 0;
       i8 = i2 + 3 | 0;
       i29 = HEAP16[(HEAP32[i18 + ((HEAPU8[i8 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i20 >> 0] << 1) >> 1] | 0;
       HEAP8[i20 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i8 >> 0] = i29;
       i8 = i2 + 4 | 0;
       i29 = i2 + 5 | 0;
       i20 = HEAP16[(HEAP32[i18 + ((HEAPU8[i29 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i8 >> 0] << 1) >> 1] | 0;
       HEAP8[i8 >> 0] = (i20 & 65535) >>> 8;
       HEAP8[i29 >> 0] = i20;
       break;
      }
     case 0:
      {
       i29 = HEAP16[i13 >> 1] | 0;
       HEAP8[i2 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i2 + 1 >> 0] = i29;
       i29 = HEAP32[i14 >> 2] | 0;
       HEAP8[i2 + 2 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i2 + 3 >> 0] = i29;
       HEAP8[i2 + 4 >> 0] = i29 >>> 24;
       HEAP8[i2 + 5 >> 0] = i29 >>> 16;
       break;
      }
     default:
      {
       i5 = i2 + 1 | 0;
       i8 = i7 ^ 65535;
       i4 = (Math_imul(HEAPU16[(HEAP32[i16 + ((HEAPU8[i5 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i2 >> 0] << 1) >> 1] | 0, i7) | 0) + 32768 + (Math_imul(HEAPU16[i10 >> 1] | 0, i8) | 0) | 0;
       i4 = (i4 >>> 16) + i4 | 0;
       i1 = i4 >>> 16;
       i4 = i4 >>> 24;
       if (i17) {
        i3 = i1 & 255;
        i1 = i4 & 255;
       } else {
        i1 = HEAP16[(HEAP32[i15 + ((i1 & 255) >>> i19 << 2) >> 2] | 0) + (i4 << 1) >> 1] | 0;
        i3 = i1 & 255;
        i1 = (i1 & 65535) >>> 8 & 255;
       }
       HEAP8[i2 >> 0] = i1;
       HEAP8[i5 >> 0] = i3;
       i5 = i2 + 2 | 0;
       i6 = i2 + 3 | 0;
       i4 = (Math_imul(HEAPU16[(HEAP32[i16 + ((HEAPU8[i6 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i5 >> 0] << 1) >> 1] | 0, i7) | 0) + 32768 + (Math_imul(HEAPU16[i11 >> 1] | 0, i8) | 0) | 0;
       i4 = (i4 >>> 16) + i4 | 0;
       i1 = i4 >>> 16;
       i4 = i4 >>> 24;
       if (i17) {
        i3 = i1 & 255;
        i1 = i4 & 255;
       } else {
        i1 = HEAP16[(HEAP32[i15 + ((i1 & 255) >>> i19 << 2) >> 2] | 0) + (i4 << 1) >> 1] | 0;
        i3 = i1 & 255;
        i1 = (i1 & 65535) >>> 8 & 255;
       }
       HEAP8[i5 >> 0] = i1;
       HEAP8[i6 >> 0] = i3;
       i5 = i2 + 4 | 0;
       i6 = i2 + 5 | 0;
       i4 = (Math_imul(HEAPU16[(HEAP32[i16 + ((HEAPU8[i6 >> 0] | 0) >>> i19 << 2) >> 2] | 0) + (HEAPU8[i5 >> 0] << 1) >> 1] | 0, i7) | 0) + 32768 + (Math_imul(HEAPU16[i12 >> 1] | 0, i8) | 0) | 0;
       i4 = (i4 >>> 16) + i4 | 0;
       i1 = i4 >>> 16;
       i4 = i4 >>> 24;
       if (i17) {
        i3 = i1 & 255;
        i1 = i4 & 255;
       } else {
        i1 = HEAP16[(HEAP32[i15 + ((i1 & 255) >>> i19 << 2) >> 2] | 0) + (i4 << 1) >> 1] | 0;
        i3 = i1 & 255;
        i1 = (i1 & 65535) >>> 8 & 255;
       }
       HEAP8[i5 >> 0] = i1;
       HEAP8[i6 >> 0] = i3;
      }
     }
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i21 | 0)) break L59; else i2 = i2 + 8 | 0;
    }
   }
  default:
   break L59;
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 L297 : do if (i1 & 8192 | 0) {
  if (!(i1 & 128)) i1 = HEAP8[i25 + 431 >> 0] | 0; else {
   if (HEAP16[i25 + 424 >> 1] | 0) break;
   i1 = HEAP8[i25 + 431 >> 0] | 0;
   if (i1 & 4) break;
  }
  if (i1 << 24 >> 24 != 3) {
   i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
   i5 = HEAP32[i25 + 480 >> 2] | 0;
   i7 = HEAP32[i25 + 488 >> 2] | 0;
   i6 = HEAP32[i25 + 492 >> 2] | 0;
   i8 = HEAP32[i27 >> 2] | 0;
   i4 = i27 + 9 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!((i7 | 0) != 0 & (i2 & 255) < 9)) if (!((i6 | 0) != 0 & i2 << 24 >> 24 == 16)) break;
   i29 = HEAP16[i27 + 8 >> 1] | 0;
   i2 = (i29 & 65535) >>> 8 & 255;
   switch ((i29 & 255) << 24 >> 24) {
   case 2:
    {
     i3 = (i8 | 0) != 0;
     if (i2 << 24 >> 24 == 8) {
      if (i3) i2 = 0; else break L297;
      while (1) {
       HEAP8[i1 >> 0] = HEAP8[i7 + (HEAPU8[i1 >> 0] | 0) >> 0] | 0;
       i29 = i1 + 1 | 0;
       HEAP8[i29 >> 0] = HEAP8[i7 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
       i29 = i1 + 2 | 0;
       HEAP8[i29 >> 0] = HEAP8[i7 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 3 | 0;
      }
     } else {
      if (i3) i2 = 0; else break L297;
      while (1) {
       i21 = i1 + 1 | 0;
       i20 = HEAP16[(HEAP32[i6 + ((HEAPU8[i21 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i1 >> 0] << 1) >> 1] | 0;
       HEAP8[i1 >> 0] = (i20 & 65535) >>> 8;
       HEAP8[i21 >> 0] = i20;
       i21 = i1 + 2 | 0;
       i20 = i1 + 3 | 0;
       i29 = HEAP16[(HEAP32[i6 + ((HEAPU8[i20 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i21 >> 0] << 1) >> 1] | 0;
       HEAP8[i21 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i20 >> 0] = i29;
       i20 = i1 + 4 | 0;
       i29 = i1 + 5 | 0;
       i21 = HEAP16[(HEAP32[i6 + ((HEAPU8[i29 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i20 >> 0] << 1) >> 1] | 0;
       HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
       HEAP8[i29 >> 0] = i21;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 6 | 0;
      }
     }
     break;
    }
   case 6:
    {
     i3 = (i8 | 0) != 0;
     if (i2 << 24 >> 24 == 8) {
      if (i3) i2 = 0; else break L297;
      while (1) {
       HEAP8[i1 >> 0] = HEAP8[i7 + (HEAPU8[i1 >> 0] | 0) >> 0] | 0;
       i29 = i1 + 1 | 0;
       HEAP8[i29 >> 0] = HEAP8[i7 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
       i29 = i1 + 2 | 0;
       HEAP8[i29 >> 0] = HEAP8[i7 + (HEAPU8[i29 >> 0] | 0) >> 0] | 0;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 4 | 0;
      }
     } else {
      if (i3) i2 = 0; else break L297;
      while (1) {
       i21 = i1 + 1 | 0;
       i20 = HEAP16[(HEAP32[i6 + ((HEAPU8[i21 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i1 >> 0] << 1) >> 1] | 0;
       HEAP8[i1 >> 0] = (i20 & 65535) >>> 8;
       HEAP8[i21 >> 0] = i20;
       i21 = i1 + 2 | 0;
       i20 = i1 + 3 | 0;
       i29 = HEAP16[(HEAP32[i6 + ((HEAPU8[i20 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i21 >> 0] << 1) >> 1] | 0;
       HEAP8[i21 >> 0] = (i29 & 65535) >>> 8;
       HEAP8[i20 >> 0] = i29;
       i20 = i1 + 4 | 0;
       i29 = i1 + 5 | 0;
       i21 = HEAP16[(HEAP32[i6 + ((HEAPU8[i29 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i20 >> 0] << 1) >> 1] | 0;
       HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
       HEAP8[i29 >> 0] = i21;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 8 | 0;
      }
     }
     break;
    }
   case 4:
    {
     i3 = (i8 | 0) != 0;
     if (i2 << 24 >> 24 == 8) {
      if (i3) i2 = 0; else break L297;
      while (1) {
       HEAP8[i1 >> 0] = HEAP8[i7 + (HEAPU8[i1 >> 0] | 0) >> 0] | 0;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 2 | 0;
      }
     } else {
      if (i3) i2 = 0; else break L297;
      while (1) {
       i29 = i1 + 1 | 0;
       i21 = HEAP16[(HEAP32[i6 + ((HEAPU8[i29 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i1 >> 0] << 1) >> 1] | 0;
       HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
       HEAP8[i29 >> 0] = i21;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 4 | 0;
      }
     }
     break;
    }
   case 0:
    {
     if (i2 << 24 >> 24 == 2) {
      if (!i8) break L297; else {
       i2 = 0;
       i3 = i1;
      }
      while (1) {
       i19 = HEAPU8[i3 >> 0] | 0;
       i20 = i19 & 192;
       i18 = i19 & 48;
       i21 = i19 & 12;
       i29 = i19 & 3;
       HEAP8[i3 >> 0] = (HEAPU8[i7 + (i18 << 2 | i18 | i18 >>> 2 | i18 >>> 4) >> 0] | 0) >>> 2 & 48 | HEAPU8[i7 + (i19 >>> 6 | i20 | i20 >>> 2 | i20 >>> 4) >> 0] & 192 | (HEAPU8[i7 + (i21 << 2 | i21 | i21 << 4 | i21 >>> 2) >> 0] | 0) >>> 4 & 12 | (HEAPU8[i7 + (i29 << 4 | i29 | i29 << 6 | i29 << 2) >> 0] | 0) >>> 6;
       i2 = i2 + 4 | 0;
       if (i2 >>> 0 >= i8 >>> 0) break; else i3 = i3 + 1 | 0;
      }
      i2 = HEAP8[i4 >> 0] | 0;
     }
     switch (i2 << 24 >> 24) {
     case 4:
      {
       if (!i8) break L297; else i2 = 0;
       while (1) {
        i29 = HEAPU8[i1 >> 0] | 0;
        i21 = i29 & 15;
        HEAP8[i1 >> 0] = (HEAPU8[i7 + (i21 << 4 | i21) >> 0] | 0) >>> 4 | HEAPU8[i7 + (i29 & 240 | i29 >>> 4) >> 0] & 240;
        i2 = i2 + 2 | 0;
        if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 1 | 0;
       }
       break;
      }
     case 8:
      {
       if (!i8) break L297; else i2 = 0;
       while (1) {
        HEAP8[i1 >> 0] = HEAP8[i7 + (HEAPU8[i1 >> 0] | 0) >> 0] | 0;
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 1 | 0;
       }
       break;
      }
     case 16:
      {
       if (!i8) break L297; else i2 = 0;
       while (1) {
        i29 = i1 + 1 | 0;
        i21 = HEAP16[(HEAP32[i6 + ((HEAPU8[i29 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i1 >> 0] << 1) >> 1] | 0;
        HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
        HEAP8[i29 >> 0] = i21;
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 2 | 0;
       }
       break;
      }
     default:
      break L297;
     }
     break;
    }
   default:
    break L297;
   }
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 L351 : do if ((i1 & 262272 | 0) == 262272) {
  switch (HEAP8[i27 + 8 >> 0] | 0) {
  case 4:
  case 6:
   break;
  default:
   break L351;
  }
  _UNITY_png_do_strip_channel(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0, 0);
  i1 = HEAP32[i24 >> 2] | 0;
 } while (0);
 L355 : do if (i1 & 8388608 | 0) {
  i1 = i27 + 8 | 0;
  if (HEAP8[i1 >> 0] & 4) {
   i6 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
   i2 = HEAP32[i27 >> 2] | 0;
   i1 = HEAP16[i1 >> 1] | 0;
   i3 = i1 & 65535;
   if (i3 & 4 | 0) switch (((i1 & 65535) >>> 8 & 255) << 24 >> 24) {
   case 8:
    {
     i4 = HEAP32[i25 + 496 >> 2] | 0;
     if (!i4) break L355;
     i1 = i3 & 2;
     i3 = i1 + 2 | 0;
     if (!i2) break L355;
     i1 = i6 + (i1 | 1) | 0;
     while (1) {
      HEAP8[i1 >> 0] = HEAP8[i4 + (HEAPU8[i1 >> 0] | 0) >> 0] | 0;
      i2 = i2 + -1 | 0;
      if (!i2) break; else i1 = i1 + i3 | 0;
     }
     break;
    }
   case 16:
    {
     i4 = HEAP32[i25 + 504 >> 2] | 0;
     i5 = HEAP32[i25 + 480 >> 2] | 0;
     if (!i4) break L355;
     i1 = i3 << 1 & 4;
     i3 = i1 + 4 | 0;
     if (!i2) break L355;
     i1 = i6 + (i1 | 2) | 0;
     while (1) {
      i29 = i1 + 1 | 0;
      i21 = HEAP16[(HEAP32[i4 + ((HEAPU8[i29 >> 0] | 0) >>> i5 << 2) >> 2] | 0) + (HEAPU8[i1 >> 0] << 1) >> 1] | 0;
      HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
      HEAP8[i29 >> 0] = i21;
      i2 = i2 + -1 | 0;
      if (!i2) break; else i1 = i1 + i3 | 0;
     }
     break;
    }
   default:
    break L355;
   }
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 & 67108864) {
  i3 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i5 = i27 + 9 | 0;
  if ((HEAP8[i5 >> 0] | 0) == 16) {
   i6 = i27 + 4 | 0;
   i29 = HEAP32[i6 >> 2] | 0;
   i4 = i3 + i29 | 0;
   if ((i29 | 0) > 0) {
    i2 = i3;
    i1 = i3;
    while (1) {
     i29 = HEAPU8[i1 >> 0] | 0;
     HEAP8[i2 >> 0] = (((((HEAPU8[i1 + 1 >> 0] | 0) - i29 | 0) * 65535 | 0) + 8388480 | 0) >>> 24) + i29;
     i1 = i1 + 2 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 1 | 0;
    }
    i1 = HEAP32[i24 >> 2] | 0;
   }
   HEAP8[i5 >> 0] = 8;
   i29 = HEAPU8[i27 + 10 >> 0] | 0;
   HEAP8[i27 + 11 >> 0] = i29 << 3;
   HEAP32[i6 >> 2] = Math_imul(HEAP32[i27 >> 2] | 0, i29) | 0;
  }
 }
 if (i1 & 1024) {
  i3 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i5 = i27 + 9 | 0;
  if ((HEAP8[i5 >> 0] | 0) == 16) {
   i6 = i27 + 4 | 0;
   i29 = HEAP32[i6 >> 2] | 0;
   i4 = i3 + i29 | 0;
   if ((i29 | 0) > 0) {
    i2 = i3;
    i1 = i3;
    while (1) {
     HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
     i1 = i1 + 2 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 1 | 0;
    }
    i1 = HEAP32[i24 >> 2] | 0;
   }
   HEAP8[i5 >> 0] = 8;
   i29 = HEAPU8[i27 + 10 >> 0] | 0;
   HEAP8[i27 + 11 >> 0] = i29 << 3;
   HEAP32[i6 >> 2] = Math_imul(HEAP32[i27 >> 2] | 0, i29) | 0;
  }
 }
 if (i1 & 16384) if (HEAP32[i25 + 204 >> 2] & 2048) {
  _UNITY_png_do_gray_to_rgb(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
 }
 L393 : do if (i1 & 524288 | 0) {
  i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i4 = HEAP32[i27 >> 2] | 0;
  i29 = HEAP16[i27 + 8 >> 1] | 0;
  i3 = (i29 & 65535) >>> 8 & 255;
  switch ((i29 & 255) << 24 >> 24) {
  case 6:
   {
    i1 = i1 + (HEAP32[i27 + 4 >> 2] | 0) | 0;
    i2 = (i4 | 0) != 0;
    if (i3 << 24 >> 24 == 8) {
     if (i2) i2 = 0; else break L393;
     while (1) {
      i29 = i1 + -1 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + -4 | 0;
     }
    } else {
     if (i2) i2 = 0; else break L393;
     while (1) {
      i29 = i1 + -1 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i29 = i1 + -2 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + -8 | 0;
     }
    }
    break;
   }
  case 4:
   {
    i1 = i1 + (HEAP32[i27 + 4 >> 2] | 0) | 0;
    i2 = (i4 | 0) != 0;
    if (i3 << 24 >> 24 == 8) {
     if (i2) i2 = 0; else break L393;
     while (1) {
      i29 = i1 + -1 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + -2 | 0;
     }
    } else {
     if (i2) i2 = 0; else break L393;
     while (1) {
      i29 = i1 + -1 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i29 = i1 + -2 | 0;
      HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] ^ 255;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + -4 | 0;
     }
    }
    break;
   }
  default:
   break L393;
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 & 8) {
  i7 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i29 = HEAP16[i27 + 8 >> 1] | 0;
  i3 = i29 & 255;
  i2 = (i29 & 65535) >>> 8;
  i5 = i2 & 255;
  if ((i29 & 255) << 24 >> 24 != 3) {
   i4 = i2 & 65535;
   if (!(i3 & 2)) {
    i1 = 1;
    i2 = HEAPU8[i25 + 520 >> 0] | 0;
   } else {
    i2 = HEAPU8[i25 + 517 >> 0] | 0;
    HEAP32[i22 + 4 >> 2] = i4 - (HEAPU8[i25 + 518 >> 0] | 0);
    HEAP32[i22 + 8 >> 2] = i4 - (HEAPU8[i25 + 519 >> 0] | 0);
    i1 = 3;
   }
   HEAP32[i22 >> 2] = i4 - i2;
   if (!(i3 & 4)) i6 = i1; else {
    HEAP32[i22 + (i1 << 2) >> 2] = i4 - (HEAPU8[i25 + 521 >> 0] | 0);
    i6 = i1 + 1 | 0;
   }
   i3 = 0;
   i1 = 0;
   do {
    i2 = i22 + (i3 << 2) | 0;
    i29 = HEAP32[i2 >> 2] | 0;
    if ((i29 | 0) > 0 & (i29 | 0) < (i4 | 0)) i1 = 1; else HEAP32[i2 >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i6 | 0));
   L429 : do if (i1 | 0) switch (i5 << 24 >> 24) {
   case 2:
    {
     i29 = HEAP32[i27 + 4 >> 2] | 0;
     i2 = i7 + i29 | 0;
     if ((i29 | 0) > 0) i1 = i7; else break L429;
     do {
      HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> 1 & 85;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
     break;
    }
   case 4:
    {
     i29 = HEAP32[i27 + 4 >> 2] | 0;
     i4 = i7 + i29 | 0;
     i2 = HEAP32[i22 >> 2] | 0;
     i3 = 15 >>> i2;
     i3 = i3 << 4 | i3;
     if ((i29 | 0) > 0) i1 = i7; else break L429;
     do {
      HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> i2 & i3;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i4 >>> 0);
     break;
    }
   case 8:
    {
     i29 = HEAP32[i27 + 4 >> 2] | 0;
     i4 = i7 + i29 | 0;
     if ((i29 | 0) > 0) {
      i3 = 0;
      i1 = i7;
     } else break L429;
     while (1) {
      i2 = i3 + 1 | 0;
      HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> (HEAP32[i22 + (i3 << 2) >> 2] | 0);
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i4 >>> 0) break; else i3 = (i2 | 0) >= (i6 | 0) ? 0 : i2;
     }
     break;
    }
   case 16:
    {
     i29 = HEAP32[i27 + 4 >> 2] | 0;
     i3 = i7 + i29 | 0;
     if ((i29 | 0) > 0) {
      i1 = 0;
      i2 = i7;
     } else break L429;
     while (1) {
      i29 = i2 + 1 | 0;
      i21 = (HEAPU8[i2 >> 0] << 8 | HEAPU8[i29 >> 0]) >>> (HEAP32[i22 + (i1 << 2) >> 2] | 0);
      i1 = i1 + 1 | 0;
      HEAP8[i2 >> 0] = i21 >>> 8;
      i2 = i2 + 2 | 0;
      HEAP8[i29 >> 0] = i21;
      if (i2 >>> 0 >= i3 >>> 0) break; else i1 = (i1 | 0) >= (i6 | 0) ? 0 : i1;
     }
     break;
    }
   default:
    break L429;
   } while (0);
   i1 = HEAP32[i24 >> 2] | 0;
  }
 }
 if (i1 & 4 | 0) {
  i2 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i6 = i27 + 9 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if ((i1 & 255) < 8) {
   i7 = HEAP32[i27 >> 2] | 0;
   switch (i1 << 24 >> 24) {
   case 1:
    {
     if (i7 | 0) {
      i4 = i7 + 7 & 7 ^ 7;
      i5 = i2 + i7 | 0;
      i1 = i2 + ((i7 + -1 | 0) >>> 3) | 0;
      i2 = 0;
      while (1) {
       i5 = i5 + -1 | 0;
       HEAP8[i5 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> i4 & 1;
       i3 = (i4 | 0) == 7;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break; else {
        i4 = i3 ? 0 : i4 + 1 | 0;
        i1 = i3 ? i1 + -1 | 0 : i1;
       }
      }
     }
     break;
    }
   case 2:
    {
     if (i7 | 0) {
      i4 = (i7 << 1) + 6 & 6 ^ 6;
      i5 = i2 + i7 | 0;
      i1 = i2 + ((i7 + -1 | 0) >>> 2) | 0;
      i2 = 0;
      while (1) {
       i5 = i5 + -1 | 0;
       HEAP8[i5 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> i4 & 3;
       i3 = (i4 | 0) == 6;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break; else {
        i4 = i3 ? 0 : i4 + 2 | 0;
        i1 = i3 ? i1 + -1 | 0 : i1;
       }
      }
     }
     break;
    }
   case 4:
    {
     if (i7 | 0) {
      i4 = i7 << 2 & 4;
      i5 = i2 + i7 | 0;
      i1 = i2 + ((i7 + -1 | 0) >>> 1) | 0;
      i2 = 0;
      while (1) {
       i5 = i5 + -1 | 0;
       HEAP8[i5 >> 0] = (HEAPU8[i1 >> 0] | 0) >>> i4 & 15;
       i3 = (i4 | 0) == 4;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break; else {
        i4 = i3 ? 0 : 4;
        i1 = i3 ? i1 + -1 | 0 : i1;
       }
      }
     }
     break;
    }
   default:
    {}
   }
   HEAP8[i6 >> 0] = 8;
   i29 = HEAPU8[i27 + 10 >> 0] | 0;
   HEAP8[i27 + 11 >> 0] = i29 << 3;
   HEAP32[i27 + 4 >> 2] = Math_imul(i29, i7) | 0;
  }
 }
 i7 = i27 + 8 | 0;
 if ((HEAP32[i7 >> 2] & 255) << 24 >> 24 == 3) if ((HEAP32[i25 + 420 >> 2] | 0) > -1) _UNITY_png_do_check_palette_indexes(i25, i27);
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 & 1) {
  _UNITY_png_do_bgr(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
 }
 L471 : do if (i1 & 32768 | 0) {
  i2 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i6 = HEAP16[i25 + 440 >> 1] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i4 = (i6 & 65535) >>> 8 & 255;
  i6 = i6 & 255;
  i29 = HEAP32[i7 >> 2] | 0;
  i1 = (i29 & 65535) >>> 8 & 255;
  switch ((i29 & 255) << 24 >> 24) {
  case 0:
   switch (i1 << 24 >> 24) {
   case 8:
    {
     i1 = i2 + i5 | 0;
     i2 = i1 + i5 | 0;
     if (!(i3 & 128)) {
      if (i5 | 0) {
       i3 = i2;
       i2 = 0;
       do {
        i1 = i1 + -1 | 0;
        HEAP8[i3 + -1 >> 0] = HEAP8[i1 >> 0] | 0;
        i3 = i3 + -2 | 0;
        HEAP8[i3 >> 0] = i6;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 2;
      HEAP8[i27 + 11 >> 0] = 16;
      HEAP32[i27 + 4 >> 2] = i5 << 1;
      break L471;
     } else {
      HEAP8[i2 + -1 >> 0] = i6;
      if (i5 >>> 0 > 1) {
       i3 = i2;
       i2 = 1;
       do {
        i1 = i1 + -1 | 0;
        i29 = i3;
        i3 = i3 + -2 | 0;
        HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
        i2 = i2 + 1 | 0;
        HEAP8[i29 + -3 >> 0] = i6;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 2;
      HEAP8[i27 + 11 >> 0] = 16;
      HEAP32[i27 + 4 >> 2] = i5 << 1;
      break L471;
     }
    }
   case 16:
    {
     i29 = i5 << 1;
     i1 = i2 + i29 | 0;
     i2 = i1 + i29 | 0;
     if (!(i3 & 128)) {
      if (i5 | 0) {
       i3 = i2;
       i2 = 0;
       do {
        HEAP8[i3 + -1 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        i1 = i1 + -2 | 0;
        HEAP8[i3 + -2 >> 0] = HEAP8[i1 >> 0] | 0;
        HEAP8[i3 + -3 >> 0] = i4;
        i3 = i3 + -4 | 0;
        HEAP8[i3 >> 0] = i6;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 2;
      HEAP8[i27 + 11 >> 0] = 32;
      HEAP32[i27 + 4 >> 2] = i5 << 2;
      break L471;
     } else {
      HEAP8[i2 + -1 >> 0] = i4;
      HEAP8[i2 + -2 >> 0] = i6;
      if (i5 >>> 0 > 1) {
       i3 = i2;
       i2 = 1;
       do {
        HEAP8[i3 + -3 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        i1 = i1 + -2 | 0;
        i29 = i3;
        i3 = i3 + -4 | 0;
        HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
        i2 = i2 + 1 | 0;
        HEAP8[i29 + -5 >> 0] = i4;
        HEAP8[i29 + -6 >> 0] = i6;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 2;
      HEAP8[i27 + 11 >> 0] = 32;
      HEAP32[i27 + 4 >> 2] = i5 << 2;
      break L471;
     }
    }
   default:
    break L471;
   }
  case 2:
   switch (i1 << 24 >> 24) {
   case 8:
    {
     i1 = i2 + (i5 * 3 | 0) | 0;
     i2 = i1 + i5 | 0;
     if (!(i3 & 128)) {
      if (i5 | 0) {
       i3 = i2;
       i2 = 0;
       do {
        HEAP8[i3 + -1 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        HEAP8[i3 + -2 >> 0] = HEAP8[i1 + -2 >> 0] | 0;
        i1 = i1 + -3 | 0;
        HEAP8[i3 + -3 >> 0] = HEAP8[i1 >> 0] | 0;
        i3 = i3 + -4 | 0;
        HEAP8[i3 >> 0] = i6;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 4;
      HEAP8[i27 + 11 >> 0] = 32;
      HEAP32[i27 + 4 >> 2] = i5 << 2;
      break L471;
     } else {
      HEAP8[i2 + -1 >> 0] = i6;
      if (i5 >>> 0 > 1) {
       i3 = i2;
       i2 = 1;
       do {
        HEAP8[i3 + -2 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        HEAP8[i3 + -3 >> 0] = HEAP8[i1 + -2 >> 0] | 0;
        i1 = i1 + -3 | 0;
        i29 = i3;
        i3 = i3 + -4 | 0;
        HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
        i2 = i2 + 1 | 0;
        HEAP8[i29 + -5 >> 0] = i6;
       } while ((i2 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 4;
      HEAP8[i27 + 11 >> 0] = 32;
      HEAP32[i27 + 4 >> 2] = i5 << 2;
      break L471;
     }
    }
   case 16:
    {
     i1 = i2 + (i5 * 6 | 0) | 0;
     i2 = i1 + (i5 << 1) | 0;
     if (!(i3 & 128)) {
      if (i5 | 0) {
       i3 = 0;
       do {
        HEAP8[i2 + -1 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        HEAP8[i2 + -2 >> 0] = HEAP8[i1 + -2 >> 0] | 0;
        HEAP8[i2 + -3 >> 0] = HEAP8[i1 + -3 >> 0] | 0;
        HEAP8[i2 + -4 >> 0] = HEAP8[i1 + -4 >> 0] | 0;
        HEAP8[i2 + -5 >> 0] = HEAP8[i1 + -5 >> 0] | 0;
        i1 = i1 + -6 | 0;
        HEAP8[i2 + -6 >> 0] = HEAP8[i1 >> 0] | 0;
        HEAP8[i2 + -7 >> 0] = i4;
        i2 = i2 + -8 | 0;
        HEAP8[i2 >> 0] = i6;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 4;
      HEAP8[i27 + 11 >> 0] = 64;
      HEAP32[i27 + 4 >> 2] = i5 << 3;
      break L471;
     } else {
      HEAP8[i2 + -1 >> 0] = i4;
      HEAP8[i2 + -2 >> 0] = i6;
      if (i5 >>> 0 > 1) {
       i3 = 1;
       do {
        HEAP8[i2 + -3 >> 0] = HEAP8[i1 + -1 >> 0] | 0;
        HEAP8[i2 + -4 >> 0] = HEAP8[i1 + -2 >> 0] | 0;
        HEAP8[i2 + -5 >> 0] = HEAP8[i1 + -3 >> 0] | 0;
        HEAP8[i2 + -6 >> 0] = HEAP8[i1 + -4 >> 0] | 0;
        HEAP8[i2 + -7 >> 0] = HEAP8[i1 + -5 >> 0] | 0;
        i1 = i1 + -6 | 0;
        i29 = i2;
        i2 = i2 + -8 | 0;
        HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
        i3 = i3 + 1 | 0;
        HEAP8[i29 + -9 >> 0] = i4;
        HEAP8[i29 + -10 >> 0] = i6;
       } while ((i3 | 0) != (i5 | 0));
      }
      HEAP8[i27 + 10 >> 0] = 4;
      HEAP8[i27 + 11 >> 0] = 64;
      HEAP32[i27 + 4 >> 2] = i5 << 3;
      break L471;
     }
    }
   default:
    break L471;
   }
  default:
   break L471;
  }
 } while (0);
 L527 : do if (HEAP32[i24 >> 2] & 131072 | 0) {
  i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
  i4 = HEAP32[i27 >> 2] | 0;
  i29 = HEAP32[i7 >> 2] | 0;
  i3 = (i29 & 65535) >>> 8 & 255;
  switch ((i29 & 255) << 24 >> 24) {
  case 6:
   {
    i1 = i1 + (HEAP32[i27 + 4 >> 2] | 0) | 0;
    i2 = (i4 | 0) != 0;
    if (i3 << 24 >> 24 == 8) {
     if (i2) i2 = 0; else break L527;
     do {
      i23 = i1 + -1 | 0;
      i29 = HEAP8[i23 >> 0] | 0;
      i22 = i1 + -2 | 0;
      HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | 0;
      i23 = i1 + -3 | 0;
      HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
      i1 = i1 + -4 | 0;
      HEAP8[i23 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i1 >> 0] = i29;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i4 | 0));
    } else {
     if (i2) i2 = 0; else break L527;
     do {
      i23 = i1 + -1 | 0;
      i22 = HEAP8[i23 >> 0] | 0;
      i20 = i1 + -2 | 0;
      i29 = HEAP8[i20 >> 0] | 0;
      i21 = i1 + -3 | 0;
      HEAP8[i23 >> 0] = HEAP8[i21 >> 0] | 0;
      i23 = i1 + -4 | 0;
      HEAP8[i20 >> 0] = HEAP8[i23 >> 0] | 0;
      i20 = i1 + -5 | 0;
      HEAP8[i21 >> 0] = HEAP8[i20 >> 0] | 0;
      i21 = i1 + -6 | 0;
      HEAP8[i23 >> 0] = HEAP8[i21 >> 0] | 0;
      i23 = i1 + -7 | 0;
      HEAP8[i20 >> 0] = HEAP8[i23 >> 0] | 0;
      i1 = i1 + -8 | 0;
      HEAP8[i21 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i23 >> 0] = i22;
      HEAP8[i1 >> 0] = i29;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i4 | 0));
    }
    break;
   }
  case 4:
   {
    i1 = i1 + (HEAP32[i27 + 4 >> 2] | 0) | 0;
    i2 = (i4 | 0) != 0;
    if (i3 << 24 >> 24 == 8) {
     if (i2) i2 = 0; else break L527;
     do {
      i23 = i1 + -1 | 0;
      i29 = HEAP8[i23 >> 0] | 0;
      i1 = i1 + -2 | 0;
      HEAP8[i23 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i1 >> 0] = i29;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i4 | 0));
    } else {
     if (i2) i2 = 0; else break L527;
     do {
      i20 = i1 + -1 | 0;
      i22 = HEAP8[i20 >> 0] | 0;
      i21 = i1 + -2 | 0;
      i29 = HEAP8[i21 >> 0] | 0;
      i23 = i1 + -3 | 0;
      HEAP8[i20 >> 0] = HEAP8[i23 >> 0] | 0;
      i1 = i1 + -4 | 0;
      HEAP8[i21 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i23 >> 0] = i22;
      HEAP8[i1 >> 0] = i29;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i4 | 0));
    }
    break;
   }
  default:
   break L527;
  }
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 & 16) {
  _UNITY_png_do_swap(i27, (HEAP32[i26 >> 2] | 0) + 1 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
 }
 if (!(i1 & 1048576)) {
  STACKTOP = i28;
  return;
 }
 i1 = HEAP32[i25 + 188 >> 2] | 0;
 if (i1 | 0) mftCall_viii(i1 | 0, i25 | 0, i27 | 0, (HEAP32[i26 >> 2] | 0) + 1 | 0);
 i1 = HEAP16[i25 + 200 >> 1] | 0;
 i2 = i1 & 255;
 i1 = (i1 & 65535) >>> 8 & 255;
 if (i2 << 24 >> 24) HEAP8[i27 + 9 >> 0] = i2;
 i2 = i27 + 10 | 0;
 if (!(i1 << 24 >> 24)) i1 = HEAP8[i2 >> 0] | 0; else HEAP8[i2 >> 0] = i1;
 i1 = Math_imul(i1 & 255, HEAPU8[i27 + 9 >> 0] | 0) | 0;
 HEAP8[i27 + 11 >> 0] = i1;
 i1 = i1 & 255;
 i2 = HEAP32[i27 >> 2] | 0;
 if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i2) | 0; else i1 = ((Math_imul(i1, i2) | 0) + 7 | 0) >>> 3;
 HEAP32[i27 + 4 >> 2] = i1;
 STACKTOP = i28;
 return;
}

function __ZL17SerializeSnapshotRK14MemorySnapshotR13dynamic_arrayIhLj1EE(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i23;
 i20 = i19 + 12 | 0;
 i21 = i19 + 16 | 0;
 i22 = i19 + 4 | 0;
 i1 = 0;
 do {
  i4 = gb + 66312 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i3 = i7 & 2147483647;
  do if (i6 >>> 0 > i3 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i3 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  i3 = gb + 66316 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  i3 = gb + 66320 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i11 = HEAP32[i18 >> 2] | 0;
 i12 = HEAP32[i18 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = i11;
 i1 = 0;
 do {
  i3 = i17 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (i11 | 0) {
  i10 = 0;
  do {
   i3 = i12 + (i10 << 4) | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 8);
   i9 = i12 + (i10 << 4) + 8 | 0;
   i1 = 0;
   do {
    i3 = i9 + i1 | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   if (HEAP32[i9 >> 2] | 0) {
    i3 = i12 + (i10 << 4) + 12 | 0;
    i1 = 0;
    do {
     i4 = (HEAP32[i3 >> 2] | 0) + i1 | 0;
     i5 = HEAP32[i20 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i21 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = i16;
       break;
      }
     } while (0);
     HEAP32[i20 >> 2] = i6;
     HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i11 | 0));
 }
 i1 = 0;
 do {
  i3 = gb + 66324 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i11 = HEAP32[i18 + 8 >> 2] | 0;
 i12 = HEAP32[i18 + 12 >> 2] | 0;
 HEAP32[i17 >> 2] = i11;
 i1 = 0;
 do {
  i3 = i17 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (i11 | 0) {
  i10 = 0;
  do {
   i3 = i12 + (i10 << 4) | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 8);
   i9 = i12 + (i10 << 4) + 8 | 0;
   i1 = 0;
   do {
    i3 = i9 + i1 | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   if (HEAP32[i9 >> 2] | 0) {
    i3 = i12 + (i10 << 4) + 12 | 0;
    i1 = 0;
    do {
     i4 = (HEAP32[i3 >> 2] | 0) + i1 | 0;
     i5 = HEAP32[i20 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i21 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = i16;
       break;
      }
     } while (0);
     HEAP32[i20 >> 2] = i6;
     HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i11 | 0));
 }
 i1 = 0;
 do {
  i3 = gb + 66328 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i16 = i18 + 16 | 0;
 i1 = 0;
 do {
  i3 = i16 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i15 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i15;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (!(HEAP32[i16 >> 2] | 0)) i1 = 0; else {
  i15 = i18 + 20 | 0;
  i14 = 0;
  do {
   i13 = HEAP32[i15 >> 2] | 0;
   i9 = i13 + (i14 * 48 | 0) | 0;
   HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
   i1 = 0;
   do {
    i3 = i17 + i1 | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i13 + (i14 * 48 | 0) + 20 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   if (!(HEAP32[i9 >> 2] & 2)) {
    i12 = i13 + (i14 * 48 | 0) + 8 | 0;
    i1 = 0;
    do {
     i3 = i12 + i1 | 0;
     i4 = HEAP32[i20 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i21 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i20 >> 2] = i5;
     HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 4);
    if (HEAP32[i12 >> 2] | 0) {
     i11 = i13 + (i14 * 48 | 0) + 4 | 0;
     i10 = 0;
     do {
      i9 = HEAP32[i11 >> 2] | 0;
      i3 = i9 + (i10 << 4) | 0;
      i1 = 0;
      do {
       i4 = i3 + i1 | 0;
       i5 = HEAP32[i20 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i7 = HEAP32[i21 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i6 >>> 0 > i8 >>> 0) {
        i2 = i7 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i20 >> 2] = i6;
       HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 4);
      i3 = i9 + (i10 << 4) + 4 | 0;
      i1 = 0;
      do {
       i4 = i3 + i1 | 0;
       i5 = HEAP32[i20 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i7 = HEAP32[i21 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i6 >>> 0 > i8 >>> 0) {
        i2 = i7 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i20 >> 2] = i6;
       HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 4);
      i1 = HEAP32[i9 + (i10 << 4) + 8 >> 2] | 0;
      while (1) {
       i3 = HEAP8[i1 >> 0] | 0;
       i4 = HEAP32[i20 >> 2] | 0;
       i5 = i4 + 1 | 0;
       i6 = HEAP32[i21 >> 2] | 0;
       i7 = i6 & 2147483647;
       do if (i5 >>> 0 > i7 >>> 0) {
        i2 = i6 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
         HEAP32[i21 >> 2] = i2;
         HEAP32[i19 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i20 >> 2] = i5;
       HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i3;
       if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
      }
      i2 = HEAP8[i9 + (i10 << 4) + 12 >> 0] | 0;
      i3 = HEAP32[i20 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i5 = HEAP32[i21 >> 2] | 0;
      i6 = i5 & 2147483647;
      do if (i4 >>> 0 > i6 >>> 0) {
       i1 = i5 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i21 >> 2] = i1;
        HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i9 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
        HEAP32[i21 >> 2] = i1;
        HEAP32[i19 >> 2] = i9;
        break;
       }
      } while (0);
      HEAP32[i20 >> 2] = i4;
      HEAP8[(HEAP32[i19 >> 2] | 0) + i3 >> 0] = i2;
      i10 = i10 + 1 | 0;
     } while (i10 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
    }
    i9 = i13 + (i14 * 48 | 0) + 12 | 0;
    i1 = 0;
    do {
     i3 = i9 + i1 | 0;
     i4 = HEAP32[i20 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i21 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
       HEAP32[i21 >> 2] = i2;
       HEAP32[i19 >> 2] = i12;
       break;
      }
     } while (0);
     HEAP32[i20 >> 2] = i5;
     HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 4);
    if (HEAP32[i9 >> 2] | 0) {
     i3 = i13 + (i14 * 48 | 0) + 16 | 0;
     i1 = 0;
     do {
      i4 = (HEAP32[i3 >> 2] | 0) + i1 | 0;
      i5 = HEAP32[i20 >> 2] | 0;
      i6 = i5 + 1 | 0;
      i7 = HEAP32[i21 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i2 = i7 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i21 >> 2] = i2;
        HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
        HEAP32[i21 >> 2] = i2;
        HEAP32[i19 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i20 >> 2] = i6;
      HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
    }
   }
   i1 = HEAP32[i13 + (i14 * 48 | 0) + 24 >> 2] | 0;
   while (1) {
    i3 = HEAP8[i1 >> 0] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i3;
    if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   }
   i1 = HEAP32[i13 + (i14 * 48 | 0) + 28 >> 2] | 0;
   while (1) {
    i3 = HEAP8[i1 >> 0] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i3;
    if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   }
   i3 = i13 + (i14 * 48 | 0) + 32 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 8);
   i3 = i13 + (i14 * 48 | 0) + 40 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i13 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i13;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
  i1 = 0;
 }
 do {
  i3 = gb + 66332 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i11 = i18 + 24 | 0;
 i1 = 0;
 do {
  i3 = i11 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (HEAP32[i11 >> 2] | 0) {
  i4 = i18 + 28 | 0;
  i1 = 0;
  do {
   i5 = (HEAP32[i4 >> 2] | 0) + (i1 << 3) | 0;
   i2 = 0;
   do {
    i6 = i5 + i2 | 0;
    i7 = HEAP32[i20 >> 2] | 0;
    i8 = i7 + 1 | 0;
    i9 = HEAP32[i21 >> 2] | 0;
    i10 = i9 & 2147483647;
    do if (i8 >>> 0 > i10 >>> 0) {
     i3 = i9 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
      HEAP32[i21 >> 2] = i3;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i3, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i3;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i8;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i7 >> 0] = HEAP8[i6 >> 0] | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 8);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 i12 = i18 + 56 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i1 = 0;
 do {
  i3 = gb + 66336 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i11 = i8 + 8 | 0;
 i1 = 0;
 do {
  i3 = i11 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (HEAP32[i11 >> 2] | 0) {
  i10 = i8 + 12 | 0;
  i9 = 0;
  do {
   i3 = (HEAP32[i10 >> 2] | 0) + (i9 * 12 | 0) | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = (HEAP32[i10 >> 2] | 0) + (i9 * 12 | 0) + 4 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i9 * 12 | 0) + 8 >> 2] | 0;
   while (1) {
    i3 = HEAP8[i1 >> 0] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i3;
    if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 i14 = HEAP32[i12 >> 2] | 0;
 i1 = 0;
 do {
  i3 = gb + 66340 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  i3 = i14 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (!(HEAP32[i14 >> 2] | 0)) i1 = 0; else {
  i13 = i14 + 4 | 0;
  i12 = 0;
  do {
   i9 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i9 + (i12 * 48 | 0) >> 2] | 0;
   while (1) {
    i3 = HEAP8[i1 >> 0] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i3;
    if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   }
   i3 = i9 + (i12 * 48 | 0) + 4 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i9 + (i12 * 48 | 0) + 8 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i9 + (i12 * 48 | 0) + 12 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i9 + (i12 * 48 | 0) + 16 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   HEAP32[i17 >> 2] = HEAP32[i9 + (i12 * 48 | 0) + 20 >> 2];
   i1 = 0;
   do {
    i3 = i17 + i1 | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i9 + (i12 * 48 | 0) + 24 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 8);
   i3 = i9 + (i12 * 48 | 0) + 32 | 0;
   i1 = 0;
   do {
    i4 = i3 + i1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i6;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i11 = i9 + (i12 * 48 | 0) + 36 | 0;
   i1 = 0;
   do {
    i3 = i11 + i1 | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i21 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i19 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i20 >> 2] = i5;
    HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   if (HEAP32[i11 >> 2] | 0) {
    i4 = i9 + (i12 * 48 | 0) + 40 | 0;
    i2 = 0;
    do {
     i5 = (HEAP32[i4 >> 2] | 0) + (i2 << 2) | 0;
     i1 = 0;
     do {
      i6 = i5 + i1 | 0;
      i7 = HEAP32[i20 >> 2] | 0;
      i8 = i7 + 1 | 0;
      i9 = HEAP32[i21 >> 2] | 0;
      i10 = i9 & 2147483647;
      do if (i8 >>> 0 > i10 >>> 0) {
       i3 = i9 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
        HEAP32[i21 >> 2] = i3;
        HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i3, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
        HEAP32[i21 >> 2] = i3;
        HEAP32[i19 >> 2] = i16;
        break;
       }
      } while (0);
      HEAP32[i20 >> 2] = i8;
      HEAP8[(HEAP32[i19 >> 2] | 0) + i7 >> 0] = HEAP8[i6 >> 0] | 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 4);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
   }
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
  i1 = 0;
 }
 do {
  i3 = gb + 66344 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 32 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 36 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 40 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 44 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 48 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i3 = i18 + 52 | 0;
 i1 = 0;
 do {
  i4 = i3 + i1 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i18 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i18;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i6;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  i3 = gb + 66348 + i1 | 0;
  i4 = HEAP32[i20 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i21 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2, 1, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i18 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i19 >> 2] = i18;
    break;
   }
  } while (0);
  HEAP32[i20 >> 2] = i5;
  HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 STACKTOP = i23;
 return;
}

function __ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i157, f158, f160, i12, i13) {
 i157 = i157 | 0;
 f158 = Math_fround(f158);
 f160 = Math_fround(f160);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i159 = 0, i161 = 0, i162 = 0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, f167 = f0, f168 = f0, f169 = f0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, f202 = f0, f203 = f0, f204 = f0, f205 = f0, f206 = f0;
 i162 = STACKTOP;
 STACKTOP = STACKTOP + 4176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i161 = i162;
 i11 = i162 + 16 | 0;
 i156 = i162 + 3984 | 0;
 i27 = i162 + 3936 | 0;
 i14 = i162 + 3872 | 0;
 i159 = i162 + 3856 | 0;
 HEAP32[i161 >> 2] = 0;
 HEAP32[i161 + 4 >> 2] = 0;
 HEAP32[i161 + 8 >> 2] = 0;
 HEAP32[i161 + 12 >> 2] = 0;
 i16 = i27 + 4 | 0;
 i17 = i27 + 8 | 0;
 i19 = i27 + 12 | 0;
 i20 = i27 + 16 | 0;
 i21 = i27 + 20 | 0;
 i22 = i27 + 24 | 0;
 i23 = i27 + 28 | 0;
 i24 = i27 + 32 | 0;
 i25 = i27 + 36 | 0;
 i26 = i27 + 40 | 0;
 i18 = i27 + 44 | 0;
 i5 = i27;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i5 = i14;
 i1 = gb + 106292 | 0;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i9 = 0;
 i1 = 0;
 i10 = 0;
 i2 = 0;
 while (1) {
  i8 = i11 + (i10 * 80 | 0) | 0;
  i7 = HEAP32[i157 + (i9 * 52 | 0) + 28 >> 2] | 0;
  if (!i7) {
   i1 = 1;
   i2 = 84;
   break;
  }
  if (i2 >>> 0 < 12) do {
   i3 = i2 + i10 | 0;
   HEAP32[i11 + (i3 * 80 | 0) + 48 >> 2] = 0;
   HEAP32[i11 + (i3 * 80 | 0) + 52 >> 2] = 0;
   HEAP32[i11 + (i3 * 80 | 0) + 56 >> 2] = 0;
   HEAPF32[i11 + (i3 * 80 | 0) + 72 >> 2] = Math_fround(0.0);
   i4 = i11 + (i3 * 80 | 0) + 44 | 0;
   i5 = i11 + (i3 * 80 | 0) | 0;
   i6 = i5 + 44 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i6 | 0));
   HEAPF32[i4 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i11 + (i3 * 80 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i11 + (i3 * 80 | 0) + 64 >> 2] = Math_fround(0.0);
   HEAPF32[i11 + (i3 * 80 | 0) + 68 >> 2] = Math_fround(0.0);
   HEAP16[i11 + (i3 * 80 | 0) + 76 >> 1] = 0;
   HEAP16[i11 + (i3 * 80 | 0) + 78 >> 1] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 12);
  i3 = i14 + (i9 << 4) | 0;
  i2 = mftCall_iiiiiiii(i7 | 0, i8 | 0, i27 + (i9 * 12 | 0) | 0, 12, i3 | 0, HEAP32[i157 + (i9 * 52 | 0) + 32 >> 2] | 0, HEAP32[i157 + (i9 * 52 | 0) + 4 >> 2] | 0, HEAP32[i157 + (i9 * 52 | 0) + 8 >> 2] | 0) | 0;
  if (!i2) {
   i1 = 1;
   i2 = 84;
   break;
  }
  i1 = i2 >>> 0 < i1 >>> 0 ? i1 : i2;
  HEAP32[i157 + (i9 * 52 | 0) + 44 >> 2] = i10;
  HEAP32[i157 + (i9 * 52 | 0) + 48 >> 2] = i2;
  i155 = HEAP32[(HEAP32[i157 + (i9 * 52 | 0) >> 2] | 0) + 52 >> 2] | 0;
  __ZN5physx14preprocessRowsEPPNS_14Px1DConstraintES1_jRKNS_17PxcSolverBodyDataES5_RKNS_24PxConstraintInvMassScaleEbb(i156 + (i10 << 2) | 0, i8, i2, HEAP32[i157 + (i9 * 52 | 0) + 20 >> 2] | 0, HEAP32[i157 + (i9 * 52 | 0) + 24 >> 2] | 0, i3, (i155 & 512 | 0) != 0, (i155 & 256 | 0) != 0);
  i9 = i9 + 1 | 0;
  if (i9 >>> 0 >= 4) {
   i154 = i1;
   i2 = 7;
   break;
  } else {
   i10 = i2 + i10 | 0;
   i2 = 12 - i2 | 0;
  }
 }
 if ((i2 | 0) == 7) {
  i153 = i154 * 416 | 0;
  i155 = i153 + 128 | 0;
  i2 = i153 + 159 & -16;
  do if (i2 >>> 0 > 16384) i152 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i12 >> 2] | 0, i2) | 0; else {
   i3 = i12 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = i12 + 8 | 0;
   if (i4 | 0) {
    i5 = HEAP32[i1 >> 2] | 0;
    i6 = i5 + i2 | 0;
    if (i6 >>> 0 <= 16384) {
     HEAP32[i1 >> 2] = i6;
     i152 = i4 + i5 | 0;
     break;
    }
   }
   i152 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i12 >> 2] | 0, i13) | 0;
   HEAP32[i3 >> 2] = i152;
   HEAP32[i1 >> 2] = i2;
  } while (0);
  switch (i152 | 0) {
  case 0:
  case -1:
   {
    i161 = HEAP32[i157 + 40 >> 2] | 0;
    HEAP32[i161 + 16 >> 2] = 0;
    HEAP16[i161 + 26 >> 1] = 0;
    HEAP32[i161 + 20 >> 2] = HEAP32[(HEAP32[i157 >> 2] | 0) + 32 >> 2];
    i161 = HEAP32[i157 + 92 >> 2] | 0;
    HEAP32[i161 + 16 >> 2] = 0;
    HEAP16[i161 + 26 >> 1] = 0;
    HEAP32[i161 + 20 >> 2] = HEAP32[(HEAP32[i157 + 52 >> 2] | 0) + 32 >> 2];
    i161 = HEAP32[i157 + 144 >> 2] | 0;
    HEAP32[i161 + 16 >> 2] = 0;
    HEAP16[i161 + 26 >> 1] = 0;
    HEAP32[i161 + 20 >> 2] = HEAP32[(HEAP32[i157 + 104 >> 2] | 0) + 32 >> 2];
    i161 = HEAP32[i157 + 196 >> 2] | 0;
    HEAP32[i161 + 16 >> 2] = 0;
    HEAP16[i161 + 26 >> 1] = 0;
    HEAP32[i161 + 20 >> 2] = HEAP32[(HEAP32[i157 + 156 >> 2] | 0) + 32 >> 2];
    i161 = 0;
    STACKTOP = i162;
    return i161 | 0;
   }
  default:
   {}
  }
  i140 = i155 >>> 4 & 65535;
  i53 = HEAP32[i157 + 40 >> 2] | 0;
  HEAP32[i53 + 16 >> 2] = i152;
  HEAP16[i53 + 26 >> 1] = i140;
  i141 = HEAP32[i157 >> 2] | 0;
  HEAP32[i53 + 20 >> 2] = HEAP32[i141 + 32 >> 2];
  i53 = HEAP32[i157 + 92 >> 2] | 0;
  HEAP32[i53 + 16 >> 2] = i152;
  HEAP16[i53 + 26 >> 1] = i140;
  i138 = i157 + 52 | 0;
  i142 = HEAP32[i138 >> 2] | 0;
  HEAP32[i53 + 20 >> 2] = HEAP32[i142 + 32 >> 2];
  i53 = HEAP32[i157 + 144 >> 2] | 0;
  HEAP32[i53 + 16 >> 2] = i152;
  HEAP16[i53 + 26 >> 1] = i140;
  i139 = i157 + 104 | 0;
  i143 = HEAP32[i139 >> 2] | 0;
  HEAP32[i53 + 20 >> 2] = HEAP32[i143 + 32 >> 2];
  i53 = HEAP32[i157 + 196 >> 2] | 0;
  HEAP32[i53 + 16 >> 2] = i152;
  HEAP16[i53 + 26 >> 1] = i140;
  i140 = i157 + 156 | 0;
  i1 = HEAP32[i140 >> 2] | 0;
  HEAP32[i53 + 20 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAPF32[i159 >> 2] = HEAP32[i141 + 52 >> 2] & 128 | 0 ? Math_fround(.699999988) : Math_fround(1.0);
  i141 = i159 + 4 | 0;
  HEAPF32[i141 >> 2] = HEAP32[i142 + 52 >> 2] & 128 | 0 ? Math_fround(.699999988) : Math_fround(1.0);
  i142 = i159 + 8 | 0;
  HEAPF32[i142 >> 2] = HEAP32[i143 + 52 >> 2] & 128 | 0 ? Math_fround(.699999988) : Math_fround(1.0);
  i143 = i159 + 12 | 0;
  HEAPF32[i143 >> 2] = HEAP32[i1 + 52 >> 2] & 128 | 0 ? Math_fround(.699999988) : Math_fround(1.0);
  i1 = i152 + 128 | 0;
  i53 = HEAP32[i157 + 20 >> 2] | 0;
  i3 = HEAP32[i157 + 72 >> 2] | 0;
  i48 = HEAP32[i157 + 124 >> 2] | 0;
  i50 = HEAP32[i157 + 176 >> 2] | 0;
  i4 = HEAP32[i157 + 24 >> 2] | 0;
  i52 = HEAP32[i157 + 76 >> 2] | 0;
  i54 = HEAP32[i157 + 128 >> 2] | 0;
  i65 = HEAP32[i157 + 180 >> 2] | 0;
  f150 = Math_fround(HEAPF32[i14 >> 2]);
  f149 = Math_fround(HEAPF32[i14 + 16 >> 2]);
  f148 = Math_fround(HEAPF32[i14 + 32 >> 2]);
  f147 = Math_fround(HEAPF32[i14 + 48 >> 2]);
  f32 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f33 = Math_fround(HEAPF32[i14 + 24 >> 2]);
  f36 = Math_fround(HEAPF32[i14 + 40 >> 2]);
  f151 = Math_fround(HEAPF32[i14 + 56 >> 2]);
  f144 = Math_fround(HEAPF32[i53 + 48 >> 2]);
  f145 = Math_fround(HEAPF32[i3 + 48 >> 2]);
  f146 = Math_fround(HEAPF32[i48 + 48 >> 2]);
  f144 = Math_fround(f150 * f144);
  f145 = Math_fround(f149 * f145);
  f146 = Math_fround(f148 * f146);
  f147 = Math_fround(f147 * Math_fround(HEAPF32[i50 + 48 >> 2]));
  f148 = Math_fround(HEAPF32[i4 + 48 >> 2]);
  f149 = Math_fround(HEAPF32[i52 + 48 >> 2]);
  f150 = Math_fround(HEAPF32[i54 + 48 >> 2]);
  f148 = Math_fround(-Math_fround(f32 * f148));
  f149 = Math_fround(-Math_fround(f33 * f149));
  f150 = Math_fround(-Math_fround(f36 * f150));
  f151 = Math_fround(-Math_fround(f151 * Math_fround(HEAPF32[i65 + 48 >> 2])));
  f36 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i14 + 20 >> 2]);
  f32 = Math_fround(HEAPF32[i14 + 36 >> 2]);
  f31 = Math_fround(HEAPF32[i14 + 52 >> 2]);
  f30 = Math_fround(HEAPF32[i14 + 12 >> 2]);
  f29 = Math_fround(HEAPF32[i14 + 28 >> 2]);
  f28 = Math_fround(HEAPF32[i14 + 44 >> 2]);
  f137 = Math_fround(HEAPF32[i14 + 60 >> 2]);
  f66 = Math_fround(HEAPF32[i53 >> 2]);
  f70 = Math_fround(HEAPF32[i53 + 4 >> 2]);
  f74 = Math_fround(HEAPF32[i53 + 8 >> 2]);
  f78 = Math_fround(HEAPF32[i53 + 12 >> 2]);
  f82 = Math_fround(HEAPF32[i53 + 16 >> 2]);
  f86 = Math_fround(HEAPF32[i53 + 20 >> 2]);
  f90 = Math_fround(HEAPF32[i53 + 24 >> 2]);
  f94 = Math_fround(HEAPF32[i53 + 28 >> 2]);
  f98 = Math_fround(HEAPF32[i53 + 32 >> 2]);
  f67 = Math_fround(HEAPF32[i3 >> 2]);
  f71 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f75 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f79 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f83 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f87 = Math_fround(HEAPF32[i3 + 20 >> 2]);
  f91 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  f95 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f99 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f68 = Math_fround(HEAPF32[i48 >> 2]);
  f72 = Math_fround(HEAPF32[i48 + 4 >> 2]);
  f76 = Math_fround(HEAPF32[i48 + 8 >> 2]);
  f80 = Math_fround(HEAPF32[i48 + 12 >> 2]);
  f84 = Math_fround(HEAPF32[i48 + 16 >> 2]);
  f88 = Math_fround(HEAPF32[i48 + 20 >> 2]);
  f92 = Math_fround(HEAPF32[i48 + 24 >> 2]);
  f96 = Math_fround(HEAPF32[i48 + 28 >> 2]);
  f100 = Math_fround(HEAPF32[i48 + 32 >> 2]);
  f69 = Math_fround(HEAPF32[i50 >> 2]);
  f73 = Math_fround(HEAPF32[i50 + 4 >> 2]);
  f77 = Math_fround(HEAPF32[i50 + 8 >> 2]);
  f81 = Math_fround(HEAPF32[i50 + 12 >> 2]);
  f85 = Math_fround(HEAPF32[i50 + 16 >> 2]);
  f89 = Math_fround(HEAPF32[i50 + 20 >> 2]);
  f93 = Math_fround(HEAPF32[i50 + 24 >> 2]);
  f97 = Math_fround(HEAPF32[i50 + 28 >> 2]);
  f101 = Math_fround(HEAPF32[i50 + 32 >> 2]);
  f102 = Math_fround(HEAPF32[i4 >> 2]);
  f106 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f110 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f114 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f118 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f122 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f126 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f130 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f134 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f103 = Math_fround(HEAPF32[i52 >> 2]);
  f107 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i52 + 8 >> 2]);
  f115 = Math_fround(HEAPF32[i52 + 12 >> 2]);
  f119 = Math_fround(HEAPF32[i52 + 16 >> 2]);
  f123 = Math_fround(HEAPF32[i52 + 20 >> 2]);
  f127 = Math_fround(HEAPF32[i52 + 24 >> 2]);
  f131 = Math_fround(HEAPF32[i52 + 28 >> 2]);
  f135 = Math_fround(HEAPF32[i52 + 32 >> 2]);
  f104 = Math_fround(HEAPF32[i54 >> 2]);
  f108 = Math_fround(HEAPF32[i54 + 4 >> 2]);
  f112 = Math_fround(HEAPF32[i54 + 8 >> 2]);
  f116 = Math_fround(HEAPF32[i54 + 12 >> 2]);
  f120 = Math_fround(HEAPF32[i54 + 16 >> 2]);
  f124 = Math_fround(HEAPF32[i54 + 20 >> 2]);
  f128 = Math_fround(HEAPF32[i54 + 24 >> 2]);
  f132 = Math_fround(HEAPF32[i54 + 28 >> 2]);
  f136 = Math_fround(HEAPF32[i54 + 32 >> 2]);
  f105 = Math_fround(HEAPF32[i65 >> 2]);
  f109 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f113 = Math_fround(HEAPF32[i65 + 8 >> 2]);
  f117 = Math_fround(HEAPF32[i65 + 12 >> 2]);
  f121 = Math_fround(HEAPF32[i65 + 16 >> 2]);
  f125 = Math_fround(HEAPF32[i65 + 20 >> 2]);
  f129 = Math_fround(HEAPF32[i65 + 24 >> 2]);
  f133 = Math_fround(HEAPF32[i65 + 28 >> 2]);
  f66 = Math_fround(f36 * f66);
  f67 = Math_fround(f33 * f67);
  f68 = Math_fround(f32 * f68);
  f69 = Math_fround(f31 * f69);
  f70 = Math_fround(f36 * f70);
  f71 = Math_fround(f33 * f71);
  f72 = Math_fround(f32 * f72);
  f73 = Math_fround(f31 * f73);
  f74 = Math_fround(f36 * f74);
  f75 = Math_fround(f33 * f75);
  f76 = Math_fround(f32 * f76);
  f77 = Math_fround(f31 * f77);
  f78 = Math_fround(f36 * f78);
  f79 = Math_fround(f33 * f79);
  f80 = Math_fround(f32 * f80);
  f81 = Math_fround(f31 * f81);
  f82 = Math_fround(f36 * f82);
  f83 = Math_fround(f33 * f83);
  f84 = Math_fround(f32 * f84);
  f85 = Math_fround(f31 * f85);
  f86 = Math_fround(f36 * f86);
  f87 = Math_fround(f33 * f87);
  f88 = Math_fround(f32 * f88);
  f89 = Math_fround(f31 * f89);
  f90 = Math_fround(f36 * f90);
  f91 = Math_fround(f33 * f91);
  f92 = Math_fround(f32 * f92);
  f93 = Math_fround(f31 * f93);
  f94 = Math_fround(f36 * f94);
  f95 = Math_fround(f33 * f95);
  f96 = Math_fround(f32 * f96);
  f97 = Math_fround(f31 * f97);
  f98 = Math_fround(f36 * f98);
  f99 = Math_fround(f33 * f99);
  f100 = Math_fround(f32 * f100);
  f101 = Math_fround(f31 * f101);
  f102 = Math_fround(f30 * f102);
  f103 = Math_fround(f29 * f103);
  f104 = Math_fround(f28 * f104);
  f105 = Math_fround(f137 * f105);
  f106 = Math_fround(f30 * f106);
  f107 = Math_fround(f29 * f107);
  f108 = Math_fround(f28 * f108);
  f109 = Math_fround(f137 * f109);
  f110 = Math_fround(f30 * f110);
  f111 = Math_fround(f29 * f111);
  f112 = Math_fround(f28 * f112);
  f113 = Math_fround(f137 * f113);
  f114 = Math_fround(f30 * f114);
  f115 = Math_fround(f29 * f115);
  f116 = Math_fround(f28 * f116);
  f117 = Math_fround(f137 * f117);
  f118 = Math_fround(f30 * f118);
  f119 = Math_fround(f29 * f119);
  f120 = Math_fround(f28 * f120);
  f121 = Math_fround(f137 * f121);
  f122 = Math_fround(f30 * f122);
  f123 = Math_fround(f29 * f123);
  f124 = Math_fround(f28 * f124);
  f125 = Math_fround(f137 * f125);
  f126 = Math_fround(f30 * f126);
  f127 = Math_fround(f29 * f127);
  f128 = Math_fround(f28 * f128);
  f129 = Math_fround(f137 * f129);
  f130 = Math_fround(f30 * f130);
  f131 = Math_fround(f29 * f131);
  f132 = Math_fround(f28 * f132);
  f133 = Math_fround(f137 * f133);
  f134 = Math_fround(f30 * f134);
  f135 = Math_fround(f29 * f135);
  f136 = Math_fround(f28 * f136);
  f137 = Math_fround(f137 * Math_fround(HEAPF32[i65 + 32 >> 2]));
  i65 = HEAP32[i27 >> 2] | 0;
  i54 = HEAP32[i16 >> 2] | 0;
  i52 = HEAP32[i17 >> 2] | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  i50 = HEAP32[i20 >> 2] | 0;
  i48 = HEAP32[i21 >> 2] | 0;
  i3 = HEAP32[i22 >> 2] | 0;
  i53 = HEAP32[i23 >> 2] | 0;
  i51 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i25 >> 2] | 0;
  i49 = HEAP32[i26 >> 2] | 0;
  i47 = HEAP32[i18 >> 2] | 0;
  i61 = HEAP32[i157 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i61 >> 2]);
  i62 = HEAP32[i138 >> 2] | 0;
  f29 = Math_fround(HEAPF32[i62 >> 2]);
  i63 = HEAP32[i139 >> 2] | 0;
  f30 = Math_fround(HEAPF32[i63 >> 2]);
  i64 = HEAP32[i140 >> 2] | 0;
  f31 = Math_fround(HEAPF32[i64 >> 2]);
  f32 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f57 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  HEAPF32[i152 + 48 >> 2] = f144;
  HEAPF32[i152 + 52 >> 2] = f145;
  HEAPF32[i152 + 56 >> 2] = f146;
  HEAPF32[i152 + 60 >> 2] = f147;
  HEAPF32[i152 + 64 >> 2] = f148;
  HEAPF32[i152 + 68 >> 2] = f149;
  HEAPF32[i152 + 72 >> 2] = f150;
  HEAPF32[i152 + 76 >> 2] = f151;
  HEAP32[i152 + 80 >> 2] = i65;
  HEAP32[i152 + 84 >> 2] = i4;
  HEAP32[i152 + 88 >> 2] = i3;
  HEAP32[i152 + 92 >> 2] = i2;
  HEAP32[i152 + 96 >> 2] = i54;
  HEAP32[i152 + 100 >> 2] = i50;
  HEAP32[i152 + 104 >> 2] = i53;
  HEAP32[i152 + 108 >> 2] = i49;
  HEAP32[i152 + 112 >> 2] = i52;
  HEAP32[i152 + 116 >> 2] = i48;
  HEAP32[i152 + 120 >> 2] = i51;
  HEAP32[i152 + 124 >> 2] = i47;
  HEAP32[i152 + 4 >> 2] = i154;
  HEAP8[i152 >> 0] = 9;
  f29 = Math_fround(f29 * f158);
  f30 = Math_fround(f30 * f158);
  f31 = Math_fround(f31 * f158);
  HEAPF32[i152 + 16 >> 2] = Math_fround(f28 * f158);
  HEAPF32[i152 + 20 >> 2] = f29;
  HEAPF32[i152 + 24 >> 2] = f30;
  HEAPF32[i152 + 28 >> 2] = f31;
  f33 = Math_fround(f33 * f158);
  f36 = Math_fround(f36 * f158);
  f57 = Math_fround(f57 * f158);
  HEAPF32[i152 + 32 >> 2] = Math_fround(f32 * f158);
  HEAPF32[i152 + 36 >> 2] = f33;
  HEAPF32[i152 + 40 >> 2] = f36;
  HEAPF32[i152 + 44 >> 2] = f57;
  i47 = i157 + 48 | 0;
  i51 = HEAP32[i47 >> 2] | 0;
  HEAP8[i152 + 8 >> 0] = i51;
  i48 = i157 + 100 | 0;
  i52 = HEAP32[i48 >> 2] | 0;
  HEAP8[i152 + 9 >> 0] = i52;
  i49 = i157 + 152 | 0;
  i53 = HEAP32[i49 >> 2] | 0;
  HEAP8[i152 + 10 >> 0] = i53;
  i50 = i157 + 204 | 0;
  i54 = HEAP32[i50 >> 2] | 0;
  HEAP8[i152 + 11 >> 0] = i54;
  i51 = i51 + -1 | 0;
  i2 = HEAP32[i157 + 96 >> 2] | 0;
  i52 = i2 + -1 + i52 | 0;
  i3 = HEAP32[i157 + 148 >> 2] | 0;
  i53 = i3 + -1 + i53 | 0;
  i4 = HEAP32[i157 + 200 >> 2] | 0;
  i54 = i4 + -1 + i54 | 0;
  if (!i154) i2 = 132; else {
   i55 = i157 + 12 | 0;
   i56 = i157 + 16 | 0;
   f57 = Math_fround(f158 * f158);
   i58 = i157 + 64 | 0;
   i59 = i157 + 68 | 0;
   i60 = i157 + 116 | 0;
   i61 = i157 + 120 | 0;
   i62 = i157 + 168 | 0;
   i63 = i157 + 172 | 0;
   i65 = f158 < Math_fround(1.0);
   i64 = i65 ? (HEAPF32[tempDoublePtr >> 2] = f158, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
   i65 = 0;
   i46 = 0;
   do {
    i26 = i1;
    i1 = i1 + 416 | 0;
    i17 = HEAP32[i156 + (i46 << 2) >> 2] | 0;
    i21 = HEAP32[i156 + (i2 << 2) >> 2] | 0;
    i25 = HEAP32[i156 + (i3 << 2) >> 2] | 0;
    i37 = HEAP32[i156 + (i4 << 2) >> 2] | 0;
    i46 = ((i46 | 0) != (i51 | 0) & 1) + i46 | 0;
    i2 = ((i2 | 0) != (i52 | 0) & 1) + i2 | 0;
    i3 = ((i3 | 0) != (i53 | 0) & 1) + i3 | 0;
    i4 = ((i4 | 0) != (i54 | 0) & 1) + i4 | 0;
    i38 = i17 + 76 | 0;
    if (!(HEAP16[i38 >> 1] & 32)) i5 = 1065353216; else i5 = (HEAP32[(HEAP32[i157 >> 2] | 0) + 52 >> 2] & 64 | 0) == 0 ? 1065353216 : i64;
    i39 = i21 + 76 | 0;
    if (!(HEAP16[i39 >> 1] & 32)) i6 = 1065353216; else i6 = (HEAP32[(HEAP32[i138 >> 2] | 0) + 52 >> 2] & 64 | 0) == 0 ? 1065353216 : i64;
    i40 = i25 + 76 | 0;
    if (!(HEAP16[i40 >> 1] & 32)) i7 = 1065353216; else i7 = (HEAP32[(HEAP32[i139 >> 2] | 0) + 52 >> 2] & 64 | 0) == 0 ? 1065353216 : i64;
    i41 = i37 + 76 | 0;
    if (!(HEAP16[i41 >> 1] & 32)) i8 = 1065353216; else i8 = (HEAP32[(HEAP32[i140 >> 2] | 0) + 52 >> 2] & 64 | 0) == 0 ? 1065353216 : i64;
    i27 = HEAP32[i17 >> 2] | 0;
    i22 = HEAP32[i17 + 4 >> 2] | 0;
    i18 = HEAP32[i17 + 8 >> 2] | 0;
    i184 = HEAP32[i21 >> 2] | 0;
    i185 = HEAP32[i21 + 4 >> 2] | 0;
    i186 = HEAP32[i21 + 8 >> 2] | 0;
    i188 = HEAP32[i25 >> 2] | 0;
    i189 = HEAP32[i25 + 4 >> 2] | 0;
    i190 = HEAP32[i25 + 8 >> 2] | 0;
    i192 = HEAP32[i37 >> 2] | 0;
    i193 = HEAP32[i37 + 4 >> 2] | 0;
    i194 = HEAP32[i37 + 8 >> 2] | 0;
    i10 = i17 + 16 | 0;
    i180 = HEAP32[i10 >> 2] | 0;
    i181 = HEAP32[i10 + 4 >> 2] | 0;
    i182 = HEAP32[i10 + 8 >> 2] | 0;
    i20 = i21 + 16 | 0;
    i23 = HEAP32[i20 >> 2] | 0;
    i19 = HEAP32[i20 + 4 >> 2] | 0;
    i183 = HEAP32[i20 + 8 >> 2] | 0;
    i24 = i25 + 16 | 0;
    i11 = HEAP32[i24 >> 2] | 0;
    i12 = HEAP32[i24 + 4 >> 2] | 0;
    i187 = HEAP32[i24 + 8 >> 2] | 0;
    i35 = i37 + 16 | 0;
    i13 = HEAP32[i35 >> 2] | 0;
    i9 = HEAP32[i35 + 4 >> 2] | 0;
    i191 = HEAP32[i35 + 8 >> 2] | 0;
    f198 = Math_fround(HEAPF32[i17 + 60 >> 2]);
    f164 = Math_fround(HEAPF32[i21 + 60 >> 2]);
    f196 = Math_fround(HEAPF32[i25 + 60 >> 2]);
    f166 = Math_fround(HEAPF32[i37 + 60 >> 2]);
    f174 = Math_fround(HEAPF32[i17 + 44 >> 2]);
    f172 = Math_fround(HEAPF32[i21 + 44 >> 2]);
    f170 = Math_fround(HEAPF32[i25 + 44 >> 2]);
    f168 = Math_fround(HEAPF32[i37 + 44 >> 2]);
    i42 = i26 + 256 | 0;
    i43 = i26 + 260 | 0;
    i44 = i26 + 264 | 0;
    i45 = i26 + 268 | 0;
    HEAP32[i42 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 0;
    HEAP32[i42 + 8 >> 2] = 0;
    HEAP32[i42 + 12 >> 2] = 0;
    HEAP32[i26 >> 2] = i27;
    HEAP32[i26 + 4 >> 2] = i184;
    HEAP32[i26 + 8 >> 2] = i188;
    HEAP32[i26 + 12 >> 2] = i192;
    HEAP32[i26 + 16 >> 2] = i22;
    HEAP32[i26 + 20 >> 2] = i185;
    HEAP32[i26 + 24 >> 2] = i189;
    HEAP32[i26 + 28 >> 2] = i193;
    HEAP32[i26 + 32 >> 2] = i18;
    HEAP32[i26 + 36 >> 2] = i186;
    HEAP32[i26 + 40 >> 2] = i190;
    HEAP32[i26 + 44 >> 2] = i194;
    HEAP32[i26 + 48 >> 2] = i180;
    HEAP32[i26 + 52 >> 2] = i23;
    HEAP32[i26 + 56 >> 2] = i11;
    HEAP32[i26 + 60 >> 2] = i13;
    HEAP32[i26 + 64 >> 2] = i181;
    HEAP32[i26 + 68 >> 2] = i19;
    HEAP32[i26 + 72 >> 2] = i12;
    HEAP32[i26 + 76 >> 2] = i9;
    HEAP32[i26 + 80 >> 2] = i182;
    HEAP32[i26 + 84 >> 2] = i183;
    HEAP32[i26 + 88 >> 2] = i187;
    HEAP32[i26 + 92 >> 2] = i191;
    f15 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f174 = Math_fround(f15 * f174);
    f202 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f172 = Math_fround(f202 * f172);
    f30 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f170 = Math_fround(f30 * f170);
    f200 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f168 = Math_fround(f200 * f168);
    HEAPF32[i26 + 208 >> 2] = f174;
    HEAPF32[i26 + 212 >> 2] = f172;
    HEAPF32[i26 + 216 >> 2] = f170;
    HEAPF32[i26 + 220 >> 2] = f168;
    f164 = Math_fround(f202 * f164);
    f196 = Math_fround(f30 * f196);
    f166 = Math_fround(f200 * f166);
    HEAPF32[i26 + 224 >> 2] = Math_fround(f15 * f198);
    HEAPF32[i26 + 228 >> 2] = f164;
    HEAPF32[i26 + 232 >> 2] = f196;
    HEAPF32[i26 + 236 >> 2] = f166;
    i7 = i26 + 240 | 0;
    HEAP32[i7 >> 2] = HEAP32[i161 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i161 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i161 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i161 + 12 >> 2];
    f166 = (HEAP32[tempDoublePtr >> 2] = i180, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f196 = Math_fround(f66 * f166);
    f164 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f198 = Math_fround(f67 * f164);
    f15 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f200 = Math_fround(f68 * f15);
    f30 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f202 = Math_fround(f69 * f30);
    f168 = (HEAP32[tempDoublePtr >> 2] = i181, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f170 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f172 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f174 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f196 = Math_fround(f196 + Math_fround(f78 * f168));
    f198 = Math_fround(f198 + Math_fround(f79 * f170));
    f200 = Math_fround(f200 + Math_fround(f80 * f172));
    f202 = Math_fround(f202 + Math_fround(f81 * f174));
    f167 = (HEAP32[tempDoublePtr >> 2] = i182, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f169 = (HEAP32[tempDoublePtr >> 2] = i183, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f171 = (HEAP32[tempDoublePtr >> 2] = i187, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f173 = (HEAP32[tempDoublePtr >> 2] = i191, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f196 = Math_fround(Math_fround(f90 * f167) + f196);
    f198 = Math_fround(Math_fround(f91 * f169) + f198);
    f200 = Math_fround(Math_fround(f92 * f171) + f200);
    f202 = Math_fround(Math_fround(f93 * f173) + f202);
    f195 = Math_fround(Math_fround(f94 * f167) + Math_fround(Math_fround(f70 * f166) + Math_fround(f82 * f168)));
    f197 = Math_fround(Math_fround(f95 * f169) + Math_fround(Math_fround(f71 * f164) + Math_fround(f83 * f170)));
    f199 = Math_fround(Math_fround(f96 * f171) + Math_fround(Math_fround(f72 * f15) + Math_fround(f84 * f172)));
    f201 = Math_fround(Math_fround(f97 * f173) + Math_fround(Math_fround(f73 * f30) + Math_fround(f85 * f174)));
    f175 = Math_fround(Math_fround(f98 * f167) + Math_fround(Math_fround(f74 * f166) + Math_fround(f86 * f168)));
    f28 = Math_fround(Math_fround(f99 * f169) + Math_fround(Math_fround(f75 * f164) + Math_fround(f87 * f170)));
    f176 = Math_fround(Math_fround(f100 * f171) + Math_fround(Math_fround(f76 * f15) + Math_fround(f88 * f172)));
    f29 = Math_fround(Math_fround(f101 * f173) + Math_fround(Math_fround(f77 * f30) + Math_fround(f89 * f174)));
    f203 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f203 = Math_fround(f203 * f203);
    f204 = (HEAP32[tempDoublePtr >> 2] = i184, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f204 = Math_fround(f204 * f204);
    f205 = (HEAP32[tempDoublePtr >> 2] = i188, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f205 = Math_fround(f205 * f205);
    f206 = (HEAP32[tempDoublePtr >> 2] = i192, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f206 = Math_fround(f206 * f206);
    f177 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f163 = (HEAP32[tempDoublePtr >> 2] = i185, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = (HEAP32[tempDoublePtr >> 2] = i189, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f165 = (HEAP32[tempDoublePtr >> 2] = i193, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f177 = Math_fround(f203 + Math_fround(f177 * f177));
    f163 = Math_fround(f204 + Math_fround(f163 * f163));
    f178 = Math_fround(f205 + Math_fround(f178 * f178));
    f165 = Math_fround(f206 + Math_fround(f165 * f165));
    f206 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f205 = (HEAP32[tempDoublePtr >> 2] = i186, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f204 = (HEAP32[tempDoublePtr >> 2] = i190, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f203 = (HEAP32[tempDoublePtr >> 2] = i194, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f177 = Math_fround(Math_fround(f206 * f206) + f177);
    f163 = Math_fround(Math_fround(f205 * f205) + f163);
    f178 = Math_fround(Math_fround(f204 * f204) + f178);
    f165 = Math_fround(Math_fround(f203 * f203) + f165);
    f166 = Math_fround(Math_fround(f167 * f175) + Math_fround(Math_fround(f168 * f195) + Math_fround(f166 * f196)));
    f164 = Math_fround(Math_fround(f169 * f28) + Math_fround(Math_fround(f170 * f197) + Math_fround(f164 * f198)));
    f15 = Math_fround(Math_fround(f171 * f176) + Math_fround(Math_fround(f172 * f199) + Math_fround(f15 * f200)));
    f30 = Math_fround(Math_fround(f173 * f29) + Math_fround(Math_fround(f174 * f201) + Math_fround(f30 * f202)));
    HEAPF32[i26 + 96 >> 2] = f196;
    HEAPF32[i26 + 100 >> 2] = f198;
    HEAPF32[i26 + 104 >> 2] = f200;
    HEAPF32[i26 + 108 >> 2] = f202;
    HEAPF32[i26 + 112 >> 2] = f195;
    HEAPF32[i26 + 116 >> 2] = f197;
    HEAPF32[i26 + 120 >> 2] = f199;
    HEAPF32[i26 + 124 >> 2] = f201;
    HEAPF32[i26 + 128 >> 2] = f175;
    HEAPF32[i26 + 132 >> 2] = f28;
    HEAPF32[i26 + 136 >> 2] = f176;
    HEAPF32[i26 + 140 >> 2] = f29;
    f166 = Math_fround(Math_fround(f144 * f177) + f166);
    f164 = Math_fround(Math_fround(f145 * f163) + f164);
    f15 = Math_fround(Math_fround(f146 * f178) + f15);
    f30 = Math_fround(Math_fround(f147 * f165) + f30);
    i7 = i17 + 32 | 0;
    HEAP32[i42 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 0;
    HEAP32[i42 + 8 >> 2] = 0;
    HEAP32[i42 + 12 >> 2] = 0;
    i194 = HEAP32[i7 >> 2] | 0;
    i190 = HEAP32[i7 + 4 >> 2] | 0;
    i186 = HEAP32[i7 + 8 >> 2] | 0;
    i18 = i21 + 32 | 0;
    i193 = HEAP32[i18 >> 2] | 0;
    i189 = HEAP32[i18 + 4 >> 2] | 0;
    i185 = HEAP32[i18 + 8 >> 2] | 0;
    i22 = i25 + 32 | 0;
    i192 = HEAP32[i22 >> 2] | 0;
    i188 = HEAP32[i22 + 4 >> 2] | 0;
    i184 = HEAP32[i22 + 8 >> 2] | 0;
    i27 = i37 + 32 | 0;
    i191 = HEAP32[i27 >> 2] | 0;
    i187 = HEAP32[i27 + 4 >> 2] | 0;
    i183 = HEAP32[i27 + 8 >> 2] | 0;
    i8 = i17 + 48 | 0;
    i182 = HEAP32[i8 >> 2] | 0;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i12 = HEAP32[i8 + 8 >> 2] | 0;
    i19 = i21 + 48 | 0;
    i181 = HEAP32[i19 >> 2] | 0;
    i13 = HEAP32[i19 + 4 >> 2] | 0;
    i11 = HEAP32[i19 + 8 >> 2] | 0;
    i23 = i25 + 48 | 0;
    i180 = HEAP32[i23 >> 2] | 0;
    i6 = HEAP32[i23 + 4 >> 2] | 0;
    i16 = HEAP32[i23 + 8 >> 2] | 0;
    i34 = i37 + 48 | 0;
    i179 = HEAP32[i34 >> 2] | 0;
    i5 = HEAP32[i34 + 4 >> 2] | 0;
    i14 = HEAP32[i34 + 8 >> 2] | 0;
    f165 = (HEAP32[tempDoublePtr >> 2] = i182, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(f102 * f165);
    f163 = (HEAP32[tempDoublePtr >> 2] = i181, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f177 = Math_fround(f103 * f163);
    f29 = (HEAP32[tempDoublePtr >> 2] = i180, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f176 = Math_fround(f104 * f29);
    f28 = (HEAP32[tempDoublePtr >> 2] = i179, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f175 = Math_fround(f105 * f28);
    f201 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f199 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f197 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f195 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(f178 + Math_fround(f114 * f201));
    f177 = Math_fround(f177 + Math_fround(f115 * f199));
    f176 = Math_fround(f176 + Math_fround(f116 * f197));
    f175 = Math_fround(f175 + Math_fround(f117 * f195));
    f202 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f200 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f198 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f196 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(Math_fround(f126 * f202) + f178);
    f177 = Math_fround(Math_fround(f127 * f200) + f177);
    f176 = Math_fround(Math_fround(f128 * f198) + f176);
    f175 = Math_fround(Math_fround(f129 * f196) + f175);
    f174 = Math_fround(Math_fround(f130 * f202) + Math_fround(Math_fround(f106 * f165) + Math_fround(f118 * f201)));
    f173 = Math_fround(Math_fround(f131 * f200) + Math_fround(Math_fround(f107 * f163) + Math_fround(f119 * f199)));
    f172 = Math_fround(Math_fround(f132 * f198) + Math_fround(Math_fround(f108 * f29) + Math_fround(f120 * f197)));
    f171 = Math_fround(Math_fround(f133 * f196) + Math_fround(Math_fround(f109 * f28) + Math_fround(f121 * f195)));
    f170 = Math_fround(Math_fround(f134 * f202) + Math_fround(Math_fround(f110 * f165) + Math_fround(f122 * f201)));
    f169 = Math_fround(Math_fround(f135 * f200) + Math_fround(Math_fround(f111 * f163) + Math_fround(f123 * f199)));
    f168 = Math_fround(Math_fround(f136 * f198) + Math_fround(Math_fround(f112 * f29) + Math_fround(f124 * f197)));
    f167 = Math_fround(Math_fround(f137 * f196) + Math_fround(Math_fround(f113 * f28) + Math_fround(f125 * f195)));
    f203 = (HEAP32[tempDoublePtr >> 2] = i194, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f203 = Math_fround(f203 * f203);
    f204 = (HEAP32[tempDoublePtr >> 2] = i193, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f204 = Math_fround(f204 * f204);
    f205 = (HEAP32[tempDoublePtr >> 2] = i192, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f205 = Math_fround(f205 * f205);
    f206 = (HEAP32[tempDoublePtr >> 2] = i191, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f206 = Math_fround(f206 * f206);
    f31 = (HEAP32[tempDoublePtr >> 2] = i190, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f32 = (HEAP32[tempDoublePtr >> 2] = i189, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f33 = (HEAP32[tempDoublePtr >> 2] = i188, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f36 = (HEAP32[tempDoublePtr >> 2] = i187, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f31 = Math_fround(f203 + Math_fround(f31 * f31));
    f32 = Math_fround(f204 + Math_fround(f32 * f32));
    f33 = Math_fround(f205 + Math_fround(f33 * f33));
    f36 = Math_fround(f206 + Math_fround(f36 * f36));
    f206 = (HEAP32[tempDoublePtr >> 2] = i186, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f205 = (HEAP32[tempDoublePtr >> 2] = i185, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f204 = (HEAP32[tempDoublePtr >> 2] = i184, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f203 = (HEAP32[tempDoublePtr >> 2] = i183, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f31 = Math_fround(Math_fround(f206 * f206) + f31);
    f32 = Math_fround(Math_fround(f205 * f205) + f32);
    f33 = Math_fround(Math_fround(f204 * f204) + f33);
    f36 = Math_fround(Math_fround(f203 * f203) + f36);
    f165 = Math_fround(Math_fround(f202 * f170) + Math_fround(Math_fround(f201 * f174) + Math_fround(f165 * f178)));
    f163 = Math_fround(Math_fround(f200 * f169) + Math_fround(Math_fround(f199 * f173) + Math_fround(f163 * f177)));
    f29 = Math_fround(Math_fround(f198 * f168) + Math_fround(Math_fround(f197 * f172) + Math_fround(f29 * f176)));
    f28 = Math_fround(Math_fround(f196 * f167) + Math_fround(Math_fround(f195 * f171) + Math_fround(f28 * f175)));
    HEAP32[i26 + 272 >> 2] = i194;
    HEAP32[i26 + 276 >> 2] = i193;
    HEAP32[i26 + 280 >> 2] = i192;
    HEAP32[i26 + 284 >> 2] = i191;
    HEAP32[i26 + 288 >> 2] = i190;
    HEAP32[i26 + 292 >> 2] = i189;
    HEAP32[i26 + 296 >> 2] = i188;
    HEAP32[i26 + 300 >> 2] = i187;
    HEAP32[i26 + 304 >> 2] = i186;
    HEAP32[i26 + 308 >> 2] = i185;
    HEAP32[i26 + 312 >> 2] = i184;
    HEAP32[i26 + 316 >> 2] = i183;
    HEAP32[i26 + 320 >> 2] = i182;
    HEAP32[i26 + 324 >> 2] = i181;
    HEAP32[i26 + 328 >> 2] = i180;
    HEAP32[i26 + 332 >> 2] = i179;
    HEAP32[i26 + 336 >> 2] = i9;
    HEAP32[i26 + 340 >> 2] = i13;
    HEAP32[i26 + 344 >> 2] = i6;
    HEAP32[i26 + 348 >> 2] = i5;
    HEAP32[i26 + 352 >> 2] = i12;
    HEAP32[i26 + 356 >> 2] = i11;
    HEAP32[i26 + 360 >> 2] = i16;
    HEAP32[i26 + 364 >> 2] = i14;
    f177 = Math_fround(-f177);
    f176 = Math_fround(-f176);
    f175 = Math_fround(-f175);
    HEAPF32[i26 + 368 >> 2] = Math_fround(-f178);
    HEAPF32[i26 + 372 >> 2] = f177;
    HEAPF32[i26 + 376 >> 2] = f176;
    HEAPF32[i26 + 380 >> 2] = f175;
    f173 = Math_fround(-f173);
    f172 = Math_fround(-f172);
    f171 = Math_fround(-f171);
    HEAPF32[i26 + 384 >> 2] = Math_fround(-f174);
    HEAPF32[i26 + 388 >> 2] = f173;
    HEAPF32[i26 + 392 >> 2] = f172;
    HEAPF32[i26 + 396 >> 2] = f171;
    f169 = Math_fround(-f169);
    f168 = Math_fround(-f168);
    f167 = Math_fround(-f167);
    HEAPF32[i26 + 400 >> 2] = Math_fround(-f170);
    HEAPF32[i26 + 404 >> 2] = f169;
    HEAPF32[i26 + 408 >> 2] = f168;
    HEAPF32[i26 + 412 >> 2] = f167;
    f31 = Math_fround(f166 + Math_fround(f165 - Math_fround(f31 * f148)));
    f32 = Math_fround(f164 + Math_fround(f163 - Math_fround(f32 * f149)));
    f33 = Math_fround(f15 + Math_fround(f29 - Math_fround(f33 * f150)));
    f36 = Math_fround(f30 + Math_fround(f28 - Math_fround(f36 * f151)));
    i14 = i26 + 144 | 0;
    i16 = i26 + 160 | 0;
    i11 = i26 + 176 | 0;
    i12 = i26 + 192 | 0;
    f28 = Math_fround(HEAPF32[(HEAP32[i157 >> 2] | 0) + 60 >> 2]);
    f30 = Math_fround(HEAPF32[i159 >> 2]);
    i5 = HEAP32[i55 >> 2] | 0;
    i6 = HEAP32[i56 >> 2] | 0;
    do if (i65 >>> 0 < (HEAP32[i47 >> 2] | 0) >>> 0) {
     i9 = HEAP16[i38 >> 1] | 0;
     i13 = i9 & 65535;
     if ((i13 & 4 | 0) != 0 | (i13 & 3 | 0) == 3) {
      f15 = Math_fround(HEAPF32[i5 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i17 >> 2]));
      f204 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f204 * Math_fround(HEAPF32[i17 + 4 >> 2])));
      f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f15 = Math_fround(f204 + Math_fround(f15 * Math_fround(HEAPF32[i17 + 8 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 16 >> 2]);
      f204 = Math_fround(f204 * Math_fround(HEAPF32[i10 >> 2]));
      f205 = Math_fround(HEAPF32[i5 + 20 >> 2]);
      f205 = Math_fround(f204 + Math_fround(f205 * Math_fround(HEAPF32[i17 + 20 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 24 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f205 + Math_fround(f204 * Math_fround(HEAPF32[i17 + 24 >> 2]))));
      f205 = Math_fround(HEAPF32[i6 >> 2]);
      f205 = Math_fround(f205 * Math_fround(HEAPF32[i7 >> 2]));
      f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
      f15 = Math_fround(f205 + Math_fround(f15 * Math_fround(HEAPF32[i17 + 36 >> 2])));
      f205 = Math_fround(HEAPF32[i6 + 8 >> 2]);
      f205 = Math_fround(f15 + Math_fround(f205 * Math_fround(HEAPF32[i17 + 40 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 16 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i8 >> 2]));
      f206 = Math_fround(HEAPF32[i6 + 20 >> 2]);
      f206 = Math_fround(f15 + Math_fround(f206 * Math_fround(HEAPF32[i17 + 52 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 24 >> 2]);
      f15 = Math_fround(f204 - Math_fround(f205 + Math_fround(f206 + Math_fround(f15 * Math_fround(HEAPF32[i17 + 56 >> 2])))));
     } else f15 = Math_fround(0.0);
     f29 = Math_fround(Math_fround(1.0) / f31);
     f29 = f31 <= f28 ? Math_fround(0.0) : f29;
     i5 = i17 + 12 | 0;
     if (i13 & 1 | 0) {
      f15 = Math_fround(f30 * Math_fround(HEAPF32[i5 >> 2]));
      f206 = Math_fround(HEAPF32[i17 + 64 >> 2]);
      f28 = Math_fround(f57 * f206);
      f205 = Math_fround(HEAPF32[i17 + 68 >> 2]);
      f28 = Math_fround(f28 + Math_fround(f205 * f158));
      f15 = Math_fround(Math_fround(Math_fround(f205 * Math_fround(HEAPF32[i17 + 28 >> 2])) - Math_fround(f206 * f15)) * f158);
      if (!(i13 & 2)) {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f31 * f28) + Math_fround(1.0)));
       f205 = Math_fround(f15 * f206);
       HEAPF32[i16 >> 2] = f205;
       HEAPF32[i14 >> 2] = f205;
       HEAPF32[i11 >> 2] = Math_fround(-Math_fround(f28 * f206));
       HEAPF32[i12 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      } else {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(f28 + Math_fround(1.0)));
       f205 = Math_fround(f29 * f206);
       f204 = Math_fround(f15 * f205);
       HEAPF32[i16 >> 2] = f204;
       HEAPF32[i14 >> 2] = f204;
       HEAPF32[i11 >> 2] = Math_fround(-Math_fround(f28 * f205));
       HEAPF32[i12 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      }
     }
     HEAPF32[i11 >> 2] = Math_fround(-f29);
     HEAPF32[i12 >> 2] = Math_fround(1.0);
     if (i9 & 4) {
      f15 = Math_fround(-f15);
      if (Math_fround(HEAPF32[i17 + 68 >> 2]) < f15) {
       f206 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i17 + 64 >> 2])) * f15);
       HEAPF32[i14 >> 2] = f206;
       HEAPF32[i16 >> 2] = f206;
       break;
      }
     }
     i194 = i17 + 28 | 0;
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i14 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f160)));
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i16 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i17 + 72 >> 2]) * f160)));
    } else {
     HEAPF32[i14 >> 2] = Math_fround(0.0);
     HEAPF32[i16 >> 2] = Math_fround(0.0);
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i12 >> 2] = Math_fround(0.0);
    } while (0);
    i11 = i26 + 148 | 0;
    i12 = i26 + 164 | 0;
    i8 = i26 + 180 | 0;
    i9 = i26 + 196 | 0;
    f28 = Math_fround(HEAPF32[(HEAP32[i138 >> 2] | 0) + 60 >> 2]);
    f30 = Math_fround(HEAPF32[i141 >> 2]);
    i5 = HEAP32[i58 >> 2] | 0;
    i6 = HEAP32[i59 >> 2] | 0;
    do if (i65 >>> 0 < (HEAP32[i48 >> 2] | 0) >>> 0) {
     i7 = HEAP16[i39 >> 1] | 0;
     i10 = i7 & 65535;
     if ((i10 & 4 | 0) != 0 | (i10 & 3 | 0) == 3) {
      f15 = Math_fround(HEAPF32[i5 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i21 >> 2]));
      f204 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f204 * Math_fround(HEAPF32[i21 + 4 >> 2])));
      f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f15 = Math_fround(f204 + Math_fround(f15 * Math_fround(HEAPF32[i21 + 8 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 16 >> 2]);
      f204 = Math_fround(f204 * Math_fround(HEAPF32[i20 >> 2]));
      f205 = Math_fround(HEAPF32[i5 + 20 >> 2]);
      f205 = Math_fround(f204 + Math_fround(f205 * Math_fround(HEAPF32[i21 + 20 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 24 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f205 + Math_fround(f204 * Math_fround(HEAPF32[i21 + 24 >> 2]))));
      f205 = Math_fround(HEAPF32[i6 >> 2]);
      f205 = Math_fround(f205 * Math_fround(HEAPF32[i18 >> 2]));
      f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
      f15 = Math_fround(f205 + Math_fround(f15 * Math_fround(HEAPF32[i21 + 36 >> 2])));
      f205 = Math_fround(HEAPF32[i6 + 8 >> 2]);
      f205 = Math_fround(f15 + Math_fround(f205 * Math_fround(HEAPF32[i21 + 40 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 16 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
      f206 = Math_fround(HEAPF32[i6 + 20 >> 2]);
      f206 = Math_fround(f15 + Math_fround(f206 * Math_fround(HEAPF32[i21 + 52 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 24 >> 2]);
      f15 = Math_fround(f204 - Math_fround(f205 + Math_fround(f206 + Math_fround(f15 * Math_fround(HEAPF32[i21 + 56 >> 2])))));
     } else f15 = Math_fround(0.0);
     f29 = Math_fround(Math_fround(1.0) / f32);
     f29 = f32 <= f28 ? Math_fround(0.0) : f29;
     i5 = i21 + 12 | 0;
     if (i10 & 1 | 0) {
      f15 = Math_fround(f30 * Math_fround(HEAPF32[i5 >> 2]));
      f206 = Math_fround(HEAPF32[i21 + 64 >> 2]);
      f28 = Math_fround(f57 * f206);
      f205 = Math_fround(HEAPF32[i21 + 68 >> 2]);
      f28 = Math_fround(f28 + Math_fround(f205 * f158));
      f15 = Math_fround(Math_fround(Math_fround(f205 * Math_fround(HEAPF32[i21 + 28 >> 2])) - Math_fround(f206 * f15)) * f158);
      if (!(i10 & 2)) {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f32 * f28) + Math_fround(1.0)));
       f205 = Math_fround(f15 * f206);
       HEAPF32[i12 >> 2] = f205;
       HEAPF32[i11 >> 2] = f205;
       HEAPF32[i8 >> 2] = Math_fround(-Math_fround(f28 * f206));
       HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      } else {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(f28 + Math_fround(1.0)));
       f205 = Math_fround(f29 * f206);
       f204 = Math_fround(f15 * f205);
       HEAPF32[i12 >> 2] = f204;
       HEAPF32[i11 >> 2] = f204;
       HEAPF32[i8 >> 2] = Math_fround(-Math_fround(f28 * f205));
       HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      }
     }
     HEAPF32[i8 >> 2] = Math_fround(-f29);
     HEAPF32[i9 >> 2] = Math_fround(1.0);
     if (i7 & 4) {
      f15 = Math_fround(-f15);
      if (Math_fround(HEAPF32[i21 + 68 >> 2]) < f15) {
       f206 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i21 + 64 >> 2])) * f15);
       HEAPF32[i11 >> 2] = f206;
       HEAPF32[i12 >> 2] = f206;
       break;
      }
     }
     i194 = i21 + 28 | 0;
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i11 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f160)));
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i12 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i21 + 72 >> 2]) * f160)));
    } else {
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     HEAPF32[i8 >> 2] = Math_fround(0.0);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
    } while (0);
    i11 = i26 + 152 | 0;
    i12 = i26 + 168 | 0;
    i8 = i26 + 184 | 0;
    i9 = i26 + 200 | 0;
    f28 = Math_fround(HEAPF32[(HEAP32[i139 >> 2] | 0) + 60 >> 2]);
    f30 = Math_fround(HEAPF32[i142 >> 2]);
    i5 = HEAP32[i60 >> 2] | 0;
    i6 = HEAP32[i61 >> 2] | 0;
    do if (i65 >>> 0 < (HEAP32[i49 >> 2] | 0) >>> 0) {
     i7 = HEAP16[i40 >> 1] | 0;
     i10 = i7 & 65535;
     if ((i10 & 4 | 0) != 0 | (i10 & 3 | 0) == 3) {
      f15 = Math_fround(HEAPF32[i5 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i25 >> 2]));
      f204 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f204 * Math_fround(HEAPF32[i25 + 4 >> 2])));
      f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f15 = Math_fround(f204 + Math_fround(f15 * Math_fround(HEAPF32[i25 + 8 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 16 >> 2]);
      f204 = Math_fround(f204 * Math_fround(HEAPF32[i24 >> 2]));
      f205 = Math_fround(HEAPF32[i5 + 20 >> 2]);
      f205 = Math_fround(f204 + Math_fround(f205 * Math_fround(HEAPF32[i25 + 20 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 24 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f205 + Math_fround(f204 * Math_fround(HEAPF32[i25 + 24 >> 2]))));
      f205 = Math_fround(HEAPF32[i6 >> 2]);
      f205 = Math_fround(f205 * Math_fround(HEAPF32[i22 >> 2]));
      f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
      f15 = Math_fround(f205 + Math_fround(f15 * Math_fround(HEAPF32[i25 + 36 >> 2])));
      f205 = Math_fround(HEAPF32[i6 + 8 >> 2]);
      f205 = Math_fround(f15 + Math_fround(f205 * Math_fround(HEAPF32[i25 + 40 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 16 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i23 >> 2]));
      f206 = Math_fround(HEAPF32[i6 + 20 >> 2]);
      f206 = Math_fround(f15 + Math_fround(f206 * Math_fround(HEAPF32[i25 + 52 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 24 >> 2]);
      f15 = Math_fround(f204 - Math_fround(f205 + Math_fround(f206 + Math_fround(f15 * Math_fround(HEAPF32[i25 + 56 >> 2])))));
     } else f15 = Math_fround(0.0);
     f29 = Math_fround(Math_fround(1.0) / f33);
     f29 = f33 <= f28 ? Math_fround(0.0) : f29;
     i5 = i25 + 12 | 0;
     if (i10 & 1 | 0) {
      f15 = Math_fround(f30 * Math_fround(HEAPF32[i5 >> 2]));
      f206 = Math_fround(HEAPF32[i25 + 64 >> 2]);
      f28 = Math_fround(f57 * f206);
      f205 = Math_fround(HEAPF32[i25 + 68 >> 2]);
      f28 = Math_fround(f28 + Math_fround(f205 * f158));
      f15 = Math_fround(Math_fround(Math_fround(f205 * Math_fround(HEAPF32[i25 + 28 >> 2])) - Math_fround(f206 * f15)) * f158);
      if (!(i10 & 2)) {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f33 * f28) + Math_fround(1.0)));
       f205 = Math_fround(f15 * f206);
       HEAPF32[i12 >> 2] = f205;
       HEAPF32[i11 >> 2] = f205;
       HEAPF32[i8 >> 2] = Math_fround(-Math_fround(f28 * f206));
       HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      } else {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(f28 + Math_fround(1.0)));
       f205 = Math_fround(f29 * f206);
       f204 = Math_fround(f15 * f205);
       HEAPF32[i12 >> 2] = f204;
       HEAPF32[i11 >> 2] = f204;
       HEAPF32[i8 >> 2] = Math_fround(-Math_fround(f28 * f205));
       HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      }
     }
     HEAPF32[i8 >> 2] = Math_fround(-f29);
     HEAPF32[i9 >> 2] = Math_fround(1.0);
     if (i7 & 4) {
      f15 = Math_fround(-f15);
      if (Math_fround(HEAPF32[i25 + 68 >> 2]) < f15) {
       f206 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i25 + 64 >> 2])) * f15);
       HEAPF32[i11 >> 2] = f206;
       HEAPF32[i12 >> 2] = f206;
       break;
      }
     }
     i194 = i25 + 28 | 0;
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i11 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f160)));
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i12 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i25 + 72 >> 2]) * f160)));
    } else {
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     HEAPF32[i8 >> 2] = Math_fround(0.0);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
    } while (0);
    i11 = i26 + 156 | 0;
    i12 = i26 + 172 | 0;
    i10 = i26 + 188 | 0;
    i8 = i26 + 204 | 0;
    f28 = Math_fround(HEAPF32[(HEAP32[i140 >> 2] | 0) + 60 >> 2]);
    f30 = Math_fround(HEAPF32[i143 >> 2]);
    i5 = HEAP32[i62 >> 2] | 0;
    i6 = HEAP32[i63 >> 2] | 0;
    do if (i65 >>> 0 < (HEAP32[i50 >> 2] | 0) >>> 0) {
     i7 = HEAP16[i41 >> 1] | 0;
     i9 = i7 & 65535;
     if ((i9 & 4 | 0) != 0 | (i9 & 3 | 0) == 3) {
      f15 = Math_fround(HEAPF32[i5 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i37 >> 2]));
      f204 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f204 * Math_fround(HEAPF32[i37 + 4 >> 2])));
      f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f15 = Math_fround(f204 + Math_fround(f15 * Math_fround(HEAPF32[i37 + 8 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 16 >> 2]);
      f204 = Math_fround(f204 * Math_fround(HEAPF32[i35 >> 2]));
      f205 = Math_fround(HEAPF32[i5 + 20 >> 2]);
      f205 = Math_fround(f204 + Math_fround(f205 * Math_fround(HEAPF32[i37 + 20 >> 2])));
      f204 = Math_fround(HEAPF32[i5 + 24 >> 2]);
      f204 = Math_fround(f15 + Math_fround(f205 + Math_fround(f204 * Math_fround(HEAPF32[i37 + 24 >> 2]))));
      f205 = Math_fround(HEAPF32[i6 >> 2]);
      f205 = Math_fround(f205 * Math_fround(HEAPF32[i27 >> 2]));
      f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
      f15 = Math_fround(f205 + Math_fround(f15 * Math_fround(HEAPF32[i37 + 36 >> 2])));
      f205 = Math_fround(HEAPF32[i6 + 8 >> 2]);
      f205 = Math_fround(f15 + Math_fround(f205 * Math_fround(HEAPF32[i37 + 40 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 16 >> 2]);
      f15 = Math_fround(f15 * Math_fround(HEAPF32[i34 >> 2]));
      f206 = Math_fround(HEAPF32[i6 + 20 >> 2]);
      f206 = Math_fround(f15 + Math_fround(f206 * Math_fround(HEAPF32[i37 + 52 >> 2])));
      f15 = Math_fround(HEAPF32[i6 + 24 >> 2]);
      f15 = Math_fround(f204 - Math_fround(f205 + Math_fround(f206 + Math_fround(f15 * Math_fround(HEAPF32[i37 + 56 >> 2])))));
     } else f15 = Math_fround(0.0);
     f29 = Math_fround(Math_fround(1.0) / f36);
     f29 = f36 <= f28 ? Math_fround(0.0) : f29;
     i5 = i37 + 12 | 0;
     if (i9 & 1 | 0) {
      f15 = Math_fround(f30 * Math_fround(HEAPF32[i5 >> 2]));
      f206 = Math_fround(HEAPF32[i37 + 64 >> 2]);
      f28 = Math_fround(f57 * f206);
      f205 = Math_fround(HEAPF32[i37 + 68 >> 2]);
      f28 = Math_fround(f28 + Math_fround(f205 * f158));
      f15 = Math_fround(Math_fround(Math_fround(f205 * Math_fround(HEAPF32[i37 + 28 >> 2])) - Math_fround(f206 * f15)) * f158);
      if (!(i9 & 2)) {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f36 * f28) + Math_fround(1.0)));
       f205 = Math_fround(f15 * f206);
       HEAPF32[i12 >> 2] = f205;
       HEAPF32[i11 >> 2] = f205;
       HEAPF32[i10 >> 2] = Math_fround(-Math_fround(f28 * f206));
       HEAPF32[i8 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      } else {
       f206 = Math_fround(Math_fround(1.0) / Math_fround(f28 + Math_fround(1.0)));
       f205 = Math_fround(f29 * f206);
       f204 = Math_fround(f15 * f205);
       HEAPF32[i12 >> 2] = f204;
       HEAPF32[i11 >> 2] = f204;
       HEAPF32[i10 >> 2] = Math_fround(-Math_fround(f28 * f205));
       HEAPF32[i8 >> 2] = Math_fround(Math_fround(1.0) - f206);
       break;
      }
     }
     HEAPF32[i10 >> 2] = Math_fround(-f29);
     HEAPF32[i8 >> 2] = Math_fround(1.0);
     if (i7 & 4) {
      f15 = Math_fround(-f15);
      if (Math_fround(HEAPF32[i37 + 68 >> 2]) < f15) {
       f206 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i37 + 64 >> 2])) * f15);
       HEAPF32[i11 >> 2] = f206;
       HEAPF32[i12 >> 2] = f206;
       break;
      }
     }
     i194 = i37 + 28 | 0;
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i11 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f160)));
     f206 = Math_fround(HEAPF32[i194 >> 2]);
     HEAPF32[i12 >> 2] = Math_fround(f29 * Math_fround(f206 - Math_fround(Math_fround(HEAPF32[i37 + 72 >> 2]) * f160)));
    } else {
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     HEAPF32[i10 >> 2] = Math_fround(0.0);
     HEAPF32[i8 >> 2] = Math_fround(0.0);
    } while (0);
    if (HEAP16[i38 >> 1] & 16) HEAP32[i42 >> 2] = HEAP32[i42 >> 2] | 2;
    if (HEAP16[i39 >> 1] & 16) HEAP32[i43 >> 2] = HEAP32[i43 >> 2] | 2;
    if (HEAP16[i40 >> 1] & 16) HEAP32[i44 >> 2] = HEAP32[i44 >> 2] | 2;
    if (HEAP16[i41 >> 1] & 16) HEAP32[i45 >> 2] = HEAP32[i45 >> 2] | 2;
    i65 = i65 + 1 | 0;
   } while ((i65 | 0) != (i154 | 0));
   i2 = i153 + 132 | 0;
   i1 = i152 + i155 | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i152 + i2 >> 2] = 0;
  i194 = 2;
  STACKTOP = i162;
  return i194 | 0;
 } else if ((i2 | 0) == 84) {
  STACKTOP = i162;
  return i1 | 0;
 }
 return 0;
}

function __ZN13SpeedTreeWind10SWindGroup8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485284 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485305 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485326 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485347 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485368 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485389 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485410 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485431 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485452 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485473 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485494 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485511 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485528 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485545 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485562 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485579 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 171; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 171;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485596 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 182; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 182;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 182) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485613 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 193; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 193;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 193) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485630 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 204; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 204;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 204) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485647 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 215; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 215;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 215) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485664 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 226; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 226;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 226) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485682 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 237; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 237;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 237) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485700 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 248; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 248;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 248) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485718 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 259; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 259;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 259) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485736 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 270; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 270;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 270) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485754 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 281; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 281;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 281) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485772 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 292; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 292;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 292) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485790 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 303; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 303;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 303) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485808 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 314; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 314;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 314) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485826 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 325; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 325;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 325) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485844 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 336; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 336;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 336) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485875 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   do if (i1 >>> 0 < i2 >>> 0) i8 = 347; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 347;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   } while (0);
   if ((i8 | 0) == 347) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485906 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 358; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 358;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 358) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485937 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 369; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 369;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 369) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485968 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 380; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 380;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 380) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 485999 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 391; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 391;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 391) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486030 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 402; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 402;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 402) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486061 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 413; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 413;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 413) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486092 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 424; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 424;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 424) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486123 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 435; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 435;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 435) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 160 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486154 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 446; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 446;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 446) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 164 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486172 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 457; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 457;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 457) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486190 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 468; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 468;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 468) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 172 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486208 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 479; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 479;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 479) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486226 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 490; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 490;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 490) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486244 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 501; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 501;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 501) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 184 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486262 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 512; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 512;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 512) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 188 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486280 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 523; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 523;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 523) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486298 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 534; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 534;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 534) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 196 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486316 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 545; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 545;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 545) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486334 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 556; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 556;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 556) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 204 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486353 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 567; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 567;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 567) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 208 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486369 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 578; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 578;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 578) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 212 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486385 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 589; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 589;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 589) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 216 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486398 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 600; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 600;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 600) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 220 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486416 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 611; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 611;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 611) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i9 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_(i55, i39, i51, i52, i45, i63, i64, i65) {
 i55 = i55 | 0;
 i39 = i39 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 i45 = i45 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i66 + 92 | 0;
 i41 = i66 + 80 | 0;
 i42 = i66 + 76 | 0;
 i54 = i66 + 72 | 0;
 i57 = i66 + 60 | 0;
 i35 = i66 + 48 | 0;
 i34 = i66 + 36 | 0;
 i38 = i66 + 24 | 0;
 i60 = i66 + 20 | 0;
 i61 = i66 + 16 | 0;
 i62 = i66 + 12 | 0;
 i59 = i66 + 8 | 0;
 i56 = i66 + 4 | 0;
 i58 = i66;
 f1 = Math_fround(HEAPF32[i39 >> 2]);
 f24 = Math_fround(f1 * f1);
 i36 = i39 + 4 | 0;
 f4 = Math_fround(HEAPF32[i36 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f4 * f4));
 i37 = i39 + 8 | 0;
 f9 = Math_fround(HEAPF32[i37 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f9 * f9));
 if (f24 < Math_fround(9.99999996e-13)) {
  if (i63 | 0) HEAPF32[i63 >> 2] = Math_fround(0.0);
  f28 = Math_fround(HEAPF32[i52 >> 2]);
  f31 = Math_fround(HEAPF32[i51 >> 2]);
  f28 = Math_fround(f28 + f31);
  f29 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i51 + 4 >> 2]);
  f29 = Math_fround(f29 + f32);
  f30 = Math_fround(HEAPF32[i52 + 8 >> 2]);
  f33 = Math_fround(HEAPF32[i51 + 8 >> 2]);
  f30 = Math_fround(f30 + f33);
  HEAPF32[i40 >> 2] = f28;
  HEAPF32[i40 + 4 >> 2] = f29;
  HEAPF32[i40 + 8 >> 2] = f30;
  f31 = Math_fround(f31 + Math_fround(HEAPF32[i45 >> 2]));
  f32 = Math_fround(f32 + Math_fround(HEAPF32[i45 + 4 >> 2]));
  f33 = Math_fround(f33 + Math_fround(HEAPF32[i45 + 8 >> 2]));
  HEAPF32[i41 >> 2] = f31;
  HEAPF32[i41 + 4 >> 2] = f32;
  HEAPF32[i41 + 8 >> 2] = f33;
  __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
  if (i64 | 0) HEAP32[i64 >> 2] = HEAP32[i42 >> 2];
  if (i65 | 0) HEAP32[i65 >> 2] = HEAP32[i54 >> 2];
  f31 = Math_fround(HEAPF32[i57 >> 2]);
  f31 = Math_fround(f31 - Math_fround(HEAPF32[i55 >> 2]));
  f32 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f32 = Math_fround(f32 - Math_fround(HEAPF32[i55 + 4 >> 2]));
  f33 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f33 = Math_fround(f33 - Math_fround(HEAPF32[i55 + 8 >> 2]));
  f33 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f33 * f33));
  STACKTOP = i66;
  return Math_fround(f33);
 }
 f20 = Math_fround(HEAPF32[i51 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i55 >> 2]));
 i46 = i51 + 4 | 0;
 f21 = Math_fround(HEAPF32[i46 >> 2]);
 i47 = i55 + 4 | 0;
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i47 >> 2]));
 i48 = i51 + 8 | 0;
 f27 = Math_fround(HEAPF32[i48 >> 2]);
 i53 = i55 + 8 | 0;
 f22 = Math_fround(f27 - Math_fround(HEAPF32[i53 >> 2]));
 f28 = Math_fround(HEAPF32[i52 >> 2]);
 f11 = Math_fround(f1 * f28);
 i49 = i52 + 4 | 0;
 f29 = Math_fround(HEAPF32[i49 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * f29));
 i50 = i52 + 8 | 0;
 f30 = Math_fround(HEAPF32[i50 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f9 * f30));
 f23 = Math_fround(-f11);
 f31 = Math_fround(HEAPF32[i45 >> 2]);
 f12 = Math_fround(f1 * f31);
 i43 = i45 + 4 | 0;
 f32 = Math_fround(HEAPF32[i43 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f4 * f32));
 i44 = i45 + 8 | 0;
 f33 = Math_fround(HEAPF32[i44 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f33));
 f25 = Math_fround(-f12);
 f26 = Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(f30 * f30));
 f15 = Math_fround(Math_fround(Math_fround(f28 * f31) + Math_fround(f29 * f32)) + Math_fround(f30 * f33));
 f16 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f33 * f33));
 f17 = Math_fround(Math_fround(Math_fround(f1 * f20) + Math_fround(f4 * f21)) + Math_fround(f9 * f22));
 f18 = Math_fround(Math_fround(Math_fround(f20 * f28) + Math_fround(f21 * f29)) + Math_fround(f22 * f30));
 f19 = Math_fround(Math_fround(Math_fround(f20 * f31) + Math_fround(f21 * f32)) + Math_fround(f22 * f33));
 f2 = Math_fround(Math_fround(f26 * f16) - Math_fround(f15 * f15));
 f13 = Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f23));
 f14 = Math_fround(Math_fround(f15 * f23) - Math_fround(f26 * f25));
 f3 = Math_fround(Math_fround(f14 * f25) + Math_fround(Math_fround(f24 * f2) + Math_fround(f13 * f23)));
 f68 = Math_fround(Math_fround(f29 * f33) - Math_fround(f30 * f32));
 f67 = Math_fround(Math_fround(f30 * f31) - Math_fround(f28 * f33));
 f69 = Math_fround(Math_fround(f28 * f32) - Math_fround(f29 * f31));
 f9 = Math_fround(Math_fround(f9 * f69) + Math_fround(Math_fround(f1 * f68) + Math_fround(f4 * f67)));
 do if (!(+Math_fround(f9 * f9) >= +f24 * 1.0e-06 * +Math_fround(Math_fround(f69 * f69) + Math_fround(Math_fround(f68 * f68) + Math_fround(f67 * f67))))) {
  HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
  i5 = i35 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i46 >> 2];
  i6 = i35 + 8 | 0;
  HEAP32[i6 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
  i7 = i34 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i49 >> 2];
  i8 = i34 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i50 >> 2];
  f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
  HEAPF32[i62 >> 2] = Math_fround(0.0);
  HEAP32[i34 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i44 >> 2];
  f2 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
  HEAPF32[i56 >> 2] = Math_fround(0.0);
  if (f2 < f1) {
   HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i61 >> 2] = 0;
   HEAP32[i62 >> 2] = HEAP32[i58 >> 2];
   f4 = f2;
  } else f4 = f1;
  f67 = Math_fround(HEAPF32[i51 >> 2]);
  f3 = Math_fround(HEAPF32[i52 >> 2]);
  f67 = Math_fround(f67 + f3);
  f68 = Math_fround(HEAPF32[i46 >> 2]);
  f2 = Math_fround(HEAPF32[i49 >> 2]);
  f68 = Math_fround(f68 + f2);
  f69 = Math_fround(HEAPF32[i48 >> 2]);
  f1 = Math_fround(HEAPF32[i50 >> 2]);
  f69 = Math_fround(f69 + f1);
  HEAPF32[i35 >> 2] = f67;
  HEAPF32[i5 >> 2] = f68;
  HEAPF32[i6 >> 2] = f69;
  f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
  f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
  f1 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f1);
  HEAPF32[i34 >> 2] = f3;
  HEAPF32[i7 >> 2] = f2;
  HEAPF32[i8 >> 2] = f1;
  f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
  f2 = Math_fround(HEAPF32[i58 >> 2]);
  f3 = Math_fround(Math_fround(1.0) - f2);
  HEAPF32[i56 >> 2] = f3;
  if (f1 < f4) {
   HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
   HEAPF32[i61 >> 2] = f3;
   HEAPF32[i62 >> 2] = f2;
  } else f1 = f4;
  f3 = Math_fround(HEAPF32[i52 >> 2]);
  f69 = Math_fround(HEAPF32[i51 >> 2]);
  f3 = Math_fround(f3 + f69);
  f2 = Math_fround(HEAPF32[i49 >> 2]);
  f9 = Math_fround(HEAPF32[i46 >> 2]);
  f2 = Math_fround(f2 + f9);
  f4 = Math_fround(HEAPF32[i50 >> 2]);
  f68 = Math_fround(HEAPF32[i48 >> 2]);
  f4 = Math_fround(f4 + f68);
  HEAPF32[i40 >> 2] = f3;
  HEAPF32[i40 + 4 >> 2] = f2;
  HEAPF32[i40 + 8 >> 2] = f4;
  f69 = Math_fround(f69 + Math_fround(HEAPF32[i45 >> 2]));
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i43 >> 2]));
  f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
  HEAPF32[i41 >> 2] = f69;
  HEAPF32[i41 + 4 >> 2] = f9;
  HEAPF32[i41 + 8 >> 2] = f68;
  __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
  i5 = HEAP32[i42 >> 2] | 0;
  HEAP32[i56 >> 2] = i5;
  i6 = HEAP32[i54 >> 2] | 0;
  HEAP32[i58 >> 2] = i6;
  f68 = Math_fround(HEAPF32[i57 >> 2]);
  f9 = Math_fround(HEAPF32[i55 >> 2]);
  f68 = Math_fround(f68 - f9);
  f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i47 >> 2]);
  f69 = Math_fround(f69 - f4);
  f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i53 >> 2]);
  f2 = Math_fround(f2 - f3);
  f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
  HEAPF32[i59 >> 2] = Math_fround(0.0);
  if (f2 < f1) {
   HEAPF32[i60 >> 2] = Math_fround(0.0);
   HEAP32[i61 >> 2] = i5;
   HEAP32[i62 >> 2] = i6;
  } else f2 = f1;
  f33 = Math_fround(f9 + Math_fround(HEAPF32[i39 >> 2]));
  f1 = Math_fround(f4 + Math_fround(HEAPF32[i36 >> 2]));
  f32 = Math_fround(f3 + Math_fround(HEAPF32[i37 >> 2]));
  HEAPF32[i38 >> 2] = f33;
  i53 = i38 + 4 | 0;
  HEAPF32[i53 >> 2] = f1;
  i55 = i38 + 8 | 0;
  HEAPF32[i55 >> 2] = f32;
  f32 = Math_fround(HEAPF32[i52 >> 2]);
  f1 = Math_fround(HEAPF32[i51 >> 2]);
  f32 = Math_fround(f32 + f1);
  f33 = Math_fround(HEAPF32[i49 >> 2]);
  f69 = Math_fround(HEAPF32[i46 >> 2]);
  f33 = Math_fround(f33 + f69);
  f67 = Math_fround(HEAPF32[i50 >> 2]);
  f68 = Math_fround(HEAPF32[i48 >> 2]);
  f67 = Math_fround(f67 + f68);
  HEAPF32[i40 >> 2] = f32;
  HEAPF32[i40 + 4 >> 2] = f33;
  HEAPF32[i40 + 8 >> 2] = f67;
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i45 >> 2]));
  f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
  f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
  HEAPF32[i41 >> 2] = f1;
  HEAPF32[i41 + 4 >> 2] = f69;
  HEAPF32[i41 + 8 >> 2] = f68;
  __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
  i6 = HEAP32[i42 >> 2] | 0;
  HEAP32[i56 >> 2] = i6;
  i5 = HEAP32[i54 >> 2] | 0;
  HEAP32[i58 >> 2] = i5;
  f68 = Math_fround(HEAPF32[i57 >> 2]);
  f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
  f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
  f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i55 >> 2]));
  f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
  HEAPF32[i59 >> 2] = Math_fround(1.0);
  if (f1 < f2) {
   HEAPF32[i60 >> 2] = Math_fround(1.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
  } else f1 = f2;
 } else {
  f9 = Math_fround(Math_fround(f24 * f16) - Math_fround(f12 * f12));
  f69 = Math_fround(Math_fround(f11 * f12) - Math_fround(f24 * f15));
  f12 = Math_fround(Math_fround(f24 * f26) - Math_fround(f11 * f11));
  i10 = f3 == Math_fround(0.0);
  f67 = Math_fround(Math_fround(1.0) / f3);
  f67 = i10 ? Math_fround(0.0) : f67;
  f68 = Math_fround(f17 * f67);
  f1 = Math_fround(-Math_fround(f18 * f67));
  f67 = Math_fround(-Math_fround(f19 * f67));
  f2 = Math_fround(Math_fround(f14 * f67) + Math_fround(Math_fround(f2 * f68) + Math_fround(f13 * f1)));
  HEAPF32[i60 >> 2] = f2;
  f3 = Math_fround(Math_fround(f69 * f67) + Math_fround(Math_fround(f13 * f68) + Math_fround(f9 * f1)));
  HEAPF32[i61 >> 2] = f3;
  f1 = Math_fround(Math_fround(f12 * f67) + Math_fround(Math_fround(f14 * f68) + Math_fround(f69 * f1)));
  HEAPF32[i62 >> 2] = f1;
  if (f2 < Math_fround(0.0)) {
   i5 = f3 < Math_fround(0.0);
   if (!(Math_fround(f1 + f3) <= Math_fround(1.0))) {
    if (i5) {
     HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
     i10 = i35 + 4 | 0;
     HEAP32[i10 >> 2] = HEAP32[i46 >> 2];
     i36 = i35 + 8 | 0;
     HEAP32[i36 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i34 >> 2] = HEAP32[i45 >> 2];
     i37 = i34 + 4 | 0;
     HEAP32[i37 >> 2] = HEAP32[i43 >> 2];
     i38 = i34 + 8 | 0;
     HEAPF32[i38 >> 2] = f33;
     f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
     HEAPF32[i61 >> 2] = Math_fround(0.0);
     f67 = Math_fround(HEAPF32[i51 >> 2]);
     f3 = Math_fround(HEAPF32[i52 >> 2]);
     f67 = Math_fround(f67 + f3);
     f68 = Math_fround(HEAPF32[i46 >> 2]);
     f2 = Math_fround(HEAPF32[i49 >> 2]);
     f68 = Math_fround(f68 + f2);
     f69 = Math_fround(HEAPF32[i48 >> 2]);
     f1 = Math_fround(HEAPF32[i50 >> 2]);
     f69 = Math_fround(f69 + f1);
     HEAPF32[i35 >> 2] = f67;
     HEAPF32[i10 >> 2] = f68;
     HEAPF32[i36 >> 2] = f69;
     f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
     f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
     f1 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f1);
     HEAPF32[i34 >> 2] = f3;
     HEAPF32[i37 >> 2] = f2;
     HEAPF32[i38 >> 2] = f1;
     f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
     f2 = Math_fround(HEAPF32[i58 >> 2]);
     f3 = Math_fround(Math_fround(1.0) - f2);
     HEAPF32[i56 >> 2] = f3;
     if (f1 < f4) {
      HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
      HEAPF32[i61 >> 2] = f3;
      HEAPF32[i62 >> 2] = f2;
      f2 = f1;
     } else f2 = f4;
     f32 = Math_fround(HEAPF32[i52 >> 2]);
     f1 = Math_fround(HEAPF32[i51 >> 2]);
     f32 = Math_fround(f32 + f1);
     f33 = Math_fround(HEAPF32[i49 >> 2]);
     f69 = Math_fround(HEAPF32[i46 >> 2]);
     f33 = Math_fround(f33 + f69);
     f67 = Math_fround(HEAPF32[i50 >> 2]);
     f68 = Math_fround(HEAPF32[i48 >> 2]);
     f67 = Math_fround(f67 + f68);
     HEAPF32[i40 >> 2] = f32;
     HEAPF32[i40 + 4 >> 2] = f33;
     HEAPF32[i40 + 8 >> 2] = f67;
     f1 = Math_fround(f1 + Math_fround(HEAPF32[i45 >> 2]));
     f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
     f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
     HEAPF32[i41 >> 2] = f1;
     HEAPF32[i41 + 4 >> 2] = f69;
     HEAPF32[i41 + 8 >> 2] = f68;
     __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
     i6 = HEAP32[i42 >> 2] | 0;
     HEAP32[i56 >> 2] = i6;
     i5 = HEAP32[i54 >> 2] | 0;
     HEAP32[i58 >> 2] = i5;
     f68 = Math_fround(HEAPF32[i57 >> 2]);
     f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
     f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
     f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
     f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
     f1 = Math_fround(f1 - Math_fround(HEAPF32[i53 >> 2]));
     f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
     HEAPF32[i59 >> 2] = Math_fround(0.0);
     if (!(f1 < f2)) {
      f1 = f2;
      break;
     }
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     HEAP32[i61 >> 2] = i6;
     HEAP32[i62 >> 2] = i5;
     break;
    }
    if (!(f1 < Math_fround(0.0))) {
     f69 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) + f28);
     f2 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) + f29);
     f1 = Math_fround(f27 + f30);
     HEAPF32[i35 >> 2] = f69;
     HEAPF32[i35 + 4 >> 2] = f2;
     HEAPF32[i35 + 8 >> 2] = f1;
     f32 = Math_fround(f32 - f29);
     f1 = Math_fround(f33 - f30);
     HEAPF32[i34 >> 2] = Math_fround(f31 - f28);
     HEAPF32[i34 + 4 >> 2] = f32;
     HEAPF32[i34 + 8 >> 2] = f1;
     f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
     HEAPF32[i61 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i62 >> 2]));
     f32 = Math_fround(HEAPF32[i52 >> 2]);
     f2 = Math_fround(HEAPF32[i51 >> 2]);
     f32 = Math_fround(f32 + f2);
     f33 = Math_fround(HEAPF32[i49 >> 2]);
     f69 = Math_fround(HEAPF32[i46 >> 2]);
     f33 = Math_fround(f33 + f69);
     f67 = Math_fround(HEAPF32[i50 >> 2]);
     f68 = Math_fround(HEAPF32[i48 >> 2]);
     f67 = Math_fround(f67 + f68);
     HEAPF32[i40 >> 2] = f32;
     HEAPF32[i40 + 4 >> 2] = f33;
     HEAPF32[i40 + 8 >> 2] = f67;
     f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
     f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
     f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
     HEAPF32[i41 >> 2] = f2;
     HEAPF32[i41 + 4 >> 2] = f69;
     HEAPF32[i41 + 8 >> 2] = f68;
     __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
     i6 = HEAP32[i42 >> 2] | 0;
     HEAP32[i56 >> 2] = i6;
     i5 = HEAP32[i54 >> 2] | 0;
     HEAP32[i58 >> 2] = i5;
     f68 = Math_fround(HEAPF32[i57 >> 2]);
     f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
     f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
     f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
     f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
     f2 = Math_fround(f2 - Math_fround(HEAPF32[i53 >> 2]));
     f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
     HEAPF32[i59 >> 2] = Math_fround(0.0);
     if (!(f2 < f1)) break;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     HEAP32[i61 >> 2] = i6;
     HEAP32[i62 >> 2] = i5;
     f1 = f2;
     break;
    }
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    i10 = i35 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i46 >> 2];
    i36 = i35 + 8 | 0;
    HEAP32[i36 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
    i37 = i34 + 4 | 0;
    HEAP32[i37 >> 2] = HEAP32[i49 >> 2];
    i38 = i34 + 8 | 0;
    HEAP32[i38 >> 2] = HEAP32[i50 >> 2];
    f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
    HEAPF32[i62 >> 2] = Math_fround(0.0);
    f67 = Math_fround(HEAPF32[i51 >> 2]);
    f3 = Math_fround(HEAPF32[i52 >> 2]);
    f67 = Math_fround(f67 + f3);
    f68 = Math_fround(HEAPF32[i46 >> 2]);
    f2 = Math_fround(HEAPF32[i49 >> 2]);
    f68 = Math_fround(f68 + f2);
    f69 = Math_fround(HEAPF32[i48 >> 2]);
    f1 = Math_fround(HEAPF32[i50 >> 2]);
    f69 = Math_fround(f69 + f1);
    HEAPF32[i35 >> 2] = f67;
    HEAPF32[i10 >> 2] = f68;
    HEAPF32[i36 >> 2] = f69;
    f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
    f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
    f1 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f1);
    HEAPF32[i34 >> 2] = f3;
    HEAPF32[i37 >> 2] = f2;
    HEAPF32[i38 >> 2] = f1;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
    f2 = Math_fround(HEAPF32[i58 >> 2]);
    f3 = Math_fround(Math_fround(1.0) - f2);
    HEAPF32[i56 >> 2] = f3;
    if (f1 < f4) {
     HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
     HEAPF32[i61 >> 2] = f3;
     HEAPF32[i62 >> 2] = f2;
     f2 = f1;
    } else f2 = f4;
    f32 = Math_fround(HEAPF32[i52 >> 2]);
    f1 = Math_fround(HEAPF32[i51 >> 2]);
    f32 = Math_fround(f32 + f1);
    f33 = Math_fround(HEAPF32[i49 >> 2]);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f33 = Math_fround(f33 + f69);
    f67 = Math_fround(HEAPF32[i50 >> 2]);
    f68 = Math_fround(HEAPF32[i48 >> 2]);
    f67 = Math_fround(f67 + f68);
    HEAPF32[i40 >> 2] = f32;
    HEAPF32[i40 + 4 >> 2] = f33;
    HEAPF32[i40 + 8 >> 2] = f67;
    f1 = Math_fround(f1 + Math_fround(HEAPF32[i45 >> 2]));
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
    f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
    HEAPF32[i41 >> 2] = f1;
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
    i6 = HEAP32[i42 >> 2] | 0;
    HEAP32[i56 >> 2] = i6;
    i5 = HEAP32[i54 >> 2] | 0;
    HEAP32[i58 >> 2] = i5;
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
    f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f1 = Math_fround(f1 - Math_fround(HEAPF32[i53 >> 2]));
    f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
    HEAPF32[i59 >> 2] = Math_fround(0.0);
    if (!(f1 < f2)) {
     f1 = f2;
     break;
    }
    HEAPF32[i60 >> 2] = Math_fround(0.0);
    HEAP32[i61 >> 2] = i6;
    HEAP32[i62 >> 2] = i5;
    break;
   }
   i10 = f1 < Math_fround(0.0);
   if (!i5) {
    if (!i10) {
     f1 = Math_fround(HEAPF32[i51 >> 2]);
     f28 = Math_fround(f28 + f1);
     f69 = Math_fround(HEAPF32[i46 >> 2]);
     f67 = Math_fround(f29 + f69);
     f68 = Math_fround(f30 + f27);
     HEAPF32[i40 >> 2] = f28;
     HEAPF32[i40 + 4 >> 2] = f67;
     HEAPF32[i40 + 8 >> 2] = f68;
     f69 = Math_fround(f69 + f32);
     f68 = Math_fround(f27 + f33);
     HEAPF32[i41 >> 2] = Math_fround(f1 + f31);
     HEAPF32[i41 + 4 >> 2] = f69;
     HEAPF32[i41 + 8 >> 2] = f68;
     __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
     HEAP32[i61 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i62 >> 2] = HEAP32[i54 >> 2];
     f68 = Math_fround(HEAPF32[i57 >> 2]);
     f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
     f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
     f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
     f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
     f1 = Math_fround(f1 - Math_fround(HEAPF32[i53 >> 2]));
     f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     break;
    }
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i34 + 4 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i34 + 8 >> 2] = HEAP32[i50 >> 2];
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
    HEAPF32[i62 >> 2] = Math_fround(0.0);
    f32 = Math_fround(HEAPF32[i52 >> 2]);
    f2 = Math_fround(HEAPF32[i51 >> 2]);
    f32 = Math_fround(f32 + f2);
    f33 = Math_fround(HEAPF32[i49 >> 2]);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f33 = Math_fround(f33 + f69);
    f67 = Math_fround(HEAPF32[i50 >> 2]);
    f68 = Math_fround(HEAPF32[i48 >> 2]);
    f67 = Math_fround(f67 + f68);
    HEAPF32[i40 >> 2] = f32;
    HEAPF32[i40 + 4 >> 2] = f33;
    HEAPF32[i40 + 8 >> 2] = f67;
    f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
    f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
    HEAPF32[i41 >> 2] = f2;
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
    i6 = HEAP32[i42 >> 2] | 0;
    HEAP32[i56 >> 2] = i6;
    i5 = HEAP32[i54 >> 2] | 0;
    HEAP32[i58 >> 2] = i5;
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
    f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i53 >> 2]));
    f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
    HEAPF32[i59 >> 2] = Math_fround(0.0);
    if (!(f2 < f1)) break;
    HEAPF32[i60 >> 2] = Math_fround(0.0);
    HEAP32[i61 >> 2] = i6;
    HEAP32[i62 >> 2] = i5;
    f1 = f2;
    break;
   }
   HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
   i6 = i35 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i46 >> 2];
   i7 = i35 + 8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i45 >> 2];
   i8 = i34 + 4 | 0;
   HEAPF32[i8 >> 2] = f32;
   i5 = i34 + 8 | 0;
   HEAPF32[i5 >> 2] = f33;
   f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
   HEAPF32[i61 >> 2] = Math_fround(0.0);
   if (!i10) {
    f32 = Math_fround(HEAPF32[i52 >> 2]);
    f2 = Math_fround(HEAPF32[i51 >> 2]);
    f32 = Math_fround(f32 + f2);
    f33 = Math_fround(HEAPF32[i49 >> 2]);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f33 = Math_fround(f33 + f69);
    f67 = Math_fround(HEAPF32[i50 >> 2]);
    f68 = Math_fround(HEAPF32[i48 >> 2]);
    f67 = Math_fround(f67 + f68);
    HEAPF32[i40 >> 2] = f32;
    HEAPF32[i40 + 4 >> 2] = f33;
    HEAPF32[i40 + 8 >> 2] = f67;
    f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
    f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
    HEAPF32[i41 >> 2] = f2;
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
    i6 = HEAP32[i42 >> 2] | 0;
    HEAP32[i56 >> 2] = i6;
    i5 = HEAP32[i54 >> 2] | 0;
    HEAP32[i58 >> 2] = i5;
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
    f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i53 >> 2]));
    f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
    HEAPF32[i59 >> 2] = Math_fround(0.0);
    if (!(f2 < f1)) break;
    HEAPF32[i60 >> 2] = Math_fround(0.0);
    HEAP32[i61 >> 2] = i6;
    HEAP32[i62 >> 2] = i5;
    f1 = f2;
    break;
   }
   HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i50 >> 2];
   f2 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i56));
   HEAPF32[i58 >> 2] = Math_fround(0.0);
   if (f2 < f1) {
    HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i61 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i62 >> 2] = 0;
    i5 = i56;
    f1 = f2;
   } else i5 = i56;
   f32 = Math_fround(HEAPF32[i52 >> 2]);
   f2 = Math_fround(HEAPF32[i51 >> 2]);
   f32 = Math_fround(f32 + f2);
   f33 = Math_fround(HEAPF32[i49 >> 2]);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f33 = Math_fround(f33 + f69);
   f67 = Math_fround(HEAPF32[i50 >> 2]);
   f68 = Math_fround(HEAPF32[i48 >> 2]);
   f67 = Math_fround(f67 + f68);
   HEAPF32[i40 >> 2] = f32;
   HEAPF32[i40 + 4 >> 2] = f33;
   HEAPF32[i40 + 8 >> 2] = f67;
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
   f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
   f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
   HEAPF32[i41 >> 2] = f2;
   HEAPF32[i41 + 4 >> 2] = f69;
   HEAPF32[i41 + 8 >> 2] = f68;
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i55, i51, i40, i41, i42, i54);
   i6 = HEAP32[i42 >> 2] | 0;
   HEAP32[i5 >> 2] = i6;
   i5 = HEAP32[i54 >> 2] | 0;
   HEAP32[i58 >> 2] = i5;
   f68 = Math_fround(HEAPF32[i57 >> 2]);
   f68 = Math_fround(f68 - Math_fround(HEAPF32[i55 >> 2]));
   f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i47 >> 2]));
   f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i53 >> 2]));
   f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
   HEAPF32[i59 >> 2] = Math_fround(0.0);
   if (!(f2 < f1)) break;
   HEAPF32[i60 >> 2] = Math_fround(0.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
   f1 = f2;
   break;
  }
  i5 = Math_fround(f1 + f3) <= Math_fround(1.0);
  i6 = f3 < Math_fround(0.0);
  if (f2 <= Math_fround(1.0)) if (i5) {
   i10 = f1 < Math_fround(0.0);
   if (i6) {
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    i7 = i35 + 4 | 0;
    HEAP32[i7 >> 2] = HEAP32[i46 >> 2];
    i8 = i35 + 8 | 0;
    HEAP32[i8 >> 2] = HEAP32[i48 >> 2];
    HEAPF32[i34 >> 2] = f31;
    i6 = i34 + 4 | 0;
    HEAPF32[i6 >> 2] = f32;
    i5 = i34 + 8 | 0;
    HEAPF32[i5 >> 2] = f33;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
    HEAPF32[i61 >> 2] = Math_fround(0.0);
    if (!i10) break;
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i50 >> 2];
    f2 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i56));
    HEAPF32[i58 >> 2] = Math_fround(0.0);
    if (!(f2 < f1)) break;
    HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i61 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i62 >> 2] = 0;
    f1 = f2;
    break;
   } else if (i10) {
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
    HEAPF32[i34 + 4 >> 2] = f29;
    HEAPF32[i34 + 8 >> 2] = f30;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
    HEAPF32[i62 >> 2] = Math_fround(0.0);
    break;
   } else {
    f1 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f22 * f22)) + Math_fround(Math_fround(f1 * Math_fround(Math_fround(f19 * Math_fround(2.0)) + Math_fround(Math_fround(f16 * f1) + Math_fround(Math_fround(f2 * f25) + Math_fround(f15 * f3))))) + Math_fround(Math_fround(f2 * Math_fround(Math_fround(Math_fround(f1 * f25) + Math_fround(Math_fround(f24 * f2) + Math_fround(f3 * f23))) - Math_fround(f17 * Math_fround(2.0)))) + Math_fround(f3 * Math_fround(Math_fround(f18 * Math_fround(2.0)) + Math_fround(Math_fround(f15 * f1) + Math_fround(Math_fround(f2 * f23) + Math_fround(f26 * f3))))))));
    break;
   }
  } else {
   if (i6) {
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    i47 = i35 + 4 | 0;
    HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
    i53 = i35 + 8 | 0;
    HEAP32[i53 >> 2] = HEAP32[i48 >> 2];
    HEAPF32[i34 >> 2] = f31;
    i54 = i34 + 4 | 0;
    HEAPF32[i54 >> 2] = f32;
    i57 = i34 + 8 | 0;
    HEAPF32[i57 >> 2] = f33;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
    HEAPF32[i61 >> 2] = Math_fround(0.0);
    f67 = Math_fround(HEAPF32[i51 >> 2]);
    f3 = Math_fround(HEAPF32[i52 >> 2]);
    f67 = Math_fround(f67 + f3);
    f68 = Math_fround(HEAPF32[i46 >> 2]);
    f2 = Math_fround(HEAPF32[i49 >> 2]);
    f68 = Math_fround(f68 + f2);
    f69 = Math_fround(HEAPF32[i48 >> 2]);
    f4 = Math_fround(HEAPF32[i50 >> 2]);
    f69 = Math_fround(f69 + f4);
    HEAPF32[i35 >> 2] = f67;
    HEAPF32[i47 >> 2] = f68;
    HEAPF32[i53 >> 2] = f69;
    f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
    f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
    f4 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f4);
    HEAPF32[i34 >> 2] = f3;
    HEAPF32[i54 >> 2] = f2;
    HEAPF32[i57 >> 2] = f4;
    f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
    f2 = Math_fround(HEAPF32[i58 >> 2]);
    f3 = Math_fround(Math_fround(1.0) - f2);
    HEAPF32[i56 >> 2] = f3;
    if (!(f4 < f1)) break;
    HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
    HEAPF32[i61 >> 2] = f3;
    HEAPF32[i62 >> 2] = f2;
    f1 = f4;
    break;
   }
   if (!(f1 < Math_fround(0.0))) {
    f68 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) + f28);
    f1 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) + f29);
    f69 = Math_fround(f27 + f30);
    HEAPF32[i35 >> 2] = f68;
    HEAPF32[i35 + 4 >> 2] = f1;
    HEAPF32[i35 + 8 >> 2] = f69;
    f69 = Math_fround(f32 - f29);
    f1 = Math_fround(f33 - f30);
    HEAPF32[i34 >> 2] = Math_fround(f31 - f28);
    HEAPF32[i34 + 4 >> 2] = f69;
    HEAPF32[i34 + 8 >> 2] = f1;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
    HEAPF32[i61 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i62 >> 2]));
    break;
   }
   HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
   i47 = i35 + 4 | 0;
   HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
   i53 = i35 + 8 | 0;
   HEAPF32[i53 >> 2] = f27;
   HEAPF32[i34 >> 2] = f28;
   i54 = i34 + 4 | 0;
   HEAPF32[i54 >> 2] = f29;
   i57 = i34 + 8 | 0;
   HEAPF32[i57 >> 2] = f30;
   f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
   HEAPF32[i62 >> 2] = Math_fround(0.0);
   f67 = Math_fround(HEAPF32[i51 >> 2]);
   f3 = Math_fround(HEAPF32[i52 >> 2]);
   f67 = Math_fround(f67 + f3);
   f68 = Math_fround(HEAPF32[i46 >> 2]);
   f2 = Math_fround(HEAPF32[i49 >> 2]);
   f68 = Math_fround(f68 + f2);
   f69 = Math_fround(HEAPF32[i48 >> 2]);
   f4 = Math_fround(HEAPF32[i50 >> 2]);
   f69 = Math_fround(f69 + f4);
   HEAPF32[i35 >> 2] = f67;
   HEAPF32[i47 >> 2] = f68;
   HEAPF32[i53 >> 2] = f69;
   f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
   f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
   f4 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f4);
   HEAPF32[i34 >> 2] = f3;
   HEAPF32[i54 >> 2] = f2;
   HEAPF32[i57 >> 2] = f4;
   f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
   f2 = Math_fround(HEAPF32[i58 >> 2]);
   f3 = Math_fround(Math_fround(1.0) - f2);
   HEAPF32[i56 >> 2] = f3;
   if (!(f4 < f1)) break;
   HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
   HEAPF32[i61 >> 2] = f3;
   HEAPF32[i62 >> 2] = f2;
   f1 = f4;
   break;
  }
  if (!i5) {
   if (i6) {
    HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
    i6 = i35 + 4 | 0;
    HEAP32[i6 >> 2] = HEAP32[i46 >> 2];
    i7 = i35 + 8 | 0;
    HEAP32[i7 >> 2] = HEAP32[i48 >> 2];
    HEAPF32[i34 >> 2] = f31;
    i8 = i34 + 4 | 0;
    HEAPF32[i8 >> 2] = f32;
    i10 = i34 + 8 | 0;
    HEAPF32[i10 >> 2] = f33;
    f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
    HEAPF32[i61 >> 2] = Math_fround(0.0);
    f67 = Math_fround(HEAPF32[i51 >> 2]);
    f3 = Math_fround(HEAPF32[i52 >> 2]);
    f67 = Math_fround(f67 + f3);
    f68 = Math_fround(HEAPF32[i46 >> 2]);
    f2 = Math_fround(HEAPF32[i49 >> 2]);
    f68 = Math_fround(f68 + f2);
    f69 = Math_fround(HEAPF32[i48 >> 2]);
    f1 = Math_fround(HEAPF32[i50 >> 2]);
    f69 = Math_fround(f69 + f1);
    HEAPF32[i35 >> 2] = f67;
    HEAPF32[i6 >> 2] = f68;
    HEAPF32[i7 >> 2] = f69;
    f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
    f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
    f1 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f1);
    HEAPF32[i34 >> 2] = f3;
    HEAPF32[i8 >> 2] = f2;
    HEAPF32[i10 >> 2] = f1;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
    f2 = Math_fround(HEAPF32[i58 >> 2]);
    f3 = Math_fround(Math_fround(1.0) - f2);
    HEAPF32[i56 >> 2] = f3;
    if (f1 < f4) {
     HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
     HEAPF32[i61 >> 2] = f3;
     HEAPF32[i62 >> 2] = f2;
     f2 = f1;
    } else f2 = f4;
    f33 = Math_fround(HEAPF32[i55 >> 2]);
    f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
    f1 = Math_fround(HEAPF32[i47 >> 2]);
    f1 = Math_fround(f1 + Math_fround(HEAPF32[i36 >> 2]));
    f32 = Math_fround(HEAPF32[i53 >> 2]);
    f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
    HEAPF32[i38 >> 2] = f33;
    i53 = i38 + 4 | 0;
    HEAPF32[i53 >> 2] = f1;
    i55 = i38 + 8 | 0;
    HEAPF32[i55 >> 2] = f32;
    f32 = Math_fround(HEAPF32[i52 >> 2]);
    f1 = Math_fround(HEAPF32[i51 >> 2]);
    f32 = Math_fround(f32 + f1);
    f33 = Math_fround(HEAPF32[i49 >> 2]);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f33 = Math_fround(f33 + f69);
    f67 = Math_fround(HEAPF32[i50 >> 2]);
    f68 = Math_fround(HEAPF32[i48 >> 2]);
    f67 = Math_fround(f67 + f68);
    HEAPF32[i40 >> 2] = f32;
    HEAPF32[i40 + 4 >> 2] = f33;
    HEAPF32[i40 + 8 >> 2] = f67;
    f1 = Math_fround(f1 + Math_fround(HEAPF32[i45 >> 2]));
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
    f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
    HEAPF32[i41 >> 2] = f1;
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
    i6 = HEAP32[i42 >> 2] | 0;
    HEAP32[i56 >> 2] = i6;
    i5 = HEAP32[i54 >> 2] | 0;
    HEAP32[i58 >> 2] = i5;
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
    f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f1 = Math_fround(f1 - Math_fround(HEAPF32[i55 >> 2]));
    f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
    HEAPF32[i59 >> 2] = Math_fround(1.0);
    if (!(f1 < f2)) {
     f1 = f2;
     break;
    }
    HEAPF32[i60 >> 2] = Math_fround(1.0);
    HEAP32[i61 >> 2] = i6;
    HEAP32[i62 >> 2] = i5;
    break;
   }
   if (!(f1 < Math_fround(0.0))) {
    f69 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) + f28);
    f1 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) + f29);
    f2 = Math_fround(f27 + f30);
    HEAPF32[i35 >> 2] = f69;
    HEAPF32[i35 + 4 >> 2] = f1;
    HEAPF32[i35 + 8 >> 2] = f2;
    f2 = Math_fround(f32 - f29);
    f1 = Math_fround(f33 - f30);
    HEAPF32[i34 >> 2] = Math_fround(f31 - f28);
    HEAPF32[i34 + 4 >> 2] = f2;
    HEAPF32[i34 + 8 >> 2] = f1;
    f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
    HEAPF32[i61 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i62 >> 2]));
    f33 = Math_fround(HEAPF32[i55 >> 2]);
    f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
    f2 = Math_fround(HEAPF32[i47 >> 2]);
    f2 = Math_fround(f2 + Math_fround(HEAPF32[i36 >> 2]));
    f32 = Math_fround(HEAPF32[i53 >> 2]);
    f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
    HEAPF32[i38 >> 2] = f33;
    i53 = i38 + 4 | 0;
    HEAPF32[i53 >> 2] = f2;
    i55 = i38 + 8 | 0;
    HEAPF32[i55 >> 2] = f32;
    f32 = Math_fround(HEAPF32[i52 >> 2]);
    f2 = Math_fround(HEAPF32[i51 >> 2]);
    f32 = Math_fround(f32 + f2);
    f33 = Math_fround(HEAPF32[i49 >> 2]);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f33 = Math_fround(f33 + f69);
    f67 = Math_fround(HEAPF32[i50 >> 2]);
    f68 = Math_fround(HEAPF32[i48 >> 2]);
    f67 = Math_fround(f67 + f68);
    HEAPF32[i40 >> 2] = f32;
    HEAPF32[i40 + 4 >> 2] = f33;
    HEAPF32[i40 + 8 >> 2] = f67;
    f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
    f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
    HEAPF32[i41 >> 2] = f2;
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
    i6 = HEAP32[i42 >> 2] | 0;
    HEAP32[i56 >> 2] = i6;
    i5 = HEAP32[i54 >> 2] | 0;
    HEAP32[i58 >> 2] = i5;
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
    f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
    f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
    HEAPF32[i59 >> 2] = Math_fround(1.0);
    if (!(f2 < f1)) break;
    HEAPF32[i60 >> 2] = Math_fround(1.0);
    HEAP32[i61 >> 2] = i6;
    HEAP32[i62 >> 2] = i5;
    f1 = f2;
    break;
   }
   HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
   i6 = i35 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i46 >> 2];
   i7 = i35 + 8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
   i8 = i34 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i49 >> 2];
   i10 = i34 + 8 | 0;
   HEAPF32[i10 >> 2] = f30;
   f4 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
   HEAPF32[i62 >> 2] = Math_fround(0.0);
   f67 = Math_fround(HEAPF32[i51 >> 2]);
   f3 = Math_fround(HEAPF32[i52 >> 2]);
   f67 = Math_fround(f67 + f3);
   f68 = Math_fround(HEAPF32[i46 >> 2]);
   f2 = Math_fround(HEAPF32[i49 >> 2]);
   f68 = Math_fround(f68 + f2);
   f69 = Math_fround(HEAPF32[i48 >> 2]);
   f1 = Math_fround(HEAPF32[i50 >> 2]);
   f69 = Math_fround(f69 + f1);
   HEAPF32[i35 >> 2] = f67;
   HEAPF32[i6 >> 2] = f68;
   HEAPF32[i7 >> 2] = f69;
   f3 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f3);
   f2 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f2);
   f1 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f1);
   HEAPF32[i34 >> 2] = f3;
   HEAPF32[i8 >> 2] = f2;
   HEAPF32[i10 >> 2] = f1;
   f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i58));
   f2 = Math_fround(HEAPF32[i58 >> 2]);
   f3 = Math_fround(Math_fround(1.0) - f2);
   HEAPF32[i56 >> 2] = f3;
   if (f1 < f4) {
    HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
    HEAPF32[i61 >> 2] = f3;
    HEAPF32[i62 >> 2] = f2;
    f2 = f1;
   } else f2 = f4;
   f33 = Math_fround(HEAPF32[i55 >> 2]);
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
   f1 = Math_fround(HEAPF32[i47 >> 2]);
   f1 = Math_fround(f1 + Math_fround(HEAPF32[i36 >> 2]));
   f32 = Math_fround(HEAPF32[i53 >> 2]);
   f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
   HEAPF32[i38 >> 2] = f33;
   i53 = i38 + 4 | 0;
   HEAPF32[i53 >> 2] = f1;
   i55 = i38 + 8 | 0;
   HEAPF32[i55 >> 2] = f32;
   f32 = Math_fround(HEAPF32[i52 >> 2]);
   f1 = Math_fround(HEAPF32[i51 >> 2]);
   f32 = Math_fround(f32 + f1);
   f33 = Math_fround(HEAPF32[i49 >> 2]);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f33 = Math_fround(f33 + f69);
   f67 = Math_fround(HEAPF32[i50 >> 2]);
   f68 = Math_fround(HEAPF32[i48 >> 2]);
   f67 = Math_fround(f67 + f68);
   HEAPF32[i40 >> 2] = f32;
   HEAPF32[i40 + 4 >> 2] = f33;
   HEAPF32[i40 + 8 >> 2] = f67;
   f1 = Math_fround(f1 + Math_fround(HEAPF32[i45 >> 2]));
   f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
   f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
   HEAPF32[i41 >> 2] = f1;
   HEAPF32[i41 + 4 >> 2] = f69;
   HEAPF32[i41 + 8 >> 2] = f68;
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
   i6 = HEAP32[i42 >> 2] | 0;
   HEAP32[i56 >> 2] = i6;
   i5 = HEAP32[i54 >> 2] | 0;
   HEAP32[i58 >> 2] = i5;
   f68 = Math_fround(HEAPF32[i57 >> 2]);
   f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
   f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
   f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   f1 = Math_fround(f1 - Math_fround(HEAPF32[i55 >> 2]));
   f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
   HEAPF32[i59 >> 2] = Math_fround(1.0);
   if (!(f1 < f2)) {
    f1 = f2;
    break;
   }
   HEAPF32[i60 >> 2] = Math_fround(1.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
   break;
  }
  i10 = f1 < Math_fround(0.0);
  if (!i6) {
   if (!i10) {
    f67 = Math_fround(HEAPF32[i55 >> 2]);
    f67 = Math_fround(f67 + Math_fround(HEAPF32[i39 >> 2]));
    f69 = Math_fround(HEAPF32[i47 >> 2]);
    f69 = Math_fround(f69 + Math_fround(HEAPF32[i36 >> 2]));
    f1 = Math_fround(HEAPF32[i53 >> 2]);
    f1 = Math_fround(f1 + Math_fround(HEAPF32[i37 >> 2]));
    HEAPF32[i38 >> 2] = f67;
    i58 = i38 + 4 | 0;
    HEAPF32[i58 >> 2] = f69;
    i59 = i38 + 8 | 0;
    HEAPF32[i59 >> 2] = f1;
    f1 = Math_fround(HEAPF32[i51 >> 2]);
    f28 = Math_fround(f28 + f1);
    f69 = Math_fround(HEAPF32[i46 >> 2]);
    f67 = Math_fround(f29 + f69);
    f68 = Math_fround(f30 + f27);
    HEAPF32[i40 >> 2] = f28;
    HEAPF32[i40 + 4 >> 2] = f67;
    HEAPF32[i40 + 8 >> 2] = f68;
    f69 = Math_fround(f69 + f32);
    f68 = Math_fround(f27 + f33);
    HEAPF32[i41 >> 2] = Math_fround(f1 + f31);
    HEAPF32[i41 + 4 >> 2] = f69;
    HEAPF32[i41 + 8 >> 2] = f68;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
    HEAP32[i61 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i62 >> 2] = HEAP32[i54 >> 2];
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
    f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f69 = Math_fround(f69 - Math_fround(HEAPF32[i58 >> 2]));
    f1 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f1 = Math_fround(f1 - Math_fround(HEAPF32[i59 >> 2]));
    f1 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f1 * f1));
    HEAPF32[i60 >> 2] = Math_fround(1.0);
    break;
   }
   HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i35 + 4 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i35 + 8 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i50 >> 2];
   f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i61));
   HEAPF32[i62 >> 2] = Math_fround(0.0);
   f33 = Math_fround(HEAPF32[i55 >> 2]);
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i36 >> 2]));
   f32 = Math_fround(HEAPF32[i53 >> 2]);
   f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
   HEAPF32[i38 >> 2] = f33;
   i53 = i38 + 4 | 0;
   HEAPF32[i53 >> 2] = f2;
   i55 = i38 + 8 | 0;
   HEAPF32[i55 >> 2] = f32;
   f32 = Math_fround(HEAPF32[i52 >> 2]);
   f2 = Math_fround(HEAPF32[i51 >> 2]);
   f32 = Math_fround(f32 + f2);
   f33 = Math_fround(HEAPF32[i49 >> 2]);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f33 = Math_fround(f33 + f69);
   f67 = Math_fround(HEAPF32[i50 >> 2]);
   f68 = Math_fround(HEAPF32[i48 >> 2]);
   f67 = Math_fround(f67 + f68);
   HEAPF32[i40 >> 2] = f32;
   HEAPF32[i40 + 4 >> 2] = f33;
   HEAPF32[i40 + 8 >> 2] = f67;
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
   f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
   f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
   HEAPF32[i41 >> 2] = f2;
   HEAPF32[i41 + 4 >> 2] = f69;
   HEAPF32[i41 + 8 >> 2] = f68;
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
   i6 = HEAP32[i42 >> 2] | 0;
   HEAP32[i56 >> 2] = i6;
   i5 = HEAP32[i54 >> 2] | 0;
   HEAP32[i58 >> 2] = i5;
   f68 = Math_fround(HEAPF32[i57 >> 2]);
   f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
   f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
   f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
   f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
   HEAPF32[i59 >> 2] = Math_fround(1.0);
   if (!(f2 < f1)) break;
   HEAPF32[i60 >> 2] = Math_fround(1.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
   f1 = f2;
   break;
  }
  HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
  i7 = i35 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i46 >> 2];
  i8 = i35 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i48 >> 2];
  HEAPF32[i34 >> 2] = f31;
  i6 = i34 + 4 | 0;
  HEAPF32[i6 >> 2] = f32;
  i5 = i34 + 8 | 0;
  HEAPF32[i5 >> 2] = f33;
  f1 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i60, i62));
  HEAPF32[i61 >> 2] = Math_fround(0.0);
  if (!i10) {
   f33 = Math_fround(HEAPF32[i55 >> 2]);
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i36 >> 2]));
   f32 = Math_fround(HEAPF32[i53 >> 2]);
   f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
   HEAPF32[i38 >> 2] = f33;
   i53 = i38 + 4 | 0;
   HEAPF32[i53 >> 2] = f2;
   i55 = i38 + 8 | 0;
   HEAPF32[i55 >> 2] = f32;
   f32 = Math_fround(HEAPF32[i52 >> 2]);
   f2 = Math_fround(HEAPF32[i51 >> 2]);
   f32 = Math_fround(f32 + f2);
   f33 = Math_fround(HEAPF32[i49 >> 2]);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f33 = Math_fround(f33 + f69);
   f67 = Math_fround(HEAPF32[i50 >> 2]);
   f68 = Math_fround(HEAPF32[i48 >> 2]);
   f67 = Math_fround(f67 + f68);
   HEAPF32[i40 >> 2] = f32;
   HEAPF32[i40 + 4 >> 2] = f33;
   HEAPF32[i40 + 8 >> 2] = f67;
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
   f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
   f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
   HEAPF32[i41 >> 2] = f2;
   HEAPF32[i41 + 4 >> 2] = f69;
   HEAPF32[i41 + 8 >> 2] = f68;
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
   i6 = HEAP32[i42 >> 2] | 0;
   HEAP32[i56 >> 2] = i6;
   i5 = HEAP32[i54 >> 2] | 0;
   HEAP32[i58 >> 2] = i5;
   f68 = Math_fround(HEAPF32[i57 >> 2]);
   f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
   f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i53 >> 2]));
   f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
   f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
   HEAPF32[i59 >> 2] = Math_fround(1.0);
   if (!(f2 < f1)) break;
   HEAPF32[i60 >> 2] = Math_fround(1.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
   f1 = f2;
   break;
  }
  HEAP32[i35 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i34 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i50 >> 2];
  f2 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i55, i39, i35, i34, i59, i56));
  HEAPF32[i58 >> 2] = Math_fround(0.0);
  if (f2 < f1) {
   HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i61 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i62 >> 2] = 0;
   i5 = i56;
   f1 = f2;
  } else i5 = i56;
  f33 = Math_fround(HEAPF32[i55 >> 2]);
  f33 = Math_fround(f33 + Math_fround(HEAPF32[i39 >> 2]));
  f2 = Math_fround(HEAPF32[i47 >> 2]);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i36 >> 2]));
  f32 = Math_fround(HEAPF32[i53 >> 2]);
  f32 = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
  HEAPF32[i38 >> 2] = f33;
  i55 = i38 + 4 | 0;
  HEAPF32[i55 >> 2] = f2;
  i56 = i38 + 8 | 0;
  HEAPF32[i56 >> 2] = f32;
  f32 = Math_fround(HEAPF32[i52 >> 2]);
  f2 = Math_fround(HEAPF32[i51 >> 2]);
  f32 = Math_fround(f32 + f2);
  f33 = Math_fround(HEAPF32[i49 >> 2]);
  f69 = Math_fround(HEAPF32[i46 >> 2]);
  f33 = Math_fround(f33 + f69);
  f67 = Math_fround(HEAPF32[i50 >> 2]);
  f68 = Math_fround(HEAPF32[i48 >> 2]);
  f67 = Math_fround(f67 + f68);
  HEAPF32[i40 >> 2] = f32;
  HEAPF32[i40 + 4 >> 2] = f33;
  HEAPF32[i40 + 8 >> 2] = f67;
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i45 >> 2]));
  f69 = Math_fround(f69 + Math_fround(HEAPF32[i43 >> 2]));
  f68 = Math_fround(f68 + Math_fround(HEAPF32[i44 >> 2]));
  HEAPF32[i41 >> 2] = f2;
  HEAPF32[i41 + 4 >> 2] = f69;
  HEAPF32[i41 + 8 >> 2] = f68;
  __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i57, i38, i51, i40, i41, i42, i54);
  i6 = HEAP32[i42 >> 2] | 0;
  HEAP32[i5 >> 2] = i6;
  i5 = HEAP32[i54 >> 2] | 0;
  HEAP32[i58 >> 2] = i5;
  f68 = Math_fround(HEAPF32[i57 >> 2]);
  f68 = Math_fround(f68 - Math_fround(HEAPF32[i38 >> 2]));
  f69 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f69 = Math_fround(f69 - Math_fround(HEAPF32[i55 >> 2]));
  f2 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i56 >> 2]));
  f2 = Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f69 * f69)) + Math_fround(f2 * f2));
  HEAPF32[i59 >> 2] = Math_fround(1.0);
  if (f2 < f1) {
   HEAPF32[i60 >> 2] = Math_fround(1.0);
   HEAP32[i61 >> 2] = i6;
   HEAP32[i62 >> 2] = i5;
   f1 = f2;
  }
 } while (0);
 if (i63 | 0) HEAP32[i63 >> 2] = HEAP32[i60 >> 2];
 if (i64 | 0) HEAP32[i64 >> 2] = HEAP32[i61 >> 2];
 if (i65 | 0) HEAP32[i65 >> 2] = HEAP32[i62 >> 2];
 i65 = f1 < Math_fround(0.0);
 f69 = i65 ? Math_fround(0.0) : f1;
 STACKTOP = i66;
 return Math_fround(f69);
}

function __ZN13InitialModule5StartERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fjf(i6, i1, i192, i3, i8, f2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i192 = i192 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f7 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, f205 = f0, f206 = f0, f207 = f0, f208 = f0, f209 = f0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0;
 i197 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i193 = i197 + 32 | 0;
 i194 = i197 + 16 | 0;
 i195 = i197;
 f2 = Math_fround(f2 / Math_fround(HEAPF32[i1 + 264 >> 2]));
 HEAPF32[i193 + 12 >> 2] = f2;
 HEAPF32[i193 + 8 >> 2] = f2;
 HEAPF32[i193 + 4 >> 2] = f2;
 HEAPF32[i193 >> 2] = f2;
 i189 = HEAP32[i3 + 48 >> 2] | 0;
 i190 = HEAP32[i3 + 52 >> 2] | 0;
 i191 = HEAP32[i3 + 56 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f185 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f186 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f185 * f185) + Math_fround(0.0)));
 f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f186))));
 f2 = Math_fround(f2 * f5);
 f4 = Math_fround(f4 * f5);
 f5 = Math_fround(f185 * f5);
 i1 = f186 > Math_fround(9.99999974e-06);
 i188 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i187 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i179 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 f180 = Math_fround(HEAPF32[i6 + 2540 >> 2]);
 i1 = HEAP32[i6 + 2620 >> 2] | 0;
 f181 = Math_fround(HEAPF32[i6 + 2624 >> 2]);
 f182 = Math_fround(HEAPF32[i6 + 2628 >> 2]);
 f183 = Math_fround(HEAPF32[i6 + 2632 >> 2]);
 f184 = Math_fround(HEAPF32[i6 + 2636 >> 2]);
 f185 = Math_fround(HEAPF32[i6 + 2640 >> 2]);
 f186 = Math_fround(HEAPF32[i6 + 2644 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 2648 >> 2]);
 f12 = Math_fround(f2 * f2);
 f4 = Math_fround(HEAPF32[i6 + 2652 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f4 * f4));
 f5 = Math_fround(HEAPF32[i6 + 2656 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f5 * f5));
 if (f12 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  i107 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i105 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i103 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i103 = 0;
  i105 = 0;
  i107 = 1065353216;
 }
 i157 = HEAP32[i192 + 12 >> 2] | 0;
 if (i157 >>> 0 <= i8 >>> 0) {
  STACKTOP = i197;
  return;
 }
 i158 = i6 + 2556 | 0;
 i159 = i6 + 2560 | 0;
 i160 = i6 + 2564 | 0;
 i161 = i6 + 2568 | 0;
 i162 = i6 + 2572 | 0;
 i163 = i6 + 2576 | 0;
 i164 = i6 + 2580 | 0;
 i165 = i6 + 2584 | 0;
 i166 = i6 + 2588 | 0;
 i167 = i6 + 2592 | 0;
 i168 = i6 + 2596 | 0;
 i169 = i6 + 2600 | 0;
 i170 = i6 + 2604 | 0;
 i171 = i6 + 2608 | 0;
 i172 = i6 + 2612 | 0;
 i173 = i6 + 2616 | 0;
 i174 = i192 + 500 | 0;
 i175 = i192 + 20 | 0;
 i176 = i192 + 40 | 0;
 i177 = i192 + 60 | 0;
 i178 = i192 + 80 | 0;
 i109 = i192 + 100 | 0;
 i110 = i192 + 120 | 0;
 i111 = i192 + 140 | 0;
 i112 = i192 + 160 | 0;
 i113 = i192 + 520 | 0;
 i114 = i6 + 8 | 0;
 i115 = i195 + 4 | 0;
 i116 = i195 + 8 | 0;
 i117 = i195 + 12 | 0;
 i118 = i6 + 92 | 0;
 i119 = i194 + 4 | 0;
 i120 = i194 + 8 | 0;
 i121 = i194 + 12 | 0;
 i122 = i192 + 540 | 0;
 i123 = i192 + 871 | 0;
 i124 = i6 + 692 | 0;
 i125 = i195 + 4 | 0;
 i126 = i195 + 8 | 0;
 i127 = i195 + 12 | 0;
 i128 = i6 + 776 | 0;
 i129 = i194 + 4 | 0;
 i130 = i194 + 8 | 0;
 i131 = i194 + 12 | 0;
 i132 = i192 + 420 | 0;
 i133 = i6 + 772 | 0;
 i134 = i6 + 924 | 0;
 i135 = i6 + 836 | 0;
 i136 = i6 + 2012 | 0;
 i137 = i195 + 4 | 0;
 i138 = i195 + 8 | 0;
 i139 = i195 + 12 | 0;
 i140 = i6 + 2096 | 0;
 i141 = i194 + 4 | 0;
 i142 = i194 + 8 | 0;
 i143 = i194 + 12 | 0;
 i144 = i192 + 340 | 0;
 i145 = i192 + 870 | 0;
 i146 = i192 + 869 | 0;
 i147 = i192 + 872 | 0;
 i148 = i6 + 536 | 0;
 i149 = i195 + 4 | 0;
 i150 = i195 + 8 | 0;
 i151 = i195 + 12 | 0;
 i152 = i6 + 676 | 0;
 i153 = i6 + 604 | 0;
 i108 = i194 + 4 | 0;
 i104 = i194 + 8 | 0;
 i106 = i194 + 12 | 0;
 i154 = i1 & 255;
 i155 = i1 >>> 8 & 255;
 i156 = i1 >>> 16 & 255;
 i26 = i1 >>> 24;
 i27 = i192 + 480 | 0;
 i28 = i192 + 868 | 0;
 i29 = i192 + 240 | 0;
 i30 = i192 + 260 | 0;
 i31 = i192 + 280 | 0;
 i32 = i192 + 880 | 0;
 i33 = i192 + 873 | 0;
 i34 = i192 + 876 | 0;
 i35 = i192 + 874 | 0;
 i36 = i192 + 824 | 0;
 i37 = i192 + 760 | 0;
 i38 = i192 + 780 | 0;
 i39 = i192 + 800 | 0;
 i40 = i192 + 728 | 0;
 i41 = i192 + 608 | 0;
 i42 = i192 + 180 | 0;
 i43 = i192 + 200 | 0;
 i44 = i192 + 220 | 0;
 i45 = i192 + 400 | 0;
 i46 = i192 + 360 | 0;
 i47 = i192 + 380 | 0;
 i48 = i6 + 2553 | 0;
 i49 = i192 + 300 | 0;
 i50 = i192 + 320 | 0;
 i51 = i6 + 1484 | 0;
 i52 = i195 + 4 | 0;
 i53 = i195 + 8 | 0;
 i54 = i195 + 12 | 0;
 i55 = i6 + 1568 | 0;
 i56 = i194 + 4 | 0;
 i57 = i194 + 8 | 0;
 i58 = i194 + 12 | 0;
 i59 = i6 + 1748 | 0;
 i60 = i195 + 4 | 0;
 i61 = i195 + 8 | 0;
 i62 = i195 + 12 | 0;
 i63 = i6 + 1832 | 0;
 i64 = i194 + 4 | 0;
 i65 = i194 + 8 | 0;
 i66 = i194 + 12 | 0;
 i67 = i6 + 1828 | 0;
 i68 = i6 + 1980 | 0;
 i69 = i6 + 1892 | 0;
 i70 = i6 + 1564 | 0;
 i71 = i6 + 1716 | 0;
 i72 = i6 + 1628 | 0;
 i73 = i6 + 2092 | 0;
 i74 = i6 + 2244 | 0;
 i75 = i6 + 2156 | 0;
 i76 = i195 + 4 | 0;
 i77 = i195 + 8 | 0;
 i78 = i195 + 12 | 0;
 i79 = i194 + 4 | 0;
 i80 = i194 + 8 | 0;
 i81 = i194 + 12 | 0;
 i82 = i6 + 2552 | 0;
 i23 = i194 + 4 | 0;
 i25 = i194 + 8 | 0;
 i21 = i194 + 12 | 0;
 i83 = i192 + 440 | 0;
 i22 = i194 + 4 | 0;
 i24 = i194 + 8 | 0;
 i20 = i194 + 12 | 0;
 i84 = i192 + 460 | 0;
 i85 = i6 + 1220 | 0;
 i86 = i195 + 4 | 0;
 i87 = i195 + 8 | 0;
 i88 = i195 + 12 | 0;
 i89 = i6 + 1304 | 0;
 i90 = i6 + 1300 | 0;
 i91 = i6 + 1452 | 0;
 i92 = i6 + 1364 | 0;
 i93 = i6 + 956 | 0;
 i94 = i195 + 4 | 0;
 i95 = i195 + 8 | 0;
 i96 = i195 + 12 | 0;
 i97 = i6 + 1040 | 0;
 i98 = i6 + 1036 | 0;
 i99 = i6 + 1188 | 0;
 i100 = i6 + 1100 | 0;
 i101 = i6 + 88 | 0;
 i102 = i6 + 240 | 0;
 i15 = i6 + 152 | 0;
 i16 = i192 + 844 | 0;
 i17 = i192 + 864 | 0;
 i18 = i192 + 848 | 0;
 i19 = i192 + 828 | 0;
 do {
  i14 = HEAP32[i158 >> 2] | 0;
  i13 = HEAP32[i159 >> 2] | 0;
  i6 = HEAP32[i160 >> 2] | 0;
  i3 = HEAP32[i161 >> 2] | 0;
  i14 = i14 << 11 ^ i14;
  i13 = i13 << 11 ^ i13;
  i6 = i6 << 11 ^ i6;
  i3 = i3 << 11 ^ i3;
  i201 = HEAP32[i163 >> 2] | 0;
  i202 = HEAP32[i164 >> 2] | 0;
  i203 = HEAP32[i165 >> 2] | 0;
  HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
  HEAP32[i159 >> 2] = i201;
  HEAP32[i160 >> 2] = i202;
  HEAP32[i161 >> 2] = i203;
  i203 = HEAP32[i167 >> 2] | 0;
  i202 = HEAP32[i168 >> 2] | 0;
  i201 = HEAP32[i169 >> 2] | 0;
  HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
  HEAP32[i163 >> 2] = i203;
  HEAP32[i164 >> 2] = i202;
  HEAP32[i165 >> 2] = i201;
  i201 = HEAP32[i170 >> 2] | 0;
  i202 = HEAP32[i171 >> 2] | 0;
  i203 = HEAP32[i172 >> 2] | 0;
  i204 = HEAP32[i173 >> 2] | 0;
  HEAP32[i166 >> 2] = i201;
  HEAP32[i167 >> 2] = i202;
  HEAP32[i168 >> 2] = i203;
  HEAP32[i169 >> 2] = i204;
  i201 = i14 >>> 8 ^ i14 ^ i201 ^ i201 >>> 19;
  i202 = i13 >>> 8 ^ i13 ^ i202 ^ i202 >>> 19;
  i203 = i6 >>> 8 ^ i6 ^ i203 ^ i203 >>> 19;
  i204 = i3 >>> 8 ^ i3 ^ i204 ^ i204 >>> 19;
  HEAP32[i170 >> 2] = i201;
  HEAP32[i171 >> 2] = i202;
  HEAP32[i172 >> 2] = i203;
  HEAP32[i173 >> 2] = i204;
  i3 = (HEAP32[i174 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i3 >> 2] = i201;
  HEAP32[i3 + 4 >> 2] = i202;
  HEAP32[i3 + 8 >> 2] = i203;
  HEAP32[i3 + 12 >> 2] = i204;
  i201 = i201 + -13913692 | 0;
  i202 = i202 + -13913692 | 0;
  i203 = i203 + -13913692 | 0;
  i204 = i204 + -13913692 | 0;
  i3 = (Math_imul(i201, 1790253981) | 0) + 1900727103 | 0;
  i6 = (Math_imul(i202, 1790253981) | 0) + 1900727103 | 0;
  i13 = (Math_imul(i203, 1790253981) | 0) + 1900727103 | 0;
  i14 = (Math_imul(i204, 1790253981) | 0) + 1900727103 | 0;
  i201 = i201 << 11 ^ i201;
  i202 = i202 << 11 ^ i202;
  i203 = i203 << 11 ^ i203;
  i204 = i204 << 11 ^ i204;
  i3 = Math_fround(Math_fround((i3 ^ i201 ^ i201 >>> 8) & 8388607 ^ i3 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f180;
  i6 = Math_fround(Math_fround((i6 ^ i202 ^ i202 >>> 8) & 8388607 ^ i6 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f180;
  i13 = Math_fround(Math_fround((i13 ^ i203 ^ i203 >>> 8) & 8388607 ^ i13 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f180;
  i14 = Math_fround(Math_fround((i14 ^ i204 ^ i204 >>> 8) & 8388607 ^ i14 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f180;
  i204 = (HEAP32[i192 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i189;
  HEAP32[i204 + 4 >> 2] = i189;
  HEAP32[i204 + 8 >> 2] = i189;
  HEAP32[i204 + 12 >> 2] = i189;
  i204 = (HEAP32[i175 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i190;
  HEAP32[i204 + 4 >> 2] = i190;
  HEAP32[i204 + 8 >> 2] = i190;
  HEAP32[i204 + 12 >> 2] = i190;
  i204 = (HEAP32[i176 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i191;
  HEAP32[i204 + 4 >> 2] = i191;
  HEAP32[i204 + 8 >> 2] = i191;
  HEAP32[i204 + 12 >> 2] = i191;
  i204 = (HEAP32[i177 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i188;
  HEAP32[i204 + 4 >> 2] = i188;
  HEAP32[i204 + 8 >> 2] = i188;
  HEAP32[i204 + 12 >> 2] = i188;
  i204 = (HEAP32[i178 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i187;
  HEAP32[i204 + 4 >> 2] = i187;
  HEAP32[i204 + 8 >> 2] = i187;
  HEAP32[i204 + 12 >> 2] = i187;
  i204 = (HEAP32[i109 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = i179;
  HEAP32[i204 + 4 >> 2] = i179;
  HEAP32[i204 + 8 >> 2] = i179;
  HEAP32[i204 + 12 >> 2] = i179;
  i204 = (HEAP32[i110 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = 0;
  HEAP32[i204 + 4 >> 2] = 0;
  HEAP32[i204 + 8 >> 2] = 0;
  HEAP32[i204 + 12 >> 2] = 0;
  i204 = (HEAP32[i111 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = 0;
  HEAP32[i204 + 4 >> 2] = 0;
  HEAP32[i204 + 8 >> 2] = 0;
  HEAP32[i204 + 12 >> 2] = 0;
  i204 = (HEAP32[i112 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = 0;
  HEAP32[i204 + 4 >> 2] = 0;
  HEAP32[i204 + 8 >> 2] = 0;
  HEAP32[i204 + 12 >> 2] = 0;
  i204 = (HEAP32[i113 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = 0;
  HEAP32[i204 + 4 >> 2] = 0;
  HEAP32[i204 + 8 >> 2] = 0;
  HEAP32[i204 + 12 >> 2] = 0;
  i204 = HEAP32[i158 >> 2] | 0;
  i203 = HEAP32[i159 >> 2] | 0;
  i202 = HEAP32[i160 >> 2] | 0;
  i201 = HEAP32[i161 >> 2] | 0;
  i204 = i204 << 11 ^ i204;
  i203 = i203 << 11 ^ i203;
  i202 = i202 << 11 ^ i202;
  i201 = i201 << 11 ^ i201;
  i200 = HEAP32[i163 >> 2] | 0;
  i199 = HEAP32[i164 >> 2] | 0;
  i198 = HEAP32[i165 >> 2] | 0;
  HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
  HEAP32[i159 >> 2] = i200;
  HEAP32[i160 >> 2] = i199;
  HEAP32[i161 >> 2] = i198;
  i198 = HEAP32[i167 >> 2] | 0;
  i199 = HEAP32[i168 >> 2] | 0;
  i200 = HEAP32[i169 >> 2] | 0;
  HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
  HEAP32[i163 >> 2] = i198;
  HEAP32[i164 >> 2] = i199;
  HEAP32[i165 >> 2] = i200;
  i200 = HEAP32[i170 >> 2] | 0;
  i199 = HEAP32[i171 >> 2] | 0;
  i198 = HEAP32[i172 >> 2] | 0;
  i1 = HEAP32[i173 >> 2] | 0;
  HEAP32[i166 >> 2] = i200;
  HEAP32[i167 >> 2] = i199;
  HEAP32[i168 >> 2] = i198;
  HEAP32[i169 >> 2] = i1;
  i200 = i204 >>> 8 ^ i204 ^ i200 ^ i200 >>> 19;
  i199 = i203 >>> 8 ^ i203 ^ i199 ^ i199 >>> 19;
  i198 = i202 >>> 8 ^ i202 ^ i198 ^ i198 >>> 19;
  i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
  HEAP32[i170 >> 2] = i200;
  HEAP32[i171 >> 2] = i199;
  HEAP32[i172 >> 2] = i198;
  HEAP32[i173 >> 2] = i1;
  f2 = Math_fround(Math_fround(i200 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(Math_fround(i199 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f5 = Math_fround(Math_fround(i198 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i195 >> 2] = f2;
  HEAPF32[i115 >> 2] = f4;
  HEAPF32[i116 >> 2] = f5;
  HEAPF32[i117 >> 2] = f7;
  i1 = HEAP32[i118 >> 2] | 0;
  L9 : do switch ((i1 & 65535) << 16 >> 16) {
  case 0:
   {
    i204 = HEAP32[i101 >> 2] | 0;
    HEAP32[i121 >> 2] = i204;
    HEAP32[i120 >> 2] = i204;
    HEAP32[i119 >> 2] = i204;
    HEAP32[i194 >> 2] = i204;
    break;
   }
  case 3:
   {
    f205 = Math_fround(HEAPF32[(HEAP32[i102 >> 2] | 0) + 4 >> 2]);
    f9 = Math_fround(HEAPF32[i101 >> 2]);
    f205 = Math_fround(f205 * f9);
    f9 = Math_fround(Math_fround(f9 * Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2])) - f205);
    f10 = Math_fround(f205 + Math_fround(f9 * f4));
    f11 = Math_fround(f205 + Math_fround(f9 * f5));
    f12 = Math_fround(f205 + Math_fround(f7 * f9));
    HEAPF32[i194 >> 2] = Math_fround(f205 + Math_fround(f2 * f9));
    HEAPF32[i119 >> 2] = f10;
    HEAPF32[i120 >> 2] = f11;
    HEAPF32[i121 >> 2] = f12;
    break;
   }
  default:
   if (!(i1 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i114, i193, i195);
    break L9;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i114, i193, i195);
    break L9;
   }
  } while (0);
  f10 = Math_fround(HEAPF32[i194 >> 2]);
  i204 = f10 < Math_fround(9.99999974e-06);
  f10 = i204 ? Math_fround(9.99999974e-06) : f10;
  f11 = Math_fround(HEAPF32[i119 >> 2]);
  i204 = f11 < Math_fround(9.99999974e-06);
  f11 = i204 ? Math_fround(9.99999974e-06) : f11;
  f12 = Math_fround(HEAPF32[i120 >> 2]);
  i204 = f12 < Math_fround(9.99999974e-06);
  f12 = i204 ? Math_fround(9.99999974e-06) : f12;
  f205 = Math_fround(HEAPF32[i121 >> 2]);
  i204 = f205 < Math_fround(9.99999974e-06);
  f10 = Math_fround(Math_fround(1.0) / f10);
  f11 = Math_fround(Math_fround(1.0) / f11);
  f12 = Math_fround(Math_fround(1.0) / f12);
  f205 = Math_fround(Math_fround(1.0) / (i204 ? Math_fround(9.99999974e-06) : f205));
  i204 = (HEAP32[i122 >> 2] | 0) + (i8 << 2) | 0;
  HEAPF32[i204 >> 2] = f10;
  HEAPF32[i204 + 4 >> 2] = f11;
  HEAPF32[i204 + 8 >> 2] = f12;
  HEAPF32[i204 + 12 >> 2] = f205;
  if (!(HEAP8[i123 >> 0] | 0)) {
   i198 = HEAP32[i158 >> 2] | 0;
   i199 = HEAP32[i159 >> 2] | 0;
   i200 = HEAP32[i160 >> 2] | 0;
   i201 = HEAP32[i161 >> 2] | 0;
   i198 = i198 << 11 ^ i198;
   i199 = i199 << 11 ^ i199;
   i200 = i200 << 11 ^ i200;
   i201 = i201 << 11 ^ i201;
   i202 = HEAP32[i163 >> 2] | 0;
   i203 = HEAP32[i164 >> 2] | 0;
   i204 = HEAP32[i165 >> 2] | 0;
   HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
   HEAP32[i159 >> 2] = i202;
   HEAP32[i160 >> 2] = i203;
   HEAP32[i161 >> 2] = i204;
   i204 = HEAP32[i167 >> 2] | 0;
   i203 = HEAP32[i168 >> 2] | 0;
   i202 = HEAP32[i169 >> 2] | 0;
   HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
   HEAP32[i163 >> 2] = i204;
   HEAP32[i164 >> 2] = i203;
   HEAP32[i165 >> 2] = i202;
   i202 = HEAP32[i170 >> 2] | 0;
   i203 = HEAP32[i171 >> 2] | 0;
   i204 = HEAP32[i172 >> 2] | 0;
   i1 = HEAP32[i173 >> 2] | 0;
   HEAP32[i166 >> 2] = i202;
   HEAP32[i167 >> 2] = i203;
   HEAP32[i168 >> 2] = i204;
   HEAP32[i169 >> 2] = i1;
   i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
   i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
   i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
   i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
   HEAP32[i170 >> 2] = i202;
   HEAP32[i171 >> 2] = i203;
   HEAP32[i172 >> 2] = i204;
   HEAP32[i173 >> 2] = i1;
   f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i195 >> 2] = f2;
   HEAPF32[i125 >> 2] = f4;
   HEAPF32[i126 >> 2] = f5;
   HEAPF32[i127 >> 2] = f7;
   i1 = HEAP32[i128 >> 2] | 0;
   L19 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i204 = HEAP32[i133 >> 2] | 0;
     HEAP32[i131 >> 2] = i204;
     HEAP32[i130 >> 2] = i204;
     HEAP32[i129 >> 2] = i204;
     HEAP32[i194 >> 2] = i204;
     break;
    }
   case 3:
    {
     f9 = Math_fround(HEAPF32[(HEAP32[i134 >> 2] | 0) + 4 >> 2]);
     f10 = Math_fround(HEAPF32[i133 >> 2]);
     f9 = Math_fround(f9 * f10);
     f10 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[(HEAP32[i135 >> 2] | 0) + 4 >> 2])) - f9);
     f11 = Math_fround(f9 + Math_fround(f10 * f4));
     f12 = Math_fround(f9 + Math_fround(f10 * f5));
     f205 = Math_fround(f9 + Math_fround(f7 * f10));
     HEAPF32[i194 >> 2] = Math_fround(f9 + Math_fround(f2 * f10));
     HEAPF32[i129 >> 2] = f11;
     HEAPF32[i130 >> 2] = f12;
     HEAPF32[i131 >> 2] = f205;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i124, i193, i195);
     break L19;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i124, i193, i195);
     break L19;
    }
   } while (0);
   f10 = Math_fround(HEAPF32[i194 >> 2]);
   i204 = f10 < Math_fround(0.0);
   f10 = i204 ? Math_fround(0.0) : f10;
   f11 = Math_fround(HEAPF32[i129 >> 2]);
   i204 = f11 < Math_fround(0.0);
   f11 = i204 ? Math_fround(0.0) : f11;
   f12 = Math_fround(HEAPF32[i130 >> 2]);
   i204 = f12 < Math_fround(0.0);
   f12 = i204 ? Math_fround(0.0) : f12;
   f205 = Math_fround(HEAPF32[i131 >> 2]);
   i204 = f205 < Math_fround(0.0);
   f10 = Math_fround(f181 * f10);
   f11 = Math_fround(f181 * f11);
   f12 = Math_fround(f181 * f12);
   f205 = Math_fround(f181 * (i204 ? Math_fround(0.0) : f205));
   i204 = (HEAP32[i132 >> 2] | 0) + (i8 << 2) | 0;
   HEAPF32[i204 >> 2] = f10;
   HEAPF32[i204 + 4 >> 2] = f11;
   HEAPF32[i204 + 8 >> 2] = f12;
   HEAPF32[i204 + 12 >> 2] = f205;
  } else {
   i198 = HEAP32[i158 >> 2] | 0;
   i199 = HEAP32[i159 >> 2] | 0;
   i200 = HEAP32[i160 >> 2] | 0;
   i201 = HEAP32[i161 >> 2] | 0;
   i198 = i198 << 11 ^ i198;
   i199 = i199 << 11 ^ i199;
   i200 = i200 << 11 ^ i200;
   i201 = i201 << 11 ^ i201;
   i202 = HEAP32[i163 >> 2] | 0;
   i203 = HEAP32[i164 >> 2] | 0;
   i204 = HEAP32[i165 >> 2] | 0;
   HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
   HEAP32[i159 >> 2] = i202;
   HEAP32[i160 >> 2] = i203;
   HEAP32[i161 >> 2] = i204;
   i204 = HEAP32[i167 >> 2] | 0;
   i203 = HEAP32[i168 >> 2] | 0;
   i202 = HEAP32[i169 >> 2] | 0;
   HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
   HEAP32[i163 >> 2] = i204;
   HEAP32[i164 >> 2] = i203;
   HEAP32[i165 >> 2] = i202;
   i202 = HEAP32[i170 >> 2] | 0;
   i203 = HEAP32[i171 >> 2] | 0;
   i204 = HEAP32[i172 >> 2] | 0;
   i1 = HEAP32[i173 >> 2] | 0;
   HEAP32[i166 >> 2] = i202;
   HEAP32[i167 >> 2] = i203;
   HEAP32[i168 >> 2] = i204;
   HEAP32[i169 >> 2] = i1;
   i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
   i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
   i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
   i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
   HEAP32[i170 >> 2] = i202;
   HEAP32[i171 >> 2] = i203;
   HEAP32[i172 >> 2] = i204;
   HEAP32[i173 >> 2] = i1;
   f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i195 >> 2] = f2;
   HEAPF32[i76 >> 2] = f4;
   HEAPF32[i77 >> 2] = f5;
   HEAPF32[i78 >> 2] = f7;
   i1 = HEAP32[i128 >> 2] | 0;
   L28 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i204 = HEAP32[i133 >> 2] | 0;
     HEAP32[i81 >> 2] = i204;
     HEAP32[i80 >> 2] = i204;
     HEAP32[i79 >> 2] = i204;
     HEAP32[i194 >> 2] = i204;
     break;
    }
   case 3:
    {
     f9 = Math_fround(HEAPF32[(HEAP32[i134 >> 2] | 0) + 4 >> 2]);
     f10 = Math_fround(HEAPF32[i133 >> 2]);
     f9 = Math_fround(f9 * f10);
     f10 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[(HEAP32[i135 >> 2] | 0) + 4 >> 2])) - f9);
     f11 = Math_fround(f9 + Math_fround(f10 * f4));
     f12 = Math_fround(f9 + Math_fround(f10 * f5));
     f205 = Math_fround(f9 + Math_fround(f7 * f10));
     HEAPF32[i194 >> 2] = Math_fround(f9 + Math_fround(f2 * f10));
     HEAPF32[i79 >> 2] = f11;
     HEAPF32[i80 >> 2] = f12;
     HEAPF32[i81 >> 2] = f205;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i124, i193, i195);
     break L28;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i124, i193, i195);
     break L28;
    }
   } while (0);
   f2 = Math_fround(HEAPF32[i194 >> 2]);
   i204 = f2 < Math_fround(0.0);
   f2 = i204 ? Math_fround(0.0) : f2;
   f5 = Math_fround(HEAPF32[i79 >> 2]);
   i204 = f5 < Math_fround(0.0);
   f5 = i204 ? Math_fround(0.0) : f5;
   f4 = Math_fround(HEAPF32[i80 >> 2]);
   i204 = f4 < Math_fround(0.0);
   f4 = i204 ? Math_fround(0.0) : f4;
   f7 = Math_fround(HEAPF32[i81 >> 2]);
   i204 = f7 < Math_fround(0.0);
   f7 = i204 ? Math_fround(0.0) : f7;
   f10 = Math_fround(f181 * f2);
   f11 = Math_fround(f181 * f5);
   f12 = Math_fround(f181 * f4);
   f205 = Math_fround(f181 * f7);
   i204 = (HEAP32[i132 >> 2] | 0) + (i8 << 2) | 0;
   HEAPF32[i204 >> 2] = f10;
   HEAPF32[i204 + 4 >> 2] = f11;
   HEAPF32[i204 + 8 >> 2] = f12;
   HEAPF32[i204 + 12 >> 2] = f205;
   if (!(HEAP8[i82 >> 0] | 0)) {
    f10 = Math_fround(f182 * f2);
    f11 = Math_fround(f182 * f5);
    f12 = Math_fround(f182 * f4);
    f205 = Math_fround(f182 * f7);
    i196 = (HEAP32[i83 >> 2] | 0) + (i8 << 2) | 0;
    HEAPF32[i196 >> 2] = f10;
    HEAPF32[i196 + 4 >> 2] = f11;
    HEAPF32[i196 + 8 >> 2] = f12;
    HEAPF32[i196 + 12 >> 2] = f205;
    i196 = 35;
   } else {
    i198 = HEAP32[i158 >> 2] | 0;
    i199 = HEAP32[i159 >> 2] | 0;
    i200 = HEAP32[i160 >> 2] | 0;
    i201 = HEAP32[i161 >> 2] | 0;
    i198 = i198 << 11 ^ i198;
    i199 = i199 << 11 ^ i199;
    i200 = i200 << 11 ^ i200;
    i201 = i201 << 11 ^ i201;
    i202 = HEAP32[i163 >> 2] | 0;
    i203 = HEAP32[i164 >> 2] | 0;
    i204 = HEAP32[i165 >> 2] | 0;
    HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
    HEAP32[i159 >> 2] = i202;
    HEAP32[i160 >> 2] = i203;
    HEAP32[i161 >> 2] = i204;
    i204 = HEAP32[i167 >> 2] | 0;
    i203 = HEAP32[i168 >> 2] | 0;
    i202 = HEAP32[i169 >> 2] | 0;
    HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
    HEAP32[i163 >> 2] = i204;
    HEAP32[i164 >> 2] = i203;
    HEAP32[i165 >> 2] = i202;
    i202 = HEAP32[i170 >> 2] | 0;
    i203 = HEAP32[i171 >> 2] | 0;
    i204 = HEAP32[i172 >> 2] | 0;
    i1 = HEAP32[i173 >> 2] | 0;
    HEAP32[i166 >> 2] = i202;
    HEAP32[i167 >> 2] = i203;
    HEAP32[i168 >> 2] = i204;
    HEAP32[i169 >> 2] = i1;
    i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
    i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
    i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
    i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
    HEAP32[i170 >> 2] = i202;
    HEAP32[i171 >> 2] = i203;
    HEAP32[i172 >> 2] = i204;
    HEAP32[i173 >> 2] = i1;
    f9 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f10 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f11 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f12 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i195 >> 2] = f9;
    HEAPF32[i94 >> 2] = f10;
    HEAPF32[i95 >> 2] = f11;
    HEAPF32[i96 >> 2] = f12;
    i1 = HEAP32[i97 >> 2] | 0;
    L39 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i204 = HEAP32[i98 >> 2] | 0;
      HEAP32[i21 >> 2] = i204;
      HEAP32[i25 >> 2] = i204;
      HEAP32[i23 >> 2] = i204;
      HEAP32[i194 >> 2] = i204;
      break;
     }
    case 3:
     {
      f207 = Math_fround(HEAPF32[(HEAP32[i99 >> 2] | 0) + 4 >> 2]);
      f206 = Math_fround(HEAPF32[i98 >> 2]);
      f207 = Math_fround(f207 * f206);
      f206 = Math_fround(Math_fround(f206 * Math_fround(HEAPF32[(HEAP32[i100 >> 2] | 0) + 4 >> 2])) - f207);
      f10 = Math_fround(f207 + Math_fround(f206 * f10));
      f11 = Math_fround(f207 + Math_fround(f206 * f11));
      f205 = Math_fround(f207 + Math_fround(f12 * f206));
      HEAPF32[i194 >> 2] = Math_fround(f207 + Math_fround(f9 * f206));
      HEAPF32[i23 >> 2] = f10;
      HEAPF32[i25 >> 2] = f11;
      HEAPF32[i21 >> 2] = f205;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i93, i193, i195);
      break L39;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i93, i193, i195);
      break L39;
     }
    } while (0);
    f12 = Math_fround(HEAPF32[i194 >> 2]);
    i204 = f12 < Math_fround(0.0);
    f12 = i204 ? Math_fround(0.0) : f12;
    f205 = Math_fround(HEAPF32[i23 >> 2]);
    i204 = f205 < Math_fround(0.0);
    f205 = i204 ? Math_fround(0.0) : f205;
    f206 = Math_fround(HEAPF32[i25 >> 2]);
    i204 = f206 < Math_fround(0.0);
    f206 = i204 ? Math_fround(0.0) : f206;
    f207 = Math_fround(HEAPF32[i21 >> 2]);
    i204 = f207 < Math_fround(0.0);
    f12 = Math_fround(f182 * f12);
    f205 = Math_fround(f182 * f205);
    f206 = Math_fround(f182 * f206);
    f207 = Math_fround(f182 * (i204 ? Math_fround(0.0) : f207));
    i204 = (HEAP32[i83 >> 2] | 0) + (i8 << 2) | 0;
    HEAPF32[i204 >> 2] = f12;
    HEAPF32[i204 + 4 >> 2] = f205;
    HEAPF32[i204 + 8 >> 2] = f206;
    HEAPF32[i204 + 12 >> 2] = f207;
    if (!(HEAP8[i82 >> 0] | 0)) i196 = 35; else {
     i198 = HEAP32[i158 >> 2] | 0;
     i199 = HEAP32[i159 >> 2] | 0;
     i200 = HEAP32[i160 >> 2] | 0;
     i201 = HEAP32[i161 >> 2] | 0;
     i198 = i198 << 11 ^ i198;
     i199 = i199 << 11 ^ i199;
     i200 = i200 << 11 ^ i200;
     i201 = i201 << 11 ^ i201;
     i202 = HEAP32[i163 >> 2] | 0;
     i203 = HEAP32[i164 >> 2] | 0;
     i204 = HEAP32[i165 >> 2] | 0;
     HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
     HEAP32[i159 >> 2] = i202;
     HEAP32[i160 >> 2] = i203;
     HEAP32[i161 >> 2] = i204;
     i204 = HEAP32[i167 >> 2] | 0;
     i203 = HEAP32[i168 >> 2] | 0;
     i202 = HEAP32[i169 >> 2] | 0;
     HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
     HEAP32[i163 >> 2] = i204;
     HEAP32[i164 >> 2] = i203;
     HEAP32[i165 >> 2] = i202;
     i202 = HEAP32[i170 >> 2] | 0;
     i203 = HEAP32[i171 >> 2] | 0;
     i204 = HEAP32[i172 >> 2] | 0;
     i1 = HEAP32[i173 >> 2] | 0;
     HEAP32[i166 >> 2] = i202;
     HEAP32[i167 >> 2] = i203;
     HEAP32[i168 >> 2] = i204;
     HEAP32[i169 >> 2] = i1;
     i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
     i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
     i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
     i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
     HEAP32[i170 >> 2] = i202;
     HEAP32[i171 >> 2] = i203;
     HEAP32[i172 >> 2] = i204;
     HEAP32[i173 >> 2] = i1;
     f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
     HEAPF32[i195 >> 2] = f2;
     HEAPF32[i86 >> 2] = f4;
     HEAPF32[i87 >> 2] = f5;
     HEAPF32[i88 >> 2] = f7;
     i1 = HEAP32[i89 >> 2] | 0;
     L48 : do switch ((i1 & 65535) << 16 >> 16) {
     case 0:
      {
       i204 = HEAP32[i90 >> 2] | 0;
       HEAP32[i20 >> 2] = i204;
       HEAP32[i24 >> 2] = i204;
       HEAP32[i22 >> 2] = i204;
       HEAP32[i194 >> 2] = i204;
       break;
      }
     case 3:
      {
       f11 = Math_fround(HEAPF32[(HEAP32[i91 >> 2] | 0) + 4 >> 2]);
       f12 = Math_fround(HEAPF32[i90 >> 2]);
       f11 = Math_fround(f11 * f12);
       f12 = Math_fround(Math_fround(f12 * Math_fround(HEAPF32[(HEAP32[i92 >> 2] | 0) + 4 >> 2])) - f11);
       f205 = Math_fround(f11 + Math_fround(f12 * f4));
       f206 = Math_fround(f11 + Math_fround(f12 * f5));
       f207 = Math_fround(f11 + Math_fround(f7 * f12));
       HEAPF32[i194 >> 2] = Math_fround(f11 + Math_fround(f2 * f12));
       HEAPF32[i22 >> 2] = f205;
       HEAPF32[i24 >> 2] = f206;
       HEAPF32[i20 >> 2] = f207;
       break;
      }
     default:
      if (!(i1 & 16711680)) {
       __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i85, i193, i195);
       break L48;
      } else {
       __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i85, i193, i195);
       break L48;
      }
     } while (0);
     f12 = Math_fround(HEAPF32[i194 >> 2]);
     i204 = f12 < Math_fround(0.0);
     f12 = i204 ? Math_fround(0.0) : f12;
     f205 = Math_fround(HEAPF32[i22 >> 2]);
     i204 = f205 < Math_fround(0.0);
     f205 = i204 ? Math_fround(0.0) : f205;
     f206 = Math_fround(HEAPF32[i24 >> 2]);
     i204 = f206 < Math_fround(0.0);
     f206 = i204 ? Math_fround(0.0) : f206;
     f207 = Math_fround(HEAPF32[i20 >> 2]);
     i204 = f207 < Math_fround(0.0);
     f12 = Math_fround(f183 * f12);
     f205 = Math_fround(f183 * f205);
     f206 = Math_fround(f183 * f206);
     f207 = Math_fround(f183 * (i204 ? Math_fround(0.0) : f207));
     i204 = (HEAP32[i84 >> 2] | 0) + (i8 << 2) | 0;
     HEAPF32[i204 >> 2] = f12;
     HEAPF32[i204 + 4 >> 2] = f205;
     HEAPF32[i204 + 8 >> 2] = f206;
     HEAPF32[i204 + 12 >> 2] = f207;
    }
   }
   if ((i196 | 0) == 35) {
    i196 = 0;
    HEAPF32[i194 >> 2] = f2;
    HEAPF32[i22 >> 2] = f5;
    HEAPF32[i24 >> 2] = f4;
    HEAPF32[i20 >> 2] = f7;
    f12 = Math_fround(f183 * f2);
    f205 = Math_fround(f183 * f5);
    f206 = Math_fround(f183 * f4);
    f207 = Math_fround(f183 * f7);
    i204 = (HEAP32[i84 >> 2] | 0) + (i8 << 2) | 0;
    HEAPF32[i204 >> 2] = f12;
    HEAPF32[i204 + 4 >> 2] = f205;
    HEAPF32[i204 + 8 >> 2] = f206;
    HEAPF32[i204 + 12 >> 2] = f207;
   }
  }
  i198 = HEAP32[i158 >> 2] | 0;
  i199 = HEAP32[i159 >> 2] | 0;
  i200 = HEAP32[i160 >> 2] | 0;
  i201 = HEAP32[i161 >> 2] | 0;
  i198 = i198 << 11 ^ i198;
  i199 = i199 << 11 ^ i199;
  i200 = i200 << 11 ^ i200;
  i201 = i201 << 11 ^ i201;
  i202 = HEAP32[i163 >> 2] | 0;
  i203 = HEAP32[i164 >> 2] | 0;
  i204 = HEAP32[i165 >> 2] | 0;
  HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
  HEAP32[i159 >> 2] = i202;
  HEAP32[i160 >> 2] = i203;
  HEAP32[i161 >> 2] = i204;
  i204 = HEAP32[i167 >> 2] | 0;
  i203 = HEAP32[i168 >> 2] | 0;
  i202 = HEAP32[i169 >> 2] | 0;
  HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
  HEAP32[i163 >> 2] = i204;
  HEAP32[i164 >> 2] = i203;
  HEAP32[i165 >> 2] = i202;
  i202 = HEAP32[i170 >> 2] | 0;
  i203 = HEAP32[i171 >> 2] | 0;
  i204 = HEAP32[i172 >> 2] | 0;
  i1 = HEAP32[i173 >> 2] | 0;
  HEAP32[i166 >> 2] = i202;
  HEAP32[i167 >> 2] = i203;
  HEAP32[i168 >> 2] = i204;
  HEAP32[i169 >> 2] = i1;
  i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
  i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
  i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
  i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
  HEAP32[i170 >> 2] = i202;
  HEAP32[i171 >> 2] = i203;
  HEAP32[i172 >> 2] = i204;
  HEAP32[i173 >> 2] = i1;
  f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i195 >> 2] = f2;
  HEAPF32[i137 >> 2] = f4;
  HEAPF32[i138 >> 2] = f5;
  HEAPF32[i139 >> 2] = f7;
  i1 = HEAP32[i140 >> 2] | 0;
  L60 : do switch ((i1 & 65535) << 16 >> 16) {
  case 0:
   {
    i204 = HEAP32[i73 >> 2] | 0;
    HEAP32[i143 >> 2] = i204;
    HEAP32[i142 >> 2] = i204;
    HEAP32[i141 >> 2] = i204;
    HEAP32[i194 >> 2] = i204;
    break;
   }
  case 3:
   {
    f11 = Math_fround(HEAPF32[(HEAP32[i74 >> 2] | 0) + 4 >> 2]);
    f12 = Math_fround(HEAPF32[i73 >> 2]);
    f11 = Math_fround(f11 * f12);
    f12 = Math_fround(Math_fround(f12 * Math_fround(HEAPF32[(HEAP32[i75 >> 2] | 0) + 4 >> 2])) - f11);
    f205 = Math_fround(f11 + Math_fround(f12 * f4));
    f206 = Math_fround(f11 + Math_fround(f12 * f5));
    f207 = Math_fround(f11 + Math_fround(f7 * f12));
    HEAPF32[i194 >> 2] = Math_fround(f11 + Math_fround(f2 * f12));
    HEAPF32[i141 >> 2] = f205;
    HEAPF32[i142 >> 2] = f206;
    HEAPF32[i143 >> 2] = f207;
    break;
   }
  default:
   if (!(i1 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i136, i193, i195);
    break L60;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i136, i193, i195);
    break L60;
   }
  } while (0);
  f7 = Math_fround(f186 + Math_fround(HEAPF32[i194 >> 2]));
  f205 = Math_fround(f186 + Math_fround(HEAPF32[i141 >> 2]));
  f206 = Math_fround(f186 + Math_fround(HEAPF32[i142 >> 2]));
  f207 = Math_fround(f186 + Math_fround(HEAPF32[i143 >> 2]));
  f12 = i3 ? Math_fround(1.0) : Math_fround(-1.0);
  f7 = Math_fround(f12 * f7);
  f11 = i6 ? Math_fround(1.0) : Math_fround(-1.0);
  f205 = Math_fround(f11 * f205);
  f10 = i13 ? Math_fround(1.0) : Math_fround(-1.0);
  f206 = Math_fround(f10 * f206);
  f9 = i14 ? Math_fround(1.0) : Math_fround(-1.0);
  f207 = Math_fround(f9 * f207);
  i204 = (HEAP32[i144 >> 2] | 0) + (i8 << 2) | 0;
  HEAPF32[i204 >> 2] = f7;
  HEAPF32[i204 + 4 >> 2] = f205;
  HEAPF32[i204 + 8 >> 2] = f206;
  HEAPF32[i204 + 12 >> 2] = f207;
  do if (HEAP8[i145 >> 0] | 0) {
   if (!(HEAP8[i48 >> 0] | 0)) {
    i204 = (HEAP32[i49 >> 2] | 0) + (i8 << 2) | 0;
    HEAP32[i204 >> 2] = 0;
    HEAP32[i204 + 4 >> 2] = 0;
    HEAP32[i204 + 8 >> 2] = 0;
    HEAP32[i204 + 12 >> 2] = 0;
    i204 = (HEAP32[i50 >> 2] | 0) + (i8 << 2) | 0;
    HEAP32[i204 >> 2] = 0;
    HEAP32[i204 + 4 >> 2] = 0;
    HEAP32[i204 + 8 >> 2] = 0;
    HEAP32[i204 + 12 >> 2] = 0;
    break;
   }
   i198 = HEAP32[i158 >> 2] | 0;
   i199 = HEAP32[i159 >> 2] | 0;
   i200 = HEAP32[i160 >> 2] | 0;
   i201 = HEAP32[i161 >> 2] | 0;
   i198 = i198 << 11 ^ i198;
   i199 = i199 << 11 ^ i199;
   i200 = i200 << 11 ^ i200;
   i201 = i201 << 11 ^ i201;
   i202 = HEAP32[i163 >> 2] | 0;
   i203 = HEAP32[i164 >> 2] | 0;
   i204 = HEAP32[i165 >> 2] | 0;
   HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
   HEAP32[i159 >> 2] = i202;
   HEAP32[i160 >> 2] = i203;
   HEAP32[i161 >> 2] = i204;
   i204 = HEAP32[i167 >> 2] | 0;
   i203 = HEAP32[i168 >> 2] | 0;
   i202 = HEAP32[i169 >> 2] | 0;
   HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
   HEAP32[i163 >> 2] = i204;
   HEAP32[i164 >> 2] = i203;
   HEAP32[i165 >> 2] = i202;
   i202 = HEAP32[i170 >> 2] | 0;
   i203 = HEAP32[i171 >> 2] | 0;
   i204 = HEAP32[i172 >> 2] | 0;
   i1 = HEAP32[i173 >> 2] | 0;
   HEAP32[i166 >> 2] = i202;
   HEAP32[i167 >> 2] = i203;
   HEAP32[i168 >> 2] = i204;
   HEAP32[i169 >> 2] = i1;
   i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
   i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
   i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
   i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
   HEAP32[i170 >> 2] = i202;
   HEAP32[i171 >> 2] = i203;
   HEAP32[i172 >> 2] = i204;
   HEAP32[i173 >> 2] = i1;
   f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i195 >> 2] = f2;
   HEAPF32[i52 >> 2] = f4;
   HEAPF32[i53 >> 2] = f5;
   HEAPF32[i54 >> 2] = f7;
   i1 = HEAP32[i55 >> 2] | 0;
   L73 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i204 = HEAP32[i70 >> 2] | 0;
     HEAP32[i58 >> 2] = i204;
     HEAP32[i57 >> 2] = i204;
     HEAP32[i56 >> 2] = i204;
     HEAP32[i194 >> 2] = i204;
     break;
    }
   case 3:
    {
     f209 = Math_fround(HEAPF32[(HEAP32[i71 >> 2] | 0) + 4 >> 2]);
     f208 = Math_fround(HEAPF32[i70 >> 2]);
     f209 = Math_fround(f209 * f208);
     f208 = Math_fround(Math_fround(f208 * Math_fround(HEAPF32[(HEAP32[i72 >> 2] | 0) + 4 >> 2])) - f209);
     f205 = Math_fround(f209 + Math_fround(f208 * f4));
     f206 = Math_fround(f209 + Math_fround(f208 * f5));
     f207 = Math_fround(f209 + Math_fround(f7 * f208));
     HEAPF32[i194 >> 2] = Math_fround(f209 + Math_fround(f2 * f208));
     HEAPF32[i56 >> 2] = f205;
     HEAPF32[i57 >> 2] = f206;
     HEAPF32[i58 >> 2] = f207;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i51, i193, i195);
     break L73;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i51, i193, i195);
     break L73;
    }
   } while (0);
   f7 = Math_fround(f184 + Math_fround(HEAPF32[i194 >> 2]));
   f5 = Math_fround(f184 + Math_fround(HEAPF32[i56 >> 2]));
   f4 = Math_fround(f184 + Math_fround(HEAPF32[i57 >> 2]));
   f7 = Math_fround(f12 * f7);
   f5 = Math_fround(f11 * f5);
   f4 = Math_fround(f10 * f4);
   f2 = Math_fround(f9 * Math_fround(f184 + Math_fround(HEAPF32[i58 >> 2])));
   i198 = (HEAP32[i49 >> 2] | 0) + (i8 << 2) | 0;
   HEAPF32[i198 >> 2] = f7;
   HEAPF32[i198 + 4 >> 2] = f5;
   HEAPF32[i198 + 8 >> 2] = f4;
   HEAPF32[i198 + 12 >> 2] = f2;
   i198 = HEAP32[i158 >> 2] | 0;
   i199 = HEAP32[i159 >> 2] | 0;
   i200 = HEAP32[i160 >> 2] | 0;
   i201 = HEAP32[i161 >> 2] | 0;
   i198 = i198 << 11 ^ i198;
   i199 = i199 << 11 ^ i199;
   i200 = i200 << 11 ^ i200;
   i201 = i201 << 11 ^ i201;
   i202 = HEAP32[i163 >> 2] | 0;
   i203 = HEAP32[i164 >> 2] | 0;
   i204 = HEAP32[i165 >> 2] | 0;
   HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
   HEAP32[i159 >> 2] = i202;
   HEAP32[i160 >> 2] = i203;
   HEAP32[i161 >> 2] = i204;
   i204 = HEAP32[i167 >> 2] | 0;
   i203 = HEAP32[i168 >> 2] | 0;
   i202 = HEAP32[i169 >> 2] | 0;
   HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
   HEAP32[i163 >> 2] = i204;
   HEAP32[i164 >> 2] = i203;
   HEAP32[i165 >> 2] = i202;
   i202 = HEAP32[i170 >> 2] | 0;
   i203 = HEAP32[i171 >> 2] | 0;
   i204 = HEAP32[i172 >> 2] | 0;
   i1 = HEAP32[i173 >> 2] | 0;
   HEAP32[i166 >> 2] = i202;
   HEAP32[i167 >> 2] = i203;
   HEAP32[i168 >> 2] = i204;
   HEAP32[i169 >> 2] = i1;
   i202 = i198 >>> 8 ^ i198 ^ i202 ^ i202 >>> 19;
   i203 = i199 >>> 8 ^ i199 ^ i203 ^ i203 >>> 19;
   i204 = i200 >>> 8 ^ i200 ^ i204 ^ i204 >>> 19;
   i1 = i201 >>> 8 ^ i201 ^ i1 ^ i1 >>> 19;
   HEAP32[i170 >> 2] = i202;
   HEAP32[i171 >> 2] = i203;
   HEAP32[i172 >> 2] = i204;
   HEAP32[i173 >> 2] = i1;
   f2 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i195 >> 2] = f2;
   HEAPF32[i60 >> 2] = f4;
   HEAPF32[i61 >> 2] = f5;
   HEAPF32[i62 >> 2] = f7;
   i1 = HEAP32[i63 >> 2] | 0;
   L81 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i204 = HEAP32[i67 >> 2] | 0;
     HEAP32[i66 >> 2] = i204;
     HEAP32[i65 >> 2] = i204;
     HEAP32[i64 >> 2] = i204;
     HEAP32[i194 >> 2] = i204;
     break;
    }
   case 3:
    {
     f205 = Math_fround(HEAPF32[(HEAP32[i68 >> 2] | 0) + 4 >> 2]);
     f206 = Math_fround(HEAPF32[i67 >> 2]);
     f205 = Math_fround(f205 * f206);
     f206 = Math_fround(Math_fround(f206 * Math_fround(HEAPF32[(HEAP32[i69 >> 2] | 0) + 4 >> 2])) - f205);
     f207 = Math_fround(f205 + Math_fround(f206 * f4));
     f208 = Math_fround(f205 + Math_fround(f206 * f5));
     f209 = Math_fround(f205 + Math_fround(f7 * f206));
     HEAPF32[i194 >> 2] = Math_fround(f205 + Math_fround(f2 * f206));
     HEAPF32[i64 >> 2] = f207;
     HEAPF32[i65 >> 2] = f208;
     HEAPF32[i66 >> 2] = f209;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i194, i59, i193, i195);
     break L81;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i194, i59, i193, i195);
     break L81;
    }
   } while (0);
   f206 = Math_fround(f185 + Math_fround(HEAPF32[i194 >> 2]));
   f207 = Math_fround(f185 + Math_fround(HEAPF32[i64 >> 2]));
   f208 = Math_fround(f185 + Math_fround(HEAPF32[i65 >> 2]));
   f206 = Math_fround(f12 * f206);
   f207 = Math_fround(f11 * f207);
   f208 = Math_fround(f10 * f208);
   f209 = Math_fround(f9 * Math_fround(f185 + Math_fround(HEAPF32[i66 >> 2])));
   i204 = (HEAP32[i50 >> 2] | 0) + (i8 << 2) | 0;
   HEAPF32[i204 >> 2] = f206;
   HEAPF32[i204 + 4 >> 2] = f207;
   HEAPF32[i204 + 8 >> 2] = f208;
   HEAPF32[i204 + 12 >> 2] = f209;
  } while (0);
  do if (HEAP8[i146 >> 0] | 0) if (!(HEAP8[i145 >> 0] | 0)) {
   i204 = (HEAP32[i45 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   break;
  } else {
   i204 = (HEAP32[i46 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   i204 = (HEAP32[i47 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   i204 = (HEAP32[i45 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   break;
  } while (0);
  if (HEAP8[i147 >> 0] | 0) {
   i204 = (HEAP32[i42 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   i204 = (HEAP32[i43 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
   i204 = (HEAP32[i44 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i204 >> 2] = 0;
   HEAP32[i204 + 4 >> 2] = 0;
   HEAP32[i204 + 8 >> 2] = 0;
   HEAP32[i204 + 12 >> 2] = 0;
  }
  i198 = HEAP32[i158 >> 2] | 0;
  i199 = HEAP32[i159 >> 2] | 0;
  i200 = HEAP32[i160 >> 2] | 0;
  i201 = HEAP32[i161 >> 2] | 0;
  i198 = i198 << 11 ^ i198;
  i199 = i199 << 11 ^ i199;
  i200 = i200 << 11 ^ i200;
  i201 = i201 << 11 ^ i201;
  i1 = HEAP32[i163 >> 2] | 0;
  i202 = HEAP32[i164 >> 2] | 0;
  i203 = HEAP32[i165 >> 2] | 0;
  HEAP32[i158 >> 2] = HEAP32[i162 >> 2];
  HEAP32[i159 >> 2] = i1;
  HEAP32[i160 >> 2] = i202;
  HEAP32[i161 >> 2] = i203;
  i203 = HEAP32[i167 >> 2] | 0;
  i202 = HEAP32[i168 >> 2] | 0;
  i1 = HEAP32[i169 >> 2] | 0;
  HEAP32[i162 >> 2] = HEAP32[i166 >> 2];
  HEAP32[i163 >> 2] = i203;
  HEAP32[i164 >> 2] = i202;
  HEAP32[i165 >> 2] = i1;
  i1 = HEAP32[i170 >> 2] | 0;
  i202 = HEAP32[i171 >> 2] | 0;
  i203 = HEAP32[i172 >> 2] | 0;
  i204 = HEAP32[i173 >> 2] | 0;
  HEAP32[i166 >> 2] = i1;
  HEAP32[i167 >> 2] = i202;
  HEAP32[i168 >> 2] = i203;
  HEAP32[i169 >> 2] = i204;
  i1 = i198 >>> 8 ^ i198 ^ i1 ^ i1 >>> 19;
  i202 = i199 >>> 8 ^ i199 ^ i202 ^ i202 >>> 19;
  i203 = i200 >>> 8 ^ i200 ^ i203 ^ i203 >>> 19;
  i204 = i201 >>> 8 ^ i201 ^ i204 ^ i204 >>> 19;
  HEAP32[i170 >> 2] = i1;
  HEAP32[i171 >> 2] = i202;
  HEAP32[i172 >> 2] = i203;
  HEAP32[i173 >> 2] = i204;
  f207 = Math_fround(Math_fround(i202 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f208 = Math_fround(Math_fround(i203 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f209 = Math_fround(Math_fround(i204 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i195 >> 2] = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i149 >> 2] = f207;
  HEAPF32[i150 >> 2] = f208;
  HEAPF32[i151 >> 2] = f209;
  i1 = (HEAP32[i153 >> 2] | 0) == 0;
  do if (!(HEAP32[i152 >> 2] | 0)) if (i1) {
   __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i194, i148, i193, i195);
   break;
  } else {
   __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i194, i148, i193, i195);
   break;
  } else if (i1) {
   __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i194, i148, i193, i195);
   break;
  } else {
   __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i194, i148, i193, i195);
   break;
  } while (0);
  i212 = HEAP32[i194 >> 2] | 0;
  i3 = HEAP32[i108 >> 2] | 0;
  i198 = HEAP32[i104 >> 2] | 0;
  i202 = HEAP32[i106 >> 2] | 0;
  i213 = (Math_imul(i212 & 255, i154) | 0) + 128 | 0;
  i214 = (Math_imul(i212 >>> 8 & 255, i155) | 0) + 128 | 0;
  i211 = (Math_imul(i212 >>> 16 & 255, i156) | 0) + 128 | 0;
  i212 = (Math_imul(i212 >>> 24, i26) | 0) + 128 | 0;
  i1 = (Math_imul(i3 & 255, i154) | 0) + 128 | 0;
  i210 = (Math_imul(i3 >>> 8 & 255, i155) | 0) + 128 | 0;
  i6 = (Math_imul(i3 >>> 16 & 255, i156) | 0) + 128 | 0;
  i3 = (Math_imul(i3 >>> 24, i26) | 0) + 128 | 0;
  i14 = (Math_imul(i198 & 255, i154) | 0) + 128 | 0;
  i13 = (Math_imul(i198 >>> 8 & 255, i155) | 0) + 128 | 0;
  i199 = (Math_imul(i198 >>> 16 & 255, i156) | 0) + 128 | 0;
  i198 = (Math_imul(i198 >>> 24, i26) | 0) + 128 | 0;
  i201 = (Math_imul(i202 & 255, i154) | 0) + 128 | 0;
  i200 = (Math_imul(i202 >>> 8 & 255, i155) | 0) + 128 | 0;
  i203 = (Math_imul(i202 >>> 16 & 255, i156) | 0) + 128 | 0;
  i202 = (Math_imul(i202 >>> 24, i26) | 0) + 128 | 0;
  i204 = (HEAP32[i27 >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i204 >> 2] = (i214 >>> 8) + i214 & 261888 | ((i213 >>> 8) + i213 | 0) >>> 8 | ((i212 >>> 8) + i212 | 0) >>> 8 << 24 | ((i211 >>> 8) + i211 | 0) >>> 8 << 16;
  HEAP32[i204 + 4 >> 2] = (i210 >>> 8) + i210 & 261888 | ((i1 >>> 8) + i1 | 0) >>> 8 | ((i3 >>> 8) + i3 | 0) >>> 8 << 24 | ((i6 >>> 8) + i6 | 0) >>> 8 << 16;
  HEAP32[i204 + 8 >> 2] = (i13 >>> 8) + i13 & 261888 | ((i14 >>> 8) + i14 | 0) >>> 8 | ((i198 >>> 8) + i198 | 0) >>> 8 << 24 | ((i199 >>> 8) + i199 | 0) >>> 8 << 16;
  HEAP32[i204 + 12 >> 2] = (i200 >>> 8) + i200 & 261888 | ((i201 >>> 8) + i201 | 0) >>> 8 | ((i202 >>> 8) + i202 | 0) >>> 8 << 24 | ((i203 >>> 8) + i203 | 0) >>> 8 << 16;
  if (HEAP8[i28 >> 0] | 0) {
   i214 = (HEAP32[i29 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i214 >> 2] = i103;
   HEAP32[i214 + 4 >> 2] = i103;
   HEAP32[i214 + 8 >> 2] = i103;
   HEAP32[i214 + 12 >> 2] = i103;
   i214 = (HEAP32[i30 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i214 >> 2] = i105;
   HEAP32[i214 + 4 >> 2] = i105;
   HEAP32[i214 + 8 >> 2] = i105;
   HEAP32[i214 + 12 >> 2] = i105;
   i214 = (HEAP32[i31 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i214 >> 2] = i107;
   HEAP32[i214 + 4 >> 2] = i107;
   HEAP32[i214 + 8 >> 2] = i107;
   HEAP32[i214 + 12 >> 2] = i107;
  }
  i3 = HEAP32[i32 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i1 = 0;
   do {
    i214 = (HEAP32[i192 + 560 + (i1 * 20 | 0) >> 2] | 0) + (i8 << 2) | 0;
    HEAP32[i214 >> 2] = 0;
    HEAP32[i214 + 4 >> 2] = 0;
    HEAP32[i214 + 8 >> 2] = 0;
    HEAP32[i214 + 12 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
  if (HEAP8[i33 >> 0] | 0) {
   i213 = (HEAP32[i41 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
   HEAP32[i213 >> 2] = HEAP32[i213 >> 2] & ~(1 << (i8 & 31));
   i213 = i8 + 1 | 0;
   i214 = (HEAP32[i41 >> 2] | 0) + (i213 >>> 5 << 2) | 0;
   HEAP32[i214 >> 2] = HEAP32[i214 >> 2] & ~(1 << (i213 & 31));
   i214 = i8 + 2 | 0;
   i213 = (HEAP32[i41 >> 2] | 0) + (i214 >>> 5 << 2) | 0;
   HEAP32[i213 >> 2] = HEAP32[i213 >> 2] & ~(1 << (i214 & 31));
   i213 = i8 + 3 | 0;
   i214 = (HEAP32[i41 >> 2] | 0) + (i213 >>> 5 << 2) | 0;
   HEAP32[i214 >> 2] = HEAP32[i214 >> 2] & ~(1 << (i213 & 31));
  }
  if (HEAP8[i34 >> 0] | 0) {
   i213 = (HEAP32[i40 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
   HEAP32[i213 >> 2] = HEAP32[i213 >> 2] & ~(1 << (i8 & 31));
   i213 = i8 + 1 | 0;
   i214 = (HEAP32[i40 >> 2] | 0) + (i213 >>> 5 << 2) | 0;
   HEAP32[i214 >> 2] = HEAP32[i214 >> 2] & ~(1 << (i213 & 31));
   i214 = i8 + 2 | 0;
   i213 = (HEAP32[i40 >> 2] | 0) + (i214 >>> 5 << 2) | 0;
   HEAP32[i213 >> 2] = HEAP32[i213 >> 2] & ~(1 << (i214 & 31));
   i213 = i8 + 3 | 0;
   i214 = (HEAP32[i40 >> 2] | 0) + (i213 >>> 5 << 2) | 0;
   HEAP32[i214 >> 2] = HEAP32[i214 >> 2] & ~(1 << (i213 & 31));
  }
  if (HEAP8[i35 >> 0] | 0) {
   i211 = HEAP32[i37 >> 2] | 0;
   i212 = HEAP32[i38 >> 2] | 0;
   i213 = HEAP32[i39 >> 2] | 0;
   HEAP32[i211 + (i8 << 2) >> 2] = (HEAP32[i36 >> 2] | 0) + -1;
   HEAP32[i212 + (i8 << 2) >> 2] = 0;
   HEAP32[i213 + (i8 << 2) >> 2] = 0;
   i214 = i8 + 1 | 0;
   HEAP32[i211 + (i214 << 2) >> 2] = (HEAP32[i36 >> 2] | 0) + -1;
   HEAP32[i212 + (i214 << 2) >> 2] = 0;
   HEAP32[i213 + (i214 << 2) >> 2] = 0;
   i214 = i8 + 2 | 0;
   HEAP32[i211 + (i214 << 2) >> 2] = (HEAP32[i36 >> 2] | 0) + -1;
   HEAP32[i212 + (i214 << 2) >> 2] = 0;
   HEAP32[i213 + (i214 << 2) >> 2] = 0;
   i214 = i8 + 3 | 0;
   HEAP32[i211 + (i214 << 2) >> 2] = (HEAP32[i36 >> 2] | 0) + -1;
   HEAP32[i212 + (i214 << 2) >> 2] = 0;
   HEAP32[i213 + (i214 << 2) >> 2] = 0;
  }
  if (HEAP32[i16 >> 2] & 2147483647 | 0) {
   i214 = (HEAP32[i19 >> 2] | 0) + (i8 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i19 >> 2] | 0) + (i8 + 1 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i19 >> 2] | 0) + (i8 + 2 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i19 >> 2] | 0) + (i8 + 3 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
  }
  if (HEAP32[i17 >> 2] & 2147483647 | 0) {
   i214 = (HEAP32[i18 >> 2] | 0) + (i8 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i18 >> 2] | 0) + (i8 + 1 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i18 >> 2] | 0) + (i8 + 2 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
   i214 = (HEAP32[i18 >> 2] | 0) + (i8 + 3 << 4) | 0;
   HEAP32[i214 >> 2] = 0;
   HEAP32[i214 + 4 >> 2] = 0;
   HEAP32[i214 + 8 >> 2] = 0;
   HEAP32[i214 + 12 >> 2] = 0;
  }
  i8 = i8 + 4 | 0;
 } while (i8 >>> 0 < i157 >>> 0);
 STACKTOP = i197;
 return;
}

function __Z36CombineMeshVerticesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEERKNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEER4Meshb(i43, i24, i45, i32) {
 i43 = i43 | 0;
 i24 = i24 | 0;
 i45 = i45 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i46 = 0, f47 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i46;
 i40 = i46 + 64 | 0;
 i36 = i46 + 88 | 0;
 if ((HEAP16[gb + 1161484 + 6 >> 1] | 0) > -1) {
  HEAP32[i40 >> 2] = i45;
  HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161484 | 0, i38);
  i44 = gb + 1161484 | 0;
 } else i44 = 0;
 i41 = i43 + 4 | 0;
 i23 = HEAP32[i43 >> 2] | 0;
 i25 = (HEAP32[i41 >> 2] | 0) - i23 | 0;
 i39 = (i25 | 0) / 112 | 0;
 i35 = (i25 | 0) == 0;
 if (i35) {
  i1 = i36;
  i2 = gb + 1546313 | 0;
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i2 = 0;
  i34 = 0;
  i5 = 0;
  i33 = 1;
 } else {
  i6 = 0;
  i5 = 0;
  do {
   i1 = HEAP32[i23 + (i6 * 112 | 0) >> 2] | 0;
   i2 = HEAP32[i23 + (i6 * 112 | 0) + 4 >> 2] | 0;
   i3 = HEAP32[i23 + (i6 * 112 | 0) + 8 >> 2] | 0;
   do if (i1) {
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    if (!((i3 | 0) < 0 | (HEAP32[i4 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i4 + 132 >> 2] | 0) - (HEAP32[i4 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i3 | 0)) {
     if (!i2) i1 = HEAP32[i4 + 100 >> 2] | 0; else {
      i1 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 100 >> 2] | 0;
      if ((i1 | 0) != (HEAP32[i4 + 100 >> 2] | 0)) break;
     }
     i5 = i1 + i5 | 0;
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i39 >>> 0);
  i1 = i36;
  i2 = gb + 1546313 | 0;
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  if (i35) {
   i2 = i5;
   i34 = 0;
   i5 = 0;
   i33 = 1;
  } else {
   i19 = i36 + 7 | 0;
   i20 = i36 + 9 | 0;
   i21 = i36 + 11 | 0;
   i22 = i36 + 13 | 0;
   i1 = 0;
   i12 = 0;
   i17 = 1;
   i18 = 0;
   while (1) {
    i2 = HEAP32[i23 + (i18 * 112 | 0) >> 2] | 0;
    i3 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
    i4 = HEAP32[i23 + (i18 * 112 | 0) + 8 >> 2] | 0;
    do if (!i2) {
     i3 = i12;
     i4 = i17;
    } else {
     i2 = HEAP32[i2 + 32 >> 2] | 0;
     if ((i4 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0) {
      i3 = i12;
      i4 = i17;
     } else if ((((HEAP32[i2 + 132 >> 2] | 0) - (HEAP32[i2 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i4 | 0)) {
      if (i3 | 0) if ((HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) {
       i3 = i12;
       i4 = i17;
       break;
      }
      i2 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
      i11 = HEAP32[(HEAP32[i23 + (i18 * 112 | 0) >> 2] | 0) + 32 >> 2] | 0;
      i9 = HEAP32[i11 + 96 >> 2] | 0;
      if (!i2) i8 = 0; else i8 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 96 >> 2] | 0;
      i3 = i23 + (i18 * 112 | 0) | 0;
      i2 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
      if (!i2) i42 = 25; else if (!(HEAP8[(HEAP32[i2 + 32 >> 2] | 0) + 23 >> 0] | 0)) i42 = 25;
      if ((i42 | 0) == 25) {
       i42 = 0;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      i10 = (HEAPU16[(HEAP32[i2 + 32 >> 2] | 0) + 22 >> 1] | 0) >>> 8 & 255;
      i3 = i23 + (i18 * 112 | 0) | 0;
      i2 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
      if (!i2) i42 = 330; else if (!(HEAP8[(HEAP32[i2 + 32 >> 2] | 0) + 27 >> 0] | 0)) i42 = 330;
      if ((i42 | 0) == 330) {
       i42 = 0;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      i3 = (HEAPU16[(HEAP32[i2 + 32 >> 2] | 0) + 26 >> 1] | 0) >>> 8 & 255;
      i4 = i23 + (i18 * 112 | 0) | 0;
      i2 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
      if (!i2) i42 = 333; else if (!(HEAP8[(HEAP32[i2 + 32 >> 2] | 0) + 31 >> 0] | 0)) i42 = 333;
      if ((i42 | 0) == 333) {
       i42 = 0;
       i2 = HEAP32[i4 >> 2] | 0;
      }
      i7 = (HEAPU16[(HEAP32[i2 + 32 >> 2] | 0) + 30 >> 1] | 0) >>> 8 & 255;
      i4 = i23 + (i18 * 112 | 0) | 0;
      i2 = HEAP32[i23 + (i18 * 112 | 0) + 4 >> 2] | 0;
      if (!i2) i42 = 336; else if (!(HEAP8[(HEAP32[i2 + 32 >> 2] | 0) + 35 >> 0] | 0)) i42 = 336;
      if ((i42 | 0) == 336) {
       i42 = 0;
       i2 = HEAP32[i4 >> 2] | 0;
      }
      i6 = (HEAPU16[(HEAP32[i2 + 32 >> 2] | 0) + 34 >> 1] | 0) >>> 8 & 255;
      i2 = i8 | i9;
      L51 : do if (!(i2 & 8)) {
       i4 = i2;
       i2 = i7;
      } else {
       L53 : do if (!(i2 & 16)) {
        do if (!(Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 76 >> 2]) != Math_fround(1.0))) {
         if (Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 80 >> 2]) != Math_fround(1.0)) break;
         if (Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 84 >> 2]) != Math_fround(0.0)) break;
         if (!(Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 88 >> 2]) != Math_fround(0.0))) break L53;
        } while (0);
        i2 = i2 | 16;
        i3 = i10;
       } while (0);
       if (!(i2 & 32)) {
        do if (!(Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 92 >> 2]) != Math_fround(1.0))) {
         if (Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 96 >> 2]) != Math_fround(1.0)) break;
         if (Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 100 >> 2]) != Math_fround(0.0)) break;
         if (!(Math_fround(HEAPF32[i23 + (i18 * 112 | 0) + 104 >> 2]) != Math_fround(0.0))) {
          i4 = i2;
          i2 = i7;
          break L51;
         }
        } while (0);
        i4 = i2 | 32;
        i2 = i10;
       } else {
        i4 = i2;
        i2 = i7;
       }
      } while (0);
      i37 = HEAP8[i19 >> 0] | 0;
      HEAP8[i19 >> 0] = (i37 & 255) < (i10 & 255) ? i10 : i37;
      i37 = HEAP8[i20 >> 0] | 0;
      HEAP8[i20 >> 0] = (i37 & 255) < (i3 & 255) ? i3 : i37;
      i37 = HEAP8[i21 >> 0] | 0;
      HEAP8[i21 >> 0] = (i37 & 255) < (i2 & 255) ? i2 : i37;
      i2 = HEAP8[i22 >> 0] | 0;
      HEAP8[i22 >> 0] = (i2 & 255) < (i6 & 255) ? i6 : i2;
      i2 = HEAP32[i11 + 156 >> 2] | 0;
      if (HEAP32[i11 + 176 >> 2] | 0) i1 = i1 | (i2 | 0) != 0;
      i3 = i2 + i12 | 0;
      i4 = i4 | i17;
     } else {
      i3 = i12;
      i4 = i17;
     }
    } while (0);
    i18 = i18 + 1 | 0;
    if (i18 >>> 0 >= i39 >>> 0) {
     i2 = i5;
     i34 = i1;
     i5 = i3;
     i33 = i4;
     break;
    } else {
     i12 = i3;
     i17 = i4;
    }
   }
  }
 }
 i31 = HEAP8[i36 + 7 >> 0] | 0;
 i37 = i36 + 9 | 0;
 i1 = HEAP8[i37 >> 0] | 0;
 i1 = (i1 & 255) < (i31 & 255) ? i31 : i1;
 HEAP8[i37 >> 0] = i1;
 i37 = i36 + 11 | 0;
 i31 = HEAP8[i37 >> 0] | 0;
 i31 = (i31 & 255) < (i1 & 255) ? i1 : i31;
 HEAP8[i37 >> 0] = i31;
 i37 = i36 + 13 | 0;
 i1 = HEAP8[i37 >> 0] | 0;
 HEAP8[i37 >> 0] = (i1 & 255) < (i31 & 255) ? i31 : i1;
 __ZN4Mesh5ClearEb(i45, 1);
 i37 = i45 + 32 | 0;
 i1 = HEAP32[i37 >> 2] | 0;
 if (!(HEAP32[i1 + 176 >> 2] | 0)) if ((HEAP32[i45 + 116 >> 2] | 0) == (HEAP32[i45 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i38, i1 + 8 | 0);
  HEAP32[i38 >> 2] = (HEAP32[i38 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i38 + 8 >> 2] & ~HEAP32[i38 + 12 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 } else i42 = 44; else i42 = 44;
 if ((i42 | 0) == 44) {
  HEAP32[i40 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i45, i2, i33, i33, i36, i40);
 mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 40 >> 2] | 0, i45 | 0, ((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24) | 0);
 i31 = i45 + 44 | 0;
 HEAP8[i31 >> 0] = HEAP8[i31 >> 0] & -17;
 do if (i34) {
  i1 = (HEAP32[i37 >> 2] | 0) + 164 | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  HEAP32[i38 + 12 >> 2] = 0;
  HEAP32[i38 + 16 >> 2] = 0;
  HEAP32[i38 + 20 >> 2] = 0;
  HEAP32[i38 + 24 >> 2] = 0;
  HEAP32[i38 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i1, i2, i38, 1);
  __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy((HEAP32[i37 >> 2] | 0) + 144 | 0, i5, i38, 1);
  i1 = i45 + 144 | 0;
  i2 = i45 + 156 | 0;
  HEAP32[i2 >> 2] = i5;
  i3 = i45 + 160 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i5;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5 << 2, 4, i45 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i45 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i31 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i5;
   HEAP32[i1 >> 2] = i31;
   break;
  }
 } while (0);
 if (i35) i1 = 0; else {
  i9 = 0;
  i1 = 0;
  do {
   i5 = HEAP32[i43 >> 2] | 0;
   i2 = i5 + (i9 * 112 | 0) | 0;
   i6 = HEAP32[i5 + (i9 * 112 | 0) + 4 >> 2] | 0;
   i7 = (i6 | 0) == 0;
   if (i7) i42 = 58; else if (!(HEAP8[(HEAP32[i6 + 32 >> 2] | 0) + 11 >> 0] | 0)) i42 = 58; else {
    i2 = HEAP32[i2 >> 2] | 0;
    i4 = i6;
   }
   if ((i42 | 0) == 58) {
    i42 = 0;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = i4;
   }
   i3 = HEAP32[i5 + (i9 * 112 | 0) + 8 >> 2] | 0;
   do if (i2) {
    i2 = HEAP32[i2 + 32 >> 2] | 0;
    if (!((i3 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i2 + 132 >> 2] | 0) - (HEAP32[i2 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i3 | 0)) {
     if (!i7) if ((HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) break;
     if (i32) {
      i2 = i4 + 32 | 0;
      i31 = HEAP32[i2 >> 2] | 0;
      i24 = i31 + 8 | 0;
      i26 = HEAP16[i24 >> 1] | 0;
      i23 = HEAP32[i37 >> 2] | 0;
      i28 = i23 + 8 | 0;
      i29 = HEAP16[i28 >> 1] | 0;
      i27 = i29 & 255;
      i27 = (HEAP32[i23 + 92 >> 2] | 0) + (((i29 & 65535) >>> 8 & 65535) + (HEAP32[i28 + 32 + (i27 * 12 | 0) + 4 >> 2] | 0)) + (Math_imul(HEAPU8[i28 + 32 + (i27 * 12 | 0) + 10 >> 0] | 0, i1) | 0) | 0;
      __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fjPS2_ji(i5 + (i9 * 112 | 0) + 12 | 0, (HEAP32[i31 + 92 >> 2] | 0) + (((i26 & 65535) >>> 8 & 65535) + (HEAP32[i24 + 32 + ((i26 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, HEAPU8[i24 + 32 + ((i26 & 255) * 12 | 0) + 10 >> 0] | 0, i27, HEAPU8[i28 + 32 + ((i29 & 255) * 12 | 0) + 10 >> 0] | 0, HEAP32[i31 + 100 >> 2] | 0);
     } else {
      i2 = i4 + 32 | 0;
      i6 = HEAP32[i2 >> 2] | 0;
      i7 = i6 + 8 | 0;
      i4 = HEAP16[i6 + 10 >> 1] | 0;
      if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
       i3 = 0;
       i8 = 0;
      } else {
       i3 = HEAP32[i6 + 92 >> 2] | 0;
       if (!i3) {
        i3 = 0;
        i8 = 1;
       } else if (!(HEAP8[i6 + 11 >> 0] | 0)) {
        i3 = 0;
        i8 = 1;
       } else {
        i4 = HEAP32[i7 >> 2] | 0;
        i3 = i3 + ((i4 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i8 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i4 = i4 >>> 16 & 65535;
       }
      }
      if ((i4 & 65535) < 768 | (i4 & 255) != 0) i7 = 0; else {
       i4 = HEAP32[i6 + 100 >> 2] | 0;
       i5 = HEAP32[i6 + 92 >> 2] | 0;
       if (!i5) i7 = 0; else if (!(HEAP8[i6 + 11 >> 0] | 0)) i7 = 0; else {
        i31 = HEAP16[i7 >> 1] | 0;
        i7 = i5 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i4) | 0) + (HEAP32[i7 + 32 + ((i31 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i31 & 65535) >>> 8 & 65535)) | 0;
       }
      }
      i4 = HEAP32[i37 >> 2] | 0;
      i6 = i4 + 8 | 0;
      i31 = HEAP16[i4 + 10 >> 1] | 0;
      do if ((i31 & 65535) < 768 | (i31 & 255) != 0) {
       i4 = 0;
       i5 = 0;
      } else {
       i5 = HEAP32[i4 + 92 >> 2] | 0;
       if (!i5) {
        i4 = 0;
        i5 = 1;
       } else {
        if (!(HEAP8[i4 + 11 >> 0] | 0)) {
         i4 = 0;
         i5 = 1;
         break;
        }
        i4 = HEAP16[i6 >> 1] | 0;
        i4 = i5 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i6 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i5 = HEAPU8[i6 + 32 + ((HEAPU8[i6 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       }
      } while (0);
      if ((i3 | 0) != (i7 | 0)) {
       i4 = i4 + (Math_imul(i5, i1) | 0) | 0;
       while (1) {
        HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i3 = i3 + i8 | 0;
        if ((i3 | 0) == (i7 | 0)) break; else i4 = i4 + i5 | 0;
       }
      }
     }
     i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0) + i1 | 0;
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < i39 >>> 0);
  i1 = (i25 | 0) != 0;
  if ((i33 & 2 | 0) != 0 & i1) {
   f30 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i21 = i38 + 12 | 0;
   i22 = i38 + 24 | 0;
   i23 = i38 + 4 | 0;
   i24 = i38 + 16 | 0;
   i25 = i38 + 28 | 0;
   i26 = i38 + 8 | 0;
   i27 = i38 + 20 | 0;
   i28 = i38 + 32 | 0;
   i29 = i40 + 4 | 0;
   i31 = i40 + 8 | 0;
   i20 = 0;
   i2 = 0;
   do {
    i8 = HEAP32[i43 >> 2] | 0;
    i3 = i8 + (i20 * 112 | 0) | 0;
    i6 = HEAP32[i8 + (i20 * 112 | 0) + 4 >> 2] | 0;
    i7 = (i6 | 0) == 0;
    if (i7) i42 = 86; else if (!(HEAP8[(HEAP32[i6 + 32 >> 2] | 0) + 15 >> 0] | 0)) i42 = 86; else {
     i3 = HEAP32[i3 >> 2] | 0;
     i5 = i6;
    }
    if ((i42 | 0) == 86) {
     i42 = 0;
     i5 = HEAP32[i3 >> 2] | 0;
     i3 = i5;
    }
    i4 = HEAP32[i8 + (i20 * 112 | 0) + 8 >> 2] | 0;
    do if (i3) {
     i3 = HEAP32[i3 + 32 >> 2] | 0;
     if (!((i4 | 0) < 0 | (HEAP32[i3 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i3 + 132 >> 2] | 0) - (HEAP32[i3 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i4 | 0)) {
      if (!i7) if ((HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i3 + 100 >> 2] | 0)) break;
      i19 = i5 + 32 | 0;
      i9 = HEAP32[i19 >> 2] | 0;
      i10 = HEAP32[i9 + 100 >> 2] | 0;
      i5 = HEAP8[i9 + 15 >> 0] | 0;
      i12 = HEAP32[i37 >> 2] | 0;
      i17 = i12 + 8 | 0;
      i6 = HEAP16[i12 + 14 >> 1] | 0;
      i3 = (i6 & 65535) < 768 | (i6 & 255) != 0;
      L143 : do if (!(i5 << 24 >> 24)) {
       if (i3) {
        i3 = 0;
        i7 = 0;
       } else {
        i3 = HEAP32[i12 + 92 >> 2] | 0;
        if (!i3) {
         i3 = 0;
         i7 = 1;
        } else if (!(HEAP8[i12 + 15 >> 0] | 0)) {
         i3 = 0;
         i7 = 1;
        } else {
         i6 = HEAP32[i12 + 12 >> 2] | 0;
         i3 = i3 + ((i6 >>> 8 & 255) + (HEAP32[i17 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i7 = HEAPU8[i17 + 32 + ((HEAPU8[i12 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i6 = i6 >>> 16 & 65535;
        }
       }
       i4 = i3 + (Math_imul(i7, i2) | 0) | 0;
       i5 = i4;
       do if ((i6 & 65535) < 768 | (i6 & 255) != 0) {
        i6 = 0;
        i3 = 0;
       } else {
        i3 = HEAP32[i12 + 92 >> 2] | 0;
        if (!i3) {
         i6 = 0;
         i3 = 1;
        } else {
         if (!(HEAP8[i12 + 15 >> 0] | 0)) {
          i6 = 0;
          i3 = 1;
          break;
         }
         i6 = HEAP16[i12 + 12 >> 1] | 0;
         i6 = i3 + (((i6 & 65535) >>> 8 & 65535) + (HEAP32[i17 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i3 = HEAPU8[i17 + 32 + ((HEAPU8[i12 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        }
       } while (0);
       i3 = ((i6 + (Math_imul(i3, i2) | 0) + (Math_imul(i3, i10) | 0) - i5 | 0) >>> 0) / (i3 >>> 0) | 0;
       if ((i3 | 0) > 0) while (1) {
        HEAPF32[i4 >> 2] = Math_fround(0.0);
        HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
        HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
        i4 = i5 + i7 | 0;
        if ((i3 | 0) > 1) {
         i3 = i3 + -1 | 0;
         i5 = i4;
        } else break;
       }
      } else {
       if (i3) {
        i3 = 0;
        i18 = 0;
       } else {
        i3 = HEAP32[i12 + 92 >> 2] | 0;
        if (!i3) {
         i3 = 0;
         i18 = 1;
        } else if (!(HEAP8[i12 + 15 >> 0] | 0)) {
         i3 = 0;
         i18 = 1;
        } else {
         i6 = HEAP32[i12 + 12 >> 2] | 0;
         i3 = i3 + ((i6 >>> 8 & 255) + (HEAP32[i17 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i18 = HEAPU8[i17 + 32 + ((HEAPU8[i12 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i6 = i6 >>> 16 & 65535;
        }
       }
       i11 = i3 + (Math_imul(i18, i2) | 0) | 0;
       if (!i32) {
        i7 = i9 + 8 | 0;
        i4 = HEAP16[i9 + 14 >> 1] | 0;
        do if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
         i3 = 0;
         i8 = 0;
        } else {
         i3 = HEAP32[i9 + 92 >> 2] | 0;
         if (!i3) {
          i3 = 0;
          i8 = 1;
          break;
         }
         i5 = HEAP32[i9 + 12 >> 2] | 0;
         i3 = i3 + ((i5 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i8 = HEAPU8[i7 + 32 + ((HEAPU8[i9 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i4 = i5 >>> 16 & 65535;
         i5 = i5 >>> 24 & 255;
        } while (0);
        do if ((i4 & 65535) < 768 | (i4 & 255) != 0) i7 = 0; else {
         i4 = HEAP32[i9 + 92 >> 2] | 0;
         if ((i4 | 0) == 0 | i5 << 24 >> 24 == 0) {
          i7 = 0;
          break;
         }
         i18 = HEAP16[i9 + 12 >> 1] | 0;
         i7 = i4 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i9 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i10) | 0) + (HEAP32[i7 + 32 + ((i18 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i18 & 65535) >>> 8 & 65535)) | 0;
        } while (0);
        do if ((i6 & 65535) < 768 | (i6 & 255) != 0) {
         i4 = 0;
         i5 = 0;
        } else {
         i4 = HEAP32[i12 + 92 >> 2] | 0;
         if (!i4) {
          i4 = 0;
          i5 = 1;
          break;
         }
         if (!(HEAP8[i12 + 15 >> 0] | 0)) {
          i4 = 0;
          i5 = 1;
          break;
         }
         i5 = HEAP16[i12 + 12 >> 1] | 0;
         i4 = i4 + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i17 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i5 = HEAPU8[i17 + 32 + ((HEAPU8[i12 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        } while (0);
        if ((i3 | 0) == (i7 | 0)) break;
        i4 = i4 + (Math_imul(i5, i2) | 0) | 0;
        while (1) {
         HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i3 = i3 + i8 | 0;
         if ((i3 | 0) == (i7 | 0)) break L143; else i4 = i4 + i5 | 0;
        }
       }
       __ZN10Matrix3x3fC2ERK10Matrix4x4f(i38, i8 + (i20 * 112 | 0) + 12 | 0);
       i3 = __Z20ComputeTransformTypeRK10Matrix4x4ff((HEAP32[i43 >> 2] | 0) + (i20 * 112 | 0) + 12 | 0, f30) | 0;
       do if (!(i3 & 2)) {
        if (i3 & 1 | 0) {
         f16 = Math_fround(Math_fround(1.0) / Math_fround(__Z19ComputeUniformScaleRK10Matrix4x4f((HEAP32[i43 >> 2] | 0) + (i20 * 112 | 0) + 12 | 0)));
         f14 = Math_fround(f16 * Math_fround(HEAPF32[gb + 62512 >> 2]));
         f15 = Math_fround(f16 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
         f16 = Math_fround(f16 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
         HEAPF32[i40 >> 2] = f14;
         HEAPF32[i29 >> 2] = f15;
         HEAPF32[i31 >> 2] = f16;
         __ZN10Matrix3x3f5ScaleERK8Vector3f(i38, i40) | 0;
        }
        i6 = HEAP32[i19 >> 2] | 0;
        i7 = i6 + 8 | 0;
        i5 = HEAP16[i6 + 14 >> 1] | 0;
        do if ((i5 & 65535) < 768 | (i5 & 255) != 0) {
         i4 = 0;
         i8 = 0;
         i3 = i5;
        } else {
         i3 = HEAP32[i6 + 92 >> 2] | 0;
         if (!i3) {
          i4 = 0;
          i8 = 1;
          i3 = i5;
          break;
         }
         if (!(HEAP8[i6 + 15 >> 0] | 0)) {
          i4 = 0;
          i8 = 1;
          i3 = i5;
          break;
         }
         i17 = HEAP32[i6 + 12 >> 2] | 0;
         i4 = i3 + ((i17 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i17 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i8 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i3 = i17 >>> 16 & 65535;
        } while (0);
        do if ((i3 & 65535) < 768 | (i3 & 255) != 0) i5 = 0; else {
         i3 = HEAP32[i6 + 92 >> 2] | 0;
         if (!i3) {
          i5 = 0;
          break;
         }
         if (!(HEAP8[i6 + 15 >> 0] | 0)) {
          i5 = 0;
          break;
         }
         i5 = HEAP16[i6 + 12 >> 1] | 0;
         i5 = i3 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i6 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, HEAP32[i6 + 100 >> 2] | 0) | 0) + (HEAP32[i7 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i5 & 65535) >>> 8 & 65535)) | 0;
        } while (0);
        if ((i4 | 0) == (i5 | 0)) break; else i3 = i11;
        while (1) {
         f14 = Math_fround(HEAPF32[i38 >> 2]);
         f47 = Math_fround(HEAPF32[i4 >> 2]);
         f14 = Math_fround(f14 * f47);
         f15 = Math_fround(HEAPF32[i21 >> 2]);
         f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
         f15 = Math_fround(f14 + Math_fround(f15 * f13));
         f14 = Math_fround(HEAPF32[i22 >> 2]);
         f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
         f14 = Math_fround(f15 + Math_fround(f14 * f16));
         f15 = Math_fround(f47 * Math_fround(HEAPF32[i23 >> 2]));
         f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i24 >> 2])));
         f15 = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i25 >> 2])));
         f47 = Math_fround(f47 * Math_fround(HEAPF32[i26 >> 2]));
         f13 = Math_fround(f47 + Math_fround(f13 * Math_fround(HEAPF32[i27 >> 2])));
         f16 = Math_fround(f13 + Math_fround(f16 * Math_fround(HEAPF32[i28 >> 2])));
         HEAPF32[i3 >> 2] = f14;
         HEAPF32[i3 + 4 >> 2] = f15;
         HEAPF32[i3 + 8 >> 2] = f16;
         i4 = i4 + i8 | 0;
         if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i18 | 0;
        }
       } else {
        __ZN10Matrix3x3f15InvertTransposeEv(i38);
        i6 = HEAP32[i19 >> 2] | 0;
        i7 = i6 + 8 | 0;
        i4 = HEAP16[i6 + 14 >> 1] | 0;
        do if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
         i5 = 0;
         i9 = 0;
         i3 = i4;
        } else {
         i3 = HEAP32[i6 + 92 >> 2] | 0;
         if (!i3) {
          i5 = 0;
          i9 = 1;
          i3 = i4;
          break;
         }
         if (!(HEAP8[i6 + 15 >> 0] | 0)) {
          i5 = 0;
          i9 = 1;
          i3 = i4;
          break;
         }
         i17 = HEAP32[i6 + 12 >> 2] | 0;
         i5 = i3 + ((i17 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i17 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i9 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i3 = i17 >>> 16 & 65535;
        } while (0);
        do if ((i3 & 65535) < 768 | (i3 & 255) != 0) i8 = 0; else {
         i3 = HEAP32[i6 + 92 >> 2] | 0;
         if (!i3) {
          i8 = 0;
          break;
         }
         if (!(HEAP8[i6 + 15 >> 0] | 0)) {
          i8 = 0;
          break;
         }
         i8 = HEAP16[i6 + 12 >> 1] | 0;
         i8 = i3 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i6 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, HEAP32[i6 + 100 >> 2] | 0) | 0) + (HEAP32[i7 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i8 & 65535) >>> 8 & 65535)) | 0;
        } while (0);
        if ((i5 | 0) == (i8 | 0)) break; else {
         i7 = i5;
         i6 = i11;
        }
        while (1) {
         f13 = Math_fround(HEAPF32[i38 >> 2]);
         f47 = Math_fround(HEAPF32[i7 >> 2]);
         f13 = Math_fround(f13 * f47);
         f14 = Math_fround(HEAPF32[i21 >> 2]);
         f16 = Math_fround(HEAPF32[i7 + 4 >> 2]);
         f14 = Math_fround(f13 + Math_fround(f14 * f16));
         f13 = Math_fround(HEAPF32[i22 >> 2]);
         f15 = Math_fround(HEAPF32[i7 + 8 >> 2]);
         f13 = Math_fround(f14 + Math_fround(f13 * f15));
         f14 = Math_fround(f47 * Math_fround(HEAPF32[i23 >> 2]));
         f14 = Math_fround(f14 + Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2])));
         f14 = Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i25 >> 2])));
         f47 = Math_fround(f47 * Math_fround(HEAPF32[i26 >> 2]));
         f16 = Math_fround(f47 + Math_fround(f16 * Math_fround(HEAPF32[i27 >> 2])));
         f15 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i28 >> 2])));
         f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f15 * f15))));
         if (f16 > f30) {
          f47 = Math_fround(f13 / f16);
          i3 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
          f47 = Math_fround(f14 / f16);
          i4 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
          f47 = Math_fround(f15 / f16);
          i5 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
         } else {
          i3 = HEAP32[gb + 1162364 >> 2] | 0;
          i4 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
          i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
         }
         HEAP32[i6 >> 2] = i3;
         HEAP32[i6 + 4 >> 2] = i4;
         HEAP32[i6 + 8 >> 2] = i5;
         i7 = i7 + i9 | 0;
         if ((i7 | 0) == (i8 | 0)) break; else i6 = i6 + i18 | 0;
        }
       } while (0);
      } while (0);
      i2 = (HEAP32[(HEAP32[i19 >> 2] | 0) + 100 >> 2] | 0) + i2 | 0;
     }
    } while (0);
    i20 = i20 + 1 | 0;
   } while (i20 >>> 0 < i39 >>> 0);
  }
 }
 if ((i33 & 128 | 0) != 0 & i1) {
  f30 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  i18 = i38 + 12 | 0;
  i19 = i38 + 24 | 0;
  i20 = i38 + 4 | 0;
  i21 = i38 + 16 | 0;
  i22 = i38 + 28 | 0;
  i23 = i38 + 8 | 0;
  i24 = i38 + 20 | 0;
  i25 = i38 + 32 | 0;
  i26 = i40 + 4 | 0;
  i27 = i40 + 8 | 0;
  i17 = 0;
  i1 = 0;
  while (1) {
   i7 = HEAP32[i43 >> 2] | 0;
   i2 = i7 + (i17 * 112 | 0) | 0;
   i5 = HEAP32[i7 + (i17 * 112 | 0) + 4 >> 2] | 0;
   i6 = (i5 | 0) == 0;
   if (i6) i42 = 155; else if (!(HEAP8[(HEAP32[i5 + 32 >> 2] | 0) + 39 >> 0] | 0)) i42 = 155; else {
    i2 = HEAP32[i2 >> 2] | 0;
    i4 = i5;
   }
   if ((i42 | 0) == 155) {
    i42 = 0;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = i4;
   }
   i3 = HEAP32[i7 + (i17 * 112 | 0) + 8 >> 2] | 0;
   do if (i2) {
    i2 = HEAP32[i2 + 32 >> 2] | 0;
    if (!((i3 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i2 + 132 >> 2] | 0) - (HEAP32[i2 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i3 | 0)) {
     if (!i6) if ((HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) break;
     i3 = i4 + 32 | 0;
     i8 = HEAP32[i3 >> 2] | 0;
     i12 = HEAP32[i8 + 100 >> 2] | 0;
     i4 = HEAP8[i8 + 39 >> 0] | 0;
     i9 = HEAP32[i37 >> 2] | 0;
     i10 = i9 + 8 | 0;
     i5 = HEAP16[i9 + 38 >> 1] | 0;
     i2 = (i5 & 65535) < 1024 | (i5 & 255) != 0;
     L237 : do if (!(i4 << 24 >> 24)) {
      if (i2) {
       i2 = 0;
       i6 = 0;
      } else {
       i2 = HEAP32[i9 + 92 >> 2] | 0;
       if (!i2) {
        i2 = 0;
        i6 = 1;
       } else if (!(HEAP8[i9 + 39 >> 0] | 0)) {
        i2 = 0;
        i6 = 1;
       } else {
        i5 = HEAP32[i9 + 36 >> 2] | 0;
        i2 = i2 + ((i5 >>> 8 & 255) + (HEAP32[i10 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i6 = HEAPU8[i10 + 32 + ((HEAPU8[i9 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i5 = i5 >>> 16 & 65535;
       }
      }
      i3 = i2 + (Math_imul(i6, i1) | 0) | 0;
      i4 = i3;
      do if ((i5 & 65535) < 1024 | (i5 & 255) != 0) {
       i5 = 0;
       i2 = 0;
      } else {
       i2 = HEAP32[i9 + 92 >> 2] | 0;
       if (!i2) {
        i5 = 0;
        i2 = 1;
       } else {
        if (!(HEAP8[i9 + 39 >> 0] | 0)) {
         i5 = 0;
         i2 = 1;
         break;
        }
        i5 = HEAP16[i9 + 36 >> 1] | 0;
        i5 = i2 + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i2 = HEAPU8[i10 + 32 + ((HEAPU8[i9 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       }
      } while (0);
      i2 = ((i5 + (Math_imul(i2, i1) | 0) + (Math_imul(i2, i12) | 0) - i4 | 0) >>> 0) / (i2 >>> 0) | 0;
      if ((i2 | 0) > 0) while (1) {
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
       HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
       HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
       i3 = i4 + i6 | 0;
       if ((i2 | 0) > 1) {
        i2 = i2 + -1 | 0;
        i4 = i3;
       } else break;
      }
     } else {
      if (i2) {
       i2 = 0;
       i11 = 0;
      } else {
       i2 = HEAP32[i9 + 92 >> 2] | 0;
       if (!i2) {
        i2 = 0;
        i11 = 1;
       } else if (!(HEAP8[i9 + 39 >> 0] | 0)) {
        i2 = 0;
        i11 = 1;
       } else {
        i5 = HEAP32[i9 + 36 >> 2] | 0;
        i2 = i2 + ((i5 >>> 8 & 255) + (HEAP32[i10 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i11 = HEAPU8[i10 + 32 + ((HEAPU8[i9 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i5 = i5 >>> 16 & 65535;
       }
      }
      i2 = i2 + (Math_imul(i11, i1) | 0) | 0;
      if (!i32) {
       i6 = i8 + 8 | 0;
       i3 = HEAP16[i8 + 38 >> 1] | 0;
       do if ((i3 & 65535) < 1024 | (i3 & 255) != 0) {
        i2 = 0;
        i7 = 0;
       } else {
        i2 = HEAP32[i8 + 92 >> 2] | 0;
        if (!i2) {
         i2 = 0;
         i7 = 1;
         break;
        }
        i4 = HEAP32[i8 + 36 >> 2] | 0;
        i2 = i2 + ((i4 >>> 8 & 255) + (HEAP32[i6 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i7 = HEAPU8[i6 + 32 + ((HEAPU8[i8 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i3 = i4 >>> 16 & 65535;
        i4 = i4 >>> 24 & 255;
       } while (0);
       do if ((i3 & 65535) < 1024 | (i3 & 255) != 0) i6 = 0; else {
        i3 = HEAP32[i8 + 92 >> 2] | 0;
        if ((i3 | 0) == 0 | i4 << 24 >> 24 == 0) {
         i6 = 0;
         break;
        }
        i31 = HEAP16[i8 + 36 >> 1] | 0;
        i6 = i3 + ((Math_imul(HEAPU8[i6 + 32 + ((HEAPU8[i8 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i12) | 0) + (HEAP32[i6 + 32 + ((i31 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i31 & 65535) >>> 8 & 65535)) | 0;
       } while (0);
       do if ((i5 & 65535) < 1024 | (i5 & 255) != 0) {
        i3 = 0;
        i4 = 0;
       } else {
        i3 = HEAP32[i9 + 92 >> 2] | 0;
        if (!i3) {
         i3 = 0;
         i4 = 1;
         break;
        }
        if (!(HEAP8[i9 + 39 >> 0] | 0)) {
         i3 = 0;
         i4 = 1;
         break;
        }
        i4 = HEAP16[i9 + 36 >> 1] | 0;
        i3 = i3 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i4 = HEAPU8[i10 + 32 + ((HEAPU8[i9 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       } while (0);
       if ((i2 | 0) == (i6 | 0)) break;
       i3 = i3 + (Math_imul(i4, i1) | 0) | 0;
       while (1) {
        HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
        i2 = i2 + i7 | 0;
        if ((i2 | 0) == (i6 | 0)) break L237; else i3 = i3 + i4 | 0;
       }
      }
      __ZN10Matrix3x3fC2ERK10Matrix4x4f(i38, i7 + (i17 * 112 | 0) + 12 | 0);
      i5 = __Z20ComputeTransformTypeRK10Matrix4x4ff((HEAP32[i43 >> 2] | 0) + (i17 * 112 | 0) + 12 | 0, f30) | 0;
      if (i5 & 1 | 0) {
       f47 = Math_fround(Math_fround(1.0) / Math_fround(__Z19ComputeUniformScaleRK10Matrix4x4f((HEAP32[i43 >> 2] | 0) + (i17 * 112 | 0) + 12 | 0)));
       f15 = Math_fround(f47 * Math_fround(HEAPF32[gb + 62512 >> 2]));
       f16 = Math_fround(f47 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
       f47 = Math_fround(f47 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
       HEAPF32[i40 >> 2] = f15;
       HEAPF32[i26 >> 2] = f16;
       HEAPF32[i27 >> 2] = f47;
       __ZN10Matrix3x3f5ScaleERK8Vector3f(i38, i40) | 0;
      }
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i6 + 8 | 0;
      i4 = HEAP16[i6 + 38 >> 1] | 0;
      i3 = (i4 & 65535) < 1024 | (i4 & 255) != 0;
      do if (!(i5 & 2)) {
       do if (i3) {
        i3 = 0;
        i5 = 0;
       } else {
        i3 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i3) {
         i3 = 0;
         i5 = 1;
         break;
        }
        if (!(HEAP8[i6 + 39 >> 0] | 0)) {
         i3 = 0;
         i5 = 1;
         break;
        }
        i4 = HEAP32[i6 + 36 >> 2] | 0;
        i3 = i3 + ((i4 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i5 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i4 = i4 >>> 16 & 65535;
       } while (0);
       do if ((i4 & 65535) < 1024 | (i4 & 255) != 0) i4 = 0; else {
        i4 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i4) {
         i4 = 0;
         break;
        }
        if (!(HEAP8[i6 + 39 >> 0] | 0)) {
         i4 = 0;
         break;
        }
        i31 = HEAP16[i6 + 36 >> 1] | 0;
        i4 = i4 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i6 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, HEAP32[i6 + 100 >> 2] | 0) | 0) + (HEAP32[i7 + 32 + ((i31 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i31 & 65535) >>> 8 & 65535)) | 0;
       } while (0);
       if ((i3 | 0) == (i4 | 0)) break;
       while (1) {
        f13 = Math_fround(HEAPF32[i3 >> 2]);
        f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
        f47 = Math_fround(HEAPF32[i3 + 8 >> 2]);
        f15 = Math_fround(f13 * Math_fround(HEAPF32[i38 >> 2]));
        f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2])));
        f15 = Math_fround(f15 + Math_fround(f47 * Math_fround(HEAPF32[i19 >> 2])));
        f16 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
        f16 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i21 >> 2])));
        f16 = Math_fround(f16 + Math_fround(f47 * Math_fround(HEAPF32[i22 >> 2])));
        f13 = Math_fround(f13 * Math_fround(HEAPF32[i23 >> 2]));
        f14 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i24 >> 2])));
        f47 = Math_fround(f14 + Math_fround(f47 * Math_fround(HEAPF32[i25 >> 2])));
        i31 = HEAP32[i3 + 12 >> 2] | 0;
        HEAPF32[i2 >> 2] = f15;
        HEAPF32[i2 + 4 >> 2] = f16;
        HEAPF32[i2 + 8 >> 2] = f47;
        HEAP32[i2 + 12 >> 2] = i31;
        i3 = i3 + i5 | 0;
        if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i11 | 0;
       }
      } else {
       do if (i3) {
        i5 = 0;
        i8 = 0;
        i3 = i4;
       } else {
        i3 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i3) {
         i5 = 0;
         i8 = 1;
         i3 = i4;
         break;
        }
        if (!(HEAP8[i6 + 39 >> 0] | 0)) {
         i5 = 0;
         i8 = 1;
         i3 = i4;
         break;
        }
        i31 = HEAP32[i6 + 36 >> 2] | 0;
        i5 = i3 + ((i31 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i31 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i8 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i3 = i31 >>> 16 & 65535;
       } while (0);
       do if ((i3 & 65535) < 1024 | (i3 & 255) != 0) i7 = 0; else {
        i3 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i3) {
         i7 = 0;
         break;
        }
        if (!(HEAP8[i6 + 39 >> 0] | 0)) {
         i7 = 0;
         break;
        }
        i31 = HEAP16[i6 + 36 >> 1] | 0;
        i7 = i3 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i6 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, HEAP32[i6 + 100 >> 2] | 0) | 0) + (HEAP32[i7 + 32 + ((i31 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i31 & 65535) >>> 8 & 65535)) | 0;
       } while (0);
       if ((i5 | 0) == (i7 | 0)) break; else i6 = i5;
       while (1) {
        f47 = Math_fround(HEAPF32[i6 >> 2]);
        f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i6 + 8 >> 2]);
        f13 = Math_fround(f47 * Math_fround(HEAPF32[i38 >> 2]));
        f13 = Math_fround(f13 + Math_fround(f16 * Math_fround(HEAPF32[i18 >> 2])));
        f13 = Math_fround(f13 + Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2])));
        f14 = Math_fround(f47 * Math_fround(HEAPF32[i20 >> 2]));
        f14 = Math_fround(f14 + Math_fround(f16 * Math_fround(HEAPF32[i21 >> 2])));
        f14 = Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i22 >> 2])));
        f47 = Math_fround(f47 * Math_fround(HEAPF32[i23 >> 2]));
        f16 = Math_fround(f47 + Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2])));
        f15 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i25 >> 2])));
        f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f15 * f15))));
        if (f16 > f30) {
         f47 = Math_fround(f13 / f16);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
         f47 = Math_fround(f14 / f16);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
         f47 = Math_fround(f15 / f16);
         i5 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i3 = HEAP32[gb + 1162364 >> 2] | 0;
         i4 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
         i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
        }
        i31 = HEAP32[i6 + 12 >> 2] | 0;
        HEAP32[i2 >> 2] = i3;
        HEAP32[i2 + 4 >> 2] = i4;
        HEAP32[i2 + 8 >> 2] = i5;
        HEAP32[i2 + 12 >> 2] = i31;
        i6 = i6 + i8 | 0;
        if ((i6 | 0) == (i7 | 0)) break; else i2 = i2 + i11 | 0;
       }
      } while (0);
     } while (0);
     i1 = i12 + i1 | 0;
    }
   } while (0);
   i17 = i17 + 1 | 0;
   if (i17 >>> 0 >= i39 >>> 0) {
    i26 = 0;
    break;
   }
  }
 } else i26 = 0;
 do {
  i27 = i26 + 3 | 0;
  if (1 << i27 & i33 | 0) {
   i1 = HEAP8[i36 + (i27 << 1) + 1 >> 0] | 0;
   i28 = i1 & 255;
   if (!i35) {
    i29 = i1 << 24 >> 24 == 0;
    i24 = (i1 & 255) > 1;
    i25 = i28 << 2;
    i23 = 0;
    i1 = 0;
    do {
     i3 = HEAP32[i43 >> 2] | 0;
     i2 = i3 + (i23 * 112 | 0) | 0;
     i5 = HEAP32[i3 + (i23 * 112 | 0) + 4 >> 2] | 0;
     i6 = (i5 | 0) == 0;
     if (i6) i42 = 228; else if (!(HEAP8[(HEAP32[i5 + 32 >> 2] | 0) + 8 + (i27 << 2) + 3 >> 0] | 0)) i42 = 228; else {
      i2 = HEAP32[i2 >> 2] | 0;
      i4 = i5;
     }
     if ((i42 | 0) == 228) {
      i42 = 0;
      i4 = HEAP32[i2 >> 2] | 0;
      i2 = i4;
     }
     i3 = HEAP32[i3 + (i23 * 112 | 0) + 8 >> 2] | 0;
     do if (i2) {
      i2 = HEAP32[i2 + 32 >> 2] | 0;
      if (!((i3 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i2 + 132 >> 2] | 0) - (HEAP32[i2 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i3 | 0)) {
       if (!i6) if ((HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) break;
       i8 = HEAP32[i4 + 32 >> 2] | 0;
       i22 = HEAP32[i8 + 100 >> 2] | 0;
       i3 = i8 + 8 | 0;
       i2 = i26;
       while (1) {
        i10 = i2 + 3 | 0;
        if ((i2 | 0) > 0 ? (HEAP8[i3 + (i10 << 2) + 3 >> 0] | 0) == 0 : 0) i2 = i2 + -1 | 0; else break;
       }
       i7 = i8 + 8 | 0;
       i6 = HEAP16[i7 + (i10 << 2) + 2 >> 1] | 0;
       i9 = (i6 & 65535) >>> 8;
       i12 = i9 & 65535;
       i2 = HEAP32[i37 >> 2] | 0;
       i3 = i2 + 8 | 0;
       i32 = HEAP16[i3 + (i27 << 2) + 2 >> 1] | 0;
       do if ((i32 & 65535) < 256 | (i32 & 255) != 0) {
        i5 = 0;
        i20 = 0;
       } else {
        i2 = HEAP32[i2 + 92 >> 2] | 0;
        if (!i2) {
         i5 = 0;
         i20 = 1;
        } else {
         if (!(HEAP8[i3 + (i27 << 2) + 3 >> 0] | 0)) {
          i5 = 0;
          i20 = 1;
          break;
         }
         i5 = HEAP16[i3 + (i27 << 2) >> 1] | 0;
         i5 = i2 + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i20 = HEAPU8[i3 + 32 + ((HEAPU8[i3 + (i27 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        }
       } while (0);
       i4 = Math_imul(i20, i1) | 0;
       i19 = i5 + i4 | 0;
       i17 = i19;
       i18 = Math_imul(i20, i22) | 0;
       i21 = i19 + i18 | 0;
       L341 : do if (!(HEAP8[i7 + (i10 << 2) + 3 >> 0] | 0)) {
        if (!i18) break;
        if (i29) {
         i2 = i19;
         do i2 = i2 + i20 | 0; while ((i2 | 0) != (i21 | 0));
        } else {
         i2 = i19;
         i3 = 0;
         while (1) {
          _memset(i5 + (i4 + (Math_imul(i20, i3) | 0)) | 0, 0, i25 | 0) | 0;
          i2 = i2 + i20 | 0;
          if ((i2 | 0) == (i21 | 0)) break; else i3 = i3 + 1 | 0;
         }
        }
       } else {
        if ((i6 & 65535) < 256 | (i6 & 255) != 0) break;
        i2 = HEAP32[i8 + 92 >> 2] | 0;
        if (!i2) {
         i2 = 0;
         i11 = 1;
        } else {
         i11 = HEAP16[i7 + (i10 << 2) >> 1] | 0;
         i2 = i2 + (((i11 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i11 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
         i11 = HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i10 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        }
        i3 = HEAP32[i8 + 92 >> 2] | 0;
        if (!i3) i10 = 0; else {
         i32 = HEAP16[i7 + (i10 << 2) >> 1] | 0;
         i10 = i3 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i7 + (i10 << 2) >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i22) | 0) + (HEAP32[i7 + 32 + ((i32 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i32 & 65535) >>> 8 & 65535)) | 0;
        }
        if ((i2 | 0) == (i10 | 0)) break;
        if (!(i9 << 16 >> 16)) if (i29) while (1) {
         i2 = i2 + i11 | 0;
         if ((i2 | 0) == (i10 | 0)) break L341;
        } else {
         i4 = i17;
         i3 = i19;
         while (1) {
          _memset(i3 | 0, 0, i25 | 0) | 0;
          i2 = i2 + i11 | 0;
          i3 = i4 + i20 | 0;
          if ((i2 | 0) == (i10 | 0)) break L341; else i4 = i3;
         }
        }
        if (i12 >>> 0 >= i28 >>> 0) {
         i6 = i17;
         i3 = i19;
         while (1) {
          i4 = i2;
          i5 = 0;
          while (1) {
           HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
           i5 = i5 + 1 | 0;
           if ((i5 | 0) == (i12 | 0)) break; else {
            i3 = i3 + 4 | 0;
            i4 = i4 + 4 | 0;
           }
          }
          i2 = i2 + i11 | 0;
          i3 = i6 + i20 | 0;
          if ((i2 | 0) == (i10 | 0)) break L341; else i6 = i3;
         }
        }
        i8 = i25 - (i12 << 2) | 0;
        i7 = i17;
        i6 = i19;
        while (1) {
         i3 = i6;
         i4 = i2;
         i5 = 0;
         while (1) {
          HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
          i5 = i5 + 1 | 0;
          if ((i5 | 0) == (i12 | 0)) break; else {
           i3 = i3 + 4 | 0;
           i4 = i4 + 4 | 0;
          }
         }
         _memset(i6 + (i12 << 2) | 0, 0, i8 | 0) | 0;
         i2 = i2 + i11 | 0;
         i3 = i7 + i20 | 0;
         if ((i2 | 0) == (i10 | 0)) break; else {
          i7 = i3;
          i6 = i3;
         }
        }
       } while (0);
       switch (i26 | 0) {
       case 1:
        {
         i32 = HEAP32[i43 >> 2] | 0;
         f13 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 76 >> 2]);
         f16 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 80 >> 2]);
         f14 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 84 >> 2]);
         f15 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 88 >> 2]);
         break;
        }
       case 2:
        {
         i32 = HEAP32[i43 >> 2] | 0;
         f13 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 92 >> 2]);
         f16 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 96 >> 2]);
         f14 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 100 >> 2]);
         f15 = Math_fround(HEAPF32[i32 + (i23 * 112 | 0) + 104 >> 2]);
         break;
        }
       default:
        {
         f13 = Math_fround(1.0);
         f14 = Math_fround(0.0);
         f15 = Math_fround(0.0);
         f16 = Math_fround(1.0);
        }
       }
       do if (i24) {
        if ((i18 | 0) == 0 | (f15 != Math_fround(0.0) | (f14 != Math_fround(0.0) | (f16 != Math_fround(1.0) | f13 != Math_fround(1.0)))) ^ 1) break; else {
         i3 = i17;
         i2 = i19;
        }
        while (1) {
         i32 = i3;
         HEAPF32[i32 >> 2] = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i32 >> 2])));
         i32 = i32 + 4 | 0;
         HEAPF32[i32 >> 2] = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i32 >> 2])));
         i2 = i2 + i20 | 0;
         if ((i2 | 0) == (i21 | 0)) break; else i3 = i2;
        }
       } while (0);
       i1 = i22 + i1 | 0;
      }
     } while (0);
     i23 = i23 + 1 | 0;
    } while (i23 >>> 0 < i39 >>> 0);
   }
  }
  i26 = i26 + 1 | 0;
 } while ((i26 | 0) != 4);
 if (i33 & 4 | 0) {
  if (!i35) {
   i11 = i40 + 12 | 0;
   i12 = i40 + 16 | 0;
   i17 = i40 + 4 | 0;
   i10 = 0;
   i1 = 0;
   do {
    i4 = HEAP32[i43 >> 2] | 0;
    i2 = i4 + (i10 * 112 | 0) | 0;
    i5 = HEAP32[i4 + (i10 * 112 | 0) + 4 >> 2] | 0;
    i6 = (i5 | 0) == 0;
    if (i6) i42 = 276; else if (!(HEAP8[(HEAP32[i5 + 32 >> 2] | 0) + 19 >> 0] | 0)) i42 = 276; else {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = i5;
    }
    if ((i42 | 0) == 276) {
     i42 = 0;
     i2 = HEAP32[i2 >> 2] | 0;
     i3 = i2;
    }
    i4 = HEAP32[i4 + (i10 * 112 | 0) + 8 >> 2] | 0;
    do if (i3) {
     i3 = HEAP32[i3 + 32 >> 2] | 0;
     if (!((i4 | 0) < 0 | (HEAP32[i3 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i3 + 132 >> 2] | 0) - (HEAP32[i3 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i4 | 0)) {
      if (!i6) if ((HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i3 + 100 >> 2] | 0)) break;
      i36 = HEAP32[i2 + 32 >> 2] | 0;
      i9 = HEAP32[i36 + 100 >> 2] | 0;
      do if (!(HEAP8[i36 + 19 >> 0] | 0)) {
       i6 = HEAP32[i37 >> 2] | 0;
       i7 = i6 + 8 | 0;
       i3 = HEAP16[i6 + 18 >> 1] | 0;
       do if ((i3 & 65535) < 1024 | (i3 & 255) != 2) {
        i2 = 0;
        i8 = 0;
        i4 = i3;
       } else {
        i2 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i2) {
         i2 = 0;
         i8 = 1;
         i4 = i3;
         break;
        }
        if (!(HEAP8[i6 + 19 >> 0] | 0)) {
         i2 = 0;
         i8 = 1;
         i4 = i3;
         break;
        }
        i4 = HEAP32[i6 + 16 >> 2] | 0;
        i2 = i2 + ((i4 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i8 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i4 = i4 >>> 16 & 65535;
       } while (0);
       i3 = i2 + (Math_imul(i8, i1) | 0) | 0;
       i5 = i3;
       do if ((i4 & 65535) < 1024 | (i4 & 255) != 2) {
        i4 = 0;
        i2 = 0;
       } else {
        i2 = HEAP32[i6 + 92 >> 2] | 0;
        if (!i2) {
         i4 = 0;
         i2 = 1;
         break;
        }
        if (!(HEAP8[i6 + 19 >> 0] | 0)) {
         i4 = 0;
         i2 = 1;
         break;
        }
        i4 = HEAP16[i6 + 16 >> 1] | 0;
        i4 = i2 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i2 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       } while (0);
       i2 = ((i4 + (Math_imul(i2, i1) | 0) + (Math_imul(i2, i9) | 0) - i5 | 0) >>> 0) / (i2 >>> 0) | 0;
       if ((i2 | 0) <= 0) break;
       while (1) {
        HEAP32[i3 >> 2] = -1;
        if ((i2 | 0) > 1) {
         i2 = i2 + -1 | 0;
         i3 = i3 + i8 | 0;
        } else break;
       }
      } else {
       HEAP32[i11 >> 2] = i9;
       HEAP32[i12 >> 2] = i9;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, gb + 64016 | 0);
       i7 = i38;
       i5 = HEAP32[i7 + 4 >> 2] | 0;
       i6 = i17;
       HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i6 + 4 >> 2] = i5;
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
       HEAP32[i40 >> 2] = i6;
       __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32(i2, i6);
       i6 = HEAP32[i40 >> 2] | 0;
       i5 = HEAP32[i11 >> 2] | 0;
       i7 = i6 + (i5 << 2) | 0;
       i3 = HEAP32[i37 >> 2] | 0;
       i4 = i3 + 8 | 0;
       i36 = HEAP16[i3 + 18 >> 1] | 0;
       do if ((i36 & 65535) < 1024 | (i36 & 255) != 2) {
        i2 = 0;
        i4 = 0;
       } else {
        i2 = HEAP32[i3 + 92 >> 2] | 0;
        if (!i2) {
         i2 = 0;
         i4 = 1;
         break;
        }
        if (!(HEAP8[i3 + 19 >> 0] | 0)) {
         i2 = 0;
         i4 = 1;
         break;
        }
        i36 = HEAP16[i3 + 16 >> 1] | 0;
        i2 = i2 + (((i36 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i36 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i4 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       } while (0);
       if (i5 | 0) {
        i3 = i6;
        i2 = i2 + (Math_imul(i4, i1) | 0) | 0;
        while (1) {
         HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
         i3 = i3 + 4 | 0;
         if ((i3 | 0) == (i7 | 0)) break; else i2 = i2 + i4 | 0;
        }
       }
       if ((HEAP32[i12 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(i6, i17);
        HEAP32[i40 >> 2] = 0;
       }
      } while (0);
      i1 = i9 + i1 | 0;
     }
    } while (0);
    i10 = i10 + 1 | 0;
   } while (i10 >>> 0 < i39 >>> 0);
  }
  __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i45, 1);
 }
 if (i34) {
  i1 = HEAP32[i43 >> 2] | 0;
  i42 = (HEAP32[i41 >> 2] | 0) - i1 | 0;
  i11 = (i42 | 0) / 112 | 0;
  if (i42) {
   i12 = i45 + 144 | 0;
   i2 = 0;
   i10 = 0;
   i3 = 0;
   do {
    i9 = HEAP32[i1 + (i10 * 112 | 0) >> 2] | 0;
    i4 = HEAP32[i1 + (i10 * 112 | 0) + 4 >> 2] | 0;
    i5 = HEAP32[i1 + (i10 * 112 | 0) + 8 >> 2] | 0;
    do if (i9) {
     i7 = i9 + 32 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     if (!((i5 | 0) < 0 | (HEAP32[i8 + 92 >> 2] | 0) == 0)) if ((((HEAP32[i8 + 132 >> 2] | 0) - (HEAP32[i8 + 128 >> 2] | 0) | 0) / 52 | 0 | 0) > (i5 | 0)) {
      if (!i4) i4 = HEAP32[i8 + 100 >> 2] | 0; else {
       i4 = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 100 >> 2] | 0;
       if ((i4 | 0) != (HEAP32[i8 + 100 >> 2] | 0)) break;
      }
      i1 = HEAP32[i37 >> 2] | 0;
      i6 = i1 + 164 | 0;
      i5 = (i4 | 0) > 0;
      if (!(HEAP32[i8 + 176 >> 2] | 0)) if (i5) {
       _memset((HEAP32[i6 >> 2] | 0) + (i2 << 5) | 0, 0, i4 << 5 | 0) | 0;
       i5 = HEAP32[i7 >> 2] | 0;
       i1 = HEAP32[i37 >> 2] | 0;
      } else i5 = i8; else if (i5) {
       i7 = HEAP32[i8 + 164 >> 2] | 0;
       i6 = HEAP32[i6 >> 2] | 0;
       i5 = 0;
       do {
        i42 = i5 + i2 | 0;
        HEAP32[i6 + (i42 << 5) >> 2] = HEAP32[i7 + (i5 << 5) >> 2];
        HEAP32[i6 + (i42 << 5) + 4 >> 2] = HEAP32[i7 + (i5 << 5) + 4 >> 2];
        HEAP32[i6 + (i42 << 5) + 8 >> 2] = HEAP32[i7 + (i5 << 5) + 8 >> 2];
        HEAP32[i6 + (i42 << 5) + 12 >> 2] = HEAP32[i7 + (i5 << 5) + 12 >> 2];
        HEAP32[i6 + (i42 << 5) + 16 >> 2] = (HEAP32[i7 + (i5 << 5) + 16 >> 2] | 0) + i3;
        HEAP32[i6 + (i42 << 5) + 20 >> 2] = (HEAP32[i7 + (i5 << 5) + 20 >> 2] | 0) + i3;
        HEAP32[i6 + (i42 << 5) + 24 >> 2] = (HEAP32[i7 + (i5 << 5) + 24 >> 2] | 0) + i3;
        HEAP32[i6 + (i42 << 5) + 28 >> 2] = (HEAP32[i7 + (i5 << 5) + 28 >> 2] | 0) + i3;
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i4 | 0));
       i5 = i8;
      } else i5 = i8;
      i6 = HEAP32[i5 + 156 >> 2] | 0;
      i42 = HEAP32[i9 + 156 >> 2] | 0;
      _memcpy((HEAP32[i1 + 144 >> 2] | 0) + (i3 << 6) | 0, HEAP32[i5 + 144 >> 2] | 0, i6 << 6 | 0) | 0;
      i1 = (HEAP32[i12 >> 2] | 0) + (i3 << 2) | 0;
      if ((i6 | 0) == (i42 | 0)) _memcpy(i1 | 0, HEAP32[i9 + 144 >> 2] | 0, i6 << 2 | 0) | 0; else _memset(i1 | 0, 0, i6 << 2 | 0) | 0;
      i3 = i6 + i3 | 0;
      i2 = i4 + i2 | 0;
      i1 = HEAP32[i43 >> 2] | 0;
     }
    } while (0);
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i11 | 0));
  }
  HEAP32[i45 + 184 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2];
 }
 if (!i44) {
  STACKTOP = i46;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i44);
 STACKTOP = i46;
 return;
}

function __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i5 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i5 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 116 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 124 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 128 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 132 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 140 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 148 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 152 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 156 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 164 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 168 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 172 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 176 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 180 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 184 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 188 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 192 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 196 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 200 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 204 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 208 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 212 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 216 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 220 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 224 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 228 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 232 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 236 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 240 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 244 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 248 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 252 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 256 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 260 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 264 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 268 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 272 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 276 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 280 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 284 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 288 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 292 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 296 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 300 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 304 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 308 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 312 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 316 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 320 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 324 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 328 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 332 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 336 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 340 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 344 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 348 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 352 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 356 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 360 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 364 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 372 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 376 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 380 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 384 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 388 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i2;
  i1 = i3;
 }
 HEAP32[i7 + 392 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i1 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 396 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 400 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 404 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 408 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 412 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 416 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 420 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 424 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 428 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 432 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 436 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 440 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 444 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 448 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 452 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 456 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 460 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 464 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 468 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 472 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 476 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 480 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 484 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 488 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 492 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i7 + 496 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i7 + 500 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 504 | 0, i5);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 636 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 768 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 992 | 0, i5);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1216 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1220 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1224 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1228 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1232 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1236 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1240 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1244 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1248 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1252 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1256 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1260 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1264 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1268 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1272 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1276 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1280 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1284 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1288 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1292 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1296 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1300 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1304 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1308 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1312 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 1316 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 1320 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i7 + 1324 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i7 + 1328 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i9 = i7;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __Z24IsProceduralInputVisiblePK18ProceduralMaterialRK8UnityStr(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 2400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i47 + 112 | 0;
 i31 = i47 + 104 | 0;
 i30 = i47 + 96 | 0;
 i29 = i47 + 88 | 0;
 i28 = i47 + 80 | 0;
 i27 = i47 + 72 | 0;
 i39 = i47 + 56 | 0;
 i26 = i47 + 48 | 0;
 i25 = i47 + 40 | 0;
 i33 = i47 + 32 | 0;
 i45 = i47 + 8 | 0;
 i5 = i47;
 i18 = i47 + 1216 | 0;
 i19 = i47 + 1212 | 0;
 i20 = i47 + 2384 | 0;
 i21 = i47 + 2256 | 0;
 i22 = i47 + 1200 | 0;
 i23 = i47 + 176 | 0;
 i24 = i47 + 1232 | 0;
 i40 = i47 + 152 | 0;
 i17 = i47 + 144 | 0;
 i46 = i47 + 120 | 0;
 i2 = i1 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i43 = i6 << 24 >> 24 < 0;
 i44 = i43 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i43 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i44, i6);
 i6 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16, i18) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 if (!i6) {
  i45 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0, i16 | 0) | 0;
  i46 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  HEAP32[i5 >> 2] = i45;
  HEAP32[i5 + 4 >> 2] = i46;
  __Z6FormatPKcz(i18, gb + 432387 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 432455 | 0, 594, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i46 = 1;
  STACKTOP = i47;
  return i46 | 0;
 }
 i2 = i6 + 48 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i1 << 24 >> 24 < 0;
 if (i5) i1 = HEAP32[i6 + 52 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i46 = 1;
  STACKTOP = i47;
  return i46 | 0;
 };
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 HEAP32[i46 + 16 >> 2] = 0;
 HEAP32[i46 + 20 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAP32[i40 + 16 >> 2] = 0;
 HEAP32[i40 + 20 >> 2] = 0;
 i34 = i40 + 8 | 0;
 i35 = i40 + 4 | 0;
 i36 = i40 + 16 | 0;
 i37 = i40 + 20 | 0;
 i38 = i46 + 8 | 0;
 i42 = i46 + 4 | 0;
 i43 = i46 + 16 | 0;
 i44 = i46 + 20 | 0;
 i15 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
 i7 = 0;
 i9 = 3;
 i1 = 0;
 i2 = 0;
 i8 = 15;
 L12 : while (1) {
  HEAP32[i17 >> 2] = 0;
  HEAP8[i18 >> 0] = 0;
  HEAP32[i45 >> 2] = i18;
  HEAP32[i45 + 4 >> 2] = i17;
  L14 : do if ((_sscanf(i15, gb + 432555 | 0, i45) | 0) > 0) {
   switch (HEAP8[i18 >> 0] | 0) {
   case 43:
    {
     i1 = 8;
     break;
    }
   case 45:
    {
     i1 = 9;
     break;
    }
   default:
    {
     i41 = 11;
     break L14;
    }
   }
   i14 = i2;
   i41 = 71;
  } else i41 = 11; while (0);
  L19 : do if ((i41 | 0) == 11) {
   i41 = 0;
   HEAP32[i33 >> 2] = i19;
   HEAP32[i33 + 4 >> 2] = i17;
   L21 : do if ((_sscanf(i15, gb + 432561 | 0, i33) | 0) > 0) {
    i5 = 1;
    i9 = HEAP32[i19 >> 2] | 0;
   } else {
    HEAP8[i20 >> 0] = 0;
    HEAP32[i25 >> 2] = i20;
    HEAP32[i25 + 4 >> 2] = i17;
    if ((_sscanf(i15, gb + 432566 | 0, i25) | 0) > 0) if (!(_strncmp(i20, gb + 1087694 | 0, 2) | 0)) i1 = 0; else if (!(_strncmp(i20, gb + 1086412 | 0, 2) | 0)) i1 = 1; else if (!(_strncmp(i20, gb + 1087637 | 0, 2) | 0)) i1 = 2; else if (!(_strncmp(i20, gb + 1087678 | 0, 2) | 0)) i1 = 3; else if (!(_strncmp(i20, gb + 1087640 | 0, 2) | 0)) i1 = 5; else if (!(_strncmp(i20, gb + 1087646 | 0, 2) | 0)) i1 = 7; else i41 = 20; else i41 = 20;
    L31 : do if ((i41 | 0) == 20) {
     i41 = 0;
     HEAP8[i20 >> 0] = 0;
     HEAP32[i26 >> 2] = i20;
     HEAP32[i26 + 4 >> 2] = i17;
     L33 : do if ((_sscanf(i15, gb + 432555 | 0, i26) | 0) > 0) switch (HEAP8[i20 >> 0] | 0) {
     case 62:
      {
       i1 = 4;
       break L31;
      }
     case 60:
      {
       i1 = 6;
       break L31;
      }
     case 42:
      {
       i1 = 10;
       break L31;
      }
     case 47:
      {
       i1 = 11;
       break L31;
      }
     case 40:
      {
       i1 = 15;
       break L31;
      }
     case 41:
      {
       i1 = 16;
       break L31;
      }
     case 33:
      {
       i1 = 14;
       break L31;
      }
     case 91:
      {
       i1 = 15;
       break L31;
      }
     case 93:
      {
       i1 = 16;
       break L31;
      }
     default:
      break L33;
     } while (0);
     i5 = i21;
     i6 = i5 + 128 | 0;
     do {
      HEAP8[i5 >> 0] = 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i6 | 0));
     HEAP32[i39 >> 2] = i21;
     HEAP32[i39 + 4 >> 2] = i17;
     if ((_sscanf(i15, gb + 432572 | 0, i39) | 0) > 0) i41 = 32; else {
      HEAP32[i27 >> 2] = i21;
      HEAP32[i27 + 4 >> 2] = i17;
      if ((_sscanf(i15, gb + 432602 | 0, i27) | 0) > 0) i41 = 32; else {
       HEAP8[i22 >> 0] = 0;
       HEAP32[i30 >> 2] = i22;
       HEAP32[i30 + 4 >> 2] = i17;
       if ((_sscanf(i15, gb + 432726 | 0, i30) | 0) > 0) if (!(_strncmp(gb + 1087447 | 0, i22, 4) | 0)) {
        i5 = 0;
        i6 = 1;
        i7 = 0;
        i2 = i2 & -256 | 1;
       } else i41 = 51; else i41 = 51;
       L51 : do if ((i41 | 0) == 51) {
        i41 = 0;
        HEAP8[i22 >> 0] = 0;
        HEAP32[i31 >> 2] = i22;
        HEAP32[i31 + 4 >> 2] = i17;
        if ((_sscanf(i15, gb + 432732 | 0, i31) | 0) > 0) if (!(_strncmp(gb + 1087441 | 0, i22, 5) | 0)) {
         i5 = 0;
         i6 = 1;
         i7 = 0;
         i2 = i2 & -256;
         break;
        }
        i5 = HEAP8[i15 >> 0] | 0;
        if (!(i5 << 24 >> 24)) {
         i5 = 0;
         i6 = 0;
        } else {
         i6 = i15;
         while (1) {
          if (!(_isspace(i5 << 24 >> 24) | 0)) break;
          i6 = i6 + 1 | 0;
          i5 = HEAP8[i6 >> 0] | 0;
          if (!(i5 << 24 >> 24)) {
           i5 = 0;
           i6 = 0;
           break L51;
          }
         }
         HEAP32[i32 >> 2] = i15;
         _snprintf(i23, 1023, gb + 432738 | 0, i32) | 0;
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i23, 0, gb + 432455 | 0, 322, 1, 0, 0, 0);
         i5 = 1;
         i6 = 0;
        }
       } while (0);
      }
     }
     do if ((i41 | 0) == 32) {
      i41 = 0;
      HEAP32[i22 >> 2] = 0;
      HEAP32[i22 + 4 >> 2] = 0;
      HEAP32[i22 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i21, _strlen(i21) | 0);
      i5 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16, i22) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
      if (!i5) {
       i5 = 0;
       i6 = 1;
       i7 = 0;
       i2 = i2 & -256 | 1;
       break;
      }
      i2 = i5;
      i14 = i15 + (HEAP32[i17 >> 2] | 0) | 0;
      HEAP16[i22 >> 1] = 0;
      HEAP32[i28 >> 2] = i22;
      HEAP32[i28 + 4 >> 2] = i23;
      do if ((_sscanf(i14, gb + 432629 | 0, i28) | 0) > 0) {
       i6 = HEAP8[i22 >> 0] | 0;
       switch (i6 | 0) {
       case 119:
        {
         i1 = 20;
         i7 = 4;
         break;
        }
       case 121:
        {
         i1 = 18;
         i7 = 2;
         break;
        }
       case 122:
        {
         i1 = 19;
         i7 = 3;
         break;
        }
       default:
        {
         i1 = 17;
         i7 = 1;
        }
       }
       switch (HEAP32[i5 + 88 >> 2] | 0) {
       case 4:
       case 0:
        {
         i5 = 1;
         break;
        }
       case 8:
       case 1:
        {
         i5 = 2;
         break;
        }
       case 9:
       case 2:
        {
         i5 = 3;
         break;
        }
       case 10:
       case 3:
        {
         i5 = 4;
         break;
        }
       default:
        i5 = -1;
       }
       if ((i7 | 0) > (i5 | 0)) {
        HEAP32[i29 >> 2] = i6;
        HEAP32[i29 + 4 >> 2] = i21;
        _snprintf(i24, 1023, gb + 432641 | 0, i29) | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i24, 0, gb + 432455 | 0, 278, 1, 0, 0, 0);
        i5 = 1;
        i6 = 0;
        break;
       } else {
        HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i23 >> 2] | 0);
        i5 = 0;
        i6 = 1;
        break;
       }
      } else {
       i5 = 0;
       i6 = 1;
       i1 = 17;
      } while (0);
      i7 = 2;
     } while (0);
     if (!i6) {
      i41 = 62;
      break L12;
     }
     if (i5 << 24 >> 24) {
      i41 = 65;
      break L12;
     }
     if ((i7 | 0) == 3) {
      i14 = i2;
      i41 = 71;
      break L19;
     } else {
      i5 = i7;
      i9 = i2;
      break L21;
     }
    } while (0);
    i14 = i2;
    i41 = 71;
    break L19;
   } while (0);
   i8 = HEAP32[i38 >> 2] | 0;
   i7 = HEAP32[i42 >> 2] | 0;
   i14 = i8 - i7 >> 2;
   i6 = HEAP32[i43 >> 2] | 0;
   i2 = HEAP32[i44 >> 2] | 0;
   if ((((i14 | 0) == 0 ? 0 : (i14 * 341 | 0) + -1 | 0) | 0) == (i2 + i6 | 0)) {
    __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i46);
    i2 = HEAP32[i44 >> 2] | 0;
    i6 = HEAP32[i43 >> 2] | 0;
    i8 = HEAP32[i38 >> 2] | 0;
    i7 = HEAP32[i42 >> 2] | 0;
   }
   i2 = i2 + i6 | 0;
   if ((i8 | 0) == (i7 | 0)) i2 = 0; else i2 = (HEAP32[i7 + (((i2 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i2 >>> 0) % 341 | 0) * 12 | 0) | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i1;
   HEAP32[i2 + 8 >> 2] = i9;
   HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
   i6 = i1;
   i2 = i9;
  } while (0);
  L95 : do if ((i41 | 0) == 71) {
   i41 = 0;
   L97 : do if ((i9 | 0) == 3 & (i8 | 0) < 16) {
    switch (i1 | 0) {
    case 9:
     {
      i11 = 12;
      break L97;
     }
    case 8:
     break;
    default:
     {
      i41 = 80;
      break L97;
     }
    }
    i11 = 13;
   } else i41 = 80; while (0);
   L100 : do if ((i41 | 0) == 80) {
    switch (i1 | 0) {
    case 15:
     {
      i6 = HEAP32[i34 >> 2] | 0;
      i5 = HEAP32[i35 >> 2] | 0;
      i41 = i6 - i5 >> 2;
      i2 = HEAP32[i36 >> 2] | 0;
      i1 = HEAP32[i37 >> 2] | 0;
      if ((((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
       __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i40);
       i1 = HEAP32[i37 >> 2] | 0;
       i2 = HEAP32[i36 >> 2] | 0;
       i6 = HEAP32[i34 >> 2] | 0;
       i5 = HEAP32[i35 >> 2] | 0;
      }
      i1 = i1 + i2 | 0;
      if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
      HEAP32[i1 >> 2] = 3;
      HEAP32[i1 + 4 >> 2] = 15;
      HEAP32[i1 + 8 >> 2] = i14;
      HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + 1;
      i5 = 3;
      i6 = 15;
      i2 = i14;
      break L95;
     }
    case 16:
     break;
    default:
     {
      i11 = i1;
      break L100;
     }
    }
    i1 = HEAP32[i37 >> 2] | 0;
    if (!i1) {
     i41 = 95;
     break L12;
    }
    while (1) {
     i11 = HEAP32[i36 >> 2] | 0;
     i2 = i1 + -1 | 0;
     i9 = i11 + i2 | 0;
     i41 = HEAP32[i35 >> 2] | 0;
     i10 = HEAP32[i41 + (((i9 >>> 0) / 341 | 0) << 2) >> 2] | 0;
     i9 = (i9 >>> 0) % 341 | 0;
     i7 = HEAP32[i10 + (i9 * 12 | 0) >> 2] | 0;
     i8 = HEAP32[i10 + (i9 * 12 | 0) + 4 >> 2] | 0;
     i9 = HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] | 0;
     HEAP32[i37 >> 2] = i2;
     i2 = HEAP32[i34 >> 2] | 0;
     i41 = i2 - i41 >> 2;
     if ((1 - i1 - i11 + ((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) >>> 0 > 681) {
      __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
      HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + -4;
     }
     if ((i8 | 0) == 15) {
      i5 = 3;
      i6 = 16;
      i2 = i14;
      break L95;
     }
     i6 = HEAP32[i38 >> 2] | 0;
     i5 = HEAP32[i42 >> 2] | 0;
     i41 = i6 - i5 >> 2;
     i2 = HEAP32[i43 >> 2] | 0;
     i1 = HEAP32[i44 >> 2] | 0;
     if ((((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
      __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i46);
      i1 = HEAP32[i44 >> 2] | 0;
      i2 = HEAP32[i43 >> 2] | 0;
      i6 = HEAP32[i38 >> 2] | 0;
      i5 = HEAP32[i42 >> 2] | 0;
     }
     i1 = i1 + i2 | 0;
     if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
     HEAP32[i1 >> 2] = i7;
     HEAP32[i1 + 4 >> 2] = i8;
     HEAP32[i1 + 8 >> 2] = i9;
     HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
     i1 = HEAP32[i37 >> 2] | 0;
     if (!i1) {
      i41 = 95;
      break L12;
     }
    }
   } while (0);
   i10 = gb + 59656 + (i11 << 2) | 0;
   i1 = HEAP32[i37 >> 2] | 0;
   L124 : do if (!i1) i1 = 0; else while (1) {
    i5 = HEAP32[i36 >> 2] | 0;
    i2 = i1 + -1 | 0;
    i9 = i5 + i2 | 0;
    i6 = HEAP32[i35 >> 2] | 0;
    i41 = HEAP32[i6 + (((i9 >>> 0) / 341 | 0) << 2) >> 2] | 0;
    i9 = (i9 >>> 0) % 341 | 0;
    i7 = HEAP32[i41 + (i9 * 12 | 0) >> 2] | 0;
    i8 = HEAP32[i41 + (i9 * 12 | 0) + 4 >> 2] | 0;
    i9 = HEAP32[i41 + (i9 * 12 | 0) + 8 >> 2] | 0;
    if ((i8 | 0) == 15) break L124;
    if ((HEAP32[i10 >> 2] | 0) > (HEAP32[gb + 59656 + (i8 << 2) >> 2] | 0)) break L124;
    HEAP32[i37 >> 2] = i2;
    i2 = HEAP32[i34 >> 2] | 0;
    i41 = i2 - i6 >> 2;
    if ((1 - i1 - i5 + ((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) >>> 0 > 681) {
     __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
     HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + -4;
    }
    i6 = HEAP32[i38 >> 2] | 0;
    i5 = HEAP32[i42 >> 2] | 0;
    i41 = i6 - i5 >> 2;
    i2 = HEAP32[i43 >> 2] | 0;
    i1 = HEAP32[i44 >> 2] | 0;
    if ((((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
     __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i46);
     i1 = HEAP32[i44 >> 2] | 0;
     i2 = HEAP32[i43 >> 2] | 0;
     i6 = HEAP32[i38 >> 2] | 0;
     i5 = HEAP32[i42 >> 2] | 0;
    }
    i1 = i1 + i2 | 0;
    if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 4 >> 2] = i8;
    HEAP32[i1 + 8 >> 2] = i9;
    HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
    i1 = HEAP32[i37 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     break;
    }
   } while (0);
   i6 = HEAP32[i34 >> 2] | 0;
   i5 = HEAP32[i35 >> 2] | 0;
   i41 = i6 - i5 >> 2;
   i2 = HEAP32[i36 >> 2] | 0;
   if ((((i41 | 0) == 0 ? 0 : (i41 * 341 | 0) + -1 | 0) | 0) == (i2 + i1 | 0)) {
    __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i40);
    i1 = HEAP32[i37 >> 2] | 0;
    i2 = HEAP32[i36 >> 2] | 0;
    i6 = HEAP32[i34 >> 2] | 0;
    i5 = HEAP32[i35 >> 2] | 0;
   }
   i1 = i1 + i2 | 0;
   if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
   HEAP32[i1 >> 2] = 3;
   HEAP32[i1 + 4 >> 2] = i11;
   HEAP32[i1 + 8 >> 2] = i14;
   HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + 1;
   i5 = 3;
   i6 = i11;
   i2 = i14;
  } while (0);
  i15 = i15 + (HEAP32[i17 >> 2] | 0) | 0;
  i7 = i5;
  i9 = i5;
  i1 = i6;
  i8 = i6;
 }
 if ((i41 | 0) == 62) {
  i1 = HEAP32[i37 >> 2] | 0;
  if (i1 | 0) do {
   i32 = HEAP32[i36 >> 2] | 0;
   i2 = i1 + -1 | 0;
   i31 = i32 + i2 | 0;
   i33 = HEAP32[i35 >> 2] | 0;
   i31 = (HEAP32[i33 + (((i31 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i31 >>> 0) % 341 | 0) * 12 | 0) | 0;
   HEAP32[i39 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i37 >> 2] = i2;
   i2 = HEAP32[i34 >> 2] | 0;
   i33 = i2 - i33 >> 2;
   if ((1 - i1 - i32 + ((i33 | 0) == 0 ? 0 : (i33 * 341 | 0) + -1 | 0) | 0) >>> 0 > 681) {
    __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + -4;
   }
   i6 = HEAP32[i38 >> 2] | 0;
   i5 = HEAP32[i42 >> 2] | 0;
   i33 = i6 - i5 >> 2;
   i2 = HEAP32[i43 >> 2] | 0;
   i1 = HEAP32[i44 >> 2] | 0;
   if ((((i33 | 0) == 0 ? 0 : (i33 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
    __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i46);
    i1 = HEAP32[i44 >> 2] | 0;
    i2 = HEAP32[i43 >> 2] | 0;
    i6 = HEAP32[i38 >> 2] | 0;
    i5 = HEAP32[i42 >> 2] | 0;
   }
   i1 = i1 + i2 | 0;
   if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
   HEAP32[i1 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
   i1 = HEAP32[i37 >> 2] | 0;
  } while ((i1 | 0) != 0);
  __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i40);
 } else if ((i41 | 0) == 65) {
  i1 = HEAP32[i44 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i43 >> 2] | 0;
   do {
    i1 = i1 + -1 | 0;
    HEAP32[i44 >> 2] = i1;
    i2 = i2 + 1 | 0;
    HEAP32[i43 >> 2] = i2;
    if (i2 >>> 0 > 681) {
     __ZdlPv(HEAP32[HEAP32[i42 >> 2] >> 2] | 0);
     HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 4;
     i2 = (HEAP32[i43 >> 2] | 0) + -341 | 0;
     HEAP32[i43 >> 2] = i2;
     i1 = HEAP32[i44 >> 2] | 0;
    }
   } while ((i1 | 0) != 0);
  }
  __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i40);
 } else if ((i41 | 0) == 95) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432843 | 0, 0, gb + 432455 | 0, 404, 1, 0, 0, 0);
  i1 = HEAP32[i44 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i43 >> 2] | 0;
   do {
    i1 = i1 + -1 | 0;
    HEAP32[i44 >> 2] = i1;
    i2 = i2 + 1 | 0;
    HEAP32[i43 >> 2] = i2;
    if (i2 >>> 0 > 681) {
     __ZdlPv(HEAP32[HEAP32[i42 >> 2] >> 2] | 0);
     HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 4;
     i2 = (HEAP32[i43 >> 2] | 0) + -341 | 0;
     HEAP32[i43 >> 2] = i2;
     i1 = HEAP32[i44 >> 2] | 0;
    }
   } while ((i1 | 0) != 0);
  }
  __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i40);
 }
 i1 = HEAP32[i44 >> 2] | 0;
 if (!i1) i1 = 1; else {
  HEAP32[i45 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = 0;
  HEAP32[i45 + 12 >> 2] = 0;
  HEAP32[i45 + 16 >> 2] = 0;
  HEAP32[i45 + 20 >> 2] = 0;
  i14 = i45 + 8 | 0;
  i16 = i45 + 4 | 0;
  i17 = i45 + 16 | 0;
  i15 = i45 + 20 | 0;
  i11 = 0;
  i9 = 0;
  f4 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  i5 = i1;
  L183 : while (1) {
   L185 : while (1) {
    i2 = HEAP32[i42 >> 2] | 0;
    i40 = HEAP32[i43 >> 2] | 0;
    i39 = HEAP32[i2 + (((i40 >>> 0) / 341 | 0) << 2) >> 2] | 0;
    i6 = (i40 >>> 0) % 341 | 0;
    i1 = HEAP32[i39 + (i6 * 12 | 0) >> 2] | 0;
    i10 = HEAP32[i39 + (i6 * 12 | 0) + 4 >> 2] | 0;
    i6 = HEAP32[i39 + (i6 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i44 >> 2] = i5 + -1;
    i40 = i40 + 1 | 0;
    HEAP32[i43 >> 2] = i40;
    if (i40 >>> 0 > 681) {
     __ZdlPv(HEAP32[i2 >> 2] | 0);
     HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 4;
     HEAP32[i43 >> 2] = (HEAP32[i43 >> 2] | 0) + -341;
    }
    L190 : do switch (i1 | 0) {
    case 3:
     break L185;
    case 2:
     {
      i1 = i6;
      if (!(HEAP32[i1 + 64 >> 2] | 0)) {
       i8 = 0;
       i6 = Math_fround(HEAPF32[i1 + 68 >> 2]) != Math_fround(0.0) | i6 & -256;
       break L190;
      } else {
       i8 = 1;
       i6 = HEAP32[i1 + 68 + (i10 + -17 << 2) >> 2] | 0;
       break L190;
      }
     }
    default:
     i8 = i1;
    } while (0);
    i7 = HEAP32[i14 >> 2] | 0;
    i5 = HEAP32[i16 >> 2] | 0;
    i40 = i7 - i5 >> 2;
    i2 = HEAP32[i17 >> 2] | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    if ((((i40 | 0) == 0 ? 0 : (i40 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
     __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i45);
     i1 = HEAP32[i15 >> 2] | 0;
     i2 = HEAP32[i17 >> 2] | 0;
     i7 = HEAP32[i14 >> 2] | 0;
     i5 = HEAP32[i16 >> 2] | 0;
    }
    i1 = i1 + i2 | 0;
    if ((i7 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
    HEAP32[i1 >> 2] = i8;
    HEAP32[i1 + 4 >> 2] = i10;
    HEAP32[i1 + 8 >> 2] = i6;
    i1 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
    HEAP32[i15 >> 2] = i1;
    i5 = HEAP32[i44 >> 2] | 0;
    if (!i5) {
     i41 = 310;
     break L183;
    }
   }
   switch (i10 | 0) {
   case 11:
   case 10:
   case 9:
   case 8:
   case 7:
   case 5:
   case 6:
   case 4:
   case 3:
   case 2:
   case 1:
   case 0:
    {
     i2 = HEAP32[i15 >> 2] | 0;
     if (i2 >>> 0 < 2) {
      i41 = 141;
      break L183;
     }
     i39 = HEAP32[i17 >> 2] | 0;
     i5 = i2 + -1 | 0;
     i38 = i39 + i5 | 0;
     i40 = HEAP32[i16 >> 2] | 0;
     i37 = HEAP32[i40 + (((i38 >>> 0) / 341 | 0) << 2) >> 2] | 0;
     i38 = (i38 >>> 0) % 341 | 0;
     i1 = HEAP32[i37 + (i38 * 12 | 0) >> 2] | 0;
     f3 = Math_fround(HEAPF32[i37 + (i38 * 12 | 0) + 8 >> 2]);
     HEAP32[i15 >> 2] = i5;
     i5 = HEAP32[i14 >> 2] | 0;
     i40 = i5 - i40 >> 2;
     if ((1 - i2 - i39 + ((i40 | 0) == 0 ? 0 : (i40 * 341 | 0) + -1 | 0) | 0) >>> 0 > 681) {
      __ZdlPv(HEAP32[i5 + -4 >> 2] | 0);
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
      i9 = i1;
      f12 = f3;
     } else {
      i9 = i1;
      f12 = f3;
     }
     break;
    }
   case 14:
   case 13:
   case 12:
    {
     if (!(HEAP32[i15 >> 2] | 0)) {
      i41 = 145;
      break L183;
     } else f12 = f4;
     break;
    }
   default:
    {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432996 | 0, 0, gb + 432455 | 0, 524, 1, 0, 0, 0);
     f12 = f4;
    }
   }
   i38 = HEAP32[i15 >> 2] | 0;
   i39 = HEAP32[i17 >> 2] | 0;
   i2 = i38 + -1 | 0;
   i37 = i2 + i39 | 0;
   i40 = HEAP32[i16 >> 2] | 0;
   i36 = HEAP32[i40 + (((i37 >>> 0) / 341 | 0) << 2) >> 2] | 0;
   i37 = (i37 >>> 0) % 341 | 0;
   i1 = HEAP32[i36 + (i37 * 12 | 0) >> 2] | 0;
   f3 = Math_fround(HEAPF32[i36 + (i37 * 12 | 0) + 8 >> 2]);
   HEAP32[i15 >> 2] = i2;
   i2 = HEAP32[i14 >> 2] | 0;
   i40 = i2 - i40 >> 2;
   if ((1 - i38 - i39 + ((i40 | 0) == 0 ? 0 : (i40 * 341 | 0) + -1 | 0) | 0) >>> 0 > 681) {
    __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
   }
   L213 : do switch (i10 | 0) {
   case 0:
    {
     switch (i1 | 0) {
     case 0:
      {
       if (!(((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24)) i41 = 156; else i1 = 1;
       break;
      }
     case 1:
      {
       if (f3 != Math_fround(0.0)) i1 = 1; else i41 = 156;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
       i1 = 1;
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
       i1 = 1;
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
       i1 = 1;
      }
     }
     L222 : do if ((i41 | 0) == 156) {
      i41 = 0;
      switch (i9 | 0) {
      case 0:
       {
        i1 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 != 0;
        break L222;
       }
      case 1:
       {
        i1 = f12 != Math_fround(0.0);
        break L222;
       }
      case 2:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
        i1 = 1;
        break L222;
       }
      case 3:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
        i1 = 1;
        break L222;
       }
      default:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
        i1 = 1;
        break L222;
       }
      }
     } while (0);
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = i1 & 1 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 1:
    {
     switch (i1 | 0) {
     case 0:
      {
       if (!(((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24)) i1 = 0; else i41 = 169;
       break;
      }
     case 1:
      {
       if (f3 != Math_fround(0.0)) i41 = 169; else i1 = 0;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
       i41 = 169;
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
       i41 = 169;
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
       i41 = 169;
      }
     }
     L238 : do if ((i41 | 0) == 169) {
      i41 = 0;
      switch (i9 | 0) {
      case 0:
       {
        i1 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 != 0;
        break L238;
       }
      case 1:
       {
        i1 = f12 != Math_fround(0.0);
        break L238;
       }
      case 2:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
        i1 = 1;
        break L238;
       }
      case 3:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
        i1 = 1;
        break L238;
       }
      default:
       {
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
        i1 = 1;
        break L238;
       }
      }
     } while (0);
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = i1 & 1 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 2:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 == f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 3:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 != f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 4:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 > f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 6:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 < f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 5:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 >= f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 7:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = f3 <= f4 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   case 8:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 1;
     f3 = Math_fround(f3 + f4);
     break;
    }
   case 9:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 1;
     f3 = Math_fround(f3 - f4);
     break;
    }
   case 10:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 1;
     f3 = Math_fround(f3 * f4);
     break;
    }
   case 11:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     switch (i9 | 0) {
     case 0:
      {
       f4 = ((HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      {
       f4 = f12;
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f4 = Math_fround(1.0);
      }
     }
     i11 = 1;
     f3 = Math_fround(f3 / f4);
     break;
    }
   case 12:
    {
     switch (i1 | 0) {
     case 0:
      {
       f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
       break;
      }
     case 1:
      break;
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
       f3 = Math_fround(1.0);
      }
     }
     i11 = 1;
     f3 = Math_fround(-f3);
     break;
    }
   case 13:
    switch (i1 | 0) {
    case 1:
     {
      i11 = 1;
      break L213;
     }
    case 0:
     {
      i11 = 1;
      f3 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 ? Math_fround(1.0) : Math_fround(0.0);
      break L213;
     }
    case 2:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433378 | 0, 0, gb + 432455 | 0, 146, 512, 0, 0, 0);
      i11 = 1;
      f3 = Math_fround(1.0);
      break L213;
     }
    case 3:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433488 | 0, 0, gb + 432455 | 0, 149, 512, 0, 0, 0);
      i11 = 1;
      f3 = Math_fround(1.0);
      break L213;
     }
    default:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433583 | 0, 0, gb + 432455 | 0, 152, 512, 0, 0, 0);
      i11 = 1;
      f3 = Math_fround(1.0);
      break L213;
     }
    }
   case 14:
    {
     switch (i1 | 0) {
     case 0:
      {
       i1 = ((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 24 >> 24 != 0;
       break;
      }
     case 1:
      {
       i1 = f3 != Math_fround(0.0);
       break;
      }
     case 2:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
       i1 = 1;
       break;
      }
     case 3:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
       i1 = 1;
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
       i1 = 1;
      }
     }
     i11 = 0;
     f3 = (HEAP32[tempDoublePtr >> 2] = (i1 & 1 | (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -256) ^ 1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
   default:
    {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432996 | 0, 0, gb + 432455 | 0, 566, 1, 0, 0, 0);
     f3 = f13;
    }
   } while (0);
   i6 = HEAP32[i14 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   i40 = i6 - i5 >> 2;
   i2 = HEAP32[i17 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   if ((((i40 | 0) == 0 ? 0 : (i40 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
    __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i45);
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    i5 = HEAP32[i16 >> 2] | 0;
   }
   i1 = i1 + i2 | 0;
   if ((i6 | 0) == (i5 | 0)) i1 = 0; else i1 = (HEAP32[i5 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
   HEAP32[i1 >> 2] = i11;
   HEAPF32[i1 + 8 >> 2] = f3;
   i1 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i1;
   i5 = HEAP32[i44 >> 2] | 0;
   if (!i5) {
    i41 = 310;
    break;
   } else {
    f4 = f12;
    f13 = f3;
   }
  }
  L405 : do if ((i41 | 0) == 141) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432910 | 0, 0, gb + 432455 | 0, 508, 1, 0, 0, 0);
   i1 = 1;
  } else if ((i41 | 0) == 145) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432910 | 0, 0, gb + 432455 | 0, 519, 1, 0, 0, 0);
   i1 = 1;
  } else if ((i41 | 0) == 310) switch (i1 | 0) {
  case 0:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433676 | 0, 0, gb + 432455 | 0, 575, 1, 0, 0, 0);
    i1 = 1;
    break L405;
   }
  case 1:
   {
    i2 = HEAP32[i17 >> 2] | 0;
    i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + (((i2 >>> 0) / 341 | 0) << 2) >> 2] | 0;
    i2 = (i2 >>> 0) % 341 | 0;
    switch (HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0) {
    case 0:
     {
      i1 = (HEAP8[i1 + (i2 * 12 | 0) + 8 >> 0] | 0) != 0;
      break L405;
     }
    case 1:
     {
      i1 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]) != Math_fround(0.0);
      break L405;
     }
    case 2:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433083 | 0, 0, gb + 432455 | 0, 126, 512, 0, 0, 0);
      i1 = 1;
      break L405;
     }
    case 3:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433192 | 0, 0, gb + 432455 | 0, 129, 512, 0, 0, 0);
      i1 = 1;
      break L405;
     }
    default:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433286 | 0, 0, gb + 432455 | 0, 132, 512, 0, 0, 0);
      i1 = 1;
      break L405;
     }
    }
   }
  default:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 433761 | 0, 0, gb + 432455 | 0, 580, 1, 0, 0, 0);
    i1 = 1;
    break L405;
   }
  } while (0);
  __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i45);
 }
 __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i46);
 i46 = i1;
 STACKTOP = i47;
 return i46 | 0;
}

function __ZN12_GLOBAL__N_19InitTableEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[gb + 1553739 >> 0] | 0)) {
  _memset(gb + 1098896 | 0, 0, 824) | 0;
  HEAP8[gb + 1553739 >> 0] = 1;
 }
 HEAP32[gb + 1098896 >> 2] = HEAP32[gb + 1111240 + 684 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 4 >> 2] = gb + 1083701;
 HEAP32[gb + 1098896 + 8 >> 2] = HEAP32[gb + 1111240 + 696 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 12 >> 2] = gb + 1083695;
 HEAP32[gb + 1098896 + 16 >> 2] = HEAP32[gb + 1111240 + 688 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 20 >> 2] = gb + 1083699;
 HEAP32[gb + 1098896 + 24 >> 2] = HEAP32[gb + 1111240 + 760 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 28 >> 2] = gb + 1083659;
 HEAP32[gb + 1098896 + 32 >> 2] = HEAP32[gb + 1111240 + 756 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 36 >> 2] = gb + 1083661;
 HEAP32[gb + 1098896 + 40 >> 2] = HEAP32[gb + 1111240 + 752 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 44 >> 2] = gb + 1083663;
 HEAP32[gb + 1098896 + 48 >> 2] = HEAP32[gb + 1111240 + 748 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 52 >> 2] = gb + 1083665;
 HEAP32[gb + 1098896 + 56 >> 2] = HEAP32[gb + 1111240 + 744 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 60 >> 2] = gb + 1083667;
 HEAP32[gb + 1098896 + 64 >> 2] = HEAP32[gb + 1111240 + 668 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 68 >> 2] = gb + 1083709;
 HEAP32[gb + 1098896 + 72 >> 2] = HEAP32[gb + 1111240 + 664 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 76 >> 2] = gb + 1083711;
 HEAP32[gb + 1098896 + 80 >> 2] = HEAP32[gb + 1111240 + 660 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 84 >> 2] = gb + 1083713;
 HEAP32[gb + 1098896 + 88 >> 2] = HEAP32[gb + 1111240 + 672 >> 2] ^ -16777216;
 HEAP32[gb + 1098896 + 92 >> 2] = gb + 1083707;
 i1 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 117) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 96 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 100 >> 2] = gb + 900333;
 i1 = HEAP32[gb + 1111240 + 712 >> 2] ^ 16777215;
 i2 = i1 >>> 8;
 i1 = i1 & 255;
 i3 = HEAP32[gb + 1111240 + ((i1 ^ 105) << 2) >> 2] ^ i2;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 110) << 2) >> 2] ^ i3 >>> 8;
 HEAP32[gb + 1098896 + 104 >> 2] = ~i3;
 HEAP32[gb + 1098896 + 108 >> 2] = gb + 900340;
 i2 = HEAP32[gb + 1111240 + ((i1 ^ 97) << 2) >> 2] ^ i2;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 120) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 112 >> 2] = ~i2;
 HEAP32[gb + 1098896 + 116 >> 2] = gb + 900344;
 i1 = HEAP32[gb + 1111240 + 676 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 117) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 120 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 124 >> 2] = gb + 900348;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 77) << 2) >> 2] ^ i3 >>> 8;
 i1 = i3 >>> 8;
 i3 = i3 & 255;
 i4 = HEAP32[gb + 1111240 + ((i3 ^ 105) << 2) >> 2] ^ i1;
 HEAP32[gb + 1098896 + 128 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 132 >> 2] = gb + 900354;
 i1 = HEAP32[gb + 1111240 + ((i3 ^ 97) << 2) >> 2] ^ i1;
 HEAP32[gb + 1098896 + 136 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 120) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 140 >> 2] = gb + 900361;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 77) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 144 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 148 >> 2] = gb + 900368;
 i2 = HEAP32[gb + 1111240 + 712 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 120) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 77) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 152 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 120) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 156 >> 2] = gb + 900375;
 i2 = HEAP32[gb + 1111240 + 728 >> 2] ^ 16777215;
 HEAP32[gb + 1098896 + 160 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 164 >> 2] = gb + 900382;
 i2 = HEAP32[gb + 1111240 + 704 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 117) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 168 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 172 >> 2] = gb + 900385;
 i2 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 103) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i1 = i2 >>> 8;
 i2 = i2 & 255;
 HEAP32[gb + 1098896 + 176 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 65) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 180 >> 2] = gb + 900389;
 HEAP32[gb + 1098896 + 184 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 66) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 188 >> 2] = gb + 900396;
 HEAP32[gb + 1098896 + 192 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 67) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 196 >> 2] = gb + 900403;
 HEAP32[gb + 1098896 + 200 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 68) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 204 >> 2] = gb + 900410;
 HEAP32[gb + 1098896 + 208 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 69) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 212 >> 2] = gb + 900417;
 i1 = HEAP32[gb + 1111240 + 672 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 103) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 104) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i2 = i1 >>> 8;
 i1 = i1 & 255;
 HEAP32[gb + 1098896 + 216 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 65) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 220 >> 2] = gb + 900424;
 HEAP32[gb + 1098896 + 224 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 66) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 228 >> 2] = gb + 900432;
 HEAP32[gb + 1098896 + 232 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 67) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 236 >> 2] = gb + 900440;
 HEAP32[gb + 1098896 + 240 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 68) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 244 >> 2] = gb + 900448;
 HEAP32[gb + 1098896 + 248 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 69) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 252 >> 2] = gb + 900456;
 i2 = HEAP32[gb + 1111240 + 704 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 117) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i1 = i2 >>> 8;
 i2 = i2 & 255;
 HEAP32[gb + 1098896 + 256 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 65) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 260 >> 2] = gb + 900464;
 HEAP32[gb + 1098896 + 264 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 66) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 268 >> 2] = gb + 900469;
 HEAP32[gb + 1098896 + 272 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 67) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 276 >> 2] = gb + 900474;
 HEAP32[gb + 1098896 + 280 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 68) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 284 >> 2] = gb + 900479;
 HEAP32[gb + 1098896 + 288 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 69) << 2) >> 2] ^ i1);
 HEAP32[gb + 1098896 + 292 >> 2] = gb + 900484;
 i1 = HEAP32[gb + 1111240 + 708 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 117) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 296 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 109) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 300 >> 2] = gb + 900489;
 i1 = HEAP32[gb + 1111240 + 748 >> 2] ^ 16777215;
 i2 = i1 >>> 8;
 i1 = i1 & 255;
 i3 = HEAP32[gb + 1111240 + ((i1 ^ 101) << 2) >> 2] ^ i2;
 i4 = i3 >>> 8;
 i3 = i3 & 255;
 HEAP32[gb + 1098896 + 304 >> 2] = ~(HEAP32[gb + 1111240 + ((i3 ^ 110) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 308 >> 2] = gb + 900493;
 i5 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 312 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 109) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 316 >> 2] = gb + 900497;
 i2 = HEAP32[gb + 1111240 + ((i1 ^ 97) << 2) >> 2] ^ i2;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 109) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 112) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 84) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 109) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 320 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 324 >> 2] = gb + 900501;
 i4 = HEAP32[gb + 1111240 + ((i3 ^ 108) << 2) >> 2] ^ i4;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 84) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 109) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 328 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 332 >> 2] = gb + 900510;
 i4 = HEAP32[gb + 1111240 + 700 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 118) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 117) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 115) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 86) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 117) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 336 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 340 >> 2] = gb + 900520;
 i4 = HEAP32[gb + 1111240 + 736 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 118) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 121) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 87) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 344 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 348 >> 2] = gb + 900534;
 i4 = HEAP32[gb + 1111240 + 688 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 99) << 2) >> 2] ^ i4 >>> 8;
 i3 = i4 >>> 8;
 i4 = i4 & 255;
 i2 = HEAP32[gb + 1111240 + ((i4 ^ 82) << 2) >> 2] ^ i3;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 102) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 352 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 88) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 356 >> 2] = gb + 900548;
 i2 = HEAP32[gb + 1111240 + 748 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 115) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i1 = i2 >>> 8;
 i2 = i2 & 255;
 i5 = HEAP32[gb + 1111240 + ((i2 ^ 82) << 2) >> 2] ^ i1;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 102) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 360 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 88) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 364 >> 2] = gb + 900556;
 i3 = HEAP32[gb + 1111240 + ((i4 ^ 80) << 2) >> 2] ^ i3;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 105) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 118) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 111) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 116) << 2) >> 2] ^ i3 >>> 8;
 HEAP32[gb + 1098896 + 368 >> 2] = ~(HEAP32[gb + 1111240 + ((i3 & 255 ^ 88) << 2) >> 2] ^ i3 >>> 8);
 HEAP32[gb + 1098896 + 372 >> 2] = gb + 900564;
 i1 = HEAP32[gb + 1111240 + ((i2 ^ 80) << 2) >> 2] ^ i1;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 118) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 376 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 88) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 380 >> 2] = gb + 900574;
 i1 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 102) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 87) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 103) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 104) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 384 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 388 >> 2] = gb + 900584;
 i1 = HEAP32[gb + 1111240 + 700 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 118) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 87) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 103) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 104) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 392 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 396 >> 2] = gb + 900594;
 i1 = HEAP32[gb + 1111240 + 668 >> 2] ^ 16777215;
 i2 = i1 >>> 8;
 i1 = i1 & 255;
 HEAP32[gb + 1098896 + 400 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 73) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 404 >> 2] = gb + 900606;
 HEAP32[gb + 1098896 + 408 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 ^ 79) << 2) >> 2] ^ i2);
 HEAP32[gb + 1098896 + 412 >> 2] = gb + 900609;
 i2 = HEAP32[gb + 1111240 + 752 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 111) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 100) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 111) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 416 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 420 >> 2] = gb + 900612;
 i2 = HEAP32[gb + 1111240 + 688 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i1 = i2 >>> 8;
 i2 = i2 & 255;
 i3 = HEAP32[gb + 1111240 + ((i2 ^ 84) << 2) >> 2] ^ i1;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 105) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 109) << 2) >> 2] ^ i3 >>> 8;
 HEAP32[gb + 1098896 + 424 >> 2] = ~(HEAP32[gb + 1111240 + ((i3 & 255 ^ 101) << 2) >> 2] ^ i3 >>> 8);
 HEAP32[gb + 1098896 + 428 >> 2] = gb + 900622;
 i3 = HEAP32[gb + 1111240 + ((i2 ^ 83) << 2) >> 2] ^ i1;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 112) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 101) << 2) >> 2] ^ i3 >>> 8;
 i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 101) << 2) >> 2] ^ i3 >>> 8;
 HEAP32[gb + 1098896 + 432 >> 2] = ~(HEAP32[gb + 1111240 + ((i3 & 255 ^ 100) << 2) >> 2] ^ i3 >>> 8);
 HEAP32[gb + 1098896 + 436 >> 2] = gb + 900632;
 i1 = HEAP32[gb + 1111240 + ((i2 ^ 69) << 2) >> 2] ^ i1;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 120) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 84) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 109) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 440 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 444 >> 2] = gb + 900643;
 i1 = HEAP32[gb + 1111240 + 748 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 84) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 448 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 452 >> 2] = gb + 900657;
 i1 = HEAP32[gb + 1111240 + 708 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 120) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 83) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 83) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 84) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 109) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 456 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 460 >> 2] = gb + 900670;
 i1 = HEAP32[gb + 1111240 + 684 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 68) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 117) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 464 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 468 >> 2] = gb + 900689;
 i1 = HEAP32[gb + 1111240 + 684 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 79) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 102) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 102) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[gb + 1098896 + 472 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8);
 HEAP32[gb + 1098896 + 476 >> 2] = gb + 900708;
 i1 = gb + 900725 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 900725 + 19 | 0));
 HEAP32[gb + 1098896 + 480 >> 2] = ~i2;
 HEAP32[gb + 1098896 + 484 >> 2] = gb + 900725;
 i4 = HEAP32[gb + 1111240 + 688 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 77) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 99) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 87) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 488 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 492 >> 2] = gb + 900745;
 i4 = HEAP32[gb + 1111240 + 684 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 115) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 84) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 109) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 496 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 500 >> 2] = gb + 900764;
 i4 = HEAP32[gb + 1111240 + 756 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 100) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 87) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 504 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 508 >> 2] = gb + 900779;
 i4 = HEAP32[gb + 1111240 + 688 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 i2 = HEAP32[gb + 1111240 + ((i4 ^ 116) << 2) >> 2] ^ i5;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 87) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 103) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 104) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 512 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 516 >> 2] = gb + 900791;
 i5 = HEAP32[gb + 1111240 + ((i4 ^ 98) << 2) >> 2] ^ i5;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 108) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 122) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 520 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 524 >> 2] = gb + 900803;
 i5 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 528 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 88) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 532 >> 2] = gb + 900817;
 i5 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 102) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 46) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 87) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 103) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 104) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i4 = i5 >>> 8;
 i5 = i5 & 255;
 HEAP32[gb + 1098896 + 536 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 84) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 540 >> 2] = gb + 900823;
 HEAP32[gb + 1098896 + 544 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 82) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 548 >> 2] = gb + 900840;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 46) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 87) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 552 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 84) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 556 >> 2] = gb + 900857;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 46) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 87) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 560 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 82) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 564 >> 2] = gb + 900875;
 i4 = HEAP32[gb + 1111240 + 752 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 109) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 112) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 117) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 117) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 99) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 568 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 572 >> 2] = gb + 900893;
 i4 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 i2 = HEAP32[gb + 1111240 + ((i4 ^ 111) << 2) >> 2] ^ i5;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 111) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 107) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 65) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[gb + 1098896 + 576 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[gb + 1098896 + 580 >> 2] = gb + 900907;
 i5 = HEAP32[gb + 1111240 + ((i4 ^ 101) << 2) >> 2] ^ i5;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 102) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 584 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 88) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 588 >> 2] = gb + 900914;
 i5 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 103) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 104) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 592 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 88) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 596 >> 2] = gb + 900924;
 i5 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 102) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 83) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 112) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 100) << 2) >> 2] ^ i5 >>> 8;
 i4 = i5 >>> 8;
 i5 = i5 & 255;
 HEAP32[gb + 1098896 + 600 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 84) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 604 >> 2] = gb + 900935;
 HEAP32[gb + 1098896 + 608 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 81) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 612 >> 2] = gb + 900950;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 112) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 100) << 2) >> 2] ^ i4 >>> 8;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 HEAP32[gb + 1098896 + 616 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 84) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 620 >> 2] = gb + 900965;
 HEAP32[gb + 1098896 + 624 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 81) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 628 >> 2] = gb + 900981;
 i5 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 102) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 70) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 83) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 97) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 98) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 108) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i4 = i5 >>> 8;
 i5 = i5 & 255;
 HEAP32[gb + 1098896 + 632 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 84) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 636 >> 2] = gb + 900997;
 HEAP32[gb + 1098896 + 640 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 81) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 644 >> 2] = gb + 901013;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 98) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 HEAP32[gb + 1098896 + 648 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 84) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 652 >> 2] = gb + 901029;
 HEAP32[gb + 1098896 + 656 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 81) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 660 >> 2] = gb + 901046;
 i5 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 83) << 2) >> 2] ^ i5 >>> 8;
 i4 = i5 >>> 8;
 i5 = i5 & 255;
 i2 = HEAP32[gb + 1111240 + ((i5 ^ 112) << 2) >> 2] ^ i4;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 100) << 2) >> 2] ^ i2 >>> 8;
 i3 = i2 >>> 8;
 i2 = i2 & 255;
 HEAP32[gb + 1098896 + 664 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 84) << 2) >> 2] ^ i3);
 HEAP32[gb + 1098896 + 668 >> 2] = gb + 901063;
 HEAP32[gb + 1098896 + 672 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 ^ 81) << 2) >> 2] ^ i3);
 HEAP32[gb + 1098896 + 676 >> 2] = gb + 901074;
 i4 = HEAP32[gb + 1111240 + ((i5 ^ 116) << 2) >> 2] ^ i4;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 98) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 680 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 84) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 684 >> 2] = gb + 901085;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 98) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 688 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 81) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 692 >> 2] = gb + 901097;
 i4 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 102) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 80) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 106) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 696 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 88) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 700 >> 2] = gb + 901109;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 80) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 114) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 106) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 704 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 88) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 708 >> 2] = gb + 901123;
 i4 = HEAP32[gb + 1111240 + 700 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 712 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 716 >> 2] = gb + 901138;
 i4 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 102) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 102) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 720 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 88) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 724 >> 2] = gb + 901148;
 i4 = HEAP32[gb + 1111240 + 692 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 103) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 104) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 70) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 83) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 102) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 HEAP32[gb + 1098896 + 728 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 & 255 ^ 88) << 2) >> 2] ^ i4 >>> 8);
 HEAP32[gb + 1098896 + 732 >> 2] = gb + 901162;
 i4 = HEAP32[gb + 1111240 + 700 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 115) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 116) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 105) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 111) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 110) << 2) >> 2] ^ i4 >>> 8;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 HEAP32[gb + 1098896 + 736 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 88) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 740 >> 2] = gb + 901177;
 HEAP32[gb + 1098896 + 744 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 89) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 748 >> 2] = gb + 901187;
 HEAP32[gb + 1098896 + 752 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 90) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 756 >> 2] = gb + 901197;
 i5 = HEAP32[gb + 1111240 + 696 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 117) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 97) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 116) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 114) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 110) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 111) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 110) << 2) >> 2] ^ i5 >>> 8;
 i4 = i5 >>> 8;
 i5 = i5 & 255;
 HEAP32[gb + 1098896 + 760 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 88) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 764 >> 2] = gb + 901207;
 HEAP32[gb + 1098896 + 768 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 89) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 772 >> 2] = gb + 901219;
 HEAP32[gb + 1098896 + 776 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 90) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 780 >> 2] = gb + 901231;
 HEAP32[gb + 1098896 + 784 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 ^ 87) << 2) >> 2] ^ i4);
 HEAP32[gb + 1098896 + 788 >> 2] = gb + 901243;
 i4 = HEAP32[gb + 1111240 + 688 >> 2] ^ 16777215;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 99) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 97) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 108) << 2) >> 2] ^ i4 >>> 8;
 i4 = HEAP32[gb + 1111240 + ((i4 & 255 ^ 101) << 2) >> 2] ^ i4 >>> 8;
 i5 = i4 >>> 8;
 i4 = i4 & 255;
 HEAP32[gb + 1098896 + 792 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 88) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 796 >> 2] = gb + 901255;
 HEAP32[gb + 1098896 + 800 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 89) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 804 >> 2] = gb + 901262;
 HEAP32[gb + 1098896 + 808 >> 2] = ~(HEAP32[gb + 1111240 + ((i4 ^ 90) << 2) >> 2] ^ i5);
 HEAP32[gb + 1098896 + 812 >> 2] = gb + 901269;
 i5 = HEAP32[gb + 1111240 + 748 >> 2] ^ 16777215;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 121) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 110) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 97) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 109) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 105) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 99) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 67) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 117) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 114) << 2) >> 2] ^ i5 >>> 8;
 i5 = HEAP32[gb + 1111240 + ((i5 & 255 ^ 118) << 2) >> 2] ^ i5 >>> 8;
 HEAP32[gb + 1098896 + 816 >> 2] = ~(HEAP32[gb + 1111240 + ((i5 & 255 ^ 101) << 2) >> 2] ^ i5 >>> 8);
 HEAP32[gb + 1098896 + 820 >> 2] = gb + 901276;
 return;
}

function __ZN15SkyboxGenerator18GetCubemapSkyboxVBEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i41 + 8 | 0;
 i39 = i41;
 i40 = i41 + 36 | 0;
 i38 = i41 + 16 | 0;
 i1 = HEAP32[gb + 1114348 >> 2] | 0;
 do if (i1 | 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
   i36 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 236 >> 2] | 0, i36 | 0, HEAP32[gb + 1114348 >> 2] | 0);
   HEAP32[gb + 1114348 >> 2] = 0;
   break;
  }
  i1 = HEAP32[gb + 1114348 >> 2] | 0;
  if (i1 | 0) {
   i40 = i1;
   STACKTOP = i41;
   return i40 | 0;
  }
 } while (0);
 i33 = __Z12GetGfxDevicev() | 0;
 i36 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 220 >> 2] | 0, i33 | 0) | 0;
 HEAP32[gb + 1114348 >> 2] = i36;
 i36 = gb + 64016 | 0;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 i34 = i39;
 HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 HEAP32[i40 >> 2] = 0;
 i34 = i40 + 12 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i40 + 16 | 0;
 HEAP32[i35 >> 2] = 0;
 i36 = i40 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, i39);
 i31 = i37;
 i32 = HEAP32[i31 + 4 >> 2] | 0;
 i1 = i36;
 HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i1 + 4 >> 2] = i32;
 HEAP32[i34 >> 2] = 24;
 i1 = HEAP32[i35 >> 2] | 0;
 do if ((i1 & 2147483640) >>> 0 < 24) if ((i1 | 0) > -1) {
  HEAP32[i35 >> 2] = 24;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, 672, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i40 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(672, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
  HEAP32[i35 >> 2] = 24;
  HEAP32[i40 >> 2] = i2;
  break;
 } else i2 = HEAP32[i40 >> 2] | 0; while (0);
 i1 = 0;
 do {
  i32 = gb + 35992 + (i1 * 3 << 2) | 0;
  f20 = Math_fround(HEAPF32[i32 >> 2]);
  f21 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i32 + 8 >> 2]);
  f22 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f14 * f14))));
  f20 = Math_fround(f20 / f22);
  f21 = Math_fround(f21 / f22);
  f22 = Math_fround(f14 / f22);
  HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f20;
  HEAPF32[i2 + (i1 * 28 | 0) >> 2] = f20;
  HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f21;
  HEAPF32[i2 + (i1 * 28 | 0) + 4 >> 2] = f21;
  HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f22;
  HEAPF32[i2 + (i1 * 28 | 0) + 8 >> 2] = f22;
  HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i19 = i38 + 12 | 0;
 i23 = i38 + 16 | 0;
 i24 = i38 + 4 | 0;
 i25 = i38 + 8 | 0;
 i32 = i40 + 8 | 0;
 i18 = 0;
 do {
  i1 = gb + 64016 | 0;
  i31 = HEAP32[i1 + 4 >> 2] | 0;
  i30 = i39;
  HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i23 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, i39);
  i30 = i37;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i1 = i24;
  HEAP32[i1 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i1 + 4 >> 2] = i31;
  i1 = HEAP32[i38 >> 2] | 0;
  if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i24, HEAP32[i32 >> 2] | 0);
  i1 = HEAP32[i40 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i36, HEAP32[i25 >> 2] | 0);
   i1 = HEAP32[i40 >> 2] | 0;
  }
  i2 = HEAP32[i38 >> 2] | 0;
  HEAP32[i38 >> 2] = i1;
  HEAP32[i40 >> 2] = i2;
  i31 = HEAP32[i19 >> 2] | 0;
  i17 = HEAP32[i34 >> 2] | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i34 >> 2] = i31;
  i31 = HEAP32[i23 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i35 >> 2] = i31;
  i29 = i24;
  i28 = HEAP32[i29 >> 2] | 0;
  i29 = HEAP32[i29 + 4 >> 2] | 0;
  i26 = i36;
  i27 = HEAP32[i26 + 4 >> 2] | 0;
  i30 = i24;
  HEAP32[i30 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i30 + 4 >> 2] = i27;
  i30 = i36;
  HEAP32[i30 >> 2] = i28;
  HEAP32[i30 + 4 >> 2] = i29;
  if ((i31 | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i36);
   HEAP32[i40 >> 2] = 0;
  }
  HEAP32[i40 >> 2] = 0;
  HEAP32[i34 >> 2] = 0;
  HEAP32[i35 >> 2] = 0;
  if (i17 | 0) {
   HEAP32[i35 >> 2] = i17 << 2;
   HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i17 * 112 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
   if ((i17 | 0) > 0) {
    i16 = 0;
    do {
     i10 = HEAP32[i38 >> 2] | 0;
     i4 = i10 + (i16 * 28 | 0) | 0;
     i2 = i16 + 1 | 0;
     i13 = i10 + (i2 * 28 | 0) | 0;
     i5 = i16 + 2 | 0;
     i15 = i10 + (i5 * 28 | 0) | 0;
     f44 = Math_fround(HEAPF32[i4 >> 2]);
     f43 = Math_fround(HEAPF32[i10 + (i16 * 28 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i10 + (i16 * 28 | 0) + 8 >> 2]);
     f20 = Math_fround(HEAPF32[i13 >> 2]);
     f21 = Math_fround(HEAPF32[i10 + (i2 * 28 | 0) + 4 >> 2]);
     f20 = Math_fround(f20 * Math_fround(.5));
     f21 = Math_fround(f21 * Math_fround(.5));
     f45 = Math_fround(Math_fround(HEAPF32[i10 + (i2 * 28 | 0) + 8 >> 2]) * Math_fround(.5));
     f44 = Math_fround(f44 * Math_fround(.5));
     f43 = Math_fround(f43 * Math_fround(.5));
     f14 = Math_fround(f14 * Math_fround(.5));
     f7 = Math_fround(f44 + f20);
     f8 = Math_fround(f43 + f21);
     f11 = Math_fround(f14 + f45);
     f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f11 * f11))));
     f7 = Math_fround(f7 / f9);
     f8 = Math_fround(f8 / f9);
     f9 = Math_fround(f11 / f9);
     f11 = Math_fround(HEAPF32[i15 >> 2]);
     f12 = Math_fround(HEAPF32[i10 + (i5 * 28 | 0) + 4 >> 2]);
     f11 = Math_fround(f11 * Math_fround(.5));
     f12 = Math_fround(f12 * Math_fround(.5));
     f42 = Math_fround(Math_fround(HEAPF32[i10 + (i5 * 28 | 0) + 8 >> 2]) * Math_fround(.5));
     f20 = Math_fround(f20 + f11);
     f21 = Math_fround(f21 + f12);
     f45 = Math_fround(f45 + f42);
     f22 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f45 * f45))));
     f20 = Math_fround(f20 / f22);
     f21 = Math_fround(f21 / f22);
     f22 = Math_fround(f45 / f22);
     f11 = Math_fround(f44 + f11);
     f12 = Math_fround(f43 + f12);
     f42 = Math_fround(f14 + f42);
     f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f42 * f42))));
     f11 = Math_fround(f11 / f14);
     f12 = Math_fround(f12 / f14);
     f14 = Math_fround(f42 / f14);
     i5 = HEAP32[i34 >> 2] | 0;
     i10 = i5 + 1 | 0;
     i2 = HEAP32[i35 >> 2] | 0;
     i3 = i2 & 2147483647;
     do if (i10 >>> 0 > i3 >>> 0) {
      i1 = i2 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       i6 = HEAP32[i35 >> 2] | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i6;
       i6 = i1;
       break;
      } else i6 = i2;
     } else i6 = i2; while (0);
     HEAP32[i34 >> 2] = i10;
     i1 = HEAP32[i40 >> 2] | 0;
     i3 = i1 + (i5 * 28 | 0) | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
     i4 = i5 + 2 | 0;
     i3 = i6 & 2147483647;
     do if (i4 >>> 0 > i3 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i3 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i35 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i40 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i2;
       HEAP32[i40 >> 2] = i1;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i4;
     HEAPF32[i1 + (i10 * 28 | 0) >> 2] = f7;
     HEAPF32[i1 + (i10 * 28 | 0) + 4 >> 2] = f8;
     HEAPF32[i1 + (i10 * 28 | 0) + 8 >> 2] = f9;
     HEAP32[i1 + (i10 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i1 + (i10 * 28 | 0) + 16 >> 2] = f7;
     HEAPF32[i1 + (i10 * 28 | 0) + 20 >> 2] = f8;
     HEAPF32[i1 + (i10 * 28 | 0) + 24 >> 2] = f9;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i3 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i3 + (i2 * 28 | 0) >> 2] = f11;
     HEAPF32[i3 + (i2 * 28 | 0) + 4 >> 2] = f12;
     HEAPF32[i3 + (i2 * 28 | 0) + 8 >> 2] = f14;
     HEAP32[i3 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i3 + (i2 * 28 | 0) + 16 >> 2] = f11;
     HEAPF32[i3 + (i2 * 28 | 0) + 20 >> 2] = f12;
     HEAPF32[i3 + (i2 * 28 | 0) + 24 >> 2] = f14;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i4 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i4 + (i2 * 28 | 0) >> 2] = f7;
     HEAPF32[i4 + (i2 * 28 | 0) + 4 >> 2] = f8;
     HEAPF32[i4 + (i2 * 28 | 0) + 8 >> 2] = f9;
     HEAP32[i4 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i4 + (i2 * 28 | 0) + 16 >> 2] = f7;
     HEAPF32[i4 + (i2 * 28 | 0) + 20 >> 2] = f8;
     HEAPF32[i4 + (i2 * 28 | 0) + 24 >> 2] = f9;
     i4 = HEAP32[i34 >> 2] | 0;
     i6 = i4 + 1 | 0;
     i2 = HEAP32[i35 >> 2] | 0;
     i3 = i2 & 2147483647;
     do if (i6 >>> 0 > i3 >>> 0) {
      i1 = i2 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       i5 = HEAP32[i35 >> 2] | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i5;
       i5 = i1;
       break;
      } else i5 = i2;
     } else i5 = i2; while (0);
     HEAP32[i34 >> 2] = i6;
     i1 = HEAP32[i40 >> 2] | 0;
     i3 = i1 + (i4 * 28 | 0) | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
     i4 = i4 + 2 | 0;
     i3 = i5 & 2147483647;
     do if (i4 >>> 0 > i3 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i3 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i35 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i40 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i2;
       HEAP32[i40 >> 2] = i1;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i4;
     HEAPF32[i1 + (i6 * 28 | 0) >> 2] = f20;
     HEAPF32[i1 + (i6 * 28 | 0) + 4 >> 2] = f21;
     HEAPF32[i1 + (i6 * 28 | 0) + 8 >> 2] = f22;
     HEAP32[i1 + (i6 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i1 + (i6 * 28 | 0) + 16 >> 2] = f20;
     HEAPF32[i1 + (i6 * 28 | 0) + 20 >> 2] = f21;
     HEAPF32[i1 + (i6 * 28 | 0) + 24 >> 2] = f22;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i3 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i3 + (i2 * 28 | 0) >> 2] = f20;
     HEAPF32[i3 + (i2 * 28 | 0) + 4 >> 2] = f21;
     HEAPF32[i3 + (i2 * 28 | 0) + 8 >> 2] = f22;
     HEAP32[i3 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i3 + (i2 * 28 | 0) + 16 >> 2] = f20;
     HEAPF32[i3 + (i2 * 28 | 0) + 20 >> 2] = f21;
     HEAPF32[i3 + (i2 * 28 | 0) + 24 >> 2] = f22;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i3 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i3 + (i2 * 28 | 0) >> 2] = f11;
     HEAPF32[i3 + (i2 * 28 | 0) + 4 >> 2] = f12;
     HEAPF32[i3 + (i2 * 28 | 0) + 8 >> 2] = f14;
     HEAP32[i3 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i3 + (i2 * 28 | 0) + 16 >> 2] = f11;
     HEAPF32[i3 + (i2 * 28 | 0) + 20 >> 2] = f12;
     HEAPF32[i3 + (i2 * 28 | 0) + 24 >> 2] = f14;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 >= i1 >>> 0) break;
      if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i4 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i4 + (i2 * 28 | 0) >> 2] = f7;
     HEAPF32[i4 + (i2 * 28 | 0) + 4 >> 2] = f8;
     HEAPF32[i4 + (i2 * 28 | 0) + 8 >> 2] = f9;
     HEAP32[i4 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i4 + (i2 * 28 | 0) + 16 >> 2] = f7;
     HEAPF32[i4 + (i2 * 28 | 0) + 20 >> 2] = f8;
     HEAPF32[i4 + (i2 * 28 | 0) + 24 >> 2] = f9;
     i4 = HEAP32[i34 >> 2] | 0;
     i6 = i4 + 1 | 0;
     i2 = HEAP32[i35 >> 2] | 0;
     i3 = i2 & 2147483647;
     do if (i6 >>> 0 > i3 >>> 0) {
      i1 = i2 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i3 >>> 0 >= i1 >>> 0) {
       i5 = i2;
       break;
      }
      if ((i2 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       i5 = HEAP32[i35 >> 2] | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i5;
       i5 = i1;
       break;
      }
     } else i5 = i2; while (0);
     HEAP32[i34 >> 2] = i6;
     i1 = HEAP32[i40 >> 2] | 0;
     i3 = i1 + (i4 * 28 | 0) | 0;
     HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
     i4 = i4 + 2 | 0;
     i3 = i5 & 2147483647;
     do if (i4 >>> 0 > i3 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i3 >>> 0 >= i2 >>> 0) break;
      if ((i5 | 0) > -1) {
       HEAP32[i35 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i40 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i2;
       HEAP32[i40 >> 2] = i1;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i4;
     HEAPF32[i1 + (i6 * 28 | 0) >> 2] = f11;
     HEAPF32[i1 + (i6 * 28 | 0) + 4 >> 2] = f12;
     HEAPF32[i1 + (i6 * 28 | 0) + 8 >> 2] = f14;
     HEAP32[i1 + (i6 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i1 + (i6 * 28 | 0) + 16 >> 2] = f11;
     HEAPF32[i1 + (i6 * 28 | 0) + 20 >> 2] = f12;
     HEAPF32[i1 + (i6 * 28 | 0) + 24 >> 2] = f14;
     i2 = HEAP32[i34 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i35 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 >= i1 >>> 0) break;
      if ((i4 | 0) > -1) {
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i31 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
       HEAP32[i35 >> 2] = i1;
       HEAP32[i40 >> 2] = i31;
       break;
      }
     } while (0);
     HEAP32[i34 >> 2] = i3;
     i31 = HEAP32[i40 >> 2] | 0;
     HEAPF32[i31 + (i2 * 28 | 0) >> 2] = f20;
     HEAPF32[i31 + (i2 * 28 | 0) + 4 >> 2] = f21;
     HEAPF32[i31 + (i2 * 28 | 0) + 8 >> 2] = f22;
     HEAP32[i31 + (i2 * 28 | 0) + 12 >> 2] = -1;
     HEAPF32[i31 + (i2 * 28 | 0) + 16 >> 2] = f20;
     HEAPF32[i31 + (i2 * 28 | 0) + 20 >> 2] = f21;
     HEAPF32[i31 + (i2 * 28 | 0) + 24 >> 2] = f22;
     i16 = i16 + 3 | 0;
    } while ((i16 | 0) < (i17 | 0));
   }
  }
  if ((HEAP32[i23 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i24);
   HEAP32[i38 >> 2] = 0;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != 3);
 i28 = i38 + 12 | 0;
 i29 = i38 + 16 | 0;
 i30 = i38 + 4 | 0;
 i31 = i38 + 8 | 0;
 i27 = 0;
 do {
  i1 = gb + 64016 | 0;
  i26 = HEAP32[i1 + 4 >> 2] | 0;
  i25 = i39;
  HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i25 + 4 >> 2] = i26;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i29 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, i39);
  i25 = i37;
  i26 = HEAP32[i25 + 4 >> 2] | 0;
  i1 = i30;
  HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i1 + 4 >> 2] = i26;
  i1 = HEAP32[i38 >> 2] | 0;
  if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i30, HEAP32[i32 >> 2] | 0);
  i1 = HEAP32[i40 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i36, HEAP32[i31 >> 2] | 0);
   i1 = HEAP32[i40 >> 2] | 0;
  }
  i2 = HEAP32[i38 >> 2] | 0;
  HEAP32[i38 >> 2] = i1;
  HEAP32[i40 >> 2] = i2;
  i25 = HEAP32[i28 >> 2] | 0;
  i26 = HEAP32[i34 >> 2] | 0;
  HEAP32[i28 >> 2] = i26;
  HEAP32[i34 >> 2] = i25;
  i25 = HEAP32[i29 >> 2] | 0;
  HEAP32[i29 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i35 >> 2] = i25;
  i23 = i30;
  i19 = HEAP32[i23 >> 2] | 0;
  i23 = HEAP32[i23 + 4 >> 2] | 0;
  i17 = i36;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i24 = i30;
  HEAP32[i24 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i24 + 4 >> 2] = i18;
  i24 = i36;
  HEAP32[i24 >> 2] = i19;
  HEAP32[i24 + 4 >> 2] = i23;
  f20 = Math_fround(+Math_pow(.5, +Math_fround(Math_fround(i27 | 0) + Math_fround(1.0))));
  if ((i25 | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i36);
   HEAP32[i40 >> 2] = 0;
  }
  HEAP32[i40 >> 2] = 0;
  HEAP32[i34 >> 2] = 0;
  HEAP32[i35 >> 2] = 0;
  if (i26 | 0) {
   HEAP32[i35 >> 2] = i26 << 2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i26 * 112 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i40 >> 2] = i1;
   if ((i26 | 0) > 0) {
    i25 = 0;
    i2 = i1;
    i19 = i1;
    while (1) {
     i24 = HEAP32[i38 >> 2] | 0;
     i10 = i24 + (i25 * 28 | 0) | 0;
     f11 = Math_fround(HEAPF32[i24 + (i25 * 28 | 0) + 4 >> 2]);
     i6 = f11 < Math_fround(0.0);
     f45 = Math_fround(-f11);
     f45 = i6 ? f45 : f11;
     i6 = i25 + 1 | 0;
     i3 = i24 + (i6 * 28 | 0) | 0;
     f14 = Math_fround(HEAPF32[i24 + (i6 * 28 | 0) + 4 >> 2]);
     i17 = f14 < Math_fround(0.0);
     f43 = Math_fround(-f14);
     f43 = i17 ? f43 : f14;
     i17 = i25 + 2 | 0;
     i4 = i24 + (i17 * 28 | 0) | 0;
     f12 = Math_fround(HEAPF32[i24 + (i17 * 28 | 0) + 4 >> 2]);
     i24 = f12 < Math_fround(0.0);
     f44 = Math_fround(-f12);
     f44 = i24 ? f44 : f12;
     f45 = f45 < f43 ? f43 : f45;
     do if ((f45 < f44 ? f44 : f45) > f20) {
      i16 = HEAP32[i34 >> 2] | 0;
      i15 = i16 + 1 | 0;
      i5 = HEAP32[i35 >> 2] | 0;
      i3 = i5 & 2147483647;
      do if (i15 >>> 0 > i3 >>> 0) {
       i4 = i5 << 1;
       i4 = (i4 | 0) == 0 ? 1 : i4;
       if (i3 >>> 0 < i4 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i35 >> 2] = i4;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i4 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i40 >> 2] = i2;
        i1 = i2;
        i4 = HEAP32[i35 >> 2] | 0;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i4;
        HEAP32[i40 >> 2] = i2;
        i1 = i2;
        break;
       } else i4 = i5;
      } else i4 = i5; while (0);
      HEAP32[i34 >> 2] = i15;
      i13 = i1 + (i16 * 28 | 0) | 0;
      HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
      HEAP32[i13 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
      HEAP32[i13 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
      HEAP32[i13 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
      i6 = (HEAP32[i38 >> 2] | 0) + (i6 * 28 | 0) | 0;
      i13 = i16 + 2 | 0;
      i3 = i4 & 2147483647;
      do if (i13 >>> 0 > i3 >>> 0) {
       i5 = i4 << 1;
       i5 = (i5 | 0) == 0 ? 1 : i5;
       if (i3 >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i35 >> 2] = i5;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i40 >> 2] = i2;
        i1 = i2;
        i10 = HEAP32[i35 >> 2] | 0;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i5;
        HEAP32[i40 >> 2] = i2;
        i1 = i2;
        i10 = i5;
        break;
       } else i10 = i4;
      } else i10 = i4; while (0);
      HEAP32[i34 >> 2] = i13;
      i5 = i1 + (i15 * 28 | 0) | 0;
      HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
      HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
      HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
      HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
      HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
      HEAP32[i5 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
      i6 = (HEAP32[i38 >> 2] | 0) + (i17 * 28 | 0) | 0;
      i5 = i16 + 3 | 0;
      i4 = i10 & 2147483647;
      do if (i5 >>> 0 > i4 >>> 0) {
       i3 = i10 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i4 >>> 0 < i3 >>> 0) if ((i10 | 0) > -1) {
        HEAP32[i35 >> 2] = i3;
        i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i40 >> 2] = i1;
        break;
       } else {
        i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i3;
        HEAP32[i40 >> 2] = i1;
        break;
       }
      } while (0);
      HEAP32[i34 >> 2] = i5;
      i3 = i1 + (i13 * 28 | 0) | 0;
      HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
      HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
      HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
      i3 = i1;
      i2 = i1;
     } else {
      f7 = Math_fround(f14 - f11);
      i24 = f7 < Math_fround(0.0);
      f8 = Math_fround(-f7);
      f7 = i24 ? f8 : f7;
      f8 = Math_fround(f14 - f12);
      i24 = f8 < Math_fround(0.0);
      f9 = Math_fround(-f8);
      f8 = i24 ? f9 : f8;
      f9 = Math_fround(f12 - f11);
      i24 = f9 < Math_fround(0.0);
      f45 = Math_fround(-f9);
      f9 = i24 ? f45 : f9;
      if (f7 < f8 & f7 < f9) {
       i24 = i3;
       i23 = i10;
       f8 = f11;
       f7 = f12;
       f9 = f14;
      } else {
       i18 = f8 < f7 & f8 < f9;
       i17 = i18 ? i10 : i3;
       i23 = i18 ? i3 : i4;
       i18 = i18 ? i4 : i10;
       f7 = Math_fround(HEAPF32[i17 + 4 >> 2]);
       f8 = Math_fround(HEAPF32[i23 + 4 >> 2]);
       i24 = i18;
       i4 = i17;
       f9 = Math_fround(HEAPF32[i18 + 4 >> 2]);
      }
      f14 = Math_fround(HEAPF32[i4 >> 2]);
      f45 = Math_fround(HEAPF32[i4 + 8 >> 2]);
      f44 = Math_fround(HEAPF32[i23 >> 2]);
      i17 = i23 + 4 | 0;
      i18 = i23 + 8 | 0;
      f14 = Math_fround(f14 * Math_fround(.5));
      f12 = Math_fround(f7 * Math_fround(.5));
      f45 = Math_fround(f45 * Math_fround(.5));
      f7 = Math_fround(f14 + Math_fround(f44 * Math_fround(.5)));
      f8 = Math_fround(Math_fround(f8 * Math_fround(.5)) + f12);
      f44 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.5)));
      f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f44 * f44))));
      f7 = Math_fround(f7 / f11);
      f8 = Math_fround(f8 / f11);
      f11 = Math_fround(f44 / f11);
      f44 = Math_fround(HEAPF32[i24 >> 2]);
      i15 = i24 + 4 | 0;
      i16 = i24 + 8 | 0;
      f44 = Math_fround(f14 + Math_fround(f44 * Math_fround(.5)));
      f12 = Math_fround(Math_fround(f9 * Math_fround(.5)) + f12);
      f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * Math_fround(.5)));
      f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f44 * f44)) + Math_fround(f45 * f45))));
      f9 = Math_fround(f44 / f14);
      f12 = Math_fround(f12 / f14);
      f14 = Math_fround(f45 / f14);
      i10 = HEAP32[i34 >> 2] | 0;
      i13 = i10 + 1 | 0;
      i5 = HEAP32[i35 >> 2] | 0;
      i2 = i5 & 2147483647;
      do if (i13 >>> 0 > i2 >>> 0) {
       i3 = i5 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i2 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i35 >> 2] = i3;
        i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i19, i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i40 >> 2] = i6;
        i1 = i6;
        i5 = HEAP32[i35 >> 2] | 0;
        break;
       } else {
        i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i6 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i3;
        HEAP32[i40 >> 2] = i6;
        i1 = i6;
        i5 = i3;
        break;
       } else i6 = i19;
      } else i6 = i19; while (0);
      HEAP32[i34 >> 2] = i13;
      i3 = i1 + (i10 * 28 | 0) | 0;
      HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
      HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
      HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
      i4 = i10 + 2 | 0;
      i3 = i5 & 2147483647;
      do if (i4 >>> 0 > i3 >>> 0) {
       i2 = i5 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i3 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i35 >> 2] = i2;
        i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i40 >> 2] = i1;
        break;
       } else {
        i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i2;
        HEAP32[i40 >> 2] = i1;
        break;
       }
      } while (0);
      HEAP32[i34 >> 2] = i4;
      HEAPF32[i1 + (i13 * 28 | 0) >> 2] = f7;
      HEAPF32[i1 + (i13 * 28 | 0) + 4 >> 2] = f8;
      HEAPF32[i1 + (i13 * 28 | 0) + 8 >> 2] = f11;
      HEAP32[i1 + (i13 * 28 | 0) + 12 >> 2] = -1;
      HEAPF32[i1 + (i13 * 28 | 0) + 16 >> 2] = f7;
      HEAPF32[i1 + (i13 * 28 | 0) + 20 >> 2] = f8;
      HEAPF32[i1 + (i13 * 28 | 0) + 24 >> 2] = f11;
      i2 = HEAP32[i34 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i35 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i35 >> 2] = i1;
        HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i19 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
        HEAP32[i35 >> 2] = i1;
        HEAP32[i40 >> 2] = i19;
        break;
       }
      } while (0);
      HEAP32[i34 >> 2] = i3;
      i19 = HEAP32[i40 >> 2] | 0;
      HEAPF32[i19 + (i2 * 28 | 0) >> 2] = f9;
      HEAPF32[i19 + (i2 * 28 | 0) + 4 >> 2] = f12;
      HEAPF32[i19 + (i2 * 28 | 0) + 8 >> 2] = f14;
      HEAP32[i19 + (i2 * 28 | 0) + 12 >> 2] = -1;
      HEAPF32[i19 + (i2 * 28 | 0) + 16 >> 2] = f9;
      HEAPF32[i19 + (i2 * 28 | 0) + 20 >> 2] = f12;
      HEAPF32[i19 + (i2 * 28 | 0) + 24 >> 2] = f14;
      f21 = Math_fround(f9 - Math_fround(HEAPF32[i23 >> 2]));
      f22 = Math_fround(f12 - Math_fround(HEAPF32[i17 >> 2]));
      f42 = Math_fround(f14 - Math_fround(HEAPF32[i18 >> 2]));
      f43 = Math_fround(f7 - Math_fround(HEAPF32[i24 >> 2]));
      f44 = Math_fround(f8 - Math_fround(HEAPF32[i15 >> 2]));
      f45 = Math_fround(f11 - Math_fround(HEAPF32[i16 >> 2]));
      i19 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f42 * f42)) > Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f44 * f44)) + Math_fround(f45 * f45));
      i2 = HEAP32[i34 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i35 >> 2] | 0;
      i5 = i4 & 2147483647;
      i1 = i3 >>> 0 > i5 >>> 0;
      if (i19) {
       do if (i1) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i19 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i19;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i3;
       i5 = HEAP32[i40 >> 2] | 0;
       HEAPF32[i5 + (i2 * 28 | 0) >> 2] = f7;
       HEAPF32[i5 + (i2 * 28 | 0) + 4 >> 2] = f8;
       HEAPF32[i5 + (i2 * 28 | 0) + 8 >> 2] = f11;
       HEAP32[i5 + (i2 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i5 + (i2 * 28 | 0) + 16 >> 2] = f7;
       HEAPF32[i5 + (i2 * 28 | 0) + 20 >> 2] = f8;
       HEAPF32[i5 + (i2 * 28 | 0) + 24 >> 2] = f11;
       i5 = HEAP32[i34 >> 2] | 0;
       i10 = i5 + 1 | 0;
       i2 = HEAP32[i35 >> 2] | 0;
       i3 = i2 & 2147483647;
       do if (i10 >>> 0 > i3 >>> 0) {
        i1 = i2 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i3 >>> 0 >= i1 >>> 0) break;
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         i2 = HEAP32[i35 >> 2] | 0;
         break;
        } else {
         i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i2;
         i2 = i1;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i10;
       i4 = HEAP32[i40 >> 2] | 0;
       i13 = i4 + (i5 * 28 | 0) | 0;
       HEAP32[i13 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i13 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
       HEAP32[i13 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
       HEAP32[i13 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
       HEAP32[i13 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
       HEAP32[i13 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
       HEAP32[i13 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
       i13 = i5 + 2 | 0;
       i1 = i2 & 2147483647;
       do if (i13 >>> 0 > i1 >>> 0) {
        i3 = i2 << 1;
        i3 = (i3 | 0) == 0 ? 1 : i3;
        if (i1 >>> 0 >= i3 >>> 0) {
         i1 = i4;
         i6 = i4;
         break;
        }
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i3;
         i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         HEAP32[i40 >> 2] = i6;
         i1 = i6;
         i2 = HEAP32[i35 >> 2] | 0;
         break;
        } else {
         i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i6 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i3;
         HEAP32[i40 >> 2] = i6;
         i1 = i6;
         i2 = i3;
         break;
        }
       } else {
        i1 = i4;
        i6 = i4;
       } while (0);
       HEAP32[i34 >> 2] = i13;
       i4 = i1 + (i10 * 28 | 0) | 0;
       HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
       HEAP32[i4 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
       HEAP32[i4 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
       HEAP32[i4 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
       i5 = i5 + 3 | 0;
       i4 = i2 & 2147483647;
       do if (i5 >>> 0 > i4 >>> 0) {
        i3 = i2 << 1;
        i3 = (i3 | 0) == 0 ? 1 : i3;
        if (i4 >>> 0 >= i3 >>> 0) break;
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i3;
         i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         HEAP32[i40 >> 2] = i1;
         break;
        } else {
         i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i3;
         HEAP32[i40 >> 2] = i1;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i5;
       HEAPF32[i1 + (i13 * 28 | 0) >> 2] = f9;
       HEAPF32[i1 + (i13 * 28 | 0) + 4 >> 2] = f12;
       HEAPF32[i1 + (i13 * 28 | 0) + 8 >> 2] = f14;
       HEAP32[i1 + (i13 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i1 + (i13 * 28 | 0) + 16 >> 2] = f9;
       HEAPF32[i1 + (i13 * 28 | 0) + 20 >> 2] = f12;
       HEAPF32[i1 + (i13 * 28 | 0) + 24 >> 2] = f14;
       i2 = HEAP32[i34 >> 2] | 0;
       i3 = i2 + 1 | 0;
       i4 = HEAP32[i35 >> 2] | 0;
       i5 = i4 & 2147483647;
       do if (i3 >>> 0 > i5 >>> 0) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i23 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i23;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i3;
       i3 = HEAP32[i40 >> 2] | 0;
       HEAPF32[i3 + (i2 * 28 | 0) >> 2] = f7;
       HEAPF32[i3 + (i2 * 28 | 0) + 4 >> 2] = f8;
       HEAPF32[i3 + (i2 * 28 | 0) + 8 >> 2] = f11;
       HEAP32[i3 + (i2 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i3 + (i2 * 28 | 0) + 16 >> 2] = f7;
       HEAPF32[i3 + (i2 * 28 | 0) + 20 >> 2] = f8;
       HEAPF32[i3 + (i2 * 28 | 0) + 24 >> 2] = f11;
       i2 = HEAP32[i34 >> 2] | 0;
       i3 = i2 + 1 | 0;
       i4 = HEAP32[i35 >> 2] | 0;
       i5 = i4 & 2147483647;
       do if (i3 >>> 0 > i5 >>> 0) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i23 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i23;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i3;
       i1 = HEAP32[i40 >> 2] | 0;
       i3 = i1 + (i2 * 28 | 0) | 0;
       HEAP32[i3 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
       i3 = i1;
       i2 = i1;
       break;
      } else {
       do if (i1) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i19 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i19;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i3;
       i3 = HEAP32[i40 >> 2] | 0;
       HEAPF32[i3 + (i2 * 28 | 0) >> 2] = f9;
       HEAPF32[i3 + (i2 * 28 | 0) + 4 >> 2] = f12;
       HEAPF32[i3 + (i2 * 28 | 0) + 8 >> 2] = f14;
       HEAP32[i3 + (i2 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i3 + (i2 * 28 | 0) + 16 >> 2] = f9;
       HEAPF32[i3 + (i2 * 28 | 0) + 20 >> 2] = f12;
       HEAPF32[i3 + (i2 * 28 | 0) + 24 >> 2] = f14;
       i2 = HEAP32[i34 >> 2] | 0;
       i3 = i2 + 1 | 0;
       i4 = HEAP32[i35 >> 2] | 0;
       i5 = i4 & 2147483647;
       do if (i3 >>> 0 > i5 >>> 0) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 >= i1 >>> 0) break;
        if ((i4 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i19 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i19;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i3;
       i4 = HEAP32[i40 >> 2] | 0;
       HEAPF32[i4 + (i2 * 28 | 0) >> 2] = f7;
       HEAPF32[i4 + (i2 * 28 | 0) + 4 >> 2] = f8;
       HEAPF32[i4 + (i2 * 28 | 0) + 8 >> 2] = f11;
       HEAP32[i4 + (i2 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i4 + (i2 * 28 | 0) + 16 >> 2] = f7;
       HEAPF32[i4 + (i2 * 28 | 0) + 20 >> 2] = f8;
       HEAPF32[i4 + (i2 * 28 | 0) + 24 >> 2] = f11;
       i4 = HEAP32[i34 >> 2] | 0;
       i6 = i4 + 1 | 0;
       i2 = HEAP32[i35 >> 2] | 0;
       i3 = i2 & 2147483647;
       do if (i6 >>> 0 > i3 >>> 0) {
        i1 = i2 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i3 >>> 0 >= i1 >>> 0) break;
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         i2 = HEAP32[i35 >> 2] | 0;
         break;
        } else {
         i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i2;
         i2 = i1;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i6;
       i1 = HEAP32[i40 >> 2] | 0;
       i5 = i1 + (i4 * 28 | 0) | 0;
       HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
       HEAP32[i5 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
       HEAP32[i5 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
       HEAP32[i5 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
       i5 = i4 + 2 | 0;
       i4 = i2 & 2147483647;
       do if (i5 >>> 0 > i4 >>> 0) {
        i3 = i2 << 1;
        i3 = (i3 | 0) == 0 ? 1 : i3;
        if (i4 >>> 0 >= i3 >>> 0) break;
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i3;
         i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         HEAP32[i40 >> 2] = i1;
         break;
        } else {
         i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i1 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i3;
         HEAP32[i40 >> 2] = i1;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i5;
       HEAPF32[i1 + (i6 * 28 | 0) >> 2] = f9;
       HEAPF32[i1 + (i6 * 28 | 0) + 4 >> 2] = f12;
       HEAPF32[i1 + (i6 * 28 | 0) + 8 >> 2] = f14;
       HEAP32[i1 + (i6 * 28 | 0) + 12 >> 2] = -1;
       HEAPF32[i1 + (i6 * 28 | 0) + 16 >> 2] = f9;
       HEAPF32[i1 + (i6 * 28 | 0) + 20 >> 2] = f12;
       HEAPF32[i1 + (i6 * 28 | 0) + 24 >> 2] = f14;
       i4 = HEAP32[i34 >> 2] | 0;
       i6 = i4 + 1 | 0;
       i2 = HEAP32[i35 >> 2] | 0;
       i3 = i2 & 2147483647;
       do if (i6 >>> 0 > i3 >>> 0) {
        i1 = i2 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i3 >>> 0 >= i1 >>> 0) break;
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         i2 = HEAP32[i35 >> 2] | 0;
         break;
        } else {
         i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i2;
         i2 = i1;
         break;
        }
       } while (0);
       HEAP32[i34 >> 2] = i6;
       i5 = HEAP32[i40 >> 2] | 0;
       i3 = i5 + (i4 * 28 | 0) | 0;
       HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
       i4 = i4 + 2 | 0;
       i3 = i2 & 2147483647;
       do if (i4 >>> 0 > i3 >>> 0) {
        i1 = i2 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i3 >>> 0 >= i1 >>> 0) {
         i1 = i5;
         i2 = i5;
         break;
        }
        if ((i2 | 0) > -1) {
         HEAP32[i35 >> 2] = i1;
         i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 464) | 0;
         HEAP32[i40 >> 2] = i2;
         i1 = i2;
         break;
        } else {
         i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i36, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i2 | 0, HEAP32[i40 >> 2] | 0, (HEAP32[i34 >> 2] | 0) * 28 | 0) | 0;
         HEAP32[i35 >> 2] = i1;
         HEAP32[i40 >> 2] = i2;
         i1 = i2;
         break;
        }
       } else {
        i1 = i5;
        i2 = i5;
       } while (0);
       HEAP32[i34 >> 2] = i4;
       i3 = i1 + (i6 * 28 | 0) | 0;
       HEAP32[i3 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
       HEAP32[i3 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
       i3 = i1;
       break;
      }
     } while (0);
     i25 = i25 + 3 | 0;
     if ((i25 | 0) >= (i26 | 0)) break; else {
      i19 = i1;
      i1 = i3;
     }
    }
   }
  }
  if ((HEAP32[i29 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i30);
   HEAP32[i38 >> 2] = 0;
  }
  i27 = i27 + 1 | 0;
 } while ((i27 | 0) != 2);
 mftCall_viiiiiii(HEAP32[(HEAP32[i33 >> 2] | 0) + 224 >> 2] | 0, i33 | 0, HEAP32[gb + 1114348 >> 2] | 0, 0, 0, (HEAP32[i34 >> 2] | 0) * 28 | 0, HEAP32[i40 >> 2] | 0, 0);
 HEAP32[gb + 1114340 >> 2] = HEAP32[i34 >> 2];
 i1 = HEAP32[gb + 1114348 >> 2] | 0;
 if ((HEAP32[i35 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i40 >> 2] | 0, i36);
  HEAP32[i40 >> 2] = 0;
 }
 i40 = i1;
 STACKTOP = i41;
 return i40 | 0;
}

function __ZN5Umbra12PortalCuller8traverseEv(i155) {
 i155 = i155 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i156 = 0, i157 = 0, i158 = 0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, f164 = f0, f165 = f0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0;
 i158 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i154 = i158 + 64 | 0;
 i99 = i158 + 120 | 0;
 i109 = i158 + 112 | 0;
 i120 = i158;
 i131 = i158 + 104 | 0;
 i142 = i158 + 96 | 0;
 i152 = i158 + 80 | 0;
 i157 = i155 + 2300 | 0;
 i153 = HEAP32[i157 >> 2] | 0;
 HEAP32[i99 >> 2] = i153;
 HEAP32[i99 + 4 >> 2] = i153;
 i156 = i155 + 2304 | 0;
 HEAP32[i109 >> 2] = 0;
 i93 = i109 + 4 | 0;
 HEAP32[i93 >> 2] = -1;
 i94 = i155 + 432 | 0;
 i151 = __ZN5Umbra16TileTraverseTree4nextERi(i94, i93) | 0;
 HEAP32[i109 >> 2] = i151;
 L1 : do if (!i151) i13 = i155 + 8 | 0; else {
  i95 = i155 + 7048 | 0;
  i96 = i155 + 2828 | 0;
  i97 = i155 + 2844 | 0;
  i98 = i155 + 2892 | 0;
  i100 = i155 + 2724 | 0;
  i101 = i155 + 2720 | 0;
  i102 = i155 + 2306 | 0;
  i103 = i155 + 4 | 0;
  i104 = i155 + 2656 | 0;
  i105 = i155 + 2672 | 0;
  i106 = i155 + 452 | 0;
  i107 = i155 + 2696 | 0;
  i108 = i155 + 2704 | 0;
  i13 = i155 + 8 | 0;
  i110 = i155 + 2728 | 0;
  i111 = i155 + 2700 | 0;
  i112 = i154 + 4 | 0;
  i113 = i154 + 8 | 0;
  i114 = i155 + 2324 | 0;
  i115 = i155 + 2328 | 0;
  i116 = i155 + 2332 | 0;
  i117 = i155 + 2308 | 0;
  i118 = i155 + 2312 | 0;
  i119 = i155 + 2316 | 0;
  i121 = i120 + 4 | 0;
  i122 = i120 + 8 | 0;
  i123 = i155 + 2352 | 0;
  i124 = i155 + 2356 | 0;
  i125 = i155 + 2360 | 0;
  i126 = i155 + 2732 | 0;
  i127 = i155 + 2736 | 0;
  i90 = i120 + 4 | 0;
  i84 = i120 + 8 | 0;
  i86 = i120 + 12 | 0;
  i128 = i120 + 16 | 0;
  i89 = i120 + 20 | 0;
  i83 = i120 + 24 | 0;
  i85 = i120 + 28 | 0;
  i129 = i120 + 32 | 0;
  i82 = i120 + 36 | 0;
  i87 = i120 + 40 | 0;
  i88 = i120 + 44 | 0;
  i80 = i120 + 48 | 0;
  i91 = i120 + 52 | 0;
  i92 = i120 + 56 | 0;
  i81 = i120 + 60 | 0;
  i130 = i154 + 8 | 0;
  i132 = i154 + 4 | 0;
  i133 = i154 + 12 | 0;
  i134 = i154 + 4 | 0;
  i135 = i154 + 8 | 0;
  i136 = i154 + 12 | 0;
  i137 = i131 + 4 | 0;
  i138 = i155 + 2304 | 0;
  i139 = i155 + 2306 | 0;
  i140 = i155 + 292 | 0;
  i141 = i152 + 4 | 0;
  i143 = i152 + 8 | 0;
  i144 = i152 + 12 | 0;
  i145 = i155 + 7032 | 0;
  i146 = i155 + 484 | 0;
  i147 = i155 + 2288 | 0;
  i148 = i155 + 7030 | 0;
  i149 = i155 + 2688 | 0;
  i150 = i155 + 2864 | 0;
  i151 = i155 + 2880 | 0;
  L4 : while (1) {
   __ZN5Umbra12PortalCuller9enterTileERKNS0_4TileE(i155, i109);
   if ((HEAP32[i95 >> 2] | 0) < 0) {
    i79 = 5;
    break;
   }
   while (1) {
    i77 = __ZN5Umbra12PortalCuller17nextCellToProcessERNS_16DoublyLinkedListINS0_8CellDataEtEE(i155, i99) | 0;
    if (!(i77 << 16 >> 16)) break;
    i78 = i77 & 65535;
    i6 = HEAP32[i157 >> 2] | 0;
    i1 = HEAPU16[i6 + (i78 << 4) + 4 >> 1] | 0;
    i5 = (HEAP32[i96 >> 2] | 0) + (Math_imul(HEAP32[i97 >> 2] | 0, i1) | 0) | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if (!(HEAP32[i98 >> 2] | 0)) {
     i1 = 0;
     i3 = 0;
    } else {
     i3 = (HEAP32[i150 >> 2] | 0) + (Math_imul(HEAP32[i151 >> 2] | 0, i1) | 0) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
    }
    i2 = HEAP32[i100 >> 2] | 0;
    if (!i2) {
     i7 = 0;
     i1 = 0;
     i3 = 0;
    } else if (!(HEAP32[i2 + 8 >> 2] | 0)) {
     i7 = 0;
     i1 = 0;
     i3 = 0;
    } else {
     i7 = HEAP32[i108 >> 2] | 0;
     i1 = (HEAP32[i2 + 12 >> 2] | 0) + (i1 << 4) | 0;
    }
    i76 = HEAP32[i101 >> 2] | 0;
    i2 = (HEAP32[i76 + 60 >> 2] | 0) + (i4 << 4) | 0;
    i2 = (i2 | 0) == 0 ? 0 : i76 + i2 | 0;
    i5 = (i2 | 0) == 0 ? 0 : i5;
    i76 = HEAP32[i6 + (i78 << 4) + 8 >> 2] | 0;
    i73 = i76 << 3 & 2040;
    i74 = i76 >>> 6 & 1020;
    i75 = i76 >>> 13 & 2040;
    i76 = i76 >>> 24 << 2;
    L16 : do if ((i3 | 0) != (0 - i5 | 0)) {
     i4 = 0;
     while (1) {
      i72 = i2;
      L20 : while (1) {
       if (!i5) {
        i68 = (i1 | 0) == 0 ? 0 : i7 + i1 | 0;
        i7 = 0;
        i70 = 0;
        i71 = 0;
        i4 = 1;
        i69 = (i68 | 0) == 0 ? 0 : i3;
       } else {
        i70 = i1;
        i71 = i3;
        i69 = i5;
        i68 = i72;
       }
       i5 = i69 + -1 | 0;
       i72 = i68 + 16 | 0;
       i11 = HEAP32[i68 >> 2] | 0;
       i12 = (i11 & 134217728 | 0) == 0;
       L25 : do if (i12) {
        i1 = i11 >>> 29;
        i2 = i11 >>> 30;
        if (!(HEAP8[(HEAP32[i103 >> 2] | 0) + 1365 >> 0] | 0)) {
         i67 = (i1 & 1) + -1 | 0;
         if ((((HEAP32[i104 + (i2 << 2) >> 2] | 0) - (HEAP32[i68 + 4 >> 2] & 65535) ^ i67) - i67 | 0) > (HEAP32[i105 + (i2 << 2) >> 2] | 0)) break; else {
          i79 = 34;
          break;
         }
        } else if ((i1 & 1 | 0) == (HEAP32[i155 + 300 + (i2 << 2) >> 2] | 0)) {
         i79 = 34;
         break;
        } else break;
       } else {
        i1 = HEAP32[i68 + 8 >> 2] | 0;
        i10 = i1 & 4095;
        if (!i10) i79 = 34; else {
         i8 = HEAP32[i111 >> 2] | 0;
         i6 = i1 >>> 12;
         i8 = i8 + (HEAP32[i8 + 120 >> 2] | 0) | 0;
         i67 = HEAP32[i107 >> 2] | 0;
         i9 = HEAP32[(HEAP32[HEAP32[i155 >> 2] >> 2] | 0) + 12 >> 2] | 0;
         i1 = (i9 | 0) == 0;
         i2 = HEAP32[i108 >> 2] | 0;
         i3 = i67 + 16 | 0;
         if (!i67) {
          if (i1) {
           i79 = 34;
           break;
          } else i1 = 0;
          while (1) {
           i2 = HEAP32[i8 + (i1 + i6 << 2) >> 2] | 0;
           if ((i2 | 0) >= 0) if (!(HEAP32[i9 + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31))) break L25;
           i1 = i1 + 1 | 0;
           if ((i1 | 0) >= (i10 | 0)) {
            i79 = 34;
            break L25;
           }
          }
         }
         if (i1) i79 = 34; else {
          i2 = i2 + (HEAP32[i3 >> 2] | 0) | 0;
          i1 = 0;
          while (1) {
           i3 = HEAP32[i2 + (HEAP32[i8 + (i1 + i6 << 2) >> 2] << 2) >> 2] | 0;
           if ((i3 | 0) >= 0) if (!(HEAP32[i9 + (i3 >> 5 << 2) >> 2] & 1 << (i3 & 31))) break L25;
           i1 = i1 + 1 | 0;
           if ((i1 | 0) >= (i10 | 0)) {
            i79 = 34;
            break;
           }
          }
         }
        }
       } while (0);
       do if ((i79 | 0) == 34) {
        i79 = 0;
        i3 = i4 << 24 >> 24 != 0;
        i1 = (i11 & 268435456 | 0) == 0;
        if (i3) {
         if (i1) {
          i1 = i11 & 67108863;
          i79 = 46;
         }
        } else if (i1) {
         if ((i11 & 67108863 | 0) == (HEAP32[i110 >> 2] | 0)) {
          i1 = -1;
          i66 = 0;
          i4 = 0;
          i67 = 1;
          break L20;
         }
         i1 = i11 & 67108863;
         i2 = HEAP32[i107 >> 2] | 0;
         if (!i2) i79 = 46; else {
          i1 = HEAP32[(HEAP32[i108 >> 2] | 0) + (HEAP32[i2 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
          i79 = 46;
         }
        }
        if ((i79 | 0) == 46) {
         i79 = 0;
         if (!(HEAP32[(HEAP32[i106 >> 2] | 0) + (i1 >> 5 << 2) >> 2] & 1 << (i1 & 31))) break; else {
          i66 = i3;
          i67 = 0;
          break L20;
         }
        }
        if (HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0) {
         i1 = HEAP32[i100 >> 2] | 0;
         if (!i1) i1 = 63; else i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (i1 & 1 << (i11 >>> 29) | 0) {
          i1 = -1;
          i66 = i3;
          i67 = 0;
          break L20;
         }
        }
       } while (0);
       if ((i71 | 0) == (1 - i69 | 0)) break L16; else {
        i1 = i70;
        i3 = i71;
       }
      }
      i2 = i11 >>> 29;
      do if (i12) {
       HEAP32[i154 >> 2] = 0;
       HEAP32[i154 + 4 >> 2] = 0;
       HEAP32[i154 + 8 >> 2] = 0;
       HEAP32[i154 + 12 >> 2] = 0;
       HEAP32[i120 >> 2] = 0;
       HEAP32[i120 + 4 >> 2] = 0;
       HEAP32[i120 + 8 >> 2] = 0;
       HEAP32[i120 + 12 >> 2] = 0;
       i8 = (HEAP32[i68 >> 2] | 0) >>> 30;
       i3 = i68 + 4 | 0;
       i65 = HEAP32[i3 >> 2] & 65535;
       HEAP32[i120 + (i8 << 2) >> 2] = i65;
       HEAP32[i154 + (i8 << 2) >> 2] = i65;
       i8 = 1 << i8 & 3;
       i65 = i68 + 8 | 0;
       HEAP32[i154 + (i8 << 2) >> 2] = (HEAP32[i65 >> 2] | 0) >>> 16;
       HEAP32[i120 + (i8 << 2) >> 2] = HEAP32[i65 >> 2] & 65535;
       i8 = 1 << i8 & 3;
       i65 = i68 + 12 | 0;
       HEAP32[i154 + (i8 << 2) >> 2] = (HEAP32[i65 >> 2] | 0) >>> 16;
       HEAP32[i120 + (i8 << 2) >> 2] = HEAP32[i65 >> 2] & 65535;
       f16 = Math_fround(HEAP32[i154 >> 2] | 0);
       f20 = Math_fround(HEAP32[i112 >> 2] | 0);
       f18 = Math_fround(HEAP32[i113 >> 2] | 0);
       f60 = Math_fround(HEAPF32[i114 >> 2]);
       f16 = Math_fround(f16 * f60);
       f19 = Math_fround(HEAPF32[i115 >> 2]);
       f20 = Math_fround(f20 * f19);
       f63 = Math_fround(HEAPF32[i116 >> 2]);
       f18 = Math_fround(f18 * f63);
       f58 = Math_fround(HEAPF32[i117 >> 2]);
       f16 = Math_fround(f16 + f58);
       f17 = Math_fround(HEAPF32[i118 >> 2]);
       f20 = Math_fround(f20 + f17);
       f15 = Math_fround(HEAPF32[i119 >> 2]);
       f18 = Math_fround(f18 + f15);
       f61 = Math_fround(HEAP32[i120 >> 2] | 0);
       f62 = Math_fround(HEAP32[i121 >> 2] | 0);
       f61 = Math_fround(f58 + Math_fround(f60 * f61));
       f62 = Math_fround(f17 + Math_fround(f19 * f62));
       f63 = Math_fround(f15 + Math_fround(f63 * Math_fround(HEAP32[i122 >> 2] | 0)));
       f15 = Math_fround(HEAPF32[i123 >> 2]);
       f19 = Math_fround(HEAPF32[i124 >> 2]);
       f17 = Math_fround(HEAPF32[i125 >> 2]);
       f16 = Math_fround(f16 - f15);
       f20 = Math_fround(f20 - f19);
       f18 = Math_fround(f18 - f17);
       f15 = Math_fround(f61 + f15);
       f19 = Math_fround(f62 + f19);
       f17 = Math_fround(f63 + f17);
       i8 = HEAP32[i103 >> 2] | 0;
       if (!(HEAP8[i8 + 1365 >> 0] | 0)) {
        i65 = HEAP32[i68 >> 2] | 0;
        i6 = i65 >>> 30;
        i65 = (i65 >>> 29 & 1) + -1 | 0;
        if ((((HEAP32[i3 >> 2] & 65535) - (HEAP32[i104 + (i6 << 2) >> 2] | 0) ^ i65) - i65 | 0) <= (HEAP32[i105 + (i6 << 2) >> 2] | 0)) {
         i23 = 1 << i6 & 3;
         i24 = 1 << i23 & 3;
         i64 = HEAP32[i105 + (i23 << 2) >> 2] | 0;
         i22 = HEAP32[i104 + (i23 << 2) >> 2] | 0;
         i29 = (HEAP32[i154 + (i23 << 2) >> 2] | 0) - i64 - i22 | 0;
         i65 = (i29 | 0) > 0;
         i2 = i23 << 1;
         i29 = i65 ? i29 : 0;
         i23 = i22 - i64 - (HEAP32[i120 + (i23 << 2) >> 2] | 0) | 0;
         i64 = (i23 | 0) > (i29 | 0);
         i29 = i64 ? i23 : i29;
         i23 = HEAP32[i105 + (i24 << 2) >> 2] | 0;
         i22 = HEAP32[i104 + (i24 << 2) >> 2] | 0;
         i28 = (HEAP32[i154 + (i24 << 2) >> 2] | 0) - i23 - i22 | 0;
         i42 = (i28 | 0) > (i29 | 0);
         i59 = i24 << 1;
         i2 = (i22 - i23 - (HEAP32[i120 + (i24 << 2) >> 2] | 0) | 0) > ((i42 ? i28 : i29) | 0) ? i59 : i42 ? i59 | 1 : i64 ? i2 : i65 ? i2 | 1 : -1;
        }
       }
       i65 = i2;
      } else {
       i64 = HEAP32[i111 >> 2] | 0;
       f62 = Math_fround(HEAPF32[i123 >> 2]);
       f63 = Math_fround(HEAPF32[i124 >> 2]);
       f27 = Math_fround(HEAPF32[i125 >> 2]);
       i65 = (HEAP32[i68 + 12 >> 2] | 0) >>> 12;
       i64 = i64 + (HEAP32[i64 + 112 >> 2] | 0) | 0;
       i8 = i64 + (i65 * 12 | 0) | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i8 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i8 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i8 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i8 + 3 >> 0];
       f26 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
       i59 = i64 + (i65 * 12 | 0) + 4 | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i59 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i59 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i59 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i59 + 3 >> 0];
       f20 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
       i65 = i64 + (i65 * 12 | 0) + 8 | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i65 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i65 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i65 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i65 + 3 >> 0];
       f18 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
       i65 = i8 + 12 | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i65 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i65 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i65 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i65 + 3 >> 0];
       f25 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
       i65 = i8 + 16 | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i65 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i65 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i65 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i65 + 3 >> 0];
       f19 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
       i8 = i8 + 20 | 0;
       HEAP8[tempDoublePtr >> 0] = HEAP8[i8 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i8 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i8 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i8 + 3 >> 0];
       f26 = Math_fround(f26 - f62);
       f20 = Math_fround(f20 - f63);
       f18 = Math_fround(f18 - f27);
       f25 = Math_fround(f62 + f25);
       f19 = Math_fround(f63 + f19);
       f27 = Math_fround(f27 + Math_fround(HEAPF32[tempDoublePtr >> 2]));
       i8 = HEAP32[i103 >> 2] | 0;
       if (HEAP8[i8 + 1365 >> 0] | 0) {
        i65 = HEAP32[i149 >> 2] | 0;
        f15 = f25;
        f16 = f26;
        f17 = f27;
        break;
       }
       i3 = i8 + 1184 | 0;
       f16 = Math_fround(HEAPF32[i3 >> 2]);
       f15 = Math_fround(f26 - f16);
       if (f15 > Math_fround(0.0)) i2 = 1; else {
        f15 = Math_fround(f16 - f25);
        if (f15 > Math_fround(0.0)) i2 = 0; else {
         f15 = Math_fround(0.0);
         i2 = -1;
        }
       }
       f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
       f17 = Math_fround(f20 - f16);
       if (f17 > f15) {
        f15 = f17;
        i2 = 3;
       } else {
        f16 = Math_fround(f16 - f19);
        if (f16 > f15) {
         f15 = f16;
         i2 = 2;
        }
       }
       f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
       if (Math_fround(f18 - f16) > f15) {
        i65 = 5;
        f15 = f25;
        f16 = f26;
        f17 = f27;
       } else if (Math_fround(f16 - f27) > f15) {
        i65 = 4;
        f15 = f25;
        f16 = f26;
        f17 = f27;
       } else {
        i65 = i2;
        f15 = f25;
        f16 = f26;
        f17 = f27;
       }
      } while (0);
      HEAP32[i154 >> 2] = 0;
      HEAP32[i154 + 4 >> 2] = 0;
      HEAP32[i154 + 8 >> 2] = 0;
      HEAP32[i154 + 12 >> 2] = 0;
      i2 = i120;
      i3 = i2 + 64 | 0;
      do {
       HEAP32[i2 >> 2] = 0;
       i2 = i2 + 4 | 0;
      } while ((i2 | 0) < (i3 | 0));
      i64 = (i65 | 0) != -1;
      do if (i64) {
       if ((HEAP32[i126 >> 2] | 0) > 0) i59 = (HEAP32[i127 >> 2] | 0) == 0; else i59 = 0;
       f53 = Math_fround(HEAPF32[i8 + 64 >> 2]);
       f25 = Math_fround(HEAPF32[i8 + 68 >> 2]);
       f30 = Math_fround(HEAPF32[i8 + 72 >> 2]);
       f54 = Math_fround(HEAPF32[i8 + 76 >> 2]);
       f55 = Math_fround(HEAPF32[i8 + 80 >> 2]);
       f26 = Math_fround(HEAPF32[i8 + 84 >> 2]);
       f31 = Math_fround(HEAPF32[i8 + 88 >> 2]);
       f56 = Math_fround(HEAPF32[i8 + 92 >> 2]);
       f57 = Math_fround(HEAPF32[i8 + 96 >> 2]);
       f27 = Math_fround(HEAPF32[i8 + 100 >> 2]);
       f32 = Math_fround(HEAPF32[i8 + 104 >> 2]);
       f58 = Math_fround(HEAPF32[i8 + 108 >> 2]);
       f60 = Math_fround(HEAPF32[i8 + 112 >> 2]);
       f61 = Math_fround(HEAPF32[i8 + 116 >> 2]);
       f62 = Math_fround(HEAPF32[i8 + 120 >> 2]);
       f60 = Math_fround(Math_fround(f16 * f53) + Math_fround(Math_fround(f20 * f55) + Math_fround(Math_fround(f18 * f57) + f60)));
       f61 = Math_fround(Math_fround(f16 * f25) + Math_fround(Math_fround(f20 * f26) + Math_fround(Math_fround(f18 * f27) + f61)));
       f62 = Math_fround(Math_fround(f16 * f30) + Math_fround(Math_fround(f20 * f31) + Math_fround(Math_fround(f18 * f32) + f62)));
       f63 = Math_fround(Math_fround(f16 * f54) + Math_fround(Math_fround(f20 * f56) + Math_fround(Math_fround(f18 * f58) + Math_fround(HEAPF32[i8 + 124 >> 2]))));
       f16 = Math_fround(f15 - f16);
       f19 = Math_fround(f19 - f20);
       f20 = Math_fround(f17 - f18);
       f15 = Math_fround(f16 * f53);
       f25 = Math_fround(f16 * f25);
       f30 = Math_fround(f16 * f30);
       f18 = Math_fround(f16 * f54);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
       i2 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
       i10 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
       i21 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
       f16 = Math_fround(f19 * f55);
       f26 = Math_fround(f19 * f26);
       f31 = Math_fround(f19 * f31);
       f19 = Math_fround(f19 * f56);
       i6 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
       i28 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
       i11 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
       i22 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
       f17 = Math_fround(f20 * f57);
       f27 = Math_fround(f20 * f27);
       f32 = Math_fround(f20 * f32);
       f20 = Math_fround(f20 * f58);
       i9 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       i29 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
       i12 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
       i23 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
       switch (i65 >>> 1 & 3) {
       case 0:
        {
         i42 = i9;
         i3 = i6;
         i24 = i29;
         i14 = i11;
         i9 = i12;
         i10 = i22;
         i6 = i23;
         i2 = i28;
         f16 = f30;
         break;
        }
       case 1:
        {
         i42 = i3;
         i3 = i9;
         f15 = f16;
         i24 = i2;
         f18 = f19;
         i14 = i12;
         i9 = i10;
         i10 = i23;
         i6 = i21;
         f25 = f26;
         i2 = i29;
         f16 = f31;
         break;
        }
       default:
        {
         i42 = i6;
         f15 = f17;
         i24 = i28;
         f18 = f20;
         i14 = i10;
         i9 = i11;
         i10 = i21;
         i6 = i22;
         f25 = f27;
         f16 = f32;
        }
       }
       i29 = (i65 & 1 | 0) != 0 ^ (HEAP8[i8 + 1204 >> 0] | 0) != 0;
       f56 = Math_fround(f60 + (HEAP32[tempDoublePtr >> 2] = i29 ? i42 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f57 = Math_fround(f61 + (HEAP32[tempDoublePtr >> 2] = i29 ? i24 : i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f165 = Math_fround(f62 + (HEAP32[tempDoublePtr >> 2] = i29 ? i9 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f58 = Math_fround(f63 + (HEAP32[tempDoublePtr >> 2] = i29 ? i6 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f48 = (HEAP32[tempDoublePtr >> 2] = i29 ? i3 : i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f55 = Math_fround(f48 + f56);
       f49 = (HEAP32[tempDoublePtr >> 2] = i29 ? i2 : i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f54 = Math_fround(f49 + f57);
       f161 = (HEAP32[tempDoublePtr >> 2] = i29 ? i14 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f163 = Math_fround(f161 + f165);
       f50 = (HEAP32[tempDoublePtr >> 2] = i29 ? i10 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f47 = Math_fround(f50 + f58);
       f48 = Math_fround(f60 + f48);
       f49 = Math_fround(f61 + f49);
       f161 = Math_fround(f62 + f161);
       f50 = Math_fround(f63 + f50);
       HEAPF32[i120 >> 2] = f60;
       HEAPF32[i90 >> 2] = f56;
       HEAPF32[i84 >> 2] = f55;
       HEAPF32[i86 >> 2] = f48;
       HEAPF32[i128 >> 2] = f61;
       HEAPF32[i89 >> 2] = f57;
       HEAPF32[i83 >> 2] = f54;
       HEAPF32[i85 >> 2] = f49;
       HEAPF32[i129 >> 2] = f63;
       HEAPF32[i82 >> 2] = f58;
       HEAPF32[i87 >> 2] = f47;
       HEAPF32[i88 >> 2] = f50;
       HEAPF32[i80 >> 2] = f15;
       HEAPF32[i91 >> 2] = f25;
       HEAPF32[i92 >> 2] = f16;
       HEAPF32[i81 >> 2] = f18;
       f51 = Math_fround(f60 + f15);
       f52 = Math_fround(f15 + f56);
       f53 = Math_fround(f15 + f55);
       f43 = Math_fround(f15 + f48);
       f44 = Math_fround(f61 + f25);
       f45 = Math_fround(f25 + f57);
       f46 = Math_fround(f25 + f54);
       f41 = Math_fround(f25 + f49);
       f159 = Math_fround(f62 + f16);
       f164 = Math_fround(f16 + f165);
       f162 = Math_fround(f16 + f163);
       f160 = Math_fround(f16 + f161);
       f38 = Math_fround(f63 + f18);
       f39 = Math_fround(f18 + f58);
       f40 = Math_fround(f18 + f47);
       f15 = Math_fround(f18 + f50);
       i24 = f63 == Math_fround(0.0);
       f20 = Math_fround(Math_fround(1.0) / f63);
       f20 = i24 ? Math_fround(1.0) : f20;
       i24 = f58 == Math_fround(0.0);
       f25 = Math_fround(Math_fround(1.0) / f58);
       f25 = i24 ? Math_fround(1.0) : f25;
       i24 = f47 == Math_fround(0.0);
       f26 = Math_fround(Math_fround(1.0) / f47);
       f26 = i24 ? Math_fround(1.0) : f26;
       i24 = f50 == Math_fround(0.0);
       f27 = Math_fround(Math_fround(1.0) / f50);
       f27 = i24 ? Math_fround(1.0) : f27;
       i24 = f38 == Math_fround(0.0);
       f34 = Math_fround(Math_fround(1.0) / f38);
       f34 = i24 ? Math_fround(1.0) : f34;
       i24 = f39 == Math_fround(0.0);
       f35 = Math_fround(Math_fround(1.0) / f39);
       f35 = i24 ? Math_fround(1.0) : f35;
       i24 = f40 == Math_fround(0.0);
       f36 = Math_fround(Math_fround(1.0) / f40);
       f36 = i24 ? Math_fround(1.0) : f36;
       i24 = f15 == Math_fround(0.0);
       f37 = Math_fround(Math_fround(1.0) / f15);
       f37 = i24 ? Math_fround(1.0) : f37;
       f16 = Math_fround(f60 * f20);
       f17 = Math_fround(f56 * f25);
       f18 = Math_fround(f55 * f26);
       f19 = Math_fround(f48 * f27);
       f20 = Math_fround(f61 * f20);
       f25 = Math_fround(f57 * f25);
       f26 = Math_fround(f54 * f26);
       f27 = Math_fround(f49 * f27);
       f30 = Math_fround(f51 * f34);
       f31 = Math_fround(f52 * f35);
       f32 = Math_fround(f53 * f36);
       f33 = Math_fround(f43 * f37);
       f34 = Math_fround(f44 * f34);
       f35 = Math_fround(f45 * f35);
       f36 = Math_fround(f46 * f36);
       f37 = Math_fround(f41 * f37);
       i24 = (f58 >= f165 | f39 >= f164) & (f58 >= f39 ? f58 : f39) >= Math_fround(0.0);
       i42 = (f47 >= f163 | f40 >= f162) & (f47 >= f40 ? f47 : f40) >= Math_fround(0.0);
       i29 = (f50 >= f161 | f15 >= f160) & (f50 >= f15 ? f50 : f15) >= Math_fround(0.0);
       i28 = ((f63 >= f62 | f38 >= f159) & (f63 >= f38 ? f63 : f38) >= Math_fround(0.0)) << 31 >> 31 >>> 31;
       if (!((i24 ? 2 : 0) | i28 | (i29 ? 8 : 0) | (i42 ? 4 : 0))) {
        HEAP32[i154 >> 2] = 0;
        HEAP32[i154 + 4 >> 2] = 0;
        HEAP32[i154 + 8 >> 2] = 0;
        HEAP32[i154 + 12 >> 2] = 0;
        break;
       }
       if (i59) if (!((f50 <= f15 ? f50 : f15) < Math_fround(0.0)) & (((f63 <= f38 ? f63 : f38) < Math_fround(0.0) ? 0 : !((f58 <= f39 ? f58 : f39) < Math_fround(0.0))) & !((f47 <= f40 ? f47 : f40) < Math_fround(0.0)))) i79 = 68; else {
        f62 = Math_fround(-f63);
        f165 = Math_fround(-f58);
        f160 = Math_fround(-f47);
        f162 = Math_fround(-f50);
        i196 = f60 > f62;
        i194 = f56 > f165;
        i192 = f55 > f160;
        i190 = f48 > f162;
        i187 = f63 > f60;
        i183 = f58 > f56;
        i179 = f47 > f55;
        i175 = f50 > f48;
        i172 = f61 > f62;
        i170 = f57 > f165;
        i168 = f54 > f160;
        i166 = f49 > f162;
        i6 = f63 > f61;
        i11 = f58 > f57;
        i22 = f47 > f54;
        i29 = f50 > f49;
        f162 = Math_fround(-f38);
        f61 = Math_fround(-f39);
        f58 = Math_fround(-f40);
        f57 = Math_fround(-f15);
        i195 = f51 > f162;
        i193 = f52 > f61;
        i191 = f53 > f58;
        i189 = f43 > f57;
        i185 = f38 > f51;
        i181 = f39 > f52;
        i177 = f40 > f53;
        i173 = f15 > f43;
        i171 = f44 > f162;
        i169 = f45 > f61;
        i167 = f46 > f58;
        i2 = f41 > f57;
        i9 = f38 > f44;
        i14 = f39 > f45;
        i24 = f40 > f46;
        i59 = f15 > f41;
        i188 = i187 & i196;
        i184 = i183 & i194;
        i180 = i179 & i192;
        i176 = i175 & i190;
        i3 = i6 & i172;
        i10 = i11 & i170;
        i21 = i22 & i168;
        i28 = i29 & i166;
        i186 = i185 & i195;
        i182 = i181 & i193;
        i178 = i177 & i191;
        i174 = i173 & i189;
        i8 = i9 & i171;
        i12 = i14 & i169;
        i23 = i24 & i167;
        i42 = i59 & i2;
        f57 = i188 ? f16 : Math_fround(1.0);
        f57 = i196 ? f57 : Math_fround(-1.0);
        f58 = i186 ? f30 : Math_fround(1.0);
        f58 = i195 ? f58 : Math_fround(-1.0);
        f58 = f57 <= f58 ? f57 : f58;
        f57 = i184 ? f17 : Math_fround(1.0);
        f57 = i194 ? f57 : Math_fround(-1.0);
        f61 = i182 ? f31 : Math_fround(1.0);
        f61 = i193 ? f61 : Math_fround(-1.0);
        f61 = f57 <= f61 ? f57 : f61;
        f57 = i180 ? f18 : Math_fround(1.0);
        f57 = i192 ? f57 : Math_fround(-1.0);
        f162 = i178 ? f32 : Math_fround(1.0);
        f162 = i191 ? f162 : Math_fround(-1.0);
        f162 = f57 <= f162 ? f57 : f162;
        f57 = i176 ? f19 : Math_fround(1.0);
        f57 = i190 ? f57 : Math_fround(-1.0);
        f15 = i174 ? f33 : Math_fround(1.0);
        f15 = i189 ? f15 : Math_fround(-1.0);
        f15 = f57 <= f15 ? f57 : f15;
        f57 = i188 ? f16 : Math_fround(-1.0);
        f57 = i187 ? f57 : Math_fround(1.0);
        f63 = i186 ? f30 : Math_fround(-1.0);
        f63 = i185 ? f63 : Math_fround(1.0);
        f63 = f57 >= f63 ? f57 : f63;
        f57 = i184 ? f17 : Math_fround(-1.0);
        f57 = i183 ? f57 : Math_fround(1.0);
        f160 = i182 ? f31 : Math_fround(-1.0);
        f160 = i181 ? f160 : Math_fround(1.0);
        f160 = f57 >= f160 ? f57 : f160;
        f57 = i180 ? f18 : Math_fround(-1.0);
        f57 = i179 ? f57 : Math_fround(1.0);
        f165 = i178 ? f32 : Math_fround(-1.0);
        f165 = i177 ? f165 : Math_fround(1.0);
        f165 = f57 >= f165 ? f57 : f165;
        f57 = i176 ? f19 : Math_fround(-1.0);
        f57 = i175 ? f57 : Math_fround(1.0);
        f18 = i174 ? f33 : Math_fround(-1.0);
        f18 = i173 ? f18 : Math_fround(1.0);
        f18 = f57 >= f18 ? f57 : f18;
        f57 = i3 ? f20 : Math_fround(1.0);
        f57 = i172 ? f57 : Math_fround(-1.0);
        f60 = i8 ? f34 : Math_fround(1.0);
        f60 = i171 ? f60 : Math_fround(-1.0);
        f60 = f57 <= f60 ? f57 : f60;
        f57 = i10 ? f25 : Math_fround(1.0);
        f57 = i170 ? f57 : Math_fround(-1.0);
        f62 = i12 ? f35 : Math_fround(1.0);
        f62 = i169 ? f62 : Math_fround(-1.0);
        f62 = f57 <= f62 ? f57 : f62;
        f57 = i21 ? f26 : Math_fround(1.0);
        f57 = i168 ? f57 : Math_fround(-1.0);
        f164 = i23 ? f36 : Math_fround(1.0);
        f164 = i167 ? f164 : Math_fround(-1.0);
        f164 = f57 <= f164 ? f57 : f164;
        f57 = i28 ? f27 : Math_fround(1.0);
        f57 = i166 ? f57 : Math_fround(-1.0);
        f17 = i42 ? f37 : Math_fround(1.0);
        f17 = i2 ? f17 : Math_fround(-1.0);
        f17 = f57 <= f17 ? f57 : f17;
        f57 = i3 ? f20 : Math_fround(-1.0);
        f57 = i6 ? f57 : Math_fround(1.0);
        f159 = i8 ? f34 : Math_fround(-1.0);
        f159 = i9 ? f159 : Math_fround(1.0);
        f159 = f57 >= f159 ? f57 : f159;
        f57 = i10 ? f25 : Math_fround(-1.0);
        f57 = i11 ? f57 : Math_fround(1.0);
        f161 = i12 ? f35 : Math_fround(-1.0);
        f161 = i14 ? f161 : Math_fround(1.0);
        f161 = f57 >= f161 ? f57 : f161;
        f57 = i21 ? f26 : Math_fround(-1.0);
        f57 = i22 ? f57 : Math_fround(1.0);
        f163 = i23 ? f36 : Math_fround(-1.0);
        f163 = i24 ? f163 : Math_fround(1.0);
        f163 = f57 >= f163 ? f57 : f163;
        f57 = i28 ? f27 : Math_fround(-1.0);
        f57 = i29 ? f57 : Math_fround(1.0);
        f16 = i42 ? f37 : Math_fround(-1.0);
        f16 = i59 ? f16 : Math_fround(1.0);
        f16 = f57 >= f16 ? f57 : f16;
        f162 = f58 <= f162 ? f58 : f162;
        f164 = f60 <= f164 ? f60 : f164;
        f15 = f61 <= f15 ? f61 : f15;
        f17 = f62 <= f17 ? f62 : f17;
        f165 = f63 >= f165 ? f63 : f165;
        f163 = f159 >= f163 ? f159 : f163;
        f18 = f160 >= f18 ? f160 : f18;
        f16 = f161 >= f16 ? f161 : f16;
        f15 = f162 <= f15 ? f162 : f15;
        f16 = f163 >= f16 ? f163 : f16;
        f17 = f164 <= f17 ? f164 : f17;
        f18 = f165 >= f18 ? f165 : f18;
       } else i79 = 68;
       if ((i79 | 0) == 68) {
        i79 = 0;
        f159 = f16 <= f30 ? f16 : f30;
        f160 = f17 <= f31 ? f17 : f31;
        f162 = f18 <= f32 ? f18 : f32;
        f15 = f19 <= f33 ? f19 : f33;
        f165 = f20 <= f34 ? f20 : f34;
        f63 = f25 <= f35 ? f25 : f35;
        f163 = f26 <= f36 ? f26 : f36;
        f164 = f27 <= f37 ? f27 : f37;
        f162 = f159 <= f162 ? f159 : f162;
        f163 = f165 <= f163 ? f165 : f163;
        f15 = f160 <= f15 ? f160 : f15;
        f164 = f63 <= f164 ? f63 : f164;
        f63 = f16 >= f30 ? f16 : f30;
        f160 = f17 >= f31 ? f17 : f31;
        f165 = f18 >= f32 ? f18 : f32;
        f18 = f19 >= f33 ? f19 : f33;
        f159 = f20 >= f34 ? f20 : f34;
        f161 = f25 >= f35 ? f25 : f35;
        f17 = f26 >= f36 ? f26 : f36;
        f16 = f27 >= f37 ? f27 : f37;
        f165 = f63 >= f165 ? f63 : f165;
        f17 = f159 >= f17 ? f159 : f17;
        f18 = f160 >= f18 ? f160 : f18;
        f16 = f161 >= f16 ? f161 : f16;
        f15 = f162 <= f15 ? f162 : f15;
        f16 = f17 >= f16 ? f17 : f16;
        f17 = f163 <= f164 ? f163 : f164;
        f18 = f165 >= f18 ? f165 : f18;
       }
       i2 = ~~Math_fround(Math_fround(f15 * Math_fround(32.0)) + Math_fround(32.0));
       i3 = ~~Math_fround(Math_fround(f17 * Math_fround(32.0)) + Math_fround(32.0));
       i6 = ~~Math_fround(Math_fround(f18 * Math_fround(32.0)) + Math_fround(32.9999962));
       i8 = ~~Math_fround(Math_fround(f16 * Math_fround(32.0)) + Math_fround(32.9999962));
       i2 = (i2 | 0) >= (i73 | 0) ? i2 : i73;
       i3 = (i3 | 0) >= (i74 | 0) ? i3 : i74;
       i6 = (i6 | 0) <= (i75 | 0) ? i6 : i75;
       i8 = (i8 | 0) <= (i76 | 0) ? i8 : i76;
       HEAP32[i154 >> 2] = i2;
       HEAP32[i134 >> 2] = i3;
       HEAP32[i135 >> 2] = i6;
       HEAP32[i136 >> 2] = i8;
       if ((i2 | 0) < (i6 | 0) & (i3 | 0) < (i8 | 0)) {
        i10 = i6;
        i79 = 72;
       }
      } else {
       HEAP32[i154 >> 2] = i73;
       HEAP32[i132 >> 2] = i74;
       HEAP32[i130 >> 2] = i75;
       HEAP32[i133 >> 2] = i76;
       i2 = i73;
       i3 = i74;
       i10 = i75;
       i8 = i76;
       i79 = 72;
      } while (0);
      if ((i79 | 0) == 72) {
       i79 = 0;
       HEAP32[i131 >> 2] = 0;
       HEAP32[i137 >> 2] = -1;
       HEAP32[i142 >> 2] = 0;
       do if (i67) {
        i9 = (HEAP32[i68 + 4 >> 2] | 0) >>> 16;
        i1 = HEAPU16[i155 + 2936 + (i9 << 1) >> 1] | 0;
        i196 = i1 >>> 14;
        HEAP32[i142 >> 2] = i196;
        if (i196 | 0) {
         i1 = i1 & 16383;
         i79 = 83;
         break;
        }
        i1 = HEAP16[i138 >> 1] | 0;
        if (!(i1 << 16 >> 16)) {
         i1 = HEAP16[i139 >> 1] | 0;
         if (!(i1 << 16 >> 16)) break;
         i196 = i1 & 65535;
         HEAP16[i139 >> 1] = HEAP16[(HEAP32[i157 >> 2] | 0) + (i196 << 4) >> 1] | 0;
         HEAP32[i95 >> 2] = (HEAP32[i95 >> 2] | 0) + -1;
         __ZN5Umbra12PortalCuller12finalizeCellEt(i155, i1);
         i6 = HEAP32[i157 >> 2] | 0;
         i195 = i6 + (i196 << 4) + 8 | 0;
         __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i140 >> 2] | 0, i195);
         HEAP8[i195 >> 0] = 0;
         HEAP8[i195 + 1 >> 0] = 0;
         HEAP8[i195 + 2 >> 0] = 0;
         HEAP8[i195 + 3 >> 0] = 0;
         HEAP32[i6 + (i196 << 4) + 12 >> 2] = 0;
         i6 = HEAP32[i157 >> 2] | 0;
         HEAP16[i155 + 2936 + (HEAPU16[i6 + (i196 << 4) + 4 >> 1] << 1) >> 1] = i1;
        } else {
         i6 = HEAP32[i157 >> 2] | 0;
         HEAP16[i138 >> 1] = HEAP16[i6 + ((i1 & 65535) << 4) >> 1] | 0;
        }
        HEAP16[i6 + ((i1 & 65535) << 4) + 4 >> 1] = i9;
        i29 = i1;
        i79 = 84;
       } else if (!(HEAP32[i68 >> 2] & 268435456)) {
        i1 = __ZN5Umbra12PortalCuller14findRemoteCellERNS0_4TileEiiRNS0_9CellStateE(i155, i131, i1, (HEAP32[i68 + 4 >> 2] | 0) >>> 16, i142) | 0;
        i79 = 83;
        break;
       } else {
        i1 = HEAP16[i148 >> 1] | 0;
        HEAP32[i142 >> 2] = 2;
        i79 = 83;
        break;
       } while (0);
       if ((i79 | 0) == 83) {
        i79 = 0;
        if (i1 << 16 >> 16) {
         i29 = i1;
         i79 = 84;
        }
       }
       if ((i79 | 0) == 84) {
        i79 = 0;
        HEAP32[i152 >> 2] = i2 >> 3;
        HEAP32[i141 >> 2] = i3 >> 2;
        HEAP32[i143 >> 2] = i10 + 7 >> 3;
        HEAP32[i144 >> 2] = i8 + 3 >> 2;
        i28 = i29 & 65535;
        do if (__ZN5Umbra15BufferAllocator12expandBufferERNS_17BlockRasterBufferERKNS_8Vector4iEb(HEAP32[i140 >> 2] | 0, (HEAP32[i157 >> 2] | 0) + (i28 << 4) + 8 | 0, i152, i67) | 0) {
         i1 = HEAP32[i155 >> 2] | 0;
         i2 = HEAP32[i1 + 60 >> 2] | 0;
         i196 = i2 + 4 | 0;
         i195 = HEAP32[i196 >> 2] | 0;
         HEAP32[i196 >> 2] = ((i195 | 0) < 0 ? 0 : i195) + 1;
         if (!i67) {
          i196 = i2 + 8 | 0;
          i195 = HEAP32[i196 >> 2] | 0;
          HEAP32[i196 >> 2] = ((i195 | 0) < 0 ? 0 : i195) + 1;
         }
         i3 = HEAP32[i157 >> 2] | 0;
         i24 = i3 + (i28 << 4) + 8 | 0;
         do if (i64) {
          if (!(__ZN5Umbra9RasterOps15rasterizePortalERNS_17BlockRasterBufferERKNS_8Vector4iERKNS_5VQuadERKNS_11AxisNormalsERKS1_(i24, i154, i120, i155 + 2368 + (i65 * 48 | 0) | 0, i3 + (i78 << 4) + 8 | 0) | 0)) {
           i79 = 96;
           break;
          }
          i1 = HEAP32[i155 >> 2] | 0;
         } else {
          i12 = HEAPU8[i3 + (i78 << 4) + 8 >> 0] | 0;
          i2 = HEAP8[i3 + (i78 << 4) + 9 >> 0] | 0;
          i196 = HEAP8[i3 + (i78 << 4) + 11 >> 0] | 0;
          i14 = i196 & 255;
          if ((i2 & 255) >= (i196 & 255)) {
           i79 = 96;
           break;
          }
          i21 = HEAPU8[i3 + (i28 << 4) + 10 >> 0] | 0;
          i22 = HEAP32[i3 + (i28 << 4) + 12 >> 2] | 0;
          i23 = (HEAPU8[i3 + (i78 << 4) + 10 >> 0] | 0) - i12 | 0;
          i10 = 0;
          i11 = i2 & 255;
          i8 = HEAP32[i3 + (i78 << 4) + 12 >> 2] | 0;
          while (1) {
           i9 = HEAP16[i24 >> 1] | 0;
           i6 = i9 & 255;
           i3 = i23;
           i6 = i22 + (i12 - i6 + (Math_imul(i11 - ((i9 & 65535) >>> 8 & 65535) | 0, i21 - i6 | 0) | 0) << 2) | 0;
           i9 = i8;
           i2 = i10;
           while (1) {
            i195 = HEAP32[i6 >> 2] | 0;
            i196 = HEAP32[i9 >> 2] | i195;
            i2 = i196 ^ i195 | i2;
            HEAP32[i6 >> 2] = i196;
            i3 = i3 + -1 | 0;
            if (!i3) break; else {
             i6 = i6 + 4 | 0;
             i9 = i9 + 4 | 0;
            }
           }
           i11 = i11 + 1 | 0;
           if ((i11 | 0) == (i14 | 0)) break; else {
            i10 = i2;
            i8 = i8 + (i23 << 2) | 0;
           }
          }
          if (!i2) i79 = 96;
         } while (0);
         if ((i79 | 0) == 96) {
          i79 = 0;
          if (HEAP32[i142 >> 2] | 0) break;
          i196 = HEAP32[i157 >> 2] | 0;
          i195 = i196 + (i28 << 4) + 8 | 0;
          __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i140 >> 2] | 0, i195);
          HEAP8[i195 >> 0] = 0;
          HEAP8[i195 + 1 >> 0] = 0;
          HEAP8[i195 + 2 >> 0] = 0;
          HEAP8[i195 + 3 >> 0] = 0;
          HEAP32[i196 + (i28 << 4) + 12 >> 2] = 0;
          HEAP16[i153 + (i28 << 4) >> 1] = HEAP16[i156 >> 1] | 0;
          HEAP16[i156 >> 1] = i29;
          break;
         }
         if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0)) {
          i79 = 101;
          break;
         }
         if (!(HEAP32[i1 + 32 >> 2] & 32)) {
          i79 = 101;
          break;
         }
         __ZNK5Umbra12PortalCuller15visualizePortalERKNS_6PortalEbb(i155, i68, i67 ^ 1, i66);
         i79 = 101;
        } else i79 = 101; while (0);
        L146 : do if ((i79 | 0) == 101) {
         i79 = 0;
         switch (HEAP32[i142 >> 2] | 0) {
         case 2:
          break L146;
         case 1:
          {
           i1 = (HEAP32[(HEAP32[i155 >> 2] | 0) + 60 >> 2] | 0) + 24 | 0;
           i196 = HEAP32[i1 >> 2] | 0;
           HEAP32[i1 >> 2] = ((i196 | 0) < 0 ? 0 : i196) + 1;
           i1 = HEAP16[i102 >> 1] | 0;
           if (i1 << 16 >> 16 == i29 << 16 >> 16) i1 = i102; else {
            i2 = i1;
            do {
             i1 = i153 + ((i2 & 65535) << 4) | 0;
             i2 = HEAP16[i1 >> 1] | 0;
            } while (i2 << 16 >> 16 != i29 << 16 >> 16);
           }
           HEAP16[i1 >> 1] = HEAP16[i153 + (i28 << 4) >> 1] | 0;
           break;
          }
         default:
          {}
         }
         i1 = HEAP32[i157 >> 2] | 0;
         if (i67) {
          HEAP16[i155 + 2936 + (HEAPU16[i1 + (i28 << 4) + 4 >> 1] << 1) >> 1] = i28 | 32768;
          HEAP32[i145 >> 2] = (HEAP32[i145 >> 2] | 0) + 1;
          i195 = HEAP32[i99 >> 2] | 0;
          i196 = i195 + 2 | 0;
          HEAP16[i195 + (i28 << 4) + 2 >> 1] = HEAP16[i196 >> 1] | 0;
          HEAP16[i195 + (i28 << 4) >> 1] = 0;
          HEAP16[i195 + (HEAPU16[i196 >> 1] << 4) >> 1] = i29;
          HEAP16[i196 >> 1] = i29;
          break;
         }
         i196 = (HEAP32[i146 >> 2] | 0) + (HEAP32[i131 >> 2] << 1) | 0;
         HEAP16[i1 + (i28 << 4) >> 1] = HEAP16[i196 >> 1] | 0;
         HEAP16[i196 >> 1] = i29;
         i1 = HEAP32[i147 >> 2] | 0;
         if (i1 | 0) {
          i2 = HEAP32[i146 >> 2] | 0;
          do {
           i1 = i1 + -1 | 0;
           i196 = i2 + (HEAPU16[i155 + 2128 + (i1 << 2) >> 1] << 1) | 0;
           HEAP16[i196 >> 1] = HEAPU16[i196 >> 1] | 16384;
          } while ((i1 | 0) != 0);
         }
        } while (0);
       }
      }
      if ((i71 | 0) == (1 - i69 | 0)) break; else {
       i1 = i70;
       i3 = i71;
       i2 = i72;
      }
     }
    } while (0);
    HEAP16[i153 + (i78 << 4) >> 1] = HEAP16[i102 >> 1] | 0;
    HEAP16[i102 >> 1] = i77;
    HEAP16[i155 + 2936 + (HEAPU16[(HEAP32[i157 >> 2] | 0) + (i78 << 4) + 4 >> 1] << 1) >> 1] = i78 | 16384;
    i1 = HEAP32[i155 >> 2] | 0;
    i196 = (HEAP32[i1 + 60 >> 2] | 0) + 12 | 0;
    i195 = HEAP32[i196 >> 2] | 0;
    HEAP32[i196 >> 2] = ((i195 | 0) < 0 ? 0 : i195) + 1;
    if ((HEAP32[i95 >> 2] | 0) < 0) break L4;
   }
   i1 = HEAP16[i102 >> 1] | 0;
   if (i1 << 16 >> 16) do {
    i196 = i1 & 65535;
    i195 = i153 + (i196 << 4) | 0;
    HEAP16[i102 >> 1] = HEAP16[i195 >> 1] | 0;
    __ZN5Umbra12PortalCuller12finalizeCellEt(i155, i1);
    i194 = HEAP32[i157 >> 2] | 0;
    i193 = i194 + (i196 << 4) + 8 | 0;
    __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i140 >> 2] | 0, i193);
    HEAP8[i193 >> 0] = 0;
    HEAP8[i193 + 1 >> 0] = 0;
    HEAP8[i193 + 2 >> 0] = 0;
    HEAP8[i193 + 3 >> 0] = 0;
    HEAP32[i194 + (i196 << 4) + 12 >> 2] = 0;
    HEAP16[i195 >> 1] = HEAP16[i156 >> 1] | 0;
    HEAP16[i156 >> 1] = i1;
    HEAP16[i155 + 2936 + (HEAPU16[(HEAP32[i157 >> 2] | 0) + (i196 << 4) + 4 >> 1] << 1) >> 1] = i1;
    i1 = HEAP16[i102 >> 1] | 0;
   } while (i1 << 16 >> 16 != 0);
   HEAP32[(HEAP32[i140 >> 2] | 0) + 136 >> 2] = 1024;
   i196 = __ZN5Umbra16TileTraverseTree4nextERi(i94, i93) | 0;
   HEAP32[i109 >> 2] = i196;
   if (!i196) break L1;
  }
  if ((i79 | 0) == 5) i1 = HEAP32[i155 >> 2] | 0;
  HEAP32[i1 + 28 >> 2] = 2;
  STACKTOP = i158;
  return;
 } while (0);
 i14 = i155 + 7030 | 0;
 if (HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0) {
  i1 = HEAPU16[i14 >> 1] | 0;
  i2 = HEAP32[i157 >> 2] | 0;
  L177 : do if (HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) {
   __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf(i2 + (i1 << 4) + 8 | 0, i155 + 352 | 0, Math_fround(1.0));
   if (HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0) {
    f165 = Math_fround(HEAPF32[i155 + 400 >> 2]);
    HEAPF32[i154 >> 2] = f165;
    i11 = i155 + 360 | 0;
    i12 = Math_fround(HEAPF32[i11 >> 2]) >= f165;
    HEAP32[i11 >> 2] = HEAP32[(i12 ? i11 : i154) >> 2];
    i11 = HEAPU8[i155 + 344 >> 0] | 0;
    i12 = HEAPU8[i155 + 345 >> 0] | 0;
    i1 = i12 << 10;
    i2 = (HEAP32[i155 + 356 >> 2] | 0) + i1 | 0;
    i12 = (HEAPU8[i155 + 347 >> 0] | 0) - i12 << 10;
    i9 = i12 + i2 | 0;
    i10 = i11 << 7;
    i11 = (HEAPU8[i155 + 346 >> 0] | 0) - i11 + -1 | 0;
    i1 = (HEAP32[i155 + 396 >> 2] | 0) + i1 | 0;
    i12 = i1 + i12 | 0;
    i3 = (i11 | 0) == 0;
    if (!(i3 & i2 >>> 0 >= i9 >>> 0)) {
     i7 = i1 + i10 | 0;
     i5 = i2 + i10 | 0;
     i6 = i11;
     i4 = i11;
     while (1) {
      while (1) {
       i196 = i5;
       i192 = i7;
       f165 = Math_fround(HEAPF32[i196 >> 2]);
       f164 = Math_fround(HEAPF32[i192 >> 2]);
       i195 = i196 + 4 | 0;
       f163 = Math_fround(HEAPF32[i195 >> 2]);
       f162 = Math_fround(HEAPF32[i192 + 4 >> 2]);
       i194 = i196 + 8 | 0;
       f161 = Math_fround(HEAPF32[i194 >> 2]);
       f160 = Math_fround(HEAPF32[i192 + 8 >> 2]);
       i193 = i196 + 12 | 0;
       f159 = Math_fround(HEAPF32[i193 >> 2]);
       f63 = Math_fround(HEAPF32[i192 + 12 >> 2]);
       HEAPF32[i196 >> 2] = f165 <= f164 ? f165 : f164;
       HEAPF32[i195 >> 2] = f163 <= f162 ? f163 : f162;
       HEAPF32[i194 >> 2] = f161 <= f160 ? f161 : f160;
       HEAPF32[i193 >> 2] = f159 <= f63 ? f159 : f63;
       i193 = i196 + 16 | 0;
       f63 = Math_fround(HEAPF32[i193 >> 2]);
       f159 = Math_fround(HEAPF32[i192 + 16 >> 2]);
       i194 = i196 + 20 | 0;
       f160 = Math_fround(HEAPF32[i194 >> 2]);
       f161 = Math_fround(HEAPF32[i192 + 20 >> 2]);
       i195 = i196 + 24 | 0;
       f162 = Math_fround(HEAPF32[i195 >> 2]);
       f163 = Math_fround(HEAPF32[i192 + 24 >> 2]);
       i191 = i196 + 28 | 0;
       f164 = Math_fround(HEAPF32[i191 >> 2]);
       f165 = Math_fround(HEAPF32[i192 + 28 >> 2]);
       HEAPF32[i193 >> 2] = f63 <= f159 ? f63 : f159;
       HEAPF32[i194 >> 2] = f160 <= f161 ? f160 : f161;
       HEAPF32[i195 >> 2] = f162 <= f163 ? f162 : f163;
       HEAPF32[i191 >> 2] = f164 <= f165 ? f164 : f165;
       i191 = i196 + 32 | 0;
       f165 = Math_fround(HEAPF32[i191 >> 2]);
       f164 = Math_fround(HEAPF32[i192 + 32 >> 2]);
       i195 = i196 + 36 | 0;
       f163 = Math_fround(HEAPF32[i195 >> 2]);
       f162 = Math_fround(HEAPF32[i192 + 36 >> 2]);
       i194 = i196 + 40 | 0;
       f161 = Math_fround(HEAPF32[i194 >> 2]);
       f160 = Math_fround(HEAPF32[i192 + 40 >> 2]);
       i193 = i196 + 44 | 0;
       f159 = Math_fround(HEAPF32[i193 >> 2]);
       f63 = Math_fround(HEAPF32[i192 + 44 >> 2]);
       HEAPF32[i191 >> 2] = f165 <= f164 ? f165 : f164;
       HEAPF32[i195 >> 2] = f163 <= f162 ? f163 : f162;
       HEAPF32[i194 >> 2] = f161 <= f160 ? f161 : f160;
       HEAPF32[i193 >> 2] = f159 <= f63 ? f159 : f63;
       i193 = i196 + 48 | 0;
       f63 = Math_fround(HEAPF32[i193 >> 2]);
       f159 = Math_fround(HEAPF32[i192 + 48 >> 2]);
       i194 = i196 + 52 | 0;
       f160 = Math_fround(HEAPF32[i194 >> 2]);
       f161 = Math_fround(HEAPF32[i192 + 52 >> 2]);
       i195 = i196 + 56 | 0;
       f162 = Math_fround(HEAPF32[i195 >> 2]);
       f163 = Math_fround(HEAPF32[i192 + 56 >> 2]);
       i191 = i196 + 60 | 0;
       f164 = Math_fround(HEAPF32[i191 >> 2]);
       f165 = Math_fround(HEAPF32[i192 + 60 >> 2]);
       HEAPF32[i193 >> 2] = f63 <= f159 ? f63 : f159;
       HEAPF32[i194 >> 2] = f160 <= f161 ? f160 : f161;
       HEAPF32[i195 >> 2] = f162 <= f163 ? f162 : f163;
       HEAPF32[i191 >> 2] = f164 <= f165 ? f164 : f165;
       i191 = i196 + 64 | 0;
       f165 = Math_fround(HEAPF32[i191 >> 2]);
       f164 = Math_fround(HEAPF32[i192 + 64 >> 2]);
       i195 = i196 + 68 | 0;
       f163 = Math_fround(HEAPF32[i195 >> 2]);
       f162 = Math_fround(HEAPF32[i192 + 68 >> 2]);
       i194 = i196 + 72 | 0;
       f161 = Math_fround(HEAPF32[i194 >> 2]);
       f160 = Math_fround(HEAPF32[i192 + 72 >> 2]);
       i193 = i196 + 76 | 0;
       f159 = Math_fround(HEAPF32[i193 >> 2]);
       f63 = Math_fround(HEAPF32[i192 + 76 >> 2]);
       HEAPF32[i191 >> 2] = f165 <= f164 ? f165 : f164;
       HEAPF32[i195 >> 2] = f163 <= f162 ? f163 : f162;
       HEAPF32[i194 >> 2] = f161 <= f160 ? f161 : f160;
       HEAPF32[i193 >> 2] = f159 <= f63 ? f159 : f63;
       i193 = i196 + 80 | 0;
       f63 = Math_fround(HEAPF32[i193 >> 2]);
       f159 = Math_fround(HEAPF32[i192 + 80 >> 2]);
       i194 = i196 + 84 | 0;
       f160 = Math_fround(HEAPF32[i194 >> 2]);
       f161 = Math_fround(HEAPF32[i192 + 84 >> 2]);
       i195 = i196 + 88 | 0;
       f162 = Math_fround(HEAPF32[i195 >> 2]);
       f163 = Math_fround(HEAPF32[i192 + 88 >> 2]);
       i191 = i196 + 92 | 0;
       f164 = Math_fround(HEAPF32[i191 >> 2]);
       f165 = Math_fround(HEAPF32[i192 + 92 >> 2]);
       HEAPF32[i193 >> 2] = f63 <= f159 ? f63 : f159;
       HEAPF32[i194 >> 2] = f160 <= f161 ? f160 : f161;
       HEAPF32[i195 >> 2] = f162 <= f163 ? f162 : f163;
       HEAPF32[i191 >> 2] = f164 <= f165 ? f164 : f165;
       i191 = i196 + 96 | 0;
       f165 = Math_fround(HEAPF32[i191 >> 2]);
       f164 = Math_fround(HEAPF32[i192 + 96 >> 2]);
       i195 = i196 + 100 | 0;
       f163 = Math_fround(HEAPF32[i195 >> 2]);
       f162 = Math_fround(HEAPF32[i192 + 100 >> 2]);
       i194 = i196 + 104 | 0;
       f161 = Math_fround(HEAPF32[i194 >> 2]);
       f160 = Math_fround(HEAPF32[i192 + 104 >> 2]);
       i193 = i196 + 108 | 0;
       f159 = Math_fround(HEAPF32[i193 >> 2]);
       f63 = Math_fround(HEAPF32[i192 + 108 >> 2]);
       HEAPF32[i191 >> 2] = f165 <= f164 ? f165 : f164;
       HEAPF32[i195 >> 2] = f163 <= f162 ? f163 : f162;
       HEAPF32[i194 >> 2] = f161 <= f160 ? f161 : f160;
       HEAPF32[i193 >> 2] = f159 <= f63 ? f159 : f63;
       i193 = i196 + 112 | 0;
       f63 = Math_fround(HEAPF32[i193 >> 2]);
       f159 = Math_fround(HEAPF32[i192 + 112 >> 2]);
       i194 = i196 + 116 | 0;
       f160 = Math_fround(HEAPF32[i194 >> 2]);
       f161 = Math_fround(HEAPF32[i192 + 116 >> 2]);
       i195 = i196 + 120 | 0;
       f162 = Math_fround(HEAPF32[i195 >> 2]);
       f163 = Math_fround(HEAPF32[i192 + 120 >> 2]);
       i196 = i196 + 124 | 0;
       f164 = Math_fround(HEAPF32[i196 >> 2]);
       f165 = Math_fround(HEAPF32[i192 + 124 >> 2]);
       HEAPF32[i193 >> 2] = f63 <= f159 ? f63 : f159;
       HEAPF32[i194 >> 2] = f160 <= f161 ? f160 : f161;
       HEAPF32[i195 >> 2] = f162 <= f163 ? f162 : f163;
       HEAPF32[i196 >> 2] = f164 <= f165 ? f164 : f165;
       if (i3) {
        i2 = i2 + 1024 | 0;
        i8 = i2 >>> 0 < i9 >>> 0;
        i5 = i8 ? i2 + i10 | 0 : i5;
        i8 = i8 ? i11 : 0;
       } else {
        i5 = i5 + 128 | 0;
        i8 = i4 + -1 | 0;
       }
       if (!i6) break;
       i3 = (i8 | 0) == 0;
       if (i3 & i2 >>> 0 >= i9 >>> 0) break L177; else {
        i7 = i7 + 128 | 0;
        i6 = i6 + -1 | 0;
        i4 = i8;
       }
      }
      i1 = i1 + 1024 | 0;
      i4 = i1 >>> 0 < i12 >>> 0;
      i3 = (i8 | 0) == 0;
      if (i3 & i2 >>> 0 >= i9 >>> 0) break; else {
       i7 = i4 ? i1 + i10 | 0 : i7;
       i6 = i4 ? i11 : 0;
       i4 = i8;
      }
     }
    }
   }
  } while (0);
  HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0) + 1416 >> 2] = HEAP32[i155 + 360 >> 2];
 }
 i196 = HEAPU16[i14 >> 1] | 0;
 i195 = HEAP32[i157 >> 2] | 0;
 i194 = i195 + (i196 << 4) + 8 | 0;
 __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i155 + 292 >> 2] | 0, i194);
 HEAP8[i194 >> 0] = 0;
 HEAP8[i194 + 1 >> 0] = 0;
 HEAP8[i194 + 2 >> 0] = 0;
 HEAP8[i194 + 3 >> 0] = 0;
 HEAP32[i195 + (i196 << 4) + 12 >> 2] = 0;
 i196 = HEAP16[i14 >> 1] | 0;
 HEAP16[(HEAP32[i157 >> 2] | 0) + ((i196 & 65535) << 4) >> 1] = HEAP16[i156 >> 1] | 0;
 HEAP16[i156 >> 1] = i196;
 STACKTOP = i158;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_118parse_builtin_typeINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i34) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i36 + 568 | 0;
 i33 = i36 + 544 | 0;
 i25 = i36 + 520 | 0;
 i26 = i36 + 500 | 0;
 i27 = i36 + 480 | 0;
 i28 = i36 + 460 | 0;
 i29 = i36 + 440 | 0;
 i24 = i36 + 420 | 0;
 i6 = i36 + 400 | 0;
 i7 = i36 + 380 | 0;
 i8 = i36 + 360 | 0;
 i30 = i36 + 340 | 0;
 i9 = i36 + 320 | 0;
 i10 = i36 + 300 | 0;
 i11 = i36 + 280 | 0;
 i32 = i36 + 260 | 0;
 i12 = i36 + 240 | 0;
 i13 = i36 + 220 | 0;
 i14 = i36 + 200 | 0;
 i15 = i36 + 180 | 0;
 i16 = i36 + 160 | 0;
 i17 = i36 + 140 | 0;
 i18 = i36 + 120 | 0;
 i19 = i36 + 100 | 0;
 i20 = i36 + 80 | 0;
 i21 = i36 + 60 | 0;
 i22 = i36 + 40 | 0;
 i31 = i36 + 20 | 0;
 i23 = i36;
 L1 : do if ((i1 | 0) != (i3 | 0)) {
  L3 : do switch (HEAP8[i1 >> 0] | 0) {
  case 118:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i35, gb + 1087820 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i23, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i23 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i23);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i23);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 119:
   {
    HEAP32[i35 >> 2] = 0;
    HEAP32[i35 + 4 >> 2] = 0;
    HEAP32[i35 + 8 >> 2] = 0;
    HEAP8[i35 + 11 >> 0] = 7;
    HEAP8[i35 >> 0] = HEAP8[gb + 1087433 >> 0] | 0;
    HEAP8[i35 + 1 >> 0] = HEAP8[gb + 1087433 + 1 >> 0] | 0;
    HEAP8[i35 + 2 >> 0] = HEAP8[gb + 1087433 + 2 >> 0] | 0;
    HEAP8[i35 + 3 >> 0] = HEAP8[gb + 1087433 + 3 >> 0] | 0;
    HEAP8[i35 + 4 >> 0] = HEAP8[gb + 1087433 + 4 >> 0] | 0;
    HEAP8[i35 + 5 >> 0] = HEAP8[gb + 1087433 + 5 >> 0] | 0;
    HEAP8[i35 + 6 >> 0] = HEAP8[gb + 1087433 + 6 >> 0] | 0;
    HEAP8[i35 + 7 >> 0] = 0;
    i3 = i35 + 12 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i31, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i31 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i31);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i31);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 98:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i35, gb + 1087825 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i22, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i22 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i22);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i22);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 99:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i35, gb + 1087452 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i21, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i21 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i21);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i21);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 97:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i35, gb + 1087457 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i20, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i20 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i20);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i20);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 104:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc(i35, gb + 1087469 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i19, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i19 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i19);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i19);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 115:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc(i35, gb + 1087483 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i18, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i18 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i18);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i18);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 116:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc(i35, gb + 1087489 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i17, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i17 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i17);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i17);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 105:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj4EEERAT__Kc(i35, gb + 1087830 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i16, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i16 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i16);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i16);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 106:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc(i35, gb + 1087834 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i15 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i15);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 108:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i35, gb + 1087847 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i14, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i14 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i14);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i14);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 109:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc(i35, gb + 1087852 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i13, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i13 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i13);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i13);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 120:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i35, gb + 1087866 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i12, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i12 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i12);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i12);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 121:
   {
    i2 = _malloc(32) | 0;
    HEAP32[i35 >> 2] = i2;
    HEAP32[i35 + 8 >> 2] = -2147483616;
    HEAP32[i35 + 4 >> 2] = 18;
    i3 = i2;
    i4 = gb + 1087876 | 0;
    i5 = i3 + 18 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i3 | 0) < (i5 | 0));
    HEAP8[i2 + 18 >> 0] = 0;
    i3 = i35 + 12 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i31 = (i5 - i4 | 0) / 24 | 0;
      i33 = i31 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i32, i31 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i32 + 8 | 0;
      i31 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i31, i35);
      HEAP32[i33 >> 2] = i31 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i32);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i32);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 110:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc(i35, gb + 1087516 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i11, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i11 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i11);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 111:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc(i35, gb + 1087525 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i10, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i10 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i10);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i10);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 102:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc(i35, gb + 1087895 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i9 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i9);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 100:
   {
    HEAP32[i35 >> 2] = 0;
    HEAP32[i35 + 4 >> 2] = 0;
    HEAP32[i35 + 8 >> 2] = 0;
    HEAP8[i35 + 11 >> 0] = 6;
    HEAP8[i35 >> 0] = HEAP8[gb + 1087901 >> 0] | 0;
    HEAP8[i35 + 1 >> 0] = HEAP8[gb + 1087901 + 1 >> 0] | 0;
    HEAP8[i35 + 2 >> 0] = HEAP8[gb + 1087901 + 2 >> 0] | 0;
    HEAP8[i35 + 3 >> 0] = HEAP8[gb + 1087901 + 3 >> 0] | 0;
    HEAP8[i35 + 4 >> 0] = HEAP8[gb + 1087901 + 4 >> 0] | 0;
    HEAP8[i35 + 5 >> 0] = HEAP8[gb + 1087901 + 5 >> 0] | 0;
    HEAP8[i35 + 6 >> 0] = 0;
    i3 = i35 + 12 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i30, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i30 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i30);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i30);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 101:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i35, gb + 1087908 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i8, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i8 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i8);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i8);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 103:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i35, gb + 1087920 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i7, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i7 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i7);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i7);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 122:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj4EEERAT__Kc(i35, gb + 1087931 | 0);
    i2 = i34 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i33 = HEAP32[i34 + 8 >> 2] | 0;
    i5 = i33;
    do if (i3 >>> 0 < i33 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i34 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i34 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      break L3;
     } else {
      i32 = (i5 - i4 | 0) / 24 | 0;
      i33 = i32 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i6, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
      i33 = i6 + 8 | 0;
      i32 = HEAP32[i33 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
      HEAP32[i33 >> 2] = i32 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i6);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i6);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
    i1 = i1 + 1 | 0;
    break L1;
   }
  case 117:
   {
    i33 = i1 + 1 | 0;
    i35 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i33, i3, i34) | 0;
    i1 = (i35 | 0) == (i33 | 0) ? i1 : i35;
    break L1;
   }
  case 68:
   {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break L1;
    switch (HEAP8[i2 >> 0] | 0) {
    case 100:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i35, gb + 1087935 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i24, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i24 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i24);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i24);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 101:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i35, gb + 1087945 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i29, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i29 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i29);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i29);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 102:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i35, gb + 1087956 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i28, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i28 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i28);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i28);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 104:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i35, gb + 1087966 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i27, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i27 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i27);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i27);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 105:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc(i35, gb + 1087976 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i26, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i26 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i26);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i26);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 115:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc(i35, gb + 1087985 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i33 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i33;
      do if (i3 >>> 0 < i33 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i32 = (i5 - i4 | 0) / 24 | 0;
        i33 = i32 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i25, i32 >>> 0 < 89478485 ? (i33 >>> 0 < i3 >>> 0 ? i3 : i33) : 178956970, i2, i34 + 12 | 0);
        i33 = i25 + 8 | 0;
        i32 = HEAP32[i33 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i32, i35);
        HEAP32[i33 >> 2] = i32 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i25);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i25);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 97:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i35, gb + 1087994 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i32 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i32;
      do if (i3 >>> 0 < i32 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i35);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
        break L3;
       } else {
        i31 = (i5 - i4 | 0) / 24 | 0;
        i32 = i31 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i33, i31 >>> 0 < 89478485 ? (i32 >>> 0 < i3 >>> 0 ? i3 : i32) : 178956970, i2, i34 + 12 | 0);
        i32 = i33 + 8 | 0;
        i31 = HEAP32[i32 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i31, i35);
        HEAP32[i32 >> 2] = i31 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i33);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i33);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i35);
      i1 = i1 + 2 | 0;
      break L1;
     }
    case 110:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc(i33, gb + 1087999 | 0);
      i2 = i34 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i32 = HEAP32[i34 + 8 >> 2] | 0;
      i5 = i32;
      do if (i3 >>> 0 < i32 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i33);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i34 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i34 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
        break L3;
       } else {
        i31 = (i5 - i4 | 0) / 24 | 0;
        i32 = i31 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i35, i31 >>> 0 < 89478485 ? (i32 >>> 0 < i3 >>> 0 ? i3 : i32) : 178956970, i2, i34 + 12 | 0);
        i32 = i35 + 8 | 0;
        i31 = HEAP32[i32 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i31, i33);
        HEAP32[i32 >> 2] = i31 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i34, i35);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i35);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i33);
      i1 = i1 + 2 | 0;
      break L1;
     }
    default:
     break L1;
    }
   }
  default:
   break L1;
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i36;
 return i1 | 0;
}

function __ZN13AnimationClip8SetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfEbb(i23, i16, i13, i14, i20, i19, i1, i22) {
 i23 = i23 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i17 = 0, i18 = 0, i21 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i18 = i25 + 16 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 116 >> 2] | 0, i23 | 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 907347 | 0, 0, gb + 899654 | 0, 1032, 1, 0, 0, 0);
  STACKTOP = i25;
  return;
 }
 i24 = __Z20push_allocation_rootPvP13BaseAllocatorb(i23, 0, 0) | 0;
 L5 : do if ((i13 | 0) == -1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 907421 | 0, 0, gb + 899654 | 0, 1048, 1, 0, 0, 0); else {
  L8 : do if (__ZN11UnityEngine9Animation15IsTransformTypeEi(i13) | 0) {
   i9 = i20 + 11 | 0;
   if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 896768 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 907490 | 0) | 0)) {
    i17 = 70;
    break;
   }
   i8 = i23 + 100 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i10 = i23 + 104 | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   L13 : do if ((i3 | 0) != (i7 | 0)) {
    i5 = HEAP8[i16 + 11 >> 0] | 0;
    i6 = i5 << 24 >> 24 < 0;
    i5 = i6 ? HEAP32[i16 + 4 >> 2] | 0 : i5 & 255;
    i6 = i6 ? HEAP32[i16 >> 2] | 0 : i16;
    while (1) {
     i4 = HEAP8[i3 + 11 >> 0] | 0;
     i1 = i4 << 24 >> 24 < 0;
     if (i1) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i4 & 255;
     if ((i2 | 0) == (i5 | 0)) {
      if (i1) {
       i2 = HEAP32[i3 >> 2] | 0;
       i1 = HEAP32[i3 + 4 >> 2] | 0;
      } else {
       i2 = i3;
       i1 = i4 & 255;
      }
      if (!(_strncmp(i2, i6, i1) | 0)) break L13;
     }
     i3 = i3 + 204 | 0;
     if ((i3 | 0) == (i7 | 0)) {
      i3 = i7;
      break;
     }
    }
   } while (0);
   if (!i19) {
    i2 = HEAP8[i9 >> 0] | 0;
    i4 = i20 + 4 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 15) {
     if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 896768 | 0, 15) | 0) {
      i2 = HEAP8[i9 >> 0] | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      i17 = 23;
     }
    } else i17 = 23;
    do if ((i17 | 0) == 23) {
     if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 13) {
      if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 907490 | 0, 13) | 0)) break;
      i2 = HEAP8[i9 >> 0] | 0;
      i1 = HEAP32[i4 >> 2] | 0;
     };
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     i23 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907504 | 0, 49, i23 + 49 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i23) | 0;
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     i23 = HEAP8[i18 + 11 >> 0] | 0;
     i22 = i23 << 24 >> 24 < 0;
     i23 = i22 ? HEAP32[i18 + 4 >> 2] | 0 : i23 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i22 ? HEAP32[i18 >> 2] | 0 : i18, i23, i23 + 65 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907554 | 0, 65) | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1079, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
     break L5;
    } while (0);
    i1 = HEAP32[i10 >> 2] | 0;
    if ((i3 | 0) == (i1 | 0)) break L5;
    i2 = i3 + 204 | 0;
    if ((i2 | 0) == (i1 | 0)) i17 = 30; else {
     do {
      __ZN13AnimationClip15QuaternionCurveaSERKS0_(i3, i2) | 0;
      i2 = i2 + 204 | 0;
      i3 = i3 + 204 | 0;
     } while ((i2 | 0) != (i1 | 0));
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) != (i3 | 0)) i17 = 30;
    }
    if ((i17 | 0) == 30) {
     i5 = i21 + 4 | 0;
     do {
      i2 = i1 + -204 | 0;
      HEAP32[i10 >> 2] = i2;
      i4 = i1 + -36 | 0;
      if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
       HEAP32[i4 >> 2] = 0;
      }
      if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
       i20 = HEAP32[i2 >> 2] | 0;
       i19 = HEAP32[i1 + -192 >> 2] | 0;
       HEAP32[i21 >> 2] = 66;
       HEAP32[i5 >> 2] = i19;
       __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
      }
      i1 = HEAP32[i10 >> 2] | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    if (!i22) break L5;
    __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
    break L5;
   }
   if ((i3 | 0) == (i7 | 0)) {
    HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAPF32[i18 + 20 >> 2] = Math_fround(inf);
    HEAP32[i18 + 16 >> 2] = 0;
    i1 = i18 + 24 | 0;
    i4 = i1 + 68 | 0;
    do {
     HEAP32[i1 >> 2] = 0;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) < (i4 | 0));
    HEAPF32[i18 + 96 >> 2] = Math_fround(inf);
    HEAP32[i18 + 92 >> 2] = 0;
    HEAP32[i18 + 180 >> 2] = 0;
    i2 = i18 + 184 | 0;
    HEAP32[i2 >> 2] = 0;
    i3 = i18 + 172 | 0;
    i1 = i18 + 100 | 0;
    i4 = i1 + 72 | 0;
    do {
     HEAP32[i1 >> 2] = 0;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) < (i4 | 0));
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
    i14 = i21;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i1 = i3;
    HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i1 + 4 >> 2] = i15;
    HEAP32[i18 + 192 >> 2] = 2;
    HEAP32[i18 + 188 >> 2] = 2;
    HEAP32[i18 + 196 >> 2] = 4;
    HEAP32[i18 + 200 >> 2] = 0;
    i1 = HEAP32[i10 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i23 + 108 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i18); else {
     __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1, i18);
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 204;
    }
    i1 = i18 + 168 | 0;
    if ((HEAP32[i2 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
     i15 = HEAP32[i18 >> 2] | 0;
     i14 = HEAP32[i18 + 12 >> 2] | 0;
     HEAP32[i21 >> 2] = 66;
     HEAP32[i21 + 4 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i15, i21);
    }
    i6 = HEAP32[i10 >> 2] | 0;
    i1 = i6 + -204 | 0;
    i7 = HEAP8[i16 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i8 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
    i7 = i4 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i6 + -196 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    do if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i6 + -200 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
    } else {
     if (i3) i1 = HEAP32[i1 >> 2] | 0;
     if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
     HEAP8[i1 + i7 >> 0] = 0;
     if ((HEAP8[i4 >> 0] | 0) < 0) {
      HEAP32[i6 + -200 >> 2] = i7;
      break;
     } else {
      HEAP8[i4 >> 0] = i7;
      break;
     }
    } while (0);
    i1 = (HEAP32[i10 >> 2] | 0) + -188 | 0;
   } else i1 = i3 + 16 | 0;
   i2 = HEAP8[i9 >> 0] | 0;
   i16 = i2 << 24 >> 24 < 0;
   i2 = i16 ? HEAP32[i20 + 4 >> 2] | 0 : i2 & 255;
   switch (HEAP8[(i16 ? HEAP32[i20 >> 2] | 0 : i20) + (i2 + -1) >> 0] | 0) {
   case 120:
    {
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     HEAP32[i21 + 12 >> 2] = 0;
     __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 0, i1, i21);
     break L8;
    }
   case 121:
    {
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     HEAP32[i21 + 12 >> 2] = 0;
     __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 1, i1, i21);
     break L8;
    }
   case 122:
    {
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     HEAP32[i21 + 12 >> 2] = 0;
     __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 2, i1, i21);
     break L8;
    }
   case 119:
    {
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     HEAP32[i21 + 12 >> 2] = 0;
     __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 3, i1, i21);
     break L8;
    }
   default:
    {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907620 | 0, 27, i2 + 27 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i2) | 0;
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     i20 = HEAP8[i18 + 11 >> 0] | 0;
     i19 = i20 << 24 >> 24 < 0;
     i20 = i19 ? HEAP32[i18 + 4 >> 2] | 0 : i20 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i19 ? HEAP32[i18 >> 2] | 0 : i18, i20, i20 + 35 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907311 | 0, 35) | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1106, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
     break L8;
    }
   }
  } else i17 = 70; while (0);
  L100 : do if ((i17 | 0) == 70) {
   do if (__ZN11UnityEngine9Animation15IsTransformTypeEi(i13) | 0) {
    i9 = i20 + 11 | 0;
    if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 896784 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 907648 | 0) | 0)) break;
    i8 = i23 + 116 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i10 = i23 + 120 | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    L107 : do if ((i3 | 0) != (i7 | 0)) {
     i5 = HEAP8[i16 + 11 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     i5 = i6 ? HEAP32[i16 + 4 >> 2] | 0 : i5 & 255;
     i6 = i6 ? HEAP32[i16 >> 2] | 0 : i16;
     while (1) {
      i4 = HEAP8[i3 + 11 >> 0] | 0;
      i1 = i4 << 24 >> 24 < 0;
      if (i1) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i4 & 255;
      if ((i2 | 0) == (i5 | 0)) {
       if (i1) {
        i2 = HEAP32[i3 >> 2] | 0;
        i1 = HEAP32[i3 + 4 >> 2] | 0;
       } else {
        i2 = i3;
        i1 = i4 & 255;
       }
       if (!(_strncmp(i2, i6, i1) | 0)) break L107;
      }
      i3 = i3 + 172 | 0;
      if ((i3 | 0) == (i7 | 0)) {
       i3 = i7;
       break;
      }
     }
    } while (0);
    if (!i19) {
     i2 = HEAP8[i9 >> 0] | 0;
     i4 = i20 + 4 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 12) {
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 896784 | 0, 12) | 0) {
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       i17 = 88;
      }
     } else i17 = 88;
     do if ((i17 | 0) == 88) {
      if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 10) {
       if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 907648 | 0, 10) | 0)) break;
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
      };
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      i23 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907659 | 0, 49, i23 + 49 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i23) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i23 = HEAP8[i18 + 11 >> 0] | 0;
      i22 = i23 << 24 >> 24 < 0;
      i23 = i22 ? HEAP32[i18 + 4 >> 2] | 0 : i23 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i22 ? HEAP32[i18 >> 2] | 0 : i18, i23, i23 + 62 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907709 | 0, 62) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1134, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L5;
     } while (0);
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (i1 | 0)) break L5;
     i2 = i3 + 172 | 0;
     if ((i2 | 0) == (i1 | 0)) i17 = 95; else {
      do {
       __ZN13AnimationClip12Vector3CurveaSERKS0_(i3, i2) | 0;
       i2 = i2 + 172 | 0;
       i3 = i3 + 172 | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i10 >> 2] | 0;
      if ((i1 | 0) != (i3 | 0)) i17 = 95;
     }
     if ((i17 | 0) == 95) {
      i5 = i21 + 4 | 0;
      do {
       i2 = i1 + -172 | 0;
       HEAP32[i10 >> 2] = i2;
       i4 = i1 + -36 | 0;
       if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
        HEAP32[i4 >> 2] = 0;
       }
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
        i22 = HEAP32[i2 >> 2] | 0;
        i20 = HEAP32[i1 + -160 >> 2] | 0;
        HEAP32[i21 >> 2] = 66;
        HEAP32[i5 >> 2] = i20;
        __Z19free_alloc_internalPvRK10MemLabelId(i22, i21);
       }
       i1 = HEAP32[i10 >> 2] | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
     __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
     break L5;
    }
    if ((i3 | 0) == (i7 | 0)) {
     HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAPF32[i18 + 20 >> 2] = Math_fround(inf);
     HEAP32[i18 + 16 >> 2] = 0;
     i1 = i18 + 24 | 0;
     i4 = i1 + 52 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     HEAPF32[i18 + 80 >> 2] = Math_fround(inf);
     HEAP32[i18 + 76 >> 2] = 0;
     HEAP32[i18 + 148 >> 2] = 0;
     i2 = i18 + 152 | 0;
     HEAP32[i2 >> 2] = 0;
     i3 = i18 + 140 | 0;
     i1 = i18 + 84 | 0;
     i4 = i1 + 56 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
     i15 = i21;
     i17 = HEAP32[i15 + 4 >> 2] | 0;
     i1 = i3;
     HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i1 + 4 >> 2] = i17;
     HEAP32[i18 + 160 >> 2] = 2;
     HEAP32[i18 + 156 >> 2] = 2;
     HEAP32[i18 + 164 >> 2] = 4;
     HEAP32[i18 + 168 >> 2] = 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i23 + 124 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i18); else {
      __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i18);
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 172;
     }
     i1 = i18 + 136 | 0;
     if ((HEAP32[i2 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
      HEAP32[i1 >> 2] = 0;
     }
     if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
      i17 = HEAP32[i18 >> 2] | 0;
      i15 = HEAP32[i18 + 12 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i21 + 4 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i17, i21);
     }
     i6 = HEAP32[i10 >> 2] | 0;
     i1 = i6 + -172 | 0;
     i7 = HEAP8[i16 + 11 >> 0] | 0;
     i4 = i7 << 24 >> 24 < 0;
     i8 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
     i7 = i4 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
     i4 = i1 + 11 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
     i3 = i2 << 24 >> 24 < 0;
     if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     do if (i7 >>> 0 > i5 >>> 0) {
      if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
     } else {
      if (i3) i1 = HEAP32[i1 >> 2] | 0;
      if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
      HEAP8[i1 + i7 >> 0] = 0;
      if ((HEAP8[i4 >> 0] | 0) < 0) {
       HEAP32[i6 + -168 >> 2] = i7;
       break;
      } else {
       HEAP8[i4 >> 0] = i7;
       break;
      }
     } while (0);
     i1 = (HEAP32[i10 >> 2] | 0) + -156 | 0;
    } else i1 = i3 + 16 | 0;
    i2 = HEAP8[i9 >> 0] | 0;
    i17 = i2 << 24 >> 24 < 0;
    i2 = i17 ? HEAP32[i20 + 4 >> 2] | 0 : i2 & 255;
    switch (HEAP8[(i17 ? HEAP32[i20 >> 2] | 0 : i20) + (i2 + -1) >> 0] | 0) {
    case 120:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 0, i1, gb + 1162364 | 0);
      break L100;
     }
    case 121:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 1, i1, gb + 1162364 | 0);
      break L100;
     }
    case 122:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 2, i1, gb + 1162364 | 0);
      break L100;
     }
    default:
     {
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907620 | 0, 27, i2 + 27 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i2) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i20 = HEAP8[i18 + 11 >> 0] | 0;
      i19 = i20 << 24 >> 24 < 0;
      i20 = i19 ? HEAP32[i18 + 4 >> 2] | 0 : i20 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i19 ? HEAP32[i18 >> 2] | 0 : i18, i20, i20 + 35 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907311 | 0, 35) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1158, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L100;
     }
    }
   } while (0);
   do if ((i13 | 0) == 4) {
    i9 = i20 + 11 | 0;
    if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 896797 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 907772 | 0) | 0)) break;
    i8 = i23 + 132 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i10 = i23 + 136 | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    L198 : do if ((i3 | 0) != (i7 | 0)) {
     i5 = HEAP8[i16 + 11 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     i5 = i6 ? HEAP32[i16 + 4 >> 2] | 0 : i5 & 255;
     i6 = i6 ? HEAP32[i16 >> 2] | 0 : i16;
     while (1) {
      i4 = HEAP8[i3 + 11 >> 0] | 0;
      i1 = i4 << 24 >> 24 < 0;
      if (i1) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i4 & 255;
      if ((i2 | 0) == (i5 | 0)) {
       if (i1) {
        i2 = HEAP32[i3 >> 2] | 0;
        i1 = HEAP32[i3 + 4 >> 2] | 0;
       } else {
        i2 = i3;
        i1 = i4 & 255;
       }
       if (!(_strncmp(i2, i6, i1) | 0)) break L198;
      }
      i3 = i3 + 172 | 0;
      if ((i3 | 0) == (i7 | 0)) {
       i3 = i7;
       break;
      }
     }
    } while (0);
    if (!i19) {
     i2 = HEAP8[i9 >> 0] | 0;
     i4 = i20 + 4 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 15) {
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 896797 | 0, 15) | 0) {
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       i17 = 151;
      }
     } else i17 = 151;
     do if ((i17 | 0) == 151) {
      if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 13) {
       if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 907772 | 0, 13) | 0)) break;
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
      };
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      i23 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907786 | 0, 49, i23 + 49 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i23) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i23 = HEAP8[i18 + 11 >> 0] | 0;
      i22 = i23 << 24 >> 24 < 0;
      i23 = i22 ? HEAP32[i18 + 4 >> 2] | 0 : i23 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i22 ? HEAP32[i18 >> 2] | 0 : i18, i23, i23 + 65 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907836 | 0, 65) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1187, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L5;
     } while (0);
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (i1 | 0)) break L5;
     i2 = i3 + 172 | 0;
     if ((i2 | 0) == (i1 | 0)) i17 = 158; else {
      do {
       __ZN13AnimationClip12Vector3CurveaSERKS0_(i3, i2) | 0;
       i2 = i2 + 172 | 0;
       i3 = i3 + 172 | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i10 >> 2] | 0;
      if ((i1 | 0) != (i3 | 0)) i17 = 158;
     }
     if ((i17 | 0) == 158) {
      i5 = i21 + 4 | 0;
      do {
       i2 = i1 + -172 | 0;
       HEAP32[i10 >> 2] = i2;
       i4 = i1 + -36 | 0;
       if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
        HEAP32[i4 >> 2] = 0;
       }
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
        i20 = HEAP32[i2 >> 2] | 0;
        i19 = HEAP32[i1 + -160 >> 2] | 0;
        HEAP32[i21 >> 2] = 66;
        HEAP32[i5 >> 2] = i19;
        __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
       }
       i1 = HEAP32[i10 >> 2] | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
     if (!i22) break L5;
     __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
     break L5;
    }
    if ((i3 | 0) == (i7 | 0)) {
     HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAPF32[i18 + 20 >> 2] = Math_fround(inf);
     HEAP32[i18 + 16 >> 2] = 0;
     i1 = i18 + 24 | 0;
     i4 = i1 + 52 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     HEAPF32[i18 + 80 >> 2] = Math_fround(inf);
     HEAP32[i18 + 76 >> 2] = 0;
     HEAP32[i18 + 148 >> 2] = 0;
     i2 = i18 + 152 | 0;
     HEAP32[i2 >> 2] = 0;
     i3 = i18 + 140 | 0;
     i1 = i18 + 84 | 0;
     i4 = i1 + 56 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
     i15 = i21;
     i17 = HEAP32[i15 + 4 >> 2] | 0;
     i1 = i3;
     HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i1 + 4 >> 2] = i17;
     HEAP32[i18 + 160 >> 2] = 2;
     HEAP32[i18 + 156 >> 2] = 2;
     HEAP32[i18 + 164 >> 2] = 4;
     HEAP32[i18 + 168 >> 2] = 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i23 + 140 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i18); else {
      __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i18);
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 172;
     }
     i1 = i18 + 136 | 0;
     if ((HEAP32[i2 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
      HEAP32[i1 >> 2] = 0;
     }
     if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
      i17 = HEAP32[i18 >> 2] | 0;
      i15 = HEAP32[i18 + 12 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i21 + 4 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i17, i21);
     }
     i6 = HEAP32[i10 >> 2] | 0;
     i1 = i6 + -172 | 0;
     i7 = HEAP8[i16 + 11 >> 0] | 0;
     i4 = i7 << 24 >> 24 < 0;
     i8 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
     i7 = i4 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
     i4 = i1 + 11 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
     i3 = i2 << 24 >> 24 < 0;
     if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     do if (i7 >>> 0 > i5 >>> 0) {
      if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
     } else {
      if (i3) i1 = HEAP32[i1 >> 2] | 0;
      if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
      HEAP8[i1 + i7 >> 0] = 0;
      if ((HEAP8[i4 >> 0] | 0) < 0) {
       HEAP32[i6 + -168 >> 2] = i7;
       break;
      } else {
       HEAP8[i4 >> 0] = i7;
       break;
      }
     } while (0);
     i1 = (HEAP32[i10 >> 2] | 0) + -156 | 0;
    } else i1 = i3 + 16 | 0;
    i2 = HEAP8[i9 >> 0] | 0;
    i17 = i2 << 24 >> 24 < 0;
    i2 = i17 ? HEAP32[i20 + 4 >> 2] | 0 : i2 & 255;
    switch (HEAP8[(i17 ? HEAP32[i20 >> 2] | 0 : i20) + (i2 + -1) >> 0] | 0) {
    case 120:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 0, i1, gb + 1162364 | 0);
      break L100;
     }
    case 121:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 1, i1, gb + 1162364 | 0);
      break L100;
     }
    case 122:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 2, i1, gb + 1162364 | 0);
      break L100;
     }
    default:
     {
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907620 | 0, 27, i2 + 27 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i2) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i20 = HEAP8[i18 + 11 >> 0] | 0;
      i19 = i20 << 24 >> 24 < 0;
      i20 = i19 ? HEAP32[i18 + 4 >> 2] | 0 : i20 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i19 ? HEAP32[i18 >> 2] | 0 : i18, i20, i20 + 35 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907311 | 0, 35) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1211, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L100;
     }
    }
   } while (0);
   do if (__ZN11UnityEngine9Animation15IsTransformTypeEi(i13) | 0) {
    i9 = i20 + 11 | 0;
    if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 896813 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, gb + 907902 | 0) | 0)) break;
    i8 = i23 + 148 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i10 = i23 + 152 | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    L290 : do if ((i3 | 0) != (i7 | 0)) {
     i5 = HEAP8[i16 + 11 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     i5 = i6 ? HEAP32[i16 + 4 >> 2] | 0 : i5 & 255;
     i6 = i6 ? HEAP32[i16 >> 2] | 0 : i16;
     while (1) {
      i4 = HEAP8[i3 + 11 >> 0] | 0;
      i1 = i4 << 24 >> 24 < 0;
      if (i1) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i4 & 255;
      if ((i2 | 0) == (i5 | 0)) {
       if (i1) {
        i2 = HEAP32[i3 >> 2] | 0;
        i1 = HEAP32[i3 + 4 >> 2] | 0;
       } else {
        i2 = i3;
        i1 = i4 & 255;
       }
       if (!(_strncmp(i2, i6, i1) | 0)) break L290;
      }
      i3 = i3 + 172 | 0;
      if ((i3 | 0) == (i7 | 0)) {
       i3 = i7;
       break;
      }
     }
    } while (0);
    if (!i19) {
     i2 = HEAP8[i9 >> 0] | 0;
     i4 = i20 + 4 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 12) {
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 896813 | 0, 12) | 0) {
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       i17 = 215;
      }
     } else i17 = 215;
     do if ((i17 | 0) == 215) {
      if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 10) {
       if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i20, 0, -1, gb + 907902 | 0, 10) | 0)) break;
       i2 = HEAP8[i9 >> 0] | 0;
       i1 = HEAP32[i4 >> 2] | 0;
      };
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      i23 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907913 | 0, 46, i23 + 46 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i23) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i23 = HEAP8[i18 + 11 >> 0] | 0;
      i22 = i23 << 24 >> 24 < 0;
      i23 = i22 ? HEAP32[i18 + 4 >> 2] | 0 : i23 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i22 ? HEAP32[i18 >> 2] | 0 : i18, i23, i23 + 62 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907960 | 0, 62) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1240, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L5;
     } while (0);
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (i1 | 0)) break L5;
     i2 = i3 + 172 | 0;
     if ((i2 | 0) == (i1 | 0)) i17 = 222; else {
      do {
       __ZN13AnimationClip12Vector3CurveaSERKS0_(i3, i2) | 0;
       i2 = i2 + 172 | 0;
       i3 = i3 + 172 | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i10 >> 2] | 0;
      if ((i1 | 0) != (i3 | 0)) i17 = 222;
     }
     if ((i17 | 0) == 222) {
      i5 = i21 + 4 | 0;
      do {
       i2 = i1 + -172 | 0;
       HEAP32[i10 >> 2] = i2;
       i4 = i1 + -36 | 0;
       if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
        HEAP32[i4 >> 2] = 0;
       }
       if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
        i20 = HEAP32[i2 >> 2] | 0;
        i19 = HEAP32[i1 + -160 >> 2] | 0;
        HEAP32[i21 >> 2] = 66;
        HEAP32[i5 >> 2] = i19;
        __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
       }
       i1 = HEAP32[i10 >> 2] | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
     if (!i22) break L5;
     __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
     break L5;
    }
    if ((i3 | 0) == (i7 | 0)) {
     HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAPF32[i18 + 20 >> 2] = Math_fround(inf);
     HEAP32[i18 + 16 >> 2] = 0;
     i1 = i18 + 24 | 0;
     i4 = i1 + 52 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     HEAPF32[i18 + 80 >> 2] = Math_fround(inf);
     HEAP32[i18 + 76 >> 2] = 0;
     HEAP32[i18 + 148 >> 2] = 0;
     i2 = i18 + 152 | 0;
     HEAP32[i2 >> 2] = 0;
     i3 = i18 + 140 | 0;
     i1 = i18 + 84 | 0;
     i4 = i1 + 56 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i4 | 0));
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
     i15 = i21;
     i17 = HEAP32[i15 + 4 >> 2] | 0;
     i1 = i3;
     HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i1 + 4 >> 2] = i17;
     HEAP32[i18 + 160 >> 2] = 2;
     HEAP32[i18 + 156 >> 2] = 2;
     HEAP32[i18 + 164 >> 2] = 4;
     HEAP32[i18 + 168 >> 2] = 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i23 + 156 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i18); else {
      __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i18);
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 172;
     }
     i1 = i18 + 136 | 0;
     if ((HEAP32[i2 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
      HEAP32[i1 >> 2] = 0;
     }
     if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
      i17 = HEAP32[i18 >> 2] | 0;
      i15 = HEAP32[i18 + 12 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i21 + 4 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i17, i21);
     }
     i6 = HEAP32[i10 >> 2] | 0;
     i1 = i6 + -172 | 0;
     i7 = HEAP8[i16 + 11 >> 0] | 0;
     i4 = i7 << 24 >> 24 < 0;
     i8 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
     i7 = i4 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
     i4 = i1 + 11 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
     i3 = i2 << 24 >> 24 < 0;
     if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     do if (i7 >>> 0 > i5 >>> 0) {
      if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
     } else {
      if (i3) i1 = HEAP32[i1 >> 2] | 0;
      if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
      HEAP8[i1 + i7 >> 0] = 0;
      if ((HEAP8[i4 >> 0] | 0) < 0) {
       HEAP32[i6 + -168 >> 2] = i7;
       break;
      } else {
       HEAP8[i4 >> 0] = i7;
       break;
      }
     } while (0);
     i1 = (HEAP32[i10 >> 2] | 0) + -156 | 0;
    } else i1 = i3 + 16 | 0;
    i2 = HEAP8[i9 >> 0] | 0;
    i17 = i2 << 24 >> 24 < 0;
    i2 = i17 ? HEAP32[i20 + 4 >> 2] | 0 : i2 & 255;
    switch (HEAP8[(i17 ? HEAP32[i20 >> 2] | 0 : i20) + (i2 + -1) >> 0] | 0) {
    case 120:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 0, i1, gb + 62512 | 0);
      break L100;
     }
    case 121:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 1, i1, gb + 62512 | 0);
      break L100;
     }
    case 122:
     {
      __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i19, 2, i1, gb + 62512 | 0);
      break L100;
     }
    default:
     {
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = 0;
      HEAP32[i18 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, gb + 907620 | 0, 27, i2 + 27 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i2) | 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      i20 = HEAP8[i18 + 11 >> 0] | 0;
      i19 = i20 << 24 >> 24 < 0;
      i20 = i19 ? HEAP32[i18 + 4 >> 2] | 0 : i20 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i21, i19 ? HEAP32[i18 >> 2] | 0 : i18, i20, i20 + 35 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, gb + 907311 | 0, 35) | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 899654 | 0, 1264, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      break L100;
     }
    }
   } while (0);
   i12 = i23 + 164 | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i15 = i23 + 168 | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   L377 : do if ((i3 | 0) != (i1 | 0)) {
    i7 = HEAP8[i16 + 11 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i16 >> 2] | 0 : i16;
    i9 = HEAP8[i20 + 11 >> 0] | 0;
    i10 = i9 << 24 >> 24 < 0;
    i9 = i10 ? HEAP32[i20 + 4 >> 2] | 0 : i9 & 255;
    i10 = i10 ? HEAP32[i20 >> 2] | 0 : i20;
    i11 = HEAP32[i14 >> 2] | 0;
    while (1) {
     do if ((HEAP32[i3 + 32 >> 2] | 0) == (i13 | 0)) {
      i5 = HEAP8[i3 + 11 >> 0] | 0;
      i2 = i5 << 24 >> 24 < 0;
      if (i2) i4 = HEAP32[i3 + 4 >> 2] | 0; else i4 = i5 & 255;
      if ((i4 | 0) == (i7 | 0)) {
       if (i2) {
        i4 = HEAP32[i3 >> 2] | 0;
        i2 = HEAP32[i3 + 4 >> 2] | 0;
       } else {
        i4 = i3;
        i2 = i5 & 255;
       }
       if (!(_strncmp(i4, i8, i2) | 0)) {
        i4 = i3 + 16 | 0;
        i6 = HEAP8[i4 + 11 >> 0] | 0;
        i2 = i6 << 24 >> 24 < 0;
        if (i2) i5 = HEAP32[i3 + 20 >> 2] | 0; else i5 = i6 & 255;
        if ((i5 | 0) == (i9 | 0)) {
         if (i2) {
          i4 = HEAP32[i4 >> 2] | 0;
          i2 = HEAP32[i3 + 20 >> 2] | 0;
         } else i2 = i6 & 255;
         if (_strncmp(i4, i10, i2) | 0) break;
         if ((HEAP32[i3 + 36 >> 2] | 0) == (i11 | 0)) break L377;
        }
       }
      }
     } while (0);
     i3 = i3 + 132 | 0;
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
    }
   } while (0);
   i2 = (i3 | 0) != (i1 | 0);
   if (!i19) {
    if (!i2) break L5;
    i2 = i3 + 132 | 0;
    if ((i2 | 0) == (i1 | 0)) i17 = 287; else {
     do {
      __ZN13AnimationClip10FloatCurveaSERKS0_(i3, i2) | 0;
      i2 = i2 + 132 | 0;
      i3 = i3 + 132 | 0;
     } while ((i2 | 0) != (i1 | 0));
     i1 = HEAP32[i15 >> 2] | 0;
     if ((i1 | 0) != (i3 | 0)) i17 = 287;
    }
    if ((i17 | 0) == 287) {
     i5 = i21 + 4 | 0;
     i6 = i21 + 4 | 0;
     do {
      i4 = i1 + -132 | 0;
      HEAP32[i15 >> 2] = i4;
      i2 = i1 + -36 | 0;
      if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -32 | 0);
       HEAP32[i2 >> 2] = 0;
      }
      i2 = i1 + -116 | 0;
      if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
       i20 = HEAP32[i2 >> 2] | 0;
       i19 = HEAP32[i1 + -104 >> 2] | 0;
       HEAP32[i21 >> 2] = 66;
       HEAP32[i5 >> 2] = i19;
       __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
      }
      if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
       i20 = HEAP32[i4 >> 2] | 0;
       i19 = HEAP32[i1 + -120 >> 2] | 0;
       HEAP32[i21 >> 2] = 66;
       HEAP32[i6 >> 2] = i19;
       __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
      }
      i1 = HEAP32[i15 >> 2] | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    if (!i22) break L5;
    __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
    break L5;
   }
   if (i2) {
    i21 = i3 + 40 | 0;
    HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i21 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i21 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i21 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    HEAP32[i21 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
    i6 = i3 + 68 | 0;
    i20 = i19 + 28 | 0;
    HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
    i6 = i3 + 96 | 0;
    if ((i21 | 0) != (i19 | 0)) {
     i7 = HEAP32[i19 + 56 >> 2] | 0;
     i8 = i3 + 108 | 0;
     i1 = HEAP32[i19 + 68 >> 2] << 4;
     i2 = i1 >> 4;
     HEAP32[i8 >> 2] = i2;
     i4 = i3 + 112 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i2;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i3 + 100 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i6 >> 2] = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i3 + 100 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      HEAP32[i6 >> 2] = i1;
      break;
     } else i1 = HEAP32[i6 >> 2] | 0; while (0);
     _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
    }
    i21 = i3 + 116 | 0;
    i20 = i19 + 76 | 0;
    HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    break;
   }
   HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   i11 = i18 + 16 | 0;
   HEAP32[i18 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i18 + 36 >> 2] = 0;
   HEAPF32[i18 + 44 >> 2] = Math_fround(inf);
   HEAP32[i18 + 40 >> 2] = 0;
   i11 = i18 + 48 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAPF32[i18 + 72 >> 2] = Math_fround(inf);
   HEAP32[i18 + 68 >> 2] = 0;
   i11 = i18 + 76 | 0;
   HEAP32[i18 + 108 >> 2] = 0;
   i2 = i18 + 112 | 0;
   HEAP32[i2 >> 2] = 0;
   i3 = i18 + 100 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
   i11 = i21;
   i17 = HEAP32[i11 + 4 >> 2] | 0;
   i1 = i3;
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 4 >> 2] = i17;
   HEAP32[i18 + 120 >> 2] = 2;
   HEAP32[i18 + 116 >> 2] = 2;
   HEAP32[i18 + 124 >> 2] = 4;
   HEAP32[i18 + 128 >> 2] = 0;
   i1 = HEAP32[i15 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i23 + 172 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i18); else {
    __ZN13AnimationClip10FloatCurveC2ERKS0_(i1, i18);
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 132;
   }
   i1 = i18 + 96 | 0;
   if ((HEAP32[i2 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i18 + 16 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i17 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i18 + 28 >> 2] | 0;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i21 + 4 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i17, i21);
   }
   if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
    i17 = HEAP32[i18 >> 2] | 0;
    i18 = HEAP32[i18 + 12 >> 2] | 0;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i21 + 4 >> 2] = i18;
    __Z19free_alloc_internalPvRK10MemLabelId(i17, i21);
   }
   i6 = HEAP32[i15 >> 2] | 0;
   i1 = i6 + -132 | 0;
   i7 = HEAP8[i16 + 11 >> 0] | 0;
   i4 = i7 << 24 >> 24 < 0;
   i8 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
   i7 = i4 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i6 + -124 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   do if (i7 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i6 + -128 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
   } else {
    if (i3) i1 = HEAP32[i1 >> 2] | 0;
    if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i6 + -128 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i6 = HEAP32[i15 >> 2] | 0;
   i1 = i6 + -116 | 0;
   i7 = HEAP8[i20 + 11 >> 0] | 0;
   i4 = i7 << 24 >> 24 < 0;
   i8 = i4 ? HEAP32[i20 >> 2] | 0 : i20;
   i7 = i4 ? HEAP32[i20 + 4 >> 2] | 0 : i7 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i6 + -108 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   do if (i7 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i6 + -112 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
   } else {
    if (i3) i1 = HEAP32[i1 >> 2] | 0;
    if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i6 + -112 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = HEAP32[i15 >> 2] | 0;
   HEAP32[i8 + -100 >> 2] = i13;
   HEAP32[i8 + -96 >> 2] = HEAP32[i14 >> 2];
   i21 = i8 + -92 | 0;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i21 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i21 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
   HEAP32[i21 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
   HEAP32[i21 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
   i2 = i8 + -64 | 0;
   i20 = i19 + 28 | 0;
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   i2 = i8 + -36 | 0;
   if ((i21 | 0) != (i19 | 0)) {
    i6 = HEAP32[i19 + 56 >> 2] | 0;
    i7 = i8 + -24 | 0;
    i1 = HEAP32[i19 + 68 >> 2] << 4;
    i3 = i1 >> 4;
    HEAP32[i7 >> 2] = i3;
    i4 = i8 + -20 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i4 >> 2] = i3;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i2 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = i1;
     break;
    } else i1 = HEAP32[i2 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
   }
   i21 = i8 + -16 | 0;
   i20 = i19 + 76 | 0;
   HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  } while (0);
  if (i22) __ZN13AnimationClip15ClipWasModifiedEb(i23, 1);
 } while (0);
 if (!i24) {
  STACKTOP = i25;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i25;
 return;
}

function __ZN2UIL13UIGeometryJobEPNS_17UIGeometryJobDataE(i70) {
 i70 = i70 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i71 = 0, f72 = f0, f73 = f0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i71 + 4 | 0;
 i2 = i71;
 if ((HEAP16[gb + 1468132 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468132 | 0, i1);
  i69 = gb + 1468132 | 0;
 } else i69 = 0;
 i1 = i70 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i68 = i70 + 28 | 0;
 i66 = HEAP32[i68 >> 2] | 0;
 i65 = HEAP32[i70 >> 2] | 0;
 i64 = HEAP32[i70 + 4 >> 2] | 0;
 i67 = i66 + 8 | 0;
 i2 = HEAP32[i67 >> 2] | 0;
 if ((i65 | 0) != 0 & (i64 | 0) != 0) {
  i1 = i66 + 20 | 0;
  if (i2) {
   i63 = i70 + 32 | 0;
   i4 = 0;
   i62 = 0;
   i3 = 0;
   while (1) {
    i60 = HEAP32[i1 >> 2] | 0;
    if (HEAP8[i60 + (i62 * 108 | 0) + 104 >> 0] | 0) {
     i54 = HEAP16[i63 >> 1] | 0;
     i55 = i60 + (i62 * 108 | 0) | 0;
     i14 = HEAP32[i55 >> 2] | 0;
     i16 = i14 + 8 | 0;
     i2 = (i54 & 255) << 24 >> 24 != 0;
     i59 = i60 + (i62 * 108 | 0) + 4 | 0;
     i17 = HEAP32[i59 >> 2] | 0;
     i61 = i60 + (i62 * 108 | 0) + 8 | 0;
     i56 = HEAP32[i61 >> 2] | 0;
     i57 = i60 + (i62 * 108 | 0) + 20 | 0;
     i58 = i60 + (i62 * 108 | 0) + 84 | 0;
     i19 = HEAP32[i14 + 92 >> 2] | 0;
     i5 = (i19 | 0) == 0;
     L14 : do if ((i54 & 65535) < 256) {
      if (!i2) {
       if (i5) {
        i54 = 0;
        i2 = 0;
        i5 = 0;
        i6 = 0;
        i7 = 0;
        i8 = 0;
        i9 = 1;
        i51 = 1;
        i10 = 1;
        i11 = 1;
        i12 = 1;
        i13 = 1;
       } else {
        if (!(HEAP8[i14 + 11 >> 0] | 0)) {
         i8 = 0;
         i9 = 1;
        } else {
         i9 = HEAPU8[i16 + 32 + ((HEAPU8[i16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i8 = HEAP16[i16 >> 1] | 0;
         i8 = i19 + ((Math_imul(i9, i17) | 0) + (HEAP32[i16 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i8 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 15 >> 0] | 0)) {
         i7 = 0;
         i13 = 1;
        } else {
         i13 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i7 = HEAP16[i14 + 12 >> 1] | 0;
         i7 = i19 + ((Math_imul(i13, i17) | 0) + (HEAP32[i16 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i7 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 19 >> 0] | 0)) {
         i6 = 0;
         i12 = 1;
        } else {
         i12 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i6 = HEAP16[i14 + 16 >> 1] | 0;
         i6 = i19 + ((Math_imul(i12, i17) | 0) + (HEAP32[i16 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 23 >> 0] | 0)) {
         i5 = 0;
         i11 = 1;
        } else {
         i11 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i5 = HEAP16[i14 + 20 >> 1] | 0;
         i5 = i19 + ((Math_imul(i11, i17) | 0) + (HEAP32[i16 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i5 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 27 >> 0] | 0)) {
         i2 = 0;
         i10 = 1;
        } else {
         i10 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i2 = HEAP16[i14 + 24 >> 1] | 0;
         i2 = i19 + ((Math_imul(i10, i17) | 0) + (HEAP32[i16 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i2 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 39 >> 0] | 0)) {
         i54 = 0;
         i51 = 1;
        } else {
         i51 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i54 = HEAP16[i14 + 36 >> 1] | 0;
         i54 = i19 + ((Math_imul(i51, i17) | 0) + (HEAP32[i16 + 32 + ((i54 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i54 & 65535) >>> 8 & 65535)) | 0;
        }
       }
       f15 = Math_fround(HEAPF32[i57 >> 2]);
       i32 = i60 + (i62 * 108 | 0) + 24 | 0;
       f23 = Math_fround(HEAPF32[i32 >> 2]);
       i25 = i60 + (i62 * 108 | 0) + 28 | 0;
       f33 = Math_fround(HEAPF32[i25 >> 2]);
       i26 = i60 + (i62 * 108 | 0) + 36 | 0;
       f18 = Math_fround(HEAPF32[i26 >> 2]);
       i27 = i60 + (i62 * 108 | 0) + 40 | 0;
       f35 = Math_fround(HEAPF32[i27 >> 2]);
       i28 = i60 + (i62 * 108 | 0) + 44 | 0;
       f36 = Math_fround(HEAPF32[i28 >> 2]);
       i29 = i60 + (i62 * 108 | 0) + 52 | 0;
       f20 = Math_fround(HEAPF32[i29 >> 2]);
       i30 = i60 + (i62 * 108 | 0) + 56 | 0;
       f38 = Math_fround(HEAPF32[i30 >> 2]);
       i31 = i60 + (i62 * 108 | 0) + 60 | 0;
       f53 = Math_fround(HEAPF32[i31 >> 2]);
       f39 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f23 * f23)) + Math_fround(f33 * f33))));
       i50 = f39 > Math_fround(9.99999997e-07);
       f39 = Math_fround(Math_fround(1.0) / f39);
       f39 = i50 ? f39 : Math_fround(1.0);
       f22 = Math_fround(f15 * f39);
       f23 = Math_fround(f23 * f39);
       f33 = Math_fround(f33 * f39);
       f34 = Math_fround(f18 * f39);
       f35 = Math_fround(f35 * f39);
       f36 = Math_fround(f36 * f39);
       f37 = Math_fround(f20 * f39);
       f38 = Math_fround(f38 * f39);
       f39 = Math_fround(f53 * f39);
       if (!i56) break;
       i40 = i60 + (i62 * 108 | 0) + 68 | 0;
       i41 = i60 + (i62 * 108 | 0) + 72 | 0;
       i42 = i60 + (i62 * 108 | 0) + 76 | 0;
       i43 = (i7 | 0) == 0;
       i44 = (i6 | 0) == 0;
       i45 = i60 + (i62 * 108 | 0) + 88 | 0;
       i46 = i60 + (i62 * 108 | 0) + 92 | 0;
       i47 = i60 + (i62 * 108 | 0) + 96 | 0;
       i48 = (i5 | 0) == 0;
       i49 = (i2 | 0) == 0;
       i50 = (i54 | 0) == 0;
       i14 = 0;
       while (1) {
        i24 = i14 + i4 | 0;
        i19 = i8 + (Math_imul(i14, i9) | 0) | 0;
        f53 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
        i21 = i19 + 4 | 0;
        f52 = Math_fround(HEAPF32[i21 >> 2]);
        f18 = Math_fround(f53 + Math_fround(f18 * f52));
        f53 = Math_fround(HEAPF32[i19 + 8 >> 2]);
        f18 = Math_fround(f18 + Math_fround(f20 * f53));
        HEAPF32[i65 + (i24 * 60 | 0) >> 2] = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + f18);
        f18 = Math_fround(HEAPF32[i32 >> 2]);
        f20 = Math_fround(HEAPF32[i19 >> 2]);
        f18 = Math_fround(f18 * f20);
        f52 = Math_fround(f18 + Math_fround(f52 * Math_fround(HEAPF32[i27 >> 2])));
        f52 = Math_fround(f52 + Math_fround(f53 * Math_fround(HEAPF32[i30 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f52);
        f20 = Math_fround(f20 * Math_fround(HEAPF32[i25 >> 2]));
        f52 = Math_fround(HEAPF32[i28 >> 2]);
        f52 = Math_fround(f20 + Math_fround(f52 * Math_fround(HEAPF32[i21 >> 2])));
        f53 = Math_fround(f52 + Math_fround(f53 * Math_fround(HEAPF32[i31 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + f53);
        if (i43) {
         i16 = 0;
         i17 = -1082130432;
         i19 = 0;
        } else {
         i19 = i7 + (Math_imul(i14, i13) | 0) | 0;
         i16 = HEAP32[i19 >> 2] | 0;
         i17 = HEAP32[i19 + 8 >> 2] | 0;
         i19 = HEAP32[i19 + 4 >> 2] | 0;
        }
        f53 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f18 = Math_fround(f22 * f53);
        f52 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f18 = Math_fround(Math_fround(f34 * f52) + f18);
        f20 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        HEAPF32[i65 + (i24 * 60 | 0) + 12 >> 2] = Math_fround(Math_fround(f37 * f20) + f18);
        HEAPF32[i65 + (i24 * 60 | 0) + 16 >> 2] = Math_fround(Math_fround(f38 * f20) + Math_fround(Math_fround(f35 * f52) + Math_fround(f23 * f53)));
        HEAPF32[i65 + (i24 * 60 | 0) + 20 >> 2] = Math_fround(Math_fround(f39 * f20) + Math_fround(Math_fround(f36 * f52) + Math_fround(f33 * f53)));
        if (i44) {
         i16 = 255;
         i17 = -16777216;
         i19 = 65280;
         i21 = 16711680;
        } else {
         i21 = HEAP32[i6 + (Math_imul(i14, i12) | 0) >> 2] | 0;
         i16 = i21;
         i17 = i21 & -16777216;
         i19 = i21 & -256;
         i21 = i21 & -65536;
        }
        f18 = Math_fround(Math_fround(i16 & 255) / Math_fround(255.0));
        f20 = Math_fround(Math_fround((i19 & 65535) >>> 8 & 255) / Math_fround(255.0));
        f52 = Math_fround(Math_fround(i21 >>> 16 & 255) / Math_fround(255.0));
        f53 = Math_fround(Math_fround(i17 >>> 24 & 255) / Math_fround(255.0));
        f18 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f18);
        f20 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * f20);
        f52 = Math_fround(f52 * Math_fround(HEAPF32[i46 >> 2]));
        f53 = Math_fround(f53 * Math_fround(HEAPF32[i47 >> 2]));
        i17 = f18 < Math_fround(0.0);
        f18 = i17 ? Math_fround(0.0) : f18;
        i17 = f18 > Math_fround(1.0);
        i17 = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i21 = f20 < Math_fround(0.0);
        f20 = i21 ? Math_fround(0.0) : f20;
        i21 = f20 > Math_fround(1.0);
        i21 = ~~Math_fround(Math_fround((i21 ? Math_fround(1.0) : f20) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i16 = f52 < Math_fround(0.0);
        f52 = i16 ? Math_fround(0.0) : f52;
        i16 = f52 > Math_fround(1.0);
        i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f52) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i19 = f53 < Math_fround(0.0);
        f53 = i19 ? Math_fround(0.0) : f53;
        i19 = f53 > Math_fround(1.0);
        HEAP32[i65 + (i24 * 60 | 0) + 24 >> 2] = i16 << 16 & 16711680 | i17 & 255 | ~~Math_fround(Math_fround((i19 ? Math_fround(1.0) : f53) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24 | i21 << 8 & 65280;
        i21 = i5 + (Math_imul(i14, i11) | 0) | 0;
        i21 = i48 ? gb + 1162356 | 0 : i21;
        i19 = HEAP32[i21 + 4 >> 2] | 0;
        i17 = i65 + (i24 * 60 | 0) + 28 | 0;
        HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i17 + 4 >> 2] = i19;
        i17 = i2 + (Math_imul(i14, i10) | 0) | 0;
        i17 = i49 ? gb + 1162356 | 0 : i17;
        i19 = HEAP32[i17 + 4 >> 2] | 0;
        i21 = i65 + (i24 * 60 | 0) + 36 | 0;
        HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
        HEAP32[i21 + 4 >> 2] = i19;
        if (i50) {
         i16 = 1065353216;
         i17 = -1082130432;
         i19 = 0;
         i21 = 0;
        } else {
         i21 = i54 + (Math_imul(i14, i51) | 0) | 0;
         i16 = HEAP32[i21 >> 2] | 0;
         i17 = HEAP32[i21 + 12 >> 2] | 0;
         i19 = HEAP32[i21 + 4 >> 2] | 0;
         i21 = HEAP32[i21 + 8 >> 2] | 0;
        }
        f53 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(f22 * f53);
        f15 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(Math_fround(f34 * f15) + f20);
        f18 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f52 = Math_fround(Math_fround(f38 * f18) + Math_fround(Math_fround(f35 * f15) + Math_fround(f23 * f53)));
        f53 = Math_fround(Math_fround(f39 * f18) + Math_fround(Math_fround(f36 * f15) + Math_fround(f33 * f53)));
        HEAPF32[i65 + (i24 * 60 | 0) + 44 >> 2] = Math_fround(Math_fround(f37 * f18) + f20);
        HEAPF32[i65 + (i24 * 60 | 0) + 48 >> 2] = f52;
        HEAPF32[i65 + (i24 * 60 | 0) + 52 >> 2] = f53;
        HEAP32[i65 + (i24 * 60 | 0) + 56 >> 2] = i17;
        i14 = i14 + 1 | 0;
        if ((i14 | 0) == (i56 | 0)) break L14;
        f15 = Math_fround(HEAPF32[i57 >> 2]);
        f18 = Math_fround(HEAPF32[i26 >> 2]);
        f20 = Math_fround(HEAPF32[i29 >> 2]);
       }
      }
      if (i5) {
       i54 = 0;
       i2 = 0;
       i5 = 0;
       i6 = 0;
       i7 = 0;
       i8 = 0;
       i9 = 1;
       i51 = 1;
       i10 = 1;
       i11 = 1;
       i12 = 1;
       i13 = 1;
      } else {
       if (!(HEAP8[i14 + 11 >> 0] | 0)) {
        i8 = 0;
        i9 = 1;
       } else {
        i9 = HEAPU8[i16 + 32 + ((HEAPU8[i16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i8 = HEAP16[i16 >> 1] | 0;
        i8 = i19 + ((Math_imul(i9, i17) | 0) + (HEAP32[i16 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i8 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 15 >> 0] | 0)) {
        i7 = 0;
        i13 = 1;
       } else {
        i13 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i7 = HEAP16[i14 + 12 >> 1] | 0;
        i7 = i19 + ((Math_imul(i13, i17) | 0) + (HEAP32[i16 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i7 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 19 >> 0] | 0)) {
        i6 = 0;
        i12 = 1;
       } else {
        i12 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i6 = HEAP16[i14 + 16 >> 1] | 0;
        i6 = i19 + ((Math_imul(i12, i17) | 0) + (HEAP32[i16 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 23 >> 0] | 0)) {
        i5 = 0;
        i11 = 1;
       } else {
        i11 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i5 = HEAP16[i14 + 20 >> 1] | 0;
        i5 = i19 + ((Math_imul(i11, i17) | 0) + (HEAP32[i16 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i5 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 27 >> 0] | 0)) {
        i2 = 0;
        i10 = 1;
       } else {
        i10 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i2 = HEAP16[i14 + 24 >> 1] | 0;
        i2 = i19 + ((Math_imul(i10, i17) | 0) + (HEAP32[i16 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i2 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 39 >> 0] | 0)) {
        i54 = 0;
        i51 = 1;
       } else {
        i51 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i54 = HEAP16[i14 + 36 >> 1] | 0;
        i54 = i19 + ((Math_imul(i51, i17) | 0) + (HEAP32[i16 + 32 + ((i54 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i54 & 65535) >>> 8 & 65535)) | 0;
       }
      }
      f15 = Math_fround(HEAPF32[i57 >> 2]);
      i32 = i60 + (i62 * 108 | 0) + 24 | 0;
      f34 = Math_fround(HEAPF32[i32 >> 2]);
      i25 = i60 + (i62 * 108 | 0) + 28 | 0;
      f35 = Math_fround(HEAPF32[i25 >> 2]);
      i26 = i60 + (i62 * 108 | 0) + 36 | 0;
      f18 = Math_fround(HEAPF32[i26 >> 2]);
      i27 = i60 + (i62 * 108 | 0) + 40 | 0;
      f37 = Math_fround(HEAPF32[i27 >> 2]);
      i28 = i60 + (i62 * 108 | 0) + 44 | 0;
      f38 = Math_fround(HEAPF32[i28 >> 2]);
      i29 = i60 + (i62 * 108 | 0) + 52 | 0;
      f20 = Math_fround(HEAPF32[i29 >> 2]);
      i30 = i60 + (i62 * 108 | 0) + 56 | 0;
      f52 = Math_fround(HEAPF32[i30 >> 2]);
      i31 = i60 + (i62 * 108 | 0) + 60 | 0;
      f23 = Math_fround(HEAPF32[i31 >> 2]);
      f53 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))));
      i50 = f53 > Math_fround(9.99999997e-07);
      f53 = Math_fround(Math_fround(1.0) / f53);
      f53 = i50 ? f53 : Math_fround(1.0);
      f33 = Math_fround(f15 * f53);
      f34 = Math_fround(f34 * f53);
      f35 = Math_fround(f35 * f53);
      f36 = Math_fround(f18 * f53);
      f37 = Math_fround(f37 * f53);
      f38 = Math_fround(f38 * f53);
      f39 = Math_fround(f20 * f53);
      f52 = Math_fround(f52 * f53);
      f53 = Math_fround(f23 * f53);
      if (i56 | 0) {
       i40 = i60 + (i62 * 108 | 0) + 68 | 0;
       i41 = i60 + (i62 * 108 | 0) + 72 | 0;
       i42 = i60 + (i62 * 108 | 0) + 76 | 0;
       i43 = (i7 | 0) == 0;
       i44 = (i6 | 0) == 0;
       i45 = i60 + (i62 * 108 | 0) + 88 | 0;
       i46 = i60 + (i62 * 108 | 0) + 92 | 0;
       i47 = i60 + (i62 * 108 | 0) + 96 | 0;
       i48 = (i5 | 0) == 0;
       i49 = (i2 | 0) == 0;
       i50 = (i54 | 0) == 0;
       i14 = 0;
       while (1) {
        i24 = i14 + i4 | 0;
        i19 = i8 + (Math_imul(i14, i9) | 0) | 0;
        f23 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
        i21 = i19 + 4 | 0;
        f22 = Math_fround(HEAPF32[i21 >> 2]);
        f18 = Math_fround(f23 + Math_fround(f18 * f22));
        f23 = Math_fround(HEAPF32[i19 + 8 >> 2]);
        f18 = Math_fround(f18 + Math_fround(f20 * f23));
        HEAPF32[i65 + (i24 * 60 | 0) >> 2] = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + f18);
        f18 = Math_fround(HEAPF32[i32 >> 2]);
        f20 = Math_fround(HEAPF32[i19 >> 2]);
        f18 = Math_fround(f18 * f20);
        f22 = Math_fround(f18 + Math_fround(f22 * Math_fround(HEAPF32[i27 >> 2])));
        f22 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i30 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f22);
        f20 = Math_fround(f20 * Math_fround(HEAPF32[i25 >> 2]));
        f22 = Math_fround(HEAPF32[i28 >> 2]);
        f22 = Math_fround(f20 + Math_fround(f22 * Math_fround(HEAPF32[i21 >> 2])));
        f23 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i31 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + f23);
        if (i43) {
         i16 = 0;
         i17 = -1082130432;
         i19 = 0;
        } else {
         i19 = i7 + (Math_imul(i14, i13) | 0) | 0;
         i16 = HEAP32[i19 >> 2] | 0;
         i17 = HEAP32[i19 + 8 >> 2] | 0;
         i19 = HEAP32[i19 + 4 >> 2] | 0;
        }
        f20 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f18 = Math_fround(f33 * f20);
        f22 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f18 = Math_fround(f18 + Math_fround(f36 * f22));
        f23 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        HEAPF32[i65 + (i24 * 60 | 0) + 12 >> 2] = Math_fround(f18 + Math_fround(f39 * f23));
        HEAPF32[i65 + (i24 * 60 | 0) + 16 >> 2] = Math_fround(Math_fround(Math_fround(f34 * f20) + Math_fround(f37 * f22)) + Math_fround(f52 * f23));
        HEAPF32[i65 + (i24 * 60 | 0) + 20 >> 2] = Math_fround(Math_fround(Math_fround(f35 * f20) + Math_fround(f38 * f22)) + Math_fround(f53 * f23));
        if (i44) {
         i16 = 255;
         i21 = -16777216;
         i17 = 65280;
         i19 = 16711680;
        } else {
         i19 = HEAP32[i6 + (Math_imul(i14, i12) | 0) >> 2] | 0;
         i16 = i19;
         i21 = i19 & -16777216;
         i17 = i19 & -256;
         i19 = i19 & -65536;
        }
        f15 = Math_fround(Math_fround(i16 & 255) / Math_fround(255.0));
        f18 = Math_fround(Math_fround((i17 & 65535) >>> 8 & 255) / Math_fround(255.0));
        f22 = Math_fround(Math_fround(i19 >>> 16 & 255) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(i21 >>> 24 & 255) / Math_fround(255.0));
        do if (!(f15 <= Math_fround(.0404499993))) {
         if (f15 < Math_fround(1.0)) {
          f20 = Math_fround(+Math_pow(+Math_fround(Math_fround(f15 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f15 == Math_fround(1.0)) f20 = Math_fround(1.0); else f20 = Math_fround(+Math_pow(+f15, 2.20000005));
        } else f20 = Math_fround(f15 / Math_fround(12.9200001)); while (0);
        do if (!(f18 <= Math_fround(.0404499993))) {
         if (f18 < Math_fround(1.0)) {
          f18 = Math_fround(+Math_pow(+Math_fround(Math_fround(f18 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f18 == Math_fround(1.0)) {
          f18 = Math_fround(1.0);
          break;
         }
         f18 = Math_fround(+Math_pow(+f18, 2.20000005));
        } else f18 = Math_fround(f18 / Math_fround(12.9200001)); while (0);
        do if (!(f22 <= Math_fround(.0404499993))) {
         if (f22 < Math_fround(1.0)) {
          f15 = Math_fround(+Math_pow(+Math_fround(Math_fround(f22 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f22 == Math_fround(1.0)) {
          f15 = Math_fround(1.0);
          break;
         }
         f15 = Math_fround(+Math_pow(+f22, 2.20000005));
        } else f15 = Math_fround(f22 / Math_fround(12.9200001)); while (0);
        f72 = Math_fround(f20 * Math_fround(HEAPF32[i58 >> 2]));
        f20 = Math_fround(f18 * Math_fround(HEAPF32[i45 >> 2]));
        f22 = Math_fround(f15 * Math_fround(HEAPF32[i46 >> 2]));
        f23 = Math_fround(f23 * Math_fround(HEAPF32[i47 >> 2]));
        i17 = f72 < Math_fround(0.0);
        f18 = i17 ? Math_fround(0.0) : f72;
        i17 = f18 > Math_fround(1.0);
        i17 = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i16 = f20 < Math_fround(0.0);
        f20 = i16 ? Math_fround(0.0) : f20;
        i16 = f20 > Math_fround(1.0);
        i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f20) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i19 = f22 < Math_fround(0.0);
        f22 = i19 ? Math_fround(0.0) : f22;
        i19 = f22 > Math_fround(1.0);
        i19 = ~~Math_fround(Math_fround((i19 ? Math_fround(1.0) : f22) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i21 = f23 < Math_fround(0.0);
        f23 = i21 ? Math_fround(0.0) : f23;
        i21 = f23 > Math_fround(1.0);
        HEAP32[i65 + (i24 * 60 | 0) + 24 >> 2] = i16 << 8 & 65280 | i17 & 255 | i19 << 16 & 16711680 | ~~Math_fround(Math_fround((i21 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
        i21 = i5 + (Math_imul(i14, i11) | 0) | 0;
        i21 = i48 ? gb + 1162356 | 0 : i21;
        i19 = HEAP32[i21 + 4 >> 2] | 0;
        i17 = i65 + (i24 * 60 | 0) + 28 | 0;
        HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i17 + 4 >> 2] = i19;
        i17 = i2 + (Math_imul(i14, i10) | 0) | 0;
        i17 = i49 ? gb + 1162356 | 0 : i17;
        i19 = HEAP32[i17 + 4 >> 2] | 0;
        i21 = i65 + (i24 * 60 | 0) + 36 | 0;
        HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
        HEAP32[i21 + 4 >> 2] = i19;
        if (i50) {
         i16 = 1065353216;
         i17 = -1082130432;
         i19 = 0;
         i21 = 0;
        } else {
         i21 = i54 + (Math_imul(i14, i51) | 0) | 0;
         i16 = HEAP32[i21 >> 2] | 0;
         i17 = HEAP32[i21 + 12 >> 2] | 0;
         i19 = HEAP32[i21 + 4 >> 2] | 0;
         i21 = HEAP32[i21 + 8 >> 2] | 0;
        }
        f72 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f22 = Math_fround(f33 * f72);
        f18 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f22 = Math_fround(Math_fround(f36 * f18) + f22);
        f20 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f23 = Math_fround(Math_fround(f52 * f20) + Math_fround(Math_fround(f37 * f18) + Math_fround(f34 * f72)));
        f72 = Math_fround(Math_fround(f53 * f20) + Math_fround(Math_fround(f38 * f18) + Math_fround(f35 * f72)));
        HEAPF32[i65 + (i24 * 60 | 0) + 44 >> 2] = Math_fround(Math_fround(f39 * f20) + f22);
        HEAPF32[i65 + (i24 * 60 | 0) + 48 >> 2] = f23;
        HEAPF32[i65 + (i24 * 60 | 0) + 52 >> 2] = f72;
        HEAP32[i65 + (i24 * 60 | 0) + 56 >> 2] = i17;
        i14 = i14 + 1 | 0;
        if ((i14 | 0) == (i56 | 0)) break L14;
        f15 = Math_fround(HEAPF32[i57 >> 2]);
        f18 = Math_fround(HEAPF32[i26 >> 2]);
        f20 = Math_fround(HEAPF32[i29 >> 2]);
       }
      }
     } else {
      if (!i2) {
       if (i5) {
        i54 = 0;
        i2 = 0;
        i5 = 0;
        i6 = 0;
        i7 = 0;
        i8 = 0;
        i9 = 1;
        i51 = 1;
        i10 = 1;
        i11 = 1;
        i12 = 1;
        i13 = 1;
       } else {
        if (!(HEAP8[i14 + 11 >> 0] | 0)) {
         i8 = 0;
         i9 = 1;
        } else {
         i9 = HEAPU8[i16 + 32 + ((HEAPU8[i16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i8 = HEAP16[i16 >> 1] | 0;
         i8 = i19 + ((Math_imul(i9, i17) | 0) + (HEAP32[i16 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i8 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 15 >> 0] | 0)) {
         i7 = 0;
         i13 = 1;
        } else {
         i13 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i7 = HEAP16[i14 + 12 >> 1] | 0;
         i7 = i19 + ((Math_imul(i13, i17) | 0) + (HEAP32[i16 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i7 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 19 >> 0] | 0)) {
         i6 = 0;
         i12 = 1;
        } else {
         i12 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i6 = HEAP16[i14 + 16 >> 1] | 0;
         i6 = i19 + ((Math_imul(i12, i17) | 0) + (HEAP32[i16 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 23 >> 0] | 0)) {
         i5 = 0;
         i11 = 1;
        } else {
         i11 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i5 = HEAP16[i14 + 20 >> 1] | 0;
         i5 = i19 + ((Math_imul(i11, i17) | 0) + (HEAP32[i16 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i5 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 27 >> 0] | 0)) {
         i2 = 0;
         i10 = 1;
        } else {
         i10 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i2 = HEAP16[i14 + 24 >> 1] | 0;
         i2 = i19 + ((Math_imul(i10, i17) | 0) + (HEAP32[i16 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i2 & 65535) >>> 8 & 65535)) | 0;
        }
        if (!(HEAP8[i14 + 39 >> 0] | 0)) {
         i54 = 0;
         i51 = 1;
        } else {
         i51 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
         i54 = HEAP16[i14 + 36 >> 1] | 0;
         i54 = i19 + ((Math_imul(i51, i17) | 0) + (HEAP32[i16 + 32 + ((i54 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i54 & 65535) >>> 8 & 65535)) | 0;
        }
       }
       f15 = Math_fround(HEAPF32[i57 >> 2]);
       i32 = i60 + (i62 * 108 | 0) + 24 | 0;
       f23 = Math_fround(HEAPF32[i32 >> 2]);
       i25 = i60 + (i62 * 108 | 0) + 28 | 0;
       f33 = Math_fround(HEAPF32[i25 >> 2]);
       i26 = i60 + (i62 * 108 | 0) + 36 | 0;
       f18 = Math_fround(HEAPF32[i26 >> 2]);
       i27 = i60 + (i62 * 108 | 0) + 40 | 0;
       f35 = Math_fround(HEAPF32[i27 >> 2]);
       i28 = i60 + (i62 * 108 | 0) + 44 | 0;
       f36 = Math_fround(HEAPF32[i28 >> 2]);
       i29 = i60 + (i62 * 108 | 0) + 52 | 0;
       f20 = Math_fround(HEAPF32[i29 >> 2]);
       i30 = i60 + (i62 * 108 | 0) + 56 | 0;
       f38 = Math_fround(HEAPF32[i30 >> 2]);
       i31 = i60 + (i62 * 108 | 0) + 60 | 0;
       f72 = Math_fround(HEAPF32[i31 >> 2]);
       f39 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f23 * f23)) + Math_fround(f33 * f33))));
       i50 = f39 > Math_fround(9.99999997e-07);
       f39 = Math_fround(Math_fround(1.0) / f39);
       f39 = i50 ? f39 : Math_fround(1.0);
       f22 = Math_fround(f15 * f39);
       f23 = Math_fround(f23 * f39);
       f33 = Math_fround(f33 * f39);
       f34 = Math_fround(f18 * f39);
       f35 = Math_fround(f35 * f39);
       f36 = Math_fround(f36 * f39);
       f37 = Math_fround(f20 * f39);
       f38 = Math_fround(f38 * f39);
       f39 = Math_fround(f72 * f39);
       if (!i56) break;
       i40 = i60 + (i62 * 108 | 0) + 68 | 0;
       i41 = i60 + (i62 * 108 | 0) + 72 | 0;
       i42 = i60 + (i62 * 108 | 0) + 76 | 0;
       i43 = (i7 | 0) == 0;
       i44 = (i6 | 0) == 0;
       i45 = i60 + (i62 * 108 | 0) + 88 | 0;
       i46 = i60 + (i62 * 108 | 0) + 92 | 0;
       i47 = i60 + (i62 * 108 | 0) + 96 | 0;
       i48 = (i5 | 0) == 0;
       i49 = (i2 | 0) == 0;
       i50 = (i54 | 0) == 0;
       i14 = 0;
       while (1) {
        i24 = i14 + i4 | 0;
        i19 = i8 + (Math_imul(i14, i9) | 0) | 0;
        f52 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
        i21 = i19 + 4 | 0;
        f53 = Math_fround(HEAPF32[i21 >> 2]);
        f52 = Math_fround(f52 + Math_fround(f18 * f53));
        f72 = Math_fround(HEAPF32[i19 + 8 >> 2]);
        f20 = Math_fround(f52 + Math_fround(f20 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) >> 2] = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + f20);
        f20 = Math_fround(HEAPF32[i32 >> 2]);
        f52 = Math_fround(HEAPF32[i19 >> 2]);
        f20 = Math_fround(f20 * f52);
        f53 = Math_fround(f20 + Math_fround(f53 * Math_fround(HEAPF32[i27 >> 2])));
        f53 = Math_fround(f53 + Math_fround(f72 * Math_fround(HEAPF32[i30 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f53);
        f52 = Math_fround(f52 * Math_fround(HEAPF32[i25 >> 2]));
        f53 = Math_fround(HEAPF32[i28 >> 2]);
        f53 = Math_fround(f52 + Math_fround(f53 * Math_fround(HEAPF32[i21 >> 2])));
        f72 = Math_fround(f53 + Math_fround(f72 * Math_fround(HEAPF32[i31 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + f72);
        if (i43) {
         i16 = 0;
         i17 = -1082130432;
         i19 = 0;
        } else {
         i19 = i7 + (Math_imul(i14, i13) | 0) | 0;
         i16 = HEAP32[i19 >> 2] | 0;
         i17 = HEAP32[i19 + 8 >> 2] | 0;
         i19 = HEAP32[i19 + 4 >> 2] | 0;
        }
        f52 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(f22 * f52);
        f53 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(f20 + Math_fround(f34 * f53));
        f72 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        HEAPF32[i65 + (i24 * 60 | 0) + 12 >> 2] = Math_fround(f20 + Math_fround(f37 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) + 16 >> 2] = Math_fround(Math_fround(Math_fround(f23 * f52) + Math_fround(f35 * f53)) + Math_fround(f38 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) + 20 >> 2] = Math_fround(Math_fround(Math_fround(f33 * f52) + Math_fround(f36 * f53)) + Math_fround(f39 * f72));
        if (i44) {
         i16 = 255;
         i17 = 255;
         i19 = -16777216;
         i21 = 65280;
        } else {
         i21 = HEAP32[i6 + (Math_imul(i14, i12) | 0) >> 2] | 0;
         i16 = i21;
         i17 = i21 >>> 16;
         i19 = i21 & -16777216;
         i21 = i21 & -256;
        }
        f20 = Math_fround(Math_fround(i17 & 255) / Math_fround(255.0));
        f52 = Math_fround(Math_fround((i21 & 65535) >>> 8 & 255) / Math_fround(255.0));
        f53 = Math_fround(Math_fround(i16 & 255) / Math_fround(255.0));
        f72 = Math_fround(Math_fround(i19 >>> 24 & 255) / Math_fround(255.0));
        f20 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f20);
        f52 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * f52);
        f53 = Math_fround(f53 * Math_fround(HEAPF32[i46 >> 2]));
        f72 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f72);
        i17 = f20 < Math_fround(0.0);
        f20 = i17 ? Math_fround(0.0) : f20;
        i17 = f20 > Math_fround(1.0);
        i17 = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f20) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i21 = f52 < Math_fround(0.0);
        f52 = i21 ? Math_fround(0.0) : f52;
        i21 = f52 > Math_fround(1.0);
        i21 = ~~Math_fround(Math_fround((i21 ? Math_fround(1.0) : f52) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i16 = f53 < Math_fround(0.0);
        f53 = i16 ? Math_fround(0.0) : f53;
        i16 = f53 > Math_fround(1.0);
        i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f53) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i19 = f72 < Math_fround(0.0);
        f72 = i19 ? Math_fround(0.0) : f72;
        i19 = f72 > Math_fround(1.0);
        HEAP32[i65 + (i24 * 60 | 0) + 24 >> 2] = i16 & 255 | i17 << 16 & 16711680 | ~~Math_fround(Math_fround((i19 ? Math_fround(1.0) : f72) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24 | i21 << 8 & 65280;
        i21 = i5 + (Math_imul(i14, i11) | 0) | 0;
        i21 = i48 ? gb + 1162356 | 0 : i21;
        i19 = HEAP32[i21 + 4 >> 2] | 0;
        i17 = i65 + (i24 * 60 | 0) + 28 | 0;
        HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i17 + 4 >> 2] = i19;
        i17 = i2 + (Math_imul(i14, i10) | 0) | 0;
        i17 = i49 ? gb + 1162356 | 0 : i17;
        i19 = HEAP32[i17 + 4 >> 2] | 0;
        i21 = i65 + (i24 * 60 | 0) + 36 | 0;
        HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
        HEAP32[i21 + 4 >> 2] = i19;
        if (i50) {
         i16 = 1065353216;
         i17 = -1082130432;
         i19 = 0;
         i21 = 0;
        } else {
         i21 = i54 + (Math_imul(i14, i51) | 0) | 0;
         i16 = HEAP32[i21 >> 2] | 0;
         i17 = HEAP32[i21 + 12 >> 2] | 0;
         i19 = HEAP32[i21 + 4 >> 2] | 0;
         i21 = HEAP32[i21 + 8 >> 2] | 0;
        }
        f72 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f52 = Math_fround(f22 * f72);
        f18 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f52 = Math_fround(Math_fround(f34 * f18) + f52);
        f20 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = Math_fround(Math_fround(f38 * f20) + Math_fround(Math_fround(f35 * f18) + Math_fround(f23 * f72)));
        f72 = Math_fround(Math_fround(f39 * f20) + Math_fround(Math_fround(f36 * f18) + Math_fround(f33 * f72)));
        HEAPF32[i65 + (i24 * 60 | 0) + 44 >> 2] = Math_fround(Math_fround(f37 * f20) + f52);
        HEAPF32[i65 + (i24 * 60 | 0) + 48 >> 2] = f53;
        HEAPF32[i65 + (i24 * 60 | 0) + 52 >> 2] = f72;
        HEAP32[i65 + (i24 * 60 | 0) + 56 >> 2] = i17;
        i14 = i14 + 1 | 0;
        if ((i14 | 0) == (i56 | 0)) break L14;
        f15 = Math_fround(HEAPF32[i57 >> 2]);
        f18 = Math_fround(HEAPF32[i26 >> 2]);
        f20 = Math_fround(HEAPF32[i29 >> 2]);
       }
      }
      if (i5) {
       i54 = 0;
       i2 = 0;
       i5 = 0;
       i6 = 0;
       i7 = 0;
       i8 = 0;
       i9 = 1;
       i51 = 1;
       i10 = 1;
       i11 = 1;
       i12 = 1;
       i13 = 1;
      } else {
       if (!(HEAP8[i14 + 11 >> 0] | 0)) {
        i8 = 0;
        i9 = 1;
       } else {
        i9 = HEAPU8[i16 + 32 + ((HEAPU8[i16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i8 = HEAP16[i16 >> 1] | 0;
        i8 = i19 + ((Math_imul(i9, i17) | 0) + (HEAP32[i16 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i8 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 15 >> 0] | 0)) {
        i7 = 0;
        i13 = 1;
       } else {
        i13 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i7 = HEAP16[i14 + 12 >> 1] | 0;
        i7 = i19 + ((Math_imul(i13, i17) | 0) + (HEAP32[i16 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i7 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 19 >> 0] | 0)) {
        i6 = 0;
        i12 = 1;
       } else {
        i12 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i6 = HEAP16[i14 + 16 >> 1] | 0;
        i6 = i19 + ((Math_imul(i12, i17) | 0) + (HEAP32[i16 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 23 >> 0] | 0)) {
        i5 = 0;
        i11 = 1;
       } else {
        i11 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i5 = HEAP16[i14 + 20 >> 1] | 0;
        i5 = i19 + ((Math_imul(i11, i17) | 0) + (HEAP32[i16 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i5 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 27 >> 0] | 0)) {
        i2 = 0;
        i10 = 1;
       } else {
        i10 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i2 = HEAP16[i14 + 24 >> 1] | 0;
        i2 = i19 + ((Math_imul(i10, i17) | 0) + (HEAP32[i16 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i2 & 65535) >>> 8 & 65535)) | 0;
       }
       if (!(HEAP8[i14 + 39 >> 0] | 0)) {
        i54 = 0;
        i51 = 1;
       } else {
        i51 = HEAPU8[i16 + 32 + ((HEAPU8[i14 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i54 = HEAP16[i14 + 36 >> 1] | 0;
        i54 = i19 + ((Math_imul(i51, i17) | 0) + (HEAP32[i16 + 32 + ((i54 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i54 & 65535) >>> 8 & 65535)) | 0;
       }
      }
      f15 = Math_fround(HEAPF32[i57 >> 2]);
      i32 = i60 + (i62 * 108 | 0) + 24 | 0;
      f34 = Math_fround(HEAPF32[i32 >> 2]);
      i25 = i60 + (i62 * 108 | 0) + 28 | 0;
      f35 = Math_fround(HEAPF32[i25 >> 2]);
      i26 = i60 + (i62 * 108 | 0) + 36 | 0;
      f18 = Math_fround(HEAPF32[i26 >> 2]);
      i27 = i60 + (i62 * 108 | 0) + 40 | 0;
      f37 = Math_fround(HEAPF32[i27 >> 2]);
      i28 = i60 + (i62 * 108 | 0) + 44 | 0;
      f38 = Math_fround(HEAPF32[i28 >> 2]);
      i29 = i60 + (i62 * 108 | 0) + 52 | 0;
      f20 = Math_fround(HEAPF32[i29 >> 2]);
      i30 = i60 + (i62 * 108 | 0) + 56 | 0;
      f52 = Math_fround(HEAPF32[i30 >> 2]);
      i31 = i60 + (i62 * 108 | 0) + 60 | 0;
      f72 = Math_fround(HEAPF32[i31 >> 2]);
      f53 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))));
      i50 = f53 > Math_fround(9.99999997e-07);
      f53 = Math_fround(Math_fround(1.0) / f53);
      f53 = i50 ? f53 : Math_fround(1.0);
      f33 = Math_fround(f15 * f53);
      f34 = Math_fround(f34 * f53);
      f35 = Math_fround(f35 * f53);
      f36 = Math_fround(f18 * f53);
      f37 = Math_fround(f37 * f53);
      f38 = Math_fround(f38 * f53);
      f39 = Math_fround(f20 * f53);
      f52 = Math_fround(f52 * f53);
      f53 = Math_fround(f72 * f53);
      if (i56 | 0) {
       i40 = i60 + (i62 * 108 | 0) + 68 | 0;
       i41 = i60 + (i62 * 108 | 0) + 72 | 0;
       i42 = i60 + (i62 * 108 | 0) + 76 | 0;
       i43 = (i7 | 0) == 0;
       i44 = (i6 | 0) == 0;
       i45 = i60 + (i62 * 108 | 0) + 88 | 0;
       i46 = i60 + (i62 * 108 | 0) + 92 | 0;
       i47 = i60 + (i62 * 108 | 0) + 96 | 0;
       i48 = (i5 | 0) == 0;
       i49 = (i2 | 0) == 0;
       i50 = (i54 | 0) == 0;
       i14 = 0;
       while (1) {
        i24 = i14 + i4 | 0;
        i19 = i8 + (Math_imul(i14, i9) | 0) | 0;
        f22 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
        i21 = i19 + 4 | 0;
        f23 = Math_fround(HEAPF32[i21 >> 2]);
        f22 = Math_fround(f22 + Math_fround(f18 * f23));
        f72 = Math_fround(HEAPF32[i19 + 8 >> 2]);
        f20 = Math_fround(f22 + Math_fround(f20 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) >> 2] = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + f20);
        f20 = Math_fround(HEAPF32[i32 >> 2]);
        f22 = Math_fround(HEAPF32[i19 >> 2]);
        f20 = Math_fround(f20 * f22);
        f23 = Math_fround(f20 + Math_fround(f23 * Math_fround(HEAPF32[i27 >> 2])));
        f23 = Math_fround(f23 + Math_fround(f72 * Math_fround(HEAPF32[i30 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f23);
        f22 = Math_fround(f22 * Math_fround(HEAPF32[i25 >> 2]));
        f23 = Math_fround(HEAPF32[i28 >> 2]);
        f23 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i21 >> 2])));
        f72 = Math_fround(f23 + Math_fround(f72 * Math_fround(HEAPF32[i31 >> 2])));
        HEAPF32[i65 + (i24 * 60 | 0) + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + f72);
        if (i43) {
         i16 = 0;
         i17 = -1082130432;
         i19 = 0;
        } else {
         i19 = i7 + (Math_imul(i14, i13) | 0) | 0;
         i16 = HEAP32[i19 >> 2] | 0;
         i17 = HEAP32[i19 + 8 >> 2] | 0;
         i19 = HEAP32[i19 + 4 >> 2] | 0;
        }
        f22 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(f33 * f22);
        f23 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f20 = Math_fround(f20 + Math_fround(f36 * f23));
        f72 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        HEAPF32[i65 + (i24 * 60 | 0) + 12 >> 2] = Math_fround(f20 + Math_fround(f39 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) + 16 >> 2] = Math_fround(Math_fround(Math_fround(f34 * f22) + Math_fround(f37 * f23)) + Math_fround(f52 * f72));
        HEAPF32[i65 + (i24 * 60 | 0) + 20 >> 2] = Math_fround(Math_fround(Math_fround(f35 * f22) + Math_fround(f38 * f23)) + Math_fround(f53 * f72));
        if (i44) {
         i19 = 255;
         i16 = 255;
         i21 = -16777216;
         i17 = 65280;
        } else {
         i17 = HEAP32[i6 + (Math_imul(i14, i12) | 0) >> 2] | 0;
         i19 = i17;
         i16 = i17 >>> 16;
         i21 = i17 & -16777216;
         i17 = i17 & -256;
        }
        f15 = Math_fround(Math_fround(i16 & 255) / Math_fround(255.0));
        f18 = Math_fround(Math_fround((i17 & 65535) >>> 8 & 255) / Math_fround(255.0));
        f22 = Math_fround(Math_fround(i19 & 255) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(i21 >>> 24 & 255) / Math_fround(255.0));
        do if (!(f15 <= Math_fround(.0404499993))) {
         if (f15 < Math_fround(1.0)) {
          f20 = Math_fround(+Math_pow(+Math_fround(Math_fround(f15 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f15 == Math_fround(1.0)) f20 = Math_fround(1.0); else f20 = Math_fround(+Math_pow(+f15, 2.20000005));
        } else f20 = Math_fround(f15 / Math_fround(12.9200001)); while (0);
        do if (!(f18 <= Math_fround(.0404499993))) {
         if (f18 < Math_fround(1.0)) {
          f18 = Math_fround(+Math_pow(+Math_fround(Math_fround(f18 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f18 == Math_fround(1.0)) {
          f18 = Math_fround(1.0);
          break;
         }
         f18 = Math_fround(+Math_pow(+f18, 2.20000005));
        } else f18 = Math_fround(f18 / Math_fround(12.9200001)); while (0);
        do if (!(f22 <= Math_fround(.0404499993))) {
         if (f22 < Math_fround(1.0)) {
          f15 = Math_fround(+Math_pow(+Math_fround(Math_fround(f22 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f22 == Math_fround(1.0)) {
          f15 = Math_fround(1.0);
          break;
         }
         f15 = Math_fround(+Math_pow(+f22, 2.20000005));
        } else f15 = Math_fround(f22 / Math_fround(12.9200001)); while (0);
        f73 = Math_fround(f20 * Math_fround(HEAPF32[i58 >> 2]));
        f20 = Math_fround(f18 * Math_fround(HEAPF32[i45 >> 2]));
        f22 = Math_fround(f15 * Math_fround(HEAPF32[i46 >> 2]));
        f72 = Math_fround(f23 * Math_fround(HEAPF32[i47 >> 2]));
        i17 = f73 < Math_fround(0.0);
        f23 = i17 ? Math_fround(0.0) : f73;
        i17 = f23 > Math_fround(1.0);
        i17 = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i16 = f20 < Math_fround(0.0);
        f23 = i16 ? Math_fround(0.0) : f20;
        i16 = f23 > Math_fround(1.0);
        i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i19 = f22 < Math_fround(0.0);
        f23 = i19 ? Math_fround(0.0) : f22;
        i19 = f23 > Math_fround(1.0);
        i19 = ~~Math_fround(Math_fround((i19 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i21 = f72 < Math_fround(0.0);
        f72 = i21 ? Math_fround(0.0) : f72;
        i21 = f72 > Math_fround(1.0);
        HEAP32[i65 + (i24 * 60 | 0) + 24 >> 2] = i16 << 8 & 65280 | i17 << 16 & 16711680 | i19 & 255 | ~~Math_fround(Math_fround((i21 ? Math_fround(1.0) : f72) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
        i21 = i5 + (Math_imul(i14, i11) | 0) | 0;
        i21 = i48 ? gb + 1162356 | 0 : i21;
        i19 = HEAP32[i21 + 4 >> 2] | 0;
        i17 = i65 + (i24 * 60 | 0) + 28 | 0;
        HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i17 + 4 >> 2] = i19;
        i17 = i2 + (Math_imul(i14, i10) | 0) | 0;
        i17 = i49 ? gb + 1162356 | 0 : i17;
        i19 = HEAP32[i17 + 4 >> 2] | 0;
        i21 = i65 + (i24 * 60 | 0) + 36 | 0;
        HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
        HEAP32[i21 + 4 >> 2] = i19;
        if (i50) {
         i16 = 1065353216;
         i17 = -1082130432;
         i19 = 0;
         i21 = 0;
        } else {
         i21 = i54 + (Math_imul(i14, i51) | 0) | 0;
         i16 = HEAP32[i21 >> 2] | 0;
         i17 = HEAP32[i21 + 12 >> 2] | 0;
         i19 = HEAP32[i21 + 4 >> 2] | 0;
         i21 = HEAP32[i21 + 8 >> 2] | 0;
        }
        f73 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f23 = Math_fround(f33 * f73);
        f20 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f23 = Math_fround(Math_fround(f36 * f20) + f23);
        f22 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f72 = Math_fround(Math_fround(f52 * f22) + Math_fround(Math_fround(f37 * f20) + Math_fround(f34 * f73)));
        f73 = Math_fround(Math_fround(f53 * f22) + Math_fround(Math_fround(f38 * f20) + Math_fround(f35 * f73)));
        HEAPF32[i65 + (i24 * 60 | 0) + 44 >> 2] = Math_fround(Math_fround(f39 * f22) + f23);
        HEAPF32[i65 + (i24 * 60 | 0) + 48 >> 2] = f72;
        HEAPF32[i65 + (i24 * 60 | 0) + 52 >> 2] = f73;
        HEAP32[i65 + (i24 * 60 | 0) + 56 >> 2] = i17;
        i14 = i14 + 1 | 0;
        if ((i14 | 0) == (i56 | 0)) break L14;
        f15 = Math_fround(HEAPF32[i57 >> 2]);
        f18 = Math_fround(HEAPF32[i26 >> 2]);
        f20 = Math_fround(HEAPF32[i29 >> 2]);
       }
      }
     } while (0);
     i8 = (HEAP32[(HEAP32[i55 >> 2] | 0) + 112 >> 2] | 0) + (HEAP32[i60 + (i62 * 108 | 0) + 12 >> 2] | 0) | 0;
     i6 = i4 - (HEAP32[i59 >> 2] | 0) - (HEAP32[i60 + (i62 * 108 | 0) + 100 >> 2] | 0) | 0;
     i7 = HEAP32[i60 + (i62 * 108 | 0) + 16 >> 2] | 0;
     if (i7 | 0) {
      i2 = i64 + (i3 << 1) | 0;
      i5 = 0;
      while (1) {
       HEAP16[i2 >> 1] = i6 + (HEAPU16[i8 + (i5 << 1) >> 1] | 0);
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i7 | 0)) break; else i2 = i2 + 2 | 0;
      }
     }
     i4 = (HEAP32[i61 >> 2] | 0) + i4 | 0;
     i3 = i7 + i3 | 0;
     i2 = HEAP32[i67 >> 2] | 0;
    }
    i62 = i62 + 1 | 0;
    if (i62 >>> 0 >= i2 >>> 0) {
     i3 = 8;
     break;
    }
   }
  }
 } else i3 = 8;
 if ((i3 | 0) == 8) {
  i1 = i66 + 20 | 0;
  if (i2) {
   i3 = 0;
   do {
    i2 = HEAP32[i1 >> 2] | 0;
    if (HEAP8[i2 + (i3 * 108 | 0) + 104 >> 0] | 0) {
     i2 = HEAP32[i2 + (i3 * 108 | 0) >> 2] | 0;
     i66 = i2 + 4 | 0;
     HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + -1;
     if (!(HEAP32[i66 >> 2] | 0)) {
      mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
      __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
     }
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i67 >> 2] | 0) >>> 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64024 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i68 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i68 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i70, gb + 64024 | 0);
 if (!i69) {
  STACKTOP = i71;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i69);
 STACKTOP = i71;
 return;
}

function __ZN13InitialModule18GenerateProceduralERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fRK8Vector3fRK24ParticleSystemEmitReplayRj(i8, i1, i209, i2, i6, i7, i210) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i209 = i209 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i210 = i210 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, f194 = f0, f195 = f0, i196 = 0, i197 = 0, i198 = 0, f199 = f0, f200 = f0, i201 = 0, i202 = 0, f203 = f0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, f208 = f0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, f222 = f0, f223 = f0, i224 = 0, f225 = f0;
 i215 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i211 = i215 + 48 | 0;
 i212 = i215 + 32 | 0;
 i213 = i215 + 16 | 0;
 i207 = i215;
 f208 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f203 = Math_fround(HEAPF32[i7 >> 2]);
 f203 = Math_fround(f203 / Math_fround(HEAPF32[i1 + 264 >> 2]));
 i204 = HEAP32[i2 + 48 >> 2] | 0;
 i205 = HEAP32[i2 + 52 >> 2] | 0;
 i206 = HEAP32[i2 + 56 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f199 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f200 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f199 * f199) + Math_fround(0.0)));
 f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f200))));
 f3 = Math_fround(f3 * f5);
 f4 = Math_fround(f4 * f5);
 f5 = Math_fround(f199 * f5);
 i1 = f200 > Math_fround(9.99999974e-06);
 i202 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i201 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i198 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 f199 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f200 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 i197 = HEAP32[i6 >> 2] | 0;
 i196 = HEAP32[i6 + 4 >> 2] | 0;
 i193 = HEAP32[i6 + 8 >> 2] | 0;
 f194 = Math_fround(HEAPF32[i8 + 2540 >> 2]);
 f195 = Math_fround((HEAP32[i7 + 20 >> 2] | 0) >>> 0);
 i151 = i7 + 16 | 0;
 i1 = HEAP32[i151 >> 2] | 0;
 if (!i1) {
  STACKTOP = i215;
  return;
 }
 i152 = i8 + 8 | 0;
 i153 = i212 + 12 | 0;
 i154 = i212 + 8 | 0;
 i155 = i212 + 4 | 0;
 i156 = i8 + 2556 | 0;
 i157 = i8 + 2560 | 0;
 i158 = i8 + 2564 | 0;
 i159 = i8 + 2568 | 0;
 i160 = i8 + 2572 | 0;
 i161 = i8 + 2576 | 0;
 i162 = i8 + 2580 | 0;
 i163 = i8 + 2584 | 0;
 i164 = i8 + 2588 | 0;
 i165 = i8 + 2592 | 0;
 i166 = i8 + 2596 | 0;
 i167 = i8 + 2600 | 0;
 i168 = i8 + 2604 | 0;
 i169 = i8 + 2608 | 0;
 i170 = i8 + 2612 | 0;
 i171 = i8 + 2616 | 0;
 i172 = i213 + 4 | 0;
 i173 = i213 + 8 | 0;
 i174 = i213 + 12 | 0;
 i175 = i8 + 92 | 0;
 i176 = i211 + 4 | 0;
 i177 = i211 + 8 | 0;
 i178 = i211 + 12 | 0;
 i179 = i209 + 500 | 0;
 i180 = i209 + 20 | 0;
 i181 = i209 + 40 | 0;
 i182 = i209 + 60 | 0;
 i183 = i209 + 80 | 0;
 i184 = i209 + 100 | 0;
 i185 = i209 + 120 | 0;
 i186 = i209 + 140 | 0;
 i187 = i209 + 160 | 0;
 i188 = i209 + 520 | 0;
 i189 = i209 + 540 | 0;
 i190 = i8 + 692 | 0;
 i191 = i212 + 12 | 0;
 i192 = i212 + 8 | 0;
 i37 = i212 + 4 | 0;
 i38 = i213 + 4 | 0;
 i39 = i213 + 8 | 0;
 i40 = i213 + 12 | 0;
 i41 = i8 + 776 | 0;
 i42 = i211 + 4 | 0;
 i43 = i211 + 8 | 0;
 i44 = i211 + 12 | 0;
 i45 = i209 + 420 | 0;
 i46 = i209 + 871 | 0;
 i47 = i8 + 2012 | 0;
 i48 = i212 + 12 | 0;
 i49 = i212 + 8 | 0;
 i50 = i212 + 4 | 0;
 i51 = i213 + 4 | 0;
 i52 = i213 + 8 | 0;
 i53 = i213 + 12 | 0;
 i54 = i8 + 2096 | 0;
 i55 = i211 + 4 | 0;
 i56 = i211 + 8 | 0;
 i57 = i211 + 12 | 0;
 i58 = i209 + 340 | 0;
 i59 = i209 + 870 | 0;
 i60 = i209 + 869 | 0;
 i61 = i209 + 872 | 0;
 i62 = i8 + 536 | 0;
 i63 = i211 + 12 | 0;
 i64 = i211 + 8 | 0;
 i65 = i211 + 4 | 0;
 i66 = i212 + 4 | 0;
 i67 = i212 + 8 | 0;
 i68 = i212 + 12 | 0;
 i69 = i8 + 676 | 0;
 i70 = i8 + 604 | 0;
 i30 = i207 + 4 | 0;
 i31 = i207 + 8 | 0;
 i32 = i207 + 12 | 0;
 i71 = i209 + 480 | 0;
 i72 = i209 + 868 | 0;
 i73 = i209 + 240 | 0;
 i74 = i209 + 260 | 0;
 i75 = i209 + 280 | 0;
 i76 = i209 + 880 | 0;
 i77 = i209 + 873 | 0;
 i78 = i209 + 876 | 0;
 i79 = i209 + 728 | 0;
 i80 = i209 + 608 | 0;
 i81 = i209 + 180 | 0;
 i82 = i209 + 200 | 0;
 i83 = i209 + 220 | 0;
 i84 = i209 + 400 | 0;
 i85 = i209 + 360 | 0;
 i86 = i209 + 380 | 0;
 i87 = i8 + 2553 | 0;
 i88 = i209 + 300 | 0;
 i89 = i209 + 320 | 0;
 i90 = i8 + 1484 | 0;
 i91 = i212 + 12 | 0;
 i92 = i212 + 8 | 0;
 i93 = i212 + 4 | 0;
 i94 = i213 + 4 | 0;
 i95 = i213 + 8 | 0;
 i96 = i213 + 12 | 0;
 i97 = i8 + 1568 | 0;
 i98 = i211 + 4 | 0;
 i99 = i211 + 8 | 0;
 i100 = i211 + 12 | 0;
 i101 = i8 + 1748 | 0;
 i102 = i212 + 12 | 0;
 i103 = i212 + 8 | 0;
 i104 = i212 + 4 | 0;
 i105 = i213 + 4 | 0;
 i106 = i213 + 8 | 0;
 i107 = i213 + 12 | 0;
 i108 = i8 + 1832 | 0;
 i109 = i211 + 4 | 0;
 i110 = i211 + 8 | 0;
 i111 = i211 + 12 | 0;
 i112 = i8 + 1828 | 0;
 i113 = i8 + 1980 | 0;
 i114 = i8 + 1892 | 0;
 i115 = i8 + 1564 | 0;
 i116 = i8 + 1716 | 0;
 i117 = i8 + 1628 | 0;
 i118 = i8 + 2092 | 0;
 i119 = i8 + 2244 | 0;
 i120 = i8 + 2156 | 0;
 i121 = i8 + 2552 | 0;
 i34 = i211 + 4 | 0;
 i36 = i211 + 8 | 0;
 i29 = i211 + 12 | 0;
 i122 = i209 + 440 | 0;
 i33 = i211 + 4 | 0;
 i35 = i211 + 8 | 0;
 i28 = i211 + 12 | 0;
 i123 = i209 + 460 | 0;
 i124 = i8 + 1220 | 0;
 i125 = i212 + 12 | 0;
 i126 = i212 + 8 | 0;
 i127 = i212 + 4 | 0;
 i128 = i213 + 4 | 0;
 i129 = i213 + 8 | 0;
 i130 = i213 + 12 | 0;
 i131 = i8 + 1304 | 0;
 i132 = i8 + 1300 | 0;
 i133 = i8 + 1452 | 0;
 i134 = i8 + 1364 | 0;
 i135 = i8 + 956 | 0;
 i136 = i212 + 12 | 0;
 i137 = i212 + 8 | 0;
 i138 = i212 + 4 | 0;
 i139 = i213 + 4 | 0;
 i140 = i213 + 8 | 0;
 i141 = i213 + 12 | 0;
 i142 = i8 + 1040 | 0;
 i143 = i8 + 1036 | 0;
 i144 = i8 + 1188 | 0;
 i145 = i8 + 1100 | 0;
 i146 = i8 + 772 | 0;
 i147 = i8 + 924 | 0;
 i148 = i8 + 836 | 0;
 i149 = i8 + 88 | 0;
 i150 = i8 + 240 | 0;
 i23 = i8 + 152 | 0;
 i24 = i209 + 844 | 0;
 i25 = i209 + 864 | 0;
 i26 = i209 + 848 | 0;
 i27 = i209 + 828 | 0;
 i18 = 0;
 f19 = Math_fround(0.0);
 f20 = Math_fround(2.0);
 f21 = Math_fround(3.0);
 f22 = Math_fround(1.0);
 do {
  f11 = Math_fround(f200 * Math_fround(f199 + f19));
  f12 = Math_fround(f200 * Math_fround(f199 + f22));
  f13 = Math_fround(f200 * Math_fround(f199 + f20));
  f14 = Math_fround(f200 * Math_fround(f199 + f21));
  i6 = f19 < f195;
  i7 = f22 < f195;
  i8 = f20 < f195;
  i15 = f21 < f195;
  HEAPF32[i153 >> 2] = f203;
  HEAPF32[i154 >> 2] = f203;
  HEAPF32[i155 >> 2] = f203;
  HEAPF32[i212 >> 2] = f203;
  i221 = HEAP32[i156 >> 2] | 0;
  i220 = HEAP32[i157 >> 2] | 0;
  i219 = HEAP32[i158 >> 2] | 0;
  i218 = HEAP32[i159 >> 2] | 0;
  i221 = i221 << 11 ^ i221;
  i220 = i220 << 11 ^ i220;
  i219 = i219 << 11 ^ i219;
  i218 = i218 << 11 ^ i218;
  i217 = HEAP32[i161 >> 2] | 0;
  i216 = HEAP32[i162 >> 2] | 0;
  i17 = HEAP32[i163 >> 2] | 0;
  HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
  HEAP32[i157 >> 2] = i217;
  HEAP32[i158 >> 2] = i216;
  HEAP32[i159 >> 2] = i17;
  i17 = HEAP32[i165 >> 2] | 0;
  i216 = HEAP32[i166 >> 2] | 0;
  i217 = HEAP32[i167 >> 2] | 0;
  HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
  HEAP32[i161 >> 2] = i17;
  HEAP32[i162 >> 2] = i216;
  HEAP32[i163 >> 2] = i217;
  i217 = HEAP32[i168 >> 2] | 0;
  i216 = HEAP32[i169 >> 2] | 0;
  i17 = HEAP32[i170 >> 2] | 0;
  i2 = HEAP32[i171 >> 2] | 0;
  HEAP32[i164 >> 2] = i217;
  HEAP32[i165 >> 2] = i216;
  HEAP32[i166 >> 2] = i17;
  HEAP32[i167 >> 2] = i2;
  i217 = i221 >>> 8 ^ i221 ^ i217 ^ i217 >>> 19;
  i216 = i220 >>> 8 ^ i220 ^ i216 ^ i216 >>> 19;
  i17 = i219 >>> 8 ^ i219 ^ i17 ^ i17 >>> 19;
  i2 = i218 >>> 8 ^ i218 ^ i2 ^ i2 >>> 19;
  HEAP32[i168 >> 2] = i217;
  HEAP32[i169 >> 2] = i216;
  HEAP32[i170 >> 2] = i17;
  HEAP32[i171 >> 2] = i2;
  f3 = Math_fround(Math_fround(i217 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(Math_fround(i216 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f5 = Math_fround(Math_fround(i17 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i213 >> 2] = f3;
  HEAPF32[i172 >> 2] = f4;
  HEAPF32[i173 >> 2] = f5;
  HEAPF32[i174 >> 2] = f9;
  i2 = HEAP32[i175 >> 2] | 0;
  L6 : do switch ((i2 & 65535) << 16 >> 16) {
  case 0:
   {
    i221 = HEAP32[i149 >> 2] | 0;
    HEAP32[i178 >> 2] = i221;
    HEAP32[i177 >> 2] = i221;
    HEAP32[i176 >> 2] = i221;
    HEAP32[i211 >> 2] = i221;
    break;
   }
  case 3:
   {
    f223 = Math_fround(HEAPF32[(HEAP32[i150 >> 2] | 0) + 4 >> 2]);
    f222 = Math_fround(HEAPF32[i149 >> 2]);
    f223 = Math_fround(f223 * f222);
    f222 = Math_fround(Math_fround(f222 * Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + 4 >> 2])) - f223);
    f4 = Math_fround(f223 + Math_fround(f222 * f4));
    f10 = Math_fround(f223 + Math_fround(f222 * f5));
    f16 = Math_fround(f223 + Math_fround(f9 * f222));
    HEAPF32[i211 >> 2] = Math_fround(f223 + Math_fround(f3 * f222));
    HEAPF32[i176 >> 2] = f4;
    HEAPF32[i177 >> 2] = f10;
    HEAPF32[i178 >> 2] = f16;
    break;
   }
  default:
   if (!(i2 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i152, i212, i213);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i152, i212, i213);
    break L6;
   }
  } while (0);
  f4 = Math_fround(HEAPF32[i211 >> 2]);
  i221 = f4 < Math_fround(9.99999974e-06);
  f4 = i221 ? Math_fround(9.99999974e-06) : f4;
  f9 = Math_fround(HEAPF32[i176 >> 2]);
  i221 = f9 < Math_fround(9.99999974e-06);
  f9 = i221 ? Math_fround(9.99999974e-06) : f9;
  f5 = Math_fround(HEAPF32[i177 >> 2]);
  i221 = f5 < Math_fround(9.99999974e-06);
  f5 = i221 ? Math_fround(9.99999974e-06) : f5;
  f10 = Math_fround(HEAPF32[i178 >> 2]);
  i221 = f10 < Math_fround(9.99999974e-06);
  f10 = i221 ? Math_fround(9.99999974e-06) : f10;
  f16 = Math_fround(f4 - f208);
  f222 = Math_fround(f9 - f208);
  f223 = Math_fround(f5 - f208);
  f3 = Math_fround(f10 - f208);
  f16 = Math_fround(f16 - (i6 ? f11 : Math_fround(0.0)));
  f12 = Math_fround(f222 - (i7 ? f12 : Math_fround(0.0)));
  f11 = Math_fround(f223 - (i8 ? f13 : Math_fround(0.0)));
  f3 = Math_fround(f3 - (i15 ? f14 : Math_fround(0.0)));
  if (!(f16 <= Math_fround(0.0) & f12 <= Math_fround(0.0) & f11 <= Math_fround(0.0) & f3 <= Math_fround(0.0))) {
   f223 = Math_fround(Math_fround(1.0) / f4);
   f9 = Math_fround(Math_fround(1.0) / f9);
   f5 = Math_fround(Math_fround(1.0) / f5);
   f4 = Math_fround(Math_fround(1.0) / f10);
   i17 = HEAP32[i210 >> 2] | 0;
   HEAP32[i210 >> 2] = i17 + (i1 >>> 0 > 4 ? 4 : i1);
   i1 = i1 + -4 | 0;
   i15 = HEAP32[i156 >> 2] | 0;
   i8 = HEAP32[i157 >> 2] | 0;
   i7 = HEAP32[i158 >> 2] | 0;
   i6 = HEAP32[i159 >> 2] | 0;
   i15 = i15 << 11 ^ i15;
   i8 = i8 << 11 ^ i8;
   i7 = i7 << 11 ^ i7;
   i6 = i6 << 11 ^ i6;
   i218 = HEAP32[i161 >> 2] | 0;
   i217 = HEAP32[i162 >> 2] | 0;
   i216 = HEAP32[i163 >> 2] | 0;
   HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
   HEAP32[i157 >> 2] = i218;
   HEAP32[i158 >> 2] = i217;
   HEAP32[i159 >> 2] = i216;
   i216 = HEAP32[i165 >> 2] | 0;
   i217 = HEAP32[i166 >> 2] | 0;
   i218 = HEAP32[i167 >> 2] | 0;
   HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
   HEAP32[i161 >> 2] = i216;
   HEAP32[i162 >> 2] = i217;
   HEAP32[i163 >> 2] = i218;
   i218 = HEAP32[i168 >> 2] | 0;
   i217 = HEAP32[i169 >> 2] | 0;
   i216 = HEAP32[i170 >> 2] | 0;
   i224 = HEAP32[i171 >> 2] | 0;
   HEAP32[i164 >> 2] = i218;
   HEAP32[i165 >> 2] = i217;
   HEAP32[i166 >> 2] = i216;
   HEAP32[i167 >> 2] = i224;
   i218 = i15 >>> 8 ^ i15 ^ i218 ^ i218 >>> 19;
   i217 = i8 >>> 8 ^ i8 ^ i217 ^ i217 >>> 19;
   i216 = i7 >>> 8 ^ i7 ^ i216 ^ i216 >>> 19;
   i224 = i6 >>> 8 ^ i6 ^ i224 ^ i224 >>> 19;
   HEAP32[i168 >> 2] = i218;
   HEAP32[i169 >> 2] = i217;
   HEAP32[i170 >> 2] = i216;
   HEAP32[i171 >> 2] = i224;
   i6 = (HEAP32[i179 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i6 >> 2] = i218;
   HEAP32[i6 + 4 >> 2] = i217;
   HEAP32[i6 + 8 >> 2] = i216;
   HEAP32[i6 + 12 >> 2] = i224;
   i218 = i218 + -13913692 | 0;
   i217 = i217 + -13913692 | 0;
   i216 = i216 + -13913692 | 0;
   i224 = i224 + -13913692 | 0;
   i6 = (Math_imul(i218, 1790253981) | 0) + 1900727103 | 0;
   i7 = (Math_imul(i217, 1790253981) | 0) + 1900727103 | 0;
   i8 = (Math_imul(i216, 1790253981) | 0) + 1900727103 | 0;
   i15 = (Math_imul(i224, 1790253981) | 0) + 1900727103 | 0;
   i218 = i218 << 11 ^ i218;
   i217 = i217 << 11 ^ i217;
   i216 = i216 << 11 ^ i216;
   i224 = i224 << 11 ^ i224;
   i6 = Math_fround(Math_fround((i6 ^ i218 ^ i218 >>> 8) & 8388607 ^ i6 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f194;
   i7 = Math_fround(Math_fround((i7 ^ i217 ^ i217 >>> 8) & 8388607 ^ i7 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f194;
   i8 = Math_fround(Math_fround((i8 ^ i216 ^ i216 >>> 8) & 8388607 ^ i8 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f194;
   i15 = Math_fround(Math_fround((i15 ^ i224 ^ i224 >>> 8) & 8388607 ^ i15 >>> 19 | 0) * Math_fround(1.19209304e-07)) > f194;
   i224 = (HEAP32[i209 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i204;
   HEAP32[i224 + 4 >> 2] = i204;
   HEAP32[i224 + 8 >> 2] = i204;
   HEAP32[i224 + 12 >> 2] = i204;
   i224 = (HEAP32[i180 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i205;
   HEAP32[i224 + 4 >> 2] = i205;
   HEAP32[i224 + 8 >> 2] = i205;
   HEAP32[i224 + 12 >> 2] = i205;
   i224 = (HEAP32[i181 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i206;
   HEAP32[i224 + 4 >> 2] = i206;
   HEAP32[i224 + 8 >> 2] = i206;
   HEAP32[i224 + 12 >> 2] = i206;
   i224 = (HEAP32[i182 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i202;
   HEAP32[i224 + 4 >> 2] = i202;
   HEAP32[i224 + 8 >> 2] = i202;
   HEAP32[i224 + 12 >> 2] = i202;
   i224 = (HEAP32[i183 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i201;
   HEAP32[i224 + 4 >> 2] = i201;
   HEAP32[i224 + 8 >> 2] = i201;
   HEAP32[i224 + 12 >> 2] = i201;
   i224 = (HEAP32[i184 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = i198;
   HEAP32[i224 + 4 >> 2] = i198;
   HEAP32[i224 + 8 >> 2] = i198;
   HEAP32[i224 + 12 >> 2] = i198;
   i224 = (HEAP32[i185 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = 0;
   HEAP32[i224 + 4 >> 2] = 0;
   HEAP32[i224 + 8 >> 2] = 0;
   HEAP32[i224 + 12 >> 2] = 0;
   i224 = (HEAP32[i186 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = 0;
   HEAP32[i224 + 4 >> 2] = 0;
   HEAP32[i224 + 8 >> 2] = 0;
   HEAP32[i224 + 12 >> 2] = 0;
   i224 = (HEAP32[i187 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = 0;
   HEAP32[i224 + 4 >> 2] = 0;
   HEAP32[i224 + 8 >> 2] = 0;
   HEAP32[i224 + 12 >> 2] = 0;
   f14 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f223 * f16)) * Math_fround(100.0));
   f16 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f9 * f12)) * Math_fround(100.0));
   f222 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f5 * f11)) * Math_fround(100.0));
   f3 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f4 * f3)) * Math_fround(100.0));
   i224 = (HEAP32[i188 >> 2] | 0) + (i17 << 2) | 0;
   HEAPF32[i224 >> 2] = f14;
   HEAPF32[i224 + 4 >> 2] = f16;
   HEAPF32[i224 + 8 >> 2] = f222;
   HEAPF32[i224 + 12 >> 2] = f3;
   i224 = (HEAP32[i189 >> 2] | 0) + (i17 << 2) | 0;
   HEAPF32[i224 >> 2] = f223;
   HEAPF32[i224 + 4 >> 2] = f9;
   HEAPF32[i224 + 8 >> 2] = f5;
   HEAPF32[i224 + 12 >> 2] = f4;
   HEAPF32[i191 >> 2] = f203;
   HEAPF32[i192 >> 2] = f203;
   HEAPF32[i37 >> 2] = f203;
   HEAPF32[i212 >> 2] = f203;
   i224 = HEAP32[i156 >> 2] | 0;
   i216 = HEAP32[i157 >> 2] | 0;
   i217 = HEAP32[i158 >> 2] | 0;
   i218 = HEAP32[i159 >> 2] | 0;
   i224 = i224 << 11 ^ i224;
   i216 = i216 << 11 ^ i216;
   i217 = i217 << 11 ^ i217;
   i218 = i218 << 11 ^ i218;
   i219 = HEAP32[i161 >> 2] | 0;
   i220 = HEAP32[i162 >> 2] | 0;
   i221 = HEAP32[i163 >> 2] | 0;
   HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
   HEAP32[i157 >> 2] = i219;
   HEAP32[i158 >> 2] = i220;
   HEAP32[i159 >> 2] = i221;
   i221 = HEAP32[i165 >> 2] | 0;
   i220 = HEAP32[i166 >> 2] | 0;
   i219 = HEAP32[i167 >> 2] | 0;
   HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
   HEAP32[i161 >> 2] = i221;
   HEAP32[i162 >> 2] = i220;
   HEAP32[i163 >> 2] = i219;
   i219 = HEAP32[i168 >> 2] | 0;
   i220 = HEAP32[i169 >> 2] | 0;
   i221 = HEAP32[i170 >> 2] | 0;
   i2 = HEAP32[i171 >> 2] | 0;
   HEAP32[i164 >> 2] = i219;
   HEAP32[i165 >> 2] = i220;
   HEAP32[i166 >> 2] = i221;
   HEAP32[i167 >> 2] = i2;
   i219 = i224 >>> 8 ^ i224 ^ i219 ^ i219 >>> 19;
   i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
   i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
   i2 = i218 >>> 8 ^ i218 ^ i2 ^ i2 >>> 19;
   HEAP32[i168 >> 2] = i219;
   HEAP32[i169 >> 2] = i220;
   HEAP32[i170 >> 2] = i221;
   HEAP32[i171 >> 2] = i2;
   f3 = Math_fround(Math_fround(i219 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i213 >> 2] = f3;
   HEAPF32[i38 >> 2] = f4;
   HEAPF32[i39 >> 2] = f5;
   HEAPF32[i40 >> 2] = f9;
   i2 = HEAP32[i41 >> 2] | 0;
   L16 : do switch ((i2 & 65535) << 16 >> 16) {
   case 0:
    {
     i224 = HEAP32[i146 >> 2] | 0;
     HEAP32[i44 >> 2] = i224;
     HEAP32[i43 >> 2] = i224;
     HEAP32[i42 >> 2] = i224;
     HEAP32[i211 >> 2] = i224;
     break;
    }
   case 3:
    {
     f13 = Math_fround(HEAPF32[(HEAP32[i147 >> 2] | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i146 >> 2]);
     f13 = Math_fround(f13 * f14);
     f14 = Math_fround(Math_fround(f14 * Math_fround(HEAPF32[(HEAP32[i148 >> 2] | 0) + 4 >> 2])) - f13);
     f16 = Math_fround(f13 + Math_fround(f14 * f4));
     f222 = Math_fround(f13 + Math_fround(f14 * f5));
     f223 = Math_fround(f13 + Math_fround(f9 * f14));
     HEAPF32[i211 >> 2] = Math_fround(f13 + Math_fround(f3 * f14));
     HEAPF32[i42 >> 2] = f16;
     HEAPF32[i43 >> 2] = f222;
     HEAPF32[i44 >> 2] = f223;
     break;
    }
   default:
    if (!(i2 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i190, i212, i213);
     break L16;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i190, i212, i213);
     break L16;
    }
   } while (0);
   f3 = Math_fround(HEAPF32[i211 >> 2]);
   i224 = f3 < Math_fround(0.0);
   f3 = i224 ? Math_fround(0.0) : f3;
   f5 = Math_fround(HEAPF32[i42 >> 2]);
   i224 = f5 < Math_fround(0.0);
   f5 = i224 ? Math_fround(0.0) : f5;
   f4 = Math_fround(HEAPF32[i43 >> 2]);
   i224 = f4 < Math_fround(0.0);
   f4 = i224 ? Math_fround(0.0) : f4;
   f9 = Math_fround(HEAPF32[i44 >> 2]);
   i224 = f9 < Math_fround(0.0);
   f9 = i224 ? Math_fround(0.0) : f9;
   i224 = (HEAP32[i45 >> 2] | 0) + (i17 << 2) | 0;
   HEAPF32[i224 >> 2] = f3;
   HEAPF32[i224 + 4 >> 2] = f5;
   HEAPF32[i224 + 8 >> 2] = f4;
   HEAPF32[i224 + 12 >> 2] = f9;
   if (HEAP8[i46 >> 0] | 0) {
    if (!(HEAP8[i121 >> 0] | 0)) {
     i214 = (HEAP32[i122 >> 2] | 0) + (i17 << 2) | 0;
     HEAPF32[i214 >> 2] = f3;
     HEAPF32[i214 + 4 >> 2] = f5;
     HEAPF32[i214 + 8 >> 2] = f4;
     HEAPF32[i214 + 12 >> 2] = f9;
     i214 = 34;
    } else {
     HEAPF32[i136 >> 2] = f203;
     HEAPF32[i137 >> 2] = f203;
     HEAPF32[i138 >> 2] = f203;
     HEAPF32[i212 >> 2] = f203;
     i216 = HEAP32[i156 >> 2] | 0;
     i217 = HEAP32[i157 >> 2] | 0;
     i218 = HEAP32[i158 >> 2] | 0;
     i219 = HEAP32[i159 >> 2] | 0;
     i216 = i216 << 11 ^ i216;
     i217 = i217 << 11 ^ i217;
     i218 = i218 << 11 ^ i218;
     i219 = i219 << 11 ^ i219;
     i220 = HEAP32[i161 >> 2] | 0;
     i221 = HEAP32[i162 >> 2] | 0;
     i224 = HEAP32[i163 >> 2] | 0;
     HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
     HEAP32[i157 >> 2] = i220;
     HEAP32[i158 >> 2] = i221;
     HEAP32[i159 >> 2] = i224;
     i224 = HEAP32[i165 >> 2] | 0;
     i221 = HEAP32[i166 >> 2] | 0;
     i220 = HEAP32[i167 >> 2] | 0;
     HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
     HEAP32[i161 >> 2] = i224;
     HEAP32[i162 >> 2] = i221;
     HEAP32[i163 >> 2] = i220;
     i220 = HEAP32[i168 >> 2] | 0;
     i221 = HEAP32[i169 >> 2] | 0;
     i224 = HEAP32[i170 >> 2] | 0;
     i2 = HEAP32[i171 >> 2] | 0;
     HEAP32[i164 >> 2] = i220;
     HEAP32[i165 >> 2] = i221;
     HEAP32[i166 >> 2] = i224;
     HEAP32[i167 >> 2] = i2;
     i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
     i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
     i224 = i218 >>> 8 ^ i218 ^ i224 ^ i224 >>> 19;
     i2 = i219 >>> 8 ^ i219 ^ i2 ^ i2 >>> 19;
     HEAP32[i168 >> 2] = i220;
     HEAP32[i169 >> 2] = i221;
     HEAP32[i170 >> 2] = i224;
     HEAP32[i171 >> 2] = i2;
     f10 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f11 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f12 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
     f13 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
     HEAPF32[i213 >> 2] = f10;
     HEAPF32[i139 >> 2] = f11;
     HEAPF32[i140 >> 2] = f12;
     HEAPF32[i141 >> 2] = f13;
     i2 = HEAP32[i142 >> 2] | 0;
     L29 : do switch ((i2 & 65535) << 16 >> 16) {
     case 0:
      {
       i224 = HEAP32[i143 >> 2] | 0;
       HEAP32[i29 >> 2] = i224;
       HEAP32[i36 >> 2] = i224;
       HEAP32[i34 >> 2] = i224;
       HEAP32[i211 >> 2] = i224;
       break;
      }
     case 3:
      {
       f225 = Math_fround(HEAPF32[(HEAP32[i144 >> 2] | 0) + 4 >> 2]);
       f14 = Math_fround(HEAPF32[i143 >> 2]);
       f225 = Math_fround(f225 * f14);
       f14 = Math_fround(Math_fround(f14 * Math_fround(HEAPF32[(HEAP32[i145 >> 2] | 0) + 4 >> 2])) - f225);
       f16 = Math_fround(f225 + Math_fround(f14 * f11));
       f222 = Math_fround(f225 + Math_fround(f14 * f12));
       f223 = Math_fround(f225 + Math_fround(f13 * f14));
       HEAPF32[i211 >> 2] = Math_fround(f225 + Math_fround(f10 * f14));
       HEAPF32[i34 >> 2] = f16;
       HEAPF32[i36 >> 2] = f222;
       HEAPF32[i29 >> 2] = f223;
       break;
      }
     default:
      if (!(i2 & 16711680)) {
       __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i135, i212, i213);
       break L29;
      } else {
       __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i135, i212, i213);
       break L29;
      }
     } while (0);
     f16 = Math_fround(HEAPF32[i211 >> 2]);
     i224 = f16 < Math_fround(0.0);
     f16 = i224 ? Math_fround(0.0) : f16;
     f222 = Math_fround(HEAPF32[i34 >> 2]);
     i224 = f222 < Math_fround(0.0);
     f222 = i224 ? Math_fround(0.0) : f222;
     f223 = Math_fround(HEAPF32[i36 >> 2]);
     i224 = f223 < Math_fround(0.0);
     f223 = i224 ? Math_fround(0.0) : f223;
     f225 = Math_fround(HEAPF32[i29 >> 2]);
     i224 = f225 < Math_fround(0.0);
     f225 = i224 ? Math_fround(0.0) : f225;
     i224 = (HEAP32[i122 >> 2] | 0) + (i17 << 2) | 0;
     HEAPF32[i224 >> 2] = f16;
     HEAPF32[i224 + 4 >> 2] = f222;
     HEAPF32[i224 + 8 >> 2] = f223;
     HEAPF32[i224 + 12 >> 2] = f225;
     if (!(HEAP8[i121 >> 0] | 0)) i214 = 34; else {
      HEAPF32[i125 >> 2] = f203;
      HEAPF32[i126 >> 2] = f203;
      HEAPF32[i127 >> 2] = f203;
      HEAPF32[i212 >> 2] = f203;
      i216 = HEAP32[i156 >> 2] | 0;
      i217 = HEAP32[i157 >> 2] | 0;
      i218 = HEAP32[i158 >> 2] | 0;
      i219 = HEAP32[i159 >> 2] | 0;
      i216 = i216 << 11 ^ i216;
      i217 = i217 << 11 ^ i217;
      i218 = i218 << 11 ^ i218;
      i219 = i219 << 11 ^ i219;
      i220 = HEAP32[i161 >> 2] | 0;
      i221 = HEAP32[i162 >> 2] | 0;
      i224 = HEAP32[i163 >> 2] | 0;
      HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
      HEAP32[i157 >> 2] = i220;
      HEAP32[i158 >> 2] = i221;
      HEAP32[i159 >> 2] = i224;
      i224 = HEAP32[i165 >> 2] | 0;
      i221 = HEAP32[i166 >> 2] | 0;
      i220 = HEAP32[i167 >> 2] | 0;
      HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
      HEAP32[i161 >> 2] = i224;
      HEAP32[i162 >> 2] = i221;
      HEAP32[i163 >> 2] = i220;
      i220 = HEAP32[i168 >> 2] | 0;
      i221 = HEAP32[i169 >> 2] | 0;
      i224 = HEAP32[i170 >> 2] | 0;
      i2 = HEAP32[i171 >> 2] | 0;
      HEAP32[i164 >> 2] = i220;
      HEAP32[i165 >> 2] = i221;
      HEAP32[i166 >> 2] = i224;
      HEAP32[i167 >> 2] = i2;
      i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
      i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
      i224 = i218 >>> 8 ^ i218 ^ i224 ^ i224 >>> 19;
      i2 = i219 >>> 8 ^ i219 ^ i2 ^ i2 >>> 19;
      HEAP32[i168 >> 2] = i220;
      HEAP32[i169 >> 2] = i221;
      HEAP32[i170 >> 2] = i224;
      HEAP32[i171 >> 2] = i2;
      f3 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
      f4 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
      f5 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
      f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
      HEAPF32[i213 >> 2] = f3;
      HEAPF32[i128 >> 2] = f4;
      HEAPF32[i129 >> 2] = f5;
      HEAPF32[i130 >> 2] = f9;
      i2 = HEAP32[i131 >> 2] | 0;
      L38 : do switch ((i2 & 65535) << 16 >> 16) {
      case 0:
       {
        i224 = HEAP32[i132 >> 2] | 0;
        HEAP32[i28 >> 2] = i224;
        HEAP32[i35 >> 2] = i224;
        HEAP32[i33 >> 2] = i224;
        HEAP32[i211 >> 2] = i224;
        break;
       }
      case 3:
       {
        f14 = Math_fround(HEAPF32[(HEAP32[i133 >> 2] | 0) + 4 >> 2]);
        f16 = Math_fround(HEAPF32[i132 >> 2]);
        f14 = Math_fround(f14 * f16);
        f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i134 >> 2] | 0) + 4 >> 2])) - f14);
        f222 = Math_fround(f14 + Math_fround(f16 * f4));
        f223 = Math_fround(f14 + Math_fround(f16 * f5));
        f225 = Math_fround(f14 + Math_fround(f9 * f16));
        HEAPF32[i211 >> 2] = Math_fround(f14 + Math_fround(f3 * f16));
        HEAPF32[i33 >> 2] = f222;
        HEAPF32[i35 >> 2] = f223;
        HEAPF32[i28 >> 2] = f225;
        break;
       }
      default:
       if (!(i2 & 16711680)) {
        __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i124, i212, i213);
        break L38;
       } else {
        __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i124, i212, i213);
        break L38;
       }
      } while (0);
      f16 = Math_fround(HEAPF32[i211 >> 2]);
      i224 = f16 < Math_fround(0.0);
      f16 = i224 ? Math_fround(0.0) : f16;
      f222 = Math_fround(HEAPF32[i33 >> 2]);
      i224 = f222 < Math_fround(0.0);
      f222 = i224 ? Math_fround(0.0) : f222;
      f223 = Math_fround(HEAPF32[i35 >> 2]);
      i224 = f223 < Math_fround(0.0);
      f223 = i224 ? Math_fround(0.0) : f223;
      f225 = Math_fround(HEAPF32[i28 >> 2]);
      i224 = f225 < Math_fround(0.0);
      f225 = i224 ? Math_fround(0.0) : f225;
      i224 = (HEAP32[i123 >> 2] | 0) + (i17 << 2) | 0;
      HEAPF32[i224 >> 2] = f16;
      HEAPF32[i224 + 4 >> 2] = f222;
      HEAPF32[i224 + 8 >> 2] = f223;
      HEAPF32[i224 + 12 >> 2] = f225;
     }
    }
    if ((i214 | 0) == 34) {
     i214 = 0;
     HEAPF32[i211 >> 2] = f3;
     HEAPF32[i33 >> 2] = f5;
     HEAPF32[i35 >> 2] = f4;
     HEAPF32[i28 >> 2] = f9;
     i224 = (HEAP32[i123 >> 2] | 0) + (i17 << 2) | 0;
     HEAPF32[i224 >> 2] = f3;
     HEAPF32[i224 + 4 >> 2] = f5;
     HEAPF32[i224 + 8 >> 2] = f4;
     HEAPF32[i224 + 12 >> 2] = f9;
    }
   }
   HEAPF32[i48 >> 2] = f203;
   HEAPF32[i49 >> 2] = f203;
   HEAPF32[i50 >> 2] = f203;
   HEAPF32[i212 >> 2] = f203;
   i216 = HEAP32[i156 >> 2] | 0;
   i217 = HEAP32[i157 >> 2] | 0;
   i218 = HEAP32[i158 >> 2] | 0;
   i219 = HEAP32[i159 >> 2] | 0;
   i216 = i216 << 11 ^ i216;
   i217 = i217 << 11 ^ i217;
   i218 = i218 << 11 ^ i218;
   i219 = i219 << 11 ^ i219;
   i220 = HEAP32[i161 >> 2] | 0;
   i221 = HEAP32[i162 >> 2] | 0;
   i224 = HEAP32[i163 >> 2] | 0;
   HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
   HEAP32[i157 >> 2] = i220;
   HEAP32[i158 >> 2] = i221;
   HEAP32[i159 >> 2] = i224;
   i224 = HEAP32[i165 >> 2] | 0;
   i221 = HEAP32[i166 >> 2] | 0;
   i220 = HEAP32[i167 >> 2] | 0;
   HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
   HEAP32[i161 >> 2] = i224;
   HEAP32[i162 >> 2] = i221;
   HEAP32[i163 >> 2] = i220;
   i220 = HEAP32[i168 >> 2] | 0;
   i221 = HEAP32[i169 >> 2] | 0;
   i224 = HEAP32[i170 >> 2] | 0;
   i2 = HEAP32[i171 >> 2] | 0;
   HEAP32[i164 >> 2] = i220;
   HEAP32[i165 >> 2] = i221;
   HEAP32[i166 >> 2] = i224;
   HEAP32[i167 >> 2] = i2;
   i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
   i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
   i224 = i218 >>> 8 ^ i218 ^ i224 ^ i224 >>> 19;
   i2 = i219 >>> 8 ^ i219 ^ i2 ^ i2 >>> 19;
   HEAP32[i168 >> 2] = i220;
   HEAP32[i169 >> 2] = i221;
   HEAP32[i170 >> 2] = i224;
   HEAP32[i171 >> 2] = i2;
   f3 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f4 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i213 >> 2] = f3;
   HEAPF32[i51 >> 2] = f4;
   HEAPF32[i52 >> 2] = f5;
   HEAPF32[i53 >> 2] = f9;
   i2 = HEAP32[i54 >> 2] | 0;
   L50 : do switch ((i2 & 65535) << 16 >> 16) {
   case 0:
    {
     i224 = HEAP32[i118 >> 2] | 0;
     HEAP32[i57 >> 2] = i224;
     HEAP32[i56 >> 2] = i224;
     HEAP32[i55 >> 2] = i224;
     HEAP32[i211 >> 2] = i224;
     break;
    }
   case 3:
    {
     f14 = Math_fround(HEAPF32[(HEAP32[i119 >> 2] | 0) + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i118 >> 2]);
     f14 = Math_fround(f14 * f16);
     f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i120 >> 2] | 0) + 4 >> 2])) - f14);
     f222 = Math_fround(f14 + Math_fround(f16 * f4));
     f223 = Math_fround(f14 + Math_fround(f16 * f5));
     f225 = Math_fround(f14 + Math_fround(f9 * f16));
     HEAPF32[i211 >> 2] = Math_fround(f14 + Math_fround(f3 * f16));
     HEAPF32[i55 >> 2] = f222;
     HEAPF32[i56 >> 2] = f223;
     HEAPF32[i57 >> 2] = f225;
     break;
    }
   default:
    if (!(i2 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i47, i212, i213);
     break L50;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i47, i212, i213);
     break L50;
    }
   } while (0);
   f16 = Math_fround(HEAPF32[i211 >> 2]);
   f13 = i6 ? Math_fround(1.0) : Math_fround(-1.0);
   f16 = Math_fround(f13 * f16);
   f222 = Math_fround(HEAPF32[i55 >> 2]);
   f12 = i7 ? Math_fround(1.0) : Math_fround(-1.0);
   f222 = Math_fround(f12 * f222);
   f223 = Math_fround(HEAPF32[i56 >> 2]);
   f11 = i8 ? Math_fround(1.0) : Math_fround(-1.0);
   f223 = Math_fround(f11 * f223);
   f225 = Math_fround(HEAPF32[i57 >> 2]);
   f10 = i15 ? Math_fround(1.0) : Math_fround(-1.0);
   f225 = Math_fround(f10 * f225);
   i224 = (HEAP32[i58 >> 2] | 0) + (i17 << 2) | 0;
   HEAPF32[i224 >> 2] = f16;
   HEAPF32[i224 + 4 >> 2] = f222;
   HEAPF32[i224 + 8 >> 2] = f223;
   HEAPF32[i224 + 12 >> 2] = f225;
   do if (HEAP8[i59 >> 0] | 0) {
    if (!(HEAP8[i87 >> 0] | 0)) {
     i224 = (HEAP32[i88 >> 2] | 0) + (i17 << 2) | 0;
     HEAP32[i224 >> 2] = 0;
     HEAP32[i224 + 4 >> 2] = 0;
     HEAP32[i224 + 8 >> 2] = 0;
     HEAP32[i224 + 12 >> 2] = 0;
     i224 = (HEAP32[i89 >> 2] | 0) + (i17 << 2) | 0;
     HEAP32[i224 >> 2] = 0;
     HEAP32[i224 + 4 >> 2] = 0;
     HEAP32[i224 + 8 >> 2] = 0;
     HEAP32[i224 + 12 >> 2] = 0;
     break;
    }
    HEAPF32[i91 >> 2] = f203;
    HEAPF32[i92 >> 2] = f203;
    HEAPF32[i93 >> 2] = f203;
    HEAPF32[i212 >> 2] = f203;
    i216 = HEAP32[i156 >> 2] | 0;
    i217 = HEAP32[i157 >> 2] | 0;
    i218 = HEAP32[i158 >> 2] | 0;
    i219 = HEAP32[i159 >> 2] | 0;
    i216 = i216 << 11 ^ i216;
    i217 = i217 << 11 ^ i217;
    i218 = i218 << 11 ^ i218;
    i219 = i219 << 11 ^ i219;
    i220 = HEAP32[i161 >> 2] | 0;
    i221 = HEAP32[i162 >> 2] | 0;
    i224 = HEAP32[i163 >> 2] | 0;
    HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
    HEAP32[i157 >> 2] = i220;
    HEAP32[i158 >> 2] = i221;
    HEAP32[i159 >> 2] = i224;
    i224 = HEAP32[i165 >> 2] | 0;
    i221 = HEAP32[i166 >> 2] | 0;
    i220 = HEAP32[i167 >> 2] | 0;
    HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i161 >> 2] = i224;
    HEAP32[i162 >> 2] = i221;
    HEAP32[i163 >> 2] = i220;
    i220 = HEAP32[i168 >> 2] | 0;
    i221 = HEAP32[i169 >> 2] | 0;
    i224 = HEAP32[i170 >> 2] | 0;
    i2 = HEAP32[i171 >> 2] | 0;
    HEAP32[i164 >> 2] = i220;
    HEAP32[i165 >> 2] = i221;
    HEAP32[i166 >> 2] = i224;
    HEAP32[i167 >> 2] = i2;
    i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
    i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
    i224 = i218 >>> 8 ^ i218 ^ i224 ^ i224 >>> 19;
    i2 = i219 >>> 8 ^ i219 ^ i2 ^ i2 >>> 19;
    HEAP32[i168 >> 2] = i220;
    HEAP32[i169 >> 2] = i221;
    HEAP32[i170 >> 2] = i224;
    HEAP32[i171 >> 2] = i2;
    f3 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f5 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i213 >> 2] = f3;
    HEAPF32[i94 >> 2] = f4;
    HEAPF32[i95 >> 2] = f5;
    HEAPF32[i96 >> 2] = f9;
    i2 = HEAP32[i97 >> 2] | 0;
    L63 : do switch ((i2 & 65535) << 16 >> 16) {
    case 0:
     {
      i224 = HEAP32[i115 >> 2] | 0;
      HEAP32[i100 >> 2] = i224;
      HEAP32[i99 >> 2] = i224;
      HEAP32[i98 >> 2] = i224;
      HEAP32[i211 >> 2] = i224;
      break;
     }
    case 3:
     {
      f14 = Math_fround(HEAPF32[(HEAP32[i116 >> 2] | 0) + 4 >> 2]);
      f16 = Math_fround(HEAPF32[i115 >> 2]);
      f14 = Math_fround(f14 * f16);
      f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i117 >> 2] | 0) + 4 >> 2])) - f14);
      f222 = Math_fround(f14 + Math_fround(f16 * f4));
      f223 = Math_fround(f14 + Math_fround(f16 * f5));
      f225 = Math_fround(f14 + Math_fround(f9 * f16));
      HEAPF32[i211 >> 2] = Math_fround(f14 + Math_fround(f3 * f16));
      HEAPF32[i98 >> 2] = f222;
      HEAPF32[i99 >> 2] = f223;
      HEAPF32[i100 >> 2] = f225;
      break;
     }
    default:
     if (!(i2 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i90, i212, i213);
      break L63;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i90, i212, i213);
      break L63;
     }
    } while (0);
    f9 = Math_fround(f13 * Math_fround(HEAPF32[i211 >> 2]));
    f5 = Math_fround(f12 * Math_fround(HEAPF32[i98 >> 2]));
    f4 = Math_fround(f11 * Math_fround(HEAPF32[i99 >> 2]));
    f3 = Math_fround(f10 * Math_fround(HEAPF32[i100 >> 2]));
    i216 = (HEAP32[i88 >> 2] | 0) + (i17 << 2) | 0;
    HEAPF32[i216 >> 2] = f9;
    HEAPF32[i216 + 4 >> 2] = f5;
    HEAPF32[i216 + 8 >> 2] = f4;
    HEAPF32[i216 + 12 >> 2] = f3;
    HEAPF32[i102 >> 2] = f203;
    HEAPF32[i103 >> 2] = f203;
    HEAPF32[i104 >> 2] = f203;
    HEAPF32[i212 >> 2] = f203;
    i216 = HEAP32[i156 >> 2] | 0;
    i217 = HEAP32[i157 >> 2] | 0;
    i218 = HEAP32[i158 >> 2] | 0;
    i219 = HEAP32[i159 >> 2] | 0;
    i216 = i216 << 11 ^ i216;
    i217 = i217 << 11 ^ i217;
    i218 = i218 << 11 ^ i218;
    i219 = i219 << 11 ^ i219;
    i220 = HEAP32[i161 >> 2] | 0;
    i221 = HEAP32[i162 >> 2] | 0;
    i224 = HEAP32[i163 >> 2] | 0;
    HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
    HEAP32[i157 >> 2] = i220;
    HEAP32[i158 >> 2] = i221;
    HEAP32[i159 >> 2] = i224;
    i224 = HEAP32[i165 >> 2] | 0;
    i221 = HEAP32[i166 >> 2] | 0;
    i220 = HEAP32[i167 >> 2] | 0;
    HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i161 >> 2] = i224;
    HEAP32[i162 >> 2] = i221;
    HEAP32[i163 >> 2] = i220;
    i220 = HEAP32[i168 >> 2] | 0;
    i221 = HEAP32[i169 >> 2] | 0;
    i224 = HEAP32[i170 >> 2] | 0;
    i2 = HEAP32[i171 >> 2] | 0;
    HEAP32[i164 >> 2] = i220;
    HEAP32[i165 >> 2] = i221;
    HEAP32[i166 >> 2] = i224;
    HEAP32[i167 >> 2] = i2;
    i220 = i216 >>> 8 ^ i216 ^ i220 ^ i220 >>> 19;
    i221 = i217 >>> 8 ^ i217 ^ i221 ^ i221 >>> 19;
    i224 = i218 >>> 8 ^ i218 ^ i224 ^ i224 >>> 19;
    i2 = i219 >>> 8 ^ i219 ^ i2 ^ i2 >>> 19;
    HEAP32[i168 >> 2] = i220;
    HEAP32[i169 >> 2] = i221;
    HEAP32[i170 >> 2] = i224;
    HEAP32[i171 >> 2] = i2;
    f3 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f5 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f9 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i213 >> 2] = f3;
    HEAPF32[i105 >> 2] = f4;
    HEAPF32[i106 >> 2] = f5;
    HEAPF32[i107 >> 2] = f9;
    i2 = HEAP32[i108 >> 2] | 0;
    L71 : do switch ((i2 & 65535) << 16 >> 16) {
    case 0:
     {
      i224 = HEAP32[i112 >> 2] | 0;
      HEAP32[i111 >> 2] = i224;
      HEAP32[i110 >> 2] = i224;
      HEAP32[i109 >> 2] = i224;
      HEAP32[i211 >> 2] = i224;
      break;
     }
    case 3:
     {
      f14 = Math_fround(HEAPF32[(HEAP32[i113 >> 2] | 0) + 4 >> 2]);
      f16 = Math_fround(HEAPF32[i112 >> 2]);
      f14 = Math_fround(f14 * f16);
      f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i114 >> 2] | 0) + 4 >> 2])) - f14);
      f222 = Math_fround(f14 + Math_fround(f16 * f4));
      f223 = Math_fround(f14 + Math_fround(f16 * f5));
      f225 = Math_fround(f14 + Math_fround(f9 * f16));
      HEAPF32[i211 >> 2] = Math_fround(f14 + Math_fround(f3 * f16));
      HEAPF32[i109 >> 2] = f222;
      HEAPF32[i110 >> 2] = f223;
      HEAPF32[i111 >> 2] = f225;
      break;
     }
    default:
     if (!(i2 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i211, i101, i212, i213);
      break L71;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i211, i101, i212, i213);
      break L71;
     }
    } while (0);
    f16 = Math_fround(f13 * Math_fround(HEAPF32[i211 >> 2]));
    f222 = Math_fround(f12 * Math_fround(HEAPF32[i109 >> 2]));
    f223 = Math_fround(f11 * Math_fround(HEAPF32[i110 >> 2]));
    f225 = Math_fround(f10 * Math_fround(HEAPF32[i111 >> 2]));
    i224 = (HEAP32[i89 >> 2] | 0) + (i17 << 2) | 0;
    HEAPF32[i224 >> 2] = f16;
    HEAPF32[i224 + 4 >> 2] = f222;
    HEAPF32[i224 + 8 >> 2] = f223;
    HEAPF32[i224 + 12 >> 2] = f225;
   } while (0);
   if (HEAP8[i60 >> 0] | 0) {
    i224 = (HEAP32[i84 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    if (HEAP8[i59 >> 0] | 0) {
     i224 = (HEAP32[i85 >> 2] | 0) + (i17 << 2) | 0;
     HEAP32[i224 >> 2] = 0;
     HEAP32[i224 + 4 >> 2] = 0;
     HEAP32[i224 + 8 >> 2] = 0;
     HEAP32[i224 + 12 >> 2] = 0;
     i224 = (HEAP32[i86 >> 2] | 0) + (i17 << 2) | 0;
     HEAP32[i224 >> 2] = 0;
     HEAP32[i224 + 4 >> 2] = 0;
     HEAP32[i224 + 8 >> 2] = 0;
     HEAP32[i224 + 12 >> 2] = 0;
    }
   }
   if (HEAP8[i61 >> 0] | 0) {
    i224 = (HEAP32[i81 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = i197;
    HEAP32[i224 + 4 >> 2] = i197;
    HEAP32[i224 + 8 >> 2] = i197;
    HEAP32[i224 + 12 >> 2] = i197;
    i224 = (HEAP32[i82 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = i196;
    HEAP32[i224 + 4 >> 2] = i196;
    HEAP32[i224 + 8 >> 2] = i196;
    HEAP32[i224 + 12 >> 2] = i196;
    i224 = (HEAP32[i83 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = i193;
    HEAP32[i224 + 4 >> 2] = i193;
    HEAP32[i224 + 8 >> 2] = i193;
    HEAP32[i224 + 12 >> 2] = i193;
   }
   HEAPF32[i63 >> 2] = f203;
   HEAPF32[i64 >> 2] = f203;
   HEAPF32[i65 >> 2] = f203;
   HEAPF32[i211 >> 2] = f203;
   i216 = HEAP32[i156 >> 2] | 0;
   i217 = HEAP32[i157 >> 2] | 0;
   i218 = HEAP32[i158 >> 2] | 0;
   i219 = HEAP32[i159 >> 2] | 0;
   i216 = i216 << 11 ^ i216;
   i217 = i217 << 11 ^ i217;
   i218 = i218 << 11 ^ i218;
   i219 = i219 << 11 ^ i219;
   i2 = HEAP32[i161 >> 2] | 0;
   i220 = HEAP32[i162 >> 2] | 0;
   i221 = HEAP32[i163 >> 2] | 0;
   HEAP32[i156 >> 2] = HEAP32[i160 >> 2];
   HEAP32[i157 >> 2] = i2;
   HEAP32[i158 >> 2] = i220;
   HEAP32[i159 >> 2] = i221;
   i221 = HEAP32[i165 >> 2] | 0;
   i220 = HEAP32[i166 >> 2] | 0;
   i2 = HEAP32[i167 >> 2] | 0;
   HEAP32[i160 >> 2] = HEAP32[i164 >> 2];
   HEAP32[i161 >> 2] = i221;
   HEAP32[i162 >> 2] = i220;
   HEAP32[i163 >> 2] = i2;
   i2 = HEAP32[i168 >> 2] | 0;
   i220 = HEAP32[i169 >> 2] | 0;
   i221 = HEAP32[i170 >> 2] | 0;
   i224 = HEAP32[i171 >> 2] | 0;
   HEAP32[i164 >> 2] = i2;
   HEAP32[i165 >> 2] = i220;
   HEAP32[i166 >> 2] = i221;
   HEAP32[i167 >> 2] = i224;
   i2 = i216 >>> 8 ^ i216 ^ i2 ^ i2 >>> 19;
   i220 = i217 >>> 8 ^ i217 ^ i220 ^ i220 >>> 19;
   i221 = i218 >>> 8 ^ i218 ^ i221 ^ i221 >>> 19;
   i224 = i219 >>> 8 ^ i219 ^ i224 ^ i224 >>> 19;
   HEAP32[i168 >> 2] = i2;
   HEAP32[i169 >> 2] = i220;
   HEAP32[i170 >> 2] = i221;
   HEAP32[i171 >> 2] = i224;
   f222 = Math_fround(Math_fround(i220 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f223 = Math_fround(Math_fround(i221 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f225 = Math_fround(Math_fround(i224 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i212 >> 2] = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i66 >> 2] = f222;
   HEAPF32[i67 >> 2] = f223;
   HEAPF32[i68 >> 2] = f225;
   i2 = (HEAP32[i70 >> 2] | 0) == 0;
   do if (!(HEAP32[i69 >> 2] | 0)) if (i2) {
    __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i207, i62, i211, i212);
    break;
   } else {
    __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i207, i62, i211, i212);
    break;
   } else if (i2) {
    __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i207, i62, i211, i212);
    break;
   } else {
    __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i207, i62, i211, i212);
    break;
   } while (0);
   i219 = HEAP32[i30 >> 2] | 0;
   i220 = HEAP32[i31 >> 2] | 0;
   i221 = HEAP32[i32 >> 2] | 0;
   i224 = (HEAP32[i71 >> 2] | 0) + (i17 << 2) | 0;
   HEAP32[i224 >> 2] = HEAP32[i207 >> 2];
   HEAP32[i224 + 4 >> 2] = i219;
   HEAP32[i224 + 8 >> 2] = i220;
   HEAP32[i224 + 12 >> 2] = i221;
   if (HEAP8[i72 >> 0] | 0) {
    i224 = (HEAP32[i73 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i74 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i75 >> 2] | 0) + (i17 << 2) | 0;
    HEAP32[i224 >> 2] = 1065353216;
    HEAP32[i224 + 4 >> 2] = 1065353216;
    HEAP32[i224 + 8 >> 2] = 1065353216;
    HEAP32[i224 + 12 >> 2] = 1065353216;
   }
   i6 = HEAP32[i76 >> 2] | 0;
   if ((i6 | 0) > 0) {
    i2 = 0;
    do {
     i224 = (HEAP32[i209 + 560 + (i2 * 20 | 0) >> 2] | 0) + (i17 << 2) | 0;
     HEAP32[i224 >> 2] = 0;
     HEAP32[i224 + 4 >> 2] = 0;
     HEAP32[i224 + 8 >> 2] = 0;
     HEAP32[i224 + 12 >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i6 | 0));
   }
   if (HEAP8[i77 >> 0] | 0) {
    i221 = (HEAP32[i80 >> 2] | 0) + (i17 >>> 5 << 2) | 0;
    HEAP32[i221 >> 2] = HEAP32[i221 >> 2] & ~(1 << (i17 & 31));
    i221 = i17 + 1 | 0;
    i224 = (HEAP32[i80 >> 2] | 0) + (i221 >>> 5 << 2) | 0;
    HEAP32[i224 >> 2] = HEAP32[i224 >> 2] & ~(1 << (i221 & 31));
    i224 = i17 + 2 | 0;
    i221 = (HEAP32[i80 >> 2] | 0) + (i224 >>> 5 << 2) | 0;
    HEAP32[i221 >> 2] = HEAP32[i221 >> 2] & ~(1 << (i224 & 31));
    i221 = i17 + 3 | 0;
    i224 = (HEAP32[i80 >> 2] | 0) + (i221 >>> 5 << 2) | 0;
    HEAP32[i224 >> 2] = HEAP32[i224 >> 2] & ~(1 << (i221 & 31));
   }
   if (HEAP8[i78 >> 0] | 0) {
    i221 = (HEAP32[i79 >> 2] | 0) + (i17 >>> 5 << 2) | 0;
    HEAP32[i221 >> 2] = HEAP32[i221 >> 2] & ~(1 << (i17 & 31));
    i221 = i17 + 1 | 0;
    i224 = (HEAP32[i79 >> 2] | 0) + (i221 >>> 5 << 2) | 0;
    HEAP32[i224 >> 2] = HEAP32[i224 >> 2] & ~(1 << (i221 & 31));
    i224 = i17 + 2 | 0;
    i221 = (HEAP32[i79 >> 2] | 0) + (i224 >>> 5 << 2) | 0;
    HEAP32[i221 >> 2] = HEAP32[i221 >> 2] & ~(1 << (i224 & 31));
    i221 = i17 + 3 | 0;
    i224 = (HEAP32[i79 >> 2] | 0) + (i221 >>> 5 << 2) | 0;
    HEAP32[i224 >> 2] = HEAP32[i224 >> 2] & ~(1 << (i221 & 31));
   }
   if (HEAP32[i24 >> 2] & 2147483647 | 0) {
    i224 = (HEAP32[i27 >> 2] | 0) + (i17 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i27 >> 2] | 0) + (i17 + 1 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i27 >> 2] | 0) + (i17 + 2 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i27 >> 2] | 0) + (i17 + 3 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
   }
   if (HEAP32[i25 >> 2] & 2147483647) {
    i224 = (HEAP32[i26 >> 2] | 0) + (i17 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i26 >> 2] | 0) + (i17 + 1 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i26 >> 2] | 0) + (i17 + 2 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
    i224 = (HEAP32[i26 >> 2] | 0) + (i17 + 3 << 4) | 0;
    HEAP32[i224 >> 2] = 0;
    HEAP32[i224 + 4 >> 2] = 0;
    HEAP32[i224 + 8 >> 2] = 0;
    HEAP32[i224 + 12 >> 2] = 0;
   }
  }
  i18 = i18 + 4 | 0;
  f19 = Math_fround(f19 + Math_fround(4.0));
  f22 = Math_fround(f22 + Math_fround(4.0));
  f20 = Math_fround(f20 + Math_fround(4.0));
  f21 = Math_fround(f21 + Math_fround(4.0));
 } while (i18 >>> 0 < (HEAP32[i151 >> 2] | 0) >>> 0);
 STACKTOP = i215;
 return;
}

function __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i3, i61, i62, i1, i2, i36) {
 i3 = i3 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i36 = i36 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i64;
 i60 = HEAP32[i3 + 72 + (i1 << 2) >> 2] | 0;
 i59 = HEAP32[i3 + 72 + (i2 << 2) >> 2] | 0;
 i53 = i3 + 40 | 0;
 i54 = i53;
 i58 = HEAP32[i53 >> 2] | 0;
 i57 = i58 + i54 | 0;
 i33 = i57 + 4 | 0;
 i33 = i33 + (HEAP32[i33 >> 2] | 0) | 0;
 i32 = HEAP32[i33 + (i60 << 3) >> 2] | 0;
 i55 = i57 + 16 | 0;
 i33 = HEAP32[i33 + (i60 << 3) + 4 >> 2] | 0;
 i55 = (HEAP32[i55 >> 2] | 0) + i55 | 0;
 i42 = HEAP32[i55 + (i33 * 76 | 0) >> 2] | 0;
 i49 = HEAP32[i55 + (i33 * 76 | 0) + 4 >> 2] | 0;
 i51 = HEAP32[i55 + (i33 * 76 | 0) + 8 >> 2] | 0;
 f52 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 12 >> 2]);
 i43 = HEAP32[i55 + (i33 * 76 | 0) + 16 >> 2] | 0;
 i44 = HEAP32[i55 + (i33 * 76 | 0) + 20 >> 2] | 0;
 i45 = HEAP32[i55 + (i33 * 76 | 0) + 24 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 28 >> 2]);
 i1 = HEAP32[i55 + (i33 * 76 | 0) + 32 >> 2] | 0;
 i2 = HEAP32[i55 + (i33 * 76 | 0) + 36 >> 2] | 0;
 i3 = HEAP32[i55 + (i33 * 76 | 0) + 40 >> 2] | 0;
 f34 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 44 >> 2]);
 f35 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 48 >> 2]);
 f37 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 52 >> 2]);
 f38 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 56 >> 2]);
 f39 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 60 >> 2]);
 f40 = Math_fround(HEAPF32[i55 + (i33 * 76 | 0) + 64 >> 2]);
 i33 = HEAP32[i55 + (i33 * 76 | 0) + 68 + 4 >> 2] | 0;
 i55 = i62 + 4 | 0;
 i56 = i55;
 i50 = (HEAP32[i55 >> 2] | 0) + i56 | 0;
 HEAP32[i50 + (i32 * 40 | 0) + 12 >> 2] = 0;
 HEAP32[i50 + (i32 * 40 | 0) + 16 >> 2] = 0;
 HEAP32[i50 + (i32 * 40 | 0) + 20 >> 2] = 0;
 HEAP32[i50 + (i32 * 40 | 0) + 24 >> 2] = 1065353216;
 __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i58 | 0) == 0 ? 0 : i57, i61, i62, i59, i60);
 i57 = i61 + 4 | 0;
 i58 = i57;
 i32 = (HEAP32[i57 >> 2] | 0) + i58 | 0;
 i50 = i32 + (i60 * 40 | 0) + 12 | 0;
 HEAP32[i63 >> 2] = HEAP32[i50 >> 2];
 HEAP32[i63 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
 HEAP32[i63 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
 HEAP32[i63 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
 i50 = (HEAP32[i55 >> 2] | 0) + i56 | 0;
 i41 = HEAP32[i50 + (i59 * 40 | 0) + 12 >> 2] | 0;
 i47 = HEAP32[i50 + (i59 * 40 | 0) + 16 >> 2] | 0;
 i48 = HEAP32[i50 + (i59 * 40 | 0) + 20 >> 2] | 0;
 i50 = HEAP32[i50 + (i59 * 40 | 0) + 24 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i32 + (i60 * 40 | 0) + 16 >> 2]);
 f8 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f8 * f7);
 f13 = Math_fround(HEAPF32[i32 + (i60 * 40 | 0) + 24 >> 2]);
 f10 = Math_fround(f46 * f13);
 f12 = Math_fround(HEAPF32[i32 + (i60 * 40 | 0) + 20 >> 2]);
 f5 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f5 * f12);
 f65 = Math_fround(HEAPF32[i32 + (i60 * 40 | 0) + 12 >> 2]);
 f4 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f4 * f13)) - Math_fround(f46 * f12)) - Math_fround(f5 * f65));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f8 * f65)) - Math_fround(f4 * f12)) - Math_fround(f5 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f4 * f7)) - Math_fround(f8 * f13)) - Math_fround(f46 * f65));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f65) - Math_fround(f8 * f12)) - Math_fround(f5 * f13)) - Math_fround(f46 * f7));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i30 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f7 = (HEAP32[tempDoublePtr >> 2] = i49 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i31 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f7 * f6);
 f13 = Math_fround(f52 * f10);
 f5 = (HEAP32[tempDoublePtr >> 2] = i51 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f5 * f12);
 f65 = (HEAP32[tempDoublePtr >> 2] = i42 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i32 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f52 * f4)) - Math_fround(f5 * f10)) - Math_fround(f65 * f12));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f65 * f6)) - Math_fround(f5 * f4)) - Math_fround(f7 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f7 * f4)) - Math_fround(f52 * f6)) - Math_fround(f65 * f10));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f65 * f4) - Math_fround(f5 * f6)) - Math_fround(f52 * f12)) - Math_fround(f7 * f10));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i30 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f10 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f10 * f10);
 f11 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f11 * f11);
 f12 = (HEAP32[tempDoublePtr >> 2] = i32 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)) + Math_fround(f7 + f8)))));
 f10 = Math_fround(f8 * f10);
 f11 = Math_fround(f8 * f11);
 f12 = Math_fround(f8 * f12);
 f13 = Math_fround(f8 * f13);
 switch (i33 | 0) {
 case 3:
  {
   f5 = Math_fround(Math_fround(f13 * f11) * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f13 * f12) * Math_fround(2.0));
   f7 = Math_fround(Math_fround(f11 * f10) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(f12 * f10) * Math_fround(2.0));
   f4 = Math_fround(f8 - f5);
   if (Math_fround(f4 * f4) < Math_fround(.999995946)) {
    f67 = Math_fround(f13 * f13);
    f65 = Math_fround(f12 * f12);
    f5 = Math_fround(f11 * f11);
    f66 = Math_fround(f10 * f10);
    f8 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f11 * f12) * Math_fround(2.0)) + Math_fround(Math_fround(f13 * f10) * Math_fround(2.0))), +Math_fround(Math_fround(Math_fround(f67 + f65) - f5) - f66)));
    f11 = Math_fround(+Math_asin(+f4));
    f65 = Math_fround(+Math_atan2(+Math_fround(f6 + f7), +Math_fround(Math_fround(Math_fround(f67 + f66) - f5) - f65)));
    i21 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f11 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f4, Math_fround(-1.0))), Math_fround(1.0)))));
    f8 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f5 * f7) + Math_fround(f6 * f8)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f6 * f6) - Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) - Math_fround(f8 * f8)))));
    i21 = 0;
   }
   f7 = Math_fround(-f11);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = f34 > Math_fround(0.0);
   i9 = f35 > Math_fround(0.0);
   i14 = f37 > Math_fround(0.0);
   f10 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(Math_fround(-f8) / f34);
   f5 = Math_fround(f11 / f35);
   f6 = Math_fround(Math_fround(-f10) / f37);
   i33 = f34 < Math_fround(0.0);
   i1 = f35 < Math_fround(0.0);
   i2 = f37 < Math_fround(0.0);
   i18 = i33 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i3 ? i19 : 0;
   i17 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i20 : 0;
   i15 = i2 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i14 ? i21 : 0;
   i2 = f38 < Math_fround(0.0);
   i3 = f39 < Math_fround(0.0);
   i16 = f40 < Math_fround(0.0);
   f4 = Math_fround(f8 / f38);
   f5 = Math_fround(f7 / f39);
   f6 = Math_fround(f10 / f40);
   i33 = f38 > Math_fround(0.0);
   i1 = f39 > Math_fround(0.0);
   i14 = f40 > Math_fround(0.0);
   i9 = i33 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i3 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i3 ? i20 : 0;
   i2 = f8 < Math_fround(0.0);
   i1 = f11 > Math_fround(-0.0);
   i33 = f10 < Math_fround(0.0);
   i33 = i33 ? i15 : i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i16 ? i21 : 0;
   f7 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * (HEAP32[tempDoublePtr >> 2] = i2 ? i18 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i36 = (HEAP32[i57 >> 2] | 0) + i58 + (i60 * 40 | 0) + 12 | 0;
   f7 = Math_fround(Math_fround(f7 * Math_fround(.5)) * Math_fround(.159154937));
   f38 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1 ? i17 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)) * Math_fround(.159154937));
   f40 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f7));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f7 - f6))));
   f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
   f65 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - Math_fround(+_roundf(+f40))))));
   f4 = Math_fround(f6 * f6);
   f67 = Math_fround(f37 * f37);
   f66 = Math_fround(f65 * f65);
   f39 = Math_fround(f4 * f4);
   f5 = Math_fround(f67 * f67);
   f35 = Math_fround(f66 * f66);
   f4 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f67 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f5 * f5) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f67 * Math_fround(41.3416595))) + Math_fround(f5 * Math_fround(Math_fround(81.6018218) - Math_fround(f67 * Math_fround(76.5686187)))))));
   f66 = Math_fround(f65 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f66 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f66 * Math_fround(76.5686187)))))));
   f7 = Math_fround(f7 + Math_fround(-.25));
   f38 = Math_fround(f38 + Math_fround(-.25));
   f40 = Math_fround(f40 + Math_fround(-.25));
   f35 = Math_fround(+_roundf(+f7));
   f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f7 - f35))));
   f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - Math_fround(+_roundf(+f38))))));
   f40 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - Math_fround(+_roundf(+f40))))));
   f7 = Math_fround(f35 * f35);
   f65 = Math_fround(f38 * f38);
   f5 = Math_fround(f40 * f40);
   f37 = Math_fround(f7 * f7);
   f39 = Math_fround(f65 * f65);
   f6 = Math_fround(f5 * f5);
   f7 = Math_fround(f35 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
   f65 = Math_fround(f38 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f65 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f65 * Math_fround(76.5686187)))))));
   f5 = Math_fround(f40 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f6 = Math_fround(f7 * f66);
   f7 = Math_fround(f7 * f5);
   f5 = Math_fround(f4 * f5);
   f66 = Math_fround(f4 * f66);
   f4 = Math_fround(Math_fround(Math_fround(f67 * f6) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(-1.0) * f65) * f5));
   f5 = Math_fround(Math_fround(Math_fround(Math_fround(-1.0) * f65) * f6) + Math_fround(Math_fround(f67 * f5) * Math_fround(1.0)));
   f6 = Math_fround(Math_fround(Math_fround(f67 * f66) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(1.0) * f65) * f7));
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) * f65) * f66) + Math_fround(Math_fround(f67 * f7) * Math_fround(1.0)));
   i1 = i36;
   break;
  }
 case 1:
  {
   f10 = Math_fround(f10 / f13);
   f4 = Math_fround(f11 / f13);
   f5 = Math_fround(f12 / f13);
   f7 = Math_fround(Math_fround(f10 * f10) + Math_fround(1.0));
   f8 = Math_fround(Math_fround(f4 - Math_fround(f5 * f10)) / f7);
   f7 = Math_fround(Math_fround(f5 + Math_fround(f4 * f10)) / f7);
   i33 = i1 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i32 = i2 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i31 = i3 & -2147483648;
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f10 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = f34 > Math_fround(0.0);
   i21 = f35 > Math_fround(0.0);
   i23 = f37 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f34);
   f5 = Math_fround(Math_fround(-f8) / f35);
   f6 = Math_fround(Math_fround(-f10) / f37);
   i20 = f34 < Math_fround(0.0);
   i22 = f35 < Math_fround(0.0);
   i24 = f37 < Math_fround(0.0);
   i17 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i1 : 0;
   i9 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i15 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i16 : 0;
   i25 = f38 < Math_fround(0.0);
   i27 = f39 < Math_fround(0.0);
   i29 = f40 < Math_fround(0.0);
   f4 = Math_fround(f7 / f38);
   f5 = Math_fround(f8 / f39);
   f6 = Math_fround(f10 / f40);
   i26 = f38 > Math_fround(0.0);
   i28 = f39 > Math_fround(0.0);
   i30 = f40 > Math_fround(0.0);
   i3 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i1 : 0;
   i2 = f7 < Math_fround(0.0);
   i18 = f8 < Math_fround(0.0);
   i1 = f10 < Math_fround(0.0);
   i18 = i18 ? i9 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i15 : 0;
   i15 = i1 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i16 : 0;
   f8 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * (HEAP32[tempDoublePtr >> 2] = i2 ? i17 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i9 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAP32[i57 >> 2] | 0) + i58 + (i60 * 40 | 0) + 12 | 0;
   f10 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(-Math_fround(f34 * f8));
   f5 = Math_fround(-Math_fround(f35 * f10));
   f6 = Math_fround(-Math_fround(f37 * f7));
   i3 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i9 : 0;
   i2 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i18 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i15 : 0;
   f4 = Math_fround(f38 * f8);
   f5 = Math_fround(f39 * f10);
   f6 = Math_fround(f40 * f7);
   i26 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i9 : 0;
   i25 = f8 < Math_fround(0.0);
   i36 = f10 < Math_fround(0.0);
   i9 = f7 < Math_fround(0.0);
   i3 = i25 ? i3 : i26;
   i2 = i36 ? i2 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i18 : 0;
   i30 = i9 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i15 : 0;
   f65 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(Math_fround(Math_abs(Math_fround(f65))) + Math_fround(3.14159274));
   f37 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f39 = Math_fround(f37 / Math_fround(6.28318548));
   f38 = Math_fround(f6 / Math_fround(6.28318548));
   f66 = Math_fround(_truncf(Math_fround(f65 / Math_fround(6.28318548))));
   f66 = Math_fround(Math_fround(f65 - Math_fround(f66 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f39 = Math_fround(Math_fround(f37 - Math_fround(Math_fround(_truncf(f39)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f38 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f38)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i29 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) ^ i3 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i30 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i30 & -2147483648;
   f38 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f38 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f38 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f38 = Math_fround(f38 * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f66 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f66, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f38));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f6))));
   f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f65 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f67 = Math_fround(f6 * f6);
   f5 = Math_fround(f37 * f37);
   f4 = Math_fround(f65 * f65);
   f40 = Math_fround(f67 * f67);
   f7 = Math_fround(f5 * f5);
   f35 = Math_fround(f4 * f4);
   f67 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f67 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f67 * Math_fround(76.5686187)))))));
   f5 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f65 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f38 = Math_fround(f38 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f66 = Math_fround(f66 + Math_fround(-.25));
   f35 = Math_fround(+_roundf(+f38));
   f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f35))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f66 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f38 = Math_fround(f35 * f35);
   f65 = Math_fround(f39 * f39);
   f7 = Math_fround(f66 * f66);
   f37 = Math_fround(f38 * f38);
   f40 = Math_fround(f65 * f65);
   f6 = Math_fround(f7 * f7);
   f67 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f67);
   f5 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f65 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f65 * Math_fround(76.5686187))))))) / f5);
   f4 = Math_fround(Math_fround(f66 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i33 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f4 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f5 + Math_fround(f4 * f67));
   f5 = Math_fround(f67 - Math_fround(f4 * f5));
   f67 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f67 * f4);
   f5 = Math_fround(f67 * f5);
   f6 = f67;
   f7 = Math_fround(f67 * f7);
   break;
  }
 case 2:
  {
   f10 = Math_fround(f10 / f13);
   f4 = Math_fround(f11 / f13);
   f5 = Math_fround(f12 / f13);
   f7 = Math_fround(Math_fround(f10 * f10) + Math_fround(1.0));
   f8 = Math_fround(Math_fround(f4 + Math_fround(f5 * f10)) / f7);
   f7 = Math_fround(Math_fround(f5 - Math_fround(f4 * f10)) / f7);
   i33 = i1 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i32 = i2 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i31 = i3 & -2147483648;
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f10 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = f34 > Math_fround(0.0);
   i21 = f35 > Math_fround(0.0);
   i23 = f37 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f34);
   f5 = Math_fround(Math_fround(-f8) / f35);
   f6 = Math_fround(Math_fround(-f10) / f37);
   i20 = f34 < Math_fround(0.0);
   i22 = f35 < Math_fround(0.0);
   i24 = f37 < Math_fround(0.0);
   i17 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i1 : 0;
   i9 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i15 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i16 : 0;
   i25 = f38 < Math_fround(0.0);
   i27 = f39 < Math_fround(0.0);
   i29 = f40 < Math_fround(0.0);
   f4 = Math_fround(f7 / f38);
   f5 = Math_fround(f8 / f39);
   f6 = Math_fround(f10 / f40);
   i26 = f38 > Math_fround(0.0);
   i28 = f39 > Math_fround(0.0);
   i30 = f40 > Math_fround(0.0);
   i3 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i1 : 0;
   i2 = f7 < Math_fround(0.0);
   i18 = f8 < Math_fround(0.0);
   i1 = f10 < Math_fround(0.0);
   i18 = i18 ? i9 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i15 : 0;
   i15 = i1 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i16 : 0;
   f8 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * (HEAP32[tempDoublePtr >> 2] = i2 ? i17 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i9 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAP32[i57 >> 2] | 0) + i58 + (i60 * 40 | 0) + 12 | 0;
   f10 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(-Math_fround(f34 * f8));
   f5 = Math_fround(-Math_fround(f35 * f10));
   f6 = Math_fround(-Math_fround(f37 * f7));
   i3 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i9 : 0;
   i2 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i18 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i15 : 0;
   f4 = Math_fround(f38 * f8);
   f5 = Math_fround(f39 * f10);
   f6 = Math_fround(f40 * f7);
   i26 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i9 : 0;
   i25 = f8 < Math_fround(0.0);
   i36 = f10 < Math_fround(0.0);
   i9 = f7 < Math_fround(0.0);
   i3 = i25 ? i3 : i26;
   i2 = i36 ? i2 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i18 : 0;
   i30 = i9 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i15 : 0;
   f65 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(Math_fround(Math_abs(Math_fround(f65))) + Math_fround(3.14159274));
   f37 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f39 = Math_fround(f37 / Math_fround(6.28318548));
   f38 = Math_fround(f6 / Math_fround(6.28318548));
   f66 = Math_fround(_truncf(Math_fround(f65 / Math_fround(6.28318548))));
   f66 = Math_fround(Math_fround(f65 - Math_fround(f66 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f39 = Math_fround(Math_fround(f37 - Math_fround(Math_fround(_truncf(f39)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f38 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f38)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i29 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) ^ i3 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i30 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i30 & -2147483648;
   f38 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f38 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f38 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f38 = Math_fround(f38 * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f66 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f66, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f38));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f6))));
   f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f65 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f5 = Math_fround(f6 * f6);
   f67 = Math_fround(f37 * f37);
   f4 = Math_fround(f65 * f65);
   f40 = Math_fround(f5 * f5);
   f7 = Math_fround(f67 * f67);
   f35 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f67 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f7 * f7) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f67 * Math_fround(41.3416595))) + Math_fround(f7 * Math_fround(Math_fround(81.6018218) - Math_fround(f67 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f65 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f38 = Math_fround(f38 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f66 = Math_fround(f66 + Math_fround(-.25));
   f35 = Math_fround(+_roundf(+f38));
   f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f35))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f66 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f38 = Math_fround(f35 * f35);
   f65 = Math_fround(f39 * f39);
   f7 = Math_fround(f66 * f66);
   f37 = Math_fround(f38 * f38);
   f40 = Math_fround(f65 * f65);
   f6 = Math_fround(f7 * f7);
   f5 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f5);
   f67 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f65 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f65 * Math_fround(76.5686187))))))) / f67);
   f4 = Math_fround(Math_fround(f66 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))) / f4);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i33 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f4 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(f67 - Math_fround(f4 * f5));
   f5 = Math_fround(Math_fround(f4 * f67) + f5);
   f67 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(1.0)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7))))));
   f4 = Math_fround(f67 * f4);
   f5 = Math_fround(f67 * f5);
   f6 = f67;
   f7 = Math_fround(f67 * f7);
   break;
  }
 default:
  {
   f10 = Math_fround(f10 / f13);
   f8 = Math_fround(f11 / f13);
   f7 = Math_fround(f12 / f13);
   i33 = i1 & -2147483648;
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i32 = i2 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i31 = i3 & -2147483648;
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f10 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = f34 > Math_fround(0.0);
   i21 = f35 > Math_fround(0.0);
   i23 = f37 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f34);
   f5 = Math_fround(Math_fround(-f8) / f35);
   f6 = Math_fround(Math_fround(-f10) / f37);
   i20 = f34 < Math_fround(0.0);
   i22 = f35 < Math_fround(0.0);
   i24 = f37 < Math_fround(0.0);
   i17 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i1 : 0;
   i9 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i15 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i16 : 0;
   i25 = f38 < Math_fround(0.0);
   i27 = f39 < Math_fround(0.0);
   i29 = f40 < Math_fround(0.0);
   f4 = Math_fround(f7 / f38);
   f5 = Math_fround(f8 / f39);
   f6 = Math_fround(f10 / f40);
   i26 = f38 > Math_fround(0.0);
   i28 = f39 > Math_fround(0.0);
   i30 = f40 > Math_fround(0.0);
   i3 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i1 : 0;
   i2 = f7 < Math_fround(0.0);
   i18 = f8 < Math_fround(0.0);
   i1 = f10 < Math_fround(0.0);
   i18 = i18 ? i9 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i15 : 0;
   i15 = i1 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i16 : 0;
   f8 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * (HEAP32[tempDoublePtr >> 2] = i2 ? i17 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i9 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAP32[i57 >> 2] | 0) + i58 + (i60 * 40 | 0) + 12 | 0;
   f10 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(-Math_fround(f34 * f8));
   f5 = Math_fround(-Math_fround(f35 * f10));
   f6 = Math_fround(-Math_fround(f37 * f7));
   i3 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i19 ? i9 : 0;
   i2 = i22 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i21 ? i18 : 0;
   i14 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i23 ? i15 : 0;
   f4 = Math_fround(f38 * f8);
   f5 = Math_fround(f39 * f10);
   f6 = Math_fround(f40 * f7);
   i26 = i26 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i25 ? i9 : 0;
   i25 = f8 < Math_fround(0.0);
   i36 = f10 < Math_fround(0.0);
   i9 = f7 < Math_fround(0.0);
   i3 = i25 ? i3 : i26;
   i2 = i36 ? i2 : i28 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i27 ? i18 : 0;
   i30 = i9 ? i14 : i30 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i29 ? i15 : 0;
   f65 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(Math_fround(Math_abs(Math_fround(f65))) + Math_fround(3.14159274));
   f37 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f6 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f39 = Math_fround(f37 / Math_fround(6.28318548));
   f38 = Math_fround(f6 / Math_fround(6.28318548));
   f66 = Math_fround(_truncf(Math_fround(f65 / Math_fround(6.28318548))));
   f66 = Math_fround(Math_fround(f65 - Math_fround(f66 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f39 = Math_fround(Math_fround(f37 - Math_fround(Math_fround(_truncf(f39)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f38 = Math_fround(Math_fround(f6 - Math_fround(Math_fround(_truncf(f38)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i29 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) ^ i3 & -2147483648;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i30 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ i30 & -2147483648;
   f38 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f38 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f38 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f38 = Math_fround(f38 * Math_fround(.159154937));
   f39 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f39, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f66 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f66, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f6 = Math_fround(+_roundf(+f38));
   f6 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f6))));
   f37 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f65 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f5 = Math_fround(f6 * f6);
   f7 = Math_fround(f37 * f37);
   f4 = Math_fround(f65 * f65);
   f40 = Math_fround(f5 * f5);
   f67 = Math_fround(f7 * f7);
   f35 = Math_fround(f4 * f4);
   f5 = Math_fround(f6 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
   f7 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(f67 * f67) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f67 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f65 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f38 = Math_fround(f38 + Math_fround(-.25));
   f39 = Math_fround(f39 + Math_fround(-.25));
   f66 = Math_fround(f66 + Math_fround(-.25));
   f35 = Math_fround(+_roundf(+f38));
   f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f38 - f35))));
   f39 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f39 - Math_fround(+_roundf(+f39))))));
   f66 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f66 - Math_fround(+_roundf(+f66))))));
   f38 = Math_fround(f35 * f35);
   f65 = Math_fround(f39 * f39);
   f67 = Math_fround(f66 * f66);
   f37 = Math_fround(f38 * f38);
   f40 = Math_fround(f65 * f65);
   f6 = Math_fround(f67 * f67);
   f5 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f37 * f37) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f38 * Math_fround(41.3416595))) + Math_fround(f37 * Math_fround(Math_fround(81.6018218) - Math_fround(f38 * Math_fround(76.5686187))))))) / f5);
   f7 = Math_fround(Math_fround(f39 * Math_fround(Math_fround(Math_fround(f40 * f40) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f65 * Math_fround(41.3416595))) + Math_fround(f40 * Math_fround(Math_fround(81.6018218) - Math_fround(f65 * Math_fround(76.5686187))))))) / f7);
   f4 = Math_fround(Math_fround(f66 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f67 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f67 * Math_fround(76.5686187))))))) / f4);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) ^ i33;
   i33 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i32;
   i36 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ i31;
   f4 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(1.0))))));
   f4 = Math_fround(f67 * f4);
   f5 = Math_fround(f67 * f5);
   f6 = f67;
   f7 = Math_fround(f67 * f7);
  }
 }
 f67 = (HEAP32[tempDoublePtr >> 2] = i43 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(f67 * f7);
 f40 = Math_fround(f46 * f6);
 f66 = (HEAP32[tempDoublePtr >> 2] = i44 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f66 * f5);
 f37 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f37 * f6)) - Math_fround(f46 * f5)) - Math_fround(f66 * f4));
 f40 = Math_fround(Math_fround(Math_fround(f40 - Math_fround(f67 * f4)) - Math_fround(f37 * f5)) - Math_fround(f66 * f7));
 f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f37 * f7)) - Math_fround(f67 * f6)) - Math_fround(f46 * f4));
 f66 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f4) - Math_fround(f67 * f5)) - Math_fround(f66 * f6)) - Math_fround(f46 * f7));
 i45 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
 i43 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i44 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f66 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i43 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(f66 * f38);
 f67 = Math_fround(f52 * f40);
 f37 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = Math_fround(f37 * f39);
 f34 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(Math_fround(Math_fround(f65 - Math_fround(f52 * f35)) - Math_fround(f37 * f40)) - Math_fround(f34 * f39));
 f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f34 * f38)) - Math_fround(f37 * f35)) - Math_fround(f66 * f39));
 f46 = Math_fround(Math_fround(Math_fround(f46 - Math_fround(f66 * f35)) - Math_fround(f52 * f38)) - Math_fround(f34 * f40));
 f52 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f35) - Math_fround(f37 * f38)) - Math_fround(f52 * f39)) - Math_fround(f66 * f40));
 i51 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
 i45 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
 i49 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f52 = (HEAP32[tempDoublePtr >> 2] = i45 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = Math_fround(f52 * f52);
 f65 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(f65 * f65);
 f66 = (HEAP32[tempDoublePtr >> 2] = i51 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f67 * f67) + Math_fround(f66 * f66)) + Math_fround(f40 + f46)))));
 f65 = Math_fround(f46 * f65);
 f66 = Math_fround(f46 * f66);
 f67 = Math_fround(f46 * f67);
 HEAPF32[i1 >> 2] = Math_fround(f46 * f52);
 HEAPF32[i1 + 4 >> 2] = f65;
 HEAPF32[i1 + 8 >> 2] = f66;
 HEAPF32[i1 + 12 >> 2] = f67;
 i51 = HEAP32[i53 >> 2] | 0;
 __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i((i51 | 0) == 0 ? 0 : i51 + i54 | 0, i63, (HEAP32[i57 >> 2] | 0) + i58 + (i60 * 40 | 0) + 12 | 0, i60);
 i63 = HEAP32[i53 >> 2] | 0;
 __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i63 | 0) == 0 ? 0 : i63 + i54 | 0, i61, i62, i59, i60);
 i63 = (HEAP32[i55 >> 2] | 0) + i56 | 0;
 HEAP32[i63 + (i59 * 40 | 0) + 12 >> 2] = i41;
 HEAP32[i63 + (i59 * 40 | 0) + 16 >> 2] = i47;
 HEAP32[i63 + (i59 * 40 | 0) + 20 >> 2] = i48;
 HEAP32[i63 + (i59 * 40 | 0) + 24 >> 2] = i50;
 i63 = HEAP32[i53 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i63 | 0) == 0 ? 0 : i63 + i54 | 0, i62, i61, i59, i59);
 STACKTOP = i64;
 return;
}

function __ZN20HardwareInfoReporter18ReportHardwareInfoEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i43 + 64 | 0;
 i42 = i43 + 48 | 0;
 i21 = i43 + 40 | 0;
 i41 = i43 + 16 | 0;
 i16 = i43 + 552 | 0;
 i30 = i43 + 456 | 0;
 i36 = i43 + 424 | 0;
 i38 = i43 + 412 | 0;
 i5 = i43 + 584 | 0;
 i39 = i43 + 400 | 0;
 i6 = i43 + 568 | 0;
 i40 = i43 + 356 | 0;
 i7 = i43 + 536 | 0;
 i24 = i43 + 344 | 0;
 i1 = i43 + 520 | 0;
 i25 = i43 + 332 | 0;
 i2 = i43 + 504 | 0;
 i26 = i43 + 320 | 0;
 i3 = i43 + 488 | 0;
 i27 = i43 + 308 | 0;
 i4 = i43 + 472 | 0;
 i28 = i43 + 296 | 0;
 i29 = i43 + 284 | 0;
 i8 = i43 + 440 | 0;
 i31 = i43 + 272 | 0;
 i9 = i43 + 384 | 0;
 i10 = i43 + 368 | 0;
 i32 = i43 + 224 | 0;
 i11 = i43 + 176 | 0;
 i33 = i43 + 148 | 0;
 i34 = i43 + 136 | 0;
 i35 = i43 + 104 | 0;
 i12 = i43 + 92 | 0;
 i13 = i43 + 80 | 0;
 i14 = i43 + 256 | 0;
 i15 = i43 + 240 | 0;
 i17 = i43 + 208 | 0;
 i18 = i43 + 192 | 0;
 i19 = i43 + 160 | 0;
 i20 = i43 + 120 | 0;
 i37 = i43;
 if (!(__Z20IsHumanControllingUsv() | 0)) {
  STACKTOP = i43;
  return;
 }
 if (!(__ZNK14PlayerSettings18GetSubmitAnalyticsEv(__Z17GetPlayerSettingsv() | 0) | 0)) {
  STACKTOP = i43;
  return;
 }
 if (__Z23GetGlobalBoolPreferencePKcb(HEAP32[gb + 188996 >> 2] | 0, 0) | 0) {
  STACKTOP = i43;
  return;
 }
 __Z23SetGlobalBoolPreferencePKcb(HEAP32[gb + 188996 >> 2] | 0, 1);
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 4 >> 2] = 0;
 HEAP32[i36 + 8 >> 2] = 0;
 __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv(i5);
 i44 = i5 + 11 | 0;
 i45 = HEAP8[i44 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 i46 = i47 ? HEAP32[i5 >> 2] | 0 : i5;
 i45 = i47 ? HEAP32[i5 + 4 >> 2] | 0 : i45 & 255;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i38, i46, i45);
 if ((HEAP8[i44 >> 0] | 0) < 0) {
  i47 = HEAP32[i5 >> 2] | 0;
  i46 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv(i6);
 i47 = i6 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i6 >> 2] | 0 : i6;
 i46 = i44 ? HEAP32[i6 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i39, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i6 >> 2] | 0;
  i46 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv(i7);
 i47 = i7 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i7 >> 2] | 0 : i7;
 i46 = i44 ? HEAP32[i7 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i40, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i7 >> 2] | 0;
  i46 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper17GetGraphicsVendorEv(i1);
 i47 = i1 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i1 >> 2] | 0 : i1;
 i46 = i44 ? HEAP32[i1 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i1 >> 2] | 0;
  i46 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper23GetGraphicsFixedVersionEv(i2);
 i47 = i2 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i2 >> 2] | 0 : i2;
 i46 = i44 ? HEAP32[i2 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i2 >> 2] | 0;
  i46 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper30GetGraphicsDriverLibraryStringEv(i3);
 i47 = i3 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i3 >> 2] | 0 : i3;
 i46 = i44 ? HEAP32[i3 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i3 >> 2] | 0;
  i46 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i4, _JS_SystemInfo_GetDocumentURL(0, 0) | 0, 0);
 i47 = i4 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i7 = i46 << 24 >> 24 < 0;
 i44 = i4 + 4 | 0;
 _JS_SystemInfo_GetDocumentURL((i7 ? HEAP32[i4 >> 2] | 0 : i4) | 0, (i7 ? HEAP32[i44 >> 2] | 0 : i46 & 255) | 0) | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i7 = i46 << 24 >> 24 < 0;
 i45 = i7 ? HEAP32[i4 >> 2] | 0 : i4;
 i46 = i7 ? HEAP32[i44 >> 2] | 0 : i46 & 255;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i27, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i4 >> 2] | 0;
  i46 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 i3 = __ZN10systeminfo17GetProcessorCountEv() | 0;
 i4 = __ZN10systeminfo24GetProcessorFrequencyMHzEv() | 0;
 i5 = __ZN10systeminfo19GetPhysicalMemoryMBEv() | 0;
 if (!(__Z19GetScreenManagerPtrv() | 0)) i7 = 0; else {
  i7 = __Z16GetScreenManagerv() | 0;
  i7 = ~~Math_fround(+mftCall_fi(HEAP32[(HEAP32[i7 >> 2] | 0) + 92 >> 2] | 0, i7 | 0));
 }
 i6 = __ZN10systeminfo18GetRuntimePlatformEv() | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i28, gb + 1040146 | 0, 13);
 __ZN11UnityEngine15PlatformWrapper19GetScreenResolutionEv(i8);
 i47 = i8 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i8 >> 2] | 0 : i8;
 i46 = i44 ? HEAP32[i8 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i29, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i8 >> 2] | 0;
  i46 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper14GetDeviceModelEv(i9);
 i47 = i9 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i9 >> 2] | 0 : i9;
 i46 = i44 ? HEAP32[i9 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, i45, i46);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i36, i31) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i9 >> 2] | 0;
  i46 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 __ZN11UnityEngine15PlatformWrapper15GetBuildVersionEv(i10);
 i47 = i10 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i10 >> 2] | 0 : i10;
 i46 = i44 ? HEAP32[i10 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i10 >> 2] | 0;
  i46 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 i1 = __Z19GetBuildSettingsPtrv() | 0;
 if (!i1) i1 = 64; else {
  i47 = HEAP8[i1 + 108 >> 0] | 0 ? 2 : 1;
  i1 = ((HEAP8[i1 + 115 >> 0] | 0) == 0 ? i47 | 8 : i47) | 64;
 }
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 505 >> 0] | 0) == 0;
 i2 = i2 ? i1 : i1 | 16777216;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0) == 0;
 i2 = (i47 ? i2 : i2 | 33554432) | 1073741824;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1041986 | 0, 28);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i47 = HEAP8[i13 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 i47 = i46 ? HEAP32[i13 + 4 >> 2] | 0 : i47 & 255;
 i44 = i30 + 11 | 0;
 i45 = HEAP8[i44 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i30 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i12, i46 ? HEAP32[i13 >> 2] | 0 : i13, i47, i45 + i47 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, (HEAP8[i44 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, i45) | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 i45 = HEAP8[i12 + 11 >> 0] | 0;
 i44 = i45 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i12 + 4 >> 2] | 0 : i45 & 255;
 i47 = i38 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i38 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i35, i44 ? HEAP32[i12 >> 2] | 0 : i12, i45, i46 + i45 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i35, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i38 >> 2] | 0 : i38, i46) | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 i46 = HEAP8[i35 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 i46 = i47 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 i45 = i39 + 11 | 0;
 i44 = HEAP8[i45 >> 0] | 0;
 i44 = i44 << 24 >> 24 < 0 ? HEAP32[i39 + 4 >> 2] | 0 : i44 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i34, i47 ? HEAP32[i35 >> 2] | 0 : i35, i46, i44 + i46 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i39 >> 2] | 0 : i39, i44) | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i33 + 4 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 i44 = HEAP8[i34 + 11 >> 0] | 0;
 i45 = i44 << 24 >> 24 < 0;
 i44 = i45 ? HEAP32[i34 + 4 >> 2] | 0 : i44 & 255;
 i46 = i40 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i40 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i33, i45 ? HEAP32[i34 >> 2] | 0 : i34, i44, i47 + i44 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i33, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i40 >> 2] | 0 : i40, i47) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i47 = HEAP8[i33 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 i47 = i46 ? HEAP32[i33 + 4 >> 2] | 0 : i47 & 255;
 i44 = i24 + 11 | 0;
 i45 = HEAP8[i44 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i24 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i46 ? HEAP32[i33 >> 2] | 0 : i33, i47, i45 + i47 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, (HEAP8[i44 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, i45) | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = HEAP8[i11 + 11 >> 0] | 0;
 i44 = i45 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i11 + 4 >> 2] | 0 : i45 & 255;
 i47 = i25 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i44 ? HEAP32[i11 >> 2] | 0 : i11, i45, i46 + i45 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25, i46) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i32, i16) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i46 = HEAP8[i32 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __Z14ComputeMD5HashPKhjPh(i47 ? HEAP32[i32 >> 2] | 0 : i32, i47 ? HEAP32[i32 + 4 >> 2] | 0 : i46 & 255, i11) | 0;
 __Z16BytesToHexStringPKvj(i33, i11, 16);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i38);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042015 | 0, 3, i47 + 3 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i39);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042019 | 0, 5, i46 + 5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i40);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042025 | 0, 9, i47 + 9 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i24);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042035 | 0, 11, i46 + 11 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i25);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042047 | 0, 12, i47 + 12 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i26);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042060 | 0, 11, i46 + 11 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042072 | 0, 11, i47 + 11 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 if (__Z11IsGfxDevicev() | 0) {
  if (__Z11IsGfxDevicev() | 0) i1 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0; else i1 = 0;
  __Z11IntToStringi(i35, i1);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  i46 = i35 + 11 | 0;
  i47 = HEAP8[i46 >> 0] | 0;
  i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042084 | 0, 8, i47 + 8 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
  i47 = HEAP8[i16 + 11 >> 0] | 0;
  i46 = i47 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 }
 __Z19UnsignedIntToStringj(i35, __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv() | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042093 | 0, 8, i45 + 8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i45) | 0;
 i45 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i45 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 i45 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 234 >> 0] | 0) == 0;
 i45 = i45 ? 1 : 3;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 236 >> 0] | 0) == 0;
 i45 = i47 ? i45 : i45 | 4;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 235 >> 0] | 0) == 0;
 i45 = i47 ? i45 : i45 | 8;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 244 >> 0] | 0) == 0;
 i45 = i47 ? i45 : i45 | 16;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 241 >> 0] | 0) == 0;
 i45 = i47 ? i45 : i45 | 32;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 247 >> 0] | 0) == 0;
 i45 = i47 ? i45 : i45 | 64;
 i47 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 246 >> 0] | 0) == 0;
 __Z19UnsignedIntToStringj(i35, i47 ? i45 : i45 | 128);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = i35 + 11 | 0;
 i47 = HEAP8[i45 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042102 | 0, 7, i47 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z19UnsignedIntToStringj(i35, __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv() | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042110 | 0, 10, i45 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i45) | 0;
 i45 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i45 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, i3);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = i35 + 11 | 0;
 i47 = HEAP8[i45 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042121 | 0, 10, i47 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, i4);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042132 | 0, 9, i45 + 9 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i45) | 0;
 i45 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i45 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, i5);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = i35 + 11 | 0;
 i47 = HEAP8[i45 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042142 | 0, 5, i47 + 5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042148 | 0, 6, i45 + 6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i45) | 0;
 i45 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i45 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i29);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = i35 + 11 | 0;
 i47 = HEAP8[i45 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042155 | 0, 8, i47 + 8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, i7);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i45 = i45 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i45 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042164 | 0, 5, i45 + 5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i45) | 0;
 i45 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i45 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i45 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, i6);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i45 = i35 + 11 | 0;
 i47 = HEAP8[i45 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042170 | 0, 10, i47 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZN11UnityEngine15PlatformWrapper24GetSystemLanguageCultureEv(i14);
 i47 = i14 + 11 | 0;
 i45 = HEAP8[i47 >> 0] | 0;
 i44 = i45 << 24 >> 24 < 0;
 i46 = i44 ? HEAP32[i14 >> 2] | 0 : i14;
 i45 = i44 ? HEAP32[i14 + 4 >> 2] | 0 : i45 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i46, i45);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i12, i13);
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 i45 = i12 + 11 | 0;
 i46 = HEAP8[i45 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i12 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i35, gb + 1042181 | 0, 6, i46 + 6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i35, (HEAP8[i45 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, i46) | 0;
 i46 = HEAP8[i35 + 11 >> 0] | 0;
 i45 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i35 >> 2] | 0 : i35, i45 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i14 >> 2] | 0;
  i46 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 i46 = (__Z15IsGyroAvailablev() | 0) & 1;
 i47 = __ZN10systeminfo21SupportsAccelerometerEv() | 0;
 i46 = i47 ? i46 | 2 : i46;
 i47 = __ZN10systeminfo23SupportsLocationServiceEv() | 0;
 i46 = i47 ? i46 | 4 : i46;
 i47 = __ZN15LocationService18IsHeadingAvailableEv() | 0;
 i46 = i47 ? i46 | 8 : i46;
 i47 = __Z19IsMultiTouchEnabledv() | 0;
 i46 = i47 ? i46 | 16 : i46;
 i47 = __ZN10systeminfo17SupportsVibrationEv() | 0;
 i46 = i47 ? i46 | 32 : i46;
 i47 = __Z24IsTouchPressureSupportedv() | 0;
 __Z19UnsignedIntToStringj(i35, i47 ? i46 | 64 : i46);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042188 | 0, 9, i47 + 9 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z19UnsignedIntToStringj(i35, i2);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042198 | 0, 7, i46 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i33 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i33 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042206 | 0, 6, i47 + 6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i35, i27);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i35 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042213 | 0, 7, i46 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __Z11IntToStringi(i35, HEAPU8[(__Z16GetBuildSettingsv() | 0) + 119 >> 0] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i35 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042221 | 0, 7, i47 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i47 = i28 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i46 = i46 << 24 >> 24 < 0 ? HEAP32[i28 + 4 >> 2] | 0 : i46 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1041536 | 0, 7, i46 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i28 >> 2] | 0 : i28, i46) | 0;
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i47 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i47 ? HEAP32[i16 >> 2] | 0 : i16, i47 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i46 = i31 + 11 | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 i47 = i47 << 24 >> 24 < 0 ? HEAP32[i31 + 4 >> 2] | 0 : i47 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1042229 | 0, 7, i47 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i31 >> 2] | 0 : i31, i47) | 0;
 i47 = HEAP8[i16 + 11 >> 0] | 0;
 i46 = i47 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZN11UnityEngine15PlatformWrapper17GetCloudProjectIdEv(i15);
 i47 = i15 + 11 | 0;
 i46 = HEAP8[i47 >> 0] | 0;
 i44 = i46 << 24 >> 24 < 0;
 i45 = i44 ? HEAP32[i15 >> 2] | 0 : i15;
 i46 = i44 ? HEAP32[i15 + 4 >> 2] | 0 : i46 & 255;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i35, i45, i46);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i15 >> 2] | 0;
  i46 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i16);
 }
 i1 = i35 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i35 + 4 >> 2] | 0 : i2 & 255;
 if (i2 | 0) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, gb + 1041565 | 0, 11, i2 + 11 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, i2) | 0;
  i47 = HEAP8[i16 + 11 >> 0] | 0;
  i46 = i47 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i46 ? HEAP32[i16 >> 2] | 0 : i16, i46 ? HEAP32[i16 + 4 >> 2] | 0 : i47 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 }
 __ZN11UnityEngine15PlatformWrapper14GetProductGUIDEv(i17);
 i47 = i17 + 11 | 0;
 HEAP32[i41 >> 2] = (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
 __Z6FormatPKcz(i16, gb + 1042237 | 0, i41);
 i46 = HEAP8[i16 + 11 >> 0] | 0;
 i45 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i16 >> 2] | 0 : i16, i45 ? HEAP32[i16 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i17 >> 2] | 0;
  i46 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i41 >> 2] = 66;
  HEAP32[i41 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i41);
 }
 i1 = __Z24GetManagerPtrFromContexti(22) | 0;
 if (i1 | 0) {
  __ZN20UnityConnectSettings14GetCloudUserIdEv(i18, i1);
  i47 = i18 + 11 | 0;
  HEAP32[i21 >> 2] = (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18;
  __Z6FormatPKcz(i41, gb + 1041524 | 0, i21);
  i46 = HEAP8[i41 + 11 >> 0] | 0;
  i45 = i46 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i41 >> 2] | 0 : i41, i45 ? HEAP32[i41 + 4 >> 2] | 0 : i46 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
  if ((HEAP8[i47 >> 0] | 0) < 0) {
   i47 = HEAP32[i18 >> 2] | 0;
   i46 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = 66;
   HEAP32[i21 + 4 >> 2] = i46;
   __Z19free_alloc_internalPvRK10MemLabelId(i47, i21);
  }
 }
 __ZN11UnityEngine15PlatformWrapper15GetVRDeviceNameEv(i19);
 i47 = i19 + 11 | 0;
 HEAP32[i42 >> 2] = (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19;
 __Z6FormatPKcz(i41, gb + 1042256 | 0, i42);
 i46 = HEAP8[i41 + 11 >> 0] | 0;
 i45 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i41 >> 2] | 0 : i41, i45 ? HEAP32[i41 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i19 >> 2] | 0;
  i46 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i42 >> 2] = 66;
  HEAP32[i42 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i42);
 }
 __ZN11UnityEngine15PlatformWrapper16GetVRDeviceModelEv(i20);
 i47 = i20 + 11 | 0;
 HEAP32[i22 >> 2] = (HEAP8[i47 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20;
 __Z6FormatPKcz(i42, gb + 1042273 | 0, i22);
 i46 = HEAP8[i42 + 11 >> 0] | 0;
 i45 = i46 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i34, i45 ? HEAP32[i42 >> 2] | 0 : i42, i45 ? HEAP32[i42 + 4 >> 2] | 0 : i46 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
 if ((HEAP8[i47 >> 0] | 0) < 0) {
  i47 = HEAP32[i20 >> 2] | 0;
  i46 = HEAP32[i20 + 12 >> 2] | 0;
  HEAP32[i22 >> 2] = 66;
  HEAP32[i22 + 4 >> 2] = i46;
  __Z19free_alloc_internalPvRK10MemLabelId(i47, i22);
 }
 i4 = i42 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i42 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i42 + 4 | 0;
 HEAP32[i42 >> 2] = i6;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i41, gb + 1047147 | 0, 12);
 i7 = i41 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1041577 | 0, 33);
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i42, i22, i41) | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i1 = __Znwj(40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i41);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 28 | 0, i7);
  i3 = HEAP32[i22 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  i3 = HEAP32[HEAP32[i42 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i42 >> 2] = i3;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
 i45 = HEAP32[gb + 189e3 >> 2] | 0;
 i47 = HEAP8[i34 + 11 >> 0] | 0;
 i44 = i47 << 24 >> 24 < 0;
 i46 = i44 ? HEAP32[i34 >> 2] | 0 : i34;
 i47 = i44 ? HEAP32[i34 + 4 >> 2] | 0 : i47 & 255;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i22 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
 HEAP32[i23 >> 2] = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i45, i46, i47, i42, 0, i22, 0) | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i42, HEAP32[i6 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i40);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
 STACKTOP = i43;
 return;
}

function __ZN13InitialModule13StartExternalERK27ParticleSystemReadOnlyStateRK23ParticleSystemParticlesRK10Matrix4x4fRK24ParticleSystemEmitParamsP22ParticleSystemParticlej(i97, i1, i88, i8, i96, i102, i103) {
 i97 = i97 | 0;
 i1 = i1 | 0;
 i88 = i88 | 0;
 i8 = i8 | 0;
 i96 = i96 | 0;
 i102 = i102 | 0;
 i103 = i103 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, f111 = f0, f112 = f0, f113 = f0;
 i101 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i98 = i101 + 144 | 0;
 i99 = i101 + 128 | 0;
 i100 = i101 + 112 | 0;
 i89 = i101 + 96 | 0;
 i90 = i101 + 80 | 0;
 i91 = i101 + 64 | 0;
 i92 = i101 + 48 | 0;
 i93 = i101 + 32 | 0;
 i94 = i101 + 16 | 0;
 i87 = i101;
 i95 = HEAP16[i96 + 120 >> 1] | 0;
 i1 = (i95 & 65535) >>> 8 & 255;
 if (!((i95 & 255) << 24 >> 24)) {
  i5 = HEAP32[i8 + 48 >> 2] | 0;
  i6 = HEAP32[i8 + 52 >> 2] | 0;
  i7 = HEAP32[i8 + 56 >> 2] | 0;
  if (i103) {
   i1 = 0;
   do {
    HEAP32[i102 + (i1 * 120 | 0) >> 2] = i5;
    HEAP32[i102 + (i1 * 120 | 0) + 4 >> 2] = i6;
    HEAP32[i102 + (i1 * 120 | 0) + 8 >> 2] = i7;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i103 | 0));
   i1 = HEAP8[i96 + 121 >> 0] | 0;
  }
 }
 if (!(i1 << 24 >> 24)) {
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f43 = Math_fround(HEAPF32[gb + 62548 >> 2]);
  f3 = Math_fround(f3 * f43);
  f4 = Math_fround(HEAPF32[i8 + 16 >> 2]);
  f44 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
  f4 = Math_fround(f3 + Math_fround(f4 * f44));
  f3 = Math_fround(HEAPF32[i8 + 32 >> 2]);
  f2 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
  f3 = Math_fround(f4 + Math_fround(f3 * f2));
  f4 = Math_fround(f43 * Math_fround(HEAPF32[i8 + 4 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f44 * Math_fround(HEAPF32[i8 + 20 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i8 + 36 >> 2])));
  f43 = Math_fround(f43 * Math_fround(HEAPF32[i8 + 8 >> 2]));
  f44 = Math_fround(f43 + Math_fround(f44 * Math_fround(HEAPF32[i8 + 24 >> 2])));
  f2 = Math_fround(f44 + Math_fround(f2 * Math_fround(HEAPF32[i8 + 40 >> 2])));
  if (i103 | 0) {
   i1 = 0;
   do {
    HEAPF32[i102 + (i1 * 120 | 0) + 12 >> 2] = f3;
    HEAPF32[i102 + (i1 * 120 | 0) + 16 >> 2] = f4;
    HEAPF32[i102 + (i1 * 120 | 0) + 20 >> 2] = f2;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i103 | 0));
  }
 }
 i95 = HEAP16[i96 + 122 >> 1] | 0;
 i1 = (i95 & 65535) >>> 8 & 255;
 if (!((i95 & 255) << 24 >> 24)) if ((HEAP8[i88 + 868 >> 0] | 0) != 0 & (i103 | 0) != 0) {
  i1 = 0;
  do {
   i95 = i102 + (i1 * 120 | 0) + 48 | 0;
   HEAP32[i95 >> 2] = HEAP32[gb + 62548 >> 2];
   HEAP32[i95 + 4 >> 2] = HEAP32[gb + 62548 + 4 >> 2];
   HEAP32[i95 + 8 >> 2] = HEAP32[gb + 62548 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i103 | 0));
  i1 = HEAP8[i96 + 123 >> 0] | 0;
 }
 i95 = (i103 | 0) != 0;
 if (i1 << 24 >> 24 == 0 & i95) {
  i73 = i88 + 870 | 0;
  i74 = i97 + 2012 | 0;
  i75 = i97 + 2556 | 0;
  i76 = i97 + 2560 | 0;
  i77 = i97 + 2564 | 0;
  i78 = i97 + 2568 | 0;
  i79 = i97 + 2572 | 0;
  i80 = i97 + 2576 | 0;
  i81 = i97 + 2580 | 0;
  i82 = i97 + 2584 | 0;
  i83 = i97 + 2588 | 0;
  i84 = i97 + 2592 | 0;
  i85 = i97 + 2596 | 0;
  i86 = i97 + 2600 | 0;
  i6 = i97 + 2604 | 0;
  i7 = i97 + 2608 | 0;
  i8 = i97 + 2612 | 0;
  i9 = i97 + 2616 | 0;
  i10 = i100 + 4 | 0;
  i11 = i100 + 8 | 0;
  i12 = i100 + 12 | 0;
  i13 = i97 + 2096 | 0;
  i14 = i97 + 2092 | 0;
  i15 = i98 + 12 | 0;
  i16 = i98 + 8 | 0;
  i17 = i98 + 4 | 0;
  i18 = i97 + 2244 | 0;
  i19 = i97 + 2156 | 0;
  i20 = i97 + 1484 | 0;
  i21 = i89 + 4 | 0;
  i22 = i89 + 8 | 0;
  i23 = i89 + 12 | 0;
  i24 = i97 + 1568 | 0;
  i25 = i97 + 1748 | 0;
  i26 = i92 + 4 | 0;
  i27 = i92 + 8 | 0;
  i28 = i92 + 12 | 0;
  i29 = i97 + 1832 | 0;
  i30 = i87 + 4 | 0;
  i32 = i87 + 8 | 0;
  i33 = i87 + 12 | 0;
  i34 = i98 + 16 | 0;
  i35 = i98 + 32 | 0;
  i36 = i98 + 16 | 0;
  i45 = i98 + 32 | 0;
  i46 = i93 + 12 | 0;
  i47 = i93 + 8 | 0;
  i48 = i93 + 4 | 0;
  i49 = i97 + 1828 | 0;
  i50 = i90 + 12 | 0;
  i51 = i90 + 8 | 0;
  i52 = i90 + 4 | 0;
  i53 = i97 + 1980 | 0;
  i54 = i97 + 1892 | 0;
  i55 = i97 + 1564 | 0;
  i56 = i99 + 12 | 0;
  i57 = i99 + 8 | 0;
  i58 = i99 + 4 | 0;
  i59 = i97 + 1716 | 0;
  i60 = i97 + 1628 | 0;
  i61 = i98 + 4 | 0;
  i62 = i98 + 8 | 0;
  i63 = i98 + 12 | 0;
  i64 = i98 + 4 | 0;
  i65 = i36 + 4 | 0;
  i66 = i45 + 4 | 0;
  i67 = i98 + 8 | 0;
  i68 = i36 + 8 | 0;
  i69 = i45 + 8 | 0;
  i70 = i98 + 12 | 0;
  i71 = i36 + 12 | 0;
  i72 = i45 + 12 | 0;
  i5 = 0;
  do {
   if (!(HEAP8[i73 >> 0] | 0)) {
    HEAP32[i99 >> 2] = 0;
    HEAP32[i99 + 4 >> 2] = 0;
    HEAP32[i99 + 8 >> 2] = 0;
    HEAP32[i99 + 12 >> 2] = 0;
    i110 = HEAP32[i75 >> 2] | 0;
    i109 = HEAP32[i76 >> 2] | 0;
    i108 = HEAP32[i77 >> 2] | 0;
    i107 = HEAP32[i78 >> 2] | 0;
    i110 = i110 << 11 ^ i110;
    i109 = i109 << 11 ^ i109;
    i108 = i108 << 11 ^ i108;
    i107 = i107 << 11 ^ i107;
    i106 = HEAP32[i80 >> 2] | 0;
    i105 = HEAP32[i81 >> 2] | 0;
    i104 = HEAP32[i82 >> 2] | 0;
    HEAP32[i75 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i76 >> 2] = i106;
    HEAP32[i77 >> 2] = i105;
    HEAP32[i78 >> 2] = i104;
    i104 = HEAP32[i84 >> 2] | 0;
    i105 = HEAP32[i85 >> 2] | 0;
    i106 = HEAP32[i86 >> 2] | 0;
    HEAP32[i79 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i80 >> 2] = i104;
    HEAP32[i81 >> 2] = i105;
    HEAP32[i82 >> 2] = i106;
    i106 = HEAP32[i6 >> 2] | 0;
    i105 = HEAP32[i7 >> 2] | 0;
    i104 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i83 >> 2] = i106;
    HEAP32[i84 >> 2] = i105;
    HEAP32[i85 >> 2] = i104;
    HEAP32[i86 >> 2] = i1;
    i106 = i110 >>> 8 ^ i110 ^ i106 ^ i106 >>> 19;
    i105 = i109 >>> 8 ^ i109 ^ i105 ^ i105 >>> 19;
    i104 = i108 >>> 8 ^ i108 ^ i104 ^ i104 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i6 >> 2] = i106;
    HEAP32[i7 >> 2] = i105;
    HEAP32[i8 >> 2] = i104;
    HEAP32[i9 >> 2] = i1;
    f2 = Math_fround(Math_fround(i106 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i105 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i104 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i100 >> 2] = f2;
    HEAPF32[i10 >> 2] = f3;
    HEAPF32[i11 >> 2] = f4;
    HEAPF32[i12 >> 2] = f31;
    i1 = HEAP32[i13 >> 2] | 0;
    L24 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i14 >> 2] | 0;
      HEAP32[i15 >> 2] = i110;
      HEAP32[i16 >> 2] = i110;
      HEAP32[i17 >> 2] = i110;
      HEAP32[i98 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i14 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i19 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i98 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i17 >> 2] = f42;
      HEAPF32[i16 >> 2] = f43;
      HEAPF32[i15 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i98, i74, i99, i100);
      break L24;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i98, i74, i99, i100);
      break L24;
     }
    } while (0);
    i110 = HEAP32[i98 >> 2] | 0;
    HEAPF32[i102 + (i5 * 120 | 0) + 60 >> 2] = Math_fround(0.0);
    HEAPF32[i102 + (i5 * 120 | 0) + 64 >> 2] = Math_fround(0.0);
    HEAP32[i102 + (i5 * 120 | 0) + 68 >> 2] = i110;
    i110 = i5 | 1;
    i109 = HEAP32[i61 >> 2] | 0;
    HEAPF32[i102 + (i110 * 120 | 0) + 60 >> 2] = Math_fround(0.0);
    HEAPF32[i102 + (i110 * 120 | 0) + 64 >> 2] = Math_fround(0.0);
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i109;
    i110 = i5 | 2;
    i109 = HEAP32[i62 >> 2] | 0;
    HEAPF32[i102 + (i110 * 120 | 0) + 60 >> 2] = Math_fround(0.0);
    HEAPF32[i102 + (i110 * 120 | 0) + 64 >> 2] = Math_fround(0.0);
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i109;
    i110 = i5 | 3;
    i109 = HEAP32[i63 >> 2] | 0;
    HEAPF32[i102 + (i110 * 120 | 0) + 60 >> 2] = Math_fround(0.0);
    HEAPF32[i102 + (i110 * 120 | 0) + 64 >> 2] = Math_fround(0.0);
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i109;
   } else {
    HEAP32[i100 >> 2] = 0;
    HEAP32[i100 + 4 >> 2] = 0;
    HEAP32[i100 + 8 >> 2] = 0;
    HEAP32[i100 + 12 >> 2] = 0;
    i104 = HEAP32[i75 >> 2] | 0;
    i105 = HEAP32[i76 >> 2] | 0;
    i106 = HEAP32[i77 >> 2] | 0;
    i107 = HEAP32[i78 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i80 >> 2] | 0;
    i109 = HEAP32[i81 >> 2] | 0;
    i110 = HEAP32[i82 >> 2] | 0;
    HEAP32[i75 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i76 >> 2] = i108;
    HEAP32[i77 >> 2] = i109;
    HEAP32[i78 >> 2] = i110;
    i110 = HEAP32[i84 >> 2] | 0;
    i109 = HEAP32[i85 >> 2] | 0;
    i108 = HEAP32[i86 >> 2] | 0;
    HEAP32[i79 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i80 >> 2] = i110;
    HEAP32[i81 >> 2] = i109;
    HEAP32[i82 >> 2] = i108;
    i108 = HEAP32[i6 >> 2] | 0;
    i109 = HEAP32[i7 >> 2] | 0;
    i110 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i83 >> 2] = i108;
    HEAP32[i84 >> 2] = i109;
    HEAP32[i85 >> 2] = i110;
    HEAP32[i86 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i6 >> 2] = i108;
    HEAP32[i7 >> 2] = i109;
    HEAP32[i8 >> 2] = i110;
    HEAP32[i9 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i89 >> 2] = f2;
    HEAPF32[i21 >> 2] = f3;
    HEAPF32[i22 >> 2] = f4;
    HEAPF32[i23 >> 2] = f31;
    i1 = HEAP32[i24 >> 2] | 0;
    L33 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i55 >> 2] | 0;
      HEAP32[i56 >> 2] = i110;
      HEAP32[i57 >> 2] = i110;
      HEAP32[i58 >> 2] = i110;
      HEAP32[i99 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i59 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i55 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i60 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i99 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i58 >> 2] = f42;
      HEAPF32[i57 >> 2] = f43;
      HEAPF32[i56 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i99, i20, i100, i89);
      break L33;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i99, i20, i100, i89);
      break L33;
     }
    } while (0);
    HEAP32[i91 >> 2] = 0;
    HEAP32[i91 + 4 >> 2] = 0;
    HEAP32[i91 + 8 >> 2] = 0;
    HEAP32[i91 + 12 >> 2] = 0;
    i104 = HEAP32[i75 >> 2] | 0;
    i105 = HEAP32[i76 >> 2] | 0;
    i106 = HEAP32[i77 >> 2] | 0;
    i107 = HEAP32[i78 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i80 >> 2] | 0;
    i109 = HEAP32[i81 >> 2] | 0;
    i110 = HEAP32[i82 >> 2] | 0;
    HEAP32[i75 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i76 >> 2] = i108;
    HEAP32[i77 >> 2] = i109;
    HEAP32[i78 >> 2] = i110;
    i110 = HEAP32[i84 >> 2] | 0;
    i109 = HEAP32[i85 >> 2] | 0;
    i108 = HEAP32[i86 >> 2] | 0;
    HEAP32[i79 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i80 >> 2] = i110;
    HEAP32[i81 >> 2] = i109;
    HEAP32[i82 >> 2] = i108;
    i108 = HEAP32[i6 >> 2] | 0;
    i109 = HEAP32[i7 >> 2] | 0;
    i110 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i83 >> 2] = i108;
    HEAP32[i84 >> 2] = i109;
    HEAP32[i85 >> 2] = i110;
    HEAP32[i86 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i6 >> 2] = i108;
    HEAP32[i7 >> 2] = i109;
    HEAP32[i8 >> 2] = i110;
    HEAP32[i9 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i92 >> 2] = f2;
    HEAPF32[i26 >> 2] = f3;
    HEAPF32[i27 >> 2] = f4;
    HEAPF32[i28 >> 2] = f31;
    i1 = HEAP32[i29 >> 2] | 0;
    L41 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i49 >> 2] | 0;
      HEAP32[i50 >> 2] = i110;
      HEAP32[i51 >> 2] = i110;
      HEAP32[i52 >> 2] = i110;
      HEAP32[i90 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i53 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i49 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i54 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i90 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i52 >> 2] = f42;
      HEAPF32[i51 >> 2] = f43;
      HEAPF32[i50 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i90, i25, i91, i92);
      break L41;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i90, i25, i91, i92);
      break L41;
     }
    } while (0);
    HEAP32[i94 >> 2] = 0;
    HEAP32[i94 + 4 >> 2] = 0;
    HEAP32[i94 + 8 >> 2] = 0;
    HEAP32[i94 + 12 >> 2] = 0;
    i104 = HEAP32[i75 >> 2] | 0;
    i105 = HEAP32[i76 >> 2] | 0;
    i106 = HEAP32[i77 >> 2] | 0;
    i107 = HEAP32[i78 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i80 >> 2] | 0;
    i109 = HEAP32[i81 >> 2] | 0;
    i110 = HEAP32[i82 >> 2] | 0;
    HEAP32[i75 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i76 >> 2] = i108;
    HEAP32[i77 >> 2] = i109;
    HEAP32[i78 >> 2] = i110;
    i110 = HEAP32[i84 >> 2] | 0;
    i109 = HEAP32[i85 >> 2] | 0;
    i108 = HEAP32[i86 >> 2] | 0;
    HEAP32[i79 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i80 >> 2] = i110;
    HEAP32[i81 >> 2] = i109;
    HEAP32[i82 >> 2] = i108;
    i108 = HEAP32[i6 >> 2] | 0;
    i109 = HEAP32[i7 >> 2] | 0;
    i110 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i83 >> 2] = i108;
    HEAP32[i84 >> 2] = i109;
    HEAP32[i85 >> 2] = i110;
    HEAP32[i86 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i6 >> 2] = i108;
    HEAP32[i7 >> 2] = i109;
    HEAP32[i8 >> 2] = i110;
    HEAP32[i9 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i87 >> 2] = f2;
    HEAPF32[i30 >> 2] = f3;
    HEAPF32[i32 >> 2] = f4;
    HEAPF32[i33 >> 2] = f31;
    i1 = HEAP32[i13 >> 2] | 0;
    L49 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i14 >> 2] | 0;
      HEAP32[i46 >> 2] = i110;
      HEAP32[i47 >> 2] = i110;
      HEAP32[i48 >> 2] = i110;
      HEAP32[i93 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i14 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i19 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i93 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i48 >> 2] = f42;
      HEAPF32[i47 >> 2] = f43;
      HEAPF32[i46 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i93, i74, i94, i87);
      break L49;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i93, i74, i94, i87);
      break L49;
     }
    } while (0);
    HEAP32[i98 >> 2] = HEAP32[i99 >> 2];
    HEAP32[i98 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
    HEAP32[i98 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
    HEAP32[i98 + 12 >> 2] = HEAP32[i99 + 12 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i90 >> 2];
    HEAP32[i34 + 4 >> 2] = HEAP32[i90 + 4 >> 2];
    HEAP32[i34 + 8 >> 2] = HEAP32[i90 + 8 >> 2];
    HEAP32[i34 + 12 >> 2] = HEAP32[i90 + 12 >> 2];
    HEAP32[i35 >> 2] = HEAP32[i93 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i93 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i93 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i93 + 12 >> 2];
    i108 = HEAP32[i36 >> 2] | 0;
    i110 = HEAP32[i45 >> 2] | 0;
    HEAP32[i102 + (i5 * 120 | 0) + 60 >> 2] = HEAP32[i98 >> 2];
    HEAP32[i102 + (i5 * 120 | 0) + 64 >> 2] = i108;
    HEAP32[i102 + (i5 * 120 | 0) + 68 >> 2] = i110;
    i110 = i5 | 1;
    i108 = HEAP32[i65 >> 2] | 0;
    i109 = HEAP32[i66 >> 2] | 0;
    HEAP32[i102 + (i110 * 120 | 0) + 60 >> 2] = HEAP32[i64 >> 2];
    HEAP32[i102 + (i110 * 120 | 0) + 64 >> 2] = i108;
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i109;
    i110 = i5 | 2;
    i109 = HEAP32[i68 >> 2] | 0;
    i108 = HEAP32[i69 >> 2] | 0;
    HEAP32[i102 + (i110 * 120 | 0) + 60 >> 2] = HEAP32[i67 >> 2];
    HEAP32[i102 + (i110 * 120 | 0) + 64 >> 2] = i109;
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i108;
    i110 = i5 | 3;
    i108 = HEAP32[i71 >> 2] | 0;
    i109 = HEAP32[i72 >> 2] | 0;
    HEAP32[i102 + (i110 * 120 | 0) + 60 >> 2] = HEAP32[i70 >> 2];
    HEAP32[i102 + (i110 * 120 | 0) + 64 >> 2] = i108;
    HEAP32[i102 + (i110 * 120 | 0) + 68 >> 2] = i109;
   }
   i5 = i5 + 4 | 0;
  } while (i5 >>> 0 < i103 >>> 0);
 }
 i1 = HEAP16[i96 + 124 >> 1] | 0;
 if ((i1 & 255) << 24 >> 24 == 0 & i95) {
  i1 = 0;
  do {
   i110 = i102 + (i1 * 120 | 0) + 72 | 0;
   HEAP32[i110 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i110 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i110 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i103 | 0));
  i1 = HEAP8[i96 + 125 >> 0] | 0;
 } else i1 = (i1 & 65535) >>> 8 & 255;
 if (i1 << 24 >> 24 == 0 & i95) {
  i6 = i88 + 871 | 0;
  i7 = i97 + 692 | 0;
  i8 = i97 + 2556 | 0;
  i9 = i97 + 2560 | 0;
  i10 = i97 + 2564 | 0;
  i11 = i97 + 2568 | 0;
  i12 = i97 + 2572 | 0;
  i13 = i97 + 2576 | 0;
  i14 = i97 + 2580 | 0;
  i15 = i97 + 2584 | 0;
  i16 = i97 + 2588 | 0;
  i17 = i97 + 2592 | 0;
  i18 = i97 + 2596 | 0;
  i19 = i97 + 2600 | 0;
  i20 = i97 + 2604 | 0;
  i21 = i97 + 2608 | 0;
  i22 = i97 + 2612 | 0;
  i23 = i97 + 2616 | 0;
  i24 = i100 + 4 | 0;
  i25 = i100 + 8 | 0;
  i26 = i100 + 12 | 0;
  i27 = i97 + 776 | 0;
  i28 = i98 + 4 | 0;
  i29 = i98 + 8 | 0;
  i30 = i98 + 12 | 0;
  i32 = i97 + 772 | 0;
  i33 = i97 + 924 | 0;
  i34 = i97 + 836 | 0;
  i35 = i100 + 4 | 0;
  i36 = i100 + 8 | 0;
  i45 = i100 + 12 | 0;
  i46 = i98 + 4 | 0;
  i47 = i98 + 8 | 0;
  i48 = i98 + 12 | 0;
  i49 = i97 + 956 | 0;
  i50 = i91 + 4 | 0;
  i51 = i91 + 8 | 0;
  i52 = i91 + 12 | 0;
  i53 = i97 + 1040 | 0;
  i54 = i89 + 4 | 0;
  i55 = i89 + 8 | 0;
  i56 = i89 + 12 | 0;
  i57 = i97 + 1220 | 0;
  i58 = i94 + 4 | 0;
  i59 = i94 + 8 | 0;
  i60 = i94 + 12 | 0;
  i61 = i97 + 1304 | 0;
  i62 = i92 + 4 | 0;
  i63 = i92 + 8 | 0;
  i64 = i92 + 12 | 0;
  i65 = i97 + 1300 | 0;
  i66 = i97 + 1452 | 0;
  i67 = i97 + 1364 | 0;
  i68 = i97 + 1036 | 0;
  i69 = i97 + 1188 | 0;
  i70 = i97 + 1100 | 0;
  i5 = 0;
  do {
   if (!(HEAP8[i6 >> 0] | 0)) {
    HEAP32[i99 >> 2] = 0;
    HEAP32[i99 + 4 >> 2] = 0;
    HEAP32[i99 + 8 >> 2] = 0;
    HEAP32[i99 + 12 >> 2] = 0;
    i104 = HEAP32[i8 >> 2] | 0;
    i105 = HEAP32[i9 >> 2] | 0;
    i106 = HEAP32[i10 >> 2] | 0;
    i107 = HEAP32[i11 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i13 >> 2] | 0;
    i109 = HEAP32[i14 >> 2] | 0;
    i110 = HEAP32[i15 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i9 >> 2] = i108;
    HEAP32[i10 >> 2] = i109;
    HEAP32[i11 >> 2] = i110;
    i110 = HEAP32[i17 >> 2] | 0;
    i109 = HEAP32[i18 >> 2] | 0;
    i108 = HEAP32[i19 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i13 >> 2] = i110;
    HEAP32[i14 >> 2] = i109;
    HEAP32[i15 >> 2] = i108;
    i108 = HEAP32[i20 >> 2] | 0;
    i109 = HEAP32[i21 >> 2] | 0;
    i110 = HEAP32[i22 >> 2] | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i16 >> 2] = i108;
    HEAP32[i17 >> 2] = i109;
    HEAP32[i18 >> 2] = i110;
    HEAP32[i19 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i20 >> 2] = i108;
    HEAP32[i21 >> 2] = i109;
    HEAP32[i22 >> 2] = i110;
    HEAP32[i23 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i100 >> 2] = f2;
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i25 >> 2] = f4;
    HEAPF32[i26 >> 2] = f31;
    i1 = HEAP32[i27 >> 2] | 0;
    L71 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i32 >> 2] | 0;
      HEAP32[i30 >> 2] = i110;
      HEAP32[i29 >> 2] = i110;
      HEAP32[i28 >> 2] = i110;
      HEAP32[i98 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i33 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i32 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i98 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i28 >> 2] = f42;
      HEAPF32[i29 >> 2] = f43;
      HEAPF32[i30 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i98, i7, i99, i100);
      break L71;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i98, i7, i99, i100);
      break L71;
     }
    } while (0);
    f41 = Math_fround(HEAPF32[i98 >> 2]);
    i110 = f41 < Math_fround(0.0);
    f41 = i110 ? Math_fround(0.0) : f41;
    f42 = Math_fround(HEAPF32[i28 >> 2]);
    i110 = f42 < Math_fround(0.0);
    f42 = i110 ? Math_fround(0.0) : f42;
    f43 = Math_fround(HEAPF32[i29 >> 2]);
    i110 = f43 < Math_fround(0.0);
    f43 = i110 ? Math_fround(0.0) : f43;
    f44 = Math_fround(HEAPF32[i30 >> 2]);
    i110 = f44 < Math_fround(0.0);
    f44 = i110 ? Math_fround(0.0) : f44;
    HEAPF32[i102 + (i5 * 120 | 0) + 84 >> 2] = f41;
    HEAPF32[i102 + (i5 * 120 | 0) + 88 >> 2] = f41;
    HEAPF32[i102 + (i5 * 120 | 0) + 92 >> 2] = f41;
    i110 = i5 | 1;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f42;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f42;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f42;
    i110 = i5 | 2;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f43;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f43;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f43;
    i110 = i5 | 3;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f44;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f44;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f44;
   } else {
    HEAP32[i99 >> 2] = 0;
    HEAP32[i99 + 4 >> 2] = 0;
    HEAP32[i99 + 8 >> 2] = 0;
    HEAP32[i99 + 12 >> 2] = 0;
    i104 = HEAP32[i8 >> 2] | 0;
    i105 = HEAP32[i9 >> 2] | 0;
    i106 = HEAP32[i10 >> 2] | 0;
    i107 = HEAP32[i11 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i13 >> 2] | 0;
    i109 = HEAP32[i14 >> 2] | 0;
    i110 = HEAP32[i15 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i9 >> 2] = i108;
    HEAP32[i10 >> 2] = i109;
    HEAP32[i11 >> 2] = i110;
    i110 = HEAP32[i17 >> 2] | 0;
    i109 = HEAP32[i18 >> 2] | 0;
    i108 = HEAP32[i19 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i13 >> 2] = i110;
    HEAP32[i14 >> 2] = i109;
    HEAP32[i15 >> 2] = i108;
    i108 = HEAP32[i20 >> 2] | 0;
    i109 = HEAP32[i21 >> 2] | 0;
    i110 = HEAP32[i22 >> 2] | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i16 >> 2] = i108;
    HEAP32[i17 >> 2] = i109;
    HEAP32[i18 >> 2] = i110;
    HEAP32[i19 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i20 >> 2] = i108;
    HEAP32[i21 >> 2] = i109;
    HEAP32[i22 >> 2] = i110;
    HEAP32[i23 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i100 >> 2] = f2;
    HEAPF32[i35 >> 2] = f3;
    HEAPF32[i36 >> 2] = f4;
    HEAPF32[i45 >> 2] = f31;
    i1 = HEAP32[i27 >> 2] | 0;
    L80 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i32 >> 2] | 0;
      HEAP32[i48 >> 2] = i110;
      HEAP32[i47 >> 2] = i110;
      HEAP32[i46 >> 2] = i110;
      HEAP32[i98 >> 2] = i110;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i33 >> 2] | 0) + 4 >> 2]);
      f41 = Math_fround(HEAPF32[i32 >> 2]);
      f40 = Math_fround(f40 * f41);
      f41 = Math_fround(Math_fround(f41 * Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + 4 >> 2])) - f40);
      f42 = Math_fround(f40 + Math_fround(f41 * f3));
      f43 = Math_fround(f40 + Math_fround(f41 * f4));
      f44 = Math_fround(f40 + Math_fround(f31 * f41));
      HEAPF32[i98 >> 2] = Math_fround(f40 + Math_fround(f2 * f41));
      HEAPF32[i46 >> 2] = f42;
      HEAPF32[i47 >> 2] = f43;
      HEAPF32[i48 >> 2] = f44;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i98, i7, i99, i100);
      break L80;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i98, i7, i99, i100);
      break L80;
     }
    } while (0);
    f41 = Math_fround(HEAPF32[i98 >> 2]);
    i104 = f41 < Math_fround(0.0);
    f41 = i104 ? Math_fround(0.0) : f41;
    f43 = Math_fround(HEAPF32[i46 >> 2]);
    i104 = f43 < Math_fround(0.0);
    f43 = i104 ? Math_fround(0.0) : f43;
    f42 = Math_fround(HEAPF32[i47 >> 2]);
    i104 = f42 < Math_fround(0.0);
    f42 = i104 ? Math_fround(0.0) : f42;
    f44 = Math_fround(HEAPF32[i48 >> 2]);
    i104 = f44 < Math_fround(0.0);
    f44 = i104 ? Math_fround(0.0) : f44;
    HEAP32[i90 >> 2] = 0;
    HEAP32[i90 + 4 >> 2] = 0;
    HEAP32[i90 + 8 >> 2] = 0;
    HEAP32[i90 + 12 >> 2] = 0;
    i104 = HEAP32[i8 >> 2] | 0;
    i105 = HEAP32[i9 >> 2] | 0;
    i106 = HEAP32[i10 >> 2] | 0;
    i107 = HEAP32[i11 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i13 >> 2] | 0;
    i109 = HEAP32[i14 >> 2] | 0;
    i110 = HEAP32[i15 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i9 >> 2] = i108;
    HEAP32[i10 >> 2] = i109;
    HEAP32[i11 >> 2] = i110;
    i110 = HEAP32[i17 >> 2] | 0;
    i109 = HEAP32[i18 >> 2] | 0;
    i108 = HEAP32[i19 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i13 >> 2] = i110;
    HEAP32[i14 >> 2] = i109;
    HEAP32[i15 >> 2] = i108;
    i108 = HEAP32[i20 >> 2] | 0;
    i109 = HEAP32[i21 >> 2] | 0;
    i110 = HEAP32[i22 >> 2] | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i16 >> 2] = i108;
    HEAP32[i17 >> 2] = i109;
    HEAP32[i18 >> 2] = i110;
    HEAP32[i19 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i20 >> 2] = i108;
    HEAP32[i21 >> 2] = i109;
    HEAP32[i22 >> 2] = i110;
    HEAP32[i23 >> 2] = i1;
    f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f31 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i91 >> 2] = f2;
    HEAPF32[i50 >> 2] = f3;
    HEAPF32[i51 >> 2] = f4;
    HEAPF32[i52 >> 2] = f31;
    i1 = HEAP32[i53 >> 2] | 0;
    L88 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i68 >> 2] | 0;
      HEAP32[i56 >> 2] = i110;
      HEAP32[i55 >> 2] = i110;
      HEAP32[i54 >> 2] = i110;
      HEAP32[i89 >> 2] = i110;
      break;
     }
    case 3:
     {
      f111 = Math_fround(HEAPF32[(HEAP32[i69 >> 2] | 0) + 4 >> 2]);
      f37 = Math_fround(HEAPF32[i68 >> 2]);
      f111 = Math_fround(f111 * f37);
      f37 = Math_fround(Math_fround(f37 * Math_fround(HEAPF32[(HEAP32[i70 >> 2] | 0) + 4 >> 2])) - f111);
      f38 = Math_fround(f111 + Math_fround(f37 * f3));
      f39 = Math_fround(f111 + Math_fround(f37 * f4));
      f40 = Math_fround(f111 + Math_fround(f31 * f37));
      HEAPF32[i89 >> 2] = Math_fround(f111 + Math_fround(f2 * f37));
      HEAPF32[i54 >> 2] = f38;
      HEAPF32[i55 >> 2] = f39;
      HEAPF32[i56 >> 2] = f40;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i89, i49, i90, i91);
      break L88;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i89, i49, i90, i91);
      break L88;
     }
    } while (0);
    f2 = Math_fround(HEAPF32[i89 >> 2]);
    i104 = f2 < Math_fround(0.0);
    f2 = i104 ? Math_fround(0.0) : f2;
    f4 = Math_fround(HEAPF32[i54 >> 2]);
    i104 = f4 < Math_fround(0.0);
    f4 = i104 ? Math_fround(0.0) : f4;
    f3 = Math_fround(HEAPF32[i55 >> 2]);
    i104 = f3 < Math_fround(0.0);
    f3 = i104 ? Math_fround(0.0) : f3;
    f31 = Math_fround(HEAPF32[i56 >> 2]);
    i104 = f31 < Math_fround(0.0);
    f31 = i104 ? Math_fround(0.0) : f31;
    HEAP32[i93 >> 2] = 0;
    HEAP32[i93 + 4 >> 2] = 0;
    HEAP32[i93 + 8 >> 2] = 0;
    HEAP32[i93 + 12 >> 2] = 0;
    i104 = HEAP32[i8 >> 2] | 0;
    i105 = HEAP32[i9 >> 2] | 0;
    i106 = HEAP32[i10 >> 2] | 0;
    i107 = HEAP32[i11 >> 2] | 0;
    i104 = i104 << 11 ^ i104;
    i105 = i105 << 11 ^ i105;
    i106 = i106 << 11 ^ i106;
    i107 = i107 << 11 ^ i107;
    i108 = HEAP32[i13 >> 2] | 0;
    i109 = HEAP32[i14 >> 2] | 0;
    i110 = HEAP32[i15 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i9 >> 2] = i108;
    HEAP32[i10 >> 2] = i109;
    HEAP32[i11 >> 2] = i110;
    i110 = HEAP32[i17 >> 2] | 0;
    i109 = HEAP32[i18 >> 2] | 0;
    i108 = HEAP32[i19 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i13 >> 2] = i110;
    HEAP32[i14 >> 2] = i109;
    HEAP32[i15 >> 2] = i108;
    i108 = HEAP32[i20 >> 2] | 0;
    i109 = HEAP32[i21 >> 2] | 0;
    i110 = HEAP32[i22 >> 2] | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i16 >> 2] = i108;
    HEAP32[i17 >> 2] = i109;
    HEAP32[i18 >> 2] = i110;
    HEAP32[i19 >> 2] = i1;
    i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
    i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
    i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
    i1 = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
    HEAP32[i20 >> 2] = i108;
    HEAP32[i21 >> 2] = i109;
    HEAP32[i22 >> 2] = i110;
    HEAP32[i23 >> 2] = i1;
    f37 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f38 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f39 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
    f40 = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i94 >> 2] = f37;
    HEAPF32[i58 >> 2] = f38;
    HEAPF32[i59 >> 2] = f39;
    HEAPF32[i60 >> 2] = f40;
    i1 = HEAP32[i61 >> 2] | 0;
    L96 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i110 = HEAP32[i65 >> 2] | 0;
      HEAP32[i64 >> 2] = i110;
      HEAP32[i63 >> 2] = i110;
      HEAP32[i62 >> 2] = i110;
      HEAP32[i92 >> 2] = i110;
      break;
     }
    case 3:
     {
      f113 = Math_fround(HEAPF32[(HEAP32[i66 >> 2] | 0) + 4 >> 2]);
      f112 = Math_fround(HEAPF32[i65 >> 2]);
      f113 = Math_fround(f113 * f112);
      f112 = Math_fround(Math_fround(f112 * Math_fround(HEAPF32[(HEAP32[i67 >> 2] | 0) + 4 >> 2])) - f113);
      f38 = Math_fround(f113 + Math_fround(f112 * f38));
      f39 = Math_fround(f113 + Math_fround(f112 * f39));
      f111 = Math_fround(f113 + Math_fround(f40 * f112));
      HEAPF32[i92 >> 2] = Math_fround(f113 + Math_fround(f37 * f112));
      HEAPF32[i62 >> 2] = f38;
      HEAPF32[i63 >> 2] = f39;
      HEAPF32[i64 >> 2] = f111;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i92, i57, i93, i94);
      break L96;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i92, i57, i93, i94);
      break L96;
     }
    } while (0);
    f40 = Math_fround(HEAPF32[i92 >> 2]);
    i110 = f40 < Math_fround(0.0);
    f40 = i110 ? Math_fround(0.0) : f40;
    f111 = Math_fround(HEAPF32[i62 >> 2]);
    i110 = f111 < Math_fround(0.0);
    f111 = i110 ? Math_fround(0.0) : f111;
    f112 = Math_fround(HEAPF32[i63 >> 2]);
    i110 = f112 < Math_fround(0.0);
    f112 = i110 ? Math_fround(0.0) : f112;
    f113 = Math_fround(HEAPF32[i64 >> 2]);
    i110 = f113 < Math_fround(0.0);
    f113 = i110 ? Math_fround(0.0) : f113;
    HEAPF32[i102 + (i5 * 120 | 0) + 84 >> 2] = f41;
    HEAPF32[i102 + (i5 * 120 | 0) + 88 >> 2] = f2;
    HEAPF32[i102 + (i5 * 120 | 0) + 92 >> 2] = f40;
    i110 = i5 | 1;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f43;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f4;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f111;
    i110 = i5 | 2;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f42;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f3;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f112;
    i110 = i5 | 3;
    HEAPF32[i102 + (i110 * 120 | 0) + 84 >> 2] = f44;
    HEAPF32[i102 + (i110 * 120 | 0) + 88 >> 2] = f31;
    HEAPF32[i102 + (i110 * 120 | 0) + 92 >> 2] = f113;
   }
   i5 = i5 + 4 | 0;
  } while (i5 >>> 0 < i103 >>> 0);
 }
 i1 = HEAP16[i96 + 126 >> 1] | 0;
 if ((i1 & 255) << 24 >> 24 == 0 & i95) {
  i6 = i97 + 2556 | 0;
  i7 = i97 + 2560 | 0;
  i8 = i97 + 2564 | 0;
  i9 = i97 + 2568 | 0;
  i10 = i97 + 2572 | 0;
  i11 = i97 + 2576 | 0;
  i12 = i97 + 2580 | 0;
  i13 = i97 + 2584 | 0;
  i14 = i97 + 2588 | 0;
  i15 = i97 + 2592 | 0;
  i16 = i97 + 2596 | 0;
  i17 = i97 + 2600 | 0;
  i18 = i97 + 2604 | 0;
  i19 = i97 + 2608 | 0;
  i20 = i97 + 2612 | 0;
  i21 = i97 + 2616 | 0;
  i22 = i98 + 4 | 0;
  i23 = i98 + 8 | 0;
  i24 = i98 + 12 | 0;
  i25 = i97 + 536 | 0;
  i26 = i97 + 676 | 0;
  i27 = i97 + 604 | 0;
  i28 = i99 + 4 | 0;
  i29 = i99 + 8 | 0;
  i30 = i99 + 12 | 0;
  i1 = 0;
  do {
   i104 = HEAP32[i6 >> 2] | 0;
   i105 = HEAP32[i7 >> 2] | 0;
   i106 = HEAP32[i8 >> 2] | 0;
   i107 = HEAP32[i9 >> 2] | 0;
   i104 = i104 << 11 ^ i104;
   i105 = i105 << 11 ^ i105;
   i106 = i106 << 11 ^ i106;
   i107 = i107 << 11 ^ i107;
   i5 = HEAP32[i11 >> 2] | 0;
   i108 = HEAP32[i12 >> 2] | 0;
   i109 = HEAP32[i13 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = i108;
   HEAP32[i9 >> 2] = i109;
   i109 = HEAP32[i15 >> 2] | 0;
   i108 = HEAP32[i16 >> 2] | 0;
   i5 = HEAP32[i17 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 >> 2] = i109;
   HEAP32[i12 >> 2] = i108;
   HEAP32[i13 >> 2] = i5;
   i5 = HEAP32[i18 >> 2] | 0;
   i108 = HEAP32[i19 >> 2] | 0;
   i109 = HEAP32[i20 >> 2] | 0;
   i110 = HEAP32[i21 >> 2] | 0;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i108;
   HEAP32[i16 >> 2] = i109;
   HEAP32[i17 >> 2] = i110;
   i5 = i104 >>> 8 ^ i104 ^ i5 ^ i5 >>> 19;
   i108 = i105 >>> 8 ^ i105 ^ i108 ^ i108 >>> 19;
   i109 = i106 >>> 8 ^ i106 ^ i109 ^ i109 >>> 19;
   i110 = i107 >>> 8 ^ i107 ^ i110 ^ i110 >>> 19;
   HEAP32[i18 >> 2] = i5;
   HEAP32[i19 >> 2] = i108;
   HEAP32[i20 >> 2] = i109;
   HEAP32[i21 >> 2] = i110;
   f111 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f112 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
   f113 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i98 >> 2] = Math_fround(Math_fround(i5 & 8388607 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i22 >> 2] = f111;
   HEAPF32[i23 >> 2] = f112;
   HEAPF32[i24 >> 2] = f113;
   HEAP32[i100 >> 2] = 0;
   HEAP32[i100 + 4 >> 2] = 0;
   HEAP32[i100 + 8 >> 2] = 0;
   HEAP32[i100 + 12 >> 2] = 0;
   i5 = (HEAP32[i27 >> 2] | 0) == 0;
   do if (!(HEAP32[i26 >> 2] | 0)) if (i5) {
    __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i99, i25, i100, i98);
    break;
   } else {
    __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i99, i25, i100, i98);
    break;
   } else if (i5) {
    __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i99, i25, i100, i98);
    break;
   } else {
    __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i99, i25, i100, i98);
    break;
   } while (0);
   HEAP32[i102 + (i1 * 120 | 0) + 96 >> 2] = HEAP32[i99 >> 2];
   HEAP32[i102 + ((i1 | 1) * 120 | 0) + 96 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i102 + ((i1 | 2) * 120 | 0) + 96 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i102 + ((i1 | 3) * 120 | 0) + 96 >> 2] = HEAP32[i30 >> 2];
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i103 >>> 0);
  i1 = HEAP8[i96 + 127 >> 0] | 0;
 } else i1 = (i1 & 65535) >>> 8 & 255;
 if (i1 << 24 >> 24 == 0 & i95) {
  i9 = i97 + 2556 | 0;
  i10 = i97 + 2560 | 0;
  i11 = i97 + 2564 | 0;
  i12 = i97 + 2568 | 0;
  i13 = i97 + 2572 | 0;
  i14 = i97 + 2576 | 0;
  i15 = i97 + 2580 | 0;
  i16 = i97 + 2584 | 0;
  i17 = i97 + 2588 | 0;
  i18 = i97 + 2592 | 0;
  i19 = i97 + 2596 | 0;
  i20 = i97 + 2600 | 0;
  i21 = i97 + 2604 | 0;
  i22 = i97 + 2608 | 0;
  i23 = i97 + 2612 | 0;
  i24 = i97 + 2616 | 0;
  i25 = i98 + 4 | 0;
  i26 = i98 + 8 | 0;
  i27 = i98 + 12 | 0;
  i8 = 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i28 = HEAP32[i13 >> 2] | 0;
  i29 = HEAP32[i14 >> 2] | 0;
  i30 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i16 >> 2] | 0;
  i33 = HEAP32[i17 >> 2] | 0;
  i34 = HEAP32[i18 >> 2] | 0;
  i35 = HEAP32[i19 >> 2] | 0;
  i36 = HEAP32[i20 >> 2] | 0;
  while (1) {
   i107 = i1 << 11 ^ i1;
   i108 = i5 << 11 ^ i5;
   i109 = i6 << 11 ^ i6;
   i110 = i7 << 11 ^ i7;
   i1 = HEAP32[i21 >> 2] | 0;
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = HEAP32[i23 >> 2] | 0;
   i7 = HEAP32[i24 >> 2] | 0;
   HEAP32[i21 >> 2] = i107 >>> 8 ^ i107 ^ i1 ^ i1 >>> 19;
   HEAP32[i22 >> 2] = i108 >>> 8 ^ i108 ^ i5 ^ i5 >>> 19;
   HEAP32[i23 >> 2] = i109 >>> 8 ^ i109 ^ i6 ^ i6 >>> 19;
   HEAP32[i24 >> 2] = i110 >>> 8 ^ i110 ^ i7 ^ i7 >>> 19;
   HEAP32[i98 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i98 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i98 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i98 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i102 + (i8 * 120 | 0) + 100 >> 2] = HEAP32[i98 >> 2];
   HEAP32[i102 + ((i8 | 1) * 120 | 0) + 100 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i102 + ((i8 | 2) * 120 | 0) + 100 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i102 + ((i8 | 3) * 120 | 0) + 100 >> 2] = HEAP32[i27 >> 2];
   i8 = i8 + 4 | 0;
   if (i8 >>> 0 >= i103 >>> 0) break; else {
    i94 = i36;
    i104 = i35;
    i105 = i34;
    i106 = i33;
    i107 = i32;
    i108 = i30;
    i109 = i29;
    i110 = i28;
    i33 = i1;
    i34 = i5;
    i35 = i6;
    i36 = i7;
    i32 = i94;
    i30 = i104;
    i29 = i105;
    i28 = i106;
    i7 = i107;
    i6 = i108;
    i5 = i109;
    i1 = i110;
   }
  }
  HEAP32[i9 >> 2] = i28;
  HEAP32[i10 >> 2] = i29;
  HEAP32[i11 >> 2] = i30;
  HEAP32[i12 >> 2] = i32;
  HEAP32[i13 >> 2] = i33;
  HEAP32[i14 >> 2] = i34;
  HEAP32[i15 >> 2] = i35;
  HEAP32[i16 >> 2] = i36;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i18 >> 2] = i5;
  HEAP32[i19 >> 2] = i6;
  HEAP32[i20 >> 2] = i7;
 }
 if (HEAP8[i96 + 128 >> 0] | 0) {
  if (i95) i1 = 0; else {
   STACKTOP = i101;
   return;
  }
  do {
   HEAP32[i102 + (i1 * 120 | 0) + 104 >> 2] = HEAP32[i102 + (i1 * 120 | 0) + 108 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i103 | 0));
  STACKTOP = i101;
  return;
 }
 if (!i95) {
  STACKTOP = i101;
  return;
 }
 i7 = i97 + 2556 | 0;
 i8 = i97 + 2560 | 0;
 i9 = i97 + 2564 | 0;
 i10 = i97 + 2568 | 0;
 i11 = i97 + 2572 | 0;
 i12 = i97 + 2576 | 0;
 i13 = i97 + 2580 | 0;
 i14 = i97 + 2584 | 0;
 i15 = i97 + 2588 | 0;
 i16 = i97 + 2592 | 0;
 i17 = i97 + 2596 | 0;
 i18 = i97 + 2600 | 0;
 i19 = i97 + 2604 | 0;
 i20 = i97 + 2608 | 0;
 i21 = i97 + 2612 | 0;
 i22 = i97 + 2616 | 0;
 i23 = i98 + 4 | 0;
 i24 = i98 + 8 | 0;
 i25 = i98 + 12 | 0;
 i26 = i97 + 8 | 0;
 i27 = i97 + 92 | 0;
 i28 = i99 + 4 | 0;
 i29 = i99 + 8 | 0;
 i30 = i99 + 12 | 0;
 i32 = i97 + 88 | 0;
 i33 = i97 + 240 | 0;
 i5 = i97 + 152 | 0;
 i1 = 0;
 do {
  i104 = HEAP32[i7 >> 2] | 0;
  i105 = HEAP32[i8 >> 2] | 0;
  i106 = HEAP32[i9 >> 2] | 0;
  i107 = HEAP32[i10 >> 2] | 0;
  i104 = i104 << 11 ^ i104;
  i105 = i105 << 11 ^ i105;
  i106 = i106 << 11 ^ i106;
  i107 = i107 << 11 ^ i107;
  i108 = HEAP32[i12 >> 2] | 0;
  i109 = HEAP32[i13 >> 2] | 0;
  i110 = HEAP32[i14 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 >> 2] = i108;
  HEAP32[i9 >> 2] = i109;
  HEAP32[i10 >> 2] = i110;
  i110 = HEAP32[i16 >> 2] | 0;
  i109 = HEAP32[i17 >> 2] | 0;
  i108 = HEAP32[i18 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i12 >> 2] = i110;
  HEAP32[i13 >> 2] = i109;
  HEAP32[i14 >> 2] = i108;
  i108 = HEAP32[i19 >> 2] | 0;
  i109 = HEAP32[i20 >> 2] | 0;
  i110 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i22 >> 2] | 0;
  HEAP32[i15 >> 2] = i108;
  HEAP32[i16 >> 2] = i109;
  HEAP32[i17 >> 2] = i110;
  HEAP32[i18 >> 2] = i6;
  i108 = i104 >>> 8 ^ i104 ^ i108 ^ i108 >>> 19;
  i109 = i105 >>> 8 ^ i105 ^ i109 ^ i109 >>> 19;
  i110 = i106 >>> 8 ^ i106 ^ i110 ^ i110 >>> 19;
  i6 = i107 >>> 8 ^ i107 ^ i6 ^ i6 >>> 19;
  HEAP32[i19 >> 2] = i108;
  HEAP32[i20 >> 2] = i109;
  HEAP32[i21 >> 2] = i110;
  HEAP32[i22 >> 2] = i6;
  f2 = Math_fround(Math_fround(i108 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f3 = Math_fround(Math_fround(i109 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(Math_fround(i110 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f31 = Math_fround(Math_fround(i6 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i98 >> 2] = f2;
  HEAPF32[i23 >> 2] = f3;
  HEAPF32[i24 >> 2] = f4;
  HEAPF32[i25 >> 2] = f31;
  HEAP32[i100 >> 2] = 0;
  HEAP32[i100 + 4 >> 2] = 0;
  HEAP32[i100 + 8 >> 2] = 0;
  HEAP32[i100 + 12 >> 2] = 0;
  i6 = HEAP32[i27 >> 2] | 0;
  L142 : do switch ((i6 & 65535) << 16 >> 16) {
  case 0:
   {
    i110 = HEAP32[i32 >> 2] | 0;
    HEAP32[i30 >> 2] = i110;
    HEAP32[i29 >> 2] = i110;
    HEAP32[i28 >> 2] = i110;
    HEAP32[i99 >> 2] = i110;
    break;
   }
  case 3:
   {
    f43 = Math_fround(HEAPF32[(HEAP32[i33 >> 2] | 0) + 4 >> 2]);
    f44 = Math_fround(HEAPF32[i32 >> 2]);
    f43 = Math_fround(f43 * f44);
    f44 = Math_fround(Math_fround(f44 * Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + 4 >> 2])) - f43);
    f111 = Math_fround(f43 + Math_fround(f44 * f3));
    f112 = Math_fround(f43 + Math_fround(f44 * f4));
    f113 = Math_fround(f43 + Math_fround(f44 * f31));
    HEAPF32[i99 >> 2] = Math_fround(f43 + Math_fround(f2 * f44));
    HEAPF32[i28 >> 2] = f111;
    HEAPF32[i29 >> 2] = f112;
    HEAPF32[i30 >> 2] = f113;
    break;
   }
  default:
   if (!(i6 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i99, i26, i100, i98);
    break L142;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i99, i26, i100, i98);
    break L142;
   }
  } while (0);
  f113 = Math_fround(HEAPF32[i30 >> 2]);
  i110 = f113 < Math_fround(9.99999974e-06);
  f113 = i110 ? Math_fround(9.99999974e-06) : f113;
  HEAPF32[i102 + (i1 * 120 | 0) + 108 >> 2] = f113;
  HEAPF32[i102 + (i1 * 120 | 0) + 104 >> 2] = f113;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i103 >>> 0);
 STACKTOP = i101;
 return;
}

function __ZN5physx31PxClothGeodesicTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i54, i24) {
 i54 = i54 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i67 + 288 | 0;
 i10 = i67 + 256 | 0;
 i11 = i67 + 240 | 0;
 i14 = i67 + 236 | 0;
 i15 = i67 + 220 | 0;
 i16 = i67 + 200 | 0;
 i17 = i67 + 192 | 0;
 i18 = i67 + 188 | 0;
 i20 = i67 + 168 | 0;
 i2 = i67 + 300 | 0;
 i66 = i67 + 264 | 0;
 i23 = i67 + 260 | 0;
 i65 = i67 + 244 | 0;
 i64 = i67 + 224 | 0;
 i27 = i67 + 216 | 0;
 i63 = i67 + 204 | 0;
 i28 = i67 + 196 | 0;
 i62 = i67 + 176 | 0;
 i29 = i67 + 172 | 0;
 i61 = i67 + 156 | 0;
 i30 = i67 + 144 | 0;
 i60 = i67 + 132 | 0;
 i59 = i67 + 120 | 0;
 i41 = i67 + 116 | 0;
 i37 = i67 + 112 | 0;
 i38 = i67 + 108 | 0;
 i40 = i67 + 104 | 0;
 i39 = i67 + 92 | 0;
 i58 = i67 + 80 | 0;
 i42 = i67 + 76 | 0;
 i57 = i67 + 64 | 0;
 i43 = i67 + 60 | 0;
 i56 = i67 + 48 | 0;
 i46 = i67 + 36 | 0;
 i47 = i67 + 24 | 0;
 i48 = i67 + 20 | 0;
 i49 = i67 + 16 | 0;
 i50 = i67 + 4 | 0;
 i53 = i67;
 i1 = HEAP32[i24 + 8 >> 2] | 0;
 i51 = i54 + 4 | 0;
 HEAP32[i51 >> 2] = i1;
 i3 = i24 + 16 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i67;
  return;
 }
 i52 = i54 + 8 | 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i52, i1, i67 + 276 | 0);
 i36 = i54 + 32 | 0;
 i4 = HEAP32[i51 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE6resizeEjRKh(i36, i4, i2);
 i4 = HEAP32[i24 >> 2] | 0;
 i5 = HEAP32[i24 + 12 >> 2] | 0;
 if (HEAP32[i51 >> 2] | 0) {
  i7 = HEAP32[i24 + 4 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = 0;
  while (1) {
   i45 = HEAP32[i52 >> 2] | 0;
   i44 = i7;
   HEAP32[i45 + (i3 * 12 | 0) >> 2] = HEAP32[i7 >> 2];
   HEAP32[i45 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i45 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   if (!i1) {
    i2 = 0;
    i1 = 0;
   } else {
    i2 = i1 + i5 | 0;
    i1 = Math_fround(HEAPF32[i1 >> 2]) == Math_fround(0.0) & 1;
   }
   HEAP8[(HEAP32[i36 >> 2] | 0) + i3 >> 0] = i1;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= (HEAP32[i51 >> 2] | 0) >>> 0) break; else {
    i7 = i7 + i4 | 0;
    i1 = i2;
   }
  }
 }
 i22 = i24 + 48 | 0;
 i21 = i54 + 20 | 0;
 i25 = i24 + 24 | 0;
 i26 = i24 + 36 | 0;
 if (!(HEAP16[i22 >> 1] & 2)) {
  i9 = i24 + 32 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i10 = i24 + 44 | 0;
  i2 = ((HEAP32[i10 >> 2] | 0) * 6 | 0) + (i1 * 3 | 0) | 0;
  i11 = i54 + 28 | 0;
  if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i21, i2);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i8 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) {
   i4 = i54 + 24 | 0;
   i5 = HEAP32[i24 + 28 >> 2] | 0;
   i7 = 0;
   while (1) {
    i3 = i5;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
     i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i3) | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    i1 = i3 + 4 | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i1) | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    i1 = i3 + 8 | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i1) | 0;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break; else i5 = i5 + i8 | 0;
   }
  }
  i4 = HEAP32[i26 >> 2] | 0;
  if (HEAP32[i10 >> 2] | 0) {
   i5 = i54 + 24 | 0;
   i7 = HEAP32[i24 + 40 >> 2] | 0;
   i8 = 0;
   while (1) {
    i3 = i7;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
     i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i3) | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    i1 = i3 + 4 | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i1;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i1) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    i2 = i3 + 8 | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
     i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i1;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i2) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
     i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i1;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i3) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
     i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i2) | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    i1 = i3 + 12 | 0;
    if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i1) | 0;
    i8 = i8 + 1 | 0;
    if (i8 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break; else i7 = i7 + i4 | 0;
   }
  }
 } else {
  i9 = i24 + 32 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i12 = i24 + 44 | 0;
  i2 = ((HEAP32[i12 >> 2] | 0) * 6 | 0) + (i1 * 3 | 0) | 0;
  i13 = i54 + 28 | 0;
  if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i21, i2);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i8 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) {
   i4 = i54 + 24 | 0;
   i5 = HEAP32[i24 + 28 >> 2] | 0;
   i7 = 0;
   while (1) {
    i3 = i5;
    i1 = HEAPU16[i3 >> 1] | 0;
    HEAP32[i55 >> 2] = i1;
    i2 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i55) | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    i1 = HEAPU16[i3 + 2 >> 1] | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i10) | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    i1 = HEAPU16[i3 + 4 >> 1] | 0;
    HEAP32[i11 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i11) | 0;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break; else i5 = i5 + i8 | 0;
   }
  }
  i5 = HEAP32[i26 >> 2] | 0;
  if (HEAP32[i12 >> 2] | 0) {
   i7 = i54 + 24 | 0;
   i8 = HEAP32[i24 + 40 >> 2] | 0;
   i9 = 0;
   while (1) {
    i4 = i8;
    i1 = HEAPU16[i4 >> 1] | 0;
    HEAP32[i14 >> 2] = i1;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i14) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = HEAPU16[i4 + 2 >> 1] | 0;
    HEAP32[i15 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i15) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i3 = i4 + 4 | 0;
    i1 = HEAPU16[i3 >> 1] | 0;
    HEAP32[i16 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i16) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = HEAPU16[i4 >> 1] | 0;
    HEAP32[i17 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i17) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = HEAPU16[i3 >> 1] | 0;
    HEAP32[i18 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i18) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = HEAPU16[i4 + 6 >> 1] | 0;
    HEAP32[i20 >> 2] = i1;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i21, i20) | 0;
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) break; else i8 = i8 + i5 | 0;
   }
  }
 }
 __ZN5physx31PxClothGeodesicTetherCookerImpl20findVertTriNeighborsEv(i54);
 i45 = __ZN5physx31PxClothGeodesicTetherCookerImpl16findTriNeighborsEv(i54) | 0;
 HEAP32[i54 + 80 >> 2] = i45;
 if (i45 | 0) {
  STACKTOP = i67;
  return;
 }
 i12 = (HEAP32[i51 >> 2] | 0) + 1 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i66 >> 2] = 0;
 i13 = i66 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i45 = i66 + 8 | 0;
 HEAP32[i45 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i66, i12, i23);
 HEAP32[i65 >> 2] = 0;
 i12 = i65 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i44 = i65 + 8 | 0;
 HEAP32[i44 >> 2] = 0;
 if (!(HEAP16[i22 >> 1] & 2)) {
  i8 = i24 + 28 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i11 = i24 + 32 | 0;
  if (HEAP32[i11 >> 2] | 0) {
   i2 = HEAP32[i66 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = 0;
   while (1) {
    i35 = i3;
    i34 = i2 + (HEAP32[i35 >> 2] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i2 + (HEAP32[i35 + 4 >> 2] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i35 = i2 + (HEAP32[i35 + 8 >> 2] << 2) | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 2;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else i3 = i3 + i1 | 0;
   }
  }
  i9 = i24 + 40 | 0;
  i4 = HEAP32[i26 >> 2] | 0;
  i10 = i24 + 44 | 0;
  if (!(HEAP32[i10 >> 2] | 0)) i7 = HEAP32[i66 >> 2] | 0; else {
   i1 = HEAP32[i66 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = 0;
   while (1) {
    i35 = i2;
    i34 = i1 + (HEAP32[i35 >> 2] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i1 + (HEAP32[i35 + 4 >> 2] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i1 + (HEAP32[i35 + 8 >> 2] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i35 = i1 + (HEAP32[i35 + 12 >> 2] << 2) | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
     i7 = i1;
     break;
    } else i2 = i2 + i4 | 0;
   }
  }
  i1 = HEAP32[i13 >> 2] | 0;
  i4 = i7 + (i1 << 2) | 0;
  if (!i1) {
   i5 = 0;
   i1 = -1;
  } else if ((i1 | 0) == 1) {
   i5 = 1;
   i1 = 0;
  } else {
   i1 = i7 + 4 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i7;
   do {
    i3 = i3 + 4 | 0;
    i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
    HEAP32[i3 >> 2] = i2;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i4 | 0));
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = i1;
   i1 = i1 + -1 | 0;
  }
  i3 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  HEAP32[i55 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i65, i3, i55);
  i3 = HEAP32[i25 >> 2] | 0;
  if (HEAP32[i11 >> 2] | 0) {
   i4 = HEAP32[i65 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = 0;
   while (1) {
    i32 = i1;
    i34 = i32 + 4 | 0;
    i31 = HEAP32[i34 >> 2] | 0;
    i35 = i7 + (HEAP32[i32 >> 2] << 2) | 0;
    i33 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i33;
    HEAP32[i4 + (i33 << 2) >> 2] = i31;
    i33 = i32 + 8 | 0;
    i31 = HEAP32[i33 >> 2] | 0;
    i35 = i7 + (HEAP32[i32 >> 2] << 2) | 0;
    i25 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i25;
    HEAP32[i4 + (i25 << 2) >> 2] = i31;
    i25 = HEAP32[i33 >> 2] | 0;
    i31 = i7 + (HEAP32[i34 >> 2] << 2) | 0;
    i35 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i25;
    i35 = HEAP32[i32 >> 2] | 0;
    i25 = i7 + (HEAP32[i34 >> 2] << 2) | 0;
    i31 = (HEAP32[i25 >> 2] | 0) + -1 | 0;
    HEAP32[i25 >> 2] = i31;
    HEAP32[i4 + (i31 << 2) >> 2] = i35;
    i32 = HEAP32[i32 >> 2] | 0;
    i31 = i7 + (HEAP32[i33 >> 2] << 2) | 0;
    i35 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i32;
    i34 = HEAP32[i34 >> 2] | 0;
    i33 = i7 + (HEAP32[i33 >> 2] << 2) | 0;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i34;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else i1 = i1 + i3 | 0;
   }
  }
  i3 = HEAP32[i26 >> 2] | 0;
  if (HEAP32[i10 >> 2] | 0) {
   i4 = HEAP32[i65 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = 0;
   while (1) {
    i32 = i1;
    i35 = i32 + 4 | 0;
    i26 = HEAP32[i35 >> 2] | 0;
    i31 = i7 + (HEAP32[i32 >> 2] << 2) | 0;
    i33 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i33;
    HEAP32[i4 + (i33 << 2) >> 2] = i26;
    i33 = i32 + 12 | 0;
    i26 = HEAP32[i33 >> 2] | 0;
    i31 = i7 + (HEAP32[i32 >> 2] << 2) | 0;
    i34 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i34;
    HEAP32[i4 + (i34 << 2) >> 2] = i26;
    i34 = i32 + 8 | 0;
    i26 = HEAP32[i34 >> 2] | 0;
    i31 = i7 + (HEAP32[i35 >> 2] << 2) | 0;
    i25 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i25;
    HEAP32[i4 + (i25 << 2) >> 2] = i26;
    i25 = HEAP32[i32 >> 2] | 0;
    i26 = i7 + (HEAP32[i35 >> 2] << 2) | 0;
    i31 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i31;
    HEAP32[i4 + (i31 << 2) >> 2] = i25;
    i31 = HEAP32[i33 >> 2] | 0;
    i25 = i7 + (HEAP32[i34 >> 2] << 2) | 0;
    i26 = (HEAP32[i25 >> 2] | 0) + -1 | 0;
    HEAP32[i25 >> 2] = i26;
    HEAP32[i4 + (i26 << 2) >> 2] = i31;
    i35 = HEAP32[i35 >> 2] | 0;
    i26 = i7 + (HEAP32[i34 >> 2] << 2) | 0;
    i31 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i31;
    HEAP32[i4 + (i31 << 2) >> 2] = i35;
    i32 = HEAP32[i32 >> 2] | 0;
    i31 = i7 + (HEAP32[i33 >> 2] << 2) | 0;
    i35 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i32;
    i34 = HEAP32[i34 >> 2] | 0;
    i33 = i7 + (HEAP32[i33 >> 2] << 2) | 0;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i34;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break; else i1 = i1 + i3 | 0;
   }
  }
  i2 = i5;
  i20 = i7;
 } else {
  i8 = i24 + 28 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i11 = i24 + 32 | 0;
  if (HEAP32[i11 >> 2] | 0) {
   i2 = HEAP32[i66 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = 0;
   while (1) {
    i35 = i3;
    i34 = i2 + (HEAPU16[i35 >> 1] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i2 + (HEAPU16[i35 + 2 >> 1] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i35 = i2 + (HEAPU16[i35 + 4 >> 1] << 2) | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 2;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else i3 = i3 + i1 | 0;
   }
  }
  i9 = i24 + 40 | 0;
  i4 = HEAP32[i26 >> 2] | 0;
  i10 = i24 + 44 | 0;
  if (!(HEAP32[i10 >> 2] | 0)) i7 = HEAP32[i66 >> 2] | 0; else {
   i1 = HEAP32[i66 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = 0;
   while (1) {
    i35 = i2;
    i34 = i1 + (HEAPU16[i35 >> 1] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i1 + (HEAPU16[i35 + 2 >> 1] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i34 = i1 + (HEAPU16[i35 + 4 >> 1] << 2) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 2;
    i35 = i1 + (HEAPU16[i35 + 6 >> 1] << 2) | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
     i7 = i1;
     break;
    } else i2 = i2 + i4 | 0;
   }
  }
  i1 = HEAP32[i13 >> 2] | 0;
  i4 = i7 + (i1 << 2) | 0;
  if (!i1) {
   i5 = 0;
   i1 = -1;
  } else if ((i1 | 0) == 1) {
   i5 = 1;
   i1 = 0;
  } else {
   i1 = i7 + 4 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i7;
   do {
    i3 = i3 + 4 | 0;
    i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
    HEAP32[i3 >> 2] = i2;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i4 | 0));
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = i1;
   i1 = i1 + -1 | 0;
  }
  i3 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  HEAP32[i55 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i65, i3, i55);
  i3 = HEAP32[i25 >> 2] | 0;
  if (HEAP32[i11 >> 2] | 0) {
   i4 = HEAP32[i65 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = 0;
   while (1) {
    i33 = i1;
    i34 = HEAPU16[i33 + 2 >> 1] | 0;
    i32 = HEAPU16[i33 >> 1] | 0;
    i35 = i7 + (i32 << 2) | 0;
    i31 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i31;
    HEAP32[i4 + (i31 << 2) >> 2] = i34;
    i33 = HEAPU16[i33 + 4 >> 1] | 0;
    i31 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i31;
    HEAP32[i4 + (i31 << 2) >> 2] = i33;
    i31 = i7 + (i34 << 2) | 0;
    i35 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i33;
    i35 = (HEAP32[i31 >> 2] | 0) + -1 | 0;
    HEAP32[i31 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i32;
    i33 = i7 + (i33 << 2) | 0;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i32;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i34;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else i1 = i1 + i3 | 0;
   }
  }
  i3 = HEAP32[i26 >> 2] | 0;
  if (HEAP32[i10 >> 2] | 0) {
   i4 = HEAP32[i65 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = 0;
   while (1) {
    i34 = i1;
    i31 = HEAPU16[i34 + 2 >> 1] | 0;
    i32 = HEAPU16[i34 >> 1] | 0;
    i26 = i7 + (i32 << 2) | 0;
    i33 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i33;
    HEAP32[i4 + (i33 << 2) >> 2] = i31;
    i33 = HEAPU16[i34 + 6 >> 1] | 0;
    i35 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i33;
    i34 = HEAPU16[i34 + 4 >> 1] | 0;
    i35 = i7 + (i31 << 2) | 0;
    i26 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i26;
    HEAP32[i4 + (i26 << 2) >> 2] = i34;
    i26 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
    HEAP32[i35 >> 2] = i26;
    HEAP32[i4 + (i26 << 2) >> 2] = i32;
    i26 = i7 + (i34 << 2) | 0;
    i35 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i33;
    i35 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
    HEAP32[i26 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i31;
    i33 = i7 + (i33 << 2) | 0;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i32;
    i35 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i4 + (i35 << 2) >> 2] = i34;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break; else i1 = i1 + i3 | 0;
   }
  }
  i2 = i5;
  i20 = i7;
 }
 HEAP32[i27 >> 2] = 0;
 HEAP32[i64 >> 2] = 0;
 HEAP32[i64 + 4 >> 2] = 0;
 i35 = i64 + 8 | 0;
 HEAP32[i35 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i64, i2, i27);
 HEAP32[i63 >> 2] = 0;
 i9 = i63 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i34 = i63 + 8 | 0;
 HEAP32[i34 >> 2] = 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i63, i1);
 if (i2 >>> 0 > 1) {
  i4 = HEAP32[i65 >> 2] | 0;
  i5 = HEAP32[i64 >> 2] | 0;
  i8 = 1;
  i1 = 0;
  do {
   i7 = i20 + (i8 << 2) | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) do {
    i3 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    HEAP32[i28 >> 2] = i3;
    i2 = i5 + (i3 << 2) | 0;
    do if ((HEAP32[i2 >> 2] | 0) != (i8 | 0)) {
     HEAP32[i2 >> 2] = i8;
     i2 = HEAP32[i9 >> 2] | 0;
     if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i63 >> 2] | 0) + (i2 << 2) >> 2] = i3;
      HEAP32[i9 >> 2] = i2 + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i63, i28) | 0;
      break;
     }
    } while (0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 i18 = HEAP32[i51 >> 2] | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i62 >> 2] = 0;
 HEAP32[i62 + 4 >> 2] = 0;
 i33 = i62 + 8 | 0;
 HEAP32[i33 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i62, i18, i29);
 HEAP32[i61 >> 2] = 0;
 i18 = i61 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 i32 = i61 + 8 | 0;
 HEAP32[i32 >> 2] = 0;
 if (HEAP32[i51 >> 2] | 0) {
  i1 = HEAP32[i62 >> 2] | 0;
  i2 = i30 + 4 | 0;
  i3 = i30 + 8 | 0;
  i5 = 0;
  do {
   HEAP32[i1 + (i5 << 2) >> 2] = -1;
   do if (HEAP8[(HEAP32[i36 >> 2] | 0) + i5 >> 0] | 0) {
    HEAP32[i30 >> 2] = i5;
    HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAP32[i3 >> 2] = 0;
    i4 = HEAP32[i18 >> 2] | 0;
    if ((HEAP32[i32 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     i31 = (HEAP32[i61 >> 2] | 0) + (i4 * 12 | 0) | 0;
     HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
     HEAP32[i18 >> 2] = i4 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i61, i30) | 0;
     break;
    }
   } while (0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0);
  i2 = HEAP32[i18 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i60 >> 2] = 0;
   i16 = i60 + 4 | 0;
   HEAP32[i16 >> 2] = 0;
   i31 = i60 + 8 | 0;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i59 >> 2] = 0;
   i17 = i59 + 4 | 0;
   HEAP32[i17 >> 2] = 0;
   i30 = i59 + 8 | 0;
   HEAP32[i30 >> 2] = 0;
   HEAP32[i41 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i60, i2);
   i1 = i2 + 1 | 0;
   if (i1 | 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i59, i1);
   i12 = HEAP32[i62 >> 2] | 0;
   i13 = HEAP32[i63 >> 2] | 0;
   i14 = i39 + 4 | 0;
   i15 = i39 + 8 | 0;
   i9 = 0;
   i3 = HEAP32[i61 >> 2] | 0;
   i7 = 0;
   while (1) {
    i2 = i2 + -1 | 0;
    i29 = i3 + (i2 * 12 | 0) | 0;
    HEAP32[i55 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i55 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i55 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
    HEAP32[i29 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    L210 : do if ((i2 | 0) > 1) {
     i4 = 1;
     i5 = 0;
     while (1) {
      i1 = i4 + 1 | 0;
      if ((i1 | 0) < (i2 | 0)) {
       f19 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 4 >> 2]);
       i29 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]) < f19;
       i1 = i29 ? i1 : i4;
      } else i1 = i4;
      f19 = Math_fround(HEAPF32[i3 + (i5 * 12 | 0) + 4 >> 2]);
      if (!(Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]) < f19)) break L210;
      i4 = i3 + (i1 * 12 | 0) | 0;
      i29 = i3 + (i5 * 12 | 0) | 0;
      HEAP32[i55 >> 2] = HEAP32[i29 >> 2];
      HEAP32[i55 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
      HEAP32[i55 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
      HEAP32[i29 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i29 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i29 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i55 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
      i4 = i1 << 1 | 1;
      if ((i4 | 0) >= (i2 | 0)) break; else i5 = i1;
     }
    } while (0);
    i1 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
    i8 = HEAP32[i61 >> 2] | 0;
    i5 = HEAP32[i8 + (i1 * 12 | 0) >> 2] | 0;
    f6 = Math_fround(HEAPF32[i8 + (i1 * 12 | 0) + 4 >> 2]);
    HEAP32[i18 >> 2] = i1;
    i10 = i12 + (i5 << 2) | 0;
    do if ((HEAP32[i10 >> 2] | 0) == -1) {
     i2 = i9 + 1 | 0;
     HEAP32[i41 >> 2] = i2;
     HEAP32[i37 >> 2] = i9;
     i3 = HEAP32[i17 >> 2] | 0;
     if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      HEAP32[(HEAP32[i59 >> 2] | 0) + (i3 << 2) >> 2] = i9;
      HEAP32[i17 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i59, i37) | 0;
     i4 = i7 + 1 | 0;
     HEAP32[i10 >> 2] = i7;
     HEAP32[i38 >> 2] = i5;
     i3 = HEAP32[i16 >> 2] | 0;
     if ((HEAP32[i31 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      HEAP32[(HEAP32[i60 >> 2] | 0) + (i3 << 2) >> 2] = i5;
      HEAP32[i16 >> 2] = i3 + 1;
      f6 = Math_fround(0.0);
      i11 = i4;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i60, i38) | 0;
      f6 = Math_fround(0.0);
      i11 = i4;
      break;
     }
    } else {
     i2 = i9;
     i11 = i7;
    } while (0);
    i4 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
    i9 = HEAP32[i20 + (i5 + 1 << 2) >> 2] | 0;
    if (i4 >>> 0 < i9 >>> 0) {
     f6 = Math_fround(f6 + Math_fround(1.0));
     i3 = i8;
     i8 = i4;
     do {
      i5 = HEAP32[i13 + (i8 << 2) >> 2] | 0;
      HEAP32[i40 >> 2] = i5;
      L232 : do if (HEAP8[(HEAP32[i36 >> 2] | 0) + i5 >> 0] | 0) {
       i7 = i12 + (i5 << 2) | 0;
       if ((HEAP32[i7 >> 2] | 0) == -1) {
        i4 = HEAP32[i16 >> 2] | 0;
        if ((HEAP32[i31 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
         HEAP32[(HEAP32[i60 >> 2] | 0) + (i4 << 2) >> 2] = i5;
         HEAP32[i16 >> 2] = i4 + 1;
        } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i60, i40) | 0;
        i2 = i2 + 1 | 0;
        HEAP32[i41 >> 2] = i2;
        HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
        HEAP32[i39 >> 2] = i5;
        HEAPF32[i14 >> 2] = f6;
        HEAP32[i15 >> 2] = 0;
        if ((HEAP32[i32 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
         i1 = i3 + (i1 * 12 | 0) | 0;
         HEAP32[i1 >> 2] = HEAP32[i39 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
         i1 = (HEAP32[i18 >> 2] | 0) + 1 | 0;
         HEAP32[i18 >> 2] = i1;
        } else {
         __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i61, i39) | 0;
         i1 = HEAP32[i18 >> 2] | 0;
        }
        i3 = HEAP32[i61 >> 2] | 0;
        if ((i1 | 0) <= 0) break;
        i4 = ((i1 * 12 | 0) / 12 | 0) + -1 | 0;
        if (!i4) break;
        do {
         i5 = i4;
         i4 = (i4 + -1 | 0) >>> 1;
         f19 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 4 >> 2]);
         if (!(Math_fround(HEAPF32[i3 + (i5 * 12 | 0) + 4 >> 2]) < f19)) break L232;
         i29 = i3 + (i5 * 12 | 0) | 0;
         i28 = i3 + (i4 * 12 | 0) | 0;
         HEAP32[i55 >> 2] = HEAP32[i28 >> 2];
         HEAP32[i55 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
         HEAP32[i55 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
         HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
         HEAP32[i28 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
         HEAP32[i28 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
         HEAP32[i29 >> 2] = HEAP32[i55 >> 2];
         HEAP32[i29 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
         HEAP32[i29 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
        } while ((i4 | 0) != 0);
       }
      } while (0);
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i9 | 0));
    } else i3 = i8;
    if (!i1) {
     i29 = i11;
     break;
    } else {
     i9 = i2;
     i2 = i1;
     i7 = i11;
    }
   }
   i1 = HEAP32[i17 >> 2] | 0;
   if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[(HEAP32[i59 >> 2] | 0) + (i1 << 2) >> 2] = i2;
    HEAP32[i17 >> 2] = i1 + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i59, i41) | 0;
   i24 = Math_imul(HEAP32[i51 >> 2] | 0, i29) | 0;
   HEAPF32[i42 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAP32[i58 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   i28 = i58 + 8 | 0;
   HEAP32[i28 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i58, i24, i42);
   HEAP32[i43 >> 2] = 0;
   HEAP32[i57 >> 2] = 0;
   HEAP32[i57 + 4 >> 2] = 0;
   i27 = i57 + 8 | 0;
   HEAP32[i27 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i57, i24, i43);
   HEAP32[i56 >> 2] = 0;
   i24 = i56 + 4 | 0;
   HEAP32[i24 >> 2] = 0;
   i25 = i56 + 8 | 0;
   HEAP32[i25 >> 2] = 0;
   i26 = (i29 | 0) == 0;
   if (!i26) {
    i11 = HEAP32[i58 >> 2] | 0;
    i12 = HEAP32[i57 >> 2] | 0;
    i13 = HEAP32[i59 >> 2] | 0;
    i14 = HEAP32[i66 >> 2] | 0;
    i15 = HEAP32[i63 >> 2] | 0;
    i16 = i47 + 4 | 0;
    i17 = i47 + 8 | 0;
    i18 = HEAP32[i60 >> 2] | 0;
    i20 = i46 + 4 | 0;
    i21 = i46 + 8 | 0;
    i23 = 0;
    do {
     HEAP32[i24 >> 2] = 0;
     i43 = HEAP32[i51 >> 2] | 0;
     i22 = Math_imul(i43, i23) | 0;
     if (i43 | 0) {
      i1 = 0;
      do {
       i43 = i1 + i22 | 0;
       HEAP32[i12 + (i43 << 2) >> 2] = i1;
       HEAPF32[i11 + (i43 << 2) >> 2] = Math_fround(3402823469999999843913219.0e14);
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0);
     }
     i2 = HEAP32[i13 + (i23 << 2) >> 2] | 0;
     i23 = i23 + 1 | 0;
     i3 = HEAP32[i13 + (i23 << 2) >> 2] | 0;
     if (i2 >>> 0 < i3 >>> 0) {
      i1 = 0;
      do {
       i43 = HEAP32[i18 + (i2 << 2) >> 2] | 0;
       HEAPF32[i11 + (i43 + i22 << 2) >> 2] = Math_fround(0.0);
       HEAP32[i46 >> 2] = i43;
       HEAPF32[i20 >> 2] = Math_fround(0.0);
       HEAP32[i21 >> 2] = 0;
       if ((HEAP32[i25 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        i43 = (HEAP32[i56 >> 2] | 0) + (i1 * 12 | 0) | 0;
        HEAP32[i43 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i43 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
        HEAP32[i43 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
        HEAP32[i24 >> 2] = i1 + 1;
       } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i56, i46) | 0;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i24 >> 2] | 0;
      } while ((i2 | 0) != (i3 | 0));
      if (i1 | 0) {
       i2 = HEAP32[i56 >> 2] | 0;
       do {
        i3 = i1 + -1 | 0;
        i43 = i2 + (i3 * 12 | 0) | 0;
        HEAP32[i55 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i55 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i55 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP32[i2 >> 2] = HEAP32[i43 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
        HEAP32[i43 >> 2] = HEAP32[i55 >> 2];
        HEAP32[i43 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
        HEAP32[i43 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
        L273 : do if ((i3 | 0) > 1) {
         i4 = 1;
         i5 = 0;
         while (1) {
          i1 = i4 + 1 | 0;
          if ((i1 | 0) < (i3 | 0)) {
           f19 = Math_fround(HEAPF32[i2 + (i4 * 12 | 0) + 4 >> 2]);
           i43 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]) < f19;
           i1 = i43 ? i1 : i4;
          } else i1 = i4;
          f19 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
          if (!(Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]) < f19)) break L273;
          i4 = i2 + (i1 * 12 | 0) | 0;
          i43 = i2 + (i5 * 12 | 0) | 0;
          HEAP32[i55 >> 2] = HEAP32[i43 >> 2];
          HEAP32[i55 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
          HEAP32[i55 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
          HEAP32[i43 >> 2] = HEAP32[i4 >> 2];
          HEAP32[i43 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
          HEAP32[i43 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
          HEAP32[i4 >> 2] = HEAP32[i55 >> 2];
          HEAP32[i4 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
          HEAP32[i4 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
          i4 = i1 << 1 | 1;
          if ((i4 | 0) >= (i3 | 0)) break; else i5 = i1;
         }
        } while (0);
        i1 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
        i2 = HEAP32[i56 >> 2] | 0;
        i9 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
        f19 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]);
        HEAP32[i24 >> 2] = i1;
        i3 = i9 + i22 | 0;
        do if (!(f19 > Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]))) {
         i4 = HEAP32[i14 + (i9 << 2) >> 2] | 0;
         i10 = HEAP32[i14 + (i9 + 1 << 2) >> 2] | 0;
         if ((i4 | 0) >= (i10 | 0)) break;
         i8 = i12 + (i3 << 2) | 0;
         i7 = i4;
         do {
          i4 = HEAP32[i15 + (i7 << 2) >> 2] | 0;
          i3 = HEAP32[i52 >> 2] | 0;
          f69 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) >> 2]);
          f69 = Math_fround(f69 - Math_fround(HEAPF32[i3 + (i9 * 12 | 0) >> 2]));
          f68 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 4 >> 2]);
          f68 = Math_fround(f68 - Math_fround(HEAPF32[i3 + (i9 * 12 | 0) + 4 >> 2]));
          f6 = Math_fround(HEAPF32[i3 + (i4 * 12 | 0) + 8 >> 2]);
          f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + (i9 * 12 | 0) + 8 >> 2]));
          f6 = Math_fround(f19 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f69 * f69) + Math_fround(f68 * f68)) + Math_fround(f6 * f6)))));
          i3 = i4 + i22 | 0;
          i5 = i11 + (i3 << 2) | 0;
          L286 : do if (f6 < Math_fround(HEAPF32[i5 >> 2])) {
           HEAPF32[i5 >> 2] = f6;
           HEAP32[i12 + (i3 << 2) >> 2] = HEAP32[i8 >> 2];
           HEAP32[i47 >> 2] = i4;
           HEAPF32[i16 >> 2] = f6;
           HEAP32[i17 >> 2] = 0;
           if ((HEAP32[i25 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
            i1 = i2 + (i1 * 12 | 0) | 0;
            HEAP32[i1 >> 2] = HEAP32[i47 >> 2];
            HEAP32[i1 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
            HEAP32[i1 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
            i1 = (HEAP32[i24 >> 2] | 0) + 1 | 0;
            HEAP32[i24 >> 2] = i1;
           } else {
            __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i56, i47) | 0;
            i1 = HEAP32[i24 >> 2] | 0;
           }
           i2 = HEAP32[i56 >> 2] | 0;
           if ((i1 | 0) <= 0) break;
           i3 = ((i1 * 12 | 0) / 12 | 0) + -1 | 0;
           if (!i3) break;
           do {
            i4 = i3;
            i3 = (i3 + -1 | 0) >>> 1;
            f69 = Math_fround(HEAPF32[i2 + (i3 * 12 | 0) + 4 >> 2]);
            if (!(Math_fround(HEAPF32[i2 + (i4 * 12 | 0) + 4 >> 2]) < f69)) break L286;
            i43 = i2 + (i4 * 12 | 0) | 0;
            i42 = i2 + (i3 * 12 | 0) | 0;
            HEAP32[i55 >> 2] = HEAP32[i42 >> 2];
            HEAP32[i55 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
            HEAP32[i55 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
            HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
            HEAP32[i42 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
            HEAP32[i42 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
            HEAP32[i43 >> 2] = HEAP32[i55 >> 2];
            HEAP32[i43 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
            HEAP32[i43 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
           } while ((i3 | 0) != 0);
          } while (0);
          i7 = i7 + 1 | 0;
         } while ((i7 | 0) != (i10 | 0));
        } while (0);
       } while ((i1 | 0) != 0);
      }
     }
    } while ((i23 | 0) != (i29 | 0));
   }
   i1 = i29 >>> 0 > 4 ? 4 : i29;
   i2 = Math_imul(HEAP32[i51 >> 2] | 0, i1) | 0;
   i18 = i54 + 84 | 0;
   HEAP32[i48 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i18, i2, i48);
   i17 = i54 + 96 | 0;
   HEAPF32[i49 >> 2] = Math_fround(0.0);
   __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i17, i2, i49);
   i2 = HEAP32[i51 >> 2] | 0;
   if (i2 | 0) {
    i10 = (i1 | 0) == 0;
    i11 = HEAP32[i57 >> 2] | 0;
    i12 = HEAP32[i58 >> 2] | 0;
    i13 = i50 + 4 | 0;
    i14 = i50 + 8 | 0;
    i16 = (i29 ^ -4) >>> 0 > 4294967291 ? ~i29 : -5;
    i15 = i16 + 1 | 0;
    i16 = ~i16;
    i9 = 0;
    do {
     HEAP32[i24 >> 2] = 0;
     L304 : do if (i26) i1 = 0; else {
      i1 = 0;
      i3 = 0;
      while (1) {
       i48 = (Math_imul(i2, i3) | 0) + i9 | 0;
       i49 = HEAP32[i12 + (i48 << 2) >> 2] | 0;
       HEAP32[i50 >> 2] = HEAP32[i11 + (i48 << 2) >> 2];
       HEAP32[i13 >> 2] = i49;
       HEAP32[i14 >> 2] = 0;
       if ((HEAP32[i25 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        i5 = HEAP32[i56 >> 2] | 0;
        i49 = i5 + (i1 * 12 | 0) | 0;
        HEAP32[i49 >> 2] = HEAP32[i50 >> 2];
        HEAP32[i49 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
        HEAP32[i49 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
        i1 = i1 + 1 | 0;
        HEAP32[i24 >> 2] = i1;
       } else {
        __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i56, i50) | 0;
        i5 = HEAP32[i56 >> 2] | 0;
        i1 = HEAP32[i24 >> 2] | 0;
       }
       L311 : do if ((i1 | 0) > 0) {
        i2 = ((i1 * 12 | 0) / 12 | 0) + -1 | 0;
        if (!i2) break;
        do {
         i4 = i2;
         i2 = (i2 + -1 | 0) >>> 1;
         f69 = Math_fround(HEAPF32[i5 + (i2 * 12 | 0) + 4 >> 2]);
         if (!(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 4 >> 2]) < f69)) break L311;
         i49 = i5 + (i4 * 12 | 0) | 0;
         i48 = i5 + (i2 * 12 | 0) | 0;
         HEAP32[i55 >> 2] = HEAP32[i48 >> 2];
         HEAP32[i55 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
         HEAP32[i55 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
         HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
         HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
         HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
         HEAP32[i49 >> 2] = HEAP32[i55 >> 2];
         HEAP32[i49 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
         HEAP32[i49 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
        } while ((i2 | 0) != 0);
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i29 | 0)) break L304;
       i2 = HEAP32[i51 >> 2] | 0;
      }
     } while (0);
     if (!i10) {
      i7 = HEAP32[i56 >> 2] | 0;
      i5 = i1;
      i8 = 0;
      do {
       i5 = i5 + -1 | 0;
       i49 = i7 + (i5 * 12 | 0) | 0;
       HEAP32[i55 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i55 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i55 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i49 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i55 >> 2];
       HEAP32[i49 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
       HEAP32[i49 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
       L323 : do if ((i5 | 0) > 1) {
        i3 = 1;
        i4 = 0;
        while (1) {
         i2 = i3 + 1 | 0;
         if ((i2 | 0) < (i5 | 0)) {
          f69 = Math_fround(HEAPF32[i7 + (i3 * 12 | 0) + 4 >> 2]);
          i49 = Math_fround(HEAPF32[i7 + (i2 * 12 | 0) + 4 >> 2]) < f69;
          i2 = i49 ? i2 : i3;
         } else i2 = i3;
         f69 = Math_fround(HEAPF32[i7 + (i4 * 12 | 0) + 4 >> 2]);
         if (!(Math_fround(HEAPF32[i7 + (i2 * 12 | 0) + 4 >> 2]) < f69)) break L323;
         i3 = i7 + (i2 * 12 | 0) | 0;
         i49 = i7 + (i4 * 12 | 0) | 0;
         HEAP32[i55 >> 2] = HEAP32[i49 >> 2];
         HEAP32[i55 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
         HEAP32[i55 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
         HEAP32[i49 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i49 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i49 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         HEAP32[i3 >> 2] = HEAP32[i55 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
         i3 = i2 << 1 | 1;
         if ((i3 | 0) >= (i5 | 0)) break; else i4 = i2;
        }
       } while (0);
       i2 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
       if ((i2 | 0) == (i9 | 0)) f6 = Math_fround(0.0); else {
        f68 = Math_fround(HEAPF32[i7 + (i5 * 12 | 0) + 4 >> 2]);
        i49 = HEAP32[i52 >> 2] | 0;
        f19 = Math_fround(HEAPF32[i49 + (i9 * 12 | 0) >> 2]);
        f19 = Math_fround(f19 - Math_fround(HEAPF32[i49 + (i2 * 12 | 0) >> 2]));
        f6 = Math_fround(HEAPF32[i49 + (i9 * 12 | 0) + 4 >> 2]);
        f6 = Math_fround(f6 - Math_fround(HEAPF32[i49 + (i2 * 12 | 0) + 4 >> 2]));
        f69 = Math_fround(HEAPF32[i49 + (i9 * 12 | 0) + 8 >> 2]);
        f69 = Math_fround(f69 - Math_fround(HEAPF32[i49 + (i2 * 12 | 0) + 8 >> 2]));
        f69 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f6 * f6)) + Math_fround(f69 * f69))));
        HEAP32[i53 >> 2] = 0;
        f6 = Math_fround(__ZN5physx31PxClothGeodesicTetherCookerImpl23computeGeodesicDistanceEjjRi(i54, i9, i2, i53));
        f6 = (HEAP32[i53 >> 2] | 0) < 0 ? f68 : f6;
        f6 = f69 > f6 ? f69 : f6;
       }
       i49 = (Math_imul(HEAP32[i51 >> 2] | 0, i8) | 0) + i9 | 0;
       HEAP32[(HEAP32[i18 >> 2] | 0) + (i49 << 2) >> 2] = i2;
       HEAPF32[(HEAP32[i17 >> 2] | 0) + (i49 << 2) >> 2] = f6;
       i8 = i8 + 1 | 0;
      } while ((i8 | 0) != (i16 | 0));
      HEAP32[i24 >> 2] = i15 + i1;
     }
     i9 = i9 + 1 | 0;
     i2 = HEAP32[i51 >> 2] | 0;
    } while (i9 >>> 0 < i2 >>> 0);
   }
   i55 = HEAP32[i25 >> 2] | 0;
   if ((i55 | 0) > -1 & (i55 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i56 >> 2] | 0;
    if (i1 | 0) {
     i56 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i56 >> 2] | 0) + 12 >> 2] | 0, i56 | 0, i1 | 0);
    }
   }
   i56 = HEAP32[i27 >> 2] | 0;
   if ((i56 | 0) > -1 & (i56 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i57 >> 2] | 0;
    if (i1 | 0) {
     i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i57 >> 2] | 0) + 12 >> 2] | 0, i57 | 0, i1 | 0);
    }
   }
   i57 = HEAP32[i28 >> 2] | 0;
   if ((i57 | 0) > -1 & (i57 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i58 >> 2] | 0;
    if (i1 | 0) {
     i58 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i58 >> 2] | 0) + 12 >> 2] | 0, i58 | 0, i1 | 0);
    }
   }
   i58 = HEAP32[i30 >> 2] | 0;
   if ((i58 | 0) > -1 & (i58 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i59 >> 2] | 0;
    if (i1 | 0) {
     i59 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 12 >> 2] | 0, i59 | 0, i1 | 0);
    }
   }
   i59 = HEAP32[i31 >> 2] | 0;
   if ((i59 | 0) > -1 & (i59 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i60 >> 2] | 0;
    if (i1 | 0) {
     i60 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i60 >> 2] | 0) + 12 >> 2] | 0, i60 | 0, i1 | 0);
    }
   }
  }
 }
 i60 = HEAP32[i32 >> 2] | 0;
 if ((i60 | 0) > -1 & (i60 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i61 >> 2] | 0;
  if (i1 | 0) {
   i61 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i61 >> 2] | 0) + 12 >> 2] | 0, i61 | 0, i1 | 0);
  }
 }
 i61 = HEAP32[i33 >> 2] | 0;
 if ((i61 | 0) > -1 & (i61 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i62 >> 2] | 0;
  if (i1 | 0) {
   i62 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i62 >> 2] | 0) + 12 >> 2] | 0, i62 | 0, i1 | 0);
  }
 }
 i62 = HEAP32[i34 >> 2] | 0;
 if ((i62 | 0) > -1 & (i62 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i63 >> 2] | 0;
  if (i1 | 0) {
   i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
  }
 }
 i63 = HEAP32[i35 >> 2] | 0;
 if ((i63 | 0) > -1 & (i63 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i64 >> 2] | 0;
  if (i1 | 0) {
   i64 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i1 | 0);
  }
 }
 i64 = HEAP32[i44 >> 2] | 0;
 if ((i64 | 0) > -1 & (i64 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i65 >> 2] | 0;
  if (i1 | 0) {
   i65 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i65 >> 2] | 0) + 12 >> 2] | 0, i65 | 0, i1 | 0);
  }
 }
 i65 = HEAP32[i45 >> 2] | 0;
 if (!((i65 | 0) > -1 & (i65 & 2147483647 | 0) != 0)) {
  STACKTOP = i67;
  return;
 }
 i1 = HEAP32[i66 >> 2] | 0;
 if (!i1) {
  STACKTOP = i67;
  return;
 }
 i66 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i66 >> 2] | 0) + 12 >> 2] | 0, i66 | 0, i1 | 0);
 STACKTOP = i67;
 return;
}

function __ZN5physx24PxClothMeshQuadifierImplC2ERKNS_15PxClothMeshDescE(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i58 + 304 | 0;
 i39 = i58 + 288 | 0;
 i56 = i58 + 264 | 0;
 i42 = i58 + 224 | 0;
 i55 = i58 + 96 | 0;
 i43 = i58 + 60 | 0;
 i54 = i58 + 48 | 0;
 i49 = i58 + 24 | 0;
 i38 = i58;
 i9 = i58 + 84 | 0;
 i5 = i58 + 72 | 0;
 i57 = i58 + 36 | 0;
 i1 = i4;
 i2 = i8;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i6 = i8 + 48 | 0;
 HEAP16[i4 + 48 >> 1] = HEAP16[i6 >> 1] | 0;
 i46 = i4 + 52 | 0;
 i47 = i4 + 56 | 0;
 i48 = i4 + 60 | 0;
 i52 = i4 + 64 | 0;
 i51 = i4 + 68 | 0;
 i50 = i4 + 72 | 0;
 i2 = i8 + 8 | 0;
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 HEAP32[i46 + 16 >> 2] = 0;
 HEAP32[i46 + 20 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i53 = i9 + 8 | 0;
 HEAP32[i53 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i9, i1, i5);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 + 4 >> 2] | 0;
  i5 = 0;
  while (1) {
   i45 = i4;
   HEAP32[i3 + (i5 * 12 | 0) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i3 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i45 + 8 >> 2];
   i5 = i5 + 1 | 0;
   if (i5 >>> 0 >= i2 >>> 0) break; else i4 = i4 + i1 | 0;
  }
 }
 if (!(HEAP16[i6 >> 1] & 2)) {
  i1 = i8 + 32 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) * 3 | 0;
  HEAP32[i40 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i52, i2, i40);
  i2 = HEAP32[i8 + 24 >> 2] | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i3 = HEAP32[i52 >> 2] | 0;
   i4 = HEAP32[i8 + 28 >> 2] | 0;
   i5 = 0;
   while (1) {
    i45 = i5 * 3 | 0;
    HEAP32[i3 + (i45 << 2) >> 2] = HEAP32[i4 >> 2];
    HEAP32[i3 + (i45 + 1 << 2) >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i3 + (i45 + 2 << 2) >> 2] = HEAP32[i4 + 8 >> 2];
    i5 = i5 + 1 | 0;
    if (i5 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) break; else i4 = i4 + i2 | 0;
   }
  }
  i3 = i8 + 44 | 0;
  i4 = HEAP32[i3 >> 2] << 2;
  HEAP32[i39 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i46, i4, i39);
  i4 = HEAP32[i8 + 36 >> 2] | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i5 = HEAP32[i46 >> 2] | 0;
   i1 = HEAP32[i8 + 40 >> 2] | 0;
   i2 = 0;
   while (1) {
    i45 = i2 << 2;
    HEAP32[i5 + (i45 << 2) >> 2] = HEAP32[i1 >> 2];
    HEAP32[i5 + ((i45 | 1) << 2) >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i5 + ((i45 | 2) << 2) >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i5 + ((i45 | 3) << 2) >> 2] = HEAP32[i1 + 12 >> 2];
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
   }
  }
 } else {
  i1 = i8 + 32 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) * 3 | 0;
  HEAP32[i40 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i52, i2, i40);
  i2 = HEAP32[i8 + 24 >> 2] | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i3 = HEAP32[i52 >> 2] | 0;
   i4 = HEAP32[i8 + 28 >> 2] | 0;
   i5 = 0;
   while (1) {
    i45 = i5 * 3 | 0;
    HEAP32[i3 + (i45 << 2) >> 2] = HEAPU16[i4 >> 1];
    HEAP32[i3 + (i45 + 1 << 2) >> 2] = HEAPU16[i4 + 2 >> 1];
    HEAP32[i3 + (i45 + 2 << 2) >> 2] = HEAPU16[i4 + 4 >> 1];
    i5 = i5 + 1 | 0;
    if (i5 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) break; else i4 = i4 + i2 | 0;
   }
  }
  i3 = i8 + 44 | 0;
  i4 = HEAP32[i3 >> 2] << 2;
  HEAP32[i39 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i46, i4, i39);
  i4 = HEAP32[i8 + 36 >> 2] | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i5 = HEAP32[i46 >> 2] | 0;
   i1 = HEAP32[i8 + 40 >> 2] | 0;
   i2 = 0;
   while (1) {
    i45 = i2 << 2;
    HEAP32[i5 + (i45 << 2) >> 2] = HEAPU16[i1 >> 1];
    HEAP32[i5 + ((i45 | 1) << 2) >> 2] = HEAPU16[i1 + 2 >> 1];
    HEAP32[i5 + ((i45 | 2) << 2) >> 2] = HEAPU16[i1 + 4 >> 1];
    HEAP32[i5 + ((i45 | 3) << 2) >> 2] = HEAPU16[i1 + 6 >> 1];
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break; else i1 = i1 + i4 | 0;
   }
  }
 }
 HEAP32[i57 >> 2] = 0;
 i41 = i57 + 4 | 0;
 HEAP32[i41 >> 2] = 0;
 i44 = i57 + 8 | 0;
 HEAP32[i44 >> 2] = 0;
 i45 = HEAP32[i9 >> 2] | 0;
 HEAP32[i56 >> 2] = 0;
 HEAP32[i56 + 4 >> 2] = 0;
 HEAP32[i56 + 8 >> 2] = 0;
 HEAP32[i56 + 12 >> 2] = -1;
 HEAPF32[i56 + 16 >> 2] = Math_fround(0.0);
 HEAP8[i56 + 20 >> 0] = 0;
 HEAP8[i56 + 21 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i57, 0, i56);
 i1 = HEAP32[i51 >> 2] | 0;
 if ((HEAP32[i44 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i57, i1);
  i1 = HEAP32[i51 >> 2] | 0;
 };
 HEAP32[i42 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 HEAP32[i42 + 12 >> 2] = 0;
 HEAP32[i42 + 16 >> 2] = 0;
 HEAP32[i42 + 20 >> 2] = 0;
 HEAP32[i42 + 24 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 1;
 HEAP32[i42 + 8 >> 2] = 2;
 HEAP32[i42 + 12 >> 2] = 1;
 HEAP32[i42 + 16 >> 2] = 2;
 HEAP32[i42 + 28 >> 2] = 2;
 HEAP32[i42 + 32 >> 2] = 1;
 if (i1 | 0) {
  i4 = i40 + 4 | 0;
  i5 = i40 + 8 | 0;
  i6 = i40 + 12 | 0;
  i8 = i40 + 16 | 0;
  i9 = i40 + 20 | 0;
  i15 = i40 + 21 | 0;
  i16 = i40 + 24 | 0;
  i19 = i40 + 28 | 0;
  i20 = i40 + 32 | 0;
  i21 = i40 + 36 | 0;
  i22 = i40 + 40 | 0;
  i23 = i40 + 44 | 0;
  i24 = i40 + 45 | 0;
  i25 = i40 + 48 | 0;
  i26 = i40 + 52 | 0;
  i27 = i40 + 56 | 0;
  i28 = i40 + 60 | 0;
  i29 = i40 + 64 | 0;
  i30 = i40 + 68 | 0;
  i31 = i40 + 69 | 0;
  i32 = i43 + 4 | 0;
  i33 = i43 + 8 | 0;
  i34 = i40 + 24 | 0;
  i35 = i40 + 48 | 0;
  i36 = 0;
  do {
   HEAP32[i40 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = -1;
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAP8[i9 >> 0] = 0;
   HEAP8[i15 >> 0] = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i21 >> 2] = -1;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   HEAP8[i23 >> 0] = 0;
   HEAP8[i24 >> 0] = 0;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i28 >> 2] = -1;
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   HEAP8[i30 >> 0] = 0;
   HEAP8[i31 >> 0] = 0;
   i1 = HEAP32[i52 >> 2] | 0;
   i2 = 0;
   do {
    i60 = HEAP32[i1 + ((HEAP32[i42 + (i2 * 12 | 0) >> 2] | 0) + i36 << 2) >> 2] | 0;
    i62 = HEAP32[i1 + ((HEAP32[i42 + (i2 * 12 | 0) + 4 >> 2] | 0) + i36 << 2) >> 2] | 0;
    i3 = HEAP32[i1 + ((HEAP32[i42 + (i2 * 12 | 0) + 8 >> 2] | 0) + i36 << 2) >> 2] | 0;
    i63 = i60 >>> 0 < i62 >>> 0;
    i61 = i63 ? i60 : i62;
    i60 = i63 ? i62 : i60;
    HEAP32[i40 + (i2 * 24 | 0) >> 2] = i61;
    HEAP32[i40 + (i2 * 24 | 0) + 4 >> 2] = i60;
    HEAP32[i40 + (i2 * 24 | 0) + 8 >> 2] = i3;
    HEAP32[i40 + (i2 * 24 | 0) + 12 >> 2] = -1;
    HEAPF32[i40 + (i2 * 24 | 0) + 16 >> 2] = Math_fround(0.0);
    HEAP8[i40 + (i2 * 24 | 0) + 20 >> 0] = 0;
    HEAP8[i40 + (i2 * 24 | 0) + 21 >> 0] = 0;
    f11 = Math_fround(HEAPF32[i45 + (i61 * 12 | 0) >> 2]);
    f14 = Math_fround(HEAPF32[i45 + (i60 * 12 | 0) >> 2]);
    f10 = Math_fround(f11 - f14);
    f12 = Math_fround(HEAPF32[i45 + (i61 * 12 | 0) + 4 >> 2]);
    f17 = Math_fround(HEAPF32[i45 + (i60 * 12 | 0) + 4 >> 2]);
    f7 = Math_fround(f12 - f17);
    f13 = Math_fround(HEAPF32[i45 + (i61 * 12 | 0) + 8 >> 2]);
    f18 = Math_fround(HEAPF32[i45 + (i60 * 12 | 0) + 8 >> 2]);
    f59 = Math_fround(f13 - f18);
    HEAPF32[i43 + (i2 << 2) >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7)) + Math_fround(f59 * f59))));
    f59 = Math_fround(HEAPF32[i45 + (i3 * 12 | 0) >> 2]);
    f11 = Math_fround(f59 - f11);
    f7 = Math_fround(HEAPF32[i45 + (i3 * 12 | 0) + 4 >> 2]);
    f12 = Math_fround(f7 - f12);
    f10 = Math_fround(HEAPF32[i45 + (i3 * 12 | 0) + 8 >> 2]);
    f13 = Math_fround(f10 - f13);
    f14 = Math_fround(f59 - f14);
    f17 = Math_fround(f7 - f17);
    f18 = Math_fround(f10 - f18);
    HEAPF32[i54 + (i2 << 2) >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f17)) + Math_fround(f13 * f18)))) / Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13)))) * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))))));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 3);
   f59 = Math_fround(HEAPF32[i32 >> 2]);
   i1 = f59 > Math_fround(HEAPF32[i43 >> 2]) & 1;
   f59 = Math_fround(HEAPF32[i33 >> 2]);
   i63 = f59 > Math_fround(HEAPF32[i43 + (i1 << 2) >> 2]);
   i1 = i63 ? 2 : i1;
   if (Math_fround(HEAPF32[i54 + (i1 << 2) >> 2]) < Math_fround(.087155804)) HEAP8[i40 + (i1 * 24 | 0) + 20 >> 0] = 1;
   i3 = HEAP32[i44 >> 2] | 0;
   i1 = HEAP32[i41 >> 2] | 0;
   if ((i3 & 2147483647) >>> 0 > i1 >>> 0) {
    i2 = (HEAP32[i57 >> 2] | 0) + (i1 * 24 | 0) | 0;
    HEAP32[i2 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i40 + 20 >> 2];
    i2 = i1 + 1 | 0;
    HEAP32[i41 >> 2] = i2;
    i1 = i3;
   } else {
    __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i57, i40) | 0;
    i2 = HEAP32[i41 >> 2] | 0;
    i1 = HEAP32[i44 >> 2] | 0;
   }
   if ((i1 & 2147483647) >>> 0 > i2 >>> 0) {
    i63 = (HEAP32[i57 >> 2] | 0) + (i2 * 24 | 0) | 0;
    HEAP32[i63 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i63 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
    HEAP32[i63 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
    HEAP32[i63 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
    HEAP32[i63 + 16 >> 2] = HEAP32[i34 + 16 >> 2];
    HEAP32[i63 + 20 >> 2] = HEAP32[i34 + 20 >> 2];
    i2 = i2 + 1 | 0;
    HEAP32[i41 >> 2] = i2;
   } else {
    __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i57, i34) | 0;
    i2 = HEAP32[i41 >> 2] | 0;
    i1 = HEAP32[i44 >> 2] | 0;
   }
   if ((i1 & 2147483647) >>> 0 > i2 >>> 0) {
    i63 = (HEAP32[i57 >> 2] | 0) + (i2 * 24 | 0) | 0;
    HEAP32[i63 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i63 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i63 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    HEAP32[i63 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
    HEAP32[i63 + 16 >> 2] = HEAP32[i35 + 16 >> 2];
    HEAP32[i63 + 20 >> 2] = HEAP32[i35 + 20 >> 2];
    HEAP32[i41 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i57, i35) | 0;
   i36 = i36 + 3 | 0;
  } while (i36 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0);
 }
 i25 = HEAP32[i57 >> 2] | 0;
 i3 = HEAP32[i41 >> 2] | 0;
 i24 = i39 + 4 | 0;
 HEAP8[i24 >> 0] = 0;
 HEAP32[i39 >> 2] = i55;
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i1 = i55;
  i23 = 32;
  i5 = 0;
  i4 = 0;
  L58 : while (1) {
   i9 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i22 = i4;
      break;
     }
     do {
      i8 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i8;
      while (1) {
       i62 = HEAP32[i25 + (i6 * 24 | 0) >> 2] | 0;
       i63 = HEAP32[i25 + (i5 * 24 | 0) >> 2] | 0;
       i5 = ((i62 | 0) == (i63 | 0) ? (HEAP32[i25 + (i6 * 24 | 0) + 4 >> 2] | 0) >>> 0 < (HEAP32[i25 + (i5 * 24 | 0) + 4 >> 2] | 0) >>> 0 : i62 >>> 0 < i63 >>> 0) ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i8 | 0)) {
       i62 = i25 + (i5 * 24 | 0) | 0;
       i63 = i25 + (i8 * 24 | 0) | 0;
       HEAP32[i40 >> 2] = HEAP32[i62 >> 2];
       HEAP32[i40 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
       HEAP32[i40 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
       HEAP32[i40 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
       HEAP32[i40 + 16 >> 2] = HEAP32[i62 + 16 >> 2];
       HEAP32[i40 + 20 >> 2] = HEAP32[i62 + 20 >> 2];
       HEAP32[i62 >> 2] = HEAP32[i63 >> 2];
       HEAP32[i62 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
       HEAP32[i62 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
       HEAP32[i62 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
       HEAP32[i62 + 16 >> 2] = HEAP32[i63 + 16 >> 2];
       HEAP16[i62 + 20 >> 1] = HEAP16[i63 + 20 >> 1] | 0;
       HEAP32[i63 >> 2] = HEAP32[i40 >> 2];
       HEAP32[i63 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
       HEAP32[i63 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
       HEAP32[i63 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
       HEAP32[i63 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
       HEAP16[i63 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i9) break L58;
    i63 = i9 + -2 | 0;
    i3 = HEAP32[i1 + (i9 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i63 << 2) >> 2] | 0;
    i9 = i63;
   }
   i21 = (i3 + i22 | 0) / 2 | 0;
   i4 = i25 + (i21 * 24 | 0) | 0;
   i20 = i25 + (i22 * 24 | 0) | 0;
   i63 = HEAP32[i4 >> 2] | 0;
   i21 = i25 + (i21 * 24 | 0) + 4 | 0;
   i5 = HEAP32[i20 >> 2] | 0;
   i6 = i25 + (i22 * 24 | 0) + 4 | 0;
   i8 = HEAP32[i6 >> 2] | 0;
   if ((i63 | 0) == (i5 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i8 >>> 0 : i63 >>> 0 < i5 >>> 0) {
    HEAP32[i40 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i40 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i40 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i40 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP16[i20 + 20 >> 1] = HEAP16[i4 + 20 >> 1] | 0;
    HEAP32[i4 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
    HEAP16[i4 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
    i16 = HEAP32[i20 >> 2] | 0;
    i8 = HEAP32[i6 >> 2] | 0;
   } else i16 = i5;
   i19 = i25 + (i3 * 24 | 0) | 0;
   i6 = HEAP32[i19 >> 2] | 0;
   i15 = i25 + (i3 * 24 | 0) + 4 | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   if ((i6 | 0) == (i16 | 0) ? i5 >>> 0 < i8 >>> 0 : i6 >>> 0 < i16 >>> 0) {
    HEAP32[i40 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i40 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i40 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i40 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP16[i20 + 20 >> 1] = HEAP16[i19 + 20 >> 1] | 0;
    HEAP32[i19 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
    HEAP16[i19 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
    i6 = HEAP32[i19 >> 2] | 0;
    i5 = HEAP32[i15 >> 2] | 0;
   }
   i63 = HEAP32[i4 >> 2] | 0;
   if ((i6 | 0) == (i63 | 0) ? i5 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : i6 >>> 0 < i63 >>> 0) {
    HEAP32[i40 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i40 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i40 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i40 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP16[i4 + 20 >> 1] = HEAP16[i19 + 20 >> 1] | 0;
    HEAP32[i19 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
    HEAP16[i19 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
   }
   i6 = i3 + -1 | 0;
   i21 = i25 + (i6 * 24 | 0) | 0;
   HEAP32[i40 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i40 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i40 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP16[i4 + 20 >> 1] = HEAP16[i21 + 20 >> 1] | 0;
   HEAP32[i21 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i21 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   HEAP32[i21 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
   HEAP16[i21 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
   i20 = i25 + (i6 * 24 | 0) + 4 | 0;
   i5 = i22;
   while (1) {
    i15 = HEAP32[i21 >> 2] | 0;
    i16 = HEAP32[i20 >> 2] | 0;
    i8 = i5;
    while (1) {
     i5 = i8 + 1 | 0;
     i4 = i25 + (i5 * 24 | 0) | 0;
     i63 = HEAP32[i4 >> 2] | 0;
     if ((i63 | 0) == (i15 | 0) ? (HEAP32[i25 + (i5 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i16 >>> 0 : i63 >>> 0 < i15 >>> 0) i8 = i5; else {
      i19 = i8;
      break;
     }
    }
    while (1) {
     i8 = i6 + -1 | 0;
     i6 = i25 + (i8 * 24 | 0) | 0;
     i63 = HEAP32[i6 >> 2] | 0;
     if ((i15 | 0) == (i63 | 0) ? i16 >>> 0 < (HEAP32[i25 + (i8 * 24 | 0) + 4 >> 2] | 0) >>> 0 : i15 >>> 0 < i63 >>> 0) i6 = i8; else break;
    }
    HEAP32[i40 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i40 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i40 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i40 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    if ((i5 | 0) >= (i8 | 0)) break;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP16[i4 + 20 >> 1] = HEAP16[i6 + 20 >> 1] | 0;
    HEAP32[i6 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
    HEAP16[i6 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
    i6 = i8;
   }
   HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP16[i4 + 20 >> 1] = HEAP16[i21 + 20 >> 1] | 0;
   HEAP32[i21 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i21 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   HEAP32[i21 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
   HEAP16[i21 + 20 >> 1] = HEAP16[i40 + 20 >> 1] | 0;
   if ((i5 - i22 | 0) < (i3 - i5 | 0)) {
    if (i9 >>> 0 < (i23 + -1 | 0) >>> 0) i5 = i23; else {
     i4 = i23 << 3;
     if (!i4) i4 = 0; else {
      i62 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i61 = HEAP32[(HEAP32[i62 >> 2] | 0) + 8 >> 2] | 0;
      i63 = _PxGetFoundation() | 0;
      i63 = mftCall_ii(HEAP32[(HEAP32[i63 >> 2] | 0) + 24 >> 2] | 0, i63 | 0) | 0;
      i4 = mftCall_iiiiii(i61 | 0, i62 | 0, i4 | 0, (i63 ? gb + 739625 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i23 << 1;
     i1 = i4;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i22;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i19;
    i4 = i19 + 2 | 0;
   } else {
    i6 = i19 + 2 | 0;
    if (i9 >>> 0 < (i23 + -1 | 0) >>> 0) i5 = i23; else {
     i4 = i23 << 3;
     if (!i4) i4 = 0; else {
      i62 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i61 = HEAP32[(HEAP32[i62 >> 2] | 0) + 8 >> 2] | 0;
      i63 = _PxGetFoundation() | 0;
      i63 = mftCall_ii(HEAP32[(HEAP32[i63 >> 2] | 0) + 24 >> 2] | 0, i63 | 0) | 0;
      i4 = mftCall_iiiiii(i61 | 0, i62 | 0, i4 | 0, (i63 ? gb + 739625 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i23 << 1;
     i1 = i4;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i6;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i3;
    i4 = i22;
    i3 = i19;
   }
   i23 = i5;
   i5 = i9 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
  }
 }
 if (HEAP8[i24 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i39, HEAP32[i39 >> 2] | 0);
 i16 = HEAP32[i41 >> 2] | 0;
 if (!i16) i1 = 0; else {
  i15 = 0;
  i1 = 0;
  while (1) {
   L126 : do if (i15 >>> 0 < i16 >>> 0) {
    i3 = HEAP32[i25 + (i15 * 24 | 0) >> 2] | 0;
    i4 = HEAP32[i25 + (i15 * 24 | 0) + 4 >> 2] | 0;
    i2 = i15;
    do {
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i16 >>> 0) break L126;
    } while ((i3 | 0) == (HEAP32[i25 + (i2 * 24 | 0) >> 2] | 0) ? (i4 | 0) == (HEAP32[i25 + (i2 * 24 | 0) + 4 >> 2] | 0) : 0);
   } else i2 = i15; while (0);
   i6 = i2 - i15 | 0;
   i8 = i25 + (i15 * 24 | 0) | 0;
   HEAP32[i49 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = HEAP32[i25 + (i15 * 24 | 0) + 16 >> 2] | 0;
   i9 = HEAP8[i25 + (i15 * 24 | 0) + 21 >> 0] | 0;
   if ((i6 | 0) == 2) {
    i4 = HEAP32[i25 + ((i15 + 1 | 0) * 24 | 0) + 8 >> 2] | 0;
    i3 = HEAP8[i25 + (i15 * 24 | 0) + 20 >> 0] | 0;
    i37 = 85;
   } else {
    i3 = HEAP32[i25 + (i15 * 24 | 0) + 12 >> 2] | 0;
    if (i6 >>> 0 > 1) {
     i4 = i3;
     i3 = 0;
     i37 = 85;
    } else {
     i4 = i3;
     i3 = 0;
    }
   }
   if ((i37 | 0) == 85) {
    i37 = 0;
    i5 = 1;
    do {
     i3 = HEAP8[i25 + ((i5 + i15 | 0) * 24 | 0) + 20 >> 0] & i3;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i6 | 0));
   }
   i63 = i25 + (i1 * 24 | 0) | 0;
   HEAP32[i63 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i25 + (i1 * 24 | 0) + 12 >> 2] = i4;
   HEAP32[i25 + (i1 * 24 | 0) + 16 >> 2] = i8;
   HEAP8[i25 + (i1 * 24 | 0) + 20 >> 0] = i3;
   HEAP8[i25 + (i1 * 24 | 0) + 21 >> 0] = i9;
   i1 = i1 + 1 | 0;
   if (i2 >>> 0 < i16 >>> 0) i15 = i2; else break;
  }
 }
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = -1;
 HEAPF32[i38 + 16 >> 2] = Math_fround(0.0);
 HEAP8[i38 + 20 >> 0] = 0;
 HEAP8[i38 + 21 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i57, i1, i38);
 HEAP32[i39 >> 2] = 0;
 i26 = i39 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 i28 = i39 + 8 | 0;
 HEAP32[i28 >> 2] = 0;
 i15 = HEAP32[i41 >> 2] | 0;
 if (!i15) HEAP32[i56 >> 2] = 0; else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i39, i15);
  HEAP32[i56 >> 2] = 0;
  i5 = i42 + 4 | 0;
  i6 = i42 + 8 | 0;
  i8 = i42 + 12 | 0;
  i16 = HEAP32[i57 >> 2] | 0;
  i9 = 0;
  do {
   i4 = i16 + (i9 * 24 | 0) + 16 | 0;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAP8[i16 + (i9 * 24 | 0) + 20 >> 0] = 0;
   i1 = HEAP32[i16 + (i9 * 24 | 0) + 12 >> 2] | 0;
   do if ((i1 | 0) != -1) {
    i2 = HEAP32[i16 + (i9 * 24 | 0) >> 2] | 0;
    HEAP32[i42 >> 2] = i2;
    HEAP32[i5 >> 2] = HEAP32[i16 + (i9 * 24 | 0) + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i16 + (i9 * 24 | 0) + 4 >> 2];
    HEAP32[i8 >> 2] = i1;
    i1 = i2;
    f7 = Math_fround(0.0);
    i2 = 0;
    while (1) {
     i3 = i2 + 1 | 0;
     i63 = HEAP32[i42 + ((i3 & 3) << 2) >> 2] | 0;
     f17 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) >> 2]);
     f10 = Math_fround(HEAPF32[i45 + (i63 * 12 | 0) >> 2]);
     f17 = Math_fround(f17 - f10);
     f18 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) + 4 >> 2]);
     f11 = Math_fround(HEAPF32[i45 + (i63 * 12 | 0) + 4 >> 2]);
     f18 = Math_fround(f18 - f11);
     f14 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) + 8 >> 2]);
     f12 = Math_fround(HEAPF32[i45 + (i63 * 12 | 0) + 8 >> 2]);
     f14 = Math_fround(f14 - f12);
     i63 = HEAP32[i42 + ((i2 + 2 & 3) << 2) >> 2] | 0;
     f10 = Math_fround(f10 - Math_fround(HEAPF32[i45 + (i63 * 12 | 0) >> 2]));
     f11 = Math_fround(f11 - Math_fround(HEAPF32[i45 + (i63 * 12 | 0) + 4 >> 2]));
     f12 = Math_fround(f12 - Math_fround(HEAPF32[i45 + (i63 * 12 | 0) + 8 >> 2]));
     f13 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f14 * f14)))) * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f12 * f12)))));
     if (f13 != Math_fround(0.0)) {
      f59 = Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f18 * f11)) + Math_fround(f14 * f12)))) / f13);
      f7 = f7 > f59 ? f7 : f59;
      HEAPF32[i4 >> 2] = f7;
     }
     if ((i3 | 0) == 4) break;
     i1 = HEAP32[i42 + (i3 << 2) >> 2] | 0;
     i2 = i3;
    }
    i1 = HEAP32[i26 >> 2] | 0;
    if ((HEAP32[i28 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i39 >> 2] | 0) + (i1 << 2) >> 2] = i9;
     HEAP32[i26 >> 2] = i1 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i39, i56) | 0;
     break;
    }
   } while (0);
   i9 = i9 + 1 | 0;
   HEAP32[i56 >> 2] = i9;
  } while (i9 >>> 0 < i15 >>> 0);
 }
 i27 = HEAP32[i39 >> 2] | 0;
 i3 = HEAP32[i26 >> 2] | 0;
 i25 = i40 + 4 | 0;
 HEAP8[i25 >> 0] = 0;
 HEAP32[i40 >> 2] = i55;
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i24 = HEAP32[i57 >> 2] | 0;
  i2 = 0;
  i1 = i55;
  i23 = 32;
  i5 = 0;
  i4 = 0;
  L162 : while (1) {
   i9 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i8 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i8;
      while (1) {
       f59 = Math_fround(HEAPF32[i24 + ((HEAP32[i27 + (i6 << 2) >> 2] | 0) * 24 | 0) + 16 >> 2]);
       i63 = f59 < Math_fround(HEAPF32[i24 + ((HEAP32[i27 + (i5 << 2) >> 2] | 0) * 24 | 0) + 16 >> 2]);
       i5 = i63 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i8 | 0)) {
       i61 = i27 + (i5 << 2) | 0;
       i63 = i27 + (i8 << 2) | 0;
       i62 = HEAP32[i61 >> 2] | 0;
       HEAP32[i61 >> 2] = HEAP32[i63 >> 2];
       HEAP32[i63 >> 2] = i62;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i9) break L162;
    i63 = i9 + -2 | 0;
    i3 = HEAP32[i1 + (i9 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i63 << 2) >> 2] | 0;
    i9 = i63;
   }
   i19 = i27 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i5 = HEAP32[i19 >> 2] | 0;
   i15 = i27 + (i4 << 2) | 0;
   i6 = HEAP32[i15 >> 2] | 0;
   f59 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 16 >> 2]);
   f7 = Math_fround(HEAPF32[i24 + (i6 * 24 | 0) + 16 >> 2]);
   if (f59 < f7) {
    HEAP32[i15 >> 2] = i5;
    HEAP32[i19 >> 2] = i6;
    i8 = HEAP32[i15 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i24 + (i8 * 24 | 0) + 16 >> 2]);
    i5 = i6;
   } else i8 = i6;
   i16 = i27 + (i3 << 2) | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i24 + (i6 * 24 | 0) + 16 >> 2]);
   if (f10 < f7) {
    HEAP32[i15 >> 2] = i6;
    HEAP32[i16 >> 2] = i8;
    i5 = HEAP32[i19 >> 2] | 0;
    i6 = i8;
   } else f7 = f10;
   if (f7 < Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 16 >> 2])) {
    HEAP32[i19 >> 2] = i6;
    HEAP32[i16 >> 2] = i5;
    i5 = HEAP32[i19 >> 2] | 0;
   }
   i15 = i3 + -1 | 0;
   i22 = i27 + (i15 << 2) | 0;
   HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i22 >> 2] = i5;
   i6 = i4;
   while (1) {
    f7 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 16 >> 2]);
    i19 = i6;
    while (1) {
     i6 = i19 + 1 | 0;
     i16 = i27 + (i6 << 2) | 0;
     i8 = HEAP32[i16 >> 2] | 0;
     if (Math_fround(HEAPF32[i24 + (i8 * 24 | 0) + 16 >> 2]) < f7) i19 = i6; else {
      i20 = i16;
      i21 = i19;
      break;
     }
    }
    do {
     i15 = i15 + -1 | 0;
     i19 = i27 + (i15 << 2) | 0;
     i16 = HEAP32[i19 >> 2] | 0;
    } while (f7 < Math_fround(HEAPF32[i24 + (i16 * 24 | 0) + 16 >> 2]));
    if ((i6 | 0) >= (i15 | 0)) {
     i15 = i20;
     break;
    }
    HEAP32[i20 >> 2] = i16;
    HEAP32[i19 >> 2] = i8;
    i5 = HEAP32[i22 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = i5;
   HEAP32[i22 >> 2] = i8;
   if ((i6 - i4 | 0) < (i3 - i6 | 0)) {
    if (i9 >>> 0 < (i23 + -1 | 0) >>> 0) i6 = i23; else {
     i5 = i23 << 3;
     if (!i5) i5 = 0; else {
      i62 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i61 = HEAP32[(HEAP32[i62 >> 2] | 0) + 8 >> 2] | 0;
      i63 = _PxGetFoundation() | 0;
      i63 = mftCall_ii(HEAP32[(HEAP32[i63 >> 2] | 0) + 24 >> 2] | 0, i63 | 0) | 0;
      i5 = mftCall_iiiiii(i61 | 0, i62 | 0, i5 | 0, (i63 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
     }
     i2 = 1;
     i6 = i23 << 1;
     i1 = i5;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i4;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i21;
    i5 = i6;
    i4 = i21 + 2 | 0;
   } else {
    i8 = i21 + 2 | 0;
    if (i9 >>> 0 < (i23 + -1 | 0) >>> 0) i5 = i23; else {
     i5 = i23 << 3;
     if (!i5) i6 = 0; else {
      i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i62 = HEAP32[(HEAP32[i63 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i62 | 0, i63 | 0, i5 | 0, (i6 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i23 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i8;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i3;
    i3 = i21;
   }
   i23 = i5;
   i5 = i9 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
  }
 }
 if (HEAP8[i25 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i40, HEAP32[i40 >> 2] | 0);
 i19 = HEAP32[i26 >> 2] | 0;
 L226 : do if (i19 | 0) {
  i24 = HEAP32[i57 >> 2] | 0;
  i25 = HEAP32[i41 >> 2] | 0;
  i20 = (i25 | 0) == 0;
  i21 = i24 + 20 | 0;
  i23 = 0;
  do {
   i22 = HEAP32[i27 + (i23 << 2) >> 2] | 0;
   if (Math_fround(HEAPF32[i24 + (i22 * 24 | 0) + 16 >> 2]) > Math_fround(.866025447)) break L226;
   i15 = HEAP32[i24 + (i22 * 24 | 0) >> 2] | 0;
   i5 = HEAP32[i24 + (i22 * 24 | 0) + 8 >> 2] | 0;
   i8 = HEAP32[i24 + (i22 * 24 | 0) + 4 >> 2] | 0;
   i16 = HEAP32[i24 + (i22 * 24 | 0) + 12 >> 2] | 0;
   if (i20) {
    i1 = (HEAP8[i21 >> 0] ^ 1) & 255;
    i1 = (0 - i1 & 3) + i1 | 0;
   } else {
    i3 = i15 >>> 0 < i5 >>> 0;
    i2 = i3 ? i15 : i5;
    i3 = i3 ? i5 : i15;
    i4 = i25;
    i1 = 0;
    do {
     i63 = (i4 + i1 | 0) >>> 1;
     i62 = HEAP32[i24 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i24 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
     i4 = i62 ? i4 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i4 >>> 0 > i1 >>> 0);
    i6 = HEAP8[i24 + (i1 * 24 | 0) + 20 >> 0] ^ 1;
    i2 = i5 >>> 0 < i8 >>> 0;
    i4 = i2 ? i5 : i8;
    i2 = i2 ? i8 : i5;
    i3 = i25;
    i1 = 0;
    do {
     i63 = (i3 + i1 | 0) >>> 1;
     i62 = HEAP32[i24 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i4 | 0) ? (HEAP32[i24 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i2 >>> 0 : i62 >>> 0 < i4 >>> 0;
     i3 = i62 ? i3 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i3 >>> 0 > i1 >>> 0);
    i9 = (HEAP8[i24 + (i1 * 24 | 0) + 20 >> 0] ^ 1) & 255;
    i2 = i8 >>> 0 < i16 >>> 0;
    i4 = i2 ? i8 : i16;
    i2 = i2 ? i16 : i8;
    i3 = i25;
    i1 = 0;
    do {
     i63 = (i3 + i1 | 0) >>> 1;
     i62 = HEAP32[i24 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i4 | 0) ? (HEAP32[i24 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i2 >>> 0 : i62 >>> 0 < i4 >>> 0;
     i3 = i62 ? i3 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i3 >>> 0 > i1 >>> 0);
    i6 = i6 & 255;
    i5 = (HEAP8[i24 + (i1 * 24 | 0) + 20 >> 0] ^ 1) & 255;
    i2 = i16 >>> 0 < i15 >>> 0;
    i4 = i2 ? i16 : i15;
    i2 = i2 ? i15 : i16;
    i3 = i25;
    i1 = 0;
    do {
     i63 = (i3 + i1 | 0) >>> 1;
     i62 = HEAP32[i24 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i4 | 0) ? (HEAP32[i24 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i2 >>> 0 : i62 >>> 0 < i4 >>> 0;
     i3 = i62 ? i3 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i3 >>> 0 > i1 >>> 0);
    i1 = i9 + i6 + i5 + ((HEAP8[i24 + (i1 * 24 | 0) + 20 >> 0] ^ 1) & 255) | 0;
   }
   if ((i1 | 0) == 4) HEAP8[i24 + (i22 * 24 | 0) + 20 >> 0] = 1;
   i23 = i23 + 1 | 0;
  } while (i23 >>> 0 < i19 >>> 0);
 } while (0);
 i63 = HEAP32[i28 >> 2] | 0;
 if (!((i27 | 0) == 0 | ((i63 | 0) < 0 | (i63 & 2147483647 | 0) == 0))) {
  i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i27 | 0);
 }
 i21 = HEAP32[i41 >> 2] | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 i22 = i40 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i27 = i40 + 8 | 0;
 HEAP32[i27 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i40, i21 + 1 | 0, i39);
 HEAP32[i56 >> 2] = 0;
 HEAP32[i56 + 4 >> 2] = 0;
 i26 = i56 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 i24 = HEAP32[i51 >> 2] | 0;
 i25 = (i24 >>> 0) / 3 | 0;
 i24 = i24 >>> 0 > 2;
 if (i24) {
  i19 = HEAP32[i52 >> 2] | 0;
  i20 = HEAP32[i57 >> 2] | 0;
  i9 = HEAP32[i40 >> 2] | 0;
  i15 = (i21 | 0) == 0;
  i16 = 0;
  do {
   i5 = i16 * 3 | 0;
   i8 = i19 + (i5 << 2) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i6 = i19 + (i5 + 1 << 2) | 0;
   i63 = HEAP32[i6 >> 2] | 0;
   i62 = i3 >>> 0 < i63 >>> 0;
   i2 = i62 ? i3 : i63;
   i3 = i62 ? i63 : i3;
   if (i15) i1 = 0; else {
    i4 = i21;
    i1 = 0;
    do {
     i63 = (i4 + i1 | 0) >>> 1;
     i62 = HEAP32[i20 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i20 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
     i4 = i62 ? i4 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i4 >>> 0 > i1 >>> 0);
   }
   i3 = i9 + (i1 << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i6 >> 2] | 0;
   i5 = i19 + (i5 + 2 << 2) | 0;
   i63 = HEAP32[i5 >> 2] | 0;
   i62 = i3 >>> 0 < i63 >>> 0;
   i2 = i62 ? i3 : i63;
   i3 = i62 ? i63 : i3;
   if (i15) i1 = 0; else {
    i4 = i21;
    i1 = 0;
    do {
     i63 = (i4 + i1 | 0) >>> 1;
     i62 = HEAP32[i20 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i20 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
     i4 = i62 ? i4 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i4 >>> 0 > i1 >>> 0);
   }
   i3 = i9 + (i1 << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = HEAP32[i5 >> 2] | 0;
   i63 = HEAP32[i8 >> 2] | 0;
   i62 = i3 >>> 0 < i63 >>> 0;
   i2 = i62 ? i3 : i63;
   i3 = i62 ? i63 : i3;
   if (i15) i1 = 0; else {
    i4 = i21;
    i1 = 0;
    do {
     i63 = (i4 + i1 | 0) >>> 1;
     i62 = HEAP32[i20 + (i63 * 24 | 0) >> 2] | 0;
     i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i20 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
     i4 = i62 ? i4 : i63;
     i1 = i62 ? i63 + 1 | 0 : i1;
    } while (i4 >>> 0 > i1 >>> 0);
   }
   i63 = i9 + (i1 << 2) | 0;
   HEAP32[i63 >> 2] = (HEAP32[i63 >> 2] | 0) + 1;
   i16 = i16 + 1 | 0;
  } while (i16 >>> 0 < i25 >>> 0);
  i23 = i9;
 } else i23 = HEAP32[i40 >> 2] | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i4 = i23 + (i1 << 2) | 0;
 if (!i1) i1 = 0; else if ((i1 | 0) == 1) i1 = 1; else {
  i1 = i23 + 4 | 0;
  i2 = HEAP32[i23 >> 2] | 0;
  i3 = i23;
  do {
   i3 = i3 + 4 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   HEAP32[i3 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP32[i22 >> 2] | 0;
 }
 i63 = HEAP32[i23 + (i1 + -1 << 2) >> 2] | 0;
 HEAP32[i42 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i56, i63, i42);
 L279 : do if (i24) {
  i16 = HEAP32[i52 >> 2] | 0;
  i19 = HEAP32[i57 >> 2] | 0;
  i20 = HEAP32[i56 >> 2] | 0;
  i21 = HEAP32[i41 >> 2] | 0;
  if (!i21) {
   i1 = 0;
   while (1) {
    i62 = i1 * 3 | 0;
    i63 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
    HEAP32[i23 >> 2] = i63;
    HEAP32[i20 + (i63 << 2) >> 2] = i62;
    i63 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
    HEAP32[i23 >> 2] = i63;
    HEAP32[i20 + (i63 << 2) >> 2] = i62 + 1;
    i63 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
    HEAP32[i23 >> 2] = i63;
    HEAP32[i20 + (i63 << 2) >> 2] = i62 + 2;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i25 >>> 0) break L279;
   }
  } else i15 = 0;
  do {
   i5 = i15 * 3 | 0;
   i8 = i16 + (i5 << 2) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i9 = i5 + 1 | 0;
   i6 = i16 + (i9 << 2) | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i1 = i3 >>> 0 < i4 >>> 0;
   i2 = i1 ? i3 : i4;
   i3 = i1 ? i4 : i3;
   i4 = i21;
   i1 = 0;
   do {
    i63 = (i4 + i1 | 0) >>> 1;
    i62 = HEAP32[i19 + (i63 * 24 | 0) >> 2] | 0;
    i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i19 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
    i4 = i62 ? i4 : i63;
    i1 = i62 ? i63 + 1 | 0 : i1;
   } while (i4 >>> 0 > i1 >>> 0);
   i3 = (HEAP32[i23 + (i1 << 2) >> 2] | 0) + -1 | 0;
   HEAP32[i23 + (i1 << 2) >> 2] = i3;
   HEAP32[i20 + (i3 << 2) >> 2] = i5;
   i3 = HEAP32[i6 >> 2] | 0;
   i6 = i5 + 2 | 0;
   i5 = i16 + (i6 << 2) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i1 = i3 >>> 0 < i4 >>> 0;
   i2 = i1 ? i3 : i4;
   i3 = i1 ? i4 : i3;
   i4 = i21;
   i1 = 0;
   do {
    i63 = (i4 + i1 | 0) >>> 1;
    i62 = HEAP32[i19 + (i63 * 24 | 0) >> 2] | 0;
    i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i19 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
    i4 = i62 ? i4 : i63;
    i1 = i62 ? i63 + 1 | 0 : i1;
   } while (i4 >>> 0 > i1 >>> 0);
   i3 = (HEAP32[i23 + (i1 << 2) >> 2] | 0) + -1 | 0;
   HEAP32[i23 + (i1 << 2) >> 2] = i3;
   HEAP32[i20 + (i3 << 2) >> 2] = i9;
   i3 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = i3 >>> 0 < i4 >>> 0;
   i2 = i1 ? i3 : i4;
   i3 = i1 ? i4 : i3;
   i4 = i21;
   i1 = 0;
   do {
    i63 = (i4 + i1 | 0) >>> 1;
    i62 = HEAP32[i19 + (i63 * 24 | 0) >> 2] | 0;
    i62 = (i62 | 0) == (i2 | 0) ? (HEAP32[i19 + (i63 * 24 | 0) + 4 >> 2] | 0) >>> 0 < i3 >>> 0 : i62 >>> 0 < i2 >>> 0;
    i4 = i62 ? i4 : i63;
    i1 = i62 ? i63 + 1 | 0 : i1;
   } while (i4 >>> 0 > i1 >>> 0);
   i63 = (HEAP32[i23 + (i1 << 2) >> 2] | 0) + -1 | 0;
   HEAP32[i23 + (i1 << 2) >> 2] = i63;
   HEAP32[i20 + (i63 << 2) >> 2] = i6;
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < i25 >>> 0);
 } else i21 = HEAP32[i41 >> 2] | 0; while (0);
 HEAP32[i43 >> 2] = 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i55 + 4 >> 2] = 0;
 i22 = i55 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i55, i25, i43);
 if (i21 | 0) {
  i16 = HEAP32[i56 >> 2] | 0;
  i19 = HEAP32[i55 >> 2] | 0;
  i20 = HEAP32[i57 >> 2] | 0;
  i1 = 0;
  do do if (!(HEAP8[i20 + (i1 * 24 | 0) + 20 >> 0] | 0)) i1 = i1 + 1 | 0; else {
   i2 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
   i1 = i1 + 1 | 0;
   if (((HEAP32[i23 + (i1 << 2) >> 2] | 0) - i2 | 0) != 2) break;
   i6 = HEAP32[i16 + (i2 << 2) >> 2] | 0;
   i5 = HEAP32[i16 + (i2 + 1 << 2) >> 2] | 0;
   i9 = (i6 >>> 0) / 3 | 0;
   i15 = (i5 >>> 0) / 3 | 0;
   i6 = (i6 >>> 0) % 3 | 0;
   i8 = i9 * 3 | 0;
   i2 = HEAP32[i52 >> 2] | 0;
   i3 = i2 + (i6 + i8 << 2) | 0;
   i4 = HEAP32[i47 >> 2] | 0;
   if ((HEAP32[i48 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i46 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
    i4 = (HEAP32[i47 >> 2] | 0) + 1 | 0;
    HEAP32[i47 >> 2] = i4;
   } else {
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i46, i3) | 0;
    i2 = HEAP32[i52 >> 2] | 0;
    i4 = HEAP32[i47 >> 2] | 0;
   }
   i3 = i2 + ((((((i5 >>> 0) % 3 | 0) + 2 | 0) >>> 0) % 3 | 0) + (i15 * 3 | 0) << 2) | 0;
   if ((HEAP32[i48 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i46 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
    i4 = (HEAP32[i47 >> 2] | 0) + 1 | 0;
    HEAP32[i47 >> 2] = i4;
   } else {
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i46, i3) | 0;
    i2 = HEAP32[i52 >> 2] | 0;
    i4 = HEAP32[i47 >> 2] | 0;
   }
   i3 = i2 + ((((i6 + 1 | 0) >>> 0) % 3 | 0) + i8 << 2) | 0;
   if ((HEAP32[i48 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i46 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
    i3 = (HEAP32[i47 >> 2] | 0) + 1 | 0;
    HEAP32[i47 >> 2] = i3;
   } else {
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i46, i3) | 0;
    i2 = HEAP32[i52 >> 2] | 0;
    i3 = HEAP32[i47 >> 2] | 0;
   }
   i2 = i2 + ((((i6 + 2 | 0) >>> 0) % 3 | 0) + i8 << 2) | 0;
   if ((HEAP32[i48 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i46 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
    HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i46, i2) | 0;
   HEAP32[i19 + (i9 << 2) >> 2] = 1;
   HEAP32[i19 + (i15 << 2) >> 2] = 1;
  } while (0); while (i1 >>> 0 < i21 >>> 0);
 }
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE(i54, i52);
 HEAP32[i49 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i52, 0, i49);
 if (i24) {
  i4 = HEAP32[i55 >> 2] | 0;
  i5 = HEAP32[i54 >> 2] | 0;
  i6 = 0;
  do {
   do if (!(HEAP32[i4 + (i6 << 2) >> 2] | 0)) {
    i3 = i6 * 3 | 0;
    i1 = i5 + (i3 << 2) | 0;
    i2 = HEAP32[i51 >> 2] | 0;
    if ((HEAP32[i50 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i52 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     i2 = (HEAP32[i51 >> 2] | 0) + 1 | 0;
     HEAP32[i51 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i52, i1) | 0;
     i2 = HEAP32[i51 >> 2] | 0;
    }
    i1 = i5 + (i3 + 1 << 2) | 0;
    if ((HEAP32[i50 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i52 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     i2 = (HEAP32[i51 >> 2] | 0) + 1 | 0;
     HEAP32[i51 >> 2] = i2;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i52, i1) | 0;
     i2 = HEAP32[i51 >> 2] | 0;
    }
    i1 = i5 + (i3 + 2 << 2) | 0;
    if ((HEAP32[i50 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i52 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
     HEAP32[i51 >> 2] = (HEAP32[i51 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i52, i1) | 0;
     break;
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i25 >>> 0);
 }
 i63 = HEAP32[i54 + 8 >> 2] | 0;
 if ((i63 | 0) > -1 & (i63 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i54 >> 2] | 0;
  if (i1 | 0) {
   i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
  }
 }
 i63 = HEAP32[i22 >> 2] | 0;
 do if ((i63 | 0) > -1 & (i63 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i55 >> 2] | 0;
  if (!i1) break;
  i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
 } while (0);
 i63 = HEAP32[i26 >> 2] | 0;
 do if ((i63 | 0) > -1 & (i63 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i56 >> 2] | 0;
  if (!i1) break;
  i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
 } while (0);
 i63 = HEAP32[i27 >> 2] | 0;
 if (!((i23 | 0) == 0 | ((i63 | 0) < 0 | (i63 & 2147483647 | 0) == 0))) {
  i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i23 | 0);
 }
 i63 = HEAP32[i44 >> 2] | 0;
 do if ((i63 | 0) > -1 & (i63 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i57 >> 2] | 0;
  if (!i1) break;
  i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i1 | 0);
 } while (0);
 i63 = HEAP32[i53 >> 2] | 0;
 if ((i63 & 2147483647 | 0) == 0 | (i63 | 0) < 0 | (i45 | 0) == 0) {
  STACKTOP = i58;
  return;
 }
 i63 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i45 | 0);
 STACKTOP = i58;
 return;
}

function __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i27, i28, i64, i65, i26, i63, i24, f25, f29, i33, i51) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i26 = i26 | 0;
 i63 = i63 | 0;
 i24 = i24 | 0;
 f25 = Math_fround(f25);
 f29 = Math_fround(f29);
 i33 = i33 | 0;
 i51 = i51 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f30 = f0, f31 = f0, f32 = f0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i66;
 f68 = Math_fround(HEAPF32[i63 >> 2]);
 f71 = Math_fround(f68 * f68);
 i52 = i63 + 4 | 0;
 f67 = Math_fround(HEAPF32[i52 >> 2]);
 f32 = Math_fround(f67 * f67);
 i53 = i63 + 8 | 0;
 f17 = Math_fround(HEAPF32[i53 >> 2]);
 f72 = Math_fround(f17 * f17);
 i54 = i63 + 12 | 0;
 f18 = Math_fround(HEAPF32[i54 >> 2]);
 f38 = Math_fround(f18 * f18);
 i55 = i63 + 16 | 0;
 f19 = Math_fround(HEAPF32[i55 >> 2]);
 f31 = Math_fround(f19 * f19);
 i56 = i63 + 20 | 0;
 f20 = Math_fround(HEAPF32[i56 >> 2]);
 f30 = Math_fround(f20 * f20);
 i57 = i63 + 24 | 0;
 f21 = Math_fround(HEAPF32[i57 >> 2]);
 f23 = Math_fround(f21 * f21);
 i58 = i63 + 28 | 0;
 f22 = Math_fround(HEAPF32[i58 >> 2]);
 f31 = Math_fround(f71 + f31);
 f30 = Math_fround(f32 + f30);
 f23 = Math_fround(f72 + f23);
 f38 = Math_fround(f38 + Math_fround(f22 * f22));
 i59 = i63 + 32 | 0;
 f72 = Math_fround(HEAPF32[i59 >> 2]);
 f32 = Math_fround(f72 * f72);
 i60 = i63 + 36 | 0;
 f71 = Math_fround(HEAPF32[i60 >> 2]);
 f36 = Math_fround(f71 * f71);
 i61 = i63 + 40 | 0;
 f70 = Math_fround(HEAPF32[i61 >> 2]);
 f37 = Math_fround(f70 * f70);
 i62 = i63 + 44 | 0;
 f69 = Math_fround(HEAPF32[i62 >> 2]);
 f32 = Math_fround(f31 + f32);
 f36 = Math_fround(f30 + f36);
 f37 = Math_fround(f23 + f37);
 f38 = Math_fround(f38 + Math_fround(f69 * f69));
 f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f32))));
 f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f36))));
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f37))));
 f1 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f38))));
 f68 = Math_fround(f68 * f23);
 f67 = Math_fround(f67 * f30);
 f17 = Math_fround(f17 * f31);
 f18 = Math_fround(f18 * f1);
 f19 = Math_fround(f19 * f23);
 f20 = Math_fround(f20 * f30);
 f21 = Math_fround(f21 * f31);
 f22 = Math_fround(f22 * f1);
 f23 = Math_fround(f72 * f23);
 f30 = Math_fround(f71 * f30);
 f31 = Math_fround(f70 * f31);
 f1 = Math_fround(f69 * f1);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f32 > Math_fround(9.99999974e-06);
 i6 = f36 > Math_fround(9.99999974e-06);
 i7 = f37 > Math_fround(9.99999974e-06);
 i50 = f38 > Math_fround(9.99999974e-06);
 i8 = i5 ? i8 : 1065353216;
 i9 = i6 ? i9 : 1065353216;
 i10 = i7 ? i10 : 1065353216;
 i11 = i50 ? i11 : 1065353216;
 i12 = i5 ? i12 : 0;
 i13 = i6 ? i13 : 0;
 i14 = i7 ? i14 : 0;
 i15 = i50 ? i15 : 0;
 i50 = i50 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i63 >> 2] = i8;
 HEAP32[i52 >> 2] = i9;
 HEAP32[i53 >> 2] = i10;
 HEAP32[i54 >> 2] = i11;
 i35 = i63 + 16 | 0;
 HEAP32[i35 >> 2] = i12;
 HEAP32[i56 >> 2] = i13;
 HEAP32[i57 >> 2] = i14;
 HEAP32[i58 >> 2] = i15;
 i34 = i63 + 32 | 0;
 HEAP32[i34 >> 2] = i5 ? i2 : 0;
 HEAP32[i60 >> 2] = i6 ? i3 : 0;
 HEAP32[i61 >> 2] = i7 ? i4 : 0;
 HEAP32[i62 >> 2] = i50;
 i50 = f25 > Math_fround(0.0);
 f23 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f1 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i50) {
  __Z16RandomUnitVectorR5RandN(i16, i24);
  f23 = Math_fround(HEAPF32[i16 >> 2]);
  f70 = Math_fround(HEAPF32[i63 >> 2]);
  f23 = Math_fround(f23 - f70);
  f22 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i52 >> 2]);
  f22 = Math_fround(f22 - f18);
  f21 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i53 >> 2]);
  f21 = Math_fround(f21 - f38);
  f19 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i54 >> 2]);
  f23 = Math_fround(f70 + Math_fround(f23 * f25));
  f22 = Math_fround(f18 + Math_fround(f22 * f25));
  f21 = Math_fround(f38 + Math_fround(f21 * f25));
  f20 = Math_fround(f20 + Math_fround(Math_fround(f19 - f20) * f25));
  f19 = Math_fround(HEAPF32[i16 + 16 >> 2]);
  f38 = Math_fround(HEAPF32[i55 >> 2]);
  f19 = Math_fround(f19 - f38);
  f18 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f70 = Math_fround(HEAPF32[i56 >> 2]);
  f18 = Math_fround(f18 - f70);
  f17 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  f37 = Math_fround(HEAPF32[i57 >> 2]);
  f17 = Math_fround(f17 - f37);
  f69 = Math_fround(HEAPF32[i16 + 28 >> 2]);
  f1 = Math_fround(HEAPF32[i58 >> 2]);
  f19 = Math_fround(f38 + Math_fround(f19 * f25));
  f18 = Math_fround(f70 + Math_fround(f18 * f25));
  f17 = Math_fround(f37 + Math_fround(f17 * f25));
  f1 = Math_fround(f1 + Math_fround(Math_fround(f69 - f1) * f25));
  f69 = Math_fround(HEAPF32[i16 + 32 >> 2]);
  f37 = Math_fround(HEAPF32[i59 >> 2]);
  f69 = Math_fround(f69 - f37);
  f70 = Math_fround(HEAPF32[i16 + 36 >> 2]);
  f38 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f70 - f38);
  f71 = Math_fround(HEAPF32[i16 + 40 >> 2]);
  f67 = Math_fround(HEAPF32[i61 >> 2]);
  f71 = Math_fround(f71 - f67);
  f68 = Math_fround(HEAPF32[i16 + 44 >> 2]);
  f72 = Math_fround(HEAPF32[i62 >> 2]);
  f69 = Math_fround(f37 + Math_fround(f69 * f25));
  f70 = Math_fround(f38 + Math_fround(f70 * f25));
  f71 = Math_fround(f67 + Math_fround(f71 * f25));
  f72 = Math_fround(f72 + Math_fround(Math_fround(f68 - f72) * f25));
  HEAPF32[i63 >> 2] = f23;
  HEAPF32[i52 >> 2] = f22;
  HEAPF32[i53 >> 2] = f21;
  HEAPF32[i54 >> 2] = f20;
  HEAPF32[i35 >> 2] = f19;
  HEAPF32[i56 >> 2] = f18;
  HEAPF32[i57 >> 2] = f17;
  HEAPF32[i58 >> 2] = f1;
  HEAPF32[i34 >> 2] = f69;
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i61 >> 2] = f71;
  HEAPF32[i62 >> 2] = f72;
 }
 if (f29 > Math_fround(0.0)) {
  f30 = Math_fround(HEAPF32[i26 >> 2]);
  f78 = Math_fround(f30 * f30);
  i40 = i26 + 4 | 0;
  f31 = Math_fround(HEAPF32[i40 >> 2]);
  f76 = Math_fround(f31 * f31);
  i41 = i26 + 8 | 0;
  f32 = Math_fround(HEAPF32[i41 >> 2]);
  f79 = Math_fround(f32 * f32);
  i42 = i26 + 12 | 0;
  f36 = Math_fround(HEAPF32[i42 >> 2]);
  f73 = Math_fround(f36 * f36);
  i43 = i26 + 16 | 0;
  f37 = Math_fround(HEAPF32[i43 >> 2]);
  f71 = Math_fround(f37 * f37);
  i44 = i26 + 20 | 0;
  f38 = Math_fround(HEAPF32[i44 >> 2]);
  f70 = Math_fround(f38 * f38);
  i45 = i26 + 24 | 0;
  f67 = Math_fround(HEAPF32[i45 >> 2]);
  f69 = Math_fround(f67 * f67);
  i46 = i26 + 28 | 0;
  f68 = Math_fround(HEAPF32[i46 >> 2]);
  f71 = Math_fround(f78 + f71);
  f70 = Math_fround(f76 + f70);
  f69 = Math_fround(f79 + f69);
  f73 = Math_fround(f73 + Math_fround(f68 * f68));
  i47 = i26 + 32 | 0;
  f79 = Math_fround(HEAPF32[i47 >> 2]);
  f76 = Math_fround(f79 * f79);
  i48 = i26 + 36 | 0;
  f78 = Math_fround(HEAPF32[i48 >> 2]);
  f75 = Math_fround(f78 * f78);
  i49 = i26 + 40 | 0;
  f77 = Math_fround(HEAPF32[i49 >> 2]);
  f74 = Math_fround(f77 * f77);
  i50 = i26 + 44 | 0;
  f72 = Math_fround(HEAPF32[i50 >> 2]);
  f76 = Math_fround(f71 + f76);
  f75 = Math_fround(f70 + f75);
  f74 = Math_fround(f69 + f74);
  f73 = Math_fround(f73 + Math_fround(f72 * f72));
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f75))));
  f71 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f74))));
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f73))));
  f30 = Math_fround(f30 * f69);
  f31 = Math_fround(f31 * f70);
  f32 = Math_fround(f32 * f71);
  f36 = Math_fround(f36 * f25);
  f37 = Math_fround(f37 * f69);
  f38 = Math_fround(f38 * f70);
  f67 = Math_fround(f67 * f71);
  f68 = Math_fround(f68 * f25);
  f69 = Math_fround(f79 * f69);
  f70 = Math_fround(f78 * f70);
  f71 = Math_fround(f77 * f71);
  f25 = Math_fround(f72 * f25);
  i15 = f76 > Math_fround(9.99999974e-06);
  i16 = f75 > Math_fround(9.99999974e-06);
  i24 = f74 > Math_fround(9.99999974e-06);
  i39 = f73 > Math_fround(9.99999974e-06);
  f30 = Math_fround((i15 ? f30 : Math_fround(1.0)) - f23);
  f31 = Math_fround((i16 ? f31 : Math_fround(1.0)) - f22);
  f32 = Math_fround((i24 ? f32 : Math_fround(1.0)) - f21);
  f30 = Math_fround(f23 + Math_fround(f30 * f29));
  f31 = Math_fround(f22 + Math_fround(f31 * f29));
  f32 = Math_fround(f21 + Math_fround(f32 * f29));
  f36 = Math_fround(f20 + Math_fround(Math_fround((i39 ? f36 : Math_fround(1.0)) - f20) * f29));
  f37 = Math_fround((i15 ? f37 : Math_fround(0.0)) - f19);
  f38 = Math_fround((i16 ? f38 : Math_fround(0.0)) - f18);
  f67 = Math_fround((i24 ? f67 : Math_fround(0.0)) - f17);
  f37 = Math_fround(f19 + Math_fround(f37 * f29));
  f38 = Math_fround(f18 + Math_fround(f38 * f29));
  f67 = Math_fround(f17 + Math_fround(f67 * f29));
  f68 = Math_fround(f1 + Math_fround(Math_fround((i39 ? f68 : Math_fround(0.0)) - f1) * f29));
  f69 = i15 ? f69 : Math_fround(0.0);
  f21 = Math_fround(HEAPF32[i59 >> 2]);
  f69 = Math_fround(f69 - f21);
  f70 = i16 ? f70 : Math_fround(0.0);
  f22 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f70 - f22);
  f71 = i24 ? f71 : Math_fround(0.0);
  f23 = Math_fround(HEAPF32[i61 >> 2]);
  f71 = Math_fround(f71 - f23);
  f25 = i39 ? f25 : Math_fround(0.0);
  f1 = Math_fround(HEAPF32[i62 >> 2]);
  f69 = Math_fround(f21 + Math_fround(f69 * f29));
  f70 = Math_fround(f22 + Math_fround(f70 * f29));
  f71 = Math_fround(f23 + Math_fround(f71 * f29));
  f1 = Math_fround(f1 + Math_fround(Math_fround(f25 - f1) * f29));
  HEAPF32[i63 >> 2] = f30;
  HEAPF32[i52 >> 2] = f31;
  HEAPF32[i53 >> 2] = f32;
  HEAPF32[i54 >> 2] = f36;
  HEAPF32[i35 >> 2] = f37;
  HEAPF32[i56 >> 2] = f38;
  HEAPF32[i57 >> 2] = f67;
  HEAPF32[i58 >> 2] = f68;
  HEAPF32[i34 >> 2] = f69;
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i61 >> 2] = f71;
  HEAPF32[i62 >> 2] = f1;
  i39 = i26;
  f1 = f72;
 } else {
  i24 = i26 + 44 | 0;
  i40 = i26 + 4 | 0;
  i41 = i26 + 8 | 0;
  i42 = i26 + 12 | 0;
  i43 = i26 + 16 | 0;
  i44 = i26 + 20 | 0;
  i45 = i26 + 24 | 0;
  i46 = i26 + 28 | 0;
  i47 = i26 + 32 | 0;
  i48 = i26 + 36 | 0;
  i49 = i26 + 40 | 0;
  i50 = i24;
  i39 = i26;
  f1 = Math_fround(HEAPF32[i24 >> 2]);
 }
 f19 = Math_fround(HEAPF32[i28 >> 2]);
 f21 = Math_fround(f19 * Math_fround(HEAPF32[i39 >> 2]));
 f20 = Math_fround(f19 * Math_fround(HEAPF32[i40 >> 2]));
 f17 = Math_fround(f19 * Math_fround(HEAPF32[i41 >> 2]));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i42 >> 2]));
 HEAPF32[i39 >> 2] = f21;
 HEAPF32[i40 >> 2] = f20;
 HEAPF32[i41 >> 2] = f17;
 HEAPF32[i42 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f17 = Math_fround(f19 * Math_fround(HEAPF32[i43 >> 2]));
 f20 = Math_fround(f19 * Math_fround(HEAPF32[i44 >> 2]));
 f21 = Math_fround(f19 * Math_fround(HEAPF32[i45 >> 2]));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i46 >> 2]));
 HEAPF32[i43 >> 2] = f17;
 HEAPF32[i44 >> 2] = f20;
 HEAPF32[i45 >> 2] = f21;
 HEAPF32[i46 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f21 = Math_fround(f19 * Math_fround(HEAPF32[i47 >> 2]));
 f20 = Math_fround(f19 * Math_fround(HEAPF32[i48 >> 2]));
 f17 = Math_fround(f19 * Math_fround(HEAPF32[i49 >> 2]));
 f19 = Math_fround(f19 * f1);
 HEAPF32[i47 >> 2] = f21;
 HEAPF32[i48 >> 2] = f20;
 HEAPF32[i49 >> 2] = f17;
 HEAPF32[i50 >> 2] = f19;
 i24 = i64 + 60 | 0;
 i26 = (HEAP32[i24 >> 2] | 0) + (i65 << 2) | 0;
 f19 = Math_fround(HEAPF32[i26 >> 2]);
 f17 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 i26 = i64 + 80 | 0;
 i28 = (HEAP32[i26 >> 2] | 0) + (i65 << 2) | 0;
 f22 = Math_fround(HEAPF32[i28 >> 2]);
 f37 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f80 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f83 = Math_fround(HEAPF32[i28 + 12 >> 2]);
 i28 = i64 + 100 | 0;
 i6 = (HEAP32[i28 >> 2] | 0) + (i65 << 2) | 0;
 f76 = Math_fround(HEAPF32[i6 >> 2]);
 f77 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f78 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f79 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f76 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f22 * f22)) + Math_fround(f76 * f76))));
 f77 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f37 * f37)) + Math_fround(f77 * f77))));
 f78 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f80 * f80)) + Math_fround(f78 * f78))));
 f79 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f83 * f83)) + Math_fround(f79 * f79))));
 f83 = Math_fround(f76 * Math_fround(HEAPF32[i63 >> 2]));
 f21 = Math_fround(f77 * Math_fround(HEAPF32[i52 >> 2]));
 f80 = Math_fround(f78 * Math_fround(HEAPF32[i53 >> 2]));
 f20 = Math_fround(f79 * Math_fround(HEAPF32[i54 >> 2]));
 f37 = Math_fround(f76 * Math_fround(HEAPF32[i55 >> 2]));
 f17 = Math_fround(f77 * Math_fround(HEAPF32[i56 >> 2]));
 f22 = Math_fround(f78 * Math_fround(HEAPF32[i57 >> 2]));
 f19 = Math_fround(f79 * Math_fround(HEAPF32[i58 >> 2]));
 f76 = Math_fround(f76 * Math_fround(HEAPF32[i59 >> 2]));
 f77 = Math_fround(f77 * Math_fround(HEAPF32[i60 >> 2]));
 f78 = Math_fround(f78 * Math_fround(HEAPF32[i61 >> 2]));
 f79 = Math_fround(f79 * Math_fround(HEAPF32[i62 >> 2]));
 f36 = Math_fround(HEAPF32[i27 >> 2]);
 f68 = Math_fround(f83 * f36);
 f69 = Math_fround(f21 * f36);
 f70 = Math_fround(f80 * f36);
 f71 = Math_fround(f20 * f36);
 f29 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f68 = Math_fround(f68 + Math_fround(f37 * f29));
 f69 = Math_fround(f69 + Math_fround(f17 * f29));
 f70 = Math_fround(f70 + Math_fround(f22 * f29));
 f71 = Math_fround(f71 + Math_fround(f19 * f29));
 f25 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f68 = Math_fround(f68 + Math_fround(f76 * f25));
 f69 = Math_fround(f69 + Math_fround(f77 * f25));
 f70 = Math_fround(f70 + Math_fround(f78 * f25));
 f71 = Math_fround(f71 + Math_fround(f79 * f25));
 f87 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f72 = Math_fround(f83 * f87);
 f73 = Math_fround(f21 * f87);
 f74 = Math_fround(f80 * f87);
 f75 = Math_fround(f20 * f87);
 f86 = Math_fround(HEAPF32[i27 + 16 >> 2]);
 f72 = Math_fround(f72 + Math_fround(f37 * f86));
 f73 = Math_fround(f73 + Math_fround(f17 * f86));
 f74 = Math_fround(f74 + Math_fround(f22 * f86));
 f75 = Math_fround(f75 + Math_fround(f19 * f86));
 f32 = Math_fround(HEAPF32[i27 + 28 >> 2]);
 f72 = Math_fround(f72 + Math_fround(f76 * f32));
 f73 = Math_fround(f73 + Math_fround(f77 * f32));
 f74 = Math_fround(f74 + Math_fround(f78 * f32));
 f75 = Math_fround(f75 + Math_fround(f79 * f32));
 f82 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f83 = Math_fround(f83 * f82);
 f21 = Math_fround(f21 * f82);
 f80 = Math_fround(f80 * f82);
 f20 = Math_fround(f20 * f82);
 f84 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f37 = Math_fround(f83 + Math_fround(f37 * f84));
 f17 = Math_fround(f21 + Math_fround(f17 * f84));
 f22 = Math_fround(f80 + Math_fround(f22 * f84));
 f19 = Math_fround(f20 + Math_fround(f19 * f84));
 f20 = Math_fround(HEAPF32[i27 + 32 >> 2]);
 f76 = Math_fround(f37 + Math_fround(f76 * f20));
 f77 = Math_fround(f17 + Math_fround(f77 * f20));
 f78 = Math_fround(f22 + Math_fround(f78 * f20));
 f79 = Math_fround(f19 + Math_fround(f79 * f20));
 f19 = Math_fround(HEAPF32[i39 >> 2]);
 f22 = Math_fround(f36 * f19);
 f17 = Math_fround(HEAPF32[i40 >> 2]);
 f37 = Math_fround(f36 * f17);
 f80 = Math_fround(HEAPF32[i41 >> 2]);
 f21 = Math_fround(f36 * f80);
 f83 = Math_fround(HEAPF32[i42 >> 2]);
 f36 = Math_fround(f36 * f83);
 f18 = Math_fround(HEAPF32[i43 >> 2]);
 f88 = Math_fround(f29 * f18);
 f1 = Math_fround(HEAPF32[i44 >> 2]);
 f31 = Math_fround(f29 * f1);
 f81 = Math_fround(HEAPF32[i45 >> 2]);
 f30 = Math_fround(f29 * f81);
 f85 = Math_fround(HEAPF32[i46 >> 2]);
 f88 = Math_fround(f22 + f88);
 f31 = Math_fround(f37 + f31);
 f30 = Math_fround(f21 + f30);
 f29 = Math_fround(f36 + Math_fround(f29 * f85));
 f36 = Math_fround(HEAPF32[i47 >> 2]);
 f21 = Math_fround(f25 * f36);
 f37 = Math_fround(HEAPF32[i48 >> 2]);
 f22 = Math_fround(f25 * f37);
 f38 = Math_fround(HEAPF32[i49 >> 2]);
 f23 = Math_fround(f25 * f38);
 f67 = Math_fround(HEAPF32[i50 >> 2]);
 f21 = Math_fround(f88 + f21);
 f22 = Math_fround(f31 + f22);
 f23 = Math_fround(f30 + f23);
 f25 = Math_fround(f29 + Math_fround(f25 * f67));
 f29 = Math_fround(Math_fround(Math_fround(f87 * f19) + Math_fround(f86 * f18)) + Math_fround(f32 * f36));
 f30 = Math_fround(Math_fround(Math_fround(f87 * f17) + Math_fround(f86 * f1)) + Math_fround(f32 * f37));
 f31 = Math_fround(Math_fround(Math_fround(f87 * f80) + Math_fround(f86 * f81)) + Math_fround(f32 * f38));
 f32 = Math_fround(Math_fround(Math_fround(f87 * f83) + Math_fround(f86 * f85)) + Math_fround(f32 * f67));
 f36 = Math_fround(Math_fround(Math_fround(f82 * f19) + Math_fround(f84 * f18)) + Math_fround(f20 * f36));
 f37 = Math_fround(Math_fround(Math_fround(f82 * f17) + Math_fround(f84 * f1)) + Math_fround(f20 * f37));
 f38 = Math_fround(Math_fround(Math_fround(f82 * f80) + Math_fround(f84 * f81)) + Math_fround(f20 * f38));
 f67 = Math_fround(Math_fround(Math_fround(f82 * f83) + Math_fround(f84 * f85)) + Math_fround(f20 * f67));
 HEAPF32[i39 >> 2] = f21;
 HEAPF32[i40 >> 2] = f22;
 HEAPF32[i41 >> 2] = f23;
 HEAPF32[i42 >> 2] = f25;
 HEAPF32[i43 >> 2] = f29;
 HEAPF32[i44 >> 2] = f30;
 HEAPF32[i45 >> 2] = f31;
 HEAPF32[i46 >> 2] = f32;
 HEAPF32[i47 >> 2] = f36;
 HEAPF32[i48 >> 2] = f37;
 HEAPF32[i49 >> 2] = f38;
 HEAPF32[i50 >> 2] = f67;
 i6 = (HEAP32[i64 >> 2] | 0) + (i65 << 2) | 0;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i6 + 4 | 0;
 f85 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i6 + 8 | 0;
 f84 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i6 + 12 | 0;
 f83 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = (HEAP32[i64 + 20 >> 2] | 0) + (i65 << 2) | 0;
 f82 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i10 + 4 | 0;
 f81 = Math_fround(HEAPF32[i11 >> 2]);
 i12 = i10 + 8 | 0;
 f80 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i10 + 12 | 0;
 f1 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = (HEAP32[i64 + 40 >> 2] | 0) + (i65 << 2) | 0;
 f17 = Math_fround(HEAPF32[i14 >> 2]);
 i15 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i14 + 8 | 0;
 f19 = Math_fround(HEAPF32[i16 >> 2]);
 i27 = i14 + 12 | 0;
 f22 = Math_fround(f85 + f22);
 f23 = Math_fround(f84 + f23);
 f25 = Math_fround(f83 + f25);
 f29 = Math_fround(f82 + f29);
 f30 = Math_fround(f81 + f30);
 f31 = Math_fround(f80 + f31);
 f32 = Math_fround(f1 + f32);
 f36 = Math_fround(f17 + f36);
 f37 = Math_fround(f18 + f37);
 f38 = Math_fround(f19 + f38);
 f67 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f67);
 HEAPF32[i6 >> 2] = Math_fround(f20 + f21);
 HEAPF32[i7 >> 2] = f22;
 HEAPF32[i8 >> 2] = f23;
 HEAPF32[i9 >> 2] = f25;
 HEAPF32[i10 >> 2] = f29;
 HEAPF32[i11 >> 2] = f30;
 HEAPF32[i12 >> 2] = f31;
 HEAPF32[i13 >> 2] = f32;
 HEAPF32[i14 >> 2] = f36;
 HEAPF32[i15 >> 2] = f37;
 HEAPF32[i16 >> 2] = f38;
 HEAPF32[i27 >> 2] = f67;
 i27 = (HEAP32[i24 >> 2] | 0) + (i65 << 2) | 0;
 HEAPF32[i27 >> 2] = f68;
 HEAPF32[i27 + 4 >> 2] = f69;
 HEAPF32[i27 + 8 >> 2] = f70;
 HEAPF32[i27 + 12 >> 2] = f71;
 i27 = (HEAP32[i26 >> 2] | 0) + (i65 << 2) | 0;
 HEAPF32[i27 >> 2] = f72;
 HEAPF32[i27 + 4 >> 2] = f73;
 HEAPF32[i27 + 8 >> 2] = f74;
 HEAPF32[i27 + 12 >> 2] = f75;
 i28 = (HEAP32[i28 >> 2] | 0) + (i65 << 2) | 0;
 HEAPF32[i28 >> 2] = f76;
 HEAPF32[i28 + 4 >> 2] = f77;
 HEAPF32[i28 + 8 >> 2] = f78;
 HEAPF32[i28 + 12 >> 2] = f79;
 if (!((HEAP8[i64 + 870 >> 0] | 0) == 0 | i33 ^ 1)) {
  f29 = Math_fround(HEAPF32[i63 >> 2]);
  f30 = Math_fround(HEAPF32[i52 >> 2]);
  f31 = Math_fround(HEAPF32[i53 >> 2]);
  f32 = Math_fround(HEAPF32[i54 >> 2]);
  f19 = Math_fround(HEAPF32[i34 >> 2]);
  f21 = Math_fround(HEAPF32[i60 >> 2]);
  f23 = Math_fround(HEAPF32[i61 >> 2]);
  f25 = Math_fround(HEAPF32[i62 >> 2]);
  i9 = HEAP32[i35 >> 2] | 0;
  i10 = HEAP32[i56 >> 2] | 0;
  i11 = HEAP32[i57 >> 2] | 0;
  i12 = HEAP32[i58 >> 2] | 0;
  f85 = Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f19 * f19) + Math_fround(0.0)));
  f86 = Math_fround(Math_fround(f30 * f30) + Math_fround(Math_fround(f21 * f21) + Math_fround(0.0)));
  f87 = Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f23 * f23) + Math_fround(0.0)));
  f88 = Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f25 * f25) + Math_fround(0.0)));
  f82 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f85))));
  f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f86))));
  f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f87))));
  f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f88))));
  f1 = Math_fround(f19 * f82);
  f18 = Math_fround(f21 * f83);
  f20 = Math_fround(f23 * f84);
  f22 = Math_fround(f25 * f17);
  f82 = Math_fround(-Math_fround(f29 * f82));
  f83 = Math_fround(-Math_fround(f30 * f83));
  f84 = Math_fround(-Math_fround(f31 * f84));
  f17 = Math_fround(-Math_fround(f32 * f17));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f85 > Math_fround(9.99999974e-06);
  i6 = f86 > Math_fround(9.99999974e-06);
  i8 = f87 > Math_fround(9.99999974e-06);
  i2 = f88 > Math_fround(9.99999974e-06);
  i24 = i2 ? (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) : i12;
  f38 = i4 ? f1 : Math_fround(0.0);
  f84 = Math_fround(f19 * f38);
  f37 = i6 ? f18 : Math_fround(0.0);
  f83 = Math_fround(f21 * f37);
  f36 = i8 ? f20 : Math_fround(0.0);
  f82 = Math_fround(f23 * f36);
  f21 = i2 ? f22 : Math_fround(0.0);
  f1 = Math_fround(f25 * f21);
  f20 = (HEAP32[tempDoublePtr >> 2] = i4 ? i3 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f86 = Math_fround(f29 * f20);
  f19 = (HEAP32[tempDoublePtr >> 2] = i6 ? i5 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(f30 * f19);
  f18 = (HEAP32[tempDoublePtr >> 2] = i8 ? i7 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f88 = Math_fround(f31 * f18);
  f17 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f86 = Math_fround(f84 - f86);
  f87 = Math_fround(f83 - f87);
  f88 = Math_fround(f82 - f88);
  f1 = Math_fround(f1 - Math_fround(f32 * f17));
  i24 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  f82 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f83 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f84 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f85 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f86 = Math_fround(Math_abs(Math_fround(f82 / f86)));
  f87 = Math_fround(Math_abs(Math_fround(f83 / f87)));
  f88 = Math_fround(Math_abs(Math_fround(f84 / f88)));
  f1 = Math_fround(Math_abs(Math_fround(f85 / f1)));
  i6 = f86 > Math_fround(1.0);
  i7 = f87 > Math_fround(1.0);
  i8 = f88 > Math_fround(1.0);
  i9 = f1 > Math_fround(1.0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  f86 = Math_fround(Math_fround(1.0) / f86);
  f87 = Math_fround(Math_fround(1.0) / f87);
  f88 = Math_fround(Math_fround(1.0) / f88);
  f1 = Math_fround(Math_fround(1.0) / f1);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i13;
  f32 = (HEAP32[tempDoublePtr >> 2] = i6 ? i14 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f70 = Math_fround(f32 * f32);
  f71 = (HEAP32[tempDoublePtr >> 2] = i7 ? i15 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f75 = Math_fround(f71 * f71);
  f76 = (HEAP32[tempDoublePtr >> 2] = i8 ? i16 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f80 = Math_fround(f76 * f76);
  f81 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(f81 * f81);
  f67 = Math_fround(f70 * f70);
  f72 = Math_fround(f75 * f75);
  f77 = Math_fround(f80 * f80);
  f86 = Math_fround(f1 * f1);
  f68 = Math_fround(f70 * f67);
  f73 = Math_fround(f75 * f72);
  f78 = Math_fround(f80 * f77);
  f87 = Math_fround(f1 * f86);
  f69 = Math_fround(f70 * f68);
  f74 = Math_fround(f75 * f73);
  f79 = Math_fround(f80 * f78);
  f88 = Math_fround(f1 * f87);
  f82 = Math_fround(f70 * f69);
  f83 = Math_fround(f75 * f74);
  f84 = Math_fround(f80 * f79);
  f85 = Math_fround(f1 * f88);
  f82 = Math_fround(f32 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f70 * Math_fround(.333264589))) + Math_fround(f67 * Math_fround(.198815241))) - Math_fround(f68 * Math_fround(.13487266))) + Math_fround(f69 * Math_fround(.0838713571))) - Math_fround(f82 * Math_fround(.0370131433))) + Math_fround(Math_fround(f70 * f82) * Math_fround(.0078625083))));
  f83 = Math_fround(f71 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f75 * Math_fround(.333264589))) + Math_fround(f72 * Math_fround(.198815241))) - Math_fround(f73 * Math_fround(.13487266))) + Math_fround(f74 * Math_fround(.0838713571))) - Math_fround(f83 * Math_fround(.0370131433))) + Math_fround(Math_fround(f75 * f83) * Math_fround(.0078625083))));
  f84 = Math_fround(f76 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f80 * Math_fround(.333264589))) + Math_fround(f77 * Math_fround(.198815241))) - Math_fround(f78 * Math_fround(.13487266))) + Math_fround(f79 * Math_fround(.0838713571))) - Math_fround(f84 * Math_fround(.0370131433))) + Math_fround(Math_fround(f80 * f84) * Math_fround(.0078625083))));
  f85 = Math_fround(f81 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f1 * Math_fround(.333264589))) + Math_fround(f86 * Math_fround(.198815241))) - Math_fround(f87 * Math_fround(.13487266))) + Math_fround(f88 * Math_fround(.0838713571))) - Math_fround(f85 * Math_fround(.0370131433))) + Math_fround(Math_fround(f1 * f85) * Math_fround(.0078625083))));
  f1 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f82);
  f88 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f83);
  f87 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f84);
  f86 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f85);
  f82 = i6 ? f1 : f82;
  f83 = i7 ? f88 : f83;
  f84 = i8 ? f87 : f84;
  f85 = i9 ? f86 : f85;
  i13 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f82 = Math_fround(Math_fround(3.14159274) - f82);
  f83 = Math_fround(Math_fround(3.14159274) - f83);
  f84 = Math_fround(Math_fround(3.14159274) - f84);
  f85 = Math_fround(Math_fround(3.14159274) - f85);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = i24 >> 31;
  i9 = i26 >> 31;
  i6 = i27 >> 31;
  i28 = i28 >> 31;
  i5 = ((HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0) & i28 | i15 & ~i28) ^ i5 & -2147483648;
  i28 = (HEAP32[i64 + 300 >> 2] | 0) + (i65 << 2) | 0;
  f85 = Math_fround(HEAPF32[i28 >> 2]);
  i27 = i28 + 4 | 0;
  f84 = Math_fround(HEAPF32[i27 >> 2]);
  i26 = i28 + 8 | 0;
  f83 = Math_fround(HEAPF32[i26 >> 2]);
  i24 = i28 + 12 | 0;
  f82 = Math_fround(HEAPF32[i24 >> 2]);
  f85 = Math_fround(f85 + (HEAP32[tempDoublePtr >> 2] = (i14 & i12 | i13 & ~i12) ^ i2 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f84 = Math_fround(f84 + (HEAP32[tempDoublePtr >> 2] = (i11 & i9 | i10 & ~i9) ^ i3 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f83 = Math_fround(f83 + (HEAP32[tempDoublePtr >> 2] = (i8 & i6 | i7 & ~i6) ^ i4 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f82 = Math_fround(f82 + (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i28 >> 2] = f85;
  HEAPF32[i27 >> 2] = f84;
  HEAPF32[i26 >> 2] = f83;
  HEAPF32[i24 >> 2] = f82;
  f82 = Math_fround(-f20);
  f83 = Math_fround(-f19);
  f84 = Math_fround(-f18);
  f85 = Math_fround(-f17);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f86 = Math_fround(-f38);
  f87 = Math_fround(-f37);
  f88 = Math_fround(-f36);
  f1 = Math_fround(-f21);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  f86 = Math_fround(Math_abs(Math_fround(f82 / f86)));
  f87 = Math_fround(Math_abs(Math_fround(f83 / f87)));
  f88 = Math_fround(Math_abs(Math_fround(f84 / f88)));
  f1 = Math_fround(Math_abs(Math_fround(f85 / f1)));
  i6 = f86 > Math_fround(1.0);
  i7 = f87 > Math_fround(1.0);
  i8 = f88 > Math_fround(1.0);
  i9 = f1 > Math_fround(1.0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  f86 = Math_fround(Math_fround(1.0) / f86);
  f87 = Math_fround(Math_fround(1.0) / f87);
  f88 = Math_fround(Math_fround(1.0) / f88);
  f1 = Math_fround(Math_fround(1.0) / f1);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i13;
  f37 = (HEAP32[tempDoublePtr >> 2] = i6 ? i14 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f69 = Math_fround(f37 * f37);
  f70 = (HEAP32[tempDoublePtr >> 2] = i7 ? i15 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f74 = Math_fround(f70 * f70);
  f75 = (HEAP32[tempDoublePtr >> 2] = i8 ? i16 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f79 = Math_fround(f75 * f75);
  f80 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = Math_fround(f80 * f80);
  f38 = Math_fround(f69 * f69);
  f71 = Math_fround(f74 * f74);
  f76 = Math_fround(f79 * f79);
  f84 = Math_fround(f81 * f81);
  f67 = Math_fround(f69 * f38);
  f72 = Math_fround(f74 * f71);
  f77 = Math_fround(f79 * f76);
  f83 = Math_fround(f81 * f84);
  f68 = Math_fround(f69 * f67);
  f73 = Math_fround(f74 * f72);
  f78 = Math_fround(f79 * f77);
  f82 = Math_fround(f81 * f83);
  f88 = Math_fround(f69 * f68);
  f87 = Math_fround(f74 * f73);
  f86 = Math_fround(f79 * f78);
  f85 = Math_fround(f81 * f82);
  f88 = Math_fround(f37 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f69 * Math_fround(.333264589))) + Math_fround(f38 * Math_fround(.198815241))) - Math_fround(f67 * Math_fround(.13487266))) + Math_fround(f68 * Math_fround(.0838713571))) - Math_fround(f88 * Math_fround(.0370131433))) + Math_fround(Math_fround(f69 * f88) * Math_fround(.0078625083))));
  f87 = Math_fround(f70 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f74 * Math_fround(.333264589))) + Math_fround(f71 * Math_fround(.198815241))) - Math_fround(f72 * Math_fround(.13487266))) + Math_fround(f73 * Math_fround(.0838713571))) - Math_fround(f87 * Math_fround(.0370131433))) + Math_fround(Math_fround(f74 * f87) * Math_fround(.0078625083))));
  f86 = Math_fround(f75 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f79 * Math_fround(.333264589))) + Math_fround(f76 * Math_fround(.198815241))) - Math_fround(f77 * Math_fround(.13487266))) + Math_fround(f78 * Math_fround(.0838713571))) - Math_fround(f86 * Math_fround(.0370131433))) + Math_fround(Math_fround(f79 * f86) * Math_fround(.0078625083))));
  f85 = Math_fround(f80 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(.999999463) - Math_fround(f81 * Math_fround(.333264589))) + Math_fround(f84 * Math_fround(.198815241))) - Math_fround(f83 * Math_fround(.13487266))) + Math_fround(f82 * Math_fround(.0838713571))) - Math_fround(f85 * Math_fround(.0370131433))) + Math_fround(Math_fround(f81 * f85) * Math_fround(.0078625083))));
  f81 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f88);
  f82 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f87);
  f83 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f86);
  f84 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 & -2147483648 | 1070141403, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f85);
  f88 = i6 ? f81 : f88;
  f87 = i7 ? f82 : f87;
  f86 = i8 ? f83 : f86;
  f85 = i9 ? f84 : f85;
  i8 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f88 = Math_fround(Math_fround(3.14159274) - f88);
  f87 = Math_fround(Math_fround(3.14159274) - f87);
  f86 = Math_fround(Math_fround(3.14159274) - f86);
  f85 = Math_fround(Math_fround(3.14159274) - f85);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = i2 >> 31;
  i12 = i3 >> 31;
  i15 = i4 >> 31;
  i16 = i5 >> 31;
  i16 = ((HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0) & i16 | i33 & ~i16) ^ i28 & -2147483648;
  i28 = (HEAP32[i64 + 320 >> 2] | 0) + (i65 << 2) | 0;
  f85 = Math_fround(HEAPF32[i28 >> 2]);
  i33 = i28 + 4 | 0;
  f86 = Math_fround(HEAPF32[i33 >> 2]);
  i34 = i28 + 8 | 0;
  f87 = Math_fround(HEAPF32[i34 >> 2]);
  i35 = i28 + 12 | 0;
  f88 = Math_fround(HEAPF32[i35 >> 2]);
  f85 = Math_fround(f85 + (HEAP32[tempDoublePtr >> 2] = (i7 & i9 | i8 & ~i9) ^ i24 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f86 = Math_fround(f86 + (HEAP32[tempDoublePtr >> 2] = (i10 & i12 | i11 & ~i12) ^ i26 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f87 = Math_fround(f87 + (HEAP32[tempDoublePtr >> 2] = (i13 & i15 | i14 & ~i15) ^ i27 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f88 = Math_fround(f88 + (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i28 >> 2] = f85;
  HEAPF32[i33 >> 2] = f86;
  HEAPF32[i34 >> 2] = f87;
  HEAPF32[i35 >> 2] = f88;
 }
 if ((HEAP8[i64 + 868 >> 0] | 0) == 0 | i51 ^ 1) {
  STACKTOP = i66;
  return;
 }
 f78 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) * Math_fround(0.0));
 f79 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) * Math_fround(0.0));
 f80 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) * Math_fround(0.0));
 f81 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) * Math_fround(0.0));
 f82 = Math_fround(HEAPF32[i55 >> 2]);
 f83 = Math_fround(HEAPF32[i56 >> 2]);
 f84 = Math_fround(HEAPF32[i57 >> 2]);
 f1 = Math_fround(HEAPF32[i58 >> 2]);
 f74 = Math_fround(f78 - f82);
 f75 = Math_fround(f79 - f83);
 f76 = Math_fround(f80 - f84);
 f77 = Math_fround(f81 - f1);
 f70 = Math_fround(HEAPF32[i63 >> 2]);
 f71 = Math_fround(HEAPF32[i52 >> 2]);
 f72 = Math_fround(HEAPF32[i53 >> 2]);
 f73 = Math_fround(HEAPF32[i54 >> 2]);
 f78 = Math_fround(f70 - f78);
 f79 = Math_fround(f71 - f79);
 f80 = Math_fround(f72 - f80);
 f81 = Math_fround(f73 - f81);
 f70 = Math_fround(Math_fround(f82 * Math_fround(0.0)) - Math_fround(f70 * Math_fround(0.0)));
 f71 = Math_fround(Math_fround(f83 * Math_fround(0.0)) - Math_fround(f71 * Math_fround(0.0)));
 f72 = Math_fround(Math_fround(f84 * Math_fround(0.0)) - Math_fround(f72 * Math_fround(0.0)));
 f73 = Math_fround(Math_fround(f1 * Math_fround(0.0)) - Math_fround(f73 * Math_fround(0.0)));
 f1 = Math_fround(HEAPF32[i47 >> 2]);
 f84 = Math_fround(HEAPF32[i48 >> 2]);
 f83 = Math_fround(HEAPF32[i49 >> 2]);
 f82 = Math_fround(HEAPF32[i50 >> 2]);
 f31 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) * Math_fround(0.0));
 f32 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) * Math_fround(0.0));
 f36 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * Math_fround(0.0));
 f37 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) * Math_fround(0.0));
 f38 = Math_fround(f1 - f31);
 f67 = Math_fround(f84 - f32);
 f68 = Math_fround(f83 - f36);
 f69 = Math_fround(f82 - f37);
 f88 = Math_fround(HEAPF32[i39 >> 2]);
 f25 = Math_fround(f88 * Math_fround(0.0));
 f87 = Math_fround(HEAPF32[i40 >> 2]);
 f29 = Math_fround(f87 * Math_fround(0.0));
 f86 = Math_fround(HEAPF32[i41 >> 2]);
 f30 = Math_fround(f86 * Math_fround(0.0));
 f85 = Math_fround(HEAPF32[i42 >> 2]);
 f1 = Math_fround(f25 - Math_fround(f1 * Math_fround(0.0)));
 f84 = Math_fround(f29 - Math_fround(f84 * Math_fround(0.0)));
 f83 = Math_fround(f30 - Math_fround(f83 * Math_fround(0.0)));
 f82 = Math_fround(Math_fround(f85 * Math_fround(0.0)) - Math_fround(f82 * Math_fround(0.0)));
 f88 = Math_fround(f31 - f88);
 f87 = Math_fround(f32 - f87);
 f86 = Math_fround(f36 - f86);
 f85 = Math_fround(f37 - f85);
 i5 = Math_fround(Math_fround(Math_fround(f74 * f74) + Math_fround(f78 * f78)) + Math_fround(f70 * f70)) <= Math_fround(.00999999977);
 i4 = Math_fround(Math_fround(Math_fround(f75 * f75) + Math_fround(f79 * f79)) + Math_fround(f71 * f71)) <= Math_fround(.00999999977);
 i3 = Math_fround(Math_fround(Math_fround(f76 * f76) + Math_fround(f80 * f80)) + Math_fround(f72 * f72)) <= Math_fround(.00999999977);
 i2 = Math_fround(Math_fround(Math_fround(f77 * f77) + Math_fround(f81 * f81)) + Math_fround(f73 * f73)) <= Math_fround(.00999999977);
 f74 = i5 ? f38 : f74;
 f75 = i4 ? f67 : f75;
 f76 = i3 ? f68 : f76;
 f77 = i2 ? f69 : f77;
 f78 = i5 ? f1 : f78;
 f79 = i4 ? f84 : f79;
 f80 = i3 ? f83 : f80;
 f81 = i2 ? f82 : f81;
 f70 = i5 ? f88 : f70;
 f71 = i4 ? f87 : f71;
 f72 = i3 ? f86 : f72;
 f73 = i2 ? f85 : f73;
 f85 = Math_fround(Math_fround(f70 * f70) + Math_fround(Math_fround(f74 * f74) + Math_fround(f78 * f78)));
 f86 = Math_fround(Math_fround(f71 * f71) + Math_fround(Math_fround(f75 * f75) + Math_fround(f79 * f79)));
 f87 = Math_fround(Math_fround(f72 * f72) + Math_fround(Math_fround(f76 * f76) + Math_fround(f80 * f80)));
 f88 = Math_fround(Math_fround(f73 * f73) + Math_fround(Math_fround(f77 * f77) + Math_fround(f81 * f81)));
 f82 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f85))));
 f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f86))));
 f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f87))));
 f1 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f88))));
 f74 = Math_fround(f74 * f82);
 f75 = Math_fround(f75 * f83);
 f76 = Math_fround(f76 * f84);
 f77 = Math_fround(f77 * f1);
 f78 = Math_fround(f78 * f82);
 f79 = Math_fround(f79 * f83);
 f80 = Math_fround(f80 * f84);
 f81 = Math_fround(f81 * f1);
 f82 = Math_fround(f70 * f82);
 f83 = Math_fround(f71 * f83);
 f84 = Math_fround(f72 * f84);
 f1 = Math_fround(f73 * f1);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f76, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = f85 <= Math_fround(.00999999977);
 i14 = f86 <= Math_fround(.00999999977);
 i15 = f87 <= Math_fround(.00999999977);
 i16 = f88 <= Math_fround(.00999999977);
 i63 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i62 = (HEAP32[i64 + 240 >> 2] | 0) + (i65 << 2) | 0;
 HEAP32[i62 >> 2] = i13 ? 0 : i2;
 HEAP32[i62 + 4 >> 2] = i14 ? 0 : i3;
 HEAP32[i62 + 8 >> 2] = i15 ? 0 : i4;
 HEAP32[i62 + 12 >> 2] = i16 ? 0 : i5;
 i62 = (HEAP32[i64 + 260 >> 2] | 0) + (i65 << 2) | 0;
 HEAP32[i62 >> 2] = i13 ? 1065353216 : i6;
 HEAP32[i62 + 4 >> 2] = i14 ? 1065353216 : i7;
 HEAP32[i62 + 8 >> 2] = i15 ? 1065353216 : i8;
 HEAP32[i62 + 12 >> 2] = i16 ? 1065353216 : i9;
 i65 = (HEAP32[i64 + 280 >> 2] | 0) + (i65 << 2) | 0;
 HEAP32[i65 >> 2] = i13 ? 0 : i10;
 HEAP32[i65 + 4 >> 2] = i14 ? 0 : i11;
 HEAP32[i65 + 8 >> 2] = i15 ? 0 : i12;
 HEAP32[i65 + 12 >> 2] = i63;
 STACKTOP = i66;
 return;
}

function __Z25InitComponentRequirementsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 44 | 0;
 i9 = i17 + 40 | 0;
 i10 = i17 + 36 | 0;
 i11 = i17 + 32 | 0;
 i15 = i17 + 12 | 0;
 i16 = i17;
 if (HEAP8[gb + 1546592 >> 0] | 0) {
  STACKTOP = i17;
  return;
 }
 HEAP8[gb + 1546592 >> 0] = 1;
 i3 = HEAP32[gb + 1162544 >> 2] | 0;
 i1 = i3 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i3, HEAP32[i1 >> 2] | 0);
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[gb + 1162548 >> 2] | 0;
 i3 = i1 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 i3 = HEAP32[gb + 1162552 >> 2] | 0;
 i1 = i3 + 4 | 0;
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i3, HEAP32[i1 >> 2] | 0);
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = gb + 64016 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 i4 = i15 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i14 = i15 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i15 + 4 >> 2] = i3;
 HEAP32[i15 + 8 >> 2] = i1;
 __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(2, i15, 1);
 i1 = HEAP32[i15 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + (i8 << 2) | 0;
 i6 = i16 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i16 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i12;
 if (i8 | 0) {
  i8 = i12;
  do {
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i8;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   i3 = __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEESB_RKT_(i16, i13, i9, i11) | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    i2 = __Znwj(20) | 0;
    HEAP32[i2 + 16 >> 2] = HEAP32[i11 >> 2];
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i2;
    i4 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i16 >> 2] = i4;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i2);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(25, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(33, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(12, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(15, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(76, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(198, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(199, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(20, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(108, 4);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(33, 102);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(102, 33);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(212, 4);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(33, 212);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(23, 212);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(212, 33);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(212, 23);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(54, 4);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(54, 50);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(54, 53);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(54, 230);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(56, 50);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(56, 53);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(56, 230);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(57, 50);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(57, 53);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(57, 230);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(75, 50);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(75, 53);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(75, 230);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(50, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(53, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(230, 4);
 i6 = HEAP32[gb + 1162552 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 231) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 14;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 231) {
     i7 = 19;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 18;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 14) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 18) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 19) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 231;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 232) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 28;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 232) {
     i7 = 33;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 32;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 28) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 32) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 33) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 232;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 255) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 42;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 255) {
     i7 = 47;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 46;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 42) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 46) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 47) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 256) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 56;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 256) {
     i7 = 61;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 60;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 56) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 60) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 61) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 256;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 233) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 70;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 233) {
     i7 = 75;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 74;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 70) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 74) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 75) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 233;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 254) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 84;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 254) {
     i7 = 89;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 88;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 84) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 88) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 89) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 254;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 257) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 98;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 257) {
     i7 = 103;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 102;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 98) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 102) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 103) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 257;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 234) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 112;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 234) {
     i7 = 117;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 116;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 112) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 116) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 117) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 234;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 235) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 126;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 235) {
     i7 = 131;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 130;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 126) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 130) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 131) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 235;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > 247) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i7 = 140;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) == 247) {
     i7 = 145;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i7 = 144;
     break;
    } else i1 = i2;
   }
  }
  if ((i7 | 0) == 140) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i7 | 0) == 144) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i7 | 0) == 145) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 247;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i11 = i6 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(230, 50);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(247, 50);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(50, 54);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(50, 56);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(50, 57);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(50, 75);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(53, 54);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(53, 56);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(53, 57);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(53, 75);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(230, 54);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(230, 56);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(230, 57);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(230, 75);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(246, 54);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(246, 56);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(246, 57);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(248, 54);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(248, 56);
 __ZL23AddConflictingClassIMPL11ClassIDTypeS_(248, 248);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(133, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(82, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(81, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(167, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(169, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(168, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(170, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(164, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(165, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(166, 180);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(102, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(102, 23);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(56, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(57, 54);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(75, 54);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(124, 20);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(92, 20);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(122, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(223, 224);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(183, 4);
 __ZL20AddRequiredClassIMPL11ClassIDTypeS_(183, 137);
 i6 = HEAP32[gb + 1162552 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 59) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 154;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 59) {
     i7 = 159;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 158;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 154) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 158) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 159) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 59;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 138) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 168;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 138) {
     i7 = 173;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 172;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 168) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 172) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 173) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 138;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 144) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 182;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 144) {
     i7 = 187;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 186;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 182) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 186) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 187) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 144;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 153) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 196;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 153) {
     i7 = 201;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 200;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 196) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 200) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 201) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 153;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 145) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 210;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 145) {
     i7 = 215;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 214;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 210) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 214) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 215) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 145;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 82) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 224;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 82) {
     i7 = 229;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 228;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 224) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 228) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 229) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 82;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 191) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 238;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 191) {
     i7 = 243;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 242;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 238) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 242) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 243) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 191;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 45) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 252;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 45) {
     i7 = 257;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 256;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 252) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 256) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 257) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 45;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 114) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 266;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 114) {
     i7 = 271;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 270;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 266) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 270) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 271) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 114;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 148) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 280;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 148) {
     i7 = 285;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 284;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 280) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 284) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 285) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 148;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 65) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 294;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 65) {
     i7 = 299;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 298;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 294) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 298) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 299) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 65;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 135) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 308;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 135) {
     i7 = 313;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 312;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 308) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 312) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 313) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 135;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 136) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 322;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 136) {
     i7 = 327;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 326;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 322) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 326) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 327) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 136;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 64) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 336;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 64) {
     i7 = 341;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 340;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 336) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 340) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 341) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 64;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 58) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 350;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 58) {
     i7 = 355;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 354;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 350) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 354) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 355) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 58;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 61) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 364;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 61) {
     i7 = 369;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 368;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 364) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 368) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 369) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 61;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 68) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 378;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 68) {
     i7 = 383;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 382;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 378) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 382) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 383) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 68;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > 60) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 392;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) == 60) {
     i7 = 397;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 396;
     break;
    } else i2 = i3;
   }
  }
  if ((i7 | 0) == 392) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i2;
   break;
  } else if ((i7 | 0) == 396) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i4;
   break;
  } else if ((i7 | 0) == 397) {
   HEAP32[i13 >> 2] = i2;
   i5 = i2;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 60;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1162552 >> 2] | 0;
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 do if (!i1) {
  HEAP32[i13 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > 70) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i7 = 406;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) == 70) {
     i7 = 411;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i7 = 410;
     break;
    } else i1 = i2;
   }
  }
  if ((i7 | 0) == 406) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i7 | 0) == 410) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i7 | 0) == 411) {
   HEAP32[i13 >> 2] = i1;
   i4 = i1;
   i3 = i13;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = 70;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i13 = i6 + 8 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 }
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i16, HEAP32[i12 >> 2] | 0);
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i15 + 4 | 0);
  HEAP32[i15 >> 2] = 0;
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx33setupFinalizeExtSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_16PxsSolverExtBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff(i8, i194, i195, i191, i192, i197, i11, i189, i190, i1, i2, f196, f193, f4, f6, f5, f7) {
 i8 = i8 | 0;
 i194 = i194 | 0;
 i195 = i195 | 0;
 i191 = i191 | 0;
 i192 = i192 | 0;
 i197 = i197 | 0;
 i11 = i11 | 0;
 i189 = i189 | 0;
 i190 = i190 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f196 = Math_fround(f196);
 f193 = Math_fround(f193);
 f4 = Math_fround(f4);
 f6 = Math_fround(f6);
 f5 = Math_fround(f5);
 f7 = Math_fround(f7);
 var f3 = f0, i9 = 0, i10 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, f162 = f0, f163 = f0, f164 = f0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i198 = 0, f199 = f0;
 i188 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i182 = i188 + 352 | 0;
 i185 = i188 + 320 | 0;
 i176 = i188 + 288 | 0;
 i177 = i188 + 256 | 0;
 i184 = i188 + 224 | 0;
 i187 = i188 + 192 | 0;
 i178 = i188 + 160 | 0;
 i179 = i188 + 128 | 0;
 i183 = i188 + 96 | 0;
 i186 = i188 + 64 | 0;
 i180 = i188 + 32 | 0;
 i181 = i188;
 if (!(HEAP32[i194 + 4096 >> 2] | 0)) {
  STACKTOP = i188;
  return;
 }
 i175 = i189 + 8 | 0;
 i1 = HEAP16[i175 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) i1 = (HEAP32[i189 + 4 >> 2] | 0) + 52 | 0; else {
  i174 = HEAP32[i189 >> 2] | 0;
  i1 = i174 + 128 + ((HEAPU16[i174 + 8 >> 1] | 0) * 80 | 0) + ((i1 & 65535) << 2) | 0;
 }
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i174 = i190 + 8 | 0;
 i1 = HEAP16[i174 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) i1 = (HEAP32[i190 + 4 >> 2] | 0) + 52 | 0; else {
  i169 = HEAP32[i190 >> 2] | 0;
  i1 = i169 + 128 + ((HEAPU16[i169 + 8 >> 1] | 0) * 80 | 0) + ((i1 & 65535) << 2) | 0;
 }
 f173 = Math_fround(HEAPF32[i1 >> 2]);
 f173 = f3 > f173 ? f3 : f173;
 f170 = Math_fround(HEAPF32[i8 + 84 >> 2]);
 f172 = Math_fround(f170 * f4);
 f162 = Math_fround(HEAPF32[i8 + 88 >> 2]);
 f171 = Math_fround(f162 * f5);
 f170 = Math_fround(f170 * f6);
 f162 = Math_fround(f162 * f7);
 f163 = Math_fround(HEAPF32[i8 + 92 >> 2]);
 f164 = Math_fround(f196 * Math_fround(.800000011));
 i165 = i8 + 22 | 0;
 i166 = (HEAP16[i165 >> 1] & 24) != 0;
 i167 = i195 + 4232 | 0;
 if (!(HEAP32[i167 >> 2] | 0)) {
  STACKTOP = i188;
  return;
 }
 i168 = i166 ? 112 : 80;
 i169 = i166 ? 128 : 96;
 i126 = i8 + 40 | 0;
 i47 = i169 << 1;
 i50 = i169 + 80 | 0;
 i127 = i191 + 12 | 0;
 i128 = i191 + 4 | 0;
 i129 = i191 + 8 | 0;
 i130 = i192 + 12 | 0;
 i131 = i192 + 4 | 0;
 i132 = i192 + 8 | 0;
 i133 = i191 + 16 | 0;
 i134 = i191 + 20 | 0;
 i135 = i191 + 24 | 0;
 i136 = i192 + 16 | 0;
 i137 = i192 + 20 | 0;
 i138 = i192 + 24 | 0;
 i139 = i178 + 4 | 0;
 i140 = i178 + 8 | 0;
 i141 = i178 + 12 | 0;
 i142 = i178 + 16 | 0;
 i143 = i178 + 20 | 0;
 i144 = i178 + 24 | 0;
 i145 = i178 + 28 | 0;
 i146 = i179 + 4 | 0;
 i147 = i179 + 8 | 0;
 i148 = i179 + 12 | 0;
 i149 = i179 + 16 | 0;
 i150 = i179 + 20 | 0;
 i151 = i179 + 24 | 0;
 i152 = i179 + 28 | 0;
 i153 = i184 + 16 | 0;
 i154 = i184 + 20 | 0;
 i155 = i184 + 24 | 0;
 i156 = i187 + 16 | 0;
 i157 = i187 + 20 | 0;
 i158 = i187 + 24 | 0;
 i159 = i184 + 4 | 0;
 i160 = i184 + 8 | 0;
 i76 = i187 + 4 | 0;
 i77 = i187 + 8 | 0;
 i78 = i180 + 4 | 0;
 i79 = i180 + 8 | 0;
 i80 = i180 + 12 | 0;
 i81 = i180 + 16 | 0;
 i82 = i180 + 20 | 0;
 i83 = i180 + 24 | 0;
 i84 = i180 + 28 | 0;
 i85 = i181 + 4 | 0;
 i86 = i181 + 8 | 0;
 i87 = i181 + 12 | 0;
 i88 = i181 + 16 | 0;
 i89 = i181 + 20 | 0;
 i90 = i181 + 24 | 0;
 i91 = i181 + 28 | 0;
 i53 = i169 | 4;
 i54 = i169 | 8;
 i55 = i169 | 12;
 i51 = i169 | 16;
 i56 = i169 | 20;
 i57 = i169 | 24;
 i58 = i169 | 28;
 i52 = i169 + 32 | 0;
 i59 = i169 + 36 | 0;
 i60 = i169 + 40 | 0;
 i61 = i169 + 44 | 0;
 i74 = i169 + 48 | 0;
 i92 = i183 + 16 | 0;
 i93 = i183 + 20 | 0;
 i94 = i183 + 24 | 0;
 i62 = i169 + 52 | 0;
 i63 = i169 + 56 | 0;
 i64 = i169 + 60 | 0;
 i75 = i169 + 64 | 0;
 i95 = i186 + 16 | 0;
 i96 = i186 + 20 | 0;
 i97 = i186 + 24 | 0;
 i65 = i169 + 68 | 0;
 i66 = i169 + 72 | 0;
 i67 = i169 + 76 | 0;
 i48 = i169 + 96 | 0;
 i98 = i183 + 4 | 0;
 i99 = i183 + 8 | 0;
 i68 = i169 + 100 | 0;
 i69 = i169 + 104 | 0;
 i70 = i169 + 108 | 0;
 i49 = i169 + 112 | 0;
 i100 = i186 + 4 | 0;
 i101 = i186 + 8 | 0;
 i71 = i169 + 116 | 0;
 i72 = i169 + 120 | 0;
 i73 = i169 + 124 | 0;
 i102 = i176 + 4 | 0;
 i103 = i176 + 8 | 0;
 i104 = i176 + 12 | 0;
 i105 = i176 + 16 | 0;
 i106 = i176 + 20 | 0;
 i107 = i176 + 24 | 0;
 i108 = i176 + 28 | 0;
 i109 = i177 + 4 | 0;
 i110 = i177 + 8 | 0;
 i111 = i177 + 12 | 0;
 i112 = i177 + 16 | 0;
 i113 = i177 + 20 | 0;
 i114 = i177 + 24 | 0;
 i115 = i177 + 28 | 0;
 i116 = i182 + 16 | 0;
 i117 = i182 + 20 | 0;
 i118 = i182 + 24 | 0;
 i119 = i185 + 16 | 0;
 i120 = i185 + 20 | 0;
 i121 = i185 + 24 | 0;
 i122 = i182 + 4 | 0;
 i123 = i182 + 8 | 0;
 i124 = i185 + 4 | 0;
 i125 = i185 + 8 | 0;
 i2 = 0;
 i161 = 0;
 while (1) {
  i8 = HEAP32[i195 + 3840 + (i161 << 2) >> 2] | 0;
  if (!i8) i1 = i11; else {
   i46 = i195 + 3968 + (i161 << 2) | 0;
   i33 = HEAPU16[i195 + ((HEAP32[i46 >> 2] | 0) * 12 | 0) >> 1] | 0;
   f27 = Math_fround(HEAPF32[i194 + (i33 << 6) + 60 >> 2]);
   i9 = HEAP32[i194 + (i33 << 6) + 44 >> 2] | 0;
   i10 = HEAP32[i194 + (i33 << 6) + 56 >> 2] | 0;
   i1 = i11 + 32 | 0;
   i33 = (HEAP32[i194 + (i33 << 6) + 52 >> 2] & 1 | 0) == 0;
   HEAP8[i11 + 5 >> 0] = i8;
   if (i33) i8 = HEAPU16[i195 + 768 + (i161 * 96 | 0) + 16 >> 1] << 1; else i8 = 0;
   i8 = i8 & 255;
   HEAP8[i11 + 6 >> 0] = i8;
   if (i166) i8 = 3; else if (!(i8 << 24 >> 24)) i8 = 6; else i8 = (HEAP16[i165 >> 1] & 64) >>> 4 ^ 5;
   HEAP8[i11 >> 0] = i8;
   HEAP32[i11 + 16 >> 2] = i9;
   HEAP32[i11 + 20 >> 2] = i10;
   HEAPF32[i11 + 24 >> 2] = f172;
   HEAPF32[i11 + 28 >> 2] = f171;
   HEAPF32[i11 + 8 >> 2] = f170;
   HEAPF32[i11 + 12 >> 2] = f162;
   i8 = HEAP32[i46 >> 2] | 0;
   if ((i8 | 0) != 65535) {
    i29 = f27 > Math_fround(0.0);
    while (1) {
     i9 = HEAP16[i195 + (i8 * 12 | 0) + 2 >> 1] | 0;
     i26 = HEAPU16[i195 + (i8 * 12 | 0) >> 1] | 0;
     if (i9 << 16 >> 16) {
      i25 = i9 & 65535;
      if (i29) {
       i23 = 0;
       i24 = i1;
       while (1) {
        i22 = i23 + i26 | 0;
        i198 = i194 + (i22 << 6) | 0;
        i13 = HEAP32[i198 >> 2] | 0;
        i11 = i194 + (i22 << 6) + 4 | 0;
        i14 = HEAP32[i11 >> 2] | 0;
        i9 = i194 + (i22 << 6) + 8 | 0;
        i15 = HEAP32[i9 >> 2] | 0;
        f12 = Math_fround(Math_fround(HEAPF32[i194 + (i22 << 6) + 12 >> 2]) - f163);
        f6 = Math_fround(HEAPF32[i194 + (i22 << 6) + 16 >> 2]);
        f19 = Math_fround(f6 - Math_fround(HEAPF32[i133 >> 2]));
        f21 = Math_fround(HEAPF32[i194 + (i22 << 6) + 20 >> 2]);
        f18 = Math_fround(f21 - Math_fround(HEAPF32[i134 >> 2]));
        f20 = Math_fround(HEAPF32[i194 + (i22 << 6) + 24 >> 2]);
        f17 = Math_fround(f20 - Math_fround(HEAPF32[i135 >> 2]));
        f6 = Math_fround(f6 - Math_fround(HEAPF32[i136 >> 2]));
        f21 = Math_fround(f21 - Math_fround(HEAPF32[i137 >> 2]));
        f20 = Math_fround(f20 - Math_fround(HEAPF32[i138 >> 2]));
        f45 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f16 = Math_fround(f18 * f45);
        f44 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f16 = Math_fround(f16 - Math_fround(f17 * f44));
        f43 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f17 = Math_fround(Math_fround(f17 * f43) - Math_fround(f19 * f45));
        f18 = Math_fround(Math_fround(f19 * f44) - Math_fround(f18 * f43));
        f19 = Math_fround(Math_fround(f21 * f45) - Math_fround(f20 * f44));
        f20 = Math_fround(Math_fround(f20 * f43) - Math_fround(f6 * f45));
        f21 = Math_fround(Math_fround(f6 * f44) - Math_fround(f21 * f43));
        HEAP32[i176 >> 2] = i13;
        HEAP32[i102 >> 2] = i14;
        HEAP32[i103 >> 2] = i15;
        HEAPF32[i104 >> 2] = Math_fround(0.0);
        HEAPF32[i105 >> 2] = f16;
        HEAPF32[i106 >> 2] = f17;
        HEAPF32[i107 >> 2] = f18;
        HEAPF32[i108 >> 2] = Math_fround(0.0);
        f44 = Math_fround(-f44);
        f45 = Math_fround(-f45);
        f6 = Math_fround(-f19);
        f5 = Math_fround(-f20);
        f7 = Math_fround(-f21);
        HEAPF32[i177 >> 2] = Math_fround(-f43);
        HEAPF32[i109 >> 2] = f44;
        HEAPF32[i110 >> 2] = f45;
        HEAPF32[i111 >> 2] = Math_fround(0.0);
        HEAPF32[i112 >> 2] = f6;
        HEAPF32[i113 >> 2] = f5;
        HEAPF32[i114 >> 2] = f7;
        HEAPF32[i115 >> 2] = Math_fround(0.0);
        f7 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i176, i182, f172, f170, i190, i177, i185, f171, f162, 0));
        i10 = HEAP16[i175 >> 1] | 0;
        f5 = Math_fround(HEAPF32[i198 >> 2]);
        f6 = Math_fround(HEAPF32[i11 >> 2]);
        if (i10 << 16 >> 16 == -1) {
         i198 = HEAP32[i189 >> 2] | 0;
         f4 = Math_fround(f5 * Math_fround(HEAPF32[i198 >> 2]));
         f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i198 + 4 >> 2])));
         f45 = Math_fround(HEAPF32[i198 + 8 >> 2]);
         f3 = Math_fround(HEAPF32[i9 >> 2]);
         f45 = Math_fround(f4 + Math_fround(f45 * f3));
         f4 = Math_fround(f16 * Math_fround(HEAPF32[i198 + 16 >> 2]));
         f4 = Math_fround(f4 + Math_fround(f17 * Math_fround(HEAPF32[i198 + 20 >> 2])));
         f4 = Math_fround(f45 + Math_fround(f4 + Math_fround(f18 * Math_fround(HEAPF32[i198 + 24 >> 2]))));
        } else {
         i198 = i10 & 65535;
         i11 = (HEAP32[i189 >> 2] | 0) + 128 | 0;
         f44 = Math_fround(HEAPF32[i11 + (i198 << 5) >> 2]);
         f45 = Math_fround(HEAPF32[i11 + (i198 << 5) + 4 >> 2]);
         f4 = Math_fround(HEAPF32[i11 + (i198 << 5) + 8 >> 2]);
         f41 = Math_fround(HEAPF32[i11 + (i198 << 5) + 16 >> 2]);
         f42 = Math_fround(HEAPF32[i11 + (i198 << 5) + 20 >> 2]);
         f43 = Math_fround(HEAPF32[i11 + (i198 << 5) + 24 >> 2]);
         f3 = Math_fround(HEAPF32[i9 >> 2]);
         f4 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f41) + Math_fround(f17 * f42)) + Math_fround(f18 * f43)) + Math_fround(Math_fround(Math_fround(f5 * f44) + Math_fround(f6 * f45)) + Math_fround(f4 * f3)));
        }
        i9 = HEAP16[i174 >> 1] | 0;
        if (i9 << 16 >> 16 == -1) {
         i198 = HEAP32[i190 >> 2] | 0;
         f45 = Math_fround(f5 * Math_fround(HEAPF32[i198 >> 2]));
         f45 = Math_fround(f45 + Math_fround(f6 * Math_fround(HEAPF32[i198 + 4 >> 2])));
         f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i198 + 8 >> 2]) * f3));
         f3 = Math_fround(f19 * Math_fround(HEAPF32[i198 + 16 >> 2]));
         f3 = Math_fround(f3 + Math_fround(f20 * Math_fround(HEAPF32[i198 + 20 >> 2])));
         f3 = Math_fround(f45 + Math_fround(f3 + Math_fround(f21 * Math_fround(HEAPF32[i198 + 24 >> 2]))));
        } else {
         i198 = i9 & 65535;
         i11 = (HEAP32[i190 >> 2] | 0) + 128 | 0;
         f43 = Math_fround(HEAPF32[i11 + (i198 << 5) >> 2]);
         f44 = Math_fround(HEAPF32[i11 + (i198 << 5) + 4 >> 2]);
         f45 = Math_fround(HEAPF32[i11 + (i198 << 5) + 8 >> 2]);
         f41 = Math_fround(HEAPF32[i11 + (i198 << 5) + 16 >> 2]);
         f42 = Math_fround(HEAPF32[i11 + (i198 << 5) + 20 >> 2]);
         f3 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f41) + Math_fround(f20 * f42)) + Math_fround(f21 * Math_fround(HEAPF32[i11 + (i198 << 5) + 24 >> 2]))) + Math_fround(Math_fround(Math_fround(f5 * f43) + Math_fround(f6 * f44)) + Math_fround(f45 * f3)));
        }
        f44 = Math_fround(f4 - f3);
        i11 = f7 == Math_fround(0.0);
        f45 = Math_fround(Math_fround(1.0) / f7);
        f45 = i11 ? Math_fround(0.0) : f45;
        f3 = Math_fround(f164 * f12);
        f3 = Math_fround((f173 > f3 ? f173 : f3) * f45);
        f4 = Math_fround(-f44);
        i11 = Math_fround(f12 * f196) < f4 & f44 < f193;
        f4 = Math_fround(f27 * f4);
        HEAP32[i24 >> 2] = i13;
        HEAP32[i24 + 4 >> 2] = i14;
        HEAP32[i24 + 8 >> 2] = i15;
        HEAPF32[i24 + 12 >> 2] = f45;
        HEAPF32[i24 + 16 >> 2] = f16;
        HEAPF32[i24 + 20 >> 2] = f17;
        HEAPF32[i24 + 24 >> 2] = f18;
        HEAP32[i24 + 28 >> 2] = 0;
        i9 = i11 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
        HEAPF32[i24 + 32 >> 2] = f19;
        HEAPF32[i24 + 36 >> 2] = f20;
        HEAPF32[i24 + 40 >> 2] = f21;
        HEAP32[i24 + 44 >> 2] = i9;
        i9 = HEAP32[i117 >> 2] | 0;
        i10 = HEAP32[i118 >> 2] | 0;
        i14 = i11 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
        HEAP32[i24 + 48 >> 2] = HEAP32[i116 >> 2];
        HEAP32[i24 + 52 >> 2] = i9;
        HEAP32[i24 + 56 >> 2] = i10;
        HEAP32[i24 + 60 >> 2] = i14;
        i14 = HEAP32[i120 >> 2] | 0;
        i15 = HEAP32[i121 >> 2] | 0;
        i198 = HEAP32[i194 + (i22 << 6) + 28 >> 2] | 0;
        HEAP32[i24 + 64 >> 2] = HEAP32[i119 >> 2];
        HEAP32[i24 + 68 >> 2] = i14;
        HEAP32[i24 + 72 >> 2] = i15;
        HEAP32[i24 + 76 >> 2] = i198;
        i198 = HEAP32[i122 >> 2] | 0;
        i22 = HEAP32[i123 >> 2] | 0;
        HEAP32[i24 + 80 >> 2] = HEAP32[i182 >> 2];
        HEAP32[i24 + 84 >> 2] = i198;
        HEAP32[i24 + 88 >> 2] = i22;
        HEAPF32[i24 + 92 >> 2] = Math_fround(0.0);
        i22 = HEAP32[i124 >> 2] | 0;
        i198 = HEAP32[i125 >> 2] | 0;
        HEAP32[i24 + 96 >> 2] = HEAP32[i185 >> 2];
        HEAP32[i24 + 100 >> 2] = i22;
        HEAP32[i24 + 104 >> 2] = i198;
        HEAPF32[i24 + 108 >> 2] = Math_fround(0.0);
        i23 = i23 + 1 | 0;
        if ((i23 | 0) == (i25 | 0)) break; else i24 = i24 + i168 | 0;
       }
      } else {
       i9 = 0;
       i10 = i1;
       while (1) {
        i198 = i9 + i26 | 0;
        i22 = HEAP32[i194 + (i198 << 6) >> 2] | 0;
        i23 = HEAP32[i194 + (i198 << 6) + 4 >> 2] | 0;
        i24 = HEAP32[i194 + (i198 << 6) + 8 >> 2] | 0;
        f45 = Math_fround(Math_fround(HEAPF32[i194 + (i198 << 6) + 12 >> 2]) - f163);
        f36 = Math_fround(HEAPF32[i194 + (i198 << 6) + 16 >> 2]);
        f42 = Math_fround(f36 - Math_fround(HEAPF32[i133 >> 2]));
        f44 = Math_fround(HEAPF32[i194 + (i198 << 6) + 20 >> 2]);
        f41 = Math_fround(f44 - Math_fround(HEAPF32[i134 >> 2]));
        f43 = Math_fround(HEAPF32[i194 + (i198 << 6) + 24 >> 2]);
        f40 = Math_fround(f43 - Math_fround(HEAPF32[i135 >> 2]));
        f36 = Math_fround(f36 - Math_fround(HEAPF32[i136 >> 2]));
        f44 = Math_fround(f44 - Math_fround(HEAPF32[i137 >> 2]));
        f43 = Math_fround(f43 - Math_fround(HEAPF32[i138 >> 2]));
        f35 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f39 = Math_fround(f41 * f35);
        f34 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f39 = Math_fround(f39 - Math_fround(f40 * f34));
        f32 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f40 = Math_fround(Math_fround(f40 * f32) - Math_fround(f42 * f35));
        f41 = Math_fround(Math_fround(f42 * f34) - Math_fround(f41 * f32));
        f42 = Math_fround(Math_fround(f44 * f35) - Math_fround(f43 * f34));
        f43 = Math_fround(Math_fround(f43 * f32) - Math_fround(f36 * f35));
        f44 = Math_fround(Math_fround(f36 * f34) - Math_fround(f44 * f32));
        HEAP32[i176 >> 2] = i22;
        HEAP32[i102 >> 2] = i23;
        HEAP32[i103 >> 2] = i24;
        HEAPF32[i104 >> 2] = Math_fround(0.0);
        HEAPF32[i105 >> 2] = f39;
        HEAPF32[i106 >> 2] = f40;
        HEAPF32[i107 >> 2] = f41;
        HEAPF32[i108 >> 2] = Math_fround(0.0);
        f34 = Math_fround(-f34);
        f35 = Math_fround(-f35);
        f36 = Math_fround(-f42);
        f37 = Math_fround(-f43);
        f38 = Math_fround(-f44);
        HEAPF32[i177 >> 2] = Math_fround(-f32);
        HEAPF32[i109 >> 2] = f34;
        HEAPF32[i110 >> 2] = f35;
        HEAPF32[i111 >> 2] = Math_fround(0.0);
        HEAPF32[i112 >> 2] = f36;
        HEAPF32[i113 >> 2] = f37;
        HEAPF32[i114 >> 2] = f38;
        HEAPF32[i115 >> 2] = Math_fround(0.0);
        f38 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i176, i182, f172, f170, i190, i177, i185, f171, f162, 0));
        i15 = f38 == Math_fround(0.0);
        f38 = Math_fround(Math_fround(1.0) / f38);
        f38 = i15 ? Math_fround(0.0) : f38;
        f45 = Math_fround(f164 * f45);
        f45 = Math_fround((f173 > f45 ? f173 : f45) * f38);
        HEAP32[i10 >> 2] = i22;
        HEAP32[i10 + 4 >> 2] = i23;
        HEAP32[i10 + 8 >> 2] = i24;
        HEAPF32[i10 + 12 >> 2] = f38;
        HEAPF32[i10 + 16 >> 2] = f39;
        HEAPF32[i10 + 20 >> 2] = f40;
        HEAPF32[i10 + 24 >> 2] = f41;
        HEAP32[i10 + 28 >> 2] = 0;
        HEAPF32[i10 + 32 >> 2] = f42;
        HEAPF32[i10 + 36 >> 2] = f43;
        HEAPF32[i10 + 40 >> 2] = f44;
        HEAPF32[i10 + 44 >> 2] = f45;
        i24 = HEAP32[i117 >> 2] | 0;
        i23 = HEAP32[i118 >> 2] | 0;
        HEAP32[i10 + 48 >> 2] = HEAP32[i116 >> 2];
        HEAP32[i10 + 52 >> 2] = i24;
        HEAP32[i10 + 56 >> 2] = i23;
        HEAP32[i10 + 60 >> 2] = 0;
        i23 = HEAP32[i120 >> 2] | 0;
        i24 = HEAP32[i121 >> 2] | 0;
        i198 = HEAP32[i194 + (i198 << 6) + 28 >> 2] | 0;
        HEAP32[i10 + 64 >> 2] = HEAP32[i119 >> 2];
        HEAP32[i10 + 68 >> 2] = i23;
        HEAP32[i10 + 72 >> 2] = i24;
        HEAP32[i10 + 76 >> 2] = i198;
        i198 = HEAP32[i122 >> 2] | 0;
        i24 = HEAP32[i123 >> 2] | 0;
        HEAP32[i10 + 80 >> 2] = HEAP32[i182 >> 2];
        HEAP32[i10 + 84 >> 2] = i198;
        HEAP32[i10 + 88 >> 2] = i24;
        HEAPF32[i10 + 92 >> 2] = Math_fround(0.0);
        i24 = HEAP32[i124 >> 2] | 0;
        i198 = HEAP32[i125 >> 2] | 0;
        HEAP32[i10 + 96 >> 2] = HEAP32[i185 >> 2];
        HEAP32[i10 + 100 >> 2] = i24;
        HEAP32[i10 + 104 >> 2] = i198;
        HEAPF32[i10 + 108 >> 2] = Math_fround(0.0);
        i9 = i9 + 1 | 0;
        if ((i9 | 0) == (i25 | 0)) break; else i10 = i10 + i168 | 0;
       }
      }
      i1 = i1 + (Math_imul(i168, i25) | 0) | 0;
     }
     i8 = HEAP16[i195 + (i8 * 12 | 0) + 4 >> 1] | 0;
     if (i8 << 16 >> 16 == -1) break; else i8 = i8 & 65535;
    }
   }
   if (i33) {
    i8 = HEAPU16[i195 + ((HEAP32[i46 >> 2] | 0) * 12 | 0) >> 1] | 0;
    f12 = Math_fround(HEAPF32[i194 + (i8 << 6) >> 2]);
    i11 = HEAP32[i194 + (i8 << 6) + 4 >> 2] | 0;
    f16 = Math_fround(HEAPF32[i194 + (i8 << 6) + 8 >> 2]);
    i8 = HEAP16[i175 >> 1] | 0;
    if (i8 << 16 >> 16 == -1) {
     i8 = HEAP32[i189 >> 2] | 0;
     i10 = i8 + 8 | 0;
     i9 = i8 + 4 | 0;
    } else {
     i8 = i8 & 65535;
     i198 = (HEAP32[i189 >> 2] | 0) + 128 | 0;
     i10 = i198 + (i8 << 5) + 8 | 0;
     i9 = i198 + (i8 << 5) + 4 | 0;
     i8 = i198 + (i8 << 5) | 0;
    }
    f5 = Math_fround(HEAPF32[i8 >> 2]);
    f4 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(HEAPF32[i10 >> 2]);
    i8 = HEAP16[i174 >> 1] | 0;
    if (i8 << 16 >> 16 == -1) {
     i10 = HEAP32[i190 >> 2] | 0;
     i8 = i10 + 8 | 0;
     i9 = i10 + 4 | 0;
    } else {
     i10 = i8 & 65535;
     i198 = (HEAP32[i190 >> 2] | 0) + 128 | 0;
     i8 = i198 + (i10 << 5) + 8 | 0;
     i9 = i198 + (i10 << 5) + 4 | 0;
     i10 = i198 + (i10 << 5) | 0;
    }
    f45 = Math_fround(HEAPF32[i10 >> 2]);
    f6 = Math_fround(HEAPF32[i9 >> 2]);
    f45 = Math_fround(f5 - f45);
    f4 = Math_fround(f4 - f6);
    f6 = Math_fround(f3 - Math_fround(HEAPF32[i8 >> 2]));
    f5 = Math_fround(f12 * f45);
    f7 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = Math_fround(Math_fround(f5 + Math_fround(f7 * f4)) + Math_fround(f16 * f6));
    f3 = Math_fround(f45 - Math_fround(f12 * f5));
    f4 = Math_fround(f4 - Math_fround(f7 * f5));
    f5 = Math_fround(f6 - Math_fround(f16 * f5));
    f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)));
    if (f6 > Math_fround(.100000001)) {
     f41 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
     f43 = Math_fround(f3 * f41);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
     f42 = Math_fround(f4 * f41);
     f41 = Math_fround(f5 * f41);
     f44 = f42;
     f45 = Math_fround(Math_fround(f12 * f42) - Math_fround(f7 * f43));
     f43 = Math_fround(Math_fround(f16 * f43) - Math_fround(f12 * f41));
     f42 = Math_fround(Math_fround(f7 * f41) - Math_fround(f16 * f42));
     i8 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i198 = Math_fround(Math_abs(Math_fround(f12))) < Math_fround(.707106769);
     f3 = Math_fround(-f7);
     f4 = Math_fround(-f16);
     i8 = i198 ? i11 : 0;
     f4 = i198 ? f4 : f12;
     i9 = i198 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
     f6 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6));
     f5 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + f3)));
     if (f3 > Math_fround(0.0)) {
      f45 = Math_fround(Math_fround(1.0) / f3);
      f3 = Math_fround(f6 * f45);
      i9 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
      f4 = Math_fround(f4 * f45);
      f5 = Math_fround(f5 * f45);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     } else f3 = f6;
     f44 = f4;
     f45 = Math_fround(Math_fround(f12 * f4) - Math_fround(f7 * f3));
     f43 = Math_fround(Math_fround(f16 * f3) - Math_fround(f12 * f5));
     f42 = Math_fround(Math_fround(f7 * f5) - Math_fround(f16 * f4));
    }
    i13 = (HEAP32[i126 >> 2] | 0) + (i2 * 96 | 0) | 0;
    i14 = i195 + 768 + (i161 * 96 | 0) + 16 | 0;
    if (HEAP16[i14 >> 1] | 0) {
     f34 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f35 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f36 = Math_fround(-f35);
     f37 = Math_fround(-f44);
     f38 = Math_fround(-f34);
     f39 = Math_fround(-f42);
     f40 = Math_fround(-f43);
     f41 = Math_fround(-f45);
     if (i197) {
      i11 = 0;
      i10 = i1;
      while (1) {
       i1 = i10 + i47 | 0;
       HEAP32[i10 + 80 >> 2] = i13;
       HEAP32[i10 + i50 >> 2] = i13;
       f7 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) >> 2]) * Math_fround(2.0));
       f6 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
       f3 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
       f30 = Math_fround(HEAPF32[i127 >> 2]);
       f21 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
       f5 = Math_fround(HEAPF32[i191 >> 2]);
       f18 = Math_fround(f7 * f5);
       f31 = Math_fround(HEAPF32[i128 >> 2]);
       f18 = Math_fround(f18 + Math_fround(f6 * f31));
       f32 = Math_fround(HEAPF32[i129 >> 2]);
       f18 = Math_fround(f18 + Math_fround(f3 * f32));
       f19 = Math_fround(Math_fround(f5 * f18) + Math_fround(Math_fround(f7 * f21) + Math_fround(f30 * Math_fround(Math_fround(f3 * f31) - Math_fround(f6 * f32)))));
       f20 = Math_fround(Math_fround(f31 * f18) + Math_fround(Math_fround(f6 * f21) + Math_fround(f30 * Math_fround(Math_fround(f7 * f32) - Math_fround(f3 * f5)))));
       f18 = Math_fround(Math_fround(Math_fround(f3 * f21) + Math_fround(f30 * Math_fround(Math_fround(f6 * f5) - Math_fround(f7 * f31)))) + Math_fround(f32 * f18));
       f32 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) >> 2]) * Math_fround(2.0));
       f31 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
       f7 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
       f5 = Math_fround(HEAPF32[i130 >> 2]);
       f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
       f30 = Math_fround(HEAPF32[i192 >> 2]);
       f21 = Math_fround(f32 * f30);
       f3 = Math_fround(HEAPF32[i131 >> 2]);
       f21 = Math_fround(f21 + Math_fround(f31 * f3));
       f4 = Math_fround(HEAPF32[i132 >> 2]);
       f21 = Math_fround(f21 + Math_fround(f7 * f4));
       f27 = Math_fround(Math_fround(f30 * f21) + Math_fround(Math_fround(f32 * f6) + Math_fround(f5 * Math_fround(Math_fround(f7 * f3) - Math_fround(f31 * f4)))));
       f28 = Math_fround(Math_fround(f3 * f21) + Math_fround(Math_fround(f31 * f6) + Math_fround(f5 * Math_fround(Math_fround(f32 * f4) - Math_fround(f7 * f30)))));
       f21 = Math_fround(Math_fround(Math_fround(f7 * f6) + Math_fround(f5 * Math_fround(Math_fround(f31 * f30) - Math_fround(f32 * f3)))) + Math_fround(f4 * f21));
       f4 = Math_fround(f19 + Math_fround(HEAPF32[i133 >> 2]));
       f3 = Math_fround(f20 + Math_fround(HEAPF32[i134 >> 2]));
       f32 = Math_fround(f18 + Math_fround(HEAPF32[i135 >> 2]));
       f30 = Math_fround(Math_fround(HEAPF32[i136 >> 2]) + f27);
       f31 = Math_fround(f28 + Math_fround(HEAPF32[i137 >> 2]));
       f30 = Math_fround(f4 - f30);
       f31 = Math_fround(f3 - f31);
       f32 = Math_fround(f32 - Math_fround(f21 + Math_fround(HEAPF32[i138 >> 2])));
       f3 = Math_fround(Math_fround(f34 * f20) - Math_fround(f44 * f18));
       f4 = Math_fround(Math_fround(f35 * f18) - Math_fround(f34 * f19));
       f5 = Math_fround(Math_fround(f44 * f19) - Math_fround(f35 * f20));
       f6 = Math_fround(Math_fround(f34 * f28) - Math_fround(f44 * f21));
       f7 = Math_fround(Math_fround(f35 * f21) - Math_fround(f34 * f27));
       f12 = Math_fround(Math_fround(f44 * f27) - Math_fround(f35 * f28));
       HEAP32[i178 >> 2] = i9;
       HEAPF32[i139 >> 2] = f44;
       HEAP32[i140 >> 2] = i8;
       HEAPF32[i141 >> 2] = Math_fround(0.0);
       HEAPF32[i142 >> 2] = f3;
       HEAPF32[i143 >> 2] = f4;
       HEAPF32[i144 >> 2] = f5;
       HEAPF32[i145 >> 2] = Math_fround(0.0);
       f17 = Math_fround(-f6);
       f199 = Math_fround(-f7);
       f16 = Math_fround(-f12);
       HEAPF32[i179 >> 2] = f36;
       HEAPF32[i146 >> 2] = f37;
       HEAPF32[i147 >> 2] = f38;
       HEAPF32[i148 >> 2] = Math_fround(0.0);
       HEAPF32[i149 >> 2] = f17;
       HEAPF32[i150 >> 2] = f199;
       HEAPF32[i151 >> 2] = f16;
       HEAPF32[i152 >> 2] = Math_fround(0.0);
       f16 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i178, i184, f172, f170, i190, i179, i187, f171, f162, 0));
       i198 = f16 > Math_fround(0.0);
       f16 = Math_fround(Math_fround(Math_fround(1.0) / f16) * Math_fround(.800000011));
       i46 = HEAPU16[i195 + 4100 + (i161 << 2) + (i11 << 1) >> 1] | 0;
       f199 = Math_fround(HEAPF32[i194 + (i46 << 6) + 32 >> 2]);
       f17 = Math_fround(HEAPF32[i194 + (i46 << 6) + 36 >> 2]);
       f17 = Math_fround(Math_fround(Math_fround(f35 * f199) + Math_fround(f44 * f17)) + Math_fround(f34 * Math_fround(HEAPF32[i194 + (i46 << 6) + 40 >> 2])));
       HEAP32[i10 >> 2] = i9;
       HEAPF32[i10 + 4 >> 2] = f44;
       HEAP32[i10 + 8 >> 2] = i8;
       HEAP32[i10 + 12 >> 2] = 0;
       i198 = i198 ? (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) : 0;
       HEAPF32[i10 + 16 >> 2] = f3;
       HEAPF32[i10 + 20 >> 2] = f4;
       HEAPF32[i10 + 24 >> 2] = f5;
       HEAP32[i10 + 28 >> 2] = i198;
       f16 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f30) + Math_fround(f44 * f31)) + Math_fround(f34 * f32)) * f196);
       HEAPF32[i10 + 32 >> 2] = f6;
       HEAPF32[i10 + 36 >> 2] = f7;
       HEAPF32[i10 + 40 >> 2] = f12;
       HEAPF32[i10 + 44 >> 2] = f16;
       i198 = HEAP32[i154 >> 2] | 0;
       i46 = HEAP32[i155 >> 2] | 0;
       HEAP32[i10 + 48 >> 2] = HEAP32[i153 >> 2];
       HEAP32[i10 + 52 >> 2] = i198;
       HEAP32[i10 + 56 >> 2] = i46;
       HEAP32[i10 + 60 >> 2] = 0;
       i46 = HEAP32[i157 >> 2] | 0;
       i198 = HEAP32[i158 >> 2] | 0;
       HEAP32[i10 + 64 >> 2] = HEAP32[i156 >> 2];
       HEAP32[i10 + 68 >> 2] = i46;
       HEAP32[i10 + 72 >> 2] = i198;
       HEAPF32[i10 + 76 >> 2] = f17;
       i198 = HEAP32[i159 >> 2] | 0;
       i46 = HEAP32[i160 >> 2] | 0;
       HEAP32[i10 + 96 >> 2] = HEAP32[i184 >> 2];
       HEAP32[i10 + 100 >> 2] = i198;
       HEAP32[i10 + 104 >> 2] = i46;
       HEAPF32[i10 + 108 >> 2] = Math_fround(0.0);
       i46 = HEAP32[i76 >> 2] | 0;
       i198 = HEAP32[i77 >> 2] | 0;
       HEAP32[i10 + 112 >> 2] = HEAP32[i187 >> 2];
       HEAP32[i10 + 116 >> 2] = i46;
       HEAP32[i10 + 120 >> 2] = i198;
       HEAPF32[i10 + 124 >> 2] = Math_fround(0.0);
       f17 = Math_fround(Math_fround(f45 * f20) - Math_fround(f43 * f18));
       f16 = Math_fround(Math_fround(f42 * f18) - Math_fround(f45 * f19));
       f7 = Math_fround(Math_fround(f43 * f19) - Math_fround(f42 * f20));
       f12 = Math_fround(Math_fround(f45 * f28) - Math_fround(f43 * f21));
       f6 = Math_fround(Math_fround(f42 * f21) - Math_fround(f45 * f27));
       f3 = Math_fround(Math_fround(f43 * f27) - Math_fround(f42 * f28));
       HEAPF32[i180 >> 2] = f42;
       HEAPF32[i78 >> 2] = f43;
       HEAPF32[i79 >> 2] = f45;
       HEAPF32[i80 >> 2] = Math_fround(0.0);
       HEAPF32[i81 >> 2] = f17;
       HEAPF32[i82 >> 2] = f16;
       HEAPF32[i83 >> 2] = f7;
       HEAPF32[i84 >> 2] = Math_fround(0.0);
       f5 = Math_fround(-f12);
       f199 = Math_fround(-f6);
       f4 = Math_fround(-f3);
       HEAPF32[i181 >> 2] = f39;
       HEAPF32[i85 >> 2] = f40;
       HEAPF32[i86 >> 2] = f41;
       HEAPF32[i87 >> 2] = Math_fround(0.0);
       HEAPF32[i88 >> 2] = f5;
       HEAPF32[i89 >> 2] = f199;
       HEAPF32[i90 >> 2] = f4;
       HEAPF32[i91 >> 2] = Math_fround(0.0);
       f4 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i180, i183, f172, f170, i190, i181, i186, f171, f162, 0));
       i198 = f4 > Math_fround(0.0);
       f4 = Math_fround(Math_fround(Math_fround(1.0) / f4) * Math_fround(.800000011));
       i46 = HEAPU16[i195 + 4100 + (i161 << 2) + (i11 << 1) >> 1] | 0;
       f199 = Math_fround(HEAPF32[i194 + (i46 << 6) + 32 >> 2]);
       f5 = Math_fround(HEAPF32[i194 + (i46 << 6) + 36 >> 2]);
       f5 = Math_fround(Math_fround(Math_fround(f35 * f199) + Math_fround(f44 * f5)) + Math_fround(f34 * Math_fround(HEAPF32[i194 + (i46 << 6) + 40 >> 2])));
       HEAPF32[i10 + i169 >> 2] = f42;
       HEAPF32[i10 + i53 >> 2] = f43;
       HEAPF32[i10 + i54 >> 2] = f45;
       HEAP32[i10 + i55 >> 2] = 0;
       i198 = i198 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
       HEAPF32[i10 + i51 >> 2] = f17;
       HEAPF32[i10 + i56 >> 2] = f16;
       HEAPF32[i10 + i57 >> 2] = f7;
       HEAP32[i10 + i58 >> 2] = i198;
       f199 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f30) + Math_fround(f43 * f31)) + Math_fround(f45 * f32)) * f196);
       HEAPF32[i10 + i52 >> 2] = f12;
       HEAPF32[i10 + i59 >> 2] = f6;
       HEAPF32[i10 + i60 >> 2] = f3;
       HEAPF32[i10 + i61 >> 2] = f199;
       i198 = HEAP32[i93 >> 2] | 0;
       i46 = HEAP32[i94 >> 2] | 0;
       HEAP32[i10 + i74 >> 2] = HEAP32[i92 >> 2];
       HEAP32[i10 + i62 >> 2] = i198;
       HEAP32[i10 + i63 >> 2] = i46;
       HEAP32[i10 + i64 >> 2] = 0;
       i46 = HEAP32[i96 >> 2] | 0;
       i198 = HEAP32[i97 >> 2] | 0;
       HEAP32[i10 + i75 >> 2] = HEAP32[i95 >> 2];
       HEAP32[i10 + i65 >> 2] = i46;
       HEAP32[i10 + i66 >> 2] = i198;
       HEAPF32[i10 + i67 >> 2] = f5;
       i198 = HEAP32[i98 >> 2] | 0;
       i46 = HEAP32[i99 >> 2] | 0;
       HEAP32[i10 + i48 >> 2] = HEAP32[i183 >> 2];
       HEAP32[i10 + i68 >> 2] = i198;
       HEAP32[i10 + i69 >> 2] = i46;
       HEAPF32[i10 + i70 >> 2] = Math_fround(0.0);
       i46 = HEAP32[i100 >> 2] | 0;
       i198 = HEAP32[i101 >> 2] | 0;
       HEAP32[i10 + i49 >> 2] = HEAP32[i186 >> 2];
       HEAP32[i10 + i71 >> 2] = i46;
       HEAP32[i10 + i72 >> 2] = i198;
       HEAPF32[i10 + i73 >> 2] = Math_fround(0.0);
       i11 = i11 + 1 | 0;
       if (i11 >>> 0 >= (HEAPU16[i14 >> 1] | 0) >>> 0) break; else i10 = i1;
      }
     } else {
      i11 = 0;
      i10 = i1;
      while (1) {
       i1 = i10 + i47 | 0;
       HEAP32[i10 + 80 >> 2] = i13;
       HEAP32[i10 + i50 >> 2] = i13;
       f7 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) >> 2]) * Math_fround(2.0));
       f6 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
       f3 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 48 + (i11 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
       f30 = Math_fround(HEAPF32[i127 >> 2]);
       f21 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
       f5 = Math_fround(HEAPF32[i191 >> 2]);
       f18 = Math_fround(f7 * f5);
       f31 = Math_fround(HEAPF32[i128 >> 2]);
       f18 = Math_fround(f18 + Math_fround(f6 * f31));
       f32 = Math_fround(HEAPF32[i129 >> 2]);
       f18 = Math_fround(f18 + Math_fround(f3 * f32));
       f19 = Math_fround(Math_fround(f5 * f18) + Math_fround(Math_fround(f7 * f21) + Math_fround(f30 * Math_fround(Math_fround(f3 * f31) - Math_fround(f6 * f32)))));
       f20 = Math_fround(Math_fround(f31 * f18) + Math_fround(Math_fround(f6 * f21) + Math_fround(f30 * Math_fround(Math_fround(f7 * f32) - Math_fround(f3 * f5)))));
       f18 = Math_fround(Math_fround(Math_fround(f3 * f21) + Math_fround(f30 * Math_fround(Math_fround(f6 * f5) - Math_fround(f7 * f31)))) + Math_fround(f32 * f18));
       f32 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) >> 2]) * Math_fround(2.0));
       f31 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
       f7 = Math_fround(Math_fround(HEAPF32[i195 + 768 + (i161 * 96 | 0) + 72 + (i11 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
       f5 = Math_fround(HEAPF32[i130 >> 2]);
       f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
       f30 = Math_fround(HEAPF32[i192 >> 2]);
       f21 = Math_fround(f32 * f30);
       f3 = Math_fround(HEAPF32[i131 >> 2]);
       f21 = Math_fround(f21 + Math_fround(f31 * f3));
       f4 = Math_fround(HEAPF32[i132 >> 2]);
       f21 = Math_fround(f21 + Math_fround(f7 * f4));
       f27 = Math_fround(Math_fround(f30 * f21) + Math_fround(Math_fround(f32 * f6) + Math_fround(f5 * Math_fround(Math_fround(f7 * f3) - Math_fround(f31 * f4)))));
       f28 = Math_fround(Math_fround(f3 * f21) + Math_fround(Math_fround(f31 * f6) + Math_fround(f5 * Math_fround(Math_fround(f32 * f4) - Math_fround(f7 * f30)))));
       f21 = Math_fround(Math_fround(Math_fround(f7 * f6) + Math_fround(f5 * Math_fround(Math_fround(f31 * f30) - Math_fround(f32 * f3)))) + Math_fround(f4 * f21));
       f4 = Math_fround(f19 + Math_fround(HEAPF32[i133 >> 2]));
       f3 = Math_fround(f20 + Math_fround(HEAPF32[i134 >> 2]));
       f32 = Math_fround(f18 + Math_fround(HEAPF32[i135 >> 2]));
       f30 = Math_fround(Math_fround(HEAPF32[i136 >> 2]) + f27);
       f31 = Math_fround(f28 + Math_fround(HEAPF32[i137 >> 2]));
       f30 = Math_fround(f4 - f30);
       f31 = Math_fround(f3 - f31);
       f32 = Math_fround(f32 - Math_fround(f21 + Math_fround(HEAPF32[i138 >> 2])));
       f3 = Math_fround(Math_fround(f34 * f20) - Math_fround(f44 * f18));
       f4 = Math_fround(Math_fround(f35 * f18) - Math_fround(f34 * f19));
       f5 = Math_fround(Math_fround(f44 * f19) - Math_fround(f35 * f20));
       f6 = Math_fround(Math_fround(f34 * f28) - Math_fround(f44 * f21));
       f7 = Math_fround(Math_fround(f35 * f21) - Math_fround(f34 * f27));
       f12 = Math_fround(Math_fround(f44 * f27) - Math_fround(f35 * f28));
       HEAP32[i178 >> 2] = i9;
       HEAPF32[i139 >> 2] = f44;
       HEAP32[i140 >> 2] = i8;
       HEAPF32[i141 >> 2] = Math_fround(0.0);
       HEAPF32[i142 >> 2] = f3;
       HEAPF32[i143 >> 2] = f4;
       HEAPF32[i144 >> 2] = f5;
       HEAPF32[i145 >> 2] = Math_fround(0.0);
       f17 = Math_fround(-f6);
       f199 = Math_fround(-f7);
       f16 = Math_fround(-f12);
       HEAPF32[i179 >> 2] = f36;
       HEAPF32[i146 >> 2] = f37;
       HEAPF32[i147 >> 2] = f38;
       HEAPF32[i148 >> 2] = Math_fround(0.0);
       HEAPF32[i149 >> 2] = f17;
       HEAPF32[i150 >> 2] = f199;
       HEAPF32[i151 >> 2] = f16;
       HEAPF32[i152 >> 2] = Math_fround(0.0);
       f16 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i178, i184, f172, f170, i190, i179, i187, f171, f162, 0));
       i198 = f16 > Math_fround(0.0);
       f16 = Math_fround(Math_fround(Math_fround(1.0) / f16) * Math_fround(.800000011));
       i33 = HEAPU16[i195 + ((HEAP32[i46 >> 2] | 0) * 12 | 0) >> 1] | 0;
       f199 = Math_fround(HEAPF32[i194 + (i33 << 6) + 32 >> 2]);
       f17 = Math_fround(HEAPF32[i194 + (i33 << 6) + 36 >> 2]);
       f17 = Math_fround(Math_fround(Math_fround(f35 * f199) + Math_fround(f44 * f17)) + Math_fround(f34 * Math_fround(HEAPF32[i194 + (i33 << 6) + 40 >> 2])));
       HEAP32[i10 >> 2] = i9;
       HEAPF32[i10 + 4 >> 2] = f44;
       HEAP32[i10 + 8 >> 2] = i8;
       HEAP32[i10 + 12 >> 2] = 0;
       i198 = i198 ? (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) : 0;
       HEAPF32[i10 + 16 >> 2] = f3;
       HEAPF32[i10 + 20 >> 2] = f4;
       HEAPF32[i10 + 24 >> 2] = f5;
       HEAP32[i10 + 28 >> 2] = i198;
       f16 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f30) + Math_fround(f44 * f31)) + Math_fround(f34 * f32)) * f196);
       HEAPF32[i10 + 32 >> 2] = f6;
       HEAPF32[i10 + 36 >> 2] = f7;
       HEAPF32[i10 + 40 >> 2] = f12;
       HEAPF32[i10 + 44 >> 2] = f16;
       i198 = HEAP32[i154 >> 2] | 0;
       i33 = HEAP32[i155 >> 2] | 0;
       HEAP32[i10 + 48 >> 2] = HEAP32[i153 >> 2];
       HEAP32[i10 + 52 >> 2] = i198;
       HEAP32[i10 + 56 >> 2] = i33;
       HEAP32[i10 + 60 >> 2] = 0;
       i33 = HEAP32[i157 >> 2] | 0;
       i198 = HEAP32[i158 >> 2] | 0;
       HEAP32[i10 + 64 >> 2] = HEAP32[i156 >> 2];
       HEAP32[i10 + 68 >> 2] = i33;
       HEAP32[i10 + 72 >> 2] = i198;
       HEAPF32[i10 + 76 >> 2] = f17;
       i198 = HEAP32[i159 >> 2] | 0;
       i33 = HEAP32[i160 >> 2] | 0;
       HEAP32[i10 + 96 >> 2] = HEAP32[i184 >> 2];
       HEAP32[i10 + 100 >> 2] = i198;
       HEAP32[i10 + 104 >> 2] = i33;
       HEAPF32[i10 + 108 >> 2] = Math_fround(0.0);
       i33 = HEAP32[i76 >> 2] | 0;
       i198 = HEAP32[i77 >> 2] | 0;
       HEAP32[i10 + 112 >> 2] = HEAP32[i187 >> 2];
       HEAP32[i10 + 116 >> 2] = i33;
       HEAP32[i10 + 120 >> 2] = i198;
       HEAPF32[i10 + 124 >> 2] = Math_fround(0.0);
       f17 = Math_fround(Math_fround(f45 * f20) - Math_fround(f43 * f18));
       f16 = Math_fround(Math_fround(f42 * f18) - Math_fround(f45 * f19));
       f7 = Math_fround(Math_fround(f43 * f19) - Math_fround(f42 * f20));
       f12 = Math_fround(Math_fround(f45 * f28) - Math_fround(f43 * f21));
       f6 = Math_fround(Math_fround(f42 * f21) - Math_fround(f45 * f27));
       f3 = Math_fround(Math_fround(f43 * f27) - Math_fround(f42 * f28));
       HEAPF32[i180 >> 2] = f42;
       HEAPF32[i78 >> 2] = f43;
       HEAPF32[i79 >> 2] = f45;
       HEAPF32[i80 >> 2] = Math_fround(0.0);
       HEAPF32[i81 >> 2] = f17;
       HEAPF32[i82 >> 2] = f16;
       HEAPF32[i83 >> 2] = f7;
       HEAPF32[i84 >> 2] = Math_fround(0.0);
       f5 = Math_fround(-f12);
       f199 = Math_fround(-f6);
       f4 = Math_fround(-f3);
       HEAPF32[i181 >> 2] = f39;
       HEAPF32[i85 >> 2] = f40;
       HEAPF32[i86 >> 2] = f41;
       HEAPF32[i87 >> 2] = Math_fround(0.0);
       HEAPF32[i88 >> 2] = f5;
       HEAPF32[i89 >> 2] = f199;
       HEAPF32[i90 >> 2] = f4;
       HEAPF32[i91 >> 2] = Math_fround(0.0);
       f4 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i189, i180, i183, f172, f170, i190, i181, i186, f171, f162, 0));
       i198 = f4 > Math_fround(0.0);
       f4 = Math_fround(Math_fround(Math_fround(1.0) / f4) * Math_fround(.800000011));
       i33 = HEAPU16[i195 + ((HEAP32[i46 >> 2] | 0) * 12 | 0) >> 1] | 0;
       f199 = Math_fround(HEAPF32[i194 + (i33 << 6) + 32 >> 2]);
       f5 = Math_fround(HEAPF32[i194 + (i33 << 6) + 36 >> 2]);
       f5 = Math_fround(Math_fround(Math_fround(f35 * f199) + Math_fround(f44 * f5)) + Math_fround(f34 * Math_fround(HEAPF32[i194 + (i33 << 6) + 40 >> 2])));
       HEAPF32[i10 + i169 >> 2] = f42;
       HEAPF32[i10 + i53 >> 2] = f43;
       HEAPF32[i10 + i54 >> 2] = f45;
       HEAP32[i10 + i55 >> 2] = 0;
       i198 = i198 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
       HEAPF32[i10 + i51 >> 2] = f17;
       HEAPF32[i10 + i56 >> 2] = f16;
       HEAPF32[i10 + i57 >> 2] = f7;
       HEAP32[i10 + i58 >> 2] = i198;
       f199 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f30) + Math_fround(f43 * f31)) + Math_fround(f45 * f32)) * f196);
       HEAPF32[i10 + i52 >> 2] = f12;
       HEAPF32[i10 + i59 >> 2] = f6;
       HEAPF32[i10 + i60 >> 2] = f3;
       HEAPF32[i10 + i61 >> 2] = f199;
       i198 = HEAP32[i93 >> 2] | 0;
       i33 = HEAP32[i94 >> 2] | 0;
       HEAP32[i10 + i74 >> 2] = HEAP32[i92 >> 2];
       HEAP32[i10 + i62 >> 2] = i198;
       HEAP32[i10 + i63 >> 2] = i33;
       HEAP32[i10 + i64 >> 2] = 0;
       i33 = HEAP32[i96 >> 2] | 0;
       i198 = HEAP32[i97 >> 2] | 0;
       HEAP32[i10 + i75 >> 2] = HEAP32[i95 >> 2];
       HEAP32[i10 + i65 >> 2] = i33;
       HEAP32[i10 + i66 >> 2] = i198;
       HEAPF32[i10 + i67 >> 2] = f5;
       i198 = HEAP32[i98 >> 2] | 0;
       i33 = HEAP32[i99 >> 2] | 0;
       HEAP32[i10 + i48 >> 2] = HEAP32[i183 >> 2];
       HEAP32[i10 + i68 >> 2] = i198;
       HEAP32[i10 + i69 >> 2] = i33;
       HEAPF32[i10 + i70 >> 2] = Math_fround(0.0);
       i33 = HEAP32[i100 >> 2] | 0;
       i198 = HEAP32[i101 >> 2] | 0;
       HEAP32[i10 + i49 >> 2] = HEAP32[i186 >> 2];
       HEAP32[i10 + i71 >> 2] = i33;
       HEAP32[i10 + i72 >> 2] = i198;
       HEAPF32[i10 + i73 >> 2] = Math_fround(0.0);
       i11 = i11 + 1 | 0;
       if (i11 >>> 0 >= (HEAPU16[i14 >> 1] | 0) >>> 0) break; else i10 = i1;
      }
     }
    }
   }
   i2 = i2 + 1 | 0;
  }
  i161 = i161 + 1 | 0;
  if (i161 >>> 0 >= (HEAP32[i167 >> 2] | 0) >>> 0) break; else i11 = i1;
 }
 STACKTOP = i188;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_(i52, i48, i49) {
 i52 = i52 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i54 + 84 | 0;
 i47 = i54 + 64 | 0;
 i46 = i54 + 44 | 0;
 i43 = i54 + 24 | 0;
 i44 = i54 + 4 | 0;
 i45 = i54;
 i6 = i48;
 L1 : do if ((i6 - i52 | 0) > 1) {
  i51 = (HEAP8[i52 >> 0] | 0) == 76 ? i52 + 1 | 0 : i52;
  i1 = HEAP8[i51 >> 0] | 0;
  switch (i1 << 24 >> 24 | 0) {
  case 78:
   {
    L51 : do if (i1 << 24 >> 24 == 78 & (i51 | 0) != (i48 | 0)) {
     i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj(i51 + 1 | 0, i48, i45) | 0;
     L53 : do if ((i1 | 0) != (i48 | 0)) {
      i2 = i49 + 52 | 0;
      HEAP32[i2 >> 2] = 0;
      switch (HEAP8[i1 >> 0] | 0) {
      case 82:
       {
        HEAP32[i2 >> 2] = 1;
        i1 = i1 + 1 | 0;
        break;
       }
      case 79:
       {
        HEAP32[i2 >> 2] = 2;
        i1 = i1 + 1 | 0;
        break;
       }
      default:
       {}
      }
      i42 = i49 + 4 | 0;
      i3 = HEAP32[i42 >> 2] | 0;
      i41 = HEAP32[i49 + 8 >> 2] | 0;
      i4 = i41;
      if (i3 >>> 0 < i41 >>> 0) {
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP32[i3 + 16 >> 2] = 0;
       HEAP32[i3 + 20 >> 2] = 0;
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i3 = i3 + 12 | 0;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 24;
      } else {
       i5 = HEAP32[i49 >> 2] | 0;
       i2 = (i3 - i5 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i49);
       i5 = (i4 - i5 | 0) / 24 | 0;
       i4 = i5 << 1;
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i53, i5 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970, i2, i49 + 12 | 0);
       i4 = i53 + 8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       HEAP32[i5 >> 2] = 0;
       HEAP32[i5 + 4 >> 2] = 0;
       HEAP32[i5 + 8 >> 2] = 0;
       HEAP32[i5 + 12 >> 2] = 0;
       HEAP32[i5 + 16 >> 2] = 0;
       HEAP32[i5 + 20 >> 2] = 0;
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i5 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       i3 = i5 + 12 | 0;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       i2 = 0;
       while (1) {
        if ((i2 | 0) == 3) break;
        HEAP32[i3 + (i2 << 2) >> 2] = 0;
        i2 = i2 + 1 | 0;
       }
       HEAP32[i4 >> 2] = i5 + 24;
       __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i49, i53);
       __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i53);
      }
      if ((i6 - i1 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == 83) if ((HEAP8[i1 + 1 >> 0] | 0) == 116) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj((HEAP32[i42 >> 2] | 0) + -24 | 0, gb + 1086567 | 0, 3);
       i1 = i1 + 2 | 0;
      }
      if ((i1 | 0) == (i48 | 0)) {
       i2 = HEAP32[i42 >> 2] | 0;
       i1 = i2 + -24 | 0;
       while (1) {
        if ((i2 | 0) == (i1 | 0)) break L53;
        i53 = i2 + -24 | 0;
        HEAP32[i42 >> 2] = i53;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i53);
        i2 = HEAP32[i42 >> 2] | 0;
       }
      }
      i14 = i53 + 11 | 0;
      i15 = i53 + 4 | 0;
      i7 = i49 + 12 | 0;
      i16 = i49 + 16 | 0;
      i41 = i49 + 20 | 0;
      i17 = i49 + 24 | 0;
      i18 = i46 + 12 | 0;
      i19 = i46 + 4 | 0;
      i20 = i46 + 8 | 0;
      i21 = i49 + 28 | 0;
      i22 = i47 + 8 | 0;
      i23 = i46 + 12 | 0;
      i24 = i46 + 4 | 0;
      i25 = i46 + 8 | 0;
      i26 = i53 + 8 | 0;
      i27 = i53 + 11 | 0;
      i28 = i53 + 4 | 0;
      i29 = i47 + 11 | 0;
      i30 = i47 + 4 | 0;
      i31 = i47 + 12 | 0;
      i32 = i47 + 4 | 0;
      i33 = i47 + 8 | 0;
      i34 = i44 + 8 | 0;
      i35 = i47 + 12 | 0;
      i36 = i47 + 4 | 0;
      i37 = i47 + 8 | 0;
      i38 = i43 + 8 | 0;
      i39 = i47 + 11 | 0;
      i40 = i47 + 4 | 0;
      i8 = i47 + 12 | 0;
      i9 = i47 + 4 | 0;
      i10 = i47 + 8 | 0;
      i11 = i46 + 8 | 0;
      i12 = i47 + 11 | 0;
      i13 = i47 + 4 | 0;
      i6 = 0;
      L93 : while (1) {
       L95 : while (1) {
        i2 = HEAP8[i1 >> 0] | 0;
        if (i2 << 24 >> 24 == 69) {
         i50 = 163;
         break L93;
        }
        switch (i2 << 24 >> 24 | 0) {
        case 83:
         {
          i50 = 36;
          break L95;
         }
        case 84:
         {
          i50 = 64;
          break L95;
         }
        case 68:
         {
          i50 = 90;
          break L95;
         }
        case 73:
         break;
        case 76:
         {
          i1 = i1 + 1 | 0;
          if ((i1 | 0) == (i48 | 0)) break L53; else continue L95;
         }
        default:
         break L95;
        }
        i5 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
        if ((i5 | 0) == (i1 | 0) | (i5 | 0) == (i48 | 0)) break L53;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, (HEAP32[i42 >> 2] | 0) + -24 | 0);
        i1 = HEAP32[i42 >> 2] | 0;
        i2 = i1 + -24 | 0;
        i3 = i1;
        while (1) {
         if ((i3 | 0) == (i2 | 0)) break;
         i4 = i3 + -24 | 0;
         HEAP32[i42 >> 2] = i4;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i4);
         i3 = HEAP32[i42 >> 2] | 0;
        }
        i4 = HEAP8[i14 >> 0] | 0;
        i3 = i4 << 24 >> 24 < 0;
        __THREW__ = 0;
        invoke_iiii(fb + 519 | 0, i1 + -48 | 0, (i3 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i3 ? HEAP32[i15 >> 2] | 0 : i4 & 255) | 0) | 0;
        i4 = __THREW__;
        __THREW__ = 0;
        if (i4 & 1) {
         i50 = 130;
         break L93;
        }
        i4 = (HEAP32[i42 >> 2] | 0) + -24 | 0;
        HEAP32[i43 >> 2] = HEAP32[i7 >> 2];
        __THREW__ = 0;
        invoke_viii(fb + 1065 | 0, i46 | 0, i4 | 0, i43 | 0);
        i4 = __THREW__;
        __THREW__ = 0;
        if (i4 & 1) {
         i50 = 131;
         break L93;
        }
        i1 = HEAP32[i41 >> 2] | 0;
        i4 = HEAP32[i17 >> 2] | 0;
        i3 = i4;
        if (i1 >>> 0 < i4 >>> 0) {
         HEAP32[i1 + 12 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i46 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAP32[i20 >> 2] = 0;
         HEAP32[i19 >> 2] = 0;
         HEAP32[i46 >> 2] = 0;
         HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 16;
        } else {
         i4 = HEAP32[i16 >> 2] | 0;
         i1 = i1 - i4 >> 4;
         i2 = i1 + 1 | 0;
         if (i2 >>> 0 > 268435455) {
          i50 = 127;
          break L93;
         }
         i3 = i3 - i4 | 0;
         i4 = i3 >> 3;
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i47, i3 >> 4 >>> 0 < 134217727 ? (i4 >>> 0 < i2 >>> 0 ? i2 : i4) : 268435455, i1, i21);
         i4 = HEAP32[i22 >> 2] | 0;
         HEAP32[i4 + 12 >> 2] = HEAP32[i18 >> 2];
         HEAP32[i4 >> 2] = HEAP32[i46 >> 2];
         HEAP32[i4 + 4 >> 2] = HEAP32[i19 >> 2];
         HEAP32[i4 + 8 >> 2] = HEAP32[i20 >> 2];
         HEAP32[i20 >> 2] = 0;
         HEAP32[i19 >> 2] = 0;
         HEAP32[i46 >> 2] = 0;
         HEAP32[i22 >> 2] = i4 + 16;
         __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i16, i47);
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i47);
        }
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i46);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        i1 = i5;
       }
       L113 : do if ((i50 | 0) == 36) {
        i50 = 0;
        i2 = i1 + 1 | 0;
        if ((i2 | 0) != (i48 | 0)) if ((HEAP8[i2 >> 0] | 0) == 116) break;
        i5 = __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
        if ((i5 | 0) == (i1 | 0) | (i5 | 0) == (i48 | 0)) break L53;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, (HEAP32[i42 >> 2] | 0) + -24 | 0);
        i3 = HEAP32[i42 >> 2] | 0;
        i1 = i3 + -24 | 0;
        i2 = i3;
        while (1) {
         if ((i2 | 0) == (i1 | 0)) break;
         i6 = i2 + -24 | 0;
         HEAP32[i42 >> 2] = i6;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
         i2 = HEAP32[i42 >> 2] | 0;
        }
        i2 = i3 + -48 | 0;
        i1 = HEAP8[i2 + 11 >> 0] | 0;
        if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + -44 >> 2] | 0; else i1 = i1 & 255;
        if (!i1) {
         __THREW__ = 0;
         invoke_vii(fb + 4622 | 0, i2 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 55;
          break L93;
         }
        } else {
         __THREW__ = 0;
         invoke_viii(fb + 1067 | 0, i47 | 0, gb + 1086571 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 56;
          break L93;
         }
         i6 = HEAP8[i29 >> 0] | 0;
         i4 = i6 << 24 >> 24 < 0;
         __THREW__ = 0;
         invoke_iiii(fb + 519 | 0, i2 | 0, (i4 ? HEAP32[i47 >> 2] | 0 : i47) | 0, (i4 ? HEAP32[i30 >> 2] | 0 : i6 & 255) | 0) | 0;
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 57;
          break L93;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
         i6 = (HEAP32[i42 >> 2] | 0) + -24 | 0;
         HEAP32[i46 >> 2] = HEAP32[i7 >> 2];
         __THREW__ = 0;
         invoke_viii(fb + 1065 | 0, i47 | 0, i6 | 0, i46 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 59;
          break L93;
         }
         i1 = HEAP32[i41 >> 2] | 0;
         i6 = HEAP32[i17 >> 2] | 0;
         i3 = i6;
         if (i1 >>> 0 < i6 >>> 0) {
          HEAP32[i1 + 12 >> 2] = HEAP32[i31 >> 2];
          HEAP32[i1 >> 2] = HEAP32[i47 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i32 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i33 >> 2];
          HEAP32[i33 >> 2] = 0;
          HEAP32[i32 >> 2] = 0;
          HEAP32[i47 >> 2] = 0;
          HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 16;
         } else {
          i4 = HEAP32[i16 >> 2] | 0;
          i1 = i1 - i4 >> 4;
          i2 = i1 + 1 | 0;
          if (i2 >>> 0 > 268435455) {
           i50 = 52;
           break L93;
          }
          i4 = i3 - i4 | 0;
          i6 = i4 >> 3;
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i44, i4 >> 4 >>> 0 < 134217727 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 268435455, i1, i21);
          i6 = HEAP32[i34 >> 2] | 0;
          HEAP32[i6 + 12 >> 2] = HEAP32[i31 >> 2];
          HEAP32[i6 >> 2] = HEAP32[i47 >> 2];
          HEAP32[i6 + 4 >> 2] = HEAP32[i32 >> 2];
          HEAP32[i6 + 8 >> 2] = HEAP32[i33 >> 2];
          HEAP32[i33 >> 2] = 0;
          HEAP32[i32 >> 2] = 0;
          HEAP32[i47 >> 2] = 0;
          HEAP32[i34 >> 2] = i6 + 16;
          __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i16, i44);
          __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i44);
         }
         __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        i6 = 1;
        i1 = i5;
        continue L93;
       } else if ((i50 | 0) == 64) {
        i50 = 0;
        i5 = __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
        if ((i5 | 0) == (i1 | 0) | (i5 | 0) == (i48 | 0)) break L53;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, (HEAP32[i42 >> 2] | 0) + -24 | 0);
        i3 = HEAP32[i42 >> 2] | 0;
        i1 = i3 + -24 | 0;
        i2 = i3;
        while (1) {
         if ((i2 | 0) == (i1 | 0)) break;
         i6 = i2 + -24 | 0;
         HEAP32[i42 >> 2] = i6;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
         i2 = HEAP32[i42 >> 2] | 0;
        }
        i2 = i3 + -48 | 0;
        i1 = HEAP8[i2 + 11 >> 0] | 0;
        if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + -44 >> 2] | 0; else i1 = i1 & 255;
        if (!i1) {
         __THREW__ = 0;
         invoke_vii(fb + 4622 | 0, i2 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 75;
          break L93;
         }
        } else {
         __THREW__ = 0;
         invoke_viii(fb + 1067 | 0, i47 | 0, gb + 1086571 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 76;
          break L93;
         }
         i6 = HEAP8[i39 >> 0] | 0;
         i4 = i6 << 24 >> 24 < 0;
         __THREW__ = 0;
         invoke_iiii(fb + 519 | 0, i2 | 0, (i4 ? HEAP32[i47 >> 2] | 0 : i47) | 0, (i4 ? HEAP32[i40 >> 2] | 0 : i6 & 255) | 0) | 0;
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 77;
          break L93;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
        }
        i6 = (HEAP32[i42 >> 2] | 0) + -24 | 0;
        HEAP32[i46 >> 2] = HEAP32[i7 >> 2];
        __THREW__ = 0;
        invoke_viii(fb + 1065 | 0, i47 | 0, i6 | 0, i46 | 0);
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i50 = 87;
         break L93;
        }
        i1 = HEAP32[i41 >> 2] | 0;
        i6 = HEAP32[i17 >> 2] | 0;
        i3 = i6;
        if (i1 >>> 0 < i6 >>> 0) {
         HEAP32[i1 + 12 >> 2] = HEAP32[i35 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i47 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i36 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i37 >> 2];
         HEAP32[i37 >> 2] = 0;
         HEAP32[i36 >> 2] = 0;
         HEAP32[i47 >> 2] = 0;
         HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 16;
        } else {
         i4 = HEAP32[i16 >> 2] | 0;
         i1 = i1 - i4 >> 4;
         i2 = i1 + 1 | 0;
         if (i2 >>> 0 > 268435455) {
          i50 = 84;
          break L93;
         }
         i4 = i3 - i4 | 0;
         i6 = i4 >> 3;
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i43, i4 >> 4 >>> 0 < 134217727 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 268435455, i1, i21);
         i6 = HEAP32[i38 >> 2] | 0;
         HEAP32[i6 + 12 >> 2] = HEAP32[i35 >> 2];
         HEAP32[i6 >> 2] = HEAP32[i47 >> 2];
         HEAP32[i6 + 4 >> 2] = HEAP32[i36 >> 2];
         HEAP32[i6 + 8 >> 2] = HEAP32[i37 >> 2];
         HEAP32[i37 >> 2] = 0;
         HEAP32[i36 >> 2] = 0;
         HEAP32[i47 >> 2] = 0;
         HEAP32[i38 >> 2] = i6 + 16;
         __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i16, i43);
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i43);
        }
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        i6 = 1;
        i1 = i5;
        continue L93;
       } else if ((i50 | 0) == 90) {
        i50 = 0;
        i2 = i1 + 1 | 0;
        if ((i2 | 0) != (i48 | 0)) switch (HEAP8[i2 >> 0] | 0) {
        case 84:
        case 116:
         break;
        default:
         break L113;
        }
        i5 = __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
        if ((i5 | 0) == (i1 | 0) | (i5 | 0) == (i48 | 0)) break L53;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, (HEAP32[i42 >> 2] | 0) + -24 | 0);
        i3 = HEAP32[i42 >> 2] | 0;
        i1 = i3 + -24 | 0;
        i2 = i3;
        while (1) {
         if ((i2 | 0) == (i1 | 0)) break;
         i6 = i2 + -24 | 0;
         HEAP32[i42 >> 2] = i6;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
         i2 = HEAP32[i42 >> 2] | 0;
        }
        i2 = i3 + -48 | 0;
        i1 = HEAP8[i2 + 11 >> 0] | 0;
        if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + -44 >> 2] | 0; else i1 = i1 & 255;
        if (!i1) {
         __THREW__ = 0;
         invoke_vii(fb + 4622 | 0, i2 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 103;
          break L93;
         }
        } else {
         __THREW__ = 0;
         invoke_viii(fb + 1067 | 0, i47 | 0, gb + 1086571 | 0, i53 | 0);
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 104;
          break L93;
         }
         i6 = HEAP8[i12 >> 0] | 0;
         i4 = i6 << 24 >> 24 < 0;
         __THREW__ = 0;
         invoke_iiii(fb + 519 | 0, i2 | 0, (i4 ? HEAP32[i47 >> 2] | 0 : i47) | 0, (i4 ? HEAP32[i13 >> 2] | 0 : i6 & 255) | 0) | 0;
         i6 = __THREW__;
         __THREW__ = 0;
         if (i6 & 1) {
          i50 = 105;
          break L93;
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
        }
        i6 = (HEAP32[i42 >> 2] | 0) + -24 | 0;
        HEAP32[i43 >> 2] = HEAP32[i7 >> 2];
        __THREW__ = 0;
        invoke_viii(fb + 1065 | 0, i47 | 0, i6 | 0, i43 | 0);
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i50 = 115;
         break L93;
        }
        i1 = HEAP32[i41 >> 2] | 0;
        i6 = HEAP32[i17 >> 2] | 0;
        i3 = i6;
        if (i1 >>> 0 < i6 >>> 0) {
         HEAP32[i1 + 12 >> 2] = HEAP32[i8 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i47 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i10 >> 2];
         HEAP32[i10 >> 2] = 0;
         HEAP32[i9 >> 2] = 0;
         HEAP32[i47 >> 2] = 0;
         HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 16;
        } else {
         i4 = HEAP32[i16 >> 2] | 0;
         i1 = i1 - i4 >> 4;
         i2 = i1 + 1 | 0;
         if (i2 >>> 0 > 268435455) {
          i50 = 112;
          break L93;
         }
         i4 = i3 - i4 | 0;
         i6 = i4 >> 3;
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i46, i4 >> 4 >>> 0 < 134217727 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 268435455, i1, i21);
         i6 = HEAP32[i11 >> 2] | 0;
         HEAP32[i6 + 12 >> 2] = HEAP32[i8 >> 2];
         HEAP32[i6 >> 2] = HEAP32[i47 >> 2];
         HEAP32[i6 + 4 >> 2] = HEAP32[i9 >> 2];
         HEAP32[i6 + 8 >> 2] = HEAP32[i10 >> 2];
         HEAP32[i10 >> 2] = 0;
         HEAP32[i9 >> 2] = 0;
         HEAP32[i47 >> 2] = 0;
         HEAP32[i11 >> 2] = i6 + 16;
         __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i16, i46);
         __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i46);
        }
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        i6 = 1;
        i1 = i5;
        continue L93;
       } while (0);
       i5 = __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
       if ((i5 | 0) == (i1 | 0) | (i5 | 0) == (i48 | 0)) break L53;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i47, (HEAP32[i42 >> 2] | 0) + -24 | 0);
       i3 = HEAP32[i42 >> 2] | 0;
       i1 = i3 + -24 | 0;
       i2 = i3;
       while (1) {
        if ((i2 | 0) == (i1 | 0)) break;
        i6 = i2 + -24 | 0;
        HEAP32[i42 >> 2] = i6;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
        i2 = HEAP32[i42 >> 2] | 0;
       }
       i2 = i3 + -48 | 0;
       i1 = HEAP8[i2 + 11 >> 0] | 0;
       if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + -44 >> 2] | 0; else i1 = i1 & 255;
       if (!i1) {
        __THREW__ = 0;
        invoke_vii(fb + 4622 | 0, i2 | 0, i47 | 0);
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i50 = 146;
         break;
        }
       } else {
        __THREW__ = 0;
        invoke_viii(fb + 1067 | 0, i53 | 0, gb + 1086571 | 0, i47 | 0);
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i50 = 147;
         break;
        }
        i6 = HEAP8[i27 >> 0] | 0;
        i4 = i6 << 24 >> 24 < 0;
        __THREW__ = 0;
        invoke_iiii(fb + 519 | 0, i2 | 0, (i4 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i4 ? HEAP32[i28 >> 2] | 0 : i6 & 255) | 0) | 0;
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i50 = 148;
         break;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
       }
       i6 = (HEAP32[i42 >> 2] | 0) + -24 | 0;
       HEAP32[i43 >> 2] = HEAP32[i7 >> 2];
       __THREW__ = 0;
       invoke_viii(fb + 1065 | 0, i46 | 0, i6 | 0, i43 | 0);
       i6 = __THREW__;
       __THREW__ = 0;
       if (i6 & 1) {
        i50 = 159;
        break;
       }
       i1 = HEAP32[i41 >> 2] | 0;
       i6 = HEAP32[i17 >> 2] | 0;
       i3 = i6;
       if (i1 >>> 0 < i6 >>> 0) {
        HEAP32[i1 + 12 >> 2] = HEAP32[i23 >> 2];
        HEAP32[i1 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i24 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i25 >> 2];
        HEAP32[i25 >> 2] = 0;
        HEAP32[i24 >> 2] = 0;
        HEAP32[i46 >> 2] = 0;
        HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 16;
       } else {
        i4 = HEAP32[i16 >> 2] | 0;
        i1 = i1 - i4 >> 4;
        i2 = i1 + 1 | 0;
        if (i2 >>> 0 > 268435455) {
         i50 = 155;
         break;
        }
        i4 = i3 - i4 | 0;
        i6 = i4 >> 3;
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i53, i4 >> 4 >>> 0 < 134217727 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 268435455, i1, i21);
        i6 = HEAP32[i26 >> 2] | 0;
        HEAP32[i6 + 12 >> 2] = HEAP32[i23 >> 2];
        HEAP32[i6 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i6 + 4 >> 2] = HEAP32[i24 >> 2];
        HEAP32[i6 + 8 >> 2] = HEAP32[i25 >> 2];
        HEAP32[i25 >> 2] = 0;
        HEAP32[i24 >> 2] = 0;
        HEAP32[i46 >> 2] = 0;
        HEAP32[i26 >> 2] = i6 + 16;
        __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i16, i53);
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i53);
       }
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i46);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
       i6 = 1;
       i1 = i5;
      }
      switch (i50 | 0) {
      case 52:
       {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i16 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        i50 = 60;
        break;
       }
      case 55:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 63;
        break;
       }
      case 56:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 58;
        break;
       }
      case 57:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
        i50 = 58;
        break;
       }
      case 59:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 60;
        break;
       }
      case 75:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 89;
        break;
       }
      case 76:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 78;
        break;
       }
      case 77:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
        i50 = 78;
        break;
       }
      case 84:
       {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i16 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        i50 = 88;
        break;
       }
      case 87:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 88;
        break;
       }
      case 103:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 117;
        break;
       }
      case 104:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 106;
        break;
       }
      case 105:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
        i50 = 106;
        break;
       }
      case 112:
       {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i16 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        i50 = 116;
        break;
       }
      case 115:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 116;
        break;
       }
      case 127:
       {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i16 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i46);
        i50 = 132;
        break;
       }
      case 130:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 133;
        break;
       }
      case 131:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 132;
        break;
       }
      case 146:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 161;
        break;
       }
      case 147:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 149;
        break;
       }
      case 148:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        i50 = 149;
        break;
       }
      case 155:
       {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i16 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i46);
        i50 = 160;
        break;
       }
      case 159:
       {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        i50 = 160;
        break;
       }
      case 163:
       {
        i1 = i1 + 1 | 0;
        HEAP32[i49 + 48 >> 2] = HEAP32[i45 >> 2];
        L230 : do if (i6) {
         i2 = HEAP32[i41 >> 2] | 0;
         if ((HEAP32[i49 + 16 >> 2] | 0) != (i2 | 0)) {
          i3 = i2 + -16 | 0;
          while (1) {
           if ((i2 | 0) == (i3 | 0)) break L230;
           i53 = i2 + -16 | 0;
           HEAP32[i41 >> 2] = i53;
           __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i53);
           i2 = HEAP32[i41 >> 2] | 0;
          }
         }
        } while (0);
        break L51;
       }
      }
      if ((i50 | 0) == 58) i50 = 63; else if ((i50 | 0) == 60) i50 = 63; else if ((i50 | 0) == 78) i50 = 89; else if ((i50 | 0) == 88) i50 = 89; else if ((i50 | 0) == 106) i50 = 117; else if ((i50 | 0) == 116) i50 = 117; else if ((i50 | 0) == 132) i50 = 133; else if ((i50 | 0) == 149) i50 = 161; else if ((i50 | 0) == 160) i50 = 161;
      if ((i50 | 0) == 63) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53); else if ((i50 | 0) == 89) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53); else if ((i50 | 0) == 117) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53); else if ((i50 | 0) == 133) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53); else if ((i50 | 0) == 161) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i47);
      ___resumeException(i1 | 0);
     } while (0);
     i1 = i51;
    } else i1 = i51; while (0);
    i1 = (i1 | 0) == (i51 | 0) ? i52 : i1;
    break L1;
   }
  case 90:
   {
    L260 : do if (i1 << 24 >> 24 == 90 & (i51 | 0) != (i48 | 0)) {
     i50 = i51 + 1 | 0;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i50, i48, i49) | 0;
     if ((i1 | 0) == (i50 | 0) | (i1 | 0) == (i48 | 0)) i1 = i51; else if ((HEAP8[i1 >> 0] | 0) == 69) {
      i2 = i1 + 1 | 0;
      if ((i2 | 0) == (i48 | 0)) i1 = i51; else {
       switch (HEAP8[i2 >> 0] | 0) {
       case 115:
        {
         i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_discriminatorEPKcS2_(i1 + 2 | 0, i48) | 0;
         i2 = HEAP32[i49 + 4 >> 2] | 0;
         if ((HEAP32[i49 >> 2] | 0) == (i2 | 0)) break L260;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i2 + -24 | 0, gb + 1086574 | 0) | 0;
         break L260;
        }
       case 100:
        {
         i1 = i1 + 2 | 0;
         if ((i1 | 0) == (i48 | 0)) {
          i1 = i51;
          break L260;
         }
         i1 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i1, i48) | 0;
         if ((i1 | 0) == (i48 | 0)) {
          i1 = i51;
          break L260;
         }
         if ((HEAP8[i1 >> 0] | 0) != 95) {
          i1 = i51;
          break L260;
         }
         i50 = i1 + 1 | 0;
         i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_(i50, i48, i49) | 0;
         i5 = i49 + 4 | 0;
         if ((i1 | 0) == (i50 | 0)) {
          i2 = HEAP32[i5 >> 2] | 0;
          i1 = i2 + -24 | 0;
          while (1) {
           if ((i2 | 0) == (i1 | 0)) {
            i1 = i51;
            break L260;
           }
           i53 = i2 + -24 | 0;
           HEAP32[i5 >> 2] = i53;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i53);
           i2 = HEAP32[i5 >> 2] | 0;
          }
         }
         i2 = HEAP32[i5 >> 2] | 0;
         if (((i2 - (HEAP32[i49 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
          i1 = i51;
          break L260;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i50 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i50;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i50);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         __THREW__ = 0;
         invoke_iii(fb + 1152 | 0, i2 + -48 | 0, gb + 1086571 | 0) | 0;
         i50 = __THREW__;
         __THREW__ = 0;
         if (!(i50 & 1)) {
          i50 = HEAP8[i53 + 11 >> 0] | 0;
          i49 = i50 << 24 >> 24 < 0;
          __THREW__ = 0;
          invoke_iiii(fb + 519 | 0, (HEAP32[i5 >> 2] | 0) + -24 | 0, (i49 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i49 ? HEAP32[i53 + 4 >> 2] | 0 : i50 & 255) | 0) | 0;
          i50 = __THREW__;
          __THREW__ = 0;
          if (!(i50 & 1)) {
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
           break L260;
          }
         }
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
         break;
        }
       default:
        {
         i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_(i2, i48, i49) | 0;
         if ((i1 | 0) == (i2 | 0)) {
          i1 = i49 + 4 | 0;
          i3 = HEAP32[i1 >> 2] | 0;
          i2 = i3 + -24 | 0;
          while (1) {
           if ((i3 | 0) == (i2 | 0)) {
            i1 = i51;
            break L260;
           }
           i53 = i3 + -24 | 0;
           HEAP32[i1 >> 2] = i53;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i53);
           i3 = HEAP32[i1 >> 2] | 0;
          }
         }
         i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_discriminatorEPKcS2_(i1, i48) | 0;
         i5 = i49 + 4 | 0;
         i2 = HEAP32[i5 >> 2] | 0;
         if (((i2 - (HEAP32[i49 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L260;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, i2 + -24 | 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + -24 | 0;
         i4 = i2;
         while (1) {
          if ((i4 | 0) == (i3 | 0)) break;
          i50 = i4 + -24 | 0;
          HEAP32[i5 >> 2] = i50;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i50);
          i4 = HEAP32[i5 >> 2] | 0;
         }
         __THREW__ = 0;
         invoke_iii(fb + 1152 | 0, i2 + -48 | 0, gb + 1086571 | 0) | 0;
         i50 = __THREW__;
         __THREW__ = 0;
         if (!(i50 & 1)) {
          i50 = HEAP8[i53 + 11 >> 0] | 0;
          i49 = i50 << 24 >> 24 < 0;
          __THREW__ = 0;
          invoke_iiii(fb + 519 | 0, (HEAP32[i5 >> 2] | 0) + -24 | 0, (i49 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i49 ? HEAP32[i53 + 4 >> 2] | 0 : i50 & 255) | 0) | 0;
          i50 = __THREW__;
          __THREW__ = 0;
          if (!(i50 & 1)) {
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
           break L260;
          }
         }
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
        }
       }
       ___resumeException(i1 | 0);
      }
     } else i1 = i51;
    } else i1 = i51; while (0);
    i1 = (i1 | 0) == (i51 | 0) ? i52 : i1;
    break L1;
   }
  default:
   {
    L5 : do if ((i6 - i51 | 0) > 1) {
     if (i1 << 24 >> 24 == 83) if ((HEAP8[i51 + 1 >> 0] | 0) == 116) {
      i1 = i51 + 2 | 0;
      if ((i1 | 0) == (i48 | 0)) {
       i3 = 0;
       i2 = i48;
      } else {
       i3 = 0;
       i2 = (HEAP8[i1 >> 0] | 0) == 76 ? i51 + 3 | 0 : i1;
      }
     } else {
      i3 = 1;
      i2 = i51;
     } else {
      i3 = 1;
      i2 = i51;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_(i2, i48, i49) | 0;
     i2 = (i1 | 0) == (i2 | 0);
     if (i3 | i2) i1 = i2 ? i51 : i1; else {
      i2 = HEAP32[i49 + 4 >> 2] | 0;
      if ((HEAP32[i49 >> 2] | 0) == (i2 | 0)) {
       i50 = 232;
       break;
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i2 + -24 | 0, 0, gb + 1086591 | 0) | 0;
     }
     if ((i1 | 0) == (i51 | 0)) i50 = 232; else {
      if ((i1 | 0) == (i48 | 0)) {
       i1 = i48;
       break L1;
      }
      if ((HEAP8[i1 >> 0] | 0) != 73) break L1;
      i7 = i49 + 4 | 0;
      i2 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i49 >> 2] | 0) == (i2 | 0)) {
       i1 = i52;
       break L1;
      }
      i6 = i49 + 16 | 0;
      HEAP32[i46 >> 2] = HEAP32[i49 + 12 >> 2];
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i47, i2 + -24 | 0, i46);
      i2 = i49 + 20 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i51 = HEAP32[i49 + 24 >> 2] | 0;
      i5 = i51;
      do if (i3 >>> 0 < i51 >>> 0) {
       HEAP32[i3 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
       HEAP32[i3 >> 2] = HEAP32[i47 >> 2];
       i51 = i47 + 4 | 0;
       HEAP32[i3 + 4 >> 2] = HEAP32[i51 >> 2];
       i46 = i47 + 8 | 0;
       HEAP32[i3 + 8 >> 2] = HEAP32[i46 >> 2];
       HEAP32[i46 >> 2] = 0;
       HEAP32[i51 >> 2] = 0;
       HEAP32[i47 >> 2] = 0;
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
      } else {
       i4 = HEAP32[i6 >> 2] | 0;
       i2 = i3 - i4 >> 4;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 268435455) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i6 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
        break L5;
       } else {
        i46 = i5 - i4 | 0;
        i51 = i46 >> 3;
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i53, i46 >> 4 >>> 0 < 134217727 ? (i51 >>> 0 < i3 >>> 0 ? i3 : i51) : 268435455, i2, i49 + 28 | 0);
        i51 = i53 + 8 | 0;
        i46 = HEAP32[i51 >> 2] | 0;
        HEAP32[i46 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
        HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
        i45 = i47 + 4 | 0;
        HEAP32[i46 + 4 >> 2] = HEAP32[i45 >> 2];
        i44 = i47 + 8 | 0;
        HEAP32[i46 + 8 >> 2] = HEAP32[i44 >> 2];
        HEAP32[i44 >> 2] = 0;
        HEAP32[i45 >> 2] = 0;
        HEAP32[i47 >> 2] = 0;
        HEAP32[i51 >> 2] = i46 + 16;
        __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i6, i53);
        __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i53);
        break;
       }
      } while (0);
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i47);
      i4 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i1, i48, i49) | 0;
      if ((i4 | 0) == (i1 | 0)) {
       i1 = i52;
       break L1;
      }
      i1 = HEAP32[i7 >> 2] | 0;
      if (((i1 - (HEAP32[i49 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
       i1 = i52;
       break L1;
      }
      __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, i1 + -24 | 0);
      i1 = HEAP32[i7 >> 2] | 0;
      i2 = i1 + -24 | 0;
      i3 = i1;
      while (1) {
       if ((i3 | 0) == (i2 | 0)) break;
       i52 = i3 + -24 | 0;
       HEAP32[i7 >> 2] = i52;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i52);
       i3 = HEAP32[i7 >> 2] | 0;
      }
      i52 = HEAP8[i53 + 11 >> 0] | 0;
      i51 = i52 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i1 + -48 | 0, (i51 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i51 ? HEAP32[i53 + 4 >> 2] | 0 : i52 & 255) | 0) | 0;
      i52 = __THREW__;
      __THREW__ = 0;
      if (i52 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
       i1 = i4;
       break L1;
      }
     }
    } else i50 = 232; while (0);
    do if ((i50 | 0) == 232) {
     i2 = __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_(i51, i48, i49) | 0;
     if ((i2 | 0) == (i51 | 0) | (i2 | 0) == (i48 | 0)) {
      i1 = i52;
      break L1;
     }
     if ((HEAP8[i2 >> 0] | 0) != 73) {
      i1 = i52;
      break L1;
     }
     i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i2, i48, i49) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i52;
      break L1;
     }
     i5 = i49 + 4 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (((i2 - (HEAP32[i49 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
      i1 = i52;
      break L1;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i53, i2 + -24 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i52 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i52;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i52);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     i52 = HEAP8[i53 + 11 >> 0] | 0;
     i51 = i52 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i51 ? HEAP32[i53 >> 2] | 0 : i53) | 0, (i51 ? HEAP32[i53 + 4 >> 2] | 0 : i52 & 255) | 0) | 0;
     i52 = __THREW__;
     __THREW__ = 0;
     if (i52 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
      break;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i53);
      break L1;
     }
    } while (0);
    ___resumeException(i1 | 0);
   }
  }
 } else i1 = i52; while (0);
 STACKTOP = i54;
 return i1 | 0;
}

function __ZL20PrepareShadowMapsJobP18ShadowMapJobHeader(i131) {
 i131 = i131 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i132 = 0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, d138 = 0.0, d139 = 0.0, d140 = 0.0;
 i132 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i129 = i132 + 16 | 0;
 i128 = i132;
 i126 = i132 + 520 | 0;
 i125 = i132 + 456 | 0;
 i127 = i132 + 360 | 0;
 i117 = i132 + 264 | 0;
 i118 = i132 + 240 | 0;
 i119 = i132 + 228 | 0;
 i121 = i132 + 216 | 0;
 i122 = i132 + 152 | 0;
 i123 = i132 + 88 | 0;
 i112 = i132 + 80 | 0;
 i113 = i131 + 8 | 0;
 i124 = HEAP32[i113 >> 2] | 0;
 if ((HEAP16[gb + 1113132 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1113132 | 0, HEAP32[i124 + 16 >> 2] | 0);
  i130 = gb + 1113132 | 0;
 } else i130 = 0;
 i66 = HEAP32[i131 + 20 >> 2] | 0;
 i67 = HEAP32[i131 + 24 >> 2] | 0;
 i58 = i131 + 34040 | 0;
 i114 = i131 + 176 | 0;
 i115 = i131 + 200 | 0;
 i61 = i131 + 1204 | 0;
 i60 = HEAP32[i124 + 268 >> 2] | 0;
 i116 = HEAP32[i124 + 272 >> 2] | 0;
 HEAP32[i61 >> 2] = HEAP32[i124 + 264 >> 2];
 i59 = i131 + 1208 | 0;
 HEAP32[i59 >> 2] = i60;
 i60 = i131 + 1212 | 0;
 HEAP32[i60 >> 2] = i116;
 i116 = i131 + 1216 | 0;
 i29 = HEAP32[i124 + 252 >> 2] | 0;
 i62 = HEAP32[i124 + 256 >> 2] | 0;
 HEAP32[i116 >> 2] = HEAP32[i124 + 248 >> 2];
 HEAP32[i131 + 1220 >> 2] = i29;
 HEAP32[i131 + 1224 >> 2] = i62;
 i62 = i124 + 40 | 0;
 i29 = HEAP32[i62 >> 2] | 0;
 i63 = i124 + 204 | 0;
 i64 = i124 + 48 | 0;
 HEAP32[i131 + 1188 >> 2] = HEAP32[((i29 | 0) == 3 ? i63 : i64) >> 2];
 HEAP32[i131 + 1192 >> 2] = HEAP32[i124 + 96 >> 2];
 HEAP32[i131 + 1196 >> 2] = HEAP32[i124 + 112 >> 2];
 HEAP32[i131 + 1200 >> 2] = HEAP32[i124 + 116 >> 2];
 HEAP32[i131 + 1184 >> 2] = i29;
 i65 = HEAP32[i124 + 120 >> 2] | 0;
 i29 = (i29 | 0) == 1;
 i30 = i131 + 1144 | 0;
 i31 = HEAP32[i30 >> 2] | 0;
 i120 = i131 + 1152 | 0;
 i32 = i131 + 1168 | 0;
 i33 = HEAP32[i131 + 34032 >> 2] | 0;
 if ((HEAP16[gb + 1113060 + 6 >> 1] | 0) > -1) {
  HEAP32[i128 >> 2] = 0;
  HEAP32[i129 >> 2] = HEAP32[i128 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113060 | 0, i129);
  i57 = gb + 1113060 | 0;
 } else i57 = 0;
 f11 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f17 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f4 = Math_fround(-f11);
 f10 = Math_fround(-f17);
 f18 = Math_fround(-f16);
 if ((i33 | 0) > 0) {
  i34 = i131 + 1228 | 0;
  i35 = i131 + 1172 | 0;
  i36 = i131 + 764 | 0;
  i37 = (i31 | 0) == 0;
  i38 = i128 + 4 | 0;
  i39 = i128 + 8 | 0;
  i40 = i128 + 12 | 0;
  i41 = i131 + 1176 | 0;
  i42 = i129 + 8 | 0;
  i43 = i129 + 4 | 0;
  i44 = i129 + 12 | 0;
  i45 = i129 + 16 | 0;
  i46 = i129 + 20 | 0;
  i47 = i131 + 1156 | 0;
  i48 = i131 + 1160 | 0;
  i49 = i131 + 180 | 0;
  i50 = i131 + 184 | 0;
  i51 = i131 + 188 | 0;
  i52 = i131 + 192 | 0;
  i53 = i131 + 196 | 0;
  i28 = 0;
  do {
   i25 = HEAP32[i34 >> 2] | 0;
   i27 = i25 + (i28 * 360 | 0) + 128 | 0;
   i22 = (HEAP32[i35 >> 2] | 0) - (HEAP32[i32 >> 2] | 0) >> 4;
   i6 = HEAP32[i25 + (i28 * 360 | 0) + 244 >> 2] | 0;
   i7 = HEAP32[i25 + (i28 * 360 | 0) + 324 >> 2] | 0;
   if (i29) i26 = __Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i27, i36) | 0; else i26 = 0;
   if ((i6 | 0) > 0) {
    i8 = i25 + (i28 * 360 | 0) + 182 | 0;
    i9 = i25 + (i28 * 360 | 0) + 180 | 0;
    if (i37) {
     i5 = 0;
     do {
      i1 = HEAP32[i7 + (i5 << 3) >> 2] | 0;
      if (i1 | 0) {
       i2 = HEAP32[i1 + 8 >> 2] | 0;
       if (i2 | 0) {
        i3 = __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(i2, i30, i1) | 0;
        if ((i3 | 0) >= 0) if (__ZNK6Shader24GetShadowCasterPassToUseEiRi(i2, i3, i129) | 0) {
         i110 = HEAP16[i8 >> 1] | 0;
         i111 = i110 & 65535;
         HEAP32[i128 >> 2] = (i110 << 16 >> 16 == 0 | (i111 | 0) > (i5 | 0) ? i5 : i111 + -1 | 0) + (HEAPU16[i9 >> 1] | 0);
         HEAP32[i38 >> 2] = i3;
         HEAP32[i39 >> 2] = i2;
         HEAP32[i40 >> 2] = i1;
         i1 = HEAP32[i35 >> 2] | 0;
         if ((i1 | 0) == (HEAP32[i41 >> 2] | 0)) __ZNSt3__26vectorI20ShadowCasterPartData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i32, i128); else {
          HEAP32[i1 >> 2] = HEAP32[i128 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i128 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i128 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i128 + 12 >> 2];
          HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 16;
         }
        }
       }
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i6 | 0));
    } else {
     i3 = 0;
     do {
      i2 = HEAP32[i7 + (i3 << 3) >> 2] | 0;
      if (i2 | 0) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if (i1 | 0) {
        i1 = __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(i1, i30, i2) | 0;
        if ((i1 | 0) >= 0) if (__ZNK6Shader24GetShadowCasterPassToUseEiRi(i31, i1, i129) | 0) {
         i110 = HEAP16[i8 >> 1] | 0;
         i111 = i110 & 65535;
         HEAP32[i128 >> 2] = (i110 << 16 >> 16 == 0 | (i111 | 0) > (i3 | 0) ? i3 : i111 + -1 | 0) + (HEAPU16[i9 >> 1] | 0);
         HEAP32[i38 >> 2] = i1;
         HEAP32[i39 >> 2] = i31;
         HEAP32[i40 >> 2] = i2;
         i1 = HEAP32[i35 >> 2] | 0;
         if ((i1 | 0) == (HEAP32[i41 >> 2] | 0)) __ZNSt3__26vectorI20ShadowCasterPartData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i32, i128); else {
          HEAP32[i1 >> 2] = HEAP32[i128 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i128 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i128 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i128 + 12 >> 2];
          HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 16;
         }
        }
       }
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i6 | 0));
    }
   }
   i1 = (HEAP32[i35 >> 2] | 0) - (HEAP32[i32 >> 2] | 0) >> 4;
   if ((i1 | 0) != (i22 | 0)) {
    HEAP32[i42 >> 2] = i28;
    HEAP32[i43 >> 2] = i27;
    HEAP32[i44 >> 2] = 1;
    HEAP32[i45 >> 2] = i22;
    HEAP32[i46 >> 2] = i1;
    i1 = HEAP32[i47 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i48 >> 2] | 0)) __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i120, i129); else {
     HEAP32[i1 >> 2] = HEAP32[i129 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i129 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i129 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i129 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i129 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i129 + 20 >> 2];
     HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + 24;
    }
    f13 = Math_fround(HEAPF32[i27 >> 2]);
    i2 = i25 + (i28 * 360 | 0) + 140 | 0;
    f14 = Math_fround(HEAPF32[i2 >> 2]);
    f15 = Math_fround(f13 - f14);
    i3 = i25 + (i28 * 360 | 0) + 132 | 0;
    f19 = Math_fround(HEAPF32[i3 >> 2]);
    i5 = i25 + (i28 * 360 | 0) + 144 | 0;
    f20 = Math_fround(HEAPF32[i5 >> 2]);
    f23 = Math_fround(f19 - f20);
    i6 = i25 + (i28 * 360 | 0) + 136 | 0;
    f21 = Math_fround(HEAPF32[i6 >> 2]);
    i1 = i25 + (i28 * 360 | 0) + 148 | 0;
    f12 = Math_fround(HEAPF32[i1 >> 2]);
    f24 = Math_fround(f21 - f12);
    if (i26) {
     f55 = Math_fround(HEAPF32[i114 >> 2]);
     f56 = Math_fround(HEAPF32[i49 >> 2]);
     f54 = Math_fround(HEAPF32[i50 >> 2]);
     HEAPF32[i114 >> 2] = f15 < f55 ? f15 : f55;
     HEAPF32[i49 >> 2] = f23 < f56 ? f23 : f56;
     HEAPF32[i50 >> 2] = f24 < f54 ? f24 : f54;
     f23 = Math_fround(HEAPF32[i27 >> 2]);
     f23 = Math_fround(f23 + Math_fround(HEAPF32[i2 >> 2]));
     f54 = Math_fround(HEAPF32[i3 >> 2]);
     f54 = Math_fround(f54 + Math_fround(HEAPF32[i5 >> 2]));
     f56 = Math_fround(HEAPF32[i6 >> 2]);
     f56 = Math_fround(f56 + Math_fround(HEAPF32[i1 >> 2]));
     f24 = Math_fround(HEAPF32[i51 >> 2]);
     f55 = Math_fround(HEAPF32[i52 >> 2]);
     f68 = Math_fround(HEAPF32[i53 >> 2]);
     HEAPF32[i51 >> 2] = f24 < f23 ? f23 : f24;
     HEAPF32[i52 >> 2] = f55 < f54 ? f54 : f55;
     HEAPF32[i53 >> 2] = f68 < f56 ? f56 : f68;
    } else {
     f55 = Math_fround(f13 + f14);
     f56 = Math_fround(f19 + f20);
     f68 = Math_fround(f21 + f12);
     f11 = f15 < f11 ? f15 : f11;
     f4 = f4 < f55 ? f55 : f4;
     f10 = f10 < f56 ? f56 : f10;
     f18 = f18 < f68 ? f68 : f18;
     f17 = f23 < f17 ? f23 : f17;
     f16 = f24 < f16 ? f24 : f16;
    }
   }
   i28 = i28 + 1 | 0;
  } while ((i28 | 0) != (i33 | 0));
  i7 = i114;
  f21 = f11;
  f20 = f4;
  f19 = f10;
  f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 } else {
  i7 = i114;
  f21 = f11;
  f20 = f4;
  f19 = f10;
  f4 = f11;
 }
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 if (f15 == f4) {
  i1 = i131 + 180 | 0;
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  if (f10 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   i2 = i131 + 184 | 0;
   f11 = Math_fround(HEAPF32[i2 >> 2]);
   if (f11 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
    i3 = i131 + 188 | 0;
    f13 = Math_fround(HEAPF32[i3 >> 2]);
    i5 = i131 + 192 | 0;
    f12 = Math_fround(HEAPF32[i5 >> 2]);
    i111 = i131 + 196 | 0;
    i6 = i111;
    f4 = Math_fround(HEAPF32[i111 >> 2]);
    i111 = 50;
   } else i111 = 13;
  } else i111 = 13;
 } else i111 = 13;
 if ((i111 | 0) == 13) {
  f68 = Math_fround(-f4);
  f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i3 = i131 + 188 | 0;
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  if (f13 == f68) {
   f68 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   i5 = i131 + 192 | 0;
   f12 = Math_fround(HEAPF32[i5 >> 2]);
   if (f12 == f68) {
    i6 = i131 + 196 | 0;
    f14 = Math_fround(HEAPF32[i6 >> 2]);
    if (!(f14 != f4)) {
     i1 = i131 + 180 | 0;
     f10 = Math_fround(HEAPF32[i1 >> 2]);
     i111 = i131 + 184 | 0;
     i2 = i111;
     f11 = Math_fround(HEAPF32[i111 >> 2]);
     f4 = f14;
     i111 = 50;
    }
   }
  }
 }
 if ((i111 | 0) == 50) {
  HEAPF32[i7 >> 2] = f21 < f15 ? f21 : f15;
  HEAPF32[i1 >> 2] = f17 < f10 ? f17 : f10;
  HEAPF32[i2 >> 2] = f16 < f11 ? f16 : f11;
  HEAPF32[i3 >> 2] = f13 < f20 ? f20 : f13;
  HEAPF32[i5 >> 2] = f12 < f19 ? f19 : f12;
  HEAPF32[i6 >> 2] = f4 < f18 ? f18 : f4;
 }
 if (i57 | 0) __Z12profiler_endP19ProfilerInformation(i57);
 i108 = i131 + 36859 | 0;
 i26 = i58;
 i25 = i26 + 64 | 0;
 do {
  HEAP32[i26 >> 2] = 0;
  i26 = i26 + 4 | 0;
 } while ((i26 | 0) < (i25 | 0));
 if (!(HEAP8[i108 >> 0] | 0)) {
  i26 = i131 + 34104 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
  i26 = i131 + 34168 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
  i26 = i131 + 34232 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
 } else {
  HEAPF32[i131 + 34096 >> 2] = Math_fround(1.0);
  i26 = i131 + 34104 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
  HEAPF32[i131 + 34160 >> 2] = Math_fround(1.0);
  i26 = i131 + 34168 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
  HEAPF32[i131 + 34224 >> 2] = Math_fround(1.0);
  i26 = i131 + 34232 | 0;
  i25 = i26 + 64 | 0;
  do {
   HEAP32[i26 >> 2] = 0;
   i26 = i26 + 4 | 0;
  } while ((i26 | 0) < (i25 | 0));
  HEAPF32[i131 + 34288 >> 2] = Math_fround(1.0);
 }
 L79 : do if ((HEAP32[i131 + 1156 >> 2] | 0) != (HEAP32[i120 >> 2] | 0)) switch (HEAP32[i62 >> 2] | 0) {
 case 2:
  {
   i2 = i128 + 4 | 0;
   i3 = i128 + 8 | 0;
   f4 = (HEAP32[tempDoublePtr >> 2] = i65, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = 0;
   do {
    i127 = i131 + 35888 + (i1 << 6) | 0;
    i124 = i1 * 3 | 0;
    i126 = i124 + 2 | 0;
    i125 = gb + 1113232 + (i126 * 12 | 0) | 0;
    __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i127, gb + 1113232 + (i124 * 12 | 0) | 0, gb + 1113232 + ((i124 + 1 | 0) * 12 | 0) | 0, i125) | 0;
    f68 = Math_fround(-Math_fround(HEAPF32[i125 >> 2]));
    f55 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i126 * 12 | 0) + 4 >> 2]));
    f56 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i126 * 12 | 0) + 8 >> 2]));
    HEAPF32[i131 + 36656 + (i1 * 12 | 0) >> 2] = f68;
    HEAPF32[i131 + 36656 + (i1 * 12 | 0) + 4 >> 2] = f55;
    HEAPF32[i131 + 36656 + (i1 * 12 | 0) + 8 >> 2] = f56;
    f56 = Math_fround(HEAPF32[i61 >> 2]);
    f55 = Math_fround(HEAPF32[i59 >> 2]);
    f55 = Math_fround(-f55);
    f68 = Math_fround(-Math_fround(HEAPF32[i60 >> 2]));
    HEAPF32[i128 >> 2] = Math_fround(-f56);
    HEAPF32[i2 >> 2] = f55;
    HEAPF32[i3 >> 2] = f68;
    __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i129, i128) | 0;
    __ZN10Matrix4x4fmLERKS_(i127, i129) | 0;
    HEAP32[i128 >> 2] = i65;
    f68 = Math_fround(Math_fround(HEAPF32[((HEAP32[i62 >> 2] | 0) == 3 ? i63 : i64) >> 2]) * Math_fround(1.00999999));
    f55 = Math_fround(Math_fround(HEAPF32[i64 >> 2]) * Math_fround(.00999999977));
    i127 = f55 > Math_fround(.100000001);
    f55 = i127 ? Math_fround(.100000001) : f55;
    f56 = Math_fround(HEAPF32[i128 >> 2]);
    __ZN10Matrix4x4f14SetPerspectiveEffff(i131 + 36272 + (i1 << 6) | 0, Math_fround(90.0), Math_fround(1.0), f4 < f55 ? f55 : f56, f68) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 6);
   break;
  }
 case 1:
  {
   i104 = i131 + 34304 | 0;
   i109 = i131 + 35864 | 0;
   i110 = i131 + 35868 | 0;
   i105 = i131 + 35884 | 0;
   switch (HEAP32[i105 >> 2] | 0) {
   case 1:
    {
     HEAP32[i109 >> 2] = 1;
     HEAP32[i110 >> 2] = 1;
     i1 = 1;
     i2 = 1;
     break;
    }
   case 2:
    {
     HEAP32[i109 >> 2] = 2;
     HEAP32[i110 >> 2] = 1;
     i1 = 2;
     i2 = 1;
     break;
    }
   case 4:
    {
     HEAP32[i109 >> 2] = 2;
     HEAP32[i110 >> 2] = 2;
     i1 = 2;
     i2 = 2;
     break;
    }
   default:
    {
     HEAP32[i109 >> 2] = 1;
     HEAP32[i110 >> 2] = 1;
     i1 = 1;
     i2 = 1;
    }
   }
   i106 = i131 + 35880 | 0;
   HEAP32[i106 >> 2] = 0;
   i107 = i131 + 35872 | 0;
   HEAP32[i107 >> 2] = (i66 | 0) / (i1 | 0) | 0;
   i103 = i131 + 35876 | 0;
   HEAP32[i103 >> 2] = (i67 | 0) / (i2 | 0) | 0;
   i33 = i131 + 12 | 0;
   i34 = i131 + 180 | 0;
   i35 = i131 + 184 | 0;
   i36 = i131 + 188 | 0;
   i37 = i131 + 192 | 0;
   i38 = i131 + 196 | 0;
   i39 = i131 + 264 | 0;
   i40 = i131 + 988 | 0;
   i41 = i131 + 980 | 0;
   i42 = i131 + 16 | 0;
   i43 = i131 + 48 | 0;
   i44 = i126 + 12 | 0;
   i45 = i126 + 28 | 0;
   i46 = i126 + 44 | 0;
   i47 = i126 + 60 | 0;
   i48 = i126 + 8 | 0;
   i49 = i126 + 24 | 0;
   i50 = i126 + 40 | 0;
   i51 = i126 + 56 | 0;
   i52 = i126 + 4 | 0;
   i53 = i126 + 20 | 0;
   i57 = i126 + 36 | 0;
   i58 = i126 + 52 | 0;
   i59 = i126 + 16 | 0;
   i60 = i126 + 32 | 0;
   i61 = i126 + 48 | 0;
   i62 = i131 + 749 | 0;
   i63 = i131 + 1e3 | 0;
   i64 = i131 + 984 | 0;
   f68 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i65 = i118 + 12 | 0;
   i66 = i118 + 16 | 0;
   i67 = i118 + 4 | 0;
   i69 = i129 + 4 | 0;
   i70 = i129 + 8 | 0;
   i71 = i129 + 4 | 0;
   i72 = i129 + 8 | 0;
   i73 = i128 + 4 | 0;
   i74 = i128 + 8 | 0;
   i75 = i119 + 4 | 0;
   i76 = i119 + 8 | 0;
   i77 = i121 + 4 | 0;
   i78 = i121 + 8 | 0;
   i79 = i131 + 40 | 0;
   i80 = i122 + 20 | 0;
   i81 = i122 + 40 | 0;
   i82 = i122 + 48 | 0;
   i83 = i122 + 52 | 0;
   i84 = i122 + 56 | 0;
   i85 = i123 + 8 | 0;
   i86 = i123 + 24 | 0;
   i87 = i123 + 40 | 0;
   i88 = i123 + 56 | 0;
   i89 = i122 + 8 | 0;
   i90 = i131 + 112 | 0;
   i91 = i131 + 128 | 0;
   i92 = i122 + 4 | 0;
   i93 = i131 + 144 | 0;
   i94 = i131 + 160 | 0;
   i95 = i131 + 116 | 0;
   i96 = i131 + 132 | 0;
   i97 = i131 + 148 | 0;
   i98 = i131 + 164 | 0;
   i99 = i131 + 120 | 0;
   i100 = i131 + 136 | 0;
   i101 = i131 + 152 | 0;
   i102 = i131 + 168 | 0;
   i32 = 0;
   i1 = HEAP32[i109 >> 2] | 0;
   do {
    if ((i1 | 0) > 0) {
     i30 = 0;
     i31 = HEAP32[i106 >> 2] | 0;
     do {
      i27 = i131 + 34304 + (i31 * 364 | 0) + 260 | 0;
      __ZN10Matrix4x4f11SetIdentityEv(i27) | 0;
      i28 = i131 + 34304 + (i31 * 364 | 0) + 324 | 0;
      HEAP32[i28 >> 2] = HEAP32[gb + 1162364 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
      i29 = i131 + 34304 + (i31 * 364 | 0) + 336 | 0;
      HEAPF32[i29 >> 2] = Math_fround(-1.0e9);
      i3 = HEAP32[i106 >> 2] | 0;
      i9 = HEAP32[i107 >> 2] | 0;
      i25 = HEAP32[i103 >> 2] | 0;
      i6 = HEAP32[i33 >> 2] | 0;
      i8 = HEAP32[i113 >> 2] | 0;
      f56 = Math_fround(HEAPF32[i114 >> 2]);
      f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
      if (f56 == f4) {
       f56 = Math_fround(HEAPF32[i34 >> 2]);
       if (f56 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
        f56 = Math_fround(HEAPF32[i35 >> 2]);
        if (f56 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) i111 = 75; else i111 = 72;
       } else i111 = 72;
      } else i111 = 72;
      do if ((i111 | 0) == 72) {
       i111 = 0;
       f56 = Math_fround(-f4);
       f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
       if (Math_fround(HEAPF32[i36 >> 2]) == f56) {
        f56 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
        if (Math_fround(HEAPF32[i37 >> 2]) == f56) if (!(Math_fround(HEAPF32[i38 >> 2]) != f4)) {
         i111 = 75;
         break;
        }
       }
       f11 = Math_fround(HEAPF32[i40 >> 2]);
       i26 = HEAP32[i41 >> 2] | 0;
       HEAP32[i125 >> 2] = i26;
       i2 = HEAP32[i42 >> 2] | 0;
       f13 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if ((i2 | 0) == 1) {
        __Z20InvertMatrix4x4_FullPKfPf(i43, i126) | 0;
        f4 = Math_fround(HEAPF32[i44 >> 2]);
        f4 = Math_fround(f4 + Math_fround(HEAPF32[i45 >> 2]));
        f4 = Math_fround(f4 + Math_fround(HEAPF32[i46 >> 2]));
        f4 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + f4);
        i26 = f4 < Math_fround(0.0);
        f56 = Math_fround(-f4);
        if ((i26 ? f56 : f4) > Math_fround(1.00000001e-07)) {
         f55 = Math_fround(HEAPF32[i48 >> 2]);
         f55 = Math_fround(f55 + Math_fround(HEAPF32[i49 >> 2]));
         f55 = Math_fround(f55 + Math_fround(HEAPF32[i50 >> 2]));
         f55 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) + f55);
         f56 = Math_fround(HEAPF32[i52 >> 2]);
         f56 = Math_fround(f56 + Math_fround(HEAPF32[i53 >> 2]));
         f56 = Math_fround(f56 + Math_fround(HEAPF32[i57 >> 2]));
         f56 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) + f56);
         f24 = Math_fround(HEAPF32[i126 >> 2]);
         f24 = Math_fround(f24 + Math_fround(HEAPF32[i59 >> 2]));
         f24 = Math_fround(f24 + Math_fround(HEAPF32[i60 >> 2]));
         f54 = Math_fround(Math_fround(1.0) / f4);
         f4 = Math_fround(f54 * Math_fround(Math_fround(HEAPF32[i61 >> 2]) + f24));
         f56 = Math_fround(f54 * f56);
         f55 = Math_fround(f54 * f55);
         f4 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f56 * f56) + Math_fround(f4 * f4))))) / f11);
         if (!(HEAP8[i62 >> 0] | 0)) {
          f10 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(HEAPF32[i63 >> 2]) / Math_fround(180.0)));
          i26 = f10 < Math_fround(0.0);
          i22 = f10 > Math_fround(1.0);
          f10 = Math_fround((i22 ? Math_fround(1.0) : f10) * Math_fround(.400000006));
          f10 = i26 ? Math_fround(0.0) : f10;
         } else f10 = Math_fround(.400000006);
         f56 = Math_fround(Math_fround(1.0) - f10);
         f4 = Math_fround(f4 * f4);
         i1 = i126;
         f4 = Math_fround(Math_fround(f10 + Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f56 * Math_fround(f4 * f56)) - Math_fround(f10 * Math_fround(f4 * f10))))))) / f4);
        } else {
         i1 = i39;
         f4 = Math_fround(1.0);
        }
       } else {
        i1 = i39;
        f4 = Math_fround(1.0);
       }
       f12 = Math_fround(HEAPF32[i64 >> 2]);
       f10 = Math_fround(f11 - f12);
       f4 = Math_fround(Math_fround(Math_fround(f13 * f4) - f12) / f10);
       if (!(f4 <= f68)) {
        __Z16GetFrustumPointsRK10Matrix4x4fP8Vector3f(i1, i127);
        f55 = Math_fround(f4 * Math_fround(HEAPF32[i131 + 35844 + (i3 << 2) >> 2]));
        f56 = Math_fround(f4 * Math_fround(HEAPF32[i131 + 35844 + (i3 + 1 << 2) >> 2]));
        HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 348 >> 2] = Math_fround(f12 + Math_fround(f10 * f55));
        i7 = i131 + 34304 + (i31 * 364 | 0) + 352 | 0;
        HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f10 * f56));
        __Z17GetFrustumPortionPK8Vector3fffPS_(i127, f55, f56, i117);
        i5 = gb + 64016 | 0;
        i26 = HEAP32[i5 + 4 >> 2] | 0;
        i22 = i128;
        HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i22 + 4 >> 2] = i26;
        HEAP32[i118 >> 2] = 0;
        HEAP32[i65 >> 2] = 0;
        HEAP32[i66 >> 2] = 0;
        __Z21SetCurrentMemoryOwnerRK10MemLabelId(i129, i128);
        i22 = i129;
        i26 = HEAP32[i22 + 4 >> 2] | 0;
        i5 = i67;
        HEAP32[i5 >> 2] = HEAP32[i22 >> 2];
        HEAP32[i5 + 4 >> 2] = i26;
        i5 = (i2 | 0) == 0;
        do if (i5) {
         i3 = i8 + 248 | 0;
         i2 = i8 + 252 | 0;
         i22 = HEAP32[i2 >> 2] | 0;
         i1 = i8 + 256 | 0;
         i26 = HEAP32[i1 >> 2] | 0;
         HEAP32[i129 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i69 >> 2] = i22;
         HEAP32[i70 >> 2] = i26;
         __Z25CalculateFocusedLightHullPK8Vector3fRS0_RK10MinMaxAABBR13dynamic_arrayIS_Lj4EE(i117, i129, i6, i118);
         if (!(HEAP32[i65 >> 2] | 0)) {
          __ZN10Matrix4x4f11SetIdentityEv(i131 + 34304 + (i31 * 364 | 0) + 4 | 0) | 0;
          __ZN10Matrix4x4f8SetOrthoEffffff(i131 + 34304 + (i31 * 364 | 0) + 132 | 0, Math_fround(-1.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(1.0), Math_fround(.100000001), Math_fround(10.0)) | 0;
          i1 = 0;
          break;
         } else {
          i111 = 87;
          break;
         }
        } else {
         i3 = i8 + 248 | 0;
         i2 = i8 + 252 | 0;
         i1 = i8 + 256 | 0;
         i111 = 87;
        } while (0);
        if ((i111 | 0) == 87) {
         i111 = 0;
         f54 = Math_fround(HEAPF32[i36 >> 2]);
         f18 = Math_fround(HEAPF32[i114 >> 2]);
         f16 = Math_fround(f54 + f18);
         f55 = Math_fround(HEAPF32[i37 >> 2]);
         f17 = Math_fround(HEAPF32[i34 >> 2]);
         f14 = Math_fround(f55 + f17);
         f56 = Math_fround(HEAPF32[i38 >> 2]);
         f4 = Math_fround(HEAPF32[i35 >> 2]);
         f16 = Math_fround(f16 * Math_fround(.5));
         f14 = Math_fround(f14 * Math_fround(.5));
         f15 = Math_fround(Math_fround(f56 + f4) * Math_fround(.5));
         f18 = Math_fround(f54 - f18);
         f17 = Math_fround(f55 - f17);
         f4 = Math_fround(f56 - f4);
         f4 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f4 * f4)))) * Math_fround(.5));
         i26 = HEAP32[i8 + 220 >> 2] | 0;
         i22 = HEAP32[i8 + 224 >> 2] | 0;
         HEAP32[i129 >> 2] = HEAP32[i8 + 216 >> 2];
         HEAP32[i71 >> 2] = i26;
         HEAP32[i72 >> 2] = i22;
         i22 = HEAP32[i8 + 236 >> 2] | 0;
         i26 = HEAP32[i8 + 240 >> 2] | 0;
         HEAP32[i128 >> 2] = HEAP32[i8 + 232 >> 2];
         HEAP32[i73 >> 2] = i22;
         HEAP32[i74 >> 2] = i26;
         i8 = HEAP32[i3 >> 2] | 0;
         i26 = HEAP32[i2 >> 2] | 0;
         i22 = HEAP32[i1 >> 2] | 0;
         HEAP32[i119 >> 2] = i8;
         HEAP32[i75 >> 2] = i26;
         HEAP32[i76 >> 2] = i22;
         f17 = Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f18 = Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f18 = Math_fround(f14 - Math_fround(f18 * Math_fround(1.20000005)));
         f4 = Math_fround(f15 - Math_fround(Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(1.20000005)));
         HEAPF32[i121 >> 2] = Math_fround(f16 - Math_fround(f17 * Math_fround(1.20000005)));
         HEAPF32[i77 >> 2] = f18;
         HEAPF32[i78 >> 2] = f4;
         i22 = i131 + 34304 + (i31 * 364 | 0) + 4 | 0;
         __ZN10Matrix4x4f30SetPositionAndOrthoNormalBasisERK8Vector3fS2_S2_S2_(i22, i121, i129, i128, i119) | 0;
         f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
         f18 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
         f17 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
         f16 = Math_fround(-f4);
         f15 = Math_fround(-f18);
         f14 = Math_fround(-f17);
         do if (i5) {
          i2 = HEAP32[i65 >> 2] | 0;
          if (!i2) {
           f19 = f4;
           break;
          }
          i3 = HEAP32[i118 >> 2] | 0;
          f10 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 52 >> 2]);
          f11 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 56 >> 2]);
          f12 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 60 >> 2]);
          f13 = Math_fround(HEAPF32[i22 >> 2]);
          f19 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 8 >> 2]);
          f20 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 12 >> 2]);
          f21 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 20 >> 2]);
          f23 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 24 >> 2]);
          f24 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 28 >> 2]);
          f54 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 36 >> 2]);
          f55 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 40 >> 2]);
          f56 = Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 44 >> 2]);
          i1 = 0;
          do {
           f137 = Math_fround(Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]) - f10);
           f136 = Math_fround(Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]) - f11);
           f133 = Math_fround(Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]) - f12);
           f135 = Math_fround(Math_fround(Math_fround(f13 * f137) + Math_fround(f19 * f136)) + Math_fround(f20 * f133));
           f134 = Math_fround(Math_fround(Math_fround(f21 * f137) + Math_fround(f23 * f136)) + Math_fround(f24 * f133));
           f133 = Math_fround(Math_fround(Math_fround(f54 * f137) + Math_fround(f55 * f136)) + Math_fround(f56 * f133));
           f4 = f135 < f4 ? f135 : f4;
           f18 = f134 < f18 ? f134 : f18;
           f17 = f133 < f17 ? f133 : f17;
           f16 = f16 < f135 ? f135 : f16;
           f15 = f15 < f134 ? f134 : f15;
           f14 = f14 < f133 ? f133 : f14;
           i1 = i1 + 1 | 0;
          } while ((i1 | 0) != (i2 | 0));
          f19 = f4;
         } else {
          __Z40CalculateBoundingSphereFromFrustumPointsPK8Vector3fRS_Rf(i117, i122, i123);
          f137 = Math_fround(HEAPF32[i89 >> 2]);
          i26 = f137 < Math_fround(0.0);
          f136 = Math_fround(-f137);
          f134 = Math_fround(HEAPF32[i123 >> 2]);
          f136 = Math_fround(f134 + (i26 ? f136 : f137));
          HEAPF32[i112 >> 2] = f136;
          HEAP32[i7 >> 2] = HEAP32[(f13 < f136 ? i125 : i112) >> 2];
          f136 = Math_fround(HEAPF32[i90 >> 2]);
          f133 = Math_fround(HEAPF32[i122 >> 2]);
          f136 = Math_fround(f136 * f133);
          f19 = Math_fround(HEAPF32[i91 >> 2]);
          f135 = Math_fround(HEAPF32[i92 >> 2]);
          f19 = Math_fround(f136 + Math_fround(f19 * f135));
          f19 = Math_fround(f19 + Math_fround(f137 * Math_fround(HEAPF32[i93 >> 2])));
          f19 = Math_fround(Math_fround(HEAPF32[i94 >> 2]) + f19);
          f136 = Math_fround(f133 * Math_fround(HEAPF32[i95 >> 2]));
          f136 = Math_fround(f136 + Math_fround(f135 * Math_fround(HEAPF32[i96 >> 2])));
          f136 = Math_fround(f136 + Math_fround(f137 * Math_fround(HEAPF32[i97 >> 2])));
          f136 = Math_fround(Math_fround(HEAPF32[i98 >> 2]) + f136);
          f133 = Math_fround(f133 * Math_fround(HEAPF32[i99 >> 2]));
          f135 = Math_fround(f133 + Math_fround(f135 * Math_fround(HEAPF32[i100 >> 2])));
          f137 = Math_fround(f135 + Math_fround(f137 * Math_fround(HEAPF32[i101 >> 2])));
          f137 = Math_fround(Math_fround(HEAPF32[i102 >> 2]) + f137);
          HEAPF32[i122 >> 2] = f19;
          HEAPF32[i92 >> 2] = f136;
          HEAPF32[i89 >> 2] = f137;
          HEAP32[i28 >> 2] = HEAP32[i122 >> 2];
          HEAP32[i28 + 4 >> 2] = HEAP32[i122 + 4 >> 2];
          HEAP32[i28 + 8 >> 2] = HEAP32[i122 + 8 >> 2];
          HEAPF32[i29 >> 2] = f134;
          f19 = Math_fround(f19 - Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 52 >> 2]));
          f136 = Math_fround(f136 - Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 56 >> 2]));
          f137 = Math_fround(f137 - Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 60 >> 2]));
          f134 = Math_fround(f19 * Math_fround(HEAPF32[i22 >> 2]));
          f134 = Math_fround(f134 + Math_fround(f136 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 8 >> 2])));
          f134 = Math_fround(f134 + Math_fround(f137 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 12 >> 2])));
          f135 = Math_fround(f19 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 20 >> 2]));
          f135 = Math_fround(f135 + Math_fround(f136 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 24 >> 2])));
          f135 = Math_fround(f135 + Math_fround(f137 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 28 >> 2])));
          f19 = Math_fround(f19 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 36 >> 2]));
          f136 = Math_fround(f19 + Math_fround(f136 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 40 >> 2])));
          f137 = Math_fround(f136 + Math_fround(f137 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 44 >> 2])));
          f136 = Math_fround(HEAPF32[i123 >> 2]);
          f19 = Math_fround((f134 < f4 ? f134 : f4) - f136);
          f18 = Math_fround((f135 < f18 ? f135 : f18) - f136);
          f17 = Math_fround((f137 < f17 ? f137 : f17) - f136);
          f16 = Math_fround((f134 > f16 ? f134 : f16) + f136);
          f15 = Math_fround((f135 > f15 ? f135 : f15) + f136);
          f14 = Math_fround(f136 + (f137 > f14 ? f137 : f14));
         } while (0);
         f11 = Math_fround(f16 - f19);
         f4 = Math_fround(f15 - f18);
         f10 = Math_fround(f14 - f17);
         f13 = Math_fround(i9 | 0);
         if ((HEAP32[i105 >> 2] | 0) > 1) {
          f137 = Math_fround(i25 | 0);
          f12 = f137;
          f11 = Math_fround(f11 + Math_fround(Math_fround(f11 / f13) * Math_fround(10.0)));
          f10 = Math_fround(f10 + Math_fround(0.0));
          f4 = Math_fround(f4 + Math_fround(Math_fround(f4 / f137) * Math_fround(10.0)));
         } else f12 = Math_fround(i25 | 0);
         f56 = Math_fround(Math_fround(f19 + f16) * Math_fround(.5));
         f23 = Math_fround(Math_fround(f18 + f15) * Math_fround(.5));
         f55 = Math_fround(Math_fround(f17 + f14) * Math_fround(.5));
         f135 = Math_fround(f11 / f13);
         f133 = Math_fround(f4 / f12);
         HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 340 >> 2] = f135;
         HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 344 >> 2] = f133;
         f21 = Math_fround(f56 * Math_fround(HEAPF32[i22 >> 2]));
         f21 = Math_fround(f21 + Math_fround(f23 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 20 >> 2])));
         f21 = Math_fround(f21 + Math_fround(f55 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 36 >> 2])));
         i26 = i131 + 34304 + (i31 * 364 | 0) + 52 | 0;
         f21 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f21);
         f24 = Math_fround(f56 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 8 >> 2]));
         f24 = Math_fround(f24 + Math_fround(f23 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 24 >> 2])));
         f24 = Math_fround(f24 + Math_fround(f55 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 40 >> 2])));
         i3 = i131 + 34304 + (i31 * 364 | 0) + 56 | 0;
         f24 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f24);
         f56 = Math_fround(f56 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 12 >> 2]));
         f23 = Math_fround(f56 + Math_fround(f23 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 28 >> 2])));
         f55 = Math_fround(f23 + Math_fround(f55 * Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 44 >> 2])));
         i2 = i131 + 34304 + (i31 * 364 | 0) + 60 | 0;
         f55 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f55);
         f23 = Math_fround(HEAPF32[i129 >> 2]);
         d140 = +f21;
         f56 = Math_fround(HEAPF32[i71 >> 2]);
         d139 = +f24;
         f137 = Math_fround(HEAPF32[i72 >> 2]);
         d138 = +f55;
         f136 = Math_fround(HEAPF32[i128 >> 2]);
         f54 = Math_fround(HEAPF32[i73 >> 2]);
         f134 = Math_fround(HEAPF32[i74 >> 2]);
         f135 = Math_fround(+_fmod(d140 * +f23 + d139 * +f56 + d138 * +f137, +f135));
         f133 = Math_fround(+_fmod(d140 * +f136 + d139 * +f54 + d138 * +f134, +f133));
         f136 = Math_fround(Math_fround(f21 - Math_fround(f23 * f135)) - Math_fround(f136 * f133));
         f54 = Math_fround(Math_fround(f24 - Math_fround(f56 * f135)) - Math_fround(f54 * f133));
         f133 = Math_fround(Math_fround(f55 - Math_fround(f137 * f135)) - Math_fround(f134 * f133));
         f134 = Math_fround(f11 * Math_fround(.5));
         f135 = Math_fround(f4 * Math_fround(.5));
         f137 = Math_fround(f10 * Math_fround(.5));
         f55 = Math_fround(f137 * Math_fround(HEAPF32[i119 >> 2]));
         f56 = Math_fround(f137 * Math_fround(HEAPF32[i75 >> 2]));
         f55 = Math_fround(f136 - Math_fround(f55 * Math_fround(1.20000005)));
         f56 = Math_fround(f54 - Math_fround(f56 * Math_fround(1.20000005)));
         f133 = Math_fround(f133 - Math_fround(Math_fround(f137 * Math_fround(HEAPF32[i76 >> 2])) * Math_fround(1.20000005)));
         f54 = Math_fround(f137 * Math_fround(.100000001));
         i25 = i131 + 34304 + (i31 * 364 | 0) + 356 | 0;
         HEAPF32[i25 >> 2] = f54;
         f137 = Math_fround(f137 * Math_fround(2.29999995));
         HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 360 >> 2] = f137;
         f136 = Math_fround(HEAPF32[i79 >> 2]);
         i9 = f136 > Math_fround(0.0);
         f136 = Math_fround(f54 - Math_fround((i9 ? f136 : Math_fround(0.0)) * Math_fround(10.0)));
         HEAPF32[i25 >> 2] = f136;
         HEAPF32[i26 >> 2] = f55;
         HEAPF32[i3 >> 2] = f56;
         HEAPF32[i2 >> 2] = f133;
         i2 = i131 + 34304 + (i31 * 364 | 0) + 132 | 0;
         __ZN10Matrix4x4f8SetOrthoEffffff(i2, Math_fround(-f134), f134, Math_fround(-f135), f135, f136, f137) | 0;
         i3 = i131 + 34304 + (i31 * 364 | 0) + 68 | 0;
         i26 = i3;
         i25 = i26 + 64 | 0;
         do {
          HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
          i26 = i26 + 4 | 0;
          i22 = i22 + 4 | 0;
         } while ((i26 | 0) < (i25 | 0));
         i25 = i131 + 34304 + (i31 * 364 | 0) + 100 | 0;
         f135 = Math_fround(HEAPF32[i25 >> 2]);
         i22 = i131 + 34304 + (i31 * 364 | 0) + 104 | 0;
         f136 = Math_fround(HEAPF32[i22 >> 2]);
         i26 = i131 + 34304 + (i31 * 364 | 0) + 108 | 0;
         f136 = Math_fround(-f136);
         f137 = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
         HEAPF32[i25 >> 2] = Math_fround(-f135);
         HEAPF32[i22 >> 2] = f136;
         HEAPF32[i26 >> 2] = f137;
         __Z20InvertMatrix4x4_FullPKfPf(i3, i3) | 0;
         i26 = i122;
         i22 = gb + 1162292 | 0;
         i25 = i26 + 64 | 0;
         do {
          HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
          i26 = i26 + 4 | 0;
          i22 = i22 + 4 | 0;
         } while ((i26 | 0) < (i25 | 0));
         HEAPF32[i122 >> 2] = Math_fround(.5);
         HEAPF32[i80 >> 2] = Math_fround(.5);
         HEAPF32[i81 >> 2] = Math_fround(.5);
         HEAPF32[i82 >> 2] = Math_fround(.5);
         HEAPF32[i83 >> 2] = Math_fround(.5);
         HEAPF32[i84 >> 2] = Math_fround(.5);
         i1 = (HEAP8[i108 >> 0] | 0) == 0;
         i26 = i123;
         i22 = i2;
         i25 = i26 + 64 | 0;
         do {
          HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
          i26 = i26 + 4 | 0;
          i22 = i22 + 4 | 0;
         } while ((i26 | 0) < (i25 | 0));
         if (!i1) {
          HEAPF32[i85 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 140 >> 2]));
          HEAPF32[i86 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 156 >> 2]));
          HEAPF32[i87 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 172 >> 2]));
          HEAPF32[i88 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 34304 + (i31 * 364 | 0) + 188 >> 2]));
         }
         i1 = i131 + 34304 + (i31 * 364 | 0) + 196 | 0;
         __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i123, i3, i1);
         __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i122, i1, i27);
         i1 = 1;
        }
        if ((HEAP32[i66 >> 2] | 0) > -1) {
         __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i67);
         HEAP32[i118 >> 2] = 0;
        }
       } else i1 = 0;
      } while (0);
      if ((i111 | 0) == 75) {
       __ZN10Matrix4x4f11SetIdentityEv(i131 + 34304 + (i31 * 364 | 0) + 4 | 0) | 0;
       __ZN10Matrix4x4f8SetOrthoEffffff(i131 + 34304 + (i31 * 364 | 0) + 132 | 0, Math_fround(-1.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(1.0), Math_fround(.100000001), Math_fround(10.0)) | 0;
       i1 = 0;
      }
      HEAP8[i131 + 34304 + (i31 * 364 | 0) >> 0] = i1 & 1;
      i1 = HEAP32[i106 >> 2] | 0;
      f137 = Math_fround(HEAPF32[i29 >> 2]);
      f137 = Math_fround(f137 * f137);
      i29 = HEAP32[i131 + 34304 + (i31 * 364 | 0) + 328 >> 2] | 0;
      i111 = HEAP32[i131 + 34304 + (i31 * 364 | 0) + 332 >> 2] | 0;
      HEAP32[i131 + 35760 + (i1 << 4) >> 2] = HEAP32[i28 >> 2];
      HEAP32[i131 + 35760 + (i1 << 4) + 4 >> 2] = i29;
      HEAP32[i131 + 35760 + (i1 << 4) + 8 >> 2] = i111;
      HEAPF32[i131 + 35760 + (i1 << 4) + 12 >> 2] = f137;
      i31 = (HEAP32[i106 >> 2] | 0) + 1 | 0;
      HEAP32[i106 >> 2] = i31;
      i30 = i30 + 1 | 0;
      i1 = HEAP32[i109 >> 2] | 0;
     } while ((i30 | 0) < (i1 | 0));
    }
    i32 = i32 + 1 | 0;
   } while ((i32 | 0) < (HEAP32[i110 >> 2] | 0));
   __Z23CullDirectionalCascadesRNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEEEPK17ShadowCascadeInfoiRK10Matrix4x4fRK8Vector3fRK13ShadowJobData16ShadowProjection(i120, i104, HEAP32[i106 >> 2] | 0, i124 + 216 | 0, i116, i115, HEAP32[i42 >> 2] | 0);
   if ((HEAP32[i110 >> 2] | 0) <= 0) break L79;
   i6 = i129 + 20 | 0;
   i7 = i129 + 40 | 0;
   i8 = i129 + 48 | 0;
   i9 = i129 + 52 | 0;
   i5 = 0;
   i2 = 0;
   i1 = HEAP32[i109 >> 2] | 0;
   do {
    if ((i1 | 0) > 0) {
     f4 = Math_fround(i5 | 0);
     i3 = 0;
     do {
      if (HEAP8[i131 + 34304 + (i2 * 364 | 0) >> 0] | 0) {
       i26 = i129;
       i22 = gb + 1162292 | 0;
       i25 = i26 + 64 | 0;
       do {
        HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
        i26 = i26 + 4 | 0;
        i22 = i22 + 4 | 0;
       } while ((i26 | 0) < (i25 | 0));
       f136 = Math_fround(i1 | 0);
       HEAPF32[i129 >> 2] = Math_fround(Math_fround(1.0) / f136);
       f137 = Math_fround(HEAP32[i110 >> 2] | 0);
       HEAPF32[i6 >> 2] = Math_fround(Math_fround(1.0) / f137);
       HEAPF32[i7 >> 2] = Math_fround(1.0);
       HEAPF32[i8 >> 2] = Math_fround(Math_fround(i3 | 0) / f136);
       HEAPF32[i9 >> 2] = Math_fround(f4 / f137);
       __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i129, i131 + 34304 + (i2 * 364 | 0) + 260 | 0, i131 + 34040 + (i2 << 6) | 0);
       i1 = HEAP32[i109 >> 2] | 0;
      }
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i1 | 0));
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i110 >> 2] | 0));
   break;
  }
 default:
  {
   i2 = i131 + 36728 | 0;
   i22 = i131 + 36792 | 0;
   HEAPF32[i128 >> 2] = Math_fround(1.0);
   HEAPF32[i128 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i128 + 8 >> 2] = Math_fround(-1.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i129, i128) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i129, i124 + 280 | 0, i2);
   HEAP32[i128 >> 2] = i65;
   f137 = Math_fround(HEAPF32[((HEAP32[i62 >> 2] | 0) == 3 ? i63 : i64) >> 2]);
   f136 = Math_fround(Math_fround(HEAPF32[i64 >> 2]) * Math_fround(.00999999977));
   i1 = f136 > Math_fround(.100000001);
   f136 = i1 ? Math_fround(.100000001) : f136;
   HEAPF32[i126 >> 2] = f136;
   i1 = (HEAP32[tempDoublePtr >> 2] = i65, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f136;
   i1 = HEAP32[(i1 ? i126 : i128) >> 2] | 0;
   HEAP32[i128 >> 2] = i1;
   f136 = Math_fround(HEAPF32[i124 + 68 >> 2]);
   __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i22, f136, (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])), f137) | 0;
   __ZN10Matrix4x4f11SetIdentityEv(i126) | 0;
   HEAPF32[i126 >> 2] = Math_fround(.5);
   HEAPF32[i126 + 20 >> 2] = Math_fround(.5);
   HEAPF32[i126 + 40 >> 2] = Math_fround(.5);
   HEAPF32[i126 + 48 >> 2] = Math_fround(.5);
   HEAPF32[i126 + 52 >> 2] = Math_fround(.5);
   HEAPF32[i126 + 56 >> 2] = Math_fround(.5);
   i1 = (HEAP8[i108 >> 0] | 0) == 0;
   i26 = i125;
   i25 = i26 + 64 | 0;
   do {
    HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
    i26 = i26 + 4 | 0;
    i22 = i22 + 4 | 0;
   } while ((i26 | 0) < (i25 | 0));
   if (!i1) {
    HEAPF32[i125 + 8 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 36800 >> 2]));
    HEAPF32[i125 + 24 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 36816 >> 2]));
    HEAPF32[i125 + 40 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 36832 >> 2]));
    HEAPF32[i125 + 56 >> 2] = Math_fround(-Math_fround(HEAPF32[i131 + 36848 >> 2]));
   }
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i126, i125, i127);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i127, i2, i58);
   break L79;
  }
 } while (0);
 if (!i130) {
  STACKTOP = i132;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i130);
 STACKTOP = i132;
 return;
}

function __ZN13SpeedTreeWind7SParams8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482386 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482406 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482427 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482443 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482466 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482481 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482496 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482511 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482526 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482541 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482556 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482571 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482586 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482601 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482616 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482631 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482646 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482661 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482676 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482691 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482706 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482721 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482736 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482751 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482766 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482781 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482796 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482811 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482826 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482841 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482856 | 0, i5, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482871 | 0, i5, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482886 | 0, i5, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482901 | 0, i5, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482916 | 0, i5, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482931 | 0, i5, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482946 | 0, i5, i1 + 144 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482961 | 0, i5, i1 + 148 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482976 | 0, i5, i1 + 152 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482991 | 0, i5, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483006 | 0, i5, i1 + 160 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483021 | 0, i5, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483036 | 0, i5, i1 + 168 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483051 | 0, i5, i1 + 172 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483066 | 0, i5, i1 + 176 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483081 | 0, i5, i1 + 180 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483096 | 0, i5, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483111 | 0, i5, i1 + 188 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483126 | 0, i5, i1 + 192 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483141 | 0, i5, i1 + 196 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483156 | 0, i5, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483171 | 0, i5, i1 + 204 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483186 | 0, i5, i1 + 208 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483201 | 0, i5, i1 + 212 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483216 | 0, i5, i1 + 216 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483231 | 0, i5, i1 + 220 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483246 | 0, i5, i1 + 224 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483261 | 0, i5, i1 + 228 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483276 | 0, i5, i1 + 232 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483291 | 0, i5, i1 + 236 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483306 | 0, i5, i1 + 240 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483321 | 0, i5, i1 + 244 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483336 | 0, i5, i1 + 248 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483351 | 0, i5, i1 + 252 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483366 | 0, i5, i1 + 256 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483381 | 0, i5, i1 + 260 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483396 | 0, i5, i1 + 264 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483411 | 0, i5, i1 + 268 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483426 | 0, i5, i1 + 272 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483441 | 0, i5, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483456 | 0, i5, i1 + 280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483471 | 0, i5, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483486 | 0, i5, i1 + 288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483501 | 0, i5, i1 + 292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483516 | 0, i5, i1 + 296 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483531 | 0, i5, i1 + 300 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483546 | 0, i5, i1 + 304 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483561 | 0, i5, i1 + 308 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483576 | 0, i5, i1 + 312 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483591 | 0, i5, i1 + 316 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483606 | 0, i5, i1 + 320 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483621 | 0, i5, i1 + 324 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483636 | 0, i5, i1 + 328 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483651 | 0, i5, i1 + 332 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483666 | 0, i5, i1 + 336 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483681 | 0, i5, i1 + 340 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483696 | 0, i5, i1 + 344 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483711 | 0, i5, i1 + 348 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483726 | 0, i5, i1 + 352 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483741 | 0, i5, i1 + 356 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483756 | 0, i5, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483771 | 0, i5, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483786 | 0, i5, i1 + 368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483801 | 0, i5, i1 + 372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483816 | 0, i5, i1 + 376 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483831 | 0, i5, i1 + 380 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483846 | 0, i5, i1 + 384 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483861 | 0, i5, i1 + 388 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483876 | 0, i5, i1 + 392 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483891 | 0, i5, i1 + 396 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483906 | 0, i5, i1 + 400 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483921 | 0, i5, i1 + 404 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483936 | 0, i5, i1 + 408 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483951 | 0, i5, i1 + 412 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483966 | 0, i5, i1 + 416 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 483982 | 0, i5, i1 + 420 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484006 | 0, i5, i1 + 424 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484027 | 0, i5, i1 + 428 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484048 | 0, i5, i1 + 432 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484069 | 0, i5, i1 + 436 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484090 | 0, i5, i1 + 440 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484111 | 0, i5, i1 + 444 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484132 | 0, i5, i1 + 448 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484153 | 0, i5, i1 + 452 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484174 | 0, i5, i1 + 456 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484195 | 0, i5, i1 + 460 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484216 | 0, i5, i1 + 464 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484247 | 0, i5, i1 + 468 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484278 | 0, i5, i1 + 472 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484309 | 0, i5, i1 + 476 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484340 | 0, i5, i1 + 480 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484371 | 0, i5, i1 + 484 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484402 | 0, i5, i1 + 488 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484433 | 0, i5, i1 + 492 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484464 | 0, i5, i1 + 496 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484495 | 0, i5, i1 + 500 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 504 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484526 | 0, gb + 484539 | 0, i6, 0);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 636 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484556 | 0, gb + 484539 | 0, i6, 0);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 768 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484569 | 0, gb + 484580 | 0, i6, 0);
 __ZN13SpeedTreeWind10SWindGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 992 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484591 | 0, gb + 484580 | 0, i6, 0);
 __ZN13SpeedTreeWind10SWindGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484602 | 0, i5, i1 + 1216 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484628 | 0, i5, i1 + 1220 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484654 | 0, i5, i1 + 1224 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484680 | 0, i5, i1 + 1228 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484706 | 0, i5, i1 + 1232 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484732 | 0, i5, i1 + 1236 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484758 | 0, i5, i1 + 1240 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484784 | 0, i5, i1 + 1244 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484810 | 0, i5, i1 + 1248 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484836 | 0, i5, i1 + 1252 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484862 | 0, i5, i1 + 1256 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484881 | 0, i5, i1 + 1260 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484910 | 0, i5, i1 + 1264 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484930 | 0, i5, i1 + 1268 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484951 | 0, i5, i1 + 1272 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484977 | 0, i5, i1 + 1276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 484999 | 0, i5, i1 + 1280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485020 | 0, i5, i1 + 1284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485045 | 0, i5, i1 + 1288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485076 | 0, i5, i1 + 1292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485107 | 0, i5, i1 + 1296 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485131 | 0, i5, i1 + 1300 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485155 | 0, i5, i1 + 1304 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485172 | 0, i5, i1 + 1308 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485191 | 0, i5, i1 + 1312 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485210 | 0, i5, i1 + 1316 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485229 | 0, i5, i1 + 1320 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485248 | 0, i5, i1 + 1324 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485266 | 0, i5, i1 + 1328 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE(i120, i48, i47, i119) {
 i120 = i120 | 0;
 i48 = i48 | 0;
 i47 = i47 | 0;
 i119 = i119 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, f86 = f0, f87 = f0, i88 = 0, i89 = 0, f90 = f0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, f127 = f0;
 i126 = STACKTOP;
 STACKTOP = STACKTOP + 2448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i126 + 2408 | 0;
 i1 = i126 + 2312 | 0;
 i114 = i126 + 2296 | 0;
 i115 = i126 + 2232 | 0;
 i117 = i126 + 2344 | 0;
 i116 = i126 + 104 | 0;
 i113 = i126 + 88 | 0;
 i109 = i126 + 72 | 0;
 i110 = i126 + 56 | 0;
 i118 = i126 + 40 | 0;
 i112 = i126 + 2248 | 0;
 i111 = i126 + 2184 | 0;
 i37 = i126 + 120 | 0;
 i124 = i126 + 28 | 0;
 i89 = i126 + 16 | 0;
 i125 = i126 + 12 | 0;
 i123 = i126 + 8 | 0;
 i122 = i126 + 4 | 0;
 i121 = i126;
 if (HEAP32[gb + 1458456 >> 2] | 0) {
  i105 = HEAP32[gb + 1458456 + (i120 << 2) >> 2] | 0;
  HEAPF32[i105 >> 2] = Math_fround(0.0);
  i106 = HEAP32[gb + 1458456 + (i120 + 1 << 2) >> 2] | 0;
  HEAPF32[i106 >> 2] = Math_fround(0.0);
  i107 = HEAP32[gb + 1458456 + (i120 + 2 << 2) >> 2] | 0;
  HEAPF32[i107 >> 2] = Math_fround(0.0);
  i108 = HEAP32[gb + 1458456 + (i120 + 3 << 2) >> 2] | 0;
  HEAPF32[i108 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i105 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i106 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i107 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i108 + 20 >> 2] = Math_fround(0.0);
 }
 f95 = Math_fround(HEAPF32[i48 >> 2]);
 f96 = Math_fround(HEAPF32[i48 + 4 >> 2]);
 f97 = Math_fround(HEAPF32[i48 + 8 >> 2]);
 f98 = Math_fround(HEAPF32[i48 + 28 >> 2]);
 f99 = Math_fround(HEAPF32[i48 + 24 >> 2]);
 i85 = HEAP8[i48 + 32 >> 0] | 0;
 f100 = Math_fround(HEAPF32[i48 + 36 >> 2]);
 i36 = i47 + 72 | 0;
 i101 = HEAP32[i36 >> 2] | 0;
 i2 = i47 + 76 | 0;
 i102 = HEAP32[i2 >> 2] | 0;
 i103 = HEAP32[i47 + 80 >> 2] | 0;
 i104 = HEAP32[i47 + 84 >> 2] | 0;
 f68 = Math_fround(Math_fround(HEAPF32[gb + 158836 >> 2]) * Math_fround(2.0));
 f64 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 4 >> 2]) * Math_fround(2.0));
 f69 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 8 >> 2]) * Math_fround(2.0));
 i105 = i47 + 32 | 0;
 f63 = Math_fround(HEAPF32[i105 >> 2]);
 f70 = Math_fround(Math_fround(f63 * f63) + Math_fround(-.5));
 i106 = i47 + 20 | 0;
 f65 = Math_fround(HEAPF32[i106 >> 2]);
 f87 = Math_fround(f68 * f65);
 i107 = i47 + 24 | 0;
 f71 = Math_fround(HEAPF32[i107 >> 2]);
 f87 = Math_fround(f87 + Math_fround(f64 * f71));
 i108 = i47 + 28 | 0;
 f66 = Math_fround(HEAPF32[i108 >> 2]);
 f87 = Math_fround(f87 + Math_fround(f69 * f66));
 f86 = Math_fround(f63 * Math_fround(Math_fround(f69 * f71) - Math_fround(f64 * f66)));
 f67 = Math_fround(f65 * f87);
 f90 = Math_fround(Math_fround(f71 * f87) + Math_fround(Math_fround(f64 * f70) + Math_fround(f63 * Math_fround(Math_fround(f68 * f66) - Math_fround(f69 * f65)))));
 f71 = Math_fround(f63 * Math_fround(Math_fround(f64 * f65) - Math_fround(f68 * f71)));
 f87 = Math_fround(f66 * f87);
 i88 = HEAP8[i47 >> 0] | 0;
 i91 = HEAP32[i47 + 12 >> 2] | 0;
 i92 = HEAP32[i47 + 8 >> 2] | 0;
 i93 = HEAP32[i47 + 4 >> 2] | 0;
 i94 = HEAP32[i47 + 16 >> 2] | 0;
 i34 = HEAP32[i48 + 40 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i34 | 0);
 HEAP32[i119 + 888 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i119 + 892 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i119 + 896 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i119 + 900 >> 2] = HEAP32[i1 + 12 >> 2];
 i85 = i85 << 24 >> 24 == 0;
 f86 = Math_fround(f67 + Math_fround(Math_fround(f68 * f70) + f86));
 f87 = Math_fround(Math_fround(Math_fround(f69 * f70) + f71) + f87);
 i88 = i88 << 24 >> 24 != 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i34 = HEAP32[i2 + 212 >> 2] | 0;
 i40 = i47 + 88 | 0;
 i1 = (HEAP32[i40 >> 2] | 0) == 0;
 if (!i34) {
  if (!i1) {
   i3 = i2 + 96 | 0;
   i4 = i2 + 192 | 0;
   i5 = i2 + 176 | 0;
   i1 = i2 + 160 | 0;
   i2 = 0;
   do {
    i78 = HEAPU16[i4 + (i2 << 1) >> 1] | 0;
    HEAP32[i114 + (i2 << 2) >> 2] = i78;
    i83 = i5 + (i2 << 2) | 0;
    HEAP32[i115 + (i2 << 2) >> 2] = HEAP32[i83 >> 2];
    i79 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
    HEAP32[i117 + (i2 << 4) >> 2] = i79;
    i80 = HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0;
    HEAP32[i117 + (i2 << 4) + 4 >> 2] = i80;
    i81 = HEAP32[i3 + (i2 << 4) + 8 >> 2] | 0;
    HEAP32[i117 + (i2 << 4) + 8 >> 2] = i81;
    i82 = HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0;
    HEAP32[i117 + (i2 << 4) + 12 >> 2] = i82;
    i84 = i1 + (i2 << 2) | 0;
    HEAP32[i116 + (i2 << 2) >> 2] = HEAP32[i84 >> 2];
    HEAP32[i113 + (i2 << 2) >> 2] = 0;
    HEAP32[i109 + (i2 << 2) >> 2] = 0;
    HEAP32[i110 + (i2 << 2) >> 2] = 0;
    HEAP32[i118 + (i2 << 2) >> 2] = -1;
    HEAP32[i112 + (i2 * 12 | 0) >> 2] = 0;
    HEAP32[i112 + (i2 * 12 | 0) + 4 >> 2] = 0;
    HEAP32[i112 + (i2 * 12 | 0) + 8 >> 2] = 0;
    HEAP32[i111 + (i2 * 12 | 0) >> 2] = 0;
    HEAP32[i111 + (i2 * 12 | 0) + 4 >> 2] = 0;
    HEAP32[i111 + (i2 * 12 | 0) + 8 >> 2] = 0;
    HEAP32[i119 + 904 + (i2 << 2) >> 2] = i78;
    HEAP32[i119 + 920 + (i2 << 4) >> 2] = i79;
    HEAP32[i119 + 920 + (i2 << 4) + 4 >> 2] = i80;
    HEAP32[i119 + 920 + (i2 << 4) + 8 >> 2] = i81;
    HEAP32[i119 + 920 + (i2 << 4) + 12 >> 2] = i82;
    HEAP32[i119 + 984 + (i2 << 2) >> 2] = HEAP32[i83 >> 2];
    HEAP32[i119 + 1e3 + (i2 << 2) >> 2] = HEAP32[i84 >> 2];
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i40 >> 2] | 0) >>> 0);
  }
 } else if (!i1) {
  i11 = i48 + 44 | 0;
  i12 = i37 + 4 | 0;
  i13 = i37 + 8 | 0;
  i33 = i37 + 12 | 0;
  i14 = i37 + 2060 | 0;
  i15 = i37 + 1036 | 0;
  i16 = i37 + 1040 | 0;
  i32 = 0;
  do {
   i84 = HEAP8[i34 + (i32 * 80 | 0) + 77 >> 0] | 0;
   i17 = i84 & 255;
   if (!(i84 << 24 >> 24)) {
    HEAP32[i114 + (i32 << 2) >> 2] = 0;
    HEAPF32[i115 + (i32 << 2) >> 2] = Math_fround(0.0);
    i84 = i117 + (i32 << 4) | 0;
    HEAP32[i84 >> 2] = 0;
    HEAP32[i84 + 4 >> 2] = 0;
    HEAP32[i84 + 8 >> 2] = 0;
    HEAP32[i84 + 12 >> 2] = 0;
    HEAPF32[i116 + (i32 << 2) >> 2] = Math_fround(0.0);
    HEAP32[i113 + (i32 << 2) >> 2] = 0;
    HEAP32[i109 + (i32 << 2) >> 2] = 0;
    HEAP32[i110 + (i32 << 2) >> 2] = 0;
    HEAP32[i118 + (i32 << 2) >> 2] = -1;
    HEAP32[i112 + (i32 * 12 | 0) >> 2] = 0;
    HEAP32[i112 + (i32 * 12 | 0) + 4 >> 2] = 0;
    HEAP32[i112 + (i32 * 12 | 0) + 8 >> 2] = 0;
    HEAP32[i111 + (i32 * 12 | 0) >> 2] = 0;
    HEAP32[i111 + (i32 * 12 | 0) + 4 >> 2] = 0;
    HEAP32[i111 + (i32 * 12 | 0) + 8 >> 2] = 0;
    HEAP32[i119 + 904 + (i32 << 2) >> 2] = 0;
    i84 = i119 + 920 + (i32 << 4) | 0;
    HEAP32[i84 >> 2] = 0;
    HEAP32[i84 + 4 >> 2] = 0;
    HEAP32[i84 + 8 >> 2] = 0;
    HEAP32[i84 + 12 >> 2] = 0;
    HEAPF32[i119 + 984 + (i32 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i119 + 1e3 + (i32 << 2) >> 2] = Math_fround(0.0);
   } else {
    i18 = i34 + (i32 * 80 | 0) | 0;
    HEAP32[i114 + (i32 << 2) >> 2] = i17;
    i19 = i34 + (i32 * 80 | 0) + 40 | 0;
    i84 = HEAP32[i19 >> 2] | 0;
    HEAP32[i115 + (i32 << 2) >> 2] = i84;
    i20 = i34 + (i32 * 80 | 0) + 16 | 0;
    f70 = Math_fround(HEAPF32[i20 >> 2]);
    i21 = i34 + (i32 * 80 | 0) + 20 | 0;
    f71 = Math_fround(HEAPF32[i21 >> 2]);
    i22 = i34 + (i32 * 80 | 0) + 24 | 0;
    f29 = Math_fround(HEAPF32[i22 >> 2]);
    i23 = i34 + (i32 * 80 | 0) + 28 | 0;
    i24 = HEAP32[i23 >> 2] | 0;
    i25 = i34 + (i32 * 80 | 0) + 32 | 0;
    i26 = HEAP32[i25 >> 2] | 0;
    i27 = i34 + (i32 * 80 | 0) + 36 | 0;
    i28 = HEAP32[i27 >> 2] | 0;
    f70 = Math_fround(f70 * (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f71 = Math_fround(f70 + Math_fround(f71 * (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
    f29 = Math_fround(-Math_fround(f71 + Math_fround(f29 * (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
    HEAP32[i117 + (i32 << 4) >> 2] = i24;
    HEAP32[i117 + (i32 << 4) + 4 >> 2] = i26;
    HEAP32[i117 + (i32 << 4) + 8 >> 2] = i28;
    HEAPF32[i117 + (i32 << 4) + 12 >> 2] = f29;
    if ((HEAP32[tempDoublePtr >> 2] = i84, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0)) {
     i31 = HEAP32[i34 + (i32 * 80 | 0) + 4 >> 2] | 0;
     i31 = mftCall_iii(HEAP32[(HEAP32[i31 >> 2] | 0) + 108 >> 2] | 0, i31 | 0, HEAP32[i34 + (i32 * 80 | 0) + 8 >> 2] | 0) | 0;
    } else i31 = 0;
    i30 = HEAP32[i11 >> 2] | 0;
    i9 = HEAP32[i30 + 12 >> 2] | 0;
    HEAP32[i37 >> 2] = i9;
    i10 = HEAP32[i30 + 4 >> 2] | 0;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i13 >> 2] = HEAP32[i30 + 8 >> 2];
    _memset(i33 | 0, -1, 2048) | 0;
    if (i9 | 0) {
     HEAP32[i38 >> 2] = 0;
     HEAP32[i38 + 4 >> 2] = 0;
     HEAP32[i38 + 8 >> 2] = 0;
     HEAP32[i38 + 12 >> 2] = 0;
     HEAP32[i38 + 16 >> 2] = 0;
     HEAP32[i38 + 20 >> 2] = 0;
     HEAP32[i38 + 24 >> 2] = 0;
     HEAP32[i38 + 28 >> 2] = 0;
     i7 = 0;
     i8 = 0;
     i1 = 2;
     while (1) {
      i6 = 0;
      i2 = 0;
      do {
       i5 = (HEAP32[i10 + (i6 << 2) >> 2] | 0) >>> i1;
       i3 = i38 + ((i5 >>> 5 & 7) << 2) | 0;
       i4 = HEAP32[i3 >> 2] | 0;
       i5 = 1 << (i5 & 31);
       if (!(i5 & i4)) {
        HEAP32[i3 >> 2] = i5 | i4;
        i2 = i2 + 1 | 0;
       }
       i6 = i6 + 1 | 0;
      } while ((i6 | 0) != (i9 | 0));
      i3 = (i2 | 0) == (i9 | 0);
      if (i2 >>> 0 <= i7 >>> 0) {
       i2 = 19;
       break;
      }
      if (i3) {
       i2 = 20;
       break;
      }
      HEAP32[i38 >> 2] = 0;
      HEAP32[i38 + 4 >> 2] = 0;
      HEAP32[i38 + 8 >> 2] = 0;
      HEAP32[i38 + 12 >> 2] = 0;
      HEAP32[i38 + 16 >> 2] = 0;
      HEAP32[i38 + 20 >> 2] = 0;
      HEAP32[i38 + 24 >> 2] = 0;
      HEAP32[i38 + 28 >> 2] = 0;
      i8 = i1;
      i7 = i2;
      i1 = i1 << 1;
     }
     if ((i2 | 0) == 19) {
      i2 = 0;
      if (i3) i2 = 20; else i1 = i8;
     }
     HEAP32[i14 >> 2] = i1;
     i84 = i37 + 12 + (((HEAP32[i10 >> 2] | 0) >>> i1 & 255) << 2) | 0;
     HEAP32[i15 >> 2] = HEAP32[i84 >> 2];
     HEAP32[i84 >> 2] = 0;
     if (i9 >>> 0 > 1) {
      i84 = i37 + 12 + (((HEAP32[i10 + 4 >> 2] | 0) >>> (HEAP32[i14 >> 2] | 0) & 255) << 2) | 0;
      HEAP32[i16 >> 2] = HEAP32[i84 >> 2];
      HEAP32[i84 >> 2] = 1;
      if ((HEAP32[i37 >> 2] | 0) >>> 0 > 2) {
       i1 = 2;
       do {
        i84 = i37 + 12 + (((HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0) >>> (HEAP32[i14 >> 2] | 0) & 255) << 2) | 0;
        HEAP32[i37 + 1036 + (i1 << 2) >> 2] = HEAP32[i84 >> 2];
        HEAP32[i84 >> 2] = i1;
        i1 = i1 + 1 | 0;
       } while (i1 >>> 0 < (HEAP32[i37 >> 2] | 0) >>> 0);
      }
     }
    }
    L40 : do if (!i31) i1 = 0; else {
     i1 = HEAP32[i37 + 12 + ((i31 >>> (HEAP32[i14 >> 2] | 0) & 255) << 2) >> 2] | 0;
     if ((i1 | 0) == -1) i1 = 0; else {
      i2 = HEAP32[i12 >> 2] | 0;
      while (1) {
       if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i31 | 0)) break;
       i1 = HEAP32[i37 + 1036 + (i1 << 2) >> 2] | 0;
       if ((i1 | 0) == -1) {
        i1 = 0;
        break L40;
       }
      }
      i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     }
    } while (0);
    f71 = Math_fround(__ZNK5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19getTypePairFrictionEjj(i30, i1, HEAP32[(HEAP32[i36 >> 2] | 0) + 384 + (i32 << 6) + 40 >> 2] | 0));
    HEAPF32[i116 + (i32 << 2) >> 2] = f71;
    HEAP32[i113 + (i32 << 2) >> 2] = HEAP32[i34 + (i32 * 80 | 0) + 4 >> 2];
    HEAP32[i109 + (i32 << 2) >> 2] = HEAP32[i18 >> 2];
    HEAP32[i110 + (i32 << 2) >> 2] = i31;
    HEAP32[i118 + (i32 << 2) >> 2] = i1;
    HEAP32[i112 + (i32 * 12 | 0) >> 2] = HEAP32[i20 >> 2];
    HEAP32[i112 + (i32 * 12 | 0) + 4 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i112 + (i32 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i111 + (i32 * 12 | 0) >> 2] = HEAP32[i23 >> 2];
    HEAP32[i111 + (i32 * 12 | 0) + 4 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i111 + (i32 * 12 | 0) + 8 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i119 + 904 + (i32 << 2) >> 2] = i17;
    HEAP32[i119 + 920 + (i32 << 4) >> 2] = i24;
    HEAP32[i119 + 920 + (i32 << 4) + 4 >> 2] = i26;
    HEAP32[i119 + 920 + (i32 << 4) + 8 >> 2] = i28;
    HEAPF32[i119 + 920 + (i32 << 4) + 12 >> 2] = f29;
    HEAP32[i119 + 984 + (i32 << 2) >> 2] = HEAP32[i19 >> 2];
    HEAPF32[i119 + 1e3 + (i32 << 2) >> 2] = f71;
   }
   i32 = i32 + 1 | 0;
  } while (i32 >>> 0 < (HEAP32[i40 >> 2] | 0) >>> 0);
 }
 i75 = i47 + 36 | 0;
 i76 = i47 + 40 | 0;
 i77 = i47 + 44 | 0;
 i78 = i124 + 4 | 0;
 i79 = i124 + 8 | 0;
 i80 = i47 + 48 | 0;
 i81 = i47 + 52 | 0;
 i82 = i47 + 56 | 0;
 i83 = i47 + 64 | 0;
 i84 = i47 + 68 | 0;
 i72 = i47 + 60 | 0;
 i73 = i48 + 12 | 0;
 i74 = i48 + 16 | 0;
 i25 = i48 + 20 | 0;
 i26 = i119 + 484 | 0;
 i27 = i119 + 488 | 0;
 i28 = i119 + 492 | 0;
 i30 = i119 + 496 | 0;
 i31 = i119 + 500 | 0;
 i32 = i119 + 504 | 0;
 i33 = i104 + 8 | 0;
 i34 = i104 + 12 | 0;
 i36 = i104 + 4 | 0;
 i37 = i104 + 16 | 0;
 i24 = i88 ^ 1;
 i38 = i103 + 16 | 0;
 i40 = i89 + 4 | 0;
 i47 = i89 + 8 | 0;
 i48 = 0;
 do {
  i2 = i101 + 784 + (i48 * 12 | 0) | 0;
  i3 = i101 + 640 + (i48 * 12 | 0) | 0;
  i18 = i119 + 508 + (i48 << 2) | 0;
  HEAP32[i18 >> 2] = HEAP32[i102 + 48 + (i48 << 2) >> 2];
  i21 = i119 + 524 + (i48 << 2) | 0;
  HEAP32[i21 >> 2] = HEAP32[i102 + 64 + (i48 << 2) >> 2];
  i1 = i101 + (i48 * 48 | 0) + 12 | 0;
  if (HEAP32[gb + 1458456 >> 2] | 0) {
   f71 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[HEAP32[gb + 1458456 + (i48 + i120 << 2) >> 2] >> 2] = f71;
  }
  i13 = i119 + 292 + (i48 << 2) | 0;
  HEAPF32[i13 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  i5 = i119 + 652 + i48 | 0;
  HEAP8[i5 >> 0] = 0;
  i6 = i119 + 636 + (i48 << 2) | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i19 = i119 + 768 + i48 | 0;
  HEAP8[i19 >> 0] = 0;
  i20 = i119 + 752 + (i48 << 2) | 0;
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i22 = i119 + 884 + i48 | 0;
  HEAP8[i22 >> 0] = 0;
  i23 = i119 + 868 + (i48 << 2) | 0;
  HEAPF32[i23 >> 2] = Math_fround(0.0);
  i7 = i119 + 112 + i48 | 0;
  HEAP8[i7 >> 0] = 1;
  f71 = Math_fround(HEAPF32[i115 + (i48 << 2) >> 2]);
  f50 = Math_fround(HEAPF32[i117 + (i48 << 4) >> 2]);
  f51 = Math_fround(HEAPF32[i117 + (i48 << 4) + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i117 + (i48 << 4) + 8 >> 2]);
  i17 = i101 + 192 + (i48 * 48 | 0) | 0;
  f29 = Math_fround(HEAPF32[i17 >> 2]);
  i8 = i101 + (i48 * 48 | 0) + 8 | 0;
  f35 = Math_fround(HEAPF32[i8 >> 2]);
  f69 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
  i9 = i101 + 640 + (i48 * 12 | 0) + 4 | 0;
  f67 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
  i10 = i101 + 640 + (i48 * 12 | 0) + 8 | 0;
  f64 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
  f65 = Math_fround(HEAPF32[i105 >> 2]);
  f63 = Math_fround(Math_fround(f65 * f65) + Math_fround(-.5));
  f66 = Math_fround(HEAPF32[i106 >> 2]);
  f45 = Math_fround(f69 * f66);
  f68 = Math_fround(HEAPF32[i107 >> 2]);
  f45 = Math_fround(f45 + Math_fround(f67 * f68));
  f42 = Math_fround(HEAPF32[i108 >> 2]);
  f45 = Math_fround(f45 + Math_fround(f64 * f42));
  f43 = Math_fround(Math_fround(f66 * f45) + Math_fround(Math_fround(f69 * f63) + Math_fround(f65 * Math_fround(Math_fround(f64 * f68) - Math_fround(f67 * f42)))));
  f44 = Math_fround(Math_fround(f68 * f45) + Math_fround(Math_fround(f67 * f63) + Math_fround(f65 * Math_fround(Math_fround(f69 * f42) - Math_fround(f64 * f66)))));
  f45 = Math_fround(Math_fround(Math_fround(f64 * f63) + Math_fround(f65 * Math_fround(Math_fround(f67 * f66) - Math_fround(f69 * f68)))) + Math_fround(f42 * f45));
  f69 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
  i11 = i101 + 784 + (i48 * 12 | 0) + 4 | 0;
  f67 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(2.0));
  i12 = i101 + 784 + (i48 * 12 | 0) + 8 | 0;
  f64 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
  f70 = Math_fround(Math_fround(Math_fround(f66 * f69) + Math_fround(f68 * f67)) + Math_fround(f42 * f64));
  f39 = Math_fround(Math_fround(f66 * f70) + Math_fround(Math_fround(f63 * f69) + Math_fround(f65 * Math_fround(Math_fround(f68 * f64) - Math_fround(f42 * f67)))));
  f41 = Math_fround(Math_fround(f68 * f70) + Math_fround(Math_fround(f63 * f67) + Math_fround(f65 * Math_fround(Math_fround(f42 * f69) - Math_fround(f66 * f64)))));
  f70 = Math_fround(Math_fround(Math_fround(f63 * f64) + Math_fround(f65 * Math_fround(Math_fround(f66 * f67) - Math_fround(f68 * f69)))) + Math_fround(f42 * f70));
  f39 = Math_fround(Math_fround(HEAPF32[i75 >> 2]) + f39);
  f41 = Math_fround(Math_fround(HEAPF32[i76 >> 2]) + f41);
  f42 = Math_fround(f29 + f35);
  f39 = Math_fround(f39 - Math_fround(f42 * f43));
  f41 = Math_fround(f41 - Math_fround(f42 * f44));
  f42 = Math_fround(Math_fround(Math_fround(HEAPF32[i77 >> 2]) + f70) - Math_fround(f42 * f45));
  do if ((HEAP8[i94 + i48 >> 0] | 0 ? (HEAP32[i114 + (i48 << 2) >> 2] | 0) != 0 : 0) & f71 != Math_fround(0.0)) {
   f46 = Math_fround(Math_fround(f49 * f45) + Math_fround(Math_fround(f50 * f43) + Math_fround(f51 * f44)));
   if (f46 < Math_fround(0.0)) {
    f71 = Math_fround(HEAPF32[i116 + (i48 << 2) >> 2]);
    f35 = Math_fround(Math_fround(f29 * Math_fround(2.0)) + f35);
    f29 = Math_fround(f35 - Math_fround(Math_fround(-Math_fround(Math_fround(Math_fround(f49 * f42) + Math_fround(Math_fround(f50 * f39) + Math_fround(f51 * f41))) + Math_fround(HEAPF32[i117 + (i48 << 4) + 12 >> 2]))) / f46));
    if (f29 > Math_fround(-Math_fround(HEAPF32[i1 >> 2]))) {
     HEAP32[i119 + 132 + (i48 << 2) >> 2] = HEAP32[i113 + (i48 << 2) >> 2];
     i4 = HEAP32[i109 + (i48 << 2) >> 2] | 0;
     HEAP32[i119 + 116 + (i48 << 2) >> 2] = i4;
     HEAP32[i119 + 148 + (i48 << 2) >> 2] = HEAP32[i110 + (i48 << 2) >> 2];
     HEAP32[i119 + 164 + (i48 << 2) >> 2] = HEAP32[i118 + (i48 << 2) >> 2];
     i14 = i112 + (i48 * 12 | 0) | 0;
     HEAP32[i119 + 180 + (i48 * 12 | 0) >> 2] = HEAP32[i14 >> 2];
     i15 = i112 + (i48 * 12 | 0) + 4 | 0;
     HEAP32[i119 + 180 + (i48 * 12 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
     i16 = i112 + (i48 * 12 | 0) + 8 | 0;
     HEAP32[i119 + 180 + (i48 * 12 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i119 + 228 + (i48 * 12 | 0) >> 2] = HEAP32[i111 + (i48 * 12 | 0) >> 2];
     HEAP32[i119 + 228 + (i48 * 12 | 0) + 4 >> 2] = HEAP32[i111 + (i48 * 12 | 0) + 4 >> 2];
     HEAP32[i119 + 228 + (i48 * 12 | 0) + 8 >> 2] = HEAP32[i111 + (i48 * 12 | 0) + 8 >> 2];
     HEAP8[i7 >> 0] = 0;
     HEAPF32[i6 >> 2] = Math_fround(f29 - Math_fround(HEAPF32[i8 >> 2]));
     f52 = Math_fround(HEAPF32[i8 >> 2]);
     HEAP8[i5 >> 0] = f29 > f52 & 1;
     HEAP32[i119 + 540 + (i48 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
     HEAP32[i119 + 540 + (i48 * 12 | 0) + 4 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i119 + 540 + (i48 * 12 | 0) + 8 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i119 + 588 + (i48 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
     HEAP32[i119 + 588 + (i48 * 12 | 0) + 4 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i119 + 588 + (i48 * 12 | 0) + 8 >> 2] = HEAP32[i10 >> 2];
     f52 = f29 < f52 ? f29 : f52;
     HEAPF32[i13 >> 2] = f52;
     i3 = HEAP32[gb + 1458456 >> 2] | 0;
     if (i3 | 0) HEAPF32[HEAP32[gb + 1458456 + (i48 + i120 << 2) >> 2] >> 2] = f52;
     f35 = Math_fround(f35 - f52);
     f67 = Math_fround(f39 + Math_fround(f43 * f35));
     f65 = Math_fround(f41 + Math_fround(f44 * f35));
     f35 = Math_fround(f42 + Math_fround(f45 * f35));
     HEAPF32[i124 >> 2] = f67;
     HEAPF32[i78 >> 2] = f65;
     HEAPF32[i79 >> 2] = f35;
     f67 = Math_fround(f67 - Math_fround(HEAPF32[i75 >> 2]));
     f65 = Math_fround(f65 - Math_fround(HEAPF32[i76 >> 2]));
     f35 = Math_fround(f35 - Math_fround(HEAPF32[i77 >> 2]));
     f68 = Math_fround(HEAPF32[i80 >> 2]);
     f69 = Math_fround(HEAPF32[i81 >> 2]);
     f70 = Math_fround(HEAPF32[i82 >> 2]);
     f39 = Math_fround(HEAPF32[i83 >> 2]);
     f29 = Math_fround(f35 * f39);
     f64 = Math_fround(HEAPF32[i84 >> 2]);
     f29 = Math_fround(f29 - Math_fround(f65 * f64));
     f64 = Math_fround(f67 * f64);
     f66 = Math_fround(HEAPF32[i72 >> 2]);
     f35 = Math_fround(f64 - Math_fround(f35 * f66));
     f39 = Math_fround(Math_fround(f65 * f66) - Math_fround(f67 * f39));
     f29 = Math_fround(f68 + f29);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
     f35 = Math_fround(f69 + f35);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
     f39 = Math_fround(f70 + f39);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
     if (!i4) {
      i9 = 0;
      i10 = 0;
      i11 = 0;
      i4 = 0;
     } else if ((HEAP16[i4 + 4 >> 1] | 0) == 5) {
      __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E(i89, i4, i124);
      i9 = HEAP32[i89 >> 2] | 0;
      i10 = HEAP32[i40 >> 2] | 0;
      i11 = HEAP32[i47 >> 2] | 0;
      f70 = Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
      f70 = Math_fround(f35 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      i2 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
      f70 = Math_fround(f39 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      i3 = HEAP32[gb + 1458456 >> 2] | 0;
      i5 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     } else {
      i9 = 0;
      i10 = 0;
      i11 = 0;
      i4 = 0;
     }
     f70 = Math_fround(HEAPF32[i102 + 80 + (i48 << 2) >> 2]);
     i13 = f70 != Math_fround(3402823469999999843913219.0e14);
     f70 = Math_fround(f97 * Math_fround(f52 - f70));
     f70 = i13 ? f70 : Math_fround(0.0);
     f29 = Math_fround(f43 * Math_fround(HEAPF32[i73 >> 2]));
     f29 = Math_fround(f29 + Math_fround(f44 * Math_fround(HEAPF32[i74 >> 2])));
     f29 = Math_fround(f29 + Math_fround(f45 * Math_fround(HEAPF32[i25 >> 2])));
     i13 = f29 < Math_fround(0.0);
     f29 = i13 ? Math_fround(0.0) : f29;
     f29 = Math_fround(Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 16 >> 2]) * f29);
     f29 = Math_fround(Math_fround(f52 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) >> 2])) + f29);
     i13 = f29 > Math_fround(0.0);
     f29 = i13 ? f29 : Math_fround(0.0);
     f29 = Math_fround(Math_fround(f70 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 4 >> 2])) + f29);
     HEAPF32[i119 + 308 + (i48 << 2) >> 2] = f29;
     if (i3 | 0) HEAPF32[(HEAP32[gb + 1458456 + (i48 + i120 << 2) >> 2] | 0) + 4 >> 2] = f29;
     f66 = Math_fround(-f29);
     f63 = Math_fround(Math_fround(f49 * Math_fround(f45 * f66)) + Math_fround(Math_fround(f50 * Math_fround(f43 * f66)) + Math_fround(f51 * Math_fround(f44 * f66))));
     f61 = Math_fround(f50 * f63);
     f62 = Math_fround(f51 * f63);
     f63 = Math_fround(f49 * f63);
     f67 = Math_fround(Math_fround(HEAPF32[i101 + 688 + (i48 * 12 | 0) >> 2]) * Math_fround(2.0));
     f59 = Math_fround(Math_fround(HEAPF32[i101 + 688 + (i48 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
     f56 = Math_fround(Math_fround(HEAPF32[i101 + 688 + (i48 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
     f58 = Math_fround(HEAPF32[i105 >> 2]);
     f57 = Math_fround(Math_fround(f58 * f58) + Math_fround(-.5));
     f60 = Math_fround(HEAPF32[i106 >> 2]);
     f70 = Math_fround(f67 * f60);
     f65 = Math_fround(HEAPF32[i107 >> 2]);
     f70 = Math_fround(f70 + Math_fround(f59 * f65));
     f64 = Math_fround(HEAPF32[i108 >> 2]);
     f70 = Math_fround(f70 + Math_fround(f56 * f64));
     f68 = Math_fround(Math_fround(f60 * f70) + Math_fround(Math_fround(f67 * f57) + Math_fround(f58 * Math_fround(Math_fround(f56 * f65) - Math_fround(f59 * f64)))));
     f69 = Math_fround(Math_fround(f65 * f70) + Math_fround(Math_fround(f59 * f57) + Math_fround(f58 * Math_fround(Math_fround(f67 * f64) - Math_fround(f56 * f60)))));
     f70 = Math_fround(Math_fround(Math_fround(f56 * f57) + Math_fround(f58 * Math_fround(Math_fround(f59 * f60) - Math_fround(f67 * f65)))) + Math_fround(f64 * f70));
     f64 = Math_fround(Math_fround(f63 * f69) - Math_fround(f62 * f70));
     f65 = Math_fround(Math_fround(f61 * f70) - Math_fround(f63 * f68));
     f67 = Math_fround(Math_fround(f62 * f68) - Math_fround(f61 * f69));
     HEAPF32[i26 >> 2] = Math_fround(f61 + Math_fround(HEAPF32[i26 >> 2]));
     HEAPF32[i27 >> 2] = Math_fround(f62 + Math_fround(HEAPF32[i27 >> 2]));
     HEAPF32[i28 >> 2] = Math_fround(f63 + Math_fround(HEAPF32[i28 >> 2]));
     HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f64);
     HEAPF32[i31 >> 2] = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f65);
     HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + f67);
     f66 = Math_fround(f46 * f66);
     f67 = Math_fround(f50 * Math_fround(HEAPF32[i73 >> 2]));
     f67 = Math_fround(f67 + Math_fround(f51 * Math_fround(HEAPF32[i74 >> 2])));
     f67 = Math_fround(f67 + Math_fround(f49 * Math_fround(HEAPF32[i25 >> 2])));
     i13 = f67 < Math_fround(0.0);
     f67 = i13 ? f67 : Math_fround(0.0);
     f67 = Math_fround(f66 - Math_fround(Math_fround(HEAPF32[i101 + 192 + (i48 * 48 | 0) + 8 >> 2]) * f67));
     if (i4 | 0) if (!((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 204 >> 2] | 0, i4 | 0) | 0) & 1)) {
      HEAP32[i119 + 1016 + (i48 << 2) >> 2] = i4;
      f64 = Math_fround(-f67);
      f65 = Math_fround(f95 * Math_fround(f51 * f64));
      f66 = Math_fround(f95 * Math_fround(f49 * f64));
      HEAPF32[i119 + 1032 + (i48 * 12 | 0) >> 2] = Math_fround(f95 * Math_fround(f50 * f64));
      HEAPF32[i119 + 1032 + (i48 * 12 | 0) + 4 >> 2] = f65;
      HEAPF32[i119 + 1032 + (i48 * 12 | 0) + 8 >> 2] = f66;
      HEAP32[i119 + 1080 + (i48 * 12 | 0) >> 2] = HEAP32[i14 >> 2];
      HEAP32[i119 + 1080 + (i48 * 12 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i119 + 1080 + (i48 * 12 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
     }
     f66 = Math_fround(f98 * f67);
     f66 = Math_fround(f66 * Math_fround(HEAPF32[i101 + 848 + (i48 << 2) >> 2]));
     f29 = Math_fround(HEAPF32[i104 >> 2]);
     if (!(f29 >= f66)) {
      i16 = !(Math_fround(HEAPF32[i33 >> 2]) <= f66);
      f35 = Math_fround(HEAPF32[i34 >> 2]);
      if (i16) {
       f65 = Math_fround(HEAPF32[i36 >> 2]);
       f35 = Math_fround(f65 + Math_fround(Math_fround(HEAPF32[i37 >> 2]) * Math_fround(Math_fround(f66 - f29) * Math_fround(f35 - f65))));
      }
     } else f35 = Math_fround(HEAPF32[i36 >> 2]);
     f65 = Math_fround(f99 * f35);
     i8 = i101 + 832 + (i48 << 2) | 0;
     f65 = Math_fround(f65 * Math_fround(HEAPF32[i8 >> 2]));
     if (HEAP32[gb + 1458456 >> 2] | 0) {
      i16 = HEAP32[gb + 1458456 + (i48 + i120 << 2) >> 2] | 0;
      HEAPF32[i16 + 8 >> 2] = f65;
      HEAPF32[i16 + 12 >> 2] = f35;
     }
     f46 = Math_fround(HEAPF32[i91 + (i48 << 2) >> 2]);
     f39 = Math_fround(Math_fround(f90 * f49) - Math_fround(f87 * f51));
     f41 = Math_fround(Math_fround(f87 * f50) - Math_fround(f86 * f49));
     f44 = Math_fround(Math_fround(f86 * f51) - Math_fround(f90 * f50));
     f45 = Math_fround(Math_fround(f51 * f44) - Math_fround(f49 * f41));
     f42 = Math_fround(Math_fround(f49 * f39) - Math_fround(f50 * f44));
     f43 = Math_fround(Math_fround(f50 * f41) - Math_fround(f51 * f39));
     f29 = Math_fround(Math_sqrt(Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f39 * f39) + Math_fround(f41 * f41)))));
     if (f29 > Math_fround(0.0)) {
      f64 = Math_fround(Math_fround(1.0) / f29);
      f39 = Math_fround(f39 * f64);
      f41 = Math_fround(f41 * f64);
      f44 = Math_fround(f44 * f64);
     }
     f29 = Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f45 * f45) + Math_fround(f42 * f42)))));
     if (f29 > Math_fround(0.0)) {
      f64 = Math_fround(Math_fround(1.0) / f29);
      f29 = Math_fround(f45 * f64);
      f42 = Math_fround(f42 * f64);
      f43 = Math_fround(f43 * f64);
     } else f29 = f45;
     f58 = Math_fround(+Math_cos(+f46));
     f59 = Math_fround(+Math_sin(+f46));
     f62 = Math_fround(Math_fround(f39 * f58) + Math_fround(f29 * f59));
     f63 = Math_fround(Math_fround(f41 * f58) + Math_fround(f42 * f59));
     f64 = Math_fround(Math_fround(f44 * f58) + Math_fround(f43 * f59));
     f61 = Math_fround(Math_fround(f29 * f58) - Math_fround(f39 * f59));
     f60 = Math_fround(Math_fround(f42 * f58) - Math_fround(f41 * f59));
     f59 = Math_fround(Math_fround(f43 * f58) - Math_fround(f44 * f59));
     HEAPF32[i119 + 324 + (i48 * 12 | 0) >> 2] = f62;
     HEAPF32[i119 + 324 + (i48 * 12 | 0) + 4 >> 2] = f63;
     HEAPF32[i119 + 324 + (i48 * 12 | 0) + 8 >> 2] = f64;
     HEAPF32[i119 + 372 + (i48 * 12 | 0) >> 2] = f61;
     HEAPF32[i119 + 372 + (i48 * 12 | 0) + 4 >> 2] = f60;
     HEAPF32[i119 + 372 + (i48 * 12 | 0) + 8 >> 2] = f59;
     f58 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = Math_fround(f58 * f62);
     f57 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = Math_fround(f53 + Math_fround(f57 * f63));
     f55 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f53 = Math_fround(Math_fround(f55 * f64) + f53);
     f57 = Math_fround(Math_fround(f55 * f59) + Math_fround(Math_fround(f58 * f61) + Math_fround(f57 * f60)));
     HEAPF32[i119 + 452 + (i48 << 2) >> 2] = f53;
     f58 = Math_fround(HEAPF32[i102 + (i48 << 2) >> 2]);
     f55 = Math_fround(HEAPF32[i17 >> 2]);
     f51 = Math_fround(Math_abs(Math_fround(f53)));
     f29 = Math_fround(f58 * f55);
     f41 = Math_fround(Math_abs(Math_fround(f29)));
     f56 = Math_fround(+Math_atan(+Math_fround(f57 / Math_fround(f51 + Math_fround(HEAPF32[gb + 1458428 >> 2])))));
     i5 = f58 == Math_fround(0.0);
     do if (i5 & f53 == Math_fround(0.0)) i1 = 0; else {
      i1 = (HEAP8[i93 + i48 >> 0] | HEAP8[i92 + i48 >> 0]) << 24 >> 24 != 0;
      f39 = Math_fround(f29 - f53);
      if (i85) {
       f29 = f51 > f41 ? f51 : f41;
       if (i1) {
        f54 = Math_fround(f39 / Math_fround(f29 + Math_fround(Math_fround(HEAPF32[gb + 1458436 >> 2]) * Math_fround(.100000001))));
        i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
        break;
       } else {
        f54 = Math_fround(f39 / (f29 < f100 ? f100 : f29));
        i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
        break;
       }
      } else if (i1) {
       f54 = Math_fround(f39 / Math_fround(f51 + Math_fround(Math_fround(HEAPF32[gb + 1458436 >> 2]) * Math_fround(.100000001))));
       i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
       break;
      } else {
       f54 = f51 > f41 ? f51 : f41;
       f54 = Math_fround(f39 / (f54 < f100 ? f100 : f54));
       i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
       break;
      }
     } while (0);
     i6 = i119 + 420 + (i48 << 2) | 0;
     HEAP32[i6 >> 2] = i1;
     i7 = i119 + 436 + (i48 << 2) | 0;
     HEAPF32[i7 >> 2] = f56;
     f29 = Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 20 >> 2]);
     if (f52 > Math_fround(0.0)) {
      f54 = Math_fround(f52 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 24 >> 2]));
      f54 = Math_fround(f29 + Math_fround(f54 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 32 >> 2])));
     } else {
      f54 = Math_fround(f52 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 28 >> 2]));
      f54 = Math_fround(f29 - Math_fround(f54 * Math_fround(HEAPF32[i101 + (i48 * 48 | 0) + 36 >> 2])));
     }
     f52 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f42 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 20 >> 2]);
     f43 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 24 >> 2]);
     f39 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 28 >> 2]);
     f29 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 36 >> 2]);
     f41 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 52 >> 2]);
     f44 = Math_fround(Math_abs(Math_fround(f52)));
     do if (f44 < f43) {
      f29 = Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 48 >> 2]);
      f29 = Math_fround(f42 + Math_fround(f29 * Math_fround(Math_fround(f39 - f42) * Math_fround(f44 - Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 16 >> 2])))));
     } else {
      if (!(f44 < Math_fround(HEAPF32[i101 + 384 + (i48 << 6) + 32 >> 2]))) break;
      f29 = Math_fround(f39 + Math_fround(f41 * Math_fround(Math_fround(f29 - f39) * Math_fround(f44 - f43))));
     } while (0);
     f45 = Math_fround(f71 * f29);
     i4 = i119 + 276 + (i48 << 2) | 0;
     HEAPF32[i4 >> 2] = f45;
     if (Math_fround(f71 * f65) > Math_fround(0.0)) {
      f44 = Math_fround(Math_fround(HEAPF32[i101 + 736 + (i48 * 12 | 0) >> 2]) * Math_fround(2.0));
      f42 = Math_fround(Math_fround(HEAPF32[i101 + 736 + (i48 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
      f127 = Math_fround(Math_fround(HEAPF32[i101 + 736 + (i48 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
      f41 = Math_fround(HEAPF32[i105 >> 2]);
      f39 = Math_fround(Math_fround(f41 * f41) + Math_fround(-.5));
      f43 = Math_fround(HEAPF32[i106 >> 2]);
      f50 = Math_fround(f44 * f43);
      f71 = Math_fround(HEAPF32[i107 >> 2]);
      f50 = Math_fround(f50 + Math_fround(f42 * f71));
      f29 = Math_fround(HEAPF32[i108 >> 2]);
      f50 = Math_fround(f50 + Math_fround(f127 * f29));
      f46 = Math_fround(Math_fround(f43 * f50) + Math_fround(Math_fround(f44 * f39) + Math_fround(f41 * Math_fround(Math_fround(f127 * f71) - Math_fround(f42 * f29)))));
      f49 = Math_fround(Math_fround(f71 * f50) + Math_fround(Math_fround(f42 * f39) + Math_fround(f41 * Math_fround(Math_fround(f44 * f29) - Math_fround(f127 * f43)))));
      f50 = Math_fround(Math_fround(Math_fround(f127 * f39) + Math_fround(f41 * Math_fround(Math_fround(f42 * f43) - Math_fround(f44 * f71)))) + Math_fround(f29 * f50));
      i3 = i101 + 192 + (i48 * 48 | 0) + 36 | 0;
      f29 = Math_fround(HEAPF32[gb + 1458432 >> 2]);
      i2 = f51 < f29;
      do if (i2) {
       f127 = Math_fround(HEAPF32[i18 >> 2]);
       i1 = i88 | !(Math_fround(Math_abs(Math_fround(f58))) < Math_fround(f29 * Math_fround(HEAPF32[i3 >> 2])));
       f29 = Math_fround(f96 + f127);
       f29 = i1 ? Math_fround(0.0) : f29;
       i1 = f29 > Math_fround(1.0);
       if (i5 & i2) {
        if (!(i1 | i24)) {
         i1 = 0;
         i2 = 0;
         f44 = f29;
         break;
        }
       } else if (!i1) {
        i1 = 0;
        i2 = 0;
        f44 = f29;
        break;
       }
       f44 = Math_fround(f53 * Math_fround(.00999999977));
       i1 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
       i2 = 1;
       f44 = f29;
      } else {
       i1 = 0;
       i2 = 0;
       f44 = Math_fround(0.0);
      } while (0);
      f43 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f29 = Math_fround(f43 * f62);
      f42 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f29 = Math_fround(f29 + Math_fround(f42 * f63));
      f41 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f29 = Math_fround(Math_fround(f41 * f64) + f29);
      f29 = Math_fround(f29 + (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      HEAPF32[i18 >> 2] = f44;
      HEAP8[i19 >> 0] = i2;
      HEAPF32[i20 >> 2] = f29;
      HEAPF32[i119 + 704 + (i48 * 12 | 0) >> 2] = f62;
      HEAPF32[i119 + 704 + (i48 * 12 | 0) + 4 >> 2] = f63;
      HEAPF32[i119 + 704 + (i48 * 12 | 0) + 8 >> 2] = f64;
      HEAPF32[i119 + 656 + (i48 * 12 | 0) >> 2] = f46;
      HEAPF32[i119 + 656 + (i48 * 12 | 0) + 4 >> 2] = f49;
      HEAPF32[i119 + 656 + (i48 * 12 | 0) + 8 >> 2] = f50;
      f29 = i2 << 24 >> 24 ? Math_fround(0.0) : f52;
      HEAPF32[i6 >> 2] = f29;
      f39 = Math_fround(HEAPF32[i21 >> 2]);
      f127 = Math_fround(Math_abs(Math_fround(f57)));
      i20 = i88 | !(f127 < Math_fround(HEAPF32[gb + 1458432 >> 2]));
      f39 = Math_fround(f96 + f39);
      i20 = i20 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = f44 > Math_fround(0.0) & (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(1.0);
      f57 = Math_fround(f57 * Math_fround(.100000001));
      f71 = Math_fround(Math_fround(f41 * f59) + Math_fround(Math_fround(f43 * f61) + Math_fround(f42 * f60)));
      f57 = Math_fround(f71 + (i1 ? f57 : Math_fround(0.0)));
      HEAP32[i21 >> 2] = i20;
      HEAP8[i22 >> 0] = i1 & 1;
      HEAPF32[i23 >> 2] = f57;
      HEAPF32[i119 + 820 + (i48 * 12 | 0) >> 2] = f61;
      HEAPF32[i119 + 820 + (i48 * 12 | 0) + 4 >> 2] = f60;
      HEAPF32[i119 + 820 + (i48 * 12 | 0) + 8 >> 2] = f59;
      HEAPF32[i119 + 772 + (i48 * 12 | 0) >> 2] = f46;
      HEAPF32[i119 + 772 + (i48 * 12 | 0) + 4 >> 2] = f49;
      HEAPF32[i119 + 772 + (i48 * 12 | 0) + 8 >> 2] = f50;
      f57 = i1 ? Math_fround(0.0) : f56;
      HEAPF32[i7 >> 2] = f57;
      HEAPF32[i125 >> 2] = Math_fround(0.0);
      HEAPF32[i123 >> 2] = Math_fround(0.0);
      HEAPF32[i122 >> 2] = Math_fround(0.0);
      HEAPF32[i121 >> 2] = Math_fround(0.0);
      f71 = Math_fround(f99 * Math_fround(HEAPF32[i8 >> 2]));
      f127 = Math_fround(HEAPF32[i3 >> 2]);
      mftCall_viffffffffffffiiii(HEAP32[i38 >> 2] | 0, HEAP32[i103 + (i48 << 2) >> 2] | 0, +f45, +f29, +f57, +f54, +f58, +f55, +f127, +f71, +f35, +f65, +f99, +f98, i125 | 0, i123 | 0, i122 | 0, i121 | 0);
      HEAP32[i119 + 468 + (i48 << 2) >> 2] = HEAP32[i125 >> 2];
      f65 = Math_fround(HEAPF32[i123 >> 2]);
      f62 = Math_fround(f62 * f65);
      f63 = Math_fround(f63 * f65);
      f65 = Math_fround(f64 * f65);
      f64 = Math_fround(HEAPF32[i122 >> 2]);
      f62 = Math_fround(f62 + Math_fround(f61 * f64));
      f63 = Math_fround(f63 + Math_fround(f60 * f64));
      f64 = Math_fround(f65 + Math_fround(f59 * f64));
      f65 = Math_fround(Math_fround(f49 * f64) - Math_fround(f50 * f63));
      f71 = Math_fround(Math_fround(f50 * f62) - Math_fround(f46 * f64));
      f127 = Math_fround(Math_fround(f46 * f63) - Math_fround(f49 * f62));
      HEAPF32[i26 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f62);
      HEAPF32[i27 >> 2] = Math_fround(f63 + Math_fround(HEAPF32[i27 >> 2]));
      HEAPF32[i28 >> 2] = Math_fround(f64 + Math_fround(HEAPF32[i28 >> 2]));
      HEAPF32[i30 >> 2] = Math_fround(f65 + Math_fround(HEAPF32[i30 >> 2]));
      HEAPF32[i31 >> 2] = Math_fround(f71 + Math_fround(HEAPF32[i31 >> 2]));
      HEAPF32[i32 >> 2] = Math_fround(f127 + Math_fround(HEAPF32[i32 >> 2]));
      i1 = HEAP32[gb + 1458448 >> 2] | 0;
      if (i1 | 0) {
       f65 = Math_fround(f46 + Math_fround(HEAPF32[i75 >> 2]));
       f71 = Math_fround(f49 + Math_fround(HEAPF32[i76 >> 2]));
       f127 = Math_fround(f50 + Math_fround(HEAPF32[i77 >> 2]));
       HEAPF32[i1 + (i48 * 12 | 0) >> 2] = f65;
       HEAPF32[i1 + (i48 * 12 | 0) + 4 >> 2] = f71;
       HEAPF32[i1 + (i48 * 12 | 0) + 8 >> 2] = f127;
      }
      i1 = HEAP32[gb + 1458452 >> 2] | 0;
      if (i1 | 0) {
       f68 = Math_fround(f68 + Math_fround(HEAPF32[i75 >> 2]));
       f71 = Math_fround(f69 + Math_fround(HEAPF32[i76 >> 2]));
       f127 = Math_fround(f70 + Math_fround(HEAPF32[i77 >> 2]));
       HEAPF32[i1 + (i48 * 12 | 0) >> 2] = f68;
       HEAPF32[i1 + (i48 * 12 | 0) + 4 >> 2] = f71;
       HEAPF32[i1 + (i48 * 12 | 0) + 8 >> 2] = f127;
      }
      if (!(HEAP32[gb + 1458456 >> 2] | 0)) break;
      f127 = Math_fround(Math_fround(f66 * Math_fround(Math_abs(Math_fround(HEAPF32[i123 >> 2])))) / f67);
      i23 = HEAP32[gb + 1458456 + (i48 + i120 << 2) >> 2] | 0;
      HEAPF32[i23 + 28 >> 2] = f127;
      HEAPF32[i23 + 36 >> 2] = Math_fround(Math_fround(f66 * Math_fround(Math_abs(Math_fround(HEAPF32[i122 >> 2])))) / f67);
      HEAPF32[i23 + 40 >> 2] = Math_fround(Math_fround(f66 * Math_fround(HEAPF32[i121 >> 2])) / f67);
      HEAP32[i23 + 24 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i23 + 32 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i23 + 20 >> 2] = HEAP32[i4 >> 2];
     }
    }
   }
  } while (0);
  i48 = i48 + 1 | 0;
 } while ((i48 | 0) != 4);
 STACKTOP = i126;
 return;
}

function __ZN5physx23PxcContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i2, i29, i21, i59, i54, i1, i79) {
 i2 = i2 | 0;
 i29 = i29 | 0;
 i21 = i21 | 0;
 i59 = i59 | 0;
 i54 = i54 | 0;
 i1 = i1 | 0;
 i79 = i79 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i80 = 0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 8976 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i80 + 528 | 0;
 i76 = i80 + 464 | 0;
 i77 = i80 + 256 | 0;
 i78 = i80 + 112 | 0;
 i75 = i80 + 8952 | 0;
 i73 = i80 + 8948 | 0;
 i74 = i80 + 8936 | 0;
 i46 = i80 + 8924 | 0;
 i1 = i80 + 80 | 0;
 i5 = i80 + 64 | 0;
 i6 = i80 + 48 | 0;
 i68 = i80 + 32 | 0;
 i69 = i80 + 8912 | 0;
 i67 = i80 + 16 | 0;
 i71 = i80;
 i53 = i80 + 8888 | 0;
 i72 = i80 + 8792 | 0;
 i65 = i80 + 8720 | 0;
 i47 = i80 + 8876 | 0;
 i55 = i80 + 8864 | 0;
 i66 = HEAP32[i29 + 32 >> 2] | 0;
 HEAP32[i68 >> 2] = 0;
 HEAP32[i68 + 4 >> 2] = 0;
 HEAP32[i68 + 8 >> 2] = 0;
 HEAP32[i68 + 12 >> 2] = 0;
 i13 = i2 + 8 | 0;
 f38 = Math_fround(HEAPF32[i13 >> 2]);
 i64 = i2 + 4 | 0;
 i70 = HEAP32[i64 >> 2] | 0;
 i52 = i29 + 4 | 0;
 i25 = i29 + 8 | 0;
 i58 = HEAP32[i25 >> 2] | 0;
 i26 = i29 + 12 | 0;
 i27 = HEAP32[i26 >> 2] | 0;
 HEAP32[i67 >> 2] = HEAP32[i52 >> 2];
 HEAP32[i67 + 4 >> 2] = i58;
 HEAP32[i67 + 8 >> 2] = i27;
 HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
 i27 = i29 + 16 | 0;
 i58 = HEAP32[i29 + 20 >> 2] | 0;
 i57 = HEAP32[i29 + 24 >> 2] | 0;
 i56 = HEAP32[i29 + 28 >> 2] | 0;
 HEAP32[i71 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i71 + 4 >> 2] = i58;
 HEAP32[i71 + 8 >> 2] = i57;
 HEAP32[i71 + 12 >> 2] = i56;
 f37 = Math_fround(-Math_fround(HEAPF32[i59 >> 2]));
 i56 = i59 + 4 | 0;
 f31 = Math_fround(-Math_fround(HEAPF32[i56 >> 2]));
 i57 = i59 + 8 | 0;
 f33 = Math_fround(-Math_fround(HEAPF32[i57 >> 2]));
 i58 = i59 + 12 | 0;
 f22 = Math_fround(HEAPF32[i58 >> 2]);
 i2 = i21 + 16 | 0;
 f36 = Math_fround(HEAPF32[i2 >> 2]);
 i60 = i59 + 16 | 0;
 f36 = Math_fround(f36 - Math_fround(HEAPF32[i60 >> 2]));
 i12 = i21 + 20 | 0;
 f32 = Math_fround(HEAPF32[i12 >> 2]);
 i61 = i59 + 20 | 0;
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i61 >> 2]));
 i20 = i21 + 24 | 0;
 f23 = Math_fround(HEAPF32[i20 >> 2]);
 i62 = i59 + 24 | 0;
 f36 = Math_fround(f36 * Math_fround(2.0));
 f32 = Math_fround(f32 * Math_fround(2.0));
 f23 = Math_fround(Math_fround(f23 - Math_fround(HEAPF32[i62 >> 2])) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f42 = Math_fround(Math_fround(Math_fround(f36 * f37) + Math_fround(f32 * f31)) + Math_fround(f23 * f33));
 f35 = Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f30 * f36) + Math_fround(f22 * Math_fround(Math_fround(f23 * f31) - Math_fround(f32 * f33)))));
 f39 = Math_fround(Math_fround(f42 * f31) + Math_fround(Math_fround(f30 * f32) + Math_fround(f22 * Math_fround(Math_fround(f36 * f33) - Math_fround(f23 * f37)))));
 f42 = Math_fround(Math_fround(Math_fround(f30 * f23) + Math_fround(f22 * Math_fround(Math_fround(f32 * f37) - Math_fround(f36 * f31)))) + Math_fround(f42 * f33));
 f36 = Math_fround(HEAPF32[i21 >> 2]);
 f32 = Math_fround(f22 * f36);
 i8 = i21 + 12 | 0;
 f23 = Math_fround(HEAPF32[i8 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f23 * f37));
 i9 = i21 + 8 | 0;
 f30 = Math_fround(HEAPF32[i9 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f30 * f31));
 i10 = i21 + 4 | 0;
 f24 = Math_fround(HEAPF32[i10 >> 2]);
 f32 = Math_fround(f32 - Math_fround(f24 * f33));
 f34 = Math_fround(Math_fround(Math_fround(f36 * f33) + Math_fround(Math_fround(f23 * f31) + Math_fround(f22 * f24))) - Math_fround(f30 * f37));
 f28 = Math_fround(Math_fround(Math_fround(f24 * f37) + Math_fround(Math_fround(f23 * f33) + Math_fround(f22 * f30))) - Math_fround(f36 * f31));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f23) - Math_fround(f36 * f37)) - Math_fround(f24 * f31)) - Math_fround(f30 * f33));
 HEAPF32[i76 + 48 >> 2] = f35;
 HEAPF32[i76 + 52 >> 2] = f39;
 HEAPF32[i76 + 56 >> 2] = f42;
 HEAPF32[i76 + 60 >> 2] = Math_fround(0.0);
 f42 = Math_fround(f32 + f32);
 f39 = Math_fround(f34 + f34);
 f35 = Math_fround(f28 + f28);
 f30 = Math_fround(f34 * f39);
 f31 = Math_fround(f28 * f35);
 f34 = Math_fround(f42 * f34);
 f24 = Math_fround(f42 * f28);
 f37 = Math_fround(f42 * f33);
 f28 = Math_fround(f28 * f39);
 f39 = Math_fround(f33 * f39);
 f35 = Math_fround(f33 * f35);
 f42 = Math_fround(Math_fround(1.0) - Math_fround(f32 * f42));
 f32 = Math_fround(f34 + f35);
 f33 = Math_fround(f24 - f39);
 f35 = Math_fround(f34 - f35);
 f34 = Math_fround(f42 - f31);
 f36 = Math_fround(f37 + f28);
 f39 = Math_fround(f24 + f39);
 f37 = Math_fround(f28 - f37);
 f42 = Math_fround(f42 - f30);
 HEAPF32[i76 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f30) - f31);
 HEAPF32[i76 + 4 >> 2] = f32;
 HEAPF32[i76 + 8 >> 2] = f33;
 HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i76 + 16 >> 2] = f35;
 HEAPF32[i76 + 20 >> 2] = f34;
 HEAPF32[i76 + 24 >> 2] = f36;
 HEAPF32[i76 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i76 + 32 >> 2] = f39;
 HEAPF32[i76 + 36 >> 2] = f37;
 HEAPF32[i76 + 40 >> 2] = f42;
 HEAPF32[i76 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i77, i66 + 16 | 0, i68, i67, i71);
 f42 = Math_fround(f38 * Math_fround(0.0));
 i71 = i78 + 64 | 0;
 HEAP32[i78 >> 2] = HEAP32[i68 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i68 + 12 >> 2];
 HEAP32[i78 + 80 >> 2] = 4;
 HEAPF32[i78 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i78 + 128 >> 2] = i70;
 i67 = i78 + 132 | 0;
 HEAP32[i67 >> 2] = HEAP32[i69 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
 f37 = Math_fround(HEAPF32[i68 >> 2]);
 f39 = Math_fround(HEAPF32[i68 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i68 + 8 >> 2]);
 f34 = Math_fround(f42 + f39);
 f35 = Math_fround(f42 + f36);
 HEAPF32[i78 + 96 >> 2] = Math_fround(f38 + f37);
 HEAPF32[i78 + 100 >> 2] = f34;
 HEAPF32[i78 + 104 >> 2] = f35;
 HEAPF32[i78 + 108 >> 2] = Math_fround(0.0);
 f39 = Math_fround(f39 - f42);
 f42 = Math_fround(f36 - f42);
 HEAPF32[i78 + 112 >> 2] = Math_fround(f37 - f38);
 HEAPF32[i78 + 116 >> 2] = f39;
 HEAPF32[i78 + 120 >> 2] = f42;
 HEAPF32[i78 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i78 + 16 >> 2] = i70;
 i68 = i78 + 20 | 0;
 HEAP32[i68 >> 2] = HEAP32[i69 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
 HEAP32[i78 + 32 >> 2] = i70;
 i70 = i78 + 36 | 0;
 HEAP32[i70 >> 2] = HEAP32[i69 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
 HEAP32[i63 >> 2] = -1;
 HEAP32[i63 + 4 >> 2] = -1;
 HEAP32[i63 + 8 >> 2] = -1;
 HEAP32[i63 + 12 >> 2] = -1;
 HEAP32[i71 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
 if ((__ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i78, i77, i76, i80 + 96 | 0, i1, i5, i6) | 0) == 1) {
  i1 = 0;
  f16 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  i43 = 0;
  i44 = 0;
  i45 = 0;
 } else {
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f31 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f35 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f17 = Math_fround(f17 * Math_fround(2.0));
  f31 = Math_fround(f31 * Math_fround(2.0));
  f30 = Math_fround(f30 * Math_fround(2.0));
  f34 = Math_fround(HEAPF32[i58 >> 2]);
  f33 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
  f36 = Math_fround(HEAPF32[i59 >> 2]);
  f42 = Math_fround(f17 * f36);
  f38 = Math_fround(HEAPF32[i56 >> 2]);
  f42 = Math_fround(f42 + Math_fround(f31 * f38));
  f39 = Math_fround(HEAPF32[i57 >> 2]);
  f42 = Math_fround(f42 + Math_fround(f30 * f39));
  f16 = Math_fround(Math_fround(f36 * f42) + Math_fround(Math_fround(f17 * f33) + Math_fround(f34 * Math_fround(Math_fround(f30 * f38) - Math_fround(f31 * f39)))));
  f18 = Math_fround(Math_fround(f38 * f42) + Math_fround(Math_fround(f31 * f33) + Math_fround(f34 * Math_fround(Math_fround(f17 * f39) - Math_fround(f30 * f36)))));
  f42 = Math_fround(Math_fround(Math_fround(f30 * f33) + Math_fround(f34 * Math_fround(Math_fround(f31 * f36) - Math_fround(f17 * f38)))) + Math_fround(f39 * f42));
  f16 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) + f16);
  f18 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) + f18);
  f42 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) + f42);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i44 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  f37 = Math_fround(f37 * Math_fround(2.0));
  f35 = Math_fround(f35 * Math_fround(2.0));
  f32 = Math_fround(f32 * Math_fround(2.0));
  f18 = Math_fround(Math_fround(Math_fround(f37 * f36) + Math_fround(f35 * f38)) + Math_fround(f32 * f39));
  i1 = HEAP32[i6 >> 2] | 0;
  f16 = Math_fround(Math_fround(f36 * f18) + Math_fround(Math_fround(f37 * f33) + Math_fround(f34 * Math_fround(Math_fround(f32 * f38) - Math_fround(f35 * f39)))));
  f17 = Math_fround(Math_fround(f38 * f18) + Math_fround(Math_fround(f35 * f33) + Math_fround(f34 * Math_fround(Math_fround(f37 * f39) - Math_fround(f32 * f36)))));
  f18 = Math_fround(Math_fround(Math_fround(f32 * f33) + Math_fround(f34 * Math_fround(Math_fround(f35 * f36) - Math_fround(f37 * f38)))) + Math_fround(f39 * f18));
  i45 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f39 = Math_fround(HEAPF32[i64 >> 2]);
 f39 = Math_fround(f39 + Math_fround(HEAPF32[i54 >> 2]));
 f39 = Math_fround(f39 * f39);
 f42 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f42 >= f39) {
  i79 = 0;
  STACKTOP = i80;
  return i79 | 0;
 }
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f38 = Math_fround(f14 * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 f37 = Math_fround(f15 * Math_fround(2.0));
 f15 = Math_fround(Math_fround(f14 * f38) + Math_fround(Math_fround(f15 * f37) + Math_fround(-1.0)));
 f14 = Math_fround(HEAPF32[i9 >> 2]);
 f11 = Math_fround(f14 * f37);
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f38 * f4));
 f4 = Math_fround(Math_fround(f38 * f14) - Math_fround(f37 * f4));
 f37 = Math_fround(HEAPF32[i13 >> 2]);
 f15 = Math_fround(f37 * f15);
 f11 = Math_fround(f37 * f11);
 f4 = Math_fround(f37 * f4);
 f37 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(f37 + f15);
 f38 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f38 + f11);
 f39 = Math_fround(HEAPF32[i20 >> 2]);
 f3 = Math_fround(f4 + f39);
 HEAPF32[i53 >> 2] = f14;
 HEAPF32[i53 + 4 >> 2] = f7;
 HEAPF32[i53 + 8 >> 2] = f3;
 f15 = Math_fround(f37 - f15);
 f11 = Math_fround(f38 - f11);
 f4 = Math_fround(f39 - f4);
 HEAPF32[i53 + 12 >> 2] = f15;
 HEAPF32[i53 + 16 >> 2] = f11;
 HEAPF32[i53 + 20 >> 2] = f4;
 i51 = f14 == f15 & f7 == f11 & f3 == f4;
 i50 = i51 ? 1 : 2;
 HEAP32[i72 >> 2] = 1065353216;
 i66 = i72 + 4 | 0;
 HEAP32[i66 >> 2] = 0;
 i67 = i72 + 8 | 0;
 HEAP32[i67 >> 2] = 0;
 HEAP32[i72 + 12 >> 2] = 0;
 i68 = i72 + 16 | 0;
 HEAP32[i68 >> 2] = 1065353216;
 i69 = i72 + 20 | 0;
 HEAP32[i69 >> 2] = 0;
 HEAP32[i72 + 24 >> 2] = 0;
 i70 = i72 + 28 | 0;
 HEAP32[i70 >> 2] = 0;
 i71 = i72 + 32 | 0;
 HEAP32[i71 >> 2] = 1065353216;
 HEAP32[i72 + 36 >> 2] = 1065353216;
 HEAP32[i72 + 40 >> 2] = 0;
 HEAP32[i72 + 44 >> 2] = 0;
 HEAP32[i72 + 48 >> 2] = 0;
 HEAP32[i72 + 52 >> 2] = 1065353216;
 HEAP32[i72 + 56 >> 2] = 0;
 HEAP32[i72 + 60 >> 2] = 0;
 HEAP32[i72 + 64 >> 2] = 0;
 HEAP32[i72 + 68 >> 2] = 1065353216;
 if (Math_fround(HEAPF32[i52 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i25 >> 2]) == Math_fround(1.0)) {
  if (!(Math_fround(HEAPF32[i26 >> 2]) == Math_fround(1.0))) i49 = 7;
 } else i49 = 7; else i49 = 7;
 if ((i49 | 0) == 7) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i72, i52, i27);
 __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE(i65, HEAP32[i29 + 36 >> 2] | 0, i72);
 L13 : do if (f42 > Math_fround(0.0)) {
  f19 = Math_fround(-f16);
  f17 = Math_fround(-f17);
  f16 = Math_fround(-f18);
  HEAPF32[i47 >> 2] = f19;
  i40 = i47 + 4 | 0;
  HEAPF32[i40 >> 2] = f17;
  i41 = i47 + 8 | 0;
  HEAPF32[i41 >> 2] = f16;
  f39 = Math_fround(HEAPF32[i64 >> 2]);
  __ZL22PxcGenerateVFContacts2RN5physx2Gu13ContactBufferERKNS_11PxTransformERKNS0_13PolygonalDataERKNS_11PxMeshScaleEjPKNS_6PxVec3EfRSD_f(i79, i59, i65, i52, i50, i53, f39, i47, Math_fround(HEAPF32[i54 >> 2]));
  i29 = i79 + 4096 | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  if ((i1 | 0) == 2) i1 = 1; else {
   if (!i51) {
    f36 = Math_fround(HEAPF32[i59 >> 2]);
    f30 = Math_fround(f36 + f36);
    f28 = Math_fround(HEAPF32[i56 >> 2]);
    f39 = Math_fround(f28 + f28);
    f31 = Math_fround(HEAPF32[i57 >> 2]);
    f35 = Math_fround(f31 + f31);
    f34 = Math_fround(HEAPF32[i58 >> 2]);
    f38 = Math_fround(f30 * f34);
    f37 = Math_fround(f39 * f34);
    f34 = Math_fround(f34 * f35);
    f24 = Math_fround(f36 * f39);
    f23 = Math_fround(f36 * f35);
    f39 = Math_fround(f28 * f39);
    f28 = Math_fround(f28 * f35);
    f35 = Math_fround(f31 * f35);
    f31 = Math_fround(Math_fround(Math_fround(1.0) - f39) - f35);
    f32 = Math_fround(f24 + f34);
    f33 = Math_fround(f23 - f37);
    f34 = Math_fround(f24 - f34);
    f30 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f30));
    f35 = Math_fround(f30 - f35);
    f36 = Math_fround(f28 + f38);
    f37 = Math_fround(f23 + f37);
    f38 = Math_fround(f28 - f38);
    f39 = Math_fround(f30 - f39);
    f30 = Math_fround(HEAPF32[i60 >> 2]);
    f28 = Math_fround(HEAPF32[i61 >> 2]);
    f23 = Math_fround(HEAPF32[i62 >> 2]);
    f24 = Math_fround(HEAPF32[i64 >> 2]);
    f22 = Math_fround(HEAPF32[i54 >> 2]);
    f81 = Math_fround(Math_fround(Math_fround(f34 * f19) + Math_fround(f35 * f17)) + Math_fround(f36 * f16));
    f18 = Math_fround(Math_fround(Math_fround(f37 * f19) + Math_fround(f38 * f17)) + Math_fround(f39 * f16));
    HEAPF32[i63 >> 2] = Math_fround(Math_fround(Math_fround(f31 * f19) + Math_fround(f32 * f17)) + Math_fround(f33 * f16));
    HEAPF32[i63 + 4 >> 2] = f81;
    HEAPF32[i63 + 8 >> 2] = f18;
    i8 = mftCall_iiii(HEAP32[i65 + 68 >> 2] | 0, i65 | 0, i72 | 0, i63 | 0) | 0;
    HEAPF32[i76 >> 2] = f14;
    i1 = i76 + 4 | 0;
    HEAPF32[i1 >> 2] = f7;
    i2 = i76 + 8 | 0;
    HEAPF32[i2 >> 2] = f3;
    HEAPF32[i77 >> 2] = f15;
    i5 = i77 + 4 | 0;
    HEAPF32[i5 >> 2] = f11;
    i6 = i77 + 8 | 0;
    HEAPF32[i6 >> 2] = f4;
    f16 = Math_fround(f15 - f14);
    f17 = Math_fround(f11 - f7);
    f18 = Math_fround(f4 - f3);
    f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
    if (f19 > Math_fround(0.0)) {
     f81 = Math_fround(Math_fround(.00999999977) / f19);
     f16 = Math_fround(f16 * f81);
     f19 = Math_fround(f17 * f81);
     f81 = Math_fround(f18 * f81);
     f14 = Math_fround(f14 - f16);
     HEAPF32[i76 >> 2] = f14;
     f7 = Math_fround(f7 - f19);
     HEAPF32[i1 >> 2] = f7;
     f3 = Math_fround(f3 - f81);
     HEAPF32[i2 >> 2] = f3;
     f15 = Math_fround(f15 + f16);
     HEAPF32[i77 >> 2] = f15;
     f11 = Math_fround(f11 + f19);
     HEAPF32[i5 >> 2] = f11;
     f4 = Math_fround(f4 + f81);
     HEAPF32[i6 >> 2] = f4;
    }
    f15 = Math_fround(f15 - f14);
    f16 = Math_fround(f11 - f7);
    f81 = Math_fround(f4 - f3);
    HEAPF32[i78 >> 2] = f15;
    HEAPF32[i78 + 4 >> 2] = f16;
    HEAPF32[i78 + 8 >> 2] = f81;
    f17 = Math_fround(HEAPF32[i41 >> 2]);
    f19 = Math_fround(f16 * f17);
    f18 = Math_fround(HEAPF32[i40 >> 2]);
    f19 = Math_fround(f19 - Math_fround(f81 * f18));
    f4 = Math_fround(HEAPF32[i47 >> 2]);
    f19 = Math_fround(-f19);
    f81 = Math_fround(-Math_fround(Math_fround(f81 * f4) - Math_fround(f17 * f15)));
    f4 = Math_fround(-Math_fround(Math_fround(f15 * f18) - Math_fround(f16 * f4)));
    HEAPF32[i75 >> 2] = f19;
    HEAPF32[i75 + 4 >> 2] = f81;
    HEAPF32[i75 + 8 >> 2] = f4;
    HEAPF32[i75 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f3 * f4) + Math_fround(Math_fround(f14 * f19) + Math_fround(f7 * f81))));
    f3 = Math_fround(Math_abs(Math_fround(f19)));
    f81 = Math_fround(Math_abs(Math_fround(f81)));
    f4 = Math_fround(Math_abs(Math_fround(f4)));
    if (f81 > f3 & f81 > f4) {
     i25 = 0;
     i26 = 2;
    } else if (f4 > f3) {
     i25 = 1;
     i26 = 0;
    } else {
     i25 = 2;
     i26 = 1;
    }
    f81 = Math_fround(HEAPF32[i78 + (i25 << 2) >> 2]);
    f81 = Math_fround(f81 * Math_fround(HEAPF32[i47 + (i26 << 2) >> 2]));
    f16 = Math_fround(HEAPF32[i78 + (i26 << 2) >> 2]);
    f16 = Math_fround(Math_fround(1.0) / Math_fround(f81 - Math_fround(f16 * Math_fround(HEAPF32[i47 + (i25 << 2) >> 2]))));
    i27 = HEAP32[i65 + 28 >> 2] | 0;
    i1 = HEAP32[i65 + 24 >> 2] | 0;
    i20 = HEAP32[i65 + 32 >> 2] | 0;
    i21 = HEAPU16[i1 + (i8 * 20 | 0) + 16 >> 1] | 0;
    i65 = HEAP8[i1 + (i8 * 20 | 0) + 18 >> 0] | 0;
    i1 = i65 & 255;
    if (i65 << 24 >> 24) {
     i9 = i72 + 12 | 0;
     i10 = i72 + 24 | 0;
     i12 = i46 + 4 | 0;
     i13 = i46 + 8 | 0;
     f4 = Math_fround(f24 + f22);
     i6 = i74 + 8 | 0;
     i8 = i74 + 4 | 0;
     f7 = Math_fround(HEAPF32[i47 >> 2]);
     f11 = Math_fround(-f7);
     f14 = Math_fround(-f18);
     f15 = Math_fround(-f17);
     i5 = i1;
     i1 = i1 + -1 | 0;
     i2 = 0;
     while (1) {
      i5 = i5 + -1 | 0;
      i65 = HEAPU8[i20 + (i1 + i21) >> 0] | 0;
      f3 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) >> 2]);
      f90 = Math_fround(HEAPF32[i72 >> 2]);
      f91 = Math_fround(f3 * f90);
      f89 = Math_fround(HEAPF32[i66 >> 2]);
      f84 = Math_fround(f3 * f89);
      f22 = Math_fround(HEAPF32[i67 >> 2]);
      f3 = Math_fround(f3 * f22);
      f83 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) + 4 >> 2]);
      f87 = Math_fround(HEAPF32[i9 >> 2]);
      f92 = Math_fround(f83 * f87);
      f86 = Math_fround(HEAPF32[i68 >> 2]);
      f82 = Math_fround(f83 * f86);
      f85 = Math_fround(HEAPF32[i69 >> 2]);
      f92 = Math_fround(f91 + f92);
      f82 = Math_fround(f84 + f82);
      f83 = Math_fround(f3 + Math_fround(f83 * f85));
      f3 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) + 8 >> 2]);
      f84 = Math_fround(HEAPF32[i10 >> 2]);
      f91 = Math_fround(f3 * f84);
      f81 = Math_fround(HEAPF32[i70 >> 2]);
      f88 = Math_fround(f3 * f81);
      f19 = Math_fround(HEAPF32[i71 >> 2]);
      f91 = Math_fround(f92 + f91);
      f88 = Math_fround(f82 + f88);
      f3 = Math_fround(f83 + Math_fround(f3 * f19));
      f83 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f31 * f91) + Math_fround(f34 * f88)) + Math_fround(f37 * f3)));
      f82 = Math_fround(f28 + Math_fround(Math_fround(Math_fround(f32 * f91) + Math_fround(f35 * f88)) + Math_fround(f38 * f3)));
      f3 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f33 * f91) + Math_fround(f36 * f88)) + Math_fround(f39 * f3)));
      i65 = HEAPU8[i20 + (i2 + i21) >> 0] | 0;
      f88 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) >> 2]);
      f90 = Math_fround(f90 * f88);
      f89 = Math_fround(f89 * f88);
      f88 = Math_fround(f22 * f88);
      f22 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) + 4 >> 2]);
      f87 = Math_fround(f90 + Math_fround(f87 * f22));
      f86 = Math_fround(f89 + Math_fround(f86 * f22));
      f22 = Math_fround(f88 + Math_fround(f85 * f22));
      f85 = Math_fround(HEAPF32[i27 + (i65 * 12 | 0) + 8 >> 2]);
      f84 = Math_fround(f87 + Math_fround(f84 * f85));
      f81 = Math_fround(f86 + Math_fround(f81 * f85));
      f85 = Math_fround(f22 + Math_fround(f19 * f85));
      f19 = Math_fround(f30 + Math_fround(Math_fround(f37 * f85) + Math_fround(Math_fround(f31 * f84) + Math_fround(f34 * f81))));
      f22 = Math_fround(f28 + Math_fround(Math_fround(f38 * f85) + Math_fround(Math_fround(f32 * f84) + Math_fround(f35 * f81))));
      f81 = Math_fround(f23 + Math_fround(Math_fround(f39 * f85) + Math_fround(Math_fround(f33 * f84) + Math_fround(f36 * f81))));
      HEAPF32[i46 >> 2] = f11;
      HEAPF32[i12 >> 2] = f14;
      HEAPF32[i13 >> 2] = f15;
      if (__ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_f(i76, i77, i78, i75, i26, i25, f16, i46, f83, f82, f3, f19, f22, f81, i73, i74, Math_fround(0.0)) | 0) {
       f3 = Math_fround(HEAPF32[i73 >> 2]);
       if (f3 < f4) {
        i1 = HEAP32[i29 >> 2] | 0;
        if (i1 >>> 0 <= 63) {
         f92 = Math_fround(f3 - f24);
         f91 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - Math_fround(f3 * f17));
         f90 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f3 * f18));
         f89 = Math_fround(Math_fround(HEAPF32[i74 >> 2]) - Math_fround(f3 * f7));
         HEAP32[i29 >> 2] = i1 + 1;
         HEAPF32[i79 + (i1 << 6) >> 2] = f7;
         HEAPF32[i79 + (i1 << 6) + 4 >> 2] = f18;
         HEAPF32[i79 + (i1 << 6) + 8 >> 2] = f17;
         HEAPF32[i79 + (i1 << 6) + 16 >> 2] = f89;
         HEAPF32[i79 + (i1 << 6) + 20 >> 2] = f90;
         HEAPF32[i79 + (i1 << 6) + 24 >> 2] = f91;
         HEAPF32[i79 + (i1 << 6) + 12 >> 2] = f92;
         HEAP32[i79 + (i1 << 6) + 48 >> 2] = -1;
         HEAP32[i79 + (i1 << 6) + 52 >> 2] = -1;
        }
       }
      }
      if (!i5) break; else {
       i1 = i2;
       i2 = i2 + 1 | 0;
      }
     }
    }
    i1 = HEAP32[i29 >> 2] | 0;
   }
   if (!i1) {
    f92 = Math_fround(Math_sqrt(Math_fround(f42)));
    f92 = Math_fround(f92 - Math_fround(HEAPF32[i64 >> 2]));
    HEAP32[i29 >> 2] = 1;
    HEAP32[i79 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i79 + 4 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i79 + 8 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i79 + 16 >> 2] = i43;
    HEAP32[i79 + 20 >> 2] = i44;
    HEAP32[i79 + 24 >> 2] = i45;
    HEAPF32[i79 + 12 >> 2] = f92;
    HEAP32[i79 + 48 >> 2] = -1;
    HEAP32[i79 + 52 >> 2] = -1;
    i1 = 1;
   } else i1 = 1;
  }
 } else {
  f33 = Math_fround(HEAPF32[i64 >> 2]);
  i47 = i65 + 16 | 0;
  i25 = HEAP32[i47 >> 2] | 0;
  i48 = i65 + 24 | 0;
  i26 = HEAP32[i48 >> 2] | 0;
  f90 = Math_fround(HEAPF32[i59 >> 2]);
  f92 = Math_fround(f90 + f90);
  f91 = Math_fround(HEAPF32[i56 >> 2]);
  f23 = Math_fround(f91 + f91);
  f16 = Math_fround(HEAPF32[i57 >> 2]);
  f22 = Math_fround(f16 + f16);
  f19 = Math_fround(HEAPF32[i58 >> 2]);
  f28 = Math_fround(f92 * f19);
  f30 = Math_fround(f23 * f19);
  f19 = Math_fround(f19 * f22);
  f92 = Math_fround(f90 * f92);
  f24 = Math_fround(f90 * f23);
  f90 = Math_fround(f90 * f22);
  f23 = Math_fround(f91 * f23);
  f91 = Math_fround(f91 * f22);
  f22 = Math_fround(f16 * f22);
  f16 = Math_fround(Math_fround(Math_fround(1.0) - f23) - f22);
  HEAPF32[i77 >> 2] = f16;
  f17 = Math_fround(f24 + f19);
  i27 = i77 + 4 | 0;
  HEAPF32[i27 >> 2] = f17;
  f18 = Math_fround(f90 - f30);
  i29 = i77 + 8 | 0;
  HEAPF32[i29 >> 2] = f18;
  f19 = Math_fround(f24 - f19);
  i40 = i77 + 12 | 0;
  HEAPF32[i40 >> 2] = f19;
  f92 = Math_fround(Math_fround(1.0) - f92);
  f22 = Math_fround(f92 - f22);
  i41 = i77 + 16 | 0;
  HEAPF32[i41 >> 2] = f22;
  f24 = Math_fround(f91 + f28);
  i43 = i77 + 20 | 0;
  HEAPF32[i43 >> 2] = f24;
  f30 = Math_fround(f90 + f30);
  i44 = i77 + 24 | 0;
  HEAPF32[i44 >> 2] = f30;
  f28 = Math_fround(f91 - f28);
  i45 = i77 + 28 | 0;
  HEAPF32[i45 >> 2] = f28;
  f23 = Math_fround(f92 - f23);
  i46 = i77 + 32 | 0;
  HEAPF32[i46 >> 2] = f23;
  HEAP32[i77 + 36 >> 2] = HEAP32[i59 + 16 >> 2];
  HEAP32[i77 + 40 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i77 + 44 >> 2] = HEAP32[i62 >> 2];
  i21 = (i25 | 0) == 0;
  L38 : do if (i21) {
   i1 = 0;
   i2 = 0;
   i5 = 0;
   f22 = Math_fround(3402823469999999843913219.0e14);
   i49 = 35;
  } else {
   i12 = i78 + 4 | 0;
   i13 = i78 + 8 | 0;
   i20 = i65 + 64 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
   f31 = f16;
   f32 = Math_fround(3402823469999999843913219.0e14);
   i10 = 0;
   while (1) {
    f90 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) >> 2]);
    f91 = Math_fround(f31 * f90);
    f92 = Math_fround(f17 * f90);
    f90 = Math_fround(f18 * f90);
    f18 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) + 4 >> 2]);
    f91 = Math_fround(f91 + Math_fround(f19 * f18));
    f92 = Math_fround(f92 + Math_fround(f22 * f18));
    f19 = Math_fround(f90 + Math_fround(f24 * f18));
    f18 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) + 8 >> 2]);
    f91 = Math_fround(f91 + Math_fround(f30 * f18));
    f92 = Math_fround(f92 + Math_fround(f28 * f18));
    f18 = Math_fround(f19 + Math_fround(f23 * f18));
    HEAPF32[i78 >> 2] = f91;
    HEAPF32[i12 >> 2] = f92;
    HEAPF32[i13 >> 2] = f18;
    f19 = Math_fround(Math_fround(Math_fround(f91 * f14) + Math_fround(f92 * f7)) + Math_fround(f18 * f3));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    f18 = Math_fround(Math_fround(Math_fround(f91 * f15) + Math_fround(f92 * f11)) + Math_fround(f18 * f4));
    i8 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = f19 > f18;
    f18 = Math_fround(f33 + (HEAP32[tempDoublePtr >> 2] = i9 ? i6 : i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    mftCall_viiiiii(HEAP32[i20 >> 2] | 0, i65 | 0, i78 | 0, i77 | 0, i72 | 0, i63 | 0, i76 | 0);
    f19 = Math_fround(HEAPF32[i63 >> 2]);
    if (f18 < f19) break;
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9 ? i8 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f33);
    f17 = Math_fround(HEAPF32[i76 >> 2]);
    if (f17 < f16) break;
    f92 = Math_fround(f18 - f19);
    f16 = Math_fround(f17 - f16);
    f16 = f92 < f16 ? f92 : f16;
    if (f16 < f32) {
     i1 = HEAP32[i13 >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i5 = HEAP32[i78 >> 2] | 0;
    } else f16 = f32;
    i6 = i10 + 1 | 0;
    if (i6 >>> 0 >= i25 >>> 0) {
     f22 = f16;
     i49 = 35;
     break L38;
    }
    f31 = Math_fround(HEAPF32[i77 >> 2]);
    f17 = Math_fround(HEAPF32[i27 >> 2]);
    f18 = Math_fround(HEAPF32[i29 >> 2]);
    f19 = Math_fround(HEAPF32[i40 >> 2]);
    f22 = Math_fround(HEAPF32[i41 >> 2]);
    f24 = Math_fround(HEAPF32[i43 >> 2]);
    f30 = Math_fround(HEAPF32[i44 >> 2]);
    f28 = Math_fround(HEAPF32[i45 >> 2]);
    f23 = Math_fround(HEAPF32[i46 >> 2]);
    f32 = f16;
    i10 = i6;
   }
  } while (0);
  L49 : do if ((i49 | 0) == 35) {
   L51 : do if (!i51) {
    f19 = Math_fround(f15 - f14);
    f18 = Math_fround(f11 - f7);
    f16 = Math_fround(f4 - f3);
    f17 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)) + Math_fround(f16 * f16));
    if (f17 > Math_fround(0.0)) {
     f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17))));
     f30 = Math_fround(f16 * f24);
     f28 = Math_fround(f18 * f24);
     f24 = Math_fround(f19 * f24);
    } else {
     f30 = Math_fround(0.0);
     f28 = Math_fround(0.0);
     f24 = Math_fround(0.0);
    }
    if (!i21) {
     i12 = i75 + 4 | 0;
     i13 = i75 + 8 | 0;
     i20 = i65 + 64 | 0;
     f23 = f22;
     i10 = 0;
     while (1) {
      f18 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) >> 2]);
      f92 = Math_fround(f18 * Math_fround(HEAPF32[i77 >> 2]));
      f16 = Math_fround(f18 * Math_fround(HEAPF32[i27 >> 2]));
      f18 = Math_fround(f18 * Math_fround(HEAPF32[i29 >> 2]));
      f22 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) + 4 >> 2]);
      f90 = Math_fround(f22 * Math_fround(HEAPF32[i40 >> 2]));
      f91 = Math_fround(f22 * Math_fround(HEAPF32[i41 >> 2]));
      f90 = Math_fround(f92 + f90);
      f91 = Math_fround(f16 + f91);
      f22 = Math_fround(f18 + Math_fround(f22 * Math_fround(HEAPF32[i43 >> 2])));
      f18 = Math_fround(HEAPF32[i26 + (i10 * 20 | 0) + 8 >> 2]);
      f16 = Math_fround(f18 * Math_fround(HEAPF32[i44 >> 2]));
      f92 = Math_fround(f18 * Math_fround(HEAPF32[i45 >> 2]));
      f16 = Math_fround(f90 + f16);
      f92 = Math_fround(f91 + f92);
      f18 = Math_fround(f22 + Math_fround(f18 * Math_fround(HEAPF32[i46 >> 2])));
      f22 = Math_fround(Math_fround(f28 * f18) - Math_fround(f30 * f92));
      f18 = Math_fround(Math_fround(f30 * f16) - Math_fround(f24 * f18));
      f16 = Math_fround(Math_fround(f24 * f92) - Math_fround(f28 * f16));
      HEAPF32[i75 >> 2] = f22;
      HEAPF32[i12 >> 2] = f18;
      HEAPF32[i13 >> 2] = f16;
      if (+Math_fround(Math_abs(Math_fround(f22))) > 1.0e-06) i49 = 43; else if (+Math_fround(Math_abs(Math_fround(f18))) > 1.0e-06) i49 = 43; else if (+Math_fround(Math_abs(Math_fround(f16))) > 1.0e-06) i49 = 43; else f16 = f23;
      if ((i49 | 0) == 43) {
       i49 = 0;
       f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(Math_fround(f22 * f22) + Math_fround(f18 * f18)));
       if (f17 > Math_fround(0.0)) {
        f92 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17))));
        f19 = Math_fround(f16 * f92);
        f17 = Math_fround(f18 * f92);
        f16 = Math_fround(f22 * f92);
       } else {
        f19 = Math_fround(0.0);
        f17 = Math_fround(0.0);
        f16 = Math_fround(0.0);
       }
       HEAPF32[i75 >> 2] = f16;
       HEAPF32[i12 >> 2] = f17;
       HEAPF32[i13 >> 2] = f19;
       f92 = Math_fround(Math_fround(Math_fround(f16 * f14) + Math_fround(f17 * f7)) + Math_fround(f19 * f3));
       i9 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
       f18 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f17 * f11)) + Math_fround(f19 * f4));
       i6 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
       i8 = f92 > f18;
       f18 = Math_fround(f33 + (HEAP32[tempDoublePtr >> 2] = i8 ? i9 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       mftCall_viiiiii(HEAP32[i20 >> 2] | 0, i65 | 0, i75 | 0, i77 | 0, i72 | 0, i63 | 0, i76 | 0);
       f19 = Math_fround(HEAPF32[i63 >> 2]);
       if (f18 < f19) break;
       f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8 ? i6 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f33);
       f17 = Math_fround(HEAPF32[i76 >> 2]);
       if (f17 < f16) break;
       f92 = Math_fround(f18 - f19);
       f16 = Math_fround(f17 - f16);
       f16 = f92 < f16 ? f92 : f16;
       if (f16 < f23) {
        i1 = HEAP32[i13 >> 2] | 0;
        i2 = HEAP32[i12 >> 2] | 0;
        i5 = HEAP32[i75 >> 2] | 0;
       } else f16 = f23;
      }
      i10 = i10 + 1 | 0;
      if (i10 >>> 0 >= i25 >>> 0) break L51; else f23 = f16;
     }
     break L49;
    }
   } while (0);
   f90 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
   f17 = Math_fround(Math_fround(f7 + f11) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f3 + f4) * Math_fround(.5));
   f87 = Math_fround(Math_fround(HEAPF32[i65 >> 2]) * Math_fround(2.0));
   f85 = Math_fround(Math_fround(HEAPF32[i65 + 4 >> 2]) * Math_fround(2.0));
   f82 = Math_fround(Math_fround(HEAPF32[i65 + 8 >> 2]) * Math_fround(2.0));
   f84 = Math_fround(HEAPF32[i58 >> 2]);
   f83 = Math_fround(Math_fround(f84 * f84) + Math_fround(-.5));
   f86 = Math_fround(HEAPF32[i59 >> 2]);
   f91 = Math_fround(f87 * f86);
   f88 = Math_fround(HEAPF32[i56 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f85 * f88));
   f89 = Math_fround(HEAPF32[i57 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f82 * f89));
   f18 = Math_fround(Math_fround(f86 * f91) + Math_fround(Math_fround(f87 * f83) + Math_fround(f84 * Math_fround(Math_fround(f82 * f88) - Math_fround(f85 * f89)))));
   f92 = Math_fround(Math_fround(f88 * f91) + Math_fround(Math_fround(f85 * f83) + Math_fround(f84 * Math_fround(Math_fround(f87 * f89) - Math_fround(f82 * f86)))));
   f91 = Math_fround(Math_fround(Math_fround(f82 * f83) + Math_fround(f84 * Math_fround(Math_fround(f85 * f86) - Math_fround(f87 * f88)))) + Math_fround(f89 * f91));
   f18 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) + f18);
   f92 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) + f92);
   f18 = Math_fround(f90 - f18);
   f92 = Math_fround(f17 - f92);
   f91 = Math_fround(f16 - Math_fround(Math_fround(HEAPF32[i62 >> 2]) + f91));
   f16 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = Math_fround(f16 * f18);
   f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f92 = Math_fround(f18 + Math_fround(f17 * f92));
   f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (Math_fround(Math_fround(f18 * f91) + f92) < Math_fround(0.0)) {
    f90 = Math_fround(-f16);
    f91 = Math_fround(-f17);
    f92 = Math_fround(-f18);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f91, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
   }
   HEAP32[i55 >> 2] = i5;
   i25 = i55 + 4 | 0;
   HEAP32[i25 >> 2] = i2;
   i26 = i55 + 8 | 0;
   HEAP32[i26 >> 2] = i1;
   f24 = Math_fround(HEAPF32[i64 >> 2]);
   __ZL22PxcGenerateVFContacts2RN5physx2Gu13ContactBufferERKNS_11PxTransformERKNS0_13PolygonalDataERKNS_11PxMeshScaleEjPKNS_6PxVec3EfRSD_f(i79, i59, i65, i52, i50, i53, f24, i55, Math_fround(HEAPF32[i54 >> 2]));
   i21 = i79 + 4096 | 0;
   f24 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i51 | (HEAP32[i21 >> 2] | 0) == 2) {
    i1 = 1;
    break L13;
   }
   f30 = Math_fround(HEAPF32[i64 >> 2]);
   f28 = Math_fround(HEAPF32[i54 >> 2]);
   i20 = __ZN5physx2Gu21findUniqueConvexEdgesEjPNS0_10ConvexEdgeEjPKNS0_15HullPolygonDataEPKh(512, i63, HEAP32[i47 >> 2] | 0, HEAP32[i48 >> 2] | 0, HEAP32[i65 + 32 >> 2] | 0) | 0;
   HEAPF32[i76 >> 2] = f14;
   i1 = i76 + 4 | 0;
   HEAPF32[i1 >> 2] = f7;
   i2 = i76 + 8 | 0;
   HEAPF32[i2 >> 2] = f3;
   HEAPF32[i77 >> 2] = f15;
   i5 = i77 + 4 | 0;
   HEAPF32[i5 >> 2] = f11;
   i6 = i77 + 8 | 0;
   HEAPF32[i6 >> 2] = f4;
   f16 = Math_fround(f15 - f14);
   f17 = Math_fround(f11 - f7);
   f18 = Math_fround(f4 - f3);
   f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
   if (f19 > Math_fround(0.0)) {
    f92 = Math_fround(Math_fround(.00999999977) / f19);
    f90 = Math_fround(f16 * f92);
    f91 = Math_fround(f17 * f92);
    f92 = Math_fround(f18 * f92);
    f14 = Math_fround(f14 - f90);
    HEAPF32[i76 >> 2] = f14;
    f7 = Math_fround(f7 - f91);
    HEAPF32[i1 >> 2] = f7;
    f3 = Math_fround(f3 - f92);
    HEAPF32[i2 >> 2] = f3;
    f15 = Math_fround(f15 + f90);
    HEAPF32[i77 >> 2] = f15;
    f11 = Math_fround(f11 + f91);
    HEAPF32[i5 >> 2] = f11;
    f4 = Math_fround(f4 + f92);
    HEAPF32[i6 >> 2] = f4;
   }
   f89 = Math_fround(f15 - f14);
   f90 = Math_fround(f11 - f7);
   f92 = Math_fround(f4 - f3);
   HEAPF32[i78 >> 2] = f89;
   HEAPF32[i78 + 4 >> 2] = f90;
   HEAPF32[i78 + 8 >> 2] = f92;
   f91 = Math_fround(Math_fround(f90 * f24) - Math_fround(f92 * f23));
   f92 = Math_fround(Math_fround(f92 * f22) - Math_fround(f24 * f89));
   f4 = Math_fround(Math_fround(f89 * f23) - Math_fround(f90 * f22));
   HEAPF32[i75 >> 2] = f91;
   HEAPF32[i75 + 4 >> 2] = f92;
   HEAPF32[i75 + 8 >> 2] = f4;
   HEAPF32[i75 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f3 * f4) + Math_fround(Math_fround(f14 * f91) + Math_fround(f7 * f92))));
   f3 = Math_fround(Math_abs(Math_fround(f91)));
   f92 = Math_fround(Math_abs(Math_fround(f92)));
   f4 = Math_fround(Math_abs(Math_fround(f4)));
   if (f92 > f3 & f92 > f4) {
    i12 = 2;
    i13 = 0;
   } else if (f4 > f3) {
    i12 = 0;
    i13 = 1;
   } else {
    i12 = 1;
    i13 = 2;
   }
   f92 = Math_fround(HEAPF32[i78 + (i12 << 2) >> 2]);
   f92 = Math_fround(f92 * Math_fround(HEAPF32[i55 + (i13 << 2) >> 2]));
   f7 = Math_fround(HEAPF32[i78 + (i13 << 2) >> 2]);
   f7 = Math_fround(Math_fround(1.0) / Math_fround(f92 - Math_fround(f7 * Math_fround(HEAPF32[i55 + (i12 << 2) >> 2]))));
   i8 = HEAP32[i65 + 28 >> 2] | 0;
   if (i20 | 0) {
    i9 = i72 + 12 | 0;
    i10 = i72 + 24 | 0;
    f3 = Math_fround(Math_fround(-f30) - f28);
    i1 = i74 + 8 | 0;
    i2 = i74 + 4 | 0;
    i6 = 0;
    do {
     i65 = HEAPU8[i63 + (i6 << 4) >> 0] | 0;
     f83 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) >> 2]);
     f32 = Math_fround(HEAPF32[i72 >> 2]);
     f81 = Math_fround(f83 * f32);
     f33 = Math_fround(HEAPF32[i66 >> 2]);
     f90 = Math_fround(f83 * f33);
     f37 = Math_fround(HEAPF32[i67 >> 2]);
     f83 = Math_fround(f83 * f37);
     f86 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) + 4 >> 2]);
     f35 = Math_fround(HEAPF32[i9 >> 2]);
     f87 = Math_fround(f86 * f35);
     f36 = Math_fround(HEAPF32[i68 >> 2]);
     f84 = Math_fround(f86 * f36);
     f85 = Math_fround(HEAPF32[i69 >> 2]);
     f87 = Math_fround(f81 + f87);
     f84 = Math_fround(f90 + f84);
     f86 = Math_fround(f83 + Math_fround(f86 * f85));
     f83 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) + 8 >> 2]);
     f90 = Math_fround(HEAPF32[i10 >> 2]);
     f81 = Math_fround(f83 * f90);
     f88 = Math_fround(HEAPF32[i70 >> 2]);
     f82 = Math_fround(f83 * f88);
     f92 = Math_fround(HEAPF32[i71 >> 2]);
     f81 = Math_fround(Math_fround(f87 + f81) * Math_fround(2.0));
     f82 = Math_fround(Math_fround(f84 + f82) * Math_fround(2.0));
     f83 = Math_fround(Math_fround(f86 + Math_fround(f83 * f92)) * Math_fround(2.0));
     f86 = Math_fround(HEAPF32[i58 >> 2]);
     f84 = Math_fround(Math_fround(f86 * f86) + Math_fround(-.5));
     f87 = Math_fround(HEAPF32[i59 >> 2]);
     f42 = Math_fround(f81 * f87);
     f89 = Math_fround(HEAPF32[i56 >> 2]);
     f42 = Math_fround(f42 + Math_fround(f82 * f89));
     f91 = Math_fround(HEAPF32[i57 >> 2]);
     f42 = Math_fround(f42 + Math_fround(f83 * f91));
     f38 = Math_fround(Math_fround(f87 * f42) + Math_fround(Math_fround(f81 * f84) + Math_fround(f86 * Math_fround(Math_fround(f83 * f89) - Math_fround(f82 * f91)))));
     f39 = Math_fround(Math_fround(f89 * f42) + Math_fround(Math_fround(f82 * f84) + Math_fround(f86 * Math_fround(Math_fround(f81 * f91) - Math_fround(f87 * f83)))));
     f42 = Math_fround(Math_fround(Math_fround(f83 * f84) + Math_fround(f86 * Math_fround(Math_fround(f82 * f87) - Math_fround(f81 * f89)))) + Math_fround(f91 * f42));
     f81 = Math_fround(HEAPF32[i60 >> 2]);
     f38 = Math_fround(f81 + f38);
     f82 = Math_fround(HEAPF32[i61 >> 2]);
     f39 = Math_fround(f82 + f39);
     f83 = Math_fround(HEAPF32[i62 >> 2]);
     f42 = Math_fround(f83 + f42);
     i65 = HEAPU8[i63 + (i6 << 4) + 1 >> 0] | 0;
     f34 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) >> 2]);
     f32 = Math_fround(f32 * f34);
     f33 = Math_fround(f33 * f34);
     f34 = Math_fround(f37 * f34);
     f37 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) + 4 >> 2]);
     f35 = Math_fround(f32 + Math_fround(f35 * f37));
     f36 = Math_fround(f33 + Math_fround(f36 * f37));
     f37 = Math_fround(f34 + Math_fround(f85 * f37));
     f85 = Math_fround(HEAPF32[i8 + (i65 * 12 | 0) + 8 >> 2]);
     f90 = Math_fround(Math_fround(f35 + Math_fround(f90 * f85)) * Math_fround(2.0));
     f88 = Math_fround(Math_fround(f36 + Math_fround(f88 * f85)) * Math_fround(2.0));
     f85 = Math_fround(Math_fround(f37 + Math_fround(f92 * f85)) * Math_fround(2.0));
     f92 = Math_fround(Math_fround(f91 * f85) + Math_fround(Math_fround(f87 * f90) + Math_fround(f89 * f88)));
     if (__ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_f(i76, i77, i78, i75, i12, i13, f7, i55, f38, f39, f42, Math_fround(f81 + Math_fround(Math_fround(f87 * f92) + Math_fround(Math_fround(f84 * f90) + Math_fround(f86 * Math_fround(Math_fround(f89 * f85) - Math_fround(f91 * f88)))))), Math_fround(f82 + Math_fround(Math_fround(f89 * f92) + Math_fround(Math_fround(f84 * f88) + Math_fround(f86 * Math_fround(Math_fround(f91 * f90) - Math_fround(f87 * f85)))))), Math_fround(f83 + Math_fround(Math_fround(Math_fround(f84 * f85) + Math_fround(f86 * Math_fround(Math_fround(f87 * f88) - Math_fround(f89 * f90)))) + Math_fround(f91 * f92))), i73, i74, f3) | 0) {
      f4 = Math_fround(HEAPF32[i73 >> 2]);
      i5 = HEAP32[i21 >> 2] | 0;
      if (i5 >>> 0 <= 63) {
       f92 = Math_fround(-Math_fround(f30 + f4));
       f91 = Math_fround(HEAPF32[i1 >> 2]);
       f88 = Math_fround(HEAPF32[i26 >> 2]);
       f91 = Math_fround(f91 - Math_fround(f4 * f88));
       f90 = Math_fround(HEAPF32[i2 >> 2]);
       f87 = Math_fround(HEAPF32[i25 >> 2]);
       f90 = Math_fround(f90 - Math_fround(f4 * f87));
       f89 = Math_fround(HEAPF32[i74 >> 2]);
       f86 = Math_fround(HEAPF32[i55 >> 2]);
       f89 = Math_fround(f89 - Math_fround(f4 * f86));
       HEAP32[i21 >> 2] = i5 + 1;
       HEAPF32[i79 + (i5 << 6) >> 2] = f86;
       HEAPF32[i79 + (i5 << 6) + 4 >> 2] = f87;
       HEAPF32[i79 + (i5 << 6) + 8 >> 2] = f88;
       HEAPF32[i79 + (i5 << 6) + 16 >> 2] = f89;
       HEAPF32[i79 + (i5 << 6) + 20 >> 2] = f90;
       HEAPF32[i79 + (i5 << 6) + 24 >> 2] = f91;
       HEAPF32[i79 + (i5 << 6) + 12 >> 2] = f92;
       HEAP32[i79 + (i5 << 6) + 48 >> 2] = -1;
       HEAP32[i79 + (i5 << 6) + 52 >> 2] = -1;
      }
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i20 | 0));
   }
   i1 = 1;
   break L13;
  } while (0);
  i1 = 0;
 } while (0);
 i79 = i1;
 STACKTOP = i80;
 return i79 | 0;
}

function __ZL18PxcContactHullHullRKN5physx2Gu13PolygonalDataES3_RKNS_9PxBounds3ES6_RKNS_11PxTransformES9_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESF_bb(i169, i170, i161, i162, i179, i180, f155, i154, i173, i174, i165, i166) {
 i169 = i169 | 0;
 i170 = i170 | 0;
 i161 = i161 | 0;
 i162 = i162 | 0;
 i179 = i179 | 0;
 i180 = i180 | 0;
 f155 = Math_fround(f155);
 i154 = i154 | 0;
 i173 = i173 | 0;
 i174 = i174 | 0;
 i165 = i165 | 0;
 i166 = i166 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i163 = 0, i164 = 0, i167 = 0, i168 = 0, i171 = 0, i172 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, f190 = f0, f191 = f0, f192 = f0, f193 = f0, f194 = f0, f195 = f0;
 i189 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i159 = i189 + 544 | 0;
 i160 = i189 + 496 | 0;
 i181 = i189 + 448 | 0;
 i182 = i189 + 412 | 0;
 i119 = i189 + 376 | 0;
 i183 = i189 + 312 | 0;
 i184 = i189 + 248 | 0;
 i157 = i189 + 364 | 0;
 i158 = i189 + 360 | 0;
 i185 = i189 + 296 | 0;
 i167 = i189 + 200 | 0;
 i168 = i189 + 152 | 0;
 i153 = i189 + 148 | 0;
 i163 = i189 + 144 | 0;
 i164 = i189 + 140 | 0;
 i120 = i189 + 128 | 0;
 i125 = i189 + 116 | 0;
 i127 = i189 + 104 | 0;
 i133 = i189 + 92 | 0;
 i186 = i189 + 80 | 0;
 i175 = i189 + 64 | 0;
 i187 = i189 + 48 | 0;
 i176 = i189 + 32 | 0;
 i156 = i189 + 16 | 0;
 i171 = i189 + 12 | 0;
 i177 = i189 + 8 | 0;
 i172 = i189 + 4 | 0;
 i178 = i189;
 i138 = i183 + 36 | 0;
 f16 = Math_fround(HEAPF32[i179 >> 2]);
 f24 = Math_fround(f16 + f16);
 i144 = i179 + 4 | 0;
 f20 = Math_fround(HEAPF32[i144 >> 2]);
 f22 = Math_fround(f20 + f20);
 i121 = i179 + 8 | 0;
 f17 = Math_fround(HEAPF32[i121 >> 2]);
 f15 = Math_fround(f17 + f17);
 i122 = i179 + 12 | 0;
 f19 = Math_fround(HEAPF32[i122 >> 2]);
 f23 = Math_fround(f24 * f19);
 f12 = Math_fround(f22 * f19);
 f19 = Math_fround(f19 * f15);
 f24 = Math_fround(f16 * f24);
 f21 = Math_fround(f16 * f22);
 f16 = Math_fround(f16 * f15);
 f22 = Math_fround(f20 * f22);
 f20 = Math_fround(f20 * f15);
 f15 = Math_fround(f17 * f15);
 HEAPF32[i183 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f22) - f15);
 i126 = i183 + 4 | 0;
 HEAPF32[i126 >> 2] = Math_fround(f21 + f19);
 i128 = i183 + 8 | 0;
 HEAPF32[i128 >> 2] = Math_fround(f16 - f12);
 i129 = i183 + 12 | 0;
 HEAPF32[i129 >> 2] = Math_fround(f21 - f19);
 f24 = Math_fround(Math_fround(1.0) - f24);
 i130 = i183 + 16 | 0;
 HEAPF32[i130 >> 2] = Math_fround(f24 - f15);
 i131 = i183 + 20 | 0;
 HEAPF32[i131 >> 2] = Math_fround(f20 + f23);
 i132 = i183 + 24 | 0;
 HEAPF32[i132 >> 2] = Math_fround(f16 + f12);
 i134 = i183 + 28 | 0;
 HEAPF32[i134 >> 2] = Math_fround(f20 - f23);
 i135 = i183 + 32 | 0;
 HEAPF32[i135 >> 2] = Math_fround(f24 - f22);
 i136 = i183 + 40 | 0;
 i137 = i183 + 44 | 0;
 HEAP32[i138 >> 2] = HEAP32[i179 + 16 >> 2];
 i6 = i179 + 20 | 0;
 HEAP32[i136 >> 2] = HEAP32[i6 >> 2];
 i7 = i179 + 24 | 0;
 HEAP32[i137 >> 2] = HEAP32[i7 >> 2];
 f22 = Math_fround(HEAPF32[i180 >> 2]);
 f24 = Math_fround(f22 + f22);
 i139 = i180 + 4 | 0;
 f23 = Math_fround(HEAPF32[i139 >> 2]);
 f20 = Math_fround(f23 + f23);
 i140 = i180 + 8 | 0;
 f12 = Math_fround(HEAPF32[i140 >> 2]);
 f16 = Math_fround(f12 + f12);
 i141 = i180 + 12 | 0;
 f15 = Math_fround(HEAPF32[i141 >> 2]);
 f19 = Math_fround(f24 * f15);
 f21 = Math_fround(f20 * f15);
 f15 = Math_fround(f15 * f16);
 f24 = Math_fround(f22 * f24);
 f17 = Math_fround(f22 * f20);
 f22 = Math_fround(f22 * f16);
 f20 = Math_fround(f23 * f20);
 f23 = Math_fround(f23 * f16);
 f16 = Math_fround(f12 * f16);
 f12 = Math_fround(Math_fround(Math_fround(1.0) - f20) - f16);
 HEAPF32[i184 >> 2] = f12;
 f13 = Math_fround(f17 + f15);
 i142 = i184 + 4 | 0;
 HEAPF32[i142 >> 2] = f13;
 f14 = Math_fround(f22 - f21);
 i143 = i184 + 8 | 0;
 HEAPF32[i143 >> 2] = f14;
 f15 = Math_fround(f17 - f15);
 i145 = i184 + 12 | 0;
 HEAPF32[i145 >> 2] = f15;
 f24 = Math_fround(Math_fround(1.0) - f24);
 f16 = Math_fround(f24 - f16);
 i146 = i184 + 16 | 0;
 HEAPF32[i146 >> 2] = f16;
 f17 = Math_fround(f23 + f19);
 i147 = i184 + 20 | 0;
 HEAPF32[i147 >> 2] = f17;
 f21 = Math_fround(f22 + f21);
 i148 = i184 + 24 | 0;
 HEAPF32[i148 >> 2] = f21;
 f19 = Math_fround(f23 - f19);
 i149 = i184 + 28 | 0;
 HEAPF32[i149 >> 2] = f19;
 f20 = Math_fround(f24 - f20);
 i150 = i184 + 32 | 0;
 HEAPF32[i150 >> 2] = f20;
 i1 = HEAP32[i180 + 16 >> 2] | 0;
 HEAP32[i184 + 36 >> 2] = i1;
 i151 = i180 + 20 | 0;
 i124 = HEAP32[i151 >> 2] | 0;
 HEAP32[i184 + 40 >> 2] = i124;
 i152 = i180 + 24 | 0;
 i123 = HEAP32[i152 >> 2] | 0;
 HEAP32[i184 + 44 >> 2] = i123;
 f24 = Math_fround(HEAPF32[i169 >> 2]);
 f23 = Math_fround(f24 * Math_fround(HEAPF32[i183 >> 2]));
 f22 = Math_fround(f24 * Math_fround(HEAPF32[i126 >> 2]));
 f24 = Math_fround(f24 * Math_fround(HEAPF32[i128 >> 2]));
 f18 = Math_fround(HEAPF32[i169 + 4 >> 2]);
 f10 = Math_fround(f18 * Math_fround(HEAPF32[i129 >> 2]));
 f11 = Math_fround(f18 * Math_fround(HEAPF32[i130 >> 2]));
 f10 = Math_fround(f23 + f10);
 f11 = Math_fround(f22 + f11);
 f18 = Math_fround(f24 + Math_fround(f18 * Math_fround(HEAPF32[i131 >> 2])));
 f24 = Math_fround(HEAPF32[i169 + 8 >> 2]);
 f22 = Math_fround(f24 * Math_fround(HEAPF32[i132 >> 2]));
 f23 = Math_fround(f24 * Math_fround(HEAPF32[i134 >> 2]));
 f22 = Math_fround(f10 + f22);
 f23 = Math_fround(f11 + f23);
 f24 = Math_fround(f18 + Math_fround(f24 * Math_fround(HEAPF32[i135 >> 2])));
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i183 + 36 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i136 >> 2]));
 f24 = Math_fround(f24 + Math_fround(HEAPF32[i137 >> 2]));
 f18 = Math_fround(HEAPF32[i170 >> 2]);
 f12 = Math_fround(f18 * f12);
 f13 = Math_fround(f18 * f13);
 f14 = Math_fround(f18 * f14);
 f18 = Math_fround(HEAPF32[i170 + 4 >> 2]);
 f15 = Math_fround(f12 + Math_fround(f18 * f15));
 f16 = Math_fround(f13 + Math_fround(f18 * f16));
 f17 = Math_fround(f14 + Math_fround(f18 * f17));
 f18 = Math_fround(HEAPF32[i170 + 8 >> 2]);
 f21 = Math_fround(f15 + Math_fround(f18 * f21));
 f19 = Math_fround(f16 + Math_fround(f18 * f19));
 f20 = Math_fround(f17 + Math_fround(f18 * f20));
 f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i124, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f23 = Math_fround(f19 - f23);
 f24 = Math_fround(Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i123, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f24);
 HEAPF32[i157 >> 2] = Math_fround(f21 - f22);
 i123 = i157 + 4 | 0;
 HEAPF32[i123 >> 2] = f23;
 i124 = i157 + 8 | 0;
 HEAPF32[i124 >> 2] = f24;
 i1 = HEAP32[i169 + 60 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, HEAP32[i169 + 12 >> 2] | 0, HEAP32[i169 + 28 >> 2] | 0);
 i1 = HEAP32[i170 + 60 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, HEAP32[i170 + 12 >> 2] | 0, HEAP32[i170 + 28 >> 2] | 0);
 mftCall_viiiiii(HEAP32[i169 + 64 >> 2] | 0, i169 | 0, i157 | 0, i183 | 0, i173 | 0, i181 | 0, i182 | 0);
 f2 = Math_fround(HEAPF32[i181 >> 2]);
 f3 = Math_fround(HEAPF32[i182 >> 2]);
 mftCall_viiiiii(HEAP32[i170 + 64 >> 2] | 0, i170 | 0, i157 | 0, i184 | 0, i174 | 0, i159 | 0, i160 | 0);
 f24 = Math_fround(f3 + f155);
 f4 = Math_fround(HEAPF32[i159 >> 2]);
 if (!(f24 < f4)) {
  f5 = Math_fround(HEAPF32[i160 >> 2]);
  if (!(Math_fround(f5 + f155) < f2)) {
   f194 = Math_fround(f3 - f4);
   f10 = Math_fround(f5 - f2);
   HEAPF32[i158 >> 2] = f194 < f10 ? f194 : f10;
   f10 = Math_fround(HEAPF32[i180 >> 2]);
   f194 = Math_fround(-f10);
   f4 = Math_fround(HEAPF32[i139 >> 2]);
   f23 = Math_fround(-f4);
   f17 = Math_fround(HEAPF32[i140 >> 2]);
   f3 = Math_fround(-f17);
   f12 = Math_fround(HEAPF32[i141 >> 2]);
   f16 = Math_fround(HEAPF32[i179 + 16 >> 2]);
   i118 = i180 + 16 | 0;
   f22 = Math_fround(HEAPF32[i118 >> 2]);
   f13 = Math_fround(f16 - f22);
   f18 = Math_fround(HEAPF32[i6 >> 2]);
   f24 = Math_fround(HEAPF32[i151 >> 2]);
   f5 = Math_fround(f18 - f24);
   f193 = Math_fround(HEAPF32[i7 >> 2]);
   f192 = Math_fround(HEAPF32[i152 >> 2]);
   f13 = Math_fround(f13 * Math_fround(2.0));
   f5 = Math_fround(f5 * Math_fround(2.0));
   f191 = Math_fround(Math_fround(f193 - f192) * Math_fround(2.0));
   f14 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
   f20 = Math_fround(Math_fround(Math_fround(f13 * f194) + Math_fround(f5 * f23)) + Math_fround(f191 * f3));
   f15 = Math_fround(Math_fround(f20 * f194) + Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f191 * f23) - Math_fround(f5 * f3)))));
   f21 = Math_fround(Math_fround(f20 * f23) + Math_fround(Math_fround(f14 * f5) + Math_fround(f12 * Math_fround(Math_fround(f13 * f3) - Math_fround(f191 * f194)))));
   f20 = Math_fround(Math_fround(Math_fround(f14 * f191) + Math_fround(f12 * Math_fround(Math_fround(f5 * f194) - Math_fround(f13 * f23)))) + Math_fround(f20 * f3));
   f13 = Math_fround(HEAPF32[i179 >> 2]);
   f5 = Math_fround(f12 * f13);
   f191 = Math_fround(HEAPF32[i122 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f191 * f194));
   f14 = Math_fround(HEAPF32[i121 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f14 * f23));
   f19 = Math_fround(HEAPF32[i144 >> 2]);
   f5 = Math_fround(f5 - Math_fround(f19 * f3));
   f11 = Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(Math_fround(f191 * f23) + Math_fround(f12 * f19))) - Math_fround(f14 * f194));
   f190 = Math_fround(Math_fround(Math_fround(f19 * f194) + Math_fround(Math_fround(f191 * f3) + Math_fround(f12 * f14))) - Math_fround(f13 * f23));
   f2 = Math_fround(f12 * f191);
   f3 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f13 * f194)) - Math_fround(f19 * f23)) - Math_fround(f14 * f3));
   f13 = Math_fround(-f13);
   f19 = Math_fround(-f19);
   f14 = Math_fround(-f14);
   f16 = Math_fround(Math_fround(f22 - f16) * Math_fround(2.0));
   f18 = Math_fround(Math_fround(f24 - f18) * Math_fround(2.0));
   f193 = Math_fround(Math_fround(f192 - f193) * Math_fround(2.0));
   f192 = Math_fround(Math_fround(f191 * f191) + Math_fround(-.5));
   f24 = Math_fround(Math_fround(f193 * f14) + Math_fround(Math_fround(f16 * f13) + Math_fround(f18 * f19)));
   f22 = Math_fround(Math_fround(f24 * f13) + Math_fround(Math_fround(f16 * f192) + Math_fround(f191 * Math_fround(Math_fround(f193 * f19) - Math_fround(f18 * f14)))));
   f23 = Math_fround(Math_fround(Math_fround(f18 * f192) + Math_fround(f191 * Math_fround(Math_fround(f16 * f14) - Math_fround(f193 * f13)))) + Math_fround(f24 * f19));
   f24 = Math_fround(Math_fround(Math_fround(f193 * f192) + Math_fround(f191 * Math_fround(Math_fround(f18 * f13) - Math_fround(f16 * f19)))) + Math_fround(f24 * f14));
   f16 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f10 * f191)) + Math_fround(f17 * f19)) - Math_fround(f4 * f14));
   f18 = Math_fround(Math_fround(Math_fround(f10 * f14) + Math_fround(Math_fround(f4 * f191) + Math_fround(f12 * f19))) - Math_fround(f17 * f13));
   f12 = Math_fround(Math_fround(Math_fround(f4 * f13) + Math_fround(Math_fround(f17 * f191) + Math_fround(f12 * f14))) - Math_fround(f10 * f19));
   f14 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f10 * f13)) - Math_fround(f4 * f19)) - Math_fround(f17 * f14));
   f17 = Math_fround(f5 + f5);
   f19 = Math_fround(f11 + f11);
   f4 = Math_fround(f190 + f190);
   f13 = Math_fround(f17 * f3);
   f10 = Math_fround(f3 * f19);
   f3 = Math_fround(f3 * f4);
   f17 = Math_fround(f5 * f17);
   f2 = Math_fround(f5 * f19);
   f5 = Math_fround(f5 * f4);
   f19 = Math_fround(f11 * f19);
   f11 = Math_fround(f11 * f4);
   f4 = Math_fround(f190 * f4);
   HEAPF32[i167 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f19) - f4);
   HEAPF32[i167 + 4 >> 2] = Math_fround(f3 + f2);
   HEAPF32[i167 + 8 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i167 + 12 >> 2] = Math_fround(f2 - f3);
   f17 = Math_fround(Math_fround(1.0) - f17);
   HEAPF32[i167 + 16 >> 2] = Math_fround(f17 - f4);
   HEAPF32[i167 + 20 >> 2] = Math_fround(f13 + f11);
   HEAPF32[i167 + 24 >> 2] = Math_fround(f5 + f10);
   HEAPF32[i167 + 28 >> 2] = Math_fround(f11 - f13);
   HEAPF32[i167 + 32 >> 2] = Math_fround(f17 - f19);
   HEAPF32[i167 + 36 >> 2] = f15;
   HEAPF32[i167 + 40 >> 2] = f21;
   HEAPF32[i167 + 44 >> 2] = f20;
   f20 = Math_fround(f16 + f16);
   f21 = Math_fround(f18 + f18);
   f15 = Math_fround(f12 + f12);
   f19 = Math_fround(f14 * f20);
   f17 = Math_fround(f14 * f21);
   f14 = Math_fround(f14 * f15);
   f20 = Math_fround(f16 * f20);
   f13 = Math_fround(f16 * f21);
   f16 = Math_fround(f16 * f15);
   f21 = Math_fround(f18 * f21);
   f18 = Math_fround(f18 * f15);
   f15 = Math_fround(f12 * f15);
   HEAPF32[i168 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f21) - f15);
   HEAPF32[i168 + 4 >> 2] = Math_fround(f14 + f13);
   HEAPF32[i168 + 8 >> 2] = Math_fround(f16 - f17);
   HEAPF32[i168 + 12 >> 2] = Math_fround(f13 - f14);
   f20 = Math_fround(Math_fround(1.0) - f20);
   HEAPF32[i168 + 16 >> 2] = Math_fround(f20 - f15);
   HEAPF32[i168 + 20 >> 2] = Math_fround(f18 + f19);
   HEAPF32[i168 + 24 >> 2] = Math_fround(f16 + f17);
   HEAPF32[i168 + 28 >> 2] = Math_fround(f18 - f19);
   HEAPF32[i168 + 32 >> 2] = Math_fround(f20 - f21);
   HEAPF32[i168 + 36 >> 2] = f22;
   HEAPF32[i168 + 40 >> 2] = f23;
   HEAPF32[i168 + 44 >> 2] = f24;
   i29 = i185 + 4 | 0;
   i30 = i185 + 8 | 0;
   i31 = i169 + 24 | 0;
   i32 = i170 + 24 | 0;
   i33 = i175 + 4 | 0;
   i34 = i175 + 8 | 0;
   i35 = i175 + 12 | 0;
   i36 = i186 + 4 | 0;
   i37 = i186 + 8 | 0;
   i38 = i176 + 4 | 0;
   i39 = i176 + 8 | 0;
   i40 = i176 + 12 | 0;
   i41 = i187 + 4 | 0;
   i42 = i187 + 8 | 0;
   i43 = i154 + 4100 | 0;
   i44 = i156 + 4 | 0;
   i45 = i156 + 8 | 0;
   i46 = i159 + 4 | 0;
   i47 = i159 + 8 | 0;
   i48 = i159 + 16 | 0;
   i49 = i159 + 20 | 0;
   i50 = i159 + 28 | 0;
   i51 = i159 + 32 | 0;
   i52 = i159 + 36 | 0;
   i53 = i159 + 40 | 0;
   i54 = i159 + 44 | 0;
   i55 = i160 + 4 | 0;
   i56 = i160 + 8 | 0;
   i57 = i160 + 12 | 0;
   i58 = i160 + 16 | 0;
   i59 = i160 + 20 | 0;
   i60 = i160 + 24 | 0;
   i61 = i160 + 28 | 0;
   i62 = i160 + 32 | 0;
   i63 = i160 + 36 | 0;
   i64 = i160 + 40 | 0;
   i65 = i160 + 44 | 0;
   i66 = i181 + 4 | 0;
   i67 = i181 + 8 | 0;
   i68 = i181 + 12 | 0;
   i69 = i181 + 16 | 0;
   i70 = i181 + 20 | 0;
   i71 = i181 + 24 | 0;
   i72 = i181 + 28 | 0;
   i73 = i181 + 32 | 0;
   i74 = i181 + 36 | 0;
   i75 = i181 + 40 | 0;
   i76 = i181 + 44 | 0;
   i77 = i169 + 28 | 0;
   i78 = i169 + 32 | 0;
   i79 = i170 + 28 | 0;
   i80 = i170 + 32 | 0;
   i81 = i174 + 36 | 0;
   i82 = i174 + 40 | 0;
   i83 = i174 + 44 | 0;
   i84 = i174 + 48 | 0;
   i85 = i174 + 52 | 0;
   i86 = i174 + 56 | 0;
   i87 = i174 + 60 | 0;
   i88 = i174 + 64 | 0;
   i89 = i174 + 68 | 0;
   i90 = i173 + 36 | 0;
   i91 = i173 + 40 | 0;
   i92 = i173 + 44 | 0;
   i93 = i173 + 48 | 0;
   i94 = i173 + 52 | 0;
   i95 = i173 + 56 | 0;
   i96 = i173 + 60 | 0;
   i97 = i173 + 64 | 0;
   i98 = i173 + 68 | 0;
   i99 = i170 + 68 | 0;
   i100 = i120 + 4 | 0;
   i101 = i120 + 8 | 0;
   i102 = i169 + 68 | 0;
   i103 = i125 + 4 | 0;
   i104 = i125 + 8 | 0;
   i105 = i127 + 4 | 0;
   i106 = i127 + 8 | 0;
   i107 = i133 + 4 | 0;
   i108 = i133 + 8 | 0;
   i109 = i119 + 4 | 0;
   i110 = i119 + 8 | 0;
   i111 = i181 + 4 | 0;
   i112 = i181 + 8 | 0;
   i113 = i182 + 4 | 0;
   i114 = i182 + 8 | 0;
   i115 = i159 + 12 | 0;
   i116 = i159 + 24 | 0;
   i117 = 1;
   i8 = 32767;
   i9 = 32767;
   while (1) {
    if (!i117) {
     if (!(__ZL28PxcBruteForceOverlapBackfaceRKN5physx9PxBounds3ES2_RKNS_2Gu13PolygonalDataES6_RKNS_2Cm8Matrix34ESA_RKNS7_23FastVertex2ShapeScalingESD_SA_SA_RKNS_6PxVec3ERjSH_RfRSE_RNS3_14PxcSepAxisTypeEf(i161, i162, i169, i170, i183, i184, i173, i174, i167, i168, i157, i163, i164, i158, i185, i153, f155) | 0)) {
      i1 = 0;
      break;
     }
     f2 = Math_fround(HEAPF32[i185 >> 2]);
     f3 = Math_fround(HEAPF32[i29 >> 2]);
     f4 = Math_fround(HEAPF32[i30 >> 2]);
    } else {
     HEAPF32[i159 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i160 >> 2] = Math_fround(3402823469999999843913219.0e14);
     f192 = Math_fround(HEAPF32[i183 >> 2]);
     f24 = Math_fround(HEAPF32[i157 >> 2]);
     f192 = Math_fround(f192 * f24);
     f193 = Math_fround(HEAPF32[i126 >> 2]);
     f190 = Math_fround(HEAPF32[i123 >> 2]);
     f193 = Math_fround(f192 + Math_fround(f193 * f190));
     f192 = Math_fround(HEAPF32[i128 >> 2]);
     f191 = Math_fround(HEAPF32[i124 >> 2]);
     f192 = Math_fround(f193 + Math_fround(f192 * f191));
     f193 = Math_fround(f24 * Math_fround(HEAPF32[i129 >> 2]));
     f193 = Math_fround(f193 + Math_fround(f190 * Math_fround(HEAPF32[i130 >> 2])));
     f193 = Math_fround(f193 + Math_fround(f191 * Math_fround(HEAPF32[i131 >> 2])));
     f194 = Math_fround(f24 * Math_fround(HEAPF32[i132 >> 2]));
     f194 = Math_fround(f194 + Math_fround(f190 * Math_fround(HEAPF32[i134 >> 2])));
     f194 = Math_fround(f194 + Math_fround(f191 * Math_fround(HEAPF32[i135 >> 2])));
     f190 = Math_fround(-f190);
     f191 = Math_fround(-f191);
     HEAPF32[i119 >> 2] = Math_fround(-f24);
     HEAPF32[i109 >> 2] = f190;
     HEAPF32[i110 >> 2] = f191;
     if (!(__ZL36PxcTestFacesSepAxesBackfaceRoughPassRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ESD_RfRSB_RjfSD_(i169, i170, i183, i184, i173, i174, i168, f192, f193, f194, i159, i181, i163, f155, i119) | 0)) {
      i188 = 15;
      break;
     }
     f191 = Math_fround(HEAPF32[i184 >> 2]);
     f190 = Math_fround(HEAPF32[i157 >> 2]);
     f191 = Math_fround(f191 * f190);
     f192 = Math_fround(HEAPF32[i142 >> 2]);
     f193 = Math_fround(HEAPF32[i123 >> 2]);
     f192 = Math_fround(f191 + Math_fround(f192 * f193));
     f191 = Math_fround(HEAPF32[i143 >> 2]);
     f194 = Math_fround(HEAPF32[i124 >> 2]);
     f191 = Math_fround(f192 + Math_fround(f191 * f194));
     f192 = Math_fround(f190 * Math_fround(HEAPF32[i145 >> 2]));
     f192 = Math_fround(f192 + Math_fround(f193 * Math_fround(HEAPF32[i146 >> 2])));
     f192 = Math_fround(f192 + Math_fround(f194 * Math_fround(HEAPF32[i147 >> 2])));
     f190 = Math_fround(f190 * Math_fround(HEAPF32[i148 >> 2]));
     f193 = Math_fround(f190 + Math_fround(f193 * Math_fround(HEAPF32[i149 >> 2])));
     if (!(__ZL36PxcTestFacesSepAxesBackfaceRoughPassRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ESD_RfRSB_RjfSD_(i170, i169, i184, i183, i174, i173, i167, Math_fround(-f191), Math_fround(-f192), Math_fround(-Math_fround(f193 + Math_fround(f194 * Math_fround(HEAPF32[i150 >> 2])))), i160, i182, i164, f155, i157) | 0)) {
      i188 = 15;
      break;
     }
     f2 = Math_fround(HEAPF32[i159 >> 2]);
     i1 = HEAP32[i181 >> 2] | 0;
     i6 = HEAP32[i111 >> 2] | 0;
     i7 = HEAP32[i112 >> 2] | 0;
     HEAP32[i153 >> 2] = 0;
     f3 = Math_fround(HEAPF32[i160 >> 2]);
     if (f3 < f2) {
      i1 = HEAP32[i182 >> 2] | 0;
      i6 = HEAP32[i113 >> 2] | 0;
      i7 = HEAP32[i114 >> 2] | 0;
      HEAP32[i153 >> 2] = 1;
      f2 = f3;
     }
     HEAPF32[i158 >> 2] = f2;
     HEAP32[i185 >> 2] = i1;
     HEAP32[i29 >> 2] = i6;
     HEAP32[i30 >> 2] = i7;
     f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    }
    f194 = Math_fround(Math_fround(HEAPF32[i157 >> 2]) * f2);
    f194 = Math_fround(f194 + Math_fround(Math_fround(HEAPF32[i123 >> 2]) * f3));
    if (Math_fround(f194 + Math_fround(Math_fround(HEAPF32[i124 >> 2]) * f4)) < Math_fround(0.0)) {
     f2 = Math_fround(-f2);
     f3 = Math_fround(-f3);
     f4 = Math_fround(-f4);
     HEAPF32[i185 >> 2] = f2;
     HEAPF32[i29 >> 2] = f3;
     HEAPF32[i30 >> 2] = f4;
    }
    switch (HEAP32[i153 >> 2] | 0) {
    case 0:
     {
      i27 = HEAP32[i163 >> 2] | 0;
      i28 = HEAP32[i99 >> 2] | 0;
      f190 = Math_fround(-f2);
      f191 = Math_fround(-f3);
      f194 = Math_fround(-f4);
      f192 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i184 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i142 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i143 >> 2]) * f194));
      f193 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i145 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i146 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i147 >> 2]) * f194));
      f194 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i148 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i149 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i150 >> 2]) * f194));
      HEAPF32[i120 >> 2] = f192;
      HEAPF32[i100 >> 2] = f193;
      HEAPF32[i101 >> 2] = f194;
      i28 = mftCall_iiii(i28 | 0, i170 | 0, i174 | 0, i120 | 0) | 0;
      break;
     }
    case 1:
     {
      i27 = HEAP32[i102 >> 2] | 0;
      f192 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i183 >> 2]) * f2) + Math_fround(Math_fround(HEAPF32[i126 >> 2]) * f3)) + Math_fround(Math_fround(HEAPF32[i128 >> 2]) * f4));
      f193 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAPF32[i129 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i130 >> 2]))) + Math_fround(f4 * Math_fround(HEAPF32[i131 >> 2])));
      f194 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAPF32[i132 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i134 >> 2]))) + Math_fround(f4 * Math_fround(HEAPF32[i135 >> 2])));
      HEAPF32[i125 >> 2] = f192;
      HEAPF32[i103 >> 2] = f193;
      HEAPF32[i104 >> 2] = f194;
      i27 = mftCall_iiii(i27 | 0, i169 | 0, i173 | 0, i125 | 0) | 0;
      i28 = HEAP32[i164 >> 2] | 0;
      break;
     }
    case 2:
     {
      i27 = HEAP32[i102 >> 2] | 0;
      f194 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i183 >> 2]) * f2) + Math_fround(Math_fround(HEAPF32[i126 >> 2]) * f3)) + Math_fround(Math_fround(HEAPF32[i128 >> 2]) * f4));
      f191 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAPF32[i129 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i130 >> 2]))) + Math_fround(f4 * Math_fround(HEAPF32[i131 >> 2])));
      f190 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAPF32[i132 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i134 >> 2]))) + Math_fround(f4 * Math_fround(HEAPF32[i135 >> 2])));
      HEAPF32[i127 >> 2] = f194;
      HEAPF32[i105 >> 2] = f191;
      HEAPF32[i106 >> 2] = f190;
      i27 = mftCall_iiii(i27 | 0, i169 | 0, i173 | 0, i127 | 0) | 0;
      i28 = HEAP32[i99 >> 2] | 0;
      f190 = Math_fround(-f2);
      f191 = Math_fround(-f3);
      f194 = Math_fround(-f4);
      f192 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i184 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i142 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i143 >> 2]) * f194));
      f193 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i145 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i146 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i147 >> 2]) * f194));
      f194 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i148 >> 2]) * f190) + Math_fround(Math_fround(HEAPF32[i149 >> 2]) * f191)) + Math_fround(Math_fround(HEAPF32[i150 >> 2]) * f194));
      HEAPF32[i133 >> 2] = f192;
      HEAPF32[i107 >> 2] = f193;
      HEAPF32[i108 >> 2] = f194;
      i28 = mftCall_iiii(i28 | 0, i170 | 0, i174 | 0, i133 | 0) | 0;
      break;
     }
    default:
     {
      i27 = i8;
      i28 = i9;
     }
    }
    i8 = HEAP32[i31 >> 2] | 0;
    i1 = i8 + (i27 * 20 | 0) | 0;
    i26 = HEAP32[i32 >> 2] | 0;
    i6 = i26 + (i28 * 20 | 0) | 0;
    f194 = Math_fround(HEAPF32[i158 >> 2]);
    f24 = Math_fround(-f194);
    i25 = f194 >= Math_fround(0.0);
    f24 = i25 ? Math_fround(0.0) : f24;
    if (i165) {
     i7 = HEAP32[i1 >> 2] | 0;
     HEAP32[i175 >> 2] = i7;
     i9 = HEAP32[i8 + (i27 * 20 | 0) + 4 >> 2] | 0;
     HEAP32[i33 >> 2] = i9;
     i25 = HEAP32[i8 + (i27 * 20 | 0) + 8 >> 2] | 0;
     HEAP32[i34 >> 2] = i25;
     HEAP32[i35 >> 2] = HEAP32[i8 + (i27 * 20 | 0) + 12 >> 2];
     f192 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f23 = Math_fround(HEAPF32[i183 >> 2]);
     f14 = Math_fround(f192 * f23);
     f22 = Math_fround(HEAPF32[i126 >> 2]);
     f17 = Math_fround(f192 * f22);
     f21 = Math_fround(HEAPF32[i128 >> 2]);
     f192 = Math_fround(f192 * f21);
     f191 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = Math_fround(HEAPF32[i129 >> 2]);
     f194 = Math_fround(f191 * f20);
     f19 = Math_fround(HEAPF32[i130 >> 2]);
     f193 = Math_fround(f191 * f19);
     f18 = Math_fround(HEAPF32[i131 >> 2]);
     f194 = Math_fround(f14 + f194);
     f193 = Math_fround(f17 + f193);
     f191 = Math_fround(f192 + Math_fround(f191 * f18));
     f192 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = Math_fround(HEAPF32[i132 >> 2]);
     f14 = Math_fround(f192 * f17);
     f16 = Math_fround(HEAPF32[i134 >> 2]);
     f13 = Math_fround(f192 * f16);
     f12 = Math_fround(HEAPF32[i135 >> 2]);
     f15 = f12;
     f12 = Math_fround(f191 + Math_fround(f192 * f12));
     f13 = Math_fround(f193 + f13);
     f14 = Math_fround(f194 + f14);
    } else {
     f16 = Math_fround(HEAPF32[i8 + (i27 * 20 | 0) + 12 >> 2]);
     f17 = Math_fround(HEAPF32[i90 >> 2]);
     f22 = Math_fround(HEAPF32[i1 >> 2]);
     f17 = Math_fround(f17 * f22);
     f191 = Math_fround(HEAPF32[i91 >> 2]);
     f23 = Math_fround(HEAPF32[i8 + (i27 * 20 | 0) + 4 >> 2]);
     f191 = Math_fround(f17 + Math_fround(f191 * f23));
     f17 = Math_fround(HEAPF32[i92 >> 2]);
     f192 = Math_fround(HEAPF32[i8 + (i27 * 20 | 0) + 8 >> 2]);
     f17 = Math_fround(f191 + Math_fround(f17 * f192));
     f191 = Math_fround(f22 * Math_fround(HEAPF32[i93 >> 2]));
     f191 = Math_fround(f191 + Math_fround(f23 * Math_fround(HEAPF32[i94 >> 2])));
     f191 = Math_fround(f191 + Math_fround(f192 * Math_fround(HEAPF32[i95 >> 2])));
     f22 = Math_fround(f22 * Math_fround(HEAPF32[i96 >> 2]));
     f23 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i97 >> 2])));
     f192 = Math_fround(f23 + Math_fround(f192 * Math_fround(HEAPF32[i98 >> 2])));
     f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f191 * f191)) + Math_fround(f192 * f192)))));
     f17 = Math_fround(f17 * f23);
     f191 = Math_fround(f191 * f23);
     f192 = Math_fround(f192 * f23);
     HEAPF32[i175 >> 2] = f17;
     HEAPF32[i33 >> 2] = f191;
     HEAPF32[i34 >> 2] = f192;
     HEAPF32[i35 >> 2] = Math_fround(f16 * f23);
     f23 = Math_fround(HEAPF32[i183 >> 2]);
     f16 = Math_fround(f17 * f23);
     f22 = Math_fround(HEAPF32[i126 >> 2]);
     f14 = Math_fround(f17 * f22);
     f21 = Math_fround(HEAPF32[i128 >> 2]);
     f17 = Math_fround(f17 * f21);
     f20 = Math_fround(HEAPF32[i129 >> 2]);
     f194 = Math_fround(f191 * f20);
     f19 = Math_fround(HEAPF32[i130 >> 2]);
     f193 = Math_fround(f191 * f19);
     f18 = Math_fround(HEAPF32[i131 >> 2]);
     f194 = Math_fround(f16 + f194);
     f193 = Math_fround(f14 + f193);
     f191 = Math_fround(f17 + Math_fround(f191 * f18));
     f17 = Math_fround(HEAPF32[i132 >> 2]);
     f14 = Math_fround(f192 * f17);
     f16 = Math_fround(HEAPF32[i134 >> 2]);
     f13 = Math_fround(f192 * f16);
     f12 = Math_fround(HEAPF32[i135 >> 2]);
     f15 = f12;
     f12 = Math_fround(f191 + Math_fround(f192 * f12));
     f13 = Math_fround(f193 + f13);
     f14 = Math_fround(f194 + f14);
    }
    HEAPF32[i186 >> 2] = f14;
    HEAPF32[i36 >> 2] = f13;
    HEAPF32[i37 >> 2] = f12;
    if (i166) {
     i7 = HEAP32[i6 >> 2] | 0;
     HEAP32[i176 >> 2] = i7;
     i9 = HEAP32[i26 + (i28 * 20 | 0) + 4 >> 2] | 0;
     HEAP32[i38 >> 2] = i9;
     i25 = HEAP32[i26 + (i28 * 20 | 0) + 8 >> 2] | 0;
     HEAP32[i39 >> 2] = i25;
     HEAP32[i40 >> 2] = HEAP32[i26 + (i28 * 20 | 0) + 12 >> 2];
     f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f10 = Math_fround(f5 * Math_fround(HEAPF32[i184 >> 2]));
     f11 = Math_fround(f5 * Math_fround(HEAPF32[i142 >> 2]));
     f5 = Math_fround(f5 * Math_fround(HEAPF32[i143 >> 2]));
     f192 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f194 = Math_fround(f192 * Math_fround(HEAPF32[i145 >> 2]));
     f193 = Math_fround(f192 * Math_fround(HEAPF32[i146 >> 2]));
     f194 = Math_fround(f10 + f194);
     f193 = Math_fround(f11 + f193);
     f192 = Math_fround(f5 + Math_fround(f192 * Math_fround(HEAPF32[i147 >> 2])));
     f5 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f11 = Math_fround(f5 * Math_fround(HEAPF32[i148 >> 2]));
     f10 = Math_fround(f5 * Math_fround(HEAPF32[i149 >> 2]));
     f5 = Math_fround(f192 + Math_fround(f5 * Math_fround(HEAPF32[i150 >> 2])));
     f10 = Math_fround(f193 + f10);
     f11 = Math_fround(f194 + f11);
    } else {
     f10 = Math_fround(HEAPF32[i26 + (i28 * 20 | 0) + 12 >> 2]);
     f11 = Math_fround(HEAPF32[i81 >> 2]);
     f194 = Math_fround(HEAPF32[i6 >> 2]);
     f11 = Math_fround(f11 * f194);
     f192 = Math_fround(HEAPF32[i82 >> 2]);
     f191 = Math_fround(HEAPF32[i26 + (i28 * 20 | 0) + 4 >> 2]);
     f192 = Math_fround(f11 + Math_fround(f192 * f191));
     f11 = Math_fround(HEAPF32[i83 >> 2]);
     f5 = Math_fround(HEAPF32[i26 + (i28 * 20 | 0) + 8 >> 2]);
     f11 = Math_fround(f192 + Math_fround(f11 * f5));
     f192 = Math_fround(f194 * Math_fround(HEAPF32[i84 >> 2]));
     f192 = Math_fround(f192 + Math_fround(f191 * Math_fround(HEAPF32[i85 >> 2])));
     f192 = Math_fround(f192 + Math_fround(f5 * Math_fround(HEAPF32[i86 >> 2])));
     f194 = Math_fround(f194 * Math_fround(HEAPF32[i87 >> 2]));
     f191 = Math_fround(f194 + Math_fround(f191 * Math_fround(HEAPF32[i88 >> 2])));
     f5 = Math_fround(f191 + Math_fround(f5 * Math_fround(HEAPF32[i89 >> 2])));
     f191 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f192 * f192)) + Math_fround(f5 * f5)))));
     f11 = Math_fround(f11 * f191);
     f192 = Math_fround(f192 * f191);
     f5 = Math_fround(f5 * f191);
     HEAPF32[i176 >> 2] = f11;
     HEAPF32[i38 >> 2] = f192;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(f10 * f191);
     f191 = Math_fround(f11 * Math_fround(HEAPF32[i184 >> 2]));
     f10 = Math_fround(f11 * Math_fround(HEAPF32[i142 >> 2]));
     f11 = Math_fround(f11 * Math_fround(HEAPF32[i143 >> 2]));
     f194 = Math_fround(f192 * Math_fround(HEAPF32[i145 >> 2]));
     f193 = Math_fround(f192 * Math_fround(HEAPF32[i146 >> 2]));
     f194 = Math_fround(f191 + f194);
     f193 = Math_fround(f10 + f193);
     f192 = Math_fround(f11 + Math_fround(f192 * Math_fround(HEAPF32[i147 >> 2])));
     f11 = Math_fround(f5 * Math_fround(HEAPF32[i148 >> 2]));
     f10 = Math_fround(f5 * Math_fround(HEAPF32[i149 >> 2]));
     f5 = Math_fround(f192 + Math_fround(f5 * Math_fround(HEAPF32[i150 >> 2])));
     f10 = Math_fround(f193 + f10);
     f11 = Math_fround(f194 + f11);
    }
    HEAPF32[i187 >> 2] = f11;
    HEAPF32[i41 >> 2] = f10;
    HEAPF32[i42 >> 2] = f5;
    i25 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f14 * f2) + Math_fround(f13 * f3)) + Math_fround(f12 * f4)))) > Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f2 * f11) + Math_fround(f3 * f10)) + Math_fround(f4 * f5))));
    f5 = Math_fround(f24 + Math_fround(HEAPF32[i43 >> 2]));
    f24 = Math_fround(-f5);
    f192 = Math_fround(f2 * f24);
    f194 = Math_fround(f3 * f24);
    f3 = Math_fround(f4 * f24);
    HEAPF32[i156 >> 2] = f192;
    HEAPF32[i44 >> 2] = f194;
    HEAPF32[i45 >> 2] = f3;
    f192 = Math_fround(Math_fround(HEAPF32[i138 >> 2]) - f192);
    f194 = Math_fround(Math_fround(HEAPF32[i136 >> 2]) - f194);
    f3 = Math_fround(Math_fround(HEAPF32[i137 >> 2]) - f3);
    HEAPF32[i159 >> 2] = f23;
    HEAPF32[i46 >> 2] = f22;
    HEAPF32[i47 >> 2] = f21;
    HEAPF32[i115 >> 2] = f20;
    HEAPF32[i48 >> 2] = f19;
    HEAPF32[i49 >> 2] = f18;
    HEAPF32[i116 >> 2] = f17;
    HEAPF32[i50 >> 2] = f16;
    HEAPF32[i51 >> 2] = f15;
    HEAPF32[i52 >> 2] = f192;
    HEAPF32[i53 >> 2] = f194;
    HEAPF32[i54 >> 2] = f3;
    f18 = Math_fround(HEAPF32[i179 >> 2]);
    f24 = Math_fround(HEAPF32[i144 >> 2]);
    f19 = Math_fround(HEAPF32[i121 >> 2]);
    f4 = Math_fround(HEAPF32[i122 >> 2]);
    f15 = Math_fround(HEAPF32[i180 >> 2]);
    f195 = Math_fround(-f15);
    f13 = Math_fround(HEAPF32[i139 >> 2]);
    f193 = Math_fround(-f13);
    f22 = Math_fround(HEAPF32[i140 >> 2]);
    f12 = Math_fround(-f22);
    f17 = Math_fround(HEAPF32[i141 >> 2]);
    f21 = Math_fround(HEAPF32[i118 >> 2]);
    f14 = Math_fround(f192 - f21);
    f23 = Math_fround(HEAPF32[i151 >> 2]);
    f16 = Math_fround(f194 - f23);
    f2 = Math_fround(HEAPF32[i152 >> 2]);
    f14 = Math_fround(f14 * Math_fround(2.0));
    f16 = Math_fround(f16 * Math_fround(2.0));
    f10 = Math_fround(Math_fround(f3 - f2) * Math_fround(2.0));
    f11 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
    f190 = Math_fround(Math_fround(Math_fround(f14 * f195) + Math_fround(f16 * f193)) + Math_fround(f10 * f12));
    f20 = Math_fround(Math_fround(f190 * f195) + Math_fround(Math_fround(f11 * f14) + Math_fround(f17 * Math_fround(Math_fround(f10 * f193) - Math_fround(f16 * f12)))));
    f191 = Math_fround(Math_fround(f190 * f193) + Math_fround(Math_fround(f11 * f16) + Math_fround(f17 * Math_fround(Math_fround(f14 * f12) - Math_fround(f10 * f195)))));
    f190 = Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(f17 * Math_fround(Math_fround(f16 * f195) - Math_fround(f14 * f193)))) + Math_fround(f190 * f12));
    f14 = Math_fround(Math_fround(Math_fround(f19 * f193) + Math_fround(Math_fround(f4 * f195) + Math_fround(f18 * f17))) - Math_fround(f24 * f12));
    f16 = Math_fround(Math_fround(Math_fround(f18 * f12) + Math_fround(Math_fround(f4 * f193) + Math_fround(f24 * f17))) - Math_fround(f19 * f195));
    f10 = Math_fround(Math_fround(Math_fround(f24 * f195) + Math_fround(Math_fround(f4 * f12) + Math_fround(f19 * f17))) - Math_fround(f18 * f193));
    f11 = Math_fround(f4 * f17);
    f12 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f18 * f195)) - Math_fround(f24 * f193)) - Math_fround(f19 * f12));
    f18 = Math_fround(-f18);
    f24 = Math_fround(-f24);
    f19 = Math_fround(-f19);
    f21 = Math_fround(Math_fround(f21 - f192) * Math_fround(2.0));
    f23 = Math_fround(Math_fround(f23 - f194) * Math_fround(2.0));
    f3 = Math_fround(Math_fround(f2 - f3) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
    f194 = Math_fround(Math_fround(Math_fround(f21 * f18) + Math_fround(f23 * f24)) + Math_fround(f3 * f19));
    f192 = Math_fround(Math_fround(f194 * f18) + Math_fround(Math_fround(f2 * f21) + Math_fround(f4 * Math_fround(Math_fround(f3 * f24) - Math_fround(f23 * f19)))));
    f193 = Math_fround(Math_fround(f194 * f24) + Math_fround(Math_fround(f2 * f23) + Math_fround(f4 * Math_fround(Math_fround(f21 * f19) - Math_fround(f3 * f18)))));
    f194 = Math_fround(Math_fround(Math_fround(f2 * f3) + Math_fround(f4 * Math_fround(Math_fround(f23 * f18) - Math_fround(f21 * f24)))) + Math_fround(f194 * f19));
    f21 = Math_fround(Math_fround(Math_fround(f22 * f24) + Math_fround(Math_fround(f4 * f15) + Math_fround(f17 * f18))) - Math_fround(f13 * f19));
    f23 = Math_fround(Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f4 * f13) + Math_fround(f17 * f24))) - Math_fround(f22 * f18));
    f17 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f4 * f22) + Math_fround(f17 * f19))) - Math_fround(f15 * f24));
    f19 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f15 * f18)) - Math_fround(f13 * f24)) - Math_fround(f22 * f19));
    f22 = Math_fround(f14 + f14);
    f24 = Math_fround(f16 + f16);
    f13 = Math_fround(f10 + f10);
    f18 = Math_fround(f12 * f22);
    f15 = Math_fround(f12 * f24);
    f12 = Math_fround(f12 * f13);
    f22 = Math_fround(f14 * f22);
    f11 = Math_fround(f14 * f24);
    f14 = Math_fround(f14 * f13);
    f24 = Math_fround(f16 * f24);
    f16 = Math_fround(f16 * f13);
    f13 = Math_fround(f10 * f13);
    HEAPF32[i160 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f24) - f13);
    HEAPF32[i55 >> 2] = Math_fround(f11 + f12);
    HEAPF32[i56 >> 2] = Math_fround(f14 - f15);
    HEAPF32[i57 >> 2] = Math_fround(f11 - f12);
    f22 = Math_fround(Math_fround(1.0) - f22);
    HEAPF32[i58 >> 2] = Math_fround(f22 - f13);
    HEAPF32[i59 >> 2] = Math_fround(f16 + f18);
    HEAPF32[i60 >> 2] = Math_fround(f14 + f15);
    HEAPF32[i61 >> 2] = Math_fround(f16 - f18);
    HEAPF32[i62 >> 2] = Math_fround(f22 - f24);
    HEAPF32[i63 >> 2] = f20;
    HEAPF32[i64 >> 2] = f191;
    HEAPF32[i65 >> 2] = f190;
    f190 = Math_fround(f21 + f21);
    f191 = Math_fround(f23 + f23);
    f20 = Math_fround(f17 + f17);
    f24 = Math_fround(f19 * f190);
    f22 = Math_fround(f19 * f191);
    f19 = Math_fround(f19 * f20);
    f190 = Math_fround(f21 * f190);
    f18 = Math_fround(f21 * f191);
    f21 = Math_fround(f21 * f20);
    f191 = Math_fround(f23 * f191);
    f23 = Math_fround(f23 * f20);
    f20 = Math_fround(f17 * f20);
    HEAPF32[i181 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f191) - f20);
    HEAPF32[i66 >> 2] = Math_fround(f18 + f19);
    HEAPF32[i67 >> 2] = Math_fround(f21 - f22);
    HEAPF32[i68 >> 2] = Math_fround(f18 - f19);
    f190 = Math_fround(Math_fround(1.0) - f190);
    HEAPF32[i69 >> 2] = Math_fround(f190 - f20);
    HEAPF32[i70 >> 2] = Math_fround(f23 + f24);
    HEAPF32[i71 >> 2] = Math_fround(f21 + f22);
    HEAPF32[i72 >> 2] = Math_fround(f23 - f24);
    HEAPF32[i73 >> 2] = Math_fround(f190 - f191);
    HEAPF32[i74 >> 2] = f192;
    HEAPF32[i75 >> 2] = f193;
    HEAPF32[i76 >> 2] = f194;
    i9 = i8 + (i27 * 20 | 0) + 18 | 0;
    if (i165) {
     i7 = 0;
     i1 = 0;
    } else {
     i6 = HEAPU8[i9 >> 0] | 0;
     i7 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * (i6 * 12 | 0) | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     i1 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i6 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    }
    __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE(i171, i177, i7, i1, i165, HEAP32[i77 >> 2] | 0, (HEAP32[i78 >> 2] | 0) + (HEAPU16[i8 + (i27 * 20 | 0) + 16 >> 1] | 0) | 0, HEAPU8[i9 >> 0] | 0, i173);
    i8 = i26 + (i28 * 20 | 0) + 18 | 0;
    if (i166) {
     i7 = 0;
     i1 = 0;
    } else {
     i6 = HEAPU8[i8 >> 0] | 0;
     i7 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * (i6 * 12 | 0) | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     i1 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i6 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    }
    __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE(i172, i178, i7, i1, i166, HEAP32[i79 >> 2] | 0, (HEAP32[i80 >> 2] | 0) + (HEAPU16[i26 + (i28 * 20 | 0) + 16 >> 1] | 0) | 0, HEAPU8[i8 >> 0] | 0, i174);
    __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E(i182, i175);
    __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E(i119, i176);
    if (i25) {
     if (__ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f(HEAPU8[i9 >> 0] | 0, HEAP32[i171 >> 2] | 0, HEAP32[i177 >> 2] | 0, i159, i175, i182, HEAPU8[i8 >> 0] | 0, HEAP32[i172 >> 2] | 0, HEAP32[i178 >> 2] | 0, i184, i176, i119, i186, i160, i181, -1, -1, i154, 1, i156, f5) | 0) {
      i188 = 37;
      break;
     }
    } else if (__ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f(HEAPU8[i8 >> 0] | 0, HEAP32[i172 >> 2] | 0, HEAP32[i178 >> 2] | 0, i184, i176, i119, HEAPU8[i9 >> 0] | 0, HEAP32[i171 >> 2] | 0, HEAP32[i177 >> 2] | 0, i159, i175, i182, i187, i181, i160, -1, -1, i154, 0, i156, f5) | 0) {
     i188 = 37;
     break;
    }
    if ((i117 | 0) > 0) {
     i117 = i117 + -1 | 0;
     i8 = i27;
     i9 = i28;
    } else {
     i1 = 0;
     break;
    }
   }
   if ((i188 | 0) == 15) i1 = 0; else if ((i188 | 0) == 37) i1 = 1;
   i188 = i1;
   STACKTOP = i189;
   return i188 | 0;
  }
 }
 i188 = 0;
 STACKTOP = i189;
 return i188 | 0;
}

function __ZL18triangleConvexTestRKN5physx2Gu13PolygonalDataEhjPKNS_6PxVec3ERKNS_7PxPlaneERS5_RKNS_2Cm8Matrix34ESE_SE_SE_RKNSB_23FastVertex2ShapeScalingEfRS4_RfRbb(i112, i52, i107, i53, f17, f21, f35, i117, i108, i109, i106, f105, i115, i116, i114, i47) {
 i112 = i112 | 0;
 i52 = i52 | 0;
 i107 = i107 | 0;
 i53 = i53 | 0;
 f17 = Math_fround(f17);
 f21 = Math_fround(f21);
 f35 = Math_fround(f35);
 i117 = i117 | 0;
 i108 = i108 | 0;
 i109 = i109 | 0;
 i106 = i106 | 0;
 f105 = Math_fround(f105);
 i115 = i115 | 0;
 i116 = i116 | 0;
 i114 = i114 | 0;
 i47 = i47 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f18 = f0, f19 = f0, f20 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0, f64 = f0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i110 = 0, i111 = 0, i113 = 0, i118 = 0;
 i118 = STACKTOP;
 STACKTOP = STACKTOP + 3168 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i111 = i118 + 3164 | 0;
 i110 = i118 + 3160 | 0;
 i103 = i118 + 3124 | 0;
 i104 = i118 + 48 | 0;
 i102 = i118 + 36 | 0;
 i113 = i118;
 i50 = HEAP32[i112 + 16 >> 2] | 0;
 i101 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i50 << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i112 + 24 | 0;
 i48 = HEAP32[i51 >> 2] | 0;
 i54 = i112 + 28 | 0;
 i49 = HEAP32[i54 >> 2] | 0;
 i1 = i108 + 36 | 0;
 L1 : do if (i47) if (!i50) {
  i27 = -1;
  i3 = 0;
  i5 = 0;
  f10 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
  i4 = 0;
 } else {
  i25 = i107 + 4 | 0;
  i26 = i107 + 8 | 0;
  i27 = i107 + 12 | 0;
  i28 = i107 + 16 | 0;
  i29 = i107 + 20 | 0;
  i30 = i107 + 24 | 0;
  i31 = i107 + 28 | 0;
  i32 = i107 + 32 | 0;
  f18 = Math_fround(HEAPF32[i108 >> 2]);
  f19 = Math_fround(HEAPF32[i108 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i108 + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i108 + 12 >> 2]);
  f23 = Math_fround(HEAPF32[i108 + 16 >> 2]);
  f24 = Math_fround(HEAPF32[i108 + 20 >> 2]);
  f33 = Math_fround(HEAPF32[i108 + 24 >> 2]);
  f34 = Math_fround(HEAPF32[i108 + 28 >> 2]);
  f36 = Math_fround(HEAPF32[i108 + 32 >> 2]);
  f37 = Math_fround(HEAPF32[i1 >> 2]);
  f38 = Math_fround(HEAPF32[i108 + 40 >> 2]);
  f39 = Math_fround(HEAPF32[i108 + 44 >> 2]);
  i12 = -1;
  i1 = 0;
  i4 = 0;
  i3 = 0;
  f16 = Math_fround(3402823469999999843913219.0e14);
  i6 = i101;
  i14 = 0;
  while (1) {
   f2 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) >> 2]);
   f80 = Math_fround(f2 * f17);
   f7 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 4 >> 2]);
   f80 = Math_fround(f80 + Math_fround(f7 * f21));
   f8 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 8 >> 2]);
   f80 = Math_fround(f80 + Math_fround(f8 * f35));
   f10 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 12 >> 2]);
   if (Math_fround(f10 + f80) < Math_fround(0.0)) {
    f2 = f16;
    i5 = i6;
   } else {
    i5 = i6 + 4 | 0;
    HEAP32[i6 >> 2] = i14;
    f11 = Math_fround(Math_fround(Math_fround(f2 * f18) + Math_fround(f7 * f22)) + Math_fround(f8 * f33));
    f13 = Math_fround(Math_fround(Math_fround(f2 * f19) + Math_fround(f7 * f23)) + Math_fround(f8 * f34));
    f15 = Math_fround(Math_fround(Math_fround(f2 * f20) + Math_fround(f7 * f24)) + Math_fround(f8 * f36));
    f80 = Math_fround(Math_fround(Math_fround(f11 * f37) + Math_fround(f13 * f38)) + Math_fround(f15 * f39));
    i100 = HEAPU8[i48 + (i14 * 20 | 0) + 19 >> 0] | 0;
    f9 = Math_fround(f2 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) >> 2]));
    f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) + 4 >> 2])));
    f9 = Math_fround(f80 + Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) + 8 >> 2]))));
    f8 = Math_fround(f80 - f10);
    f7 = Math_fround(f11 * Math_fround(HEAPF32[i107 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f13 * Math_fround(HEAPF32[i25 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f15 * Math_fround(HEAPF32[i26 >> 2])));
    f80 = Math_fround(f11 * Math_fround(HEAPF32[i27 >> 2]));
    f80 = Math_fround(f80 + Math_fround(f13 * Math_fround(HEAPF32[i28 >> 2])));
    f80 = Math_fround(f80 + Math_fround(f15 * Math_fround(HEAPF32[i29 >> 2])));
    f2 = f7 < f80 ? f7 : f80;
    f80 = f7 > f80 ? f7 : f80;
    f7 = Math_fround(f11 * Math_fround(HEAPF32[i30 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f13 * Math_fround(HEAPF32[i31 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f15 * Math_fround(HEAPF32[i32 >> 2])));
    f2 = f2 < f7 ? f2 : f7;
    f7 = f80 > f7 ? f80 : f7;
    if (Math_fround(f8 + f105) < f2 | Math_fround(f7 + f105) < f9) {
     i1 = 0;
     break;
    }
    f80 = Math_fround(f8 - f2);
    f2 = Math_fround(f7 - f9);
    f2 = f80 < f2 ? f80 : f2;
    if (f2 < f16) {
     i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = i14;
     i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
    } else f2 = f16;
   }
   i14 = i14 + 1 | 0;
   if (i14 >>> 0 >= i50 >>> 0) {
    f80 = f18;
    f79 = f19;
    f78 = f20;
    f65 = f22;
    f64 = f23;
    f58 = f24;
    f59 = f36;
    f60 = f37;
    f61 = f38;
    f62 = f39;
    i100 = 18;
    break L1;
   } else {
    f16 = f2;
    i6 = i5;
   }
  }
  STACKTOP = i118;
  return i1 | 0;
 } else {
  f40 = Math_fround(HEAPF32[i106 + 36 >> 2]);
  f22 = Math_fround(f40 * f17);
  f41 = Math_fround(HEAPF32[i106 + 40 >> 2]);
  f24 = Math_fround(f41 * f17);
  f42 = Math_fround(HEAPF32[i106 + 44 >> 2]);
  f20 = Math_fround(f42 * f17);
  f37 = Math_fround(HEAPF32[i106 + 48 >> 2]);
  f79 = Math_fround(f37 * f21);
  f38 = Math_fround(HEAPF32[i106 + 52 >> 2]);
  f80 = Math_fround(f38 * f21);
  f39 = Math_fround(HEAPF32[i106 + 56 >> 2]);
  f79 = Math_fround(f22 + f79);
  f80 = Math_fround(f24 + f80);
  f20 = Math_fround(f20 + Math_fround(f39 * f21));
  f21 = Math_fround(HEAPF32[i106 + 60 >> 2]);
  f24 = Math_fround(f21 * f35);
  f22 = Math_fround(HEAPF32[i106 + 64 >> 2]);
  f36 = Math_fround(f22 * f35);
  f23 = Math_fround(HEAPF32[i106 + 68 >> 2]);
  f24 = Math_fround(f79 + f24);
  f36 = Math_fround(f80 + f36);
  f20 = Math_fround(f20 + Math_fround(f23 * f35));
  if (!i50) {
   i27 = -1;
   i3 = 0;
   i5 = 0;
   f10 = Math_fround(3402823469999999843913219.0e14);
   i1 = 0;
   i4 = 0;
  } else {
   i25 = i107 + 4 | 0;
   i26 = i107 + 8 | 0;
   i27 = i107 + 12 | 0;
   i28 = i107 + 16 | 0;
   i29 = i107 + 20 | 0;
   i30 = i107 + 24 | 0;
   i31 = i107 + 28 | 0;
   i32 = i107 + 32 | 0;
   f35 = Math_fround(HEAPF32[i108 >> 2]);
   f43 = Math_fround(HEAPF32[i108 + 4 >> 2]);
   f44 = Math_fround(HEAPF32[i108 + 8 >> 2]);
   f45 = Math_fround(HEAPF32[i108 + 12 >> 2]);
   f46 = Math_fround(HEAPF32[i108 + 16 >> 2]);
   f58 = Math_fround(HEAPF32[i108 + 20 >> 2]);
   f33 = Math_fround(HEAPF32[i108 + 24 >> 2]);
   f34 = Math_fround(HEAPF32[i108 + 28 >> 2]);
   f59 = Math_fround(HEAPF32[i108 + 32 >> 2]);
   f60 = Math_fround(HEAPF32[i1 >> 2]);
   f61 = Math_fround(HEAPF32[i108 + 40 >> 2]);
   f62 = Math_fround(HEAPF32[i108 + 44 >> 2]);
   i12 = -1;
   i1 = 0;
   i4 = 0;
   i3 = 0;
   f19 = Math_fround(3402823469999999843913219.0e14);
   i6 = i101;
   i14 = 0;
   while (1) {
    f9 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) >> 2]);
    f80 = Math_fround(f24 * f9);
    f10 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 4 >> 2]);
    f80 = Math_fround(f80 + Math_fround(f36 * f10));
    f11 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 8 >> 2]);
    f80 = Math_fround(f80 + Math_fround(f20 * f11));
    f15 = Math_fround(HEAPF32[i48 + (i14 * 20 | 0) + 12 >> 2]);
    if (Math_fround(f15 + f80) < Math_fround(0.0)) {
     f2 = f19;
     i5 = i6;
    } else {
     f2 = Math_fround(Math_fround(Math_fround(f9 * f40) + Math_fround(f10 * f37)) + Math_fround(f11 * f21));
     f7 = Math_fround(Math_fround(Math_fround(f9 * f41) + Math_fround(f10 * f38)) + Math_fround(f11 * f22));
     f8 = Math_fround(Math_fround(Math_fround(f9 * f42) + Math_fround(f10 * f39)) + Math_fround(f11 * f23));
     f80 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f7 * f7)) + Math_fround(f8 * f8))));
     f16 = Math_fround(Math_fround(1.0) / f80);
     if (f80 > Math_fround(0.0)) {
      f2 = Math_fround(f2 * f16);
      f7 = Math_fround(f7 * f16);
      f8 = Math_fround(f8 * f16);
     }
     i5 = i6 + 4 | 0;
     HEAP32[i6 >> 2] = i14;
     f17 = Math_fround(Math_fround(Math_fround(f2 * f35) + Math_fround(f7 * f45)) + Math_fround(f8 * f33));
     f18 = Math_fround(Math_fround(Math_fround(f2 * f43) + Math_fround(f7 * f46)) + Math_fround(f8 * f34));
     f13 = Math_fround(Math_fround(Math_fround(f2 * f44) + Math_fround(f7 * f58)) + Math_fround(f8 * f59));
     f2 = Math_fround(Math_fround(Math_fround(f17 * f60) + Math_fround(f18 * f61)) + Math_fround(f13 * f62));
     i100 = HEAPU8[i48 + (i14 * 20 | 0) + 19 >> 0] | 0;
     f9 = Math_fround(f9 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) >> 2]));
     f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) + 4 >> 2])));
     f9 = Math_fround(f2 + Math_fround(f16 * Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i49 + (i100 * 12 | 0) + 8 >> 2])))));
     f2 = Math_fround(f2 - Math_fround(f15 * f16));
     f8 = Math_fround(f17 * Math_fround(HEAPF32[i107 >> 2]));
     f8 = Math_fround(f8 + Math_fround(f18 * Math_fround(HEAPF32[i25 >> 2])));
     f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i26 >> 2])));
     f80 = Math_fround(f17 * Math_fround(HEAPF32[i27 >> 2]));
     f80 = Math_fround(f80 + Math_fround(f18 * Math_fround(HEAPF32[i28 >> 2])));
     f80 = Math_fround(f80 + Math_fround(f13 * Math_fround(HEAPF32[i29 >> 2])));
     f7 = f8 < f80 ? f8 : f80;
     f80 = f8 > f80 ? f8 : f80;
     f8 = Math_fround(f17 * Math_fround(HEAPF32[i30 >> 2]));
     f8 = Math_fround(f8 + Math_fround(f18 * Math_fround(HEAPF32[i31 >> 2])));
     f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i32 >> 2])));
     f7 = f7 < f8 ? f7 : f8;
     f8 = f80 > f8 ? f80 : f8;
     if (Math_fround(f2 + f105) < f7 | Math_fround(f8 + f105) < f9) {
      i1 = 0;
      break;
     }
     f80 = Math_fround(f2 - f7);
     f2 = Math_fround(f8 - f9);
     f2 = f80 < f2 ? f80 : f2;
     if (f2 < f19) {
      i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = i14;
      i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     } else f2 = f19;
    }
    i14 = i14 + 1 | 0;
    if (i14 >>> 0 >= i50 >>> 0) {
     f80 = f35;
     f79 = f43;
     f78 = f44;
     f65 = f45;
     f64 = f46;
     i100 = 18;
     break L1;
    } else {
     f19 = f2;
     i6 = i5;
    }
   }
   STACKTOP = i118;
   return i1 | 0;
  }
 } while (0);
 L25 : do if ((i100 | 0) == 18) {
  i5 = i5 - i101 >> 2;
  if ((i12 | 0) == -1) {
   i5 = (i50 | 0) == 0;
   if (i47) {
    if (i5) {
     i27 = -1;
     i5 = 0;
     f10 = f2;
     break;
    }
    f16 = Math_fround(HEAPF32[i107 >> 2]);
    f17 = Math_fround(HEAPF32[i107 + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i107 + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i107 + 12 >> 2]);
    f20 = Math_fround(HEAPF32[i107 + 16 >> 2]);
    f21 = Math_fround(HEAPF32[i107 + 20 >> 2]);
    f22 = Math_fround(HEAPF32[i107 + 24 >> 2]);
    f23 = Math_fround(HEAPF32[i107 + 28 >> 2]);
    f24 = Math_fround(HEAPF32[i107 + 32 >> 2]);
    i5 = -1;
    f13 = f2;
    i6 = 0;
    while (1) {
     f46 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) >> 2]);
     f10 = Math_fround(f46 * f80);
     f11 = Math_fround(f46 * f79);
     f15 = Math_fround(f46 * f78);
     f9 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 4 >> 2]);
     f10 = Math_fround(f10 + Math_fround(f9 * f65));
     f11 = Math_fround(f11 + Math_fround(f9 * f64));
     f15 = Math_fround(f15 + Math_fround(f9 * f58));
     f2 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 8 >> 2]);
     f10 = Math_fround(f10 + Math_fround(f2 * f33));
     f11 = Math_fround(f11 + Math_fround(f2 * f34));
     f15 = Math_fround(f15 + Math_fround(f2 * f59));
     f7 = Math_fround(Math_fround(Math_fround(f10 * f60) + Math_fround(f11 * f61)) + Math_fround(f15 * f62));
     i99 = HEAPU8[i48 + (i6 * 20 | 0) + 19 >> 0] | 0;
     f46 = Math_fround(f46 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) >> 2]));
     f9 = Math_fround(f46 + Math_fround(f9 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) + 4 >> 2])));
     f2 = Math_fround(f7 + Math_fround(f9 + Math_fround(f2 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) + 8 >> 2]))));
     f7 = Math_fround(f7 - Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 12 >> 2]));
     f9 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f17 * f11)) + Math_fround(f18 * f15));
     f46 = Math_fround(Math_fround(Math_fround(f19 * f10) + Math_fround(f20 * f11)) + Math_fround(f21 * f15));
     f8 = f9 < f46 ? f9 : f46;
     f46 = f9 > f46 ? f9 : f46;
     f9 = Math_fround(Math_fround(Math_fround(f22 * f10) + Math_fround(f23 * f11)) + Math_fround(f24 * f15));
     f8 = f8 < f9 ? f8 : f9;
     f9 = f46 > f9 ? f46 : f9;
     if (Math_fround(f7 + f105) < f8 | Math_fround(f9 + f105) < f2) {
      i1 = 0;
      break;
     }
     f46 = Math_fround(f7 - f8);
     f2 = Math_fround(f9 - f2);
     f2 = f46 < f2 ? f46 : f2;
     if (f2 < f13) {
      i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
      i5 = i6;
      i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
     } else f2 = f13;
     HEAP32[i101 + (i6 << 2) >> 2] = i6;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= i50 >>> 0) {
      i27 = i5;
      i5 = i50;
      f10 = f2;
      break L25;
     } else f13 = f2;
    }
    STACKTOP = i118;
    return i1 | 0;
   }
   if (i5) {
    i27 = -1;
    i5 = 0;
    f10 = f2;
   } else {
    f19 = Math_fround(HEAPF32[i106 + 36 >> 2]);
    f20 = Math_fround(HEAPF32[i106 + 40 >> 2]);
    f21 = Math_fround(HEAPF32[i106 + 44 >> 2]);
    f22 = Math_fround(HEAPF32[i106 + 48 >> 2]);
    f23 = Math_fround(HEAPF32[i106 + 52 >> 2]);
    f24 = Math_fround(HEAPF32[i106 + 56 >> 2]);
    f35 = Math_fround(HEAPF32[i106 + 60 >> 2]);
    f36 = Math_fround(HEAPF32[i106 + 64 >> 2]);
    f37 = Math_fround(HEAPF32[i106 + 68 >> 2]);
    f38 = Math_fround(HEAPF32[i107 >> 2]);
    f39 = Math_fround(HEAPF32[i107 + 4 >> 2]);
    f40 = Math_fround(HEAPF32[i107 + 8 >> 2]);
    f41 = Math_fround(HEAPF32[i107 + 12 >> 2]);
    f42 = Math_fround(HEAPF32[i107 + 16 >> 2]);
    f43 = Math_fround(HEAPF32[i107 + 20 >> 2]);
    f44 = Math_fround(HEAPF32[i107 + 24 >> 2]);
    f45 = Math_fround(HEAPF32[i107 + 28 >> 2]);
    f46 = Math_fround(HEAPF32[i107 + 32 >> 2]);
    i5 = -1;
    i6 = 0;
    while (1) {
     f10 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) >> 2]);
     f7 = Math_fround(f10 * f19);
     f8 = Math_fround(f10 * f20);
     f9 = Math_fround(f10 * f21);
     f11 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 4 >> 2]);
     f7 = Math_fround(f7 + Math_fround(f11 * f22));
     f8 = Math_fround(f8 + Math_fround(f11 * f23));
     f9 = Math_fround(f9 + Math_fround(f11 * f24));
     f13 = Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 8 >> 2]);
     f7 = Math_fround(f7 + Math_fround(f13 * f35));
     f8 = Math_fround(f8 + Math_fround(f13 * f36));
     f9 = Math_fround(f9 + Math_fround(f13 * f37));
     f18 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9))));
     f15 = Math_fround(Math_fround(1.0) / f18);
     if (f18 > Math_fround(0.0)) {
      f7 = Math_fround(f7 * f15);
      f8 = Math_fround(f8 * f15);
      f9 = Math_fround(f9 * f15);
     }
     f17 = Math_fround(Math_fround(Math_fround(f7 * f80) + Math_fround(f8 * f65)) + Math_fround(f9 * f33));
     f18 = Math_fround(Math_fround(Math_fround(f7 * f79) + Math_fround(f8 * f64)) + Math_fround(f9 * f34));
     f16 = Math_fround(Math_fround(Math_fround(f7 * f78) + Math_fround(f8 * f58)) + Math_fround(f9 * f59));
     f7 = Math_fround(Math_fround(Math_fround(f17 * f60) + Math_fround(f18 * f61)) + Math_fround(f16 * f62));
     i99 = HEAPU8[i48 + (i6 * 20 | 0) + 19 >> 0] | 0;
     f10 = Math_fround(f10 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) >> 2]));
     f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) + 4 >> 2])));
     f10 = Math_fround(f7 + Math_fround(f15 * Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i49 + (i99 * 12 | 0) + 8 >> 2])))));
     f7 = Math_fround(f7 - Math_fround(f15 * Math_fround(HEAPF32[i48 + (i6 * 20 | 0) + 12 >> 2])));
     f9 = Math_fround(Math_fround(Math_fround(f17 * f38) + Math_fround(f18 * f39)) + Math_fround(f16 * f40));
     f15 = Math_fround(Math_fround(Math_fround(f17 * f41) + Math_fround(f18 * f42)) + Math_fround(f16 * f43));
     f8 = f9 < f15 ? f9 : f15;
     f15 = f9 > f15 ? f9 : f15;
     f9 = Math_fround(Math_fround(Math_fround(f17 * f44) + Math_fround(f18 * f45)) + Math_fround(f16 * f46));
     f8 = f8 < f9 ? f8 : f9;
     f9 = f15 > f9 ? f15 : f9;
     if (Math_fround(f7 + f105) < f8 | Math_fround(f9 + f105) < f10) {
      i1 = 0;
      break;
     }
     f15 = Math_fround(f7 - f8);
     f7 = Math_fround(f9 - f10);
     f7 = f15 < f7 ? f15 : f7;
     if (f7 < f2) {
      i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
      i5 = i6;
      f2 = f7;
      i1 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
     }
     HEAP32[i101 + (i6 << 2) >> 2] = i6;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= i50 >>> 0) {
      i27 = i5;
      i5 = i50;
      f10 = f2;
      break L25;
     }
    }
    STACKTOP = i118;
    return i1 | 0;
   }
  } else {
   i27 = i12;
   f10 = f2;
  }
 } while (0);
 HEAP32[i115 >> 2] = 0;
 i98 = i115 + 4 | 0;
 HEAP32[i98 >> 2] = 0;
 i99 = i115 + 8 | 0;
 HEAP32[i99 >> 2] = 0;
 HEAPF32[i116 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i89 = i112 + 64 | 0;
 mftCall_viiiiii(HEAP32[i89 >> 2] | 0, i112 | 0, i53 | 0, i108 | 0, i106 | 0, i111 | 0, i110 | 0);
 f44 = Math_fround(HEAPF32[i107 >> 2]);
 f78 = Math_fround(HEAPF32[i53 >> 2]);
 f58 = Math_fround(f44 * f78);
 i90 = i107 + 4 | 0;
 f45 = Math_fround(HEAPF32[i90 >> 2]);
 i25 = i53 + 4 | 0;
 f79 = Math_fround(HEAPF32[i25 >> 2]);
 f58 = Math_fround(f58 + Math_fround(f45 * f79));
 i91 = i107 + 8 | 0;
 f46 = Math_fround(HEAPF32[i91 >> 2]);
 i26 = i53 + 8 | 0;
 f80 = Math_fround(HEAPF32[i26 >> 2]);
 f58 = Math_fround(f58 + Math_fround(f46 * f80));
 i92 = i107 + 12 | 0;
 f41 = Math_fround(HEAPF32[i92 >> 2]);
 f8 = Math_fround(f78 * f41);
 i93 = i107 + 16 | 0;
 f42 = Math_fround(HEAPF32[i93 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f79 * f42));
 i94 = i107 + 20 | 0;
 f43 = Math_fround(HEAPF32[i94 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f80 * f43));
 f2 = f58 < f8 ? f58 : f8;
 f8 = f58 > f8 ? f58 : f8;
 i95 = i107 + 24 | 0;
 f58 = Math_fround(HEAPF32[i95 >> 2]);
 f7 = Math_fround(f78 * f58);
 i96 = i107 + 28 | 0;
 f59 = Math_fround(HEAPF32[i96 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f79 * f59));
 i97 = i107 + 32 | 0;
 f60 = Math_fround(HEAPF32[i97 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f80 * f60));
 f2 = f2 < f7 ? f2 : f7;
 f7 = f8 > f7 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i110 >> 2]);
 i88 = Math_fround(f8 + f105) < f2;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
 if (!i88) {
  f80 = Math_fround(f7 + f105);
  f9 = Math_fround(HEAPF32[i111 >> 2]);
  if (!(f80 < f9)) {
   f80 = Math_fround(f8 - f2);
   f2 = Math_fround(f7 - f9);
   f2 = f80 < f2 ? f80 : f2;
   if (f2 < Math_fround(f10 + Math_fround(.0000999999974))) {
    i3 = i6;
    i4 = i12;
    i1 = i14;
    i6 = 1;
   } else {
    f2 = f10;
    i6 = 0;
   }
   HEAP8[i114 >> 0] = i6;
   if (f2 < Math_fround(HEAPF32[i116 >> 2])) {
    HEAPF32[i116 >> 2] = f2;
    f80 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f79 = Math_fround(f80 * Math_fround(HEAPF32[i117 >> 2]));
    f78 = Math_fround(f80 * Math_fround(HEAPF32[i117 + 4 >> 2]));
    f80 = Math_fround(f80 * Math_fround(HEAPF32[i117 + 8 >> 2]));
    f64 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f65 = Math_fround(f64 * Math_fround(HEAPF32[i117 + 12 >> 2]));
    f62 = Math_fround(f64 * Math_fround(HEAPF32[i117 + 16 >> 2]));
    f65 = Math_fround(f79 + f65);
    f62 = Math_fround(f78 + f62);
    f64 = Math_fround(f80 + Math_fround(f64 * Math_fround(HEAPF32[i117 + 20 >> 2])));
    f80 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f78 = Math_fround(f80 * Math_fround(HEAPF32[i117 + 24 >> 2]));
    f79 = Math_fround(f80 * Math_fround(HEAPF32[i117 + 28 >> 2]));
    f79 = Math_fround(f62 + f79);
    f80 = Math_fround(f64 + Math_fround(f80 * Math_fround(HEAPF32[i117 + 32 >> 2])));
    HEAPF32[i115 >> 2] = Math_fround(f65 + f78);
    HEAPF32[i98 >> 2] = f79;
    HEAPF32[i99 >> 2] = f80;
   }
   i66 = HEAP32[i51 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i66 + (i27 * 20 | 0) >> 2]);
   f10 = Math_fround(HEAPF32[i109 >> 2]);
   f40 = Math_fround(f2 * f10);
   i81 = i109 + 4 | 0;
   f11 = Math_fround(HEAPF32[i81 >> 2]);
   f18 = Math_fround(f2 * f11);
   i82 = i109 + 8 | 0;
   f13 = Math_fround(HEAPF32[i82 >> 2]);
   f2 = Math_fround(f2 * f13);
   f21 = Math_fround(HEAPF32[i66 + (i27 * 20 | 0) + 4 >> 2]);
   i83 = i109 + 12 | 0;
   f15 = Math_fround(HEAPF32[i83 >> 2]);
   f24 = Math_fround(f21 * f15);
   i84 = i109 + 16 | 0;
   f16 = Math_fround(HEAPF32[i84 >> 2]);
   f7 = Math_fround(f21 * f16);
   i85 = i109 + 20 | 0;
   f17 = Math_fround(HEAPF32[i85 >> 2]);
   f24 = Math_fround(f40 + f24);
   f7 = Math_fround(f18 + f7);
   f21 = Math_fround(f2 + Math_fround(f21 * f17));
   f2 = Math_fround(HEAPF32[i66 + (i27 * 20 | 0) + 8 >> 2]);
   i86 = i109 + 24 | 0;
   f18 = Math_fround(HEAPF32[i86 >> 2]);
   f40 = Math_fround(f2 * f18);
   i87 = i109 + 28 | 0;
   f19 = Math_fround(HEAPF32[i87 >> 2]);
   f80 = Math_fround(f2 * f19);
   i88 = i109 + 32 | 0;
   f20 = Math_fround(HEAPF32[i88 >> 2]);
   f40 = Math_fround(f24 + f40);
   f80 = Math_fround(f7 + f80);
   f2 = Math_fround(f21 + Math_fround(f2 * f20));
   f21 = Math_fround(HEAPF32[i106 >> 2]);
   f7 = Math_fround(f40 * f21);
   i67 = i106 + 4 | 0;
   f24 = Math_fround(HEAPF32[i67 >> 2]);
   f23 = Math_fround(f40 * f24);
   i68 = i106 + 8 | 0;
   f35 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(f40 * f35);
   i69 = i106 + 12 | 0;
   f22 = Math_fround(HEAPF32[i69 >> 2]);
   f38 = Math_fround(f80 * f22);
   i70 = i106 + 16 | 0;
   f33 = Math_fround(HEAPF32[i70 >> 2]);
   f79 = Math_fround(f80 * f33);
   i71 = i106 + 20 | 0;
   f36 = Math_fround(HEAPF32[i71 >> 2]);
   f38 = Math_fround(f7 + f38);
   f79 = Math_fround(f23 + f79);
   f9 = Math_fround(f9 + Math_fround(f80 * f36));
   i72 = i106 + 24 | 0;
   f23 = Math_fround(HEAPF32[i72 >> 2]);
   f7 = Math_fround(f2 * f23);
   i73 = i106 + 28 | 0;
   f34 = Math_fround(HEAPF32[i73 >> 2]);
   f8 = Math_fround(f2 * f34);
   i74 = i106 + 32 | 0;
   f37 = Math_fround(HEAPF32[i74 >> 2]);
   f7 = Math_fround(f38 + f7);
   f8 = Math_fround(f79 + f8);
   f9 = Math_fround(f9 + Math_fround(f2 * f37));
   f79 = Math_fround(HEAPF32[i66 + (i27 * 20 | 0) + 12 >> 2]);
   i75 = i109 + 36 | 0;
   f38 = Math_fround(HEAPF32[i75 >> 2]);
   f40 = Math_fround(f40 * f38);
   i76 = i109 + 40 | 0;
   f39 = Math_fround(HEAPF32[i76 >> 2]);
   f80 = Math_fround(f40 + Math_fround(f80 * f39));
   i77 = i109 + 44 | 0;
   f40 = Math_fround(HEAPF32[i77 >> 2]);
   f2 = Math_fround(f79 - Math_fround(f80 + Math_fround(f2 * f40)));
   i12 = i52 & 255;
   do if (!(i12 & 8)) i6 = 0; else {
    if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f44) + Math_fround(f8 * f45)) + Math_fround(f9 * f46))) <= f105)) if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f41) + Math_fround(f8 * f42)) + Math_fround(f9 * f43))) <= f105)) {
     i6 = 0;
     break;
    }
    f79 = Math_fround(f45 - f42);
    f80 = Math_fround(f46 - f43);
    HEAPF32[i103 >> 2] = Math_fround(f44 - f41);
    HEAPF32[i103 + 4 >> 2] = f79;
    HEAPF32[i103 + 8 >> 2] = f80;
    i6 = 1;
   } while (0);
   do if (i12 & 16) {
    if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f41) + Math_fround(f8 * f42)) + Math_fround(f9 * f43))) <= f105)) if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f58) + Math_fround(f8 * f59)) + Math_fround(f9 * f60))) <= f105)) break;
    f79 = Math_fround(f42 - f59);
    f80 = Math_fround(f43 - f60);
    HEAPF32[i103 + (i6 * 12 | 0) >> 2] = Math_fround(f41 - f58);
    HEAPF32[i103 + (i6 * 12 | 0) + 4 >> 2] = f79;
    HEAPF32[i103 + (i6 * 12 | 0) + 8 >> 2] = f80;
    i6 = i6 + 1 | 0;
   } while (0);
   do if (!(i12 & 32)) i63 = i6; else {
    if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f58) + Math_fround(f8 * f59)) + Math_fround(f9 * f60))) <= f105)) if (!(Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 * f44) + Math_fround(f8 * f45)) + Math_fround(f9 * f46))) <= f105)) {
     i63 = i6;
     break;
    }
    f79 = Math_fround(f59 - f45);
    f80 = Math_fround(f60 - f46);
    HEAPF32[i103 + (i6 * 12 | 0) >> 2] = Math_fround(f58 - f44);
    HEAPF32[i103 + (i6 * 12 | 0) + 4 >> 2] = f79;
    HEAPF32[i103 + (i6 * 12 | 0) + 8 >> 2] = f80;
    i63 = i6 + 1 | 0;
   } while (0);
   f78 = Math_fround(HEAPF32[i53 >> 2]);
   f80 = Math_fround(f10 * f78);
   f65 = Math_fround(f11 * f78);
   f78 = Math_fround(f13 * f78);
   f79 = Math_fround(HEAPF32[i25 >> 2]);
   f80 = Math_fround(f80 + Math_fround(f15 * f79));
   f13 = Math_fround(f65 + Math_fround(f16 * f79));
   f17 = Math_fround(f78 + Math_fround(f17 * f79));
   f79 = Math_fround(HEAPF32[i26 >> 2]);
   f80 = Math_fround(f80 + Math_fround(f18 * f79));
   f13 = Math_fround(f13 + Math_fround(f19 * f79));
   f79 = Math_fround(f17 + Math_fround(f20 * f79));
   f17 = Math_fround(Math_fround(f23 * f79) + Math_fround(Math_fround(f21 * f80) + Math_fround(f22 * f13)));
   f16 = Math_fround(Math_fround(f34 * f79) + Math_fround(Math_fround(f24 * f80) + Math_fround(f33 * f13)));
   f15 = Math_fround(Math_fround(f37 * f79) + Math_fround(Math_fround(f35 * f80) + Math_fround(f36 * f13)));
   f13 = Math_fround(Math_fround(HEAPF32[i53 + 12 >> 2]) - Math_fround(Math_fround(f40 * f79) + Math_fround(Math_fround(f38 * f80) + Math_fround(f39 * f13))));
   i32 = HEAP32[i54 >> 2] | 0;
   HEAP32[i104 >> 2] = 0;
   i47 = HEAP32[i112 + 32 >> 2] | 0;
   L78 : do if (!i5) i100 = 70; else {
    i48 = i108 + 4 | 0;
    i49 = i108 + 8 | 0;
    i50 = i108 + 12 | 0;
    i51 = i108 + 16 | 0;
    i52 = i108 + 20 | 0;
    i53 = i108 + 24 | 0;
    i54 = i108 + 28 | 0;
    i55 = i108 + 32 | 0;
    i56 = i102 + 4 | 0;
    i57 = i102 + 8 | 0;
    if (!i63) i100 = 70; else {
     i31 = i101;
     while (1) {
      i5 = i5 + -1 | 0;
      i25 = HEAP32[i31 >> 2] | 0;
      i14 = HEAPU16[i66 + (i25 * 20 | 0) + 16 >> 1] | 0;
      i25 = i66 + (i25 * 20 | 0) + 18 | 0;
      i12 = i63;
      i29 = i103;
      do {
       i12 = i12 + -1 | 0;
       i101 = HEAP8[i25 >> 0] | 0;
       i26 = i101 & 255;
       if (i101 << 24 >> 24) {
        i27 = i29 + 8 | 0;
        i28 = i29 + 4 | 0;
        i30 = 0;
        do {
         i101 = HEAPU8[i47 + (i30 + i14) >> 0] | 0;
         i30 = i30 + 1 | 0;
         i6 = HEAPU8[i47 + ((i30 >>> 0 >= i26 >>> 0 ? 0 : i30) + i14) >> 0] | 0;
         f8 = Math_fround(HEAPF32[i32 + (i101 * 12 | 0) >> 2]);
         f11 = Math_fround(f17 * f8);
         f9 = Math_fround(HEAPF32[i32 + (i101 * 12 | 0) + 4 >> 2]);
         f11 = Math_fround(f11 + Math_fround(f16 * f9));
         f10 = Math_fround(HEAPF32[i32 + (i101 * 12 | 0) + 8 >> 2]);
         i101 = !(Math_fround(f13 + Math_fround(f11 + Math_fround(f15 * f10))) <= f105);
         f11 = Math_fround(HEAPF32[i32 + (i6 * 12 | 0) >> 2]);
         if (i101) {
          f80 = Math_fround(f17 * f11);
          f7 = Math_fround(HEAPF32[i32 + (i6 * 12 | 0) + 4 >> 2]);
          f80 = Math_fround(f80 + Math_fround(f16 * f7));
          f2 = Math_fround(HEAPF32[i32 + (i6 * 12 | 0) + 8 >> 2]);
          if (Math_fround(f13 + Math_fround(f80 + Math_fround(f15 * f2))) <= f105) i100 = 63;
         } else {
          f7 = Math_fround(HEAPF32[i32 + (i6 * 12 | 0) + 4 >> 2]);
          f2 = Math_fround(HEAPF32[i32 + (i6 * 12 | 0) + 8 >> 2]);
          i100 = 63;
         }
         L91 : do if ((i100 | 0) == 63) {
          i100 = 0;
          f79 = Math_fround(f8 - f11);
          f78 = Math_fround(f9 - f7);
          f65 = Math_fround(f10 - f2);
          f10 = Math_fround(f79 * Math_fround(HEAPF32[i106 >> 2]));
          f9 = Math_fround(f79 * Math_fround(HEAPF32[i67 >> 2]));
          f2 = Math_fround(f79 * Math_fround(HEAPF32[i68 >> 2]));
          f79 = Math_fround(f78 * Math_fround(HEAPF32[i69 >> 2]));
          f80 = Math_fround(f78 * Math_fround(HEAPF32[i70 >> 2]));
          f79 = Math_fround(f10 + f79);
          f80 = Math_fround(f9 + f80);
          f2 = Math_fround(f2 + Math_fround(f78 * Math_fround(HEAPF32[i71 >> 2])));
          f78 = Math_fround(f65 * Math_fround(HEAPF32[i72 >> 2]));
          f9 = Math_fround(f65 * Math_fround(HEAPF32[i73 >> 2]));
          f78 = Math_fround(f79 + f78);
          f9 = Math_fround(f80 + f9);
          f65 = Math_fround(f2 + Math_fround(f65 * Math_fround(HEAPF32[i74 >> 2])));
          f2 = Math_fround(f78 * Math_fround(HEAPF32[i108 >> 2]));
          f80 = Math_fround(f78 * Math_fround(HEAPF32[i48 >> 2]));
          f78 = Math_fround(f78 * Math_fround(HEAPF32[i49 >> 2]));
          f79 = Math_fround(f9 * Math_fround(HEAPF32[i50 >> 2]));
          f10 = Math_fround(f9 * Math_fround(HEAPF32[i51 >> 2]));
          f79 = Math_fround(f2 + f79);
          f10 = Math_fround(f80 + f10);
          f9 = Math_fround(f78 + Math_fround(f9 * Math_fround(HEAPF32[i52 >> 2])));
          f78 = Math_fround(f65 * Math_fround(HEAPF32[i53 >> 2]));
          f80 = Math_fround(f65 * Math_fround(HEAPF32[i54 >> 2]));
          f78 = Math_fround(f79 + f78);
          f80 = Math_fround(f10 + f80);
          f65 = Math_fround(f9 + Math_fround(f65 * Math_fround(HEAPF32[i55 >> 2])));
          f9 = Math_fround(HEAPF32[i27 >> 2]);
          f10 = Math_fround(f80 * f9);
          f79 = Math_fround(HEAPF32[i28 >> 2]);
          f10 = Math_fround(f10 - Math_fround(f65 * f79));
          f2 = Math_fround(HEAPF32[i29 >> 2]);
          f9 = Math_fround(Math_fround(f65 * f2) - Math_fround(f78 * f9));
          f2 = Math_fround(Math_fround(f78 * f79) - Math_fround(f80 * f2));
          do if (!(+Math_fround(Math_abs(Math_fround(f10))) > 1.0e-06)) {
           if (+Math_fround(Math_abs(Math_fround(f9))) > 1.0e-06) break;
           if (!(+Math_fround(Math_abs(Math_fround(f2))) > 1.0e-06)) break L91;
          } while (0);
          f7 = Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)));
          if (f7 > Math_fround(0.0)) {
           f80 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
           f8 = Math_fround(f2 * f80);
           f7 = Math_fround(f9 * f80);
           f2 = Math_fround(f10 * f80);
          } else {
           f8 = Math_fround(0.0);
           f7 = Math_fround(0.0);
           f2 = Math_fround(0.0);
          }
          HEAPF32[i102 >> 2] = f2;
          HEAPF32[i56 >> 2] = f7;
          HEAPF32[i57 >> 2] = f8;
          __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E(i104, i102) | 0;
         } while (0);
        } while ((i30 | 0) != (i26 | 0));
       }
       i29 = i29 + 12 | 0;
      } while ((i12 | 0) != 0);
      if (!i5) break; else i31 = i31 + 4 | 0;
     }
     i5 = HEAP32[i104 >> 2] | 0;
     if (!i5) {
      i5 = 1;
      f2 = Math_fround(3402823469999999843913219.0e14);
     } else {
      f16 = Math_fround(HEAPF32[i107 >> 2]);
      f20 = Math_fround(HEAPF32[i109 >> 2]);
      f15 = Math_fround(f16 * f20);
      f21 = Math_fround(HEAPF32[i81 >> 2]);
      f10 = Math_fround(f16 * f21);
      f2 = Math_fround(HEAPF32[i82 >> 2]);
      f16 = Math_fround(f16 * f2);
      f78 = Math_fround(HEAPF32[i90 >> 2]);
      f7 = Math_fround(HEAPF32[i83 >> 2]);
      f80 = Math_fround(f78 * f7);
      f8 = Math_fround(HEAPF32[i84 >> 2]);
      f79 = Math_fround(f78 * f8);
      f9 = Math_fround(HEAPF32[i85 >> 2]);
      f80 = Math_fround(f15 + f80);
      f79 = Math_fround(f10 + f79);
      f78 = Math_fround(f16 + Math_fround(f78 * f9));
      f16 = Math_fround(HEAPF32[i91 >> 2]);
      f10 = Math_fround(HEAPF32[i86 >> 2]);
      f15 = Math_fround(f16 * f10);
      f11 = Math_fround(HEAPF32[i87 >> 2]);
      f23 = Math_fround(f16 * f11);
      f13 = Math_fround(HEAPF32[i88 >> 2]);
      f15 = Math_fround(f80 + f15);
      f23 = Math_fround(f79 + f23);
      f16 = Math_fround(f78 + Math_fround(f16 * f13));
      f78 = Math_fround(HEAPF32[i75 >> 2]);
      f15 = Math_fround(f15 + f78);
      f79 = Math_fround(HEAPF32[i76 >> 2]);
      f23 = Math_fround(f23 + f79);
      f80 = Math_fround(HEAPF32[i77 >> 2]);
      f16 = Math_fround(f16 + f80);
      HEAPF32[i113 >> 2] = f15;
      HEAPF32[i113 + 4 >> 2] = f23;
      HEAPF32[i113 + 8 >> 2] = f16;
      f19 = Math_fround(HEAPF32[i92 >> 2]);
      f17 = Math_fround(f20 * f19);
      f18 = Math_fround(f21 * f19);
      f19 = Math_fround(f2 * f19);
      f22 = Math_fround(HEAPF32[i93 >> 2]);
      f17 = Math_fround(f17 + Math_fround(f7 * f22));
      f18 = Math_fround(f18 + Math_fround(f8 * f22));
      f22 = Math_fround(f19 + Math_fround(f9 * f22));
      f19 = Math_fround(HEAPF32[i94 >> 2]);
      f17 = Math_fround(f78 + Math_fround(f17 + Math_fround(f10 * f19)));
      f18 = Math_fround(f79 + Math_fround(f18 + Math_fround(f11 * f19)));
      f19 = Math_fround(f80 + Math_fround(f22 + Math_fround(f13 * f19)));
      HEAPF32[i113 + 12 >> 2] = f17;
      HEAPF32[i113 + 16 >> 2] = f18;
      HEAPF32[i113 + 20 >> 2] = f19;
      f22 = Math_fround(HEAPF32[i95 >> 2]);
      f20 = Math_fround(f20 * f22);
      f21 = Math_fround(f21 * f22);
      f22 = Math_fround(f2 * f22);
      f2 = Math_fround(HEAPF32[i96 >> 2]);
      f20 = Math_fround(f20 + Math_fround(f7 * f2));
      f21 = Math_fround(f21 + Math_fround(f8 * f2));
      f2 = Math_fround(f22 + Math_fround(f9 * f2));
      f22 = Math_fround(HEAPF32[i97 >> 2]);
      f20 = Math_fround(f78 + Math_fround(f20 + Math_fround(f10 * f22)));
      f21 = Math_fround(f79 + Math_fround(f21 + Math_fround(f11 * f22)));
      f22 = Math_fround(f80 + Math_fround(f2 + Math_fround(f13 * f22)));
      HEAPF32[i113 + 24 >> 2] = f20;
      HEAPF32[i113 + 28 >> 2] = f21;
      HEAPF32[i113 + 32 >> 2] = f22;
      i26 = i112 + 4 | 0;
      i27 = i112 + 8 | 0;
      i28 = i112 + 44 | 0;
      i29 = i112 + 48 | 0;
      i30 = i112 + 52 | 0;
      i31 = i112 + 40 | 0;
      f2 = Math_fround(3402823469999999843913219.0e14);
      i14 = i104 + 4 | 0;
      while (1) {
       i5 = i5 + -1 | 0;
       i25 = i14 + 12 | 0;
       f62 = Math_fround(HEAPF32[i14 >> 2]);
       f61 = Math_fround(f62 * Math_fround(HEAPF32[i109 >> 2]));
       f80 = Math_fround(f62 * Math_fround(HEAPF32[i81 >> 2]));
       f62 = Math_fround(f62 * Math_fround(HEAPF32[i82 >> 2]));
       i12 = i14 + 4 | 0;
       f65 = Math_fround(HEAPF32[i12 >> 2]);
       f61 = Math_fround(f61 + Math_fround(f65 * f7));
       f80 = Math_fround(f80 + Math_fround(f65 * f8));
       f65 = Math_fround(f62 + Math_fround(f65 * f9));
       i6 = i14 + 8 | 0;
       f62 = Math_fround(HEAPF32[i6 >> 2]);
       f61 = Math_fround(f61 + Math_fround(f62 * f10));
       f80 = Math_fround(f80 + Math_fround(f62 * f11));
       f62 = Math_fround(f65 + Math_fround(f62 * f13));
       f65 = Math_fround(Math_fround(Math_fround(f15 * f61) + Math_fround(f80 * f23)) + Math_fround(f62 * f16));
       f64 = Math_fround(Math_fround(Math_fround(f61 * f17) + Math_fround(f80 * f18)) + Math_fround(f62 * f19));
       f79 = f65 < f64 ? f65 : f64;
       f64 = f65 > f64 ? f65 : f64;
       f65 = Math_fround(Math_fround(Math_fround(f61 * f20) + Math_fround(f80 * f21)) + Math_fround(f62 * f22));
       f78 = Math_fround(f61 * Math_fround(HEAPF32[i112 >> 2]));
       f78 = Math_fround(f78 + Math_fround(f80 * Math_fround(HEAPF32[i26 >> 2])));
       f78 = Math_fround(f78 + Math_fround(f62 * Math_fround(HEAPF32[i27 >> 2])));
       i102 = HEAP32[i28 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
       i103 = HEAP32[i29 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
       i104 = HEAP32[i30 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
       f61 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f80 = Math_fround(f61 + Math_fround(f80 * (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
       f62 = Math_fround(f80 + Math_fround(f62 * (HEAP32[tempDoublePtr >> 2] = i104, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
       f80 = Math_fround(HEAPF32[i31 >> 2]);
       f80 = f62 > f80 ? f62 : f80;
       f79 = Math_fround(Math_fround(f78 + f80) - (f79 < f65 ? f79 : f65));
       f80 = Math_fround((f64 > f65 ? f64 : f65) - Math_fround(f78 - f80));
       if (!((f79 < f80 ? f79 : f80) > f2)) {
        mftCall_viiiiii(HEAP32[i89 >> 2] | 0, i112 | 0, i14 | 0, i108 | 0, i106 | 0, i111 | 0, i110 | 0);
        f78 = Math_fround(HEAPF32[i107 >> 2]);
        f79 = Math_fround(HEAPF32[i14 >> 2]);
        f78 = Math_fround(f78 * f79);
        f9 = Math_fround(HEAPF32[i90 >> 2]);
        f80 = Math_fround(HEAPF32[i12 >> 2]);
        f9 = Math_fround(f78 + Math_fround(f9 * f80));
        f78 = Math_fround(HEAPF32[i91 >> 2]);
        f8 = Math_fround(HEAPF32[i6 >> 2]);
        f78 = Math_fround(f9 + Math_fround(f78 * f8));
        f9 = Math_fround(f79 * Math_fround(HEAPF32[i92 >> 2]));
        f9 = Math_fround(f9 + Math_fround(f80 * Math_fround(HEAPF32[i93 >> 2])));
        f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i94 >> 2])));
        f7 = f78 < f9 ? f78 : f9;
        f9 = f78 > f9 ? f78 : f9;
        f79 = Math_fround(f79 * Math_fround(HEAPF32[i95 >> 2]));
        f80 = Math_fround(f79 + Math_fround(f80 * Math_fround(HEAPF32[i96 >> 2])));
        f8 = Math_fround(f80 + Math_fround(f8 * Math_fround(HEAPF32[i97 >> 2])));
        f7 = f7 < f8 ? f7 : f8;
        f8 = f9 > f8 ? f9 : f8;
        f9 = Math_fround(HEAPF32[i110 >> 2]);
        if (Math_fround(f9 + f105) < f7) break;
        f80 = Math_fround(f8 + f105);
        f10 = Math_fround(HEAPF32[i111 >> 2]);
        if (f80 < f10) break;
        f80 = Math_fround(f9 - f7);
        f7 = Math_fround(f8 - f10);
        f7 = f80 < f7 ? f80 : f7;
        if (f7 < f2) {
         i1 = HEAP32[i6 >> 2] | 0;
         i4 = HEAP32[i12 >> 2] | 0;
         i3 = HEAP32[i14 >> 2] | 0;
         f2 = f7;
        }
       }
       if (!i5) {
        i5 = 1;
        break L78;
       }
       f15 = Math_fround(HEAPF32[i113 >> 2]);
       f7 = Math_fround(HEAPF32[i83 >> 2]);
       f8 = Math_fround(HEAPF32[i84 >> 2]);
       f9 = Math_fround(HEAPF32[i85 >> 2]);
       f10 = Math_fround(HEAPF32[i86 >> 2]);
       f11 = Math_fround(HEAPF32[i87 >> 2]);
       f13 = Math_fround(HEAPF32[i88 >> 2]);
       i14 = i25;
      }
      i5 = 0;
     }
    }
   } while (0);
   if ((i100 | 0) == 70) {
    i5 = 1;
    f2 = Math_fround(3402823469999999843913219.0e14);
   }
   if (!i5) {
    i117 = 0;
    STACKTOP = i118;
    return i117 | 0;
   }
   if (!(f2 < Math_fround(HEAPF32[i116 >> 2]))) {
    i117 = 1;
    STACKTOP = i118;
    return i117 | 0;
   }
   HEAPF32[i116 >> 2] = f2;
   f105 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f80 = Math_fround(f105 * Math_fround(HEAPF32[i117 >> 2]));
   f79 = Math_fround(f105 * Math_fround(HEAPF32[i117 + 4 >> 2]));
   f105 = Math_fround(f105 * Math_fround(HEAPF32[i117 + 8 >> 2]));
   f65 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f78 = Math_fround(f65 * Math_fround(HEAPF32[i117 + 12 >> 2]));
   f64 = Math_fround(f65 * Math_fround(HEAPF32[i117 + 16 >> 2]));
   f78 = Math_fround(f80 + f78);
   f64 = Math_fround(f79 + f64);
   f65 = Math_fround(f105 + Math_fround(f65 * Math_fround(HEAPF32[i117 + 20 >> 2])));
   f105 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f79 = Math_fround(f105 * Math_fround(HEAPF32[i117 + 24 >> 2]));
   f80 = Math_fround(f105 * Math_fround(HEAPF32[i117 + 28 >> 2]));
   f80 = Math_fround(f64 + f80);
   f105 = Math_fround(f65 + Math_fround(f105 * Math_fround(HEAPF32[i117 + 32 >> 2])));
   HEAPF32[i115 >> 2] = Math_fround(f78 + f79);
   HEAPF32[i98 >> 2] = f80;
   HEAPF32[i99 >> 2] = f105;
   HEAP8[i114 >> 0] = 0;
   i117 = 1;
   STACKTOP = i118;
   return i117 | 0;
  }
 }
 i117 = 0;
 STACKTOP = i118;
 return i117 | 0;
}

function __ZN5physx17updateIslandsMainEjPKjjS1_jS1_jS1_jS1_jS1_jRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEES8_jS8_S8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS2_13EventProfilerE(i67, i32, i33, i27, i28, i34, i35, i1, i2, i19, i20, i25, i26, i40, i5, i36, i6, i4, i51, i49, i50, i55, i66, i37, i3) {
 i67 = i67 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i40 = i40 | 0;
 i5 = i5 | 0;
 i36 = i36 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i51 = i51 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i55 = i55 | 0;
 i66 = i66 | 0;
 i37 = i37 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i29 = 0, i30 = 0, i31 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i68 = 0, i69 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 4096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i69;
 i45 = HEAP32[i37 + 72 >> 2] | 0;
 i41 = i45 + 4 | 0;
 _memset(HEAP32[i45 >> 2] | 0, 0, HEAP32[i41 >> 2] << 2 | 0) | 0;
 i46 = HEAP32[i37 + 76 >> 2] | 0;
 i47 = i46 + 4 | 0;
 _memset(HEAP32[i46 >> 2] | 0, 0, HEAP32[i47 >> 2] << 2 | 0) | 0;
 i44 = HEAP32[i37 + 80 >> 2] | 0;
 _memset(HEAP32[i44 >> 2] | 0, 0, HEAP32[i44 + 4 >> 2] << 2 | 0) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i44 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] & 2147483647;
 if (i1 | 0) {
  i2 = 0;
  do {
   i65 = i7 + (i2 << 2) | 0;
   HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | HEAP32[i3 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i5 + 4 >> 2] & 2147483647;
 if (i1 | 0) {
  i2 = 0;
  do {
   i65 = i7 + (i2 << 2) | 0;
   HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | HEAP32[i3 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] & 2147483647;
 if (i1 | 0) {
  i2 = 0;
  do {
   i65 = i7 + (i2 << 2) | 0;
   HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | HEAP32[i3 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i23 = (i28 | 0) == 0;
 if (!i23) {
  i1 = 0;
  do {
   i64 = HEAP32[i27 + (i1 << 2) >> 2] | 0;
   i65 = i7 + (i64 >>> 5 << 2) | 0;
   HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i64 & 31);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i28 | 0));
 }
 i48 = i50 + 4 | 0;
 i17 = HEAP32[i48 >> 2] | 0;
 i43 = i51 + 4 | 0;
 i16 = HEAP32[i43 >> 2] | 0;
 i24 = (i33 | 0) == 0;
 i15 = HEAP32[i45 >> 2] | 0;
 if (!i24) {
  i2 = 0;
  do {
   i1 = HEAP32[i32 + (i2 << 2) >> 2] | 0;
   if ((HEAP8[i16 + (i1 * 12 | 0) + 8 >> 0] & 96) == 32) {
    i64 = HEAP32[i16 + (i1 * 12 | 0) + 4 >> 2] | 0;
    i65 = i15 + (i64 >>> 5 << 2) | 0;
    HEAP32[i65 >> 2] = 1 << (i64 & 31) | HEAP32[i65 >> 2];
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i33 | 0));
 }
 i1 = HEAP32[i41 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i11 = 0;
   break;
  }
  i1 = HEAP32[i15 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i68 = 16;
   break;
  }
 }
 if ((i68 | 0) == 16) {
  i11 = i1 >>> 1 | i1;
  i11 = i11 >>> 2 | i11;
  i11 = i11 >>> 4 | i11;
  i11 = i11 >>> 8 | i11;
  i11 = (Math_imul(i11 >>> 16 | i11, 130329821) | 0) >>> 27;
  i11 = ((HEAP32[gb + 85120 + (i11 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i42 = i51 + 24 | 0;
 i14 = HEAP32[i42 >> 2] | 0;
 i13 = HEAP32[i46 >> 2] | 0;
 i1 = 0;
 i12 = 0;
 while (1) {
  i2 = HEAP32[i15 + (i12 << 2) >> 2] | 0;
  if (i2) {
   i10 = i12 << 5;
   do {
    i7 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
    i7 = HEAP32[gb + 90668 + (i7 << 2) >> 2] | i10;
    if (i1 >>> 0 < 1024) {
     HEAP32[i18 + (i1 << 2) >> 2] = i7;
     i1 = i1 + 1 | 0;
    } else {
     i9 = 0;
     do {
      i8 = HEAP32[i18 + (i9 << 2) >> 2] | 0;
      i4 = i17 + (i8 << 4) | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      L40 : do if ((i3 | 0) == -1) i68 = 25; else {
       while (1) {
        if (!(HEAP8[i16 + (i3 * 12 | 0) + 8 >> 0] & 32)) break;
        i65 = i14 + (i3 << 2) | 0;
        i3 = HEAP32[i65 >> 2] | 0;
        HEAP32[i65 >> 2] = -1;
        if ((i3 | 0) == -1) {
         i68 = 25;
         break L40;
        }
       }
       HEAP32[i4 >> 2] = i3;
       i4 = i14 + (i3 << 2) | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       L45 : do if ((i5 | 0) != -1) {
        i6 = i3;
        L46 : while (1) {
         i3 = i5;
         while (1) {
          if (!(HEAP8[i16 + (i3 * 12 | 0) + 8 >> 0] & 32)) break;
          i65 = i14 + (i3 << 2) | 0;
          i3 = HEAP32[i65 >> 2] | 0;
          HEAP32[i65 >> 2] = -1;
          if ((i3 | 0) == -1) {
           i3 = i6;
           break L46;
          }
         }
         HEAP32[i4 >> 2] = i3;
         i4 = i14 + (i3 << 2) | 0;
         i5 = HEAP32[i4 >> 2] | 0;
         if ((i5 | 0) == -1) break L45; else i6 = i3;
        }
        HEAP32[i4 >> 2] = -1;
        HEAP32[i17 + (i8 << 4) + 8 >> 2] = i3;
        if ((i3 | 0) == -1) {
         i68 = 33;
         break L40;
        } else break L40;
       } while (0);
       HEAP32[i4 >> 2] = -1;
       HEAP32[i17 + (i8 << 4) + 8 >> 2] = i3;
      } while (0);
      if ((i68 | 0) == 25) {
       HEAP32[i4 >> 2] = -1;
       HEAP32[i17 + (i8 << 4) + 8 >> 2] = -1;
       i68 = 33;
      }
      if ((i68 | 0) == 33) {
       i68 = 0;
       i65 = i13 + (i8 >>> 5 << 2) | 0;
       HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i8 & 31);
      }
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i1 | 0));
     HEAP32[i18 >> 2] = i7;
     i1 = 1;
    }
    i2 = i2 + -1 & i2;
   } while ((i2 | 0) != 0);
  }
  if ((i12 | 0) == (i11 | 0)) break; else i12 = i12 + 1 | 0;
 }
 if (i1 | 0) {
  i7 = 0;
  do {
   i6 = HEAP32[i18 + (i7 << 2) >> 2] | 0;
   i3 = i17 + (i6 << 4) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   L66 : do if ((i2 | 0) == -1) i68 = 42; else {
    while (1) {
     if (!(HEAP8[i16 + (i2 * 12 | 0) + 8 >> 0] & 32)) break;
     i65 = i14 + (i2 << 2) | 0;
     i2 = HEAP32[i65 >> 2] | 0;
     HEAP32[i65 >> 2] = -1;
     if ((i2 | 0) == -1) {
      i68 = 42;
      break L66;
     }
    }
    HEAP32[i3 >> 2] = i2;
    i3 = i14 + (i2 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    L71 : do if ((i4 | 0) != -1) {
     i5 = i2;
     L72 : while (1) {
      i2 = i4;
      while (1) {
       if (!(HEAP8[i16 + (i2 * 12 | 0) + 8 >> 0] & 32)) break;
       i65 = i14 + (i2 << 2) | 0;
       i2 = HEAP32[i65 >> 2] | 0;
       HEAP32[i65 >> 2] = -1;
       if ((i2 | 0) == -1) {
        i2 = i5;
        break L72;
       }
      }
      HEAP32[i3 >> 2] = i2;
      i3 = i14 + (i2 << 2) | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == -1) break L71; else i5 = i2;
     }
     HEAP32[i3 >> 2] = -1;
     HEAP32[i17 + (i6 << 4) + 8 >> 2] = i2;
     if ((i2 | 0) == -1) {
      i68 = 50;
      break L66;
     } else break L66;
    } while (0);
    HEAP32[i3 >> 2] = -1;
    HEAP32[i17 + (i6 << 4) + 8 >> 2] = i2;
   } while (0);
   if ((i68 | 0) == 42) {
    HEAP32[i3 >> 2] = -1;
    HEAP32[i17 + (i6 << 4) + 8 >> 2] = -1;
    i68 = 50;
   }
   if ((i68 | 0) == 50) {
    i68 = 0;
    i65 = i13 + (i6 >>> 5 << 2) | 0;
    HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i6 & 31);
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
 }
 _memset(i15 | 0, 0, HEAP32[i41 >> 2] << 2 | 0) | 0;
 __ZL28removeBrokenEdgesFromIslandsPKjjS0_jS0_RKN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerERNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEEPSD_(i19, i20, i34, i35, 0, i51, i49, i50, i45, i44);
 i5 = HEAP32[i46 >> 2] | 0;
 i1 = HEAP32[i47 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i2 = 1;
   break;
  }
  i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i68 = 55;
   break;
  }
 }
 if ((i68 | 0) == 55) {
  i65 = i1 >>> 1 | i1;
  i65 = i65 >>> 2 | i65;
  i65 = i65 >>> 4 | i65;
  i65 = i65 >>> 8 | i65;
  i65 = (Math_imul(i65 >>> 16 | i65, 130329821) | 0) >>> 27;
  i2 = (((HEAP32[gb + 85120 + (i65 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5) + 1 | 0;
 }
 i19 = i50 + 16 | 0;
 i20 = i50 + 8 | 0;
 i21 = i50 + 20 | 0;
 i22 = i50 + 36 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
  if (i1 | 0) {
   i3 = i4 << 5;
   do {
    i64 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i64 = HEAP32[gb + 90668 + (i64 << 2) >> 2] | 0;
    i65 = i64 | i3;
    i63 = (HEAP32[i48 >> 2] | 0) + (i65 << 4) | 0;
    HEAP32[i63 >> 2] = -1;
    HEAP32[i63 + 4 >> 2] = -1;
    HEAP32[i63 + 8 >> 2] = -1;
    HEAP32[i63 + 12 >> 2] = -1;
    HEAP32[(HEAP32[i20 >> 2] | 0) + (i65 << 2) >> 2] = HEAP32[i19 >> 2];
    HEAP32[i19 >> 2] = i65;
    HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
    i64 = ~(1 << (i64 & 31));
    i65 = i65 >>> 5;
    i63 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i65 << 2) | 0;
    HEAP32[i63 >> 2] = HEAP32[i63 >> 2] & i64;
    i65 = (HEAP32[i45 >> 2] | 0) + (i65 << 2) | 0;
    HEAP32[i65 >> 2] = HEAP32[i65 >> 2] & i64;
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i2 | 0));
 _memset(HEAP32[i46 >> 2] | 0, 0, HEAP32[i47 >> 2] << 2 | 0) | 0;
 i29 = i37 + 84 | 0;
 i15 = HEAP32[i29 >> 2] | 0;
 i30 = i37 + 88 | 0;
 i16 = HEAP32[i30 >> 2] | 0;
 i31 = i37 + 92 | 0;
 i17 = HEAP32[i31 >> 2] | 0;
 i18 = HEAP32[i43 >> 2] | 0;
 i38 = i49 + 4 | 0;
 i12 = HEAP32[i38 >> 2] | 0;
 i13 = HEAP32[i42 >> 2] | 0;
 i39 = i49 + 24 | 0;
 i14 = HEAP32[i39 >> 2] | 0;
 i11 = HEAP32[i50 + 12 >> 2] << 2;
 _memset(i15 | 0, -1, i11 | 0) | 0;
 _memset(i16 | 0, -1, i11 | 0) | 0;
 _memset(i17 | 0, -1, i11 | 0) | 0;
 i11 = (i26 | 0) == 0;
 if (!i11) {
  i5 = 0;
  do {
   i1 = HEAP32[i25 + (i5 << 2) >> 2] | 0;
   do if (!(HEAP32[i12 + (i1 * 12 | 0) + 8 >> 2] & 8)) {
    i2 = HEAP32[i12 + (i1 * 12 | 0) >> 2] | 0;
    do if ((i2 | 0) != -1) {
     i3 = (HEAP32[i44 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i2 & 31);
     i3 = i18 + (i2 * 12 | 0) + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) == -1) {
      i63 = HEAP32[i19 >> 2] | 0;
      i64 = (HEAP32[i20 >> 2] | 0) + (i63 << 2) | 0;
      HEAP32[i19 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i64 >> 2] = -1;
      i64 = (HEAP32[i48 >> 2] | 0) + (i63 << 4) | 0;
      HEAP32[i64 >> 2] = -1;
      HEAP32[i64 + 4 >> 2] = -1;
      HEAP32[i64 + 8 >> 2] = -1;
      HEAP32[i64 + 12 >> 2] = -1;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + -1;
      i64 = 1 << (i63 & 31);
      i65 = i63 >>> 5;
      i62 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i65 << 2) | 0;
      HEAP32[i62 >> 2] = HEAP32[i62 >> 2] | i64;
      i62 = HEAP32[i48 >> 2] | 0;
      HEAP32[i3 >> 2] = i63;
      i61 = i62 + (i63 << 4) | 0;
      HEAP32[i13 + (i2 << 2) >> 2] = HEAP32[i61 >> 2];
      HEAP32[i61 >> 2] = i2;
      i63 = i62 + (i63 << 4) + 8 | 0;
      i62 = HEAP32[i63 >> 2] | 0;
      HEAP32[i63 >> 2] = (i62 | 0) == -1 ? i2 : i62;
      i65 = (HEAP32[i46 >> 2] | 0) + (i65 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | i64;
      break;
     } else {
      i65 = (HEAP32[i46 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i4 & 31);
      break;
     }
    } while (0);
    i1 = HEAP32[i12 + (i1 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i2 = (HEAP32[i44 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
     HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i1 & 31);
     i2 = i18 + (i1 * 12 | 0) + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) == -1) {
      i63 = HEAP32[i19 >> 2] | 0;
      i64 = (HEAP32[i20 >> 2] | 0) + (i63 << 2) | 0;
      HEAP32[i19 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i64 >> 2] = -1;
      i64 = (HEAP32[i48 >> 2] | 0) + (i63 << 4) | 0;
      HEAP32[i64 >> 2] = -1;
      HEAP32[i64 + 4 >> 2] = -1;
      HEAP32[i64 + 8 >> 2] = -1;
      HEAP32[i64 + 12 >> 2] = -1;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + -1;
      i64 = 1 << (i63 & 31);
      i65 = i63 >>> 5;
      i62 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i65 << 2) | 0;
      HEAP32[i62 >> 2] = HEAP32[i62 >> 2] | i64;
      i62 = HEAP32[i48 >> 2] | 0;
      HEAP32[i2 >> 2] = i63;
      i61 = i62 + (i63 << 4) | 0;
      HEAP32[i13 + (i1 << 2) >> 2] = HEAP32[i61 >> 2];
      HEAP32[i61 >> 2] = i1;
      i63 = i62 + (i63 << 4) + 8 | 0;
      i62 = HEAP32[i63 >> 2] | 0;
      HEAP32[i63 >> 2] = (i62 | 0) == -1 ? i1 : i62;
      i65 = (HEAP32[i46 >> 2] | 0) + (i65 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | i64;
      break;
     } else {
      i65 = (HEAP32[i46 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i3 & 31);
      break;
     }
    }
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i26 | 0));
 }
 i10 = HEAP32[i46 >> 2] | 0;
 i1 = HEAP32[i47 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i7 = 0;
   break;
  }
  i1 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i68 = 75;
   break;
  }
 }
 if ((i68 | 0) == 75) {
  i7 = i1 >>> 1 | i1;
  i7 = i7 >>> 2 | i7;
  i7 = i7 >>> 4 | i7;
  i7 = i7 >>> 8 | i7;
  i7 = (Math_imul(i7 >>> 16 | i7, 130329821) | 0) >>> 27;
  i7 = ((HEAP32[gb + 85120 + (i7 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i8 = HEAP32[i48 >> 2] | 0;
 i2 = -1;
 i3 = -1;
 i9 = 0;
 while (1) {
  i1 = HEAP32[i10 + (i9 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i6 = i9 << 5;
   i5 = i2;
   while (1) {
    i4 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i6;
    i2 = HEAP32[i8 + (i4 << 4) >> 2] | 0;
    if ((i5 | 0) == -1) i3 = i2; else HEAP32[i15 + (HEAP32[i8 + (i5 << 4) + 8 >> 2] << 2) >> 2] = i2;
    if ((i2 | 0) != -1) do {
     i65 = HEAP32[i18 + (i2 * 12 | 0) + 4 >> 2] | 0;
     i64 = i2;
     i2 = HEAP32[i13 + (i2 << 2) >> 2] | 0;
     HEAP32[i15 + (i64 << 2) >> 2] = i2;
     HEAP32[i16 + (i64 << 2) >> 2] = i65;
     HEAP32[i17 + (i65 << 2) >> 2] = -1;
    } while ((i2 | 0) != -1);
    i1 = i1 + -1 & i1;
    if (!i1) {
     i1 = i4;
     break;
    } else i5 = i4;
   }
  }
  if ((i9 | 0) == (i7 | 0)) break; else {
   i2 = i1;
   i9 = i9 + 1 | 0;
  }
 }
 if (!i11) {
  i7 = 0;
  do {
   i6 = HEAP32[i25 + (i7 << 2) >> 2] | 0;
   do if (!(HEAP32[i12 + (i6 * 12 | 0) + 8 >> 2] & 8)) {
    i1 = HEAP32[i12 + (i6 * 12 | 0) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = -1; else {
     i1 = HEAP32[i16 + (i1 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) i1 = -1; else while (1) {
      i2 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
      if ((i2 | 0) == -1) break; else i1 = i2;
     }
    }
    i2 = HEAP32[i12 + (i6 * 12 | 0) + 4 >> 2] | 0;
    if ((i2 | 0) != -1) {
     i2 = HEAP32[i16 + (i2 << 2) >> 2] | 0;
     if ((i2 | 0) != -1) {
      while (1) {
       i4 = i17 + (i2 << 2) | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) == -1) break; else i2 = i5;
      }
      i5 = HEAP32[i48 >> 2] | 0;
      if ((i1 | 0) == -1) {
       i65 = i5 + (i2 << 4) + 4 | 0;
       HEAP32[i14 + (i6 << 2) >> 2] = HEAP32[i65 >> 2];
       HEAP32[i65 >> 2] = i6;
       i65 = i5 + (i2 << 4) + 12 | 0;
       i64 = HEAP32[i65 >> 2] | 0;
       HEAP32[i65 >> 2] = (i64 | 0) == -1 ? i6 : i64;
       break;
      }
      i65 = i5 + (i1 << 4) + 4 | 0;
      HEAP32[i14 + (i6 << 2) >> 2] = HEAP32[i65 >> 2];
      HEAP32[i65 >> 2] = i6;
      i65 = i5 + (i1 << 4) + 12 | 0;
      i64 = HEAP32[i65 >> 2] | 0;
      HEAP32[i65 >> 2] = (i64 | 0) == -1 ? i6 : i64;
      if ((i1 | 0) == (i2 | 0)) break;
      HEAP32[i4 >> 2] = i1;
      i6 = HEAP32[i48 >> 2] | 0;
      i4 = i6 + (i1 << 4) + 4 | 0;
      i5 = HEAP32[i6 + (i2 << 4) + 4 >> 2] | 0;
      do if ((HEAP32[i4 >> 2] | 0) == -1) {
       HEAP32[i4 >> 2] = i5;
       HEAP32[i6 + (i1 << 4) + 12 >> 2] = HEAP32[i6 + (i2 << 4) + 12 >> 2];
      } else {
       if ((i5 | 0) == -1) break;
       i65 = i6 + (i1 << 4) + 12 | 0;
       HEAP32[i14 + (HEAP32[i65 >> 2] << 2) >> 2] = i5;
       HEAP32[i65 >> 2] = HEAP32[i6 + (i2 << 4) + 12 >> 2];
      } while (0);
      i4 = i6 + (i1 << 4) | 0;
      i5 = HEAP32[i6 + (i2 << 4) >> 2] | 0;
      do if ((HEAP32[i4 >> 2] | 0) == -1) {
       HEAP32[i4 >> 2] = i5;
       HEAP32[i6 + (i1 << 4) + 8 >> 2] = HEAP32[i6 + (i2 << 4) + 8 >> 2];
      } else {
       if ((i5 | 0) == -1) break;
       i65 = i6 + (i1 << 4) + 8 | 0;
       HEAP32[i13 + (HEAP32[i65 >> 2] << 2) >> 2] = i5;
       HEAP32[i65 >> 2] = HEAP32[i6 + (i2 << 4) + 8 >> 2];
      } while (0);
      i65 = i6 + (i2 << 4) | 0;
      HEAP32[i65 >> 2] = -1;
      HEAP32[i65 + 4 >> 2] = -1;
      HEAP32[i65 + 8 >> 2] = -1;
      HEAP32[i65 + 12 >> 2] = -1;
      HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i2;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
      i65 = 1 << (i2 & 31);
      i5 = ~i65;
      i4 = i2 >>> 5;
      i2 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i4 << 2) | 0;
      HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & i5;
      i2 = HEAP32[i45 >> 2] | 0;
      i4 = i2 + (i4 << 2) | 0;
      if (!(HEAP32[i4 >> 2] & i65)) break;
      i65 = i2 + (i1 >>> 5 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i1 & 31);
      HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & i5;
      break;
     }
    }
    if ((i1 | 0) != -1) {
     i65 = HEAP32[i48 >> 2] | 0;
     i64 = i65 + (i1 << 4) + 4 | 0;
     HEAP32[i14 + (i6 << 2) >> 2] = HEAP32[i64 >> 2];
     HEAP32[i64 >> 2] = i6;
     i65 = i65 + (i1 << 4) + 12 | 0;
     i64 = HEAP32[i65 >> 2] | 0;
     HEAP32[i65 >> 2] = (i64 | 0) == -1 ? i6 : i64;
    }
   } while (0);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i26 | 0));
 }
 if ((i3 | 0) != -1) do {
  i1 = HEAP32[i16 + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = -1; else while (1) {
   i2 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) == -1) break; else i1 = i2;
  }
  HEAP32[i18 + (i3 * 12 | 0) + 4 >> 2] = i1;
  i3 = HEAP32[i15 + (i3 << 2) >> 2] | 0;
 } while ((i3 | 0) != -1);
 _memset(HEAP32[i46 >> 2] | 0, 0, HEAP32[i47 >> 2] << 2 | 0) | 0;
 i4 = HEAP32[i43 >> 2] | 0;
 i5 = HEAP32[i42 >> 2] | 0;
 if (!i23) {
  i3 = 0;
  do {
   i1 = HEAP32[i27 + (i3 << 2) >> 2] | 0;
   i64 = i4 + (i1 * 12 | 0) + 8 | 0;
   i65 = HEAP8[i64 >> 0] | 0;
   HEAP8[i64 >> 0] = i65 & 191;
   if (!(i65 & 32)) {
    i2 = i4 + (i1 * 12 | 0) + 4 | 0;
    if ((HEAP32[i2 >> 2] | 0) == -1) {
     i65 = HEAP32[i19 >> 2] | 0;
     i64 = (HEAP32[i20 >> 2] | 0) + (i65 << 2) | 0;
     HEAP32[i19 >> 2] = HEAP32[i64 >> 2];
     HEAP32[i64 >> 2] = -1;
     i64 = (HEAP32[i48 >> 2] | 0) + (i65 << 4) | 0;
     HEAP32[i64 >> 2] = -1;
     HEAP32[i64 + 4 >> 2] = -1;
     HEAP32[i64 + 8 >> 2] = -1;
     HEAP32[i64 + 12 >> 2] = -1;
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + -1;
     i64 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i65 >>> 5 << 2) | 0;
     HEAP32[i64 >> 2] = HEAP32[i64 >> 2] | 1 << (i65 & 31);
     i64 = HEAP32[i48 >> 2] | 0;
     HEAP32[i2 >> 2] = i65;
     i63 = i64 + (i65 << 4) | 0;
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i63 >> 2];
     HEAP32[i63 >> 2] = i1;
     i65 = i64 + (i65 << 4) + 8 | 0;
     i64 = HEAP32[i65 >> 2] | 0;
     HEAP32[i65 >> 2] = (i64 | 0) == -1 ? i1 : i64;
    }
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i28 | 0));
 }
 if (!i24) {
  i1 = i51 + 16 | 0;
  i2 = i51 + 8 | 0;
  i3 = i51 + 20 | 0;
  i4 = 0;
  do {
   i64 = HEAP32[i32 + (i4 << 2) >> 2] | 0;
   i65 = HEAP32[i43 >> 2] | 0;
   HEAP32[i65 + (i64 * 12 | 0) >> 2] = 0;
   HEAP32[i65 + (i64 * 12 | 0) + 4 >> 2] = -1;
   HEAP8[i65 + (i64 * 12 | 0) + 8 >> 0] = 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i64 << 2) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i64;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i65 = (HEAP32[i44 >> 2] | 0) + (i64 >>> 5 << 2) | 0;
   HEAP32[i65 >> 2] = HEAP32[i65 >> 2] & ~(1 << (i64 & 31));
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i33 | 0));
 }
 if (i35 | 0) {
  i1 = i49 + 16 | 0;
  i2 = i49 + 8 | 0;
  i3 = i49 + 20 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = 0;
  do {
   i65 = i4;
   i4 = HEAP32[i34 + (i5 << 2) >> 2] | 0;
   i64 = HEAP32[i38 >> 2] | 0;
   HEAP32[i64 + (i4 * 12 | 0) >> 2] = -1;
   HEAP32[i64 + (i4 * 12 | 0) + 4 >> 2] = -1;
   HEAP32[i64 + (i4 * 12 | 0) + 8 >> 2] = 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i65;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i35 | 0));
 }
 if (!i36) i1 = i37 + 4 | 0; else {
  __Z22updateIslandsToProcessRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjRKNS_11NodeManagerERS4_(i44, 0, i51, i46);
  i21 = HEAP32[i37 >> 2] | 0;
  i1 = i37 + 4 | 0;
  i25 = HEAP32[i1 >> 2] | 0;
  i18 = HEAP32[i37 + 8 >> 2] | 0;
  i22 = HEAP32[i29 >> 2] | 0;
  i12 = i51 + 12 | 0;
  i2 = (HEAP32[i12 >> 2] | 0) >>> 5;
  _memset(i22 | 0, 0, i2 << 2 | 0) | 0;
  i23 = HEAP32[i43 >> 2] | 0;
  i24 = HEAP32[i42 >> 2] | 0;
  i19 = HEAP32[i38 >> 2] | 0;
  i20 = HEAP32[i39 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] << 2;
  _memset(i21 | 0, -1, i12 | 0) | 0;
  _memset(i25 | 0, -1, i12 | 0) | 0;
  _memset(i18 | 0, -1, i12 | 0) | 0;
  i12 = HEAP32[i40 >> 2] | 0;
  i3 = HEAP32[i40 + 4 >> 2] & 2147483647;
  while (1) {
   i4 = i3 + -1 | 0;
   if (!i3) {
    i8 = 0;
    break;
   }
   i3 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
   if (!i3) i3 = i4; else {
    i68 = 129;
    break;
   }
  }
  if ((i68 | 0) == 129) {
   i8 = i3 >>> 1 | i3;
   i8 = i8 >>> 2 | i8;
   i8 = i8 >>> 4 | i8;
   i8 = i8 >>> 8 | i8;
   i8 = (Math_imul(i8 >>> 16 | i8, 130329821) | 0) >>> 27;
   i8 = ((HEAP32[gb + 85120 + (i8 << 2) >> 2] | 0) + (i4 << 5) | 0) >>> 5;
  }
  i9 = HEAP32[i46 >> 2] | 0;
  i13 = HEAP32[i45 >> 2] | 0;
  i11 = 0;
  while (1) {
   i3 = HEAP32[i12 + (i11 << 2) >> 2] | 0;
   if (i3 | 0) {
    i10 = i11 << 5;
    do {
     i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | 0;
     i5 = i4 | i10;
     i7 = HEAP32[i23 + (i5 * 12 | 0) + 4 >> 2] | 0;
     i6 = i7 >>> 5;
     i7 = 1 << (i7 & 31);
     if (i7 & HEAP32[i9 + (i6 << 2) >> 2] | 0) {
      i65 = i13 + (i6 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | i7;
      i65 = i23 + (i5 * 12 | 0) + 8 | 0;
      HEAP8[i65 >> 0] = HEAPU8[i65 >> 0] | 0 | 32;
      i65 = i22 + (i5 >>> 5 << 2) | 0;
      HEAP32[i65 >> 2] = HEAP32[i65 >> 2] | 1 << (i4 & 31);
     }
     i3 = i3 + -1 & i3;
    } while ((i3 | 0) != 0);
   }
   if ((i11 | 0) == (i8 | 0)) break; else i11 = i11 + 1 | 0;
  }
  i3 = HEAP32[i41 >> 2] & 2147483647;
  while (1) {
   i4 = i3 + -1 | 0;
   if (!i3) {
    i14 = 0;
    break;
   }
   i3 = HEAP32[i13 + (i4 << 2) >> 2] | 0;
   if (!i3) i3 = i4; else {
    i68 = 140;
    break;
   }
  }
  if ((i68 | 0) == 140) {
   i14 = i3 >>> 1 | i3;
   i14 = i14 >>> 2 | i14;
   i14 = i14 >>> 4 | i14;
   i14 = i14 >>> 8 | i14;
   i14 = (Math_imul(i14 >>> 16 | i14, 130329821) | 0) >>> 27;
   i14 = ((HEAP32[gb + 85120 + (i14 << 2) >> 2] | 0) + (i4 << 5) | 0) >>> 5;
  }
  i15 = i51 + 16 | 0;
  i16 = i51 + 8 | 0;
  i17 = i51 + 20 | 0;
  i3 = i13;
  i12 = 0;
  while (1) {
   i3 = HEAP32[i3 + (i12 << 2) >> 2] | 0;
   if (i3 | 0) {
    i11 = i12 << 5;
    do {
     i10 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i10 = HEAP32[gb + 90668 + (i10 << 2) >> 2] | i11;
     i9 = HEAP32[i48 >> 2] | 0;
     i7 = HEAP32[i43 >> 2] | 0;
     i8 = HEAP32[i42 >> 2] | 0;
     i5 = i9 + (i10 << 4) | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     L230 : do if ((i4 | 0) == -1) i68 = 147; else {
      while (1) {
       if (!(HEAP8[i7 + (i4 * 12 | 0) + 8 >> 0] & 32)) break;
       i65 = i8 + (i4 << 2) | 0;
       i4 = HEAP32[i65 >> 2] | 0;
       HEAP32[i65 >> 2] = -1;
       if ((i4 | 0) == -1) {
        i68 = 147;
        break L230;
       }
      }
      HEAP32[i5 >> 2] = i4;
      i6 = i8 + (i4 << 2) | 0;
      i5 = HEAP32[i6 >> 2] | 0;
      L235 : do if ((i5 | 0) != -1) do {
       while (1) {
        if (!(HEAP8[i7 + (i5 * 12 | 0) + 8 >> 0] & 32)) {
         i4 = i5;
         break;
        }
        i65 = i8 + (i5 << 2) | 0;
        i5 = HEAP32[i65 >> 2] | 0;
        HEAP32[i65 >> 2] = -1;
        if ((i5 | 0) == -1) break L235;
       }
       HEAP32[i6 >> 2] = i4;
       i6 = i8 + (i4 << 2) | 0;
       i5 = HEAP32[i6 >> 2] | 0;
      } while ((i5 | 0) != -1); while (0);
      HEAP32[i6 >> 2] = -1;
     } while (0);
     if ((i68 | 0) == 147) {
      i68 = 0;
      HEAP32[i5 >> 2] = -1;
      i4 = -1;
     }
     HEAP32[i9 + (i10 << 4) + 8 >> 2] = i4;
     i4 = HEAP32[i9 + (i10 << 4) + 4 >> 2] | 0;
     if ((i4 | 0) != -1) do {
      i5 = i19 + (i4 * 12 | 0) | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      do if ((i6 | 0) != -1) {
       i7 = i23 + (i6 * 12 | 0) + 8 | 0;
       if (!(HEAP8[i7 >> 0] & 1)) break;
       i65 = HEAP32[i15 >> 2] | 0;
       i64 = (HEAP32[i16 >> 2] | 0) + (i65 << 2) | 0;
       HEAP32[i15 >> 2] = HEAP32[i64 >> 2];
       HEAP32[i64 >> 2] = -1;
       i64 = HEAP32[i43 >> 2] | 0;
       HEAP32[i64 + (i65 * 12 | 0) >> 2] = 0;
       HEAP32[i64 + (i65 * 12 | 0) + 4 >> 2] = -1;
       HEAP8[i64 + (i65 * 12 | 0) + 8 >> 0] = 0;
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
       HEAP32[i21 + (i65 << 2) >> 2] = i6;
       i64 = i18 + (i6 << 2) | 0;
       i63 = HEAP32[i64 >> 2] | 0;
       HEAP32[i25 + (((i63 | 0) == -1 ? i6 : i63) << 2) >> 2] = i65;
       HEAP32[i25 + (i65 << 2) >> 2] = -1;
       HEAP32[i64 >> 2] = i65;
       HEAP32[i23 + (i65 * 12 | 0) >> 2] = HEAP32[i23 + (i6 * 12 | 0) >> 2];
       HEAP8[i23 + (i65 * 12 | 0) + 8 >> 0] = (HEAPU8[i7 >> 0] | 0) & 223;
       i64 = HEAP32[i48 >> 2] | 0;
       HEAP32[i23 + (i65 * 12 | 0) + 4 >> 2] = i10;
       i63 = i64 + (i10 << 4) | 0;
       HEAP32[i24 + (i65 << 2) >> 2] = HEAP32[i63 >> 2];
       HEAP32[i63 >> 2] = i65;
       i64 = i64 + (i10 << 4) + 8 | 0;
       i63 = HEAP32[i64 >> 2] | 0;
       HEAP32[i64 >> 2] = (i63 | 0) == -1 ? i65 : i63;
       HEAP32[i5 >> 2] = i65;
      } while (0);
      i5 = i19 + (i4 * 12 | 0) + 4 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      do if ((i6 | 0) != -1) {
       i7 = i23 + (i6 * 12 | 0) + 8 | 0;
       if (!(HEAP8[i7 >> 0] & 1)) break;
       i65 = HEAP32[i15 >> 2] | 0;
       i64 = (HEAP32[i16 >> 2] | 0) + (i65 << 2) | 0;
       HEAP32[i15 >> 2] = HEAP32[i64 >> 2];
       HEAP32[i64 >> 2] = -1;
       i64 = HEAP32[i43 >> 2] | 0;
       HEAP32[i64 + (i65 * 12 | 0) >> 2] = 0;
       HEAP32[i64 + (i65 * 12 | 0) + 4 >> 2] = -1;
       HEAP8[i64 + (i65 * 12 | 0) + 8 >> 0] = 0;
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
       HEAP32[i21 + (i65 << 2) >> 2] = i6;
       i64 = i18 + (i6 << 2) | 0;
       i63 = HEAP32[i64 >> 2] | 0;
       HEAP32[i25 + (((i63 | 0) == -1 ? i6 : i63) << 2) >> 2] = i65;
       HEAP32[i25 + (i65 << 2) >> 2] = -1;
       HEAP32[i64 >> 2] = i65;
       HEAP32[i23 + (i65 * 12 | 0) >> 2] = HEAP32[i23 + (i6 * 12 | 0) >> 2];
       HEAP8[i23 + (i65 * 12 | 0) + 8 >> 0] = (HEAPU8[i7 >> 0] | 0) & 223;
       i64 = HEAP32[i48 >> 2] | 0;
       HEAP32[i23 + (i65 * 12 | 0) + 4 >> 2] = i10;
       i63 = i64 + (i10 << 4) | 0;
       HEAP32[i24 + (i65 << 2) >> 2] = HEAP32[i63 >> 2];
       HEAP32[i63 >> 2] = i65;
       i64 = i64 + (i10 << 4) + 8 | 0;
       i63 = HEAP32[i64 >> 2] | 0;
       HEAP32[i64 >> 2] = (i63 | 0) == -1 ? i65 : i63;
       HEAP32[i5 >> 2] = i65;
      } while (0);
      i4 = HEAP32[i20 + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i3 = i3 + -1 & i3;
    } while ((i3 | 0) != 0);
   }
   if ((i12 | 0) == (i14 | 0)) break;
   i3 = HEAP32[i45 >> 2] | 0;
   i12 = i12 + 1 | 0;
  }
  while (1) {
   i3 = i2 + -1 | 0;
   if (!i2) {
    i6 = 1;
    break;
   }
   i2 = HEAP32[i22 + (i3 << 2) >> 2] | 0;
   if (!i2) i2 = i3; else {
    i68 = 167;
    break;
   }
  }
  if ((i68 | 0) == 167) {
   i6 = i2 >>> 1 | i2;
   i6 = i6 >>> 2 | i6;
   i6 = i6 >>> 4 | i6;
   i6 = i6 >>> 8 | i6;
   i6 = (Math_imul(i6 >>> 16 | i6, 130329821) | 0) >>> 27;
   i6 = (((HEAP32[gb + 85120 + (i6 << 2) >> 2] | 0) + (i3 << 5) | 0) >>> 5) + 1 | 0;
  }
  i7 = HEAP32[i48 >> 2] | 0;
  i9 = 0;
  do {
   i2 = HEAP32[i22 + (i9 << 2) >> 2] | 0;
   if (i2 | 0) {
    i8 = i9 << 5;
    do {
     i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i8;
     i3 = i23 + (i5 * 12 | 0) + 8 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
     do if (i4 & 32) {
      HEAP8[i3 >> 0] = i4 & 223;
      i3 = i23 + (i5 * 12 | 0) + 4 | 0;
      if ((HEAP32[i25 + (i5 << 2) >> 2] | 0) == -1) {
       i65 = HEAP32[i3 >> 2] | 0;
       i64 = i7 + (i65 << 4) | 0;
       HEAP32[i24 + (i5 << 2) >> 2] = HEAP32[i64 >> 2];
       HEAP32[i64 >> 2] = i5;
       i65 = i7 + (i65 << 4) + 8 | 0;
       i64 = HEAP32[i65 >> 2] | 0;
       HEAP32[i65 >> 2] = (i64 | 0) == -1 ? i5 : i64;
       break;
      } else {
       HEAP32[i3 >> 2] = -1;
       break;
      }
     } while (0);
     i2 = i2 + -1 & i2;
    } while ((i2 | 0) != 0);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i6 | 0));
  _memset(HEAP32[i46 >> 2] | 0, 0, HEAP32[i47 >> 2] << 2 | 0) | 0;
 }
 __ZL24processBrokenEdgeIslandsRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerEPjSD_SD_RS4_(i45, i51, i49, i50, HEAP32[i29 >> 2] | 0, HEAP32[i30 >> 2] | 0, HEAP32[i31 >> 2] | 0, i46);
 __Z22updateIslandsToProcessRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjRKNS_11NodeManagerERS4_(i44, HEAP32[i1 >> 2] | 0, i51, i46);
 i54 = HEAP32[i46 >> 2] | 0;
 i1 = HEAP32[i47 >> 2] | 0;
 i56 = i66 + 12 | 0;
 HEAP32[i56 >> 2] = 0;
 i57 = i66 + 16 | 0;
 HEAP32[i57 >> 2] = 0;
 i58 = i66 + 28 | 0;
 HEAP32[i58 >> 2] = 0;
 i59 = i66 + 48 | 0;
 HEAP32[i59 >> 2] = 0;
 i60 = i66 + 60 | 0;
 HEAP32[i60 >> 2] = 0;
 i61 = i66 + 76 | 0;
 HEAP32[i61 >> 2] = 0;
 i62 = i66 + 88 | 0;
 HEAP32[i62 >> 2] = 0;
 i63 = i66 + 100 | 0;
 HEAP32[i63 >> 2] = 0;
 i64 = i66 + 112 | 0;
 HEAP32[i64 >> 2] = 0;
 i65 = i66 + 120 | 0;
 HEAP32[i65 >> 2] = 0;
 i53 = HEAP32[i43 >> 2] | 0;
 i52 = HEAP32[i42 >> 2] | 0;
 i51 = HEAP32[i38 >> 2] | 0;
 i50 = HEAP32[i39 >> 2] | 0;
 i49 = HEAP32[i55 + 4 >> 2] | 0;
 i38 = HEAP32[i48 >> 2] | 0;
 i39 = HEAP32[i66 + 36 >> 2] | 0;
 i40 = HEAP32[i66 + 8 >> 2] | 0;
 i3 = HEAP32[i66 + 20 >> 2] | 0;
 i41 = HEAP32[i66 + 24 >> 2] | 0;
 i42 = HEAP32[i66 + 44 >> 2] | 0;
 i43 = HEAP32[i66 + 56 >> 2] | 0;
 i44 = HEAP32[i66 + 68 >> 2] | 0;
 i45 = HEAP32[i66 + 72 >> 2] | 0;
 i46 = HEAP32[i66 + 84 >> 2] | 0;
 i47 = HEAP32[i66 + 96 >> 2] | 0;
 i55 = i66 + 108 | 0;
 i48 = HEAP32[i55 >> 2] | 0;
 i37 = HEAP32[i66 + 116 >> 2] | 0;
 i1 = i1 & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i36 = 0;
   break;
  }
  i1 = HEAP32[i54 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i68 = 181;
   break;
  }
 }
 if ((i68 | 0) == 181) {
  i36 = i1 >>> 1 | i1;
  i36 = i36 >>> 2 | i36;
  i36 = i36 >>> 4 | i36;
  i36 = i36 >>> 8 | i36;
  i36 = (Math_imul(i36 >>> 16 | i36, 130329821) | 0) >>> 27;
  i36 = ((HEAP32[gb + 85120 + (i36 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i34 = i3 + -1 | 0;
 i10 = 0;
 i9 = 0;
 i8 = 0;
 i7 = 0;
 i6 = 0;
 i5 = 0;
 i4 = 0;
 i3 = 0;
 i2 = 0;
 i1 = 0;
 i35 = 0;
 while (1) {
  i11 = HEAP32[i54 + (i35 << 2) >> 2] | 0;
  if (i11) {
   i33 = i35 << 5;
   do {
    i31 = (Math_imul(i11 & 0 - i11, 125613361) | 0) >>> 27;
    i31 = HEAP32[gb + 90668 + (i31 << 2) >> 2] | i33;
    i15 = i38 + (i31 << 4) | 0;
    i12 = HEAP32[i15 >> 2] | 0;
    L293 : do if ((i12 | 0) != -1) {
     i13 = 0;
     i14 = i12;
     do {
      i13 = HEAPU8[i53 + (i14 * 12 | 0) + 8 >> 0] | 0 | i13;
      i14 = HEAP32[i52 + (i14 << 2) >> 2] | 0;
     } while ((i14 | 0) != -1);
     if (!(i13 & 8)) while (1) {
      i13 = i12;
      L300 : while (1) {
       i12 = i52 + (i13 << 2) | 0;
       i15 = i53 + (i13 * 12 | 0) + 8 | 0;
       i14 = HEAP8[i15 >> 0] | 0;
       do if (!(i14 & 16)) if (!(i14 & 2)) if (!(i14 & 1)) {
        i68 = 193;
        break L300;
       } else break; else if (!(i14 & 4)) break; else {
        i68 = 196;
        break L300;
       } while (0);
       i13 = HEAP32[i12 >> 2] | 0;
       if ((i13 | 0) == -1) break L293;
      }
      if ((i68 | 0) == 193) {
       i68 = 0;
       HEAP8[i15 >> 0] = i14 & 255 | 16;
       HEAP32[i40 + (i34 - i10 << 2) >> 2] = HEAP32[i53 + (i13 * 12 | 0) >> 2];
      } else if ((i68 | 0) == 196) {
       i68 = 0;
       HEAP8[i15 >> 0] = i14 & 255 | 16;
       HEAP32[i40 + (i34 - i10 << 2) >> 2] = HEAP32[i49 + (HEAP32[i53 + (i13 * 12 | 0) >> 2] << 3) + 4 >> 2] | 1;
      }
      i10 = i10 + 1 | 0;
      i12 = HEAP32[i12 >> 2] | 0;
      if ((i12 | 0) == -1) break L293;
     }
     i30 = i48 + (i7 << 4) + 4 | 0;
     HEAP32[i30 >> 2] = HEAP32[i30 >> 2] & -2147483648 | i5 & 2147483647;
     HEAP32[i48 + (i7 << 4) >> 2] = i4;
     HEAP32[i48 + (i7 << 4) + 8 >> 2] = i2;
     HEAP32[i48 + (i7 << 4) + 12 >> 2] = i3;
     i32 = i7 + 1 | 0;
     i12 = i15;
     i19 = i5;
     i14 = i4;
     i13 = i1;
     L313 : while (1) {
      i18 = i14;
      L315 : while (1) {
       i17 = i13;
       L317 : while (1) {
        while (1) {
         i13 = HEAP32[i12 >> 2] | 0;
         if ((i13 | 0) == -1) {
          i27 = i19;
          i28 = i18;
          i29 = i17;
          break L313;
         }
         i15 = i53 + (i13 * 12 | 0) | 0;
         i12 = i52 + (i13 << 2) | 0;
         i16 = i53 + (i13 * 12 | 0) + 8 | 0;
         i14 = HEAP8[i16 >> 0] | 0;
         do if (i14 & 16) if (!(i14 & 2)) {
          if (i14 & 1) break;
          HEAP8[i16 >> 0] = i14 & 239;
          HEAP32[i40 + (i9 << 2) >> 2] = HEAP32[i15 >> 2];
          i9 = i9 + 1 | 0;
          break;
         } else {
          if (!(i14 & 4)) break;
          HEAP8[i16 >> 0] = i14 & 239;
          HEAP32[i40 + (i9 << 2) >> 2] = HEAP32[i49 + (HEAP32[i15 >> 2] << 3) + 4 >> 2] | 1;
          i9 = i9 + 1 | 0;
          break;
         } while (0);
         i14 = HEAP8[i16 >> 0] | 0;
         if (i14 & 1) {
          i14 = i15;
          break;
         }
         if (!(i14 & 2)) {
          i14 = i17;
          break L317;
         }
         if (i14 & 4) {
          i14 = i18;
          i13 = i17;
          break L315;
         }
        }
        HEAP32[i39 + (i13 << 2) >> 2] = i17;
        HEAP32[i42 + (i17 << 2) >> 2] = (HEAP32[i14 >> 2] | 0) + i67;
        i17 = i17 + 1 | 0;
       }
       HEAP32[i39 + (i13 << 2) >> 2] = i18;
       HEAP32[i43 + (i18 << 2) >> 2] = (HEAP32[i15 >> 2] | 0) + i67;
       i18 = i18 + 1 | 0;
       i13 = i14;
      }
      i29 = HEAP32[i15 >> 2] | 0;
      i66 = HEAP32[i49 + (i29 << 3) + 4 >> 2] | 0;
      HEAP32[i44 + (i19 << 2) >> 2] = HEAP32[i49 + (i29 << 3) >> 2] & -64;
      HEAP32[i45 + (i19 << 2) >> 2] = i66;
      i19 = i19 + 1 | 0;
     }
     i12 = HEAP32[i38 + (i31 << 4) + 4 >> 2] | 0;
     L336 : do if ((i12 | 0) == -1) i1 = 0; else {
      i15 = 0;
      i13 = i3;
      i26 = i2;
      L337 : while (1) {
       i14 = 0;
       L339 : while (1) {
        L341 : while (1) {
         while (1) {
          i25 = i50 + (i12 << 2) | 0;
          i17 = HEAP32[i51 + (i12 * 12 | 0) >> 2] | 0;
          i19 = HEAP32[i51 + (i12 * 12 | 0) + 4 >> 2] | 0;
          i16 = (i17 | 0) != -1;
          do if (i14) {
           if (i16) {
            i16 = HEAP8[i53 + (i17 * 12 | 0) + 8 >> 0] | 0;
            i16 = (i16 & 2) == 0 ? i16 & 1 : 0;
           } else i16 = 1;
           i17 = i16 << 24 >> 24 != 0;
           if ((i19 | 0) == -1) {
            i16 = -1;
            i20 = 3;
            i18 = 1;
            i68 = 234;
            break;
           }
           i18 = HEAP8[i53 + (i19 * 12 | 0) + 8 >> 0] | 0;
           if (i18 & 2) {
            i16 = -1;
            i20 = 3;
            i18 = 0;
            i68 = 234;
            break;
           }
           if (i17) {
            i16 = -1;
            i19 = -1;
            i21 = 3;
            i17 = (i18 & 1) != 0;
            i20 = 3;
            i68 = 235;
           } else {
            i24 = 1;
            i16 = -1;
            i18 = -1;
            i23 = 3;
            i22 = 3;
           }
          } else {
           do if (i16) {
            i18 = HEAP8[i53 + (i17 * 12 | 0) + 8 >> 0] | 0;
            if (!(i18 & 2)) {
             i21 = i18 & 1;
             i16 = HEAP32[i39 + (i17 << 2) >> 2] | 0;
             i17 = i21 << 24 >> 24 != 0;
             break;
            }
            i16 = HEAP32[i53 + (i17 * 12 | 0) >> 2] | 0;
            if (!(i18 & 4)) {
             i17 = 0;
             i21 = 2;
             break;
            }
            i16 = HEAP32[i49 + (i16 << 3) >> 2] | 0;
            i17 = 0;
            i21 = 2;
           } else {
            i16 = -1;
            i15 = 1;
            i17 = 1;
            i21 = 3;
           } while (0);
           if ((i19 | 0) == -1) {
            i15 = 1;
            i20 = i21;
            i18 = 1;
            i68 = 234;
            break;
           }
           i18 = HEAP8[i53 + (i19 * 12 | 0) + 8 >> 0] | 0;
           if (!(i18 & 2)) {
            i20 = i18 & 1;
            i18 = HEAP32[i39 + (i19 << 2) >> 2] | 0;
            if (i17) {
             i19 = i18;
             i17 = i20 << 24 >> 24 != 0;
             i68 = 235;
             break;
            } else {
             i24 = 1;
             i23 = i21;
             i22 = i20;
             break;
            }
           }
           i19 = HEAP32[i53 + (i19 * 12 | 0) >> 2] | 0;
           if (!(i18 & 4)) if (i17) {
            i17 = 0;
            i20 = 2;
            i68 = 235;
            break;
           } else {
            i24 = 1;
            i18 = i19;
            i23 = i21;
            i22 = 2;
            break;
           } else {
            i18 = HEAP32[i49 + (i19 << 3) >> 2] | 0;
            if (i17) {
             i19 = i18;
             i17 = 0;
             i20 = 2;
             i68 = 235;
             break;
            } else {
             i24 = 1;
             i23 = i21;
             i22 = 2;
             break;
            }
           }
          } while (0);
          if ((i68 | 0) == 234) {
           i68 = 0;
           if (i17) {
            i19 = -1;
            i21 = i20;
            i17 = i18;
            i20 = 3;
            i68 = 235;
           } else {
            i24 = 1;
            i18 = -1;
            i23 = i20;
            i22 = 3;
           }
          }
          if ((i68 | 0) == 235) {
           i68 = 0;
           i24 = i17 ^ 1;
           i18 = i19;
           i23 = i21;
           i22 = i20;
          }
          i19 = HEAP32[i51 + (i12 * 12 | 0) + 8 >> 2] | 0;
          i17 = i19;
          i20 = i17 & 1;
          i21 = (i20 | 0) == 0;
          if (i21) if (!(i19 >>> 0 >= 16 >>> 0 | i24 ^ 1)) {
           i14 = i25;
           break L341;
          }
          if (i14) {
           i12 = i25;
           i14 = 1;
           break;
          }
          i12 = i24 ^ 1;
          if (!((i20 | 0) != 0 | i12)) {
           i19 = i25;
           i14 = i23;
           i12 = i22;
           break L339;
          }
          if (i19 >>> 0 <= 15 >>> 0 | i21 | i12) {
           i12 = i25;
           i14 = 0;
           break;
          }
          HEAP32[i47 + (i13 << 4) + 12 >> 2] = i17 & -16;
          HEAP8[i47 + (i13 << 4) + 8 >> 0] = i23;
          HEAP8[i47 + (i13 << 4) + 9 >> 0] = i22;
          HEAP32[i47 + (i13 << 4) >> 2] = i16;
          HEAP32[i47 + (i13 << 4) + 4 >> 2] = i18;
          i13 = i13 + 1 | 0;
          i12 = HEAP32[i25 >> 2] | 0;
          if ((i12 | 0) == -1) {
           i1 = i15;
           i3 = i13;
           i2 = i26;
           break L336;
          }
         }
         i12 = HEAP32[i12 >> 2] | 0;
         if ((i12 | 0) == -1) {
          i68 = 246;
          break L337;
         }
        }
        HEAP32[i41 + (i6 << 3) + 4 >> 2] = i12;
        HEAP32[i41 + (i6 << 3) >> 2] = 0;
        i6 = i6 + 1 | 0;
        i12 = HEAP32[i14 >> 2] | 0;
        if ((i12 | 0) == -1) break L337; else i14 = 1;
       }
       HEAP32[i46 + (i26 << 4) + 12 >> 2] = i17 & -16;
       HEAP8[i46 + (i26 << 4) + 8 >> 0] = i14;
       HEAP8[i46 + (i26 << 4) + 9 >> 0] = i12;
       HEAP32[i46 + (i26 << 4) >> 2] = i16;
       HEAP32[i46 + (i26 << 4) + 4 >> 2] = i18;
       i14 = i26 + 1 | 0;
       i12 = HEAP32[i19 >> 2] | 0;
       if ((i12 | 0) == -1) {
        i1 = i15;
        i3 = i13;
        i2 = i14;
        break L336;
       } else i26 = i14;
      }
      if ((i68 | 0) == 246) {
       i68 = 0;
       if (!i14) {
        i1 = i15;
        i3 = i13;
        i2 = i26;
        break;
       }
      }
      i8 = i8 + 1 | 0;
      HEAP32[i48 + (i37 - i8 << 4) + 12 >> 2] = i31;
      break L293;
     } while (0);
     HEAP32[i30 >> 2] = HEAP32[i30 >> 2] & 2147483647 | (i1 & 1) << 31;
     i7 = i32;
     i5 = i27;
     i4 = i28;
     i1 = i29;
    } while (0);
    i11 = i11 + -1 & i11;
   } while ((i11 | 0) != 0);
  }
  if ((i35 | 0) == (i36 | 0)) break; else i35 = i35 + 1 | 0;
 }
 i68 = HEAP32[i55 >> 2] | 0;
 HEAP32[i68 + (i7 << 4) >> 2] = i4;
 i68 = i68 + (i7 << 4) + 4 | 0;
 HEAP32[i68 >> 2] = HEAP32[i68 >> 2] & -2147483648 | i5 & 2147483647;
 i68 = HEAP32[i55 >> 2] | 0;
 HEAP32[i68 + (i7 << 4) + 8 >> 2] = i2;
 HEAP32[i68 + (i7 << 4) + 12 >> 2] = i3;
 HEAP32[i56 >> 2] = i9;
 HEAP32[i57 >> 2] = i10;
 HEAP32[i58 >> 2] = i6;
 HEAP32[i59 >> 2] = i1;
 HEAP32[i60 >> 2] = i4;
 HEAP32[i61 >> 2] = i5;
 HEAP32[i62 >> 2] = i2;
 HEAP32[i63 >> 2] = i3;
 HEAP32[i64 >> 2] = i7;
 HEAP32[i65 >> 2] = i8;
 STACKTOP = i69;
 return;
}

function __ZL31ParticleRenderer_FillVertexDataPvRK27LegacyParticleRenderingDataPK8ParticlePK5RectTIfE(i41, i29, i15, i99) {
 i41 = i41 | 0;
 i29 = i29 | 0;
 i15 = i15 | 0;
 i99 = i99 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, f40 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, i91 = 0, f92 = f0, i93 = 0, f94 = f0, i95 = 0, f96 = f0, i97 = 0, f98 = f0, i100 = 0, f101 = f0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, i130 = 0;
 i113 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i108 = i113 + 32 | 0;
 i109 = i113 + 208 | 0;
 i110 = i113 + 144 | 0;
 i111 = i113 + 80 | 0;
 i112 = i113;
 i10 = i29 + 184 | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  i11 = i109;
  i8 = i29;
  i9 = i11 + 64 | 0;
  do {
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   i11 = i11 + 4 | 0;
   i8 = i8 + 4 | 0;
  } while ((i11 | 0) < (i9 | 0));
 } else __ZN10Matrix4x4f11SetIdentityEv(i109) | 0;
 i8 = i29 + 64 | 0;
 f86 = Math_fround(HEAPF32[i29 + 72 >> 2]);
 f87 = Math_fround(HEAPF32[i29 + 88 >> 2]);
 f88 = Math_fround(HEAPF32[i29 + 104 >> 2]);
 f89 = Math_fround(HEAPF32[i29 + 120 >> 2]);
 __Z20InvertMatrix4x4_FullPKfPf(i8, i110) | 0;
 f90 = Math_fround(HEAPF32[i110 >> 2]);
 i91 = i110 + 4 | 0;
 f92 = Math_fround(HEAPF32[i91 >> 2]);
 i93 = i110 + 8 | 0;
 f94 = Math_fround(HEAPF32[i93 >> 2]);
 i95 = i110 + 16 | 0;
 f96 = Math_fround(HEAPF32[i95 >> 2]);
 i97 = i110 + 20 | 0;
 f98 = Math_fround(HEAPF32[i97 >> 2]);
 i100 = i110 + 24 | 0;
 f101 = Math_fround(HEAPF32[i100 >> 2]);
 i102 = i110 + 32 | 0;
 i103 = HEAP32[i102 >> 2] | 0;
 i104 = i110 + 36 | 0;
 i105 = HEAP32[i104 >> 2] | 0;
 i106 = i110 + 40 | 0;
 i107 = HEAP32[i106 >> 2] | 0;
 i16 = i29 + 176 | 0;
 L5 : do switch (HEAP32[i16 >> 2] | 0) {
 case 4:
  {
   i21 = HEAP32[i109 + 32 >> 2] | 0;
   i17 = HEAP32[i109 >> 2] | 0;
   i18 = HEAP32[i109 + 4 >> 2] | 0;
   i22 = HEAP32[i109 + 36 >> 2] | 0;
   i19 = HEAP32[i109 + 8 >> 2] | 0;
   i23 = HEAP32[i109 + 40 >> 2] | 0;
   break;
  }
 case 5:
  {
   i1 = HEAP32[i109 + 16 >> 2] | 0;
   i6 = HEAP32[i109 + 20 >> 2] | 0;
   i7 = HEAP32[i109 + 24 >> 2] | 0;
   f44 = Math_fround(HEAPF32[i29 + 140 >> 2]);
   f3 = Math_fround(f44 * Math_fround(2.0));
   f4 = Math_fround(HEAPF32[i29 + 144 >> 2]);
   f43 = Math_fround(f4 * Math_fround(2.0));
   f2 = Math_fround(HEAPF32[i29 + 148 >> 2]);
   f39 = Math_fround(f2 * Math_fround(2.0));
   f42 = Math_fround(f44 * f3);
   f5 = Math_fround(f4 * f43);
   f2 = Math_fround(f2 * f39);
   f37 = Math_fround(f44 * f43);
   f44 = Math_fround(f44 * f39);
   f4 = Math_fround(f4 * f39);
   f40 = Math_fround(HEAPF32[i29 + 152 >> 2]);
   f3 = Math_fround(f3 * f40);
   f43 = Math_fround(f43 * f40);
   f39 = Math_fround(f40 * f39);
   f40 = Math_fround(Math_fround(f44 + f43) + Math_fround(Math_fround(Math_fround(f37 - f39) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f5 + f2)) * Math_fround(0.0))));
   f2 = Math_fround(Math_fround(f4 - f3) + Math_fround(Math_fround(Math_fround(f37 + f39) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f42 + f2)) * Math_fround(0.0))));
   f3 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f42 + f5)) + Math_fround(Math_fround(Math_fround(f44 - f43) * Math_fround(0.0)) + Math_fround(Math_fround(f4 + f3) * Math_fround(0.0))));
   f4 = Math_fround(Math_fround(HEAPF32[i109 >> 2]) * f40);
   f43 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(Math_fround(f4 + Math_fround(f43 * f2)) + Math_fround(Math_fround(HEAPF32[i109 + 32 >> 2]) * f3));
   f44 = Math_fround(Math_fround(HEAPF32[i109 + 4 >> 2]) * f40);
   f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f44 = Math_fround(Math_fround(f44 + Math_fround(f5 * f2)) + Math_fround(f3 * Math_fround(HEAPF32[i109 + 36 >> 2])));
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i109 + 8 >> 2]));
   f42 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(Math_fround(f40 + Math_fround(f2 * f42)) + Math_fround(f3 * Math_fround(HEAPF32[i109 + 40 >> 2])));
   f2 = Math_fround(Math_fround(f5 * f3) - Math_fround(f42 * f44));
   f3 = Math_fround(Math_fround(f42 * f4) - Math_fround(f43 * f3));
   f4 = Math_fround(Math_fround(f43 * f44) - Math_fround(f5 * f4));
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)))));
   if (f5 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
    f44 = Math_fround(f2 / f5);
    i17 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    f44 = Math_fround(f3 / f5);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    f44 = Math_fround(f4 / f5);
    i21 = i1;
    i22 = i6;
    i19 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = i7;
    break L5;
   } else {
    i21 = i1;
    i17 = HEAP32[gb + 1162364 >> 2] | 0;
    i18 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
    i22 = i6;
    i19 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
    i23 = i7;
    break L5;
   }
  }
 default:
  {
   i21 = 0;
   i17 = 0;
   i18 = 0;
   i22 = 0;
   i19 = 0;
   i23 = 0;
  }
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 < 3) {
  if (!(HEAP8[i10 >> 0] | 0)) {
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i8, i109, i111);
   i1 = HEAP32[i16 >> 2] | 0;
  } else {
   i11 = i111;
   i9 = i11 + 64 | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
    i11 = i11 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i11 | 0) < (i9 | 0));
  }
  if ((i1 | 0) == 2) {
   HEAP32[i112 >> 2] = 0;
   i13 = i112 + 4 | 0;
   i6 = gb + 63160 | 0;
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   i14 = i13;
   HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i14 + 4 >> 2] = i1;
   i14 = i29 + 188 | 0;
   i1 = HEAP32[i14 >> 2] | 0;
   i6 = i1 << 3;
   do if (!i6) {
    i6 = 0;
    i12 = 0;
   } else {
    i7 = (i6 | 4) + -1 | 0;
    if (i7 >>> 0 < 2e3) {
     i6 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     i12 = 0;
     break;
    } else {
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 1048339 | 0, 323) | 0;
     i1 = gb + 64016 | 0;
     i85 = HEAP32[i1 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i112 >> 2] = i12;
     i6 = i13;
     HEAP32[i6 >> 2] = i85;
     HEAP32[i6 + 4 >> 2] = i1;
     i6 = i12;
     i1 = HEAP32[i14 >> 2] | 0;
     break;
    }
   } while (0);
   i10 = i6 + 3 & -4;
   f2 = Math_fround(HEAPF32[i111 + 32 >> 2]);
   f3 = Math_fround(HEAPF32[i111 + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i111 + 40 >> 2]);
   if (!i1) i1 = 0; else {
    i6 = 0;
    do {
     f44 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i6 * 48 | 0) >> 2]));
     f44 = Math_fround(f44 + Math_fround(f3 * Math_fround(HEAPF32[i15 + (i6 * 48 | 0) + 4 >> 2])));
     HEAPF32[i10 + (i6 << 3) >> 2] = Math_fround(f44 + Math_fround(f4 * Math_fround(HEAPF32[i15 + (i6 * 48 | 0) + 8 >> 2])));
     HEAP32[i10 + (i6 << 3) + 4 >> 2] = i6;
     i6 = i6 + 1 | 0;
    } while (i6 >>> 0 < i1 >>> 0);
   }
   __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_(i10, i10 + (i1 << 3) | 0, i108);
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i14 >> 2] | 0) * 48 | 0, 4, gb + 64016 | 0, 0, gb + 1048339 | 0, 336) | 0;
   if (HEAP32[i14 >> 2] | 0) {
    i1 = 0;
    do {
     i6 = HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0;
     i11 = i7 + (i1 * 48 | 0) | 0;
     i8 = i15 + (i6 * 48 | 0) | 0;
     i9 = i11 + 44 | 0;
     do {
      HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
      i11 = i11 + 4 | 0;
      i8 = i8 + 4 | 0;
     } while ((i11 | 0) < (i9 | 0));
     HEAP32[i7 + (i1 * 48 | 0) + 44 >> 2] = HEAP32[i15 + (i6 * 48 | 0) + 44 >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
   i15 = i7;
   i85 = i7;
   i1 = HEAP32[i16 >> 2] | 0;
  } else i85 = 0;
 } else i85 = 0;
 i1 = (i1 | 0) == 2 ? 0 : i1;
 i56 = i29 + 188 | 0;
 if ((HEAP32[i56 >> 2] | 0) > 0) {
  i57 = i109 + 16 | 0;
  i58 = i109 + 32 | 0;
  i59 = i109 + 48 | 0;
  i60 = i109 + 4 | 0;
  i61 = i109 + 20 | 0;
  i62 = i109 + 36 | 0;
  i63 = i109 + 52 | 0;
  i64 = i109 + 8 | 0;
  i65 = i109 + 24 | 0;
  i66 = i109 + 40 | 0;
  i67 = i109 + 56 | 0;
  i68 = i29 + 156 | 0;
  i69 = i29 + 160 | 0;
  i51 = i108 + 4 | 0;
  i55 = i108 + 8 | 0;
  i47 = i108 + 12 | 0;
  i50 = i108 + 16 | 0;
  i54 = i108 + 20 | 0;
  i46 = i108 + 24 | 0;
  i49 = i108 + 28 | 0;
  i53 = i108 + 32 | 0;
  i45 = i108 + 36 | 0;
  i48 = i108 + 40 | 0;
  i52 = i108 + 44 | 0;
  i70 = i29 + 196 | 0;
  i71 = i29 + 180 | 0;
  i72 = i112 + 4 | 0;
  i73 = i112 + 8 | 0;
  i74 = i112 + 12 | 0;
  i75 = i112 + 16 | 0;
  i76 = i112 + 20 | 0;
  i77 = i112 + 24 | 0;
  i78 = i112 + 28 | 0;
  i79 = i108 + 12 | 0;
  i80 = i112 + 8 | 0;
  i81 = i108 + 24 | 0;
  i82 = i112 + 16 | 0;
  i83 = i108 + 36 | 0;
  i84 = i112 + 24 | 0;
  f44 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f42 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f40 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f32 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i33 = i29 + 164 | 0;
  i34 = i29 + 128 | 0;
  i35 = i29 + 132 | 0;
  i36 = i29 + 136 | 0;
  f37 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  i38 = i29 + 168 | 0;
  i10 = i29 + 172 | 0;
  i11 = i111 + 16 | 0;
  i12 = i111 + 32 | 0;
  i13 = i111 + 48 | 0;
  i14 = i111 + 4 | 0;
  i16 = i111 + 20 | 0;
  i17 = i111 + 36 | 0;
  i18 = i111 + 52 | 0;
  i19 = i111 + 8 | 0;
  i21 = i111 + 24 | 0;
  i22 = i111 + 40 | 0;
  i23 = i111 + 56 | 0;
  i29 = i110 + 48 | 0;
  i30 = i110 + 52 | 0;
  i31 = i110 + 56 | 0;
  i1 = (i1 | 0) == 5 ? 4 : i1;
  i8 = i41;
  i9 = 0;
  while (1) {
   i6 = i15 + (i9 * 48 | 0) | 0;
   f2 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 28 >> 2]);
   if (f2 != Math_fround(0.0)) if (!i1) i7 = 32; else {
    i1 = (i1 | 0) == 4 ? 1001 : i1;
    i7 = 29;
   } else i7 = 29;
   L41 : do if ((i7 | 0) == 29) {
    i7 = 0;
    switch (i1 | 0) {
    case 1e3:
     {
      i7 = 32;
      break L41;
     }
    case 0:
     {
      f115 = Math_fround(HEAPF32[i109 >> 2]);
      f28 = Math_fround(HEAPF32[i6 >> 2]);
      f115 = Math_fround(f115 * f28);
      f2 = Math_fround(HEAPF32[i57 >> 2]);
      f3 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
      f2 = Math_fround(f115 + Math_fround(f2 * f3));
      f115 = Math_fround(HEAPF32[i58 >> 2]);
      f114 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
      f115 = Math_fround(Math_fround(f2 + Math_fround(f115 * f114)) + Math_fround(HEAPF32[i59 >> 2]));
      f2 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * Math_fround(HEAPF32[i60 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i61 >> 2]))) + Math_fround(f114 * Math_fround(HEAPF32[i62 >> 2]))) + Math_fround(HEAPF32[i63 >> 2]));
      f114 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * Math_fround(HEAPF32[i64 >> 2])) + Math_fround(f3 * Math_fround(HEAPF32[i65 >> 2]))) + Math_fround(f114 * Math_fround(HEAPF32[i66 >> 2]))) + Math_fround(HEAPF32[i67 >> 2]));
      f3 = Math_fround(Math_fround(Math_fround(f89 + Math_fround(Math_fround(Math_fround(f86 * f115) + Math_fround(f87 * f2)) + Math_fround(f88 * f114))) * Math_fround(HEAPF32[i68 >> 2])) + Math_fround(HEAPF32[i69 >> 2]));
      f28 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 24 >> 2]);
      f28 = Math_fround((f3 < f28 ? f3 : f28) * Math_fround(.5));
      f3 = Math_fround(f90 * f28);
      f4 = Math_fround(f92 * f28);
      f5 = Math_fround(f94 * f28);
      f26 = Math_fround(f96 * f28);
      f27 = Math_fround(f98 * f28);
      f28 = Math_fround(f101 * f28);
      f25 = Math_fround(f115 - f3);
      f20 = Math_fround(f2 - f4);
      f24 = Math_fround(f114 - f5);
      f117 = Math_fround(f27 + f20);
      f116 = Math_fround(f28 + f24);
      HEAPF32[i108 >> 2] = Math_fround(f26 + f25);
      HEAPF32[i51 >> 2] = f117;
      HEAPF32[i55 >> 2] = f116;
      f3 = Math_fround(f115 + f3);
      f4 = Math_fround(f2 + f4);
      f5 = Math_fround(f114 + f5);
      f114 = Math_fround(f27 + f4);
      f2 = Math_fround(f28 + f5);
      HEAPF32[i47 >> 2] = Math_fround(f26 + f3);
      HEAPF32[i50 >> 2] = f114;
      HEAPF32[i54 >> 2] = f2;
      f4 = Math_fround(f4 - f27);
      f5 = Math_fround(f5 - f28);
      HEAPF32[i46 >> 2] = Math_fround(f3 - f26);
      HEAPF32[i49 >> 2] = f4;
      HEAPF32[i53 >> 2] = f5;
      f27 = Math_fround(f20 - f27);
      f28 = Math_fround(f24 - f28);
      HEAPF32[i45 >> 2] = Math_fround(f25 - f26);
      HEAPF32[i48 >> 2] = f27;
      HEAPF32[i52 >> 2] = f28;
      i6 = 0;
      break L41;
     }
    case 4:
     {
      f4 = Math_fround(HEAPF32[i109 >> 2]);
      f117 = Math_fround(HEAPF32[i6 >> 2]);
      f4 = Math_fround(f4 * f117);
      f20 = Math_fround(HEAPF32[i57 >> 2]);
      f24 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
      f20 = Math_fround(f4 + Math_fround(f20 * f24));
      f4 = Math_fround(HEAPF32[i58 >> 2]);
      f5 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
      f4 = Math_fround(Math_fround(f20 + Math_fround(f4 * f5)) + Math_fround(HEAPF32[i59 >> 2]));
      f20 = Math_fround(Math_fround(Math_fround(Math_fround(f117 * Math_fround(HEAPF32[i60 >> 2])) + Math_fround(f24 * Math_fround(HEAPF32[i61 >> 2]))) + Math_fround(f5 * Math_fround(HEAPF32[i62 >> 2]))) + Math_fround(HEAPF32[i63 >> 2]));
      f5 = Math_fround(Math_fround(Math_fround(Math_fround(f117 * Math_fround(HEAPF32[i64 >> 2])) + Math_fround(f24 * Math_fround(HEAPF32[i65 >> 2]))) + Math_fround(f5 * Math_fround(HEAPF32[i66 >> 2]))) + Math_fround(HEAPF32[i67 >> 2]));
      f24 = Math_fround(f89 + Math_fround(Math_fround(Math_fround(f86 * f4) + Math_fround(f87 * f20)) + Math_fround(f88 * f5)));
      f117 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 24 >> 2]);
      f24 = Math_fround(Math_fround(Math_fround(f24 - Math_fround(f117 * Math_fround(.707106769))) * Math_fround(HEAPF32[i68 >> 2])) + Math_fround(HEAPF32[i69 >> 2]));
      f117 = Math_fround((f24 < f117 ? f24 : f117) * Math_fround(.5));
      f24 = Math_fround(f44 * f117);
      f25 = Math_fround(f43 * f117);
      f26 = Math_fround(f42 * f117);
      f114 = Math_fround(f4 - f24);
      f27 = Math_fround(f20 - f25);
      f28 = Math_fround(f5 - f26);
      f115 = Math_fround(f40 * f117);
      f116 = Math_fround(f39 * f117);
      f117 = Math_fround(f32 * f117);
      f2 = Math_fround(f116 + f27);
      f3 = Math_fround(f117 + f28);
      HEAPF32[i108 >> 2] = Math_fround(f115 + f114);
      HEAPF32[i51 >> 2] = f2;
      HEAPF32[i55 >> 2] = f3;
      f24 = Math_fround(f4 + f24);
      f25 = Math_fround(f20 + f25);
      f26 = Math_fround(f5 + f26);
      f5 = Math_fround(f116 + f25);
      f20 = Math_fround(f117 + f26);
      HEAPF32[i47 >> 2] = Math_fround(f115 + f24);
      HEAPF32[i50 >> 2] = f5;
      HEAPF32[i54 >> 2] = f20;
      f25 = Math_fround(f25 - f116);
      f26 = Math_fround(f26 - f117);
      HEAPF32[i46 >> 2] = Math_fround(f24 - f115);
      HEAPF32[i49 >> 2] = f25;
      HEAPF32[i53 >> 2] = f26;
      f116 = Math_fround(f27 - f116);
      f117 = Math_fround(f28 - f117);
      HEAPF32[i45 >> 2] = Math_fround(f114 - f115);
      HEAPF32[i48 >> 2] = f116;
      HEAPF32[i52 >> 2] = f117;
      i6 = 4;
      break L41;
     }
    case 1001:
     {
      f114 = Math_fround(HEAPF32[i109 >> 2]);
      f120 = Math_fround(HEAPF32[i6 >> 2]);
      f114 = Math_fround(f114 * f120);
      f25 = Math_fround(HEAPF32[i57 >> 2]);
      f28 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
      f25 = Math_fround(f114 + Math_fround(f25 * f28));
      f114 = Math_fround(HEAPF32[i58 >> 2]);
      f27 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
      f114 = Math_fround(Math_fround(f25 + Math_fround(f114 * f27)) + Math_fround(HEAPF32[i59 >> 2]));
      f25 = Math_fround(Math_fround(Math_fround(Math_fround(f120 * Math_fround(HEAPF32[i60 >> 2])) + Math_fround(f28 * Math_fround(HEAPF32[i61 >> 2]))) + Math_fround(f27 * Math_fround(HEAPF32[i62 >> 2]))) + Math_fround(HEAPF32[i63 >> 2]));
      f27 = Math_fround(Math_fround(Math_fround(Math_fround(f120 * Math_fround(HEAPF32[i64 >> 2])) + Math_fround(f28 * Math_fround(HEAPF32[i65 >> 2]))) + Math_fround(f27 * Math_fround(HEAPF32[i66 >> 2]))) + Math_fround(HEAPF32[i67 >> 2]));
      f28 = Math_fround(Math_fround(Math_fround(f89 + Math_fround(Math_fround(Math_fround(f86 * f114) + Math_fround(f87 * f25)) + Math_fround(f88 * f27))) * Math_fround(HEAPF32[i68 >> 2])) + Math_fround(HEAPF32[i69 >> 2]));
      f120 = Math_fround(+Math_sin(+f2));
      f119 = Math_fround(+Math_cos(+f2));
      f117 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 24 >> 2]);
      f117 = Math_fround((f28 < f117 ? f28 : f117) * Math_fround(.5));
      f28 = Math_fround(f44 * f117);
      f24 = Math_fround(f43 * f117);
      f26 = Math_fround(f42 * f117);
      f3 = Math_fround(f119 * f28);
      f118 = Math_fround(f119 * f24);
      f2 = Math_fround(f119 * f26);
      f115 = Math_fround(f40 * f117);
      f116 = Math_fround(f39 * f117);
      f117 = Math_fround(f32 * f117);
      f4 = Math_fround(f120 * f115);
      f5 = Math_fround(f120 * f116);
      f20 = Math_fround(f120 * f117);
      f122 = Math_fround(f5 + Math_fround(f25 + f118));
      f121 = Math_fround(f20 + Math_fround(f27 + f2));
      HEAPF32[i108 >> 2] = Math_fround(f4 + Math_fround(f114 + f3));
      HEAPF32[i51 >> 2] = f122;
      HEAPF32[i55 >> 2] = f121;
      f115 = Math_fround(f119 * f115);
      f116 = Math_fround(f119 * f116);
      f117 = Math_fround(f119 * f117);
      f28 = Math_fround(f120 * f28);
      f24 = Math_fround(f120 * f24);
      f26 = Math_fround(f120 * f26);
      f120 = Math_fround(Math_fround(f25 + f116) - f24);
      f119 = Math_fround(Math_fround(f27 + f117) - f26);
      HEAPF32[i47 >> 2] = Math_fround(Math_fround(f114 + f115) - f28);
      HEAPF32[i50 >> 2] = f120;
      HEAPF32[i54 >> 2] = f119;
      f5 = Math_fround(Math_fround(f25 - f118) - f5);
      f20 = Math_fround(Math_fround(f27 - f2) - f20);
      HEAPF32[i46 >> 2] = Math_fround(Math_fround(f114 - f3) - f4);
      HEAPF32[i49 >> 2] = f5;
      HEAPF32[i53 >> 2] = f20;
      f116 = Math_fround(f24 + Math_fround(f25 - f116));
      f117 = Math_fround(f26 + Math_fround(f27 - f117));
      HEAPF32[i45 >> 2] = Math_fround(f28 + Math_fround(f114 - f115));
      HEAPF32[i48 >> 2] = f116;
      HEAPF32[i52 >> 2] = f117;
      i6 = 1001;
      break L41;
     }
    case 3:
     {
      f20 = Math_fround(HEAPF32[i33 >> 2]);
      f4 = Math_fround(f20 * Math_fround(HEAPF32[i34 >> 2]));
      f5 = Math_fround(f20 * Math_fround(HEAPF32[i35 >> 2]));
      f20 = Math_fround(f20 * Math_fround(HEAPF32[i36 >> 2]));
      f4 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 12 >> 2]) - f4);
      f5 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 16 >> 2]) - f5);
      f20 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 20 >> 2]) - f20);
      f2 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f20 * f20));
      i1 = HEAP32[i15 + (i9 * 48 | 0) + 24 >> 2] | 0;
      if (f2 > f37) {
       f3 = Math_fround(HEAPF32[i38 >> 2]);
       if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
       f121 = Math_fround(HEAPF32[i10 >> 2]);
       f122 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f3 = Math_fround(f3 + Math_fround(f2 * Math_fround(f122 * f121)));
       f2 = f122;
      } else {
       f3 = Math_fround(0.0);
       f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      }
      f4 = Math_fround(f4 * f3);
      f116 = Math_fround(f5 * f3);
      f128 = Math_fround(f20 * f3);
      f127 = Math_fround(HEAPF32[i111 >> 2]);
      f24 = Math_fround(HEAPF32[i6 >> 2]);
      f5 = Math_fround(f127 * f24);
      f25 = Math_fround(HEAPF32[i11 >> 2]);
      f121 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
      f5 = Math_fround(f5 + Math_fround(f25 * f121));
      f124 = Math_fround(HEAPF32[i12 >> 2]);
      f3 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
      f5 = Math_fround(f5 + Math_fround(f124 * f3));
      f26 = Math_fround(HEAPF32[i13 >> 2]);
      f5 = Math_fround(f26 + f5);
      f120 = Math_fround(HEAPF32[i14 >> 2]);
      f20 = Math_fround(f24 * f120);
      f117 = Math_fround(HEAPF32[i16 >> 2]);
      f20 = Math_fround(f20 + Math_fround(f121 * f117));
      f123 = Math_fround(HEAPF32[i17 >> 2]);
      f20 = Math_fround(f20 + Math_fround(f3 * f123));
      f115 = Math_fround(HEAPF32[i18 >> 2]);
      f20 = Math_fround(f115 + f20);
      f118 = Math_fround(HEAPF32[i19 >> 2]);
      f122 = Math_fround(f24 * f118);
      f126 = Math_fround(HEAPF32[i21 >> 2]);
      f122 = Math_fround(f122 + Math_fround(f121 * f126));
      f125 = Math_fround(HEAPF32[i22 >> 2]);
      f122 = Math_fround(f122 + Math_fround(f3 * f125));
      f119 = Math_fround(HEAPF32[i23 >> 2]);
      f122 = Math_fround(f119 + f122);
      f4 = Math_fround(f24 - f4);
      f116 = Math_fround(f121 - f116);
      f128 = Math_fround(f3 - f128);
      f124 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f127 * f4) + Math_fround(f25 * f116)) + Math_fround(f124 * f128)));
      f123 = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f4 * f120) + Math_fround(f116 * f117)) + Math_fround(f128 * f123)));
      f125 = Math_fround(f119 + Math_fround(Math_fround(Math_fround(f4 * f118) + Math_fround(f116 * f126)) + Math_fround(f128 * f125)));
      f128 = Math_fround(Math_fround(Math_fround(HEAPF32[i68 >> 2]) * f125) + Math_fround(HEAPF32[i69 >> 2]));
      f128 = Math_fround((f128 < f2 ? f128 : f2) * Math_fround(.5));
      f126 = Math_fround(f5 - f124);
      f116 = Math_fround(f20 - f123);
      f118 = Math_fround(f122 - f125);
      f4 = Math_fround(Math_abs(Math_fround(f5)));
      f119 = Math_fround(Math_abs(Math_fround(f20)));
      f117 = Math_fround(Math_abs(Math_fround(f122)));
      i1 = f4 > Math_fround(.00999999977);
      f4 = i1 ? f4 : Math_fround(.00999999977);
      i1 = f119 > Math_fround(.00999999977);
      f119 = i1 ? f119 : Math_fround(.00999999977);
      i1 = f117 > Math_fround(.00999999977);
      f117 = i1 ? f117 : Math_fround(.00999999977);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
      i41 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
      i6 = (HEAPF32[tempDoublePtr >> 2] = f122, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
      f4 = Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f119 = Math_fround(f119 * (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f117 = Math_fround(f117 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f116 = Math_fround(Math_fround(f118 * f119) - Math_fround(f116 * f117));
      f118 = Math_fround(Math_fround(f126 * f117) - Math_fround(f4 * f118));
      f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f116 * f116) + Math_fround(f118 * f118)) + Math_fround(0.0)))));
      f116 = Math_fround(f128 * Math_fround(f4 * f116));
      f118 = Math_fround(f128 * Math_fround(f4 * f118));
      f4 = Math_fround(f5 + f116);
      f128 = Math_fround(f20 + f118);
      f117 = Math_fround(HEAPF32[i110 >> 2]);
      f126 = Math_fround(f117 * f4);
      f119 = Math_fround(HEAPF32[i95 >> 2]);
      f126 = Math_fround(f126 + Math_fround(f119 * f128));
      f2 = Math_fround(HEAPF32[i102 >> 2]);
      f120 = Math_fround(f122 * f2);
      f126 = Math_fround(f120 + f126);
      f115 = Math_fround(HEAPF32[i29 >> 2]);
      f126 = Math_fround(f115 + f126);
      f25 = Math_fround(HEAPF32[i91 >> 2]);
      f127 = Math_fround(f25 * f4);
      f26 = Math_fround(HEAPF32[i97 >> 2]);
      f127 = Math_fround(f127 + Math_fround(f26 * f128));
      f3 = Math_fround(HEAPF32[i104 >> 2]);
      f121 = Math_fround(f122 * f3);
      f127 = Math_fround(f121 + f127);
      f24 = Math_fround(HEAPF32[i30 >> 2]);
      f127 = Math_fround(f24 + f127);
      f28 = Math_fround(HEAPF32[i93 >> 2]);
      f4 = Math_fround(f28 * f4);
      f114 = Math_fround(HEAPF32[i100 >> 2]);
      f128 = Math_fround(f4 + Math_fround(f128 * f114));
      f4 = Math_fround(HEAPF32[i106 >> 2]);
      f122 = Math_fround(f122 * f4);
      f128 = Math_fround(f128 + f122);
      f27 = Math_fround(HEAPF32[i31 >> 2]);
      f128 = Math_fround(f27 + f128);
      HEAPF32[i108 >> 2] = f126;
      HEAPF32[i51 >> 2] = f127;
      HEAPF32[i55 >> 2] = f128;
      f128 = Math_fround(f124 + f116);
      f127 = Math_fround(f123 + f118);
      f2 = Math_fround(f125 * f2);
      f3 = Math_fround(f125 * f3);
      f126 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f128 * f25) + Math_fround(f127 * f26)) + f3));
      f4 = Math_fround(f125 * f4);
      f125 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f128 * f28) + Math_fround(f127 * f114)) + f4));
      HEAPF32[i47 >> 2] = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f128 * f117) + Math_fround(f127 * f119)) + f2));
      HEAPF32[i50 >> 2] = f126;
      HEAPF32[i54 >> 2] = f125;
      f124 = Math_fround(f124 - f116);
      f123 = Math_fround(f123 - f118);
      f3 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f124 * f25) + Math_fround(f123 * f26)) + f3));
      f4 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f124 * f28) + Math_fround(f123 * f114)) + f4));
      HEAPF32[i46 >> 2] = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f124 * f117) + Math_fround(f123 * f119)) + f2));
      HEAPF32[i49 >> 2] = f3;
      HEAPF32[i53 >> 2] = f4;
      f116 = Math_fround(f5 - f116);
      f118 = Math_fround(f20 - f118);
      f121 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f116 * f25) + Math_fround(f118 * f26)) + f121));
      f122 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f116 * f28) + Math_fround(f118 * f114)) + f122));
      HEAPF32[i45 >> 2] = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f116 * f117) + Math_fround(f118 * f119)) + f120));
      HEAPF32[i48 >> 2] = f121;
      HEAPF32[i52 >> 2] = f122;
      i6 = 3;
      break L41;
     }
    case 1:
     {
      f20 = Math_fround(HEAPF32[i33 >> 2]);
      f4 = Math_fround(f20 * Math_fround(HEAPF32[i34 >> 2]));
      f5 = Math_fround(f20 * Math_fround(HEAPF32[i35 >> 2]));
      f20 = Math_fround(f20 * Math_fround(HEAPF32[i36 >> 2]));
      f4 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 12 >> 2]) - f4);
      f5 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 16 >> 2]) - f5);
      f20 = Math_fround(Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 20 >> 2]) - f20);
      f2 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f20 * f20));
      i1 = HEAP32[i15 + (i9 * 48 | 0) + 24 >> 2] | 0;
      if (f2 > f37) {
       f3 = Math_fround(HEAPF32[i38 >> 2]);
       if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
       f127 = Math_fround(HEAPF32[i10 >> 2]);
       f128 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f2 = Math_fround(f3 + Math_fround(f2 * Math_fround(f128 * f127)));
       f3 = f128;
      } else {
       f2 = Math_fround(0.0);
       f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      }
      f117 = Math_fround(f4 * f2);
      f118 = Math_fround(f5 * f2);
      f119 = Math_fround(f20 * f2);
      f121 = Math_fround(HEAPF32[i111 >> 2]);
      f127 = Math_fround(HEAPF32[i6 >> 2]);
      f20 = Math_fround(f121 * f127);
      f122 = Math_fround(HEAPF32[i11 >> 2]);
      f2 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
      f20 = Math_fround(f20 + Math_fround(f122 * f2));
      f26 = Math_fround(HEAPF32[i12 >> 2]);
      f5 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
      f20 = Math_fround(f20 + Math_fround(f26 * f5));
      f120 = Math_fround(HEAPF32[i13 >> 2]);
      f20 = Math_fround(f120 + f20);
      f124 = Math_fround(HEAPF32[i14 >> 2]);
      f24 = Math_fround(f127 * f124);
      f125 = Math_fround(HEAPF32[i16 >> 2]);
      f24 = Math_fround(f24 + Math_fround(f2 * f125));
      f27 = Math_fround(HEAPF32[i17 >> 2]);
      f24 = Math_fround(f24 + Math_fround(f5 * f27));
      f123 = Math_fround(HEAPF32[i18 >> 2]);
      f24 = Math_fround(f123 + f24);
      f128 = Math_fround(HEAPF32[i19 >> 2]);
      f25 = Math_fround(f127 * f128);
      f4 = Math_fround(HEAPF32[i21 >> 2]);
      f25 = Math_fround(f25 + Math_fround(f2 * f4));
      f28 = Math_fround(HEAPF32[i22 >> 2]);
      f25 = Math_fround(f25 + Math_fround(f5 * f28));
      f126 = Math_fround(HEAPF32[i23 >> 2]);
      f25 = Math_fround(f126 + f25);
      f127 = Math_fround(f117 + f127);
      f2 = Math_fround(f118 + f2);
      f5 = Math_fround(f119 + f5);
      f26 = Math_fround(f120 + Math_fround(Math_fround(Math_fround(f121 * f127) + Math_fround(f122 * f2)) + Math_fround(f26 * f5)));
      f27 = Math_fround(f123 + Math_fround(Math_fround(Math_fround(f127 * f124) + Math_fround(f2 * f125)) + Math_fround(f5 * f27)));
      f28 = Math_fround(f126 + Math_fround(Math_fround(Math_fround(f127 * f128) + Math_fround(f2 * f4)) + Math_fround(f5 * f28)));
      f5 = Math_fround(f26 - f20);
      f4 = Math_fround(f27 - f24);
      f2 = Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4));
      i41 = f2 < f37;
      f5 = i41 ? Math_fround(1.0) : f5;
      f4 = i41 ? Math_fround(0.0) : f4;
      f2 = i41 ? Math_fround(1.0) : f2;
      f128 = Math_fround(Math_fround(f28 * Math_fround(HEAPF32[i68 >> 2])) + Math_fround(HEAPF32[i69 >> 2]));
      f3 = Math_fround((f128 < f3 ? f128 : f3) * Math_fround(.5));
      if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
      f124 = Math_fround(f3 * f2);
      f122 = Math_fround(f4 * f124);
      f124 = Math_fround(f5 * f124);
      f114 = Math_fround(f20 - f122);
      f2 = Math_fround(f24 + f124);
      f123 = Math_fround(HEAPF32[i110 >> 2]);
      f129 = Math_fround(f123 * f114);
      f125 = Math_fround(HEAPF32[i95 >> 2]);
      f129 = Math_fround(f129 + Math_fround(f125 * f2));
      f4 = Math_fround(HEAPF32[i102 >> 2]);
      f126 = Math_fround(f25 * f4);
      f129 = Math_fround(f126 + f129);
      f121 = Math_fround(HEAPF32[i29 >> 2]);
      f129 = Math_fround(f121 + f129);
      f116 = Math_fround(HEAPF32[i91 >> 2]);
      f3 = Math_fround(f114 * f116);
      f117 = Math_fround(HEAPF32[i97 >> 2]);
      f3 = Math_fround(f3 + Math_fround(f2 * f117));
      f5 = Math_fround(HEAPF32[i104 >> 2]);
      f127 = Math_fround(f25 * f5);
      f3 = Math_fround(f3 + f127);
      f115 = Math_fround(HEAPF32[i30 >> 2]);
      f3 = Math_fround(f115 + f3);
      f119 = Math_fround(HEAPF32[i93 >> 2]);
      f114 = Math_fround(f114 * f119);
      f120 = Math_fround(HEAPF32[i100 >> 2]);
      f2 = Math_fround(f114 + Math_fround(f2 * f120));
      f114 = Math_fround(HEAPF32[i106 >> 2]);
      f128 = Math_fround(f25 * f114);
      f2 = Math_fround(f2 + f128);
      f118 = Math_fround(HEAPF32[i31 >> 2]);
      f2 = Math_fround(f118 + f2);
      HEAPF32[i108 >> 2] = f129;
      HEAPF32[i51 >> 2] = f3;
      HEAPF32[i55 >> 2] = f2;
      f2 = Math_fround(f26 - f122);
      f3 = Math_fround(f27 + f124);
      f25 = Math_fround(f28 * f4);
      f5 = Math_fround(f28 * f5);
      f4 = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f2 * f116) + Math_fround(f3 * f117)) + f5));
      f114 = Math_fround(f28 * f114);
      f28 = Math_fround(f118 + Math_fround(Math_fround(Math_fround(f2 * f119) + Math_fround(f3 * f120)) + f114));
      HEAPF32[i47 >> 2] = Math_fround(f121 + Math_fround(Math_fround(Math_fround(f2 * f123) + Math_fround(f3 * f125)) + f25));
      HEAPF32[i50 >> 2] = f4;
      HEAPF32[i54 >> 2] = f28;
      f26 = Math_fround(f26 + f122);
      f27 = Math_fround(f27 - f124);
      f28 = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f26 * f116) + Math_fround(f27 * f117)) + f5));
      f114 = Math_fround(f118 + Math_fround(Math_fround(Math_fround(f26 * f119) + Math_fround(f27 * f120)) + f114));
      HEAPF32[i46 >> 2] = Math_fround(f121 + Math_fround(Math_fround(Math_fround(f26 * f123) + Math_fround(f27 * f125)) + f25));
      HEAPF32[i49 >> 2] = f28;
      HEAPF32[i53 >> 2] = f114;
      f122 = Math_fround(f20 + f122);
      f124 = Math_fround(f24 - f124);
      f127 = Math_fround(f115 + Math_fround(Math_fround(Math_fround(f122 * f116) + Math_fround(f124 * f117)) + f127));
      f128 = Math_fround(f118 + Math_fround(Math_fround(Math_fround(f122 * f119) + Math_fround(f124 * f120)) + f128));
      HEAPF32[i45 >> 2] = Math_fround(f121 + Math_fround(Math_fround(Math_fround(f122 * f123) + Math_fround(f124 * f125)) + f126));
      HEAPF32[i48 >> 2] = f127;
      HEAPF32[i52 >> 2] = f128;
      i6 = 1;
      break L41;
     }
    default:
     {
      i6 = i1;
      break L41;
     }
    }
   } while (0);
   if ((i7 | 0) == 32) {
    f118 = Math_fround(HEAPF32[i109 >> 2]);
    f124 = Math_fround(HEAPF32[i6 >> 2]);
    f118 = Math_fround(f118 * f124);
    f120 = Math_fround(HEAPF32[i57 >> 2]);
    f121 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 4 >> 2]);
    f120 = Math_fround(f118 + Math_fround(f120 * f121));
    f118 = Math_fround(HEAPF32[i58 >> 2]);
    f119 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 8 >> 2]);
    f118 = Math_fround(f120 + Math_fround(f118 * f119));
    f118 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) + f118);
    f120 = Math_fround(f124 * Math_fround(HEAPF32[i60 >> 2]));
    f120 = Math_fround(f120 + Math_fround(f121 * Math_fround(HEAPF32[i61 >> 2])));
    f120 = Math_fround(f120 + Math_fround(f119 * Math_fround(HEAPF32[i62 >> 2])));
    f120 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) + f120);
    f124 = Math_fround(f124 * Math_fround(HEAPF32[i64 >> 2]));
    f121 = Math_fround(f124 + Math_fround(f121 * Math_fround(HEAPF32[i65 >> 2])));
    f119 = Math_fround(f121 + Math_fround(f119 * Math_fround(HEAPF32[i66 >> 2])));
    f119 = Math_fround(Math_fround(HEAPF32[i67 >> 2]) + f119);
    f121 = Math_fround(f89 + Math_fround(Math_fround(Math_fround(f86 * f118) + Math_fround(f87 * f120)) + Math_fround(f88 * f119)));
    f121 = Math_fround(Math_fround(HEAPF32[i68 >> 2]) * f121);
    f121 = Math_fround(Math_fround(HEAPF32[i69 >> 2]) + f121);
    f124 = Math_fround(+Math_sin(+f2));
    f126 = Math_fround(+Math_cos(+f2));
    f129 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 24 >> 2]);
    f129 = Math_fround((f121 < f129 ? f121 : f129) * Math_fround(.5));
    f121 = Math_fround(Math_fround(Math_fround(f90 * f126) - Math_fround(f96 * f124)) * f129);
    f122 = Math_fround(Math_fround(Math_fround(f92 * f126) - Math_fround(f98 * f124)) * f129);
    f123 = Math_fround(Math_fround(Math_fround(f94 * f126) - Math_fround(f101 * f124)) * f129);
    f127 = Math_fround(Math_fround(Math_fround(f90 * f124) + Math_fround(f96 * f126)) * f129);
    f128 = Math_fround(Math_fround(Math_fround(f92 * f124) + Math_fround(f98 * f126)) * f129);
    f129 = Math_fround(Math_fround(Math_fround(f94 * f124) + Math_fround(f101 * f126)) * f129);
    f126 = Math_fround(f118 - f121);
    f124 = Math_fround(f120 - f122);
    f125 = Math_fround(f119 - f123);
    f116 = Math_fround(f128 + f124);
    f117 = Math_fround(f129 + f125);
    HEAPF32[i108 >> 2] = Math_fround(f127 + f126);
    HEAPF32[i51 >> 2] = f116;
    HEAPF32[i55 >> 2] = f117;
    f121 = Math_fround(f118 + f121);
    f122 = Math_fround(f120 + f122);
    f123 = Math_fround(f119 + f123);
    f119 = Math_fround(f128 + f122);
    f120 = Math_fround(f129 + f123);
    HEAPF32[i47 >> 2] = Math_fround(f127 + f121);
    HEAPF32[i50 >> 2] = f119;
    HEAPF32[i54 >> 2] = f120;
    f122 = Math_fround(f122 - f128);
    f123 = Math_fround(f123 - f129);
    HEAPF32[i46 >> 2] = Math_fround(f121 - f127);
    HEAPF32[i49 >> 2] = f122;
    HEAPF32[i53 >> 2] = f123;
    f128 = Math_fround(f124 - f128);
    f129 = Math_fround(f125 - f129);
    HEAPF32[i45 >> 2] = Math_fround(f126 - f127);
    HEAPF32[i48 >> 2] = f128;
    HEAPF32[i52 >> 2] = f129;
    i6 = 1e3;
   }
   i1 = HEAP32[i70 >> 2] | 0;
   if ((i1 | 0) > 0) {
    f2 = Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 36 >> 2]);
    f2 = Math_fround(f2 / Math_fround(HEAPF32[i15 + (i9 * 48 | 0) + 40 >> 2]));
    i7 = f2 < Math_fround(0.0);
    i41 = f2 > Math_fround(1.0);
    f2 = Math_fround(Math_fround(1.0) - (i41 ? Math_fround(1.0) : f2));
    f2 = i7 ? Math_fround(1.0) : f2;
    i7 = (~~Math_fround(Math_fround(HEAP32[i71 >> 2] | 0) * f2) >>> 0 >>> 0) % (i1 >>> 0) | 0;
    i41 = HEAP32[i99 + (i7 << 4) >> 2] | 0;
    f2 = Math_fround(HEAPF32[i99 + (i7 << 4) + 4 >> 2]);
    f128 = Math_fround(f2 + Math_fround(HEAPF32[i99 + (i7 << 4) + 12 >> 2]));
    HEAP32[i112 >> 2] = i41;
    HEAPF32[i72 >> 2] = f128;
    f129 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f129 = Math_fround(f129 + Math_fround(HEAPF32[i99 + (i7 << 4) + 8 >> 2]));
    HEAPF32[i73 >> 2] = f129;
    HEAPF32[i74 >> 2] = f128;
    HEAPF32[i75 >> 2] = f129;
    HEAPF32[i76 >> 2] = f2;
    HEAP32[i77 >> 2] = i41;
   } else {
    HEAPF32[i112 >> 2] = Math_fround(0.0);
    HEAPF32[i72 >> 2] = Math_fround(1.0);
    HEAPF32[i73 >> 2] = Math_fround(1.0);
    HEAPF32[i74 >> 2] = Math_fround(1.0);
    HEAPF32[i75 >> 2] = Math_fround(1.0);
    HEAPF32[i76 >> 2] = Math_fround(0.0);
    HEAPF32[i84 >> 2] = Math_fround(0.0);
    f2 = Math_fround(0.0);
   }
   HEAPF32[i78 >> 2] = f2;
   i1 = HEAP32[i15 + (i9 * 48 | 0) + 44 >> 2] | 0;
   i130 = i1 >>> 16;
   i41 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0) == 0;
   HEAP32[i8 >> 2] = HEAP32[i108 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i108 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i108 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = i103;
   HEAP32[i8 + 16 >> 2] = i105;
   HEAP32[i8 + 20 >> 2] = i107;
   i1 = i1 & -16711936 | (i41 ? i1 : i130) & 255 | (i41 ? i130 : i1) << 16 & 16711680;
   HEAP32[i8 + 24 >> 2] = i1;
   i130 = i112;
   i41 = HEAP32[i130 + 4 >> 2] | 0;
   i7 = i8 + 28 | 0;
   HEAP32[i7 >> 2] = HEAP32[i130 >> 2];
   HEAP32[i7 + 4 >> 2] = i41;
   i7 = i8 + 36 | 0;
   HEAP32[i7 >> 2] = HEAP32[i79 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
   HEAP32[i8 + 48 >> 2] = i103;
   HEAP32[i8 + 52 >> 2] = i105;
   HEAP32[i8 + 56 >> 2] = i107;
   HEAP32[i8 + 60 >> 2] = i1;
   i7 = i80;
   i41 = HEAP32[i7 + 4 >> 2] | 0;
   i130 = i8 + 64 | 0;
   HEAP32[i130 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i130 + 4 >> 2] = i41;
   i130 = i8 + 72 | 0;
   HEAP32[i130 >> 2] = HEAP32[i81 >> 2];
   HEAP32[i130 + 4 >> 2] = HEAP32[i81 + 4 >> 2];
   HEAP32[i130 + 8 >> 2] = HEAP32[i81 + 8 >> 2];
   HEAP32[i8 + 84 >> 2] = i103;
   HEAP32[i8 + 88 >> 2] = i105;
   HEAP32[i8 + 92 >> 2] = i107;
   HEAP32[i8 + 96 >> 2] = i1;
   i130 = i82;
   i41 = HEAP32[i130 + 4 >> 2] | 0;
   i7 = i8 + 100 | 0;
   HEAP32[i7 >> 2] = HEAP32[i130 >> 2];
   HEAP32[i7 + 4 >> 2] = i41;
   i7 = i8 + 108 | 0;
   HEAP32[i7 >> 2] = HEAP32[i83 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i83 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i83 + 8 >> 2];
   HEAP32[i8 + 120 >> 2] = i103;
   HEAP32[i8 + 124 >> 2] = i105;
   HEAP32[i8 + 128 >> 2] = i107;
   HEAP32[i8 + 132 >> 2] = i1;
   i1 = i77;
   i7 = HEAP32[i1 + 4 >> 2] | 0;
   i41 = i8 + 136 | 0;
   HEAP32[i41 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i41 + 4 >> 2] = i7;
   i9 = i9 + 1 | 0;
   if ((i9 | 0) >= (HEAP32[i56 >> 2] | 0)) break; else {
    i1 = i6;
    i8 = i8 + 144 | 0;
   }
  }
 }
 if (!i85) {
  STACKTOP = i113;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i85, gb + 64016 | 0);
 STACKTOP = i113;
 return;
}

function __ZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeE(i49, i31, i1) {
 i49 = i49 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i51 + 600 | 0;
 i41 = i51 + 592 | 0;
 i40 = i51 + 584 | 0;
 i39 = i51 + 576 | 0;
 i38 = i51 + 568 | 0;
 i37 = i51 + 560 | 0;
 i36 = i51 + 552 | 0;
 i6 = i51 + 544 | 0;
 i5 = i51 + 528 | 0;
 i4 = i51 + 520 | 0;
 i3 = i51 + 512 | 0;
 i50 = i51;
 i45 = i51 + 744 | 0;
 i17 = i51 + 712 | 0;
 i29 = i51 + 708 | 0;
 i27 = i51 + 748 | 0;
 i28 = i51 + 704 | 0;
 i25 = i51 + 696 | 0;
 i32 = i51 + 688 | 0;
 i30 = i51 + 750 | 0;
 i43 = i51 + 656 | 0;
 i44 = i51 + 652 | 0;
 i48 = i51 + 640 | 0;
 i47 = i51 + 608 | 0;
 i26 = HEAP32[i49 >> 2] | 0;
 i2 = (i1 | 0) == 1;
 HEAP32[i50 >> 2] = i2 ? gb + 670513 | 0 : gb + 670520 | 0;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i26, 1, gb + 670527 | 0, i50);
 HEAP32[i49 + 4 >> 2] = i1;
 i26 = i49 + 60 | 0;
 HEAP8[i26 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i45 | 0, 4) | 0;
 i1 = HEAP32[i45 >> 2] | 0;
 L1 : do if ((i1 | 0) < 1296389185) {
  switch (i1 | 0) {
  case 1096041805:
   break;
  default:
   {
    i46 = 3;
    break L1;
   }
  }
  HEAP8[i26 >> 0] = 0;
 } else {
  switch (i1 | 0) {
  case 1296389185:
   break;
  default:
   {
    i46 = 3;
    break L1;
   }
  }
  HEAP8[i26 >> 0] = 1;
  if (i2) {
   __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(HEAP32[i49 >> 2] | 0, 4, gb + 670596 | 0, i4);
   i50 = 0;
   STACKTOP = i51;
   return i50 | 0;
  }
 } while (0);
 if ((i46 | 0) == 3) {
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(HEAP32[i49 >> 2] | 0, 4, gb + 670552 | 0, i3);
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i1 = i49 + 32 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i1 | 0, 4) | 0;
 i2 = i49 + 36 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i2 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i34 = HEAP8[i1 >> 0] | 0;
  i45 = i1 + 3 | 0;
  HEAP8[i1 >> 0] = HEAP8[i45 >> 0] | 0;
  HEAP8[i45 >> 0] = i34;
  i45 = i1 + 1 | 0;
  i34 = HEAP8[i45 >> 0] | 0;
  i35 = i1 + 2 | 0;
  HEAP8[i45 >> 0] = HEAP8[i35 >> 0] | 0;
  HEAP8[i35 >> 0] = i34;
  i35 = HEAP8[i2 >> 0] | 0;
  i34 = i2 + 3 | 0;
  HEAP8[i2 >> 0] = HEAP8[i34 >> 0] | 0;
  HEAP8[i34 >> 0] = i35;
  i34 = i2 + 1 | 0;
  i35 = HEAP8[i34 >> 0] | 0;
  i45 = i2 + 2 | 0;
  HEAP8[i34 >> 0] = HEAP8[i45 >> 0] | 0;
  HEAP8[i45 >> 0] = i35;
 }
 if (!(__ZN5physx2Sn18checkCompatibilityEjj(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0)) {
  __ZN5physx2Sn27getCompatibilityVersionsStrEPcj(i50, 512);
  i49 = HEAP32[i49 >> 2] | 0;
  i48 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i48;
  HEAP32[i5 + 8 >> 2] = i50;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 4, gb + 670679 | 0, i5);
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i1 = i49 + 40 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i1 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i35 = HEAP8[i1 >> 0] | 0;
  i34 = i1 + 3 | 0;
  HEAP8[i1 >> 0] = HEAP8[i34 >> 0] | 0;
  HEAP8[i34 >> 0] = i35;
  i34 = i1 + 1 | 0;
  i35 = HEAP8[i34 >> 0] | 0;
  i45 = i1 + 2 | 0;
  HEAP8[i34 >> 0] = HEAP8[i45 >> 0] | 0;
  HEAP8[i45 >> 0] = i35;
 }
 i35 = i49 + 44 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i35 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i34 = HEAP8[i35 >> 0] | 0;
  i33 = i35 + 3 | 0;
  HEAP8[i35 >> 0] = HEAP8[i33 >> 0] | 0;
  HEAP8[i33 >> 0] = i34;
  i33 = i35 + 1 | 0;
  i34 = HEAP8[i33 >> 0] | 0;
  i45 = i35 + 2 | 0;
  HEAP8[i33 >> 0] = HEAP8[i45 >> 0] | 0;
  HEAP8[i45 >> 0] = i34;
 }
 i1 = i49 + 48 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i1 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i34 = HEAP8[i1 >> 0] | 0;
  i33 = i1 + 3 | 0;
  HEAP8[i1 >> 0] = HEAP8[i33 >> 0] | 0;
  HEAP8[i33 >> 0] = i34;
  i33 = i1 + 1 | 0;
  i34 = HEAP8[i33 >> 0] | 0;
  i45 = i1 + 2 | 0;
  HEAP8[i33 >> 0] = HEAP8[i45 >> 0] | 0;
  HEAP8[i45 >> 0] = i34;
 }
 i34 = HEAP32[i1 >> 2] | 0;
 i45 = (i34 | 0) == 1430866263;
 if (!(__ZN5physx2Sn24isBinaryPlatformTagValidEj(i34) | 0)) {
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(HEAP32[i49 >> 2] | 0, 4, gb + 670796 | 0, i6);
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i1 = i49 + 52 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i1 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i33 = HEAP8[i1 >> 0] | 0;
  i24 = i1 + 3 | 0;
  HEAP8[i1 >> 0] = HEAP8[i24 >> 0] | 0;
  HEAP8[i24 >> 0] = i33;
  i24 = i1 + 1 | 0;
  i33 = HEAP8[i24 >> 0] | 0;
  i34 = i1 + 2 | 0;
  HEAP8[i24 >> 0] = HEAP8[i34 >> 0] | 0;
  HEAP8[i34 >> 0] = i33;
 }
 i1 = i49 + 56 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i1 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i33 = HEAP8[i1 >> 0] | 0;
  i24 = i1 + 3 | 0;
  HEAP8[i1 >> 0] = HEAP8[i24 >> 0] | 0;
  HEAP8[i24 >> 0] = i33;
  i24 = i1 + 1 | 0;
  i33 = HEAP8[i24 >> 0] | 0;
  i34 = i1 + 2 | 0;
  HEAP8[i24 >> 0] = HEAP8[i34 >> 0] | 0;
  HEAP8[i34 >> 0] = i33;
 }
 i34 = i49 + 8 | 0;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i34 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i24 = HEAP8[i34 >> 0] | 0;
  i23 = i34 + 3 | 0;
  HEAP8[i34 >> 0] = HEAP8[i23 >> 0] | 0;
  HEAP8[i23 >> 0] = i24;
  i23 = i34 + 1 | 0;
  i24 = HEAP8[i23 >> 0] | 0;
  i33 = i34 + 2 | 0;
  HEAP8[i23 >> 0] = HEAP8[i33 >> 0] | 0;
  HEAP8[i33 >> 0] = i24;
 }
 i3 = HEAP32[i34 >> 2] | 0;
 i2 = i3 << 5;
 i1 = i3 >>> 0 > 134217727 ? -1 : i2;
 if (!i1) i1 = 0; else {
  i24 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i23 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  i33 = _PxGetFoundation() | 0;
  i33 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 24 >> 2] | 0, i33 | 0) | 0;
  i1 = mftCall_iiiiii(i23 | 0, i24 | 0, i1 | 0, (i33 ? gb + 670846 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 363) | 0;
 }
 if (i3 | 0) _memset(i1 | 0, 0, i2 | 0) | 0;
 i33 = i49 + 12 | 0;
 HEAP32[i33 >> 2] = i1;
 i2 = HEAP32[i34 >> 2] | 0;
 i3 = (i2 | 0) > 0;
 if ((HEAP32[i35 >> 2] | 0) == 8) {
  if (i3) {
   i3 = i50 + 8 | 0;
   i4 = i50 + 16 | 0;
   i5 = i50 + 20 | 0;
   i6 = i50 + 24 | 0;
   i7 = i50 + 28 | 0;
   i8 = i50 + 32 | 0;
   i9 = i50 + 36 | 0;
   i10 = i50 + 7 | 0;
   i11 = i50 + 1 | 0;
   i12 = i50 + 6 | 0;
   i13 = i50 + 2 | 0;
   i14 = i50 + 5 | 0;
   i15 = i50 + 3 | 0;
   i16 = i50 + 4 | 0;
   i17 = i3 + 7 | 0;
   i18 = i3 + 1 | 0;
   i19 = i3 + 6 | 0;
   i20 = i3 + 2 | 0;
   i21 = i3 + 5 | 0;
   i22 = i3 + 3 | 0;
   i23 = i3 + 4 | 0;
   i24 = 0;
   do {
    mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i50 | 0, 40) | 0;
    if (HEAP8[i26 >> 0] | 0) {
     i2 = HEAP32[i50 >> 2] | 0;
     HEAP8[i50 >> 0] = HEAP8[i10 >> 0] | 0;
     HEAP8[i10 >> 0] = i2;
     HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
     HEAP8[i12 >> 0] = (i2 & 65535) >>> 8;
     HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
     HEAP8[i14 >> 0] = i2 >>> 16;
     HEAP8[i15 >> 0] = HEAP8[i16 >> 0] | 0;
     HEAP8[i16 >> 0] = i2 >>> 24;
     i2 = HEAP32[i3 >> 2] | 0;
     HEAP8[i3 >> 0] = HEAP8[i17 >> 0] | 0;
     HEAP8[i17 >> 0] = i2;
     HEAP8[i18 >> 0] = HEAP8[i19 >> 0] | 0;
     HEAP8[i19 >> 0] = (i2 & 65535) >>> 8;
     HEAP8[i20 >> 0] = HEAP8[i21 >> 0] | 0;
     HEAP8[i21 >> 0] = i2 >>> 16;
     HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
     HEAP8[i23 >> 0] = i2 >>> 24;
    }
    i1 = HEAP32[i33 >> 2] | 0;
    HEAP32[i1 + (i24 << 5) >> 2] = HEAP32[i50 >> 2];
    HEAP32[i1 + (i24 << 5) + 4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + (i24 << 5) + 8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + (i24 << 5) + 12 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i1 + (i24 << 5) + 16 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + (i24 << 5) + 20 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i1 + (i24 << 5) + 24 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + (i24 << 5) + 28 >> 2] = HEAP32[i9 >> 2];
    i24 = i24 + 1 | 0;
    i2 = HEAP32[i34 >> 2] | 0;
   } while ((i24 | 0) < (i2 | 0));
  }
 } else if (i3) {
  i3 = i17 + 4 | 0;
  i4 = i17 + 8 | 0;
  i5 = i17 + 12 | 0;
  i6 = i17 + 16 | 0;
  i7 = i17 + 20 | 0;
  i8 = i17 + 24 | 0;
  i9 = i17 + 28 | 0;
  i10 = i17 + 3 | 0;
  i11 = i17 + 1 | 0;
  i12 = i17 + 2 | 0;
  i13 = i3 + 3 | 0;
  i14 = i3 + 1 | 0;
  i15 = i3 + 2 | 0;
  i16 = 0;
  do {
   mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i17 | 0, 32) | 0;
   if (HEAP8[i26 >> 0] | 0) {
    i24 = HEAP32[i17 >> 2] | 0;
    HEAP8[i17 >> 0] = i24 >>> 24;
    HEAP8[i10 >> 0] = i24;
    HEAP8[i11 >> 0] = i24 >>> 16;
    HEAP8[i12 >> 0] = (i24 & 65535) >>> 8;
    i24 = HEAP32[i3 >> 2] | 0;
    HEAP8[i3 >> 0] = i24 >>> 24;
    HEAP8[i13 >> 0] = i24;
    HEAP8[i14 >> 0] = i24 >>> 16;
    HEAP8[i15 >> 0] = (i24 & 65535) >>> 8;
   }
   i1 = HEAP32[i33 >> 2] | 0;
   HEAP32[i1 + (i16 << 5) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i1 + (i16 << 5) + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + (i16 << 5) + 8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + (i16 << 5) + 12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + (i16 << 5) + 16 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + (i16 << 5) + 20 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + (i16 << 5) + 24 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + (i16 << 5) + 28 >> 2] = HEAP32[i9 >> 2];
   i16 = i16 + 1 | 0;
   i2 = HEAP32[i34 >> 2] | 0;
  } while ((i16 | 0) < (i2 | 0));
 }
 L63 : do if ((HEAP8[i26 >> 0] | 0) != 0 & (i2 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  while (1) {
   i24 = i2 + (i1 << 5) + 8 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i24 = (HEAP32[i33 >> 2] | 0) + (i1 << 5) + 12 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i24 = (HEAP32[i33 >> 2] | 0) + (i1 << 5) + 16 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i24 = (HEAP32[i33 >> 2] | 0) + (i1 << 5) + 20 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i24 = (HEAP32[i33 >> 2] | 0) + (i1 << 5) + 24 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i24 = (HEAP32[i33 >> 2] | 0) + (i1 << 5) + 28 | 0;
   i23 = HEAP8[i24 >> 0] | 0;
   i22 = i24 + 3 | 0;
   HEAP8[i24 >> 0] = HEAP8[i22 >> 0] | 0;
   HEAP8[i22 >> 0] = i23;
   i22 = i24 + 1 | 0;
   i23 = HEAP8[i22 >> 0] | 0;
   i24 = i24 + 2 | 0;
   HEAP8[i22 >> 0] = HEAP8[i24 >> 0] | 0;
   HEAP8[i24 >> 0] = i23;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i34 >> 2] | 0)) break L63;
   i2 = HEAP32[i33 >> 2] | 0;
  }
 } while (0);
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i29 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i24 = HEAP32[i29 >> 2] | 0;
  HEAP8[i29 >> 0] = i24 >>> 24;
  HEAP8[i29 + 3 >> 0] = i24;
  HEAP8[i29 + 1 >> 0] = i24 >>> 16;
  HEAP8[i29 + 2 >> 0] = (i24 & 65535) >>> 8;
 }
 i1 = HEAP32[HEAP32[i31 >> 2] >> 2] | 0;
 if ((HEAP32[i29 >> 2] | 0) > 0) {
  i5 = i49 + 64 | 0;
  i6 = i25 + 4 | 0;
  i7 = i49 + 72 | 0;
  i8 = i49 + 68 | 0;
  i9 = i27 + 1 | 0;
  i10 = i28 + 3 | 0;
  i11 = i28 + 1 | 0;
  i12 = i28 + 2 | 0;
  i4 = 0;
  do {
   mftCall_iiii(i1 | 0, i31 | 0, i27 | 0, 2) | 0;
   mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i28 | 0, 4) | 0;
   if (HEAP8[i26 >> 0] | 0) {
    i24 = HEAP16[i27 >> 1] | 0;
    HEAP8[i27 >> 0] = (i24 & 65535) >>> 8;
    HEAP8[i9 >> 0] = i24;
    i24 = HEAP32[i28 >> 2] | 0;
    HEAP8[i28 >> 0] = i24 >>> 24;
    HEAP8[i10 >> 0] = i24;
    HEAP8[i11 >> 0] = i24 >>> 16;
    HEAP8[i12 >> 0] = (i24 & 65535) >>> 8;
   }
   i1 = HEAPU16[i27 >> 1] | 0;
   HEAP32[i25 >> 2] = i1;
   i2 = HEAP32[i28 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i24 = HEAP32[i5 >> 2] | 0;
    HEAP32[i24 + (i3 << 3) >> 2] = i1;
    HEAP32[i24 + (i3 << 3) + 4 >> 2] = i2;
    HEAP32[i8 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayINS0_4PairINS_14PxConcreteType4EnumEjEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i5, i25) | 0;
   i4 = i4 + 1 | 0;
   i1 = HEAP32[HEAP32[i31 >> 2] >> 2] | 0;
  } while ((i4 | 0) < (HEAP32[i29 >> 2] | 0));
 }
 mftCall_iiii(i1 | 0, i31 | 0, i32 | 0, 4) | 0;
 if (HEAP8[i26 >> 0] | 0) {
  i29 = HEAP32[i32 >> 2] | 0;
  HEAP8[i32 >> 0] = i29 >>> 24;
  HEAP8[i32 + 3 >> 0] = i29;
  HEAP8[i32 + 1 >> 0] = i29 >>> 16;
  HEAP8[i32 + 2 >> 0] = (i29 & 65535) >>> 8;
 }
 i19 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, HEAP32[i32 >> 2] | 0, gb + 670404 | 0, 450) | 0;
 i17 = i49 + 16 | 0;
 HEAP32[i17 >> 2] = i19;
 mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i19 | 0, HEAP32[i32 >> 2] | 0) | 0;
 i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i16 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i16 | 0, i19 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i19 = i1 + 24 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 292;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1087825;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i19 = i49 + 20 | 0;
 i16 = i49 + 28 | 0;
 i20 = i49 + 24 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 292;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1087452;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 293;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1087483;
 HEAP32[i1 + 16 >> 2] = 2;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 294;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1087830;
 HEAP32[i1 + 16 >> 2] = 4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 295;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 774357;
 HEAP32[i1 + 16 >> 2] = 8;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 296;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1087895;
 HEAP32[i1 + 16 >> 2] = 4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i32 | 0, i2 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i50 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 297;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 671086;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i20 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
 if ((HEAP32[i34 >> 2] | 0) > 0) {
  i9 = i43 + 4 | 0;
  i10 = i43 + 8 | 0;
  i8 = i45 << 31 >> 31;
  i11 = i43 + 12 | 0;
  i12 = i43 + 16 | 0;
  i13 = i43 + 24 | 0;
  i14 = i49 + 20 | 0;
  i1 = 0;
  i15 = 0;
  do {
   i5 = HEAP32[i33 >> 2] | 0;
   i3 = i5 + (i15 << 5) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (-1 | 0)) i6 = 0; else i6 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
   HEAP32[i3 >> 2] = i6;
   i3 = i5 + (i15 << 5) + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == (-1 | 0)) i4 = 0; else i4 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i5 + (i15 << 5) + 24 >> 2] | 0;
   L124 : do if (!(i3 & 4)) {
    if (i3 & 1 | 0) {
     i2 = HEAP32[i49 >> 2] | 0;
     if (i4 | 0) {
      HEAP32[i39 >> 2] = i4;
      __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i2, 1, gb + 671238 | 0, i39);
      i2 = i1 + 24 | 0;
      i3 = (HEAP32[i33 >> 2] | 0) + (i15 << 5) | 0;
      i4 = i1 + 28 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if ((HEAP32[i1 + 32 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
       i32 = (HEAP32[i2 >> 2] | 0) + (i5 << 5) | 0;
       HEAP32[i32 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i32 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i32 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i32 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i32 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i32 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i32 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i32 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i3) | 0;
       break;
      }
     }
     HEAP32[i38 >> 2] = i6;
     __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i2, 1, gb + 671221 | 0, i38);
     i2 = HEAP32[i33 >> 2] | 0;
     i32 = HEAP32[i2 + (i15 << 5) >> 2] | 0;
     i2 = HEAP32[i2 + (i15 << 5) + 12 >> 2] | 0;
     i31 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i30 = HEAP32[(HEAP32[i31 >> 2] | 0) + 8 >> 2] | 0;
     i1 = _PxGetFoundation() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(i30 | 0, i31 | 0, 52, (i1 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
     i31 = i1 + 24 | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     HEAP32[i31 + 8 >> 2] = 0;
     HEAP32[i31 + 12 >> 2] = 0;
     HEAP32[i31 + 16 >> 2] = 0;
     HEAP32[i31 + 20 >> 2] = 0;
     HEAP32[i50 >> 2] = i1;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i1 + 12 >> 2] = i32;
     HEAP32[i1 + 16 >> 2] = i2;
     HEAP32[i1 + 20 >> 2] = 0;
     HEAP8[i1 + 48 >> 0] = 0;
     i2 = HEAP32[i20 >> 2] | 0;
     if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i1;
      HEAP32[i20 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
     if (!(HEAP32[(HEAP32[i33 >> 2] | 0) + (i15 << 5) + 24 >> 2] & 2)) break;
     HEAP32[i43 >> 2] = 0;
     HEAP32[i43 + 4 >> 2] = 0;
     HEAP32[i43 + 8 >> 2] = 0;
     HEAP32[i43 + 12 >> 2] = 0;
     HEAP32[i43 + 16 >> 2] = 0;
     HEAP32[i43 + 20 >> 2] = 0;
     HEAP32[i43 + 24 >> 2] = 0;
     HEAP32[i43 + 28 >> 2] = 0;
     HEAP32[i43 >> 2] = gb + 669663;
     HEAP32[i9 >> 2] = gb + 669663;
     HEAP32[i10 >> 2] = i8;
     HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i12 >> 2] = 1;
     HEAP32[i13 >> 2] = 8;
     i2 = i1 + 36 | 0;
     i3 = i1 + 40 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i1 + 44 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i32 = (HEAP32[i2 >> 2] | 0) + (i4 << 5) | 0;
      HEAP32[i32 >> 2] = HEAP32[i43 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
      HEAP32[i32 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
      HEAP32[i32 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
      HEAP32[i32 + 16 >> 2] = HEAP32[i43 + 16 >> 2];
      HEAP32[i32 + 20 >> 2] = HEAP32[i43 + 20 >> 2];
      HEAP32[i32 + 24 >> 2] = HEAP32[i43 + 24 >> 2];
      HEAP32[i32 + 28 >> 2] = HEAP32[i43 + 28 >> 2];
      HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i43) | 0;
      break;
     }
    }
    do if (!(i3 & 256)) i2 = i5; else {
     i2 = HEAP32[i49 >> 2] | 0;
     if (!(HEAP32[i5 + (i15 << 5) + 12 >> 2] | 0)) {
      __ZN5physx2Sn5ConvX17registerUnionTypeEPKcS3_i(i2, i6, i4, HEAP32[i5 + (i15 << 5) + 8 >> 2] | 0) | 0;
      break L124;
     } else {
      __ZN5physx2Sn5ConvX13registerUnionEPKc(i2, i6) | 0;
      i3 = HEAP32[i33 >> 2] | 0;
      i2 = i3;
      i3 = HEAP32[i3 + (i15 << 5) + 24 >> 2] | 0;
      break;
     }
    } while (0);
    i2 = i2 + (i15 << 5) | 0;
    i4 = i1 + 36 | 0;
    i5 = i1 + 40 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i1 + 44 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
     i32 = (HEAP32[i4 >> 2] | 0) + (i6 << 5) | 0;
     HEAP32[i32 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i32 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i32 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i32 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i32 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i32 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i32 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i2) | 0;
    if (i3 & 512 | 0) {
     i32 = HEAP32[i49 >> 2] | 0;
     i30 = HEAP32[i33 >> 2] | 0;
     i31 = HEAP32[i30 + (i15 << 5) + 4 >> 2] | 0;
     HEAP32[i40 >> 2] = HEAP32[i30 + (i15 << 5) >> 2];
     HEAP32[i40 + 4 >> 2] = i31;
     __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i32, 1, gb + 671260 | 0, i40);
     break;
    }
    i3 = HEAP32[i33 >> 2] | 0;
    i32 = HEAP32[i3 + (i15 << 5) + 24 >> 2] | 0;
    i2 = HEAP32[i49 >> 2] | 0;
    i3 = HEAP32[i3 + (i15 << 5) >> 2] | 0;
    i4 = i32 & 8 | 0 ? gb + 1086428 | 0 : gb + 1576256 | 0;
    if (!(i32 & 16)) {
     HEAP32[i42 >> 2] = i3;
     HEAP32[i42 + 4 >> 2] = i4;
     __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i2, 1, gb + 671320 | 0, i42);
     break;
    } else {
     HEAP32[i41 >> 2] = i3;
     HEAP32[i41 + 4 >> 2] = i4;
     __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i2, 1, gb + 671290 | 0, i41);
     break;
    }
   } else {
    i7 = HEAP32[i49 >> 2] | 0;
    HEAP32[i36 >> 2] = i4;
    HEAP32[i36 + 4 >> 2] = i6;
    __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i7, 1, gb + 671098 | 0, i36);
    i6 = HEAP32[i33 >> 2] | 0;
    i7 = HEAP32[i6 + (i15 << 5) + 4 >> 2] | 0;
    i2 = HEAP32[i20 >> 2] | 0;
    L160 : do if (i2 | 0) {
     i4 = HEAP32[i14 >> 2] | 0;
     i5 = 0;
     while (1) {
      i3 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
      i5 = i5 + 1 | 0;
      if (!(_strcmp(HEAP32[i3 + 12 >> 2] | 0, i7) | 0)) break;
      if (i5 >>> 0 >= i2 >>> 0) break L160;
     }
     while (1) {
      i2 = HEAP32[i3 + 8 >> 2] | 0;
      if (!i2) {
       i2 = i3;
       break;
      } else i3 = i2;
     }
     if (!i2) break;
     i31 = HEAP32[i6 + (i15 << 5) >> 2] | 0;
     i32 = HEAP32[i2 + 16 >> 2] | 0;
     i29 = HEAP32[i2 >> 2] | 0;
     i30 = HEAP32[i2 + 4 >> 2] | 0;
     i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i27 = HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0;
     i3 = _PxGetFoundation() | 0;
     i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
     i3 = mftCall_iiiiii(i27 | 0, i28 | 0, 52, (i3 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
     i28 = i3 + 24 | 0;
     HEAP32[i28 >> 2] = 0;
     HEAP32[i28 + 4 >> 2] = 0;
     HEAP32[i28 + 8 >> 2] = 0;
     HEAP32[i28 + 12 >> 2] = 0;
     HEAP32[i28 + 16 >> 2] = 0;
     HEAP32[i28 + 20 >> 2] = 0;
     HEAP32[i50 >> 2] = i3;
     HEAP32[i3 >> 2] = i29;
     HEAP32[i3 + 4 >> 2] = i30;
     HEAP32[i3 + 8 >> 2] = i2;
     HEAP32[i3 + 12 >> 2] = i31;
     HEAP32[i3 + 16 >> 2] = i32;
     HEAP32[i3 + 20 >> 2] = 0;
     HEAP8[i3 + 48 >> 0] = 0;
     i2 = HEAP32[i20 >> 2] | 0;
     if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i3;
      HEAP32[i20 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i19, i50) | 0;
     break L124;
    } while (0);
    i32 = HEAP32[i49 >> 2] | 0;
    HEAP32[i37 >> 2] = i7;
    __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i32, 32, gb + 671123 | 0, i37);
   } while (0);
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) < (HEAP32[i34 >> 2] | 0));
 }
 i2 = HEAP32[i20 >> 2] | 0;
 do if (i45) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (!i2) {
   i2 = 0;
   break;
  } else i9 = 0;
  do {
   i7 = HEAP32[i1 + (i9 << 2) >> 2] | 0;
   do if (!(HEAP32[i7 + 28 >> 2] | 0)) {
    i4 = HEAP32[i7 + 40 >> 2] | 0;
    if (!i4) break;
    i5 = HEAP32[i7 + 36 >> 2] | 0;
    if ((HEAP32[i5 >> 2] | 0) != (gb + 669663 | 0)) break;
    i8 = i5 + 8 | 0;
    HEAP32[i8 >> 2] = 0;
    if (i4 >>> 0 > 1) {
     i6 = 1;
     i3 = 1879048191;
    } else break;
    do {
     if (HEAP32[i5 + (i6 << 5) + 4 >> 2] | 0) {
      i46 = HEAP32[i5 + (i6 << 5) + 8 >> 2] | 0;
      i3 = (i46 | 0) < (i3 | 0) ? i46 : i3;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i4 | 0));
    if (i3 | 0) break;
    HEAP32[i8 >> 2] = (HEAP32[i7 + 16 >> 2] | 0) + -4;
   } while (0);
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i2 | 0));
  i46 = 130;
 } else i46 = 130; while (0);
 L192 : do if ((i46 | 0) == 130) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (!i2) {
   i2 = 0;
   break;
  } else i3 = 0;
  while (1) {
   i1 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
   HEAP32[i44 >> 2] = 0;
   if (!(__ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local13_computeDepthERKS1_PNS0_9MetaClassEiRi(i49, i1, 0, i44) | 0)) {
    i1 = 0;
    break;
   }
   HEAP32[i1 + 20 >> 2] = HEAP32[i44 >> 2];
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   if (i3 >>> 0 >= i2 >>> 0) break L192;
  }
  STACKTOP = i51;
  return i1 | 0;
 } while (0);
 _qsort(i1, i2, 4, fb + 825 | 0);
 i13 = HEAP32[i20 >> 2] | 0;
 if (!i13) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 }
 i14 = i48 + 4 | 0;
 i15 = i48 + 8 | 0;
 i16 = i49 + 20 | 0;
 i17 = i47 + 8 | 0;
 i18 = 0;
 do {
  i1 = HEAP32[i19 >> 2] | 0;
  i12 = HEAP32[i1 + (i18 << 2) >> 2] | 0;
  i8 = HEAP32[i12 + 28 >> 2] | 0;
  HEAP32[i48 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  L204 : do if (i8 | 0) {
   i9 = i12 + 24 | 0;
   i10 = i12 + 36 | 0;
   i11 = i12 + 48 | 0;
   i2 = 0;
   while (1) {
    i6 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i6 + (i2 << 5) + 4 >> 2] | 0;
    i5 = 0;
    while (1) {
     i3 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
     if (!(_strcmp(HEAP32[i3 + 12 >> 2] | 0, i4) | 0)) break; else i5 = i5 + 1 | 0;
    }
    while (1) {
     i1 = HEAP32[i3 + 8 >> 2] | 0;
     if (!i1) break; else i3 = i1;
    }
    i7 = HEAP32[i3 + 40 >> 2] | 0;
    L213 : do if (i7 | 0) {
     i5 = i3 + 36 | 0;
     i4 = i6 + (i2 << 5) + 8 | 0;
     if (i45) i3 = 0; else {
      i3 = 0;
      while (1) {
       i44 = (HEAP32[i5 >> 2] | 0) + (i3 << 5) | 0;
       HEAP32[i47 >> 2] = HEAP32[i44 >> 2];
       HEAP32[i47 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
       HEAP32[i47 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
       HEAP32[i47 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
       HEAP32[i47 + 16 >> 2] = HEAP32[i44 + 16 >> 2];
       HEAP32[i47 + 20 >> 2] = HEAP32[i44 + 20 >> 2];
       HEAP32[i47 + 24 >> 2] = HEAP32[i44 + 24 >> 2];
       HEAP32[i47 + 28 >> 2] = HEAP32[i44 + 28 >> 2];
       if ((HEAP32[i17 >> 2] | 0) == 0 ? (HEAP32[i47 >> 2] | 0) == (gb + 669663 | 0) : 0) {
        if (HEAP32[i4 >> 2] | 0) i46 = 153;
       } else i46 = 153;
       do if ((i46 | 0) == 153) {
        i46 = 0;
        HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i4 >> 2] | 0);
        i1 = HEAP32[i14 >> 2] | 0;
        if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
         i44 = (HEAP32[i48 >> 2] | 0) + (i1 << 5) | 0;
         HEAP32[i44 >> 2] = HEAP32[i47 >> 2];
         HEAP32[i44 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
         HEAP32[i44 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
         HEAP32[i44 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
         HEAP32[i44 + 16 >> 2] = HEAP32[i47 + 16 >> 2];
         HEAP32[i44 + 20 >> 2] = HEAP32[i47 + 20 >> 2];
         HEAP32[i44 + 24 >> 2] = HEAP32[i47 + 24 >> 2];
         HEAP32[i44 + 28 >> 2] = HEAP32[i47 + 28 >> 2];
         HEAP32[i14 >> 2] = i1 + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i48, i47) | 0;
         break;
        }
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i7 | 0)) break L213;
      }
     }
     do {
      i44 = (HEAP32[i5 >> 2] | 0) + (i3 << 5) | 0;
      HEAP32[i47 >> 2] = HEAP32[i44 >> 2];
      HEAP32[i47 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
      HEAP32[i47 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
      HEAP32[i47 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
      HEAP32[i47 + 16 >> 2] = HEAP32[i44 + 16 >> 2];
      HEAP32[i47 + 20 >> 2] = HEAP32[i44 + 20 >> 2];
      HEAP32[i47 + 24 >> 2] = HEAP32[i44 + 24 >> 2];
      HEAP32[i47 + 28 >> 2] = HEAP32[i44 + 28 >> 2];
      do if ((HEAP32[i47 >> 2] | 0) == (gb + 669663 | 0)) {
       if (HEAP32[i4 >> 2] | 0) {
        i46 = 146;
        break;
       }
       i1 = (HEAP32[i10 >> 2] | 0) + 8 | 0;
       if ((HEAP32[i1 >> 2] | 0) != -1) {
        i46 = 146;
        break;
       }
       HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
      } else i46 = 146; while (0);
      do if ((i46 | 0) == 146) {
       i46 = 0;
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i4 >> 2] | 0);
       i1 = HEAP32[i14 >> 2] | 0;
       if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        i44 = (HEAP32[i48 >> 2] | 0) + (i1 << 5) | 0;
        HEAP32[i44 >> 2] = HEAP32[i47 >> 2];
        HEAP32[i44 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
        HEAP32[i44 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
        HEAP32[i44 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
        HEAP32[i44 + 16 >> 2] = HEAP32[i47 + 16 >> 2];
        HEAP32[i44 + 20 >> 2] = HEAP32[i47 + 20 >> 2];
        HEAP32[i44 + 24 >> 2] = HEAP32[i47 + 24 >> 2];
        HEAP32[i44 + 28 >> 2] = HEAP32[i47 + 28 >> 2];
        HEAP32[i14 >> 2] = i1 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i48, i47) | 0;
        break;
       }
      } while (0);
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
    } while (0);
    HEAP8[i11 >> 0] = 1;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i8 | 0)) break L204;
    i1 = HEAP32[i16 >> 2] | 0;
   }
  } while (0);
  i4 = i12 + 36 | 0;
  i5 = i12 + 40 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   i3 = 0;
   do {
    i1 = (HEAP32[i4 >> 2] | 0) + (i3 << 5) | 0;
    i2 = HEAP32[i14 >> 2] | 0;
    if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     i44 = (HEAP32[i48 >> 2] | 0) + (i2 << 5) | 0;
     HEAP32[i44 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i44 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i44 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i44 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i44 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i44 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i44 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
     HEAP32[i44 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
     HEAP32[i14 >> 2] = i2 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i48, i1) | 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
  }
  HEAP32[i5 >> 2] = 0;
  i6 = HEAP32[i48 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE19resizeUninitializedEj(i4, HEAP32[i14 >> 2] << 5 >> 5);
  i1 = HEAP32[i4 >> 2] | 0;
  i44 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + (i44 << 5) | 0;
  if ((i44 | 0) > 0) {
   i2 = i6;
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    i1 = i1 + 32 | 0;
    if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
   }
  }
  i44 = HEAP32[i15 >> 2] | 0;
  if (!((i44 & 2147483647 | 0) == 0 | (i44 | 0) < 0 | (i6 | 0) == 0)) {
   i44 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 12 >> 2] | 0, i44 | 0, i6 | 0);
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i13 | 0));
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 } else i2 = 0;
 do {
  if (!(__ZN5physx2Sn9MetaClass5checkERKNS0_8MetaDataE(HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] | 0, i49) | 0)) {
   i1 = 0;
   i46 = 188;
   break;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 if ((i46 | 0) == 188) {
  STACKTOP = i51;
  return i1 | 0;
 }
 i7 = HEAP32[i20 >> 2] | 0;
 if (!i7) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 }
 i8 = 0;
 do {
  i1 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0;
  i5 = HEAP32[i1 + 40 >> 2] | 0;
  if (i5 >>> 0 >= 2) {
   i6 = HEAP32[i1 + 36 >> 2] | 0;
   i1 = i5 >>> 0 > 134217727 ? -1 : i5 << 5;
   if (!i1) i4 = 0; else {
    i49 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i48 = HEAP32[(HEAP32[i49 >> 2] | 0) + 8 >> 2] | 0;
    i4 = _PxGetFoundation() | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
    i4 = mftCall_iiiiii(i48 | 0, i49 | 0, i1 | 0, (i4 ? gb + 670846 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 780) | 0;
   }
   _memset(i4 | 0, 0, i5 << 5 | 0) | 0;
   i2 = 0;
   i1 = 0;
   do {
    if (!(HEAP32[i6 + (i2 << 5) + 24 >> 2] & 16)) {
     i48 = i6 + (i2 << 5) | 0;
     i49 = i4 + (i1 << 5) | 0;
     HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
     HEAP32[i49 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
     HEAP32[i49 + 16 >> 2] = HEAP32[i48 + 16 >> 2];
     HEAP32[i49 + 20 >> 2] = HEAP32[i48 + 20 >> 2];
     HEAP32[i49 + 24 >> 2] = HEAP32[i48 + 24 >> 2];
     HEAP32[i49 + 28 >> 2] = HEAP32[i48 + 28 >> 2];
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i5 | 0));
   i3 = i1;
   i2 = 0;
   i1 = i3;
   do {
    if (HEAP32[i6 + (i2 << 5) + 24 >> 2] & 16) {
     i48 = i6 + (i2 << 5) | 0;
     i49 = i4 + (i1 << 5) | 0;
     HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
     HEAP32[i49 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
     HEAP32[i49 + 16 >> 2] = HEAP32[i48 + 16 >> 2];
     HEAP32[i49 + 20 >> 2] = HEAP32[i48 + 20 >> 2];
     HEAP32[i49 + 24 >> 2] = HEAP32[i48 + 24 >> 2];
     HEAP32[i49 + 28 >> 2] = HEAP32[i48 + 28 >> 2];
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i5 | 0));
   _memcpy(i6 | 0, i4 | 0, i1 << 5 | 0) | 0;
   if (i4 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i50, i4);
   _qsort(i6, i3, 32, fb + 826 | 0);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i7 | 0));
 i1 = 1;
 STACKTOP = i51;
 return i1 | 0;
}

function __ZN14DetailDatabase22RefreshPrototypesStep1EPP9Texture2D(i1, i58) {
 i1 = i1 | 0;
 i58 = i58 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i74 + 164 | 0;
 i56 = i74 + 160 | 0;
 i65 = i74 + 48 | 0;
 i66 = i74 + 152 | 0;
 i67 = i74 + 144 | 0;
 i68 = i74 + 136 | 0;
 i69 = i74 + 128 | 0;
 i70 = i74 + 120 | 0;
 i71 = i74 + 112 | 0;
 i72 = i74 + 104 | 0;
 i59 = i74 + 100 | 0;
 i60 = i74 + 32 | 0;
 i61 = i74 + 96 | 0;
 i62 = i74;
 i63 = i74 + 176 | 0;
 i64 = i1 + 16 | 0;
 i17 = i1 + 20 | 0;
 if ((HEAP32[i17 >> 2] | 0) == (HEAP32[i64 >> 2] | 0)) {
  STACKTOP = i74;
  return;
 }
 i18 = i65 + 4 | 0;
 i19 = i65 + 8 | 0;
 i20 = i65 + 12 | 0;
 i21 = i65 + 16 | 0;
 i22 = i65 + 20 | 0;
 i23 = i65 + 24 | 0;
 i24 = i65 + 28 | 0;
 i25 = i65 + 32 | 0;
 i26 = i65 + 36 | 0;
 i27 = i65 + 40 | 0;
 i28 = i65 + 44 | 0;
 i29 = i60 + 4 | 0;
 i30 = i60 + 8 | 0;
 i31 = i60 + 12 | 0;
 i32 = i62 + 4 | 0;
 i33 = i62 + 8 | 0;
 i34 = i62 + 12 | 0;
 i35 = i62 + 16 | 0;
 i36 = i62 + 20 | 0;
 i37 = i62 + 24 | 0;
 i38 = i62 + 28 | 0;
 i39 = i65 + 48 | 0;
 i40 = i60 + 16 | 0;
 i41 = i62 + 32 | 0;
 i42 = i63 + 12 | 0;
 i43 = i66 + 4 | 0;
 i44 = i67 + 4 | 0;
 i45 = i57 + 4 | 0;
 i46 = i57 + 8 | 0;
 i47 = i70 + 4 | 0;
 i48 = i71 + 4 | 0;
 i49 = i65 + 4 | 0;
 i50 = i65 + 8 | 0;
 i51 = i65 + 12 | 0;
 i52 = i65 + 12 | 0;
 i53 = i57 + 4 | 0;
 i54 = i68 + 4 | 0;
 i55 = i69 + 4 | 0;
 i16 = 0;
 i15 = HEAP32[i64 >> 2] | 0;
 do {
  i13 = i58 + (i16 << 2) | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i15 + (i16 * 136 | 0) | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  L6 : do if (!i1) if (!(HEAP32[i15 + (i16 * 136 | 0) + 72 >> 2] | 0)) i73 = 226; else i73 = 246; else {
   HEAP32[i56 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i73 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
     i2 = HEAP32[i57 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i73 = 13;
    }
   }
   if ((i73 | 0) == 11) i73 = 13;
   if ((i73 | 0) == 13) {
    i73 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
   }
   i2 = (HEAP32[i15 + (i16 * 136 | 0) + 72 >> 2] | 0) != 0;
   if (!((i1 | 0) != 0 & i2)) if (i2) {
    i73 = 246;
    break;
   } else {
    i73 = 226;
    break;
   }
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31312 | 0) | 0;
   if (!i2) {
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    __Z6AppendPKcS0_(i57, gb + 934053 | 0, i1);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 80 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 104 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 116 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
    i1 = i15 + (i16 * 136 | 0) + 128 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i57);
    break;
   }
   if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0) != 1) {
    HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i73 = 31; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
      i2 = HEAP32[i57 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 31; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i73 = 33;
     }
    }
    if ((i73 | 0) == 31) i73 = 33;
    if ((i73 | 0) == 33) {
     i73 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
    }
    __Z6AppendPKcS0_(i65, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0, gb + 934071 | 0);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 80 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 104 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 116 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
    i1 = i15 + (i16 * 136 | 0) + 128 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
    break;
   }
   i5 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0) | 0;
   do if (i5 | 0) {
    HEAP32[i56 >> 2] = i5;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i73 = 49; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i2, i56);
      i3 = HEAP32[i57 >> 2] | 0;
      i12 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i73 = 49; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i73 = 51;
     }
    }
    if ((i73 | 0) == 49) i73 = 51;
    if ((i73 | 0) == 51) {
     i73 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     if (!i2) break;
    }
    i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30872 | 0) | 0;
    if (!i3) {
     HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i73 = 75; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
       i2 = HEAP32[i57 >> 2] | 0;
       i13 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 75; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i73 = 77;
      }
     }
     if ((i73 | 0) == 75) i73 = 77;
     if ((i73 | 0) == 77) {
      i73 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
     }
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     __Z6AppendPKcS0_(i65, gb + 934122 | 0, i1);
     i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
     i2 = i15 + (i16 * 136 | 0) + 80 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
     i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
     i2 = i15 + (i16 * 136 | 0) + 104 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
     i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
     i2 = i15 + (i16 * 136 | 0) + 116 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
     i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
     i1 = i15 + (i16 * 136 | 0) + 128 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
     break L6;
    }
    i6 = __ZN10MeshFilter13GetSharedMeshEv(i3) | 0;
    do if (i6 | 0) {
     HEAP32[i56 >> 2] = i6;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i73 = 93; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i3, i56);
       i4 = HEAP32[i57 >> 2] | 0;
       i12 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i73 = 93; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i73 = 95;
      }
     }
     if ((i73 | 0) == 93) i73 = 95;
     if ((i73 | 0) == 95) {
      i73 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
      if (!i3) break;
     }
     i8 = i15 + (i16 * 136 | 0) + 76 | 0;
     i11 = i3 + 32 | 0;
     i6 = HEAP32[i11 >> 2] | 0;
     i7 = i6 + 8 | 0;
     i4 = HEAP16[i6 + 10 >> 1] | 0;
     do if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
      HEAP32[i66 >> 2] = 0;
      HEAP32[i43 >> 2] = 0;
     } else {
      i5 = HEAP32[i6 + 92 >> 2] | 0;
      if (i5 | 0) if (HEAP8[i6 + 11 >> 0] | 0) {
       i12 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i4 = HEAP32[i7 >> 2] | 0;
       HEAP32[i66 >> 2] = i5 + ((i4 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0));
       HEAP32[i43 >> 2] = i12;
       i4 = i4 >>> 16 & 65535;
       break;
      }
      HEAP32[i66 >> 2] = 0;
      HEAP32[i43 >> 2] = 1;
     } while (0);
     L129 : do if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
      HEAP32[i67 >> 2] = 0;
      HEAP32[i44 >> 2] = 0;
     } else {
      i4 = HEAP32[i6 + 100 >> 2] | 0;
      i5 = HEAP32[i6 + 92 >> 2] | 0;
      do if (i5 | 0) {
       if (!(HEAP8[i6 + 11 >> 0] | 0)) break;
       i12 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i10 = HEAP16[i7 >> 1] | 0;
       HEAP32[i67 >> 2] = i5 + ((Math_imul(i12, i4) | 0) + (HEAP32[i7 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i10 & 65535) >>> 8 & 65535));
       HEAP32[i44 >> 2] = i12;
       break L129;
      } while (0);
      HEAP32[i67 >> 2] = 0;
      HEAP32[i44 >> 2] = 1;
     } while (0);
     __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i66, i67);
     i12 = i15 + (i16 * 136 | 0) + 80 | 0;
     if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) {
      i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      __Z6AppendPKcS0_(i57, gb + 934157 | 0, i1);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 104 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 116 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
      i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
      i1 = i15 + (i16 * 136 | 0) + 128 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i57);
      break L6;
     }
     i4 = HEAP32[i11 >> 2] | 0;
     i9 = i15 + (i16 * 136 | 0) + 112 | 0;
     if (!(HEAP8[i4 + 19 >> 0] | 0)) {
      i7 = HEAP32[i9 >> 2] | 0;
      i8 = i15 + (i16 * 136 | 0) + 116 | 0;
      i1 = HEAP32[i8 >> 2] | 0;
      i5 = i7;
      if ((i1 | 0) == (i7 | 0)) i6 = i1; else {
       i6 = i1 + (~((i1 + -4 - i5 | 0) >>> 2) << 2) | 0;
       HEAP32[i8 >> 2] = i6;
      }
      i4 = HEAP32[i4 + 100 >> 2] | 0;
      HEAP32[i57 >> 2] = -1;
      i1 = i6 - i5 >> 2;
      do if (i4 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEjRKS1_(i9, i4 - i1 | 0, i57); else {
       if (i4 >>> 0 >= i1 >>> 0) break;
       i1 = i7 + (i4 << 2) | 0;
       if ((i6 | 0) == (i1 | 0)) break;
       HEAP32[i8 >> 2] = i6 + (~((i6 + -4 - i1 | 0) >>> 2) << 2);
      } while (0);
     } else {
      i4 = HEAP32[i4 + 100 >> 2] | 0;
      i6 = i15 + (i16 * 136 | 0) + 116 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      i1 = HEAP32[i9 >> 2] | 0;
      i5 = i7 - i1 >> 2;
      do if (i4 >>> 0 > i5 >>> 0) {
       __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEj(i9, i4 - i5 | 0);
       i1 = HEAP32[i9 >> 2] | 0;
      } else {
       if (i4 >>> 0 >= i5 >>> 0) break;
       i4 = i1 + (i4 << 2) | 0;
       if ((i7 | 0) == (i4 | 0)) break;
       HEAP32[i6 >> 2] = i7 + (~((i7 + -4 - i4 | 0) >>> 2) << 2);
      } while (0);
      __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32(i3, i1);
     }
     i9 = HEAP32[i11 >> 2] | 0;
     i6 = i9 + 8 | 0;
     i5 = HEAP8[i9 + 15 >> 0] | 0;
     i10 = i15 + (i16 * 136 | 0) + 88 | 0;
     if (!(i5 << 24 >> 24)) {
      i7 = HEAP32[i10 >> 2] | 0;
      i8 = i15 + (i16 * 136 | 0) + 92 | 0;
      i1 = HEAP32[i8 >> 2] | 0;
      i5 = i7;
      if ((i1 | 0) == (i7 | 0)) i6 = i1; else {
       i6 = i1 + (~(((i1 + -12 - i5 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
       HEAP32[i8 >> 2] = i6;
      }
      i4 = HEAP32[i9 + 100 >> 2] | 0;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      HEAPF32[i45 >> 2] = Math_fround(1.0);
      HEAPF32[i46 >> 2] = Math_fround(0.0);
      i1 = (i6 - i5 | 0) / 12 | 0;
      do if (i4 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEjRKS1_(i10, i4 - i1 | 0, i57); else {
       if (i4 >>> 0 >= i1 >>> 0) break;
       i1 = i7 + (i4 * 12 | 0) | 0;
       if ((i6 | 0) == (i1 | 0)) break;
       HEAP32[i8 >> 2] = i6 + (~(((i6 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
      } while (0);
     } else {
      i1 = HEAP16[i9 + 14 >> 1] | 0;
      do if ((i1 & 65535) < 768 | (i1 & 255) != 0) {
       HEAP32[i68 >> 2] = 0;
       HEAP32[i54 >> 2] = 0;
       i4 = i5;
      } else {
       i4 = HEAP32[i9 + 92 >> 2] | 0;
       if (!i4) {
        HEAP32[i68 >> 2] = 0;
        HEAP32[i54 >> 2] = 1;
        i4 = i5;
        break;
       } else {
        i1 = HEAPU8[i6 + 32 + ((HEAPU8[i9 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i8 = HEAP32[i9 + 12 >> 2] | 0;
        HEAP32[i68 >> 2] = i4 + ((i8 >>> 8 & 255) + (HEAP32[i6 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0));
        HEAP32[i54 >> 2] = i1;
        i1 = i8 >>> 16 & 65535;
        i4 = i8 >>> 24 & 255;
        break;
       }
      } while (0);
      do if ((i1 & 65535) < 768 | (i1 & 255) != 0) {
       HEAP32[i69 >> 2] = 0;
       HEAP32[i55 >> 2] = 0;
      } else {
       i1 = HEAP32[i9 + 92 >> 2] | 0;
       if ((i1 | 0) == 0 | i4 << 24 >> 24 == 0) {
        HEAP32[i69 >> 2] = 0;
        HEAP32[i55 >> 2] = 1;
        break;
       } else {
        i8 = HEAPU8[i6 + 32 + ((HEAPU8[i9 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
        i7 = HEAP16[i9 + 12 >> 1] | 0;
        HEAP32[i69 >> 2] = i1 + ((Math_imul(i8, HEAP32[i9 + 100 >> 2] | 0) | 0) + (HEAP32[i6 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i7 & 65535) >>> 8 & 65535));
        HEAP32[i55 >> 2] = i8;
        break;
       }
      } while (0);
      __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i68, i69);
     }
     i6 = HEAP32[i11 >> 2] | 0;
     i7 = i6 + 8 | 0;
     i5 = HEAP8[i6 + 23 >> 0] | 0;
     if (!(i5 << 24 >> 24)) {
      HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      do if (!i1) i73 = 187; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
        i2 = HEAP32[i57 >> 2] | 0;
        i13 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
        i73 = 187;
        break;
       }
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i73 = 189;
      } while (0);
      if ((i73 | 0) == 187) i73 = 189;
      if ((i73 | 0) == 189) {
       i73 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
      }
      i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      __Z6AppendPKcS0_(i65, gb + 934180 | 0, i1);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 104 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 116 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
      i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
      i1 = i15 + (i16 * 136 | 0) + 128 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
      break L6;
     }
     i8 = i15 + (i16 * 136 | 0) + 100 | 0;
     i1 = HEAP16[i6 + 22 >> 1] | 0;
     do if ((i1 & 65535) < 512 | (i1 & 255) != 0) {
      HEAP32[i70 >> 2] = 0;
      HEAP32[i47 >> 2] = 0;
      i4 = i5;
     } else {
      i4 = HEAP32[i6 + 92 >> 2] | 0;
      if (!i4) {
       HEAP32[i70 >> 2] = 0;
       HEAP32[i47 >> 2] = 1;
       i4 = i5;
       break;
      } else {
       i1 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i11 = HEAP32[i6 + 20 >> 2] | 0;
       HEAP32[i70 >> 2] = i4 + ((i11 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i11 & 255) * 12 | 0) + 4 >> 2] | 0));
       HEAP32[i47 >> 2] = i1;
       i1 = i11 >>> 16 & 65535;
       i4 = i11 >>> 24 & 255;
       break;
      }
     } while (0);
     do if ((i1 & 65535) < 512 | (i1 & 255) != 0) {
      HEAP32[i71 >> 2] = 0;
      HEAP32[i48 >> 2] = 0;
     } else {
      i1 = HEAP32[i6 + 92 >> 2] | 0;
      if ((i1 | 0) == 0 | i4 << 24 >> 24 == 0) {
       HEAP32[i71 >> 2] = 0;
       HEAP32[i48 >> 2] = 1;
       break;
      } else {
       i11 = HEAPU8[i7 + 32 + ((HEAPU8[i6 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       i10 = HEAP16[i6 + 20 >> 1] | 0;
       HEAP32[i71 >> 2] = i1 + ((Math_imul(i11, HEAP32[i6 + 100 >> 2] | 0) | 0) + (HEAP32[i7 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i10 & 65535) >>> 8 & 65535));
       HEAP32[i48 >> 2] = i11;
       break;
      }
     } while (0);
     __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i70, i71);
     HEAP32[i65 >> 2] = 0;
     HEAP32[i49 >> 2] = 0;
     HEAP32[i50 >> 2] = 0;
     HEAP32[i51 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i3, i65);
     i11 = i15 + (i16 * 136 | 0) + 124 | 0;
     HEAP32[i72 >> 2] = HEAP32[i65 >> 2];
     HEAP32[i59 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i56 >> 2] = HEAP32[i72 >> 2];
     HEAP32[i57 >> 2] = HEAP32[i59 >> 2];
     __ZNSt3__26vectorItNS_9allocatorItEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i11, i56, i57);
     i4 = i15 + (i16 * 136 | 0) + 128 | 0;
     if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
      HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      do if (!i1) i73 = 204; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
        i2 = HEAP32[i57 >> 2] | 0;
        i13 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
        i73 = 204;
        break;
       }
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i73 = 206;
      } while (0);
      if ((i73 | 0) == 204) i73 = 206;
      if ((i73 | 0) == 206) {
       i73 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
      }
      i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      __Z6AppendPKcS0_(i60, gb + 934198 | 0, i1);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 104 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
      i2 = i15 + (i16 * 136 | 0) + 116 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
      i1 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
      i2 = HEAP32[i4 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i2 + (~((i2 + -2 - i1 | 0) >>> 1) << 1);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i60);
     } else {
      HEAP32[i61 >> 2] = HEAP32[gb + 1467400 >> 2];
      HEAP32[i57 >> 2] = HEAP32[i61 >> 2];
      i1 = __ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE(i2, i57) | 0;
      if (!i1) i73 = 218; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) i73 = 218;
      if ((i73 | 0) == 218) {
       i73 = 0;
       i1 = 0;
      }
      HEAP32[i13 >> 2] = i1;
     }
     i1 = HEAP32[i65 >> 2] | 0;
     i2 = i1;
     if (i1 | 0) {
      i3 = HEAP32[i49 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i49 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
      i15 = HEAP32[i52 >> 2] | 0;
      HEAP32[i57 >> 2] = 1;
      HEAP32[i53 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i57);
     }
     break L6;
    } while (0);
    HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i73 = 101; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
      i2 = HEAP32[i57 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 101; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i73 = 103;
     }
    }
    if ((i73 | 0) == 101) i73 = 103;
    if ((i73 | 0) == 103) {
     i73 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
    }
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    __Z6AppendPKcS0_(i65, gb + 934143 | 0, i1);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 80 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 104 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 116 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
    i1 = i15 + (i16 * 136 | 0) + 128 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
    break L6;
   } while (0);
   HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i73 = 57; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
     i2 = HEAP32[i57 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 57; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i73 = 59;
    }
   }
   if ((i73 | 0) == 57) i73 = 59;
   if ((i73 | 0) == 59) {
    i73 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
   }
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   __Z6AppendPKcS0_(i65, gb + 934104 | 0, i1);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 80 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 104 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 116 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
   i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
   i1 = i15 + (i16 * 136 | 0) + 128 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
  } while (0);
  do if ((i73 | 0) == 226) {
   i73 = 0;
   i4 = i15 + (i16 * 136 | 0) + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i73 = 246; else {
    HEAP32[i56 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i73 = 232; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
      i2 = HEAP32[i57 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 232; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i73 = 234;
    }
    if ((i73 | 0) == 232) i73 = 234;
    if ((i73 | 0) == 234) {
     i73 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
      i73 = 246;
      break;
     }
    }
    HEAPF32[i65 >> 2] = Math_fround(-.5);
    HEAPF32[i18 >> 2] = Math_fround(0.0);
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    HEAPF32[i20 >> 2] = Math_fround(-.5);
    HEAPF32[i21 >> 2] = Math_fround(1.0);
    HEAPF32[i22 >> 2] = Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(.5);
    HEAPF32[i24 >> 2] = Math_fround(1.0);
    HEAPF32[i25 >> 2] = Math_fround(0.0);
    HEAPF32[i26 >> 2] = Math_fround(.5);
    HEAPF32[i27 >> 2] = Math_fround(0.0);
    HEAPF32[i28 >> 2] = Math_fround(0.0);
    HEAP32[i60 >> 2] = 10526880;
    HEAP32[i29 >> 2] = -1;
    HEAP32[i30 >> 2] = -1;
    HEAP32[i31 >> 2] = 10526880;
    HEAPF32[i62 >> 2] = Math_fround(0.0);
    HEAPF32[i32 >> 2] = Math_fround(0.0);
    HEAPF32[i33 >> 2] = Math_fround(0.0);
    HEAPF32[i34 >> 2] = Math_fround(1.0);
    HEAPF32[i35 >> 2] = Math_fround(1.0);
    HEAPF32[i36 >> 2] = Math_fround(1.0);
    HEAPF32[i37 >> 2] = Math_fround(1.0);
    HEAPF32[i38 >> 2] = Math_fround(0.0);
    HEAP16[i63 >> 1] = HEAP16[gb + 223192 >> 1] | 0;
    HEAP16[i63 + 2 >> 1] = HEAP16[gb + 223192 + 2 >> 1] | 0;
    HEAP16[i63 + 4 >> 1] = HEAP16[gb + 223192 + 4 >> 1] | 0;
    HEAP16[i63 + 6 >> 1] = HEAP16[gb + 223192 + 6 >> 1] | 0;
    HEAP16[i63 + 8 >> 1] = HEAP16[gb + 223192 + 8 >> 1] | 0;
    HEAP16[i63 + 10 >> 1] = HEAP16[gb + 223192 + 10 >> 1] | 0;
    __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i15 + (i16 * 136 | 0) + 76 | 0, i65, i39);
    __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i15 + (i16 * 136 | 0) + 112 | 0, i60, i40);
    __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i15 + (i16 * 136 | 0) + 100 | 0, i62, i41);
    __ZNSt3__26vectorItNS_9allocatorItEEE6assignIPtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i15 + (i16 * 136 | 0) + 124 | 0, i63, i42);
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i56 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i73 = 241; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
       i2 = HEAP32[i57 >> 2] | 0;
       i15 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 241; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i73 = 243;
      }
     }
     if ((i73 | 0) == 241) i73 = 243;
     if ((i73 | 0) == 243) {
      i73 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     }
    }
    HEAP32[i13 >> 2] = i1;
   }
  } while (0);
  L358 : do if ((i73 | 0) == 246) {
   i73 = 0;
   i1 = HEAP32[i14 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i56 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i73 = 252; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
      i2 = HEAP32[i57 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 252; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i73 = 254;
    }
    if ((i73 | 0) == 252) i73 = 254;
    if ((i73 | 0) == 254) {
     i73 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0)) break;
    }
    HEAP32[i56 >> 2] = HEAP32[i14 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i73 = 260; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i56);
      i2 = HEAP32[i57 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i73 = 260; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i73 = 262;
     }
    }
    if ((i73 | 0) == 260) i73 = 262;
    if ((i73 | 0) == 262) {
     i73 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
    }
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    __Z6AppendPKcS0_(i65, gb + 934222 | 0, i1);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 80 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 104 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
    i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
    i2 = i15 + (i16 * 136 | 0) + 116 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
    i1 = i15 + (i16 * 136 | 0) + 128 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i65);
    break L358;
   } while (0);
   HEAP32[i57 >> 2] = 0;
   HEAP32[i57 + 4 >> 2] = 0;
   HEAP32[i57 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i57, gb + 934241 | 0, 17);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 76 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 80 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 100 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 104 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
   i1 = HEAP32[i15 + (i16 * 136 | 0) + 112 >> 2] | 0;
   i2 = i15 + (i16 * 136 | 0) + 116 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
   i3 = HEAP32[i15 + (i16 * 136 | 0) + 124 >> 2] | 0;
   i1 = i15 + (i16 * 136 | 0) + 128 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i57);
  } while (0);
  i16 = i16 + 1 | 0;
  i15 = HEAP32[i64 >> 2] | 0;
 } while (i16 >>> 0 < (((HEAP32[i17 >> 2] | 0) - i15 | 0) / 136 | 0) >>> 0);
 STACKTOP = i74;
 return;
}

function _D6JointSolverPrep(i13, i11, i1, i2, i66, i6, i9) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i66 = i66 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f10 = f0, f12 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, f74 = f0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i69 = i73 + 320 | 0;
 i71 = i73 + 220 | 0;
 i72 = i73 + 152 | 0;
 i70 = i73 + 120 | 0;
 i57 = i73 + 284 | 0;
 i48 = i73 + 248 | 0;
 i67 = i73 + 108 | 0;
 i68 = i73 + 96 | 0;
 i19 = i73 + 84 | 0;
 i32 = i73 + 184 | 0;
 i31 = i73 + 72 | 0;
 i43 = i73 + 56 | 0;
 i41 = i73 + 40 | 0;
 i40 = i73 + 28 | 0;
 i42 = i73 + 24 | 0;
 i45 = i73 + 12 | 0;
 i46 = i73;
 i14 = i66 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i14 = i66 + 176 | 0;
 i65 = HEAP32[i66 + 324 >> 2] | 0;
 i56 = HEAP32[i66 + 328 >> 2] | 0;
 i24 = HEAP32[i66 + 332 >> 2] | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i66 + 16 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(HEAPF32[i66 + 20 >> 2]) * Math_fround(2.0));
 f49 = Math_fround(Math_fround(HEAPF32[i66 + 24 >> 2]) * Math_fround(2.0));
 f4 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f3 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f16 = Math_fround(f12 * f18);
 f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f17 * f10));
 f50 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f49 * f50));
 f7 = Math_fround(Math_fround(f18 * f16) + Math_fround(Math_fround(f12 * f3) + Math_fround(f4 * Math_fround(Math_fround(f49 * f10) - Math_fround(f17 * f50)))));
 f5 = Math_fround(Math_fround(f10 * f16) + Math_fround(Math_fround(f17 * f3) + Math_fround(f4 * Math_fround(Math_fround(f12 * f50) - Math_fround(f49 * f18)))));
 f16 = Math_fround(Math_fround(Math_fround(f49 * f3) + Math_fround(f4 * Math_fround(Math_fround(f17 * f18) - Math_fround(f12 * f10)))) + Math_fround(f50 * f16));
 i62 = i6 + 16 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) + f7);
 i61 = i6 + 20 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) + f5);
 i60 = i6 + 24 | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) + f16);
 f12 = Math_fround(HEAPF32[i66 >> 2]);
 f17 = Math_fround(f4 * f12);
 f3 = Math_fround(HEAPF32[i66 + 12 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f18 * f3));
 f49 = Math_fround(HEAPF32[i66 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f10 * f49));
 f8 = Math_fround(HEAPF32[i66 + 4 >> 2]);
 f51 = Math_fround(Math_fround(Math_fround(f50 * f12) + Math_fround(Math_fround(f10 * f3) + Math_fround(f4 * f8))) - Math_fround(f18 * f49));
 f15 = Math_fround(Math_fround(Math_fround(f18 * f8) + Math_fround(Math_fround(f50 * f3) + Math_fround(f4 * f49))) - Math_fround(f10 * f12));
 f49 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f3) - Math_fround(f18 * f12)) - Math_fround(f10 * f8)) - Math_fround(f50 * f49));
 HEAPF32[i69 >> 2] = Math_fround(f17 - Math_fround(f50 * f8));
 i35 = i69 + 4 | 0;
 HEAPF32[i35 >> 2] = f51;
 i36 = i69 + 8 | 0;
 HEAPF32[i36 >> 2] = f15;
 i37 = i69 + 12 | 0;
 HEAPF32[i37 >> 2] = f49;
 i1 = i69 + 16 | 0;
 HEAPF32[i1 >> 2] = f7;
 i2 = i69 + 20 | 0;
 HEAPF32[i2 >> 2] = f5;
 i6 = i69 + 24 | 0;
 HEAPF32[i6 >> 2] = f16;
 f16 = Math_fround(Math_fround(HEAPF32[i66 + 44 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i66 + 48 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i66 + 52 >> 2]) * Math_fround(2.0));
 f49 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f15 = Math_fround(Math_fround(f49 * f49) + Math_fround(-.5));
 f51 = Math_fround(HEAPF32[i9 >> 2]);
 f8 = Math_fround(f16 * f51);
 f50 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f5 * f50));
 f17 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f17));
 f10 = Math_fround(Math_fround(f51 * f8) + Math_fround(Math_fround(f16 * f15) + Math_fround(f49 * Math_fround(Math_fround(f7 * f50) - Math_fround(f5 * f17)))));
 f12 = Math_fround(Math_fround(f50 * f8) + Math_fround(Math_fround(f5 * f15) + Math_fround(f49 * Math_fround(Math_fround(f16 * f17) - Math_fround(f7 * f51)))));
 f8 = Math_fround(Math_fround(Math_fround(f7 * f15) + Math_fround(f49 * Math_fround(Math_fround(f5 * f51) - Math_fround(f16 * f50)))) + Math_fround(f17 * f8));
 i59 = i9 + 16 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) + f10);
 i58 = i9 + 20 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) + f12);
 i64 = i9 + 24 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i64 >> 2]) + f8);
 f16 = Math_fround(HEAPF32[i66 + 28 >> 2]);
 f5 = Math_fround(f49 * f16);
 f15 = Math_fround(HEAPF32[i66 + 40 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f51 * f15));
 f7 = Math_fround(HEAPF32[i66 + 36 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f50 * f7));
 f18 = Math_fround(HEAPF32[i66 + 32 >> 2]);
 f5 = Math_fround(f5 - Math_fround(f17 * f18));
 f3 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f50 * f15) + Math_fround(f49 * f18))) - Math_fround(f51 * f7));
 f4 = Math_fround(Math_fround(Math_fround(f51 * f18) + Math_fround(Math_fround(f17 * f15) + Math_fround(f49 * f7))) - Math_fround(f50 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f49 * f15) - Math_fround(f51 * f16)) - Math_fround(f50 * f18)) - Math_fround(f17 * f7));
 HEAPF32[i71 >> 2] = f5;
 i26 = i71 + 4 | 0;
 HEAPF32[i26 >> 2] = f3;
 i27 = i71 + 8 | 0;
 HEAPF32[i27 >> 2] = f4;
 i28 = i71 + 12 | 0;
 HEAPF32[i28 >> 2] = f7;
 HEAPF32[i71 + 16 >> 2] = f10;
 HEAPF32[i71 + 20 >> 2] = f12;
 HEAPF32[i71 + 24 >> 2] = f8;
 f17 = Math_fround(f10 - Math_fround(HEAPF32[i62 >> 2]));
 f18 = Math_fround(f12 - Math_fround(HEAPF32[i61 >> 2]));
 f50 = Math_fround(f8 - Math_fround(HEAPF32[i60 >> 2]));
 HEAPF32[i11 >> 2] = f17;
 HEAPF32[i11 + 4 >> 2] = f18;
 HEAPF32[i11 + 8 >> 2] = f50;
 f50 = Math_fround(f10 - Math_fround(HEAPF32[i62 >> 2]));
 f18 = Math_fround(f12 - Math_fround(HEAPF32[i61 >> 2]));
 f17 = Math_fround(f8 - Math_fround(HEAPF32[i60 >> 2]));
 f16 = Math_fround(f10 - Math_fround(HEAPF32[i59 >> 2]));
 f51 = Math_fround(f12 - Math_fround(HEAPF32[i58 >> 2]));
 f15 = Math_fround(f8 - Math_fround(HEAPF32[i64 >> 2]));
 HEAP32[i72 >> 2] = i13;
 i64 = i72 + 4 | 0;
 HEAP32[i64 >> 2] = i13;
 i58 = i72 + 8 | 0;
 HEAPF32[i58 >> 2] = f50;
 i59 = i72 + 12 | 0;
 HEAPF32[i59 >> 2] = f18;
 i60 = i72 + 16 | 0;
 HEAPF32[i60 >> 2] = f17;
 i61 = i72 + 20 | 0;
 HEAPF32[i61 >> 2] = f16;
 i62 = i72 + 24 | 0;
 HEAPF32[i62 >> 2] = f51;
 i63 = i72 + 28 | 0;
 HEAPF32[i63 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i69 >> 2]);
 f51 = Math_fround(f15 * f5);
 f16 = Math_fround(HEAPF32[i35 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f16 * f3));
 f17 = Math_fround(HEAPF32[i36 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f17 * f4));
 f18 = Math_fround(HEAPF32[i37 >> 2]);
 if (Math_fround(f51 + Math_fround(f18 * f7)) < Math_fround(0.0)) {
  f5 = Math_fround(-f5);
  f3 = Math_fround(-f3);
  f4 = Math_fround(-f4);
  f7 = Math_fround(-f7);
  HEAPF32[i71 >> 2] = f5;
  HEAPF32[i26 >> 2] = f3;
  HEAPF32[i27 >> 2] = f4;
  HEAPF32[i28 >> 2] = f7;
 }
 f50 = Math_fround(-f15);
 f49 = Math_fround(-f16);
 f74 = Math_fround(-f17);
 f20 = Math_fround(f10 - Math_fround(HEAPF32[i1 >> 2]));
 f23 = Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2]));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f23 = Math_fround(f23 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f8 - Math_fround(HEAPF32[i6 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f22 = Math_fround(Math_fround(Math_fround(f20 * f50) + Math_fround(f23 * f49)) + Math_fround(f8 * f74));
 f12 = Math_fround(Math_fround(f22 * f50) + Math_fround(Math_fround(f10 * f20) + Math_fround(f18 * Math_fround(Math_fround(f8 * f49) - Math_fround(f23 * f74)))));
 f21 = Math_fround(Math_fround(f22 * f49) + Math_fround(Math_fround(f10 * f23) + Math_fround(f18 * Math_fround(Math_fround(f20 * f74) - Math_fround(f8 * f50)))));
 f22 = Math_fround(Math_fround(Math_fround(f10 * f8) + Math_fround(f18 * Math_fround(Math_fround(f23 * f50) - Math_fround(f20 * f49)))) + Math_fround(f22 * f74));
 f20 = Math_fround(Math_fround(Math_fround(f5 * f74) + Math_fround(Math_fround(f7 * f49) + Math_fround(f18 * f3))) - Math_fround(f4 * f50));
 f23 = Math_fround(Math_fround(Math_fround(f3 * f50) + Math_fround(Math_fround(f7 * f74) + Math_fround(f18 * f4))) - Math_fround(f5 * f49));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f7) - Math_fround(f5 * f50)) - Math_fround(f3 * f49)) - Math_fround(f4 * f74));
 HEAPF32[i70 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f5) + Math_fround(f7 * f50)) + Math_fround(f4 * f49)) - Math_fround(f3 * f74));
 i29 = i70 + 4 | 0;
 HEAPF32[i29 >> 2] = f20;
 i30 = i70 + 8 | 0;
 HEAPF32[i30 >> 2] = f23;
 i25 = i70 + 12 | 0;
 HEAPF32[i25 >> 2] = f8;
 i44 = i70 + 16 | 0;
 HEAPF32[i44 >> 2] = f12;
 i1 = i70 + 20 | 0;
 HEAPF32[i1 >> 2] = f21;
 i2 = i70 + 24 | 0;
 HEAPF32[i2 >> 2] = f22;
 f22 = Math_fround(f15 + f15);
 f21 = Math_fround(f16 + f16);
 f12 = Math_fround(f17 + f17);
 f8 = Math_fround(f15 * f22);
 f23 = Math_fround(f16 * f21);
 f20 = Math_fround(f17 * f12);
 f3 = Math_fround(f22 * f16);
 f7 = Math_fround(f22 * f17);
 f22 = Math_fround(f22 * f18);
 f74 = Math_fround(f21 * f17);
 f21 = Math_fround(f21 * f18);
 f17 = Math_fround(f12 * f18);
 f15 = Math_fround(f3 + f17);
 f18 = Math_fround(f7 - f21);
 HEAPF32[i57 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f23) - f20);
 HEAPF32[i57 + 4 >> 2] = f15;
 HEAPF32[i57 + 8 >> 2] = f18;
 f17 = Math_fround(f3 - f17);
 f8 = Math_fround(Math_fround(1.0) - f8);
 f18 = Math_fround(f8 - f20);
 f20 = Math_fround(f74 + f22);
 HEAPF32[i57 + 12 >> 2] = f17;
 HEAPF32[i57 + 16 >> 2] = f18;
 HEAPF32[i57 + 20 >> 2] = f20;
 f21 = Math_fround(f7 + f21);
 f22 = Math_fround(f74 - f22);
 f23 = Math_fround(f8 - f23);
 HEAPF32[i57 + 24 >> 2] = f21;
 HEAPF32[i57 + 28 >> 2] = f22;
 HEAPF32[i57 + 32 >> 2] = f23;
 f8 = Math_fround(HEAPF32[i71 >> 2]);
 f74 = Math_fround(HEAPF32[i26 >> 2]);
 f7 = Math_fround(HEAPF32[i27 >> 2]);
 f3 = Math_fround(HEAPF32[i28 >> 2]);
 f15 = Math_fround(f8 + f8);
 f12 = Math_fround(f74 + f74);
 f49 = Math_fround(f7 + f7);
 f8 = Math_fround(f8 * f15);
 f16 = Math_fround(f74 * f12);
 f4 = Math_fround(f7 * f49);
 f74 = Math_fround(f15 * f74);
 f10 = Math_fround(f15 * f7);
 f15 = Math_fround(f15 * f3);
 f7 = Math_fround(f12 * f7);
 f12 = Math_fround(f12 * f3);
 f3 = Math_fround(f49 * f3);
 f49 = Math_fround(Math_fround(Math_fround(1.0) - f16) - f4);
 f50 = Math_fround(f74 + f3);
 f51 = Math_fround(f10 - f12);
 HEAPF32[i48 >> 2] = f49;
 HEAPF32[i48 + 4 >> 2] = f50;
 HEAPF32[i48 + 8 >> 2] = f51;
 f8 = Math_fround(Math_fround(1.0) - f8);
 f4 = Math_fround(f8 - f4);
 f5 = Math_fround(f7 + f15);
 HEAPF32[i48 + 12 >> 2] = Math_fround(f74 - f3);
 HEAPF32[i48 + 16 >> 2] = f4;
 HEAPF32[i48 + 20 >> 2] = f5;
 f15 = Math_fround(f7 - f15);
 f16 = Math_fround(f8 - f16);
 HEAPF32[i48 + 24 >> 2] = Math_fround(f10 + f12);
 HEAPF32[i48 + 28 >> 2] = f15;
 HEAPF32[i48 + 32 >> 2] = f16;
 HEAPF32[i67 >> 2] = f17;
 i52 = i67 + 4 | 0;
 i33 = i57 + 16 | 0;
 HEAPF32[i52 >> 2] = f18;
 i53 = i67 + 8 | 0;
 i34 = i57 + 20 | 0;
 HEAPF32[i53 >> 2] = f20;
 HEAPF32[i68 >> 2] = f21;
 i54 = i68 + 4 | 0;
 i38 = i57 + 28 | 0;
 HEAPF32[i54 >> 2] = f22;
 i55 = i68 + 8 | 0;
 i39 = i57 + 32 | 0;
 HEAPF32[i55 >> 2] = f23;
 if (i24 & 7 | 0) {
  f5 = Math_fround(HEAPF32[i66 + 288 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i44 >> 2]));
  f4 = Math_fround(HEAPF32[i66 + 292 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 >> 2]));
  f3 = Math_fround(HEAPF32[i66 + 296 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i19 >> 2] = f5;
  HEAPF32[i19 + 4 >> 2] = f4;
  HEAPF32[i19 + 8 >> 2] = f3;
  i1 = i66 + 300 | 0;
  f3 = Math_fround(HEAPF32[i59 >> 2]);
  f4 = Math_fround(HEAPF32[i60 >> 2]);
  f5 = Math_fround(HEAPF32[i58 >> 2]);
  f7 = Math_fround(HEAPF32[i62 >> 2]);
  f8 = Math_fround(HEAPF32[i63 >> 2]);
  f10 = Math_fround(HEAPF32[i61 >> 2]);
  i2 = 0;
  do {
   if (1 << i2 & i24 | 0) {
    f74 = Math_fround(-Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]));
    i11 = HEAP32[i19 + (i2 << 2) >> 2] | 0;
    i13 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i13 + 80;
    HEAP16[i13 + 78 >> 1] = 0;
    i75 = HEAP32[i57 + (i2 * 12 | 0) >> 2] | 0;
    HEAP32[i13 >> 2] = i75;
    i6 = HEAP32[i57 + (i2 * 12 | 0) + 4 >> 2] | 0;
    HEAP32[i13 + 4 >> 2] = i6;
    i9 = HEAP32[i57 + (i2 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i13 + 8 >> 2] = i9;
    f20 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = Math_fround(f3 * f20);
    f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = Math_fround(f17 - Math_fround(f4 * f21));
    f23 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = Math_fround(Math_fround(f4 * f23) - Math_fround(f20 * f5));
    f22 = Math_fround(Math_fround(f21 * f5) - Math_fround(f3 * f23));
    HEAPF32[i13 + 16 >> 2] = f17;
    HEAPF32[i13 + 20 >> 2] = f18;
    HEAPF32[i13 + 24 >> 2] = f22;
    HEAP32[i13 + 32 >> 2] = i75;
    HEAP32[i13 + 36 >> 2] = i6;
    HEAP32[i13 + 40 >> 2] = i9;
    f22 = Math_fround(Math_fround(f8 * f23) - Math_fround(f20 * f10));
    f23 = Math_fround(Math_fround(f21 * f10) - Math_fround(f7 * f23));
    HEAPF32[i13 + 48 >> 2] = Math_fround(Math_fround(f7 * f20) - Math_fround(f8 * f21));
    HEAPF32[i13 + 52 >> 2] = f22;
    HEAPF32[i13 + 56 >> 2] = f23;
    HEAP32[i13 + 12 >> 2] = i11;
    HEAPF32[i13 + 28 >> 2] = f74;
    i11 = i13 + 76 | 0;
    HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | HEAP32[i14 + (i2 << 4) + 12 >> 2] << 1 & 2 | 33;
    HEAP32[i13 + 64 >> 2] = HEAP32[i14 + (i2 << 4) >> 2];
    HEAP32[i13 + 68 >> 2] = HEAP32[i14 + (i2 << 4) + 4 >> 2];
    f74 = Math_fround(HEAPF32[i14 + (i2 << 4) + 8 >> 2]);
    HEAPF32[i13 + 44 >> 2] = Math_fround(-f74);
    HEAPF32[i13 + 60 >> 2] = f74;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 3);
 }
 do if (i24 & 56 | 0) {
  f8 = Math_fround(HEAPF32[i70 >> 2]);
  f7 = Math_fround(HEAPF32[i66 + 272 >> 2]);
  f74 = Math_fround(f8 * f7);
  f10 = Math_fround(HEAPF32[i29 >> 2]);
  f5 = Math_fround(HEAPF32[i66 + 276 >> 2]);
  f74 = Math_fround(f74 + Math_fround(f10 * f5));
  f12 = Math_fround(HEAPF32[i30 >> 2]);
  f4 = Math_fround(HEAPF32[i66 + 280 >> 2]);
  f74 = Math_fround(f74 + Math_fround(f12 * f4));
  f15 = Math_fround(HEAPF32[i25 >> 2]);
  f3 = Math_fround(HEAPF32[i66 + 284 >> 2]);
  if (!(Math_fround(f74 + Math_fround(f15 * f3)) > Math_fround(0.0))) {
   f3 = Math_fround(-f3);
   f4 = Math_fround(-f4);
   f5 = Math_fround(-f5);
   f7 = Math_fround(-f7);
  }
  i1 = i66 + 312 | 0;
  f18 = Math_fround(-f7);
  f20 = Math_fround(-f5);
  f74 = Math_fround(-f4);
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f8) + Math_fround(f15 * f18)) + Math_fround(f12 * f20)) - Math_fround(f10 * f74));
  f22 = Math_fround(Math_fround(Math_fround(f8 * f74) + Math_fround(Math_fround(f15 * f20) + Math_fround(f3 * f10))) - Math_fround(f12 * f18));
  f23 = Math_fround(Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f15 * f74) + Math_fround(f3 * f12))) - Math_fround(f8 * f20));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f15) - Math_fround(f8 * f18)) - Math_fround(f10 * f20)) - Math_fround(f12 * f74));
  if (!(i24 & 32)) {
   if (i24 & 16 | 0) {
    i32 = HEAP32[i1 >> 2] | 0;
    f74 = Math_fround(f21 * Math_fround(-2.0));
    i75 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i75 + 80;
    HEAP16[i75 + 78 >> 1] = 0;
    HEAP32[i75 >> 2] = 0;
    HEAP32[i75 + 4 >> 2] = 0;
    HEAP32[i75 + 8 >> 2] = 0;
    HEAPF32[i75 + 16 >> 2] = f49;
    HEAPF32[i75 + 20 >> 2] = f50;
    HEAPF32[i75 + 24 >> 2] = f51;
    HEAP32[i75 + 32 >> 2] = 0;
    HEAP32[i75 + 36 >> 2] = 0;
    HEAP32[i75 + 40 >> 2] = 0;
    HEAPF32[i75 + 48 >> 2] = f49;
    HEAPF32[i75 + 52 >> 2] = f50;
    HEAPF32[i75 + 56 >> 2] = f51;
    HEAPF32[i75 + 12 >> 2] = f74;
    HEAP32[i75 + 28 >> 2] = i32;
    i32 = i75 + 76 | 0;
    HEAP16[i32 >> 1] = HEAPU16[i32 >> 1] | 0 | HEAP32[i66 + 252 >> 2] << 1 & 2 | 33;
    HEAP32[i75 + 64 >> 2] = HEAP32[i66 + 240 >> 2];
    HEAP32[i75 + 68 >> 2] = HEAP32[i66 + 244 >> 2];
    f74 = Math_fround(HEAPF32[i66 + 248 >> 2]);
    HEAPF32[i75 + 44 >> 2] = Math_fround(-f74);
    HEAPF32[i75 + 60 >> 2] = f74;
   }
   if (!(i24 & 8)) break;
   f5 = Math_fround(Math_fround(f23 * Math_fround(0.0)) + Math_fround(Math_fround(f21 * Math_fround(2.0)) + Math_fround(f22 * Math_fround(0.0))));
   f7 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(-.5)) * Math_fround(0.0));
   f3 = Math_fround(f21 * Math_fround(0.0));
   f4 = Math_fround(Math_fround(f7 + Math_fround(f8 * Math_fround(Math_fround(f23 * Math_fround(2.0)) - f3))) + Math_fround(f22 * f5));
   if (!(i65 & 16)) {
    f74 = Math_fround(Math_fround(f7 + Math_fround(f8 * Math_fround(f3 - Math_fround(f22 * Math_fround(2.0))))) + Math_fround(f23 * f5));
    i32 = HEAP32[i66 + 316 >> 2] | 0;
    i75 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i75 + 80;
    HEAP16[i75 + 78 >> 1] = 0;
    HEAP32[i75 >> 2] = 0;
    HEAP32[i75 + 4 >> 2] = 0;
    HEAP32[i75 + 8 >> 2] = 0;
    i27 = HEAP32[i48 + 12 >> 2] | 0;
    HEAP32[i75 + 16 >> 2] = i27;
    i28 = HEAP32[i48 + 16 >> 2] | 0;
    HEAP32[i75 + 20 >> 2] = i28;
    i31 = HEAP32[i48 + 20 >> 2] | 0;
    HEAP32[i75 + 24 >> 2] = i31;
    HEAP32[i75 + 32 >> 2] = 0;
    HEAP32[i75 + 36 >> 2] = 0;
    HEAP32[i75 + 40 >> 2] = 0;
    HEAP32[i75 + 48 >> 2] = i27;
    HEAP32[i75 + 52 >> 2] = i28;
    HEAP32[i75 + 56 >> 2] = i31;
    HEAPF32[i75 + 12 >> 2] = f74;
    HEAP32[i75 + 28 >> 2] = i32;
    i32 = i75 + 76 | 0;
    HEAP16[i32 >> 1] = HEAPU16[i32 >> 1] | 0 | HEAP32[i66 + 236 >> 2] << 1 & 2 | 33;
    HEAP32[i75 + 64 >> 2] = HEAP32[i66 + 224 >> 2];
    HEAP32[i75 + 68 >> 2] = HEAP32[i66 + 228 >> 2];
    f74 = Math_fround(HEAPF32[i66 + 232 >> 2]);
    HEAPF32[i75 + 44 >> 2] = Math_fround(-f74);
    HEAPF32[i75 + 60 >> 2] = f74;
   }
   if (i65 & 32 | 0) break;
   i32 = HEAP32[i66 + 320 >> 2] | 0;
   f74 = Math_fround(-f4);
   i75 = HEAP32[i64 >> 2] | 0;
   HEAP32[i64 >> 2] = i75 + 80;
   HEAP16[i75 + 78 >> 1] = 0;
   HEAP32[i75 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   i27 = HEAP32[i48 + 24 >> 2] | 0;
   HEAP32[i75 + 16 >> 2] = i27;
   i28 = HEAP32[i48 + 28 >> 2] | 0;
   HEAP32[i75 + 20 >> 2] = i28;
   i31 = HEAP32[i48 + 32 >> 2] | 0;
   HEAP32[i75 + 24 >> 2] = i31;
   HEAP32[i75 + 32 >> 2] = 0;
   HEAP32[i75 + 36 >> 2] = 0;
   HEAP32[i75 + 40 >> 2] = 0;
   HEAP32[i75 + 48 >> 2] = i27;
   HEAP32[i75 + 52 >> 2] = i28;
   HEAP32[i75 + 56 >> 2] = i31;
   HEAPF32[i75 + 12 >> 2] = f74;
   HEAP32[i75 + 28 >> 2] = i32;
   i32 = i75 + 76 | 0;
   HEAP16[i32 >> 1] = HEAPU16[i32 >> 1] | 0 | HEAP32[i66 + 236 >> 2] << 1 & 2 | 33;
   HEAP32[i75 + 64 >> 2] = HEAP32[i66 + 224 >> 2];
   HEAP32[i75 + 68 >> 2] = HEAP32[i66 + 228 >> 2];
   f74 = Math_fround(HEAPF32[i66 + 232 >> 2]);
   HEAPF32[i75 + 44 >> 2] = Math_fround(-f74);
   HEAPF32[i75 + 60 >> 2] = f74;
   break;
  }
  f20 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(2.0));
  f74 = Math_fround(Math_fround(HEAPF32[i66 + 316 >> 2]) * Math_fround(2.0));
  f77 = Math_fround(Math_fround(HEAPF32[i66 + 320 >> 2]) * Math_fround(2.0));
  f8 = Math_fround(HEAPF32[i37 >> 2]);
  f76 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f10 = Math_fround(HEAPF32[i69 >> 2]);
  f18 = Math_fround(f20 * f10);
  f12 = Math_fround(HEAPF32[i35 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f74 * f12));
  f15 = Math_fround(HEAPF32[i36 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f77 * f15));
  f16 = Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f20 * f76) + Math_fround(f8 * Math_fround(Math_fround(f77 * f12) - Math_fround(f74 * f15)))));
  f17 = Math_fround(Math_fround(f12 * f18) + Math_fround(Math_fround(f74 * f76) + Math_fround(f8 * Math_fround(Math_fround(f20 * f15) - Math_fround(f77 * f10)))));
  f18 = Math_fround(Math_fround(Math_fround(f77 * f76) + Math_fround(f8 * Math_fround(Math_fround(f74 * f10) - Math_fround(f20 * f12)))) + Math_fround(f15 * f18));
  HEAPF32[i32 >> 2] = Math_fround(1.0);
  i1 = i32 + 4 | 0;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  i2 = i32 + 8 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  i6 = i32 + 12 | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i11 = i32 + 16 | 0;
  HEAPF32[i11 >> 2] = Math_fround(1.0);
  i9 = i32 + 20 | 0;
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i13 = i32 + 24 | 0;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  i14 = i32 + 28 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i19 = i32 + 32 | 0;
  HEAPF32[i19 >> 2] = Math_fround(1.0);
  f20 = Math_fround(HEAPF32[i66 + 256 >> 2]);
  if (f20 != Math_fround(0.0)) {
   f83 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f8) + Math_fround(f3 * f10)) + Math_fround(f4 * f12)) - Math_fround(f5 * f15));
   f80 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f8) + Math_fround(f3 * f12)) + Math_fround(f7 * f15)) - Math_fround(f4 * f10));
   f81 = Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(Math_fround(f4 * f8) + Math_fround(f3 * f15))) - Math_fround(f7 * f12));
   f76 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f8) - Math_fround(f7 * f10)) - Math_fround(f5 * f12)) - Math_fround(f4 * f15));
   f5 = Math_fround(HEAPF32[i28 >> 2]);
   f15 = Math_fround(HEAPF32[i71 >> 2]);
   f7 = Math_fround(HEAPF32[i26 >> 2]);
   f8 = Math_fround(HEAPF32[i27 >> 2]);
   f74 = Math_fround(Math_fround(f5 * f83) + Math_fround(f76 * f15));
   f12 = Math_fround(Math_fround(f5 * f80) + Math_fround(f76 * f7));
   f78 = Math_fround(Math_fround(f5 * f81) + Math_fround(f76 * f8));
   f76 = Math_fround(f5 * f76);
   f5 = Math_fround(f83 * f15);
   f4 = Math_fround(f80 * f7);
   f10 = Math_fround(f81 * f8);
   f77 = Math_fround(Math_fround(f5 + f4) + f10);
   f3 = Math_fround(f76 - f77);
   f79 = Math_fround(Math_fround(f15 * f80) + Math_fround(f83 * f7));
   f15 = Math_fround(Math_fround(f15 * f81) + Math_fround(f83 * f8));
   f5 = Math_fround(Math_fround(Math_fround(f5 + f5) + f3) * Math_fround(.5));
   f83 = Math_fround(Math_fround(f79 + f78) * Math_fround(.5));
   f82 = Math_fround(Math_fround(f15 - f12) * Math_fround(.5));
   HEAPF32[i32 >> 2] = f5;
   HEAPF32[i1 >> 2] = f83;
   HEAPF32[i2 >> 2] = f82;
   f8 = Math_fround(Math_fround(f7 * f81) + Math_fround(f80 * f8));
   f4 = Math_fround(Math_fround(Math_fround(f4 + f4) + f3) * Math_fround(.5));
   f7 = Math_fround(Math_fround(f74 + f8) * Math_fround(.5));
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(f79 - f78) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f4;
   HEAPF32[i9 >> 2] = f7;
   f74 = Math_fround(Math_fround(f8 - f74) * Math_fround(.5));
   f3 = Math_fround(Math_fround(Math_fround(f10 + f10) + f3) * Math_fround(.5));
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(f12 + f15) * Math_fround(.5));
   HEAPF32[i14 >> 2] = f74;
   HEAPF32[i19 >> 2] = f3;
   if (!(Math_fround(f76 + f77) != Math_fround(0.0))) {
    HEAPF32[i32 >> 2] = Math_fround(f5 + Math_fround(1.1920929e-07));
    HEAPF32[i11 >> 2] = Math_fround(f4 + Math_fround(1.1920929e-07));
    HEAPF32[i19 >> 2] = Math_fround(f3 + Math_fround(1.1920929e-07));
   }
  }
  i1 = i31 + 4 | 0;
  i2 = i31 + 8 | 0;
  i6 = i66 + 268 | 0;
  i9 = i66 + 260 | 0;
  i11 = i66 + 264 | 0;
  i13 = 0;
  do {
   if (!(1 << i13 + 3 & i65)) {
    f79 = Math_fround(HEAPF32[i32 + (i13 * 12 | 0) >> 2]);
    f83 = Math_fround(f16 * f79);
    f80 = Math_fround(HEAPF32[i32 + (i13 * 12 | 0) + 4 >> 2]);
    f83 = Math_fround(Math_fround(-Math_fround(f17 * f80)) - f83);
    f81 = Math_fround(HEAPF32[i32 + (i13 * 12 | 0) + 8 >> 2]);
    f83 = Math_fround(f83 - Math_fround(f18 * f81));
    HEAPF32[i31 >> 2] = f21;
    HEAPF32[i1 >> 2] = f22;
    HEAPF32[i2 >> 2] = f23;
    f82 = Math_fround(-Math_fround(HEAPF32[i31 + (i13 << 2) >> 2]));
    i75 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i75 + 80;
    HEAP16[i75 + 78 >> 1] = 258;
    HEAP32[i75 >> 2] = 0;
    HEAP32[i75 + 4 >> 2] = 0;
    HEAP32[i75 + 8 >> 2] = 0;
    HEAPF32[i75 + 16 >> 2] = f79;
    HEAPF32[i75 + 20 >> 2] = f80;
    HEAPF32[i75 + 24 >> 2] = f81;
    HEAP32[i75 + 32 >> 2] = 0;
    HEAP32[i75 + 36 >> 2] = 0;
    HEAP32[i75 + 40 >> 2] = 0;
    HEAPF32[i75 + 48 >> 2] = f79;
    HEAPF32[i75 + 52 >> 2] = f80;
    HEAPF32[i75 + 56 >> 2] = f81;
    HEAPF32[i75 + 12 >> 2] = f82;
    HEAPF32[i75 + 28 >> 2] = f83;
    i28 = i75 + 76 | 0;
    HEAP16[i28 >> 1] = HEAPU16[i28 >> 1] | 0 | HEAP32[i6 >> 2] << 1 & 2 | 33;
    HEAPF32[i75 + 64 >> 2] = f20;
    HEAP32[i75 + 68 >> 2] = HEAP32[i9 >> 2];
    f83 = Math_fround(HEAPF32[i11 >> 2]);
    HEAPF32[i75 + 44 >> 2] = Math_fround(-f83);
    HEAPF32[i75 + 60 >> 2] = f83;
   }
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != 3);
 } while (0);
 if (i56 & 56 | 0) {
  f4 = Math_fround(HEAPF32[i70 >> 2]);
  i75 = f4 != Math_fround(0.0);
  f3 = Math_fround(HEAPF32[i25 >> 2]);
  if (i75) {
   f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(0.0)) + Math_fround(f3 * f3)))));
   f81 = Math_fround(f4 * f83);
   f82 = Math_fround(f83 * Math_fround(0.0));
   f83 = Math_fround(f3 * f83);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = 0;
   i2 = 0;
   i6 = 1065353216;
  }
  f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f81 = Math_fround(-f12);
  f78 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f82 = Math_fround(f3 * f81);
  f10 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f82 = Math_fround(f82 + Math_fround(f10 * f4));
  f8 = Math_fround(HEAPF32[i29 >> 2]);
  f5 = Math_fround(f8 * f78);
  f82 = Math_fround(f82 + f5);
  f80 = Math_fround(HEAPF32[i30 >> 2]);
  f83 = Math_fround(f80 * f78);
  f79 = Math_fround(f3 * f78);
  f78 = Math_fround(f4 * f78);
  f7 = Math_fround(Math_fround(Math_fround(f79 + Math_fround(f10 * f8)) + Math_fround(f80 * f81)) - f78);
  f8 = Math_fround(Math_fround(f78 + Math_fround(f79 + Math_fround(f10 * f80))) - Math_fround(f8 * f81));
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f3) - Math_fround(f4 * f81)) - f5) - f83);
  HEAPF32[i43 >> 2] = Math_fround(f82 - f83);
  HEAPF32[i43 + 4 >> 2] = f7;
  HEAPF32[i43 + 8 >> 2] = f8;
  HEAPF32[i43 + 12 >> 2] = f5;
  i2 = (i56 & 16 | 0) != 0;
  i6 = (i56 & 32 | 0) == 0;
  do if (i6 | i2 ^ 1) {
   i1 = i66 + 148 | 0;
   f3 = Math_fround(HEAPF32[i66 + 356 >> 2]);
   f4 = Math_fround(HEAPF32[i66 + 344 >> 2]);
   do if (i2) if (!(i65 & 32)) {
    f80 = Math_fround(HEAPF32[i68 >> 2]);
    f81 = Math_fround(f49 * f80);
    f77 = Math_fround(HEAPF32[i54 >> 2]);
    f81 = Math_fround(f81 + Math_fround(f50 * f77));
    f78 = Math_fround(HEAPF32[i55 >> 2]);
    f81 = Math_fround(f81 + Math_fround(f51 * f78));
    f81 = Math_fround(Math_fround(-f81) / Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f81 * f81)) + Math_fround(1.0)));
    f83 = Math_fround(HEAPF32[i66 + 336 >> 2]);
    f82 = Math_fround(-f83);
    f79 = Math_fround(Math_fround(f49 * f78) - Math_fround(f51 * f80));
    f80 = Math_fround(Math_fround(f50 * f80) - Math_fround(f49 * f77));
    HEAPF32[i45 >> 2] = Math_fround(Math_fround(f51 * f77) - Math_fround(f50 * f78));
    HEAPF32[i45 + 4 >> 2] = f79;
    HEAPF32[i45 + 8 >> 2] = f80;
    __ZN5physx3Ext5joint16ConstraintHelper13halfAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i72, f81, f82, f83, f4, i45, i1);
    break;
   } else {
    f82 = Math_fround(f7 / Math_fround(f5 + Math_fround(1.0)));
    f83 = Math_fround(HEAPF32[i66 + 348 >> 2]);
    __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i72, f82, Math_fround(-f83), f83, f3, i67, i1);
    break;
   } while (0);
   if (!i6) if (!(i65 & 16)) {
    f80 = Math_fround(HEAPF32[i67 >> 2]);
    f81 = Math_fround(f49 * f80);
    f77 = Math_fround(HEAPF32[i52 >> 2]);
    f81 = Math_fround(f81 + Math_fround(f50 * f77));
    f78 = Math_fround(HEAPF32[i53 >> 2]);
    f81 = Math_fround(f81 + Math_fround(f51 * f78));
    f81 = Math_fround(f81 / Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f81 * f81)) + Math_fround(1.0)));
    f83 = Math_fround(HEAPF32[i66 + 340 >> 2]);
    f82 = Math_fround(-f83);
    f79 = Math_fround(-Math_fround(Math_fround(f49 * f78) - Math_fround(f51 * f80)));
    f80 = Math_fround(-Math_fround(Math_fround(f50 * f80) - Math_fround(f49 * f77)));
    HEAPF32[i46 >> 2] = Math_fround(-Math_fround(Math_fround(f51 * f77) - Math_fround(f50 * f78)));
    HEAPF32[i46 + 4 >> 2] = f79;
    HEAPF32[i46 + 8 >> 2] = f80;
    __ZN5physx3Ext5joint16ConstraintHelper13halfAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i72, f81, f82, f83, f4, i46, i1);
    break;
   } else {
    f82 = Math_fround(f8 / Math_fround(f5 + Math_fround(1.0)));
    f83 = Math_fround(HEAPF32[i66 + 352 >> 2]);
    __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i72, f82, Math_fround(-f83), f83, f3, i68, i1);
    break;
   }
  } else {
   i46 = HEAP32[i66 + 348 >> 2] | 0;
   i75 = HEAP32[i66 + 356 >> 2] | 0;
   HEAP32[i41 >> 2] = HEAP32[i66 + 352 >> 2];
   HEAP32[i41 + 4 >> 2] = i46;
   HEAP32[i41 + 8 >> 2] = i75;
   if (__ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf(i41, i43, i40, i42) | 0) {
    f80 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) * Math_fround(2.0));
    f78 = Math_fround(Math_fround(HEAPF32[i40 + 4 >> 2]) * Math_fround(2.0));
    f74 = Math_fround(Math_fround(HEAPF32[i40 + 8 >> 2]) * Math_fround(2.0));
    f77 = Math_fround(HEAPF32[i37 >> 2]);
    f76 = Math_fround(Math_fround(f77 * f77) + Math_fround(-.5));
    f79 = Math_fround(HEAPF32[i69 >> 2]);
    f5 = Math_fround(f80 * f79);
    f81 = Math_fround(HEAPF32[i35 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f78 * f81));
    f4 = Math_fround(HEAPF32[i36 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f74 * f4));
    f82 = Math_fround(Math_fround(f79 * f5) + Math_fround(Math_fround(f80 * f76) + Math_fround(f77 * Math_fround(Math_fround(f74 * f81) - Math_fround(f78 * f4)))));
    f83 = Math_fround(Math_fround(f81 * f5) + Math_fround(Math_fround(f78 * f76) + Math_fround(f77 * Math_fround(Math_fround(f80 * f4) - Math_fround(f74 * f79)))));
    f5 = Math_fround(Math_fround(Math_fround(f74 * f76) + Math_fround(f77 * Math_fround(Math_fround(f78 * f79) - Math_fround(f80 * f81)))) + Math_fround(f4 * f5));
    f4 = Math_fround(HEAPF32[i42 >> 2]);
    i2 = i66 + 148 | 0;
    i11 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i11 + 80;
    i6 = i11 + 78 | 0;
    HEAP16[i6 >> 1] = 0;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    HEAPF32[i11 + 16 >> 2] = f82;
    HEAPF32[i11 + 20 >> 2] = f83;
    HEAPF32[i11 + 24 >> 2] = f5;
    HEAP32[i11 + 32 >> 2] = 0;
    HEAP32[i11 + 36 >> 2] = 0;
    HEAP32[i11 + 40 >> 2] = 0;
    HEAPF32[i11 + 48 >> 2] = f82;
    HEAPF32[i11 + 52 >> 2] = f83;
    HEAPF32[i11 + 56 >> 2] = f5;
    HEAPF32[i11 + 12 >> 2] = f4;
    i13 = i11 + 76 | 0;
    i9 = HEAPU16[i13 >> 1] | 0;
    f5 = Math_fround(HEAPF32[i66 + 160 >> 2]);
    i1 = i66 + 156 | 0;
    do if (f5 > Math_fround(0.0)) {
     i1 = HEAP32[i1 >> 2] | 0;
     i47 = 36;
    } else {
     f3 = Math_fround(HEAPF32[i1 >> 2]);
     if (f3 > Math_fround(0.0)) {
      i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
      i47 = 36;
      break;
     }
     HEAP16[i6 >> 1] = 1025;
     i75 = HEAP32[i2 >> 2] | 0;
     HEAP32[i11 + 64 >> 2] = i75;
     HEAP32[i11 + 68 >> 2] = HEAP32[i66 + 152 >> 2];
     i1 = f4 > Math_fround(0.0);
     i1 = i9 | (i1 ? 24 : 16);
     if ((HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
    } while (0);
    if ((i47 | 0) == 36) {
     HEAP32[i11 + 64 >> 2] = i1;
     HEAPF32[i11 + 68 >> 2] = f5;
     i1 = i9 | 17;
    }
    HEAP16[i13 >> 1] = i1;
    HEAPF32[i11 + 44 >> 2] = Math_fround(0.0);
   }
  } while (0);
  if (i56 & 8 | 0) {
   f81 = Math_fround(f12 / Math_fround(f10 + Math_fround(1.0)));
   f82 = Math_fround(HEAPF32[i66 + 360 >> 2]);
   f83 = Math_fround(HEAPF32[i66 + 364 >> 2]);
   __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i72, f81, f82, f83, Math_fround(HEAPF32[i66 + 368 >> 2]), i48, i66 + 120 | 0);
  }
 }
 if (i56 & 7 | 0) {
  if (!(i56 & 1)) {
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f3 = Math_fround(0.0);
  } else {
   f3 = Math_fround(HEAPF32[i44 >> 2]);
   f4 = Math_fround(f3 * Math_fround(HEAPF32[i57 >> 2]));
   f5 = Math_fround(f3 * Math_fround(HEAPF32[i57 + 4 >> 2]));
   f4 = Math_fround(f4 + Math_fround(0.0));
   f5 = Math_fround(f5 + Math_fround(0.0));
   f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i57 + 8 >> 2])) + Math_fround(0.0));
  }
  if (i56 & 2) {
   f83 = Math_fround(HEAPF32[i44 + 4 >> 2]);
   f81 = Math_fround(f83 * Math_fround(HEAPF32[i57 + 12 >> 2]));
   f82 = Math_fround(f83 * Math_fround(HEAPF32[i33 >> 2]));
   f4 = Math_fround(f4 + f81);
   f5 = Math_fround(f5 + f82);
   f3 = Math_fround(f3 + Math_fround(f83 * Math_fround(HEAPF32[i34 >> 2])));
  }
  if (i56 & 4) {
   f83 = Math_fround(HEAPF32[i44 + 8 >> 2]);
   f81 = Math_fround(f83 * Math_fround(HEAPF32[i57 + 24 >> 2]));
   f82 = Math_fround(f83 * Math_fround(HEAPF32[i38 >> 2]));
   f4 = Math_fround(f4 + f81);
   f5 = Math_fround(f5 + f82);
   f3 = Math_fround(f3 + Math_fround(f83 * Math_fround(HEAPF32[i39 >> 2])));
  }
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
  if (f7 > Math_fround(HEAPF32[i66 + 372 >> 2])) {
   f10 = Math_fround(Math_fround(1.0) / f7);
   f8 = Math_fround(f4 * f10);
   f5 = Math_fround(f5 * f10);
   f4 = Math_fround(f3 * f10);
   i9 = i66 + 96 | 0;
   f3 = Math_fround(HEAPF32[i66 + 116 >> 2]);
   f10 = Math_fround(HEAPF32[i66 + 108 >> 2]);
   i11 = f10 > Math_fround(0.0);
   f12 = Math_fround(HEAPF32[i66 + 104 >> 2]);
   i13 = f12 > Math_fround(0.0);
   f83 = Math_fround(HEAPF32[i66 + 112 >> 2]);
   if (Math_fround(f7 + (i11 | i13 ? Math_fround(0.0) : f83)) > f3) {
    f3 = Math_fround(f3 - f7);
    i14 = HEAP32[i64 >> 2] | 0;
    HEAP32[i64 >> 2] = i14 + 80;
    i6 = i14 + 78 | 0;
    HEAP16[i6 >> 1] = 0;
    HEAPF32[i14 >> 2] = f8;
    HEAPF32[i14 + 4 >> 2] = f5;
    HEAPF32[i14 + 8 >> 2] = f4;
    f83 = Math_fround(HEAPF32[i59 >> 2]);
    f82 = Math_fround(f4 * f83);
    f81 = Math_fround(HEAPF32[i60 >> 2]);
    f82 = Math_fround(f82 - Math_fround(f5 * f81));
    f81 = Math_fround(f8 * f81);
    f80 = Math_fround(HEAPF32[i58 >> 2]);
    f81 = Math_fround(f81 - Math_fround(f4 * f80));
    f83 = Math_fround(Math_fround(f5 * f80) - Math_fround(f8 * f83));
    HEAPF32[i14 + 16 >> 2] = f82;
    HEAPF32[i14 + 20 >> 2] = f81;
    HEAPF32[i14 + 24 >> 2] = f83;
    HEAPF32[i14 + 32 >> 2] = f8;
    HEAPF32[i14 + 36 >> 2] = f5;
    HEAPF32[i14 + 40 >> 2] = f4;
    f83 = Math_fround(HEAPF32[i62 >> 2]);
    f81 = Math_fround(f4 * f83);
    f82 = Math_fround(HEAPF32[i63 >> 2]);
    f81 = Math_fround(f81 - Math_fround(f5 * f82));
    f82 = Math_fround(f8 * f82);
    f80 = Math_fround(HEAPF32[i61 >> 2]);
    f82 = Math_fround(f82 - Math_fround(f4 * f80));
    f83 = Math_fround(Math_fround(f5 * f80) - Math_fround(f8 * f83));
    HEAPF32[i14 + 48 >> 2] = f81;
    HEAPF32[i14 + 52 >> 2] = f82;
    HEAPF32[i14 + 56 >> 2] = f83;
    HEAPF32[i14 + 12 >> 2] = f3;
    i2 = i14 + 76 | 0;
    i1 = HEAPU16[i2 >> 1] | 0;
    if (i11 | i13) {
     HEAPF32[i14 + 64 >> 2] = f12;
     HEAPF32[i14 + 68 >> 2] = f10;
     i1 = i1 | 17;
    } else {
     HEAP16[i6 >> 1] = 1025;
     i75 = HEAP32[i9 >> 2] | 0;
     HEAP32[i14 + 64 >> 2] = i75;
     HEAP32[i14 + 68 >> 2] = HEAP32[i66 + 100 >> 2];
     i66 = f3 > Math_fround(0.0);
     i1 = (i66 ? 24 : 16) | i1;
     if ((HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
    }
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i14 + 44 >> 2] = Math_fround(0.0);
   }
  }
 }
 switch (i65 & 56 | 0) {
 case 16:
  {
   f78 = Math_fround(HEAPF32[i55 >> 2]);
   f80 = Math_fround(f50 * f78);
   f79 = Math_fround(HEAPF32[i54 >> 2]);
   f80 = Math_fround(f80 - Math_fround(f51 * f79));
   f83 = Math_fround(HEAPF32[i68 >> 2]);
   f81 = Math_fround(Math_fround(f51 * f83) - Math_fround(f49 * f78));
   f82 = Math_fround(Math_fround(f49 * f79) - Math_fround(f50 * f83));
   f83 = Math_fround(-Math_fround(Math_fround(f51 * f78) + Math_fround(Math_fround(f50 * f79) + Math_fround(f49 * f83))));
   i75 = HEAP32[i64 >> 2] | 0;
   HEAP32[i64 >> 2] = i75 + 80;
   HEAP16[i75 + 78 >> 1] = 1024;
   HEAP32[i75 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   HEAPF32[i75 + 16 >> 2] = f80;
   HEAPF32[i75 + 20 >> 2] = f81;
   HEAPF32[i75 + 24 >> 2] = f82;
   HEAP32[i75 + 32 >> 2] = 0;
   HEAP32[i75 + 36 >> 2] = 0;
   HEAP32[i75 + 40 >> 2] = 0;
   HEAPF32[i75 + 48 >> 2] = f80;
   HEAPF32[i75 + 52 >> 2] = f81;
   HEAPF32[i75 + 56 >> 2] = f82;
   HEAPF32[i75 + 12 >> 2] = f83;
   i75 = i75 + 76 | 0;
   HEAP16[i75 >> 1] = HEAPU16[i75 >> 1] | 0 | 16;
   i75 = i65 & -17;
   i68 = i70 + 16 | 0;
   i70 = i75 & 7;
   i75 = i75 >>> 3;
   __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i72, i69, i71, i68, i70, i75);
   i71 = HEAP32[i64 >> 2] | 0;
   i75 = HEAP32[i72 >> 2] | 0;
   i72 = i71;
   i75 = i72 - i75 | 0;
   i75 = (i75 | 0) / 80 | 0;
   STACKTOP = i73;
   return i75 | 0;
  }
 case 32:
  {
   f78 = Math_fround(HEAPF32[i53 >> 2]);
   f80 = Math_fround(f50 * f78);
   f79 = Math_fround(HEAPF32[i52 >> 2]);
   f80 = Math_fround(f80 - Math_fround(f51 * f79));
   f83 = Math_fround(HEAPF32[i67 >> 2]);
   f81 = Math_fround(Math_fround(f51 * f83) - Math_fround(f49 * f78));
   f82 = Math_fround(Math_fround(f49 * f79) - Math_fround(f50 * f83));
   f83 = Math_fround(-Math_fround(Math_fround(f51 * f78) + Math_fround(Math_fround(f50 * f79) + Math_fround(f49 * f83))));
   i75 = HEAP32[i64 >> 2] | 0;
   HEAP32[i64 >> 2] = i75 + 80;
   HEAP16[i75 + 78 >> 1] = 1024;
   HEAP32[i75 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   HEAPF32[i75 + 16 >> 2] = f80;
   HEAPF32[i75 + 20 >> 2] = f81;
   HEAPF32[i75 + 24 >> 2] = f82;
   HEAP32[i75 + 32 >> 2] = 0;
   HEAP32[i75 + 36 >> 2] = 0;
   HEAP32[i75 + 40 >> 2] = 0;
   HEAPF32[i75 + 48 >> 2] = f80;
   HEAPF32[i75 + 52 >> 2] = f81;
   HEAPF32[i75 + 56 >> 2] = f82;
   HEAPF32[i75 + 12 >> 2] = f83;
   i75 = i75 + 76 | 0;
   HEAP16[i75 >> 1] = HEAPU16[i75 >> 1] | 0 | 16;
   i75 = i65 & -33;
   i68 = i70 + 16 | 0;
   i70 = i75 & 7;
   i75 = i75 >>> 3;
   __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i72, i69, i71, i68, i70, i75);
   i71 = HEAP32[i64 >> 2] | 0;
   i75 = HEAP32[i72 >> 2] | 0;
   i72 = i71;
   i75 = i72 - i75 | 0;
   i75 = (i75 | 0) / 80 | 0;
   STACKTOP = i73;
   return i75 | 0;
  }
 default:
  {
   i75 = i65;
   i68 = i70 + 16 | 0;
   i70 = i75 & 7;
   i75 = i75 >>> 3;
   __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i72, i69, i71, i68, i70, i75);
   i71 = HEAP32[i64 >> 2] | 0;
   i75 = HEAP32[i72 >> 2] | 0;
   i72 = i71;
   i75 = i72 - i75 | 0;
   i75 = (i75 | 0) / 80 | 0;
   STACKTOP = i73;
   return i75 | 0;
  }
 }
 return 0;
}

function __ZN12InputManager11MakeDefaultEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 132 | 0;
 i9 = i13 + 24 | 0;
 i10 = i13 + 12 | 0;
 i6 = i13;
 i12 = i1 + 28 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440974 | 0, 10);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i8 = i1 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + 36 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i2, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440985 | 0, 8);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i5 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 435735 | 0, 5);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255) | 0)) i4 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i4 = 0; else i4 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 435741 | 0, 4);
 i3 = HEAP8[i9 + 11 >> 0] | 0;
 if (!((i3 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255) | 0)) i3 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i9) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i3 = 0; else i3 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1086046 | 0, 1);
 i2 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i10) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1085926 | 0, 1);
 i1 = HEAP8[i6 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i6) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i5 + 56 >> 2] = i4;
 HEAP32[i5 + 60 >> 2] = i3;
 HEAP32[i5 + 64 >> 2] = i2;
 HEAP32[i5 + 68 >> 2] = i1;
 HEAP32[i5 + 76 >> 2] = 0;
 HEAPF32[i5 + 100 >> 2] = Math_fround(3.0);
 HEAPF32[i5 + 92 >> 2] = Math_fround(3.0);
 HEAP8[i5 + 104 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i5 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 435727 | 0, 2);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255) | 0)) i4 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i4 = 0; else i4 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 435730 | 0, 4);
 i3 = HEAP8[i9 + 11 >> 0] | 0;
 if (!((i3 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255) | 0)) i3 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i9) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i3 = 0; else i3 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1085899 | 0, 1);
 i2 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i10) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1085935 | 0, 1);
 i1 = HEAP8[i6 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i6) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i5 + 164 >> 2] = i4;
 HEAP32[i5 + 168 >> 2] = i3;
 HEAP32[i5 + 172 >> 2] = i2;
 HEAP32[i5 + 176 >> 2] = i1;
 HEAP32[i5 + 184 >> 2] = 0;
 HEAPF32[i5 + 208 >> 2] = Math_fround(3.0);
 HEAPF32[i5 + 200 >> 2] = Math_fround(3.0);
 HEAP8[i5 + 212 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440994 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441e3 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441006 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441012 | 0, 4);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i3 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 435895 | 0, 9);
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i2 = 0;
   break;
  }
  i2 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 436034 | 0, 7);
 i6 = HEAP8[i9 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i9) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i3 + 272 >> 2] = i2;
 HEAP32[i3 + 276 >> 2] = 0;
 HEAP32[i3 + 280 >> 2] = i1;
 HEAP32[i3 + 284 >> 2] = 0;
 HEAP32[i3 + 292 >> 2] = 0;
 HEAPF32[i3 + 316 >> 2] = Math_fround(1.0e3);
 HEAPF32[i3 + 308 >> 2] = Math_fround(1.0e3);
 HEAP8[i3 + 320 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i3 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 435915 | 0, 8);
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i2 = 0;
   break;
  }
  i2 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 436042 | 0, 7);
 i6 = HEAP8[i9 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i9) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i3 + 380 >> 2] = i2;
 HEAP32[i3 + 384 >> 2] = 0;
 HEAP32[i3 + 388 >> 2] = i1;
 HEAP32[i3 + 392 >> 2] = 0;
 HEAP32[i3 + 400 >> 2] = 0;
 HEAPF32[i3 + 424 >> 2] = Math_fround(1.0e3);
 HEAPF32[i3 + 416 >> 2] = Math_fround(1.0e3);
 HEAP8[i3 + 428 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i3 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 435873 | 0, 10);
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i2 = 0;
   break;
  }
  i2 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 436050 | 0, 7);
 i6 = HEAP8[i9 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i9) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i3 + 488 >> 2] = i2;
 HEAP32[i3 + 492 >> 2] = 0;
 HEAP32[i3 + 496 >> 2] = i1;
 HEAP32[i3 + 500 >> 2] = 0;
 HEAP32[i3 + 508 >> 2] = 0;
 HEAPF32[i3 + 532 >> 2] = Math_fround(1.0e3);
 HEAPF32[i3 + 524 >> 2] = Math_fround(1.0e3);
 HEAP8[i3 + 536 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1084278 | 0, 5);
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i6 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i2 + 596 >> 2] = i1;
 HEAP32[i2 + 600 >> 2] = 0;
 HEAP32[i2 + 604 >> 2] = 0;
 HEAP32[i2 + 608 >> 2] = 0;
 HEAP32[i2 + 616 >> 2] = 0;
 HEAPF32[i2 + 640 >> 2] = Math_fround(1.0e3);
 HEAPF32[i2 + 632 >> 2] = Math_fround(1.0e3);
 HEAP8[i2 + 644 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441017 | 0, 7);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441025 | 0, 7);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441033 | 0, 17);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i1 + 724 >> 2] = 1;
 HEAP32[i1 + 736 >> 2] = 0;
 HEAPF32[i1 + 744 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 748 >> 2] = Math_fround(.100000001);
 HEAP32[i1 + 832 >> 2] = 1;
 HEAP32[i1 + 844 >> 2] = 1;
 HEAPF32[i1 + 852 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 856 >> 2] = Math_fround(.100000001);
 HEAP32[i1 + 940 >> 2] = 1;
 HEAP32[i1 + 952 >> 2] = 2;
 HEAPF32[i1 + 960 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 964 >> 2] = Math_fround(.100000001);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440974 | 0, 10);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440985 | 0, 8);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i1 + 1048 >> 2] = 2;
 HEAP32[i1 + 1060 >> 2] = 0;
 HEAPF32[i1 + 1072 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1068 >> 2] = Math_fround(.189999998);
 HEAPF32[i1 + 1064 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 1076 >> 0] = 0;
 HEAP8[i1 + 1077 >> 0] = 0;
 HEAP32[i1 + 1156 >> 2] = 2;
 HEAP32[i1 + 1168 >> 2] = 1;
 HEAPF32[i1 + 1180 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1176 >> 2] = Math_fround(.189999998);
 HEAPF32[i1 + 1172 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 1184 >> 0] = 0;
 HEAP8[i1 + 1185 >> 0] = 1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 440994 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441e3 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441006 | 0, 5);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 441012 | 0, 4);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i9); else {
  __ZN9InputAxisC2ERKS_(i1, i9);
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
 }
 HEAP32[i9 >> 2] = gb + 59740 + 8;
 i1 = i9 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 i1 = i9 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 434550 | 0, 17);
 i10 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i10 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i2 + 1244 >> 2] = i1;
 HEAP32[i2 + 1248 >> 2] = 0;
 HEAP32[i2 + 1252 >> 2] = 0;
 HEAP32[i2 + 1256 >> 2] = 0;
 HEAP32[i2 + 1264 >> 2] = 0;
 HEAPF32[i2 + 1288 >> 2] = Math_fround(1.0e3);
 HEAPF32[i2 + 1280 >> 2] = Math_fround(1.0e3);
 HEAP8[i2 + 1292 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 434582 | 0, 17);
 i10 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i10 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i2 + 1352 >> 2] = i1;
 HEAP32[i2 + 1356 >> 2] = 0;
 HEAP32[i2 + 1360 >> 2] = 0;
 HEAP32[i2 + 1364 >> 2] = 0;
 HEAP32[i2 + 1372 >> 2] = 0;
 HEAPF32[i2 + 1396 >> 2] = Math_fround(1.0e3);
 HEAPF32[i2 + 1388 >> 2] = Math_fround(1.0e3);
 HEAP8[i2 + 1400 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 436090 | 0, 17);
 i10 = HEAP8[i11 + 11 >> 0] | 0;
 do if (!((i10 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 + 28 >> 2] | 0;
 } while (0);
 HEAP32[i2 + 1460 >> 2] = i1;
 HEAP32[i2 + 1464 >> 2] = 0;
 HEAP32[i2 + 1468 >> 2] = 0;
 HEAP32[i2 + 1472 >> 2] = 0;
 HEAP32[i2 + 1480 >> 2] = 0;
 HEAPF32[i2 + 1504 >> 2] = Math_fround(1.0e3);
 HEAPF32[i2 + 1496 >> 2] = Math_fround(1.0e3);
 HEAP8[i2 + 1508 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 436108 | 0, 17);
 i10 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i10 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255) | 0)) {
  i9 = 0;
  i10 = i1 + 1568 | 0;
  HEAP32[i10 >> 2] = i9;
  i10 = i1 + 1572 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1576 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1580 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1588 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1612 | 0;
  HEAPF32[i10 >> 2] = Math_fround(1.0e3);
  i10 = i1 + 1604 | 0;
  HEAPF32[i10 >> 2] = Math_fround(1.0e3);
  i10 = i1 + 1616 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE(i12);
  STACKTOP = i13;
  return;
 }
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
 if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
  i9 = 0;
  i10 = i1 + 1568 | 0;
  HEAP32[i10 >> 2] = i9;
  i10 = i1 + 1572 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1576 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1580 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1588 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i1 + 1612 | 0;
  HEAPF32[i10 >> 2] = Math_fround(1.0e3);
  i10 = i1 + 1604 | 0;
  HEAPF32[i10 >> 2] = Math_fround(1.0e3);
  i10 = i1 + 1616 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE(i12);
  STACKTOP = i13;
  return;
 }
 i9 = HEAP32[i2 + 28 >> 2] | 0;
 i10 = i1 + 1568 | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i1 + 1572 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i1 + 1576 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i1 + 1580 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i1 + 1588 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i1 + 1612 | 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0e3);
 i10 = i1 + 1604 | 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0e3);
 i10 = i1 + 1616 | 0;
 HEAP8[i10 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE(i12);
 STACKTOP = i13;
 return;
}

function __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j(i14, i17, i18) {
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 32 | 0;
 i16 = i19;
 i13 = i19 + 144 | 0;
 i12 = i19 + 96 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj139ES3_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i17, i14 + 132 | 0, i18 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i17, i14 + 160 | 0, i18 + 3 | 0);
 i5 = i14 + 176 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i1 = i16 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj142ENS_22PxRepXPropertyAccessorILj142ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 204 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj144ENS_22PxRepXPropertyAccessorILj144ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 220 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 236 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 252 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 280 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 296 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 312 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 340 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i14 + 364 >> 2] | 0;
 i5 = HEAP32[i14 + 356 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i15;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 i8 = i17 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = i12;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev(i12);
 i9 = i17 + 8 | 0;
 mftCall_vii(i6 | 0, i13 | 0, HEAP32[i9 >> 2] | 0);
 i11 = i17 + 4 | 0;
 i10 = i17 + 12 | 0;
 i7 = i17 + 16 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev(i15);
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 HEAP32[i16 + 8 >> 2] = i13;
 HEAP32[i16 + 12 >> 2] = i2;
 HEAP32[i16 + 16 >> 2] = i1;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 __ZNK5physx42PxClothMotionConstraintConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEEEEEjT_j(i15, i16, 0) | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 i1 = i14 + 372 | 0;
 i2 = i18 + 17 | 0;
 i3 = i15;
 i4 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev(i15);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i17, i2, i1, gb + 90072 | 0, i15);
 i6 = HEAP32[i14 + 396 >> 2] | 0;
 i5 = HEAP32[i14 + 388 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i20 = i15;
  i4 = HEAP32[i20 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 0;
 HEAP32[i12 + 28 >> 2] = 0;
 __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev(i12);
 mftCall_vii(i6 | 0, i13 | 0, HEAP32[i9 >> 2] | 0);
 i12 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev(i15);
 HEAP32[i16 >> 2] = i12;
 HEAP32[i16 + 4 >> 2] = i20;
 HEAP32[i16 + 8 >> 2] = i13;
 HEAP32[i16 + 12 >> 2] = i1;
 HEAP32[i16 + 16 >> 2] = i2;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 __ZNK5physx32PxClothTetherConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEEEEEjT_j(i15, i16, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 404 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i15;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj157ENS_22PxRepXPropertyAccessorILj157ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 420 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i15;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj158ENS_22PxRepXPropertyAccessorILj158ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 436 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i15;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj159ENS_22PxRepXPropertyAccessorILj159ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 452 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i15;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj160ENS_22PxRepXPropertyAccessorILj160ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i14 + 476 >> 2] | 0;
 i5 = HEAP32[i14 + 468 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i15;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(i6 | 0, i13 | 0, HEAP32[i9 >> 2] | 0);
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i3, i16) | 0;
 HEAP8[i15 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i15 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 484 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i20 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj162ENS_22PxRepXPropertyAccessorILj162ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 500 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i20 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj163ENS_22PxRepXPropertyAccessorILj163ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 516 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i20 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj164ENS_22PxRepXPropertyAccessorILj164ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i14 + 532 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i20 = i16 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i14 = i15;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i20 + 4 >> 2] = i15;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj165ENS_22PxRepXPropertyAccessorILj165ES4_ffEEEEvRKT0_(i17, i16);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i20 = i18 + 30 | 0;
  STACKTOP = i19;
  return i20 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i20 = i18 + 30 | 0;
 STACKTOP = i19;
 return i20 | 0;
}

function __ZN13SpeedTreeWind7SParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i5 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i4 = i7 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i7 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i7 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i7 + 68 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 108 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 112 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 116 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 140 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 144 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 148 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 152 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 156 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 160 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 164 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 168 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 172 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 176 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 180 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 184 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 188 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 192 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 196 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 200 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 204 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 208 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 212 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 216 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 220 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 224 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 228 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 232 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 236 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 240 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 244 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 248 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 252 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 256 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 260 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 264 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 268 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 272 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 276 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 280 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 284 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 288 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 292 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 296 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 300 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 308 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 312 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 316 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 320 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 324 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 328 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 332 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 336 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 340 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 344 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 348 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 352 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 356 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 360 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 364 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 368 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 372 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 376 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 380 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 384 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 388 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 392 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 396 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 400 | 0;
 i2 = i3 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 404 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 408 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 412 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 416 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 420 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 424 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 428 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 432 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 436 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 440 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 444 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 448 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 452 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 456 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 460 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 464 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 468 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 472 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 476 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 480 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 484 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 488 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 492 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 496 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 500 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 504 | 0, i5);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 636 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 768 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 992 | 0, i5);
 i1 = i7 + 1216 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1220 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1224 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1228 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1232 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1236 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1240 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1244 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1248 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1252 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1256 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1260 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1264 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1268 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1272 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1276 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1280 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1284 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1288 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1292 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1296 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1300 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1304 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1308 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1312 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1316 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1320 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1324 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 1328 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i1, i86) {
 i1 = i1 | 0;
 i86 = i86 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0;
 i100 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i87 = i100;
 i96 = HEAP32[i1 >> 2] | 0;
 i97 = HEAP32[i1 + 32 >> 2] | 0;
 i98 = HEAP32[i1 + 64 >> 2] | 0;
 i99 = HEAP32[i1 + 96 >> 2] | 0;
 i25 = HEAP32[i1 + 16 >> 2] | 0;
 i85 = HEAP16[i1 + 26 >> 1] | 0;
 i84 = i25 + ((i85 & 65535) << 4) | 0;
 HEAP32[i87 >> 2] = 2139095039;
 HEAP32[i87 + 4 >> 2] = 2139095039;
 HEAP32[i87 + 8 >> 2] = 2139095039;
 HEAP32[i87 + 12 >> 2] = 2139095039;
 i19 = HEAP32[i96 >> 2] | 0;
 i17 = HEAP32[i96 + 4 >> 2] | 0;
 i13 = HEAP32[i96 + 8 >> 2] | 0;
 i88 = HEAP32[i96 + 12 >> 2] | 0;
 i89 = i96 + 16 | 0;
 i9 = HEAP32[i89 >> 2] | 0;
 i5 = HEAP32[i89 + 4 >> 2] | 0;
 i1 = HEAP32[i89 + 8 >> 2] | 0;
 i89 = HEAP32[i89 + 12 >> 2] | 0;
 i21 = HEAP32[i97 >> 2] | 0;
 i18 = HEAP32[i97 + 4 >> 2] | 0;
 i14 = HEAP32[i97 + 8 >> 2] | 0;
 i90 = HEAP32[i97 + 12 >> 2] | 0;
 i91 = i97 + 16 | 0;
 i10 = HEAP32[i91 >> 2] | 0;
 i6 = HEAP32[i91 + 4 >> 2] | 0;
 i2 = HEAP32[i91 + 8 >> 2] | 0;
 i91 = HEAP32[i91 + 12 >> 2] | 0;
 i23 = HEAP32[i98 >> 2] | 0;
 i20 = HEAP32[i98 + 4 >> 2] | 0;
 i15 = HEAP32[i98 + 8 >> 2] | 0;
 i92 = HEAP32[i98 + 12 >> 2] | 0;
 i93 = i98 + 16 | 0;
 i11 = HEAP32[i93 >> 2] | 0;
 i7 = HEAP32[i93 + 4 >> 2] | 0;
 i3 = HEAP32[i93 + 8 >> 2] | 0;
 i93 = HEAP32[i93 + 12 >> 2] | 0;
 i24 = HEAP32[i99 >> 2] | 0;
 i22 = HEAP32[i99 + 4 >> 2] | 0;
 i16 = HEAP32[i99 + 8 >> 2] | 0;
 i94 = HEAP32[i99 + 12 >> 2] | 0;
 i95 = i99 + 16 | 0;
 i12 = HEAP32[i95 >> 2] | 0;
 i8 = HEAP32[i95 + 4 >> 2] | 0;
 i4 = HEAP32[i95 + 8 >> 2] | 0;
 i95 = HEAP32[i95 + 12 >> 2] | 0;
 if (!(i85 << 16 >> 16)) {
  i45 = i24;
  i40 = i23;
  i30 = i21;
  i28 = i19;
  i46 = i22;
  i41 = i20;
  i32 = i18;
  i24 = i17;
  i49 = i16;
  i44 = i15;
  i33 = i14;
  i25 = i13;
  i85 = i12;
  i82 = i11;
  i75 = i10;
  i50 = i9;
  i86 = i8;
  i83 = i7;
  i80 = i6;
  i51 = i5;
  i87 = i4;
  i84 = i3;
  i81 = i2;
  i52 = i1;
  HEAP32[i96 >> 2] = i28;
  i28 = i96 + 4 | 0;
  HEAP32[i28 >> 2] = i24;
  i28 = i96 + 8 | 0;
  HEAP32[i28 >> 2] = i25;
  i28 = i96 + 12 | 0;
  HEAP32[i28 >> 2] = i88;
  HEAP32[i97 >> 2] = i30;
  i88 = i97 + 4 | 0;
  HEAP32[i88 >> 2] = i32;
  i88 = i97 + 8 | 0;
  HEAP32[i88 >> 2] = i33;
  i88 = i97 + 12 | 0;
  HEAP32[i88 >> 2] = i90;
  HEAP32[i98 >> 2] = i40;
  i90 = i98 + 4 | 0;
  HEAP32[i90 >> 2] = i41;
  i90 = i98 + 8 | 0;
  HEAP32[i90 >> 2] = i44;
  i90 = i98 + 12 | 0;
  HEAP32[i90 >> 2] = i92;
  HEAP32[i99 >> 2] = i45;
  i92 = i99 + 4 | 0;
  HEAP32[i92 >> 2] = i46;
  i92 = i99 + 8 | 0;
  HEAP32[i92 >> 2] = i49;
  i92 = i99 + 12 | 0;
  HEAP32[i92 >> 2] = i94;
  i94 = i96 + 16 | 0;
  HEAP32[i94 >> 2] = i50;
  i94 = i96 + 20 | 0;
  HEAP32[i94 >> 2] = i51;
  i94 = i96 + 24 | 0;
  HEAP32[i94 >> 2] = i52;
  i96 = i96 + 28 | 0;
  HEAP32[i96 >> 2] = i89;
  i96 = i97 + 16 | 0;
  HEAP32[i96 >> 2] = i75;
  i96 = i97 + 20 | 0;
  HEAP32[i96 >> 2] = i80;
  i96 = i97 + 24 | 0;
  HEAP32[i96 >> 2] = i81;
  i97 = i97 + 28 | 0;
  HEAP32[i97 >> 2] = i91;
  i97 = i98 + 16 | 0;
  HEAP32[i97 >> 2] = i82;
  i97 = i98 + 20 | 0;
  HEAP32[i97 >> 2] = i83;
  i97 = i98 + 24 | 0;
  HEAP32[i97 >> 2] = i84;
  i98 = i98 + 28 | 0;
  HEAP32[i98 >> 2] = i93;
  i98 = i99 + 16 | 0;
  HEAP32[i98 >> 2] = i85;
  i98 = i99 + 20 | 0;
  HEAP32[i98 >> 2] = i86;
  i98 = i99 + 24 | 0;
  HEAP32[i98 >> 2] = i87;
  i99 = i99 + 28 | 0;
  HEAP32[i99 >> 2] = i95;
  STACKTOP = i100;
  return;
 }
 i85 = i86 + 1 | 0;
 i83 = i25;
 i25 = i25 + 288 | 0;
 do {
  i30 = i83 + 144 | 0;
  i52 = HEAP8[i83 + 1 >> 0] | 0;
  i40 = i52 & 255;
  i41 = HEAP8[i83 + 2 >> 0] | 0;
  i80 = i41 & 255;
  i51 = HEAPU8[i83 + 3 >> 0] | 0;
  i28 = (i51 & 1 | 0) == 0;
  i82 = i40 << 4;
  i32 = i83 + (i82 + 144) | 0;
  i75 = i32 + (i40 * 144 | 0) | 0;
  i33 = i28 ? i87 : i75;
  i82 = i28 ? i75 : i75 + i82 | 0;
  i41 = i41 << 24 >> 24 != 0;
  i75 = i41 ? i82 + 128 | 0 : i82;
  i81 = i75 + (i80 << 4) | 0;
  i44 = i83;
  i83 = i75 + (Math_imul((i51 << 3 & 16) + 144 | 0, i80) | 0) | 0;
  f76 = Math_fround(HEAPF32[i44 + 64 >> 2]);
  f77 = Math_fround(HEAPF32[i44 + 68 >> 2]);
  f78 = Math_fround(HEAPF32[i44 + 72 >> 2]);
  f79 = Math_fround(HEAPF32[i44 + 76 >> 2]);
  f63 = Math_fround(HEAPF32[i44 + 96 >> 2]);
  f64 = Math_fround(HEAPF32[i44 + 100 >> 2]);
  f65 = Math_fround(HEAPF32[i44 + 104 >> 2]);
  f66 = Math_fround(HEAPF32[i44 + 108 >> 2]);
  f67 = Math_fround(HEAPF32[i44 + 112 >> 2]);
  f68 = Math_fround(HEAPF32[i44 + 116 >> 2]);
  f69 = Math_fround(HEAPF32[i44 + 120 >> 2]);
  f70 = Math_fround(HEAPF32[i44 + 124 >> 2]);
  f71 = Math_fround(HEAPF32[i44 + 128 >> 2]);
  f72 = Math_fround(HEAPF32[i44 + 132 >> 2]);
  f73 = Math_fround(HEAPF32[i44 + 136 >> 2]);
  f74 = Math_fround(HEAPF32[i44 + 140 >> 2]);
  f60 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f60 * f63);
  f57 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f57 * f64);
  f54 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f54 * f65);
  f47 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = Math_fround(f47 * f66);
  f61 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f48 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 + Math_fround(f61 * f67));
  f27 = Math_fround(f27 + Math_fround(f58 * f68));
  f39 = Math_fround(f39 + Math_fround(f55 * f69));
  f38 = Math_fround(f38 + Math_fround(f48 * f70));
  f62 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f53 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 + Math_fround(f62 * f71));
  f27 = Math_fround(f27 + Math_fround(f59 * f72));
  f39 = Math_fround(f39 + Math_fround(f56 * f73));
  f38 = Math_fround(f38 + Math_fround(f53 * f74));
  if (!(i52 << 24 >> 24)) {
   f37 = Math_fround(0.0);
   f36 = Math_fround(0.0);
   f35 = Math_fround(0.0);
   f34 = Math_fround(0.0);
   f31 = Math_fround(0.0);
   f29 = Math_fround(0.0);
   f27 = Math_fround(0.0);
   f26 = Math_fround(0.0);
  } else {
   if (i28) {
    i15 = i33 + 4 | 0;
    i16 = i33 + 8 | 0;
    i17 = i33 + 12 | 0;
    f43 = f26;
    f42 = f27;
    f26 = Math_fround(0.0);
    f27 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    f31 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    i13 = 0;
    i14 = i25;
    while (1) {
     i49 = i30 + (i13 << 4) | 0;
     f114 = Math_fround(HEAPF32[i49 >> 2]);
     i50 = i30 + (i13 << 4) + 4 | 0;
     f112 = Math_fround(HEAPF32[i50 >> 2]);
     i51 = i30 + (i13 << 4) + 8 | 0;
     f110 = Math_fround(HEAPF32[i51 >> 2]);
     i52 = i30 + (i13 << 4) + 12 | 0;
     f105 = Math_fround(HEAPF32[i52 >> 2]);
     f104 = Math_fround(HEAPF32[i33 >> 2]);
     f103 = Math_fround(HEAPF32[i15 >> 2]);
     f102 = Math_fround(HEAPF32[i16 >> 2]);
     f101 = Math_fround(HEAPF32[i17 >> 2]);
     f124 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 4 >> 2]);
     f120 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 8 >> 2]);
     f130 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 12 >> 2]);
     f123 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f124 = Math_fround(f123 * f124);
     f122 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f106 = Math_fround(f122 * f106);
     f121 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f120 = Math_fround(f121 * f120);
     f116 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f130 = Math_fround(f116 * f130);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 16 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 20 >> 2]);
     f127 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 24 >> 2]);
     f128 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 28 >> 2]);
     f119 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f118 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f117 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f108 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f125 = Math_fround(f124 + Math_fround(f119 * f125));
     f126 = Math_fround(f106 + Math_fround(f118 * f126));
     f127 = Math_fround(f120 + Math_fround(f117 * f127));
     f128 = Math_fround(f130 + Math_fround(f108 * f128));
     f130 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 32 >> 2]);
     f120 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 36 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 40 >> 2]);
     f124 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 44 >> 2]);
     f115 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f113 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f111 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f109 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f130 = Math_fround(f43 + Math_fround(f125 + Math_fround(f115 * f130)));
     f120 = Math_fround(f42 + Math_fround(f126 + Math_fround(f113 * f120)));
     f106 = Math_fround(f39 + Math_fround(f127 + Math_fround(f111 * f106)));
     f124 = Math_fround(f38 + Math_fround(f128 + Math_fround(f109 * f124)));
     f128 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 96 >> 2]);
     f127 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 100 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 104 >> 2]);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 108 >> 2]);
     f131 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 128 >> 2]);
     f129 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 132 >> 2]);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 136 >> 2]);
     f128 = Math_fround(f131 - Math_fround(f130 * f128));
     f127 = Math_fround(f129 - Math_fround(f120 * f127));
     f126 = Math_fround(f107 - Math_fround(f106 * f126));
     f125 = Math_fround(Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 140 >> 2]) - Math_fround(f124 * f125));
     f124 = Math_fround(-f114);
     f106 = Math_fround(-f112);
     f107 = Math_fround(-f110);
     f120 = Math_fround(-f105);
     f124 = Math_fround(f114 + (f128 > f124 ? f128 : f124));
     f106 = Math_fround(f112 + (f127 > f106 ? f127 : f106));
     f107 = Math_fround(f110 + (f126 > f107 ? f126 : f107));
     f120 = Math_fround(f105 + (f125 > f120 ? f125 : f120));
     f104 = f124 < f104 ? f124 : f104;
     f103 = f106 < f103 ? f106 : f103;
     f102 = f107 < f102 ? f107 : f102;
     f101 = f120 < f101 ? f120 : f101;
     f114 = Math_fround(f104 - f114);
     f112 = Math_fround(f103 - f112);
     f110 = Math_fround(f102 - f110);
     f105 = Math_fround(f101 - f105);
     f26 = Math_fround(f26 + f114);
     f27 = Math_fround(f27 + f112);
     f29 = Math_fround(f29 + f110);
     f31 = Math_fround(f31 + f105);
     f43 = Math_fround(f43 + Math_fround(f76 * f114));
     f42 = Math_fround(f42 + Math_fround(f77 * f112));
     f39 = Math_fround(f39 + Math_fround(f78 * f110));
     f38 = Math_fround(f38 + Math_fround(f79 * f105));
     f120 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 48 >> 2]);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 52 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 56 >> 2]);
     f120 = Math_fround(f123 + Math_fround(f120 * f114));
     f107 = Math_fround(f122 + Math_fround(f107 * f112));
     f106 = Math_fround(f121 + Math_fround(f106 * f110));
     f116 = Math_fround(f116 + Math_fround(Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 60 >> 2]) * f105));
     i9 = (HEAPF32[tempDoublePtr >> 2] = f120, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
     f116 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 64 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 68 >> 2]);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 72 >> 2]);
     f116 = Math_fround(f119 + Math_fround(f114 * f116));
     f106 = Math_fround(f118 + Math_fround(f112 * f106));
     f107 = Math_fround(f117 + Math_fround(f110 * f107));
     f108 = Math_fround(f108 + Math_fround(f105 * Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 76 >> 2])));
     i5 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
     f108 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 80 >> 2]);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 84 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 88 >> 2]);
     f108 = Math_fround(f115 + Math_fround(f114 * f108));
     f107 = Math_fround(f113 + Math_fround(f112 * f107));
     f106 = Math_fround(f111 + Math_fround(f110 * f106));
     f105 = Math_fround(f109 + Math_fround(f105 * Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 92 >> 2])));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     HEAPF32[i49 >> 2] = f104;
     HEAPF32[i50 >> 2] = f103;
     HEAPF32[i51 >> 2] = f102;
     HEAPF32[i52 >> 2] = f101;
     f34 = Math_fround(f34 + f104);
     f35 = Math_fround(f35 + f103);
     f36 = Math_fround(f36 + f102);
     f37 = Math_fround(f37 + f101);
     i13 = i13 + 1 | 0;
     if ((i13 | 0) == (i40 | 0)) break; else i14 = i14 + 192 | 0;
    }
   } else {
    f43 = f26;
    f42 = f27;
    f26 = Math_fround(0.0);
    f27 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    f31 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    i13 = 0;
    i14 = i25;
    while (1) {
     i49 = i30 + (i13 << 4) | 0;
     f118 = Math_fround(HEAPF32[i49 >> 2]);
     i50 = i30 + (i13 << 4) + 4 | 0;
     f120 = Math_fround(HEAPF32[i50 >> 2]);
     i51 = i30 + (i13 << 4) + 8 | 0;
     f122 = Math_fround(HEAPF32[i51 >> 2]);
     i52 = i30 + (i13 << 4) + 12 | 0;
     f127 = Math_fround(HEAPF32[i52 >> 2]);
     f128 = Math_fround(HEAPF32[i33 + (i13 << 4) >> 2]);
     f129 = Math_fround(HEAPF32[i33 + (i13 << 4) + 4 >> 2]);
     f130 = Math_fround(HEAPF32[i33 + (i13 << 4) + 8 >> 2]);
     f131 = Math_fround(HEAPF32[i33 + (i13 << 4) + 12 >> 2]);
     f108 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 4 >> 2]);
     f112 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 8 >> 2]);
     f102 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 12 >> 2]);
     f109 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f108 = Math_fround(f109 * f108);
     f110 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f126 = Math_fround(f110 * f126);
     f111 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f112 = Math_fround(f111 * f112);
     f116 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f102 = Math_fround(f116 * f102);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 16 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 20 >> 2]);
     f105 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 24 >> 2]);
     f104 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 28 >> 2]);
     f113 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f114 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f115 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f124 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f107 = Math_fround(f108 + Math_fround(f113 * f107));
     f106 = Math_fround(f126 + Math_fround(f114 * f106));
     f105 = Math_fround(f112 + Math_fround(f115 * f105));
     f104 = Math_fround(f102 + Math_fround(f124 * f104));
     f102 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 32 >> 2]);
     f112 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 36 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 40 >> 2]);
     f108 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 44 >> 2]);
     f117 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f119 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f121 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f123 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f102 = Math_fround(f43 + Math_fround(f107 + Math_fround(f117 * f102)));
     f112 = Math_fround(f42 + Math_fround(f106 + Math_fround(f119 * f112)));
     f126 = Math_fround(f39 + Math_fround(f105 + Math_fround(f121 * f126)));
     f108 = Math_fround(f38 + Math_fround(f104 + Math_fround(f123 * f108)));
     f104 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 96 >> 2]);
     f105 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 100 >> 2]);
     f106 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 104 >> 2]);
     f107 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 108 >> 2]);
     f101 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 128 >> 2]);
     f103 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 132 >> 2]);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 136 >> 2]);
     f104 = Math_fround(f101 - Math_fround(f102 * f104));
     f105 = Math_fround(f103 - Math_fround(f112 * f105));
     f106 = Math_fround(f125 - Math_fround(f126 * f106));
     f107 = Math_fround(Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 140 >> 2]) - Math_fround(f108 * f107));
     f108 = Math_fround(-f118);
     f126 = Math_fround(-f120);
     f125 = Math_fround(-f122);
     f112 = Math_fround(-f127);
     f108 = Math_fround(f118 + (f104 > f108 ? f104 : f108));
     f126 = Math_fround(f120 + (f105 > f126 ? f105 : f126));
     f125 = Math_fround(f122 + (f106 > f125 ? f106 : f125));
     f112 = Math_fround(f127 + (f107 > f112 ? f107 : f112));
     f128 = f108 < f128 ? f108 : f128;
     f129 = f126 < f129 ? f126 : f129;
     f130 = f125 < f130 ? f125 : f130;
     f131 = f112 < f131 ? f112 : f131;
     f118 = Math_fround(f128 - f118);
     f120 = Math_fround(f129 - f120);
     f122 = Math_fround(f130 - f122);
     f127 = Math_fround(f131 - f127);
     f26 = Math_fround(f26 + f118);
     f27 = Math_fround(f27 + f120);
     f29 = Math_fround(f29 + f122);
     f31 = Math_fround(f31 + f127);
     f43 = Math_fround(f43 + Math_fround(f76 * f118));
     f42 = Math_fround(f42 + Math_fround(f77 * f120));
     f39 = Math_fround(f39 + Math_fround(f78 * f122));
     f38 = Math_fround(f38 + Math_fround(f79 * f127));
     f112 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 48 >> 2]);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 52 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 56 >> 2]);
     f112 = Math_fround(f109 + Math_fround(f112 * f118));
     f125 = Math_fround(f110 + Math_fround(f125 * f120));
     f126 = Math_fround(f111 + Math_fround(f126 * f122));
     f116 = Math_fround(f116 + Math_fround(Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 60 >> 2]) * f127));
     i9 = (HEAPF32[tempDoublePtr >> 2] = f112, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
     f116 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 64 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 68 >> 2]);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 72 >> 2]);
     f116 = Math_fround(f113 + Math_fround(f118 * f116));
     f126 = Math_fround(f114 + Math_fround(f120 * f126));
     f125 = Math_fround(f115 + Math_fround(f122 * f125));
     f124 = Math_fround(f124 + Math_fround(f127 * Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 76 >> 2])));
     i5 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     f124 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 80 >> 2]);
     f125 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 84 >> 2]);
     f126 = Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 88 >> 2]);
     f124 = Math_fround(f117 + Math_fround(f118 * f124));
     f125 = Math_fround(f119 + Math_fround(f120 * f125));
     f126 = Math_fround(f121 + Math_fround(f122 * f126));
     f127 = Math_fround(f123 + Math_fround(f127 * Math_fround(HEAPF32[i32 + (i13 * 144 | 0) + 92 >> 2])));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
     HEAPF32[i49 >> 2] = f128;
     HEAPF32[i50 >> 2] = f129;
     HEAPF32[i51 >> 2] = f130;
     HEAPF32[i52 >> 2] = f131;
     f34 = Math_fround(f34 + f128);
     f35 = Math_fround(f35 + f129);
     f36 = Math_fround(f36 + f130);
     f37 = Math_fround(f37 + f131);
     i13 = i13 + 1 | 0;
     if ((i13 | 0) == (i40 | 0)) break; else i14 = i14 + 192 | 0;
    }
   }
   i25 = i25 + (i40 * 192 | 0) | 0;
  }
  f128 = Math_fround(f76 * f26);
  f129 = Math_fround(f77 * f27);
  f130 = Math_fround(f78 * f29);
  f131 = Math_fround(f79 * f31);
  f127 = Math_fround(f60 + Math_fround(f63 * f128));
  f126 = Math_fround(f57 + Math_fround(f64 * f129));
  f125 = Math_fround(f54 + Math_fround(f65 * f130));
  f124 = Math_fround(f47 + Math_fround(f66 * f131));
  i19 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  f124 = Math_fround(f61 + Math_fround(f67 * f128));
  f125 = Math_fround(f58 + Math_fround(f68 * f129));
  f126 = Math_fround(f55 + Math_fround(f69 * f130));
  f127 = Math_fround(f48 + Math_fround(f70 * f131));
  i17 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  f128 = Math_fround(f62 + Math_fround(f71 * f128));
  f129 = Math_fround(f59 + Math_fround(f72 * f129));
  f130 = Math_fround(f56 + Math_fround(f73 * f130));
  f131 = Math_fround(f53 + Math_fround(f74 * f131));
  i13 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f130, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f131, HEAP32[tempDoublePtr >> 2] | 0);
  if (i41 & (HEAP8[i86 >> 0] | 0) != 0) {
   f42 = Math_fround(HEAPF32[i44 + 32 >> 2]);
   f43 = Math_fround(HEAPF32[i44 + 36 >> 2]);
   f47 = Math_fround(HEAPF32[i44 + 40 >> 2]);
   f48 = Math_fround(HEAPF32[i44 + 44 >> 2]);
   f39 = Math_fround(HEAPF32[i44 + 48 >> 2]);
   f38 = Math_fround(HEAPF32[i44 + 52 >> 2]);
   f26 = Math_fround(HEAPF32[i44 + 56 >> 2]);
   f42 = Math_fround(f34 * f42);
   f43 = Math_fround(f35 * f43);
   f47 = Math_fround(f36 * f47);
   f48 = Math_fround(f37 * f48);
   f39 = Math_fround(f34 * f39);
   f38 = Math_fround(f35 * f38);
   f35 = Math_fround(f36 * f26);
   f26 = Math_fround(f37 * Math_fround(HEAPF32[i44 + 60 >> 2]));
   f27 = Math_fround(-f39);
   f29 = Math_fround(-f38);
   f31 = Math_fround(-f35);
   f34 = Math_fround(-f26);
   i49 = i82 + 4 | 0;
   i50 = i82 + 8 | 0;
   i51 = i82 + 12 | 0;
   i44 = i82 + 32 | 0;
   i45 = i82 + 64 | 0;
   i46 = i82 + 96 | 0;
   i52 = i80 * 192 | 0;
   i33 = HEAP32[i82 >> 2] | 0;
   i32 = HEAP32[i49 >> 2] | 0;
   i30 = HEAP32[i50 >> 2] | 0;
   i28 = HEAP32[i51 >> 2] | 0;
   i40 = 0;
   i41 = i25;
   while (1) {
    i135 = i75 + (i40 << 4) | 0;
    f118 = Math_fround(HEAPF32[i135 >> 2]);
    i134 = i75 + (i40 << 4) + 4 | 0;
    f120 = Math_fround(HEAPF32[i134 >> 2]);
    i133 = i75 + (i40 << 4) + 8 | 0;
    f122 = Math_fround(HEAPF32[i133 >> 2]);
    i132 = i75 + (i40 << 4) + 12 | 0;
    f127 = Math_fround(HEAPF32[i132 >> 2]);
    i136 = i40 & 1;
    f62 = Math_fround(HEAPF32[i44 + (i136 << 4) >> 2]);
    f68 = Math_fround(HEAPF32[i44 + (i136 << 4) + 4 >> 2]);
    f67 = Math_fround(HEAPF32[i44 + (i136 << 4) + 8 >> 2]);
    f66 = Math_fround(HEAPF32[i44 + (i136 << 4) + 12 >> 2]);
    f74 = Math_fround(HEAPF32[i45 + (i136 << 4) >> 2]);
    f106 = Math_fround(HEAPF32[i45 + (i136 << 4) + 4 >> 2]);
    f105 = Math_fround(HEAPF32[i45 + (i136 << 4) + 8 >> 2]);
    f104 = Math_fround(HEAPF32[i45 + (i136 << 4) + 12 >> 2]);
    f109 = Math_fround(HEAPF32[i46 + (i136 << 4) >> 2]);
    f111 = Math_fround(HEAPF32[i46 + (i136 << 4) + 4 >> 2]);
    f113 = Math_fround(HEAPF32[i46 + (i136 << 4) + 8 >> 2]);
    f115 = Math_fround(HEAPF32[i46 + (i136 << 4) + 12 >> 2]);
    f58 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = Math_fround(f58 * f62);
    f59 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f129 = Math_fround(f59 * f68);
    f60 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f124 = Math_fround(f60 * f67);
    f61 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f57 = Math_fround(f61 * f66);
    f114 = Math_fround(HEAPF32[i81 + (i40 << 7) >> 2]);
    f112 = Math_fround(HEAPF32[i81 + (i40 << 7) + 4 >> 2]);
    f110 = Math_fround(HEAPF32[i81 + (i40 << 7) + 8 >> 2]);
    f108 = Math_fround(HEAPF32[i81 + (i40 << 7) + 12 >> 2]);
    f63 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f114 = Math_fround(f63 * f114);
    f64 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f112 = Math_fround(f64 * f112);
    f65 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f110 = Math_fround(f65 * f110);
    f69 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f108 = Math_fround(f69 * f108);
    f70 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f71 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f72 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f73 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = Math_fround(f54 + Math_fround(f70 * f74));
    f129 = Math_fround(f129 + Math_fround(f71 * f106));
    f124 = Math_fround(f124 + Math_fround(f72 * f105));
    f57 = Math_fround(f57 + Math_fround(f73 * f104));
    f130 = Math_fround(HEAPF32[i81 + (i40 << 7) + 16 >> 2]);
    f128 = Math_fround(HEAPF32[i81 + (i40 << 7) + 20 >> 2]);
    f126 = Math_fround(HEAPF32[i81 + (i40 << 7) + 24 >> 2]);
    f55 = Math_fround(HEAPF32[i81 + (i40 << 7) + 28 >> 2]);
    f101 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f102 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f103 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f107 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f130 = Math_fround(f114 + Math_fround(f101 * f130));
    f128 = Math_fround(f112 + Math_fround(f102 * f128));
    f126 = Math_fround(f110 + Math_fround(f103 * f126));
    f55 = Math_fround(f108 + Math_fround(f107 * f55));
    f108 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f110 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f112 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f114 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = Math_fround(f54 + Math_fround(f108 * f109));
    f129 = Math_fround(f129 + Math_fround(f110 * f111));
    f124 = Math_fround(f124 + Math_fround(f112 * f113));
    f57 = Math_fround(f57 + Math_fround(f114 * f115));
    f56 = Math_fround(HEAPF32[i81 + (i40 << 7) + 32 >> 2]);
    f116 = Math_fround(HEAPF32[i81 + (i40 << 7) + 36 >> 2]);
    f125 = Math_fround(HEAPF32[i81 + (i40 << 7) + 40 >> 2]);
    f131 = Math_fround(HEAPF32[i81 + (i40 << 7) + 44 >> 2]);
    f117 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f119 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f121 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f123 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = Math_fround(f54 + Math_fround(f130 + Math_fround(f117 * f56)));
    f116 = Math_fround(f129 + Math_fround(f128 + Math_fround(f119 * f116)));
    f125 = Math_fround(f124 + Math_fround(f126 + Math_fround(f121 * f125)));
    f131 = Math_fround(f57 + Math_fround(f55 + Math_fround(f123 * f131)));
    f55 = Math_fround(HEAPF32[i81 + (i40 << 7) + 96 >> 2]);
    f57 = Math_fround(HEAPF32[i81 + (i40 << 7) + 100 >> 2]);
    f126 = Math_fround(HEAPF32[i81 + (i40 << 7) + 104 >> 2]);
    f55 = Math_fround(f118 - f55);
    f57 = Math_fround(f120 - f57);
    f126 = Math_fround(f122 - f126);
    f124 = Math_fround(f127 - Math_fround(HEAPF32[i81 + (i40 << 7) + 108 >> 2]));
    f128 = Math_fround(HEAPF32[i81 + (i40 << 7) + 112 >> 2]);
    f129 = Math_fround(HEAPF32[i81 + (i40 << 7) + 116 >> 2]);
    f130 = Math_fround(HEAPF32[i81 + (i40 << 7) + 120 >> 2]);
    f128 = Math_fround(f55 - Math_fround(f56 * f128));
    f129 = Math_fround(f57 - Math_fround(f116 * f129));
    f130 = Math_fround(f126 - Math_fround(f125 * f130));
    f131 = Math_fround(f124 - Math_fround(f131 * Math_fround(HEAPF32[i81 + (i40 << 7) + 124 >> 2])));
    f124 = Math_fround(-f128);
    f125 = Math_fround(-f129);
    f126 = Math_fround(-f130);
    f116 = Math_fround(-f131);
    i33 = (i33 | 0 ? 1 : (f128 > f124 ? f128 : f124) > f42) << 31 >> 31;
    i32 = (i32 | 0 ? 1 : (f129 > f125 ? f129 : f125) > f43) << 31 >> 31;
    i30 = (i30 | 0 ? 1 : (f130 > f126 ? f130 : f126) > f47) << 31 >> 31;
    i28 = (i28 | 0 ? 1 : (f131 > f116 ? f131 : f116) > f48) << 31 >> 31;
    f128 = f128 < f27 ? f27 : f128;
    f129 = f129 < f29 ? f29 : f129;
    f130 = f130 < f31 ? f31 : f130;
    f131 = f131 < f34 ? f34 : f131;
    f128 = f39 < f128 ? f39 : f128;
    f129 = f38 < f129 ? f38 : f129;
    f130 = f35 < f130 ? f35 : f130;
    f131 = f26 < f131 ? f26 : f131;
    f118 = Math_fround(f128 - f118);
    f120 = Math_fround(f129 - f120);
    f122 = Math_fround(f130 - f122);
    f127 = Math_fround(f131 - f127);
    f116 = Math_fround(f76 * f118);
    f126 = Math_fround(f77 * f120);
    f125 = Math_fround(f78 * f122);
    f124 = Math_fround(f79 * f127);
    f62 = Math_fround(f58 + Math_fround(f62 * f116));
    f68 = Math_fround(f59 + Math_fround(f68 * f126));
    f67 = Math_fround(f60 + Math_fround(f67 * f125));
    f66 = Math_fround(f61 + Math_fround(f66 * f124));
    i19 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
    i21 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
    i24 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
    f66 = Math_fround(HEAPF32[i81 + (i40 << 7) + 48 >> 2]);
    f67 = Math_fround(HEAPF32[i81 + (i40 << 7) + 52 >> 2]);
    f68 = Math_fround(HEAPF32[i81 + (i40 << 7) + 56 >> 2]);
    f66 = Math_fround(f63 + Math_fround(f66 * f118));
    f67 = Math_fround(f64 + Math_fround(f67 * f120));
    f68 = Math_fround(f65 + Math_fround(f68 * f122));
    f69 = Math_fround(f69 + Math_fround(Math_fround(HEAPF32[i81 + (i40 << 7) + 60 >> 2]) * f127));
    i9 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
    f74 = Math_fround(f70 + Math_fround(f74 * f116));
    f106 = Math_fround(f71 + Math_fround(f106 * f126));
    f105 = Math_fround(f72 + Math_fround(f105 * f125));
    f104 = Math_fround(f73 + Math_fround(f104 * f124));
    i17 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    f104 = Math_fround(HEAPF32[i81 + (i40 << 7) + 64 >> 2]);
    f105 = Math_fround(HEAPF32[i81 + (i40 << 7) + 68 >> 2]);
    f106 = Math_fround(HEAPF32[i81 + (i40 << 7) + 72 >> 2]);
    f104 = Math_fround(f101 + Math_fround(f118 * f104));
    f105 = Math_fround(f102 + Math_fround(f120 * f105));
    f106 = Math_fround(f103 + Math_fround(f122 * f106));
    f107 = Math_fround(f107 + Math_fround(f127 * Math_fround(HEAPF32[i81 + (i40 << 7) + 76 >> 2])));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
    f116 = Math_fround(f108 + Math_fround(f109 * f116));
    f126 = Math_fround(f110 + Math_fround(f111 * f126));
    f125 = Math_fround(f112 + Math_fround(f113 * f125));
    f124 = Math_fround(f114 + Math_fround(f115 * f124));
    i13 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    f124 = Math_fround(HEAPF32[i81 + (i40 << 7) + 80 >> 2]);
    f125 = Math_fround(HEAPF32[i81 + (i40 << 7) + 84 >> 2]);
    f126 = Math_fround(HEAPF32[i81 + (i40 << 7) + 88 >> 2]);
    f124 = Math_fround(f117 + Math_fround(f118 * f124));
    f125 = Math_fround(f119 + Math_fround(f120 * f125));
    f126 = Math_fround(f121 + Math_fround(f122 * f126));
    f127 = Math_fround(f123 + Math_fround(f127 * Math_fround(HEAPF32[i81 + (i40 << 7) + 92 >> 2])));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f124, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i135 >> 2] = f128;
    HEAPF32[i134 >> 2] = f129;
    HEAPF32[i133 >> 2] = f130;
    HEAPF32[i132 >> 2] = f131;
    i40 = i40 + 1 | 0;
    if ((i40 | 0) == (i80 | 0)) break; else i41 = i41 + 192 | 0;
   }
   HEAP32[i82 >> 2] = i33;
   HEAP32[i49 >> 2] = i32;
   HEAP32[i50 >> 2] = i30;
   HEAP32[i51 >> 2] = i28;
   i25 = i25 + i52 | 0;
  }
 } while (i83 >>> 0 < i84 >>> 0);
 HEAP32[i96 >> 2] = i19;
 i136 = i96 + 4 | 0;
 HEAP32[i136 >> 2] = i17;
 i136 = i96 + 8 | 0;
 HEAP32[i136 >> 2] = i13;
 i136 = i96 + 12 | 0;
 HEAP32[i136 >> 2] = i88;
 HEAP32[i97 >> 2] = i21;
 i136 = i97 + 4 | 0;
 HEAP32[i136 >> 2] = i18;
 i136 = i97 + 8 | 0;
 HEAP32[i136 >> 2] = i14;
 i136 = i97 + 12 | 0;
 HEAP32[i136 >> 2] = i90;
 HEAP32[i98 >> 2] = i23;
 i136 = i98 + 4 | 0;
 HEAP32[i136 >> 2] = i20;
 i136 = i98 + 8 | 0;
 HEAP32[i136 >> 2] = i15;
 i136 = i98 + 12 | 0;
 HEAP32[i136 >> 2] = i92;
 HEAP32[i99 >> 2] = i24;
 i136 = i99 + 4 | 0;
 HEAP32[i136 >> 2] = i22;
 i136 = i99 + 8 | 0;
 HEAP32[i136 >> 2] = i16;
 i136 = i99 + 12 | 0;
 HEAP32[i136 >> 2] = i94;
 i136 = i96 + 16 | 0;
 HEAP32[i136 >> 2] = i9;
 i136 = i96 + 20 | 0;
 HEAP32[i136 >> 2] = i5;
 i136 = i96 + 24 | 0;
 HEAP32[i136 >> 2] = i1;
 i136 = i96 + 28 | 0;
 HEAP32[i136 >> 2] = i89;
 i136 = i97 + 16 | 0;
 HEAP32[i136 >> 2] = i10;
 i136 = i97 + 20 | 0;
 HEAP32[i136 >> 2] = i6;
 i136 = i97 + 24 | 0;
 HEAP32[i136 >> 2] = i2;
 i136 = i97 + 28 | 0;
 HEAP32[i136 >> 2] = i91;
 i136 = i98 + 16 | 0;
 HEAP32[i136 >> 2] = i11;
 i136 = i98 + 20 | 0;
 HEAP32[i136 >> 2] = i7;
 i136 = i98 + 24 | 0;
 HEAP32[i136 >> 2] = i3;
 i136 = i98 + 28 | 0;
 HEAP32[i136 >> 2] = i93;
 i136 = i99 + 16 | 0;
 HEAP32[i136 >> 2] = i12;
 i136 = i99 + 20 | 0;
 HEAP32[i136 >> 2] = i8;
 i136 = i99 + 24 | 0;
 HEAP32[i136 >> 2] = i4;
 i136 = i99 + 28 | 0;
 HEAP32[i136 >> 2] = i95;
 STACKTOP = i100;
 return;
}

function __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i5 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i7 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
  i4 = i3;
 }
 i2 = i7 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 48 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 60 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i3 = i7 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i7 + 68 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 88 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 92 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 108 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 112 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 116 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 140 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 144 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 148 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 152 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 156 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 160 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 164 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 168 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 172 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 176 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 180 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 184 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 188 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 192 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 196 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 200 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 204 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 208 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 212 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 216 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 220 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 224 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 228 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 232 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 236 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 240 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 244 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 248 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 252 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 256 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 260 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 264 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 268 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 272 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 276 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 280 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 284 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 288 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 292 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 296 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 300 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 308 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 312 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 316 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 320 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 324 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 328 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 332 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 336 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 340 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 344 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 348 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 352 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 356 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 360 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 364 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 368 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 372 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 376 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 380 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 384 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 388 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 392 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 396 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 400 | 0;
 i2 = i3 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 404 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 408 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 412 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 416 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 420 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 424 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 428 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 432 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 436 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 440 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 444 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 448 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 452 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 456 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 460 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 464 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 468 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 472 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 476 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 480 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 484 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 488 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 492 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 496 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 500 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 504 | 0, i5);
 __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 636 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 768 | 0, i5);
 __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 992 | 0, i5);
 i1 = i7 + 1216 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1220 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1224 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1228 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1232 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1236 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1240 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1244 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1248 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1252 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1256 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1260 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1264 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1268 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1272 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1276 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1280 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1284 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1288 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1292 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1296 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1300 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1304 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1308 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1312 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1316 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 1320 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 1324 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 1328 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE(i181, i200, i198, i206, f27, i23, i204, i205, i203, i199, i202, i207, i1, i197, i173) {
 i181 = i181 | 0;
 i200 = i200 | 0;
 i198 = i198 | 0;
 i206 = i206 | 0;
 f27 = Math_fround(f27);
 i23 = i23 | 0;
 i204 = i204 | 0;
 i205 = i205 | 0;
 i203 = i203 | 0;
 i199 = i199 | 0;
 i202 = i202 | 0;
 i207 = i207 | 0;
 i1 = i1 | 0;
 i197 = i197 | 0;
 i173 = i173 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, f164 = f0, i165 = 0, f166 = f0, f167 = f0, f168 = f0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i201 = 0, i208 = 0, f209 = f0;
 i208 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i196 = i208 + 600 | 0;
 i19 = i208 + 336 | 0;
 i17 = i208 + 204 | 0;
 i18 = i208 + 192 | 0;
 i24 = i208 + 180 | 0;
 i175 = i208 + 348 | 0;
 i176 = i208 + 252 | 0;
 i187 = i208 + 216 | 0;
 i177 = i208 + 168 | 0;
 i178 = i208 + 156 | 0;
 i179 = i208 + 144 | 0;
 i172 = i208 + 132 | 0;
 i174 = i208 + 128 | 0;
 i194 = i208 + 112 | 0;
 i195 = i208 + 96 | 0;
 i188 = i208 + 80 | 0;
 i189 = i208 + 64 | 0;
 i190 = i208 + 48 | 0;
 i191 = i208 + 32 | 0;
 i192 = i208 + 16 | 0;
 i193 = i208;
 if (!i181) {
  i207 = 0;
  STACKTOP = i208;
  return i207 | 0;
 }
 i170 = HEAP16[i1 >> 1] | 0;
 i22 = (i170 & 128) != 0;
 i180 = i22 ^ 1;
 i171 = (i197 ^ 1) & i180;
 f5 = Math_fround(HEAPF32[i198 >> 2]);
 i182 = i198 + 12 | 0;
 f8 = Math_fround(HEAPF32[i182 >> 2]);
 f166 = Math_fround(f5 + f8);
 i183 = i198 + 4 | 0;
 f9 = Math_fround(HEAPF32[i183 >> 2]);
 i184 = i198 + 16 | 0;
 f6 = Math_fround(HEAPF32[i184 >> 2]);
 f167 = Math_fround(f9 + f6);
 i185 = i198 + 8 | 0;
 f7 = Math_fround(HEAPF32[i185 >> 2]);
 i186 = i198 + 20 | 0;
 f4 = Math_fround(HEAPF32[i186 >> 2]);
 f167 = Math_fround(f167 * Math_fround(.5));
 f168 = Math_fround(Math_fround(f7 + f4) * Math_fround(.5));
 HEAPF32[i196 >> 2] = Math_fround(f166 * Math_fround(.5));
 i25 = i196 + 4 | 0;
 HEAPF32[i25 >> 2] = f167;
 i26 = i196 + 8 | 0;
 HEAPF32[i26 >> 2] = f168;
 do if (!(i170 & 16)) {
  f168 = Math_fround(f6 - f9);
  f13 = Math_fround(f4 - f7);
  HEAPF32[i19 >> 2] = Math_fround(f8 - f5);
  HEAPF32[i19 + 4 >> 2] = f168;
  HEAPF32[i19 + 8 >> 2] = f13;
  f13 = Math_fround(HEAPF32[i198 + 24 >> 2]);
  f13 = Math_fround(f13 * f13);
  i20 = i206 + 4 | 0;
  i21 = i206 + 8 | 0;
  i3 = i17 + 4 | 0;
  i14 = i17 + 8 | 0;
  i15 = i18 + 4 | 0;
  i16 = i18 + 8 | 0;
  L6 : do if (i171) {
   i1 = 0;
   while (1) {
    i2 = i200 + (i1 * 36 | 0) | 0;
    f4 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 12 >> 2]);
    f9 = Math_fround(HEAPF32[i2 >> 2]);
    f4 = Math_fround(f4 - f9);
    f7 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 16 >> 2]);
    f11 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 4 >> 2]);
    f7 = Math_fround(f7 - f11);
    f8 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 20 >> 2]);
    f12 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 8 >> 2]);
    f8 = Math_fround(f8 - f12);
    f9 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 24 >> 2]) - f9);
    f11 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 28 >> 2]) - f11);
    f12 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 32 >> 2]) - f12);
    f10 = Math_fround(Math_fround(f7 * f12) - Math_fround(f8 * f11));
    f6 = Math_fround(Math_fround(f8 * f9) - Math_fround(f4 * f12));
    f5 = Math_fround(Math_fround(f4 * f11) - Math_fround(f7 * f9));
    f168 = Math_fround(f10 * Math_fround(HEAPF32[i206 >> 2]));
    f168 = Math_fround(f168 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
    if (!(Math_fround(f168 + Math_fround(f5 * Math_fround(HEAPF32[i21 >> 2]))) > Math_fround(0.0))) {
     HEAPF32[i17 >> 2] = f4;
     HEAPF32[i3 >> 2] = f7;
     HEAPF32[i14 >> 2] = f8;
     HEAPF32[i18 >> 2] = f9;
     HEAPF32[i15 >> 2] = f11;
     HEAPF32[i16 >> 2] = f12;
     if (Math_fround(__ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_(i198, i19, i2, i17, i18, 0, 0, 0)) <= f13) break L6;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i181 >>> 0) {
     i201 = 13;
     break;
    }
   }
  } else {
   i1 = 0;
   while (1) {
    i170 = i200 + (i1 * 36 | 0) | 0;
    f9 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 12 >> 2]);
    f7 = Math_fround(HEAPF32[i170 >> 2]);
    f9 = Math_fround(f9 - f7);
    f8 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 16 >> 2]);
    f5 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 4 >> 2]);
    f8 = Math_fround(f8 - f5);
    f6 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 20 >> 2]);
    f4 = Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 8 >> 2]);
    f6 = Math_fround(f6 - f4);
    f7 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 24 >> 2]) - f7);
    f5 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 28 >> 2]) - f5);
    f4 = Math_fround(Math_fround(HEAPF32[i200 + (i1 * 36 | 0) + 32 >> 2]) - f4);
    HEAPF32[i17 >> 2] = f9;
    HEAPF32[i3 >> 2] = f8;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i18 >> 2] = f7;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f4;
    if (Math_fround(__ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_(i198, i19, i170, i17, i18, 0, 0, 0)) <= f13) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i181 >>> 0) {
     i201 = 13;
     break L6;
    }
   }
   f10 = Math_fround(Math_fround(f8 * f4) - Math_fround(f6 * f5));
   f6 = Math_fround(Math_fround(f6 * f7) - Math_fround(f9 * f4));
   f5 = Math_fround(Math_fround(f9 * f5) - Math_fround(f8 * f7));
  } while (0);
  if ((i201 | 0) == 13) {
   f5 = Math_fround(HEAPF32[i198 >> 2]);
   f8 = Math_fround(HEAPF32[i182 >> 2]);
   f9 = Math_fround(HEAPF32[i183 >> 2]);
   f6 = Math_fround(HEAPF32[i184 >> 2]);
   f7 = Math_fround(HEAPF32[i185 >> 2]);
   f4 = Math_fround(HEAPF32[i186 >> 2]);
   break;
  }
  HEAP32[i202 >> 2] = i1;
  HEAPF32[i205 >> 2] = Math_fround(0.0);
  f167 = Math_fround(-Math_fround(HEAPF32[i206 >> 2]));
  f168 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
  f4 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
  HEAPF32[i203 >> 2] = f167;
  HEAPF32[i203 + 4 >> 2] = f168;
  HEAPF32[i203 + 8 >> 2] = f4;
  HEAP16[i204 >> 1] = 6;
  f4 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6)));
  if (f4 > Math_fround(0.0)) {
   f168 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
   f166 = Math_fround(f10 * f168);
   f167 = Math_fround(f6 * f168);
   f168 = Math_fround(f5 * f168);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = 0;
   i2 = 0;
   i3 = 0;
  }
  HEAP32[i207 >> 2] = i3;
  HEAP32[i207 + 4 >> 2] = i2;
  HEAP32[i207 + 8 >> 2] = i1;
  i207 = 1;
  STACKTOP = i208;
  return i207 | 0;
 } while (0);
 f168 = Math_fround(Math_fround(f5 - f8) * Math_fround(.5));
 f167 = Math_fround(Math_fround(f9 - f6) * Math_fround(.5));
 f166 = Math_fround(Math_fround(f7 - f4) * Math_fround(.5));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f168 * f168) + Math_fround(f167 * f167)) + Math_fround(f166 * f166))));
 if (f7 != Math_fround(0.0)) {
  f164 = Math_fround(Math_fround(1.0) / f7);
  f4 = Math_fround(f168 * f164);
  f52 = Math_fround(f167 * f164);
  f164 = Math_fround(f166 * f164);
  f6 = Math_fround(HEAPF32[i206 >> 2]);
  f4 = Math_fround(f4 * f6);
  i169 = i206 + 4 | 0;
  f5 = Math_fround(HEAPF32[i169 >> 2]);
  f52 = Math_fround(f4 + Math_fround(f52 * f5));
  i170 = i206 + 8 | 0;
  f4 = Math_fround(HEAPF32[i170 >> 2]);
  if (Math_fround(Math_abs(Math_fround(f52 + Math_fround(f164 * f4)))) < Math_fround(.999989986)) {
   HEAP32[i202 >> 2] = -1;
   if (!i23) i165 = 0; else i165 = HEAP32[i23 >> 2] | 0;
   f164 = Math_fround(HEAPF32[i198 + 24 >> 2]);
   f52 = Math_fround(Math_fround(HEAPF32[i196 >> 2]) * f6);
   f52 = Math_fround(f52 + Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f5));
   f52 = Math_fround(f52 + Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f4));
   i53 = (i173 | 0) == 0;
   i54 = i175 + 4 | 0;
   i55 = i175 + 8 | 0;
   i56 = i175 + 12 | 0;
   i57 = i175 + 16 | 0;
   i58 = i175 + 20 | 0;
   i59 = i175 + 24 | 0;
   i60 = i175 + 28 | 0;
   i61 = i175 + 32 | 0;
   i62 = i176 + 4 | 0;
   i63 = i176 + 8 | 0;
   i64 = i175 + 36 | 0;
   i65 = i175 + 40 | 0;
   i66 = i175 + 44 | 0;
   i67 = i175 + 48 | 0;
   i68 = i175 + 52 | 0;
   i69 = i175 + 56 | 0;
   i70 = i175 + 60 | 0;
   i71 = i175 + 64 | 0;
   i72 = i175 + 68 | 0;
   i73 = i176 + 12 | 0;
   i74 = i176 + 16 | 0;
   i75 = i176 + 20 | 0;
   i76 = i175 + 72 | 0;
   i77 = i175 + 76 | 0;
   i78 = i175 + 80 | 0;
   i79 = i175 + 84 | 0;
   i80 = i175 + 88 | 0;
   i81 = i175 + 92 | 0;
   i82 = i175 + 96 | 0;
   i83 = i175 + 100 | 0;
   i84 = i175 + 104 | 0;
   i85 = i176 + 24 | 0;
   i86 = i176 + 28 | 0;
   i87 = i176 + 32 | 0;
   i88 = i175 + 108 | 0;
   i89 = i175 + 112 | 0;
   i90 = i175 + 116 | 0;
   i91 = i175 + 120 | 0;
   i92 = i175 + 124 | 0;
   i93 = i175 + 128 | 0;
   i94 = i175 + 132 | 0;
   i95 = i175 + 136 | 0;
   i96 = i175 + 140 | 0;
   i97 = i176 + 36 | 0;
   i98 = i176 + 40 | 0;
   i99 = i176 + 44 | 0;
   i100 = i175 + 144 | 0;
   i101 = i175 + 148 | 0;
   i102 = i175 + 152 | 0;
   i103 = i175 + 156 | 0;
   i104 = i175 + 160 | 0;
   i105 = i175 + 164 | 0;
   i106 = i175 + 168 | 0;
   i107 = i175 + 172 | 0;
   i108 = i175 + 176 | 0;
   i109 = i176 + 48 | 0;
   i110 = i176 + 52 | 0;
   i111 = i176 + 56 | 0;
   i112 = i175 + 180 | 0;
   i113 = i175 + 184 | 0;
   i114 = i175 + 188 | 0;
   i115 = i175 + 192 | 0;
   i116 = i175 + 196 | 0;
   i117 = i175 + 200 | 0;
   i118 = i175 + 204 | 0;
   i119 = i175 + 208 | 0;
   i120 = i175 + 212 | 0;
   i121 = i176 + 60 | 0;
   i122 = i176 + 64 | 0;
   i123 = i176 + 68 | 0;
   i124 = i175 + 216 | 0;
   i125 = i175 + 220 | 0;
   i126 = i175 + 224 | 0;
   i127 = i175 + 228 | 0;
   i128 = i175 + 232 | 0;
   i129 = i175 + 236 | 0;
   i130 = i175 + 240 | 0;
   i131 = i175 + 244 | 0;
   i132 = i175 + 248 | 0;
   i133 = i176 + 72 | 0;
   i134 = i176 + 76 | 0;
   i135 = i176 + 80 | 0;
   i136 = i187 + 4 | 0;
   i137 = i187 + 8 | 0;
   i138 = i187 + 12 | 0;
   i139 = i187 + 16 | 0;
   i140 = i187 + 20 | 0;
   i141 = i187 + 24 | 0;
   i142 = i187 + 28 | 0;
   i143 = i187 + 32 | 0;
   i144 = i173 + 36 | 0;
   i145 = i173 + 40 | 0;
   i146 = i173 + 44 | 0;
   i147 = i173 + 4 | 0;
   i148 = i173 + 8 | 0;
   i149 = i173 + 12 | 0;
   i150 = i173 + 16 | 0;
   i151 = i173 + 20 | 0;
   i152 = i173 + 24 | 0;
   i153 = i173 + 28 | 0;
   i154 = i173 + 32 | 0;
   i155 = i177 + 4 | 0;
   i156 = i177 + 8 | 0;
   i157 = i178 + 4 | 0;
   i158 = i178 + 8 | 0;
   i159 = i179 + 4 | 0;
   i160 = i179 + 8 | 0;
   i161 = i172 + 4 | 0;
   i162 = i172 + 8 | 0;
   i163 = i173 + 48 | 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   f4 = f27;
   i51 = 0;
   f5 = Math_fround(2.0);
   do {
    i50 = (i51 | 0) == 0 ? i165 : (i51 | 0) == (i165 | 0) ? 0 : i51;
    i14 = i200 + (i50 * 36 | 0) + 12 | 0;
    f9 = Math_fround(HEAPF32[i14 >> 2]);
    i15 = i200 + (i50 * 36 | 0) | 0;
    f6 = Math_fround(HEAPF32[i15 >> 2]);
    f44 = Math_fround(f9 - f6);
    i16 = i200 + (i50 * 36 | 0) + 16 | 0;
    f10 = Math_fround(HEAPF32[i16 >> 2]);
    i17 = i200 + (i50 * 36 | 0) + 4 | 0;
    f7 = Math_fround(HEAPF32[i17 >> 2]);
    f46 = Math_fround(f10 - f7);
    i18 = i200 + (i50 * 36 | 0) + 20 | 0;
    f11 = Math_fround(HEAPF32[i18 >> 2]);
    i19 = i200 + (i50 * 36 | 0) + 8 | 0;
    f8 = Math_fround(HEAPF32[i19 >> 2]);
    f43 = Math_fround(f11 - f8);
    i20 = i200 + (i50 * 36 | 0) + 24 | 0;
    f12 = Math_fround(HEAPF32[i20 >> 2]);
    f47 = Math_fround(f12 - f6);
    i21 = i200 + (i50 * 36 | 0) + 28 | 0;
    f13 = Math_fround(HEAPF32[i21 >> 2]);
    f45 = Math_fround(f13 - f7);
    i22 = i200 + (i50 * 36 | 0) + 32 | 0;
    f27 = Math_fround(HEAPF32[i22 >> 2]);
    f48 = Math_fround(f27 - f8);
    f49 = Math_fround(Math_fround(f46 * f48) - Math_fround(f43 * f45));
    f48 = Math_fround(Math_fround(f43 * f47) - Math_fround(f44 * f48));
    f47 = Math_fround(Math_fround(f44 * f45) - Math_fround(f46 * f47));
    if (i171) {
     f46 = Math_fround(f49 * Math_fround(HEAPF32[i206 >> 2]));
     f46 = Math_fround(f46 + Math_fround(f48 * Math_fround(HEAPF32[i169 >> 2])));
     if (!(Math_fround(f46 + Math_fround(f47 * Math_fround(HEAPF32[i170 >> 2]))) > Math_fround(0.0))) i201 = 23;
    } else i201 = 23;
    L34 : do if ((i201 | 0) == 23) {
     i201 = 0;
     if (!i53) {
      f39 = Math_fround(HEAPF32[i144 >> 2]);
      f46 = Math_fround(f6 - f39);
      f41 = Math_fround(HEAPF32[i145 >> 2]);
      f33 = Math_fround(f7 - f41);
      f43 = Math_fround(HEAPF32[i146 >> 2]);
      f29 = Math_fround(f8 - f43);
      f40 = Math_fround(HEAPF32[i173 >> 2]);
      f31 = Math_fround(f46 * f40);
      f42 = Math_fround(HEAPF32[i147 >> 2]);
      f31 = Math_fround(f31 + Math_fround(f33 * f42));
      f44 = Math_fround(HEAPF32[i148 >> 2]);
      f31 = Math_fround(f31 + Math_fround(f29 * f44));
      f35 = Math_fround(HEAPF32[i149 >> 2]);
      f30 = Math_fround(f46 * f35);
      f36 = Math_fround(HEAPF32[i150 >> 2]);
      f30 = Math_fround(f30 + Math_fround(f33 * f36));
      f45 = Math_fround(HEAPF32[i151 >> 2]);
      f30 = Math_fround(f30 + Math_fround(f29 * f45));
      f37 = Math_fround(HEAPF32[i152 >> 2]);
      f46 = Math_fround(f46 * f37);
      f38 = Math_fround(HEAPF32[i153 >> 2]);
      f33 = Math_fround(f46 + Math_fround(f33 * f38));
      f46 = Math_fround(HEAPF32[i154 >> 2]);
      f29 = Math_fround(f33 + Math_fround(f29 * f46));
      HEAPF32[i177 >> 2] = f31;
      HEAPF32[i155 >> 2] = f30;
      HEAPF32[i156 >> 2] = f29;
      f29 = Math_fround(f9 - f39);
      f30 = Math_fround(f10 - f41);
      f31 = Math_fround(f11 - f43);
      f33 = Math_fround(Math_fround(Math_fround(f29 * f35) + Math_fround(f30 * f36)) + Math_fround(f31 * f45));
      f34 = Math_fround(Math_fround(Math_fround(f29 * f37) + Math_fround(f30 * f38)) + Math_fround(f31 * f46));
      HEAPF32[i178 >> 2] = Math_fround(Math_fround(Math_fround(f29 * f40) + Math_fround(f30 * f42)) + Math_fround(f31 * f44));
      HEAPF32[i157 >> 2] = f33;
      HEAPF32[i158 >> 2] = f34;
      f39 = Math_fround(f12 - f39);
      f41 = Math_fround(f13 - f41);
      f43 = Math_fround(f27 - f43);
      f45 = Math_fround(Math_fround(Math_fround(f39 * f35) + Math_fround(f41 * f36)) + Math_fround(f43 * f45));
      f46 = Math_fround(Math_fround(Math_fround(f39 * f37) + Math_fround(f41 * f38)) + Math_fround(f43 * f46));
      HEAPF32[i179 >> 2] = Math_fround(Math_fround(Math_fround(f39 * f40) + Math_fround(f41 * f42)) + Math_fround(f43 * f44));
      HEAPF32[i159 >> 2] = f45;
      HEAPF32[i160 >> 2] = f46;
      HEAPF32[i172 >> 2] = Math_fround(0.0);
      HEAPF32[i161 >> 2] = Math_fround(0.0);
      HEAPF32[i162 >> 2] = Math_fround(0.0);
      if (!(__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i172, i163, i177, i178, i179) | 0)) break;
      f6 = Math_fround(HEAPF32[i15 >> 2]);
      f7 = Math_fround(HEAPF32[i17 >> 2]);
      f8 = Math_fround(HEAPF32[i19 >> 2]);
      f9 = Math_fround(HEAPF32[i14 >> 2]);
      f10 = Math_fround(HEAPF32[i16 >> 2]);
      f11 = Math_fround(HEAPF32[i18 >> 2]);
      f12 = Math_fround(HEAPF32[i20 >> 2]);
      f13 = Math_fround(HEAPF32[i21 >> 2]);
      f27 = Math_fround(HEAPF32[i22 >> 2]);
     }
     f39 = Math_fround(f168 + f6);
     f40 = Math_fround(f167 + f7);
     f41 = Math_fround(f166 + f8);
     f33 = Math_fround(f168 + f9);
     f34 = Math_fround(f167 + f10);
     f35 = Math_fround(f166 + f11);
     f29 = Math_fround(f168 + f12);
     f30 = Math_fround(f167 + f13);
     f31 = Math_fround(f166 + f27);
     f46 = Math_fround(f6 - f168);
     f43 = Math_fround(f7 - f167);
     f42 = Math_fround(f8 - f166);
     f38 = Math_fround(f9 - f168);
     f37 = Math_fround(f10 - f167);
     f36 = Math_fround(f11 - f166);
     f28 = Math_fround(f12 - f168);
     f13 = Math_fround(f13 - f167);
     f12 = Math_fround(f27 - f166);
     if (!(Math_fround(Math_fround(f166 * f47) + Math_fround(Math_fround(f168 * f49) + Math_fround(f167 * f48))) >= Math_fround(0.0))) {
      HEAPF32[i175 >> 2] = f46;
      HEAPF32[i54 >> 2] = f43;
      HEAPF32[i55 >> 2] = f42;
      HEAPF32[i56 >> 2] = f38;
      HEAPF32[i57 >> 2] = f37;
      HEAPF32[i58 >> 2] = f36;
      HEAPF32[i59 >> 2] = f28;
      HEAPF32[i60 >> 2] = f13;
      HEAPF32[i61 >> 2] = f12;
      f7 = Math_fround(f38 - f46);
      f27 = Math_fround(f37 - f43);
      f45 = Math_fround(f36 - f42);
      f11 = Math_fround(f28 - f46);
      f8 = Math_fround(f13 - f43);
      f44 = Math_fround(f12 - f42);
      f6 = Math_fround(Math_fround(f7 * f8) - Math_fround(f27 * f11));
      f7 = Math_fround(Math_fround(f45 * f11) - Math_fround(f7 * f44));
      f8 = Math_fround(Math_fround(f27 * f44) - Math_fround(f45 * f8));
     } else {
      HEAPF32[i175 >> 2] = f39;
      HEAPF32[i54 >> 2] = f40;
      HEAPF32[i55 >> 2] = f41;
      HEAPF32[i56 >> 2] = f33;
      HEAPF32[i57 >> 2] = f34;
      HEAPF32[i58 >> 2] = f35;
      HEAPF32[i59 >> 2] = f29;
      HEAPF32[i60 >> 2] = f30;
      HEAPF32[i61 >> 2] = f31;
      f7 = Math_fround(f33 - f39);
      f27 = Math_fround(f34 - f40);
      f45 = Math_fround(f35 - f41);
      f11 = Math_fround(f29 - f39);
      f8 = Math_fround(f30 - f40);
      f44 = Math_fround(f31 - f41);
      f6 = Math_fround(Math_fround(f7 * f8) - Math_fround(f27 * f11));
      f7 = Math_fround(Math_fround(f45 * f11) - Math_fround(f7 * f44));
      f8 = Math_fround(Math_fround(f27 * f44) - Math_fround(f45 * f8));
     }
     HEAPF32[i176 >> 2] = f8;
     HEAPF32[i62 >> 2] = f7;
     HEAPF32[i63 >> 2] = f6;
     HEAPF32[i64 >> 2] = f38;
     HEAPF32[i65 >> 2] = f37;
     HEAPF32[i66 >> 2] = f36;
     HEAPF32[i67 >> 2] = f33;
     HEAPF32[i68 >> 2] = f34;
     HEAPF32[i69 >> 2] = f35;
     HEAPF32[i70 >> 2] = f29;
     HEAPF32[i71 >> 2] = f30;
     HEAPF32[i72 >> 2] = f31;
     f27 = Math_fround(f33 - f38);
     f7 = Math_fround(f34 - f37);
     f8 = Math_fround(f35 - f36);
     f10 = Math_fround(f29 - f38);
     f11 = Math_fround(f30 - f37);
     f9 = Math_fround(f31 - f36);
     f6 = Math_fround(Math_fround(f7 * f9) - Math_fround(f8 * f11));
     f8 = Math_fround(Math_fround(f8 * f10) - Math_fround(f27 * f9));
     f7 = Math_fround(Math_fround(f27 * f11) - Math_fround(f7 * f10));
     f27 = Math_fround(HEAPF32[i206 >> 2]);
     f209 = Math_fround(f27 * f6);
     f44 = Math_fround(HEAPF32[i169 >> 2]);
     f209 = Math_fround(f209 + Math_fround(f44 * f8));
     f45 = Math_fround(HEAPF32[i170 >> 2]);
     if (Math_fround(Math_fround(f7 * f45) + f209) > Math_fround(0.0)) {
      HEAPF32[i67 >> 2] = f29;
      HEAPF32[i68 >> 2] = f30;
      HEAPF32[i69 >> 2] = f31;
      HEAPF32[i70 >> 2] = f33;
      HEAPF32[i71 >> 2] = f34;
      HEAPF32[i72 >> 2] = f35;
      f7 = Math_fround(-f7);
      f8 = Math_fround(-f8);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i73 >> 2] = f6;
     HEAPF32[i74 >> 2] = f8;
     HEAPF32[i75 >> 2] = f7;
     HEAPF32[i76 >> 2] = f38;
     HEAPF32[i77 >> 2] = f37;
     HEAPF32[i78 >> 2] = f36;
     HEAPF32[i79 >> 2] = f29;
     HEAPF32[i80 >> 2] = f30;
     HEAPF32[i81 >> 2] = f31;
     HEAPF32[i82 >> 2] = f28;
     HEAPF32[i83 >> 2] = f13;
     HEAPF32[i84 >> 2] = f12;
     f7 = Math_fround(f28 - f38);
     f209 = Math_fround(f13 - f37);
     f8 = Math_fround(f12 - f36);
     f6 = Math_fround(Math_fround(f11 * f8) - Math_fround(f9 * f209));
     f8 = Math_fround(Math_fround(f9 * f7) - Math_fround(f10 * f8));
     f7 = Math_fround(Math_fround(f10 * f209) - Math_fround(f11 * f7));
     if (Math_fround(Math_fround(f7 * f45) + Math_fround(Math_fround(f27 * f6) + Math_fround(f44 * f8))) > Math_fround(0.0)) {
      HEAPF32[i79 >> 2] = f28;
      HEAPF32[i80 >> 2] = f13;
      HEAPF32[i81 >> 2] = f12;
      HEAPF32[i82 >> 2] = f29;
      HEAPF32[i83 >> 2] = f30;
      HEAPF32[i84 >> 2] = f31;
      f7 = Math_fround(-f7);
      f8 = Math_fround(-f8);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i85 >> 2] = f6;
     HEAPF32[i86 >> 2] = f8;
     HEAPF32[i87 >> 2] = f7;
     HEAPF32[i88 >> 2] = f46;
     HEAPF32[i89 >> 2] = f43;
     HEAPF32[i90 >> 2] = f42;
     HEAPF32[i91 >> 2] = f28;
     HEAPF32[i92 >> 2] = f13;
     HEAPF32[i93 >> 2] = f12;
     HEAPF32[i94 >> 2] = f29;
     HEAPF32[i95 >> 2] = f30;
     HEAPF32[i96 >> 2] = f31;
     f209 = Math_fround(f28 - f46);
     f8 = Math_fround(f13 - f43);
     f7 = Math_fround(f12 - f42);
     f10 = Math_fround(f29 - f46);
     f11 = Math_fround(f30 - f43);
     f9 = Math_fround(f31 - f42);
     f6 = Math_fround(Math_fround(f8 * f9) - Math_fround(f7 * f11));
     f7 = Math_fround(Math_fround(f7 * f10) - Math_fround(f209 * f9));
     f8 = Math_fround(Math_fround(f209 * f11) - Math_fround(f8 * f10));
     if (Math_fround(Math_fround(f8 * f45) + Math_fround(Math_fround(f27 * f6) + Math_fround(f44 * f7))) > Math_fround(0.0)) {
      HEAPF32[i91 >> 2] = f29;
      HEAPF32[i92 >> 2] = f30;
      HEAPF32[i93 >> 2] = f31;
      HEAPF32[i94 >> 2] = f28;
      HEAPF32[i95 >> 2] = f13;
      HEAPF32[i96 >> 2] = f12;
      f8 = Math_fround(-f8);
      f7 = Math_fround(-f7);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i97 >> 2] = f6;
     HEAPF32[i98 >> 2] = f7;
     HEAPF32[i99 >> 2] = f8;
     HEAPF32[i100 >> 2] = f46;
     HEAPF32[i101 >> 2] = f43;
     HEAPF32[i102 >> 2] = f42;
     HEAPF32[i103 >> 2] = f29;
     HEAPF32[i104 >> 2] = f30;
     HEAPF32[i105 >> 2] = f31;
     HEAPF32[i106 >> 2] = f39;
     HEAPF32[i107 >> 2] = f40;
     HEAPF32[i108 >> 2] = f41;
     f8 = Math_fround(f39 - f46);
     f209 = Math_fround(f40 - f43);
     f7 = Math_fround(f41 - f42);
     f6 = Math_fround(Math_fround(f11 * f7) - Math_fround(f9 * f209));
     f7 = Math_fround(Math_fround(f9 * f8) - Math_fround(f10 * f7));
     f8 = Math_fround(Math_fround(f10 * f209) - Math_fround(f11 * f8));
     if (Math_fround(Math_fround(f8 * f45) + Math_fround(Math_fround(f27 * f6) + Math_fround(f44 * f7))) > Math_fround(0.0)) {
      HEAPF32[i103 >> 2] = f39;
      HEAPF32[i104 >> 2] = f40;
      HEAPF32[i105 >> 2] = f41;
      HEAPF32[i106 >> 2] = f29;
      HEAPF32[i107 >> 2] = f30;
      HEAPF32[i108 >> 2] = f31;
      f8 = Math_fround(-f8);
      f7 = Math_fround(-f7);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i109 >> 2] = f6;
     HEAPF32[i110 >> 2] = f7;
     HEAPF32[i111 >> 2] = f8;
     HEAPF32[i112 >> 2] = f39;
     HEAPF32[i113 >> 2] = f40;
     HEAPF32[i114 >> 2] = f41;
     HEAPF32[i115 >> 2] = f33;
     HEAPF32[i116 >> 2] = f34;
     HEAPF32[i117 >> 2] = f35;
     HEAPF32[i118 >> 2] = f38;
     HEAPF32[i119 >> 2] = f37;
     HEAPF32[i120 >> 2] = f36;
     f209 = Math_fround(f33 - f39);
     f8 = Math_fround(f34 - f40);
     f7 = Math_fround(f35 - f41);
     f10 = Math_fround(f38 - f39);
     f11 = Math_fround(f37 - f40);
     f9 = Math_fround(f36 - f41);
     f6 = Math_fround(Math_fround(f8 * f9) - Math_fround(f7 * f11));
     f7 = Math_fround(Math_fround(f7 * f10) - Math_fround(f209 * f9));
     f8 = Math_fround(Math_fround(f209 * f11) - Math_fround(f8 * f10));
     if (Math_fround(Math_fround(f8 * f45) + Math_fround(Math_fround(f27 * f6) + Math_fround(f44 * f7))) > Math_fround(0.0)) {
      HEAPF32[i115 >> 2] = f38;
      HEAPF32[i116 >> 2] = f37;
      HEAPF32[i117 >> 2] = f36;
      HEAPF32[i118 >> 2] = f33;
      HEAPF32[i119 >> 2] = f34;
      HEAPF32[i120 >> 2] = f35;
      f8 = Math_fround(-f8);
      f7 = Math_fround(-f7);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i121 >> 2] = f6;
     HEAPF32[i122 >> 2] = f7;
     HEAPF32[i123 >> 2] = f8;
     HEAPF32[i124 >> 2] = f39;
     HEAPF32[i125 >> 2] = f40;
     HEAPF32[i126 >> 2] = f41;
     HEAPF32[i127 >> 2] = f38;
     HEAPF32[i128 >> 2] = f37;
     HEAPF32[i129 >> 2] = f36;
     HEAPF32[i130 >> 2] = f46;
     HEAPF32[i131 >> 2] = f43;
     HEAPF32[i132 >> 2] = f42;
     f8 = Math_fround(f46 - f39);
     f209 = Math_fround(f43 - f40);
     f7 = Math_fround(f42 - f41);
     f6 = Math_fround(Math_fround(f11 * f7) - Math_fround(f9 * f209));
     f7 = Math_fround(Math_fround(f9 * f8) - Math_fround(f10 * f7));
     f8 = Math_fround(Math_fround(f10 * f209) - Math_fround(f11 * f8));
     if (Math_fround(Math_fround(f8 * f45) + Math_fround(Math_fround(f27 * f6) + Math_fround(f44 * f7))) > Math_fround(0.0)) {
      HEAPF32[i127 >> 2] = f46;
      HEAPF32[i128 >> 2] = f43;
      HEAPF32[i129 >> 2] = f42;
      HEAPF32[i130 >> 2] = f38;
      HEAPF32[i131 >> 2] = f37;
      HEAPF32[i132 >> 2] = f36;
      f8 = Math_fround(-f8);
      f7 = Math_fround(-f7);
      f6 = Math_fround(-f6);
     }
     HEAPF32[i133 >> 2] = f6;
     HEAPF32[i134 >> 2] = f7;
     HEAPF32[i135 >> 2] = f8;
     f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f47 * f47) + Math_fround(Math_fround(f49 * f49) + Math_fround(f48 * f48)))));
     if (f6 > Math_fround(0.0)) {
      f6 = Math_fround(Math_fround(1.0) / f6);
      f8 = Math_fround(f47 * f6);
      f7 = Math_fround(f48 * f6);
      f6 = Math_fround(f49 * f6);
     } else {
      f8 = f47;
      f7 = f48;
      f6 = f49;
     }
     i25 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
     i26 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
     i32 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     f10 = Math_fround(-Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f6 * f27) + Math_fround(f7 * f44)) + Math_fround(f8 * f45)))));
     if (i171) i24 = 0; else {
      i24 = 0;
      while (1) {
       i17 = i175 + (i24 * 36 | 0) | 0;
       i16 = i176 + (i24 * 12 | 0) | 0;
       do if (__ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE(i196, i206, f4, f164, i17) | 0) {
        f6 = Math_fround(HEAPF32[i17 >> 2]);
        f49 = Math_fround(HEAPF32[i206 >> 2]);
        f6 = Math_fround(f6 * f49);
        i18 = i175 + (i24 * 36 | 0) + 4 | 0;
        f7 = Math_fround(HEAPF32[i18 >> 2]);
        f209 = Math_fround(HEAPF32[i169 >> 2]);
        f7 = Math_fround(f6 + Math_fround(f7 * f209));
        i19 = i175 + (i24 * 36 | 0) + 8 | 0;
        f6 = Math_fround(HEAPF32[i19 >> 2]);
        f8 = Math_fround(HEAPF32[i170 >> 2]);
        f6 = Math_fround(f7 + Math_fround(f6 * f8));
        f7 = Math_fround(f49 * Math_fround(HEAPF32[i175 + (i24 * 36 | 0) + 12 >> 2]));
        i20 = i175 + (i24 * 36 | 0) + 16 | 0;
        f7 = Math_fround(f7 + Math_fround(f209 * Math_fround(HEAPF32[i20 >> 2])));
        i21 = i175 + (i24 * 36 | 0) + 20 | 0;
        f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
        f49 = Math_fround(f49 * Math_fround(HEAPF32[i175 + (i24 * 36 | 0) + 24 >> 2]));
        i22 = i175 + (i24 * 36 | 0) + 28 | 0;
        f209 = Math_fround(f49 + Math_fround(f209 * Math_fround(HEAPF32[i22 >> 2])));
        i23 = i175 + (i24 * 36 | 0) + 32 | 0;
        f8 = Math_fround(f209 + Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2])));
        f209 = f6 < f7 ? f6 : f7;
        if ((f209 < f8 ? f209 : f8) > Math_fround(Math_fround(f164 + Math_fround(f52 + f4)) + Math_fround(.00999999977))) break;
        if (f6 < f52 & f7 < f52 & f8 < f52) break;
        f6 = Math_fround(HEAPF32[i16 >> 2]);
        f9 = Math_fround(f6 * f6);
        i14 = i176 + (i24 * 12 | 0) + 4 | 0;
        f7 = Math_fround(HEAPF32[i14 >> 2]);
        f9 = Math_fround(f9 + Math_fround(f7 * f7));
        i15 = i176 + (i24 * 12 | 0) + 8 | 0;
        f8 = Math_fround(HEAPF32[i15 >> 2]);
        f9 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f8 * f8))));
        if (f9 == Math_fround(0.0)) break;
        f209 = Math_fround(Math_fround(1.0) / f9);
        HEAPF32[i16 >> 2] = Math_fround(f6 * f209);
        HEAPF32[i14 >> 2] = Math_fround(f209 * f7);
        HEAPF32[i15 >> 2] = Math_fround(f209 * f8);
        if (!(__ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf(i17, i16, i196, f164, i206, i174) | 0)) break;
        f7 = Math_fround(HEAPF32[i174 >> 2]);
        f6 = f7 > f4 ? f7 : f4;
        i16 = f6 < Math_fround(1.0);
        f6 = Math_fround(f6 * Math_fround(.00100000005));
        f6 = i16 ? Math_fround(.00100000005) : f6;
        if (!(Math_fround(f4 - f6) > f7)) if (!(f5 > f10 & Math_fround(f4 + f6) > f7)) break;
        HEAP32[i202 >> 2] = i50;
        HEAP32[i187 >> 2] = HEAP32[i17 >> 2];
        HEAP32[i136 >> 2] = HEAP32[i18 >> 2];
        HEAP32[i137 >> 2] = HEAP32[i19 >> 2];
        HEAP32[i138 >> 2] = HEAP32[i175 + (i24 * 36 | 0) + 12 >> 2];
        HEAP32[i139 >> 2] = HEAP32[i20 >> 2];
        HEAP32[i140 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i141 >> 2] = HEAP32[i175 + (i24 * 36 | 0) + 24 >> 2];
        HEAP32[i142 >> 2] = HEAP32[i22 >> 2];
        HEAP32[i143 >> 2] = HEAP32[i23 >> 2];
        i3 = i32;
        i2 = i26;
        i1 = i25;
        f4 = f7;
        f5 = f10;
       } while (0);
       i24 = i24 + 1 | 0;
       if ((i24 | 0) == 7) break L34;
      }
     }
     do {
      i17 = i175 + (i24 * 36 | 0) | 0;
      i16 = i176 + (i24 * 12 | 0) | 0;
      f209 = Math_fround(HEAPF32[i16 >> 2]);
      f209 = Math_fround(f209 * Math_fround(HEAPF32[i206 >> 2]));
      f49 = Math_fround(HEAPF32[i176 + (i24 * 12 | 0) + 4 >> 2]);
      f49 = Math_fround(f209 + Math_fround(f49 * Math_fround(HEAPF32[i169 >> 2])));
      f209 = Math_fround(HEAPF32[i176 + (i24 * 12 | 0) + 8 >> 2]);
      do if (!(Math_fround(f49 + Math_fround(f209 * Math_fround(HEAPF32[i170 >> 2]))) > Math_fround(0.0))) {
       if (!(__ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE(i196, i206, f4, f164, i17) | 0)) break;
       f6 = Math_fround(HEAPF32[i17 >> 2]);
       f49 = Math_fround(HEAPF32[i206 >> 2]);
       f6 = Math_fround(f6 * f49);
       i18 = i175 + (i24 * 36 | 0) + 4 | 0;
       f7 = Math_fround(HEAPF32[i18 >> 2]);
       f209 = Math_fround(HEAPF32[i169 >> 2]);
       f7 = Math_fround(f6 + Math_fround(f7 * f209));
       i19 = i175 + (i24 * 36 | 0) + 8 | 0;
       f6 = Math_fround(HEAPF32[i19 >> 2]);
       f8 = Math_fround(HEAPF32[i170 >> 2]);
       f6 = Math_fround(f7 + Math_fround(f6 * f8));
       f7 = Math_fround(f49 * Math_fround(HEAPF32[i175 + (i24 * 36 | 0) + 12 >> 2]));
       i20 = i175 + (i24 * 36 | 0) + 16 | 0;
       f7 = Math_fround(f7 + Math_fround(f209 * Math_fround(HEAPF32[i20 >> 2])));
       i21 = i175 + (i24 * 36 | 0) + 20 | 0;
       f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
       f49 = Math_fround(f49 * Math_fround(HEAPF32[i175 + (i24 * 36 | 0) + 24 >> 2]));
       i22 = i175 + (i24 * 36 | 0) + 28 | 0;
       f209 = Math_fround(f49 + Math_fround(f209 * Math_fround(HEAPF32[i22 >> 2])));
       i23 = i175 + (i24 * 36 | 0) + 32 | 0;
       f8 = Math_fround(f209 + Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2])));
       f209 = f6 < f7 ? f6 : f7;
       if ((f209 < f8 ? f209 : f8) > Math_fround(Math_fround(f164 + Math_fround(f52 + f4)) + Math_fround(.00999999977))) break;
       if (f6 < f52 & f7 < f52 & f8 < f52) break;
       f6 = Math_fround(HEAPF32[i16 >> 2]);
       f9 = Math_fround(f6 * f6);
       i14 = i176 + (i24 * 12 | 0) + 4 | 0;
       f7 = Math_fround(HEAPF32[i14 >> 2]);
       f9 = Math_fround(f9 + Math_fround(f7 * f7));
       i15 = i176 + (i24 * 12 | 0) + 8 | 0;
       f8 = Math_fround(HEAPF32[i15 >> 2]);
       f9 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f8 * f8))));
       if (f9 == Math_fround(0.0)) break;
       f209 = Math_fround(Math_fround(1.0) / f9);
       HEAPF32[i16 >> 2] = Math_fround(f6 * f209);
       HEAPF32[i14 >> 2] = Math_fround(f209 * f7);
       HEAPF32[i15 >> 2] = Math_fround(f209 * f8);
       if (!(__ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf(i17, i16, i196, f164, i206, i174) | 0)) break;
       f7 = Math_fround(HEAPF32[i174 >> 2]);
       f6 = f7 > f4 ? f7 : f4;
       i16 = f6 < Math_fround(1.0);
       f6 = Math_fround(f6 * Math_fround(.00100000005));
       f6 = i16 ? Math_fround(.00100000005) : f6;
       if (!(Math_fround(f4 - f6) > f7)) if (!(f5 > f10 & Math_fround(f4 + f6) > f7)) break;
       HEAP32[i202 >> 2] = i50;
       HEAP32[i187 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i136 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i137 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i138 >> 2] = HEAP32[i175 + (i24 * 36 | 0) + 12 >> 2];
       HEAP32[i139 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i140 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i141 >> 2] = HEAP32[i175 + (i24 * 36 | 0) + 24 >> 2];
       HEAP32[i142 >> 2] = HEAP32[i22 >> 2];
       HEAP32[i143 >> 2] = HEAP32[i23 >> 2];
       i3 = i32;
       i2 = i26;
       i1 = i25;
       f4 = f7;
       f5 = f10;
      } while (0);
      i24 = i24 + 1 | 0;
     } while ((i24 | 0) != 7);
    } while (0);
    i51 = i51 + 1 | 0;
   } while ((i51 | 0) != (i181 | 0));
   if ((HEAP32[i202 >> 2] | 0) == -1) i1 = 0; else {
    HEAPF32[i205 >> 2] = f4;
    __ZN5physx2Gu26computeSphereTriImpactDataERNS_6PxVec3ES2_RKS1_S4_fRKNS_10PxTriangleE(i199, i203, i196, i206, f4, i187);
    if (!(i197 | i180)) {
     f209 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f209 = Math_fround(f209 * Math_fround(HEAPF32[i206 >> 2]));
     f168 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f168 = Math_fround(f209 + Math_fround(f168 * Math_fround(HEAPF32[i169 >> 2])));
     f209 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (Math_fround(f168 + Math_fround(f209 * Math_fround(HEAPF32[i170 >> 2]))) > Math_fround(0.0)) {
      f167 = Math_fround(-Math_fround(HEAPF32[i203 >> 2]));
      i197 = i203 + 4 | 0;
      f168 = Math_fround(-Math_fround(HEAPF32[i197 >> 2]));
      i201 = i203 + 8 | 0;
      f209 = Math_fround(-Math_fround(HEAPF32[i201 >> 2]));
      HEAPF32[i203 >> 2] = f167;
      HEAPF32[i197 >> 2] = f168;
      HEAPF32[i201 >> 2] = f209;
     }
    }
    HEAP32[i207 >> 2] = i1;
    HEAP32[i207 + 4 >> 2] = i2;
    HEAP32[i207 + 8 >> 2] = i3;
    i1 = HEAP32[i202 >> 2] | 0;
    if ((i1 | 0) == -1) i1 = 1; else {
     f166 = Math_fround(HEAPF32[i205 >> 2]);
     f167 = Math_fround(HEAPF32[i206 >> 2]);
     f52 = Math_fround(f166 * f167);
     f168 = Math_fround(HEAPF32[i169 >> 2]);
     f164 = Math_fround(f166 * f168);
     f209 = Math_fround(HEAPF32[i170 >> 2]);
     f166 = Math_fround(f166 * f209);
     f52 = Math_fround(f52 + Math_fround(HEAPF32[i198 >> 2]));
     f164 = Math_fround(f164 + Math_fround(HEAPF32[i183 >> 2]));
     f166 = Math_fround(f166 + Math_fround(HEAPF32[i185 >> 2]));
     HEAPF32[i188 >> 2] = f52;
     HEAPF32[i188 + 4 >> 2] = f164;
     HEAPF32[i188 + 8 >> 2] = f166;
     HEAPF32[i188 + 12 >> 2] = Math_fround(0.0);
     f167 = Math_fround(f4 * f167);
     f168 = Math_fround(f4 * f168);
     f209 = Math_fround(f4 * f209);
     f167 = Math_fround(f167 + Math_fround(HEAPF32[i182 >> 2]));
     f168 = Math_fround(f168 + Math_fround(HEAPF32[i184 >> 2]));
     f209 = Math_fround(f209 + Math_fround(HEAPF32[i186 >> 2]));
     HEAPF32[i189 >> 2] = f167;
     HEAPF32[i189 + 4 >> 2] = f168;
     HEAPF32[i189 + 8 >> 2] = f209;
     HEAPF32[i189 + 12 >> 2] = Math_fround(0.0);
     i206 = HEAP32[i200 + (i1 * 36 | 0) + 4 >> 2] | 0;
     i207 = HEAP32[i200 + (i1 * 36 | 0) + 8 >> 2] | 0;
     HEAP32[i190 >> 2] = HEAP32[i200 + (i1 * 36 | 0) >> 2];
     HEAP32[i190 + 4 >> 2] = i206;
     HEAP32[i190 + 8 >> 2] = i207;
     HEAPF32[i190 + 12 >> 2] = Math_fround(0.0);
     i207 = HEAP32[i200 + (i1 * 36 | 0) + 16 >> 2] | 0;
     i206 = HEAP32[i200 + (i1 * 36 | 0) + 20 >> 2] | 0;
     HEAP32[i191 >> 2] = HEAP32[i200 + (i1 * 36 | 0) + 12 >> 2];
     HEAP32[i191 + 4 >> 2] = i207;
     HEAP32[i191 + 8 >> 2] = i206;
     HEAPF32[i191 + 12 >> 2] = Math_fround(0.0);
     i206 = HEAP32[i200 + (i1 * 36 | 0) + 28 >> 2] | 0;
     i207 = HEAP32[i200 + (i1 * 36 | 0) + 32 >> 2] | 0;
     HEAP32[i192 >> 2] = HEAP32[i200 + (i1 * 36 | 0) + 24 >> 2];
     HEAP32[i192 + 4 >> 2] = i206;
     HEAP32[i192 + 8 >> 2] = i207;
     HEAPF32[i192 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_(i193, i188, i189, i190, i191, i192, i194, i195);
     i207 = HEAP32[i195 + 4 >> 2] | 0;
     i1 = HEAP32[i195 + 8 >> 2] | 0;
     HEAP32[i199 >> 2] = HEAP32[i195 >> 2];
     HEAP32[i199 + 4 >> 2] = i207;
     HEAP32[i199 + 8 >> 2] = i1;
     HEAP16[i204 >> 1] = 7;
     i1 = 1;
    }
   }
   i207 = i1;
   STACKTOP = i208;
   return i207 | 0;
  }
 } else {
  f6 = Math_fround(HEAPF32[i206 >> 2]);
  f5 = Math_fround(HEAPF32[i206 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i206 + 8 >> 2]);
 }
 f167 = Math_fround(f7 * f6);
 f168 = Math_fround(f7 * f5);
 f209 = Math_fround(f7 * f4);
 f167 = Math_fround(f167 + Math_fround(HEAPF32[i196 >> 2]));
 f168 = Math_fround(f168 + Math_fround(HEAPF32[i25 >> 2]));
 f209 = Math_fround(f209 + Math_fround(HEAPF32[i26 >> 2]));
 HEAPF32[i24 >> 2] = f167;
 HEAPF32[i24 + 4 >> 2] = f168;
 HEAPF32[i24 + 8 >> 2] = f209;
 i207 = __ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb(i181, i200, i24, Math_fround(HEAPF32[i198 + 24 >> 2]), i206, f27, i23, i199, i203, i205, i202, i204, i207, i197, i22) | 0;
 STACKTOP = i208;
 return i207 | 0;
}

function __Z14DecodeBC7BlockP9HDRColorAPKh(i29, i24) {
 i29 = i29 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i33 + 56 | 0;
 i30 = i33 + 32 | 0;
 i31 = i33 + 16 | 0;
 i32 = i33;
 i1 = 0;
 while (1) {
  i28 = i1 >>> 3;
  i2 = i1 + 1 | 0;
  if (i2 >>> 0 < 128 ? (1 << i1 - (i28 << 3) & (HEAPU8[i24 + i28 >> 0] | 0) | 0) == 0 : 0) i1 = i2; else break;
 }
 i11 = i1 & 255;
 if (i11 >>> 0 >= 8) {
  _memset(i29 | 0, 0, 256) | 0;
  STACKTOP = i33;
  return;
 }
 i26 = HEAPU8[gb + 1545909 + (i11 * 15 | 0) >> 0] | 0;
 i7 = (i26 << 1) + 2 | 0;
 i27 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 5 >> 0] | 0;
 i28 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 6 >> 0] | 0;
 i4 = i11 + 1 | 0;
 i25 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 1 >> 0] | 0;
 i5 = i25 & 255;
 if (!(i25 << 24 >> 24)) {
  i1 = 0;
  i5 = i4;
 } else {
  i1 = i4 >>> 3;
  i2 = i4 - (i1 << 3) | 0;
  i3 = HEAP8[i24 + i1 >> 0] | 0;
  if ((i5 + i2 | 0) >>> 0 > 8) {
   i25 = 8 - i2 | 0;
   i1 = ((HEAPU8[i24 + (i1 + 1) >> 0] | 0) & (1 << i5 - i25) + -1) << i25 | (i3 & 255) >>> i2;
  } else i1 = (i3 & 255) >>> i2 & (1 << i5) + 255;
  i5 = i5 + i4 | 0;
 }
 i25 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 3 >> 0] | 0;
 i6 = i25 & 255;
 if (!(i25 << 24 >> 24)) i25 = 0; else {
  i2 = i5 >>> 3;
  i3 = i5 - (i2 << 3) | 0;
  i4 = HEAP8[i24 + i2 >> 0] | 0;
  if ((i3 + i6 | 0) >>> 0 > 8) {
   i25 = 8 - i3 | 0;
   i2 = ((HEAPU8[i24 + (i2 + 1) >> 0] | 0) & (1 << i6 - i25) + -1) << i25 | (i4 & 255) >>> i3;
  } else i2 = (i4 & 255) >>> i3 & (1 << i6) + 255;
  i25 = i2 & 255;
  i5 = i6 + i5 | 0;
 }
 i23 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 4 >> 0] | 0;
 i6 = i23 & 255;
 if (!(i23 << 24 >> 24)) {
  i23 = 0;
  i2 = i5;
 } else {
  i2 = i5 >>> 3;
  i3 = i5 - (i2 << 3) | 0;
  i4 = HEAP8[i24 + i2 >> 0] | 0;
  if ((i3 + i6 | 0) >>> 0 > 8) {
   i23 = 8 - i3 | 0;
   i2 = ((HEAPU8[i24 + (i2 + 1) >> 0] | 0) & (1 << i6 - i23) + -1) << i23 | (i4 & 255) >>> i3;
  } else i2 = (i4 & 255) >>> i3 & (1 << i6) + 255;
  i23 = i2 & 255;
  i2 = i6 + i5 | 0;
 }
 i15 = gb + 1545909 + (i11 * 15 | 0) + 7 | 0;
 i9 = HEAP8[i15 >> 0] | 0;
 i10 = HEAP8[i15 + 1 >> 0] | 0;
 i14 = HEAP8[i15 + 2 >> 0] | 0;
 i15 = HEAP8[i15 + 3 >> 0] | 0;
 i20 = gb + 1545909 + (i11 * 15 | 0) + 11 | 0;
 i17 = HEAP8[i20 >> 0] | 0;
 i18 = HEAP8[i20 + 1 >> 0] | 0;
 i19 = HEAP8[i20 + 2 >> 0] | 0;
 i20 = HEAP8[i20 + 3 >> 0] | 0;
 i21 = i7 & 254;
 i16 = (i21 | 0) == 0;
 L29 : do if (i16) i13 = 57; else {
  i7 = i9 & 255;
  i8 = (1 << i7) + 255 | 0;
  L31 : do if (!(i9 << 24 >> 24)) {
   i4 = (i2 + i7 | 0) >>> 0 > 128;
   i3 = 0;
   do {
    if (i4) {
     i13 = 30;
     break L31;
    }
    HEAP8[i30 + (i3 << 2) >> 0] = 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i21 >>> 0);
  } else {
   i6 = 0;
   i3 = i2;
   while (1) {
    i2 = i3 + i7 | 0;
    if (i2 >>> 0 > 128) {
     i13 = 30;
     break L31;
    }
    i5 = i3 >>> 3;
    i3 = i3 - (i5 << 3) | 0;
    i4 = HEAP8[i24 + i5 >> 0] | 0;
    if ((i3 + i7 | 0) >>> 0 > 8) {
     i12 = 8 - i3 | 0;
     i3 = ((HEAPU8[i24 + (i5 + 1) >> 0] | 0) & (1 << i7 - i12) + -1) << i12 | (i4 & 255) >>> i3;
    } else i3 = (i4 & 255) >>> i3 & i8;
    HEAP8[i30 + (i6 << 2) >> 0] = i3;
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= i21 >>> 0) break; else i3 = i2;
   }
  } while (0);
  if ((i13 | 0) == 30) {
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
   break;
  }
  if (i16) i13 = 57; else {
   i7 = i10 & 255;
   i8 = (1 << i7) + 255 | 0;
   L47 : do if (!(i10 << 24 >> 24)) {
    i4 = (i2 + i7 | 0) >>> 0 > 128;
    i3 = 0;
    do {
     if (i4) {
      i13 = 41;
      break L47;
     }
     HEAP8[i30 + (i3 << 2) + 1 >> 0] = 0;
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i21 >>> 0);
   } else {
    i6 = 0;
    i3 = i2;
    while (1) {
     i2 = i3 + i7 | 0;
     if (i2 >>> 0 > 128) {
      i13 = 41;
      break L47;
     }
     i5 = i3 >>> 3;
     i3 = i3 - (i5 << 3) | 0;
     i4 = HEAP8[i24 + i5 >> 0] | 0;
     if ((i3 + i7 | 0) >>> 0 > 8) {
      i12 = 8 - i3 | 0;
      i3 = ((HEAPU8[i24 + (i5 + 1) >> 0] | 0) & (1 << i7 - i12) + -1) << i12 | (i4 & 255) >>> i3;
     } else i3 = (i4 & 255) >>> i3 & i8;
     HEAP8[i30 + (i6 << 2) + 1 >> 0] = i3;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= i21 >>> 0) break; else i3 = i2;
    }
   } while (0);
   if ((i13 | 0) == 41) {
    HEAPF32[i29 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
    break;
   }
   if (i16) i13 = 57; else {
    i7 = i14 & 255;
    i8 = (1 << i7) + 255 | 0;
    L63 : do if (!(i14 << 24 >> 24)) {
     i4 = (i2 + i7 | 0) >>> 0 > 128;
     i3 = 0;
     do {
      if (i4) {
       i13 = 52;
       break L63;
      }
      HEAP8[i30 + (i3 << 2) + 2 >> 0] = 0;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i21 >>> 0);
    } else {
     i6 = 0;
     i3 = i2;
     while (1) {
      i2 = i3 + i7 | 0;
      if (i2 >>> 0 > 128) {
       i13 = 52;
       break L63;
      }
      i5 = i3 >>> 3;
      i3 = i3 - (i5 << 3) | 0;
      i4 = HEAP8[i24 + i5 >> 0] | 0;
      if ((i3 + i7 | 0) >>> 0 > 8) {
       i12 = 8 - i3 | 0;
       i3 = ((HEAPU8[i24 + (i5 + 1) >> 0] | 0) & (1 << i7 - i12) + -1) << i12 | (i4 & 255) >>> i3;
      } else i3 = (i4 & 255) >>> i3 & i8;
      HEAP8[i30 + (i6 << 2) + 2 >> 0] = i3;
      i6 = i6 + 1 | 0;
      if (i6 >>> 0 >= i21 >>> 0) break; else i3 = i2;
     }
    } while (0);
    if ((i13 | 0) == 52) {
     HEAPF32[i29 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
     break;
    }
    if (i16) i13 = 57; else {
     i7 = i15 & 255;
     i8 = (1 << i7) + 255 | 0;
     L79 : do if (!(i15 << 24 >> 24)) {
      i4 = (i2 + i7 | 0) >>> 0 > 128;
      i3 = 0;
      while (1) {
       if (i4) break L79;
       HEAP8[i30 + (i3 << 2) + 3 >> 0] = -1;
       i3 = i3 + 1 | 0;
       if (i3 >>> 0 >= i21 >>> 0) {
        i13 = 57;
        break L29;
       }
      }
     } else {
      i6 = 0;
      while (1) {
       i5 = i2 + i7 | 0;
       if (i5 >>> 0 > 128) break L79;
       i4 = i2 >>> 3;
       i2 = i2 - (i4 << 3) | 0;
       i3 = HEAP8[i24 + i4 >> 0] | 0;
       if ((i2 + i7 | 0) >>> 0 > 8) {
        i12 = 8 - i2 | 0;
        i2 = ((HEAPU8[i24 + (i4 + 1) >> 0] | 0) & (1 << i7 - i12) + -1) << i12 | (i3 & 255) >>> i2;
       } else i2 = (i3 & 255) >>> i2 & i8;
       HEAP8[i30 + (i6 << 2) + 3 >> 0] = i2;
       i6 = i6 + 1 | 0;
       if (i6 >>> 0 >= i21 >>> 0) {
        i2 = i5;
        i13 = 57;
        break L29;
       } else i2 = i5;
      }
     } while (0);
     HEAPF32[i29 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
     HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
     HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
    }
   }
  }
 } while (0);
 do if ((i13 | 0) == 57) {
  i4 = HEAP8[gb + 1545909 + (i11 * 15 | 0) + 2 >> 0] | 0;
  if (i4 << 24 >> 24) {
   i5 = i4 & 255;
   i3 = 0;
   do {
    if (i2 >>> 0 > 127) {
     i13 = 66;
     break;
    }
    i12 = i2 >>> 3;
    i11 = i2;
    i2 = i2 + 1 | 0;
    HEAP8[i22 + i3 >> 0] = (HEAPU8[i24 + i12 >> 0] | 0) >>> (i11 - (i12 << 3) | 0) & 1;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i5 >>> 0);
   if ((i13 | 0) == 66) {
    HEAPF32[i29 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
    break;
   }
   if (i4 << 24 >> 24 != 0 & (i21 | 0) != 0) {
    i13 = i4 & 255;
    i12 = i9 << 24 >> 24 == i17 << 24 >> 24;
    i11 = i10 << 24 >> 24 == i18 << 24 >> 24;
    i10 = i14 << 24 >> 24 == i19 << 24 >> 24;
    i4 = i15 << 24 >> 24 == i20 << 24 >> 24;
    i3 = 0;
    do {
     i5 = i30 + (i3 << 2) | 0;
     i6 = i22 + (((Math_imul(i13, i3) | 0) >>> 0) / (i21 >>> 0) | 0) | 0;
     i7 = i30 + (i3 << 2) + 1 | 0;
     i8 = i30 + (i3 << 2) + 2 | 0;
     i9 = i30 + (i3 << 2) + 3 | 0;
     if (!i12) HEAP8[i5 >> 0] = (HEAPU8[i5 >> 0] | 0) << 1 | (HEAPU8[i6 >> 0] | 0);
     if (!i11) HEAP8[i7 >> 0] = (HEAPU8[i7 >> 0] | 0) << 1 | (HEAPU8[i6 >> 0] | 0);
     if (!i10) HEAP8[i8 >> 0] = (HEAPU8[i8 >> 0] | 0) << 1 | (HEAPU8[i6 >> 0] | 0);
     if (!i4) HEAP8[i9 >> 0] = (HEAPU8[i9 >> 0] | 0) << 1 | (HEAPU8[i6 >> 0] | 0);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i21 | 0));
   }
  }
  if (!i16) {
   i10 = i17 & 255;
   i11 = 8 - i10 | 0;
   i8 = i18 & 255;
   i9 = 8 - i8 | 0;
   i6 = i19 & 255;
   i7 = 8 - i6 | 0;
   i4 = i20 & 255;
   i5 = 8 - i4 | 0;
   if (!(i20 << 24 >> 24)) {
    i3 = 0;
    do {
     i22 = i30 + (i3 << 2) | 0;
     i19 = (HEAPU8[i22 >> 0] | 0) << i11;
     i18 = (HEAPU8[i30 + (i3 << 2) + 1 >> 0] | 0) << i9;
     i20 = (HEAPU8[i30 + (i3 << 2) + 2 >> 0] | 0) << i7;
     i20 = ((i18 & 255) >>> i8 | i18) << 8 & 65280 | ((i19 & 255) >>> i10 | i19) & 255 | ((i20 & 255) >>> i6 | i20) << 16 | -16777216;
     HEAP8[i22 >> 0] = i20;
     HEAP8[i22 + 1 >> 0] = i20 >> 8;
     HEAP8[i22 + 2 >> 0] = i20 >> 16;
     HEAP8[i22 + 3 >> 0] = i20 >> 24;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i21 | 0));
   } else {
    i3 = 0;
    do {
     i22 = i30 + (i3 << 2) | 0;
     i18 = (HEAPU8[i22 >> 0] | 0) << i11;
     i17 = (HEAPU8[i30 + (i3 << 2) + 1 >> 0] | 0) << i9;
     i19 = (HEAPU8[i30 + (i3 << 2) + 2 >> 0] | 0) << i7;
     i20 = (HEAPU8[i30 + (i3 << 2) + 3 >> 0] | 0) << i5;
     i20 = ((i17 & 255) >>> i8 | i17) << 8 & 65280 | ((i18 & 255) >>> i10 | i18) & 255 | ((i19 & 255) >>> i6 | i19) << 16 & 16711680 | ((i20 & 255) >>> i4 | i20) << 24;
     HEAP8[i22 >> 0] = i20;
     HEAP8[i22 + 1 >> 0] = i20 >> 8;
     HEAP8[i22 + 2 >> 0] = i20 >> 16;
     HEAP8[i22 + 3 >> 0] = i20 >> 24;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i21 | 0));
   }
  }
  i12 = i1 & 255;
  i7 = i27 & 255;
  i6 = 0;
  while (1) {
   i1 = 0;
   while (1) {
    if ((HEAPU8[gb + 412525 + (i26 * 192 | 0) + (i12 * 3 | 0) + i1 >> 0] | 0 | 0) == (i6 | 0)) {
     i1 = -1;
     break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 > i26 >>> 0) {
     i1 = 0;
     break;
    }
   }
   i3 = i1 + i7 | 0;
   i5 = i3 + i2 | 0;
   if (i5 >>> 0 > 128) {
    i13 = 86;
    break;
   }
   if (!i3) i1 = 0; else {
    i4 = i2 >>> 3;
    i1 = i2 - (i4 << 3) | 0;
    i2 = HEAP8[i24 + i4 >> 0] | 0;
    if ((i3 + i1 | 0) >>> 0 > 8) {
     i22 = 8 - i1 | 0;
     i1 = ((HEAPU8[i24 + (i4 + 1) >> 0] | 0) & (1 << i3 - i22) + -1) << i22 | (i2 & 255) >>> i1;
    } else i1 = (i2 & 255) >>> i1 & (1 << i3) + 255;
    i1 = i1 & 255;
    i2 = i5;
   }
   HEAP8[i31 + i6 >> 0] = i1;
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= 16) {
    i13 = 88;
    break;
   }
  }
  L140 : do if ((i13 | 0) == 86) {
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
   HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
   HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
  } else if ((i13 | 0) == 88) {
   i11 = i28 << 24 >> 24 == 0;
   L142 : do if (!i11) {
    i7 = i28 & 255;
    i1 = i2;
    i6 = 0;
    while (1) {
     i3 = (((i6 | 0) == 0) << 31 >> 31) + i7 | 0;
     i5 = i3 + i1 | 0;
     if (i5 >>> 0 > 128) break;
     if (!i3) i2 = 0; else {
      i4 = i1 >>> 3;
      i1 = i1 - (i4 << 3) | 0;
      i2 = HEAP8[i24 + i4 >> 0] | 0;
      if ((i3 + i1 | 0) >>> 0 > 8) {
       i22 = 8 - i1 | 0;
       i1 = ((HEAPU8[i24 + (i4 + 1) >> 0] | 0) & (1 << i3 - i22) + -1) << i22 | (i2 & 255) >>> i1;
      } else i1 = (i2 & 255) >>> i1 & (1 << i3) + 255;
      i2 = i1 & 255;
      i1 = i5;
     }
     HEAP8[i32 + i6 >> 0] = i2;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= 16) break L142;
    }
    HEAPF32[i29 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 32 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 36 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 40 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 68 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 72 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 76 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 80 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 84 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 88 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 92 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 96 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 100 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 104 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 108 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 112 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 116 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 120 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 124 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 128 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 132 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 136 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 140 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 148 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 152 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 156 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 160 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 164 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 168 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 172 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 176 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 180 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 184 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 188 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 192 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 196 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 200 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 204 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 208 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 212 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 216 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 220 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 224 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 228 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 232 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 236 >> 2] = Math_fround(1.0);
    HEAPF32[i29 + 240 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 244 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 248 >> 2] = Math_fround(0.0);
    HEAPF32[i29 + 252 >> 2] = Math_fround(1.0);
    break L140;
   } while (0);
   i10 = i23 << 24 >> 24 == 0;
   i9 = 0;
   while (1) {
    i6 = (HEAPU8[gb + 413101 + (i26 << 10) + (i12 << 4) + i9 >> 0] | 0) << 1;
    L158 : do if (i11) {
     i7 = i6 | 1;
     i4 = HEAPU8[i31 + i9 >> 0] | 0;
     switch (i27 << 24 >> 24) {
     case 2:
      {
       i1 = gb + 46488 | 0;
       i13 = 103;
       break;
      }
     case 3:
      {
       i1 = gb + 46456 | 0;
       i13 = 103;
       break;
      }
     case 4:
      {
       i1 = gb + 46392 | 0;
       i13 = 103;
       break;
      }
     default:
      {
       i1 = 0;
       i3 = 0;
       i5 = 0;
      }
     }
     if ((i13 | 0) == 103) {
      i13 = 0;
      i5 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
      i24 = 64 - i5 | 0;
      i1 = Math_imul(i24, HEAPU8[i30 + (i6 << 2) >> 0] | 0) | 0;
      i1 = (i1 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) >> 0] | 0, i5) | 0) | 0) >>> 6 & 255;
      i3 = Math_imul(HEAPU8[i30 + (i6 << 2) + 1 >> 0] | 0, i24) | 0;
      i3 = (i3 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 1 >> 0] | 0, i5) | 0) | 0) >>> 6 & 255;
      i24 = Math_imul(HEAPU8[i30 + (i6 << 2) + 2 >> 0] | 0, i24) | 0;
      i5 = (i24 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 2 >> 0] | 0, i5) | 0) | 0) >>> 6 & 255;
     }
     switch (i27 << 24 >> 24) {
     case 2:
      {
       i2 = gb + 46488 | 0;
       break;
      }
     case 3:
      {
       i2 = gb + 46456 | 0;
       break;
      }
     case 4:
      {
       i2 = gb + 46392 | 0;
       break;
      }
     default:
      {
       i8 = i3;
       i6 = i5;
       i2 = 0;
       break L158;
      }
     }
     i2 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
     i24 = Math_imul(64 - i2 | 0, HEAPU8[i30 + (i6 << 2) + 3 >> 0] | 0) | 0;
     i8 = i3;
     i6 = i5;
     i2 = (i24 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 3 >> 0] | 0, i2) | 0) | 0) >>> 6 & 255;
    } else {
     i3 = i30 + (i6 << 2) | 0;
     i7 = i6 | 1;
     i4 = i30 + (i7 << 2) | 0;
     if (i10) {
      i2 = HEAPU8[i31 + i9 >> 0] | 0;
      i5 = HEAPU8[i32 + i9 >> 0] | 0;
      switch (i27 << 24 >> 24) {
      case 2:
       {
        i1 = gb + 46488 | 0;
        i13 = 112;
        break;
       }
      case 3:
       {
        i1 = gb + 46456 | 0;
        i13 = 112;
        break;
       }
      case 4:
       {
        i1 = gb + 46392 | 0;
        i13 = 112;
        break;
       }
      default:
       {
        i1 = 0;
        i3 = 0;
        i4 = 0;
       }
      }
      if ((i13 | 0) == 112) {
       i13 = 0;
       i24 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
       i23 = 64 - i24 | 0;
       i1 = Math_imul(i23, HEAPU8[i3 >> 0] | 0) | 0;
       i1 = (i1 + 32 + (Math_imul(HEAPU8[i4 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
       i3 = Math_imul(HEAPU8[i30 + (i6 << 2) + 1 >> 0] | 0, i23) | 0;
       i3 = (i3 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 1 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
       i4 = Math_imul(HEAPU8[i30 + (i6 << 2) + 2 >> 0] | 0, i23) | 0;
       i4 = (i4 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 2 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
      }
      switch (i28 << 24 >> 24) {
      case 2:
       {
        i2 = gb + 46488 | 0;
        break;
       }
      case 3:
       {
        i2 = gb + 46456 | 0;
        break;
       }
      case 4:
       {
        i2 = gb + 46392 | 0;
        break;
       }
      default:
       {
        i8 = i3;
        i6 = i4;
        i2 = 0;
        break L158;
       }
      }
      i2 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
      i24 = Math_imul(64 - i2 | 0, HEAPU8[i30 + (i6 << 2) + 3 >> 0] | 0) | 0;
      i8 = i3;
      i6 = i4;
      i2 = (i24 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 3 >> 0] | 0, i2) | 0) | 0) >>> 6 & 255;
      break;
     } else {
      i2 = HEAPU8[i32 + i9 >> 0] | 0;
      i5 = HEAPU8[i31 + i9 >> 0] | 0;
      switch (i28 << 24 >> 24) {
      case 2:
       {
        i1 = gb + 46488 | 0;
        i13 = 120;
        break;
       }
      case 3:
       {
        i1 = gb + 46456 | 0;
        i13 = 120;
        break;
       }
      case 4:
       {
        i1 = gb + 46392 | 0;
        i13 = 120;
        break;
       }
      default:
       {
        i1 = 0;
        i3 = 0;
        i4 = 0;
       }
      }
      if ((i13 | 0) == 120) {
       i13 = 0;
       i24 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
       i23 = 64 - i24 | 0;
       i1 = Math_imul(i23, HEAPU8[i3 >> 0] | 0) | 0;
       i1 = (i1 + 32 + (Math_imul(HEAPU8[i4 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
       i3 = Math_imul(HEAPU8[i30 + (i6 << 2) + 1 >> 0] | 0, i23) | 0;
       i3 = (i3 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 1 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
       i4 = Math_imul(HEAPU8[i30 + (i6 << 2) + 2 >> 0] | 0, i23) | 0;
       i4 = (i4 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 2 >> 0] | 0, i24) | 0) | 0) >>> 6 & 255;
      }
      switch (i27 << 24 >> 24) {
      case 2:
       {
        i2 = gb + 46488 | 0;
        break;
       }
      case 3:
       {
        i2 = gb + 46456 | 0;
        break;
       }
      case 4:
       {
        i2 = gb + 46392 | 0;
        break;
       }
      default:
       {
        i8 = i3;
        i6 = i4;
        i2 = 0;
        break L158;
       }
      }
      i2 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
      i24 = Math_imul(64 - i2 | 0, HEAPU8[i30 + (i6 << 2) + 3 >> 0] | 0) | 0;
      i8 = i3;
      i6 = i4;
      i2 = (i24 + 32 + (Math_imul(HEAPU8[i30 + (i7 << 2) + 3 >> 0] | 0, i2) | 0) | 0) >>> 6 & 255;
      break;
     }
    } while (0);
    switch (i25 << 24 >> 24) {
    case 1:
     {
      i3 = i2;
      i4 = i8;
      i5 = i6;
      break;
     }
    case 2:
     {
      i3 = i1;
      i4 = i2;
      i5 = i6;
      i1 = i8;
      break;
     }
    case 3:
     {
      i3 = i1;
      i4 = i8;
      i5 = i2;
      i1 = i6;
      break;
     }
    default:
     {
      i3 = i1;
      i4 = i8;
      i5 = i6;
      i1 = i2;
     }
    }
    f36 = Math_fround(Math_fround(i4 & 255) * Math_fround(.00392156886));
    f35 = Math_fround(Math_fround(i5 & 255) * Math_fround(.00392156886));
    f34 = Math_fround(Math_fround(i1 & 255) * Math_fround(.00392156886));
    HEAPF32[i29 + (i9 << 4) >> 2] = Math_fround(Math_fround(i3 & 255) * Math_fround(.00392156886));
    HEAPF32[i29 + (i9 << 4) + 4 >> 2] = f36;
    HEAPF32[i29 + (i9 << 4) + 8 >> 2] = f35;
    HEAPF32[i29 + (i9 << 4) + 12 >> 2] = f34;
    i9 = i9 + 1 | 0;
    if ((i9 | 0) == 16) break L140;
   }
  } while (0);
 } while (0);
 STACKTOP = i33;
 return;
}

function __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i65, i57, i66) {
 i65 = i65 | 0;
 i57 = i57 | 0;
 i66 = i66 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, i88 = 0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i73 + 96 | 0;
 i61 = i73 + 88 | 0;
 i38 = i73 + 80 | 0;
 i62 = i73 + 56 | 0;
 i41 = i73 + 32 | 0;
 i42 = i73 + 24 | 0;
 i58 = i73 + 16 | 0;
 i59 = i73 + 8 | 0;
 i60 = i73;
 i70 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i65 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
 i71 = (i70 | 0) != 0;
 if (i71) i64 = HEAPU16[i70 + 340 >> 1] | 0; else i64 = 0;
 i72 = i66 + 368 | 0;
 HEAP32[i72 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i72 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i72 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f37 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f39 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f40 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i67 = i66 + 380 | 0;
 HEAPF32[i67 >> 2] = f37;
 i68 = i66 + 384 | 0;
 HEAPF32[i68 >> 2] = f39;
 i69 = i66 + 388 | 0;
 HEAPF32[i69 >> 2] = f40;
 i55 = HEAP32[i57 + 12 >> 2] | 0;
 if (i55 & 3 | 0) {
  i24 = HEAP8[i57 + 871 >> 0] | 0 ? 3 : 1;
  i25 = HEAP8[i57 + 870 >> 0] | 0 ? 0 : 2;
  i26 = HEAP32[i57 + 520 >> 2] | 0;
  i27 = i26 + ((HEAP32[i57 + 532 >> 2] | 0) + -1 << 2) | 0;
  i9 = HEAP32[i57 >> 2] | 0;
  i10 = HEAP32[i57 + 60 >> 2] | 0;
  i16 = HEAP32[i57 + 120 >> 2] | 0;
  i17 = HEAP32[i57 + 20 >> 2] | 0;
  i19 = HEAP32[i57 + 80 >> 2] | 0;
  i20 = HEAP32[i57 + 140 >> 2] | 0;
  i21 = HEAP32[i57 + 40 >> 2] | 0;
  i22 = HEAP32[i57 + 100 >> 2] | 0;
  i23 = HEAP32[i57 + 160 >> 2] | 0;
  i28 = i9 + (i55 + -1 << 2) | 0;
  i29 = i10 + ((HEAP32[i57 + 72 >> 2] | 0) + -1 << 2) | 0;
  i30 = i16 + ((HEAP32[i57 + 132 >> 2] | 0) + -1 << 2) | 0;
  i31 = i17 + ((HEAP32[i57 + 32 >> 2] | 0) + -1 << 2) | 0;
  i32 = i19 + ((HEAP32[i57 + 92 >> 2] | 0) + -1 << 2) | 0;
  i33 = i20 + ((HEAP32[i57 + 152 >> 2] | 0) + -1 << 2) | 0;
  i34 = i21 + ((HEAP32[i57 + 52 >> 2] | 0) + -1 << 2) | 0;
  i35 = i22 + ((HEAP32[i57 + 112 >> 2] | 0) + -1 << 2) | 0;
  i36 = i23 + ((HEAP32[i57 + 172 >> 2] | 0) + -1 << 2) | 0;
  i7 = i55;
  do {
   HEAP32[i9 + (i7 << 2) >> 2] = HEAP32[i28 >> 2];
   HEAP32[i10 + (i7 << 2) >> 2] = HEAP32[i29 >> 2];
   HEAP32[i16 + (i7 << 2) >> 2] = HEAP32[i30 >> 2];
   HEAP32[i17 + (i7 << 2) >> 2] = HEAP32[i31 >> 2];
   HEAP32[i19 + (i7 << 2) >> 2] = HEAP32[i32 >> 2];
   HEAP32[i20 + (i7 << 2) >> 2] = HEAP32[i33 >> 2];
   HEAP32[i21 + (i7 << 2) >> 2] = HEAP32[i34 >> 2];
   HEAP32[i22 + (i7 << 2) >> 2] = HEAP32[i35 >> 2];
   HEAP32[i23 + (i7 << 2) >> 2] = HEAP32[i36 >> 2];
   i3 = 0;
   do {
    i56 = HEAP32[i57 + 420 + (i3 * 20 | 0) >> 2] | 0;
    HEAP32[i56 + (i7 << 2) >> 2] = HEAP32[i56 + ((HEAP32[i57 + 420 + (i3 * 20 | 0) + 12 >> 2] | 0) + -1 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i24 | 0));
   i3 = i25;
   do {
    i56 = HEAP32[i57 + 300 + (i3 * 20 | 0) >> 2] | 0;
    HEAP32[i56 + (i7 << 2) >> 2] = HEAP32[i56 + ((HEAP32[i57 + 300 + (i3 * 20 | 0) + 12 >> 2] | 0) + -1 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != 3);
   HEAP32[i26 + (i7 << 2) >> 2] = HEAP32[i27 >> 2];
   i7 = i7 + 1 | 0;
  } while ((i7 & 3 | 0) != 0);
 }
 i56 = i65 + 40 | 0;
 i3 = HEAP32[i56 >> 2] | 0;
 if (!(HEAP8[i3 + 25 >> 0] | 0)) i43 = 28; else if (!(HEAP8[i3 + 26 >> 0] | 0)) {
  i22 = i3 + 180 | 0;
  i24 = i65 + 44 | 0;
  __ZNK11MinMaxCurve10FindMinMaxEv(i63, (HEAP32[i24 >> 2] | 0) + 8 | 0);
  f40 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  __ZNK11MinMaxCurve10FindMinMaxEv(i61, (HEAP32[i24 >> 2] | 0) + 272 | 0);
  f1 = Math_fround(HEAPF32[i61 >> 2]);
  i25 = i61 + 4 | 0;
  f1 = Math_fround(f40 * f1);
  f2 = Math_fround(f40 * Math_fround(HEAPF32[i25 >> 2]));
  f14 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
  f18 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
  i26 = i66 + 372 | 0;
  i27 = i66 + 376 | 0;
  f13 = Math_fround(HEAPF32[gb + 62548 >> 2]);
  f4 = Math_fround(f1 * f13);
  f15 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
  f5 = Math_fround(f1 * f15);
  f37 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
  f6 = Math_fround(f1 * f37);
  f8 = f4 < f14 ? f4 : f14;
  f11 = f5 < f18 ? f5 : f18;
  f12 = f6 < f39 ? f6 : f39;
  f14 = f14 < f4 ? f4 : f14;
  f18 = f18 < f5 ? f5 : f18;
  f39 = f39 < f6 ? f6 : f39;
  f13 = Math_fround(f2 * f13);
  f15 = Math_fround(f2 * f15);
  f37 = Math_fround(f2 * f37);
  HEAPF32[i72 >> 2] = f13 < f8 ? f13 : f8;
  HEAPF32[i26 >> 2] = f15 < f11 ? f15 : f11;
  HEAPF32[i27 >> 2] = f37 < f12 ? f37 : f12;
  HEAPF32[i67 >> 2] = f14 < f13 ? f13 : f14;
  HEAPF32[i68 >> 2] = f18 < f15 ? f15 : f18;
  HEAPF32[i69 >> 2] = f39 < f37 ? f37 : f39;
  if (HEAP8[i65 + 52 >> 0] | 0) {
   HEAPF32[i38 >> 2] = f1;
   HEAPF32[i38 + 4 >> 2] = f2;
   __ZNK11ShapeModule25CalculateProceduralBoundsER10MinMaxAABBRK8Vector3f8Vector2f(i65 + 48 | 0, i72, i66 + 304 | 0, i38);
  }
  i55 = i65 + 36 | 0;
  __ZNK13InitialModule10GetGravityERK27ParticleSystemReadOnlyStateRK19ParticleSystemState(i62, HEAP32[i24 >> 2] | 0, HEAP32[i55 >> 2] | 0, HEAP32[i56 >> 2] | 0);
  f1 = Math_fround(HEAPF32[i62 >> 2]);
  f4 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f1 = Math_fround(Math_fround(f40 * Math_fround(f40 * f1)) * Math_fround(.5));
  f4 = Math_fround(Math_fround(f40 * Math_fround(f40 * f4)) * Math_fround(.5));
  f39 = Math_fround(Math_fround(f40 * Math_fround(f40 * Math_fround(HEAPF32[i62 + 8 >> 2]))) * Math_fround(.5));
  f2 = Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + 2356 >> 2]);
  f1 = Math_fround(f1 * f2);
  f4 = Math_fround(f4 * f2);
  f2 = Math_fround(f39 * f2);
  if ((HEAP32[(HEAP32[i55 >> 2] | 0) + 280 >> 2] | 0) != 1) {
   i55 = HEAP32[i56 >> 2] | 0;
   f37 = Math_fround(f1 * Math_fround(HEAPF32[i55 + 180 >> 2]));
   f37 = Math_fround(f37 + Math_fround(f4 * Math_fround(HEAPF32[i55 + 196 >> 2])));
   f37 = Math_fround(f37 + Math_fround(f2 * Math_fround(HEAPF32[i55 + 212 >> 2])));
   f39 = Math_fround(f1 * Math_fround(HEAPF32[i55 + 184 >> 2]));
   f39 = Math_fround(f39 + Math_fround(f4 * Math_fround(HEAPF32[i55 + 200 >> 2])));
   f39 = Math_fround(f39 + Math_fround(f2 * Math_fround(HEAPF32[i55 + 216 >> 2])));
   f1 = Math_fround(f1 * Math_fround(HEAPF32[i55 + 188 >> 2]));
   f4 = Math_fround(f1 + Math_fround(f4 * Math_fround(HEAPF32[i55 + 204 >> 2])));
   f1 = f37;
   f2 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i55 + 220 >> 2])));
   f4 = f39;
  }
  f12 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
  f13 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
  i23 = i66 + 380 | 0;
  f5 = Math_fround((f1 < f12 ? f12 : f1) + Math_fround(HEAPF32[i23 >> 2]));
  HEAPF32[i23 >> 2] = f5;
  f6 = Math_fround((f4 < f13 ? f13 : f4) + Math_fround(HEAPF32[i68 >> 2]));
  HEAPF32[i68 >> 2] = f6;
  f8 = Math_fround((f2 < f39 ? f39 : f2) + Math_fround(HEAPF32[i69 >> 2]));
  HEAPF32[i69 >> 2] = f8;
  f11 = Math_fround((f12 < f1 ? f12 : f1) + Math_fround(HEAPF32[i72 >> 2]));
  HEAPF32[i72 >> 2] = f11;
  f4 = Math_fround((f13 < f4 ? f13 : f4) + Math_fround(HEAPF32[i26 >> 2]));
  HEAPF32[i26 >> 2] = f4;
  f1 = Math_fround((f39 < f2 ? f39 : f2) + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i27 >> 2] = f1;
  i21 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i62 >> 2] = f12;
  i3 = i62 + 4 | 0;
  i20 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i3 >> 2] = f13;
  i7 = i62 + 8 | 0;
  i19 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i7 >> 2] = f39;
  i9 = i62 + 12 | 0;
  HEAPF32[i9 >> 2] = f12;
  i10 = i62 + 16 | 0;
  HEAPF32[i10 >> 2] = f13;
  i16 = i62 + 20 | 0;
  HEAPF32[i16 >> 2] = f39;
  i17 = HEAP32[i65 + 868 >> 2] | 0;
  if (!(HEAP8[i17 + 4 >> 0] | 0)) {
   f14 = f12;
   f18 = f13;
   f37 = f39;
   f15 = f12;
   f2 = f4;
   f4 = f39;
  } else {
   __ZN14VelocityModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff(i17, i62, i22, f40);
   f14 = Math_fround(HEAPF32[i9 >> 2]);
   f5 = Math_fround(HEAPF32[i23 >> 2]);
   f18 = Math_fround(HEAPF32[i10 >> 2]);
   f6 = Math_fround(HEAPF32[i68 >> 2]);
   f37 = Math_fround(HEAPF32[i16 >> 2]);
   f8 = Math_fround(HEAPF32[i69 >> 2]);
   f15 = Math_fround(HEAPF32[i62 >> 2]);
   f11 = Math_fround(HEAPF32[i72 >> 2]);
   f13 = Math_fround(HEAPF32[i3 >> 2]);
   f2 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(HEAPF32[i7 >> 2]);
   f1 = Math_fround(HEAPF32[i27 >> 2]);
   i21 = HEAP32[gb + 1162364 >> 2] | 0;
   i20 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i19 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  }
  f14 = Math_fround(f14 + f5);
  HEAPF32[i23 >> 2] = f14;
  f12 = Math_fround(f18 + f6);
  HEAPF32[i68 >> 2] = f12;
  f8 = Math_fround(f37 + f8);
  HEAPF32[i69 >> 2] = f8;
  f5 = Math_fround(f15 + f11);
  HEAPF32[i72 >> 2] = f5;
  f2 = Math_fround(f13 + f2);
  HEAPF32[i26 >> 2] = f2;
  f1 = Math_fround(f4 + f1);
  HEAPF32[i27 >> 2] = f1;
  HEAP32[i41 >> 2] = i21;
  i3 = i41 + 4 | 0;
  HEAP32[i3 >> 2] = i20;
  i7 = i41 + 8 | 0;
  HEAP32[i7 >> 2] = i19;
  i9 = i41 + 12 | 0;
  HEAP32[i9 >> 2] = i21;
  i10 = i41 + 16 | 0;
  HEAP32[i10 >> 2] = i20;
  i16 = i41 + 20 | 0;
  HEAP32[i16 >> 2] = i19;
  i17 = HEAP32[i65 + 876 >> 2] | 0;
  if (!(HEAP8[i17 + 4 >> 0] | 0)) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } else {
   __ZN11ForceModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff(i17, i41, i22, f40);
   f18 = Math_fround(HEAPF32[i9 >> 2]);
   f14 = Math_fround(HEAPF32[i23 >> 2]);
   f15 = Math_fround(HEAPF32[i10 >> 2]);
   f12 = Math_fround(HEAPF32[i68 >> 2]);
   f13 = Math_fround(HEAPF32[i16 >> 2]);
   f8 = Math_fround(HEAPF32[i69 >> 2]);
   f11 = Math_fround(HEAPF32[i41 >> 2]);
   f5 = Math_fround(HEAPF32[i72 >> 2]);
   f6 = Math_fround(HEAPF32[i3 >> 2]);
   f2 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(HEAPF32[i7 >> 2]);
   f1 = Math_fround(HEAPF32[i27 >> 2]);
  }
  HEAPF32[i23 >> 2] = Math_fround(f18 + f14);
  HEAPF32[i68 >> 2] = Math_fround(f15 + f12);
  HEAPF32[i69 >> 2] = Math_fround(f13 + f8);
  HEAPF32[i72 >> 2] = Math_fround(f11 + f5);
  HEAPF32[i26 >> 2] = Math_fround(f6 + f2);
  HEAPF32[i27 >> 2] = Math_fround(f4 + f1);
  if ((i64 | 0) == 1) {
   i3 = HEAP32[i24 >> 2] | 0;
   if (!(HEAP8[i3 + 2552 >> 0] | 0)) __ZNK11MinMaxCurve10FindMinMaxEv(i42, i3 + 692 | 0); else __ZNK11MinMaxCurve10FindMinMaxEv(i42, i3 + 956 | 0);
   f1 = Math_fround(HEAPF32[i70 + 356 >> 2]);
   f2 = Math_fround(HEAPF32[i25 >> 2]);
   if (f2 > Math_fround(9.99999974e-06)) {
    f40 = Math_fround(HEAPF32[i70 + 360 >> 2]);
    f1 = Math_fround(f1 + Math_fround(Math_fround(f40 * Math_fround(HEAPF32[i42 + 4 >> 2])) / f2));
   }
   f40 = Math_fround(f2 * Math_fround(f1 * Math_fround(.5)));
   HEAPF32[i23 >> 2] = Math_fround(f40 + Math_fround(HEAPF32[i23 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(f40 + Math_fround(HEAPF32[i68 >> 2]));
   HEAPF32[i69 >> 2] = Math_fround(f40 + Math_fround(HEAPF32[i69 >> 2]));
   HEAPF32[i72 >> 2] = Math_fround(Math_fround(HEAPF32[i72 >> 2]) - f40);
   HEAPF32[i26 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f40);
   HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f40);
  }
 } else i43 = 28;
 do if ((i43 | 0) == 28) {
  if (!i55) if ((HEAP32[(HEAP32[i65 + 36 >> 2] | 0) + 280 >> 2] | 0) == 1) {
   i53 = HEAP32[i66 + 100 >> 2] | 0;
   i54 = HEAP32[i66 + 104 >> 2] | 0;
   i55 = HEAP32[i66 + 108 >> 2] | 0;
   HEAP32[i72 >> 2] = i53;
   HEAP32[i66 + 372 >> 2] = i54;
   HEAP32[i66 + 376 >> 2] = i55;
   HEAP32[i66 + 380 >> 2] = i53;
   HEAP32[i68 >> 2] = i54;
   HEAP32[i69 >> 2] = i55;
   break;
  } else {
   i53 = HEAP32[gb + 1162364 >> 2] | 0;
   i54 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i55 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
   HEAP32[i72 >> 2] = i53;
   HEAP32[i66 + 372 >> 2] = i54;
   HEAP32[i66 + 376 >> 2] = i55;
   HEAP32[i66 + 380 >> 2] = i53;
   HEAP32[i68 >> 2] = i54;
   HEAP32[i69 >> 2] = i55;
   break;
  }
  i9 = HEAP32[i57 >> 2] | 0;
  i10 = HEAP32[i57 + 20 >> 2] | 0;
  i16 = HEAP32[i57 + 40 >> 2] | 0;
  i7 = 0;
  i17 = -8388608;
  i23 = 2139095040;
  i21 = -8388608;
  i27 = 2139095040;
  i26 = -8388608;
  i32 = 2139095040;
  i30 = -8388608;
  i36 = 2139095040;
  i34 = -8388608;
  i33 = 2139095040;
  i35 = -8388608;
  i29 = 2139095040;
  i31 = -8388608;
  i25 = 2139095040;
  i28 = -8388608;
  i22 = 2139095040;
  i24 = -8388608;
  i19 = 2139095040;
  i20 = -8388608;
  i38 = 2139095040;
  i41 = -8388608;
  i42 = 2139095040;
  i44 = -8388608;
  i3 = 2139095040;
  do {
   i54 = i9 + (i7 << 2) | 0;
   f81 = Math_fround(HEAPF32[i54 >> 2]);
   f79 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f77 = Math_fround(HEAPF32[i54 + 8 >> 2]);
   f75 = Math_fround(HEAPF32[i54 + 12 >> 2]);
   i54 = i10 + (i7 << 2) | 0;
   f1 = Math_fround(HEAPF32[i54 >> 2]);
   f4 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i54 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i54 + 12 >> 2]);
   i54 = i16 + (i7 << 2) | 0;
   f13 = Math_fround(HEAPF32[i54 >> 2]);
   f15 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i54 + 8 >> 2]);
   f40 = Math_fround(HEAPF32[i54 + 12 >> 2]);
   f39 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f76 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f78 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f80 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f82 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i23 = (HEAPF32[tempDoublePtr >> 2] = f39 < f81 ? f39 : f81, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f18 < f79 ? f18 : f79, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = (HEAPF32[tempDoublePtr >> 2] = f14 < f77 ? f14 : f77, HEAP32[tempDoublePtr >> 2] | 0);
   i32 = (HEAPF32[tempDoublePtr >> 2] = f12 < f75 ? f12 : f75, HEAP32[tempDoublePtr >> 2] | 0);
   i36 = (HEAPF32[tempDoublePtr >> 2] = f8 < f1 ? f8 : f1, HEAP32[tempDoublePtr >> 2] | 0);
   i33 = (HEAPF32[tempDoublePtr >> 2] = f5 < f4 ? f5 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i29 = (HEAPF32[tempDoublePtr >> 2] = f2 < f6 ? f2 : f6, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f74 < f11 ? f74 : f11, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = (HEAPF32[tempDoublePtr >> 2] = f76 < f13 ? f76 : f13, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f78 < f15 ? f78 : f15, HEAP32[tempDoublePtr >> 2] | 0);
   i38 = (HEAPF32[tempDoublePtr >> 2] = f80 < f37 ? f80 : f37, HEAP32[tempDoublePtr >> 2] | 0);
   i42 = (HEAPF32[tempDoublePtr >> 2] = f82 < f40 ? f82 : f40, HEAP32[tempDoublePtr >> 2] | 0);
   f82 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f80 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f78 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f76 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i17 = (HEAPF32[tempDoublePtr >> 2] = f82 > f81 ? f82 : f81, HEAP32[tempDoublePtr >> 2] | 0);
   i44 = (HEAPF32[tempDoublePtr >> 2] = f80 > f79 ? f80 : f79, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f78 > f77 ? f78 : f77, HEAP32[tempDoublePtr >> 2] | 0);
   i26 = (HEAPF32[tempDoublePtr >> 2] = f76 > f75 ? f76 : f75, HEAP32[tempDoublePtr >> 2] | 0);
   i30 = (HEAPF32[tempDoublePtr >> 2] = f74 > f1 ? f74 : f1, HEAP32[tempDoublePtr >> 2] | 0);
   i34 = (HEAPF32[tempDoublePtr >> 2] = f2 > f4 ? f2 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i35 = (HEAPF32[tempDoublePtr >> 2] = f5 > f6 ? f5 : f6, HEAP32[tempDoublePtr >> 2] | 0);
   i31 = (HEAPF32[tempDoublePtr >> 2] = f8 > f11 ? f8 : f11, HEAP32[tempDoublePtr >> 2] | 0);
   i28 = (HEAPF32[tempDoublePtr >> 2] = f12 > f13 ? f12 : f13, HEAP32[tempDoublePtr >> 2] | 0);
   i24 = (HEAPF32[tempDoublePtr >> 2] = f14 > f15 ? f14 : f15, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = (HEAPF32[tempDoublePtr >> 2] = f18 > f37 ? f18 : f37, HEAP32[tempDoublePtr >> 2] | 0);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f39 > f40 ? f39 : f40, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = i7 + 4 | 0;
  } while (i7 >>> 0 < i55 >>> 0);
  if ((i64 | 0) == 1) {
   f1 = Math_fround(HEAPF32[i70 + 356 >> 2]);
   f2 = Math_fround(HEAPF32[i70 + 360 >> 2]);
   i45 = HEAP32[i57 + 60 >> 2] | 0;
   i46 = HEAP32[i57 + 80 >> 2] | 0;
   i47 = HEAP32[i57 + 100 >> 2] | 0;
   i48 = HEAP32[i57 + 120 >> 2] | 0;
   i49 = HEAP32[i57 + 140 >> 2] | 0;
   i50 = HEAP32[i57 + 160 >> 2] | 0;
   i51 = HEAP32[i57 + 420 >> 2] | 0;
   i52 = HEAP32[i57 >> 2] | 0;
   i53 = HEAP32[i57 + 20 >> 2] | 0;
   i54 = HEAP32[i57 + 40 >> 2] | 0;
   i43 = 0;
   i10 = i38;
   i16 = i41;
   i9 = i42;
   i7 = i44;
   do {
    i38 = i45 + (i43 << 2) | 0;
    f11 = Math_fround(HEAPF32[i38 >> 2]);
    f6 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f87 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    i38 = i46 + (i43 << 2) | 0;
    f86 = Math_fround(HEAPF32[i38 >> 2]);
    f85 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f84 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f76 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    i38 = i47 + (i43 << 2) | 0;
    f78 = Math_fround(HEAPF32[i38 >> 2]);
    f80 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f82 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f81 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    i38 = i48 + (i43 << 2) | 0;
    f83 = Math_fround(HEAPF32[i38 >> 2]);
    f5 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f12 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    i38 = i49 + (i43 << 2) | 0;
    f14 = Math_fround(HEAPF32[i38 >> 2]);
    f18 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f39 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f74 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    i38 = i50 + (i43 << 2) | 0;
    f37 = Math_fround(HEAPF32[i38 >> 2]);
    f75 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f79 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f83 = Math_fround(f11 + f83);
    f5 = Math_fround(f6 + f5);
    f8 = Math_fround(f4 + f8);
    f12 = Math_fround(f87 + f12);
    f14 = Math_fround(f86 + f14);
    f18 = Math_fround(f85 + f18);
    f39 = Math_fround(f84 + f39);
    f74 = Math_fround(f76 + f74);
    f37 = Math_fround(f78 + f37);
    f75 = Math_fround(f80 + f75);
    f79 = Math_fround(f82 + f79);
    f81 = Math_fround(f81 + Math_fround(HEAPF32[i38 + 12 >> 2]));
    f82 = Math_fround(Math_fround(Math_fround(f83 * f83) + Math_fround(f14 * f14)) + Math_fround(f37 * f37));
    f80 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f18 * f18)) + Math_fround(f75 * f75));
    f78 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f39 * f39)) + Math_fround(f79 * f79));
    f76 = Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f74 * f74)) + Math_fround(f81 * f81));
    f84 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f82))));
    f85 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f80))));
    f86 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f78))));
    f87 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f76))));
    i38 = !(f82 <= Math_fround(9.99999974e-06));
    i41 = !(f80 <= Math_fround(9.99999974e-06));
    i42 = !(f78 <= Math_fround(9.99999974e-06));
    i44 = !(f76 <= Math_fround(9.99999974e-06));
    i88 = i51 + (i43 << 2) | 0;
    f76 = Math_fround(HEAPF32[i88 >> 2]);
    f78 = Math_fround(HEAPF32[i88 + 4 >> 2]);
    f80 = Math_fround(HEAPF32[i88 + 8 >> 2]);
    f82 = Math_fround(HEAPF32[i88 + 12 >> 2]);
    f84 = Math_fround(f2 * (i38 ? f84 : Math_fround(0.0)));
    f85 = Math_fround(f2 * (i41 ? f85 : Math_fround(0.0)));
    f86 = Math_fround(f2 * (i42 ? f86 : Math_fround(0.0)));
    f76 = Math_fround(f1 + Math_fround(f84 * f76));
    f78 = Math_fround(f1 + Math_fround(f85 * f78));
    f80 = Math_fround(f1 + Math_fround(f86 * f80));
    f82 = Math_fround(f1 + Math_fround(Math_fround(f2 * (i44 ? f87 : Math_fround(0.0))) * f82));
    i44 = i52 + (i43 << 2) | 0;
    f87 = Math_fround(HEAPF32[i44 >> 2]);
    f86 = Math_fround(HEAPF32[i44 + 4 >> 2]);
    f85 = Math_fround(HEAPF32[i44 + 8 >> 2]);
    f84 = Math_fround(HEAPF32[i44 + 12 >> 2]);
    i44 = i53 + (i43 << 2) | 0;
    f4 = Math_fround(HEAPF32[i44 >> 2]);
    f6 = Math_fround(HEAPF32[i44 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[i44 + 8 >> 2]);
    f13 = Math_fround(HEAPF32[i44 + 12 >> 2]);
    i44 = i54 + (i43 << 2) | 0;
    f15 = Math_fround(HEAPF32[i44 >> 2]);
    f40 = Math_fround(HEAPF32[i44 + 4 >> 2]);
    f77 = Math_fround(HEAPF32[i44 + 8 >> 2]);
    f83 = Math_fround(f87 - Math_fround(f83 * f76));
    f5 = Math_fround(f86 - Math_fround(f5 * f78));
    f8 = Math_fround(f85 - Math_fround(f8 * f80));
    f12 = Math_fround(f84 - Math_fround(f12 * f82));
    f14 = Math_fround(f4 - Math_fround(f14 * f76));
    f18 = Math_fround(f6 - Math_fround(f18 * f78));
    f39 = Math_fround(f11 - Math_fround(f39 * f80));
    f74 = Math_fround(f13 - Math_fround(f74 * f82));
    f76 = Math_fround(f15 - Math_fround(f37 * f76));
    f78 = Math_fround(f40 - Math_fround(f75 * f78));
    f80 = Math_fround(f77 - Math_fround(f79 * f80));
    f82 = Math_fround(Math_fround(HEAPF32[i44 + 12 >> 2]) - Math_fround(f81 * f82));
    f81 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f79 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f77 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f75 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f84 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i23 = (HEAPF32[tempDoublePtr >> 2] = f81 < f83 ? f81 : f83, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f79 < f5 ? f79 : f5, HEAP32[tempDoublePtr >> 2] | 0);
    i27 = (HEAPF32[tempDoublePtr >> 2] = f77 < f8 ? f77 : f8, HEAP32[tempDoublePtr >> 2] | 0);
    i32 = (HEAPF32[tempDoublePtr >> 2] = f75 < f12 ? f75 : f12, HEAP32[tempDoublePtr >> 2] | 0);
    i36 = (HEAPF32[tempDoublePtr >> 2] = f40 < f14 ? f40 : f14, HEAP32[tempDoublePtr >> 2] | 0);
    i33 = (HEAPF32[tempDoublePtr >> 2] = f37 < f18 ? f37 : f18, HEAP32[tempDoublePtr >> 2] | 0);
    i29 = (HEAPF32[tempDoublePtr >> 2] = f15 < f39 ? f15 : f39, HEAP32[tempDoublePtr >> 2] | 0);
    i25 = (HEAPF32[tempDoublePtr >> 2] = f13 < f74 ? f13 : f74, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f11 < f76 ? f11 : f76, HEAP32[tempDoublePtr >> 2] | 0);
    i19 = (HEAPF32[tempDoublePtr >> 2] = f6 < f78 ? f6 : f78, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f4 < f80 ? f4 : f80, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f84 < f82 ? f84 : f82, HEAP32[tempDoublePtr >> 2] | 0);
    f84 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f75 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f77 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f79 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f81 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i17 = (HEAPF32[tempDoublePtr >> 2] = f84 > f83 ? f84 : f83, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f4 > f5 ? f4 : f5, HEAP32[tempDoublePtr >> 2] | 0);
    i21 = (HEAPF32[tempDoublePtr >> 2] = f6 > f8 ? f6 : f8, HEAP32[tempDoublePtr >> 2] | 0);
    i26 = (HEAPF32[tempDoublePtr >> 2] = f11 > f12 ? f11 : f12, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f13 > f14 ? f13 : f14, HEAP32[tempDoublePtr >> 2] | 0);
    i34 = (HEAPF32[tempDoublePtr >> 2] = f15 > f18 ? f15 : f18, HEAP32[tempDoublePtr >> 2] | 0);
    i35 = (HEAPF32[tempDoublePtr >> 2] = f37 > f39 ? f37 : f39, HEAP32[tempDoublePtr >> 2] | 0);
    i31 = (HEAPF32[tempDoublePtr >> 2] = f40 > f74 ? f40 : f74, HEAP32[tempDoublePtr >> 2] | 0);
    i28 = (HEAPF32[tempDoublePtr >> 2] = f75 > f76 ? f75 : f76, HEAP32[tempDoublePtr >> 2] | 0);
    i24 = (HEAPF32[tempDoublePtr >> 2] = f77 > f78 ? f77 : f78, HEAP32[tempDoublePtr >> 2] | 0);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f79 > f80 ? f79 : f80, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f81 > f82 ? f81 : f82, HEAP32[tempDoublePtr >> 2] | 0);
    i43 = i43 + 4 | 0;
   } while (i43 >>> 0 < i55 >>> 0);
  } else {
   i10 = i38;
   i16 = i41;
   i9 = i42;
   i7 = i44;
  }
  f87 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fminf(f87, (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f2 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(_fminf(f87, Math_fround(_fminf(f2, (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  f87 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fminf(f87, (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f4 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(_fminf(f87, Math_fround(_fminf(f4, (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  f87 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fminf(f87, (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f6 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(_fminf(f87, Math_fround(_fminf(f6, (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  f87 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fmaxf(f87, (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f8 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(_fmaxf(f87, Math_fround(_fmaxf(f8, (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  f87 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fmaxf(f87, (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f5 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(_fmaxf(f87, Math_fround(_fmaxf(f5, (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  f87 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f87 = Math_fround(_fmaxf(f87, (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f1 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(_fmaxf(f87, Math_fround(_fmaxf(f1, (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  HEAPF32[i72 >> 2] = f2;
  HEAPF32[i72 + 4 >> 2] = f4;
  HEAPF32[i72 + 8 >> 2] = f6;
  HEAPF32[i67 >> 2] = f8;
  HEAPF32[i67 + 4 >> 2] = f5;
  HEAPF32[i67 + 8 >> 2] = f1;
  if (HEAP8[(HEAP32[i65 + 908 >> 2] | 0) + 4 >> 0] | 0) {
   i7 = HEAP32[i57 + 800 >> 2] | 0;
   i9 = HEAP32[i57 + 824 >> 2] | 0;
   i10 = HEAP32[i57 + 780 >> 2] | 0;
   i16 = HEAP32[i57 + 740 >> 2] | 0;
   i17 = i66 + 372 | 0;
   i19 = i66 + 376 | 0;
   i3 = 0;
   do {
    if (HEAP32[i7 + (i3 << 2) >> 2] | 0) {
     i88 = Math_imul(i9, i3) | 0;
     i88 = (HEAP32[i10 + (i3 << 2) >> 2] | 0) + i88 | 0;
     f85 = Math_fround(HEAPF32[i16 + (i88 << 4) >> 2]);
     f86 = Math_fround(HEAPF32[i16 + (i88 << 4) + 4 >> 2]);
     f87 = Math_fround(HEAPF32[i16 + (i88 << 4) + 8 >> 2]);
     f2 = f85 < f2 ? f85 : f2;
     f4 = f86 < f4 ? f86 : f4;
     f6 = f87 < f6 ? f87 : f6;
     HEAPF32[i72 >> 2] = f2;
     HEAPF32[i17 >> 2] = f4;
     HEAPF32[i19 >> 2] = f6;
     f8 = f8 < f85 ? f85 : f8;
     f5 = f5 < f86 ? f86 : f5;
     f1 = f1 < f87 ? f87 : f1;
     HEAPF32[i67 >> 2] = f8;
     HEAPF32[i68 >> 2] = f5;
     HEAPF32[i69 >> 2] = f1;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i55 | 0));
  }
 } while (0);
 i3 = i65 + 44 | 0;
 __ZNK11MinMaxCurve10FindMinMaxEv(i58, (HEAP32[i3 >> 2] | 0) + 692 | 0);
 i88 = HEAP32[i58 + 4 >> 2] | 0;
 HEAP32[i63 >> 2] = i88;
 i9 = i57 + 871 | 0;
 f1 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!(HEAP8[i9 >> 0] | 0)) i10 = i63; else {
  __ZNK11MinMaxCurve10FindMinMaxEv(i61, (HEAP32[i3 >> 2] | 0) + 956 | 0);
  i10 = i61 + 4 | 0;
  i88 = f1 < Math_fround(HEAPF32[i10 >> 2]);
  i10 = HEAP32[(i88 ? i10 : i63) >> 2] | 0;
  HEAP32[i63 >> 2] = i10;
  __ZNK11MinMaxCurve10FindMinMaxEv(i61, (HEAP32[i3 >> 2] | 0) + 1220 | 0);
  i88 = i61 + 4 | 0;
  f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i10 = f1 < Math_fround(HEAPF32[i88 >> 2]);
  i88 = HEAP32[(i10 ? i88 : i63) >> 2] | 0;
  HEAP32[i63 >> 2] = i88;
  i10 = i63;
  f1 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f1 = Math_fround(f1 * Math_fround(.709999978));
 HEAPF32[i10 >> 2] = f1;
 i7 = i65 + 852 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (HEAP8[i3 + 4 >> 0] | 0) {
  __ZNK11MinMaxCurve10FindMinMaxEv(i59, i3 + 8 | 0);
  i88 = HEAP32[i59 + 4 >> 2] | 0;
  HEAP32[i61 >> 2] = i88;
  f2 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (HEAP8[i9 >> 0] | 0) {
   __ZNK11MinMaxCurve10FindMinMaxEv(i62, (HEAP32[i7 >> 2] | 0) + 272 | 0);
   i59 = i62 + 4 | 0;
   i88 = f2 < Math_fround(HEAPF32[i59 >> 2]);
   i59 = HEAP32[(i88 ? i59 : i61) >> 2] | 0;
   HEAP32[i61 >> 2] = i59;
   __ZNK11MinMaxCurve10FindMinMaxEv(i62, (HEAP32[i7 >> 2] | 0) + 536 | 0);
   i88 = i62 + 4 | 0;
   f2 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i59 = f2 < Math_fround(HEAPF32[i88 >> 2]);
   i88 = HEAP32[(i59 ? i88 : i61) >> 2] | 0;
   HEAP32[i61 >> 2] = i88;
   f2 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
  f1 = Math_fround(f2 * f1);
  HEAPF32[i10 >> 2] = f1;
 }
 i7 = i65 + 892 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (HEAP8[i3 + 4 >> 0] | 0) {
  __ZNK11MinMaxCurve10FindMinMaxEv(i60, i3 + 8 | 0);
  i88 = HEAP32[i60 + 4 >> 2] | 0;
  HEAP32[i61 >> 2] = i88;
  f2 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (HEAP8[i9 >> 0] | 0) {
   __ZNK11MinMaxCurve10FindMinMaxEv(i62, (HEAP32[i7 >> 2] | 0) + 272 | 0);
   i60 = i62 + 4 | 0;
   i88 = f2 < Math_fround(HEAPF32[i60 >> 2]);
   i60 = HEAP32[(i88 ? i60 : i61) >> 2] | 0;
   HEAP32[i61 >> 2] = i60;
   __ZNK11MinMaxCurve10FindMinMaxEv(i62, (HEAP32[i7 >> 2] | 0) + 536 | 0);
   i88 = i62 + 4 | 0;
   f2 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i62 = f2 < Math_fround(HEAPF32[i88 >> 2]);
   i88 = HEAP32[(i62 ? i88 : i61) >> 2] | 0;
   HEAP32[i61 >> 2] = i88;
   f2 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
  f1 = Math_fround(f2 * f1);
  HEAPF32[i10 >> 2] = f1;
 }
 i88 = i66 + 392 | 0;
 i62 = f1 < Math_fround(HEAPF32[i88 >> 2]);
 i88 = HEAP32[(i62 ? i88 : i10) >> 2] | 0;
 HEAP32[i63 >> 2] = i88;
 f1 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i64 | 0) == 4) {
  f2 = Math_fround(HEAPF32[i70 + 340 + 64 >> 2]);
  if (f2 != Math_fround(0.0)) {
   f1 = Math_fround(f1 * f2);
   HEAPF32[i10 >> 2] = f1;
  }
 }
 if ((HEAP32[(HEAP32[i65 + 36 >> 2] | 0) + 280 >> 2] | 0) == 1) {
  i88 = HEAP32[i56 >> 2] | 0;
  f86 = Math_fround(HEAPF32[i88 + 320 >> 2]);
  f85 = Math_fround(HEAPF32[i88 + 324 >> 2]);
  f87 = Math_fround(HEAPF32[i88 + 316 >> 2]);
  f86 = f86 < f85 ? f85 : f86;
  f1 = Math_fround(f1 * (f87 < f86 ? f86 : f87));
  HEAPF32[i10 >> 2] = f1;
 }
 f6 = Math_fround(Math_fround(HEAPF32[i72 >> 2]) - f1);
 HEAPF32[i72 >> 2] = f6;
 i7 = i66 + 372 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f1);
 HEAPF32[i7 >> 2] = f8;
 i3 = i66 + 376 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f1);
 HEAPF32[i3 >> 2] = f2;
 f4 = Math_fround(f1 + Math_fround(HEAPF32[i67 >> 2]));
 HEAPF32[i67 >> 2] = f4;
 f5 = Math_fround(f1 + Math_fround(HEAPF32[i68 >> 2]));
 HEAPF32[i68 >> 2] = f5;
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i69 >> 2]));
 HEAPF32[i69 >> 2] = f1;
 if (!i71) {
  STACKTOP = i73;
  return;
 }
 f87 = Math_fround(Math_abs(Math_fround(HEAPF32[i70 + 376 >> 2])));
 f86 = Math_fround(Math_abs(Math_fround(HEAPF32[i70 + 380 >> 2])));
 f85 = Math_fround(Math_abs(Math_fround(HEAPF32[i70 + 384 >> 2])));
 f86 = f86 < f85 ? f85 : f86;
 f87 = f87 < f86 ? f86 : f87;
 HEAPF32[i72 >> 2] = Math_fround(f6 - f87);
 HEAPF32[i7 >> 2] = Math_fround(f8 - f87);
 HEAPF32[i3 >> 2] = Math_fround(f2 - f87);
 HEAPF32[i67 >> 2] = Math_fround(f87 + f4);
 HEAPF32[i68 >> 2] = Math_fround(f87 + f5);
 HEAPF32[i69 >> 2] = Math_fround(f87 + f1);
 STACKTOP = i73;
 return;
}

function __ZN5Umbra15PortalRayTracer5traceEv(i123) {
 i123 = i123 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, f151 = f0, f152 = f0, f153 = f0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, f205 = f0, f206 = f0, f207 = f0, f208 = f0;
 i162 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i124 = i162 + 208 | 0;
 i132 = i162 + 192 | 0;
 i134 = i162 + 188 | 0;
 i135 = i162 + 184 | 0;
 i138 = i162 + 160 | 0;
 i140 = i162;
 i149 = i162 + 148 | 0;
 i155 = i162 + 136 | 0;
 i156 = i162 + 120 | 0;
 i125 = i162 + 104 | 0;
 i126 = i162 + 80 | 0;
 i127 = i162 + 56 | 0;
 i128 = i162 + 92 | 0;
 i129 = i162 + 68 | 0;
 i130 = i162 + 44 | 0;
 i131 = i162 + 32 | 0;
 i158 = HEAP32[i123 >> 2] | 0;
 i144 = HEAP32[i123 + 84 >> 2] | 0;
 HEAP32[i124 >> 2] = i158;
 i121 = HEAP32[i123 + 4 >> 2] | 0;
 HEAP32[i124 + 4 >> 2] = i121;
 i122 = HEAP32[i123 + 8 >> 2] | 0;
 HEAP32[i124 + 8 >> 2] = i122;
 i154 = HEAP32[i123 + 12 >> 2] | 0;
 HEAP32[i124 + 12 >> 2] = i154;
 i133 = i124 + 16 | 0;
 _memset(i133 | 0, 0, 152) | 0;
 i160 = HEAP32[HEAP32[i158 >> 2] >> 2] | 0;
 i157 = HEAP32[i160 + 136 >> 2] | 0;
 i137 = (HEAP32[i160 + 144 >> 2] | 0) + 1 | 0;
 i139 = i158 + 4 | 0;
 HEAP32[i124 + 168 >> 2] = i139;
 i1 = i158 + 44 | 0;
 i159 = i124 + 180 | 0;
 HEAP32[i159 >> 2] = i1;
 i158 = i158 + 48 | 0;
 i141 = HEAP32[i158 >> 2] | 0;
 i161 = i124 + 184 | 0;
 HEAP32[i161 >> 2] = i141;
 i136 = i124 + 188 | 0;
 HEAP32[i136 >> 2] = 4;
 HEAP32[i124 + 200 >> 2] = i137;
 i137 = i124 + 172 | 0;
 HEAP32[i137 >> 2] = (i157 | 0) == 0 ? 0 : i160 + i157 | 0;
 HEAP32[i124 + 204 >> 2] = i139;
 i157 = i124 + 216 | 0;
 HEAP32[i157 >> 2] = i1;
 i160 = i124 + 220 | 0;
 HEAP32[i160 >> 2] = i141 + 1;
 HEAP32[i124 + 224 >> 2] = 36;
 HEAP32[i124 + 240 >> 2] = i139;
 i139 = i124 + 252 | 0;
 HEAP32[i139 >> 2] = i1;
 HEAP32[i158 >> 2] = i141 + 3;
 i158 = i124 + 256 | 0;
 HEAP32[i158 >> 2] = i141 + 2;
 HEAP32[i124 + 260 >> 2] = 8;
 i141 = i124 + 288 | 0;
 HEAP32[i141 >> 2] = 0;
 HEAP32[i141 + 4 >> 2] = 0;
 HEAP32[i141 + 8 >> 2] = 0;
 HEAP32[i141 + 12 >> 2] = 0;
 i142 = i124 + 308 | 0;
 HEAP32[i142 >> 2] = 0;
 HEAP32[i142 + 4 >> 2] = 0;
 HEAP32[i142 + 8 >> 2] = 0;
 HEAP32[i142 + 12 >> 2] = 0;
 HEAP32[i142 + 16 >> 2] = 0;
 HEAP32[i142 + 20 >> 2] = 0;
 HEAP32[i142 + 24 >> 2] = 0;
 HEAP32[i142 + 28 >> 2] = 0;
 i143 = i124 + 344 | 0;
 HEAP32[i143 >> 2] = i144;
 HEAP32[i124 + 348 >> 2] = -1;
 HEAP32[i124 + 352 >> 2] = -1;
 i144 = i124 + 356 | 0;
 HEAP32[i144 >> 2] = 0;
 i145 = i124 + 360 | 0;
 HEAP32[i145 >> 2] = 0;
 i146 = i124 + 364 | 0;
 HEAP32[i146 >> 2] = 0;
 i147 = i124 + 380 | 0;
 HEAP32[i147 >> 2] = 0;
 i148 = i124 + 384 | 0;
 HEAP32[i148 >> 2] = 0;
 i150 = i124 + 392 | 0;
 HEAP32[i150 >> 2] = 0;
 HEAP32[i150 + 4 >> 2] = 0;
 HEAP32[i150 + 8 >> 2] = 0;
 HEAP32[i150 + 12 >> 2] = 0;
 f151 = (HEAP32[tempDoublePtr >> 2] = i121, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f152 = (HEAP32[tempDoublePtr >> 2] = i122, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f153 = (HEAP32[tempDoublePtr >> 2] = i154, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i154 = i123 + 4364 | 0;
 if (!(HEAP32[i154 >> 2] | 0)) i55 = 97; else {
  i100 = i132 + 4 | 0;
  i101 = i123 + 88 | 0;
  i102 = i132 + 8 | 0;
  i103 = i126 + 4 | 0;
  i104 = i126 + 8 | 0;
  i105 = i127 + 4 | 0;
  i106 = i127 + 8 | 0;
  i107 = i123 + 208 | 0;
  i108 = i123 + 236 | 0;
  i109 = i124 + 284 | 0;
  i110 = i124 + 300 | 0;
  i111 = i124 + 304 | 0;
  i112 = i124 + 292 | 0;
  i113 = i124 + 280 | 0;
  i114 = i128 + 4 | 0;
  i115 = i128 + 8 | 0;
  i116 = i129 + 4 | 0;
  i117 = i129 + 8 | 0;
  i118 = i124 + 408 | 0;
  i119 = i124 + 28 | 0;
  i120 = i130 + 4 | 0;
  i121 = i130 + 8 | 0;
  i122 = i131 + 4 | 0;
  i57 = i131 + 8 | 0;
  i58 = i124 + 328 | 0;
  i59 = i124 + 336 | 0;
  i60 = i124 + 340 | 0;
  i61 = i124 + 320 | 0;
  i62 = i124 + 324 | 0;
  i63 = i124 + 316 | 0;
  i64 = i124 + 312 | 0;
  i65 = i124 + 332 | 0;
  i66 = i123 + 4372 | 0;
  i67 = i123 + 4388 | 0;
  i68 = i140 + 28 | 0;
  i69 = i123 + 4408 | 0;
  i70 = i138 + 4 | 0;
  i71 = i138 + 8 | 0;
  i72 = i138 + 12 | 0;
  i73 = i138 + 16 | 0;
  i74 = i138 + 20 | 0;
  i75 = i123 + 16 | 0;
  i76 = i123 + 264 | 0;
  i77 = i149 + 4 | 0;
  i78 = i149 + 8 | 0;
  i79 = i155 + 4 | 0;
  i80 = i155 + 8 | 0;
  i81 = i123 + 248 | 0;
  i82 = i123 + 252 | 0;
  i83 = i123 + 256 | 0;
  i84 = i123 + 260 | 0;
  i85 = i140 + 4 | 0;
  i86 = i140 + 8 | 0;
  i87 = i140 + 12 | 0;
  i88 = i140 + 16 | 0;
  i89 = i88 + 4 | 0;
  i90 = i88 + 8 | 0;
  i91 = i88 + 12 | 0;
  i92 = i156 + 4 | 0;
  i93 = i156 + 8 | 0;
  i94 = i156 + 12 | 0;
  i95 = i125 + 4 | 0;
  i96 = i125 + 8 | 0;
  i97 = i125 + 12 | 0;
  i98 = i140 + 16 | 0;
  i99 = i123 + 4424 | 0;
  i1 = HEAP32[i154 >> 2] | 0;
  do {
   i56 = i1 + -1 | 0;
   HEAP32[i154 >> 2] = i56;
   i56 = i123 + 268 + (i56 << 4) | 0;
   HEAP32[i132 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i132 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i132 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i132 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   i56 = HEAP32[i132 >> 2] | 0;
   __ZN5Umbra18CellGraphTraversal12prefetchNodeERKNS_10PortalNodeE(i124, i100);
   if (__ZN5Umbra18CellGraphTraversal9enterNodeERKNS_10PortalNodeE(i124, i100) | 0) {
    i6 = HEAP32[i101 >> 2] | 0;
    i4 = HEAP32[i6 + 8 >> 2] | 0;
    if (i4 | 0) {
     i1 = HEAP32[i147 >> 2] | 0;
     if ((HEAP32[i1 + 52 >> 2] | 0) >>> 0 < 65536) i3 = -1; else i3 = HEAP32[i1 + (HEAP32[i1 + 56 >> 2] | 0) + ((HEAP32[i102 >> 2] | 0) * 36 | 0) + 16 >> 2] | 0;
     i16 = (HEAP32[i6 + 20 >> 2] | 0) + (i3 >> 5 << 2) | 0;
     i18 = 1 << (i3 & 31);
     i17 = HEAP32[i16 >> 2] | 0;
     HEAP32[i16 >> 2] = i17 | i18;
     if (!(i17 & i18)) {
      i5 = i4 + 8 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
      if ((i1 | 0) < (HEAP32[i4 + 4 >> 2] | 0)) {
       HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
       i1 = HEAP32[i5 >> 2] | 0;
      }
      HEAP32[i5 >> 2] = i1 + 1;
     }
    }
    if (!(HEAP32[i6 + 4 >> 2] | 0)) {
     if (HEAP32[i6 + 16 >> 2] | 0) i55 = 13;
    } else i55 = 13;
    L19 : do if ((i55 | 0) == 13) while (1) {
     i55 = 0;
     i14 = (HEAP8[i60 >> 0] | 0) == 0;
     i15 = HEAP32[i142 >> 2] | 0;
     i18 = HEAP32[i144 >> 2] | 0;
     i16 = (i18 | 0) == 0;
     i17 = HEAP32[i146 >> 2] | 0;
     i18 = i18 + 8 | 0;
     do {
      i13 = HEAP32[i58 >> 2] | 0;
      if (!i13) break L19;
      i1 = HEAP32[i59 >> 2] | 0;
      do if (!i1) {
       i9 = HEAP32[i61 >> 2] | 0;
       if (i14) {
        i3 = (HEAP32[i62 >> 2] | 0) + i9 | 0;
        i12 = HEAP32[i63 >> 2] | 0;
        i10 = i12 >> 5;
        i1 = i12 & 31;
        i1 = (HEAP32[i15 + (i10 + 1 << 2) >> 2] << 32 - i1 & -1 << (i1 ^ 31) | (HEAP32[i15 + (i10 << 2) >> 2] | 0) >>> i1) & (1 << i3) + -1;
        HEAP32[i63 >> 2] = i12 + i3;
        HEAP32[i64 >> 2] = (HEAP32[i64 >> 2] | 0) - i3;
        i3 = i1 & (1 << i9) + -1;
        HEAP32[i65 >> 2] = i3;
        i1 = i1 >>> i9;
        HEAP32[i59 >> 2] = i1;
        break;
       }
       i6 = HEAP32[i63 >> 2] | 0;
       i5 = i6 >> 5;
       i1 = i6 & 31;
       i3 = (HEAP32[i15 + (i5 << 2) >> 2] | 0) >>> i1;
       i4 = 32 - i1 | 0;
       i5 = HEAP32[i15 + (i5 + 1 << 2) >> 2] << i4;
       if ((i9 | 0) < 32) i3 = (i5 & -1 << (i1 ^ 31) | i3) & (1 << i9) + -1; else i3 = -1 << i4 & 0 - i1 >> 31 & i5 | i3;
       i12 = i6 + i9 | 0;
       HEAP32[i63 >> 2] = i12;
       i9 = (HEAP32[i64 >> 2] | 0) - i9 | 0;
       HEAP32[i64 >> 2] = i9;
       HEAP32[i65 >> 2] = i3;
       i10 = HEAP32[i62 >> 2] | 0;
       i6 = i12 >> 5;
       i1 = i12 & 31;
       i4 = (HEAP32[i15 + (i6 << 2) >> 2] | 0) >>> i1;
       i5 = 32 - i1 | 0;
       i6 = HEAP32[i15 + (i6 + 1 << 2) >> 2] << i5;
       if ((i10 | 0) < 32) i1 = (i6 & -1 << (i1 ^ 31) | i4) & (1 << i10) + -1; else i1 = -1 << i5 & 0 - i1 >> 31 & i6 | i4;
       HEAP32[i63 >> 2] = i10 + i12;
       HEAP32[i64 >> 2] = i9 - i10;
       HEAP32[i59 >> 2] = i1;
      } else i3 = HEAP32[i65 >> 2] | 0; while (0);
      HEAP32[i58 >> 2] = i13 + -1;
      HEAP32[i59 >> 2] = i1 + -1;
      HEAP32[i65 >> 2] = i3 + 1;
      if (i16) i10 = i3; else i10 = HEAP32[i17 + (HEAP32[i18 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      i12 = i10 >> 5;
      i13 = 1 << (i10 & 31);
     } while ((HEAP32[(HEAP32[(HEAP32[i101 >> 2] | 0) + 12 >> 2] | 0) + (i12 << 2) >> 2] & i13 | 0) != 0);
     HEAPF32[i134 >> 2] = Math_fround(0.0);
     HEAPF32[i135 >> 2] = Math_fround(0.0);
     HEAP32[i138 >> 2] = 0;
     HEAP32[i138 + 4 >> 2] = 0;
     HEAP32[i138 + 8 >> 2] = 0;
     HEAP32[i138 + 12 >> 2] = 0;
     HEAP32[i138 + 16 >> 2] = 0;
     HEAP32[i138 + 20 >> 2] = 0;
     i1 = (HEAP32[i66 >> 2] | 0) + (Math_imul(HEAP32[i67 >> 2] | 0, i10) | 0) | 0;
     HEAP32[i138 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i138 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i138 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i138 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i138 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i138 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i140 >> 2] = 0;
     HEAP32[i140 + 4 >> 2] = 0;
     HEAP32[i140 + 8 >> 2] = 0;
     HEAP32[i140 + 12 >> 2] = 0;
     HEAP32[i140 + 16 >> 2] = 0;
     HEAP32[i140 + 20 >> 2] = 0;
     HEAP32[i140 + 24 >> 2] = 0;
     HEAPF32[i68 >> 2] = Math_fround(3402823469999999843913219.0e14);
     i1 = HEAP32[i69 >> 2] | 0;
     if (i1 | 0) {
      i55 = i1 + (Math_imul(HEAP32[i99 >> 2] | 0, i10) | 0) | 0;
      HEAP32[i140 >> 2] = HEAP32[i55 >> 2];
      HEAP32[i140 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
      HEAP32[i140 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
      HEAP32[i140 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
      HEAP32[i140 + 16 >> 2] = HEAP32[i55 + 16 >> 2];
      HEAP32[i140 + 20 >> 2] = HEAP32[i55 + 20 >> 2];
      HEAP32[i140 + 24 >> 2] = HEAP32[i55 + 24 >> 2];
      HEAP32[i140 + 28 >> 2] = HEAP32[i55 + 28 >> 2];
     }
     i1 = HEAP32[i138 >> 2] | 0;
     i3 = HEAP32[i70 >> 2] | 0;
     i4 = HEAP32[i71 >> 2] | 0;
     i5 = HEAP32[i72 >> 2] | 0;
     i6 = HEAP32[i73 >> 2] | 0;
     i9 = HEAP32[i74 >> 2] | 0;
     i55 = HEAP32[i75 >> 2] | 0;
     f33 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f26 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = Math_fround(f20 - f33);
     f26 = Math_fround(f26 - f7);
     f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
     f32 = Math_fround(HEAPF32[i55 + 64 >> 2]);
     f28 = Math_fround(HEAPF32[i55 + 68 >> 2]);
     f22 = Math_fround(HEAPF32[i55 + 76 >> 2]);
     f11 = Math_fround(f20 * f32);
     f19 = Math_fround(f20 * f28);
     f20 = Math_fround(f20 * f22);
     f31 = Math_fround(HEAPF32[i55 + 80 >> 2]);
     f27 = Math_fround(HEAPF32[i55 + 84 >> 2]);
     f21 = Math_fround(HEAPF32[i55 + 92 >> 2]);
     f24 = Math_fround(f26 * f31);
     f25 = Math_fround(f26 * f27);
     f26 = Math_fround(f26 * f21);
     f29 = Math_fround(HEAPF32[i55 + 96 >> 2]);
     f23 = Math_fround(HEAPF32[i55 + 100 >> 2]);
     f8 = Math_fround(HEAPF32[i55 + 108 >> 2]);
     f30 = Math_fround(f38 * f29);
     f34 = Math_fround(f38 * f23);
     f38 = Math_fround(f38 * f8);
     f32 = Math_fround(f33 * f32);
     f28 = Math_fround(f33 * f28);
     f22 = Math_fround(f33 * f22);
     f31 = Math_fround(f7 * f31);
     f27 = Math_fround(f7 * f27);
     f21 = Math_fround(f7 * f21);
     f29 = Math_fround(f2 * f29);
     f23 = Math_fround(f2 * f23);
     f8 = Math_fround(f2 * f8);
     f2 = Math_fround(HEAPF32[i55 + 112 >> 2]);
     f7 = Math_fround(HEAPF32[i55 + 116 >> 2]);
     f2 = Math_fround(f32 + Math_fround(f31 + Math_fround(f29 + f2)));
     f7 = Math_fround(f28 + Math_fround(f27 + Math_fround(f23 + f7)));
     f8 = Math_fround(f22 + Math_fround(f21 + Math_fround(f8 + Math_fround(HEAPF32[i55 + 124 >> 2]))));
     f11 = Math_fround(f11 + f2);
     f19 = Math_fround(f19 + f7);
     f20 = Math_fround(f20 + f8);
     f21 = Math_fround(f24 + f11);
     f22 = Math_fround(f25 + f19);
     f23 = Math_fround(f26 + f20);
     f24 = Math_fround(f24 + f2);
     f25 = Math_fround(f25 + f7);
     f26 = Math_fround(f26 + f8);
     f27 = Math_fround(f30 + f2);
     f28 = Math_fround(f30 + f11);
     f29 = Math_fround(f30 + f21);
     f30 = Math_fround(f30 + f24);
     f31 = Math_fround(f34 + f7);
     f32 = Math_fround(f34 + f19);
     f33 = Math_fround(f34 + f22);
     f34 = Math_fround(f34 + f25);
     f35 = Math_fround(f38 + f8);
     f36 = Math_fround(f38 + f20);
     f37 = Math_fround(f38 + f23);
     f38 = Math_fround(f38 + f26);
     i55 = f8 == Math_fround(0.0);
     f43 = Math_fround(Math_fround(1.0) / f8);
     f43 = i55 ? Math_fround(1.0) : f43;
     i55 = f20 == Math_fround(0.0);
     f44 = Math_fround(Math_fround(1.0) / f20);
     f44 = i55 ? Math_fround(1.0) : f44;
     i55 = f23 == Math_fround(0.0);
     f45 = Math_fround(Math_fround(1.0) / f23);
     f45 = i55 ? Math_fround(1.0) : f45;
     i55 = f26 == Math_fround(0.0);
     f46 = Math_fround(Math_fround(1.0) / f26);
     f46 = i55 ? Math_fround(1.0) : f46;
     i55 = f35 == Math_fround(0.0);
     f51 = Math_fround(Math_fround(1.0) / f35);
     f51 = i55 ? Math_fround(1.0) : f51;
     i55 = f36 == Math_fround(0.0);
     f52 = Math_fround(Math_fround(1.0) / f36);
     f52 = i55 ? Math_fround(1.0) : f52;
     i55 = f37 == Math_fround(0.0);
     f53 = Math_fround(Math_fround(1.0) / f37);
     f53 = i55 ? Math_fround(1.0) : f53;
     i55 = f38 == Math_fround(0.0);
     f54 = Math_fround(Math_fround(1.0) / f38);
     f54 = i55 ? Math_fround(1.0) : f54;
     f39 = Math_fround(f2 * f43);
     f40 = Math_fround(f11 * f44);
     f41 = Math_fround(f21 * f45);
     f42 = Math_fround(f24 * f46);
     f43 = Math_fround(f7 * f43);
     f44 = Math_fround(f19 * f44);
     f45 = Math_fround(f22 * f45);
     f46 = Math_fround(f25 * f46);
     f47 = Math_fround(f27 * f51);
     f48 = Math_fround(f28 * f52);
     f49 = Math_fround(f29 * f53);
     f50 = Math_fround(f30 * f54);
     f51 = Math_fround(f31 * f51);
     f52 = Math_fround(f32 * f52);
     f53 = Math_fround(f33 * f53);
     f54 = Math_fround(f34 * f54);
     if (!((f26 <= f38 ? f26 : f38) < Math_fround(0.0)) & (((f8 <= f35 ? f8 : f35) < Math_fround(0.0) ? 0 : !((f20 <= f36 ? f20 : f36) < Math_fround(0.0))) & !((f23 <= f37 ? f23 : f37) < Math_fround(0.0)))) {
      f35 = f39 <= f47 ? f39 : f47;
      f8 = f40 <= f48 ? f40 : f48;
      f37 = f41 <= f49 ? f41 : f49;
      f2 = f42 <= f50 ? f42 : f50;
      f36 = f43 <= f51 ? f43 : f51;
      f7 = f44 <= f52 ? f44 : f52;
      f38 = f45 <= f53 ? f45 : f53;
      f11 = f46 <= f54 ? f46 : f54;
      f37 = f35 <= f37 ? f35 : f37;
      f38 = f36 <= f38 ? f36 : f38;
      f2 = f8 <= f2 ? f8 : f2;
      f11 = f7 <= f11 ? f7 : f11;
      f47 = f39 >= f47 ? f39 : f47;
      f48 = f40 >= f48 ? f40 : f48;
      f49 = f41 >= f49 ? f41 : f49;
      f7 = f42 >= f50 ? f42 : f50;
      f50 = f43 >= f51 ? f43 : f51;
      f52 = f44 >= f52 ? f44 : f52;
      f51 = f45 >= f53 ? f45 : f53;
      f8 = f46 >= f54 ? f46 : f54;
      f53 = f47 >= f49 ? f47 : f49;
      f54 = f50 >= f51 ? f50 : f51;
      f7 = f48 >= f7 ? f48 : f7;
      f8 = f52 >= f8 ? f52 : f8;
      f2 = f37 <= f2 ? f37 : f2;
      f7 = f53 >= f7 ? f53 : f7;
      f8 = f54 >= f8 ? f54 : f8;
      f11 = f38 <= f11 ? f38 : f11;
     } else {
      f208 = Math_fround(-f8);
      f207 = Math_fround(-f20);
      f206 = Math_fround(-f23);
      f205 = Math_fround(-f26);
      i204 = f2 > f208;
      i202 = f11 > f207;
      i200 = f21 > f206;
      i198 = f24 > f205;
      i195 = f8 > f2;
      i191 = f20 > f11;
      i187 = f23 > f21;
      i183 = f26 > f24;
      i180 = f7 > f208;
      i178 = f19 > f207;
      i176 = f22 > f206;
      i174 = f25 > f205;
      i171 = f8 > f7;
      i167 = f20 > f19;
      i163 = f23 > f22;
      i17 = f26 > f25;
      f8 = Math_fround(-f35);
      f11 = Math_fround(-f36);
      f2 = Math_fround(-f37);
      f7 = Math_fround(-f38);
      i203 = f27 > f8;
      i201 = f28 > f11;
      i199 = f29 > f2;
      i197 = f30 > f7;
      i193 = f35 > f27;
      i189 = f36 > f28;
      i185 = f37 > f29;
      i181 = f38 > f30;
      i179 = f31 > f8;
      i177 = f32 > f11;
      i175 = f33 > f2;
      i173 = f34 > f7;
      i169 = f35 > f31;
      i165 = f36 > f32;
      i15 = f37 > f33;
      i55 = f38 > f34;
      i196 = i195 & i204;
      i192 = i191 & i202;
      i188 = i187 & i200;
      i184 = i183 & i198;
      i172 = i171 & i180;
      i168 = i167 & i178;
      i164 = i163 & i176;
      i16 = i17 & i174;
      i194 = i193 & i203;
      i190 = i189 & i201;
      i186 = i185 & i199;
      i182 = i181 & i197;
      i170 = i169 & i179;
      i166 = i165 & i177;
      i14 = i15 & i175;
      i18 = i55 & i173;
      f7 = i196 ? f39 : Math_fround(1.0);
      f7 = i204 ? f7 : Math_fround(-1.0);
      f36 = i194 ? f47 : Math_fround(1.0);
      f36 = i203 ? f36 : Math_fround(-1.0);
      f36 = f7 <= f36 ? f7 : f36;
      f7 = i192 ? f40 : Math_fround(1.0);
      f7 = i202 ? f7 : Math_fround(-1.0);
      f38 = i190 ? f48 : Math_fround(1.0);
      f38 = i201 ? f38 : Math_fround(-1.0);
      f38 = f7 <= f38 ? f7 : f38;
      f7 = i188 ? f41 : Math_fround(1.0);
      f7 = i200 ? f7 : Math_fround(-1.0);
      f37 = i186 ? f49 : Math_fround(1.0);
      f37 = i199 ? f37 : Math_fround(-1.0);
      f37 = f7 <= f37 ? f7 : f37;
      f7 = i184 ? f42 : Math_fround(1.0);
      f7 = i198 ? f7 : Math_fround(-1.0);
      f2 = i182 ? f50 : Math_fround(1.0);
      f2 = i197 ? f2 : Math_fround(-1.0);
      f2 = f7 <= f2 ? f7 : f2;
      f7 = i196 ? f39 : Math_fround(-1.0);
      f7 = i195 ? f7 : Math_fround(1.0);
      f39 = i194 ? f47 : Math_fround(-1.0);
      f39 = i193 ? f39 : Math_fround(1.0);
      f39 = f7 >= f39 ? f7 : f39;
      f40 = i192 ? f40 : Math_fround(-1.0);
      f40 = i191 ? f40 : Math_fround(1.0);
      f48 = i190 ? f48 : Math_fround(-1.0);
      f48 = i189 ? f48 : Math_fround(1.0);
      f48 = f40 >= f48 ? f40 : f48;
      f40 = i188 ? f41 : Math_fround(-1.0);
      f40 = i187 ? f40 : Math_fround(1.0);
      f47 = i186 ? f49 : Math_fround(-1.0);
      f47 = i185 ? f47 : Math_fround(1.0);
      f47 = f40 >= f47 ? f40 : f47;
      f40 = i184 ? f42 : Math_fround(-1.0);
      f40 = i183 ? f40 : Math_fround(1.0);
      f7 = i182 ? f50 : Math_fround(-1.0);
      f7 = i181 ? f7 : Math_fround(1.0);
      f7 = f40 >= f7 ? f40 : f7;
      f50 = i172 ? f43 : Math_fround(1.0);
      f50 = i180 ? f50 : Math_fround(-1.0);
      f40 = i170 ? f51 : Math_fround(1.0);
      f40 = i179 ? f40 : Math_fround(-1.0);
      f40 = f50 <= f40 ? f50 : f40;
      f50 = i168 ? f44 : Math_fround(1.0);
      f50 = i178 ? f50 : Math_fround(-1.0);
      f42 = i166 ? f52 : Math_fround(1.0);
      f42 = i177 ? f42 : Math_fround(-1.0);
      f42 = f50 <= f42 ? f50 : f42;
      f50 = i164 ? f45 : Math_fround(1.0);
      f50 = i176 ? f50 : Math_fround(-1.0);
      f41 = i14 ? f53 : Math_fround(1.0);
      f41 = i175 ? f41 : Math_fround(-1.0);
      f41 = f50 <= f41 ? f50 : f41;
      f50 = i16 ? f46 : Math_fround(1.0);
      f50 = i174 ? f50 : Math_fround(-1.0);
      f11 = i18 ? f54 : Math_fround(1.0);
      f11 = i173 ? f11 : Math_fround(-1.0);
      f11 = f50 <= f11 ? f50 : f11;
      f50 = i172 ? f43 : Math_fround(-1.0);
      f50 = i171 ? f50 : Math_fround(1.0);
      f49 = i170 ? f51 : Math_fround(-1.0);
      f49 = i169 ? f49 : Math_fround(1.0);
      f49 = f50 >= f49 ? f50 : f49;
      f51 = i168 ? f44 : Math_fround(-1.0);
      f51 = i167 ? f51 : Math_fround(1.0);
      f50 = i166 ? f52 : Math_fround(-1.0);
      f50 = i165 ? f50 : Math_fround(1.0);
      f50 = f51 >= f50 ? f51 : f50;
      f51 = i164 ? f45 : Math_fround(-1.0);
      f51 = i163 ? f51 : Math_fround(1.0);
      f53 = i14 ? f53 : Math_fround(-1.0);
      f53 = i15 ? f53 : Math_fround(1.0);
      f53 = f51 >= f53 ? f51 : f53;
      f51 = i16 ? f46 : Math_fround(-1.0);
      f51 = i17 ? f51 : Math_fround(1.0);
      f8 = i18 ? f54 : Math_fround(-1.0);
      f8 = i55 ? f8 : Math_fround(1.0);
      f8 = f51 >= f8 ? f51 : f8;
      f51 = f36 <= f37 ? f36 : f37;
      f54 = f40 <= f41 ? f40 : f41;
      f2 = f38 <= f2 ? f38 : f2;
      f11 = f42 <= f11 ? f42 : f11;
      f52 = f39 >= f47 ? f39 : f47;
      f53 = f49 >= f53 ? f49 : f53;
      f7 = f48 >= f7 ? f48 : f7;
      f8 = f50 >= f8 ? f50 : f8;
      f2 = f51 <= f2 ? f51 : f2;
      f7 = f52 >= f7 ? f52 : f7;
      f8 = f53 >= f8 ? f53 : f8;
      f11 = f54 <= f11 ? f54 : f11;
     }
     i204 = f2 <= Math_fround(1.0);
     f207 = i204 ? f2 : Math_fround(1.0);
     i204 = f11 <= Math_fround(1.0);
     f11 = i204 ? f11 : Math_fround(1.0);
     i204 = f7 <= Math_fround(1.0);
     f206 = i204 ? f7 : Math_fround(1.0);
     i204 = f8 <= Math_fround(1.0);
     f208 = i204 ? f8 : Math_fround(1.0);
     i204 = f207 >= Math_fround(-1.0);
     f207 = i204 ? f207 : Math_fround(-1.0);
     i204 = f11 >= Math_fround(-1.0);
     f11 = i204 ? f11 : Math_fround(-1.0);
     i204 = f206 >= Math_fround(-1.0);
     f206 = i204 ? f206 : Math_fround(-1.0);
     i204 = f208 >= Math_fround(-1.0);
     f11 = Math_fround(Math_fround(Math_fround(f206 - f207) * Math_fround((i204 ? f208 : Math_fround(-1.0)) - f11)) * Math_fround(.25));
     do if (f11 >= Math_fround(HEAPF32[i76 >> 2])) {
      HEAP32[i149 >> 2] = HEAP32[i138 >> 2];
      HEAP32[i77 >> 2] = HEAP32[i70 >> 2];
      HEAP32[i78 >> 2] = HEAP32[i71 >> 2];
      HEAP32[i155 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i79 >> 2] = HEAP32[i73 >> 2];
      HEAP32[i80 >> 2] = HEAP32[i74 >> 2];
      if (__ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_(i123, i149, i155, i134, i135, i107) | 0) {
       f207 = Math_fround(HEAPF32[i81 >> 2]);
       f208 = Math_fround(HEAPF32[i82 >> 2]);
       f206 = Math_fround(HEAPF32[i83 >> 2]);
       f205 = Math_fround(HEAPF32[i84 >> 2]);
       f54 = Math_fround(HEAPF32[i140 >> 2]);
       f8 = Math_fround(HEAPF32[i85 >> 2]);
       f53 = Math_fround(HEAPF32[i86 >> 2]);
       f2 = Math_fround(HEAPF32[i87 >> 2]);
       f50 = Math_fround(HEAPF32[i88 >> 2]);
       f51 = Math_fround(HEAPF32[i89 >> 2]);
       f52 = Math_fround(HEAPF32[i90 >> 2]);
       f7 = Math_fround(HEAPF32[i91 >> 2]);
       f54 = f54 >= f151 ? f54 : f151;
       f8 = f8 >= f152 ? f8 : f152;
       f53 = f53 >= f153 ? f53 : f153;
       f54 = Math_fround((f50 <= f54 ? f50 : f54) - f151);
       f8 = Math_fround((f51 <= f8 ? f51 : f8) - f152);
       f53 = Math_fround((f52 <= f53 ? f52 : f53) - f153);
       f8 = Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(Math_fround(f54 * f54) + Math_fround(f8 * f8))) + Math_fround(0.0));
       f207 = Math_fround(f207 * f8);
       f208 = Math_fround(f208 * f8);
       f206 = Math_fround(f206 * f8);
       f8 = Math_fround(f205 * f8);
       if (!(f206 >= f7 | f2 > f206 | (f207 >= f7 | f2 > f207 | (f208 >= f7 | f2 > f208)))) if (!(f2 > f8) & !(f8 >= f7)) {
        i204 = HEAP32[i75 >> 2] | 0;
        HEAP32[i156 >> 2] = i1;
        HEAP32[i92 >> 2] = i3;
        HEAP32[i93 >> 2] = i4;
        HEAP32[i94 >> 2] = 1065353216;
        HEAP32[i125 >> 2] = i5;
        HEAP32[i95 >> 2] = i6;
        HEAP32[i96 >> 2] = i9;
        HEAP32[i97 >> 2] = 1065353216;
        if (__ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i204, i156, i125) | 0) {
         i5 = HEAP32[i101 >> 2] | 0;
         i3 = (HEAP32[i5 + 12 >> 2] | 0) + (i12 << 2) | 0;
         HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i13;
         i3 = HEAP32[i5 + 4 >> 2] | 0;
         if (i3 | 0) {
          i4 = i3 + 8 | 0;
          i1 = HEAP32[i4 >> 2] | 0;
          if ((i1 | 0) < (HEAP32[i3 + 4 >> 2] | 0)) {
           HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = i10;
           i1 = HEAP32[i4 >> 2] | 0;
          }
          HEAP32[i4 >> 2] = i1 + 1;
         }
         i204 = HEAP32[i5 + 16 >> 2] | 0;
         i1 = i204 + (i12 << 2) | 0;
         if (i204 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i13;
         i1 = HEAP32[i5 + 36 >> 2] | 0;
         if (i1 | 0) {
          i3 = (HEAP32[i69 >> 2] | 0) != 0;
          i4 = i3 ? i140 : i138;
          f2 = Math_fround(HEAPF32[i4 >> 2]);
          f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
          f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
          i3 = i3 ? i98 : i72;
          f206 = Math_fround(HEAPF32[i3 >> 2]);
          f207 = Math_fround(HEAPF32[i3 + 4 >> 2]);
          f208 = Math_fround(HEAPF32[i3 + 8 >> 2]);
          f2 = f2 >= f151 ? f2 : f151;
          f7 = f7 >= f152 ? f7 : f152;
          f8 = f8 >= f153 ? f8 : f153;
          f2 = Math_fround((f206 <= f2 ? f206 : f2) - f151);
          f7 = Math_fround((f207 <= f7 ? f207 : f7) - f152);
          f8 = Math_fround((f208 <= f8 ? f208 : f8) - f153);
          i3 = i5 + 44 | 0;
          i4 = HEAP32[i3 >> 2] | 0;
          if ((i4 | 0) < (HEAP32[i5 + 40 >> 2] | 0)) HEAPF32[i1 + (i4 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f2 * f2) + Math_fround(f7 * f7))) + Math_fround(0.0));
          HEAP32[i3 >> 2] = i4 + 1;
         }
         i1 = HEAP32[i5 + 52 >> 2] | 0;
         if (!i1) break;
         i3 = i5 + 60 | 0;
         i4 = HEAP32[i3 >> 2] | 0;
         if ((i4 | 0) < (HEAP32[i5 + 56 >> 2] | 0)) HEAPF32[i1 + (i4 << 2) >> 2] = f11;
         HEAP32[i3 >> 2] = i4 + 1;
        }
       }
      }
     } while (0);
     i55 = 13;
    } while (0);
    i201 = HEAP32[i147 >> 2] | 0;
    i204 = HEAP32[i102 >> 2] | 0;
    i200 = i201 + (HEAP32[i201 + 56 >> 2] | 0) | 0;
    i202 = HEAP32[i200 + (i204 * 36 | 0) + 24 >> 2] | 0;
    i203 = HEAP32[i200 + (i204 * 36 | 0) + 28 >> 2] | 0;
    i204 = HEAP32[i200 + (i204 * 36 | 0) + 32 >> 2] | 0;
    f49 = Math_fround(HEAPF32[i201 >> 2]);
    f51 = Math_fround(HEAPF32[i201 + 4 >> 2]);
    f53 = Math_fround(HEAPF32[i201 + 8 >> 2]);
    f48 = Math_fround(HEAPF32[i201 + 12 >> 2]);
    f50 = Math_fround(HEAPF32[i201 + 16 >> 2]);
    f52 = Math_fround(HEAPF32[i201 + 20 >> 2]);
    f54 = Math_fround(i202 >>> 16 | 0);
    f205 = Math_fround(i202 & 65535 | 0);
    f206 = Math_fround(i203 >>> 16 | 0);
    f207 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
    f54 = Math_fround(f54 * f207);
    f208 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
    f205 = Math_fround(f205 * f208);
    f2 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
    f206 = Math_fround(f206 * f2);
    f207 = Math_fround(Math_fround(i203 & 65535 | 0) * f207);
    f208 = Math_fround(Math_fround(i204 >>> 16 | 0) * f208);
    f2 = Math_fround(Math_fround(i204 & 65535 | 0) * f2);
    f54 = Math_fround(Math_fround(f48 * f54) + Math_fround(f49 * Math_fround(Math_fround(1.0) - f54)));
    f207 = Math_fround(Math_fround(f48 * f207) + Math_fround(f49 * Math_fround(Math_fround(1.0) - f207)));
    f205 = Math_fround(Math_fround(f50 * f205) + Math_fround(f51 * Math_fround(Math_fround(1.0) - f205)));
    f208 = Math_fround(Math_fround(f50 * f208) + Math_fround(f51 * Math_fround(Math_fround(1.0) - f208)));
    f206 = Math_fround(Math_fround(f52 * f206) + Math_fround(f53 * Math_fround(Math_fround(1.0) - f206)));
    f2 = Math_fround(Math_fround(f52 * f2) + Math_fround(f53 * Math_fround(Math_fround(1.0) - f2)));
    HEAPF32[i134 >> 2] = Math_fround(0.0);
    HEAPF32[i135 >> 2] = Math_fround(0.0);
    HEAPF32[i126 >> 2] = f54;
    HEAPF32[i103 >> 2] = f205;
    HEAPF32[i104 >> 2] = f206;
    HEAPF32[i127 >> 2] = f207;
    HEAPF32[i105 >> 2] = f208;
    HEAPF32[i106 >> 2] = f2;
    __ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_(i123, i126, i127, i134, i135, i107) | 0;
    f2 = Math_fround(HEAPF32[i135 >> 2]);
    if (f2 > Math_fround(HEAPF32[i108 >> 2])) HEAPF32[i108 >> 2] = f2;
    i1 = HEAP32[i109 >> 2] | 0;
    i3 = HEAP32[i110 >> 2] | 0;
    L81 : do if ((i3 | 0) != (0 - i1 | 0)) {
     L82 : while (1) {
      while (1) {
       if (!i1) {
        HEAP8[i111 >> 0] = 1;
        i12 = HEAP32[i112 >> 2] | 0;
        i12 = (i12 | 0) == 0 ? 0 : (HEAP32[i141 >> 2] | 0) + i12 | 0;
        HEAP32[i113 >> 2] = i12;
        HEAP32[i141 >> 2] = 0;
        HEAP32[i141 + 4 >> 2] = 0;
        HEAP32[i141 + 8 >> 2] = 0;
        HEAP32[i141 + 12 >> 2] = 0;
        i10 = (i12 | 0) == 0 ? 0 : i3;
        i3 = 0;
       } else {
        i10 = i1;
        i12 = HEAP32[i113 >> 2] | 0;
       }
       i1 = i10 + -1 | 0;
       HEAP32[i113 >> 2] = i12 + 16;
       i4 = HEAP32[i12 >> 2] | 0;
       i5 = (i4 & 134217728 | 0) == 0;
       if (i5) {
        i6 = HEAP32[i12 + 4 >> 2] & 65535;
        i9 = HEAP32[i150 + (i4 >>> 30 << 2) >> 2] | 0;
        if ((i6 | 0) == (i9 | 0)) i55 = 65; else if ((i4 & 67108864 | 0) == 0 ? ((i6 | 0) < (i9 | 0) | 0) == (i4 >>> 29 & 1 ^ 1 | 0) : 0) break;
       } else i55 = 65;
       if ((i55 | 0) == 65) {
        i55 = 0;
        if (!(i4 & 67108864)) break;
       }
       if ((i3 | 0) == (1 - i10 | 0)) break L82;
      }
      HEAP32[i109 >> 2] = i1;
      HEAP32[i138 >> 2] = i56;
      HEAPF32[i140 >> 2] = Math_fround(0.0);
      if (i5) {
       HEAPF32[i128 >> 2] = Math_fround(0.0);
       HEAPF32[i114 >> 2] = Math_fround(0.0);
       HEAPF32[i115 >> 2] = Math_fround(0.0);
       HEAPF32[i129 >> 2] = Math_fround(0.0);
       HEAPF32[i116 >> 2] = Math_fround(0.0);
       HEAPF32[i117 >> 2] = Math_fround(0.0);
       f205 = Math_fround(HEAPF32[i118 >> 2]);
       i204 = i4 >>> 30;
       f53 = Math_fround(HEAP32[i12 + 4 >> 2] & 65535 | 0);
       f52 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
       f53 = Math_fround(f52 * f53);
       f208 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
       f54 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
       f207 = Math_fround(HEAPF32[gb + 1451432 + 12 >> 2]);
       i202 = HEAP32[i12 + 8 >> 2] | 0;
       i203 = HEAP32[i12 + 12 >> 2] | 0;
       f52 = Math_fround(f52 * Math_fround(i202 >>> 16 | 0));
       f208 = Math_fround(f208 * Math_fround(i202 & 65535 | 0));
       f54 = Math_fround(f54 * Math_fround(i203 >>> 16 | 0));
       f207 = Math_fround(f207 * Math_fround(i203 & 65535 | 0));
       f206 = Math_fround(HEAPF32[i133 + (i204 << 2) >> 2]);
       f53 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f53) * f206) + Math_fround(f53 * Math_fround(HEAPF32[i119 + (i204 << 2) >> 2])));
       HEAPF32[i129 + (i204 << 2) >> 2] = f53;
       HEAPF32[i128 + (i204 << 2) >> 2] = f53;
       i204 = ((i204 + 1 | 0) >>> 0) % 3 | 0;
       f53 = Math_fround(HEAPF32[i133 + (i204 << 2) >> 2]);
       f206 = Math_fround(HEAPF32[i119 + (i204 << 2) >> 2]);
       HEAPF32[i128 + (i204 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f52) * f53) + Math_fround(f52 * f206)) - f205);
       HEAPF32[i129 + (i204 << 2) >> 2] = Math_fround(f205 + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f208) * f53) + Math_fround(f208 * f206)));
       i204 = ((i204 + 1 | 0) >>> 0) % 3 | 0;
       f206 = Math_fround(HEAPF32[i133 + (i204 << 2) >> 2]);
       f208 = Math_fround(HEAPF32[i119 + (i204 << 2) >> 2]);
       HEAPF32[i128 + (i204 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f54) * f206) + Math_fround(f54 * f208)) - f205);
       HEAPF32[i129 + (i204 << 2) >> 2] = Math_fround(f205 + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f207) * f206) + Math_fround(f207 * f208)));
       HEAP32[i130 >> 2] = HEAP32[i128 >> 2];
       HEAP32[i120 >> 2] = HEAP32[i114 >> 2];
       HEAP32[i121 >> 2] = HEAP32[i115 >> 2];
       HEAP32[i131 >> 2] = HEAP32[i129 >> 2];
       HEAP32[i122 >> 2] = HEAP32[i116 >> 2];
       HEAP32[i57 >> 2] = HEAP32[i117 >> 2];
       if (__ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_(i123, i130, i131, i138, i140, i107) | 0) {
        i4 = HEAP32[i12 >> 2] | 0;
        i55 = 69;
       }
      } else i55 = 69;
      L100 : do if ((i55 | 0) == 69) {
       i55 = 0;
       if (i4 & 268435456 | 0) {
        i1 = HEAP32[i148 >> 2] | 0;
        if (!i1) i1 = 63; else i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!(i1 & 1 << (i4 >>> 29))) break;
        HEAPF32[i108 >> 2] = Math_fround(1.0);
        break;
       }
       i6 = HEAP32[i123 >> 2] | 0;
       i17 = HEAP32[i143 >> 2] | 0;
       i14 = HEAP32[i12 + 4 >> 2] | 0;
       i5 = HEAP32[i12 + 8 >> 2] | 0;
       i15 = HEAP32[i137 >> 2] | 0;
       i16 = HEAP32[i136 >> 2] | 0;
       i1 = i4 & 67108863;
       if (!(HEAP8[i111 >> 0] | 0)) {
        i3 = HEAP32[i144 >> 2] | 0;
        if (!i3) i13 = i1; else i13 = HEAP32[(HEAP32[i146 >> 2] | 0) + (HEAP32[i3 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
       } else i13 = i1;
       L113 : do if (i4 & 134217728 | 0) {
        i12 = i5 & 4095;
        if (i12 | 0) {
         i10 = HEAP32[i145 >> 2] | 0;
         i9 = i5 >>> 12;
         i10 = i10 + (HEAP32[i10 + 120 >> 2] | 0) | 0;
         i204 = HEAP32[i144 >> 2] | 0;
         i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
         i1 = (i5 | 0) == 0;
         i3 = HEAP32[i146 >> 2] | 0;
         i4 = i204 + 16 | 0;
         if (!i204) {
          if (i1) break; else i1 = 0;
          while (1) {
           i3 = HEAP32[i10 + (i1 + i9 << 2) >> 2] | 0;
           if ((i3 | 0) >= 0) if (!(HEAP32[i5 + (i3 >> 5 << 2) >> 2] & 1 << (i3 & 31))) break L100;
           i1 = i1 + 1 | 0;
           if ((i1 | 0) >= (i12 | 0)) break L113;
          }
         }
         if (!i1) {
          i3 = i3 + (HEAP32[i4 >> 2] | 0) | 0;
          i1 = 0;
          do {
           i4 = HEAP32[i3 + (HEAP32[i10 + (i1 + i9 << 2) >> 2] << 2) >> 2] | 0;
           if ((i4 | 0) >= 0) if (!(HEAP32[i5 + (i4 >> 5 << 2) >> 2] & 1 << (i4 & 31))) break L100;
           i1 = i1 + 1 | 0;
          } while ((i1 | 0) < (i12 | 0));
         }
        }
       } while (0);
       i4 = i14 >>> 16;
       i3 = (HEAP32[i15 + (Math_imul(i13, i16) | 0) >> 2] | 0) + i4 | 0;
       if (!(1 << (i3 & 31) & HEAP32[i17 + (i3 >> 5 << 2) >> 2])) {
        i1 = HEAP32[i154 >> 2] | 0;
        if ((i1 | 0) < 256) {
         HEAP32[i154 >> 2] = i1 + 1;
         HEAP32[i123 + 268 + (i1 << 4) + 4 >> 2] = i13;
         HEAP32[i123 + 268 + (i1 << 4) + 8 >> 2] = i4;
         HEAP32[i123 + 268 + (i1 << 4) + 12 >> 2] = i3;
         HEAP32[i123 + 268 + (i1 << 4) >> 2] = HEAP32[i138 >> 2];
        }
       }
      } while (0);
      i1 = HEAP32[i109 >> 2] | 0;
      i3 = HEAP32[i110 >> 2] | 0;
      if ((i3 | 0) == (0 - i1 | 0)) break L81;
     }
     HEAP32[i109 >> 2] = i1;
    } while (0);
   }
   i1 = HEAP32[i154 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i1 = HEAP32[i139 >> 2] | 0;
  if (i1 | 0) i55 = 97;
 }
 if ((i55 | 0) == 97) HEAP32[i1 + 4 >> 2] = HEAP32[i158 >> 2];
 i1 = HEAP32[i157 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i160 >> 2];
 i1 = HEAP32[i159 >> 2] | 0;
 if (!i1) {
  STACKTOP = i162;
  return;
 }
 HEAP32[i1 + 4 >> 2] = HEAP32[i161 >> 2];
 STACKTOP = i162;
 return;
}

function __ZN14CompressedMesh10DecompressER4Mesh(i36, i33) {
 i36 = i36 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i40;
 i38 = i40 + 36 | 0;
 i23 = i40 + 56 | 0;
 i39 = i40 + 16 | 0;
 i37 = HEAP32[i36 >> 2] | 0;
 i3 = (i37 | 0) / 3 | 0;
 do if ((i37 | 0) == (i3 * 3 | 0)) {
  i28 = i36 + 56 | 0;
  i1 = HEAP32[i28 >> 2] | 0;
  if (i1 | 0) {
   if ((i1 | 0) != (i3 << 1 | 0)) break;
   if ((HEAP32[i36 + 84 >> 2] | 0) != (i3 | 0)) break;
  }
  i29 = i36 + 104 | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 << 1;
   if ((i1 | 0) != (i2 | 0)) break;
   if ((HEAP32[i36 + 132 >> 2] | 0) != (i2 | 0)) break;
  }
  i31 = i36 + 152 | 0;
  i37 = HEAP32[i31 >> 2] | 0;
  if ((i37 | 0) == 0 | (i37 | 0) == (i3 << 2 | 0)) {
   i16 = i36 + 220 | 0;
   i37 = i33 + 32 | 0;
   i11 = HEAP32[i37 >> 2] | 0;
   i3 = i11 + 112 | 0;
   i4 = HEAP32[i16 >> 2] << 1;
   i9 = i11 + 116 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = i2 - i1 | 0;
   i8 = i1;
   i10 = i2;
   if (i4 >>> 0 > i5 >>> 0) {
    __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i3, i4 - i5 | 0);
    i11 = HEAP32[i37 >> 2] | 0;
    i2 = HEAP32[i11 + 116 >> 2] | 0;
    i1 = HEAP32[i11 + 112 >> 2] | 0;
   } else if (i4 >>> 0 < i5 >>> 0) {
    i3 = i8 + i4 | 0;
    if ((i10 | 0) != (i3 | 0)) {
     HEAP32[i9 >> 2] = i3;
     i2 = i3;
    }
   }
   if ((i2 | 0) == (i1 | 0)) i20 = 0; else i20 = HEAP32[i11 + 112 >> 2] | 0;
   i18 = HEAP8[i36 + 224 >> 0] | 0;
   i19 = _bitshift64Shl(1, 0, i18 & 255 | 0) | 0;
   i19 = _i64Add(i19 | 0, getTempRet0() | 0, 65535, 0) | 0;
   getTempRet0() | 0;
   i9 = HEAP32[i16 >> 2] | 0;
   if (i9 | 0) {
    i10 = i36 + 228 | 0;
    i16 = i18 & 255;
    i8 = 0;
    i3 = 0;
    i2 = 0;
    i1 = i18;
    while (1) {
     i17 = i20 + (i8 << 1) | 0;
     HEAP16[i17 >> 1] = 0;
     if (!(i1 << 24 >> 24)) {
      i4 = i2;
      i1 = 0;
      i2 = 0;
     } else {
      i5 = HEAP32[i10 >> 2] | 0;
      i4 = 0;
      i1 = i2;
      i2 = 0;
      do {
       i2 = (HEAPU8[i5 + i1 >> 0] | 0) >>> i3 << i4 | i2 & 65535;
       HEAP16[i17 >> 1] = i2;
       i34 = i16 - i4 | 0;
       i32 = 8 - i3 | 0;
       i34 = (i32 | 0) < (i34 | 0) ? i32 : i34;
       i3 = i34 + i3 | 0;
       i4 = i34 + i4 | 0;
       i34 = (i3 | 0) == 8;
       i3 = i34 ? 0 : i3;
       i1 = (i34 & 1) + i1 | 0;
      } while ((i4 | 0) < (i16 | 0));
      i4 = i1;
      i1 = i18;
     }
     HEAP16[i17 >> 1] = i2 & i19;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i9 | 0)) break; else i2 = i4;
    }
   }
   i30 = HEAP32[i36 >> 2] | 0;
   i34 = (i30 | 0) / 3 | 0;
   i1 = i23;
   i2 = gb + 1546313 | 0;
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i1 = (i30 | 0) != 0 & 1;
   i1 = (HEAP32[i28 >> 2] | 0) == 0 ? i1 : i1 | 2;
   i3 = HEAP32[i36 + 240 >> 2] | 0;
   if (!i3) {
    i32 = HEAP32[i36 + 28 >> 2] | 0;
    i1 = (i32 | 0) == 0 ? i1 : i1 | 8;
    i1 = (i32 | 0) == (i34 << 2 | 0) ? i1 | 16 : i1;
   } else {
    if (i3 & 4) {
     HEAP8[i23 + 7 >> 0] = (i3 & 3) + 1;
     i1 = i1 | 8;
    }
    i2 = i3 >>> 4;
    if (i2 & 4) {
     HEAP8[i23 + 9 >> 0] = (i2 & 3) + 1;
     i1 = i1 | 16;
    }
    i2 = i3 >>> 8;
    if (i2 & 4) {
     HEAP8[i23 + 11 >> 0] = (i2 & 3) + 1;
     i1 = i1 | 32;
    }
    i2 = i3 >>> 12;
    if (i2 & 4) {
     HEAP8[i23 + 13 >> 0] = (i2 & 3) + 1;
     i1 = i1 | 64;
    }
   }
   i1 = (HEAP32[i29 >> 2] | 0) == 0 ? i1 : i1 | 128;
   i32 = i23 + 4 | 0;
   do if (!(HEAP32[i31 >> 2] | 0)) i22 = i1; else {
    i1 = i1 | 4;
    f7 = Math_fround(HEAPF32[i36 + 160 >> 2]);
    if (!(f7 < Math_fround(0.0))) if (!(Math_fround(f7 + Math_fround(HEAPF32[i36 + 156 >> 2])) > Math_fround(1.0))) {
     i22 = i1;
     break;
    }
    HEAP8[i32 >> 0] = 0;
    i22 = i1;
   } while (0);
   if (!(HEAP32[i11 + 176 >> 2] | 0)) if ((HEAP32[i33 + 116 >> 2] | 0) == (HEAP32[i33 + 112 >> 2] | 0)) {
    __ZNK14VertexDataInfo16GetStreamsLayoutEv(i35, i11 + 8 | 0);
    HEAP32[i35 >> 2] = (HEAP32[i35 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i35 + 8 >> 2] & ~HEAP32[i35 + 12 >> 2];
    HEAP32[i38 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i38 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i38 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    HEAP32[i38 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   } else i21 = 34; else i21 = 34;
   if ((i21 | 0) == 34) {
    HEAP32[i38 >> 2] = HEAP32[gb + 59228 >> 2];
    HEAP32[i38 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
    HEAP32[i38 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
    HEAP32[i38 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
   }
   __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i33, i34, i22, i22, i23, i38);
   i1 = i33 + 44 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
   if (i2 & 16) HEAP8[i1 >> 0] = i2 & -17;
   i1 = HEAP32[i37 >> 2] | 0;
   i20 = i1 + 8 | 0;
   i19 = HEAP16[i20 >> 1] | 0;
   i1 = (HEAP32[i1 + 92 >> 2] | 0) + (((i19 & 65535) >>> 8 & 65535) + (HEAP32[i20 + 32 + ((i19 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i19 = HEAPU8[i20 + 32 + ((i19 & 255) * 12 | 0) + 10 >> 0] | 0;
   i20 = HEAP8[i36 + 12 >> 0] | 0;
   i21 = i20 & 255;
   d6 = +Math_fround(HEAPF32[i36 + 4 >> 2]);
   if (i20 << 24 >> 24) d6 = d6 / +((1 << i21) + -1 | 0);
   i27 = Math_imul(((HEAP32[i36 >> 2] | 0) >>> 0) / 3 | 0, i19) | 0;
   i16 = i1 + i27 | 0;
   if (i27 | 0) {
    i17 = i36 + 8 | 0;
    i18 = i36 + 16 | 0;
    i5 = 0;
    i4 = 0;
    i2 = i20;
    do {
     i9 = i2 & 255;
     if (!(i2 << 24 >> 24)) {
      i8 = 0;
      i2 = i9;
      i3 = 0;
     } else {
      i10 = HEAP32[i18 >> 2] | 0;
      i8 = 0;
      i3 = 0;
      i2 = i9;
      while (1) {
       i3 = (HEAPU8[i10 + i5 >> 0] | 0) >>> i4 << i8 | i3;
       i2 = i2 - i8 | 0;
       i27 = 8 - i4 | 0;
       i2 = (i27 | 0) < (i2 | 0) ? i27 : i2;
       i4 = i2 + i4 | 0;
       i8 = i2 + i8 | 0;
       i2 = (i4 | 0) == 8;
       i4 = i2 ? 0 : i4;
       i2 = (i2 & 1) + i5 | 0;
       if ((i21 | 0) <= (i8 | 0)) {
        i8 = i3;
        i5 = i2;
        i2 = i21;
        i3 = i20;
        break;
       } else {
        i5 = i2;
        i2 = i21;
       }
      }
     }
     HEAPF32[i1 >> 2] = Math_fround(+Math_fround(HEAPF32[i17 >> 2]) + d6 * +(((1 << i2) + -1 & i8) >>> 0));
     i2 = i3 & 255;
     if (!(i3 << 24 >> 24)) {
      i3 = 0;
      i10 = i4;
      i4 = 0;
     } else {
      i9 = HEAP32[i18 >> 2] | 0;
      i8 = 0;
      i3 = 0;
      while (1) {
       i3 = (HEAPU8[i9 + i5 >> 0] | 0) >>> i4 << i8 | i3;
       i2 = i2 - i8 | 0;
       i27 = 8 - i4 | 0;
       i2 = (i27 | 0) < (i2 | 0) ? i27 : i2;
       i4 = i2 + i4 | 0;
       i8 = i2 + i8 | 0;
       i2 = (i4 | 0) == 8;
       i4 = i2 ? 0 : i4;
       i2 = (i2 & 1) + i5 | 0;
       if ((i21 | 0) <= (i8 | 0)) {
        i5 = i2;
        i10 = i4;
        i2 = i21;
        i4 = i20;
        break;
       } else {
        i5 = i2;
        i2 = i21;
       }
      }
     }
     HEAPF32[i1 + 4 >> 2] = Math_fround(+Math_fround(HEAPF32[i17 >> 2]) + d6 * +(((1 << i2) + -1 & i3) >>> 0));
     i3 = i4 & 255;
     if (!(i4 << 24 >> 24)) {
      i8 = 0;
      i4 = i10;
      i2 = 0;
     } else {
      i11 = HEAP32[i18 >> 2] | 0;
      i9 = 0;
      i8 = 0;
      i4 = i10;
      i2 = i5;
      while (1) {
       i5 = (HEAPU8[i11 + i2 >> 0] | 0) >>> i4 << i9 | i8;
       i27 = i3 - i9 | 0;
       i26 = 8 - i4 | 0;
       i27 = (i26 | 0) < (i27 | 0) ? i26 : i27;
       i4 = i27 + i4 | 0;
       i9 = i27 + i9 | 0;
       i27 = (i4 | 0) == 8;
       i4 = i27 ? 0 : i4;
       i2 = (i27 & 1) + i2 | 0;
       if ((i21 | 0) <= (i9 | 0)) {
        i8 = i5;
        i5 = i2;
        i3 = i21;
        i2 = i20;
        break;
       } else {
        i8 = i5;
        i3 = i21;
       }
      }
     }
     HEAPF32[i1 + 8 >> 2] = Math_fround(+Math_fround(HEAPF32[i17 >> 2]) + d6 * +(((1 << i3) + -1 & i8) >>> 0));
     i1 = i1 + i19 | 0;
    } while ((i1 | 0) != (i16 | 0));
   }
   i2 = i36 + 28 | 0;
   if (!(i22 & 8)) i1 = 0; else {
    i1 = HEAPU8[i23 + 7 >> 0] | 0;
    i25 = HEAP32[i37 >> 2] | 0;
    i26 = i25 + 8 | 0;
    i27 = HEAP16[i25 + 20 >> 1] | 0;
    __ZN17PackedFloatVector12UnpackFloatsEPfiiii(i2, (HEAP32[i25 + 92 >> 2] | 0) + (((i27 & 65535) >>> 8 & 65535) + (HEAP32[i26 + 32 + ((i27 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, i1, HEAPU8[i26 + 32 + ((i27 & 255) * 12 | 0) + 10 >> 0] | 0, 0, i34);
    i1 = Math_imul(i1, i34) | 0;
   }
   if (i22 & 16) {
    i27 = HEAPU8[i23 + 9 >> 0] | 0;
    i24 = HEAP32[i37 >> 2] | 0;
    i25 = i24 + 8 | 0;
    i26 = HEAP16[i24 + 24 >> 1] | 0;
    __ZN17PackedFloatVector12UnpackFloatsEPfiiii(i2, (HEAP32[i24 + 92 >> 2] | 0) + (((i26 & 65535) >>> 8 & 65535) + (HEAP32[i25 + 32 + ((i26 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, i27, HEAPU8[i25 + 32 + ((i26 & 255) * 12 | 0) + 10 >> 0] | 0, i1, i34);
    i1 = (Math_imul(i27, i34) | 0) + i1 | 0;
   }
   if (i22 & 32) {
    i27 = HEAPU8[i23 + 11 >> 0] | 0;
    i24 = HEAP32[i37 >> 2] | 0;
    i25 = i24 + 8 | 0;
    i26 = HEAP16[i24 + 28 >> 1] | 0;
    __ZN17PackedFloatVector12UnpackFloatsEPfiiii(i2, (HEAP32[i24 + 92 >> 2] | 0) + (((i26 & 65535) >>> 8 & 65535) + (HEAP32[i25 + 32 + ((i26 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, i27, HEAPU8[i25 + 32 + ((i26 & 255) * 12 | 0) + 10 >> 0] | 0, i1, i34);
    i1 = (Math_imul(i27, i34) | 0) + i1 | 0;
   }
   if (i22 & 64 | 0) {
    i25 = HEAP32[i37 >> 2] | 0;
    i26 = i25 + 8 | 0;
    i27 = HEAP16[i25 + 32 >> 1] | 0;
    __ZN17PackedFloatVector12UnpackFloatsEPfiiii(i2, (HEAP32[i25 + 92 >> 2] | 0) + (((i27 & 65535) >>> 8 & 65535) + (HEAP32[i26 + 32 + ((i27 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, HEAPU8[i23 + 13 >> 0] | 0, HEAPU8[i26 + 32 + ((i27 & 255) * 12 | 0) + 10 >> 0] | 0, i1, i34);
   }
   if (HEAP32[i28 >> 2] | 0) {
    HEAP32[i38 + 12 >> 2] = i34;
    i24 = i38 + 16 | 0;
    HEAP32[i24 >> 2] = i34;
    i25 = i38 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i26 = i35;
    i22 = HEAP32[i26 + 4 >> 2] | 0;
    i21 = i25;
    HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i21 + 4 >> 2] = i22;
    HEAP32[i38 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 << 3, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
    i21 = i36 + 84 | 0;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i39 + 12 >> 2] = i22;
    i26 = i39 + 16 | 0;
    HEAP32[i26 >> 2] = i22;
    i27 = i39 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i20 = i35;
    i19 = HEAP32[i20 + 4 >> 2] | 0;
    i23 = i27;
    HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i23 + 4 >> 2] = i19;
    i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22 << 2, 4, i27, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i39 >> 2] = i22;
    i23 = HEAP32[i38 >> 2] | 0;
    i19 = HEAP8[i36 + 68 >> 0] | 0;
    i20 = i19 & 255;
    d6 = +Math_fround(HEAPF32[i36 + 60 >> 2]);
    if (i19 << 24 >> 24) d6 = d6 / +((1 << i20) + -1 | 0);
    i1 = (HEAP32[i28 >> 2] | 0) >>> 1;
    if (i1 | 0) {
     i17 = i36 + 64 | 0;
     i18 = i36 + 72 | 0;
     i16 = i23 + (i1 << 3) | 0;
     i4 = 0;
     i3 = 0;
     i11 = i23;
     i1 = i19;
     do {
      i8 = i1 & 255;
      if (!(i1 << 24 >> 24)) {
       i2 = 0;
       i9 = i3;
       i1 = i8;
       i3 = 0;
      } else {
       i9 = HEAP32[i18 >> 2] | 0;
       i5 = 0;
       i2 = 0;
       i1 = i8;
       while (1) {
        i2 = (HEAPU8[i9 + i4 >> 0] | 0) >>> i3 << i5 | i2;
        i1 = i1 - i5 | 0;
        i28 = 8 - i3 | 0;
        i1 = (i28 | 0) < (i1 | 0) ? i28 : i1;
        i3 = i1 + i3 | 0;
        i5 = i1 + i5 | 0;
        i1 = (i3 | 0) == 8;
        i3 = i1 ? 0 : i3;
        i1 = (i1 & 1) + i4 | 0;
        if ((i20 | 0) <= (i5 | 0)) {
         i4 = i1;
         i9 = i3;
         i1 = i20;
         i3 = i19;
         break;
        } else {
         i4 = i1;
         i1 = i20;
        }
       }
      }
      HEAPF32[i11 >> 2] = Math_fround(+Math_fround(HEAPF32[i17 >> 2]) + d6 * +(((1 << i1) + -1 & i2) >>> 0));
      i2 = i3 & 255;
      if (!(i3 << 24 >> 24)) {
       i5 = 0;
       i3 = i9;
       i1 = 0;
      } else {
       i10 = HEAP32[i18 >> 2] | 0;
       i8 = 0;
       i5 = 0;
       i3 = i9;
       i1 = i4;
       while (1) {
        i4 = (HEAPU8[i10 + i1 >> 0] | 0) >>> i3 << i8 | i5;
        i28 = i2 - i8 | 0;
        i9 = 8 - i3 | 0;
        i28 = (i9 | 0) < (i28 | 0) ? i9 : i28;
        i3 = i28 + i3 | 0;
        i8 = i28 + i8 | 0;
        i28 = (i3 | 0) == 8;
        i3 = i28 ? 0 : i3;
        i1 = (i28 & 1) + i1 | 0;
        if ((i20 | 0) <= (i8 | 0)) {
         i5 = i4;
         i4 = i1;
         i2 = i20;
         i1 = i19;
         break;
        } else {
         i5 = i4;
         i2 = i20;
        }
       }
      }
      HEAPF32[i11 + 4 >> 2] = Math_fround(+Math_fround(HEAPF32[i17 >> 2]) + d6 * +(((1 << i2) + -1 & i5) >>> 0));
      i11 = i11 + 8 | 0;
     } while ((i11 | 0) != (i16 | 0));
    }
    i9 = HEAP8[i36 + 88 >> 0] | 0;
    i10 = _bitshift64Shl(1, 0, i9 & 255 | 0) | 0;
    i10 = _i64Add(i10 | 0, getTempRet0() | 0, -1, 0) | 0;
    getTempRet0() | 0;
    if (HEAP32[i21 >> 2] | 0) {
     i11 = i36 + 92 | 0;
     i16 = i9 & 255;
     i8 = 0;
     i3 = 0;
     i2 = 0;
     i1 = i9;
     while (1) {
      i17 = i22 + (i8 << 2) | 0;
      HEAP32[i17 >> 2] = 0;
      if (!(i1 << 24 >> 24)) {
       i4 = i2;
       i1 = 0;
       i2 = 0;
      } else {
       i5 = HEAP32[i11 >> 2] | 0;
       i4 = 0;
       i1 = i2;
       i2 = 0;
       do {
        i2 = (HEAPU8[i5 + i1 >> 0] | 0) >>> i3 << i4 | i2;
        HEAP32[i17 >> 2] = i2;
        i28 = i16 - i4 | 0;
        i20 = 8 - i3 | 0;
        i28 = (i20 | 0) < (i28 | 0) ? i20 : i28;
        i3 = i28 + i3 | 0;
        i4 = i28 + i4 | 0;
        i28 = (i3 | 0) == 8;
        i3 = i28 ? 0 : i3;
        i1 = (i28 & 1) + i1 | 0;
       } while ((i4 | 0) < (i16 | 0));
       i4 = i1;
       i1 = i9;
      }
      HEAP32[i17 >> 2] = i2 & i10;
      i8 = i8 + 1 | 0;
      if (i8 >>> 0 >= (HEAP32[i21 >> 2] | 0) >>> 0) break; else i2 = i4;
     }
    }
    i2 = HEAP32[i37 >> 2] | 0;
    i3 = i2 + 8 | 0;
    i28 = HEAP16[i2 + 14 >> 1] | 0;
    do if ((i28 & 65535) < 768 | (i28 & 255) != 0) {
     i1 = 0;
     i8 = 0;
    } else {
     i1 = HEAP32[i2 + 92 >> 2] | 0;
     if (!i1) {
      i1 = 0;
      i8 = 1;
      break;
     }
     if (!(HEAP8[i2 + 15 >> 0] | 0)) {
      i1 = 0;
      i8 = 1;
      break;
     }
     i8 = HEAP16[i2 + 12 >> 1] | 0;
     i1 = i1 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i8 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    } while (0);
    if ((i30 | 0) > 2) {
     i5 = 0;
     i4 = i1;
     i1 = i22;
     i2 = i22;
     while (1) {
      i22 = HEAP32[i23 + (i5 << 3) >> 2] | 0;
      HEAP32[i4 >> 2] = i22;
      i28 = HEAP32[i23 + (i5 << 3) + 4 >> 2] | 0;
      i3 = i4 + 4 | 0;
      HEAP32[i3 >> 2] = i28;
      f7 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f12 = Math_fround(f7 * f7);
      f15 = Math_fround(Math_fround(1.0) - f12);
      f13 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = Math_fround(f13 * f13);
      f15 = Math_fround(f15 - f14);
      if (!(f15 >= Math_fround(0.0))) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f14) + Math_fround(0.0))));
       f14 = Math_fround(f13 / f12);
       f15 = Math_fround(Math_fround(0.0) / f12);
       HEAPF32[i4 >> 2] = Math_fround(f7 / f12);
       HEAPF32[i3 >> 2] = f14;
       HEAPF32[i4 + 8 >> 2] = f15;
       i2 = HEAP32[i39 >> 2] | 0;
       i1 = i2;
       f7 = f15;
      } else {
       f7 = Math_fround(Math_sqrt(Math_fround(f15)));
       HEAPF32[i4 + 8 >> 2] = f7;
      }
      if (!(HEAP32[i2 + (i5 << 2) >> 2] | 0)) HEAPF32[i4 + 8 >> 2] = Math_fround(-f7);
      i5 = i5 + 1 | 0;
      if ((i5 | 0) >= (i34 | 0)) break; else i4 = i4 + i8 | 0;
     }
    } else i1 = i22;
    if ((HEAP32[i26 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
     HEAP32[i39 >> 2] = 0;
    }
    if ((HEAP32[i24 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i25);
     HEAP32[i38 >> 2] = 0;
    }
   }
   if (HEAP32[i29 >> 2] | 0) {
    HEAP32[i38 + 12 >> 2] = i34;
    i24 = i38 + 16 | 0;
    HEAP32[i24 >> 2] = i34;
    i25 = i38 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i26 = i35;
    i23 = HEAP32[i26 + 4 >> 2] | 0;
    i22 = i25;
    HEAP32[i22 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i22 + 4 >> 2] = i23;
    HEAP32[i38 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 << 3, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
    i22 = i36 + 132 | 0;
    i23 = HEAP32[i22 >> 2] | 0;
    HEAP32[i39 + 12 >> 2] = i23;
    i26 = i39 + 16 | 0;
    HEAP32[i26 >> 2] = i23;
    i27 = i39 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i21 = i35;
    i20 = HEAP32[i21 + 4 >> 2] | 0;
    i3 = i27;
    HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i3 + 4 >> 2] = i20;
    i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i23 << 2, 4, i27, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i39 >> 2] = i23;
    i3 = HEAP32[i38 >> 2] | 0;
    i20 = HEAP8[i36 + 116 >> 0] | 0;
    i21 = i20 & 255;
    d6 = +Math_fround(HEAPF32[i36 + 108 >> 2]);
    if (i20 << 24 >> 24) d6 = d6 / +((1 << i21) + -1 | 0);
    i1 = (HEAP32[i29 >> 2] | 0) >>> 1;
    if (i1 | 0) {
     i18 = i36 + 112 | 0;
     i19 = i36 + 120 | 0;
     i17 = i3 + (i1 << 3) | 0;
     i5 = 0;
     i4 = 0;
     i16 = i3;
     i1 = i20;
     do {
      i9 = i1 & 255;
      if (!(i1 << 24 >> 24)) {
       i2 = 0;
       i10 = i4;
       i1 = i9;
       i4 = 0;
      } else {
       i10 = HEAP32[i19 >> 2] | 0;
       i8 = 0;
       i2 = 0;
       i1 = i9;
       while (1) {
        i2 = (HEAPU8[i10 + i5 >> 0] | 0) >>> i4 << i8 | i2;
        i1 = i1 - i8 | 0;
        i29 = 8 - i4 | 0;
        i1 = (i29 | 0) < (i1 | 0) ? i29 : i1;
        i4 = i1 + i4 | 0;
        i8 = i1 + i8 | 0;
        i1 = (i4 | 0) == 8;
        i4 = i1 ? 0 : i4;
        i1 = (i1 & 1) + i5 | 0;
        if ((i21 | 0) <= (i8 | 0)) {
         i5 = i1;
         i10 = i4;
         i1 = i21;
         i4 = i20;
         break;
        } else {
         i5 = i1;
         i1 = i21;
        }
       }
      }
      HEAPF32[i16 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i1) + -1 & i2) >>> 0));
      i2 = i4 & 255;
      if (!(i4 << 24 >> 24)) {
       i8 = 0;
       i4 = i10;
       i1 = 0;
      } else {
       i11 = HEAP32[i19 >> 2] | 0;
       i9 = 0;
       i8 = 0;
       i4 = i10;
       i1 = i5;
       while (1) {
        i5 = (HEAPU8[i11 + i1 >> 0] | 0) >>> i4 << i9 | i8;
        i29 = i2 - i9 | 0;
        i28 = 8 - i4 | 0;
        i29 = (i28 | 0) < (i29 | 0) ? i28 : i29;
        i4 = i29 + i4 | 0;
        i9 = i29 + i9 | 0;
        i29 = (i4 | 0) == 8;
        i4 = i29 ? 0 : i4;
        i1 = (i29 & 1) + i1 | 0;
        if ((i21 | 0) <= (i9 | 0)) {
         i8 = i5;
         i5 = i1;
         i2 = i21;
         i1 = i20;
         break;
        } else {
         i8 = i5;
         i2 = i21;
        }
       }
      }
      HEAPF32[i16 + 4 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i2) + -1 & i8) >>> 0));
      i16 = i16 + 8 | 0;
     } while ((i16 | 0) != (i17 | 0));
    }
    i10 = HEAP8[i36 + 136 >> 0] | 0;
    i11 = _bitshift64Shl(1, 0, i10 & 255 | 0) | 0;
    i11 = _i64Add(i11 | 0, getTempRet0() | 0, -1, 0) | 0;
    getTempRet0() | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i16 = i36 + 140 | 0;
     i17 = i10 & 255;
     i9 = 0;
     i4 = 0;
     i2 = 0;
     i1 = i10;
     while (1) {
      i18 = i23 + (i9 << 2) | 0;
      HEAP32[i18 >> 2] = 0;
      if (!(i1 << 24 >> 24)) {
       i5 = i2;
       i1 = 0;
       i2 = 0;
      } else {
       i8 = HEAP32[i16 >> 2] | 0;
       i5 = 0;
       i1 = i2;
       i2 = 0;
       do {
        i2 = (HEAPU8[i8 + i1 >> 0] | 0) >>> i4 << i5 | i2;
        HEAP32[i18 >> 2] = i2;
        i29 = i17 - i5 | 0;
        i28 = 8 - i4 | 0;
        i29 = (i28 | 0) < (i29 | 0) ? i28 : i29;
        i4 = i29 + i4 | 0;
        i5 = i29 + i5 | 0;
        i29 = (i4 | 0) == 8;
        i4 = i29 ? 0 : i4;
        i1 = (i29 & 1) + i1 | 0;
       } while ((i5 | 0) < (i17 | 0));
       i5 = i1;
       i1 = i10;
      }
      HEAP32[i18 >> 2] = i2 & i11;
      i9 = i9 + 1 | 0;
      if (i9 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i2 = i5;
     }
    }
    i2 = HEAP32[i37 >> 2] | 0;
    i4 = i2 + 8 | 0;
    i29 = HEAP16[i2 + 38 >> 1] | 0;
    do if ((i29 & 65535) < 1024 | (i29 & 255) != 0) {
     i1 = 0;
     i8 = 0;
    } else {
     i1 = HEAP32[i2 + 92 >> 2] | 0;
     if (!i1) {
      i1 = 0;
      i8 = 1;
      break;
     }
     if (!(HEAP8[i2 + 39 >> 0] | 0)) {
      i1 = 0;
      i8 = 1;
      break;
     }
     i8 = HEAP16[i2 + 36 >> 1] | 0;
     i1 = i1 + (((i8 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i8 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i8 = HEAPU8[i4 + 32 + ((HEAPU8[i2 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    } while (0);
    L183 : do if ((i30 | 0) > 2) {
     i2 = 0;
     i5 = i1;
     i1 = i23;
     i4 = i23;
     while (1) {
      i29 = HEAP32[i3 + (i2 << 3) >> 2] | 0;
      HEAP32[i5 >> 2] = i29;
      i30 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
      i3 = i5 + 4 | 0;
      HEAP32[i3 >> 2] = i30;
      f7 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f12 = Math_fround(f7 * f7);
      f15 = Math_fround(Math_fround(1.0) - f12);
      f13 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = Math_fround(f13 * f13);
      f15 = Math_fround(f15 - f14);
      if (!(f15 >= Math_fround(0.0))) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f14) + Math_fround(0.0))));
       f14 = Math_fround(f13 / f12);
       f15 = Math_fround(Math_fround(0.0) / f12);
       HEAPF32[i5 >> 2] = Math_fround(f7 / f12);
       HEAPF32[i3 >> 2] = f14;
       HEAPF32[i5 + 8 >> 2] = f15;
       i4 = HEAP32[i39 >> 2] | 0;
       i1 = i4;
       f7 = f15;
      } else {
       f7 = Math_fround(Math_sqrt(Math_fround(f15)));
       HEAPF32[i5 + 8 >> 2] = f7;
      }
      i3 = i2 << 1;
      if (!(HEAP32[i4 + (i3 << 2) >> 2] | 0)) HEAPF32[i5 + 8 >> 2] = Math_fround(-f7);
      HEAPF32[i5 + 12 >> 2] = HEAP32[i4 + ((i3 | 1) << 2) >> 2] | 0 ? Math_fround(1.0) : Math_fround(-1.0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i34 | 0)) break L183;
      i5 = i5 + i8 | 0;
      i3 = HEAP32[i38 >> 2] | 0;
     }
    } else i1 = i23; while (0);
    if ((HEAP32[i26 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
     HEAP32[i39 >> 2] = 0;
    }
    if ((HEAP32[i24 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i25);
     HEAP32[i38 >> 2] = 0;
    }
   }
   if (HEAP32[i31 >> 2] | 0) {
    i20 = i38 + 12 | 0;
    HEAP32[i20 >> 2] = i34;
    i23 = i38 + 16 | 0;
    HEAP32[i23 >> 2] = i34;
    i24 = i38 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i22 = i35;
    i21 = HEAP32[i22 + 4 >> 2] | 0;
    i2 = i24;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i2 + 4 >> 2] = i21;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 << 4, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i38 >> 2] = i2;
    i21 = HEAP8[i36 + 164 >> 0] | 0;
    i22 = i21 & 255;
    d6 = +Math_fround(HEAPF32[i36 + 156 >> 2]);
    if (i21 << 24 >> 24) d6 = d6 / +((1 << i22) + -1 | 0);
    i31 = (HEAP32[i31 >> 2] | 0) >>> 2;
    i17 = i2 + (i31 << 4) | 0;
    if (i31 | 0) {
     i18 = i36 + 160 | 0;
     i19 = i36 + 168 | 0;
     i5 = 0;
     i4 = 0;
     i16 = i2;
     i1 = i21;
     do {
      i9 = i1 & 255;
      if (!(i1 << 24 >> 24)) {
       i8 = 0;
       i1 = i9;
       i3 = 0;
      } else {
       i10 = HEAP32[i19 >> 2] | 0;
       i8 = 0;
       i3 = 0;
       i1 = i9;
       while (1) {
        i3 = (HEAPU8[i10 + i5 >> 0] | 0) >>> i4 << i8 | i3;
        i1 = i1 - i8 | 0;
        i31 = 8 - i4 | 0;
        i1 = (i31 | 0) < (i1 | 0) ? i31 : i1;
        i4 = i1 + i4 | 0;
        i8 = i1 + i8 | 0;
        i1 = (i4 | 0) == 8;
        i4 = i1 ? 0 : i4;
        i1 = (i1 & 1) + i5 | 0;
        if ((i22 | 0) <= (i8 | 0)) {
         i8 = i3;
         i5 = i1;
         i1 = i22;
         i3 = i21;
         break;
        } else {
         i5 = i1;
         i1 = i22;
        }
       }
      }
      HEAPF32[i16 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i1) + -1 & i8) >>> 0));
      i1 = i3 & 255;
      if (!(i3 << 24 >> 24)) {
       i8 = 0;
       i3 = 0;
      } else {
       i9 = HEAP32[i19 >> 2] | 0;
       i8 = 0;
       i3 = 0;
       while (1) {
        i3 = (HEAPU8[i9 + i5 >> 0] | 0) >>> i4 << i8 | i3;
        i1 = i1 - i8 | 0;
        i31 = 8 - i4 | 0;
        i1 = (i31 | 0) < (i1 | 0) ? i31 : i1;
        i4 = i1 + i4 | 0;
        i8 = i1 + i8 | 0;
        i1 = (i4 | 0) == 8;
        i4 = i1 ? 0 : i4;
        i1 = (i1 & 1) + i5 | 0;
        if ((i22 | 0) <= (i8 | 0)) {
         i8 = i3;
         i5 = i1;
         i1 = i22;
         i3 = i21;
         break;
        } else {
         i5 = i1;
         i1 = i22;
        }
       }
      }
      HEAPF32[i16 + 4 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i1) + -1 & i8) >>> 0));
      i1 = i3 & 255;
      if (!(i3 << 24 >> 24)) {
       i3 = 0;
       i10 = i4;
       i4 = 0;
      } else {
       i9 = HEAP32[i19 >> 2] | 0;
       i8 = 0;
       i3 = 0;
       while (1) {
        i3 = (HEAPU8[i9 + i5 >> 0] | 0) >>> i4 << i8 | i3;
        i1 = i1 - i8 | 0;
        i31 = 8 - i4 | 0;
        i1 = (i31 | 0) < (i1 | 0) ? i31 : i1;
        i4 = i1 + i4 | 0;
        i8 = i1 + i8 | 0;
        i1 = (i4 | 0) == 8;
        i4 = i1 ? 0 : i4;
        i1 = (i1 & 1) + i5 | 0;
        if ((i22 | 0) <= (i8 | 0)) {
         i5 = i1;
         i10 = i4;
         i1 = i22;
         i4 = i21;
         break;
        } else {
         i5 = i1;
         i1 = i22;
        }
       }
      }
      HEAPF32[i16 + 8 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i1) + -1 & i3) >>> 0));
      i3 = i4 & 255;
      if (!(i4 << 24 >> 24)) {
       i8 = 0;
       i4 = i10;
       i1 = 0;
      } else {
       i11 = HEAP32[i19 >> 2] | 0;
       i9 = 0;
       i8 = 0;
       i4 = i10;
       i1 = i5;
       while (1) {
        i5 = (HEAPU8[i11 + i1 >> 0] | 0) >>> i4 << i9 | i8;
        i31 = i3 - i9 | 0;
        i30 = 8 - i4 | 0;
        i31 = (i30 | 0) < (i31 | 0) ? i30 : i31;
        i4 = i31 + i4 | 0;
        i9 = i31 + i9 | 0;
        i31 = (i4 | 0) == 8;
        i4 = i31 ? 0 : i4;
        i1 = (i31 & 1) + i1 | 0;
        if ((i22 | 0) <= (i9 | 0)) {
         i8 = i5;
         i5 = i1;
         i3 = i22;
         i1 = i21;
         break;
        } else {
         i8 = i5;
         i3 = i22;
        }
       }
      }
      HEAPF32[i16 + 12 >> 2] = Math_fround(+Math_fround(HEAPF32[i18 >> 2]) + d6 * +(((1 << i3) + -1 & i8) >>> 0));
      i16 = i16 + 16 | 0;
     } while ((i16 | 0) != (i17 | 0));
    }
    i9 = HEAP32[i20 >> 2] | 0;
    i10 = i2 + (i9 << 4) | 0;
    i5 = HEAP32[i37 >> 2] | 0;
    i8 = i5 + 8 | 0;
    i1 = HEAP16[i5 + 18 >> 1] | 0;
    i3 = i1 & 255;
    do if ((HEAP8[i32 >> 0] | 0) == 2) {
     do if ((i1 & 65535) < 1024 | i3 << 16 >> 16 != 2) {
      i1 = 0;
      i3 = 0;
     } else {
      i1 = HEAP32[i5 + 92 >> 2] | 0;
      if (!i1) {
       i1 = 0;
       i3 = 1;
       break;
      }
      if (!(HEAP8[i5 + 19 >> 0] | 0)) {
       i1 = 0;
       i3 = 1;
       break;
      }
      i3 = HEAP16[i5 + 16 >> 1] | 0;
      i1 = i1 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i8 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      i3 = HEAPU8[i8 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     } while (0);
     if (i9 | 0) while (1) {
      f15 = Math_fround(HEAPF32[i2 >> 2]);
      i32 = f15 < Math_fround(0.0);
      f15 = i32 ? Math_fround(0.0) : f15;
      i32 = f15 > Math_fround(1.0);
      HEAP8[i1 >> 0] = ~~Math_fround(Math_fround((i32 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
      f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
      i32 = f15 < Math_fround(0.0);
      f15 = i32 ? Math_fround(0.0) : f15;
      i32 = f15 > Math_fround(1.0);
      HEAP8[i1 + 1 >> 0] = ~~Math_fround(Math_fround((i32 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
      f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
      i32 = f15 < Math_fround(0.0);
      f15 = i32 ? Math_fround(0.0) : f15;
      i32 = f15 > Math_fround(1.0);
      HEAP8[i1 + 2 >> 0] = ~~Math_fround(Math_fround((i32 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
      f15 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      i32 = f15 < Math_fround(0.0);
      f15 = i32 ? Math_fround(0.0) : f15;
      i32 = f15 > Math_fround(1.0);
      HEAP8[i1 + 3 >> 0] = ~~Math_fround(Math_fround((i32 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
      i2 = i2 + 16 | 0;
      if ((i2 | 0) == (i10 | 0)) break; else i1 = i1 + i3 | 0;
     }
     __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i33, 1);
    } else {
     do if ((i1 & 65535) < 1024 | i3 << 16 >> 16 != 0) {
      i4 = 0;
      i5 = 0;
     } else {
      i1 = HEAP32[i5 + 92 >> 2] | 0;
      if (!i1) {
       i4 = 0;
       i5 = 1;
       break;
      }
      if (!(HEAP8[i5 + 19 >> 0] | 0)) {
       i4 = 0;
       i5 = 1;
       break;
      }
      i4 = HEAP16[i5 + 16 >> 1] | 0;
      i4 = i1 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i8 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
      i5 = HEAPU8[i8 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     } while (0);
     if (!i9) break;
     i1 = i2;
     i3 = i4;
     i2 = i4;
     while (1) {
      i31 = HEAP32[i1 + 4 >> 2] | 0;
      i32 = HEAP32[i1 + 8 >> 2] | 0;
      i33 = HEAP32[i1 + 12 >> 2] | 0;
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = i31;
      HEAP32[i3 + 8 >> 2] = i32;
      HEAP32[i3 + 12 >> 2] = i33;
      i1 = i1 + 16 | 0;
      i2 = i2 + i5 | 0;
      if ((i1 | 0) == (i10 | 0)) break; else i3 = i2;
     }
    } while (0);
    if ((HEAP32[i23 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i24);
     HEAP32[i38 >> 2] = 0;
    }
   }
   i22 = i36 + 180 | 0;
   i1 = HEAP32[i22 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i38 + 12 >> 2] = i1;
    i23 = i38 + 16 | 0;
    HEAP32[i23 >> 2] = i1;
    i24 = i38 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i11 = i35;
    i10 = HEAP32[i11 + 4 >> 2] | 0;
    i9 = i24;
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i38 >> 2] = i9;
    i10 = HEAP8[i36 + 184 >> 0] | 0;
    i11 = _bitshift64Shl(1, 0, i10 & 255 | 0) | 0;
    i11 = _i64Add(i11 | 0, getTempRet0() | 0, -1, 0) | 0;
    getTempRet0() | 0;
    if (HEAP32[i22 >> 2] | 0) {
     i16 = i36 + 188 | 0;
     i17 = i10 & 255;
     i8 = 0;
     i3 = 0;
     i2 = 0;
     i1 = i10;
     while (1) {
      i18 = i9 + (i8 << 2) | 0;
      HEAP32[i18 >> 2] = 0;
      if (!(i1 << 24 >> 24)) {
       i4 = i2;
       i1 = 0;
       i2 = 0;
      } else {
       i5 = HEAP32[i16 >> 2] | 0;
       i4 = 0;
       i1 = i2;
       i2 = 0;
       do {
        i2 = (HEAPU8[i5 + i1 >> 0] | 0) >>> i3 << i4 | i2;
        HEAP32[i18 >> 2] = i2;
        i33 = i17 - i4 | 0;
        i32 = 8 - i3 | 0;
        i33 = (i32 | 0) < (i33 | 0) ? i32 : i33;
        i3 = i33 + i3 | 0;
        i4 = i33 + i4 | 0;
        i33 = (i3 | 0) == 8;
        i3 = i33 ? 0 : i3;
        i1 = (i33 & 1) + i1 | 0;
       } while ((i4 | 0) < (i17 | 0));
       i4 = i1;
       i1 = i10;
      }
      HEAP32[i18 >> 2] = i2 & i11;
      i8 = i8 + 1 | 0;
      if (i8 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break; else i2 = i4;
     }
    }
    i19 = i36 + 200 | 0;
    i16 = HEAP32[i19 >> 2] | 0;
    HEAP32[i39 + 12 >> 2] = i16;
    i20 = i39 + 16 | 0;
    HEAP32[i20 >> 2] = i16;
    i21 = i39 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 64016 | 0);
    i18 = HEAP32[i35 + 4 >> 2] | 0;
    i17 = i21;
    HEAP32[i17 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i17 + 4 >> 2] = i18;
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i39 >> 2] = i16;
    i17 = HEAP8[i36 + 204 >> 0] | 0;
    i18 = _bitshift64Shl(1, 0, i17 & 255 | 0) | 0;
    i18 = _i64Add(i18 | 0, getTempRet0() | 0, -1, 0) | 0;
    getTempRet0() | 0;
    if (HEAP32[i19 >> 2] | 0) {
     i9 = i36 + 208 | 0;
     i10 = i17 & 255;
     i8 = 0;
     i3 = 0;
     i2 = 0;
     i1 = i17;
     while (1) {
      i11 = i16 + (i8 << 2) | 0;
      HEAP32[i11 >> 2] = 0;
      if (!(i1 << 24 >> 24)) {
       i4 = i2;
       i1 = 0;
       i2 = 0;
      } else {
       i5 = HEAP32[i9 >> 2] | 0;
       i4 = 0;
       i1 = i2;
       i2 = 0;
       do {
        i2 = (HEAPU8[i5 + i1 >> 0] | 0) >>> i3 << i4 | i2;
        HEAP32[i11 >> 2] = i2;
        i36 = i10 - i4 | 0;
        i35 = 8 - i3 | 0;
        i36 = (i35 | 0) < (i36 | 0) ? i35 : i36;
        i3 = i36 + i3 | 0;
        i4 = i36 + i4 | 0;
        i36 = (i3 | 0) == 8;
        i3 = i36 ? 0 : i3;
        i1 = (i36 & 1) + i1 | 0;
       } while ((i4 | 0) < (i10 | 0));
       i4 = i1;
       i1 = i17;
      }
      HEAP32[i11 >> 2] = i2 & i18;
      i8 = i8 + 1 | 0;
      if (i8 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) break; else i2 = i4;
     }
    }
    i1 = HEAP32[i37 >> 2] | 0;
    i5 = i1 + 164 | 0;
    i2 = i1 + 176 | 0;
    HEAP32[i2 >> 2] = i34;
    i3 = i1 + 180 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    do if ((i4 & 2147483647) >>> 0 < i34 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i34;
     HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i34 << 5, 16, i1 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i37 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 << 5, 16, i1 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i37 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 5 | 0) | 0;
     HEAP32[i3 >> 2] = i34;
     HEAP32[i5 >> 2] = i37;
     break;
    } while (0);
    if ((HEAP32[i22 >> 2] | 0) > 0) {
     i11 = HEAP32[i38 >> 2] | 0;
     i9 = HEAP32[i5 >> 2] | 0;
     i10 = HEAP32[i39 >> 2] | 0;
     i2 = 0;
     i1 = 0;
     i3 = 0;
     i4 = 0;
     i8 = 0;
     do {
      i37 = i11 + (i8 << 2) | 0;
      HEAPF32[i9 + (i4 << 5) + (i1 << 2) >> 2] = Math_fround(+((HEAP32[i37 >> 2] | 0) >>> 0) / 31.0);
      i5 = i3 + 1 | 0;
      HEAP32[i9 + (i4 << 5) + 16 + (i1 << 2) >> 2] = HEAP32[i10 + (i3 << 2) >> 2];
      i1 = i1 + 1 | 0;
      i2 = (HEAP32[i37 >> 2] | 0) + i2 | 0;
      do if ((i2 | 0) > 30) {
       if ((i1 | 0) < 4) do {
        HEAPF32[i9 + (i4 << 5) + (i1 << 2) >> 2] = Math_fround(0.0);
        HEAP32[i9 + (i4 << 5) + 16 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != 4);
       i2 = 0;
       i3 = i5;
       i4 = i4 + 1 | 0;
       i1 = 0;
      } else {
       if ((i1 | 0) != 3) {
        i3 = i5;
        break;
       }
       HEAPF32[i9 + (i4 << 5) + 12 >> 2] = Math_fround(+(31 - i2 | 0) / 31.0);
       HEAP32[i9 + (i4 << 5) + 28 >> 2] = HEAP32[i10 + (i5 << 2) >> 2];
       i2 = 0;
       i3 = i3 + 2 | 0;
       i4 = i4 + 1 | 0;
       i1 = 0;
      } while (0);
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) < (HEAP32[i22 >> 2] | 0));
    }
    if ((HEAP32[i20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i21);
     HEAP32[i39 >> 2] = 0;
    }
    if ((HEAP32[i23 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i24);
     HEAP32[i38 >> 2] = 0;
    }
   }
   STACKTOP = i40;
   return;
  }
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 426053 | 0, 0, gb + 426077 | 0, 457, 1, 0, 0, 0);
 STACKTOP = i40;
 return;
}

function __ZN5physx27PxcContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i22, i4, i2, i3, i111, i1, i110) {
 i22 = i22 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i111 = i111 | 0;
 i1 = i1 | 0;
 i110 = i110 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, i107 = 0, i108 = 0, i109 = 0, i112 = 0, i113 = 0;
 i113 = STACKTOP;
 STACKTOP = STACKTOP + 8400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i107 = i113 + 8304 | 0;
 i64 = i113 + 8328 | 0;
 i30 = i113 + 104 | 0;
 i31 = i113 + 24 | 0;
 i63 = i113 + 112 | 0;
 i62 = i113 + 32 | 0;
 i109 = i113 + 12 | 0;
 i108 = i113;
 f43 = Math_fround(HEAPF32[i2 >> 2]);
 f58 = Math_fround(f43 + f43);
 f59 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f46 = Math_fround(f59 + f59);
 f38 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f42 = Math_fround(f38 + f38);
 f41 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f45 = Math_fround(f58 * f41);
 f44 = Math_fround(f46 * f41);
 f41 = Math_fround(f41 * f42);
 f103 = Math_fround(f43 * f46);
 f57 = Math_fround(f43 * f42);
 f46 = Math_fround(f59 * f46);
 f59 = Math_fround(f59 * f42);
 f42 = Math_fround(f38 * f42);
 f38 = Math_fround(Math_fround(Math_fround(1.0) - f46) - f42);
 f39 = Math_fround(f103 + f41);
 f40 = Math_fround(f57 - f44);
 f41 = Math_fround(f103 - f41);
 f58 = Math_fround(Math_fround(1.0) - Math_fround(f43 * f58));
 f42 = Math_fround(f58 - f42);
 f43 = Math_fround(f59 + f45);
 f44 = Math_fround(f57 + f44);
 f45 = Math_fround(f59 - f45);
 f46 = Math_fround(f58 - f46);
 f58 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f59 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f57 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f103 = Math_fround(HEAPF32[i3 >> 2]);
 f86 = Math_fround(f103 + f103);
 f85 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f106 = Math_fround(f85 + f85);
 f98 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f102 = Math_fround(f98 + f98);
 f101 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f105 = Math_fround(f86 * f101);
 f104 = Math_fround(f106 * f101);
 f101 = Math_fround(f101 * f102);
 f83 = Math_fround(f103 * f106);
 f84 = Math_fround(f103 * f102);
 f106 = Math_fround(f85 * f106);
 f85 = Math_fround(f85 * f102);
 f102 = Math_fround(f98 * f102);
 f98 = Math_fround(Math_fround(Math_fround(1.0) - f106) - f102);
 f99 = Math_fround(f83 + f101);
 f100 = Math_fround(f84 - f104);
 f101 = Math_fround(f83 - f101);
 f86 = Math_fround(Math_fround(1.0) - Math_fround(f103 * f86));
 f102 = Math_fround(f86 - f102);
 f103 = Math_fround(f85 + f105);
 f104 = Math_fround(f84 + f104);
 f105 = Math_fround(f85 - f105);
 f106 = Math_fround(f86 - f106);
 i56 = HEAP32[i3 + 16 >> 2] | 0;
 i60 = HEAP32[i3 + 20 >> 2] | 0;
 i55 = HEAP32[i3 + 24 >> 2] | 0;
 i61 = HEAP32[i4 + 4 >> 2] | 0;
 i95 = i107 + 12 | 0;
 HEAP32[i95 >> 2] = i61;
 HEAP32[i107 + 16 >> 2] = i4;
 i96 = i4 + 8 | 0;
 i29 = i107 + 4 | 0;
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i96 >> 2]));
 i97 = i4 + 12 | 0;
 HEAPF32[i107 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i97 >> 2]));
 i94 = i4 + 16 | 0;
 i28 = i107 + 8 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i94 >> 2]));
 i1 = i22 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i22 + 8 >> 2]) == Math_fround(1.0)) i89 = Math_fround(HEAPF32[i22 + 12 >> 2]) == Math_fround(1.0); else i89 = 0; else i89 = 0;
 HEAP32[i64 >> 2] = 1065353216;
 i2 = i64 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i64 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i64 + 12 >> 2] = 0;
 i4 = i64 + 16 | 0;
 HEAP32[i4 >> 2] = 1065353216;
 i11 = i64 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i64 + 24 >> 2] = 0;
 i16 = i64 + 28 | 0;
 HEAP32[i16 >> 2] = 0;
 i21 = i64 + 32 | 0;
 HEAP32[i21 >> 2] = 1065353216;
 HEAP32[i64 + 36 >> 2] = 1065353216;
 i87 = i64 + 40 | 0;
 HEAP32[i87 >> 2] = 0;
 i88 = i64 + 44 | 0;
 HEAP32[i88 >> 2] = 0;
 HEAP32[i64 + 48 >> 2] = 0;
 i90 = i64 + 52 | 0;
 HEAP32[i90 >> 2] = 1065353216;
 i91 = i64 + 56 | 0;
 HEAP32[i91 >> 2] = 0;
 HEAP32[i64 + 60 >> 2] = 0;
 i92 = i64 + 64 | 0;
 HEAP32[i92 >> 2] = 0;
 i93 = i64 + 68 | 0;
 HEAP32[i93 >> 2] = 1065353216;
 if (!i89) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i64, i1, i22 + 16 | 0);
 f18 = Math_fround(Math_fround(f106 * f102) - Math_fround(f103 * f105));
 f19 = Math_fround(f103 * f104);
 f20 = Math_fround(f106 * f101);
 f17 = Math_fround(Math_fround(f105 * f101) - Math_fround(f102 * f104));
 f15 = Math_fround(Math_fround(f100 * f17) + Math_fround(Math_fround(f98 * f18) + Math_fround(f99 * Math_fround(f19 - f20))));
 i1 = f15 != Math_fround(0.0);
 if (i1) {
  f14 = Math_fround(Math_fround(1.0) / f15);
  f12 = Math_fround(Math_fround(Math_fround(f102 * f98) - Math_fround(f99 * f101)) * f14);
  f8 = Math_fround(-Math_fround(Math_fround(Math_fround(f105 * f98) - Math_fround(f99 * f104)) * f14));
  f5 = Math_fround(f17 * f14);
  f6 = Math_fround(f18 * f14);
  f9 = Math_fround(-Math_fround(Math_fround(Math_fround(f106 * f99) - Math_fround(f105 * f100)) * f14));
  f13 = Math_fround(Math_fround(Math_fround(f103 * f99) - Math_fround(f102 * f100)) * f14);
  f7 = Math_fround(-Math_fround(Math_fround(f20 - f19) * f14));
  f10 = Math_fround(Math_fround(Math_fround(f106 * f98) - Math_fround(f100 * f104)) * f14);
  f14 = Math_fround(-Math_fround(Math_fround(Math_fround(f103 * f98) - Math_fround(f100 * f101)) * f14));
 } else {
  f12 = Math_fround(1.0);
  f8 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(1.0);
  f9 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f10 = Math_fround(1.0);
  f14 = Math_fround(0.0);
 }
 f81 = Math_fround(Math_fround(Math_fround(f39 * f7) + Math_fround(f38 * f6)) + Math_fround(f40 * f5));
 f82 = Math_fround(Math_fround(Math_fround(f39 * f10) + Math_fround(f38 * f9)) + Math_fround(f40 * f8));
 f83 = Math_fround(Math_fround(Math_fround(f39 * f14) + Math_fround(f38 * f13)) + Math_fround(f40 * f12));
 f84 = Math_fround(Math_fround(Math_fround(f42 * f7) + Math_fround(f41 * f6)) + Math_fround(f43 * f5));
 f85 = Math_fround(Math_fround(Math_fround(f42 * f10) + Math_fround(f41 * f9)) + Math_fround(f43 * f8));
 f86 = Math_fround(Math_fround(Math_fround(f42 * f14) + Math_fround(f41 * f13)) + Math_fround(f43 * f12));
 f80 = Math_fround(Math_fround(Math_fround(f45 * f7) + Math_fround(f44 * f6)) + Math_fround(f46 * f5));
 f79 = Math_fround(Math_fround(Math_fround(f45 * f10) + Math_fround(f44 * f9)) + Math_fround(f46 * f8));
 f78 = Math_fround(Math_fround(Math_fround(f45 * f14) + Math_fround(f44 * f13)) + Math_fround(f46 * f12));
 if (i1) {
  f8 = Math_fround(Math_fround(1.0) / f15);
  f14 = Math_fround(Math_fround(Math_fround(f102 * f98) - Math_fround(f99 * f101)) * f8);
  f13 = Math_fround(-Math_fround(Math_fround(Math_fround(f105 * f98) - Math_fround(f99 * f104)) * f8));
  f9 = Math_fround(f17 * f8);
  f7 = Math_fround(f18 * f8);
  f10 = Math_fround(-Math_fround(Math_fround(Math_fround(f106 * f99) - Math_fround(f105 * f100)) * f8));
  f12 = Math_fround(Math_fround(Math_fround(f103 * f99) - Math_fround(f102 * f100)) * f8);
  f5 = Math_fround(-Math_fround(Math_fround(f20 - f19) * f8));
  f6 = Math_fround(Math_fround(Math_fround(f106 * f98) - Math_fround(f100 * f104)) * f8);
  f8 = Math_fround(-Math_fround(Math_fround(Math_fround(f103 * f98) - Math_fround(f100 * f101)) * f8));
 } else {
  f14 = Math_fround(1.0);
  f13 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f7 = Math_fround(1.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(1.0);
  f8 = Math_fround(0.0);
 }
 f75 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = Math_fround(f58 - f75);
 f76 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = Math_fround(f59 - f76);
 f77 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f72 = Math_fround(f57 - f77);
 f74 = Math_fround(Math_fround(Math_fround(f52 * f5) + Math_fround(f51 * f7)) + Math_fround(f72 * f9));
 f73 = Math_fround(Math_fround(Math_fround(f52 * f6) + Math_fround(f51 * f10)) + Math_fround(f72 * f13));
 f72 = Math_fround(Math_fround(Math_fround(f52 * f8) + Math_fround(f51 * f12)) + Math_fround(f72 * f14));
 f8 = Math_fround(HEAPF32[i64 >> 2]);
 f51 = Math_fround(f38 * f8);
 f52 = Math_fround(f39 * f8);
 f53 = Math_fround(f40 * f8);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f41 * f7));
 f52 = Math_fround(f52 + Math_fround(f42 * f7));
 f53 = Math_fround(f53 + Math_fround(f43 * f7));
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f44 * f6));
 f52 = Math_fround(f52 + Math_fround(f45 * f6));
 f53 = Math_fround(f53 + Math_fround(f46 * f6));
 f15 = Math_fround(HEAPF32[i64 + 12 >> 2]);
 f47 = Math_fround(f38 * f15);
 f48 = Math_fround(f39 * f15);
 f50 = Math_fround(f40 * f15);
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f41 * f14));
 f48 = Math_fround(f48 + Math_fround(f42 * f14));
 f50 = Math_fround(f50 + Math_fround(f43 * f14));
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f44 * f13));
 f48 = Math_fround(f48 + Math_fround(f45 * f13));
 f50 = Math_fround(f50 + Math_fround(f46 * f13));
 f17 = Math_fround(HEAPF32[i64 + 24 >> 2]);
 f20 = Math_fround(f38 * f17);
 f19 = Math_fround(f39 * f17);
 f18 = Math_fround(f40 * f17);
 f10 = Math_fround(HEAPF32[i16 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f41 * f10));
 f19 = Math_fround(f19 + Math_fround(f42 * f10));
 f18 = Math_fround(f18 + Math_fround(f43 * f10));
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f44 * f5));
 f19 = Math_fround(f19 + Math_fround(f45 * f5));
 f18 = Math_fround(f18 + Math_fround(f46 * f5));
 i27 = HEAP32[i22 + 36 >> 2] | 0;
 i26 = i27 + 38 | 0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((HEAPU8[i26 >> 0] | 0) * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 f12 = Math_fround(Math_fround(Math_fround(f81 * f8) + Math_fround(f84 * f7)) + Math_fround(f80 * f6));
 f40 = Math_fround(Math_fround(Math_fround(f82 * f8) + Math_fround(f85 * f7)) + Math_fround(f79 * f6));
 f8 = Math_fround(Math_fround(Math_fround(f83 * f8) + Math_fround(f86 * f7)) + Math_fround(f78 * f6));
 f9 = Math_fround(Math_fround(Math_fround(f81 * f15) + Math_fround(f84 * f14)) + Math_fround(f80 * f13));
 f39 = Math_fround(Math_fround(Math_fround(f82 * f15) + Math_fround(f85 * f14)) + Math_fround(f79 * f13));
 f6 = Math_fround(Math_fround(Math_fround(f83 * f15) + Math_fround(f86 * f14)) + Math_fround(f78 * f13));
 f7 = Math_fround(Math_fround(Math_fround(f81 * f17) + Math_fround(f84 * f10)) + Math_fround(f80 * f5));
 f38 = Math_fround(Math_fround(Math_fround(f82 * f17) + Math_fround(f85 * f10)) + Math_fround(f79 * f5));
 f5 = Math_fround(Math_fround(Math_fround(f83 * f17) + Math_fround(f86 * f10)) + Math_fround(f78 * f5));
 i70 = i27 + 40 | 0;
 i71 = i27 + 39 | 0;
 i25 = (HEAP32[i70 >> 2] | 0) + ((HEAPU8[i71 >> 0] | 0) * 20 | 0) | 0;
 i1 = HEAP8[i26 >> 0] | 0;
 i2 = i1 << 24 >> 24 == 0;
 if (i2) {
  f8 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(3402823469999999843913219.0e14);
  f6 = Math_fround(3402823469999999843913219.0e14);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  i3 = i1 & 255;
  i4 = 0;
  do {
   f44 = Math_fround(HEAPF32[i25 + (i4 * 12 | 0) >> 2]);
   f43 = Math_fround(f12 * f44);
   f45 = Math_fround(f40 * f44);
   f44 = Math_fround(f8 * f44);
   f46 = Math_fround(HEAPF32[i25 + (i4 * 12 | 0) + 4 >> 2]);
   f43 = Math_fround(f43 + Math_fround(f9 * f46));
   f45 = Math_fround(f45 + Math_fround(f39 * f46));
   f46 = Math_fround(f44 + Math_fround(f6 * f46));
   f44 = Math_fround(HEAPF32[i25 + (i4 * 12 | 0) + 8 >> 2]);
   f45 = Math_fround(f73 + Math_fround(f45 + Math_fround(f38 * f44)));
   f46 = Math_fround(f72 + Math_fround(f46 + Math_fround(f5 * f44)));
   HEAPF32[i54 + (i4 * 12 | 0) >> 2] = Math_fround(f74 + Math_fround(f43 + Math_fround(f7 * f44)));
   HEAPF32[i54 + (i4 * 12 | 0) + 4 >> 2] = f45;
   HEAPF32[i54 + (i4 * 12 | 0) + 8 >> 2] = f46;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i3 >>> 0);
  if (i2) {
   f8 = Math_fround(3402823469999999843913219.0e14);
   f7 = Math_fround(3402823469999999843913219.0e14);
   f6 = Math_fround(3402823469999999843913219.0e14);
   f10 = Math_fround(-3402823469999999843913219.0e14);
   f9 = Math_fround(-3402823469999999843913219.0e14);
   f5 = Math_fround(-3402823469999999843913219.0e14);
  } else {
   i1 = i1 & 255;
   f6 = Math_fround(3402823469999999843913219.0e14);
   f7 = Math_fround(3402823469999999843913219.0e14);
   f8 = Math_fround(3402823469999999843913219.0e14);
   f5 = Math_fround(-3402823469999999843913219.0e14);
   f9 = Math_fround(-3402823469999999843913219.0e14);
   f10 = Math_fround(-3402823469999999843913219.0e14);
   i2 = 0;
   do {
    f44 = Math_fround(HEAPF32[i54 + (i2 * 12 | 0) >> 2]);
    f6 = f6 < f44 ? f6 : f44;
    f45 = Math_fround(HEAPF32[i54 + (i2 * 12 | 0) + 4 >> 2]);
    f7 = f7 < f45 ? f7 : f45;
    f46 = Math_fround(HEAPF32[i54 + (i2 * 12 | 0) + 8 >> 2]);
    f8 = f8 < f46 ? f8 : f46;
    f5 = f5 > f44 ? f5 : f44;
    f9 = f9 > f45 ? f9 : f45;
    f10 = f10 > f46 ? f10 : f46;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i1 >>> 0);
  }
 }
 i24 = i61 + 40 | 0;
 i69 = Math_fround(HEAPF32[i24 >> 2]) <= Math_fround(0.0);
 f13 = Math_fround(HEAPF32[i107 >> 2]);
 f14 = Math_fround(HEAPF32[i28 >> 2]);
 i49 = ~~Math_fround(Math_floor(Math_fround(f6 * f13)));
 i67 = HEAP32[i61 + 16 >> 2] | 0;
 i68 = i67 + -2 | 0;
 i49 = (i49 | 0) > 0 ? i49 : 0;
 i49 = (i49 | 0) > (i68 | 0) ? i68 : i49;
 i68 = ~~Math_fround(Math_ceil(Math_fround(f5 * f13)));
 i67 = i67 + -1 | 0;
 i68 = (i68 | 0) > 0 ? i68 : 0;
 i68 = (i68 | 0) > (i67 | 0) ? i67 : i68;
 i67 = ~~Math_fround(Math_floor(Math_fround(f8 * f14)));
 i66 = i61 + 20 | 0;
 i37 = HEAP32[i66 >> 2] | 0;
 i65 = i37 + -2 | 0;
 i67 = (i67 | 0) > 0 ? i67 : 0;
 i67 = (i67 | 0) > (i65 | 0) ? i65 : i67;
 i65 = ~~Math_fround(Math_ceil(Math_fround(f10 * f14)));
 i37 = i37 + -1 | 0;
 i65 = (i65 | 0) > 0 ? i65 : 0;
 i65 = (i65 | 0) > (i37 | 0) ? i37 : i65;
 f15 = Math_fround(__ZNK5physx2Gu11HeightField14computeExtremeEjjjj(i61, i49, i68, i67, i65));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i96 >> 2]));
 if (i69) {
  if (f7 > f15) {
   i112 = 0;
   STACKTOP = i113;
   return i112 | 0;
  }
 } else if (f9 < f15) {
  i112 = 0;
  STACKTOP = i113;
  return i112 | 0;
 }
 i1 = HEAP8[i26 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = i1 & 255; else {
  i22 = i110 + 4096 | 0;
  i23 = 0;
  do {
   i2 = i54 + (i23 * 12 | 0) + 4 | 0;
   f46 = Math_fround(HEAPF32[i2 >> 2]);
   do if (i69 ? f46 < f15 : f46 > f15) {
    f5 = Math_fround(HEAPF32[i54 + (i23 * 12 | 0) >> 2]);
    f6 = Math_fround(HEAPF32[i54 + (i23 * 12 | 0) + 8 >> 2]);
    f7 = Math_fround(f5 * Math_fround(HEAPF32[i107 >> 2]));
    f8 = Math_fround(f6 * Math_fround(HEAPF32[i28 >> 2]));
    if (f7 >= Math_fround(0.0) & f8 >= Math_fround(0.0)) {
     i1 = HEAP32[i95 >> 2] | 0;
     if (f7 < Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + Math_fround(1.0))) if (f8 < Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) + Math_fround(1.0))) {
      i16 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i1, Math_fround(f13 * f5), Math_fround(f14 * f6), i30, i31) | 0;
      f7 = Math_fround(HEAPF32[i30 >> 2]);
      f8 = Math_fround(HEAPF32[i31 >> 2]);
      f12 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff(i107, i16, f7, f8));
      f12 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f12);
      f5 = Math_fround(HEAPF32[i111 >> 2]);
      f6 = Math_fround(HEAPF32[i24 >> 2]);
      if (!(f6 <= f12) | (!(f12 <= f5) | !(f6 <= Math_fround(0.0)))) if (!(f6 > f12 & (f12 > Math_fround(-f5) & f6 > Math_fround(0.0)))) break;
      i21 = __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff(i107, i16, f7, f8) | 0;
      if ((i21 | 0) != -1) {
       f5 = Math_fround(HEAPF32[i30 >> 2]);
       f6 = Math_fround(HEAPF32[i31 >> 2]);
       i11 = HEAP32[i95 >> 2] | 0;
       f8 = Math_fround(HEAPF32[i107 >> 2]);
       f7 = Math_fround(HEAPF32[i29 >> 2]);
       f9 = Math_fround(HEAPF32[i28 >> 2]);
       i2 = HEAP32[i11 + 36 >> 2] | 0;
       do if ((HEAP8[i2 + (i16 << 2) + 2 >> 0] | 0) < 0) {
        i3 = HEAP16[i2 + (i16 << 2) >> 1] | 0;
        i1 = (HEAP32[i11 + 20 >> 2] | 0) + i16 | 0;
        i4 = HEAP16[i2 + (i1 + 1 << 2) >> 1] | 0;
        if (!(f6 >= f5)) {
         i1 = HEAP16[i2 + (i1 << 2) >> 1] | 0;
         i2 = i1 - i4 | 0;
         i1 = i3 - i1 | 0;
         break;
        } else {
         i1 = HEAP16[i2 + (i16 + 1 << 2) >> 1] | 0;
         i2 = i3 - i1 | 0;
         i1 = i1 - i4 | 0;
         break;
        }
       } else {
        i3 = HEAP16[i2 + (i16 + 1 << 2) >> 1] | 0;
        i1 = (HEAP32[i11 + 20 >> 2] | 0) + i16 | 0;
        i4 = HEAP16[i2 + (i1 << 2) >> 1] | 0;
        if (!(Math_fround(f5 + f6) <= Math_fround(1.0))) {
         i1 = HEAP16[i2 + (i1 + 1 << 2) >> 1] | 0;
         i2 = i4 - i1 | 0;
         i1 = i3 - i1 | 0;
         break;
        } else {
         i1 = HEAP16[i2 + (i16 << 2) >> 1] | 0;
         i2 = i1 - i3 | 0;
         i1 = i1 - i4 | 0;
         break;
        }
       } while (0);
       f6 = Math_fround(f8 * Math_fround(i1 | 0));
       f5 = Math_fround(f9 * Math_fround(i2 | 0));
       if (!(Math_fround(HEAPF32[i11 + 40 >> 2]) <= Math_fround(0.0))) {
        f5 = Math_fround(-f5);
        f8 = Math_fround(-f6);
        f7 = Math_fround(-f7);
       } else f8 = f6;
       f6 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f5 * f5));
       if (f6 > Math_fround(0.0)) {
        f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
        f10 = Math_fround(f5 * f46);
        f9 = Math_fround(f7 * f46);
        f5 = Math_fround(f8 * f46);
       } else {
        f10 = Math_fround(0.0);
        f9 = Math_fround(0.0);
        f5 = Math_fround(0.0);
       }
       f6 = Math_fround(HEAPF32[i25 + (i23 * 12 | 0) >> 2]);
       f7 = Math_fround(HEAPF32[i25 + (i23 * 12 | 0) + 4 >> 2]);
       f8 = Math_fround(HEAPF32[i25 + (i23 * 12 | 0) + 8 >> 2]);
       i1 = HEAP32[i22 >> 2] | 0;
       if (i1 >>> 0 <= 63) {
        f46 = Math_fround(f12 * f9);
        f42 = Math_fround(Math_fround(Math_fround(f100 * f5) + Math_fround(f103 * f9)) + Math_fround(f106 * f10));
        f41 = Math_fround(Math_fround(Math_fround(f99 * f5) + Math_fround(f102 * f9)) + Math_fround(f105 * f10));
        f17 = Math_fround(Math_fround(Math_fround(f98 * f5) + Math_fround(f101 * f9)) + Math_fround(f104 * f10));
        f45 = Math_fround(f57 + Math_fround(Math_fround(Math_fround(f53 * f6) + Math_fround(f50 * f7)) + Math_fround(f18 * f8)));
        f44 = Math_fround(f59 + Math_fround(Math_fround(Math_fround(f52 * f6) + Math_fround(f48 * f7)) + Math_fround(f19 * f8)));
        f43 = Math_fround(f58 + Math_fround(Math_fround(Math_fround(f51 * f6) + Math_fround(f47 * f7)) + Math_fround(f20 * f8)));
        HEAP32[i22 >> 2] = i1 + 1;
        HEAPF32[i110 + (i1 << 6) >> 2] = f17;
        HEAPF32[i110 + (i1 << 6) + 4 >> 2] = f41;
        HEAPF32[i110 + (i1 << 6) + 8 >> 2] = f42;
        HEAPF32[i110 + (i1 << 6) + 16 >> 2] = f43;
        HEAPF32[i110 + (i1 << 6) + 20 >> 2] = f44;
        HEAPF32[i110 + (i1 << 6) + 24 >> 2] = f45;
        HEAPF32[i110 + (i1 << 6) + 12 >> 2] = f46;
        HEAP32[i110 + (i1 << 6) + 48 >> 2] = -1;
        HEAP32[i110 + (i1 << 6) + 52 >> 2] = i21;
       }
      }
     }
    }
   } while (0);
   i23 = i23 + 1 | 0;
   i1 = HEAPU8[i26 >> 0] | 0;
  } while (i23 >>> 0 < i1 >>> 0);
 }
 i16 = HEAPU8[i71 >> 0] | 0;
 i37 = HEAP32[i70 >> 2] | 0;
 i16 = __ZN5physx2Gu21findUniqueConvexEdgesEjPNS0_10ConvexEdgeEjPKNS0_15HullPolygonDataEPKh(512, i63, i16, i37, i37 + ((i16 * 20 | 0) + (i1 * 15 | 0) + (HEAPU16[i27 + 36 >> 1] << 1)) | 0) | 0;
 if (i16 | 0) {
  i21 = i62 + 4 | 0;
  i22 = i62 + 8 | 0;
  i23 = i62 + 12 | 0;
  i24 = i62 + 52 | 0;
  i25 = i62 + 16 | 0;
  i26 = i62 + 20 | 0;
  i27 = i62 + 24 | 0;
  i28 = i62 + 28 | 0;
  i29 = i62 + 32 | 0;
  i30 = i62 + 36 | 0;
  i31 = i62 + 40 | 0;
  i32 = i62 + 44 | 0;
  i33 = i62 + 48 | 0;
  i34 = i62 + 56 | 0;
  i35 = i62 + 60 | 0;
  i36 = i62 + 64 | 0;
  i37 = i62 + 68 | 0;
  if (i69) {
   i11 = 0;
   do {
    f59 = Math_fround(f40 * Math_fround(HEAPF32[i63 + (i11 << 4) + 4 >> 2]));
    f59 = Math_fround(f59 + Math_fround(f39 * Math_fround(HEAPF32[i63 + (i11 << 4) + 8 >> 2])));
    do if (!(Math_fround(f59 + Math_fround(f38 * Math_fround(HEAPF32[i63 + (i11 << 4) + 12 >> 2]))) > Math_fround(0.0))) {
     i1 = HEAPU8[i63 + (i11 << 4) >> 0] | 0;
     i2 = i54 + (i1 * 12 | 0) | 0;
     i3 = HEAPU8[i63 + (i11 << 4) + 1 >> 0] | 0;
     i4 = i54 + (i3 * 12 | 0) | 0;
     if (Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 4 >> 2]) > f15) if (Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 4 >> 2]) > f15) break;
     f57 = Math_fround(HEAPF32[i4 >> 2]);
     f57 = Math_fround(f57 - Math_fround(HEAPF32[i2 >> 2]));
     f58 = Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 4 >> 2]);
     f58 = Math_fround(f58 - Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 4 >> 2]));
     f59 = Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 8 >> 2]);
     f59 = Math_fround(f59 - Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 8 >> 2]));
     i3 = HEAP32[i111 >> 2] | 0;
     HEAPF32[i62 >> 2] = f57;
     HEAPF32[i21 >> 2] = f58;
     HEAPF32[i22 >> 2] = f59;
     HEAP32[i23 >> 2] = i110;
     HEAPF32[i25 >> 2] = f98;
     HEAPF32[i26 >> 2] = f99;
     HEAPF32[i27 >> 2] = f100;
     HEAPF32[i28 >> 2] = f101;
     HEAPF32[i29 >> 2] = f102;
     HEAPF32[i30 >> 2] = f103;
     HEAPF32[i31 >> 2] = f104;
     HEAPF32[i32 >> 2] = f105;
     HEAPF32[i33 >> 2] = f106;
     HEAP32[i24 >> 2] = i56;
     HEAP32[i34 >> 2] = i60;
     HEAP32[i35 >> 2] = i55;
     HEAP32[i36 >> 2] = i3;
     HEAP32[i37 >> 2] = -1;
     __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i107, i2, i4, i62, 0);
    } while (0);
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i16 | 0));
  } else {
   i11 = 0;
   do {
    f59 = Math_fround(f40 * Math_fround(HEAPF32[i63 + (i11 << 4) + 4 >> 2]));
    f59 = Math_fround(f59 + Math_fround(f39 * Math_fround(HEAPF32[i63 + (i11 << 4) + 8 >> 2])));
    do if (!(Math_fround(f59 + Math_fround(f38 * Math_fround(HEAPF32[i63 + (i11 << 4) + 12 >> 2]))) > Math_fround(0.0))) {
     i1 = HEAPU8[i63 + (i11 << 4) >> 0] | 0;
     i2 = i54 + (i1 * 12 | 0) | 0;
     i3 = HEAPU8[i63 + (i11 << 4) + 1 >> 0] | 0;
     i4 = i54 + (i3 * 12 | 0) | 0;
     if (Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 4 >> 2]) < f15) if (Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 4 >> 2]) < f15) break;
     f57 = Math_fround(HEAPF32[i4 >> 2]);
     f57 = Math_fround(f57 - Math_fround(HEAPF32[i2 >> 2]));
     f58 = Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 4 >> 2]);
     f58 = Math_fround(f58 - Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 4 >> 2]));
     f59 = Math_fround(HEAPF32[i54 + (i3 * 12 | 0) + 8 >> 2]);
     f59 = Math_fround(f59 - Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 8 >> 2]));
     i3 = HEAP32[i111 >> 2] | 0;
     HEAPF32[i62 >> 2] = f57;
     HEAPF32[i21 >> 2] = f58;
     HEAPF32[i22 >> 2] = f59;
     HEAP32[i23 >> 2] = i110;
     HEAPF32[i25 >> 2] = f98;
     HEAPF32[i26 >> 2] = f99;
     HEAPF32[i27 >> 2] = f100;
     HEAPF32[i28 >> 2] = f101;
     HEAPF32[i29 >> 2] = f102;
     HEAPF32[i30 >> 2] = f103;
     HEAPF32[i31 >> 2] = f104;
     HEAPF32[i32 >> 2] = f105;
     HEAPF32[i33 >> 2] = f106;
     HEAP32[i24 >> 2] = i56;
     HEAP32[i34 >> 2] = i60;
     HEAP32[i35 >> 2] = i55;
     HEAP32[i36 >> 2] = i3;
     HEAP32[i37 >> 2] = -1;
     __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i107, i2, i4, i62, 0);
    } while (0);
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i16 | 0));
  }
 }
 if (i49 >>> 0 > i68 >>> 0) i1 = i110 + 4096 | 0; else {
  i56 = i67 >>> 0 > i65 >>> 0;
  i33 = i61 + 36 | 0;
  i34 = i109 + 4 | 0;
  i35 = i109 + 8 | 0;
  i36 = i108 + 4 | 0;
  i37 = i108 + 8 | 0;
  i1 = i110 + 4096 | 0;
  i54 = i64 + 36 | 0;
  i55 = i64 + 48 | 0;
  i32 = i64 + 60 | 0;
  do {
   if (!i56) {
    f50 = Math_fround(i49 >>> 0);
    i31 = i67;
    do {
     i30 = (Math_imul(HEAP32[i66 >> 2] | 0, i49) | 0) + i31 | 0;
     L90 : do if ((HEAP8[(HEAP32[(HEAP32[i95 >> 2] | 0) + 36 >> 2] | 0) + (i30 << 2) + 3 >> 0] | 0) < 0) {
      f51 = Math_fround(f50 * Math_fround(HEAPF32[i97 >> 2]));
      f52 = Math_fround(HEAPF32[i96 >> 2]);
      f52 = Math_fround(f52 * Math_fround(HEAP16[(HEAP32[i33 >> 2] | 0) + (i30 << 2) >> 1] | 0));
      f53 = Math_fround(Math_fround(i31 >>> 0) * Math_fround(HEAPF32[i94 >> 2]));
      __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i109, i107, i30, i49, i31);
      if (i69) {
       i2 = HEAP32[i109 >> 2] | 0;
       i3 = HEAP32[i34 >> 2] | 0;
       i4 = HEAP32[i35 >> 2] | 0;
      } else {
       f57 = Math_fround(-Math_fround(HEAPF32[i109 >> 2]));
       f58 = Math_fround(-Math_fround(HEAPF32[i34 >> 2]));
       f59 = Math_fround(-Math_fround(HEAPF32[i35 >> 2]));
       i2 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
      }
      f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = Math_fround(f8 * f8);
      f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = Math_fround(Math_fround(f7 * f7) + f6);
      f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = Math_fround(Math_fround(f5 * f5) + f6);
      if (f6 > Math_fround(0.0)) {
       f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
       f48 = Math_fround(f5 * f46);
       f47 = Math_fround(f7 * f46);
       f46 = Math_fround(f8 * f46);
      } else {
       f48 = Math_fround(0.0);
       f47 = Math_fround(0.0);
       f46 = Math_fround(0.0);
      }
      f42 = Math_fround(f51 - f74);
      f41 = Math_fround(f52 - f73);
      f43 = Math_fround(f53 - f72);
      f39 = Math_fround(Math_fround(f83 * f43) + Math_fround(Math_fround(f81 * f42) + Math_fround(f82 * f41)));
      f40 = Math_fround(Math_fround(f86 * f43) + Math_fround(Math_fround(f84 * f42) + Math_fround(f85 * f41)));
      f41 = Math_fround(Math_fround(f78 * f43) + Math_fround(Math_fround(f80 * f42) + Math_fround(f79 * f41)));
      f42 = Math_fround(-Math_fround(Math_fround(Math_fround(f81 * f46) + Math_fround(f82 * f47)) + Math_fround(f83 * f48)));
      f43 = Math_fround(-Math_fround(Math_fround(Math_fround(f84 * f46) + Math_fround(f85 * f47)) + Math_fround(f86 * f48)));
      f44 = Math_fround(-Math_fround(Math_fround(Math_fround(f80 * f46) + Math_fround(f79 * f47)) + Math_fround(f78 * f48)));
      i27 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
      i28 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
      i29 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
      f45 = Math_fround(HEAPF32[i111 >> 2]);
      i2 = HEAP8[i71 >> 0] | 0;
      if (!(i2 << 24 >> 24)) {
       f5 = Math_fround(-3402823469999999843913219.0e14);
       i112 = 82;
      } else {
       i26 = HEAP32[i70 >> 2] | 0;
       i25 = i2 & 255;
       f12 = Math_fround(HEAPF32[i54 >> 2]);
       f13 = Math_fround(HEAPF32[i87 >> 2]);
       f14 = Math_fround(HEAPF32[i88 >> 2]);
       f15 = Math_fround(HEAPF32[i55 >> 2]);
       f17 = Math_fround(HEAPF32[i90 >> 2]);
       f18 = Math_fround(HEAPF32[i91 >> 2]);
       f19 = Math_fround(HEAPF32[i32 >> 2]);
       f20 = Math_fround(HEAPF32[i92 >> 2]);
       f38 = Math_fround(HEAPF32[i93 >> 2]);
       if (i89) {
        i4 = 0;
        i3 = 0;
        i2 = 0;
        f10 = Math_fround(-3402823469999999843913219.0e14);
        f9 = Math_fround(-3402823469999999843913219.0e14);
        i24 = 0;
        i16 = -1;
        i11 = -2;
        while (1) {
         i23 = HEAP32[i26 + (i24 * 20 | 0) >> 2] | 0;
         i22 = HEAP32[i26 + (i24 * 20 | 0) + 4 >> 2] | 0;
         i21 = HEAP32[i26 + (i24 * 20 | 0) + 8 >> 2] | 0;
         f59 = Math_fround(HEAPF32[i26 + (i24 * 20 | 0) + 12 >> 2]);
         f5 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f8 = Math_fround(f39 * f5);
         f6 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f8 = Math_fround(f8 + Math_fround(f40 * f6));
         f7 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f8 = Math_fround(Math_fround(f59 + Math_fround(Math_fround(f41 * f7) + f8)) - f45);
         if (f8 >= Math_fround(0.0)) break L90;
         f5 = Math_fround(Math_fround(Math_fround(f5 * f42) + Math_fround(f6 * f43)) + Math_fround(f7 * f44));
         do if (f5 > Math_fround(0.0)) {
          if (f8 > f10) {
           i2 = i21;
           i3 = i22;
           i4 = i23;
           f10 = f8;
           i16 = i24;
          }
          f5 = Math_fround(f8 / f5);
          if (!(f5 > f9)) {
           f5 = f9;
           break;
          }
          i11 = i24;
         } else f5 = f9; while (0);
         i24 = i24 + 1 | 0;
         if (i24 >>> 0 >= i25 >>> 0) break; else f9 = f5;
        }
       } else {
        i4 = 0;
        i3 = 0;
        i2 = 0;
        f10 = Math_fround(-3402823469999999843913219.0e14);
        f9 = Math_fround(-3402823469999999843913219.0e14);
        i24 = 0;
        i16 = -1;
        i11 = -2;
        while (1) {
         f59 = Math_fround(HEAPF32[i26 + (i24 * 20 | 0) + 12 >> 2]);
         f58 = Math_fround(HEAPF32[i26 + (i24 * 20 | 0) >> 2]);
         f5 = Math_fround(f12 * f58);
         f8 = Math_fround(HEAPF32[i26 + (i24 * 20 | 0) + 4 >> 2]);
         f5 = Math_fround(f5 + Math_fround(f13 * f8));
         f7 = Math_fround(HEAPF32[i26 + (i24 * 20 | 0) + 8 >> 2]);
         f5 = Math_fround(f5 + Math_fround(f14 * f7));
         f6 = Math_fround(Math_fround(Math_fround(f15 * f58) + Math_fround(f17 * f8)) + Math_fround(f18 * f7));
         f7 = Math_fround(Math_fround(Math_fround(f19 * f58) + Math_fround(f20 * f8)) + Math_fround(f38 * f7));
         f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6))))));
         f5 = Math_fround(f5 * f8);
         f6 = Math_fround(f6 * f8);
         f7 = Math_fround(f7 * f8);
         i23 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
         i22 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
         i21 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
         f8 = Math_fround(Math_fround(Math_fround(f59 * f8) + Math_fround(Math_fround(f41 * f7) + Math_fround(Math_fround(f40 * f6) + Math_fround(f39 * f5)))) - f45);
         if (f8 >= Math_fround(0.0)) break L90;
         f5 = Math_fround(Math_fround(f7 * f44) + Math_fround(Math_fround(f5 * f42) + Math_fround(f6 * f43)));
         do if (f5 > Math_fround(0.0)) {
          if (f8 > f10) {
           i2 = i21;
           i3 = i22;
           i4 = i23;
           f10 = f8;
           i16 = i24;
          }
          f5 = Math_fround(f8 / f5);
          if (!(f5 > f9)) {
           f5 = f9;
           break;
          }
          i11 = i24;
         } else f5 = f9; while (0);
         i24 = i24 + 1 | 0;
         if (i24 >>> 0 >= i25 >>> 0) break; else f9 = f5;
        }
       }
       if ((i16 | 0) != (i11 | 0)) i112 = 82;
      }
      if ((i112 | 0) == 82) {
       i112 = 0;
       i4 = i27;
       i3 = i28;
       i2 = i29;
       f10 = f5;
      }
      f8 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f6 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f58 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f59 = Math_fround(Math_fround(f79 * f58) + Math_fround(Math_fround(f85 * f6) + Math_fround(f82 * f8)));
      f9 = Math_fround(Math_fround(f78 * f58) + Math_fround(Math_fround(f86 * f6) + Math_fround(f83 * f8)));
      HEAPF32[i108 >> 2] = Math_fround(Math_fround(f80 * f58) + Math_fround(Math_fround(f84 * f6) + Math_fround(f81 * f8)));
      HEAPF32[i36 >> 2] = f59;
      HEAPF32[i37 >> 2] = f9;
      __ZNK5physx2Gu15HeightFieldUtil30clipShapeNormalToVertexVoronoiERNS_6PxVec3Ejjj(i107, i108, i30, i49, i31) | 0;
      f9 = Math_fround(HEAPF32[i108 >> 2]);
      f59 = Math_fround(f46 * f9);
      f8 = Math_fround(HEAPF32[i36 >> 2]);
      f59 = Math_fround(f59 + Math_fround(f47 * f8));
      f6 = Math_fround(HEAPF32[i37 >> 2]);
      if (!(Math_fround(f59 + Math_fround(f48 * f6)) < Math_fround(1.1920929e-07))) {
       f5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f6 * f6));
       if (f5 > Math_fround(0.0)) {
        f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
        f7 = Math_fround(f6 * f5);
        f6 = Math_fround(f8 * f5);
        f5 = Math_fround(f9 * f5);
       } else {
        f7 = Math_fround(0.0);
        f6 = Math_fround(0.0);
        f5 = Math_fround(0.0);
       }
       HEAPF32[i108 >> 2] = f5;
       HEAPF32[i36 >> 2] = f6;
       HEAPF32[i37 >> 2] = f7;
       i2 = __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj(i107, i30, i49, i31) | 0;
       f5 = Math_fround(HEAPF32[i108 >> 2]);
       f6 = Math_fround(HEAPF32[i36 >> 2]);
       f7 = Math_fround(HEAPF32[i37 >> 2]);
       i3 = HEAP32[i1 >> 2] | 0;
       if (i3 >>> 0 > 63) break;
       f48 = Math_fround(Math_fround(Math_fround(f100 * f5) + Math_fround(f103 * f6)) + Math_fround(f106 * f7));
       f47 = Math_fround(Math_fround(Math_fround(f99 * f5) + Math_fround(f102 * f6)) + Math_fround(f105 * f7));
       f46 = Math_fround(Math_fround(Math_fround(f98 * f5) + Math_fround(f101 * f6)) + Math_fround(f104 * f7));
       f59 = Math_fround(f77 + Math_fround(Math_fround(f106 * f53) + Math_fround(Math_fround(f100 * f51) + Math_fround(f103 * f52))));
       f58 = Math_fround(f76 + Math_fround(Math_fround(f105 * f53) + Math_fround(Math_fround(f99 * f51) + Math_fround(f102 * f52))));
       f57 = Math_fround(f75 + Math_fround(Math_fround(f104 * f53) + Math_fround(Math_fround(f98 * f51) + Math_fround(f101 * f52))));
       HEAP32[i1 >> 2] = i3 + 1;
       HEAPF32[i110 + (i3 << 6) >> 2] = f46;
       HEAPF32[i110 + (i3 << 6) + 4 >> 2] = f47;
       HEAPF32[i110 + (i3 << 6) + 8 >> 2] = f48;
       HEAPF32[i110 + (i3 << 6) + 16 >> 2] = f57;
       HEAPF32[i110 + (i3 << 6) + 20 >> 2] = f58;
       HEAPF32[i110 + (i3 << 6) + 24 >> 2] = f59;
       HEAPF32[i110 + (i3 << 6) + 12 >> 2] = f10;
       HEAP32[i110 + (i3 << 6) + 48 >> 2] = -1;
       HEAP32[i110 + (i3 << 6) + 52 >> 2] = i2;
      }
     } while (0);
     i31 = i31 + 1 | 0;
    } while (i31 >>> 0 <= i65 >>> 0);
   }
   i49 = i49 + 1 | 0;
  } while (i49 >>> 0 <= i68 >>> 0);
 }
 i112 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i113;
 return i112 | 0;
}

function __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE(i10, i7, i71, i74) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i71 = i71 | 0;
 i74 = i74 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0;
 i83 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i83 + 40 | 0;
 i51 = i83 + 16 | 0;
 i53 = i83;
 i54 = i83 + 200 | 0;
 i80 = i83 + 188 | 0;
 i81 = i83 + 176 | 0;
 i82 = i83 + 164 | 0;
 i75 = i83 + 144 | 0;
 i76 = i83 + 124 | 0;
 i77 = i83 + 104 | 0;
 i78 = i83 + 84 | 0;
 i52 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i80 >> 2] = 0;
 i79 = i80 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i79;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i52 << 2;
 i6 = (i5 | 0) != 0;
 do if (i6) {
  i1 = i5 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 900251 | 0, 85) | 0;
   i3 = gb + 64016 | 0;
   i73 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i80 >> 2] = i2;
   i4 = i79;
   HEAP32[i4 >> 2] = i73;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i50 = i2 + 3 & -4;
 HEAP32[i81 >> 2] = 0;
 i73 = i81 + 4 | 0;
 i72 = i73;
 HEAP32[i72 >> 2] = i3;
 HEAP32[i72 + 4 >> 2] = i4;
 do if (i6) {
  i1 = i5 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 900251 | 0, 88) | 0;
   i3 = gb + 64016 | 0;
   i72 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i81 >> 2] = i2;
   i4 = i73;
   HEAP32[i4 >> 2] = i72;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i49 = i2 + 3 & -4;
 HEAP32[i82 >> 2] = 0;
 i72 = i82 + 4 | 0;
 i70 = i72;
 HEAP32[i70 >> 2] = i3;
 HEAP32[i70 + 4 >> 2] = i4;
 if (!(i5 >>> 0 < 2e3 | i6 ^ 1)) {
  i70 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 900251 | 0, 91) | 0;
  i69 = gb + 64016 | 0;
  i68 = HEAP32[i69 >> 2] | 0;
  i69 = HEAP32[i69 + 4 >> 2] | 0;
  HEAP32[i82 >> 2] = i70;
  i70 = i72;
  HEAP32[i70 >> 2] = i68;
  HEAP32[i70 + 4 >> 2] = i69;
 }
 i61 = (i71 | 0) != 0;
 if (i61) i1 = HEAP32[i71 >> 2] | 0; else i1 = 0;
 i70 = __ZN7mecanim9animation18CreateAnimationSetEjjjRNS_6memory9AllocatorE(i52, i7, i1, i74) | 0;
 HEAP32[i70 + 32 >> 2] = 4;
 i7 = i70 + 4 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i8 = i70 + 8 | 0;
  i9 = i70 + 36 | 0;
  i6 = 0;
  do {
   i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if (!i4) i55 = 191; else {
    i1 = HEAP32[i4 + 216 >> 2] | 0;
    if (!i1) i55 = 191; else if (!(HEAP32[i4 + 220 >> 2] | 0)) i55 = 191; else {
     i5 = HEAP32[i8 >> 2] | 0;
     i2 = i5 + (i6 * 40 | 0) | 0;
     HEAP32[i2 >> 2] = i4;
     i1 = __ZN7mecanim9animation15HasMotionCurvesERKNS0_18ClipMuscleConstantE(i1) | 0;
     i3 = 1;
    }
   }
   if ((i55 | 0) == 191) {
    i55 = 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i2 = i5 + (i6 * 40 | 0) | 0;
    HEAP32[i2 >> 2] = i4;
    i1 = 0;
    i3 = 0;
   }
   HEAP8[i9 >> 0] = HEAPU8[i9 >> 0] | i1 & 1;
   i1 = i50 + (i6 << 2) | 0;
   if (i3) {
    HEAP32[i1 >> 2] = i2;
    HEAP32[i49 + (i6 << 2) >> 2] = i4 + 224;
    i1 = HEAP32[i4 + 244 >> 2] | 0;
   } else {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i49 + (i6 << 2) >> 2] = 0;
    i1 = 0;
   }
   HEAP32[i5 + (i6 * 40 | 0) + 36 >> 2] = i1;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 i63 = gb + 64016 | 0;
 i62 = HEAP32[i63 + 4 >> 2] | 0;
 i58 = i51;
 HEAP32[i58 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i58 + 4 >> 2] = i62;
 HEAP32[i75 >> 2] = 0;
 i58 = i75 + 12 | 0;
 HEAP32[i58 >> 2] = 0;
 i62 = i75 + 16 | 0;
 HEAP32[i62 >> 2] = 0;
 i63 = i75 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i56, i51);
 i59 = i56;
 i64 = HEAP32[i59 + 4 >> 2] | 0;
 i65 = i63;
 HEAP32[i65 >> 2] = HEAP32[i59 >> 2];
 HEAP32[i65 + 4 >> 2] = i64;
 i65 = gb + 64016 | 0;
 i64 = HEAP32[i65 + 4 >> 2] | 0;
 i59 = i51;
 HEAP32[i59 >> 2] = HEAP32[i65 >> 2];
 HEAP32[i59 + 4 >> 2] = i64;
 HEAP32[i76 >> 2] = 0;
 i59 = i76 + 12 | 0;
 HEAP32[i59 >> 2] = 0;
 i64 = i76 + 16 | 0;
 HEAP32[i64 >> 2] = 0;
 i65 = i76 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i56, i51);
 i57 = i56;
 i66 = HEAP32[i57 + 4 >> 2] | 0;
 i67 = i65;
 HEAP32[i67 >> 2] = HEAP32[i57 >> 2];
 HEAP32[i67 + 4 >> 2] = i66;
 i67 = gb + 64016 | 0;
 i66 = HEAP32[i67 + 4 >> 2] | 0;
 i57 = i51;
 HEAP32[i57 >> 2] = HEAP32[i67 >> 2];
 HEAP32[i57 + 4 >> 2] = i66;
 HEAP32[i77 >> 2] = 0;
 i57 = i77 + 12 | 0;
 HEAP32[i57 >> 2] = 0;
 i66 = i77 + 16 | 0;
 HEAP32[i66 >> 2] = 0;
 i67 = i77 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i56, i51);
 i60 = i56;
 i68 = HEAP32[i60 + 4 >> 2] | 0;
 i69 = i67;
 HEAP32[i69 >> 2] = HEAP32[i60 >> 2];
 HEAP32[i69 + 4 >> 2] = i68;
 i69 = gb + 64016 | 0;
 i68 = HEAP32[i69 + 4 >> 2] | 0;
 i60 = i51;
 HEAP32[i60 >> 2] = HEAP32[i69 >> 2];
 HEAP32[i60 + 4 >> 2] = i68;
 HEAP32[i78 >> 2] = 0;
 i60 = i78 + 12 | 0;
 HEAP32[i60 >> 2] = 0;
 i68 = i78 + 16 | 0;
 HEAP32[i68 >> 2] = 0;
 i69 = i78 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i56, i51);
 i45 = i56;
 i5 = HEAP32[i45 + 4 >> 2] | 0;
 i44 = i69;
 HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i44 + 4 >> 2] = i5;
 i44 = i54 + 4 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP8[i54 + 8 >> 0] = 0;
 i5 = i54 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i54 + 36 >> 2] = 0;
 HEAP32[i54 + 28 >> 2] = 10;
 HEAP32[i54 + 32 >> 2] = -1;
 i5 = i54 + 56 | 0;
 i45 = i54 + 100 | 0;
 HEAP32[i45 >> 2] = 0;
 i46 = i54 + 104 | 0;
 HEAP32[i46 >> 2] = 32;
 i47 = i54 + 108 | 0;
 HEAP32[i47 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i54 + 124 >> 2] = i1;
 HEAP32[i54 + 116 >> 2] = 16;
 HEAP32[i54 + 112 >> 2] = 6;
 HEAP8[i54 + 120 >> 0] = 0;
 HEAP8[i54 + 9 >> 0] = 1;
 HEAP32[i54 + 56 >> 2] = -1;
 HEAP32[i54 + 60 >> 2] = -1;
 i48 = i54 + 64 | 0;
 HEAP32[i48 >> 2] = 0;
 HEAP32[i48 + 4 >> 2] = 0;
 HEAP32[i54 + 72 >> 2] = 10;
 HEAP32[i54 + 76 >> 2] = -1;
 HEAP32[i54 + 80 >> 2] = 0;
 i48 = i54 + 124 | 0;
 HEAP32[i56 >> 2] = 1;
 HEAP32[i56 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1408, 16, i56, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i45 >> 2] = i1;
 i6 = i1 + ((HEAP32[i46 >> 2] | 0) * 44 | 0) | 0;
 if ((i1 | 0) != (i6 | 0)) do {
  i2 = i1;
  i3 = i5;
  i4 = i2 + 44 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i19 = (i52 | 0) == 0;
 if (!i19) {
  i11 = i56 + 16 | 0;
  i12 = i56 + 20 | 0;
  i13 = i56 + 24 | 0;
  i14 = i56 + 28 | 0;
  i15 = i53 + 4 | 0;
  i10 = 0;
  do {
   i16 = HEAP32[i49 + (i10 << 2) >> 2] | 0;
   if (i16 | 0) {
    i1 = (HEAP32[(HEAP32[HEAP32[i50 + (i10 << 2) >> 2] >> 2] | 0) + 216 >> 2] | 0) + 1060 | 0;
    i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
    i17 = (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) | 0;
    i18 = i16 + 12 | 0;
    if (HEAP32[i18 >> 2] | 0) {
     i8 = i1 + 40 | 0;
     i9 = i8;
     i6 = 0;
     i7 = 0;
     while (1) {
      i3 = HEAP32[i16 >> 2] | 0;
      i2 = i3 + (i7 << 4) | 0;
      i1 = HEAP32[i3 + (i7 << 4) + 4 >> 2] | 0;
      i3 = i3 + (i7 << 4) + 12 | 0;
      L48 : do if ((HEAP16[i3 >> 1] | 0) == 4) if ((i1 | 0) == 2) i5 = 4; else {
       switch (i1 | 0) {
       case 1:
       case 3:
       case 4:
        {
         i5 = 3;
         break L48;
        }
       default:
        {}
       }
       i5 = 1;
      } else i5 = 1; while (0);
      _memmove(i56 | 0, i2 | 0, 16) | 0;
      HEAP32[i11 >> 2] = 10;
      HEAP32[i12 >> 2] = -1;
      HEAP32[i13 >> 2] = 0;
      HEAP32[i14 >> 2] = HEAP32[i51 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
      __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i54, 1, 0);
      __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS7_(i53, i54, i56);
      i4 = HEAP32[i15 >> 2] | 0;
      L53 : do if (i6 >>> 0 < i17 >>> 0) i55 = 32; else if ((HEAP16[i3 >> 1] | 0) == 4) {
       i1 = (HEAP32[i8 >> 2] | 0) + i9 + (i6 - i17 << 2) | 0;
       i2 = i4 + 24 | 0;
       switch (HEAP32[i2 >> 2] | 0) {
       case 0:
        {
         HEAP32[i2 >> 2] = 2;
         _memcpy(i4 + 28 | 0, i1 | 0, i5 << 2 | 0) | 0;
         break L53;
        }
       case 2:
        break;
       default:
        break L53;
       }
       if (_memcmp(i4 + 28 | 0, i1, i5 << 2) | 0) HEAP32[i2 >> 2] = 3;
      } else i55 = 32; while (0);
      if ((i55 | 0) == 32) {
       i55 = 0;
       HEAP32[i4 + 24 >> 2] = 3;
      }
      i7 = i7 + 1 | 0;
      if (i7 >>> 0 >= (HEAP32[i18 >> 2] | 0) >>> 0) break; else i6 = i5 + i6 | 0;
     }
    }
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i52 | 0));
 }
 HEAP32[i51 >> 2] = 0;
 i15 = i51 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i42 = i51 + 16 | 0;
 HEAP32[i42 >> 2] = 0;
 i43 = i51 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i56, gb + 63664 | 0);
 i41 = i56;
 i2 = HEAP32[i41 + 4 >> 2] | 0;
 i1 = i43;
 HEAP32[i1 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = (HEAP32[i47 >> 2] | 0) - (HEAP32[i44 >> 2] | 0) | 0;
 i2 = HEAP32[i42 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i42 >> 2] = i1;
  HEAP32[i51 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i51 >> 2] | 0, i1 * 20 | 0, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i41 | 0, HEAP32[i51 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i42 >> 2] = i1;
  HEAP32[i51 >> 2] = i41;
  break;
 } while (0);
 i8 = HEAP32[i45 >> 2] | 0;
 i1 = i8 + ((HEAP32[i46 >> 2] | 0) * 44 | 0) | 0;
 HEAP32[i56 >> 2] = i54;
 i7 = i56 + 4 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i56 + 8 >> 2] = i1;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i56);
 i1 = (HEAP32[i45 >> 2] | 0) + ((HEAP32[i46 >> 2] | 0) * 44 | 0) | 0;
 HEAP32[i53 >> 2] = i54;
 i8 = i53 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i53 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i53);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i8 >> 2] | 0)) do {
  HEAP32[i53 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i42 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i42 >> 2] = i1;
    HEAP32[i51 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i51 >> 2] | 0, i1 * 20 | 0, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i41 | 0, HEAP32[i51 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 20 | 0) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i51 >> 2] = i41;
    break;
   }
  } while (0);
  HEAP32[i15 >> 2] = i4;
  i1 = HEAP32[i51 >> 2] | 0;
  i41 = i1 + (i3 * 20 | 0) | 0;
  HEAP32[i41 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i41 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  HEAP32[i1 + (i3 * 20 | 0) + 16 >> 2] = i2;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 44;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i56);
  i1 = (HEAP32[i45 >> 2] | 0) + ((HEAP32[i46 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i53 >> 2] = i54;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i1;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i53);
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i8 >> 2] | 0));
 i41 = HEAP32[i51 >> 2] | 0;
 __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_(i41, i41 + ((HEAP32[i15 >> 2] | 0) * 20 | 0) | 0, i56);
 if (!(HEAP32[i15 >> 2] | 0)) {
  i41 = 0;
  i40 = 0;
  i3 = 0;
  i6 = 0;
  i7 = 0;
 } else {
  i4 = 0;
  i5 = 0;
  i3 = 0;
  i6 = 0;
  i7 = 0;
  i8 = 0;
  while (1) {
   i1 = HEAP32[i51 >> 2] | 0;
   i2 = i1 + (i8 * 20 | 0) | 0;
   L86 : do if ((HEAP16[i1 + (i8 * 20 | 0) + 12 >> 1] | 0) == 4) switch (HEAP32[i1 + (i8 * 20 | 0) + 4 >> 2] | 0) {
   case 1:
    {
     i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
     HEAP32[i1 >> 2] = 6;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i4 + 1 | 0;
     i2 = i5;
     break L86;
    }
   case 4:
   case 2:
    {
     i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
     HEAP32[i1 >> 2] = 7;
     HEAP32[i1 + 4 >> 2] = i5;
     i1 = i4;
     i2 = i5 + 1 | 0;
     break L86;
    }
   case 3:
    {
     i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
     HEAP32[i1 >> 2] = 8;
     HEAP32[i1 + 4 >> 2] = i3;
     i1 = i4;
     i2 = i5;
     i3 = i3 + 1 | 0;
     break L86;
    }
   default:
    {
     i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
     HEAP32[i1 >> 2] = 10;
     HEAP32[i1 + 4 >> 2] = -1;
     i1 = i4;
     i2 = i5;
     break L86;
    }
   } else {
    if (HEAP8[i1 + (i8 * 20 | 0) + 15 >> 0] | 0) {
     i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
     HEAP32[i1 >> 2] = 3;
     HEAP32[i1 + 4 >> 2] = i7;
     i1 = i4;
     i2 = i5;
     i7 = i7 + 1 | 0;
     break;
    }
    i41 = __ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE(i2) | 0;
    i1 = HEAP32[i1 + (i8 * 20 | 0) + 16 >> 2] | 0;
    if (i41) {
     HEAP32[i1 >> 2] = 10;
     HEAP32[i1 + 4 >> 2] = -1;
     i1 = i4;
     i2 = i5;
     break;
    } else {
     HEAP32[i1 >> 2] = 1;
     HEAP32[i1 + 4 >> 2] = i6;
     i1 = i4;
     i2 = i5;
     i6 = i6 + 1 | 0;
     break;
    }
   } while (0);
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) {
    i41 = i1;
    i40 = i2;
    break;
   } else {
    i4 = i1;
    i5 = i2;
   }
  }
 }
 i1 = HEAP32[i62 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i62 >> 2] = i6;
  HEAP32[i75 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i75 >> 2] | 0, i6 << 4, 4, i63, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 4, i63, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i39 | 0, HEAP32[i75 >> 2] | 0, HEAP32[i58 >> 2] << 4 | 0) | 0;
  HEAP32[i62 >> 2] = i6;
  HEAP32[i75 >> 2] = i39;
  break;
 } while (0);
 i1 = HEAP32[i64 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i7 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i64 >> 2] = i7;
  HEAP32[i76 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i76 >> 2] | 0, i7 << 4, 4, i65, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i65, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i39 | 0, HEAP32[i76 >> 2] | 0, HEAP32[i59 >> 2] << 4 | 0) | 0;
  HEAP32[i64 >> 2] = i7;
  HEAP32[i76 >> 2] = i39;
  break;
 } while (0);
 i1 = i40 + i3 + i41 | 0;
 i2 = HEAP32[i66 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i66 >> 2] = i1;
  HEAP32[i77 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i77 >> 2] | 0, i1 << 3, 4, i67, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i67, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i39 | 0, HEAP32[i77 >> 2] | 0, HEAP32[i57 >> 2] << 3 | 0) | 0;
  HEAP32[i66 >> 2] = i1;
  HEAP32[i77 >> 2] = i39;
  break;
 } while (0);
 if (!(HEAP32[i15 >> 2] | 0)) i39 = 0; else {
  i14 = 0;
  i1 = 0;
  while (1) {
   i8 = HEAP32[i51 >> 2] | 0;
   i12 = i8 + (i14 * 20 | 0) | 0;
   i10 = i8 + (i14 * 20 | 0) + 12 | 0;
   L124 : do if ((HEAP16[i10 >> 1] | 0) == 4) {
    i9 = HEAP32[i57 >> 2] | 0;
    i11 = i9 + 1 | 0;
    i4 = HEAP32[i66 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i11 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 >= i2 >>> 0) break;
     if ((i4 | 0) > -1) {
      HEAP32[i66 >> 2] = i2;
      HEAP32[i77 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i77 >> 2] | 0, i2 << 3, 4, i67, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i67, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i39 | 0, HEAP32[i77 >> 2] | 0, HEAP32[i57 >> 2] << 3 | 0) | 0;
      HEAP32[i66 >> 2] = i2;
      HEAP32[i77 >> 2] = i39;
      break;
     }
    } while (0);
    HEAP32[i57 >> 2] = i11;
    i13 = HEAP32[i77 >> 2] | 0;
    HEAP32[i13 + (i9 << 3) >> 2] = HEAP32[i12 >> 2];
    i2 = HEAP32[i8 + (i14 * 20 | 0) + 4 >> 2] | 0;
    HEAP32[i13 + (i9 << 3) + 4 >> 2] = i2;
    i13 = i8 + (i14 * 20 | 0) + 16 | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    if ((HEAP32[i4 + 8 >> 2] | 0) == 3) i1 = i11; else {
     L134 : do if ((HEAP16[i10 >> 1] | 0) == 4) {
      if ((i2 | 0) == 2) {
       i12 = 4;
       break;
      }
      switch (i2 | 0) {
      case 1:
      case 3:
      case 4:
       {
        i12 = 3;
        break L134;
       }
      default:
       {}
      }
      i12 = 1;
     } else i12 = 1; while (0);
     i2 = 0;
     i10 = HEAP32[i60 >> 2] | 0;
     while (1) {
      i5 = i4 + 12 + (i2 << 2) | 0;
      i11 = i10 + 1 | 0;
      i8 = HEAP32[i68 >> 2] | 0;
      i9 = i8 & 2147483647;
      do if (i11 >>> 0 > i9 >>> 0) {
       i4 = i8 << 1;
       i4 = (i4 | 0) == 0 ? 1 : i4;
       if (i9 >>> 0 >= i4 >>> 0) break;
       if ((i8 | 0) > -1) {
        HEAP32[i68 >> 2] = i4;
        HEAP32[i78 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i78 >> 2] | 0, i4 << 2, 4, i69, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i69, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i39 | 0, HEAP32[i78 >> 2] | 0, HEAP32[i60 >> 2] << 2 | 0) | 0;
        HEAP32[i68 >> 2] = i4;
        HEAP32[i78 >> 2] = i39;
        break;
       }
      } while (0);
      HEAP32[i60 >> 2] = i11;
      HEAP32[(HEAP32[i78 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i5 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i12 | 0)) break L124;
      i4 = HEAP32[i13 >> 2] | 0;
      i10 = i11;
     }
    }
   } else {
    if (HEAP8[i8 + (i14 * 20 | 0) + 15 >> 0] | 0) {
     i4 = HEAP32[i59 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i8 = HEAP32[i64 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i5 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 >= i2 >>> 0) break;
      if ((i8 | 0) > -1) {
       HEAP32[i64 >> 2] = i2;
       HEAP32[i76 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i76 >> 2] | 0, i2 << 4, 4, i65, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i65, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i39 | 0, HEAP32[i76 >> 2] | 0, HEAP32[i59 >> 2] << 4 | 0) | 0;
       HEAP32[i64 >> 2] = i2;
       HEAP32[i76 >> 2] = i39;
       break;
      }
     } while (0);
     HEAP32[i59 >> 2] = i5;
     i39 = (HEAP32[i76 >> 2] | 0) + (i4 << 4) | 0;
     HEAP32[i39 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i39 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i39 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i39 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break;
    }
    if (!(__ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE(i12) | 0)) {
     i4 = HEAP32[i58 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i8 = HEAP32[i62 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i5 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 >= i2 >>> 0) break;
      if ((i8 | 0) > -1) {
       HEAP32[i62 >> 2] = i2;
       HEAP32[i75 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i75 >> 2] | 0, i2 << 4, 4, i63, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i63, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i39 | 0, HEAP32[i75 >> 2] | 0, HEAP32[i58 >> 2] << 4 | 0) | 0;
       HEAP32[i62 >> 2] = i2;
       HEAP32[i75 >> 2] = i39;
       break;
      }
     } while (0);
     HEAP32[i58 >> 2] = i5;
     i39 = (HEAP32[i75 >> 2] | 0) + (i4 << 4) | 0;
     HEAP32[i39 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i39 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i39 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i39 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    }
   } while (0);
   i14 = i14 + 1 | 0;
   if (i14 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) {
    i39 = i1;
    break;
   }
  }
 }
 if (!i19) {
  i21 = (i41 | 0) == 0;
  i22 = (i40 | 0) == 0;
  i23 = (i3 | 0) == 0;
  i24 = (i6 | 0) == 0;
  i25 = (i7 | 0) == 0;
  i26 = (i41 | 0) > 0;
  i27 = (i40 | 0) > 0;
  i28 = (i3 | 0) > 0;
  i29 = (i6 | 0) > 0;
  i30 = (i7 | 0) > 0;
  i31 = i53 + 4 | 0;
  i32 = i53 + 8 | 0;
  i33 = i7 << 1;
  i34 = i6 << 1;
  i35 = i3 << 1;
  i36 = i40 << 1;
  i37 = i41 << 1;
  i20 = 0;
  do {
   i38 = HEAP32[i50 + (i20 << 2) >> 2] | 0;
   if (i38 | 0) {
    i19 = HEAP32[i49 + (i20 << 2) >> 2] | 0;
    do if (i21) i1 = 0; else {
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i37 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i41 << 1) | 0)) break;
     _memset(i1 | 0, 0, i37 | 0) | 0;
    } while (0);
    i18 = i38 + 8 | 0;
    HEAP32[i18 >> 2] = i1;
    do if (i22) {
     i2 = i38 + 12 | 0;
     HEAP32[i2 >> 2] = 0;
     i4 = i38 + 16 | 0;
     HEAP32[i4 >> 2] = 0;
     i1 = 0;
    } else {
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i36 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i40 << 1) | 0)) {
      i2 = i38 + 12 | 0;
      HEAP32[i2 >> 2] = i1;
     } else {
      _memset(i1 | 0, 0, i36 | 0) | 0;
      i2 = i38 + 12 | 0;
      HEAP32[i2 >> 2] = i1;
     }
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i36 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i40 << 1) | 0)) {
      i4 = i38 + 16 | 0;
      HEAP32[i4 >> 2] = i1;
     } else {
      _memset(i1 | 0, 0, i36 | 0) | 0;
      i4 = i38 + 16 | 0;
      HEAP32[i4 >> 2] = i1;
     }
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i36 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i40 << 1) | 0)) break;
     _memset(i1 | 0, 0, i36 | 0) | 0;
    } while (0);
    i17 = i38 + 20 | 0;
    HEAP32[i17 >> 2] = i1;
    do if (i23) i1 = 0; else {
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i35 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i3 << 1) | 0)) break;
     _memset(i1 | 0, 0, i35 | 0) | 0;
    } while (0);
    i16 = i38 + 24 | 0;
    HEAP32[i16 >> 2] = i1;
    do if (i24) i1 = 0; else {
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i34 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i6 << 1) | 0)) break;
     _memset(i1 | 0, 0, i34 | 0) | 0;
    } while (0);
    i15 = i38 + 28 | 0;
    HEAP32[i15 >> 2] = i1;
    do if (i25) i1 = 0; else {
     i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i33 | 0, 2) | 0;
     if ((i1 | 0) == (i1 + (i7 << 1) | 0)) break;
     _memset(i1 | 0, 0, i33 | 0) | 0;
    } while (0);
    i14 = i38 + 32 | 0;
    HEAP32[i14 >> 2] = i1;
    if (i26) _memset(HEAP32[i18 >> 2] | 0, -1, i37 | 0) | 0;
    if (i27) {
     _memset(HEAP32[i2 >> 2] | 0, -1, i36 | 0) | 0;
     _memset(HEAP32[i4 >> 2] | 0, -1, i36 | 0) | 0;
    }
    if (i28) _memset(HEAP32[i16 >> 2] | 0, -1, i35 | 0) | 0;
    if (i29) _memset(HEAP32[i15 >> 2] | 0, -1, i34 | 0) | 0;
    if (i30) _memset(HEAP32[i14 >> 2] | 0, -1, i33 | 0) | 0;
    i13 = i19 + 12 | 0;
    L220 : do if (!(HEAP32[i13 >> 2] | 0)) i1 = 0; else {
     i11 = 0;
     i12 = 0;
     i1 = 0;
     while (1) {
      i10 = HEAP32[i19 >> 2] | 0;
      if ((HEAP32[i47 >> 2] | 0) == (HEAP32[i44 >> 2] | 0)) {
       i9 = (HEAP32[i45 >> 2] | 0) + ((HEAP32[i46 >> 2] | 0) * 44 | 0) | 0;
       HEAP32[i53 >> 2] = i54;
       HEAP32[i31 >> 2] = i9;
       HEAP32[i32 >> 2] = i9;
       __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i53);
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E13find_positionERS5_(i56, i54, i10 + (i11 << 4) | 0);
       i5 = HEAP32[i56 >> 2] | 0;
       i8 = HEAP32[i45 >> 2] | 0;
       i9 = HEAP32[i46 >> 2] | 0;
       if ((i5 | 0) == -1) {
        i9 = i8 + (i9 * 44 | 0) | 0;
        HEAP32[i53 >> 2] = i54;
        HEAP32[i31 >> 2] = i9;
        HEAP32[i32 >> 2] = i9;
        __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i53);
       } else {
        HEAP32[i53 >> 2] = i54;
        HEAP32[i31 >> 2] = i8 + (i5 * 44 | 0);
        HEAP32[i32 >> 2] = i8 + (i9 * 44 | 0);
       }
      }
      i8 = HEAP32[i31 >> 2] | 0;
      L232 : do switch (HEAP32[i8 + 16 >> 2] | 0) {
      case 6:
       {
        HEAP16[(HEAP32[i18 >> 2] | 0) + (HEAP32[i8 + 20 >> 2] << 1) >> 1] = i12;
        break;
       }
      case 7:
       switch (HEAP32[i10 + (i11 << 4) + 4 >> 2] | 0) {
       case 2:
        {
         HEAP16[(HEAP32[i2 >> 2] | 0) + (HEAP32[i8 + 20 >> 2] << 1) >> 1] = i12;
         break L232;
        }
       case 4:
        {
         i9 = HEAP32[i8 + 20 >> 2] | 0;
         HEAP16[(HEAP32[i4 >> 2] | 0) + (i9 << 1) >> 1] = i12;
         HEAP16[(HEAP32[i17 >> 2] | 0) + (i9 << 1) >> 1] = (HEAPU8[i10 + (i11 << 4) + 14 >> 0] | 0) + 65526;
         break L232;
        }
       default:
        break L232;
       }
      case 8:
       {
        HEAP16[(HEAP32[i16 >> 2] | 0) + (HEAP32[i8 + 20 >> 2] << 1) >> 1] = i12;
        break;
       }
      case 1:
       {
        HEAP16[(HEAP32[i15 >> 2] | 0) + (HEAP32[i8 + 20 >> 2] << 1) >> 1] = i12;
        break;
       }
      case 3:
       {
        HEAP16[(HEAP32[i14 >> 2] | 0) + (HEAP32[i8 + 20 >> 2] << 1) >> 1] = i12;
        break;
       }
      default:
       {}
      } while (0);
      i5 = HEAP32[i10 + (i11 << 4) + 4 >> 2] | 0;
      L242 : do if ((HEAP16[i10 + (i11 << 4) + 12 >> 1] | 0) == 4) {
       if ((i5 | 0) == 2) {
        i5 = 4;
        break;
       }
       switch (i5 | 0) {
       case 1:
       case 3:
       case 4:
        {
         i5 = 3;
         break L242;
        }
       default:
        {}
       }
       i5 = 1;
      } else i5 = 1; while (0);
      i12 = i5 + i12 | 0;
      i1 = (HEAP32[i8 + 24 >> 2] | 0) == 3 ? i12 : i1;
      i11 = i11 + 1 | 0;
      if (i11 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break L220;
     }
    } while (0);
    i2 = HEAP32[i38 >> 2] | 0;
    i4 = HEAP32[i2 + 216 >> 2] | 0;
    if (!i4) i55 = 151; else if (!(HEAP32[i2 + 220 >> 2] | 0)) i55 = 151;
    if ((i55 | 0) == 151) {
     i55 = 0;
     i4 = 0;
    }
    i2 = 0;
    do {
     i19 = (HEAP32[i4 + 1088 + (i2 << 2) >> 2] | 0) + 1 | 0;
     i1 = (i19 | 0) < (i1 | 0) ? i1 : i19;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 155);
    HEAP32[i38 + 4 >> 2] = i1;
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i52 | 0));
 }
 if ((HEAP32[i42 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i51 >> 2] | 0, i43);
  HEAP32[i51 >> 2] = 0;
 }
 i1 = HEAP32[i45 >> 2] | 0;
 if (i1 | 0) {
  i55 = HEAP32[i48 >> 2] | 0;
  HEAP32[i56 >> 2] = 1;
  HEAP32[i56 + 4 >> 2] = i55;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i56);
 }
 i4 = HEAP32[i75 >> 2] | 0;
 i3 = HEAP32[i58 >> 2] | 0;
 i5 = HEAP32[i76 >> 2] | 0;
 i6 = HEAP32[i59 >> 2] | 0;
 i8 = HEAP32[i77 >> 2] | 0;
 i9 = HEAP32[i57 >> 2] | 0;
 i1 = __ZN7mecanim24CreateValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE(1, i6 + i3 + i9 | 0, i74) | 0;
 i56 = i1 + 4 | 0;
 i7 = HEAP32[i56 >> 2] | 0;
 i7 = (i7 | 0) == 0 ? 0 : i56 + i7 | 0;
 if (!i3) i3 = 0; else {
  i2 = 0;
  do {
   HEAP32[i7 + (i2 * 12 | 0) >> 2] = HEAP32[i4 + (i2 << 4) + 4 >> 2];
   HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] = i2;
   HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] = 1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 if (i6) {
  i2 = 0;
  i4 = i3;
  while (1) {
   HEAP32[i7 + (i4 * 12 | 0) >> 2] = HEAP32[i5 + (i2 << 4) + 4 >> 2];
   HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] = i2;
   HEAP32[i7 + (i4 * 12 | 0) + 4 >> 2] = 3;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i6 | 0)) break; else i4 = i4 + 1 | 0;
  }
  i3 = i3 + i6 | 0;
 }
 L273 : do if (i9 | 0) {
  i2 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
  while (1) {
   HEAP32[i7 + (i3 * 12 | 0) >> 2] = HEAP32[i8 + (i6 << 3) >> 2];
   switch (HEAP32[i8 + (i6 << 3) + 4 >> 2] | 0) {
   case 1:
    {
     HEAP32[i7 + (i3 * 12 | 0) + 8 >> 2] = i5;
     HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] = 6;
     i5 = i5 + 1 | 0;
     break;
    }
   case 2:
    {
     HEAP32[i7 + (i3 * 12 | 0) + 8 >> 2] = i4;
     HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] = 7;
     i4 = i4 + 1 | 0;
     break;
    }
   case 3:
    {
     HEAP32[i7 + (i3 * 12 | 0) + 8 >> 2] = i2;
     HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] = 8;
     i2 = i2 + 1 | 0;
     break;
    }
   case 4:
    {
     HEAP32[i7 + (i3 * 12 | 0) + 8 >> 2] = i4;
     HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] = 7;
     i4 = i4 + 1 | 0;
     break;
    }
   default:
    {}
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i9 | 0)) break L273; else i3 = i3 + 1 | 0;
  }
 } while (0);
 i4 = i70 + 20 | 0;
 HEAP32[i4 >> 2] = i1;
 do if (i61) {
  i3 = HEAP32[i70 + 16 >> 2] | 0;
  if (!(HEAP32[i58 >> 2] | 0)) break; else i2 = 0;
  do {
   i1 = HEAP32[i75 >> 2] | 0;
   do if ((HEAP16[i1 + (i2 << 4) + 12 >> 1] | 0) == 95) {
    i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i71, HEAP32[i1 + (i2 << 4) + 4 >> 2] | 0) | 0;
    if ((i1 | 0) == -1) break;
    HEAP32[i3 + (i1 << 2) >> 2] = i2;
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i58 >> 2] | 0) >>> 0);
  i1 = HEAP32[i4 >> 2] | 0;
 } while (0);
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i1, __ZN7mecanim6CRCKeyENS_7eStringE(43) | 0) | 0;
 i3 = i70 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((i2 | 0) != -1) {
  i71 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[(HEAP32[i71 >> 2] | 0) + i71 + (i2 * 12 | 0) + 8 >> 2];
 }
 i2 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, 40, 4) | 0;
 HEAP32[i2 + 36 >> 2] = i70;
 HEAP32[i2 + 16 >> 2] = i39;
 i1 = HEAP32[i57 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i70 = HEAP32[i77 >> 2] | 0;
  i71 = i1 << 3;
  i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i71 | 0, 4) | 0;
  _memcpy(i1 | 0, i70 | 0, i71 | 0) | 0;
 }
 HEAP32[i2 + 24 >> 2] = i1;
 i1 = HEAP32[i58 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i70 = HEAP32[i75 >> 2] | 0;
  i71 = i1 << 4;
  i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i71 | 0, 4) | 0;
  _memcpy(i1 | 0, i70 | 0, i71 | 0) | 0;
 }
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i59 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i70 = HEAP32[i76 >> 2] | 0;
  i71 = i1 << 4;
  i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i71 | 0, 4) | 0;
  _memcpy(i1 | 0, i70 | 0, i71 | 0) | 0;
 }
 HEAP32[i2 + 12 >> 2] = i1;
 i1 = HEAP32[i60 >> 2] | 0;
 HEAP32[i2 + 28 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i70 = HEAP32[i78 >> 2] | 0;
  i71 = i1 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i74 >> 2] >> 2] | 0, i74 | 0, i71 | 0, 4) | 0;
  _memcpy(i1 | 0, i70 | 0, i71 | 0) | 0;
 }
 HEAP32[i2 + 32 >> 2] = i1;
 if ((HEAP32[i68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i78 >> 2] | 0, i69);
  HEAP32[i78 >> 2] = 0;
 }
 if ((HEAP32[i66 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i77 >> 2] | 0, i67);
  HEAP32[i77 >> 2] = 0;
 }
 if ((HEAP32[i64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i76 >> 2] | 0, i65);
  HEAP32[i76 >> 2] = 0;
 }
 if ((HEAP32[i62 >> 2] | 0) <= -1) {
  i82 = HEAP32[i82 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i82, i72);
  i82 = HEAP32[i81 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i82, i73);
  i82 = HEAP32[i80 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i82, i79);
  STACKTOP = i83;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i75 >> 2] | 0, i63);
 HEAP32[i75 >> 2] = 0;
 i82 = HEAP32[i82 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i82, i72);
 i82 = HEAP32[i81 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i82, i73);
 i82 = HEAP32[i80 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i82, i79);
 STACKTOP = i83;
 return i2 | 0;
}

function _unity_z_inflate(i67, i3) {
 i67 = i67 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i68 = 0, i69 = 0, i70 = 0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i70;
 if (!i67) {
  i69 = -2;
  STACKTOP = i70;
  return i69 | 0;
 }
 i69 = HEAP32[i67 + 28 >> 2] | 0;
 if (!i69) {
  i69 = -2;
  STACKTOP = i70;
  return i69 | 0;
 }
 i62 = i67 + 12 | 0;
 i4 = HEAP32[i62 >> 2] | 0;
 if (!i4) {
  i69 = -2;
  STACKTOP = i70;
  return i69 | 0;
 }
 i5 = HEAP32[i67 >> 2] | 0;
 if (!i5) if (HEAP32[i67 + 4 >> 2] | 0) {
  i69 = -2;
  STACKTOP = i70;
  return i69 | 0;
 }
 i68 = i3 & -4097;
 i1 = HEAP32[i69 >> 2] | 0;
 if ((i1 | 0) == 11) {
  HEAP32[i69 >> 2] = 12;
  i1 = 12;
 }
 i54 = i67 + 16 | 0;
 i6 = HEAP32[i54 >> 2] | 0;
 i51 = i67 + 4 | 0;
 i55 = HEAP32[i51 >> 2] | 0;
 i52 = i69 + 56 | 0;
 i63 = i69 + 60 | 0;
 i58 = i69 + 8 | 0;
 i64 = i69 + 24 | 0;
 i27 = i44 + 1 | 0;
 i61 = i69 + 16 | 0;
 i28 = i69 + 32 | 0;
 i29 = i67 + 24 | 0;
 i30 = i69 + 36 | 0;
 i31 = i69 + 20 | 0;
 i65 = i67 + 48 | 0;
 i32 = i69 + 64 | 0;
 i33 = i69 + 12 | 0;
 i34 = (i68 | 0) == 5;
 i66 = i69 + 4 | 0;
 i35 = i69 + 76 | 0;
 i36 = i69 + 84 | 0;
 i37 = i69 + 80 | 0;
 i38 = i69 + 88 | 0;
 i39 = i69 + 72 | 0;
 i40 = i69 + 68 | 0;
 i41 = i69 + 44 | 0;
 i42 = i69 + 48 | 0;
 i43 = i69 + 52 | 0;
 i53 = i69 + 40 | 0;
 i59 = i67 + 20 | 0;
 i60 = i69 + 28 | 0;
 i56 = (i3 & 4096 | 0) == 0;
 i17 = i44 + 2 | 0;
 i18 = i44 + 3 | 0;
 i19 = i69 + 104 | 0;
 i20 = i69 + 96 | 0;
 i21 = i69 + 100 | 0;
 i22 = i69 + 1328 | 0;
 i23 = i69 + 108 | 0;
 i24 = i69 + 112 | 0;
 i25 = i69 + 752 | 0;
 i26 = i69 + 92 | 0;
 i47 = i4;
 i8 = i5;
 i5 = 0;
 i16 = i6;
 i3 = HEAP32[i63 >> 2] | 0;
 i4 = HEAP32[i52 >> 2] | 0;
 i7 = i55;
 L17 : while (1) {
  L19 : do switch (i1 | 0) {
  case 26:
   {
    i2 = i7;
    i1 = i8;
    i5 = 1;
    i15 = 276;
    break L17;
   }
  case 27:
   {
    i57 = i16;
    i49 = i3;
    i48 = i4;
    i2 = i7;
    i46 = i8;
    i50 = -3;
    i45 = i6;
    break L17;
   }
  case 28:
   {
    i15 = 289;
    break L17;
   }
  case 0:
   {
    i9 = HEAP32[i58 >> 2] | 0;
    if (!i9) {
     HEAP32[i69 >> 2] = 12;
     i10 = i47;
     i1 = i8;
     i9 = i16;
     break L19;
    }
    if (i3 >>> 0 < 16) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 16) i8 = i1; else break;
    } else i1 = i8;
    if ((i4 | 0) == 35615 & (i9 & 2 | 0) != 0) {
     i10 = _unity_z_crc32(0, 0, 0) | 0;
     HEAP32[i64 >> 2] = i10;
     HEAP8[i44 >> 0] = 31;
     HEAP8[i27 >> 0] = -117;
     HEAP32[i64 >> 2] = _unity_z_crc32(i10, i44, 2) | 0;
     HEAP32[i69 >> 2] = 1;
     i10 = i47;
     i9 = i16;
     i3 = 0;
     i4 = 0;
     break L19;
    }
    HEAP32[i61 >> 2] = 0;
    i8 = HEAP32[i28 >> 2] | 0;
    if (i8 | 0) HEAP32[i8 + 48 >> 2] = -1;
    if (i9 & 1 | 0) if (!((((i4 << 8 & 65280) + (i4 >>> 8) | 0) >>> 0) % 31 | 0)) {
     if ((i4 & 15 | 0) != 8) {
      HEAP32[i29 >> 2] = gb + 362577;
      HEAP32[i69 >> 2] = 27;
      i10 = i47;
      i9 = i16;
      break L19;
     }
     i11 = i4 >>> 4;
     i8 = (i11 & 15) + 8 | 0;
     if (i8 >>> 0 > (HEAP32[i30 >> 2] | 0) >>> 0) {
      HEAP32[i29 >> 2] = gb + 362604;
      HEAP32[i69 >> 2] = 27;
      i10 = i47;
      i9 = i16;
      i3 = i3 + -4 | 0;
      i4 = i11;
      break L19;
     } else {
      HEAP32[i31 >> 2] = 1 << i8;
      i10 = _unity_z_adler32(0, 0, 0) | 0;
      HEAP32[i64 >> 2] = i10;
      HEAP32[i65 >> 2] = i10;
      HEAP32[i69 >> 2] = i4 >>> 12 & 2 ^ 11;
      i10 = i47;
      i9 = i16;
      i3 = 0;
      i4 = 0;
      break L19;
     }
    }
    HEAP32[i29 >> 2] = gb + 362554;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
  case 1:
   {
    if (i3 >>> 0 < 16) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 16) i8 = i1; else break;
    } else i1 = i8;
    HEAP32[i61 >> 2] = i4;
    if ((i4 & 255 | 0) != 8) {
     HEAP32[i29 >> 2] = gb + 362577;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break L19;
    }
    if (i4 & 57344 | 0) {
     HEAP32[i29 >> 2] = gb + 362624;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break L19;
    }
    i3 = HEAP32[i28 >> 2] | 0;
    if (i3 | 0) HEAP32[i3 >> 2] = i4 >>> 8 & 1;
    if (i4 & 512 | 0) {
     HEAP8[i44 >> 0] = i4;
     HEAP8[i27 >> 0] = i4 >>> 8;
     HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i44, 2) | 0;
    }
    HEAP32[i69 >> 2] = 2;
    i3 = 0;
    i4 = 0;
    i15 = 46;
    break;
   }
  case 2:
   {
    if (i3 >>> 0 < 32) {
     i1 = i8;
     i15 = 46;
    } else i15 = 48;
    break;
   }
  case 3:
   {
    if (i3 >>> 0 < 16) i15 = 54; else {
     i1 = i8;
     i15 = 56;
    }
    break;
   }
  case 4:
   {
    i1 = i8;
    i15 = 61;
    break;
   }
  case 5:
   {
    i1 = i8;
    i15 = 72;
    break;
   }
  case 6:
   {
    i1 = i8;
    i15 = 82;
    break;
   }
  case 7:
   {
    i1 = i8;
    i15 = 95;
    break;
   }
  case 8:
   {
    i1 = i8;
    i15 = 108;
    break;
   }
  case 9:
   {
    if (i3 >>> 0 < 32) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 >= 32) break; else i8 = i1;
    } else i1 = i8;
    i3 = _llvm_bswap_i32(i4 | 0) | 0;
    HEAP32[i64 >> 2] = i3;
    HEAP32[i65 >> 2] = i3;
    HEAP32[i69 >> 2] = 10;
    i3 = 0;
    i4 = 0;
    i15 = 120;
    break;
   }
  case 10:
   {
    i1 = i8;
    i15 = 120;
    break;
   }
  case 11:
   {
    i1 = i8;
    i15 = 123;
    break;
   }
  case 12:
   {
    i1 = i8;
    i15 = 124;
    break;
   }
  case 13:
   {
    i14 = i3 & 7;
    i4 = i4 >>> i14;
    i3 = i3 - i14 | 0;
    if (i3 >>> 0 < 32) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 32) i8 = i1; else break;
    } else i1 = i8;
    i8 = i4 & 65535;
    if ((i8 | 0) == (i4 >>> 16 ^ 65535 | 0)) {
     HEAP32[i32 >> 2] = i8;
     HEAP32[i69 >> 2] = 14;
     i3 = 0;
     i4 = 0;
     i15 = 142;
     break L19;
    } else {
     HEAP32[i29 >> 2] = gb + 362732;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break L19;
    }
   }
  case 14:
   {
    i1 = i8;
    i8 = HEAP32[i32 >> 2] | 0;
    i15 = 142;
    break;
   }
  case 15:
   {
    if (i3 >>> 0 < 14) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 14) i8 = i1; else break;
    } else i1 = i8;
    i13 = (i4 & 31) + 257 | 0;
    HEAP32[i20 >> 2] = i13;
    i14 = (i4 >>> 5 & 31) + 1 | 0;
    HEAP32[i21 >> 2] = i14;
    i9 = (i4 >>> 10 & 15) + 4 | 0;
    HEAP32[i26 >> 2] = i9;
    i4 = i4 >>> 14;
    i3 = i3 + -14 | 0;
    if (i13 >>> 0 > 286 | i14 >>> 0 > 30) {
     HEAP32[i29 >> 2] = gb + 362761;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break L19;
    } else {
     HEAP32[i19 >> 2] = 0;
     HEAP32[i69 >> 2] = 16;
     i8 = 0;
     i15 = 152;
     break L19;
    }
   }
  case 16:
   {
    i10 = HEAP32[i19 >> 2] | 0;
    i9 = HEAP32[i26 >> 2] | 0;
    if (i10 >>> 0 < i9 >>> 0) {
     i1 = i8;
     i8 = i10;
     i15 = 152;
    } else {
     i1 = i8;
     i5 = i10;
     i15 = 153;
    }
    break;
   }
  case 17:
   {
    i1 = i8;
    i8 = HEAP32[i19 >> 2] | 0;
    i15 = 163;
    break;
   }
  case 18:
   {
    i1 = i8;
    i15 = 198;
    break;
   }
  case 19:
   {
    i1 = i8;
    i9 = HEAP32[i39 >> 2] | 0;
    i15 = 215;
    break;
   }
  case 20:
   {
    i1 = i8;
    i15 = 221;
    break;
   }
  case 21:
   {
    i1 = i8;
    i9 = HEAP32[i39 >> 2] | 0;
    i15 = 232;
    break;
   }
  case 22:
   {
    i1 = i8;
    i15 = 241;
    break;
   }
  case 23:
   {
    if (!i6) {
     i2 = i7;
     i1 = i8;
     i6 = 0;
     i15 = 276;
     break L17;
    }
    HEAP8[i47 >> 0] = HEAP32[i32 >> 2];
    HEAP32[i69 >> 2] = 18;
    i10 = i47 + 1 | 0;
    i1 = i8;
    i9 = i16;
    i6 = i6 + -1 | 0;
    break;
   }
  case 24:
   {
    if (!(HEAP32[i58 >> 2] | 0)) {
     i9 = i16;
     i1 = i8;
    } else {
     if (i3 >>> 0 < 32) while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      if (i3 >>> 0 < 32) i8 = i1; else break;
     } else i1 = i8;
     i8 = i16 - i6 | 0;
     HEAP32[i59 >> 2] = (HEAP32[i59 >> 2] | 0) + i8;
     HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i8;
     if (i56 & (i8 | 0) != 0) {
      i9 = HEAP32[i64 >> 2] | 0;
      i10 = i47 + (0 - i8) | 0;
      if (!(HEAP32[i61 >> 2] | 0)) i8 = _unity_z_adler32(i9, i10, i8) | 0; else i8 = _unity_z_crc32(i9, i10, i8) | 0;
      HEAP32[i64 >> 2] = i8;
      HEAP32[i65 >> 2] = i8;
     }
     if (i56) {
      i14 = (HEAP32[i61 >> 2] | 0) == 0;
      i16 = _llvm_bswap_i32(i4 | 0) | 0;
      if (((i14 ? i16 : i4) | 0) == (HEAP32[i64 >> 2] | 0)) {
       i9 = i6;
       i3 = 0;
       i4 = 0;
      } else {
       HEAP32[i29 >> 2] = gb + 362669;
       HEAP32[i69 >> 2] = 27;
       i10 = i47;
       i9 = i6;
       break L19;
      }
     } else {
      i9 = i6;
      i3 = 0;
      i4 = 0;
     }
    }
    HEAP32[i69 >> 2] = 25;
    i15 = 268;
    break;
   }
  case 25:
   {
    i9 = i16;
    i1 = i8;
    i15 = 268;
    break;
   }
  default:
   {
    i1 = -2;
    i15 = 290;
    break L17;
   }
  } while (0);
  do if ((i15 | 0) == 46) while (1) {
   i15 = 0;
   if (!i7) {
    i57 = i16;
    i49 = i3;
    i48 = i4;
    i2 = 0;
    i46 = i1;
    i50 = i5;
    i45 = i6;
    break L17;
   }
   i7 = i7 + -1 | 0;
   i8 = i1 + 1 | 0;
   i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
   i3 = i3 + 8 | 0;
   if (i3 >>> 0 >= 32) {
    i15 = 48;
    break;
   } else {
    i1 = i8;
    i15 = 46;
   }
  } else if ((i15 | 0) == 120) {
   if (!(HEAP32[i33 >> 2] | 0)) {
    i15 = 121;
    break L17;
   }
   i15 = _unity_z_adler32(0, 0, 0) | 0;
   HEAP32[i64 >> 2] = i15;
   HEAP32[i65 >> 2] = i15;
   HEAP32[i69 >> 2] = 11;
   i15 = 123;
  } else if ((i15 | 0) == 142) {
   i15 = 0;
   if (!i8) {
    HEAP32[i69 >> 2] = 11;
    i10 = i47;
    i9 = i16;
    break;
   }
   i8 = i8 >>> 0 > i7 >>> 0 ? i7 : i8;
   i8 = i8 >>> 0 > i6 >>> 0 ? i6 : i8;
   if (!i8) {
    i2 = i7;
    i15 = 276;
    break L17;
   }
   _memcpy(i47 | 0, i1 | 0, i8 | 0) | 0;
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) - i8;
   i10 = i47 + i8 | 0;
   i1 = i1 + i8 | 0;
   i9 = i16;
   i6 = i6 - i8 | 0;
   i7 = i7 - i8 | 0;
  } else if ((i15 | 0) == 152) {
   i15 = 0;
   while (1) {
    if (i3 >>> 0 < 3) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i1;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i10 = i3 + 8 | 0;
     i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
     i1 = i1 + 1 | 0;
     i7 = i7 + -1 | 0;
    } else i10 = i3;
    i11 = i8 + 1 | 0;
    HEAP32[i19 >> 2] = i11;
    HEAP16[i69 + 112 + ((HEAPU16[gb + 222788 + (i8 << 1) >> 1] | 0) << 1) >> 1] = i4 & 7;
    i4 = i4 >>> 3;
    i3 = i10 + -3 | 0;
    if (i11 >>> 0 < i9 >>> 0) i8 = i11; else {
     i5 = i11;
     i15 = 153;
     break;
    }
   }
  } else if ((i15 | 0) == 268) {
   i15 = 0;
   if (!(HEAP32[i58 >> 2] | 0)) {
    i2 = i7;
    i15 = 275;
    break L17;
   }
   if (!(HEAP32[i61 >> 2] | 0)) {
    i2 = i7;
    i15 = 275;
    break L17;
   }
   if (i3 >>> 0 < 32) {
    i8 = i1;
    while (1) {
     if (!i7) {
      i57 = i9;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i8;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i1 = i8 + 1 | 0;
     i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 32) i8 = i1; else break;
    }
   }
   if ((i4 | 0) == (HEAP32[i60 >> 2] | 0)) {
    i3 = 0;
    i4 = 0;
    i2 = i7;
    i15 = 275;
    break L17;
   }
   HEAP32[i29 >> 2] = gb + 362690;
   HEAP32[i69 >> 2] = 27;
   i10 = i47;
  } while (0);
  do if ((i15 | 0) == 48) {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 4 >> 2] = i4;
   if (HEAP32[i61 >> 2] & 512 | 0) {
    HEAP8[i44 >> 0] = i4;
    HEAP8[i27 >> 0] = i4 >>> 8;
    HEAP8[i17 >> 0] = i4 >>> 16;
    HEAP8[i18 >> 0] = i4 >>> 24;
    HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i44, 4) | 0;
   }
   HEAP32[i69 >> 2] = 3;
   i3 = 0;
   i4 = 0;
   i15 = 54;
  } else if ((i15 | 0) == 123) if (i34) {
   i2 = i7;
   i15 = 276;
   break L17;
  } else i15 = 124; else if ((i15 | 0) == 153) {
   i15 = 0;
   if (i5 >>> 0 < 19) {
    do {
     HEAP16[i69 + 112 + ((HEAPU16[gb + 222788 + (i5 << 1) >> 1] | 0) << 1) >> 1] = 0;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 19);
    HEAP32[i19 >> 2] = 19;
   }
   HEAP32[i23 >> 2] = i22;
   HEAP32[i35 >> 2] = i22;
   HEAP32[i36 >> 2] = 7;
   i5 = _inflate_table(0, i24, 19, i23, i36, i25) | 0;
   if (!i5) {
    HEAP32[i19 >> 2] = 0;
    HEAP32[i69 >> 2] = 17;
    i5 = 0;
    i8 = 0;
    i15 = 163;
    break;
   } else {
    HEAP32[i29 >> 2] = gb + 362797;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
  } while (0);
  L159 : do if ((i15 | 0) == 54) while (1) {
   i15 = 0;
   if (!i7) {
    i57 = i16;
    i49 = i3;
    i48 = i4;
    i2 = 0;
    i46 = i8;
    i50 = i5;
    i45 = i6;
    break L17;
   }
   i7 = i7 + -1 | 0;
   i1 = i8 + 1 | 0;
   i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
   i3 = i3 + 8 | 0;
   if (i3 >>> 0 >= 16) {
    i15 = 56;
    break;
   } else {
    i8 = i1;
    i15 = 54;
   }
  } else if ((i15 | 0) == 124) {
   i15 = 0;
   if (HEAP32[i66 >> 2] | 0) {
    i14 = i3 & 7;
    HEAP32[i69 >> 2] = 24;
    i10 = i47;
    i9 = i16;
    i3 = i3 - i14 | 0;
    i4 = i4 >>> i14;
    break;
   }
   if (i3 >>> 0 < 3) {
    if (!i7) {
     i2 = 0;
     i15 = 276;
     break L17;
    }
    i8 = i3 + 8 | 0;
    i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
    i1 = i1 + 1 | 0;
    i7 = i7 + -1 | 0;
   } else i8 = i3;
   HEAP32[i66 >> 2] = i4 & 1;
   switch (i4 >>> 1 & 3) {
   case 0:
    {
     HEAP32[i69 >> 2] = 13;
     break;
    }
   case 1:
    {
     HEAP32[i35 >> 2] = gb + 218184;
     HEAP32[i36 >> 2] = 9;
     HEAP32[i37 >> 2] = gb + 220232;
     HEAP32[i38 >> 2] = 5;
     HEAP32[i69 >> 2] = 18;
     break;
    }
   case 2:
    {
     HEAP32[i69 >> 2] = 15;
     break;
    }
   case 3:
    {
     HEAP32[i29 >> 2] = gb + 362713;
     HEAP32[i69 >> 2] = 27;
     break;
    }
   default:
    {
     i15 = 134;
     break L17;
    }
   }
   i10 = i47;
   i9 = i16;
   i3 = i8 + -3 | 0;
   i4 = i4 >>> 3;
  } else if ((i15 | 0) == 163) {
   i15 = 0;
   i10 = HEAP32[i20 >> 2] | 0;
   i9 = HEAP32[i21 >> 2] | 0;
   do if (i8 >>> 0 < (i9 + i10 | 0) >>> 0) {
    i14 = i8;
    i13 = i10;
    L179 : while (1) {
     i11 = (1 << HEAP32[i36 >> 2]) + -1 | 0;
     i8 = i11 & i4;
     i12 = HEAP32[i35 >> 2] | 0;
     i10 = HEAPU8[i12 + (i8 << 2) + 1 >> 0] | 0;
     if (i10 >>> 0 > i3 >>> 0) {
      i8 = i1;
      while (1) {
       if (!i7) {
        i57 = i16;
        i49 = i3;
        i48 = i4;
        i2 = 0;
        i46 = i8;
        i50 = i5;
        i45 = i6;
        break L17;
       }
       i7 = i7 + -1 | 0;
       i1 = i8 + 1 | 0;
       i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
       i3 = i3 + 8 | 0;
       i8 = i11 & i4;
       i10 = HEAPU8[i12 + (i8 << 2) + 1 >> 0] | 0;
       if (i10 >>> 0 > i3 >>> 0) i8 = i1; else break;
      }
     }
     i11 = HEAP16[i12 + (i8 << 2) + 2 >> 1] | 0;
     if ((i11 & 65535) < 16) {
      if (i3 >>> 0 < i10 >>> 0) {
       i8 = i1;
       while (1) {
        if (!i7) {
         i57 = i16;
         i49 = i3;
         i48 = i4;
         i2 = 0;
         i46 = i8;
         i50 = i5;
         i45 = i6;
         break L17;
        }
        i7 = i7 + -1 | 0;
        i1 = i8 + 1 | 0;
        i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
        i3 = i3 + 8 | 0;
        if (i3 >>> 0 < i10 >>> 0) i8 = i1; else break;
       }
      }
      HEAP32[i19 >> 2] = i14 + 1;
      HEAP16[i69 + 112 + (i14 << 1) >> 1] = i11;
      i3 = i3 - i10 | 0;
      i4 = i4 >>> i10;
     } else {
      switch (i11 << 16 >> 16) {
      case 16:
       {
        i11 = i10 + 2 | 0;
        if (i3 >>> 0 < i11 >>> 0) {
         i8 = i1;
         while (1) {
          if (!i7) {
           i57 = i16;
           i49 = i3;
           i48 = i4;
           i2 = 0;
           i46 = i8;
           i50 = i5;
           i45 = i6;
           break L17;
          }
          i7 = i7 + -1 | 0;
          i1 = i8 + 1 | 0;
          i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
          i3 = i3 + 8 | 0;
          if (i3 >>> 0 < i11 >>> 0) i8 = i1; else break;
         }
        }
        i8 = i4 >>> i10;
        i3 = i3 - i10 | 0;
        if (!i14) {
         i15 = 180;
         break L179;
        }
        i11 = HEAPU16[i69 + 112 + (i14 + -1 << 1) >> 1] | 0;
        i3 = i3 + -2 | 0;
        i4 = i8 >>> 2;
        i8 = (i8 & 3) + 3 | 0;
        break;
       }
      case 17:
       {
        i11 = i10 + 3 | 0;
        if (i3 >>> 0 < i11 >>> 0) {
         i8 = i1;
         while (1) {
          if (!i7) {
           i57 = i16;
           i49 = i3;
           i48 = i4;
           i2 = 0;
           i46 = i8;
           i50 = i5;
           i45 = i6;
           break L17;
          }
          i7 = i7 + -1 | 0;
          i1 = i8 + 1 | 0;
          i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
          i3 = i3 + 8 | 0;
          if (i3 >>> 0 < i11 >>> 0) i8 = i1; else break;
         }
        }
        i8 = i4 >>> i10;
        i11 = 0;
        i3 = -3 - i10 + i3 | 0;
        i4 = i8 >>> 3;
        i8 = (i8 & 7) + 3 | 0;
        break;
       }
      default:
       {
        i11 = i10 + 7 | 0;
        if (i3 >>> 0 < i11 >>> 0) {
         i8 = i1;
         while (1) {
          if (!i7) {
           i57 = i16;
           i49 = i3;
           i48 = i4;
           i2 = 0;
           i46 = i8;
           i50 = i5;
           i45 = i6;
           break L17;
          }
          i7 = i7 + -1 | 0;
          i1 = i8 + 1 | 0;
          i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
          i3 = i3 + 8 | 0;
          if (i3 >>> 0 < i11 >>> 0) i8 = i1; else break;
         }
        }
        i8 = i4 >>> i10;
        i11 = 0;
        i3 = -7 - i10 + i3 | 0;
        i4 = i8 >>> 7;
        i8 = (i8 & 127) + 11 | 0;
       }
      }
      if ((i14 + i8 | 0) >>> 0 > (i9 + i13 | 0) >>> 0) {
       i15 = 190;
       break;
      }
      i9 = i11 & 65535;
      i8 = i8 + -1 | 0;
      HEAP32[i19 >> 2] = i14 + 1;
      HEAP16[i69 + 112 + (i14 << 1) >> 1] = i9;
      if (i8) do {
       i14 = HEAP32[i19 >> 2] | 0;
       i8 = i8 + -1 | 0;
       HEAP32[i19 >> 2] = i14 + 1;
       HEAP16[i69 + 112 + (i14 << 1) >> 1] = i9;
      } while ((i8 | 0) != 0);
     }
     i14 = HEAP32[i19 >> 2] | 0;
     i13 = HEAP32[i20 >> 2] | 0;
     i9 = HEAP32[i21 >> 2] | 0;
     if (i14 >>> 0 >= (i9 + i13 | 0) >>> 0) {
      i15 = 192;
      break;
     }
    }
    if ((i15 | 0) == 180) {
     i15 = 0;
     HEAP32[i29 >> 2] = gb + 362822;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     i4 = i8;
     break L159;
    } else if ((i15 | 0) == 190) {
     i15 = 0;
     HEAP32[i29 >> 2] = gb + 362822;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break L159;
    } else if ((i15 | 0) == 192) {
     i15 = 0;
     if ((HEAP32[i69 >> 2] | 0) == 27) {
      i10 = i47;
      i9 = i16;
      break L159;
     } else {
      i5 = i13;
      break;
     }
    }
   } else i5 = i10; while (0);
   HEAP32[i23 >> 2] = i22;
   HEAP32[i35 >> 2] = i22;
   HEAP32[i36 >> 2] = 9;
   i5 = _inflate_table(1, i24, i5, i23, i36, i25) | 0;
   if (i5 | 0) {
    HEAP32[i29 >> 2] = gb + 362848;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
   HEAP32[i37 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i38 >> 2] = 6;
   i5 = _inflate_table(2, i69 + 112 + (HEAP32[i20 >> 2] << 1) | 0, HEAP32[i21 >> 2] | 0, i23, i38, i25) | 0;
   if (!i5) {
    HEAP32[i69 >> 2] = 18;
    i5 = 0;
    i15 = 198;
    break;
   } else {
    HEAP32[i29 >> 2] = gb + 362876;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
  } while (0);
  do if ((i15 | 0) == 56) {
   i3 = HEAP32[i28 >> 2] | 0;
   if (i3 | 0) {
    HEAP32[i3 + 8 >> 2] = i4 & 255;
    HEAP32[i3 + 12 >> 2] = i4 >>> 8;
   }
   if (HEAP32[i61 >> 2] & 512 | 0) {
    HEAP8[i44 >> 0] = i4;
    HEAP8[i27 >> 0] = i4 >>> 8;
    HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i44, 2) | 0;
   }
   HEAP32[i69 >> 2] = 4;
   i3 = 0;
   i4 = 0;
   i15 = 61;
  } else if ((i15 | 0) == 198) {
   i15 = 0;
   if (i6 >>> 0 > 257 & i7 >>> 0 > 5) {
    HEAP32[i62 >> 2] = i47;
    HEAP32[i54 >> 2] = i6;
    HEAP32[i67 >> 2] = i1;
    HEAP32[i51 >> 2] = i7;
    HEAP32[i52 >> 2] = i4;
    HEAP32[i63 >> 2] = i3;
    _inflate_fast(i67, i16);
    i10 = HEAP32[i62 >> 2] | 0;
    i1 = HEAP32[i67 >> 2] | 0;
    i9 = i16;
    i3 = HEAP32[i63 >> 2] | 0;
    i4 = HEAP32[i52 >> 2] | 0;
    i6 = HEAP32[i54 >> 2] | 0;
    i7 = HEAP32[i51 >> 2] | 0;
    break;
   }
   i12 = (1 << HEAP32[i36 >> 2]) + -1 | 0;
   i10 = i12 & i4;
   i13 = HEAP32[i35 >> 2] | 0;
   i9 = HEAP8[i13 + (i10 << 2) + 1 >> 0] | 0;
   i8 = i9 & 255;
   if (i8 >>> 0 > i3 >>> 0) while (1) {
    if (!i7) {
     i57 = i16;
     i49 = i3;
     i48 = i4;
     i2 = 0;
     i46 = i1;
     i50 = i5;
     i45 = i6;
     break L17;
    }
    i7 = i7 + -1 | 0;
    i11 = i1 + 1 | 0;
    i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
    i3 = i3 + 8 | 0;
    i10 = i12 & i4;
    i9 = HEAP8[i13 + (i10 << 2) + 1 >> 0] | 0;
    i8 = i9 & 255;
    if (i8 >>> 0 > i3 >>> 0) i1 = i11; else {
     i1 = i11;
     i12 = i8;
     break;
    }
   } else i12 = i8;
   i8 = HEAP16[i13 + (i10 << 2) + 2 >> 1] | 0;
   i11 = HEAP8[i13 + (i10 << 2) >> 0] | 0;
   i10 = i11 & 255;
   if (i11 << 24 >> 24 != 0 & (i10 & 240 | 0) == 0) {
    i11 = i8 & 65535;
    i10 = (1 << i12 + i10) + -1 | 0;
    i8 = ((i4 & i10) >>> i12) + i11 | 0;
    i9 = HEAP8[i13 + (i8 << 2) + 1 >> 0] | 0;
    if (((i9 & 255) + i12 | 0) >>> 0 > i3 >>> 0) {
     i8 = i1;
     while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      i8 = ((i4 & i10) >>> i12) + i11 | 0;
      i9 = HEAP8[i13 + (i8 << 2) + 1 >> 0] | 0;
      if (((i9 & 255) + i12 | 0) >>> 0 > i3 >>> 0) i8 = i1; else break;
     }
    }
    i3 = i3 - i12 | 0;
    i4 = i4 >>> i12;
    i11 = HEAP8[i13 + (i8 << 2) >> 0] | 0;
    i8 = HEAP16[i13 + (i8 << 2) + 2 >> 1] | 0;
   }
   i14 = i9 & 255;
   i4 = i4 >>> i14;
   i3 = i3 - i14 | 0;
   HEAP32[i32 >> 2] = i8 & 65535;
   i8 = i11 & 255;
   if (!(i11 << 24 >> 24)) {
    HEAP32[i69 >> 2] = 23;
    i10 = i47;
    i9 = i16;
    break;
   }
   if (i8 & 32 | 0) {
    HEAP32[i69 >> 2] = 11;
    i10 = i47;
    i9 = i16;
    break;
   }
   if (!(i8 & 64)) {
    i9 = i8 & 15;
    HEAP32[i39 >> 2] = i9;
    HEAP32[i69 >> 2] = 19;
    i15 = 215;
    break;
   } else {
    HEAP32[i29 >> 2] = gb + 362898;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
  } while (0);
  if ((i15 | 0) == 61) {
   i15 = 0;
   i9 = HEAP32[i61 >> 2] | 0;
   if (!(i9 & 1024)) {
    i8 = HEAP32[i28 >> 2] | 0;
    if (i8) HEAP32[i8 + 16 >> 2] = 0;
   } else {
    if (i3 >>> 0 < 16) {
     i8 = i1;
     while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      if (i3 >>> 0 >= 16) break; else i8 = i1;
     }
    }
    HEAP32[i32 >> 2] = i4;
    i3 = HEAP32[i28 >> 2] | 0;
    if (i3 | 0) HEAP32[i3 + 20 >> 2] = i4;
    if (!(i9 & 512)) {
     i3 = 0;
     i4 = 0;
    } else {
     HEAP8[i44 >> 0] = i4;
     HEAP8[i27 >> 0] = i4 >>> 8;
     HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i44, 2) | 0;
     i3 = 0;
     i4 = 0;
    }
   }
   HEAP32[i69 >> 2] = 5;
   i15 = 72;
  } else if ((i15 | 0) == 215) {
   i15 = 0;
   if (i9) {
    if (i3 >>> 0 < i9 >>> 0) {
     i8 = i1;
     while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      if (i3 >>> 0 < i9 >>> 0) i8 = i1; else break;
     }
    }
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + ((1 << i9) + -1 & i4);
    i3 = i3 - i9 | 0;
    i4 = i4 >>> i9;
   }
   HEAP32[i69 >> 2] = 20;
   i15 = 221;
  }
  do if ((i15 | 0) == 72) {
   i9 = HEAP32[i61 >> 2] | 0;
   if (i9 & 1024) {
    i8 = HEAP32[i32 >> 2] | 0;
    i12 = i8 >>> 0 > i7 >>> 0 ? i7 : i8;
    if (i12) {
     i10 = HEAP32[i28 >> 2] | 0;
     if (!i10) i8 = i9; else {
      i11 = HEAP32[i10 + 16 >> 2] | 0;
      if (!i11) i8 = i9; else {
       i8 = (HEAP32[i10 + 20 >> 2] | 0) - i8 | 0;
       i15 = HEAP32[i10 + 24 >> 2] | 0;
       _memcpy(i11 + i8 | 0, i1 | 0, ((i8 + i12 | 0) >>> 0 > i15 >>> 0 ? i15 - i8 | 0 : i12) | 0) | 0;
       i8 = HEAP32[i61 >> 2] | 0;
      }
     }
     if (i8 & 512 | 0) HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i1, i12) | 0;
     i8 = (HEAP32[i32 >> 2] | 0) - i12 | 0;
     HEAP32[i32 >> 2] = i8;
     i1 = i1 + i12 | 0;
     i7 = i7 - i12 | 0;
    }
    if (i8) {
     i2 = i7;
     i15 = 276;
     break L17;
    }
   }
   HEAP32[i32 >> 2] = 0;
   HEAP32[i69 >> 2] = 6;
   i15 = 82;
  } else if ((i15 | 0) == 221) {
   i15 = 0;
   i12 = (1 << HEAP32[i38 >> 2]) + -1 | 0;
   i10 = i12 & i4;
   i13 = HEAP32[i37 >> 2] | 0;
   i8 = HEAP8[i13 + (i10 << 2) + 1 >> 0] | 0;
   i9 = i8 & 255;
   if (i9 >>> 0 > i3 >>> 0) while (1) {
    if (!i7) {
     i57 = i16;
     i49 = i3;
     i48 = i4;
     i2 = 0;
     i46 = i1;
     i50 = i5;
     i45 = i6;
     break L17;
    }
    i7 = i7 + -1 | 0;
    i11 = i1 + 1 | 0;
    i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
    i3 = i3 + 8 | 0;
    i10 = i12 & i4;
    i8 = HEAP8[i13 + (i10 << 2) + 1 >> 0] | 0;
    i9 = i8 & 255;
    if (i9 >>> 0 > i3 >>> 0) i1 = i11; else {
     i1 = i11;
     i12 = i9;
     break;
    }
   } else i12 = i9;
   i9 = HEAP16[i13 + (i10 << 2) + 2 >> 1] | 0;
   i11 = HEAP8[i13 + (i10 << 2) >> 0] | 0;
   i10 = i11 & 255;
   if (!(i10 & 240)) {
    i11 = i9 & 65535;
    i10 = (1 << i12 + i10) + -1 | 0;
    i9 = ((i4 & i10) >>> i12) + i11 | 0;
    i8 = HEAP8[i13 + (i9 << 2) + 1 >> 0] | 0;
    if (((i8 & 255) + i12 | 0) >>> 0 > i3 >>> 0) {
     i8 = i1;
     while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      i9 = ((i4 & i10) >>> i12) + i11 | 0;
      i8 = HEAP8[i13 + (i9 << 2) + 1 >> 0] | 0;
      if (((i8 & 255) + i12 | 0) >>> 0 > i3 >>> 0) i8 = i1; else break;
     }
    }
    i3 = i3 - i12 | 0;
    i4 = i4 >>> i12;
    i11 = HEAP8[i13 + (i9 << 2) >> 0] | 0;
    i9 = HEAP16[i13 + (i9 << 2) + 2 >> 1] | 0;
   }
   i8 = i8 & 255;
   i4 = i4 >>> i8;
   i3 = i3 - i8 | 0;
   i8 = i11 & 255;
   if (!(i8 & 64)) {
    HEAP32[i40 >> 2] = i9 & 65535;
    i9 = i8 & 15;
    HEAP32[i39 >> 2] = i9;
    HEAP32[i69 >> 2] = 21;
    i15 = 232;
    break;
   } else {
    HEAP32[i29 >> 2] = gb + 362926;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   }
  } while (0);
  do if ((i15 | 0) == 82) {
   if (!(HEAP32[i61 >> 2] & 2048)) {
    i8 = HEAP32[i28 >> 2] | 0;
    if (i8) HEAP32[i8 + 28 >> 2] = 0;
   } else {
    if (!i7) {
     i2 = 0;
     i15 = 276;
     break L17;
    } else i12 = 0;
    do {
     i8 = i12;
     i12 = i12 + 1 | 0;
     i8 = HEAP8[i1 + i8 >> 0] | 0;
     i9 = HEAP32[i28 >> 2] | 0;
     if (i9 | 0) {
      i10 = HEAP32[i9 + 28 >> 2] | 0;
      if (i10 | 0) {
       i11 = HEAP32[i32 >> 2] | 0;
       if (i11 >>> 0 < (HEAP32[i9 + 32 >> 2] | 0) >>> 0) {
        HEAP32[i32 >> 2] = i11 + 1;
        HEAP8[i10 + i11 >> 0] = i8;
       }
      }
     }
     i8 = i8 << 24 >> 24 != 0;
    } while (i8 & i7 >>> 0 > i12 >>> 0);
    if (HEAP32[i61 >> 2] & 512 | 0) HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i1, i12) | 0;
    i7 = i7 - i12 | 0;
    i1 = i1 + i12 | 0;
    if (i8) {
     i2 = i7;
     i15 = 276;
     break L17;
    }
   }
   HEAP32[i32 >> 2] = 0;
   HEAP32[i69 >> 2] = 7;
   i15 = 95;
  } else if ((i15 | 0) == 232) {
   i15 = 0;
   if (!i9) i8 = HEAP32[i40 >> 2] | 0; else {
    if (i3 >>> 0 < i9 >>> 0) {
     i8 = i1;
     while (1) {
      if (!i7) {
       i57 = i16;
       i49 = i3;
       i48 = i4;
       i2 = 0;
       i46 = i8;
       i50 = i5;
       i45 = i6;
       break L17;
      }
      i7 = i7 + -1 | 0;
      i1 = i8 + 1 | 0;
      i4 = ((HEAPU8[i8 >> 0] | 0) << i3) + i4 | 0;
      i3 = i3 + 8 | 0;
      if (i3 >>> 0 < i9 >>> 0) i8 = i1; else break;
     }
    }
    i8 = (HEAP32[i40 >> 2] | 0) + ((1 << i9) + -1 & i4) | 0;
    HEAP32[i40 >> 2] = i8;
    i3 = i3 - i9 | 0;
    i4 = i4 >>> i9;
   }
   if (i8 >>> 0 > (i16 - i6 + (HEAP32[i41 >> 2] | 0) | 0) >>> 0) {
    HEAP32[i29 >> 2] = gb + 362948;
    HEAP32[i69 >> 2] = 27;
    i10 = i47;
    i9 = i16;
    break;
   } else {
    HEAP32[i69 >> 2] = 22;
    i15 = 241;
    break;
   }
  } while (0);
  if ((i15 | 0) == 95) {
   if (!(HEAP32[i61 >> 2] & 4096)) {
    i8 = HEAP32[i28 >> 2] | 0;
    if (i8) HEAP32[i8 + 36 >> 2] = 0;
   } else {
    if (!i7) {
     i2 = 0;
     i15 = 276;
     break;
    } else i12 = 0;
    do {
     i8 = i12;
     i12 = i12 + 1 | 0;
     i8 = HEAP8[i1 + i8 >> 0] | 0;
     i9 = HEAP32[i28 >> 2] | 0;
     if (i9 | 0) {
      i10 = HEAP32[i9 + 36 >> 2] | 0;
      if (i10 | 0) {
       i11 = HEAP32[i32 >> 2] | 0;
       if (i11 >>> 0 < (HEAP32[i9 + 40 >> 2] | 0) >>> 0) {
        HEAP32[i32 >> 2] = i11 + 1;
        HEAP8[i10 + i11 >> 0] = i8;
       }
      }
     }
     i8 = i8 << 24 >> 24 != 0;
    } while (i8 & i7 >>> 0 > i12 >>> 0);
    if (HEAP32[i61 >> 2] & 512 | 0) HEAP32[i64 >> 2] = _unity_z_crc32(HEAP32[i64 >> 2] | 0, i1, i12) | 0;
    i7 = i7 - i12 | 0;
    i1 = i1 + i12 | 0;
    if (i8) {
     i2 = i7;
     i15 = 276;
     break;
    }
   }
   HEAP32[i69 >> 2] = 8;
   i15 = 108;
  } else if ((i15 | 0) == 241) {
   i15 = 0;
   if (!i6) {
    i2 = i7;
    i6 = 0;
    i15 = 276;
    break;
   }
   i8 = i16 - i6 | 0;
   i9 = HEAP32[i40 >> 2] | 0;
   if (i9 >>> 0 > i8 >>> 0) {
    i9 = i9 - i8 | 0;
    i8 = HEAP32[i42 >> 2] | 0;
    if (i9 >>> 0 > i8 >>> 0) {
     i9 = i9 - i8 | 0;
     i8 = (HEAP32[i43 >> 2] | 0) + ((HEAP32[i53 >> 2] | 0) - i9) | 0;
    } else i8 = (HEAP32[i43 >> 2] | 0) + (i8 - i9) | 0;
    i10 = HEAP32[i32 >> 2] | 0;
    i9 = i9 >>> 0 > i10 >>> 0 ? i10 : i9;
   } else {
    i10 = HEAP32[i32 >> 2] | 0;
    i8 = i47 + (0 - i9) | 0;
    i9 = i10;
   }
   i11 = i9 >>> 0 > i6 >>> 0 ? i6 : i9;
   HEAP32[i32 >> 2] = i10 - i11;
   i9 = i11;
   i10 = i47;
   while (1) {
    i47 = i10;
    i10 = i10 + 1 | 0;
    HEAP8[i47 >> 0] = HEAP8[i8 >> 0] | 0;
    i9 = i9 + -1 | 0;
    if (!i9) break; else i8 = i8 + 1 | 0;
   }
   i6 = i6 - i11 | 0;
   if (!(HEAP32[i32 >> 2] | 0)) {
    HEAP32[i69 >> 2] = 18;
    i9 = i16;
   } else i9 = i16;
  }
  do if ((i15 | 0) == 108) {
   i15 = 0;
   i9 = HEAP32[i61 >> 2] | 0;
   if (i9 & 512) {
    if (i3 >>> 0 < 16) while (1) {
     if (!i7) {
      i57 = i16;
      i49 = i3;
      i48 = i4;
      i2 = 0;
      i46 = i1;
      i50 = i5;
      i45 = i6;
      break L17;
     }
     i7 = i7 + -1 | 0;
     i8 = i1 + 1 | 0;
     i4 = ((HEAPU8[i1 >> 0] | 0) << i3) + i4 | 0;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 < 16) i1 = i8; else {
      i1 = i8;
      break;
     }
    }
    if ((i4 | 0) == (HEAP32[i64 >> 2] & 65535 | 0)) {
     i3 = 0;
     i4 = 0;
    } else {
     HEAP32[i29 >> 2] = gb + 362649;
     HEAP32[i69 >> 2] = 27;
     i10 = i47;
     i9 = i16;
     break;
    }
   }
   i8 = HEAP32[i28 >> 2] | 0;
   if (i8 | 0) {
    HEAP32[i8 + 44 >> 2] = i9 >>> 9 & 1;
    HEAP32[i8 + 48 >> 2] = 1;
   }
   i10 = _unity_z_crc32(0, 0, 0) | 0;
   HEAP32[i64 >> 2] = i10;
   HEAP32[i65 >> 2] = i10;
   HEAP32[i69 >> 2] = 11;
   i10 = i47;
   i9 = i16;
  } while (0);
  i47 = i10;
  i8 = i1;
  i16 = i9;
  i1 = HEAP32[i69 >> 2] | 0;
 }
 if ((i15 | 0) == 121) {
  HEAP32[i62 >> 2] = i47;
  HEAP32[i54 >> 2] = i6;
  HEAP32[i67 >> 2] = i1;
  HEAP32[i51 >> 2] = i7;
  HEAP32[i52 >> 2] = i4;
  HEAP32[i63 >> 2] = i3;
  i69 = 2;
  STACKTOP = i70;
  return i69 | 0;
 } else if ((i15 | 0) != 134) if ((i15 | 0) == 275) {
  HEAP32[i69 >> 2] = 26;
  i57 = i9;
  i49 = i3;
  i48 = i4;
  i46 = i1;
  i50 = 1;
  i45 = i6;
 } else if ((i15 | 0) == 276) {
  i57 = i16;
  i49 = i3;
  i48 = i4;
  i46 = i1;
  i50 = i5;
  i45 = i6;
 } else if ((i15 | 0) == 289) {
  i69 = -4;
  STACKTOP = i70;
  return i69 | 0;
 } else if ((i15 | 0) == 290) {
  STACKTOP = i70;
  return i1 | 0;
 }
 HEAP32[i62 >> 2] = i47;
 HEAP32[i54 >> 2] = i45;
 HEAP32[i67 >> 2] = i46;
 HEAP32[i51 >> 2] = i2;
 HEAP32[i52 >> 2] = i48;
 HEAP32[i63 >> 2] = i49;
 if (!(HEAP32[i53 >> 2] | 0)) if ((HEAP32[i69 >> 2] | 0) >>> 0 > 23 | (i57 | 0) == (i45 | 0)) i1 = i45; else i15 = 279; else i15 = 279;
 do if ((i15 | 0) == 279) {
  if (!(_updatewindow(i67, i57) | 0)) {
   i2 = HEAP32[i51 >> 2] | 0;
   i1 = HEAP32[i54 >> 2] | 0;
   break;
  }
  HEAP32[i69 >> 2] = 28;
  i69 = -4;
  STACKTOP = i70;
  return i69 | 0;
 } while (0);
 i4 = i55 - i2 | 0;
 i3 = i57 - i1 | 0;
 i57 = i67 + 8 | 0;
 HEAP32[i57 >> 2] = (HEAP32[i57 >> 2] | 0) + i4;
 HEAP32[i59 >> 2] = (HEAP32[i59 >> 2] | 0) + i3;
 HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i3;
 if (i56) if ((i3 | 0) != 0 & (HEAP32[i58 >> 2] | 0) != 0) {
  i2 = HEAP32[i64 >> 2] | 0;
  i1 = (HEAP32[i62 >> 2] | 0) + (0 - i3) | 0;
  if (!(HEAP32[i61 >> 2] | 0)) i1 = _unity_z_adler32(i2, i1, i3) | 0; else i1 = _unity_z_crc32(i2, i1, i3) | 0;
  HEAP32[i64 >> 2] = i1;
  HEAP32[i65 >> 2] = i1;
 }
 HEAP32[i67 + 44 >> 2] = (HEAP32[i66 >> 2] | 0 ? 64 : 0) + (HEAP32[i63 >> 2] | 0) + ((HEAP32[i69 >> 2] | 0) == 11 ? 128 : 0);
 i69 = (i50 | 0) == 0 & ((i68 | 0) == 4 | (i3 | i4 | 0) == 0) ? -5 : i50;
 STACKTOP = i70;
 return i69 | 0;
}

function __ZN5physx18PxcArticulationRef9ltbFactorERNS_9PxcFsDataE(i96) {
 i96 = i96 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0;
 i100 = STACKTOP;
 STACKTOP = STACKTOP + 7376 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i99 = i100 + 456 | 0;
 i94 = i100;
 i90 = i100 + 312 | 0;
 i95 = i100 + 420 | 0;
 i91 = i100 + 204 | 0;
 i92 = i100 + 96 | 0;
 i93 = HEAPU16[i96 + 24 >> 1] | 0;
 i97 = i96 + i93 | 0;
 i98 = i96 + 8 | 0;
 i1 = HEAP16[i98 >> 1] | 0;
 if (!(i1 << 16 >> 16)) i1 = 0; else {
  i1 = i1 & 65535;
  i2 = 0;
  do {
   i64 = HEAP32[i97 + (i2 * 400 | 0) + 4 >> 2] | 0;
   i65 = HEAP32[i97 + (i2 * 400 | 0) + 8 >> 2] | 0;
   i66 = HEAP32[i97 + (i2 * 400 | 0) + 16 >> 2] | 0;
   i67 = HEAP32[i97 + (i2 * 400 | 0) + 20 >> 2] | 0;
   i68 = HEAP32[i97 + (i2 * 400 | 0) + 24 >> 2] | 0;
   i69 = HEAP32[i97 + (i2 * 400 | 0) + 32 >> 2] | 0;
   i70 = HEAP32[i97 + (i2 * 400 | 0) + 36 >> 2] | 0;
   i71 = HEAP32[i97 + (i2 * 400 | 0) + 40 >> 2] | 0;
   i72 = HEAP32[i97 + (i2 * 400 | 0) + 48 >> 2] | 0;
   i73 = HEAP32[i97 + (i2 * 400 | 0) + 52 >> 2] | 0;
   i74 = HEAP32[i97 + (i2 * 400 | 0) + 56 >> 2] | 0;
   i75 = HEAP32[i97 + (i2 * 400 | 0) + 64 >> 2] | 0;
   i76 = HEAP32[i97 + (i2 * 400 | 0) + 68 >> 2] | 0;
   i77 = HEAP32[i97 + (i2 * 400 | 0) + 72 >> 2] | 0;
   i78 = HEAP32[i97 + (i2 * 400 | 0) + 80 >> 2] | 0;
   i79 = HEAP32[i97 + (i2 * 400 | 0) + 84 >> 2] | 0;
   i80 = HEAP32[i97 + (i2 * 400 | 0) + 88 >> 2] | 0;
   i81 = HEAP32[i97 + (i2 * 400 | 0) + 96 >> 2] | 0;
   i82 = HEAP32[i97 + (i2 * 400 | 0) + 100 >> 2] | 0;
   i83 = HEAP32[i97 + (i2 * 400 | 0) + 104 >> 2] | 0;
   i84 = HEAP32[i97 + (i2 * 400 | 0) + 112 >> 2] | 0;
   i85 = HEAP32[i97 + (i2 * 400 | 0) + 116 >> 2] | 0;
   i86 = HEAP32[i97 + (i2 * 400 | 0) + 120 >> 2] | 0;
   i87 = HEAP32[i97 + (i2 * 400 | 0) + 128 >> 2] | 0;
   i88 = HEAP32[i97 + (i2 * 400 | 0) + 132 >> 2] | 0;
   i89 = HEAP32[i97 + (i2 * 400 | 0) + 136 >> 2] | 0;
   HEAP32[i99 + (i2 * 108 | 0) >> 2] = HEAP32[i97 + (i2 * 400 | 0) >> 2];
   HEAP32[i99 + (i2 * 108 | 0) + 4 >> 2] = i64;
   HEAP32[i99 + (i2 * 108 | 0) + 8 >> 2] = i65;
   HEAP32[i99 + (i2 * 108 | 0) + 12 >> 2] = i66;
   HEAP32[i99 + (i2 * 108 | 0) + 16 >> 2] = i67;
   HEAP32[i99 + (i2 * 108 | 0) + 20 >> 2] = i68;
   HEAP32[i99 + (i2 * 108 | 0) + 24 >> 2] = i69;
   HEAP32[i99 + (i2 * 108 | 0) + 28 >> 2] = i70;
   HEAP32[i99 + (i2 * 108 | 0) + 32 >> 2] = i71;
   HEAP32[i99 + (i2 * 108 | 0) + 36 >> 2] = i72;
   HEAP32[i99 + (i2 * 108 | 0) + 40 >> 2] = i73;
   HEAP32[i99 + (i2 * 108 | 0) + 44 >> 2] = i74;
   HEAP32[i99 + (i2 * 108 | 0) + 48 >> 2] = i75;
   HEAP32[i99 + (i2 * 108 | 0) + 52 >> 2] = i76;
   HEAP32[i99 + (i2 * 108 | 0) + 56 >> 2] = i77;
   HEAP32[i99 + (i2 * 108 | 0) + 60 >> 2] = i78;
   HEAP32[i99 + (i2 * 108 | 0) + 64 >> 2] = i79;
   HEAP32[i99 + (i2 * 108 | 0) + 68 >> 2] = i80;
   HEAP32[i99 + (i2 * 108 | 0) + 72 >> 2] = i81;
   HEAP32[i99 + (i2 * 108 | 0) + 76 >> 2] = i82;
   HEAP32[i99 + (i2 * 108 | 0) + 80 >> 2] = i83;
   HEAP32[i99 + (i2 * 108 | 0) + 84 >> 2] = i84;
   HEAP32[i99 + (i2 * 108 | 0) + 88 >> 2] = i85;
   HEAP32[i99 + (i2 * 108 | 0) + 92 >> 2] = i86;
   HEAP32[i99 + (i2 * 108 | 0) + 96 >> 2] = i87;
   HEAP32[i99 + (i2 * 108 | 0) + 100 >> 2] = i88;
   HEAP32[i99 + (i2 * 108 | 0) + 104 >> 2] = i89;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  i1 = HEAP16[i98 >> 1] | 0;
 }
 i1 = (i1 & 65535) + -1 | 0;
 if (i1 | 0) {
  i88 = i90 + 4 | 0;
  i89 = i90 + 8 | 0;
  i2 = i90 + 12 | 0;
  i3 = i90 + 16 | 0;
  i4 = i90 + 20 | 0;
  i5 = i90 + 24 | 0;
  i6 = i90 + 28 | 0;
  i7 = i90 + 32 | 0;
  i8 = i90 + 36 | 0;
  i9 = i90 + 40 | 0;
  i10 = i90 + 44 | 0;
  i11 = i90 + 48 | 0;
  i12 = i90 + 52 | 0;
  i13 = i90 + 56 | 0;
  i14 = i90 + 60 | 0;
  i15 = i90 + 64 | 0;
  i16 = i90 + 68 | 0;
  i17 = i90 + 72 | 0;
  i18 = i90 + 76 | 0;
  i19 = i90 + 80 | 0;
  i20 = i90 + 84 | 0;
  i21 = i90 + 88 | 0;
  i22 = i90 + 92 | 0;
  i23 = i90 + 96 | 0;
  i24 = i90 + 100 | 0;
  i25 = i90 + 104 | 0;
  i26 = i94 + 4 | 0;
  i27 = i94 + 8 | 0;
  i28 = i94 + 12 | 0;
  i29 = i94 + 16 | 0;
  i30 = i94 + 20 | 0;
  i31 = i94 + 24 | 0;
  i32 = i94 + 28 | 0;
  i33 = i94 + 32 | 0;
  i34 = i94 + 36 | 0;
  i35 = i94 + 40 | 0;
  i36 = i94 + 44 | 0;
  i37 = i94 + 48 | 0;
  i38 = i94 + 52 | 0;
  i39 = i94 + 56 | 0;
  i40 = i94 + 60 | 0;
  i41 = i94 + 64 | 0;
  i42 = i94 + 68 | 0;
  i43 = i94 + 72 | 0;
  i44 = i94 + 76 | 0;
  i45 = i94 + 80 | 0;
  i46 = i94 + 84 | 0;
  i47 = i94 + 88 | 0;
  i48 = i94 + 92 | 0;
  i49 = i94 + 16 | 0;
  i50 = i95 + 4 | 0;
  i51 = i95 + 8 | 0;
  i52 = i95 + 12 | 0;
  i53 = i95 + 16 | 0;
  i54 = i95 + 20 | 0;
  i55 = i95 + 24 | 0;
  i56 = i95 + 28 | 0;
  i57 = i95 + 32 | 0;
  i58 = i94 + 32 | 0;
  i59 = i94 + 48 | 0;
  i60 = i94 + 64 | 0;
  i61 = i94 + 80 | 0;
  i62 = i91 + 4 | 0;
  i63 = i91 + 8 | 0;
  i64 = i91 + 12 | 0;
  i65 = i91 + 16 | 0;
  i66 = i91 + 20 | 0;
  i67 = i91 + 24 | 0;
  i68 = i91 + 28 | 0;
  i69 = i91 + 32 | 0;
  i70 = i91 + 36 | 0;
  i71 = i91 + 40 | 0;
  i72 = i91 + 44 | 0;
  i73 = i91 + 48 | 0;
  i74 = i91 + 52 | 0;
  i75 = i91 + 56 | 0;
  i76 = i91 + 60 | 0;
  i77 = i91 + 64 | 0;
  i78 = i91 + 68 | 0;
  i79 = i91 + 72 | 0;
  i80 = i91 + 76 | 0;
  i81 = i91 + 80 | 0;
  i82 = i91 + 84 | 0;
  i83 = i91 + 88 | 0;
  i84 = i91 + 92 | 0;
  i85 = i91 + 96 | 0;
  i86 = i91 + 100 | 0;
  i87 = i91 + 104 | 0;
  do {
   i166 = i99 + (i1 * 108 | 0) | 0;
   __ZN5physx24PxcArticulationFnsScalar13invertInertiaERKNS_9SpInertiaE(i90, i166);
   HEAP32[i166 >> 2] = HEAP32[i90 >> 2];
   i165 = i99 + (i1 * 108 | 0) + 4 | 0;
   HEAP32[i165 >> 2] = HEAP32[i88 >> 2];
   i112 = i99 + (i1 * 108 | 0) + 8 | 0;
   HEAP32[i112 >> 2] = HEAP32[i89 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 12 >> 2] = HEAP32[i2 >> 2];
   i163 = i99 + (i1 * 108 | 0) + 16 | 0;
   HEAP32[i163 >> 2] = HEAP32[i3 >> 2];
   i111 = i99 + (i1 * 108 | 0) + 20 | 0;
   HEAP32[i111 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 24 >> 2] = HEAP32[i5 >> 2];
   i161 = i99 + (i1 * 108 | 0) + 28 | 0;
   HEAP32[i161 >> 2] = HEAP32[i6 >> 2];
   i140 = i99 + (i1 * 108 | 0) + 32 | 0;
   HEAP32[i140 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 36 >> 2] = HEAP32[i8 >> 2];
   i159 = i99 + (i1 * 108 | 0) + 40 | 0;
   HEAP32[i159 >> 2] = HEAP32[i9 >> 2];
   i110 = i99 + (i1 * 108 | 0) + 44 | 0;
   HEAP32[i110 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 48 >> 2] = HEAP32[i11 >> 2];
   i157 = i99 + (i1 * 108 | 0) + 52 | 0;
   HEAP32[i157 >> 2] = HEAP32[i12 >> 2];
   i103 = i99 + (i1 * 108 | 0) + 56 | 0;
   HEAP32[i103 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 60 >> 2] = HEAP32[i14 >> 2];
   i155 = i99 + (i1 * 108 | 0) + 64 | 0;
   HEAP32[i155 >> 2] = HEAP32[i15 >> 2];
   i154 = i99 + (i1 * 108 | 0) + 68 | 0;
   HEAP32[i154 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 72 >> 2] = HEAP32[i17 >> 2];
   i152 = i99 + (i1 * 108 | 0) + 76 | 0;
   HEAP32[i152 >> 2] = HEAP32[i18 >> 2];
   i151 = i99 + (i1 * 108 | 0) + 80 | 0;
   HEAP32[i151 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 84 >> 2] = HEAP32[i20 >> 2];
   i149 = i99 + (i1 * 108 | 0) + 88 | 0;
   HEAP32[i149 >> 2] = HEAP32[i21 >> 2];
   i148 = i99 + (i1 * 108 | 0) + 92 | 0;
   HEAP32[i148 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i99 + (i1 * 108 | 0) + 96 >> 2] = HEAP32[i23 >> 2];
   i146 = i99 + (i1 * 108 | 0) + 100 | 0;
   HEAP32[i146 >> 2] = HEAP32[i24 >> 2];
   i145 = i99 + (i1 * 108 | 0) + 104 | 0;
   HEAP32[i145 >> 2] = HEAP32[i25 >> 2];
   i102 = HEAPU8[i96 + 64 + i1 >> 0] | 0;
   i101 = i97 + (i1 * 400 | 0) + 144 | 0;
   i121 = i97 + (i1 * 400 | 0) + 240 | 0;
   f104 = Math_fround(HEAPF32[i121 >> 2]);
   f123 = Math_fround(f104 * Math_fround(HEAPF32[i166 >> 2]));
   f122 = Math_fround(f104 * Math_fround(HEAPF32[i165 >> 2]));
   f139 = Math_fround(f104 * Math_fround(HEAPF32[i112 >> 2]));
   i120 = i97 + (i1 * 400 | 0) + 244 | 0;
   f125 = Math_fround(HEAPF32[i120 >> 2]);
   i164 = i99 + (i1 * 108 | 0) + 12 | 0;
   f131 = Math_fround(f125 * Math_fround(HEAPF32[i164 >> 2]));
   f127 = Math_fround(f125 * Math_fround(HEAPF32[i163 >> 2]));
   f131 = Math_fround(f123 + f131);
   f127 = Math_fround(f122 + f127);
   f139 = Math_fround(f139 + Math_fround(f125 * Math_fround(HEAPF32[i111 >> 2])));
   i119 = i97 + (i1 * 400 | 0) + 248 | 0;
   f122 = Math_fround(HEAPF32[i119 >> 2]);
   i162 = i99 + (i1 * 108 | 0) + 24 | 0;
   f123 = Math_fround(f122 * Math_fround(HEAPF32[i162 >> 2]));
   f106 = Math_fround(f122 * Math_fround(HEAPF32[i161 >> 2]));
   f123 = Math_fround(f131 + f123);
   f106 = Math_fround(f127 + f106);
   f139 = Math_fround(f139 + Math_fround(f122 * Math_fround(HEAPF32[i140 >> 2])));
   i144 = i97 + (i1 * 400 | 0) + 256 | 0;
   f127 = Math_fround(HEAPF32[i144 >> 2]);
   i160 = i99 + (i1 * 108 | 0) + 36 | 0;
   f131 = Math_fround(HEAPF32[i160 >> 2]);
   f126 = Math_fround(f127 * f131);
   f134 = Math_fround(HEAPF32[i159 >> 2]);
   f128 = Math_fround(f127 * f134);
   f124 = Math_fround(HEAPF32[i110 >> 2]);
   f136 = Math_fround(f127 * f124);
   i118 = i97 + (i1 * 400 | 0) + 260 | 0;
   f137 = Math_fround(HEAPF32[i118 >> 2]);
   i158 = i99 + (i1 * 108 | 0) + 48 | 0;
   f129 = Math_fround(HEAPF32[i158 >> 2]);
   f109 = Math_fround(f137 * f129);
   f130 = Math_fround(HEAPF32[i157 >> 2]);
   f105 = Math_fround(f137 * f130);
   f132 = Math_fround(HEAPF32[i103 >> 2]);
   f109 = Math_fround(f126 + f109);
   f105 = Math_fround(f128 + f105);
   f136 = Math_fround(f136 + Math_fround(f137 * f132));
   i117 = i97 + (i1 * 400 | 0) + 264 | 0;
   f128 = Math_fround(HEAPF32[i117 >> 2]);
   i156 = i99 + (i1 * 108 | 0) + 60 | 0;
   f126 = Math_fround(HEAPF32[i156 >> 2]);
   f138 = Math_fround(f128 * f126);
   f135 = Math_fround(HEAPF32[i155 >> 2]);
   f107 = Math_fround(f128 * f135);
   f108 = Math_fround(HEAPF32[i154 >> 2]);
   f138 = Math_fround(f123 + Math_fround(f109 + f138));
   f107 = Math_fround(f106 + Math_fround(f105 + f107));
   f136 = Math_fround(f139 + Math_fround(f136 + Math_fround(f128 * f108)));
   f124 = Math_fround(Math_fround(Math_fround(f104 * f131) + Math_fround(f125 * f134)) + Math_fround(f122 * f124));
   f132 = Math_fround(Math_fround(Math_fround(f104 * f129) + Math_fround(f125 * f130)) + Math_fround(f122 * f132));
   f108 = Math_fround(Math_fround(Math_fround(f104 * f126) + Math_fround(f125 * f135)) + Math_fround(f122 * f108));
   i153 = i99 + (i1 * 108 | 0) + 72 | 0;
   f122 = Math_fround(f127 * Math_fround(HEAPF32[i153 >> 2]));
   f135 = Math_fround(f127 * Math_fround(HEAPF32[i152 >> 2]));
   f127 = Math_fround(f127 * Math_fround(HEAPF32[i151 >> 2]));
   i150 = i99 + (i1 * 108 | 0) + 84 | 0;
   f125 = Math_fround(f137 * Math_fround(HEAPF32[i150 >> 2]));
   f126 = Math_fround(f137 * Math_fround(HEAPF32[i149 >> 2]));
   f125 = Math_fround(f122 + f125);
   f126 = Math_fround(f135 + f126);
   f137 = Math_fround(f127 + Math_fround(f137 * Math_fround(HEAPF32[i148 >> 2])));
   i147 = i99 + (i1 * 108 | 0) + 96 | 0;
   f127 = Math_fround(f128 * Math_fround(HEAPF32[i147 >> 2]));
   f135 = Math_fround(f128 * Math_fround(HEAPF32[i146 >> 2]));
   f127 = Math_fround(f124 + Math_fround(f125 + f127));
   f135 = Math_fround(f132 + Math_fround(f126 + f135));
   f128 = Math_fround(f108 + Math_fround(f137 + Math_fround(f128 * Math_fround(HEAPF32[i145 >> 2]))));
   HEAPF32[i94 >> 2] = f138;
   HEAPF32[i26 >> 2] = f107;
   HEAPF32[i27 >> 2] = f136;
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   HEAPF32[i29 >> 2] = f127;
   HEAPF32[i30 >> 2] = f135;
   HEAPF32[i31 >> 2] = f128;
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   i143 = i97 + (i1 * 400 | 0) + 272 | 0;
   f128 = Math_fround(HEAPF32[i143 >> 2]);
   f135 = Math_fround(f128 * Math_fround(HEAPF32[i166 >> 2]));
   f127 = Math_fround(f128 * Math_fround(HEAPF32[i165 >> 2]));
   f136 = Math_fround(f128 * Math_fround(HEAPF32[i112 >> 2]));
   i116 = i97 + (i1 * 400 | 0) + 276 | 0;
   f107 = Math_fround(HEAPF32[i116 >> 2]);
   f138 = Math_fround(f107 * Math_fround(HEAPF32[i164 >> 2]));
   f137 = Math_fround(f107 * Math_fround(HEAPF32[i163 >> 2]));
   f138 = Math_fround(f135 + f138);
   f137 = Math_fround(f127 + f137);
   f136 = Math_fround(f136 + Math_fround(f107 * Math_fround(HEAPF32[i111 >> 2])));
   i115 = i97 + (i1 * 400 | 0) + 280 | 0;
   f127 = Math_fround(HEAPF32[i115 >> 2]);
   f135 = Math_fround(f127 * Math_fround(HEAPF32[i162 >> 2]));
   f108 = Math_fround(f127 * Math_fround(HEAPF32[i161 >> 2]));
   f135 = Math_fround(f138 + f135);
   f108 = Math_fround(f137 + f108);
   f136 = Math_fround(f136 + Math_fround(f127 * Math_fround(HEAPF32[i140 >> 2])));
   i142 = i97 + (i1 * 400 | 0) + 288 | 0;
   f137 = Math_fround(HEAPF32[i142 >> 2]);
   f138 = Math_fround(HEAPF32[i160 >> 2]);
   f126 = Math_fround(f137 * f138);
   f132 = Math_fround(HEAPF32[i159 >> 2]);
   f125 = Math_fround(f137 * f132);
   f124 = Math_fround(HEAPF32[i110 >> 2]);
   f122 = Math_fround(f137 * f124);
   i114 = i97 + (i1 * 400 | 0) + 292 | 0;
   f104 = Math_fround(HEAPF32[i114 >> 2]);
   f130 = Math_fround(HEAPF32[i158 >> 2]);
   f129 = Math_fround(f104 * f130);
   f134 = Math_fround(HEAPF32[i157 >> 2]);
   f131 = Math_fround(f104 * f134);
   f139 = Math_fround(HEAPF32[i103 >> 2]);
   f129 = Math_fround(f126 + f129);
   f131 = Math_fround(f125 + f131);
   f122 = Math_fround(f122 + Math_fround(f104 * f139));
   i113 = i97 + (i1 * 400 | 0) + 296 | 0;
   f125 = Math_fround(HEAPF32[i113 >> 2]);
   f126 = Math_fround(HEAPF32[i156 >> 2]);
   f105 = Math_fround(f125 * f126);
   f106 = Math_fround(HEAPF32[i155 >> 2]);
   f109 = Math_fround(f125 * f106);
   f123 = Math_fround(HEAPF32[i154 >> 2]);
   f105 = Math_fround(f135 + Math_fround(f129 + f105));
   f109 = Math_fround(f108 + Math_fround(f131 + f109));
   f122 = Math_fround(f136 + Math_fround(f122 + Math_fround(f125 * f123)));
   f124 = Math_fround(Math_fround(Math_fround(f128 * f138) + Math_fround(f107 * f132)) + Math_fround(f127 * f124));
   f139 = Math_fround(Math_fround(Math_fround(f128 * f130) + Math_fround(f107 * f134)) + Math_fround(f127 * f139));
   f123 = Math_fround(Math_fround(Math_fround(f128 * f126) + Math_fround(f107 * f106)) + Math_fround(f127 * f123));
   f127 = Math_fround(f137 * Math_fround(HEAPF32[i153 >> 2]));
   f106 = Math_fround(f137 * Math_fround(HEAPF32[i152 >> 2]));
   f137 = Math_fround(f137 * Math_fround(HEAPF32[i151 >> 2]));
   f107 = Math_fround(f104 * Math_fround(HEAPF32[i150 >> 2]));
   f126 = Math_fround(f104 * Math_fround(HEAPF32[i149 >> 2]));
   f107 = Math_fround(f127 + f107);
   f126 = Math_fround(f106 + f126);
   f104 = Math_fround(f137 + Math_fround(f104 * Math_fround(HEAPF32[i148 >> 2])));
   f137 = Math_fround(f125 * Math_fround(HEAPF32[i147 >> 2]));
   f106 = Math_fround(f125 * Math_fround(HEAPF32[i146 >> 2]));
   f137 = Math_fround(f124 + Math_fround(f107 + f137));
   f106 = Math_fround(f139 + Math_fround(f126 + f106));
   f125 = Math_fround(f123 + Math_fround(f104 + Math_fround(f125 * Math_fround(HEAPF32[i145 >> 2]))));
   HEAPF32[i33 >> 2] = f105;
   HEAPF32[i34 >> 2] = f109;
   HEAPF32[i35 >> 2] = f122;
   HEAPF32[i36 >> 2] = Math_fround(0.0);
   HEAPF32[i37 >> 2] = f137;
   HEAPF32[i38 >> 2] = f106;
   HEAPF32[i39 >> 2] = f125;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   i141 = i97 + (i1 * 400 | 0) + 304 | 0;
   f125 = Math_fround(HEAPF32[i141 >> 2]);
   f106 = Math_fround(f125 * Math_fround(HEAPF32[i166 >> 2]));
   f137 = Math_fround(f125 * Math_fround(HEAPF32[i165 >> 2]));
   f122 = Math_fround(f125 * Math_fround(HEAPF32[i112 >> 2]));
   i112 = i97 + (i1 * 400 | 0) + 308 | 0;
   f109 = Math_fround(HEAPF32[i112 >> 2]);
   f105 = Math_fround(f109 * Math_fround(HEAPF32[i164 >> 2]));
   f104 = Math_fround(f109 * Math_fround(HEAPF32[i163 >> 2]));
   f105 = Math_fround(f106 + f105);
   f104 = Math_fround(f137 + f104);
   f122 = Math_fround(f122 + Math_fround(f109 * Math_fround(HEAPF32[i111 >> 2])));
   i111 = i97 + (i1 * 400 | 0) + 312 | 0;
   f137 = Math_fround(HEAPF32[i111 >> 2]);
   f106 = Math_fround(f137 * Math_fround(HEAPF32[i162 >> 2]));
   f123 = Math_fround(f137 * Math_fround(HEAPF32[i161 >> 2]));
   f106 = Math_fround(f105 + f106);
   f123 = Math_fround(f104 + f123);
   f122 = Math_fround(f122 + Math_fround(f137 * Math_fround(HEAPF32[i140 >> 2])));
   i140 = i97 + (i1 * 400 | 0) + 320 | 0;
   f104 = Math_fround(HEAPF32[i140 >> 2]);
   f105 = Math_fround(HEAPF32[i160 >> 2]);
   f126 = Math_fround(f104 * f105);
   f139 = Math_fround(HEAPF32[i159 >> 2]);
   f107 = Math_fround(f104 * f139);
   f124 = Math_fround(HEAPF32[i110 >> 2]);
   f127 = Math_fround(f104 * f124);
   i110 = i97 + (i1 * 400 | 0) + 324 | 0;
   f128 = Math_fround(HEAPF32[i110 >> 2]);
   f134 = Math_fround(HEAPF32[i158 >> 2]);
   f130 = Math_fround(f128 * f134);
   f132 = Math_fround(HEAPF32[i157 >> 2]);
   f138 = Math_fround(f128 * f132);
   f136 = Math_fround(HEAPF32[i103 >> 2]);
   f130 = Math_fround(f126 + f130);
   f138 = Math_fround(f107 + f138);
   f127 = Math_fround(f127 + Math_fround(f128 * f136));
   i103 = i97 + (i1 * 400 | 0) + 328 | 0;
   f107 = Math_fround(HEAPF32[i103 >> 2]);
   f126 = Math_fround(HEAPF32[i156 >> 2]);
   f131 = Math_fround(f107 * f126);
   f108 = Math_fround(HEAPF32[i155 >> 2]);
   f129 = Math_fround(f107 * f108);
   f135 = Math_fround(HEAPF32[i154 >> 2]);
   f131 = Math_fround(f106 + Math_fround(f130 + f131));
   f129 = Math_fround(f123 + Math_fround(f138 + f129));
   f127 = Math_fround(f122 + Math_fround(f127 + Math_fround(f107 * f135)));
   f124 = Math_fround(Math_fround(Math_fround(f125 * f105) + Math_fround(f109 * f139)) + Math_fround(f137 * f124));
   f136 = Math_fround(Math_fround(Math_fround(f125 * f134) + Math_fround(f109 * f132)) + Math_fround(f137 * f136));
   f135 = Math_fround(Math_fround(Math_fround(f125 * f126) + Math_fround(f109 * f108)) + Math_fround(f137 * f135));
   f137 = Math_fround(f104 * Math_fround(HEAPF32[i153 >> 2]));
   f108 = Math_fround(f104 * Math_fround(HEAPF32[i152 >> 2]));
   f104 = Math_fround(f104 * Math_fround(HEAPF32[i151 >> 2]));
   f109 = Math_fround(f128 * Math_fround(HEAPF32[i150 >> 2]));
   f126 = Math_fround(f128 * Math_fround(HEAPF32[i149 >> 2]));
   f109 = Math_fround(f137 + f109);
   f126 = Math_fround(f108 + f126);
   f128 = Math_fround(f104 + Math_fround(f128 * Math_fround(HEAPF32[i148 >> 2])));
   f104 = Math_fround(f107 * Math_fround(HEAPF32[i147 >> 2]));
   f108 = Math_fround(f107 * Math_fround(HEAPF32[i146 >> 2]));
   f104 = Math_fround(f124 + Math_fround(f109 + f104));
   f108 = Math_fround(f136 + Math_fround(f126 + f108));
   f107 = Math_fround(f135 + Math_fround(f128 + Math_fround(f107 * Math_fround(HEAPF32[i145 >> 2]))));
   HEAPF32[i41 >> 2] = f131;
   HEAPF32[i42 >> 2] = f129;
   HEAPF32[i43 >> 2] = f127;
   HEAPF32[i44 >> 2] = Math_fround(0.0);
   HEAPF32[i45 >> 2] = f104;
   HEAPF32[i46 >> 2] = f108;
   HEAPF32[i47 >> 2] = f107;
   HEAPF32[i48 >> 2] = Math_fround(0.0);
   f128 = Math_fround(HEAPF32[i94 >> 2]);
   f135 = Math_fround(f128 * Math_fround(HEAPF32[i121 >> 2]));
   f126 = Math_fround(HEAPF32[i26 >> 2]);
   f135 = Math_fround(f135 + Math_fround(f126 * Math_fround(HEAPF32[i120 >> 2])));
   f136 = Math_fround(HEAPF32[i27 >> 2]);
   f135 = Math_fround(f135 + Math_fround(f136 * Math_fround(HEAPF32[i119 >> 2])));
   f109 = Math_fround(HEAPF32[i49 >> 2]);
   f124 = Math_fround(f109 * Math_fround(HEAPF32[i144 >> 2]));
   f137 = Math_fround(HEAPF32[i30 >> 2]);
   f124 = Math_fround(f124 + Math_fround(f137 * Math_fround(HEAPF32[i118 >> 2])));
   f125 = Math_fround(HEAPF32[i31 >> 2]);
   f124 = Math_fround(f135 + Math_fround(f124 + Math_fround(f125 * Math_fround(HEAPF32[i117 >> 2]))));
   f135 = Math_fround(HEAPF32[i143 >> 2]);
   f132 = Math_fround(f128 * f135);
   f134 = Math_fround(HEAPF32[i116 >> 2]);
   f132 = Math_fround(f132 + Math_fround(f126 * f134));
   f139 = Math_fround(HEAPF32[i115 >> 2]);
   f132 = Math_fround(f132 + Math_fround(f136 * f139));
   f105 = Math_fround(HEAPF32[i142 >> 2]);
   f122 = Math_fround(f109 * f105);
   f138 = Math_fround(HEAPF32[i114 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f137 * f138));
   f123 = Math_fround(HEAPF32[i113 >> 2]);
   f122 = Math_fround(f132 + Math_fround(f122 + Math_fround(f125 * f123)));
   f132 = Math_fround(HEAPF32[i141 >> 2]);
   f128 = Math_fround(f128 * f132);
   f130 = Math_fround(HEAPF32[i112 >> 2]);
   f126 = Math_fround(f128 + Math_fround(f126 * f130));
   f128 = Math_fround(HEAPF32[i111 >> 2]);
   f136 = Math_fround(f126 + Math_fround(f136 * f128));
   f126 = Math_fround(HEAPF32[i140 >> 2]);
   f109 = Math_fround(f109 * f126);
   f106 = Math_fround(HEAPF32[i110 >> 2]);
   f137 = Math_fround(f109 + Math_fround(f137 * f106));
   f109 = Math_fround(HEAPF32[i103 >> 2]);
   f125 = Math_fround(f136 + Math_fround(f137 + Math_fround(f125 * f109)));
   f137 = Math_fround(HEAPF32[i33 >> 2]);
   f135 = Math_fround(f135 * f137);
   f136 = Math_fround(HEAPF32[i34 >> 2]);
   f134 = Math_fround(f135 + Math_fround(f134 * f136));
   f135 = Math_fround(HEAPF32[i35 >> 2]);
   f139 = Math_fround(f134 + Math_fround(f139 * f135));
   f134 = Math_fround(HEAPF32[i37 >> 2]);
   f105 = Math_fround(f105 * f134);
   f133 = Math_fround(HEAPF32[i38 >> 2]);
   f138 = Math_fround(f105 + Math_fround(f138 * f133));
   f105 = Math_fround(HEAPF32[i39 >> 2]);
   f123 = Math_fround(f139 + Math_fround(f138 + Math_fround(f123 * f105)));
   f105 = Math_fround(Math_fround(Math_fround(Math_fround(f132 * f137) + Math_fround(f130 * f136)) + Math_fround(f128 * f135)) + Math_fround(Math_fround(Math_fround(f126 * f134) + Math_fround(f106 * f133)) + Math_fround(f109 * f105)));
   f107 = Math_fround(Math_fround(Math_fround(Math_fround(f132 * f131) + Math_fround(f130 * f129)) + Math_fround(f128 * f127)) + Math_fround(Math_fround(Math_fround(f126 * f104) + Math_fround(f106 * f108)) + Math_fround(f109 * f107)));
   f109 = Math_fround(Math_fround(f123 * f107) - Math_fround(f105 * f105));
   f108 = Math_fround(Math_fround(f125 * f105) - Math_fround(f122 * f107));
   f106 = Math_fround(Math_fround(f122 * f105) - Math_fround(f125 * f123));
   f104 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(-Math_fround(f124 * f109)) - Math_fround(f122 * f108)) - Math_fround(f125 * f106)));
   f109 = Math_fround(f104 * f109);
   f108 = Math_fround(f104 * f108);
   f106 = Math_fround(f106 * f104);
   f107 = Math_fround(f104 * Math_fround(Math_fround(f124 * f107) - Math_fround(f125 * f125)));
   f105 = Math_fround(Math_fround(Math_fround(f122 * f125) - Math_fround(f124 * f105)) * f104);
   f104 = Math_fround(Math_fround(Math_fround(f124 * f123) - Math_fround(f122 * f122)) * f104);
   HEAPF32[i95 >> 2] = f109;
   HEAPF32[i50 >> 2] = f108;
   HEAPF32[i51 >> 2] = f106;
   HEAPF32[i52 >> 2] = f108;
   HEAPF32[i53 >> 2] = f107;
   HEAPF32[i54 >> 2] = f105;
   HEAPF32[i55 >> 2] = f106;
   HEAPF32[i56 >> 2] = f105;
   HEAPF32[i57 >> 2] = f104;
   HEAP32[i121 >> 2] = HEAP32[i94 >> 2];
   HEAP32[i120 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i119 >> 2] = HEAP32[i27 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 252 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 256 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i118 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i117 >> 2] = HEAP32[i31 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 268 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 272 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i116 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i115 >> 2] = HEAP32[i35 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 284 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 288 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i114 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i113 >> 2] = HEAP32[i39 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 300 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 304 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i112 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i111 >> 2] = HEAP32[i43 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 316 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 320 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i110 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i103 >> 2] = HEAP32[i47 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 332 >> 2] = Math_fround(0.0);
   HEAPF32[i97 + (i1 * 400 | 0) + 336 >> 2] = f109;
   HEAPF32[i97 + (i1 * 400 | 0) + 340 >> 2] = f108;
   HEAPF32[i97 + (i1 * 400 | 0) + 344 >> 2] = f106;
   HEAPF32[i97 + (i1 * 400 | 0) + 348 >> 2] = Math_fround(0.0);
   HEAPF32[i97 + (i1 * 400 | 0) + 352 >> 2] = f108;
   HEAPF32[i97 + (i1 * 400 | 0) + 356 >> 2] = f107;
   HEAPF32[i97 + (i1 * 400 | 0) + 360 >> 2] = f105;
   HEAPF32[i97 + (i1 * 400 | 0) + 364 >> 2] = Math_fround(0.0);
   HEAPF32[i97 + (i1 * 400 | 0) + 368 >> 2] = f106;
   HEAPF32[i97 + (i1 * 400 | 0) + 372 >> 2] = f105;
   HEAPF32[i97 + (i1 * 400 | 0) + 376 >> 2] = f104;
   HEAPF32[i97 + (i1 * 400 | 0) + 380 >> 2] = Math_fround(0.0);
   __ZN5physx24PxcArticulationFnsScalar8multiplyEPNS_2Cm13SpatialVectorEPKS2_RKNS_7PxMat33E(i94, i101, i95);
   i103 = i99 + (i102 * 108 | 0) | 0;
   __ZN5physx24PxcArticulationFnsScalar16multiplySubtractERKNS_9SpInertiaEPKNS_2Cm13SpatialVectorES7_(i91, i103, i94, i101);
   HEAP32[i103 >> 2] = HEAP32[i91 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 4 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 8 >> 2] = HEAP32[i63 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 12 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 16 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 20 >> 2] = HEAP32[i66 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 24 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 28 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 32 >> 2] = HEAP32[i69 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 36 >> 2] = HEAP32[i70 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 40 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 44 >> 2] = HEAP32[i72 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 48 >> 2] = HEAP32[i73 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 52 >> 2] = HEAP32[i74 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 56 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 60 >> 2] = HEAP32[i76 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 64 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 68 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 72 >> 2] = HEAP32[i79 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 76 >> 2] = HEAP32[i80 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 80 >> 2] = HEAP32[i81 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 84 >> 2] = HEAP32[i82 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 88 >> 2] = HEAP32[i83 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 92 >> 2] = HEAP32[i84 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 96 >> 2] = HEAP32[i85 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 100 >> 2] = HEAP32[i86 >> 2];
   HEAP32[i99 + (i102 * 108 | 0) + 104 >> 2] = HEAP32[i87 >> 2];
   HEAP32[i101 >> 2] = HEAP32[i94 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 148 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 152 >> 2] = HEAP32[i27 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 156 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 160 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 164 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 168 >> 2] = HEAP32[i31 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 172 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 176 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 180 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 184 >> 2] = HEAP32[i35 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 188 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 192 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 196 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 200 >> 2] = HEAP32[i39 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 204 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 208 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 212 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 216 >> 2] = HEAP32[i43 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 220 >> 2] = Math_fround(0.0);
   HEAP32[i97 + (i1 * 400 | 0) + 224 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 228 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i97 + (i1 * 400 | 0) + 232 >> 2] = HEAP32[i47 >> 2];
   HEAPF32[i97 + (i1 * 400 | 0) + 236 >> 2] = Math_fround(0.0);
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
 }
 __ZN5physx24PxcArticulationFnsScalar13invertInertiaERKNS_9SpInertiaE(i92, i99);
 i141 = HEAP32[i92 + 4 >> 2] | 0;
 i142 = HEAP32[i92 + 8 >> 2] | 0;
 i143 = HEAP32[i92 + 12 >> 2] | 0;
 i144 = HEAP32[i92 + 16 >> 2] | 0;
 i145 = HEAP32[i92 + 20 >> 2] | 0;
 i146 = HEAP32[i92 + 24 >> 2] | 0;
 i147 = HEAP32[i92 + 28 >> 2] | 0;
 i148 = HEAP32[i92 + 32 >> 2] | 0;
 i149 = HEAP32[i92 + 36 >> 2] | 0;
 i150 = HEAP32[i92 + 40 >> 2] | 0;
 i151 = HEAP32[i92 + 44 >> 2] | 0;
 i152 = HEAP32[i92 + 48 >> 2] | 0;
 i153 = HEAP32[i92 + 52 >> 2] | 0;
 i154 = HEAP32[i92 + 56 >> 2] | 0;
 i155 = HEAP32[i92 + 60 >> 2] | 0;
 i156 = HEAP32[i92 + 64 >> 2] | 0;
 i157 = HEAP32[i92 + 68 >> 2] | 0;
 i158 = HEAP32[i92 + 72 >> 2] | 0;
 i159 = HEAP32[i92 + 76 >> 2] | 0;
 i160 = HEAP32[i92 + 80 >> 2] | 0;
 i161 = HEAP32[i92 + 84 >> 2] | 0;
 i162 = HEAP32[i92 + 88 >> 2] | 0;
 i163 = HEAP32[i92 + 92 >> 2] | 0;
 i164 = HEAP32[i92 + 96 >> 2] | 0;
 i165 = HEAP32[i92 + 100 >> 2] | 0;
 i166 = HEAP32[i92 + 104 >> 2] | 0;
 HEAP32[i97 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i96 + (i93 + 4) >> 2] = i141;
 HEAP32[i96 + (i93 + 8) >> 2] = i142;
 HEAPF32[i96 + (i93 + 12) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 16) >> 2] = i143;
 HEAP32[i96 + (i93 + 20) >> 2] = i144;
 HEAP32[i96 + (i93 + 24) >> 2] = i145;
 HEAPF32[i96 + (i93 + 28) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 32) >> 2] = i146;
 HEAP32[i96 + (i93 + 36) >> 2] = i147;
 HEAP32[i96 + (i93 + 40) >> 2] = i148;
 HEAPF32[i96 + (i93 + 44) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 48) >> 2] = i149;
 HEAP32[i96 + (i93 + 52) >> 2] = i150;
 HEAP32[i96 + (i93 + 56) >> 2] = i151;
 HEAPF32[i96 + (i93 + 60) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 64) >> 2] = i152;
 HEAP32[i96 + (i93 + 68) >> 2] = i153;
 HEAP32[i96 + (i93 + 72) >> 2] = i154;
 HEAPF32[i96 + (i93 + 76) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 80) >> 2] = i155;
 HEAP32[i96 + (i93 + 84) >> 2] = i156;
 HEAP32[i96 + (i93 + 88) >> 2] = i157;
 HEAPF32[i96 + (i93 + 92) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 96) >> 2] = i158;
 HEAP32[i96 + (i93 + 100) >> 2] = i159;
 HEAP32[i96 + (i93 + 104) >> 2] = i160;
 HEAPF32[i96 + (i93 + 108) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 112) >> 2] = i161;
 HEAP32[i96 + (i93 + 116) >> 2] = i162;
 HEAP32[i96 + (i93 + 120) >> 2] = i163;
 HEAPF32[i96 + (i93 + 124) >> 2] = Math_fround(0.0);
 HEAP32[i96 + (i93 + 128) >> 2] = i164;
 HEAP32[i96 + (i93 + 132) >> 2] = i165;
 HEAP32[i96 + (i93 + 136) >> 2] = i166;
 HEAPF32[i96 + (i93 + 140) >> 2] = Math_fround(0.0);
 if ((HEAPU16[i98 >> 1] | 0) > 1) i1 = 1; else {
  STACKTOP = i100;
  return;
 }
 do {
  i141 = HEAP32[i99 + (i1 * 108 | 0) + 4 >> 2] | 0;
  i142 = HEAP32[i99 + (i1 * 108 | 0) + 8 >> 2] | 0;
  i143 = HEAP32[i99 + (i1 * 108 | 0) + 12 >> 2] | 0;
  i144 = HEAP32[i99 + (i1 * 108 | 0) + 16 >> 2] | 0;
  i145 = HEAP32[i99 + (i1 * 108 | 0) + 20 >> 2] | 0;
  i146 = HEAP32[i99 + (i1 * 108 | 0) + 24 >> 2] | 0;
  i147 = HEAP32[i99 + (i1 * 108 | 0) + 28 >> 2] | 0;
  i148 = HEAP32[i99 + (i1 * 108 | 0) + 32 >> 2] | 0;
  i149 = HEAP32[i99 + (i1 * 108 | 0) + 36 >> 2] | 0;
  i150 = HEAP32[i99 + (i1 * 108 | 0) + 40 >> 2] | 0;
  i151 = HEAP32[i99 + (i1 * 108 | 0) + 44 >> 2] | 0;
  i152 = HEAP32[i99 + (i1 * 108 | 0) + 48 >> 2] | 0;
  i153 = HEAP32[i99 + (i1 * 108 | 0) + 52 >> 2] | 0;
  i154 = HEAP32[i99 + (i1 * 108 | 0) + 56 >> 2] | 0;
  i155 = HEAP32[i99 + (i1 * 108 | 0) + 60 >> 2] | 0;
  i156 = HEAP32[i99 + (i1 * 108 | 0) + 64 >> 2] | 0;
  i157 = HEAP32[i99 + (i1 * 108 | 0) + 68 >> 2] | 0;
  i158 = HEAP32[i99 + (i1 * 108 | 0) + 72 >> 2] | 0;
  i159 = HEAP32[i99 + (i1 * 108 | 0) + 76 >> 2] | 0;
  i160 = HEAP32[i99 + (i1 * 108 | 0) + 80 >> 2] | 0;
  i161 = HEAP32[i99 + (i1 * 108 | 0) + 84 >> 2] | 0;
  i162 = HEAP32[i99 + (i1 * 108 | 0) + 88 >> 2] | 0;
  i163 = HEAP32[i99 + (i1 * 108 | 0) + 92 >> 2] | 0;
  i164 = HEAP32[i99 + (i1 * 108 | 0) + 96 >> 2] | 0;
  i165 = HEAP32[i99 + (i1 * 108 | 0) + 100 >> 2] | 0;
  i166 = HEAP32[i99 + (i1 * 108 | 0) + 104 >> 2] | 0;
  HEAP32[i97 + (i1 * 400 | 0) >> 2] = HEAP32[i99 + (i1 * 108 | 0) >> 2];
  HEAP32[i97 + (i1 * 400 | 0) + 4 >> 2] = i141;
  HEAP32[i97 + (i1 * 400 | 0) + 8 >> 2] = i142;
  HEAPF32[i97 + (i1 * 400 | 0) + 12 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 16 >> 2] = i143;
  HEAP32[i97 + (i1 * 400 | 0) + 20 >> 2] = i144;
  HEAP32[i97 + (i1 * 400 | 0) + 24 >> 2] = i145;
  HEAPF32[i97 + (i1 * 400 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 32 >> 2] = i146;
  HEAP32[i97 + (i1 * 400 | 0) + 36 >> 2] = i147;
  HEAP32[i97 + (i1 * 400 | 0) + 40 >> 2] = i148;
  HEAPF32[i97 + (i1 * 400 | 0) + 44 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 48 >> 2] = i149;
  HEAP32[i97 + (i1 * 400 | 0) + 52 >> 2] = i150;
  HEAP32[i97 + (i1 * 400 | 0) + 56 >> 2] = i151;
  HEAPF32[i97 + (i1 * 400 | 0) + 60 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 64 >> 2] = i152;
  HEAP32[i97 + (i1 * 400 | 0) + 68 >> 2] = i153;
  HEAP32[i97 + (i1 * 400 | 0) + 72 >> 2] = i154;
  HEAPF32[i97 + (i1 * 400 | 0) + 76 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 80 >> 2] = i155;
  HEAP32[i97 + (i1 * 400 | 0) + 84 >> 2] = i156;
  HEAP32[i97 + (i1 * 400 | 0) + 88 >> 2] = i157;
  HEAPF32[i97 + (i1 * 400 | 0) + 92 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 96 >> 2] = i158;
  HEAP32[i97 + (i1 * 400 | 0) + 100 >> 2] = i159;
  HEAP32[i97 + (i1 * 400 | 0) + 104 >> 2] = i160;
  HEAPF32[i97 + (i1 * 400 | 0) + 108 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 112 >> 2] = i161;
  HEAP32[i97 + (i1 * 400 | 0) + 116 >> 2] = i162;
  HEAP32[i97 + (i1 * 400 | 0) + 120 >> 2] = i163;
  HEAPF32[i97 + (i1 * 400 | 0) + 124 >> 2] = Math_fround(0.0);
  HEAP32[i97 + (i1 * 400 | 0) + 128 >> 2] = i164;
  HEAP32[i97 + (i1 * 400 | 0) + 132 >> 2] = i165;
  HEAP32[i97 + (i1 * 400 | 0) + 136 >> 2] = i166;
  HEAPF32[i97 + (i1 * 400 | 0) + 140 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAPU16[i98 >> 1] | 0) >>> 0);
 STACKTOP = i100;
 return;
}

function _regexec(i1, i40, i2, i47, i3) {
 i1 = i1 | 0;
 i40 = i40 | 0;
 i2 = i2 | 0;
 i47 = i47 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i48;
 i45 = HEAP32[i1 + 4 >> 2] | 0;
 i46 = i45 + 56 | 0;
 i44 = (HEAP32[i46 >> 2] & 8 | 0) == 0 ? i2 : 0;
 i39 = i45 + 40 | 0;
 i1 = HEAP32[i39 >> 2] | 0;
 if ((i1 | 0) > 0 & (i44 | 0) != 0) {
  i1 = _malloc(i1 << 2) | 0;
  if (!i1) i1 = 12; else {
   i43 = i1;
   i41 = 3;
  }
 } else {
  i43 = 0;
  i41 = 3;
 }
 if ((i41 | 0) == 3) {
  if (!(HEAP32[i45 + 60 >> 2] | 0)) {
   HEAP32[i42 >> 2] = 0;
   i6 = i3 & 1;
   i38 = i3 & 2;
   i5 = HEAP32[i46 >> 2] & 4;
   if (!i43) i36 = 0; else i36 = HEAP32[i39 >> 2] | 0;
   i37 = i36 << 2;
   i4 = HEAP32[i45 + 52 >> 2] | 0;
   i3 = i4 << 3;
   i2 = i3 + 8 | 0;
   i1 = i37 + 12 + i3 + (i2 + (Math_imul(i37, i4) | 0) << 1) | 0;
   i39 = _malloc(i1) | 0;
   if (!i39) {
    i1 = 12;
    i2 = 0;
   } else {
    _memset(i39 | 0, 0, i1 | 0) | 0;
    i1 = i39 + i37 | 0;
    i7 = i1 & 3;
    i7 = i1 + ((i7 | 0) == 0 ? 0 : 4 - i7 | 0) | 0;
    i1 = i7 + i2 | 0;
    i8 = i1 & 3;
    i8 = i1 + ((i8 | 0) == 0 ? 0 : 4 - i8 | 0) | 0;
    i1 = i8 + i2 | 0;
    i35 = i1 & 3;
    i35 = i1 + ((i35 | 0) == 0 ? 0 : 4 - i35 | 0) | 0;
    i1 = i35 + i3 | 0;
    i2 = i1 & 3;
    if ((i4 | 0) > 0) {
     i1 = i1 + ((i2 | 0) == 0 ? 0 : 4 - i2 | 0) | 0;
     i2 = 0;
     while (1) {
      HEAP32[i8 + (i2 << 3) + 4 >> 2] = i1;
      i1 = i1 + i37 | 0;
      HEAP32[i7 + (i2 << 3) + 4 >> 2] = i1;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) {
       i1 = 0;
       break;
      } else i1 = i1 + i37 | 0;
     }
     do {
      HEAP32[i35 + (i1 << 3) >> 2] = -1;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i4 | 0));
    }
    i1 = _mbtowc(i42, i40, 4) | 0;
    if ((i1 | 0) < 1) if ((i1 | 0) < 0) {
     i1 = 1;
     i2 = 0;
    } else {
     i1 = 1;
     i41 = 201;
    } else i41 = 201;
    L21 : do if ((i41 | 0) == 201) {
     i34 = i45 + 8 | 0;
     i27 = (i5 | 0) != 0;
     i28 = (i36 | 0) > 0;
     i29 = i45 + 12 | 0;
     i30 = i45 + 44 | 0;
     i31 = i45 + 32 | 0;
     i32 = i45 + 36 | 0;
     i33 = (i36 | 0) == 0;
     i26 = (i6 | 0) == 0;
     i25 = (i36 | 0) < 1;
     i4 = 0;
     i18 = i40 + i1 | 0;
     i17 = 0;
     i5 = 0;
     i2 = -1;
     i3 = i7;
     i23 = i39;
     i21 = i7;
     i19 = i8;
     while (1) {
      if ((i2 | 0) < 0) {
       i6 = HEAP32[i34 >> 2] | 0;
       i7 = i6 + 8 | 0;
       L27 : do if (HEAP32[i7 >> 2] | 0) {
        i12 = (i17 | 0) != 0;
        i13 = (i4 | 0) == 95;
        i14 = (i17 | 0) == 0;
        i16 = i27 & (i4 | 0) == 10;
        i15 = i26 & (i17 | 0) < 1;
        while (1) {
         L31 : while (1) {
          i11 = i6 + 12 | 0;
          if ((HEAP32[i35 + (HEAP32[i11 >> 2] << 3) >> 2] | 0) >= (i17 | 0)) break;
          i10 = i6 + 20 | 0;
          i8 = HEAP32[i10 >> 2] | 0;
          if (!i8) {
           i41 = 236;
           break;
          }
          L35 : do if (i16 | (i15 | (i8 & 1 | 0) == 0)) {
           if (i8 & 2 | 0) {
            i40 = HEAP32[i42 >> 2] | 0;
            if (!((i40 | i38 | 0) == 0 | i27 & (i40 | 0) == 10)) break;
           }
           do if (i8 & 16 | 0) {
            if (i13) break L35;
            if (_iswalnum(i4) | 0) break L35;
            i8 = HEAP32[i42 >> 2] | 0;
            if ((i8 | 0) == 95) break;
            if (!(_iswalnum(i8) | 0)) break L35;
           } while (0);
           i8 = HEAP32[i10 >> 2] | 0;
           if (i8 & 32) {
            if (i13) {
             i8 = HEAP32[i42 >> 2] | 0;
             if ((i8 | 0) == 95) break;
            } else {
             i40 = (_iswalnum(i4) | 0) == 0;
             i8 = HEAP32[i42 >> 2] | 0;
             if (i40 | (i8 | 0) == 95) break;
            }
            if (_iswalnum(i8) | 0) break;
            i8 = HEAP32[i10 >> 2] | 0;
           }
           i9 = HEAP32[i42 >> 2] | 0;
           do if ((i9 | 0) != 0 & (i12 & (i8 & 64 | 0) != 0)) {
            if (i13) i8 = 1; else {
             i8 = (_iswalnum(i4) | 0) != 0;
             i9 = HEAP32[i42 >> 2] | 0;
            }
            if ((i9 | 0) == 95) if (i8) break L35; else break; else if (i8 ^ (_iswalnum(i9) | 0) != 0) break; else break L35;
           } while (0);
           if (!(HEAP32[i10 >> 2] & 128)) {
            i41 = 236;
            break L31;
           }
           i8 = HEAP32[i42 >> 2] | 0;
           if (i14 | (i8 | 0) == 0) break;
           if (i13) i9 = 1; else {
            i9 = (_iswalnum(i4) | 0) != 0;
            i8 = HEAP32[i42 >> 2] | 0;
           }
           if ((i8 | 0) == 95) if (i9) {
            i41 = 236;
            break L31;
           } else break; else if (i9 ^ (_iswalnum(i8) | 0) != 0) break; else {
            i41 = 236;
            break L31;
           }
          } while (0);
          i7 = i6 + 40 | 0;
          if (!(HEAP32[i7 >> 2] | 0)) break L27; else i6 = i6 + 32 | 0;
         }
         if ((i41 | 0) == 236) {
          i41 = 0;
          HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
          if (i28) _memset(HEAP32[i3 + 4 >> 2] | 0, -1, i37 | 0) | 0;
          i7 = HEAP32[i6 + 16 >> 2] | 0;
          do if (i7 | 0) {
           i8 = HEAP32[i7 >> 2] | 0;
           if ((i8 | 0) <= -1) break;
           i9 = i3 + 4 | 0;
           do {
            if ((i8 | 0) < (i36 | 0)) HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] = i17;
            i7 = i7 + 4 | 0;
            i8 = HEAP32[i7 >> 2] | 0;
           } while ((i8 | 0) > -1);
          } while (0);
          i7 = (HEAP32[i3 >> 2] | 0) != (HEAP32[i29 >> 2] | 0);
          if (i25 | i7) {
           i5 = i7 ? i5 : 1;
           i2 = i7 ? i2 : i17;
           i7 = i3 + 4 | 0;
          } else {
           i7 = i3 + 4 | 0;
           i5 = HEAP32[i7 >> 2] | 0;
           i2 = 0;
           do {
            HEAP32[i43 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
            i2 = i2 + 1 | 0;
           } while ((i2 | 0) != (i36 | 0));
           i5 = 1;
           i2 = i17;
          }
          i40 = HEAP32[i11 >> 2] | 0;
          HEAP32[i35 + (i40 << 3) >> 2] = i17;
          HEAP32[i35 + (i40 << 3) + 4 >> 2] = i7;
          i3 = i3 + 8 | 0;
         }
         i7 = i6 + 40 | 0;
         if (!(HEAP32[i7 >> 2] | 0)) break; else i6 = i6 + 32 | 0;
        }
       } while (0);
       HEAP32[i3 >> 2] = 0;
       i3 = HEAP32[i42 >> 2] | 0;
       if (!i3) break; else i4 = i3;
      } else {
       if (i33) break;
       i4 = HEAP32[i42 >> 2] | 0;
       if (!((i3 | 0) != (i21 | 0) & (i4 | 0) != 0)) break;
      }
      i24 = i17 + i1 | 0;
      i1 = _mbtowc(i42, i18, 4) | 0;
      if ((i1 | 0) < 1) if ((i1 | 0) < 0) {
       i1 = 1;
       i2 = 0;
       break L21;
      } else i1 = 1;
      i22 = i18 + i1 | 0;
      if ((i5 | 0) != 0 & (HEAP32[i30 >> 2] | 0) != 0) {
       if (!(HEAP32[i21 >> 2] | 0)) i3 = i19; else {
        i11 = HEAP32[i32 >> 2] | 0;
        i12 = HEAP32[i11 >> 2] | 0;
        i13 = (i12 | 0) > -1;
        i10 = i21;
        i3 = i19;
        do {
         i9 = i10 + 4 | 0;
         L106 : do if (i13) {
          i6 = 0;
          i8 = i12;
          do {
           i7 = HEAP32[i11 + ((i6 | 1) << 2) >> 2] | 0;
           if ((i8 | 0) >= (i36 | 0)) break L106;
           i5 = HEAP32[i9 >> 2] | 0;
           if ((HEAP32[i5 + (i7 << 2) >> 2] | 0) == (HEAP32[i43 + (i7 << 2) >> 2] | 0)) if ((HEAP32[i5 + (i8 << 2) >> 2] | 0) < (HEAP32[i43 + (i8 << 2) >> 2] | 0)) break L106;
           i6 = i6 + 2 | 0;
           i8 = HEAP32[i11 + (i6 << 2) >> 2] | 0;
          } while ((i8 | 0) > -1);
          i6 = i9;
          i41 = 265;
         } else {
          i6 = i9;
          i5 = HEAP32[i9 >> 2] | 0;
          i41 = 265;
         } while (0);
         if ((i41 | 0) == 265) {
          i41 = 0;
          HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
          i20 = i3 + 4 | 0;
          i40 = HEAP32[i20 >> 2] | 0;
          HEAP32[i20 >> 2] = i5;
          HEAP32[i6 >> 2] = i40;
          i3 = i3 + 8 | 0;
         }
         i10 = i10 + 8 | 0;
        } while ((HEAP32[i10 >> 2] | 0) != 0);
       }
       HEAP32[i3 >> 2] = 0;
       i20 = i21;
       i5 = 0;
      } else {
       i20 = i19;
       i19 = i21;
      }
      i6 = HEAP32[i19 >> 2] | 0;
      if (!i6) {
       i6 = i23;
       i3 = i20;
      } else {
       i14 = (i24 | 0) != 0;
       i15 = (i4 | 0) == 95;
       i16 = (i24 | 0) == 0;
       i18 = i27 & (i4 | 0) == 10;
       i17 = i26 & (i24 | 0) < 1;
       i13 = i19;
       i7 = i23;
       i3 = i20;
       while (1) {
        i8 = i6 + 8 | 0;
        if (HEAP32[i8 >> 2] | 0) {
         i12 = i13 + 4 | 0;
         i11 = i7;
         i10 = i8;
         while (1) {
          L128 : do if ((HEAP32[i6 >> 2] | 0) >>> 0 > i4 >>> 0) i7 = i11; else {
           if ((HEAP32[i6 + 4 >> 2] | 0) >>> 0 < i4 >>> 0) {
            i7 = i11;
            break;
           }
           i9 = i6 + 20 | 0;
           i7 = HEAP32[i9 >> 2] | 0;
           do if (i7 | 0) {
            if (!(i18 | (i17 | (i7 & 1 | 0) == 0))) {
             i7 = i11;
             break L128;
            }
            if (i7 & 2 | 0) {
             i40 = HEAP32[i42 >> 2] | 0;
             if (!((i40 | i38 | 0) == 0 | i27 & (i40 | 0) == 10)) {
              i7 = i11;
              break L128;
             }
            }
            do if (i7 & 16 | 0) {
             if (i15) {
              i7 = i11;
              break L128;
             }
             if (_iswalnum(i4) | 0) {
              i7 = i11;
              break L128;
             }
             i7 = HEAP32[i42 >> 2] | 0;
             if ((i7 | 0) == 95) break;
             if (!(_iswalnum(i7) | 0)) {
              i7 = i11;
              break L128;
             }
            } while (0);
            i7 = HEAP32[i9 >> 2] | 0;
            if (i7 & 32) {
             if (i15) {
              i7 = HEAP32[i42 >> 2] | 0;
              if ((i7 | 0) == 95) {
               i7 = i11;
               break L128;
              }
             } else {
              i40 = (_iswalnum(i4) | 0) == 0;
              i7 = HEAP32[i42 >> 2] | 0;
              if (i40 | (i7 | 0) == 95) {
               i7 = i11;
               break L128;
              }
             }
             if (_iswalnum(i7) | 0) {
              i7 = i11;
              break L128;
             }
             i7 = HEAP32[i9 >> 2] | 0;
            }
            i8 = HEAP32[i42 >> 2] | 0;
            do if ((i8 | 0) != 0 & (i14 & (i7 & 64 | 0) != 0)) {
             if (i15) i7 = 1; else {
              i7 = (_iswalnum(i4) | 0) != 0;
              i8 = HEAP32[i42 >> 2] | 0;
             }
             if ((i8 | 0) == 95) if (i7) {
              i7 = i11;
              break L128;
             } else break; else if (i7 ^ (_iswalnum(i8) | 0) != 0) break; else {
              i7 = i11;
              break L128;
             }
            } while (0);
            do if (HEAP32[i9 >> 2] & 128 | 0) {
             i7 = HEAP32[i42 >> 2] | 0;
             if (i16 | (i7 | 0) == 0) {
              i7 = i11;
              break L128;
             }
             if (i15) i8 = 1; else {
              i8 = (_iswalnum(i4) | 0) != 0;
              i7 = HEAP32[i42 >> 2] | 0;
             }
             if ((i7 | 0) == 95) if (i8) break; else {
              i7 = i11;
              break L128;
             } else if (i8 ^ (_iswalnum(i7) | 0) != 0) {
              i7 = i11;
              break L128;
             } else break;
            } while (0);
            i7 = HEAP32[i9 >> 2] | 0;
            do if (i7 & 4) {
             if (HEAP32[i46 >> 2] & 2 | 0) break;
             if (!(_iswctype(i4, HEAP32[i6 + 24 >> 2] | 0) | 0)) {
              i7 = i11;
              break L128;
             }
             i7 = HEAP32[i9 >> 2] | 0;
            } while (0);
            do if (i7 & 4 | 0) {
             if (!(HEAP32[i46 >> 2] & 2)) break;
             i40 = _towlower(i4) | 0;
             i7 = i6 + 24 | 0;
             if (_iswctype(i40, HEAP32[i7 >> 2] | 0) | 0) break;
             i40 = _towupper(i4) | 0;
             if (!(_iswctype(i40, HEAP32[i7 >> 2] | 0) | 0)) {
              i7 = i11;
              break L128;
             }
            } while (0);
            if (!(HEAP32[i9 >> 2] & 8)) break;
            if (_tre_neg_char_classes_match(HEAP32[i6 + 28 >> 2] | 0, i4, HEAP32[i46 >> 2] & 2) | 0) {
             i7 = i11;
             break L128;
            }
           } while (0);
           if (i28) {
            i8 = HEAP32[i12 >> 2] | 0;
            i7 = 0;
            do {
             HEAP32[i11 + (i7 << 2) >> 2] = HEAP32[i8 + (i7 << 2) >> 2];
             i7 = i7 + 1 | 0;
            } while ((i7 | 0) != (i36 | 0));
           }
           i7 = HEAP32[i6 + 16 >> 2] | 0;
           do if (i7 | 0) {
            i8 = HEAP32[i7 >> 2] | 0;
            if ((i8 | 0) <= -1) break;
            do {
             if ((i8 | 0) < (i36 | 0)) HEAP32[i11 + (i8 << 2) >> 2] = i24;
             i7 = i7 + 4 | 0;
             i8 = HEAP32[i7 >> 2] | 0;
            } while ((i8 | 0) > -1);
           } while (0);
           i7 = HEAP32[i6 + 12 >> 2] | 0;
           i8 = i35 + (i7 << 3) | 0;
           if ((HEAP32[i8 >> 2] | 0) >= (i24 | 0)) {
            i7 = HEAP32[i35 + (i7 << 3) + 4 >> 2] | 0;
            i8 = HEAP32[i7 >> 2] | 0;
            if (!(_tre_tag_order(i36, HEAP32[i31 >> 2] | 0, i11, i8) | 0)) {
             i7 = i11;
             break;
            }
            HEAP32[i7 >> 2] = i11;
            if ((HEAP32[i10 >> 2] | 0) != (HEAP32[i29 >> 2] | 0)) {
             i7 = i8;
             break;
            }
            if (i28) i2 = 0; else {
             i5 = 1;
             i7 = i8;
             i2 = i24;
             break;
            }
            while (1) {
             HEAP32[i43 + (i2 << 2) >> 2] = HEAP32[i11 + (i2 << 2) >> 2];
             i2 = i2 + 1 | 0;
             if ((i2 | 0) == (i36 | 0)) {
              i5 = 1;
              i7 = i8;
              i2 = i24;
              break L128;
             }
            }
           }
           i40 = HEAP32[i10 >> 2] | 0;
           HEAP32[i3 >> 2] = i40;
           i23 = i3 + 4 | 0;
           i9 = HEAP32[i23 >> 2] | 0;
           HEAP32[i23 >> 2] = i11;
           HEAP32[i8 >> 2] = i24;
           HEAP32[i35 + (i7 << 3) + 4 >> 2] = i23;
           do if ((i40 | 0) == (HEAP32[i29 >> 2] | 0)) {
            if ((i2 | 0) == -1) if (i28) i2 = 0; else {
             i2 = i24;
             i5 = 1;
             break;
            } else {
             if (!i28) break;
             if ((HEAP32[i11 >> 2] | 0) > (HEAP32[i43 >> 2] | 0)) break; else i2 = 0;
            }
            do {
             HEAP32[i43 + (i2 << 2) >> 2] = HEAP32[i11 + (i2 << 2) >> 2];
             i2 = i2 + 1 | 0;
            } while ((i2 | 0) < (i36 | 0));
            i2 = i24;
            i5 = 1;
           } while (0);
           i7 = i9;
           i3 = i3 + 8 | 0;
          } while (0);
          i10 = i6 + 40 | 0;
          if (!(HEAP32[i10 >> 2] | 0)) break; else {
           i6 = i6 + 32 | 0;
           i11 = i7;
          }
         }
        }
        i13 = i13 + 8 | 0;
        i6 = HEAP32[i13 >> 2] | 0;
        if (!i6) {
         i6 = i7;
         break;
        }
       }
      }
      HEAP32[i3 >> 2] = 0;
      i18 = i22;
      i17 = i24;
      i23 = i6;
      i21 = i20;
     }
     i1 = i2 >>> 31;
    } while (0);
    _free(i39);
   }
  } else {
   HEAP32[i42 >> 2] = 0;
   i6 = i3 & 1;
   i37 = i3 & 2;
   i2 = HEAP32[i46 >> 2] & 4;
   i38 = ___tre_mem_new_impl(0, 0) | 0;
   L218 : do if (!i38) {
    i2 = 0;
    i1 = 12;
   } else {
    i7 = ___tre_mem_alloc_impl(i38, 0, 0, 0, 32) | 0;
    if (!i7) {
     ___tre_mem_destroy(i38);
     i2 = 0;
     i1 = 12;
     break;
    }
    HEAP32[i7 + 24 >> 2] = 0;
    HEAP32[i7 + 28 >> 2] = 0;
    i8 = HEAP32[i39 >> 2] | 0;
    if (!i8) {
     i3 = 0;
     i41 = 9;
    } else {
     i3 = _malloc(i8 << 2) | 0;
     if (!i3) {
      i2 = 0;
      i5 = 0;
      i4 = 0;
      i1 = 12;
     } else i41 = 9;
    }
    L225 : do if ((i41 | 0) == 9) {
     i1 = HEAP32[i45 + 28 >> 2] | 0;
     if (!i1) i5 = 0; else {
      i5 = _malloc(i1 << 3) | 0;
      if (!i5) {
       i2 = 0;
       i4 = 0;
       i1 = 12;
       break;
      }
     }
     i36 = i45 + 52 | 0;
     i1 = HEAP32[i36 >> 2] | 0;
     if (!i1) i4 = 0; else {
      i4 = _malloc(i1 << 2) | 0;
      if (!i4) {
       i2 = 0;
       i1 = 12;
       break;
      }
     }
     i31 = i45 + 8 | 0;
     i32 = i45 + 12 | 0;
     i33 = (i43 | 0) == 0;
     i34 = (i43 | 0) != 0;
     i35 = i45 + 32 | 0;
     i27 = (i2 | 0) != 0;
     i28 = (i3 | 0) == 0;
     i29 = (i5 | 0) == 0;
     i30 = (i4 | 0) == 0;
     i26 = (i6 | 0) == 0;
     i10 = i40;
     i9 = 1;
     i6 = -1;
     i14 = -1;
     i1 = i8;
     L233 : while (1) {
      if ((i1 | 0) > 0) {
       i2 = 0;
       do {
        HEAP32[i3 + (i2 << 2) >> 2] = -1;
        if (!i33) {
         HEAP32[i43 + (i2 << 2) >> 2] = -1;
         i1 = HEAP32[i39 >> 2] | 0;
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i1 | 0));
      }
      i1 = HEAP32[i36 >> 2] | 0;
      if ((i1 | 0) > 0) _memset(i4 | 0, 0, i1 << 2 | 0) | 0;
      i8 = HEAP32[i42 >> 2] | 0;
      i25 = i9 + i6 | 0;
      i1 = _mbtowc(i42, i10, 4) | 0;
      if ((i1 | 0) < 1) if ((i1 | 0) < 0) {
       i2 = 0;
       i1 = 1;
       break L225;
      } else i1 = 1;
      i23 = i10 + i1 | 0;
      i24 = HEAP32[i42 >> 2] | 0;
      i2 = HEAP32[i31 >> 2] | 0;
      i6 = i2 + 8 | 0;
      if (!(HEAP32[i6 >> 2] | 0)) {
       i6 = i25;
       i12 = 0;
       i9 = i23;
       i2 = 0;
       i41 = 174;
      } else {
       i15 = (i25 | 0) != 0;
       i16 = (i8 | 0) == 95;
       i17 = (i25 | 0) == 0;
       i19 = i27 & (i8 | 0) == 10;
       i18 = i26 & (i25 | 0) < 1;
       i13 = i2;
       i2 = 0;
       i12 = 0;
       i11 = i6;
       while (1) {
        i10 = i13 + 20 | 0;
        i6 = HEAP32[i10 >> 2] | 0;
        L252 : do if (!i6) i41 = 52; else {
         if (!(i19 | (i18 | (i6 & 1 | 0) == 0))) {
          i9 = i12;
          break;
         }
         if (i6 & 2 | 0) {
          i22 = HEAP32[i42 >> 2] | 0;
          if (!((i22 | i37 | 0) == 0 | i27 & (i22 | 0) == 10)) {
           i9 = i12;
           break;
          }
         }
         do if (i6 & 16 | 0) {
          if (i16) {
           i9 = i12;
           break L252;
          }
          if (_iswalnum(i8) | 0) {
           i9 = i12;
           break L252;
          }
          i6 = HEAP32[i42 >> 2] | 0;
          if ((i6 | 0) == 95) break;
          if (!(_iswalnum(i6) | 0)) {
           i9 = i12;
           break L252;
          }
         } while (0);
         i6 = HEAP32[i10 >> 2] | 0;
         if (i6 & 32) {
          if (i16) {
           i6 = HEAP32[i42 >> 2] | 0;
           if ((i6 | 0) == 95) {
            i9 = i12;
            break;
           }
          } else {
           i22 = (_iswalnum(i8) | 0) == 0;
           i6 = HEAP32[i42 >> 2] | 0;
           if (i22 | (i6 | 0) == 95) {
            i9 = i12;
            break;
           }
          }
          if (_iswalnum(i6) | 0) {
           i9 = i12;
           break;
          }
          i6 = HEAP32[i10 >> 2] | 0;
         }
         i9 = HEAP32[i42 >> 2] | 0;
         do if ((i9 | 0) != 0 & (i15 & (i6 & 64 | 0) != 0)) {
          if (i16) i6 = 1; else {
           i6 = (_iswalnum(i8) | 0) != 0;
           i9 = HEAP32[i42 >> 2] | 0;
          }
          if ((i9 | 0) == 95) if (i6) {
           i9 = i12;
           break L252;
          } else break; else if (i6 ^ (_iswalnum(i9) | 0) != 0) break; else {
           i9 = i12;
           break L252;
          }
         } while (0);
         if (!(HEAP32[i10 >> 2] & 128)) {
          i41 = 52;
          break;
         }
         i6 = HEAP32[i42 >> 2] | 0;
         if (i17 | (i6 | 0) == 0) {
          i9 = i12;
          break;
         }
         if (i16) i9 = 1; else {
          i9 = (_iswalnum(i8) | 0) != 0;
          i6 = HEAP32[i42 >> 2] | 0;
         }
         if ((i6 | 0) == 95) if (i9) {
          i41 = 52;
          break;
         } else {
          i9 = i12;
          break;
         } else if (i9 ^ (_iswalnum(i6) | 0) != 0) {
          i9 = i12;
          break;
         } else {
          i41 = 52;
          break;
         }
        } while (0);
        do if ((i41 | 0) == 52) {
         i41 = 0;
         if (!i12) {
          i2 = HEAP32[i13 + 16 >> 2] | 0;
          i9 = HEAP32[i11 >> 2] | 0;
          break;
         }
         i9 = i7 + 28 | 0;
         i6 = HEAP32[i9 >> 2] | 0;
         if (!i6) {
          i6 = ___tre_mem_alloc_impl(i38, 0, 0, 0, 32) | 0;
          if (!i6) {
           i41 = 56;
           break L233;
          }
          HEAP32[i6 + 24 >> 2] = i7;
          HEAP32[i6 + 28 >> 2] = 0;
          i22 = ___tre_mem_alloc_impl(i38, 0, 0, 0, HEAP32[i39 >> 2] << 2) | 0;
          HEAP32[i6 + 20 >> 2] = i22;
          if (!i22) {
           i41 = 63;
           break L233;
          }
          HEAP32[i9 >> 2] = i6;
          i7 = i6;
         } else i7 = i6;
         HEAP32[i7 >> 2] = i25;
         HEAP32[i7 + 4 >> 2] = i23;
         HEAP32[i7 + 8 >> 2] = HEAP32[i11 >> 2];
         HEAP32[i7 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
         HEAP32[i7 + 16 >> 2] = HEAP32[i42 >> 2];
         if ((HEAP32[i39 >> 2] | 0) > 0) {
          i9 = HEAP32[i7 + 20 >> 2] | 0;
          i6 = 0;
          do {
           HEAP32[i9 + (i6 << 2) >> 2] = HEAP32[i3 + (i6 << 2) >> 2];
           i6 = i6 + 1 | 0;
          } while ((i6 | 0) < (HEAP32[i39 >> 2] | 0));
         }
         i6 = HEAP32[i13 + 16 >> 2] | 0;
         if (!i6) {
          i9 = i12;
          break;
         }
         i9 = HEAP32[i6 >> 2] | 0;
         if ((i9 | 0) <= -1) {
          i9 = i12;
          break;
         }
         i10 = HEAP32[i7 + 20 >> 2] | 0;
         do {
          i6 = i6 + 4 | 0;
          HEAP32[i10 + (i9 << 2) >> 2] = i25;
          i9 = HEAP32[i6 >> 2] | 0;
         } while ((i9 | 0) > -1);
         i9 = i12;
        } while (0);
        i11 = i13 + 40 | 0;
        if (!(HEAP32[i11 >> 2] | 0)) break; else {
         i13 = i13 + 32 | 0;
         i12 = i9;
        }
       }
       if (!i2) i2 = 0; else {
        i6 = HEAP32[i2 >> 2] | 0;
        if ((i6 | 0) > -1) do {
         HEAP32[i3 + (i6 << 2) >> 2] = i25;
         i2 = i2 + 4 | 0;
         i6 = HEAP32[i2 >> 2] | 0;
        } while ((i6 | 0) > -1);
       }
       if (!i9) {
        i6 = i25;
        i12 = 0;
        i9 = i23;
        i41 = 174;
       } else {
        i10 = i8;
        i11 = i25;
        i15 = i23;
        i22 = i14;
        i21 = i9;
        i41 = 82;
       }
      }
      L315 : while (1) {
       L316 : do if ((i41 | 0) == 82) {
        i41 = 0;
        if ((i21 | 0) == (HEAP32[i32 >> 2] | 0)) {
         if ((i22 | 0) >= (i11 | 0)) {
          if (!(i34 & (i22 | 0) == (i11 | 0))) {
           i14 = i22;
           i8 = i10;
           i6 = i11;
           i12 = i21;
           i9 = i15;
           i41 = 174;
           continue L315;
          }
          if (!(_tre_tag_order(HEAP32[i39 >> 2] | 0, HEAP32[i35 >> 2] | 0, i3, i43) | 0)) {
           i14 = i22;
           i8 = i10;
           i6 = i22;
           i12 = i21;
           i9 = i15;
           i41 = 174;
           continue L315;
          }
         }
         if (i33) {
          i14 = i11;
          i8 = i10;
          i6 = i11;
          i12 = i21;
          i9 = i15;
          i41 = 174;
          continue L315;
         }
         if ((HEAP32[i39 >> 2] | 0) > 0) i6 = 0; else {
          i14 = i11;
          i8 = i10;
          i6 = i11;
          i12 = i21;
          i9 = i15;
          i41 = 174;
          continue L315;
         }
         while (1) {
          HEAP32[i43 + (i6 << 2) >> 2] = HEAP32[i3 + (i6 << 2) >> 2];
          i6 = i6 + 1 | 0;
          if ((i6 | 0) >= (HEAP32[i39 >> 2] | 0)) {
           i14 = i11;
           i8 = i10;
           i6 = i11;
           i12 = i21;
           i9 = i15;
           i41 = 174;
           continue L315;
          }
         }
        }
        i13 = i21 + 8 | 0;
        do if (!(HEAP32[i13 >> 2] | 0)) i41 = 98; else {
         if (!(HEAP32[i21 + 20 >> 2] & 256)) {
          i41 = 98;
          break;
         }
         i8 = HEAP32[i21 + 24 >> 2] | 0;
         _tre_fill_pmatch(i8 + 1 | 0, i5, HEAP32[i46 >> 2] & -9, i45, i3, i11);
         i20 = HEAP32[i5 + (i8 << 3) >> 2] | 0;
         i8 = (HEAP32[i5 + (i8 << 3) + 4 >> 2] | 0) - i20 | 0;
         do if (!(_strncmp(i40 + i20 | 0, i15 + -1 | 0, i8) | 0)) {
          i20 = (i8 | 0) == 0;
          i6 = i20 & 1;
          i9 = i4 + (HEAP32[i21 + 12 >> 2] << 2) | 0;
          if (i20) if (HEAP32[i9 >> 2] | 0) {
           i8 = i10;
           i6 = i11;
           i9 = i15;
           i10 = 25;
           break;
          }
          HEAP32[i9 >> 2] = i6;
          i6 = i8 + -1 | 0;
          i9 = i15 + i6 | 0;
          i8 = HEAP32[i42 >> 2] | 0;
          i6 = i11 + i1 + i6 | 0;
          i1 = _mbtowc(i42, i9, 4) | 0;
          if ((i1 | 0) < 1) if ((i1 | 0) < 0) {
           i10 = 2;
           break;
          } else i1 = 1;
          i9 = i9 + i1 | 0;
          i10 = 0;
         } else {
          i8 = i10;
          i6 = i11;
          i9 = i15;
          i10 = 25;
         } while (0);
         switch (i10 & 31) {
         case 25:
          {
           i14 = i22;
           i12 = i21;
           i41 = 174;
           continue L315;
          }
         case 0:
          {
           i20 = i6;
           break;
          }
         default:
          {
           i14 = i22;
           i12 = i21;
           break L316;
          }
         }
        } while (0);
        if ((i41 | 0) == 98) {
         i41 = 0;
         i8 = HEAP32[i42 >> 2] | 0;
         if (!i8) {
          i14 = i22;
          i8 = i10;
          i6 = i11;
          i12 = i21;
          i9 = i15;
          i41 = 174;
          continue L315;
         }
         i6 = i11 + i1 | 0;
         i1 = _mbtowc(i42, i15, 4) | 0;
         if ((i1 | 0) < 1) if ((i1 | 0) < 0) {
          i14 = i22;
          i10 = 2;
          i12 = i21;
          i9 = i15;
          break;
         } else i1 = 1;
         i20 = i6;
         i9 = i15 + i1 | 0;
        }
        if (!(HEAP32[i13 >> 2] | 0)) {
         i14 = i22;
         i6 = i20;
         i12 = i21;
         i41 = 174;
         continue L315;
        }
        i15 = (i20 | 0) != 0;
        i16 = (i8 | 0) == 95;
        i17 = (i20 | 0) == 0;
        i19 = i27 & (i8 | 0) == 10;
        i18 = i26 & (i20 | 0) < 1;
        i12 = 0;
        i14 = i21;
        L359 : while (1) {
         L361 : do if ((HEAP32[i14 >> 2] | 0) >>> 0 <= i8 >>> 0) {
          if ((HEAP32[i14 + 4 >> 2] | 0) >>> 0 < i8 >>> 0) break;
          i11 = i14 + 20 | 0;
          i6 = HEAP32[i11 >> 2] | 0;
          do if (i6 | 0) {
           if (!(i19 | (i18 | (i6 & 1 | 0) == 0))) break L361;
           if (i6 & 2 | 0) {
            i41 = HEAP32[i42 >> 2] | 0;
            if (!((i41 | i37 | 0) == 0 | i27 & (i41 | 0) == 10)) break L361;
           }
           do if (i6 & 16 | 0) {
            if (i16) break L361;
            if (_iswalnum(i8) | 0) break L361;
            i6 = HEAP32[i42 >> 2] | 0;
            if ((i6 | 0) == 95) break;
            if (!(_iswalnum(i6) | 0)) break L361;
           } while (0);
           i6 = HEAP32[i11 >> 2] | 0;
           if (i6 & 32) {
            if (i16) {
             i6 = HEAP32[i42 >> 2] | 0;
             if ((i6 | 0) == 95) break L361;
            } else {
             i41 = (_iswalnum(i8) | 0) == 0;
             i6 = HEAP32[i42 >> 2] | 0;
             if (i41 | (i6 | 0) == 95) break L361;
            }
            if (_iswalnum(i6) | 0) break L361;
            i6 = HEAP32[i11 >> 2] | 0;
           }
           i10 = HEAP32[i42 >> 2] | 0;
           do if ((i10 | 0) != 0 & (i15 & (i6 & 64 | 0) != 0)) {
            if (i16) i6 = 1; else {
             i6 = (_iswalnum(i8) | 0) != 0;
             i10 = HEAP32[i42 >> 2] | 0;
            }
            if ((i10 | 0) == 95) if (i6) break L361; else break; else if (i6 ^ (_iswalnum(i10) | 0) != 0) break; else break L361;
           } while (0);
           do if (HEAP32[i11 >> 2] & 128 | 0) {
            i6 = HEAP32[i42 >> 2] | 0;
            if (i17 | (i6 | 0) == 0) break L361;
            if (i16) i10 = 1; else {
             i10 = (_iswalnum(i8) | 0) != 0;
             i6 = HEAP32[i42 >> 2] | 0;
            }
            if ((i6 | 0) == 95) if (i10) break; else break L361; else if (i10 ^ (_iswalnum(i6) | 0) != 0) break L361; else break;
           } while (0);
           i6 = HEAP32[i11 >> 2] | 0;
           do if (i6 & 4) {
            if (HEAP32[i46 >> 2] & 2 | 0) break;
            if (!(_iswctype(i8, HEAP32[i14 + 24 >> 2] | 0) | 0)) break L361;
            i6 = HEAP32[i11 >> 2] | 0;
           } while (0);
           do if (i6 & 4 | 0) {
            if (!(HEAP32[i46 >> 2] & 2)) break;
            i41 = _towlower(i8) | 0;
            i6 = i14 + 24 | 0;
            if (_iswctype(i41, HEAP32[i6 >> 2] | 0) | 0) break;
            i41 = _towupper(i8) | 0;
            if (!(_iswctype(i41, HEAP32[i6 >> 2] | 0) | 0)) break L361;
           } while (0);
           if (!(HEAP32[i11 >> 2] & 8)) break;
           if (_tre_neg_char_classes_match(HEAP32[i14 + 28 >> 2] | 0, i8, HEAP32[i46 >> 2] & 2) | 0) break L361;
          } while (0);
          if (!i12) {
           i12 = HEAP32[i13 >> 2] | 0;
           i2 = HEAP32[i14 + 16 >> 2] | 0;
           break;
          }
          i10 = i7 + 28 | 0;
          i6 = HEAP32[i10 >> 2] | 0;
          if (!i6) {
           i6 = ___tre_mem_alloc_impl(i38, 0, 0, 0, 32) | 0;
           if (!i6) {
            i41 = 148;
            break L359;
           }
           HEAP32[i6 + 24 >> 2] = i7;
           HEAP32[i6 + 28 >> 2] = 0;
           i41 = ___tre_mem_alloc_impl(i38, 0, 0, 0, HEAP32[i39 >> 2] << 2) | 0;
           HEAP32[i6 + 20 >> 2] = i41;
           if (!i41) {
            i41 = 155;
            break L359;
           }
           HEAP32[i10 >> 2] = i6;
           i7 = i6;
          } else i7 = i6;
          HEAP32[i7 >> 2] = i20;
          HEAP32[i7 + 4 >> 2] = i9;
          HEAP32[i7 + 8 >> 2] = HEAP32[i13 >> 2];
          HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
          HEAP32[i7 + 16 >> 2] = HEAP32[i42 >> 2];
          if ((HEAP32[i39 >> 2] | 0) > 0) {
           i10 = HEAP32[i7 + 20 >> 2] | 0;
           i6 = 0;
           do {
            HEAP32[i10 + (i6 << 2) >> 2] = HEAP32[i3 + (i6 << 2) >> 2];
            i6 = i6 + 1 | 0;
           } while ((i6 | 0) < (HEAP32[i39 >> 2] | 0));
          }
          i6 = HEAP32[i14 + 16 >> 2] | 0;
          if (!i6) break;
          i10 = HEAP32[i6 >> 2] | 0;
          if ((i10 | 0) <= -1) break;
          i11 = HEAP32[i7 + 20 >> 2] | 0;
          do {
           HEAP32[i11 + (i10 << 2) >> 2] = i20;
           i6 = i6 + 4 | 0;
           i10 = HEAP32[i6 >> 2] | 0;
          } while ((i10 | 0) > -1);
         } while (0);
         i13 = i14 + 40 | 0;
         if (!(HEAP32[i13 >> 2] | 0)) {
          i41 = 170;
          break;
         } else i14 = i14 + 32 | 0;
        }
        if ((i41 | 0) == 148) {
         i41 = 0;
         ___tre_mem_destroy(i38);
         if (!i28) _free(i3);
         if (!i29) _free(i5);
         if (i30) {
          i14 = i22;
          i6 = i20;
          i10 = 1;
          i12 = i21;
          break;
         }
         _free(i4);
         i14 = i22;
         i6 = i20;
         i10 = 1;
         i12 = i21;
         break;
        } else if ((i41 | 0) == 155) {
         i41 = 0;
         ___tre_mem_destroy(i38);
         if (!i28) _free(i3);
         if (!i29) _free(i5);
         if (i30) {
          i14 = i22;
          i6 = i20;
          i10 = 1;
          i12 = i21;
          break;
         }
         _free(i4);
         i14 = i22;
         i6 = i20;
         i10 = 1;
         i12 = i21;
         break;
        } else if ((i41 | 0) == 170) {
         i41 = 0;
         if (!i12) {
          i14 = i22;
          i6 = i20;
          i12 = i21;
          i41 = 174;
          continue L315;
         }
         if (!i2) {
          i2 = 0;
          i14 = i22;
          i6 = i20;
          i10 = 0;
          break;
         }
         i6 = HEAP32[i2 >> 2] | 0;
         if ((i6 | 0) <= -1) {
          i14 = i22;
          i6 = i20;
          i10 = 0;
          break;
         }
         do {
          i2 = i2 + 4 | 0;
          HEAP32[i3 + (i6 << 2) >> 2] = i20;
          i6 = HEAP32[i2 >> 2] | 0;
         } while ((i6 | 0) > -1);
         i14 = i22;
         i6 = i20;
         i10 = 0;
        }
       } else if ((i41 | 0) == 174) {
        i41 = 0;
        i10 = HEAP32[i7 + 24 >> 2] | 0;
        if (!i10) {
         if ((i14 | 0) > -1 | (HEAP32[i42 >> 2] | 0) == 0) {
          i10 = 27;
          break;
         }
         HEAP32[i42 >> 2] = i24;
         i10 = 3;
         i9 = i23;
         break;
        }
        i12 = HEAP32[i7 + 8 >> 2] | 0;
        if (HEAP32[i12 + 20 >> 2] & 256 | 0) HEAP32[i4 + (HEAP32[i7 + 12 >> 2] << 2) >> 2] = 0;
        i11 = HEAP32[i7 >> 2] | 0;
        i13 = HEAP32[i7 + 4 >> 2] | 0;
        HEAP32[i42 >> 2] = HEAP32[i7 + 16 >> 2];
        i9 = HEAP32[i39 >> 2] | 0;
        if ((i9 | 0) <= 0) {
         i7 = i10;
         i6 = i11;
         i10 = 0;
         i9 = i13;
         break;
        }
        i7 = HEAP32[i7 + 20 >> 2] | 0;
        i6 = 0;
        do {
         HEAP32[i3 + (i6 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
         i6 = i6 + 1 | 0;
        } while ((i6 | 0) != (i9 | 0));
        i7 = i10;
        i6 = i11;
        i10 = 0;
        i9 = i13;
       } while (0);
       switch (i10 | 0) {
       case 2:
        {
         i2 = 0;
         i1 = 1;
         break L225;
        }
       case 27:
        {
         i41 = 184;
         break L233;
        }
       case 0:
        {
         i10 = i8;
         i11 = i6;
         i15 = i9;
         i22 = i14;
         i21 = i12;
         i41 = 82;
         break;
        }
       case 3:
        break L315;
       default:
        {
         i2 = 0;
         i1 = 12;
         break L218;
        }
       }
      }
      i10 = i9;
      i9 = i1;
      i6 = i25;
      i1 = HEAP32[i39 >> 2] | 0;
     }
     if ((i41 | 0) == 56) {
      ___tre_mem_destroy(i38);
      if (!i28) _free(i3);
      if (!i29) _free(i5);
      if (i30) {
       i2 = 0;
       i1 = 12;
       break L218;
      }
      _free(i4);
      i2 = 0;
      i1 = 12;
      break L218;
     } else if ((i41 | 0) == 63) {
      ___tre_mem_destroy(i38);
      if (!i28) _free(i3);
      if (!i29) _free(i5);
      if (i30) {
       i2 = 0;
       i1 = 12;
       break L218;
      }
      _free(i4);
      i2 = 0;
      i1 = 12;
      break L218;
     } else if ((i41 | 0) == 184) {
      i2 = i14;
      i1 = i14 >>> 31;
      break;
     }
    } while (0);
    ___tre_mem_destroy(i38);
    if (i3 | 0) _free(i3);
    if (i5 | 0) _free(i5);
    if (i4) _free(i4);
   } while (0);
  }
  if (!i1) _tre_fill_pmatch(i44, i47, HEAP32[i46 >> 2] | 0, i45, i43, i2);
  if (i43) _free(i43);
 }
 STACKTOP = i48;
 return i1 | 0;
}

function __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackERNS0_14PvdInputStreamE(i1, i51) {
 i1 = i1 | 0;
 i51 = i51 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i59 + 1032 | 0;
 i57 = i59 + 200 | 0;
 i47 = i59 + 144 | 0;
 i48 = i59 + 120 | 0;
 i52 = i59 + 112 | 0;
 i49 = i59 + 36 | 0;
 i50 = i59 + 32 | 0;
 i25 = i59 + 28 | 0;
 i24 = i59 + 24 | 0;
 i54 = i59 + 16 | 0;
 i55 = i59 + 12 | 0;
 i56 = i59;
 i58 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 248, gb + 774161 | 0, gb + 774188 | 0, 1328) | 0;
 __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplC2ERN5physx19PxAllocatorCallbackE(i58, i1);
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i59 + 20 | 0, i53 | 0) | 0;
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i58 + 240 | 0, i53 | 0) | 0;
 i46 = i58 + 160 | 0;
 i8 = HEAP32[i46 >> 2] | 0;
 i1 = HEAP32[i8 + 96 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 112 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i8 + 88 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i8 + 92 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i8 + 84 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i8 + 104 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = HEAP32[i8 + 148 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 164 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i8 + 140 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i8 + 144 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i8 + 136 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i8 + 156 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i47 | 0, i53 | 0) | 0;
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i8 + 60 | 0, i53 | 0) | 0;
 i9 = i8 + 4 | 0;
 i17 = i48 + 4 | 0;
 HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i48 + 8 >> 2] = gb + 774905;
 i10 = i48 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i48 + 16 >> 2] = 0;
 i18 = i48 + 20 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i48 >> 2] = gb + 148736 + 8;
 if (!(HEAP32[i47 >> 2] | 0)) HEAP32[i48 >> 2] = gb + 148752 + 8; else {
  i11 = i8 + 40 | 0;
  i12 = i8 + 8 | 0;
  i13 = i8 + 64 | 0;
  i14 = i8 + 116 | 0;
  i15 = i8 + 32 | 0;
  i16 = i8 + 24 | 0;
  i6 = i8 + 28 | 0;
  i1 = 0;
  i7 = 0;
  i8 = 0;
  do {
   HEAP32[i53 >> 2] = 4;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i52 | 0, i53 | 0) | 0;
   HEAP32[i53 >> 2] = 4;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i49 | 0, i53 | 0) | 0;
   i2 = HEAP32[i49 >> 2] | 0;
   if (i7 >>> 0 < i2 >>> 0) {
    HEAP8[i50 >> 0] = 0;
    __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i48, i2, i50);
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i49 >> 2] | 0;
   }
   i7 = i7 >>> 0 < i2 >>> 0 ? i2 : i7;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 | 0, i49 | 0) | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   L27 : do if (!i5) i19 = 26; else {
    i2 = HEAP8[i1 >> 0] | 0;
    if (!(i2 << 24 >> 24)) i2 = 5381; else {
     i3 = 5381;
     i4 = i1;
     do {
      i3 = i3 * 33 ^ i2 << 24 >> 24;
      i4 = i4 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     } while (i2 << 24 >> 24 != 0);
     i2 = i3;
    }
    i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + ((i2 & i5 + -1) << 2) >> 2] | 0;
    if ((i2 | 0) == -1) i19 = 26; else {
     i4 = HEAP32[i16 >> 2] | 0;
     while (1) {
      i3 = i4 + (i2 << 3) | 0;
      if (!(_strcmp(HEAP32[i3 >> 2] | 0, i1) | 0)) break;
      i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      if ((i2 | 0) == -1) {
       i19 = 26;
       break L27;
      }
     }
     if (!i3) i19 = 26; else i2 = HEAP32[i4 + (i2 << 3) + 4 >> 2] | 0;
    }
   } while (0);
   if ((i19 | 0) == 26) {
    i19 = 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i45 = i1 | 0 ? i1 : gb + 1576256 | 0;
    i3 = _strlen(i45) | 0;
    i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 + 1 | 0, gb + 774868 | 0, gb + 774188 | 0, 178) | 0;
    _memcpy(i2 | 0, i45 | 0, i3 | 0) | 0;
    HEAP8[i2 + i3 >> 0] = 0;
    HEAP32[i53 >> 2] = i2;
    i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i12, i53, i57) | 0;
    if (!(HEAP8[i57 >> 0] | 0)) {
     i45 = i2;
     HEAP32[i3 >> 2] = i45;
     HEAP32[i3 + 4 >> 2] = i45;
    }
   }
   i4 = HEAP32[i52 >> 2] | 0;
   HEAP32[i53 >> 2] = i4;
   i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i13, i53, i57) | 0;
   if (!(HEAP8[i57 >> 0] | 0)) {
    HEAP32[i3 >> 2] = i4;
    HEAP32[i3 + 4 >> 2] = i2;
   }
   HEAP32[i53 >> 2] = i2;
   i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i14, i53, i57) | 0;
   if (!(HEAP8[i57 >> 0] | 0)) {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i3 + 4 >> 2] = i4;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (HEAP32[i47 >> 2] | 0) >>> 0);
  i45 = HEAP32[i18 >> 2] | 0;
  HEAP32[i48 >> 2] = gb + 148752 + 8;
  if ((i45 | 0) > -1 & (i45 & 2147483647 | 0) != 0) {
   i45 = HEAP32[i17 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i1 | 0);
  }
 }
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i49 | 0, i53 | 0) | 0;
 i45 = HEAP32[i49 >> 2] | 0;
 HEAP32[i50 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i58 + 136 | 0, i45, i50);
 i45 = i58 + 152 | 0;
 if (HEAP32[i45 >> 2] | 0) {
  i6 = i58 + 148 | 0;
  i7 = i48 + 4 | 0;
  i8 = i58 + 4 | 0;
  i10 = 0;
  do {
   i9 = (HEAP32[i6 >> 2] | 0) + (i10 << 2) | 0;
   HEAP32[i53 >> 2] = 4;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i52 | 0, i53 | 0) | 0;
   if (!(HEAP32[i52 >> 2] | 0)) i1 = 0; else {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 76, gb + 774935 | 0, gb + 774188 | 0, 1218) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i33 = i1 + 4 | 0;
    HEAP32[i33 >> 2] = gb + 1576256;
    i34 = i1 + 8 | 0;
    HEAP32[i34 >> 2] = gb + 1576256;
    i35 = i1 + 12 | 0;
    HEAP32[i35 >> 2] = -1;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = gb + 1576256;
    i36 = i1 + 20 | 0;
    HEAP32[i36 >> 2] = gb + 1576256;
    i37 = i1 + 24 | 0;
    HEAP32[i37 >> 2] = -1;
    i38 = i1 + 28 | 0;
    HEAP32[i38 >> 2] = gb + 1576256;
    i39 = i1 + 32 | 0;
    HEAP32[i39 >> 2] = gb + 1576256;
    i40 = i1 + 36 | 0;
    HEAP32[i40 >> 2] = 0;
    i41 = i1 + 40 | 0;
    HEAP32[i41 >> 2] = -1;
    i42 = i1 + 44 | 0;
    HEAP32[i42 >> 2] = 0;
    i44 = i1 + 48 | 0;
    HEAP32[i44 >> 2] = 0;
    HEAP32[i1 >> 2] = gb + 148768 + 8;
    i43 = i1 + 52 | 0;
    HEAP32[i1 + 56 >> 2] = i3;
    HEAP32[i1 + 60 >> 2] = gb + 774945;
    i3 = i1 + 64 | 0;
    HEAP32[i3 >> 2] = 0;
    i4 = i1 + 68 | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i1 + 72 >> 2] = 0;
    HEAP32[i43 >> 2] = gb + 148784 + 8;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i32 = HEAP32[i46 >> 2] | 0;
    HEAP32[i33 >> 2] = mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 24 >> 2] | 0, i32 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i33 = HEAP32[i46 >> 2] | 0;
    HEAP32[i34 >> 2] = mftCall_iii(HEAP32[(HEAP32[i33 >> 2] | 0) + 24 >> 2] | 0, i33 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i35 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i35 = HEAP32[i46 >> 2] | 0;
    HEAP32[i36 >> 2] = mftCall_iii(HEAP32[(HEAP32[i35 >> 2] | 0) + 24 >> 2] | 0, i35 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i37 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i37 = HEAP32[i46 >> 2] | 0;
    HEAP32[i38 >> 2] = mftCall_iii(HEAP32[(HEAP32[i37 >> 2] | 0) + 24 >> 2] | 0, i37 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i38 = HEAP32[i46 >> 2] | 0;
    HEAP32[i39 >> 2] = mftCall_iii(HEAP32[(HEAP32[i38 >> 2] | 0) + 24 >> 2] | 0, i38 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i40 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i41 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i42 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i44 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i47 | 0, i53 | 0) | 0;
    i44 = HEAP32[i47 >> 2] | 0;
    HEAP32[i48 >> 2] = gb + 1576256;
    HEAP32[i7 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i43, i44, i48);
    if (HEAP32[i4 >> 2] | 0) {
     i5 = 0;
     do {
      i44 = HEAP32[i3 >> 2] | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i44 + (i5 << 3) + 4 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      i43 = HEAP32[i46 >> 2] | 0;
      HEAP32[i44 + (i5 << 3) >> 2] = mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 24 >> 2] | 0, i43 | 0, HEAP32[i57 >> 2] | 0) | 0;
      i5 = i5 + 1 | 0;
     } while (i5 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
    }
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i44 = HEAP32[i46 >> 2] | 0;
    HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i44 >> 2] | 0) + 24 >> 2] | 0, i44 | 0, HEAP32[i57 >> 2] | 0) | 0;
   }
   HEAP32[i9 >> 2] = i1;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i45 >> 2] | 0) >>> 0);
 }
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i49 | 0, i53 | 0) | 0;
 i44 = HEAP32[i49 >> 2] | 0;
 HEAP32[i50 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i58 + 112 | 0, i44, i50);
 i44 = i58 + 128 | 0;
 if (HEAP32[i44 >> 2] | 0) {
  i18 = i58 + 124 | 0;
  i19 = i48 + 4 | 0;
  i20 = i48 + 4 | 0;
  i21 = i58 + 4 | 0;
  i17 = i58 + 148 | 0;
  i23 = 0;
  do {
   i22 = (HEAP32[i18 >> 2] | 0) + (i23 << 2) | 0;
   HEAP32[i53 >> 2] = 4;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i52 | 0, i53 | 0) | 0;
   if (!(HEAP32[i52 >> 2] | 0)) i1 = 0; else {
    i1 = HEAP32[i21 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 144, gb + 774935 | 0, gb + 774188 | 0, 1218) | 0;
    i2 = HEAP32[i21 >> 2] | 0;
    i5 = i1 + 4 | 0;
    HEAP32[i5 >> 2] = gb + 1576256;
    i6 = i1 + 8 | 0;
    HEAP32[i6 >> 2] = gb + 1576256;
    i7 = i1 + 12 | 0;
    i8 = i1 + 28 | 0;
    HEAP32[i7 >> 2] = -1;
    HEAP32[i7 + 4 >> 2] = -1;
    HEAP32[i7 + 8 >> 2] = -1;
    HEAP32[i7 + 12 >> 2] = -1;
    i3 = i8;
    i4 = i3 + 40 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    HEAP16[i8 + 40 >> 1] = 0;
    HEAP32[i1 >> 2] = gb + 148256 + 8;
    i16 = i2;
    i42 = i1 + 72 | 0;
    HEAP32[i1 + 76 >> 2] = i16;
    HEAP32[i1 + 80 >> 2] = gb + 774548;
    i9 = i1 + 84 | 0;
    HEAP32[i9 >> 2] = 0;
    i10 = i1 + 88 | 0;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i1 + 92 >> 2] = 0;
    HEAP32[i42 >> 2] = gb + 148272 + 8;
    i11 = i1 + 96 | 0;
    HEAP32[i1 + 100 >> 2] = i16;
    HEAP32[i1 + 104 >> 2] = gb + 774562;
    i14 = i1 + 108 | 0;
    HEAP32[i14 >> 2] = 0;
    i15 = i1 + 112 | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i1 + 116 >> 2] = 0;
    HEAP32[i11 >> 2] = gb + 148288 + 8;
    i12 = i1 + 120 | 0;
    HEAP32[i1 + 124 >> 2] = i16;
    HEAP32[i1 + 128 >> 2] = gb + 774592;
    i16 = i1 + 132 | 0;
    HEAP32[i16 >> 2] = 0;
    i13 = i1 + 136 | 0;
    HEAP32[i13 >> 2] = 0;
    HEAP32[i1 + 140 >> 2] = 0;
    HEAP32[i12 >> 2] = gb + 148288 + 8;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i43 = HEAP32[i46 >> 2] | 0;
    HEAP32[i5 >> 2] = mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 24 >> 2] | 0, i43 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i43 = HEAP32[i46 >> 2] | 0;
    HEAP32[i6 >> 2] = mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 24 >> 2] | 0, i43 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i1 + 20 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i1 + 24 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 1;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP8[i1 + 68 >> 0] = (HEAP8[i57 >> 0] | 0) != 0 & 1;
    HEAP32[i53 >> 2] = 1;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP8[i1 + 69 >> 0] = (HEAP8[i57 >> 0] | 0) != 0 & 1;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i8 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 32 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 36 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 48 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 52 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 56 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i47 | 0, i53 | 0) | 0;
    i43 = HEAP32[i47 >> 2] | 0;
    HEAP32[i48 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i42, i43, i48);
    if (HEAP32[i10 >> 2] | 0) {
     i4 = 0;
     do {
      i3 = (HEAP32[i9 >> 2] | 0) + (i4 << 2) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      i2 = HEAP32[i57 >> 2] | 0;
      if ((i2 | 0) > -1) if ((HEAP32[i45 >> 2] | 0) > (i2 | 0)) i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i2 << 2) >> 2] | 0; else i2 = 0; else i2 = 0;
      HEAP32[i3 >> 2] = i2;
      i4 = i4 + 1 | 0;
     } while (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
    }
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i47 | 0, i53 | 0) | 0;
    i43 = HEAP32[i47 >> 2] | 0;
    HEAP32[i48 >> 2] = 0;
    HEAP32[i19 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i11, i43, i48);
    if (HEAP32[i15 >> 2] | 0) {
     i2 = 0;
     do {
      i43 = HEAP32[i14 >> 2] | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i43 + (i2 << 3) + 4 | 0, i53 | 0) | 0;
      HEAP32[i43 + (i2 << 3) >> 2] = HEAP32[i57 >> 2];
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
    }
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i47 | 0, i53 | 0) | 0;
    i43 = HEAP32[i47 >> 2] | 0;
    HEAP32[i48 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i12, i43, i48);
    if (!(HEAP32[i13 >> 2] | 0)) i2 = 0; else {
     i3 = 0;
     do {
      i2 = HEAP32[i16 >> 2] | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i2 + (i3 << 3) + 4 | 0, i53 | 0) | 0;
      HEAP32[i2 + (i3 << 3) >> 2] = HEAP32[i57 >> 2];
      i3 = i3 + 1 | 0;
      i2 = HEAP32[i13 >> 2] | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
    i42 = HEAP32[i14 >> 2] | 0;
    i43 = i42 + (HEAP32[i15 >> 2] << 3) | 0;
    HEAP32[i1 + 40 >> 2] = i42;
    HEAP32[i1 + 44 >> 2] = i43;
    i43 = HEAP32[i16 >> 2] | 0;
    HEAP32[i1 + 60 >> 2] = i43;
    HEAP32[i1 + 64 >> 2] = i43 + (i2 << 3);
   }
   HEAP32[i22 >> 2] = i1;
   i23 = i23 + 1 | 0;
  } while (i23 >>> 0 < (HEAP32[i44 >> 2] | 0) >>> 0);
 }
 HEAP32[i53 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i25 | 0, i53 | 0) | 0;
 i43 = HEAP32[i25 >> 2] | 0;
 HEAP32[i24 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i58 + 216 | 0, i43, i24);
 i43 = i58 + 232 | 0;
 if (HEAP32[i43 >> 2] | 0) {
  i14 = i58 + 228 | 0;
  i15 = i49 + 4 | 0;
  i16 = i49 + 8 | 0;
  i17 = i49 + 12 | 0;
  i18 = i49 + 16 | 0;
  i19 = i49 + 20 | 0;
  i20 = i49 + 24 | 0;
  i21 = i49 + 28 | 0;
  i22 = i49 + 32 | 0;
  i23 = i49 + 36 | 0;
  i24 = i49 + 40 | 0;
  i25 = i49 + 44 | 0;
  i26 = i49 + 48 | 0;
  i27 = i49 + 52 | 0;
  i28 = i49 + 56 | 0;
  i29 = i49 + 60 | 0;
  i30 = i49 + 64 | 0;
  i31 = i49 + 68 | 0;
  i32 = i49 + 72 | 0;
  i33 = i47 + 4 | 0;
  i34 = i47 + 12 | 0;
  i35 = i47 + 16 | 0;
  i36 = i47 + 24 | 0;
  i37 = i47 + 28 | 0;
  i38 = i47 + 40 | 0;
  i39 = i47 + 44 | 0;
  i40 = i58 + 4 | 0;
  i42 = 0;
  do {
   i41 = (HEAP32[i14 >> 2] | 0) + (i42 << 2) | 0;
   HEAP32[i53 >> 2] = 4;
   mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i50 | 0, i53 | 0) | 0;
   if (!(HEAP32[i50 >> 2] | 0)) i1 = 0; else {
    i1 = HEAP32[i40 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 124, gb + 774935 | 0, gb + 774188 | 0, 1218) | 0;
    i13 = HEAP32[i40 >> 2] | 0;
    i64 = i1 + 4 | 0;
    HEAP32[i64 >> 2] = gb + 1576256;
    i63 = i1 + 8 | 0;
    HEAP32[i63 >> 2] = gb + 1576256;
    i62 = i1 + 12 | 0;
    HEAP32[i62 >> 2] = -1;
    i61 = i1 + 16 | 0;
    HEAP32[i61 >> 2] = gb + 1576256;
    i60 = i1 + 20 | 0;
    HEAP32[i60 >> 2] = gb + 1576256;
    i5 = i1 + 24 | 0;
    HEAP32[i5 >> 2] = -1;
    i11 = i1 + 28 | 0;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    HEAP32[i11 + 12 >> 2] = 0;
    HEAP32[i11 + 16 >> 2] = 0;
    HEAP32[i1 >> 2] = gb + 148800 + 8;
    HEAP32[i1 + 48 >> 2] = i13;
    i3 = i1 + 52 | 0;
    HEAP32[i1 + 56 >> 2] = i13;
    HEAP32[i1 + 60 >> 2] = gb + 774956;
    i6 = i1 + 64 | 0;
    HEAP32[i6 >> 2] = 0;
    i4 = i1 + 68 | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i1 + 72 >> 2] = 0;
    HEAP32[i3 >> 2] = gb + 148816 + 8;
    i7 = i1 + 76 | 0;
    HEAP32[i1 + 80 >> 2] = i13;
    HEAP32[i1 + 84 >> 2] = gb + 775e3;
    i12 = i1 + 88 | 0;
    HEAP32[i12 >> 2] = 0;
    i8 = i1 + 92 | 0;
    HEAP32[i8 >> 2] = 0;
    i9 = i1 + 96 | 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i7 >> 2] = gb + 148832 + 8;
    i2 = i1 + 100 | 0;
    HEAP32[i1 + 104 >> 2] = i13;
    HEAP32[i1 + 108 >> 2] = gb + 775041;
    i13 = i1 + 112 | 0;
    HEAP32[i13 >> 2] = 0;
    i10 = i1 + 116 | 0;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i1 + 120 >> 2] = 0;
    HEAP32[i2 >> 2] = gb + 148848 + 8;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i65 = HEAP32[i46 >> 2] | 0;
    HEAP32[i64 >> 2] = mftCall_iii(HEAP32[(HEAP32[i65 >> 2] | 0) + 24 >> 2] | 0, i65 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i64 = HEAP32[i46 >> 2] | 0;
    HEAP32[i63 >> 2] = mftCall_iii(HEAP32[(HEAP32[i64 >> 2] | 0) + 24 >> 2] | 0, i64 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i62 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i62 = HEAP32[i46 >> 2] | 0;
    HEAP32[i61 >> 2] = mftCall_iii(HEAP32[(HEAP32[i62 >> 2] | 0) + 24 >> 2] | 0, i62 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i61 = HEAP32[i46 >> 2] | 0;
    HEAP32[i60 >> 2] = mftCall_iii(HEAP32[(HEAP32[i61 >> 2] | 0) + 24 >> 2] | 0, i61 | 0, HEAP32[i57 >> 2] | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    HEAP32[i5 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i1 + 36 | 0, i53 | 0) | 0;
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i52 | 0, i53 | 0) | 0;
    i5 = HEAP32[i52 >> 2] | 0;
    HEAP32[i49 >> 2] = gb + 148864 + 8;
    HEAP32[i15 >> 2] = gb + 1576256;
    HEAP32[i16 >> 2] = gb + 1576256;
    HEAP32[i17 >> 2] = -1;
    HEAP32[i18 >> 2] = gb + 1576256;
    HEAP32[i19 >> 2] = gb + 1576256;
    HEAP32[i20 >> 2] = -1;
    HEAP32[i21 >> 2] = gb + 1576256;
    HEAP32[i22 >> 2] = gb + 1576256;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i24 >> 2] = -1;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i26 >> 2] = 0;
    HEAP32[i27 >> 2] = gb + 1576256;
    HEAP32[i28 >> 2] = gb + 1576256;
    HEAP32[i29 >> 2] = -1;
    HEAP32[i30 >> 2] = 0;
    HEAP32[i31 >> 2] = 0;
    HEAP32[i32 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS3_(i3, i5, i49);
    if (HEAP32[i4 >> 2] | 0) {
     i3 = 0;
     do {
      i65 = HEAP32[i6 >> 2] | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      i62 = HEAP32[i46 >> 2] | 0;
      HEAP32[i65 + (i3 * 76 | 0) + 52 >> 2] = mftCall_iii(HEAP32[(HEAP32[i62 >> 2] | 0) + 24 >> 2] | 0, i62 | 0, HEAP32[i57 >> 2] | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      i62 = HEAP32[i46 >> 2] | 0;
      HEAP32[i65 + (i3 * 76 | 0) + 56 >> 2] = mftCall_iii(HEAP32[(HEAP32[i62 >> 2] | 0) + 24 >> 2] | 0, i62 | 0, HEAP32[i57 >> 2] | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      HEAP32[i65 + (i3 * 76 | 0) + 60 >> 2] = HEAP32[i57 >> 2];
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i65 + (i3 * 76 | 0) + 64 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i65 + (i3 * 76 | 0) + 68 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i65 + (i3 * 76 | 0) + 72 | 0, i53 | 0) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
      i62 = HEAP32[i57 >> 2] | 0;
      i63 = i65 + (i3 * 76 | 0) + 40 | 0;
      HEAP32[i63 >> 2] = i62;
      i64 = HEAP32[(HEAP32[i58 >> 2] | 0) + 52 >> 2] | 0;
      HEAP32[i48 >> 2] = i62;
      mftCall_viii(i64 | 0, i47 | 0, i58 | 0, i48 | 0);
      i64 = i33;
      i62 = HEAP32[i64 + 4 >> 2] | 0;
      i61 = i65 + (i3 * 76 | 0) + 4 | 0;
      HEAP32[i61 >> 2] = HEAP32[i64 >> 2];
      HEAP32[i61 + 4 >> 2] = i62;
      HEAP32[i65 + (i3 * 76 | 0) + 12 >> 2] = HEAP32[i34 >> 2];
      i61 = i35;
      i62 = HEAP32[i61 + 4 >> 2] | 0;
      i64 = i65 + (i3 * 76 | 0) + 16 | 0;
      HEAP32[i64 >> 2] = HEAP32[i61 >> 2];
      HEAP32[i64 + 4 >> 2] = i62;
      HEAP32[i65 + (i3 * 76 | 0) + 24 >> 2] = HEAP32[i36 >> 2];
      i64 = i65 + (i3 * 76 | 0) + 28 | 0;
      HEAP32[i64 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i64 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i64 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      HEAP32[i63 >> 2] = HEAP32[i38 >> 2];
      i63 = i39;
      i64 = HEAP32[i63 + 4 >> 2] | 0;
      i65 = i65 + (i3 * 76 | 0) + 44 | 0;
      HEAP32[i65 >> 2] = HEAP32[i63 >> 2];
      HEAP32[i65 + 4 >> 2] = i64;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
    }
    HEAP32[i53 >> 2] = 4;
    mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i57 | 0, i53 | 0) | 0;
    i65 = HEAP32[i57 >> 2] | 0;
    HEAP32[i47 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE6resizeEjRKj(i2, i65, i47);
    if (!(HEAP32[i10 >> 2] | 0)) i3 = 0; else {
     i2 = 0;
     do {
      i3 = (HEAP32[i13 >> 2] | 0) + (i2 << 2) | 0;
      HEAP32[i53 >> 2] = 4;
      mftCall_iiii(HEAP32[(HEAP32[i51 >> 2] | 0) + 8 >> 2] | 0, i51 | 0, i3 | 0, i53 | 0) | 0;
      i2 = i2 + 1 | 0;
      i3 = HEAP32[i10 >> 2] | 0;
     } while (i2 >>> 0 < i3 >>> 0);
    }
    i2 = HEAP32[i8 >> 2] | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) != (i5 | 0)) {
     HEAP32[i8 >> 2] = 0;
     if (!i5) i2 = 0; else {
      i2 = 0;
      i4 = 0;
      do {
       i3 = HEAP32[i6 >> 2] | 0;
       if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
        i65 = HEAP32[i12 >> 2] | 0;
        HEAP32[i65 + (i2 * 76 | 0) >> 2] = gb + 148864 + 8;
        i64 = i3 + (i4 * 76 | 0) + 4 | 0;
        i63 = HEAP32[i64 + 4 >> 2] | 0;
        i62 = i65 + (i2 * 76 | 0) + 4 | 0;
        HEAP32[i62 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i62 + 4 >> 2] = i63;
        HEAP32[i65 + (i2 * 76 | 0) + 12 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 12 >> 2];
        i62 = i3 + (i4 * 76 | 0) + 16 | 0;
        i63 = HEAP32[i62 + 4 >> 2] | 0;
        i64 = i65 + (i2 * 76 | 0) + 16 | 0;
        HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
        HEAP32[i64 + 4 >> 2] = i63;
        HEAP32[i65 + (i2 * 76 | 0) + 24 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 24 >> 2];
        i64 = i65 + (i2 * 76 | 0) + 28 | 0;
        i63 = i3 + (i4 * 76 | 0) + 28 | 0;
        HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
        HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
        HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
        HEAP32[i65 + (i2 * 76 | 0) + 40 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 40 >> 2];
        i64 = i3 + (i4 * 76 | 0) + 44 | 0;
        i63 = HEAP32[i64 + 4 >> 2] | 0;
        i62 = i65 + (i2 * 76 | 0) + 44 | 0;
        HEAP32[i62 >> 2] = HEAP32[i64 >> 2];
        HEAP32[i62 + 4 >> 2] = i63;
        i62 = i3 + (i4 * 76 | 0) + 52 | 0;
        i63 = HEAP32[i62 + 4 >> 2] | 0;
        i64 = i65 + (i2 * 76 | 0) + 52 | 0;
        HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
        HEAP32[i64 + 4 >> 2] = i63;
        HEAP32[i65 + (i2 * 76 | 0) + 60 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 60 >> 2];
        i2 = i65 + (i2 * 76 | 0) + 64 | 0;
        i65 = i3 + (i4 * 76 | 0) + 64 | 0;
        HEAP32[i2 >> 2] = HEAP32[i65 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
        i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
        HEAP32[i8 >> 2] = i2;
       } else {
        __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i7, i3 + (i4 * 76 | 0) | 0) | 0;
        i2 = HEAP32[i8 >> 2] | 0;
       }
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i5 | 0));
      i3 = HEAP32[i10 >> 2] | 0;
     }
    }
    i65 = HEAP32[i12 >> 2] | 0;
    HEAP32[i11 >> 2] = i65;
    HEAP32[i1 + 32 >> 2] = i65 + (i2 * 76 | 0);
    i65 = HEAP32[i13 >> 2] | 0;
    HEAP32[i1 + 40 >> 2] = i65;
    HEAP32[i1 + 44 >> 2] = i65 + (i3 << 2);
   }
   HEAP32[i41 >> 2] = i1;
   i42 = i42 + 1 | 0;
  } while (i42 >>> 0 < (HEAP32[i43 >> 2] | 0) >>> 0);
 }
 i15 = i58 + 8 | 0;
 i1 = HEAP32[i58 + 40 >> 2] | 0;
 if (i1 | 0) {
  i7 = i58 + 56 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i58 + 32 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i58 + 36 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i58 + 28 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i58 + 48 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i14 = i58 + 60 | 0;
 i1 = HEAP32[i58 + 92 >> 2] | 0;
 if (i1 | 0) {
  i7 = i58 + 108 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i58 + 84 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i58 + 88 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i58 + 80 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i58 + 100 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i13 = i58 + 164 | 0;
 i1 = HEAP32[i58 + 196 >> 2] | 0;
 if (i1 | 0) {
  i7 = i58 + 212 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i58 + 188 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i58 + 192 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i58 + 184 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i58 + 204 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = HEAP32[i44 >> 2] | 0;
 if (i1 | 0) {
  i10 = i58 + 124 | 0;
  i11 = i57 + 832 | 0;
  i9 = i58 + 148 | 0;
  i12 = i56 + 8 | 0;
  i8 = 0;
  do {
   i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   if (i2) {
    i7 = i2 + 4 | 0;
    __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i15, HEAP32[i7 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, i2);
    i6 = HEAP32[(HEAP32[i58 >> 2] | 0) + 64 >> 2] | 0;
    i5 = i2 + 12 | 0;
    HEAP32[i54 >> 2] = HEAP32[i5 >> 2];
    i6 = mftCall_iii(i6 | 0, i58 | 0, i54 | 0) | 0;
    i1 = i57;
    do {
     HEAP32[i1 >> 2] = gb + 148864 + 8;
     HEAP32[i1 + 4 >> 2] = gb + 1576256;
     HEAP32[i1 + 8 >> 2] = gb + 1576256;
     HEAP32[i1 + 12 >> 2] = -1;
     HEAP32[i1 + 16 >> 2] = gb + 1576256;
     HEAP32[i1 + 20 >> 2] = gb + 1576256;
     HEAP32[i1 + 24 >> 2] = -1;
     HEAP32[i1 + 28 >> 2] = gb + 1576256;
     HEAP32[i1 + 32 >> 2] = gb + 1576256;
     HEAP32[i1 + 36 >> 2] = 0;
     HEAP32[i1 + 40 >> 2] = -1;
     HEAP32[i1 + 44 >> 2] = 0;
     HEAP32[i1 + 48 >> 2] = 0;
     i1 = i1 + 52 | 0;
    } while ((i1 | 0) != (i11 | 0));
    if (i6 | 0) {
     i3 = 0;
     do {
      i2 = HEAP32[(HEAP32[i58 >> 2] | 0) + 68 >> 2] | 0;
      HEAP32[i55 >> 2] = HEAP32[i5 >> 2];
      i2 = mftCall_iiiiii(i2 | 0, i58 | 0, i55 | 0, i57 | 0, 16, i3 | 0) | 0;
      i3 = i2 + i3 | 0;
      if (i2 | 0) {
       i4 = 0;
       do {
        i1 = HEAP32[i57 + (i4 * 52 | 0) + 40 >> 2] | 0;
        do if ((i1 | 0) > -1) {
         if ((HEAP32[i45 >> 2] | 0) <= (i1 | 0)) break;
         i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
         if (!i1) break;
         i65 = HEAP32[i1 + 16 >> 2] | 0;
         i62 = i7;
         i63 = HEAP32[i62 + 4 >> 2] | 0;
         i64 = i56;
         HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
         HEAP32[i64 + 4 >> 2] = i63;
         HEAP32[i12 >> 2] = i65;
         HEAP32[i53 >> 2] = HEAP32[i56 >> 2];
         HEAP32[i53 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
         HEAP32[i53 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
         __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_(i14, i53, i1);
        } while (0);
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i2 | 0));
      }
     } while (i3 >>> 0 < i6 >>> 0);
    }
    i1 = HEAP32[i44 >> 2] | 0;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i1 >>> 0);
 }
 if (!(HEAP32[i43 >> 2] | 0)) {
  STACKTOP = i59;
  return i58 | 0;
 }
 i1 = i58 + 228 | 0;
 i2 = 0;
 do {
  i65 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i13, HEAP32[i65 + 16 >> 2] | 0, HEAP32[i65 + 20 >> 2] | 0, i65);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i43 >> 2] | 0) >>> 0);
 STACKTOP = i59;
 return i58 | 0;
}

function __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_(i36, i37, i2, i3, i4, i40, i30, i31, i32, i33, i1) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i40 = i40 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i34 = 0, i35 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i41 + 96 | 0;
 i35 = i41 + 104 | 0;
 i48 = i41 + 88 | 0;
 i38 = i41 + 80 | 0;
 i25 = i41 + 76 | 0;
 i26 = i41 + 504 | 0;
 i27 = i41 + 72 | 0;
 i28 = i41 + 68 | 0;
 i42 = i41 + 56 | 0;
 i43 = i41 + 44 | 0;
 i44 = i41 + 32 | 0;
 i45 = i41 + 20 | 0;
 i46 = i41 + 8 | 0;
 i29 = i41 + 4 | 0;
 i39 = i41;
 HEAP32[i24 >> 2] = i1;
 HEAP32[i48 >> 2] = i35;
 i47 = i48 + 4 | 0;
 HEAP32[i47 >> 2] = fb + 4003;
 HEAP32[i38 >> 2] = i35;
 HEAP32[i25 >> 2] = i35 + 400;
 HEAP32[i42 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i42 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i43 >> 2] = 0;
 HEAP32[i43 + 4 >> 2] = 0;
 HEAP32[i43 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i43 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i44 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i45 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i45 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i46 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_viiiiiiiiii(fb + 12 | 0, i2 | 0, i3 | 0, i26 | 0, i27 | 0, i28 | 0, i42 | 0, i43 | 0, i44 | 0, i45 | 0, i29 | 0);
 i35 = __THREW__;
 __THREW__ = 0;
 L21 : do if (i35 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i33 >> 2] = HEAP32[i32 >> 2];
  i20 = i44 + 8 + 3 | 0;
  i21 = i44 + 4 | 0;
  i22 = i45 + 8 + 3 | 0;
  i23 = i45 + 4 | 0;
  i12 = (i4 & 512 | 0) != 0;
  i13 = i43 + 8 + 3 | 0;
  i14 = i43 + 4 | 0;
  i15 = i46 + 8 + 3 | 0;
  i16 = i46 + 4 | 0;
  i17 = i26 + 3 | 0;
  i18 = i42 + 11 | 0;
  i19 = i42 + 4 | 0;
  i35 = 0;
  i11 = 0;
  L24 : while (1) {
   if (i11 >>> 0 >= 4) {
    i34 = 262;
    break;
   }
   i1 = HEAP32[i36 >> 2] | 0;
   do if (!i1) i3 = 1; else {
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i34 = 36;
      break L24;
     }
    } else i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i36 >> 2] = 0;
     i3 = 1;
     break;
    } else {
     i3 = (HEAP32[i36 >> 2] | 0) == 0;
     break;
    }
   } while (0);
   i2 = HEAP32[i37 >> 2] | 0;
   do if (!i2) i34 = 32; else {
    i1 = HEAP32[i2 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i34 = 36;
      break L24;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i37 >> 2] = 0;
     i34 = 32;
     break;
    } else if (i3) {
     i10 = i2;
     break;
    } else {
     i34 = 262;
     break L24;
    }
   } while (0);
   if ((i34 | 0) == 32) {
    i34 = 0;
    if (i3) {
     i34 = 262;
     break;
    } else i10 = 0;
   }
   L49 : do switch (HEAP8[i26 + i11 >> 0] | 0) {
   case 1:
    {
     if ((i11 | 0) == 3) i1 = i35; else {
      i2 = HEAP32[i36 >> 2] | 0;
      i1 = HEAP32[i2 + 12 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
       i34 = __THREW__;
       __THREW__ = 0;
       if (i34 & 1) {
        i34 = 36;
        break L24;
       }
      } else i1 = HEAP32[i1 >> 2] | 0;
      __THREW__ = 0;
      i1 = invoke_iiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, 8192, i1 | 0) | 0;
      i34 = __THREW__;
      __THREW__ = 0;
      if (i34 & 1) {
       i34 = 36;
       break L24;
      }
      if (!i1) {
       i34 = 49;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i34 = __THREW__;
       __THREW__ = 0;
       if (i34 & 1) {
        i34 = 36;
        break L24;
       }
      } else {
       HEAP32[i2 >> 2] = i3 + 4;
       i1 = HEAP32[i3 >> 2] | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i46 | 0, i1 | 0);
      i34 = __THREW__;
      __THREW__ = 0;
      if (i34 & 1) {
       i34 = 36;
       break L24;
      } else {
       i1 = i10;
       i4 = i10;
       i34 = 51;
      }
     }
     break;
    }
   case 0:
    {
     if ((i11 | 0) == 3) i1 = i35; else {
      i1 = i10;
      i4 = i10;
      i34 = 51;
     }
     break;
    }
   case 3:
    {
     i4 = HEAP8[i20 >> 0] | 0;
     i1 = i4 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i4 & 255;
     i3 = HEAP8[i22 >> 0] | 0;
     i5 = i3 << 24 >> 24 < 0 ? HEAP32[i23 >> 2] | 0 : i3 & 255;
     if ((i1 | 0) == (0 - i5 | 0)) i1 = i35; else {
      if (!i1) {
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 36;
         break L24;
        }
        i4 = HEAP8[i22 >> 0] | 0;
       } else {
        i1 = HEAP32[i2 >> 2] | 0;
        i4 = i3;
       }
       if ((i1 | 0) != (HEAP32[(i4 << 24 >> 24 < 0 ? HEAP32[i45 >> 2] | 0 : i45) >> 2] | 0)) {
        i1 = i35;
        break L49;
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 36;
         break L24;
        }
        i1 = HEAP8[i22 >> 0] | 0;
       } else {
        HEAP32[i2 >> 2] = i3 + 4;
        i1 = i4;
       }
       HEAP8[i30 >> 0] = 1;
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i23 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i45 : i35;
       break L49;
      }
      i3 = HEAP32[i36 >> 2] | 0;
      i6 = HEAP32[i3 + 12 >> 2] | 0;
      i2 = HEAP32[i3 + 16 >> 2] | 0;
      i1 = (i6 | 0) == (i2 | 0);
      if (!i5) {
       if (i1) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 36;
         break L24;
        }
        i4 = HEAP8[i20 >> 0] | 0;
       } else i1 = HEAP32[i6 >> 2] | 0;
       if ((i1 | 0) != (HEAP32[(i4 << 24 >> 24 < 0 ? HEAP32[i44 >> 2] | 0 : i44) >> 2] | 0)) {
        HEAP8[i30 >> 0] = 1;
        i1 = i35;
        break L49;
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 36;
         break L24;
        }
        i1 = HEAP8[i20 >> 0] | 0;
       } else {
        HEAP32[i2 >> 2] = i3 + 4;
        i1 = i4;
       }
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i44 : i35;
       break L49;
      }
      if (i1) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 36;
        break L24;
       }
       i2 = HEAP32[i36 >> 2] | 0;
       i4 = HEAP8[i20 >> 0] | 0;
       i7 = i2;
       i5 = HEAP32[i2 + 12 >> 2] | 0;
       i2 = HEAP32[i2 + 16 >> 2] | 0;
      } else {
       i1 = HEAP32[i6 >> 2] | 0;
       i7 = i3;
       i5 = i6;
      }
      i3 = i7 + 12 | 0;
      i2 = (i5 | 0) == (i2 | 0);
      if ((i1 | 0) == (HEAP32[(i4 << 24 >> 24 < 0 ? HEAP32[i44 >> 2] | 0 : i44) >> 2] | 0)) {
       if (i2) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0, i7 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 36;
         break L24;
        }
        i1 = HEAP8[i20 >> 0] | 0;
       } else {
        HEAP32[i3 >> 2] = i5 + 4;
        i1 = i4;
       }
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i44 : i35;
       break L49;
      }
      if (i2) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 36;
        break L24;
       }
      } else i1 = HEAP32[i5 >> 2] | 0;
      i4 = HEAP8[i22 >> 0] | 0;
      if ((i1 | 0) != (HEAP32[(i4 << 24 >> 24 < 0 ? HEAP32[i45 >> 2] | 0 : i45) >> 2] | 0)) {
       i34 = 118;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 36;
        break L24;
       }
       i1 = HEAP8[i22 >> 0] | 0;
      } else {
       HEAP32[i2 >> 2] = i3 + 4;
       i1 = i4;
      }
      HEAP8[i30 >> 0] = 1;
      i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i23 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i45 : i35;
     }
     break;
    }
   case 2:
    {
     if (!(i11 >>> 0 < 2 | (i35 | 0) != 0)) if (!(i12 | (i11 | 0) == 2 & (HEAP8[i17 >> 0] | 0) != 0)) {
      i1 = 0;
      break L49;
     }
     i3 = HEAP8[i13 >> 0] | 0;
     i2 = HEAP32[i43 >> 2] | 0;
     i1 = i3 << 24 >> 24 < 0 ? i2 : i43;
     L122 : do if (!i11) {
      i9 = i10;
      i4 = i1;
      i1 = i3;
      i3 = i10;
     } else if ((HEAPU8[i26 + (i11 + -1) >> 0] | 0) < 2) {
      i8 = i1;
      i1 = i3;
      while (1) {
       i9 = i1 << 24 >> 24 < 0;
       i3 = i8;
       if ((i3 | 0) == ((i9 ? i2 : i43) + ((i9 ? HEAP32[i14 >> 2] | 0 : i1 & 255) << 2) | 0)) break;
       __THREW__ = 0;
       i1 = invoke_iiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, 8192, HEAP32[i3 >> 2] | 0) | 0;
       i9 = __THREW__;
       __THREW__ = 0;
       if (i9 & 1) {
        i34 = 128;
        break L24;
       }
       if (!i1) {
        i34 = 126;
        break;
       }
       i8 = i3 + 4 | 0;
       i1 = HEAP8[i13 >> 0] | 0;
       i2 = HEAP32[i43 >> 2] | 0;
      }
      if ((i34 | 0) == 126) {
       i34 = 0;
       i1 = HEAP8[i13 >> 0] | 0;
       i2 = HEAP32[i43 >> 2] | 0;
      }
      i4 = i1 << 24 >> 24 < 0 ? i2 : i43;
      i7 = i4;
      i6 = i8 - i7 >> 2;
      i5 = HEAP8[i15 >> 0] | 0;
      i3 = i5 << 24 >> 24 < 0;
      i5 = i3 ? HEAP32[i16 >> 2] | 0 : i5 & 255;
      if (i6 >>> 0 > i5 >>> 0) {
       i9 = i10;
       i4 = i7;
       i3 = i10;
      } else {
       i5 = (i3 ? HEAP32[i46 >> 2] | 0 : i46) + (i5 << 2) | 0;
       i3 = i5 + (0 - i6 << 2) | 0;
       while (1) {
        if ((i3 | 0) == (i5 | 0)) {
         i9 = i10;
         i4 = i8;
         i3 = i10;
         break L122;
        }
        if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i4 >> 2] | 0)) {
         i9 = i10;
         i4 = i7;
         i3 = i10;
         break L122;
        }
        i4 = i4 + 4 | 0;
        i3 = i3 + 4 | 0;
       }
      }
     } else {
      i9 = i10;
      i4 = i1;
      i1 = i3;
      i3 = i10;
     } while (0);
     L137 : while (1) {
      i6 = i1 << 24 >> 24 < 0;
      i1 = (i6 ? i2 : i43) + ((i6 ? HEAP32[i14 >> 2] | 0 : i1 & 255) << 2) | 0;
      i6 = i4;
      if ((i6 | 0) == (i1 | 0)) break;
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i2 = 1; else {
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 158;
         break L24;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i2 = 1;
        break;
       } else {
        i2 = (HEAP32[i36 >> 2] | 0) == 0;
        break;
       }
      } while (0);
      do if (!i3) {
       i1 = i9;
       i34 = 148;
      } else {
       i1 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 158;
         break L24;
        }
       } else i1 = HEAP32[i1 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i1 = 0;
        i34 = 148;
        break;
       } else if (i2 ^ (i9 | 0) == 0) {
        i1 = i9;
        i5 = i9;
        break;
       } else {
        i1 = i6;
        break L137;
       }
      } while (0);
      if ((i34 | 0) == 148) {
       i34 = 0;
       if (i2) {
        i1 = i6;
        break;
       } else i5 = 0;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = HEAP32[i2 + 12 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 158;
        break L24;
       }
      } else i2 = HEAP32[i3 >> 2] | 0;
      if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
       i1 = i6;
       break;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 159;
        break L24;
       }
      } else HEAP32[i3 >> 2] = i4 + 4;
      i9 = i1;
      i4 = i6 + 4 | 0;
      i1 = HEAP8[i13 >> 0] | 0;
      i2 = HEAP32[i43 >> 2] | 0;
      i3 = i5;
     }
     if (i12) {
      i10 = HEAP8[i13 >> 0] | 0;
      i9 = i10 << 24 >> 24 < 0;
      if ((i1 | 0) == ((i9 ? HEAP32[i43 >> 2] | 0 : i43) + ((i9 ? HEAP32[i14 >> 2] | 0 : i10 & 255) << 2) | 0)) i1 = i35; else {
       i34 = 162;
       break L24;
      }
     } else i1 = i35;
     break;
    }
   case 4:
    {
     i7 = 0;
     i1 = i10;
     i4 = i10;
     L173 : while (1) {
      i2 = HEAP32[i36 >> 2] | 0;
      do if (!i2) i3 = 1; else {
       i3 = HEAP32[i2 + 12 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 187;
         break L24;
        }
       } else i2 = HEAP32[i3 >> 2] | 0;
       if ((i2 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i3 = 1;
        break;
       } else {
        i3 = (HEAP32[i36 >> 2] | 0) == 0;
        break;
       }
      } while (0);
      do if (!i4) i34 = 176; else {
       i2 = HEAP32[i4 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 187;
         break L24;
        }
       } else i2 = HEAP32[i2 >> 2] | 0;
       if ((i2 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i1 = 0;
        i34 = 176;
        break;
       } else if (i3 ^ (i1 | 0) == 0) {
        i5 = i1;
        i6 = i1;
        break;
       } else {
        i4 = i1;
        break L173;
       }
      } while (0);
      if ((i34 | 0) == 176) {
       i34 = 0;
       if (i3) {
        i4 = i1;
        break;
       } else {
        i5 = i1;
        i6 = 0;
       }
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 187;
        break L24;
       }
      } else i1 = HEAP32[i2 >> 2] | 0;
      __THREW__ = 0;
      i2 = invoke_iiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, 2048, i1 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i34 = 189;
       break L24;
      }
      if (i2) {
       i2 = HEAP32[i33 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i24 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1044 | 0, i32 | 0, i33 | 0, i24 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 189;
         break L24;
        }
        i2 = HEAP32[i33 >> 2] | 0;
       }
       HEAP32[i33 >> 2] = i2 + 4;
       HEAP32[i2 >> 2] = i1;
       i1 = i7 + 1 | 0;
      } else {
       i10 = HEAP8[i18 >> 0] | 0;
       if (!((i1 | 0) == (HEAP32[i28 >> 2] | 0) & (i7 | 0 ? ((i10 << 24 >> 24 < 0 ? HEAP32[i19 >> 2] | 0 : i10 & 255) | 0) != 0 : 0))) {
        i4 = i5;
        break;
       }
       i1 = HEAP32[i38 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i25 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1043 | 0, i48 | 0, i38 | 0, i25 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 189;
         break L24;
        }
        i1 = HEAP32[i38 >> 2] | 0;
       }
       HEAP32[i38 >> 2] = i1 + 4;
       HEAP32[i1 >> 2] = i7;
       i1 = 0;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 187;
        break L24;
       } else {
        i7 = i1;
        i1 = i5;
        i4 = i6;
        continue;
       }
      } else {
       HEAP32[i3 >> 2] = i4 + 4;
       i7 = i1;
       i1 = i5;
       i4 = i6;
       continue;
      }
     }
     i1 = HEAP32[i38 >> 2] | 0;
     if (i7 | 0 ? (HEAP32[i48 >> 2] | 0) != (i1 | 0) : 0) {
      if ((i1 | 0) == (HEAP32[i25 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_viii(fb + 1043 | 0, i48 | 0, i38 | 0, i25 | 0);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 188;
        break L24;
       }
       i1 = HEAP32[i38 >> 2] | 0;
      }
      HEAP32[i38 >> 2] = i1 + 4;
      HEAP32[i1 >> 2] = i7;
     }
     L226 : do if ((HEAP32[i29 >> 2] | 0) > 0) {
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i2 = 1; else {
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 188;
         break L24;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i2 = 1;
        break;
       } else {
        i2 = (HEAP32[i36 >> 2] | 0) == 0;
        break;
       }
      } while (0);
      do if (!i4) i34 = 218; else {
       i1 = HEAP32[i4 + 12 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 188;
         break L24;
        }
       } else i1 = HEAP32[i1 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i34 = 218;
        break;
       } else if (i2) break; else {
        i34 = 224;
        break L24;
       }
      } while (0);
      if ((i34 | 0) == 218) {
       i34 = 0;
       if (i2) {
        i34 = 224;
        break L24;
       } else i4 = 0;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 188;
        break L24;
       }
      } else i1 = HEAP32[i2 >> 2] | 0;
      if ((i1 | 0) != (HEAP32[i27 >> 2] | 0)) {
       i34 = 224;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 188;
        break L24;
       } else i1 = i4;
      } else {
       HEAP32[i2 >> 2] = i3 + 4;
       i1 = i4;
      }
      while (1) {
       if ((HEAP32[i29 >> 2] | 0) <= 0) break L226;
       i2 = HEAP32[i36 >> 2] | 0;
       do if (!i2) i3 = 1; else {
        i3 = HEAP32[i2 + 12 >> 2] | 0;
        if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
         i10 = __THREW__;
         __THREW__ = 0;
         if (i10 & 1) {
          i34 = 186;
          break L24;
         }
        } else i2 = HEAP32[i3 >> 2] | 0;
        if ((i2 | 0) == -1) {
         HEAP32[i36 >> 2] = 0;
         i3 = 1;
         break;
        } else {
         i3 = (HEAP32[i36 >> 2] | 0) == 0;
         break;
        }
       } while (0);
       do if (!i4) i34 = 242; else {
        i2 = HEAP32[i4 + 12 >> 2] | 0;
        if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
         __THREW__ = 0;
         i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
         i10 = __THREW__;
         __THREW__ = 0;
         if (i10 & 1) {
          i34 = 186;
          break L24;
         }
        } else i2 = HEAP32[i2 >> 2] | 0;
        if ((i2 | 0) == -1) {
         HEAP32[i37 >> 2] = 0;
         i1 = 0;
         i34 = 242;
         break;
        } else if (i3 ^ (i1 | 0) == 0) {
         i5 = i1;
         i4 = i1;
         break;
        } else {
         i34 = 249;
         break L24;
        }
       } while (0);
       if ((i34 | 0) == 242) {
        i34 = 0;
        if (i3) {
         i34 = 249;
         break L24;
        } else {
         i5 = i1;
         i4 = 0;
        }
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 186;
         break L24;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, 2048, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i34 = 186;
        break L24;
       }
       if (!i1) {
        i34 = 249;
        break L24;
       }
       if ((HEAP32[i33 >> 2] | 0) == (HEAP32[i24 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1044 | 0, i32 | 0, i33 | 0, i24 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 186;
         break L24;
        }
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 186;
         break L24;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       i2 = HEAP32[i33 >> 2] | 0;
       HEAP32[i33 >> 2] = i2 + 4;
       HEAP32[i2 >> 2] = i1;
       HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + -1;
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i34 = 186;
         break L24;
        } else {
         i1 = i5;
         continue;
        }
       } else {
        HEAP32[i2 >> 2] = i3 + 4;
        i1 = i5;
        continue;
       }
      }
     } while (0);
     if ((HEAP32[i33 >> 2] | 0) == (HEAP32[i32 >> 2] | 0)) {
      i34 = 259;
      break L24;
     } else i1 = i35;
     break;
    }
   default:
    i1 = i35;
   } while (0);
   L300 : do if ((i34 | 0) == 51) while (1) {
    i34 = 0;
    i2 = HEAP32[i36 >> 2] | 0;
    do if (!i2) i3 = 1; else {
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i34 = 35;
       break L24;
      }
     } else i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == -1) {
      HEAP32[i36 >> 2] = 0;
      i3 = 1;
      break;
     } else {
      i3 = (HEAP32[i36 >> 2] | 0) == 0;
      break;
     }
    } while (0);
    do if (!i4) i34 = 64; else {
     i2 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i34 = 35;
       break L24;
      }
     } else i2 = HEAP32[i2 >> 2] | 0;
     if ((i2 | 0) == -1) {
      HEAP32[i37 >> 2] = 0;
      i1 = 0;
      i34 = 64;
      break;
     } else if (i3 ^ (i1 | 0) == 0) {
      i5 = i1;
      i4 = i1;
      break;
     } else {
      i1 = i35;
      break L300;
     }
    } while (0);
    if ((i34 | 0) == 64) {
     i34 = 0;
     if (i3) {
      i1 = i35;
      break L300;
     } else {
      i5 = i1;
      i4 = 0;
     }
    }
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i34 = 35;
      break L24;
     }
    } else i1 = HEAP32[i2 >> 2] | 0;
    __THREW__ = 0;
    i1 = invoke_iiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, 8192, i1 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i34 = 35;
     break L24;
    }
    if (!i1) {
     i1 = i35;
     break L300;
    }
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i34 = __THREW__;
     __THREW__ = 0;
     if (i34 & 1) {
      i34 = 35;
      break L24;
     }
    } else {
     HEAP32[i2 >> 2] = i3 + 4;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4513 | 0, i46 | 0, i1 | 0);
    i34 = __THREW__;
    __THREW__ = 0;
    if (i34 & 1) {
     i34 = 35;
     break L24;
    } else {
     i1 = i5;
     i34 = 51;
    }
   } while (0);
   i35 = i1;
   i11 = i11 + 1 | 0;
  }
  L336 : switch (i34 | 0) {
  case 35:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 37;
    break;
   }
  case 36:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 37;
    break;
   }
  case 49:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 118:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 128:
   {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L21;
   }
  case 158:
   {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L21;
   }
  case 159:
   {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L21;
   }
  case 162:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 186:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 260;
    break;
   }
  case 187:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 260;
    break;
   }
  case 188:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 260;
    break;
   }
  case 189:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i34 = 260;
    break;
   }
  case 224:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 249:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 259:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i34 = 298;
    break;
   }
  case 262:
   {
    L338 : do if (i35 | 0) {
     i5 = i35 + 8 + 3 | 0;
     i6 = i35 + 4 | 0;
     i4 = 1;
     L340 : while (1) {
      i1 = HEAP8[i5 >> 0] | 0;
      if (i1 << 24 >> 24 < 0) i1 = HEAP32[i6 >> 2] | 0; else i1 = i1 & 255;
      if (i4 >>> 0 >= i1 >>> 0) break L338;
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i3 = 1; else {
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i33 = __THREW__;
        __THREW__ = 0;
        if (i33 & 1) {
         i34 = 290;
         break L340;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i3 = 1;
        break;
       } else {
        i3 = (HEAP32[i36 >> 2] | 0) == 0;
        break;
       }
      } while (0);
      i1 = HEAP32[i37 >> 2] | 0;
      do if (!i1) i34 = 281; else {
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i33 = __THREW__;
        __THREW__ = 0;
        if (i33 & 1) {
         i34 = 290;
         break L340;
        }
       } else i1 = HEAP32[i2 >> 2] | 0;
       if ((i1 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i34 = 281;
        break;
       } else if (i3) break; else {
        i34 = 289;
        break L340;
       }
      } while (0);
      if ((i34 | 0) == 281) {
       i34 = 0;
       if (i3) {
        i34 = 289;
        break;
       }
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i34 = 290;
        break;
       }
      } else i1 = HEAP32[i2 >> 2] | 0;
      if ((HEAP8[i5 >> 0] | 0) < 0) i2 = HEAP32[i35 >> 2] | 0; else i2 = i35;
      if ((i1 | 0) != (HEAP32[i2 + (i4 << 2) >> 2] | 0)) {
       i34 = 289;
       break;
      }
      i1 = i4 + 1 | 0;
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i34 = 290;
        break;
       } else {
        i4 = i1;
        continue;
       }
      } else {
       HEAP32[i3 >> 2] = i4 + 4;
       i4 = i1;
       continue;
      }
     }
     if ((i34 | 0) == 289) {
      HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
      i2 = 0;
      i34 = 298;
      break L336;
     } else if ((i34 | 0) == 290) {
      i2 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break L21;
     }
    } while (0);
    i2 = HEAP32[i48 >> 2] | 0;
    i1 = HEAP32[i38 >> 2] | 0;
    if ((i2 | 0) == (i1 | 0)) {
     i2 = 1;
     i34 = 298;
    } else {
     HEAP32[i39 >> 2] = 0;
     __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i42, i2, i1, i39);
     if (!(HEAP32[i39 >> 2] | 0)) {
      i2 = 1;
      i34 = 298;
      break;
     } else {
      HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
      i2 = 0;
      i34 = 298;
      break;
     }
    }
    break;
   }
  }
  if ((i34 | 0) == 37) {
   i2 = i1;
   break;
  } else if ((i34 | 0) == 260) {
   i2 = i1;
   break;
  } else if ((i34 | 0) == 298) {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i46);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i45);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i44);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i43);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
   i1 = HEAP32[i48 >> 2] | 0;
   HEAP32[i48 >> 2] = 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(HEAP32[i47 >> 2] | 0, i1 | 0);
    i48 = __THREW__;
    __THREW__ = 0;
    if (i48 & 1) {
     i48 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i48);
    }
   }
   STACKTOP = i41;
   return i2 | 0;
  }
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i46);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i45);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i44);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i43);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
 i1 = HEAP32[i48 >> 2] | 0;
 HEAP32[i48 >> 2] = 0;
 if (i1 | 0) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i47 >> 2] | 0, i1 | 0);
  i48 = __THREW__;
  __THREW__ = 0;
  if (i48 & 1) {
   i48 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i48);
  }
 }
 ___resumeException(i2 | 0);
 return 0;
}

function __ZN22RenderingCommandBuffer20ExecuteCommandBufferER17ShaderPassContextRK15RenderNodeQueue(i42, i43, i46) {
 i42 = i42 | 0;
 i43 = i43 | 0;
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, f77 = f0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i64 = i69 + 408 | 0;
 i60 = i69 + 48 | 0;
 i53 = i69 + 32 | 0;
 i55 = i69 + 24 | 0;
 i54 = i69 + 16 | 0;
 i52 = i69 + 8 | 0;
 i51 = i69;
 i47 = i69 + 368 | 0;
 i48 = i69 + 360 | 0;
 i41 = i69 + 328 | 0;
 i66 = i69 + 128 | 0;
 i67 = i69 + 96 | 0;
 i68 = i69 + 64 | 0;
 i49 = i69 + 404 | 0;
 i50 = i69 + 400 | 0;
 i65 = i69 + 364 | 0;
 i44 = HEAP32[i42 + 24 >> 2] | 0;
 if (!i44) {
  STACKTOP = i69;
  return;
 }
 i3 = i42 + 164 | 0;
 i45 = i3 + 11 | 0;
 if ((HEAP8[i45 >> 0] | 0) < 0) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
 i1 = __Z26profiler_get_info_for_namePKc13ProfilerGroup(i1, 0) | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i47 >> 2] = 0;
  HEAP32[i64 >> 2] = HEAP32[i47 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i64);
  i62 = i1;
 } else i62 = 0;
 i40 = HEAP32[i1 >> 2] | 0;
 i61 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i61 >> 2] | 0) + 648 >> 2] | 0, i61 | 0, i40 | 0);
 i40 = __Z12GetGfxDevicev() | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i66, __Z12GetGfxDevicev() | 0);
 i61 = mftCall_ii(HEAP32[(HEAP32[i40 >> 2] | 0) + 356 >> 2] | 0, i40 | 0) | 0;
 HEAP32[i67 >> 2] = 0;
 HEAP32[i67 + 4 >> 2] = 0;
 HEAP32[i67 + 8 >> 2] = 0;
 HEAP32[i67 + 12 >> 2] = 0;
 HEAP32[i67 + 16 >> 2] = 0;
 HEAP32[i67 + 20 >> 2] = 0;
 HEAP32[i67 + 24 >> 2] = 0;
 HEAP32[i67 + 28 >> 2] = 0;
 if ((i61 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i67 + (i1 << 2) >> 2] = mftCall_iii(HEAP32[(HEAP32[i40 >> 2] | 0) + 348 >> 2] | 0, i40 | 0, i1 | 0) | 0;
   HEAP32[i68 + (i1 << 2) >> 2] = __ZN13RenderTexture9GetActiveEi(i1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i61 | 0));
 }
 i56 = mftCall_ii(HEAP32[(HEAP32[i40 >> 2] | 0) + 352 >> 2] | 0, i40 | 0) | 0;
 i57 = HEAP32[i40 + 4196 >> 2] | 0;
 i58 = i43 + 148 | 0;
 i59 = HEAP8[i58 >> 0] | 0;
 HEAP8[i58 >> 0] = 1;
 i18 = i42 + 16 | 0;
 f19 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i20 = i43 + 4 | 0;
 i21 = i43 + 8 | 0;
 i22 = i43 + 12 | 0;
 i23 = i43 + 16 | 0;
 i24 = i43 + 20 | 0;
 i25 = i43 + 24 | 0;
 i26 = i43 + 28 | 0;
 i27 = i43 + 32 | 0;
 i28 = i47 + 4 | 0;
 i29 = i64 + 8 | 0;
 i30 = i64 + 4 | 0;
 i31 = i64 + 40 | 0;
 i32 = i47 + 4 | 0;
 i33 = i64 + 8 | 0;
 i34 = i64 + 4 | 0;
 i35 = i64 + 40 | 0;
 i36 = i42 + 40 | 0;
 i37 = i43 + 36 | 0;
 i38 = i42 + 72 | 0;
 i39 = i42 + 60 | 0;
 i4 = 0;
 i2 = 0;
 i1 = 0;
 i6 = 21;
 i5 = 0;
 L16 : while (1) {
  i7 = i5 + 3 & -4;
  i8 = HEAP32[i18 >> 2] | 0;
  i5 = HEAP32[i8 + i7 >> 2] | 0;
  L18 : do switch (i5 | 0) {
  case 1:
   {
    i9 = i7 + 7 & -4;
    i5 = i9 + 92 | 0;
    i9 = i8 + i9 | 0;
    i6 = HEAP32[i9 + 76 >> 2] | 0;
    if ((i6 | 0) == -1) i10 = 0; else i10 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i6 = HEAP32[i9 + 88 >> 2] | 0;
    if ((i6 | 0) == -1) i6 = 1; else {
     i15 = HEAP32[(HEAP32[i46 >> 2] | 0) + (i6 * 360 | 0) + 328 >> 2] | 0;
     i16 = __Z12GetGfxDevicev() | 0;
     i14 = i9 + 80 | 0;
     i11 = HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0;
     i11 = HEAP32[(HEAP32[i11 >> 2] | 0) + (HEAP32[i11 + 48 >> 2] << 2) >> 2] | 0;
     i12 = HEAP32[i11 + 20 >> 2] | 0;
     __Z17SetupObjectMatrixRK10Matrix4x4fi(i9, __Z20ComputeTransformTypeRK10Matrix4x4ff(i9, f19) | 0);
     i13 = i9 + 84 | 0;
     i7 = HEAP32[i13 >> 2] | 0;
     i74 = HEAP32[i7 + 124 >> 2] | 0;
     i73 = HEAP32[i7 + 128 >> 2] | 0;
     i72 = HEAP32[i7 + 132 >> 2] | 0;
     i71 = HEAP32[i7 + 136 >> 2] | 0;
     i70 = HEAP32[i7 + 140 >> 2] | 0;
     i17 = HEAP32[i7 + 144 >> 2] | 0;
     i8 = HEAP32[i7 + 148 >> 2] | 0;
     i6 = HEAP32[i7 + 152 >> 2] | 0;
     HEAP32[i41 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i41 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i41 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i41 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i41 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i74;
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i73;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i72;
     HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i71;
     HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | i70;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i17;
     HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i8;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | i6;
     i6 = HEAP16[i9 + 74 >> 1] | 0;
     i8 = i6 << 16 >> 16;
     L24 : do if (i6 << 16 >> 16 == -1) {
      if ((i12 | 0) > 0) {
       i8 = i9 + 72 | 0;
       if (!i10) {
        i6 = 0;
        while (1) {
         i7 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0;
         if (i7 | 0) {
          HEAP32[i47 >> 2] = -1;
          HEAP32[i28 >> 2] = 0;
          HEAP32[i28 + 4 >> 2] = 0;
          HEAP32[i28 + 8 >> 2] = 0;
          HEAP32[i28 + 12 >> 2] = 0;
          HEAP32[i28 + 16 >> 2] = 0;
          HEAP32[i28 + 20 >> 2] = 0;
          HEAP32[i28 + 24 >> 2] = 0;
          if (__ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb(i15, HEAP32[i7 >> 2] | 0, HEAP16[i8 >> 1] | 0, i64, i47, 0) | 0) mftCall_viiiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 244 >> 2] | 0, i16 | 0, HEAP32[i64 >> 2] | 0, i29 | 0, HEAP32[i30 >> 2] | 0, i47 | 0, 1, HEAP32[i31 >> 2] | 0, i7 | 0);
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i12 | 0)) break L24;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       } else {
        i6 = 0;
        while (1) {
         i7 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0;
         if (i7 | 0) {
          mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 188 >> 2] | 0, i16 | 0, i10 | 0);
          HEAP32[i47 >> 2] = -1;
          HEAP32[i28 >> 2] = 0;
          HEAP32[i28 + 4 >> 2] = 0;
          HEAP32[i28 + 8 >> 2] = 0;
          HEAP32[i28 + 12 >> 2] = 0;
          HEAP32[i28 + 16 >> 2] = 0;
          HEAP32[i28 + 20 >> 2] = 0;
          HEAP32[i28 + 24 >> 2] = 0;
          if (__ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb(i15, HEAP32[i7 >> 2] | 0, HEAP16[i8 >> 1] | 0, i64, i47, 0) | 0) mftCall_viiiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 244 >> 2] | 0, i16 | 0, HEAP32[i64 >> 2] | 0, i29 | 0, HEAP32[i30 >> 2] | 0, i47 | 0, 1, HEAP32[i31 >> 2] | 0, i7 | 0);
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i12 | 0)) break L24;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       }
      }
     } else {
      if (!(i6 << 16 >> 16 > -1 & (i8 | 0) < (i12 | 0))) {
       HEAP32[i51 >> 2] = i8;
       __Z6FormatPKcz(i64, gb + 424106 | 0, i51);
       __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 256, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
       break;
      }
      i6 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i8, 0, 0) | 0;
      if (i6 | 0) {
       if (i10 | 0) mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 188 >> 2] | 0, i16 | 0, i10 | 0);
       HEAP32[i47 >> 2] = -1;
       HEAP32[i32 >> 2] = 0;
       HEAP32[i32 + 4 >> 2] = 0;
       HEAP32[i32 + 8 >> 2] = 0;
       HEAP32[i32 + 12 >> 2] = 0;
       HEAP32[i32 + 16 >> 2] = 0;
       HEAP32[i32 + 20 >> 2] = 0;
       HEAP32[i32 + 24 >> 2] = 0;
       if (__ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb(i15, HEAP32[i6 >> 2] | 0, HEAP16[i9 + 72 >> 1] | 0, i64, i47, 0) | 0) mftCall_viiiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 244 >> 2] | 0, i16 | 0, HEAP32[i64 >> 2] | 0, i33 | 0, HEAP32[i34 >> 2] | 0, i47 | 0, 1, HEAP32[i35 >> 2] | 0, i6 | 0);
      }
     } while (0);
     HEAP32[i20 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i41 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i41 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i41 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i41 + 28 >> 2];
     i6 = 1;
    }
    break;
   }
  case 0:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 24 | 0;
    i6 = i8 + i6 | 0;
    i16 = i6 + 20 | 0;
    i10 = HEAP32[i16 >> 2] | 0;
    if ((i10 | 0) == -1) i6 = 0; else {
     i11 = HEAP32[i46 >> 2] | 0;
     __Z17SetupObjectMatrixRK10Matrix4x4fi(i11 + (i10 * 360 | 0) | 0, HEAP32[i11 + (i10 * 360 | 0) + 176 >> 2] | 0);
     i13 = i6 + 12 | 0;
     i7 = HEAP32[i13 >> 2] | 0;
     i14 = HEAP32[i7 + 32 >> 2] | 0;
     i14 = HEAP32[(HEAP32[i14 >> 2] | 0) + (HEAP32[i14 + 48 >> 2] << 2) >> 2] | 0;
     i9 = HEAP32[i6 + 8 >> 2] | 0;
     i15 = i9 << 16 >> 16;
     i12 = HEAP16[i11 + (i10 * 360 | 0) + 182 >> 1] | 0;
     i17 = i12 & 65535;
     i17 = (i12 << 16 >> 16 == 0 | (i17 | 0) > (i15 | 0) ? i15 : i17 + -1 | 0) + (HEAPU16[i11 + (i10 * 360 | 0) + 180 >> 1] | 0) | 0;
     i15 = HEAP32[i14 + 20 >> 2] | 0;
     i12 = i6 + 16 | 0;
     i8 = HEAP32[i12 >> 2] | 0;
     i76 = HEAP32[i8 + 124 >> 2] | 0;
     i75 = HEAP32[i8 + 128 >> 2] | 0;
     i70 = HEAP32[i8 + 132 >> 2] | 0;
     i71 = HEAP32[i8 + 136 >> 2] | 0;
     i72 = HEAP32[i8 + 140 >> 2] | 0;
     i73 = HEAP32[i8 + 144 >> 2] | 0;
     i74 = HEAP32[i8 + 148 >> 2] | 0;
     i6 = HEAP32[i8 + 152 >> 2] | 0;
     HEAP32[i41 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i41 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i41 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i41 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i41 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i76;
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i75;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i70;
     HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i71;
     HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | i72;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i73;
     HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i74;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | i6;
     i6 = i9 >>> 16 & 65535;
     i9 = i9 >> 16;
     L60 : do if (i6 << 16 >> 16 == -1) {
      if ((i15 | 0) > 0) {
       i9 = i11 + (i10 * 360 | 0) + 332 | 0;
       i6 = 0;
       while (1) {
        i7 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i14 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i8 + 160 >> 2] | 0, i8 + 12 | 0, i43, i7, i6, 0, 0) | 0;
        if (i7 | 0) {
         i8 = HEAP32[i9 >> 2] | 0;
         if (i8 | 0) mftCall_viiii(i8 | 0, i46 | 0, HEAP32[i16 >> 2] | 0, i7 | 0, i17 | 0);
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i15 | 0)) break L60;
        i8 = HEAP32[i12 >> 2] | 0;
        i7 = HEAP32[i13 >> 2] | 0;
       }
      }
     } else {
      if (!(i6 << 16 >> 16 > -1 & (i9 | 0) < (i15 | 0))) {
       HEAP32[i52 >> 2] = i9;
       __Z6FormatPKcz(i64, gb + 424164 | 0, i52);
       __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 256, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
       break;
      }
      i7 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i14 >> 2] | 0) + (i9 << 2) >> 2] | 0, HEAP32[i8 + 160 >> 2] | 0, i8 + 12 | 0, i43, i7, i9, 0, 0) | 0;
      if (i7 | 0) {
       i6 = HEAP32[i11 + (i10 * 360 | 0) + 332 >> 2] | 0;
       if (i6 | 0) mftCall_viiii(i6 | 0, i46 | 0, HEAP32[i16 >> 2] | 0, i7 | 0, i17 | 0);
      }
     } while (0);
     HEAP32[i20 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i41 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i41 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i41 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i41 + 28 >> 2];
     i6 = 0;
    }
    break;
   }
  case 2:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 96 | 0;
    i8 = i8 + i6 | 0;
    i6 = HEAP32[i8 + 84 >> 2] | 0;
    if ((i6 | 0) == -1) i10 = 0; else i10 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i13 = i8 + 92 | 0;
    if (!(HEAP32[i13 >> 2] | 0)) i6 = 2; else {
     i9 = __Z12GetGfxDevicev() | 0;
     i14 = i8 + 88 | 0;
     i15 = HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0;
     i15 = HEAP32[(HEAP32[i15 >> 2] | 0) + (HEAP32[i15 + 48 >> 2] << 2) >> 2] | 0;
     i16 = HEAP32[i15 + 20 >> 2] | 0;
     __Z17SetupObjectMatrixRK10Matrix4x4fi(i8, 1);
     i7 = HEAP32[i13 >> 2] | 0;
     i70 = HEAP32[i7 + 124 >> 2] | 0;
     i71 = HEAP32[i7 + 128 >> 2] | 0;
     i72 = HEAP32[i7 + 132 >> 2] | 0;
     i73 = HEAP32[i7 + 136 >> 2] | 0;
     i74 = HEAP32[i7 + 140 >> 2] | 0;
     i75 = HEAP32[i7 + 144 >> 2] | 0;
     i76 = HEAP32[i7 + 148 >> 2] | 0;
     i6 = HEAP32[i7 + 152 >> 2] | 0;
     HEAP32[i41 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i41 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i41 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i41 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i41 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i70;
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i71;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i72;
     HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i73;
     HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | i74;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i75;
     HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i76;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | i6;
     i6 = HEAP32[i8 + 68 >> 2] | 0;
     L82 : do if ((i6 | 0) == -1) {
      if ((i16 | 0) > 0) {
       i11 = i8 + 72 | 0;
       i12 = i8 + 76 | 0;
       i8 = i8 + 80 | 0;
       if (!i10) {
        i6 = 0;
        while (1) {
         if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii(HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i8 >> 2] | 0);
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i16 | 0)) break L82;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       } else {
        i6 = 0;
        while (1) {
         if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) {
          mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 188 >> 2] | 0, i9 | 0, i10 | 0);
          __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii(HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i8 >> 2] | 0);
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i16 | 0)) break L82;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       }
      }
     } else {
      if (!((i6 | 0) > -1 & (i6 | 0) < (i16 | 0))) {
       HEAP32[i54 >> 2] = i6;
       __Z6FormatPKcz(i64, gb + 424226 | 0, i54);
       __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 256, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
       break;
      }
      if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) {
       if (i10 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 188 >> 2] | 0, i9 | 0, i10 | 0);
       __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii(HEAP32[i8 + 72 >> 2] | 0, HEAP32[i8 + 76 >> 2] | 0, HEAP32[i8 + 80 >> 2] | 0);
      }
     } while (0);
     HEAP32[i20 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i41 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i41 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i41 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i41 + 28 >> 2];
     i6 = 2;
    }
    break;
   }
  case 3:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 96 | 0;
    i8 = i8 + i6 | 0;
    i6 = HEAP32[i8 + 84 >> 2] | 0;
    if ((i6 | 0) == -1) i10 = 0; else i10 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i13 = i8 + 92 | 0;
    if (HEAP32[i13 >> 2] | 0) {
     i9 = __Z12GetGfxDevicev() | 0;
     i14 = i8 + 88 | 0;
     i15 = HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0;
     i15 = HEAP32[(HEAP32[i15 >> 2] | 0) + (HEAP32[i15 + 48 >> 2] << 2) >> 2] | 0;
     i16 = HEAP32[i15 + 20 >> 2] | 0;
     __Z17SetupObjectMatrixRK10Matrix4x4fi(i8, 1);
     i7 = HEAP32[i13 >> 2] | 0;
     i70 = HEAP32[i7 + 124 >> 2] | 0;
     i71 = HEAP32[i7 + 128 >> 2] | 0;
     i72 = HEAP32[i7 + 132 >> 2] | 0;
     i73 = HEAP32[i7 + 136 >> 2] | 0;
     i74 = HEAP32[i7 + 140 >> 2] | 0;
     i75 = HEAP32[i7 + 144 >> 2] | 0;
     i76 = HEAP32[i7 + 148 >> 2] | 0;
     i6 = HEAP32[i7 + 152 >> 2] | 0;
     HEAP32[i41 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i41 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i41 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i41 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i41 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i41 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i41 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i41 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i70;
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i71;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i72;
     HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i73;
     HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | i74;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i75;
     HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i76;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | i6;
     i6 = HEAP32[i8 + 68 >> 2] | 0;
     L113 : do if ((i6 | 0) == -1) {
      if ((i16 | 0) > 0) {
       i11 = i8 + 72 | 0;
       i12 = i8 + 76 | 0;
       i8 = i8 + 80 | 0;
       if (!i10) {
        i6 = 0;
        while (1) {
         if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) {
          i75 = HEAP32[i11 >> 2] | 0;
          HEAP32[i47 >> 2] = HEAP32[i12 >> 2];
          i76 = HEAP32[i8 >> 2] | 0;
          HEAP32[i64 >> 2] = HEAP32[i47 >> 2];
          __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj(i75, i64, i76);
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i16 | 0)) break L113;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       } else {
        i6 = 0;
        while (1) {
         if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) {
          mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 188 >> 2] | 0, i9 | 0, i10 | 0);
          i75 = HEAP32[i11 >> 2] | 0;
          HEAP32[i47 >> 2] = HEAP32[i12 >> 2];
          i76 = HEAP32[i8 >> 2] | 0;
          HEAP32[i64 >> 2] = HEAP32[i47 >> 2];
          __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj(i75, i64, i76);
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i16 | 0)) break L113;
         i7 = HEAP32[i13 >> 2] | 0;
        }
       }
      }
     } else {
      if (!((i6 | 0) > -1 & (i6 | 0) < (i16 | 0))) {
       HEAP32[i55 >> 2] = i6;
       __Z6FormatPKcz(i64, gb + 424290 | 0, i55);
       __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 256, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
       break;
      }
      if (__ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 << 2) >> 2] | 0, HEAP32[i7 + 160 >> 2] | 0, i7 + 12 | 0, i43, HEAP32[i14 >> 2] | 0, i6, 0, 0) | 0) {
       if (i10 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 188 >> 2] | 0, i9 | 0, i10 | 0);
       i75 = HEAP32[i8 + 72 >> 2] | 0;
       HEAP32[i48 >> 2] = HEAP32[i8 + 76 >> 2];
       i76 = HEAP32[i8 + 80 >> 2] | 0;
       HEAP32[i64 >> 2] = HEAP32[i48 >> 2];
       __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj(i75, i64, i76);
      }
     } while (0);
     HEAP32[i20 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i41 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i41 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i41 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i41 + 28 >> 2];
    }
    i6 = 3;
    break;
   }
  case 4:
   {
    i6 = 4;
    i5 = i7 + 35 & -4;
    break;
   }
  case 5:
   {
    i76 = i7 + 7 & -4;
    i5 = i76 + 28 | 0;
    i8 = i8 + i76 | 0;
    HEAP32[i48 >> 2] = HEAP32[i8 + 24 >> 2];
    do if (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, HEAP32[i8 + 4 >> 2] | 0, i8 + 8 | 0, gb + 424362 | 0, i48) | 0) {
     __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i48 >> 2] | 0, HEAP32[i8 + 12 >> 2] | 0, HEAP32[i8 + 16 >> 2] | 0, HEAP32[i8 + 20 >> 2] | 0, 0);
     i4 = HEAP32[i8 >> 2] | 0;
     if (!i4) i4 = 1; else {
      HEAP32[i47 >> 2] = i4;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i4) i63 = 105; else {
       if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
        i6 = HEAP32[i4 + 28 >> 2] | 0;
        i7 = HEAP32[i4 + 32 >> 2] | 0;
        i4 = i6 + (i7 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i64, i4, i47);
        i6 = HEAP32[i64 >> 2] | 0;
        i76 = HEAP32[i4 + 28 >> 2] | 0;
        i7 = HEAP32[gb + 1104264 >> 2] | 0;
        i4 = (i6 | 0) == -1 ? i76 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i76 + (i6 << 3) | 0;
        i6 = HEAP32[i7 + 28 >> 2] | 0;
        i7 = HEAP32[i7 + 32 >> 2] | 0;
       }
       if ((i4 | 0) == (i6 + (i7 << 3) | 0)) i63 = 105; else if (HEAP32[i4 + 4 >> 2] | 0) {
        i4 = 1;
        break;
       }
      }
      if ((i63 | 0) == 105) i63 = 0;
      __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
      i4 = 1;
     }
    } while (0);
    i6 = 5;
    break;
   }
  case 6:
   {
    i9 = i7 + 7 & -4;
    i5 = i9 + 196 | 0;
    i9 = i8 + i9 | 0;
    if ((HEAP32[i9 >> 2] | 0) > 0) {
     i6 = 1;
     i8 = 0;
     do {
      i76 = i9 + 124 + (i8 << 2) | 0;
      i6 = i6 & (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, HEAP32[i9 + 36 + (i8 << 2) >> 2] | 0, i9 + 68 + (i8 << 2) | 0, gb + 424407 | 0, i76) | 0);
      i7 = __Z28EnsureRenderTextureIsCreatedP13RenderTexture(HEAP32[i76 >> 2] | 0) | 0;
      HEAP32[i76 >> 2] = i7;
      if (!i7) i7 = mftCall_ii(HEAP32[(HEAP32[i40 >> 2] | 0) + 368 >> 2] | 0, i40 | 0) | 0; else i7 = HEAP32[i7 + 128 >> 2] | 0;
      HEAP32[i9 + 160 + (i8 << 2) >> 2] = i7;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) < (HEAP32[i9 >> 2] | 0));
    } else i6 = 1;
    i76 = i9 + 156 | 0;
    i7 = i6 & (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, HEAP32[i9 + 104 >> 2] | 0, i9 + 108 | 0, gb + 424378 | 0, i76) | 0);
    i6 = __Z28EnsureRenderTextureIsCreatedP13RenderTexture(HEAP32[i76 >> 2] | 0) | 0;
    HEAP32[i76 >> 2] = i6;
    if (!i6) i6 = mftCall_ii(HEAP32[(HEAP32[i40 >> 2] | 0) + 372 >> 2] | 0, i40 | 0) | 0; else i6 = HEAP32[i6 + 136 >> 2] | 0;
    HEAP32[i9 + 192 >> 2] = i6;
    if (i7) {
     i75 = HEAP32[i9 >> 2] | 0;
     HEAP32[i49 >> 2] = i6;
     i76 = HEAP32[i9 + 112 >> 2] | 0;
     i6 = HEAP32[i9 + 116 >> 2] | 0;
     i4 = HEAP32[i9 + 120 >> 2] | 0;
     HEAP32[i64 >> 2] = HEAP32[i49 >> 2];
     __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i75, i9 + 160 | 0, i64, i9 + 124 | 0, i76, i6, i4, 0) | 0;
     i4 = 1;
     i6 = 6;
    } else i6 = 6;
    break;
   }
  case 7:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 52 | 0;
    i8 = i8 + i6 | 0;
    i6 = HEAP32[i8 + 32 >> 2] | 0;
    if (!i6) if ((HEAP32[i8 + 4 >> 2] | 0) == 1) {
     HEAP32[i64 >> 2] = 0;
     i7 = __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, 1, i8 + 8 | 0, gb + 424022 | 0, i64) | 0;
     i6 = HEAP32[i64 >> 2] | 0;
    } else {
     i7 = 1;
     i6 = 0;
    } else i7 = 1;
    HEAP32[i64 >> 2] = HEAP32[i8 + 36 >> 2];
    do if (i7 & (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, HEAP32[i8 + 16 >> 2] | 0, i8 + 20 | 0, gb + 424436 | 0, i64) | 0)) {
     i4 = HEAP32[i8 + 44 >> 2] | 0;
     if (!i4) {
      __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture(i43, i6, HEAP32[i64 >> 2] | 0);
      i4 = 1;
      break;
     } else {
      __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_(i43, i6, HEAP32[i64 >> 2] | 0, i4, gb + 424453 | 0, HEAP32[i8 + 40 >> 2] | 0, HEAP16[i8 + 28 >> 1] | 0, HEAP32[i8 + 48 >> 2] | 0, -1, gb + 62472 | 0, gb + 1162356 | 0);
      i4 = 1;
      break;
     }
    } while (0);
    i6 = 7;
    break;
   }
  case 8:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    f77 = Math_fround(HEAPF32[i6 + 20 >> 2]);
    mftCall_viiifi(HEAP32[(HEAP32[i40 >> 2] | 0) + 32 >> 2] | 0, i40 | 0, HEAP32[i6 + 16 >> 2] | 0, i6 | 0, +f77, HEAP32[i6 + 24 >> 2] | 0);
    i6 = 8;
    i5 = i5 + 28 | 0;
    break;
   }
  case 9:
   {
    i10 = i7 + 7 & -4;
    i5 = i10 + 36 | 0;
    i10 = i8 + i10 | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    L182 : do if ((i7 | 0) == -1) i6 = HEAP32[i10 + 32 >> 2] | 0; else {
     i8 = HEAP32[i38 >> 2] | 0;
     L184 : do if (i8 | 0) {
      i9 = HEAP32[i39 >> 2] | 0;
      i6 = 0;
      while (1) {
       if ((HEAP32[i9 + (i6 << 3) >> 2] | 0) == (i7 | 0)) break;
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i8 | 0)) break L184;
      }
      i6 = HEAP32[i9 + (i6 << 3) + 4 >> 2] | 0;
      if (i6 | 0) break L182;
     } while (0);
     i6 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i10) | 0;
     if ((HEAP8[i45 >> 0] | 0) < 0) i7 = HEAP32[i3 >> 2] | 0; else i7 = i3;
     HEAP32[i53 >> 2] = i6;
     HEAP32[i53 + 4 >> 2] = i7;
     HEAP32[i53 + 8 >> 2] = gb + 424472;
     __Z6FormatPKcz(i64, gb + 423945 | 0, i53);
     __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 512, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
     i6 = 9;
     break L18;
    } while (0);
    __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i37, i10, i6);
    i6 = 9;
    break;
   }
  case 10:
   {
    i6 = 10;
    i5 = i7 + 11 & -4;
    break;
   }
  case 11:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i37, i6, Math_fround(HEAPF32[i6 + 4 >> 2]), 0);
    i6 = 11;
    i5 = i5 + 8 | 0;
    break;
   }
  case 12:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 20 | 0;
    i6 = i8 + i6 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    if ((i7 | 0) != -1 & (i7 & -1073741824 | 0) == 1073741824) {
     i76 = i6 + 4 | 0;
     i6 = i40 + 4 + ((i7 & 1073741823) << 4) | 0;
     HEAP32[i6 >> 2] = HEAP32[i76 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
     i6 = 12;
     break L18;
    } else {
     __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i37, i6, i6 + 4 | 0, 0);
     i6 = 12;
     break L18;
    }
   }
  case 13:
   {
    i7 = i7 + 7 & -4;
    i5 = i7 + 68 | 0;
    i7 = i8 + i7 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    if ((i6 | 0) != -1 & (i6 & -1073741824 | 0) == -2147483648) {
     i8 = i40 + 1764 + ((i6 & 1073741823) << 6) | 0;
     i6 = i7 + 4 | 0;
     i7 = i8 + 64 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
      i8 = i8 + 4 | 0;
      i6 = i6 + 4 | 0;
     } while ((i8 | 0) < (i7 | 0));
     i6 = 13;
     break L18;
    } else {
     __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i37, i7, i7 + 4 | 0, 0);
     i6 = 13;
     break L18;
    }
   }
  case 16:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    i76 = HEAP32[i6 + 4 >> 2] | 0;
    i5 = i5 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i37, i6, 0, i8 + i5 | 0, 4, i76) | 0;
    i6 = 16;
    i5 = (i76 << 2) + i5 | 0;
    break;
   }
  case 17:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    i76 = HEAP32[i6 + 4 >> 2] | 0;
    i5 = i5 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i37, i6, 1, i8 + i5 | 0, 16, i76) | 0;
    i6 = 17;
    i5 = (i76 << 4) + i5 | 0;
    break;
   }
  case 18:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    i76 = HEAP32[i6 + 4 >> 2] | 0;
    i5 = i5 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i37, i6, 2, i8 + i5 | 0, 64, i76) | 0;
    i6 = 18;
    i5 = (i76 << 6) + i5 | 0;
    break;
   }
  case 14:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 20 | 0;
    i6 = i8 + i6 | 0;
    i7 = HEAP32[i6 + 16 >> 2] | 0;
    HEAP32[i64 >> 2] = i7;
    i8 = HEAP32[i6 + 8 >> 2] | 0;
    if ((i8 | 0) == -1) __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i37, i6, i7); else if (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, i8, i6 + 12 | 0, gb + 424496 | 0, i64) | 0) __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i37, i6, HEAP32[i64 >> 2] | 0);
    i6 = 14;
    break;
   }
  case 15:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    HEAP32[i50 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i64 >> 2] = HEAP32[i50 >> 2];
    __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i37, i6, i64, 0);
    i6 = 15;
    i5 = i5 + 8 | 0;
    break;
   }
  case 20:
   {
    i5 = i7 + 7 & -4;
    i6 = i8 + i5 | 0;
    mftCall_viii(HEAP32[(HEAP32[i40 >> 2] | 0) + 740 >> 2] | 0, i40 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0);
    i6 = 20;
    i5 = i5 + 8 | 0;
    break;
   }
  case 19:
   {
    i6 = i7 + 7 & -4;
    i5 = i6 + 20 | 0;
    i6 = i8 + i6 | 0;
    HEAP32[i64 >> 2] = HEAP32[i6 + 16 >> 2];
    if (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i42, HEAP32[i6 + 4 >> 2] | 0, i6 + 8 | 0, gb + 424513 | 0, i64) | 0) {
     i7 = HEAP32[i64 >> 2] | 0;
     if ((HEAP32[i7 + 96 >> 2] | 0) == 3) {
      i76 = i6 + 12 | 0;
      __ZN13RenderTexture21SetShadowSamplingModeE18ShadowSamplingMode(i7, HEAP32[i76 >> 2] | 0);
      i1 = HEAP32[i7 + 32 >> 2] | 0;
      if ((HEAP32[i76 >> 2] | 0) == 1) {
       __ZN7Texture13SetFilterModeEi(i7, 0);
       i2 = i7;
      } else i2 = i7;
     }
    }
    i6 = 19;
    break;
   }
  default:
   {
    i63 = 162;
    break L16;
   }
  } while (0);
  if (i5 >>> 0 >= i44 >>> 0) {
   i3 = i4;
   break;
  }
 }
 if ((i63 | 0) == 162) {
  if ((HEAP8[i45 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i60 >> 2] = i5;
  HEAP32[i60 + 4 >> 2] = i6;
  HEAP32[i60 + 8 >> 2] = i3;
  __Z6FormatPKcz(i64, gb + 424034 | 0, i60);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i64, 256, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i64);
  i3 = i4;
 }
 if (i2 | 0) {
  __ZN13RenderTexture21SetShadowSamplingModeE18ShadowSamplingMode(i2, 0);
  __ZN7Texture13SetFilterModeEi(i2, i1);
 }
 if (i3) {
  HEAP32[i65 >> 2] = i56;
  HEAP32[i64 >> 2] = HEAP32[i65 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i61, i67, i64, i68, 0, i57, 0, 0) | 0;
 }
 HEAP8[i58 >> 0] = i59;
 __ZN22DeviceMVPMatricesStateD2Ev(i66);
 i76 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i76 >> 2] | 0) + 652 >> 2] | 0, i76 | 0);
 if (!i62) {
  STACKTOP = i69;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i62);
 STACKTOP = i69;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE23collideVirtualParticlesEv(i351) {
 i351 = i351 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i246 = 0, i247 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i267 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i310 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0, i344 = 0, i345 = 0, i346 = 0, i347 = 0, i348 = 0, i349 = 0, i350 = 0, i352 = 0, i353 = 0, i354 = 0, i355 = 0, i356 = 0, i357 = 0, f358 = f0, f359 = f0;
 i357 = STACKTOP;
 STACKTOP = STACKTOP + 5280 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i308 = i357 + 5216 | 0;
 i205 = i357 + 5096 | 0;
 i305 = i357 + 5080 | 0;
 i204 = i357 + 5024 | 0;
 i298 = i357 + 5232 | 0;
 i224 = i357 + 4944 | 0;
 i221 = i357 + 4928 | 0;
 i222 = i357 + 4912 | 0;
 i220 = i357 + 4896 | 0;
 i1 = i357 + 4880 | 0;
 i223 = i357 + 4864 | 0;
 i309 = i357 + 4848 | 0;
 i264 = i357 + 4840 | 0;
 i310 = i357 + 4824 | 0;
 i275 = i357 + 4816 | 0;
 i311 = i357 + 4800 | 0;
 i286 = i357 + 4792 | 0;
 i352 = i357 + 4776 | 0;
 i13 = i357 + 4768 | 0;
 i312 = i357 + 4752 | 0;
 i24 = i357 + 4744 | 0;
 i313 = i357 + 4728 | 0;
 i35 = i357 + 4720 | 0;
 i314 = i357 + 4704 | 0;
 i46 = i357 + 4696 | 0;
 i353 = i357 + 4680 | 0;
 i57 = i357 + 4672 | 0;
 i315 = i357 + 4656 | 0;
 i68 = i357 + 4648 | 0;
 i316 = i357 + 4632 | 0;
 i79 = i357 + 4624 | 0;
 i317 = i357 + 4608 | 0;
 i90 = i357 + 4600 | 0;
 i354 = i357 + 4584 | 0;
 i101 = i357 + 4576 | 0;
 i319 = i357 + 4560 | 0;
 i112 = i357 + 4552 | 0;
 i318 = i357 + 4536 | 0;
 i123 = i357 + 4528 | 0;
 i320 = i357 + 4512 | 0;
 i134 = i357 + 4504 | 0;
 i355 = i357 + 4488 | 0;
 i145 = i357 + 4480 | 0;
 i323 = i357 + 4464 | 0;
 i156 = i357 + 4448 | 0;
 i167 = i357 + 4432 | 0;
 i178 = i357 + 4416 | 0;
 i189 = i357 + 4400 | 0;
 i200 = i357 + 4384 | 0;
 i203 = i357 + 4368 | 0;
 i209 = i357 + 4352 | 0;
 i324 = i357 + 4336 | 0;
 i210 = i357 + 4320 | 0;
 i218 = i357 + 4304 | 0;
 i226 = i357 + 4288 | 0;
 i227 = i357 + 4272 | 0;
 i228 = i357 + 4256 | 0;
 i229 = i357 + 4240 | 0;
 i230 = i357 + 4224 | 0;
 i325 = i357 + 4208 | 0;
 i231 = i357 + 4192 | 0;
 i232 = i357 + 4176 | 0;
 i233 = i357 + 4160 | 0;
 i234 = i357 + 4144 | 0;
 i235 = i357 + 4128 | 0;
 i236 = i357 + 4112 | 0;
 i237 = i357 + 4096 | 0;
 i322 = i357 + 4080 | 0;
 i238 = i357 + 4064 | 0;
 i239 = i357 + 4048 | 0;
 i240 = i357 + 4032 | 0;
 i241 = i357 + 4016 | 0;
 i242 = i357 + 4e3 | 0;
 i243 = i357 + 3984 | 0;
 i244 = i357 + 3968 | 0;
 i297 = i357 + 5104 | 0;
 i350 = i357 + 3952 | 0;
 i307 = i357 + 3936 | 0;
 i245 = i357 + 3920 | 0;
 i306 = i357 + 3904 | 0;
 i299 = i357 + 3888 | 0;
 i300 = i357 + 3872 | 0;
 i301 = i357 + 3856 | 0;
 i302 = i357 + 3840 | 0;
 i342 = i357 + 3824 | 0;
 i246 = i357 + 3808 | 0;
 i343 = i357 + 3792 | 0;
 i247 = i357 + 3776 | 0;
 i344 = i357 + 3760 | 0;
 i248 = i357 + 3744 | 0;
 i345 = i357 + 3728 | 0;
 i249 = i357 + 3712 | 0;
 i326 = i357 + 3696 | 0;
 i250 = i357 + 3688 | 0;
 i327 = i357 + 3672 | 0;
 i251 = i357 + 3664 | 0;
 i328 = i357 + 3648 | 0;
 i252 = i357 + 3640 | 0;
 i329 = i357 + 3624 | 0;
 i253 = i357 + 3616 | 0;
 i330 = i357 + 3600 | 0;
 i254 = i357 + 3592 | 0;
 i331 = i357 + 3576 | 0;
 i255 = i357 + 3568 | 0;
 i332 = i357 + 3552 | 0;
 i256 = i357 + 3544 | 0;
 i333 = i357 + 3528 | 0;
 i257 = i357 + 3520 | 0;
 i334 = i357 + 3504 | 0;
 i258 = i357 + 3496 | 0;
 i335 = i357 + 3480 | 0;
 i259 = i357 + 3472 | 0;
 i336 = i357 + 3456 | 0;
 i260 = i357 + 3448 | 0;
 i337 = i357 + 3432 | 0;
 i261 = i357 + 3424 | 0;
 i339 = i357 + 3408 | 0;
 i262 = i357 + 3392 | 0;
 i263 = i357 + 3376 | 0;
 i265 = i357 + 3360 | 0;
 i266 = i357 + 3344 | 0;
 i267 = i357 + 3328 | 0;
 i268 = i357 + 3312 | 0;
 i269 = i357 + 3296 | 0;
 i340 = i357 + 3280 | 0;
 i270 = i357 + 3264 | 0;
 i271 = i357 + 3248 | 0;
 i272 = i357 + 3232 | 0;
 i273 = i357 + 3216 | 0;
 i274 = i357 + 3200 | 0;
 i276 = i357 + 3184 | 0;
 i277 = i357 + 3168 | 0;
 i341 = i357 + 3152 | 0;
 i278 = i357 + 3136 | 0;
 i279 = i357 + 3120 | 0;
 i280 = i357 + 3104 | 0;
 i281 = i357 + 3088 | 0;
 i282 = i357 + 3072 | 0;
 i283 = i357 + 3056 | 0;
 i284 = i357 + 3040 | 0;
 i338 = i357 + 3024 | 0;
 i285 = i357 + 3008 | 0;
 i287 = i357 + 2992 | 0;
 i288 = i357 + 2976 | 0;
 i289 = i357 + 2960 | 0;
 i290 = i357 + 2944 | 0;
 i291 = i357 + 2928 | 0;
 i292 = i357 + 2912 | 0;
 i321 = i357 + 5032 | 0;
 i304 = i357 + 4960 | 0;
 i293 = i357 + 2896 | 0;
 i294 = i357 + 2880 | 0;
 i295 = i357 + 2864 | 0;
 i296 = i357 + 2848 | 0;
 i14 = i357 + 2832 | 0;
 i15 = i357 + 2816 | 0;
 i16 = i357 + 2800 | 0;
 i17 = i357 + 2784 | 0;
 i18 = i357 + 2768 | 0;
 i19 = i357 + 2752 | 0;
 i20 = i357 + 2736 | 0;
 i21 = i357 + 2720 | 0;
 i22 = i357 + 2704 | 0;
 i23 = i357 + 2688 | 0;
 i25 = i357 + 2672 | 0;
 i26 = i357 + 2656 | 0;
 i27 = i357 + 2640 | 0;
 i28 = i357 + 2624 | 0;
 i29 = i357 + 2608 | 0;
 i30 = i357 + 2592 | 0;
 i31 = i357 + 2576 | 0;
 i32 = i357 + 2560 | 0;
 i33 = i357 + 2544 | 0;
 i34 = i357 + 2528 | 0;
 i36 = i357 + 2512 | 0;
 i37 = i357 + 2496 | 0;
 i38 = i357 + 2480 | 0;
 i39 = i357 + 2464 | 0;
 i40 = i357 + 2448 | 0;
 i41 = i357 + 2432 | 0;
 i42 = i357 + 2416 | 0;
 i43 = i357 + 2400 | 0;
 i44 = i357 + 2384 | 0;
 i45 = i357 + 2368 | 0;
 i47 = i357 + 2352 | 0;
 i48 = i357 + 2336 | 0;
 i49 = i357 + 2320 | 0;
 i303 = i357 + 2304 | 0;
 i50 = i357 + 2288 | 0;
 i51 = i357 + 2272 | 0;
 i52 = i357 + 2256 | 0;
 i53 = i357 + 2240 | 0;
 i54 = i357 + 2224 | 0;
 i55 = i357 + 2208 | 0;
 i356 = i357 + 2192 | 0;
 i56 = i357 + 2176 | 0;
 i58 = i357 + 2160 | 0;
 i59 = i357 + 2144 | 0;
 i60 = i357 + 2128 | 0;
 i61 = i357 + 2112 | 0;
 i346 = i357 + 2096 | 0;
 i62 = i357 + 2080 | 0;
 i63 = i357 + 2064 | 0;
 i64 = i357 + 2048 | 0;
 i65 = i357 + 2032 | 0;
 i66 = i357 + 2016 | 0;
 i347 = i357 + 2e3 | 0;
 i67 = i357 + 1984 | 0;
 i69 = i357 + 1968 | 0;
 i70 = i357 + 1952 | 0;
 i71 = i357 + 1936 | 0;
 i72 = i357 + 1920 | 0;
 i348 = i357 + 1904 | 0;
 i73 = i357 + 1888 | 0;
 i74 = i357 + 1872 | 0;
 i75 = i357 + 1856 | 0;
 i76 = i357 + 1840 | 0;
 i77 = i357 + 1824 | 0;
 i349 = i357 + 1808 | 0;
 i78 = i357 + 1792 | 0;
 i80 = i357 + 1776 | 0;
 i81 = i357 + 1760 | 0;
 i82 = i357 + 1744 | 0;
 i83 = i357 + 1728 | 0;
 i84 = i357 + 1712 | 0;
 i85 = i357 + 1696 | 0;
 i86 = i357 + 1680 | 0;
 i87 = i357 + 1664 | 0;
 i88 = i357 + 1648 | 0;
 i89 = i357 + 1632 | 0;
 i91 = i357 + 1616 | 0;
 i92 = i357 + 1600 | 0;
 i93 = i357 + 1584 | 0;
 i94 = i357 + 1568 | 0;
 i95 = i357 + 1552 | 0;
 i96 = i357 + 1536 | 0;
 i97 = i357 + 1520 | 0;
 i98 = i357 + 1504 | 0;
 i99 = i357 + 1488 | 0;
 i100 = i357 + 1472 | 0;
 i102 = i357 + 1456 | 0;
 i103 = i357 + 1440 | 0;
 i104 = i357 + 1424 | 0;
 i105 = i357 + 1408 | 0;
 i106 = i357 + 1392 | 0;
 i107 = i357 + 1376 | 0;
 i108 = i357 + 1360 | 0;
 i109 = i357 + 1344 | 0;
 i110 = i357 + 1328 | 0;
 i111 = i357 + 1312 | 0;
 i113 = i357 + 1296 | 0;
 i114 = i357 + 1280 | 0;
 i115 = i357 + 1264 | 0;
 i116 = i357 + 1248 | 0;
 i117 = i357 + 1232 | 0;
 i118 = i357 + 1216 | 0;
 i119 = i357 + 1200 | 0;
 i120 = i357 + 1184 | 0;
 i121 = i357 + 1168 | 0;
 i122 = i357 + 1152 | 0;
 i124 = i357 + 1136 | 0;
 i125 = i357 + 1120 | 0;
 i126 = i357 + 1104 | 0;
 i127 = i357 + 1088 | 0;
 i128 = i357 + 1072 | 0;
 i129 = i357 + 1056 | 0;
 i130 = i357 + 1040 | 0;
 i131 = i357 + 1024 | 0;
 i132 = i357 + 1008 | 0;
 i133 = i357 + 992 | 0;
 i135 = i357 + 976 | 0;
 i136 = i357 + 960 | 0;
 i137 = i357 + 944 | 0;
 i138 = i357 + 928 | 0;
 i139 = i357 + 912 | 0;
 i140 = i357 + 896 | 0;
 i141 = i357 + 880 | 0;
 i142 = i357 + 864 | 0;
 i143 = i357 + 848 | 0;
 i144 = i357 + 832 | 0;
 i146 = i357 + 816 | 0;
 i147 = i357 + 800 | 0;
 i148 = i357 + 784 | 0;
 i149 = i357 + 768 | 0;
 i150 = i357 + 752 | 0;
 i151 = i357 + 736 | 0;
 i152 = i357 + 720 | 0;
 i153 = i357 + 704 | 0;
 i154 = i357 + 688 | 0;
 i155 = i357 + 672 | 0;
 i157 = i357 + 656 | 0;
 i158 = i357 + 640 | 0;
 i159 = i357 + 624 | 0;
 i160 = i357 + 608 | 0;
 i161 = i357 + 592 | 0;
 i162 = i357 + 576 | 0;
 i163 = i357 + 560 | 0;
 i164 = i357 + 544 | 0;
 i165 = i357 + 528 | 0;
 i166 = i357 + 512 | 0;
 i168 = i357 + 496 | 0;
 i169 = i357 + 480 | 0;
 i170 = i357 + 464 | 0;
 i171 = i357 + 448 | 0;
 i172 = i357 + 432 | 0;
 i173 = i357 + 416 | 0;
 i174 = i357 + 400 | 0;
 i175 = i357 + 384 | 0;
 i176 = i357 + 368 | 0;
 i177 = i357 + 352 | 0;
 i179 = i357 + 336 | 0;
 i180 = i357 + 320 | 0;
 i181 = i357 + 304 | 0;
 i182 = i357 + 288 | 0;
 i183 = i357 + 272 | 0;
 i184 = i357 + 256 | 0;
 i185 = i357 + 240 | 0;
 i186 = i357 + 224 | 0;
 i187 = i357 + 208 | 0;
 i188 = i357 + 192 | 0;
 i190 = i357 + 176 | 0;
 i191 = i357 + 160 | 0;
 i192 = i357 + 144 | 0;
 i193 = i357 + 128 | 0;
 i194 = i357 + 112 | 0;
 i195 = i357 + 96 | 0;
 i196 = i357 + 80 | 0;
 i197 = i357 + 64 | 0;
 i198 = i357 + 48 | 0;
 i199 = i357 + 32 | 0;
 i201 = i357 + 16 | 0;
 i202 = i357;
 i211 = i351 + 432 | 0;
 i225 = (HEAP32[i211 >> 2] | 0) + 220 | 0;
 f359 = Math_fround(HEAPF32[i225 >> 2]);
 HEAP32[i205 >> 2] = __Z6simd4fRKf(i225) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i308, i205);
 i205 = (HEAP32[i211 >> 2] | 0) + 216 | 0;
 f358 = Math_fround(HEAPF32[i205 >> 2]);
 HEAP32[i204 >> 2] = __Z6simd4fRKf(i205) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i305, i204);
 i204 = f359 > Math_fround(0.0);
 i205 = f358 > Math_fround(0.0);
 i225 = HEAP32[i211 >> 2] | 0;
 i206 = HEAP32[i225 + 204 >> 2] | 0;
 i207 = HEAP32[i225 + 4 >> 2] | 0;
 i208 = HEAP32[i225 + 8 >> 2] | 0;
 i225 = HEAP32[i225 >> 2] | 0;
 i219 = i351 + 384 | 0;
 __Z5recipRK8Scalar4f(i221, i219);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i220, gb + 1097856 | 0);
 __ZgtRK8Scalar4fS1_(i222, i219, i220);
 __ZanRK8Scalar4fS1_(i224, i221, i222);
 __ZmlRK8Scalar4fS1_(i223, i224, i351 + 400 | 0);
 __ZmiRK8Scalar4fS1_(i1, i223, i224);
 __ZN8Scalar4faSERKS_(i207 + (i225 << 4) | 0, __ZN8Scalar4faSERKS_(i207 + (i225 + 1 << 4) | 0, __ZN8Scalar4faSERKS_(i207 + (i225 + 2 << 4) | 0, i1) | 0) | 0) | 0;
 i211 = HEAP32[i211 >> 2] | 0;
 i1 = HEAP32[i211 + 196 >> 2] | 0;
 i211 = HEAP32[i211 + 200 >> 2] | 0;
 if ((i1 | 0) == (i211 | 0)) {
  STACKTOP = i357;
  return;
 }
 i212 = i298 + 16 | 0;
 i213 = i298 + 32 | 0;
 i214 = i297 + 96 | 0;
 i215 = i297 + 16 | 0;
 i216 = i297 + 32 | 0;
 i217 = i321 + 16 | 0;
 i219 = i321 + 32 | 0;
 i220 = i304 + 48 | 0;
 i221 = i297 + 48 | 0;
 i222 = i297 + 64 | 0;
 i223 = i297 + 80 | 0;
 i224 = i304 + 16 | 0;
 i225 = i304 + 32 | 0;
 do {
  __Z11loadAlignedPKfj(i264, i207, (HEAPU16[i1 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i309, i264);
  i2 = i1 + 2 | 0;
  __Z11loadAlignedPKfj(i275, i207, (HEAPU16[i2 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i310, i275);
  i3 = i1 + 4 | 0;
  __Z11loadAlignedPKfj(i286, i207, (HEAPU16[i3 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i311, i286);
  __Z11loadAlignedPKfj(i13, i206, (HEAPU16[i1 + 6 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i352, i13);
  i4 = i1 + 8 | 0;
  __Z11loadAlignedPKfj(i24, i207, (HEAPU16[i4 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i312, i24);
  i5 = i1 + 10 | 0;
  __Z11loadAlignedPKfj(i35, i207, (HEAPU16[i5 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i313, i35);
  i6 = i1 + 12 | 0;
  __Z11loadAlignedPKfj(i46, i207, (HEAPU16[i6 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i314, i46);
  __Z11loadAlignedPKfj(i57, i206, (HEAPU16[i1 + 14 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i353, i57);
  i7 = i1 + 16 | 0;
  __Z11loadAlignedPKfj(i68, i207, (HEAPU16[i7 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i315, i68);
  i8 = i1 + 18 | 0;
  __Z11loadAlignedPKfj(i79, i207, (HEAPU16[i8 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i316, i79);
  i9 = i1 + 20 | 0;
  __Z11loadAlignedPKfj(i90, i207, (HEAPU16[i9 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i317, i90);
  __Z11loadAlignedPKfj(i101, i206, (HEAPU16[i1 + 22 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i354, i101);
  i10 = i1 + 26 | 0;
  __Z11loadAlignedPKfj(i112, i207, (HEAPU16[i10 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i319, i112);
  i11 = i1 + 24 | 0;
  __Z11loadAlignedPKfj(i123, i207, (HEAPU16[i11 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i318, i123);
  i12 = i1 + 28 | 0;
  __Z11loadAlignedPKfj(i134, i207, (HEAPU16[i12 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i320, i134);
  __Z11loadAlignedPKfj(i145, i206, (HEAPU16[i1 + 30 >> 1] | 0) << 4);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i355, i145);
  __Z5splatILj0EE8Scalar4fRKS0_(i178, i352);
  __ZmlRK8Scalar4fS1_(i167, i309, i178);
  __Z5splatILj1EE8Scalar4fRKS0_(i200, i352);
  __ZmlRK8Scalar4fS1_(i189, i310, i200);
  __ZplRK8Scalar4fS1_(i156, i167, i189);
  __Z5splatILj2EE8Scalar4fRKS0_(i209, i352);
  __ZmlRK8Scalar4fS1_(i203, i311, i209);
  __ZplRK8Scalar4fS1_(i323, i156, i203);
  __Z5splatILj0EE8Scalar4fRKS0_(i226, i353);
  __ZmlRK8Scalar4fS1_(i218, i312, i226);
  __Z5splatILj1EE8Scalar4fRKS0_(i228, i353);
  __ZmlRK8Scalar4fS1_(i227, i313, i228);
  __ZplRK8Scalar4fS1_(i210, i218, i227);
  __Z5splatILj2EE8Scalar4fRKS0_(i230, i353);
  __ZmlRK8Scalar4fS1_(i229, i314, i230);
  __ZplRK8Scalar4fS1_(i324, i210, i229);
  __Z5splatILj0EE8Scalar4fRKS0_(i233, i354);
  __ZmlRK8Scalar4fS1_(i232, i315, i233);
  __Z5splatILj1EE8Scalar4fRKS0_(i235, i354);
  __ZmlRK8Scalar4fS1_(i234, i316, i235);
  __ZplRK8Scalar4fS1_(i231, i232, i234);
  __Z5splatILj2EE8Scalar4fRKS0_(i237, i354);
  __ZmlRK8Scalar4fS1_(i236, i317, i237);
  __ZplRK8Scalar4fS1_(i325, i231, i236);
  __Z5splatILj0EE8Scalar4fRKS0_(i240, i355);
  __ZmlRK8Scalar4fS1_(i239, i318, i240);
  __Z5splatILj1EE8Scalar4fRKS0_(i242, i355);
  __ZmlRK8Scalar4fS1_(i241, i319, i242);
  __ZplRK8Scalar4fS1_(i238, i239, i241);
  __Z5splatILj2EE8Scalar4fRKS0_(i244, i355);
  __ZmlRK8Scalar4fS1_(i243, i320, i244);
  __ZplRK8Scalar4fS1_(i322, i238, i243);
  __Z9transposeR8Scalar4fS0_S0_S0_(i323, i324, i325, i322);
  __ZN8Scalar4faSERKS_(i298, i323) | 0;
  __ZN8Scalar4faSERKS_(i212, i324) | 0;
  __ZN8Scalar4faSERKS_(i213, i325) | 0;
  __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i297);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_RNS3_18ImpulseAccumulatorE(i350, i351, i298, i297);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_RNS3_18ImpulseAccumulatorE(i351, i350, i298, i297);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i245, gb + 1097856 | 0);
  if (__Z10anyGreaterRK8Scalar4fS1_RS_(i214, i245, i307) | 0) {
   __Z5recipRK8Scalar4f(i306, i214);
   __ZmlRK8Scalar4fS1_(i299, i297, i306);
   __ZmlRK8Scalar4fS1_(i300, i215, i306);
   __ZmlRK8Scalar4fS1_(i301, i216, i306);
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i302, gb + 1097776 | 0);
   __Z9transposeR8Scalar4fS0_S0_S0_(i299, i300, i301, i302);
   __Z5splatILj3EE8Scalar4fRKS0_(i246, i352);
   __ZmlRK8Scalar4fS1_(i342, i352, i246);
   __Z5splatILj3EE8Scalar4fRKS0_(i247, i353);
   __ZmlRK8Scalar4fS1_(i343, i353, i247);
   __Z5splatILj3EE8Scalar4fRKS0_(i248, i354);
   __ZmlRK8Scalar4fS1_(i344, i354, i248);
   __Z5splatILj3EE8Scalar4fRKS0_(i249, i355);
   __ZmlRK8Scalar4fS1_(i345, i355, i249);
   if (i205) {
    __Z11loadAlignedPKfj(i250, i208, (HEAPU16[i1 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i326, i250);
    __Z11loadAlignedPKfj(i251, i208, (HEAPU16[i2 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i327, i251);
    __Z11loadAlignedPKfj(i252, i208, (HEAPU16[i3 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i328, i252);
    __Z11loadAlignedPKfj(i253, i208, (HEAPU16[i4 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i329, i253);
    __Z11loadAlignedPKfj(i254, i208, (HEAPU16[i5 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i330, i254);
    __Z11loadAlignedPKfj(i255, i208, (HEAPU16[i6 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i331, i255);
    __Z11loadAlignedPKfj(i256, i208, (HEAPU16[i7 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i332, i256);
    __Z11loadAlignedPKfj(i257, i208, (HEAPU16[i8 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i333, i257);
    __Z11loadAlignedPKfj(i258, i208, (HEAPU16[i9 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i334, i258);
    __Z11loadAlignedPKfj(i259, i208, (HEAPU16[i11 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i335, i259);
    __Z11loadAlignedPKfj(i260, i208, (HEAPU16[i10 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i336, i260);
    __Z11loadAlignedPKfj(i261, i208, (HEAPU16[i12 >> 1] | 0) << 4);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i337, i261);
    __Z5splatILj0EE8Scalar4fRKS0_(i265, i352);
    __ZmlRK8Scalar4fS1_(i263, i326, i265);
    __Z5splatILj1EE8Scalar4fRKS0_(i267, i352);
    __ZmlRK8Scalar4fS1_(i266, i327, i267);
    __ZplRK8Scalar4fS1_(i262, i263, i266);
    __Z5splatILj2EE8Scalar4fRKS0_(i269, i352);
    __ZmlRK8Scalar4fS1_(i268, i328, i269);
    __ZplRK8Scalar4fS1_(i339, i262, i268);
    __Z5splatILj0EE8Scalar4fRKS0_(i272, i353);
    __ZmlRK8Scalar4fS1_(i271, i329, i272);
    __Z5splatILj1EE8Scalar4fRKS0_(i274, i353);
    __ZmlRK8Scalar4fS1_(i273, i330, i274);
    __ZplRK8Scalar4fS1_(i270, i271, i273);
    __Z5splatILj2EE8Scalar4fRKS0_(i277, i353);
    __ZmlRK8Scalar4fS1_(i276, i331, i277);
    __ZplRK8Scalar4fS1_(i340, i270, i276);
    __Z5splatILj0EE8Scalar4fRKS0_(i280, i354);
    __ZmlRK8Scalar4fS1_(i279, i332, i280);
    __Z5splatILj1EE8Scalar4fRKS0_(i282, i354);
    __ZmlRK8Scalar4fS1_(i281, i333, i282);
    __ZplRK8Scalar4fS1_(i278, i279, i281);
    __Z5splatILj2EE8Scalar4fRKS0_(i284, i354);
    __ZmlRK8Scalar4fS1_(i283, i334, i284);
    __ZplRK8Scalar4fS1_(i341, i278, i283);
    __Z5splatILj0EE8Scalar4fRKS0_(i288, i355);
    __ZmlRK8Scalar4fS1_(i287, i335, i288);
    __Z5splatILj1EE8Scalar4fRKS0_(i290, i355);
    __ZmlRK8Scalar4fS1_(i289, i336, i290);
    __ZplRK8Scalar4fS1_(i285, i287, i289);
    __Z5splatILj2EE8Scalar4fRKS0_(i292, i355);
    __ZmlRK8Scalar4fS1_(i291, i337, i292);
    __ZplRK8Scalar4fS1_(i338, i285, i291);
    __Z9transposeR8Scalar4fS0_S0_S0_(i339, i340, i341, i338);
    __ZN8Scalar4fC2ERKS_(i321, i339);
    __ZN8Scalar4fC2ERKS_(i217, i340);
    __ZN8Scalar4fC2ERKS_(i219, i341);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i293, gb + 1097776 | 0);
    __ZN8Scalar4faSERKS_(i220, i293) | 0;
    __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_(i297, i215, i216, i221, i222, i223, i298, i321, i306, i305, i307, i304);
    __Z9transposeR8Scalar4fS0_S0_S0_(i304, i224, i225, i220);
    __Z5splatILj0EE8Scalar4fRKS0_(i296, i342);
    __ZmlRK8Scalar4fS1_(i295, i296, i304);
    __ZmiRK8Scalar4fS1_(i294, i326, i295);
    __ZN8Scalar4faSERKS_(i326, i294) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i16, i342);
    __ZmlRK8Scalar4fS1_(i15, i16, i304);
    __ZmiRK8Scalar4fS1_(i14, i327, i15);
    __ZN8Scalar4faSERKS_(i327, i14) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i19, i342);
    __ZmlRK8Scalar4fS1_(i18, i19, i304);
    __ZmiRK8Scalar4fS1_(i17, i328, i18);
    __ZN8Scalar4faSERKS_(i328, i17) | 0;
    __Z5splatILj0EE8Scalar4fRKS0_(i22, i343);
    __ZmlRK8Scalar4fS1_(i21, i22, i224);
    __ZmiRK8Scalar4fS1_(i20, i329, i21);
    __ZN8Scalar4faSERKS_(i329, i20) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i26, i343);
    __ZmlRK8Scalar4fS1_(i25, i26, i224);
    __ZmiRK8Scalar4fS1_(i23, i330, i25);
    __ZN8Scalar4faSERKS_(i330, i23) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i29, i343);
    __ZmlRK8Scalar4fS1_(i28, i29, i224);
    __ZmiRK8Scalar4fS1_(i27, i331, i28);
    __ZN8Scalar4faSERKS_(i331, i27) | 0;
    __Z5splatILj0EE8Scalar4fRKS0_(i32, i344);
    __ZmlRK8Scalar4fS1_(i31, i32, i225);
    __ZmiRK8Scalar4fS1_(i30, i332, i31);
    __ZN8Scalar4faSERKS_(i332, i30) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i36, i344);
    __ZmlRK8Scalar4fS1_(i34, i36, i225);
    __ZmiRK8Scalar4fS1_(i33, i333, i34);
    __ZN8Scalar4faSERKS_(i333, i33) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i39, i344);
    __ZmlRK8Scalar4fS1_(i38, i39, i225);
    __ZmiRK8Scalar4fS1_(i37, i334, i38);
    __ZN8Scalar4faSERKS_(i334, i37) | 0;
    __Z5splatILj0EE8Scalar4fRKS0_(i42, i345);
    __ZmlRK8Scalar4fS1_(i41, i42, i220);
    __ZmiRK8Scalar4fS1_(i40, i335, i41);
    __ZN8Scalar4faSERKS_(i335, i40) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i45, i345);
    __ZmlRK8Scalar4fS1_(i44, i45, i220);
    __ZmiRK8Scalar4fS1_(i43, i336, i44);
    __ZN8Scalar4faSERKS_(i336, i43) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i49, i345);
    __ZmlRK8Scalar4fS1_(i48, i49, i220);
    __ZmiRK8Scalar4fS1_(i47, i337, i48);
    __ZN8Scalar4faSERKS_(i337, i47) | 0;
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i1 >> 1] | 0) << 4, i326);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i2 >> 1] | 0) << 4, i327);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i3 >> 1] | 0) << 4, i328);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i4 >> 1] | 0) << 4, i329);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i5 >> 1] | 0) << 4, i330);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i6 >> 1] | 0) << 4, i331);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i7 >> 1] | 0) << 4, i332);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i8 >> 1] | 0) << 4, i333);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i9 >> 1] | 0) << 4, i334);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i11 >> 1] | 0) << 4, i335);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i10 >> 1] | 0) << 4, i336);
    __Z12storeAlignedPfjRK8Scalar4f(i208, (HEAPU16[i12 >> 1] | 0) << 4, i337);
   }
   if (i204) {
    __ZmlRK8Scalar4fS1_(i50, i306, i306);
    __ZmlRK8Scalar4fS1_(i53, i297, i297);
    __ZmlRK8Scalar4fS1_(i54, i215, i215);
    __ZplRK8Scalar4fS1_(i52, i53, i54);
    __ZmlRK8Scalar4fS1_(i55, i216, i216);
    __ZplRK8Scalar4fS1_(i51, i52, i55);
    __ZmlRK8Scalar4fS1_(i303, i50, i51);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i58, gb + 1097760 | 0);
    __ZmlRK8Scalar4fS1_(i59, i308, i303);
    __ZplRK8Scalar4fS1_(i56, i58, i59);
    __Z5recipRK8Scalar4f(i356, i56);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i61, gb + 1097760 | 0);
    __ZmiRK8Scalar4fS1_(i60, i356, i61);
    __ZN8Scalar4faSERKS_(i356, i60) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i62, gb + 1097760 | 0);
    __Z5splatILj0EE8Scalar4fRKS0_(i64, i356);
    __Z5splatILj0EE8Scalar4fRKS0_(i66, i307);
    __ZanRK8Scalar4fS1_(i65, i352, i66);
    __ZmlRK8Scalar4fS1_(i63, i64, i65);
    __ZplRK8Scalar4fS1_(i346, i62, i63);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i67, gb + 1097760 | 0);
    __Z5splatILj1EE8Scalar4fRKS0_(i70, i356);
    __Z5splatILj1EE8Scalar4fRKS0_(i72, i307);
    __ZanRK8Scalar4fS1_(i71, i353, i72);
    __ZmlRK8Scalar4fS1_(i69, i70, i71);
    __ZplRK8Scalar4fS1_(i347, i67, i69);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i73, gb + 1097760 | 0);
    __Z5splatILj2EE8Scalar4fRKS0_(i75, i356);
    __Z5splatILj2EE8Scalar4fRKS0_(i77, i307);
    __ZanRK8Scalar4fS1_(i76, i354, i77);
    __ZmlRK8Scalar4fS1_(i74, i75, i76);
    __ZplRK8Scalar4fS1_(i348, i73, i74);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i78, gb + 1097760 | 0);
    __Z5splatILj3EE8Scalar4fRKS0_(i81, i356);
    __Z5splatILj3EE8Scalar4fRKS0_(i83, i307);
    __ZanRK8Scalar4fS1_(i82, i355, i83);
    __ZmlRK8Scalar4fS1_(i80, i81, i82);
    __ZplRK8Scalar4fS1_(i349, i78, i80);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i86, gb + 1097712 | 0);
    __Z5splatILj0EE8Scalar4fRKS0_(i88, i346);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i89, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i87, i88, i89);
    __ZorRK8Scalar4fS1_(i85, i86, i87);
    __ZmlRK8Scalar4fS1_(i84, i309, i85);
    __ZN8Scalar4faSERKS_(i309, i84) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i93, gb + 1097712 | 0);
    __Z5splatILj1EE8Scalar4fRKS0_(i95, i346);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i96, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i94, i95, i96);
    __ZorRK8Scalar4fS1_(i92, i93, i94);
    __ZmlRK8Scalar4fS1_(i91, i310, i92);
    __ZN8Scalar4faSERKS_(i310, i91) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i99, gb + 1097712 | 0);
    __Z5splatILj2EE8Scalar4fRKS0_(i102, i346);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i103, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i100, i102, i103);
    __ZorRK8Scalar4fS1_(i98, i99, i100);
    __ZmlRK8Scalar4fS1_(i97, i311, i98);
    __ZN8Scalar4faSERKS_(i311, i97) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i106, gb + 1097712 | 0);
    __Z5splatILj0EE8Scalar4fRKS0_(i108, i347);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i109, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i107, i108, i109);
    __ZorRK8Scalar4fS1_(i105, i106, i107);
    __ZmlRK8Scalar4fS1_(i104, i312, i105);
    __ZN8Scalar4faSERKS_(i312, i104) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i113, gb + 1097712 | 0);
    __Z5splatILj1EE8Scalar4fRKS0_(i115, i347);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i116, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i114, i115, i116);
    __ZorRK8Scalar4fS1_(i111, i113, i114);
    __ZmlRK8Scalar4fS1_(i110, i313, i111);
    __ZN8Scalar4faSERKS_(i313, i110) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i119, gb + 1097712 | 0);
    __Z5splatILj2EE8Scalar4fRKS0_(i121, i347);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i122, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i120, i121, i122);
    __ZorRK8Scalar4fS1_(i118, i119, i120);
    __ZmlRK8Scalar4fS1_(i117, i314, i118);
    __ZN8Scalar4faSERKS_(i314, i117) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i126, gb + 1097712 | 0);
    __Z5splatILj0EE8Scalar4fRKS0_(i128, i348);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i129, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i127, i128, i129);
    __ZorRK8Scalar4fS1_(i125, i126, i127);
    __ZmlRK8Scalar4fS1_(i124, i315, i125);
    __ZN8Scalar4faSERKS_(i315, i124) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i132, gb + 1097712 | 0);
    __Z5splatILj1EE8Scalar4fRKS0_(i135, i348);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i136, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i133, i135, i136);
    __ZorRK8Scalar4fS1_(i131, i132, i133);
    __ZmlRK8Scalar4fS1_(i130, i316, i131);
    __ZN8Scalar4faSERKS_(i316, i130) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i139, gb + 1097712 | 0);
    __Z5splatILj2EE8Scalar4fRKS0_(i141, i348);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i142, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i140, i141, i142);
    __ZorRK8Scalar4fS1_(i138, i139, i140);
    __ZmlRK8Scalar4fS1_(i137, i317, i138);
    __ZN8Scalar4faSERKS_(i317, i137) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i146, gb + 1097712 | 0);
    __Z5splatILj0EE8Scalar4fRKS0_(i148, i349);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i149, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i147, i148, i149);
    __ZorRK8Scalar4fS1_(i144, i146, i147);
    __ZmlRK8Scalar4fS1_(i143, i318, i144);
    __ZN8Scalar4faSERKS_(i318, i143) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i152, gb + 1097712 | 0);
    __Z5splatILj1EE8Scalar4fRKS0_(i154, i349);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i155, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i153, i154, i155);
    __ZorRK8Scalar4fS1_(i151, i152, i153);
    __ZmlRK8Scalar4fS1_(i150, i319, i151);
    __ZN8Scalar4faSERKS_(i319, i150) | 0;
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i159, gb + 1097712 | 0);
    __Z5splatILj2EE8Scalar4fRKS0_(i161, i349);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i162, gb + 1097792 | 0);
    __ZanRK8Scalar4fS1_(i160, i161, i162);
    __ZorRK8Scalar4fS1_(i158, i159, i160);
    __ZmlRK8Scalar4fS1_(i157, i320, i158);
    __ZN8Scalar4faSERKS_(i320, i157) | 0;
   }
   __Z5splatILj0EE8Scalar4fRKS0_(i165, i342);
   __ZmlRK8Scalar4fS1_(i164, i165, i299);
   __ZplRK8Scalar4fS1_(i163, i309, i164);
   __ZN8Scalar4faSERKS_(i309, i163) | 0;
   __Z5splatILj1EE8Scalar4fRKS0_(i169, i342);
   __ZmlRK8Scalar4fS1_(i168, i169, i299);
   __ZplRK8Scalar4fS1_(i166, i310, i168);
   __ZN8Scalar4faSERKS_(i310, i166) | 0;
   __Z5splatILj2EE8Scalar4fRKS0_(i172, i342);
   __ZmlRK8Scalar4fS1_(i171, i172, i299);
   __ZplRK8Scalar4fS1_(i170, i311, i171);
   __ZN8Scalar4faSERKS_(i311, i170) | 0;
   __Z5splatILj0EE8Scalar4fRKS0_(i175, i343);
   __ZmlRK8Scalar4fS1_(i174, i175, i300);
   __ZplRK8Scalar4fS1_(i173, i312, i174);
   __ZN8Scalar4faSERKS_(i312, i173) | 0;
   __Z5splatILj1EE8Scalar4fRKS0_(i179, i343);
   __ZmlRK8Scalar4fS1_(i177, i179, i300);
   __ZplRK8Scalar4fS1_(i176, i313, i177);
   __ZN8Scalar4faSERKS_(i313, i176) | 0;
   __Z5splatILj2EE8Scalar4fRKS0_(i182, i343);
   __ZmlRK8Scalar4fS1_(i181, i182, i300);
   __ZplRK8Scalar4fS1_(i180, i314, i181);
   __ZN8Scalar4faSERKS_(i314, i180) | 0;
   __Z5splatILj0EE8Scalar4fRKS0_(i185, i344);
   __ZmlRK8Scalar4fS1_(i184, i185, i301);
   __ZplRK8Scalar4fS1_(i183, i315, i184);
   __ZN8Scalar4faSERKS_(i315, i183) | 0;
   __Z5splatILj1EE8Scalar4fRKS0_(i188, i344);
   __ZmlRK8Scalar4fS1_(i187, i188, i301);
   __ZplRK8Scalar4fS1_(i186, i316, i187);
   __ZN8Scalar4faSERKS_(i316, i186) | 0;
   __Z5splatILj2EE8Scalar4fRKS0_(i192, i344);
   __ZmlRK8Scalar4fS1_(i191, i192, i301);
   __ZplRK8Scalar4fS1_(i190, i317, i191);
   __ZN8Scalar4faSERKS_(i317, i190) | 0;
   __Z5splatILj0EE8Scalar4fRKS0_(i195, i345);
   __ZmlRK8Scalar4fS1_(i194, i195, i302);
   __ZplRK8Scalar4fS1_(i193, i318, i194);
   __ZN8Scalar4faSERKS_(i318, i193) | 0;
   __Z5splatILj1EE8Scalar4fRKS0_(i198, i345);
   __ZmlRK8Scalar4fS1_(i197, i198, i302);
   __ZplRK8Scalar4fS1_(i196, i319, i197);
   __ZN8Scalar4faSERKS_(i319, i196) | 0;
   __Z5splatILj2EE8Scalar4fRKS0_(i202, i345);
   __ZmlRK8Scalar4fS1_(i201, i202, i302);
   __ZplRK8Scalar4fS1_(i199, i320, i201);
   __ZN8Scalar4faSERKS_(i320, i199) | 0;
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i1 >> 1] | 0) << 4, i309);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i2 >> 1] | 0) << 4, i310);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i3 >> 1] | 0) << 4, i311);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i4 >> 1] | 0) << 4, i312);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i5 >> 1] | 0) << 4, i313);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i6 >> 1] | 0) << 4, i314);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i7 >> 1] | 0) << 4, i315);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i8 >> 1] | 0) << 4, i316);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i9 >> 1] | 0) << 4, i317);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i11 >> 1] | 0) << 4, i318);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i10 >> 1] | 0) << 4, i319);
   __Z12storeAlignedPfjRK8Scalar4f(i207, (HEAPU16[i12 >> 1] | 0) << 4, i320);
  }
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i211 | 0));
 STACKTOP = i357;
 return;
}

function __ZNK5physx2Gu5RTree11traverseOBBERKNS0_3BoxEjPjPNS1_8CallbackE(i8, i3, i1, i2, i43) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i43 = i43 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, i69 = 0, f70 = f0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0, f156 = f0, f157 = f0, f158 = f0, f159 = f0, f160 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i42 + 24 | 0;
 i40 = i42;
 i39 = i42 + 16 | 0;
 i7 = i8 + 84 | 0;
 i1 = (HEAP32[i7 >> 2] & 2 | 0) == 0;
 if (i1) i37 = HEAP32[i8 + 92 >> 2] | 0; else i37 = 0;
 i5 = i3 + 36 | 0;
 f36 = Math_fround(HEAPF32[i5 >> 2]);
 f38 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = i3 + 48 | 0;
 f27 = Math_fround(HEAPF32[i5 >> 2]);
 f28 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i3 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i5 = i3 + 12 | 0;
 f33 = Math_fround(HEAPF32[i5 >> 2]);
 f34 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = i3 + 24 | 0;
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = HEAP32[i8 + 68 >> 2] | 0;
 i2 = i5 + -1 | 0;
 if ((i2 | 0) > -1) {
  i6 = i8 + 92 | 0;
  i4 = i1;
  i3 = i41;
  while (1) {
   if (i4) i1 = i2 * 112 | 0; else i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   i2 = i2 + -1 | 0;
   i4 = (HEAP32[i7 >> 2] & 2 | 0) == 0;
   if ((i2 | 0) <= -1) break; else i3 = i3 + 4 | 0;
  }
  i1 = i41 + (i5 << 2) | 0;
  if (i4) i2 = 0; else i9 = 11;
 } else if (i1) {
  i2 = 0;
  i1 = i41;
 } else {
  i1 = i41;
  i9 = 11;
 }
 if ((i9 | 0) == 11) i2 = HEAP32[i8 + 92 >> 2] | 0;
 f10 = Math_fround(Math_fround(0.0) - f27);
 f11 = Math_fround(Math_fround(0.0) - f28);
 f12 = Math_fround(Math_fround(0.0) - f29);
 f13 = Math_fround(Math_fround(f27 * f30) + Math_fround(0.0));
 f14 = Math_fround(Math_fround(f27 * f31) + Math_fround(0.0));
 f15 = Math_fround(Math_fround(f27 * f32) + Math_fround(0.0));
 f16 = Math_fround(Math_fround(f28 * f33) + Math_fround(0.0));
 f17 = Math_fround(Math_fround(f28 * f34) + Math_fround(0.0));
 f18 = Math_fround(Math_fround(f28 * f35) + Math_fround(0.0));
 f19 = Math_fround(Math_fround(f29 * f23) + Math_fround(0.0));
 f20 = Math_fround(Math_fround(f29 * f24) + Math_fround(0.0));
 f21 = Math_fround(Math_fround(f29 * f25) + Math_fround(0.0));
 i8 = i40 + 4 | 0;
 i9 = i40 + 8 | 0;
 i22 = i40 + 12 | 0;
 i3 = 1;
 L17 : while (1) {
  i6 = i1 + -4 | 0;
  if (!i3) i7 = HEAP32[i6 >> 2] | 0; else i7 = i2;
  f71 = Math_fround(HEAPF32[i37 + i7 >> 2]);
  f64 = Math_fround(HEAPF32[i37 + (i7 + 4) >> 2]);
  f57 = Math_fround(HEAPF32[i37 + (i7 + 8) >> 2]);
  f50 = Math_fround(HEAPF32[i37 + (i7 + 12) >> 2]);
  f119 = Math_fround(HEAPF32[i37 + (i7 + 16) >> 2]);
  f117 = Math_fround(HEAPF32[i37 + (i7 + 20) >> 2]);
  f67 = Math_fround(HEAPF32[i37 + (i7 + 24) >> 2]);
  f60 = Math_fround(HEAPF32[i37 + (i7 + 28) >> 2]);
  f58 = Math_fround(HEAPF32[i37 + (i7 + 32) >> 2]);
  f45 = Math_fround(HEAPF32[i37 + (i7 + 36) >> 2]);
  f53 = Math_fround(HEAPF32[i37 + (i7 + 40) >> 2]);
  f84 = Math_fround(HEAPF32[i37 + (i7 + 44) >> 2]);
  f70 = Math_fround(HEAPF32[i37 + (i7 + 48) >> 2]);
  f63 = Math_fround(HEAPF32[i37 + (i7 + 52) >> 2]);
  f56 = Math_fround(HEAPF32[i37 + (i7 + 56) >> 2]);
  f49 = Math_fround(HEAPF32[i37 + (i7 + 60) >> 2]);
  f46 = Math_fround(HEAPF32[i37 + (i7 + 64) >> 2]);
  f52 = Math_fround(HEAPF32[i37 + (i7 + 68) >> 2]);
  f59 = Math_fround(HEAPF32[i37 + (i7 + 72) >> 2]);
  f66 = Math_fround(HEAPF32[i37 + (i7 + 76) >> 2]);
  f88 = Math_fround(HEAPF32[i37 + (i7 + 80) >> 2]);
  f87 = Math_fround(HEAPF32[i37 + (i7 + 84) >> 2]);
  f86 = Math_fround(HEAPF32[i37 + (i7 + 88) >> 2]);
  f85 = Math_fround(HEAPF32[i37 + (i7 + 92) >> 2]);
  f160 = f70 < f36 ? f70 : f36;
  f158 = f63 < f36 ? f63 : f36;
  f156 = f56 < f36 ? f56 : f36;
  f154 = f49 < f36 ? f49 : f36;
  f160 = f71 > f160 ? f71 : f160;
  f158 = f64 > f158 ? f64 : f158;
  f156 = f57 > f156 ? f57 : f156;
  f154 = f50 > f154 ? f50 : f154;
  f159 = f46 < f38 ? f46 : f38;
  f157 = f52 < f38 ? f52 : f38;
  f155 = f59 < f38 ? f59 : f38;
  f153 = f66 < f38 ? f66 : f38;
  f159 = f119 > f159 ? f119 : f159;
  f157 = f117 > f157 ? f117 : f157;
  f155 = f67 > f155 ? f67 : f155;
  f153 = f60 > f153 ? f60 : f153;
  f152 = f88 < f26 ? f88 : f26;
  f151 = f87 < f26 ? f87 : f26;
  f150 = f86 < f26 ? f86 : f26;
  f149 = f85 < f26 ? f85 : f26;
  f152 = f58 > f152 ? f58 : f152;
  f151 = f45 > f151 ? f45 : f151;
  f150 = f53 > f150 ? f53 : f150;
  f149 = f84 > f149 ? f84 : f149;
  f61 = Math_fround(f160 - f36);
  f118 = Math_fround(f158 - f36);
  f121 = Math_fround(f156 - f36);
  f123 = Math_fround(f154 - f36);
  f68 = Math_fround(f159 - f38);
  f120 = Math_fround(f157 - f38);
  f122 = Math_fround(f155 - f38);
  f124 = Math_fround(f153 - f38);
  f65 = Math_fround(f152 - f26);
  f51 = Math_fround(f151 - f26);
  f54 = Math_fround(f150 - f26);
  f47 = Math_fround(f149 - f26);
  f97 = Math_fround(Math_fround(f30 * f61) + Math_fround(Math_fround(f31 * f68) + Math_fround(Math_fround(f32 * f65) + Math_fround(0.0))));
  f107 = Math_fround(Math_fround(f30 * f118) + Math_fround(Math_fround(f31 * f120) + Math_fround(Math_fround(f32 * f51) + Math_fround(0.0))));
  f98 = Math_fround(Math_fround(f30 * f121) + Math_fround(Math_fround(f31 * f122) + Math_fround(Math_fround(f32 * f54) + Math_fround(0.0))));
  f108 = Math_fround(Math_fround(f30 * f123) + Math_fround(Math_fround(f31 * f124) + Math_fround(Math_fround(f32 * f47) + Math_fround(0.0))));
  f102 = Math_fround(Math_fround(f33 * f61) + Math_fround(Math_fround(f34 * f68) + Math_fround(Math_fround(f35 * f65) + Math_fround(0.0))));
  f112 = Math_fround(Math_fround(f33 * f118) + Math_fround(Math_fround(f34 * f120) + Math_fround(Math_fround(f35 * f51) + Math_fround(0.0))));
  f103 = Math_fround(Math_fround(f33 * f121) + Math_fround(Math_fround(f34 * f122) + Math_fround(Math_fround(f35 * f54) + Math_fround(0.0))));
  f113 = Math_fround(Math_fround(f33 * f123) + Math_fround(Math_fround(f34 * f124) + Math_fround(Math_fround(f35 * f47) + Math_fround(0.0))));
  f65 = Math_fround(Math_fround(f23 * f61) + Math_fround(Math_fround(f24 * f68) + Math_fround(Math_fround(f25 * f65) + Math_fround(0.0))));
  f51 = Math_fround(Math_fround(f23 * f118) + Math_fround(Math_fround(f24 * f120) + Math_fround(Math_fround(f25 * f51) + Math_fround(0.0))));
  f54 = Math_fround(Math_fround(f23 * f121) + Math_fround(Math_fround(f24 * f122) + Math_fround(Math_fround(f25 * f54) + Math_fround(0.0))));
  f47 = Math_fround(Math_fround(f23 * f123) + Math_fround(Math_fround(f24 * f124) + Math_fround(Math_fround(f25 * f47) + Math_fround(0.0))));
  f97 = f97 < f27 ? f97 : f27;
  f107 = f107 < f27 ? f107 : f27;
  f98 = f98 < f27 ? f98 : f27;
  f108 = f108 < f27 ? f108 : f27;
  f97 = f10 > f97 ? f10 : f97;
  f107 = f10 > f107 ? f10 : f107;
  f98 = f10 > f98 ? f10 : f98;
  f108 = f10 > f108 ? f10 : f108;
  f102 = f102 < f28 ? f102 : f28;
  f112 = f112 < f28 ? f112 : f28;
  f103 = f103 < f28 ? f103 : f28;
  f113 = f113 < f28 ? f113 : f28;
  f102 = f11 > f102 ? f11 : f102;
  f112 = f11 > f112 ? f11 : f112;
  f103 = f11 > f103 ? f11 : f103;
  f113 = f11 > f113 ? f11 : f113;
  f65 = f65 < f29 ? f65 : f29;
  f51 = f51 < f29 ? f51 : f29;
  f54 = f54 < f29 ? f54 : f29;
  f47 = f47 < f29 ? f47 : f29;
  f65 = f12 > f65 ? f12 : f65;
  f51 = f12 > f51 ? f12 : f51;
  f54 = f12 > f54 ? f12 : f54;
  f47 = f12 > f47 ? f12 : f47;
  f124 = Math_fround(Math_fround(f30 * f97) + Math_fround(Math_fround(f33 * f102) + Math_fround(f36 + Math_fround(f23 * f65))));
  f123 = Math_fround(Math_fround(f30 * f107) + Math_fround(Math_fround(f33 * f112) + Math_fround(f36 + Math_fround(f23 * f51))));
  f122 = Math_fround(Math_fround(f30 * f98) + Math_fround(Math_fround(f33 * f103) + Math_fround(f36 + Math_fround(f23 * f54))));
  f121 = Math_fround(Math_fround(f30 * f108) + Math_fround(Math_fround(f33 * f113) + Math_fround(f36 + Math_fround(f23 * f47))));
  f120 = Math_fround(Math_fround(f31 * f97) + Math_fround(Math_fround(f34 * f102) + Math_fround(f38 + Math_fround(f24 * f65))));
  f118 = Math_fround(Math_fround(f31 * f107) + Math_fround(Math_fround(f34 * f112) + Math_fround(f38 + Math_fround(f24 * f51))));
  f68 = Math_fround(Math_fround(f31 * f98) + Math_fround(Math_fround(f34 * f103) + Math_fround(f38 + Math_fround(f24 * f54))));
  f61 = Math_fround(Math_fround(f31 * f108) + Math_fround(Math_fround(f34 * f113) + Math_fround(f38 + Math_fround(f24 * f47))));
  f65 = Math_fround(Math_fround(f32 * f97) + Math_fround(Math_fround(f35 * f102) + Math_fround(f26 + Math_fround(f25 * f65))));
  f51 = Math_fround(Math_fround(f32 * f107) + Math_fround(Math_fround(f35 * f112) + Math_fround(f26 + Math_fround(f25 * f51))));
  f54 = Math_fround(Math_fround(f32 * f98) + Math_fround(Math_fround(f35 * f103) + Math_fround(f26 + Math_fround(f25 * f54))));
  f47 = Math_fround(Math_fround(f32 * f108) + Math_fround(Math_fround(f35 * f113) + Math_fround(f26 + Math_fround(f25 * f47))));
  f113 = f70 < f124 ? f70 : f124;
  f108 = f63 < f123 ? f63 : f123;
  f103 = f56 < f122 ? f56 : f122;
  f98 = f49 < f121 ? f49 : f121;
  f112 = f46 < f120 ? f46 : f120;
  f107 = f52 < f118 ? f52 : f118;
  f102 = f59 < f68 ? f59 : f68;
  f97 = f66 < f61 ? f66 : f61;
  f96 = f88 < f65 ? f88 : f65;
  f95 = f87 < f51 ? f87 : f51;
  f94 = f86 < f54 ? f86 : f54;
  f93 = f85 < f47 ? f85 : f47;
  f116 = Math_fround(Math_fround(Math_fround(f71 + f70) * Math_fround(.5)) + Math_fround(0.0));
  f111 = Math_fround(Math_fround(Math_fround(f64 + f63) * Math_fround(.5)) + Math_fround(0.0));
  f106 = Math_fround(Math_fround(Math_fround(f57 + f56) * Math_fround(.5)) + Math_fround(0.0));
  f101 = Math_fround(Math_fround(Math_fround(f50 + f49) * Math_fround(.5)) + Math_fround(0.0));
  f115 = Math_fround(Math_fround(Math_fround(f119 + f46) * Math_fround(.5)) + Math_fround(0.0));
  f110 = Math_fround(Math_fround(Math_fround(f117 + f52) * Math_fround(.5)) + Math_fround(0.0));
  f105 = Math_fround(Math_fround(Math_fround(f67 + f59) * Math_fround(.5)) + Math_fround(0.0));
  f100 = Math_fround(Math_fround(Math_fround(f60 + f66) * Math_fround(.5)) + Math_fround(0.0));
  f114 = Math_fround(Math_fround(Math_fround(f58 + f88) * Math_fround(.5)) + Math_fround(0.0));
  f109 = Math_fround(Math_fround(Math_fround(f45 + f87) * Math_fround(.5)) + Math_fround(0.0));
  f104 = Math_fround(Math_fround(Math_fround(f53 + f86) * Math_fround(.5)) + Math_fround(0.0));
  f99 = Math_fround(Math_fround(Math_fround(f84 + f85) * Math_fround(.5)) + Math_fround(0.0));
  f92 = Math_fround(f70 - f116);
  f91 = Math_fround(f63 - f111);
  f90 = Math_fround(f56 - f106);
  f89 = Math_fround(f49 - f101);
  f46 = Math_fround(f46 - f115);
  f52 = Math_fround(f52 - f110);
  f59 = Math_fround(f59 - f105);
  f66 = Math_fround(f66 - f100);
  f88 = Math_fround(f88 - f114);
  f87 = Math_fround(f87 - f109);
  f86 = Math_fround(f86 - f104);
  f85 = Math_fround(f85 - f99);
  f160 = Math_fround(f124 - f160);
  f158 = Math_fround(f123 - f158);
  f156 = Math_fround(f122 - f156);
  f154 = Math_fround(f121 - f154);
  f159 = Math_fround(f120 - f159);
  f157 = Math_fround(f118 - f157);
  f155 = Math_fround(f68 - f155);
  f153 = Math_fround(f61 - f153);
  f152 = Math_fround(f65 - f152);
  f151 = Math_fround(f51 - f151);
  f150 = Math_fround(f54 - f150);
  f149 = Math_fround(f47 - f149);
  f148 = Math_fround(Math_fround(f92 * f160) + Math_fround(0.0));
  f147 = Math_fround(Math_fround(f91 * f158) + Math_fround(0.0));
  f146 = Math_fround(Math_fround(f90 * f156) + Math_fround(0.0));
  f145 = Math_fround(Math_fround(f89 * f154) + Math_fround(0.0));
  f130 = Math_fround(Math_fround(f46 * f159) + Math_fround(0.0));
  f132 = Math_fround(Math_fround(f52 * f157) + Math_fround(0.0));
  f135 = Math_fround(Math_fround(f59 * f155) + Math_fround(0.0));
  f138 = Math_fround(Math_fround(f66 * f153) + Math_fround(0.0));
  f144 = Math_fround(Math_fround(f88 * f152) + Math_fround(0.0));
  f143 = Math_fround(Math_fround(f87 * f151) + Math_fround(0.0));
  f142 = Math_fround(Math_fround(f86 * f150) + Math_fround(0.0));
  f141 = Math_fround(Math_fround(f85 * f149) + Math_fround(0.0));
  f140 = Math_fround(Math_fround(f13 * f160) + Math_fround(Math_fround(f14 * f159) + Math_fround(Math_fround(f15 * f152) + Math_fround(0.0))));
  f125 = Math_fround(Math_fround(f13 * f158) + Math_fround(Math_fround(f14 * f157) + Math_fround(Math_fround(f15 * f151) + Math_fround(0.0))));
  f133 = Math_fround(Math_fround(f13 * f156) + Math_fround(Math_fround(f14 * f155) + Math_fround(Math_fround(f15 * f150) + Math_fround(0.0))));
  f126 = Math_fround(Math_fround(f13 * f154) + Math_fround(Math_fround(f14 * f153) + Math_fround(Math_fround(f15 * f149) + Math_fround(0.0))));
  f129 = Math_fround(Math_fround(f16 * f160) + Math_fround(Math_fround(f17 * f159) + Math_fround(Math_fround(f18 * f152) + Math_fround(0.0))));
  f131 = Math_fround(Math_fround(f16 * f158) + Math_fround(Math_fround(f17 * f157) + Math_fround(Math_fround(f18 * f151) + Math_fround(0.0))));
  f134 = Math_fround(Math_fround(f16 * f156) + Math_fround(Math_fround(f17 * f155) + Math_fround(Math_fround(f18 * f150) + Math_fround(0.0))));
  f137 = Math_fround(Math_fround(f16 * f154) + Math_fround(Math_fround(f17 * f153) + Math_fround(Math_fround(f18 * f149) + Math_fround(0.0))));
  f136 = Math_fround(Math_fround(f19 * f160) + Math_fround(Math_fround(f20 * f159) + Math_fround(Math_fround(f21 * f152) + Math_fround(0.0))));
  f127 = Math_fround(Math_fround(f19 * f158) + Math_fround(Math_fround(f20 * f157) + Math_fround(Math_fround(f21 * f151) + Math_fround(0.0))));
  f139 = Math_fround(Math_fround(f19 * f156) + Math_fround(Math_fround(f20 * f155) + Math_fround(Math_fround(f21 * f150) + Math_fround(0.0))));
  f128 = Math_fround(Math_fround(f19 * f154) + Math_fround(Math_fround(f20 * f153) + Math_fround(Math_fround(f21 * f149) + Math_fround(0.0))));
  f152 = Math_fround(Math_fround(Math_fround(f116 * f160) + Math_fround(Math_fround(f115 * f159) + Math_fround(Math_fround(f114 * f152) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f160) + Math_fround(Math_fround(f38 * f159) + Math_fround(Math_fround(f26 * f152) + Math_fround(0.0)))));
  f151 = Math_fround(Math_fround(Math_fround(f111 * f158) + Math_fround(Math_fround(f110 * f157) + Math_fround(Math_fround(f109 * f151) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f158) + Math_fround(Math_fround(f38 * f157) + Math_fround(Math_fround(f26 * f151) + Math_fround(0.0)))));
  f150 = Math_fround(Math_fround(Math_fround(f106 * f156) + Math_fround(Math_fround(f105 * f155) + Math_fround(Math_fround(f104 * f150) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f156) + Math_fround(Math_fround(f38 * f155) + Math_fround(Math_fround(f26 * f150) + Math_fround(0.0)))));
  f149 = Math_fround(Math_fround(Math_fround(f101 * f154) + Math_fround(Math_fround(f100 * f153) + Math_fround(Math_fround(f99 * f149) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f154) + Math_fround(Math_fround(f38 * f153) + Math_fround(Math_fround(f26 * f149) + Math_fround(0.0)))));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f152, HEAP32[tempDoublePtr >> 2] | 0);
  i44 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f150, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f149, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i48 = (HEAPF32[tempDoublePtr >> 2] = f148, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = (HEAPF32[tempDoublePtr >> 2] = f147, HEAP32[tempDoublePtr >> 2] | 0);
  i72 = (HEAPF32[tempDoublePtr >> 2] = f146, HEAP32[tempDoublePtr >> 2] | 0);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f145, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i62 = (HEAPF32[tempDoublePtr >> 2] = f130, HEAP32[tempDoublePtr >> 2] | 0);
  i73 = (HEAPF32[tempDoublePtr >> 2] = f132, HEAP32[tempDoublePtr >> 2] | 0);
  i74 = (HEAPF32[tempDoublePtr >> 2] = f135, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = (HEAPF32[tempDoublePtr >> 2] = f138, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f138 = (HEAP32[tempDoublePtr >> 2] = i48 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f138 = Math_fround(f138 + (HEAP32[tempDoublePtr >> 2] = i62 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f135 = (HEAP32[tempDoublePtr >> 2] = i75 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f135 = Math_fround(f135 + (HEAP32[tempDoublePtr >> 2] = i73 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f132 = (HEAP32[tempDoublePtr >> 2] = i72 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f132 = Math_fround(f132 + (HEAP32[tempDoublePtr >> 2] = i74 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f130 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f130 = Math_fround(f130 + (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i55 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f143, HEAP32[tempDoublePtr >> 2] | 0);
  i74 = (HEAPF32[tempDoublePtr >> 2] = f142, HEAP32[tempDoublePtr >> 2] | 0);
  i72 = (HEAPF32[tempDoublePtr >> 2] = f141, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f138 = Math_fround((HEAP32[tempDoublePtr >> 2] = i55 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f138);
  f135 = Math_fround((HEAP32[tempDoublePtr >> 2] = i69 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f135);
  f132 = Math_fround((HEAP32[tempDoublePtr >> 2] = i74 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f132);
  f130 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f130);
  i72 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
  i74 = (HEAPF32[tempDoublePtr >> 2] = f125, HEAP32[tempDoublePtr >> 2] | 0);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f133, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i73 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
  i75 = (HEAPF32[tempDoublePtr >> 2] = f131, HEAP32[tempDoublePtr >> 2] | 0);
  i62 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f137, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f137 = (HEAP32[tempDoublePtr >> 2] = i72 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f137 = Math_fround(f137 + (HEAP32[tempDoublePtr >> 2] = i73 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f134 = (HEAP32[tempDoublePtr >> 2] = i74 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f134 = Math_fround(f134 + (HEAP32[tempDoublePtr >> 2] = i75 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f131 = (HEAP32[tempDoublePtr >> 2] = i69 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f131 = Math_fround(f131 + (HEAP32[tempDoublePtr >> 2] = i62 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f129 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f129 = Math_fround(f129 + (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i48 = (HEAPF32[tempDoublePtr >> 2] = f136, HEAP32[tempDoublePtr >> 2] | 0);
  i55 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  i62 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
  i69 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f137 = Math_fround((HEAP32[tempDoublePtr >> 2] = i48 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f137);
  f134 = Math_fround((HEAP32[tempDoublePtr >> 2] = i55 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f134);
  f131 = Math_fround((HEAP32[tempDoublePtr >> 2] = i62 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f131);
  f129 = Math_fround((HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f129);
  f128 = (HEAP32[tempDoublePtr >> 2] = i4 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f139 = Math_fround(f128 + Math_fround(-9.99999997e-07));
  f127 = (HEAP32[tempDoublePtr >> 2] = i44 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f136 = Math_fround(f127 + Math_fround(-9.99999997e-07));
  f126 = (HEAP32[tempDoublePtr >> 2] = i3 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f133 = Math_fround(f126 + Math_fround(-9.99999997e-07));
  f125 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = f139 > Math_fround(f138 + f137);
  i3 = f136 > Math_fround(f135 + f134);
  i44 = f133 > Math_fround(f132 + f131);
  i4 = Math_fround(f125 + Math_fround(-9.99999997e-07)) > Math_fround(f130 + f129);
  i69 = f128 > Math_fround(9.99999997e-07);
  i62 = f127 > Math_fround(9.99999997e-07);
  i55 = f126 > Math_fround(9.99999997e-07);
  i48 = f125 > Math_fround(9.99999997e-07);
  f113 = Math_fround(f124 - (f71 > f113 ? f71 : f113));
  f108 = Math_fround(f123 - (f64 > f108 ? f64 : f108));
  f103 = Math_fround(f122 - (f57 > f103 ? f57 : f103));
  f98 = Math_fround(f121 - (f50 > f98 ? f50 : f98));
  f112 = Math_fround(f120 - (f119 > f112 ? f119 : f112));
  f107 = Math_fround(f118 - (f117 > f107 ? f117 : f107));
  f102 = Math_fround(f68 - (f67 > f102 ? f67 : f102));
  f97 = Math_fround(f61 - (f60 > f97 ? f60 : f97));
  f96 = Math_fround(f65 - (f58 > f96 ? f58 : f96));
  f95 = Math_fround(f51 - (f45 > f95 ? f45 : f95));
  f94 = Math_fround(f54 - (f53 > f94 ? f53 : f94));
  f93 = Math_fround(f47 - (f84 > f93 ? f84 : f93));
  f92 = Math_fround(Math_fround(f92 * f113) + Math_fround(0.0));
  f91 = Math_fround(Math_fround(f91 * f108) + Math_fround(0.0));
  f90 = Math_fround(Math_fround(f90 * f103) + Math_fround(0.0));
  f89 = Math_fround(Math_fround(f89 * f98) + Math_fround(0.0));
  f46 = Math_fround(Math_fround(f46 * f112) + Math_fround(0.0));
  f52 = Math_fround(Math_fround(f52 * f107) + Math_fround(0.0));
  f59 = Math_fround(Math_fround(f59 * f102) + Math_fround(0.0));
  f66 = Math_fround(Math_fround(f66 * f97) + Math_fround(0.0));
  f88 = Math_fround(Math_fround(f88 * f96) + Math_fround(0.0));
  f87 = Math_fround(Math_fround(f87 * f95) + Math_fround(0.0));
  f86 = Math_fround(Math_fround(f86 * f94) + Math_fround(0.0));
  f85 = Math_fround(Math_fround(f85 * f93) + Math_fround(0.0));
  f84 = Math_fround(Math_fround(f13 * f113) + Math_fround(Math_fround(f14 * f112) + Math_fround(Math_fround(f15 * f96) + Math_fround(0.0))));
  f47 = Math_fround(Math_fround(f13 * f108) + Math_fround(Math_fround(f14 * f107) + Math_fround(Math_fround(f15 * f95) + Math_fround(0.0))));
  f53 = Math_fround(Math_fround(f13 * f103) + Math_fround(Math_fround(f14 * f102) + Math_fround(Math_fround(f15 * f94) + Math_fround(0.0))));
  f54 = Math_fround(Math_fround(f13 * f98) + Math_fround(Math_fround(f14 * f97) + Math_fround(Math_fround(f15 * f93) + Math_fround(0.0))));
  f45 = Math_fround(Math_fround(f16 * f113) + Math_fround(Math_fround(f17 * f112) + Math_fround(Math_fround(f18 * f96) + Math_fround(0.0))));
  f51 = Math_fround(Math_fround(f16 * f108) + Math_fround(Math_fround(f17 * f107) + Math_fround(Math_fround(f18 * f95) + Math_fround(0.0))));
  f58 = Math_fround(Math_fround(f16 * f103) + Math_fround(Math_fround(f17 * f102) + Math_fround(Math_fround(f18 * f94) + Math_fround(0.0))));
  f65 = Math_fround(Math_fround(f16 * f98) + Math_fround(Math_fround(f17 * f97) + Math_fround(Math_fround(f18 * f93) + Math_fround(0.0))));
  f60 = Math_fround(Math_fround(f19 * f113) + Math_fround(Math_fround(f20 * f112) + Math_fround(Math_fround(f21 * f96) + Math_fround(0.0))));
  f61 = Math_fround(Math_fround(f19 * f108) + Math_fround(Math_fround(f20 * f107) + Math_fround(Math_fround(f21 * f95) + Math_fround(0.0))));
  f67 = Math_fround(Math_fround(f19 * f103) + Math_fround(Math_fround(f20 * f102) + Math_fround(Math_fround(f21 * f94) + Math_fround(0.0))));
  f68 = Math_fround(Math_fround(f19 * f98) + Math_fround(Math_fround(f20 * f97) + Math_fround(Math_fround(f21 * f93) + Math_fround(0.0))));
  f96 = Math_fround(Math_fround(Math_fround(f116 * f113) + Math_fround(Math_fround(f115 * f112) + Math_fround(Math_fround(f114 * f96) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f113) + Math_fround(Math_fround(f38 * f112) + Math_fround(Math_fround(f26 * f96) + Math_fround(0.0)))));
  f95 = Math_fround(Math_fround(Math_fround(f111 * f108) + Math_fround(Math_fround(f110 * f107) + Math_fround(Math_fround(f109 * f95) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f108) + Math_fround(Math_fround(f38 * f107) + Math_fround(Math_fround(f26 * f95) + Math_fround(0.0)))));
  f94 = Math_fround(Math_fround(Math_fround(f106 * f103) + Math_fround(Math_fround(f105 * f102) + Math_fround(Math_fround(f104 * f94) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f103) + Math_fround(Math_fround(f38 * f102) + Math_fround(Math_fround(f26 * f94) + Math_fround(0.0)))));
  f93 = Math_fround(Math_fround(Math_fround(f101 * f98) + Math_fround(Math_fround(f100 * f97) + Math_fround(Math_fround(f99 * f93) + Math_fround(0.0)))) - Math_fround(Math_fround(f36 * f98) + Math_fround(Math_fround(f38 * f97) + Math_fround(Math_fround(f26 * f93) + Math_fround(0.0)))));
  i75 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
  i74 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
  i73 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
  i72 = (HEAPF32[tempDoublePtr >> 2] = f93, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i79 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  i80 = (HEAPF32[tempDoublePtr >> 2] = f91, HEAP32[tempDoublePtr >> 2] | 0);
  i83 = (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i77 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
  i82 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
  i81 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i78 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f66 = (HEAP32[tempDoublePtr >> 2] = i79 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(f66 + (HEAP32[tempDoublePtr >> 2] = i77 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f59 = (HEAP32[tempDoublePtr >> 2] = i80 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(f59 + (HEAP32[tempDoublePtr >> 2] = i82 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f52 = (HEAP32[tempDoublePtr >> 2] = i83 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f52 = Math_fround(f52 + (HEAP32[tempDoublePtr >> 2] = i81 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f46 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f46 = Math_fround(f46 + (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i78 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
  i81 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
  i83 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i78 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f66);
  f59 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f59);
  f52 = Math_fround((HEAP32[tempDoublePtr >> 2] = i81 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f52);
  f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i83, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f46);
  i83 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
  i81 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  i78 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  i82 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
  i80 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  i77 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i79 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f65 = (HEAP32[tempDoublePtr >> 2] = i83 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = Math_fround(f65 + (HEAP32[tempDoublePtr >> 2] = i82 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f58 = (HEAP32[tempDoublePtr >> 2] = i81 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f58 + (HEAP32[tempDoublePtr >> 2] = i80 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f51 = (HEAP32[tempDoublePtr >> 2] = i76 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f51 = Math_fround(f51 + (HEAP32[tempDoublePtr >> 2] = i77 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f45 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f45 = Math_fround(f45 + (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i79 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i78 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i77 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i76 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
  f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i79 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f65);
  f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i78 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f58);
  f51 = Math_fround((HEAP32[tempDoublePtr >> 2] = i77 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f51);
  f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f45);
  f68 = (HEAP32[tempDoublePtr >> 2] = i75 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f67 = Math_fround(f68 + Math_fround(-9.99999997e-07));
  f61 = (HEAP32[tempDoublePtr >> 2] = i74 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = Math_fround(f61 + Math_fround(-9.99999997e-07));
  f54 = (HEAP32[tempDoublePtr >> 2] = i73 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f53 = Math_fround(f54 + Math_fround(-9.99999997e-07));
  f47 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = f71 > f70 | (i69 & i5 | f68 > Math_fround(9.99999997e-07) & f67 > Math_fround(f66 + f65));
  i3 = (f64 > f63 | (i62 & i3 | f61 > Math_fround(9.99999997e-07) & f60 > Math_fround(f59 + f58))) & 1 ^ 1;
  i44 = (f57 > f56 | (i55 & i44 | f54 > Math_fround(9.99999997e-07) & f53 > Math_fround(f52 + f51))) & 1 ^ 1;
  i4 = (f50 > f49 | (i48 & i4 | (f47 > Math_fround(9.99999997e-07) ? Math_fround(f47 + Math_fround(-9.99999997e-07)) > Math_fround(f46 + f45) : 0))) & 1 ^ 1;
  HEAP32[i40 >> 2] = i5 & 1 ^ 1;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i44;
  HEAP32[i22 >> 2] = i4;
  i4 = HEAP32[i37 + (i7 + 96) >> 2] & -2;
  HEAP32[i39 >> 2] = i4;
  do if (i5) {
   i5 = i3;
   i3 = 0;
   i1 = i6;
  } else if (!(HEAP32[i37 + (i7 + 96) >> 2] & 1)) {
   HEAP32[i6 >> 2] = i4;
   i5 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i39 >> 2] | 0;
   i3 = 1;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, 1, i39 | 0) | 0) {
   i5 = i3;
   i3 = 0;
   i1 = i6;
   break;
  } else {
   i9 = 20;
   break L17;
  } while (0);
  i4 = HEAP32[i37 + (i7 + 100) >> 2] & -2;
  HEAP32[i39 >> 2] = i4;
  do if (!i5) i4 = i2; else if (!(HEAP32[i37 + (i7 + 100) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i4;
   i4 = HEAP32[i39 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, 1, i39 | 0) | 0) {
   i4 = i2;
   break;
  } else {
   i9 = 20;
   break L17;
  } while (0);
  i2 = HEAP32[i37 + (i7 + 104) >> 2] & -2;
  HEAP32[i39 >> 2] = i2;
  do if (HEAP32[i9 >> 2] | 0) if (!(HEAP32[i37 + (i7 + 104) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i2;
   i4 = HEAP32[i39 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, 1, i39 | 0) | 0) break; else {
   i9 = 20;
   break L17;
  } while (0);
  i2 = HEAP32[i37 + (i7 + 108) >> 2] & -2;
  HEAP32[i39 >> 2] = i2;
  do if (!(HEAP32[i22 >> 2] | 0)) i2 = i4; else if (!(HEAP32[i37 + (i7 + 108) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i2;
   i2 = HEAP32[i39 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, 1, i39 | 0) | 0) {
   i2 = i4;
   break;
  } else {
   i9 = 20;
   break L17;
  } while (0);
  if (i1 >>> 0 <= i41 >>> 0) {
   i9 = 20;
   break;
  }
 }
 if ((i9 | 0) == 20) {
  STACKTOP = i42;
  return;
 }
}

function __ZN14SerializedFile12ReadMetadataILb0EEEbijPKhjj(i55, i54, i47, i53, i1, i48) {
 i55 = i55 | 0;
 i54 = i54 | 0;
 i47 = i47 | 0;
 i53 = i53 | 0;
 i1 = i1 | 0;
 i48 = i48 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i69 + 88 | 0;
 i49 = i69 + 80 | 0;
 i7 = i69 + 72 | 0;
 i67 = i69 + 16 | 0;
 i63 = i69;
 i62 = i69 + 144 | 0;
 i68 = i69 + 128 | 0;
 i65 = i69 + 116 | 0;
 i64 = i69 + 96 | 0;
 i46 = i69 + 160 | 0;
 i50 = i69 + 148 | 0;
 i66 = __Z20push_allocation_rootPvP13BaseAllocatorb(i55, 0, 0) | 0;
 HEAP32[i62 >> 2] = i53;
 i61 = i53 + i1 | 0;
 HEAP32[i68 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i68 >> 2] = 0;
 HEAP32[i68 + 4 >> 2] = 0;
 HEAP32[i68 + 8 >> 2] = 0;
 i52 = i53;
 do if ((i54 | 0) > 6) {
  L3 : do if ((i1 | 0) > 0) {
   i1 = i53;
   while (1) {
    if (!(HEAP8[i1 >> 0] | 0)) {
     i5 = i1;
     break L3;
    }
    i1 = i1 + 1 | 0;
    HEAP32[i62 >> 2] = i1;
    if (i1 >>> 0 >= i61 >>> 0) {
     i5 = i1;
     break;
    }
   }
  } else i5 = i53; while (0);
  i6 = i5 - i52 | 0;
  i1 = i68 + 11 | 0;
  if (i6 >>> 0 > 10) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i68, 10, i6 + -10 | 0, 0, 0, 0, 0);
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP32[i68 >> 2] | 0;
  } else {
   i2 = 0;
   i3 = 0;
  }
  i2 = i2 << 24 >> 24 < 0 ? i3 : i68;
  if ((i5 | 0) != (i53 | 0)) {
   i3 = i53;
   i4 = i2;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 1 | 0;
   }
   i2 = i2 + i6 | 0;
  }
  HEAP8[i2 >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) HEAP32[i68 + 4 >> 2] = i6; else HEAP8[i1 >> 0] = i6;
  i3 = HEAP32[i62 >> 2] | 0;
  i2 = i3 + 1 | 0;
  HEAP32[i62 >> 2] = i2;
  if ((i54 | 0) > 7) {
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   i4 = i3 + 5 | 0;
   HEAP32[i62 >> 2] = i4;
   i59 = i55 + 56 | 0;
   HEAP32[i59 >> 2] = i2;
   HEAP32[i59 + 4 >> 2] = 0;
   if ((i2 | 0) != 20) {
    HEAP32[i7 >> 2] = i2;
    __Z6FormatPKcz(i67, gb + 588354 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1049, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
    i2 = 0;
    break;
   }
   i1 = i55 + 52 | 0;
   HEAP8[i1 >> 0] = 1;
   if ((i54 | 0) > 12) {
    HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
    i60 = i3 + 6 | 0;
    HEAP32[i62 >> 2] = i60;
    i56 = i62;
    i45 = i1;
    i1 = i60;
    i60 = 19;
   } else {
    i56 = i62;
    i45 = i1;
    i1 = i4;
    i60 = 19;
   }
  } else {
   i1 = i2;
   i60 = 16;
  }
 } else {
  i1 = i53;
  i60 = 16;
 } while (0);
 if ((i60 | 0) == 16) {
  i45 = i55 + 52 | 0;
  HEAP8[i45 >> 0] = 1;
  i56 = i62;
  i60 = 19;
 }
 if ((i60 | 0) == 19) {
  i8 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  HEAP32[i56 >> 2] = i1 + 4;
  HEAP32[i67 >> 2] = -1;
  HEAP32[i67 + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(-1) | 0;
  i1 = i67 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP8[i67 + 41 >> 0] = 1;
  HEAP16[i67 + 42 >> 1] = -1;
  i1 = i67 + 44 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i67 + 48 >> 2] = -1;
  __ZN13dynamic_arrayIN14SerializedFile4TypeELj8EE18resize_initializedEjRKS1_12ResizePolicy(i55, i8, i67, 1);
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i2 = i1 + 40 | 0;
   if ((HEAP32[i1 + 56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 44 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
    i59 = i1 + 20 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i59 >> 2] | 0, i1 + 24 | 0);
    HEAP32[i59 >> 2] = 0;
   }
   if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
    HEAP32[i1 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63720 | 0);
  i43 = i65 + 4 | 0;
  HEAP32[i43 >> 2] = 0;
  i44 = i65 + 8 | 0;
  HEAP32[i44 >> 2] = 0;
  i59 = i65 + 4 | 0;
  HEAP32[i65 >> 2] = i59;
  i58 = gb + 64016 | 0;
  i57 = HEAP32[i58 + 4 >> 2] | 0;
  i42 = i63;
  HEAP32[i42 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i42 + 4 >> 2] = i57;
  HEAP32[i64 >> 2] = 0;
  i42 = i64 + 12 | 0;
  HEAP32[i42 >> 2] = 0;
  i57 = i64 + 16 | 0;
  HEAP32[i57 >> 2] = 0;
  i58 = i64 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i67, i63);
  i1 = i67;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i58;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = (i54 | 0) > 16 & 1;
  i3 = HEAP32[i42 >> 2] | 0;
  HEAP32[i42 >> 2] = i8;
  i1 = HEAP32[i57 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i57 >> 2] = i8;
   HEAP32[i64 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i64 >> 2] | 0, i8, 1, i58, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, i58, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i41 | 0, HEAP32[i64 >> 2] | 0, HEAP32[i42 >> 2] | 0) | 0;
   HEAP32[i57 >> 2] = i8;
   HEAP32[i64 >> 2] = i41;
   break;
  } while (0);
  if (i8 >>> 0 > i3 >>> 0) {
   i1 = i8 - i3 | 0;
   if (i1 | 0) _memset((HEAP32[i64 >> 2] | 0) + i3 | 0, i2 | 0, i1 | 0) | 0;
  }
  L49 : do if ((i8 | 0) > 0) {
   i7 = i59;
   L51 : do if ((i54 | 0) < 16) {
    i6 = 0;
    while (1) {
     HEAP32[i63 >> 2] = 0;
     if (!(__ZN14SerializedFile4Type8ReadTypeILb0EEEbibRPKhS3_Pi((HEAP32[i55 >> 2] | 0) + (i6 * 56 | 0) | 0, i54, (HEAP8[i45 >> 0] | 0) != 0, i62, i61, i63) | 0)) break L51;
     i1 = HEAP32[i59 >> 2] | 0;
     do if (!i1) {
      HEAP32[i67 >> 2] = i59;
      i4 = i7;
      i3 = i59;
      i2 = HEAP32[i63 >> 2] | 0;
      i60 = 47;
     } else {
      i5 = HEAP32[i63 >> 2] | 0;
      while (1) {
       i2 = HEAP32[i1 + 16 >> 2] | 0;
       if ((i5 | 0) < (i2 | 0)) {
        i2 = HEAP32[i1 >> 2] | 0;
        if (!i2) {
         i60 = 45;
         break;
        } else i1 = i2;
       } else {
        if ((i2 | 0) >= (i5 | 0)) {
         i60 = 40;
         break;
        }
        i3 = i1 + 4 | 0;
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i60 = 42;
         break;
        } else i1 = i2;
       }
      }
      if ((i60 | 0) == 40) {
       i60 = 0;
       HEAP32[i67 >> 2] = i1;
       if (!i1) {
        i4 = i1;
        i3 = i67;
        i2 = i5;
        i60 = 47;
        break;
       } else break;
      } else if ((i60 | 0) == 42) {
       HEAP32[i67 >> 2] = i1;
       i4 = i1;
       i2 = i5;
       i60 = 47;
       break;
      } else if ((i60 | 0) == 45) {
       HEAP32[i67 >> 2] = i1;
       i4 = i1;
       i3 = i1;
       i2 = i5;
       i60 = 47;
       break;
      }
     } while (0);
     if ((i60 | 0) == 47) {
      i60 = 0;
      i1 = __Znwj(24) | 0;
      HEAP32[i1 + 16 >> 2] = i2;
      HEAP32[i1 + 20 >> 2] = 0;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i4;
      HEAP32[i3 >> 2] = i1;
      i2 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
      if (!i2) i2 = i1; else {
       HEAP32[i65 >> 2] = i2;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i43 >> 2] | 0, i2);
      HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
     }
     HEAP32[i1 + 20 >> 2] = i6;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i8 | 0)) {
      i60 = 54;
      break L49;
     }
    }
   } else {
    i1 = 0;
    while (1) {
     HEAP32[i63 >> 2] = 0;
     if (!(__ZN14SerializedFile4Type8ReadTypeILb0EEEbibRPKhS3_Pi((HEAP32[i55 >> 2] | 0) + (i1 * 56 | 0) | 0, i54, (HEAP8[i45 >> 0] | 0) != 0, i62, i61, i63) | 0)) break L51;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i8 | 0)) {
      i60 = 54;
      break L49;
     }
    }
   } while (0);
   i2 = 0;
  } else i60 = 54; while (0);
  L79 : do if ((i60 | 0) == 54) {
   if ((i54 + -7 | 0) >>> 0 < 7) {
    i1 = (HEAP32[i62 >> 2] | 0) + 4 | 0;
    HEAP32[i62 >> 2] = i1;
   } else i1 = HEAP32[i56 >> 2] | 0;
   i41 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   HEAP32[i56 >> 2] = i1 + 4;
   i39 = i55 + 32 | 0;
   i40 = i55 + 40 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
   if ((((HEAP32[i40 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0 < i41 >>> 0) {
    i2 = i55 + 36 | 0;
    i3 = (HEAP32[i2 >> 2] | 0) - i1 | 0;
    if (!i41) i5 = 0; else i5 = __Znwj(i41 * 24 | 0) | 0;
    i4 = i5 + (((i3 | 0) / 24 | 0) * 24 | 0) | 0;
    i6 = i4 + (((i3 | 0) / -24 | 0) * 24 | 0) | 0;
    if ((i3 | 0) > 0) _memcpy(i6 | 0, i1 | 0, i3 | 0) | 0;
    HEAP32[i39 >> 2] = i6;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i40 >> 2] = i5 + (i41 * 24 | 0);
    if (i1 | 0) __ZdlPv(i1);
   }
   L95 : do if ((i41 | 0) > 0) {
    i22 = (i54 | 0) > 13;
    i23 = 3 - i52 | 0;
    i24 = (i54 | 0) < 16;
    i25 = (i54 | 0) < 11;
    i26 = (i54 | 0) < 17;
    i27 = (i54 + -11 | 0) >>> 0 < 6;
    i28 = (i54 + -15 | 0) >>> 0 < 2;
    i29 = i59;
    i30 = i67 + 8 | 0;
    i31 = i63 + 4 | 0;
    i32 = i55 + 20 | 0;
    i33 = i55 + 128 | 0;
    i34 = i55 + 44 | 0;
    i35 = i55 + 72 | 0;
    i36 = i55 + 84 | 0;
    i37 = i55 + 88 | 0;
    i38 = i55 + 76 | 0;
    i19 = i67 + 8 | 0;
    i20 = i67 + 12 | 0;
    i21 = i67 + 16 | 0;
    i1 = i55 + 36 | 0;
    i18 = 0;
    L97 : while (1) {
     if (i22) {
      i2 = i53 + (i23 + (HEAP32[i62 >> 2] | 0) & -4) | 0;
      i17 = i2;
      i16 = i17;
      i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
      i17 = i17 + 4 | 0;
      i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
      i2 = i2 + 8 | 0;
      HEAP32[i62 >> 2] = i2;
     } else {
      i2 = HEAP32[i56 >> 2] | 0;
      i17 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
      i2 = i2 + 4 | 0;
      HEAP32[i56 >> 2] = i2;
      i16 = i17;
      i17 = ((i17 | 0) < 0) << 31 >> 31;
     }
     i14 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
     i15 = i2 + 4 | 0;
     i15 = HEAPU8[i15 >> 0] | HEAPU8[i15 + 1 >> 0] << 8 | HEAPU8[i15 + 2 >> 0] << 16 | HEAPU8[i15 + 3 >> 0] << 24;
     i3 = i2 + 8 | 0;
     i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
     i5 = i2 + 12 | 0;
     HEAP32[i56 >> 2] = i5;
     if (i24) {
      i4 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
      i5 = i5 + 2 | 0;
      HEAP32[i62 >> 2] = i5;
      if (i25) {
       i2 = i2 + 16 | 0;
       HEAP32[i62 >> 2] = i2;
       i6 = i2;
       i9 = 1;
      } else {
       i6 = i5;
       i2 = i5;
       i9 = 0;
      }
     } else {
      i4 = 0;
      i6 = i5;
      i2 = i5;
      i9 = 0;
     }
     if (i27) {
      i8 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8;
      i2 = i6 + 2 | 0;
      HEAP32[i62 >> 2] = i2;
     } else i8 = -1;
     if (i28) {
      i13 = HEAP8[i2 >> 0] | 0;
      HEAP32[i62 >> 2] = i2 + 1;
     } else i13 = 0;
     do if (i24) {
      i2 = HEAP32[i59 >> 2] | 0;
      do if (!i2) {
       HEAP32[i67 >> 2] = i59;
       i7 = i29;
       i5 = i59;
       i60 = 88;
      } else {
       while (1) {
        i5 = HEAP32[i2 + 16 >> 2] | 0;
        if ((i3 | 0) < (i5 | 0)) {
         i5 = HEAP32[i2 >> 2] | 0;
         if (!i5) {
          i60 = 81;
          break;
         } else i2 = i5;
        } else {
         if ((i5 | 0) >= (i3 | 0)) {
          i60 = 87;
          break;
         }
         i6 = i2 + 4 | 0;
         i5 = HEAP32[i6 >> 2] | 0;
         if (!i5) {
          i60 = 85;
          break;
         } else i2 = i5;
        }
       }
       if ((i60 | 0) == 81) {
        HEAP32[i67 >> 2] = i2;
        i7 = i2;
        i5 = i2;
        i60 = 88;
        break;
       } else if ((i60 | 0) == 85) {
        HEAP32[i67 >> 2] = i2;
        i7 = i2;
        i5 = i6;
        i60 = 88;
        break;
       } else if ((i60 | 0) == 87) {
        i60 = 0;
        HEAP32[i67 >> 2] = i2;
        if (!i2) {
         i7 = i2;
         i5 = i67;
         i60 = 88;
         break;
        } else break;
       }
      } while (0);
      if ((i60 | 0) == 88) {
       i60 = 0;
       i2 = __Znwj(24) | 0;
       HEAP32[i2 + 16 >> 2] = i3;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i7;
       HEAP32[i5 >> 2] = i2;
       i3 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
       if (!i3) i3 = i2; else {
        HEAP32[i65 >> 2] = i3;
        i3 = HEAP32[i5 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i43 >> 2] | 0, i3);
       HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
      }
      i3 = HEAP32[i2 + 20 >> 2] | 0;
      i2 = HEAP32[i55 >> 2] | 0;
      i5 = i2 + (i3 * 56 | 0) | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i6 | 0) == -1) {
       HEAP8[i2 + (i3 * 56 | 0) + 41 >> 0] = 0;
       i12 = i4 << 16 >> 16;
       HEAP32[i5 >> 2] = i12;
       HEAP32[i2 + (i3 * 56 | 0) + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i12) | 0;
       break;
      }
      i2 = i4 << 16 >> 16;
      if ((i6 | 0) == (i2 | 0)) break;
      i3 = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i55, i2, i13 << 24 >> 24 != 0, i8, i3) | 0;
      HEAP8[(HEAP32[i55 >> 2] | 0) + (i3 * 56 | 0) + 41 >> 0] = 0;
     } while (0);
     do if (i26) {
      i11 = HEAP32[i55 >> 2] | 0;
      i12 = i11 + (i3 * 56 | 0) | 0;
      do if (i9) {
       if ((HEAP32[i12 >> 2] | 0) != 114) {
        i2 = i8;
        break;
       }
       i2 = HEAP32[i11 + (i3 * 56 | 0) + 44 >> 2] | 0;
       if (!i2) {
        i60 = 99;
        break L97;
       }
       i60 = i30;
       HEAP32[i60 >> 2] = 0;
       HEAP32[i60 + 4 >> 2] = 0;
       HEAP32[i67 >> 2] = 0;
       HEAP32[i63 >> 2] = i2;
       HEAP32[i31 >> 2] = 0;
       if (!(__ZL26ExtractScriptTypeReferenceRK16TypeTreeIteratorjR15CacheReaderBasebR31LocalSerializedObjectIdentifier(i63, i14 + i47 + (HEAP32[i32 >> 2] | 0) | 0, HEAP32[i33 >> 2] | 0, (HEAP8[i34 >> 0] | 0) != 0, i67) | 0)) {
        i60 = 115;
        break L97;
       }
       i2 = HEAP32[i35 >> 2] | 0;
       i10 = HEAP32[i36 >> 2] | 0;
       i8 = i2 + (i10 << 4) | 0;
       i9 = i2;
       L146 : do if (!i10) {
        i4 = i2;
        i60 = 106;
       } else {
        i6 = i30;
        i5 = HEAP32[i6 >> 2] | 0;
        i6 = HEAP32[i6 + 4 >> 2] | 0;
        i7 = HEAP32[i67 >> 2] | 0;
        i4 = i2;
        while (1) {
         i60 = i4 + 8 | 0;
         if ((HEAP32[i60 >> 2] | 0) == (i5 | 0) ? (HEAP32[i60 + 4 >> 2] | 0) == (i6 | 0) : 0) if ((HEAP32[i4 >> 2] | 0) == (i7 | 0)) {
          i60 = 106;
          break L146;
         }
         i4 = i4 + 16 | 0;
         if ((i4 | 0) == (i8 | 0)) {
          i60 = 108;
          break;
         }
        }
       } while (0);
       do if ((i60 | 0) == 106) {
        i60 = 0;
        if ((i4 | 0) == (i8 | 0)) {
         i60 = 108;
         break;
        }
        i2 = i4 - i9 >> 4;
       } while (0);
       if ((i60 | 0) == 108) {
        i60 = 0;
        i7 = i10 + 1 | 0;
        i5 = HEAP32[i37 >> 2] | 0;
        i6 = i5 & 2147483647;
        do if (i7 >>> 0 > i6 >>> 0) {
         i4 = i5 << 1;
         i4 = (i4 | 0) == 0 ? 1 : i4;
         if (i6 >>> 0 >= i4 >>> 0) break;
         if ((i5 | 0) > -1) {
          HEAP32[i37 >> 2] = i4;
          i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i4 << 4, 8, i38, 0, gb + 1047584 | 0, 464) | 0;
          HEAP32[i35 >> 2] = i2;
          break;
         } else {
          i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 8, i38, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i2 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i36 >> 2] << 4 | 0) | 0;
          HEAP32[i37 >> 2] = i4;
          HEAP32[i35 >> 2] = i2;
          break;
         }
        } while (0);
        HEAP32[i36 >> 2] = i7;
        i2 = i2 + (i10 << 4) | 0;
        HEAP32[i2 >> 2] = HEAP32[i67 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
        HEAP32[i2 + 12 >> 2] = HEAP32[i67 + 12 >> 2];
        i2 = (HEAP32[i36 >> 2] | 0) + -1 | 0;
       }
       i2 = i2 & 65535;
      } else i2 = i8; while (0);
      do if (i3 >>> 0 < (HEAP32[i42 >> 2] | 0) >>> 0) {
       i4 = (HEAP32[i64 >> 2] | 0) + i3 | 0;
       if (HEAP8[i4 >> 0] | 0) break;
       HEAP8[i11 + (i3 * 56 | 0) + 40 >> 0] = i13;
       HEAP16[i11 + (i3 * 56 | 0) + 42 >> 1] = i2;
       HEAP8[i4 >> 0] = 1;
      } while (0);
      if ((HEAP8[i11 + (i3 * 56 | 0) + 40 >> 0] | 0) != i13 << 24 >> 24) {
       i60 = 120;
       break L97;
      }
      if ((HEAP16[i11 + (i3 * 56 | 0) + 42 >> 1] | 0) == i2 << 16 >> 16) break;
      i3 = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i55, HEAP32[i12 >> 2] | 0, i13 << 24 >> 24 != 0, i2, i3) | 0;
     } while (0);
     i2 = i14 + i47 | 0;
     i14 = i15 + i2 | 0;
     if (i14 >>> 0 < i2 >>> 0 | i14 >>> 0 > i48 >>> 0) {
      i2 = 0;
      break L79;
     }
     i14 = i67;
     HEAP32[i14 >> 2] = i16;
     HEAP32[i14 + 4 >> 2] = i17;
     HEAP32[i19 >> 2] = i2;
     HEAP32[i20 >> 2] = i15;
     HEAP32[i21 >> 2] = i3;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i40 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIxN14SerializedFile10ObjectInfoEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i39, i67); else {
      HEAP32[i2 >> 2] = HEAP32[i67 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
      HEAP32[i2 + 12 >> 2] = HEAP32[i67 + 12 >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i67 + 16 >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i67 + 20 >> 2];
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
     }
     i18 = i18 + 1 | 0;
     if ((i18 | 0) >= (i41 | 0)) break L95;
    }
    if ((i60 | 0) == 99) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 588591 | 0, 0, gb + 588245 | 0, 1172, 1, 0, 0, 0);
     i2 = 0;
     break L79;
    } else if ((i60 | 0) == 115) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 588591 | 0, 0, gb + 588245 | 0, 1179, 1, 0, 0, 0);
     i2 = 0;
     break L79;
    } else if ((i60 | 0) == 120) {
     i2 = HEAP32[i33 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i46 | 0, i2 | 0);
     HEAP32[i49 >> 2] = (HEAP8[i46 + 11 >> 0] | 0) < 0 ? HEAP32[i46 >> 2] | 0 : i46;
     __Z6FormatPKcz(i67, gb + 588617 | 0, i49);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1202, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i46);
     i2 = 0;
     break L79;
    }
   } else i1 = i55 + 36 | 0; while (0);
   L185 : do if ((HEAP32[i55 + 32 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) if (!(HEAP8[i45 >> 0] | 0)) if (!(HEAP32[i55 + 48 >> 2] & 16777216)) {
    i6 = i68 + 11 | 0;
    i3 = HEAP8[i6 >> 0] | 0;
    i49 = i3 << 24 >> 24 < 0;
    i2 = i49 ? HEAP32[i68 >> 2] | 0 : i68;
    i3 = i49 ? HEAP32[i68 + 4 >> 2] | 0 : i3 & 255;
    do if (i3 | 0) {
     i1 = _memchr(i2, 10, i3) | 0;
     if ((i1 | 0) == 0 | (i1 - i2 | 0) == -1) {
      if ((i3 | 0) != 13) break;
      if (!(_memcmp(i2, gb + 1040146 | 0, 13) | 0)) break L185; else break;
     }
     i4 = i1 + 1 | 0;
     i5 = i2 + i3 | 0;
     i3 = i4;
     HEAP32[i67 >> 2] = 0;
     HEAP32[i67 + 4 >> 2] = 0;
     HEAP32[i67 + 8 >> 2] = 0;
     i1 = i5 - i3 | 0;
     if (i1 >>> 0 > 4294967279) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i67);
      i60 = 139;
     } else if (i1 >>> 0 < 11) {
      HEAP8[i67 + 11 >> 0] = i1;
      i1 = i67;
     } else i60 = 139;
     if ((i60 | 0) == 139) {
      i48 = i1 + 16 & -16;
      i49 = __Znwj(i48) | 0;
      HEAP32[i67 >> 2] = i49;
      HEAP32[i67 + 8 >> 2] = i48 | -2147483648;
      HEAP32[i67 + 4 >> 2] = i1;
      i1 = i49;
     }
     if ((i4 | 0) != (i5 | 0)) {
      i2 = i4;
      while (1) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       i2 = i3 + 1 | 0;
       i1 = i1 + 1 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
      }
     }
     HEAP8[i1 >> 0] = 0;
     i1 = HEAP32[gb + 74108 >> 2] | 0;
     i2 = _strlen(i1) | 0;
     i49 = HEAP8[i67 + 11 >> 0] | 0;
     if ((i2 | 0) == ((i49 << 24 >> 24 < 0 ? HEAP32[i67 + 4 >> 2] | 0 : i49 & 255) | 0)) {
      i49 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i67, 0, -1, i1, i2) | 0) == 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
      if (i49) break L185; else break;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
      break;
     }
    } while (0);
    i2 = HEAP32[i55 + 128 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i50 | 0, i2 | 0);
    i2 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i68 >> 2] | 0 : i68;
    HEAP32[i51 >> 2] = (HEAP8[i50 + 11 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50;
    HEAP32[i51 + 4 >> 2] = i2;
    __Z6FormatPKcz(i67, gb + 588653 | 0, i51);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1239, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
    i2 = 0;
    break L79;
   } while (0);
   if ((i54 | 0) > 10) {
    i6 = HEAP32[i56 >> 2] | 0;
    i5 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    HEAP32[i56 >> 2] = i6 + 4;
    i6 = i55 + 72 | 0;
    i1 = i55 + 84 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i55 + 88 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i5 << 4, 8, i55 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i51 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 8, i55 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i51 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i6 >> 2] = i51;
     break;
    } while (0);
    if ((i5 | 0) > 0) {
     i4 = 3 - i52 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     i1 = HEAP32[i56 >> 2] | 0;
     if ((i54 | 0) > 13) {
      i3 = 0;
      do {
       i52 = i2 + (i3 << 4) | 0;
       i51 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
       HEAP8[i52 >> 0] = i51;
       HEAP8[i52 + 1 >> 0] = i51 >> 8;
       HEAP8[i52 + 2 >> 0] = i51 >> 16;
       HEAP8[i52 + 3 >> 0] = i51 >> 24;
       i52 = i53 + (i4 + ((HEAP32[i62 >> 2] | 0) + 4) & -4) | 0;
       i51 = i52;
       i50 = i51;
       i50 = HEAPU8[i50 >> 0] | HEAPU8[i50 + 1 >> 0] << 8 | HEAPU8[i50 + 2 >> 0] << 16 | HEAPU8[i50 + 3 >> 0] << 24;
       i51 = i51 + 4 | 0;
       i51 = HEAPU8[i51 >> 0] | HEAPU8[i51 + 1 >> 0] << 8 | HEAPU8[i51 + 2 >> 0] << 16 | HEAPU8[i51 + 3 >> 0] << 24;
       i1 = i52 + 8 | 0;
       HEAP32[i62 >> 2] = i1;
       i2 = HEAP32[i6 >> 2] | 0;
       i52 = i2 + (i3 << 4) + 8 | 0;
       HEAP32[i52 >> 2] = i50;
       HEAP32[i52 + 4 >> 2] = i51;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i5 | 0));
     } else {
      i3 = 0;
      do {
       i53 = i2 + (i3 << 4) | 0;
       i52 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
       HEAP8[i53 >> 0] = i52;
       HEAP8[i53 + 1 >> 0] = i52 >> 8;
       HEAP8[i53 + 2 >> 0] = i52 >> 16;
       HEAP8[i53 + 3 >> 0] = i52 >> 24;
       i53 = HEAP32[i62 >> 2] | 0;
       i52 = i53 + 4 | 0;
       i52 = HEAPU8[i52 >> 0] | HEAPU8[i52 + 1 >> 0] << 8 | HEAPU8[i52 + 2 >> 0] << 16 | HEAPU8[i52 + 3 >> 0] << 24;
       i1 = i53 + 8 | 0;
       HEAP32[i62 >> 2] = i1;
       i2 = HEAP32[i6 >> 2] | 0;
       i53 = i2 + (i3 << 4) + 8 | 0;
       HEAP32[i53 >> 2] = i52;
       HEAP32[i53 + 4 >> 2] = ((i52 | 0) < 0) << 31 >> 31;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i5 | 0));
     }
    }
   }
   i20 = HEAP32[i56 >> 2] | 0;
   i19 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
   HEAP32[i56 >> 2] = i20 + 4;
   i20 = i55 + 92 | 0;
   __ZN20dynamic_block_vectorI14FileIdentifierE6resizeEj(i20, i19);
   i21 = (i54 | 0) > 4;
   if ((i19 | 0) > 0) {
    i13 = (i54 | 0) == 5;
    i14 = i63 + 12 | 0;
    i15 = i63 + 11 | 0;
    i16 = i63 + 4 | 0;
    i17 = i63 + 12 | 0;
    i18 = i67 + 4 | 0;
    i12 = i55 + 108 | 0;
    i11 = 0;
    do {
     if (i21) {
      if (!i13) {
       HEAP32[i63 >> 2] = 0;
       HEAP32[i63 + 4 >> 2] = 0;
       HEAP32[i63 + 8 >> 2] = 0;
       HEAP32[i14 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i63 >> 2] = 0;
       HEAP32[i63 + 4 >> 2] = 0;
       HEAP32[i63 + 8 >> 2] = 0;
       i2 = HEAP32[i62 >> 2] | 0;
       L234 : do if (i2 >>> 0 < i61 >>> 0) {
        i1 = i2;
        while (1) {
         if (!(HEAP8[i1 >> 0] | 0)) {
          i4 = i1;
          break L234;
         }
         i1 = i1 + 1 | 0;
         HEAP32[i62 >> 2] = i1;
         if (i1 >>> 0 >= i61 >>> 0) {
          i4 = i1;
          break;
         }
        }
       } else i4 = i2; while (0);
       i5 = i4 - i2 | 0;
       if (i5 >>> 0 > 10) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i63, 10, i5 + -10 | 0, 0, 0, 0, 0);
        i1 = HEAP8[i15 >> 0] | 0;
        i3 = HEAP32[i63 >> 2] | 0;
       } else {
        i1 = 0;
        i3 = 0;
       }
       i1 = i1 << 24 >> 24 < 0 ? i3 : i63;
       if ((i2 | 0) != (i4 | 0)) {
        i3 = i1;
        while (1) {
         HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
        }
        i1 = i1 + i5 | 0;
       }
       HEAP8[i1 >> 0] = 0;
       if ((HEAP8[i15 >> 0] | 0) < 0) {
        HEAP32[i16 >> 2] = i5;
        HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
        i60 = 171;
       } else {
        i55 = i5 & 255;
        HEAP8[i15 >> 0] = i55;
        HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
        if (i55 << 24 >> 24 < 0) i60 = 171;
       }
       if ((i60 | 0) == 171) {
        i60 = 0;
        i55 = HEAP32[i63 >> 2] | 0;
        i54 = HEAP32[i17 >> 2] | 0;
        HEAP32[i67 >> 2] = 66;
        HEAP32[i18 >> 2] = i54;
        __Z19free_alloc_internalPvRK10MemLabelId(i55, i67);
       }
      }
      i55 = HEAP32[i20 >> 2] | 0;
      i55 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 20 | 0;
      i2 = HEAP32[i56 >> 2] | 0;
      i54 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
      HEAP8[i55 >> 0] = i54;
      HEAP8[i55 + 1 >> 0] = i54 >> 8;
      HEAP8[i55 + 2 >> 0] = i54 >> 16;
      HEAP8[i55 + 3 >> 0] = i54 >> 24;
      i55 = i2 + 4 | 0;
      HEAP32[i56 >> 2] = i55;
      i54 = HEAP32[i20 >> 2] | 0;
      i54 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i54 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i54 >>> 0) | 0) * 36 | 0) + 24 | 0;
      i55 = HEAPU8[i55 >> 0] | HEAPU8[i55 + 1 >> 0] << 8 | HEAPU8[i55 + 2 >> 0] << 16 | HEAPU8[i55 + 3 >> 0] << 24;
      HEAP8[i54 >> 0] = i55;
      HEAP8[i54 + 1 >> 0] = i55 >> 8;
      HEAP8[i54 + 2 >> 0] = i55 >> 16;
      HEAP8[i54 + 3 >> 0] = i55 >> 24;
      i54 = i2 + 8 | 0;
      HEAP32[i56 >> 2] = i54;
      i55 = HEAP32[i20 >> 2] | 0;
      i55 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 28 | 0;
      i54 = HEAPU8[i54 >> 0] | HEAPU8[i54 + 1 >> 0] << 8 | HEAPU8[i54 + 2 >> 0] << 16 | HEAPU8[i54 + 3 >> 0] << 24;
      HEAP8[i55 >> 0] = i54;
      HEAP8[i55 + 1 >> 0] = i54 >> 8;
      HEAP8[i55 + 2 >> 0] = i54 >> 16;
      HEAP8[i55 + 3 >> 0] = i54 >> 24;
      i55 = i2 + 12 | 0;
      HEAP32[i56 >> 2] = i55;
      i54 = HEAP32[i20 >> 2] | 0;
      i54 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i54 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i54 >>> 0) | 0) * 36 | 0) + 32 | 0;
      i55 = HEAPU8[i55 >> 0] | HEAPU8[i55 + 1 >> 0] << 8 | HEAPU8[i55 + 2 >> 0] << 16 | HEAPU8[i55 + 3 >> 0] << 24;
      HEAP8[i54 >> 0] = i55;
      HEAP8[i54 + 1 >> 0] = i55 >> 8;
      HEAP8[i54 + 2 >> 0] = i55 >> 16;
      HEAP8[i54 + 3 >> 0] = i55 >> 24;
      i54 = i2 + 16 | 0;
      HEAP32[i56 >> 2] = i54;
      i55 = HEAP32[i20 >> 2] | 0;
      i55 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 16 | 0;
      i54 = HEAPU8[i54 >> 0] | HEAPU8[i54 + 1 >> 0] << 8 | HEAPU8[i54 + 2 >> 0] << 16 | HEAPU8[i54 + 3 >> 0] << 24;
      HEAP8[i55 >> 0] = i54;
      HEAP8[i55 + 1 >> 0] = i54 >> 8;
      HEAP8[i55 + 2 >> 0] = i54 >> 16;
      HEAP8[i55 + 3 >> 0] = i54 >> 24;
      i2 = i2 + 20 | 0;
      HEAP32[i56 >> 2] = i2;
     } else i2 = HEAP32[i62 >> 2] | 0;
     i10 = HEAP32[i20 >> 2] | 0;
     i9 = (i11 >>> 0) % (i10 >>> 0) | 0;
     i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (((i11 >>> 0) / (i10 >>> 0) | 0) << 2) >> 2] | 0;
     i5 = i10 + (i9 * 36 | 0) | 0;
     L256 : do if (i2 >>> 0 < i61 >>> 0) {
      i1 = i2;
      while (1) {
       if (!(HEAP8[i1 >> 0] | 0)) {
        i6 = i1;
        break L256;
       }
       i1 = i1 + 1 | 0;
       HEAP32[i62 >> 2] = i1;
       if (i1 >>> 0 >= i61 >>> 0) {
        i6 = i1;
        break;
       }
      }
     } else i6 = i2; while (0);
     i7 = i6 - i2 | 0;
     i8 = i5 + 11 | 0;
     i1 = HEAP8[i8 >> 0] | 0;
     i3 = i1 << 24 >> 24 < 0;
     if (i3) i4 = (HEAP32[i10 + (i9 * 36 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     if (i7 >>> 0 > i4 >>> 0) {
      i1 = i3 ? HEAP32[i10 + (i9 * 36 | 0) + 4 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i5, i4, i7 - i4 | 0, i1, 0, i1, 0);
      i1 = HEAP8[i8 >> 0] | 0;
     }
     i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5;
     if ((i2 | 0) != (i6 | 0)) {
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
      }
      i1 = i1 + i7 | 0;
     }
     HEAP8[i1 >> 0] = 0;
     if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i10 + (i9 * 36 | 0) + 4 >> 2] = i7; else HEAP8[i8 >> 0] = i7;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i19 | 0));
   }
   if (i21) {
    HEAP32[i63 >> 2] = 0;
    HEAP32[i63 + 4 >> 2] = 0;
    HEAP32[i63 + 8 >> 2] = 0;
    HEAP32[i63 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i63 >> 2] = 0;
    HEAP32[i63 + 4 >> 2] = 0;
    HEAP32[i63 + 8 >> 2] = 0;
    i2 = HEAP32[i62 >> 2] | 0;
    L278 : do if (i2 >>> 0 < i61 >>> 0) {
     i1 = i2;
     do {
      if (!(HEAP8[i1 >> 0] | 0)) break L278;
      i1 = i1 + 1 | 0;
      HEAP32[i62 >> 2] = i1;
     } while (i1 >>> 0 < i61 >>> 0);
    } else i1 = i2; while (0);
    i6 = i1 - i2 | 0;
    i7 = i63 + 11 | 0;
    if (i6 >>> 0 > 10) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i63, 10, i6 + -10 | 0, 0, 0, 0, 0);
     i5 = i63;
     i4 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i63 >> 2] | 0 : i63;
    } else {
     i5 = i63;
     i4 = i63;
    }
    if ((i2 | 0) == (i1 | 0)) i1 = i4; else {
     i3 = i4;
     while (1) {
      HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i1 | 0)) break; else i3 = i3 + 1 | 0;
     }
     i1 = i4 + i6 | 0;
    }
    HEAP8[i1 >> 0] = 0;
    if ((HEAP8[i7 >> 0] | 0) < 0) {
     HEAP32[i63 + 4 >> 2] = i6;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     i60 = 201;
    } else {
     i61 = i6 & 255;
     HEAP8[i7 >> 0] = i61;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     if (i61 << 24 >> 24 < 0) i60 = 201;
    }
    if ((i60 | 0) == 201) {
     i62 = HEAP32[i5 >> 2] | 0;
     i63 = HEAP32[i63 + 12 >> 2] | 0;
     HEAP32[i67 >> 2] = 66;
     HEAP32[i67 + 4 >> 2] = i63;
     __Z19free_alloc_internalPvRK10MemLabelId(i62, i67);
    }
    i2 = 1;
   } else i2 = 1;
  } while (0);
  if ((HEAP32[i57 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i64 >> 2] | 0, i58);
   HEAP32[i64 >> 2] = 0;
  }
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i65, HEAP32[i59 >> 2] | 0);
  i1 = i68 + 11 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i65 = HEAP32[i68 >> 2] | 0;
  i68 = HEAP32[i68 + 12 >> 2] | 0;
  HEAP32[i67 >> 2] = 66;
  HEAP32[i67 + 4 >> 2] = i68;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i67);
 }
 if (!i66) {
  STACKTOP = i69;
  return i2 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i69;
 return i2 | 0;
}

function __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i111, i104, i105, i106, i113, i100, i103, i2, i129, f102, i101, i1) {
 i111 = i111 | 0;
 i104 = i104 | 0;
 i105 = i105 | 0;
 i106 = i106 | 0;
 i113 = i113 | 0;
 i100 = i100 | 0;
 i103 = i103 | 0;
 i2 = i2 | 0;
 i129 = i129 | 0;
 f102 = Math_fround(f102);
 i101 = i101 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, d5 = 0.0, d6 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, d60 = 0.0, d61 = 0.0, d62 = 0.0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i112 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i130 = 0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, d141 = 0.0;
 i130 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i116 = i130 + 80 | 0;
 i117 = i130 + 296 | 0;
 i122 = i130 + 256 | 0;
 i123 = i130 + 224 | 0;
 i124 = i130 + 212 | 0;
 i121 = i130 + 208 | 0;
 i125 = i130 + 180 | 0;
 i120 = i130 + 168 | 0;
 i119 = i130 + 152 | 0;
 i110 = i130 + 56 | 0;
 i99 = i130 + 136 | 0;
 i98 = i130;
 f12 = Math_fround(HEAPF32[i100 >> 2]);
 i128 = f12 == Math_fround(0.0);
 i33 = i100 + 4 | 0;
 if (i128 & Math_fround(HEAPF32[i33 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i100 + 8 >> 2]) == Math_fround(0.0)) {
  i129 = 0;
  STACKTOP = i130;
  return i129 | 0;
 }
 i20 = i111 + 308 | 0;
 HEAP32[i20 >> 2] = HEAP32[i20 >> 2] & -53;
 i27 = i111 + 156 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i111 + 160 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i111 + 152 | 0;
 HEAP32[i29 >> 2] = -1;
 i30 = (HEAP8[(HEAP32[i105 >> 2] | 0) + 486 >> 0] | 0) != 0;
 i128 = i113 + 8 | 0;
 HEAP32[i110 >> 2] = HEAP32[i128 >> 2];
 HEAP32[i110 + 4 >> 2] = HEAP32[i128 + 4 >> 2];
 HEAP32[i110 + 8 >> 2] = HEAP32[i128 + 8 >> 2];
 HEAP32[i110 + 12 >> 2] = HEAP32[i128 + 12 >> 2];
 HEAP32[i110 + 16 >> 2] = HEAP32[i128 + 16 >> 2];
 HEAP32[i110 + 20 >> 2] = HEAP32[i128 + 20 >> 2];
 i126 = i113 + 16 | 0;
 i127 = i113 + 24 | 0;
 i31 = i100 + 8 | 0;
 L5 : do if (!i2) {
  i2 = 0;
  i1 = 0;
 } else {
  d5 = +HEAPF64[i127 >> 3] + +Math_fround(HEAPF32[i31 >> 2]);
  d6 = +HEAPF64[i126 >> 3] + +Math_fround(HEAPF32[i33 >> 2]);
  i32 = i111 + 306 | 0;
  i108 = i110 + 8 | 0;
  i109 = i110 + 16 | 0;
  i34 = i99 + 4 | 0;
  i35 = i99 + 8 | 0;
  i107 = i111 + 260 | 0;
  i36 = i98 + 36 | 0;
  i37 = i111 + 282 | 0;
  i114 = i111 + 32 | 0;
  i115 = i111 + 36 | 0;
  i38 = i98 + 40 | 0;
  i39 = i98 + 44 | 0;
  i40 = i98 + 48 | 0;
  i118 = i113 + 36 | 0;
  i41 = i116 + 36 | 0;
  i42 = i116 + 40 | 0;
  i43 = i116 + 44 | 0;
  i44 = i98 + 24 | 0;
  i45 = i116 + 24 | 0;
  i46 = i116 + 28 | 0;
  i47 = i98 + 28 | 0;
  i48 = i116 + 32 | 0;
  i49 = i98 + 32 | 0;
  i50 = (i1 | 0) == 3;
  i51 = i105 + 8 | 0;
  i52 = i105 + 12 | 0;
  i53 = (i1 | 0) == 2;
  i54 = i98 + 8 | 0;
  i55 = i98 + 16 | 0;
  i56 = i111 + 212 | 0;
  i63 = i111 + 216 | 0;
  i64 = i111 + 220 | 0;
  i65 = i111 + 200 | 0;
  i66 = i111 + 204 | 0;
  i67 = i111 + 208 | 0;
  i68 = (i1 | 0) != 2;
  i69 = i111 + 244 | 0;
  i70 = i111 + 248 | 0;
  i71 = i111 + 252 | 0;
  i72 = i111 + 292 | 0;
  i73 = i111 + 224 | 0;
  i74 = i117 + 16 | 0;
  i75 = i117 + 20 | 0;
  i76 = i117 + 24 | 0;
  i77 = i116 + 12 | 0;
  i78 = i116 + 4 | 0;
  i79 = i116 + 8 | 0;
  i80 = i116 + 16 | 0;
  i81 = i116 + 20 | 0;
  i82 = i116 + 24 | 0;
  i83 = i117 + 12 | 0;
  i84 = i117 + 8 | 0;
  i85 = i117 + 4 | 0;
  i86 = i111 + 188 | 0;
  i87 = i111 + 192 | 0;
  i88 = i111 + 196 | 0;
  i89 = i111 + 176 | 0;
  i90 = i111 + 180 | 0;
  i91 = i111 + 184 | 0;
  i92 = i111 + 8 | 0;
  i93 = i111 + 48 | 0;
  i94 = i111 + 72 | 0;
  i95 = i111 + 56 | 0;
  i96 = i111 + 80 | 0;
  i97 = i111 + 64 | 0;
  i21 = i111 + 88 | 0;
  i22 = i111 + 144 | 0;
  i23 = i111 + 148 | 0;
  i24 = i111 + 120 | 0;
  i25 = i111 + 124 | 0;
  i26 = i111 + 128 | 0;
  i11 = (i1 & -3 | 0) != 1;
  i16 = i111 + 132 | 0;
  i17 = i111 + 136 | 0;
  i18 = i111 + 140 | 0;
  i19 = i111 + 284 | 0;
  i10 = i2;
  d7 = +HEAPF64[i113 + 8 >> 3] + +f12;
  d60 = +HEAPF64[i110 >> 3];
  d61 = +HEAPF64[i108 >> 3];
  d62 = +HEAPF64[i109 >> 3];
  i2 = 0;
  i1 = 0;
  while (1) {
   HEAP16[i32 >> 1] = (HEAP16[i32 >> 1] | 0) + 1 << 16 >> 16;
   f57 = Math_fround(d6 - d61);
   f12 = Math_fround(d5 - d62);
   HEAPF32[i99 >> 2] = Math_fround(d7 - d60);
   HEAPF32[i34 >> 2] = f57;
   HEAPF32[i35 >> 2] = f12;
   mftCall_viiiii(HEAP32[(HEAP32[i113 >> 2] | 0) + 8 >> 2] | 0, i113 | 0, i111 | 0, i116 | 0, i110 | 0, i99 | 0);
   __ZN5physx3Cct9SweepTest18updateTouchedGeomsEPKNS0_30InternalCBData_FindTouchedGeomERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3ERKNS_19PxControllerFiltersERKNS_6PxVec3E(i111, i104, i106, i116, i101, i103);
   f12 = Math_fround(HEAPF32[i99 >> 2]);
   f57 = Math_fround(f12 * f12);
   f13 = Math_fround(HEAPF32[i34 >> 2]);
   f57 = Math_fround(f57 + Math_fround(f13 * f13));
   f14 = Math_fround(HEAPF32[i35 >> 2]);
   f57 = Math_fround(Math_sqrt(Math_fround(f57 + Math_fround(f14 * f14))));
   if (f57 <= f102) break L5;
   f59 = Math_fround(Math_fround(1.0) / f57);
   f15 = Math_fround(f12 * f59);
   HEAPF32[i99 >> 2] = f15;
   f58 = Math_fround(f59 * f13);
   HEAPF32[i34 >> 2] = f58;
   f59 = Math_fround(f59 * f14);
   HEAPF32[i35 >> 2] = f59;
   f15 = Math_fround(f15 * Math_fround(HEAPF32[i100 >> 2]));
   f58 = Math_fround(f15 + Math_fround(f58 * Math_fround(HEAPF32[i33 >> 2])));
   if (Math_fround(f58 + Math_fround(f59 * Math_fround(HEAPF32[i31 >> 2]))) <= Math_fround(0.0)) break L5;
   HEAPF32[i36 >> 2] = Math_fround(f57 + Math_fround(HEAPF32[i107 >> 2]));
   i3 = HEAP8[i37 >> 0] | 0;
   i1 = HEAP32[i114 >> 2] | 0;
   i112 = HEAP32[i115 >> 2] | 0;
   HEAP32[i38 >> 2] = -1;
   HEAP32[i39 >> 2] = -1;
   HEAP32[i40 >> 2] = 0;
   i8 = i1 + (i112 << 2) | 0;
   if (!i112) {
    i112 = 28;
    break;
   }
   L12 : do if (!(i3 << 24 >> 24)) {
    i4 = i1;
    while (1) {
     i1 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[gb + 83892 + ((HEAP32[i118 >> 2] | 0) * 24 | 0) + (i1 << 2) >> 2] | 0;
     if (i3) {
      HEAP32[i41 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i42 >> 2] = -1;
      HEAP32[i43 >> 2] = -1;
      if (mftCall_iiiiiii(i3 | 0, i111 | 0, i113 | 0, i4 | 0, i110 | 0, i99 | 0, i116 | 0) | 0) {
       f12 = Math_fround(HEAPF32[i41 >> 2]);
       i112 = f12 != Math_fround(0.0);
       if (i112 & f12 < Math_fround(HEAPF32[i36 >> 2])) {
        HEAP32[i98 >> 2] = HEAP32[i116 >> 2];
        HEAP32[i98 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
        HEAP32[i98 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
        HEAP32[i98 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
        HEAP32[i98 + 16 >> 2] = HEAP32[i116 + 16 >> 2];
        HEAP32[i98 + 20 >> 2] = HEAP32[i116 + 20 >> 2];
        HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
        HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
        HEAP32[i36 >> 2] = HEAP32[i41 >> 2];
        HEAP32[i36 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
        HEAP32[i36 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
        HEAP32[i40 >> 2] = i4;
        if (f12 <= Math_fround(0.0)) {
         i1 = i4;
         i3 = i4;
         i112 = 23;
         break L12;
        }
       }
      }
      i1 = HEAP32[i4 >> 2] | 0;
     }
     i4 = i4 + ((HEAP32[gb + 83868 + (i1 << 2) >> 2] | 0) + 7 & -8) | 0;
     if ((i4 | 0) == (i8 | 0)) {
      i112 = 26;
      break;
     }
    }
   } else {
    i4 = i1;
    L22 : while (1) {
     i1 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[gb + 83892 + ((HEAP32[i118 >> 2] | 0) * 24 | 0) + (i1 << 2) >> 2] | 0;
     if (i3) {
      HEAP32[i41 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i42 >> 2] = -1;
      HEAP32[i43 >> 2] = -1;
      do if (mftCall_iiiiiii(i3 | 0, i111 | 0, i113 | 0, i4 | 0, i110 | 0, i99 | 0, i116 | 0) | 0) {
       f12 = Math_fround(HEAPF32[i41 >> 2]);
       if (f12 == Math_fround(0.0)) {
        if ((HEAP32[i4 >> 2] | 0) >>> 0 < 2) break;
        if ((HEAP16[(HEAP32[i4 + 8 >> 2] | 0) + 4 >> 1] | 0) == 6) {
         i3 = i4;
         i1 = i4;
         break L22;
        } else break;
       } else {
        if (!(f12 < Math_fround(HEAPF32[i36 >> 2]))) break;
        HEAP32[i98 >> 2] = HEAP32[i116 >> 2];
        HEAP32[i98 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
        HEAP32[i98 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
        HEAP32[i98 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
        HEAP32[i98 + 16 >> 2] = HEAP32[i116 + 16 >> 2];
        HEAP32[i98 + 20 >> 2] = HEAP32[i116 + 20 >> 2];
        HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
        HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
        HEAP32[i36 >> 2] = HEAP32[i41 >> 2];
        HEAP32[i36 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
        HEAP32[i36 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
        HEAP32[i40 >> 2] = i4;
        if (!(f12 <= Math_fround(0.0))) break; else {
         i1 = i4;
         i3 = i4;
         i112 = 23;
         break L12;
        }
       }
      } while (0);
      i1 = HEAP32[i4 >> 2] | 0;
     }
     i4 = i4 + ((HEAP32[gb + 83868 + (i1 << 2) >> 2] | 0) + 7 & -8) | 0;
     if ((i4 | 0) == (i8 | 0)) {
      i112 = 26;
      break L12;
     }
    }
    HEAP32[i98 >> 2] = HEAP32[i116 >> 2];
    HEAP32[i98 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
    HEAP32[i98 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
    HEAP32[i98 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
    HEAP32[i98 + 16 >> 2] = HEAP32[i116 + 16 >> 2];
    HEAP32[i98 + 20 >> 2] = HEAP32[i116 + 20 >> 2];
    HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i40 >> 2] = i1;
    i112 = 23;
   } while (0);
   if ((i112 | 0) == 23) i112 = 0; else if ((i112 | 0) == 26) {
    i112 = 0;
    i1 = HEAP32[i40 >> 2] | 0;
    i3 = i1;
   }
   if (!i3) {
    i112 = 28;
    break;
   }
   if (HEAP8[i37 >> 0] | 0 ? Math_fround(HEAPF32[i36 >> 2]) == Math_fround(0.0) : 0) break;
   do if ((HEAP32[i1 >> 2] | 0) >>> 0 < 2) if (i50) {
    i1 = 0;
    i3 = 1;
   } else {
    HEAP32[i51 >> 2] = 0;
    HEAP32[i52 >> 2] = -1;
    i3 = ((__ZN5physx3Cct15userHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef(i105, i98, i99, f57) | 0) & 2 | 0) == 0;
    i1 = HEAP32[i51 >> 2] | 0;
    i4 = HEAP32[i52 >> 2] | 0;
    if (i53) {
     i8 = HEAP32[i20 >> 2] | 0;
     if (!i1) {
      HEAP32[i20 >> 2] = i8 | 16;
      i1 = 0;
      break;
     } else {
      HEAP32[i20 >> 2] = i8 | 32;
      HEAP32[i29 >> 2] = i4;
      f58 = Math_fround(+HEAPF64[i98 >> 3]);
      f133 = Math_fround(+HEAPF64[i54 >> 3]);
      f131 = Math_fround(+HEAPF64[i55 >> 3]);
      HEAPF32[i56 >> 2] = f58;
      HEAPF32[i63 >> 2] = f133;
      HEAPF32[i64 >> 2] = f131;
      f132 = Math_fround(+HEAPF64[i1 + 8 >> 3]);
      f15 = Math_fround(+HEAPF64[i1 + 16 >> 3]);
      f14 = Math_fround(+HEAPF64[i1 + 24 >> 3]);
      f134 = Math_fround(HEAPF32[i1 + 32 >> 2]);
      f13 = Math_fround(HEAPF32[i1 + 36 >> 2]);
      f57 = Math_fround(HEAPF32[i1 + 40 >> 2]);
      f12 = Math_fround(HEAPF32[i1 + 44 >> 2]);
      f132 = Math_fround(Math_fround(f58 - f132) * Math_fround(2.0));
      f15 = Math_fround(Math_fround(f133 - f15) * Math_fround(2.0));
      f14 = Math_fround(Math_fround(f131 - f14) * Math_fround(2.0));
      f131 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
      f133 = Math_fround(Math_fround(Math_fround(f132 * f134) + Math_fround(f15 * f13)) + Math_fround(f14 * f57));
      f58 = Math_fround(Math_fround(f13 * f133) + Math_fround(Math_fround(f15 * f131) - Math_fround(f12 * Math_fround(Math_fround(f132 * f57) - Math_fround(f134 * f14)))));
      f59 = Math_fround(Math_fround(f57 * f133) + Math_fround(Math_fround(f14 * f131) - Math_fround(f12 * Math_fround(Math_fround(f134 * f15) - Math_fround(f132 * f13)))));
      HEAPF32[i65 >> 2] = Math_fround(Math_fround(f134 * f133) + Math_fround(Math_fround(f132 * f131) - Math_fround(f12 * Math_fround(Math_fround(f13 * f14) - Math_fround(f15 * f57)))));
      HEAPF32[i66 >> 2] = f58;
      HEAPF32[i67 >> 2] = f59;
      i1 = 0;
      break;
     }
    } else i1 = 0;
   } else {
    i9 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP16[i8 + 4 >> 1] | 0;
    if (i1 << 16 >> 16 == 6) i4 = 1; else i4 = i30 & i1 << 16 >> 16 == 5;
    if (i53) {
     i1 = HEAP32[i20 >> 2] & -49;
     HEAP32[i20 >> 2] = i1;
     i3 = HEAP32[i38 >> 2] | 0;
     if (!((i3 | 0) == -1 | i4 ^ 1)) {
      HEAP32[i20 >> 2] = i1 | 4;
      i4 = HEAP32[i92 >> 2] | 0;
      f14 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) >> 2]);
      f139 = Math_fround(HEAPF32[i69 >> 2]);
      f140 = Math_fround(f14 * f139);
      f134 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 4 >> 2]);
      f138 = Math_fround(HEAPF32[i70 >> 2]);
      f140 = Math_fround(f140 + Math_fround(f134 * f138));
      f13 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 8 >> 2]);
      f58 = Math_fround(HEAPF32[i71 >> 2]);
      f140 = Math_fround(f140 + Math_fround(f13 * f58));
      f133 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 12 >> 2]);
      f136 = Math_fround(f139 * f133);
      f15 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 16 >> 2]);
      f136 = Math_fround(f136 + Math_fround(f138 * f15));
      f132 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 20 >> 2]);
      f136 = Math_fround(f136 + Math_fround(f58 * f132));
      f59 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 24 >> 2]);
      f135 = Math_fround(f139 * f59);
      f131 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 28 >> 2]);
      f135 = Math_fround(f135 + Math_fround(f138 * f131));
      f12 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 32 >> 2]);
      f135 = Math_fround(f135 + Math_fround(f58 * f12));
      f137 = f140 < f136 ? f140 : f136;
      f136 = f140 > f136 ? f140 : f136;
      f58 = Math_fround(Math_fround(Math_fround(f139 * Math_fround((+HEAPF64[i93 >> 3] + +HEAPF64[i94 >> 3]) * .5)) + Math_fround(f138 * Math_fround((+HEAPF64[i95 >> 3] + +HEAPF64[i96 >> 3]) * .5))) + Math_fround(f58 * Math_fround((+HEAPF64[i97 >> 3] + +HEAPF64[i21 >> 3]) * .5)));
      HEAPF32[i22 >> 2] = Math_fround((f137 < f135 ? f137 : f135) + f58);
      HEAPF32[i23 >> 2] = Math_fround((f136 > f135 ? f136 : f135) + f58);
      f133 = Math_fround(f133 - f14);
      f15 = Math_fround(f15 - f134);
      f132 = Math_fround(f132 - f13);
      f14 = Math_fround(f59 - f14);
      f134 = Math_fround(f131 - f134);
      f13 = Math_fround(f12 - f13);
      f12 = Math_fround(Math_fround(f15 * f13) - Math_fround(f132 * f134));
      f13 = Math_fround(Math_fround(f132 * f14) - Math_fround(f133 * f13));
      f14 = Math_fround(Math_fround(f133 * f134) - Math_fround(f15 * f14));
      HEAPF32[i24 >> 2] = f12;
      HEAPF32[i25 >> 2] = f13;
      HEAPF32[i26 >> 2] = f14;
      f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)))));
      if (f15 > Math_fround(0.0)) {
       f140 = Math_fround(Math_fround(1.0) / f15);
       HEAPF32[i24 >> 2] = Math_fround(f12 * f140);
       HEAPF32[i25 >> 2] = Math_fround(f13 * f140);
       HEAPF32[i26 >> 2] = Math_fround(f14 * f140);
      }
     }
     HEAP32[i27 >> 2] = i9;
     HEAP32[i28 >> 2] = i8;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 84 >> 2] | 0, i116 | 0, i8 | 0);
     mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 72 >> 2] | 0, i117 | 0, i9 | 0);
     f140 = Math_fround(Math_fround(HEAPF32[i74 >> 2]) * Math_fround(2.0));
     f59 = Math_fround(Math_fround(HEAPF32[i75 >> 2]) * Math_fround(2.0));
     f134 = Math_fround(Math_fround(HEAPF32[i76 >> 2]) * Math_fround(2.0));
     f14 = Math_fround(HEAPF32[i77 >> 2]);
     f15 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
     f58 = Math_fround(HEAPF32[i116 >> 2]);
     f136 = Math_fround(f140 * f58);
     f132 = Math_fround(HEAPF32[i78 >> 2]);
     f136 = Math_fround(f136 + Math_fround(f59 * f132));
     f139 = Math_fround(HEAPF32[i79 >> 2]);
     f136 = Math_fround(f136 + Math_fround(f134 * f139));
     f133 = Math_fround(Math_fround(f58 * f136) + Math_fround(Math_fround(f140 * f15) + Math_fround(f14 * Math_fround(Math_fround(f134 * f132) - Math_fround(f59 * f139)))));
     f138 = Math_fround(Math_fround(f132 * f136) + Math_fround(Math_fround(f59 * f15) + Math_fround(f14 * Math_fround(Math_fround(f140 * f139) - Math_fround(f134 * f58)))));
     f136 = Math_fround(Math_fround(Math_fround(f134 * f15) + Math_fround(f14 * Math_fround(Math_fround(f59 * f58) - Math_fround(f140 * f132)))) + Math_fround(f139 * f136));
     f133 = Math_fround(Math_fround(HEAPF32[i80 >> 2]) + f133);
     f138 = Math_fround(Math_fround(HEAPF32[i81 >> 2]) + f138);
     f136 = Math_fround(Math_fround(HEAPF32[i82 >> 2]) + f136);
     f140 = Math_fround(HEAPF32[i117 >> 2]);
     f59 = Math_fround(f14 * f140);
     f15 = Math_fround(HEAPF32[i83 >> 2]);
     f59 = Math_fround(f59 + Math_fround(f58 * f15));
     f134 = Math_fround(HEAPF32[i84 >> 2]);
     f59 = Math_fround(f59 + Math_fround(f132 * f134));
     f131 = Math_fround(HEAPF32[i85 >> 2]);
     f59 = Math_fround(f59 - Math_fround(f139 * f131));
     f135 = Math_fround(Math_fround(Math_fround(f139 * f140) + Math_fround(Math_fround(f132 * f15) + Math_fround(f14 * f131))) - Math_fround(f58 * f134));
     f137 = Math_fround(Math_fround(Math_fround(f58 * f131) + Math_fround(Math_fround(f139 * f15) + Math_fround(f14 * f134))) - Math_fround(f132 * f140));
     f134 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f58 * f140)) - Math_fround(f132 * f131)) - Math_fround(f139 * f134));
     f139 = Math_fround(+HEAPF64[i98 >> 3]);
     f131 = Math_fround(+HEAPF64[i54 >> 3]);
     f132 = Math_fround(+HEAPF64[i55 >> 3]);
     HEAPF32[i86 >> 2] = f139;
     HEAPF32[i87 >> 2] = f131;
     HEAPF32[i88 >> 2] = f132;
     f133 = Math_fround(Math_fround(f139 - f133) * Math_fround(2.0));
     f138 = Math_fround(Math_fround(f131 - f138) * Math_fround(2.0));
     f136 = Math_fround(Math_fround(f132 - f136) * Math_fround(2.0));
     f132 = Math_fround(Math_fround(f134 * f134) + Math_fround(-.5));
     f131 = Math_fround(Math_fround(Math_fround(f59 * f133) + Math_fround(f135 * f138)) + Math_fround(f137 * f136));
     f139 = Math_fround(Math_fround(f135 * f131) + Math_fround(Math_fround(f132 * f138) - Math_fround(f134 * Math_fround(Math_fround(f137 * f133) - Math_fround(f59 * f136)))));
     f140 = Math_fround(Math_fround(Math_fround(f132 * f136) - Math_fround(f134 * Math_fround(Math_fround(f59 * f138) - Math_fround(f135 * f133)))) + Math_fround(f137 * f131));
     HEAPF32[i89 >> 2] = Math_fround(Math_fround(f59 * f131) + Math_fround(Math_fround(f132 * f133) - Math_fround(f134 * Math_fround(Math_fround(f135 * f136) - Math_fround(f137 * f138)))));
     HEAPF32[i90 >> 2] = f139;
     HEAPF32[i91 >> 2] = f140;
     i1 = 0;
    } else {
     i1 = HEAP32[i38 >> 2] | 0;
     if (i11 | i4 ^ 1 | (i1 | 0) == -1) i1 = 0; else {
      HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 8;
      i9 = HEAP32[i92 >> 2] | 0;
      f139 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 12 >> 2]);
      f12 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) >> 2]);
      f139 = Math_fround(f139 - f12);
      f14 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 16 >> 2]);
      f140 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 4 >> 2]);
      f14 = Math_fround(f14 - f140);
      f138 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 20 >> 2]);
      f15 = Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 8 >> 2]);
      f138 = Math_fround(f138 - f15);
      f12 = Math_fround(Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 24 >> 2]) - f12);
      f140 = Math_fround(Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 28 >> 2]) - f140);
      f15 = Math_fround(Math_fround(HEAPF32[i9 + (i1 * 36 | 0) + 32 >> 2]) - f15);
      f13 = Math_fround(Math_fround(f14 * f15) - Math_fround(f138 * f140));
      f15 = Math_fround(Math_fround(f138 * f12) - Math_fround(f139 * f15));
      f12 = Math_fround(Math_fround(f139 * f140) - Math_fround(f14 * f12));
      HEAPF32[i16 >> 2] = f13;
      HEAPF32[i17 >> 2] = f15;
      HEAPF32[i18 >> 2] = f12;
      f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f13 * f13) + Math_fround(f15 * f15)))));
      if (f14 > Math_fround(0.0)) {
       f140 = Math_fround(Math_fround(1.0) / f14);
       f13 = Math_fround(f13 * f140);
       HEAPF32[i16 >> 2] = f13;
       f14 = Math_fround(f15 * f140);
       HEAPF32[i17 >> 2] = f14;
       f12 = Math_fround(f12 * f140);
       HEAPF32[i18 >> 2] = f12;
      } else f14 = f15;
      if (!(HEAP8[i19 >> 0] | 0)) i1 = 0; else {
       f140 = Math_fround(f13 * Math_fround(HEAPF32[i69 >> 2]));
       f140 = Math_fround(f140 + Math_fround(f14 * Math_fround(HEAPF32[i70 >> 2])));
       if (Math_fround(f140 + Math_fround(f12 * Math_fround(HEAPF32[i71 >> 2]))) < Math_fround(0.0)) i1 = 1; else i1 = 0;
      }
     }
     if (i50) {
      i3 = 1;
      break;
     }
    }
    i3 = ((__ZN5physx3Cct16shapeHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef(i105, i98, i99, f57) | 0) & 2 | 0) == 0;
   } while (0);
   i10 = (i68 | ((i2 | 0) != 0 | i3) ? -1 : 8) + i10 | 0;
   i2 = i2 + 1 | 0;
   f58 = Math_fround(+HEAPF64[i98 >> 3]);
   f13 = Math_fround(+HEAPF64[i54 >> 3]);
   f12 = Math_fround(+HEAPF64[i55 >> 3]);
   f14 = Math_fround(HEAPF32[i69 >> 2]);
   f58 = Math_fround(f58 * f14);
   f57 = Math_fround(HEAPF32[i70 >> 2]);
   f13 = Math_fround(f58 + Math_fround(f13 * f57));
   f58 = Math_fround(HEAPF32[i71 >> 2]);
   HEAPF32[i72 >> 2] = Math_fround(f13 + Math_fround(f12 * f58));
   f12 = Math_fround(HEAPF32[i107 >> 2]);
   f13 = Math_fround(HEAPF32[i36 >> 2]);
   if (f13 > f12) {
    f140 = Math_fround(f13 - f12);
    f138 = Math_fround(f140 * Math_fround(HEAPF32[i99 >> 2]));
    f139 = Math_fround(f140 * Math_fround(HEAPF32[i34 >> 2]));
    f140 = Math_fround(f140 * Math_fround(HEAPF32[i35 >> 2]));
    HEAPF64[i110 >> 3] = +f138 + +HEAPF64[i110 >> 3];
    HEAPF64[i108 >> 3] = +f139 + +HEAPF64[i108 >> 3];
    HEAPF64[i109 >> 3] = +f140 + +HEAPF64[i109 >> 3];
   }
   i3 = HEAP32[i44 >> 2] | 0;
   i4 = HEAP32[i47 >> 2] | 0;
   i8 = HEAP32[i49 >> 2] | 0;
   if (i1) i112 = 69; else if (!(HEAP32[i20 >> 2] & 2)) i1 = i8; else if ((HEAP32[i73 >> 2] | 0) == 1) i1 = i8; else i112 = 69;
   if ((i112 | 0) == 69) {
    f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f15 * f14);
    f140 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f12 + Math_fround(f140 * f57));
    f13 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f12 + Math_fround(f13 * f58));
    f15 = Math_fround(f15 - Math_fround(f14 * f12));
    f14 = Math_fround(f140 - Math_fround(f57 * f12));
    f12 = Math_fround(f13 - Math_fround(f58 * f12));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)))));
    if (f13 > Math_fround(0.0)) {
     f140 = Math_fround(Math_fround(1.0) / f13);
     f139 = Math_fround(f15 * f140);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
     f139 = Math_fround(f14 * f140);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
     f140 = Math_fround(f12 * f140);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
    }
   }
   f12 = Math_fround(HEAPF32[i99 >> 2]);
   f14 = Math_fround(HEAPF32[i34 >> 2]);
   f13 = Math_fround(HEAPF32[i35 >> 2]);
   f57 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f58 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = Math_fround(Math_fround(Math_fround(f57 * f12) + Math_fround(f58 * f14)) + Math_fround(f59 * f13));
   f12 = Math_fround(f12 - Math_fround(Math_fround(f57 * Math_fround(2.0)) * f15));
   f14 = Math_fround(f14 - Math_fround(Math_fround(f58 * Math_fround(2.0)) * f15));
   f15 = Math_fround(f13 - Math_fround(Math_fround(f59 * Math_fround(2.0)) * f15));
   f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
   if (f13 > Math_fround(0.0)) {
    f140 = Math_fround(Math_fround(1.0) / f13);
    f12 = Math_fround(f12 * f140);
    f14 = Math_fround(f14 * f140);
    f15 = Math_fround(f15 * f140);
   }
   f140 = Math_fround(Math_fround(f59 * f15) + Math_fround(Math_fround(f58 * f14) + Math_fround(f57 * f12)));
   f57 = Math_fround(f12 - Math_fround(f57 * f140));
   f13 = Math_fround(f14 - Math_fround(f58 * f140));
   f14 = Math_fround(f15 - Math_fround(f59 * f140));
   d60 = +HEAPF64[i110 >> 3];
   d141 = d7 - d60;
   d61 = +HEAPF64[i108 >> 3];
   d7 = d6 - d61;
   d62 = +HEAPF64[i109 >> 3];
   d5 = d5 - d62;
   d5 = +Math_sqrt(+(d141 * d141 + d7 * d7 + d5 * d5));
   if (!(HEAP32[i20 >> 2] & 64)) f12 = f57; else {
    f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f57 * f57) + Math_fround(f13 * f13)))));
    if (f12 > Math_fround(0.0)) {
     f140 = Math_fround(Math_fround(1.0) / f12);
     f12 = Math_fround(f57 * f140);
     f13 = Math_fround(f13 * f140);
     f14 = Math_fround(f14 * f140);
    } else f12 = f57;
   }
   f140 = Math_fround(d5);
   d7 = d60 + +Math_fround(f140 * f12);
   d6 = d61 + +Math_fround(f140 * f13);
   d5 = d62 + +Math_fround(f140 * f14);
   if (!i10) {
    i1 = 1;
    break L5;
   } else i1 = 1;
  }
  if ((i112 | 0) == 28) {
   HEAPF64[i110 >> 3] = d7;
   HEAPF64[i108 >> 3] = d6;
   HEAPF64[i109 >> 3] = d5;
   i1 = 1;
   break;
  }
  f57 = Math_fround(HEAPF32[i107 >> 2]);
  f138 = Math_fround(+HEAPF64[i110 >> 3]);
  f139 = Math_fround(+HEAPF64[i108 >> 3]);
  f140 = Math_fround(+HEAPF64[i109 >> 3]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f138, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = i117 + 16 | 0;
  i34 = i117 + 20 | 0;
  i35 = i117 + 24 | 0;
  i36 = i116 + 12 | 0;
  i37 = i116 + 4 | 0;
  i38 = i116 + 8 | 0;
  i39 = i116 + 16 | 0;
  i40 = i116 + 20 | 0;
  i41 = i116 + 24 | 0;
  i42 = i117 + 12 | 0;
  i43 = i117 + 8 | 0;
  i44 = i117 + 4 | 0;
  i45 = i123 + 4 | 0;
  i46 = i123 + 8 | 0;
  i47 = i123 + 12 | 0;
  i48 = i123 + 16 | 0;
  i49 = i123 + 20 | 0;
  i50 = i123 + 24 | 0;
  i51 = i111 + 228 | 0;
  i52 = i125 + 4 | 0;
  i53 = i111 + 232 | 0;
  i54 = i125 + 8 | 0;
  i55 = i111 + 236 | 0;
  i56 = i125 + 12 | 0;
  i22 = i111 + 240 | 0;
  i23 = i125 + 16 | 0;
  i24 = i125 + 20 | 0;
  i25 = i125 + 24 | 0;
  i26 = i113 + 40 | 0;
  i27 = i113 + 44 | 0;
  i28 = i120 + 4 | 0;
  i29 = i120 + 8 | 0;
  i30 = i124 + 4 | 0;
  i31 = i124 + 8 | 0;
  i32 = i26 + 4 | 0;
  i18 = i113 + 48 | 0;
  i19 = i119 + 4 | 0;
  i20 = i119 + 8 | 0;
  i21 = i119 + 12 | 0;
  i4 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = 0;
  do {
   i8 = HEAP32[i114 >> 2] | 0;
   i113 = HEAP32[i115 >> 2] | 0;
   i17 = i8 + (i113 << 2) | 0;
   if (!i113) i8 = 1; else {
    i16 = i8;
    i8 = 1;
    do {
     i10 = HEAP32[i16 >> 2] | 0;
     if (i10 >>> 0 >= 2) {
      i11 = HEAP32[i16 + 8 >> 2] | 0;
      if ((HEAP16[i11 + 4 >> 1] | 0) == 6) {
       i113 = HEAP32[i16 + 4 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i113 >> 2] | 0) + 32 >> 2] | 0, i122 | 0, i113 | 0);
       mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i116 | 0, i11 | 0);
       mftCall_vii(HEAP32[(HEAP32[i113 >> 2] | 0) + 72 >> 2] | 0, i117 | 0, i113 | 0);
       f134 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) * Math_fround(2.0));
       f136 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) * Math_fround(2.0));
       f15 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * Math_fround(2.0));
       f131 = Math_fround(HEAPF32[i36 >> 2]);
       f132 = Math_fround(Math_fround(f131 * f131) + Math_fround(-.5));
       f133 = Math_fround(HEAPF32[i116 >> 2]);
       f12 = Math_fround(f134 * f133);
       f135 = Math_fround(HEAPF32[i37 >> 2]);
       f12 = Math_fround(f12 + Math_fround(f136 * f135));
       f137 = Math_fround(HEAPF32[i38 >> 2]);
       f12 = Math_fround(f12 + Math_fround(f15 * f137));
       f14 = Math_fround(Math_fround(f133 * f12) + Math_fround(Math_fround(f134 * f132) + Math_fround(f131 * Math_fround(Math_fround(f15 * f135) - Math_fround(f136 * f137)))));
       f13 = Math_fround(Math_fround(f135 * f12) + Math_fround(Math_fround(f136 * f132) + Math_fround(f131 * Math_fround(Math_fround(f134 * f137) - Math_fround(f15 * f133)))));
       f12 = Math_fround(Math_fround(Math_fround(f15 * f132) + Math_fround(f131 * Math_fround(Math_fround(f136 * f133) - Math_fround(f134 * f135)))) + Math_fround(f137 * f12));
       f14 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) + f14);
       f13 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + f13);
       f12 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f12);
       f134 = Math_fround(HEAPF32[i117 >> 2]);
       f136 = Math_fround(f131 * f134);
       f132 = Math_fround(HEAPF32[i42 >> 2]);
       f136 = Math_fround(f136 + Math_fround(f133 * f132));
       f15 = Math_fround(HEAPF32[i43 >> 2]);
       f136 = Math_fround(f136 + Math_fround(f135 * f15));
       f138 = Math_fround(HEAPF32[i44 >> 2]);
       f139 = Math_fround(Math_fround(Math_fround(f137 * f134) + Math_fround(Math_fround(f135 * f132) + Math_fround(f131 * f138))) - Math_fround(f133 * f15));
       f140 = Math_fround(Math_fround(Math_fround(f133 * f138) + Math_fround(Math_fround(f137 * f132) + Math_fround(f131 * f15))) - Math_fround(f135 * f134));
       f15 = Math_fround(Math_fround(Math_fround(Math_fround(f131 * f132) - Math_fround(f133 * f134)) - Math_fround(f135 * f138)) - Math_fround(f137 * f15));
       HEAPF32[i123 >> 2] = Math_fround(f136 - Math_fround(f137 * f138));
       HEAPF32[i45 >> 2] = f139;
       HEAPF32[i46 >> 2] = f140;
       HEAPF32[i47 >> 2] = f15;
       HEAPF32[i48 >> 2] = f14;
       HEAPF32[i49 >> 2] = f13;
       HEAPF32[i50 >> 2] = f12;
       HEAP32[i125 >> 2] = HEAP32[i51 >> 2];
       HEAP32[i52 >> 2] = HEAP32[i53 >> 2];
       HEAP32[i54 >> 2] = HEAP32[i55 >> 2];
       HEAP32[i56 >> 2] = HEAP32[i22 >> 2];
       HEAP32[i23 >> 2] = i1;
       HEAP32[i24 >> 2] = i3;
       HEAP32[i25 >> 2] = i4;
       f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f14 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f15 = Math_fround(f57 + Math_fround(HEAPF32[i26 >> 2]));
       if ((HEAP32[i118 >> 2] | 0) == 1) {
        f140 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(.5));
        HEAP32[i120 >> 2] = 2;
        HEAPF32[i28 >> 2] = f15;
        HEAPF32[i29 >> 2] = f140;
        if (__ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_(i124, i121, i120, i125, i122, i123) | 0) i112 = 38; else i8 = 0;
       } else {
        f139 = Math_fround(f57 + Math_fround(HEAPF32[i32 >> 2]));
        f140 = Math_fround(f57 + Math_fround(HEAPF32[i18 >> 2]));
        HEAP32[i119 >> 2] = 3;
        HEAPF32[i19 >> 2] = f15;
        HEAPF32[i20 >> 2] = f139;
        HEAPF32[i21 >> 2] = f140;
        if (__ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_(i124, i121, i119, i125, i122, i123) | 0) i112 = 38; else i8 = 0;
       }
       if ((i112 | 0) == 38) {
        i112 = 0;
        f140 = Math_fround(HEAPF32[i121 >> 2]);
        f138 = Math_fround(f140 * Math_fround(HEAPF32[i124 >> 2]));
        f139 = Math_fround(f140 * Math_fround(HEAPF32[i30 >> 2]));
        f140 = Math_fround(f140 * Math_fround(HEAPF32[i31 >> 2]));
        f138 = Math_fround(f12 + f138);
        i1 = (HEAPF32[tempDoublePtr >> 2] = f138, HEAP32[tempDoublePtr >> 2] | 0);
        f139 = Math_fround(f13 + f139);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
        f140 = Math_fround(f14 + f140);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
        i8 = 1;
        i9 = i9 + 1 | 0;
       }
       i10 = HEAP32[i16 >> 2] | 0;
      }
     }
     i16 = i16 + (HEAP32[gb + 83868 + (i10 << 2) >> 2] | 0) | 0;
    } while ((i16 | 0) != (i17 | 0));
   }
  } while (i8 & i9 >>> 0 < 4);
  if (i129 | 0) HEAP32[i129 >> 2] = i2;
  HEAPF64[i128 >> 3] = +(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF64[i126 >> 3] = +(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF64[i127 >> 3] = +(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i129 = 1;
  STACKTOP = i130;
  return i129 | 0;
 } while (0);
 if (i129 | 0) HEAP32[i129 >> 2] = i2;
 HEAP32[i128 >> 2] = HEAP32[i110 >> 2];
 HEAP32[i128 + 4 >> 2] = HEAP32[i110 + 4 >> 2];
 HEAP32[i128 + 8 >> 2] = HEAP32[i110 + 8 >> 2];
 HEAP32[i128 + 12 >> 2] = HEAP32[i110 + 12 >> 2];
 HEAP32[i128 + 16 >> 2] = HEAP32[i110 + 16 >> 2];
 HEAP32[i128 + 20 >> 2] = HEAP32[i110 + 20 >> 2];
 i129 = i1;
 STACKTOP = i130;
 return i129 | 0;
}

function __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_(i36, i37, i2, i3, i5, i40, i31, i4, i32, i33, i1) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i40 = i40 | 0;
 i31 = i31 | 0;
 i4 = i4 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i34 = 0, i35 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i41 + 88 | 0;
 i34 = i41 + 96 | 0;
 i48 = i41 + 80 | 0;
 i38 = i41 + 72 | 0;
 i26 = i41 + 68 | 0;
 i27 = i41 + 500 | 0;
 i28 = i41 + 497 | 0;
 i29 = i41 + 496 | 0;
 i42 = i41 + 56 | 0;
 i43 = i41 + 44 | 0;
 i44 = i41 + 32 | 0;
 i45 = i41 + 20 | 0;
 i46 = i41 + 8 | 0;
 i30 = i41 + 4 | 0;
 i39 = i41;
 HEAP32[i25 >> 2] = i1;
 HEAP32[i48 >> 2] = i34;
 i47 = i48 + 4 | 0;
 HEAP32[i47 >> 2] = fb + 4003;
 HEAP32[i38 >> 2] = i34;
 HEAP32[i26 >> 2] = i34 + 400;
 HEAP32[i42 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i42 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i43 >> 2] = 0;
 HEAP32[i43 + 4 >> 2] = 0;
 HEAP32[i43 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i43 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i44 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i45 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i45 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i46 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_viiiiiiiiii(fb + 11 | 0, i2 | 0, i3 | 0, i27 | 0, i28 | 0, i29 | 0, i42 | 0, i43 | 0, i44 | 0, i45 | 0, i30 | 0);
 i34 = __THREW__;
 __THREW__ = 0;
 L21 : do if (i34 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i33 >> 2] = HEAP32[i32 >> 2];
  i20 = i4 + 8 | 0;
  i21 = i44 + 11 | 0;
  i22 = i44 + 4 | 0;
  i23 = i45 + 11 | 0;
  i24 = i45 + 4 | 0;
  i12 = (i5 & 512 | 0) != 0;
  i13 = i43 + 11 | 0;
  i14 = i43 + 4 | 0;
  i15 = i46 + 11 | 0;
  i16 = i46 + 4 | 0;
  i17 = i27 + 3 | 0;
  i18 = i42 + 11 | 0;
  i19 = i42 + 4 | 0;
  i34 = 0;
  i11 = 0;
  L24 : while (1) {
   if (i11 >>> 0 >= 4) {
    i35 = 254;
    break;
   }
   i1 = HEAP32[i36 >> 2] | 0;
   do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i35 = 35;
     break L24;
    }
    if ((i1 | 0) == -1) {
     HEAP32[i36 >> 2] = 0;
     i1 = 0;
     break;
    } else {
     i1 = HEAP32[i36 >> 2] | 0;
     break;
    }
   } while (0);
   i1 = (i1 | 0) == 0;
   i2 = HEAP32[i37 >> 2] | 0;
   do if (!i2) i35 = 31; else {
    if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) if (i1) {
     i10 = i2;
     break;
    } else {
     i35 = 254;
     break L24;
    }
    __THREW__ = 0;
    i3 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i35 = 35;
     break L24;
    }
    if ((i3 | 0) == -1) {
     HEAP32[i37 >> 2] = 0;
     i35 = 31;
     break;
    } else if (i1) {
     i10 = i2;
     break;
    } else {
     i35 = 254;
     break L24;
    }
   } while (0);
   if ((i35 | 0) == 31) {
    i35 = 0;
    if (i1) {
     i35 = 254;
     break;
    } else i10 = 0;
   }
   L47 : do switch (HEAP8[i27 + i11 >> 0] | 0) {
   case 1:
    {
     if ((i11 | 0) == 3) i1 = i34; else {
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i35 = __THREW__;
       __THREW__ = 0;
       if (i35 & 1) {
        i35 = 35;
        break L24;
       }
      } else i1 = HEAPU8[i2 >> 0] | 0;
      if ((i1 & 255) << 24 >> 24 <= -1) {
       i35 = 48;
       break L24;
      }
      if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) {
       i35 = 48;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i35 = __THREW__;
       __THREW__ = 0;
       if (i35 & 1) {
        i35 = 35;
        break L24;
       }
      } else {
       HEAP32[i2 >> 2] = i3 + 1;
       i1 = HEAPU8[i3 >> 0] | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i46 | 0, i1 & 255 | 0);
      i35 = __THREW__;
      __THREW__ = 0;
      if (i35 & 1) {
       i35 = 35;
       break L24;
      } else {
       i1 = i10;
       i4 = i10;
       i35 = 50;
      }
     }
     break;
    }
   case 0:
    {
     if ((i11 | 0) == 3) i1 = i34; else {
      i1 = i10;
      i4 = i10;
      i35 = 50;
     }
     break;
    }
   case 3:
    {
     i4 = HEAP8[i21 >> 0] | 0;
     i1 = i4 << 24 >> 24 < 0 ? HEAP32[i22 >> 2] | 0 : i4 & 255;
     i3 = HEAP8[i23 >> 0] | 0;
     i5 = i3 << 24 >> 24 < 0 ? HEAP32[i24 >> 2] | 0 : i3 & 255;
     if ((i1 | 0) == (0 - i5 | 0)) i1 = i34; else {
      if (!i1) {
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 35;
         break L24;
        }
        i4 = HEAP8[i23 >> 0] | 0;
       } else {
        i1 = HEAPU8[i2 >> 0] | 0;
        i4 = i3;
       }
       if ((i1 & 255) << 24 >> 24 != (HEAP8[(i4 << 24 >> 24 < 0 ? HEAP32[i45 >> 2] | 0 : i45) >> 0] | 0)) {
        i1 = i34;
        break L47;
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 35;
         break L24;
        }
        i1 = HEAP8[i23 >> 0] | 0;
       } else {
        HEAP32[i2 >> 2] = i3 + 1;
        i1 = i4;
       }
       HEAP8[i31 >> 0] = 1;
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i24 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i45 : i34;
       break L47;
      }
      i3 = HEAP32[i36 >> 2] | 0;
      i6 = HEAP32[i3 + 12 >> 2] | 0;
      i2 = HEAP32[i3 + 16 >> 2] | 0;
      i1 = (i6 | 0) == (i2 | 0);
      if (!i5) {
       if (i1) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 35;
         break L24;
        }
        i4 = HEAP8[i21 >> 0] | 0;
       } else i1 = HEAPU8[i6 >> 0] | 0;
       if ((i1 & 255) << 24 >> 24 != (HEAP8[(i4 << 24 >> 24 < 0 ? HEAP32[i44 >> 2] | 0 : i44) >> 0] | 0)) {
        HEAP8[i31 >> 0] = 1;
        i1 = i34;
        break L47;
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 35;
         break L24;
        }
        i1 = HEAP8[i21 >> 0] | 0;
       } else {
        HEAP32[i2 >> 2] = i3 + 1;
        i1 = i4;
       }
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i22 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i44 : i34;
       break L47;
      }
      if (i1) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 35;
        break L24;
       }
       i2 = HEAP32[i36 >> 2] | 0;
       i4 = HEAP8[i21 >> 0] | 0;
       i7 = i2;
       i5 = HEAP32[i2 + 12 >> 2] | 0;
       i2 = HEAP32[i2 + 16 >> 2] | 0;
      } else {
       i1 = HEAPU8[i6 >> 0] | 0;
       i7 = i3;
       i5 = i6;
      }
      i3 = i7 + 12 | 0;
      i2 = (i5 | 0) == (i2 | 0);
      if ((i1 & 255) << 24 >> 24 == (HEAP8[(i4 << 24 >> 24 < 0 ? HEAP32[i44 >> 2] | 0 : i44) >> 0] | 0)) {
       if (i2) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0, i7 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 35;
         break L24;
        }
        i1 = HEAP8[i21 >> 0] | 0;
       } else {
        HEAP32[i3 >> 2] = i5 + 1;
        i1 = i4;
       }
       i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i22 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i44 : i34;
       break L47;
      }
      if (i2) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 35;
        break L24;
       }
      } else i1 = HEAPU8[i5 >> 0] | 0;
      i4 = HEAP8[i23 >> 0] | 0;
      if ((i1 & 255) << 24 >> 24 != (HEAP8[(i4 << 24 >> 24 < 0 ? HEAP32[i45 >> 2] | 0 : i45) >> 0] | 0)) {
       i35 = 116;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 35;
        break L24;
       }
       i1 = HEAP8[i23 >> 0] | 0;
      } else {
       HEAP32[i2 >> 2] = i3 + 1;
       i1 = i4;
      }
      HEAP8[i31 >> 0] = 1;
      i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i24 >> 2] | 0 : i1 & 255) >>> 0 > 1 ? i45 : i34;
     }
     break;
    }
   case 2:
    {
     if (!(i11 >>> 0 < 2 | (i34 | 0) != 0)) if (!(i12 | (i11 | 0) == 2 & (HEAP8[i17 >> 0] | 0) != 0)) {
      i1 = 0;
      break L47;
     }
     i2 = HEAP8[i13 >> 0] | 0;
     i1 = i2 << 24 >> 24 < 0;
     i9 = HEAP32[i43 >> 2] | 0;
     i3 = i1 ? i9 : i43;
     i7 = i3;
     L120 : do if (!i11) {
      i8 = i10;
      i3 = i7;
      i1 = i9;
      i4 = i10;
     } else if ((HEAPU8[i27 + (i11 + -1) >> 0] | 0) < 2) {
      i1 = i3 + (i1 ? HEAP32[i14 >> 2] | 0 : i2 & 255) | 0;
      i6 = i7;
      while (1) {
       i4 = i6;
       if ((i4 | 0) == (i1 | 0)) break;
       i5 = HEAP8[i4 >> 0] | 0;
       if (i5 << 24 >> 24 <= -1) break;
       if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i5 << 24 >> 24 << 1) >> 1] & 8192)) break;
       i6 = i4 + 1 | 0;
      }
      i5 = i6 - i7 | 0;
      i4 = HEAP8[i15 >> 0] | 0;
      i1 = i4 << 24 >> 24 < 0;
      i4 = i1 ? HEAP32[i16 >> 2] | 0 : i4 & 255;
      if (i5 >>> 0 > i4 >>> 0) {
       i8 = i10;
       i3 = i7;
       i1 = i9;
       i4 = i10;
      } else {
       i4 = (i1 ? HEAP32[i46 >> 2] | 0 : i46) + i4 | 0;
       i1 = i4 + (0 - i5) | 0;
       while (1) {
        if ((i1 | 0) == (i4 | 0)) {
         i8 = i10;
         i3 = i6;
         i1 = i9;
         i4 = i10;
         break L120;
        }
        if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
         i8 = i10;
         i3 = i7;
         i1 = i9;
         i4 = i10;
         break L120;
        }
        i3 = i3 + 1 | 0;
        i1 = i1 + 1 | 0;
       }
      }
     } else {
      i8 = i10;
      i3 = i7;
      i1 = i9;
      i4 = i10;
     } while (0);
     L134 : while (1) {
      i6 = i2 << 24 >> 24 < 0;
      i1 = (i6 ? i1 : i43) + (i6 ? HEAP32[i14 >> 2] | 0 : i2 & 255) | 0;
      i6 = i3;
      if ((i6 | 0) == (i1 | 0)) break;
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 154;
        break L24;
       }
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i1 = 0;
        break;
       } else {
        i1 = HEAP32[i36 >> 2] | 0;
        break;
       }
      } while (0);
      i2 = (i1 | 0) == 0;
      do if (!i4) {
       i1 = i8;
       i35 = 144;
      } else {
       if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) {
        i1 = i8;
        i5 = i4;
        break;
       } else {
        i1 = i6;
        break L134;
       }
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 154;
        break L24;
       }
       if ((i1 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i1 = 0;
        i35 = 144;
        break;
       } else if (i2 ^ (i8 | 0) == 0) {
        i1 = i8;
        i5 = i8;
        break;
       } else {
        i1 = i6;
        break L134;
       }
      } while (0);
      if ((i35 | 0) == 144) {
       i35 = 0;
       if (i2) {
        i1 = i6;
        break;
       } else i5 = 0;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = HEAP32[i2 + 12 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 154;
        break L24;
       }
      } else i2 = HEAPU8[i3 >> 0] | 0;
      if ((i2 & 255) << 24 >> 24 != (HEAP8[i6 >> 0] | 0)) {
       i1 = i6;
       break;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 155;
        break L24;
       }
      } else HEAP32[i3 >> 2] = i4 + 1;
      i8 = i1;
      i3 = i6 + 1 | 0;
      i2 = HEAP8[i13 >> 0] | 0;
      i1 = HEAP32[i43 >> 2] | 0;
      i4 = i5;
     }
     if (i12) {
      i10 = HEAP8[i13 >> 0] | 0;
      i9 = i10 << 24 >> 24 < 0;
      if ((i1 | 0) == ((i9 ? HEAP32[i43 >> 2] | 0 : i43) + (i9 ? HEAP32[i14 >> 2] | 0 : i10 & 255) | 0)) i1 = i34; else {
       i35 = 158;
       break L24;
      }
     } else i1 = i34;
     break;
    }
   case 4:
    {
     i7 = 0;
     i1 = i10;
     i4 = i10;
     L168 : while (1) {
      i2 = HEAP32[i36 >> 2] | 0;
      do if (!i2) i2 = 0; else if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 182;
        break L24;
       }
       if ((i2 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i2 = 0;
        break;
       } else {
        i2 = HEAP32[i36 >> 2] | 0;
        break;
       }
      } while (0);
      i3 = (i2 | 0) == 0;
      do if (!i4) i35 = 171; else {
       if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i3) {
        i6 = i1;
        i5 = i4;
        break;
       } else {
        i3 = i1;
        break L168;
       }
       __THREW__ = 0;
       i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 182;
        break L24;
       }
       if ((i2 | 0) == -1) {
        HEAP32[i37 >> 2] = 0;
        i1 = 0;
        i35 = 171;
        break;
       } else if (i3 ^ (i1 | 0) == 0) {
        i6 = i1;
        i5 = i1;
        break;
       } else {
        i3 = i1;
        break L168;
       }
      } while (0);
      if ((i35 | 0) == 171) {
       i35 = 0;
       if (i3) {
        i3 = i1;
        break;
       } else {
        i6 = i1;
        i5 = 0;
       }
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 182;
        break L24;
       }
      } else i1 = HEAPU8[i2 >> 0] | 0;
      i2 = i1 & 255;
      if (i2 << 24 >> 24 > -1) if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048)) i35 = 186; else {
       i1 = HEAP32[i33 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i25 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1042 | 0, i32 | 0, i33 | 0, i25 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 184;
         break L24;
        }
        i1 = HEAP32[i33 >> 2] | 0;
       }
       HEAP32[i33 >> 2] = i1 + 1;
       HEAP8[i1 >> 0] = i2;
       i1 = i7 + 1 | 0;
      } else i35 = 186;
      if ((i35 | 0) == 186) {
       i35 = 0;
       i10 = HEAP8[i18 >> 0] | 0;
       if (!(i2 << 24 >> 24 == (HEAP8[i29 >> 0] | 0) & (i7 | 0 ? ((i10 << 24 >> 24 < 0 ? HEAP32[i19 >> 2] | 0 : i10 & 255) | 0) != 0 : 0))) {
        i3 = i6;
        break;
       }
       i1 = HEAP32[i38 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i26 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1043 | 0, i48 | 0, i38 | 0, i26 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 184;
         break L24;
        }
        i1 = HEAP32[i38 >> 2] | 0;
       }
       HEAP32[i38 >> 2] = i1 + 4;
       HEAP32[i1 >> 2] = i7;
       i1 = 0;
      }
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 182;
        break L24;
       } else {
        i7 = i1;
        i1 = i6;
        i4 = i5;
        continue;
       }
      } else {
       HEAP32[i3 >> 2] = i4 + 1;
       i7 = i1;
       i1 = i6;
       i4 = i5;
       continue;
      }
     }
     i1 = HEAP32[i38 >> 2] | 0;
     if (i7 | 0 ? (HEAP32[i48 >> 2] | 0) != (i1 | 0) : 0) {
      if ((i1 | 0) == (HEAP32[i26 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_viii(fb + 1043 | 0, i48 | 0, i38 | 0, i26 | 0);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 183;
        break L24;
       }
       i1 = HEAP32[i38 >> 2] | 0;
      }
      HEAP32[i38 >> 2] = i1 + 4;
      HEAP32[i1 >> 2] = i7;
     }
     L220 : do if ((HEAP32[i30 >> 2] | 0) > 0) {
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 183;
        break L24;
       }
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i1 = 0;
        break;
       } else {
        i1 = HEAP32[i36 >> 2] | 0;
        break;
       }
      } while (0);
      i1 = (i1 | 0) == 0;
      do if (!i3) i35 = 212; else {
       if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 183;
         break L24;
        }
        if ((i2 | 0) == -1) {
         HEAP32[i37 >> 2] = 0;
         i35 = 212;
         break;
        }
       }
       if (i1) i4 = i3; else {
        i35 = 217;
        break L24;
       }
      } while (0);
      if ((i35 | 0) == 212) {
       i35 = 0;
       if (i1) {
        i35 = 217;
        break L24;
       } else i4 = 0;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 183;
        break L24;
       }
      } else i1 = HEAPU8[i2 >> 0] | 0;
      if ((i1 & 255) << 24 >> 24 != (HEAP8[i28 >> 0] | 0)) {
       i35 = 217;
       break L24;
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = i1 + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i35 = 183;
        break L24;
       } else i1 = i4;
      } else {
       HEAP32[i2 >> 2] = i3 + 1;
       i1 = i4;
      }
      while (1) {
       if ((HEAP32[i30 >> 2] | 0) <= 0) break L220;
       i2 = HEAP32[i36 >> 2] | 0;
       do if (!i2) i2 = 0; else if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        }
        if ((i2 | 0) == -1) {
         HEAP32[i36 >> 2] = 0;
         i2 = 0;
         break;
        } else {
         i2 = HEAP32[i36 >> 2] | 0;
         break;
        }
       } while (0);
       i3 = (i2 | 0) == 0;
       do if (!i4) i35 = 234; else {
        if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i3) {
         i5 = i1;
         break;
        } else {
         i35 = 241;
         break L24;
        }
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        }
        if ((i2 | 0) == -1) {
         HEAP32[i37 >> 2] = 0;
         i1 = 0;
         i35 = 234;
         break;
        } else if (i3 ^ (i1 | 0) == 0) {
         i5 = i1;
         i4 = i1;
         break;
        } else {
         i35 = 241;
         break L24;
        }
       } while (0);
       if ((i35 | 0) == 234) {
        i35 = 0;
        if (i3) {
         i35 = 241;
         break L24;
        } else {
         i5 = i1;
         i4 = 0;
        }
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        }
       } else i1 = HEAPU8[i2 >> 0] | 0;
       if ((i1 & 255) << 24 >> 24 <= -1) {
        i35 = 241;
        break L24;
       }
       if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048)) {
        i35 = 241;
        break L24;
       }
       if ((HEAP32[i33 >> 2] | 0) == (HEAP32[i25 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_viii(fb + 1042 | 0, i32 | 0, i33 | 0, i25 | 0);
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        }
       }
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = HEAP32[i1 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        }
       } else i1 = HEAPU8[i2 >> 0] | 0;
       i2 = HEAP32[i33 >> 2] | 0;
       HEAP32[i33 >> 2] = i2 + 1;
       HEAP8[i2 >> 0] = i1;
       HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + -1;
       i1 = HEAP32[i36 >> 2] | 0;
       i2 = i1 + 12 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        if (i10 & 1) {
         i35 = 181;
         break L24;
        } else {
         i1 = i5;
         continue;
        }
       } else {
        HEAP32[i2 >> 2] = i3 + 1;
        i1 = i5;
        continue;
       }
      }
     } while (0);
     if ((HEAP32[i33 >> 2] | 0) == (HEAP32[i32 >> 2] | 0)) {
      i35 = 251;
      break L24;
     } else i1 = i34;
     break;
    }
   default:
    i1 = i34;
   } while (0);
   L288 : do if ((i35 | 0) == 50) while (1) {
    i35 = 0;
    i2 = HEAP32[i36 >> 2] | 0;
    do if (!i2) i2 = 0; else if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i35 = 34;
      break L24;
     }
     if ((i2 | 0) == -1) {
      HEAP32[i36 >> 2] = 0;
      i2 = 0;
      break;
     } else {
      i2 = HEAP32[i36 >> 2] | 0;
      break;
     }
    } while (0);
    i3 = (i2 | 0) == 0;
    do if (!i4) i35 = 62; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i3) {
      i5 = i1;
      break;
     } else {
      i1 = i34;
      break L288;
     }
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i35 = 34;
      break L24;
     }
     if ((i2 | 0) == -1) {
      HEAP32[i37 >> 2] = 0;
      i1 = 0;
      i35 = 62;
      break;
     } else if (i3 ^ (i1 | 0) == 0) {
      i5 = i1;
      i4 = i1;
      break;
     } else {
      i1 = i34;
      break L288;
     }
    } while (0);
    if ((i35 | 0) == 62) {
     i35 = 0;
     if (i3) {
      i1 = i34;
      break L288;
     } else {
      i5 = i1;
      i4 = 0;
     }
    }
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i35 = 34;
      break L24;
     }
    } else i1 = HEAPU8[i2 >> 0] | 0;
    if ((i1 & 255) << 24 >> 24 <= -1) {
     i1 = i34;
     break L288;
    }
    if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) {
     i1 = i34;
     break L288;
    }
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i35 = __THREW__;
     __THREW__ = 0;
     if (i35 & 1) {
      i35 = 34;
      break L24;
     }
    } else {
     HEAP32[i2 >> 2] = i3 + 1;
     i1 = HEAPU8[i3 >> 0] | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4511 | 0, i46 | 0, i1 & 255 | 0);
    i35 = __THREW__;
    __THREW__ = 0;
    if (i35 & 1) {
     i35 = 34;
     break L24;
    } else {
     i1 = i5;
     i35 = 50;
    }
   } while (0);
   i34 = i1;
   i11 = i11 + 1 | 0;
  }
  L322 : switch (i35 | 0) {
  case 34:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 36;
    break;
   }
  case 35:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 36;
    break;
   }
  case 48:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 116:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 154:
   {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L21;
   }
  case 155:
   {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L21;
   }
  case 158:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 181:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 252;
    break;
   }
  case 182:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 252;
    break;
   }
  case 183:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 252;
    break;
   }
  case 184:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i35 = 252;
    break;
   }
  case 217:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 241:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 251:
   {
    HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
    i2 = 0;
    i35 = 288;
    break;
   }
  case 254:
   {
    L324 : do if (i34 | 0) {
     i5 = i34 + 11 | 0;
     i6 = i34 + 4 | 0;
     i3 = 1;
     L326 : while (1) {
      i1 = HEAP8[i5 >> 0] | 0;
      if (i1 << 24 >> 24 < 0) i1 = HEAP32[i6 >> 2] | 0; else i1 = i1 & 255;
      if (i3 >>> 0 >= i1 >>> 0) break L324;
      i1 = HEAP32[i36 >> 2] | 0;
      do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i35 = 280;
        break L326;
       }
       if ((i1 | 0) == -1) {
        HEAP32[i36 >> 2] = 0;
        i1 = 0;
        break;
       } else {
        i1 = HEAP32[i36 >> 2] | 0;
        break;
       }
      } while (0);
      i2 = (i1 | 0) == 0;
      i1 = HEAP32[i37 >> 2] | 0;
      do if (!i1) i35 = 272; else {
       if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        i33 = __THREW__;
        __THREW__ = 0;
        if (i33 & 1) {
         i35 = 280;
         break L326;
        }
        if ((i1 | 0) == -1) {
         HEAP32[i37 >> 2] = 0;
         i35 = 272;
         break;
        }
       }
       if (!i2) {
        i35 = 279;
        break L326;
       }
      } while (0);
      if ((i35 | 0) == 272) {
       i35 = 0;
       if (i2) {
        i35 = 279;
        break;
       }
      }
      i1 = HEAP32[i36 >> 2] | 0;
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i35 = 280;
        break;
       }
      } else i1 = HEAPU8[i2 >> 0] | 0;
      if ((HEAP8[i5 >> 0] | 0) < 0) i2 = HEAP32[i34 >> 2] | 0; else i2 = i34;
      if ((i1 & 255) << 24 >> 24 != (HEAP8[i2 + i3 >> 0] | 0)) {
       i35 = 279;
       break;
      }
      i1 = i3 + 1 | 0;
      i2 = HEAP32[i36 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
       i33 = __THREW__;
       __THREW__ = 0;
       if (i33 & 1) {
        i35 = 280;
        break;
       } else {
        i3 = i1;
        continue;
       }
      } else {
       HEAP32[i3 >> 2] = i4 + 1;
       i3 = i1;
       continue;
      }
     }
     if ((i35 | 0) == 279) {
      HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
      i2 = 0;
      i35 = 288;
      break L322;
     } else if ((i35 | 0) == 280) {
      i2 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break L21;
     }
    } while (0);
    i2 = HEAP32[i48 >> 2] | 0;
    i1 = HEAP32[i38 >> 2] | 0;
    if ((i2 | 0) == (i1 | 0)) {
     i2 = 1;
     i35 = 288;
    } else {
     HEAP32[i39 >> 2] = 0;
     __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i42, i2, i1, i39);
     if (!(HEAP32[i39 >> 2] | 0)) {
      i2 = 1;
      i35 = 288;
      break;
     } else {
      HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
      i2 = 0;
      i35 = 288;
      break;
     }
    }
    break;
   }
  }
  if ((i35 | 0) == 36) {
   i2 = i1;
   break;
  } else if ((i35 | 0) == 252) {
   i2 = i1;
   break;
  } else if ((i35 | 0) == 288) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i46);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
   i1 = HEAP32[i48 >> 2] | 0;
   HEAP32[i48 >> 2] = 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(HEAP32[i47 >> 2] | 0, i1 | 0);
    i48 = __THREW__;
    __THREW__ = 0;
    if (i48 & 1) {
     i48 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i48);
    }
   }
   STACKTOP = i41;
   return i2 | 0;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i46);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
 i1 = HEAP32[i48 >> 2] | 0;
 HEAP32[i48 >> 2] = 0;
 if (i1 | 0) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i47 >> 2] | 0, i1 | 0);
  i48 = __THREW__;
  __THREW__ = 0;
  if (i48 & 1) {
   i48 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i48);
  }
 }
 ___resumeException(i2 | 0);
 return 0;
}

function __ZN14DetailDatabase12GenerateMeshER4Meshii8Vector3f16DetailRenderModefii(i15, i131, i114, i117, i118, i119, f120, i9, i12) {
 i15 = i15 | 0;
 i131 = i131 | 0;
 i114 = i114 | 0;
 i117 = i117 | 0;
 i118 = i118 | 0;
 i119 = i119 | 0;
 f120 = Math_fround(f120);
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i57 = 0, f58 = f0, i59 = 0, f60 = f0, i61 = 0, f62 = f0, i63 = 0, f64 = f0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, f97 = f0, f98 = f0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, f104 = f0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i115 = 0, i116 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0;
 i141 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i140 = i141 + 200 | 0;
 i132 = i141 + 188 | 0;
 i133 = i141 + 176 | 0;
 i134 = i141 + 164 | 0;
 i135 = i141 + 152 | 0;
 i136 = i141 + 140 | 0;
 i137 = i141 + 128 | 0;
 i138 = i141 + 116 | 0;
 i130 = i141 + 112 | 0;
 i129 = i141 + 108 | 0;
 i111 = i141 + 96 | 0;
 i112 = i141 + 80 | 0;
 i113 = i141 + 64 | 0;
 i115 = i141;
 i116 = i15 + 36 | 0;
 i13 = (Math_imul(HEAP32[i116 >> 2] | 0, i117) | 0) + i114 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i132 >> 2] = 0;
 i139 = i132 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i139;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i4;
 i11 = i9 * 12 | 0;
 i10 = (i11 | 0) != 0;
 do if (i10) {
  i1 = i11 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 828) | 0;
   i3 = gb + 64016 | 0;
   i128 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i132 >> 2] = i2;
   i4 = i139;
   HEAP32[i4 >> 2] = i128;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i6 = i2 + 3 & -4;
 HEAP32[i133 >> 2] = 0;
 i128 = i133 + 4 | 0;
 i8 = i128;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i4;
 i8 = i9 << 3;
 i7 = (i8 | 0) != 0;
 do if (i7) {
  i1 = (i8 | 4) + -1 | 0;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i5 = i4;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 831) | 0;
   i3 = gb + 64016 | 0;
   i127 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i133 >> 2] = i2;
   i5 = i128;
   HEAP32[i5 >> 2] = i127;
   HEAP32[i5 + 4 >> 2] = i3;
   i5 = gb + 63160 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   break;
  }
 } else {
  i2 = 0;
  i5 = i4;
 } while (0);
 i4 = i2 + 3 & -4;
 HEAP32[i134 >> 2] = 0;
 i127 = i134 + 4 | 0;
 i126 = i127;
 HEAP32[i126 >> 2] = i3;
 HEAP32[i126 + 4 >> 2] = i5;
 do if (i7) {
  i2 = (i8 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i7 = i3;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 836) | 0;
   i7 = gb + 64016 | 0;
   i126 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i134 >> 2] = i1;
   i5 = i127;
   HEAP32[i5 >> 2] = i126;
   HEAP32[i5 + 4 >> 2] = i7;
   i5 = gb + 63160 | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i7 = i3;
 } while (0);
 i3 = i1 + 3 & -4;
 i124 = (i119 | 0) == 0;
 HEAP32[i135 >> 2] = 0;
 i126 = i135 + 4 | 0;
 i1 = i126;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i9 << 4;
 do if ((i1 | 0) == 0 | i124 ^ 1) {
  i1 = 0;
  i8 = i7;
 } else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i8 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 843) | 0;
   i8 = gb + 64016 | 0;
   i125 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i135 >> 2] = i1;
   i5 = i126;
   HEAP32[i5 >> 2] = i125;
   HEAP32[i5 + 4 >> 2] = i8;
   i5 = gb + 63160 | 0;
   i8 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 i2 = i1 + 3 & -4;
 HEAP32[i136 >> 2] = 0;
 i125 = i136 + 4 | 0;
 i1 = i125;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i9 << 2;
 do if (!i1) i1 = 0; else {
  i7 = i1 | 3;
  if (i7 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 846) | 0;
   i8 = gb + 64016 | 0;
   i123 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i136 >> 2] = i1;
   i5 = i125;
   HEAP32[i5 >> 2] = i123;
   HEAP32[i5 + 4 >> 2] = i8;
   i5 = gb + 63160 | 0;
   i8 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 i110 = i1 + 3 & -4;
 HEAP32[i137 >> 2] = 0;
 i123 = i137 + 4 | 0;
 i122 = i123;
 HEAP32[i122 >> 2] = i8;
 HEAP32[i122 + 4 >> 2] = i5;
 do if (i10) {
  i7 = i11 | 3;
  if (i7 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i7 = i5;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 850) | 0;
   i8 = gb + 64016 | 0;
   i122 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i137 >> 2] = i1;
   i7 = i123;
   HEAP32[i7 >> 2] = i122;
   HEAP32[i7 + 4 >> 2] = i8;
   i7 = gb + 63160 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i7 = i5;
 } while (0);
 i9 = i1 + 3 & -4;
 i5 = i9;
 HEAP32[i138 >> 2] = 0;
 i122 = i138 + 4 | 0;
 i1 = i122;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 1;
 do if (!i1) i1 = 0; else {
  i7 = i1 | 1;
  if (i7 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, gb + 64016 | 0, 0, gb + 932993 | 0, 853) | 0;
   i109 = gb + 64016 | 0;
   i108 = HEAP32[i109 >> 2] | 0;
   i109 = HEAP32[i109 + 4 >> 2] | 0;
   HEAP32[i138 >> 2] = i1;
   i121 = i122;
   HEAP32[i121 >> 2] = i108;
   HEAP32[i121 + 4 >> 2] = i109;
   break;
  }
 } while (0);
 i121 = i1 + 1 & -2;
 i102 = i121;
 i103 = HEAP32[i15 + 40 >> 2] | 0;
 f104 = Math_fround(Math_fround(1.0) / Math_fround(Math_imul(HEAP32[i116 >> 2] | 0, i103) | 0));
 i105 = (HEAP32[i15 + 28 >> 2] | 0) + 248 | 0;
 HEAP32[i130 >> 2] = 0;
 HEAP32[i129 >> 2] = 0;
 i106 = i14 + (i13 * 52 | 0) + 28 | 0;
 i107 = i14 + (i13 * 52 | 0) + 32 | 0;
 i1 = HEAP32[i107 >> 2] | 0;
 i7 = HEAP32[i106 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  i14 = 0;
  i11 = 0;
 } else {
  i108 = i15 + 16 | 0;
  i109 = (i103 | 0) > 0;
  i96 = i14 + (i13 * 52 | 0) + 40 | 0;
  f97 = Math_fround(i114 | 0);
  f98 = Math_fround(i117 | 0);
  i99 = i15 + 88 | 0;
  i100 = i15 + 92 | 0;
  i101 = i15 + 96 | 0;
  i70 = i15 + 100 | 0;
  i71 = i111 + 4 | 0;
  i72 = i118 + 8 | 0;
  i73 = i111 + 8 | 0;
  i74 = i115 + 4 | 0;
  i75 = i115 + 8 | 0;
  i76 = i115 + 12 | 0;
  i77 = i115 + 20 | 0;
  i78 = i115 + 28 | 0;
  i79 = i112 + 12 | 0;
  i80 = i112 + 4 | 0;
  i81 = i112 + 8 | 0;
  i82 = i113 + 4 | 0;
  i83 = i113 + 8 | 0;
  i84 = i115 + 16 | 0;
  i85 = i115 + 32 | 0;
  i86 = i115 + 48 | 0;
  i87 = i115 + 4 | 0;
  i88 = i115 + 20 | 0;
  i89 = i115 + 36 | 0;
  i90 = i115 + 52 | 0;
  i91 = i115 + 8 | 0;
  i92 = i115 + 24 | 0;
  i93 = i115 + 40 | 0;
  i94 = i115 + 56 | 0;
  i95 = (i119 | 0) == 2;
  i67 = (i9 | 0) == 0;
  i66 = (i103 | 0) < 1;
  i68 = i115 + 16 | 0;
  i69 = i115 + 24 | 0;
  i14 = 0;
  i11 = 0;
  i65 = 0;
  do {
   i8 = HEAPU8[i7 + i65 >> 0] | 0;
   i9 = HEAP32[i108 >> 2] | 0;
   if ((HEAP32[i9 + (i8 * 136 | 0) + 68 >> 2] | 0) == (i119 | 0)) {
    i40 = HEAP32[i9 + (i8 * 136 | 0) + 80 >> 2] | 0;
    i44 = HEAP32[i9 + (i8 * 136 | 0) + 76 >> 2] | 0;
    i45 = (i40 | 0) == (i44 | 0) ? 0 : i44;
    i56 = HEAP32[i9 + (i8 * 136 | 0) + 88 >> 2] | 0;
    i56 = (HEAP32[i9 + (i8 * 136 | 0) + 92 >> 2] | 0) == (i56 | 0) ? 0 : i56;
    i46 = HEAP32[i9 + (i8 * 136 | 0) + 100 >> 2] | 0;
    i46 = (HEAP32[i9 + (i8 * 136 | 0) + 104 >> 2] | 0) == (i46 | 0) ? 0 : i46;
    i57 = HEAP32[i9 + (i8 * 136 | 0) + 112 >> 2] | 0;
    i57 = (HEAP32[i9 + (i8 * 136 | 0) + 116 >> 2] | 0) == (i57 | 0) ? 0 : i57;
    i39 = HEAP32[i9 + (i8 * 136 | 0) + 128 >> 2] | 0;
    i43 = HEAP32[i9 + (i8 * 136 | 0) + 124 >> 2] | 0;
    i47 = (i39 | 0) == (i43 | 0) ? 0 : i43;
    f58 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 24 >> 2]);
    f49 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 48 >> 2]);
    f51 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 52 >> 2]);
    f53 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 56 >> 2]);
    f55 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 60 >> 2]);
    f48 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 32 >> 2]);
    f50 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 36 >> 2]);
    f52 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 40 >> 2]);
    f54 = Math_fround(HEAPF32[i9 + (i8 * 136 | 0) + 44 >> 2]);
    i59 = i9 + (i8 * 136 | 0) + 8 | 0;
    f62 = Math_fround(HEAPF32[i59 >> 2]);
    f60 = Math_fround(f62 * Math_fround(.5));
    i61 = i9 + (i8 * 136 | 0) + 12 | 0;
    f62 = Math_fround(Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f62) * Math_fround(.5));
    i63 = i9 + (i8 * 136 | 0) + 16 | 0;
    f64 = Math_fround(HEAPF32[i63 >> 2]);
    i41 = i9 + (i8 * 136 | 0) + 20 | 0;
    f42 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) - f64);
    i9 = i39 - i43 | 0;
    i43 = i9 >> 1;
    i8 = i40 - i44 | 0;
    i44 = (i8 | 0) / 12 | 0;
    if (!((i8 | 0) == 0 | i66)) {
     i40 = Math_imul(i65, i103) | 0;
     i39 = (i8 | 0) > 0;
     i38 = (i9 | 0) > 0;
     i37 = 0;
     do {
      if (i109) {
       i36 = Math_imul(i37 + i40 | 0, i103) | 0;
       f34 = Math_fround(i37 | 0);
       i35 = i37 & 7;
       i33 = 0;
       do {
        i1 = i36 + i33 | 0;
        i30 = HEAP8[(HEAP32[i96 >> 2] | 0) + i1 >> 0] | 0;
        i7 = i30 & 255;
        if (i30 << 24 >> 24) {
         i8 = HEAP32[i116 >> 2] | 0;
         f24 = Math_fround(i8 | 0);
         f32 = Math_fround(Math_imul(i8, i103) | 0);
         f31 = Math_fround(Math_fround(f97 / f24) + Math_fround(Math_fround(i33 | 0) / f32));
         f32 = Math_fround(Math_fround(f98 / f24) + Math_fround(f34 / f32));
         i8 = (((Math_imul(i8, i114) | 0) + i117 | 0) * 1013 | 0) + i1 | 0;
         HEAP32[i99 >> 2] = i8;
         i10 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
         HEAP32[i100 >> 2] = i10;
         i12 = (Math_imul(i10, 1812433253) | 0) + 1 | 0;
         HEAP32[i101 >> 2] = i12;
         i9 = (Math_imul(i12, 1812433253) | 0) + 1 | 0;
         HEAP32[i70 >> 2] = i9;
         i28 = (65e3 - i11 | 0) / (i44 | 0) | 0;
         f24 = Math_fround(Math_fround(((i7 | 0) < (i28 | 0) ? i7 : i28) | 0) * f120);
         i28 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[gb + 184836 + ((i33 << 3 & 56 | i35) << 2) >> 2]) + Math_fround(-.5)) * Math_fround(.015625)) + f24);
         if ((i28 | 0) > 0) {
          i29 = Math_imul(i43, i28) | 0;
          i30 = Math_imul(i44, i28) | 0;
          i1 = 0;
          i26 = i11;
          i27 = i14;
          i7 = i12;
          while (1) {
           i8 = i8 << 11 ^ i8;
           i8 = i8 >>> 8 ^ i8 ^ i9;
           i25 = i8 ^ i9 >>> 19;
           f19 = Math_fround(f31 + Math_fround(f104 * Math_fround(Math_fround((i25 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
           i10 = i10 << 11 ^ i10;
           HEAP32[i99 >> 2] = i7;
           HEAP32[i100 >> 2] = i9;
           HEAP32[i101 >> 2] = i25;
           i10 = i10 >>> 8 ^ i10 ^ i25 ^ i8 >>> 19;
           HEAP32[i70 >> 2] = i10;
           f18 = Math_fround(f32 + Math_fround(f104 * Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
           HEAPF32[i71 >> 2] = Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i105, f19, f18));
           f17 = Math_fround(f19 * Math_fround(HEAPF32[i118 >> 2]));
           HEAPF32[i111 >> 2] = f17;
           f16 = Math_fround(f18 * Math_fround(HEAPF32[i72 >> 2]));
           HEAPF32[i73 >> 2] = f16;
           f16 = Math_fround(Math_fround(Math_fround(__ZN11PerlinNoise5NoiseEff(Math_fround(f58 * f17), Math_fround(f58 * f16))) + Math_fround(.689999997)) / Math_fround(1.48300004));
           f17 = Math_fround(Math_fround(1.0) - f16);
           f21 = Math_fround(Math_fround(f48 * f16) + Math_fround(f49 * f17));
           f22 = Math_fround(Math_fround(f50 * f16) + Math_fround(f51 * f17));
           f23 = Math_fround(Math_fround(f52 * f16) + Math_fround(f53 * f17));
           f24 = Math_fround(Math_fround(f54 * f16) + Math_fround(f55 * f17));
           i10 = f21 < Math_fround(0.0);
           f21 = i10 ? Math_fround(0.0) : f21;
           i10 = f21 > Math_fround(1.0);
           i10 = ~~Math_fround(Math_fround((i10 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
           i8 = f22 < Math_fround(0.0);
           f22 = i8 ? Math_fround(0.0) : f22;
           i8 = f22 > Math_fround(1.0);
           i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f22) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
           i7 = f23 < Math_fround(0.0);
           f23 = i7 ? Math_fround(0.0) : f23;
           i7 = f23 > Math_fround(1.0);
           i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
           i25 = f24 < Math_fround(0.0);
           f24 = i25 ? Math_fround(0.0) : f24;
           i25 = f24 > Math_fround(1.0);
           i25 = ~~Math_fround(Math_fround((i25 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
           i9 = i7 << 16 & 16711680 | i25 << 24;
           if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
            i13 = i10;
            i8 = (i9 | i8 << 8 & 65280) >>> 8;
            i15 = i9 >>> 16;
           } else {
            i13 = i7;
            i15 = i10;
           }
           if (i39) {
            i7 = 0;
            do {
             i12 = i7 + i26 | 0;
             HEAPF32[i3 + (i12 << 3) >> 2] = f19;
             HEAPF32[i3 + (i12 << 3) + 4 >> 2] = f18;
             i7 = i7 + 1 | 0;
            } while ((i7 | 0) != (i44 | 0));
           }
           if (i124) {
            f24 = Math_fround(f60 + Math_fround(f62 * f16));
            HEAPF32[i112 >> 2] = f24;
            f23 = Math_fround(f64 + Math_fround(f42 * f16));
            HEAPF32[i113 >> 2] = f23;
            i9 = Math_fround(HEAPF32[i130 >> 2]) < f24;
            HEAP32[i130 >> 2] = HEAP32[(i9 ? i112 : i130) >> 2];
            i9 = Math_fround(HEAPF32[i129 >> 2]) < f23;
            HEAP32[i129 >> 2] = HEAP32[(i9 ? i113 : i129) >> 2];
            f22 = Math_fround(-f24);
            HEAPF32[i115 >> 2] = f22;
            HEAPF32[i74 >> 2] = Math_fround(0.0);
            HEAPF32[i75 >> 2] = f22;
            HEAPF32[i76 >> 2] = f23;
            HEAPF32[i68 >> 2] = f24;
            HEAPF32[i77 >> 2] = f23;
            HEAPF32[i69 >> 2] = f24;
            HEAPF32[i78 >> 2] = Math_fround(0.0);
            i9 = HEAP32[i111 >> 2] | 0;
            i10 = HEAP32[i71 >> 2] | 0;
            i12 = HEAP32[i73 >> 2] | 0;
            if (i39) {
             i7 = 0;
             do {
              i142 = i7 + i26 | 0;
              HEAP32[i6 + (i142 * 12 | 0) >> 2] = i9;
              HEAP32[i6 + (i142 * 12 | 0) + 4 >> 2] = i10;
              HEAP32[i6 + (i142 * 12 | 0) + 8 >> 2] = i12;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             i7 = 0;
             do {
              i10 = i46 + (i7 << 3) | 0;
              i12 = HEAP32[i10 + 4 >> 2] | 0;
              i142 = i4 + (i7 + i26 << 3) | 0;
              HEAP32[i142 >> 2] = HEAP32[i10 >> 2];
              HEAP32[i142 + 4 >> 2] = i12;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             i7 = 0;
             do {
              i12 = HEAP32[i115 + (i7 << 3) + 4 >> 2] | 0;
              i142 = i7 + i26 | 0;
              HEAP32[i2 + (i142 << 4) >> 2] = HEAP32[i115 + (i7 << 3) >> 2];
              HEAP32[i2 + (i142 << 4) + 4 >> 2] = i12;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             i12 = (i13 & 255) + 1 | 0;
             i10 = (i8 & 255) + 1 | 0;
             i9 = (i15 & 255) + 1 | 0;
             i8 = (i25 & 255) + 1 | 0;
             i7 = 0;
             do {
              i142 = HEAP32[i57 + (i7 << 2) >> 2] | 0;
              i25 = i142 >>> 8;
              HEAP32[i110 + (i7 + i26 << 2) >> 2] = (Math_imul(i25 & 255, i10) | 0) & 65280 | (Math_imul(i25 & 16711680, i8) | 0) & -16777216 | (Math_imul(i142 & 255, i12) | 0) >>> 8 & 255 | (Math_imul(i142 & 16711680, i9) | 0) >>> 8 & 16711680;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             __ZNK9Heightmap21GetInterpolatedNormalEff(i140, i105, f19, f18);
             i7 = 0;
             do {
              i142 = i5 + ((i7 + i26 | 0) * 12 | 0) | 0;
              HEAP32[i142 >> 2] = HEAP32[i140 >> 2];
              HEAP32[i142 + 4 >> 2] = HEAP32[i140 + 4 >> 2];
              HEAP32[i142 + 8 >> 2] = HEAP32[i140 + 8 >> 2];
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
            } else __ZNK9Heightmap21GetInterpolatedNormalEff(i140, i105, f19, f18);
            if (i38) {
             i7 = 0;
             do {
              HEAP16[i102 + (i7 + i27 << 1) >> 1] = (HEAPU16[i47 + (i7 << 1) >> 1] | 0) + i26;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) < (i43 | 0));
            }
           } else {
            i12 = HEAP32[i99 >> 2] | 0;
            i12 = i12 << 11 ^ i12;
            HEAP32[i99 >> 2] = HEAP32[i100 >> 2];
            HEAP32[i100 >> 2] = HEAP32[i101 >> 2];
            i142 = HEAP32[i70 >> 2] | 0;
            HEAP32[i101 >> 2] = i142;
            i142 = i12 >>> 8 ^ i12 ^ i142 ^ i142 >>> 19;
            HEAP32[i70 >> 2] = i142;
            f24 = Math_fround(Math_fround(Math_fround(Math_fround((i142 & 8388607) >>> 0) * Math_fround(1.19209304e-07)) * Math_fround(6.283185)) * Math_fround(.5));
            f23 = Math_fround(+Math_sin(+f24));
            HEAPF32[i79 >> 2] = Math_fround(+Math_cos(+f24));
            f24 = Math_fround(f23 * Math_fround(0.0));
            HEAPF32[i112 >> 2] = f24;
            HEAPF32[i80 >> 2] = f23;
            HEAPF32[i81 >> 2] = f24;
            f24 = Math_fround(HEAPF32[i59 >> 2]);
            f24 = Math_fround(Math_fround(f17 * f24) + Math_fround(f16 * Math_fround(HEAPF32[i61 >> 2])));
            f23 = Math_fround(HEAPF32[i63 >> 2]);
            f23 = Math_fround(Math_fround(f17 * f23) + Math_fround(f16 * Math_fround(HEAPF32[i41 >> 2])));
            HEAPF32[i113 >> 2] = f24;
            HEAPF32[i82 >> 2] = f23;
            HEAPF32[i83 >> 2] = f24;
            __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i115, i111, i112, i113);
            if (i39) {
             i7 = 0;
             do {
              i142 = i7 + i26 | 0;
              f22 = Math_fround(HEAPF32[i115 >> 2]);
              f20 = Math_fround(HEAPF32[i45 + (i7 * 12 | 0) >> 2]);
              f22 = Math_fround(f22 * f20);
              f23 = Math_fround(HEAPF32[i84 >> 2]);
              f21 = Math_fround(HEAPF32[i45 + (i7 * 12 | 0) + 4 >> 2]);
              f23 = Math_fround(f22 + Math_fround(f23 * f21));
              f22 = Math_fround(HEAPF32[i85 >> 2]);
              f24 = Math_fround(HEAPF32[i45 + (i7 * 12 | 0) + 8 >> 2]);
              f22 = Math_fround(f23 + Math_fround(f22 * f24));
              f22 = Math_fround(Math_fround(HEAPF32[i86 >> 2]) + f22);
              f23 = Math_fround(f20 * Math_fround(HEAPF32[i87 >> 2]));
              f23 = Math_fround(f23 + Math_fround(f21 * Math_fround(HEAPF32[i88 >> 2])));
              f23 = Math_fround(f23 + Math_fround(f24 * Math_fround(HEAPF32[i89 >> 2])));
              f23 = Math_fround(Math_fround(HEAPF32[i90 >> 2]) + f23);
              f20 = Math_fround(f20 * Math_fround(HEAPF32[i91 >> 2]));
              f21 = Math_fround(f20 + Math_fround(f21 * Math_fround(HEAPF32[i92 >> 2])));
              f24 = Math_fround(f21 + Math_fround(f24 * Math_fround(HEAPF32[i93 >> 2])));
              f24 = Math_fround(Math_fround(HEAPF32[i94 >> 2]) + f24);
              HEAPF32[i6 + (i142 * 12 | 0) >> 2] = f22;
              HEAPF32[i6 + (i142 * 12 | 0) + 4 >> 2] = f23;
              HEAPF32[i6 + (i142 * 12 | 0) + 8 >> 2] = f24;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             i7 = 0;
             do {
              i10 = i46 + (i7 << 3) | 0;
              i12 = HEAP32[i10 + 4 >> 2] | 0;
              i142 = i4 + (i7 + i26 << 3) | 0;
              HEAP32[i142 >> 2] = HEAP32[i10 >> 2];
              HEAP32[i142 + 4 >> 2] = i12;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
             i12 = (i13 & 255) + 1 | 0;
             i10 = (i8 & 255) + 1 | 0;
             i9 = (i15 & 255) + 1 | 0;
             i8 = (i25 & 255) + 1 | 0;
             i7 = 0;
             do {
              i142 = HEAP32[i57 + (i7 << 2) >> 2] | 0;
              i25 = i142 >>> 8;
              HEAP32[i110 + (i7 + i26 << 2) >> 2] = (Math_imul(i25 & 255, i10) | 0) & 65280 | (Math_imul(i25 & 16711680, i8) | 0) & -16777216 | (Math_imul(i142 & 255, i12) | 0) >>> 8 & 255 | (Math_imul(i142 & 16711680, i9) | 0) >>> 8 & 16711680;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
            }
            do if (i95) {
             __ZNK9Heightmap21GetInterpolatedNormalEff(i140, i105, f19, f18);
             if (i39) {
              i7 = 0;
              do {
               i142 = i5 + ((i7 + i26 | 0) * 12 | 0) | 0;
               HEAP32[i142 >> 2] = HEAP32[i140 >> 2];
               HEAP32[i142 + 4 >> 2] = HEAP32[i140 + 4 >> 2];
               HEAP32[i142 + 8 >> 2] = HEAP32[i140 + 8 >> 2];
               i7 = i7 + 1 | 0;
              } while ((i7 | 0) != (i44 | 0));
             }
            } else {
             if (i67) break;
             f16 = Math_fround(HEAPF32[i112 >> 2]);
             f17 = Math_fround(HEAPF32[i80 >> 2]);
             f18 = Math_fround(HEAPF32[i81 >> 2]);
             f19 = Math_fround(HEAPF32[i79 >> 2]);
             if (!i39) break;
             f23 = Math_fround(f16 * Math_fround(2.0));
             f22 = Math_fround(f17 * Math_fround(2.0));
             f146 = Math_fround(f18 * Math_fround(2.0));
             f143 = Math_fround(f16 * f23);
             f24 = Math_fround(f17 * f22);
             f20 = Math_fround(f18 * f146);
             f21 = Math_fround(f16 * f22);
             f145 = Math_fround(f16 * f146);
             f144 = Math_fround(f17 * f146);
             f23 = Math_fround(f23 * f19);
             f22 = Math_fround(f22 * f19);
             f19 = Math_fround(f19 * f146);
             f16 = Math_fround(Math_fround(1.0) - Math_fround(f24 + f20));
             f17 = Math_fround(f21 - f19);
             f18 = Math_fround(f145 + f22);
             f19 = Math_fround(f21 + f19);
             f20 = Math_fround(Math_fround(1.0) - Math_fround(f143 + f20));
             f21 = Math_fround(f144 - f23);
             f22 = Math_fround(f145 - f22);
             f23 = Math_fround(f144 + f23);
             f24 = Math_fround(Math_fround(1.0) - Math_fround(f143 + f24));
             i7 = 0;
             do {
              i142 = i7 + i26 | 0;
              f147 = Math_fround(HEAPF32[i56 + (i7 * 12 | 0) >> 2]);
              f144 = Math_fround(f16 * f147);
              f146 = Math_fround(HEAPF32[i56 + (i7 * 12 | 0) + 4 >> 2]);
              f144 = Math_fround(f144 + Math_fround(f17 * f146));
              f143 = Math_fround(HEAPF32[i56 + (i7 * 12 | 0) + 8 >> 2]);
              f145 = Math_fround(Math_fround(f21 * f143) + Math_fround(Math_fround(f19 * f147) + Math_fround(f20 * f146)));
              f146 = Math_fround(Math_fround(Math_fround(f22 * f147) + Math_fround(f23 * f146)) + Math_fround(f24 * f143));
              HEAPF32[i5 + (i142 * 12 | 0) >> 2] = Math_fround(Math_fround(f18 * f143) + f144);
              HEAPF32[i5 + (i142 * 12 | 0) + 4 >> 2] = f145;
              HEAPF32[i5 + (i142 * 12 | 0) + 8 >> 2] = f146;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i44 | 0));
            } while (0);
            if (i38) {
             i7 = 0;
             do {
              HEAP16[i102 + (i7 + i27 << 1) >> 1] = (HEAPU16[i47 + (i7 << 1) >> 1] | 0) + i26;
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) < (i43 | 0));
            }
           }
           i1 = i1 + 1 | 0;
           if ((i1 | 0) == (i28 | 0)) break;
           i26 = i26 + i44 | 0;
           i27 = i27 + i43 | 0;
           i8 = HEAP32[i99 >> 2] | 0;
           i9 = HEAP32[i70 >> 2] | 0;
           i10 = HEAP32[i100 >> 2] | 0;
           i7 = HEAP32[i101 >> 2] | 0;
          }
          i14 = i14 + i29 | 0;
          i11 = i11 + i30 | 0;
         }
        }
        i33 = i33 + 1 | 0;
       } while ((i33 | 0) != (i103 | 0));
      }
      i37 = i37 + 1 | 0;
     } while ((i37 | 0) != (i103 | 0));
     i1 = HEAP32[i107 >> 2] | 0;
     i7 = HEAP32[i106 >> 2] | 0;
    }
   }
   i65 = i65 + 1 | 0;
  } while (i65 >>> 0 < (i1 - i7 | 0) >>> 0);
 }
 __ZN4Mesh5ClearEb(i131, 1);
 __ZN4Mesh14ResizeVerticesEjj(i131, i11, i124 ? 159 : 31);
 i9 = i6 + (i11 * 12 | 0) | 0;
 i13 = i131 + 32 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i7 = i8 + 8 | 0;
 i142 = HEAP16[i8 + 10 >> 1] | 0;
 if ((i142 & 65535) < 768 | (i142 & 255) != 0) {
  i1 = 0;
  i7 = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 1;
  } else if (!(HEAP8[i8 + 11 >> 0] | 0)) {
   i1 = 0;
   i7 = 1;
  } else {
   i142 = HEAP16[i7 >> 1] | 0;
   i1 = i1 + (((i142 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i142 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i7 = HEAPU8[i7 + 32 + ((HEAPU8[i7 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 i12 = (i11 | 0) == 0;
 if (!i12) {
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i6 = i6 + 12 | 0;
   if ((i6 | 0) == (i9 | 0)) break; else i1 = i1 + i7 | 0;
  }
  i8 = HEAP32[i13 >> 2] | 0;
 }
 i9 = i110 + (i11 << 2) | 0;
 i10 = i8 + 8 | 0;
 i142 = HEAP16[i8 + 18 >> 1] | 0;
 if ((i142 & 65535) < 1024 | (i142 & 255) != 2) {
  i1 = 0;
  i7 = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 1;
  } else if (!(HEAP8[i8 + 19 >> 0] | 0)) {
   i1 = 0;
   i7 = 1;
  } else {
   i7 = HEAP16[i8 + 16 >> 1] | 0;
   i1 = i1 + (((i7 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i7 = HEAPU8[i10 + 32 + ((HEAPU8[i8 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if (!i12) {
  i6 = i110;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   i6 = i6 + 4 | 0;
   if ((i6 | 0) == (i9 | 0)) break; else i1 = i1 + i7 | 0;
  }
 }
 i7 = i5 + (i11 * 12 | 0) | 0;
 i142 = HEAP16[i8 + 14 >> 1] | 0;
 if ((i142 & 65535) < 768 | (i142 & 255) != 0) {
  i1 = 0;
  i6 = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i6 = 1;
  } else if (!(HEAP8[i8 + 15 >> 0] | 0)) {
   i1 = 0;
   i6 = 1;
  } else {
   i6 = HEAP16[i8 + 12 >> 1] | 0;
   i1 = i1 + (((i6 & 65535) >>> 8 & 65535) + (HEAP32[i10 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i6 = HEAPU8[i10 + 32 + ((HEAPU8[i8 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if (!i12) while (1) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i5 = i5 + 12 | 0;
  if ((i5 | 0) == (i7 | 0)) break; else i1 = i1 + i6 | 0;
 }
 i7 = i4 + (i11 << 3) | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i142 = HEAP16[i5 + 22 >> 1] | 0;
 if ((i142 & 65535) < 512 | (i142 & 255) != 0) {
  i1 = 0;
  i6 = 0;
 } else {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i6 = 1;
  } else if (!(HEAP8[i5 + 23 >> 0] | 0)) {
   i1 = 0;
   i6 = 1;
  } else {
   i142 = HEAP16[i5 + 20 >> 1] | 0;
   i1 = i1 + (((i142 & 65535) >>> 8 & 65535) + (HEAP32[i6 + 32 + ((i142 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i6 = HEAPU8[i6 + 32 + ((HEAPU8[i5 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if (!i12) {
  while (1) {
   i118 = i4;
   i119 = HEAP32[i118 + 4 >> 2] | 0;
   i142 = i1;
   HEAP32[i142 >> 2] = HEAP32[i118 >> 2];
   HEAP32[i142 + 4 >> 2] = i119;
   i4 = i4 + 8 | 0;
   if ((i4 | 0) == (i7 | 0)) break; else i1 = i1 + i6 | 0;
  }
  i5 = HEAP32[i13 >> 2] | 0;
 }
 i6 = i3 + (i11 << 3) | 0;
 i4 = i5 + 8 | 0;
 i142 = HEAP16[i5 + 26 >> 1] | 0;
 if ((i142 & 65535) < 512 | (i142 & 255) != 0) {
  i1 = 0;
  i4 = 0;
 } else {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = 1;
  } else if (!(HEAP8[i5 + 27 >> 0] | 0)) {
   i1 = 0;
   i4 = 1;
  } else {
   i142 = HEAP16[i5 + 24 >> 1] | 0;
   i1 = i1 + (((i142 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i142 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i4 = HEAPU8[i4 + 32 + ((HEAPU8[i5 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if (!i12) while (1) {
  i118 = i3;
  i119 = HEAP32[i118 + 4 >> 2] | 0;
  i142 = i1;
  HEAP32[i142 >> 2] = HEAP32[i118 >> 2];
  HEAP32[i142 + 4 >> 2] = i119;
  i3 = i3 + 8 | 0;
  if ((i3 | 0) == (i6 | 0)) break; else i1 = i1 + i4 | 0;
 }
 if (!i124) {
  __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i131, i121, i14, 0, 0, 1) | 0;
  __ZN4Mesh16SetChannelsDirtyEjb(i131, HEAP32[(HEAP32[i13 >> 2] | 0) + 96 >> 2] | 0, 1);
  __ZN4Mesh17RecalculateBoundsEv(i131);
  i142 = HEAP32[i138 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i122);
  i142 = HEAP32[i137 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i123);
  i142 = HEAP32[i136 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i125);
  i142 = HEAP32[i135 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i126);
  i142 = HEAP32[i134 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i127);
  i142 = HEAP32[i133 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i128);
  i142 = HEAP32[i132 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i142, i139);
  STACKTOP = i141;
  return;
 }
 i5 = i2 + (i11 << 4) | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i142 = HEAP16[i3 + 38 >> 1] | 0;
 do if ((i142 & 65535) < 1024 | (i142 & 255) != 0) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = 1;
   break;
  }
  if (!(HEAP8[i3 + 39 >> 0] | 0)) {
   i1 = 0;
   i3 = 1;
   break;
  }
  i142 = HEAP16[i3 + 36 >> 1] | 0;
  i1 = i1 + (((i142 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i142 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
  i3 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
 } while (0);
 if (!i12) while (1) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
 }
 __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i131, i121, i14, 0, 0, 1) | 0;
 __ZN4Mesh16SetChannelsDirtyEjb(i131, HEAP32[(HEAP32[i13 >> 2] | 0) + 96 >> 2] | 0, 1);
 __ZN4Mesh17RecalculateBoundsEv(i131);
 f120 = Math_fround(HEAPF32[i130 >> 2]);
 f145 = Math_fround(HEAPF32[i129 >> 2]);
 f144 = Math_fround(HEAPF32[i131 + 48 >> 2]);
 f146 = Math_fround(HEAPF32[i131 + 52 >> 2]);
 f147 = Math_fround(HEAPF32[i131 + 56 >> 2]);
 f98 = Math_fround(HEAPF32[i131 + 60 >> 2]);
 f104 = Math_fround(HEAPF32[i131 + 64 >> 2]);
 f143 = Math_fround(HEAPF32[i131 + 68 >> 2]);
 f120 = f120 < f145 ? f145 : f120;
 f145 = Math_fround(f145 * Math_fround(.5));
 HEAPF32[i140 + 12 >> 2] = Math_fround(f120 + f98);
 HEAPF32[i140 + 16 >> 2] = Math_fround(f145 + f104);
 HEAPF32[i140 + 20 >> 2] = Math_fround(f120 + f143);
 HEAPF32[i140 >> 2] = Math_fround(f144 + Math_fround(0.0));
 HEAPF32[i140 + 4 >> 2] = Math_fround(f145 + f146);
 HEAPF32[i140 + 8 >> 2] = Math_fround(f147 + Math_fround(0.0));
 __ZN4Mesh9SetBoundsERK4AABB(i131, i140);
 i142 = HEAP32[i138 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i122);
 i142 = HEAP32[i137 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i123);
 i142 = HEAP32[i136 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i125);
 i142 = HEAP32[i135 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i126);
 i142 = HEAP32[i134 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i127);
 i142 = HEAP32[i133 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i128);
 i142 = HEAP32[i132 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i142, i139);
 STACKTOP = i141;
 return;
}

function __ZN21AnimationClipPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i16, i18, i53, i6) {
 i16 = i16 | 0;
 i18 = i18 | 0;
 i53 = i53 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 2192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i56 + 8 | 0;
 i10 = i56;
 i55 = i56 + 2172 | 0;
 i8 = i56 + 2168 | 0;
 i9 = i56 + 2164 | 0;
 i14 = i56 + 2160 | 0;
 i15 = i56 + 2156 | 0;
 i54 = i56 + 2152 | 0;
 i32 = i56 + 1264 | 0;
 i33 = i56 + 1256 | 0;
 i34 = i56 + 1252 | 0;
 i50 = i56 + 920 | 0;
 i52 = i56 + 32 | 0;
 i24 = gb + 64016 | 0;
 i7 = HEAP32[i24 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i55 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i10);
 i1 = i51;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i24 = i55 + 4 | 0;
 HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i24 + 4 >> 2] = i7;
 i24 = HEAP8[i18 + 34 >> 0] | 0;
 i7 = HEAP8[i18 + 33 >> 0] | 0;
 i1 = i6 + 4 | 0;
 HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | HEAP8[i16 + 172 >> 0];
 i1 = i16 + 84 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0;
  if (!(HEAP8[i16 + 113 >> 0] | 0)) {
   __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(i1, 1);
   i55 = HEAP32[i6 >> 2] | 0;
   __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE(HEAP32[i53 + 12 >> 2] | 0, HEAP32[i55 >> 2] | 0, HEAP32[i55 + 4 >> 2] | 0);
  } else __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(i1, 0);
  if (!((i7 | i24) << 24 >> 24)) {
   STACKTOP = i56;
   return;
  }
  __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0);
  if (!(i24 << 24 >> 24)) {
   STACKTOP = i56;
   return;
  }
  __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0);
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
  if (!i1) {
   STACKTOP = i56;
   return;
  }
  __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(i1);
  STACKTOP = i56;
  return;
 }
 HEAPF32[i51 >> 2] = Math_fround(0.0);
 i35 = i51 + 4 | 0;
 HEAPF32[i35 >> 2] = Math_fround(0.0);
 i36 = i51 + 8 | 0;
 HEAPF32[i36 >> 2] = Math_fround(1.0);
 i5 = i51 + 12 | 0;
 HEAP8[i5 >> 0] = 0;
 i37 = i51 + 16 | 0;
 HEAPF32[i37 >> 2] = Math_fround(0.0);
 i38 = i51 + 20 | 0;
 HEAP8[i38 >> 0] = 0;
 i13 = i51 + 21 | 0;
 HEAP8[i13 >> 0] = 1;
 i49 = HEAP32[i16 + 164 >> 2] | 0;
 f2 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i49 >> 2] | 0) + 92 >> 2] | 0, i49 | 0));
 if (f2 != Math_fround(0.0)) {
  HEAPF32[i51 >> 2] = Math_fround(Math_fround(HEAPF32[i16 + 96 >> 2]) / f2);
  f2 = Math_fround(Math_fround(HEAPF32[i16 + 100 >> 2]) / f2);
 } else {
  HEAPF32[i51 >> 2] = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i35 >> 2] = f2;
 HEAP32[i37 >> 2] = HEAP32[i16 + 108 >> 2];
 HEAP32[i36 >> 2] = HEAP32[i16 + 104 >> 2];
 HEAP8[i5 >> 0] = HEAP8[i16 + 112 >> 0] | 0;
 HEAP8[i38 >> 0] = HEAP8[i18 + 36 >> 0] | 0;
 i45 = HEAP32[i1 >> 2] | 0;
 i28 = i45 + 1060 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i29 = i28;
 i1 = (i1 | 0) == 0 ? 0 : i29 + i1 | 0;
 i17 = HEAP32[i16 + 88 >> 2] | 0;
 i11 = HEAP32[i18 + 4 >> 2] | 0;
 i25 = i18 + 8 | 0;
 i21 = HEAP32[i25 >> 2] | 0;
 i22 = HEAP32[i18 + 12 >> 2] | 0;
 i26 = HEAP32[i18 + 24 >> 2] | 0;
 i12 = HEAP32[i18 + 28 >> 2] | 0;
 i49 = (HEAP8[i53 + 4 >> 0] | 0) != 0;
 i27 = HEAP32[i53 >> 2] | 0;
 i30 = HEAP32[i16 + 92 >> 2] | 0;
 i19 = HEAP32[i6 >> 2] | 0;
 i46 = HEAP32[i19 >> 2] | 0;
 i47 = HEAP32[i19 + 8 >> 2] | 0;
 i23 = i19 + 12 | 0;
 i20 = HEAP32[i23 >> 2] | 0;
 i48 = __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE(i1, i55) | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i54 >> 2] = Math_fround(0.0);
 i6 = (i7 | i24) << 24 >> 24 == 0;
 if (i6) {
  i44 = 0;
  i7 = i45 + 1068 | 0;
  i8 = i45 + 1080 | 0;
  i9 = i45 + 1725 | 0;
  i10 = i45 + 1064 | 0;
 } else {
  i44 = __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE(i1, i55) | 0;
  f58 = Math_fround(HEAPF32[i35 >> 2]);
  i43 = i45 + 1064 | 0;
  f57 = Math_fround(HEAPF32[i43 >> 2]);
  i7 = i45 + 1068 | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  i41 = i45 + 1080 | 0;
  f3 = Math_fround(HEAPF32[i41 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i37 >> 2]));
  i42 = i45 + 1725 | 0;
  f4 = Math_fround(HEAPF32[i36 >> 2]);
  HEAPF32[i10 >> 2] = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f58, f57, f2, f3, (HEAP8[i42 >> 0] | 0) != 0, f4, i9, i8, Math_fround(HEAPF32[i51 >> 2]) < Math_fround(0.0)));
  i8 = HEAP32[i28 >> 2] | 0;
  __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i8 | 0) == 0 ? 0 : i8 + i29 | 0, i10, i30, i44);
  i8 = i41;
  i9 = i42;
  i10 = i43;
 }
 f58 = Math_fround(HEAPF32[i51 >> 2]);
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 f57 = Math_fround(HEAPF32[i8 >> 2]);
 f57 = Math_fround(f57 + Math_fround(HEAPF32[i37 >> 2]));
 HEAPF32[i14 >> 2] = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f58, f3, f4, f57, (HEAP8[i9 >> 0] | 0) != 0, Math_fround(HEAPF32[i36 >> 2]), i54, i15, f58 < Math_fround(0.0)));
 i43 = HEAP32[i28 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i43 | 0) == 0 ? 0 : i43 + i29 | 0, i14, i30, i48);
 if (!i6) {
  HEAP8[i13 >> 0] = HEAP8[i16 + 173 >> 0] | 0;
  __ZN7mecanim9animation18EvaluateRootMotionERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfS8_RNS0_12MotionOutputEb(i45, i51, HEAP32[i44 >> 2] | 0, HEAP32[i48 >> 2] | 0, i47, i24 << 24 >> 24 != 0);
 }
 i5 = (HEAP8[i16 + 113 >> 0] | 0) == 0;
 if (i5) {
  i1 = HEAP32[i53 + 12 >> 2] | 0;
  if (!i1) i31 = 19;
 } else i31 = 19;
 if ((i31 | 0) == 19) i1 = i11;
 i43 = i19 + 4 | 0;
 __ZN7mecanim9animation14ValuesFromClipERKNS_10ValueArrayERKNS0_18ClipMuscleConstantERKNS0_10ClipOutputERKNS0_12ClipBindingsEiRS1_RNS_14ValueArrayMaskEb(i1, i45, i48, i17, i12, i46, HEAP32[i43 >> 2] | 0, i5);
 if (!(HEAP8[i9 >> 0] | 0)) i42 = 0; else i42 = (HEAP8[i45 + 1726 >> 0] | 0) != 0;
 if (i49 | i42) {
  i39 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i18 >> 2] | 0, i55) | 0;
  i40 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i18 >> 2] | 0, i55) | 0;
  i41 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i18 >> 2] | 0, i55) | 0;
  __ZN7mecanim9animation14DeltasFromClipERKNS0_18ClipMuscleConstantERKNS0_12ClipBindingsERKNS_14ValueArrayMaskERNS_10ValueArrayESB_SB_(i45, i17, HEAP32[i43 >> 2] | 0, i39, i40, i41);
 } else {
  i39 = 0;
  i40 = 0;
  i41 = 0;
 }
 if (!i6) {
  i18 = i24 << 24 >> 24 != 0;
  do if (i18) {
   __ZN7mecanim9animation17EvaluateHumanPoseERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfRKNS0_12MotionOutputERNS_5human9HumanPoseE(i45, i51, HEAP32[i48 >> 2] | 0, i47, i20);
   if (i49) {
    __ZN7mecanim5human9HumanPoseC2Ev(i32);
    i1 = i45 + 1720 | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    if (!i5) {
     i24 = i45 + 1712 | 0;
     i22 = HEAP32[i24 >> 2] | 0;
     __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKNS0_10ValueDeltaERNS_5human9HumanPoseE(i45, (i22 | 0) == 0 ? 0 : i22 + i24 | 0, i32);
    } else __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKfRNS_5human9HumanPoseE(i45, i5 + i1 | 0, i32);
    if (HEAP8[i45 + 1724 >> 0] | 0) __ZN7mecanim5human15HumanPoseMirrorERNS0_9HumanPoseERKS1_(i32, i32);
    f71 = Math_fround(HEAPF32[i20 >> 2]);
    i6 = i20 + 4 | 0;
    f67 = Math_fround(HEAPF32[i6 >> 2]);
    i11 = i20 + 8 | 0;
    f65 = Math_fround(HEAPF32[i11 >> 2]);
    f62 = Math_fround(HEAPF32[i47 + 96 >> 2]);
    f61 = Math_fround(HEAPF32[i47 + 100 >> 2]);
    f58 = Math_fround(HEAPF32[i47 + 104 >> 2]);
    f71 = Math_fround(f71 * f62);
    f67 = Math_fround(f67 * f61);
    f65 = Math_fround(f65 * f58);
    f64 = Math_fround(HEAPF32[i47 + 84 >> 2]);
    f70 = Math_fround(HEAPF32[i47 + 80 >> 2]);
    f66 = Math_fround(HEAPF32[i47 + 92 >> 2]);
    f68 = Math_fround(HEAPF32[i47 + 88 >> 2]);
    f72 = Math_fround(f64 * Math_fround(-2.0));
    f4 = Math_fround(f64 * Math_fround(2.0));
    f69 = Math_fround(f72 * f66);
    f63 = Math_fround(f68 * Math_fround(2.0));
    f57 = Math_fround(f68 * Math_fround(-2.0));
    f73 = Math_fround(f66 * f57);
    f3 = Math_fround(f70 * Math_fround(-2.0));
    f59 = Math_fround(f70 * Math_fround(2.0));
    f2 = Math_fround(f66 * f3);
    f60 = Math_fround(Math_fround(f71 + Math_fround(f71 * Math_fround(Math_fround(f64 * f72) - Math_fround(f68 * f63)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f59 * f68) - f69)) + Math_fround(f67 * Math_fround(f73 - Math_fround(f64 * f3)))));
    f59 = Math_fround(Math_fround(f67 + Math_fround(f71 * Math_fround(Math_fround(f70 * f4) - f73))) + Math_fround(Math_fround(f65 * Math_fround(f2 - Math_fround(f72 * f68))) + Math_fround(f67 * Math_fround(Math_fround(f68 * f57) - Math_fround(f70 * f59)))));
    f2 = Math_fround(Math_fround(f65 + Math_fround(f71 * Math_fround(f69 - Math_fround(f70 * f57)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f70 * f3) - Math_fround(f64 * f4))) + Math_fround(f67 * Math_fround(Math_fround(f64 * f63) - f2))));
    f63 = Math_fround(HEAPF32[i47 + 68 >> 2]);
    f67 = Math_fround(HEAPF32[i47 + 72 >> 2]);
    f60 = Math_fround(f63 + f60);
    f59 = Math_fround(f67 + f59);
    f2 = Math_fround(Math_fround(HEAPF32[i47 + 76 >> 2]) + f2);
    f67 = Math_fround(HEAPF32[i20 + 12 >> 2]);
    f63 = Math_fround(f64 * f67);
    i17 = i20 + 24 | 0;
    f4 = Math_fround(HEAPF32[i17 >> 2]);
    f3 = Math_fround(f66 * f4);
    i14 = i20 + 16 | 0;
    f65 = Math_fround(HEAPF32[i14 >> 2]);
    f57 = Math_fround(f68 * f65);
    i16 = i20 + 20 | 0;
    f69 = Math_fround(HEAPF32[i16 >> 2]);
    f63 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f66 * f69)) - Math_fround(f68 * f4)) - Math_fround(f70 * f65));
    f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f70 * f67)) - Math_fround(f68 * f69)) - Math_fround(f64 * f65));
    f57 = Math_fround(Math_fround(Math_fround(f57 - Math_fround(f64 * f69)) - Math_fround(f66 * f67)) - Math_fround(f70 * f4));
    f4 = Math_fround(Math_fround(Math_fround(Math_fround(f70 * f69) - Math_fround(f68 * f67)) - Math_fround(f66 * f65)) - Math_fround(f64 * f4));
    i15 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    i21 = i20 + 28 | 0;
    f4 = Math_fround(HEAPF32[i21 >> 2]);
    i22 = i20 + 32 | 0;
    f57 = Math_fround(HEAPF32[i22 >> 2]);
    i24 = i20 + 36 | 0;
    f4 = Math_fround(f62 * f4);
    f57 = Math_fround(f61 * f57);
    f58 = Math_fround(f58 * Math_fround(HEAPF32[i24 >> 2]));
    HEAPF32[i20 >> 2] = f60;
    HEAPF32[i6 >> 2] = f59;
    HEAPF32[i11 >> 2] = f2;
    HEAP32[i20 + 12 >> 2] = i12 ^ -2147483648;
    HEAP32[i14 >> 2] = i13;
    HEAP32[i16 >> 2] = i15 ^ -2147483648;
    HEAPF32[i17 >> 2] = f3;
    HEAPF32[i21 >> 2] = f4;
    HEAPF32[i22 >> 2] = f57;
    HEAPF32[i24 >> 2] = f58;
    __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_(i20, i20, i32);
    i24 = i20 + 68 | 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 20 >> 2] = 0;
    HEAP32[i20 + 92 >> 2] = 1065353216;
    HEAP32[i20 + 96 >> 2] = 1065353216;
    HEAP32[i20 + 100 >> 2] = 1065353216;
    HEAP32[i20 + 104 >> 2] = 1065353216;
    i24 = i20 + 132 | 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 20 >> 2] = 0;
    HEAP32[i20 + 156 >> 2] = 1065353216;
    HEAP32[i20 + 160 >> 2] = 1065353216;
    HEAP32[i20 + 164 >> 2] = 1065353216;
    HEAP32[i20 + 168 >> 2] = 1065353216;
    i24 = i20 + 196 | 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 20 >> 2] = 0;
    HEAP32[i20 + 220 >> 2] = 1065353216;
    HEAP32[i20 + 224 >> 2] = 1065353216;
    HEAP32[i20 + 228 >> 2] = 1065353216;
    HEAP32[i20 + 232 >> 2] = 1065353216;
    i24 = i20 + 260 | 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 20 >> 2] = 0;
    HEAP32[i20 + 284 >> 2] = 1065353216;
    HEAP32[i20 + 288 >> 2] = 1065353216;
    HEAP32[i20 + 292 >> 2] = 1065353216;
    HEAP32[i20 + 296 >> 2] = 1065353216;
    __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(i47);
   }
   i1 = HEAP32[i19 + 16 >> 2] | 0;
   if (i1 | 0) __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i1, HEAP32[i23 >> 2] | 0, 0);
  } else if ((HEAP32[i21 + 40 >> 2] | 0) != -1) {
   if (i49) {
    __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(i47);
    break;
   }
   i24 = (HEAP32[i25 >> 2] | 0) + 84 | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i1 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i1 | 0) == 0 ? 0 : i24 + i1 | 0, i55) | 0;
   i24 = (HEAP32[i25 >> 2] | 0) + 84 | 0;
   i5 = HEAP32[i24 >> 2] | 0;
   i5 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i5 | 0) == 0 ? 0 : i24 + i5 | 0, i55) | 0;
   if (i42) {
    __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i21, i22, i47 + 108 | 0, i39, i1, i5);
    __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i21, i22, i47 + 148 | 0, i40, i1, i5);
   }
   __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i21, i22, i47 + 68 | 0, i46, i1, i5);
   __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i1, i55);
   __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i5, i55);
  } while (0);
  if ((i26 | 0) == -1) i31 = 44; else {
   i24 = (HEAP32[i43 >> 2] | 0) + 28 | 0;
   if (!(HEAP8[i24 + (HEAP32[i24 >> 2] | 0) + i26 >> 0] | 0)) i31 = 44; else {
    i25 = i46 + 28 | 0;
    HEAP32[i47 + 284 >> 2] = HEAP32[(HEAP32[i25 >> 2] | 0) + i25 + (i26 << 2) >> 2];
   }
  }
  do if ((i31 | 0) == 44) {
   if (!i18) if ((HEAP32[(HEAP32[i25 >> 2] | 0) + 40 >> 2] | 0) == -1) {
    HEAPF32[i47 + 284 >> 2] = Math_fround(1.0);
    break;
   }
   HEAPF32[i47 + 284 >> 2] = Math_fround(HEAPU8[i45 + 1728 >> 0] | 0);
  } while (0);
  if (!(HEAP8[i27 + 18 >> 0] | 0)) {
   f73 = Math_fround(HEAPF32[i47 >> 2]);
   i31 = i47 + 4 | 0;
   f70 = Math_fround(f73 * Math_fround(HEAPF32[i31 >> 2]));
   i27 = i47 + 8 | 0;
   f72 = Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2]));
   i26 = i47 + 12 | 0;
   f71 = Math_fround(f73 * Math_fround(HEAPF32[i26 >> 2]));
   HEAPF32[i31 >> 2] = f70;
   HEAPF32[i27 >> 2] = f72;
   HEAPF32[i26 >> 2] = f71;
   i26 = i47 + 16 | 0;
   f71 = Math_fround(f73 * Math_fround(HEAPF32[i26 >> 2]));
   i27 = i47 + 20 | 0;
   f72 = Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2]));
   i31 = i47 + 24 | 0;
   f73 = Math_fround(f73 * Math_fround(HEAPF32[i31 >> 2]));
   HEAPF32[i26 >> 2] = f71;
   HEAPF32[i27 >> 2] = f72;
   HEAPF32[i31 >> 2] = f73;
  }
  i1 = HEAP32[i53 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) != -1) {
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   f69 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f70 = Math_fround(HEAPF32[i10 >> 2]);
   f71 = Math_fround(HEAPF32[i7 >> 2]);
   f72 = Math_fround(HEAPF32[i8 >> 2]);
   f72 = Math_fround(f72 + Math_fround(HEAPF32[i37 >> 2]));
   f73 = Math_fround(HEAPF32[i36 >> 2]);
   HEAPF32[i32 >> 2] = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f69, f70, f71, f72, (HEAP8[i9 >> 0] | 0) != 0, f73, i34, i33, Math_fround(HEAPF32[i51 >> 2]) < Math_fround(0.0)));
   i1 = HEAP32[i28 >> 2] | 0;
   __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i1 | 0) == 0 ? 0 : i1 + i29 | 0, i32, i30, i48);
   HEAP8[i38 >> 0] = 1;
   i1 = HEAP32[(HEAP32[i53 >> 2] | 0) + 8 >> 2] | 0;
   HEAP32[i35 >> 2] = i1;
   HEAP32[i51 >> 2] = i1;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   i1 = i50 + 4 | 0;
   i9 = i50 + 28 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i50 + 52 >> 2] = 1065353216;
   HEAP32[i50 + 56 >> 2] = 1065353216;
   HEAP32[i50 + 60 >> 2] = 1065353216;
   HEAP32[i50 + 64 >> 2] = 1065353216;
   i9 = i50 + 68 | 0;
   i11 = i50 + 96 | 0;
   i10 = i50 + 92 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i10 >> 2] = 1065353216;
   HEAP32[i11 >> 2] = 1065353216;
   i12 = i50 + 100 | 0;
   HEAP32[i12 >> 2] = 1065353216;
   i13 = i50 + 104 | 0;
   HEAP32[i13 >> 2] = 1065353216;
   i5 = i50 + 108 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   HEAP32[i50 + 132 >> 2] = 1065353216;
   HEAP32[i50 + 136 >> 2] = 1065353216;
   HEAP32[i50 + 140 >> 2] = 1065353216;
   HEAP32[i50 + 144 >> 2] = 1065353216;
   i5 = i50 + 148 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   HEAP32[i50 + 172 >> 2] = 1065353216;
   HEAP32[i50 + 176 >> 2] = 1065353216;
   HEAP32[i50 + 180 >> 2] = 1065353216;
   HEAP32[i50 + 184 >> 2] = 1065353216;
   i5 = i50 + 188 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   HEAP32[i50 + 212 >> 2] = 1065353216;
   HEAP32[i50 + 216 >> 2] = 1065353216;
   HEAP32[i50 + 220 >> 2] = 1065353216;
   HEAP32[i50 + 224 >> 2] = 1065353216;
   i5 = i50 + 228 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   HEAP32[i50 + 252 >> 2] = 1065353216;
   HEAP32[i50 + 256 >> 2] = 1065353216;
   HEAP32[i50 + 260 >> 2] = 1065353216;
   HEAP32[i50 + 264 >> 2] = 1065353216;
   i5 = i50 + 320 | 0;
   i6 = i50 + 316 | 0;
   i7 = i50 + 268 | 0;
   i8 = i7 + 48 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i8 | 0));
   HEAP32[i6 >> 2] = 1065353216;
   HEAP32[i5 >> 2] = 1065353216;
   HEAP32[i50 + 324 >> 2] = 1065353216;
   HEAP32[i50 + 328 >> 2] = 1065353216;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   __ZN7mecanim5human9HumanPoseC2Ev(i52);
   i17 = HEAP32[i48 >> 2] | 0;
   __ZN7mecanim9animation18EvaluateRootMotionERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfS8_RNS0_12MotionOutputEb(i45, i51, i17, i17, i50, i18);
   i17 = i47 + 292 | 0;
   i36 = HEAP32[i9 >> 2] | 0;
   i37 = HEAP32[i50 + 72 >> 2] | 0;
   i38 = HEAP32[i50 + 76 >> 2] | 0;
   HEAP32[i17 >> 2] = i36;
   i14 = i47 + 296 | 0;
   HEAP32[i14 >> 2] = i37;
   i15 = i47 + 300 | 0;
   HEAP32[i15 >> 2] = i38;
   i16 = i47 + 304 | 0;
   i8 = HEAP32[i50 + 84 >> 2] | 0;
   i9 = HEAP32[i50 + 88 >> 2] | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i50 + 80 >> 2];
   i7 = i47 + 308 | 0;
   HEAP32[i7 >> 2] = i8;
   i8 = i47 + 312 | 0;
   HEAP32[i8 >> 2] = i9;
   i9 = i47 + 316 | 0;
   HEAP32[i9 >> 2] = i10;
   i10 = i47 + 320 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i35 = HEAP32[i13 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   i5 = i47 + 324 | 0;
   HEAP32[i5 >> 2] = i6;
   i6 = i47 + 328 | 0;
   HEAP32[i6 >> 2] = i35;
   f2 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   do if (i18) if (((HEAP32[(HEAP32[i53 >> 2] | 0) + 4 >> 2] | 0) + -1 | 0) >>> 0 < 5) {
    __ZN7mecanim9animation17EvaluateHumanPoseERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfRKNS0_12MotionOutputERNS_5human9HumanPoseE(i45, i51, HEAP32[i48 >> 2] | 0, i50, i52);
    i1 = HEAP32[(HEAP32[i53 >> 2] | 0) + 4 >> 2] | 0;
    if ((i1 | 0) > 1) {
     i45 = i1 + -2 | 0;
     f59 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) >> 2]);
     f63 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 4 >> 2]);
     f65 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 8 >> 2]);
     f68 = Math_fround(HEAPF32[i47 + 320 >> 2]);
     f69 = Math_fround(HEAPF32[i5 >> 2]);
     f73 = Math_fround(HEAPF32[i6 >> 2]);
     f59 = Math_fround(f59 * f68);
     f63 = Math_fround(f63 * f69);
     f65 = Math_fround(f65 * f73);
     f66 = Math_fround(HEAPF32[i7 >> 2]);
     f60 = Math_fround(HEAPF32[i47 + 304 >> 2]);
     f64 = Math_fround(HEAPF32[i9 >> 2]);
     f62 = Math_fround(HEAPF32[i8 >> 2]);
     f58 = Math_fround(f66 * Math_fround(-2.0));
     f71 = Math_fround(f66 * Math_fround(2.0));
     f61 = Math_fround(f58 * f64);
     f67 = Math_fround(f62 * Math_fround(2.0));
     f72 = Math_fround(f62 * Math_fround(-2.0));
     f57 = Math_fround(f64 * f72);
     f70 = Math_fround(f60 * Math_fround(-2.0));
     f4 = Math_fround(f60 * Math_fround(2.0));
     f3 = Math_fround(f64 * f70);
     f2 = Math_fround(Math_fround(f59 + Math_fround(f59 * Math_fround(Math_fround(f66 * f58) - Math_fround(f62 * f67)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f4 * f62) - f61)) + Math_fround(f63 * Math_fround(f57 - Math_fround(f66 * f70)))));
     f4 = Math_fround(Math_fround(f63 + Math_fround(f59 * Math_fround(Math_fround(f60 * f71) - f57))) + Math_fround(Math_fround(f65 * Math_fround(f3 - Math_fround(f58 * f62))) + Math_fround(f63 * Math_fround(Math_fround(f62 * f72) - Math_fround(f60 * f4)))));
     f3 = Math_fround(Math_fround(f65 + Math_fround(f59 * Math_fround(f61 - Math_fround(f60 * f72)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f60 * f70) - Math_fround(f66 * f71))) + Math_fround(f63 * Math_fround(Math_fround(f66 * f67) - f3))));
     f67 = Math_fround(HEAPF32[i17 >> 2]);
     f63 = Math_fround(HEAPF32[i14 >> 2]);
     f2 = Math_fround(f67 + f2);
     f4 = Math_fround(f63 + f4);
     f3 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f3);
     f63 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 12 >> 2]);
     f67 = Math_fround(f66 * f63);
     f71 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 24 >> 2]);
     f70 = Math_fround(f64 * f71);
     f65 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 16 >> 2]);
     f72 = Math_fround(f62 * f65);
     f61 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 20 >> 2]);
     f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f64 * f61)) - Math_fround(f62 * f71)) - Math_fround(f60 * f65));
     f70 = Math_fround(Math_fround(Math_fround(f70 - Math_fround(f60 * f63)) - Math_fround(f62 * f61)) - Math_fround(f66 * f65));
     f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f66 * f61)) - Math_fround(f64 * f63)) - Math_fround(f60 * f71));
     f71 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f61) - Math_fround(f62 * f63)) - Math_fround(f64 * f65)) - Math_fround(f66 * f71));
     i53 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i50 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i51 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
     f71 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 28 >> 2]);
     f72 = Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 32 >> 2]);
     f71 = Math_fround(f68 * f71);
     f72 = Math_fround(f69 * f72);
     f73 = Math_fround(f73 * Math_fround(HEAPF32[i52 + 68 + (i45 << 6) + 36 >> 2]));
     HEAPF32[i17 >> 2] = f2;
     HEAPF32[i14 >> 2] = f4;
     HEAPF32[i15 >> 2] = f3;
     HEAP32[i16 >> 2] = i50 ^ -2147483648;
     HEAP32[i7 >> 2] = i51;
     HEAP32[i8 >> 2] = i53 ^ -2147483648;
     HEAPF32[i9 >> 2] = f70;
     HEAPF32[i10 >> 2] = f71;
     HEAPF32[i5 >> 2] = f72;
     HEAPF32[i6 >> 2] = f73;
     break;
    } else {
     f59 = Math_fround(HEAPF32[i52 >> 2]);
     f63 = Math_fround(HEAPF32[i52 + 4 >> 2]);
     f65 = Math_fround(HEAPF32[i52 + 8 >> 2]);
     f68 = Math_fround(HEAPF32[i47 + 320 >> 2]);
     f69 = Math_fround(HEAPF32[i5 >> 2]);
     f73 = Math_fround(HEAPF32[i6 >> 2]);
     f59 = Math_fround(f59 * f68);
     f63 = Math_fround(f63 * f69);
     f65 = Math_fround(f65 * f73);
     f66 = Math_fround(HEAPF32[i7 >> 2]);
     f60 = Math_fround(HEAPF32[i47 + 304 >> 2]);
     f64 = Math_fround(HEAPF32[i9 >> 2]);
     f62 = Math_fround(HEAPF32[i8 >> 2]);
     f58 = Math_fround(f66 * Math_fround(-2.0));
     f71 = Math_fround(f66 * Math_fround(2.0));
     f61 = Math_fround(f58 * f64);
     f67 = Math_fround(f62 * Math_fround(2.0));
     f72 = Math_fround(f62 * Math_fround(-2.0));
     f57 = Math_fround(f64 * f72);
     f70 = Math_fround(f60 * Math_fround(-2.0));
     f4 = Math_fround(f60 * Math_fround(2.0));
     f3 = Math_fround(f64 * f70);
     f2 = Math_fround(Math_fround(f59 + Math_fround(f59 * Math_fround(Math_fround(f66 * f58) - Math_fround(f62 * f67)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f4 * f62) - f61)) + Math_fround(f63 * Math_fround(f57 - Math_fround(f66 * f70)))));
     f4 = Math_fround(Math_fround(f63 + Math_fround(f59 * Math_fround(Math_fround(f60 * f71) - f57))) + Math_fround(Math_fround(f65 * Math_fround(f3 - Math_fround(f58 * f62))) + Math_fround(f63 * Math_fround(Math_fround(f62 * f72) - Math_fround(f60 * f4)))));
     f3 = Math_fround(Math_fround(f65 + Math_fround(f59 * Math_fround(f61 - Math_fround(f60 * f72)))) + Math_fround(Math_fround(f65 * Math_fround(Math_fround(f60 * f70) - Math_fround(f66 * f71))) + Math_fround(f63 * Math_fround(Math_fround(f66 * f67) - f3))));
     f67 = Math_fround(HEAPF32[i17 >> 2]);
     f63 = Math_fround(HEAPF32[i14 >> 2]);
     f2 = Math_fround(f67 + f2);
     f4 = Math_fround(f63 + f4);
     f3 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f3);
     f63 = Math_fround(HEAPF32[i52 + 12 >> 2]);
     f67 = Math_fround(f66 * f63);
     f71 = Math_fround(HEAPF32[i52 + 24 >> 2]);
     f70 = Math_fround(f64 * f71);
     f65 = Math_fround(HEAPF32[i52 + 16 >> 2]);
     f72 = Math_fround(f62 * f65);
     f61 = Math_fround(HEAPF32[i52 + 20 >> 2]);
     f67 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f64 * f61)) - Math_fround(f62 * f71)) - Math_fround(f60 * f65));
     f70 = Math_fround(Math_fround(Math_fround(f70 - Math_fround(f60 * f63)) - Math_fround(f62 * f61)) - Math_fround(f66 * f65));
     f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f66 * f61)) - Math_fround(f64 * f63)) - Math_fround(f60 * f71));
     f71 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f61) - Math_fround(f62 * f63)) - Math_fround(f64 * f65)) - Math_fround(f66 * f71));
     i53 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i50 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i51 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
     f71 = Math_fround(HEAPF32[i52 + 28 >> 2]);
     f72 = Math_fround(HEAPF32[i52 + 32 >> 2]);
     f71 = Math_fround(f68 * f71);
     f72 = Math_fround(f69 * f72);
     f73 = Math_fround(f73 * Math_fround(HEAPF32[i52 + 36 >> 2]));
     HEAPF32[i17 >> 2] = f2;
     HEAPF32[i14 >> 2] = f4;
     HEAPF32[i15 >> 2] = f3;
     HEAP32[i16 >> 2] = i50 ^ -2147483648;
     HEAP32[i7 >> 2] = i51;
     HEAP32[i8 >> 2] = i53 ^ -2147483648;
     HEAPF32[i9 >> 2] = f70;
     HEAPF32[i10 >> 2] = f71;
     HEAPF32[i5 >> 2] = f72;
     HEAPF32[i6 >> 2] = f73;
     break;
    }
   } while (0);
   f61 = Math_fround(HEAPF32[i47 + 92 >> 2]);
   f71 = Math_fround(HEAPF32[i47 + 68 >> 2]);
   f73 = Math_fround(HEAPF32[i47 + 72 >> 2]);
   f71 = Math_fround(f2 - f71);
   f73 = Math_fround(f4 - f73);
   f69 = Math_fround(f3 - Math_fround(HEAPF32[i47 + 76 >> 2]));
   f63 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + 84 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + 80 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + 88 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f68 = Math_fround(f63 * Math_fround(-2.0));
   f65 = Math_fround(f63 * Math_fround(2.0));
   f62 = Math_fround(f61 * f68);
   f64 = Math_fround(f59 * Math_fround(2.0));
   f70 = Math_fround(f59 * Math_fround(-2.0));
   f58 = Math_fround(f61 * f70);
   f66 = Math_fround(f57 * Math_fround(-2.0));
   f72 = Math_fround(f57 * Math_fround(2.0));
   f60 = Math_fround(f61 * f66);
   f67 = Math_fround(Math_fround(f71 + Math_fround(Math_fround(Math_fround(f63 * f68) - Math_fround(f59 * f64)) * f71)) + Math_fround(Math_fround(Math_fround(f58 - Math_fround(f63 * f66)) * f73) + Math_fround(Math_fround(Math_fround(f72 * f59) - f62) * f69)));
   f68 = Math_fround(Math_fround(f73 + Math_fround(Math_fround(Math_fround(f57 * f65) - f58) * f71)) + Math_fround(Math_fround(Math_fround(Math_fround(f59 * f70) - Math_fround(f57 * f72)) * f73) + Math_fround(Math_fround(f60 - Math_fround(f59 * f68)) * f69)));
   f69 = Math_fround(Math_fround(Math_fround(Math_fround(f62 - Math_fround(f57 * f70)) * f71) + f69) + Math_fround(Math_fround(Math_fround(Math_fround(f63 * f64) - f60) * f73) + Math_fround(Math_fround(Math_fround(f57 * f66) - Math_fround(f63 * f65)) * f69)));
   f65 = Math_fround(HEAPF32[i47 + 96 >> 2]);
   f66 = Math_fround(HEAPF32[i47 + 100 >> 2]);
   f73 = Math_fround(HEAPF32[i47 + 104 >> 2]);
   i52 = Math_fround(Math_abs(Math_fround(f65))) < Math_fround(9.99999971e-10);
   i51 = Math_fround(Math_abs(Math_fround(f66))) < Math_fround(9.99999971e-10);
   i53 = Math_fround(Math_abs(Math_fround(f73))) < Math_fround(9.99999971e-10);
   f65 = Math_fround(Math_fround(1.0) / f65);
   f65 = i52 ? Math_fround(1.0) : f65;
   f66 = Math_fround(Math_fround(1.0) / f66);
   f66 = i51 ? Math_fround(1.0) : f66;
   f73 = Math_fround(Math_fround(1.0) / f73);
   f73 = i53 ? Math_fround(1.0) : f73;
   f67 = Math_fround(f67 * f65);
   f68 = Math_fround(f68 * f66);
   f69 = Math_fround(f69 * f73);
   f60 = Math_fround(HEAPF32[i47 + 304 >> 2]);
   f64 = Math_fround(f63 * f60);
   f71 = Math_fround(HEAPF32[i9 >> 2]);
   f70 = Math_fround(f61 * f71);
   f62 = Math_fround(HEAPF32[i7 >> 2]);
   f72 = Math_fround(f59 * f62);
   f58 = Math_fround(HEAPF32[i8 >> 2]);
   f64 = Math_fround(Math_fround(Math_fround(f64 - Math_fround(f61 * f58)) - Math_fround(f59 * f71)) - Math_fround(f57 * f62));
   f70 = Math_fround(Math_fround(Math_fround(f70 - Math_fround(f57 * f60)) - Math_fround(f59 * f58)) - Math_fround(f63 * f62));
   f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f63 * f58)) - Math_fround(f61 * f60)) - Math_fround(f57 * f71));
   f71 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f58) - Math_fround(f59 * f60)) - Math_fround(f61 * f62)) - Math_fround(f63 * f71));
   i53 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
   i51 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
   i52 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f71 = Math_fround(HEAPF32[i47 + 320 >> 2]);
   f72 = Math_fround(HEAPF32[i5 >> 2]);
   f71 = Math_fround(f65 * f71);
   f72 = Math_fround(f66 * f72);
   f73 = Math_fround(f73 * Math_fround(HEAPF32[i6 >> 2]));
   HEAPF32[i17 >> 2] = f67;
   HEAPF32[i14 >> 2] = f68;
   HEAPF32[i15 >> 2] = f69;
   HEAP32[i16 >> 2] = i51 ^ -2147483648;
   HEAP32[i7 >> 2] = i52;
   HEAP32[i8 >> 2] = i53 ^ -2147483648;
   HEAPF32[i9 >> 2] = f70;
   HEAPF32[i10 >> 2] = f71;
   HEAPF32[i5 >> 2] = f72;
   HEAPF32[i6 >> 2] = f73;
  }
 }
 if (i49) __ZN7mecanim13ValueArraySubERKNS_10ValueArrayERS0_PKNS_14ValueArrayMaskE(i41, i46, HEAP32[i43 >> 2] | 0);
 if (i42) {
  f73 = Math_fround(HEAPF32[i54 >> 2]);
  __ZN7mecanim14ValueArrayLoopERKNS_10ValueArrayES2_RS0_fRKNS_14ValueArrayMaskE(i39, i40, i46, f73, HEAP32[i43 >> 2] | 0);
 }
 if (i39 | 0) __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i39, i55);
 if (i40 | 0) __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i40, i55);
 if (i41 | 0) __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i41, i55);
 __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE(i44, i55);
 __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE(i48, i55);
 STACKTOP = i56;
 return;
}

function __ZN14SerializedFile12ReadMetadataILb1EEEbijPKhjj(i55, i54, i47, i53, i1, i48) {
 i55 = i55 | 0;
 i54 = i54 | 0;
 i47 = i47 | 0;
 i53 = i53 | 0;
 i1 = i1 | 0;
 i48 = i48 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i69 + 88 | 0;
 i49 = i69 + 80 | 0;
 i7 = i69 + 72 | 0;
 i67 = i69 + 16 | 0;
 i63 = i69;
 i62 = i69 + 144 | 0;
 i68 = i69 + 128 | 0;
 i65 = i69 + 116 | 0;
 i64 = i69 + 96 | 0;
 i46 = i69 + 160 | 0;
 i50 = i69 + 148 | 0;
 i66 = __Z20push_allocation_rootPvP13BaseAllocatorb(i55, 0, 0) | 0;
 HEAP32[i62 >> 2] = i53;
 i61 = i53 + i1 | 0;
 HEAP32[i68 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i68 >> 2] = 0;
 HEAP32[i68 + 4 >> 2] = 0;
 HEAP32[i68 + 8 >> 2] = 0;
 i52 = i53;
 do if ((i54 | 0) > 6) {
  L3 : do if ((i1 | 0) > 0) {
   i1 = i53;
   while (1) {
    if (!(HEAP8[i1 >> 0] | 0)) {
     i5 = i1;
     break L3;
    }
    i1 = i1 + 1 | 0;
    HEAP32[i62 >> 2] = i1;
    if (i1 >>> 0 >= i61 >>> 0) {
     i5 = i1;
     break;
    }
   }
  } else i5 = i53; while (0);
  i6 = i5 - i52 | 0;
  i1 = i68 + 11 | 0;
  if (i6 >>> 0 > 10) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i68, 10, i6 + -10 | 0, 0, 0, 0, 0);
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP32[i68 >> 2] | 0;
  } else {
   i2 = 0;
   i3 = 0;
  }
  i2 = i2 << 24 >> 24 < 0 ? i3 : i68;
  if ((i5 | 0) != (i53 | 0)) {
   i3 = i53;
   i4 = i2;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 1 | 0;
   }
   i2 = i2 + i6 | 0;
  }
  HEAP8[i2 >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) HEAP32[i68 + 4 >> 2] = i6; else HEAP8[i1 >> 0] = i6;
  i3 = HEAP32[i62 >> 2] | 0;
  i2 = i3 + 1 | 0;
  HEAP32[i62 >> 2] = i2;
  if ((i54 | 0) > 7) {
   i59 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
   i2 = _llvm_bswap_i32(i59 | 0) | 0;
   i4 = i3 + 5 | 0;
   HEAP32[i62 >> 2] = i4;
   i58 = i55 + 56 | 0;
   HEAP32[i58 >> 2] = i2;
   HEAP32[i58 + 4 >> 2] = 0;
   if ((i59 | 0) != 335544320) {
    HEAP32[i7 >> 2] = i2;
    __Z6FormatPKcz(i67, gb + 588354 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1049, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
    i2 = 0;
    break;
   }
   i1 = i55 + 52 | 0;
   HEAP8[i1 >> 0] = 1;
   if ((i54 | 0) > 12) {
    HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
    i60 = i3 + 6 | 0;
    HEAP32[i62 >> 2] = i60;
    i56 = i62;
    i45 = i1;
    i1 = i60;
    i60 = 19;
   } else {
    i56 = i62;
    i45 = i1;
    i1 = i4;
    i60 = 19;
   }
  } else {
   i1 = i2;
   i60 = 16;
  }
 } else {
  i1 = i53;
  i60 = 16;
 } while (0);
 if ((i60 | 0) == 16) {
  i45 = i55 + 52 | 0;
  HEAP8[i45 >> 0] = 1;
  i56 = i62;
  i60 = 19;
 }
 if ((i60 | 0) == 19) {
  i8 = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
  HEAP32[i56 >> 2] = i1 + 4;
  HEAP32[i67 >> 2] = -1;
  HEAP32[i67 + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(-1) | 0;
  i1 = i67 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP8[i67 + 41 >> 0] = 1;
  HEAP16[i67 + 42 >> 1] = -1;
  i1 = i67 + 44 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i67 + 48 >> 2] = -1;
  __ZN13dynamic_arrayIN14SerializedFile4TypeELj8EE18resize_initializedEjRKS1_12ResizePolicy(i55, i8, i67, 1);
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i2 = i1 + 40 | 0;
   if ((HEAP32[i1 + 56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 44 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
    i59 = i1 + 20 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i59 >> 2] | 0, i1 + 24 | 0);
    HEAP32[i59 >> 2] = 0;
   }
   if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
    HEAP32[i1 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63720 | 0);
  i43 = i65 + 4 | 0;
  HEAP32[i43 >> 2] = 0;
  i44 = i65 + 8 | 0;
  HEAP32[i44 >> 2] = 0;
  i59 = i65 + 4 | 0;
  HEAP32[i65 >> 2] = i59;
  i58 = gb + 64016 | 0;
  i57 = HEAP32[i58 + 4 >> 2] | 0;
  i42 = i63;
  HEAP32[i42 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i42 + 4 >> 2] = i57;
  HEAP32[i64 >> 2] = 0;
  i42 = i64 + 12 | 0;
  HEAP32[i42 >> 2] = 0;
  i57 = i64 + 16 | 0;
  HEAP32[i57 >> 2] = 0;
  i58 = i64 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i67, i63);
  i1 = i67;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i58;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = (i54 | 0) > 16 & 1;
  i3 = HEAP32[i42 >> 2] | 0;
  HEAP32[i42 >> 2] = i8;
  i1 = HEAP32[i57 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i57 >> 2] = i8;
   HEAP32[i64 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i64 >> 2] | 0, i8, 1, i58, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, i58, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i41 | 0, HEAP32[i64 >> 2] | 0, HEAP32[i42 >> 2] | 0) | 0;
   HEAP32[i57 >> 2] = i8;
   HEAP32[i64 >> 2] = i41;
   break;
  } while (0);
  if (i8 >>> 0 > i3 >>> 0) {
   i1 = i8 - i3 | 0;
   if (i1 | 0) _memset((HEAP32[i64 >> 2] | 0) + i3 | 0, i2 | 0, i1 | 0) | 0;
  }
  L49 : do if ((i8 | 0) > 0) {
   i7 = i59;
   L51 : do if ((i54 | 0) < 16) {
    i6 = 0;
    while (1) {
     HEAP32[i63 >> 2] = 0;
     if (!(__ZN14SerializedFile4Type8ReadTypeILb1EEEbibRPKhS3_Pi((HEAP32[i55 >> 2] | 0) + (i6 * 56 | 0) | 0, i54, (HEAP8[i45 >> 0] | 0) != 0, i62, i61, i63) | 0)) break L51;
     i1 = HEAP32[i59 >> 2] | 0;
     do if (!i1) {
      HEAP32[i67 >> 2] = i59;
      i4 = i7;
      i3 = i59;
      i2 = HEAP32[i63 >> 2] | 0;
      i60 = 47;
     } else {
      i5 = HEAP32[i63 >> 2] | 0;
      while (1) {
       i2 = HEAP32[i1 + 16 >> 2] | 0;
       if ((i5 | 0) < (i2 | 0)) {
        i2 = HEAP32[i1 >> 2] | 0;
        if (!i2) {
         i60 = 45;
         break;
        } else i1 = i2;
       } else {
        if ((i2 | 0) >= (i5 | 0)) {
         i60 = 40;
         break;
        }
        i3 = i1 + 4 | 0;
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i60 = 42;
         break;
        } else i1 = i2;
       }
      }
      if ((i60 | 0) == 40) {
       i60 = 0;
       HEAP32[i67 >> 2] = i1;
       if (!i1) {
        i4 = i1;
        i3 = i67;
        i2 = i5;
        i60 = 47;
        break;
       } else break;
      } else if ((i60 | 0) == 42) {
       HEAP32[i67 >> 2] = i1;
       i4 = i1;
       i2 = i5;
       i60 = 47;
       break;
      } else if ((i60 | 0) == 45) {
       HEAP32[i67 >> 2] = i1;
       i4 = i1;
       i3 = i1;
       i2 = i5;
       i60 = 47;
       break;
      }
     } while (0);
     if ((i60 | 0) == 47) {
      i60 = 0;
      i1 = __Znwj(24) | 0;
      HEAP32[i1 + 16 >> 2] = i2;
      HEAP32[i1 + 20 >> 2] = 0;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i4;
      HEAP32[i3 >> 2] = i1;
      i2 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
      if (!i2) i2 = i1; else {
       HEAP32[i65 >> 2] = i2;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i43 >> 2] | 0, i2);
      HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
     }
     HEAP32[i1 + 20 >> 2] = i6;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i8 | 0)) {
      i60 = 54;
      break L49;
     }
    }
   } else {
    i1 = 0;
    while (1) {
     HEAP32[i63 >> 2] = 0;
     if (!(__ZN14SerializedFile4Type8ReadTypeILb1EEEbibRPKhS3_Pi((HEAP32[i55 >> 2] | 0) + (i1 * 56 | 0) | 0, i54, (HEAP8[i45 >> 0] | 0) != 0, i62, i61, i63) | 0)) break L51;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i8 | 0)) {
      i60 = 54;
      break L49;
     }
    }
   } while (0);
   i2 = 0;
  } else i60 = 54; while (0);
  L79 : do if ((i60 | 0) == 54) {
   i1 = HEAP32[i56 >> 2] | 0;
   if ((i54 + -7 | 0) >>> 0 < 7) {
    i1 = i1 + 4 | 0;
    HEAP32[i56 >> 2] = i1;
   }
   i2 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   i41 = _llvm_bswap_i32(i2 | 0) | 0;
   HEAP32[i56 >> 2] = i1 + 4;
   i39 = i55 + 32 | 0;
   i40 = i55 + 40 | 0;
   i4 = HEAP32[i39 >> 2] | 0;
   if ((((HEAP32[i40 >> 2] | 0) - i4 | 0) / 24 | 0) >>> 0 < i41 >>> 0) {
    i5 = i55 + 36 | 0;
    i6 = (HEAP32[i5 >> 2] | 0) - i4 | 0;
    if (!i2) i2 = 0; else i2 = __Znwj(i41 * 24 | 0) | 0;
    i1 = i2 + (((i6 | 0) / 24 | 0) * 24 | 0) | 0;
    i3 = i1 + (((i6 | 0) / -24 | 0) * 24 | 0) | 0;
    if ((i6 | 0) > 0) _memcpy(i3 | 0, i4 | 0, i6 | 0) | 0;
    HEAP32[i39 >> 2] = i3;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i40 >> 2] = i2 + (i41 * 24 | 0);
    if (i4 | 0) __ZdlPv(i4);
   }
   L94 : do if ((i41 | 0) > 0) {
    i22 = (i54 | 0) > 13;
    i23 = 3 - i52 | 0;
    i24 = (i54 | 0) < 16;
    i25 = (i54 | 0) < 11;
    i26 = (i54 | 0) < 17;
    i27 = (i54 + -11 | 0) >>> 0 < 6;
    i28 = (i54 + -15 | 0) >>> 0 < 2;
    i29 = i59;
    i30 = i67 + 8 | 0;
    i31 = i63 + 4 | 0;
    i32 = i55 + 20 | 0;
    i33 = i55 + 128 | 0;
    i34 = i55 + 44 | 0;
    i35 = i55 + 72 | 0;
    i36 = i55 + 84 | 0;
    i37 = i55 + 88 | 0;
    i38 = i55 + 76 | 0;
    i19 = i67 + 8 | 0;
    i20 = i67 + 12 | 0;
    i21 = i67 + 16 | 0;
    i1 = i55 + 36 | 0;
    i18 = 0;
    L96 : while (1) {
     if (i22) {
      i2 = i53 + (i23 + (HEAP32[i62 >> 2] | 0) & -4) | 0;
      i16 = i2;
      i17 = i16;
      i16 = i16 + 4 | 0;
      i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
      i17 = _llvm_bswap_i32(HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24 | 0) | 0;
      i16 = _llvm_bswap_i32(i16 | 0) | 0;
      i2 = i2 + 8 | 0;
      HEAP32[i62 >> 2] = i2;
     } else {
      i2 = HEAP32[i56 >> 2] | 0;
      i17 = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
      i2 = i2 + 4 | 0;
      HEAP32[i56 >> 2] = i2;
      i16 = i17;
      i17 = ((i17 | 0) < 0) << 31 >> 31;
     }
     i14 = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
     i15 = i2 + 4 | 0;
     i15 = _llvm_bswap_i32(HEAPU8[i15 >> 0] | HEAPU8[i15 + 1 >> 0] << 8 | HEAPU8[i15 + 2 >> 0] << 16 | HEAPU8[i15 + 3 >> 0] << 24 | 0) | 0;
     i3 = i2 + 8 | 0;
     i3 = _llvm_bswap_i32(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24 | 0) | 0;
     i5 = i2 + 12 | 0;
     HEAP32[i56 >> 2] = i5;
     if (i24) {
      i4 = _llvm_bswap_i16(HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | 0) | 0;
      i5 = i5 + 2 | 0;
      HEAP32[i62 >> 2] = i5;
      if (i25) {
       i2 = i2 + 16 | 0;
       HEAP32[i62 >> 2] = i2;
       i6 = i2;
       i9 = 1;
      } else {
       i6 = i5;
       i2 = i5;
       i9 = 0;
      }
     } else {
      i4 = 0;
      i6 = i5;
      i2 = i5;
      i9 = 0;
     }
     if (i27) {
      i8 = _llvm_bswap_i16(HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | 0) | 0;
      i2 = i6 + 2 | 0;
      HEAP32[i62 >> 2] = i2;
     } else i8 = -1;
     if (i28) {
      i13 = HEAP8[i2 >> 0] | 0;
      HEAP32[i62 >> 2] = i2 + 1;
     } else i13 = 0;
     do if (i24) {
      i2 = HEAP32[i59 >> 2] | 0;
      do if (!i2) {
       HEAP32[i67 >> 2] = i59;
       i7 = i29;
       i5 = i59;
       i60 = 87;
      } else {
       while (1) {
        i5 = HEAP32[i2 + 16 >> 2] | 0;
        if ((i3 | 0) < (i5 | 0)) {
         i5 = HEAP32[i2 >> 2] | 0;
         if (!i5) {
          i60 = 80;
          break;
         } else i2 = i5;
        } else {
         if ((i5 | 0) >= (i3 | 0)) {
          i60 = 86;
          break;
         }
         i6 = i2 + 4 | 0;
         i5 = HEAP32[i6 >> 2] | 0;
         if (!i5) {
          i60 = 84;
          break;
         } else i2 = i5;
        }
       }
       if ((i60 | 0) == 80) {
        HEAP32[i67 >> 2] = i2;
        i7 = i2;
        i5 = i2;
        i60 = 87;
        break;
       } else if ((i60 | 0) == 84) {
        HEAP32[i67 >> 2] = i2;
        i7 = i2;
        i5 = i6;
        i60 = 87;
        break;
       } else if ((i60 | 0) == 86) {
        i60 = 0;
        HEAP32[i67 >> 2] = i2;
        if (!i2) {
         i7 = i2;
         i5 = i67;
         i60 = 87;
         break;
        } else break;
       }
      } while (0);
      if ((i60 | 0) == 87) {
       i60 = 0;
       i2 = __Znwj(24) | 0;
       HEAP32[i2 + 16 >> 2] = i3;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i7;
       HEAP32[i5 >> 2] = i2;
       i3 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
       if (!i3) i3 = i2; else {
        HEAP32[i65 >> 2] = i3;
        i3 = HEAP32[i5 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i43 >> 2] | 0, i3);
       HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
      }
      i3 = HEAP32[i2 + 20 >> 2] | 0;
      i2 = HEAP32[i55 >> 2] | 0;
      i5 = i2 + (i3 * 56 | 0) | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i6 | 0) == -1) {
       HEAP8[i2 + (i3 * 56 | 0) + 41 >> 0] = 0;
       i12 = i4 << 16 >> 16;
       HEAP32[i5 >> 2] = i12;
       HEAP32[i2 + (i3 * 56 | 0) + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i12) | 0;
       break;
      }
      i2 = i4 << 16 >> 16;
      if ((i6 | 0) == (i2 | 0)) break;
      i3 = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i55, i2, i13 << 24 >> 24 != 0, i8, i3) | 0;
      HEAP8[(HEAP32[i55 >> 2] | 0) + (i3 * 56 | 0) + 41 >> 0] = 0;
     } while (0);
     do if (i26) {
      i11 = HEAP32[i55 >> 2] | 0;
      i12 = i11 + (i3 * 56 | 0) | 0;
      do if (i9) {
       if ((HEAP32[i12 >> 2] | 0) != 114) {
        i2 = i8;
        break;
       }
       i2 = HEAP32[i11 + (i3 * 56 | 0) + 44 >> 2] | 0;
       if (!i2) {
        i60 = 98;
        break L96;
       }
       i60 = i30;
       HEAP32[i60 >> 2] = 0;
       HEAP32[i60 + 4 >> 2] = 0;
       HEAP32[i67 >> 2] = 0;
       HEAP32[i63 >> 2] = i2;
       HEAP32[i31 >> 2] = 0;
       if (!(__ZL26ExtractScriptTypeReferenceRK16TypeTreeIteratorjR15CacheReaderBasebR31LocalSerializedObjectIdentifier(i63, i14 + i47 + (HEAP32[i32 >> 2] | 0) | 0, HEAP32[i33 >> 2] | 0, (HEAP8[i34 >> 0] | 0) != 0, i67) | 0)) {
        i60 = 114;
        break L96;
       }
       i2 = HEAP32[i35 >> 2] | 0;
       i10 = HEAP32[i36 >> 2] | 0;
       i8 = i2 + (i10 << 4) | 0;
       i9 = i2;
       L145 : do if (!i10) {
        i4 = i2;
        i60 = 105;
       } else {
        i6 = i30;
        i5 = HEAP32[i6 >> 2] | 0;
        i6 = HEAP32[i6 + 4 >> 2] | 0;
        i7 = HEAP32[i67 >> 2] | 0;
        i4 = i2;
        while (1) {
         i60 = i4 + 8 | 0;
         if ((HEAP32[i60 >> 2] | 0) == (i5 | 0) ? (HEAP32[i60 + 4 >> 2] | 0) == (i6 | 0) : 0) if ((HEAP32[i4 >> 2] | 0) == (i7 | 0)) {
          i60 = 105;
          break L145;
         }
         i4 = i4 + 16 | 0;
         if ((i4 | 0) == (i8 | 0)) {
          i60 = 107;
          break;
         }
        }
       } while (0);
       do if ((i60 | 0) == 105) {
        i60 = 0;
        if ((i4 | 0) == (i8 | 0)) {
         i60 = 107;
         break;
        }
        i2 = i4 - i9 >> 4;
       } while (0);
       if ((i60 | 0) == 107) {
        i60 = 0;
        i7 = i10 + 1 | 0;
        i5 = HEAP32[i37 >> 2] | 0;
        i6 = i5 & 2147483647;
        do if (i7 >>> 0 > i6 >>> 0) {
         i4 = i5 << 1;
         i4 = (i4 | 0) == 0 ? 1 : i4;
         if (i6 >>> 0 >= i4 >>> 0) break;
         if ((i5 | 0) > -1) {
          HEAP32[i37 >> 2] = i4;
          i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i4 << 4, 8, i38, 0, gb + 1047584 | 0, 464) | 0;
          HEAP32[i35 >> 2] = i2;
          break;
         } else {
          i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 8, i38, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i2 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i36 >> 2] << 4 | 0) | 0;
          HEAP32[i37 >> 2] = i4;
          HEAP32[i35 >> 2] = i2;
          break;
         }
        } while (0);
        HEAP32[i36 >> 2] = i7;
        i2 = i2 + (i10 << 4) | 0;
        HEAP32[i2 >> 2] = HEAP32[i67 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
        HEAP32[i2 + 12 >> 2] = HEAP32[i67 + 12 >> 2];
        i2 = (HEAP32[i36 >> 2] | 0) + -1 | 0;
       }
       i2 = i2 & 65535;
      } else i2 = i8; while (0);
      do if (i3 >>> 0 < (HEAP32[i42 >> 2] | 0) >>> 0) {
       i4 = (HEAP32[i64 >> 2] | 0) + i3 | 0;
       if (HEAP8[i4 >> 0] | 0) break;
       HEAP8[i11 + (i3 * 56 | 0) + 40 >> 0] = i13;
       HEAP16[i11 + (i3 * 56 | 0) + 42 >> 1] = i2;
       HEAP8[i4 >> 0] = 1;
      } while (0);
      if ((HEAP8[i11 + (i3 * 56 | 0) + 40 >> 0] | 0) != i13 << 24 >> 24) {
       i60 = 119;
       break L96;
      }
      if ((HEAP16[i11 + (i3 * 56 | 0) + 42 >> 1] | 0) == i2 << 16 >> 16) break;
      i3 = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i55, HEAP32[i12 >> 2] | 0, i13 << 24 >> 24 != 0, i2, i3) | 0;
     } while (0);
     i2 = i14 + i47 | 0;
     i14 = i15 + i2 | 0;
     if (i14 >>> 0 < i2 >>> 0 | i14 >>> 0 > i48 >>> 0) {
      i2 = 0;
      break L79;
     }
     i14 = i67;
     HEAP32[i14 >> 2] = i16;
     HEAP32[i14 + 4 >> 2] = i17;
     HEAP32[i19 >> 2] = i2;
     HEAP32[i20 >> 2] = i15;
     HEAP32[i21 >> 2] = i3;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i40 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIxN14SerializedFile10ObjectInfoEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i39, i67); else {
      HEAP32[i2 >> 2] = HEAP32[i67 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
      HEAP32[i2 + 12 >> 2] = HEAP32[i67 + 12 >> 2];
      HEAP32[i2 + 16 >> 2] = HEAP32[i67 + 16 >> 2];
      HEAP32[i2 + 20 >> 2] = HEAP32[i67 + 20 >> 2];
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
     }
     i18 = i18 + 1 | 0;
     if ((i18 | 0) >= (i41 | 0)) break L94;
    }
    if ((i60 | 0) == 98) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 588591 | 0, 0, gb + 588245 | 0, 1172, 1, 0, 0, 0);
     i2 = 0;
     break L79;
    } else if ((i60 | 0) == 114) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 588591 | 0, 0, gb + 588245 | 0, 1179, 1, 0, 0, 0);
     i2 = 0;
     break L79;
    } else if ((i60 | 0) == 119) {
     i2 = HEAP32[i33 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i46 | 0, i2 | 0);
     HEAP32[i49 >> 2] = (HEAP8[i46 + 11 >> 0] | 0) < 0 ? HEAP32[i46 >> 2] | 0 : i46;
     __Z6FormatPKcz(i67, gb + 588617 | 0, i49);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1202, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i46);
     i2 = 0;
     break L79;
    }
   } else i1 = i55 + 36 | 0; while (0);
   L184 : do if ((HEAP32[i55 + 32 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) if (!(HEAP8[i45 >> 0] | 0)) if (!(HEAP32[i55 + 48 >> 2] & 16777216)) {
    i6 = i68 + 11 | 0;
    i3 = HEAP8[i6 >> 0] | 0;
    i49 = i3 << 24 >> 24 < 0;
    i2 = i49 ? HEAP32[i68 >> 2] | 0 : i68;
    i3 = i49 ? HEAP32[i68 + 4 >> 2] | 0 : i3 & 255;
    do if (i3 | 0) {
     i1 = _memchr(i2, 10, i3) | 0;
     if ((i1 | 0) == 0 | (i1 - i2 | 0) == -1) {
      if ((i3 | 0) != 13) break;
      if (!(_memcmp(i2, gb + 1040146 | 0, 13) | 0)) break L184; else break;
     }
     i4 = i1 + 1 | 0;
     i5 = i2 + i3 | 0;
     i3 = i4;
     HEAP32[i67 >> 2] = 0;
     HEAP32[i67 + 4 >> 2] = 0;
     HEAP32[i67 + 8 >> 2] = 0;
     i1 = i5 - i3 | 0;
     if (i1 >>> 0 > 4294967279) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i67);
      i60 = 138;
     } else if (i1 >>> 0 < 11) {
      HEAP8[i67 + 11 >> 0] = i1;
      i1 = i67;
     } else i60 = 138;
     if ((i60 | 0) == 138) {
      i48 = i1 + 16 & -16;
      i49 = __Znwj(i48) | 0;
      HEAP32[i67 >> 2] = i49;
      HEAP32[i67 + 8 >> 2] = i48 | -2147483648;
      HEAP32[i67 + 4 >> 2] = i1;
      i1 = i49;
     }
     if ((i4 | 0) != (i5 | 0)) {
      i2 = i4;
      while (1) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       i2 = i3 + 1 | 0;
       i1 = i1 + 1 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
      }
     }
     HEAP8[i1 >> 0] = 0;
     i1 = HEAP32[gb + 74108 >> 2] | 0;
     i2 = _strlen(i1) | 0;
     i49 = HEAP8[i67 + 11 >> 0] | 0;
     if ((i2 | 0) == ((i49 << 24 >> 24 < 0 ? HEAP32[i67 + 4 >> 2] | 0 : i49 & 255) | 0)) {
      i49 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i67, 0, -1, i1, i2) | 0) == 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
      if (i49) break L184; else break;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
      break;
     }
    } while (0);
    i2 = HEAP32[i55 + 128 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i50 | 0, i2 | 0);
    i2 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i68 >> 2] | 0 : i68;
    HEAP32[i51 >> 2] = (HEAP8[i50 + 11 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50;
    HEAP32[i51 + 4 >> 2] = i2;
    __Z6FormatPKcz(i67, gb + 588653 | 0, i51);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i67 + 11 >> 0] | 0) < 0 ? HEAP32[i67 >> 2] | 0 : i67, 0, gb + 588245 | 0, 1239, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i67);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
    i2 = 0;
    break L79;
   } while (0);
   if ((i54 | 0) > 10) {
    i4 = HEAP32[i56 >> 2] | 0;
    i5 = _llvm_bswap_i32(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24 | 0) | 0;
    HEAP32[i56 >> 2] = i4 + 4;
    i4 = i55 + 72 | 0;
    i1 = i55 + 84 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i55 + 88 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5 << 4, 8, i55 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i51 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 8, i55 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i51 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i51;
     break;
    } while (0);
    if ((i5 | 0) > 0) {
     i3 = 3 - i52 | 0;
     i4 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP32[i56 >> 2] | 0;
     if ((i54 | 0) > 13) {
      i2 = 0;
      do {
       HEAP32[i4 + (i2 << 4) >> 2] = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
       i52 = i1 + 4 | 0;
       HEAP32[i56 >> 2] = i52;
       i52 = i53 + (i3 + i52 & -4) | 0;
       i50 = i52;
       i51 = i50;
       i50 = i50 + 4 | 0;
       i50 = HEAPU8[i50 >> 0] | HEAPU8[i50 + 1 >> 0] << 8 | HEAPU8[i50 + 2 >> 0] << 16 | HEAPU8[i50 + 3 >> 0] << 24;
       i51 = _llvm_bswap_i32(HEAPU8[i51 >> 0] | HEAPU8[i51 + 1 >> 0] << 8 | HEAPU8[i51 + 2 >> 0] << 16 | HEAPU8[i51 + 3 >> 0] << 24 | 0) | 0;
       i50 = _llvm_bswap_i32(i50 | 0) | 0;
       i1 = i52 + 8 | 0;
       HEAP32[i62 >> 2] = i1;
       i52 = i4 + (i2 << 4) + 8 | 0;
       HEAP32[i52 >> 2] = i50;
       HEAP32[i52 + 4 >> 2] = i51;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
     } else {
      i2 = 0;
      do {
       HEAP32[i4 + (i2 << 4) >> 2] = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
       i52 = i1 + 4 | 0;
       i52 = _llvm_bswap_i32(HEAPU8[i52 >> 0] | HEAPU8[i52 + 1 >> 0] << 8 | HEAPU8[i52 + 2 >> 0] << 16 | HEAPU8[i52 + 3 >> 0] << 24 | 0) | 0;
       i1 = i1 + 8 | 0;
       HEAP32[i56 >> 2] = i1;
       i53 = i4 + (i2 << 4) + 8 | 0;
       HEAP32[i53 >> 2] = i52;
       HEAP32[i53 + 4 >> 2] = ((i52 | 0) < 0) << 31 >> 31;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
     }
    }
   }
   i20 = HEAP32[i56 >> 2] | 0;
   i19 = _llvm_bswap_i32(HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24 | 0) | 0;
   HEAP32[i56 >> 2] = i20 + 4;
   i20 = i55 + 92 | 0;
   __ZN20dynamic_block_vectorI14FileIdentifierE6resizeEj(i20, i19);
   i21 = (i54 | 0) > 4;
   if ((i19 | 0) > 0) {
    i13 = (i54 | 0) == 5;
    i14 = i63 + 12 | 0;
    i15 = i63 + 11 | 0;
    i16 = i63 + 4 | 0;
    i17 = i63 + 12 | 0;
    i18 = i67 + 4 | 0;
    i12 = i55 + 108 | 0;
    i11 = 0;
    do {
     if (i21) {
      if (!i13) {
       HEAP32[i63 >> 2] = 0;
       HEAP32[i63 + 4 >> 2] = 0;
       HEAP32[i63 + 8 >> 2] = 0;
       HEAP32[i14 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i63 >> 2] = 0;
       HEAP32[i63 + 4 >> 2] = 0;
       HEAP32[i63 + 8 >> 2] = 0;
       i2 = HEAP32[i62 >> 2] | 0;
       L233 : do if (i2 >>> 0 < i61 >>> 0) {
        i1 = i2;
        while (1) {
         if (!(HEAP8[i1 >> 0] | 0)) {
          i4 = i1;
          break L233;
         }
         i1 = i1 + 1 | 0;
         HEAP32[i62 >> 2] = i1;
         if (i1 >>> 0 >= i61 >>> 0) {
          i4 = i1;
          break;
         }
        }
       } else i4 = i2; while (0);
       i5 = i4 - i2 | 0;
       if (i5 >>> 0 > 10) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i63, 10, i5 + -10 | 0, 0, 0, 0, 0);
        i1 = HEAP8[i15 >> 0] | 0;
        i3 = HEAP32[i63 >> 2] | 0;
       } else {
        i1 = 0;
        i3 = 0;
       }
       i1 = i1 << 24 >> 24 < 0 ? i3 : i63;
       if ((i2 | 0) != (i4 | 0)) {
        i3 = i1;
        while (1) {
         HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
        }
        i1 = i1 + i5 | 0;
       }
       HEAP8[i1 >> 0] = 0;
       if ((HEAP8[i15 >> 0] | 0) < 0) {
        HEAP32[i16 >> 2] = i5;
        HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
        i60 = 170;
       } else {
        i55 = i5 & 255;
        HEAP8[i15 >> 0] = i55;
        HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
        if (i55 << 24 >> 24 < 0) i60 = 170;
       }
       if ((i60 | 0) == 170) {
        i60 = 0;
        i55 = HEAP32[i63 >> 2] | 0;
        i54 = HEAP32[i17 >> 2] | 0;
        HEAP32[i67 >> 2] = 66;
        HEAP32[i18 >> 2] = i54;
        __Z19free_alloc_internalPvRK10MemLabelId(i55, i67);
       }
      }
      i55 = HEAP32[i20 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      i55 = (HEAP32[i1 + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 20 | 0;
      i2 = HEAP32[i56 >> 2] | 0;
      HEAP32[i55 >> 2] = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
      i55 = i2 + 4 | 0;
      HEAP32[i56 >> 2] = i55;
      i54 = HEAP32[i20 >> 2] | 0;
      i54 = (HEAP32[i1 + (((i11 >>> 0) / (i54 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i54 >>> 0) | 0) * 36 | 0) + 24 | 0;
      HEAP32[i54 >> 2] = _llvm_bswap_i32(HEAPU8[i55 >> 0] | HEAPU8[i55 + 1 >> 0] << 8 | HEAPU8[i55 + 2 >> 0] << 16 | HEAPU8[i55 + 3 >> 0] << 24 | 0) | 0;
      i54 = i2 + 8 | 0;
      HEAP32[i56 >> 2] = i54;
      i55 = HEAP32[i20 >> 2] | 0;
      i55 = (HEAP32[i1 + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 28 | 0;
      HEAP32[i55 >> 2] = _llvm_bswap_i32(HEAPU8[i54 >> 0] | HEAPU8[i54 + 1 >> 0] << 8 | HEAPU8[i54 + 2 >> 0] << 16 | HEAPU8[i54 + 3 >> 0] << 24 | 0) | 0;
      i55 = i2 + 12 | 0;
      HEAP32[i56 >> 2] = i55;
      i54 = HEAP32[i20 >> 2] | 0;
      i54 = (HEAP32[i1 + (((i11 >>> 0) / (i54 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i54 >>> 0) | 0) * 36 | 0) + 32 | 0;
      HEAP32[i54 >> 2] = _llvm_bswap_i32(HEAPU8[i55 >> 0] | HEAPU8[i55 + 1 >> 0] << 8 | HEAPU8[i55 + 2 >> 0] << 16 | HEAPU8[i55 + 3 >> 0] << 24 | 0) | 0;
      i54 = i2 + 16 | 0;
      HEAP32[i56 >> 2] = i54;
      i55 = HEAP32[i20 >> 2] | 0;
      i55 = (HEAP32[i1 + (((i11 >>> 0) / (i55 >>> 0) | 0) << 2) >> 2] | 0) + (((i11 >>> 0) % (i55 >>> 0) | 0) * 36 | 0) + 16 | 0;
      HEAP32[i55 >> 2] = _llvm_bswap_i32(HEAPU8[i54 >> 0] | HEAPU8[i54 + 1 >> 0] << 8 | HEAPU8[i54 + 2 >> 0] << 16 | HEAPU8[i54 + 3 >> 0] << 24 | 0) | 0;
      i2 = i2 + 20 | 0;
      HEAP32[i56 >> 2] = i2;
     } else {
      i1 = HEAP32[i12 >> 2] | 0;
      i2 = HEAP32[i62 >> 2] | 0;
     }
     i9 = HEAP32[i20 >> 2] | 0;
     i10 = (i11 >>> 0) % (i9 >>> 0) | 0;
     i9 = HEAP32[i1 + (((i11 >>> 0) / (i9 >>> 0) | 0) << 2) >> 2] | 0;
     i5 = i9 + (i10 * 36 | 0) | 0;
     L255 : do if (i2 >>> 0 < i61 >>> 0) {
      i1 = i2;
      while (1) {
       if (!(HEAP8[i1 >> 0] | 0)) {
        i6 = i1;
        break L255;
       }
       i1 = i1 + 1 | 0;
       HEAP32[i62 >> 2] = i1;
       if (i1 >>> 0 >= i61 >>> 0) {
        i6 = i1;
        break;
       }
      }
     } else i6 = i2; while (0);
     i7 = i6 - i2 | 0;
     i8 = i5 + 11 | 0;
     i1 = HEAP8[i8 >> 0] | 0;
     i3 = i1 << 24 >> 24 < 0;
     if (i3) i4 = (HEAP32[i9 + (i10 * 36 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     if (i7 >>> 0 > i4 >>> 0) {
      i1 = i3 ? HEAP32[i9 + (i10 * 36 | 0) + 4 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i5, i4, i7 - i4 | 0, i1, 0, i1, 0);
      i1 = HEAP8[i8 >> 0] | 0;
     }
     i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5;
     if ((i2 | 0) != (i6 | 0)) {
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
      }
      i1 = i1 + i7 | 0;
     }
     HEAP8[i1 >> 0] = 0;
     if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i9 + (i10 * 36 | 0) + 4 >> 2] = i7; else HEAP8[i8 >> 0] = i7;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i19 | 0));
   }
   if (i21) {
    HEAP32[i63 >> 2] = 0;
    HEAP32[i63 + 4 >> 2] = 0;
    HEAP32[i63 + 8 >> 2] = 0;
    HEAP32[i63 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i63 >> 2] = 0;
    HEAP32[i63 + 4 >> 2] = 0;
    HEAP32[i63 + 8 >> 2] = 0;
    i2 = HEAP32[i62 >> 2] | 0;
    L277 : do if (i2 >>> 0 < i61 >>> 0) {
     i1 = i2;
     do {
      if (!(HEAP8[i1 >> 0] | 0)) break L277;
      i1 = i1 + 1 | 0;
      HEAP32[i62 >> 2] = i1;
     } while (i1 >>> 0 < i61 >>> 0);
    } else i1 = i2; while (0);
    i6 = i1 - i2 | 0;
    i7 = i63 + 11 | 0;
    if (i6 >>> 0 > 10) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i63, 10, i6 + -10 | 0, 0, 0, 0, 0);
     i5 = i63;
     i4 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i63 >> 2] | 0 : i63;
    } else {
     i5 = i63;
     i4 = i63;
    }
    if ((i2 | 0) == (i1 | 0)) i1 = i4; else {
     i3 = i4;
     while (1) {
      HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i1 | 0)) break; else i3 = i3 + 1 | 0;
     }
     i1 = i4 + i6 | 0;
    }
    HEAP8[i1 >> 0] = 0;
    if ((HEAP8[i7 >> 0] | 0) < 0) {
     HEAP32[i63 + 4 >> 2] = i6;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     i60 = 200;
    } else {
     i61 = i6 & 255;
     HEAP8[i7 >> 0] = i61;
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + 1;
     if (i61 << 24 >> 24 < 0) i60 = 200;
    }
    if ((i60 | 0) == 200) {
     i62 = HEAP32[i5 >> 2] | 0;
     i63 = HEAP32[i63 + 12 >> 2] | 0;
     HEAP32[i67 >> 2] = 66;
     HEAP32[i67 + 4 >> 2] = i63;
     __Z19free_alloc_internalPvRK10MemLabelId(i62, i67);
    }
    i2 = 1;
   } else i2 = 1;
  } while (0);
  if ((HEAP32[i57 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i64 >> 2] | 0, i58);
   HEAP32[i64 >> 2] = 0;
  }
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i65, HEAP32[i59 >> 2] | 0);
  i1 = i68 + 11 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i65 = HEAP32[i68 >> 2] | 0;
  i68 = HEAP32[i68 + 12 >> 2] | 0;
  HEAP32[i67 >> 2] = 66;
  HEAP32[i67 + 4 >> 2] = i68;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i67);
 }
 if (!i66) {
  STACKTOP = i69;
  return i2 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i69;
 return i2 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i1, i2, i42) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i42 = i42 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i64 = i66 + 16 | 0;
 i65 = i66;
 i53 = i65 + 12 | 0;
 i23 = i65 + 12 | 0;
 i54 = i64 + 4 | 0;
 i55 = i65 + 8 | 0;
 i56 = i65 + 4 | 0;
 i28 = i65 + 11 | 0;
 i57 = i64 + 4 | 0;
 i32 = i65 + 12 | 0;
 i22 = i65 + 12 | 0;
 i33 = i64 + 4 | 0;
 i34 = i65 + 8 | 0;
 i35 = i65 + 4 | 0;
 i27 = i65 + 11 | 0;
 i36 = i64 + 4 | 0;
 i37 = i65 + 12 | 0;
 i25 = i65 + 12 | 0;
 i38 = i64 + 4 | 0;
 i39 = i65 + 8 | 0;
 i40 = i65 + 4 | 0;
 i30 = i65 + 11 | 0;
 i41 = i64 + 4 | 0;
 i43 = i65 + 12 | 0;
 i26 = i65 + 12 | 0;
 i44 = i64 + 4 | 0;
 i45 = i65 + 8 | 0;
 i46 = i65 + 4 | 0;
 i31 = i65 + 11 | 0;
 i47 = i64 + 4 | 0;
 i48 = i65 + 12 | 0;
 i24 = i65 + 12 | 0;
 i49 = i64 + 4 | 0;
 i50 = i65 + 8 | 0;
 i51 = i65 + 4 | 0;
 i29 = i65 + 11 | 0;
 i52 = i64 + 4 | 0;
 L1 : while (1) {
  i19 = i2;
  i61 = i2 + -16 | 0;
  i20 = i2 + -32 | 0;
  i62 = i61 + 11 | 0;
  i63 = i2 + -12 | 0;
  i21 = (i65 | 0) == (i61 | 0);
  i60 = i2 + -8 | 0;
  while (1) {
   i59 = i1;
   L5 : while (1) {
    i18 = i59;
    i1 = i19 - i18 | 0;
    i3 = i1 >> 4;
    switch (i3 | 0) {
    case 2:
     {
      i58 = 5;
      break L1;
     }
    case 3:
     {
      i58 = 39;
      break L1;
     }
    case 4:
     {
      i58 = 40;
      break L1;
     }
    case 5:
     {
      i58 = 41;
      break L1;
     }
    case 1:
    case 0:
     {
      i58 = 279;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 112) {
     i58 = 43;
     break L1;
    }
    i4 = (i3 | 0) / 2 | 0;
    i15 = i59 + (i4 << 4) | 0;
    if ((i1 | 0) > 15984) {
     i1 = (i3 | 0) / 4 | 0;
     i1 = __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i59, i59 + (i1 << 4) | 0, i15, i15 + (i1 << 4) | 0, i61, i42) | 0;
    } else i1 = __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i59, i15, i61, i42) | 0;
    i16 = i59 + 11 | 0;
    i13 = HEAP8[i16 >> 0] | 0;
    i12 = i13 << 24 >> 24 < 0;
    i17 = i59 + 4 | 0;
    i13 = i12 ? HEAP32[i17 >> 2] | 0 : i13 & 255;
    i10 = HEAP8[i15 + 11 >> 0] | 0;
    i5 = i10 << 24 >> 24 < 0;
    i10 = i5 ? HEAP32[i59 + (i4 << 4) + 4 >> 2] | 0 : i10 & 255;
    i3 = i10 >>> 0 < i13 >>> 0 ? i10 : i13;
    if (!i3) i58 = 49; else {
     i3 = _memcmp(i12 ? HEAP32[i59 >> 2] | 0 : i59, i5 ? HEAP32[i15 >> 2] | 0 : i15, i3) | 0;
     if (!i3) i58 = 49; else if ((i3 | 0) < 0) {
      i3 = i61;
      break;
     }
    }
    if ((i58 | 0) == 49) {
     i58 = 0;
     if (i13 >>> 0 < i10 >>> 0) {
      i3 = i61;
      break;
     }
    }
    if ((i59 | 0) != (i20 | 0)) if (i5) {
     i6 = i61;
     i3 = i20;
     while (1) {
      i9 = i3 + 11 | 0;
      i7 = HEAP8[i9 >> 0] | 0;
      i5 = i7 << 24 >> 24 < 0;
      i8 = i6 + -12 | 0;
      i7 = i5 ? HEAP32[i8 >> 2] | 0 : i7 & 255;
      i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
      if (!i4) i58 = 56; else {
       i4 = _memcmp(i5 ? HEAP32[i3 >> 2] | 0 : i3, HEAP32[i15 >> 2] | 0, i4) | 0;
       if (!i4) i58 = 56; else if ((i4 | 0) < 0) {
        i10 = i6;
        i11 = i8;
        i58 = 159;
        break L5;
       }
      }
      if ((i58 | 0) == 56) {
       i58 = 0;
       if (i7 >>> 0 < i10 >>> 0) {
        i10 = i6;
        i11 = i8;
        i58 = 159;
        break L5;
       }
      }
      i4 = i3 + -16 | 0;
      if ((i59 | 0) == (i4 | 0)) break; else {
       i6 = i3;
       i3 = i4;
      }
     }
    } else {
     i6 = i61;
     i3 = i20;
     while (1) {
      i9 = i3 + 11 | 0;
      i7 = HEAP8[i9 >> 0] | 0;
      i5 = i7 << 24 >> 24 < 0;
      i8 = i6 + -12 | 0;
      i7 = i5 ? HEAP32[i8 >> 2] | 0 : i7 & 255;
      i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
      if (!i4) i58 = 156; else {
       i4 = _memcmp(i5 ? HEAP32[i3 >> 2] | 0 : i3, i15, i4) | 0;
       if (!i4) i58 = 156; else if ((i4 | 0) < 0) {
        i10 = i6;
        i11 = i8;
        i58 = 159;
        break L5;
       }
      }
      if ((i58 | 0) == 156) {
       i58 = 0;
       if (i7 >>> 0 < i10 >>> 0) {
        i10 = i6;
        i11 = i8;
        i58 = 159;
        break L5;
       }
      }
      i4 = i3 + -16 | 0;
      if ((i59 | 0) == (i4 | 0)) break; else {
       i6 = i3;
       i3 = i4;
      }
     }
    }
    i1 = i59 + 16 | 0;
    i5 = HEAP8[i62 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i63 >> 2] | 0 : i5 & 255;
    i3 = i5 >>> 0 < i13 >>> 0 ? i5 : i13;
    if (!i3) i58 = 60; else {
     i3 = _memcmp(i12 ? HEAP32[i59 >> 2] | 0 : i59, i4 ? HEAP32[i61 >> 2] | 0 : i61, i3) | 0;
     if (!i3) i58 = 60; else if ((i3 | 0) >= 0) i58 = 62;
    }
    if ((i58 | 0) == 60) {
     i58 = 0;
     if (i13 >>> 0 >= i5 >>> 0) i58 = 62;
    }
    if ((i58 | 0) == 62) {
     i58 = 0;
     if ((i1 | 0) == (i61 | 0)) {
      i58 = 279;
      break L1;
     }
     L47 : do if (i12) while (1) {
      i8 = i1 + 11 | 0;
      i9 = HEAP8[i8 >> 0] | 0;
      i5 = i9 << 24 >> 24 < 0;
      i7 = i1 + 4 | 0;
      i3 = HEAP32[i7 >> 2] | 0;
      i6 = i5 ? i3 : i9 & 255;
      i4 = i6 >>> 0 < i13 >>> 0 ? i6 : i13;
      if (!i4) i58 = 67; else {
       i4 = _memcmp(HEAP32[i59 >> 2] | 0, i5 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0;
       if (!i4) i58 = 67; else if ((i4 | 0) < 0) {
        i10 = i7;
        i4 = i9;
        break L47;
       }
      }
      if ((i58 | 0) == 67) {
       i58 = 0;
       if (i13 >>> 0 < i6 >>> 0) {
        i10 = i7;
        i4 = i9;
        break L47;
       }
      }
      i1 = i1 + 16 | 0;
      if ((i1 | 0) == (i61 | 0)) {
       i58 = 279;
       break L1;
      }
     } else while (1) {
      i8 = i1 + 11 | 0;
      i9 = HEAP8[i8 >> 0] | 0;
      i5 = i9 << 24 >> 24 < 0;
      i7 = i1 + 4 | 0;
      i3 = HEAP32[i7 >> 2] | 0;
      i6 = i5 ? i3 : i9 & 255;
      i4 = i6 >>> 0 < i13 >>> 0 ? i6 : i13;
      if (!i4) i58 = 71; else {
       i4 = _memcmp(i59, i5 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0;
       if (!i4) i58 = 71; else if ((i4 | 0) < 0) {
        i10 = i7;
        i4 = i9;
        break L47;
       }
      }
      if ((i58 | 0) == 71) {
       i58 = 0;
       if (i13 >>> 0 < i6 >>> 0) {
        i10 = i7;
        i4 = i9;
        break L47;
       }
      }
      i1 = i1 + 16 | 0;
      if ((i1 | 0) == (i61 | 0)) {
       i58 = 279;
       break L1;
      }
     } while (0);
     i18 = i4 << 24 >> 24 < 0;
     i5 = i18 ? HEAP32[i1 >> 2] | 0 : i1;
     i4 = i18 ? i3 : i4 & 255;
     HEAP32[i65 >> 2] = 0;
     HEAP32[i65 + 4 >> 2] = 0;
     HEAP32[i65 + 8 >> 2] = 0;
     i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i32 >> 2] = i3;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
      i3 = HEAP32[i22 >> 2] | 0;
      i58 = 76;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i27 >> 0] = i4;
      if (!i4) i3 = i65; else {
       i3 = i65;
       i58 = 78;
      }
     } else i58 = 76;
     if ((i58 | 0) == 76) {
      i18 = i4 + 16 & -16;
      HEAP32[i64 >> 2] = 66;
      HEAP32[i33 >> 2] = i3;
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i65 >> 2] = i3;
      HEAP32[i34 >> 2] = i18 | -2147483648;
      HEAP32[i35 >> 2] = i4;
      i58 = 78;
     }
     if ((i58 | 0) == 78) {
      i58 = 0;
      _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
     }
     HEAP8[i3 + i4 >> 0] = 0;
     i7 = HEAP8[i62 >> 0] | 0;
     i3 = i7 << 24 >> 24 < 0;
     i6 = i3 ? HEAP32[i61 >> 2] | 0 : i61;
     i7 = i3 ? HEAP32[i63 >> 2] | 0 : i7 & 255;
     i3 = HEAP8[i8 >> 0] | 0;
     i4 = i3 << 24 >> 24 < 0;
     if (i4) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     do if (i7 >>> 0 > i5 >>> 0) {
      i18 = i4 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i18, 0, i18, i7, i6);
     } else {
      i3 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
      if (i7 | 0) _memmove(i3 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i8 >> 0] | 0) < 0) {
       HEAP32[i10 >> 2] = i7;
       break;
      } else {
       HEAP8[i8 >> 0] = i7;
       break;
      }
     } while (0);
     do if (!i21) {
      i7 = HEAP8[i27 >> 0] | 0;
      i3 = i7 << 24 >> 24 < 0;
      i6 = i3 ? HEAP32[i65 >> 2] | 0 : i65;
      i7 = i3 ? HEAP32[i35 >> 2] | 0 : i7 & 255;
      i3 = HEAP8[i62 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i5 = (HEAP32[i60 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
      if (i7 >>> 0 > i5 >>> 0) {
       i18 = i4 ? HEAP32[i63 >> 2] | 0 : i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i61, i5, i7 - i5 | 0, i18, 0, i18, i7, i6);
       break;
      }
      i3 = i4 ? HEAP32[i61 >> 2] | 0 : i61;
      if (i7 | 0) _memmove(i3 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i62 >> 0] | 0) < 0) {
       HEAP32[i63 >> 2] = i7;
       break;
      } else {
       HEAP8[i62 >> 0] = i7;
       break;
      }
     } while (0);
     if ((HEAP8[i27 >> 0] | 0) < 0) {
      i18 = HEAP32[i65 >> 2] | 0;
      i15 = HEAP32[i22 >> 2] | 0;
      HEAP32[i64 >> 2] = 66;
      HEAP32[i36 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i18, i64);
     }
     i1 = i1 + 16 | 0;
    }
    if ((i1 | 0) == (i61 | 0)) {
     i58 = 279;
     break L1;
    }
    i11 = i61;
    while (1) {
     i13 = HEAP8[i16 >> 0] | 0;
     i10 = i13 << 24 >> 24 < 0;
     i13 = i10 ? HEAP32[i17 >> 2] | 0 : i13 & 255;
     L109 : do if (i10) while (1) {
      i7 = i1 + 11 | 0;
      i8 = HEAP8[i7 >> 0] | 0;
      i4 = i8 << 24 >> 24 < 0;
      i6 = i1 + 4 | 0;
      i9 = HEAP32[i6 >> 2] | 0;
      i5 = i4 ? i9 : i8 & 255;
      i3 = i5 >>> 0 < i13 >>> 0 ? i5 : i13;
      if (!i3) i58 = 108; else {
       i3 = _memcmp(HEAP32[i59 >> 2] | 0, i4 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0;
       if (!i3) i58 = 108; else if ((i3 | 0) < 0) {
        i14 = i7;
        i12 = i9;
        break L109;
       }
      }
      if ((i58 | 0) == 108) {
       i58 = 0;
       if (i13 >>> 0 < i5 >>> 0) {
        i14 = i7;
        i12 = i9;
        break L109;
       }
      }
      i1 = i1 + 16 | 0;
     } else while (1) {
      i7 = i1 + 11 | 0;
      i8 = HEAP8[i7 >> 0] | 0;
      i4 = i8 << 24 >> 24 < 0;
      i6 = i1 + 4 | 0;
      i9 = HEAP32[i6 >> 2] | 0;
      i5 = i4 ? i9 : i8 & 255;
      i3 = i5 >>> 0 < i13 >>> 0 ? i5 : i13;
      if (!i3) i58 = 112; else {
       i3 = _memcmp(i59, i4 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0;
       if (!i3) i58 = 112; else if ((i3 | 0) < 0) {
        i14 = i7;
        i12 = i9;
        break L109;
       }
      }
      if ((i58 | 0) == 112) {
       i58 = 0;
       if (i13 >>> 0 < i5 >>> 0) {
        i14 = i7;
        i12 = i9;
        break L109;
       }
      }
      i1 = i1 + 16 | 0;
     } while (0);
     L127 : do if (i10) {
      i5 = i11;
      while (1) {
       i11 = i5 + -16 | 0;
       i10 = i11 + 11 | 0;
       i7 = HEAP8[i10 >> 0] | 0;
       i4 = i7 << 24 >> 24 < 0;
       i9 = i5 + -12 | 0;
       i7 = i4 ? HEAP32[i9 >> 2] | 0 : i7 & 255;
       i3 = i7 >>> 0 < i13 >>> 0 ? i7 : i13;
       if (i3 | 0) {
        i3 = _memcmp(HEAP32[i59 >> 2] | 0, i4 ? HEAP32[i11 >> 2] | 0 : i11, i3) | 0;
        if (i3 | 0) if ((i3 | 0) < 0) {
         i5 = i11;
         continue;
        } else {
         i13 = i5;
         break L127;
        }
       }
       if (i13 >>> 0 < i7 >>> 0) i5 = i11; else {
        i13 = i5;
        break;
       }
      }
     } else {
      i5 = i11;
      while (1) {
       i11 = i5 + -16 | 0;
       i10 = i11 + 11 | 0;
       i7 = HEAP8[i10 >> 0] | 0;
       i4 = i7 << 24 >> 24 < 0;
       i9 = i5 + -12 | 0;
       i7 = i4 ? HEAP32[i9 >> 2] | 0 : i7 & 255;
       i3 = i7 >>> 0 < i13 >>> 0 ? i7 : i13;
       if (i3 | 0) {
        i3 = _memcmp(i59, i4 ? HEAP32[i11 >> 2] | 0 : i11, i3) | 0;
        if (i3 | 0) if ((i3 | 0) < 0) {
         i5 = i11;
         continue;
        } else {
         i13 = i5;
         break L127;
        }
       }
       if (i13 >>> 0 < i7 >>> 0) i5 = i11; else {
        i13 = i5;
        break;
       }
      }
     } while (0);
     if (i1 >>> 0 >= i11 >>> 0) {
      i59 = i1;
      continue L5;
     }
     i4 = i8 << 24 >> 24 < 0;
     i5 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
     i4 = i4 ? i12 : i8 & 255;
     HEAP32[i65 >> 2] = 0;
     HEAP32[i65 + 4 >> 2] = 0;
     HEAP32[i65 + 8 >> 2] = 0;
     i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i53 >> 2] = i3;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
      i3 = HEAP32[i23 >> 2] | 0;
      i58 = 128;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i28 >> 0] = i4;
      if (!i4) i3 = i65; else {
       i3 = i65;
       i58 = 130;
      }
     } else i58 = 128;
     if ((i58 | 0) == 128) {
      i18 = i4 + 16 & -16;
      HEAP32[i64 >> 2] = 66;
      HEAP32[i54 >> 2] = i3;
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i65 >> 2] = i3;
      HEAP32[i55 >> 2] = i18 | -2147483648;
      HEAP32[i56 >> 2] = i4;
      i58 = 130;
     }
     if ((i58 | 0) == 130) {
      i58 = 0;
      _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
     }
     HEAP8[i3 + i4 >> 0] = 0;
     do if ((i1 | 0) != (i11 | 0)) {
      i8 = HEAP8[i10 >> 0] | 0;
      i3 = i8 << 24 >> 24 < 0;
      i7 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
      i8 = i3 ? HEAP32[i9 >> 2] | 0 : i8 & 255;
      i3 = HEAP8[i14 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
      if (i8 >>> 0 > i5 >>> 0) {
       i18 = i4 ? HEAP32[i6 >> 2] | 0 : i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i18, 0, i18, i8, i7);
       break;
      }
      i3 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
      if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
      HEAP8[i3 + i8 >> 0] = 0;
      if ((HEAP8[i14 >> 0] | 0) < 0) {
       HEAP32[i6 >> 2] = i8;
       break;
      } else {
       HEAP8[i14 >> 0] = i8;
       break;
      }
     } while (0);
     do if ((i65 | 0) != (i11 | 0)) {
      i7 = HEAP8[i28 >> 0] | 0;
      i4 = i7 << 24 >> 24 < 0;
      i6 = i4 ? HEAP32[i65 >> 2] | 0 : i65;
      i7 = i4 ? HEAP32[i56 >> 2] | 0 : i7 & 255;
      i4 = HEAP8[i10 >> 0] | 0;
      i5 = i4 << 24 >> 24 < 0;
      if (i5) i3 = (HEAP32[i13 + -8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
      if (i7 >>> 0 > i3 >>> 0) {
       i18 = i5 ? HEAP32[i9 >> 2] | 0 : i4 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i7 - i3 | 0, i18, 0, i18, i7, i6);
       break;
      }
      i3 = i5 ? HEAP32[i11 >> 2] | 0 : i11;
      if (i7 | 0) _memmove(i3 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i10 >> 0] | 0) < 0) {
       HEAP32[i9 >> 2] = i7;
       break;
      } else {
       HEAP8[i10 >> 0] = i7;
       break;
      }
     } while (0);
     if ((HEAP8[i28 >> 0] | 0) < 0) {
      i18 = HEAP32[i65 >> 2] | 0;
      i15 = HEAP32[i23 >> 2] | 0;
      HEAP32[i64 >> 2] = 66;
      HEAP32[i57 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i18, i64);
     }
     i1 = i1 + 16 | 0;
    }
   }
   if ((i58 | 0) == 159) {
    i58 = 0;
    i5 = i12 ? HEAP32[i59 >> 2] | 0 : i59;
    HEAP32[i65 >> 2] = 0;
    HEAP32[i65 + 4 >> 2] = 0;
    HEAP32[i65 + 8 >> 2] = 0;
    i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i48 >> 2] = i4;
    if (i13 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
     i4 = HEAP32[i24 >> 2] | 0;
     i58 = 162;
    } else if (i13 >>> 0 < 11) {
     HEAP8[i29 >> 0] = i13;
     if (!i13) i4 = i65; else {
      i4 = i65;
      i58 = 164;
     }
    } else i58 = 162;
    if ((i58 | 0) == 162) {
     i14 = i13 + 16 & -16;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i49 >> 2] = i4;
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i65 >> 2] = i4;
     HEAP32[i50 >> 2] = i14 | -2147483648;
     HEAP32[i51 >> 2] = i13;
     i58 = 164;
    }
    if ((i58 | 0) == 164) {
     i58 = 0;
     _memcpy(i4 | 0, i5 | 0, i13 | 0) | 0;
    }
    HEAP8[i4 + i13 >> 0] = 0;
    i8 = HEAP8[i9 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
    i8 = i4 ? HEAP32[i11 >> 2] | 0 : i8 & 255;
    i4 = HEAP8[i16 >> 0] | 0;
    i5 = i4 << 24 >> 24 < 0;
    if (i5) i6 = (HEAP32[i59 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
    do if (i8 >>> 0 > i6 >>> 0) {
     i17 = i5 ? HEAP32[i17 >> 2] | 0 : i4 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i59, i6, i8 - i6 | 0, i17, 0, i17, i8, i7);
    } else {
     i4 = i5 ? HEAP32[i59 >> 2] | 0 : i59;
     if (i8 | 0) _memmove(i4 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i4 + i8 >> 0] = 0;
     if ((HEAP8[i16 >> 0] | 0) < 0) {
      HEAP32[i17 >> 2] = i8;
      break;
     } else {
      HEAP8[i16 >> 0] = i8;
      break;
     }
    } while (0);
    do if ((i65 | 0) != (i3 | 0)) {
     i8 = HEAP8[i29 >> 0] | 0;
     i5 = i8 << 24 >> 24 < 0;
     i7 = i5 ? HEAP32[i65 >> 2] | 0 : i65;
     i8 = i5 ? HEAP32[i51 >> 2] | 0 : i8 & 255;
     i5 = HEAP8[i9 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     if (i6) i4 = (HEAP32[i10 + -8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     if (i8 >>> 0 > i4 >>> 0) {
      i17 = i6 ? HEAP32[i11 >> 2] | 0 : i5 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i4, i8 - i4 | 0, i17, 0, i17, i8, i7);
      break;
     }
     i4 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
     if (i8 | 0) _memmove(i4 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i4 + i8 >> 0] = 0;
     if ((HEAP8[i9 >> 0] | 0) < 0) {
      HEAP32[i11 >> 2] = i8;
      break;
     } else {
      HEAP8[i9 >> 0] = i8;
      break;
     }
    } while (0);
    if ((HEAP8[i29 >> 0] | 0) < 0) {
     i17 = HEAP32[i65 >> 2] | 0;
     i16 = HEAP32[i24 >> 2] | 0;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i52 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i64);
    }
    i1 = i1 + 1 | 0;
   }
   i4 = i59 + 16 | 0;
   L227 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i14 = HEAP8[i15 + 11 >> 0] | 0;
    i12 = i14 << 24 >> 24 < 0;
    i14 = i12 ? HEAP32[i15 + 4 >> 2] | 0 : i14 & 255;
    L230 : do if (i12) while (1) {
     i9 = i4 + 11 | 0;
     i10 = HEAP8[i9 >> 0] | 0;
     i6 = i10 << 24 >> 24 < 0;
     i8 = i4 + 4 | 0;
     i11 = HEAP32[i8 >> 2] | 0;
     i7 = i6 ? i11 : i10 & 255;
     i5 = i14 >>> 0 < i7 >>> 0 ? i14 : i7;
     if (!i5) i58 = 192; else {
      i5 = _memcmp(i6 ? HEAP32[i4 >> 2] | 0 : i4, HEAP32[i15 >> 2] | 0, i5) | 0;
      if (!i5) i58 = 192; else if ((i5 | 0) >= 0) {
       i16 = i9;
       break L230;
      }
     }
     if ((i58 | 0) == 192) {
      i58 = 0;
      if (i7 >>> 0 >= i14 >>> 0) {
       i16 = i9;
       break L230;
      }
     }
     i4 = i4 + 16 | 0;
    } else while (1) {
     i9 = i4 + 11 | 0;
     i10 = HEAP8[i9 >> 0] | 0;
     i6 = i10 << 24 >> 24 < 0;
     i8 = i4 + 4 | 0;
     i11 = HEAP32[i8 >> 2] | 0;
     i7 = i6 ? i11 : i10 & 255;
     i5 = i14 >>> 0 < i7 >>> 0 ? i14 : i7;
     if (!i5) i58 = 196; else {
      i5 = _memcmp(i6 ? HEAP32[i4 >> 2] | 0 : i4, i15, i5) | 0;
      if (!i5) i58 = 196; else if ((i5 | 0) >= 0) {
       i16 = i9;
       break L230;
      }
     }
     if ((i58 | 0) == 196) {
      i58 = 0;
      if (i7 >>> 0 >= i14 >>> 0) {
       i16 = i9;
       break L230;
      }
     }
     i4 = i4 + 16 | 0;
    } while (0);
    L248 : do if (i12) while (1) {
     i13 = i3 + -16 | 0;
     i12 = i13 + 11 | 0;
     i7 = HEAP8[i12 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i9 = i3 + -12 | 0;
     i7 = i6 ? HEAP32[i9 >> 2] | 0 : i7 & 255;
     i5 = i14 >>> 0 < i7 >>> 0 ? i14 : i7;
     if (i5 | 0) {
      i5 = _memcmp(i6 ? HEAP32[i13 >> 2] | 0 : i13, HEAP32[i15 >> 2] | 0, i5) | 0;
      if (i5 | 0) if ((i5 | 0) < 0) {
       i14 = i9;
       break L248;
      } else {
       i3 = i13;
       continue;
      }
     }
     if (i7 >>> 0 < i14 >>> 0) {
      i14 = i9;
      break;
     } else i3 = i13;
    } else while (1) {
     i13 = i3 + -16 | 0;
     i12 = i13 + 11 | 0;
     i7 = HEAP8[i12 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i9 = i3 + -12 | 0;
     i7 = i6 ? HEAP32[i9 >> 2] | 0 : i7 & 255;
     i5 = i14 >>> 0 < i7 >>> 0 ? i14 : i7;
     if (i5 | 0) {
      i5 = _memcmp(i6 ? HEAP32[i13 >> 2] | 0 : i13, i15, i5) | 0;
      if (i5 | 0) if ((i5 | 0) < 0) {
       i14 = i9;
       break L248;
      } else {
       i3 = i13;
       continue;
      }
     }
     if (i7 >>> 0 < i14 >>> 0) {
      i14 = i9;
      break;
     } else i3 = i13;
    } while (0);
    if (i4 >>> 0 > i13 >>> 0) break L227;
    i6 = i10 << 24 >> 24 < 0;
    i7 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
    i6 = i6 ? i11 : i10 & 255;
    HEAP32[i65 >> 2] = 0;
    HEAP32[i65 + 4 >> 2] = 0;
    HEAP32[i65 + 8 >> 2] = 0;
    i5 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i37 >> 2] = i5;
    if (i6 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
     i5 = HEAP32[i25 >> 2] | 0;
     i58 = 212;
    } else if (i6 >>> 0 < 11) {
     HEAP8[i30 >> 0] = i6;
     if (!i6) i5 = i65; else {
      i5 = i65;
      i58 = 214;
     }
    } else i58 = 212;
    if ((i58 | 0) == 212) {
     i17 = i6 + 16 & -16;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i38 >> 2] = i5;
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i65 >> 2] = i5;
     HEAP32[i39 >> 2] = i17 | -2147483648;
     HEAP32[i40 >> 2] = i6;
     i58 = 214;
    }
    if ((i58 | 0) == 214) {
     i58 = 0;
     _memcpy(i5 | 0, i7 | 0, i6 | 0) | 0;
    }
    HEAP8[i5 + i6 >> 0] = 0;
    do if ((i4 | 0) != (i13 | 0)) {
     i10 = HEAP8[i12 >> 0] | 0;
     i5 = i10 << 24 >> 24 < 0;
     i9 = i5 ? HEAP32[i13 >> 2] | 0 : i13;
     i10 = i5 ? HEAP32[i14 >> 2] | 0 : i10 & 255;
     i5 = HEAP8[i16 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     if (i6) i7 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
     if (i10 >>> 0 > i7 >>> 0) {
      i17 = i6 ? HEAP32[i8 >> 2] | 0 : i5 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i7, i10 - i7 | 0, i17, 0, i17, i10, i9);
      break;
     }
     i5 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
     if (i10 | 0) _memmove(i5 | 0, i9 | 0, i10 | 0) | 0;
     HEAP8[i5 + i10 >> 0] = 0;
     if ((HEAP8[i16 >> 0] | 0) < 0) {
      HEAP32[i8 >> 2] = i10;
      break;
     } else {
      HEAP8[i16 >> 0] = i10;
      break;
     }
    } while (0);
    do if ((i65 | 0) != (i13 | 0)) {
     i8 = HEAP8[i30 >> 0] | 0;
     i5 = i8 << 24 >> 24 < 0;
     i7 = i5 ? HEAP32[i65 >> 2] | 0 : i65;
     i8 = i5 ? HEAP32[i40 >> 2] | 0 : i8 & 255;
     i5 = HEAP8[i12 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     if (i6) i3 = (HEAP32[i3 + -8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i8 >>> 0 > i3 >>> 0) {
      i17 = i6 ? HEAP32[i14 >> 2] | 0 : i5 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i8 - i3 | 0, i17, 0, i17, i8, i7);
      break;
     }
     i3 = i6 ? HEAP32[i13 >> 2] | 0 : i13;
     if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i3 + i8 >> 0] = 0;
     if ((HEAP8[i12 >> 0] | 0) < 0) {
      HEAP32[i14 >> 2] = i8;
      break;
     } else {
      HEAP8[i12 >> 0] = i8;
      break;
     }
    } while (0);
    if ((HEAP8[i30 >> 0] | 0) < 0) {
     i17 = HEAP32[i65 >> 2] | 0;
     i16 = HEAP32[i25 >> 2] | 0;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i41 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i64);
    }
    i15 = (i15 | 0) == (i4 | 0) ? i13 : i15;
    i3 = i13;
    i4 = i4 + 16 | 0;
    i1 = i1 + 1 | 0;
   } while (0);
   do if ((i4 | 0) != (i15 | 0)) {
    i13 = i15 + 11 | 0;
    i6 = HEAP8[i13 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i14 = i15 + 4 | 0;
    i6 = i5 ? HEAP32[i14 >> 2] | 0 : i6 & 255;
    i11 = i4 + 11 | 0;
    i8 = HEAP8[i11 >> 0] | 0;
    i7 = i8 << 24 >> 24 < 0;
    i12 = i4 + 4 | 0;
    i8 = i7 ? HEAP32[i12 >> 2] | 0 : i8 & 255;
    i3 = i8 >>> 0 < i6 >>> 0 ? i8 : i6;
    if (!i3) i58 = 241; else {
     i3 = _memcmp(i5 ? HEAP32[i15 >> 2] | 0 : i15, i7 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
     if (!i3) i58 = 241; else if ((i3 | 0) < 0) {
      i9 = i4;
      i10 = i4;
     } else break;
    }
    if ((i58 | 0) == 241) {
     i58 = 0;
     if (i6 >>> 0 >= i8 >>> 0) break;
     i9 = i4;
     i10 = i4;
    }
    i5 = i7 ? HEAP32[i9 >> 2] | 0 : i10;
    HEAP32[i65 >> 2] = 0;
    HEAP32[i65 + 4 >> 2] = 0;
    HEAP32[i65 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i43 >> 2] = i3;
    if (i8 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
     i3 = HEAP32[i26 >> 2] | 0;
     i58 = 247;
    } else if (i8 >>> 0 < 11) {
     HEAP8[i31 >> 0] = i8;
     if (!i8) i3 = i65; else {
      i3 = i65;
      i58 = 249;
     }
    } else i58 = 247;
    if ((i58 | 0) == 247) {
     i17 = i8 + 16 & -16;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i44 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i65 >> 2] = i3;
     HEAP32[i45 >> 2] = i17 | -2147483648;
     HEAP32[i46 >> 2] = i8;
     i58 = 249;
    }
    if ((i58 | 0) == 249) {
     i58 = 0;
     _memcpy(i3 | 0, i5 | 0, i8 | 0) | 0;
    }
    HEAP8[i3 + i8 >> 0] = 0;
    i8 = HEAP8[i13 >> 0] | 0;
    i3 = i8 << 24 >> 24 < 0;
    i7 = i3 ? HEAP32[i15 >> 2] | 0 : i15;
    i8 = i3 ? HEAP32[i14 >> 2] | 0 : i8 & 255;
    i3 = HEAP8[i11 >> 0] | 0;
    i5 = i3 << 24 >> 24 < 0;
    if (i5) i6 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
    do if (i8 >>> 0 > i6 >>> 0) {
     i17 = i5 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i6, i8 - i6 | 0, i17, 0, i17, i8, i7);
    } else {
     i3 = i5 ? HEAP32[i9 >> 2] | 0 : i10;
     if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i3 + i8 >> 0] = 0;
     if ((HEAP8[i11 >> 0] | 0) < 0) {
      HEAP32[i12 >> 2] = i8;
      break;
     } else {
      HEAP8[i11 >> 0] = i8;
      break;
     }
    } while (0);
    do if ((i65 | 0) != (i15 | 0)) {
     i8 = HEAP8[i31 >> 0] | 0;
     i3 = i8 << 24 >> 24 < 0;
     i7 = i3 ? HEAP32[i65 >> 2] | 0 : i65;
     i8 = i3 ? HEAP32[i46 >> 2] | 0 : i8 & 255;
     i3 = HEAP8[i13 >> 0] | 0;
     i5 = i3 << 24 >> 24 < 0;
     if (i5) i6 = (HEAP32[i15 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
     if (i8 >>> 0 > i6 >>> 0) {
      i17 = i5 ? HEAP32[i14 >> 2] | 0 : i3 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i6, i8 - i6 | 0, i17, 0, i17, i8, i7);
      break;
     }
     i3 = i5 ? HEAP32[i15 >> 2] | 0 : i15;
     if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i3 + i8 >> 0] = 0;
     if ((HEAP8[i13 >> 0] | 0) < 0) {
      HEAP32[i14 >> 2] = i8;
      break;
     } else {
      HEAP8[i13 >> 0] = i8;
      break;
     }
    } while (0);
    if ((HEAP8[i31 >> 0] | 0) < 0) {
     i17 = HEAP32[i65 >> 2] | 0;
     i16 = HEAP32[i26 >> 2] | 0;
     HEAP32[i64 >> 2] = 66;
     HEAP32[i47 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i64);
    }
    i1 = i1 + 1 | 0;
   } while (0);
   if (!i1) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI8UnityStrS2_EEPS2_EEbT0_S6_T_(i59, i4, i42) | 0;
    i1 = i4 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI8UnityStrS2_EEPS2_EEbT0_S6_T_(i1, i2, i42) | 0) {
     i58 = 278;
     break;
    }
    if (i3) continue;
   }
   i17 = i4;
   if ((i17 - i18 | 0) >= (i19 - i17 | 0)) {
    i58 = 277;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i59, i4, i42);
   i1 = i4 + 16 | 0;
  }
  if ((i58 | 0) == 277) {
   i58 = 0;
   __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i4 + 16 | 0, i2, i42);
   i1 = i59;
   i2 = i4;
   continue;
  } else if ((i58 | 0) == 278) {
   i58 = 0;
   if (i3) {
    i58 = 279;
    break;
   } else {
    i1 = i59;
    i2 = i4;
    continue;
   }
  }
 }
 if ((i58 | 0) == 5) {
  i3 = HEAP8[i62 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i63 >> 2] | 0 : i3 & 255;
  i9 = i59 + 11 | 0;
  i6 = HEAP8[i9 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  i10 = i59 + 4 | 0;
  i6 = i5 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
  i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
  if (!i1) i58 = 7; else {
   i4 = HEAP32[i59 >> 2] | 0;
   i1 = _memcmp(i2 ? HEAP32[i61 >> 2] | 0 : i61, i5 ? i4 : i59, i1) | 0;
   if (!i1) i58 = 7; else if ((i1 | 0) < 0) {
    i7 = i59;
    i8 = i59;
    i1 = i4;
   } else {
    STACKTOP = i66;
    return;
   }
  }
  do if ((i58 | 0) == 7) if (i3 >>> 0 < i6 >>> 0) {
   i7 = i59;
   i8 = i59;
   i1 = HEAP32[i59 >> 2] | 0;
   break;
  } else {
   STACKTOP = i66;
   return;
  } while (0);
  i2 = i5 ? i1 : i7;
  HEAP32[i65 >> 2] = 0;
  HEAP32[i65 + 4 >> 2] = 0;
  HEAP32[i65 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i65 + 12 >> 2] = i1;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i65);
   i1 = HEAP32[i65 + 12 >> 2] | 0;
   i58 = 13;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i65 + 11 >> 0] = i6;
   if (!i6) i1 = i65; else {
    i1 = i65;
    i58 = 15;
   }
  } else i58 = 13;
  if ((i58 | 0) == 13) {
   i57 = i6 + 16 & -16;
   HEAP32[i64 >> 2] = 66;
   HEAP32[i64 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i57, 16, i64, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i65 >> 2] = i1;
   HEAP32[i65 + 8 >> 2] = i57 | -2147483648;
   HEAP32[i65 + 4 >> 2] = i6;
   i58 = 15;
  }
  if ((i58 | 0) == 15) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  do if ((i59 | 0) != (i61 | 0)) {
   i5 = HEAP8[i62 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i61 >> 2] | 0 : i61;
   i5 = i1 ? HEAP32[i63 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i9 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i59 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i58 = i2 ? HEAP32[i10 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i59, i3, i5 - i3 | 0, i58, 0, i58, i5, i4);
    break;
   }
   i1 = i2 ? HEAP32[i8 >> 2] | 0 : i7;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i9 >> 0] | 0) < 0) {
    HEAP32[i10 >> 2] = i5;
    break;
   } else {
    HEAP8[i9 >> 0] = i5;
    break;
   }
  } while (0);
  i4 = i65 + 11 | 0;
  do if ((i65 | 0) != (i61 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   i5 = i2 ? HEAP32[i65 >> 2] | 0 : i65;
   i6 = i2 ? HEAP32[i65 + 4 >> 2] | 0 : i6 & 255;
   i2 = HEAP8[i62 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i1 = (HEAP32[i60 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
   if (i6 >>> 0 > i1 >>> 0) {
    i63 = i3 ? HEAP32[i63 >> 2] | 0 : i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i61, i1, i6 - i1 | 0, i63, 0, i63, i6, i5);
    break;
   }
   i1 = i3 ? HEAP32[i61 >> 2] | 0 : i61;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i62 >> 0] | 0) < 0) {
    HEAP32[i63 >> 2] = i6;
    break;
   } else {
    HEAP8[i62 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i63 = HEAP32[i65 >> 2] | 0;
   i65 = HEAP32[i65 + 12 >> 2] | 0;
   HEAP32[i64 >> 2] = 66;
   HEAP32[i64 + 4 >> 2] = i65;
   __Z19free_alloc_internalPvRK10MemLabelId(i63, i64);
  }
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 39) {
  __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i59, i59 + 16 | 0, i61, i42) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 40) {
  __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_(i59, i59 + 16 | 0, i59 + 32 | 0, i61, i42) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 41) {
  __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i59, i59 + 16 | 0, i59 + 32 | 0, i59 + 48 | 0, i61, i42) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 43) {
  __ZNSt3__218__insertion_sort_3IRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i59, i2, i42);
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 279) {
  STACKTOP = i66;
  return;
 }
}

function __ZN12TreeDatabase9Prototype3SetERK4PPtrI10GameObjectEfb(i26, i28, f4, i24) {
 i26 = i26 | 0;
 i28 = i28 | 0;
 f4 = Math_fround(f4);
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i31 + 32 | 0;
 i16 = i31 + 24 | 0;
 i21 = i31 + 16 | 0;
 i20 = i31 + 8 | 0;
 i19 = i31;
 i27 = i31 + 88 | 0;
 i25 = i31 + 80 | 0;
 i30 = i31 + 56 | 0;
 i23 = i31 + 40 | 0;
 i22 = i26 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i1 = HEAP32[i28 >> 2] | 0;
 HEAP32[i26 >> 2] = i1;
 HEAP32[i25 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i29 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
   i2 = HEAP32[i27 >> 2] | 0;
   i18 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 8;
  }
 }
 if ((i29 | 0) == 6) i29 = 8;
 if ((i29 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i26 >> 2] | 0) | 0;
 i12 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30872 | 0) | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i29 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
   i2 = HEAP32[i27 >> 2] | 0;
   i18 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 14; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 16;
  }
 }
 if ((i29 | 0) == 14) i29 = 16;
 if ((i29 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i26 >> 2] | 0) | 0;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31312 | 0) | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i29 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
   i2 = HEAP32[i27 >> 2] | 0;
   i18 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 24;
  }
 }
 if ((i29 | 0) == 22) i29 = 24;
 if ((i29 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i26 >> 2] | 0) | 0;
 i18 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30752 | 0) | 0;
 L37 : do if (!i18) {
  if (i12 | 0) {
   i6 = __ZN10MeshFilter13GetSharedMeshEv(i12) | 0;
   if (i6 | 0) {
    HEAP32[i25 >> 2] = i6;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i29 = 127; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
      i2 = HEAP32[i27 >> 2] | 0;
      i23 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 127; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i29 = 129;
     }
    }
    if ((i29 | 0) == 127) i29 = 129;
    if ((i29 | 0) == 129) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
    if ((i7 | 0) != 0 & (i1 | 0) != 0) {
     i14 = i7 + 288 | 0;
     if (!(__ZL21CheckMaterialsNotNullRK13dynamic_arrayI4PPtrI8MaterialELj4EERKS0_I10GameObjectE(i14, i28) | 0)) {
      STACKTOP = i31;
      return;
     }
     HEAP32[i22 >> 2] = 1;
     i15 = i26 + 16 | 0;
     HEAP32[i15 >> 2] = __ZN10MeshFilter13GetSharedMeshEv(i12) | 0;
     i13 = i7 + 300 | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     HEAP32[i27 >> 2] = 0;
     __ZN13dynamic_arrayIP8MaterialLj4EE18resize_initializedEjRKS1_12ResizePolicy(i26 + 116 | 0, i1, i27, 1);
     i1 = HEAP32[i13 >> 2] | 0;
     HEAP32[i27 >> 2] = 0;
     __ZN13dynamic_arrayIP8MaterialLj4EE18resize_initializedEjRKS1_12ResizePolicy(i26 + 76 | 0, i1, i27, 1);
     i1 = i26 + 96 | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     i3 = i26 + 108 | 0;
     HEAP32[i3 >> 2] = i2;
     i6 = i26 + 112 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     do if ((i7 & 2147483647) >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i2;
      HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 4, 4, i26 + 100 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i26 + 100 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i23 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
      HEAP32[i6 >> 2] = i2;
      HEAP32[i1 >> 2] = i23;
      break;
     } while (0);
     i1 = i26 + 56 | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     i3 = i26 + 68 | 0;
     HEAP32[i3 >> 2] = i2;
     i6 = i26 + 72 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     do if ((i7 & 2147483647) >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i2;
      HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 2, 4, i26 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i26 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i23 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
      HEAP32[i6 >> 2] = i2;
      HEAP32[i1 >> 2] = i23;
      break;
     } while (0);
     if (HEAP32[i13 >> 2] | 0) {
      i12 = i30 + 11 | 0;
      i7 = 0;
      do {
       i6 = (HEAP32[i14 >> 2] | 0) + (i7 << 2) | 0;
       i1 = HEAP32[i6 >> 2] | 0;
       if (!i1) i1 = 0; else {
        HEAP32[i25 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i1) i29 = 157; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
          i2 = HEAP32[i27 >> 2] | 0;
          i23 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
          i29 = 157;
          break;
         }
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i29 = 159;
        } while (0);
        if ((i29 | 0) == 157) i29 = 159;
        if ((i29 | 0) == 159) {
         i29 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
        }
       }
       if (!(__ZN12TreeDatabase9Prototype11SetMaterialEiP8Material(i26, i7, i1) | 0)) {
        HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i1) i29 = 167; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
          i2 = HEAP32[i27 >> 2] | 0;
          i23 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
          i29 = 167;
          break;
         }
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i29 = 169;
        } while (0);
        if ((i29 | 0) == 167) i29 = 169;
        if ((i29 | 0) == 169) {
         i29 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
        }
        HEAP32[i16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
        __Z6FormatPKcz(i30, gb + 933663 | 0, i16);
        i1 = HEAP32[i28 >> 2] | 0;
        do if (!i1) i1 = 0; else {
         HEAP32[i25 >> 2] = i1;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i1) i29 = 176; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i2 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[i1 + 32 >> 2] | 0;
           i1 = i2 + (i3 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
           i2 = HEAP32[i27 >> 2] | 0;
           i23 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[gb + 1104264 >> 2] | 0;
           i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
           i2 = HEAP32[i3 + 28 >> 2] | 0;
           i3 = HEAP32[i3 + 32 >> 2] | 0;
          }
          if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
           i29 = 176;
           break;
          }
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i29 = 178;
         } while (0);
         if ((i29 | 0) == 176) i29 = 178;
         if ((i29 | 0) == 178) {
          i29 = 0;
          i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
         }
         if (!i1) {
          i1 = 0;
          break;
         }
         i1 = HEAP32[i1 + 4 >> 2] | 0;
        } while (0);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 0, gb + 933103 | 0, 140, 512, i1, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
       }
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
     }
     i6 = i26 + 20 | 0;
     HEAP32[i25 >> 2] = HEAP32[i15 >> 2];
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 147; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
       i2 = HEAP32[i27 >> 2] | 0;
       i23 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 147; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 149;
      }
     }
     if ((i29 | 0) == 147) i29 = 149;
     if ((i29 | 0) == 149) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i15 >> 2] | 0) | 0;
     i23 = i1 + 48 | 0;
     HEAP32[i6 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
     f11 = Math_fround(HEAPF32[i6 >> 2]);
     f8 = Math_fround(HEAPF32[i26 + 32 >> 2]);
     f34 = Math_fround(f11 - f8);
     f10 = Math_fround(HEAPF32[i26 + 24 >> 2]);
     f5 = Math_fround(HEAPF32[i26 + 36 >> 2]);
     f9 = Math_fround(HEAPF32[i26 + 28 >> 2]);
     f32 = Math_fround(HEAPF32[i26 + 40 >> 2]);
     f35 = Math_fround(f9 - f32);
     f37 = Math_fround(f11 + f8);
     f36 = Math_fround(f9 + f32);
     HEAPF32[i26 + 140 >> 2] = Math_fround(f10 + f5);
     f33 = Math_fround(f5 * Math_fround(2.0));
     HEAPF32[i26 + 136 >> 2] = f33;
     f34 = Math_fround(Math_abs(Math_fround(f34)));
     f37 = Math_fround(Math_abs(Math_fround(f37)));
     f34 = f34 < f37 ? f37 : f34;
     f35 = Math_fround(Math_abs(Math_fround(f35)));
     f36 = Math_fround(Math_abs(Math_fround(f36)));
     f35 = f35 < f36 ? f36 : f35;
     f34 = Math_fround((f34 < f35 ? f35 : f34) * Math_fround(1.89999998));
     HEAPF32[i26 + 144 >> 2] = f34;
     HEAPF32[i26 + 148 >> 2] = Math_fround(f34 / f33);
     HEAPF32[i26 + 152 >> 2] = f4;
     f4 = f32;
     break;
    }
   }
  }
  HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i29 = 188; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
    i2 = HEAP32[i27 >> 2] | 0;
    i26 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i26 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i26 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 188; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i29 = 190;
   }
  }
  if ((i29 | 0) == 188) i29 = 190;
  if ((i29 | 0) == 190) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
  HEAP32[i13 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i30, gb + 933775 | 0, i13);
  i1 = HEAP32[i28 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i27 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i29 = 197; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i27);
     i2 = HEAP32[i13 >> 2] | 0;
     i27 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 197; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i29 = 199;
    }
   }
   if ((i29 | 0) == 197) i29 = 199;
   if ((i29 | 0) == 199) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i30 + 11 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 0, gb + 933103 | 0, 160, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
  STACKTOP = i31;
  return;
 } else {
  i16 = i18 + 56 | 0;
  i17 = i18 + 60 | 0;
  L164 : do if (((HEAP32[i17 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) > 0) {
   i15 = 0;
   i1 = 0;
   L166 : while (1) {
    i2 = __ZNK8LODGroup6GetLODEi(i18, i15) | 0;
    i14 = i2 + 20 | 0;
    if (HEAP32[i14 >> 2] | 0) {
     i13 = i2 + 8 | 0;
     i12 = 0;
     do {
      i6 = (__Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E((HEAP32[i13 >> 2] | 0) + (i12 << 2) | 0) | 0) == 0;
      i7 = (HEAP32[i13 >> 2] | 0) + (i12 << 2) | 0;
      if (i6) {
       i1 = __Z17dynamic_pptr_castIP17BillboardRenderer8RendererET_RK4PPtrIT0_E(i7) | 0;
       if (!i1) {
        i29 = 41;
        break L166;
       }
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) {
        i29 = 41;
        break L166;
       }
       HEAP32[i25 >> 2] = i1;
       i2 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i2) i29 = 38; else {
        if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
         i3 = HEAP32[i2 + 28 >> 2] | 0;
         i6 = HEAP32[i2 + 32 >> 2] | 0;
         i2 = i3 + (i6 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i25);
         i3 = HEAP32[i27 >> 2] | 0;
         i7 = HEAP32[i2 + 28 >> 2] | 0;
         i6 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
         i3 = HEAP32[i6 + 28 >> 2] | 0;
         i6 = HEAP32[i6 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i3 + (i6 << 3) | 0)) i29 = 38; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i29 = 40;
       }
       if ((i29 | 0) == 38) i29 = 40;
       if ((i29 | 0) == 40) {
        i29 = 0;
        if (!(__Z31ReadObjectFromPersistentManageri(i1) | 0)) {
         i29 = 41;
         break L166;
        }
       }
       if ((i15 | 0) != ((((HEAP32[i17 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) / 28 | 0) + -1 | 0)) {
        i29 = 62;
        break L166;
       }
      } else {
       HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
       i2 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i2) i29 = 87; else {
        if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
         i3 = HEAP32[i2 + 28 >> 2] | 0;
         i6 = HEAP32[i2 + 32 >> 2] | 0;
         i2 = i3 + (i6 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i25);
         i3 = HEAP32[i27 >> 2] | 0;
         i38 = HEAP32[i2 + 28 >> 2] | 0;
         i6 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i3 | 0) == -1 ? i38 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i38 + (i3 << 3) | 0;
         i3 = HEAP32[i6 + 28 >> 2] | 0;
         i6 = HEAP32[i6 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i3 + (i6 << 3) | 0)) i29 = 87; else {
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i29 = 89;
        }
       }
       if ((i29 | 0) == 87) i29 = 89;
       if ((i29 | 0) == 89) {
        i29 = 0;
        i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
       }
       if (!(__ZL21CheckMaterialsNotNullRK13dynamic_arrayI4PPtrI8MaterialELj4EERKS0_I10GameObjectE(i2 + 288 | 0, i28) | 0)) {
        i29 = 215;
        break L166;
       }
      }
      i12 = i12 + 1 | 0;
     } while (i12 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
    }
    i15 = i15 + 1 | 0;
    if ((i15 | 0) >= (((HEAP32[i17 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) / 28 | 0 | 0)) {
     i6 = i1;
     break L164;
    }
   }
   if ((i29 | 0) == 41) {
    HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i29 = 46; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
      i2 = HEAP32[i27 >> 2] | 0;
      i38 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 46; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i29 = 48;
     }
    }
    if ((i29 | 0) == 46) i29 = 48;
    if ((i29 | 0) == 48) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
    HEAP32[i19 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    __Z6FormatPKcz(i30, gb + 933373 | 0, i19);
    i1 = HEAP32[i28 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i27 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 55; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i19, i1, i27);
       i2 = HEAP32[i19 >> 2] | 0;
       i38 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 55; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 57;
      }
     }
     if ((i29 | 0) == 55) i29 = 57;
     if ((i29 | 0) == 57) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
     if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i30 + 11 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 0, gb + 933103 | 0, 87, 512, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
    STACKTOP = i31;
    return;
   } else if ((i29 | 0) == 62) {
    HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i29 = 67; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
      i2 = HEAP32[i27 >> 2] | 0;
      i38 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 67; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i29 = 69;
     }
    }
    if ((i29 | 0) == 67) i29 = 69;
    if ((i29 | 0) == 69) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
    HEAP32[i20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    __Z6FormatPKcz(i30, gb + 933504 | 0, i20);
    i1 = HEAP32[i28 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i27 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 76; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i27);
       i2 = HEAP32[i20 >> 2] | 0;
       i38 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 76; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 78;
      }
     }
     if ((i29 | 0) == 76) i29 = 78;
     if ((i29 | 0) == 78) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
     if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i30 + 11 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 0, gb + 933103 | 0, 93, 512, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
    STACKTOP = i31;
    return;
   } else if ((i29 | 0) == 215) {
    STACKTOP = i31;
    return;
   }
  } else i6 = 0; while (0);
  HEAP32[i30 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f37 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i1 = i30 + 12 | 0;
  HEAPF32[i1 >> 2] = f37;
  i2 = i30 + 16 | 0;
  HEAPF32[i2 >> 2] = f4;
  i3 = i30 + 20 | 0;
  HEAPF32[i3 >> 2] = f9;
  __Z23GetLODGroupAABBUnawakenR10MinMaxAABBRK8LODGroup(i30, i18);
  f9 = Math_fround(HEAPF32[i30 >> 2]);
  f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
  if (f9 == f4) {
   f37 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   if (f37 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
    f37 = Math_fround(HEAPF32[i30 + 8 >> 2]);
    if (!(f37 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2]))) i29 = 96;
   } else i29 = 96;
  } else i29 = 96;
  do if ((i29 | 0) == 96) {
   f37 = Math_fround(-f4);
   f8 = Math_fround(HEAPF32[i1 >> 2]);
   if (f8 == f37) {
    f37 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
    f36 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    f4 = Math_fround(HEAPF32[i3 >> 2]);
    if (!(f5 != f36 | f4 != f37)) break;
   } else {
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    f4 = Math_fround(HEAPF32[i3 >> 2]);
   }
   f11 = Math_fround(f9 + f8);
   f35 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   f10 = Math_fround(f35 + f5);
   f36 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f11 = Math_fround(f11 * Math_fround(.5));
   f10 = Math_fround(f10 * Math_fround(.5));
   f37 = Math_fround(Math_fround(f36 + f4) * Math_fround(.5));
   f8 = Math_fround(Math_fround(f8 - f9) * Math_fround(.5));
   f5 = Math_fround(Math_fround(f5 - f35) * Math_fround(.5));
   f4 = Math_fround(Math_fround(f4 - f36) * Math_fround(.5));
   HEAPF32[i26 + 20 >> 2] = f11;
   HEAPF32[i26 + 24 >> 2] = f10;
   HEAPF32[i26 + 28 >> 2] = f37;
   HEAPF32[i26 + 32 >> 2] = f8;
   HEAPF32[i26 + 36 >> 2] = f5;
   HEAPF32[i26 + 40 >> 2] = f4;
   HEAP32[i22 >> 2] = 2;
   HEAP32[i26 + 8 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i26 + 12 >> 2] = i6;
   f9 = f37;
   break L37;
  } while (0);
  HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i29 = 104; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
    i2 = HEAP32[i27 >> 2] | 0;
    i38 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 104; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i29 = 106;
   }
  }
  if ((i29 | 0) == 104) i29 = 106;
  if ((i29 | 0) == 106) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
  HEAP32[i21 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i23, gb + 933589 | 0, i21);
  i1 = HEAP32[i28 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i27 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i29 = 113; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i27);
     i2 = HEAP32[i21 >> 2] | 0;
     i38 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 113; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i29 = 115;
    }
   }
   if ((i29 | 0) == 113) i29 = 115;
   if ((i29 | 0) == 115) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 933103 | 0, 110, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  STACKTOP = i31;
  return;
 } while (0);
 i13 = i26 + 44 | 0;
 if (i24) {
  HEAP32[i30 >> 2] = HEAP32[gb + 62512 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  i1 = i26 + 24 | 0;
  i2 = i26 + 28 | 0;
  i3 = i26 + 32 | 0;
  i6 = i26 + 36 | 0;
  i7 = i26 + 40 | 0;
  i12 = i26 + 20 | 0;
 } else {
  HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i29 = 210; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i1, i25);
    i2 = HEAP32[i27 >> 2] | 0;
    i38 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i38 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i38 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 210; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i29 = 212;
   }
  }
  if ((i29 | 0) == 210) i29 = 212;
  if ((i29 | 0) == 212) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i30, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
  i12 = i26 + 20 | 0;
  f11 = Math_fround(HEAPF32[i12 >> 2]);
  i1 = i26 + 24 | 0;
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i26 + 28 | 0;
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i26 + 32 | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i6 = i26 + 36 | 0;
  f5 = Math_fround(HEAPF32[i6 >> 2]);
  i38 = i26 + 40 | 0;
  i7 = i38;
  f4 = Math_fround(HEAPF32[i38 >> 2]);
 };
 HEAP32[i13 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 f35 = Math_fround(HEAPF32[i13 >> 2]);
 HEAPF32[i12 >> 2] = Math_fround(f35 * f11);
 f36 = Math_fround(HEAPF32[i26 + 48 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f36 * f10);
 f37 = Math_fround(HEAPF32[i26 + 52 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(f37 * f9);
 HEAPF32[i3 >> 2] = Math_fround(f35 * f8);
 HEAPF32[i6 >> 2] = Math_fround(f36 * f5);
 HEAPF32[i7 >> 2] = Math_fround(f37 * f4);
 STACKTOP = i31;
 return;
}

function __ZN10systeminfo19ISOToSystemLanguageERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i11 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i10 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i10 & 255;
 i9 = i10 >>> 0 < 2;
 if (i9) {
  i11 = 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L4 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L6 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 97) {
      i2 = gb + 455024 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L4;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455024 + 2 | 0)) break L6;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L4;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 0 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L20 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L22 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 97) {
      i2 = gb + 455027 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L20;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455027 + 2 | 0)) break L22;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L20;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 1 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L36 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L38 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 101) {
      i2 = gb + 455030 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L36;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455030 + 2 | 0)) break L38;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L36;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 2 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L52 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L54 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 98) {
      i2 = gb + 455033 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L52;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455033 + 2 | 0)) break L54;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L52;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 3 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L68 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L70 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 98) {
      i2 = gb + 455036 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L68;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455036 + 2 | 0)) break L70;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L68;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 4 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L84 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L86 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 99) {
      i2 = gb + 455039 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L84;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455039 + 2 | 0)) break L86;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L84;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 5 : 42;
  return i11 | 0;
 }
 i7 = i11 + i10 | 0;
 i6 = i7;
 i8 = i11;
 L100 : do if ((i10 | 0) < 2) i1 = i6; else {
  i4 = i7 + -1 | 0;
  if ((i4 | 0) == (i11 | 0)) i1 = i6; else {
   i1 = i11;
   L102 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 122) {
      i2 = gb + 455042 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i6;
      break L100;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455042 + 2 | 0)) break L102;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i6;
     break L100;
    }
   }
  }
 } while (0);
 if (!((i1 | 0) == (i7 | 0) | (i1 - i8 | 0) == -1)) {
  i5 = i10 >>> 0 < 4;
  if (i5) {
   i11 = 6;
   return i11 | 0;
  }
  L118 : do if ((i10 | 0) < 4) i1 = i6; else {
   i4 = i7 + -3 | 0;
   if ((i4 | 0) == (i11 | 0)) i1 = i6; else {
    i1 = i11;
    L120 : while (1) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == 104) {
       i2 = gb + 455045 | 0;
       i3 = i1;
       break;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i6;
       break L118;
      }
     }
     do {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (gb + 455045 + 4 | 0)) break L120;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i6;
      break L118;
     }
    }
   }
  } while (0);
  i1 = (i1 - i8 | 0) != -1 & (i1 | 0) != (i7 | 0);
  if (i1 | i5) {
   i11 = i1 ? 40 : 6;
   return i11 | 0;
  }
  L134 : do if ((i10 | 0) < 4) i1 = i6; else {
   i4 = i7 + -3 | 0;
   if ((i4 | 0) == (i11 | 0)) {
    i1 = i6;
    break;
   } else i1 = i11;
   L136 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 104) {
      i2 = gb + 455050 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i6;
      break L134;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455050 + 4 | 0)) break L136;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i6;
     break L134;
    }
   }
  } while (0);
  i11 = (i1 | 0) == (i7 | 0) | (i1 - i8 | 0) == -1 ? 6 : 41;
  return i11 | 0;
 }
 if (i9) {
  i11 = 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L152 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) i1 = i4; else {
   i1 = i11;
   L154 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 99) {
      i2 = gb + 455055 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) {
      i1 = i4;
      break L152;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 455055 + 2 | 0)) break L154;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L152;
    }
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 7 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L168 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L170 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 100) {
     i2 = gb + 455058 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L168;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455058 + 2 | 0)) break L170;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L168;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 8 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L184 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L186 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 110) {
     i2 = gb + 455061 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L184;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455061 + 2 | 0)) break L186;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L184;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 9 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L200 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L202 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = gb + 455064 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L200;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455064 + 2 | 0)) break L202;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L200;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 10 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L216 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L218 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = gb + 455067 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L216;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455067 + 2 | 0)) break L218;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L216;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 11 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L232 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L234 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 102) {
     i2 = gb + 455070 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L232;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455070 + 2 | 0)) break L234;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L232;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 12 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L248 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L250 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 102) {
     i2 = gb + 455073 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L248;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455073 + 2 | 0)) break L250;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L248;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 13 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L264 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L266 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 102) {
     i2 = gb + 455076 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L264;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455076 + 2 | 0)) break L266;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L264;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 14 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L280 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L282 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 100) {
     i2 = gb + 455079 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L280;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455079 + 2 | 0)) break L282;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L280;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 15 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L296 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L298 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = gb + 455082 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L296;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455082 + 2 | 0)) break L298;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L296;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 16 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L312 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L314 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 104) {
     i2 = gb + 455085 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L312;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455085 + 2 | 0)) break L314;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L312;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 17 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L328 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L330 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 104) {
     i2 = gb + 455088 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L328;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455088 + 2 | 0)) break L330;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L328;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 18 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L344 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L346 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 105) {
     i2 = gb + 455091 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L344;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455091 + 2 | 0)) break L346;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L344;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 19 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L360 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L362 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 105) {
     i2 = gb + 1086430 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L360;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 1086430 + 2 | 0)) break L362;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L360;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 20 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L376 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L378 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 105) {
     i2 = gb + 870753 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L376;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 870753 + 2 | 0)) break L378;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L376;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 21 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L392 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L394 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 106) {
     i2 = gb + 455094 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L392;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455094 + 2 | 0)) break L394;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L392;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 22 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L408 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L410 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 107) {
     i2 = gb + 455097 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L408;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455097 + 2 | 0)) break L410;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L408;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 23 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L424 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L426 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 108) {
     i2 = gb + 455100 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L424;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455100 + 2 | 0)) break L426;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L424;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 24 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L440 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L442 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 108) {
     i2 = gb + 455103 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L440;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455103 + 2 | 0)) break L442;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L440;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 25 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L456 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L458 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 110) {
     i2 = gb + 488717 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L456;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 488717 + 2 | 0)) break L458;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L456;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 26 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L472 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L474 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 112) {
     i2 = gb + 455106 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L472;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455106 + 2 | 0)) break L474;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L472;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 27 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L488 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L490 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 112) {
     i2 = gb + 455109 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L488;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455109 + 2 | 0)) break L490;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L488;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 28 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L504 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L506 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 114) {
     i2 = gb + 455112 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L504;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455112 + 2 | 0)) break L506;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L504;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 29 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L520 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L522 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 114) {
     i2 = gb + 455115 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L520;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455115 + 2 | 0)) break L522;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L520;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 30 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L536 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L538 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 115) {
     i2 = gb + 455118 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L536;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455118 + 2 | 0)) break L538;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L536;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 31 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L552 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L554 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 115) {
     i2 = gb + 455121 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L552;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455121 + 2 | 0)) break L554;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L552;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 32 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L568 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L570 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 115) {
     i2 = gb + 455124 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L568;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455124 + 2 | 0)) break L570;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L568;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 33 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L584 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L586 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = gb + 455127 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L584;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455127 + 2 | 0)) break L586;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L584;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 34 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L600 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L602 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 115) {
     i2 = gb + 455130 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L600;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455130 + 2 | 0)) break L602;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L600;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 35 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L616 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L618 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 116) {
     i2 = gb + 455133 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L616;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455133 + 2 | 0)) break L618;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L616;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 36 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L632 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L634 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 116) {
     i2 = gb + 455136 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L632;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455136 + 2 | 0)) break L634;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L632;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 37 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i4 = i6;
 i7 = i11;
 L648 : do if ((i10 | 0) < 2) i1 = i4; else {
  i5 = i6 + -1 | 0;
  if ((i5 | 0) == (i11 | 0)) {
   i1 = i4;
   break;
  } else i1 = i11;
  L650 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 117) {
     i2 = gb + 455139 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = i4;
     break L648;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455139 + 2 | 0)) break L650;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i4;
    break L648;
   }
  }
 } while (0);
 i1 = (i1 - i7 | 0) != -1 & (i1 | 0) != (i6 | 0);
 if (i1 | i9) {
  i11 = i1 ? 38 : 42;
  return i11 | 0;
 }
 i6 = i11 + i10 | 0;
 i5 = i6;
 i7 = i11;
 L664 : do if ((i10 | 0) < 2) i1 = i5; else {
  i4 = i6 + -1 | 0;
  if ((i4 | 0) == (i11 | 0)) {
   i1 = i5;
   break;
  } else i1 = i11;
  L666 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 118) {
     i2 = gb + 455142 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L664;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 455142 + 2 | 0)) break L666;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i5;
    break L664;
   }
  }
 } while (0);
 i11 = (i1 | 0) == (i6 | 0) | (i1 - i7 | 0) == -1 ? 42 : 39;
 return i11 | 0;
}

function __ZN5physx28PxcContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i1, i11, i4, i131, i2, i3, i133) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i131 = i131 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i133 = i133 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, f103 = f0, f104 = f0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, f113 = f0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i132 = 0, i134 = 0;
 i134 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i123 = i134 + 240 | 0;
 i88 = i134 + 216 | 0;
 i97 = i134 + 208 | 0;
 i96 = i134 + 180 | 0;
 i98 = i134 + 152 | 0;
 i119 = i134 + 128 | 0;
 i118 = i134 + 120 | 0;
 i127 = i134 + 104 | 0;
 i122 = i134 + 92 | 0;
 i128 = i134 + 88 | 0;
 i130 = i134 + 84 | 0;
 i108 = i134 + 72 | 0;
 i120 = i134 + 60 | 0;
 i124 = i134 + 56 | 0;
 i126 = i134 + 44 | 0;
 i132 = i134 + 32 | 0;
 i129 = i134 + 28 | 0;
 i121 = i134 + 16 | 0;
 i125 = i134 + 12 | 0;
 i109 = i134;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i114 = i123 + 12 | 0;
 HEAP32[i114 >> 2] = i12;
 i115 = i123 + 16 | 0;
 HEAP32[i115 >> 2] = i11;
 i116 = i11 + 8 | 0;
 i117 = i123 + 4 | 0;
 HEAPF32[i117 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i116 >> 2]));
 i110 = i11 + 12 | 0;
 f52 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i110 >> 2]));
 HEAPF32[i123 >> 2] = f52;
 i111 = i11 + 16 | 0;
 f76 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i111 >> 2]));
 i112 = i123 + 8 | 0;
 HEAPF32[i112 >> 2] = f76;
 f113 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f45 = Math_fround(f113 + Math_fround(HEAPF32[i2 >> 2]));
 i100 = i1 + 8 | 0;
 f80 = Math_fround(HEAPF32[i100 >> 2]);
 f104 = Math_fround(f113 * Math_fround(.100000001));
 f52 = Math_fround(Math_abs(Math_fround(f52)));
 f76 = Math_fround(Math_abs(Math_fround(f76)));
 f48 = Math_fround(-Math_fround(HEAPF32[i131 >> 2]));
 i105 = i131 + 4 | 0;
 f78 = Math_fround(-Math_fround(HEAPF32[i105 >> 2]));
 i106 = i131 + 8 | 0;
 f7 = Math_fround(-Math_fround(HEAPF32[i106 >> 2]));
 i107 = i131 + 12 | 0;
 f10 = Math_fround(HEAPF32[i107 >> 2]);
 i85 = i4 + 16 | 0;
 f8 = Math_fround(HEAPF32[i85 >> 2]);
 i93 = i131 + 16 | 0;
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i93 >> 2]));
 i84 = i4 + 20 | 0;
 f58 = Math_fround(HEAPF32[i84 >> 2]);
 i94 = i131 + 20 | 0;
 f58 = Math_fround(f58 - Math_fround(HEAPF32[i94 >> 2]));
 i82 = i4 + 24 | 0;
 f79 = Math_fround(HEAPF32[i82 >> 2]);
 i95 = i131 + 24 | 0;
 f8 = Math_fround(f8 * Math_fround(2.0));
 f58 = Math_fround(f58 * Math_fround(2.0));
 f79 = Math_fround(Math_fround(f79 - Math_fround(HEAPF32[i95 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f50 = Math_fround(Math_fround(Math_fround(f8 * f48) + Math_fround(f58 * f78)) + Math_fround(f79 * f7));
 f49 = Math_fround(f10 * Math_fround(Math_fround(f79 * f78) - Math_fround(f58 * f7)));
 f46 = Math_fround(f50 * f48);
 f6 = Math_fround(Math_fround(f50 * f78) + Math_fround(Math_fround(f9 * f58) + Math_fround(f10 * Math_fround(Math_fround(f8 * f7) - Math_fround(f79 * f48)))));
 f58 = Math_fround(f10 * Math_fround(Math_fround(f58 * f48) - Math_fround(f8 * f78)));
 f50 = Math_fround(f50 * f7);
 f77 = Math_fround(HEAPF32[i4 >> 2]);
 f51 = Math_fround(f10 * f77);
 i90 = i4 + 12 | 0;
 f5 = Math_fround(HEAPF32[i90 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f5 * f48));
 i99 = i4 + 8 | 0;
 f47 = Math_fround(HEAPF32[i99 >> 2]);
 f51 = Math_fround(f51 + Math_fround(f47 * f78));
 i101 = i4 + 4 | 0;
 f53 = Math_fround(HEAPF32[i101 >> 2]);
 f51 = Math_fround(f51 - Math_fround(f53 * f7));
 f81 = Math_fround(Math_fround(Math_fround(f53 * f48) + Math_fround(Math_fround(f5 * f7) + Math_fround(f10 * f47))) - Math_fround(f77 * f78));
 f103 = Math_fround(f45 * f45);
 f104 = Math_fround(f104 * f104);
 f52 = Math_fround(f45 * f52);
 f76 = Math_fround(f45 * f76);
 f49 = Math_fround(f46 + Math_fround(Math_fround(f9 * f8) + f49));
 f50 = Math_fround(Math_fround(Math_fround(f9 * f79) + f58) + f50);
 f58 = Math_fround(Math_fround(Math_fround(f77 * f7) + Math_fround(Math_fround(f5 * f78) + Math_fround(f10 * f53))) - Math_fround(f47 * f48));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f5) - Math_fround(f77 * f48)) - Math_fround(f53 * f78)) - Math_fround(f47 * f7));
 f47 = Math_fround(f80 * Math_fround(-2.0));
 f78 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
 f53 = Math_fround(f58 * Math_fround(0.0));
 f48 = Math_fround(f81 * Math_fround(0.0));
 f77 = Math_fround(f48 + Math_fround(Math_fround(f47 * f51) + f53));
 f5 = Math_fround(f7 * Math_fround(f53 - f48));
 f10 = Math_fround(f78 * Math_fround(0.0));
 f79 = Math_fround(f51 * Math_fround(0.0));
 f9 = Math_fround(f49 + Math_fround(Math_fround(f51 * f77) + Math_fround(Math_fround(f47 * f78) + f5)));
 f8 = Math_fround(f6 + Math_fround(Math_fround(f10 + Math_fround(f7 * Math_fround(Math_fround(f47 * f81) - f79))) + Math_fround(f58 * f77)));
 f77 = Math_fround(f50 + Math_fround(Math_fround(f10 + Math_fround(f7 * Math_fround(f79 - Math_fround(f47 * f58)))) + Math_fround(f81 * f77)));
 HEAPF32[i88 >> 2] = f9;
 i83 = i88 + 4 | 0;
 HEAPF32[i83 >> 2] = f8;
 i87 = i88 + 8 | 0;
 HEAPF32[i87 >> 2] = f77;
 i89 = i88 + 12 | 0;
 f80 = Math_fround(f80 * Math_fround(2.0));
 f53 = Math_fround(f48 + Math_fround(Math_fround(f80 * f51) + f53));
 f5 = Math_fround(f49 + Math_fround(Math_fround(f51 * f53) + Math_fround(Math_fround(f80 * f78) + f5)));
 f6 = Math_fround(f6 + Math_fround(Math_fround(f10 + Math_fround(f7 * Math_fround(Math_fround(f80 * f81) - f79))) + Math_fround(f58 * f53)));
 f53 = Math_fround(f50 + Math_fround(Math_fround(f10 + Math_fround(f7 * Math_fround(f79 - Math_fround(f80 * f58)))) + Math_fround(f81 * f53)));
 HEAPF32[i89 >> 2] = f5;
 i86 = i88 + 16 | 0;
 HEAPF32[i86 >> 2] = f6;
 i1 = i88 + 20 | 0;
 HEAPF32[i1 >> 2] = f53;
 HEAP32[i97 >> 2] = 0;
 HEAPF32[i97 + 4 >> 2] = f113;
 f9 = Math_fround(f9 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f77 = Math_fround(f77 * Math_fround(2.0));
 f81 = Math_fround(HEAPF32[i107 >> 2]);
 f58 = Math_fround(Math_fround(f81 * f81) + Math_fround(-.5));
 f80 = Math_fround(HEAPF32[i131 >> 2]);
 f79 = Math_fround(f9 * f80);
 f7 = Math_fround(HEAPF32[i105 >> 2]);
 f79 = Math_fround(f79 + Math_fround(f8 * f7));
 f10 = Math_fround(HEAPF32[i106 >> 2]);
 f79 = Math_fround(f79 + Math_fround(f77 * f10));
 f50 = Math_fround(Math_fround(f80 * f79) + Math_fround(Math_fround(f9 * f58) + Math_fround(f81 * Math_fround(Math_fround(f77 * f7) - Math_fround(f8 * f10)))));
 f78 = Math_fround(Math_fround(f7 * f79) + Math_fround(Math_fround(f8 * f58) + Math_fround(f81 * Math_fround(Math_fround(f9 * f10) - Math_fround(f77 * f80)))));
 f79 = Math_fround(Math_fround(Math_fround(f77 * f58) + Math_fround(f81 * Math_fround(Math_fround(f8 * f80) - Math_fround(f9 * f7)))) + Math_fround(f10 * f79));
 f9 = Math_fround(HEAPF32[i93 >> 2]);
 f50 = Math_fround(f9 + f50);
 f8 = Math_fround(HEAPF32[i94 >> 2]);
 f78 = Math_fround(f8 + f78);
 f77 = Math_fround(HEAPF32[i95 >> 2]);
 f79 = Math_fround(f77 + f79);
 HEAPF32[i96 >> 2] = Math_fround(0.0);
 HEAPF32[i96 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i96 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i96 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i96 + 16 >> 2] = f50;
 HEAPF32[i96 + 20 >> 2] = f78;
 HEAPF32[i96 + 24 >> 2] = f79;
 f5 = Math_fround(f5 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f53 = Math_fround(f53 * Math_fround(2.0));
 f79 = Math_fround(Math_fround(Math_fround(f5 * f80) + Math_fround(f6 * f7)) + Math_fround(f53 * f10));
 f9 = Math_fround(f9 + Math_fround(Math_fround(f80 * f79) + Math_fround(Math_fround(f5 * f58) + Math_fround(f81 * Math_fround(Math_fround(f53 * f7) - Math_fround(f6 * f10))))));
 f8 = Math_fround(f8 + Math_fround(Math_fround(f7 * f79) + Math_fround(Math_fround(f6 * f58) + Math_fround(f81 * Math_fround(Math_fround(f5 * f10) - Math_fround(f53 * f80))))));
 f79 = Math_fround(f77 + Math_fround(Math_fround(Math_fround(f53 * f58) + Math_fround(f81 * Math_fround(Math_fround(f6 * f80) - Math_fround(f5 * f7)))) + Math_fround(f10 * f79)));
 HEAPF32[i98 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i98 + 16 >> 2] = f9;
 HEAPF32[i98 + 20 >> 2] = f8;
 HEAPF32[i98 + 24 >> 2] = f79;
 __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb(i97, i11, i96, i131, i2, i3, i133, 1) | 0;
 __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb(i97, i11, i98, i131, i2, i3, i133, 1) | 0;
 f79 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f79 * Math_fround(2.0));
 f9 = Math_fround(HEAPF32[i90 >> 2]);
 f10 = Math_fround(f9 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f79 * f8) + Math_fround(Math_fround(f9 * f10) + Math_fround(-1.0)));
 f79 = Math_fround(HEAPF32[i99 >> 2]);
 f7 = Math_fround(f79 * f10);
 f5 = Math_fround(HEAPF32[i101 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f8 * f5));
 f5 = Math_fround(Math_fround(f8 * f79) - Math_fround(f10 * f5));
 f10 = Math_fround(HEAPF32[i100 >> 2]);
 f9 = Math_fround(f10 * f9);
 f7 = Math_fround(f10 * f7);
 f5 = Math_fround(f10 * f5);
 f10 = Math_fround(HEAPF32[i85 >> 2]);
 f79 = Math_fround(f10 - f9);
 f8 = Math_fround(HEAPF32[i84 >> 2]);
 f80 = Math_fround(f8 - f7);
 f6 = Math_fround(HEAPF32[i82 >> 2]);
 f81 = Math_fround(f6 - f5);
 i88 = HEAP32[i88 >> 2] | 0;
 HEAP32[i119 >> 2] = i88;
 i82 = i119 + 4 | 0;
 HEAP32[i82 >> 2] = HEAP32[i83 >> 2];
 i83 = i119 + 8 | 0;
 i87 = HEAP32[i87 >> 2] | 0;
 HEAP32[i83 >> 2] = i87;
 i84 = i119 + 12 | 0;
 i89 = HEAP32[i89 >> 2] | 0;
 HEAP32[i84 >> 2] = i89;
 i85 = i119 + 16 | 0;
 HEAP32[i85 >> 2] = HEAP32[i86 >> 2];
 i86 = i119 + 20 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i86 >> 2] = i1;
 i100 = i133 + 4096 | 0;
 i101 = HEAP32[i100 >> 2] | 0;
 f58 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f53 = Math_fround(HEAPF32[i123 >> 2]);
 f58 = Math_fround(f58 * f53);
 f77 = (HEAP32[tempDoublePtr >> 2] = i87, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f78 = Math_fround(HEAPF32[i112 >> 2]);
 f77 = Math_fround(f77 * f78);
 f53 = Math_fround(f53 * (HEAP32[tempDoublePtr >> 2] = i89, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f78 = Math_fround(f78 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f50 = Math_fround(f58 - f52);
 f51 = Math_fround(f53 - f52);
 i1 = ~~Math_fround(Math_floor(Math_fround(f50 < f51 ? f50 : f51)));
 i89 = HEAP32[i12 + 16 >> 2] | 0;
 i87 = i89 + -2 | 0;
 i1 = (i1 | 0) > 0 ? i1 : 0;
 i1 = (i1 | 0) > (i87 | 0) ? i87 : i1;
 f58 = Math_fround(f52 + f58);
 f53 = Math_fround(f52 + f53);
 i87 = ~~Math_fround(Math_ceil(Math_fround(f58 > f53 ? f58 : f53)));
 i89 = i89 + -1 | 0;
 i87 = (i87 | 0) > 0 ? i87 : 0;
 i87 = (i87 | 0) > (i89 | 0) ? i89 : i87;
 f53 = Math_fround(f77 - f76);
 f58 = Math_fround(f78 - f76);
 i89 = ~~Math_fround(Math_floor(Math_fround(f53 < f58 ? f53 : f58)));
 i88 = i12 + 20 | 0;
 i99 = HEAP32[i88 >> 2] | 0;
 i90 = i99 + -2 | 0;
 i89 = (i89 | 0) > 0 ? i89 : 0;
 i89 = (i89 | 0) > (i90 | 0) ? i90 : i89;
 f77 = Math_fround(f76 + f77);
 f78 = Math_fround(f76 + f78);
 i90 = ~~Math_fround(Math_ceil(Math_fround(f77 > f78 ? f77 : f78)));
 i99 = i99 + -1 | 0;
 i90 = (i90 | 0) > 0 ? i90 : 0;
 i90 = (i90 | 0) > (i99 | 0) ? i99 : i90;
 if (i1 >>> 0 <= i87 >>> 0) {
  i91 = i89 >>> 0 > i90 >>> 0;
  i92 = i12 + 36 | 0;
  i93 = i132 + 4 | 0;
  i94 = i132 + 8 | 0;
  i95 = i119 + 12 | 0;
  i96 = i121 + 4 | 0;
  i97 = i121 + 8 | 0;
  i98 = i12 + 40 | 0;
  i99 = (i101 | 0) == 0;
  f78 = Math_fround(Math_fround(f5 + f6) - f81);
  f77 = Math_fround(Math_fround(f8 + f7) - f80);
  f76 = Math_fround(Math_fround(f10 + f9) - f79);
  i73 = i11 + 20 | 0;
  i74 = i109 + 4 | 0;
  i75 = i109 + 8 | 0;
  i61 = i12 + 16 | 0;
  i62 = i118 + 4 | 0;
  i63 = i108 + 4 | 0;
  i64 = i108 + 8 | 0;
  i71 = i122 + 4 | 0;
  i72 = i122 + 8 | 0;
  i65 = i127 + 4 | 0;
  i66 = i127 + 8 | 0;
  i67 = i120 + 4 | 0;
  i68 = i120 + 8 | 0;
  i69 = i126 + 4 | 0;
  i70 = i126 + 8 | 0;
  i60 = i1;
  do {
   if (!i91) {
    i57 = (i60 | 0) == (i87 | 0) ? 1 : 3;
    f58 = Math_fround(i60 >>> 0);
    i59 = i89;
    do {
     i1 = HEAP32[i88 >> 2] | 0;
     i56 = (Math_imul(i1, i60) | 0) + i59 | 0;
     i55 = i56 * 3 | 0;
     i2 = (i59 | 0) == (i90 | 0) ? 2 : 0;
     L9 : do if (i2 >>> 0 < i57 >>> 0) while (1) {
      i12 = i2 + i55 | 0;
      i11 = (i12 >>> 0) / 3 | 0;
      i3 = (i11 >>> 0) / (i1 >>> 0) | 0;
      i4 = (i11 >>> 0) % (i1 >>> 0) | 0;
      switch (i12 + (Math_imul(i11, -3) | 0) | 0) {
      case 0:
       {
        if (i4 >>> 0 < (i1 + -1 | 0) >>> 0) {
         if (!i3) i1 = 0; else {
          i1 = i11 - i1 | 0;
          HEAP32[i118 >> 2] = (i1 << 1 | 1) - ((HEAPU8[(HEAP32[i92 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >>> 7 & 255);
          i1 = 1;
         }
         if (i3 >>> 0 < ((HEAP32[i61 >> 2] | 0) + -1 | 0) >>> 0) {
          HEAP32[i118 + (i1 << 2) >> 2] = (HEAPU8[(HEAP32[i92 >> 2] | 0) + (i11 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i11 << 1;
          i102 = 20;
         } else i102 = 24;
        }
        break;
       }
      case 1:
       {
        if (i4 >>> 0 < (i1 + -1 | 0) >>> 0 ? i3 >>> 0 < ((HEAP32[i61 >> 2] | 0) + -1 | 0) >>> 0 : 0) {
         i3 = i11 << 1;
         HEAP32[i118 >> 2] = i3;
         HEAP32[i62 >> 2] = i3 | 1;
         i102 = 22;
        }
        break;
       }
      case 2:
       {
        if (i3 >>> 0 < ((HEAP32[i61 >> 2] | 0) + -1 | 0) >>> 0) {
         if (!i4) i3 = 0; else {
          HEAP32[i118 >> 2] = (i11 << 1) + -1;
          i3 = 1;
         }
         if (i4 >>> 0 < (i1 + -1 | 0) >>> 0) {
          HEAP32[i118 + (i3 << 2) >> 2] = i11 << 1;
          i1 = i3;
          i102 = 20;
         } else {
          i1 = i3;
          i102 = 24;
         }
        }
        break;
       }
      default:
       {}
      }
      if ((i102 | 0) == 20) if ((i1 | 0) == 1) {
       i3 = HEAP32[i118 >> 2] | 0;
       i102 = 22;
      } else i102 = 25; else if ((i102 | 0) == 24) {
       i102 = 0;
       if ((i1 | 0) == 1) i102 = 25;
      }
      if ((i102 | 0) == 22) {
       i1 = HEAP32[i92 >> 2] | 0;
       if ((HEAP8[i1 + (i3 >>> 1 << 2) + 2 >> 0] & 127) == 127) {
        i1 = i1 + ((HEAP32[i62 >> 2] | 0) >>> 1 << 2) + 3 | 0;
        i4 = 1;
        i11 = 2;
        i102 = 26;
       } else {
        i4 = 1;
        i11 = 2;
        i102 = 27;
       }
      } else if ((i102 | 0) == 25) {
       i3 = HEAP32[i118 >> 2] | 0;
       i1 = (HEAP32[i92 >> 2] | 0) + (i3 >>> 1 << 2) + 2 | 0;
       i4 = 0;
       i11 = 1;
       i102 = 26;
      }
      if ((i102 | 0) == 26) {
       i102 = 0;
       if ((HEAP8[i1 >> 0] & 127) != 127) i102 = 27;
      }
      do if ((i102 | 0) == 27) {
       i102 = 0;
       __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_(i123, i12, i56, i60, i59, i127, i122);
       f53 = Math_fround(HEAPF32[i95 >> 2]);
       f53 = Math_fround(f53 - Math_fround(HEAPF32[i119 >> 2]));
       f5 = Math_fround(HEAPF32[i85 >> 2]);
       f5 = Math_fround(f5 - Math_fround(HEAPF32[i82 >> 2]));
       f9 = Math_fround(HEAPF32[i86 >> 2]);
       f9 = Math_fround(f9 - Math_fround(HEAPF32[i83 >> 2]));
       HEAPF32[i108 >> 2] = f53;
       HEAPF32[i63 >> 2] = f5;
       HEAPF32[i64 >> 2] = f9;
       f9 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i119, i108, i127, i122, i128, i130));
       f5 = Math_fround(HEAPF32[i130 >> 2]);
       if (f5 <= Math_fround(1.0) & (f9 < f103 & f5 >= Math_fround(0.0))) {
        if (i2 | 0) if (f5 == Math_fround(0.0) | f5 == Math_fround(1.0)) break;
        f7 = Math_fround(HEAPF32[i128 >> 2]);
        f53 = Math_fround(HEAPF32[i95 >> 2]);
        f50 = Math_fround(HEAPF32[i119 >> 2]);
        f53 = Math_fround(f53 - f50);
        f52 = Math_fround(HEAPF32[i85 >> 2]);
        f6 = Math_fround(HEAPF32[i82 >> 2]);
        f52 = Math_fround(f52 - f6);
        f51 = Math_fround(HEAPF32[i86 >> 2]);
        f8 = Math_fround(HEAPF32[i83 >> 2]);
        f53 = Math_fround(f50 + Math_fround(f7 * f53));
        f52 = Math_fround(f6 + Math_fround(f7 * f52));
        f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(f51 - f8)));
        f51 = Math_fround(HEAPF32[i122 >> 2]);
        f7 = Math_fround(HEAPF32[i71 >> 2]);
        f51 = Math_fround(f5 * f51);
        f7 = Math_fround(f5 * f7);
        f6 = Math_fround(f5 * Math_fround(HEAPF32[i72 >> 2]));
        f5 = Math_fround(f51 + Math_fround(HEAPF32[i127 >> 2]));
        f7 = Math_fround(f7 + Math_fround(HEAPF32[i65 >> 2]));
        f6 = Math_fround(f6 + Math_fround(HEAPF32[i66 >> 2]));
        f7 = Math_fround(f52 - f7);
        f8 = Math_fround(f8 - f6);
        HEAPF32[i120 >> 2] = Math_fround(f53 - f5);
        HEAPF32[i67 >> 2] = f7;
        HEAPF32[i68 >> 2] = f8;
        f8 = Math_fround(HEAPF32[i98 >> 2]);
        if (!(f7 > Math_fround(0.0) & f8 <= Math_fround(0.0))) if (!(f7 < Math_fround(0.0) & f8 > Math_fround(0.0))) break;
        __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf(i126, i123, HEAPU8[i73 >> 0] | 0, i120, i131, f9, f5, f6, f104, i124);
        f5 = Math_fround(HEAPF32[i126 >> 2]);
        f35 = Math_fround(f5 * Math_fround(2.0));
        f9 = Math_fround(HEAPF32[i69 >> 2]);
        f36 = Math_fround(f9 * Math_fround(2.0));
        f10 = Math_fround(HEAPF32[i70 >> 2]);
        f37 = Math_fround(f10 * Math_fround(2.0));
        f49 = Math_fround(HEAPF32[i107 >> 2]);
        f50 = Math_fround(Math_fround(f49 * f49) + Math_fround(-.5));
        f51 = Math_fround(HEAPF32[i131 >> 2]);
        f33 = Math_fround(f35 * f51);
        f52 = Math_fround(HEAPF32[i105 >> 2]);
        f33 = Math_fround(f33 + Math_fround(f36 * f52));
        f53 = Math_fround(HEAPF32[i106 >> 2]);
        f33 = Math_fround(f33 + Math_fround(f37 * f53));
        f31 = Math_fround(Math_fround(f51 * f33) + Math_fround(Math_fround(f35 * f50) - Math_fround(f49 * Math_fround(Math_fround(f37 * f52) - Math_fround(f36 * f53)))));
        f32 = Math_fround(Math_fround(f52 * f33) + Math_fround(Math_fround(f36 * f50) - Math_fround(f49 * Math_fround(Math_fround(f35 * f53) - Math_fround(f37 * f51)))));
        f33 = Math_fround(Math_fround(Math_fround(f37 * f50) - Math_fround(f49 * Math_fround(Math_fround(f36 * f51) - Math_fround(f35 * f52)))) + Math_fround(f53 * f33));
        i54 = HEAP32[i92 >> 2] | 0;
        i34 = HEAP32[i88 >> 2] | 0;
        i1 = Math_fround(HEAPF32[i98 >> 2]) >= Math_fround(0.0);
        f35 = i1 ? Math_fround(-1.0) : Math_fround(1.0);
        f36 = Math_fround(HEAPF32[i123 >> 2]);
        f37 = Math_fround(f35 * Math_fround(HEAPF32[i117 >> 2]));
        f38 = Math_fround(HEAPF32[i112 >> 2]);
        f39 = Math_fround(f37 * f37);
        i1 = HEAP32[i115 >> 2] | 0;
        f40 = Math_fround(HEAPF32[i1 + 12 >> 2]);
        f41 = Math_fround(HEAPF32[i1 + 8 >> 2]);
        f42 = Math_fround(HEAPF32[i1 + 16 >> 2]);
        f43 = Math_fround(HEAPF32[i72 >> 2]);
        f44 = Math_fround(HEAPF32[i71 >> 2]);
        f45 = Math_fround(HEAPF32[i122 >> 2]);
        f46 = Math_fround(HEAPF32[i127 >> 2]);
        f47 = Math_fround(HEAPF32[i65 >> 2]);
        f48 = Math_fround(HEAPF32[i66 >> 2]);
        i1 = i3;
        i12 = 0;
        while (1) {
         i27 = i1 >>> 1;
         i29 = (HEAP8[i54 + (i27 << 2) + 2 >> 0] | 0) < 0;
         i28 = (i1 & 1 | 0) == 0;
         do if (i29) if (i28) {
          i13 = i34 + i27 | 0;
          i15 = i27;
          i1 = i27 + 1 + i34 | 0;
          break;
         } else {
          i15 = i27 + 1 | 0;
          i13 = i15;
          i15 = i34 + i15 | 0;
          i1 = i27;
          break;
         } else {
          i1 = i27 + 1 | 0;
          if (i28) {
           i13 = i27;
           i15 = i1;
           i1 = i34 + i27 | 0;
           break;
          } else {
           i13 = i34 + i1 | 0;
           i15 = i34 + i27 | 0;
           break;
          }
         } while (0);
         i17 = HEAP16[i54 + (i13 << 2) >> 1] | 0;
         i13 = HEAP16[i54 + (i15 << 2) >> 1] | 0;
         i1 = HEAP16[i54 + (i1 << 2) >> 1] | 0;
         do if (i29) if (i28) {
          f7 = Math_fround(Math_fround(i13 - i17 | 0) * f35);
          f6 = Math_fround(f35 * Math_fround(i17 - i1 | 0));
          break;
         } else {
          f7 = Math_fround(Math_fround(i17 - i13 | 0) * f35);
          f6 = Math_fround(f35 * Math_fround(i1 - i17 | 0));
          break;
         } else if (i28) {
          f7 = Math_fround(f35 * Math_fround(i17 - i1 | 0));
          f6 = Math_fround(Math_fround(i17 - i13 | 0) * f35);
          break;
         } else {
          f7 = Math_fround(f35 * Math_fround(i1 - i17 | 0));
          f6 = Math_fround(Math_fround(i13 - i17 | 0) * f35);
          break;
         } while (0);
         f8 = Math_fround(f7 * f36);
         f6 = Math_fround(f6 * f38);
         f7 = Math_fround(Math_fround(Math_fround(f8 * f8) + f39) + Math_fround(f6 * f6));
         if (f7 > Math_fround(0.0)) {
          f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
          f7 = Math_fround(f6 * f30);
          f6 = Math_fround(f37 * f30);
          f30 = Math_fround(f8 * f30);
         } else {
          f7 = Math_fround(0.0);
          f6 = Math_fround(0.0);
          f30 = Math_fround(0.0);
         }
         i1 = (i27 >>> 0) / (i34 >>> 0) | 0;
         i13 = (i27 >>> 0) % (i34 >>> 0) | 0;
         f8 = Math_fround(HEAP16[i54 + (i27 << 2) >> 1] | 0);
         f21 = Math_fround(HEAP16[i54 + (i27 + 1 << 2) >> 1] | 0);
         i27 = i34 + i27 | 0;
         f14 = Math_fround(HEAP16[i54 + (i27 << 2) >> 1] | 0);
         f18 = Math_fround(HEAP16[i54 + (i27 + 1 << 2) >> 1] | 0);
         do if (i28) if (i29) {
          f16 = Math_fround((i1 + 1 | 0) >>> 0);
          f26 = Math_fround(i13 >>> 0);
          f19 = f16;
          f20 = Math_fround(i1 >>> 0);
          f22 = f14;
          f23 = f8;
          f25 = f26;
          f8 = f18;
          f14 = Math_fround((i13 + 1 | 0) >>> 0);
          break;
         } else {
          f20 = Math_fround(i1 >>> 0);
          f24 = Math_fround(i13 >>> 0);
          f19 = f20;
          f22 = f8;
          f23 = f21;
          f25 = f24;
          f26 = Math_fround((i13 + 1 | 0) >>> 0);
          f16 = Math_fround((i1 + 1 | 0) >>> 0);
          f8 = f14;
          f14 = f24;
          break;
         } else if (i29) {
          f16 = Math_fround(i1 >>> 0);
          f26 = Math_fround((i13 + 1 | 0) >>> 0);
          f19 = f16;
          f20 = Math_fround((i1 + 1 | 0) >>> 0);
          f22 = f21;
          f23 = f18;
          f25 = f26;
          f14 = Math_fround(i13 >>> 0);
          break;
         } else {
          f20 = Math_fround((i1 + 1 | 0) >>> 0);
          f24 = Math_fround((i13 + 1 | 0) >>> 0);
          f19 = f20;
          f22 = f18;
          f23 = f14;
          f25 = f24;
          f26 = Math_fround(i13 >>> 0);
          f16 = Math_fround(i1 >>> 0);
          f8 = f21;
          f14 = f24;
          break;
         } while (0);
         f24 = Math_fround(Math_fround(Math_fround(Math_fround(f19 + f20) + f16) * Math_fround(.333333343)) * f40);
         f21 = Math_fround(Math_fround(Math_fround(Math_fround(f22 + f23) + f8) * Math_fround(.333333343)) * f41);
         f20 = Math_fround(Math_fround(Math_fround(Math_fround(f25 + f26) + f14) * Math_fround(.333333343)) * f42);
         f19 = Math_fround(Math_fround(f6 * f43) - Math_fround(f7 * f44));
         f18 = Math_fround(Math_fround(f7 * f45) - Math_fround(f30 * f43));
         f8 = Math_fround(Math_fround(f30 * f44) - Math_fround(f6 * f45));
         f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)));
         if (f14 > Math_fround(0.0)) {
          f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14))));
          f16 = Math_fround(f8 * f26);
          f14 = Math_fround(f18 * f26);
          f8 = Math_fround(f19 * f26);
         } else {
          f16 = Math_fround(0.0);
          f14 = Math_fround(0.0);
          f8 = Math_fround(0.0);
         }
         if (Math_fround(Math_fround(Math_fround(f8 * Math_fround(f24 - f46)) + Math_fround(f14 * Math_fround(f21 - f47))) + Math_fround(f16 * Math_fround(f20 - f48))) < Math_fround(0.0)) {
          f16 = Math_fround(-f16);
          f14 = Math_fround(-f14);
          f8 = Math_fround(-f8);
         }
         i12 = i12 + 1 | 0;
         if (Math_fround(Math_fround(f33 * f16) + Math_fround(Math_fround(f32 * f14) + Math_fround(f31 * f8))) > Math_fround(0.0)) {
          f5 = f30;
          i102 = 63;
          break;
         }
         if (i12 >>> 0 >= i11 >>> 0) break;
         i1 = HEAP32[i118 + (i12 << 2) >> 2] | 0;
        }
        if ((i102 | 0) == 63) {
         i102 = 0;
         f48 = Math_fround(f5 * Math_fround(2.0));
         f47 = Math_fround(f6 * Math_fround(2.0));
         f46 = Math_fround(f7 * Math_fround(2.0));
         f10 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(f47 * f52)) + Math_fround(f46 * f53));
         f5 = Math_fround(Math_fround(f51 * f10) + Math_fround(Math_fround(f48 * f50) + Math_fround(f49 * Math_fround(Math_fround(f46 * f52) - Math_fround(f47 * f53)))));
         f9 = Math_fround(Math_fround(f52 * f10) + Math_fround(Math_fround(f47 * f50) + Math_fround(f49 * Math_fround(Math_fround(f48 * f53) - Math_fround(f46 * f51)))));
         f10 = Math_fround(Math_fround(Math_fround(f46 * f50) + Math_fround(f49 * Math_fround(Math_fround(f47 * f51) - Math_fround(f48 * f52)))) + Math_fround(f53 * f10));
         HEAPF32[i126 >> 2] = f5;
         HEAPF32[i69 >> 2] = f9;
         HEAPF32[i70 >> 2] = f10;
        }
        f8 = Math_fround(HEAPF32[i128 >> 2]);
        f6 = Math_fround(Math_fround(f79 + Math_fround(f76 * f8)) - Math_fround(f113 * f5));
        f7 = Math_fround(Math_fround(f80 + Math_fround(f77 * f8)) - Math_fround(f113 * f9));
        f8 = Math_fround(Math_fround(f81 + Math_fround(f78 * f8)) - Math_fround(f113 * f10));
        if (i4) i3 = (HEAP8[i54 + (i3 >>> 1 << 2) + 2 >> 0] & 127) == 127 ? HEAP32[i62 >> 2] | 0 : i3;
        i1 = HEAP32[i100 >> 2] | 0;
        if (i1 >>> 0 <= 63) {
         f53 = Math_fround(Math_fround(HEAPF32[i124 >> 2]) - f113);
         HEAP32[i100 >> 2] = i1 + 1;
         HEAPF32[i133 + (i1 << 6) >> 2] = f5;
         HEAPF32[i133 + (i1 << 6) + 4 >> 2] = f9;
         HEAPF32[i133 + (i1 << 6) + 8 >> 2] = f10;
         HEAPF32[i133 + (i1 << 6) + 16 >> 2] = f6;
         HEAPF32[i133 + (i1 << 6) + 20 >> 2] = f7;
         HEAPF32[i133 + (i1 << 6) + 24 >> 2] = f8;
         HEAPF32[i133 + (i1 << 6) + 12 >> 2] = f53;
         HEAP32[i133 + (i1 << 6) + 48 >> 2] = -1;
         HEAP32[i133 + (i1 << 6) + 52 >> 2] = i3;
        }
       }
      } while (0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i57 | 0)) break L9;
      i1 = HEAP32[i88 >> 2] | 0;
     } while (0);
     do if ((HEAP8[(HEAP32[(HEAP32[i114 >> 2] | 0) + 36 >> 2] | 0) + (i56 << 2) + 3 >> 0] | 0) < 0) {
      f52 = Math_fround(f58 * Math_fround(HEAPF32[i110 >> 2]));
      f53 = Math_fround(HEAPF32[i116 >> 2]);
      f53 = Math_fround(f53 * Math_fround(HEAP16[(HEAP32[i92 >> 2] | 0) + (i56 << 2) >> 1] | 0));
      f7 = Math_fround(i59 >>> 0);
      f7 = Math_fround(f7 * Math_fround(HEAPF32[i111 >> 2]));
      HEAPF32[i132 >> 2] = f52;
      HEAPF32[i93 >> 2] = f53;
      HEAPF32[i94 >> 2] = f7;
      f7 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i119, i84, i132, i129));
      if (f7 < f103) {
       f10 = Math_fround(HEAPF32[i129 >> 2]);
       f53 = Math_fround(HEAPF32[i95 >> 2]);
       f52 = Math_fround(HEAPF32[i119 >> 2]);
       f53 = Math_fround(f53 - f52);
       f5 = Math_fround(HEAPF32[i85 >> 2]);
       f9 = Math_fround(HEAPF32[i82 >> 2]);
       f5 = Math_fround(f5 - f9);
       f8 = Math_fround(HEAPF32[i86 >> 2]);
       f6 = Math_fround(HEAPF32[i83 >> 2]);
       f53 = Math_fround(f52 + Math_fround(f10 * f53));
       f5 = Math_fround(f9 + Math_fround(f10 * f5));
       f6 = Math_fround(f6 + Math_fround(f10 * Math_fround(f8 - f6)));
       f8 = Math_fround(HEAPF32[i132 >> 2]);
       f53 = Math_fround(f53 - f8);
       f5 = Math_fround(f5 - Math_fround(HEAPF32[i93 >> 2]));
       f9 = Math_fround(HEAPF32[i94 >> 2]);
       f6 = Math_fround(f6 - f9);
       HEAPF32[i121 >> 2] = f53;
       HEAPF32[i96 >> 2] = f5;
       HEAPF32[i97 >> 2] = f6;
       f6 = Math_fround(HEAPF32[i98 >> 2]);
       if (!(f5 > Math_fround(0.0) & f6 <= Math_fround(0.0))) if (!(f5 < Math_fround(0.0) & f6 > Math_fround(0.0))) break;
       L105 : do if (i99) i102 = 87; else {
        i12 = HEAP32[i92 >> 2] | 0;
        i1 = 0;
        while (1) {
         i2 = HEAP32[i133 + (i1 << 6) + 52 >> 2] | 0;
         i3 = i2 >>> 1;
         i2 = (i2 & 1 | 0) == 0;
         do if ((HEAP8[i12 + (i3 << 2) + 2 >> 0] | 0) < 0) if (i2) {
          i2 = HEAP32[i88 >> 2] | 0;
          i4 = i2 + i3 | 0;
          i11 = i3;
          i2 = i3 + 1 + i2 | 0;
          break;
         } else {
          i11 = i3 + 1 | 0;
          i4 = i11;
          i11 = (HEAP32[i88 >> 2] | 0) + i11 | 0;
          i2 = i3;
          break;
         } else if (i2) {
          i4 = i3;
          i11 = i3 + 1 | 0;
          i2 = (HEAP32[i88 >> 2] | 0) + i3 | 0;
          break;
         } else {
          i11 = HEAP32[i88 >> 2] | 0;
          i2 = i3 + 1 | 0;
          i4 = i11 + i2 | 0;
          i11 = i11 + i3 | 0;
          break;
         } while (0);
         if (!(HEAP32[i133 + (i1 << 6) + 48 >> 2] | 0)) if ((i56 | 0) == (i4 | 0) | (i56 | 0) == (i11 | 0) | (i56 | 0) == (i2 | 0)) break;
         i1 = i1 + 1 | 0;
         if (i1 >>> 0 >= i101 >>> 0) {
          i102 = 87;
          break L105;
         }
        }
        i11 = HEAP32[i133 + (i1 << 6) >> 2] | 0;
        i4 = HEAP32[i133 + (i1 << 6) + 4 >> 2] | 0;
        i3 = HEAP32[i133 + (i1 << 6) + 8 >> 2] | 0;
        HEAPF32[i125 >> 2] = Math_fround(1.0);
        f5 = f10;
       } while (0);
       if ((i102 | 0) == 87) {
        i102 = 0;
        HEAPF32[i125 >> 2] = Math_fround(1.0);
        __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf(i109, i123, HEAPU8[i73 >> 0] | 0, i121, i131, f7, f8, f9, f104, i125);
        f5 = Math_fround(HEAPF32[i129 >> 2]);
        i3 = HEAP32[i75 >> 2] | 0;
        i4 = HEAP32[i74 >> 2] | 0;
        i11 = HEAP32[i109 >> 2] | 0;
       }
       i1 = __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj(i123, i56, i60, i59) | 0;
       i2 = HEAP32[i100 >> 2] | 0;
       if (i2 >>> 0 <= 63) {
        f53 = Math_fround(Math_fround(HEAPF32[i125 >> 2]) - f113);
        f52 = Math_fround(f81 + Math_fround(f78 * f5));
        f52 = Math_fround(f52 - Math_fround(f113 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
        f51 = Math_fround(f80 + Math_fround(f77 * f5));
        f51 = Math_fround(f51 - Math_fround(f113 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
        f50 = Math_fround(f79 + Math_fround(f76 * f5));
        f50 = Math_fround(f50 - Math_fround(f113 * (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
        HEAP32[i100 >> 2] = i2 + 1;
        HEAP32[i133 + (i2 << 6) >> 2] = i11;
        HEAP32[i133 + (i2 << 6) + 4 >> 2] = i4;
        HEAP32[i133 + (i2 << 6) + 8 >> 2] = i3;
        HEAPF32[i133 + (i2 << 6) + 16 >> 2] = f50;
        HEAPF32[i133 + (i2 << 6) + 20 >> 2] = f51;
        HEAPF32[i133 + (i2 << 6) + 24 >> 2] = f52;
        HEAPF32[i133 + (i2 << 6) + 12 >> 2] = f53;
        HEAP32[i133 + (i2 << 6) + 48 >> 2] = -1;
        HEAP32[i133 + (i2 << 6) + 52 >> 2] = i1;
       }
      }
     } while (0);
     i59 = i59 + 1 | 0;
    } while (i59 >>> 0 <= i90 >>> 0);
   }
   i60 = i60 + 1 | 0;
  } while (i60 >>> 0 <= i87 >>> 0);
 }
 if (!i101) {
  i133 = HEAP32[i100 >> 2] | 0;
  i133 = (i133 | 0) != 0;
  STACKTOP = i134;
  return i133 | 0;
 } else i1 = 0;
 do {
  HEAP32[i133 + (i1 << 6) + 48 >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i101 | 0));
 i133 = HEAP32[i100 >> 2] | 0;
 i133 = (i133 | 0) != 0;
 STACKTOP = i134;
 return i133 | 0;
}

function __ZN22RenderingCommandBuffer20FlattenCommandBufferER17ShaderPassContextR15RenderNodeQueue(i28, i1, i29) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i32 + 56 | 0;
 i30 = i32;
 i22 = i32 + 52 | 0;
 i23 = i32 + 32 | 0;
 i24 = i32 + 16 | 0;
 i25 = i32 + 48 | 0;
 i26 = HEAP32[i28 + 24 >> 2] | 0;
 if (!i26) {
  STACKTOP = i32;
  return;
 }
 i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 if (!i1) {
  i1 = i28 + 100 | 0;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
 } else {
  HEAP32[i28 + 100 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 0) | 0;
  HEAP32[i28 + 104 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 1) | 0;
  HEAP32[i28 + 108 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 2) | 0;
  HEAP32[i28 + 112 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 3) | 0;
  HEAP32[i28 + 116 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 4) | 0;
  HEAP32[i28 + 120 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 5) | 0;
  HEAP32[i28 + 124 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 6) | 0;
  HEAP32[i28 + 128 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 7) | 0;
  HEAP32[i28 + 132 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 8) | 0;
  HEAP32[i28 + 136 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 9) | 0;
  HEAP32[i28 + 140 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 10) | 0;
  HEAP32[i28 + 144 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 11) | 0;
  HEAP32[i28 + 148 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 12) | 0;
  HEAP32[i28 + 152 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 13) | 0;
  HEAP32[i28 + 156 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 14) | 0;
  HEAP32[i28 + 160 >> 2] = __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, 15) | 0;
 }
 i1 = i29 + 12 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + (HEAP32[i28 + 32 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i29 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i2 * 360 | 0, 4, i29 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 360 | 0, 4, i29 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i29 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 360 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i29 >> 2] = i21;
  break;
 } while (0);
 __ZN22PerThreadPageAllocatorC2ER19AtomicPageAllocator(i23, i29 + 20 | 0);
 HEAP32[i24 >> 2] = 0;
 HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
 i13 = i24 + 8 | 0;
 HEAP32[i13 >> 2] = -1;
 HEAP32[i24 + 12 >> 2] = i23;
 i14 = i28 + 16 | 0;
 i1 = i28 + 164 | 0;
 i15 = i1 + 11 | 0;
 i16 = i23 + 4 | 0;
 i17 = i23 + 8 | 0;
 i18 = i28 + 60 | 0;
 i19 = i28 + 72 | 0;
 i20 = i28 + 76 | 0;
 i21 = i28 + 64 | 0;
 i6 = 21;
 i12 = i5;
 i2 = 0;
 L14 : while (1) {
  i4 = i2 + 3 & -4;
  i5 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i5 + i4 >> 2] | 0;
  L16 : do switch (i2 | 0) {
  case 1:
   {
    i9 = i4 + 7 & -4;
    i2 = i9 + 92 | 0;
    i9 = i5 + i9 | 0;
    i3 = i12 + 1 | 0;
    i10 = i9 + 88 | 0;
    HEAP32[i10 >> 2] = i12;
    i11 = HEAP32[i29 >> 2] | 0;
    i7 = i9 + 68 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if (!i4) i4 = 0; else {
     HEAP32[i22 >> 2] = i4;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i4) i31 = 17; else {
      if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
       i5 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[i4 + 32 >> 2] | 0;
       i4 = i5 + (i6 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i4, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i8 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[gb + 1104264 >> 2] | 0;
       i4 = (i5 | 0) == -1 ? i8 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i8 + (i5 << 3) | 0;
       i5 = HEAP32[i6 + 28 >> 2] | 0;
       i6 = HEAP32[i6 + 32 >> 2] | 0;
      }
      if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i31 = 17; else {
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       if (!i4) i31 = 19;
      }
     }
     if ((i31 | 0) == 17) i31 = 19;
     if ((i31 | 0) == 19) {
      i31 = 0;
      i4 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
     }
    }
    i8 = i9 + 64 | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if (i5 | 0) {
     HEAP32[i22 >> 2] = i5;
     i5 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i5) i31 = 27; else {
      if ((HEAP32[i5 + 36 >> 2] | 0) == (HEAP32[i5 + 4 >> 2] | 0)) {
       i6 = HEAP32[i5 + 28 >> 2] | 0;
       i7 = HEAP32[i5 + 32 >> 2] | 0;
       i5 = i6 + (i7 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i5, i22);
       i6 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i5 + 28 >> 2] | 0;
       i7 = HEAP32[gb + 1104264 >> 2] | 0;
       i5 = (i6 | 0) == -1 ? i33 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i33 + (i6 << 3) | 0;
       i6 = HEAP32[i7 + 28 >> 2] | 0;
       i7 = HEAP32[i7 + 32 >> 2] | 0;
      }
      if ((i5 | 0) == (i6 + (i7 << 3) | 0)) i31 = 27; else {
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       if (!i5) i31 = 29;
      }
     }
     if ((i31 | 0) == 27) i31 = 29;
     if ((i31 | 0) == 29) {
      i31 = 0;
      i5 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
     }
     if (!((i4 | 0) == 0 | (i5 | 0) == 0)) {
      HEAP32[i9 + 80 >> 2] = __ZN8Material9GetShaderEv(i4) | 0;
      HEAP32[i9 + 84 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i4) | 0;
      __ZN4Mesh18CheckIfBuffersLostEv(i5);
      if (HEAP8[i5 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i5);
      i4 = HEAP32[i16 >> 2] | 0;
      if ((i4 + 28 | 0) >>> 0 > (HEAP32[i17 >> 2] | 0) >>> 0) {
       __ZN22PerThreadPageAllocator14AcquireNewPageEj(i23, 32768);
       i4 = HEAP32[i16 >> 2] | 0;
      }
      i6 = (HEAP32[i23 >> 2] | 0) + i4 | 0;
      HEAP32[i16 >> 2] = i4 + 28;
      __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i6, i5, 0, 0, 0, 0);
      HEAP32[i11 + (i12 * 360 | 0) + 188 >> 2] = 0;
      HEAP32[i11 + (i12 * 360 | 0) + 244 >> 2] = 0;
      HEAP32[i11 + (i12 * 360 | 0) + 328 >> 2] = i6;
      HEAP32[i11 + (i12 * 360 | 0) + 344 >> 2] = fb + 2371;
      i6 = 1;
      break L16;
     }
    }
    HEAP32[i10 >> 2] = -1;
    HEAP32[i11 + (i12 * 360 | 0) + 344 >> 2] = 0;
    HEAP32[i11 + (i12 * 360 | 0) + 188 >> 2] = 0;
    HEAP32[i11 + (i12 * 360 | 0) + 244 >> 2] = 0;
    i6 = 1;
    break;
   }
  case 0:
   {
    i8 = i4 + 7 & -4;
    i2 = i8 + 24 | 0;
    i8 = i5 + i8 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    if (!i3) i7 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 43; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 43; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 45;
      }
     }
     if ((i31 | 0) == 43) i31 = 45;
     if ((i31 | 0) == 45) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
     }
     i7 = i3;
    }
    i6 = i8 + 4 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) {
     HEAP32[i13 >> 2] = i12;
     i3 = i12 + 1 | 0;
     i31 = 58;
    } else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 54; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 54; else {
       i4 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i4) i31 = 56;
      }
     }
     if ((i31 | 0) == 54) i31 = 56;
     if ((i31 | 0) == 56) {
      i31 = 0;
      i4 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
     i3 = i12 + 1 | 0;
     HEAP32[i13 >> 2] = i12;
     if ((i7 | 0) == 0 | (i4 | 0) == 0) i31 = 58; else {
      HEAP32[i8 + 12 >> 2] = __ZN8Material9GetShaderEv(i4) | 0;
      HEAP32[i8 + 16 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i4) | 0;
      i33 = i7 + 32 | 0;
      HEAP32[i24 >> 2] = i33;
      mftCall_vi(HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2] | 0, i33 | 0);
      i33 = mftCall_iiii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i29 | 0, i24 | 0) | 0;
      HEAP32[i8 + 20 >> 2] = i33;
      if ((i33 | 0) != -1) {
       i6 = 0;
       break L16;
      }
     }
    }
    if ((i31 | 0) == 58) {
     i31 = 0;
     HEAP32[i8 + 20 >> 2] = -1;
    }
    i6 = HEAP32[i13 >> 2] | 0;
    i33 = HEAP32[i29 >> 2] | 0;
    HEAP32[i33 + (i6 * 360 | 0) + 344 >> 2] = 0;
    HEAP32[i33 + (i6 * 360 | 0) + 188 >> 2] = 0;
    HEAP32[i33 + (i6 * 360 | 0) + 244 >> 2] = 0;
    i6 = 0;
    break;
   }
  case 2:
   {
    i7 = i4 + 7 & -4;
    i2 = i7 + 96 | 0;
    i7 = i5 + i7 | 0;
    i6 = i7 + 64 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    do if (i3 | 0) {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 67; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 67; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 69;
      }
     }
     if ((i31 | 0) == 67) i31 = 69;
     if ((i31 | 0) == 69) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      if (!i3) break;
     }
     HEAP32[i7 + 88 >> 2] = __ZN8Material9GetShaderEv(i3) | 0;
     HEAP32[i7 + 92 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i3) | 0;
     i6 = 2;
     i3 = i12;
     break L16;
    } while (0);
    HEAP32[i7 + 88 >> 2] = 0;
    HEAP32[i7 + 92 >> 2] = 0;
    i6 = 2;
    i3 = i12;
    break;
   }
  case 3:
   {
    i7 = i4 + 7 & -4;
    i2 = i7 + 96 | 0;
    i7 = i5 + i7 | 0;
    i6 = i7 + 64 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    do if (i3 | 0) {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 78; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 78; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 80;
      }
     }
     if ((i31 | 0) == 78) i31 = 80;
     if ((i31 | 0) == 80) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      if (!i3) break;
     }
     HEAP32[i7 + 88 >> 2] = __ZN8Material9GetShaderEv(i3) | 0;
     HEAP32[i7 + 92 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i3) | 0;
     i6 = 3;
     i3 = i12;
     break L16;
    } while (0);
    HEAP32[i7 + 88 >> 2] = 0;
    HEAP32[i7 + 92 >> 2] = 0;
    i6 = 3;
    i3 = i12;
    break;
   }
  case 4:
   {
    i8 = i4 + 7 & -4;
    i2 = i8 + 28 | 0;
    i8 = i5 + i8 | 0;
    i3 = i12 + 1 | 0;
    i9 = i8 + 24 | 0;
    HEAP32[i9 >> 2] = i12;
    i10 = HEAP32[i29 >> 2] | 0;
    i7 = i8 + 4 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if (!i4) i4 = 0; else {
     HEAP32[i22 >> 2] = i4;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i4) i31 = 89; else {
      if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
       i5 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[i4 + 32 >> 2] | 0;
       i4 = i5 + (i6 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i4, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[gb + 1104264 >> 2] | 0;
       i4 = (i5 | 0) == -1 ? i33 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i33 + (i5 << 3) | 0;
       i5 = HEAP32[i6 + 28 >> 2] | 0;
       i6 = HEAP32[i6 + 32 >> 2] | 0;
      }
      if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i31 = 89; else {
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       if (!i4) i31 = 91;
      }
     }
     if ((i31 | 0) == 89) i31 = 91;
     if ((i31 | 0) == 91) {
      i31 = 0;
      i4 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
     }
    }
    i5 = HEAP32[i8 >> 2] | 0;
    if (i5 | 0) {
     HEAP32[i22 >> 2] = i5;
     i5 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i5) i31 = 99; else {
      if ((HEAP32[i5 + 36 >> 2] | 0) == (HEAP32[i5 + 4 >> 2] | 0)) {
       i6 = HEAP32[i5 + 28 >> 2] | 0;
       i7 = HEAP32[i5 + 32 >> 2] | 0;
       i5 = i6 + (i7 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i5, i22);
       i6 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i5 + 28 >> 2] | 0;
       i7 = HEAP32[gb + 1104264 >> 2] | 0;
       i5 = (i6 | 0) == -1 ? i33 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i33 + (i6 << 3) | 0;
       i6 = HEAP32[i7 + 28 >> 2] | 0;
       i7 = HEAP32[i7 + 32 >> 2] | 0;
      }
      if ((i5 | 0) == (i6 + (i7 << 3) | 0)) i31 = 99; else {
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       if (!i5) i31 = 101;
      }
     }
     if ((i31 | 0) == 99) i31 = 101;
     if ((i31 | 0) == 101) {
      i31 = 0;
      i5 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
     }
     if (!((i4 | 0) == 0 | (i5 | 0) == 0)) {
      HEAP32[i8 + 16 >> 2] = __ZN8Material9GetShaderEv(i4) | 0;
      HEAP32[i8 + 20 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i4) | 0;
      __ZN4Mesh18CheckIfBuffersLostEv(i5);
      if (HEAP8[i5 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i5);
      i4 = HEAP32[i16 >> 2] | 0;
      if ((i4 + 28 | 0) >>> 0 > (HEAP32[i17 >> 2] | 0) >>> 0) {
       __ZN22PerThreadPageAllocator14AcquireNewPageEj(i23, 32768);
       i4 = HEAP32[i16 >> 2] | 0;
      }
      i6 = (HEAP32[i23 >> 2] | 0) + i4 | 0;
      HEAP32[i16 >> 2] = i4 + 28;
      __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i6, i5, 0, 0, 0, 0);
      HEAP32[i10 + (i12 * 360 | 0) + 188 >> 2] = 0;
      HEAP32[i10 + (i12 * 360 | 0) + 244 >> 2] = 0;
      HEAP32[i10 + (i12 * 360 | 0) + 328 >> 2] = i6;
      HEAP32[i10 + (i12 * 360 | 0) + 344 >> 2] = fb + 2371;
      i6 = 4;
      break L16;
     }
    }
    HEAP32[i9 >> 2] = -1;
    HEAP32[i10 + (i12 * 360 | 0) + 344 >> 2] = 0;
    HEAP32[i10 + (i12 * 360 | 0) + 188 >> 2] = 0;
    HEAP32[i10 + (i12 * 360 | 0) + 244 >> 2] = 0;
    i6 = 4;
    break;
   }
  case 5:
   {
    i6 = i4 + 7 & -4;
    i2 = i6 + 28 | 0;
    i6 = i5 + i6 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 116; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 116; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 118;
      }
     }
     if ((i31 | 0) == 116) i31 = 118;
     if ((i31 | 0) == 118) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i6 + 24 >> 2] = i3;
    i6 = 5;
    i3 = i12;
    break;
   }
  case 6:
   {
    i8 = i4 + 7 & -4;
    i2 = i8 + 196 | 0;
    i8 = i5 + i8 | 0;
    if ((HEAP32[i8 >> 2] | 0) > 0) {
     i7 = 0;
     do {
      i6 = i8 + 4 + (i7 << 2) | 0;
      i3 = HEAP32[i6 >> 2] | 0;
      if (!i3) i3 = 0; else {
       HEAP32[i22 >> 2] = i3;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i3) i31 = 139; else {
        if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
         i4 = HEAP32[i3 + 28 >> 2] | 0;
         i5 = HEAP32[i3 + 32 >> 2] | 0;
         i3 = i4 + (i5 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
         i4 = HEAP32[i27 >> 2] | 0;
         i33 = HEAP32[i3 + 28 >> 2] | 0;
         i5 = HEAP32[gb + 1104264 >> 2] | 0;
         i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
         i4 = HEAP32[i5 + 28 >> 2] | 0;
         i5 = HEAP32[i5 + 32 >> 2] | 0;
        }
        if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 139; else {
         i3 = HEAP32[i3 + 4 >> 2] | 0;
         if (!i3) i31 = 141;
        }
       }
       if ((i31 | 0) == 139) i31 = 141;
       if ((i31 | 0) == 141) {
        i31 = 0;
        i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
       }
      }
      HEAP32[i8 + 124 + (i7 << 2) >> 2] = i3;
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (HEAP32[i8 >> 2] | 0));
    }
    i6 = i8 + 100 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 128; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 128; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 130;
      }
     }
     if ((i31 | 0) == 128) i31 = 130;
     if ((i31 | 0) == 130) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i8 + 156 >> 2] = i3;
    i6 = 6;
    i3 = i12;
    break;
   }
  case 7:
   {
    if (!(HEAP8[gb + 1546310 >> 0] | 0)) {
     HEAP32[gb + 1160172 >> 2] = -1;
     __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1160172 | 0, gb + 1046318 | 0);
     HEAP8[gb + 1546310 >> 0] = 1;
     i3 = HEAP32[i14 >> 2] | 0;
    } else i3 = i5;
    i9 = i4 + 7 & -4;
    i2 = i9 + 52 | 0;
    i9 = i3 + i9 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    do if (!i3) i31 = 156; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 152; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 152; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (i3 | 0) break;
      }
     }
     if ((i31 | 0) == 152) i31 = 0;
     i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
     if (!i3) i31 = 156;
    } while (0);
    if ((i31 | 0) == 156) {
     i31 = 0;
     i3 = HEAP32[i9 + 4 >> 2] | 0;
     if ((i3 | 0) == 1) i3 = 0; else {
      HEAP32[i27 >> 2] = 0;
      __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i28, i3, i9 + 8 | 0, gb + 424022 | 0, i27) | 0;
      i3 = HEAP32[i27 >> 2] | 0;
     }
    }
    i7 = i9 + 24 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if (!i4) {
     HEAP32[i9 + 48 >> 2] = 1;
     i4 = 0;
     i6 = 0;
    } else {
     HEAP32[i22 >> 2] = i4;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i4) i31 = 165; else {
      if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
       i5 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[i4 + 32 >> 2] | 0;
       i4 = i5 + (i6 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i4, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i4 + 28 >> 2] | 0;
       i6 = HEAP32[gb + 1104264 >> 2] | 0;
       i4 = (i5 | 0) == -1 ? i33 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i33 + (i5 << 3) | 0;
       i5 = HEAP32[i6 + 28 >> 2] | 0;
       i6 = HEAP32[i6 + 32 >> 2] | 0;
      }
      if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i31 = 165; else {
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       if (!i4) i31 = 167;
      }
     }
     if ((i31 | 0) == 165) i31 = 167;
     if ((i31 | 0) == 167) {
      i31 = 0;
      i4 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
     }
     i5 = i9 + 48 | 0;
     HEAP32[i5 >> 2] = 1;
     i6 = (i4 | 0) != 0;
     if ((i3 | 0) != 0 & i6) {
      HEAP32[i25 >> 2] = HEAP32[gb + 1160172 >> 2];
      HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
      if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i4, i27) | 0) {
       HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
       i6 = 1;
      } else i6 = 1;
     }
    }
    HEAP32[i9 + 32 >> 2] = i3;
    i8 = i9 + 12 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 177; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i5 = HEAP32[i3 + 28 >> 2] | 0;
       i7 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i5 + (i7 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i7 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i5 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i5 << 3) | 0;
       i5 = HEAP32[i7 + 28 >> 2] | 0;
       i7 = HEAP32[i7 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i5 + (i7 << 3) | 0)) i31 = 177; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 179;
      }
     }
     if ((i31 | 0) == 177) i31 = 179;
     if ((i31 | 0) == 179) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
     }
    }
    HEAP32[i9 + 36 >> 2] = i3;
    HEAP32[i9 + 44 >> 2] = __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i28, i4) | 0;
    if (i6) i3 = __ZN8Material9GetShaderEv(i4) | 0; else i3 = 0;
    HEAP32[i9 + 40 >> 2] = i3;
    i6 = 7;
    i3 = i12;
    break;
   }
  case 8:
   {
    i6 = 8;
    i3 = i12;
    i2 = i4 + 35 & -4;
    break;
   }
  case 9:
   {
    i4 = i4 + 7 & -4;
    i2 = i4 + 36 | 0;
    i4 = i5 + i4 | 0;
    i5 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4212 >> 2] | 0) == 1;
    i6 = __Z22GetRenderBufferManagerv() | 0;
    i5 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i6, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0, 0, HEAP32[i4 + 24 >> 2] | 0, i5 ? 2 : 0, HEAP32[i4 + 28 >> 2] | 0) | 0;
    __ZN7Texture13SetFilterModeEi(i5, HEAP32[i4 + 20 >> 2] | 0);
    i4 = HEAP32[i4 >> 2] | 0;
    i6 = HEAP32[i19 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = HEAP32[i20 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i7 >>> 0 > i9 >>> 0) {
     i3 = i8 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i9 >>> 0 < i3 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i20 >> 2] = i3;
      HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i3 << 3, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i33 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i33 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i19 >> 2] << 3 | 0) | 0;
      HEAP32[i20 >> 2] = i3;
      HEAP32[i18 >> 2] = i33;
      break;
     }
    } while (0);
    HEAP32[i19 >> 2] = i7;
    i3 = HEAP32[i18 >> 2] | 0;
    HEAP32[i3 + (i6 << 3) >> 2] = i4;
    HEAP32[i3 + (i6 << 3) + 4 >> 2] = i5;
    i6 = 9;
    i3 = i12;
    break;
   }
  case 10:
   {
    i6 = 10;
    i3 = i12;
    i2 = i4 + 11 & -4;
    break;
   }
  case 11:
   {
    i6 = 11;
    i3 = i12;
    i2 = i4 + 15 & -4;
    break;
   }
  case 12:
   {
    i6 = 12;
    i3 = i12;
    i2 = i4 + 27 & -4;
    break;
   }
  case 13:
   {
    i6 = 13;
    i3 = i12;
    i2 = i4 + 75 & -4;
    break;
   }
  case 16:
   {
    i2 = i4 + 7 & -4;
    i6 = 16;
    i3 = i12;
    i2 = (HEAP32[i5 + i2 + 4 >> 2] << 2) + (i2 + 11 & -4) | 0;
    break;
   }
  case 17:
   {
    i2 = i4 + 7 & -4;
    i6 = 17;
    i3 = i12;
    i2 = (HEAP32[i5 + i2 + 4 >> 2] << 4) + (i2 + 11 & -4) | 0;
    break;
   }
  case 18:
   {
    i2 = i4 + 7 & -4;
    i6 = 18;
    i3 = i12;
    i2 = (HEAP32[i5 + i2 + 4 >> 2] << 6) + (i2 + 11 & -4) | 0;
    break;
   }
  case 14:
   {
    i7 = i4 + 7 & -4;
    i2 = i7 + 20 | 0;
    i7 = i5 + i7 | 0;
    i6 = i7 + 4 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 204; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 204; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 206;
      }
     }
     if ((i31 | 0) == 204) i31 = 206;
     if ((i31 | 0) == 206) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i7 + 16 >> 2] = i3;
    i6 = 14;
    i3 = i12;
    break;
   }
  case 15:
   {
    i6 = 15;
    i3 = i12;
    i2 = i4 + 15 & -4;
    break;
   }
  case 20:
   {
    i6 = 20;
    i3 = i12;
    i2 = i4 + 15 & -4;
    break;
   }
  case 19:
   {
    i6 = i4 + 7 & -4;
    i2 = i6 + 20 | 0;
    i6 = i5 + i6 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i22 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i31 = 217; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i3, i22);
       i4 = HEAP32[i27 >> 2] | 0;
       i33 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i33 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i33 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i31 = 217; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i31 = 219;
      }
     }
     if ((i31 | 0) == 217) i31 = 219;
     if ((i31 | 0) == 219) {
      i31 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i6 + 16 >> 2] = i3;
    i6 = 19;
    i3 = i12;
    break;
   }
  default:
   {
    i31 = 222;
    break L14;
   }
  } while (0);
  if (i2 >>> 0 < i26 >>> 0) i12 = i3; else break;
 }
 if ((i31 | 0) == 222) {
  if ((HEAP8[i15 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i30 >> 2] = i2;
  HEAP32[i30 + 4 >> 2] = i6;
  HEAP32[i30 + 8 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 424034 | 0, i30);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i27, 256, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 STACKTOP = i32;
 return;
}

function __ZN13TriggerModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i66, i51, i53, i74, i6, i50) {
 i66 = i66 | 0;
 i51 = i51 | 0;
 i53 = i53 | 0;
 i74 = i74 | 0;
 i6 = i6 | 0;
 i50 = i50 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, i88 = 0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i76;
 i57 = i76 + 72 | 0;
 i58 = i76 + 48 | 0;
 i72 = i76 + 28 | 0;
 i73 = i76 + 8 | 0;
 i60 = i74 + 640 | 0;
 i61 = i74 + 652 | 0;
 HEAP32[i61 >> 2] = 0;
 i62 = i74 + 656 | 0;
 i63 = i74 + 660 | 0;
 i64 = i74 + 672 | 0;
 HEAP32[i64 >> 2] = 0;
 i65 = i74 + 676 | 0;
 i56 = HEAP32[i74 + 12 >> 2] | 0;
 if ((i56 | 0) == (i6 | 0)) {
  STACKTOP = i76;
  return;
 }
 i68 = i66 + 8 | 0;
 if (!(HEAP32[i68 >> 2] | 0)) if (!(HEAP32[i66 + 12 >> 2] | 0)) if (!(HEAP32[i66 + 16 >> 2] | 0)) if (!(HEAP32[i66 + 20 >> 2] | 0)) {
  STACKTOP = i76;
  return;
 }
 if ((HEAP16[gb + 1451740 + 6 >> 1] | 0) > -1) {
  HEAP32[i57 >> 2] = 0;
  HEAP32[i59 >> 2] = HEAP32[i57 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451740 | 0, i59);
  i75 = gb + 1451740 | 0;
 } else i75 = 0;
 i69 = i66 + 16 | 0;
 if ((HEAP32[i69 >> 2] | 0) == 2) i1 = 1; else i1 = ((HEAP32[i66 + 20 >> 2] | 0) + -1 | 0) >>> 0 < 2;
 __ZN23ParticleSystemParticles20SetUsesTriggerEventsEb(i74, i1);
 i4 = 0;
 i5 = 0;
 do {
  HEAP32[i57 >> 2] = HEAP32[i66 + 28 + (i5 << 2) >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i67 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i59, i1, i57);
    i2 = HEAP32[i59 >> 2] | 0;
    i71 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i71 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i71 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i67 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1) {
     i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 32548 | 0) | 0;
     if (i1) {
      HEAP32[i58 + (i4 << 2) >> 2] = i1;
      i4 = i4 + 1 | 0;
     }
    }
   }
  }
  if ((i67 | 0) == 17) i67 = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 6);
 i52 = __Z13GetIPhysics2Dv() | 0;
 i52 = mftCall_iiiii(HEAP32[(HEAP32[i52 >> 2] | 0) + 32 >> 2] | 0, i52 | 0, i66 + 28 | 0, i57 | 0, 6) | 0;
 if (!(i52 | i4)) {
  switch (HEAP32[i66 + 20 >> 2] | 0) {
  case 2:
   {
    i7 = i74 + 700 | 0;
    if (i56 | 0) {
     i8 = i74 + 728 | 0;
     i9 = i74 + 712 | 0;
     i10 = i74 + 716 | 0;
     i11 = i74 + 704 | 0;
     i1 = 0;
     do {
      if (HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) {
       i3 = HEAP32[i9 >> 2] | 0;
       i4 = i3 + 1 | 0;
       i5 = HEAP32[i10 >> 2] | 0;
       i6 = i5 & 2147483647;
       do if (i4 >>> 0 > i6 >>> 0) {
        i2 = i5 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
         HEAP32[i10 >> 2] = i2;
         HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i73 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i73 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
         HEAP32[i10 >> 2] = i2;
         HEAP32[i7 >> 2] = i73;
         break;
        }
       } while (0);
       HEAP32[i9 >> 2] = i4;
       HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] = i1;
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i56 | 0));
    }
    break;
   }
  case 1:
   {
    if (i56 | 0) {
     i2 = HEAP32[i74 + 728 >> 2] | 0;
     i3 = HEAP32[i74 + 520 >> 2] | 0;
     i1 = 0;
     do {
      if (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) HEAPF32[i3 + (i1 << 2) >> 2] = Math_fround(100.0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i56 | 0));
    }
    break;
   }
  default:
   {}
  }
  if (HEAP32[i74 + 732 >> 2] | 0) _memset(HEAP32[i74 + 728 >> 2] | 0, 0, HEAP32[i74 + 736 >> 2] << 2 | 0) | 0;
 } else {
  i55 = i56 - i6 | 0;
  i1 = (i55 + 3 | 0) >>> 2;
  i54 = i72 + 12 | 0;
  HEAP32[i54 >> 2] = i1;
  i70 = i72 + 16 | 0;
  HEAP32[i70 >> 2] = i1;
  i71 = i72 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i59, gb + 64016 | 0);
  i47 = i59;
  i48 = HEAP32[i47 + 4 >> 2] | 0;
  i49 = i71;
  HEAP32[i49 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i49 + 4 >> 2] = i48;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 144 | 0, 4, i71, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i72 >> 2] = i1;
  f36 = Math_fround(Math_fround(HEAPF32[i66 + 24 >> 2]) * Math_fround(.5));
  if (i56 >>> 0 > i6 >>> 0) {
   i37 = HEAP32[i74 >> 2] | 0;
   i38 = HEAP32[i74 + 20 >> 2] | 0;
   i39 = HEAP32[i74 + 40 >> 2] | 0;
   i40 = HEAP32[i74 + 60 >> 2] | 0;
   i41 = HEAP32[i74 + 80 >> 2] | 0;
   i42 = HEAP32[i74 + 100 >> 2] | 0;
   i43 = HEAP32[i74 + 120 >> 2] | 0;
   i44 = HEAP32[i74 + 140 >> 2] | 0;
   i45 = HEAP32[i74 + 160 >> 2] | 0;
   i46 = HEAP32[i74 + 420 >> 2] | 0;
   i47 = (HEAP8[i74 + 871 >> 0] | 0) == 0;
   i48 = HEAP32[i74 + 440 >> 2] | 0;
   i49 = HEAP32[i74 + 460 >> 2] | 0;
   i32 = 0;
   i33 = i6;
   i34 = i6 + 2 | 0;
   i35 = i6 + 3 | 0;
   i7 = i6 + 1 | 0;
   while (1) {
    i11 = i37 + (i33 << 2) | 0;
    i8 = HEAP32[i11 >> 2] | 0;
    i9 = HEAP32[i11 + 4 >> 2] | 0;
    i10 = HEAP32[i11 + 8 >> 2] | 0;
    i11 = HEAP32[i11 + 12 >> 2] | 0;
    i27 = i38 + (i33 << 2) | 0;
    i12 = HEAP32[i27 >> 2] | 0;
    i13 = HEAP32[i27 + 4 >> 2] | 0;
    i26 = HEAP32[i27 + 8 >> 2] | 0;
    i27 = HEAP32[i27 + 12 >> 2] | 0;
    i31 = i39 + (i33 << 2) | 0;
    i28 = HEAP32[i31 >> 2] | 0;
    i29 = HEAP32[i31 + 4 >> 2] | 0;
    i30 = HEAP32[i31 + 8 >> 2] | 0;
    i31 = HEAP32[i31 + 12 >> 2] | 0;
    i5 = i40 + (i33 << 2) | 0;
    f87 = Math_fround(HEAPF32[i5 >> 2]);
    f86 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f85 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f84 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    i5 = i41 + (i33 << 2) | 0;
    f83 = Math_fround(HEAPF32[i5 >> 2]);
    f82 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f81 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f80 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    i5 = i42 + (i33 << 2) | 0;
    f79 = Math_fround(HEAPF32[i5 >> 2]);
    f78 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f77 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f25 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    i5 = i43 + (i33 << 2) | 0;
    f14 = Math_fround(HEAPF32[i5 >> 2]);
    f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f17 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    i5 = i44 + (i33 << 2) | 0;
    f18 = Math_fround(HEAPF32[i5 >> 2]);
    f19 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f20 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f21 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    i5 = i45 + (i33 << 2) | 0;
    f22 = Math_fround(HEAPF32[i5 >> 2]);
    f23 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f24 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f14 = Math_fround(f87 + f14);
    f15 = Math_fround(f86 + f15);
    f16 = Math_fround(f85 + f16);
    f17 = Math_fround(f84 + f17);
    f18 = Math_fround(f83 + f18);
    f19 = Math_fround(f82 + f19);
    f20 = Math_fround(f81 + f20);
    f21 = Math_fround(f80 + f21);
    f22 = Math_fround(f79 + f22);
    f23 = Math_fround(f78 + f23);
    f24 = Math_fround(f77 + f24);
    f25 = Math_fround(f25 + Math_fround(HEAPF32[i5 + 12 >> 2]));
    f77 = Math_fround(HEAPF32[i50 >> 2]);
    f14 = Math_fround(f14 * f77);
    f15 = Math_fround(f15 * f77);
    f16 = Math_fround(f16 * f77);
    f17 = Math_fround(f17 * f77);
    f18 = Math_fround(f18 * f77);
    f19 = Math_fround(f19 * f77);
    f20 = Math_fround(f20 * f77);
    f21 = Math_fround(f21 * f77);
    f22 = Math_fround(f22 * f77);
    f23 = Math_fround(f23 * f77);
    f24 = Math_fround(f24 * f77);
    f25 = Math_fround(f77 * f25);
    f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
    f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f16);
    f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f17);
    f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18);
    f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f19);
    f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f20);
    f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
    f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f22);
    f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
    f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f24);
    f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f25);
    i5 = i46 + (i33 << 2) | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i5 + 4 >> 2] | 0;
    i6 = HEAP32[i5 + 8 >> 2] | 0;
    i5 = HEAP32[i5 + 12 >> 2] | 0;
    if (!i47) {
     i88 = i48 + (i33 << 2) | 0;
     f80 = Math_fround(HEAPF32[i88 >> 2]);
     f82 = Math_fround(HEAPF32[i88 + 4 >> 2]);
     f84 = Math_fround(HEAPF32[i88 + 8 >> 2]);
     f86 = Math_fround(HEAPF32[i88 + 12 >> 2]);
     f81 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = f81 > f80 ? f81 : f80;
     f81 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f82 = f81 > f82 ? f81 : f82;
     f81 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = f81 > f84 ? f81 : f84;
     f81 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = f81 > f86 ? f81 : f86;
     i3 = i49 + (i33 << 2) | 0;
     f81 = Math_fround(HEAPF32[i3 >> 2]);
     f83 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     f85 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     f87 = Math_fround(HEAPF32[i3 + 12 >> 2]);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f80 > f81 ? f80 : f81, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f82 > f83 ? f82 : f83, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f84 > f85 ? f84 : f85, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f86 > f87 ? f86 : f87, HEAP32[tempDoublePtr >> 2] | 0);
    }
    f84 = Math_fround(f36 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f85 = Math_fround(f36 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f86 = Math_fround(f36 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f87 = Math_fround(f36 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAP32[i1 + (i32 * 144 | 0) >> 2] = i33;
    HEAP32[i1 + (i32 * 144 | 0) + 4 >> 2] = i7;
    HEAP32[i1 + (i32 * 144 | 0) + 8 >> 2] = i34;
    HEAP32[i1 + (i32 * 144 | 0) + 12 >> 2] = i35;
    HEAPF32[i1 + (i32 * 144 | 0) + 16 >> 2] = f14;
    HEAPF32[i1 + (i32 * 144 | 0) + 20 >> 2] = f15;
    HEAPF32[i1 + (i32 * 144 | 0) + 24 >> 2] = f16;
    HEAPF32[i1 + (i32 * 144 | 0) + 28 >> 2] = f17;
    HEAPF32[i1 + (i32 * 144 | 0) + 32 >> 2] = f18;
    HEAPF32[i1 + (i32 * 144 | 0) + 36 >> 2] = f19;
    HEAPF32[i1 + (i32 * 144 | 0) + 40 >> 2] = f20;
    HEAPF32[i1 + (i32 * 144 | 0) + 44 >> 2] = f21;
    HEAPF32[i1 + (i32 * 144 | 0) + 48 >> 2] = f22;
    HEAPF32[i1 + (i32 * 144 | 0) + 52 >> 2] = f23;
    HEAPF32[i1 + (i32 * 144 | 0) + 56 >> 2] = f24;
    HEAPF32[i1 + (i32 * 144 | 0) + 60 >> 2] = f25;
    HEAP32[i1 + (i32 * 144 | 0) + 64 >> 2] = i8;
    HEAP32[i1 + (i32 * 144 | 0) + 68 >> 2] = i9;
    HEAP32[i1 + (i32 * 144 | 0) + 72 >> 2] = i10;
    HEAP32[i1 + (i32 * 144 | 0) + 76 >> 2] = i11;
    HEAP32[i1 + (i32 * 144 | 0) + 80 >> 2] = i12;
    HEAP32[i1 + (i32 * 144 | 0) + 84 >> 2] = i13;
    HEAP32[i1 + (i32 * 144 | 0) + 88 >> 2] = i26;
    HEAP32[i1 + (i32 * 144 | 0) + 92 >> 2] = i27;
    HEAP32[i1 + (i32 * 144 | 0) + 96 >> 2] = i28;
    HEAP32[i1 + (i32 * 144 | 0) + 100 >> 2] = i29;
    HEAP32[i1 + (i32 * 144 | 0) + 104 >> 2] = i30;
    HEAP32[i1 + (i32 * 144 | 0) + 108 >> 2] = i31;
    HEAPF32[i1 + (i32 * 144 | 0) + 112 >> 2] = f84;
    HEAPF32[i1 + (i32 * 144 | 0) + 116 >> 2] = f85;
    HEAPF32[i1 + (i32 * 144 | 0) + 120 >> 2] = f86;
    HEAPF32[i1 + (i32 * 144 | 0) + 124 >> 2] = f87;
    i88 = i1 + (i32 * 144 | 0) + 128 | 0;
    i33 = i33 + 4 | 0;
    HEAP32[i88 >> 2] = 0;
    HEAP32[i88 + 4 >> 2] = 0;
    HEAP32[i88 + 8 >> 2] = 0;
    HEAP32[i88 + 12 >> 2] = 0;
    if (i33 >>> 0 >= i56 >>> 0) break; else {
     i32 = i32 + 1 | 0;
     i34 = i34 + 4 | 0;
     i35 = i35 + 4 | 0;
     i7 = i7 + 4 | 0;
    }
   }
   i30 = i72;
   i1 = HEAP32[i72 >> 2] | 0;
  } else i30 = i72;
  i3 = (HEAP32[i54 >> 2] | 0) + -1 | 0;
  i5 = i1 + (i3 * 144 | 0) + 16 | 0;
  i6 = i1 + (i3 * 144 | 0) + 32 | 0;
  i7 = i1 + (i3 * 144 | 0) + 48 | 0;
  i8 = i1 + (i3 * 144 | 0) + 64 | 0;
  i9 = i1 + (i3 * 144 | 0) + 80 | 0;
  i10 = i1 + (i3 * 144 | 0) + 96 | 0;
  i11 = i1 + (i3 * 144 | 0) | 0;
  i3 = i1 + (i3 * 144 | 0) + 112 | 0;
  i1 = i56 & 3;
  if (i1 | 0) {
   i2 = i56;
   do {
    HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[i10 >> 2];
    HEAP32[i11 + (i1 << 2) >> 2] = i56;
    HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 1 | 0;
    i1 = i2 & 3;
   } while ((i1 | 0) != 0);
  }
  if ((HEAP32[i51 + 280 >> 2] | 0) != 1) {
   f15 = Math_fround(HEAPF32[i53 + 52 >> 2]);
   f16 = Math_fround(HEAPF32[i53 + 56 >> 2]);
   f17 = Math_fround(HEAPF32[i53 + 60 >> 2]);
   f18 = Math_fround(HEAPF32[i53 + 68 >> 2]);
   f19 = Math_fround(HEAPF32[i53 + 72 >> 2]);
   f20 = Math_fround(HEAPF32[i53 + 76 >> 2]);
   f21 = Math_fround(HEAPF32[i53 + 84 >> 2]);
   f22 = Math_fround(HEAPF32[i53 + 88 >> 2]);
   f23 = Math_fround(HEAPF32[i53 + 92 >> 2]);
   f24 = Math_fround(HEAPF32[i53 + 100 >> 2]);
   f25 = Math_fround(HEAPF32[i53 + 104 >> 2]);
   f14 = Math_fround(HEAPF32[i53 + 108 >> 2]);
   i2 = HEAP32[i54 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i30 >> 2] | 0;
    i1 = 0;
    do {
     i88 = i3 + (i1 * 144 | 0) + 16 | 0;
     f83 = Math_fround(HEAPF32[i88 >> 2]);
     f95 = Math_fround(f15 * f83);
     i56 = i3 + (i1 * 144 | 0) + 20 | 0;
     f87 = Math_fround(HEAPF32[i56 >> 2]);
     f81 = Math_fround(f15 * f87);
     i53 = i3 + (i1 * 144 | 0) + 24 | 0;
     f86 = Math_fround(HEAPF32[i53 >> 2]);
     f36 = Math_fround(f15 * f86);
     i51 = i3 + (i1 * 144 | 0) + 28 | 0;
     f90 = Math_fround(HEAPF32[i51 >> 2]);
     f96 = Math_fround(f15 * f90);
     i50 = i3 + (i1 * 144 | 0) + 32 | 0;
     f82 = Math_fround(HEAPF32[i50 >> 2]);
     f92 = Math_fround(f18 * f82);
     i49 = i3 + (i1 * 144 | 0) + 36 | 0;
     f78 = Math_fround(HEAPF32[i49 >> 2]);
     f91 = Math_fround(f18 * f78);
     i48 = i3 + (i1 * 144 | 0) + 40 | 0;
     f77 = Math_fround(HEAPF32[i48 >> 2]);
     f79 = Math_fround(f18 * f77);
     i47 = i3 + (i1 * 144 | 0) + 44 | 0;
     f80 = Math_fround(HEAPF32[i47 >> 2]);
     f92 = Math_fround(f95 + f92);
     f91 = Math_fround(f81 + f91);
     f79 = Math_fround(f36 + f79);
     f96 = Math_fround(f96 + Math_fround(f18 * f80));
     i46 = i3 + (i1 * 144 | 0) + 48 | 0;
     f36 = Math_fround(HEAPF32[i46 >> 2]);
     f81 = Math_fround(f21 * f36);
     i45 = i3 + (i1 * 144 | 0) + 52 | 0;
     f95 = Math_fround(HEAPF32[i45 >> 2]);
     f94 = Math_fround(f21 * f95);
     i44 = i3 + (i1 * 144 | 0) + 56 | 0;
     f85 = Math_fround(HEAPF32[i44 >> 2]);
     f89 = Math_fround(f21 * f85);
     i43 = i3 + (i1 * 144 | 0) + 60 | 0;
     f97 = Math_fround(HEAPF32[i43 >> 2]);
     f94 = Math_fround(f24 + Math_fround(f91 + f94));
     f89 = Math_fround(f24 + Math_fround(f79 + f89));
     f96 = Math_fround(f24 + Math_fround(f96 + Math_fround(f21 * f97)));
     f79 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f83) + Math_fround(f19 * f82)) + Math_fround(f22 * f36)));
     f91 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f87) + Math_fround(f19 * f78)) + Math_fround(f22 * f95)));
     f84 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f86) + Math_fround(f19 * f77)) + Math_fround(f22 * f85)));
     f93 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f90) + Math_fround(f19 * f80)) + Math_fround(f22 * f97)));
     f36 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f83) + Math_fround(f20 * f82)) + Math_fround(f23 * f36)));
     f95 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f87) + Math_fround(f20 * f78)) + Math_fround(f23 * f95)));
     f85 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f86) + Math_fround(f20 * f77)) + Math_fround(f23 * f85)));
     f97 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f90) + Math_fround(f20 * f80)) + Math_fround(f23 * f97)));
     HEAPF32[i88 >> 2] = Math_fround(f24 + Math_fround(f92 + f81));
     HEAPF32[i56 >> 2] = f94;
     HEAPF32[i53 >> 2] = f89;
     HEAPF32[i51 >> 2] = f96;
     HEAPF32[i50 >> 2] = f79;
     HEAPF32[i49 >> 2] = f91;
     HEAPF32[i48 >> 2] = f84;
     HEAPF32[i47 >> 2] = f93;
     HEAPF32[i46 >> 2] = f36;
     HEAPF32[i45 >> 2] = f95;
     HEAPF32[i44 >> 2] = f85;
     HEAPF32[i43 >> 2] = f97;
     i43 = i3 + (i1 * 144 | 0) + 64 | 0;
     f97 = Math_fround(HEAPF32[i43 >> 2]);
     f85 = Math_fround(f15 * f97);
     i44 = i3 + (i1 * 144 | 0) + 68 | 0;
     f95 = Math_fround(HEAPF32[i44 >> 2]);
     f36 = Math_fround(f15 * f95);
     i45 = i3 + (i1 * 144 | 0) + 72 | 0;
     f93 = Math_fround(HEAPF32[i45 >> 2]);
     f84 = Math_fround(f15 * f93);
     i46 = i3 + (i1 * 144 | 0) + 76 | 0;
     f91 = Math_fround(HEAPF32[i46 >> 2]);
     f79 = Math_fround(f15 * f91);
     i47 = i3 + (i1 * 144 | 0) + 80 | 0;
     f96 = Math_fround(HEAPF32[i47 >> 2]);
     f89 = Math_fround(f18 * f96);
     i48 = i3 + (i1 * 144 | 0) + 84 | 0;
     f94 = Math_fround(HEAPF32[i48 >> 2]);
     f81 = Math_fround(f18 * f94);
     i49 = i3 + (i1 * 144 | 0) + 88 | 0;
     f92 = Math_fround(HEAPF32[i49 >> 2]);
     f80 = Math_fround(f18 * f92);
     i50 = i3 + (i1 * 144 | 0) + 92 | 0;
     f90 = Math_fround(HEAPF32[i50 >> 2]);
     f89 = Math_fround(f85 + f89);
     f81 = Math_fround(f36 + f81);
     f80 = Math_fround(f84 + f80);
     f79 = Math_fround(f79 + Math_fround(f18 * f90));
     i51 = i3 + (i1 * 144 | 0) + 96 | 0;
     f84 = Math_fround(HEAPF32[i51 >> 2]);
     f36 = Math_fround(f21 * f84);
     i53 = i3 + (i1 * 144 | 0) + 100 | 0;
     f85 = Math_fround(HEAPF32[i53 >> 2]);
     f77 = Math_fround(f21 * f85);
     i56 = i3 + (i1 * 144 | 0) + 104 | 0;
     f86 = Math_fround(HEAPF32[i56 >> 2]);
     f78 = Math_fround(f21 * f86);
     i88 = i3 + (i1 * 144 | 0) + 108 | 0;
     f87 = Math_fround(HEAPF32[i88 >> 2]);
     f77 = Math_fround(f24 + Math_fround(f81 + f77));
     f78 = Math_fround(f24 + Math_fround(f80 + f78));
     f79 = Math_fround(f24 + Math_fround(f79 + Math_fround(f21 * f87)));
     f80 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f97) + Math_fround(f19 * f96)) + Math_fround(f22 * f84)));
     f81 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f95) + Math_fround(f19 * f94)) + Math_fround(f22 * f85)));
     f82 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f93) + Math_fround(f19 * f92)) + Math_fround(f22 * f86)));
     f83 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f16 * f91) + Math_fround(f19 * f90)) + Math_fround(f22 * f87)));
     f84 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f97) + Math_fround(f20 * f96)) + Math_fround(f23 * f84)));
     f85 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f95) + Math_fround(f20 * f94)) + Math_fround(f23 * f85)));
     f86 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f93) + Math_fround(f20 * f92)) + Math_fround(f23 * f86)));
     f87 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f91) + Math_fround(f20 * f90)) + Math_fround(f23 * f87)));
     HEAPF32[i43 >> 2] = Math_fround(f24 + Math_fround(f89 + f36));
     HEAPF32[i44 >> 2] = f77;
     HEAPF32[i45 >> 2] = f78;
     HEAPF32[i46 >> 2] = f79;
     HEAPF32[i47 >> 2] = f80;
     HEAPF32[i48 >> 2] = f81;
     HEAPF32[i49 >> 2] = f82;
     HEAPF32[i50 >> 2] = f83;
     HEAPF32[i51 >> 2] = f84;
     HEAPF32[i53 >> 2] = f85;
     HEAPF32[i56 >> 2] = f86;
     HEAPF32[i88 >> 2] = f87;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
  }
  if (i4 | 0) {
   i88 = __Z19GetRaycastInterfacev() | 0;
   mftCall_viiii(HEAP32[(HEAP32[i88 >> 2] | 0) + 12 >> 2] | 0, i88 | 0, i72 | 0, i58 | 0, i4 | 0);
  }
  if (i52 | 0) {
   i88 = __Z13GetIPhysics2Dv() | 0;
   mftCall_viiii(HEAP32[(HEAP32[i88 >> 2] | 0) + 36 >> 2] | 0, i88 | 0, i72 | 0, i57 | 0, i52 | 0);
  }
  i2 = HEAP32[i54 >> 2] | 0;
  i29 = i2 << 2;
  i27 = i73 + 12 | 0;
  HEAP32[i27 >> 2] = i29;
  i28 = i73 + 16 | 0;
  HEAP32[i28 >> 2] = i29;
  i29 = i73 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i59, gb + 64016 | 0);
  i58 = i59;
  i59 = HEAP32[i58 + 4 >> 2] | 0;
  i88 = i29;
  HEAP32[i88 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i88 + 4 >> 2] = i59;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i73 >> 2] = i2;
  L85 : do if (HEAP32[i54 >> 2] | 0) {
   i1 = 0;
   while (1) {
    i88 = i1 << 2;
    i59 = i2 + (i88 << 2) | 0;
    HEAP32[i59 >> 2] = HEAP32[i59 >> 2] & -2 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 128 >> 2] & 1;
    i59 = (HEAP32[i73 >> 2] | 0) + (i88 << 2) | 0;
    HEAP32[i59 >> 2] = HEAP32[i59 >> 2] & 1 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) >> 2] << 1;
    i59 = i88 | 1;
    i58 = (HEAP32[i73 >> 2] | 0) + (i59 << 2) | 0;
    HEAP32[i58 >> 2] = HEAP32[i58 >> 2] & -2 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 128 + 4 >> 2] & 1;
    i59 = (HEAP32[i73 >> 2] | 0) + (i59 << 2) | 0;
    HEAP32[i59 >> 2] = HEAP32[i59 >> 2] & 1 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 4 >> 2] << 1;
    i59 = i88 | 2;
    i58 = (HEAP32[i73 >> 2] | 0) + (i59 << 2) | 0;
    HEAP32[i58 >> 2] = HEAP32[i58 >> 2] & -2 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 128 + 8 >> 2] & 1;
    i59 = (HEAP32[i73 >> 2] | 0) + (i59 << 2) | 0;
    HEAP32[i59 >> 2] = HEAP32[i59 >> 2] & 1 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 8 >> 2] << 1;
    i88 = i88 | 3;
    i59 = (HEAP32[i73 >> 2] | 0) + (i88 << 2) | 0;
    HEAP32[i59 >> 2] = HEAP32[i59 >> 2] & -2 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 128 + 12 >> 2] & 1;
    i88 = (HEAP32[i73 >> 2] | 0) + (i88 << 2) | 0;
    HEAP32[i88 >> 2] = HEAP32[i88 >> 2] & 1 | HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 144 | 0) + 12 >> 2] << 1;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[i54 >> 2] | 0) >>> 0) break L85;
    i2 = HEAP32[i73 >> 2] | 0;
   }
  } while (0);
  HEAP32[i27 >> 2] = i55;
  i1 = HEAP32[i28 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i55 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i28 >> 2] = i55;
   HEAP32[i73 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i73 >> 2] | 0, i55 << 2, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i88 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i55 << 2, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i88 | 0, HEAP32[i73 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i55;
   HEAP32[i73 >> 2] = i88;
   break;
  } while (0);
  i1 = HEAP32[i27 >> 2] | 0;
  if ((HEAP32[i68 >> 2] | 0) == 2 & (i1 | 0) != 0) {
   i8 = i74 + 644 | 0;
   i7 = 0;
   do {
    i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    if (i2 & 1) {
     i2 = i2 >>> 1;
     i3 = HEAP32[i61 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i62 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 >= i1 >>> 0) break;
      if ((i5 | 0) > -1) {
       HEAP32[i62 >> 2] = i1;
       HEAP32[i60 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i60 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i88 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i88 | 0, HEAP32[i60 >> 2] | 0, HEAP32[i61 >> 2] << 2 | 0) | 0;
       HEAP32[i62 >> 2] = i1;
       HEAP32[i60 >> 2] = i88;
       break;
      }
     } while (0);
     HEAP32[i61 >> 2] = i4;
     HEAP32[(HEAP32[i60 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     i1 = HEAP32[i27 >> 2] | 0;
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i1 >>> 0);
  }
  i26 = i66 + 12 | 0;
  if ((HEAP32[i26 >> 2] | 0) == 2 & (i1 | 0) != 0) {
   i8 = i74 + 664 | 0;
   i7 = 0;
   do {
    i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    if (!(i2 & 1)) {
     i2 = i2 >>> 1;
     i3 = HEAP32[i64 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i65 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 >= i1 >>> 0) break;
      if ((i5 | 0) > -1) {
       HEAP32[i65 >> 2] = i1;
       HEAP32[i63 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i63 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i88 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i88 | 0, HEAP32[i63 >> 2] | 0, HEAP32[i64 >> 2] << 2 | 0) | 0;
       HEAP32[i65 >> 2] = i1;
       HEAP32[i63 >> 2] = i88;
       break;
      }
     } while (0);
     HEAP32[i64 >> 2] = i4;
     HEAP32[(HEAP32[i63 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     i1 = HEAP32[i27 >> 2] | 0;
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i1 >>> 0);
  }
  if ((HEAP32[i69 >> 2] | 0) == 2) {
   i8 = i74 + 680 | 0;
   if (!i1) i1 = 0; else {
    i9 = i74 + 728 | 0;
    i10 = i74 + 692 | 0;
    i11 = i74 + 696 | 0;
    i12 = i74 + 684 | 0;
    i7 = 0;
    do {
     i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i6 = i2 >>> 1;
     do if (i2 & 1) {
      if (HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 >>> 6 << 2) >> 2] & 1 << (i6 & 31) | 0) break;
      i2 = HEAP32[i10 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i11 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 >= i1 >>> 0) break;
       if ((i4 | 0) > -1) {
        HEAP32[i11 >> 2] = i1;
        HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i88 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i88 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
        HEAP32[i11 >> 2] = i1;
        HEAP32[i8 >> 2] = i88;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = i3;
      HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i6;
      i1 = HEAP32[i27 >> 2] | 0;
     } while (0);
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < i1 >>> 0);
   }
  }
  i13 = i66 + 20 | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 | 0) == 2) {
   i12 = i74 + 700 | 0;
   if (!i1) {
    i1 = 0;
    i2 = 2;
   } else {
    i8 = i74 + 728 | 0;
    i9 = i74 + 712 | 0;
    i10 = i74 + 716 | 0;
    i11 = i74 + 704 | 0;
    i7 = 0;
    i2 = i1;
    do {
     i3 = HEAP32[(HEAP32[i73 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i6 = i3 >>> 1;
     do if (!(i3 & 1)) {
      if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 >>> 6 << 2) >> 2] & 1 << (i6 & 31))) break;
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 >= i1 >>> 0) break;
       if ((i4 | 0) > -1) {
        HEAP32[i10 >> 2] = i1;
        HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i88 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i88 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
        HEAP32[i10 >> 2] = i1;
        HEAP32[i12 >> 2] = i88;
        break;
       }
      } while (0);
      HEAP32[i9 >> 2] = i3;
      HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] = i6;
      i1 = HEAP32[i27 >> 2] | 0;
      i2 = i1;
     } while (0);
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < i1 >>> 0);
    i9 = i2;
    i2 = HEAP32[i13 >> 2] | 0;
    i67 = 111;
   }
  } else {
   i9 = i1;
   i67 = 111;
  }
  if ((i67 | 0) == 111) if ((i2 | 0) == 1 & (i1 | 0) != 0) {
   i7 = i74 + 728 | 0;
   i8 = i74 + 520 | 0;
   i6 = HEAP32[i73 >> 2] | 0;
   i5 = 0;
   do {
    i3 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
    i4 = i3 >>> 1;
    do if (!(i3 & 1)) {
     if (!(HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 >>> 6 << 2) >> 2] & 1 << (i4 & 31))) break;
     HEAPF32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] = Math_fround(100.0);
     i1 = i9;
    } while (0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
  }
  if ((HEAP32[i69 >> 2] | 0) == 2) if (!i1) i1 = 0; else i67 = 120; else if ((i2 + -1 | 0) >>> 0 < 2 & (i1 | 0) != 0) i67 = 120;
  if ((i67 | 0) == 120) {
   i6 = i74 + 728 | 0;
   i5 = HEAP32[i73 >> 2] | 0;
   i4 = 0;
   do {
    i1 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
    i2 = 1 << (i1 >>> 1 & 31);
    i3 = HEAP32[i6 >> 2] | 0;
    if (!(i1 & 1)) {
     i88 = i3 + (i1 >>> 6 << 2) | 0;
     HEAP32[i88 >> 2] = HEAP32[i88 >> 2] & ~i2;
    } else {
     i88 = i3 + (i1 >>> 6 << 2) | 0;
     HEAP32[i88 >> 2] = HEAP32[i88 >> 2] | i2;
    }
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i27 >> 2] | 0;
   } while (i4 >>> 0 < i1 >>> 0);
  }
  if ((HEAP32[i68 >> 2] | 0) == 1) {
   if (i1 | 0) i67 = 128;
  } else if ((HEAP32[i69 >> 2] | 0) == 1 & (i1 | 0) != 0) i67 = 128; else i67 = 132;
  if ((i67 | 0) == 128) {
   i5 = i74 + 520 | 0;
   i4 = HEAP32[i73 >> 2] | 0;
   i3 = 0;
   do {
    i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    if (i2 & 1) {
     HEAPF32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 1 << 2) >> 2] = Math_fround(100.0);
     i1 = HEAP32[i27 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
   i67 = 132;
  }
  do if ((i67 | 0) == 132) {
   if (!((HEAP32[i26 >> 2] | 0) == 1 & (i1 | 0) != 0)) break;
   i5 = i74 + 520 | 0;
   i4 = HEAP32[i73 >> 2] | 0;
   i3 = 0;
   do {
    i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    if (!(i2 & 1)) {
     HEAPF32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 1 << 2) >> 2] = Math_fround(100.0);
     i1 = HEAP32[i27 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  } while (0);
  if ((HEAP32[i28 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i73 >> 2] | 0, i29);
   HEAP32[i73 >> 2] = 0;
  }
  if ((HEAP32[i70 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i72 >> 2] | 0, i71);
   HEAP32[i30 >> 2] = 0;
  }
 }
 if (!i75) {
  STACKTOP = i76;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i75);
 STACKTOP = i76;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator13outputObjectsERNS_7ImpTomeERNS_4HashIjiEE(i54, i52, i53) {
 i54 = i54 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, i89 = 0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i83 = i85 + 60 | 0;
 i51 = i85 + 56 | 0;
 i80 = i85 + 32 | 0;
 i81 = i85 + 24 | 0;
 i82 = i85 + 20 | 0;
 i76 = i85 + 16 | 0;
 i77 = i85 + 12 | 0;
 i78 = i85 + 8 | 0;
 i75 = i85;
 i79 = i85 + 4 | 0;
 i1 = HEAP32[i54 >> 2] | 0;
 if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
  i84 = gb + 1451688 | 0;
 } else i84 = gb + 1451688 | 0; else i84 = i1;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i84 >> 2] | 0) + 8 >> 2] | 0, i84 | 0, 80, 0) | 0;
 if (!i1) {
  i3 = 0;
  i7 = 0;
 } else {
  HEAP32[i1 >> 2] = 16;
  i3 = i1 + 16 | 0;
  i7 = 16;
 }
 i72 = i54 + 60 | 0;
 i8 = HEAP32[i72 >> 2] | 0;
 i6 = (i8 | 0) > 0;
 L8 : do if (i6) {
  i5 = HEAP32[i54 + 56 >> 2] | 0;
  i2 = 0;
  i1 = 0;
  i4 = 0;
  do {
   i73 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
   i71 = HEAP32[i73 + 76 >> 2] | 0;
   i1 = i1 | (i71 | 0) != 0 & (i73 + i71 | 0) != 0;
   i2 = i2 | (HEAP32[i73 + 72 >> 2] | 0) != 0;
   i4 = i4 + 1 | 0;
   if (i2 & i1) {
    i2 = 1;
    i1 = 1;
    break L8;
   }
  } while ((i4 | 0) < (i8 | 0));
 } else {
  i2 = 0;
  i1 = 0;
 } while (0);
 i5 = HEAP32[i54 >> 2] | 0;
 HEAP32[i83 >> 2] = i5;
 i4 = (i5 | 0) == 0;
 if (i4) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i83 >> 2] = gb + 1451688;
  HEAP32[i83 + 4 >> 2] = gb + 1451688;
 } else HEAP32[i83 + 4 >> 2] = i5;
 i71 = i83 + 8 | 0;
 HEAP32[i71 >> 2] = 0;
 i73 = i83 + 12 | 0;
 HEAP32[i73 >> 2] = 0;
 i48 = i83 + 16 | 0;
 HEAP32[i48 >> 2] = -1;
 i49 = i83 + 20 | 0;
 HEAP32[i49 >> 2] = 0;
 i50 = i83 + 24 | 0;
 HEAP32[i50 >> 2] = 0;
 i67 = i83 + 28 | 0;
 HEAP32[i67 >> 2] = i5;
 if (i4) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i67 >> 2] = gb + 1451688;
 }
 i68 = i83 + 32 | 0;
 HEAP32[i68 >> 2] = 0;
 i69 = i83 + 36 | 0;
 HEAP32[i69 >> 2] = 0;
 i70 = i83 + 40 | 0;
 HEAP32[i70 >> 2] = 0;
 i66 = i83 + 44 | 0;
 HEAP32[i66 >> 2] = i5;
 if (i4) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i66 >> 2] = gb + 1451688;
 }
 i63 = i83 + 48 | 0;
 HEAP32[i63 >> 2] = 0;
 i64 = i83 + 52 | 0;
 HEAP32[i64 >> 2] = 0;
 i65 = i83 + 56 | 0;
 HEAP32[i65 >> 2] = 0;
 if (i1) if (i6) {
  i17 = i54 + 56 | 0;
  i16 = 0;
  i4 = i7;
  i6 = i7;
  i5 = i8;
  do {
   i13 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i16 << 2) >> 2] | 0;
   i14 = i13 + 64 | 0;
   i7 = HEAP32[i14 >> 2] | 0;
   if ((i7 | 0) > 0) {
    i11 = i13 + 76 | 0;
    i12 = i13 + 80 | 0;
    i10 = 0;
    i8 = i7;
    while (1) {
     i7 = HEAP32[i11 >> 2] | 0;
     i5 = (i7 | 0) == 0;
     i7 = i13 + i7 | 0;
     if (i5 | (i7 | 0) == 0) {
      i7 = (i8 | 0) <= (i10 | 0);
      i7 = i7 | i5 ^ 1 ? i7 & 1 ^ 1 : 1;
     } else i7 = (HEAP32[i7 + (i10 + 1 << 2) >> 2] | 0) - (HEAP32[i7 + (i10 << 2) >> 2] | 0) | 0;
     if ((i4 | 0) < (i7 | 0)) {
      i5 = mftCall_iiii(HEAP32[(HEAP32[i84 >> 2] | 0) + 8 >> 2] | 0, i84 | 0, (i7 << 2) + 16 | 0, 0) | 0;
      if (!i5) i9 = i4; else {
       HEAP32[i5 >> 2] = i7;
       if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i84 >> 2] | 0) + 12 >> 2] | 0, i84 | 0, i3 + -16 | 0);
       i3 = i5 + 16 | 0;
       i9 = i7;
       i6 = i7;
      }
     } else {
      i9 = i4;
      i6 = i7;
     }
     i5 = HEAP32[i11 >> 2] | 0;
     i4 = (i5 | 0) == 0;
     i5 = i13 + i5 | 0;
     if (i4 | (i5 | 0) == 0) {
      if ((HEAP32[i14 >> 2] | 0) > (i10 | 0)) {
       if (i4) {
        i4 = HEAP32[i12 >> 2] | 0;
        i4 = HEAP32[((i4 | 0) == 0 ? 0 : i13 + i4 | 0) + (i10 << 2) >> 2] | 0;
       } else i4 = -1;
       if ((i3 | 0) != 0 & (i6 | 0) > 0) HEAP32[i3 >> 2] = i4;
      }
     } else {
      i7 = HEAP32[i5 + (i10 << 2) >> 2] | 0;
      i4 = (HEAP32[i5 + (i10 + 1 << 2) >> 2] | 0) - i7 | 0;
      if (i3 | 0) {
       i5 = (i4 | 0) <= (i6 | 0) ? i4 : i6;
       if ((i5 | 0) > 0) {
        i62 = HEAP32[i12 >> 2] | 0;
        HEAP32[i3 >> 2] = HEAP32[((i62 | 0) == 0 ? 0 : i13 + i62 | 0) + (i7 << 2) >> 2];
        if ((i5 | 0) != 1) {
         i4 = 1;
         do {
          i62 = HEAP32[i11 >> 2] | 0;
          i61 = HEAP32[i12 >> 2] | 0;
          HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[((i61 | 0) == 0 ? 0 : i13 + i61 | 0) + (HEAP32[((i62 | 0) == 0 ? 0 : i13 + i62 | 0) + (i10 << 2) >> 2] << 2) + (i4 << 2) >> 2];
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) < (i5 | 0));
        }
       }
      }
     }
     if ((i6 | 0) > 0) {
      i4 = 0;
      do {
       HEAP32[i51 >> 2] = HEAP32[i3 + (i4 << 2) >> 2];
       if ((i4 | 0) > 0) __ZN5Umbra9UnionFindIjE9unionSetsERKjS3_(i83, i3, i51);
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i10 = i10 + 1 | 0;
     i8 = HEAP32[i14 >> 2] | 0;
     if ((i10 | 0) >= (i8 | 0)) break; else i4 = i9;
    }
    i4 = i9;
    i5 = HEAP32[i72 >> 2] | 0;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) < (i5 | 0));
  i9 = i4;
  i4 = HEAP32[i54 >> 2] | 0;
 } else {
  i9 = i7;
  i6 = i7;
  i4 = i5;
  i5 = i8;
 } else {
  i9 = i7;
  i6 = i7;
  i4 = i5;
  i5 = i8;
 }
 HEAP32[i51 >> 2] = 0;
 HEAP32[i80 >> 2] = i4;
 if (!i4) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i80 >> 2] = gb + 1451688;
 }
 i32 = i80 + 4 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i80 + 8 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i80 + 12 >> 2] = -1;
 HEAP32[i80 + 16 >> 2] = 0;
 HEAP32[i80 + 20 >> 2] = 0;
 L83 : do if ((i5 | 0) > 0) {
  i26 = i54 + 56 | 0;
  i27 = i53 + 16 | 0;
  i28 = i53 + 12 | 0;
  i29 = i53 + 8 | 0;
  i30 = i53 + 4 | 0;
  i31 = i53 + 20 | 0;
  i25 = 0;
  i4 = i9;
  L85 : while (1) {
   i13 = HEAP32[(HEAP32[i26 >> 2] | 0) + (i25 << 2) >> 2] | 0;
   i14 = i13 + 64 | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   if ((i5 | 0) > 0) {
    i16 = i13 + 76 | 0;
    i17 = i13 + 80 | 0;
    i12 = 0;
    i8 = i6;
    i7 = i5;
    while (1) {
     i6 = HEAP32[i16 >> 2] | 0;
     i5 = (i6 | 0) == 0;
     i6 = i13 + i6 | 0;
     if (i5 | (i6 | 0) == 0) {
      i6 = (i7 | 0) <= (i12 | 0);
      i6 = i6 | i5 ^ 1 ? i6 & 1 ^ 1 : 1;
     } else i6 = (HEAP32[i6 + (i12 + 1 << 2) >> 2] | 0) - (HEAP32[i6 + (i12 << 2) >> 2] | 0) | 0;
     if ((i4 | 0) < (i6 | 0)) {
      i5 = mftCall_iiii(HEAP32[(HEAP32[i84 >> 2] | 0) + 8 >> 2] | 0, i84 | 0, (i6 << 2) + 16 | 0, 0) | 0;
      if (!i5) i6 = i8; else {
       HEAP32[i5 >> 2] = i6;
       if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i84 >> 2] | 0) + 12 >> 2] | 0, i84 | 0, i3 + -16 | 0);
       i3 = i5 + 16 | 0;
       i4 = i6;
      }
     }
     i7 = HEAP32[i16 >> 2] | 0;
     i5 = (i7 | 0) == 0;
     i7 = i13 + i7 | 0;
     do if (i5 | (i7 | 0) == 0) {
      if ((HEAP32[i14 >> 2] | 0) > (i12 | 0)) {
       if (i5) {
        i5 = HEAP32[i17 >> 2] | 0;
        i5 = HEAP32[((i5 | 0) == 0 ? 0 : i13 + i5 | 0) + (i12 << 2) >> 2] | 0;
       } else i5 = -1;
       if (!((i3 | 0) != 0 & (i6 | 0) > 0)) break;
       HEAP32[i3 >> 2] = i5;
      }
     } else {
      i8 = HEAP32[i7 + (i12 << 2) >> 2] | 0;
      i5 = (HEAP32[i7 + (i12 + 1 << 2) >> 2] | 0) - i8 | 0;
      if (i3 | 0) {
       i7 = (i5 | 0) <= (i6 | 0) ? i5 : i6;
       if ((i7 | 0) > 0) {
        i62 = HEAP32[i17 >> 2] | 0;
        HEAP32[i3 >> 2] = HEAP32[((i62 | 0) == 0 ? 0 : i13 + i62 | 0) + (i8 << 2) >> 2];
        if ((i7 | 0) == 1) break; else i5 = 1;
        do {
         i62 = HEAP32[i16 >> 2] | 0;
         i61 = HEAP32[i17 >> 2] | 0;
         HEAP32[i3 + (i5 << 2) >> 2] = HEAP32[((i61 | 0) == 0 ? 0 : i13 + i61 | 0) + (HEAP32[((i62 | 0) == 0 ? 0 : i13 + i62 | 0) + (i12 << 2) >> 2] << 2) + (i5 << 2) >> 2];
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) < (i7 | 0));
       }
      }
     } while (0);
     if ((i6 | 0) > 0) {
      i11 = 0;
      do {
       i10 = HEAP32[i3 + (i11 << 2) >> 2] | 0;
       HEAP32[i81 >> 2] = i10;
       i7 = HEAP32[i27 >> 2] | 0;
       L118 : do if (!i7) i74 = 87; else {
        i5 = (HEAP32[i30 >> 2] | 0) + (((i10 >>> 5) + i10 + (i10 >>> 10) + (i10 >>> 20) & i7 + -1) << 2) | 0;
        if (!i5) {
         i74 = 87;
         break;
        }
        i5 = HEAP32[i5 >> 2] | 0;
        if ((i5 | 0) == -1) {
         i74 = 87;
         break;
        }
        i8 = HEAP32[i29 >> 2] | 0;
        while (1) {
         if ((HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] | 0) == (i10 | 0)) break L118;
         i5 = HEAP32[i8 + (i5 * 12 | 0) >> 2] | 0;
         if ((i5 | 0) == -1) {
          i74 = 87;
          break;
         }
        }
       } while (0);
       do if ((i74 | 0) == 87) {
        i74 = 0;
        if (!i1) {
         i9 = HEAP32[i51 >> 2] | 0;
         HEAP32[i51 >> 2] = i9 + 1;
         i5 = HEAP32[i28 >> 2] | 0;
         if ((i5 | 0) == -1) {
          if (!(__ZN5Umbra4HashIjiE6rehashEj(i53, 0) | 0)) {
           i74 = 103;
           break L85;
          }
          i5 = HEAP32[i28 >> 2] | 0;
          i8 = HEAP32[i81 >> 2] | 0;
          i7 = HEAP32[i27 >> 2] | 0;
         } else i8 = i10;
         i62 = HEAP32[i29 >> 2] | 0;
         i61 = i62 + (i5 * 12 | 0) | 0;
         HEAP32[i28 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i62 + (i5 * 12 | 0) + 4 >> 2] = i8;
         HEAP32[i62 + (i5 * 12 | 0) + 8 >> 2] = i9;
         i62 = (HEAP32[i30 >> 2] | 0) + (((i8 >>> 5) + i8 + (i8 >>> 10) + (i8 >>> 20) & i7 + -1) << 2) | 0;
         HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
         HEAP32[i62 >> 2] = i5;
         HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
         break;
        }
        i5 = __ZNK5Umbra9UnionFindIjE8getIndexERKj(i83, i81) | 0;
        i9 = HEAP32[i68 >> 2] | 0;
        i8 = i5;
        while (1) {
         i7 = HEAP32[i9 + (i8 << 2) >> 2] | 0;
         if ((i7 | 0) == (i8 | 0) | (i7 | 0) == -1) break; else i8 = i7;
        }
        if ((i5 | 0) != (i8 | 0)) do {
         i62 = i9 + (i5 << 2) | 0;
         i5 = HEAP32[i62 >> 2] | 0;
         HEAP32[i62 >> 2] = i8;
        } while ((i5 | 0) != (i8 | 0));
        HEAP32[i82 >> 2] = i8;
        i7 = __ZN5Umbra4HashIiiE10getDefaultERKiS3_(i80, i82, i51) | 0;
        i5 = HEAP32[i7 >> 2] | 0;
        if ((i5 | 0) == (HEAP32[i51 >> 2] | 0)) HEAP32[i51 >> 2] = i5 + 1;
        i5 = HEAP32[i28 >> 2] | 0;
        if ((i5 | 0) == -1) {
         if (!(__ZN5Umbra4HashIjiE6rehashEj(i53, 0) | 0)) {
          i74 = 98;
          break L85;
         }
         i5 = HEAP32[i28 >> 2] | 0;
        }
        i60 = HEAP32[i29 >> 2] | 0;
        i61 = i60 + (i5 * 12 | 0) | 0;
        HEAP32[i28 >> 2] = HEAP32[i61 >> 2];
        i59 = HEAP32[i81 >> 2] | 0;
        i62 = (i59 >>> 5) + i59 + (i59 >>> 10) + (i59 >>> 20) & (HEAP32[i27 >> 2] | 0) + -1;
        HEAP32[i60 + (i5 * 12 | 0) + 4 >> 2] = i59;
        HEAP32[i60 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i7 >> 2];
        i62 = (HEAP32[i30 >> 2] | 0) + (i62 << 2) | 0;
        HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
        HEAP32[i62 >> 2] = i5;
        HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
       } while (0);
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) < (i6 | 0));
     }
     i12 = i12 + 1 | 0;
     i7 = HEAP32[i14 >> 2] | 0;
     if ((i12 | 0) >= (i7 | 0)) break; else i8 = i6;
    }
   }
   i25 = i25 + 1 | 0;
   if ((i25 | 0) >= (HEAP32[i72 >> 2] | 0)) {
    i5 = 1;
    i16 = i4;
    i14 = i6;
    break L83;
   }
  }
  if ((i74 | 0) == 98) HEAP32[i54 + 464 >> 2] = 1; else if ((i74 | 0) == 103) HEAP32[i54 + 464 >> 2] = 1;
  i5 = 0;
  i16 = i4;
  i14 = i6;
 } else {
  i5 = 1;
  i16 = i9;
  i14 = i6;
 } while (0);
 i4 = HEAP32[i32 >> 2] | 0;
 if (i4 | 0) {
  i62 = HEAP32[i80 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i62 >> 2] | 0) + 12 >> 2] | 0, i62 | 0, i4 + -16 | 0);
 }
 i4 = HEAP32[i33 >> 2] | 0;
 if (i4 | 0) {
  i62 = HEAP32[i80 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i62 >> 2] | 0) + 12 >> 2] | 0, i62 | 0, i4 + -16 | 0);
 }
 do if (i5) {
  i5 = i83 + 4 | 0;
  i4 = HEAP32[i71 >> 2] | 0;
  if (i4 | 0) {
   i62 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i62 >> 2] | 0) + 12 >> 2] | 0, i62 | 0, i4 + -16 | 0);
  }
  i4 = HEAP32[i73 >> 2] | 0;
  if (i4 | 0) {
   i62 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i62 >> 2] | 0) + 12 >> 2] | 0, i62 | 0, i4 + -16 | 0);
  }
  HEAP32[i71 >> 2] = 0;
  HEAP32[i73 >> 2] = 0;
  HEAP32[i48 >> 2] = -1;
  HEAP32[i49 >> 2] = 0;
  HEAP32[i50 >> 2] = 0;
  if ((HEAP32[i69 >> 2] | 0) < 0) {
   i5 = HEAP32[i67 >> 2] | 0;
   i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 16, 0) | 0;
   if (i5 | 0) {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i69 >> 2] = 0;
    i4 = HEAP32[i68 >> 2] | 0;
    if (i4 | 0) {
     i74 = HEAP32[i67 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i74 >> 2] | 0) + 12 >> 2] | 0, i74 | 0, i4 + -16 | 0);
    }
    HEAP32[i68 >> 2] = i5 + 16;
    i74 = 122;
   }
  } else i74 = 122;
  if ((i74 | 0) == 122) HEAP32[i70 >> 2] = 0;
  if ((HEAP32[i64 >> 2] | 0) < 0) {
   i5 = HEAP32[i66 >> 2] | 0;
   i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 16, 0) | 0;
   if (i5 | 0) {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i64 >> 2] = 0;
    i4 = HEAP32[i63 >> 2] | 0;
    if (i4 | 0) {
     i74 = HEAP32[i66 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i74 >> 2] | 0) + 12 >> 2] | 0, i74 | 0, i4 + -16 | 0);
    }
    HEAP32[i63 >> 2] = i5 + 16;
    i74 = 128;
   }
  } else i74 = 128;
  if ((i74 | 0) == 128) HEAP32[i65 >> 2] = 0;
  i10 = HEAP32[i51 >> 2] | 0;
  i11 = i52 + 64 | 0;
  HEAP32[i11 >> 2] = i10;
  i4 = i10 * 24 | 0;
  i5 = i2 ? i10 << 5 : 0;
  i6 = HEAP32[i53 + 20 >> 2] << 2;
  i10 = i1 ? (i10 << 2) + 4 | 0 : 0;
  if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i54 + 300 | 0, i4 + 64 + i5 + i6 + i10 | 0, 65536) | 0)) {
   HEAP32[i54 + 464 >> 2] = 1;
   i4 = 0;
   break;
  }
  i60 = i4 + 15 & -16;
  i7 = i54 + 452 | 0;
  i8 = i54 + 444 | 0;
  i9 = (HEAP32[i8 >> 2] | 0) + (((HEAP32[i7 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i62 = HEAP32[i9 >> 2] | 0;
  _memset(i62 | 0, 0, i60 | 0) | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i60;
  i9 = i54 + 432 | 0;
  i61 = HEAP32[i9 >> 2] | 0;
  HEAP32[i52 + 68 >> 2] = (HEAP32[i54 + 304 + (i61 << 3) + 4 >> 2] | 0) - (HEAP32[i54 + 304 + (i61 << 3) >> 2] | 0);
  i61 = i54 + 304 + (HEAP32[i9 >> 2] << 3) + 4 | 0;
  HEAP32[i61 >> 2] = (HEAP32[i61 >> 2] | 0) + i60;
  if ((HEAP32[i11 >> 2] | 0) > 0) {
   i4 = 0;
   do {
    HEAPF32[i62 + (i4 * 24 | 0) >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i62 + (i4 * 24 | 0) + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i62 + (i4 * 24 | 0) + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i62 + (i4 * 24 | 0) + 12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i62 + (i4 * 24 | 0) + 16 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i62 + (i4 * 24 | 0) + 20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (HEAP32[i11 >> 2] | 0));
  }
  if (i2) {
   i60 = (HEAP32[i8 >> 2] | 0) + (((HEAP32[i7 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i61 = HEAP32[i60 >> 2] | 0;
   _memset(i61 | 0, 0, i5 | 0) | 0;
   HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i5;
   i60 = HEAP32[i9 >> 2] | 0;
   HEAP32[i52 + 72 >> 2] = (HEAP32[i54 + 304 + (i60 << 3) + 4 >> 2] | 0) - (HEAP32[i54 + 304 + (i60 << 3) >> 2] | 0);
   i60 = i54 + 304 + (HEAP32[i9 >> 2] << 3) + 4 | 0;
   HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i5;
  } else i61 = 0;
  i59 = i6 + 15 & -16;
  i60 = (HEAP32[i8 >> 2] | 0) + (((HEAP32[i7 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i13 = HEAP32[i60 >> 2] | 0;
  _memset(i13 | 0, 0, i59 | 0) | 0;
  HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i59;
  i60 = HEAP32[i9 >> 2] | 0;
  HEAP32[i52 + 80 >> 2] = (HEAP32[i54 + 304 + (i60 << 3) + 4 >> 2] | 0) - (HEAP32[i54 + 304 + (i60 << 3) >> 2] | 0);
  i60 = i54 + 304 + (HEAP32[i9 >> 2] << 3) + 4 | 0;
  HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i59;
  if (i1) {
   i59 = i10 + 15 & -16;
   i60 = (HEAP32[i8 >> 2] | 0) + (((HEAP32[i7 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i12 = HEAP32[i60 >> 2] | 0;
   _memset(i12 | 0, 0, i59 | 0) | 0;
   HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i59;
   i60 = HEAP32[i9 >> 2] | 0;
   HEAP32[i52 + 76 >> 2] = (HEAP32[i54 + 304 + (i60 << 3) + 4 >> 2] | 0) - (HEAP32[i54 + 304 + (i60 << 3) >> 2] | 0);
   i60 = i54 + 304 + (HEAP32[i9 >> 2] << 3) + 4 | 0;
   HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + i59;
  } else i12 = 0;
  HEAP8[i54 + 436 >> 0] = 0;
  i60 = i53 + 16 | 0;
  i6 = HEAP32[i60 >> 2] | 0;
  i59 = i53 + 4 | 0;
  i8 = HEAP32[i59 >> 2] | 0;
  L201 : do if (!i6) {
   i4 = 0;
   i5 = -1;
  } else {
   i5 = HEAP32[i8 >> 2] | 0;
   if ((i6 | 0) > 0 & (i5 | 0) == -1) i4 = 0; else {
    i4 = 0;
    break;
   }
   do {
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (i6 | 0)) {
     i5 = -1;
     break L201;
    }
    i5 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
   } while ((i5 | 0) == -1);
  } while (0);
  i58 = i53 + 8 | 0;
  i7 = HEAP32[i58 >> 2] | 0;
  L207 : do if (!i12) L208 : while (1) {
   while (1) {
    do {
     if (!((i5 | 0) != -1 & (i4 | 0) < (i6 | 0))) break L207;
     HEAP32[i13 + (HEAP32[i7 + (i5 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i7 + (i5 * 12 | 0) + 4 >> 2];
     i5 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
     i6 = HEAP32[i60 >> 2] | 0;
    } while ((i5 | 0) != -1);
    if ((i4 | 0) < (i6 | 0)) break; else i5 = -1;
   }
   while (1) {
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (i6 | 0)) {
     i5 = -1;
     continue L208;
    }
    i5 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) continue L208;
   }
  } else L219 : while (1) {
   while (1) {
    do {
     if (!((i5 | 0) != -1 & (i4 | 0) < (i6 | 0))) break L207;
     i57 = HEAP32[i7 + (i5 * 12 | 0) + 4 >> 2] | 0;
     i6 = HEAP32[i7 + (i5 * 12 | 0) + 8 >> 2] | 0;
     i56 = i12 + (i6 + 1 << 2) | 0;
     HEAP32[i56 >> 2] = (HEAP32[i56 >> 2] | 0) + 1;
     HEAP32[i13 + (i6 << 2) >> 2] = i57;
     i5 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
     i6 = HEAP32[i60 >> 2] | 0;
    } while ((i5 | 0) != -1);
    if ((i4 | 0) < (i6 | 0)) break; else i5 = -1;
   }
   while (1) {
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (i6 | 0)) {
     i5 = -1;
     continue L219;
    }
    i5 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) continue L219;
   }
  } while (0);
  L231 : do if (i1) {
   do if ((HEAP32[i11 >> 2] | 0) > 0) {
    i1 = 0;
    i5 = HEAP32[i12 >> 2] | 0;
    do {
     i1 = i1 + 1 | 0;
     i4 = i12 + (i1 << 2) | 0;
     i5 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
     HEAP32[i4 >> 2] = i5;
     i4 = HEAP32[i11 >> 2] | 0;
    } while ((i1 | 0) < (i4 | 0));
    if ((i4 | 0) <= 0) break;
    do {
     i5 = i4;
     i4 = i4 + -1 | 0;
     i1 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
     i6 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
     if ((i1 | 0) < (i6 | 0)) {
      i7 = i13 + (i4 << 2) | 0;
      do {
       HEAP32[i13 + (i1 << 2) >> 2] = HEAP32[i7 >> 2];
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i6 | 0));
     }
    } while ((i5 | 0) > 1);
   } while (0);
   i5 = HEAP32[i60 >> 2] | 0;
   L246 : do if (!i5) {
    i1 = 0;
    i4 = -1;
   } else {
    i4 = HEAP32[i8 >> 2] | 0;
    if ((i5 | 0) > 0 & (i4 | 0) == -1) i1 = 0; else {
     i1 = 0;
     break;
    }
    do {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i5 | 0)) {
      i4 = -1;
      break L246;
     }
     i4 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
    } while ((i4 | 0) == -1);
   } while (0);
   i9 = HEAP32[i58 >> 2] | 0;
   i10 = HEAP32[i59 >> 2] | 0;
   L252 : while (1) {
    while (1) {
     do {
      if (!((i4 | 0) != -1 & (i1 | 0) < (i5 | 0))) break L231;
      i7 = HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] | 0;
      i5 = HEAP32[i12 + (HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0;
      i8 = HEAP32[i13 + (i5 << 2) >> 2] | 0;
      if ((i7 | 0) != (i8 | 0)) {
       do {
        i5 = i5 + 1 | 0;
        i6 = i13 + (i5 << 2) | 0;
       } while ((HEAP32[i6 >> 2] | 0) != (i8 | 0));
       HEAP32[i6 >> 2] = i7;
      }
      i4 = HEAP32[i9 + (i4 * 12 | 0) >> 2] | 0;
      i5 = HEAP32[i60 >> 2] | 0;
     } while ((i4 | 0) != -1);
     if ((i1 | 0) < (i5 | 0)) break; else i4 = -1;
    }
    while (1) {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i5 | 0)) {
      i4 = -1;
      continue L252;
     }
     i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
     if ((i4 | 0) != -1) continue L252;
    }
   }
  } while (0);
  i4 = HEAP32[i72 >> 2] | 0;
  if ((i4 | 0) <= 0) {
   i4 = 1;
   break;
  }
  i57 = i54 + 56 | 0;
  i56 = 0;
  i5 = i16;
  i1 = i14;
  do {
   i53 = HEAP32[(HEAP32[i57 >> 2] | 0) + (i56 << 2) >> 2] | 0;
   i55 = HEAP32[i53 + 68 >> 2] | 0;
   i54 = i53 + 64 | 0;
   i52 = HEAP32[i53 + 72 >> 2] | 0;
   i55 = (i55 | 0) == 0 ? 0 : i53 + i55 | 0;
   i52 = (i52 | 0) == 0 ? 0 : i53 + i52 | 0;
   i6 = HEAP32[i54 >> 2] | 0;
   if ((i6 | 0) > 0) {
    i49 = i53 + 76 | 0;
    i50 = i53 + 80 | 0;
    i51 = (i52 | 0) == 0;
    i48 = 0;
    i7 = i6;
    do {
     i6 = HEAP32[i49 >> 2] | 0;
     i4 = (i6 | 0) == 0;
     i6 = i53 + i6 | 0;
     if (i4 | (i6 | 0) == 0) {
      i6 = (i7 | 0) <= (i48 | 0);
      i6 = i6 | i4 ^ 1 ? i6 & 1 ^ 1 : 1;
     } else i6 = (HEAP32[i6 + (i48 + 1 << 2) >> 2] | 0) - (HEAP32[i6 + (i48 << 2) >> 2] | 0) | 0;
     do if ((i5 | 0) < (i6 | 0)) {
      i4 = mftCall_iiii(HEAP32[(HEAP32[i84 >> 2] | 0) + 8 >> 2] | 0, i84 | 0, (i6 << 2) + 16 | 0, 0) | 0;
      if (!i4) break;
      HEAP32[i4 >> 2] = i6;
      if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i84 >> 2] | 0) + 12 >> 2] | 0, i84 | 0, i3 + -16 | 0);
      i3 = i4 + 16 | 0;
      i5 = i6;
      i1 = i6;
     } else i1 = i6; while (0);
     i6 = HEAP32[i49 >> 2] | 0;
     i4 = (i6 | 0) == 0;
     i6 = i53 + i6 | 0;
     do if (i4 | (i6 | 0) == 0) {
      if ((HEAP32[i54 >> 2] | 0) <= (i48 | 0)) break;
      if (i4) {
       i4 = HEAP32[i50 >> 2] | 0;
       i4 = HEAP32[((i4 | 0) == 0 ? 0 : i53 + i4 | 0) + (i48 << 2) >> 2] | 0;
      } else i4 = -1;
      if (!((i3 | 0) != 0 & (i1 | 0) > 0)) break;
      HEAP32[i3 >> 2] = i4;
     } else {
      i7 = HEAP32[i6 + (i48 << 2) >> 2] | 0;
      i4 = (HEAP32[i6 + (i48 + 1 << 2) >> 2] | 0) - i7 | 0;
      if (!i3) break;
      i6 = (i4 | 0) <= (i1 | 0) ? i4 : i1;
      if ((i6 | 0) <= 0) break;
      i33 = HEAP32[i50 >> 2] | 0;
      HEAP32[i3 >> 2] = HEAP32[((i33 | 0) == 0 ? 0 : i53 + i33 | 0) + (i7 << 2) >> 2];
      if ((i6 | 0) == 1) break; else i4 = 1;
      do {
       i33 = HEAP32[i49 >> 2] | 0;
       i32 = HEAP32[i50 >> 2] | 0;
       HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[((i32 | 0) == 0 ? 0 : i53 + i32 | 0) + (HEAP32[((i33 | 0) == 0 ? 0 : i53 + i33 | 0) + (i48 << 2) >> 2] << 2) + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (i6 | 0));
     } while (0);
     i4 = HEAP32[i55 + (i48 * 24 | 0) >> 2] | 0;
     HEAP32[i80 >> 2] = i4;
     i10 = HEAP32[i55 + (i48 * 24 | 0) + 4 >> 2] | 0;
     HEAP32[i81 >> 2] = i10;
     i6 = HEAP32[i55 + (i48 * 24 | 0) + 8 >> 2] | 0;
     HEAP32[i82 >> 2] = i6;
     i7 = HEAP32[i55 + (i48 * 24 | 0) + 12 >> 2] | 0;
     HEAP32[i76 >> 2] = i7;
     i8 = HEAP32[i55 + (i48 * 24 | 0) + 16 >> 2] | 0;
     HEAP32[i77 >> 2] = i8;
     i9 = HEAP32[i55 + (i48 * 24 | 0) + 20 >> 2] | 0;
     HEAP32[i78 >> 2] = i9;
     HEAP32[i75 >> 2] = 0;
     HEAP32[i79 >> 2] = 2139095039;
     if (i51) {
      i26 = 0;
      f15 = Math_fround(0.0);
      i27 = i4;
      i28 = i6;
      i29 = i7;
      i30 = i8;
      i31 = i9;
      i32 = 2139095039;
      f18 = Math_fround(3402823469999999843913219.0e14);
      i33 = i10;
     } else {
      i27 = HEAP32[i52 + (i48 << 5) >> 2] | 0;
      i33 = HEAP32[i52 + (i48 << 5) + 4 >> 2] | 0;
      i28 = HEAP32[i52 + (i48 << 5) + 8 >> 2] | 0;
      i29 = HEAP32[i52 + (i48 << 5) + 16 >> 2] | 0;
      i30 = HEAP32[i52 + (i48 << 5) + 20 >> 2] | 0;
      i31 = HEAP32[i52 + (i48 << 5) + 24 >> 2] | 0;
      i26 = HEAP32[i52 + (i48 << 5) + 12 >> 2] | 0;
      i25 = HEAP32[i52 + (i48 << 5) + 28 >> 2] | 0;
      HEAP32[i75 >> 2] = i26;
      HEAP32[i79 >> 2] = i25;
      f15 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i32 = i25;
      f18 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     }
     if ((i1 | 0) > 0) {
      f39 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f34 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f38 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f36 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f35 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f42 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f43 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f44 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f45 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f46 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f47 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i25 = 0;
      i17 = i8;
      i16 = i10;
      while (1) {
       i10 = HEAP32[i3 + (i25 << 2) >> 2] | 0;
       i11 = HEAP32[i58 >> 2] | 0;
       i8 = HEAP32[(HEAP32[i59 >> 2] | 0) + (((i10 >>> 5) + i10 + (i10 >>> 10) + (i10 >>> 20) & (HEAP32[i60 >> 2] | 0) + -1) << 2) >> 2] | 0;
       if ((HEAP32[i11 + (i8 * 12 | 0) + 4 >> 2] | 0) != (i10 | 0)) do i8 = HEAP32[i11 + (i8 * 12 | 0) >> 2] | 0; while ((HEAP32[i11 + (i8 * 12 | 0) + 4 >> 2] | 0) != (i10 | 0));
       i14 = HEAP32[i11 + (i8 * 12 | 0) + 8 >> 2] | 0;
       i13 = i62 + (i14 * 24 | 0) | 0;
       f19 = Math_fround(HEAPF32[i13 >> 2]);
       f20 = Math_fround(HEAPF32[i62 + (i14 * 24 | 0) + 12 >> 2]);
       i12 = i62 + (i14 * 24 | 0) + 4 | 0;
       do if (!(f19 <= f20)) {
        i8 = i62 + (i14 * 24 | 0) + 16 | 0;
        i74 = 215;
       } else {
        f21 = Math_fround(HEAPF32[i12 >> 2]);
        i8 = i62 + (i14 * 24 | 0) + 16 | 0;
        f22 = Math_fround(HEAPF32[i8 >> 2]);
        if (!(f21 <= f22)) {
         i74 = 215;
         break;
        }
        i10 = i62 + (i14 * 24 | 0) + 8 | 0;
        f23 = Math_fround(HEAPF32[i10 >> 2]);
        i11 = i62 + (i14 * 24 | 0) + 20 | 0;
        f24 = Math_fround(HEAPF32[i11 >> 2]);
        if (!(f23 <= f24)) {
         i74 = 215;
         break;
        }
        f88 = Math_fround(HEAPF32[i80 >> 2]);
        f87 = Math_fround(HEAPF32[i81 >> 2]);
        i4 = HEAP32[(f21 <= f87 ? i12 : i81) >> 2] | 0;
        f86 = Math_fround(HEAPF32[i82 >> 2]);
        i6 = HEAP32[(f23 <= f86 ? i10 : i82) >> 2] | 0;
        HEAP32[i13 >> 2] = HEAP32[(f19 <= f88 ? i13 : i80) >> 2];
        HEAP32[i12 >> 2] = i4;
        HEAP32[i10 >> 2] = i6;
        i6 = i62 + (i14 * 24 | 0) + 12 | 0;
        f19 = Math_fround(HEAPF32[i76 >> 2]);
        f21 = Math_fround(HEAPF32[i77 >> 2]);
        i10 = HEAP32[(f22 >= f21 ? i8 : i77) >> 2] | 0;
        f23 = Math_fround(HEAPF32[i78 >> 2]);
        i4 = HEAP32[(f24 >= f23 ? i11 : i78) >> 2] | 0;
        HEAP32[i6 >> 2] = HEAP32[(f20 >= f19 ? i6 : i76) >> 2];
        HEAP32[i8 >> 2] = i10;
        HEAP32[i11 >> 2] = i4;
        i4 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
        i10 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
        i7 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
        i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
        if (!i2) {
         f24 = f39;
         f23 = f38;
         f22 = f37;
         f21 = f36;
         f20 = f35;
         f19 = f34;
         break;
        }
        i89 = i61 + (i14 << 5) | 0;
        i13 = i61 + (i14 << 5) + 16 | 0;
        f19 = Math_fround(HEAPF32[i89 >> 2]);
        i11 = i61 + (i14 << 5) + 4 | 0;
        f20 = Math_fround(HEAPF32[i11 >> 2]);
        i12 = i61 + (i14 << 5) + 8 | 0;
        f21 = Math_fround(HEAPF32[i12 >> 2]);
        f22 = Math_fround(HEAPF32[i13 >> 2]);
        i16 = i61 + (i14 << 5) + 20 | 0;
        f23 = Math_fround(HEAPF32[i16 >> 2]);
        i17 = i61 + (i14 << 5) + 24 | 0;
        f24 = Math_fround(HEAPF32[i17 >> 2]);
        HEAPF32[i89 >> 2] = f19 <= f39 ? f19 : f39;
        HEAPF32[i11 >> 2] = f20 <= f34 ? f20 : f34;
        HEAPF32[i12 >> 2] = f21 <= f38 ? f21 : f38;
        HEAPF32[i13 >> 2] = f22 >= f37 ? f22 : f37;
        HEAPF32[i16 >> 2] = f23 >= f36 ? f23 : f36;
        HEAPF32[i17 >> 2] = f24 >= f35 ? f24 : f35;
        i17 = i61 + (i14 << 5) + 12 | 0;
        i16 = Math_fround(HEAPF32[i17 >> 2]) <= f15;
        HEAP32[i17 >> 2] = HEAP32[(i16 ? i17 : i75) >> 2];
        i17 = i61 + (i14 << 5) + 28 | 0;
        i16 = Math_fround(HEAPF32[i17 >> 2]) >= f18;
        HEAP32[i17 >> 2] = HEAP32[(i16 ? i17 : i79) >> 2];
        f24 = f39;
        f23 = f38;
        f22 = f37;
        f21 = f36;
        f20 = f35;
        f19 = f34;
       } while (0);
       do if ((i74 | 0) == 215) {
        i74 = 0;
        HEAP32[i13 >> 2] = i4;
        HEAP32[i12 >> 2] = i16;
        HEAP32[i62 + (i14 * 24 | 0) + 8 >> 2] = i6;
        HEAP32[i62 + (i14 * 24 | 0) + 12 >> 2] = i7;
        HEAP32[i8 >> 2] = i17;
        HEAP32[i62 + (i14 * 24 | 0) + 20 >> 2] = i9;
        if (!i2) {
         f24 = f39;
         f23 = f38;
         f22 = f37;
         f21 = f36;
         i8 = i17;
         f20 = f35;
         f19 = f34;
         i10 = i16;
         break;
        }
        HEAP32[i61 + (i14 << 5) >> 2] = i27;
        HEAP32[i61 + (i14 << 5) + 4 >> 2] = i33;
        HEAP32[i61 + (i14 << 5) + 8 >> 2] = i28;
        HEAP32[i61 + (i14 << 5) + 16 >> 2] = i29;
        HEAP32[i61 + (i14 << 5) + 20 >> 2] = i30;
        HEAP32[i61 + (i14 << 5) + 24 >> 2] = i31;
        HEAP32[i61 + (i14 << 5) + 12 >> 2] = i26;
        HEAP32[i61 + (i14 << 5) + 28 >> 2] = i32;
        f15 = f46;
        f24 = f40;
        f23 = f42;
        f22 = f43;
        f21 = f44;
        i8 = i17;
        f20 = f45;
        f18 = f47;
        f19 = f41;
        i10 = i16;
       } while (0);
       i25 = i25 + 1 | 0;
       if ((i25 | 0) == (i1 | 0)) break; else {
        f39 = f24;
        f38 = f23;
        f37 = f22;
        f36 = f21;
        i17 = i8;
        f35 = f20;
        f34 = f19;
        i16 = i10;
       }
      }
     }
     i48 = i48 + 1 | 0;
     i7 = HEAP32[i54 >> 2] | 0;
    } while ((i48 | 0) < (i7 | 0));
    i4 = HEAP32[i72 >> 2] | 0;
   }
   i56 = i56 + 1 | 0;
  } while ((i56 | 0) < (i4 | 0));
  i4 = 1;
 } else i4 = 0; while (0);
 i1 = HEAP32[i63 >> 2] | 0;
 if (i1 | 0) {
  i89 = HEAP32[i66 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i89 >> 2] | 0) + 12 >> 2] | 0, i89 | 0, i1 + -16 | 0);
 }
 HEAP32[i63 >> 2] = 0;
 HEAP32[i64 >> 2] = 0;
 HEAP32[i65 >> 2] = 0;
 i1 = HEAP32[i68 >> 2] | 0;
 if (i1 | 0) {
  i89 = HEAP32[i67 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i89 >> 2] | 0) + 12 >> 2] | 0, i89 | 0, i1 + -16 | 0);
 }
 HEAP32[i68 >> 2] = 0;
 HEAP32[i69 >> 2] = 0;
 HEAP32[i70 >> 2] = 0;
 i2 = i83 + 4 | 0;
 i1 = HEAP32[i71 >> 2] | 0;
 if (i1 | 0) {
  i89 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i89 >> 2] | 0) + 12 >> 2] | 0, i89 | 0, i1 + -16 | 0);
 }
 i1 = HEAP32[i73 >> 2] | 0;
 if (i1 | 0) {
  i89 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i89 >> 2] | 0) + 12 >> 2] | 0, i89 | 0, i1 + -16 | 0);
 }
 if (!i3) {
  STACKTOP = i85;
  return i4 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i84 >> 2] | 0) + 12 >> 2] | 0, i84 | 0, i3 + -16 | 0);
 STACKTOP = i85;
 return i4 | 0;
}

function __ZN18DeferredRenderLoop17RenderReflectionsEP13RenderTexturePS1_(i1, i5, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, f104 = f0, i105 = 0, i106 = 0, f107 = f0, f108 = f0, i109 = 0, i110 = 0, i111 = 0, f112 = f0, f113 = f0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, i142 = 0;
 i131 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i117 = i131 + 24 | 0;
 i13 = i131 + 16 | 0;
 i127 = i131;
 i9 = i131 + 716 | 0;
 i10 = i131 + 712 | 0;
 i11 = i131 + 808 | 0;
 i12 = i131 + 696 | 0;
 i14 = i131 + 744 | 0;
 i15 = i131 + 684 | 0;
 i16 = i131 + 816 | 0;
 i17 = i131 + 814 | 0;
 i130 = i131 + 544 | 0;
 i18 = i131 + 812 | 0;
 i19 = i131 + 740 | 0;
 i20 = i131 + 528 | 0;
 i21 = i131 + 512 | 0;
 i22 = i131 + 736 | 0;
 i23 = i131 + 732 | 0;
 i118 = i131 + 376 | 0;
 i24 = i131 + 728 | 0;
 i25 = i131 + 724 | 0;
 i119 = i131 + 352 | 0;
 i120 = i131 + 288 | 0;
 i121 = i131 + 272 | 0;
 i122 = i131 + 256 | 0;
 i123 = i131 + 240 | 0;
 i124 = i131 + 224 | 0;
 i125 = i131 + 720 | 0;
 i126 = i131 + 92 | 0;
 i114 = i1 + 8 | 0;
 if ((HEAP16[gb + 1114672 + 6 >> 1] | 0) > -1) {
  HEAP32[i127 >> 2] = HEAP32[(HEAP32[i114 >> 2] | 0) + 8 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i127 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114672 | 0, i117);
  i129 = gb + 1114672 | 0;
 } else i129 = 0;
 i115 = HEAP32[gb + 1114672 >> 2] | 0;
 i116 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i116 >> 2] | 0) + 648 >> 2] | 0, i116 | 0, i115 | 0);
 i115 = __Z12GetGfxDevicev() | 0;
 i116 = HEAP32[(HEAP32[i114 >> 2] | 0) + 8 >> 2] | 0;
 i111 = HEAP8[i116 + 1092 >> 0] | 0;
 if (i111 << 24 >> 24 == 0 | (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 235 >> 0] | 0) == 0) {
  i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 241 >> 0] | 0) == 0;
  i1 = i1 ? 0 : 8;
 } else i1 = 2;
 i2 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, 0, i1, 0, 0, 0, 1) | 0;
 HEAP32[i9 >> 2] = i2;
 if (!i2) {
  HEAP32[i13 >> 2] = i1;
  __Z6FormatPKcz(i117, gb + 387533 | 0, i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i117 + 11 >> 0] | 0) < 0 ? HEAP32[i117 >> 2] | 0 : i117, 0, gb + 387579 | 0, 721, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i117);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, gb + 387669 | 0);
  __ZN7Texture13SetFilterModeEi(HEAP32[i9 >> 2] | 0, 0);
  __ZN13RenderTexture6CreateEv(HEAP32[i9 >> 2] | 0) | 0;
  i109 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = i109;
  __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[(HEAP32[i114 >> 2] | 0) + 1888 >> 2] | 0, 14, i109);
  HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 128 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i5 + 136 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i11 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i10, i117, i9, 0, -1, 0, 0) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  mftCall_viiifi(HEAP32[(HEAP32[i115 >> 2] | 0) + 32 >> 2] | 0, i115 | 0, 1, i12 | 0, 1.0, 0);
  mftCall_vii(HEAP32[(HEAP32[i115 >> 2] | 0) + 148 >> 2] | 0, i115 | 0, 0);
  i109 = HEAP32[gb + 1166248 >> 2] | 0;
  i110 = i116 + 1136 | 0;
  i111 = i116 + 4 | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i110, 21, i109, HEAP32[(HEAP32[i114 >> 2] | 0) + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i111 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i110, 21, i109, HEAP32[(HEAP32[i114 >> 2] | 0) + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i111 >> 2] | 0);
  f112 = Math_fround(Math_fround(__ZNK6Camera17GetProjectionNearEv(i116)) * Math_fround(1.00100005));
  f113 = Math_fround(Math_fround(__ZNK6Camera16GetProjectionFarEv(i116)) * Math_fround(.999000012));
  __ZNK6Camera22GetCameraToWorldMatrixEv(i14, i116);
  f6 = Math_fround(HEAPF32[i14 + 32 >> 2]);
  f7 = Math_fround(HEAPF32[i14 + 36 >> 2]);
  f4 = Math_fround(HEAPF32[i14 + 40 >> 2]);
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f4 * f4))));
  if (f3 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   f108 = Math_fround(f6 / f3);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
   f108 = Math_fround(f7 / f3);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
   f108 = Math_fround(f4 / f3);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = HEAP32[gb + 1162364 >> 2] | 0;
   i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  }
  f108 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f107 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f7 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i101 = HEAP32[i114 >> 2] | 0;
  f104 = Math_fround(Math_fround(HEAPF32[i101 + 1812 >> 2]) * f108);
  f104 = Math_fround(f104 + Math_fround(Math_fround(HEAPF32[i101 + 1816 >> 2]) * f107));
  f104 = Math_fround(f104 + Math_fround(Math_fround(HEAPF32[i101 + 1820 >> 2]) * f7));
  HEAP32[i15 + 4 >> 2] = 0;
  HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i15 >> 2] = 1;
  HEAP8[i16 >> 0] = 0;
  HEAP8[i16 + 1 >> 0] = 5;
  HEAP8[i17 >> 0] = 0;
  HEAP8[i17 + 1 >> 0] = 8;
  i101 = mftCall_iii(HEAP32[(HEAP32[i115 >> 2] | 0) + 56 >> 2] | 0, i115 | 0, i15 | 0) | 0;
  i94 = mftCall_iii(HEAP32[(HEAP32[i115 >> 2] | 0) + 48 >> 2] | 0, i115 | 0, i16 | 0) | 0;
  i5 = mftCall_iii(HEAP32[(HEAP32[i115 >> 2] | 0) + 48 >> 2] | 0, i115 | 0, i17 | 0) | 0;
  i90 = HEAP32[(HEAP32[i115 >> 2] | 0) + 52 >> 2] | 0;
  HEAP8[i117 >> 0] = 0;
  HEAP8[i117 + 1 >> 0] = -1;
  HEAP8[i117 + 2 >> 0] = -1;
  HEAP8[i117 + 3 >> 0] = 0;
  HEAP8[i117 + 4 >> 0] = 8;
  HEAP8[i117 + 5 >> 0] = 0;
  HEAP8[i117 + 6 >> 0] = 0;
  HEAP8[i117 + 7 >> 0] = 0;
  HEAP8[i117 + 8 >> 0] = 8;
  HEAP8[i117 + 9 >> 0] = 0;
  HEAP8[i117 + 10 >> 0] = 0;
  HEAP8[i117 + 11 >> 0] = 0;
  i90 = mftCall_iii(i90 | 0, i115 | 0, i117 | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i115 >> 2] | 0) + 72 >> 2] | 0, i115 | 0, i90 | 0, 0);
  HEAP32[i117 >> 2] = 0;
  HEAP32[i117 + 4 >> 2] = 0;
  HEAP32[i117 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i117, gb + 453301 | 0, 8);
  i91 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i117) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i117);
  i92 = i109 + 36 | 0;
  i95 = i130 + 8 | 0;
  HEAP32[i130 + 12 >> 2] = 1;
  HEAP32[i95 >> 2] = gb + 33952 + 8;
  i106 = gb + 64016 | 0;
  i105 = HEAP32[i106 + 4 >> 2] | 0;
  i89 = i127;
  HEAP32[i89 >> 2] = HEAP32[i106 >> 2];
  HEAP32[i89 + 4 >> 2] = i105;
  HEAP32[i130 + 40 >> 2] = 0;
  i89 = i130 + 52 | 0;
  HEAP32[i89 >> 2] = 0;
  i105 = i130 + 56 | 0;
  HEAP32[i105 >> 2] = 0;
  i106 = i130 + 44 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i117, i127);
  i102 = i117;
  i103 = HEAP32[i102 + 4 >> 2] | 0;
  i96 = i106;
  HEAP32[i96 >> 2] = HEAP32[i102 >> 2];
  HEAP32[i96 + 4 >> 2] = i103;
  i96 = gb + 64016 | 0;
  i103 = HEAP32[i96 + 4 >> 2] | 0;
  i102 = i127;
  HEAP32[i102 >> 2] = HEAP32[i96 >> 2];
  HEAP32[i102 + 4 >> 2] = i103;
  HEAP32[i130 + 60 >> 2] = 0;
  HEAP32[i130 + 72 >> 2] = 0;
  i102 = i130 + 76 | 0;
  HEAP32[i102 >> 2] = 0;
  i103 = i130 + 64 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i117, i127);
  i96 = i117;
  i97 = HEAP32[i96 + 4 >> 2] | 0;
  i98 = i103;
  HEAP32[i98 >> 2] = HEAP32[i96 >> 2];
  HEAP32[i98 + 4 >> 2] = i97;
  i98 = gb + 64016 | 0;
  i97 = HEAP32[i98 + 4 >> 2] | 0;
  i96 = i127;
  HEAP32[i96 >> 2] = HEAP32[i98 >> 2];
  HEAP32[i96 + 4 >> 2] = i97;
  i96 = i130 + 80 | 0;
  HEAP32[i96 >> 2] = 0;
  HEAP32[i130 + 92 >> 2] = 0;
  i97 = i130 + 96 | 0;
  HEAP32[i97 >> 2] = 0;
  i98 = i130 + 84 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i117, i127);
  i88 = i117;
  i100 = HEAP32[i88 + 4 >> 2] | 0;
  i99 = i98;
  HEAP32[i99 >> 2] = HEAP32[i88 >> 2];
  HEAP32[i99 + 4 >> 2] = i100;
  HEAP32[i130 + 100 >> 2] = 0;
  HEAP32[i130 + 104 >> 2] = 0;
  i99 = gb + 64016 | 0;
  i100 = HEAP32[i99 >> 2] | 0;
  i99 = HEAP32[i99 + 4 >> 2] | 0;
  i88 = i130 + 108 | 0;
  HEAP32[i88 >> 2] = i100;
  HEAP32[i88 + 4 >> 2] = i99;
  HEAP8[i130 + 116 >> 0] = 1;
  i88 = i130 + 16 | 0;
  HEAP32[i88 >> 2] = 0;
  HEAP32[i88 + 4 >> 2] = 0;
  HEAP32[i88 + 8 >> 2] = 0;
  HEAP32[i88 + 12 >> 2] = 0;
  HEAP32[i88 + 16 >> 2] = 0;
  HEAP32[i88 + 20 >> 2] = 0;
  HEAP32[i95 >> 2] = gb + 35824 + 8;
  i88 = i127;
  HEAP32[i88 >> 2] = i100;
  HEAP32[i88 + 4 >> 2] = i99;
  HEAP32[i130 + 120 >> 2] = 0;
  i88 = i130 + 132 | 0;
  HEAP32[i88 >> 2] = 0;
  i99 = i130 + 136 | 0;
  HEAP32[i99 >> 2] = 0;
  i100 = i130 + 124 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i117, i127);
  i87 = i117;
  i93 = HEAP32[i87 + 4 >> 2] | 0;
  i1 = i100;
  HEAP32[i1 >> 2] = HEAP32[i87 >> 2];
  HEAP32[i1 + 4 >> 2] = i93;
  i1 = i130 + 4 | 0;
  HEAP32[i1 >> 2] = i115;
  HEAP32[i130 >> 2] = i115 + 4;
  i93 = i130 + 8 | 0;
  __ZN19ShaderPropertySheet20ReservePropertyCountEj(i93, 6);
  HEAP8[i18 >> 0] = 0;
  i87 = __ZNK16ReflectionProbes17GetDefaultTextureEPb(__Z19GetReflectionProbesv() | 0, i18) | 0;
  HEAP32[i19 >> 2] = HEAP32[i87 + 48 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i19 >> 2];
  __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i130, 19, 4, 0, i117);
  __ZNK16ReflectionProbes41CalculateHDRDecodeValuesForDefaultTextureEP7Texture(i127, __Z19GetReflectionProbesv() | 0, i87);
  i87 = (HEAP32[i130 >> 2] | 0) + 1520 | 0;
  HEAP32[i87 >> 2] = HEAP32[i127 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i127 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i127 + 8 >> 2];
  HEAP32[i87 + 12 >> 2] = HEAP32[i127 + 12 >> 2];
  HEAP32[i117 >> 2] = 1073741919;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i127, 2);
  f132 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
  f134 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  f133 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[gb + 62500 >> 2]);
  f4 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
  f136 = Math_fround(f134 - f4);
  f135 = Math_fround(f133 - f6);
  HEAPF32[i20 >> 2] = Math_fround(f132 - f3);
  HEAPF32[i20 + 4 >> 2] = f136;
  HEAPF32[i20 + 8 >> 2] = f135;
  HEAPF32[i20 + 12 >> 2] = Math_fround(1.0);
  f4 = Math_fround(f134 + f4);
  f6 = Math_fround(f133 + f6);
  HEAPF32[i21 >> 2] = Math_fround(f132 + f3);
  HEAPF32[i21 + 4 >> 2] = f4;
  HEAPF32[i21 + 8 >> 2] = f6;
  HEAPF32[i21 + 12 >> 2] = Math_fround(1.0);
  i87 = (HEAP32[i130 >> 2] | 0) + 1552 | 0;
  HEAP32[i87 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i87 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i117 >> 2] = 1073741921;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i20, 2);
  i87 = (HEAP32[i130 >> 2] | 0) + 1536 | 0;
  HEAP32[i87 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i87 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i117 >> 2] = 1073741920;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i21, 2);
  HEAP32[i127 >> 2] = 0;
  HEAP32[i127 + 4 >> 2] = 0;
  HEAP32[i127 + 8 >> 2] = 0;
  HEAP32[i127 + 12 >> 2] = 0;
  i87 = (HEAP32[i130 >> 2] | 0) + 1568 | 0;
  HEAP32[i87 >> 2] = HEAP32[i127 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i127 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i127 + 8 >> 2];
  HEAP32[i87 + 12 >> 2] = HEAP32[i127 + 12 >> 2];
  HEAP32[i117 >> 2] = 1073741922;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i127, 2);
  HEAPF32[i127 >> 2] = Math_fround(0.0);
  HEAPF32[i127 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i127 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i127 + 12 >> 2] = Math_fround(1.0);
  i87 = (HEAP32[i130 >> 2] | 0) + 1632 | 0;
  HEAP32[i87 >> 2] = HEAP32[i127 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i127 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i127 + 8 >> 2];
  HEAP32[i87 + 12 >> 2] = HEAP32[i127 + 12 >> 2];
  HEAP32[i117 >> 2] = 1073741926;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i127, 2);
  if (HEAP32[i88 >> 2] | HEAP32[i89 >> 2] | 0) {
   __ZN20DynamicPropertySheet10FlushQueueEv(i93);
   i89 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i89 >> 2] | 0) + 184 >> 2] | 0, i89 | 0, i93 | 0);
   __ZN19ShaderPropertySheet5ClearEb(i93, 1);
  }
  __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i92, gb + 1114740 | 0, Math_fround(1.0), 0);
  i89 = HEAP32[gb + 1115116 >> 2] | 0;
  HEAP32[i22 >> 2] = HEAP32[gb + 1114788 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i22 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i89, i117, Math_fround(1.0));
  i89 = HEAP32[gb + 1115116 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[gb + 1114792 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i23 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i89, i117, Math_fround(0.0));
  if (!(HEAP8[i18 >> 0] | 0)) {
   __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i118, __Z12GetGfxDevicev() | 0);
   __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i116)), i115);
   i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 0, i109, 0, 1) | 0;
   if ((HEAP16[gb + 1114684 + 6 >> 1] | 0) > -1) {
    HEAP32[i127 >> 2] = i116;
    HEAP32[i117 >> 2] = HEAP32[i127 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114684 | 0, i117);
    i1 = gb + 1114684 | 0;
   } else i1 = 0;
   i89 = HEAP32[gb + 1114684 >> 2] | 0;
   i88 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 648 >> 2] | 0, i88 | 0, i89 | 0);
   mftCall_vii(HEAP32[(HEAP32[i115 >> 2] | 0) + 68 >> 2] | 0, i115 | 0, i5 | 0);
   HEAPF32[i117 >> 2] = Math_fround(0.0);
   HEAPF32[i117 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i117 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i117 + 12 >> 2] = Math_fround(1.0);
   __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i115, i116, i2, i117, f112, 0);
   i89 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i89 >> 2] | 0) + 652 >> 2] | 0, i89 | 0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   __ZN27DeviceViewProjMatricesStateD2Ev(i118);
  }
  __ZN13dynamic_arrayIP15ReflectionProbeLj4EEC2ERKS2_RK10MemLabelId(i118, (__Z19GetReflectionProbesv() | 0) + 12 | 0, gb + 64016 | 0);
  i88 = HEAP32[i118 >> 2] | 0;
  i89 = i118 + 12 | 0;
  __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_(i88, i88 + (HEAP32[i89 >> 2] << 2) | 0, i117);
  i88 = HEAP32[gb + 1115116 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[gb + 1114788 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i24 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i88, i117, Math_fround(5.0));
  i88 = HEAP32[gb + 1115116 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[gb + 1114792 >> 2];
  HEAP32[i117 >> 2] = HEAP32[i25 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i88, i117, Math_fround(10.0));
  if (HEAP32[i89 >> 2] | 0) {
   i11 = i119 + 12 | 0;
   i12 = i119 + 16 | 0;
   i13 = i119 + 20 | 0;
   i14 = i117 + 4 | 0;
   i15 = i117 + 8 | 0;
   i16 = i120 + 48 | 0;
   i17 = i119 + 4 | 0;
   i18 = i120 + 52 | 0;
   i19 = i119 + 8 | 0;
   i20 = i120 + 56 | 0;
   i21 = i121 + 4 | 0;
   i22 = i121 + 8 | 0;
   i23 = i121 + 12 | 0;
   i24 = i122 + 4 | 0;
   i25 = i122 + 8 | 0;
   i26 = i122 + 12 | 0;
   i27 = i123 + 4 | 0;
   i28 = i117 + 4 | 0;
   i29 = i123 + 8 | 0;
   i30 = i117 + 8 | 0;
   i31 = i123 + 12 | 0;
   i32 = i124 + 4 | 0;
   i33 = i124 + 8 | 0;
   i34 = i124 + 12 | 0;
   i35 = i117 + 8 | 0;
   i36 = i117 + 4 | 0;
   i37 = i117 + 12 | 0;
   i38 = i117 + 1 | 0;
   i39 = i117 + 2 | 0;
   i40 = i117 + 3 | 0;
   i41 = i117 + 4 | 0;
   i42 = i117 + 5 | 0;
   i43 = i117 + 6 | 0;
   i44 = i117 + 7 | 0;
   i45 = i117 + 8 | 0;
   i46 = i117 + 9 | 0;
   i47 = i117 + 10 | 0;
   i48 = i117 + 11 | 0;
   i49 = i117 + 1 | 0;
   i50 = i117 + 2 | 0;
   i51 = i117 + 3 | 0;
   i52 = i117 + 4 | 0;
   i53 = i117 + 8 | 0;
   i54 = i117 + 9 | 0;
   i55 = i117 + 10 | 0;
   i56 = i117 + 11 | 0;
   i57 = i117 + 12 | 0;
   i58 = i117 + 16 | 0;
   i59 = i117 + 17 | 0;
   i60 = i117 + 18 | 0;
   i61 = i117 + 19 | 0;
   i62 = i117 + 20 | 0;
   i63 = i117 + 24 | 0;
   i64 = i117 + 25 | 0;
   i65 = i117 + 26 | 0;
   i66 = i117 + 27 | 0;
   i67 = i117 + 28 | 0;
   i68 = i117 + 32 | 0;
   i69 = i117 + 33 | 0;
   i70 = i117 + 34 | 0;
   i71 = i117 + 35 | 0;
   i72 = i117 + 36 | 0;
   i73 = i117 + 40 | 0;
   i74 = i117 + 41 | 0;
   i75 = i117 + 42 | 0;
   i76 = i117 + 43 | 0;
   i77 = i117 + 44 | 0;
   i78 = i117 + 48 | 0;
   i79 = i117 + 49 | 0;
   i80 = i117 + 50 | 0;
   i81 = i117 + 51 | 0;
   i82 = i117 + 52 | 0;
   i83 = i117 + 56 | 0;
   i84 = i117 + 57 | 0;
   i85 = i117 + 58 | 0;
   i86 = i117 + 59 | 0;
   i87 = i117 + 60 | 0;
   i88 = i117 + 64 | 0;
   i10 = HEAP32[i118 >> 2] | 0;
   do {
    i9 = HEAP32[i10 >> 2] | 0;
    f136 = Math_fround(HEAPF32[i9 + 136 >> 2]);
    __ZNK15ReflectionProbe13GetGlobalAABBEv(i119, i9);
    f3 = Math_fround(f136 + Math_fround(HEAPF32[i11 >> 2]));
    f4 = Math_fround(f136 + Math_fround(HEAPF32[i12 >> 2]));
    f6 = Math_fround(f136 + Math_fround(HEAPF32[i13 >> 2]));
    f133 = Math_fround(f4 * Math_fround(2.0));
    f132 = Math_fround(f6 * Math_fround(2.0));
    HEAPF32[i117 >> 2] = Math_fround(f3 * Math_fround(2.0));
    HEAPF32[i14 >> 2] = f133;
    HEAPF32[i15 >> 2] = f132;
    __ZN10Matrix4x4f8SetScaleERK8Vector3f(i120, i117) | 0;
    i2 = HEAP32[i119 >> 2] | 0;
    HEAP32[i16 >> 2] = i2;
    i5 = HEAP32[i17 >> 2] | 0;
    HEAP32[i18 >> 2] = i5;
    i8 = HEAP32[i19 >> 2] | 0;
    HEAP32[i20 >> 2] = i8;
    f132 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f133 = Math_fround(HEAPF32[i11 >> 2]);
    f141 = Math_fround(f132 - f133);
    f138 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f134 = Math_fround(HEAPF32[i12 >> 2]);
    f140 = Math_fround(f138 - f134);
    f137 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f135 = Math_fround(HEAPF32[i13 >> 2]);
    f139 = Math_fround(f137 - f135);
    HEAPF32[i121 >> 2] = f141;
    HEAPF32[i21 >> 2] = f140;
    HEAPF32[i22 >> 2] = f139;
    HEAPF32[i23 >> 2] = Math_fround(1.0);
    f134 = Math_fround(f138 + f134);
    f135 = Math_fround(f137 + f135);
    HEAPF32[i122 >> 2] = Math_fround(f132 + f133);
    HEAPF32[i24 >> 2] = f134;
    HEAPF32[i25 >> 2] = f135;
    HEAPF32[i26 >> 2] = Math_fround(1.0);
    __ZNK9Transform11GetPositionEv(i117, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f135 = HEAP8[i9 + 141 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
    HEAP32[i123 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
    HEAPF32[i31 >> 2] = f135;
    i8 = f136 > Math_fround(.00100000005);
    f136 = i8 ? f136 : Math_fround(.00100000005);
    HEAPF32[i124 >> 2] = Math_fround(0.0);
    HEAPF32[i32 >> 2] = Math_fround(0.0);
    HEAPF32[i33 >> 2] = Math_fround(0.0);
    HEAPF32[i34 >> 2] = f136;
    i8 = __ZNK15ReflectionProbe10GetTextureEv(i9) | 0;
    do if (!i8) i1 = 0; else {
     HEAP32[i127 >> 2] = i8;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i128 = 37; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i5 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i117, i1, i127);
       i2 = HEAP32[i117 >> 2] | 0;
       i142 = HEAP32[i1 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i142 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i142 + (i2 << 3) | 0;
       i2 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i5 << 3) | 0)) i128 = 37; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i128 = 39;
     }
     if ((i128 | 0) == 37) i128 = 39;
     if ((i128 | 0) == 39) {
      i128 = 0;
      if (!(__Z31ReadObjectFromPersistentManageri(i8) | 0)) {
       i1 = 0;
       break;
      }
     }
     i8 = __ZNK15ReflectionProbe10GetTextureEv(i9) | 0;
     HEAP32[i127 >> 2] = i8;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i128 = 45; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i5 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i117, i1, i127);
       i2 = HEAP32[i117 >> 2] | 0;
       i142 = HEAP32[i1 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i142 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i142 + (i2 << 3) | 0;
       i2 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i5 << 3) | 0)) i128 = 45; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i128 = 47;
      }
     }
     if ((i128 | 0) == 45) i128 = 47;
     if ((i128 | 0) == 47) {
      i128 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
     }
     i1 = HEAP32[i1 + 48 >> 2] | 0;
    } while (0);
    HEAP32[i125 >> 2] = i1;
    HEAP32[i117 >> 2] = HEAP32[i125 >> 2];
    __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i130, 19, 4, 0, i117);
    __ZNK15ReflectionProbe24CalculateHDRDecodeValuesEv(i127, i9);
    i1 = (HEAP32[i130 >> 2] | 0) + 1520 | 0;
    HEAP32[i1 >> 2] = HEAP32[i127 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i127 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i127 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i127 + 12 >> 2];
    HEAP32[i117 >> 2] = 1073741919;
    __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i127, 2);
    i1 = (HEAP32[i130 >> 2] | 0) + 1552 | 0;
    HEAP32[i1 >> 2] = HEAP32[i121 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i121 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i121 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i121 + 12 >> 2];
    HEAP32[i117 >> 2] = 1073741921;
    __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i121, 2);
    i1 = (HEAP32[i130 >> 2] | 0) + 1536 | 0;
    HEAP32[i1 >> 2] = HEAP32[i122 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i122 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i122 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i122 + 12 >> 2];
    HEAP32[i117 >> 2] = 1073741920;
    __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i122, 2);
    i1 = (HEAP32[i130 >> 2] | 0) + 1568 | 0;
    HEAP32[i1 >> 2] = HEAP32[i123 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i123 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i123 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i123 + 12 >> 2];
    HEAP32[i117 >> 2] = 1073741922;
    __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i123, 2);
    i1 = (HEAP32[i130 >> 2] | 0) + 1632 | 0;
    HEAP32[i1 >> 2] = HEAP32[i124 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i124 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i124 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i124 + 12 >> 2];
    HEAP32[i117 >> 2] = 1073741926;
    __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i93, i117, i124, 2);
    __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i126, __Z12GetGfxDevicev() | 0);
    f140 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f6 * f6))));
    f141 = Math_fround(Math_fround(HEAPF32[i119 >> 2]) * f108);
    f141 = Math_fround(f141 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f107));
    f141 = Math_fround(Math_fround(f141 + Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f7)) - f104);
    i1 = Math_fround(f141 - f140) <= f112;
    i2 = Math_fround(f140 + f141) >= f113;
    if (i1 & i2) {
     __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i116)), i115);
     __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i92, gb + 1114740 | 0, Math_fround(1.0), 0);
     i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 0, i109, 0, 1) | 0;
     if ((HEAP16[gb + 1114696 + 6 >> 1] | 0) > -1) {
      HEAP32[i127 >> 2] = i9;
      HEAP32[i117 >> 2] = HEAP32[i127 >> 2];
      __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114696 | 0, i117);
      i1 = gb + 1114696 | 0;
     } else i1 = 0;
     i142 = HEAP32[gb + 1114696 >> 2] | 0;
     i9 = __Z12GetGfxDevicev() | 0;
     mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 648 >> 2] | 0, i9 | 0, i142 | 0);
     HEAPF32[i117 >> 2] = Math_fround(0.0);
     HEAPF32[i35 >> 2] = Math_fround(1.0);
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = Math_fround(1.0);
     __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i115, i116, i2, i117, f112, 0);
     i142 = __Z12GetGfxDevicev() | 0;
     mftCall_vi(HEAP32[(HEAP32[i142 >> 2] | 0) + 652 >> 2] | 0, i142 | 0);
     if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
    } else {
     __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i92, gb + 1114740 | 0, Math_fround(0.0), 0);
     do if (i1) {
      i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 0, i109, 0, 1) | 0;
      mftCall_vii(HEAP32[(HEAP32[i115 >> 2] | 0) + 64 >> 2] | 0, i115 | 0, i101 | 0);
      mftCall_vii(HEAP32[(HEAP32[i115 >> 2] | 0) + 68 >> 2] | 0, i115 | 0, i94 | 0);
      i1 = 0;
     } else if (i2) {
      i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 0, i109, 0, 1) | 0;
      i1 = 0;
      break;
     } else {
      __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(__ZL31SetRenderStateForStencilMarkingR9GfxDeviceR17ShaderPassContextjj(i115, i109, 0, 128) | 0, i91, i120, -1);
      HEAP8[i49 >> 0] = 1;
      HEAP8[i50 >> 0] = 0;
      HEAP8[i51 >> 0] = 1;
      HEAP32[i52 >> 2] = 0;
      HEAP8[i53 >> 0] = 15;
      HEAP8[i54 >> 0] = 1;
      HEAP8[i55 >> 0] = 0;
      HEAP8[i56 >> 0] = 1;
      HEAP32[i57 >> 2] = 0;
      HEAP8[i58 >> 0] = 15;
      HEAP8[i59 >> 0] = 1;
      HEAP8[i60 >> 0] = 0;
      HEAP8[i61 >> 0] = 1;
      HEAP32[i62 >> 2] = 0;
      HEAP8[i63 >> 0] = 15;
      HEAP8[i64 >> 0] = 1;
      HEAP8[i65 >> 0] = 0;
      HEAP8[i66 >> 0] = 1;
      HEAP32[i67 >> 2] = 0;
      HEAP8[i68 >> 0] = 15;
      HEAP8[i69 >> 0] = 1;
      HEAP8[i70 >> 0] = 0;
      HEAP8[i71 >> 0] = 1;
      HEAP32[i72 >> 2] = 0;
      HEAP8[i73 >> 0] = 15;
      HEAP8[i74 >> 0] = 1;
      HEAP8[i75 >> 0] = 0;
      HEAP8[i76 >> 0] = 1;
      HEAP32[i77 >> 2] = 0;
      HEAP8[i78 >> 0] = 15;
      HEAP8[i79 >> 0] = 1;
      HEAP8[i80 >> 0] = 0;
      HEAP8[i81 >> 0] = 1;
      HEAP32[i82 >> 2] = 0;
      HEAP8[i83 >> 0] = 15;
      HEAP8[i84 >> 0] = 1;
      HEAP8[i85 >> 0] = 0;
      HEAP8[i86 >> 0] = 1;
      HEAP32[i87 >> 2] = 0;
      HEAP32[i88 >> 2] = 0;
      HEAP8[i117 >> 0] = 15;
      i2 = HEAP32[i115 >> 2] | 0;
      i1 = HEAP32[i2 + 60 >> 2] | 0;
      mftCall_vii(i1 | 0, i115 | 0, mftCall_iii(HEAP32[i2 + 44 >> 2] | 0, i115 | 0, i117 | 0) | 0);
      i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 0, i109, 0, 1) | 0;
      i1 = 1;
      break;
     } while (0);
     HEAP8[i39 >> 0] = -1;
     HEAP8[i40 >> 0] = 0;
     HEAP8[i42 >> 0] = 0;
     HEAP8[i43 >> 0] = 0;
     HEAP8[i44 >> 0] = 0;
     HEAP8[i46 >> 0] = 0;
     HEAP8[i47 >> 0] = 0;
     HEAP8[i48 >> 0] = 0;
     HEAP8[i117 >> 0] = 1;
     HEAP8[i45 >> 0] = 3;
     HEAP8[i41 >> 0] = 3;
     HEAP8[i38 >> 0] = -128;
     if (i1) {
      HEAP8[i39 >> 0] = 16;
      HEAP8[i48 >> 0] = 1;
      HEAP8[i44 >> 0] = 1;
      HEAP8[i46 >> 0] = 1;
      HEAP8[i42 >> 0] = 1;
      HEAP8[i47 >> 0] = 1;
      HEAP8[i43 >> 0] = 1;
      HEAP8[i38 >> 0] = -112;
      i1 = 144;
     } else i1 = 128;
     i142 = mftCall_iii(HEAP32[(HEAP32[i115 >> 2] | 0) + 52 >> 2] | 0, i115 | 0, i117 | 0) | 0;
     mftCall_viii(HEAP32[(HEAP32[i115 >> 2] | 0) + 72 >> 2] | 0, i115 | 0, i142 | 0, i1 | 0);
     __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(i2, i91, i120, -1);
    }
    __ZN27DeviceViewProjMatricesStateD2Ev(i126);
    i10 = i10 + 4 | 0;
   } while (((HEAP32[i118 >> 2] | 0) + (HEAP32[i89 >> 2] << 2) | 0) != (i10 | 0));
  }
  mftCall_viii(HEAP32[(HEAP32[i115 >> 2] | 0) + 72 >> 2] | 0, i115 | 0, i90 | 0, 0);
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i110, 22, i109, HEAP32[(HEAP32[i114 >> 2] | 0) + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i111 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i110, 22, i109, HEAP32[(HEAP32[i114 >> 2] | 0) + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i111 >> 2] | 0);
  if ((HEAP32[i118 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, i118 + 4 | 0);
   HEAP32[i118 >> 2] = 0;
  }
  HEAP32[i95 >> 2] = gb + 35824 + 8;
  i1 = i130 + 120 | 0;
  if ((HEAP32[i99 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i100);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i95 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i97 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i96 >> 2] | 0, i98);
   HEAP32[i96 >> 2] = 0;
  }
  i1 = i130 + 60 | 0;
  if ((HEAP32[i102 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i103);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i130 + 40 | 0;
  if ((HEAP32[i105 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i106);
   HEAP32[i1 >> 2] = 0;
  }
 }
 i142 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i142 >> 2] | 0) + 652 >> 2] | 0, i142 | 0);
 if (!i129) {
  STACKTOP = i131;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i129);
 STACKTOP = i131;
 return;
}

function __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i7, i1, i2, i27) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i26 = i7 + 4 | 0;
 i26 = HEAP32[(HEAP32[i26 >> 2] | 0) + i26 + (i27 << 3) + 4 >> 2] | 0;
 i25 = i1 + 4 | 0;
 i25 = (HEAP32[i25 >> 2] | 0) + i25 | 0;
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(Math_fround(f6 * f6) + Math_fround(1.0))))));
 f22 = Math_fround(f16 * f21);
 f23 = Math_fround(f17 * f21);
 f24 = Math_fround(f6 * f21);
 i20 = i7 + 16 | 0;
 i20 = (HEAP32[i20 >> 2] | 0) + i20 | 0;
 i15 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 switch (HEAP32[i20 + (i26 * 76 | 0) + 72 >> 2] | 0) {
 case 3:
  {
   f33 = Math_fround(Math_fround(f16 * Math_fround(.5)) * Math_fround(.159154937));
   f31 = Math_fround(Math_fround(f17 * Math_fround(.5)) * Math_fround(.159154937));
   f29 = Math_fround(Math_fround(f6 * Math_fround(.5)) * Math_fround(.159154937));
   f5 = Math_fround(+_roundf(+f33));
   f5 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f33 - f5))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f3 = Math_fround(f5 * f5);
   f17 = Math_fround(f32 * f32);
   f28 = Math_fround(f16 * f16);
   f30 = Math_fround(f3 * f3);
   f4 = Math_fround(f17 * f17);
   f6 = Math_fround(f28 * f28);
   f3 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
   f17 = Math_fround(f32 * Math_fround(Math_fround(Math_fround(f4 * f4) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f17 * Math_fround(41.3416595))) + Math_fround(f4 * Math_fround(Math_fround(81.6018218) - Math_fround(f17 * Math_fround(76.5686187)))))));
   f28 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
   f6 = Math_fround(f33 + Math_fround(-.25));
   f31 = Math_fround(f31 + Math_fround(-.25));
   f29 = Math_fround(f29 + Math_fround(-.25));
   f33 = Math_fround(+_roundf(+f6));
   f33 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f6 - f33))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f31 - Math_fround(+_roundf(+f31))))));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f6 = Math_fround(f33 * f33);
   f16 = Math_fround(f31 * f31);
   f4 = Math_fround(f29 * f29);
   f32 = Math_fround(f6 * f6);
   f30 = Math_fround(f16 * f16);
   f5 = Math_fround(f4 * f4);
   f6 = Math_fround(f33 * Math_fround(Math_fround(Math_fround(f32 * f32) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f6 * Math_fround(41.3416595))) + Math_fround(f32 * Math_fround(Math_fround(81.6018218) - Math_fround(f6 * Math_fround(76.5686187)))))));
   f16 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f16 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f16 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f29 * Math_fround(Math_fround(Math_fround(f5 * f5) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f5 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f5 = Math_fround(f28 * f6);
   f6 = Math_fround(f6 * f4);
   f4 = Math_fround(f3 * f4);
   f28 = Math_fround(f3 * f28);
   f3 = Math_fround(Math_fround(Math_fround(f17 * f5) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(-1.0) * f16) * f4));
   f4 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(-1.0) * f16)) + Math_fround(Math_fround(f17 * f4) * Math_fround(1.0)));
   f5 = Math_fround(Math_fround(Math_fround(f17 * f28) * Math_fround(1.0)) + Math_fround(Math_fround(Math_fround(1.0) * f16) * f6));
   f6 = Math_fround(Math_fround(f28 * Math_fround(Math_fround(1.0) * f16)) + Math_fround(Math_fround(f17 * f6) * Math_fround(1.0)));
   break;
  }
 case 1:
  {
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 44 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 48 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 52 >> 2]);
   i1 = f31 > Math_fround(0.0);
   i2 = f32 > Math_fround(0.0);
   i8 = f33 > Math_fround(0.0);
   f3 = Math_fround(-Math_fround(f31 * f16));
   f4 = Math_fround(-Math_fround(f32 * f17));
   f5 = Math_fround(-Math_fround(f33 * f6));
   i14 = f31 < Math_fround(0.0);
   i7 = f32 < Math_fround(0.0);
   i9 = f33 < Math_fround(0.0);
   i14 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i13 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i18 : 0;
   i10 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i19 : 0;
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 56 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 60 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 64 >> 2]);
   i1 = f31 < Math_fround(0.0);
   i8 = f32 < Math_fround(0.0);
   i11 = f33 < Math_fround(0.0);
   f3 = Math_fround(f16 * f31);
   f4 = Math_fround(f17 * f32);
   f5 = Math_fround(f6 * f33);
   i7 = f31 > Math_fround(0.0);
   i9 = f32 > Math_fround(0.0);
   i12 = f33 > Math_fround(0.0);
   i2 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i1 = f16 < Math_fround(0.0);
   i15 = f17 < Math_fround(0.0);
   i7 = f6 < Math_fround(0.0);
   i2 = i1 ? i14 : i2;
   i1 = i15 ? i13 : i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i18 : 0;
   i15 = i7 ? i10 : i12 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i11 ? i19 : 0;
   f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = Math_fround(Math_fround(Math_abs(Math_fround(f31))) + Math_fround(3.14159274));
   f17 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f5 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f29 = Math_fround(f17 / Math_fround(6.28318548));
   f28 = Math_fround(f5 / Math_fround(6.28318548));
   f32 = Math_fround(_truncf(Math_fround(f31 / Math_fround(6.28318548))));
   f32 = Math_fround(Math_fround(f31 - Math_fround(f32 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f29 = Math_fround(Math_fround(f17 - Math_fround(Math_fround(_truncf(f29)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f5 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   f28 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f28 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f28 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f28 = Math_fround(f28 * Math_fround(.159154937));
   f29 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f29, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f5 = Math_fround(+_roundf(+f28));
   f5 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f5))));
   f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f33 = Math_fround(f5 * f5);
   f4 = Math_fround(f17 * f17);
   f3 = Math_fround(f31 * f31);
   f30 = Math_fround(f33 * f33);
   f6 = Math_fround(f4 * f4);
   f16 = Math_fround(f3 * f3);
   f33 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187)))))));
   f4 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f3 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f29 = Math_fround(f29 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f16 = Math_fround(+_roundf(+f28));
   f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f16))));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f28 = Math_fround(f16 * f16);
   f31 = Math_fround(f29 * f29);
   f6 = Math_fround(f32 * f32);
   f17 = Math_fround(f28 * f28);
   f30 = Math_fround(f31 * f31);
   f5 = Math_fround(f6 * f6);
   f33 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187))))))) / f33);
   f4 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f4);
   f3 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f5 * f5) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f6 * Math_fround(41.3416595))) + Math_fround(f5 * Math_fround(Math_fround(81.6018218) - Math_fround(f6 * Math_fround(76.5686187))))))) / f3);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 32 >> 2] & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 36 >> 2] & -2147483648;
   i19 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 40 >> 2] & -2147483648;
   f3 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f4 + Math_fround(f3 * f33));
   f4 = Math_fround(f33 - Math_fround(f3 * f4));
   f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(1.0)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6))))));
   f3 = Math_fround(f33 * f3);
   f4 = Math_fround(f33 * f4);
   f5 = f33;
   f6 = Math_fround(f33 * f6);
   break;
  }
 case 2:
  {
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 44 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 48 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 52 >> 2]);
   i1 = f31 > Math_fround(0.0);
   i2 = f32 > Math_fround(0.0);
   i8 = f33 > Math_fround(0.0);
   f3 = Math_fround(-Math_fround(f31 * f16));
   f4 = Math_fround(-Math_fround(f32 * f17));
   f5 = Math_fround(-Math_fround(f33 * f6));
   i14 = f31 < Math_fround(0.0);
   i7 = f32 < Math_fround(0.0);
   i9 = f33 < Math_fround(0.0);
   i14 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i13 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i18 : 0;
   i10 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i19 : 0;
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 56 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 60 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 64 >> 2]);
   i1 = f31 < Math_fround(0.0);
   i8 = f32 < Math_fround(0.0);
   i11 = f33 < Math_fround(0.0);
   f3 = Math_fround(f16 * f31);
   f4 = Math_fround(f17 * f32);
   f5 = Math_fround(f6 * f33);
   i7 = f31 > Math_fround(0.0);
   i9 = f32 > Math_fround(0.0);
   i12 = f33 > Math_fround(0.0);
   i2 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i1 = f16 < Math_fround(0.0);
   i15 = f17 < Math_fround(0.0);
   i7 = f6 < Math_fround(0.0);
   i2 = i1 ? i14 : i2;
   i1 = i15 ? i13 : i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i18 : 0;
   i15 = i7 ? i10 : i12 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i11 ? i19 : 0;
   f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = Math_fround(Math_fround(Math_abs(Math_fround(f31))) + Math_fround(3.14159274));
   f17 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f5 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f29 = Math_fround(f17 / Math_fround(6.28318548));
   f28 = Math_fround(f5 / Math_fround(6.28318548));
   f32 = Math_fround(_truncf(Math_fround(f31 / Math_fround(6.28318548))));
   f32 = Math_fround(Math_fround(f31 - Math_fround(f32 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f29 = Math_fround(Math_fround(f17 - Math_fround(Math_fround(_truncf(f29)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f5 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   f28 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f28 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f28 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f28 = Math_fround(f28 * Math_fround(.159154937));
   f29 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f29, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f5 = Math_fround(+_roundf(+f28));
   f5 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f5))));
   f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f4 = Math_fround(f5 * f5);
   f33 = Math_fround(f17 * f17);
   f3 = Math_fround(f31 * f31);
   f30 = Math_fround(f4 * f4);
   f6 = Math_fround(f33 * f33);
   f16 = Math_fround(f3 * f3);
   f4 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f33 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f6 * f6) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f6 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187)))))));
   f3 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f29 = Math_fround(f29 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f16 = Math_fround(+_roundf(+f28));
   f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f16))));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f28 = Math_fround(f16 * f16);
   f31 = Math_fround(f29 * f29);
   f6 = Math_fround(f32 * f32);
   f17 = Math_fround(f28 * f28);
   f30 = Math_fround(f31 * f31);
   f5 = Math_fround(f6 * f6);
   f4 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187))))))) / f4);
   f33 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f33);
   f3 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f5 * f5) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f6 * Math_fround(41.3416595))) + Math_fround(f5 * Math_fround(Math_fround(81.6018218) - Math_fround(f6 * Math_fround(76.5686187))))))) / f3);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 32 >> 2] & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 36 >> 2] & -2147483648;
   i19 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 40 >> 2] & -2147483648;
   f3 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f33 - Math_fround(f3 * f4));
   f4 = Math_fround(Math_fround(f3 * f33) + f4);
   f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(1.0)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6))))));
   f3 = Math_fround(f33 * f3);
   f4 = Math_fround(f33 * f4);
   f5 = f33;
   f6 = Math_fround(f33 * f6);
   break;
  }
 default:
  {
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 44 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 48 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 52 >> 2]);
   i1 = f31 > Math_fround(0.0);
   i2 = f32 > Math_fround(0.0);
   i8 = f33 > Math_fround(0.0);
   f3 = Math_fround(-Math_fround(f31 * f16));
   f4 = Math_fround(-Math_fround(f32 * f17));
   f5 = Math_fround(-Math_fround(f33 * f6));
   i14 = f31 < Math_fround(0.0);
   i7 = f32 < Math_fround(0.0);
   i9 = f33 < Math_fround(0.0);
   i14 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i13 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i18 : 0;
   i10 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i19 : 0;
   f31 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 56 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 60 >> 2]);
   f33 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 64 >> 2]);
   i1 = f31 < Math_fround(0.0);
   i8 = f32 < Math_fround(0.0);
   i11 = f33 < Math_fround(0.0);
   f3 = Math_fround(f16 * f31);
   f4 = Math_fround(f17 * f32);
   f5 = Math_fround(f6 * f33);
   i7 = f31 > Math_fround(0.0);
   i9 = f32 > Math_fround(0.0);
   i12 = f33 > Math_fround(0.0);
   i2 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i15 : 0;
   i1 = f16 < Math_fround(0.0);
   i15 = f17 < Math_fround(0.0);
   i7 = f6 < Math_fround(0.0);
   i2 = i1 ? i14 : i2;
   i1 = i15 ? i13 : i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i8 ? i18 : 0;
   i15 = i7 ? i10 : i12 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i11 ? i19 : 0;
   f31 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = Math_fround(Math_fround(Math_abs(Math_fround(f31))) + Math_fround(3.14159274));
   f17 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f5 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
   f29 = Math_fround(f17 / Math_fround(6.28318548));
   f28 = Math_fround(f5 / Math_fround(6.28318548));
   f32 = Math_fround(_truncf(Math_fround(f31 / Math_fround(6.28318548))));
   f32 = Math_fround(Math_fround(f31 - Math_fround(f32 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f29 = Math_fround(Math_fround(f17 - Math_fround(Math_fround(_truncf(f29)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   f28 = Math_fround(Math_fround(f5 - Math_fround(Math_fround(_truncf(f28)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ i15 & -2147483648;
   f28 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
   f28 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f28 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
   f28 = Math_fround(f28 * Math_fround(.159154937));
   f29 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f29, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f32 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f32, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
   f5 = Math_fround(+_roundf(+f28));
   f5 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f5))));
   f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f4 = Math_fround(f5 * f5);
   f6 = Math_fround(f17 * f17);
   f3 = Math_fround(f31 * f31);
   f30 = Math_fround(f4 * f4);
   f33 = Math_fround(f6 * f6);
   f16 = Math_fround(f3 * f3);
   f4 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
   f6 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f33 * f33) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f6 * Math_fround(41.3416595))) + Math_fround(f33 * Math_fround(Math_fround(81.6018218) - Math_fround(f6 * Math_fround(76.5686187)))))));
   f3 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
   f28 = Math_fround(f28 + Math_fround(-.25));
   f29 = Math_fround(f29 + Math_fround(-.25));
   f32 = Math_fround(f32 + Math_fround(-.25));
   f16 = Math_fround(+_roundf(+f28));
   f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f28 - f16))));
   f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f29 - Math_fround(+_roundf(+f29))))));
   f32 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f32 - Math_fround(+_roundf(+f32))))));
   f28 = Math_fround(f16 * f16);
   f31 = Math_fround(f29 * f29);
   f33 = Math_fround(f32 * f32);
   f17 = Math_fround(f28 * f28);
   f30 = Math_fround(f31 * f31);
   f5 = Math_fround(f33 * f33);
   f4 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187))))))) / f4);
   f6 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f31 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f31 * Math_fround(76.5686187))))))) / f6);
   f3 = Math_fround(Math_fround(f32 * Math_fround(Math_fround(Math_fround(f5 * f5) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f33 * Math_fround(41.3416595))) + Math_fround(f5 * Math_fround(Math_fround(81.6018218) - Math_fround(f33 * Math_fround(76.5686187))))))) / f3);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 32 >> 2] & -2147483648;
   i18 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 36 >> 2] & -2147483648;
   i19 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i20 + (i26 * 76 | 0) + 40 >> 2] & -2147483648;
   f3 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f4 * f4) + Math_fround(1.0))))));
   f3 = Math_fround(f33 * f3);
   f4 = Math_fround(f33 * f4);
   f5 = f33;
   f6 = Math_fround(f33 * f6);
  }
 }
 f28 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 28 >> 2]);
 f33 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i20 + (i26 * 76 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f6 * f33);
 f30 = Math_fround(f5 * f28);
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i20 + (i26 * 76 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f4 * f17);
 f32 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i20 + (i26 * 76 | 0) + 24 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f5 * f32)) - Math_fround(f4 * f28)) - Math_fround(f3 * f17));
 f30 = Math_fround(Math_fround(Math_fround(f30 - Math_fround(f3 * f33)) - Math_fround(f4 * f32)) - Math_fround(f6 * f17));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f6 * f32)) - Math_fround(f5 * f33)) - Math_fround(f3 * f28));
 f28 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f32) - Math_fround(f4 * f33)) - Math_fround(f5 * f17)) - Math_fround(f6 * f28));
 i18 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f28 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 4 >> 2]);
 f16 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f28 * f16);
 f17 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 12 >> 2]);
 f33 = Math_fround(f17 * f30);
 f6 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) + 8 >> 2]);
 f32 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f6 * f32);
 f4 = Math_fround(HEAPF32[i20 + (i26 * 76 | 0) >> 2]);
 f5 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f17 * f5)) - Math_fround(f6 * f30)) - Math_fround(f4 * f32));
 f33 = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f4 * f16)) - Math_fround(f6 * f5)) - Math_fround(f28 * f32));
 f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f28 * f5)) - Math_fround(f17 * f16)) - Math_fround(f4 * f30));
 f30 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f5) - Math_fround(f6 * f16)) - Math_fround(f17 * f32)) - Math_fround(f28 * f30));
 i20 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f30 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f30 * f30);
 f31 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f31 * f31);
 f32 = (HEAP32[tempDoublePtr >> 2] = i20 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f32 * f32)) + Math_fround(f28 + f29)))));
 f30 = Math_fround(f29 * f30);
 f31 = Math_fround(f29 * f31);
 f32 = Math_fround(f29 * f32);
 f33 = Math_fround(f29 * f33);
 i26 = (i26 | 0) != -1;
 HEAPF32[i25 + (i27 * 40 | 0) + 12 >> 2] = i26 ? f30 : f22;
 HEAPF32[i25 + (i27 * 40 | 0) + 16 >> 2] = i26 ? f31 : f23;
 HEAPF32[i25 + (i27 * 40 | 0) + 20 >> 2] = i26 ? f32 : f24;
 HEAPF32[i25 + (i27 * 40 | 0) + 24 >> 2] = i26 ? f33 : f21;
 return;
}

function _malloc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i28;
 do if (i1 >>> 0 < 245) {
  i13 = i1 >>> 0 < 11 ? 16 : i1 + 11 & -8;
  i1 = i13 >>> 3;
  i18 = HEAP32[gb + 1470404 >> 2] | 0;
  i2 = i18 >>> i1;
  if (i2 & 3 | 0) {
   i2 = (i2 & 1 ^ 1) + i1 | 0;
   i3 = gb + 1470404 + 40 + (i2 << 1 << 2) | 0;
   i4 = i3 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   do if ((i3 | 0) == (i7 | 0)) HEAP32[gb + 1470404 >> 2] = i18 & ~(1 << i2); else {
    if (i7 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i1 = i7 + 12 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
     HEAP32[i1 >> 2] = i3;
     HEAP32[i4 >> 2] = i7;
     break;
    } else _abort();
   } while (0);
   i27 = i2 << 3;
   HEAP32[i5 + 4 >> 2] = i27 | 3;
   i27 = i5 + i27 + 4 | 0;
   HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 1;
   i27 = i6;
   STACKTOP = i28;
   return i27 | 0;
  }
  i17 = HEAP32[gb + 1470404 + 8 >> 2] | 0;
  if (i13 >>> 0 > i17 >>> 0) {
   if (i2 | 0) {
    i8 = 2 << i1;
    i2 = i2 << i1 & (i8 | 0 - i8);
    i2 = (i2 & 0 - i2) + -1 | 0;
    i8 = i2 >>> 12 & 16;
    i2 = i2 >>> i8;
    i4 = i2 >>> 5 & 8;
    i2 = i2 >>> i4;
    i6 = i2 >>> 2 & 4;
    i2 = i2 >>> i6;
    i3 = i2 >>> 1 & 2;
    i2 = i2 >>> i3;
    i1 = i2 >>> 1 & 1;
    i1 = (i4 | i8 | i6 | i3 | i1) + (i2 >>> i1) | 0;
    i2 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
    i3 = i2 + 8 | 0;
    i6 = HEAP32[i3 >> 2] | 0;
    i8 = i6 + 8 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    do if ((i2 | 0) == (i4 | 0)) {
     i9 = i18 & ~(1 << i1);
     HEAP32[gb + 1470404 >> 2] = i9;
    } else {
     if (i4 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
     i5 = i4 + 12 | 0;
     if ((HEAP32[i5 >> 2] | 0) == (i6 | 0)) {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i3 >> 2] = i4;
      i9 = i18;
      break;
     } else _abort();
    } while (0);
    i7 = (i1 << 3) - i13 | 0;
    HEAP32[i6 + 4 >> 2] = i13 | 3;
    i4 = i6 + i13 | 0;
    HEAP32[i4 + 4 >> 2] = i7 | 1;
    HEAP32[i4 + i7 >> 2] = i7;
    if (i17 | 0) {
     i5 = HEAP32[gb + 1470404 + 20 >> 2] | 0;
     i1 = i17 >>> 3;
     i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
     i1 = 1 << i1;
     if (!(i9 & i1)) {
      HEAP32[gb + 1470404 >> 2] = i9 | i1;
      i10 = i3;
      i11 = i3 + 8 | 0;
     } else {
      i1 = i3 + 8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
       i10 = i2;
       i11 = i1;
      }
     }
     HEAP32[i11 >> 2] = i5;
     HEAP32[i10 + 12 >> 2] = i5;
     HEAP32[i5 + 8 >> 2] = i10;
     HEAP32[i5 + 12 >> 2] = i3;
    }
    HEAP32[gb + 1470404 + 8 >> 2] = i7;
    HEAP32[gb + 1470404 + 20 >> 2] = i4;
    i27 = i8;
    STACKTOP = i28;
    return i27 | 0;
   }
   i8 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
   if (i8) {
    i2 = (i8 & 0 - i8) + -1 | 0;
    i26 = i2 >>> 12 & 16;
    i2 = i2 >>> i26;
    i25 = i2 >>> 5 & 8;
    i2 = i2 >>> i25;
    i27 = i2 >>> 2 & 4;
    i2 = i2 >>> i27;
    i9 = i2 >>> 1 & 2;
    i2 = i2 >>> i9;
    i10 = i2 >>> 1 & 1;
    i10 = HEAP32[gb + 1470404 + 304 + ((i25 | i26 | i27 | i9 | i10) + (i2 >>> i10) << 2) >> 2] | 0;
    i2 = i10;
    i9 = i10;
    i10 = (HEAP32[i10 + 4 >> 2] & -8) - i13 | 0;
    while (1) {
     i1 = HEAP32[i2 + 16 >> 2] | 0;
     if (!i1) {
      i1 = HEAP32[i2 + 20 >> 2] | 0;
      if (!i1) break;
     }
     i27 = (HEAP32[i1 + 4 >> 2] & -8) - i13 | 0;
     i26 = i27 >>> 0 < i10 >>> 0;
     i2 = i1;
     i9 = i26 ? i1 : i9;
     i10 = i26 ? i27 : i10;
    }
    i5 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
    if (i9 >>> 0 < i5 >>> 0) _abort();
    i7 = i9 + i13 | 0;
    if (i9 >>> 0 >= i7 >>> 0) _abort();
    i6 = HEAP32[i9 + 24 >> 2] | 0;
    i3 = HEAP32[i9 + 12 >> 2] | 0;
    do if ((i3 | 0) == (i9 | 0)) {
     i2 = i9 + 20 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) {
      i2 = i9 + 16 | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) {
       i12 = 0;
       break;
      }
     }
     while (1) {
      i3 = i1 + 20 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i4 | 0) {
       i1 = i4;
       i2 = i3;
       continue;
      }
      i3 = i1 + 16 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (!i4) break; else {
       i1 = i4;
       i2 = i3;
      }
     }
     if (i2 >>> 0 < i5 >>> 0) _abort(); else {
      HEAP32[i2 >> 2] = 0;
      i12 = i1;
      break;
     }
    } else {
     i4 = HEAP32[i9 + 8 >> 2] | 0;
     if (i4 >>> 0 < i5 >>> 0) _abort();
     i1 = i4 + 12 | 0;
     if ((HEAP32[i1 >> 2] | 0) != (i9 | 0)) _abort();
     i2 = i3 + 8 | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i2 >> 2] = i4;
      i12 = i3;
      break;
     } else _abort();
    } while (0);
    do if (i6 | 0) {
     i1 = HEAP32[i9 + 28 >> 2] | 0;
     i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
     if ((i9 | 0) == (HEAP32[i2 >> 2] | 0)) {
      HEAP32[i2 >> 2] = i12;
      if (!i12) {
       HEAP32[gb + 1470404 + 4 >> 2] = i8 & ~(1 << i1);
       break;
      }
     } else {
      if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
      i1 = i6 + 16 | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i9 | 0)) HEAP32[i1 >> 2] = i12; else HEAP32[i6 + 20 >> 2] = i12;
      if (!i12) break;
     }
     i2 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
     if (i12 >>> 0 < i2 >>> 0) _abort();
     HEAP32[i12 + 24 >> 2] = i6;
     i1 = HEAP32[i9 + 16 >> 2] | 0;
     do if (i1 | 0) if (i1 >>> 0 < i2 >>> 0) _abort(); else {
      HEAP32[i12 + 16 >> 2] = i1;
      HEAP32[i1 + 24 >> 2] = i12;
      break;
     } while (0);
     i1 = HEAP32[i9 + 20 >> 2] | 0;
     if (i1 | 0) if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
      HEAP32[i12 + 20 >> 2] = i1;
      HEAP32[i1 + 24 >> 2] = i12;
      break;
     }
    } while (0);
    if (i10 >>> 0 < 16) {
     i27 = i10 + i13 | 0;
     HEAP32[i9 + 4 >> 2] = i27 | 3;
     i27 = i9 + i27 + 4 | 0;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 1;
    } else {
     HEAP32[i9 + 4 >> 2] = i13 | 3;
     HEAP32[i7 + 4 >> 2] = i10 | 1;
     HEAP32[i7 + i10 >> 2] = i10;
     if (i17 | 0) {
      i4 = HEAP32[gb + 1470404 + 20 >> 2] | 0;
      i1 = i17 >>> 3;
      i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
      i1 = 1 << i1;
      if (!(i18 & i1)) {
       HEAP32[gb + 1470404 >> 2] = i18 | i1;
       i15 = i3;
       i16 = i3 + 8 | 0;
      } else {
       i1 = i3 + 8 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
        i15 = i2;
        i16 = i1;
       }
      }
      HEAP32[i16 >> 2] = i4;
      HEAP32[i15 + 12 >> 2] = i4;
      HEAP32[i4 + 8 >> 2] = i15;
      HEAP32[i4 + 12 >> 2] = i3;
     }
     HEAP32[gb + 1470404 + 8 >> 2] = i10;
     HEAP32[gb + 1470404 + 20 >> 2] = i7;
    }
    i27 = i9 + 8 | 0;
    STACKTOP = i28;
    return i27 | 0;
   }
  }
 } else if (i1 >>> 0 > 4294967231) i13 = -1; else {
  i1 = i1 + 11 | 0;
  i13 = i1 & -8;
  i10 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
  if (i10) {
   i3 = 0 - i13 | 0;
   i1 = i1 >>> 8;
   if (!i1) i7 = 0; else if (i13 >>> 0 > 16777215) i7 = 31; else {
    i16 = (i1 + 1048320 | 0) >>> 16 & 8;
    i21 = i1 << i16;
    i15 = (i21 + 520192 | 0) >>> 16 & 4;
    i21 = i21 << i15;
    i7 = (i21 + 245760 | 0) >>> 16 & 2;
    i7 = 14 - (i15 | i16 | i7) + (i21 << i7 >>> 15) | 0;
    i7 = i13 >>> (i7 + 7 | 0) & 1 | i7 << 1;
   }
   i1 = HEAP32[gb + 1470404 + 304 + (i7 << 2) >> 2] | 0;
   L123 : do if (!i1) {
    i2 = 0;
    i4 = 0;
    i21 = 86;
   } else {
    i4 = 0;
    i6 = i1;
    i5 = i13 << ((i7 | 0) == 31 ? 0 : 25 - (i7 >>> 1) | 0);
    i2 = 0;
    while (1) {
     i1 = (HEAP32[i6 + 4 >> 2] & -8) - i13 | 0;
     if (i1 >>> 0 < i3 >>> 0) if (!i1) {
      i1 = i6;
      i3 = 0;
      i2 = i6;
      i21 = 90;
      break L123;
     } else {
      i4 = i6;
      i3 = i1;
     }
     i1 = HEAP32[i6 + 20 >> 2] | 0;
     i6 = HEAP32[i6 + 16 + (i5 >>> 31 << 2) >> 2] | 0;
     i2 = (i1 | 0) == 0 | (i1 | 0) == (i6 | 0) ? i2 : i1;
     i1 = (i6 | 0) == 0;
     if (i1) {
      i21 = 86;
      break;
     } else i5 = i5 << (i1 & 1 ^ 1);
    }
   } while (0);
   if ((i21 | 0) == 86) {
    if ((i2 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 2 << i7;
     i1 = i10 & (i1 | 0 - i1);
     if (!i1) break;
     i16 = (i1 & 0 - i1) + -1 | 0;
     i11 = i16 >>> 12 & 16;
     i16 = i16 >>> i11;
     i9 = i16 >>> 5 & 8;
     i16 = i16 >>> i9;
     i12 = i16 >>> 2 & 4;
     i16 = i16 >>> i12;
     i15 = i16 >>> 1 & 2;
     i16 = i16 >>> i15;
     i2 = i16 >>> 1 & 1;
     i2 = HEAP32[gb + 1470404 + 304 + ((i9 | i11 | i12 | i15 | i2) + (i16 >>> i2) << 2) >> 2] | 0;
    }
    if (!i2) {
     i9 = i4;
     i7 = i3;
    } else {
     i1 = i4;
     i21 = 90;
    }
   }
   if ((i21 | 0) == 90) while (1) {
    i21 = 0;
    i16 = (HEAP32[i2 + 4 >> 2] & -8) - i13 | 0;
    i4 = i16 >>> 0 < i3 >>> 0;
    i3 = i4 ? i16 : i3;
    i1 = i4 ? i2 : i1;
    i4 = HEAP32[i2 + 16 >> 2] | 0;
    if (i4 | 0) {
     i2 = i4;
     i21 = 90;
     continue;
    }
    i2 = HEAP32[i2 + 20 >> 2] | 0;
    if (!i2) {
     i9 = i1;
     i7 = i3;
     break;
    } else i21 = 90;
   }
   if (i9) if (i7 >>> 0 < ((HEAP32[gb + 1470404 + 8 >> 2] | 0) - i13 | 0) >>> 0) {
    i5 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
    if (i9 >>> 0 < i5 >>> 0) _abort();
    i8 = i9 + i13 | 0;
    if (i9 >>> 0 >= i8 >>> 0) _abort();
    i6 = HEAP32[i9 + 24 >> 2] | 0;
    i3 = HEAP32[i9 + 12 >> 2] | 0;
    do if ((i3 | 0) == (i9 | 0)) {
     i2 = i9 + 20 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) {
      i2 = i9 + 16 | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) {
       i17 = 0;
       break;
      }
     }
     while (1) {
      i3 = i1 + 20 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i4 | 0) {
       i1 = i4;
       i2 = i3;
       continue;
      }
      i3 = i1 + 16 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (!i4) break; else {
       i1 = i4;
       i2 = i3;
      }
     }
     if (i2 >>> 0 < i5 >>> 0) _abort(); else {
      HEAP32[i2 >> 2] = 0;
      i17 = i1;
      break;
     }
    } else {
     i4 = HEAP32[i9 + 8 >> 2] | 0;
     if (i4 >>> 0 < i5 >>> 0) _abort();
     i1 = i4 + 12 | 0;
     if ((HEAP32[i1 >> 2] | 0) != (i9 | 0)) _abort();
     i2 = i3 + 8 | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i2 >> 2] = i4;
      i17 = i3;
      break;
     } else _abort();
    } while (0);
    do if (!i6) i18 = i10; else {
     i1 = HEAP32[i9 + 28 >> 2] | 0;
     i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
     if ((i9 | 0) == (HEAP32[i2 >> 2] | 0)) {
      HEAP32[i2 >> 2] = i17;
      if (!i17) {
       i18 = i10 & ~(1 << i1);
       HEAP32[gb + 1470404 + 4 >> 2] = i18;
       break;
      }
     } else {
      if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
      i1 = i6 + 16 | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i9 | 0)) HEAP32[i1 >> 2] = i17; else HEAP32[i6 + 20 >> 2] = i17;
      if (!i17) {
       i18 = i10;
       break;
      }
     }
     i2 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
     if (i17 >>> 0 < i2 >>> 0) _abort();
     HEAP32[i17 + 24 >> 2] = i6;
     i1 = HEAP32[i9 + 16 >> 2] | 0;
     do if (i1 | 0) if (i1 >>> 0 < i2 >>> 0) _abort(); else {
      HEAP32[i17 + 16 >> 2] = i1;
      HEAP32[i1 + 24 >> 2] = i17;
      break;
     } while (0);
     i1 = HEAP32[i9 + 20 >> 2] | 0;
     if (!i1) i18 = i10; else if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
      HEAP32[i17 + 20 >> 2] = i1;
      HEAP32[i1 + 24 >> 2] = i17;
      i18 = i10;
      break;
     }
    } while (0);
    do if (i7 >>> 0 < 16) {
     i27 = i7 + i13 | 0;
     HEAP32[i9 + 4 >> 2] = i27 | 3;
     i27 = i9 + i27 + 4 | 0;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 1;
    } else {
     HEAP32[i9 + 4 >> 2] = i13 | 3;
     HEAP32[i8 + 4 >> 2] = i7 | 1;
     HEAP32[i8 + i7 >> 2] = i7;
     i1 = i7 >>> 3;
     if (i7 >>> 0 < 256) {
      i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
      i2 = HEAP32[gb + 1470404 >> 2] | 0;
      i1 = 1 << i1;
      if (!(i2 & i1)) {
       HEAP32[gb + 1470404 >> 2] = i2 | i1;
       i19 = i3;
       i20 = i3 + 8 | 0;
      } else {
       i1 = i3 + 8 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
        i19 = i2;
        i20 = i1;
       }
      }
      HEAP32[i20 >> 2] = i8;
      HEAP32[i19 + 12 >> 2] = i8;
      HEAP32[i8 + 8 >> 2] = i19;
      HEAP32[i8 + 12 >> 2] = i3;
      break;
     }
     i1 = i7 >>> 8;
     if (!i1) i1 = 0; else if (i7 >>> 0 > 16777215) i1 = 31; else {
      i26 = (i1 + 1048320 | 0) >>> 16 & 8;
      i27 = i1 << i26;
      i25 = (i27 + 520192 | 0) >>> 16 & 4;
      i27 = i27 << i25;
      i1 = (i27 + 245760 | 0) >>> 16 & 2;
      i1 = 14 - (i25 | i26 | i1) + (i27 << i1 >>> 15) | 0;
      i1 = i7 >>> (i1 + 7 | 0) & 1 | i1 << 1;
     }
     i3 = gb + 1470404 + 304 + (i1 << 2) | 0;
     HEAP32[i8 + 28 >> 2] = i1;
     i2 = i8 + 16 | 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 >> 2] = 0;
     i2 = 1 << i1;
     if (!(i18 & i2)) {
      HEAP32[gb + 1470404 + 4 >> 2] = i18 | i2;
      HEAP32[i3 >> 2] = i8;
      HEAP32[i8 + 24 >> 2] = i3;
      HEAP32[i8 + 12 >> 2] = i8;
      HEAP32[i8 + 8 >> 2] = i8;
      break;
     }
     i2 = i7 << ((i1 | 0) == 31 ? 0 : 25 - (i1 >>> 1) | 0);
     i4 = HEAP32[i3 >> 2] | 0;
     while (1) {
      if ((HEAP32[i4 + 4 >> 2] & -8 | 0) == (i7 | 0)) {
       i21 = 148;
       break;
      }
      i3 = i4 + 16 + (i2 >>> 31 << 2) | 0;
      i1 = HEAP32[i3 >> 2] | 0;
      if (!i1) {
       i21 = 145;
       break;
      } else {
       i2 = i2 << 1;
       i4 = i1;
      }
     }
     if ((i21 | 0) == 145) if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
      HEAP32[i3 >> 2] = i8;
      HEAP32[i8 + 24 >> 2] = i4;
      HEAP32[i8 + 12 >> 2] = i8;
      HEAP32[i8 + 8 >> 2] = i8;
      break;
     } else if ((i21 | 0) == 148) {
      i1 = i4 + 8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      i27 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
      if (i2 >>> 0 >= i27 >>> 0 & i4 >>> 0 >= i27 >>> 0) {
       HEAP32[i2 + 12 >> 2] = i8;
       HEAP32[i1 >> 2] = i8;
       HEAP32[i8 + 8 >> 2] = i2;
       HEAP32[i8 + 12 >> 2] = i4;
       HEAP32[i8 + 24 >> 2] = 0;
       break;
      } else _abort();
     }
    } while (0);
    i27 = i9 + 8 | 0;
    STACKTOP = i28;
    return i27 | 0;
   }
  }
 } while (0);
 i3 = HEAP32[gb + 1470404 + 8 >> 2] | 0;
 if (i3 >>> 0 >= i13 >>> 0) {
  i1 = i3 - i13 | 0;
  i2 = HEAP32[gb + 1470404 + 20 >> 2] | 0;
  if (i1 >>> 0 > 15) {
   i27 = i2 + i13 | 0;
   HEAP32[gb + 1470404 + 20 >> 2] = i27;
   HEAP32[gb + 1470404 + 8 >> 2] = i1;
   HEAP32[i27 + 4 >> 2] = i1 | 1;
   HEAP32[i27 + i1 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i13 | 3;
  } else {
   HEAP32[gb + 1470404 + 8 >> 2] = 0;
   HEAP32[gb + 1470404 + 20 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = i3 | 3;
   i27 = i2 + i3 + 4 | 0;
   HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 1;
  }
  i27 = i2 + 8 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i7 = HEAP32[gb + 1470404 + 12 >> 2] | 0;
 if (i7 >>> 0 > i13 >>> 0) {
  i25 = i7 - i13 | 0;
  HEAP32[gb + 1470404 + 12 >> 2] = i25;
  i27 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
  i26 = i27 + i13 | 0;
  HEAP32[gb + 1470404 + 24 >> 2] = i26;
  HEAP32[i26 + 4 >> 2] = i25 | 1;
  HEAP32[i27 + 4 >> 2] = i13 | 3;
  i27 = i27 + 8 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i1 = i14 & -16 ^ 1431655768;
  HEAP32[i14 >> 2] = i1;
  HEAP32[gb + 1470876 >> 2] = i1;
  i1 = 4096;
 } else i1 = HEAP32[gb + 1470876 + 8 >> 2] | 0;
 i8 = i13 + 48 | 0;
 i9 = i13 + 47 | 0;
 i6 = i1 + i9 | 0;
 i4 = 0 - i1 | 0;
 i10 = i6 & i4;
 if (i10 >>> 0 <= i13 >>> 0) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i1 = HEAP32[gb + 1470404 + 440 >> 2] | 0;
 if (i1 | 0) {
  i19 = HEAP32[gb + 1470404 + 432 >> 2] | 0;
  i20 = i19 + i10 | 0;
  if (i20 >>> 0 <= i19 >>> 0 | i20 >>> 0 > i1 >>> 0) {
   i27 = 0;
   STACKTOP = i28;
   return i27 | 0;
  }
 }
 L255 : do if (!(HEAP32[gb + 1470404 + 444 >> 2] & 4)) {
  i2 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
  L257 : do if (!i2) i21 = 172; else {
   i3 = gb + 1470404 + 448 | 0;
   while (1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 >>> 0 <= i2 >>> 0) {
     i5 = i3 + 4 | 0;
     if ((i1 + (HEAP32[i5 >> 2] | 0) | 0) >>> 0 > i2 >>> 0) break;
    }
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    if (!i1) {
     i21 = 172;
     break L257;
    } else i3 = i1;
   }
   i1 = i6 - i7 & i4;
   if (i1 >>> 0 < 2147483647) {
    i2 = _sbrk(i1 | 0) | 0;
    if ((i2 | 0) == ((HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0)) {
     if ((i2 | 0) != (-1 | 0)) {
      i7 = i1;
      i6 = i2;
      i21 = 190;
      break L255;
     }
    } else {
     i4 = i2;
     i21 = 180;
    }
   }
  } while (0);
  do if ((i21 | 0) == 172) {
   i5 = _sbrk(0) | 0;
   if ((i5 | 0) != (-1 | 0)) {
    i1 = i5;
    i2 = HEAP32[gb + 1470876 + 4 >> 2] | 0;
    i3 = i2 + -1 | 0;
    i1 = ((i3 & i1 | 0) == 0 ? 0 : (i3 + i1 & 0 - i2) - i1 | 0) + i10 | 0;
    i2 = HEAP32[gb + 1470404 + 432 >> 2] | 0;
    i3 = i1 + i2 | 0;
    if (i1 >>> 0 > i13 >>> 0 & i1 >>> 0 < 2147483647) {
     i4 = HEAP32[gb + 1470404 + 440 >> 2] | 0;
     if (i4 | 0) if (i3 >>> 0 <= i2 >>> 0 | i3 >>> 0 > i4 >>> 0) break;
     i2 = _sbrk(i1 | 0) | 0;
     if ((i2 | 0) == (i5 | 0)) {
      i7 = i1;
      i6 = i5;
      i21 = 190;
      break L255;
     } else {
      i4 = i2;
      i21 = 180;
     }
    }
   }
  } while (0);
  L274 : do if ((i21 | 0) == 180) {
   i3 = 0 - i1 | 0;
   do if (i8 >>> 0 > i1 >>> 0 & (i1 >>> 0 < 2147483647 & (i4 | 0) != (-1 | 0))) {
    i2 = HEAP32[gb + 1470876 + 8 >> 2] | 0;
    i2 = i9 - i1 + i2 & 0 - i2;
    if (i2 >>> 0 < 2147483647) if ((_sbrk(i2 | 0) | 0) == (-1 | 0)) {
     _sbrk(i3 | 0) | 0;
     break L274;
    } else {
     i1 = i2 + i1 | 0;
     break;
    }
   } while (0);
   if ((i4 | 0) != (-1 | 0)) {
    i7 = i1;
    i6 = i4;
    i21 = 190;
    break L255;
   }
  } while (0);
  HEAP32[gb + 1470404 + 444 >> 2] = HEAP32[gb + 1470404 + 444 >> 2] | 4;
  i21 = 187;
 } else i21 = 187; while (0);
 if ((i21 | 0) == 187) if (i10 >>> 0 < 2147483647) {
  i2 = _sbrk(i10 | 0) | 0;
  i1 = _sbrk(0) | 0;
  if (i2 >>> 0 < i1 >>> 0 & ((i2 | 0) != (-1 | 0) & (i1 | 0) != (-1 | 0))) {
   i1 = i1 - i2 | 0;
   if (i1 >>> 0 > (i13 + 40 | 0) >>> 0) {
    i7 = i1;
    i6 = i2;
    i21 = 190;
   }
  }
 }
 if ((i21 | 0) == 190) {
  i1 = (HEAP32[gb + 1470404 + 432 >> 2] | 0) + i7 | 0;
  HEAP32[gb + 1470404 + 432 >> 2] = i1;
  if (i1 >>> 0 > (HEAP32[gb + 1470404 + 436 >> 2] | 0) >>> 0) HEAP32[gb + 1470404 + 436 >> 2] = i1;
  i10 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
  do if (!i10) {
   i27 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if ((i27 | 0) == 0 | i6 >>> 0 < i27 >>> 0) HEAP32[gb + 1470404 + 16 >> 2] = i6;
   HEAP32[gb + 1470404 + 448 >> 2] = i6;
   HEAP32[gb + 1470404 + 452 >> 2] = i7;
   HEAP32[gb + 1470404 + 460 >> 2] = 0;
   HEAP32[gb + 1470404 + 36 >> 2] = HEAP32[gb + 1470876 >> 2];
   HEAP32[gb + 1470404 + 32 >> 2] = -1;
   i1 = 0;
   do {
    i27 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
    HEAP32[i27 + 12 >> 2] = i27;
    HEAP32[i27 + 8 >> 2] = i27;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 32);
   i27 = i6 + 8 | 0;
   i27 = (i27 & 7 | 0) == 0 ? 0 : 0 - i27 & 7;
   i26 = i6 + i27 | 0;
   i27 = i7 + -40 - i27 | 0;
   HEAP32[gb + 1470404 + 24 >> 2] = i26;
   HEAP32[gb + 1470404 + 12 >> 2] = i27;
   HEAP32[i26 + 4 >> 2] = i27 | 1;
   HEAP32[i26 + i27 + 4 >> 2] = 40;
   HEAP32[gb + 1470404 + 28 >> 2] = HEAP32[gb + 1470876 + 16 >> 2];
  } else {
   i1 = gb + 1470404 + 448 | 0;
   do {
    i2 = HEAP32[i1 >> 2] | 0;
    i3 = i1 + 4 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i6 | 0) == (i2 + i4 | 0)) {
     i21 = 200;
     break;
    }
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   } while ((i1 | 0) != 0);
   if ((i21 | 0) == 200) if (!(HEAP32[i1 + 12 >> 2] & 8)) if (i10 >>> 0 < i6 >>> 0 & i10 >>> 0 >= i2 >>> 0) {
    HEAP32[i3 >> 2] = i4 + i7;
    i27 = i10 + 8 | 0;
    i27 = (i27 & 7 | 0) == 0 ? 0 : 0 - i27 & 7;
    i26 = i10 + i27 | 0;
    i27 = i7 - i27 + (HEAP32[gb + 1470404 + 12 >> 2] | 0) | 0;
    HEAP32[gb + 1470404 + 24 >> 2] = i26;
    HEAP32[gb + 1470404 + 12 >> 2] = i27;
    HEAP32[i26 + 4 >> 2] = i27 | 1;
    HEAP32[i26 + i27 + 4 >> 2] = 40;
    HEAP32[gb + 1470404 + 28 >> 2] = HEAP32[gb + 1470876 + 16 >> 2];
    break;
   }
   i1 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if (i6 >>> 0 < i1 >>> 0) {
    HEAP32[gb + 1470404 + 16 >> 2] = i6;
    i8 = i6;
   } else i8 = i1;
   i2 = i6 + i7 | 0;
   i1 = gb + 1470404 + 448 | 0;
   while (1) {
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
     i21 = 208;
     break;
    }
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i1) {
     i2 = gb + 1470404 + 448 | 0;
     break;
    }
   }
   if ((i21 | 0) == 208) if (!(HEAP32[i1 + 12 >> 2] & 8)) {
    HEAP32[i1 >> 2] = i6;
    i12 = i1 + 4 | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i7;
    i12 = i6 + 8 | 0;
    i12 = i6 + ((i12 & 7 | 0) == 0 ? 0 : 0 - i12 & 7) | 0;
    i1 = i2 + 8 | 0;
    i1 = i2 + ((i1 & 7 | 0) == 0 ? 0 : 0 - i1 & 7) | 0;
    i11 = i12 + i13 | 0;
    i9 = i1 - i12 - i13 | 0;
    HEAP32[i12 + 4 >> 2] = i13 | 3;
    do if ((i1 | 0) == (i10 | 0)) {
     i27 = (HEAP32[gb + 1470404 + 12 >> 2] | 0) + i9 | 0;
     HEAP32[gb + 1470404 + 12 >> 2] = i27;
     HEAP32[gb + 1470404 + 24 >> 2] = i11;
     HEAP32[i11 + 4 >> 2] = i27 | 1;
    } else {
     if ((i1 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
      i27 = (HEAP32[gb + 1470404 + 8 >> 2] | 0) + i9 | 0;
      HEAP32[gb + 1470404 + 8 >> 2] = i27;
      HEAP32[gb + 1470404 + 20 >> 2] = i11;
      HEAP32[i11 + 4 >> 2] = i27 | 1;
      HEAP32[i11 + i27 >> 2] = i27;
      break;
     }
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if ((i2 & 3 | 0) == 1) {
      i7 = i2 & -8;
      i5 = i2 >>> 3;
      L326 : do if (i2 >>> 0 < 256) {
       i3 = HEAP32[i1 + 8 >> 2] | 0;
       i4 = HEAP32[i1 + 12 >> 2] | 0;
       i2 = gb + 1470404 + 40 + (i5 << 1 << 2) | 0;
       do if ((i3 | 0) != (i2 | 0)) {
        if (i3 >>> 0 < i8 >>> 0) _abort();
        if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) break;
        _abort();
       } while (0);
       if ((i4 | 0) == (i3 | 0)) {
        HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i5);
        break;
       }
       do if ((i4 | 0) == (i2 | 0)) i22 = i4 + 8 | 0; else {
        if (i4 >>> 0 < i8 >>> 0) _abort();
        i2 = i4 + 8 | 0;
        if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
         i22 = i2;
         break;
        }
        _abort();
       } while (0);
       HEAP32[i3 + 12 >> 2] = i4;
       HEAP32[i22 >> 2] = i3;
      } else {
       i6 = HEAP32[i1 + 24 >> 2] | 0;
       i4 = HEAP32[i1 + 12 >> 2] | 0;
       do if ((i4 | 0) == (i1 | 0)) {
        i4 = i1 + 16 | 0;
        i3 = i4 + 4 | 0;
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i2 = HEAP32[i4 >> 2] | 0;
         if (!i2) {
          i25 = 0;
          break;
         } else i3 = i4;
        }
        while (1) {
         i4 = i2 + 20 | 0;
         i5 = HEAP32[i4 >> 2] | 0;
         if (i5 | 0) {
          i2 = i5;
          i3 = i4;
          continue;
         }
         i4 = i2 + 16 | 0;
         i5 = HEAP32[i4 >> 2] | 0;
         if (!i5) break; else {
          i2 = i5;
          i3 = i4;
         }
        }
        if (i3 >>> 0 < i8 >>> 0) _abort(); else {
         HEAP32[i3 >> 2] = 0;
         i25 = i2;
         break;
        }
       } else {
        i5 = HEAP32[i1 + 8 >> 2] | 0;
        if (i5 >>> 0 < i8 >>> 0) _abort();
        i2 = i5 + 12 | 0;
        if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) _abort();
        i3 = i4 + 8 | 0;
        if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
         HEAP32[i2 >> 2] = i4;
         HEAP32[i3 >> 2] = i5;
         i25 = i4;
         break;
        } else _abort();
       } while (0);
       if (!i6) break;
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = gb + 1470404 + 304 + (i2 << 2) | 0;
       do if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
        HEAP32[i3 >> 2] = i25;
        if (i25 | 0) break;
        HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i2);
        break L326;
       } else {
        if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
        i2 = i6 + 16 | 0;
        if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) HEAP32[i2 >> 2] = i25; else HEAP32[i6 + 20 >> 2] = i25;
        if (!i25) break L326;
       } while (0);
       i4 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
       if (i25 >>> 0 < i4 >>> 0) _abort();
       HEAP32[i25 + 24 >> 2] = i6;
       i2 = i1 + 16 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       do if (i3 | 0) if (i3 >>> 0 < i4 >>> 0) _abort(); else {
        HEAP32[i25 + 16 >> 2] = i3;
        HEAP32[i3 + 24 >> 2] = i25;
        break;
       } while (0);
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) break;
       if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
        HEAP32[i25 + 20 >> 2] = i2;
        HEAP32[i2 + 24 >> 2] = i25;
        break;
       }
      } while (0);
      i1 = i1 + i7 | 0;
      i5 = i7 + i9 | 0;
     } else i5 = i9;
     i1 = i1 + 4 | 0;
     HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -2;
     HEAP32[i11 + 4 >> 2] = i5 | 1;
     HEAP32[i11 + i5 >> 2] = i5;
     i1 = i5 >>> 3;
     if (i5 >>> 0 < 256) {
      i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
      i2 = HEAP32[gb + 1470404 >> 2] | 0;
      i1 = 1 << i1;
      do if (!(i2 & i1)) {
       HEAP32[gb + 1470404 >> 2] = i2 | i1;
       i26 = i3;
       i27 = i3 + 8 | 0;
      } else {
       i1 = i3 + 8 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       if (i2 >>> 0 >= (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) {
        i26 = i2;
        i27 = i1;
        break;
       }
       _abort();
      } while (0);
      HEAP32[i27 >> 2] = i11;
      HEAP32[i26 + 12 >> 2] = i11;
      HEAP32[i11 + 8 >> 2] = i26;
      HEAP32[i11 + 12 >> 2] = i3;
      break;
     }
     i1 = i5 >>> 8;
     do if (!i1) i1 = 0; else {
      if (i5 >>> 0 > 16777215) {
       i1 = 31;
       break;
      }
      i26 = (i1 + 1048320 | 0) >>> 16 & 8;
      i27 = i1 << i26;
      i25 = (i27 + 520192 | 0) >>> 16 & 4;
      i27 = i27 << i25;
      i1 = (i27 + 245760 | 0) >>> 16 & 2;
      i1 = 14 - (i25 | i26 | i1) + (i27 << i1 >>> 15) | 0;
      i1 = i5 >>> (i1 + 7 | 0) & 1 | i1 << 1;
     } while (0);
     i4 = gb + 1470404 + 304 + (i1 << 2) | 0;
     HEAP32[i11 + 28 >> 2] = i1;
     i2 = i11 + 16 | 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 >> 2] = 0;
     i2 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
     i3 = 1 << i1;
     if (!(i2 & i3)) {
      HEAP32[gb + 1470404 + 4 >> 2] = i2 | i3;
      HEAP32[i4 >> 2] = i11;
      HEAP32[i11 + 24 >> 2] = i4;
      HEAP32[i11 + 12 >> 2] = i11;
      HEAP32[i11 + 8 >> 2] = i11;
      break;
     }
     i2 = i5 << ((i1 | 0) == 31 ? 0 : 25 - (i1 >>> 1) | 0);
     i4 = HEAP32[i4 >> 2] | 0;
     while (1) {
      if ((HEAP32[i4 + 4 >> 2] & -8 | 0) == (i5 | 0)) {
       i21 = 278;
       break;
      }
      i3 = i4 + 16 + (i2 >>> 31 << 2) | 0;
      i1 = HEAP32[i3 >> 2] | 0;
      if (!i1) {
       i21 = 275;
       break;
      } else {
       i2 = i2 << 1;
       i4 = i1;
      }
     }
     if ((i21 | 0) == 275) if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
      HEAP32[i3 >> 2] = i11;
      HEAP32[i11 + 24 >> 2] = i4;
      HEAP32[i11 + 12 >> 2] = i11;
      HEAP32[i11 + 8 >> 2] = i11;
      break;
     } else if ((i21 | 0) == 278) {
      i1 = i4 + 8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      i27 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
      if (i2 >>> 0 >= i27 >>> 0 & i4 >>> 0 >= i27 >>> 0) {
       HEAP32[i2 + 12 >> 2] = i11;
       HEAP32[i1 >> 2] = i11;
       HEAP32[i11 + 8 >> 2] = i2;
       HEAP32[i11 + 12 >> 2] = i4;
       HEAP32[i11 + 24 >> 2] = 0;
       break;
      } else _abort();
     }
    } while (0);
    i27 = i12 + 8 | 0;
    STACKTOP = i28;
    return i27 | 0;
   } else i2 = gb + 1470404 + 448 | 0;
   while (1) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (i1 >>> 0 <= i10 >>> 0) {
     i3 = i1 + (HEAP32[i2 + 4 >> 2] | 0) | 0;
     if (i3 >>> 0 > i10 >>> 0) break;
    }
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   }
   i5 = i3 + -47 | 0;
   i2 = i5 + 8 | 0;
   i2 = i5 + ((i2 & 7 | 0) == 0 ? 0 : 0 - i2 & 7) | 0;
   i5 = i10 + 16 | 0;
   i2 = i2 >>> 0 < i5 >>> 0 ? i10 : i2;
   i1 = i2 + 8 | 0;
   i4 = i6 + 8 | 0;
   i4 = (i4 & 7 | 0) == 0 ? 0 : 0 - i4 & 7;
   i27 = i6 + i4 | 0;
   i4 = i7 + -40 - i4 | 0;
   HEAP32[gb + 1470404 + 24 >> 2] = i27;
   HEAP32[gb + 1470404 + 12 >> 2] = i4;
   HEAP32[i27 + 4 >> 2] = i4 | 1;
   HEAP32[i27 + i4 + 4 >> 2] = 40;
   HEAP32[gb + 1470404 + 28 >> 2] = HEAP32[gb + 1470876 + 16 >> 2];
   i4 = i2 + 4 | 0;
   HEAP32[i4 >> 2] = 27;
   HEAP32[i1 >> 2] = HEAP32[gb + 1470404 + 448 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1470404 + 448 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1470404 + 448 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[gb + 1470404 + 448 + 12 >> 2];
   HEAP32[gb + 1470404 + 448 >> 2] = i6;
   HEAP32[gb + 1470404 + 452 >> 2] = i7;
   HEAP32[gb + 1470404 + 460 >> 2] = 0;
   HEAP32[gb + 1470404 + 456 >> 2] = i1;
   i1 = i2 + 24 | 0;
   do {
    i1 = i1 + 4 | 0;
    HEAP32[i1 >> 2] = 7;
   } while ((i1 + 4 | 0) >>> 0 < i3 >>> 0);
   if ((i2 | 0) != (i10 | 0)) {
    i6 = i2 - i10 | 0;
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -2;
    HEAP32[i10 + 4 >> 2] = i6 | 1;
    HEAP32[i2 >> 2] = i6;
    i1 = i6 >>> 3;
    if (i6 >>> 0 < 256) {
     i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
     i2 = HEAP32[gb + 1470404 >> 2] | 0;
     i1 = 1 << i1;
     if (!(i2 & i1)) {
      HEAP32[gb + 1470404 >> 2] = i2 | i1;
      i23 = i3;
      i24 = i3 + 8 | 0;
     } else {
      i1 = i3 + 8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
       i23 = i2;
       i24 = i1;
      }
     }
     HEAP32[i24 >> 2] = i10;
     HEAP32[i23 + 12 >> 2] = i10;
     HEAP32[i10 + 8 >> 2] = i23;
     HEAP32[i10 + 12 >> 2] = i3;
     break;
    }
    i1 = i6 >>> 8;
    if (!i1) i3 = 0; else if (i6 >>> 0 > 16777215) i3 = 31; else {
     i26 = (i1 + 1048320 | 0) >>> 16 & 8;
     i27 = i1 << i26;
     i25 = (i27 + 520192 | 0) >>> 16 & 4;
     i27 = i27 << i25;
     i3 = (i27 + 245760 | 0) >>> 16 & 2;
     i3 = 14 - (i25 | i26 | i3) + (i27 << i3 >>> 15) | 0;
     i3 = i6 >>> (i3 + 7 | 0) & 1 | i3 << 1;
    }
    i4 = gb + 1470404 + 304 + (i3 << 2) | 0;
    HEAP32[i10 + 28 >> 2] = i3;
    HEAP32[i10 + 20 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    i1 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
    i2 = 1 << i3;
    if (!(i1 & i2)) {
     HEAP32[gb + 1470404 + 4 >> 2] = i1 | i2;
     HEAP32[i4 >> 2] = i10;
     HEAP32[i10 + 24 >> 2] = i4;
     HEAP32[i10 + 12 >> 2] = i10;
     HEAP32[i10 + 8 >> 2] = i10;
     break;
    }
    i2 = i6 << ((i3 | 0) == 31 ? 0 : 25 - (i3 >>> 1) | 0);
    i4 = HEAP32[i4 >> 2] | 0;
    while (1) {
     if ((HEAP32[i4 + 4 >> 2] & -8 | 0) == (i6 | 0)) {
      i21 = 304;
      break;
     }
     i3 = i4 + 16 + (i2 >>> 31 << 2) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      i21 = 301;
      break;
     } else {
      i2 = i2 << 1;
      i4 = i1;
     }
    }
    if ((i21 | 0) == 301) if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
     HEAP32[i3 >> 2] = i10;
     HEAP32[i10 + 24 >> 2] = i4;
     HEAP32[i10 + 12 >> 2] = i10;
     HEAP32[i10 + 8 >> 2] = i10;
     break;
    } else if ((i21 | 0) == 304) {
     i1 = i4 + 8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     i27 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
     if (i2 >>> 0 >= i27 >>> 0 & i4 >>> 0 >= i27 >>> 0) {
      HEAP32[i2 + 12 >> 2] = i10;
      HEAP32[i1 >> 2] = i10;
      HEAP32[i10 + 8 >> 2] = i2;
      HEAP32[i10 + 12 >> 2] = i4;
      HEAP32[i10 + 24 >> 2] = 0;
      break;
     } else _abort();
    }
   }
  } while (0);
  i1 = HEAP32[gb + 1470404 + 12 >> 2] | 0;
  if (i1 >>> 0 > i13 >>> 0) {
   i25 = i1 - i13 | 0;
   HEAP32[gb + 1470404 + 12 >> 2] = i25;
   i27 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
   i26 = i27 + i13 | 0;
   HEAP32[gb + 1470404 + 24 >> 2] = i26;
   HEAP32[i26 + 4 >> 2] = i25 | 1;
   HEAP32[i27 + 4 >> 2] = i13 | 3;
   i27 = i27 + 8 | 0;
   STACKTOP = i28;
   return i27 | 0;
  }
 }
 HEAP32[(___errno_location() | 0) >> 2] = 12;
 i27 = 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN14PlayerSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i6 = i11 + 20 | 0;
 i9 = i11 + 16 | 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 10);
 i7 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448100 | 0, gb + 863904 | 0, i7, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448112 | 0, i7, i1 + 280 | 0, 0);
 i10 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i12 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448128 | 0, i12, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448153 | 0, i12, i1 + 288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448166 | 0, i7, i1 + 292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448187 | 0, i12, i1 + 296 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448210 | 0, i7, i1 + 96 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i8 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448222 | 0, i7, i1 + 112 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 268 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448234 | 0, gb + 1034905 | 0, i8, 0);
 i7 = i4 + 8 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i12, i8, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448248 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 0);
 i12 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i12;
 i12 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i12, i7, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i12, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN26PlayerSettingsSplashScreen8TransferI24GenerateTypeTreeTransferEEvRT_(i1 + 144 | 0, i2);
 i12 = i1 + 264 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448262 | 0, gb + 1034905 | 0, i12, 0);
 i7 = i4 + 8 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i5, i12, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448294 | 0, i5, i1 + 300 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448313 | 0, i5, i1 + 304 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448333 | 0, i5, i1 + 308 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448355 | 0, i5, i1 + 312 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448378 | 0, i5, i1 + 328 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448400 | 0, i5, i1 + 332 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448419 | 0, i5, i1 + 336 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448433 | 0, i5, i1 + 337 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448453 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 340 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448471 | 0, i7, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448505 | 0, i7, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448543 | 0, i7, i1 + 368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448579 | 0, i7, i1 + 372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448606 | 0, i7, i1 + 316 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448630 | 0, i5, i1 + 376 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448651 | 0, i5, i1 + 377 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448679 | 0, i5, i1 + 378 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448717 | 0, i5, i1 + 379 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448751 | 0, i5, i1 + 380 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448784 | 0, i5, i1 + 381 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448802 | 0, i5, i1 + 382 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448824 | 0, i5, i1 + 384 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448854 | 0, i5, i1 + 386 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448874 | 0, i5, i1 + 387 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448900 | 0, i5, i1 + 388 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448916 | 0, i5, i1 + 389 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448936 | 0, i5, i1 + 390 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448958 | 0, i5, i1 + 391 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 448984 | 0, i5, i1 + 392 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449e3 | 0, i5, i1 + 393 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449013 | 0, i5, i1 + 394 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449033 | 0, i5, i1 + 412 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449053 | 0, i5, i1 + 413 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449069 | 0, i5, i1 + 395 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449094 | 0, i5, i1 + 414 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449106 | 0, i5, i1 + 415 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449119 | 0, i5, i1 + 416 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449141 | 0, i5, i1 + 417 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449158 | 0, i5, i1 + 418 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449175 | 0, i5, i1 + 419 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449204 | 0, i5, i1 + 424 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449222 | 0, i5, i1 + 396 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449242 | 0, i5, i1 + 397 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 400 | 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449264 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 if (!(HEAP32[i7 >> 2] | 0)) HEAP32[i7 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449282 | 0, i8, i1 + 404 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449301 | 0, i8, i1 + 408 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449321 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 420 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449334 | 0, i5, i1 + 425 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449360 | 0, i5, i1 + 426 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449376 | 0, i5, i1 + 427 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449398 | 0, i5, i1 + 428 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449426 | 0, i5, i1 + 429 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449450 | 0, i5, i1 + 430 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449466 | 0, i5, i1 + 383 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449488 | 0, i5, i1 + 385 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449505 | 0, i7, i1 + 432 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449523 | 0, i7, i1 + 436 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449547 | 0, i7, i1 + 440 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449567 | 0, i7, i1 + 444 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449595 | 0, i7, i1 + 448 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449609 | 0, i8, i1 + 452 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449624 | 0, i7, i1 + 504 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449641 | 0, i7, i1 + 508 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449657 | 0, i8, i1 + 512 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449677 | 0, i8, i1 + 513 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449707 | 0, i8, i1 + 514 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449732 | 0, i8, i1 + 515 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449755 | 0, i8, i1 + 516 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449781 | 0, i8, i1 + 517 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449804 | 0, i8, i1 + 520 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 320 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449824 | 0, gb + 449848 | 0, i7, 0);
 __ZN12AspectRatios8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449861 | 0, i7, i1 + 556 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i12 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449878 | 0, i7, i1 + 572 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449892 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 604 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37176 >> 2] | 0, i9, 0);
 i12 = i4 + 8 | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i12, 1);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = i1 + 624 | 0;
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449908 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449925 | 0, i12, i1 + 628 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449958 | 0, i12, i1 + 629 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 449993 | 0, i12, i1 + 630 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450015 | 0, i8, i1 + 44 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i9 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450030 | 0, i8, i1 + 64 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450042 | 0, i8, i1 + 80 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450057 | 0, i12, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i11;
 return;
}

function __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif(i45, i46, i47, i39, f15) {
 i45 = i45 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 i39 = i39 | 0;
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i52;
 i31 = i52 + 96 | 0;
 i21 = i52 + 72 | 0;
 i32 = i52 + 48 | 0;
 i34 = i52 + 36 | 0;
 i51 = i52 + 132 | 0;
 i37 = i52 + 84 | 0;
 i44 = i52 + 60 | 0;
 if ((i47 | 0) < 4) {
  i51 = 1;
  STACKTOP = i52;
  return i51 | 0;
 }
 i38 = (i39 | 0) == 0;
 f7 = Math_fround(HEAPF32[i46 >> 2]);
 f4 = Math_fround(HEAPF32[i46 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i46 + 8 >> 2]);
 i9 = i47 << 2;
 i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i48, i9, gb + 730303 | 0, 136) | 0;
 i49 = i51 + 4 | 0;
 HEAP32[i49 >> 2] = 0;
 i50 = i51 + 8 | 0;
 HEAP32[i50 >> 2] = i47;
 i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i48, i9, gb + 730303 | 0, 136) | 0;
 HEAP32[i51 >> 2] = i9;
 i11 = 0;
 i12 = i47;
 i3 = i47;
 f10 = f7;
 f6 = f4;
 f13 = f8;
 i5 = 0;
 while (1) {
  if ((i11 | 0) == (i12 | 0)) {
   i2 = (i12 | 0) == 0 ? 16 : i12 << 1;
   HEAP32[i50 >> 2] = i2;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i48, i2 << 2, gb + 730303 | 0, 136) | 0;
   HEAP32[i51 >> 2] = i2;
   if ((i12 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i9 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i12 | 0));
    i43 = 7;
   } else if (i9 | 0) i43 = 7;
   if ((i43 | 0) == 7) {
    i43 = 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i31, i9);
   }
   i9 = i2;
  }
  HEAP32[i49 >> 2] = i11 + 1;
  HEAP32[i9 + (i11 << 2) >> 2] = 1;
  if ((i5 | 0) == (i3 | 0)) {
   i3 = (i5 | 0) == 0 ? 16 : i5 << 1;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i48, i3 << 2, gb + 730303 | 0, 136) | 0;
   if ((i5 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i14 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i5 | 0));
    i43 = 13;
   } else if (i14 | 0) i43 = 13;
   if ((i43 | 0) == 13) {
    i43 = 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i31, i14);
   }
  } else i2 = i14;
  i1 = i5 + 1 | 0;
  HEAP32[i2 + (i5 << 2) >> 2] = 0;
  f36 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) >> 2]);
  f40 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) + 4 >> 2]);
  f41 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) + 8 >> 2]);
  f10 = f10 < f36 ? f10 : f36;
  f6 = f6 < f40 ? f6 : f40;
  f13 = f13 < f41 ? f13 : f41;
  f7 = f7 > f36 ? f7 : f36;
  f4 = f4 > f40 ? f4 : f40;
  f8 = f8 > f41 ? f8 : f41;
  if ((i1 | 0) == (i47 | 0)) {
   i42 = i2;
   break;
  }
  i11 = HEAP32[i49 >> 2] | 0;
  i12 = HEAP32[i50 >> 2] | 0;
  i14 = i2;
  i5 = i1;
 }
 f7 = Math_fround(f7 - f10);
 f6 = Math_fround(f4 - f6);
 f4 = Math_fround(f8 - f13);
 f41 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))))) * Math_fround(.00100000005));
 i33 = f15 != Math_fround(0.0);
 f36 = Math_fround(f15 * Math_fround(2.0));
 f40 = Math_fround(Math_fround(f41 * f41) * Math_fround(.100000001));
 f40 = i33 ? f36 : f40;
 i30 = i48;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAPF32[i48 >> 2] = Math_fround(1.0);
 HEAPF32[i48 + 4 >> 2] = Math_fround(.0199999996);
 HEAPF32[i48 + 8 >> 2] = Math_fround(.00999999977);
 HEAPF32[i48 + 12 >> 2] = Math_fround(-.0199999996);
 HEAPF32[i48 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i48 + 20 >> 2] = Math_fround(-.00999999977);
 HEAPF32[i48 + 24 >> 2] = Math_fround(.00999999977);
 HEAPF32[i48 + 28 >> 2] = Math_fround(.0199999996);
 HEAPF32[i48 + 32 >> 2] = Math_fround(1.0);
 if (f4 > f6 & f4 > f7) {
  i1 = 2;
  i9 = 0;
  i11 = 1;
 } else {
  i11 = f6 > f4 & f6 > f7;
  i1 = i11 & 1;
  i9 = i11 ? 2 : 1;
  i11 = i11 ? 0 : 2;
 }
 i16 = i31 + 16 | 0;
 i20 = i31 + 20 | 0;
 i22 = i31 + 24 | 0;
 i23 = i31 + 28 | 0;
 i24 = i31 + 32 | 0;
 i1 = i48 + (i1 * 12 | 0) | 0;
 i2 = i31;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i31 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i5 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i31, i51) | 0;
 f13 = Math_fround(HEAPF32[i31 >> 2]);
 i12 = i31 + 4 | 0;
 f36 = Math_fround(HEAPF32[i12 >> 2]);
 i14 = i31 + 8 | 0;
 f36 = Math_fround(-f36);
 f35 = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i21 >> 2] = Math_fround(-f13);
 HEAPF32[i21 + 4 >> 2] = f36;
 HEAPF32[i21 + 8 >> 2] = f35;
 i2 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i21, i51) | 0;
 i25 = i46 + (i5 * 12 | 0) | 0;
 f35 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i46 + (i5 * 12 | 0) + 4 | 0;
 f36 = Math_fround(HEAPF32[i26 >> 2]);
 i27 = i46 + (i5 * 12 | 0) + 8 | 0;
 f13 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i46 + (i2 * 12 | 0) | 0;
 f15 = Math_fround(HEAPF32[i28 >> 2]);
 i29 = i46 + (i2 * 12 | 0) + 4 | 0;
 f17 = Math_fround(HEAPF32[i29 >> 2]);
 i30 = i46 + (i2 * 12 | 0) + 8 | 0;
 f15 = Math_fround(f35 - f15);
 f17 = Math_fround(f36 - f17);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i30 >> 2]));
 HEAPF32[i31 >> 2] = f15;
 HEAPF32[i12 >> 2] = f17;
 HEAPF32[i14 >> 2] = f13;
 if ((i5 | 0) == (i2 | 0)) {
  i5 = -1;
  i2 = -1;
  i3 = -1;
  i1 = -1;
 } else if (f15 == Math_fround(0.0) & f17 == Math_fround(0.0) & f13 == Math_fround(0.0)) {
  i5 = -1;
  i2 = -1;
  i3 = -1;
  i1 = -1;
 } else {
  i12 = i31 + 12 | 0;
  f19 = Math_fround(HEAPF32[i48 + (i9 * 12 | 0) >> 2]);
  f35 = Math_fround(HEAPF32[i48 + (i9 * 12 | 0) + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i48 + (i9 * 12 | 0) + 8 >> 2]);
  f36 = Math_fround(Math_fround(f13 * f35) - Math_fround(f17 * f4));
  f4 = Math_fround(Math_fround(f15 * f4) - Math_fround(f13 * f19));
  f35 = Math_fround(Math_fround(f17 * f19) - Math_fround(f15 * f35));
  i14 = i31 + 12 | 0;
  HEAPF32[i14 >> 2] = f36;
  HEAPF32[i16 >> 2] = f4;
  HEAPF32[i20 >> 2] = f35;
  i21 = i31 + 24 | 0;
  f19 = Math_fround(HEAPF32[i48 + (i11 * 12 | 0) >> 2]);
  f8 = Math_fround(HEAPF32[i48 + (i11 * 12 | 0) + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i48 + (i11 * 12 | 0) + 8 >> 2]);
  f10 = Math_fround(Math_fround(f13 * f8) - Math_fround(f17 * f6));
  f6 = Math_fround(Math_fround(f15 * f6) - Math_fround(f13 * f19));
  f8 = Math_fround(Math_fround(f17 * f19) - Math_fround(f15 * f8));
  HEAPF32[i22 >> 2] = f10;
  HEAPF32[i23 >> 2] = f6;
  HEAPF32[i24 >> 2] = f8;
  i1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f35 * f35) + Math_fround(Math_fround(f36 * f36) + Math_fround(f4 * f4))))) > Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6)))));
  i1 = i1 ? i12 : i21;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = i1 + 4 | 0;
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  i9 = i1 + 8 | 0;
  f8 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f10 * f10)) + Math_fround(f8 * f8))));
  if (f4 == Math_fround(0.0)) {
   _puts(gb + 730491 | 0) | 0;
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f10 = Math_fround(HEAPF32[i3 >> 2]);
   f8 = Math_fround(HEAPF32[i9 >> 2]);
   f4 = Math_fround(.100000001);
  }
  f4 = Math_fround(Math_fround(1.0) / f4);
  f7 = Math_fround(f6 * f4);
  f6 = Math_fround(f10 * f4);
  f4 = Math_fround(f8 * f4);
  HEAPF32[i14 >> 2] = f7;
  HEAPF32[i16 >> 2] = f6;
  HEAPF32[i20 >> 2] = f4;
  i1 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i12, i51) | 0;
  if ((i1 | 0) == (i5 | 0) | (i1 | 0) == (i2 | 0)) {
   f35 = Math_fround(-f6);
   f36 = Math_fround(-f4);
   HEAPF32[i32 >> 2] = Math_fround(-f7);
   HEAPF32[i32 + 4 >> 2] = f35;
   HEAPF32[i32 + 8 >> 2] = f36;
   i12 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i32, i51) | 0;
  } else i12 = i1;
  if ((i12 | 0) == (i5 | 0) | (i12 | 0) == (i2 | 0)) {
   i5 = -1;
   i2 = -1;
   i3 = -1;
   i1 = -1;
  } else {
   i3 = i46 + (i12 * 12 | 0) | 0;
   f36 = Math_fround(HEAPF32[i3 >> 2]);
   i9 = i46 + (i12 * 12 | 0) + 4 | 0;
   f7 = Math_fround(HEAPF32[i9 >> 2]);
   i11 = i46 + (i12 * 12 | 0) + 8 | 0;
   f8 = Math_fround(HEAPF32[i11 >> 2]);
   f4 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(f36 - f4);
   f6 = Math_fround(f7 - f6);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i27 >> 2]));
   HEAPF32[i14 >> 2] = f4;
   HEAPF32[i16 >> 2] = f6;
   HEAPF32[i20 >> 2] = f8;
   f7 = Math_fround(Math_fround(f13 * f6) - Math_fround(f17 * f8));
   f8 = Math_fround(Math_fround(f15 * f8) - Math_fround(f13 * f4));
   f6 = Math_fround(Math_fround(f17 * f4) - Math_fround(f15 * f6));
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)))));
   if (f4 == Math_fround(0.0)) {
    _puts(gb + 730491 | 0) | 0;
    f4 = Math_fround(.100000001);
   }
   f17 = Math_fround(Math_fround(1.0) / f4);
   f19 = Math_fround(f7 * f17);
   f18 = Math_fround(f8 * f17);
   f17 = Math_fround(f6 * f17);
   HEAPF32[i22 >> 2] = f19;
   HEAPF32[i23 >> 2] = f18;
   HEAPF32[i24 >> 2] = f17;
   i1 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i21, i51) | 0;
   if ((i1 | 0) == (i12 | 0) | ((i1 | 0) == (i5 | 0) | (i1 | 0) == (i2 | 0))) i43 = 33; else {
    f35 = Math_fround(HEAPF32[i28 >> 2]);
    f6 = Math_fround(HEAPF32[i29 >> 2]);
    f53 = Math_fround(HEAPF32[i30 >> 2]);
    f4 = Math_fround(HEAPF32[i25 >> 2]);
    f7 = Math_fround(HEAPF32[i26 >> 2]);
    f8 = Math_fround(HEAPF32[i27 >> 2]);
    f35 = Math_fround(f35 - f4);
    f6 = Math_fround(f6 - f7);
    f53 = Math_fround(f53 - f8);
    f15 = Math_fround(HEAPF32[i3 >> 2]);
    f36 = Math_fround(HEAPF32[i9 >> 2]);
    f15 = Math_fround(f15 - f4);
    f36 = Math_fround(f36 - f7);
    f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f8);
    f10 = Math_fround(Math_fround(f6 * f13) - Math_fround(f53 * f36));
    f13 = Math_fround(Math_fround(f53 * f15) - Math_fround(f35 * f13));
    f15 = Math_fround(Math_fround(f35 * f36) - Math_fround(f6 * f15));
    f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f10 * f10) + Math_fround(f13 * f13)))));
    if (f6 < Math_fround(9.99999968e-21) & f6 > Math_fround(-9.99999968e-21)) i43 = 33; else {
     if (f6 == Math_fround(0.0)) {
      _puts(gb + 730491 | 0) | 0;
      f4 = Math_fround(HEAPF32[i25 >> 2]);
      f7 = Math_fround(HEAPF32[i26 >> 2]);
      f8 = Math_fround(HEAPF32[i27 >> 2]);
      f6 = Math_fround(.100000001);
     }
     f53 = Math_fround(Math_fround(1.0) / f6);
     f10 = Math_fround(f10 * f53);
     f35 = Math_fround(f13 * f53);
     f53 = Math_fround(f15 * f53);
     f15 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) >> 2]);
     f36 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 4 >> 2]);
     f53 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(f15 - f4)) + Math_fround(f35 * Math_fround(f36 - f7))) + Math_fround(f53 * Math_fround(Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 8 >> 2]) - f8)));
     if (!(f53 > Math_fround(9.99999968e-21) | f53 < Math_fround(-9.99999968e-21))) i43 = 33;
    }
   }
   if ((i43 | 0) == 33) {
    f36 = Math_fround(-f18);
    f53 = Math_fround(-f17);
    HEAPF32[i34 >> 2] = Math_fround(-f19);
    HEAPF32[i34 + 4 >> 2] = f36;
    HEAPF32[i34 + 8 >> 2] = f53;
    i1 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i34, i51) | 0;
   }
   if ((i1 | 0) == (i12 | 0) | ((i1 | 0) == (i5 | 0) | (i1 | 0) == (i2 | 0))) {
    i5 = -1;
    i2 = -1;
    i3 = -1;
    i1 = -1;
   } else {
    f13 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) >> 2]);
    f18 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 4 >> 2]);
    f10 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 8 >> 2]);
    f35 = Math_fround(HEAPF32[i25 >> 2]);
    f17 = Math_fround(HEAPF32[i26 >> 2]);
    f53 = Math_fround(HEAPF32[i27 >> 2]);
    f13 = Math_fround(f13 - f35);
    f18 = Math_fround(f18 - f17);
    f10 = Math_fround(f10 - f53);
    f36 = Math_fround(HEAPF32[i28 >> 2]);
    f15 = Math_fround(HEAPF32[i29 >> 2]);
    f36 = Math_fround(f36 - f35);
    f15 = Math_fround(f15 - f17);
    f19 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) - f53);
    f7 = Math_fround(HEAPF32[i3 >> 2]);
    f8 = Math_fround(HEAPF32[i9 >> 2]);
    f35 = Math_fround(f7 - f35);
    f17 = Math_fround(f8 - f17);
    f53 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f53);
    i34 = Math_fround(Math_fround(f10 * Math_fround(Math_fround(f36 * f17) - Math_fround(f15 * f35))) + Math_fround(Math_fround(f13 * Math_fround(Math_fround(f15 * f53) - Math_fround(f19 * f17))) + Math_fround(f18 * Math_fround(Math_fround(f19 * f35) - Math_fround(f36 * f53))))) < Math_fround(0.0);
    i3 = i34 ? i1 : i12;
    i1 = i34 ? i12 : i1;
   }
  }
 }
 L55 : do if ((i5 | 0) == -1) i1 = 1; else {
  f53 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i46 + (i5 * 12 | 0) + 8 >> 2]);
  f35 = Math_fround(HEAPF32[i46 + (i2 * 12 | 0) >> 2]);
  f19 = Math_fround(HEAPF32[i46 + (i2 * 12 | 0) + 4 >> 2]);
  f35 = Math_fround(f53 + f35);
  f19 = Math_fround(f18 + f19);
  f36 = Math_fround(f36 + Math_fround(HEAPF32[i46 + (i2 * 12 | 0) + 8 >> 2]));
  f18 = Math_fround(HEAPF32[i46 + (i3 * 12 | 0) >> 2]);
  f53 = Math_fround(HEAPF32[i46 + (i3 * 12 | 0) + 4 >> 2]);
  f18 = Math_fround(f35 + f18);
  f53 = Math_fround(f19 + f53);
  f36 = Math_fround(f36 + Math_fround(HEAPF32[i46 + (i3 * 12 | 0) + 8 >> 2]));
  f19 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) >> 2]);
  f35 = Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 4 >> 2]);
  f19 = Math_fround(Math_fround(f18 + f19) * Math_fround(.25));
  f35 = Math_fround(Math_fround(f53 + f35) * Math_fround(.25));
  f36 = Math_fround(Math_fround(f36 + Math_fround(HEAPF32[i46 + (i1 * 12 | 0) + 8 >> 2])) * Math_fround(.25));
  i34 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i32 = HEAP32[(HEAP32[i34 >> 2] | 0) + 8 >> 2] | 0;
  i9 = _PxGetFoundation() | 0;
  i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0;
  i9 = mftCall_iiiiii(i32 | 0, i34 | 0, 36, (i9 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1559) | 0;
  __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i9, i3, i1, i2, HEAP32[i45 >> 2] | 0);
  HEAP32[i9 + 12 >> 2] = 2;
  HEAP32[i9 + 16 >> 2] = 3;
  HEAP32[i9 + 20 >> 2] = 1;
  i34 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i32 = HEAP32[(HEAP32[i34 >> 2] | 0) + 8 >> 2] | 0;
  i11 = _PxGetFoundation() | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
  i11 = mftCall_iiiiii(i32 | 0, i34 | 0, 36, (i11 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1560) | 0;
  __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i11, i1, i3, i5, HEAP32[i45 >> 2] | 0);
  HEAP32[i11 + 12 >> 2] = 3;
  HEAP32[i11 + 16 >> 2] = 2;
  HEAP32[i11 + 20 >> 2] = 0;
  i34 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i32 = HEAP32[(HEAP32[i34 >> 2] | 0) + 8 >> 2] | 0;
  i12 = _PxGetFoundation() | 0;
  i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0) | 0;
  i12 = mftCall_iiiiii(i32 | 0, i34 | 0, 36, (i12 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1561) | 0;
  __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i12, i5, i2, i1, HEAP32[i45 >> 2] | 0);
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 1;
  HEAP32[i12 + 20 >> 2] = 3;
  i34 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i32 = HEAP32[(HEAP32[i34 >> 2] | 0) + 8 >> 2] | 0;
  i14 = _PxGetFoundation() | 0;
  i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
  i14 = mftCall_iiiiii(i32 | 0, i34 | 0, 36, (i14 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1562) | 0;
  __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i14, i2, i5, i3, HEAP32[i45 >> 2] | 0);
  HEAP32[i14 + 12 >> 2] = 1;
  HEAP32[i14 + 16 >> 2] = 0;
  HEAP32[i14 + 20 >> 2] = 2;
  HEAP32[i42 + (i1 << 2) >> 2] = 1;
  HEAP32[i42 + (i3 << 2) >> 2] = 1;
  HEAP32[i42 + (i2 << 2) >> 2] = 1;
  HEAP32[i42 + (i5 << 2) >> 2] = 1;
  i1 = HEAP32[i45 >> 2] | 0;
  L57 : do if ((HEAP32[i1 + 4 >> 2] | 0) > 0) {
   i16 = i37 + 4 | 0;
   i20 = i37 + 8 | 0;
   if (i33) i5 = 0; else {
    i2 = 0;
    while (1) {
     i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i32 = HEAP32[i1 >> 2] | 0;
     i33 = HEAP32[i1 + 4 >> 2] | 0;
     i34 = HEAP32[i1 + 8 >> 2] | 0;
     f18 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) >> 2]);
     f6 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) + 4 >> 2]);
     f17 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) + 8 >> 2]);
     f4 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) >> 2]);
     f53 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 4 >> 2]);
     f8 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 8 >> 2]);
     f15 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
     f10 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
     f18 = Math_fround(f4 - f18);
     f6 = Math_fround(f53 - f6);
     f17 = Math_fround(f8 - f17);
     f4 = Math_fround(f15 - f4);
     f53 = Math_fround(f10 - f53);
     f8 = Math_fround(Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2]) - f8);
     f10 = Math_fround(Math_fround(f6 * f8) - Math_fround(f17 * f53));
     f8 = Math_fround(Math_fround(f17 * f4) - Math_fround(f18 * f8));
     f4 = Math_fround(Math_fround(f18 * f53) - Math_fround(f6 * f4));
     f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f10 * f10) + Math_fround(f8 * f8)))));
     if (f6 == Math_fround(0.0)) {
      f7 = Math_fround(0.0);
      f6 = Math_fround(0.0);
      f4 = Math_fround(1.0);
     } else {
      f53 = Math_fround(Math_fround(1.0) / f6);
      f7 = Math_fround(f4 * f53);
      f6 = Math_fround(f8 * f53);
      f4 = Math_fround(f10 * f53);
     }
     HEAPF32[i37 >> 2] = f4;
     HEAPF32[i16 >> 2] = f6;
     HEAPF32[i20 >> 2] = f7;
     i33 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i37, i51) | 0;
     HEAP32[i1 + 28 >> 2] = i33;
     i34 = HEAP32[i1 >> 2] | 0;
     f13 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) >> 2]);
     f17 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 4 >> 2]);
     f53 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 8 >> 2]);
     f15 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
     f18 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
     HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f13 - f15) * f4) + Math_fround(Math_fround(f17 - f18) * f6)) + Math_fround(Math_fround(f53 - Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2])) * f7));
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i45 >> 2] | 0;
     if ((i2 | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = i1;
      break L57;
     }
    }
   }
   while (1) {
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i32 = HEAP32[i1 >> 2] | 0;
    i2 = i1 + 4 | 0;
    i33 = HEAP32[i2 >> 2] | 0;
    i3 = i1 + 8 | 0;
    i34 = HEAP32[i3 >> 2] | 0;
    f18 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) >> 2]);
    f6 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) + 4 >> 2]);
    f17 = Math_fround(HEAPF32[i46 + (i32 * 12 | 0) + 8 >> 2]);
    f4 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) >> 2]);
    f53 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 8 >> 2]);
    f15 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
    f10 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
    f18 = Math_fround(f4 - f18);
    f6 = Math_fround(f53 - f6);
    f17 = Math_fround(f8 - f17);
    f4 = Math_fround(f15 - f4);
    f53 = Math_fround(f10 - f53);
    f8 = Math_fround(Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2]) - f8);
    f10 = Math_fround(Math_fround(f6 * f8) - Math_fround(f17 * f53));
    f8 = Math_fround(Math_fround(f17 * f4) - Math_fround(f18 * f8));
    f4 = Math_fround(Math_fround(f18 * f53) - Math_fround(f6 * f4));
    f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f10 * f10) + Math_fround(f8 * f8)))));
    if (f6 == Math_fround(0.0)) {
     f7 = Math_fround(0.0);
     f6 = Math_fround(0.0);
     f4 = Math_fround(1.0);
    } else {
     f53 = Math_fround(Math_fround(1.0) / f6);
     f7 = Math_fround(f4 * f53);
     f6 = Math_fround(f8 * f53);
     f4 = Math_fround(f10 * f53);
    }
    HEAPF32[i37 >> 2] = f4;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i20 >> 2] = f7;
    i33 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i37, i51) | 0;
    HEAP32[i1 + 28 >> 2] = i33;
    i34 = HEAP32[i1 >> 2] | 0;
    f53 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) >> 2]);
    f13 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 4 >> 2]);
    f17 = Math_fround(HEAPF32[i46 + (i33 * 12 | 0) + 8 >> 2]);
    f10 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
    f15 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2]);
    HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f53 - f10) * f4) + Math_fround(Math_fround(f13 - f15) * f6)) + Math_fround(Math_fround(f17 - f8) * f7));
    i34 = HEAP32[i2 >> 2] | 0;
    f17 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
    f13 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
    f53 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2]);
    f10 = Math_fround(f17 - f10);
    f15 = Math_fround(f13 - f15);
    f8 = Math_fround(f53 - f8);
    i34 = HEAP32[i3 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) >> 2]);
    f18 = Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 4 >> 2]);
    f17 = Math_fround(f7 - f17);
    f13 = Math_fround(f18 - f13);
    f53 = Math_fround(Math_fround(HEAPF32[i46 + (i34 * 12 | 0) + 8 >> 2]) - f53);
    f18 = Math_fround(Math_fround(f15 * f53) - Math_fround(f8 * f13));
    f53 = Math_fround(Math_fround(f8 * f17) - Math_fround(f10 * f53));
    f17 = Math_fround(Math_fround(f10 * f13) - Math_fround(f15 * f17));
    if (Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f18 * f18) + Math_fround(f53 * f53))))) < f40) break;
    i5 = i5 + 1 | 0;
    i1 = HEAP32[i45 >> 2] | 0;
    if ((i5 | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = i1;
     break L57;
    }
   }
   HEAP32[(HEAP32[HEAP32[i45 >> 2] >> 2] | 0) + (HEAP32[i9 + 24 >> 2] << 2) >> 2] = 0;
   if (i9 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i9);
   HEAP32[(HEAP32[HEAP32[i45 >> 2] >> 2] | 0) + (HEAP32[i11 + 24 >> 2] << 2) >> 2] = 0;
   if (i11 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i11);
   HEAP32[(HEAP32[HEAP32[i45 >> 2] >> 2] | 0) + (HEAP32[i12 + 24 >> 2] << 2) >> 2] = 0;
   if (i12 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i12);
   HEAP32[(HEAP32[HEAP32[i45 >> 2] >> 2] | 0) + (HEAP32[i14 + 24 >> 2] << 2) >> 2] = 0;
   if (!i14) {
    i1 = 3;
    break L55;
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i14);
   i1 = 3;
   break L55;
  } else i3 = i1; while (0);
  i1 = i38 ? 999999996 : i39 + -4 | 0;
  L83 : do if ((i1 | 0) > 0) {
   i20 = i44 + 4 | 0;
   i21 = i44 + 8 | 0;
   f18 = Math_fround(f41 * Math_fround(.00999999977));
   i5 = i3 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i14 = i2;
    while (1) {
     i16 = HEAP32[i3 >> 2] | 0;
     i11 = 0;
     i12 = 0;
     i9 = 0;
     while (1) {
      i2 = HEAP32[i16 + (i12 << 2) >> 2] | 0;
      if (i11) if (!i2) i2 = i9; else {
       f53 = Math_fround(HEAPF32[i9 + 32 >> 2]);
       if (f53 < Math_fround(HEAPF32[i2 + 32 >> 2])) i43 = 60; else i2 = i9;
      } else i43 = 60;
      if ((i43 | 0) == 60) i43 = 0;
      i12 = i12 + 1 | 0;
      i11 = (i2 | 0) != 0;
      if ((i12 | 0) == (i14 | 0)) break; else i9 = i2;
     }
     if (!i11) break L83;
     if (!(Math_fround(HEAPF32[i2 + 32 >> 2]) > f41)) break L83;
     i14 = HEAP32[i2 + 28 >> 2] | 0;
     HEAP32[i42 + (i14 << 2) >> 2] = 1;
     i2 = HEAP32[i5 >> 2] | 0;
     L98 : do if (i2) {
      i9 = i46 + (i14 * 12 | 0) | 0;
      i11 = i46 + (i14 * 12 | 0) + 4 | 0;
      i12 = i46 + (i14 * 12 | 0) + 8 | 0;
      i5 = i16;
      while (1) {
       i2 = i2 + -1 | 0;
       i5 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
       if (i5) {
        i37 = HEAP32[i5 >> 2] | 0;
        i38 = HEAP32[i5 + 4 >> 2] | 0;
        i39 = HEAP32[i5 + 8 >> 2] | 0;
        f13 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) >> 2]);
        f15 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 4 >> 2]);
        f17 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 8 >> 2]);
        f4 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) >> 2]);
        f53 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 4 >> 2]);
        f8 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 8 >> 2]);
        f55 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) >> 2]);
        f10 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 4 >> 2]);
        f7 = Math_fround(f4 - f13);
        f6 = Math_fround(f53 - f15);
        f54 = Math_fround(f8 - f17);
        f4 = Math_fround(f55 - f4);
        f53 = Math_fround(f10 - f53);
        f8 = Math_fround(Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 8 >> 2]) - f8);
        f10 = Math_fround(Math_fround(f6 * f8) - Math_fround(f54 * f53));
        f8 = Math_fround(Math_fround(f54 * f4) - Math_fround(f7 * f8));
        f4 = Math_fround(Math_fround(f7 * f53) - Math_fround(f6 * f4));
        f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f10 * f10) + Math_fround(f8 * f8)))));
        if (f6 == Math_fround(0.0)) {
         f7 = Math_fround(0.0);
         f6 = Math_fround(0.0);
         f4 = Math_fround(1.0);
        } else {
         f55 = Math_fround(Math_fround(1.0) / f6);
         f7 = Math_fround(f4 * f55);
         f6 = Math_fround(f8 * f55);
         f4 = Math_fround(f10 * f55);
        }
        f54 = Math_fround(HEAPF32[i9 >> 2]);
        f55 = Math_fround(HEAPF32[i11 >> 2]);
        if (Math_fround(Math_fround(Math_fround(f4 * Math_fround(f54 - f13)) + Math_fround(f6 * Math_fround(f55 - f15))) + Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f17))) > f18) {
         __ZN5physx11HullLibrary7extrudeEPNS_3TriEi(i45, i5, i14);
         i3 = HEAP32[i45 >> 2] | 0;
        }
       }
       if (!i2) break;
       i5 = HEAP32[i3 >> 2] | 0;
      }
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (i2) do {
       i2 = i2 + -1 | 0;
       i5 = HEAP32[i3 >> 2] | 0;
       i9 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
       do if (i9) {
        do if ((HEAP32[i9 >> 2] | 0) != (i14 | 0)) {
         if ((HEAP32[i9 + 4 >> 2] | 0) == (i14 | 0)) break;
         if ((HEAP32[i9 + 8 >> 2] | 0) != (i14 | 0)) break L98;
        } while (0);
        i37 = HEAP32[i9 >> 2] | 0;
        i38 = HEAP32[i9 + 4 >> 2] | 0;
        i39 = HEAP32[i9 + 8 >> 2] | 0;
        f10 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) >> 2]);
        f13 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 8 >> 2]);
        f4 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) >> 2]);
        f55 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 4 >> 2]);
        f6 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 8 >> 2]);
        f7 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) >> 2]);
        f8 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 4 >> 2]);
        f54 = Math_fround(f4 - f10);
        f17 = Math_fround(f55 - f13);
        f53 = Math_fround(f6 - f15);
        f4 = Math_fround(f7 - f4);
        f55 = Math_fround(f8 - f55);
        f6 = Math_fround(Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 8 >> 2]) - f6);
        f8 = Math_fround(Math_fround(f17 * f6) - Math_fround(f53 * f55));
        f6 = Math_fround(Math_fround(f53 * f4) - Math_fround(f54 * f6));
        f4 = Math_fround(Math_fround(f54 * f55) - Math_fround(f17 * f4));
        f17 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f8 * f8) + Math_fround(f6 * f6)))));
        if (f17 == Math_fround(0.0)) {
         f7 = Math_fround(0.0);
         f6 = Math_fround(0.0);
         f4 = Math_fround(1.0);
        } else {
         f55 = Math_fround(Math_fround(1.0) / f17);
         f7 = Math_fround(f4 * f55);
         f6 = Math_fround(f6 * f55);
         f4 = Math_fround(f8 * f55);
        }
        if (!(f17 < f40 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f19 - f10) * f4) + Math_fround(Math_fround(f35 - f13) * f6)) + Math_fround(Math_fround(f36 - f15) * f7)) > f18)) break;
        __ZN5physx11HullLibrary7extrudeEPNS_3TriEi(i45, HEAP32[i5 + (HEAP32[i9 + 12 >> 2] << 2) >> 2] | 0, i14);
        i2 = HEAP32[i45 >> 2] | 0;
        i3 = i2;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
       } while (0);
      } while ((i2 | 0) != 0);
     } while (0);
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     L125 : do if (i2 | 0) while (1) {
      i2 = i2 + -1 | 0;
      i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      do if (i5 | 0) {
       i9 = i5 + 28 | 0;
       if ((HEAP32[i9 >> 2] | 0) > -1) break L125;
       i37 = HEAP32[i5 >> 2] | 0;
       i38 = HEAP32[i5 + 4 >> 2] | 0;
       i39 = HEAP32[i5 + 8 >> 2] | 0;
       f54 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) >> 2]);
       f6 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 4 >> 2]);
       f53 = Math_fround(HEAPF32[i46 + (i37 * 12 | 0) + 8 >> 2]);
       f8 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) >> 2]);
       f55 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 4 >> 2]);
       f7 = Math_fround(HEAPF32[i46 + (i38 * 12 | 0) + 8 >> 2]);
       f17 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) >> 2]);
       f4 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 4 >> 2]);
       f54 = Math_fround(f8 - f54);
       f6 = Math_fround(f55 - f6);
       f53 = Math_fround(f7 - f53);
       f8 = Math_fround(f17 - f8);
       f55 = Math_fround(f4 - f55);
       f7 = Math_fround(Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 8 >> 2]) - f7);
       f4 = Math_fround(Math_fround(f6 * f7) - Math_fround(f53 * f55));
       f7 = Math_fround(Math_fround(f53 * f8) - Math_fround(f54 * f7));
       f8 = Math_fround(Math_fround(f54 * f55) - Math_fround(f6 * f8));
       f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)))));
       if (f6 == Math_fround(0.0)) {
        f10 = Math_fround(1.0);
        f6 = Math_fround(0.0);
        f4 = Math_fround(0.0);
       } else {
        f55 = Math_fround(Math_fround(1.0) / f6);
        f10 = Math_fround(f4 * f55);
        f6 = Math_fround(f7 * f55);
        f4 = Math_fround(f8 * f55);
       }
       HEAPF32[i44 >> 2] = f10;
       HEAPF32[i20 >> 2] = f6;
       HEAPF32[i21 >> 2] = f4;
       i3 = __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i46, i47, i44, i51) | 0;
       HEAP32[i9 >> 2] = i3;
       if (!(HEAP32[i42 + (i3 << 2) >> 2] | 0)) {
        i39 = HEAP32[i5 >> 2] | 0;
        f15 = Math_fround(HEAPF32[i46 + (i3 * 12 | 0) >> 2]);
        f53 = Math_fround(HEAPF32[i46 + (i3 * 12 | 0) + 4 >> 2]);
        f55 = Math_fround(HEAPF32[i46 + (i3 * 12 | 0) + 8 >> 2]);
        f17 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) >> 2]);
        f54 = Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 4 >> 2]);
        HEAPF32[i5 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 - f17) * f10) + Math_fround(Math_fround(f53 - f54) * f6)) + Math_fround(Math_fround(f55 - Math_fround(HEAPF32[i46 + (i39 * 12 | 0) + 8 >> 2])) * f4));
        break;
       } else {
        HEAP32[i9 >> 2] = -1;
        break;
       }
      } while (0);
      if (!i2) break L125;
      i3 = HEAP32[i45 >> 2] | 0;
     } while (0);
     i2 = i1 + -1 | 0;
     if ((i1 | 0) <= 1) {
      i1 = i2;
      break L83;
     }
     i3 = HEAP32[i45 >> 2] | 0;
     i5 = i3 + 4 | 0;
     i14 = HEAP32[i5 >> 2] | 0;
     if ((i14 | 0) <= 0) {
      i1 = i2;
      break;
     } else i1 = i2;
    }
   }
  } while (0);
  i1 = (i1 | 0) == 0 ? 2 : 0;
 } while (0);
 i2 = HEAP32[i51 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i2);
  HEAP32[i51 >> 2] = 0;
 }
 HEAP32[i49 >> 2] = 0;
 HEAP32[i50 >> 2] = 0;
 HEAP32[i51 >> 2] = 0;
 if (i42 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i48, i42);
 i51 = i1;
 STACKTOP = i52;
 return i51 | 0;
}

function __ZN17MessageIdentifier16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(16) | 0;
  HEAP32[i1 >> 2] = i1;
  HEAP32[i1 + 4 >> 2] = i1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[gb + 1104732 >> 2] = i1;
 }
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104736;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104756;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104776;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104796;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104816;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104836;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104856;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104876;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104896;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104916;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104936;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104956;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104976;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1104996;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105016;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105036;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105056;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105076;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105096;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105116;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105136;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105156;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105176;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105196;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105216;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105236;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105256;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105276;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105296;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105316;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105336;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105356;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105376;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105396;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105416;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105436;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105456;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105476;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105496;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105516;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105536;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105556;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105576;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105596;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105616;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105636;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105656;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105676;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105696;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105716;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105736;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105756;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105776;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105796;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105816;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105836;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105856;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105876;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105896;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105916;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105936;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105956;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105976;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1105996;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106016;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106036;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106056;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106076;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106096;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = gb + 1106116;
 HEAP32[i4 + 4 >> 2] = i1;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1104732 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 6;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 8 >> 2] = gb + 1106136;
 HEAP32[i2 + 4 >> 2] = i1;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu15EdgeListBuilder18ComputeActiveEdgesEjPKjPKtPKNS_6PxVec3Ef(i55, i52, i59, i60, i47, f46) {
 i55 = i55 | 0;
 i52 = i52 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 i47 = i47 | 0;
 f46 = Math_fround(f46);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i61 = 0, f62 = f0, f63 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i61 + 32 | 0;
 i4 = i61 + 24 | 0;
 i3 = i61 + 16 | 0;
 i2 = i61 + 8 | 0;
 i1 = i61;
 i5 = i61 + 51 | 0;
 i51 = i61 + 50 | 0;
 i53 = i61 + 49 | 0;
 i54 = i61 + 36 | 0;
 i56 = i61 + 48 | 0;
 if (i47 | 0) {
  i57 = (i59 | 0) != 0;
  i58 = (i60 | 0) != 0;
  if (i57 | i58) {
   i6 = HEAP32[i55 >> 2] | 0;
   if (!i6) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 306, gb + 728162 | 0, i2);
    i60 = 0;
    STACKTOP = i61;
    return i60 | 0;
   }
   i2 = HEAP32[i55 + 4 >> 2] | 0;
   if (!i2) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 313, gb + 728218 | 0, i3);
    i60 = 0;
    STACKTOP = i61;
    return i60 | 0;
   }
   i50 = i55 + 16 | 0;
   i1 = HEAP32[i50 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 320, gb + 728278 | 0, i4);
    i60 = 0;
    STACKTOP = i61;
    return i60 | 0;
   }
   i45 = HEAP32[i55 + 20 >> 2] | 0;
   if (!i45) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 327, gb + 728345 | 0, i7);
    i60 = 0;
    STACKTOP = i61;
    return i60 | 0;
   }
   i49 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i6, gb + 728039 | 0, 332) | 0;
   i44 = i49;
   i43 = i1;
   while (1) {
    i6 = i6 + -1 | 0;
    i1 = HEAP16[i43 + 2 >> 1] | 0;
    i38 = i1 & 65535;
    L22 : do if (i1 << 16 >> 16 == 1) i1 = 1; else {
     i39 = HEAP32[i43 + 4 >> 2] | 0;
     i3 = (HEAP32[i45 + (i39 << 2) >> 2] | 0) * 3 | 0;
     if (i1 << 16 >> 16 == 2) {
      i1 = (HEAP32[i45 + (i39 + 1 << 2) >> 2] | 0) * 3 | 0;
      if (i57) {
       i10 = HEAP32[i59 + (i3 << 2) >> 2] | 0;
       i16 = HEAP32[i59 + (i3 + 1 << 2) >> 2] | 0;
       i9 = HEAP32[i59 + (i3 + 2 << 2) >> 2] | 0;
       i5 = HEAP32[i59 + (i1 << 2) >> 2] | 0;
       i4 = HEAP32[i59 + (i1 + 1 << 2) >> 2] | 0;
       i7 = HEAP32[i59 + (i1 + 2 << 2) >> 2] | 0;
      } else {
       i10 = HEAPU16[i60 + (i3 << 1) >> 1] | 0;
       i16 = HEAPU16[i60 + (i3 + 1 << 1) >> 1] | 0;
       i9 = HEAPU16[i60 + (i3 + 2 << 1) >> 1] | 0;
       i5 = HEAPU16[i60 + (i1 << 1) >> 1] | 0;
       i4 = HEAPU16[i60 + (i1 + 1 << 1) >> 1] | 0;
       i7 = HEAPU16[i60 + (i1 + 2 << 1) >> 1] | 0;
      }
      i1 = HEAP32[i2 >> 2] | 0;
      i3 = HEAP32[i2 + 4 >> 2] | 0;
      do if ((i1 | 0) == (i10 | 0)) if ((i3 | 0) == (i16 | 0)) i8 = i9; else if ((i3 | 0) == (i9 | 0)) i8 = i16; else i48 = 29; else {
       if ((i1 | 0) == (i16 | 0)) {
        if ((i3 | 0) == (i10 | 0)) {
         i8 = i9;
         break;
        }
        if ((i3 | 0) == (i9 | 0)) {
         i8 = i10;
         break;
        } else {
         i48 = 29;
         break;
        }
       }
       if ((i1 | 0) == (i9 | 0)) if ((i3 | 0) == (i16 | 0)) i8 = i10; else if ((i3 | 0) == (i10 | 0)) i8 = i16; else i48 = 29; else i48 = 29;
      } while (0);
      if ((i48 | 0) == 29) {
       i48 = 0;
       i8 = -1;
      }
      f26 = Math_fround(HEAPF32[i47 + (i4 * 12 | 0) >> 2]);
      f27 = Math_fround(HEAPF32[i47 + (i5 * 12 | 0) >> 2]);
      f17 = Math_fround(f26 - f27);
      f24 = Math_fround(HEAPF32[i47 + (i4 * 12 | 0) + 4 >> 2]);
      f25 = Math_fround(HEAPF32[i47 + (i5 * 12 | 0) + 4 >> 2]);
      f14 = Math_fround(f24 - f25);
      f23 = Math_fround(HEAPF32[i47 + (i4 * 12 | 0) + 8 >> 2]);
      f20 = Math_fround(HEAPF32[i47 + (i5 * 12 | 0) + 8 >> 2]);
      f15 = Math_fround(f23 - f20);
      f21 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) >> 2]);
      f13 = Math_fround(f21 - f27);
      f22 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 4 >> 2]);
      f18 = Math_fround(f22 - f25);
      f19 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 8 >> 2]);
      f12 = Math_fround(f19 - f20);
      f11 = Math_fround(Math_fround(f14 * f12) - Math_fround(f15 * f18));
      f12 = Math_fround(Math_fround(f15 * f13) - Math_fround(f17 * f12));
      f13 = Math_fround(Math_fround(f17 * f18) - Math_fround(f14 * f13));
      f14 = Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)));
      if (f14 > Math_fround(0.0)) {
       f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14))));
       f15 = Math_fround(f11 * f18);
       f17 = Math_fround(f12 * f18);
       f18 = Math_fround(f13 * f18);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
      } else {
       i1 = 0;
       i3 = 0;
       i4 = 0;
      }
      f17 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = Math_fround(f17 * f27);
      f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = Math_fround(f14 + Math_fround(f13 * f25));
      f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = Math_fround(f14 + Math_fround(f18 * f20));
      f17 = Math_fround(f17 * Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]));
      f13 = Math_fround(f17 + Math_fround(f13 * Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2])));
      i42 = Math_fround(Math_fround(f13 + Math_fround(f18 * Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]))) - f14) < Math_fround(0.0);
      f14 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) >> 2]);
      f18 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 4 >> 2]);
      f13 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 8 >> 2]);
      f17 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) >> 2]);
      f12 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) + 4 >> 2]);
      f15 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) + 8 >> 2]);
      f62 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) >> 2]);
      f11 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 4 >> 2]);
      f17 = Math_fround(f17 - f14);
      f12 = Math_fround(f12 - f18);
      f15 = Math_fround(f15 - f13);
      f14 = Math_fround(f62 - f14);
      f18 = Math_fround(f11 - f18);
      f13 = Math_fround(Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 8 >> 2]) - f13);
      f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f18));
      f13 = Math_fround(Math_fround(f15 * f14) - Math_fround(f17 * f13));
      f14 = Math_fround(Math_fround(f17 * f18) - Math_fround(f12 * f14));
      f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
      i1 = f12 > Math_fround(0.0);
      if (i42) {
       if (i1) {
        f15 = Math_fround(Math_fround(1.0) / f12);
        f18 = Math_fround(f11 * f15);
        f17 = Math_fround(f13 * f15);
        f15 = Math_fround(f14 * f15);
       } else {
        f18 = f11;
        f17 = f13;
        f15 = f14;
       }
       f26 = Math_fround(f26 - f27);
       f13 = Math_fround(f24 - f25);
       f24 = Math_fround(f23 - f20);
       f11 = Math_fround(f21 - f27);
       f62 = Math_fround(f22 - f25);
       f14 = Math_fround(f19 - f20);
       f12 = Math_fround(Math_fround(f13 * f14) - Math_fround(f24 * f62));
       f14 = Math_fround(Math_fround(f24 * f11) - Math_fround(f26 * f14));
       f11 = Math_fround(Math_fround(f26 * f62) - Math_fround(f13 * f11));
       f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
       if (f13 > Math_fround(0.0)) {
        f62 = Math_fround(Math_fround(1.0) / f13);
        f12 = Math_fround(f12 * f62);
        f13 = Math_fround(f14 * f62);
        f11 = Math_fround(f11 * f62);
       } else f13 = f14;
       f27 = Math_fround(Math_fround(f17 * f11) - Math_fround(f15 * f13));
       f62 = Math_fround(Math_fround(f15 * f12) - Math_fround(f18 * f11));
       f26 = Math_fround(Math_fround(f18 * f13) - Math_fround(f17 * f12));
       i1 = Math_fround(Math_abs(Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f27 * f27) + Math_fround(f62 * f62))))), +Math_fround(Math_fround(f15 * f11) + Math_fround(Math_fround(f17 * f13) + Math_fround(f18 * f12))))))) > f46;
       break;
      } else {
       if (i1) {
        f15 = Math_fround(Math_fround(1.0) / f12);
        f18 = Math_fround(f11 * f15);
        f17 = Math_fround(f13 * f15);
        f15 = Math_fround(f14 * f15);
       } else {
        f18 = f11;
        f17 = f13;
        f15 = f14;
       }
       f26 = Math_fround(f26 - f27);
       f13 = Math_fround(f24 - f25);
       f24 = Math_fround(f23 - f20);
       f11 = Math_fround(f21 - f27);
       f62 = Math_fround(f22 - f25);
       f14 = Math_fround(f19 - f20);
       f12 = Math_fround(Math_fround(f13 * f14) - Math_fround(f24 * f62));
       f14 = Math_fround(Math_fround(f24 * f11) - Math_fround(f26 * f14));
       f11 = Math_fround(Math_fround(f26 * f62) - Math_fround(f13 * f11));
       f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
       if (f13 > Math_fround(0.0)) {
        f62 = Math_fround(Math_fround(1.0) / f13);
        f12 = Math_fround(f12 * f62);
        f13 = Math_fround(f14 * f62);
        f11 = Math_fround(f11 * f62);
       } else f13 = f14;
       i1 = Math_fround(Math_fround(f15 * f11) + Math_fround(Math_fround(f17 * f13) + Math_fround(f18 * f12))) < Math_fround(-.999000012);
       break;
      }
     }
     if (i57) {
      i41 = HEAP32[i59 + (i3 << 2) >> 2] | 0;
      i42 = HEAP32[i59 + (i3 + 1 << 2) >> 2] | 0;
      i40 = HEAP32[i59 + (i3 + 2 << 2) >> 2] | 0;
     } else {
      i41 = HEAPU16[i60 + (i3 << 1) >> 1] | 0;
      i42 = HEAPU16[i60 + (i3 + 1 << 1) >> 1] | 0;
      i40 = HEAPU16[i60 + (i3 + 2 << 1) >> 1] | 0;
     }
     if ((i1 & 65535) > 1) {
      i28 = i47 + (i41 * 12 | 0) | 0;
      i29 = i47 + (i41 * 12 | 0) + 4 | 0;
      i30 = i47 + (i41 * 12 | 0) + 8 | 0;
      i31 = i47 + (i42 * 12 | 0) | 0;
      i32 = i47 + (i42 * 12 | 0) + 4 | 0;
      i33 = i47 + (i42 * 12 | 0) + 8 | 0;
      i34 = i47 + (i40 * 12 | 0) | 0;
      i35 = i47 + (i40 * 12 | 0) + 4 | 0;
      i36 = i47 + (i40 * 12 | 0) + 8 | 0;
      i7 = 0;
      i16 = 0;
      i10 = 0;
      i37 = 1;
      i5 = 0;
      i4 = 0;
      i3 = 1;
      while (1) {
       i1 = (HEAP32[i45 + (i39 + i37 << 2) >> 2] | 0) * 3 | 0;
       if (i57) {
        i8 = HEAP32[i59 + (i1 << 2) >> 2] | 0;
        i9 = HEAP32[i59 + (i1 + 1 << 2) >> 2] | 0;
        i1 = HEAP32[i59 + (i1 + 2 << 2) >> 2] | 0;
       } else {
        i8 = HEAPU16[i60 + (i1 << 1) >> 1] | 0;
        i9 = HEAPU16[i60 + (i1 + 1 << 1) >> 1] | 0;
        i1 = HEAPU16[i60 + (i1 + 2 << 1) >> 1] | 0;
       }
       if ((i8 | 0) == (i40 | 0) | ((i8 | 0) == (i41 | 0) | (i8 | 0) == (i42 | 0))) if ((i9 | 0) == (i40 | 0) | ((i9 | 0) == (i41 | 0) | (i9 | 0) == (i42 | 0))) if ((i1 | 0) == (i40 | 0) | ((i1 | 0) == (i41 | 0) | (i1 | 0) == (i42 | 0))) {
        f14 = Math_fround(HEAPF32[i28 >> 2]);
        f62 = Math_fround(HEAPF32[i29 >> 2]);
        f13 = Math_fround(HEAPF32[i30 >> 2]);
        f27 = Math_fround(HEAPF32[i31 >> 2]);
        f12 = Math_fround(HEAPF32[i32 >> 2]);
        f26 = Math_fround(HEAPF32[i33 >> 2]);
        f63 = Math_fround(HEAPF32[i34 >> 2]);
        f25 = Math_fround(HEAPF32[i35 >> 2]);
        f11 = Math_fround(HEAPF32[i36 >> 2]);
        f23 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]);
        f24 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2]);
        f20 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]);
        f21 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) >> 2]);
        f22 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 4 >> 2]);
        f17 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 8 >> 2]);
        f18 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) >> 2]);
        f19 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) + 8 >> 2]);
        f27 = Math_fround(f27 - f14);
        f12 = Math_fround(f12 - f62);
        f26 = Math_fround(f26 - f13);
        f14 = Math_fround(f63 - f14);
        f62 = Math_fround(f25 - f62);
        f13 = Math_fround(f11 - f13);
        f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f26 * f62));
        f13 = Math_fround(Math_fround(f26 * f14) - Math_fround(f27 * f13));
        f14 = Math_fround(Math_fround(f27 * f62) - Math_fround(f12 * f14));
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
        if (f12 > Math_fround(0.0)) {
         f25 = Math_fround(Math_fround(1.0) / f12);
         f27 = Math_fround(f11 * f25);
         f26 = Math_fround(f13 * f25);
         f25 = Math_fround(f14 * f25);
        } else {
         f27 = f11;
         f26 = f13;
         f25 = f14;
        }
        f62 = Math_fround(f21 - f23);
        f12 = Math_fround(f22 - f24);
        f22 = Math_fround(f17 - f20);
        f14 = Math_fround(f18 - f23);
        f63 = Math_fround(f19 - f24);
        f13 = Math_fround(f15 - f20);
        f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f22 * f63));
        f13 = Math_fround(Math_fround(f22 * f14) - Math_fround(f62 * f13));
        f14 = Math_fround(Math_fround(f62 * f63) - Math_fround(f12 * f14));
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
        if (f12 > Math_fround(0.0)) {
         f63 = Math_fround(Math_fround(1.0) / f12);
         f11 = Math_fround(f11 * f63);
         f13 = Math_fround(f13 * f63);
         f14 = Math_fround(f14 * f63);
        }
        i8 = i7;
        i9 = i16;
        i5 = i5 | Math_fround(Math_fround(f25 * f14) + Math_fround(Math_fround(f26 * f13) + Math_fround(f27 * f11))) < Math_fround(-.999000012);
       } else i48 = 54; else i48 = 54; else i48 = 54;
       do if ((i48 | 0) == 54) {
        i48 = 0;
        if ((i3 | 0) != 2) {
         i10 = i1;
         i3 = i3 + 1 | 0;
         break;
        }
        if (!((i8 | 0) == (i10 | 0) | ((i8 | 0) == (i7 | 0) | (i8 | 0) == (i16 | 0)))) {
         i1 = 1;
         break L22;
        }
        if (!((i9 | 0) == (i10 | 0) | ((i9 | 0) == (i7 | 0) | (i9 | 0) == (i16 | 0)))) {
         i1 = 1;
         break L22;
        }
        if (!((i1 | 0) == (i10 | 0) | ((i1 | 0) == (i7 | 0) | (i1 | 0) == (i16 | 0)))) {
         i1 = 1;
         break L22;
        }
        f14 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) >> 2]);
        f63 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 4 >> 2]);
        f13 = Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 8 >> 2]);
        f62 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) >> 2]);
        f12 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) + 4 >> 2]);
        f27 = Math_fround(HEAPF32[i47 + (i16 * 12 | 0) + 8 >> 2]);
        f25 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) >> 2]);
        f26 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 4 >> 2]);
        f11 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 8 >> 2]);
        f23 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]);
        f24 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2]);
        f20 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]);
        f21 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) >> 2]);
        f22 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 4 >> 2]);
        f17 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 8 >> 2]);
        f18 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) >> 2]);
        f19 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i47 + (i1 * 12 | 0) + 8 >> 2]);
        f62 = Math_fround(f62 - f14);
        f12 = Math_fround(f12 - f63);
        f27 = Math_fround(f27 - f13);
        f14 = Math_fround(f25 - f14);
        f63 = Math_fround(f26 - f63);
        f13 = Math_fround(f11 - f13);
        f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f27 * f63));
        f13 = Math_fround(Math_fround(f27 * f14) - Math_fround(f62 * f13));
        f14 = Math_fround(Math_fround(f62 * f63) - Math_fround(f12 * f14));
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
        if (f12 > Math_fround(0.0)) {
         f25 = Math_fround(Math_fround(1.0) / f12);
         f27 = Math_fround(f11 * f25);
         f26 = Math_fround(f13 * f25);
         f25 = Math_fround(f14 * f25);
        } else {
         f27 = f11;
         f26 = f13;
         f25 = f14;
        }
        f62 = Math_fround(f21 - f23);
        f12 = Math_fround(f22 - f24);
        f22 = Math_fround(f17 - f20);
        f14 = Math_fround(f18 - f23);
        f63 = Math_fround(f19 - f24);
        f13 = Math_fround(f15 - f20);
        f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f22 * f63));
        f13 = Math_fround(Math_fround(f22 * f14) - Math_fround(f62 * f13));
        f14 = Math_fround(Math_fround(f62 * f63) - Math_fround(f12 * f14));
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
        if (f12 > Math_fround(0.0)) {
         f63 = Math_fround(Math_fround(1.0) / f12);
         f11 = Math_fround(f11 * f63);
         f13 = Math_fround(f13 * f63);
         f14 = Math_fround(f14 * f63);
        }
        i8 = i7;
        i9 = i16;
        i4 = i4 | Math_fround(Math_fround(f25 * f14) + Math_fround(Math_fround(f26 * f13) + Math_fround(f27 * f11))) < Math_fround(-.999000012);
        i3 = 2;
       } while (0);
       i37 = i37 + 1 | 0;
       if (i37 >>> 0 >= i38 >>> 0) break; else {
        i7 = i8;
        i16 = i9;
       }
      }
      i1 = (i3 | 0) == 1;
      if ((i3 | 0) == 2) {
       if (i5 | i4) {
        f14 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) >> 2]);
        f63 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) + 4 >> 2]);
        f13 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) + 8 >> 2]);
        f62 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) >> 2]);
        f12 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) + 4 >> 2]);
        f27 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) + 8 >> 2]);
        f25 = Math_fround(HEAPF32[i47 + (i40 * 12 | 0) >> 2]);
        f26 = Math_fround(HEAPF32[i47 + (i40 * 12 | 0) + 4 >> 2]);
        f11 = Math_fround(HEAPF32[i47 + (i40 * 12 | 0) + 8 >> 2]);
        f23 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]);
        f24 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2]);
        f20 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]);
        f21 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) >> 2]);
        f22 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 4 >> 2]);
        f17 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 8 >> 2]);
        f18 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) >> 2]);
        f19 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 8 >> 2]);
        f62 = Math_fround(f62 - f14);
        f12 = Math_fround(f12 - f63);
        f27 = Math_fround(f27 - f13);
        f14 = Math_fround(f25 - f14);
        f63 = Math_fround(f26 - f63);
        f13 = Math_fround(f11 - f13);
        f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f27 * f63));
        f13 = Math_fround(Math_fround(f27 * f14) - Math_fround(f62 * f13));
        f14 = Math_fround(Math_fround(f62 * f63) - Math_fround(f12 * f14));
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
        if (f12 > Math_fround(0.0)) {
         f25 = Math_fround(Math_fround(1.0) / f12);
         f27 = Math_fround(f11 * f25);
         f26 = Math_fround(f13 * f25);
         f25 = Math_fround(f14 * f25);
        } else {
         f27 = f11;
         f26 = f13;
         f25 = f14;
        }
        f62 = Math_fround(f21 - f23);
        f13 = Math_fround(f22 - f24);
        f22 = Math_fround(f17 - f20);
        f11 = Math_fround(f18 - f23);
        f63 = Math_fround(f19 - f24);
        f14 = Math_fround(f15 - f20);
        f12 = Math_fround(Math_fround(f13 * f14) - Math_fround(f22 * f63));
        f14 = Math_fround(Math_fround(f22 * f11) - Math_fround(f62 * f14));
        f11 = Math_fround(Math_fround(f62 * f63) - Math_fround(f13 * f11));
        f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
        if (f13 > Math_fround(0.0)) {
         f63 = Math_fround(Math_fround(1.0) / f13);
         f12 = Math_fround(f12 * f63);
         f13 = Math_fround(f14 * f63);
         f11 = Math_fround(f11 * f63);
        } else f13 = f14;
        f62 = Math_fround(Math_fround(f26 * f11) - Math_fround(f25 * f13));
        f63 = Math_fround(Math_fround(f25 * f12) - Math_fround(f27 * f11));
        f24 = Math_fround(Math_fround(f27 * f13) - Math_fround(f26 * f12));
        i1 = i1 | Math_fround(Math_abs(Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f24 * f24) + Math_fround(Math_fround(f62 * f62) + Math_fround(f63 * f63))))), +Math_fround(Math_fround(f25 * f11) + Math_fround(Math_fround(f26 * f13) + Math_fround(f27 * f12))))))) > f46;
        break;
       }
       i3 = HEAP32[i2 >> 2] | 0;
       i4 = HEAP32[i2 + 4 >> 2] | 0;
       do if ((i3 | 0) == (i41 | 0)) if ((i4 | 0) == (i42 | 0)) i7 = i40; else if ((i4 | 0) == (i40 | 0)) i7 = i42; else i48 = 86; else {
        if ((i3 | 0) == (i42 | 0)) {
         if ((i4 | 0) == (i41 | 0)) {
          i7 = i40;
          break;
         }
         if ((i4 | 0) == (i40 | 0)) {
          i7 = i41;
          break;
         } else {
          i48 = 86;
          break;
         }
        }
        if ((i3 | 0) == (i40 | 0)) if ((i4 | 0) == (i42 | 0)) i7 = i41; else if ((i4 | 0) == (i41 | 0)) i7 = i42; else i48 = 86; else i48 = 86;
       } while (0);
       if ((i48 | 0) == 86) {
        i48 = 0;
        i7 = -1;
       }
       f62 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) >> 2]);
       f13 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]);
       f62 = Math_fround(f62 - f13);
       f18 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 4 >> 2]);
       f14 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2]);
       f18 = Math_fround(f18 - f14);
       f27 = Math_fround(HEAPF32[i47 + (i9 * 12 | 0) + 8 >> 2]);
       f12 = Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]);
       f27 = Math_fround(f27 - f12);
       f11 = Math_fround(Math_fround(HEAPF32[i47 + (i10 * 12 | 0) >> 2]) - f13);
       f63 = Math_fround(Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 4 >> 2]) - f14);
       f20 = Math_fround(Math_fround(HEAPF32[i47 + (i10 * 12 | 0) + 8 >> 2]) - f12);
       f19 = Math_fround(Math_fround(f18 * f20) - Math_fround(f27 * f63));
       f20 = Math_fround(Math_fround(f27 * f11) - Math_fround(f62 * f20));
       f11 = Math_fround(Math_fround(f62 * f63) - Math_fround(f18 * f11));
       f18 = Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)));
       if (f18 > Math_fround(0.0)) {
        f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f18))));
        f27 = Math_fround(f19 * f63);
        f62 = Math_fround(f20 * f63);
        f63 = Math_fround(f11 * f63);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        i3 = 0;
        i4 = 0;
        i5 = 0;
       }
       f26 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f63 = Math_fround(f26 * f13);
       f27 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f63 = Math_fround(f63 + Math_fround(f27 * f14));
       f62 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f63 = Math_fround(f63 + Math_fround(f62 * f12));
       f26 = Math_fround(f26 * Math_fround(HEAPF32[i47 + (i7 * 12 | 0) >> 2]));
       f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 4 >> 2])));
       if (Math_fround(Math_fround(f27 + Math_fround(f62 * Math_fround(HEAPF32[i47 + (i7 * 12 | 0) + 8 >> 2]))) - f63) < Math_fround(0.0)) {
        f15 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) >> 2]);
        f63 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) + 4 >> 2]);
        f14 = Math_fround(HEAPF32[i47 + (i41 * 12 | 0) + 8 >> 2]);
        f62 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) >> 2]);
        f13 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) + 4 >> 2]);
        f27 = Math_fround(HEAPF32[i47 + (i42 * 12 | 0) + 8 >> 2]);
        f26 = Math_fround(HEAPF32[i47 + (i40 * 12 | 0) >> 2]);
        f12 = Math_fround(HEAPF32[i47 + (i40 * 12 | 0) + 4 >> 2]);
        f62 = Math_fround(f62 - f15);
        f13 = Math_fround(f13 - f63);
        f27 = Math_fround(f27 - f14);
        f15 = Math_fround(f26 - f15);
        f63 = Math_fround(f12 - f63);
        f14 = Math_fround(Math_fround(HEAPF32[i47 + (i40 * 12 | 0) + 8 >> 2]) - f14);
        f12 = Math_fround(Math_fround(f13 * f14) - Math_fround(f27 * f63));
        f14 = Math_fround(Math_fround(f27 * f15) - Math_fround(f62 * f14));
        f15 = Math_fround(Math_fround(f62 * f63) - Math_fround(f13 * f15));
        f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
        if (f13 > Math_fround(0.0)) {
         f63 = Math_fround(Math_fround(1.0) / f13);
         f17 = Math_fround(f12 * f63);
         f14 = Math_fround(f14 * f63);
         f15 = Math_fround(f15 * f63);
        } else f17 = f12;
        f12 = Math_fround(Math_sqrt(Math_fround(f18)));
        if (f12 > Math_fround(0.0)) {
         f63 = Math_fround(Math_fround(1.0) / f12);
         f13 = Math_fround(f19 * f63);
         f12 = Math_fround(f20 * f63);
         f11 = Math_fround(f11 * f63);
        } else {
         f13 = f19;
         f12 = f20;
        }
        f62 = Math_fround(Math_fround(f14 * f11) - Math_fround(f15 * f12));
        f63 = Math_fround(Math_fround(f15 * f13) - Math_fround(f17 * f11));
        f27 = Math_fround(Math_fround(f17 * f12) - Math_fround(f14 * f13));
        i1 = i1 | Math_fround(Math_abs(Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f62 * f62) + Math_fround(f63 * f63))))), +Math_fround(Math_fround(f15 * f11) + Math_fround(Math_fround(f14 * f12) + Math_fround(f17 * f13))))))) > f46;
       }
      } else i1 = 1;
     } else i1 = 1;
    } while (0);
    HEAP8[i44 >> 0] = i1 & 1;
    if (!i6) break; else {
     i44 = i44 + 1 | 0;
     i43 = i43 + 8 | 0;
     i2 = i2 + 8 | 0;
    }
   }
   i28 = i55 + 8 | 0;
   if (HEAP32[i28 >> 2] | 0) {
    i3 = HEAP32[i55 + 12 >> 2] | 0;
    i4 = 0;
    do {
     i1 = i3 + (i4 * 12 | 0) | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) >= 0) if (HEAP8[i49 + (i2 & 268435455) >> 0] | 0) HEAP32[i1 >> 2] = i2 | -2147483648;
     i1 = i3 + (i4 * 12 | 0) + 4 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) >= 0) if (HEAP8[i49 + (i2 & 268435455) >> 0] | 0) HEAP32[i1 >> 2] = i2 | -2147483648;
     i1 = i3 + (i4 * 12 | 0) + 8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) >= 0) if (HEAP8[i49 + (i2 & 268435455) >> 0] | 0) HEAP32[i1 >> 2] = i2 | -2147483648;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0);
   }
   i1 = HEAP32[i55 >> 2] | 0;
   if (i1 | 0) {
    i2 = 0;
    do {
     if (HEAP8[i49 + i2 >> 0] | 0) {
      i48 = (HEAP32[i50 >> 2] | 0) + (i2 << 3) | 0;
      HEAP16[i48 >> 1] = HEAPU16[i48 >> 1] | 1;
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i1 >>> 0);
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i51, i49);
   if (!i52) i1 = 0; else if (i57) {
    i1 = 0;
    i2 = 0;
    do {
     i51 = i2 * 3 | 0;
     i49 = HEAP32[i59 + (i51 << 2) >> 2] | 0;
     i50 = HEAP32[i59 + (i51 + 1 << 2) >> 2] | 0;
     i51 = HEAP32[i59 + (i51 + 2 << 2) >> 2] | 0;
     i1 = i49 >>> 0 > i1 >>> 0 ? i49 : i1;
     i1 = i50 >>> 0 > i1 >>> 0 ? i50 : i1;
     i1 = i51 >>> 0 > i1 >>> 0 ? i51 : i1;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i52 | 0));
   } else {
    i1 = 0;
    i2 = 0;
    do {
     i51 = i2 * 3 | 0;
     i49 = HEAPU16[i60 + (i51 << 1) >> 1] | 0;
     i50 = HEAPU16[i60 + (i51 + 1 << 1) >> 1] | 0;
     i51 = HEAPU16[i60 + (i51 + 2 << 1) >> 1] | 0;
     i1 = i49 >>> 0 > i1 >>> 0 ? i49 : i1;
     i1 = i50 >>> 0 > i1 >>> 0 ? i50 : i1;
     i1 = i51 >>> 0 > i1 >>> 0 ? i51 : i1;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i52 | 0));
   }
   i1 = i1 + 1 | 0;
   i16 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i53, i1, gb + 728039 | 0, 634) | 0;
   _memset(i16 | 0, 0, i1 | 0) | 0;
   i1 = HEAP32[i28 >> 2] | 0;
   i2 = (i1 | 0) == 0;
   if (!i2) {
    i3 = i54 + 4 | 0;
    i4 = i54 + 8 | 0;
    i5 = HEAP32[i55 + 12 >> 2] | 0;
    i6 = i54 + 4 | 0;
    i7 = i54 + 8 | 0;
    i8 = i54 + 4 | 0;
    i9 = i54 + 8 | 0;
    i10 = 0;
    do {
     if (i57) {
      i53 = i10 * 3 | 0;
      HEAP32[i54 >> 2] = HEAP32[i59 + (i53 << 2) >> 2];
      HEAP32[i3 >> 2] = HEAP32[i59 + (i53 + 1 << 2) >> 2];
      HEAP32[i4 >> 2] = HEAP32[i59 + (i53 + 2 << 2) >> 2];
     } else if (i58) {
      i53 = i10 * 3 | 0;
      HEAP32[i54 >> 2] = HEAPU16[i60 + (i53 << 1) >> 1];
      HEAP32[i3 >> 2] = HEAPU16[i60 + (i53 + 1 << 1) >> 1];
      HEAP32[i4 >> 2] = HEAPU16[i60 + (i53 + 2 << 1) >> 1];
     }
     if ((HEAP32[i5 + (i10 * 12 | 0) >> 2] | 0) < 0) {
      HEAP8[i16 + (HEAP32[i6 >> 2] | 0) >> 0] = 1;
      HEAP8[i16 + (HEAP32[i54 >> 2] | 0) >> 0] = 1;
     }
     if ((HEAP32[i5 + (i10 * 12 | 0) + 4 >> 2] | 0) < 0) {
      HEAP8[i16 + (HEAP32[i7 >> 2] | 0) >> 0] = 1;
      HEAP8[i16 + (HEAP32[i8 >> 2] | 0) >> 0] = 1;
     }
     if ((HEAP32[i5 + (i10 * 12 | 0) + 8 >> 2] | 0) < 0) {
      HEAP8[i16 + (HEAP32[i9 >> 2] | 0) >> 0] = 1;
      HEAP8[i16 + (HEAP32[i54 >> 2] | 0) >> 0] = 1;
     }
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < i1 >>> 0);
    if (!i2) {
     i6 = HEAP32[i55 + 12 >> 2] | 0;
     i3 = 0;
     i2 = 0;
     i1 = 0;
     i7 = 0;
     do {
      if (i57) {
       i3 = i7 * 3 | 0;
       i1 = HEAP32[i59 + (i3 << 2) >> 2] | 0;
       i2 = HEAP32[i59 + (i3 + 1 << 2) >> 2] | 0;
       i3 = HEAP32[i59 + (i3 + 2 << 2) >> 2] | 0;
      } else if (i58) {
       i3 = i7 * 3 | 0;
       i1 = HEAPU16[i60 + (i3 << 1) >> 1] | 0;
       i2 = HEAPU16[i60 + (i3 + 1 << 1) >> 1] | 0;
       i3 = HEAPU16[i60 + (i3 + 2 << 1) >> 1] | 0;
      }
      i4 = i6 + (i7 * 12 | 0) | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!(i5 & 1073741824)) if (HEAP8[i16 + i1 >> 0] | 0) HEAP32[i4 >> 2] = i5 | 1073741824;
      i4 = i6 + (i7 * 12 | 0) + 4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!(i5 & 1073741824)) if (HEAP8[i16 + i2 >> 0] | 0) HEAP32[i4 >> 2] = i5 | 1073741824;
      i4 = i6 + (i7 * 12 | 0) + 8 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!(i5 & 1073741824)) if (HEAP8[i16 + i3 >> 0] | 0) HEAP32[i4 >> 2] = i5 | 1073741824;
      i7 = i7 + 1 | 0;
     } while (i7 >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0);
    }
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i16);
   i60 = 1;
   STACKTOP = i61;
   return i60 | 0;
  }
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 299, gb + 728116 | 0, i1);
 i60 = 0;
 STACKTOP = i61;
 return i60 | 0;
}

function __Z17sweepBox_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i39, i41, i45, i43, f38, i49, i42, f40) {
 i39 = i39 | 0;
 i41 = i41 | 0;
 i45 = i45 | 0;
 i43 = i43 | 0;
 f38 = Math_fround(f38);
 i49 = i49 | 0;
 i42 = i42 | 0;
 f40 = Math_fround(f40);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i50;
 i36 = i50 + 528 | 0;
 i35 = i50 + 464 | 0;
 i1 = i50 + 416 | 0;
 i24 = i50 + 476 | 0;
 i9 = i50 + 356 | 0;
 i8 = i50 + 368 | 0;
 i6 = i50 + 296 | 0;
 i34 = i50 + 284 | 0;
 i37 = i50 + 256 | 0;
 i46 = i50 + 244 | 0;
 i47 = i50 + 232 | 0;
 i33 = i50 + 220 | 0;
 i48 = i50 + 208 | 0;
 i23 = i39 + 4 | 0;
 i7 = i39 + 8 | 0;
 if (Math_fround(HEAPF32[i23 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i39 + 12 >> 2]) == Math_fround(1.0)) {
  f31 = Math_fround(HEAPF32[i41 >> 2]);
  f32 = Math_fround(f31 + f31);
  f2 = Math_fround(HEAPF32[i41 + 4 >> 2]);
  f25 = Math_fround(f2 + f2);
  f55 = Math_fround(HEAPF32[i41 + 8 >> 2]);
  f3 = Math_fround(f55 + f55);
  f52 = Math_fround(HEAPF32[i41 + 12 >> 2]);
  f30 = Math_fround(f32 * f52);
  f51 = Math_fround(f25 * f52);
  f54 = Math_fround(f52 * f3);
  f32 = Math_fround(f31 * f32);
  f5 = Math_fround(f31 * f25);
  f11 = Math_fround(f31 * f3);
  f25 = Math_fround(f2 * f25);
  f27 = Math_fround(f2 * f3);
  f3 = Math_fround(f55 * f3);
  f10 = Math_fround(Math_fround(Math_fround(1.0) - f25) - f3);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f10 = Math_fround(f5 + f54);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f10 = Math_fround(f11 - f51);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f54 = Math_fround(f5 - f54);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  f32 = Math_fround(Math_fround(1.0) - f32);
  f3 = Math_fround(f32 - f3);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f3 = Math_fround(f27 + f30);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f51 = Math_fround(f11 + f51);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  f30 = Math_fround(f27 - f30);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  f25 = Math_fround(f32 - f25);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = HEAP32[i41 + 16 >> 2] | 0;
  i20 = HEAP32[i41 + 20 >> 2] | 0;
  i21 = HEAP32[i41 + 24 >> 2] | 0;
  f25 = Math_fround(-f31);
  f32 = Math_fround(-f2);
  f30 = Math_fround(-f55);
  f31 = Math_fround(f25 - f31);
  f2 = Math_fround(f32 - f2);
  f55 = Math_fround(f30 - f55);
  f27 = Math_fround(f2 * f32);
  f51 = Math_fround(f55 * f30);
  f32 = Math_fround(f31 * f32);
  f11 = Math_fround(f31 * f30);
  f3 = Math_fround(f31 * f52);
  f30 = Math_fround(f2 * f30);
  f2 = Math_fround(f2 * f52);
  f52 = Math_fround(f55 * f52);
  f55 = Math_fround(Math_fround(Math_fround(1.0) - f27) - f51);
  f54 = Math_fround(f32 + f52);
  f5 = Math_fround(f11 - f2);
  f52 = Math_fround(f32 - f52);
  f25 = Math_fround(Math_fround(1.0) - Math_fround(f31 * f25));
  f51 = Math_fround(f25 - f51);
  f31 = Math_fround(f30 + f3);
  f2 = Math_fround(f11 + f2);
  f3 = Math_fround(f30 - f3);
  f27 = Math_fround(f25 - f27);
  f25 = Math_fround(HEAPF32[i45 + 36 >> 2]);
  f25 = Math_fround(f25 - (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f30 = Math_fround(HEAPF32[i45 + 40 >> 2]);
  f30 = Math_fround(f30 - (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f11 = Math_fround(HEAPF32[i45 + 44 >> 2]);
  f11 = Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f32 = Math_fround(Math_fround(Math_fround(f54 * f25) + Math_fround(f51 * f30)) + Math_fround(f3 * f11));
  f10 = Math_fround(Math_fround(Math_fround(f5 * f25) + Math_fround(f31 * f30)) + Math_fround(f27 * f11));
  HEAPF32[i35 >> 2] = Math_fround(Math_fround(Math_fround(f55 * f25) + Math_fround(f52 * f30)) + Math_fround(f2 * f11));
  HEAPF32[i35 + 4 >> 2] = f32;
  HEAPF32[i35 + 8 >> 2] = f10;
  f10 = Math_fround(HEAPF32[i43 >> 2]);
  f32 = Math_fround(f55 * f10);
  f11 = Math_fround(f54 * f10);
  f10 = Math_fround(f5 * f10);
  f30 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f32 = Math_fround(f32 + Math_fround(f52 * f30));
  f11 = Math_fround(f11 + Math_fround(f51 * f30));
  f30 = Math_fround(f10 + Math_fround(f31 * f30));
  f10 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f32 = Math_fround(Math_fround(f32 + Math_fround(f2 * f10)) * f38);
  f11 = Math_fround(Math_fround(f11 + Math_fround(f3 * f10)) * f38);
  f10 = Math_fround(Math_fround(f30 + Math_fround(f27 * f10)) * f38);
  f30 = Math_fround(HEAPF32[i45 >> 2]);
  f25 = Math_fround(f55 * f30);
  f26 = Math_fround(f54 * f30);
  f30 = Math_fround(f5 * f30);
  f4 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f52 * f4));
  f26 = Math_fround(f26 + Math_fround(f51 * f4));
  f4 = Math_fround(f30 + Math_fround(f31 * f4));
  f30 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f2 * f30));
  f26 = Math_fround(f26 + Math_fround(f3 * f30));
  f30 = Math_fround(f4 + Math_fround(f27 * f30));
  f4 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  f28 = Math_fround(f55 * f4);
  f29 = Math_fround(f54 * f4);
  f4 = Math_fround(f5 * f4);
  f53 = Math_fround(HEAPF32[i45 + 16 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f52 * f53));
  f29 = Math_fround(f29 + Math_fround(f51 * f53));
  f53 = Math_fround(f4 + Math_fround(f31 * f53));
  f4 = Math_fround(HEAPF32[i45 + 20 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f2 * f4));
  f29 = Math_fround(f29 + Math_fround(f3 * f4));
  f4 = Math_fround(f53 + Math_fround(f27 * f4));
  f53 = Math_fround(HEAPF32[i45 + 24 >> 2]);
  f55 = Math_fround(f55 * f53);
  f54 = Math_fround(f54 * f53);
  f53 = Math_fround(f5 * f53);
  f5 = Math_fround(HEAPF32[i45 + 28 >> 2]);
  f52 = Math_fround(f55 + Math_fround(f52 * f5));
  f51 = Math_fround(f54 + Math_fround(f51 * f5));
  f5 = Math_fround(f53 + Math_fround(f31 * f5));
  f31 = Math_fround(HEAPF32[i45 + 32 >> 2]);
  f2 = Math_fround(f52 + Math_fround(f2 * f31));
  f3 = Math_fround(f51 + Math_fround(f3 * f31));
  f31 = Math_fround(f5 + Math_fround(f27 * f31));
  f25 = Math_fround(Math_abs(Math_fround(f25)));
  f26 = Math_fround(Math_abs(Math_fround(f26)));
  f30 = Math_fround(Math_abs(Math_fround(f30)));
  f27 = Math_fround(HEAPF32[i45 + 48 >> 2]);
  f25 = Math_fround(f25 * f27);
  f26 = Math_fround(f26 * f27);
  f27 = Math_fround(f30 * f27);
  f28 = Math_fround(Math_abs(Math_fround(f28)));
  f29 = Math_fround(Math_abs(Math_fround(f29)));
  f4 = Math_fround(Math_abs(Math_fround(f4)));
  f30 = Math_fround(HEAPF32[i45 + 52 >> 2]);
  f28 = Math_fround(f25 + Math_fround(f28 * f30));
  f29 = Math_fround(f26 + Math_fround(f29 * f30));
  f30 = Math_fround(f27 + Math_fround(f4 * f30));
  f2 = Math_fround(Math_abs(Math_fround(f2)));
  f3 = Math_fround(Math_abs(Math_fround(f3)));
  f31 = Math_fround(Math_abs(Math_fround(f31)));
  f4 = Math_fround(HEAPF32[i45 + 56 >> 2]);
  f2 = Math_fround(f28 + Math_fround(f2 * f4));
  f3 = Math_fround(f29 + Math_fround(f3 * f4));
  f4 = Math_fround(f30 + Math_fround(f31 * f4));
  HEAPF32[i36 >> 2] = f2;
  i1 = i36 + 4 | 0;
  HEAPF32[i1 >> 2] = f3;
  i6 = i36 + 8 | 0;
  HEAPF32[i6 >> 2] = f4;
  i7 = i36;
 } else i22 = 5; else i22 = 5; else i22 = 5;
 if ((i22 | 0) == 5) {
  __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i1, i41, i23);
  i56 = HEAP32[i1 >> 2] | 0;
  i22 = HEAP32[i1 + 4 >> 2] | 0;
  i12 = HEAP32[i1 + 8 >> 2] | 0;
  i13 = HEAP32[i1 + 12 >> 2] | 0;
  i14 = HEAP32[i1 + 16 >> 2] | 0;
  i15 = HEAP32[i1 + 20 >> 2] | 0;
  i16 = HEAP32[i1 + 24 >> 2] | 0;
  i17 = HEAP32[i1 + 28 >> 2] | 0;
  i18 = HEAP32[i1 + 32 >> 2] | 0;
  i19 = HEAP32[i1 + 36 >> 2] | 0;
  i20 = HEAP32[i1 + 40 >> 2] | 0;
  i21 = HEAP32[i1 + 44 >> 2] | 0;
  f29 = Math_fround(HEAPF32[i41 >> 2]);
  f73 = Math_fround(HEAPF32[i41 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i41 + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i41 + 12 >> 2]);
  f66 = Math_fround(f29 + f29);
  f26 = Math_fround(f73 + f73);
  f51 = Math_fround(f2 + f2);
  f5 = Math_fround(f73 * f26);
  f27 = Math_fround(f2 * f51);
  f73 = Math_fround(f66 * f73);
  f71 = Math_fround(f66 * f2);
  f65 = Math_fround(f66 * f32);
  f2 = Math_fround(f26 * f2);
  f26 = Math_fround(f26 * f32);
  f32 = Math_fround(f51 * f32);
  f51 = Math_fround(Math_fround(Math_fround(1.0) - f5) - f27);
  f64 = Math_fround(f73 + f32);
  f53 = Math_fround(f71 - f26);
  f32 = Math_fround(f73 - f32);
  f66 = Math_fround(Math_fround(1.0) - Math_fround(f29 * f66));
  f27 = Math_fround(f66 - f27);
  f29 = Math_fround(f2 + f65);
  f26 = Math_fround(f71 + f26);
  f65 = Math_fround(f2 - f65);
  f5 = Math_fround(f66 - f5);
  f66 = Math_fround(HEAPF32[i39 + 16 >> 2]);
  f2 = Math_fround(HEAPF32[i39 + 20 >> 2]);
  f71 = Math_fround(HEAPF32[i39 + 24 >> 2]);
  f73 = Math_fround(HEAPF32[i39 + 28 >> 2]);
  f28 = Math_fround(f66 + f66);
  f67 = Math_fround(f2 + f2);
  f54 = Math_fround(f71 + f71);
  f3 = Math_fround(f2 * f67);
  f72 = Math_fround(f71 * f54);
  f2 = Math_fround(f28 * f2);
  f69 = Math_fround(f28 * f71);
  f52 = Math_fround(f28 * f73);
  f71 = Math_fround(f67 * f71);
  f67 = Math_fround(f67 * f73);
  f73 = Math_fround(f54 * f73);
  f54 = Math_fround(Math_fround(Math_fround(1.0) - f3) - f72);
  f30 = Math_fround(f2 + f73);
  f31 = Math_fround(f69 - f67);
  f73 = Math_fround(f2 - f73);
  f28 = Math_fround(Math_fround(1.0) - Math_fround(f66 * f28));
  f72 = Math_fround(f28 - f72);
  f66 = Math_fround(f71 + f52);
  f67 = Math_fround(f69 + f67);
  f52 = Math_fround(f71 - f52);
  f3 = Math_fround(f28 - f3);
  f28 = Math_fround(HEAPF32[i23 >> 2]);
  f71 = Math_fround(f28 * f54);
  f69 = Math_fround(f28 * f73);
  f28 = Math_fround(f28 * f67);
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f70 = Math_fround(f30 * f2);
  f68 = Math_fround(f72 * f2);
  f2 = Math_fround(f52 * f2);
  f10 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  f11 = Math_fround(f31 * f10);
  f25 = Math_fround(f66 * f10);
  f10 = Math_fround(f3 * f10);
  f55 = Math_fround(Math_fround(Math_fround(f54 * f71) + Math_fround(f30 * f70)) + Math_fround(f31 * f11));
  f4 = Math_fround(Math_fround(Math_fround(f54 * f69) + Math_fround(f30 * f68)) + Math_fround(f31 * f25));
  f31 = Math_fround(Math_fround(Math_fround(f54 * f28) + Math_fround(f30 * f2)) + Math_fround(f31 * f10));
  f30 = Math_fround(Math_fround(Math_fround(f73 * f71) + Math_fround(f72 * f70)) + Math_fround(f66 * f11));
  f54 = Math_fround(Math_fround(Math_fround(f73 * f69) + Math_fround(f72 * f68)) + Math_fround(f66 * f25));
  f66 = Math_fround(Math_fround(Math_fround(f73 * f28) + Math_fround(f72 * f2)) + Math_fround(f66 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f67 * f71) + Math_fround(f52 * f70)) + Math_fround(f3 * f11));
  f25 = Math_fround(Math_fround(Math_fround(f67 * f69) + Math_fround(f52 * f68)) + Math_fround(f3 * f25));
  f10 = Math_fround(Math_fround(Math_fround(f67 * f28) + Math_fround(f52 * f2)) + Math_fround(f3 * f10));
  f3 = Math_fround(Math_fround(f65 * f31) + Math_fround(Math_fround(f64 * f55) + Math_fround(f27 * f4)));
  f2 = Math_fround(Math_fround(f5 * f31) + Math_fround(Math_fround(f53 * f55) + Math_fround(f29 * f4)));
  f52 = Math_fround(Math_fround(f26 * f66) + Math_fround(Math_fround(f51 * f30) + Math_fround(f32 * f54)));
  f28 = Math_fround(Math_fround(f65 * f66) + Math_fround(Math_fround(f64 * f30) + Math_fround(f27 * f54)));
  f54 = Math_fround(Math_fround(f5 * f66) + Math_fround(Math_fround(f53 * f30) + Math_fround(f29 * f54)));
  f30 = Math_fround(Math_fround(f26 * f10) + Math_fround(Math_fround(f51 * f11) + Math_fround(f32 * f25)));
  f27 = Math_fround(Math_fround(f65 * f10) + Math_fround(Math_fround(f64 * f11) + Math_fround(f27 * f25)));
  f25 = Math_fround(Math_fround(f5 * f10) + Math_fround(Math_fround(f53 * f11) + Math_fround(f29 * f25)));
  HEAPF32[i44 >> 2] = Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f51 * f55) + Math_fround(f32 * f4)));
  HEAPF32[i44 + 4 >> 2] = f3;
  HEAPF32[i44 + 8 >> 2] = f2;
  HEAPF32[i44 + 12 >> 2] = f52;
  HEAPF32[i44 + 16 >> 2] = f28;
  HEAPF32[i44 + 20 >> 2] = f54;
  HEAPF32[i44 + 24 >> 2] = f30;
  HEAPF32[i44 + 28 >> 2] = f27;
  HEAPF32[i44 + 32 >> 2] = f25;
  __ZN5physx10getInverseERNS_7PxMat33ERNS_6PxVec3ERKS0_RKS2_(i24, i9, i44, i41 + 16 | 0);
  HEAP32[i8 >> 2] = HEAP32[i24 >> 2];
  i63 = i8 + 4 | 0;
  HEAP32[i63 >> 2] = HEAP32[i24 + 4 >> 2];
  i62 = i8 + 8 | 0;
  HEAP32[i62 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  i61 = i8 + 16 | 0;
  HEAP32[i61 >> 2] = HEAP32[i24 + 16 >> 2];
  i60 = i8 + 20 | 0;
  HEAP32[i60 >> 2] = HEAP32[i24 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
  i59 = i8 + 28 | 0;
  HEAP32[i59 >> 2] = HEAP32[i24 + 28 >> 2];
  i58 = i8 + 32 | 0;
  HEAP32[i58 >> 2] = HEAP32[i24 + 32 >> 2];
  HEAP32[i8 + 36 >> 2] = HEAP32[i9 >> 2];
  i57 = i8 + 40 | 0;
  HEAP32[i57 >> 2] = HEAP32[i9 + 4 >> 2];
  i7 = i8 + 44 | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 + 8 >> 2];
  __ZN5physx9transformERKNS_2Cm8Matrix34ERKNS_2Gu3BoxE(i6, i8, i45);
  f25 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f54 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f28 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f52 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f2 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  f3 = Math_fround(HEAPF32[i6 + 28 >> 2]);
  f4 = Math_fround(HEAPF32[i6 + 32 >> 2]);
  f32 = Math_fround(HEAPF32[i6 + 48 >> 2]);
  f55 = Math_fround(HEAPF32[i6 + 52 >> 2]);
  f51 = Math_fround(HEAPF32[i6 + 56 >> 2]);
  f2 = Math_fround(Math_fround(Math_fround(f32 * Math_fround(Math_abs(Math_fround(f25)))) + Math_fround(f55 * Math_fround(Math_abs(Math_fround(f54))))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f2)))));
  f3 = Math_fround(Math_fround(Math_fround(f32 * Math_fround(Math_abs(Math_fround(f27)))) + Math_fround(f55 * Math_fround(Math_abs(Math_fround(f28))))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f3)))));
  f4 = Math_fround(Math_fround(Math_fround(f32 * Math_fround(Math_abs(Math_fround(f30)))) + Math_fround(f55 * Math_fround(Math_abs(Math_fround(f52))))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f4)))));
  HEAPF32[i36 >> 2] = f2;
  i1 = i36 + 4 | 0;
  HEAPF32[i1 >> 2] = f3;
  i6 = i36 + 8 | 0;
  HEAPF32[i6 >> 2] = f4;
  f51 = Math_fround(HEAPF32[i45 + 36 >> 2]);
  f52 = Math_fround(HEAPF32[i8 >> 2]);
  f55 = Math_fround(f51 * f52);
  f30 = Math_fround(HEAPF32[i63 >> 2]);
  f32 = Math_fround(f51 * f30);
  f28 = Math_fround(HEAPF32[i62 >> 2]);
  f51 = Math_fround(f51 * f28);
  f27 = Math_fround(HEAPF32[i45 + 40 >> 2]);
  f54 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f25 = Math_fround(f27 * f54);
  f31 = Math_fround(HEAPF32[i61 >> 2]);
  f26 = Math_fround(f27 * f31);
  f29 = Math_fround(HEAPF32[i60 >> 2]);
  f25 = Math_fround(f55 + f25);
  f26 = Math_fround(f32 + f26);
  f27 = Math_fround(f51 + Math_fround(f27 * f29));
  f51 = Math_fround(HEAPF32[i45 + 44 >> 2]);
  f32 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f55 = Math_fround(f51 * f32);
  f11 = Math_fround(HEAPF32[i59 >> 2]);
  f53 = Math_fround(f51 * f11);
  f10 = Math_fround(HEAPF32[i58 >> 2]);
  f55 = Math_fround(f25 + f55);
  f53 = Math_fround(f26 + f53);
  f51 = Math_fround(f27 + Math_fround(f51 * f10));
  f55 = Math_fround(f55 + Math_fround(HEAPF32[i8 + 36 >> 2]));
  f53 = Math_fround(f53 + Math_fround(HEAPF32[i57 >> 2]));
  f51 = Math_fround(f51 + Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i35 >> 2] = f55;
  HEAPF32[i35 + 4 >> 2] = f53;
  HEAPF32[i35 + 8 >> 2] = f51;
  f51 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) * f38);
  f53 = Math_fround(Math_fround(HEAPF32[i43 + 4 >> 2]) * f38);
  f55 = Math_fround(Math_fround(HEAPF32[i43 + 8 >> 2]) * f38);
  f10 = Math_fround(Math_fround(Math_fround(f51 * f28) + Math_fround(f53 * f29)) + Math_fround(f55 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f51 * f30) + Math_fround(f53 * f31)) + Math_fround(f55 * f11));
  f32 = Math_fround(Math_fround(Math_fround(f51 * f52) + Math_fround(f53 * f54)) + Math_fround(f55 * f32));
  i7 = i36;
  i8 = i56;
  i9 = i22;
 }
 f73 = Math_fround(f3 + f40);
 f5 = Math_fround(f4 + f40);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f2 + f40) * Math_fround(1.00999999));
 HEAPF32[i1 >> 2] = Math_fround(f73 * Math_fround(1.00999999));
 HEAPF32[i6 >> 2] = Math_fround(f5 * Math_fround(1.00999999));
 i63 = HEAP32[i39 + 36 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i63 + 32 >> 2];
 HEAP32[i34 + 4 >> 2] = i63 + 48;
 HEAP32[i34 + 8 >> 2] = HEAP32[i63 + 36 >> 2];
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f32 * f32)))));
 i63 = f5 > Math_fround(9.99999974e-06);
 f5 = i63 ? f5 : Math_fround(9.99999974e-06);
 if (Math_fround(HEAPF32[i23 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i39 + 8 >> 2]) == Math_fround(1.0)) i1 = Math_fround(HEAPF32[i39 + 12 >> 2]) == Math_fround(1.0); else i1 = 0; else i1 = 0;
 f70 = Math_fround(f5 / f38);
 f70 = i1 ? Math_fround(1.0) : f70;
 f66 = Math_fround(HEAPF32[i45 >> 2]);
 f69 = Math_fround(HEAPF32[i45 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i45 + 8 >> 2]);
 f67 = Math_fround(HEAPF32[i45 + 12 >> 2]);
 f73 = Math_fround(HEAPF32[i45 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i45 + 20 >> 2]);
 f72 = Math_fround(HEAPF32[i45 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i45 + 28 >> 2]);
 f71 = Math_fround(HEAPF32[i45 + 32 >> 2]);
 f54 = Math_fround(HEAPF32[i45 + 36 >> 2]);
 i62 = i45 + 40 | 0;
 f64 = Math_fround(HEAPF32[i62 >> 2]);
 i1 = i45 + 44 | 0;
 f54 = Math_fround(-f54);
 f64 = Math_fround(-f64);
 f25 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f27 = Math_fround(Math_fround(Math_fround(f66 * f54) + Math_fround(f69 * f64)) + Math_fround(f2 * f25));
 f26 = Math_fround(Math_fround(Math_fround(f67 * f54) + Math_fround(f73 * f64)) + Math_fround(f3 * f25));
 f25 = Math_fround(Math_fround(Math_fround(f72 * f54) + Math_fround(f4 * f64)) + Math_fround(f71 * f25));
 i63 = HEAP8[i39 + 32 >> 0] & 2;
 i7 = HEAP16[i42 >> 1] & 128;
 i22 = i7 << 16 >> 16 != 0 | i63 << 24 >> 24 != 0;
 f64 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = Math_fround(f64 * f66);
 f55 = Math_fround(f64 * f67);
 f64 = Math_fround(f64 * f72);
 f31 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = Math_fround(f54 + Math_fround(f31 * f69));
 f55 = Math_fround(f55 + Math_fround(f31 * f73));
 f31 = Math_fround(f64 + Math_fround(f31 * f4));
 f64 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = Math_fround(f54 + Math_fround(f64 * f2));
 f55 = Math_fround(f55 + Math_fround(f64 * f3));
 f64 = Math_fround(f31 + Math_fround(f64 * f71));
 f31 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(f31 * f66);
 f68 = Math_fround(f31 * f67);
 f31 = Math_fround(f31 * f72);
 f28 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(f65 + Math_fround(f28 * f69));
 f68 = Math_fround(f68 + Math_fround(f28 * f73));
 f28 = Math_fround(f31 + Math_fround(f28 * f4));
 f31 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(f65 + Math_fround(f31 * f2));
 f68 = Math_fround(f68 + Math_fround(f31 * f3));
 f31 = Math_fround(f28 + Math_fround(f31 * f71));
 f28 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f28 * f66);
 f29 = Math_fround(f28 * f67);
 f28 = Math_fround(f28 * f72);
 f53 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f30 + Math_fround(f53 * f69));
 f29 = Math_fround(f29 + Math_fround(f53 * f73));
 f53 = Math_fround(f28 + Math_fround(f53 * f4));
 f28 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f30 + Math_fround(f28 * f2));
 f29 = Math_fround(f29 + Math_fround(f28 * f3));
 f28 = Math_fround(f53 + Math_fround(f28 * f71));
 f53 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f74 = Math_fround(f53 * f66);
 f51 = Math_fround(f53 * f67);
 f53 = Math_fround(f53 * f72);
 f52 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f74 = Math_fround(f74 + Math_fround(f52 * f69));
 f51 = Math_fround(f51 + Math_fround(f52 * f73));
 f52 = Math_fround(f53 + Math_fround(f52 * f4));
 f53 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(Math_fround(f74 + Math_fround(f53 * f2)) + f27);
 f26 = Math_fround(Math_fround(f51 + Math_fround(f53 * f3)) + f26);
 f25 = Math_fround(Math_fround(f52 + Math_fround(f53 * f71)) + f25);
 HEAPF32[i24 >> 2] = f54;
 HEAPF32[i24 + 4 >> 2] = f55;
 HEAPF32[i24 + 8 >> 2] = f64;
 HEAPF32[i24 + 12 >> 2] = f65;
 HEAPF32[i24 + 16 >> 2] = f68;
 HEAPF32[i24 + 20 >> 2] = f31;
 HEAPF32[i24 + 24 >> 2] = f30;
 HEAPF32[i24 + 28 >> 2] = f29;
 HEAPF32[i24 + 32 >> 2] = f28;
 HEAPF32[i24 + 36 >> 2] = f27;
 HEAPF32[i24 + 40 >> 2] = f26;
 HEAPF32[i24 + 44 >> 2] = f25;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i44, i45);
 i15 = HEAP32[i44 >> 2] | 0;
 HEAP32[i37 >> 2] = i15;
 i14 = HEAP32[i44 + 4 >> 2] | 0;
 HEAP32[i37 + 4 >> 2] = i14;
 i13 = HEAP32[i44 + 8 >> 2] | 0;
 HEAP32[i37 + 8 >> 2] = i13;
 i12 = HEAP32[i44 + 12 >> 2] | 0;
 HEAP32[i37 + 12 >> 2] = i12;
 i9 = HEAP32[i45 + 36 >> 2] | 0;
 HEAP32[i37 + 16 >> 2] = i9;
 i17 = HEAP32[i62 >> 2] | 0;
 HEAP32[i37 + 20 >> 2] = i17;
 i16 = HEAP32[i1 >> 2] | 0;
 HEAP32[i37 + 24 >> 2] = i16;
 f25 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f68 = Math_fround(HEAPF32[i43 >> 2]);
 f66 = Math_fround(f66 * f68);
 f67 = Math_fround(f67 * f68);
 f68 = Math_fround(f72 * f68);
 i12 = i43 + 4 | 0;
 f72 = Math_fround(HEAPF32[i12 >> 2]);
 f69 = Math_fround(f66 + Math_fround(f69 * f72));
 f73 = Math_fround(f67 + Math_fround(f73 * f72));
 f72 = Math_fround(f68 + Math_fround(f4 * f72));
 i13 = i43 + 8 | 0;
 f4 = Math_fround(HEAPF32[i13 >> 2]);
 f2 = Math_fround(f69 + Math_fround(f2 * f4));
 f3 = Math_fround(f73 + Math_fround(f3 * f4));
 f4 = Math_fround(f72 + Math_fround(f71 * f4));
 HEAPF32[i46 >> 2] = f2;
 i14 = i46 + 4 | 0;
 HEAPF32[i14 >> 2] = f3;
 i15 = i46 + 8 | 0;
 HEAPF32[i15 >> 2] = f4;
 f71 = Math_fround(f2 * f38);
 f72 = Math_fround(f3 * f38);
 f73 = Math_fround(f4 * f38);
 HEAPF32[i47 >> 2] = f71;
 i16 = i47 + 4 | 0;
 HEAPF32[i16 >> 2] = f72;
 i17 = i47 + 8 | 0;
 HEAPF32[i17 >> 2] = f73;
 HEAP32[i44 + 4 >> 2] = 2;
 HEAP32[i44 >> 2] = gb + 85368 + 8;
 HEAP32[i44 + 8 >> 2] = i24;
 i9 = i44 + 12 | 0;
 HEAPF32[i9 >> 2] = f38;
 HEAPF32[i44 + 20 >> 2] = f70;
 HEAP8[i44 + 48 >> 0] = (i63 & 255) >>> 1 | (i7 & 65535) >>> 7 & 255;
 HEAP32[i44 + 52 >> 2] = i45;
 HEAP32[i44 + 60 >> 2] = i47;
 HEAP32[i44 + 64 >> 2] = i46;
 HEAP32[i44 + 68 >> 2] = i43;
 HEAP32[i44 + 72 >> 2] = i42;
 i7 = i44 + 76 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i44 + 77 >> 0] = 0;
 HEAPF32[i44 + 80 >> 2] = f40;
 HEAPF32[i44 + 160 >> 2] = f2;
 HEAPF32[i44 + 164 >> 2] = f3;
 HEAPF32[i44 + 168 >> 2] = f4;
 HEAPF32[i44 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i44 + 176 >> 2] = f71;
 HEAPF32[i44 + 180 >> 2] = f72;
 HEAPF32[i44 + 184 >> 2] = f73;
 HEAPF32[i44 + 188 >> 2] = Math_fround(0.0);
 HEAPF32[i44 + 32 >> 2] = f38;
 HEAPF32[i44 + 16 >> 2] = f38;
 i63 = f2 != Math_fround(0.0);
 f2 = Math_fround(Math_fround(1.0) / f2);
 i1 = f3 != Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f3);
 i8 = f4 != Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 i6 = i63 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i63 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i44 + 196 >> 2] = i6;
 HEAP32[i44 + 200 >> 2] = i1;
 HEAP32[i44 + 204 >> 2] = i63;
 f4 = Math_fround(Math_fround(1.0) / f5);
 f3 = Math_fround(f11 * f4);
 f2 = Math_fround(f10 * f4);
 HEAPF32[i33 >> 2] = Math_fround(f32 * f4);
 HEAPF32[i33 + 4 >> 2] = f3;
 HEAPF32[i33 + 8 >> 2] = f2;
 __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i35, i33, f5, i22, i34, i44, i36);
 i1 = HEAP16[i7 >> 1] | 0;
 f2 = Math_fround(HEAPF32[i44 + 128 >> 2]);
 f3 = Math_fround(HEAPF32[i44 + 132 >> 2]);
 f4 = Math_fround(HEAPF32[i44 + 136 >> 2]);
 f5 = Math_fround(HEAPF32[i44 + 144 >> 2]);
 f10 = Math_fround(HEAPF32[i44 + 148 >> 2]);
 f11 = Math_fround(HEAPF32[i44 + 152 >> 2]);
 i6 = HEAP32[i44 + 192 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i63 = 0;
  STACKTOP = i50;
  return i63 | 0;
 }
 if ((i1 & 65535) < 256) {
  i1 = i49 + 8 | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i49 + 40 >> 2] = HEAP32[i9 >> 2];
  HEAP16[i49 + 12 >> 1] = 7;
  if (!(HEAP16[i42 >> 1] & 256)) {
   f69 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
   f68 = Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f29 * f10)) + Math_fround(f30 * f11));
   f70 = Math_fround(-Math_fround(Math_fround(Math_fround(f29 * f68) + Math_fround(Math_fround(f69 * f10) + Math_fround(f31 * Math_fround(Math_fround(f30 * f5) - Math_fround(f28 * f11))))) * Math_fround(2.0)));
   f71 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f69 * f11) + Math_fround(f31 * Math_fround(Math_fround(f28 * f10) - Math_fround(f29 * f5)))) + Math_fround(f30 * f68)) * Math_fround(2.0)));
   f74 = Math_fround(Math_fround(Math_fround(f28 * f2) + Math_fround(f29 * f3)) + Math_fround(f30 * f4));
   f72 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f28 * f74) + Math_fround(Math_fround(f69 * f2) + Math_fround(f31 * Math_fround(Math_fround(f29 * f4) - Math_fround(f30 * f3))))) * Math_fround(2.0)));
   f73 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f29 * f74) + Math_fround(Math_fround(f69 * f3) + Math_fround(f31 * Math_fround(Math_fround(f30 * f2) - Math_fround(f28 * f4))))) * Math_fround(2.0)));
   f74 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(Math_fround(f69 * f4) + Math_fround(f31 * Math_fround(Math_fround(f28 * f3) - Math_fround(f29 * f2)))) + Math_fround(f30 * f74)) * Math_fround(2.0)));
   HEAPF32[i49 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f28 * f68) + Math_fround(Math_fround(f69 * f5) + Math_fround(f31 * Math_fround(Math_fround(f29 * f11) - Math_fround(f30 * f10))))) * Math_fround(2.0)));
   HEAPF32[i49 + 32 >> 2] = f70;
   HEAPF32[i49 + 36 >> 2] = f71;
   HEAPF32[i49 + 16 >> 2] = f72;
   HEAPF32[i49 + 20 >> 2] = f73;
   HEAPF32[i49 + 24 >> 2] = f74;
   HEAP32[i1 >> 2] = i6;
   i63 = 1;
   STACKTOP = i50;
   return i63 | 0;
  }
  i7 = Math_fround(HEAPF32[i46 >> 2]) != Math_fround(0.0);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i47 >> 2]));
  f5 = i7 ? f5 : Math_fround(0.0);
  i7 = Math_fround(HEAPF32[i14 >> 2]) != Math_fround(0.0);
  f4 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i16 >> 2]));
  f4 = i7 ? f4 : Math_fround(0.0);
  i7 = Math_fround(HEAPF32[i15 >> 2]) != Math_fround(0.0);
  f3 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i17 >> 2]));
  f3 = i7 ? f3 : Math_fround(0.0);
  HEAPF32[i48 >> 2] = f5;
  HEAPF32[i48 + 4 >> 2] = f4;
  HEAPF32[i48 + 8 >> 2] = f3;
  i7 = i49 + 16 | 0;
  i8 = i49 + 28 | 0;
  __ZN5physx2Gu23computeBoxTriImpactDataERNS_6PxVec3ES2_RKS1_S4_S4_S4_RKNS_10PxTriangleE(i7, i8, i45 + 48 | 0, i46, i47, i48, i44 + 84 | 0);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f4 = Math_fround(f3 * f3);
  i1 = i49 + 32 | 0;
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f5 * f5));
  i6 = i49 + 36 | 0;
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  f4 = Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f2 * f2))));
  if (f4 > Math_fround(0.0)) {
   f74 = Math_fround(Math_fround(1.0) / f4);
   f3 = Math_fround(f3 * f74);
   HEAPF32[i8 >> 2] = f3;
   f4 = Math_fround(f5 * f74);
   HEAPF32[i1 >> 2] = f4;
   f2 = Math_fround(f2 * f74);
   HEAPF32[i6 >> 2] = f2;
  } else f4 = f5;
  f69 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
  f71 = Math_fround(Math_fround(Math_fround(f28 * f3) + Math_fround(f29 * f4)) + Math_fround(f30 * f2));
  f72 = Math_fround(Math_fround(Math_fround(f29 * f71) + Math_fround(Math_fround(f69 * f4) + Math_fround(f31 * Math_fround(Math_fround(f30 * f3) - Math_fround(f28 * f2))))) * Math_fround(2.0));
  f70 = Math_fround(Math_fround(Math_fround(Math_fround(f69 * f2) + Math_fround(f31 * Math_fround(Math_fround(f28 * f4) - Math_fround(f29 * f3)))) + Math_fround(f30 * f71)) * Math_fround(2.0));
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f28 * f71) + Math_fround(Math_fround(f69 * f3) + Math_fround(f31 * Math_fround(Math_fround(f29 * f2) - Math_fround(f30 * f4))))) * Math_fround(2.0));
  HEAPF32[i1 >> 2] = f72;
  HEAPF32[i6 >> 2] = f70;
  f70 = Math_fround(HEAPF32[i7 >> 2]);
  i62 = i49 + 20 | 0;
  f72 = Math_fround(HEAPF32[i62 >> 2]);
  i63 = i49 + 24 | 0;
  f71 = Math_fround(HEAPF32[i63 >> 2]);
  f68 = Math_fround(Math_fround(Math_fround(f28 * f70) + Math_fround(f29 * f72)) + Math_fround(f30 * f71));
  f73 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f29 * f68) + Math_fround(Math_fround(f69 * f72) + Math_fround(f31 * Math_fround(Math_fround(f30 * f70) - Math_fround(f28 * f71))))) * Math_fround(2.0)));
  f74 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(Math_fround(f69 * f71) + Math_fround(f31 * Math_fround(Math_fround(f28 * f72) - Math_fround(f29 * f70)))) + Math_fround(f30 * f68)) * Math_fround(2.0)));
  HEAPF32[i7 >> 2] = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f28 * f68) + Math_fround(Math_fround(f69 * f70) + Math_fround(f31 * Math_fround(Math_fround(f29 * f71) - Math_fround(f30 * f72))))) * Math_fround(2.0)));
  HEAPF32[i62 >> 2] = f73;
  HEAPF32[i63 >> 2] = f74;
  i63 = 1;
  STACKTOP = i50;
  return i63 | 0;
 } else {
  do if (!(HEAP16[i42 >> 1] & 512)) {
   HEAP16[i49 + 12 >> 1] = 6;
   HEAPF32[i49 + 40 >> 2] = Math_fround(0.0);
   f72 = Math_fround(-Math_fround(HEAPF32[i43 >> 2]));
   f73 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
   f74 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
   HEAPF32[i49 + 28 >> 2] = f72;
   HEAPF32[i49 + 32 >> 2] = f73;
   HEAPF32[i49 + 36 >> 2] = f74;
  } else {
   i63 = __ZN5physx2Gu26computeBox_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbRNS_10PxSweepHitE(i39, i41, i45, i37, f40, f38, i22, i49) | 0;
   i1 = i49 + 12 | 0;
   HEAP16[i1 >> 1] = 6;
   if (i63) {
    HEAP16[i1 >> 1] = 7;
    break;
   } else {
    HEAPF32[i49 + 40 >> 2] = Math_fround(0.0);
    f72 = Math_fround(-Math_fround(HEAPF32[i43 >> 2]));
    f73 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
    f74 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
    HEAPF32[i49 + 28 >> 2] = f72;
    HEAPF32[i49 + 32 >> 2] = f73;
    HEAPF32[i49 + 36 >> 2] = f74;
    break;
   }
  } while (0);
  HEAP32[i49 + 8 >> 2] = i6;
  i63 = 1;
  STACKTOP = i50;
  return i63 | 0;
 }
 return 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i19, i16, i18) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 48 | 0;
 i21 = i23 + 36 | 0;
 i20 = i23 + 24 | 0;
 i13 = i23 + 12 | 0;
 i12 = i23;
 L1 : do if ((i19 | 0) == (i16 | 0)) i1 = i19; else {
  i27 = i18 + 56 | 0;
  i24 = HEAP32[i27 >> 2] | 0;
  i15 = i24 + 1 | 0;
  HEAP32[i27 >> 2] = i15;
  i25 = i18 + 61 | 0;
  i26 = HEAP8[i25 >> 0] | 0;
  if (i15 >>> 0 > 1) HEAP8[i25 >> 0] = 1;
  i1 = HEAP8[i19 >> 0] | 0;
  L6 : do switch (i1 | 0) {
  case 84:
  case 71:
   {
    L164 : do if ((i16 - i19 | 0) > 2) {
     switch (i1 | 0) {
     case 84:
      break;
     case 71:
      switch (HEAP8[i19 + 1 >> 0] | 0) {
      case 86:
       {
        i2 = i19 + 2 | 0;
        __THREW__ = 0;
        i1 = invoke_iiii(fb + 523 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i17 = 105;
         break L6;
        }
        if ((i1 | 0) == (i2 | 0)) {
         i1 = i19;
         break L164;
        }
        i2 = HEAP32[i18 + 4 >> 2] | 0;
        if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
         i1 = i19;
         i17 = 223;
         break L6;
        }
        __THREW__ = 0;
        invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088165 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i17 = 105;
         break L6;
        } else break L164;
       }
      case 82:
       {
        i2 = i19 + 2 | 0;
        __THREW__ = 0;
        i1 = invoke_iiii(fb + 523 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i17 = 105;
         break L6;
        }
        if ((i1 | 0) == (i2 | 0)) {
         i1 = i19;
         break L164;
        }
        i2 = HEAP32[i18 + 4 >> 2] | 0;
        if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
         i1 = i19;
         i17 = 223;
         break L6;
        }
        __THREW__ = 0;
        invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088185 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i17 = 105;
         break L6;
        } else break L164;
       }
      default:
       {
        i1 = i19;
        break L164;
       }
      }
     default:
      {
       i1 = i19;
       break L164;
      }
     }
     i1 = i19 + 1 | 0;
     switch (HEAP8[i1 >> 0] | 0) {
     case 86:
      {
       i2 = i19 + 2 | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = HEAP32[i18 + 4 >> 2] | 0;
       if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088014 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       } else break L164;
      }
     case 84:
      {
       i2 = i19 + 2 | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = HEAP32[i18 + 4 >> 2] | 0;
       if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088026 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       } else break L164;
      }
     case 73:
      {
       i2 = i19 + 2 | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = HEAP32[i18 + 4 >> 2] | 0;
       if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088035 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       } else break L164;
      }
     case 83:
      {
       i2 = i19 + 2 | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = HEAP32[i18 + 4 >> 2] | 0;
       if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088049 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       } else break L164;
      }
     case 99:
      {
       i22 = i19 + 2 | 0;
       i1 = __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_(i22, i16) | 0;
       if ((i1 | 0) == (i22 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_(i1, i16) | 0;
       if ((i2 | 0) == (i1 | 0)) {
        i1 = i19;
        break L164;
       }
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 522 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i2 = HEAP32[i18 + 4 >> 2] | 0;
       if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_iiii(fb + 520 | 0, i2 + -24 | 0, 0, gb + 1088068 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (i22 & 1) {
        i17 = 105;
        break L6;
       } else break L164;
      }
     case 67:
      {
       i1 = i19 + 2 | 0;
       __THREW__ = 0;
       i2 = invoke_iiii(fb + 521 | 0, i1 | 0, i16 | 0, i18 | 0) | 0;
       i15 = __THREW__;
       __THREW__ = 0;
       if (i15 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i2 | 0) == (i1 | 0)) {
        i1 = i19;
        break L164;
       }
       i1 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i2, i16) | 0;
       if ((i1 | 0) == (i2 | 0) | (i1 | 0) == (i16 | 0)) {
        i1 = i19;
        break L164;
       }
       if ((HEAP8[i1 >> 0] | 0) != 95) {
        i1 = i19;
        break L164;
       }
       i2 = i1 + 1 | 0;
       __THREW__ = 0;
       i1 = invoke_iiii(fb + 521 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
       i16 = __THREW__;
       __THREW__ = 0;
       if (i16 & 1) {
        i17 = 105;
        break L6;
       }
       if ((i1 | 0) == (i2 | 0)) {
        i1 = i19;
        break L164;
       }
       i4 = i18 + 4 | 0;
       i2 = HEAP32[i4 >> 2] | 0;
       if (((i2 - (HEAP32[i18 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
        i1 = i19;
        i17 = 223;
        break L6;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4619 | 0, i22 | 0, i2 + -24 | 0);
       i19 = __THREW__;
       __THREW__ = 0;
       if (i19 & 1) {
        i17 = 105;
        break L6;
       }
       i11 = HEAP32[i4 >> 2] | 0;
       i2 = i11 + -24 | 0;
       i3 = i11;
       while (1) {
        if ((i3 | 0) == (i2 | 0)) break;
        i19 = i3 + -24 | 0;
        HEAP32[i4 >> 2] = i19;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i19);
        i3 = HEAP32[i4 >> 2] | 0;
       }
       i10 = i11 + -48 | 0;
       __THREW__ = 0;
       i3 = invoke_iiii(fb + 520 | 0, i22 | 0, 0, gb + 1088095 | 0) | 0;
       i19 = __THREW__;
       __THREW__ = 0;
       if (i19 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i13 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        i2 = 0;
        while (1) {
         if ((i2 | 0) == 3) break;
         HEAP32[i3 + (i2 << 2) >> 2] = 0;
         i2 = i2 + 1 | 0;
        }
        __THREW__ = 0;
        i3 = invoke_iii(fb + 1152 | 0, i13 | 0, gb + 1088120 | 0) | 0;
        i19 = __THREW__;
        __THREW__ = 0;
        if (i19 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i20 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i20 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __THREW__ = 0;
         invoke_vii(fb + 4619 | 0, i12 | 0, (HEAP32[i4 >> 2] | 0) + -24 | 0);
         i19 = __THREW__;
         __THREW__ = 0;
         do if (i19 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          i3 = HEAP8[i12 + 11 >> 0] | 0;
          i19 = i3 << 24 >> 24 < 0;
          __THREW__ = 0;
          i3 = invoke_iiii(fb + 519 | 0, i20 | 0, (i19 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i19 ? HEAP32[i12 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
          i19 = __THREW__;
          __THREW__ = 0;
          if (i19 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
           break;
          };
          HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
          HEAP32[i21 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
          HEAP32[i21 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i3 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          i8 = i10 + 11 | 0;
          do if ((HEAP8[i8 >> 0] | 0) < 0) {
           HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
           HEAP32[i11 + -44 >> 2] = 0;
           i2 = HEAP8[i8 >> 0] | 0;
           if (i2 << 24 >> 24 >= 0) {
            i17 = 58;
            break;
           }
           i9 = 0;
           i6 = (HEAP32[i11 + -40 >> 2] & 2147483647) + -1 | 0;
           i5 = 1;
          } else {
           HEAP8[i10 >> 0] = 0;
           HEAP8[i8 >> 0] = 0;
           i2 = 0;
           i17 = 58;
          } while (0);
          if ((i17 | 0) == 58) {
           i9 = i2 & 255;
           i6 = 10;
           i5 = 0;
          }
          i3 = i9 >>> 0 < 11;
          i7 = i3 ? 10 : (i9 + 16 & 496) + -1 | 0;
          L256 : do if ((i7 | 0) != (i6 | 0)) {
           do if (i3) {
            i3 = HEAP32[i10 >> 2] | 0;
            if (i5) {
             i2 = 0;
             i4 = i10;
             i17 = 66;
            } else {
             i5 = 0;
             i6 = 1;
             i4 = i10;
             i17 = 67;
            }
           } else {
            i4 = _malloc(i7 + 1 | 0) | 0;
            if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L256;
            if (i5) {
             i2 = 1;
             i3 = HEAP32[i10 >> 2] | 0;
             i17 = 66;
             break;
            } else {
             i5 = 1;
             i6 = 0;
             i3 = i10;
             i17 = 67;
             break;
            }
           } while (0);
           if ((i17 | 0) == 66) {
            i5 = i2;
            i6 = 1;
            i2 = HEAP32[i11 + -44 >> 2] | 0;
           } else if ((i17 | 0) == 67) i2 = i2 & 255;
           i2 = i2 + 1 | 0;
           if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
           if (i6) _free(i3);
           if (i5) {
            HEAP32[i11 + -40 >> 2] = i7 + 1 | -2147483648;
            HEAP32[i11 + -44 >> 2] = i9;
            HEAP32[i10 >> 2] = i4;
            break;
           } else {
            HEAP8[i8 >> 0] = i9;
            break;
           }
          } while (0);
          HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
          HEAP32[i10 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
          HEAP32[i10 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i21 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i20);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
          break L164;
         } while (0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i20);
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
       i17 = 106;
       break L6;
      }
     default:
      {
       i2 = __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_(i1, i16) | 0;
       do if ((i2 | 0) == (i1 | 0)) {
        i2 = 3;
        i1 = i19;
       } else {
        __THREW__ = 0;
        i1 = invoke_iiii(fb + 522 | 0, i2 | 0, i16 | 0, i18 | 0) | 0;
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) {
         i17 = 105;
         break L6;
        }
        if ((i1 | 0) == (i2 | 0)) {
         i2 = 0;
         i1 = i19;
        } else {
         i2 = HEAP32[i18 + 4 >> 2] | 0;
         if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
          i2 = 1;
          i1 = i19;
         } else {
          i2 = i2 + -24 | 0;
          if ((HEAP8[i19 + 2 >> 0] | 0) == 118) {
           __THREW__ = 0;
           invoke_iiii(fb + 520 | 0, i2 | 0, 0, gb + 1088125 | 0) | 0;
           i22 = __THREW__;
           __THREW__ = 0;
           if (i22 & 1) {
            i17 = 105;
            break L6;
           } else {
            i2 = 0;
            break;
           }
          } else {
           __THREW__ = 0;
           invoke_iiii(fb + 520 | 0, i2 | 0, 0, gb + 1088143 | 0) | 0;
           i22 = __THREW__;
           __THREW__ = 0;
           if (i22 & 1) {
            i17 = 105;
            break L6;
           } else {
            i2 = 0;
            break;
           }
          }
         }
        }
       } while (0);
       switch (i2 & 3) {
       case 3:
       case 0:
        break L164;
       default:
        {}
       }
       if (!i2) break L164; else {
        i1 = i19;
        i17 = 223;
        break L6;
       }
      }
     }
    } else i1 = i19; while (0);
    i17 = 223;
    break;
   }
  default:
   {
    __THREW__ = 0;
    i1 = invoke_iiii(fb + 523 | 0, i19 | 0, i16 | 0, i18 | 0) | 0;
    i15 = __THREW__;
    __THREW__ = 0;
    if (i15 & 1) i17 = 105; else {
     i13 = HEAP32[i18 + 48 >> 2] | 0;
     i14 = HEAP32[i18 + 52 >> 2] | 0;
     if ((i1 | 0) == (i19 | 0)) {
      i1 = i19;
      i17 = 223;
     } else if ((i1 | 0) == (i16 | 0)) {
      i1 = i16;
      i17 = 223;
     } else {
      switch (HEAP8[i1 >> 0] | 0) {
      case 46:
      case 69:
       {
        i17 = 223;
        break L6;
       }
      default:
       {}
      }
      i15 = HEAP8[i25 >> 0] | 0;
      HEAP8[i25 >> 0] = 0;
      HEAP32[i22 >> 2] = 0;
      HEAP32[i22 + 4 >> 2] = 0;
      HEAP32[i22 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i22 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i12 = i18 + 4 | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      L16 : do if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
       i1 = i19;
       i2 = 0;
      } else {
       i3 = i2 + -24 | 0;
       i6 = HEAP8[i3 + 11 >> 0] | 0;
       i7 = i6 << 24 >> 24 < 0;
       if (i7) i4 = HEAP32[i2 + -20 >> 2] | 0; else i4 = i6 & 255;
       if (!i4) {
        i1 = i19;
        i2 = 0;
       } else {
        L23 : do if (!(HEAP8[i18 + 60 >> 0] | 0)) {
         if (i7) {
          i4 = HEAP32[i3 >> 2] | 0;
          i5 = HEAP32[i2 + -20 >> 2] | 0;
         } else {
          i4 = i3;
          i5 = i6 & 255;
         }
         if ((HEAP8[i4 + i5 + -1 >> 0] | 0) == 62) {
          if (i7) {
           i4 = HEAP32[i2 + -20 >> 2] | 0;
           i5 = HEAP32[i3 >> 2] | 0;
          } else {
           i4 = i6 & 255;
           i5 = i3;
          }
          if ((HEAP8[i5 + (i4 + -2) >> 0] | 0) == 45) i17 = 170; else {
           if (i7) {
            i4 = HEAP32[i2 + -20 >> 2] | 0;
            i3 = HEAP32[i3 >> 2] | 0;
           } else i4 = i6 & 255;
           if ((HEAP8[i3 + (i4 + -2) >> 0] | 0) == 62) i17 = 170; else {
            __THREW__ = 0;
            i10 = invoke_iiii(fb + 521 | 0, i1 | 0, i16 | 0, i18 | 0) | 0;
            i11 = __THREW__;
            __THREW__ = 0;
            if (i11 & 1) i17 = 134; else {
             if ((i10 | 0) == (i1 | 0)) {
              i1 = i19;
              i2 = 0;
              break L16;
             }
             i11 = HEAP32[i12 >> 2] | 0;
             i2 = i11;
             if (((i11 - (HEAP32[i18 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
              i1 = i19;
              i2 = 0;
              break L16;
             }
             i3 = i2 + -24 | 0;
             HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
             HEAP32[i21 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
             HEAP32[i21 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
             i1 = 0;
             while (1) {
              if ((i1 | 0) == 3) break;
              HEAP32[i3 + (i1 << 2) >> 2] = 0;
              i1 = i1 + 1 | 0;
             }
             i8 = i2 + -12 | 0;
             i9 = i22 + 11 | 0;
             do if ((HEAP8[i9 >> 0] | 0) < 0) {
              HEAP8[HEAP32[i22 >> 2] >> 0] = 0;
              HEAP32[i22 + 4 >> 2] = 0;
              i1 = HEAP8[i9 >> 0] | 0;
              if (i1 << 24 >> 24 >= 0) {
               i17 = 143;
               break;
              }
              i7 = 0;
              i5 = (HEAP32[i22 + 8 >> 2] & 2147483647) + -1 | 0;
              i4 = 1;
             } else {
              HEAP8[i22 >> 0] = 0;
              HEAP8[i9 >> 0] = 0;
              i1 = 0;
              i17 = 143;
             } while (0);
             if ((i17 | 0) == 143) {
              i7 = i1 & 255;
              i5 = 10;
              i4 = 0;
             }
             i2 = i7 >>> 0 < 11;
             i6 = i2 ? 10 : (i7 + 16 & 496) + -1 | 0;
             L54 : do if ((i6 | 0) != (i5 | 0)) {
              do if (i2) {
               i2 = HEAP32[i22 >> 2] | 0;
               if (i4) {
                i1 = 0;
                i3 = i22;
                i17 = 150;
               } else {
                i4 = 0;
                i5 = 1;
                i3 = i22;
                i17 = 151;
               }
              } else {
               i3 = _malloc(i6 + 1 | 0) | 0;
               if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L54;
               if (!i4) {
                i4 = 1;
                i5 = 0;
                i2 = i22;
                i17 = 151;
                break;
               }
               i1 = 1;
               i2 = HEAP32[i22 >> 2] | 0;
               i17 = 150;
              } while (0);
              if ((i17 | 0) == 150) {
               i4 = i1;
               i5 = 1;
               i1 = HEAP32[i22 + 4 >> 2] | 0;
              } else if ((i17 | 0) == 151) i1 = i1 & 255;
              i1 = i1 + 1 | 0;
              if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
              if (i5) _free(i2);
              if (i4) {
               HEAP32[i22 + 8 >> 2] = i6 + 1 | -2147483648;
               HEAP32[i22 + 4 >> 2] = i7;
               HEAP32[i22 >> 2] = i3;
               break;
              } else {
               HEAP8[i9 >> 0] = i7;
               break;
              }
             } while (0);
             HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
             HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
             HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
             i1 = 0;
             while (1) {
              if ((i1 | 0) == 3) break;
              HEAP32[i8 + (i1 << 2) >> 2] = 0;
              i1 = i1 + 1 | 0;
             }
             i11 = HEAP8[i9 >> 0] | 0;
             if (!((i11 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i11 & 255) | 0)) {
              __THREW__ = 0;
              invoke_vii(fb + 4620 | 0, i21 | 0, 32);
              i11 = __THREW__;
              __THREW__ = 0;
              if (!(i11 & 1)) i17 = 165;
             } else i17 = 165;
             do if ((i17 | 0) == 165) {
              i1 = HEAP32[i12 >> 2] | 0;
              i2 = i1 + -24 | 0;
              i3 = i1;
              while (1) {
               if ((i3 | 0) == (i2 | 0)) break;
               i11 = i3 + -24 | 0;
               HEAP32[i12 >> 2] = i11;
               __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
               i3 = HEAP32[i12 >> 2] | 0;
              }
              i11 = HEAP8[i21 + 11 >> 0] | 0;
              i9 = i11 << 24 >> 24 < 0;
              __THREW__ = 0;
              invoke_iiiii(fb + 216 | 0, i1 + -48 | 0, 0, (i9 ? HEAP32[i21 >> 2] | 0 : i21) | 0, (i9 ? HEAP32[i21 + 4 >> 2] | 0 : i11 & 255) | 0) | 0;
              i11 = __THREW__;
              __THREW__ = 0;
              if (i11 & 1) break;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
              i1 = i10;
              i2 = HEAP32[i12 >> 2] | 0;
              i17 = 170;
              break L23;
             } while (0);
             i1 = ___cxa_find_matching_catch_2() | 0;
             getTempRet0() | 0;
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
            }
           }
          }
         } else i17 = 170;
        } else i17 = 170; while (0);
        L89 : do if ((i17 | 0) == 170) {
         __THREW__ = 0;
         invoke_vii(fb + 4620 | 0, i2 + -24 | 0, 40);
         i11 = __THREW__;
         __THREW__ = 0;
         if (i11 & 1) i17 = 134; else {
          if ((i1 | 0) == (i16 | 0)) i17 = 173; else if ((HEAP8[i1 >> 0] | 0) == 118) {
           i1 = i1 + 1 | 0;
           i3 = HEAP32[i18 >> 2] | 0;
           i2 = HEAP32[i12 >> 2] | 0;
          } else i17 = 173;
          do if ((i17 | 0) == 173) {
           i8 = i21 + 11 | 0;
           i9 = i21 + 4 | 0;
           i10 = i20 + 11 | 0;
           i11 = i20 + 4 | 0;
           i6 = 1;
           L97 : while (1) {
            i2 = HEAP32[i12 >> 2] | 0;
            i3 = HEAP32[i18 >> 2] | 0;
            while (1) {
             i4 = (i2 - i3 | 0) / 24 | 0;
             __THREW__ = 0;
             i7 = invoke_iiii(fb + 521 | 0, i1 | 0, i16 | 0, i18 | 0) | 0;
             i17 = __THREW__;
             __THREW__ = 0;
             if (i17 & 1) {
              i17 = 177;
              break L97;
             }
             i2 = HEAP32[i12 >> 2] | 0;
             i3 = HEAP32[i18 >> 2] | 0;
             i5 = (i2 - i3 | 0) / 24 | 0;
             if ((i7 | 0) == (i1 | 0)) {
              i17 = 207;
              break L97;
             }
             if (i5 >>> 0 > i4 >>> 0) break; else i1 = i7;
            }
            HEAP32[i21 >> 2] = 0;
            HEAP32[i21 + 4 >> 2] = 0;
            HEAP32[i21 + 8 >> 2] = 0;
            i1 = 0;
            while (1) {
             if ((i1 | 0) == 3) {
              i1 = i4;
              break;
             }
             HEAP32[i21 + (i1 << 2) >> 2] = 0;
             i1 = i1 + 1 | 0;
            }
            while (1) {
             if (i1 >>> 0 >= i5 >>> 0) {
              i1 = i4;
              break;
             }
             i17 = HEAP8[i8 >> 0] | 0;
             if ((i17 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i17 & 255) | 0) {
              __THREW__ = 0;
              invoke_iii(fb + 1152 | 0, i21 | 0, gb + 1086385 | 0) | 0;
              i17 = __THREW__;
              __THREW__ = 0;
              if (i17 & 1) {
               i17 = 185;
               break L97;
              }
             }
             __THREW__ = 0;
             invoke_vii(fb + 4619 | 0, i20 | 0, (HEAP32[i18 >> 2] | 0) + (i1 * 24 | 0) | 0);
             i17 = __THREW__;
             __THREW__ = 0;
             if (i17 & 1) {
              i17 = 189;
              break L97;
             }
             i17 = HEAP8[i10 >> 0] | 0;
             i3 = i17 << 24 >> 24 < 0;
             __THREW__ = 0;
             invoke_iiii(fb + 519 | 0, i21 | 0, (i3 ? HEAP32[i20 >> 2] | 0 : i20) | 0, (i3 ? HEAP32[i11 >> 2] | 0 : i17 & 255) | 0) | 0;
             i17 = __THREW__;
             __THREW__ = 0;
             if (i17 & 1) {
              i17 = 190;
              break L97;
             }
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i20);
             i1 = i1 + 1 | 0;
            }
            while (1) {
             if (i1 >>> 0 >= i5 >>> 0) break;
             i3 = HEAP32[i12 >> 2] | 0;
             i2 = i3 + -24 | 0;
             while (1) {
              if ((i3 | 0) == (i2 | 0)) break;
              i17 = i3 + -24 | 0;
              HEAP32[i12 >> 2] = i17;
              __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i17);
              i3 = HEAP32[i12 >> 2] | 0;
             }
             i1 = i1 + 1 | 0;
            }
            i3 = HEAP8[i8 >> 0] | 0;
            i1 = HEAP32[i9 >> 2] | 0;
            if (!((i3 << 24 >> 24 < 0 ? i1 : i3 & 255) | 0)) i1 = i6; else {
             i2 = HEAP32[i12 >> 2] | 0;
             if ((HEAP32[i18 >> 2] | 0) == (i2 | 0)) {
              i17 = 220;
              break;
             }
             if (!i6) {
              __THREW__ = 0;
              invoke_iii(fb + 1152 | 0, i2 + -24 | 0, gb + 1086385 | 0) | 0;
              i17 = __THREW__;
              __THREW__ = 0;
              if (i17 & 1) {
               i17 = 202;
               break;
              }
              i2 = HEAP32[i12 >> 2] | 0;
              i3 = HEAP8[i8 >> 0] | 0;
              i1 = HEAP32[i9 >> 2] | 0;
             }
             i17 = i3 << 24 >> 24 < 0;
             __THREW__ = 0;
             invoke_iiii(fb + 519 | 0, i2 + -24 | 0, (i17 ? HEAP32[i21 >> 2] | 0 : i21) | 0, (i17 ? i1 : i3 & 255) | 0) | 0;
             i17 = __THREW__;
             __THREW__ = 0;
             if (i17 & 1) {
              i17 = 202;
              break;
             } else i1 = 0;
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
            i6 = i1;
            i1 = i7;
           }
           if ((i17 | 0) == 177) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            break L89;
           } else if ((i17 | 0) == 185) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else if ((i17 | 0) == 189) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            i17 = 191;
           } else if ((i17 | 0) == 190) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i20);
            i17 = 191;
           } else if ((i17 | 0) == 202) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
           } else if ((i17 | 0) == 207) break; else if ((i17 | 0) == 220) {
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
            i1 = i19;
            i2 = 0;
            break L16;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i21);
           break L89;
          } while (0);
          if ((i3 | 0) == (i2 | 0)) {
           i1 = i19;
           i2 = 0;
           break L16;
          }
          __THREW__ = 0;
          invoke_vii(fb + 4620 | 0, i2 + -24 | 0, 41);
          i21 = __THREW__;
          __THREW__ = 0;
          if (i21 & 1) i17 = 134; else {
           if (i13 & 1 | 0) {
            __THREW__ = 0;
            invoke_iii(fb + 1152 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086338 | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            if (i21 & 1) {
             i17 = 134;
             break;
            }
           }
           if (i13 & 2 | 0) {
            __THREW__ = 0;
            invoke_iii(fb + 1152 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086345 | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            if (i21 & 1) {
             i17 = 134;
             break;
            }
           }
           if (i13 & 4 | 0) {
            __THREW__ = 0;
            invoke_iii(fb + 1152 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086355 | 0) | 0;
            i21 = __THREW__;
            __THREW__ = 0;
            if (i21 & 1) {
             i17 = 134;
             break;
            }
           }
           switch (i14 | 0) {
           case 1:
            {
             __THREW__ = 0;
             invoke_iii(fb + 1152 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086388 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i17 = 134;
              break L89;
             }
             break;
            }
           case 2:
            {
             __THREW__ = 0;
             invoke_iii(fb + 1152 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, gb + 1086391 | 0) | 0;
             i21 = __THREW__;
             __THREW__ = 0;
             if (i21 & 1) {
              i17 = 134;
              break L89;
             }
             break;
            }
           default:
            {}
           }
           i21 = HEAP8[i22 + 11 >> 0] | 0;
           i20 = i21 << 24 >> 24 < 0;
           __THREW__ = 0;
           invoke_iiii(fb + 519 | 0, (HEAP32[i12 >> 2] | 0) + -24 | 0, (i20 ? HEAP32[i22 >> 2] | 0 : i22) | 0, (i20 ? HEAP32[i22 + 4 >> 2] | 0 : i21 & 255) | 0) | 0;
           i21 = __THREW__;
           __THREW__ = 0;
           if (i21 & 1) i17 = 134; else {
            i2 = 1;
            break L16;
           }
          }
         }
        } while (0);
        if ((i17 | 0) == 134) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
        HEAP8[i25 >> 0] = i15;
        break L6;
       }
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i22);
      HEAP8[i25 >> 0] = i15;
      if (i2) i17 = 223; else {
       HEAP8[i25 >> 0] = i26;
       HEAP32[i27 >> 2] = i24;
       i1 = i19;
       break L1;
      }
     }
    }
   }
  } while (0);
  if ((i17 | 0) == 105) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i17 = 106;
  } else if ((i17 | 0) == 223) {
   HEAP8[i25 >> 0] = i26;
   HEAP32[i27 >> 2] = i24;
   break;
  }
  HEAP8[i25 >> 0] = i26;
  HEAP32[i27 >> 2] = i24;
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i23;
 return i1 | 0;
}
function __ZN5physx13PxsCCDContext9updateCCDEfPNS_10PxBaseTaskEb(i107, f10, i101, i1) {
 i107 = i107 | 0;
 f10 = Math_fround(f10);
 i101 = i101 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i108 = 0, f109 = f0;
 i108 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i103 = i108 + 211 | 0;
 i82 = i108 + 200 | 0;
 i91 = i108 + 172 | 0;
 i87 = i108 + 144 | 0;
 i89 = i108 + 132 | 0;
 i85 = i108 + 120 | 0;
 i83 = i108 + 112 | 0;
 i92 = i108 + 84 | 0;
 i88 = i108 + 56 | 0;
 i90 = i108 + 44 | 0;
 i86 = i108 + 32 | 0;
 i95 = i108 + 28 | 0;
 i106 = i108 + 16 | 0;
 i97 = i108 + 208 | 0;
 i105 = i108 + 4 | 0;
 i98 = i108;
 i102 = i108 + 210 | 0;
 HEAP8[i107 + 88 >> 0] = i1 & 1;
 i104 = i107 + 264 | 0;
 i96 = HEAP32[i104 >> 2] | 0;
 i94 = i96 + 5864 | 0;
 HEAP32[i96 + 5868 >> 2] = 0;
 _memset(HEAP32[i96 + 1344 >> 2] | 0, 0, HEAP32[i96 + 1348 >> 2] << 2 | 0) | 0;
 HEAP32[i96 + 1356 >> 2] = 0;
 HEAP32[i96 + 1360 >> 2] = 0;
 HEAP32[i96 + 1364 >> 2] = 0;
 i81 = i107 + 92 | 0;
 if (!(HEAP32[i81 >> 2] | 0)) i93 = 3; else {
  i1 = i107 + 96 | 0;
  if (HEAP32[i1 >> 2] | 0) i93 = 3;
 }
 if ((i93 | 0) == 3) {
  i2 = HEAP32[i104 >> 2] | 0;
  i1 = i107 + 96 | 0;
  if (HEAP32[i2 + 7608 >> 2] | 0) {
   HEAP32[i1 >> 2] = 0;
   i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
   if (!i1) {
    i100 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i99 = HEAP32[(HEAP32[i100 >> 2] | 0) + 8 >> 2] | 0;
    i1 = _PxGetFoundation() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
    i1 = mftCall_iiiiii(i99 | 0, i100 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
    if (!i1) i1 = 0; else {
     i100 = i1 + 19 & -16;
     HEAP32[i100 + -4 >> 2] = i100 - i1;
     i1 = i100;
    }
    __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
   }
   i80 = i107 + 252 | 0;
   HEAP32[i80 >> 2] = i1;
   HEAPF32[i1 + 8752 >> 2] = f10;
   i84 = i107 + 212 | 0;
   i79 = i107 + 224 | 0;
   HEAP32[i79 >> 2] = 0;
   HEAP32[(HEAP32[i84 >> 2] | 0) + 4 >> 2] = 0;
   i100 = i107 + 228 | 0;
   i99 = i107 + 232 | 0;
   HEAP32[i99 >> 2] = 0;
   i76 = i107 + 116 | 0;
   HEAP32[i107 + 128 >> 2] = 0;
   HEAP32[(HEAP32[i76 >> 2] | 0) + 4 >> 2] = 0;
   i6 = HEAP32[i104 >> 2] | 0;
   i77 = i6 + 1332 | 0;
   i78 = i6 + 1336 | 0;
   i4 = HEAP32[i78 >> 2] & 2147483647;
   L12 : do if (i4 | 0) {
    i3 = HEAP32[i77 >> 2] | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
     if (i2 | 0) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L12;
    }
    i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
    i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i1 << 5;
    i2 = i2 + -1 & i2;
    L18 : do if (!i2) do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) {
      i2 = 0;
      break L18;
     }
     i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0); while (0);
    if ((i5 | 0) != -1) {
     i69 = i107 + 192 | 0;
     i70 = i107 + 132 | 0;
     i71 = i82 + 4 | 0;
     i72 = i107 + 172 | 0;
     i73 = i87 + 4 | 0;
     i74 = i91 + 4 | 0;
     i75 = i87 + 8 | 0;
     i34 = i91 + 8 | 0;
     i35 = i87 + 12 | 0;
     i36 = i91 + 12 | 0;
     i37 = i87 + 16 | 0;
     i38 = i91 + 16 | 0;
     i39 = i87 + 20 | 0;
     i40 = i91 + 20 | 0;
     i41 = i87 + 24 | 0;
     i42 = i91 + 24 | 0;
     i43 = i89 + 4 | 0;
     i44 = i89 + 8 | 0;
     i45 = i85 + 4 | 0;
     i46 = i85 + 8 | 0;
     i47 = i83 + 4 | 0;
     i48 = i88 + 4 | 0;
     i49 = i92 + 4 | 0;
     i50 = i88 + 8 | 0;
     i51 = i92 + 8 | 0;
     i52 = i88 + 12 | 0;
     i53 = i92 + 12 | 0;
     i54 = i88 + 16 | 0;
     i55 = i92 + 16 | 0;
     i56 = i88 + 20 | 0;
     i57 = i92 + 20 | 0;
     i58 = i88 + 24 | 0;
     i59 = i92 + 24 | 0;
     i60 = i90 + 4 | 0;
     i61 = i90 + 8 | 0;
     i62 = i86 + 4 | 0;
     i63 = i86 + 8 | 0;
     i64 = i107 + 100 | 0;
     i65 = i107 + 112 | 0;
     i66 = i107 + 184 | 0;
     i67 = i107 + 176 | 0;
     i68 = i107 + 180 | 0;
     i3 = i1;
     i4 = i6;
     i1 = 0;
     L24 : while (1) {
      i33 = i3 << 5;
      while (1) {
       i32 = HEAP32[(HEAP32[i4 + 720 >> 2] | 0) + (i5 >>> (HEAP32[i4 + 708 >> 2] | 0) << 2) >> 2] | 0;
       i29 = (HEAP32[i4 + 696 >> 2] | 0) + -1 & i5;
       i30 = i32 + (i29 << 7) | 0;
       i31 = i32 + (i29 << 7) + 8 | 0;
       i5 = HEAP32[i31 >> 2] | 0;
       do if (i5 & 2) if ((HEAP8[i32 + (i29 << 7) + 35 >> 0] | 0) != 1) {
        if (!(HEAP32[i81 >> 2] | 0)) {
         HEAP32[i31 >> 2] = i5 & -5;
         HEAP32[i32 + (i29 << 7) + 40 >> 2] = 0;
        }
        if ((HEAP16[i32 + (i29 << 7) + 38 >> 1] & 24) != 24) {
         i16 = HEAP32[i32 + (i29 << 7) + 80 >> 2] | 0;
         i17 = HEAP32[i32 + (i29 << 7) + 84 >> 2] | 0;
         i14 = HEAP32[i32 + (i29 << 7) + 88 >> 2] | 0;
         i15 = HEAP32[i32 + (i29 << 7) + 92 >> 2] | 0;
         i18 = HEAP32[i30 >> 2] | 0;
         i28 = HEAP32[i32 + (i29 << 7) + 4 >> 2] | 0;
         i4 = HEAP32[i69 >> 2] | 0;
         do if (!i4) {
          i12 = 0;
          i93 = 43;
         } else {
          i6 = i14 + ~(i14 << 15) | 0;
          i6 = (i6 >>> 10 ^ i6) * 9 | 0;
          i6 = i6 >>> 6 ^ i6;
          i6 = i6 + ~(i6 << 11) | 0;
          i5 = i16 + ~(i16 << 15) | 0;
          i5 = (i5 >>> 10 ^ i5) * 9 | 0;
          i5 = i5 >>> 6 ^ i5;
          i5 = i5 + ~(i5 << 11) | 0;
          i8 = i4 + -1 | 0;
          i9 = HEAP32[i66 >> 2] | 0;
          i4 = HEAP32[i9 + (((i6 >>> 16 ^ i6 ^ (i5 ^ -57320555 ^ i5 >>> 16) * 1000007) & i8) << 2) >> 2] | 0;
          i5 = i16;
          i6 = i14;
          L37 : do if ((i4 | 0) == -1) i11 = 0; else {
           i7 = HEAP32[i67 >> 2] | 0;
           while (1) {
            if ((HEAP32[i7 + (i4 * 12 | 0) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i7 + (i4 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) break;
            i4 = HEAP32[(HEAP32[i68 >> 2] | 0) + (i4 << 2) >> 2] | 0;
            if ((i4 | 0) == -1) {
             i11 = 0;
             break L37;
            }
           }
           i11 = i7 + (i4 * 12 | 0) | 0;
          } while (0);
          i5 = i15 + ~(i15 << 15) | 0;
          i5 = (i5 >>> 10 ^ i5) * 9 | 0;
          i5 = i5 >>> 6 ^ i5;
          i5 = i5 + ~(i5 << 11) | 0;
          i4 = i17 + ~(i17 << 15) | 0;
          i4 = (i4 >>> 10 ^ i4) * 9 | 0;
          i4 = i4 >>> 6 ^ i4;
          i4 = i4 + ~(i4 << 11) | 0;
          i4 = HEAP32[i9 + ((i8 & (i5 >>> 16 ^ i5 ^ (i4 ^ -57320555 ^ i4 >>> 16) * 1000007)) << 2) >> 2] | 0;
          i5 = i17;
          i6 = i15;
          L46 : do if ((i4 | 0) == -1) i4 = 0; else {
           i7 = HEAP32[i67 >> 2] | 0;
           while (1) {
            if ((HEAP32[i7 + (i4 * 12 | 0) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i7 + (i4 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) break;
            i4 = HEAP32[(HEAP32[i68 >> 2] | 0) + (i4 << 2) >> 2] | 0;
            if ((i4 | 0) == -1) {
             i4 = 0;
             break L46;
            }
           }
           i4 = i7 + (i4 * 12 | 0) | 0;
          } while (0);
          if (!i11) i5 = 0; else i5 = HEAP32[i11 + 8 >> 2] | 0;
          if (!i4) i4 = 0; else i4 = HEAP32[i4 + 8 >> 2] | 0;
          if (!i5) {
           i12 = i4;
           i93 = 43;
           break;
          }
          f24 = Math_fround(HEAPF32[i5 + 8 >> 2]);
          f27 = Math_fround(HEAPF32[i5 + 56 >> 2]);
          f27 = Math_fround(f27 - Math_fround(HEAPF32[i5 + 28 >> 2]));
          f26 = Math_fround(HEAPF32[i5 + 60 >> 2]);
          f26 = Math_fround(f26 - Math_fround(HEAPF32[i5 + 32 >> 2]));
          f25 = Math_fround(HEAPF32[i5 + 64 >> 2]);
          f25 = Math_fround(f25 - Math_fround(HEAPF32[i5 + 36 >> 2]));
          i13 = i5;
         } while (0);
         if ((i93 | 0) == 43) {
          i93 = 0;
          i13 = __ZN5physx16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE8pushBackEv(i70) | 0;
          HEAP32[i82 >> 2] = i16;
          HEAP32[i71 >> 2] = i14;
          i4 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE6createERSB_Rb(i72, i82, i103) | 0;
          if (!(HEAP8[i103 >> 0] | 0)) {
           HEAP32[i4 >> 2] = i16;
           HEAP32[i4 + 4 >> 2] = i14;
           HEAP32[i4 + 8 >> 2] = i13;
          }
          HEAP32[i13 + 4 >> 2] = i16;
          HEAP32[i13 >> 2] = i14;
          __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE(i91, i13, i18);
          if (!i18) {
           i4 = HEAP32[i91 >> 2] | 0;
           HEAP32[i87 >> 2] = i4;
           i5 = HEAP32[i74 >> 2] | 0;
           HEAP32[i73 >> 2] = i5;
           i6 = HEAP32[i34 >> 2] | 0;
           HEAP32[i75 >> 2] = i6;
           i7 = HEAP32[i36 >> 2] | 0;
           HEAP32[i35 >> 2] = i7;
           i8 = HEAP32[i38 >> 2] | 0;
           HEAP32[i37 >> 2] = i8;
           i9 = HEAP32[i40 >> 2] | 0;
           HEAP32[i39 >> 2] = i9;
           i11 = HEAP32[i42 >> 2] | 0;
           HEAP32[i41 >> 2] = i11;
           f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f21 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f23 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f10 = f19;
           f20 = f21;
           f22 = f23;
          } else {
           __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE(i87, i13, i18);
           f10 = Math_fround(HEAPF32[i38 >> 2]);
           f19 = Math_fround(HEAPF32[i37 >> 2]);
           f20 = Math_fround(HEAPF32[i40 >> 2]);
           f21 = Math_fround(HEAPF32[i39 >> 2]);
           f22 = Math_fround(HEAPF32[i42 >> 2]);
           f27 = Math_fround(HEAPF32[i41 >> 2]);
           i8 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
           i9 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
           f23 = f27;
           i4 = HEAP32[i87 >> 2] | 0;
           i5 = HEAP32[i73 >> 2] | 0;
           i6 = HEAP32[i75 >> 2] | 0;
           i7 = HEAP32[i35 >> 2] | 0;
           i11 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
          }
          f27 = Math_fround(f10 - f19);
          f26 = Math_fround(f20 - f21);
          f25 = Math_fround(f22 - f23);
          f24 = Math_fround(__ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E(i14 + 36 | 0, i89, i85, i91, 0));
          f21 = Math_fround(Math_fround(HEAPF32[i89 >> 2]) - f27);
          f22 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f26);
          f23 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f25);
          HEAPF32[i13 + 80 >> 2] = f21;
          HEAPF32[i13 + 84 >> 2] = f22;
          HEAPF32[i13 + 88 >> 2] = f23;
          HEAP32[i13 + 68 >> 2] = HEAP32[i85 >> 2];
          HEAP32[i13 + 72 >> 2] = HEAP32[i45 >> 2];
          HEAP32[i13 + 76 >> 2] = HEAP32[i46 >> 2];
          HEAPF32[i13 + 8 >> 2] = f24;
          HEAP32[i13 + 12 >> 2] = i4;
          HEAP32[i13 + 16 >> 2] = i5;
          HEAP32[i13 + 20 >> 2] = i6;
          HEAP32[i13 + 24 >> 2] = i7;
          HEAP32[i13 + 28 >> 2] = i8;
          HEAP32[i13 + 32 >> 2] = i9;
          HEAP32[i13 + 36 >> 2] = i11;
          HEAP32[i13 + 40 >> 2] = HEAP32[i91 >> 2];
          HEAP32[i13 + 44 >> 2] = HEAP32[i74 >> 2];
          HEAP32[i13 + 48 >> 2] = HEAP32[i34 >> 2];
          HEAP32[i13 + 52 >> 2] = HEAP32[i36 >> 2];
          HEAP32[i13 + 56 >> 2] = HEAP32[i38 >> 2];
          HEAP32[i13 + 60 >> 2] = HEAP32[i40 >> 2];
          HEAP32[i13 + 64 >> 2] = HEAP32[i42 >> 2];
          HEAP32[i13 + 92 >> 2] = 0;
          i4 = i12;
         }
         if (!i4) {
          i4 = __ZN5physx16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE8pushBackEv(i70) | 0;
          HEAP32[i4 + 4 >> 2] = i17;
          HEAP32[i4 >> 2] = i15;
          HEAP32[i83 >> 2] = i17;
          HEAP32[i47 >> 2] = i15;
          i5 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE6createERSB_Rb(i72, i83, i103) | 0;
          if (!(HEAP8[i103 >> 0] | 0)) {
           HEAP32[i5 >> 2] = i17;
           HEAP32[i5 + 4 >> 2] = i15;
           HEAP32[i5 + 8 >> 2] = i4;
          }
          __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE(i92, i4, i28);
          if (!i28) {
           i5 = HEAP32[i92 >> 2] | 0;
           HEAP32[i88 >> 2] = i5;
           i6 = HEAP32[i49 >> 2] | 0;
           HEAP32[i48 >> 2] = i6;
           i7 = HEAP32[i51 >> 2] | 0;
           HEAP32[i50 >> 2] = i7;
           i8 = HEAP32[i53 >> 2] | 0;
           HEAP32[i52 >> 2] = i8;
           i9 = HEAP32[i55 >> 2] | 0;
           HEAP32[i54 >> 2] = i9;
           i11 = HEAP32[i57 >> 2] | 0;
           HEAP32[i56 >> 2] = i11;
           i12 = HEAP32[i59 >> 2] | 0;
           HEAP32[i58 >> 2] = i12;
           f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f21 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f23 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
           f10 = f19;
           f20 = f21;
           f22 = f23;
          } else {
           __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE(i88, i4, i28);
           f10 = Math_fround(HEAPF32[i55 >> 2]);
           f19 = Math_fround(HEAPF32[i54 >> 2]);
           f20 = Math_fround(HEAPF32[i57 >> 2]);
           f21 = Math_fround(HEAPF32[i56 >> 2]);
           f22 = Math_fround(HEAPF32[i59 >> 2]);
           f109 = Math_fround(HEAPF32[i58 >> 2]);
           i9 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
           i11 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
           f23 = f109;
           i5 = HEAP32[i88 >> 2] | 0;
           i6 = HEAP32[i48 >> 2] | 0;
           i7 = HEAP32[i50 >> 2] | 0;
           i8 = HEAP32[i52 >> 2] | 0;
           i12 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
          }
          f109 = Math_fround(f10 - f19);
          f20 = Math_fround(f20 - f21);
          f19 = Math_fround(f22 - f23);
          f10 = Math_fround(__ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E(i15 + 36 | 0, i90, i86, i92, 0));
          f22 = Math_fround(Math_fround(HEAPF32[i90 >> 2]) - f109);
          f23 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f20);
          f21 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f19);
          HEAPF32[i4 + 80 >> 2] = f22;
          HEAPF32[i4 + 84 >> 2] = f23;
          HEAPF32[i4 + 88 >> 2] = f21;
          HEAP32[i4 + 68 >> 2] = HEAP32[i86 >> 2];
          HEAP32[i4 + 72 >> 2] = HEAP32[i62 >> 2];
          HEAP32[i4 + 76 >> 2] = HEAP32[i63 >> 2];
          HEAPF32[i4 + 8 >> 2] = f10;
          HEAP32[i4 + 12 >> 2] = i5;
          HEAP32[i4 + 16 >> 2] = i6;
          HEAP32[i4 + 20 >> 2] = i7;
          HEAP32[i4 + 24 >> 2] = i8;
          HEAP32[i4 + 28 >> 2] = i9;
          HEAP32[i4 + 32 >> 2] = i11;
          HEAP32[i4 + 36 >> 2] = i12;
          HEAP32[i4 + 40 >> 2] = HEAP32[i92 >> 2];
          HEAP32[i4 + 44 >> 2] = HEAP32[i49 >> 2];
          HEAP32[i4 + 48 >> 2] = HEAP32[i51 >> 2];
          HEAP32[i4 + 52 >> 2] = HEAP32[i53 >> 2];
          HEAP32[i4 + 56 >> 2] = HEAP32[i55 >> 2];
          HEAP32[i4 + 60 >> 2] = HEAP32[i57 >> 2];
          HEAP32[i4 + 64 >> 2] = HEAP32[i59 >> 2];
          HEAP32[i4 + 92 >> 2] = 0;
          f21 = f109;
         } else {
          f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
          f21 = Math_fround(HEAPF32[i4 + 56 >> 2]);
          f21 = Math_fround(f21 - Math_fround(HEAPF32[i4 + 28 >> 2]));
          f20 = Math_fround(HEAPF32[i4 + 60 >> 2]);
          f20 = Math_fround(f20 - Math_fround(HEAPF32[i4 + 32 >> 2]));
          f19 = Math_fround(HEAPF32[i4 + 64 >> 2]);
          f19 = Math_fround(f19 - Math_fround(HEAPF32[i4 + 36 >> 2]));
         }
         if (i18 | 0) {
          i6 = i18 + 60 | 0;
          i5 = HEAP32[i6 >> 2] | 0;
          if (!i5) {
           i5 = __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE8pushBackEv(i64) | 0;
           HEAP32[i6 >> 2] = i5;
           i15 = HEAP32[i65 >> 2] | 0;
           HEAP16[i5 >> 1] = (i15 << 7) + 65535 + (HEAP32[(HEAP32[i64 >> 2] | 0) + (i15 << 3) + 4 >> 2] | 0);
           HEAP32[i5 + 8 >> 2] = i18;
           HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
           HEAP32[i5 + 12 >> 2] = 0;
           HEAP32[i5 + 16 >> 2] = 0;
          }
          HEAP16[i5 + 2 >> 1] = 0;
         }
         L89 : do if (i28 | 0) {
          i6 = i28 + 60 | 0;
          i5 = HEAP32[i6 >> 2] | 0;
          if (!i5) {
           i5 = __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE8pushBackEv(i64) | 0;
           HEAP32[i6 >> 2] = i5;
           i15 = HEAP32[i65 >> 2] | 0;
           HEAP16[i5 >> 1] = (i15 << 7) + 65535 + (HEAP32[(HEAP32[i64 >> 2] | 0) + (i15 << 3) + 4 >> 2] | 0);
           HEAP32[i5 + 8 >> 2] = i28;
           HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
           HEAP32[i5 + 12 >> 2] = 0;
           HEAP32[i5 + 16 >> 2] = 0;
          }
          HEAP16[i5 + 2 >> 1] = 0;
          if (!i18) break;
          if (Math_fround(HEAPF32[(HEAP32[i18 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) break;
          if (Math_fround(HEAPF32[(HEAP32[i28 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) break;
          i6 = i18 + 60 | 0;
          i7 = i28 + 60 | 0;
          i8 = HEAP32[i7 >> 2] | 0;
          i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
          if (i5 | 0) do {
           if ((HEAP32[i5 >> 2] | 0) == (i8 | 0)) break L89;
           i5 = HEAP32[i5 + 4 >> 2] | 0;
          } while ((i5 | 0) != 0);
          i11 = __ZN5physx16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE8pushBackEv(i76) | 0;
          i14 = __ZN5physx16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE8pushBackEv(i76) | 0;
          i15 = HEAP32[i7 >> 2] | 0;
          HEAP32[i11 >> 2] = i15;
          i12 = HEAP32[i6 >> 2] | 0;
          HEAP32[i14 >> 2] = i12;
          i12 = i12 + 12 | 0;
          HEAP32[i11 + 4 >> 2] = HEAP32[i12 >> 2];
          HEAP32[i12 >> 2] = i11;
          i15 = i15 + 12 | 0;
          HEAP32[i14 + 4 >> 2] = HEAP32[i15 >> 2];
          HEAP32[i15 >> 2] = i14;
         } while (0);
         i5 = __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE8pushBackEv(i84) | 0;
         HEAP32[i5 >> 2] = i18;
         HEAP32[i5 + 4 >> 2] = i28;
         HEAP32[i5 + 8 >> 2] = i13;
         HEAP32[i5 + 12 >> 2] = i4;
         if (!(HEAP8[i16 + 28 >> 0] & 8)) i4 = (HEAP8[i17 + 28 >> 0] & 8) != 0; else i4 = 1;
         HEAP8[i5 + 104 >> 0] = i4 & 1;
         HEAPF32[i5 + 28 >> 2] = Math_fround(3402823469999999843913219.0e14);
         i18 = HEAP8[i32 + (i29 << 7) + 112 >> 0] | 0;
         i28 = i18 & 255;
         HEAP32[i5 + 60 >> 2] = i28;
         i4 = HEAP8[i32 + (i29 << 7) + 113 >> 0] | 0;
         i32 = i4 & 255;
         HEAP32[i5 + 64 >> 2] = i32;
         HEAP32[i5 + 52 >> 2] = i30;
         HEAP32[i5 + 56 >> 2] = -1;
         HEAP8[i5 + 68 >> 0] = 0;
         HEAP32[i5 + 72 >> 2] = -1;
         HEAP8[i5 + 69 >> 0] = HEAP32[i31 >> 2] & 1;
         HEAPF32[i5 + 96 >> 2] = Math_fround(0.0);
         i31 = (i18 & 255) < (i4 & 255);
         i4 = HEAP32[i104 >> 2] | 0;
         i32 = i4 + 7176 + ((i31 ? i28 : i32) * 28 | 0) + ((i31 ? i32 : i28) << 2) | 0;
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         f10 = Math_fround(f24 + f10);
         if (i1) {
          i1 = 1;
          break;
         }
         f109 = Math_fround(f27 - f21);
         f27 = Math_fround(f26 - f20);
         f26 = Math_fround(f25 - f19);
         i1 = Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f27 * f27) + Math_fround(f109 * f109))) >= Math_fround(f10 * f10);
        }
       } while (0);
       if (!i2) {
        i93 = 74;
        break L24;
       }
       i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
       i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i33;
       i2 = i2 + -1 & i2;
       if (!i2) {
        i6 = i4;
        break;
       }
       if ((i5 | 0) == -1) {
        i93 = 80;
        break L24;
       }
      }
      i4 = HEAP32[i78 >> 2] & 2147483647;
      i2 = i3;
      while (1) {
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 >= i4 >>> 0) {
        i2 = 0;
        break;
       }
       i2 = HEAP32[(HEAP32[i77 >> 2] | 0) + (i3 << 2) >> 2] | 0;
       if (!i2) i2 = i3; else break;
      }
      if ((i5 | 0) == -1) {
       i93 = 80;
       break;
      } else i4 = i6;
     }
     if ((i93 | 0) == 74) {
      if (!i1) break;
     } else if ((i93 | 0) == 80) if (!i1) break;
     i1 = HEAP32[i79 >> 2] | 0;
     i2 = HEAP32[(HEAP32[i84 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
     i5 = i2 + (i1 << 7) | 0;
     i6 = i107 + 236 | 0;
     if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i100, i5);
     if (i5 | 0) {
      i1 = i2 + (i1 << 7) | 0;
      i4 = 0;
      do {
       i2 = (HEAP32[(HEAP32[i84 >> 2] | 0) + (i4 >>> 7 << 3) >> 2] | 0) + ((i4 & 127) * 108 | 0) | 0;
       HEAP32[i95 >> 2] = i2;
       i3 = HEAP32[i99 >> 2] | 0;
       if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
        HEAP32[(HEAP32[i100 >> 2] | 0) + (i3 << 2) >> 2] = i2;
        HEAP32[i99 >> 2] = i3 + 1;
       } else __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i100, i95) | 0;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i1 | 0));
     }
     i1 = i5 >>> 1 | i5;
     i1 = i1 >>> 2 | i1;
     i1 = i1 >>> 4 | i1;
     i1 = i1 >>> 8 | i1;
     i1 = (i1 >>> 16 | i1) + 1 | 0;
     if ((HEAP32[i96 + 5872 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i94, i1);
     i13 = i107 + 112 | 0;
     i4 = HEAP32[i13 >> 2] | 0;
     i16 = i107 + 100 | 0;
     i5 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
     i14 = i5 + (i4 << 7) | 0;
     HEAP32[i106 >> 2] = 0;
     HEAP32[i106 + 4 >> 2] = 0;
     i18 = i106 + 8 | 0;
     HEAP32[i18 >> 2] = 0;
     HEAP16[i97 >> 1] = 0;
     __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt(i106, i14, i97);
     HEAP32[i105 >> 2] = 0;
     i1 = i105 + 4 | 0;
     HEAP32[i1 >> 2] = 0;
     i17 = i105 + 8 | 0;
     HEAP32[i17 >> 2] = 0;
     i3 = (i14 | 0) == 0;
     if (!i3) __ZN5physx6shdfnd5ArrayIPKNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i105, i14);
     HEAP32[i1 >> 2] = i14;
     i15 = i107 + 160 | 0;
     i1 = i107 + 164 | 0;
     HEAP32[i1 >> 2] = 0;
     i2 = i14 + 1 | 0;
     if ((HEAP32[i107 + 168 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj(i15, i2);
     HEAP32[i1 >> 2] = i2;
     if (i3) i1 = 0; else {
      _memset(HEAP32[i106 >> 2] | 0, -1, (i4 << 8) + (i5 << 1) | 0) | 0;
      i11 = i5 + (i4 << 7) | 0;
      i9 = HEAP32[i106 >> 2] | 0;
      i1 = 0;
      i12 = 0;
      do {
       i2 = i9 + (i12 << 1) | 0;
       if ((HEAP16[i2 >> 1] | 0) == -1) {
        i4 = (HEAP32[(HEAP32[i16 >> 2] | 0) + (i12 >>> 7 << 3) >> 2] | 0) + ((i12 & 127) * 20 | 0) | 0;
        HEAP16[i2 >> 1] = i1;
        i8 = HEAP32[i105 >> 2] | 0;
        HEAP32[i8 >> 2] = i4;
        i2 = 0;
        i3 = 1;
        do {
         i5 = i3 + -1 | 0;
         i6 = HEAP32[i8 + ((i5 >>> 0 > 1 ? i3 + -2 | 0 : 0) << 2) >> 2] | 0;
         i3 = HEAP32[i4 + 12 >> 2] | 0;
         if (!i3) {
          i3 = i5;
          i4 = i6;
         } else {
          i7 = i5;
          i4 = i6;
          while (1) {
           i5 = HEAP32[i3 >> 2] | 0;
           i6 = i9 + (HEAPU16[i5 >> 1] << 1) | 0;
           if ((HEAP16[i6 >> 1] | 0) == -1) {
            HEAP16[i6 >> 1] = i1;
            HEAP32[i8 + (i7 << 2) >> 2] = i5;
            i2 = i2 + 1 << 16 >> 16;
            i5 = i7 + 1 | 0;
            i4 = HEAP32[i3 >> 2] | 0;
           } else i5 = i7;
           i3 = HEAP32[i3 + 4 >> 2] | 0;
           if (!i3) {
            i3 = i5;
            break;
           } else i7 = i5;
          }
         }
        } while ((i3 | 0) != 0);
        HEAP16[(HEAP32[i15 >> 2] | 0) + ((i1 & 65535) << 1) >> 1] = (i2 & 65535) + 1;
        i1 = i1 + 1 << 16 >> 16;
       }
       i12 = i12 + 1 | 0;
      } while ((i12 | 0) != (i11 | 0));
     }
     i9 = i107 + 240 | 0;
     HEAP32[i107 + 244 >> 2] = 0;
     i8 = i1 & 65535;
     HEAP32[i98 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i9, i8, i98);
     i3 = HEAP32[i99 >> 2] | 0;
     if (i3 | 0) {
      i4 = HEAP32[i100 >> 2] | 0;
      i5 = HEAP32[i106 >> 2] | 0;
      i7 = 0;
      do {
       i6 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
       i1 = HEAP32[i6 >> 2] | 0;
       if (!i1) i2 = -1; else if (Math_fround(HEAPF32[(HEAP32[i1 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) i2 = -1; else i2 = HEAPU16[i5 + (HEAPU16[HEAP32[i1 + 60 >> 2] >> 1] << 1) >> 1] | 0;
       i1 = HEAP32[i6 + 4 >> 2] | 0;
       do if (!i1) i1 = -1; else {
        if (Math_fround(HEAPF32[(HEAP32[i1 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) {
         i1 = -1;
         break;
        }
        i1 = HEAPU16[i5 + (HEAPU16[HEAP32[i1 + 60 >> 2] >> 1] << 1) >> 1] | 0;
       } while (0);
       i1 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
       if ((i1 | 0) != -1) {
        HEAP32[i6 + 56 >> 2] = i1;
        i98 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
        HEAP32[i98 >> 2] = (HEAP32[i98 >> 2] | 0) + 1;
       }
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i3 | 0));
     }
     i1 = i8 + 1 | 0;
     i2 = HEAP32[i15 >> 2] | 0;
     i3 = 0;
     i5 = 0;
     i6 = 0;
     while (1) {
      i98 = i2 + (i3 << 1) | 0;
      i4 = HEAP16[i98 >> 1] | 0;
      HEAP16[i98 >> 1] = i6;
      i5 = i5 + 1 << 16 >> 16;
      i3 = i5 & 65535;
      if (i3 >>> 0 >= i1 >>> 0) break; else i6 = (i4 & 65535) + (i6 & 65535) & 65535;
     }
     i6 = i107 + 148 | 0;
     i1 = i107 + 152 | 0;
     HEAP32[i1 >> 2] = 0;
     if ((HEAP32[i107 + 156 >> 2] & 2147483647) >>> 0 < i14 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i14);
     HEAP32[i1 >> 2] = i14;
     i3 = HEAP32[i13 >> 2] | 0;
     i4 = i3 << 7;
     i1 = HEAP32[i16 >> 2] | 0;
     if ((HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0) != (0 - i4 | 0)) {
      i5 = HEAP32[i106 >> 2] | 0;
      i2 = 0;
      do {
       i97 = i2 & 127;
       i96 = HEAP32[i1 + (i2 >>> 7 << 3) >> 2] | 0;
       i95 = (HEAP32[i15 >> 2] | 0) + (HEAPU16[i5 + (HEAPU16[i96 + (i97 * 20 | 0) >> 1] << 1) >> 1] << 1) | 0;
       i98 = HEAPU16[i95 >> 1] | 0;
       HEAP16[i95 >> 1] = i98 + 1;
       HEAP32[(HEAP32[i6 >> 2] | 0) + (i98 << 2) >> 2] = i96 + (i97 * 20 | 0);
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i16 >> 2] | 0;
      } while (i2 >>> 0 < ((HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0) + i4 | 0) >>> 0);
     }
     i5 = i107 + 56 | 0;
     HEAP32[i107 + 72 >> 2] = 1;
     i1 = i107 + 68 | 0;
     HEAP32[i1 >> 2] = i101;
     if (i101 | 0) {
      mftCall_vi(HEAP32[(HEAP32[i101 >> 2] | 0) + 16 >> 2] | 0, i101 | 0);
      HEAP32[i107 + 64 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
     }
     i4 = i107 + 28 | 0;
     HEAP32[i107 + 44 >> 2] = 1;
     i1 = i107 + 40 | 0;
     HEAP32[i1 >> 2] = i5;
     mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
     HEAP32[i107 + 36 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
     HEAP32[i107 + 16 >> 2] = 1;
     i1 = i107 + 12 | 0;
     HEAP32[i1 >> 2] = i4;
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
     HEAP32[i107 + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
     __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_16IslandPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i100 >> 2] | 0, HEAP32[i99 >> 2] | 0, i102, i103, 32);
     i1 = HEAP32[i99 >> 2] | 0;
     i103 = HEAP32[(HEAP32[i104 >> 2] | 0) + 6956 >> 2] | 0;
     i103 = mftCall_ii(HEAP32[(HEAP32[i103 >> 2] | 0) + 16 >> 2] | 0, i103 | 0) | 0;
     i103 = mftCall_ii(HEAP32[(HEAP32[i103 >> 2] | 0) + 4 >> 2] | 0, i103 | 0) | 0;
     i103 = (i1 >>> 0) / ((i103 >>> 0 > 1 ? i103 : 1) >>> 0) | 0;
     i2 = i107 + 256 | 0;
     HEAP32[i2 >> 2] = (i103 | 0) == 0 ? 1 : i103;
     if (i1 | 0) {
      i3 = 0;
      do {
       i101 = HEAP32[(HEAP32[i104 >> 2] | 0) + 6960 >> 2] | 0;
       __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i101 >> 2] | 0);
       i103 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i101, 28, 16) | 0;
       __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i101 >> 2] | 0);
       i101 = (HEAP32[i2 >> 2] | 0) + i3 | 0;
       i97 = (HEAP32[i100 >> 2] | 0) + (i3 << 2) | 0;
       HEAP16[i103 + 4 >> 1] = -1;
       HEAP16[i103 + 6 >> 1] = 0;
       i102 = i103 + 8 | 0;
       HEAP32[i102 >> 2] = 0;
       HEAP32[i103 >> 2] = gb + 87404 + 8;
       i99 = i103 + 12 | 0;
       HEAP32[i99 >> 2] = 0;
       i98 = i103 + 16 | 0;
       HEAP32[i98 >> 2] = 0;
       HEAP32[i103 >> 2] = gb + 106704 + 8;
       HEAP32[i103 + 20 >> 2] = i97;
       HEAP32[i103 + 24 >> 2] = (i1 >>> 0 < i101 >>> 0 ? i1 : i101) - i3;
       i101 = HEAP32[(HEAP32[i104 >> 2] | 0) + 6956 >> 2] | 0;
       HEAP32[i98 >> 2] = 1;
       HEAP32[i99 >> 2] = i107;
       HEAP32[i102 >> 2] = i101;
       mftCall_vi(HEAP32[(HEAP32[i107 >> 2] | 0) + 16 >> 2] | 0, i107 | 0);
       mftCall_vi(HEAP32[(HEAP32[i103 >> 2] | 0) + 20 >> 2] | 0, i103 | 0);
       i3 = (HEAP32[i2 >> 2] | 0) + i3 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     mftCall_vi(HEAP32[(HEAP32[i107 >> 2] | 0) + 20 >> 2] | 0, i107 | 0);
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
     mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
     i107 = HEAP32[i17 >> 2] | 0;
     do if ((i107 | 0) > -1 & (i107 & 2147483647 | 0) != 0) {
      i1 = HEAP32[i105 >> 2] | 0;
      if (!i1) break;
      i107 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i107 >> 2] | 0) + 12 >> 2] | 0, i107 | 0, i1 | 0);
     } while (0);
     i107 = HEAP32[i18 >> 2] | 0;
     if (!((i107 | 0) > -1 & (i107 & 2147483647 | 0) != 0)) {
      STACKTOP = i108;
      return;
     }
     i1 = HEAP32[i106 >> 2] | 0;
     if (!i1) {
      STACKTOP = i108;
      return;
     }
     i107 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i107 >> 2] | 0) + 12 >> 2] | 0, i107 | 0, i1 | 0);
     STACKTOP = i108;
     return;
    }
   } while (0);
   __ZN5physx13PxsCCDContext12updateCCDEndEv(i107);
   __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[(HEAP32[i104 >> 2] | 0) + 224 >> 2] | 0, HEAP32[i80 >> 2] | 0);
   STACKTOP = i108;
   return;
  }
 }
 HEAP32[i1 >> 2] = 0;
 __ZN5physx13PxsCCDContext12updateCCDEndEv(i107);
 STACKTOP = i108;
 return;
}

function __ZN5audio5mixer22CreateAudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorEib(i74, i75, i68, i1, i76) {
 i74 = i74 | 0;
 i75 = i75 | 0;
 i68 = i68 | 0;
 i1 = i1 | 0;
 i76 = i76 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i77 = 0, i78 = 0, f79 = f0, f80 = f0;
 i78 = STACKTOP;
 STACKTOP = STACKTOP + 704 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i77 = i78 + 656 | 0;
 i72 = i78 + 640 | 0;
 i63 = i78 + 624 | 0;
 i62 = i78 + 608 | 0;
 i61 = i78 + 592 | 0;
 i57 = i78 + 576 | 0;
 i56 = i78 + 560 | 0;
 i44 = i78 + 552 | 0;
 i43 = i78 + 544 | 0;
 i42 = i78 + 528 | 0;
 i55 = i78 + 520 | 0;
 i54 = i78 + 504 | 0;
 i53 = i78 + 496 | 0;
 i52 = i78 + 480 | 0;
 i51 = i78 + 464 | 0;
 i50 = i78 + 448 | 0;
 i49 = i78 + 432 | 0;
 i48 = i78 + 416 | 0;
 i47 = i78 + 400 | 0;
 i46 = i78 + 384 | 0;
 i45 = i78 + 368 | 0;
 i13 = i78 + 352 | 0;
 i10 = i78 + 336 | 0;
 i9 = i78 + 320 | 0;
 i8 = i78 + 304 | 0;
 i7 = i78 + 288 | 0;
 i6 = i78 + 272 | 0;
 i5 = i78 + 256 | 0;
 i59 = i78;
 i41 = i78 + 692 | 0;
 i11 = i78 + 688 | 0;
 i12 = i78 + 684 | 0;
 i60 = i78 + 672 | 0;
 i58 = (HEAP32[i74 + 32 >> 2] | 0) + -1 | 0;
 i58 = (i1 | 0) < 0 ? 0 : (i58 | 0) < (i1 | 0) ? i58 : i1;
 i70 = i74 + 36 | 0;
 i71 = i70;
 i66 = HEAP32[(HEAP32[i70 >> 2] | 0) + i71 + 4 >> 2] | 0;
 i73 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, 80, 4) | 0;
 i2 = HEAP32[i74 >> 2] | 0;
 _memset(i59 | 0, 0, 256) | 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i2 << 8 | 0, 4) | 0;
  i3 = i1 + (i2 << 8) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    _memcpy(i2 | 0, i59 | 0, 256) | 0;
    i2 = i2 + 256 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i40 = i73 + 8 | 0;
 HEAP32[i40 >> 2] = i1;
 i2 = HEAP32[i74 >> 2] | 0;
 _memset(i59 | 0, 0, 256) | 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i2 << 8 | 0, 4) | 0;
  i3 = i1 + (i2 << 8) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    _memcpy(i2 | 0, i59 | 0, 256) | 0;
    i2 = i2 + 256 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i69 = i73 + 12 | 0;
 HEAP32[i69 >> 2] = i1;
 i2 = HEAP32[i74 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i73 >> 2] = i1;
 i2 = HEAP32[i74 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i67 = i73 + 4 | 0;
 HEAP32[i67 >> 2] = i1;
 _memset(i1 | 0, 0, HEAP32[i74 >> 2] << 2 | 0) | 0;
 _memset(HEAP32[i40 >> 2] | 0, 0, HEAP32[i74 >> 2] << 8 | 0) | 0;
 _memset(HEAP32[i69 >> 2] | 0, 0, HEAP32[i74 >> 2] << 8 | 0) | 0;
 i65 = i74 + 12 | 0;
 i2 = HEAP32[i65 >> 2] | 0;
 HEAP32[i59 >> 2] = 0;
 HEAP32[i59 + 4 >> 2] = 0;
 HEAP32[i59 + 8 >> 2] = 0;
 HEAP32[i59 + 12 >> 2] = 0;
 HEAP32[i59 + 16 >> 2] = 0;
 HEAP32[i59 + 20 >> 2] = 0;
 HEAP32[i59 + 24 >> 2] = 0;
 HEAP32[i59 + 28 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i2 << 5 | 0, 4) | 0;
  i3 = i1 + (i2 << 5) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i59 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i59 + 20 >> 2];
    HEAP32[i2 + 24 >> 2] = HEAP32[i59 + 24 >> 2];
    HEAP32[i2 + 28 >> 2] = HEAP32[i59 + 28 >> 2];
    i2 = i2 + 32 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i64 = i73 + 16 | 0;
 HEAP32[i64 >> 2] = i1;
 _memset(i1 | 0, 0, HEAP32[i65 >> 2] << 5 | 0) | 0;
 i1 = HEAP32[i74 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i1 | 0, 1) | 0;
  _memset(i2 | 0, 0, i1 | 0) | 0;
  i1 = i2;
  i2 = HEAP32[i74 >> 2] | 0;
 }
 HEAP32[i73 + 64 >> 2] = i1;
 _memset(i1 | 0, 0, i2 | 0) | 0;
 HEAP32[i73 + 76 >> 2] = i74;
 i4 = i73 + 68 | 0;
 i1 = __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(i75, gb + 862107 | 0, i4) | 0;
 if (i1 | 0) {
  i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i5 >> 2] = gb + 859765;
  HEAP32[i5 + 4 >> 2] = 189;
  HEAP32[i5 + 8 >> 2] = i38;
  HEAP32[i5 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i5);
 }
 i1 = __ZN4FMOD12ChannelGroup7setMuteEb(HEAP32[i4 >> 2] | 0, 1) | 0;
 if (i1 | 0) {
  i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i6 >> 2] = gb + 859765;
  HEAP32[i6 + 4 >> 2] = 190;
  HEAP32[i6 + 8 >> 2] = i38;
  HEAP32[i6 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i6);
 }
 HEAP32[i41 >> 2] = 48e3;
 HEAP32[i11 >> 2] = 8;
 i1 = __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i75, i41, 0, i11, 0, 0, 0) | 0;
 if (i1 | 0) {
  i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i7 >> 2] = gb + 859765;
  HEAP32[i7 + 4 >> 2] = 194;
  HEAP32[i7 + 8 >> 2] = i38;
  HEAP32[i7 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i7);
 }
 HEAP32[i12 >> 2] = 0;
 i1 = __ZN4FMOD6System16getDSPBufferSizeEPjPi(i75, i12, 0) | 0;
 if (i1 | 0) {
  i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i8 >> 2] = gb + 859765;
  HEAP32[i8 + 4 >> 2] = 197;
  HEAP32[i8 + 8 >> 2] = i38;
  HEAP32[i8 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i8);
 }
 i1 = i74 + 48 | 0;
 if (HEAP32[i74 >> 2] | 0) {
  i3 = 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  do {
   HEAP32[i59 >> 2] = 0;
   if (!i3) {
    i38 = HEAP32[i69 >> 2] | 0;
    f79 = Math_fround(HEAP32[i41 >> 2] | 0);
    HEAPF32[i38 + 8 >> 2] = Math_fround(__Z32AudioMeasurement_GetTimeConstantff(Math_fround(.990000009), Math_fround(f79 * Math_fround(.300000012))));
    HEAPF32[i38 + 12 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(__Z32AudioMeasurement_GetTimeConstantff(Math_fround(.899999976), Math_fround(f79 * Math_fround(1.70000005)))));
    f80 = Math_fround(Math_fround(-.5) / f79);
    HEAPF32[i38 + 16 >> 2] = Math_fround(_exp2f(Math_fround(f80 * Math_fround(_log2f(Math_fround(10.0))))));
    HEAP32[i38 + 24 >> 2] = ~~Math_fround(f79 * Math_fround(2.0));
    i38 = i38 + 28 | 0;
    HEAP32[i38 >> 2] = HEAP32[i38 >> 2] | 2;
   }
   i2 = (HEAP32[i69 >> 2] | 0) + (i3 << 8) + 28 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
   i2 = __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(i75, i1, i59) | 0;
   if (i2 | 0) {
    i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i2) | 0;
    HEAP32[i9 >> 2] = gb + 859765;
    HEAP32[i9 + 4 >> 2] = 216;
    HEAP32[i9 + 8 >> 2] = i38;
    HEAP32[i9 + 12 >> 2] = i2;
    _printf_console(gb + 859725 | 0, i9);
   }
   HEAP32[(HEAP32[i73 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i59 >> 2];
   i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i74 >> 2] | 0) >>> 0);
 }
 i1 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i4 >> 2] | 0, HEAP32[HEAP32[i73 >> 2] >> 2] | 0) | 0;
 if (i1 | 0) {
  i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i10 >> 2] = gb + 859765;
  HEAP32[i10 + 4 >> 2] = 222;
  HEAP32[i10 + 8 >> 2] = i38;
  HEAP32[i10 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i10);
 }
 if ((HEAP32[i74 >> 2] | 0) >>> 0 > 1) {
  i2 = i74 + 4 | 0;
  i3 = i2;
  i1 = 1;
  do {
   i4 = HEAP32[i73 >> 2] | 0;
   i4 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i4 + (HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 4) >> 2] << 2) >> 2] | 0, HEAP32[i4 + (i1 << 2) >> 2] | 0) | 0;
   if (i4 | 0) {
    i38 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i4) | 0;
    HEAP32[i13 >> 2] = gb + 859765;
    HEAP32[i13 + 4 >> 2] = 228;
    HEAP32[i13 + 8 >> 2] = i38;
    HEAP32[i13 + 12 >> 2] = i4;
    _printf_console(gb + 859725 | 0, i13);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i74 >> 2] | 0) >>> 0);
 }
 i12 = Math_imul(HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
 i4 = i74 + 24 | 0;
 i2 = Math_imul(i12, HEAP32[i4 >> 2] | 0) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i2 = i73 + 72 | 0;
 HEAP32[i2 >> 2] = i1;
 _memset(i1 | 0, 0, Math_imul(i12 << 2, HEAP32[i4 >> 2] | 0) | 0) | 0;
 L65 : do if (!(HEAP32[i65 >> 2] | 0)) i1 = 0; else {
  i8 = i74 + 16 | 0;
  i9 = i8;
  i10 = i74 + 64 | 0;
  i11 = i10;
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = 0;
  do {
   i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i7 << 5) >> 2] | 0;
   L69 : do if ((i2 + 5 | 0) >>> 0 < 2) i39 = 57; else if ((i2 | 0) > -1 & ((i2 | 0) > 999 | (i2 | 0) == 0)) {
    i3 = i2 + -1e3 | 0;
    i2 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
    if (i3) do {
     i2 = i2 + ((_strlen(i2) | 0) + 1) | 0;
     i3 = i3 + -1 | 0;
    } while ((i3 | 0) != 0);
    HEAP32[i59 >> 2] = 0;
    i4 = __Z25GetAudioEffectDefinitionsPi(i59) | 0;
    i5 = HEAP32[i59 >> 2] | 0;
    L76 : do if ((i5 | 0) > 0) {
     i3 = 0;
     while (1) {
      i6 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
      i3 = i3 + 1 | 0;
      if (!(_strcmp((HEAP32[i6 >> 2] | 0) + 128 | 0, i2) | 0)) break;
      if ((i3 | 0) >= (i5 | 0)) break L76;
     }
     if (!i6) break L69;
     if (0 == 0 ? (HEAP32[(HEAP32[i6 >> 2] | 0) + 120 >> 2] & 1 | 0) == 0 : 0) break L69; else {
      i39 = 57;
      break L69;
     }
    } while (0);
   } while (0);
   if ((i39 | 0) == 57) {
    i39 = 0;
    HEAP32[(HEAP32[i64 >> 2] | 0) + (i7 << 5) + 20 >> 2] = i1;
    i1 = i1 + (i12 << 2) | 0;
   }
   i7 = i7 + 1 | 0;
   i2 = HEAP32[i65 >> 2] | 0;
  } while (i7 >>> 0 < i2 >>> 0);
  if (!i2) i1 = 0; else {
   i11 = i74 + 16 | 0;
   i12 = i11;
   i13 = i74 + 64 | 0;
   i14 = i13;
   i15 = i59 + 11 | 0;
   i16 = i59 + 11 | 0;
   i17 = i59 + 11 | 0;
   i18 = i59 + 11 | 0;
   i19 = i59 + 32 | 0;
   i20 = i59 + 4 | 0;
   i21 = i59 + 76 | 0;
   i22 = i59 + 32 | 0;
   i23 = i59 + 4 | 0;
   i24 = i59 + 24 | 0;
   i25 = i59 + 76 | 0;
   i26 = i59 + 32 | 0;
   i27 = i59 + 4 | 0;
   i28 = i59 + 24 | 0;
   i29 = i59 + 64 | 0;
   i30 = i59 + 68 | 0;
   i31 = i59 + 88 | 0;
   i32 = i59 + 96 | 0;
   i33 = i59 + 20 | 0;
   i34 = i59 + 84 | 0;
   i35 = i59 + 76 | 0;
   i36 = i59 + 32 | 0;
   i37 = i59 + 4 | 0;
   i38 = i59 + 76 | 0;
   i10 = 0;
   while (1) {
    i7 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
    i6 = i7 + (i10 << 5) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    i9 = (i1 | 0) < 0 ? 1 : (i1 | 0) > 999 ? 0 : i1;
    i3 = HEAP32[i64 >> 2] | 0;
    i2 = i3 + (i10 << 5) | 0;
    HEAP32[i2 >> 2] = 0;
    L90 : do switch (i1 | 0) {
    case -3:
     {
      i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i7 + (i10 << 5) + 4 >> 2] << 2) >> 2] | 0;
      i1 = HEAP32[i7 + (i10 << 5) + 8 >> 2] | 0;
      if ((i1 | 0) != -1) {
       if (!(HEAP32[i3 + (i1 << 5) + 20 >> 2] | 0)) break L90;
       i7 = i59;
       i8 = i7 + 104 | 0;
       do {
        HEAP32[i7 >> 2] = 0;
        i7 = i7 + 4 | 0;
       } while ((i7 | 0) < (i8 | 0));
       HEAP8[i19 >> 0] = HEAP8[gb + 862117 >> 0] | 0;
       HEAP8[i19 + 1 >> 0] = HEAP8[gb + 862117 + 1 >> 0] | 0;
       HEAP8[i19 + 2 >> 0] = HEAP8[gb + 862117 + 2 >> 0] | 0;
       HEAP8[i19 + 3 >> 0] = HEAP8[gb + 862117 + 3 >> 0] | 0;
       HEAP8[i19 + 4 >> 0] = HEAP8[gb + 862117 + 4 >> 0] | 0;
       i39 = HEAP32[i64 >> 2] | 0;
       HEAP32[i39 + (i10 << 5) + 20 >> 2] = HEAP32[i39 + (i1 << 5) + 20 >> 2];
       HEAP32[i59 >> 2] = 104;
       HEAP32[i20 >> 2] = 56;
       HEAP32[i21 >> 2] = fb + 139;
       __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i60, i59, 0);
       i1 = HEAP32[i64 >> 2] | 0;
       i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i60, i75, i1 + (i10 << 5) | 0, HEAP32[i1 + (i10 << 5) + 20 >> 2] | 0, 0) | 0;
       HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] = i1;
       i1 = __ZN4FMOD3DSP9setBypassEb(i1, 1) | 0;
       if (i1 | 0) {
        i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
        HEAP32[i45 >> 2] = gb + 859765;
        HEAP32[i45 + 4 >> 2] = 281;
        HEAP32[i45 + 8 >> 2] = i39;
        HEAP32[i45 + 12 >> 2] = i1;
        _printf_console(gb + 859725 | 0, i45);
       }
       i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i2, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 0) | 0;
       if (i1 | 0) {
        i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
        HEAP32[i46 >> 2] = gb + 859765;
        HEAP32[i46 + 4 >> 2] = 283;
        HEAP32[i46 + 8 >> 2] = i39;
        HEAP32[i46 + 12 >> 2] = i1;
        _printf_console(gb + 859725 | 0, i46);
       }
       __ZN29AudioEffectInternalDefinitionD2Ev(i60);
       i39 = 103;
      }
      break;
     }
    case -4:
     {
      i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i7 + (i10 << 5) + 4 >> 2] << 2) >> 2] | 0;
      i7 = i59;
      i8 = i7 + 104 | 0;
      do {
       HEAP32[i7 >> 2] = 0;
       i7 = i7 + 4 | 0;
      } while ((i7 | 0) < (i8 | 0));
      i1 = i22;
      HEAP32[i1 >> 2] = 1701012818;
      HEAP32[i1 + 4 >> 2] = 6649449;
      HEAP32[i59 >> 2] = 104;
      HEAP32[i23 >> 2] = 56;
      i1 = i24;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i25 >> 2] = fb + 140;
      __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i60, i59, 0);
      i1 = HEAP32[i64 >> 2] | 0;
      i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i60, i75, i1 + (i10 << 5) | 0, HEAP32[i1 + (i10 << 5) + 20 >> 2] | 0, 0) | 0;
      HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] = i1;
      i1 = __ZN4FMOD3DSP9setBypassEb(i1, 1) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i47 >> 2] = gb + 859765;
       HEAP32[i47 + 4 >> 2] = 305;
       HEAP32[i47 + 8 >> 2] = i39;
       HEAP32[i47 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i47);
      }
      i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i2, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 0) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i48 >> 2] = gb + 859765;
       HEAP32[i48 + 4 >> 2] = 307;
       HEAP32[i48 + 8 >> 2] = i39;
       HEAP32[i48 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i48);
      }
      __ZN29AudioEffectInternalDefinitionD2Ev(i60);
      i39 = 103;
      break;
     }
    case -5:
     {
      i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i7 + (i10 << 5) + 4 >> 2] << 2) >> 2] | 0;
      i7 = i59;
      i8 = i7 + 104 | 0;
      do {
       HEAP32[i7 >> 2] = 0;
       i7 = i7 + 4 | 0;
      } while ((i7 | 0) < (i8 | 0));
      i7 = i26;
      i3 = gb + 862122 | 0;
      i8 = i7 + 12 | 0;
      do {
       HEAP8[i7 >> 0] = HEAP8[i3 >> 0] | 0;
       i7 = i7 + 1 | 0;
       i3 = i3 + 1 | 0;
      } while ((i7 | 0) < (i8 | 0));
      i1 = i28;
      HEAP32[i1 >> 2] = 1;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i59 >> 2] = 104;
      HEAP32[i27 >> 2] = 56;
      HEAP32[i29 >> 2] = fb + 2475;
      HEAP32[i30 >> 2] = fb + 2476;
      HEAP32[i31 >> 2] = fb + 4;
      HEAP32[i32 >> 2] = fb + 169;
      HEAP32[i33 >> 2] = 7;
      HEAP32[i34 >> 2] = gb + 174308;
      HEAP32[i35 >> 2] = fb + 141;
      __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i60, i59, 0);
      i1 = HEAP32[i64 >> 2] | 0;
      i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i60, i75, i1 + (i10 << 5) | 0, HEAP32[i1 + (i10 << 5) + 20 >> 2] | 0, 0) | 0;
      HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] = i1;
      i1 = __ZN4FMOD3DSP9setBypassEb(i1, 1) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i49 >> 2] = gb + 859765;
       HEAP32[i49 + 4 >> 2] = 347;
       HEAP32[i49 + 8 >> 2] = i39;
       HEAP32[i49 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i49);
      }
      i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i2, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 0) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i50 >> 2] = gb + 859765;
       HEAP32[i50 + 4 >> 2] = 349;
       HEAP32[i50 + 8 >> 2] = i39;
       HEAP32[i50 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i50);
      }
      __ZN29AudioEffectInternalDefinitionD2Ev(i60);
      i39 = 103;
      break;
     }
    case -2:
     {
      i1 = i7 + (i10 << 5) + 4 | 0;
      i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
      i7 = i59;
      i8 = i7 + 104 | 0;
      do {
       HEAP32[i7 >> 2] = 0;
       i7 = i7 + 4 | 0;
      } while ((i7 | 0) < (i8 | 0));
      i7 = i36;
      i3 = gb + 862134 | 0;
      i8 = i7 + 14 | 0;
      do {
       HEAP8[i7 >> 0] = HEAP8[i3 >> 0] | 0;
       i7 = i7 + 1 | 0;
       i3 = i3 + 1 | 0;
      } while ((i7 | 0) < (i8 | 0));
      HEAP32[i59 >> 2] = 104;
      HEAP32[i37 >> 2] = 56;
      HEAP32[i38 >> 2] = fb + 142;
      __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i60, i59, 0);
      i39 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i60, i75, (HEAP32[i40 >> 2] | 0) + (HEAP32[i1 >> 2] << 8) | 0, 0, 0) | 0;
      HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] = i39;
      i39 = HEAP32[i1 >> 2] | 0;
      i8 = HEAP32[i40 >> 2] | 0;
      f80 = Math_fround(HEAP32[i41 >> 2] | 0);
      HEAPF32[i8 + (i39 << 8) + 8 >> 2] = Math_fround(__Z32AudioMeasurement_GetTimeConstantff(Math_fround(.990000009), Math_fround(f80 * Math_fround(.300000012))));
      HEAPF32[i8 + (i39 << 8) + 12 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(__Z32AudioMeasurement_GetTimeConstantff(Math_fround(.899999976), Math_fround(f80 * Math_fround(1.70000005)))));
      HEAPF32[i8 + (i39 << 8) + 16 >> 2] = Math_fround(_exp2f(Math_fround(Math_fround(Math_fround(-.5) / f80) * Math_fround(_log2f(Math_fround(10.0))))));
      HEAP32[i8 + (i39 << 8) + 24 >> 2] = ~~Math_fround(f80 * Math_fround(2.0));
      i1 = HEAP32[i1 >> 2] | 0;
      i39 = (HEAP32[i40 >> 2] | 0) + (i1 << 8) + 28 | 0;
      HEAP32[i39 >> 2] = HEAP32[i39 >> 2] | 1;
      i1 = (HEAP32[i69 >> 2] | 0) + (i1 << 8) + 28 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -2;
      i1 = __ZN4FMOD3DSP9setBypassEb(HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 1) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i51 >> 2] = gb + 859765;
       HEAP32[i51 + 4 >> 2] = 372;
       HEAP32[i51 + 8 >> 2] = i39;
       HEAP32[i51 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i51);
      }
      i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i2, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 0) | 0;
      if (i1 | 0) {
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i52 >> 2] = gb + 859765;
       HEAP32[i52 + 4 >> 2] = 374;
       HEAP32[i52 + 8 >> 2] = i39;
       HEAP32[i52 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i52);
      }
      __ZN29AudioEffectInternalDefinitionD2Ev(i60);
      i39 = 103;
      break;
     }
    default:
     {
      if (i9 | 0) {
       if (__ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i75, i9, i2) | 0) {
        __Z6FormatPKcz(i59, gb + 862311 | 0, i43);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 >> 0] | 0) < 0 ? HEAP32[i59 >> 2] | 0 : i59, 0, gb + 859765 | 0, 402, 1, 0, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i59);
        i39 = 103;
        break L90;
       }
       i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i7 + (i10 << 5) + 4 >> 2] << 2) >> 2] | 0, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0, 0) | 0;
       if (!i1) {
        i39 = 103;
        break L90;
       }
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i42 >> 2] = gb + 859765;
       HEAP32[i42 + 4 >> 2] = 398;
       HEAP32[i42 + 8 >> 2] = i39;
       HEAP32[i42 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i42);
       i39 = 103;
       break L90;
      }
      i2 = i1 + -1e3 | 0;
      i1 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
      if (i2) do {
       i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
       i2 = i2 + -1 | 0;
      } while ((i2 | 0) != 0);
      HEAP32[i59 >> 2] = 0;
      i3 = __Z25GetAudioEffectDefinitionsPi(i59) | 0;
      i4 = HEAP32[i59 >> 2] | 0;
      L103 : do if ((i4 | 0) > 0) {
       i2 = 0;
       while (1) {
        i5 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
        i2 = i2 + 1 | 0;
        if (!(_strcmp((HEAP32[i5 >> 2] | 0) + 128 | 0, i1) | 0)) break;
        if ((i2 | 0) >= (i4 | 0)) {
         i39 = 90;
         break L103;
        }
       }
       if (!i5) break;
       i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i5, i75, 0, HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) + 20 >> 2] | 0, 0) | 0;
       HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] = i1;
       if (!i1) {
        HEAP32[i55 >> 2] = (HEAP32[i5 >> 2] | 0) + 128;
        __Z6FormatPKcz(i59, gb + 862148 | 0, i55);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i59 >> 2] | 0 : i59, 0, gb + 859765 | 0, 392, 1, 0, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i59);
        i39 = 103;
        break L90;
       }
       i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[(HEAP32[i73 >> 2] | 0) + (HEAP32[i7 + (i10 << 5) + 4 >> 2] << 2) >> 2] | 0, i1, 0) | 0;
       if (!i1) {
        i39 = 103;
        break L90;
       }
       i39 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i54 >> 2] = gb + 859765;
       HEAP32[i54 + 4 >> 2] = 388;
       HEAP32[i54 + 8 >> 2] = i39;
       HEAP32[i54 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i54);
       i39 = 103;
       break L90;
      } else i39 = 90; while (0);
      if ((i39 | 0) == 90) i39 = 0;
      i2 = (HEAP32[i6 >> 2] | 0) + -1e3 | 0;
      i1 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
      if (i2) do {
       i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
       i2 = i2 + -1 | 0;
      } while ((i2 | 0) != 0);
      HEAP32[i53 >> 2] = i1;
      __Z6FormatPKcz(i59, gb + 862148 | 0, i53);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i59 >> 2] | 0 : i59, 0, gb + 859765 | 0, 381, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i59);
     }
    } while (0);
    if ((i39 | 0) == 103) {
     i39 = 0;
     if (!(HEAP32[(HEAP32[i64 >> 2] | 0) + (i10 << 5) >> 2] | 0)) {
      HEAP32[i44 >> 2] = i9;
      __Z6FormatPKcz(i59, gb + 862354 | 0, i44);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i59 >> 2] | 0 : i59, 0, gb + 859765 | 0, 407, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i59);
     }
    }
    i10 = i10 + 1 | 0;
    i1 = HEAP32[i65 >> 2] | 0;
    if (i10 >>> 0 >= i1 >>> 0) break L65;
   }
  }
 } while (0);
 i2 = HEAP32[i74 >> 2] | 0;
 if (i2) {
  i4 = i59 + 32 | 0;
  i5 = i59 + 4 | 0;
  i6 = i59 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   if (HEAP32[(HEAP32[i69 >> 2] | 0) + (i3 << 8) + 28 >> 2] & 3) {
    i2 = HEAP32[(HEAP32[i73 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i7 = i59;
    i8 = i7 + 104 | 0;
    do {
     HEAP32[i7 >> 2] = 0;
     i7 = i7 + 4 | 0;
    } while ((i7 | 0) < (i8 | 0));
    i1 = i4;
    HEAP32[i1 >> 2] = 1631999318;
    HEAP32[i1 + 4 >> 2] = 7497060;
    HEAP32[i59 >> 2] = 104;
    HEAP32[i5 >> 2] = 56;
    HEAP32[i6 >> 2] = fb + 142;
    __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i60, i59, 0);
    i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i60, i75, (HEAP32[i69 >> 2] | 0) + (i3 << 8) | 0, 0, 0) | 0;
    HEAP32[(HEAP32[i67 >> 2] | 0) + (i3 << 2) >> 2] = i1;
    i1 = __ZN4FMOD3DSP9setBypassEb(HEAP32[(HEAP32[i67 >> 2] | 0) + (i3 << 2) >> 2] | 0, 1) | 0;
    if (i1 | 0) {
     i55 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i56 >> 2] = gb + 859765;
     HEAP32[i56 + 4 >> 2] = 431;
     HEAP32[i56 + 8 >> 2] = i55;
     HEAP32[i56 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i56);
    }
    i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i2, HEAP32[(HEAP32[i67 >> 2] | 0) + (i3 << 2) >> 2] | 0, 0) | 0;
    if (i1 | 0) {
     i55 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i57 >> 2] = gb + 859765;
     HEAP32[i57 + 4 >> 2] = 433;
     HEAP32[i57 + 8 >> 2] = i55;
     HEAP32[i57 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i57);
    }
    __ZN29AudioEffectInternalDefinitionD2Ev(i60);
    i1 = HEAP32[i74 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i65 >> 2] | 0;
 }
 if (i1 | 0) {
  i4 = i74 + 16 | 0;
  i5 = i4;
  i3 = 0;
  do {
   i2 = HEAP32[i64 >> 2] | 0;
   HEAP32[i2 + (i3 << 5) + 4 >> 2] = 0;
   HEAP32[i2 + (i3 << 5) + 8 >> 2] = 0;
   i1 = i2 + (i3 << 5) | 0;
   HEAPF32[i2 + (i3 << 5) + 12 >> 2] = HEAP32[i1 >> 2] | 0 ? Math_fround(1.0) : Math_fround(0.0);
   HEAP32[i59 >> 2] = 0;
   HEAP32[i60 >> 2] = 0;
   i2 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
   do if (((HEAP32[i2 + (i3 << 5) >> 2] | 0) + 5 | 0) >>> 0 >= 3) {
    i1 = HEAP32[i1 >> 2] | 0;
    if (!i1) break;
    if ((HEAP32[i2 + (i3 << 5) + 12 >> 2] | 0) == -1) break;
    i1 = __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(i1, 0, i59, 0) | 0;
    if (i1 | 0) {
     i57 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i61 >> 2] = gb + 859765;
     HEAP32[i61 + 4 >> 2] = 455;
     HEAP32[i61 + 8 >> 2] = i57;
     HEAP32[i61 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i61);
    }
    i1 = HEAP32[i64 >> 2] | 0;
    i1 = __ZN4FMOD3DSP9getOutputEiPPS0_PPNS_13DSPConnectionE(HEAP32[i1 + (i3 << 5) >> 2] | 0, 0, i60, i1 + (i3 << 5) + 4 | 0) | 0;
    if (i1 | 0) {
     i57 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i62 >> 2] = gb + 859765;
     HEAP32[i62 + 4 >> 2] = 456;
     HEAP32[i62 + 8 >> 2] = i57;
     HEAP32[i62 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i62);
    }
    i1 = __ZN4FMOD3DSP8addInputEPS0_PPNS_13DSPConnectionE(HEAP32[i60 >> 2] | 0, HEAP32[i59 >> 2] | 0, (HEAP32[i64 >> 2] | 0) + (i3 << 5) + 8 | 0) | 0;
    if (!i1) break;
    i57 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
    HEAP32[i63 >> 2] = gb + 859765;
    HEAP32[i63 + 4 >> 2] = 457;
    HEAP32[i63 + 8 >> 2] = i57;
    HEAP32[i63 + 12 >> 2] = i1;
    _printf_console(gb + 859725 | 0, i63);
   } while (0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i65 >> 2] | 0) >>> 0);
 }
 HEAP32[i73 + 60 >> 2] = i58;
 i6 = i73 + 20 | 0;
 HEAP32[i6 >> 2] = i66;
 do if (!i66) {
  i5 = i73 + 24 | 0;
  HEAP32[i5 >> 2] = 0;
  i2 = i73 + 32 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i73 + 28 >> 2] = 0;
  HEAP32[i73 + 36 >> 2] = 0;
  i1 = 0;
 } else {
  i3 = i66 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) == (i1 + (i66 << 2) | 0)) {
   i4 = i73 + 24 | 0;
   HEAP32[i4 >> 2] = i1;
  } else {
   _memset(i1 | 0, 0, i3 | 0) | 0;
   i4 = i73 + 24 | 0;
   HEAP32[i4 >> 2] = i1;
  }
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) == (i1 + (i66 << 2) | 0)) {
   i2 = i73 + 32 | 0;
   HEAP32[i2 >> 2] = i1;
  } else {
   _memset(i1 | 0, 0, i3 | 0) | 0;
   i2 = i73 + 32 | 0;
   HEAP32[i2 >> 2] = i1;
  }
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) == (i1 + (i66 << 2) | 0)) HEAP32[i73 + 28 >> 2] = i1; else {
   _memset(i1 | 0, 0, i3 | 0) | 0;
   HEAP32[i73 + 28 >> 2] = i1;
  }
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i66 | 0, 1) | 0;
  _memset(i1 | 0, 0, i66 | 0) | 0;
  HEAP32[i73 + 36 >> 2] = i1;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) == (i1 + (i66 << 2) | 0)) {
   i5 = i4;
   break;
  }
  _memset(i1 | 0, 0, i3 | 0) | 0;
  i5 = i4;
 } while (0);
 HEAP32[i73 + 52 >> 2] = i1;
 i3 = HEAP32[(HEAP32[i70 >> 2] | 0) + i71 + 4 >> 2] | 0;
 if (i3 | 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = 0;
  do {
   HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(-inf);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i4 = i74 + 68 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if (!i2) i3 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i68 >> 2] >> 2] | 0, i68 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) == (i1 + (i2 << 2) | 0)) {
   i3 = i1;
   break;
  }
  _memset(i1 | 0, 0, i3 | 0) | 0;
  i3 = i1;
 } while (0);
 HEAP32[i73 + 40 >> 2] = i3;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = 0;
  do {
   HEAPF32[i3 + (i1 << 2) >> 2] = Math_fround(-inf);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 HEAPF32[i73 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i73 + 48 >> 2] = Math_fround(0.0);
 HEAP8[i73 + 56 >> 0] = 0;
 i70 = (HEAP32[i70 >> 2] | 0) + i71 + 8 | 0;
 i71 = HEAP32[i70 >> 2] | 0;
 _memcpy(HEAP32[i5 >> 2] | 0, ((i71 | 0) == 0 ? 0 : i70 + i71 | 0) | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 if (HEAP32[i65 >> 2] | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[(HEAP32[i64 >> 2] | 0) + (i2 << 5) >> 2] | 0;
   do if (i1 | 0) {
    i1 = __ZN4FMOD3DSP9setBypassEb(i1, 0) | 0;
    if (!i1) break;
    i71 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
    HEAP32[i72 >> 2] = gb + 859765;
    HEAP32[i72 + 4 >> 2] = 487;
    HEAP32[i72 + 8 >> 2] = i71;
    HEAP32[i72 + 12 >> 2] = i1;
    _printf_console(gb + 859725 | 0, i72);
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i65 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i74 >> 2] | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[(HEAP32[i67 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   do if (i1 | 0) {
    i1 = __ZN4FMOD3DSP9setBypassEb(i1, 0) | 0;
    if (!i1) break;
    i72 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
    HEAP32[i77 >> 2] = gb + 859765;
    HEAP32[i77 + 4 >> 2] = 491;
    HEAP32[i77 + 8 >> 2] = i72;
    HEAP32[i77 + 12 >> 2] = i1;
    _printf_console(gb + 859725 | 0, i77);
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i74 >> 2] | 0) >>> 0);
 }
 if (!i76) {
  __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf(i74, i73, Math_fround(0.0), i75, Math_fround(1.0e4));
  STACKTOP = i78;
  return i73 | 0;
 }
 i77 = (HEAP32[i69 >> 2] | 0) + 28 | 0;
 HEAP32[i77 >> 2] = HEAP32[i77 >> 2] | 4;
 __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf(i74, i73, Math_fround(0.0), i75, Math_fround(1.0e4));
 STACKTOP = i78;
 return i73 | 0;
}

function __ZN5physx24PxcContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i16, i2, i3, i4, i102, i1, i101) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i102 = i102 | 0;
 i1 = i1 | 0;
 i101 = i101 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i103 = 0, i104 = 0;
 i100 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i97 = i100 + 464 | 0;
 i95 = i100 + 440 | 0;
 i22 = i100 + 344 | 0;
 i17 = i100 + 248 | 0;
 i57 = i100 + 152 | 0;
 i56 = i100 + 56 | 0;
 i23 = i100 + 52 | 0;
 i24 = i100 + 48 | 0;
 i96 = i100 + 36 | 0;
 i99 = i100 + 24 | 0;
 i91 = i100 + 12 | 0;
 i98 = i100;
 i58 = HEAP32[i2 + 4 >> 2] | 0;
 i92 = i95 + 12 | 0;
 HEAP32[i92 >> 2] = i58;
 HEAP32[i95 + 16 >> 2] = i2;
 i93 = i2 + 8 | 0;
 i21 = i95 + 4 | 0;
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i93 >> 2]));
 i94 = i2 + 12 | 0;
 HEAPF32[i95 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i94 >> 2]));
 i90 = i2 + 16 | 0;
 f37 = Math_fround(HEAPF32[i90 >> 2]);
 f43 = Math_fround(Math_fround(1.0) / f37);
 i20 = i95 + 8 | 0;
 HEAPF32[i20 >> 2] = f43;
 f49 = Math_fround(HEAPF32[i3 >> 2]);
 f53 = Math_fround(f49 + f49);
 f54 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f52 = Math_fround(f54 + f54);
 f44 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f48 = Math_fround(f44 + f44);
 f47 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f51 = Math_fround(f53 * f47);
 f50 = Math_fround(f52 * f47);
 f47 = Math_fround(f47 * f48);
 f86 = Math_fround(f49 * f52);
 f42 = Math_fround(f49 * f48);
 f52 = Math_fround(f54 * f52);
 f54 = Math_fround(f54 * f48);
 f48 = Math_fround(f44 * f48);
 f44 = Math_fround(Math_fround(Math_fround(1.0) - f52) - f48);
 f45 = Math_fround(f86 + f47);
 f46 = Math_fround(f42 - f50);
 f47 = Math_fround(f86 - f47);
 f53 = Math_fround(Math_fround(1.0) - Math_fround(f49 * f53));
 f48 = Math_fround(f53 - f48);
 f49 = Math_fround(f54 + f51);
 f50 = Math_fround(f42 + f50);
 f51 = Math_fround(f54 - f51);
 f52 = Math_fround(f53 - f52);
 f53 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f54 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f86 = Math_fround(HEAPF32[i4 >> 2]);
 f34 = Math_fround(f86 + f86);
 f35 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f89 = Math_fround(f35 + f35);
 f81 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f85 = Math_fround(f81 + f81);
 f84 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f88 = Math_fround(f34 * f84);
 f87 = Math_fround(f89 * f84);
 f84 = Math_fround(f84 * f85);
 f15 = Math_fround(f86 * f89);
 f36 = Math_fround(f86 * f85);
 f89 = Math_fround(f35 * f89);
 f35 = Math_fround(f35 * f85);
 f85 = Math_fround(f81 * f85);
 f81 = Math_fround(Math_fround(Math_fround(1.0) - f89) - f85);
 f82 = Math_fround(f15 + f84);
 f83 = Math_fround(f36 - f87);
 f84 = Math_fround(f15 - f84);
 f34 = Math_fround(Math_fround(1.0) - Math_fround(f86 * f34));
 f85 = Math_fround(f34 - f85);
 f86 = Math_fround(f35 + f88);
 f87 = Math_fround(f36 + f87);
 f88 = Math_fround(f35 - f88);
 f89 = Math_fround(f34 - f89);
 i40 = HEAP32[i4 + 16 >> 2] | 0;
 i55 = HEAP32[i4 + 20 >> 2] | 0;
 i39 = HEAP32[i4 + 24 >> 2] | 0;
 f34 = Math_fround(Math_fround(f89 * f85) - Math_fround(f86 * f88));
 f35 = Math_fround(f86 * f87);
 f36 = Math_fround(f89 * f84);
 f15 = Math_fround(Math_fround(f88 * f84) - Math_fround(f85 * f87));
 f14 = Math_fround(Math_fround(f83 * f15) + Math_fround(Math_fround(f81 * f34) + Math_fround(f82 * Math_fround(f35 - f36))));
 i1 = f14 != Math_fround(0.0);
 if (i1) {
  f13 = Math_fround(Math_fround(1.0) / f14);
  f11 = Math_fround(Math_fround(Math_fround(f85 * f81) - Math_fround(f82 * f84)) * f13);
  f8 = Math_fround(-Math_fround(Math_fround(Math_fround(f88 * f81) - Math_fround(f82 * f87)) * f13));
  f5 = Math_fround(f15 * f13);
  f6 = Math_fround(f34 * f13);
  f9 = Math_fround(-Math_fround(Math_fround(Math_fround(f89 * f82) - Math_fround(f88 * f83)) * f13));
  f12 = Math_fround(Math_fround(Math_fround(f86 * f82) - Math_fround(f85 * f83)) * f13);
  f7 = Math_fround(-Math_fround(Math_fround(f36 - f35) * f13));
  f10 = Math_fround(Math_fround(Math_fround(f89 * f81) - Math_fround(f83 * f87)) * f13);
  f13 = Math_fround(-Math_fround(Math_fround(Math_fround(f86 * f81) - Math_fround(f83 * f84)) * f13));
 } else {
  f11 = Math_fround(1.0);
  f8 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(1.0);
  f9 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f10 = Math_fround(1.0);
  f13 = Math_fround(0.0);
 }
 f75 = Math_fround(Math_fround(Math_fround(f45 * f7) + Math_fround(f44 * f6)) + Math_fround(f46 * f5));
 f76 = Math_fround(Math_fround(Math_fround(f45 * f10) + Math_fround(f44 * f9)) + Math_fround(f46 * f8));
 f77 = Math_fround(Math_fround(Math_fround(f45 * f13) + Math_fround(f44 * f12)) + Math_fround(f46 * f11));
 f78 = Math_fround(Math_fround(Math_fround(f48 * f7) + Math_fround(f47 * f6)) + Math_fround(f49 * f5));
 f79 = Math_fround(Math_fround(Math_fround(f48 * f10) + Math_fround(f47 * f9)) + Math_fround(f49 * f8));
 f80 = Math_fround(Math_fround(Math_fround(f48 * f13) + Math_fround(f47 * f12)) + Math_fround(f49 * f11));
 f74 = Math_fround(Math_fround(Math_fround(f51 * f7) + Math_fround(f50 * f6)) + Math_fround(f52 * f5));
 f73 = Math_fround(Math_fround(Math_fround(f51 * f10) + Math_fround(f50 * f9)) + Math_fround(f52 * f8));
 f72 = Math_fround(Math_fround(Math_fround(f51 * f13) + Math_fround(f50 * f12)) + Math_fround(f52 * f11));
 if (i1) {
  f5 = Math_fround(Math_fround(1.0) / f14);
  f13 = Math_fround(Math_fround(Math_fround(f85 * f81) - Math_fround(f82 * f84)) * f5);
  f9 = Math_fround(-Math_fround(Math_fround(Math_fround(f88 * f81) - Math_fround(f82 * f87)) * f5));
  f10 = Math_fround(f15 * f5);
  f6 = Math_fround(-Math_fround(Math_fround(Math_fround(f89 * f82) - Math_fround(f88 * f83)) * f5));
  f11 = Math_fround(Math_fround(Math_fround(f86 * f82) - Math_fround(f85 * f83)) * f5);
  f7 = Math_fround(Math_fround(Math_fround(f89 * f81) - Math_fround(f83 * f87)) * f5);
  f12 = Math_fround(-Math_fround(Math_fround(Math_fround(f86 * f81) - Math_fround(f83 * f84)) * f5));
  f8 = Math_fround(f34 * f5);
  f5 = Math_fround(-Math_fround(Math_fround(f36 - f35) * f5));
 } else {
  f13 = Math_fround(1.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f7 = Math_fround(1.0);
  f12 = Math_fround(0.0);
  f8 = Math_fround(1.0);
  f5 = Math_fround(0.0);
 }
 f69 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = Math_fround(f53 - f69);
 f70 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f54 - f70);
 f71 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(f42 - f71);
 f68 = Math_fround(Math_fround(Math_fround(f34 * f7) + Math_fround(f35 * f6)) + Math_fround(f36 * f9));
 f67 = Math_fround(Math_fround(Math_fround(f34 * f5) + Math_fround(f35 * f8)) + Math_fround(f36 * f10));
 f36 = Math_fround(Math_fround(Math_fround(f34 * f12) + Math_fround(f35 * f11)) + Math_fround(f36 * f13));
 i65 = i16 + 4 | 0;
 f10 = Math_fround(HEAPF32[i65 >> 2]);
 i66 = i16 + 8 | 0;
 f11 = Math_fround(HEAPF32[i66 >> 2]);
 i64 = i16 + 12 | 0;
 f5 = Math_fround(HEAPF32[i64 >> 2]);
 i4 = 0;
 do {
  i1 = i4 * 3 | 0;
  f6 = Math_fround(HEAPF32[gb + 147072 + (i1 << 2) >> 2]);
  f34 = Math_fround(f10 * f6);
  f7 = Math_fround(HEAPF32[gb + 147072 + (i1 + 1 << 2) >> 2]);
  f35 = Math_fround(f11 * f7);
  f8 = Math_fround(HEAPF32[gb + 147072 + (i1 + 2 << 2) >> 2]);
  f9 = Math_fround(f5 * f8);
  HEAPF32[i22 + (i4 * 12 | 0) >> 2] = f34;
  HEAPF32[i22 + (i4 * 12 | 0) + 4 >> 2] = f35;
  HEAPF32[i22 + (i4 * 12 | 0) + 8 >> 2] = f9;
  i1 = i17 + (i4 * 12 | 0) | 0;
  HEAPF32[i1 >> 2] = f6;
  i2 = i17 + (i4 * 12 | 0) + 4 | 0;
  HEAPF32[i2 >> 2] = f7;
  i3 = i17 + (i4 * 12 | 0) + 8 | 0;
  HEAPF32[i3 >> 2] = f8;
  f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8))));
  if (f9 > Math_fround(0.0)) {
   f35 = Math_fround(Math_fround(1.0) / f9);
   HEAPF32[i1 >> 2] = Math_fround(f6 * f35);
   HEAPF32[i2 >> 2] = Math_fround(f7 * f35);
   HEAPF32[i3 >> 2] = Math_fround(f8 * f35);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 8);
 i1 = 0;
 do {
  f34 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) >> 2]);
  f35 = Math_fround(f75 * f34);
  f14 = Math_fround(f76 * f34);
  f34 = Math_fround(f77 * f34);
  f15 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 4 >> 2]);
  f35 = Math_fround(f35 + Math_fround(f78 * f15));
  f14 = Math_fround(f14 + Math_fround(f79 * f15));
  f15 = Math_fround(f34 + Math_fround(f80 * f15));
  f34 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 8 >> 2]);
  f14 = Math_fround(f68 + Math_fround(f14 + Math_fround(f73 * f34)));
  f15 = Math_fround(f36 + Math_fround(f15 + Math_fround(f72 * f34)));
  HEAPF32[i57 + (i1 * 12 | 0) >> 2] = Math_fround(f67 + Math_fround(f35 + Math_fround(f74 * f34)));
  HEAPF32[i57 + (i1 * 12 | 0) + 4 >> 2] = f14;
  HEAPF32[i57 + (i1 * 12 | 0) + 8 >> 2] = f15;
  f15 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) >> 2]);
  f14 = Math_fround(f75 * f15);
  f34 = Math_fround(f76 * f15);
  f15 = Math_fround(f77 * f15);
  f35 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f78 * f35));
  f34 = Math_fround(f34 + Math_fround(f79 * f35));
  f35 = Math_fround(f15 + Math_fround(f80 * f35));
  f15 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f73 * f15));
  f35 = Math_fround(f35 + Math_fround(f72 * f15));
  HEAPF32[i56 + (i1 * 12 | 0) >> 2] = Math_fround(f14 + Math_fround(f74 * f15));
  HEAPF32[i56 + (i1 * 12 | 0) + 4 >> 2] = f34;
  HEAPF32[i56 + (i1 * 12 | 0) + 8 >> 2] = f35;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 f12 = Math_fround(HEAPF32[i57 >> 2]);
 f6 = Math_fround(HEAPF32[i57 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i57 + 8 >> 2]);
 i38 = i57 + 12 | 0;
 f11 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f12 < f11 ? f12 : f11;
 f11 = f12 > f11 ? f12 : f11;
 f12 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f6 < f12 ? f6 : f12;
 f12 = f6 > f12 ? f6 : f12;
 f6 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f10 < f6 ? f10 : f6;
 f6 = f10 > f6 ? f10 : f6;
 i38 = i57 + 24 | 0;
 f10 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f10 ? f5 : f10;
 f10 = f11 > f10 ? f11 : f10;
 f11 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f9 < f11 ? f9 : f11;
 f11 = f12 > f11 ? f12 : f11;
 f12 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f12 ? f7 : f12;
 f12 = f6 > f12 ? f6 : f12;
 i38 = i57 + 36 | 0;
 f6 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f6 ? f5 : f6;
 f6 = f10 > f6 ? f10 : f6;
 f10 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f9 < f10 ? f9 : f10;
 f10 = f11 > f10 ? f11 : f10;
 f11 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f11 ? f7 : f11;
 f11 = f12 > f11 ? f12 : f11;
 i38 = i57 + 48 | 0;
 f12 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f12 ? f5 : f12;
 f12 = f6 > f12 ? f6 : f12;
 f6 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f9 < f6 ? f9 : f6;
 f6 = f10 > f6 ? f10 : f6;
 f10 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f10 ? f7 : f10;
 f10 = f11 > f10 ? f11 : f10;
 i38 = i57 + 60 | 0;
 f11 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f11 ? f5 : f11;
 f11 = f12 > f11 ? f12 : f11;
 f12 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f9 < f12 ? f9 : f12;
 f12 = f6 > f12 ? f6 : f12;
 f6 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f6 ? f7 : f6;
 f6 = f10 > f6 ? f10 : f6;
 i38 = i57 + 72 | 0;
 f10 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f10 ? f5 : f10;
 f10 = f11 > f10 ? f11 : f10;
 f11 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f9 = f9 < f11 ? f9 : f11;
 f11 = f12 > f11 ? f12 : f11;
 f12 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f12 ? f7 : f12;
 f12 = f6 > f12 ? f6 : f12;
 i38 = i57 + 84 | 0;
 f6 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = f5 < f6 ? f5 : f6;
 f6 = f10 > f6 ? f10 : f6;
 f10 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f11 = f11 > f10 ? f11 : f10;
 f8 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f7 = f7 < f8 ? f7 : f8;
 f8 = f12 > f8 ? f12 : f8;
 i38 = i58 + 40 | 0;
 i63 = Math_fround(HEAPF32[i38 >> 2]) <= Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i95 >> 2]);
 i62 = Math_fround(HEAPF32[i94 >> 2]) < Math_fround(0.0);
 i1 = HEAP32[i58 + 16 >> 2] | 0;
 if (i62) {
  i41 = ~~Math_fround(Math_floor(Math_fround(f12 * f6)));
  i61 = i1 + -2 | 0;
  i41 = (i41 | 0) > 0 ? i41 : 0;
  i62 = ~~Math_fround(Math_ceil(Math_fround(f12 * f5)));
  i60 = i1 + -1 | 0;
  i62 = (i62 | 0) > 0 ? i62 : 0;
  i62 = (i62 | 0) > (i60 | 0) ? i60 : i62;
  i41 = (i41 | 0) > (i61 | 0) ? i61 : i41;
 } else {
  i41 = ~~Math_fround(Math_floor(Math_fround(f12 * f5)));
  i61 = i1 + -2 | 0;
  i41 = (i41 | 0) > 0 ? i41 : 0;
  i62 = ~~Math_fround(Math_ceil(Math_fround(f12 * f6)));
  i60 = i1 + -1 | 0;
  i62 = (i62 | 0) > 0 ? i62 : 0;
  i62 = (i62 | 0) > (i60 | 0) ? i60 : i62;
  i41 = (i41 | 0) > (i61 | 0) ? i61 : i41;
 }
 if (f37 < Math_fround(0.0)) {
  i61 = ~~Math_fround(Math_floor(Math_fround(f43 * f8)));
  i33 = HEAP32[i58 + 20 >> 2] | 0;
  i59 = i33 + -2 | 0;
  i61 = (i61 | 0) > 0 ? i61 : 0;
  i60 = ~~Math_fround(Math_ceil(Math_fround(f43 * f7)));
  i33 = i33 + -1 | 0;
  i60 = (i60 | 0) > 0 ? i60 : 0;
  i60 = (i60 | 0) > (i33 | 0) ? i33 : i60;
  i61 = (i61 | 0) > (i59 | 0) ? i59 : i61;
 } else {
  i61 = ~~Math_fround(Math_floor(Math_fround(f43 * f7)));
  i33 = HEAP32[i58 + 20 >> 2] | 0;
  i59 = i33 + -2 | 0;
  i61 = (i61 | 0) > 0 ? i61 : 0;
  i60 = ~~Math_fround(Math_ceil(Math_fround(f43 * f8)));
  i33 = i33 + -1 | 0;
  i60 = (i60 | 0) > 0 ? i60 : 0;
  i60 = (i60 | 0) > (i33 | 0) ? i33 : i60;
  i61 = (i61 | 0) > (i59 | 0) ? i59 : i61;
 }
 f13 = Math_fround(__ZNK5physx2Gu11HeightField14computeExtremeEjjjj(i58, i41, i62, i61, i60));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i93 >> 2]));
 if (i63) {
  if ((f9 < f10 ? f9 : f10) > f13) {
   i103 = 0;
   STACKTOP = i100;
   return i103 | 0;
  }
 } else if (f11 < f13) {
  i103 = 0;
  STACKTOP = i100;
  return i103 | 0;
 }
 i59 = i101 + 4096 | 0;
 i19 = 0;
 do {
  do if ((HEAP32[i56 + (i19 * 12 | 0) + 4 >> 2] | 0) <= 0) {
   i2 = i57 + (i19 * 12 | 0) + 4 | 0;
   f35 = Math_fround(HEAPF32[i2 >> 2]);
   f37 = Math_fround(HEAPF32[i102 >> 2]);
   i32 = f35 < Math_fround(f13 + f37);
   i33 = f35 > Math_fround(f13 - f37);
   if (i63 ? i32 : i33) {
    f5 = Math_fround(HEAPF32[i57 + (i19 * 12 | 0) >> 2]);
    f6 = Math_fround(HEAPF32[i57 + (i19 * 12 | 0) + 8 >> 2]);
    f7 = Math_fround(f5 * Math_fround(HEAPF32[i95 >> 2]));
    f8 = Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2]));
    if (f7 >= Math_fround(0.0) & f8 >= Math_fround(0.0)) {
     i1 = HEAP32[i92 >> 2] | 0;
     if (f7 < Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + Math_fround(1.0))) if (f8 < Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) + Math_fround(1.0))) {
      i17 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i1, Math_fround(f12 * f5), Math_fround(f43 * f6), i23, i24) | 0;
      f7 = Math_fround(HEAPF32[i23 >> 2]);
      f8 = Math_fround(HEAPF32[i24 >> 2]);
      f11 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff(i95, i17, f7, f8));
      f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f11);
      f5 = Math_fround(HEAPF32[i102 >> 2]);
      f6 = Math_fround(HEAPF32[i38 >> 2]);
      if (!(f6 <= f11) | (!(f11 <= f5) | !(f6 <= Math_fround(0.0)))) if (!(f6 > f11 & (f11 > Math_fround(-f5) & f6 > Math_fround(0.0)))) break;
      i18 = __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff(i95, i17, f7, f8) | 0;
      if ((i18 | 0) != -1) {
       f5 = Math_fround(HEAPF32[i23 >> 2]);
       f6 = Math_fround(HEAPF32[i24 >> 2]);
       i16 = HEAP32[i92 >> 2] | 0;
       f8 = Math_fround(HEAPF32[i95 >> 2]);
       f7 = Math_fround(HEAPF32[i21 >> 2]);
       f9 = Math_fround(HEAPF32[i20 >> 2]);
       i2 = HEAP32[i16 + 36 >> 2] | 0;
       do if ((HEAP8[i2 + (i17 << 2) + 2 >> 0] | 0) < 0) {
        i3 = HEAP16[i2 + (i17 << 2) >> 1] | 0;
        i1 = (HEAP32[i16 + 20 >> 2] | 0) + i17 | 0;
        i4 = HEAP16[i2 + (i1 + 1 << 2) >> 1] | 0;
        if (!(f6 >= f5)) {
         i1 = HEAP16[i2 + (i1 << 2) >> 1] | 0;
         i2 = i1 - i4 | 0;
         i1 = i3 - i1 | 0;
         break;
        } else {
         i1 = HEAP16[i2 + (i17 + 1 << 2) >> 1] | 0;
         i2 = i3 - i1 | 0;
         i1 = i1 - i4 | 0;
         break;
        }
       } else {
        i3 = HEAP16[i2 + (i17 + 1 << 2) >> 1] | 0;
        i1 = (HEAP32[i16 + 20 >> 2] | 0) + i17 | 0;
        i4 = HEAP16[i2 + (i1 << 2) >> 1] | 0;
        if (!(Math_fround(f5 + f6) <= Math_fround(1.0))) {
         i1 = HEAP16[i2 + (i1 + 1 << 2) >> 1] | 0;
         i2 = i4 - i1 | 0;
         i1 = i3 - i1 | 0;
         break;
        } else {
         i1 = HEAP16[i2 + (i17 << 2) >> 1] | 0;
         i2 = i1 - i3 | 0;
         i1 = i1 - i4 | 0;
         break;
        }
       } while (0);
       f6 = Math_fround(f8 * Math_fround(i1 | 0));
       f5 = Math_fround(f9 * Math_fround(i2 | 0));
       if (!(Math_fround(HEAPF32[i16 + 40 >> 2]) <= Math_fround(0.0))) {
        f5 = Math_fround(-f5);
        f8 = Math_fround(-f6);
        f7 = Math_fround(-f7);
       } else f8 = f6;
       f6 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f5 * f5));
       if (f6 > Math_fround(0.0)) {
        f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
        f10 = Math_fround(f5 * f37);
        f9 = Math_fround(f7 * f37);
        f5 = Math_fround(f8 * f37);
       } else {
        f10 = Math_fround(0.0);
        f9 = Math_fround(0.0);
        f5 = Math_fround(0.0);
       }
       f6 = Math_fround(HEAPF32[i22 + (i19 * 12 | 0) >> 2]);
       f7 = Math_fround(HEAPF32[i22 + (i19 * 12 | 0) + 4 >> 2]);
       f8 = Math_fround(HEAPF32[i22 + (i19 * 12 | 0) + 8 >> 2]);
       i1 = HEAP32[i59 >> 2] | 0;
       if (i1 >>> 0 <= 63) {
        f37 = Math_fround(f11 * f9);
        f14 = Math_fround(Math_fround(Math_fround(f83 * f5) + Math_fround(f86 * f9)) + Math_fround(f89 * f10));
        f11 = Math_fround(Math_fround(Math_fround(f82 * f5) + Math_fround(f85 * f9)) + Math_fround(f88 * f10));
        f10 = Math_fround(Math_fround(Math_fround(f81 * f5) + Math_fround(f84 * f9)) + Math_fround(f87 * f10));
        f35 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f46 * f6) + Math_fround(f49 * f7)) + Math_fround(f52 * f8)));
        f34 = Math_fround(f54 + Math_fround(Math_fround(Math_fround(f45 * f6) + Math_fround(f48 * f7)) + Math_fround(f51 * f8)));
        f15 = Math_fround(f53 + Math_fround(Math_fround(Math_fround(f44 * f6) + Math_fround(f47 * f7)) + Math_fround(f50 * f8)));
        HEAP32[i59 >> 2] = i1 + 1;
        HEAPF32[i101 + (i1 << 6) >> 2] = f10;
        HEAPF32[i101 + (i1 << 6) + 4 >> 2] = f11;
        HEAPF32[i101 + (i1 << 6) + 8 >> 2] = f14;
        HEAPF32[i101 + (i1 << 6) + 16 >> 2] = f15;
        HEAPF32[i101 + (i1 << 6) + 20 >> 2] = f34;
        HEAPF32[i101 + (i1 << 6) + 24 >> 2] = f35;
        HEAPF32[i101 + (i1 << 6) + 12 >> 2] = f37;
        HEAP32[i101 + (i1 << 6) + 48 >> 2] = -1;
        HEAP32[i101 + (i1 << 6) + 52 >> 2] = i18;
       }
      }
     }
    }
   }
  } while (0);
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != 8);
 i1 = i97 + 4 | 0;
 i2 = i97 + 8 | 0;
 i3 = i97 + 12 | 0;
 i4 = i97 + 52 | 0;
 i16 = i97 + 16 | 0;
 i17 = i97 + 20 | 0;
 i18 = i97 + 24 | 0;
 i19 = i97 + 28 | 0;
 i20 = i97 + 32 | 0;
 i21 = i97 + 36 | 0;
 i22 = i97 + 40 | 0;
 i23 = i97 + 44 | 0;
 i24 = i97 + 48 | 0;
 i25 = i97 + 56 | 0;
 i26 = i97 + 60 | 0;
 i27 = i97 + 64 | 0;
 i28 = i97 + 68 | 0;
 i33 = 0;
 do {
  i30 = i33 << 1;
  i29 = HEAPU8[gb + 768836 + i30 >> 0] | 0;
  f54 = Math_fround(HEAPF32[i56 + (i29 * 12 | 0) + 4 >> 2]);
  i30 = HEAPU8[(i30 | 1) + (gb + 768836) >> 0] | 0;
  do if (!(Math_fround(f54 + Math_fround(HEAPF32[i56 + (i30 * 12 | 0) + 4 >> 2])) > Math_fround(0.0))) {
   i31 = i57 + (i29 * 12 | 0) | 0;
   i32 = i57 + (i30 * 12 | 0) | 0;
   i104 = Math_fround(HEAPF32[i38 >> 2]) != Math_fround(0.0);
   f5 = Math_fround(HEAPF32[i57 + (i29 * 12 | 0) + 4 >> 2]);
   if (i104) {
    if (f5 > f13) if (Math_fround(HEAPF32[i57 + (i30 * 12 | 0) + 4 >> 2]) > f13) break;
   } else if (f5 < f13) if (Math_fround(HEAPF32[i57 + (i30 * 12 | 0) + 4 >> 2]) < f13) break;
   f52 = Math_fround(HEAPF32[i32 >> 2]);
   f52 = Math_fround(f52 - Math_fround(HEAPF32[i31 >> 2]));
   f53 = Math_fround(Math_fround(HEAPF32[i57 + (i30 * 12 | 0) + 4 >> 2]) - f5);
   f54 = Math_fround(HEAPF32[i57 + (i30 * 12 | 0) + 8 >> 2]);
   f54 = Math_fround(f54 - Math_fround(HEAPF32[i57 + (i29 * 12 | 0) + 8 >> 2]));
   i104 = HEAP32[i102 >> 2] | 0;
   HEAPF32[i97 >> 2] = f52;
   HEAPF32[i1 >> 2] = f53;
   HEAPF32[i2 >> 2] = f54;
   HEAP32[i3 >> 2] = i101;
   HEAPF32[i16 >> 2] = f81;
   HEAPF32[i17 >> 2] = f82;
   HEAPF32[i18 >> 2] = f83;
   HEAPF32[i19 >> 2] = f84;
   HEAPF32[i20 >> 2] = f85;
   HEAPF32[i21 >> 2] = f86;
   HEAPF32[i22 >> 2] = f87;
   HEAPF32[i23 >> 2] = f88;
   HEAPF32[i24 >> 2] = f89;
   HEAP32[i4 >> 2] = i40;
   HEAP32[i25 >> 2] = i55;
   HEAP32[i26 >> 2] = i39;
   HEAP32[i27 >> 2] = i104;
   HEAP32[i28 >> 2] = -1;
   __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i95, i31, i32, i97, 0);
  } while (0);
  i33 = i33 + 1 | 0;
 } while ((i33 | 0) != 12);
 if (i41 >>> 0 <= i62 >>> 0) {
  i39 = i61 >>> 0 > i60 >>> 0;
  i40 = i58 + 20 | 0;
  i24 = i58 + 36 | 0;
  i25 = i96 + 4 | 0;
  i26 = i96 + 8 | 0;
  i27 = i99 + 4 | 0;
  i28 = i99 + 8 | 0;
  i29 = i91 + 4 | 0;
  i30 = i91 + 8 | 0;
  i31 = i97 + 4 | 0;
  i32 = i97 + 8 | 0;
  i33 = i98 + 4 | 0;
  i38 = i98 + 8 | 0;
  i23 = i41;
  do {
   if (!i39) {
    f14 = Math_fround(i23 >>> 0);
    i22 = i61;
    do {
     i21 = (Math_imul(HEAP32[i40 >> 2] | 0, i23) | 0) + i22 | 0;
     do if ((HEAP8[(HEAP32[(HEAP32[i92 >> 2] | 0) + 36 >> 2] | 0) + (i21 << 2) + 3 >> 0] | 0) < 0) {
      f15 = Math_fround(f14 * Math_fround(HEAPF32[i94 >> 2]));
      f34 = Math_fround(HEAPF32[i93 >> 2]);
      f34 = Math_fround(f34 * Math_fround(HEAP16[(HEAP32[i24 >> 2] | 0) + (i21 << 2) >> 1] | 0));
      f35 = Math_fround(Math_fround(i22 >>> 0) * Math_fround(HEAPF32[i90 >> 2]));
      f7 = Math_fround(f15 - f67);
      f6 = Math_fround(f34 - f68);
      f53 = Math_fround(f35 - f36);
      f54 = Math_fround(Math_fround(f77 * f53) + Math_fround(Math_fround(f75 * f7) + Math_fround(f76 * f6)));
      f5 = Math_fround(Math_fround(f80 * f53) + Math_fround(Math_fround(f78 * f7) + Math_fround(f79 * f6)));
      f6 = Math_fround(Math_fround(f72 * f53) + Math_fround(Math_fround(f74 * f7) + Math_fround(f73 * f6)));
      HEAPF32[i96 >> 2] = f54;
      HEAPF32[i25 >> 2] = f5;
      HEAPF32[i26 >> 2] = f6;
      f54 = Math_fround(Math_abs(Math_fround(f54)));
      f54 = Math_fround(f54 - Math_fround(HEAPF32[i65 >> 2]));
      f7 = Math_fround(HEAPF32[i102 >> 2]);
      if (Math_fround(f54 - f7) < Math_fround(0.0)) {
       f54 = Math_fround(Math_abs(Math_fround(f5)));
       if (Math_fround(Math_fround(f54 - Math_fround(HEAPF32[i66 >> 2])) - f7) < Math_fround(0.0)) {
        f54 = Math_fround(Math_abs(Math_fround(f6)));
        if (Math_fround(Math_fround(f54 - Math_fround(HEAPF32[i64 >> 2])) - f7) < Math_fround(0.0)) {
         __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i99, i95, i21, i23, i22);
         if (i63) {
          i1 = HEAP32[i99 >> 2] | 0;
          i2 = HEAP32[i27 >> 2] | 0;
          i3 = HEAP32[i28 >> 2] | 0;
         } else {
          f52 = Math_fround(-Math_fround(HEAPF32[i99 >> 2]));
          f53 = Math_fround(-Math_fround(HEAPF32[i27 >> 2]));
          f54 = Math_fround(-Math_fround(HEAPF32[i28 >> 2]));
          i1 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
          i2 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
          i3 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
         }
         f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f6 = Math_fround(f8 * f8);
         f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f6 = Math_fround(Math_fround(f7 * f7) + f6);
         f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f6 = Math_fround(Math_fround(f5 * f5) + f6);
         if (f6 > Math_fround(0.0)) {
          f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
          f13 = Math_fround(f5 * f11);
          f12 = Math_fround(f7 * f11);
          f11 = Math_fround(f8 * f11);
         } else {
          f13 = Math_fround(0.0);
          f12 = Math_fround(0.0);
          f11 = Math_fround(0.0);
         }
         f54 = Math_fround(-Math_fround(Math_fround(Math_fround(f75 * f11) + Math_fround(f76 * f12)) + Math_fround(f77 * f13)));
         f8 = Math_fround(-Math_fround(Math_fround(Math_fround(f78 * f11) + Math_fround(f79 * f12)) + Math_fround(f80 * f13)));
         f6 = Math_fround(-Math_fround(Math_fround(Math_fround(f74 * f11) + Math_fround(f73 * f12)) + Math_fround(f72 * f13)));
         HEAPF32[i91 >> 2] = f54;
         HEAPF32[i29 >> 2] = f8;
         HEAPF32[i30 >> 2] = f6;
         i18 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
         i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
         i20 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
         i3 = 0;
         i4 = 0;
         i16 = 0;
         f6 = Math_fround(-3402823469999999843913219.0e14);
         f8 = Math_fround(-3402823469999999843913219.0e14);
         i17 = 0;
         i2 = -1;
         i1 = -2;
         while (1) {
          i104 = (i17 >>> 0) % 3 | 0;
          f7 = i17 >>> 0 > 2 ? Math_fround(-1.0) : Math_fround(1.0);
          HEAPF32[i97 >> 2] = Math_fround(0.0);
          HEAPF32[i31 >> 2] = Math_fround(0.0);
          HEAPF32[i32 >> 2] = Math_fround(0.0);
          HEAPF32[i97 + (i104 << 2) >> 2] = f7;
          f5 = Math_fround(f7 * Math_fround(HEAPF32[i91 + (i104 << 2) >> 2]));
          f54 = Math_fround(HEAPF32[i96 + (i104 << 2) >> 2]);
          f7 = Math_fround(f7 * Math_fround(f54 - Math_fround(f7 * Math_fround(HEAPF32[i65 + (i104 << 2) >> 2]))));
          if (f7 >= Math_fround(0.0)) {
           i103 = 74;
           break;
          }
          do if (f5 > Math_fround(0.0)) {
           if (f7 > f6) {
            i16 = HEAP32[i32 >> 2] | 0;
            i4 = HEAP32[i31 >> 2] | 0;
            i3 = HEAP32[i97 >> 2] | 0;
            f6 = f7;
            i2 = i17;
           }
           f5 = Math_fround(f7 / f5);
           if (!(f5 > f8)) {
            f5 = f8;
            break;
           }
           i1 = i17;
          } else f5 = f8; while (0);
          i17 = i17 + 1 | 0;
          if (i17 >>> 0 >= 6) break; else f8 = f5;
         }
         if ((i103 | 0) == 74) {
          i103 = 0;
          break;
         }
         i104 = (i2 | 0) == (i1 | 0);
         f10 = i104 ? f6 : f5;
         f8 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i104 ? i3 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f6 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i104 ? i4 : i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f53 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i104 ? i16 : i20, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f54 = Math_fround(Math_fround(f73 * f53) + Math_fround(Math_fround(f79 * f6) + Math_fround(f76 * f8)));
         f9 = Math_fround(Math_fround(f72 * f53) + Math_fround(Math_fround(f80 * f6) + Math_fround(f77 * f8)));
         HEAPF32[i98 >> 2] = Math_fround(Math_fround(f74 * f53) + Math_fround(Math_fround(f78 * f6) + Math_fround(f75 * f8)));
         HEAPF32[i33 >> 2] = f54;
         HEAPF32[i38 >> 2] = f9;
         __ZNK5physx2Gu15HeightFieldUtil30clipShapeNormalToVertexVoronoiERNS_6PxVec3Ejjj(i95, i98, i21, i23, i22) | 0;
         f9 = Math_fround(HEAPF32[i98 >> 2]);
         f54 = Math_fround(f11 * f9);
         f8 = Math_fround(HEAPF32[i33 >> 2]);
         f54 = Math_fround(f54 + Math_fround(f12 * f8));
         f6 = Math_fround(HEAPF32[i38 >> 2]);
         if (!(Math_fround(f54 + Math_fround(f13 * f6)) < Math_fround(1.1920929e-07))) {
          f5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f6 * f6));
          if (f5 > Math_fround(0.0)) {
           f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
           f7 = Math_fround(f6 * f5);
           f6 = Math_fround(f8 * f5);
           f5 = Math_fround(f9 * f5);
          } else {
           f7 = Math_fround(0.0);
           f6 = Math_fround(0.0);
           f5 = Math_fround(0.0);
          }
          HEAPF32[i98 >> 2] = f5;
          HEAPF32[i33 >> 2] = f6;
          HEAPF32[i38 >> 2] = f7;
          i1 = __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj(i95, i21, i23, i22) | 0;
          f5 = Math_fround(HEAPF32[i98 >> 2]);
          f6 = Math_fround(HEAPF32[i33 >> 2]);
          f7 = Math_fround(HEAPF32[i38 >> 2]);
          i2 = HEAP32[i59 >> 2] | 0;
          if (i2 >>> 0 > 63) break;
          f51 = Math_fround(Math_fround(Math_fround(f83 * f5) + Math_fround(f86 * f6)) + Math_fround(f89 * f7));
          f50 = Math_fround(Math_fround(Math_fround(f82 * f5) + Math_fround(f85 * f6)) + Math_fround(f88 * f7));
          f49 = Math_fround(Math_fround(Math_fround(f81 * f5) + Math_fround(f84 * f6)) + Math_fround(f87 * f7));
          f54 = Math_fround(f71 + Math_fround(Math_fround(f89 * f35) + Math_fround(Math_fround(f83 * f15) + Math_fround(f86 * f34))));
          f53 = Math_fround(f70 + Math_fround(Math_fround(f88 * f35) + Math_fround(Math_fround(f82 * f15) + Math_fround(f85 * f34))));
          f52 = Math_fround(f69 + Math_fround(Math_fround(f87 * f35) + Math_fround(Math_fround(f81 * f15) + Math_fround(f84 * f34))));
          HEAP32[i59 >> 2] = i2 + 1;
          HEAPF32[i101 + (i2 << 6) >> 2] = f49;
          HEAPF32[i101 + (i2 << 6) + 4 >> 2] = f50;
          HEAPF32[i101 + (i2 << 6) + 8 >> 2] = f51;
          HEAPF32[i101 + (i2 << 6) + 16 >> 2] = f52;
          HEAPF32[i101 + (i2 << 6) + 20 >> 2] = f53;
          HEAPF32[i101 + (i2 << 6) + 24 >> 2] = f54;
          HEAPF32[i101 + (i2 << 6) + 12 >> 2] = f10;
          HEAP32[i101 + (i2 << 6) + 48 >> 2] = -1;
          HEAP32[i101 + (i2 << 6) + 52 >> 2] = i1;
         }
        }
       }
      }
     } while (0);
     i22 = i22 + 1 | 0;
    } while (i22 >>> 0 <= i60 >>> 0);
   }
   i23 = i23 + 1 | 0;
  } while (i23 >>> 0 <= i62 >>> 0);
 }
 i104 = (HEAP32[i59 >> 2] | 0) != 0;
 STACKTOP = i100;
 return i104 | 0;
}

function __ZN13SpeedTreeWind16SBranchWindLevel8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486433 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486448 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486463 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486478 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486493 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486508 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486523 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486538 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486553 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486568 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486583 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486608 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486633 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486658 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486683 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486708 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 171; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 171;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486733 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 182; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 182;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 182) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486758 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 193; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 193;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 193) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486783 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 204; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 204;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 204) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486808 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 215; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 215;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 215) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486833 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 226; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 226;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 226) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486844 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 237; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 237;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 237) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486855 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 248; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 248;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 248) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486866 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 259; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 259;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 259) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486877 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 270; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 270;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 270) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486888 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 281; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 281;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 281) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486899 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 292; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 292;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 292) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486910 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 303; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 303;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 303) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486921 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 314; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 314;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 314) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486932 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 325; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 325;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 325) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486943 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 336; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 336;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 336) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486957 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   do if (i1 >>> 0 < i2 >>> 0) i8 = 347; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 347;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   } while (0);
   if ((i8 | 0) == 347) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486967 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 358; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 358;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 358) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i9 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0, i156 = 0, f157 = f0, f158 = f0, f159 = f0, i160 = 0, i161 = 0, i162 = 0, f163 = f0, i164 = 0, f165 = f0, f166 = f0, f167 = f0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0;
 i76 = HEAP32[i1 >> 2] | 0;
 i80 = HEAP32[i1 + 4 >> 2] | 0;
 i81 = HEAP32[i1 + 32 >> 2] | 0;
 i82 = HEAP32[i1 + 36 >> 2] | 0;
 i83 = HEAP32[i1 + 64 >> 2] | 0;
 i77 = HEAP32[i1 + 68 >> 2] | 0;
 i78 = HEAP32[i1 + 96 >> 2] | 0;
 i79 = HEAP32[i1 + 100 >> 2] | 0;
 i49 = HEAP32[i1 + 16 >> 2] | 0;
 i12 = HEAP32[i76 >> 2] | 0;
 i36 = HEAP32[i76 + 4 >> 2] | 0;
 i45 = HEAP32[i76 + 8 >> 2] | 0;
 i65 = HEAP32[i76 + 12 >> 2] | 0;
 i20 = HEAP32[i80 >> 2] | 0;
 i39 = HEAP32[i80 + 4 >> 2] | 0;
 i33 = HEAP32[i80 + 8 >> 2] | 0;
 i66 = HEAP32[i80 + 12 >> 2] | 0;
 i67 = i76 + 16 | 0;
 i28 = HEAP32[i67 >> 2] | 0;
 i23 = HEAP32[i67 + 4 >> 2] | 0;
 i15 = HEAP32[i67 + 8 >> 2] | 0;
 i67 = HEAP32[i67 + 12 >> 2] | 0;
 i68 = i80 + 16 | 0;
 i9 = HEAP32[i68 >> 2] | 0;
 i5 = HEAP32[i68 + 4 >> 2] | 0;
 i1 = HEAP32[i68 + 8 >> 2] | 0;
 i68 = HEAP32[i68 + 12 >> 2] | 0;
 i14 = HEAP32[i81 >> 2] | 0;
 i38 = HEAP32[i81 + 4 >> 2] | 0;
 i47 = HEAP32[i81 + 8 >> 2] | 0;
 i69 = HEAP32[i81 + 12 >> 2] | 0;
 i22 = HEAP32[i82 >> 2] | 0;
 i41 = HEAP32[i82 + 4 >> 2] | 0;
 i34 = HEAP32[i82 + 8 >> 2] | 0;
 i70 = HEAP32[i82 + 12 >> 2] | 0;
 i71 = i81 + 16 | 0;
 i30 = HEAP32[i71 >> 2] | 0;
 i25 = HEAP32[i71 + 4 >> 2] | 0;
 i17 = HEAP32[i71 + 8 >> 2] | 0;
 i71 = HEAP32[i71 + 12 >> 2] | 0;
 i72 = i82 + 16 | 0;
 i10 = HEAP32[i72 >> 2] | 0;
 i6 = HEAP32[i72 + 4 >> 2] | 0;
 i2 = HEAP32[i72 + 8 >> 2] | 0;
 i72 = HEAP32[i72 + 12 >> 2] | 0;
 i16 = HEAP32[i83 >> 2] | 0;
 i40 = HEAP32[i83 + 4 >> 2] | 0;
 i48 = HEAP32[i83 + 8 >> 2] | 0;
 i73 = HEAP32[i83 + 12 >> 2] | 0;
 i24 = HEAP32[i77 >> 2] | 0;
 i43 = HEAP32[i77 + 4 >> 2] | 0;
 i35 = HEAP32[i77 + 8 >> 2] | 0;
 i74 = HEAP32[i77 + 12 >> 2] | 0;
 i75 = i83 + 16 | 0;
 i31 = HEAP32[i75 >> 2] | 0;
 i27 = HEAP32[i75 + 4 >> 2] | 0;
 i19 = HEAP32[i75 + 8 >> 2] | 0;
 i75 = HEAP32[i75 + 12 >> 2] | 0;
 i60 = i77 + 16 | 0;
 i11 = HEAP32[i60 >> 2] | 0;
 i7 = HEAP32[i60 + 4 >> 2] | 0;
 i3 = HEAP32[i60 + 8 >> 2] | 0;
 i60 = HEAP32[i60 + 12 >> 2] | 0;
 i18 = HEAP32[i78 >> 2] | 0;
 i42 = HEAP32[i78 + 4 >> 2] | 0;
 i46 = HEAP32[i78 + 8 >> 2] | 0;
 i61 = HEAP32[i78 + 12 >> 2] | 0;
 i26 = HEAP32[i79 >> 2] | 0;
 i44 = HEAP32[i79 + 4 >> 2] | 0;
 i37 = HEAP32[i79 + 8 >> 2] | 0;
 i62 = HEAP32[i79 + 12 >> 2] | 0;
 i63 = i78 + 16 | 0;
 i32 = HEAP32[i63 >> 2] | 0;
 i29 = HEAP32[i63 + 4 >> 2] | 0;
 i21 = HEAP32[i63 + 8 >> 2] | 0;
 i63 = HEAP32[i63 + 12 >> 2] | 0;
 i64 = i79 + 16 | 0;
 i13 = HEAP32[i64 >> 2] | 0;
 i8 = HEAP32[i64 + 4 >> 2] | 0;
 i4 = HEAP32[i64 + 8 >> 2] | 0;
 i64 = HEAP32[i64 + 12 >> 2] | 0;
 f51 = Math_fround(HEAPF32[i49 + 48 >> 2]);
 f52 = Math_fround(HEAPF32[i49 + 52 >> 2]);
 f53 = Math_fround(HEAPF32[i49 + 56 >> 2]);
 f54 = Math_fround(HEAPF32[i49 + 60 >> 2]);
 f55 = Math_fround(HEAPF32[i49 + 64 >> 2]);
 f56 = Math_fround(HEAPF32[i49 + 68 >> 2]);
 f57 = Math_fround(HEAPF32[i49 + 72 >> 2]);
 f58 = Math_fround(HEAPF32[i49 + 76 >> 2]);
 i59 = HEAP32[i49 + 4 >> 2] | 0;
 if (!i59) {
  i90 = i18;
  i93 = i16;
  i96 = i14;
  i99 = i12;
  i89 = i42;
  i92 = i40;
  i95 = i38;
  i98 = i36;
  i88 = i46;
  i91 = i48;
  i94 = i47;
  i97 = i45;
  i18 = i26;
  i16 = i24;
  i84 = i22;
  i87 = i20;
  i24 = i44;
  i20 = i43;
  i12 = i41;
  i86 = i39;
  i26 = i37;
  i22 = i35;
  i14 = i34;
  i85 = i33;
  i37 = i32;
  i34 = i31;
  i31 = i30;
  i38 = i29;
  i35 = i27;
  i32 = i25;
  i29 = i23;
  i39 = i21;
  i36 = i19;
  i33 = i17;
  i30 = i15;
  i49 = i13;
  i46 = i11;
  i43 = i10;
  i40 = i9;
  i50 = i8;
  i47 = i7;
  i44 = i6;
  i41 = i5;
  i59 = i4;
  i48 = i3;
  i45 = i2;
  i42 = i1;
  HEAP32[i76 >> 2] = i99;
  i27 = i76 + 4 | 0;
  HEAP32[i27 >> 2] = i98;
  i27 = i76 + 8 | 0;
  HEAP32[i27 >> 2] = i97;
  i27 = i76 + 12 | 0;
  HEAP32[i27 >> 2] = i65;
  HEAP32[i81 >> 2] = i96;
  i65 = i81 + 4 | 0;
  HEAP32[i65 >> 2] = i95;
  i65 = i81 + 8 | 0;
  HEAP32[i65 >> 2] = i94;
  i65 = i81 + 12 | 0;
  HEAP32[i65 >> 2] = i69;
  HEAP32[i83 >> 2] = i93;
  i69 = i83 + 4 | 0;
  HEAP32[i69 >> 2] = i92;
  i69 = i83 + 8 | 0;
  HEAP32[i69 >> 2] = i91;
  i69 = i83 + 12 | 0;
  HEAP32[i69 >> 2] = i73;
  HEAP32[i78 >> 2] = i90;
  i73 = i78 + 4 | 0;
  HEAP32[i73 >> 2] = i89;
  i73 = i78 + 8 | 0;
  HEAP32[i73 >> 2] = i88;
  i73 = i78 + 12 | 0;
  HEAP32[i73 >> 2] = i61;
  HEAP32[i80 >> 2] = i87;
  i73 = i80 + 4 | 0;
  HEAP32[i73 >> 2] = i86;
  i73 = i80 + 8 | 0;
  HEAP32[i73 >> 2] = i85;
  i73 = i80 + 12 | 0;
  HEAP32[i73 >> 2] = i66;
  HEAP32[i82 >> 2] = i84;
  i73 = i82 + 4 | 0;
  HEAP32[i73 >> 2] = i12;
  i73 = i82 + 8 | 0;
  HEAP32[i73 >> 2] = i14;
  i73 = i82 + 12 | 0;
  HEAP32[i73 >> 2] = i70;
  HEAP32[i77 >> 2] = i16;
  i73 = i77 + 4 | 0;
  HEAP32[i73 >> 2] = i20;
  i73 = i77 + 8 | 0;
  HEAP32[i73 >> 2] = i22;
  i73 = i77 + 12 | 0;
  HEAP32[i73 >> 2] = i74;
  HEAP32[i79 >> 2] = i18;
  i74 = i79 + 4 | 0;
  HEAP32[i74 >> 2] = i24;
  i74 = i79 + 8 | 0;
  HEAP32[i74 >> 2] = i26;
  i74 = i79 + 12 | 0;
  HEAP32[i74 >> 2] = i62;
  i74 = i76 + 16 | 0;
  HEAP32[i74 >> 2] = i28;
  i74 = i76 + 20 | 0;
  HEAP32[i74 >> 2] = i29;
  i74 = i76 + 24 | 0;
  HEAP32[i74 >> 2] = i30;
  i76 = i76 + 28 | 0;
  HEAP32[i76 >> 2] = i67;
  i76 = i81 + 16 | 0;
  HEAP32[i76 >> 2] = i31;
  i76 = i81 + 20 | 0;
  HEAP32[i76 >> 2] = i32;
  i76 = i81 + 24 | 0;
  HEAP32[i76 >> 2] = i33;
  i81 = i81 + 28 | 0;
  HEAP32[i81 >> 2] = i71;
  i81 = i83 + 16 | 0;
  HEAP32[i81 >> 2] = i34;
  i81 = i83 + 20 | 0;
  HEAP32[i81 >> 2] = i35;
  i81 = i83 + 24 | 0;
  HEAP32[i81 >> 2] = i36;
  i83 = i83 + 28 | 0;
  HEAP32[i83 >> 2] = i75;
  i83 = i78 + 16 | 0;
  HEAP32[i83 >> 2] = i37;
  i83 = i78 + 20 | 0;
  HEAP32[i83 >> 2] = i38;
  i83 = i78 + 24 | 0;
  HEAP32[i83 >> 2] = i39;
  i83 = i78 + 28 | 0;
  HEAP32[i83 >> 2] = i63;
  i83 = i80 + 16 | 0;
  HEAP32[i83 >> 2] = i40;
  i83 = i80 + 20 | 0;
  HEAP32[i83 >> 2] = i41;
  i83 = i80 + 24 | 0;
  HEAP32[i83 >> 2] = i42;
  i83 = i80 + 28 | 0;
  HEAP32[i83 >> 2] = i68;
  i83 = i82 + 16 | 0;
  HEAP32[i83 >> 2] = i43;
  i83 = i82 + 20 | 0;
  HEAP32[i83 >> 2] = i44;
  i83 = i82 + 24 | 0;
  HEAP32[i83 >> 2] = i45;
  i83 = i82 + 28 | 0;
  HEAP32[i83 >> 2] = i72;
  i83 = i77 + 16 | 0;
  HEAP32[i83 >> 2] = i46;
  i83 = i77 + 20 | 0;
  HEAP32[i83 >> 2] = i47;
  i83 = i77 + 24 | 0;
  HEAP32[i83 >> 2] = i48;
  i83 = i77 + 28 | 0;
  HEAP32[i83 >> 2] = i60;
  i83 = i79 + 16 | 0;
  HEAP32[i83 >> 2] = i49;
  i83 = i79 + 20 | 0;
  HEAP32[i83 >> 2] = i50;
  i83 = i79 + 24 | 0;
  HEAP32[i83 >> 2] = i59;
  i83 = i79 + 28 | 0;
  HEAP32[i83 >> 2] = i64;
  return;
 }
 i50 = 0;
 i49 = i49 + 128 | 0;
 while (1) {
  i173 = i49 + 240 | 0;
  f109 = Math_fround(HEAPF32[i173 >> 2]);
  i172 = i49 + 244 | 0;
  f107 = Math_fround(HEAPF32[i172 >> 2]);
  i171 = i49 + 248 | 0;
  f105 = Math_fround(HEAPF32[i171 >> 2]);
  i170 = i49 + 252 | 0;
  f100 = Math_fround(HEAPF32[i170 >> 2]);
  f181 = Math_fround(HEAPF32[i49 >> 2]);
  i169 = i49 + 4 | 0;
  f127 = Math_fround(HEAPF32[i169 >> 2]);
  i168 = i49 + 8 | 0;
  f119 = Math_fround(HEAPF32[i168 >> 2]);
  i164 = i49 + 12 | 0;
  f174 = Math_fround(HEAPF32[i164 >> 2]);
  f167 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f167 * f181);
  f166 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f127 = Math_fround(f166 * f127);
  f165 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f119 = Math_fround(f165 * f119);
  f155 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = Math_fround(f155 * f174);
  i162 = i49 + 272 | 0;
  f176 = Math_fround(HEAPF32[i162 >> 2]);
  i161 = i49 + 276 | 0;
  f101 = Math_fround(HEAPF32[i161 >> 2]);
  i160 = i49 + 280 | 0;
  f121 = Math_fround(HEAPF32[i160 >> 2]);
  i156 = i49 + 284 | 0;
  f111 = Math_fround(HEAPF32[i156 >> 2]);
  f159 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(f159 * f176);
  f158 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f101 = Math_fround(f158 * f101);
  f157 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f121 = Math_fround(f157 * f121);
  f151 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f111 = Math_fround(f151 * f111);
  f177 = Math_fround(HEAPF32[i49 + 48 >> 2]);
  f175 = Math_fround(HEAPF32[i49 + 52 >> 2]);
  f115 = Math_fround(HEAPF32[i49 + 56 >> 2]);
  f179 = Math_fround(HEAPF32[i49 + 60 >> 2]);
  f154 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f177 = Math_fround(f154 * f177);
  f153 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f175 = Math_fround(f153 * f175);
  f152 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f115 = Math_fround(f152 * f115);
  f147 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f147 * f179);
  f117 = Math_fround(HEAPF32[i49 + 320 >> 2]);
  f129 = Math_fround(HEAPF32[i49 + 324 >> 2]);
  f178 = Math_fround(HEAPF32[i49 + 328 >> 2]);
  f182 = Math_fround(HEAPF32[i49 + 332 >> 2]);
  f150 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f117 = Math_fround(f150 * f117);
  f149 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f129 = Math_fround(f149 * f129);
  f148 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f178 = Math_fround(f148 * f178);
  f143 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f143 * f182);
  i84 = i49 + 16 | 0;
  f163 = Math_fround(HEAPF32[i84 >> 2]);
  i85 = i49 + 20 | 0;
  f102 = Math_fround(HEAPF32[i85 >> 2]);
  i86 = i49 + 24 | 0;
  f125 = Math_fround(HEAPF32[i86 >> 2]);
  i87 = i49 + 28 | 0;
  f180 = Math_fround(HEAPF32[i87 >> 2]);
  f146 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f145 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f144 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f139 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f163 = Math_fround(f181 + Math_fround(f146 * f163));
  f102 = Math_fround(f127 + Math_fround(f145 * f102));
  f125 = Math_fround(f119 + Math_fround(f144 * f125));
  f180 = Math_fround(f174 + Math_fround(f139 * f180));
  i88 = i49 + 288 | 0;
  f174 = Math_fround(HEAPF32[i88 >> 2]);
  i89 = i49 + 292 | 0;
  f119 = Math_fround(HEAPF32[i89 >> 2]);
  i90 = i49 + 296 | 0;
  f127 = Math_fround(HEAPF32[i90 >> 2]);
  i91 = i49 + 300 | 0;
  f181 = Math_fround(HEAPF32[i91 >> 2]);
  f142 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f141 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f140 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f135 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f174 = Math_fround(f176 + Math_fround(f142 * f174));
  f119 = Math_fround(f101 + Math_fround(f141 * f119));
  f127 = Math_fround(f121 + Math_fround(f140 * f127));
  f181 = Math_fround(f111 + Math_fround(f135 * f181));
  f111 = Math_fround(HEAPF32[i49 + 64 >> 2]);
  f121 = Math_fround(HEAPF32[i49 + 68 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 72 >> 2]);
  f176 = Math_fround(HEAPF32[i49 + 76 >> 2]);
  f138 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f137 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f136 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f131 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f111 = Math_fround(f177 + Math_fround(f138 * f111));
  f121 = Math_fround(f175 + Math_fround(f137 * f121));
  f101 = Math_fround(f115 + Math_fround(f136 * f101));
  f176 = Math_fround(f179 + Math_fround(f131 * f176));
  f179 = Math_fround(HEAPF32[i49 + 336 >> 2]);
  f115 = Math_fround(HEAPF32[i49 + 340 >> 2]);
  f175 = Math_fround(HEAPF32[i49 + 344 >> 2]);
  f177 = Math_fround(HEAPF32[i49 + 348 >> 2]);
  f134 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f133 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f132 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f179 = Math_fround(f117 + Math_fround(f134 * f179));
  f115 = Math_fround(f129 + Math_fround(f133 * f115));
  f175 = Math_fround(f178 + Math_fround(f132 * f175));
  f177 = Math_fround(f182 + Math_fround(f123 * f177));
  i92 = i49 + 32 | 0;
  f182 = Math_fround(HEAPF32[i92 >> 2]);
  i93 = i49 + 36 | 0;
  f178 = Math_fround(HEAPF32[i93 >> 2]);
  i94 = i49 + 40 | 0;
  f129 = Math_fround(HEAPF32[i94 >> 2]);
  i95 = i49 + 44 | 0;
  f117 = Math_fround(HEAPF32[i95 >> 2]);
  f130 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f128 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f126 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f124 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f182 = Math_fround(f163 + Math_fround(f130 * f182));
  f178 = Math_fround(f102 + Math_fround(f128 * f178));
  f129 = Math_fround(f125 + Math_fround(f126 * f129));
  f117 = Math_fround(f180 + Math_fround(f124 * f117));
  i96 = i49 + 304 | 0;
  f180 = Math_fround(HEAPF32[i96 >> 2]);
  i97 = i49 + 308 | 0;
  f125 = Math_fround(HEAPF32[i97 >> 2]);
  i98 = i49 + 312 | 0;
  f102 = Math_fround(HEAPF32[i98 >> 2]);
  i99 = i49 + 316 | 0;
  f163 = Math_fround(HEAPF32[i99 >> 2]);
  f122 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f120 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f118 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f116 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f180 = Math_fround(f174 + Math_fround(f122 * f180));
  f125 = Math_fround(f119 + Math_fround(f120 * f125));
  f102 = Math_fround(f127 + Math_fround(f118 * f102));
  f163 = Math_fround(f181 + Math_fround(f116 * f163));
  f181 = Math_fround(HEAPF32[i49 + 80 >> 2]);
  f127 = Math_fround(HEAPF32[i49 + 84 >> 2]);
  f119 = Math_fround(HEAPF32[i49 + 88 >> 2]);
  f174 = Math_fround(HEAPF32[i49 + 92 >> 2]);
  f114 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f113 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f103 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f181 = Math_fround(f111 + Math_fround(f114 * f181));
  f127 = Math_fround(f121 + Math_fround(f113 * f127));
  f119 = Math_fround(f101 + Math_fround(f112 * f119));
  f174 = Math_fround(f176 + Math_fround(f103 * f174));
  f176 = Math_fround(HEAPF32[i49 + 352 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 356 >> 2]);
  f121 = Math_fround(HEAPF32[i49 + 360 >> 2]);
  f111 = Math_fround(HEAPF32[i49 + 364 >> 2]);
  f110 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f108 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f106 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f104 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f176 = Math_fround(Math_fround(f182 + f181) - Math_fround(f180 + Math_fround(f179 + Math_fround(f110 * f176))));
  f101 = Math_fround(Math_fround(f178 + f127) - Math_fround(f125 + Math_fround(f115 + Math_fround(f108 * f101))));
  f121 = Math_fround(Math_fround(f129 + f119) - Math_fround(f102 + Math_fround(f175 + Math_fround(f106 * f121))));
  f111 = Math_fround(Math_fround(f117 + f174) - Math_fround(f163 + Math_fround(f177 + Math_fround(f104 * f111))));
  f177 = Math_fround(HEAPF32[i49 + 192 >> 2]);
  f163 = Math_fround(HEAPF32[i49 + 196 >> 2]);
  f174 = Math_fround(HEAPF32[i49 + 200 >> 2]);
  f117 = Math_fround(HEAPF32[i49 + 204 >> 2]);
  f175 = Math_fround(HEAPF32[i49 + 176 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 180 >> 2]);
  f119 = Math_fround(HEAPF32[i49 + 184 >> 2]);
  f129 = Math_fround(HEAPF32[i49 + 188 >> 2]);
  f115 = Math_fround(HEAPF32[i49 + 144 >> 2]);
  f125 = Math_fround(HEAPF32[i49 + 148 >> 2]);
  f127 = Math_fround(HEAPF32[i49 + 152 >> 2]);
  f115 = Math_fround(Math_fround(f109 * f177) + Math_fround(Math_fround(f176 * f175) + f115));
  f125 = Math_fround(Math_fround(f107 * f163) + Math_fround(Math_fround(f101 * f102) + f125));
  f127 = Math_fround(Math_fround(f105 * f174) + Math_fround(Math_fround(f121 * f119) + f127));
  f129 = Math_fround(Math_fround(f100 * f117) + Math_fround(Math_fround(f111 * f129) + Math_fround(HEAPF32[i49 + 156 >> 2])));
  f111 = Math_fround(HEAPF32[i49 + 208 >> 2]);
  f117 = Math_fround(HEAPF32[i49 + 212 >> 2]);
  f119 = Math_fround(HEAPF32[i49 + 216 >> 2]);
  f121 = Math_fround(HEAPF32[i49 + 220 >> 2]);
  f174 = Math_fround(HEAPF32[i49 + 224 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 228 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 232 >> 2]);
  f163 = Math_fround(HEAPF32[i49 + 236 >> 2]);
  f115 = f174 < f115 ? f174 : f115;
  f125 = f102 < f125 ? f102 : f125;
  f127 = f101 < f127 ? f101 : f127;
  f129 = f163 < f129 ? f163 : f129;
  f115 = f111 > f115 ? f111 : f115;
  f125 = f117 > f125 ? f117 : f125;
  f127 = f119 > f127 ? f119 : f127;
  f129 = f121 > f129 ? f121 : f129;
  f109 = Math_fround(f115 - f109);
  f107 = Math_fround(f125 - f107);
  f105 = Math_fround(f127 - f105);
  f100 = Math_fround(f129 - f100);
  HEAPF32[i173 >> 2] = f115;
  HEAPF32[i172 >> 2] = f125;
  HEAPF32[i171 >> 2] = f127;
  HEAPF32[i170 >> 2] = f129;
  f129 = Math_fround(f51 * f109);
  f127 = Math_fround(f52 * f107);
  f125 = Math_fround(f53 * f105);
  f115 = Math_fround(f54 * f100);
  f121 = Math_fround(f55 * f109);
  f119 = Math_fround(f56 * f107);
  f117 = Math_fround(f57 * f105);
  f111 = Math_fround(f58 * f100);
  f163 = Math_fround(HEAPF32[i49 >> 2]);
  f101 = Math_fround(HEAPF32[i169 >> 2]);
  f102 = Math_fround(HEAPF32[i168 >> 2]);
  f163 = Math_fround(f167 + Math_fround(f163 * f129));
  f101 = Math_fround(f166 + Math_fround(f101 * f127));
  f102 = Math_fround(f165 + Math_fround(f102 * f125));
  f155 = Math_fround(f155 + Math_fround(Math_fround(HEAPF32[i164 >> 2]) * f115));
  i12 = (HEAPF32[tempDoublePtr >> 2] = f163, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f155, HEAP32[tempDoublePtr >> 2] | 0);
  f155 = Math_fround(HEAPF32[i162 >> 2]);
  f102 = Math_fround(HEAPF32[i161 >> 2]);
  f101 = Math_fround(HEAPF32[i160 >> 2]);
  f155 = Math_fround(f159 + Math_fround(f121 * f155));
  f102 = Math_fround(f158 + Math_fround(f119 * f102));
  f101 = Math_fround(f157 + Math_fround(f117 * f101));
  f151 = Math_fround(f151 + Math_fround(f111 * Math_fround(HEAPF32[i156 >> 2])));
  i20 = (HEAPF32[tempDoublePtr >> 2] = f155, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0);
  f151 = Math_fround(HEAPF32[i49 + 96 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 100 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 104 >> 2]);
  f151 = Math_fround(f154 + Math_fround(f109 * f151));
  f101 = Math_fround(f153 + Math_fround(f107 * f101));
  f102 = Math_fround(f152 + Math_fround(f105 * f102));
  f147 = Math_fround(f147 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 108 >> 2])));
  i28 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f147, HEAP32[tempDoublePtr >> 2] | 0);
  f147 = Math_fround(HEAPF32[i49 + 368 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 372 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 376 >> 2]);
  f147 = Math_fround(f150 + Math_fround(f109 * f147));
  f102 = Math_fround(f149 + Math_fround(f107 * f102));
  f101 = Math_fround(f148 + Math_fround(f105 * f101));
  f143 = Math_fround(f143 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 380 >> 2])));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f147, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f143, HEAP32[tempDoublePtr >> 2] | 0);
  f143 = Math_fround(HEAPF32[i84 >> 2]);
  f101 = Math_fround(HEAPF32[i85 >> 2]);
  f102 = Math_fround(HEAPF32[i86 >> 2]);
  f143 = Math_fround(f146 + Math_fround(f129 * f143));
  f101 = Math_fround(f145 + Math_fround(f127 * f101));
  f102 = Math_fround(f144 + Math_fround(f125 * f102));
  f139 = Math_fround(f139 + Math_fround(f115 * Math_fround(HEAPF32[i87 >> 2])));
  i36 = (HEAPF32[tempDoublePtr >> 2] = f143, HEAP32[tempDoublePtr >> 2] | 0);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i42 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
  f139 = Math_fround(HEAPF32[i88 >> 2]);
  f102 = Math_fround(HEAPF32[i89 >> 2]);
  f101 = Math_fround(HEAPF32[i90 >> 2]);
  f139 = Math_fround(f142 + Math_fround(f121 * f139));
  f102 = Math_fround(f141 + Math_fround(f119 * f102));
  f101 = Math_fround(f140 + Math_fround(f117 * f101));
  f135 = Math_fround(f135 + Math_fround(f111 * Math_fround(HEAPF32[i91 >> 2])));
  i39 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i44 = (HEAPF32[tempDoublePtr >> 2] = f135, HEAP32[tempDoublePtr >> 2] | 0);
  f135 = Math_fround(HEAPF32[i49 + 112 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 116 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 120 >> 2]);
  f135 = Math_fround(f138 + Math_fround(f109 * f135));
  f101 = Math_fround(f137 + Math_fround(f107 * f101));
  f102 = Math_fround(f136 + Math_fround(f105 * f102));
  f131 = Math_fround(f131 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 124 >> 2])));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f135, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f131, HEAP32[tempDoublePtr >> 2] | 0);
  f131 = Math_fround(HEAPF32[i49 + 384 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 388 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 392 >> 2]);
  f131 = Math_fround(f134 + Math_fround(f109 * f131));
  f102 = Math_fround(f133 + Math_fround(f107 * f102));
  f101 = Math_fround(f132 + Math_fround(f105 * f101));
  f123 = Math_fround(f123 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 396 >> 2])));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f131, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  f123 = Math_fround(HEAPF32[i92 >> 2]);
  f101 = Math_fround(HEAPF32[i93 >> 2]);
  f102 = Math_fround(HEAPF32[i94 >> 2]);
  f123 = Math_fround(f130 + Math_fround(f129 * f123));
  f101 = Math_fround(f128 + Math_fround(f127 * f101));
  f102 = Math_fround(f126 + Math_fround(f125 * f102));
  f115 = Math_fround(f124 + Math_fround(f115 * Math_fround(HEAPF32[i95 >> 2])));
  i45 = (HEAPF32[tempDoublePtr >> 2] = f123, HEAP32[tempDoublePtr >> 2] | 0);
  i47 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i46 = (HEAPF32[tempDoublePtr >> 2] = f115, HEAP32[tempDoublePtr >> 2] | 0);
  f115 = Math_fround(HEAPF32[i96 >> 2]);
  f102 = Math_fround(HEAPF32[i97 >> 2]);
  f101 = Math_fround(HEAPF32[i98 >> 2]);
  f115 = Math_fround(f122 + Math_fround(f121 * f115));
  f102 = Math_fround(f120 + Math_fround(f119 * f102));
  f101 = Math_fround(f118 + Math_fround(f117 * f101));
  f111 = Math_fround(f116 + Math_fround(f111 * Math_fround(HEAPF32[i99 >> 2])));
  i33 = (HEAPF32[tempDoublePtr >> 2] = f115, HEAP32[tempDoublePtr >> 2] | 0);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f111, HEAP32[tempDoublePtr >> 2] | 0);
  f111 = Math_fround(HEAPF32[i49 + 128 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 132 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 136 >> 2]);
  f111 = Math_fround(f114 + Math_fround(f109 * f111));
  f101 = Math_fround(f113 + Math_fround(f107 * f101));
  f102 = Math_fround(f112 + Math_fround(f105 * f102));
  f103 = Math_fround(f103 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 140 >> 2])));
  i15 = (HEAPF32[tempDoublePtr >> 2] = f111, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
  f103 = Math_fround(HEAPF32[i49 + 400 >> 2]);
  f102 = Math_fround(HEAPF32[i49 + 404 >> 2]);
  f101 = Math_fround(HEAPF32[i49 + 408 >> 2]);
  f103 = Math_fround(f110 + Math_fround(f109 * f103));
  f102 = Math_fround(f108 + Math_fround(f107 * f102));
  f101 = Math_fround(f106 + Math_fround(f105 * f101));
  f100 = Math_fround(f104 + Math_fround(f100 * Math_fround(HEAPF32[i49 + 412 >> 2])));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f100, HEAP32[tempDoublePtr >> 2] | 0);
  i50 = i50 + 1 | 0;
  if ((i50 | 0) == (i59 | 0)) break; else i49 = i49 + 416 | 0;
 }
 HEAP32[i76 >> 2] = i12;
 i173 = i76 + 4 | 0;
 HEAP32[i173 >> 2] = i36;
 i173 = i76 + 8 | 0;
 HEAP32[i173 >> 2] = i45;
 i173 = i76 + 12 | 0;
 HEAP32[i173 >> 2] = i65;
 HEAP32[i81 >> 2] = i14;
 i173 = i81 + 4 | 0;
 HEAP32[i173 >> 2] = i38;
 i173 = i81 + 8 | 0;
 HEAP32[i173 >> 2] = i47;
 i173 = i81 + 12 | 0;
 HEAP32[i173 >> 2] = i69;
 HEAP32[i83 >> 2] = i16;
 i173 = i83 + 4 | 0;
 HEAP32[i173 >> 2] = i40;
 i173 = i83 + 8 | 0;
 HEAP32[i173 >> 2] = i48;
 i173 = i83 + 12 | 0;
 HEAP32[i173 >> 2] = i73;
 HEAP32[i78 >> 2] = i18;
 i173 = i78 + 4 | 0;
 HEAP32[i173 >> 2] = i42;
 i173 = i78 + 8 | 0;
 HEAP32[i173 >> 2] = i46;
 i173 = i78 + 12 | 0;
 HEAP32[i173 >> 2] = i61;
 HEAP32[i80 >> 2] = i20;
 i173 = i80 + 4 | 0;
 HEAP32[i173 >> 2] = i39;
 i173 = i80 + 8 | 0;
 HEAP32[i173 >> 2] = i33;
 i173 = i80 + 12 | 0;
 HEAP32[i173 >> 2] = i66;
 HEAP32[i82 >> 2] = i22;
 i173 = i82 + 4 | 0;
 HEAP32[i173 >> 2] = i41;
 i173 = i82 + 8 | 0;
 HEAP32[i173 >> 2] = i34;
 i173 = i82 + 12 | 0;
 HEAP32[i173 >> 2] = i70;
 HEAP32[i77 >> 2] = i24;
 i173 = i77 + 4 | 0;
 HEAP32[i173 >> 2] = i43;
 i173 = i77 + 8 | 0;
 HEAP32[i173 >> 2] = i35;
 i173 = i77 + 12 | 0;
 HEAP32[i173 >> 2] = i74;
 HEAP32[i79 >> 2] = i26;
 i173 = i79 + 4 | 0;
 HEAP32[i173 >> 2] = i44;
 i173 = i79 + 8 | 0;
 HEAP32[i173 >> 2] = i37;
 i173 = i79 + 12 | 0;
 HEAP32[i173 >> 2] = i62;
 i173 = i76 + 16 | 0;
 HEAP32[i173 >> 2] = i28;
 i173 = i76 + 20 | 0;
 HEAP32[i173 >> 2] = i23;
 i173 = i76 + 24 | 0;
 HEAP32[i173 >> 2] = i15;
 i173 = i76 + 28 | 0;
 HEAP32[i173 >> 2] = i67;
 i173 = i81 + 16 | 0;
 HEAP32[i173 >> 2] = i30;
 i173 = i81 + 20 | 0;
 HEAP32[i173 >> 2] = i25;
 i173 = i81 + 24 | 0;
 HEAP32[i173 >> 2] = i17;
 i173 = i81 + 28 | 0;
 HEAP32[i173 >> 2] = i71;
 i173 = i83 + 16 | 0;
 HEAP32[i173 >> 2] = i31;
 i173 = i83 + 20 | 0;
 HEAP32[i173 >> 2] = i27;
 i173 = i83 + 24 | 0;
 HEAP32[i173 >> 2] = i19;
 i173 = i83 + 28 | 0;
 HEAP32[i173 >> 2] = i75;
 i173 = i78 + 16 | 0;
 HEAP32[i173 >> 2] = i32;
 i173 = i78 + 20 | 0;
 HEAP32[i173 >> 2] = i29;
 i173 = i78 + 24 | 0;
 HEAP32[i173 >> 2] = i21;
 i173 = i78 + 28 | 0;
 HEAP32[i173 >> 2] = i63;
 i173 = i80 + 16 | 0;
 HEAP32[i173 >> 2] = i9;
 i173 = i80 + 20 | 0;
 HEAP32[i173 >> 2] = i5;
 i173 = i80 + 24 | 0;
 HEAP32[i173 >> 2] = i1;
 i173 = i80 + 28 | 0;
 HEAP32[i173 >> 2] = i68;
 i173 = i82 + 16 | 0;
 HEAP32[i173 >> 2] = i10;
 i173 = i82 + 20 | 0;
 HEAP32[i173 >> 2] = i6;
 i173 = i82 + 24 | 0;
 HEAP32[i173 >> 2] = i2;
 i173 = i82 + 28 | 0;
 HEAP32[i173 >> 2] = i72;
 i173 = i77 + 16 | 0;
 HEAP32[i173 >> 2] = i11;
 i173 = i77 + 20 | 0;
 HEAP32[i173 >> 2] = i7;
 i173 = i77 + 24 | 0;
 HEAP32[i173 >> 2] = i3;
 i173 = i77 + 28 | 0;
 HEAP32[i173 >> 2] = i60;
 i173 = i79 + 16 | 0;
 HEAP32[i173 >> 2] = i13;
 i173 = i79 + 20 | 0;
 HEAP32[i173 >> 2] = i8;
 i173 = i79 + 24 | 0;
 HEAP32[i173 >> 2] = i4;
 i173 = i79 + 28 | 0;
 HEAP32[i173 >> 2] = i64;
 return;
}

function _tre_parse(i41) {
 i41 = i41 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i42 + 276 | 0;
 i30 = i42 + 272 | 0;
 i33 = i42 + 268 | 0;
 i35 = i42 + 320 | 0;
 i36 = i42 + 264 | 0;
 i37 = i42 + 8 | 0;
 i38 = i42;
 i39 = HEAP32[i41 + 4 >> 2] | 0;
 i40 = i39 + 12 | 0;
 i31 = HEAP32[i40 >> 2] | 0;
 if (!(HEAP32[i41 + 40 >> 2] | 0)) {
  i34 = i41 + 20 | 0;
  HEAP32[i30 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
  _tre_stack_push(i39, i29) | 0;
  HEAP32[i30 >> 2] = 2;
  HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
  _tre_stack_push(i39, i29) | 0;
  HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
 }
 HEAP32[i30 >> 2] = 0;
 HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
 i1 = _tre_stack_push(i39, i29) | 0;
 i32 = i41 + 12 | 0;
 i34 = i41 + 16 | 0;
 HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
 i5 = HEAP32[i40 >> 2] | 0;
 i4 = (i1 | 0) == 0;
 L4 : do if ((i1 | 0) != 0 | i4 & (i5 | 0) > (i31 | 0) ^ 1) {
  i2 = 0;
  i3 = 0;
  i18 = 230;
 } else {
  i19 = i39 + 16 | 0;
  i20 = i41 + 36 | 0;
  i21 = i41 + 24 | 0;
  i22 = i41 + 20 | 0;
  i23 = i41 + 28 | 0;
  i24 = i29 + 1 | 0;
  i25 = i29 + 12 | 0;
  i26 = i29 + 40 | 0;
  i27 = i29 + 24 | 0;
  i28 = i29 + 8 | 0;
  i2 = 0;
  i3 = 0;
  L6 : while (1) {
   i17 = i5 + -1 | 0;
   HEAP32[i40 >> 2] = i17;
   i1 = HEAP32[i19 >> 2] | 0;
   L8 : do switch (HEAP32[i1 + (i17 << 2) >> 2] | 0) {
   case 0:
    {
     if (HEAP32[i20 >> 2] & 1 | 0) {
      HEAP32[i30 >> 2] = 7;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      if (i1 | 0) break L8;
     }
     HEAP32[i30 >> 2] = 3;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     i1 = _tre_stack_push(i39, i29) | 0;
     break;
    }
   case 3:
    {
     HEAP32[i30 >> 2] = 5;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     i1 = _tre_stack_push(i39, i29) | 0;
     if (!i1) {
      HEAP32[i30 >> 2] = 4;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
     }
     break;
    }
   case 4:
    {
     HEAP32[i30 >> 2] = 9;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     i1 = _tre_stack_push(i39, i29) | 0;
     if (!i1) {
      HEAP32[i30 >> 2] = 1;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
     }
     break;
    }
   case 5:
    {
     i5 = HEAP32[i32 >> 2] | 0;
     i1 = HEAP8[i5 >> 0] | 0;
     if (!(i1 << 24 >> 24)) i1 = 0; else {
      i6 = HEAP32[i20 >> 2] & 1;
      i4 = (i6 | 0) != 0;
      if (i1 << 24 >> 24 == 124 & i4) i1 = 0; else {
       do if (!((i2 | 0) > 0 & (i1 << 24 >> 24 == 41 & i4))) {
        if (i1 << 24 >> 24 == 92 & (i6 | 0) == 0) if ((HEAP8[i5 + 1 >> 0] | 0) == 41) break;
        HEAP32[i30 >> 2] = 5;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        if (i1 | 0) break L8;
        HEAP32[i30 >> 2] = i3;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        if (i1 | 0) break L8;
        HEAP32[i30 >> 2] = 6;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        if (i1 | 0) break L8;
        HEAP32[i30 >> 2] = 4;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        break L8;
       } while (0);
       i1 = (i6 | i2 | 0) == 0 ? 8 : 0;
       i2 = i2 + -1 | 0;
       if (!i6) HEAP32[i32 >> 2] = i5 + 2;
      }
     }
     break;
    }
   case 6:
    {
     i17 = i5 + -2 | 0;
     HEAP32[i40 >> 2] = i17;
     i3 = _tre_ast_new_catenation(HEAP32[i41 >> 2] | 0, HEAP32[i1 + (i17 << 2) >> 2] | 0, i3) | 0;
     if (!i3) {
      i1 = 12;
      break L4;
     }
     i1 = 0;
     break;
    }
   case 7:
    {
     i1 = HEAP32[i32 >> 2] | 0;
     switch (HEAP8[i1 >> 0] | 0) {
     case 124:
      break;
     case 41:
      {
       HEAP32[i32 >> 2] = i1 + 1;
       i1 = 0;
       break L8;
      }
     default:
      {
       i1 = 0;
       break L8;
      }
     }
     HEAP32[i30 >> 2] = 7;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     i1 = _tre_stack_push(i39, i29) | 0;
     if (!i1) {
      HEAP32[i30 >> 2] = i3;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      if (!i1) {
       HEAP32[i30 >> 2] = 8;
       HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
       i1 = _tre_stack_push(i39, i29) | 0;
       if (!i1) {
        HEAP32[i30 >> 2] = 3;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        if (!i1) {
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         i1 = 0;
        }
       }
      }
     }
     break;
    }
   case 8:
    {
     i17 = i5 + -2 | 0;
     HEAP32[i40 >> 2] = i17;
     i3 = _tre_ast_new_union(HEAP32[i41 >> 2] | 0, HEAP32[i1 + (i17 << 2) >> 2] | 0, i3) | 0;
     if (!i3) {
      i1 = 12;
      break L4;
     }
     i1 = 0;
     break;
    }
   case 9:
    {
     i5 = HEAP32[i32 >> 2] | 0;
     i1 = HEAP8[i5 >> 0] | 0;
     switch (i1 << 24 >> 24 | 0) {
     case 63:
     case 43:
      {
       if (!(HEAP32[i20 >> 2] & 1)) {
        i1 = 0;
        break L8;
       } else i18 = 38;
       break;
      }
     case 42:
      {
       i18 = 38;
       break;
      }
     case 92:
      {
       i4 = HEAP32[i20 >> 2] | 0;
       if (i4 & 1 | 0) {
        i1 = 0;
        break L8;
       }
       i1 = i5 + 1 | 0;
       if ((HEAP8[i1 >> 0] | 0) != 123) {
        i1 = 0;
        break L8;
       }
       HEAP32[i32 >> 2] = i1;
       break;
      }
     case 123:
      {
       i4 = HEAP32[i20 >> 2] | 0;
       if (!(i4 & 1)) {
        i1 = 0;
        break L8;
       } else i1 = i5;
       break;
      }
     default:
      {
       i1 = 0;
       break L8;
      }
     }
     if ((i18 | 0) == 38) {
      i18 = 0;
      HEAP32[i32 >> 2] = i5 + 1;
      i3 = _tre_ast_new_iter(HEAP32[i41 >> 2] | 0, i3, i1 << 24 >> 24 == 43 & 1, i1 << 24 >> 24 == 63 ? 1 : -1, 0) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
      HEAP32[i30 >> 2] = 9;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      break L8;
     }
     i5 = i1 + 1 | 0;
     HEAP32[i32 >> 2] = i5;
     i5 = HEAP8[i5 >> 0] | 0;
     if ((i5 + -48 & 255) < 10) {
      i5 = i5 << 24 >> 24;
      if ((i5 + -48 | 0) >>> 0 < 10) {
       i6 = -1;
       i7 = 1;
       i8 = i5;
      } else {
       i1 = 10;
       break L4;
      }
      do {
       i6 = i8 + -48 + (((i6 | 0) < 0 ? 0 : i6) * 10 | 0) | 0;
       i7 = i7 + 1 | 0;
       i5 = HEAP8[i1 + i7 >> 0] | 0;
       i8 = i5 << 24 >> 24;
      } while ((i8 + -48 | 0) >>> 0 < 10);
     } else {
      i6 = -1;
      i7 = 1;
     }
     if (i5 << 24 >> 24 == 44) {
      i7 = i7 + 1 | 0;
      i5 = HEAP8[i1 + i7 >> 0] | 0;
      i9 = i5 << 24 >> 24;
      if ((i9 + -48 | 0) >>> 0 < 10) {
       i8 = -1;
       do {
        i8 = i9 + -48 + (((i8 | 0) < 0 ? 0 : i8) * 10 | 0) | 0;
        i7 = i7 + 1 | 0;
        i5 = HEAP8[i1 + i7 >> 0] | 0;
        i9 = i5 << 24 >> 24;
       } while ((i9 + -48 | 0) >>> 0 < 10);
       i18 = 50;
      } else i8 = -1;
     } else {
      i8 = i6;
      i18 = 50;
     }
     if ((i18 | 0) == 50) {
      i18 = 0;
      if ((i8 | 0) > -1) if ((i6 | 0) > (i8 | 0) | (i8 | 0) > 255) {
       i1 = 10;
       break L4;
      }
     }
     i1 = i1 + i7 | 0;
     if (!(i5 << 24 >> 24)) {
      i1 = 9;
      break L4;
     }
     if ((i7 | 0) == 1) {
      i1 = 10;
      break L4;
     }
     if (!(i4 & 1)) {
      if (i5 << 24 >> 24 != 92) {
       i1 = 10;
       break L4;
      }
      if ((HEAP8[i1 + 1 >> 0] | 0) != 125) {
       i1 = 10;
       break L4;
      }
      i1 = i1 + 2 | 0;
     } else {
      if (i5 << 24 >> 24 != 125) {
       i1 = 10;
       break L4;
      }
      i1 = i1 + 1 | 0;
     }
     if (!(i8 | i6)) {
      i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
      i17 = HEAP32[i3 + 4 >> 2] | 0;
      HEAP32[i17 >> 2] = -1;
      HEAP32[i17 + 4 >> 2] = -1;
      HEAP32[i17 + 8 >> 2] = -1;
     } else {
      i17 = (i8 & i6 | 0) < 0;
      i3 = _tre_ast_new_iter(HEAP32[i41 >> 2] | 0, i3, i17 ? 1 : i6, i17 ? 1 : i8, 0) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
     }
     HEAP32[i32 >> 2] = i1;
     HEAP32[i30 >> 2] = 9;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     i1 = _tre_stack_push(i39, i29) | 0;
     break;
    }
   case 1:
    {
     i1 = HEAP32[i32 >> 2] | 0;
     L81 : do switch (HEAP8[i1 >> 0] | 0) {
     case 40:
      {
       if (HEAP32[i20 >> 2] & 1) i18 = 67;
       break;
      }
     case 91:
      {
       i3 = i1 + 1 | 0;
       HEAP32[i32 >> 2] = i3;
       i17 = _malloc(128) | 0;
       HEAP32[i36 >> 2] = i17;
       if (!i17) {
        i18 = 72;
        break L6;
       }
       if ((HEAP8[i3 >> 0] | 0) == 94) {
        i3 = i1 + 2 | 0;
        HEAP32[i32 >> 2] = i3;
        i17 = 1;
       } else i17 = 0;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i30 >> 2] = 32;
       i8 = 0;
       i1 = 0;
       L88 : while (1) {
        switch (HEAP8[i3 >> 0] | 0) {
        case 0:
         {
          i1 = 7;
          i16 = i8;
          break L88;
         }
        case 93:
         {
          if (i3 >>> 0 > (HEAP32[i32 >> 2] | 0) >>> 0) {
           i18 = 78;
           break L88;
          }
          break;
         }
        default:
         {}
        }
        i4 = _mbtowc(i33, i3, -1) | 0;
        if ((i4 | 0) < 0) {
         HEAP32[i33 >> 2] = -1;
         i4 = 1;
        }
        i6 = i3 + i4 | 0;
        if ((HEAP8[i6 >> 0] | 0) == 45) if ((HEAP8[i6 + 1 >> 0] | 0) == 93) i18 = 87; else {
         i6 = HEAP32[i33 >> 2] | 0;
         i4 = i3 + (i4 + 1) | 0;
         i3 = _mbtowc(i33, i4, -1) | 0;
         if ((i3 | 0) < 0) {
          HEAP32[i33 >> 2] = -1;
          i3 = 1;
          i5 = -1;
         } else i5 = HEAP32[i33 >> 2] | 0;
         i3 = i4 + i3 | 0;
         if (i6 >>> 0 > i5 >>> 0) {
          i1 = 11;
          i5 = 3;
          i4 = i8;
         } else {
          i7 = i6;
          i4 = 0;
          i18 = 97;
         }
        } else i18 = 87;
        L103 : do if ((i18 | 0) == 87) {
         i18 = 0;
         L105 : do switch (HEAP8[i3 >> 0] | 0) {
         case 91:
          {
           switch (HEAP8[i3 + 1 >> 0] | 0) {
           case 61:
           case 46:
            {
             i1 = 3;
             i5 = 3;
             i4 = i8;
             break L103;
            }
           case 58:
            break;
           default:
            break L105;
           }
           i4 = i3 + 2 | 0;
           i6 = i4;
           while (1) {
            i18 = HEAP8[i6 >> 0] | 0;
            i5 = i18 << 24 >> 24 == 0;
            if (i18 << 24 >> 24 != 58 & (i5 ^ 1)) i6 = i6 + 1 | 0; else break;
           }
           if (i5) {
            i4 = 0;
            i1 = 4;
           } else {
            i18 = i6 - i3 + -2 | 0;
            i18 = (i18 | 0) > 63 ? 63 : i18;
            _strncpy(i35, i4, i18) | 0;
            HEAP8[i35 + i18 >> 0] = 0;
            i18 = _wctype(i35) | 0;
            i4 = i18;
            i3 = i6 + 2 | 0;
            i1 = (i18 | 0) == 0 ? 4 : i1;
           }
           i5 = 1114111;
           i7 = 0;
           i18 = 97;
           break L103;
          }
         case 45:
          {
           if ((HEAP8[i3 + 1 >> 0] | 0) != 93) i1 = (HEAP32[i32 >> 2] | 0) == (i3 | 0) ? i1 : 11;
           break;
          }
         default:
          {}
         } while (0);
         i7 = HEAP32[i33 >> 2] | 0;
         i5 = i7;
         i4 = 0;
         i3 = i6;
         i18 = 97;
        } while (0);
        L117 : do if ((i18 | 0) == 97) {
         i18 = 0;
         if (!i1) {
          if (i17 & (i4 | 0) != 0) if ((i8 | 0) > 63) i1 = 12; else {
           HEAP32[i37 + (i8 << 2) >> 2] = i4;
           i8 = i8 + 1 | 0;
           i1 = 0;
          } else {
           i1 = _tre_new_item(HEAP32[i41 >> 2] | 0, i7, i5, i29, i30, i36) | 0;
           if (i1 | 0) {
            i5 = 3;
            i4 = i8;
            break;
           }
           HEAP32[(HEAP32[(HEAP32[(HEAP32[i36 >> 2] | 0) + ((HEAP32[i29 >> 2] | 0) + -1 << 2) >> 2] | 0) + 4 >> 2] | 0) + 12 >> 2] = i4;
           i1 = 0;
          }
          if (!((i1 | i4 | 0) != 0 | (HEAP32[i20 >> 2] & 2 | 0) == 0)) {
           i4 = i7;
           while (1) {
            if (i4 >>> 0 > i5 >>> 0) break;
            do if (!(_iswlower(i4) | 0)) {
             i6 = i4 + 1 | 0;
             if (!(_iswupper(i4) | 0)) break;
             i7 = _towlower(i4) | 0;
             L133 : do if (!(_iswupper(i6) | 0)) {
              i4 = i7;
              i1 = i6;
             } else {
              i4 = i7;
              i1 = i6;
              while (1) {
               if (i1 >>> 0 > i5 >>> 0 | (_towlower(i1) | 0) != (i4 + 1 | 0)) break L133;
               i6 = i1 + 1 | 0;
               i1 = _towlower(i1) | 0;
               if (!(_iswupper(i6) | 0)) {
                i4 = i1;
                i1 = i6;
                break;
               } else {
                i4 = i1;
                i1 = i6;
               }
              }
             } while (0);
             i6 = i1;
             i1 = _tre_new_item(HEAP32[i41 >> 2] | 0, i7, i4, i29, i30, i36) | 0;
            } else {
             i7 = _towupper(i4) | 0;
             i1 = i4 + 1 | 0;
             L139 : do if (!(_iswlower(i1) | 0)) i4 = i7; else {
              i4 = i7;
              do {
               if (i1 >>> 0 > i5 >>> 0 | (_towupper(i1) | 0) != (i4 + 1 | 0)) break L139;
               i4 = _towupper(i1) | 0;
               i1 = i1 + 1 | 0;
              } while ((_iswlower(i1) | 0) != 0);
             } while (0);
             i6 = i1;
             i1 = _tre_new_item(HEAP32[i41 >> 2] | 0, i7, i4, i29, i30, i36) | 0;
            } while (0);
            if (!i1) {
             i4 = i6;
             i1 = 0;
            } else {
             i5 = 3;
             i4 = i8;
             break L117;
            }
           }
           if (!i1) i1 = 0; else {
            i5 = 3;
            i4 = i8;
            break;
           }
          }
          i5 = 0;
          i4 = i8;
         } else {
          i5 = 3;
          i4 = i8;
         }
        } while (0);
        if (!(i5 | i1)) i8 = i4; else {
         i16 = i4;
         break;
        }
       }
       if ((i18 | 0) == 78) {
        i18 = 0;
        i16 = i8;
        i3 = i3 + 1 | 0;
       }
       i15 = HEAP32[i29 >> 2] | 0;
       HEAP32[i32 >> 2] = i3;
       L151 : do if (!i1) {
        if (i17) _qsort(HEAP32[i36 >> 2] | 0, i15, 4, fb + 1141 | 0);
        if ((i15 | 0) > 0) {
         i11 = HEAP32[i36 >> 2] | 0;
         i12 = (i16 | 0) > 0;
         i13 = i16 << 2;
         i14 = i13 + 4 | 0;
         i3 = 0;
         i4 = 0;
         i5 = 0;
         i10 = 0;
         do {
          i9 = i11 + (i10 << 2) | 0;
          i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0;
          i6 = HEAP32[i1 >> 2] | 0;
          i7 = i1 + 4 | 0;
          i8 = HEAP32[i7 >> 2] | 0;
          do if (i17) {
           if ((i6 | 0) < (i5 | 0)) {
            i1 = i8 + 1 | 0;
            i5 = (i1 | 0) >= (i5 | 0) ? i1 : i5;
            i1 = 0;
            break;
           }
           if ((i6 | 0) > (i4 | 0)) {
            HEAP32[i1 >> 2] = i4;
            HEAP32[i7 >> 2] = i6 + -1;
           } else i1 = 0;
           i5 = i8 + 1 | 0;
           i4 = i5;
           i18 = 130;
          } else i18 = 130; while (0);
          if ((i18 | 0) == 130) {
           i18 = 0;
           if (!i1) i1 = 0; else {
            HEAP32[i1 + 8 >> 2] = HEAP32[i21 >> 2];
            if (i12) {
             i6 = ___tre_mem_alloc_impl(HEAP32[i41 >> 2] | 0, 0, 0, 0, i14) | 0;
             i1 = i1 + 16 | 0;
             HEAP32[i1 >> 2] = i6;
             if (!i6) {
              i1 = 12;
              break L151;
             }
             _memcpy(i6 | 0, i37 | 0, i13 | 0) | 0;
             HEAP32[(HEAP32[i1 >> 2] | 0) + (i16 << 2) >> 2] = 0;
            } else HEAP32[i1 + 16 >> 2] = 0;
            i1 = HEAP32[i9 >> 2] | 0;
            if (!i3) {
             i3 = i1;
             i1 = 0;
            } else {
             i1 = _tre_ast_new_union(HEAP32[i41 >> 2] | 0, i3, i1) | 0;
             i3 = i1;
             i1 = (i1 | 0) == 0 ? 12 : 0;
            }
           }
          }
          i10 = i10 + 1 | 0;
         } while ((i10 | 0) < (i15 | 0) & (i1 | 0) == 0);
        } else {
         i3 = 0;
         i4 = 0;
         i1 = 0;
        }
        if (i17 & (i1 | 0) == 0) {
         i1 = HEAP32[i21 >> 2] | 0;
         i7 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i7) i1 = 12; else {
          i6 = HEAP32[i7 + 4 >> 2] | 0;
          HEAP32[i6 >> 2] = i4;
          HEAP32[i6 + 4 >> 2] = 1114111;
          HEAP32[i6 + 8 >> 2] = i1;
          if ((i16 | 0) > 0) {
           i4 = i16 << 2;
           i5 = ___tre_mem_alloc_impl(HEAP32[i41 >> 2] | 0, 0, 0, 0, i4 + 4 | 0) | 0;
           i1 = i6 + 16 | 0;
           HEAP32[i1 >> 2] = i5;
           if (!i5) {
            i1 = 12;
            break;
           }
           _memcpy(i5 | 0, i37 | 0, i4 | 0) | 0;
           HEAP32[(HEAP32[i1 >> 2] | 0) + (i16 << 2) >> 2] = 0;
          } else HEAP32[i6 + 16 >> 2] = 0;
          if (!i3) {
           i3 = i7;
           i1 = 0;
          } else {
           i1 = _tre_ast_new_union(HEAP32[i41 >> 2] | 0, i3, i7) | 0;
           i3 = i1;
           i1 = (i1 | 0) == 0 ? 12 : 0;
          }
         }
        }
       } else i3 = 0; while (0);
       _free(HEAP32[i36 >> 2] | 0);
       HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
       if (!i1) {
        i1 = 0;
        break L8;
       } else break L4;
      }
     case 92:
      {
       i4 = i1 + 1 | 0;
       i5 = HEAP8[i4 >> 0] | 0;
       do if (!(HEAP32[i20 >> 2] & 1)) if (i5 << 24 >> 24 == 40) {
        HEAP32[i32 >> 2] = i4;
        i1 = i4;
        i18 = 67;
        break L81;
       } else {
        i3 = i1 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
        if (i4 << 24 >> 24 == 41) {
         i18 = 211;
         break L81;
        } else {
         i5 = i4;
         break;
        }
       } else i3 = i4; while (0);
       i7 = i5 << 24 >> 24 == 0;
       if (i7) {
        i1 = 5;
        break L4;
       } else {
        i6 = 0;
        i4 = gb + 207908 + 4 | 0;
       }
       do {
        if ((HEAP8[gb + 207908 + (i6 << 3) >> 0] | 0) == i5 << 24 >> 24) break;
        i6 = i6 + 1 | 0;
        i4 = gb + 207908 + (i6 << 3) + 4 | 0;
       } while ((i6 | 0) != 12);
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        i1 = i29;
        i3 = i41;
        i4 = i1 + 40 | 0;
        do {
         HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
         i1 = i1 + 4 | 0;
         i3 = i3 + 4 | 0;
        } while ((i1 | 0) < (i4 | 0));
        HEAP32[i25 >> 2] = i5;
        HEAP32[i26 >> 2] = 1;
        i1 = _tre_parse(i29) | 0;
        if (i1 | 0) {
         i18 = 156;
         break L6;
        }
        HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 2;
        HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
        i1 = 0;
        i3 = HEAP32[i28 >> 2] | 0;
        break L8;
       }
       if (i7) {
        i1 = 5;
        break L4;
       }
       HEAP32[i32 >> 2] = i3;
       i3 = HEAP8[i3 >> 0] | 0;
       L204 : do switch (i3 | 0) {
       case 98:
        {
         i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i3) i3 = 0; else {
          i17 = HEAP32[i3 + 4 >> 2] | 0;
          HEAP32[i17 >> 2] = -2;
          HEAP32[i17 + 4 >> 2] = 64;
          HEAP32[i17 + 8 >> 2] = -1;
         }
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         break;
        }
       case 66:
        {
         i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i3) i3 = 0; else {
          i17 = HEAP32[i3 + 4 >> 2] | 0;
          HEAP32[i17 >> 2] = -2;
          HEAP32[i17 + 4 >> 2] = 128;
          HEAP32[i17 + 8 >> 2] = -1;
         }
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         break;
        }
       case 60:
        {
         i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i3) i3 = 0; else {
          i17 = HEAP32[i3 + 4 >> 2] | 0;
          HEAP32[i17 >> 2] = -2;
          HEAP32[i17 + 4 >> 2] = 16;
          HEAP32[i17 + 8 >> 2] = -1;
         }
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         break;
        }
       case 62:
        {
         i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i3) i3 = 0; else {
          i17 = HEAP32[i3 + 4 >> 2] | 0;
          HEAP32[i17 >> 2] = -2;
          HEAP32[i17 + 4 >> 2] = 32;
          HEAP32[i17 + 8 >> 2] = -1;
         }
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         break;
        }
       case 120:
        {
         i4 = i1 + 2 | 0;
         HEAP32[i32 >> 2] = i4;
         i3 = HEAP8[i4 >> 0] | 0;
         if (i3 << 24 >> 24 == 123) {
          i6 = i1 + 3 | 0;
          HEAP32[i32 >> 2] = i6;
          i5 = 0;
          i1 = i4;
          L227 : while (1) {
           i3 = HEAP8[i6 >> 0] | 0;
           switch (i3 << 24 >> 24) {
           case 0:
           case 125:
            {
             i3 = i5;
             break L227;
            }
           default:
            {}
           }
           if (!(_iswxdigit(i3 << 24 >> 24) | 0)) {
            i18 = 187;
            break L6;
           }
           i1 = HEAP32[i32 >> 2] | 0;
           HEAP8[i29 + i5 >> 0] = HEAP8[i1 >> 0] | 0;
           i3 = i5 + 1 | 0;
           i6 = i1 + 1 | 0;
           HEAP32[i32 >> 2] = i6;
           if (i3 >>> 0 > 31) break; else i5 = i3;
          }
          HEAP32[i32 >> 2] = i1 + 2;
          HEAP8[i29 + i3 >> 0] = 0;
          i1 = _strtol(i29, 0, 16) | 0;
          i4 = HEAP32[i21 >> 2] | 0;
          i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
          if (!i3) i3 = 0; else {
           i17 = HEAP32[i3 + 4 >> 2] | 0;
           HEAP32[i17 >> 2] = i1;
           HEAP32[i17 + 4 >> 2] = i1;
           HEAP32[i17 + 8 >> 2] = i4;
          }
          HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
          break L204;
         } else {
          HEAP8[i29 >> 0] = 0;
          HEAP8[i29 + 1 >> 0] = 0;
          HEAP8[i29 + 2 >> 0] = 0;
          i17 = (_iswxdigit(i3 << 24 >> 24) | 0) == 0;
          i1 = HEAP32[i32 >> 2] | 0;
          if (!i17) {
           HEAP8[i29 >> 0] = HEAP8[i1 >> 0] | 0;
           i1 = i1 + 1 | 0;
           HEAP32[i32 >> 2] = i1;
          }
          if (_iswxdigit(HEAP8[i1 >> 0] | 0) | 0) {
           i17 = HEAP32[i32 >> 2] | 0;
           HEAP8[i24 >> 0] = HEAP8[i17 >> 0] | 0;
           HEAP32[i32 >> 2] = i17 + 1;
          }
          i1 = _strtol(i29, 0, 16) | 0;
          i4 = HEAP32[i21 >> 2] | 0;
          i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
          if (!i3) i3 = 0; else {
           i17 = HEAP32[i3 + 4 >> 2] | 0;
           HEAP32[i17 >> 2] = i1;
           HEAP32[i17 + 4 >> 2] = i1;
           HEAP32[i17 + 8 >> 2] = i4;
          }
          HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
          break L204;
         }
        }
       default:
        {
         i17 = (_iswdigit(i3) | 0) == 0;
         i1 = HEAP32[i32 >> 2] | 0;
         if (i17) break L81;
         i1 = (HEAP8[i1 >> 0] | 0) + -48 | 0;
         i4 = HEAP32[i21 >> 2] | 0;
         i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
         if (!i3) {
          i1 = 12;
          break L4;
         }
         i17 = HEAP32[i3 + 4 >> 2] | 0;
         HEAP32[i17 >> 2] = -4;
         HEAP32[i17 + 4 >> 2] = i1;
         HEAP32[i17 + 8 >> 2] = i4;
         HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
         i17 = HEAP32[i23 >> 2] | 0;
         HEAP32[i23 >> 2] = (i1 | 0) < (i17 | 0) ? i17 : i1;
         HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
         i1 = 0;
         break L8;
        }
       } while (0);
       if (!i3) {
        i1 = 12;
        break L4;
       } else {
        i1 = 0;
        break L8;
       }
      }
     case 46:
      {
       i17 = (HEAP32[i20 >> 2] & 4 | 0) == 0;
       i1 = HEAP32[i21 >> 2] | 0;
       i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
       i4 = (i3 | 0) == 0;
       if (i17) {
        if (i4) {
         i1 = 12;
         break L4;
        }
        i17 = HEAP32[i3 + 4 >> 2] | 0;
        HEAP32[i17 >> 2] = 0;
        HEAP32[i17 + 4 >> 2] = 1114111;
        HEAP32[i17 + 8 >> 2] = i1;
        i1 = (HEAP32[i21 >> 2] | 0) + 1 | 0;
       } else {
        if (i4) {
         i1 = 12;
         break L4;
        }
        i4 = HEAP32[i3 + 4 >> 2] | 0;
        HEAP32[i4 >> 2] = 0;
        HEAP32[i4 + 4 >> 2] = 9;
        HEAP32[i4 + 8 >> 2] = i1;
        i1 = HEAP32[i21 >> 2] | 0;
        i4 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
        if (!i4) {
         i1 = 12;
         break L4;
        }
        i17 = HEAP32[i4 + 4 >> 2] | 0;
        HEAP32[i17 >> 2] = 11;
        HEAP32[i17 + 4 >> 2] = 1114111;
        HEAP32[i17 + 8 >> 2] = i1 + 1;
        i3 = _tre_ast_new_union(HEAP32[i41 >> 2] | 0, i3, i4) | 0;
        if (!i3) {
         i1 = 12;
         break L4;
        }
        i1 = (HEAP32[i21 >> 2] | 0) + 2 | 0;
       }
       HEAP32[i21 >> 2] = i1;
       HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
       i1 = 0;
       break L8;
      }
     case 94:
      {
       if (!(HEAP32[i20 >> 2] & 1)) {
        if ((i1 | 0) != (HEAP32[i34 >> 2] | 0)) break L81;
        HEAP32[i30 >> 2] = 5;
        HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
        i1 = _tre_stack_push(i39, i29) | 0;
        if (i1 | 0) break L8;
       }
       i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
       if (!i3) {
        i1 = 12;
        break L4;
       }
       i1 = HEAP32[i3 + 4 >> 2] | 0;
       HEAP32[i1 >> 2] = -2;
       HEAP32[i1 + 4 >> 2] = 1;
       HEAP32[i1 + 8 >> 2] = -1;
       HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
       i1 = 0;
       break L8;
      }
     case 36:
      {
       if (!(HEAP32[i20 >> 2] & 1)) if (HEAP8[i1 + 1 >> 0] | 0) break L81;
       i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
       if (!i3) {
        i1 = 12;
        break L4;
       }
       i1 = HEAP32[i3 + 4 >> 2] | 0;
       HEAP32[i1 >> 2] = -2;
       HEAP32[i1 + 4 >> 2] = 2;
       HEAP32[i1 + 8 >> 2] = -1;
       HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
       i1 = 0;
       break L8;
      }
     case 41:
      {
       if (i2) i18 = 210;
       break;
      }
     case 63:
     case 43:
     case 123:
     case 124:
     case 42:
      {
       i18 = 210;
       break;
      }
     case 0:
      {
       i18 = 211;
       break;
      }
     default:
      {}
     } while (0);
     if ((i18 | 0) == 67) {
      i18 = 0;
      i2 = i2 + 1 | 0;
      HEAP32[i32 >> 2] = i1 + 1;
      HEAP32[i30 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      if (i1 | 0) break L8;
      HEAP32[i30 >> 2] = 2;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      if (i1 | 0) break L8;
      HEAP32[i30 >> 2] = 0;
      HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
      i1 = _tre_stack_push(i39, i29) | 0;
      if (i1 | 0) break L8;
      HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
      i1 = 0;
      break L8;
     } else if ((i18 | 0) == 210) {
      i18 = 0;
      if (HEAP32[i20 >> 2] & 1) i18 = 211;
     }
     if ((i18 | 0) == 211) {
      i18 = 0;
      i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
      i1 = HEAP32[i3 + 4 >> 2] | 0;
      HEAP32[i1 >> 2] = -1;
      HEAP32[i1 + 4 >> 2] = -1;
      HEAP32[i1 + 8 >> 2] = -1;
      i1 = 0;
      break L8;
     }
     i1 = _mbtowc(i38, i1, -1) | 0;
     if ((i1 | 0) < 0) {
      HEAP32[i38 >> 2] = -1;
      i1 = 1;
     }
     do if (!(HEAP32[i20 >> 2] & 2)) i18 = 221; else {
      if (!(_iswupper(HEAP32[i38 >> 2] | 0) | 0)) if (!(_iswlower(HEAP32[i38 >> 2] | 0) | 0)) {
       i18 = 221;
       break;
      }
      i7 = HEAP32[i41 >> 2] | 0;
      i3 = _towupper(HEAP32[i38 >> 2] | 0) | 0;
      i4 = _towupper(HEAP32[i38 >> 2] | 0) | 0;
      i5 = HEAP32[i21 >> 2] | 0;
      i7 = _tre_ast_new_node(i7, 0, 20) | 0;
      if (!i7) {
       i1 = 12;
       break L4;
      }
      i6 = HEAP32[i7 + 4 >> 2] | 0;
      HEAP32[i6 >> 2] = i3;
      HEAP32[i6 + 4 >> 2] = i4;
      HEAP32[i6 + 8 >> 2] = i5;
      i6 = HEAP32[i41 >> 2] | 0;
      i3 = _towlower(HEAP32[i38 >> 2] | 0) | 0;
      i4 = _towlower(HEAP32[i38 >> 2] | 0) | 0;
      i5 = HEAP32[i21 >> 2] | 0;
      i6 = _tre_ast_new_node(i6, 0, 20) | 0;
      if (!i6) {
       i1 = 12;
       break L4;
      }
      i17 = HEAP32[i6 + 4 >> 2] | 0;
      HEAP32[i17 >> 2] = i3;
      HEAP32[i17 + 4 >> 2] = i4;
      HEAP32[i17 + 8 >> 2] = i5;
      i3 = _tre_ast_new_union(HEAP32[i41 >> 2] | 0, i7, i6) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
     } while (0);
     if ((i18 | 0) == 221) {
      i18 = 0;
      i4 = HEAP32[i38 >> 2] | 0;
      i5 = HEAP32[i21 >> 2] | 0;
      i3 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
      i17 = HEAP32[i3 + 4 >> 2] | 0;
      HEAP32[i17 >> 2] = i4;
      HEAP32[i17 + 4 >> 2] = i4;
      HEAP32[i17 + 8 >> 2] = i5;
     }
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
     HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + i1;
     i1 = 0;
     break;
    }
   case 2:
    {
     i5 = i5 + -2 | 0;
     HEAP32[i40 >> 2] = i5;
     i5 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
     i4 = i3;
     if ((HEAP32[i4 + 12 >> 2] | 0) > -1) {
      i1 = _tre_ast_new_node(HEAP32[i41 >> 2] | 0, 0, 20) | 0;
      if (!i1) {
       i1 = 12;
       break L4;
      }
      i3 = HEAP32[i1 + 4 >> 2] | 0;
      HEAP32[i3 >> 2] = -1;
      HEAP32[i3 + 4 >> 2] = -1;
      HEAP32[i3 + 8 >> 2] = -1;
      i3 = _tre_ast_new_catenation(HEAP32[i41 >> 2] | 0, i1, i4) | 0;
      if (!i3) {
       i1 = 12;
       break L4;
      }
      HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     }
     i1 = i3;
     HEAP32[i1 + 12 >> 2] = i5;
     i1 = i1 + 16 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = 0;
     break;
    }
   case 10:
    {
     i17 = i5 + -2 | 0;
     HEAP32[i40 >> 2] = i17;
     HEAP32[i20 >> 2] = HEAP32[i1 + (i17 << 2) >> 2];
     i1 = 0;
     break;
    }
   default:
    i1 = 0;
   } while (0);
   i5 = HEAP32[i40 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if ((i1 | 0) != 0 | i4 & (i5 | 0) > (i31 | 0) ^ 1) {
    i18 = 230;
    break L4;
   }
  }
  if ((i18 | 0) == 72) {
   i1 = 12;
   break;
  } else if ((i18 | 0) == 156) break; else if ((i18 | 0) == 187) {
   i1 = 9;
   break;
  }
 } while (0);
 if ((i18 | 0) == 230) {
  i2 = (i2 | 0) > 0;
  if (i2 | i4 ^ 1) i1 = i2 ? 8 : i1; else HEAP32[i41 + 8 >> 2] = i3;
 }
 STACKTOP = i42;
 return i1 | 0;
}

function __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb1EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, f169 = f0, i170 = 0, i171 = 0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0;
 i180 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i160 = i180 + 584 | 0;
 i162 = i180 + 580 | 0;
 i167 = i180 + 576 | 0;
 i168 = i180 + 408 | 0;
 i170 = i180 + 240 | 0;
 i171 = i180 + 224 | 0;
 i176 = i180 + 176 | 0;
 i177 = i180 + 144 | 0;
 i178 = i180 + 112 | 0;
 i179 = i180 + 80 | 0;
 i163 = i180 + 32 | 0;
 i164 = i180 + 16 | 0;
 i165 = i180;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i162 >> 2] = 0;
  HEAP32[i160 >> 2] = HEAP32[i162 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i160);
  i161 = gb + 1451836 | 0;
 } else i161 = 0;
 i166 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i160 >> 2] = f2;
 HEAP32[i162 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i167 >> 2] = HEAP32[i3 + 812 >> 2];
 f172 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f173 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f174 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f169 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i168 + 4 >> 2] = Math_fround(inf);
 HEAP32[i168 >> 2] = 0;
 i139 = i168 + 8 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 32 >> 2] = Math_fround(inf);
 HEAP32[i168 + 28 >> 2] = 0;
 i139 = i168 + 36 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 60 >> 2] = Math_fround(inf);
 HEAP32[i168 + 56 >> 2] = 0;
 i139 = i168 + 64 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 88 >> 2] = Math_fround(inf);
 HEAP32[i168 + 84 >> 2] = 0;
 i139 = i168 + 92 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 116 >> 2] = Math_fround(inf);
 HEAP32[i168 + 112 >> 2] = 0;
 i139 = i168 + 120 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 144 >> 2] = Math_fround(inf);
 HEAP32[i168 + 140 >> 2] = 0;
 i139 = i168 + 148 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f172 = Math_fround(f172 * Math_fround(100.0));
 f173 = Math_fround(f173 * Math_fround(100.0));
 f174 = Math_fround(f174 * Math_fround(100.0));
 f175 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i170 + 4 >> 2] = Math_fround(inf);
 HEAP32[i170 >> 2] = 0;
 i4 = i170 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 32 >> 2] = Math_fround(inf);
 HEAP32[i170 + 28 >> 2] = 0;
 i4 = i170 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 60 >> 2] = Math_fround(inf);
 HEAP32[i170 + 56 >> 2] = 0;
 i4 = i170 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 88 >> 2] = Math_fround(inf);
 HEAP32[i170 + 84 >> 2] = 0;
 i4 = i170 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 116 >> 2] = Math_fround(inf);
 HEAP32[i170 + 112 >> 2] = 0;
 i4 = i170 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 144 >> 2] = Math_fround(inf);
 HEAP32[i170 + 140 >> 2] = 0;
 i4 = i170 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i139 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i139 >> 2] | 0) >>> 0) {
  i140 = i166 + 520 | 0;
  i141 = i171 + 4 | 0;
  i142 = i171 + 8 | 0;
  i143 = i171 + 12 | 0;
  i144 = i166 + 500 | 0;
  i145 = i177 + 4 | 0;
  i146 = i177 + 8 | 0;
  i147 = i177 + 12 | 0;
  i148 = i3 + 8 | 0;
  i149 = i3 + 92 | 0;
  i150 = i177 + 4 | 0;
  i151 = i177 + 8 | 0;
  i152 = i177 + 12 | 0;
  i153 = i3 + 272 | 0;
  i154 = i168 + 56 | 0;
  i155 = i176 + 16 | 0;
  i156 = i3 + 356 | 0;
  i157 = i177 + 4 | 0;
  i158 = i177 + 8 | 0;
  i159 = i177 + 12 | 0;
  i81 = i3 + 536 | 0;
  i82 = i168 + 112 | 0;
  i83 = i176 + 32 | 0;
  i84 = i3 + 620 | 0;
  i85 = i177 + 4 | 0;
  i86 = i177 + 8 | 0;
  i87 = i177 + 12 | 0;
  i88 = i166 + 20 | 0;
  i89 = i166 + 40 | 0;
  i90 = i176 + 4 | 0;
  i91 = i176 + 8 | 0;
  i92 = i176 + 12 | 0;
  i93 = i176 + 16 | 0;
  i94 = i176 + 20 | 0;
  i95 = i176 + 24 | 0;
  i96 = i176 + 28 | 0;
  i97 = i176 + 32 | 0;
  i98 = i176 + 36 | 0;
  i99 = i176 + 40 | 0;
  i100 = i176 + 44 | 0;
  i101 = i3 + 808 | 0;
  i102 = i178 + 16 | 0;
  i103 = i179 + 4 | 0;
  i104 = i178 + 20 | 0;
  i105 = i179 + 8 | 0;
  i106 = i178 + 24 | 0;
  i107 = i179 + 12 | 0;
  i108 = i178 + 28 | 0;
  i109 = i163 + 4 | 0;
  i110 = i163 + 8 | 0;
  i111 = i163 + 12 | 0;
  i112 = i163 + 16 | 0;
  i113 = i179 + 16 | 0;
  i114 = i177 + 4 | 0;
  i115 = i179 + 20 | 0;
  i116 = i177 + 8 | 0;
  i117 = i179 + 24 | 0;
  i118 = i177 + 12 | 0;
  i119 = i179 + 28 | 0;
  i120 = i163 + 20 | 0;
  i121 = i163 + 24 | 0;
  i122 = i163 + 28 | 0;
  i123 = i163 + 32 | 0;
  i124 = i177 + 16 | 0;
  i125 = i178 + 4 | 0;
  i126 = i177 + 20 | 0;
  i127 = i178 + 8 | 0;
  i128 = i177 + 24 | 0;
  i129 = i178 + 12 | 0;
  i130 = i177 + 28 | 0;
  i131 = i163 + 36 | 0;
  i132 = i163 + 40 | 0;
  i133 = i163 + 44 | 0;
  i134 = i3 + 1884 | 0;
  i135 = i166 + 120 | 0;
  i136 = i166 + 140 | 0;
  i137 = i166 + 160 | 0;
  i138 = i163 + 16 | 0;
  f31 = Math_fround(f2 * Math_fround(.5));
  i32 = i3 + 1092 | 0;
  i33 = i165 + 12 | 0;
  i34 = i165 + 8 | 0;
  i35 = i165 + 4 | 0;
  i36 = i3 + 1176 | 0;
  i37 = i164 + 4 | 0;
  i38 = i164 + 8 | 0;
  i39 = i164 + 12 | 0;
  i40 = i3 + 1356 | 0;
  i41 = i170 + 56 | 0;
  i42 = i165 + 12 | 0;
  i43 = i165 + 8 | 0;
  i44 = i165 + 4 | 0;
  i45 = i3 + 1440 | 0;
  i46 = i164 + 4 | 0;
  i47 = i164 + 8 | 0;
  i48 = i164 + 12 | 0;
  i49 = i3 + 1620 | 0;
  i50 = i170 + 112 | 0;
  i51 = i165 + 12 | 0;
  i52 = i165 + 8 | 0;
  i53 = i165 + 4 | 0;
  i54 = i3 + 1704 | 0;
  i55 = i164 + 4 | 0;
  i56 = i164 + 8 | 0;
  i57 = i164 + 12 | 0;
  i58 = i3 + 1700 | 0;
  i59 = i3 + 1852 | 0;
  i60 = i3 + 1764 | 0;
  i61 = i3 + 1436 | 0;
  i62 = i3 + 1588 | 0;
  i63 = i3 + 1500 | 0;
  i64 = i3 + 1172 | 0;
  i65 = i3 + 1324 | 0;
  i66 = i3 + 1236 | 0;
  i67 = i3 + 616 | 0;
  i68 = i3 + 768 | 0;
  i69 = i3 + 680 | 0;
  i70 = i176 + 36 | 0;
  i71 = i176 + 40 | 0;
  i72 = i176 + 44 | 0;
  i73 = i3 + 352 | 0;
  i74 = i3 + 504 | 0;
  i75 = i3 + 416 | 0;
  i76 = i176 + 20 | 0;
  i77 = i176 + 24 | 0;
  i78 = i176 + 28 | 0;
  i79 = i3 + 88 | 0;
  i80 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  i28 = i176 + 4 | 0;
  i29 = i176 + 8 | 0;
  i30 = i176 + 12 | 0;
  while (1) {
   i183 = (HEAP32[i140 >> 2] | 0) + (i4 << 2) | 0;
   f24 = Math_fround(HEAPF32[i183 >> 2]);
   f25 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.00999999977));
   f26 = Math_fround(f26 * Math_fround(.00999999977));
   f27 = Math_fround(Math_fround(HEAPF32[i183 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i171 >> 2] = Math_fround(f24 * Math_fround(.00999999977));
   HEAPF32[i141 >> 2] = f25;
   HEAPF32[i142 >> 2] = f26;
   HEAPF32[i143 >> 2] = f27;
   i183 = (HEAP32[i144 >> 2] | 0) + (i4 << 2) | 0;
   i182 = (HEAP32[i183 + 4 >> 2] | 0) + 1054653076 | 0;
   i181 = (HEAP32[i183 + 8 >> 2] | 0) + 1054653076 | 0;
   i1 = (HEAP32[i183 + 12 >> 2] | 0) + 1054653076 | 0;
   HEAP32[i177 >> 2] = (HEAP32[i183 >> 2] | 0) + 1054653076;
   HEAP32[i145 >> 2] = i182;
   HEAP32[i146 >> 2] = i181;
   HEAP32[i147 >> 2] = i1;
   __Z17GenerateRandomNx3RKN4math5_int4E(i176, i177);
   i1 = HEAP32[i149 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i79 >> 2] | 0;
     HEAP32[i152 >> 2] = i183;
     HEAP32[i151 >> 2] = i183;
     HEAP32[i150 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i80 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i79 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i176 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i28 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i29 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i30 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i150 >> 2] = f25;
     HEAPF32[i151 >> 2] = f26;
     HEAPF32[i152 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i148, i168, i171, i176);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i148, i171, i176);
     break L8;
    }
   } while (0);
   f2 = Math_fround(HEAPF32[i177 >> 2]);
   f5 = Math_fround(HEAPF32[i150 >> 2]);
   f6 = Math_fround(HEAPF32[i151 >> 2]);
   f7 = Math_fround(HEAPF32[i152 >> 2]);
   i1 = HEAP32[i156 >> 2] | 0;
   L16 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i73 >> 2] | 0;
     HEAP32[i159 >> 2] = i183;
     HEAP32[i158 >> 2] = i183;
     HEAP32[i157 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i74 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i73 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i75 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i155 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i76 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i77 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i78 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i157 >> 2] = f25;
     HEAPF32[i158 >> 2] = f26;
     HEAPF32[i159 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i153, i154, i171, i155);
     break L16;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i153, i171, i155);
     break L16;
    }
   } while (0);
   f8 = Math_fround(HEAPF32[i177 >> 2]);
   f9 = Math_fround(HEAPF32[i157 >> 2]);
   f10 = Math_fround(HEAPF32[i158 >> 2]);
   f11 = Math_fround(HEAPF32[i159 >> 2]);
   i1 = HEAP32[i84 >> 2] | 0;
   L24 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i67 >> 2] | 0;
     HEAP32[i87 >> 2] = i183;
     HEAP32[i86 >> 2] = i183;
     HEAP32[i85 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i68 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i67 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i69 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i70 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i71 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i72 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i85 >> 2] = f25;
     HEAPF32[i86 >> 2] = f26;
     HEAPF32[i87 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i81, i82, i171, i83);
     break L24;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i81, i171, i83);
     break L24;
    }
   } while (0);
   f17 = Math_fround(HEAPF32[i177 >> 2]);
   f18 = Math_fround(HEAPF32[i85 >> 2]);
   f19 = Math_fround(HEAPF32[i86 >> 2]);
   f27 = Math_fround(f175 * f2);
   f26 = Math_fround(f175 * f5);
   f25 = Math_fround(f175 * f6);
   f24 = Math_fround(f175 * f7);
   f23 = Math_fround(f175 * f8);
   f22 = Math_fround(f175 * f9);
   f21 = Math_fround(f175 * f10);
   f16 = Math_fround(f175 * f11);
   f17 = Math_fround(f175 * f17);
   f18 = Math_fround(f175 * f18);
   f19 = Math_fround(f175 * f19);
   f20 = Math_fround(f175 * Math_fround(HEAPF32[i87 >> 2]));
   i183 = (HEAP32[i166 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i183 >> 2]);
   f15 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i183 >> 2]);
   f7 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i183 >> 2]);
   f8 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f13 = Math_fround(f172 + f13);
   f15 = Math_fround(f172 + f15);
   f14 = Math_fround(f172 + f14);
   f12 = Math_fround(f172 + f12);
   f5 = Math_fround(f173 + f5);
   f7 = Math_fround(f173 + f7);
   f9 = Math_fround(f173 + f9);
   f11 = Math_fround(f173 + f11);
   f10 = Math_fround(f174 + f10);
   f8 = Math_fround(f174 + f8);
   f6 = Math_fround(f174 + f6);
   f2 = Math_fround(f174 + Math_fround(HEAPF32[i183 + 12 >> 2]));
   HEAPF32[i176 >> 2] = f10;
   HEAPF32[i90 >> 2] = f8;
   HEAPF32[i91 >> 2] = f6;
   HEAPF32[i92 >> 2] = f2;
   HEAPF32[i93 >> 2] = f5;
   HEAPF32[i94 >> 2] = f7;
   HEAPF32[i95 >> 2] = f9;
   HEAPF32[i96 >> 2] = f11;
   f184 = Math_fround(f169 + f15);
   f185 = Math_fround(f169 + f14);
   f186 = Math_fround(f169 + f12);
   HEAPF32[i97 >> 2] = Math_fround(f169 + f13);
   HEAPF32[i98 >> 2] = f184;
   HEAPF32[i99 >> 2] = f185;
   HEAPF32[i100 >> 2] = f186;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i177, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f13 = Math_fround(f13 + Math_fround(100.0));
   f15 = Math_fround(f15 + Math_fround(100.0));
   f14 = Math_fround(f14 + Math_fround(100.0));
   f12 = Math_fround(f12 + Math_fround(100.0));
   HEAPF32[i176 >> 2] = f13;
   HEAPF32[i90 >> 2] = f15;
   HEAPF32[i91 >> 2] = f14;
   HEAPF32[i92 >> 2] = f12;
   HEAPF32[i93 >> 2] = f10;
   HEAPF32[i94 >> 2] = f8;
   HEAPF32[i95 >> 2] = f6;
   HEAPF32[i96 >> 2] = f2;
   f186 = Math_fround(f169 + f7);
   f185 = Math_fround(f169 + f9);
   f184 = Math_fround(f169 + f11);
   HEAPF32[i97 >> 2] = Math_fround(f169 + f5);
   HEAPF32[i98 >> 2] = f186;
   HEAPF32[i99 >> 2] = f185;
   HEAPF32[i100 >> 2] = f184;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i178, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   HEAPF32[i176 >> 2] = f5;
   HEAPF32[i90 >> 2] = f7;
   HEAPF32[i91 >> 2] = f9;
   HEAPF32[i92 >> 2] = f11;
   HEAPF32[i93 >> 2] = f13;
   HEAPF32[i94 >> 2] = f15;
   HEAPF32[i95 >> 2] = f14;
   HEAPF32[i96 >> 2] = f12;
   f8 = Math_fround(f169 + f8);
   f6 = Math_fround(f169 + f6);
   f2 = Math_fround(f169 + f2);
   HEAPF32[i97 >> 2] = Math_fround(f169 + f10);
   HEAPF32[i98 >> 2] = f8;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i179, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f2 = Math_fround(HEAPF32[i179 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i102 >> 2]));
   f6 = Math_fround(HEAPF32[i103 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i104 >> 2]));
   f8 = Math_fround(HEAPF32[i105 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i106 >> 2]));
   f10 = Math_fround(HEAPF32[i107 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i108 >> 2]));
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i177 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i113 >> 2]));
   f14 = Math_fround(HEAPF32[i114 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i115 >> 2]));
   f15 = Math_fround(HEAPF32[i116 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i117 >> 2]));
   f13 = Math_fround(HEAPF32[i118 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i119 >> 2]));
   HEAPF32[i112 >> 2] = f12;
   HEAPF32[i120 >> 2] = f14;
   HEAPF32[i121 >> 2] = f15;
   HEAPF32[i122 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i178 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i124 >> 2]));
   f9 = Math_fround(HEAPF32[i125 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i126 >> 2]));
   f7 = Math_fround(HEAPF32[i127 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i128 >> 2]));
   f5 = Math_fround(HEAPF32[i129 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i130 >> 2]));
   HEAPF32[i123 >> 2] = f11;
   HEAPF32[i131 >> 2] = f9;
   HEAPF32[i132 >> 2] = f7;
   HEAPF32[i133 >> 2] = f5;
   if (HEAP8[i134 >> 0] | 0) {
    f189 = Math_fround(Math_fround(Math_fround(f31 * f2) * Math_fround(.5)) + Math_fround(.5));
    f188 = Math_fround(Math_fround(Math_fround(f31 * f6) * Math_fround(.5)) + Math_fround(.5));
    f187 = Math_fround(Math_fround(Math_fround(f31 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f31 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f31 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f31 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f31 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f31 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f31 * f11) * Math_fround(.5)) + Math_fround(.5));
    f184 = Math_fround(Math_fround(Math_fround(f31 * f9) * Math_fround(.5)) + Math_fround(.5));
    f185 = Math_fround(Math_fround(Math_fround(f31 * f7) * Math_fround(.5)) + Math_fround(.5));
    f186 = Math_fround(Math_fround(Math_fround(f31 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f189 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f189;
    i1 = f188 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f188;
    i1 = f187 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f187;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f184 < Math_fround(0.0);
    f184 = i1 ? Math_fround(0.0) : f184;
    i1 = f185 < Math_fround(0.0);
    f185 = i1 ? Math_fround(0.0) : f185;
    i1 = f186 < Math_fround(0.0);
    f186 = i1 ? Math_fround(0.0) : f186;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f184 > Math_fround(1.0);
    f184 = i1 ? Math_fround(1.0) : f184;
    i1 = f185 > Math_fround(1.0);
    f185 = i1 ? Math_fround(1.0) : f185;
    i1 = f186 > Math_fround(1.0);
    f186 = i1 ? Math_fround(1.0) : f186;
    HEAPF32[i163 >> 2] = f7;
    HEAPF32[i109 >> 2] = f8;
    HEAPF32[i110 >> 2] = f9;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f11;
    HEAPF32[i120 >> 2] = f12;
    HEAPF32[i121 >> 2] = f13;
    HEAPF32[i122 >> 2] = f14;
    HEAPF32[i123 >> 2] = f15;
    HEAPF32[i131 >> 2] = f184;
    HEAPF32[i132 >> 2] = f185;
    HEAPF32[i133 >> 2] = f186;
    HEAPF32[i33 >> 2] = Math_fround(1.0);
    HEAPF32[i34 >> 2] = Math_fround(1.0);
    HEAPF32[i35 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i36 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i64 >> 2] | 0;
      HEAP32[i39 >> 2] = i183;
      HEAP32[i38 >> 2] = i183;
      HEAP32[i37 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i65 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i64 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i66 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i37 >> 2] = f189;
      HEAPF32[i38 >> 2] = f189;
      HEAPF32[i39 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i32, i170, i163, i165);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i32, i163, i165);
      break L34;
     }
    } while (0);
    i182 = HEAP32[i37 >> 2] | 0;
    i183 = HEAP32[i38 >> 2] | 0;
    i1 = HEAP32[i39 >> 2] | 0;
    HEAP32[i163 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i109 >> 2] = i182;
    HEAP32[i110 >> 2] = i183;
    HEAP32[i111 >> 2] = i1;
    HEAPF32[i42 >> 2] = Math_fround(1.0);
    HEAPF32[i43 >> 2] = Math_fround(1.0);
    HEAPF32[i44 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i45 >> 2] | 0;
    L42 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i61 >> 2] | 0;
      HEAP32[i48 >> 2] = i183;
      HEAP32[i47 >> 2] = i183;
      HEAP32[i46 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i62 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i61 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i63 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i46 >> 2] = f189;
      HEAPF32[i47 >> 2] = f189;
      HEAPF32[i48 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i40, i41, i112, i165);
      break L42;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i40, i112, i165);
      break L42;
     }
    } while (0);
    i182 = HEAP32[i46 >> 2] | 0;
    i183 = HEAP32[i47 >> 2] | 0;
    i1 = HEAP32[i48 >> 2] | 0;
    HEAP32[i112 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i120 >> 2] = i182;
    HEAP32[i121 >> 2] = i183;
    HEAP32[i122 >> 2] = i1;
    HEAPF32[i51 >> 2] = Math_fround(1.0);
    HEAPF32[i52 >> 2] = Math_fround(1.0);
    HEAPF32[i53 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i54 >> 2] | 0;
    L50 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i58 >> 2] | 0;
      HEAP32[i57 >> 2] = i183;
      HEAP32[i56 >> 2] = i183;
      HEAP32[i55 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i59 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i58 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i60 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i55 >> 2] = f189;
      HEAPF32[i56 >> 2] = f189;
      HEAPF32[i57 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i49, i50, i123, i165);
      break L50;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i49, i123, i165);
      break L50;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i164 >> 2]);
    f9 = Math_fround(HEAPF32[i55 >> 2]);
    f7 = Math_fround(HEAPF32[i56 >> 2]);
    f5 = Math_fround(HEAPF32[i57 >> 2]);
    f189 = Math_fround(Math_fround(HEAPF32[i160 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i163 >> 2]) * f189);
    f6 = Math_fround(f189 * Math_fround(HEAPF32[i109 >> 2]));
    f8 = Math_fround(f189 * Math_fround(HEAPF32[i110 >> 2]));
    f10 = Math_fround(f189 * Math_fround(HEAPF32[i111 >> 2]));
    f12 = Math_fround(f189 * Math_fround(HEAPF32[i138 >> 2]));
    f14 = Math_fround(f189 * Math_fround(HEAPF32[i120 >> 2]));
    f15 = Math_fround(f189 * Math_fround(HEAPF32[i121 >> 2]));
    f13 = Math_fround(f189 * Math_fround(HEAPF32[i122 >> 2]));
    f11 = Math_fround(f189 * f11);
    f9 = Math_fround(f189 * f9);
    f7 = Math_fround(f189 * f7);
    f5 = Math_fround(f189 * f5);
    HEAPF32[i163 >> 2] = f2;
    HEAPF32[i109 >> 2] = f6;
    HEAPF32[i110 >> 2] = f8;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f12;
    HEAPF32[i120 >> 2] = f14;
    HEAPF32[i121 >> 2] = f15;
    HEAPF32[i122 >> 2] = f13;
    HEAPF32[i123 >> 2] = f11;
    HEAPF32[i131 >> 2] = f9;
    HEAPF32[i132 >> 2] = f7;
    HEAPF32[i133 >> 2] = f5;
   }
   f2 = Math_fround(f27 * f2);
   f6 = Math_fround(f26 * f6);
   f8 = Math_fround(f25 * f8);
   f25 = Math_fround(f24 * f10);
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f25;
   f26 = Math_fround(f23 * f12);
   f27 = Math_fround(f22 * f14);
   f184 = Math_fround(f21 * f15);
   f185 = Math_fround(f16 * f13);
   HEAPF32[i112 >> 2] = f26;
   HEAPF32[i120 >> 2] = f27;
   HEAPF32[i121 >> 2] = f184;
   HEAPF32[i122 >> 2] = f185;
   f186 = Math_fround(f17 * f11);
   f187 = Math_fround(f18 * f9);
   f188 = Math_fround(f19 * f7);
   f189 = Math_fround(f20 * f5);
   HEAPF32[i123 >> 2] = f186;
   HEAPF32[i131 >> 2] = f187;
   HEAPF32[i132 >> 2] = f188;
   HEAPF32[i133 >> 2] = f189;
   i197 = (HEAP32[i135 >> 2] | 0) + (i4 << 2) | 0;
   f22 = Math_fround(HEAPF32[i197 >> 2]);
   i196 = i197 + 4 | 0;
   f23 = Math_fround(HEAPF32[i196 >> 2]);
   i195 = i197 + 8 | 0;
   f24 = Math_fround(HEAPF32[i195 >> 2]);
   i194 = i197 + 12 | 0;
   f14 = Math_fround(HEAPF32[i194 >> 2]);
   i193 = (HEAP32[i136 >> 2] | 0) + (i4 << 2) | 0;
   f15 = Math_fround(HEAPF32[i193 >> 2]);
   i192 = i193 + 4 | 0;
   f16 = Math_fround(HEAPF32[i192 >> 2]);
   i191 = i193 + 8 | 0;
   f17 = Math_fround(HEAPF32[i191 >> 2]);
   i190 = i193 + 12 | 0;
   f18 = Math_fround(HEAPF32[i190 >> 2]);
   i1 = (HEAP32[i137 >> 2] | 0) + (i4 << 2) | 0;
   f19 = Math_fround(HEAPF32[i1 >> 2]);
   i181 = i1 + 4 | 0;
   f20 = Math_fround(HEAPF32[i181 >> 2]);
   i182 = i1 + 8 | 0;
   f21 = Math_fround(HEAPF32[i182 >> 2]);
   i183 = i1 + 12 | 0;
   f23 = Math_fround(f23 + f6);
   f24 = Math_fround(f24 + f8);
   f25 = Math_fround(f14 + f25);
   f26 = Math_fround(f15 + f26);
   f27 = Math_fround(f16 + f27);
   f184 = Math_fround(f17 + f184);
   f185 = Math_fround(f18 + f185);
   f186 = Math_fround(f19 + f186);
   f187 = Math_fround(f20 + f187);
   f188 = Math_fround(f21 + f188);
   f189 = Math_fround(Math_fround(HEAPF32[i183 >> 2]) + f189);
   HEAPF32[i197 >> 2] = Math_fround(f22 + f2);
   HEAPF32[i196 >> 2] = f23;
   HEAPF32[i195 >> 2] = f24;
   HEAPF32[i194 >> 2] = f25;
   HEAPF32[i193 >> 2] = f26;
   HEAPF32[i192 >> 2] = f27;
   HEAPF32[i191 >> 2] = f184;
   HEAPF32[i190 >> 2] = f185;
   HEAPF32[i1 >> 2] = f186;
   HEAPF32[i181 >> 2] = f187;
   HEAPF32[i182 >> 2] = f188;
   HEAPF32[i183 >> 2] = f189;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i139 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i161) {
  STACKTOP = i180;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i161);
 STACKTOP = i180;
 return;
}

function __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb1EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, f169 = f0, i170 = 0, i171 = 0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0;
 i180 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i160 = i180 + 584 | 0;
 i162 = i180 + 580 | 0;
 i167 = i180 + 576 | 0;
 i168 = i180 + 408 | 0;
 i170 = i180 + 240 | 0;
 i171 = i180 + 224 | 0;
 i176 = i180 + 176 | 0;
 i177 = i180 + 144 | 0;
 i178 = i180 + 112 | 0;
 i179 = i180 + 80 | 0;
 i163 = i180 + 32 | 0;
 i164 = i180 + 16 | 0;
 i165 = i180;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i162 >> 2] = 0;
  HEAP32[i160 >> 2] = HEAP32[i162 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i160);
  i161 = gb + 1451836 | 0;
 } else i161 = 0;
 i166 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i160 >> 2] = f2;
 HEAP32[i162 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i167 >> 2] = HEAP32[i3 + 812 >> 2];
 f172 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f173 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f174 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f169 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i168 + 4 >> 2] = Math_fround(inf);
 HEAP32[i168 >> 2] = 0;
 i139 = i168 + 8 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 32 >> 2] = Math_fround(inf);
 HEAP32[i168 + 28 >> 2] = 0;
 i139 = i168 + 36 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 60 >> 2] = Math_fround(inf);
 HEAP32[i168 + 56 >> 2] = 0;
 i139 = i168 + 64 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 88 >> 2] = Math_fround(inf);
 HEAP32[i168 + 84 >> 2] = 0;
 i139 = i168 + 92 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 116 >> 2] = Math_fround(inf);
 HEAP32[i168 + 112 >> 2] = 0;
 i139 = i168 + 120 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 144 >> 2] = Math_fround(inf);
 HEAP32[i168 + 140 >> 2] = 0;
 i139 = i168 + 148 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f172 = Math_fround(f172 * Math_fround(100.0));
 f173 = Math_fround(f173 * Math_fround(100.0));
 f174 = Math_fround(f174 * Math_fround(100.0));
 f175 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i170 + 4 >> 2] = Math_fround(inf);
 HEAP32[i170 >> 2] = 0;
 i4 = i170 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 32 >> 2] = Math_fround(inf);
 HEAP32[i170 + 28 >> 2] = 0;
 i4 = i170 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 60 >> 2] = Math_fround(inf);
 HEAP32[i170 + 56 >> 2] = 0;
 i4 = i170 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 88 >> 2] = Math_fround(inf);
 HEAP32[i170 + 84 >> 2] = 0;
 i4 = i170 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 116 >> 2] = Math_fround(inf);
 HEAP32[i170 + 112 >> 2] = 0;
 i4 = i170 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 144 >> 2] = Math_fround(inf);
 HEAP32[i170 + 140 >> 2] = 0;
 i4 = i170 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i139 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i139 >> 2] | 0) >>> 0) {
  i140 = i166 + 520 | 0;
  i141 = i171 + 4 | 0;
  i142 = i171 + 8 | 0;
  i143 = i171 + 12 | 0;
  i144 = i166 + 500 | 0;
  i145 = i177 + 4 | 0;
  i146 = i177 + 8 | 0;
  i147 = i177 + 12 | 0;
  i148 = i3 + 8 | 0;
  i149 = i3 + 92 | 0;
  i150 = i177 + 4 | 0;
  i151 = i177 + 8 | 0;
  i152 = i177 + 12 | 0;
  i153 = i3 + 272 | 0;
  i154 = i168 + 56 | 0;
  i155 = i176 + 16 | 0;
  i156 = i3 + 356 | 0;
  i157 = i177 + 4 | 0;
  i158 = i177 + 8 | 0;
  i159 = i177 + 12 | 0;
  i81 = i3 + 536 | 0;
  i82 = i168 + 112 | 0;
  i83 = i176 + 32 | 0;
  i84 = i3 + 620 | 0;
  i85 = i177 + 4 | 0;
  i86 = i177 + 8 | 0;
  i87 = i177 + 12 | 0;
  i88 = i166 + 20 | 0;
  i89 = i166 + 40 | 0;
  i90 = i176 + 4 | 0;
  i91 = i176 + 8 | 0;
  i92 = i176 + 12 | 0;
  i93 = i176 + 16 | 0;
  i94 = i176 + 20 | 0;
  i95 = i176 + 24 | 0;
  i96 = i176 + 28 | 0;
  i97 = i176 + 32 | 0;
  i98 = i176 + 36 | 0;
  i99 = i176 + 40 | 0;
  i100 = i176 + 44 | 0;
  i101 = i3 + 808 | 0;
  i102 = i178 + 16 | 0;
  i103 = i179 + 4 | 0;
  i104 = i178 + 20 | 0;
  i105 = i179 + 8 | 0;
  i106 = i178 + 24 | 0;
  i107 = i179 + 12 | 0;
  i108 = i178 + 28 | 0;
  i109 = i163 + 4 | 0;
  i110 = i163 + 8 | 0;
  i111 = i163 + 12 | 0;
  i112 = i163 + 16 | 0;
  i113 = i179 + 16 | 0;
  i114 = i177 + 4 | 0;
  i115 = i179 + 20 | 0;
  i116 = i177 + 8 | 0;
  i117 = i179 + 24 | 0;
  i118 = i177 + 12 | 0;
  i119 = i179 + 28 | 0;
  i120 = i163 + 20 | 0;
  i121 = i163 + 24 | 0;
  i122 = i163 + 28 | 0;
  i123 = i163 + 32 | 0;
  i124 = i177 + 16 | 0;
  i125 = i178 + 4 | 0;
  i126 = i177 + 20 | 0;
  i127 = i178 + 8 | 0;
  i128 = i177 + 24 | 0;
  i129 = i178 + 12 | 0;
  i130 = i177 + 28 | 0;
  i131 = i163 + 36 | 0;
  i132 = i163 + 40 | 0;
  i133 = i163 + 44 | 0;
  i134 = i3 + 1884 | 0;
  i135 = i166 + 120 | 0;
  i136 = i166 + 140 | 0;
  i137 = i166 + 160 | 0;
  i138 = i163 + 16 | 0;
  f31 = Math_fround(f2 * Math_fround(.5));
  i32 = i3 + 1092 | 0;
  i33 = i165 + 12 | 0;
  i34 = i165 + 8 | 0;
  i35 = i165 + 4 | 0;
  i36 = i3 + 1176 | 0;
  i37 = i164 + 4 | 0;
  i38 = i164 + 8 | 0;
  i39 = i164 + 12 | 0;
  i40 = i3 + 1356 | 0;
  i41 = i170 + 56 | 0;
  i42 = i165 + 12 | 0;
  i43 = i165 + 8 | 0;
  i44 = i165 + 4 | 0;
  i45 = i3 + 1440 | 0;
  i46 = i164 + 4 | 0;
  i47 = i164 + 8 | 0;
  i48 = i164 + 12 | 0;
  i49 = i3 + 1620 | 0;
  i50 = i170 + 112 | 0;
  i51 = i165 + 12 | 0;
  i52 = i165 + 8 | 0;
  i53 = i165 + 4 | 0;
  i54 = i3 + 1704 | 0;
  i55 = i164 + 4 | 0;
  i56 = i164 + 8 | 0;
  i57 = i164 + 12 | 0;
  i58 = i3 + 1700 | 0;
  i59 = i3 + 1852 | 0;
  i60 = i3 + 1764 | 0;
  i61 = i3 + 1436 | 0;
  i62 = i3 + 1588 | 0;
  i63 = i3 + 1500 | 0;
  i64 = i3 + 1172 | 0;
  i65 = i3 + 1324 | 0;
  i66 = i3 + 1236 | 0;
  i67 = i3 + 616 | 0;
  i68 = i3 + 768 | 0;
  i69 = i3 + 680 | 0;
  i70 = i176 + 36 | 0;
  i71 = i176 + 40 | 0;
  i72 = i176 + 44 | 0;
  i73 = i3 + 352 | 0;
  i74 = i3 + 504 | 0;
  i75 = i3 + 416 | 0;
  i76 = i176 + 20 | 0;
  i77 = i176 + 24 | 0;
  i78 = i176 + 28 | 0;
  i79 = i3 + 88 | 0;
  i80 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  i28 = i176 + 4 | 0;
  i29 = i176 + 8 | 0;
  i30 = i176 + 12 | 0;
  while (1) {
   i183 = (HEAP32[i140 >> 2] | 0) + (i4 << 2) | 0;
   f24 = Math_fround(HEAPF32[i183 >> 2]);
   f25 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.00999999977));
   f26 = Math_fround(f26 * Math_fround(.00999999977));
   f27 = Math_fround(Math_fround(HEAPF32[i183 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i171 >> 2] = Math_fround(f24 * Math_fround(.00999999977));
   HEAPF32[i141 >> 2] = f25;
   HEAPF32[i142 >> 2] = f26;
   HEAPF32[i143 >> 2] = f27;
   i183 = (HEAP32[i144 >> 2] | 0) + (i4 << 2) | 0;
   i182 = (HEAP32[i183 + 4 >> 2] | 0) + 1054653076 | 0;
   i181 = (HEAP32[i183 + 8 >> 2] | 0) + 1054653076 | 0;
   i1 = (HEAP32[i183 + 12 >> 2] | 0) + 1054653076 | 0;
   HEAP32[i177 >> 2] = (HEAP32[i183 >> 2] | 0) + 1054653076;
   HEAP32[i145 >> 2] = i182;
   HEAP32[i146 >> 2] = i181;
   HEAP32[i147 >> 2] = i1;
   __Z17GenerateRandomNx3RKN4math5_int4E(i176, i177);
   i1 = HEAP32[i149 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i79 >> 2] | 0;
     HEAP32[i152 >> 2] = i183;
     HEAP32[i151 >> 2] = i183;
     HEAP32[i150 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i80 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i79 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i176 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i28 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i29 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i30 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i150 >> 2] = f25;
     HEAPF32[i151 >> 2] = f26;
     HEAPF32[i152 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i148, i168, i171, i176);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i148, i171, i176);
     break L8;
    }
   } while (0);
   f2 = Math_fround(HEAPF32[i177 >> 2]);
   f5 = Math_fround(HEAPF32[i150 >> 2]);
   f6 = Math_fround(HEAPF32[i151 >> 2]);
   f7 = Math_fround(HEAPF32[i152 >> 2]);
   i1 = HEAP32[i156 >> 2] | 0;
   L16 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i73 >> 2] | 0;
     HEAP32[i159 >> 2] = i183;
     HEAP32[i158 >> 2] = i183;
     HEAP32[i157 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i74 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i73 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i75 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i155 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i76 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i77 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i78 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i157 >> 2] = f25;
     HEAPF32[i158 >> 2] = f26;
     HEAPF32[i159 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i153, i154, i171, i155);
     break L16;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i153, i171, i155);
     break L16;
    }
   } while (0);
   f8 = Math_fround(HEAPF32[i177 >> 2]);
   f9 = Math_fround(HEAPF32[i157 >> 2]);
   f10 = Math_fround(HEAPF32[i158 >> 2]);
   f11 = Math_fround(HEAPF32[i159 >> 2]);
   i1 = HEAP32[i84 >> 2] | 0;
   L24 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i67 >> 2] | 0;
     HEAP32[i87 >> 2] = i183;
     HEAP32[i86 >> 2] = i183;
     HEAP32[i85 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i68 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i67 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i69 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i70 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i71 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i72 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i85 >> 2] = f25;
     HEAPF32[i86 >> 2] = f26;
     HEAPF32[i87 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i81, i82, i171, i83);
     break L24;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i81, i171, i83);
     break L24;
    }
   } while (0);
   f17 = Math_fround(HEAPF32[i177 >> 2]);
   f18 = Math_fround(HEAPF32[i85 >> 2]);
   f19 = Math_fround(HEAPF32[i86 >> 2]);
   f27 = Math_fround(f175 * f2);
   f26 = Math_fround(f175 * f5);
   f25 = Math_fround(f175 * f6);
   f24 = Math_fround(f175 * f7);
   f23 = Math_fround(f175 * f8);
   f22 = Math_fround(f175 * f9);
   f21 = Math_fround(f175 * f10);
   f16 = Math_fround(f175 * f11);
   f17 = Math_fround(f175 * f17);
   f18 = Math_fround(f175 * f18);
   f19 = Math_fround(f175 * f19);
   f20 = Math_fround(f175 * Math_fround(HEAPF32[i87 >> 2]));
   i183 = (HEAP32[i166 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i183 >> 2]);
   f8 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i183 >> 2]);
   f7 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i183 >> 2]);
   f15 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f10 = Math_fround(f172 + f10);
   f8 = Math_fround(f172 + f8);
   f6 = Math_fround(f172 + f6);
   f2 = Math_fround(f172 + f2);
   f5 = Math_fround(f173 + f5);
   f7 = Math_fround(f173 + f7);
   f9 = Math_fround(f173 + f9);
   f11 = Math_fround(f173 + f11);
   f13 = Math_fround(f174 + f13);
   f15 = Math_fround(f174 + f15);
   f14 = Math_fround(f174 + f14);
   f12 = Math_fround(f174 + Math_fround(HEAPF32[i183 + 12 >> 2]));
   HEAPF32[i176 >> 2] = f13;
   HEAPF32[i90 >> 2] = f15;
   HEAPF32[i91 >> 2] = f14;
   HEAPF32[i92 >> 2] = f12;
   HEAPF32[i97 >> 2] = f10;
   HEAPF32[i98 >> 2] = f8;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f2;
   f184 = Math_fround(f169 + f7);
   f185 = Math_fround(f169 + f9);
   f186 = Math_fround(f169 + f11);
   HEAPF32[i93 >> 2] = Math_fround(f169 + f5);
   HEAPF32[i94 >> 2] = f184;
   HEAPF32[i95 >> 2] = f185;
   HEAPF32[i96 >> 2] = f186;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i177, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f10 = Math_fround(f10 + Math_fround(100.0));
   f8 = Math_fround(f8 + Math_fround(100.0));
   f6 = Math_fround(f6 + Math_fround(100.0));
   f2 = Math_fround(f2 + Math_fround(100.0));
   HEAPF32[i176 >> 2] = f10;
   HEAPF32[i90 >> 2] = f8;
   HEAPF32[i91 >> 2] = f6;
   HEAPF32[i92 >> 2] = f2;
   HEAPF32[i97 >> 2] = f5;
   HEAPF32[i98 >> 2] = f7;
   HEAPF32[i99 >> 2] = f9;
   HEAPF32[i100 >> 2] = f11;
   f186 = Math_fround(f169 + f15);
   f185 = Math_fround(f169 + f14);
   f184 = Math_fround(f169 + f12);
   HEAPF32[i93 >> 2] = Math_fround(f169 + f13);
   HEAPF32[i94 >> 2] = f186;
   HEAPF32[i95 >> 2] = f185;
   HEAPF32[i96 >> 2] = f184;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i178, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   HEAPF32[i176 >> 2] = f5;
   HEAPF32[i90 >> 2] = f7;
   HEAPF32[i91 >> 2] = f9;
   HEAPF32[i92 >> 2] = f11;
   HEAPF32[i97 >> 2] = f13;
   HEAPF32[i98 >> 2] = f15;
   HEAPF32[i99 >> 2] = f14;
   HEAPF32[i100 >> 2] = f12;
   f8 = Math_fround(f169 + f8);
   f6 = Math_fround(f169 + f6);
   f2 = Math_fround(f169 + f2);
   HEAPF32[i93 >> 2] = Math_fround(f169 + f10);
   HEAPF32[i94 >> 2] = f8;
   HEAPF32[i95 >> 2] = f6;
   HEAPF32[i96 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i179, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f2 = Math_fround(HEAPF32[i179 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i102 >> 2]));
   f6 = Math_fround(HEAPF32[i103 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i104 >> 2]));
   f8 = Math_fround(HEAPF32[i105 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i106 >> 2]));
   f10 = Math_fround(HEAPF32[i107 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i108 >> 2]));
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i177 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i113 >> 2]));
   f14 = Math_fround(HEAPF32[i114 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i115 >> 2]));
   f15 = Math_fround(HEAPF32[i116 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i117 >> 2]));
   f13 = Math_fround(HEAPF32[i118 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i119 >> 2]));
   HEAPF32[i112 >> 2] = f12;
   HEAPF32[i120 >> 2] = f14;
   HEAPF32[i121 >> 2] = f15;
   HEAPF32[i122 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i178 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i124 >> 2]));
   f9 = Math_fround(HEAPF32[i125 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i126 >> 2]));
   f7 = Math_fround(HEAPF32[i127 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i128 >> 2]));
   f5 = Math_fround(HEAPF32[i129 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i130 >> 2]));
   HEAPF32[i123 >> 2] = f11;
   HEAPF32[i131 >> 2] = f9;
   HEAPF32[i132 >> 2] = f7;
   HEAPF32[i133 >> 2] = f5;
   if (HEAP8[i134 >> 0] | 0) {
    f189 = Math_fround(Math_fround(Math_fround(f31 * f2) * Math_fround(.5)) + Math_fround(.5));
    f188 = Math_fround(Math_fround(Math_fround(f31 * f6) * Math_fround(.5)) + Math_fround(.5));
    f187 = Math_fround(Math_fround(Math_fround(f31 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f31 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f31 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f31 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f31 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f31 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f31 * f11) * Math_fround(.5)) + Math_fround(.5));
    f184 = Math_fround(Math_fround(Math_fround(f31 * f9) * Math_fround(.5)) + Math_fround(.5));
    f185 = Math_fround(Math_fround(Math_fround(f31 * f7) * Math_fround(.5)) + Math_fround(.5));
    f186 = Math_fround(Math_fround(Math_fround(f31 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f189 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f189;
    i1 = f188 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f188;
    i1 = f187 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f187;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f184 < Math_fround(0.0);
    f184 = i1 ? Math_fround(0.0) : f184;
    i1 = f185 < Math_fround(0.0);
    f185 = i1 ? Math_fround(0.0) : f185;
    i1 = f186 < Math_fround(0.0);
    f186 = i1 ? Math_fround(0.0) : f186;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f184 > Math_fround(1.0);
    f184 = i1 ? Math_fround(1.0) : f184;
    i1 = f185 > Math_fround(1.0);
    f185 = i1 ? Math_fround(1.0) : f185;
    i1 = f186 > Math_fround(1.0);
    f186 = i1 ? Math_fround(1.0) : f186;
    HEAPF32[i163 >> 2] = f7;
    HEAPF32[i109 >> 2] = f8;
    HEAPF32[i110 >> 2] = f9;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f11;
    HEAPF32[i120 >> 2] = f12;
    HEAPF32[i121 >> 2] = f13;
    HEAPF32[i122 >> 2] = f14;
    HEAPF32[i123 >> 2] = f15;
    HEAPF32[i131 >> 2] = f184;
    HEAPF32[i132 >> 2] = f185;
    HEAPF32[i133 >> 2] = f186;
    HEAPF32[i33 >> 2] = Math_fround(1.0);
    HEAPF32[i34 >> 2] = Math_fround(1.0);
    HEAPF32[i35 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i36 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i64 >> 2] | 0;
      HEAP32[i39 >> 2] = i183;
      HEAP32[i38 >> 2] = i183;
      HEAP32[i37 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i65 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i64 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i66 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i37 >> 2] = f189;
      HEAPF32[i38 >> 2] = f189;
      HEAPF32[i39 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i32, i170, i163, i165);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i32, i163, i165);
      break L34;
     }
    } while (0);
    i182 = HEAP32[i37 >> 2] | 0;
    i183 = HEAP32[i38 >> 2] | 0;
    i1 = HEAP32[i39 >> 2] | 0;
    HEAP32[i163 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i109 >> 2] = i182;
    HEAP32[i110 >> 2] = i183;
    HEAP32[i111 >> 2] = i1;
    HEAPF32[i42 >> 2] = Math_fround(1.0);
    HEAPF32[i43 >> 2] = Math_fround(1.0);
    HEAPF32[i44 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i45 >> 2] | 0;
    L42 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i61 >> 2] | 0;
      HEAP32[i48 >> 2] = i183;
      HEAP32[i47 >> 2] = i183;
      HEAP32[i46 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i62 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i61 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i63 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i46 >> 2] = f189;
      HEAPF32[i47 >> 2] = f189;
      HEAPF32[i48 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i40, i41, i112, i165);
      break L42;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i40, i112, i165);
      break L42;
     }
    } while (0);
    i182 = HEAP32[i46 >> 2] | 0;
    i183 = HEAP32[i47 >> 2] | 0;
    i1 = HEAP32[i48 >> 2] | 0;
    HEAP32[i112 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i120 >> 2] = i182;
    HEAP32[i121 >> 2] = i183;
    HEAP32[i122 >> 2] = i1;
    HEAPF32[i51 >> 2] = Math_fround(1.0);
    HEAPF32[i52 >> 2] = Math_fround(1.0);
    HEAPF32[i53 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i54 >> 2] | 0;
    L50 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i58 >> 2] | 0;
      HEAP32[i57 >> 2] = i183;
      HEAP32[i56 >> 2] = i183;
      HEAP32[i55 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i59 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i58 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i60 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i55 >> 2] = f189;
      HEAPF32[i56 >> 2] = f189;
      HEAPF32[i57 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i49, i50, i123, i165);
      break L50;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i49, i123, i165);
      break L50;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i164 >> 2]);
    f9 = Math_fround(HEAPF32[i55 >> 2]);
    f7 = Math_fround(HEAPF32[i56 >> 2]);
    f5 = Math_fround(HEAPF32[i57 >> 2]);
    f189 = Math_fround(Math_fround(HEAPF32[i160 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i163 >> 2]) * f189);
    f6 = Math_fround(f189 * Math_fround(HEAPF32[i109 >> 2]));
    f8 = Math_fround(f189 * Math_fround(HEAPF32[i110 >> 2]));
    f10 = Math_fround(f189 * Math_fround(HEAPF32[i111 >> 2]));
    f12 = Math_fround(f189 * Math_fround(HEAPF32[i138 >> 2]));
    f14 = Math_fround(f189 * Math_fround(HEAPF32[i120 >> 2]));
    f15 = Math_fround(f189 * Math_fround(HEAPF32[i121 >> 2]));
    f13 = Math_fround(f189 * Math_fround(HEAPF32[i122 >> 2]));
    f11 = Math_fround(f189 * f11);
    f9 = Math_fround(f189 * f9);
    f7 = Math_fround(f189 * f7);
    f5 = Math_fround(f189 * f5);
    HEAPF32[i163 >> 2] = f2;
    HEAPF32[i109 >> 2] = f6;
    HEAPF32[i110 >> 2] = f8;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f12;
    HEAPF32[i120 >> 2] = f14;
    HEAPF32[i121 >> 2] = f15;
    HEAPF32[i122 >> 2] = f13;
    HEAPF32[i123 >> 2] = f11;
    HEAPF32[i131 >> 2] = f9;
    HEAPF32[i132 >> 2] = f7;
    HEAPF32[i133 >> 2] = f5;
   }
   f2 = Math_fround(f27 * f2);
   f6 = Math_fround(f26 * f6);
   f8 = Math_fround(f25 * f8);
   f25 = Math_fround(f24 * f10);
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f25;
   f26 = Math_fround(f23 * f12);
   f27 = Math_fround(f22 * f14);
   f184 = Math_fround(f21 * f15);
   f185 = Math_fround(f16 * f13);
   HEAPF32[i112 >> 2] = f26;
   HEAPF32[i120 >> 2] = f27;
   HEAPF32[i121 >> 2] = f184;
   HEAPF32[i122 >> 2] = f185;
   f186 = Math_fround(f17 * f11);
   f187 = Math_fround(f18 * f9);
   f188 = Math_fround(f19 * f7);
   f189 = Math_fround(f20 * f5);
   HEAPF32[i123 >> 2] = f186;
   HEAPF32[i131 >> 2] = f187;
   HEAPF32[i132 >> 2] = f188;
   HEAPF32[i133 >> 2] = f189;
   i197 = (HEAP32[i135 >> 2] | 0) + (i4 << 2) | 0;
   f22 = Math_fround(HEAPF32[i197 >> 2]);
   i196 = i197 + 4 | 0;
   f23 = Math_fround(HEAPF32[i196 >> 2]);
   i195 = i197 + 8 | 0;
   f24 = Math_fround(HEAPF32[i195 >> 2]);
   i194 = i197 + 12 | 0;
   f14 = Math_fround(HEAPF32[i194 >> 2]);
   i193 = (HEAP32[i136 >> 2] | 0) + (i4 << 2) | 0;
   f15 = Math_fround(HEAPF32[i193 >> 2]);
   i192 = i193 + 4 | 0;
   f16 = Math_fround(HEAPF32[i192 >> 2]);
   i191 = i193 + 8 | 0;
   f17 = Math_fround(HEAPF32[i191 >> 2]);
   i190 = i193 + 12 | 0;
   f18 = Math_fround(HEAPF32[i190 >> 2]);
   i1 = (HEAP32[i137 >> 2] | 0) + (i4 << 2) | 0;
   f19 = Math_fround(HEAPF32[i1 >> 2]);
   i181 = i1 + 4 | 0;
   f20 = Math_fround(HEAPF32[i181 >> 2]);
   i182 = i1 + 8 | 0;
   f21 = Math_fround(HEAPF32[i182 >> 2]);
   i183 = i1 + 12 | 0;
   f23 = Math_fround(f23 + f6);
   f24 = Math_fround(f24 + f8);
   f25 = Math_fround(f14 + f25);
   f26 = Math_fround(f15 + f26);
   f27 = Math_fround(f16 + f27);
   f184 = Math_fround(f17 + f184);
   f185 = Math_fround(f18 + f185);
   f186 = Math_fround(f19 + f186);
   f187 = Math_fround(f20 + f187);
   f188 = Math_fround(f21 + f188);
   f189 = Math_fround(Math_fround(HEAPF32[i183 >> 2]) + f189);
   HEAPF32[i197 >> 2] = Math_fround(f22 + f2);
   HEAPF32[i196 >> 2] = f23;
   HEAPF32[i195 >> 2] = f24;
   HEAPF32[i194 >> 2] = f25;
   HEAPF32[i193 >> 2] = f26;
   HEAPF32[i192 >> 2] = f27;
   HEAPF32[i191 >> 2] = f184;
   HEAPF32[i190 >> 2] = f185;
   HEAPF32[i1 >> 2] = f186;
   HEAPF32[i181 >> 2] = f187;
   HEAPF32[i182 >> 2] = f188;
   HEAPF32[i183 >> 2] = f189;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i139 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i161) {
  STACKTOP = i180;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i161);
 STACKTOP = i180;
 return;
}

function __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb1EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, f169 = f0, i170 = 0, i171 = 0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0;
 i180 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i160 = i180 + 584 | 0;
 i162 = i180 + 580 | 0;
 i167 = i180 + 576 | 0;
 i168 = i180 + 408 | 0;
 i170 = i180 + 240 | 0;
 i171 = i180 + 224 | 0;
 i176 = i180 + 176 | 0;
 i177 = i180 + 144 | 0;
 i178 = i180 + 112 | 0;
 i179 = i180 + 80 | 0;
 i163 = i180 + 32 | 0;
 i164 = i180 + 16 | 0;
 i165 = i180;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i162 >> 2] = 0;
  HEAP32[i160 >> 2] = HEAP32[i162 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i160);
  i161 = gb + 1451836 | 0;
 } else i161 = 0;
 i166 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i160 >> 2] = f2;
 HEAP32[i162 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i167 >> 2] = HEAP32[i3 + 812 >> 2];
 f172 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f173 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f174 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f169 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i168 + 4 >> 2] = Math_fround(inf);
 HEAP32[i168 >> 2] = 0;
 i139 = i168 + 8 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 32 >> 2] = Math_fround(inf);
 HEAP32[i168 + 28 >> 2] = 0;
 i139 = i168 + 36 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 60 >> 2] = Math_fround(inf);
 HEAP32[i168 + 56 >> 2] = 0;
 i139 = i168 + 64 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 88 >> 2] = Math_fround(inf);
 HEAP32[i168 + 84 >> 2] = 0;
 i139 = i168 + 92 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 116 >> 2] = Math_fround(inf);
 HEAP32[i168 + 112 >> 2] = 0;
 i139 = i168 + 120 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 HEAPF32[i168 + 144 >> 2] = Math_fround(inf);
 HEAP32[i168 + 140 >> 2] = 0;
 i139 = i168 + 148 | 0;
 HEAP32[i139 >> 2] = 0;
 HEAP32[i139 + 4 >> 2] = 0;
 HEAP32[i139 + 8 >> 2] = 0;
 HEAP32[i139 + 12 >> 2] = 0;
 HEAP32[i139 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f172 = Math_fround(f172 * Math_fround(100.0));
 f173 = Math_fround(f173 * Math_fround(100.0));
 f174 = Math_fround(f174 * Math_fround(100.0));
 f175 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i170 + 4 >> 2] = Math_fround(inf);
 HEAP32[i170 >> 2] = 0;
 i4 = i170 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 32 >> 2] = Math_fround(inf);
 HEAP32[i170 + 28 >> 2] = 0;
 i4 = i170 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 60 >> 2] = Math_fround(inf);
 HEAP32[i170 + 56 >> 2] = 0;
 i4 = i170 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 88 >> 2] = Math_fround(inf);
 HEAP32[i170 + 84 >> 2] = 0;
 i4 = i170 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 116 >> 2] = Math_fround(inf);
 HEAP32[i170 + 112 >> 2] = 0;
 i4 = i170 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i170 + 144 >> 2] = Math_fround(inf);
 HEAP32[i170 + 140 >> 2] = 0;
 i4 = i170 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i139 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i139 >> 2] | 0) >>> 0) {
  i140 = i166 + 520 | 0;
  i141 = i171 + 4 | 0;
  i142 = i171 + 8 | 0;
  i143 = i171 + 12 | 0;
  i144 = i166 + 500 | 0;
  i145 = i177 + 4 | 0;
  i146 = i177 + 8 | 0;
  i147 = i177 + 12 | 0;
  i148 = i3 + 8 | 0;
  i149 = i3 + 92 | 0;
  i150 = i177 + 4 | 0;
  i151 = i177 + 8 | 0;
  i152 = i177 + 12 | 0;
  i153 = i3 + 272 | 0;
  i154 = i168 + 56 | 0;
  i155 = i176 + 16 | 0;
  i156 = i3 + 356 | 0;
  i157 = i177 + 4 | 0;
  i158 = i177 + 8 | 0;
  i159 = i177 + 12 | 0;
  i81 = i3 + 536 | 0;
  i82 = i168 + 112 | 0;
  i83 = i176 + 32 | 0;
  i84 = i3 + 620 | 0;
  i85 = i177 + 4 | 0;
  i86 = i177 + 8 | 0;
  i87 = i177 + 12 | 0;
  i88 = i166 + 20 | 0;
  i89 = i166 + 40 | 0;
  i90 = i176 + 4 | 0;
  i91 = i176 + 8 | 0;
  i92 = i176 + 12 | 0;
  i93 = i176 + 16 | 0;
  i94 = i176 + 20 | 0;
  i95 = i176 + 24 | 0;
  i96 = i176 + 28 | 0;
  i97 = i176 + 32 | 0;
  i98 = i176 + 36 | 0;
  i99 = i176 + 40 | 0;
  i100 = i176 + 44 | 0;
  i101 = i3 + 808 | 0;
  i102 = i178 + 16 | 0;
  i103 = i179 + 4 | 0;
  i104 = i178 + 20 | 0;
  i105 = i179 + 8 | 0;
  i106 = i178 + 24 | 0;
  i107 = i179 + 12 | 0;
  i108 = i178 + 28 | 0;
  i109 = i163 + 4 | 0;
  i110 = i163 + 8 | 0;
  i111 = i163 + 12 | 0;
  i112 = i163 + 16 | 0;
  i113 = i179 + 16 | 0;
  i114 = i177 + 4 | 0;
  i115 = i179 + 20 | 0;
  i116 = i177 + 8 | 0;
  i117 = i179 + 24 | 0;
  i118 = i177 + 12 | 0;
  i119 = i179 + 28 | 0;
  i120 = i163 + 20 | 0;
  i121 = i163 + 24 | 0;
  i122 = i163 + 28 | 0;
  i123 = i163 + 32 | 0;
  i124 = i177 + 16 | 0;
  i125 = i178 + 4 | 0;
  i126 = i177 + 20 | 0;
  i127 = i178 + 8 | 0;
  i128 = i177 + 24 | 0;
  i129 = i178 + 12 | 0;
  i130 = i177 + 28 | 0;
  i131 = i163 + 36 | 0;
  i132 = i163 + 40 | 0;
  i133 = i163 + 44 | 0;
  i134 = i3 + 1884 | 0;
  i135 = i166 + 120 | 0;
  i136 = i166 + 140 | 0;
  i137 = i166 + 160 | 0;
  i138 = i163 + 16 | 0;
  f31 = Math_fround(f2 * Math_fround(.5));
  i32 = i3 + 1092 | 0;
  i33 = i165 + 12 | 0;
  i34 = i165 + 8 | 0;
  i35 = i165 + 4 | 0;
  i36 = i3 + 1176 | 0;
  i37 = i164 + 4 | 0;
  i38 = i164 + 8 | 0;
  i39 = i164 + 12 | 0;
  i40 = i3 + 1356 | 0;
  i41 = i170 + 56 | 0;
  i42 = i165 + 12 | 0;
  i43 = i165 + 8 | 0;
  i44 = i165 + 4 | 0;
  i45 = i3 + 1440 | 0;
  i46 = i164 + 4 | 0;
  i47 = i164 + 8 | 0;
  i48 = i164 + 12 | 0;
  i49 = i3 + 1620 | 0;
  i50 = i170 + 112 | 0;
  i51 = i165 + 12 | 0;
  i52 = i165 + 8 | 0;
  i53 = i165 + 4 | 0;
  i54 = i3 + 1704 | 0;
  i55 = i164 + 4 | 0;
  i56 = i164 + 8 | 0;
  i57 = i164 + 12 | 0;
  i58 = i3 + 1700 | 0;
  i59 = i3 + 1852 | 0;
  i60 = i3 + 1764 | 0;
  i61 = i3 + 1436 | 0;
  i62 = i3 + 1588 | 0;
  i63 = i3 + 1500 | 0;
  i64 = i3 + 1172 | 0;
  i65 = i3 + 1324 | 0;
  i66 = i3 + 1236 | 0;
  i67 = i3 + 616 | 0;
  i68 = i3 + 768 | 0;
  i69 = i3 + 680 | 0;
  i70 = i176 + 36 | 0;
  i71 = i176 + 40 | 0;
  i72 = i176 + 44 | 0;
  i73 = i3 + 352 | 0;
  i74 = i3 + 504 | 0;
  i75 = i3 + 416 | 0;
  i76 = i176 + 20 | 0;
  i77 = i176 + 24 | 0;
  i78 = i176 + 28 | 0;
  i79 = i3 + 88 | 0;
  i80 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  i28 = i176 + 4 | 0;
  i29 = i176 + 8 | 0;
  i30 = i176 + 12 | 0;
  while (1) {
   i183 = (HEAP32[i140 >> 2] | 0) + (i4 << 2) | 0;
   f24 = Math_fround(HEAPF32[i183 >> 2]);
   f25 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.00999999977));
   f26 = Math_fround(f26 * Math_fround(.00999999977));
   f27 = Math_fround(Math_fround(HEAPF32[i183 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i171 >> 2] = Math_fround(f24 * Math_fround(.00999999977));
   HEAPF32[i141 >> 2] = f25;
   HEAPF32[i142 >> 2] = f26;
   HEAPF32[i143 >> 2] = f27;
   i183 = (HEAP32[i144 >> 2] | 0) + (i4 << 2) | 0;
   i182 = (HEAP32[i183 + 4 >> 2] | 0) + 1054653076 | 0;
   i181 = (HEAP32[i183 + 8 >> 2] | 0) + 1054653076 | 0;
   i1 = (HEAP32[i183 + 12 >> 2] | 0) + 1054653076 | 0;
   HEAP32[i177 >> 2] = (HEAP32[i183 >> 2] | 0) + 1054653076;
   HEAP32[i145 >> 2] = i182;
   HEAP32[i146 >> 2] = i181;
   HEAP32[i147 >> 2] = i1;
   __Z17GenerateRandomNx3RKN4math5_int4E(i176, i177);
   i1 = HEAP32[i149 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i79 >> 2] | 0;
     HEAP32[i152 >> 2] = i183;
     HEAP32[i151 >> 2] = i183;
     HEAP32[i150 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i80 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i79 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i176 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i28 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i29 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i30 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i150 >> 2] = f25;
     HEAPF32[i151 >> 2] = f26;
     HEAPF32[i152 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i148, i168, i171, i176);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i148, i171, i176);
     break L8;
    }
   } while (0);
   f2 = Math_fround(HEAPF32[i177 >> 2]);
   f5 = Math_fround(HEAPF32[i150 >> 2]);
   f6 = Math_fround(HEAPF32[i151 >> 2]);
   f7 = Math_fround(HEAPF32[i152 >> 2]);
   i1 = HEAP32[i156 >> 2] | 0;
   L16 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i73 >> 2] | 0;
     HEAP32[i159 >> 2] = i183;
     HEAP32[i158 >> 2] = i183;
     HEAP32[i157 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i74 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i73 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i75 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i155 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i76 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i77 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i78 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i157 >> 2] = f25;
     HEAPF32[i158 >> 2] = f26;
     HEAPF32[i159 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i153, i154, i171, i155);
     break L16;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i153, i171, i155);
     break L16;
    }
   } while (0);
   f8 = Math_fround(HEAPF32[i177 >> 2]);
   f9 = Math_fround(HEAPF32[i157 >> 2]);
   f10 = Math_fround(HEAPF32[i158 >> 2]);
   f11 = Math_fround(HEAPF32[i159 >> 2]);
   i1 = HEAP32[i84 >> 2] | 0;
   L24 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i183 = HEAP32[i67 >> 2] | 0;
     HEAP32[i87 >> 2] = i183;
     HEAP32[i86 >> 2] = i183;
     HEAP32[i85 >> 2] = i183;
     HEAP32[i177 >> 2] = i183;
     break;
    }
   case 3:
    {
     f23 = Math_fround(HEAPF32[(HEAP32[i68 >> 2] | 0) + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i67 >> 2]);
     f23 = Math_fround(f23 * f27);
     f27 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[(HEAP32[i69 >> 2] | 0) + 4 >> 2])) - f23);
     f24 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) * f27);
     f25 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i70 >> 2])));
     f26 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i71 >> 2])));
     f27 = Math_fround(f23 + Math_fround(f27 * Math_fround(HEAPF32[i72 >> 2])));
     HEAPF32[i177 >> 2] = Math_fround(f23 + f24);
     HEAPF32[i85 >> 2] = f25;
     HEAPF32[i86 >> 2] = f26;
     HEAPF32[i87 >> 2] = f27;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i177, i81, i82, i171, i83);
     break L24;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i177, i81, i171, i83);
     break L24;
    }
   } while (0);
   f17 = Math_fround(HEAPF32[i177 >> 2]);
   f18 = Math_fround(HEAPF32[i85 >> 2]);
   f19 = Math_fround(HEAPF32[i86 >> 2]);
   f27 = Math_fround(f175 * f2);
   f26 = Math_fround(f175 * f5);
   f25 = Math_fround(f175 * f6);
   f24 = Math_fround(f175 * f7);
   f23 = Math_fround(f175 * f8);
   f22 = Math_fround(f175 * f9);
   f21 = Math_fround(f175 * f10);
   f16 = Math_fround(f175 * f11);
   f17 = Math_fround(f175 * f17);
   f18 = Math_fround(f175 * f18);
   f19 = Math_fround(f175 * f19);
   f20 = Math_fround(f175 * Math_fround(HEAPF32[i87 >> 2]));
   i183 = (HEAP32[i166 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i183 >> 2]);
   f7 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i183 >> 2]);
   f8 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i183 + 12 >> 2]);
   i183 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i183 >> 2]);
   f15 = Math_fround(HEAPF32[i183 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i183 + 8 >> 2]);
   f5 = Math_fround(f172 + f5);
   f7 = Math_fround(f172 + f7);
   f9 = Math_fround(f172 + f9);
   f11 = Math_fround(f172 + f11);
   f10 = Math_fround(f173 + f10);
   f8 = Math_fround(f173 + f8);
   f6 = Math_fround(f173 + f6);
   f2 = Math_fround(f173 + f2);
   f13 = Math_fround(f174 + f13);
   f15 = Math_fround(f174 + f15);
   f14 = Math_fround(f174 + f14);
   f12 = Math_fround(f174 + Math_fround(HEAPF32[i183 + 12 >> 2]));
   HEAPF32[i93 >> 2] = f10;
   HEAPF32[i94 >> 2] = f8;
   HEAPF32[i95 >> 2] = f6;
   HEAPF32[i96 >> 2] = f2;
   HEAPF32[i97 >> 2] = f5;
   HEAPF32[i98 >> 2] = f7;
   HEAPF32[i99 >> 2] = f9;
   HEAPF32[i100 >> 2] = f11;
   f184 = Math_fround(f169 + f15);
   f185 = Math_fround(f169 + f14);
   f186 = Math_fround(f169 + f12);
   HEAPF32[i176 >> 2] = Math_fround(f169 + f13);
   HEAPF32[i90 >> 2] = f184;
   HEAPF32[i91 >> 2] = f185;
   HEAPF32[i92 >> 2] = f186;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i177, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f5 = Math_fround(f5 + Math_fround(100.0));
   f7 = Math_fround(f7 + Math_fround(100.0));
   f9 = Math_fround(f9 + Math_fround(100.0));
   f11 = Math_fround(f11 + Math_fround(100.0));
   HEAPF32[i93 >> 2] = f13;
   HEAPF32[i94 >> 2] = f15;
   HEAPF32[i95 >> 2] = f14;
   HEAPF32[i96 >> 2] = f12;
   HEAPF32[i97 >> 2] = f10;
   HEAPF32[i98 >> 2] = f8;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f2;
   f186 = Math_fround(f169 + f7);
   f185 = Math_fround(f169 + f9);
   f184 = Math_fround(f169 + f11);
   HEAPF32[i176 >> 2] = Math_fround(f169 + f5);
   HEAPF32[i90 >> 2] = f186;
   HEAPF32[i91 >> 2] = f185;
   HEAPF32[i92 >> 2] = f184;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i178, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   HEAPF32[i93 >> 2] = f5;
   HEAPF32[i94 >> 2] = f7;
   HEAPF32[i95 >> 2] = f9;
   HEAPF32[i96 >> 2] = f11;
   HEAPF32[i97 >> 2] = f13;
   HEAPF32[i98 >> 2] = f15;
   HEAPF32[i99 >> 2] = f14;
   HEAPF32[i100 >> 2] = f12;
   f8 = Math_fround(f169 + f8);
   f6 = Math_fround(f169 + f6);
   f2 = Math_fround(f169 + f2);
   HEAPF32[i176 >> 2] = Math_fround(f169 + f10);
   HEAPF32[i90 >> 2] = f8;
   HEAPF32[i91 >> 2] = f6;
   HEAPF32[i92 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i179, i176, i160, HEAP32[i101 >> 2] | 0, i162, i167);
   f2 = Math_fround(HEAPF32[i179 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i102 >> 2]));
   f6 = Math_fround(HEAPF32[i103 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i104 >> 2]));
   f8 = Math_fround(HEAPF32[i105 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i106 >> 2]));
   f10 = Math_fround(HEAPF32[i107 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i108 >> 2]));
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i177 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i113 >> 2]));
   f14 = Math_fround(HEAPF32[i114 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i115 >> 2]));
   f15 = Math_fround(HEAPF32[i116 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i117 >> 2]));
   f13 = Math_fround(HEAPF32[i118 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i119 >> 2]));
   HEAPF32[i112 >> 2] = f12;
   HEAPF32[i120 >> 2] = f14;
   HEAPF32[i121 >> 2] = f15;
   HEAPF32[i122 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i178 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i124 >> 2]));
   f9 = Math_fround(HEAPF32[i125 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i126 >> 2]));
   f7 = Math_fround(HEAPF32[i127 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i128 >> 2]));
   f5 = Math_fround(HEAPF32[i129 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i130 >> 2]));
   HEAPF32[i123 >> 2] = f11;
   HEAPF32[i131 >> 2] = f9;
   HEAPF32[i132 >> 2] = f7;
   HEAPF32[i133 >> 2] = f5;
   if (HEAP8[i134 >> 0] | 0) {
    f189 = Math_fround(Math_fround(Math_fround(f31 * f2) * Math_fround(.5)) + Math_fround(.5));
    f188 = Math_fround(Math_fround(Math_fround(f31 * f6) * Math_fround(.5)) + Math_fround(.5));
    f187 = Math_fround(Math_fround(Math_fround(f31 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f31 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f31 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f31 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f31 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f31 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f31 * f11) * Math_fround(.5)) + Math_fround(.5));
    f184 = Math_fround(Math_fround(Math_fround(f31 * f9) * Math_fround(.5)) + Math_fround(.5));
    f185 = Math_fround(Math_fround(Math_fround(f31 * f7) * Math_fround(.5)) + Math_fround(.5));
    f186 = Math_fround(Math_fround(Math_fround(f31 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f189 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f189;
    i1 = f188 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f188;
    i1 = f187 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f187;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f184 < Math_fround(0.0);
    f184 = i1 ? Math_fround(0.0) : f184;
    i1 = f185 < Math_fround(0.0);
    f185 = i1 ? Math_fround(0.0) : f185;
    i1 = f186 < Math_fround(0.0);
    f186 = i1 ? Math_fround(0.0) : f186;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f184 > Math_fround(1.0);
    f184 = i1 ? Math_fround(1.0) : f184;
    i1 = f185 > Math_fround(1.0);
    f185 = i1 ? Math_fround(1.0) : f185;
    i1 = f186 > Math_fround(1.0);
    f186 = i1 ? Math_fround(1.0) : f186;
    HEAPF32[i163 >> 2] = f7;
    HEAPF32[i109 >> 2] = f8;
    HEAPF32[i110 >> 2] = f9;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f11;
    HEAPF32[i120 >> 2] = f12;
    HEAPF32[i121 >> 2] = f13;
    HEAPF32[i122 >> 2] = f14;
    HEAPF32[i123 >> 2] = f15;
    HEAPF32[i131 >> 2] = f184;
    HEAPF32[i132 >> 2] = f185;
    HEAPF32[i133 >> 2] = f186;
    HEAPF32[i33 >> 2] = Math_fround(1.0);
    HEAPF32[i34 >> 2] = Math_fround(1.0);
    HEAPF32[i35 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i36 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i64 >> 2] | 0;
      HEAP32[i39 >> 2] = i183;
      HEAP32[i38 >> 2] = i183;
      HEAP32[i37 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i65 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i64 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i66 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i37 >> 2] = f189;
      HEAPF32[i38 >> 2] = f189;
      HEAPF32[i39 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i32, i170, i163, i165);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i32, i163, i165);
      break L34;
     }
    } while (0);
    i182 = HEAP32[i37 >> 2] | 0;
    i183 = HEAP32[i38 >> 2] | 0;
    i1 = HEAP32[i39 >> 2] | 0;
    HEAP32[i163 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i109 >> 2] = i182;
    HEAP32[i110 >> 2] = i183;
    HEAP32[i111 >> 2] = i1;
    HEAPF32[i42 >> 2] = Math_fround(1.0);
    HEAPF32[i43 >> 2] = Math_fround(1.0);
    HEAPF32[i44 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i45 >> 2] | 0;
    L42 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i61 >> 2] | 0;
      HEAP32[i48 >> 2] = i183;
      HEAP32[i47 >> 2] = i183;
      HEAP32[i46 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i62 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i61 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i63 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i46 >> 2] = f189;
      HEAPF32[i47 >> 2] = f189;
      HEAPF32[i48 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i40, i41, i112, i165);
      break L42;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i40, i112, i165);
      break L42;
     }
    } while (0);
    i182 = HEAP32[i46 >> 2] | 0;
    i183 = HEAP32[i47 >> 2] | 0;
    i1 = HEAP32[i48 >> 2] | 0;
    HEAP32[i112 >> 2] = HEAP32[i164 >> 2];
    HEAP32[i120 >> 2] = i182;
    HEAP32[i121 >> 2] = i183;
    HEAP32[i122 >> 2] = i1;
    HEAPF32[i51 >> 2] = Math_fround(1.0);
    HEAPF32[i52 >> 2] = Math_fround(1.0);
    HEAPF32[i53 >> 2] = Math_fround(1.0);
    HEAPF32[i165 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i54 >> 2] | 0;
    L50 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i183 = HEAP32[i58 >> 2] | 0;
      HEAP32[i57 >> 2] = i183;
      HEAP32[i56 >> 2] = i183;
      HEAP32[i55 >> 2] = i183;
      HEAP32[i164 >> 2] = i183;
      break;
     }
    case 3:
     {
      f189 = Math_fround(HEAPF32[(HEAP32[i59 >> 2] | 0) + 4 >> 2]);
      f188 = Math_fround(HEAPF32[i58 >> 2]);
      f189 = Math_fround(f189 * f188);
      f189 = Math_fround(f189 + Math_fround(Math_fround(f188 * Math_fround(HEAPF32[(HEAP32[i60 >> 2] | 0) + 4 >> 2])) - f189));
      HEAPF32[i164 >> 2] = f189;
      HEAPF32[i55 >> 2] = f189;
      HEAPF32[i56 >> 2] = f189;
      HEAPF32[i57 >> 2] = f189;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i164, i49, i50, i123, i165);
      break L50;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i164, i49, i123, i165);
      break L50;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i164 >> 2]);
    f9 = Math_fround(HEAPF32[i55 >> 2]);
    f7 = Math_fround(HEAPF32[i56 >> 2]);
    f5 = Math_fround(HEAPF32[i57 >> 2]);
    f189 = Math_fround(Math_fround(HEAPF32[i160 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i163 >> 2]) * f189);
    f6 = Math_fround(f189 * Math_fround(HEAPF32[i109 >> 2]));
    f8 = Math_fround(f189 * Math_fround(HEAPF32[i110 >> 2]));
    f10 = Math_fround(f189 * Math_fround(HEAPF32[i111 >> 2]));
    f12 = Math_fround(f189 * Math_fround(HEAPF32[i138 >> 2]));
    f14 = Math_fround(f189 * Math_fround(HEAPF32[i120 >> 2]));
    f15 = Math_fround(f189 * Math_fround(HEAPF32[i121 >> 2]));
    f13 = Math_fround(f189 * Math_fround(HEAPF32[i122 >> 2]));
    f11 = Math_fround(f189 * f11);
    f9 = Math_fround(f189 * f9);
    f7 = Math_fround(f189 * f7);
    f5 = Math_fround(f189 * f5);
    HEAPF32[i163 >> 2] = f2;
    HEAPF32[i109 >> 2] = f6;
    HEAPF32[i110 >> 2] = f8;
    HEAPF32[i111 >> 2] = f10;
    HEAPF32[i112 >> 2] = f12;
    HEAPF32[i120 >> 2] = f14;
    HEAPF32[i121 >> 2] = f15;
    HEAPF32[i122 >> 2] = f13;
    HEAPF32[i123 >> 2] = f11;
    HEAPF32[i131 >> 2] = f9;
    HEAPF32[i132 >> 2] = f7;
    HEAPF32[i133 >> 2] = f5;
   }
   f2 = Math_fround(f27 * f2);
   f6 = Math_fround(f26 * f6);
   f8 = Math_fround(f25 * f8);
   f25 = Math_fround(f24 * f10);
   HEAPF32[i163 >> 2] = f2;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f8;
   HEAPF32[i111 >> 2] = f25;
   f26 = Math_fround(f23 * f12);
   f27 = Math_fround(f22 * f14);
   f184 = Math_fround(f21 * f15);
   f185 = Math_fround(f16 * f13);
   HEAPF32[i112 >> 2] = f26;
   HEAPF32[i120 >> 2] = f27;
   HEAPF32[i121 >> 2] = f184;
   HEAPF32[i122 >> 2] = f185;
   f186 = Math_fround(f17 * f11);
   f187 = Math_fround(f18 * f9);
   f188 = Math_fround(f19 * f7);
   f189 = Math_fround(f20 * f5);
   HEAPF32[i123 >> 2] = f186;
   HEAPF32[i131 >> 2] = f187;
   HEAPF32[i132 >> 2] = f188;
   HEAPF32[i133 >> 2] = f189;
   i197 = (HEAP32[i135 >> 2] | 0) + (i4 << 2) | 0;
   f22 = Math_fround(HEAPF32[i197 >> 2]);
   i196 = i197 + 4 | 0;
   f23 = Math_fround(HEAPF32[i196 >> 2]);
   i195 = i197 + 8 | 0;
   f24 = Math_fround(HEAPF32[i195 >> 2]);
   i194 = i197 + 12 | 0;
   f14 = Math_fround(HEAPF32[i194 >> 2]);
   i193 = (HEAP32[i136 >> 2] | 0) + (i4 << 2) | 0;
   f15 = Math_fround(HEAPF32[i193 >> 2]);
   i192 = i193 + 4 | 0;
   f16 = Math_fround(HEAPF32[i192 >> 2]);
   i191 = i193 + 8 | 0;
   f17 = Math_fround(HEAPF32[i191 >> 2]);
   i190 = i193 + 12 | 0;
   f18 = Math_fround(HEAPF32[i190 >> 2]);
   i1 = (HEAP32[i137 >> 2] | 0) + (i4 << 2) | 0;
   f19 = Math_fround(HEAPF32[i1 >> 2]);
   i181 = i1 + 4 | 0;
   f20 = Math_fround(HEAPF32[i181 >> 2]);
   i182 = i1 + 8 | 0;
   f21 = Math_fround(HEAPF32[i182 >> 2]);
   i183 = i1 + 12 | 0;
   f23 = Math_fround(f23 + f6);
   f24 = Math_fround(f24 + f8);
   f25 = Math_fround(f14 + f25);
   f26 = Math_fround(f15 + f26);
   f27 = Math_fround(f16 + f27);
   f184 = Math_fround(f17 + f184);
   f185 = Math_fround(f18 + f185);
   f186 = Math_fround(f19 + f186);
   f187 = Math_fround(f20 + f187);
   f188 = Math_fround(f21 + f188);
   f189 = Math_fround(Math_fround(HEAPF32[i183 >> 2]) + f189);
   HEAPF32[i197 >> 2] = Math_fround(f22 + f2);
   HEAPF32[i196 >> 2] = f23;
   HEAPF32[i195 >> 2] = f24;
   HEAPF32[i194 >> 2] = f25;
   HEAPF32[i193 >> 2] = f26;
   HEAPF32[i192 >> 2] = f27;
   HEAPF32[i191 >> 2] = f184;
   HEAPF32[i190 >> 2] = f185;
   HEAPF32[i1 >> 2] = f186;
   HEAPF32[i181 >> 2] = f187;
   HEAPF32[i182 >> 2] = f188;
   HEAPF32[i183 >> 2] = f189;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i139 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i161) {
  STACKTOP = i180;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i161);
 STACKTOP = i180;
 return;
}

function __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0, f156 = f0, f157 = f0, f158 = f0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, f167 = f0, f168 = f0, f169 = f0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, f191 = f0, f192 = f0, f193 = f0, f194 = f0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, f202 = f0, f203 = f0, f204 = f0, f205 = f0, f206 = f0, f207 = f0, f208 = f0, f209 = f0, f210 = f0, f211 = f0, f212 = f0, f213 = f0, f214 = f0, f215 = f0, f216 = f0, f217 = f0, f218 = f0, f219 = f0, f220 = f0, f221 = f0, f222 = f0, f223 = f0, f224 = f0, f225 = f0, f226 = f0, f227 = f0, f228 = f0, f229 = f0, f230 = f0, f231 = f0, f232 = f0, f233 = f0, f234 = f0, f235 = f0, f236 = f0, f237 = f0;
 i70 = HEAP32[i4 >> 2] | 0;
 i74 = HEAP32[i4 + 4 >> 2] | 0;
 i77 = HEAP32[i4 + 32 >> 2] | 0;
 i80 = HEAP32[i4 + 36 >> 2] | 0;
 i83 = HEAP32[i4 + 64 >> 2] | 0;
 i71 = HEAP32[i4 + 68 >> 2] | 0;
 i72 = HEAP32[i4 + 96 >> 2] | 0;
 i73 = HEAP32[i4 + 100 >> 2] | 0;
 i24 = HEAP32[i70 >> 2] | 0;
 i46 = HEAP32[i70 + 4 >> 2] | 0;
 i42 = HEAP32[i70 + 8 >> 2] | 0;
 i38 = HEAP32[i74 >> 2] | 0;
 i34 = HEAP32[i74 + 4 >> 2] | 0;
 i29 = HEAP32[i74 + 8 >> 2] | 0;
 i75 = i70 + 16 | 0;
 i21 = HEAP32[i75 >> 2] | 0;
 i17 = HEAP32[i75 + 4 >> 2] | 0;
 i13 = HEAP32[i75 + 8 >> 2] | 0;
 i76 = i74 + 16 | 0;
 i9 = HEAP32[i76 >> 2] | 0;
 i5 = HEAP32[i76 + 4 >> 2] | 0;
 i1 = HEAP32[i76 + 8 >> 2] | 0;
 i25 = HEAP32[i77 >> 2] | 0;
 i47 = HEAP32[i77 + 4 >> 2] | 0;
 i43 = HEAP32[i77 + 8 >> 2] | 0;
 i39 = HEAP32[i80 >> 2] | 0;
 i35 = HEAP32[i80 + 4 >> 2] | 0;
 i30 = HEAP32[i80 + 8 >> 2] | 0;
 i78 = i77 + 16 | 0;
 i22 = HEAP32[i78 >> 2] | 0;
 i18 = HEAP32[i78 + 4 >> 2] | 0;
 i14 = HEAP32[i78 + 8 >> 2] | 0;
 i79 = i80 + 16 | 0;
 i10 = HEAP32[i79 >> 2] | 0;
 i6 = HEAP32[i79 + 4 >> 2] | 0;
 i2 = HEAP32[i79 + 8 >> 2] | 0;
 i26 = HEAP32[i83 >> 2] | 0;
 i48 = HEAP32[i83 + 4 >> 2] | 0;
 i44 = HEAP32[i83 + 8 >> 2] | 0;
 i40 = HEAP32[i71 >> 2] | 0;
 i36 = HEAP32[i71 + 4 >> 2] | 0;
 i31 = HEAP32[i71 + 8 >> 2] | 0;
 i81 = i83 + 16 | 0;
 i23 = HEAP32[i81 >> 2] | 0;
 i19 = HEAP32[i81 + 4 >> 2] | 0;
 i15 = HEAP32[i81 + 8 >> 2] | 0;
 i82 = i71 + 16 | 0;
 i11 = HEAP32[i82 >> 2] | 0;
 i7 = HEAP32[i82 + 4 >> 2] | 0;
 i3 = HEAP32[i82 + 8 >> 2] | 0;
 i27 = HEAP32[i72 >> 2] | 0;
 i49 = HEAP32[i72 + 4 >> 2] | 0;
 i45 = HEAP32[i72 + 8 >> 2] | 0;
 i41 = HEAP32[i73 >> 2] | 0;
 i37 = HEAP32[i73 + 4 >> 2] | 0;
 i33 = HEAP32[i73 + 8 >> 2] | 0;
 i84 = i72 + 16 | 0;
 i32 = HEAP32[i84 >> 2] | 0;
 i28 = HEAP32[i84 + 4 >> 2] | 0;
 i20 = HEAP32[i84 + 8 >> 2] | 0;
 i85 = i73 + 16 | 0;
 i16 = HEAP32[i85 >> 2] | 0;
 i12 = HEAP32[i85 + 4 >> 2] | 0;
 i8 = HEAP32[i85 + 8 >> 2] | 0;
 i50 = HEAP32[i4 + 16 >> 2] | 0;
 i68 = HEAP16[i4 + 26 >> 1] | 0;
 i69 = i50 + ((i68 & 65535) << 4) | 0;
 if (!(i68 << 16 >> 16)) {
  i92 = i27;
  i95 = i26;
  i98 = i25;
  i101 = i24;
  i91 = i49;
  i94 = i48;
  i97 = i47;
  i100 = i46;
  i90 = i45;
  i93 = i44;
  i96 = i43;
  i99 = i42;
  i25 = i41;
  i4 = i40;
  i87 = i39;
  i89 = i38;
  i26 = i37;
  i24 = i36;
  i86 = i35;
  i88 = i34;
  i27 = i33;
  i43 = i32;
  i40 = i23;
  i37 = i22;
  i34 = i21;
  i44 = i28;
  i41 = i19;
  i38 = i18;
  i35 = i17;
  i45 = i20;
  i42 = i15;
  i39 = i14;
  i36 = i13;
  i55 = i16;
  i52 = i11;
  i49 = i10;
  i46 = i9;
  i68 = i12;
  i53 = i7;
  i50 = i6;
  i47 = i5;
  i69 = i8;
  i54 = i3;
  i51 = i2;
  i48 = i1;
  HEAP32[i70 >> 2] = i101;
  i33 = i70 + 4 | 0;
  HEAP32[i33 >> 2] = i100;
  i33 = i70 + 8 | 0;
  HEAP32[i33 >> 2] = i99;
  HEAP32[i77 >> 2] = i98;
  i33 = i77 + 4 | 0;
  HEAP32[i33 >> 2] = i97;
  i33 = i77 + 8 | 0;
  HEAP32[i33 >> 2] = i96;
  HEAP32[i83 >> 2] = i95;
  i33 = i83 + 4 | 0;
  HEAP32[i33 >> 2] = i94;
  i33 = i83 + 8 | 0;
  HEAP32[i33 >> 2] = i93;
  HEAP32[i72 >> 2] = i92;
  i33 = i72 + 4 | 0;
  HEAP32[i33 >> 2] = i91;
  i33 = i72 + 8 | 0;
  HEAP32[i33 >> 2] = i90;
  HEAP32[i74 >> 2] = i89;
  i33 = i74 + 4 | 0;
  HEAP32[i33 >> 2] = i88;
  i33 = i74 + 8 | 0;
  HEAP32[i33 >> 2] = i29;
  HEAP32[i80 >> 2] = i87;
  i33 = i80 + 4 | 0;
  HEAP32[i33 >> 2] = i86;
  i33 = i80 + 8 | 0;
  HEAP32[i33 >> 2] = i30;
  HEAP32[i71 >> 2] = i4;
  i33 = i71 + 4 | 0;
  HEAP32[i33 >> 2] = i24;
  i33 = i71 + 8 | 0;
  HEAP32[i33 >> 2] = i31;
  HEAP32[i73 >> 2] = i25;
  i33 = i73 + 4 | 0;
  HEAP32[i33 >> 2] = i26;
  i33 = i73 + 8 | 0;
  HEAP32[i33 >> 2] = i27;
  HEAP32[i75 >> 2] = i34;
  i75 = i70 + 20 | 0;
  HEAP32[i75 >> 2] = i35;
  i75 = i70 + 24 | 0;
  HEAP32[i75 >> 2] = i36;
  HEAP32[i78 >> 2] = i37;
  i78 = i77 + 20 | 0;
  HEAP32[i78 >> 2] = i38;
  i78 = i77 + 24 | 0;
  HEAP32[i78 >> 2] = i39;
  HEAP32[i81 >> 2] = i40;
  i81 = i83 + 20 | 0;
  HEAP32[i81 >> 2] = i41;
  i83 = i83 + 24 | 0;
  HEAP32[i83 >> 2] = i42;
  HEAP32[i84 >> 2] = i43;
  i84 = i72 + 20 | 0;
  HEAP32[i84 >> 2] = i44;
  i84 = i72 + 24 | 0;
  HEAP32[i84 >> 2] = i45;
  HEAP32[i76 >> 2] = i46;
  i84 = i74 + 20 | 0;
  HEAP32[i84 >> 2] = i47;
  i84 = i74 + 24 | 0;
  HEAP32[i84 >> 2] = i48;
  HEAP32[i79 >> 2] = i49;
  i84 = i80 + 20 | 0;
  HEAP32[i84 >> 2] = i50;
  i84 = i80 + 24 | 0;
  HEAP32[i84 >> 2] = i51;
  HEAP32[i82 >> 2] = i52;
  i84 = i71 + 20 | 0;
  HEAP32[i84 >> 2] = i53;
  i84 = i71 + 24 | 0;
  HEAP32[i84 >> 2] = i54;
  HEAP32[i85 >> 2] = i55;
  i85 = i73 + 20 | 0;
  HEAP32[i85 >> 2] = i68;
  i85 = i73 + 24 | 0;
  HEAP32[i85 >> 2] = i69;
  return;
 } else {
  i4 = i8;
  i8 = i12;
  i12 = i16;
  i16 = i20;
  i20 = i50;
 }
 while (1) {
  i53 = i20 + 64 | 0;
  i54 = i20 + (((HEAPU8[i20 + 1 >> 0] | 0) << 4) + 64) | 0;
  i101 = HEAP8[i20 + 2 >> 0] | 0;
  i55 = i101 & 255;
  i68 = i54 + (i55 * 288 | 0) | 0;
  f56 = Math_fround(HEAPF32[i20 + 16 >> 2]);
  f57 = Math_fround(HEAPF32[i20 + 20 >> 2]);
  f58 = Math_fround(HEAPF32[i20 + 24 >> 2]);
  f59 = Math_fround(HEAPF32[i20 + 28 >> 2]);
  f60 = Math_fround(HEAPF32[i20 + 32 >> 2]);
  f61 = Math_fround(HEAPF32[i20 + 36 >> 2]);
  f62 = Math_fround(HEAPF32[i20 + 40 >> 2]);
  f63 = Math_fround(HEAPF32[i20 + 44 >> 2]);
  f64 = Math_fround(HEAPF32[i20 + 48 >> 2]);
  f65 = Math_fround(HEAPF32[i20 + 52 >> 2]);
  f66 = Math_fround(HEAPF32[i20 + 56 >> 2]);
  f67 = Math_fround(HEAPF32[i20 + 60 >> 2]);
  if (!(i101 << 24 >> 24)) i20 = i28; else {
   i52 = i20 + 12 | 0;
   i51 = i22;
   i20 = i28;
   i22 = 0;
   while (1) {
    i50 = i22 + 1 | 0;
    i98 = i22 >>> (HEAP32[i52 >> 2] | 0);
    f209 = Math_fround(HEAPF32[i53 + (i98 << 4) >> 2]);
    f208 = Math_fround(HEAPF32[i53 + (i98 << 4) + 4 >> 2]);
    f207 = Math_fround(HEAPF32[i53 + (i98 << 4) + 8 >> 2]);
    f209 = Math_fround(f56 * f209);
    f208 = Math_fround(f57 * f208);
    f207 = Math_fround(f58 * f207);
    f206 = Math_fround(f59 * Math_fround(HEAPF32[i53 + (i98 << 4) + 12 >> 2]));
    f105 = Math_fround(-f209);
    f104 = Math_fround(-f208);
    f103 = Math_fround(-f207);
    f102 = Math_fround(-f206);
    f185 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 96 >> 2]);
    f184 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 100 >> 2]);
    f183 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 104 >> 2]);
    f182 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 108 >> 2]);
    f153 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 112 >> 2]);
    f152 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 116 >> 2]);
    f151 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 120 >> 2]);
    f150 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 124 >> 2]);
    f121 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 128 >> 2]);
    f120 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 132 >> 2]);
    f119 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 136 >> 2]);
    f118 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 140 >> 2]);
    f177 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 240 >> 2]);
    f176 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 244 >> 2]);
    f175 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 248 >> 2]);
    f174 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 252 >> 2]);
    f145 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 256 >> 2]);
    f144 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 260 >> 2]);
    f143 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 264 >> 2]);
    f142 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 268 >> 2]);
    f116 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 272 >> 2]);
    f114 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 276 >> 2]);
    f112 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 280 >> 2]);
    f110 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 284 >> 2]);
    f193 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) >> 2]);
    f192 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 4 >> 2]);
    f191 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 8 >> 2]);
    f190 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 12 >> 2]);
    f161 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 16 >> 2]);
    f160 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 20 >> 2]);
    f159 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 24 >> 2]);
    f158 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 28 >> 2]);
    f129 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 32 >> 2]);
    f128 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 36 >> 2]);
    f127 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 40 >> 2]);
    f126 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 44 >> 2]);
    f162 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 48 >> 2]);
    f163 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 52 >> 2]);
    f164 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 56 >> 2]);
    f165 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 60 >> 2]);
    f130 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 64 >> 2]);
    f131 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 68 >> 2]);
    f132 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 72 >> 2]);
    f133 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 76 >> 2]);
    f236 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 80 >> 2]);
    f230 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 84 >> 2]);
    f224 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 88 >> 2]);
    f218 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 92 >> 2]);
    f138 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 192 >> 2]);
    f139 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 196 >> 2]);
    f140 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 200 >> 2]);
    f141 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 204 >> 2]);
    f234 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 208 >> 2]);
    f228 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 212 >> 2]);
    f222 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 216 >> 2]);
    f216 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 220 >> 2]);
    f233 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 224 >> 2]);
    f227 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 228 >> 2]);
    f221 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 232 >> 2]);
    f215 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 236 >> 2]);
    i98 = i54 + (i22 * 288 | 0) + 144 | 0;
    f109 = Math_fround(HEAPF32[i98 >> 2]);
    i99 = i54 + (i22 * 288 | 0) + 148 | 0;
    f108 = Math_fround(HEAPF32[i99 >> 2]);
    i100 = i54 + (i22 * 288 | 0) + 152 | 0;
    f107 = Math_fround(HEAPF32[i100 >> 2]);
    i101 = i54 + (i22 * 288 | 0) + 156 | 0;
    f106 = Math_fround(HEAPF32[i101 >> 2]);
    f232 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 160 >> 2]);
    f226 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 164 >> 2]);
    f220 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 168 >> 2]);
    f214 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 172 >> 2]);
    f213 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 176 >> 2]);
    f212 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 180 >> 2]);
    f211 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 184 >> 2]);
    f210 = Math_fround(HEAPF32[i54 + (i22 * 288 | 0) + 188 >> 2]);
    f205 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f237 = Math_fround(f205 * f193);
    f204 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f231 = Math_fround(f204 * f192);
    f203 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f225 = Math_fround(f203 * f191);
    f202 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f219 = Math_fround(f202 * f190);
    f189 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f162 = Math_fround(f189 * f162);
    f188 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f163 = Math_fround(f188 * f163);
    f187 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f164 = Math_fround(f187 * f164);
    f186 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f165 = Math_fround(f186 * f165);
    f197 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f235 = Math_fround(f197 * f193);
    f196 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f229 = Math_fround(f196 * f192);
    f195 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f223 = Math_fround(f195 * f191);
    f194 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f217 = Math_fround(f194 * f190);
    f181 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f138 = Math_fround(f181 * f138);
    f180 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f139 = Math_fround(f180 * f139);
    f179 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f140 = Math_fround(f179 * f140);
    f178 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f141 = Math_fround(f178 * f141);
    f173 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f172 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f171 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f170 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f237 = Math_fround(f237 + Math_fround(f173 * f161));
    f231 = Math_fround(f231 + Math_fround(f172 * f160));
    f225 = Math_fround(f225 + Math_fround(f171 * f159));
    f219 = Math_fround(f219 + Math_fround(f170 * f158));
    f157 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f156 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f155 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f154 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f130 = Math_fround(f162 + Math_fround(f157 * f130));
    f131 = Math_fround(f163 + Math_fround(f156 * f131));
    f132 = Math_fround(f164 + Math_fround(f155 * f132));
    f133 = Math_fround(f165 + Math_fround(f154 * f133));
    f165 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f164 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f163 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f162 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f235 = Math_fround(f235 + Math_fround(f165 * f161));
    f229 = Math_fround(f229 + Math_fround(f164 * f160));
    f223 = Math_fround(f223 + Math_fround(f163 * f159));
    f217 = Math_fround(f217 + Math_fround(f162 * f158));
    f149 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f148 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f147 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f146 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f234 = Math_fround(f138 + Math_fround(f149 * f234));
    f228 = Math_fround(f139 + Math_fround(f148 * f228));
    f222 = Math_fround(f140 + Math_fround(f147 * f222));
    f216 = Math_fround(f141 + Math_fround(f146 * f216));
    f141 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f140 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f139 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f138 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f237 = Math_fround(f237 + Math_fround(f141 * f129));
    f231 = Math_fround(f231 + Math_fround(f140 * f128));
    f225 = Math_fround(f225 + Math_fround(f139 * f127));
    f219 = Math_fround(f219 + Math_fround(f138 * f126));
    f125 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f124 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f123 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f122 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f236 = Math_fround(f130 + Math_fround(f125 * f236));
    f230 = Math_fround(f131 + Math_fround(f124 * f230));
    f224 = Math_fround(f132 + Math_fround(f123 * f224));
    f218 = Math_fround(f133 + Math_fround(f122 * f218));
    f133 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f132 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f131 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f130 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f235 = Math_fround(f235 + Math_fround(f133 * f129));
    f229 = Math_fround(f229 + Math_fround(f132 * f128));
    f223 = Math_fround(f223 + Math_fround(f131 * f127));
    f217 = Math_fround(f217 + Math_fround(f130 * f126));
    f117 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f115 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f113 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f111 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f201 = Math_fround(f60 * f193);
    f200 = Math_fround(f61 * f192);
    f199 = Math_fround(f62 * f191);
    f198 = Math_fround(f63 * f190);
    f193 = Math_fround(f64 * f193);
    f192 = Math_fround(f65 * f192);
    f191 = Math_fround(f66 * f191);
    f190 = Math_fround(f67 * f190);
    f169 = Math_fround(f60 * f161);
    f168 = Math_fround(f61 * f160);
    f167 = Math_fround(f62 * f159);
    f166 = Math_fround(f63 * f158);
    f161 = Math_fround(f64 * f161);
    f160 = Math_fround(f65 * f160);
    f159 = Math_fround(f66 * f159);
    f158 = Math_fround(f67 * f158);
    f137 = Math_fround(f60 * f129);
    f136 = Math_fround(f61 * f128);
    f135 = Math_fround(f62 * f127);
    f134 = Math_fround(f63 * f126);
    f129 = Math_fround(f64 * f129);
    f128 = Math_fround(f65 * f128);
    f127 = Math_fround(f66 * f127);
    f126 = Math_fround(f67 * f126);
    f213 = Math_fround(Math_fround(Math_fround(Math_fround(f237 + f236) - Math_fround(f235 + Math_fround(f234 + Math_fround(f117 * f233)))) * f232) + Math_fround(f109 - Math_fround(f232 * f213)));
    f212 = Math_fround(Math_fround(Math_fround(Math_fround(f231 + f230) - Math_fround(f229 + Math_fround(f228 + Math_fround(f115 * f227)))) * f226) + Math_fround(f108 - Math_fround(f226 * f212)));
    f211 = Math_fround(Math_fround(Math_fround(Math_fround(f225 + f224) - Math_fround(f223 + Math_fround(f222 + Math_fround(f113 * f221)))) * f220) + Math_fround(f107 - Math_fround(f220 * f211)));
    f210 = Math_fround(Math_fround(Math_fround(Math_fround(f219 + f218) - Math_fround(f217 + Math_fround(f216 + Math_fround(f111 * f215)))) * f214) + Math_fround(f106 - Math_fround(f214 * f210)));
    f209 = f213 < f209 ? f213 : f209;
    f208 = f212 < f208 ? f212 : f208;
    f207 = f211 < f207 ? f211 : f207;
    f206 = f210 < f206 ? f210 : f206;
    f105 = f209 > f105 ? f209 : f105;
    f104 = f208 > f104 ? f208 : f104;
    f103 = f207 > f103 ? f207 : f103;
    f102 = f206 > f102 ? f206 : f102;
    f109 = Math_fround(f105 - f109);
    f108 = Math_fround(f104 - f108);
    f107 = Math_fround(f103 - f107);
    f106 = Math_fround(f102 - f106);
    f201 = Math_fround(f205 + Math_fround(f201 * f109));
    f200 = Math_fround(f204 + Math_fround(f200 * f108));
    f199 = Math_fround(f203 + Math_fround(f199 * f107));
    f198 = Math_fround(f202 + Math_fround(f198 * f106));
    i24 = (HEAPF32[tempDoublePtr >> 2] = f201, HEAP32[tempDoublePtr >> 2] | 0);
    i25 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
    i26 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
    i27 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
    f193 = Math_fround(f197 + Math_fround(f193 * f109));
    f192 = Math_fround(f196 + Math_fround(f192 * f108));
    f191 = Math_fround(f195 + Math_fround(f191 * f107));
    f190 = Math_fround(f194 + Math_fround(f190 * f106));
    i38 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
    i39 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
    i40 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
    i41 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
    f185 = Math_fround(f189 + Math_fround(f185 * f109));
    f184 = Math_fround(f188 + Math_fround(f184 * f108));
    f183 = Math_fround(f187 + Math_fround(f183 * f107));
    f182 = Math_fround(f186 + Math_fround(f182 * f106));
    i21 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
    i32 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
    f177 = Math_fround(f181 + Math_fround(f177 * f109));
    f176 = Math_fround(f180 + Math_fround(f176 * f108));
    f175 = Math_fround(f179 + Math_fround(f175 * f107));
    f174 = Math_fround(f178 + Math_fround(f174 * f106));
    i9 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
    f169 = Math_fround(f173 + Math_fround(f169 * f109));
    f168 = Math_fround(f172 + Math_fround(f168 * f108));
    f167 = Math_fround(f171 + Math_fround(f167 * f107));
    f166 = Math_fround(f170 + Math_fround(f166 * f106));
    i46 = (HEAPF32[tempDoublePtr >> 2] = f169, HEAP32[tempDoublePtr >> 2] | 0);
    i47 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
    i48 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
    i28 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
    f161 = Math_fround(f165 + Math_fround(f161 * f109));
    f160 = Math_fround(f164 + Math_fround(f160 * f108));
    f159 = Math_fround(f163 + Math_fround(f159 * f107));
    f158 = Math_fround(f162 + Math_fround(f158 * f106));
    i34 = (HEAPF32[tempDoublePtr >> 2] = f161, HEAP32[tempDoublePtr >> 2] | 0);
    i35 = (HEAPF32[tempDoublePtr >> 2] = f160, HEAP32[tempDoublePtr >> 2] | 0);
    i36 = (HEAPF32[tempDoublePtr >> 2] = f159, HEAP32[tempDoublePtr >> 2] | 0);
    i37 = (HEAPF32[tempDoublePtr >> 2] = f158, HEAP32[tempDoublePtr >> 2] | 0);
    f153 = Math_fround(f157 + Math_fround(f153 * f109));
    f152 = Math_fround(f156 + Math_fround(f152 * f108));
    f151 = Math_fround(f155 + Math_fround(f151 * f107));
    f150 = Math_fround(f154 + Math_fround(f150 * f106));
    i17 = (HEAPF32[tempDoublePtr >> 2] = f153, HEAP32[tempDoublePtr >> 2] | 0);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f152, HEAP32[tempDoublePtr >> 2] | 0);
    i19 = (HEAPF32[tempDoublePtr >> 2] = f151, HEAP32[tempDoublePtr >> 2] | 0);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f150, HEAP32[tempDoublePtr >> 2] | 0);
    f145 = Math_fround(f149 + Math_fround(f145 * f109));
    f144 = Math_fround(f148 + Math_fround(f144 * f108));
    f143 = Math_fround(f147 + Math_fround(f143 * f107));
    f142 = Math_fround(f146 + Math_fround(f142 * f106));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f145, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f144, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f143, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f142, HEAP32[tempDoublePtr >> 2] | 0);
    f137 = Math_fround(f141 + Math_fround(f137 * f109));
    f136 = Math_fround(f140 + Math_fround(f136 * f108));
    f135 = Math_fround(f139 + Math_fround(f135 * f107));
    f134 = Math_fround(f138 + Math_fround(f134 * f106));
    i42 = (HEAPF32[tempDoublePtr >> 2] = f137, HEAP32[tempDoublePtr >> 2] | 0);
    i43 = (HEAPF32[tempDoublePtr >> 2] = f136, HEAP32[tempDoublePtr >> 2] | 0);
    i44 = (HEAPF32[tempDoublePtr >> 2] = f135, HEAP32[tempDoublePtr >> 2] | 0);
    i45 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
    f129 = Math_fround(f133 + Math_fround(f129 * f109));
    f128 = Math_fround(f132 + Math_fround(f128 * f108));
    f127 = Math_fround(f131 + Math_fround(f127 * f107));
    f126 = Math_fround(f130 + Math_fround(f126 * f106));
    i29 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0);
    i31 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
    i33 = (HEAPF32[tempDoublePtr >> 2] = f126, HEAP32[tempDoublePtr >> 2] | 0);
    f121 = Math_fround(f125 + Math_fround(f121 * f109));
    f120 = Math_fround(f124 + Math_fround(f120 * f108));
    f119 = Math_fround(f123 + Math_fround(f119 * f107));
    f118 = Math_fround(f122 + Math_fround(f118 * f106));
    i13 = (HEAPF32[tempDoublePtr >> 2] = f121, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f120, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f118, HEAP32[tempDoublePtr >> 2] | 0);
    f109 = Math_fround(f117 + Math_fround(f116 * f109));
    f108 = Math_fround(f115 + Math_fround(f114 * f108));
    f107 = Math_fround(f113 + Math_fround(f112 * f107));
    f106 = Math_fround(f111 + Math_fround(f110 * f106));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f109, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f108, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i98 >> 2] = f105;
    HEAPF32[i99 >> 2] = f104;
    HEAPF32[i100 >> 2] = f103;
    HEAPF32[i101 >> 2] = f102;
    if ((i50 | 0) == (i55 | 0)) {
     i49 = i28;
     break;
    } else {
     i51 = i22;
     i49 = i28;
     i22 = i50;
    }
   }
  }
  if (i68 >>> 0 < i69 >>> 0) {
   i28 = i20;
   i20 = i68;
  } else {
   i28 = i32;
   break;
  }
 }
 HEAP32[i70 >> 2] = i24;
 i101 = i70 + 4 | 0;
 HEAP32[i101 >> 2] = i46;
 i101 = i70 + 8 | 0;
 HEAP32[i101 >> 2] = i42;
 HEAP32[i77 >> 2] = i25;
 i101 = i77 + 4 | 0;
 HEAP32[i101 >> 2] = i47;
 i101 = i77 + 8 | 0;
 HEAP32[i101 >> 2] = i43;
 HEAP32[i83 >> 2] = i26;
 i101 = i83 + 4 | 0;
 HEAP32[i101 >> 2] = i48;
 i101 = i83 + 8 | 0;
 HEAP32[i101 >> 2] = i44;
 HEAP32[i72 >> 2] = i27;
 i101 = i72 + 4 | 0;
 HEAP32[i101 >> 2] = i49;
 i101 = i72 + 8 | 0;
 HEAP32[i101 >> 2] = i45;
 HEAP32[i74 >> 2] = i38;
 i101 = i74 + 4 | 0;
 HEAP32[i101 >> 2] = i34;
 i101 = i74 + 8 | 0;
 HEAP32[i101 >> 2] = i29;
 HEAP32[i80 >> 2] = i39;
 i101 = i80 + 4 | 0;
 HEAP32[i101 >> 2] = i35;
 i101 = i80 + 8 | 0;
 HEAP32[i101 >> 2] = i30;
 HEAP32[i71 >> 2] = i40;
 i101 = i71 + 4 | 0;
 HEAP32[i101 >> 2] = i36;
 i101 = i71 + 8 | 0;
 HEAP32[i101 >> 2] = i31;
 HEAP32[i73 >> 2] = i41;
 i101 = i73 + 4 | 0;
 HEAP32[i101 >> 2] = i37;
 i101 = i73 + 8 | 0;
 HEAP32[i101 >> 2] = i33;
 HEAP32[i75 >> 2] = i21;
 i101 = i70 + 20 | 0;
 HEAP32[i101 >> 2] = i17;
 i101 = i70 + 24 | 0;
 HEAP32[i101 >> 2] = i13;
 HEAP32[i78 >> 2] = i22;
 i101 = i77 + 20 | 0;
 HEAP32[i101 >> 2] = i18;
 i101 = i77 + 24 | 0;
 HEAP32[i101 >> 2] = i14;
 HEAP32[i81 >> 2] = i23;
 i101 = i83 + 20 | 0;
 HEAP32[i101 >> 2] = i19;
 i101 = i83 + 24 | 0;
 HEAP32[i101 >> 2] = i15;
 HEAP32[i84 >> 2] = i28;
 i101 = i72 + 20 | 0;
 HEAP32[i101 >> 2] = i20;
 i101 = i72 + 24 | 0;
 HEAP32[i101 >> 2] = i16;
 HEAP32[i76 >> 2] = i9;
 i101 = i74 + 20 | 0;
 HEAP32[i101 >> 2] = i5;
 i101 = i74 + 24 | 0;
 HEAP32[i101 >> 2] = i1;
 HEAP32[i79 >> 2] = i10;
 i101 = i80 + 20 | 0;
 HEAP32[i101 >> 2] = i6;
 i101 = i80 + 24 | 0;
 HEAP32[i101 >> 2] = i2;
 HEAP32[i82 >> 2] = i11;
 i101 = i71 + 20 | 0;
 HEAP32[i101 >> 2] = i7;
 i101 = i71 + 24 | 0;
 HEAP32[i101 >> 2] = i3;
 HEAP32[i85 >> 2] = i12;
 i101 = i73 + 20 | 0;
 HEAP32[i101 >> 2] = i8;
 i101 = i73 + 24 | 0;
 HEAP32[i101 >> 2] = i4;
 return;
}

function __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, f156 = f0, f157 = f0, f158 = f0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, f167 = f0, f168 = f0, f169 = f0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, f176 = f0, f177 = f0, f178 = f0, f179 = f0, f180 = f0, f181 = f0, f182 = f0, f183 = f0, f184 = f0, f185 = f0, f186 = f0, f187 = f0, f188 = f0, f189 = f0, f190 = f0, f191 = f0, f192 = f0, f193 = f0, f194 = f0, f195 = f0, f196 = f0, f197 = f0, f198 = f0, f199 = f0, f200 = f0, f201 = f0, f202 = f0, f203 = f0, f204 = f0, f205 = f0, f206 = f0, f207 = f0, f208 = f0, f209 = f0, f210 = f0, f211 = f0, f212 = f0, f213 = f0, f214 = f0, f215 = f0, f216 = f0, f217 = f0, f218 = f0, f219 = f0, f220 = f0, f221 = f0, f222 = f0, f223 = f0, f224 = f0, f225 = f0, f226 = f0, f227 = f0, f228 = f0, f229 = f0;
 i129 = HEAP32[i3 >> 2] | 0;
 i133 = HEAP32[i3 + 4 >> 2] | 0;
 i136 = HEAP32[i3 + 32 >> 2] | 0;
 i139 = HEAP32[i3 + 36 >> 2] | 0;
 i142 = HEAP32[i3 + 64 >> 2] | 0;
 i130 = HEAP32[i3 + 68 >> 2] | 0;
 i131 = HEAP32[i3 + 96 >> 2] | 0;
 i132 = HEAP32[i3 + 100 >> 2] | 0;
 i7 = HEAP32[i129 >> 2] | 0;
 i23 = HEAP32[i129 + 4 >> 2] | 0;
 i39 = HEAP32[i129 + 8 >> 2] | 0;
 i15 = HEAP32[i133 >> 2] | 0;
 i31 = HEAP32[i133 + 4 >> 2] | 0;
 i44 = HEAP32[i133 + 8 >> 2] | 0;
 i134 = i129 + 16 | 0;
 i36 = HEAP32[i134 >> 2] | 0;
 i28 = HEAP32[i134 + 4 >> 2] | 0;
 i20 = HEAP32[i134 + 8 >> 2] | 0;
 i135 = i133 + 16 | 0;
 i12 = HEAP32[i135 >> 2] | 0;
 i5 = HEAP32[i135 + 4 >> 2] | 0;
 i1 = HEAP32[i135 + 8 >> 2] | 0;
 i9 = HEAP32[i136 >> 2] | 0;
 i25 = HEAP32[i136 + 4 >> 2] | 0;
 i41 = HEAP32[i136 + 8 >> 2] | 0;
 i17 = HEAP32[i139 >> 2] | 0;
 i33 = HEAP32[i139 + 4 >> 2] | 0;
 i46 = HEAP32[i139 + 8 >> 2] | 0;
 i137 = i136 + 16 | 0;
 i38 = HEAP32[i137 >> 2] | 0;
 i30 = HEAP32[i137 + 4 >> 2] | 0;
 i22 = HEAP32[i137 + 8 >> 2] | 0;
 i138 = i139 + 16 | 0;
 i14 = HEAP32[i138 >> 2] | 0;
 i6 = HEAP32[i138 + 4 >> 2] | 0;
 i2 = HEAP32[i138 + 8 >> 2] | 0;
 i11 = HEAP32[i142 >> 2] | 0;
 i27 = HEAP32[i142 + 4 >> 2] | 0;
 i43 = HEAP32[i142 + 8 >> 2] | 0;
 i19 = HEAP32[i130 >> 2] | 0;
 i35 = HEAP32[i130 + 4 >> 2] | 0;
 i47 = HEAP32[i130 + 8 >> 2] | 0;
 i140 = i142 + 16 | 0;
 i40 = HEAP32[i140 >> 2] | 0;
 i32 = HEAP32[i140 + 4 >> 2] | 0;
 i24 = HEAP32[i140 + 8 >> 2] | 0;
 i141 = i130 + 16 | 0;
 i16 = HEAP32[i141 >> 2] | 0;
 i8 = HEAP32[i141 + 4 >> 2] | 0;
 i50 = HEAP32[i141 + 8 >> 2] | 0;
 i13 = HEAP32[i131 >> 2] | 0;
 i29 = HEAP32[i131 + 4 >> 2] | 0;
 i45 = HEAP32[i131 + 8 >> 2] | 0;
 i21 = HEAP32[i132 >> 2] | 0;
 i37 = HEAP32[i132 + 4 >> 2] | 0;
 i49 = HEAP32[i132 + 8 >> 2] | 0;
 i143 = i131 + 16 | 0;
 i42 = HEAP32[i143 >> 2] | 0;
 i34 = HEAP32[i143 + 4 >> 2] | 0;
 i26 = HEAP32[i143 + 8 >> 2] | 0;
 i144 = i132 + 16 | 0;
 i18 = HEAP32[i144 >> 2] | 0;
 i10 = HEAP32[i144 + 4 >> 2] | 0;
 i4 = HEAP32[i144 + 8 >> 2] | 0;
 i48 = HEAP32[i3 + 16 >> 2] | 0;
 i3 = HEAP16[i48 + 2 >> 1] | 0;
 i128 = i48 + (i3 & 65535) | 0;
 if (!(i3 << 16 >> 16)) {
  i146 = i13;
  i149 = i11;
  i152 = i9;
  i155 = i7;
  i145 = i29;
  i148 = i27;
  i151 = i25;
  i154 = i23;
  i3 = i45;
  i147 = i43;
  i150 = i41;
  i153 = i39;
  i25 = i21;
  i13 = i17;
  i7 = i15;
  i27 = i37;
  i21 = i35;
  i15 = i33;
  i9 = i31;
  i29 = i49;
  i23 = i47;
  i17 = i46;
  i11 = i44;
  i39 = i42;
  i37 = i40;
  i33 = i38;
  i31 = i36;
  i41 = i34;
  i38 = i32;
  i35 = i30;
  i32 = i28;
  i42 = i26;
  i40 = i24;
  i36 = i22;
  i34 = i20;
  i70 = i18;
  i48 = i16;
  i46 = i14;
  i43 = i12;
  i127 = i10;
  i49 = i8;
  i47 = i6;
  i44 = i5;
  i128 = i4;
  i63 = i50;
  i50 = i2;
  i45 = i1;
  HEAP32[i129 >> 2] = i155;
  i30 = i129 + 4 | 0;
  HEAP32[i30 >> 2] = i154;
  i30 = i129 + 8 | 0;
  HEAP32[i30 >> 2] = i153;
  HEAP32[i136 >> 2] = i152;
  i30 = i136 + 4 | 0;
  HEAP32[i30 >> 2] = i151;
  i30 = i136 + 8 | 0;
  HEAP32[i30 >> 2] = i150;
  HEAP32[i142 >> 2] = i149;
  i30 = i142 + 4 | 0;
  HEAP32[i30 >> 2] = i148;
  i30 = i142 + 8 | 0;
  HEAP32[i30 >> 2] = i147;
  HEAP32[i131 >> 2] = i146;
  i30 = i131 + 4 | 0;
  HEAP32[i30 >> 2] = i145;
  i30 = i131 + 8 | 0;
  HEAP32[i30 >> 2] = i3;
  HEAP32[i133 >> 2] = i7;
  i30 = i133 + 4 | 0;
  HEAP32[i30 >> 2] = i9;
  i30 = i133 + 8 | 0;
  HEAP32[i30 >> 2] = i11;
  HEAP32[i139 >> 2] = i13;
  i30 = i139 + 4 | 0;
  HEAP32[i30 >> 2] = i15;
  i30 = i139 + 8 | 0;
  HEAP32[i30 >> 2] = i17;
  HEAP32[i130 >> 2] = i19;
  i30 = i130 + 4 | 0;
  HEAP32[i30 >> 2] = i21;
  i30 = i130 + 8 | 0;
  HEAP32[i30 >> 2] = i23;
  HEAP32[i132 >> 2] = i25;
  i30 = i132 + 4 | 0;
  HEAP32[i30 >> 2] = i27;
  i30 = i132 + 8 | 0;
  HEAP32[i30 >> 2] = i29;
  HEAP32[i134 >> 2] = i31;
  i134 = i129 + 20 | 0;
  HEAP32[i134 >> 2] = i32;
  i134 = i129 + 24 | 0;
  HEAP32[i134 >> 2] = i34;
  HEAP32[i137 >> 2] = i33;
  i137 = i136 + 20 | 0;
  HEAP32[i137 >> 2] = i35;
  i137 = i136 + 24 | 0;
  HEAP32[i137 >> 2] = i36;
  HEAP32[i140 >> 2] = i37;
  i140 = i142 + 20 | 0;
  HEAP32[i140 >> 2] = i38;
  i142 = i142 + 24 | 0;
  HEAP32[i142 >> 2] = i40;
  HEAP32[i143 >> 2] = i39;
  i143 = i131 + 20 | 0;
  HEAP32[i143 >> 2] = i41;
  i143 = i131 + 24 | 0;
  HEAP32[i143 >> 2] = i42;
  HEAP32[i135 >> 2] = i43;
  i143 = i133 + 20 | 0;
  HEAP32[i143 >> 2] = i44;
  i143 = i133 + 24 | 0;
  HEAP32[i143 >> 2] = i45;
  HEAP32[i138 >> 2] = i46;
  i143 = i139 + 20 | 0;
  HEAP32[i143 >> 2] = i47;
  i143 = i139 + 24 | 0;
  HEAP32[i143 >> 2] = i50;
  HEAP32[i141 >> 2] = i48;
  i143 = i130 + 20 | 0;
  HEAP32[i143 >> 2] = i49;
  i143 = i130 + 24 | 0;
  HEAP32[i143 >> 2] = i63;
  HEAP32[i144 >> 2] = i70;
  i144 = i132 + 20 | 0;
  HEAP32[i144 >> 2] = i127;
  i144 = i132 + 24 | 0;
  HEAP32[i144 >> 2] = i128;
  return;
 } else {
  i63 = i3;
  i3 = i50;
 }
 while (1) {
  i50 = i48 + ((i63 & 65535) + 64) | 0;
  i63 = i48 + 112 | 0;
  i155 = HEAP8[i48 + 1 >> 0] | 0;
  i70 = i155 & 255;
  i127 = i63 + (i70 * 272 | 0) | 0;
  f71 = Math_fround(HEAPF32[i48 + 80 >> 2]);
  f72 = Math_fround(HEAPF32[i48 + 84 >> 2]);
  f73 = Math_fround(HEAPF32[i48 + 88 >> 2]);
  f74 = Math_fround(HEAPF32[i48 + 92 >> 2]);
  f75 = Math_fround(HEAPF32[i48 + 96 >> 2]);
  f76 = Math_fround(HEAPF32[i48 + 100 >> 2]);
  f77 = Math_fround(HEAPF32[i48 + 104 >> 2]);
  f78 = Math_fround(HEAPF32[i48 + 108 >> 2]);
  f51 = Math_fround(HEAPF32[i48 + 32 >> 2]);
  f54 = Math_fround(HEAPF32[i48 + 36 >> 2]);
  f64 = Math_fround(HEAPF32[i48 + 40 >> 2]);
  f68 = Math_fround(HEAPF32[i48 + 44 >> 2]);
  f52 = Math_fround(HEAPF32[i48 + 48 >> 2]);
  f55 = Math_fround(HEAPF32[i48 + 52 >> 2]);
  f65 = Math_fround(HEAPF32[i48 + 56 >> 2]);
  f69 = Math_fround(HEAPF32[i48 + 60 >> 2]);
  f53 = Math_fround(HEAPF32[i48 + 64 >> 2]);
  f56 = Math_fround(HEAPF32[i48 + 68 >> 2]);
  f66 = Math_fround(HEAPF32[i48 + 72 >> 2]);
  f67 = Math_fround(HEAPF32[i48 + 76 >> 2]);
  f113 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f107 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f101 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f91 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f114 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f108 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f102 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f92 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f115 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f109 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f103 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f93 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f116 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f110 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f104 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f94 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f79 = Math_fround(f71 * f51);
  f80 = Math_fround(f72 * f54);
  f81 = Math_fround(f73 * f64);
  f82 = Math_fround(f74 * f68);
  f83 = Math_fround(f75 * f51);
  f84 = Math_fround(f76 * f54);
  f85 = Math_fround(f77 * f64);
  f86 = Math_fround(f78 * f68);
  f87 = Math_fround(f71 * f52);
  f88 = Math_fround(f72 * f55);
  f89 = Math_fround(f73 * f65);
  f90 = Math_fround(f74 * f69);
  f95 = Math_fround(f75 * f52);
  f96 = Math_fround(f76 * f55);
  f97 = Math_fround(f77 * f65);
  f98 = Math_fround(f78 * f69);
  f119 = Math_fround(f71 * f53);
  f120 = Math_fround(f72 * f56);
  f121 = Math_fround(f73 * f66);
  f122 = Math_fround(f74 * f67);
  f123 = Math_fround(f75 * f53);
  f124 = Math_fround(f76 * f56);
  f125 = Math_fround(f77 * f66);
  f126 = Math_fround(f78 * f67);
  f117 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f111 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f105 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f99 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f118 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f112 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f106 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f100 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(i155 << 24 >> 24)) {
   f54 = Math_fround(0.0);
   f53 = Math_fround(0.0);
   f52 = Math_fround(0.0);
   f51 = Math_fround(0.0);
  } else {
   f59 = Math_fround(Math_fround(Math_fround(f113 * f51) + Math_fround(f115 * f52)) + Math_fround(f117 * f53));
   f60 = Math_fround(Math_fround(Math_fround(f107 * f54) + Math_fround(f109 * f55)) + Math_fround(f111 * f56));
   f61 = Math_fround(Math_fround(Math_fround(f101 * f64) + Math_fround(f103 * f65)) + Math_fround(f105 * f66));
   f62 = Math_fround(Math_fround(Math_fround(f91 * f68) + Math_fround(f93 * f69)) + Math_fround(f99 * f67));
   f58 = Math_fround(Math_fround(Math_fround(f114 * f51) + Math_fround(f116 * f52)) + Math_fround(f118 * f53));
   f57 = Math_fround(Math_fround(Math_fround(f108 * f54) + Math_fround(f110 * f55)) + Math_fround(f112 * f56));
   f56 = Math_fround(Math_fround(Math_fround(f102 * f64) + Math_fround(f104 * f65)) + Math_fround(f106 * f66));
   f55 = Math_fround(Math_fround(Math_fround(f92 * f68) + Math_fround(f94 * f69)) + Math_fround(f100 * f67));
   f51 = Math_fround(0.0);
   f52 = Math_fround(0.0);
   f53 = Math_fround(0.0);
   f54 = Math_fround(0.0);
   i9 = 0;
   while (1) {
    i7 = i9 + 1 | 0;
    f201 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 48 >> 2]);
    f200 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 52 >> 2]);
    f199 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 56 >> 2]);
    f198 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 60 >> 2]);
    f185 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 64 >> 2]);
    f184 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 68 >> 2]);
    f183 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 72 >> 2]);
    f182 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 76 >> 2]);
    f169 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 80 >> 2]);
    f168 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 84 >> 2]);
    f167 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 88 >> 2]);
    f166 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 92 >> 2]);
    f193 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 224 >> 2]);
    f192 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 228 >> 2]);
    f191 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 232 >> 2]);
    f190 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 236 >> 2]);
    f177 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 240 >> 2]);
    f176 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 244 >> 2]);
    f175 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 248 >> 2]);
    f174 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 252 >> 2]);
    f164 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 256 >> 2]);
    f162 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 260 >> 2]);
    f160 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 264 >> 2]);
    f158 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 268 >> 2]);
    i152 = i63 + (i9 * 272 | 0) + 96 | 0;
    f157 = Math_fround(HEAPF32[i152 >> 2]);
    i153 = i63 + (i9 * 272 | 0) + 100 | 0;
    f156 = Math_fround(HEAPF32[i153 >> 2]);
    i154 = i63 + (i9 * 272 | 0) + 104 | 0;
    f64 = Math_fround(HEAPF32[i154 >> 2]);
    i155 = i63 + (i9 * 272 | 0) + 108 | 0;
    f65 = Math_fround(HEAPF32[i155 >> 2]);
    f227 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 112 >> 2]);
    f222 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 116 >> 2]);
    f217 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 120 >> 2]);
    f207 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 124 >> 2]);
    f229 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 128 >> 2]);
    f224 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 132 >> 2]);
    f219 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 136 >> 2]);
    f214 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 140 >> 2]);
    f228 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 144 >> 2]);
    f223 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 148 >> 2]);
    f218 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 152 >> 2]);
    f206 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 156 >> 2]);
    f66 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 160 >> 2]);
    f67 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 164 >> 2]);
    f68 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 168 >> 2]);
    f69 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 172 >> 2]);
    f178 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) >> 2]);
    f179 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 4 >> 2]);
    f180 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 8 >> 2]);
    f181 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 12 >> 2]);
    f159 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 16 >> 2]);
    f161 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 20 >> 2]);
    f163 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 24 >> 2]);
    f165 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 28 >> 2]);
    f226 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 32 >> 2]);
    f221 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 36 >> 2]);
    f216 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 40 >> 2]);
    f208 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 44 >> 2]);
    f170 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 176 >> 2]);
    f171 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 180 >> 2]);
    f172 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 184 >> 2]);
    f173 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 188 >> 2]);
    f225 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 192 >> 2]);
    f220 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 196 >> 2]);
    f215 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 200 >> 2]);
    f209 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 204 >> 2]);
    f213 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 208 >> 2]);
    f212 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 212 >> 2]);
    f211 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 216 >> 2]);
    f210 = Math_fround(HEAPF32[i63 + (i9 * 272 | 0) + 220 >> 2]);
    f205 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = Math_fround(f205 * f178);
    f204 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f179 = Math_fround(f204 * f179);
    f203 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f180 = Math_fround(f203 * f180);
    f202 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f181 = Math_fround(f202 * f181);
    f197 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f170 = Math_fround(f197 * f170);
    f196 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f171 = Math_fround(f196 * f171);
    f195 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f172 = Math_fround(f195 * f172);
    f194 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f173 = Math_fround(f194 * f173);
    f189 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f188 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f187 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f186 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f159 = Math_fround(f178 + Math_fround(f189 * f159));
    f161 = Math_fround(f179 + Math_fround(f188 * f161));
    f163 = Math_fround(f180 + Math_fround(f187 * f163));
    f165 = Math_fround(f181 + Math_fround(f186 * f165));
    f181 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f180 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f179 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f178 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f225 = Math_fround(f170 + Math_fround(f181 * f225));
    f220 = Math_fround(f171 + Math_fround(f180 * f220));
    f215 = Math_fround(f172 + Math_fround(f179 * f215));
    f209 = Math_fround(f173 + Math_fround(f178 * f209));
    f173 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f172 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f171 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f170 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f226 = Math_fround(f159 + Math_fround(f173 * f226));
    f221 = Math_fround(f161 + Math_fround(f172 * f221));
    f216 = Math_fround(f163 + Math_fround(f171 * f216));
    f208 = Math_fround(f165 + Math_fround(f170 * f208));
    f165 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f163 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f161 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f159 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f213 = Math_fround(Math_fround(Math_fround(f227 * f229) - f228) - Math_fround(f227 * Math_fround(Math_fround(f59 + f226) - Math_fround(f58 + Math_fround(f225 + Math_fround(f165 * f213))))));
    f212 = Math_fround(Math_fround(Math_fround(f222 * f224) - f223) - Math_fround(f222 * Math_fround(Math_fround(f60 + f221) - Math_fround(f57 + Math_fround(f220 + Math_fround(f163 * f212))))));
    f211 = Math_fround(Math_fround(Math_fround(f217 * f219) - f218) - Math_fround(f217 * Math_fround(Math_fround(f61 + f216) - Math_fround(f56 + Math_fround(f215 + Math_fround(f161 * f211))))));
    f210 = Math_fround(Math_fround(Math_fround(f207 * f214) - f206) - Math_fround(f207 * Math_fround(Math_fround(f62 + f208) - Math_fround(f55 + Math_fround(f209 + Math_fround(f159 * f210))))));
    f209 = Math_fround(-f157);
    f208 = Math_fround(-f156);
    f207 = Math_fround(-f64);
    f206 = Math_fround(-f65);
    f209 = Math_fround(f157 + (f213 > f209 ? f213 : f209));
    f208 = Math_fround(f156 + (f212 > f208 ? f212 : f208));
    f207 = Math_fround(f64 + (f211 > f207 ? f211 : f207));
    f206 = Math_fround(f65 + (f210 > f206 ? f210 : f206));
    f66 = f209 < f66 ? f209 : f66;
    f67 = f208 < f67 ? f208 : f67;
    f68 = f207 < f68 ? f207 : f68;
    f69 = f206 < f69 ? f206 : f69;
    f157 = Math_fround(f66 - f157);
    f156 = Math_fround(f67 - f156);
    f64 = Math_fround(f68 - f64);
    f65 = Math_fround(f69 - f65);
    f59 = Math_fround(f59 + Math_fround(f71 * f157));
    f60 = Math_fround(f60 + Math_fround(f72 * f156));
    f61 = Math_fround(f61 + Math_fround(f73 * f64));
    f62 = Math_fround(f62 + Math_fround(f74 * f65));
    f58 = Math_fround(f58 + Math_fround(f75 * f157));
    f57 = Math_fround(f57 + Math_fround(f76 * f156));
    f56 = Math_fround(f56 + Math_fround(f77 * f64));
    f55 = Math_fround(f55 + Math_fround(f78 * f65));
    f51 = Math_fround(f51 + f157);
    f52 = Math_fround(f52 + f156);
    f53 = Math_fround(f53 + f64);
    f54 = Math_fround(f54 + f65);
    f201 = Math_fround(f205 + Math_fround(f201 * f157));
    f200 = Math_fround(f204 + Math_fround(f200 * f156));
    f199 = Math_fround(f203 + Math_fround(f199 * f64));
    f198 = Math_fround(f202 + Math_fround(f198 * f65));
    i36 = (HEAPF32[tempDoublePtr >> 2] = f201, HEAP32[tempDoublePtr >> 2] | 0);
    i38 = (HEAPF32[tempDoublePtr >> 2] = f200, HEAP32[tempDoublePtr >> 2] | 0);
    i40 = (HEAPF32[tempDoublePtr >> 2] = f199, HEAP32[tempDoublePtr >> 2] | 0);
    i42 = (HEAPF32[tempDoublePtr >> 2] = f198, HEAP32[tempDoublePtr >> 2] | 0);
    f193 = Math_fround(f197 + Math_fround(f193 * f157));
    f192 = Math_fround(f196 + Math_fround(f192 * f156));
    f191 = Math_fround(f195 + Math_fround(f191 * f64));
    f190 = Math_fround(f194 + Math_fround(f190 * f65));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f193, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f192, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f191, HEAP32[tempDoublePtr >> 2] | 0);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f190, HEAP32[tempDoublePtr >> 2] | 0);
    f185 = Math_fround(f189 + Math_fround(f185 * f157));
    f184 = Math_fround(f188 + Math_fround(f184 * f156));
    f183 = Math_fround(f187 + Math_fround(f183 * f64));
    f182 = Math_fround(f186 + Math_fround(f182 * f65));
    i28 = (HEAPF32[tempDoublePtr >> 2] = f185, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f184, HEAP32[tempDoublePtr >> 2] | 0);
    i32 = (HEAPF32[tempDoublePtr >> 2] = f183, HEAP32[tempDoublePtr >> 2] | 0);
    i34 = (HEAPF32[tempDoublePtr >> 2] = f182, HEAP32[tempDoublePtr >> 2] | 0);
    f177 = Math_fround(f181 + Math_fround(f177 * f157));
    f176 = Math_fround(f180 + Math_fround(f176 * f156));
    f175 = Math_fround(f179 + Math_fround(f175 * f64));
    f174 = Math_fround(f178 + Math_fround(f174 * f65));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f177, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f176, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f175, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f174, HEAP32[tempDoublePtr >> 2] | 0);
    f169 = Math_fround(f173 + Math_fround(f169 * f157));
    f168 = Math_fround(f172 + Math_fround(f168 * f156));
    f167 = Math_fround(f171 + Math_fround(f167 * f64));
    f166 = Math_fround(f170 + Math_fround(f166 * f65));
    i20 = (HEAPF32[tempDoublePtr >> 2] = f169, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f168, HEAP32[tempDoublePtr >> 2] | 0);
    i24 = (HEAPF32[tempDoublePtr >> 2] = f167, HEAP32[tempDoublePtr >> 2] | 0);
    i26 = (HEAPF32[tempDoublePtr >> 2] = f166, HEAP32[tempDoublePtr >> 2] | 0);
    f157 = Math_fround(f165 + Math_fround(f164 * f157));
    f156 = Math_fround(f163 + Math_fround(f162 * f156));
    f64 = Math_fround(f161 + Math_fround(f160 * f64));
    f65 = Math_fround(f159 + Math_fround(f158 * f65));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f157, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f156, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i152 >> 2] = f66;
    HEAPF32[i153 >> 2] = f67;
    HEAPF32[i154 >> 2] = f68;
    HEAPF32[i155 >> 2] = f69;
    HEAPF32[i50 + (i9 << 4) >> 2] = f66;
    HEAPF32[i50 + (i9 << 4) + 4 >> 2] = f67;
    HEAPF32[i50 + (i9 << 4) + 8 >> 2] = f68;
    HEAPF32[i50 + (i9 << 4) + 12 >> 2] = f69;
    if ((i7 | 0) == (i70 | 0)) break; else i9 = i7;
   }
  }
  f229 = Math_fround(f113 + Math_fround(f79 * f51));
  f228 = Math_fround(f107 + Math_fround(f80 * f52));
  f227 = Math_fround(f101 + Math_fround(f81 * f53));
  f226 = Math_fround(f91 + Math_fround(f82 * f54));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  f226 = Math_fround(f114 + Math_fround(f83 * f51));
  f227 = Math_fround(f108 + Math_fround(f84 * f52));
  f228 = Math_fround(f102 + Math_fround(f85 * f53));
  f229 = Math_fround(f92 + Math_fround(f86 * f54));
  i15 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  f229 = Math_fround(f115 + Math_fround(f87 * f51));
  f228 = Math_fround(f109 + Math_fround(f88 * f52));
  f227 = Math_fround(f103 + Math_fround(f89 * f53));
  f226 = Math_fround(f93 + Math_fround(f90 * f54));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i27 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  f226 = Math_fround(f116 + Math_fround(f95 * f51));
  f227 = Math_fround(f110 + Math_fround(f96 * f52));
  f228 = Math_fround(f104 + Math_fround(f97 * f53));
  f229 = Math_fround(f94 + Math_fround(f98 * f54));
  i31 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  f229 = Math_fround(f117 + Math_fround(f119 * f51));
  f228 = Math_fround(f111 + Math_fround(f120 * f52));
  f227 = Math_fround(f105 + Math_fround(f121 * f53));
  f226 = Math_fround(f99 + Math_fround(f122 * f54));
  i39 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  f226 = Math_fround(f118 + Math_fround(f123 * f51));
  f227 = Math_fround(f112 + Math_fround(f124 * f52));
  f228 = Math_fround(f106 + Math_fround(f125 * f53));
  f229 = Math_fround(f100 + Math_fround(f126 * f54));
  i44 = (HEAPF32[tempDoublePtr >> 2] = f226, HEAP32[tempDoublePtr >> 2] | 0);
  i46 = (HEAPF32[tempDoublePtr >> 2] = f227, HEAP32[tempDoublePtr >> 2] | 0);
  i47 = (HEAPF32[tempDoublePtr >> 2] = f228, HEAP32[tempDoublePtr >> 2] | 0);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f229, HEAP32[tempDoublePtr >> 2] | 0);
  if (i127 >>> 0 >= i128 >>> 0) break;
  i63 = HEAP16[i127 + 2 >> 1] | 0;
  i49 = i48;
  i48 = i127;
 }
 HEAP32[i129 >> 2] = i7;
 i155 = i129 + 4 | 0;
 HEAP32[i155 >> 2] = i23;
 i155 = i129 + 8 | 0;
 HEAP32[i155 >> 2] = i39;
 HEAP32[i136 >> 2] = i9;
 i155 = i136 + 4 | 0;
 HEAP32[i155 >> 2] = i25;
 i155 = i136 + 8 | 0;
 HEAP32[i155 >> 2] = i41;
 HEAP32[i142 >> 2] = i11;
 i155 = i142 + 4 | 0;
 HEAP32[i155 >> 2] = i27;
 i155 = i142 + 8 | 0;
 HEAP32[i155 >> 2] = i43;
 HEAP32[i131 >> 2] = i13;
 i155 = i131 + 4 | 0;
 HEAP32[i155 >> 2] = i29;
 i155 = i131 + 8 | 0;
 HEAP32[i155 >> 2] = i45;
 HEAP32[i133 >> 2] = i15;
 i155 = i133 + 4 | 0;
 HEAP32[i155 >> 2] = i31;
 i155 = i133 + 8 | 0;
 HEAP32[i155 >> 2] = i44;
 HEAP32[i139 >> 2] = i17;
 i155 = i139 + 4 | 0;
 HEAP32[i155 >> 2] = i33;
 i155 = i139 + 8 | 0;
 HEAP32[i155 >> 2] = i46;
 HEAP32[i130 >> 2] = i19;
 i155 = i130 + 4 | 0;
 HEAP32[i155 >> 2] = i35;
 i155 = i130 + 8 | 0;
 HEAP32[i155 >> 2] = i47;
 HEAP32[i132 >> 2] = i21;
 i155 = i132 + 4 | 0;
 HEAP32[i155 >> 2] = i37;
 i155 = i132 + 8 | 0;
 HEAP32[i155 >> 2] = i48;
 HEAP32[i134 >> 2] = i36;
 i155 = i129 + 20 | 0;
 HEAP32[i155 >> 2] = i28;
 i155 = i129 + 24 | 0;
 HEAP32[i155 >> 2] = i20;
 HEAP32[i137 >> 2] = i38;
 i155 = i136 + 20 | 0;
 HEAP32[i155 >> 2] = i30;
 i155 = i136 + 24 | 0;
 HEAP32[i155 >> 2] = i22;
 HEAP32[i140 >> 2] = i40;
 i155 = i142 + 20 | 0;
 HEAP32[i155 >> 2] = i32;
 i155 = i142 + 24 | 0;
 HEAP32[i155 >> 2] = i24;
 HEAP32[i143 >> 2] = i42;
 i155 = i131 + 20 | 0;
 HEAP32[i155 >> 2] = i34;
 i155 = i131 + 24 | 0;
 HEAP32[i155 >> 2] = i26;
 HEAP32[i135 >> 2] = i12;
 i155 = i133 + 20 | 0;
 HEAP32[i155 >> 2] = i5;
 i155 = i133 + 24 | 0;
 HEAP32[i155 >> 2] = i1;
 HEAP32[i138 >> 2] = i14;
 i155 = i139 + 20 | 0;
 HEAP32[i155 >> 2] = i6;
 i155 = i139 + 24 | 0;
 HEAP32[i155 >> 2] = i2;
 HEAP32[i141 >> 2] = i16;
 i155 = i130 + 20 | 0;
 HEAP32[i155 >> 2] = i8;
 i155 = i130 + 24 | 0;
 HEAP32[i155 >> 2] = i3;
 HEAP32[i144 >> 2] = i18;
 i155 = i132 + 20 | 0;
 HEAP32[i155 >> 2] = i10;
 i155 = i132 + 24 | 0;
 HEAP32[i155 >> 2] = i4;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_118parse_expr_primaryINS0_2DbEEEPKcS4_S4_RT_(i1, i4, i17) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 72 | 0;
 i11 = i19 + 48 | 0;
 i10 = i19 + 24 | 0;
 i18 = i19;
 i14 = i19 + 152 | 0;
 i15 = i19 + 128 | 0;
 i16 = i19 + 104 | 0;
 i8 = i19 + 116 | 0;
 i9 = i19 + 92 | 0;
 i3 = i4;
 L1 : do if ((i3 - i1 | 0) > 3) if ((HEAP8[i1 >> 0] | 0) == 76) {
  i2 = i1 + 1 | 0;
  L4 : do switch (HEAP8[i2 >> 0] | 0) {
  case 84:
   break L1;
  case 119:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087433 | 0, 7);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 98:
   {
    if ((HEAP8[i1 + 3 >> 0] | 0) != 69) break L1;
    switch (HEAP8[i1 + 2 >> 0] | 0) {
    case 48:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc(i18, gb + 1087441 | 0);
      i2 = i17 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i16 = HEAP32[i17 + 8 >> 2] | 0;
      i5 = i16;
      do if (i3 >>> 0 < i16 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i18);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i17 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i17 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
        break L4;
       } else {
        i15 = (i5 - i4 | 0) / 24 | 0;
        i16 = i15 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i14, i15 >>> 0 < 89478485 ? (i16 >>> 0 < i3 >>> 0 ? i3 : i16) : 178956970, i2, i17 + 12 | 0);
        i16 = i14 + 8 | 0;
        i15 = HEAP32[i16 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i15, i18);
        HEAP32[i16 >> 2] = i15 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i17, i14);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i14);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
      i1 = i1 + 4 | 0;
      break L1;
     }
    case 49:
     {
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i14, gb + 1087447 | 0);
      i2 = i17 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i16 = HEAP32[i17 + 8 >> 2] | 0;
      i5 = i16;
      do if (i3 >>> 0 < i16 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i14);
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
      } else {
       i4 = HEAP32[i17 >> 2] | 0;
       i2 = (i3 - i4 | 0) / 24 | 0;
       i3 = i2 + 1 | 0;
       if (i3 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i17 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i14);
        break L4;
       } else {
        i15 = (i5 - i4 | 0) / 24 | 0;
        i16 = i15 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i18, i15 >>> 0 < 89478485 ? (i16 >>> 0 < i3 >>> 0 ? i3 : i16) : 178956970, i2, i17 + 12 | 0);
        i16 = i18 + 8 | 0;
        i15 = HEAP32[i16 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i15, i14);
        HEAP32[i16 >> 2] = i15 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i17, i18);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i18);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i14);
      i1 = i1 + 4 | 0;
      break L1;
     }
    default:
     break L1;
    }
   }
  case 99:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087452 | 0, 4);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 97:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087457 | 0, 11);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 104:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087469 | 0, 13);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 115:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087483 | 0, 5);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 116:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087489 | 0, 14);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 105:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1576256 | 0, 0);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 106:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087504 | 0, 1);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 108:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1085971 | 0, 1);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 109:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087506 | 0, 2);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 120:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087509 | 0, 2);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 121:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087512 | 0, 3);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 110:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087516 | 0, 8);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 111:
   {
    i3 = i1 + 2 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i18, gb + 1087525 | 0, 17);
    __THREW__ = 0;
    i2 = invoke_iiiii(fb + 219 | 0, i3 | 0, i4 | 0, i18 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     break L4;
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i18);
     i1 = (i2 | 0) == (i3 | 0) ? i1 : i2;
     break L1;
    }
   }
  case 102:
   {
    i7 = i1 + 2 | 0;
    L127 : do if ((i3 - i7 | 0) >>> 0 > 8) {
     i3 = 0;
     i2 = i18;
     while (1) {
      i4 = i3 + 2 | 0;
      i5 = HEAP8[i1 + i4 >> 0] | 0;
      i6 = i5 << 24 >> 24;
      if ((i3 | 0) == 8) {
       i13 = 65;
       break;
      }
      if (!(_isxdigit(i6) | 0)) break;
      i12 = HEAP8[i7 + (i3 | 1) >> 0] | 0;
      HEAP8[i2 >> 0] = i12 + (((i6 + -48 | 0) >>> 0 < 10 ? 0 : 9) + i6 << 4) + ((i12 + -48 | 0) >>> 0 < 10 ? 208 : 169);
      i3 = i4;
      i2 = i2 + 1 | 0;
     }
     do if ((i13 | 0) == 65) {
      if (i5 << 24 >> 24 == 69) {
       L137 : do if ((i18 | 0) != (i2 | 0)) {
        i3 = i18;
        while (1) {
         i2 = i2 + -1 | 0;
         if (i3 >>> 0 >= i2 >>> 0) break L137;
         i13 = HEAP8[i3 >> 0] | 0;
         HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
         HEAP8[i2 >> 0] = i13;
         i3 = i3 + 1 | 0;
        }
       } while (0);
       i2 = i14;
       i3 = i2 + 24 | 0;
       do {
        HEAP8[i2 >> 0] = 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i3 | 0));
       HEAPF64[i10 >> 3] = +Math_fround(HEAPF32[i18 >> 2]);
       i2 = _snprintf(i14, 24, gb + 1087543 | 0, i10) | 0;
       if (i2 >>> 0 > 23) break;
       HEAP32[i16 >> 2] = 0;
       HEAP32[i16 + 4 >> 2] = 0;
       HEAP32[i16 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i16, i14, i2);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i16);
       i2 = i17 + 4 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i18 = HEAP32[i17 + 8 >> 2] | 0;
       i5 = i18;
       do if (i3 >>> 0 < i18 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
       } else {
        i4 = HEAP32[i17 >> 2] | 0;
        i2 = (i3 - i4 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i17 | 0);
         __THREW__ = 0;
         i19 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         ___resumeException(i19 | 0);
        } else {
         i14 = (i5 - i4 | 0) / 24 | 0;
         i18 = i14 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i10, i14 >>> 0 < 89478485 ? (i18 >>> 0 < i3 >>> 0 ? i3 : i18) : 178956970, i2, i17 + 12 | 0);
         i18 = i10 + 8 | 0;
         i14 = HEAP32[i18 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i14, i15);
         HEAP32[i18 >> 2] = i14 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i17, i10);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i10);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
       i2 = 11;
      } else i2 = 2;
      break L127;
     } while (0);
     i2 = 2;
    } else i2 = 2; while (0);
    i1 = (i2 | 0) == 2 ? i1 : i1 + i2 | 0;
    break L1;
   }
  case 100:
   {
    i7 = i1 + 2 | 0;
    L156 : do if ((i3 - i7 | 0) >>> 0 > 16) {
     i3 = 0;
     i2 = i18;
     while (1) {
      i4 = i3 + 2 | 0;
      i5 = HEAP8[i1 + i4 >> 0] | 0;
      i6 = i5 << 24 >> 24;
      if ((i3 | 0) == 16) {
       i13 = 85;
       break;
      }
      if (!(_isxdigit(i6) | 0)) break;
      i12 = HEAP8[i7 + (i3 | 1) >> 0] | 0;
      HEAP8[i2 >> 0] = i12 + (((i6 + -48 | 0) >>> 0 < 10 ? 0 : 9) + i6 << 4) + ((i12 + -48 | 0) >>> 0 < 10 ? 208 : 169);
      i3 = i4;
      i2 = i2 + 1 | 0;
     }
     do if ((i13 | 0) == 85) {
      if (i5 << 24 >> 24 == 69) {
       L166 : do if ((i18 | 0) != (i2 | 0)) {
        i3 = i18;
        while (1) {
         i2 = i2 + -1 | 0;
         if (i3 >>> 0 >= i2 >>> 0) break L166;
         i13 = HEAP8[i3 >> 0] | 0;
         HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
         HEAP8[i2 >> 0] = i13;
         i3 = i3 + 1 | 0;
        }
       } while (0);
       i2 = i14;
       i3 = i2 + 32 | 0;
       do {
        HEAP8[i2 >> 0] = 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i3 | 0));
       HEAPF64[i11 >> 3] = +HEAPF64[i18 >> 3];
       i2 = _snprintf(i14, 32, gb + 1087547 | 0, i11) | 0;
       if (i2 >>> 0 > 31) break;
       HEAP32[i16 >> 2] = 0;
       HEAP32[i16 + 4 >> 2] = 0;
       HEAP32[i16 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i16, i14, i2);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i16);
       i2 = i17 + 4 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i18 = HEAP32[i17 + 8 >> 2] | 0;
       i5 = i18;
       do if (i3 >>> 0 < i18 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
       } else {
        i4 = HEAP32[i17 >> 2] | 0;
        i2 = (i3 - i4 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i17 | 0);
         __THREW__ = 0;
         i19 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         ___resumeException(i19 | 0);
        } else {
         i14 = (i5 - i4 | 0) / 24 | 0;
         i18 = i14 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i11, i14 >>> 0 < 89478485 ? (i18 >>> 0 < i3 >>> 0 ? i3 : i18) : 178956970, i2, i17 + 12 | 0);
         i18 = i11 + 8 | 0;
         i14 = HEAP32[i18 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i14, i15);
         HEAP32[i18 >> 2] = i14 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i17, i11);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
       i2 = 19;
      } else i2 = 2;
      break L156;
     } while (0);
     i2 = 2;
    } else i2 = 2; while (0);
    i1 = (i2 | 0) == 2 ? i1 : i1 + i2 | 0;
    break L1;
   }
  case 101:
   {
    i7 = i1 + 2 | 0;
    L185 : do if ((i3 - i7 | 0) >>> 0 > 20) {
     i3 = 0;
     i2 = i18;
     while (1) {
      i4 = i3 + 2 | 0;
      i5 = HEAP8[i1 + i4 >> 0] | 0;
      i6 = i5 << 24 >> 24;
      if ((i3 | 0) == 20) {
       i13 = 105;
       break;
      }
      if (!(_isxdigit(i6) | 0)) break;
      i11 = HEAP8[i7 + (i3 | 1) >> 0] | 0;
      HEAP8[i2 >> 0] = i11 + (((i6 + -48 | 0) >>> 0 < 10 ? 0 : 9) + i6 << 4) + ((i11 + -48 | 0) >>> 0 < 10 ? 208 : 169);
      i3 = i4;
      i2 = i2 + 1 | 0;
     }
     do if ((i13 | 0) == 105) {
      if (i5 << 24 >> 24 == 69) {
       L195 : do if ((i18 | 0) != (i2 | 0)) {
        i3 = i18;
        while (1) {
         i2 = i2 + -1 | 0;
         if (i3 >>> 0 >= i2 >>> 0) break L195;
         i13 = HEAP8[i3 >> 0] | 0;
         HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
         HEAP8[i2 >> 0] = i13;
         i3 = i3 + 1 | 0;
        }
       } while (0);
       i2 = i14;
       i3 = i2 + 40 | 0;
       do {
        HEAP8[i2 >> 0] = 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i3 | 0));
       HEAPF64[i12 >> 3] = +HEAPF64[i18 >> 3];
       i2 = _snprintf(i14, 40, gb + 1087550 | 0, i12) | 0;
       if (i2 >>> 0 > 39) break;
       HEAP32[i16 >> 2] = 0;
       HEAP32[i16 + 4 >> 2] = 0;
       HEAP32[i16 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i16, i14, i2);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i16);
       i2 = i17 + 4 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i18 = HEAP32[i17 + 8 >> 2] | 0;
       i5 = i18;
       do if (i3 >>> 0 < i18 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
       } else {
        i4 = HEAP32[i17 >> 2] | 0;
        i2 = (i3 - i4 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i17 | 0);
         __THREW__ = 0;
         i19 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
         ___resumeException(i19 | 0);
        } else {
         i14 = (i5 - i4 | 0) / 24 | 0;
         i18 = i14 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i12, i14 >>> 0 < 89478485 ? (i18 >>> 0 < i3 >>> 0 ? i3 : i18) : 178956970, i2, i17 + 12 | 0);
         i18 = i12 + 8 | 0;
         i14 = HEAP32[i18 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i14, i15);
         HEAP32[i18 >> 2] = i14 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i17, i12);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i12);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
       i2 = 23;
      } else i2 = 2;
      break L185;
     } while (0);
     i2 = 2;
    } else i2 = 2; while (0);
    i1 = (i2 | 0) == 2 ? i1 : i1 + i2 | 0;
    break L1;
   }
  case 95:
   {
    if ((HEAP8[i1 + 2 >> 0] | 0) != 90) break L1;
    i18 = i1 + 3 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i18, i4, i17) | 0;
    if ((i2 | 0) == (i18 | 0) | (i2 | 0) == (i4 | 0)) break L1;
    i1 = (HEAP8[i2 >> 0] | 0) == 69 ? i2 + 1 | 0 : i1;
    break L1;
   }
  default:
   {
    i6 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i2, i4, i17) | 0;
    if ((i6 | 0) == (i2 | 0) | (i6 | 0) == (i4 | 0)) break L1;
    if ((HEAP8[i6 >> 0] | 0) == 69) {
     i1 = i6 + 1 | 0;
     break L1;
    } else i7 = i6;
    while (1) {
     if ((i7 | 0) == (i4 | 0)) break L1;
     i2 = HEAP8[i7 >> 0] | 0;
     if (((i2 << 24 >> 24) + -48 | 0) >>> 0 >= 10) break;
     i7 = i7 + 1 | 0;
    }
    if (!((i7 | 0) != (i6 | 0) & i2 << 24 >> 24 == 69)) break L1;
    i2 = HEAP32[i17 + 4 >> 2] | 0;
    if ((HEAP32[i17 >> 2] | 0) == (i2 | 0)) break L1;
    i5 = i2 + -24 | 0;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i16, i5);
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 520 | 0, i16 | 0, 0, gb + 1086383 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iii(fb + 1152 | 0, i15 | 0, gb + 1086288 | 0) | 0;
     i17 = __THREW__;
     __THREW__ = 0;
     if (i17 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      HEAP32[i9 >> 2] = 0;
      HEAP32[i9 + 4 >> 2] = 0;
      HEAP32[i9 + 8 >> 2] = 0;
      i4 = i7 - i6 | 0;
      do if (i4 >>> 0 > 4294967279) {
       __THREW__ = 0;
       invoke_vi(fb + 4015 | 0, i9 | 0);
       __THREW__ = 0;
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       if (i4 >>> 0 < 11) {
        HEAP8[i9 + 11 >> 0] = i4;
        i3 = i9;
       } else {
        i17 = i4 + 16 & -16;
        i3 = _malloc(i17) | 0;
        HEAP32[i9 >> 2] = i3;
        HEAP32[i9 + 8 >> 2] = i17 | -2147483648;
        HEAP32[i9 + 4 >> 2] = i4;
       }
       i1 = i6;
       i2 = i3;
       while (1) {
        if ((i1 | 0) == (i7 | 0)) break;
        HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
        i1 = i1 + 1 | 0;
        i2 = i2 + 1 | 0;
       }
       HEAP8[i3 + i4 >> 0] = 0;
       i2 = HEAP8[i9 + 11 >> 0] | 0;
       i17 = i2 << 24 >> 24 < 0;
       __THREW__ = 0;
       i2 = invoke_iiii(fb + 519 | 0, i14 | 0, (i17 ? HEAP32[i9 >> 2] | 0 : i9) | 0, (i17 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
       i17 = __THREW__;
       __THREW__ = 0;
       if (i17 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
        break;
       };
       HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       i1 = 0;
       while (1) {
        if ((i1 | 0) == 3) break;
        HEAP32[i2 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i18, i8);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i5, i18);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i14);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
       i1 = i7 + 1 | 0;
       break L1;
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i14);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i19;
 return i1 | 0;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE11solveFabricEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, i34 = 0, f35 = f0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, i40 = 0, f41 = f0, i42 = 0, f43 = f0, i44 = 0, f45 = f0, i46 = 0, f47 = f0, i48 = 0, f49 = f0, i50 = 0, f51 = f0, i52 = 0, f53 = f0, i54 = 0, f55 = f0, i56 = 0, f57 = f0, i58 = 0, f59 = f0, i60 = 0, f61 = f0, i62 = 0, f63 = f0, i64 = 0, f65 = f0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, f104 = f0, f105 = f0, i106 = 0, i107 = 0, i108 = 0, f109 = f0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, f140 = f0, i141 = 0, f142 = f0;
 i124 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i119 = i124 + 28 | 0;
 i120 = i124 + 24 | 0;
 i121 = i124 + 20 | 0;
 i122 = i124 + 16 | 0;
 i110 = i124 + 12 | 0;
 i111 = i124 + 8 | 0;
 i112 = i124 + 4 | 0;
 i113 = i124;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 64 >> 2] | 0;
 i116 = HEAP32[i2 + 68 >> 2] | 0;
 i117 = HEAP32[i2 + 72 >> 2] | 0;
 i118 = HEAP32[i2 + 88 >> 2] | 0;
 i114 = HEAP32[i2 + 80 >> 2] | 0;
 i115 = HEAP32[i2 + 96 >> 2] | 0;
 f109 = Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + 144 >> 2]);
 f109 = Math_fround(f109 * Math_fround(HEAPF32[i1 + 724 >> 2]));
 if ((i3 | 0) == (i116 | 0)) {
  STACKTOP = i124;
  return;
 }
 i108 = HEAP32[i2 + 4 >> 2] | 0;
 do {
  i5 = HEAP32[i117 + ((HEAPU16[i3 >> 1] | 0) << 2) >> 2] | 0;
  i4 = HEAP32[i114 + (i5 << 2) >> 2] | 0;
  i19 = i118 + (i4 << 2) | 0;
  i5 = HEAP32[i114 + (i5 + 1 << 2) >> 2] | 0;
  i107 = i118 + (i5 << 2) | 0;
  i18 = i115 + (i4 << 1 << 1) | 0;
  i106 = i3 + 4 | 0;
  i17 = HEAP32[i106 >> 2] | 0;
  i1 = HEAP32[i106 + 4 >> 2] | 0;
  i2 = HEAP32[i106 + 8 >> 2] | 0;
  i106 = HEAP32[i106 + 12 >> 2] | 0;
  f98 = Math_fround(f109 * (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f99 = Math_fround(f109 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f104 = Math_fround(f109 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f98 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(f98 * Math_fround(.693147182)))));
  f99 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(f99 * Math_fround(.693147182)))));
  f104 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(f104 * Math_fround(.693147182)))));
  f105 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f109 * (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.693147182)))));
  i101 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
  i103 = (HEAPF32[tempDoublePtr >> 2] = f99, HEAP32[tempDoublePtr >> 2] | 0);
  i102 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = HEAP32[gb + 1097456 >> 2] & (i101 ^ i17) ^ i17;
  i1 = HEAP32[gb + 1097456 + 4 >> 2] & (i103 ^ i1) ^ i1;
  i2 = HEAP32[gb + 1097456 + 8 >> 2] & (i102 ^ i2) ^ i2;
  i106 = HEAP32[gb + 1097456 + 12 >> 2] & ((HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0) ^ i106) ^ i106;
  i102 = HEAP32[gb + 1097488 + 4 >> 2] & i1;
  i103 = HEAP32[gb + 1097488 + 8 >> 2] & i2;
  i101 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097488 >> 2] & i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0);
  i102 = i101 & (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0);
  if (i102 & (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0)) if ((HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097488 + 12 >> 2] & i106, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0)) {
   if ((i4 | 0) != (i5 | 0)) {
    f7 = Math_fround(HEAPF32[gb + 1097520 >> 2]);
    f8 = Math_fround(HEAPF32[gb + 1097520 + 4 >> 2]);
    f9 = Math_fround(HEAPF32[gb + 1097520 + 8 >> 2]);
    f10 = Math_fround(HEAPF32[gb + 1097520 + 12 >> 2]);
    f11 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
    f12 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
    f13 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
    f14 = Math_fround(HEAPF32[gb + 1097504 + 12 >> 2]);
    i4 = HEAP32[gb + 1097472 >> 2] | 0;
    i5 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
    i15 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
    i16 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
    f6 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i2 = i18;
    i1 = i19;
    while (1) {
     i132 = (HEAPU16[i2 >> 1] | 0) << 4;
     i128 = (HEAPU16[i2 + 2 >> 1] | 0) << 4;
     i21 = (HEAPU16[i2 + 4 >> 1] | 0) << 4;
     i28 = (HEAPU16[i2 + 6 >> 1] | 0) << 4;
     i44 = (HEAPU16[i2 + 8 >> 1] | 0) << 4;
     i52 = (HEAPU16[i2 + 10 >> 1] | 0) << 4;
     i100 = (HEAPU16[i2 + 12 >> 1] | 0) << 4;
     i106 = (HEAPU16[i2 + 14 >> 1] | 0) << 4;
     i135 = i108 + i132 | 0;
     f63 = Math_fround(HEAPF32[i135 >> 2]);
     i134 = i108 + (i132 | 4) | 0;
     f59 = Math_fround(HEAPF32[i134 >> 2]);
     i133 = i108 + (i132 | 8) | 0;
     f61 = Math_fround(HEAPF32[i133 >> 2]);
     i132 = i108 + (i132 | 12) | 0;
     f69 = Math_fround(HEAPF32[i132 >> 2]);
     i131 = i108 + i128 | 0;
     f76 = Math_fround(HEAPF32[i131 >> 2]);
     i130 = i108 + (i128 | 4) | 0;
     f70 = Math_fround(HEAPF32[i130 >> 2]);
     i129 = i108 + (i128 | 8) | 0;
     f91 = Math_fround(HEAPF32[i129 >> 2]);
     i128 = i108 + (i128 | 12) | 0;
     f82 = Math_fround(HEAPF32[i128 >> 2]);
     i18 = i108 + i21 | 0;
     f73 = Math_fround(HEAPF32[i18 >> 2]);
     i19 = i108 + (i21 | 4) | 0;
     f71 = Math_fround(HEAPF32[i19 >> 2]);
     i20 = i108 + (i21 | 8) | 0;
     f72 = Math_fround(HEAPF32[i20 >> 2]);
     i21 = i108 + (i21 | 12) | 0;
     f77 = Math_fround(HEAPF32[i21 >> 2]);
     i22 = i108 + i28 | 0;
     f84 = Math_fround(HEAPF32[i22 >> 2]);
     i24 = i108 + (i28 | 4) | 0;
     f78 = Math_fround(HEAPF32[i24 >> 2]);
     i26 = i108 + (i28 | 8) | 0;
     f98 = Math_fround(HEAPF32[i26 >> 2]);
     i28 = i108 + (i28 | 12) | 0;
     f90 = Math_fround(HEAPF32[i28 >> 2]);
     i38 = i108 + i44 | 0;
     f81 = Math_fround(HEAPF32[i38 >> 2]);
     i40 = i108 + (i44 | 4) | 0;
     f79 = Math_fround(HEAPF32[i40 >> 2]);
     i42 = i108 + (i44 | 8) | 0;
     f80 = Math_fround(HEAPF32[i42 >> 2]);
     i44 = i108 + (i44 | 12) | 0;
     f85 = Math_fround(HEAPF32[i44 >> 2]);
     i46 = i108 + i52 | 0;
     f92 = Math_fround(HEAPF32[i46 >> 2]);
     i48 = i108 + (i52 | 4) | 0;
     f86 = Math_fround(HEAPF32[i48 >> 2]);
     i50 = i108 + (i52 | 8) | 0;
     f105 = Math_fround(HEAPF32[i50 >> 2]);
     i52 = i108 + (i52 | 12) | 0;
     f104 = Math_fround(HEAPF32[i52 >> 2]);
     i62 = i108 + i100 | 0;
     f89 = Math_fround(HEAPF32[i62 >> 2]);
     i64 = i108 + (i100 | 4) | 0;
     f87 = Math_fround(HEAPF32[i64 >> 2]);
     i66 = i108 + (i100 | 8) | 0;
     f88 = Math_fround(HEAPF32[i66 >> 2]);
     i100 = i108 + (i100 | 12) | 0;
     f93 = Math_fround(HEAPF32[i100 >> 2]);
     i101 = i108 + i106 | 0;
     f96 = Math_fround(HEAPF32[i101 >> 2]);
     i102 = i108 + (i106 | 4) | 0;
     f94 = Math_fround(HEAPF32[i102 >> 2]);
     i103 = i108 + (i106 | 8) | 0;
     f95 = Math_fround(HEAPF32[i103 >> 2]);
     i106 = i108 + (i106 | 12) | 0;
     f97 = Math_fround(HEAPF32[i106 >> 2]);
     f35 = Math_fround(Math_fround(f7 * f63) + f76);
     f37 = Math_fround(Math_fround(f8 * f59) + f70);
     f39 = Math_fround(Math_fround(f9 * f61) + f91);
     f33 = Math_fround(Math_fround(f10 * f69) + f82);
     f45 = Math_fround(Math_fround(f7 * f73) + f84);
     f47 = Math_fround(Math_fround(f8 * f71) + f78);
     f49 = Math_fround(Math_fround(f9 * f72) + f98);
     f43 = Math_fround(Math_fround(f10 * f77) + f90);
     f55 = Math_fround(Math_fround(f7 * f81) + f92);
     f57 = Math_fround(Math_fround(f8 * f79) + f86);
     f83 = Math_fround(Math_fround(f9 * f80) + f105);
     f53 = Math_fround(Math_fround(f10 * f85) + f104);
     f67 = Math_fround(Math_fround(f7 * f89) + f96);
     f99 = Math_fround(Math_fround(f8 * f87) + f94);
     f65 = Math_fround(Math_fround(f9 * f88) + f95);
     f74 = Math_fround(Math_fround(f10 * f93) + f97);
     f25 = Math_fround(HEAPF32[i1 >> 2]);
     f27 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f31 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     f41 = Math_fround(Math_fround(1.0) - Math_fround(f25 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f39 * f39) + Math_fround(Math_fround(f37 * f37) + Math_fround(f11 + Math_fround(f35 * f35)))))))));
     f51 = Math_fround(Math_fround(1.0) - Math_fround(f27 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f49 * f49) + Math_fround(Math_fround(f47 * f47) + Math_fround(f12 + Math_fround(f45 * f45)))))))));
     f68 = Math_fround(Math_fround(1.0) - Math_fround(f29 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f83 * f83) + Math_fround(Math_fround(f57 * f57) + Math_fround(f13 + Math_fround(f55 * f55)))))))));
     f75 = Math_fround(Math_fround(1.0) - Math_fround(f31 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f65 * f65) + Math_fround(Math_fround(f99 * f99) + Math_fround(f14 + Math_fround(f67 * f67)))))))));
     f41 = Math_fround(f6 * (f25 > f11 ? f41 : Math_fround(0.0)));
     f51 = Math_fround(f6 * (f27 > f12 ? f51 : Math_fround(0.0)));
     f68 = Math_fround(f6 * (f29 > f13 ? f68 : Math_fround(0.0)));
     f41 = Math_fround(f41 * Math_fround(Math_fround(1.0) / Math_fround(f11 + f33)));
     f51 = Math_fround(f51 * Math_fround(Math_fround(1.0) / Math_fround(f12 + f43)));
     f68 = Math_fround(f68 * Math_fround(Math_fround(1.0) / Math_fround(f13 + f53)));
     f75 = Math_fround(Math_fround(f6 * (f31 > f14 ? f75 : Math_fround(0.0))) * Math_fround(Math_fround(1.0) / Math_fround(f14 + f74)));
     f35 = Math_fround(f35 * f41);
     f37 = Math_fround(f37 * f41);
     f39 = Math_fround(f39 * f41);
     f41 = Math_fround(f33 * f41);
     i139 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
     i138 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
     i137 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
     i136 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0) & i16;
     f45 = Math_fround(f45 * f51);
     f47 = Math_fround(f47 * f51);
     f49 = Math_fround(f49 * f51);
     f51 = Math_fround(f43 * f51);
     i127 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
     i126 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
     i125 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0) & i16;
     f55 = Math_fround(f55 * f68);
     f57 = Math_fround(f57 * f68);
     f83 = Math_fround(f83 * f68);
     f68 = Math_fround(f53 * f68);
     i30 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
     i32 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
     i34 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
     i36 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0) & i16;
     f67 = Math_fround(f67 * f75);
     f99 = Math_fround(f99 * f75);
     f65 = Math_fround(f65 * f75);
     f75 = Math_fround(f74 * f75);
     i54 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i56 = (HEAPF32[tempDoublePtr >> 2] = f99, HEAP32[tempDoublePtr >> 2] | 0);
     i58 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
     i60 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0) & i16;
     f75 = (HEAP32[tempDoublePtr >> 2] = i139 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f65 = Math_fround(f69 * f75);
     f99 = (HEAP32[tempDoublePtr >> 2] = i138 & i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f69 * f99);
     f74 = (HEAP32[tempDoublePtr >> 2] = i137 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f68 = Math_fround(f69 * f74);
     f83 = (HEAP32[tempDoublePtr >> 2] = i136, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f59 + f67);
     f68 = Math_fround(f61 + f68);
     f69 = Math_fround(f69 + Math_fround(f69 * f83));
     HEAPF32[i135 >> 2] = Math_fround(f63 + f65);
     HEAPF32[i134 >> 2] = f67;
     HEAPF32[i133 >> 2] = f68;
     HEAPF32[i132 >> 2] = f69;
     f99 = Math_fround(f70 - Math_fround(f82 * f99));
     f74 = Math_fround(f91 - Math_fround(f82 * f74));
     f83 = Math_fround(f82 - Math_fround(f82 * f83));
     HEAPF32[i131 >> 2] = Math_fround(f76 - Math_fround(f82 * f75));
     HEAPF32[i130 >> 2] = f99;
     HEAPF32[i129 >> 2] = f74;
     HEAPF32[i128 >> 2] = f83;
     f83 = (HEAP32[tempDoublePtr >> 2] = i127 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f74 = Math_fround(f77 * f83);
     f99 = (HEAP32[tempDoublePtr >> 2] = i126 & i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f75 = Math_fround(f77 * f99);
     f82 = (HEAP32[tempDoublePtr >> 2] = i125 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f76 = Math_fround(f77 * f82);
     f91 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f75 = Math_fround(f71 + f75);
     f76 = Math_fround(f72 + f76);
     f77 = Math_fround(f77 + Math_fround(f77 * f91));
     HEAPF32[i18 >> 2] = Math_fround(f73 + f74);
     HEAPF32[i19 >> 2] = f75;
     HEAPF32[i20 >> 2] = f76;
     HEAPF32[i21 >> 2] = f77;
     f99 = Math_fround(f78 - Math_fround(f90 * f99));
     f82 = Math_fround(f98 - Math_fround(f90 * f82));
     f91 = Math_fround(f90 - Math_fround(f90 * f91));
     HEAPF32[i22 >> 2] = Math_fround(f84 - Math_fround(f90 * f83));
     HEAPF32[i24 >> 2] = f99;
     HEAPF32[i26 >> 2] = f82;
     HEAPF32[i28 >> 2] = f91;
     f91 = (HEAP32[tempDoublePtr >> 2] = i30 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f82 = Math_fround(f85 * f91);
     f99 = (HEAP32[tempDoublePtr >> 2] = i32 & i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f85 * f99);
     f90 = (HEAP32[tempDoublePtr >> 2] = i34 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f85 * f90);
     f98 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f79 + f83);
     f84 = Math_fround(f80 + f84);
     f85 = Math_fround(f85 + Math_fround(f85 * f98));
     HEAPF32[i38 >> 2] = Math_fround(f81 + f82);
     HEAPF32[i40 >> 2] = f83;
     HEAPF32[i42 >> 2] = f84;
     HEAPF32[i44 >> 2] = f85;
     f99 = Math_fround(f86 - Math_fround(f104 * f99));
     f90 = Math_fround(f105 - Math_fround(f104 * f90));
     f98 = Math_fround(f104 - Math_fround(f104 * f98));
     HEAPF32[i46 >> 2] = Math_fround(f92 - Math_fround(f104 * f91));
     HEAPF32[i48 >> 2] = f99;
     HEAPF32[i50 >> 2] = f90;
     HEAPF32[i52 >> 2] = f98;
     f98 = (HEAP32[tempDoublePtr >> 2] = i54 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f90 = Math_fround(f93 * f98);
     f99 = (HEAP32[tempDoublePtr >> 2] = i56 & i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f91 = Math_fround(f93 * f99);
     f104 = (HEAP32[tempDoublePtr >> 2] = i58 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f92 = Math_fround(f93 * f104);
     f105 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f91 = Math_fround(f87 + f91);
     f92 = Math_fround(f88 + f92);
     f93 = Math_fround(f93 + Math_fround(f93 * f105));
     HEAPF32[i62 >> 2] = Math_fround(f89 + f90);
     HEAPF32[i64 >> 2] = f91;
     HEAPF32[i66 >> 2] = f92;
     HEAPF32[i100 >> 2] = f93;
     f99 = Math_fround(f94 - Math_fround(f97 * f99));
     f104 = Math_fround(f95 - Math_fround(f97 * f104));
     f105 = Math_fround(f97 - Math_fround(f97 * f105));
     HEAPF32[i101 >> 2] = Math_fround(f96 - Math_fround(f97 * f98));
     HEAPF32[i102 >> 2] = f99;
     HEAPF32[i103 >> 2] = f104;
     HEAPF32[i106 >> 2] = f105;
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i107 | 0)) break; else i2 = i2 + 16 | 0;
    }
   }
  } else i123 = 8; else i123 = 8;
  if ((i123 | 0) == 8) {
   i123 = 0;
   HEAP32[i119 >> 2] = i2;
   HEAP32[i120 >> 2] = i2;
   HEAP32[i121 >> 2] = i2;
   HEAP32[i122 >> 2] = i2;
   f105 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i4 | 0) != (i5 | 0)) {
    f92 = Math_fround(HEAPF32[gb + 1097520 >> 2]);
    f93 = Math_fround(HEAPF32[gb + 1097520 + 4 >> 2]);
    f94 = Math_fround(HEAPF32[gb + 1097520 + 8 >> 2]);
    f95 = Math_fround(HEAPF32[gb + 1097520 + 12 >> 2]);
    f96 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
    f97 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
    f98 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
    f99 = Math_fround(HEAPF32[gb + 1097504 + 12 >> 2]);
    i100 = HEAP32[gb + 1097472 >> 2] | 0;
    i101 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
    i102 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
    i103 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
    f104 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f91 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    while (1) {
     i5 = (HEAPU16[i18 >> 1] | 0) << 4;
     i20 = (HEAPU16[i18 + 2 >> 1] | 0) << 4;
     i26 = (HEAPU16[i18 + 4 >> 1] | 0) << 4;
     i34 = (HEAPU16[i18 + 6 >> 1] | 0) << 4;
     i42 = (HEAPU16[i18 + 8 >> 1] | 0) << 4;
     i50 = (HEAPU16[i18 + 10 >> 1] | 0) << 4;
     i58 = (HEAPU16[i18 + 12 >> 1] | 0) << 4;
     i66 = (HEAPU16[i18 + 14 >> 1] | 0) << 4;
     i1 = i108 + i5 | 0;
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     i2 = i108 + (i5 | 4) | 0;
     f7 = Math_fround(HEAPF32[i2 >> 2]);
     i4 = i108 + (i5 | 8) | 0;
     f8 = Math_fround(HEAPF32[i4 >> 2]);
     i5 = i108 + (i5 | 12) | 0;
     f9 = Math_fround(HEAPF32[i5 >> 2]);
     i15 = i108 + i20 | 0;
     f10 = Math_fround(HEAPF32[i15 >> 2]);
     i16 = i108 + (i20 | 4) | 0;
     f11 = Math_fround(HEAPF32[i16 >> 2]);
     i17 = i108 + (i20 | 8) | 0;
     f12 = Math_fround(HEAPF32[i17 >> 2]);
     i20 = i108 + (i20 | 12) | 0;
     f13 = Math_fround(HEAPF32[i20 >> 2]);
     i21 = i108 + i26 | 0;
     f14 = Math_fround(HEAPF32[i21 >> 2]);
     i22 = i108 + (i26 | 4) | 0;
     f23 = Math_fround(HEAPF32[i22 >> 2]);
     i24 = i108 + (i26 | 8) | 0;
     f25 = Math_fround(HEAPF32[i24 >> 2]);
     i26 = i108 + (i26 | 12) | 0;
     f27 = Math_fround(HEAPF32[i26 >> 2]);
     i28 = i108 + i34 | 0;
     f29 = Math_fround(HEAPF32[i28 >> 2]);
     i30 = i108 + (i34 | 4) | 0;
     f31 = Math_fround(HEAPF32[i30 >> 2]);
     i32 = i108 + (i34 | 8) | 0;
     f33 = Math_fround(HEAPF32[i32 >> 2]);
     i34 = i108 + (i34 | 12) | 0;
     f35 = Math_fround(HEAPF32[i34 >> 2]);
     i36 = i108 + i42 | 0;
     f37 = Math_fround(HEAPF32[i36 >> 2]);
     i38 = i108 + (i42 | 4) | 0;
     f39 = Math_fround(HEAPF32[i38 >> 2]);
     i40 = i108 + (i42 | 8) | 0;
     f41 = Math_fround(HEAPF32[i40 >> 2]);
     i42 = i108 + (i42 | 12) | 0;
     f43 = Math_fround(HEAPF32[i42 >> 2]);
     i44 = i108 + i50 | 0;
     f45 = Math_fround(HEAPF32[i44 >> 2]);
     i46 = i108 + (i50 | 4) | 0;
     f47 = Math_fround(HEAPF32[i46 >> 2]);
     i48 = i108 + (i50 | 8) | 0;
     f49 = Math_fround(HEAPF32[i48 >> 2]);
     i50 = i108 + (i50 | 12) | 0;
     f51 = Math_fround(HEAPF32[i50 >> 2]);
     i52 = i108 + i58 | 0;
     f53 = Math_fround(HEAPF32[i52 >> 2]);
     i54 = i108 + (i58 | 4) | 0;
     f55 = Math_fround(HEAPF32[i54 >> 2]);
     i56 = i108 + (i58 | 8) | 0;
     f57 = Math_fround(HEAPF32[i56 >> 2]);
     i58 = i108 + (i58 | 12) | 0;
     f59 = Math_fround(HEAPF32[i58 >> 2]);
     i60 = i108 + i66 | 0;
     f61 = Math_fround(HEAPF32[i60 >> 2]);
     i62 = i108 + (i66 | 4) | 0;
     f63 = Math_fround(HEAPF32[i62 >> 2]);
     i64 = i108 + (i66 | 8) | 0;
     f65 = Math_fround(HEAPF32[i64 >> 2]);
     i66 = i108 + (i66 | 12) | 0;
     f67 = Math_fround(HEAPF32[i66 >> 2]);
     f68 = Math_fround(Math_fround(f92 * f6) + f10);
     f69 = Math_fround(Math_fround(f93 * f7) + f11);
     f70 = Math_fround(Math_fround(f94 * f8) + f12);
     f71 = Math_fround(Math_fround(f95 * f9) + f13);
     f72 = Math_fround(Math_fround(f92 * f14) + f29);
     f73 = Math_fround(Math_fround(f93 * f23) + f31);
     f74 = Math_fround(Math_fround(f94 * f25) + f33);
     f75 = Math_fround(Math_fround(f95 * f27) + f35);
     f76 = Math_fround(Math_fround(f92 * f37) + f45);
     f77 = Math_fround(Math_fround(f93 * f39) + f47);
     f78 = Math_fround(Math_fround(f94 * f41) + f49);
     f79 = Math_fround(Math_fround(f95 * f43) + f51);
     f80 = Math_fround(Math_fround(f92 * f53) + f61);
     f81 = Math_fround(Math_fround(f93 * f55) + f63);
     f82 = Math_fround(Math_fround(f94 * f57) + f65);
     f83 = Math_fround(Math_fround(f95 * f59) + f67);
     f84 = Math_fround(HEAPF32[i19 >> 2]);
     f85 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f86 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f140 = Math_fround(HEAPF32[i19 + 12 >> 2]);
     f87 = Math_fround(Math_fround(1.0) - Math_fround(f84 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f70 * f70) + Math_fround(Math_fround(f69 * f69) + Math_fround(f96 + Math_fround(f68 * f68)))))))));
     f88 = Math_fround(Math_fround(1.0) - Math_fround(f85 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f74 * f74) + Math_fround(Math_fround(f73 * f73) + Math_fround(f97 + Math_fround(f72 * f72)))))))));
     f89 = Math_fround(Math_fround(1.0) - Math_fround(f86 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f78 * f78) + Math_fround(Math_fround(f77 * f77) + Math_fround(f98 + Math_fround(f76 * f76)))))))));
     f90 = Math_fround(Math_fround(1.0) - Math_fround(f140 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f82 * f82) + Math_fround(Math_fround(f81 * f81) + Math_fround(f99 + Math_fround(f80 * f80)))))))));
     i141 = f140 > f99 ? (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     f87 = f84 > f96 ? f87 : Math_fround(0.0);
     f142 = f104 < f87 ? f104 : f87;
     f84 = f85 > f97 ? f88 : Math_fround(0.0);
     f90 = f104 < f84 ? f104 : f84;
     f140 = f86 > f98 ? f89 : Math_fround(0.0);
     f85 = f104 < f140 ? f104 : f140;
     f88 = (HEAP32[tempDoublePtr >> 2] = i141, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i141 = f104 < f88 ? i106 : i141;
     HEAPF32[i110 >> 2] = f142;
     HEAPF32[i111 >> 2] = f90;
     HEAPF32[i112 >> 2] = f85;
     HEAP32[i113 >> 2] = i141;
     i125 = Math_fround(HEAPF32[i119 >> 2]) < f142;
     f86 = Math_fround(HEAPF32[(i125 ? i110 : i119) >> 2]);
     i125 = Math_fround(HEAPF32[i120 >> 2]) < f90;
     f90 = Math_fround(HEAPF32[(i125 ? i111 : i120) >> 2]);
     i125 = Math_fround(HEAPF32[i121 >> 2]) < f85;
     f85 = Math_fround(HEAPF32[(i125 ? i112 : i121) >> 2]);
     f89 = Math_fround(HEAPF32[i122 >> 2]);
     i141 = f89 < (HEAP32[tempDoublePtr >> 2] = i141, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(Math_fround(f91 * Math_fround(f87 - Math_fround(f105 * f86))) * Math_fround(Math_fround(1.0) / Math_fround(f96 + f71)));
     f90 = Math_fround(Math_fround(f91 * Math_fround(f84 - Math_fround(f105 * f90))) * Math_fround(Math_fround(1.0) / Math_fround(f97 + f75)));
     f85 = Math_fround(Math_fround(f91 * Math_fround(f140 - Math_fround(f105 * f85))) * Math_fround(Math_fround(1.0) / Math_fround(f98 + f79)));
     f88 = Math_fround(Math_fround(f91 * Math_fround(f88 - Math_fround(f105 * Math_fround(HEAPF32[(i141 ? i113 : i122) >> 2])))) * Math_fround(Math_fround(1.0) / Math_fround(f99 + f83)));
     f140 = Math_fround(f68 * f86);
     f84 = Math_fround(f69 * f86);
     f89 = Math_fround(f70 * f86);
     f86 = Math_fround(f71 * f86);
     i141 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
     i125 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
     i126 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
     i127 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0) & i103;
     f86 = Math_fround(f72 * f90);
     f89 = Math_fround(f73 * f90);
     f84 = Math_fround(f74 * f90);
     f90 = Math_fround(f75 * f90);
     i128 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
     i129 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
     i130 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
     i131 = (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0) & i103;
     f90 = Math_fround(f76 * f85);
     f84 = Math_fround(f77 * f85);
     f89 = Math_fround(f78 * f85);
     f85 = Math_fround(f79 * f85);
     i132 = (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0);
     i133 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
     i134 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
     i135 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0) & i103;
     f85 = Math_fround(f80 * f88);
     f89 = Math_fround(f81 * f88);
     f84 = Math_fround(f82 * f88);
     f88 = Math_fround(f83 * f88);
     i136 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
     i137 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
     i138 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
     i139 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0) & i103;
     f88 = (HEAP32[tempDoublePtr >> 2] = i141 & i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f9 * f88);
     f89 = (HEAP32[tempDoublePtr >> 2] = i125 & i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f9 * f89);
     f90 = (HEAP32[tempDoublePtr >> 2] = i126 & i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(f9 * f90);
     f140 = (HEAP32[tempDoublePtr >> 2] = i127, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f7 + f85);
     f86 = Math_fround(f8 + f86);
     f87 = Math_fround(f9 + Math_fround(f9 * f140));
     HEAPF32[i1 >> 2] = Math_fround(f6 + f84);
     HEAPF32[i2 >> 2] = f85;
     HEAPF32[i4 >> 2] = f86;
     HEAPF32[i5 >> 2] = f87;
     f89 = Math_fround(f11 - Math_fround(f13 * f89));
     f90 = Math_fround(f12 - Math_fround(f13 * f90));
     f140 = Math_fround(f13 - Math_fround(f13 * f140));
     HEAPF32[i15 >> 2] = Math_fround(f10 - Math_fround(f13 * f88));
     HEAPF32[i16 >> 2] = f89;
     HEAPF32[i17 >> 2] = f90;
     HEAPF32[i20 >> 2] = f140;
     f140 = (HEAP32[tempDoublePtr >> 2] = i128 & i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f90 = Math_fround(f27 * f140);
     f89 = (HEAP32[tempDoublePtr >> 2] = i129 & i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f88 = Math_fround(f27 * f89);
     f87 = (HEAP32[tempDoublePtr >> 2] = i130 & i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(f27 * f87);
     f85 = (HEAP32[tempDoublePtr >> 2] = i131, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f88 = Math_fround(f23 + f88);
     f86 = Math_fround(f25 + f86);
     f84 = Math_fround(f27 + Math_fround(f27 * f85));
     HEAPF32[i21 >> 2] = Math_fround(f14 + f90);
     HEAPF32[i22 >> 2] = f88;
     HEAPF32[i24 >> 2] = f86;
     HEAPF32[i26 >> 2] = f84;
     f89 = Math_fround(f31 - Math_fround(f35 * f89));
     f87 = Math_fround(f33 - Math_fround(f35 * f87));
     f85 = Math_fround(f35 - Math_fround(f35 * f85));
     HEAPF32[i28 >> 2] = Math_fround(f29 - Math_fround(f35 * f140));
     HEAPF32[i30 >> 2] = f89;
     HEAPF32[i32 >> 2] = f87;
     HEAPF32[i34 >> 2] = f85;
     f85 = (HEAP32[tempDoublePtr >> 2] = i132 & i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f87 = Math_fround(f43 * f85);
     f89 = (HEAP32[tempDoublePtr >> 2] = i133 & i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f140 = Math_fround(f43 * f89);
     f84 = (HEAP32[tempDoublePtr >> 2] = i134 & i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(f43 * f84);
     f88 = (HEAP32[tempDoublePtr >> 2] = i135, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f140 = Math_fround(f39 + f140);
     f86 = Math_fround(f41 + f86);
     f90 = Math_fround(f43 + Math_fround(f43 * f88));
     HEAPF32[i36 >> 2] = Math_fround(f37 + f87);
     HEAPF32[i38 >> 2] = f140;
     HEAPF32[i40 >> 2] = f86;
     HEAPF32[i42 >> 2] = f90;
     f89 = Math_fround(f47 - Math_fround(f51 * f89));
     f84 = Math_fround(f49 - Math_fround(f51 * f84));
     f88 = Math_fround(f51 - Math_fround(f51 * f88));
     HEAPF32[i44 >> 2] = Math_fround(f45 - Math_fround(f51 * f85));
     HEAPF32[i46 >> 2] = f89;
     HEAPF32[i48 >> 2] = f84;
     HEAPF32[i50 >> 2] = f88;
     f88 = (HEAP32[tempDoublePtr >> 2] = i136 & i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f59 * f88);
     f89 = (HEAP32[tempDoublePtr >> 2] = i137 & i101, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f59 * f89);
     f90 = (HEAP32[tempDoublePtr >> 2] = i138 & i102, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(f59 * f90);
     f140 = (HEAP32[tempDoublePtr >> 2] = i139, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f55 + f85);
     f86 = Math_fround(f57 + f86);
     f87 = Math_fround(f59 + Math_fround(f59 * f140));
     HEAPF32[i52 >> 2] = Math_fround(f53 + f84);
     HEAPF32[i54 >> 2] = f85;
     HEAPF32[i56 >> 2] = f86;
     HEAPF32[i58 >> 2] = f87;
     f89 = Math_fround(f63 - Math_fround(f67 * f89));
     f90 = Math_fround(f65 - Math_fround(f67 * f90));
     f140 = Math_fround(f67 - Math_fround(f67 * f140));
     HEAPF32[i60 >> 2] = Math_fround(f61 - Math_fround(f67 * f88));
     HEAPF32[i62 >> 2] = f89;
     HEAPF32[i64 >> 2] = f90;
     HEAPF32[i66 >> 2] = f140;
     i19 = i19 + 16 | 0;
     if ((i19 | 0) == (i107 | 0)) break; else i18 = i18 + 16 | 0;
    }
   }
  }
  i3 = i3 + 20 | 0;
 } while ((i3 | 0) != (i116 | 0));
 STACKTOP = i124;
 return;
}

function __ZN14PlayerSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 28 | 0, i10);
 i1 = i9 + 280 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 284 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 292 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 296 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 96 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 100 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 112 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 116 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 268 | 0, i10);
 i1 = i9 + 272 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 276 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN26PlayerSettingsSplashScreen8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 144 | 0, i10);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 264 | 0, i10);
 i1 = i9 + 300 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 304 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 308 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 312 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 328 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 332 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 336 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 337 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i4 = i9 + 352 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 340 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i9 + 364 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 360 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 316 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 376 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 377 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 378 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 379 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 380 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 381 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 382 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 384 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 386 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 387 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 388 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 389 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 390 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 391 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 392 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 393 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 394 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 412 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 413 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 395 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 414 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 415 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 416 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 417 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 418 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 419 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 424 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 396 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 397 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 400 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 1;
 i1 = i9 + 404 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 408 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 420 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 425 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 426 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 427 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 428 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 429 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 430 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 383 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 385 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 432 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 436 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 440 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 444 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 448 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 452 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 504 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 508 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 512 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 513 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 514 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 515 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 516 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 517 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 520 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN12AspectRatios8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 320 | 0, i10);
 i6 = i9 + 556 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 560 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 572 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 576 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i4 = i9 + 616 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 604 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i5 = i9 + 624 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i9 + 628 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 629 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 630 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 44 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 48 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 64 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 68 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 80 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 84 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 60 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  STACKTOP = i13;
  return;
 }
}
function __ZN7mecanim5human12RetargetFromEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_SD_PKNS6_7_float3E(i27, i1, i31, i15, i21, i16, i17, i14) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 i15 = i15 | 0;
 i21 = i21 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f18 = f0, f19 = f0, f20 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f28 = f0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, f46 = f0, f47 = f0, f48 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i32;
 i24 = HEAP32[i27 + 72 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i27 + 360 >> 2]);
 i29 = i27 + 40 | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i30 = i29;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i2 | 0) == 0 ? 0 : i2 + i30 | 0, i1, i15);
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(i15, i21);
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(i1, i16);
 i2 = HEAP32[i29 >> 2] | 0;
 i3 = i2 + i30 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) > 1) {
  i5 = i21 + 4 | 0;
  i6 = i5;
  i7 = i27 + 44 | 0;
  i8 = i7;
  i9 = i3 + 4 | 0;
  i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
  i1 = 1;
  do {
   if ((HEAP32[i9 + (i1 << 3) + 4 >> 2] | 0) == -1) {
    i26 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    i33 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
    i25 = (HEAP32[i7 >> 2] | 0) + i8 + 4 | 0;
    i25 = i25 + (HEAP32[i25 >> 2] | 0) | 0;
    f12 = Math_fround(HEAPF32[i26 + (i33 * 40 | 0) + 16 >> 2]);
    f35 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 12 >> 2]);
    f13 = Math_fround(f12 * f35);
    f10 = Math_fround(HEAPF32[i26 + (i33 * 40 | 0) + 24 >> 2]);
    f19 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 24 >> 2]);
    f20 = Math_fround(f10 * f19);
    f34 = Math_fround(HEAPF32[i26 + (i33 * 40 | 0) + 20 >> 2]);
    f11 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 16 >> 2]);
    f18 = Math_fround(f34 * f11);
    f37 = Math_fround(HEAPF32[i26 + (i33 * 40 | 0) + 12 >> 2]);
    f36 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 20 >> 2]);
    f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f10 * f36)) - Math_fround(f19 * f34)) - Math_fround(f11 * f37));
    f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f35 * f37)) - Math_fround(f34 * f36)) - Math_fround(f12 * f11));
    f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f12 * f36)) - Math_fround(f35 * f10)) - Math_fround(f19 * f37));
    f19 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f36) - Math_fround(f35 * f34)) - Math_fround(f10 * f11)) - Math_fround(f12 * f19));
    i25 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    i33 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    HEAP32[i26 + (i1 * 40 | 0) + 12 >> 2] = i33 ^ -2147483648;
    HEAP32[i26 + (i1 * 40 | 0) + 16 >> 2] = i23;
    HEAP32[i26 + (i1 * 40 | 0) + 20 >> 2] = i25 ^ -2147483648;
    HEAPF32[i26 + (i1 * 40 | 0) + 24 >> 2] = f20;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_((i2 | 0) == 0 ? 0 : i3, i21, i16);
 if ((i14 | 0) != 0 & (HEAP8[i27 + 394 >> 0] | 0) != 0) {
  i23 = i16 + 4 | 0;
  i23 = (HEAP32[i23 >> 2] | 0) + i23 | 0;
  i33 = i23;
  HEAP32[i23 >> 2] = 0;
  i23 = i33 + 4 | 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  HEAP32[i23 + 12 >> 2] = 0;
  HEAP32[i23 + 16 >> 2] = 0;
  HEAP32[i33 + 24 >> 2] = 1065353216;
  HEAP32[i33 + 28 >> 2] = 1065353216;
  HEAP32[i33 + 32 >> 2] = 1065353216;
  HEAP32[i33 + 36 >> 2] = 1065353216;
  i23 = i15 + 4 | 0;
  i23 = (HEAP32[i23 >> 2] | 0) + i23 | 0;
  i26 = HEAP32[i23 + (i24 * 40 | 0) + 4 >> 2] | 0;
  i9 = HEAP32[i23 + (i24 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i33 + (i24 * 40 | 0) >> 2] = HEAP32[i23 + (i24 * 40 | 0) >> 2];
  HEAP32[i33 + (i24 * 40 | 0) + 4 >> 2] = i26;
  HEAP32[i33 + (i24 * 40 | 0) + 8 >> 2] = i9;
  i9 = HEAP32[i23 + (i24 * 40 | 0) + 16 >> 2] | 0;
  i26 = HEAP32[i23 + (i24 * 40 | 0) + 20 >> 2] | 0;
  i25 = HEAP32[i23 + (i24 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i33 + (i24 * 40 | 0) + 12 >> 2] = HEAP32[i23 + (i24 * 40 | 0) + 12 >> 2];
  HEAP32[i33 + (i24 * 40 | 0) + 16 >> 2] = i9;
  HEAP32[i33 + (i24 * 40 | 0) + 20 >> 2] = i26;
  HEAP32[i33 + (i24 * 40 | 0) + 24 >> 2] = i25;
  i25 = HEAP32[i23 + (i24 * 40 | 0) + 32 >> 2] | 0;
  i26 = HEAP32[i23 + (i24 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i33 + (i24 * 40 | 0) + 28 >> 2] = HEAP32[i23 + (i24 * 40 | 0) + 28 >> 2];
  HEAP32[i33 + (i24 * 40 | 0) + 32 >> 2] = i25;
  HEAP32[i33 + (i24 * 40 | 0) + 36 >> 2] = i26;
  __ZN7mecanim5human16RetargetFromTDoFEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3EPNS0_9HumanPoseEPS8_SG_(i27, i15, i14, i31, i16, i21);
 }
 i1 = i27 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 11, 11);
 i2 = i27 + 120 | 0;
 if ((HEAP32[i2 >> 2] | 0) != -1) __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 12, 12);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 13, (HEAP32[i1 >> 2] | 0) != -1 ? 11 : 13);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 14, (HEAP32[i2 >> 2] | 0) != -1 ? 12 : 14);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 1, 1);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 2, 2);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 15, 13);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 16, 14);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 3, 1);
 __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i27, i15, i31, i21, i16, 4, 2);
 __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 13, 15, Math_fround(.100000001), 10);
 __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 14, 16, Math_fround(.100000001), 10);
 __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 1, 3, Math_fround(.100000001), 10);
 __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 2, 4, Math_fround(.100000001), 10);
 __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseE(i27, i16, i31);
 __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i27, i31, i16);
 i4 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i4 | 0) == 0 ? 0 : i4 + i30 | 0, i16, i21);
 __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii(i27, i15, i21, i16, 5, 1);
 __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii(i27, i15, i21, i16, 6, 2);
 __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii(i27, i15, i21, i16, 17, 13);
 __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii(i27, i15, i21, i16, 18, 14);
 i4 = i21 + 4 | 0;
 i2 = HEAP32[i27 + 140 >> 2] | 0;
 i5 = i4;
 i3 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i25 = i15 + 4 | 0;
 i26 = i25;
 i15 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 i23 = HEAP32[i15 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i33 = HEAP32[i15 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i1 = HEAP32[i15 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i15 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] = i23;
 HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] = i33;
 HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] = i1;
 i3 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i30 | 0, i21, i16, i2, i2);
 i2 = HEAP32[i27 + 144 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i1 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 i33 = HEAP32[i1 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i23 = HEAP32[i1 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i15 = HEAP32[i1 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i1 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] = i33;
 HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] = i15;
 i3 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i30 | 0, i21, i16, i2, i2);
 i2 = HEAP32[i27 + 92 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i15 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 i23 = HEAP32[i15 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i33 = HEAP32[i15 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i1 = HEAP32[i15 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i15 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] = i23;
 HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] = i33;
 HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] = i1;
 i3 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i30 | 0, i21, i16, i2, i2);
 i2 = HEAP32[i27 + 96 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i1 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 i33 = HEAP32[i1 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i23 = HEAP32[i1 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i15 = HEAP32[i1 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i1 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] = i33;
 HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] = i15;
 i3 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i30 | 0, i21, i16, i2, i2);
 i2 = HEAP32[i27 + 112 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i15 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 i23 = HEAP32[i15 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i33 = HEAP32[i15 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i1 = HEAP32[i15 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i15 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] = i23;
 HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] = i33;
 HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] = i1;
 i3 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i30 | 0, i21, i16, i2, i2);
 __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 15, 17, Math_fround(.100000001), 5);
 __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 16, 18, Math_fround(.100000001), 5);
 __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 3, 5, Math_fround(.100000001), 5);
 __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i27, i16, i17, 4, 6, Math_fround(.100000001), 5);
 __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseE(i27, i16, i31);
 i2 = i27 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i3 | 0) == 0 ? 0 : i3 + i2 | 0, i16);
 __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i27, i31, i16);
 i2 = HEAP32[i29 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i2 | 0) == 0 ? 0 : i2 + i30 | 0, i16, i21);
 i2 = i22 + 4 | 0;
 i3 = i22 + 8 | 0;
 f10 = Math_fround(0.0);
 i1 = 0;
 f11 = Math_fround(0.0);
 f12 = Math_fround(0.0);
 f13 = Math_fround(0.0);
 do {
  if ((HEAP32[i27 + 72 + (i1 << 2) >> 2] | 0) > -1) {
   f36 = Math_fround(HEAPF32[i27 + 168 + (i1 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i22, i27, i21, i1);
   f35 = Math_fround(HEAPF32[i22 >> 2]);
   f37 = Math_fround(HEAPF32[i2 >> 2]);
   f10 = Math_fround(f10 + f36);
   f11 = Math_fround(f11 + Math_fround(f36 * f35));
   f12 = Math_fround(f12 + Math_fround(f36 * Math_fround(HEAPF32[i3 >> 2])));
   f13 = Math_fround(f13 + Math_fround(f36 * f37));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 f36 = Math_fround(f11 / f10);
 f41 = Math_fround(f13 / f10);
 f19 = Math_fround(f12 / f10);
 __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i22, i27, i21);
 i21 = HEAP32[i22 >> 2] | 0;
 i33 = HEAP32[i22 + 4 >> 2] | 0;
 i23 = HEAP32[i22 + 8 >> 2] | 0;
 i14 = HEAP32[i22 + 12 >> 2] | 0;
 HEAPF32[i31 >> 2] = f36;
 i15 = i31 + 4 | 0;
 HEAPF32[i15 >> 2] = f41;
 i16 = i31 + 8 | 0;
 HEAPF32[i16 >> 2] = f19;
 i17 = i31 + 12 | 0;
 HEAP32[i17 >> 2] = i21;
 i21 = i31 + 16 | 0;
 HEAP32[i21 >> 2] = i33;
 i22 = i31 + 20 | 0;
 HEAP32[i22 >> 2] = i23;
 i23 = i31 + 24 | 0;
 HEAP32[i23 >> 2] = i14;
 i14 = i31 + 28 | 0;
 HEAP32[i14 >> 2] = 1065353216;
 i33 = i31 + 32 | 0;
 HEAP32[i33 >> 2] = 1065353216;
 i2 = i31 + 36 | 0;
 HEAP32[i2 >> 2] = 1065353216;
 i9 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 f39 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) >> 2]);
 f42 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 4 >> 2]);
 f11 = Math_fround(f36 - f11);
 f42 = Math_fround(f41 - f42);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 8 >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i24 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i24 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i24 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f41 * Math_fround(-2.0));
 f43 = Math_fround(f41 * Math_fround(2.0));
 f18 = Math_fround(f39 * f13);
 f37 = Math_fround(f12 * Math_fround(2.0));
 f20 = Math_fround(f12 * Math_fround(-2.0));
 f35 = Math_fround(f39 * f20);
 f38 = Math_fround(f36 * Math_fround(-2.0));
 f10 = Math_fround(f36 * Math_fround(2.0));
 f44 = Math_fround(f39 * f38);
 f40 = Math_fround(Math_fround(f11 + Math_fround(Math_fround(Math_fround(f41 * f13) - Math_fround(f12 * f37)) * f11)) + Math_fround(Math_fround(Math_fround(f35 - Math_fround(f41 * f38)) * f42) + Math_fround(Math_fround(Math_fround(f10 * f12) - f18) * f19)));
 f13 = Math_fround(Math_fround(f42 + Math_fround(Math_fround(Math_fround(f36 * f43) - f35) * f11)) + Math_fround(Math_fround(Math_fround(Math_fround(f12 * f20) - Math_fround(f36 * f10)) * f42) + Math_fround(Math_fround(f44 - Math_fround(f12 * f13)) * f19)));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f18 - Math_fround(f36 * f20)) * f11) + f19) + Math_fround(Math_fround(Math_fround(Math_fround(f41 * f37) - f44) * f42) + Math_fround(Math_fround(Math_fround(f36 * f38) - Math_fround(f41 * f43)) * f19)));
 f43 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 28 >> 2]);
 f38 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 32 >> 2]);
 f42 = Math_fround(HEAPF32[i9 + (i24 * 40 | 0) + 36 >> 2]);
 i9 = Math_fround(Math_abs(Math_fround(f43))) < Math_fround(9.99999971e-10);
 i7 = Math_fround(Math_abs(Math_fround(f38))) < Math_fround(9.99999971e-10);
 i8 = Math_fround(Math_abs(Math_fround(f42))) < Math_fround(9.99999971e-10);
 f43 = Math_fround(Math_fround(1.0) / f43);
 f43 = i9 ? Math_fround(1.0) : f43;
 f38 = Math_fround(Math_fround(1.0) / f38);
 f38 = i7 ? Math_fround(1.0) : f38;
 f42 = Math_fround(Math_fround(1.0) / f42);
 f42 = i8 ? Math_fround(1.0) : f42;
 f40 = Math_fround(f40 * f43);
 f13 = Math_fround(f13 * f38);
 f19 = Math_fround(f19 * f42);
 f44 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f37 = Math_fround(f41 * f44);
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f20 = Math_fround(f39 * f11);
 f18 = Math_fround(HEAPF32[i21 >> 2]);
 f10 = Math_fround(f12 * f18);
 f35 = Math_fround(HEAPF32[i22 >> 2]);
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f39 * f35)) - Math_fround(f12 * f11)) - Math_fround(f36 * f18));
 f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f36 * f44)) - Math_fround(f12 * f35)) - Math_fround(f41 * f18));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f41 * f35)) - Math_fround(f39 * f44)) - Math_fround(f36 * f11));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f12 * f44)) - Math_fround(f39 * f18)) - Math_fround(f41 * f11));
 i8 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = i7 ^ -2147483648;
 i9 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i8 = i8 ^ -2147483648;
 f11 = Math_fround(HEAPF32[i31 + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i33 >> 2]);
 f11 = Math_fround(f43 * f11);
 f10 = Math_fround(f38 * f10);
 f42 = Math_fround(f42 * Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i31 >> 2] = f40;
 HEAPF32[i15 >> 2] = f13;
 HEAPF32[i16 >> 2] = f19;
 HEAP32[i17 >> 2] = i7;
 HEAP32[i21 >> 2] = i9;
 HEAP32[i22 >> 2] = i8;
 HEAPF32[i23 >> 2] = f20;
 HEAPF32[i14 >> 2] = f11;
 HEAPF32[i33 >> 2] = f10;
 HEAPF32[i2 >> 2] = f42;
 i6 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
 f42 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 32 >> 2]);
 f42 = Math_fround(f40 * f42);
 f10 = Math_fround(f13 * f10);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 36 >> 2]));
 f13 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 16 >> 2]);
 f40 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 24 >> 2]);
 f38 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 20 >> 2]);
 f43 = Math_fround(f13 * Math_fround(-2.0));
 f37 = Math_fround(f13 * Math_fround(2.0));
 f41 = Math_fround(f43 * f11);
 f18 = Math_fround(f38 * Math_fround(2.0));
 f39 = Math_fround(f38 * Math_fround(-2.0));
 f44 = Math_fround(f11 * f39);
 f12 = Math_fround(f40 * Math_fround(-2.0));
 f35 = Math_fround(f40 * Math_fround(2.0));
 f36 = Math_fround(f11 * f12);
 f34 = Math_fround(Math_fround(f42 + Math_fround(f42 * Math_fround(Math_fround(f13 * f43) - Math_fround(f38 * f18)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f35 * f38) - f41)) + Math_fround(f10 * Math_fround(f44 - Math_fround(f13 * f12)))));
 f35 = Math_fround(Math_fround(f10 + Math_fround(f42 * Math_fround(Math_fround(f40 * f37) - f44))) + Math_fround(Math_fround(f19 * Math_fround(f36 - Math_fround(f43 * f38))) + Math_fround(f10 * Math_fround(Math_fround(f38 * f39) - Math_fround(f40 * f35)))));
 f36 = Math_fround(Math_fround(f19 + Math_fround(f42 * Math_fround(f41 - Math_fround(f40 * f39)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f40 * f12) - Math_fround(f13 * f37))) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - f36))));
 f18 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) >> 2]);
 f10 = Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 4 >> 2]);
 f34 = Math_fround(f18 + f34);
 f35 = Math_fround(f10 + f35);
 f36 = Math_fround(Math_fround(HEAPF32[i6 + (i24 * 40 | 0) + 8 >> 2]) + f36);
 f10 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(f13 * f10);
 f37 = Math_fround(f11 * f20);
 f12 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(f38 * f12);
 f39 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f11 * f39)) - Math_fround(f38 * f20)) - Math_fround(f40 * f12));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f40 * f10)) - Math_fround(f38 * f39)) - Math_fround(f13 * f12));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f13 * f39)) - Math_fround(f11 * f10)) - Math_fround(f40 * f20));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) - Math_fround(f38 * f10)) - Math_fround(f11 * f12)) - Math_fround(f13 * f20));
 i24 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i31 >> 2] = f34;
 HEAPF32[i15 >> 2] = f35;
 HEAPF32[i16 >> 2] = f36;
 HEAP32[i17 >> 2] = i8 ^ -2147483648;
 HEAP32[i21 >> 2] = i9;
 HEAP32[i22 >> 2] = i24 ^ -2147483648;
 HEAPF32[i23 >> 2] = f37;
 HEAP32[i14 >> 2] = 1065353216;
 HEAP32[i33 >> 2] = 1065353216;
 HEAP32[i2 >> 2] = 1065353216;
 i2 = 0;
 do {
  i5 = HEAP32[i27 + 72 + (HEAP32[gb + 179492 + (i2 << 4) >> 2] << 2) >> 2] | 0;
  i1 = i31 + 68 + (i2 << 6) | 0;
  i7 = (HEAP32[i25 >> 2] | 0) + i26 | 0;
  i4 = HEAP32[i7 + (i5 * 40 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i7 + (i5 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i7 + (i5 * 40 | 0) >> 2];
  i3 = i31 + 68 + (i2 << 6) + 4 | 0;
  HEAP32[i3 >> 2] = i4;
  i4 = i31 + 68 + (i2 << 6) + 8 | 0;
  HEAP32[i4 >> 2] = i6;
  i6 = (HEAP32[i29 >> 2] | 0) + i30 | 0;
  i8 = i6 + 16 | 0;
  i6 = i6 + 4 | 0;
  i6 = HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
  i8 = i8 + (HEAP32[i8 >> 2] | 0) | 0;
  f40 = Math_fround(HEAPF32[i8 + (i6 * 76 | 0) + 16 >> 2]);
  f42 = Math_fround(HEAPF32[i8 + (i6 * 76 | 0) + 20 >> 2]);
  f38 = Math_fround(HEAPF32[i8 + (i6 * 76 | 0) + 24 >> 2]);
  f44 = Math_fround(HEAPF32[i8 + (i6 * 76 | 0) + 28 >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 16 >> 2]);
  f18 = Math_fround(f40 * f13);
  f19 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 24 >> 2]);
  f20 = Math_fround(f44 * f19);
  f41 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 20 >> 2]);
  f43 = Math_fround(f42 * f41);
  f39 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 12 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f38 * f19)) - Math_fround(f44 * f41)) - Math_fround(f42 * f39));
  f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f40 * f39)) - Math_fround(f38 * f41)) - Math_fround(f42 * f13));
  f43 = Math_fround(Math_fround(Math_fround(f43 - Math_fround(f38 * f13)) - Math_fround(f40 * f19)) - Math_fround(f44 * f39));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f40 * f41)) - Math_fround(f42 * f19)) - Math_fround(f44 * f13));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f13 = (HEAP32[tempDoublePtr >> 2] = i7 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = Math_fround(f13 * f13);
  f18 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = Math_fround(f18 * f18);
  f19 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f19 * f19)) + Math_fround(f43 + f44)))));
  f13 = Math_fround(f44 * f13);
  f18 = Math_fround(f44 * f18);
  f19 = Math_fround(f44 * f19);
  f20 = Math_fround(f44 * f20);
  HEAPF32[i31 + 68 + (i2 << 6) + 12 >> 2] = f13;
  i5 = i31 + 68 + (i2 << 6) + 16 | 0;
  HEAPF32[i5 >> 2] = f18;
  i6 = i31 + 68 + (i2 << 6) + 20 | 0;
  HEAPF32[i6 >> 2] = f19;
  i7 = i31 + 68 + (i2 << 6) + 24 | 0;
  HEAPF32[i7 >> 2] = f20;
  i8 = i31 + 68 + (i2 << 6) + 28 | 0;
  HEAP32[i8 >> 2] = 1065353216;
  i9 = i31 + 68 + (i2 << 6) + 32 | 0;
  HEAP32[i9 >> 2] = 1065353216;
  i14 = i31 + 68 + (i2 << 6) + 36 | 0;
  HEAP32[i14 >> 2] = 1065353216;
  if ((i2 | 0) < 2) {
   i33 = (HEAP32[i29 >> 2] | 0) + i30 | 0;
   i24 = i33 + 16 | 0;
   i33 = i33 + 4 | 0;
   f39 = Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + i24 + ((HEAP32[i33 + (HEAP32[i33 >> 2] | 0) + (HEAP32[i27 + 72 + (((i2 | 0) == 0 ? 5 : 6) << 2) >> 2] << 3) + 4 >> 2] | 0) * 76 | 0) + 68 >> 2]);
   f38 = Math_fround(f18 * Math_fround(-2.0));
   f44 = Math_fround(f18 * Math_fround(2.0));
   f40 = Math_fround(f38 * f20);
   f43 = Math_fround(f19 * Math_fround(2.0));
   f41 = Math_fround(f19 * Math_fround(-2.0));
   f37 = Math_fround(f20 * f41);
   f42 = Math_fround(f13 * Math_fround(-2.0));
   f11 = Math_fround(f13 * Math_fround(2.0));
   f12 = Math_fround(f20 * f42);
   f10 = Math_fround(Math_fround(f39 + Math_fround(f39 * Math_fround(Math_fround(f18 * f38) - Math_fround(f19 * f43)))) + Math_fround(Math_fround(Math_fround(Math_fround(f11 * f19) - f40) * Math_fround(0.0)) + Math_fround(Math_fround(f37 - Math_fround(f18 * f42)) * Math_fround(0.0))));
   f11 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(Math_fround(f13 * f44) - f37)) + Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(f12 - Math_fround(f38 * f19)) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(f19 * f41) - Math_fround(f13 * f11)) * Math_fround(0.0))));
   f12 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(f40 - Math_fround(f13 * f41))) + Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(Math_fround(f13 * f42) - Math_fround(f18 * f44)) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(f18 * f43) - f12) * Math_fround(0.0))));
   f43 = Math_fround(HEAPF32[i1 >> 2]);
   f44 = Math_fround(HEAPF32[i3 >> 2]);
   f10 = Math_fround(f43 + f10);
   f11 = Math_fround(f44 + f11);
   f12 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f12);
   HEAPF32[i1 >> 2] = f10;
   HEAPF32[i3 >> 2] = f11;
   HEAPF32[i4 >> 2] = f12;
  } else {
   f10 = Math_fround(HEAPF32[i1 >> 2]);
   f11 = Math_fround(HEAPF32[i3 >> 2]);
   f12 = Math_fround(HEAPF32[i4 >> 2]);
  }
  f37 = Math_fround(HEAPF32[i23 >> 2]);
  f44 = Math_fround(HEAPF32[i31 >> 2]);
  f39 = Math_fround(HEAPF32[i15 >> 2]);
  f10 = Math_fround(f10 - f44);
  f39 = Math_fround(f11 - f39);
  f44 = Math_fround(f12 - Math_fround(HEAPF32[i16 >> 2]));
  f40 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i17 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i22 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = Math_fround(f40 * Math_fround(-2.0));
  f38 = Math_fround(f40 * Math_fround(2.0));
  f46 = Math_fround(f37 * f43);
  f12 = Math_fround(f36 * Math_fround(2.0));
  f11 = Math_fround(f36 * Math_fround(-2.0));
  f48 = Math_fround(f37 * f11);
  f41 = Math_fround(f35 * Math_fround(-2.0));
  f47 = Math_fround(f35 * Math_fround(2.0));
  f34 = Math_fround(f37 * f41);
  f42 = Math_fround(Math_fround(f10 + Math_fround(Math_fround(Math_fround(f40 * f43) - Math_fround(f36 * f12)) * f10)) + Math_fround(Math_fround(Math_fround(f48 - Math_fround(f40 * f41)) * f39) + Math_fround(Math_fround(Math_fround(f47 * f36) - f46) * f44)));
  f43 = Math_fround(Math_fround(f39 + Math_fround(Math_fround(Math_fround(f35 * f38) - f48) * f10)) + Math_fround(Math_fround(Math_fround(Math_fround(f36 * f11) - Math_fround(f35 * f47)) * f39) + Math_fround(Math_fround(f34 - Math_fround(f36 * f43)) * f44)));
  f44 = Math_fround(Math_fround(Math_fround(Math_fround(f46 - Math_fround(f35 * f11)) * f10) + f44) + Math_fround(Math_fround(Math_fround(Math_fround(f40 * f12) - f34) * f39) + Math_fround(Math_fround(Math_fround(f35 * f41) - Math_fround(f40 * f38)) * f44)));
  f38 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f13) - Math_fround(f37 * f19)) - Math_fround(f36 * f20)) - Math_fround(f35 * f18));
  f41 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f20) - Math_fround(f35 * f13)) - Math_fround(f36 * f19)) - Math_fround(f40 * f18));
  f39 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f18) - Math_fround(f40 * f19)) - Math_fround(f37 * f13)) - Math_fround(f35 * f20));
  f40 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f19) - Math_fround(f36 * f13)) - Math_fround(f37 * f18)) - Math_fround(f40 * f20));
  i33 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAP32[i31 + 68 + (i2 << 6) + 12 >> 2] = i45 ^ -2147483648;
  HEAP32[i5 >> 2] = i24;
  HEAP32[i6 >> 2] = i33 ^ -2147483648;
  HEAPF32[i7 >> 2] = f41;
  HEAP32[i8 >> 2] = 1065353216;
  HEAP32[i9 >> 2] = 1065353216;
  HEAP32[i14 >> 2] = 1065353216;
  f43 = Math_fround(f43 / f28);
  f44 = Math_fround(f44 / f28);
  HEAPF32[i1 >> 2] = Math_fround(f42 / f28);
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f44;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 4);
 f46 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) / f28);
 f47 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) / f28);
 f48 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) / f28);
 HEAPF32[i31 >> 2] = f46;
 HEAPF32[i15 >> 2] = f47;
 HEAPF32[i16 >> 2] = f48;
 STACKTOP = i32;
 return;
}

function __ZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE(i123, i124, i32, i33, i127, i131, f119, i135, i136, i111, i112) {
 i123 = i123 | 0;
 i124 = i124 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i127 = i127 | 0;
 i131 = i131 | 0;
 f119 = Math_fround(f119);
 i135 = i135 | 0;
 i136 = i136 | 0;
 i111 = i111 | 0;
 i112 = i112 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, f94 = f0, f95 = f0, f96 = f0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i120 = 0, i121 = 0, i122 = 0, i125 = 0, i126 = 0, i128 = 0, i129 = 0, i130 = 0, i132 = 0, i133 = 0, i134 = 0, i137 = 0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0;
 i137 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i107 = i137 + 208 | 0;
 i118 = i137 + 1032 | 0;
 i122 = i137 + 1028 | 0;
 i126 = i137 + 1024 | 0;
 i114 = i137 + 1012 | 0;
 i117 = i137 + 928 | 0;
 i49 = i137 + 1e3 | 0;
 i50 = i137 + 876 | 0;
 i17 = i137 + 804 | 0;
 i15 = i137 + 888 | 0;
 i16 = i137 + 816 | 0;
 i22 = i137 + 744 | 0;
 i5 = i137 + 600 | 0;
 i10 = i137 + 572 | 0;
 i21 = i137 + 560 | 0;
 i134 = i137 + 544 | 0;
 i20 = i137 + 528 | 0;
 i115 = i137 + 32 | 0;
 i116 = i137;
 i48 = i137 + 516 | 0;
 i47 = i137 + 504 | 0;
 i133 = i137 + 488 | 0;
 i132 = i137 + 472 | 0;
 i51 = i137 + 464 | 0;
 i44 = i137 + 452 | 0;
 i45 = i137 + 440 | 0;
 i46 = i137 + 428 | 0;
 i125 = i137 + 416 | 0;
 i129 = i137 + 412 | 0;
 i113 = i137 + 664 | 0;
 i120 = i137 + 400 | 0;
 i121 = i137 + 388 | 0;
 i130 = i137 + 376 | 0;
 i128 = i137 + 64 | 0;
 i108 = i137 + 304 | 0;
 i109 = i137 + 288 | 0;
 i18 = HEAP32[i124 >> 2] | 0;
 i110 = i18 + 36 | 0;
 i9 = i18 + 40 | 0;
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i117, i9, i18 + 52 | 0);
 i26 = i123 + 12 | 0;
 i52 = i123 + 28 | 0;
 f95 = Math_fround(HEAPF32[i123 + 56 >> 2]);
 f95 = Math_fround(f95 - Math_fround(HEAPF32[i52 >> 2]));
 f96 = Math_fround(HEAPF32[i123 + 60 >> 2]);
 i53 = i123 + 32 | 0;
 f96 = Math_fround(f96 - Math_fround(HEAPF32[i53 >> 2]));
 f1 = Math_fround(HEAPF32[i123 + 64 >> 2]);
 i54 = i123 + 36 | 0;
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i54 >> 2]));
 HEAPF32[i49 >> 2] = f95;
 HEAPF32[i49 + 4 >> 2] = f96;
 HEAPF32[i49 + 8 >> 2] = f1;
 i11 = i124 + 40 | 0;
 i29 = i124 + 12 | 0;
 i12 = i124 + 56 | 0;
 f8 = Math_fround(HEAPF32[i12 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i124 + 28 >> 2]));
 i13 = i124 + 60 | 0;
 f41 = Math_fround(HEAPF32[i13 >> 2]);
 i30 = i124 + 32 | 0;
 f41 = Math_fround(f41 - Math_fround(HEAPF32[i30 >> 2]));
 i14 = i124 + 64 | 0;
 f42 = Math_fround(HEAPF32[i14 >> 2]);
 i31 = i124 + 36 | 0;
 f42 = Math_fround(f42 - Math_fround(HEAPF32[i31 >> 2]));
 HEAPF32[i50 >> 2] = f8;
 HEAPF32[i50 + 4 >> 2] = f41;
 HEAPF32[i50 + 8 >> 2] = f42;
 f8 = Math_fround(f95 - f8);
 f41 = Math_fround(f96 - f41);
 f42 = Math_fround(f1 - f42);
 HEAPF32[i17 >> 2] = f8;
 i3 = i17 + 4 | 0;
 HEAPF32[i3 >> 2] = f41;
 i4 = i17 + 8 | 0;
 HEAPF32[i4 >> 2] = f42;
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f41 * f41)) + Math_fround(f42 * f42))));
 if (f1 > Math_fround(0.0)) {
  f96 = Math_fround(Math_fround(1.0) / f1);
  HEAPF32[i17 >> 2] = Math_fround(f8 * f96);
  HEAPF32[i3 >> 2] = Math_fround(f41 * f96);
  HEAPF32[i4 >> 2] = Math_fround(f42 * f96);
 }
 f56 = Math_fround(HEAPF32[i26 >> 2]);
 i23 = i123 + 16 | 0;
 f2 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i123 + 20 | 0;
 f55 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = i123 + 24 | 0;
 f6 = Math_fround(HEAPF32[i25 >> 2]);
 f95 = Math_fround(f56 + f56);
 f94 = Math_fround(f2 + f2);
 f138 = Math_fround(f55 + f55);
 f56 = Math_fround(f56 * f95);
 f96 = Math_fround(f2 * f94);
 f7 = Math_fround(f55 * f138);
 f2 = Math_fround(f95 * f2);
 f57 = Math_fround(f95 * f55);
 f95 = Math_fround(f95 * f6);
 f55 = Math_fround(f94 * f55);
 f94 = Math_fround(f94 * f6);
 f6 = Math_fround(f138 * f6);
 f138 = Math_fround(f2 + f6);
 f43 = Math_fround(f57 - f94);
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f96) - f7);
 HEAPF32[i15 + 4 >> 2] = f138;
 HEAPF32[i15 + 8 >> 2] = f43;
 f56 = Math_fround(Math_fround(1.0) - f56);
 f7 = Math_fround(f56 - f7);
 f43 = Math_fround(f55 + f95);
 HEAPF32[i15 + 12 >> 2] = Math_fround(f2 - f6);
 HEAPF32[i15 + 16 >> 2] = f7;
 HEAPF32[i15 + 20 >> 2] = f43;
 f95 = Math_fround(f55 - f95);
 f96 = Math_fround(f56 - f96);
 HEAPF32[i15 + 24 >> 2] = Math_fround(f57 + f94);
 HEAPF32[i15 + 28 >> 2] = f95;
 HEAPF32[i15 + 32 >> 2] = f96;
 i27 = i123 + 68 | 0;
 i28 = i123 + 80 | 0;
 __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i16, i27, i28, i15, i17, f1);
 if (Math_fround(HEAPF32[i9 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i18 + 44 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i18 + 48 >> 2]) == Math_fround(1.0)) {
  f57 = Math_fround(HEAPF32[i12 >> 2]);
  f56 = Math_fround(HEAPF32[i13 >> 2]);
  f57 = Math_fround(f57 * Math_fround(-2.0));
  f56 = Math_fround(f56 * Math_fround(-2.0));
  f43 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(-2.0));
  f138 = Math_fround(HEAPF32[i124 + 52 >> 2]);
  f55 = Math_fround(Math_fround(f138 * f138) + Math_fround(-.5));
  f94 = Math_fround(HEAPF32[i11 >> 2]);
  f1 = Math_fround(f57 * f94);
  f95 = Math_fround(HEAPF32[i124 + 44 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f56 * f95));
  f96 = Math_fround(HEAPF32[i124 + 48 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f43 * f96));
  f6 = Math_fround(Math_fround(f94 * f1) + Math_fround(Math_fround(f57 * f55) - Math_fround(f138 * Math_fround(Math_fround(f43 * f95) - Math_fround(f56 * f96)))));
  f2 = Math_fround(Math_fround(f95 * f1) + Math_fround(Math_fround(f56 * f55) - Math_fround(f138 * Math_fround(Math_fround(f57 * f96) - Math_fround(f43 * f94)))));
  f1 = Math_fround(Math_fround(Math_fround(f43 * f55) - Math_fround(f138 * Math_fround(Math_fround(f56 * f94) - Math_fround(f57 * f95)))) + Math_fround(f96 * f1));
  f95 = Math_fround(-f95);
  f96 = Math_fround(-f96);
  HEAPF32[i10 >> 2] = Math_fround(-f94);
  HEAPF32[i10 + 4 >> 2] = f95;
  HEAPF32[i10 + 8 >> 2] = f96;
  HEAPF32[i10 + 12 >> 2] = f138;
  HEAPF32[i10 + 16 >> 2] = f6;
  HEAPF32[i10 + 20 >> 2] = f2;
  HEAPF32[i10 + 24 >> 2] = f1;
  __ZN5physx23transformBoxOrthonormalERKNS_2Gu3BoxERKNS_11PxTransformE(i5, i16, i10);
  HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i22 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i22 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i22 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP32[i22 + 32 >> 2] = HEAP32[i5 + 32 >> 2];
  HEAP32[i22 + 36 >> 2] = HEAP32[i5 + 36 >> 2];
  HEAP32[i22 + 40 >> 2] = HEAP32[i5 + 40 >> 2];
  HEAP32[i22 + 44 >> 2] = HEAP32[i5 + 44 >> 2];
  i104 = HEAP32[i5 + 48 >> 2] | 0;
  HEAP32[i22 + 48 >> 2] = i104;
  i105 = HEAP32[i5 + 52 >> 2] | 0;
  i3 = i22 + 52 | 0;
  HEAP32[i3 >> 2] = i105;
  i106 = HEAP32[i5 + 56 >> 2] | 0;
  i4 = i22 + 56 | 0;
  HEAP32[i4 >> 2] = i106;
  f1 = (HEAP32[tempDoublePtr >> 2] = i104, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i105, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = i22 + 48 | 0;
  f6 = (HEAP32[tempDoublePtr >> 2] = i106, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } else i19 = 7; else i19 = 7; else i19 = 7;
 if ((i19 | 0) == 7) {
  __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i22, i16, i11, i9);
  i5 = i22 + 48 | 0;
  f1 = Math_fround(HEAPF32[i5 >> 2]);
  i3 = i22 + 52 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  i106 = i22 + 56 | 0;
  i4 = i106;
  f6 = Math_fround(HEAPF32[i106 >> 2]);
 }
 HEAPF32[i5 >> 2] = Math_fround(f1 + f119);
 HEAPF32[i3 >> 2] = Math_fround(f2 + f119);
 HEAPF32[i4 >> 2] = Math_fround(f6 + f119);
 i105 = i18 + 76 | 0;
 i3 = HEAP32[i105 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i21 + 4 >> 2] = i3 + 32;
 HEAP32[i21 + 8 >> 2] = HEAP32[i3 + 20 >> 2];
 __ZN5physx2Gu9ContainerC2Ev(i134);
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i134, 64, i3, 1);
 HEAP32[i20 + 4 >> 2] = 2;
 HEAP32[i20 >> 2] = gb + 103272 + 8;
 HEAP32[i20 + 8 >> 2] = i134;
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i22, 1, i21, i20, 1);
 i12 = i134 + 4 | 0;
 i36 = HEAP32[i12 >> 2] | 0;
 if (!i36) {
  f138 = Math_fround(3402823469999999843913219.0e14);
  __ZN5physx2Gu9ContainerD2Ev(i134);
  STACKTOP = i137;
  return Math_fround(f138);
 }
 i37 = HEAP32[i134 + 8 >> 2] | 0;
 i101 = HEAP32[(HEAP32[i123 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i115 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i25 >> 2];
 i38 = i115 + 16 | 0;
 HEAP32[i38 >> 2] = HEAP32[i52 >> 2];
 i39 = i115 + 20 | 0;
 HEAP32[i39 >> 2] = HEAP32[i53 >> 2];
 i40 = i115 + 24 | 0;
 HEAP32[i40 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i116 >> 2] = HEAP32[i131 >> 2];
 i103 = i131 + 4 | 0;
 i3 = i116 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i103 >> 2];
 i106 = i131 + 8 | 0;
 i4 = i116 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i106 >> 2];
 i104 = i131 + 12 | 0;
 i5 = i116 + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i104 >> 2];
 i9 = i116 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i131 + 16 >> 2];
 i34 = i131 + 20 | 0;
 i10 = i116 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[i34 >> 2];
 i35 = i131 + 24 | 0;
 i11 = i116 + 24 | 0;
 HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
 i13 = (i33 | 0) != 0;
 if (i13) if (!(Math_fround(HEAPF32[(HEAP32[i33 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0))) {
  HEAP32[i116 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i124 + 16 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i124 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i124 + 24 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i124 + 28 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i31 >> 2];
 }
 HEAP32[i48 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i123 + 84 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i123 + 88 >> 2];
 f95 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f119);
 f96 = Math_fround(Math_fround(HEAPF32[i123 + 72 >> 2]) + f119);
 f138 = Math_fround(Math_fround(HEAPF32[i123 + 76 >> 2]) + f119);
 HEAPF32[i47 >> 2] = f95;
 HEAPF32[i47 + 4 >> 2] = f96;
 HEAPF32[i47 + 8 >> 2] = f138;
 __ZN5physx2Gu9ContainerC2Ev(i133);
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i133, 64, i3, 1);
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i133 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 + i4 | 0) >>> 0 > (HEAP32[i133 >> 2] | 0) >>> 0) {
  __ZN5physx2Gu9Container6ResizeEj(i133, i4) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i3 + i4;
 __ZN5physx2Gu9ContainerC2Ev(i132);
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i132, 64, i3, 1);
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i132 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 + i4 | 0) >>> 0 > (HEAP32[i132 >> 2] | 0) >>> 0) {
  __ZN5physx2Gu9Container6ResizeEj(i132, i4) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i3 + i4;
 i102 = HEAP32[i133 + 8 >> 2] | 0;
 i28 = HEAP32[i132 + 8 >> 2] | 0;
 i100 = (i32 | 0) != 0;
 i29 = i123 + 8 | 0;
 f6 = Math_fround(HEAPF32[i29 >> 2]);
 f6 = i100 ? f6 : Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i124 + 8 >> 2]);
 f7 = i13 ? f7 : Math_fround(0.0);
 if (i100) f2 = Math_fround(HEAPF32[(HEAP32[i32 + 60 >> 2] | 0) + 4 >> 2]); else f2 = Math_fround(1.0);
 if (i13) f1 = Math_fround(HEAPF32[(HEAP32[i33 + 60 >> 2] | 0) + 4 >> 2]); else f1 = Math_fround(1.0);
 f6 = Math_fround((f6 > f7 ? f6 : f7) * (f2 < f1 ? f2 : f1));
 i10 = i107 + 4 | 0;
 i11 = i107 + 8 | 0;
 i12 = i107 + 12 | 0;
 i13 = i107 + 16 | 0;
 i14 = i107 + 40 | 0;
 i15 = i107 + 44 | 0;
 i16 = i107 + 48 | 0;
 i17 = i107 + 52 | 0;
 i18 = i107 + 56 | 0;
 i19 = i107 + 60 | 0;
 i20 = i107 + 64 | 0;
 i21 = i44 + 4 | 0;
 i22 = i44 + 8 | 0;
 i23 = i45 + 4 | 0;
 i24 = i45 + 8 | 0;
 i25 = i46 + 4 | 0;
 i26 = i46 + 8 | 0;
 i27 = 0;
 i3 = 0;
 while (1) {
  i9 = i37 + (i27 << 2) | 0;
  HEAP32[i107 >> 2] = i110;
  HEAP32[i10 >> 2] = i117;
  HEAP32[i11 >> 2] = i9;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i13 >> 2] = i51;
  HEAP32[i14 >> 2] = 2122317823;
  HEAP32[i15 >> 2] = 2122317823;
  HEAP32[i16 >> 2] = 2122317823;
  HEAP32[i17 >> 2] = -25165825;
  HEAP32[i18 >> 2] = -25165825;
  HEAP32[i19 >> 2] = -25165825;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP8[i20 + 12 >> 0] = 0;
  __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj(i44, i107, 0);
  f94 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) * Math_fround(2.0));
  f56 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(2.0));
  f55 = Math_fround(HEAPF32[i104 >> 2]);
  f43 = Math_fround(Math_fround(f55 * f55) + Math_fround(-.5));
  f57 = Math_fround(HEAPF32[i131 >> 2]);
  f138 = Math_fround(f94 * f57);
  f95 = Math_fround(HEAPF32[i103 >> 2]);
  f138 = Math_fround(f138 + Math_fround(f56 * f95));
  f96 = Math_fround(HEAPF32[i106 >> 2]);
  f138 = Math_fround(f138 + Math_fround(f7 * f96));
  if (Math_fround(Math_fround(Math_fround(-Math_fround(f41 * Math_fround(Math_fround(f95 * f138) + Math_fround(Math_fround(f56 * f43) + Math_fround(f55 * Math_fround(Math_fround(f94 * f96) - Math_fround(f7 * f57))))))) - Math_fround(f8 * Math_fround(Math_fround(f57 * f138) + Math_fround(Math_fround(f94 * f43) + Math_fround(f55 * Math_fround(Math_fround(f7 * f95) - Math_fround(f56 * f96))))))) - Math_fround(f42 * Math_fround(Math_fround(Math_fround(f7 * f43) + Math_fround(f55 * Math_fround(Math_fround(f56 * f57) - Math_fround(f94 * f95)))) + Math_fround(f96 * f138)))) >= f6) {
   __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE(i107, i116);
   f96 = Math_fround(HEAPF32[i14 >> 2]);
   f138 = Math_fround(HEAPF32[i15 >> 2]);
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   f95 = Math_fround(HEAPF32[i17 >> 2]);
   f57 = Math_fround(HEAPF32[i18 >> 2]);
   f94 = Math_fround(HEAPF32[i19 >> 2]);
   f55 = Math_fround(Math_fround(f138 + f57) * Math_fround(.5));
   f56 = Math_fround(Math_fround(f2 + f94) * Math_fround(.5));
   HEAPF32[i45 >> 2] = Math_fround(Math_fround(f96 + f95) * Math_fround(.5));
   HEAPF32[i23 >> 2] = f55;
   HEAPF32[i24 >> 2] = f56;
   f138 = Math_fround(Math_fround(Math_fround(f57 - f138) * Math_fround(.5)) + Math_fround(.0199999996));
   f2 = Math_fround(Math_fround(Math_fround(f94 - f2) * Math_fround(.5)) + Math_fround(.0199999996));
   HEAPF32[i46 >> 2] = Math_fround(Math_fround(Math_fround(f95 - f96) * Math_fround(.5)) + Math_fround(.0199999996));
   HEAPF32[i25 >> 2] = f138;
   HEAPF32[i26 >> 2] = f2;
   f2 = Math_fround(__Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i48, i47, i45, i46, i49, i50));
   if (f2 <= Math_fround(1.0)) {
    L35 : do if (!i3) i4 = 0; else {
     i5 = i3;
     while (1) {
      i4 = i5;
      i5 = i5 + -1 | 0;
      f1 = Math_fround(HEAPF32[i28 + (i5 << 2) >> 2]);
      if (f1 <= f2) break L35;
      HEAPF32[i28 + (i4 << 2) >> 2] = f1;
      HEAP32[i102 + (i4 << 2) >> 2] = HEAP32[i102 + (i5 << 2) >> 2];
      if (!i5) {
       i4 = 0;
       break;
      }
     }
    } while (0);
    HEAP32[i102 + (i4 << 2) >> 2] = HEAP32[i9 >> 2];
    HEAPF32[i28 + (i4 << 2) >> 2] = f2;
    i3 = i3 + 1 | 0;
   }
  }
  i27 = i27 + 1 | 0;
  if ((i27 | 0) == (i36 | 0)) {
   i100 = i3;
   break;
  }
 }
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 i99 = i112 + 8744 | 0;
 HEAP32[i99 >> 2] = -1;
 f42 = Math_fround(HEAPF32[i52 >> 2]);
 f95 = Math_fround(HEAPF32[i53 >> 2]);
 f43 = Math_fround(HEAPF32[i54 >> 2]);
 f138 = Math_fround(HEAPF32[i131 + 16 >> 2]);
 f42 = Math_fround(f42 - f138);
 f57 = Math_fround(HEAPF32[i34 >> 2]);
 f95 = Math_fround(f95 - f57);
 f55 = Math_fround(HEAPF32[i35 >> 2]);
 f42 = Math_fround(f42 * Math_fround(2.0));
 f95 = Math_fround(f95 * Math_fround(2.0));
 f43 = Math_fround(Math_fround(f43 - f55) * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i104 >> 2]);
 f56 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f7 = Math_fround(HEAPF32[i131 >> 2]);
 f41 = Math_fround(f42 * f7);
 f6 = Math_fround(HEAPF32[i103 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f95 * f6));
 f2 = Math_fround(HEAPF32[i106 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f43 * f2));
 f94 = Math_fround(Math_fround(f6 * f41) + Math_fround(Math_fround(f95 * f56) - Math_fround(f8 * Math_fround(Math_fround(f42 * f2) - Math_fround(f43 * f7)))));
 f96 = Math_fround(Math_fround(Math_fround(f43 * f56) - Math_fround(f8 * Math_fround(Math_fround(f95 * f7) - Math_fround(f42 * f6)))) + Math_fround(f2 * f41));
 HEAPF32[i125 >> 2] = Math_fround(Math_fround(f7 * f41) + Math_fround(Math_fround(f42 * f56) - Math_fround(f8 * Math_fround(Math_fround(f43 * f6) - Math_fround(f95 * f2)))));
 i97 = i125 + 4 | 0;
 HEAPF32[i97 >> 2] = f94;
 i98 = i125 + 8 | 0;
 HEAPF32[i98 >> 2] = f96;
 f138 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) - f138);
 f57 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) - f57);
 f138 = Math_fround(f138 * Math_fround(2.0));
 f57 = Math_fround(f57 * Math_fround(2.0));
 f55 = Math_fround(Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f55) * Math_fround(2.0));
 f96 = Math_fround(Math_fround(Math_fround(f138 * f7) + Math_fround(f57 * f6)) + Math_fround(f55 * f2));
 f94 = Math_fround(Math_fround(f7 * f96) + Math_fround(Math_fround(f138 * f56) - Math_fround(f8 * Math_fround(Math_fround(f55 * f6) - Math_fround(f57 * f2)))));
 f95 = Math_fround(Math_fround(f6 * f96) + Math_fround(Math_fround(f57 * f56) - Math_fround(f8 * Math_fround(Math_fround(f138 * f2) - Math_fround(f55 * f7)))));
 f96 = Math_fround(Math_fround(Math_fround(f55 * f56) - Math_fround(f8 * Math_fround(Math_fround(f57 * f7) - Math_fround(f138 * f6)))) + Math_fround(f2 * f96));
 if (!i100) {
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i11 = 0;
  i10 = 0;
  i9 = 0;
  f1 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i51 = i113 + 4 | 0;
  i52 = i113 + 8 | 0;
  i53 = i113 + 12 | 0;
  i54 = i113 + 16 | 0;
  i58 = i113 + 40 | 0;
  i59 = i113 + 44 | 0;
  i60 = i113 + 48 | 0;
  i61 = i113 + 52 | 0;
  i62 = i113 + 56 | 0;
  i63 = i113 + 60 | 0;
  i64 = i113 + 64 | 0;
  i65 = i117 + 4 | 0;
  i66 = i117 + 8 | 0;
  i67 = i117 + 12 | 0;
  i68 = i117 + 16 | 0;
  i69 = i117 + 20 | 0;
  i70 = i117 + 24 | 0;
  i71 = i117 + 28 | 0;
  i72 = i117 + 32 | 0;
  i73 = i130 + 4 | 0;
  i74 = i130 + 8 | 0;
  i75 = i128 + 64 | 0;
  i76 = i128 + 80 | 0;
  i77 = i128 + 16 | 0;
  i78 = i128 + 32 | 0;
  i79 = i128 + 48 | 0;
  i80 = i128 + 4 | 0;
  i81 = i128 + 8 | 0;
  i82 = i128 + 12 | 0;
  i83 = i128 + 100 | 0;
  i84 = i128 + 104 | 0;
  i85 = i128 + 108 | 0;
  i86 = i128 + 112 | 0;
  i87 = i128 + 116 | 0;
  i88 = i128 + 120 | 0;
  i89 = i128 + 124 | 0;
  i90 = i128 + 128 | 0;
  i91 = i128 + 132 | 0;
  i92 = i128 + 136 | 0;
  i93 = i128 + 140 | 0;
  i20 = HEAP32[gb + 103160 + (i101 << 2) >> 2] | 0;
  i21 = i108 + 36 | 0;
  i22 = i108 + 4 | 0;
  i23 = i108 + 8 | 0;
  i24 = i108 + 12 | 0;
  i25 = i108 + 16 | 0;
  i26 = i108 + 20 | 0;
  i27 = i108 + 24 | 0;
  i28 = i108 + 28 | 0;
  i29 = i108 + 32 | 0;
  i30 = i108 + 40 | 0;
  i31 = i108 + 44 | 0;
  i32 = i108 + 48 | 0;
  i33 = i108 + 52 | 0;
  i34 = i108 + 56 | 0;
  i35 = i108 + 60 | 0;
  i36 = i108 + 64 | 0;
  i37 = i108 + 68 | 0;
  i38 = i109 + 4 | 0;
  i39 = i109 + 8 | 0;
  i40 = i121 + 4 | 0;
  i44 = i121 + 8 | 0;
  i45 = i107 + 4 | 0;
  i46 = i107 + 8 | 0;
  i47 = i118 + 4 | 0;
  i48 = i118 + 8 | 0;
  i49 = i114 + 4 | 0;
  i50 = i114 + 8 | 0;
  f55 = Math_fround(f1 + f119);
  f56 = Math_fround(f55 * f55);
  f57 = Math_fround(f55 * Math_fround(2.0));
  i18 = i128 + 96 | 0;
  i9 = 0;
  i10 = 0;
  i11 = 0;
  i5 = 0;
  i4 = 0;
  i3 = 0;
  f1 = Math_fround(3402823469999999843913219.0e14);
  i19 = 0;
  do {
   i17 = i102 + (i19 << 2) | 0;
   HEAP32[i113 >> 2] = i110;
   HEAP32[i51 >> 2] = i117;
   HEAP32[i52 >> 2] = i17;
   HEAP32[i53 >> 2] = 1;
   HEAP32[i54 >> 2] = i129;
   HEAP32[i58 >> 2] = 2122317823;
   HEAP32[i59 >> 2] = 2122317823;
   HEAP32[i60 >> 2] = 2122317823;
   HEAP32[i61 >> 2] = -25165825;
   HEAP32[i62 >> 2] = -25165825;
   HEAP32[i63 >> 2] = -25165825;
   HEAP32[i64 >> 2] = 0;
   HEAP32[i64 + 4 >> 2] = 0;
   HEAP32[i64 + 8 >> 2] = 0;
   HEAP8[i64 + 12 >> 0] = 0;
   i101 = HEAP32[i105 >> 2] | 0;
   i12 = HEAP32[i17 >> 2] | 0;
   i13 = HEAP32[i101 + 12 >> 2] | 0;
   i16 = HEAP32[i101 + 8 >> 2] | 0;
   if (!(HEAP8[i101 + 156 >> 0] & 2)) {
    i14 = HEAP32[i13 + (i12 * 12 | 0) + 4 >> 2] | 0;
    i15 = HEAP32[i13 + (i12 * 12 | 0) >> 2] | 0;
    i12 = HEAP32[i13 + (i12 * 12 | 0) + 8 >> 2] | 0;
   } else {
    i14 = HEAPU16[i13 + (i12 * 6 | 0) + 2 >> 1] | 0;
    i15 = HEAPU16[i13 + (i12 * 6 | 0) >> 1] | 0;
    i12 = HEAPU16[i13 + (i12 * 6 | 0) + 4 >> 1] | 0;
   }
   f6 = Math_fround(HEAPF32[i16 + (i15 * 12 | 0) >> 2]);
   f146 = Math_fround(HEAPF32[i117 >> 2]);
   f139 = Math_fround(f6 * f146);
   f145 = Math_fround(HEAPF32[i65 >> 2]);
   f2 = Math_fround(f6 * f145);
   f140 = Math_fround(HEAPF32[i66 >> 2]);
   f6 = Math_fround(f6 * f140);
   f43 = Math_fround(HEAPF32[i16 + (i15 * 12 | 0) + 4 >> 2]);
   f143 = Math_fround(HEAPF32[i67 >> 2]);
   f42 = Math_fround(f43 * f143);
   f142 = Math_fround(HEAPF32[i68 >> 2]);
   f41 = Math_fround(f43 * f142);
   f8 = Math_fround(HEAPF32[i69 >> 2]);
   f42 = Math_fround(f139 + f42);
   f41 = Math_fround(f2 + f41);
   f43 = Math_fround(f6 + Math_fround(f43 * f8));
   f6 = Math_fround(HEAPF32[i16 + (i15 * 12 | 0) + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i70 >> 2]);
   f139 = Math_fround(f6 * f2);
   f7 = Math_fround(HEAPF32[i71 >> 2]);
   f138 = Math_fround(f6 * f7);
   f141 = Math_fround(HEAPF32[i72 >> 2]);
   f139 = Math_fround(f42 + f139);
   f138 = Math_fround(f41 + f138);
   f6 = Math_fround(f43 + Math_fround(f6 * f141));
   HEAPF32[i130 >> 2] = f139;
   HEAPF32[i73 >> 2] = f138;
   HEAPF32[i74 >> 2] = f6;
   f43 = Math_fround(HEAPF32[i16 + (i14 * 12 | 0) >> 2]);
   f41 = Math_fround(f43 * f146);
   f42 = Math_fround(f43 * f145);
   f43 = Math_fround(f43 * f140);
   f144 = Math_fround(HEAPF32[i16 + (i14 * 12 | 0) + 4 >> 2]);
   f41 = Math_fround(f41 + Math_fround(f144 * f143));
   f42 = Math_fround(f42 + Math_fround(f144 * f142));
   f144 = Math_fround(f43 + Math_fround(f144 * f8));
   f43 = Math_fround(HEAPF32[i16 + (i14 * 12 | 0) + 8 >> 2]);
   f41 = Math_fround(f41 + Math_fround(f43 * f2));
   f42 = Math_fround(f42 + Math_fround(f43 * f7));
   f43 = Math_fround(f144 + Math_fround(f43 * f141));
   f144 = Math_fround(HEAPF32[i16 + (i12 * 12 | 0) >> 2]);
   f146 = Math_fround(f146 * f144);
   f145 = Math_fround(f145 * f144);
   f144 = Math_fround(f140 * f144);
   f140 = Math_fround(HEAPF32[i16 + (i12 * 12 | 0) + 4 >> 2]);
   f143 = Math_fround(f146 + Math_fround(f143 * f140));
   f142 = Math_fround(f145 + Math_fround(f142 * f140));
   f140 = Math_fround(f144 + Math_fround(f8 * f140));
   f8 = Math_fround(HEAPF32[i16 + (i12 * 12 | 0) + 8 >> 2]);
   f2 = Math_fround(f143 + Math_fround(f2 * f8));
   f7 = Math_fround(f142 + Math_fround(f7 * f8));
   f8 = Math_fround(f140 + Math_fround(f141 * f8));
   HEAP32[i76 >> 2] = 7;
   HEAPF32[i79 >> 2] = Math_fround(0.0);
   HEAP32[i107 >> 2] = 0;
   HEAP32[i107 + 4 >> 2] = 0;
   HEAP32[i107 + 8 >> 2] = 0;
   HEAP32[i107 + 12 >> 2] = 0;
   HEAP32[i75 >> 2] = HEAP32[i107 >> 2];
   HEAP32[i75 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
   HEAP32[i75 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
   HEAP32[i75 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
   f141 = Math_fround(Math_fround(f7 + Math_fround(f42 + f138)) * Math_fround(.333332986));
   f140 = Math_fround(Math_fround(f8 + Math_fround(f43 + f6)) * Math_fround(.333332986));
   HEAPF32[i128 >> 2] = Math_fround(Math_fround(f2 + Math_fround(f41 + f139)) * Math_fround(.333332986));
   HEAPF32[i80 >> 2] = f141;
   HEAPF32[i81 >> 2] = f140;
   HEAPF32[i82 >> 2] = Math_fround(0.0);
   HEAPF32[i18 >> 2] = f139;
   HEAPF32[i83 >> 2] = f138;
   HEAPF32[i84 >> 2] = f6;
   HEAPF32[i85 >> 2] = Math_fround(0.0);
   HEAPF32[i86 >> 2] = f41;
   HEAPF32[i87 >> 2] = f42;
   HEAPF32[i88 >> 2] = f43;
   HEAPF32[i89 >> 2] = Math_fround(0.0);
   HEAPF32[i90 >> 2] = f2;
   HEAPF32[i91 >> 2] = f7;
   HEAPF32[i92 >> 2] = f8;
   HEAPF32[i93 >> 2] = Math_fround(0.0);
   HEAPF32[i77 >> 2] = Math_fround(0.0);
   HEAPF32[i78 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAP32[i108 >> 2] = 1065353216;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i25 >> 2] = 1065353216;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i29 >> 2] = 1065353216;
   HEAP32[i21 >> 2] = 1065353216;
   HEAP32[i30 >> 2] = 0;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i33 >> 2] = 1065353216;
   HEAP32[i34 >> 2] = 0;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i36 >> 2] = 0;
   HEAP32[i37 >> 2] = 1065353216;
   f6 = Math_fround(+mftCall_fiiiiiifiiiiiif(i20 | 0, i123 | 0, i124 | 0, i127 | 0, i131 | 0, i115 | 0, i116 | 0, +f119, i120 | 0, i121 | 0, i111 | 0, i112 | 0, i108 | 0, i128 | 0, 0.0));
   if (f6 <= Math_fround(0.0)) {
    f144 = Math_fround(HEAPF32[i130 >> 2]);
    f139 = Math_fround(f41 - f144);
    f146 = Math_fround(HEAPF32[i73 >> 2]);
    f140 = Math_fround(f42 - f146);
    f145 = Math_fround(HEAPF32[i74 >> 2]);
    f141 = Math_fround(f43 - f145);
    f2 = Math_fround(f2 - f144);
    f142 = Math_fround(f7 - f146);
    f143 = Math_fround(f8 - f145);
    f7 = Math_fround(Math_fround(f140 * f143) - Math_fround(f142 * f141));
    f8 = Math_fround(Math_fround(f2 * f141) - Math_fround(f139 * f143));
    f41 = Math_fround(Math_fround(f139 * f142) - Math_fround(f2 * f140));
    f140 = Math_fround(f140 + f146);
    f141 = Math_fround(f141 + f145);
    HEAPF32[i107 >> 2] = Math_fround(f139 + f144);
    HEAPF32[i45 >> 2] = f140;
    HEAPF32[i46 >> 2] = f141;
    f146 = Math_fround(f142 + f146);
    f145 = Math_fround(f143 + f145);
    HEAPF32[i118 >> 2] = Math_fround(f2 + f144);
    HEAPF32[i47 >> 2] = f146;
    HEAPF32[i48 >> 2] = f145;
    __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i114, i125, i130, i107, i118, i122, i126);
    f145 = Math_fround(HEAPF32[i114 >> 2]);
    f145 = Math_fround(f145 - Math_fround(HEAPF32[i125 >> 2]));
    f146 = Math_fround(HEAPF32[i49 >> 2]);
    f146 = Math_fround(f146 - Math_fround(HEAPF32[i97 >> 2]));
    f2 = Math_fround(HEAPF32[i50 >> 2]);
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i98 >> 2]));
    f2 = Math_fround(Math_fround(Math_fround(f145 * f145) + Math_fround(f146 * f146)) + Math_fround(f2 * f2));
    if (f2 < f56) {
     f2 = Math_fround(Math_sqrt(Math_fround(f2)));
     f6 = Math_fround(f2 - f55);
     f146 = Math_fround(f7 * Math_fround(HEAPF32[i130 >> 2]));
     f146 = Math_fround(f146 + Math_fround(f8 * Math_fround(HEAPF32[i73 >> 2])));
     if (Math_fround(Math_fround(Math_fround(f96 * f41) + Math_fround(Math_fround(f94 * f7) + Math_fround(f95 * f8))) - Math_fround(f146 + Math_fround(f41 * Math_fround(HEAPF32[i74 >> 2])))) > Math_fround(0.0)) f6 = Math_fround(-Math_fround(f57 - f2));
    }
   }
   if (f6 < f1) {
    __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj(i109, i113, 0);
    i5 = HEAP32[i109 >> 2] | 0;
    i4 = HEAP32[i38 >> 2] | 0;
    i3 = HEAP32[i39 >> 2] | 0;
    i9 = HEAP32[i121 >> 2] | 0;
    i10 = HEAP32[i40 >> 2] | 0;
    i11 = HEAP32[i44 >> 2] | 0;
    HEAP32[i99 >> 2] = HEAP32[i17 >> 2];
    f1 = f6;
   }
   i19 = i19 + 1 | 0;
  } while ((i19 | 0) != (i100 | 0));
  f8 = Math_fround(HEAPF32[i104 >> 2]);
  f7 = Math_fround(HEAPF32[i131 >> 2]);
  f6 = Math_fround(HEAPF32[i103 >> 2]);
  f2 = Math_fround(HEAPF32[i106 >> 2]);
 }
 f141 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f144 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f143 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
 f142 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f140 = Math_fround(Math_fround(Math_fround(f141 * f7) + Math_fround(f144 * f6)) + Math_fround(f143 * f2));
 f145 = Math_fround(Math_fround(f6 * f140) + Math_fround(Math_fround(f144 * f142) + Math_fround(f8 * Math_fround(Math_fround(f141 * f2) - Math_fround(f143 * f7)))));
 f146 = Math_fround(Math_fround(Math_fround(f143 * f142) + Math_fround(f8 * Math_fround(Math_fround(f144 * f7) - Math_fround(f141 * f6)))) + Math_fround(f2 * f140));
 HEAPF32[i135 >> 2] = Math_fround(Math_fround(f7 * f140) + Math_fround(Math_fround(f141 * f142) + Math_fround(f8 * Math_fround(Math_fround(f143 * f6) - Math_fround(f144 * f2)))));
 HEAPF32[i135 + 4 >> 2] = f145;
 HEAPF32[i135 + 8 >> 2] = f146;
 HEAP32[i136 >> 2] = i9;
 HEAP32[i136 + 4 >> 2] = i10;
 HEAP32[i136 + 8 >> 2] = i11;
 __ZN5physx2Gu9ContainerD2Ev(i132);
 __ZN5physx2Gu9ContainerD2Ev(i133);
 f146 = f1;
 __ZN5physx2Gu9ContainerD2Ev(i134);
 STACKTOP = i137;
 return Math_fround(f146);
}

function __ZN5physx20PxcContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i5, i11, i2, i10, i52, i1, i74) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i52 = i52 | 0;
 i1 = i1 | 0;
 i74 = i74 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i71 = i75 + 296 | 0;
 i72 = i75 + 284 | 0;
 i73 = i75 + 272 | 0;
 i70 = i75 + 256 | 0;
 i68 = i75 + 248 | 0;
 i69 = i75 + 236 | 0;
 i40 = i75 + 224 | 0;
 i67 = i75 + 128 | 0;
 i62 = i75 + 104 | 0;
 i58 = i75;
 i1 = i75 + 96 | 0;
 i41 = i75 + 84 | 0;
 i34 = i75 + 72 | 0;
 i60 = i75 + 60 | 0;
 f33 = Math_fround(HEAPF32[i2 >> 2]);
 f36 = Math_fround(f33 * Math_fround(2.0));
 f47 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f32 = Math_fround(f47 * Math_fround(2.0));
 f47 = Math_fround(Math_fround(f33 * f36) + Math_fround(Math_fround(f47 * f32) + Math_fround(-1.0)));
 f33 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f46 = Math_fround(f33 * f32);
 f50 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f36 * f50));
 f50 = Math_fround(Math_fround(f36 * f33) - Math_fround(f32 * f50));
 f32 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f47 = Math_fround(f32 * f47);
 f46 = Math_fround(f32 * f46);
 f50 = Math_fround(f32 * f50);
 f32 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f33 = Math_fround(f32 + f47);
 f36 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f43 = Math_fround(f36 + f46);
 f45 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f48 = Math_fround(f50 + f45);
 HEAPF32[i62 >> 2] = f33;
 i61 = i62 + 4 | 0;
 HEAPF32[i61 >> 2] = f43;
 i63 = i62 + 8 | 0;
 HEAPF32[i63 >> 2] = f48;
 f46 = Math_fround(f36 - f46);
 f50 = Math_fround(f45 - f50);
 i59 = i62 + 12 | 0;
 HEAPF32[i59 >> 2] = Math_fround(f32 - f47);
 i64 = i62 + 16 | 0;
 HEAPF32[i64 >> 2] = f46;
 i65 = i62 + 20 | 0;
 HEAPF32[i65 >> 2] = f50;
 i66 = i5 + 4 | 0;
 f50 = Math_fround(HEAPF32[i66 >> 2]);
 f50 = Math_fround(f50 + Math_fround(HEAPF32[i52 >> 2]));
 f46 = Math_fround(HEAPF32[i10 >> 2]);
 f47 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f45 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f36 = Math_fround(f46 + f46);
 f48 = Math_fround(f47 + f47);
 f43 = Math_fround(f32 + f32);
 f33 = Math_fround(f47 * f48);
 f42 = Math_fround(f32 * f43);
 f47 = Math_fround(f36 * f47);
 f31 = Math_fround(f36 * f32);
 f49 = Math_fround(f36 * f45);
 f32 = Math_fround(f48 * f32);
 f48 = Math_fround(f48 * f45);
 f45 = Math_fround(f43 * f45);
 f43 = Math_fround(f47 + f45);
 f44 = Math_fround(f31 - f48);
 f45 = Math_fround(f47 - f45);
 f36 = Math_fround(Math_fround(1.0) - Math_fround(f46 * f36));
 f46 = Math_fround(f36 - f42);
 f47 = Math_fround(f32 + f49);
 f48 = Math_fround(f31 + f48);
 f49 = Math_fround(f32 - f49);
 f36 = Math_fround(f36 - f33);
 HEAPF32[i58 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f33) - f42);
 i2 = i58 + 4 | 0;
 HEAPF32[i2 >> 2] = f43;
 i5 = i58 + 8 | 0;
 HEAPF32[i5 >> 2] = f44;
 i54 = i58 + 12 | 0;
 HEAPF32[i54 >> 2] = f45;
 i16 = i58 + 16 | 0;
 HEAPF32[i16 >> 2] = f46;
 i17 = i58 + 20 | 0;
 HEAPF32[i17 >> 2] = f47;
 i55 = i58 + 24 | 0;
 HEAPF32[i55 >> 2] = f48;
 i18 = i58 + 28 | 0;
 HEAPF32[i18 >> 2] = f49;
 i19 = i58 + 32 | 0;
 HEAPF32[i19 >> 2] = f36;
 i56 = i58 + 36 | 0;
 HEAP32[i56 >> 2] = HEAP32[i10 + 16 >> 2];
 i21 = i58 + 40 | 0;
 HEAP32[i21 >> 2] = HEAP32[i10 + 20 >> 2];
 i22 = i58 + 44 | 0;
 HEAP32[i22 >> 2] = HEAP32[i10 + 24 >> 2];
 i53 = i58 + 48 | 0;
 HEAP32[i53 >> 2] = HEAP32[i11 + 4 >> 2];
 i37 = i58 + 52 | 0;
 HEAP32[i37 >> 2] = HEAP32[i11 + 8 >> 2];
 i38 = i58 + 56 | 0;
 HEAP32[i38 >> 2] = HEAP32[i11 + 12 >> 2];
 i57 = i62 + 12 | 0;
 f36 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i62, i57, i56, i53, i58, i1, i41));
 if (f36 >= Math_fround(f50 * f50)) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 if (f36 != Math_fround(0.0)) {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f30 = Math_fround(HEAPF32[i59 >> 2]);
  f24 = Math_fround(HEAPF32[i62 >> 2]);
  f49 = Math_fround(f30 - f24);
  f31 = Math_fround(HEAPF32[i64 >> 2]);
  f28 = Math_fround(HEAPF32[i61 >> 2]);
  f50 = Math_fround(f31 - f28);
  f32 = Math_fround(HEAPF32[i65 >> 2]);
  f29 = Math_fround(HEAPF32[i63 >> 2]);
  f49 = Math_fround(f24 + Math_fround(f4 * f49));
  f50 = Math_fround(f28 + Math_fround(f4 * f50));
  f4 = Math_fround(f29 + Math_fround(f4 * Math_fround(f32 - f29)));
  f7 = Math_fround(HEAPF32[i41 >> 2]);
  f23 = Math_fround(HEAPF32[i58 >> 2]);
  f3 = Math_fround(f7 * f23);
  f20 = Math_fround(HEAPF32[i2 >> 2]);
  f33 = Math_fround(f7 * f20);
  f15 = Math_fround(HEAPF32[i5 >> 2]);
  f7 = Math_fround(f7 * f15);
  i39 = i41 + 4 | 0;
  f25 = Math_fround(HEAPF32[i39 >> 2]);
  i10 = i58 + 12 | 0;
  f12 = Math_fround(HEAPF32[i10 >> 2]);
  f27 = Math_fround(f25 * f12);
  f14 = Math_fround(HEAPF32[i16 >> 2]);
  f26 = Math_fround(f25 * f14);
  f13 = Math_fround(HEAPF32[i17 >> 2]);
  f27 = Math_fround(f3 + f27);
  f26 = Math_fround(f33 + f26);
  f25 = Math_fround(f7 + Math_fround(f25 * f13));
  i35 = i41 + 8 | 0;
  f7 = Math_fround(HEAPF32[i35 >> 2]);
  i5 = i58 + 24 | 0;
  f33 = Math_fround(HEAPF32[i5 >> 2]);
  f3 = Math_fround(f7 * f33);
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f6 = Math_fround(f7 * f9);
  f8 = Math_fround(HEAPF32[i19 >> 2]);
  f3 = Math_fround(f27 + f3);
  f6 = Math_fround(f26 + f6);
  f7 = Math_fround(f25 + Math_fround(f7 * f8));
  f25 = Math_fround(HEAPF32[i56 >> 2]);
  f3 = Math_fround(f3 + f25);
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f6 = Math_fround(f6 + f26);
  f27 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(f7 + f27);
  HEAPF32[i41 >> 2] = f3;
  HEAPF32[i39 >> 2] = f6;
  HEAPF32[i35 >> 2] = f7;
  f3 = Math_fround(f49 - f3);
  f6 = Math_fround(f50 - f6);
  f7 = Math_fround(f4 - f7);
  HEAPF32[i34 >> 2] = f3;
  i1 = i34 + 4 | 0;
  HEAPF32[i1 >> 2] = f6;
  i2 = i34 + 8 | 0;
  HEAPF32[i2 >> 2] = f7;
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)))));
  if (f4 > Math_fround(0.0)) {
   f24 = Math_fround(Math_fround(1.0) / f4);
   f26 = Math_fround(f3 * f24);
   HEAPF32[i34 >> 2] = f26;
   f25 = Math_fround(f24 * f6);
   HEAPF32[i1 >> 2] = f25;
   f24 = Math_fround(f24 * f7);
   HEAPF32[i2 >> 2] = f24;
   f50 = Math_fround(HEAPF32[i66 >> 2]);
   __ZL21PxcGenerateVFContactsRN5physx2Gu13ContactBufferERKNS0_7SegmentEfRKNS0_3BoxERKNS_6PxVec3Ef(i74, i62, f50, i58, i34, Math_fround(HEAPF32[i52 >> 2]));
   i21 = i74 + 4096 | 0;
   if ((HEAP32[i21 >> 2] | 0) == 2) {
    i74 = 1;
    STACKTOP = i75;
    return i74 | 0;
   }
   f23 = Math_fround(HEAPF32[i66 >> 2]);
   f20 = Math_fround(HEAPF32[i52 >> 2]);
   i2 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
   __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i67, i56, i53, i58, i54, i55);
   i60 = HEAP32[i62 >> 2] | 0;
   HEAP32[i71 >> 2] = i60;
   i11 = i71 + 4 | 0;
   i62 = HEAP32[i61 >> 2] | 0;
   HEAP32[i11 >> 2] = i62;
   i10 = i71 + 8 | 0;
   i63 = HEAP32[i63 >> 2] | 0;
   HEAP32[i10 >> 2] = i63;
   i61 = HEAP32[i57 >> 2] | 0;
   HEAP32[i72 >> 2] = i61;
   i5 = i72 + 4 | 0;
   i64 = HEAP32[i64 >> 2] | 0;
   HEAP32[i5 >> 2] = i64;
   i1 = i72 + 8 | 0;
   i65 = HEAP32[i65 >> 2] | 0;
   HEAP32[i1 >> 2] = i65;
   f9 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(f9 - f8);
   f7 = (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = Math_fround(f7 - f6);
   f4 = (HEAP32[tempDoublePtr >> 2] = i65, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f4 - f3);
   f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14))));
   if (f15 > Math_fround(0.0)) {
    f50 = Math_fround(Math_fround(.00999999977) / f15);
    f48 = Math_fround(f12 * f50);
    f49 = Math_fround(f13 * f50);
    f50 = Math_fround(f14 * f50);
    f8 = Math_fround(f8 - f48);
    HEAPF32[i71 >> 2] = f8;
    f6 = Math_fround(f6 - f49);
    HEAPF32[i11 >> 2] = f6;
    f3 = Math_fround(f3 - f50);
    HEAPF32[i10 >> 2] = f3;
    f9 = Math_fround(f9 + f48);
    HEAPF32[i72 >> 2] = f9;
    f7 = Math_fround(f7 + f49);
    HEAPF32[i5 >> 2] = f7;
    f4 = Math_fround(f4 + f50);
    HEAPF32[i1 >> 2] = f4;
   }
   f47 = Math_fround(f9 - f8);
   f48 = Math_fround(f7 - f6);
   f50 = Math_fround(f4 - f3);
   HEAPF32[i73 >> 2] = f47;
   HEAPF32[i73 + 4 >> 2] = f48;
   HEAPF32[i73 + 8 >> 2] = f50;
   f49 = Math_fround(-Math_fround(Math_fround(f48 * f24) - Math_fround(f50 * f25)));
   f50 = Math_fround(-Math_fround(Math_fround(f50 * f26) - Math_fround(f24 * f47)));
   f4 = Math_fround(-Math_fround(Math_fround(f47 * f25) - Math_fround(f48 * f26)));
   HEAPF32[i70 >> 2] = f49;
   HEAPF32[i70 + 4 >> 2] = f50;
   HEAPF32[i70 + 8 >> 2] = f4;
   HEAPF32[i70 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f3 * f4) + Math_fround(Math_fround(f8 * f49) + Math_fround(f6 * f50))));
   f3 = Math_fround(Math_abs(Math_fround(f49)));
   f50 = Math_fround(Math_abs(Math_fround(f50)));
   f4 = Math_fround(Math_abs(Math_fround(f4)));
   if (f50 > f3 & f50 > f4) {
    i18 = 0;
    i19 = 2;
   } else if (f4 > f3) {
    i18 = 1;
    i19 = 0;
   } else {
    i18 = 2;
    i19 = 1;
   }
   f4 = Math_fround(HEAPF32[i73 + (i18 << 2) >> 2]);
   f4 = Math_fround(f4 * Math_fround(HEAPF32[i34 + (i19 << 2) >> 2]));
   f9 = Math_fround(HEAPF32[i73 + (i19 << 2) >> 2]);
   f9 = Math_fround(Math_fround(1.0) / Math_fround(f4 - Math_fround(f9 * Math_fround(HEAPF32[i34 + (i18 << 2) >> 2]))));
   i16 = i40 + 4 | 0;
   i17 = i40 + 8 | 0;
   f4 = Math_fround(f23 + f20);
   i10 = i69 + 8 | 0;
   i11 = i69 + 4 | 0;
   f6 = Math_fround(-f26);
   f7 = Math_fround(-f25);
   f8 = Math_fround(-f24);
   i5 = 0;
   do {
    i64 = HEAPU8[i2 >> 0] | 0;
    i65 = HEAPU8[i2 + 1 >> 0] | 0;
    i2 = i2 + 2 | 0;
    HEAPF32[i40 >> 2] = f6;
    HEAPF32[i16 >> 2] = f7;
    HEAPF32[i17 >> 2] = f8;
    f46 = Math_fround(HEAPF32[i67 + (i64 * 12 | 0) >> 2]);
    f47 = Math_fround(HEAPF32[i67 + (i64 * 12 | 0) + 4 >> 2]);
    f48 = Math_fround(HEAPF32[i67 + (i64 * 12 | 0) + 8 >> 2]);
    f49 = Math_fround(HEAPF32[i67 + (i65 * 12 | 0) >> 2]);
    f50 = Math_fround(HEAPF32[i67 + (i65 * 12 | 0) + 4 >> 2]);
    if (__ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_(i71, i72, i73, i70, i19, i18, f9, i40, f46, f47, f48, f49, f50, Math_fround(HEAPF32[i67 + (i65 * 12 | 0) + 8 >> 2]), i68, i69) | 0) {
     f3 = Math_fround(HEAPF32[i68 >> 2]);
     if (f3 < f4) {
      i1 = HEAP32[i21 >> 2] | 0;
      if (i1 >>> 0 <= 63) {
       f50 = Math_fround(f3 - f23);
       f49 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - Math_fround(f3 * f24));
       f48 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - Math_fround(f3 * f25));
       f47 = Math_fround(Math_fround(HEAPF32[i69 >> 2]) - Math_fround(f3 * f26));
       HEAP32[i21 >> 2] = i1 + 1;
       HEAPF32[i74 + (i1 << 6) >> 2] = f26;
       HEAPF32[i74 + (i1 << 6) + 4 >> 2] = f25;
       HEAPF32[i74 + (i1 << 6) + 8 >> 2] = f24;
       HEAPF32[i74 + (i1 << 6) + 16 >> 2] = f47;
       HEAPF32[i74 + (i1 << 6) + 20 >> 2] = f48;
       HEAPF32[i74 + (i1 << 6) + 24 >> 2] = f49;
       HEAPF32[i74 + (i1 << 6) + 12 >> 2] = f50;
       HEAP32[i74 + (i1 << 6) + 48 >> 2] = -1;
       HEAP32[i74 + (i1 << 6) + 52 >> 2] = -1;
      }
     }
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != 12);
   if (HEAP32[i21 >> 2] | 0) {
    i74 = 1;
    STACKTOP = i75;
    return i74 | 0;
   }
   f50 = Math_fround(Math_sqrt(Math_fround(f36)));
   f50 = Math_fround(f50 - Math_fround(HEAPF32[i66 >> 2]));
   HEAP32[i21 >> 2] = 1;
   HEAPF32[i74 >> 2] = f26;
   HEAPF32[i74 + 4 >> 2] = f25;
   HEAPF32[i74 + 8 >> 2] = f24;
   HEAP32[i74 + 16 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i74 + 20 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i74 + 24 >> 2] = HEAP32[i35 >> 2];
   HEAPF32[i74 + 12 >> 2] = f50;
   HEAP32[i74 + 48 >> 2] = -1;
   HEAP32[i74 + 52 >> 2] = -1;
   i74 = 1;
   STACKTOP = i75;
   return i74 | 0;
  } else {
   f50 = f8;
   i35 = i5;
   i22 = i10;
   f49 = f28;
   f48 = f29;
   f3 = f33;
  }
 } else {
  f23 = Math_fround(HEAPF32[i58 >> 2]);
  f20 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(HEAPF32[i5 >> 2]);
  f24 = Math_fround(HEAPF32[i62 >> 2]);
  f49 = Math_fround(HEAPF32[i61 >> 2]);
  f48 = Math_fround(HEAPF32[i63 >> 2]);
  f30 = Math_fround(HEAPF32[i59 >> 2]);
  f31 = Math_fround(HEAPF32[i64 >> 2]);
  f32 = Math_fround(HEAPF32[i65 >> 2]);
  f25 = Math_fround(HEAPF32[i58 + 36 >> 2]);
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f27 = Math_fround(HEAPF32[i22 >> 2]);
  i22 = i58 + 12 | 0;
  f12 = Math_fround(HEAPF32[i22 >> 2]);
  f14 = Math_fround(HEAPF32[i16 >> 2]);
  f13 = Math_fround(HEAPF32[i17 >> 2]);
  i35 = i58 + 24 | 0;
  f3 = Math_fround(HEAPF32[i35 >> 2]);
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f50 = Math_fround(HEAPF32[i19 >> 2]);
 }
 i18 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
 f47 = Math_fround(HEAPF32[i66 >> 2]);
 f43 = Math_fround(Math_fround(Math_fround(f23 * f24) + Math_fround(f20 * f49)) + Math_fround(f15 * f48));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
 f7 = Math_fround(Math_fround(Math_fround(f23 * f30) + Math_fround(f20 * f31)) + Math_fround(f15 * f32));
 i10 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = f43 > f7;
 f7 = Math_fround(f47 + (HEAP32[tempDoublePtr >> 2] = i11 ? i5 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f43 = Math_fround(Math_fround(Math_fround(f23 * f25) + Math_fround(f20 * f26)) + Math_fround(f15 * f27));
 f4 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f20 * f20)) + Math_fround(f15 * f15))));
 f46 = Math_fround(HEAPF32[i58 + 48 >> 2]);
 f4 = Math_fround(f4 * f46);
 f28 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f23 * f12) + Math_fround(f20 * f14)) + Math_fround(f15 * f13))));
 f45 = Math_fround(HEAPF32[i37 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f28 * f45));
 f33 = Math_fround(f20 * f9);
 f36 = Math_fround(f15 * f50);
 f6 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f23 * f3) + f33) + f36)));
 f44 = Math_fround(HEAPF32[i38 >> 2]);
 f6 = Math_fround(f4 + Math_fround(f6 * f44));
 f4 = Math_fround(f43 - f6);
 f6 = Math_fround(f43 + f6);
 if (f7 < f4) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i10 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
 if (f6 < f3) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f43 = Math_fround(f7 - f4);
 f3 = Math_fround(f6 - f3);
 f3 = f43 < f3 ? f43 : f3;
 if (f3 < Math_fround(3402823469999999843913219.0e14)) i21 = i16; else {
  i21 = 0;
  i17 = 0;
  i18 = 0;
  f3 = Math_fround(3402823469999999843913219.0e14);
 }
 f4 = Math_fround(Math_fround(Math_fround(f12 * f24) + Math_fround(f14 * f49)) + Math_fround(f13 * f48));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = Math_fround(Math_fround(Math_fround(f12 * f30) + Math_fround(f14 * f31)) + Math_fround(f13 * f32));
 i10 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = f4 > f8;
 f8 = Math_fround(f47 + (HEAP32[tempDoublePtr >> 2] = i11 ? i5 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = Math_fround(Math_fround(Math_fround(f12 * f25) + Math_fround(f14 * f26)) + Math_fround(f13 * f27));
 f7 = Math_fround(f28 * f46);
 f43 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(f7 + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f12 * f43) + Math_fround(f14 * f14)) + Math_fround(f13 * f13)))) * f45));
 f42 = Math_fround(HEAPF32[i35 >> 2]);
 f28 = Math_fround(f14 * f9);
 f29 = Math_fround(f13 * f50);
 f7 = Math_fround(f7 + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f12 * f42) + f28) + f29))) * f44));
 f6 = Math_fround(f4 - f7);
 f7 = Math_fround(f4 + f7);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
 if (f8 < f6) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i10 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
 if (f7 < f4) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f12 = Math_fround(f8 - f6);
 f8 = Math_fround(f7 - f4);
 f8 = f12 < f8 ? f12 : f8;
 if (f8 < f3) i17 = i34; else {
  i19 = i21;
  i16 = i18;
  f8 = f3;
 }
 f12 = Math_fround(Math_fround(Math_fround(f42 * f24) + Math_fround(f9 * f49)) + Math_fround(f50 * f48));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f7 = Math_fround(Math_fround(Math_fround(f42 * f30) + Math_fround(f9 * f31)) + Math_fround(f50 * f32));
 i10 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = f12 > f7;
 f7 = Math_fround(f47 + (HEAP32[tempDoublePtr >> 2] = i11 ? i5 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(Math_fround(Math_fround(f42 * f25) + Math_fround(f9 * f26)) + Math_fround(f50 * f27));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f42 * f23) + f33) + f36))) * f46) + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f42 * f43) + f28) + f29))) * f45)) + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f9 * f9)) + Math_fround(f50 * f50)))) * f44));
 f4 = Math_fround(f12 - f6);
 f6 = Math_fround(f12 + f6);
 if (f7 < f4) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i10 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
 if (f6 < f3) {
  i74 = 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 f36 = Math_fround(f7 - f4);
 f3 = Math_fround(f6 - f3);
 f3 = f36 < f3 ? f36 : f3;
 if (f3 < f8) {
  i5 = i22;
  f8 = f3;
 } else {
  i5 = i16;
  i2 = i17;
  i1 = i19;
 }
 f7 = Math_fround(f30 - f24);
 f6 = Math_fround(f31 - f49);
 f4 = Math_fround(f32 - f48);
 f3 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f4 * f4));
 if (f3 > Math_fround(0.0)) {
  f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
  f33 = Math_fround(f4 * f28);
  f29 = Math_fround(f6 * f28);
  f28 = Math_fround(f7 * f28);
 } else {
  f33 = Math_fround(0.0);
  f29 = Math_fround(0.0);
  f28 = Math_fround(0.0);
 }
 i21 = i5;
 i18 = i2;
 i17 = i1;
 i19 = 0;
 while (1) {
  f6 = Math_fround(HEAPF32[i58 + (i19 * 12 | 0) + 8 >> 2]);
  f7 = Math_fround(f29 * f6);
  f36 = Math_fround(HEAPF32[i58 + (i19 * 12 | 0) + 4 >> 2]);
  f7 = Math_fround(f7 - Math_fround(f33 * f36));
  f3 = Math_fround(HEAPF32[i58 + (i19 * 12 | 0) >> 2]);
  f6 = Math_fround(Math_fround(f33 * f3) - Math_fround(f28 * f6));
  f3 = Math_fround(Math_fround(f28 * f36) - Math_fround(f29 * f3));
  if (+Math_fround(Math_abs(Math_fround(f7))) > 1.0e-06) i51 = 30; else if (+Math_fround(Math_abs(Math_fround(f6))) > 1.0e-06) i51 = 30; else if (+Math_fround(Math_abs(Math_fround(f3))) > 1.0e-06) i51 = 30; else {
   i5 = i17;
   i2 = i18;
   i1 = i21;
  }
  if ((i51 | 0) == 30) {
   i51 = 0;
   f4 = Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
   if (f4 > Math_fround(0.0)) {
    f36 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
    f12 = Math_fround(f3 * f36);
    f4 = Math_fround(f6 * f36);
    f3 = Math_fround(f7 * f36);
   } else {
    f12 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f3 = Math_fround(0.0);
   }
   i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   f36 = Math_fround(Math_fround(Math_fround(f3 * f24) + Math_fround(f4 * f49)) + Math_fround(f12 * f48));
   i10 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = Math_fround(Math_fround(Math_fround(f3 * f30) + Math_fround(f4 * f31)) + Math_fround(f12 * f32));
   i11 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = f36 > f7;
   f7 = Math_fround(f47 + (HEAP32[tempDoublePtr >> 2] = i16 ? i10 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f36 = Math_fround(Math_fround(Math_fround(f3 * f25) + Math_fround(f4 * f26)) + Math_fround(f12 * f27));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(f4 * f20)) + Math_fround(f12 * f15)))) * f46) + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f3 * f43) + Math_fround(f4 * f14)) + Math_fround(f12 * f13)))) * f45)) + Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f3 * f42) + Math_fround(f4 * f9)) + Math_fround(f12 * f50)))) * f44));
   f4 = Math_fround(f36 - f6);
   f6 = Math_fround(f36 + f6);
   if (f7 < f4) {
    i1 = 0;
    i51 = 59;
    break;
   }
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i11 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
   if (f6 < f3) {
    i1 = 0;
    i51 = 59;
    break;
   }
   f36 = Math_fround(f7 - f4);
   f3 = Math_fround(f6 - f3);
   f3 = f36 < f3 ? f36 : f3;
   if (f3 < f8) f8 = f3; else {
    i5 = i17;
    i2 = i18;
    i1 = i21;
   }
  }
  i19 = i19 + 1 | 0;
  if (i19 >>> 0 >= 3) {
   f28 = f8;
   i51 = 37;
   break;
  } else {
   i21 = i1;
   i18 = i2;
   i17 = i5;
  }
 }
 if ((i51 | 0) == 37) {
  f6 = Math_fround(Math_fround(Math_fround(f24 + f30) * Math_fround(.5)) - f25);
  f49 = Math_fround(Math_fround(Math_fround(f49 + f31) * Math_fround(.5)) - f26);
  f50 = Math_fround(Math_fround(Math_fround(f48 + f32) * Math_fround(.5)) - f27);
  f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f3 * f6);
  f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f49 = Math_fround(f6 + Math_fround(f4 * f49));
  f6 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(f49 + Math_fround(f6 * f50)) < Math_fround(0.0)) {
   f48 = Math_fround(-f3);
   f49 = Math_fround(-f4);
   f50 = Math_fround(-f6);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i22 = i2;
   i21 = i5;
  }
  HEAP32[i60 >> 2] = i1;
  HEAP32[i60 + 4 >> 2] = i22;
  HEAP32[i60 + 8 >> 2] = i21;
  __ZL21PxcGenerateVFContactsRN5physx2Gu13ContactBufferERKNS0_7SegmentEfRKNS0_3BoxERKNS_6PxVec3Ef(i74, i62, f47, i58, i60, Math_fround(HEAPF32[i52 >> 2]));
  i19 = i74 + 4096 | 0;
  f23 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if ((HEAP32[i19 >> 2] | 0) == 2) {
   i74 = 1;
   STACKTOP = i75;
   return i74 | 0;
  }
  f25 = Math_fround(HEAPF32[i66 >> 2]);
  i5 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
  __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i67, i56, i53, i58, i54, i55);
  i54 = HEAP32[i62 >> 2] | 0;
  HEAP32[i71 >> 2] = i54;
  i11 = i71 + 4 | 0;
  i56 = HEAP32[i61 >> 2] | 0;
  HEAP32[i11 >> 2] = i56;
  i16 = i71 + 8 | 0;
  i58 = HEAP32[i63 >> 2] | 0;
  HEAP32[i16 >> 2] = i58;
  i53 = HEAP32[i57 >> 2] | 0;
  HEAP32[i72 >> 2] = i53;
  i2 = i72 + 4 | 0;
  i55 = HEAP32[i64 >> 2] | 0;
  HEAP32[i2 >> 2] = i55;
  i10 = i72 + 8 | 0;
  i57 = HEAP32[i65 >> 2] | 0;
  HEAP32[i10 >> 2] = i57;
  f9 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = Math_fround(f9 - f8);
  f7 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f7 - f6);
  f4 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f4 - f3);
  f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14))));
  if (f15 > Math_fround(0.0)) {
   f50 = Math_fround(Math_fround(.00999999977) / f15);
   f48 = Math_fround(f12 * f50);
   f49 = Math_fround(f13 * f50);
   f50 = Math_fround(f14 * f50);
   f8 = Math_fround(f8 - f48);
   HEAPF32[i71 >> 2] = f8;
   f6 = Math_fround(f6 - f49);
   HEAPF32[i11 >> 2] = f6;
   f3 = Math_fround(f3 - f50);
   HEAPF32[i16 >> 2] = f3;
   f9 = Math_fround(f9 + f48);
   HEAPF32[i72 >> 2] = f9;
   f7 = Math_fround(f7 + f49);
   HEAPF32[i2 >> 2] = f7;
   f4 = Math_fround(f4 + f50);
   HEAPF32[i10 >> 2] = f4;
  }
  f47 = Math_fround(f9 - f8);
  f48 = Math_fround(f7 - f6);
  f50 = Math_fround(f4 - f3);
  HEAPF32[i73 >> 2] = f47;
  HEAPF32[i73 + 4 >> 2] = f48;
  HEAPF32[i73 + 8 >> 2] = f50;
  f49 = Math_fround(Math_fround(f48 * f23) - Math_fround(f50 * f24));
  f50 = Math_fround(Math_fround(f50 * f20) - Math_fround(f23 * f47));
  f4 = Math_fround(Math_fround(f47 * f24) - Math_fround(f48 * f20));
  HEAPF32[i70 >> 2] = f49;
  HEAPF32[i70 + 4 >> 2] = f50;
  HEAPF32[i70 + 8 >> 2] = f4;
  HEAPF32[i70 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f3 * f4) + Math_fround(Math_fround(f8 * f49) + Math_fround(f6 * f50))));
  f3 = Math_fround(Math_abs(Math_fround(f49)));
  f50 = Math_fround(Math_abs(Math_fround(f50)));
  f4 = Math_fround(Math_abs(Math_fround(f4)));
  if (f50 > f3 & f50 > f4) {
   i11 = 2;
   i16 = 0;
  } else if (f4 > f3) {
   i11 = 0;
   i16 = 1;
  } else {
   i11 = 1;
   i16 = 2;
  }
  f50 = Math_fround(HEAPF32[i73 + (i11 << 2) >> 2]);
  f50 = Math_fround(f50 * Math_fround(HEAPF32[i60 + (i16 << 2) >> 2]));
  f4 = Math_fround(HEAPF32[i73 + (i16 << 2) >> 2]);
  f4 = Math_fround(Math_fround(1.0) / Math_fround(f50 - Math_fround(f4 * Math_fround(HEAPF32[i60 + (i11 << 2) >> 2]))));
  i17 = i69 + 8 | 0;
  i18 = i69 + 4 | 0;
  i10 = 0;
  do {
   i57 = HEAPU8[i5 >> 0] | 0;
   i58 = HEAPU8[i5 + 1 >> 0] | 0;
   i5 = i5 + 2 | 0;
   f46 = Math_fround(HEAPF32[i67 + (i57 * 12 | 0) >> 2]);
   f47 = Math_fround(HEAPF32[i67 + (i57 * 12 | 0) + 4 >> 2]);
   f48 = Math_fround(HEAPF32[i67 + (i57 * 12 | 0) + 8 >> 2]);
   f49 = Math_fround(HEAPF32[i67 + (i58 * 12 | 0) >> 2]);
   f50 = Math_fround(HEAPF32[i67 + (i58 * 12 | 0) + 4 >> 2]);
   do if (__ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_(i71, i72, i73, i70, i11, i16, f4, i60, f46, f47, f48, f49, f50, Math_fround(HEAPF32[i67 + (i58 * 12 | 0) + 8 >> 2]), i68, i69) | 0) {
    f3 = Math_fround(HEAPF32[i68 >> 2]);
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 > 63) break;
    f49 = Math_fround(-Math_fround(f25 + f3));
    f48 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - Math_fround(f3 * f23));
    f47 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - Math_fround(f3 * f24));
    f46 = Math_fround(HEAPF32[i69 >> 2]);
    f50 = Math_fround(HEAPF32[i60 >> 2]);
    f46 = Math_fround(f46 - Math_fround(f3 * f50));
    HEAP32[i19 >> 2] = i2 + 1;
    HEAPF32[i74 + (i2 << 6) >> 2] = f50;
    HEAP32[i74 + (i2 << 6) + 4 >> 2] = i22;
    HEAP32[i74 + (i2 << 6) + 8 >> 2] = i21;
    HEAPF32[i74 + (i2 << 6) + 16 >> 2] = f46;
    HEAPF32[i74 + (i2 << 6) + 20 >> 2] = f47;
    HEAPF32[i74 + (i2 << 6) + 24 >> 2] = f48;
    HEAPF32[i74 + (i2 << 6) + 12 >> 2] = f49;
    HEAP32[i74 + (i2 << 6) + 48 >> 2] = -1;
    HEAP32[i74 + (i2 << 6) + 52 >> 2] = -1;
    i1 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
   } while (0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != 12);
  if (HEAP32[i19 >> 2] | 0) {
   i74 = 1;
   STACKTOP = i75;
   return i74 | 0;
  }
  f47 = Math_fround(HEAPF32[i62 >> 2]);
  f47 = Math_fround(f47 + Math_fround(HEAPF32[i59 >> 2]));
  f48 = Math_fround(HEAPF32[i61 >> 2]);
  f48 = Math_fround(f48 + Math_fround(HEAPF32[i64 >> 2]));
  f49 = Math_fround(HEAPF32[i63 >> 2]);
  f47 = Math_fround(f47 * Math_fround(.5));
  f48 = Math_fround(f48 * Math_fround(.5));
  f49 = Math_fround(Math_fround(f49 + Math_fround(HEAPF32[i65 >> 2])) * Math_fround(.5));
  f50 = Math_fround(-Math_fround(f28 + Math_fround(HEAPF32[i66 >> 2])));
  HEAP32[i19 >> 2] = 1;
  HEAP32[i74 >> 2] = i1;
  HEAP32[i74 + 4 >> 2] = i22;
  HEAP32[i74 + 8 >> 2] = i21;
  HEAPF32[i74 + 16 >> 2] = f47;
  HEAPF32[i74 + 20 >> 2] = f48;
  HEAPF32[i74 + 24 >> 2] = f49;
  HEAPF32[i74 + 12 >> 2] = f50;
  HEAP32[i74 + 48 >> 2] = -1;
  HEAP32[i74 + 52 >> 2] = -1;
  i74 = 1;
  STACKTOP = i75;
  return i74 | 0;
 } else if ((i51 | 0) == 59) {
  STACKTOP = i75;
  return i1 | 0;
 }
 return 0;
}

function __ZN4Mesh8TransferI14SafeBinaryReadEEvRT_(i37, i38) {
 i37 = i37 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i40 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i39;
 i33 = i39 + 224 | 0;
 i29 = i39 + 120 | 0;
 i30 = i39 + 96 | 0;
 i25 = i39 + 76 | 0;
 i26 = i39 + 56 | 0;
 i27 = i39 + 36 | 0;
 i28 = i39 + 16 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i37, i38);
 __ZN14SafeBinaryRead10SetVersionEi(i38, 8);
 i32 = i37 + 32 | 0;
 if ((HEAP32[(HEAP32[i32 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i32 >> 2] | 0);
  i2 = HEAP32[i32 >> 2] | 0;
  i34 = i2 + 4 | 0;
  HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + -1;
  if (!(HEAP32[i34 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i32 >> 2] = i1;
 }
 i34 = i37 + 44 | 0;
 i31 = (HEAP8[i34 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i37, 1);
 i2 = (HEAP32[i32 >> 2] | 0) + 128 | 0;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425727 | 0, i6, i35, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI7SubMesh13stl_allocatorIS3_L18MemLabelIdentifier16ELi16EEEEEEvRT_17TransferMetaFlags(i38, i2, 0); else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i2 = i37 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425739 | 0, gb + 425748 | 0, i35, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14BlendShapeData8TransferI14SafeBinaryReadEEvRT_(i2, i38); else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i2 = (HEAP32[i32 >> 2] | 0) + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425763 | 0, i6, i35, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj16EEEEvRT_17TransferMetaFlags(i38, i2, 0); else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i2 = i37 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425774 | 0, i6, i35, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i38, i2, 0); else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i4 = i37 + 184 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425791 | 0, HEAP32[gb + 37304 >> 2] | 0, i35, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i38 + 16 | 0;
   i24 = HEAP32[i38 + 20 >> 2] | 0;
   i2 = i24 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i24 >>> 0) i36 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i38 + 24 >> 2] | 0) >>> 0) i36 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i36 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i38 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i5 = i37 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425810 | 0, HEAP32[gb + 37300 >> 2] | 0, i35, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i38 + 16 | 0;
   i24 = HEAP32[i38 + 20 >> 2] | 0;
   i1 = i24 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i24 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i38 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 1);
  } else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i38 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i3 = i37 + 41 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425828 | 0, i4, i35, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i38 + 16 | 0;
   i24 = HEAP32[i38 + 20 >> 2] | 0;
   i2 = i24 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i24 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i38 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i38 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i3 = i37 + 42 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425841 | 0, i4, i35, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i38 + 16 | 0;
   i24 = HEAP32[i38 + 20 >> 2] | 0;
   i2 = i24 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i24 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i38 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i38 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i3 = i37 + 43 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425856 | 0, i4, i35, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i38 + 16 | 0;
   i24 = HEAP32[i38 + 20 >> 2] | 0;
   i2 = i24 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i24 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i38 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i38 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 if (!(HEAP8[i5 >> 0] | 0)) i36 = 78; else if (!(HEAP32[i38 >> 2] & 16384)) {
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 12 >> 2] = 0;
  i2 = i33 + 16 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = i33 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i28 = i35;
  i1 = HEAP32[i28 + 4 >> 2] | 0;
  i4 = i3;
  HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  __ZN14VertexDataInfoC2Ev(i29);
  HEAP32[i30 >> 2] = 0;
  i4 = i30 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425870 | 0, i6, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_17TransferMetaFlags(i38, i30, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i30 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425884 | 0, i6, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13BoneInfluenceLj16EEEEvRT_17TransferMetaFlags(i38, i33, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i33 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425923 | 0, gb + 442181 | 0, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN10VertexData8TransferI14SafeBinaryReadEEvRT_(i29, i38); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i29 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = HEAP32[i30 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i1;
   i30 = HEAP32[i30 + 12 >> 2] | 0;
   HEAP32[i35 >> 2] = 14;
   HEAP32[i35 + 4 >> 2] = i30;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i35);
  }
  __ZN10VertexDataD2Ev(i29);
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i3);
   HEAP32[i33 >> 2] = 0;
  }
  i1 = 1;
 } else i36 = 78;
 do if ((i36 | 0) == 78) {
  i2 = (HEAP32[i32 >> 2] | 0) + 112 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425870 | 0, i6, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_17TransferMetaFlags(i38, i2, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i3 = HEAP32[i32 >> 2] | 0;
  if (HEAP32[i38 >> 2] & 512 | 0) {
   i1 = HEAP32[i3 + 112 >> 2] | 0;
   i4 = ((HEAP32[i3 + 116 >> 2] | 0) - i1 | 0) >>> 1;
   if (i4 | 0) {
    i2 = 0;
    while (1) {
     HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
  }
  i2 = i3 + 164 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425884 | 0, i6, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13BoneInfluenceLj16EEEEvRT_17TransferMetaFlags(i38, i2, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i38, 5) | 0)) {
   i2 = (HEAP32[i32 >> 2] | 0) + 8 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425923 | 0, gb + 442181 | 0, i35, 1) | 0;
   if (i1 | 0) {
    do if ((i1 | 0) > 0) __ZN10VertexData8TransferI14SafeBinaryReadEEvRT_(i2, i38); else {
     i1 = HEAP32[i35 >> 2] | 0;
     if (!i1) break;
     mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
    } while (0);
    __ZN14SafeBinaryRead11EndTransferEv(i38);
   }
   if (!(HEAP32[i38 >> 2] & 512)) {
    i1 = 0;
    break;
   }
   __ZN10VertexData13SwapEndianessEv((HEAP32[i32 >> 2] | 0) + 8 | 0);
   i1 = 0;
   break;
  }
  HEAP32[i29 >> 2] = 0;
  i11 = i29 + 12 | 0;
  HEAP32[i11 >> 2] = 0;
  i13 = i29 + 16 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i29 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i16 = i35;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = i14;
  HEAP32[i3 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i3 + 4 >> 2] = i15;
  HEAP32[i30 >> 2] = 0;
  i3 = i30 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  i15 = i30 + 16 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i30 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i18 = i35;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i7 = i16;
  HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i7 + 4 >> 2] = i17;
  HEAP32[i25 >> 2] = 0;
  i7 = i25 + 12 | 0;
  HEAP32[i7 >> 2] = 0;
  i17 = i25 + 16 | 0;
  HEAP32[i17 >> 2] = 0;
  i18 = i25 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i20 = i35;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i8 = i18;
  HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i8 + 4 >> 2] = i19;
  HEAP32[i26 >> 2] = 0;
  i8 = i26 + 12 | 0;
  HEAP32[i8 >> 2] = 0;
  i19 = i26 + 16 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i26 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i22 = i35;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  i9 = i20;
  HEAP32[i9 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i9 + 4 >> 2] = i21;
  HEAP32[i27 >> 2] = 0;
  i9 = i27 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  i21 = i27 + 16 | 0;
  HEAP32[i21 >> 2] = 0;
  i22 = i27 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i24 = i35;
  i23 = HEAP32[i24 + 4 >> 2] | 0;
  i12 = i22;
  HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i12 + 4 >> 2] = i23;
  HEAP32[i28 >> 2] = 0;
  i12 = i28 + 12 | 0;
  HEAP32[i12 >> 2] = 0;
  i23 = i28 + 16 | 0;
  HEAP32[i23 >> 2] = 0;
  i24 = i28 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i10 = i35;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = i24;
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  i2 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 843803 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i38, i30, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i30 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425891 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i38, i26, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i26 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425896 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i38, i27, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i27 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425902 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i38, i29, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i29 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425913 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i38, i25, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i25 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 469900 | 0, i2, i35, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i38, i28, 0); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i28 | 0, i38 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  i10 = HEAP32[i3 >> 2] | 0;
  i1 = (i10 | 0) != 0 & 1;
  i1 = (HEAP32[i11 >> 2] | 0) == 0 ? i1 : i1 | 128;
  i1 = (HEAP32[i7 >> 2] | 0) == 0 ? i1 : i1 | 2;
  i1 = (HEAP32[i8 >> 2] | 0) == 0 ? i1 : i1 | 8;
  i1 = (HEAP32[i9 >> 2] | 0) == 0 ? i1 : i1 | 16;
  i1 = (HEAP32[i12 >> 2] | 0) == 0 ? i1 : i1 | 4;
  i2 = HEAP32[i32 >> 2] | 0;
  if ((HEAP32[i2 + 100 >> 2] | 0) == (i10 | 0)) if ((HEAP32[i2 + 96 >> 2] | 0) == (i1 | 0)) i1 = i10; else i36 = 133; else i36 = 133;
  if ((i36 | 0) == 133) {
   do if (!(HEAP32[i2 + 176 >> 2] | 0)) {
    if ((HEAP32[i37 + 116 >> 2] | 0) != (HEAP32[i37 + 112 >> 2] | 0)) {
     i36 = 135;
     break;
    }
    __ZNK14VertexDataInfo16GetStreamsLayoutEv(i35, i2 + 8 | 0);
    HEAP32[i35 >> 2] = (HEAP32[i35 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i35 + 8 >> 2] & ~HEAP32[i35 + 12 >> 2];
    HEAP32[i33 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i33 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i33 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    HEAP32[i33 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   } else i36 = 135; while (0);
   if ((i36 | 0) == 135) {
    HEAP32[i33 >> 2] = HEAP32[gb + 59228 >> 2];
    HEAP32[i33 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
    HEAP32[i33 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
    HEAP32[i33 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
   }
   __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i37, i10, i1, 0, gb + 1546313 | 0, i33);
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i32 >> 2] | 0;
  }
  i5 = HEAP32[i30 >> 2] | 0;
  i4 = i10 >>> 0 < i1 >>> 0 ? i10 : i1;
  i6 = i5 + (i4 * 12 | 0) | 0;
  i3 = i2 + 8 | 0;
  i1 = HEAP16[i2 + 10 >> 1] | 0;
  do if ((i1 & 65535) < 768 | (i1 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i2 + 11 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i3 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i3 + 32 + ((HEAPU8[i3 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (!i4) i5 = i2; else {
   i2 = i5;
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i2 + 12 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i3 | 0;
   }
   i5 = HEAP32[i32 >> 2] | 0;
  }
  i2 = HEAP32[i25 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i4 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
  i6 = i2 + (i4 * 12 | 0) | 0;
  i3 = i5 + 8 | 0;
  i40 = HEAP16[i5 + 14 >> 1] | 0;
  do if ((i40 & 65535) < 768 | (i40 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i5 + 15 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i5 + 12 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i3 + 32 + ((HEAPU8[i5 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (i4) {
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i2 + 12 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i3 | 0;
   }
   i5 = HEAP32[i32 >> 2] | 0;
  }
  i2 = HEAP32[i26 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i4 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
  i6 = i2 + (i4 << 3) | 0;
  i3 = i5 + 8 | 0;
  i40 = HEAP16[i5 + 22 >> 1] | 0;
  do if ((i40 & 65535) < 512 | (i40 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i5 + 23 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i5 + 20 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i3 + 32 + ((HEAPU8[i5 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (i4) {
   while (1) {
    i7 = i2;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i40 = i1;
    HEAP32[i40 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i40 + 4 >> 2] = i8;
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i3 | 0;
   }
   i5 = HEAP32[i32 >> 2] | 0;
  }
  i2 = HEAP32[i27 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i4 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
  i6 = i2 + (i4 << 3) | 0;
  i3 = i5 + 8 | 0;
  i40 = HEAP16[i5 + 26 >> 1] | 0;
  do if ((i40 & 65535) < 512 | (i40 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i5 + 27 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i5 + 24 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i3 + 32 + ((HEAPU8[i5 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (i4) {
   while (1) {
    i8 = i2;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i40 = i1;
    HEAP32[i40 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i40 + 4 >> 2] = i9;
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i3 | 0;
   }
   i5 = HEAP32[i32 >> 2] | 0;
  }
  i2 = HEAP32[i29 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i4 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
  i6 = i2 + (i4 << 4) | 0;
  i3 = i5 + 8 | 0;
  i40 = HEAP16[i5 + 38 >> 1] | 0;
  do if ((i40 & 65535) < 1024 | (i40 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i5 + 39 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i5 + 36 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i3 + 32 + ((HEAPU8[i5 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (!i4) i3 = i5; else {
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i2 = i2 + 16 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i3 | 0;
   }
   i3 = HEAP32[i32 >> 2] | 0;
  }
  i6 = HEAP32[i28 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i4 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
  i5 = i6 + (i4 << 2) | 0;
  i2 = i3 + 8 | 0;
  i40 = HEAP16[i3 + 18 >> 1] | 0;
  do if ((i40 & 65535) < 1024 | (i40 & 255) != 2) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
    break;
   }
   if (!(HEAP8[i3 + 19 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
    break;
   }
   i40 = HEAP16[i3 + 16 >> 1] | 0;
   i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i2 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i2 + 32 + ((HEAPU8[i3 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if (i4 | 0) {
   i2 = i6;
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
   }
  }
  if ((HEAP32[i23 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i24);
   HEAP32[i28 >> 2] = 0;
  }
  if ((HEAP32[i21 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i22);
   HEAP32[i27 >> 2] = 0;
  }
  if ((HEAP32[i19 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i20);
   HEAP32[i26 >> 2] = 0;
  }
  if ((HEAP32[i17 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i18);
   HEAP32[i25 >> 2] = 0;
  }
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i16);
   HEAP32[i30 >> 2] = 0;
  }
  if ((HEAP32[i13 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i14);
   HEAP32[i29 >> 2] = 0;
  }
  i1 = 0;
 } while (0);
 i22 = i33 + 16 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i33 + 4 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 HEAP8[i33 + 12 >> 0] = 0;
 i23 = i33 + 44 | 0;
 i24 = i33 + 72 | 0;
 i25 = i33 + 92 | 0;
 i26 = i33 + 120 | 0;
 i27 = i33 + 140 | 0;
 i28 = i33 + 168 | 0;
 i29 = i33 + 188 | 0;
 i30 = i33 + 208 | 0;
 i40 = i33 + 228 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i22 + 16 >> 2] = 0;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP8[i22 + 24 >> 0] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP8[i23 + 24 >> 0] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP8[i24 + 16 >> 0] = 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAP32[i25 + 16 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP8[i25 + 24 >> 0] = 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i26 + 16 >> 0] = 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = 0;
 HEAP32[i27 + 20 >> 2] = 0;
 HEAP8[i27 + 24 >> 0] = 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP8[i28 + 16 >> 0] = 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAP8[i29 + 16 >> 0] = 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP8[i30 + 16 >> 0] = 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 if (i1) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425936 | 0, gb + 425953 | 0, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14CompressedMesh8TransferI14SafeBinaryReadEEvRT_(i33, i38); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i33 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
  if (HEAP8[i38 + 128 >> 0] | 0) __ZN14CompressedMesh10DecompressER4Mesh(i33, i37);
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425936 | 0, gb + 425953 | 0, i35, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14CompressedMesh8TransferI14SafeBinaryReadEEvRT_(i33, i38); else {
    i1 = HEAP32[i35 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i33 | 0, i38 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i38);
  }
 }
 __ZN14CompressedMeshD2Ev(i33);
 if (!i31) {
  i4 = HEAP32[i32 >> 2] | 0;
  i5 = i4 + 8 | 0;
  i2 = HEAP16[i4 + 18 >> 1] | 0;
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i6 = 0;
   i8 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i6 = 0;
    i8 = 1;
   } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i6 = 0;
    i8 = 1;
   } else {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i6 = i1 + ((i2 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i8 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i2 = i2 >>> 16 & 65535;
   }
  }
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) i7 = 0; else {
   i1 = HEAP32[i4 + 100 >> 2] | 0;
   i3 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i3) i7 = 0; else if (!(HEAP8[i4 + 19 >> 0] | 0)) i7 = 0; else {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i7 = i3 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + (i2 >>> 8 & 255)) | 0;
    i2 = i2 >>> 16 & 65535;
   }
  }
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i1 = 0;
   i5 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i5 = 1;
   } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i1 = 0;
    i5 = 1;
   } else {
    i40 = HEAP16[i4 + 16 >> 1] | 0;
    i1 = i1 + (((i40 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i40 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  if ((i6 | 0) != (i7 | 0)) {
   i4 = i1;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
    i1 = i3 + i8 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  }
  HEAP8[i34 >> 0] = HEAP8[i34 >> 0] | 16;
 }
 i2 = i37 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425968 | 0, gb + 1034406 | 0, i35, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i38); else {
   i1 = HEAP32[i35 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i38 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i38);
 }
 i4 = i37 + 224 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i38, gb + 425980 | 0, HEAP32[gb + 37040 >> 2] | 0, i35, 0) | 0;
 if (!i1) {
  i40 = i37 + 204 | 0;
  __ZN17CollisionMeshData8TransferI14SafeBinaryReadEEvRT_R4Mesh(i40, i38, i37);
  STACKTOP = i39;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i38 + 16 | 0;
  i40 = HEAP32[i38 + 20 >> 2] | 0;
  i2 = i40 + (HEAP32[(HEAP32[i38 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i38 + 36 >> 2] | 0, 0 - (HEAP32[i38 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i40 >>> 0) i36 = 269; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i38 + 24 >> 2] | 0) >>> 0) i36 = 269; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i36 | 0) == 269) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i38 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i35 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i38 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i38);
 i40 = i37 + 204 | 0;
 __ZN17CollisionMeshData8TransferI14SafeBinaryReadEEvRT_R4Mesh(i40, i38, i37);
 STACKTOP = i39;
 return;
}

function __ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f(i96, i105, i94, i106, i95, i64, i97, i81, i80, i76, i3, i78, i1, i61, i79, i100, i101, i91, i93, i102, f103) {
 i96 = i96 | 0;
 i105 = i105 | 0;
 i94 = i94 | 0;
 i106 = i106 | 0;
 i95 = i95 | 0;
 i64 = i64 | 0;
 i97 = i97 | 0;
 i81 = i81 | 0;
 i80 = i80 | 0;
 i76 = i76 | 0;
 i3 = i3 | 0;
 i78 = i78 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i79 = i79 | 0;
 i100 = i100 | 0;
 i101 = i101 | 0;
 i91 = i91 | 0;
 i93 = i93 | 0;
 i102 = i102 | 0;
 f103 = Math_fround(f103);
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, i63 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i77 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i92 = 0, i98 = 0, i99 = 0, i104 = 0, i107 = 0, i108 = 0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0;
 i108 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i77 = i108 + 64 | 0;
 i63 = i108 + 56 | 0;
 i65 = i108 + 52 | 0;
 i66 = i108 + 48 | 0;
 i67 = i108 + 44 | 0;
 i104 = i108 + 32 | 0;
 i99 = i108 + 16 | 0;
 i92 = i108 + 12 | 0;
 i98 = i108;
 if (i93) {
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  f52 = Math_fround(-f2);
  f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f53 = Math_fround(-f4);
  f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f54 = Math_fround(-f5);
  i85 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
  i86 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  i87 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i85 = HEAP32[i1 >> 2] | 0;
  i86 = HEAP32[i1 + 4 >> 2] | 0;
  i90 = HEAP32[i1 + 8 >> 2] | 0;
  f2 = (HEAP32[tempDoublePtr >> 2] = i85, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i86, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i87 = i90;
  f5 = (HEAP32[tempDoublePtr >> 2] = i90, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 i82 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((i96 >>> 0 < i97 >>> 0 ? i97 : i96) * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i83 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i96 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i84 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i96 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i88 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i97 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i89 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i97 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i90 = i91 + 4096 | 0;
 i62 = HEAP32[i90 >> 2] | 0;
 HEAPF32[i63 >> 2] = Math_fround(0.0);
 HEAPF32[i65 >> 2] = Math_fround(0.0);
 HEAPF32[i66 >> 2] = Math_fround(0.0);
 HEAPF32[i67 >> 2] = Math_fround(0.0);
 f49 = Math_fround(Math_fround(HEAPF32[i76 >> 2]) * f2);
 i70 = i76 + 4 | 0;
 f49 = Math_fround(f49 + Math_fround(Math_fround(HEAPF32[i70 >> 2]) * f4));
 i71 = i76 + 8 | 0;
 f49 = Math_fround(f49 + Math_fround(Math_fround(HEAPF32[i71 >> 2]) * f5));
 i72 = i76 + 12 | 0;
 f50 = Math_fround(f2 * Math_fround(HEAPF32[i72 >> 2]));
 i73 = i76 + 16 | 0;
 f50 = Math_fround(f50 + Math_fround(f4 * Math_fround(HEAPF32[i73 >> 2])));
 i74 = i76 + 20 | 0;
 f50 = Math_fround(f50 + Math_fround(f5 * Math_fround(HEAPF32[i74 >> 2])));
 i75 = i76 + 24 | 0;
 f46 = Math_fround(f2 * Math_fround(HEAPF32[i75 >> 2]));
 i69 = i76 + 28 | 0;
 f46 = Math_fround(f46 + Math_fround(f4 * Math_fround(HEAPF32[i69 >> 2])));
 i68 = i76 + 32 | 0;
 f49 = Math_fround(-f49);
 f50 = Math_fround(-f50);
 f46 = Math_fround(-Math_fround(f46 + Math_fround(f5 * Math_fround(HEAPF32[i68 >> 2]))));
 f45 = Math_fround(HEAPF32[i61 >> 2]);
 i40 = i78 + 4 | 0;
 i41 = i61 + 4 | 0;
 f53 = Math_fround(HEAPF32[i41 >> 2]);
 i42 = i78 + 8 | 0;
 i43 = i61 + 8 | 0;
 f47 = Math_fround(HEAPF32[i43 >> 2]);
 i44 = i78 + 12 | 0;
 i55 = i78 + 16 | 0;
 i56 = i78 + 20 | 0;
 f52 = Math_fround(HEAPF32[i78 + 24 >> 2]);
 f45 = Math_fround(f45 * f52);
 f54 = Math_fround(HEAPF32[i78 + 28 >> 2]);
 f53 = Math_fround(f45 + Math_fround(f53 * f54));
 f45 = Math_fround(HEAPF32[i78 + 32 >> 2]);
 f47 = Math_fround(f53 + Math_fround(f47 * f45));
 i57 = i61 + 12 | 0;
 f53 = Math_fround(HEAPF32[i57 >> 2]);
 i58 = i61 + 16 | 0;
 f48 = Math_fround(HEAPF32[i58 >> 2]);
 i59 = i61 + 20 | 0;
 f48 = Math_fround(Math_fround(Math_fround(f52 * f53) + Math_fround(f54 * f48)) + Math_fround(f45 * Math_fround(HEAPF32[i59 >> 2])));
 i60 = i61 + 24 | 0;
 f53 = Math_fround(HEAPF32[i60 >> 2]);
 i35 = i61 + 28 | 0;
 f15 = Math_fround(HEAPF32[i35 >> 2]);
 i36 = i61 + 32 | 0;
 f15 = Math_fround(Math_fround(Math_fround(f52 * f53) + Math_fround(f54 * f15)) + Math_fround(f45 * Math_fround(HEAPF32[i36 >> 2])));
 i37 = i61 + 36 | 0;
 f53 = Math_fround(HEAPF32[i37 >> 2]);
 i38 = i61 + 40 | 0;
 f2 = Math_fround(HEAPF32[i38 >> 2]);
 i39 = i61 + 44 | 0;
 f45 = Math_fround(Math_fround(Math_fround(f52 * f53) + Math_fround(f54 * f2)) + Math_fround(f45 * Math_fround(HEAPF32[i39 >> 2])));
 f2 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f49);
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f50));
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f46));
 if (i97 >>> 0 < 3 | !(+f2 >= 1.0e-07)) {
  _memset(i83 | 0, 0, i96 | 0) | 0;
  _memset(i84 | 0, 0, i96 | 0) | 0;
  i3 = 0;
  i1 = 0;
 } else {
  f14 = Math_fround(Math_fround(1.0) / f2);
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f8 = Math_fround(-f7);
  __ZL17transformVerticesRfS_S_S_PfjPKN5physx6PxVec3EPKhRKNS1_7PxMat33E(i63, i65, i66, i67, i82, i97, i81, i80, i78);
  if (!i96) {
   i3 = 0;
   i1 = 0;
  } else {
   f9 = Math_fround(HEAPF32[i63 >> 2]);
   f10 = Math_fround(HEAPF32[i65 >> 2]);
   f12 = Math_fround(HEAPF32[i66 >> 2]);
   f13 = Math_fround(HEAPF32[i67 >> 2]);
   i21 = i106 + 4 | 0;
   i22 = i106 + 8 | 0;
   i23 = i106 + 12 | 0;
   i24 = i106 + 16 | 0;
   i25 = i106 + 20 | 0;
   i26 = i106 + 24 | 0;
   i27 = i106 + 28 | 0;
   i28 = i106 + 32 | 0;
   i29 = i106 + 36 | 0;
   i30 = i106 + 40 | 0;
   i31 = i106 + 44 | 0;
   i32 = i102 + 4 | 0;
   i33 = i102 + 8 | 0;
   i1 = 0;
   i34 = 0;
   i3 = 0;
   i11 = 0;
   do {
    i16 = i94 + i34 | 0;
    i19 = HEAPU8[i16 >> 0] | 0;
    i17 = i105 + (i19 * 12 | 0) | 0;
    f51 = Math_fround(HEAPF32[i17 >> 2]);
    f2 = Math_fround(f47 * f51);
    i18 = i105 + (i19 * 12 | 0) + 4 | 0;
    f6 = Math_fround(HEAPF32[i18 >> 2]);
    f2 = Math_fround(f2 + Math_fround(f48 * f6));
    i19 = i105 + (i19 * 12 | 0) + 8 | 0;
    f54 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(f45 + Math_fround(f2 + Math_fround(f15 * f54)));
    f4 = Math_fround(f51 * Math_fround(HEAPF32[i61 >> 2]));
    f53 = Math_fround(f51 * Math_fround(HEAPF32[i41 >> 2]));
    f51 = Math_fround(f51 * Math_fround(HEAPF32[i43 >> 2]));
    f5 = Math_fround(f6 * Math_fround(HEAPF32[i57 >> 2]));
    f52 = Math_fround(f6 * Math_fround(HEAPF32[i58 >> 2]));
    f5 = Math_fround(f4 + f5);
    f52 = Math_fround(f53 + f52);
    f6 = Math_fround(f51 + Math_fround(f6 * Math_fround(HEAPF32[i59 >> 2])));
    f51 = Math_fround(f54 * Math_fround(HEAPF32[i60 >> 2]));
    f53 = Math_fround(f54 * Math_fround(HEAPF32[i35 >> 2]));
    f51 = Math_fround(f5 + f51);
    f53 = Math_fround(f52 + f53);
    f54 = Math_fround(f6 + Math_fround(f54 * Math_fround(HEAPF32[i36 >> 2])));
    f51 = Math_fround(f51 + Math_fround(HEAPF32[i37 >> 2]));
    f53 = Math_fround(f53 + Math_fround(HEAPF32[i38 >> 2]));
    f6 = Math_fround(f14 * Math_fround(f7 + f2));
    f51 = Math_fround(f51 - Math_fround(f6 * f49));
    f53 = Math_fround(f53 - Math_fround(f6 * f50));
    f54 = Math_fround(Math_fround(f54 + Math_fround(HEAPF32[i39 >> 2])) - Math_fround(f6 * f46));
    f52 = Math_fround(f51 * Math_fround(HEAPF32[i78 >> 2]));
    f52 = Math_fround(f52 + Math_fround(f53 * Math_fround(HEAPF32[i40 >> 2])));
    f52 = Math_fround(f52 + Math_fround(f54 * Math_fround(HEAPF32[i42 >> 2])));
    f51 = Math_fround(f51 * Math_fround(HEAPF32[i44 >> 2]));
    f53 = Math_fround(f51 + Math_fround(f53 * Math_fround(HEAPF32[i55 >> 2])));
    i20 = __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh(i82, i97, Math_fround(f52 - f9), Math_fround(Math_fround(f53 + Math_fround(f54 * Math_fround(HEAPF32[i56 >> 2]))) - f10), f12, f13, i84 + i34 | 0) | 0;
    HEAP8[i83 + i34 >> 0] = i20 & 1;
    if (i20) {
     i1 = i1 + 1 | 0;
     if (f2 < f8) {
      i20 = HEAP32[i90 >> 2] | 0;
      if (i20 >>> 0 > 63) i11 = 1; else {
       HEAP32[i90 >> 2] = i20 + 1;
       HEAP8[i77 + i3 >> 0] = HEAP8[i16 >> 0] | 0;
       HEAP32[i91 + (i20 << 6) >> 2] = i85;
       HEAP32[i91 + (i20 << 6) + 4 >> 2] = i86;
       HEAP32[i91 + (i20 << 6) + 8 >> 2] = i87;
       f5 = Math_fround(HEAPF32[i17 >> 2]);
       f4 = Math_fround(f5 * Math_fround(HEAPF32[i106 >> 2]));
       f2 = Math_fround(f5 * Math_fround(HEAPF32[i21 >> 2]));
       f5 = Math_fround(f5 * Math_fround(HEAPF32[i22 >> 2]));
       f54 = Math_fround(HEAPF32[i18 >> 2]);
       f52 = Math_fround(f54 * Math_fround(HEAPF32[i23 >> 2]));
       f53 = Math_fround(f54 * Math_fround(HEAPF32[i24 >> 2]));
       f52 = Math_fround(f4 + f52);
       f53 = Math_fround(f2 + f53);
       f54 = Math_fround(f5 + Math_fround(f54 * Math_fround(HEAPF32[i25 >> 2])));
       f5 = Math_fround(HEAPF32[i19 >> 2]);
       f2 = Math_fround(f5 * Math_fround(HEAPF32[i26 >> 2]));
       f4 = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
       f2 = Math_fround(f52 + f2);
       f4 = Math_fround(f53 + f4);
       f5 = Math_fround(f54 + Math_fround(f5 * Math_fround(HEAPF32[i28 >> 2])));
       f2 = Math_fround(f2 + Math_fround(HEAPF32[i29 >> 2]));
       f4 = Math_fround(f4 + Math_fround(HEAPF32[i30 >> 2]));
       f5 = Math_fround(f5 + Math_fround(HEAPF32[i31 >> 2]));
       if (i93) {
        i11 = HEAP32[i102 >> 2] | 0;
        i16 = HEAP32[i32 >> 2] | 0;
        i17 = HEAP32[i33 >> 2] | 0;
       } else {
        i11 = 0;
        i16 = 0;
        i17 = 0;
       }
       f52 = Math_fround(f2 + (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f53 = Math_fround(f4 + (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f54 = Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       HEAPF32[i91 + (i20 << 6) + 16 >> 2] = f52;
       HEAPF32[i91 + (i20 << 6) + 20 >> 2] = f53;
       HEAPF32[i91 + (i20 << 6) + 24 >> 2] = f54;
       HEAPF32[i91 + (i20 << 6) + 12 >> 2] = Math_fround(f6 + f103);
       HEAP32[i91 + (i20 << 6) + 48 >> 2] = i100;
       HEAP32[i91 + (i20 << 6) + 52 >> 2] = i101;
       i3 = i3 + 1 | 0;
       i11 = 1;
      }
     }
    }
    i34 = i34 + 1 | 0;
   } while ((i34 | 0) != (i96 | 0));
   i3 = i1;
   i1 = (i11 & 1) != 0;
  }
 }
 __ZL21ContactReductionAllInRN5physx2Gu13ContactBufferEjjRKNS_7PxMat33EPKNS_6PxVec3EPKh(i91, i62, i3, i64, i105, i77);
 if ((i3 | 0) == (i96 | 0)) {
  i107 = i1;
  STACKTOP = i108;
  return i107 | 0;
 }
 i23 = HEAP32[i90 >> 2] | 0;
 f52 = Math_fround(HEAPF32[i64 >> 2]);
 f54 = Math_fround(HEAPF32[i79 >> 2]);
 f12 = Math_fround(f52 * f54);
 f5 = Math_fround(HEAPF32[i64 + 4 >> 2]);
 i24 = i79 + 4 | 0;
 f47 = Math_fround(HEAPF32[i24 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f5 * f47));
 f50 = Math_fround(HEAPF32[i64 + 8 >> 2]);
 i25 = i79 + 8 | 0;
 f14 = Math_fround(HEAPF32[i25 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f50 * f14));
 f6 = Math_fround(HEAPF32[i64 + 12 >> 2]);
 f13 = Math_fround(f54 * f6);
 f7 = Math_fround(HEAPF32[i64 + 16 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f47 * f7));
 f51 = Math_fround(HEAPF32[i64 + 20 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f14 * f51));
 f8 = Math_fround(HEAPF32[i64 + 24 >> 2]);
 f54 = Math_fround(f54 * f8);
 f10 = Math_fround(HEAPF32[i64 + 28 >> 2]);
 f47 = Math_fround(f54 + Math_fround(f47 * f10));
 f54 = Math_fround(HEAPF32[i64 + 32 >> 2]);
 f14 = Math_fround(f47 + Math_fround(f14 * f54));
 i26 = i79 + 12 | 0;
 f47 = Math_fround(HEAPF32[i26 >> 2]);
 f15 = Math_fround(f52 * f47);
 i27 = i79 + 16 | 0;
 f53 = Math_fround(HEAPF32[i27 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f5 * f53));
 i28 = i79 + 20 | 0;
 f46 = Math_fround(HEAPF32[i28 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f50 * f46));
 f45 = Math_fround(Math_fround(Math_fround(f6 * f47) + Math_fround(f7 * f53)) + Math_fround(f51 * f46));
 f46 = Math_fround(Math_fround(Math_fround(f8 * f47) + Math_fround(f10 * f53)) + Math_fround(f54 * f46));
 i29 = i79 + 24 | 0;
 f53 = Math_fround(HEAPF32[i29 >> 2]);
 f47 = Math_fround(f52 * f53);
 i30 = i79 + 28 | 0;
 f9 = Math_fround(HEAPF32[i30 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f5 * f9));
 i31 = i79 + 32 | 0;
 f49 = Math_fround(HEAPF32[i31 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f50 * f49));
 f48 = Math_fround(Math_fround(Math_fround(f6 * f53) + Math_fround(f7 * f9)) + Math_fround(f51 * f49));
 f49 = Math_fround(Math_fround(Math_fround(f8 * f53) + Math_fround(f10 * f9)) + Math_fround(f54 * f49));
 i32 = i79 + 36 | 0;
 f9 = Math_fround(HEAPF32[i32 >> 2]);
 f52 = Math_fround(f52 * f9);
 i33 = i79 + 40 | 0;
 f53 = Math_fround(HEAPF32[i33 >> 2]);
 f5 = Math_fround(f52 + Math_fround(f5 * f53));
 i34 = i79 + 44 | 0;
 f52 = Math_fround(HEAPF32[i34 >> 2]);
 f50 = Math_fround(f5 + Math_fround(f50 * f52));
 f51 = Math_fround(Math_fround(Math_fround(f6 * f9) + Math_fround(f7 * f53)) + Math_fround(f51 * f52));
 f52 = Math_fround(Math_fround(Math_fround(f8 * f9) + Math_fround(f10 * f53)) + Math_fround(f54 * f52));
 if (i96 >>> 0 > 2) {
  f53 = Math_fround(HEAPF32[i95 + 12 >> 2]);
  f54 = Math_fround(-f53);
  __ZL17transformVerticesRfS_S_S_PfjPKN5physx6PxVec3EPKhRKNS1_7PxMat33E(i63, i65, i66, i67, i82, i96, i105, i94, i64);
  L26 : do if (!i97) i3 = 0; else {
   f10 = Math_fround(HEAPF32[i63 >> 2]);
   f9 = Math_fround(HEAPF32[i65 >> 2]);
   f8 = Math_fround(HEAPF32[i66 >> 2]);
   f7 = Math_fround(HEAPF32[i67 >> 2]);
   i20 = i76 + 36 | 0;
   i21 = i76 + 40 | 0;
   i22 = i76 + 44 | 0;
   i17 = i102 + 4 | 0;
   i18 = i102 + 8 | 0;
   if (i93) {
    i3 = 0;
    i17 = 0;
    i11 = 0;
    while (1) {
     i16 = HEAP8[i80 + i17 >> 0] | 0;
     i67 = i16 & 255;
     f4 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) >> 2]);
     f2 = Math_fround(f12 * f4);
     f5 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) + 4 >> 2]);
     f2 = Math_fround(f2 + Math_fround(f15 * f5));
     f6 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) + 8 >> 2]);
     i67 = __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh(i82, i96, Math_fround(Math_fround(f50 + Math_fround(f2 + Math_fround(f47 * f6))) - f10), Math_fround(Math_fround(f51 + Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f45 * f5)) + Math_fround(f48 * f6))) - f9), f8, f7, i89 + i17 | 0) | 0;
     HEAP8[i88 + i17 >> 0] = i67 & 1;
     if (i67) {
      i3 = i3 + 1 | 0;
      f2 = Math_fround(f52 + Math_fround(Math_fround(Math_fround(f14 * f4) + Math_fround(f46 * f5)) + Math_fround(f49 * f6)));
      if (f2 < f54) {
       i1 = HEAP32[i90 >> 2] | 0;
       if (i1 >>> 0 > 63) i1 = 1; else {
        HEAP32[i90 >> 2] = i1 + 1;
        HEAP8[i77 + i11 >> 0] = i16;
        HEAP32[i91 + (i1 << 6) >> 2] = i85;
        HEAP32[i91 + (i1 << 6) + 4 >> 2] = i86;
        HEAP32[i91 + (i1 << 6) + 8 >> 2] = i87;
        f113 = Math_fround(f4 * Math_fround(HEAPF32[i76 >> 2]));
        f112 = Math_fround(f4 * Math_fround(HEAPF32[i70 >> 2]));
        f109 = Math_fround(f4 * Math_fround(HEAPF32[i71 >> 2]));
        f111 = Math_fround(f5 * Math_fround(HEAPF32[i72 >> 2]));
        f110 = Math_fround(f5 * Math_fround(HEAPF32[i73 >> 2]));
        f111 = Math_fround(f113 + f111);
        f110 = Math_fround(f112 + f110);
        f109 = Math_fround(f109 + Math_fround(f5 * Math_fround(HEAPF32[i74 >> 2])));
        f4 = Math_fround(f6 * Math_fround(HEAPF32[i75 >> 2]));
        f5 = Math_fround(f6 * Math_fround(HEAPF32[i69 >> 2]));
        f4 = Math_fround(f111 + f4);
        f5 = Math_fround(f110 + f5);
        f6 = Math_fround(f109 + Math_fround(f6 * Math_fround(HEAPF32[i68 >> 2])));
        f4 = Math_fround(f4 + Math_fround(HEAPF32[i20 >> 2]));
        f5 = Math_fround(f5 + Math_fround(HEAPF32[i21 >> 2]));
        f5 = Math_fround(f5 + Math_fround(0.0));
        f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i22 >> 2])) + Math_fround(0.0));
        HEAPF32[i91 + (i1 << 6) + 16 >> 2] = Math_fround(f4 + Math_fround(0.0));
        HEAPF32[i91 + (i1 << 6) + 20 >> 2] = f5;
        HEAPF32[i91 + (i1 << 6) + 24 >> 2] = f6;
        HEAPF32[i91 + (i1 << 6) + 12 >> 2] = Math_fround(Math_fround(f53 + f2) + f103);
        HEAP32[i91 + (i1 << 6) + 48 >> 2] = i100;
        HEAP32[i91 + (i1 << 6) + 52 >> 2] = i101;
        i11 = i11 + 1 | 0;
        i1 = 1;
       }
      }
     }
     i17 = i17 + 1 | 0;
     if ((i17 | 0) == (i97 | 0)) break L26;
    }
   }
   i3 = 0;
   i19 = 0;
   i11 = 0;
   do {
    i16 = HEAP8[i80 + i19 >> 0] | 0;
    i67 = i16 & 255;
    f4 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) >> 2]);
    f113 = Math_fround(f12 * f4);
    f5 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) + 4 >> 2]);
    f113 = Math_fround(f113 + Math_fround(f15 * f5));
    f6 = Math_fround(HEAPF32[i81 + (i67 * 12 | 0) + 8 >> 2]);
    i67 = __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh(i82, i96, Math_fround(Math_fround(f50 + Math_fround(f113 + Math_fround(f47 * f6))) - f10), Math_fround(Math_fround(f51 + Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f45 * f5)) + Math_fround(f48 * f6))) - f9), f8, f7, i89 + i19 | 0) | 0;
    HEAP8[i88 + i19 >> 0] = i67 & 1;
    if (i67) {
     i3 = i3 + 1 | 0;
     f2 = Math_fround(f52 + Math_fround(Math_fround(Math_fround(f14 * f4) + Math_fround(f46 * f5)) + Math_fround(f49 * f6)));
     if (f2 < f54) {
      i1 = HEAP32[i90 >> 2] | 0;
      if (i1 >>> 0 > 63) i1 = 1; else {
       HEAP32[i90 >> 2] = i1 + 1;
       HEAP8[i77 + i11 >> 0] = i16;
       HEAP32[i91 + (i1 << 6) >> 2] = i85;
       HEAP32[i91 + (i1 << 6) + 4 >> 2] = i86;
       HEAP32[i91 + (i1 << 6) + 8 >> 2] = i87;
       f109 = Math_fround(f4 * Math_fround(HEAPF32[i76 >> 2]));
       f110 = Math_fround(f4 * Math_fround(HEAPF32[i70 >> 2]));
       f113 = Math_fround(f4 * Math_fround(HEAPF32[i71 >> 2]));
       f112 = Math_fround(f5 * Math_fround(HEAPF32[i72 >> 2]));
       f111 = Math_fround(f5 * Math_fround(HEAPF32[i73 >> 2]));
       f112 = Math_fround(f109 + f112);
       f111 = Math_fround(f110 + f111);
       f113 = Math_fround(f113 + Math_fround(f5 * Math_fround(HEAPF32[i74 >> 2])));
       f110 = Math_fround(f6 * Math_fround(HEAPF32[i75 >> 2]));
       f109 = Math_fround(f6 * Math_fround(HEAPF32[i69 >> 2]));
       f110 = Math_fround(f112 + f110);
       f109 = Math_fround(f111 + f109);
       f113 = Math_fround(f113 + Math_fround(f6 * Math_fround(HEAPF32[i68 >> 2])));
       f110 = Math_fround(f110 + Math_fround(HEAPF32[i20 >> 2]));
       f109 = Math_fround(f109 + Math_fround(HEAPF32[i21 >> 2]));
       f113 = Math_fround(f113 + Math_fround(HEAPF32[i22 >> 2]));
       f111 = Math_fround(HEAPF32[i102 >> 2]);
       f112 = Math_fround(HEAPF32[i17 >> 2]);
       f112 = Math_fround(f109 + f112);
       f113 = Math_fround(f113 + Math_fround(HEAPF32[i18 >> 2]));
       HEAPF32[i91 + (i1 << 6) + 16 >> 2] = Math_fround(f110 + f111);
       HEAPF32[i91 + (i1 << 6) + 20 >> 2] = f112;
       HEAPF32[i91 + (i1 << 6) + 24 >> 2] = f113;
       HEAPF32[i91 + (i1 << 6) + 12 >> 2] = Math_fround(Math_fround(f53 + f2) + f103);
       HEAP32[i91 + (i1 << 6) + 48 >> 2] = i100;
       HEAP32[i91 + (i1 << 6) + 52 >> 2] = i101;
       i11 = i11 + 1 | 0;
       i1 = 1;
      }
     }
    }
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) != (i97 | 0));
  } while (0);
  __ZL21ContactReductionAllInRN5physx2Gu13ContactBufferEjjRKNS_7PxMat33EPKNS_6PxVec3EPKh(i91, i23, i3, i78, i81, i77);
  if ((i3 | 0) == (i97 | 0)) {
   i107 = i1;
   STACKTOP = i108;
   return i107 | 0;
  }
 } else {
  _memset(i88 | 0, 0, i97 | 0) | 0;
  _memset(i89 | 0, 0, i97 | 0) | 0;
 }
 if (!i97) {
  i107 = i1;
  STACKTOP = i108;
  return i107 | 0;
 }
 f15 = Math_fround(HEAPF32[i79 >> 2]);
 f14 = Math_fround(HEAPF32[i24 >> 2]);
 f13 = Math_fround(HEAPF32[i25 >> 2]);
 f12 = Math_fround(HEAPF32[i26 >> 2]);
 f10 = Math_fround(HEAPF32[i27 >> 2]);
 f9 = Math_fround(HEAPF32[i28 >> 2]);
 f8 = Math_fround(HEAPF32[i29 >> 2]);
 f7 = Math_fround(HEAPF32[i30 >> 2]);
 f6 = Math_fround(HEAPF32[i31 >> 2]);
 f5 = Math_fround(HEAPF32[i32 >> 2]);
 f4 = Math_fround(HEAPF32[i33 >> 2]);
 f2 = Math_fround(HEAPF32[i34 >> 2]);
 i3 = 0;
 do {
  i79 = HEAPU8[i80 + i3 >> 0] | 0;
  f111 = Math_fround(HEAPF32[i81 + (i79 * 12 | 0) >> 2]);
  f110 = Math_fround(f111 * f15);
  f112 = Math_fround(f111 * f14);
  f111 = Math_fround(f111 * f13);
  f113 = Math_fround(HEAPF32[i81 + (i79 * 12 | 0) + 4 >> 2]);
  f110 = Math_fround(f110 + Math_fround(f113 * f12));
  f112 = Math_fround(f112 + Math_fround(f113 * f10));
  f113 = Math_fround(f111 + Math_fround(f113 * f9));
  f111 = Math_fround(HEAPF32[i81 + (i79 * 12 | 0) + 8 >> 2]);
  f112 = Math_fround(Math_fround(f112 + Math_fround(f111 * f7)) + f4);
  f113 = Math_fround(Math_fround(f113 + Math_fround(f111 * f6)) + f2);
  HEAPF32[i82 + (i3 * 12 | 0) >> 2] = Math_fround(Math_fround(f110 + Math_fround(f111 * f8)) + f5);
  HEAPF32[i82 + (i3 * 12 | 0) + 4 >> 2] = f112;
  HEAPF32[i82 + (i3 * 12 | 0) + 8 >> 2] = f113;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i97 | 0));
 if (i97 >>> 0 < 2 | i96 >>> 0 < 2) {
  i107 = i1;
  STACKTOP = i108;
  return i107 | 0;
 }
 i22 = i104 + 4 | 0;
 i23 = i104 + 8 | 0;
 i24 = i95 + 8 | 0;
 i25 = i95 + 4 | 0;
 i26 = i99 + 4 | 0;
 i27 = i99 + 8 | 0;
 i28 = i99 + 12 | 0;
 i29 = (i96 | 0) == 0;
 i30 = i106 + 4 | 0;
 i31 = i106 + 8 | 0;
 i32 = i98 + 4 | 0;
 i33 = i106 + 12 | 0;
 i34 = i106 + 16 | 0;
 i35 = i106 + 20 | 0;
 i36 = i98 + 8 | 0;
 i37 = i106 + 24 | 0;
 i38 = i106 + 28 | 0;
 i39 = i106 + 32 | 0;
 i40 = i106 + 36 | 0;
 i41 = i106 + 40 | 0;
 i42 = i106 + 44 | 0;
 i43 = i102 + 4 | 0;
 i44 = i102 + 8 | 0;
 i3 = 0;
 L57 : while (1) {
  i11 = i3;
  while (1) {
   i16 = i11;
   i11 = i11 + 1 | 0;
   i3 = i11 >>> 0 >= i97 >>> 0 ? 0 : i11;
   if (!(HEAP8[i88 + i16 >> 0] | 0)) i107 = 43; else if (!(HEAP8[i88 + i3 >> 0] | 0)) i107 = 43;
   if ((i107 | 0) == 43) {
    i107 = 0;
    if (!((HEAP8[i89 + i3 >> 0] & HEAP8[i89 + i16 >> 0]) << 24 >> 24)) break;
   }
   if (i11 >>> 0 >= i97 >>> 0) {
    i107 = 67;
    break L57;
   }
  }
  i20 = i82 + (i16 * 12 | 0) | 0;
  i21 = i82 + (i3 * 12 | 0) | 0;
  f54 = Math_fround(HEAPF32[i21 >> 2]);
  f110 = Math_fround(HEAPF32[i20 >> 2]);
  f54 = Math_fround(f54 - f110);
  f109 = Math_fround(HEAPF32[i82 + (i3 * 12 | 0) + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i82 + (i16 * 12 | 0) + 4 >> 2]);
  f109 = Math_fround(f109 - f111);
  f52 = Math_fround(HEAPF32[i82 + (i3 * 12 | 0) + 8 >> 2]);
  f112 = Math_fround(HEAPF32[i82 + (i16 * 12 | 0) + 8 >> 2]);
  f52 = Math_fround(f52 - f112);
  HEAPF32[i104 >> 2] = f54;
  HEAPF32[i22 >> 2] = f109;
  HEAPF32[i23 >> 2] = f52;
  f113 = Math_fround(HEAPF32[i24 >> 2]);
  f2 = Math_fround(f109 * f113);
  f53 = Math_fround(HEAPF32[i25 >> 2]);
  f2 = Math_fround(f2 - Math_fround(f52 * f53));
  f4 = Math_fround(HEAPF32[i95 >> 2]);
  f113 = Math_fround(Math_fround(f52 * f4) - Math_fround(f113 * f54));
  f4 = Math_fround(Math_fround(f53 * f54) - Math_fround(f109 * f4));
  f112 = Math_fround(-Math_fround(Math_fround(Math_fround(f2 * f110) + Math_fround(f113 * f111)) + Math_fround(f4 * f112)));
  HEAPF32[i99 >> 2] = f2;
  HEAPF32[i26 >> 2] = f113;
  HEAPF32[i27 >> 2] = f4;
  HEAPF32[i28 >> 2] = f112;
  f2 = Math_fround(Math_abs(Math_fround(f2)));
  f113 = Math_fround(Math_abs(Math_fround(f113)));
  f4 = Math_fround(Math_abs(Math_fround(f4)));
  if (f113 > f2 & f113 > f4) {
   i18 = 2;
   i19 = 0;
  } else if (f4 > f2) {
   i18 = 0;
   i19 = 1;
  } else {
   i18 = 1;
   i19 = 2;
  }
  f113 = Math_fround(HEAPF32[i104 + (i18 << 2) >> 2]);
  f113 = Math_fround(f113 * Math_fround(HEAPF32[i95 + (i19 << 2) >> 2]));
  f2 = Math_fround(HEAPF32[i104 + (i19 << 2) >> 2]);
  f2 = Math_fround(Math_fround(1.0) / Math_fround(f113 - Math_fround(f2 * Math_fround(HEAPF32[i95 + (i18 << 2) >> 2]))));
  L71 : do if (!i29) if (i93) {
   i3 = 0;
   while (1) {
    while (1) {
     i17 = i3;
     i3 = i3 + 1 | 0;
     i16 = i3 >>> 0 >= i96 >>> 0 ? 0 : i3;
     if (!(HEAP8[i83 + i17 >> 0] | 0)) i107 = 52; else if (!(HEAP8[i83 + i16 >> 0] | 0)) i107 = 52;
     if ((i107 | 0) == 52) {
      i107 = 0;
      if (!((HEAP8[i84 + i16 >> 0] & HEAP8[i84 + i17 >> 0]) << 24 >> 24)) if (__Z22EdgeEdgeContactSpecialRKN5physx6PxVec3ERKNS_7PxPlaneES2_S2_S2_S2_S2_RfRS0_jjf(i104, i99, i20, i21, i95, i105 + ((HEAPU8[i94 + i17 >> 0] | 0) * 12 | 0) | 0, i105 + ((HEAPU8[i94 + i16 >> 0] | 0) * 12 | 0) | 0, i92, i98, i18, i19, f2) | 0) {
       i1 = i3;
       break;
      }
     }
     if (i3 >>> 0 >= i96 >>> 0) break L71;
    }
    i3 = HEAP32[i90 >> 2] | 0;
    if (i3 >>> 0 <= 63) {
     HEAP32[i90 >> 2] = i3 + 1;
     HEAP32[i91 + (i3 << 6) >> 2] = i85;
     HEAP32[i91 + (i3 << 6) + 4 >> 2] = i86;
     HEAP32[i91 + (i3 << 6) + 8 >> 2] = i87;
     f113 = Math_fround(HEAPF32[i98 >> 2]);
     f112 = Math_fround(f113 * Math_fround(HEAPF32[i106 >> 2]));
     f111 = Math_fround(f113 * Math_fround(HEAPF32[i30 >> 2]));
     f113 = Math_fround(f113 * Math_fround(HEAPF32[i31 >> 2]));
     f110 = Math_fround(HEAPF32[i32 >> 2]);
     f54 = Math_fround(f110 * Math_fround(HEAPF32[i33 >> 2]));
     f109 = Math_fround(f110 * Math_fround(HEAPF32[i34 >> 2]));
     f54 = Math_fround(f112 + f54);
     f109 = Math_fround(f111 + f109);
     f110 = Math_fround(f113 + Math_fround(f110 * Math_fround(HEAPF32[i35 >> 2])));
     f113 = Math_fround(HEAPF32[i36 >> 2]);
     f111 = Math_fround(f113 * Math_fround(HEAPF32[i37 >> 2]));
     f112 = Math_fround(f113 * Math_fround(HEAPF32[i38 >> 2]));
     f111 = Math_fround(f54 + f111);
     f112 = Math_fround(f109 + f112);
     f113 = Math_fround(f110 + Math_fround(f113 * Math_fround(HEAPF32[i39 >> 2])));
     f111 = Math_fround(f111 + Math_fround(HEAPF32[i40 >> 2]));
     f112 = Math_fround(f112 + Math_fround(HEAPF32[i41 >> 2]));
     f112 = Math_fround(f112 + Math_fround(0.0));
     f113 = Math_fround(Math_fround(f113 + Math_fround(HEAPF32[i42 >> 2])) + Math_fround(0.0));
     HEAPF32[i91 + (i3 << 6) + 16 >> 2] = Math_fround(f111 + Math_fround(0.0));
     HEAPF32[i91 + (i3 << 6) + 20 >> 2] = f112;
     HEAPF32[i91 + (i3 << 6) + 24 >> 2] = f113;
     HEAPF32[i91 + (i3 << 6) + 12 >> 2] = Math_fround(f103 - Math_fround(HEAPF32[i92 >> 2]));
     HEAP32[i91 + (i3 << 6) + 48 >> 2] = i100;
     HEAP32[i91 + (i3 << 6) + 52 >> 2] = i101;
    }
    if (i1 >>> 0 < i96 >>> 0) {
     i3 = i1;
     i1 = 1;
    } else {
     i1 = 1;
     break;
    }
   }
  } else {
   i3 = 0;
   while (1) {
    while (1) {
     i17 = i3;
     i3 = i3 + 1 | 0;
     i16 = i3 >>> 0 >= i96 >>> 0 ? 0 : i3;
     if (!(HEAP8[i83 + i17 >> 0] | 0)) i107 = 62; else if (!(HEAP8[i83 + i16 >> 0] | 0)) i107 = 62;
     if ((i107 | 0) == 62) {
      i107 = 0;
      if (!((HEAP8[i84 + i16 >> 0] & HEAP8[i84 + i17 >> 0]) << 24 >> 24)) if (__Z22EdgeEdgeContactSpecialRKN5physx6PxVec3ERKNS_7PxPlaneES2_S2_S2_S2_S2_RfRS0_jjf(i104, i99, i20, i21, i95, i105 + ((HEAPU8[i94 + i17 >> 0] | 0) * 12 | 0) | 0, i105 + ((HEAPU8[i94 + i16 >> 0] | 0) * 12 | 0) | 0, i92, i98, i18, i19, f2) | 0) {
       i1 = i3;
       break;
      }
     }
     if (i3 >>> 0 >= i96 >>> 0) break L71;
    }
    i3 = HEAP32[i90 >> 2] | 0;
    if (i3 >>> 0 <= 63) {
     HEAP32[i90 >> 2] = i3 + 1;
     HEAP32[i91 + (i3 << 6) >> 2] = i85;
     HEAP32[i91 + (i3 << 6) + 4 >> 2] = i86;
     HEAP32[i91 + (i3 << 6) + 8 >> 2] = i87;
     f113 = Math_fround(HEAPF32[i98 >> 2]);
     f109 = Math_fround(f113 * Math_fround(HEAPF32[i106 >> 2]));
     f110 = Math_fround(f113 * Math_fround(HEAPF32[i30 >> 2]));
     f113 = Math_fround(f113 * Math_fround(HEAPF32[i31 >> 2]));
     f111 = Math_fround(HEAPF32[i32 >> 2]);
     f54 = Math_fround(f111 * Math_fround(HEAPF32[i33 >> 2]));
     f112 = Math_fround(f111 * Math_fround(HEAPF32[i34 >> 2]));
     f54 = Math_fround(f109 + f54);
     f112 = Math_fround(f110 + f112);
     f111 = Math_fround(f113 + Math_fround(f111 * Math_fround(HEAPF32[i35 >> 2])));
     f113 = Math_fround(HEAPF32[i36 >> 2]);
     f110 = Math_fround(f113 * Math_fround(HEAPF32[i37 >> 2]));
     f109 = Math_fround(f113 * Math_fround(HEAPF32[i38 >> 2]));
     f110 = Math_fround(f54 + f110);
     f109 = Math_fround(f112 + f109);
     f113 = Math_fround(f111 + Math_fround(f113 * Math_fround(HEAPF32[i39 >> 2])));
     f110 = Math_fround(f110 + Math_fround(HEAPF32[i40 >> 2]));
     f109 = Math_fround(f109 + Math_fround(HEAPF32[i41 >> 2]));
     f113 = Math_fround(f113 + Math_fround(HEAPF32[i42 >> 2]));
     f111 = Math_fround(HEAPF32[i102 >> 2]);
     f112 = Math_fround(HEAPF32[i43 >> 2]);
     f112 = Math_fround(f109 + f112);
     f113 = Math_fround(f113 + Math_fround(HEAPF32[i44 >> 2]));
     HEAPF32[i91 + (i3 << 6) + 16 >> 2] = Math_fround(f110 + f111);
     HEAPF32[i91 + (i3 << 6) + 20 >> 2] = f112;
     HEAPF32[i91 + (i3 << 6) + 24 >> 2] = f113;
     HEAPF32[i91 + (i3 << 6) + 12 >> 2] = Math_fround(f103 - Math_fround(HEAPF32[i92 >> 2]));
     HEAP32[i91 + (i3 << 6) + 48 >> 2] = i100;
     HEAP32[i91 + (i3 << 6) + 52 >> 2] = i101;
    }
    if (i1 >>> 0 < i96 >>> 0) {
     i3 = i1;
     i1 = 1;
    } else {
     i1 = 1;
     break;
    }
   }
  } while (0);
  if (i11 >>> 0 < i97 >>> 0) i3 = i11; else {
   i107 = 67;
   break;
  }
 }
 if ((i107 | 0) == 67) {
  STACKTOP = i108;
  return i1 | 0;
 }
 return 0;
}

function __Z28CalculateAllObjectReferencesR13dynamic_arrayIP6ObjectLj4EERS_IPKcLj4EERS_IjLj4EES9_b(i3, i30, i36, i34, i4) {
 i3 = i3 | 0;
 i30 = i30 | 0;
 i36 = i36 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i43 + 24 | 0;
 i31 = i43;
 i32 = i43 + 248 | 0;
 i33 = i43 + 228 | 0;
 i42 = i43 + 120 | 0;
 i35 = i43 + 32 | 0;
 i39 = gb + 64016 | 0;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i25 = i31;
 HEAP32[i25 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i25 + 4 >> 2] = i38;
 HEAP32[i42 >> 2] = 0;
 i25 = i42 + 12 | 0;
 HEAP32[i25 >> 2] = 0;
 i38 = i42 + 16 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i42 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, i31);
 i40 = i37;
 i19 = HEAP32[i40 + 4 >> 2] | 0;
 i18 = i39;
 HEAP32[i18 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 i18 = i42 + 20 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i42 + 32 | 0;
 HEAP32[i19 >> 2] = 0;
 i40 = i42 + 36 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = i42 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
 i15 = i37;
 i5 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i41;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i5;
 HEAP32[i42 + 48 >> 2] = 0;
 HEAP8[i42 + 52 >> 0] = 0;
 HEAP8[i42 + 53 >> 0] = 0;
 i17 = i42 + 56 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i17 = i42 + 76 | 0;
 HEAP32[i17 >> 2] = 32;
 HEAP32[i42 + 80 >> 2] = 0;
 HEAP32[i42 + 96 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f44 = Math_fround((HEAP32[i17 >> 2] | 0) >>> 0);
 HEAP32[i42 + 88 >> 2] = ~~Math_fround(f44 * Math_fround(.5)) >>> 0;
 HEAP32[i42 + 84 >> 2] = ~~Math_fround(f44 * Math_fround(.200000003)) >>> 0;
 HEAP8[i42 + 92 >> 0] = 0;
 HEAP8[i42 + 105 >> 0] = 1;
 i17 = i42 + 104 | 0;
 HEAP8[i17 >> 0] = i4 & 1;
 __ZL18FindAllLiveObjectsR21GarbageCollectorState(i42);
 __ZL44CreateObjectToIndexMappingFromNonRootObjectsR21GarbageCollectorState(i42);
 i5 = HEAP32[i25 >> 2] | 0;
 i15 = i3 + 12 | 0;
 HEAP32[i15 >> 2] = i5;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i5 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i1 >> 2] = i5;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i5 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i29 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i3 >> 2] = i29;
  }
  i5 = HEAP32[i15 >> 2] | 0;
 }
 if (i5 | 0) {
  i1 = 0;
  do {
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[(HEAP32[i42 >> 2] | 0) + (i1 << 3) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 if (i4) {
  i1 = i5 << 1;
  i2 = i34 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i5 << 3, 4, i34 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i34 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i29 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i34 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i34 >> 2] = i29;
   break;
  } while (0);
  i1 = (HEAP32[i15 >> 2] | 0) + 20 | 0;
  i27 = i36 + 16 | 0;
  i2 = HEAP32[i27 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i27 >> 2] = i1;
   HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i29 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i36 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i27 >> 2] = i1;
   HEAP32[i36 >> 2] = i29;
   break;
  } while (0);
  i14 = i35 + 4 | 0;
  HEAP32[i14 >> 2] = i42;
  i8 = i35 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  i16 = i35 + 20 | 0;
  HEAP32[i16 >> 2] = 0;
  i28 = i35 + 24 | 0;
  HEAP32[i28 >> 2] = 0;
  i29 = i35 + 12 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
  i22 = i37;
  i23 = HEAP32[i22 + 4 >> 2] | 0;
  i26 = i29;
  HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i26 + 4 >> 2] = i23;
  __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb(i35 + 36 | 0, 33562624, 0);
  i26 = i35 + 80 | 0;
  HEAP32[i26 >> 2] = gb + 64712 + 8;
  HEAP32[i35 + 84 >> 2] = i35;
  HEAP32[i35 + 52 >> 2] = i26;
  HEAP32[i35 + 28 >> 2] = 0;
  HEAPF32[i35 + 32 >> 2] = Math_fround(0.0);
  if (HEAP32[i15 >> 2] | 0) {
   i9 = i35 + 8 | 0;
   i10 = i42 + 40 | 0;
   i11 = i36 + 12 | 0;
   i12 = i36 + 4 | 0;
   i13 = i34 + 12 | 0;
   i7 = 0;
   do {
    i3 = (HEAP32[i42 >> 2] | 0) + (i7 << 3) + 4 | 0;
    if ((HEAP32[i3 >> 2] & 536870911 | 0) == 114) {
     i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0;
     i2 = HEAP32[i28 >> 2] | 0;
     do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i28 >> 2] = i1;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i26 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i1;
      HEAP32[i9 >> 2] = i26;
      break;
     } while (0);
     if (HEAP8[(HEAP32[i14 >> 2] | 0) + 104 >> 0] | 0) {
      i26 = __Z19GetScriptingManagerv() | 0;
      HEAP32[i35 >> 2] = __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_(HEAP32[(HEAP32[i26 + 168 >> 2] | 0) + (HEAP32[gb + 28304 + 24 >> 2] << 2) >> 2] | 0, i1, fb + 533 | 0, i35, fb + 73 | 0, fb + 74 | 0) | 0;
     }
     HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
     if (HEAP8[i17 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
    }
    i1 = HEAP32[i3 >> 2] | 0;
    i26 = i1 & 536870911;
    if ((i26 | 0) != 78 & (((i26 | 0) == 43 | ((i26 | 0) == 142 | ((i26 | 0) == 84 | ((i26 | 0) == 158 | ((i26 | 0) == 171 | ((i26 | 0) == 89 | ((i26 + -187 | 0) >>> 0 < 2 | ((i26 | 0) == 117 | ((i26 + -27 | 0) >>> 0 < 2 | ((i26 | 0) == 150 | ((i26 | 0) == 147 | ((i26 | 0) == 115 | (i26 | 0) == 149)))))))))))) ^ 1)) {
     HEAP32[i3 >> 2] = i1 | 536870912;
     __Z16MarkDependenciesR27GarbageCollectorThreadStatej(i35, i7);
     i1 = HEAP32[i3 >> 2] & -536870913;
     HEAP32[i3 >> 2] = i1;
    }
    if ((i1 & 536870911 | 0) == 114) {
     if (HEAP8[i17 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
     if (HEAP8[(HEAP32[i14 >> 2] | 0) + 104 >> 0] | 0) __Z34scripting_liveness_calculation_endPv(HEAP32[i35 >> 2] | 0);
    }
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i27 >> 2] = i1;
      HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i26 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i27 >> 2] = i1;
      HEAP32[i36 >> 2] = i26;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    i26 = HEAP32[i8 >> 2] | 0;
    __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i13 >> 2] << 2) | 0, i26, i26 + (HEAP32[i16 >> 2] << 2) | 0) | 0;
    if (HEAP32[i16 >> 2] | 0) {
     i2 = HEAP32[i42 >> 2] | 0;
     i1 = 0;
     do {
      i26 = i2 + (HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] << 3) + 4 | 0;
      HEAP32[i26 >> 2] = HEAP32[i26 >> 2] & -536870913;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
    }
    HEAP32[i16 >> 2] = 0;
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
  }
  i22 = i30 + 12 | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i23 = i30 + 16 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i26 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i26;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 451867;
  i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0;
  i26 = i35 + 8 | 0;
  i2 = HEAP32[i28 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i28 >> 2] = i1;
   HEAP32[i26 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i26 >> 2] | 0, i1 << 2, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i21 | 0, HEAP32[i26 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i26 >> 2] = i21;
   break;
  } while (0);
  if (HEAP8[(HEAP32[i14 >> 2] | 0) + 104 >> 0] | 0) {
   i21 = __Z19GetScriptingManagerv() | 0;
   HEAP32[i35 >> 2] = __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_(HEAP32[(HEAP32[i21 + 168 >> 2] | 0) + (HEAP32[gb + 28304 + 24 >> 2] << 2) >> 2] | 0, i1, fb + 533 | 0, i35, fb + 73 | 0, fb + 74 | 0) | 0;
  }
  HEAP32[i42 + 40 >> 2] = HEAP32[i19 >> 2];
  if (HEAP8[i17 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
  if (HEAP8[(HEAP32[i14 >> 2] | 0) + 104 >> 0] | 0) __Z43scripting_liveness_calculation_from_staticsPv(HEAP32[i35 >> 2] | 0);
  if (HEAP8[i17 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
  if (HEAP8[(HEAP32[i14 >> 2] | 0) + 104 >> 0] | 0) __Z34scripting_liveness_calculation_endPv(HEAP32[i35 >> 2] | 0);
  i2 = HEAP32[i16 >> 2] | 0;
  i21 = i36 + 12 | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i20 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i20;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i20 = i34 + 12 | 0;
  i17 = HEAP32[i26 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i17, i17 + (HEAP32[i16 >> 2] << 2) | 0) | 0;
  if (HEAP32[i16 >> 2] | 0) {
   i2 = HEAP32[i42 >> 2] | 0;
   i1 = 0;
   do {
    i17 = i2 + (HEAP32[(HEAP32[i26 >> 2] | 0) + (i1 << 2) >> 2] << 3) + 4 | 0;
    HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -536870913;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
  }
  HEAP32[i16 >> 2] = 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 464723;
  i1 = 0;
  do {
   if (__Z24GetManagerPtrFromContexti(i1) | 0) __Z20MarkInstanceIDAsRootiR21GarbageCollectorState(HEAP32[(__Z24GetManagerPtrFromContexti(i1) | 0) + 4 >> 2] | 0, i42);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 24);
  i2 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i17 = HEAP32[i18 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i17, i17 + (HEAP32[i19 >> 2] << 2) | 0) | 0;
  if (HEAP32[i19 >> 2] | 0) {
   i2 = HEAP32[i42 >> 2] | 0;
   i1 = 0;
   do {
    i17 = i2 + (HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] << 3) + 4 | 0;
    HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -536870913;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0);
  }
  HEAP32[i19 >> 2] = 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 >= i1 >>> 0) break;
   if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 451891;
  i2 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 >= i1 >>> 0) break;
   if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i17 = HEAP32[i18 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i17, i17 + (HEAP32[i19 >> 2] << 2) | 0) | 0;
  if (HEAP32[i19 >> 2] | 0) {
   i2 = HEAP32[i42 >> 2] | 0;
   i1 = 0;
   do {
    i17 = i2 + (HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] << 3) + 4 | 0;
    HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -536870913;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0);
  }
  HEAP32[i19 >> 2] = 0;
  HEAP32[i31 >> 2] = 0;
  i10 = i31 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i12 = i31 + 16 | 0;
  HEAP32[i12 >> 2] = 0;
  i13 = i31 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
  i15 = i37;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i11 = i13;
  HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i11 + 4 >> 2] = i14;
  HEAP32[i32 >> 2] = 0;
  i11 = i32 + 12 | 0;
  HEAP32[i11 >> 2] = 0;
  i14 = i32 + 16 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i32 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
  i18 = i37;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i16 = i15;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i33 >> 2] = 0;
  i16 = i33 + 12 | 0;
  HEAP32[i16 >> 2] = 0;
  i17 = i33 + 16 | 0;
  HEAP32[i17 >> 2] = 0;
  i18 = i33 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
  i8 = i37;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i19 = i18;
  HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 + 4 >> 2] = i9;
  if (HEAP32[i25 >> 2] | 0) {
   i9 = 0;
   do {
    i8 = HEAP32[i42 >> 2] | 0;
    i4 = i8 + (i9 << 3) | 0;
    i8 = HEAP32[i8 + (i9 << 3) + 4 >> 2] | 0;
    i7 = i8 & 536870911;
    L155 : do if (!(i8 & 1073741824)) {
     L157 : do switch (i8 & 536870911 | 0) {
     case 114:
      {
       if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0)) {
        i24 = 147;
        break L155;
       }
       i1 = HEAP32[gb + 1110260 >> 2] | 0;
       i24 = 132;
       break;
      }
     case 1:
      break;
     default:
      {
       i1 = HEAP32[gb + 1110260 >> 2] | 0;
       if (i7 >>> 0 <= 99999) {
        i24 = 132;
        break L157;
       }
       i5 = (HEAP32[i1 + 24 >> 2] | 0) + (i7 + -1e5 << 3) | 0;
       i6 = HEAP32[i1 + 4 >> 2] | 0;
       i24 = 133;
      }
     } while (0);
     if ((i24 | 0) == 132) {
      i6 = HEAP32[i1 + 4 >> 2] | 0;
      i5 = i6 + (i7 << 3) | 0;
      i24 = 133;
     }
     do if ((i24 | 0) == 133) {
      i24 = 0;
      i2 = HEAP32[i6 + 16 >> 2] | 0;
      i3 = HEAP32[i6 + 20 >> 2] | 0;
      if (((HEAP32[i5 >> 2] | 0) - i2 | 0) >>> 0 < i3 >>> 0) break;
      switch (i8 & 536870911 | 0) {
      case 4:
       {
        i24 = 148;
        break L155;
       }
      case 114:
       if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0)) {
        i24 = 147;
        break L155;
       } else {
        i24 = 148;
        break L155;
       }
      default:
       {}
      }
      if (i7 >>> 0 > 99999) i1 = (HEAP32[i1 + 24 >> 2] | 0) + (i7 + -1e5 << 3) | 0; else i1 = i6 + (i7 << 3) | 0;
      if ((i7 | 0) == 142 ? 1 : ((HEAP32[i1 >> 2] | 0) - i2 | 0) >>> 0 < i3 >>> 0) {
       i24 = 148;
       break L155;
      } else {
       i24 = 147;
       break L155;
      }
     } while (0);
     i2 = HEAP32[i10 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 >= i1 >>> 0) break;
      if ((i4 | 0) > -1) {
       HEAP32[i12 >> 2] = i1;
       HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i19 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i31 >> 2] = i19;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i3;
     HEAP32[(HEAP32[i31 >> 2] | 0) + (i2 << 2) >> 2] = i9;
    } else if ((i7 | 0) == 142) i24 = 148; else i24 = 147; while (0);
    if ((i24 | 0) == 147) {
     i24 = 0;
     if (i8 >> 31 & 2 | 0) i24 = 148;
    }
    if ((i24 | 0) == 148) {
     i24 = 0;
     i2 = HEAP32[i11 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i14 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 >= i1 >>> 0) break;
      if ((i4 | 0) > -1) {
       HEAP32[i14 >> 2] = i1;
       HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i19 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
       HEAP32[i14 >> 2] = i1;
       HEAP32[i32 >> 2] = i19;
       break;
      }
     } while (0);
     HEAP32[i11 >> 2] = i3;
     HEAP32[(HEAP32[i32 >> 2] | 0) + (i2 << 2) >> 2] = i9;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
  }
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 >= i1 >>> 0) break;
   if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 451901;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 >= i1 >>> 0) break;
   if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i2 = HEAP32[i31 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i2, i2 + (HEAP32[i10 >> 2] << 2) | 0) | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 >= i1 >>> 0) break;
   if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 451914;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 >= i1 >>> 0) break;
   if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i2 = HEAP32[i32 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i2, i2 + (HEAP32[i11 >> 2] << 2) | 0) | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 >= i1 >>> 0) break;
   if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i30 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i22 >> 2] = i3;
  HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = gb + 451954;
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 >= i1 >>> 0) break;
   if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i30 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i36 >> 2] = i30;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i4;
  HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i1 = HEAP32[i33 >> 2] | 0;
  __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i34, (HEAP32[i34 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) | 0, i1, i1 + (HEAP32[i16 >> 2] << 2) | 0) | 0;
  if ((HEAP32[i17 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
   HEAP32[i33 >> 2] = 0;
  }
  if ((HEAP32[i14 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i15);
   HEAP32[i32 >> 2] = 0;
  }
  if ((HEAP32[i12 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i13);
   HEAP32[i31 >> 2] = 0;
  }
  i1 = HEAP32[i35 + 56 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = i35 + 60 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   i36 = HEAP32[i35 + 68 >> 2] | 0;
   HEAP32[i37 >> 2] = 1;
   HEAP32[i37 + 4 >> 2] = i36;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i37);
  }
  if ((HEAP32[i28 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i29);
   HEAP32[i26 >> 2] = 0;
  }
 } else {
  i1 = i34 + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, i34 + 4 | 0);
   HEAP32[i34 >> 2] = 0;
   i5 = HEAP32[i15 >> 2] | 0;
  }
  HEAP32[i34 >> 2] = 0;
  HEAP32[i34 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i4 = i36 + 12 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  i2 = i36 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i5;
   HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i5 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i35 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i36 >> 2] = i35;
   break;
  } while (0);
  if (i5 >>> 0 > i1 >>> 0) _memset((HEAP32[i36 >> 2] | 0) + (i1 << 2) | 0, 0, i5 - i1 << 2 | 0) | 0;
  i1 = i30 + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i30 + 4 | 0);
   HEAP32[i30 >> 2] = 0;
  }
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i42 + 72 >> 2] | 0;
 if (i1 | 0) {
  i36 = HEAP32[i42 + 96 >> 2] | 0;
  HEAP32[i37 >> 2] = 1;
  HEAP32[i37 + 4 >> 2] = i36;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i37);
 }
 i1 = i42 + 20 | 0;
 if ((HEAP32[i40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i41);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i38 >> 2] | 0) <= -1) {
  STACKTOP = i43;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i39);
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i43;
 return;
}

function __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE(i114, i2) {
 i114 = i114 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, f119 = f0, f120 = f0;
 i118 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i111 = i118 + 212 | 0;
 i112 = i118 + 200 | 0;
 i107 = i118 + 196 | 0;
 i108 = i118 + 184 | 0;
 i53 = i118 + 172 | 0;
 i113 = i118 + 168 | 0;
 i116 = i118 + 164 | 0;
 i117 = i118 + 160 | 0;
 i54 = i118 + 136 | 0;
 i91 = i118 + 112 | 0;
 i110 = i118 + 100 | 0;
 i104 = i118 + 88 | 0;
 i109 = i118 + 40 | 0;
 i105 = i118 + 148 | 0;
 i106 = i118 + 124 | 0;
 i115 = i118;
 i103 = HEAP32[i114 + 4 >> 2] | 0;
 f42 = Math_fround(HEAPF32[i103 >> 2]);
 f45 = Math_fround(f42 + f42);
 f50 = Math_fround(HEAPF32[i103 + 4 >> 2]);
 f48 = Math_fround(f50 + f50);
 f38 = Math_fround(HEAPF32[i103 + 8 >> 2]);
 f41 = Math_fround(f38 + f38);
 f40 = Math_fround(HEAPF32[i103 + 12 >> 2]);
 f44 = Math_fround(f45 * f40);
 f43 = Math_fround(f48 * f40);
 f40 = Math_fround(f40 * f41);
 f45 = Math_fround(f42 * f45);
 f39 = Math_fround(f42 * f48);
 f42 = Math_fround(f42 * f41);
 f48 = Math_fround(f50 * f48);
 f50 = Math_fround(f50 * f41);
 f41 = Math_fround(f38 * f41);
 HEAPF32[i109 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f48) - f41);
 i92 = i109 + 4 | 0;
 HEAPF32[i92 >> 2] = Math_fround(f39 + f40);
 i93 = i109 + 8 | 0;
 HEAPF32[i93 >> 2] = Math_fround(f42 - f43);
 i94 = i109 + 12 | 0;
 HEAPF32[i94 >> 2] = Math_fround(f39 - f40);
 f45 = Math_fround(Math_fround(1.0) - f45);
 i95 = i109 + 16 | 0;
 HEAPF32[i95 >> 2] = Math_fround(f45 - f41);
 i96 = i109 + 20 | 0;
 HEAPF32[i96 >> 2] = Math_fround(f50 + f44);
 i97 = i109 + 24 | 0;
 HEAPF32[i97 >> 2] = Math_fround(f42 + f43);
 i98 = i109 + 28 | 0;
 HEAPF32[i98 >> 2] = Math_fround(f50 - f44);
 i99 = i109 + 32 | 0;
 HEAPF32[i99 >> 2] = Math_fround(f45 - f48);
 i100 = i109 + 36 | 0;
 HEAPF32[i100 >> 2] = Math_fround(0.0);
 i101 = i109 + 40 | 0;
 HEAPF32[i101 >> 2] = Math_fround(0.0);
 i102 = i109 + 44 | 0;
 HEAPF32[i102 >> 2] = Math_fround(0.0);
 HEAP32[i109 + 36 >> 2] = HEAP32[i103 + 16 >> 2];
 HEAP32[i101 >> 2] = HEAP32[i103 + 20 >> 2];
 HEAP32[i102 >> 2] = HEAP32[i103 + 24 >> 2];
 i103 = i114 + 8 | 0;
 i86 = HEAP32[i103 >> 2] | 0;
 f48 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i86 + 12 | 0;
 f48 = Math_fround(f48 + Math_fround(HEAPF32[i87 >> 2]));
 i88 = i86 + 4 | 0;
 f45 = Math_fround(HEAPF32[i88 >> 2]);
 i89 = i86 + 16 | 0;
 f45 = Math_fround(f45 + Math_fround(HEAPF32[i89 >> 2]));
 i90 = i86 + 8 | 0;
 f44 = Math_fround(HEAPF32[i90 >> 2]);
 i1 = i86 + 20 | 0;
 f45 = Math_fround(f45 * Math_fround(.5));
 f44 = Math_fround(Math_fround(f44 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 HEAPF32[i105 >> 2] = Math_fround(f48 * Math_fround(.5));
 HEAPF32[i105 + 4 >> 2] = f45;
 HEAPF32[i105 + 8 >> 2] = f44;
 f44 = Math_fround(HEAPF32[i86 >> 2]);
 f44 = Math_fround(f44 - Math_fround(HEAPF32[i87 >> 2]));
 f45 = Math_fround(HEAPF32[i88 >> 2]);
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i89 >> 2]));
 f48 = Math_fround(HEAPF32[i90 >> 2]);
 f45 = Math_fround(f45 * Math_fround(.5));
 f48 = Math_fround(Math_fround(f48 - Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f44 = Math_fround(Math_abs(Math_fround(f44 * Math_fround(.5))));
 f50 = Math_fround(HEAPF32[i114 + 12 >> 2]);
 HEAPF32[i106 >> 2] = Math_fround(f44 + f50);
 HEAPF32[i106 + 4 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f45))) + f50);
 HEAPF32[i106 + 8 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f48))) + f50);
 i1 = HEAP32[i2 + 848 >> 2] | 0;
 if (!i1) {
  STACKTOP = i118;
  return 1;
 }
 i55 = i115 + 4 | 0;
 i56 = i115 + 8 | 0;
 i57 = i115 + 12 | 0;
 i58 = i115 + 16 | 0;
 i59 = i115 + 20 | 0;
 i60 = i115 + 24 | 0;
 i61 = i115 + 28 | 0;
 i62 = i115 + 32 | 0;
 i63 = i114 + 20 | 0;
 i64 = i114 + 16 | 0;
 i65 = i115 + 12 | 0;
 i66 = i54 + 4 | 0;
 i67 = i54 + 8 | 0;
 i68 = i115 + 24 | 0;
 i69 = i91 + 4 | 0;
 i70 = i91 + 8 | 0;
 i71 = i111 + 4 | 0;
 i72 = i111 + 8 | 0;
 i73 = i110 + 4 | 0;
 i74 = i110 + 8 | 0;
 i75 = i111 + 4 | 0;
 i76 = i111 + 8 | 0;
 i77 = i112 + 4 | 0;
 i78 = i112 + 8 | 0;
 i79 = i108 + 4 | 0;
 i80 = i108 + 8 | 0;
 i81 = i104 + 4 | 0;
 i82 = i104 + 8 | 0;
 i83 = i111 + 4 | 0;
 i84 = i111 + 8 | 0;
 i85 = i112 + 4 | 0;
 i86 = i112 + 8 | 0;
 i87 = i53 + 4 | 0;
 i88 = i53 + 8 | 0;
 i89 = i108 + 4 | 0;
 i90 = i108 + 8 | 0;
 i51 = i2 + 832 | 0;
 i52 = i2 + 768 | 0;
 do {
  i1 = i1 + -1 | 0;
  i46 = HEAP32[i52 >> 2] | 0;
  i52 = i52 + 4 | 0;
  HEAP32[i115 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i55 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i56 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i57 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i58 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i59 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i60 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i61 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i62 >> 2] = HEAP32[i2 + 32 >> 2];
  i2 = i2 + 36 | 0;
  i29 = HEAP8[i51 >> 0] | 0;
  i51 = i51 + 1 | 0;
  if (__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i105, i106, i115, i57, i60) | 0) {
   i47 = HEAP32[i103 >> 2] | 0;
   f48 = Math_fround(HEAPF32[i63 >> 2]);
   i49 = HEAP32[i114 >> 2] | 0;
   f50 = Math_fround(HEAPF32[i64 >> 2]);
   f41 = Math_fround(HEAPF32[i65 >> 2]);
   f8 = Math_fround(HEAPF32[i115 >> 2]);
   f41 = Math_fround(f41 - f8);
   f42 = Math_fround(HEAPF32[i58 >> 2]);
   f45 = Math_fround(HEAPF32[i55 >> 2]);
   f42 = Math_fround(f42 - f45);
   f43 = Math_fround(HEAPF32[i59 >> 2]);
   f44 = Math_fround(HEAPF32[i56 >> 2]);
   f43 = Math_fround(f43 - f44);
   HEAPF32[i54 >> 2] = f41;
   HEAPF32[i66 >> 2] = f42;
   HEAPF32[i67 >> 2] = f43;
   f8 = Math_fround(Math_fround(HEAPF32[i68 >> 2]) - f8);
   f45 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f45);
   f44 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) - f44);
   HEAPF32[i91 >> 2] = f8;
   HEAPF32[i69 >> 2] = f45;
   HEAPF32[i70 >> 2] = f44;
   i13 = i47 + 12 | 0;
   f44 = Math_fround(HEAPF32[i13 >> 2]);
   f44 = Math_fround(f44 - Math_fround(HEAPF32[i47 >> 2]));
   i27 = i47 + 16 | 0;
   f45 = Math_fround(HEAPF32[i27 >> 2]);
   i15 = i47 + 4 | 0;
   f45 = Math_fround(f45 - Math_fround(HEAPF32[i15 >> 2]));
   i28 = i47 + 20 | 0;
   f8 = Math_fround(HEAPF32[i28 >> 2]);
   i18 = i47 + 8 | 0;
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i18 >> 2]));
   HEAPF32[i111 >> 2] = f44;
   HEAPF32[i71 >> 2] = f45;
   HEAPF32[i72 >> 2] = f8;
   f8 = Math_fround(__ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_(i47, i111, i115, i54, i91, i113, i116, i117));
   f45 = Math_fround(f48 + f50);
   L8 : do if (!(f8 >= Math_fround(f45 * f45))) {
    f25 = Math_fround(HEAPF32[i65 >> 2]);
    f26 = Math_fround(HEAPF32[i115 >> 2]);
    f43 = Math_fround(f25 - f26);
    f32 = Math_fround(HEAPF32[i58 >> 2]);
    f33 = Math_fround(HEAPF32[i55 >> 2]);
    f7 = Math_fround(f32 - f33);
    f34 = Math_fround(HEAPF32[i59 >> 2]);
    f35 = Math_fround(HEAPF32[i56 >> 2]);
    f42 = Math_fround(f34 - f35);
    f36 = Math_fround(HEAPF32[i68 >> 2]);
    f6 = Math_fround(f36 - f26);
    f37 = Math_fround(HEAPF32[i61 >> 2]);
    f44 = Math_fround(f37 - f33);
    f38 = Math_fround(HEAPF32[i62 >> 2]);
    f5 = Math_fround(f38 - f35);
    f4 = Math_fround(Math_fround(f7 * f5) - Math_fround(f42 * f44));
    f5 = Math_fround(Math_fround(f42 * f6) - Math_fround(f43 * f5));
    f6 = Math_fround(Math_fround(f43 * f44) - Math_fround(f7 * f6));
    f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)));
    if (f7 > Math_fround(0.0)) {
     f44 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
     f42 = Math_fround(f4 * f44);
     f43 = Math_fround(f5 * f44);
     f44 = Math_fround(f6 * f44);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i3 = 0;
     i9 = 0;
     i11 = 0;
    }
    f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f26 * f17);
    f19 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f21 + Math_fround(f33 * f19));
    f20 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f21 + Math_fround(f35 * f20));
    f39 = Math_fround(HEAPF32[i47 >> 2]);
    f40 = Math_fround(HEAPF32[i13 >> 2]);
    f22 = Math_fround(f39 + f40);
    f41 = Math_fround(HEAPF32[i15 >> 2]);
    f42 = Math_fround(HEAPF32[i27 >> 2]);
    f23 = Math_fround(f41 + f42);
    f43 = Math_fround(HEAPF32[i18 >> 2]);
    f44 = Math_fround(HEAPF32[i28 >> 2]);
    f22 = Math_fround(f22 * Math_fround(.5));
    f23 = Math_fround(f23 * Math_fround(.5));
    f24 = Math_fround(Math_fround(f43 + f44) * Math_fround(.5));
    if (!(Math_fround(Math_fround(Math_fround(Math_fround(f17 * f22) + Math_fround(f19 * f23)) + Math_fround(f20 * f24)) - f21) < Math_fround(0.0))) {
     if (f8 > Math_fround(1.00000011e-06)) {
      f44 = Math_fround(HEAPF32[i116 >> 2]);
      if (__ZN5physx2Gu12selectNormalEhff(i29, f44, Math_fround(HEAPF32[i117 >> 2])) | 0) {
       HEAP32[i110 >> 2] = i11;
       HEAP32[i73 >> 2] = i9;
       HEAP32[i74 >> 2] = i3;
       i11 = HEAP32[i47 >> 2] | 0;
       i15 = HEAP32[i15 >> 2] | 0;
       i18 = HEAP32[i18 >> 2] | 0;
       i3 = HEAP32[i47 + 12 >> 2] | 0;
       i9 = HEAP32[i27 >> 2] | 0;
       i13 = HEAP32[i28 >> 2] | 0;
      } else {
       f8 = Math_fround(HEAPF32[i116 >> 2]);
       f7 = Math_fround(HEAPF32[i117 >> 2]);
       f16 = Math_fround(Math_fround(Math_fround(1.0) - f8) - f7);
       f5 = Math_fround(f16 * Math_fround(HEAPF32[i115 >> 2]));
       f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i65 >> 2])));
       f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i68 >> 2])));
       f6 = Math_fround(f16 * Math_fround(HEAPF32[i55 >> 2]));
       f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i58 >> 2])));
       f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i61 >> 2])));
       f16 = Math_fround(f16 * Math_fround(HEAPF32[i56 >> 2]));
       f8 = Math_fround(f16 + Math_fround(f8 * Math_fround(HEAPF32[i59 >> 2])));
       f7 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i62 >> 2])));
       f8 = Math_fround(HEAPF32[i113 >> 2]);
       f16 = Math_fround(HEAPF32[i13 >> 2]);
       f17 = Math_fround(HEAPF32[i47 >> 2]);
       f43 = Math_fround(f16 - f17);
       f14 = Math_fround(HEAPF32[i27 >> 2]);
       f12 = Math_fround(HEAPF32[i15 >> 2]);
       f44 = Math_fround(f14 - f12);
       f10 = Math_fround(HEAPF32[i28 >> 2]);
       f4 = Math_fround(HEAPF32[i18 >> 2]);
       f5 = Math_fround(Math_fround(f17 + Math_fround(f8 * f43)) - f5);
       f6 = Math_fround(Math_fround(f12 + Math_fround(f8 * f44)) - f6);
       f7 = Math_fround(Math_fround(f4 + Math_fround(f8 * Math_fround(f10 - f4))) - f7);
       HEAPF32[i110 >> 2] = f5;
       HEAPF32[i73 >> 2] = f6;
       HEAPF32[i74 >> 2] = f7;
       f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7))));
       if (f8 == Math_fround(0.0)) break;
       i13 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
       i9 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
       i18 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
       i15 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
       i11 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       f42 = Math_fround(Math_fround(1.0) / f8);
       f43 = Math_fround(f6 * f42);
       f44 = Math_fround(f7 * f42);
       HEAPF32[i110 >> 2] = Math_fround(f5 * f42);
       HEAPF32[i73 >> 2] = f43;
       HEAPF32[i74 >> 2] = f44;
      }
      HEAP32[i111 >> 2] = i11;
      HEAP32[i75 >> 2] = i15;
      HEAP32[i76 >> 2] = i18;
      HEAP32[i112 >> 2] = i3;
      HEAP32[i77 >> 2] = i9;
      HEAP32[i78 >> 2] = i13;
      f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f14 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f16 = Math_fround(f17 - f14);
      f12 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f8 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f10 = Math_fround(f12 - f8);
      f7 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = Math_fround(f7 - f4);
      f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f16 * f16)))));
      if (f6 > Math_fround(0.0)) {
       f44 = Math_fround(Math_fround(.00999999977) / f6);
       f42 = Math_fround(f16 * f44);
       f43 = Math_fround(f10 * f44);
       f44 = Math_fround(f5 * f44);
       HEAPF32[i111 >> 2] = Math_fround(f14 - f42);
       HEAPF32[i75 >> 2] = Math_fround(f8 - f43);
       HEAPF32[i76 >> 2] = Math_fround(f4 - f44);
       HEAPF32[i112 >> 2] = Math_fround(f17 + f42);
       HEAPF32[i77 >> 2] = Math_fround(f12 + f43);
       HEAPF32[i78 >> 2] = Math_fround(f7 + f44);
      }
      i3 = i49 + 4096 | 0;
      i11 = 0;
      do {
       i31 = i11;
       i11 = i11 + 1 | 0;
       if (__ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_(i115 + (i31 * 12 | 0) | 0, i115 + ((i11 + (i31 >>> 1) & 3) * 12 | 0) | 0, i110, i111, i112, i107, i108) | 0) {
        f4 = Math_fround(HEAPF32[i107 >> 2]);
        if (f4 < f45) {
         f21 = Math_fround(HEAPF32[i108 >> 2]);
         f5 = Math_fround(HEAPF32[i109 >> 2]);
         f19 = Math_fround(f21 * f5);
         f6 = Math_fround(HEAPF32[i92 >> 2]);
         f14 = Math_fround(f21 * f6);
         f7 = Math_fround(HEAPF32[i93 >> 2]);
         f21 = Math_fround(f21 * f7);
         f22 = Math_fround(HEAPF32[i79 >> 2]);
         f8 = Math_fround(HEAPF32[i94 >> 2]);
         f24 = Math_fround(f22 * f8);
         f10 = Math_fround(HEAPF32[i95 >> 2]);
         f23 = Math_fround(f22 * f10);
         f12 = Math_fround(HEAPF32[i96 >> 2]);
         f24 = Math_fround(f19 + f24);
         f23 = Math_fround(f14 + f23);
         f22 = Math_fround(f21 + Math_fround(f22 * f12));
         f21 = Math_fround(HEAPF32[i80 >> 2]);
         f14 = Math_fround(HEAPF32[i97 >> 2]);
         f19 = Math_fround(f21 * f14);
         f16 = Math_fround(HEAPF32[i98 >> 2]);
         f20 = Math_fround(f21 * f16);
         f17 = Math_fround(HEAPF32[i99 >> 2]);
         f19 = Math_fround(f24 + f19);
         f20 = Math_fround(f23 + f20);
         f21 = Math_fround(f22 + Math_fround(f21 * f17));
         f19 = Math_fround(f19 + Math_fround(HEAPF32[i100 >> 2]));
         f20 = Math_fround(f20 + Math_fround(HEAPF32[i101 >> 2]));
         f21 = Math_fround(f21 + Math_fround(HEAPF32[i102 >> 2]));
         HEAPF32[i108 >> 2] = f19;
         HEAPF32[i79 >> 2] = f20;
         HEAPF32[i80 >> 2] = f21;
         f22 = Math_fround(HEAPF32[i110 >> 2]);
         f23 = Math_fround(HEAPF32[i73 >> 2]);
         f24 = Math_fround(HEAPF32[i74 >> 2]);
         i9 = HEAP32[i3 >> 2] | 0;
         if (i9 >>> 0 <= 63) {
          f44 = Math_fround(f4 - f48);
          f43 = Math_fround(Math_fround(Math_fround(f7 * f22) + Math_fround(f12 * f23)) + Math_fround(f17 * f24));
          f42 = Math_fround(Math_fround(Math_fround(f6 * f22) + Math_fround(f10 * f23)) + Math_fround(f16 * f24));
          f41 = Math_fround(Math_fround(Math_fround(f5 * f22) + Math_fround(f8 * f23)) + Math_fround(f14 * f24));
          HEAP32[i3 >> 2] = i9 + 1;
          HEAPF32[i49 + (i9 << 6) >> 2] = f41;
          HEAPF32[i49 + (i9 << 6) + 4 >> 2] = f42;
          HEAPF32[i49 + (i9 << 6) + 8 >> 2] = f43;
          HEAPF32[i49 + (i9 << 6) + 16 >> 2] = f19;
          HEAPF32[i49 + (i9 << 6) + 20 >> 2] = f20;
          HEAPF32[i49 + (i9 << 6) + 24 >> 2] = f21;
          HEAPF32[i49 + (i9 << 6) + 12 >> 2] = f44;
          HEAP32[i49 + (i9 << 6) + 48 >> 2] = -1;
          HEAP32[i49 + (i9 << 6) + 52 >> 2] = i46;
         }
        }
       }
      } while ((i11 | 0) != 3);
      __ZL21PxcGenerateVFContactsRKN5physx2Cm8Matrix34ERNS_2Gu13ContactBufferERKNS4_7SegmentEfPKNS_6PxVec3ERSB_jf(i109, i49, i47, f48, i115, i110, i46, f50);
      break;
     }
     f20 = Math_fround(f26 - f25);
     f7 = Math_fround(f33 - f32);
     f19 = Math_fround(f35 - f34);
     f6 = Math_fround(f26 - f36);
     f21 = Math_fround(f33 - f37);
     f5 = Math_fround(f35 - f38);
     f4 = Math_fround(Math_fround(f7 * f5) - Math_fround(f19 * f21));
     f5 = Math_fround(Math_fround(f19 * f6) - Math_fround(f20 * f5));
     f6 = Math_fround(Math_fround(f20 * f21) - Math_fround(f7 * f6));
     f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)));
     if (f7 > Math_fround(0.0)) {
      f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
      f19 = Math_fround(f4 * f21);
      f20 = Math_fround(f5 * f21);
      f21 = Math_fround(f6 * f21);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
      i15 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
      i18 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     } else {
      i18 = 0;
      i15 = 0;
      i13 = 0;
     }
     f19 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f20 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f7 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = Math_fround(Math_fround(Math_fround(f39 * f19) + Math_fround(f41 * f20)) + Math_fround(f43 * f7));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
     f5 = Math_fround(Math_fround(Math_fround(f40 * f19) + Math_fround(f42 * f20)) + Math_fround(f44 * f7));
     i9 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     i11 = f17 > f5;
     f5 = Math_fround(f45 + (HEAP32[tempDoublePtr >> 2] = i11 ? i3 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f17 = Math_fround(Math_fround(Math_fround(f26 * f19) + Math_fround(f33 * f20)) + Math_fround(f35 * f7));
     f21 = Math_fround(Math_fround(Math_fround(f25 * f19) + Math_fround(f32 * f20)) + Math_fround(f34 * f7));
     f6 = f17 < f21 ? f17 : f21;
     f21 = f17 > f21 ? f17 : f21;
     f7 = Math_fround(Math_fround(Math_fround(f36 * f19) + Math_fround(f37 * f20)) + Math_fround(f38 * f7));
     f6 = f6 < f7 ? f6 : f7;
     f7 = f21 > f7 ? f21 : f7;
     if (!(f5 < f6)) {
      f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i9 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f45);
      if (!(f7 < f4)) {
       f5 = Math_fround(f5 - f6);
       f4 = Math_fround(f7 - f4);
       f19 = Math_fround(f40 - f39);
       f20 = Math_fround(f42 - f41);
       f21 = Math_fround(f44 - f43);
       f17 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21));
       if (f17 > Math_fround(0.0)) {
        f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17))));
        f12 = Math_fround(f21 * f16);
        f14 = Math_fround(f20 * f16);
        f16 = Math_fround(f19 * f16);
       } else {
        f12 = Math_fround(0.0);
        f14 = Math_fround(0.0);
        f16 = Math_fround(0.0);
       }
       i31 = i29 & 255;
       f10 = f5 < f4 ? f5 : f4;
       i30 = i13;
       i3 = 0;
       while (1) {
        do if (!(HEAP32[gb + 84424 + (i3 << 2) >> 2] & i31)) {
         i13 = i3 + 1 | 0;
         f4 = f10;
         i11 = i18;
         i9 = i15;
         i3 = i30;
        } else {
         f5 = Math_fround(HEAPF32[i115 + (i3 * 12 | 0) >> 2]);
         f7 = Math_fround(HEAPF32[i115 + (i3 * 12 | 0) + 4 >> 2]);
         f6 = Math_fround(HEAPF32[i115 + (i3 * 12 | 0) + 8 >> 2]);
         i13 = i3 + 1 | 0;
         i29 = i13 + (i3 >>> 1) & 3;
         f4 = Math_fround(HEAPF32[i115 + (i29 * 12 | 0) >> 2]);
         f8 = Math_fround(HEAPF32[i115 + (i29 * 12 | 0) + 4 >> 2]);
         f4 = Math_fround(f5 - f4);
         f8 = Math_fround(f7 - f8);
         f6 = Math_fround(f6 - Math_fround(HEAPF32[i115 + (i29 * 12 | 0) + 8 >> 2]));
         f7 = Math_fround(Math_fround(f14 * f6) - Math_fround(f12 * f8));
         f6 = Math_fround(Math_fround(f12 * f4) - Math_fround(f16 * f6));
         f4 = Math_fround(Math_fround(f16 * f8) - Math_fround(f14 * f4));
         if (!(+Math_fround(Math_abs(Math_fround(f7))) > 1.0e-06)) if (!(+Math_fround(Math_abs(Math_fround(f6))) > 1.0e-06)) if (!(+Math_fround(Math_abs(Math_fround(f4))) > 1.0e-06)) {
          f4 = f10;
          i11 = i18;
          i9 = i15;
          i3 = i30;
          break;
         }
         f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
         if (f5 > Math_fround(0.0)) {
          f119 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
          f8 = Math_fround(f4 * f119);
          f5 = Math_fround(f6 * f119);
          f4 = Math_fround(f7 * f119);
         } else {
          f8 = Math_fround(0.0);
          f5 = Math_fround(0.0);
          f4 = Math_fround(0.0);
         }
         i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
         i9 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
         i11 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
         f6 = Math_fround(Math_fround(Math_fround(f39 * f4) + Math_fround(f41 * f5)) + Math_fround(f43 * f8));
         i27 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
         f7 = Math_fround(Math_fround(Math_fround(f40 * f4) + Math_fround(f42 * f5)) + Math_fround(f44 * f8));
         i28 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
         i29 = f6 > f7;
         f7 = Math_fround(f45 + (HEAP32[tempDoublePtr >> 2] = i29 ? i27 : i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
         f6 = Math_fround(Math_fround(Math_fround(f26 * f4) + Math_fround(f33 * f5)) + Math_fround(f35 * f8));
         f119 = Math_fround(Math_fround(Math_fround(f25 * f4) + Math_fround(f32 * f5)) + Math_fround(f34 * f8));
         f120 = f6 < f119 ? f6 : f119;
         f119 = f6 > f119 ? f6 : f119;
         f6 = Math_fround(Math_fround(Math_fround(f36 * f4) + Math_fround(f37 * f5)) + Math_fround(f38 * f8));
         f5 = f120 < f6 ? f120 : f6;
         f6 = f119 > f6 ? f119 : f6;
         if (f7 < f5) break L8;
         f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29 ? i28 : i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f45);
         if (f6 < f4) break L8;
         f120 = Math_fround(f7 - f5);
         f4 = Math_fround(f6 - f4);
         f4 = f120 < f4 ? f120 : f4;
         if (!(f4 < f10)) {
          f4 = f10;
          i11 = i18;
          i9 = i15;
          i3 = i30;
          break;
         }
        } while (0);
        if (i13 >>> 0 < 3) {
         f10 = f4;
         i30 = i3;
         i15 = i9;
         i18 = i11;
         i3 = i13;
        } else break;
       }
       f120 = Math_fround(f22 - Math_fround(Math_fround(Math_fround(f25 + f26) + f36) * Math_fround(.333333343)));
       f6 = Math_fround(f23 - Math_fround(Math_fround(Math_fround(f32 + f33) + f37) * Math_fround(.333333343)));
       f119 = Math_fround(f24 - Math_fround(Math_fround(Math_fround(f34 + f35) + f38) * Math_fround(.333333343)));
       f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f120 = Math_fround(f120 * f4);
       f5 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f120 = Math_fround(Math_fround(f6 * f5) + f120);
       f6 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (Math_fround(Math_fround(f119 * f6) + f120) < Math_fround(0.0)) {
        f45 = Math_fround(-f4);
        f119 = Math_fround(-f5);
        f120 = Math_fround(-f6);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
        i11 = (HEAPF32[tempDoublePtr >> 2] = f120, HEAP32[tempDoublePtr >> 2] | 0);
       }
       HEAP32[i104 >> 2] = i3;
       HEAP32[i81 >> 2] = i9;
       HEAP32[i82 >> 2] = i11;
       HEAPF32[i111 >> 2] = f39;
       HEAPF32[i83 >> 2] = f41;
       HEAPF32[i84 >> 2] = f43;
       HEAPF32[i112 >> 2] = f40;
       HEAPF32[i85 >> 2] = f42;
       HEAPF32[i86 >> 2] = f44;
       f4 = Math_fround(Math_sqrt(Math_fround(f17)));
       i31 = f4 > Math_fround(0.0);
       f26 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f25 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f24 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (i31) {
        f120 = Math_fround(Math_fround(.00999999977) / f4);
        f45 = Math_fround(f19 * f120);
        f119 = Math_fround(f20 * f120);
        f120 = Math_fround(f21 * f120);
        HEAPF32[i111 >> 2] = Math_fround(f39 - f45);
        HEAPF32[i83 >> 2] = Math_fround(f41 - f119);
        HEAPF32[i84 >> 2] = Math_fround(f43 - f120);
        HEAPF32[i112 >> 2] = Math_fround(f40 + f45);
        HEAPF32[i85 >> 2] = Math_fround(f42 + f119);
        HEAPF32[i86 >> 2] = Math_fround(f44 + f120);
       }
       i3 = i49 + 4096 | 0;
       f4 = Math_fround(-f26);
       f5 = Math_fround(-f25);
       f6 = Math_fround(-f24);
       i11 = 0;
       do {
        i31 = i11;
        i11 = i11 + 1 | 0;
        HEAPF32[i53 >> 2] = f4;
        HEAPF32[i87 >> 2] = f5;
        HEAPF32[i88 >> 2] = f6;
        if (__ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_(i115 + (i31 * 12 | 0) | 0, i115 + ((i11 + (i31 >>> 1) & 3) * 12 | 0) | 0, i53, i111, i112, i107, i108) | 0) {
         f23 = Math_fround(HEAPF32[i108 >> 2]);
         f7 = Math_fround(HEAPF32[i109 >> 2]);
         f21 = Math_fround(f23 * f7);
         f8 = Math_fround(HEAPF32[i92 >> 2]);
         f17 = Math_fround(f23 * f8);
         f10 = Math_fround(HEAPF32[i93 >> 2]);
         f23 = Math_fround(f23 * f10);
         f120 = Math_fround(HEAPF32[i89 >> 2]);
         f12 = Math_fround(HEAPF32[i94 >> 2]);
         f45 = Math_fround(f120 * f12);
         f14 = Math_fround(HEAPF32[i95 >> 2]);
         f119 = Math_fround(f120 * f14);
         f16 = Math_fround(HEAPF32[i96 >> 2]);
         f45 = Math_fround(f21 + f45);
         f119 = Math_fround(f17 + f119);
         f120 = Math_fround(f23 + Math_fround(f120 * f16));
         f23 = Math_fround(HEAPF32[i90 >> 2]);
         f17 = Math_fround(HEAPF32[i97 >> 2]);
         f21 = Math_fround(f23 * f17);
         f19 = Math_fround(HEAPF32[i98 >> 2]);
         f22 = Math_fround(f23 * f19);
         f20 = Math_fround(HEAPF32[i99 >> 2]);
         f21 = Math_fround(f45 + f21);
         f22 = Math_fround(f119 + f22);
         f23 = Math_fround(f120 + Math_fround(f23 * f20));
         f21 = Math_fround(f21 + Math_fround(HEAPF32[i100 >> 2]));
         f22 = Math_fround(f22 + Math_fround(HEAPF32[i101 >> 2]));
         f23 = Math_fround(f23 + Math_fround(HEAPF32[i102 >> 2]));
         HEAPF32[i108 >> 2] = f21;
         HEAPF32[i89 >> 2] = f22;
         HEAPF32[i90 >> 2] = f23;
         i9 = HEAP32[i3 >> 2] | 0;
         if (i9 >>> 0 <= 63) {
          f120 = Math_fround(-Math_fround(f48 + Math_fround(HEAPF32[i107 >> 2])));
          f119 = Math_fround(Math_fround(Math_fround(f26 * f10) + Math_fround(f25 * f16)) + Math_fround(f24 * f20));
          f45 = Math_fround(Math_fround(Math_fround(f26 * f8) + Math_fround(f25 * f14)) + Math_fround(f24 * f19));
          f44 = Math_fround(Math_fround(Math_fround(f26 * f7) + Math_fround(f25 * f12)) + Math_fround(f24 * f17));
          HEAP32[i3 >> 2] = i9 + 1;
          HEAPF32[i49 + (i9 << 6) >> 2] = f44;
          HEAPF32[i49 + (i9 << 6) + 4 >> 2] = f45;
          HEAPF32[i49 + (i9 << 6) + 8 >> 2] = f119;
          HEAPF32[i49 + (i9 << 6) + 16 >> 2] = f21;
          HEAPF32[i49 + (i9 << 6) + 20 >> 2] = f22;
          HEAPF32[i49 + (i9 << 6) + 24 >> 2] = f23;
          HEAPF32[i49 + (i9 << 6) + 12 >> 2] = f120;
          HEAP32[i49 + (i9 << 6) + 48 >> 2] = -1;
          HEAP32[i49 + (i9 << 6) + 52 >> 2] = i46;
         }
        }
       } while ((i11 | 0) != 3);
       __ZL21PxcGenerateVFContactsRKN5physx2Cm8Matrix34ERNS_2Gu13ContactBufferERKNS4_7SegmentEfPKNS_6PxVec3ERSB_jf(i109, i49, i47, f48, i115, i104, i46, f50);
      }
     }
    }
   } while (0);
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i118;
 return 1;
}

function __ZN5physx2Sc13ClothBulkData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 2368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i76 = i2 + 2336 | 0;
 i75 = i2 + 2304 | 0;
 i74 = i2 + 2272 | 0;
 i73 = i2 + 2240 | 0;
 i72 = i2 + 2208 | 0;
 i71 = i2 + 2176 | 0;
 i70 = i2 + 2144 | 0;
 i69 = i2 + 2112 | 0;
 i68 = i2 + 2080 | 0;
 i67 = i2 + 2048 | 0;
 i66 = i2 + 2016 | 0;
 i65 = i2 + 1984 | 0;
 i64 = i2 + 1952 | 0;
 i63 = i2 + 1920 | 0;
 i62 = i2 + 1888 | 0;
 i61 = i2 + 1856 | 0;
 i60 = i2 + 1824 | 0;
 i59 = i2 + 1792 | 0;
 i58 = i2 + 1760 | 0;
 i57 = i2 + 1728 | 0;
 i56 = i2 + 1696 | 0;
 i55 = i2 + 1664 | 0;
 i54 = i2 + 1632 | 0;
 i53 = i2 + 1600 | 0;
 i52 = i2 + 1568 | 0;
 i51 = i2 + 1536 | 0;
 i50 = i2 + 1504 | 0;
 i49 = i2 + 1472 | 0;
 i48 = i2 + 1440 | 0;
 i47 = i2 + 1408 | 0;
 i46 = i2 + 1376 | 0;
 i45 = i2 + 1344 | 0;
 i44 = i2 + 1312 | 0;
 i43 = i2 + 1280 | 0;
 i42 = i2 + 1248 | 0;
 i41 = i2 + 1216 | 0;
 i40 = i2 + 1184 | 0;
 i39 = i2 + 1152 | 0;
 i38 = i2 + 1120 | 0;
 i37 = i2 + 1088 | 0;
 i36 = i2 + 1056 | 0;
 i35 = i2 + 1024 | 0;
 i34 = i2 + 992 | 0;
 i33 = i2 + 960 | 0;
 i32 = i2 + 928 | 0;
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i76 >> 2] = HEAP32[gb + 127684 >> 2];
 HEAP32[i76 + 4 >> 2] = HEAP32[gb + 127684 + 4 >> 2];
 HEAP32[i76 + 8 >> 2] = HEAP32[gb + 127684 + 8 >> 2];
 HEAP32[i76 + 12 >> 2] = HEAP32[gb + 127684 + 12 >> 2];
 HEAP32[i76 + 16 >> 2] = HEAP32[gb + 127684 + 16 >> 2];
 HEAP32[i76 + 20 >> 2] = HEAP32[gb + 127684 + 20 >> 2];
 HEAP32[i76 + 24 >> 2] = HEAP32[gb + 127684 + 24 >> 2];
 HEAP32[i76 + 28 >> 2] = HEAP32[gb + 127684 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i76 | 0, 32) | 0;
 HEAP32[i75 >> 2] = HEAP32[gb + 127716 >> 2];
 HEAP32[i75 + 4 >> 2] = HEAP32[gb + 127716 + 4 >> 2];
 HEAP32[i75 + 8 >> 2] = HEAP32[gb + 127716 + 8 >> 2];
 HEAP32[i75 + 12 >> 2] = HEAP32[gb + 127716 + 12 >> 2];
 HEAP32[i75 + 16 >> 2] = HEAP32[gb + 127716 + 16 >> 2];
 HEAP32[i75 + 20 >> 2] = HEAP32[gb + 127716 + 20 >> 2];
 HEAP32[i75 + 24 >> 2] = HEAP32[gb + 127716 + 24 >> 2];
 HEAP32[i75 + 28 >> 2] = HEAP32[gb + 127716 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i75 | 0, 32) | 0;
 HEAP32[i74 >> 2] = HEAP32[gb + 127748 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[gb + 127748 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[gb + 127748 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[gb + 127748 + 12 >> 2];
 HEAP32[i74 + 16 >> 2] = HEAP32[gb + 127748 + 16 >> 2];
 HEAP32[i74 + 20 >> 2] = HEAP32[gb + 127748 + 20 >> 2];
 HEAP32[i74 + 24 >> 2] = HEAP32[gb + 127748 + 24 >> 2];
 HEAP32[i74 + 28 >> 2] = HEAP32[gb + 127748 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i74 | 0, 32) | 0;
 HEAP32[i73 >> 2] = HEAP32[gb + 127780 >> 2];
 HEAP32[i73 + 4 >> 2] = HEAP32[gb + 127780 + 4 >> 2];
 HEAP32[i73 + 8 >> 2] = HEAP32[gb + 127780 + 8 >> 2];
 HEAP32[i73 + 12 >> 2] = HEAP32[gb + 127780 + 12 >> 2];
 HEAP32[i73 + 16 >> 2] = HEAP32[gb + 127780 + 16 >> 2];
 HEAP32[i73 + 20 >> 2] = HEAP32[gb + 127780 + 20 >> 2];
 HEAP32[i73 + 24 >> 2] = HEAP32[gb + 127780 + 24 >> 2];
 HEAP32[i73 + 28 >> 2] = HEAP32[gb + 127780 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i73 | 0, 32) | 0;
 HEAP32[i72 >> 2] = HEAP32[gb + 127812 >> 2];
 HEAP32[i72 + 4 >> 2] = HEAP32[gb + 127812 + 4 >> 2];
 HEAP32[i72 + 8 >> 2] = HEAP32[gb + 127812 + 8 >> 2];
 HEAP32[i72 + 12 >> 2] = HEAP32[gb + 127812 + 12 >> 2];
 HEAP32[i72 + 16 >> 2] = HEAP32[gb + 127812 + 16 >> 2];
 HEAP32[i72 + 20 >> 2] = HEAP32[gb + 127812 + 20 >> 2];
 HEAP32[i72 + 24 >> 2] = HEAP32[gb + 127812 + 24 >> 2];
 HEAP32[i72 + 28 >> 2] = HEAP32[gb + 127812 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i72 | 0, 32) | 0;
 HEAP32[i71 >> 2] = HEAP32[gb + 127844 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[gb + 127844 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[gb + 127844 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[gb + 127844 + 12 >> 2];
 HEAP32[i71 + 16 >> 2] = HEAP32[gb + 127844 + 16 >> 2];
 HEAP32[i71 + 20 >> 2] = HEAP32[gb + 127844 + 20 >> 2];
 HEAP32[i71 + 24 >> 2] = HEAP32[gb + 127844 + 24 >> 2];
 HEAP32[i71 + 28 >> 2] = HEAP32[gb + 127844 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i71 | 0, 32) | 0;
 HEAP32[i70 >> 2] = HEAP32[gb + 127876 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[gb + 127876 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[gb + 127876 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[gb + 127876 + 12 >> 2];
 HEAP32[i70 + 16 >> 2] = HEAP32[gb + 127876 + 16 >> 2];
 HEAP32[i70 + 20 >> 2] = HEAP32[gb + 127876 + 20 >> 2];
 HEAP32[i70 + 24 >> 2] = HEAP32[gb + 127876 + 24 >> 2];
 HEAP32[i70 + 28 >> 2] = HEAP32[gb + 127876 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i70 | 0, 32) | 0;
 HEAP32[i69 >> 2] = HEAP32[gb + 127908 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[gb + 127908 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[gb + 127908 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[gb + 127908 + 12 >> 2];
 HEAP32[i69 + 16 >> 2] = HEAP32[gb + 127908 + 16 >> 2];
 HEAP32[i69 + 20 >> 2] = HEAP32[gb + 127908 + 20 >> 2];
 HEAP32[i69 + 24 >> 2] = HEAP32[gb + 127908 + 24 >> 2];
 HEAP32[i69 + 28 >> 2] = HEAP32[gb + 127908 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i69 | 0, 32) | 0;
 HEAP32[i68 >> 2] = HEAP32[gb + 127940 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[gb + 127940 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[gb + 127940 + 8 >> 2];
 HEAP32[i68 + 12 >> 2] = HEAP32[gb + 127940 + 12 >> 2];
 HEAP32[i68 + 16 >> 2] = HEAP32[gb + 127940 + 16 >> 2];
 HEAP32[i68 + 20 >> 2] = HEAP32[gb + 127940 + 20 >> 2];
 HEAP32[i68 + 24 >> 2] = HEAP32[gb + 127940 + 24 >> 2];
 HEAP32[i68 + 28 >> 2] = HEAP32[gb + 127940 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i68 | 0, 32) | 0;
 HEAP32[i67 >> 2] = HEAP32[gb + 127972 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[gb + 127972 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[gb + 127972 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[gb + 127972 + 12 >> 2];
 HEAP32[i67 + 16 >> 2] = HEAP32[gb + 127972 + 16 >> 2];
 HEAP32[i67 + 20 >> 2] = HEAP32[gb + 127972 + 20 >> 2];
 HEAP32[i67 + 24 >> 2] = HEAP32[gb + 127972 + 24 >> 2];
 HEAP32[i67 + 28 >> 2] = HEAP32[gb + 127972 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i67 | 0, 32) | 0;
 HEAP32[i66 >> 2] = HEAP32[gb + 128004 >> 2];
 HEAP32[i66 + 4 >> 2] = HEAP32[gb + 128004 + 4 >> 2];
 HEAP32[i66 + 8 >> 2] = HEAP32[gb + 128004 + 8 >> 2];
 HEAP32[i66 + 12 >> 2] = HEAP32[gb + 128004 + 12 >> 2];
 HEAP32[i66 + 16 >> 2] = HEAP32[gb + 128004 + 16 >> 2];
 HEAP32[i66 + 20 >> 2] = HEAP32[gb + 128004 + 20 >> 2];
 HEAP32[i66 + 24 >> 2] = HEAP32[gb + 128004 + 24 >> 2];
 HEAP32[i66 + 28 >> 2] = HEAP32[gb + 128004 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i66 | 0, 32) | 0;
 HEAP32[i65 >> 2] = HEAP32[gb + 128036 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[gb + 128036 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[gb + 128036 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[gb + 128036 + 12 >> 2];
 HEAP32[i65 + 16 >> 2] = HEAP32[gb + 128036 + 16 >> 2];
 HEAP32[i65 + 20 >> 2] = HEAP32[gb + 128036 + 20 >> 2];
 HEAP32[i65 + 24 >> 2] = HEAP32[gb + 128036 + 24 >> 2];
 HEAP32[i65 + 28 >> 2] = HEAP32[gb + 128036 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i65 | 0, 32) | 0;
 HEAP32[i64 >> 2] = HEAP32[gb + 128068 >> 2];
 HEAP32[i64 + 4 >> 2] = HEAP32[gb + 128068 + 4 >> 2];
 HEAP32[i64 + 8 >> 2] = HEAP32[gb + 128068 + 8 >> 2];
 HEAP32[i64 + 12 >> 2] = HEAP32[gb + 128068 + 12 >> 2];
 HEAP32[i64 + 16 >> 2] = HEAP32[gb + 128068 + 16 >> 2];
 HEAP32[i64 + 20 >> 2] = HEAP32[gb + 128068 + 20 >> 2];
 HEAP32[i64 + 24 >> 2] = HEAP32[gb + 128068 + 24 >> 2];
 HEAP32[i64 + 28 >> 2] = HEAP32[gb + 128068 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i64 | 0, 32) | 0;
 HEAP32[i63 >> 2] = HEAP32[gb + 128100 >> 2];
 HEAP32[i63 + 4 >> 2] = HEAP32[gb + 128100 + 4 >> 2];
 HEAP32[i63 + 8 >> 2] = HEAP32[gb + 128100 + 8 >> 2];
 HEAP32[i63 + 12 >> 2] = HEAP32[gb + 128100 + 12 >> 2];
 HEAP32[i63 + 16 >> 2] = HEAP32[gb + 128100 + 16 >> 2];
 HEAP32[i63 + 20 >> 2] = HEAP32[gb + 128100 + 20 >> 2];
 HEAP32[i63 + 24 >> 2] = HEAP32[gb + 128100 + 24 >> 2];
 HEAP32[i63 + 28 >> 2] = HEAP32[gb + 128100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i63 | 0, 32) | 0;
 HEAP32[i62 >> 2] = HEAP32[gb + 128132 >> 2];
 HEAP32[i62 + 4 >> 2] = HEAP32[gb + 128132 + 4 >> 2];
 HEAP32[i62 + 8 >> 2] = HEAP32[gb + 128132 + 8 >> 2];
 HEAP32[i62 + 12 >> 2] = HEAP32[gb + 128132 + 12 >> 2];
 HEAP32[i62 + 16 >> 2] = HEAP32[gb + 128132 + 16 >> 2];
 HEAP32[i62 + 20 >> 2] = HEAP32[gb + 128132 + 20 >> 2];
 HEAP32[i62 + 24 >> 2] = HEAP32[gb + 128132 + 24 >> 2];
 HEAP32[i62 + 28 >> 2] = HEAP32[gb + 128132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i62 | 0, 32) | 0;
 HEAP32[i61 >> 2] = HEAP32[gb + 128164 >> 2];
 HEAP32[i61 + 4 >> 2] = HEAP32[gb + 128164 + 4 >> 2];
 HEAP32[i61 + 8 >> 2] = HEAP32[gb + 128164 + 8 >> 2];
 HEAP32[i61 + 12 >> 2] = HEAP32[gb + 128164 + 12 >> 2];
 HEAP32[i61 + 16 >> 2] = HEAP32[gb + 128164 + 16 >> 2];
 HEAP32[i61 + 20 >> 2] = HEAP32[gb + 128164 + 20 >> 2];
 HEAP32[i61 + 24 >> 2] = HEAP32[gb + 128164 + 24 >> 2];
 HEAP32[i61 + 28 >> 2] = HEAP32[gb + 128164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i61 | 0, 32) | 0;
 HEAP32[i60 >> 2] = HEAP32[gb + 128196 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[gb + 128196 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[gb + 128196 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[gb + 128196 + 12 >> 2];
 HEAP32[i60 + 16 >> 2] = HEAP32[gb + 128196 + 16 >> 2];
 HEAP32[i60 + 20 >> 2] = HEAP32[gb + 128196 + 20 >> 2];
 HEAP32[i60 + 24 >> 2] = HEAP32[gb + 128196 + 24 >> 2];
 HEAP32[i60 + 28 >> 2] = HEAP32[gb + 128196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i60 | 0, 32) | 0;
 HEAP32[i59 >> 2] = HEAP32[gb + 128228 >> 2];
 HEAP32[i59 + 4 >> 2] = HEAP32[gb + 128228 + 4 >> 2];
 HEAP32[i59 + 8 >> 2] = HEAP32[gb + 128228 + 8 >> 2];
 HEAP32[i59 + 12 >> 2] = HEAP32[gb + 128228 + 12 >> 2];
 HEAP32[i59 + 16 >> 2] = HEAP32[gb + 128228 + 16 >> 2];
 HEAP32[i59 + 20 >> 2] = HEAP32[gb + 128228 + 20 >> 2];
 HEAP32[i59 + 24 >> 2] = HEAP32[gb + 128228 + 24 >> 2];
 HEAP32[i59 + 28 >> 2] = HEAP32[gb + 128228 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i59 | 0, 32) | 0;
 HEAP32[i58 >> 2] = HEAP32[gb + 128260 >> 2];
 HEAP32[i58 + 4 >> 2] = HEAP32[gb + 128260 + 4 >> 2];
 HEAP32[i58 + 8 >> 2] = HEAP32[gb + 128260 + 8 >> 2];
 HEAP32[i58 + 12 >> 2] = HEAP32[gb + 128260 + 12 >> 2];
 HEAP32[i58 + 16 >> 2] = HEAP32[gb + 128260 + 16 >> 2];
 HEAP32[i58 + 20 >> 2] = HEAP32[gb + 128260 + 20 >> 2];
 HEAP32[i58 + 24 >> 2] = HEAP32[gb + 128260 + 24 >> 2];
 HEAP32[i58 + 28 >> 2] = HEAP32[gb + 128260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i58 | 0, 32) | 0;
 HEAP32[i57 >> 2] = HEAP32[gb + 128292 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[gb + 128292 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[gb + 128292 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[gb + 128292 + 12 >> 2];
 HEAP32[i57 + 16 >> 2] = HEAP32[gb + 128292 + 16 >> 2];
 HEAP32[i57 + 20 >> 2] = HEAP32[gb + 128292 + 20 >> 2];
 HEAP32[i57 + 24 >> 2] = HEAP32[gb + 128292 + 24 >> 2];
 HEAP32[i57 + 28 >> 2] = HEAP32[gb + 128292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i57 | 0, 32) | 0;
 HEAP32[i56 >> 2] = HEAP32[gb + 128324 >> 2];
 HEAP32[i56 + 4 >> 2] = HEAP32[gb + 128324 + 4 >> 2];
 HEAP32[i56 + 8 >> 2] = HEAP32[gb + 128324 + 8 >> 2];
 HEAP32[i56 + 12 >> 2] = HEAP32[gb + 128324 + 12 >> 2];
 HEAP32[i56 + 16 >> 2] = HEAP32[gb + 128324 + 16 >> 2];
 HEAP32[i56 + 20 >> 2] = HEAP32[gb + 128324 + 20 >> 2];
 HEAP32[i56 + 24 >> 2] = HEAP32[gb + 128324 + 24 >> 2];
 HEAP32[i56 + 28 >> 2] = HEAP32[gb + 128324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i56 | 0, 32) | 0;
 HEAP32[i55 >> 2] = HEAP32[gb + 128356 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[gb + 128356 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[gb + 128356 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[gb + 128356 + 12 >> 2];
 HEAP32[i55 + 16 >> 2] = HEAP32[gb + 128356 + 16 >> 2];
 HEAP32[i55 + 20 >> 2] = HEAP32[gb + 128356 + 20 >> 2];
 HEAP32[i55 + 24 >> 2] = HEAP32[gb + 128356 + 24 >> 2];
 HEAP32[i55 + 28 >> 2] = HEAP32[gb + 128356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i55 | 0, 32) | 0;
 HEAP32[i54 >> 2] = gb + 1087820;
 HEAP32[i54 + 4 >> 2] = gb + 748731;
 HEAP32[i54 + 8 >> 2] = 0;
 HEAP32[i54 + 12 >> 2] = 4;
 HEAP32[i54 + 16 >> 2] = 1;
 HEAP32[i54 + 20 >> 2] = 0;
 HEAP32[i54 + 24 >> 2] = 8;
 HEAP32[i54 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i54 | 0, 32) | 0;
 HEAP32[i53 >> 2] = gb + 827882;
 HEAP32[i53 + 4 >> 2] = gb + 748748;
 HEAP32[i53 + 8 >> 2] = 4;
 HEAP32[i53 + 12 >> 2] = 4;
 HEAP32[i53 + 16 >> 2] = 1;
 HEAP32[i53 + 20 >> 2] = 0;
 HEAP32[i53 + 24 >> 2] = 0;
 HEAP32[i53 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i53 | 0, 32) | 0;
 HEAP32[i52 >> 2] = gb + 827882;
 HEAP32[i52 + 4 >> 2] = gb + 748765;
 HEAP32[i52 + 8 >> 2] = 8;
 HEAP32[i52 + 12 >> 2] = 4;
 HEAP32[i52 + 16 >> 2] = 1;
 HEAP32[i52 + 20 >> 2] = 0;
 HEAP32[i52 + 24 >> 2] = 2048;
 HEAP32[i52 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i52 | 0, 32) | 0;
 HEAP32[i51 >> 2] = gb + 774398;
 HEAP32[i51 + 4 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 4;
 HEAP32[i51 + 12 >> 2] = 4;
 HEAP32[i51 + 16 >> 2] = 0;
 HEAP32[i51 + 20 >> 2] = 0;
 HEAP32[i51 + 24 >> 2] = 16;
 HEAP32[i51 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i51 | 0, 32) | 0;
 HEAP32[i50 >> 2] = gb + 1087820;
 HEAP32[i50 + 4 >> 2] = gb + 748786;
 HEAP32[i50 + 8 >> 2] = 12;
 HEAP32[i50 + 12 >> 2] = 4;
 HEAP32[i50 + 16 >> 2] = 1;
 HEAP32[i50 + 20 >> 2] = 0;
 HEAP32[i50 + 24 >> 2] = 8;
 HEAP32[i50 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i50 | 0, 32) | 0;
 HEAP32[i49 >> 2] = gb + 827882;
 HEAP32[i49 + 4 >> 2] = gb + 748800;
 HEAP32[i49 + 8 >> 2] = 16;
 HEAP32[i49 + 12 >> 2] = 4;
 HEAP32[i49 + 16 >> 2] = 1;
 HEAP32[i49 + 20 >> 2] = 0;
 HEAP32[i49 + 24 >> 2] = 0;
 HEAP32[i49 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i49 | 0, 32) | 0;
 HEAP32[i48 >> 2] = gb + 827882;
 HEAP32[i48 + 4 >> 2] = gb + 748814;
 HEAP32[i48 + 8 >> 2] = 20;
 HEAP32[i48 + 12 >> 2] = 4;
 HEAP32[i48 + 16 >> 2] = 1;
 HEAP32[i48 + 20 >> 2] = 0;
 HEAP32[i48 + 24 >> 2] = 2048;
 HEAP32[i48 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i48 | 0, 32) | 0;
 HEAP32[i47 >> 2] = gb + 827882;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 16;
 HEAP32[i47 + 12 >> 2] = 4;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAP32[i47 + 20 >> 2] = 0;
 HEAP32[i47 + 24 >> 2] = 16;
 HEAP32[i47 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i47 | 0, 32) | 0;
 HEAP32[i46 >> 2] = gb + 1087820;
 HEAP32[i46 + 4 >> 2] = gb + 748832;
 HEAP32[i46 + 8 >> 2] = 24;
 HEAP32[i46 + 12 >> 2] = 4;
 HEAP32[i46 + 16 >> 2] = 1;
 HEAP32[i46 + 20 >> 2] = 0;
 HEAP32[i46 + 24 >> 2] = 8;
 HEAP32[i46 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i46 | 0, 32) | 0;
 HEAP32[i45 >> 2] = gb + 827882;
 HEAP32[i45 + 4 >> 2] = gb + 748852;
 HEAP32[i45 + 8 >> 2] = 28;
 HEAP32[i45 + 12 >> 2] = 4;
 HEAP32[i45 + 16 >> 2] = 1;
 HEAP32[i45 + 20 >> 2] = 0;
 HEAP32[i45 + 24 >> 2] = 0;
 HEAP32[i45 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i45 | 0, 32) | 0;
 HEAP32[i44 >> 2] = gb + 827882;
 HEAP32[i44 + 4 >> 2] = gb + 748872;
 HEAP32[i44 + 8 >> 2] = 32;
 HEAP32[i44 + 12 >> 2] = 4;
 HEAP32[i44 + 16 >> 2] = 1;
 HEAP32[i44 + 20 >> 2] = 0;
 HEAP32[i44 + 24 >> 2] = 2048;
 HEAP32[i44 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i44 | 0, 32) | 0;
 HEAP32[i43 >> 2] = gb + 829437;
 HEAP32[i43 + 4 >> 2] = 0;
 HEAP32[i43 + 8 >> 2] = 28;
 HEAP32[i43 + 12 >> 2] = 4;
 HEAP32[i43 + 16 >> 2] = 0;
 HEAP32[i43 + 20 >> 2] = 0;
 HEAP32[i43 + 24 >> 2] = 16;
 HEAP32[i43 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i43 | 0, 32) | 0;
 HEAP32[i42 >> 2] = gb + 1087820;
 HEAP32[i42 + 4 >> 2] = gb + 748896;
 HEAP32[i42 + 8 >> 2] = 36;
 HEAP32[i42 + 12 >> 2] = 4;
 HEAP32[i42 + 16 >> 2] = 1;
 HEAP32[i42 + 20 >> 2] = 0;
 HEAP32[i42 + 24 >> 2] = 8;
 HEAP32[i42 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i42 | 0, 32) | 0;
 HEAP32[i41 >> 2] = gb + 827882;
 HEAP32[i41 + 4 >> 2] = gb + 748920;
 HEAP32[i41 + 8 >> 2] = 40;
 HEAP32[i41 + 12 >> 2] = 4;
 HEAP32[i41 + 16 >> 2] = 1;
 HEAP32[i41 + 20 >> 2] = 0;
 HEAP32[i41 + 24 >> 2] = 0;
 HEAP32[i41 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i41 | 0, 32) | 0;
 HEAP32[i40 >> 2] = gb + 827882;
 HEAP32[i40 + 4 >> 2] = gb + 748944;
 HEAP32[i40 + 8 >> 2] = 44;
 HEAP32[i40 + 12 >> 2] = 4;
 HEAP32[i40 + 16 >> 2] = 1;
 HEAP32[i40 + 20 >> 2] = 0;
 HEAP32[i40 + 24 >> 2] = 2048;
 HEAP32[i40 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i40 | 0, 32) | 0;
 HEAP32[i39 >> 2] = gb + 774398;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 40;
 HEAP32[i39 + 12 >> 2] = 4;
 HEAP32[i39 + 16 >> 2] = 0;
 HEAP32[i39 + 20 >> 2] = 0;
 HEAP32[i39 + 24 >> 2] = 16;
 HEAP32[i39 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i39 | 0, 32) | 0;
 HEAP32[i38 >> 2] = gb + 1087820;
 HEAP32[i38 + 4 >> 2] = gb + 748972;
 HEAP32[i38 + 8 >> 2] = 48;
 HEAP32[i38 + 12 >> 2] = 4;
 HEAP32[i38 + 16 >> 2] = 1;
 HEAP32[i38 + 20 >> 2] = 0;
 HEAP32[i38 + 24 >> 2] = 8;
 HEAP32[i38 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i38 | 0, 32) | 0;
 HEAP32[i37 >> 2] = gb + 827882;
 HEAP32[i37 + 4 >> 2] = gb + 748994;
 HEAP32[i37 + 8 >> 2] = 52;
 HEAP32[i37 + 12 >> 2] = 4;
 HEAP32[i37 + 16 >> 2] = 1;
 HEAP32[i37 + 20 >> 2] = 0;
 HEAP32[i37 + 24 >> 2] = 0;
 HEAP32[i37 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i37 | 0, 32) | 0;
 HEAP32[i36 >> 2] = gb + 827882;
 HEAP32[i36 + 4 >> 2] = gb + 749016;
 HEAP32[i36 + 8 >> 2] = 56;
 HEAP32[i36 + 12 >> 2] = 4;
 HEAP32[i36 + 16 >> 2] = 1;
 HEAP32[i36 + 20 >> 2] = 0;
 HEAP32[i36 + 24 >> 2] = 2048;
 HEAP32[i36 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i36 | 0, 32) | 0;
 HEAP32[i35 >> 2] = gb + 827882;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 52;
 HEAP32[i35 + 12 >> 2] = 4;
 HEAP32[i35 + 16 >> 2] = 0;
 HEAP32[i35 + 20 >> 2] = 0;
 HEAP32[i35 + 24 >> 2] = 16;
 HEAP32[i35 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i35 | 0, 32) | 0;
 HEAP32[i34 >> 2] = gb + 1087820;
 HEAP32[i34 + 4 >> 2] = gb + 749042;
 HEAP32[i34 + 8 >> 2] = 60;
 HEAP32[i34 + 12 >> 2] = 4;
 HEAP32[i34 + 16 >> 2] = 1;
 HEAP32[i34 + 20 >> 2] = 0;
 HEAP32[i34 + 24 >> 2] = 8;
 HEAP32[i34 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i34 | 0, 32) | 0;
 HEAP32[i33 >> 2] = gb + 827882;
 HEAP32[i33 + 4 >> 2] = gb + 749065;
 HEAP32[i33 + 8 >> 2] = 64;
 HEAP32[i33 + 12 >> 2] = 4;
 HEAP32[i33 + 16 >> 2] = 1;
 HEAP32[i33 + 20 >> 2] = 0;
 HEAP32[i33 + 24 >> 2] = 0;
 HEAP32[i33 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i33 | 0, 32) | 0;
 HEAP32[i32 >> 2] = gb + 827882;
 HEAP32[i32 + 4 >> 2] = gb + 749088;
 HEAP32[i32 + 8 >> 2] = 68;
 HEAP32[i32 + 12 >> 2] = 4;
 HEAP32[i32 + 16 >> 2] = 1;
 HEAP32[i32 + 20 >> 2] = 0;
 HEAP32[i32 + 24 >> 2] = 2048;
 HEAP32[i32 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i32 | 0, 32) | 0;
 HEAP32[i31 >> 2] = gb + 774398;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 64;
 HEAP32[i31 + 12 >> 2] = 4;
 HEAP32[i31 + 16 >> 2] = 0;
 HEAP32[i31 + 20 >> 2] = 0;
 HEAP32[i31 + 24 >> 2] = 16;
 HEAP32[i31 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = gb + 1087820;
 HEAP32[i30 + 4 >> 2] = gb + 749115;
 HEAP32[i30 + 8 >> 2] = 72;
 HEAP32[i30 + 12 >> 2] = 4;
 HEAP32[i30 + 16 >> 2] = 1;
 HEAP32[i30 + 20 >> 2] = 0;
 HEAP32[i30 + 24 >> 2] = 8;
 HEAP32[i30 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = gb + 827882;
 HEAP32[i29 + 4 >> 2] = gb + 749134;
 HEAP32[i29 + 8 >> 2] = 76;
 HEAP32[i29 + 12 >> 2] = 4;
 HEAP32[i29 + 16 >> 2] = 1;
 HEAP32[i29 + 20 >> 2] = 0;
 HEAP32[i29 + 24 >> 2] = 0;
 HEAP32[i29 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = gb + 827882;
 HEAP32[i28 + 4 >> 2] = gb + 749153;
 HEAP32[i28 + 8 >> 2] = 80;
 HEAP32[i28 + 12 >> 2] = 4;
 HEAP32[i28 + 16 >> 2] = 1;
 HEAP32[i28 + 20 >> 2] = 0;
 HEAP32[i28 + 24 >> 2] = 2048;
 HEAP32[i28 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = gb + 827882;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 76;
 HEAP32[i27 + 12 >> 2] = 4;
 HEAP32[i27 + 16 >> 2] = 0;
 HEAP32[i27 + 20 >> 2] = 0;
 HEAP32[i27 + 24 >> 2] = 16;
 HEAP32[i27 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = gb + 1087820;
 HEAP32[i26 + 4 >> 2] = gb + 749176;
 HEAP32[i26 + 8 >> 2] = 84;
 HEAP32[i26 + 12 >> 2] = 4;
 HEAP32[i26 + 16 >> 2] = 1;
 HEAP32[i26 + 20 >> 2] = 0;
 HEAP32[i26 + 24 >> 2] = 8;
 HEAP32[i26 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = gb + 827882;
 HEAP32[i25 + 4 >> 2] = gb + 749202;
 HEAP32[i25 + 8 >> 2] = 88;
 HEAP32[i25 + 12 >> 2] = 4;
 HEAP32[i25 + 16 >> 2] = 1;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP32[i25 + 24 >> 2] = 0;
 HEAP32[i25 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = gb + 827882;
 HEAP32[i24 + 4 >> 2] = gb + 749228;
 HEAP32[i24 + 8 >> 2] = 92;
 HEAP32[i24 + 12 >> 2] = 4;
 HEAP32[i24 + 16 >> 2] = 1;
 HEAP32[i24 + 20 >> 2] = 0;
 HEAP32[i24 + 24 >> 2] = 2048;
 HEAP32[i24 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = gb + 774450;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 88;
 HEAP32[i23 + 12 >> 2] = 4;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 16;
 HEAP32[i23 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = gb + 1087820;
 HEAP32[i22 + 4 >> 2] = gb + 749258;
 HEAP32[i22 + 8 >> 2] = 96;
 HEAP32[i22 + 12 >> 2] = 4;
 HEAP32[i22 + 16 >> 2] = 1;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 8;
 HEAP32[i22 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = gb + 827882;
 HEAP32[i21 + 4 >> 2] = gb + 749277;
 HEAP32[i21 + 8 >> 2] = 100;
 HEAP32[i21 + 12 >> 2] = 4;
 HEAP32[i21 + 16 >> 2] = 1;
 HEAP32[i21 + 20 >> 2] = 0;
 HEAP32[i21 + 24 >> 2] = 0;
 HEAP32[i21 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = gb + 827882;
 HEAP32[i20 + 4 >> 2] = gb + 749296;
 HEAP32[i20 + 8 >> 2] = 104;
 HEAP32[i20 + 12 >> 2] = 4;
 HEAP32[i20 + 16 >> 2] = 1;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 24 >> 2] = 2048;
 HEAP32[i20 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = gb + 774398;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 100;
 HEAP32[i19 + 12 >> 2] = 4;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 16;
 HEAP32[i19 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = gb + 1087820;
 HEAP32[i18 + 4 >> 2] = gb + 749319;
 HEAP32[i18 + 8 >> 2] = 108;
 HEAP32[i18 + 12 >> 2] = 4;
 HEAP32[i18 + 16 >> 2] = 1;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 8;
 HEAP32[i18 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = gb + 827882;
 HEAP32[i17 + 4 >> 2] = gb + 749348;
 HEAP32[i17 + 8 >> 2] = 112;
 HEAP32[i17 + 12 >> 2] = 4;
 HEAP32[i17 + 16 >> 2] = 1;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = gb + 827882;
 HEAP32[i16 + 4 >> 2] = gb + 749377;
 HEAP32[i16 + 8 >> 2] = 116;
 HEAP32[i16 + 12 >> 2] = 4;
 HEAP32[i16 + 16 >> 2] = 1;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 2048;
 HEAP32[i16 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = gb + 774398;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 112;
 HEAP32[i15 + 12 >> 2] = 4;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 16;
 HEAP32[i15 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = gb + 1087820;
 HEAP32[i14 + 4 >> 2] = gb + 749410;
 HEAP32[i14 + 8 >> 2] = 120;
 HEAP32[i14 + 12 >> 2] = 4;
 HEAP32[i14 + 16 >> 2] = 1;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 8;
 HEAP32[i14 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = gb + 827882;
 HEAP32[i13 + 4 >> 2] = gb + 749439;
 HEAP32[i13 + 8 >> 2] = 124;
 HEAP32[i13 + 12 >> 2] = 4;
 HEAP32[i13 + 16 >> 2] = 1;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 HEAP32[i13 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = gb + 827882;
 HEAP32[i12 + 4 >> 2] = gb + 749468;
 HEAP32[i12 + 8 >> 2] = 128;
 HEAP32[i12 + 12 >> 2] = 4;
 HEAP32[i12 + 16 >> 2] = 1;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 2048;
 HEAP32[i12 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = gb + 774398;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 124;
 HEAP32[i11 + 12 >> 2] = 4;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 16;
 HEAP32[i11 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 1087820;
 HEAP32[i10 + 4 >> 2] = gb + 749501;
 HEAP32[i10 + 8 >> 2] = 132;
 HEAP32[i10 + 12 >> 2] = 4;
 HEAP32[i10 + 16 >> 2] = 1;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 8;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 827882;
 HEAP32[i9 + 4 >> 2] = gb + 749529;
 HEAP32[i9 + 8 >> 2] = 136;
 HEAP32[i9 + 12 >> 2] = 4;
 HEAP32[i9 + 16 >> 2] = 1;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = gb + 827882;
 HEAP32[i8 + 4 >> 2] = gb + 749557;
 HEAP32[i8 + 8 >> 2] = 140;
 HEAP32[i8 + 12 >> 2] = 4;
 HEAP32[i8 + 16 >> 2] = 1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 2048;
 HEAP32[i8 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 827882;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 136;
 HEAP32[i7 + 12 >> 2] = 4;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 16;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 1087820;
 HEAP32[i6 + 4 >> 2] = gb + 749589;
 HEAP32[i6 + 8 >> 2] = 144;
 HEAP32[i6 + 12 >> 2] = 4;
 HEAP32[i6 + 16 >> 2] = 1;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 8;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 827882;
 HEAP32[i5 + 4 >> 2] = gb + 749610;
 HEAP32[i5 + 8 >> 2] = 148;
 HEAP32[i5 + 12 >> 2] = 4;
 HEAP32[i5 + 16 >> 2] = 1;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 827882;
 HEAP32[i4 + 4 >> 2] = gb + 749631;
 HEAP32[i4 + 8 >> 2] = 152;
 HEAP32[i4 + 12 >> 2] = 4;
 HEAP32[i4 + 16 >> 2] = 1;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 2048;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = gb + 774398;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 148;
 HEAP32[i3 + 12 >> 2] = 4;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 16;
 HEAP32[i3 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5Umbra17LineSegmentFinder13queryInternalILb1EEEbRKNS_7Vector3ES4_RNS_4CellES6_PNS_8UserListIiEE(i137, i1, i2, i3, i130, i131) {
 i137 = i137 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i130 = i130 | 0;
 i131 = i131 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i138 = 0, i139 = 0, i140 = 0, f141 = f0, f142 = f0;
 i140 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i132 = i140 + 72 | 0;
 i133 = i140 + 32 | 0;
 i134 = i140 + 16 | 0;
 i135 = i140;
 i89 = HEAP32[i137 >> 2] | 0;
 i138 = i89 + 48 | 0;
 i139 = HEAP32[i138 >> 2] | 0;
 HEAP32[i138 >> 2] = i139 + 1;
 i125 = i137 + 4120 | 0;
 HEAP32[i125 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i125 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i125 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i129 = i137 + 4132 | 0;
 HEAP32[i129 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i129 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i129 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 f40 = Math_fround(HEAPF32[i129 >> 2]);
 f19 = Math_fround(HEAPF32[i125 >> 2]);
 f43 = Math_fround(f40 - f19);
 f41 = Math_fround(HEAPF32[i137 + 4136 >> 2]);
 f20 = Math_fround(HEAPF32[i137 + 4124 >> 2]);
 f44 = Math_fround(f41 - f20);
 f42 = Math_fround(HEAPF32[i137 + 4140 >> 2]);
 f21 = Math_fround(HEAPF32[i137 + 4128 >> 2]);
 f45 = Math_fround(f42 - f21);
 i125 = i137 + 4296 | 0;
 HEAPF32[i125 >> 2] = f19;
 i120 = i137 + 4300 | 0;
 HEAPF32[i120 >> 2] = f20;
 i122 = i137 + 4304 | 0;
 HEAPF32[i122 >> 2] = f21;
 i124 = i137 + 4308 | 0;
 HEAPF32[i124 >> 2] = Math_fround(1.0);
 i126 = i137 + 4312 | 0;
 HEAPF32[i126 >> 2] = f40;
 i119 = i137 + 4316 | 0;
 HEAPF32[i119 >> 2] = f41;
 i121 = i137 + 4320 | 0;
 HEAPF32[i121 >> 2] = f42;
 i123 = i137 + 4324 | 0;
 HEAPF32[i123 >> 2] = Math_fround(1.0);
 i118 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i117 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i127 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i127 = (i127 << 5 | (i118 << 1 | i118 | i117 << 2 | i117 << 3 | i127 << 4)) ^ 42;
 i89 = HEAP32[HEAP32[i89 >> 2] >> 2] | 0;
 i117 = HEAP32[i3 >> 2] | 0;
 i118 = HEAP32[i3 + 4 >> 2] | 0;
 i89 = i118 + (HEAP32[i89 + (HEAP32[i89 + 136 >> 2] | 0) + (i117 << 2) >> 2] | 0) | 0;
 i128 = i137 + 4108 | 0;
 HEAP32[i128 >> 2] = 0;
 i136 = i137 + 4112 | 0;
 HEAP32[i136 >> 2] = 0;
 i87 = i137 + 3076 | 0;
 HEAP32[i87 >> 2] = 0;
 i88 = i137 + 3080 | 0;
 HEAP32[i137 + 4 >> 2] = i117;
 HEAP32[i137 + 8 >> 2] = i118;
 HEAP32[i137 + 12 >> 2] = i89;
 HEAP32[i88 >> 2] = 1;
 i89 = (i131 | 0) != 0;
 if (i89) {
  i118 = HEAP32[HEAP32[HEAP32[i137 >> 2] >> 2] >> 2] | 0;
  i49 = HEAP32[i118 + 68 >> 2] | 0;
  i49 = (i49 | 0) == 0 ? 0 : i118 + i49 | 0;
 } else i49 = 0;
 HEAP32[i133 >> 2] = -1;
 i90 = i133 + 4 | 0;
 HEAP32[i90 >> 2] = 0;
 i91 = i133 + 8 | 0;
 HEAP32[i91 >> 2] = 0;
 i92 = i133 + 12 | 0;
 HEAP32[i92 >> 2] = 0;
 i93 = i133 + 28 | 0;
 HEAP32[i93 >> 2] = 0;
 i94 = i133 + 32 | 0;
 HEAP32[i94 >> 2] = 0;
 HEAP32[i134 >> 2] = 0;
 HEAP32[i134 + 4 >> 2] = 0;
 HEAP32[i134 + 8 >> 2] = 0;
 HEAP32[i134 + 12 >> 2] = 0;
 HEAP32[i135 >> 2] = 0;
 HEAP32[i135 + 4 >> 2] = 0;
 HEAP32[i135 + 8 >> 2] = 0;
 HEAP32[i135 + 12 >> 2] = 0;
 i95 = i130 + 4 | 0;
 i96 = i137 + 4148 | 0;
 i97 = i137 + 4156 | 0;
 i98 = i137 + 4172 | 0;
 i99 = i137 + 4224 | 0;
 i100 = i137 + 4256 | 0;
 i101 = i137 + 4236 | 0;
 i102 = i137 + 4240 | 0;
 i103 = i137 + 4244 | 0;
 i104 = i137 + 4252 | 0;
 i105 = i131 + 8 | 0;
 i106 = i131 + 4 | 0;
 i107 = i137 + 4232 | 0;
 i108 = i137 + 4228 | 0;
 i109 = i137 + 4248 | 0;
 i110 = i137 + 4360 | 0;
 i111 = i137 + 4364 | 0;
 i112 = i137 + 4368 | 0;
 i113 = i137 + 4392 | 0;
 i114 = i137 + 4396 | 0;
 i115 = i137 + 4400 | 0;
 i116 = i137 + 4144 | 0;
 i117 = i137 + 4328 | 0;
 i118 = i137 + 4332 | 0;
 i58 = i137 + 4336 | 0;
 i59 = i137 + 4424 | 0;
 i60 = i137 + 4428 | 0;
 i61 = i137 + 4432 | 0;
 i62 = i137 + 4344 | 0;
 i63 = i137 + 4348 | 0;
 i64 = i137 + 4352 | 0;
 i65 = i137 + 4356 | 0;
 i66 = i132 + 4 | 0;
 i67 = i132 + 8 | 0;
 i68 = i132 + 12 | 0;
 i69 = i132 + 28 | 0;
 i70 = i132 + 32 | 0;
 i71 = i137 + 4264 | 0;
 i72 = i137 + 4280 | 0;
 i73 = i134 + 4 | 0;
 i74 = i134 + 8 | 0;
 i75 = i135 + 4 | 0;
 i76 = i135 + 8 | 0;
 i77 = i137 + 4408 | 0;
 i78 = i137 + 4412 | 0;
 i79 = i137 + 4416 | 0;
 i80 = i137 + 4116 | 0;
 i81 = i137 + 4192 | 0;
 i82 = i137 + 4208 | 0;
 i83 = i137 + 4184 | 0;
 i84 = i137 + 4220 | 0;
 i85 = i137 + 4360 | 0;
 i57 = i137 + 4372 | 0;
 i86 = i137 + 4376 | 0;
 i50 = i137 + 4380 | 0;
 i51 = i137 + 4384 | 0;
 i56 = i137 + 4388 | 0;
 i55 = i137 + 4420 | 0;
 i54 = i137 + 4404 | 0;
 i53 = i137 + 4340 | 0;
 i52 = i137 + 4436 | 0;
 i2 = -1;
 i5 = 0;
 f40 = Math_fround(0.0);
 f41 = Math_fround(0.0);
 i22 = 0;
 f42 = Math_fround(0.0);
 f43 = Math_fround(0.0);
 i11 = 0;
 f44 = Math_fround(0.0);
 f45 = Math_fround(0.0);
 i1 = 1;
 while (1) {
  i10 = i1 + 255 & 255;
  HEAP32[i88 >> 2] = i10;
  i47 = HEAP32[i137 + 4 + (i10 * 12 | 0) >> 2] | 0;
  i48 = HEAP32[i137 + 4 + (i10 * 12 | 0) + 4 >> 2] | 0;
  i10 = HEAP32[i137 + 4 + (i10 * 12 | 0) + 8 >> 2] | 0;
  if ((i47 | 0) == (i2 | 0)) i46 = i2; else {
   __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(HEAP32[i137 >> 2] | 0, i133, i47);
   i5 = HEAP32[i93 >> 2] | 0;
   i1 = HEAP32[i5 + 56 >> 2] | 0;
   i4 = HEAP32[i5 + 52 >> 2] & 65535;
   HEAP32[i83 >> 2] = i4;
   HEAP32[i97 >> 2] = (i1 | 0) == 0 ? 0 : i5 + i1 | 0;
   i1 = HEAP32[i94 >> 2] | 0;
   if (!i1) {
    i2 = 0;
    i3 = 0;
    i1 = 0;
   } else {
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = (i3 | 0) == 0;
    i2 = i1 ? 0 : HEAP32[i92 >> 2] | 0;
    i1 = i1 ? 0 : i4;
   }
   HEAP32[i84 >> 2] = i1;
   HEAP32[i81 >> 2] = (i3 | 0) == 0 ? 0 : i2 + i3 | 0;
   i36 = HEAP32[i5 >> 2] | 0;
   i39 = HEAP32[i5 + 4 >> 2] | 0;
   i37 = HEAP32[i5 + 8 >> 2] | 0;
   i35 = HEAP32[i5 + 12 >> 2] | 0;
   i46 = HEAP32[i5 + 16 >> 2] | 0;
   i38 = HEAP32[i5 + 20 >> 2] | 0;
   HEAP32[i85 >> 2] = i36;
   HEAP32[i111 >> 2] = i39;
   HEAP32[i112 >> 2] = i37;
   HEAPF32[i57 >> 2] = Math_fround(1.0);
   HEAP32[i86 >> 2] = i35;
   HEAP32[i50 >> 2] = i46;
   HEAP32[i51 >> 2] = i38;
   HEAPF32[i56 >> 2] = Math_fround(1.0);
   i34 = HEAP32[i5 + 48 >> 2] | 0;
   HEAP32[i80 >> 2] = i34;
   HEAP32[i77 >> 2] = i34;
   HEAP32[i78 >> 2] = i34;
   HEAP32[i79 >> 2] = i34;
   HEAPF32[i55 >> 2] = Math_fround(0.0);
   f15 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = Math_fround(f15 - f8);
   f14 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f14 - f9);
   f17 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f17 - f18);
   i37 = f15 == Math_fround(0.0);
   f21 = Math_fround(Math_fround(1.0) / f15);
   f21 = i37 ? Math_fround(1.0) : f21;
   i37 = f14 == Math_fround(0.0);
   f20 = Math_fround(Math_fround(1.0) / f14);
   f20 = i37 ? Math_fround(1.0) : f20;
   i37 = f17 == Math_fround(0.0);
   f19 = Math_fround(Math_fround(1.0) / f17);
   f19 = i37 ? Math_fround(1.0) : f19;
   f21 = Math_fround(Math_fround(Math_fround(f21 + f21) - Math_fround(f21 * Math_fround(f15 * f21))) * Math_fround(65535.0));
   f20 = Math_fround(Math_fround(Math_fround(f20 + f20) - Math_fround(f20 * Math_fround(f14 * f20))) * Math_fround(65535.0));
   f19 = Math_fround(Math_fround(Math_fround(f19 + f19) - Math_fround(f19 * Math_fround(f17 * f19))) * Math_fround(65535.0));
   HEAPF32[i113 >> 2] = f21;
   HEAPF32[i114 >> 2] = f20;
   HEAPF32[i115 >> 2] = f19;
   HEAPF32[i54 >> 2] = Math_fround(131070.0);
   f17 = Math_fround(Math_fround(HEAPF32[i125 >> 2]) - f8);
   f14 = Math_fround(Math_fround(HEAPF32[i120 >> 2]) - f9);
   f15 = Math_fround(Math_fround(HEAPF32[i122 >> 2]) - f18);
   f17 = Math_fround(f17 * f21);
   f14 = Math_fround(f14 * f20);
   f15 = Math_fround(f15 * f19);
   f16 = Math_fround(Math_fround(Math_fround(HEAPF32[i124 >> 2]) + Math_fround(-1.0)) * Math_fround(131070.0));
   HEAPF32[i117 >> 2] = f17;
   HEAPF32[i118 >> 2] = f14;
   HEAPF32[i58 >> 2] = f15;
   HEAPF32[i53 >> 2] = f16;
   f8 = Math_fround(Math_fround(HEAPF32[i126 >> 2]) - f8);
   f9 = Math_fround(Math_fround(HEAPF32[i119 >> 2]) - f9);
   f18 = Math_fround(Math_fround(HEAPF32[i121 >> 2]) - f18);
   f21 = Math_fround(f8 * f21);
   f20 = Math_fround(f9 * f20);
   f19 = Math_fround(f18 * f19);
   f18 = Math_fround(Math_fround(Math_fround(HEAPF32[i123 >> 2]) + Math_fround(-1.0)) * Math_fround(131070.0));
   HEAPF32[i62 >> 2] = f21;
   HEAPF32[i63 >> 2] = f20;
   HEAPF32[i64 >> 2] = f19;
   HEAPF32[i65 >> 2] = f18;
   f17 = Math_fround(f21 - f17);
   f14 = Math_fround(f20 - f14);
   f15 = Math_fround(f19 - f15);
   f16 = Math_fround(f18 - f16);
   i37 = f17 == Math_fround(0.0);
   i38 = f14 == Math_fround(0.0);
   i39 = f15 == Math_fround(0.0);
   i46 = f16 == Math_fround(0.0);
   f17 = i37 ? Math_fround(1.0) : f17;
   f18 = Math_fround(Math_fround(1.0) / f17);
   f14 = i38 ? Math_fround(1.0) : f14;
   f19 = Math_fround(Math_fround(1.0) / f14);
   f15 = i39 ? Math_fround(1.0) : f15;
   f20 = Math_fround(Math_fround(1.0) / f15);
   f16 = i46 ? Math_fround(1.0) : f16;
   f21 = Math_fround(Math_fround(1.0) / f16);
   f19 = Math_fround(Math_fround(f19 + f19) - Math_fround(f19 * Math_fround(f14 * f19)));
   f20 = Math_fround(Math_fround(f20 + f20) - Math_fround(f20 * Math_fround(f15 * f20)));
   f21 = Math_fround(Math_fround(f21 + f21) - Math_fround(f21 * Math_fround(f16 * f21)));
   HEAPF32[i59 >> 2] = Math_fround(Math_fround(f18 + f18) - Math_fround(f18 * Math_fround(f17 * f18)));
   HEAPF32[i60 >> 2] = f19;
   HEAPF32[i61 >> 2] = f20;
   HEAPF32[i52 >> 2] = f21;
   i46 = i47;
  }
  i1 = (HEAP32[i96 >> 2] | 0) + (i10 >> 5 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i10 & 31);
  HEAP32[i137 + 3084 + (HEAP32[i136 >> 2] << 2) >> 2] = i10;
  i1 = (HEAP32[i136 >> 2] | 0) + 1 & 255;
  HEAP32[i136 >> 2] = i1;
  if ((i1 | 0) == (HEAP32[i128 >> 2] | 0)) {
   i38 = HEAP32[i137 + 3084 + (i1 << 2) >> 2] | 0;
   i39 = (HEAP32[i96 >> 2] | 0) + (i38 >> 5 << 2) | 0;
   HEAP32[i39 >> 2] = HEAP32[i39 >> 2] & ~(1 << (i38 & 31));
   HEAP32[i128 >> 2] = (HEAP32[i128 >> 2] | 0) + 1 & 255;
  }
  i13 = (HEAP32[i97 >> 2] | 0) + (Math_imul(HEAP32[i98 >> 2] | 0, i48) | 0) | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
  i12 = HEAP32[i13 + 8 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  i1 = HEAP32[i94 >> 2] | 0;
  if (!i1) {
   i39 = i11;
   i29 = 0;
  } else if (!(HEAP32[i1 + 8 >> 2] | 0)) {
   i39 = i11;
   i29 = 0;
  } else {
   i29 = (HEAP32[i81 >> 2] | 0) + (Math_imul(HEAP32[i82 >> 2] | 0, i48) | 0) | 0;
   i22 = HEAP32[i92 >> 2] | 0;
   i39 = (HEAP32[i1 + 12 >> 2] | 0) + (HEAP32[i29 >> 2] << 4) | 0;
   i29 = HEAP32[i29 + 4 >> 2] | 0;
  }
  i30 = HEAP32[i93 >> 2] | 0;
  i28 = (HEAP32[i30 + 60 >> 2] | 0) + (i2 << 4) | 0;
  i28 = (i28 | 0) == 0 ? 0 : i30 + i28 | 0;
  i30 = (i28 | 0) == 0 ? 0 : i3;
  L19 : do if (i89) {
   i3 = HEAP32[i91 >> 2] | 0;
   i10 = HEAP32[i3 + 84 >> 2] | 0;
   i4 = i10 & 31;
   i10 = i10 >>> 5 & 31;
   i11 = i10 + i4 | 0;
   i1 = Math_imul(i11, i12) | 0;
   i2 = ((Math_imul(i11, HEAP32[i3 + 92 >> 2] | 0) | 0) + 31 >> 5 << 5) - i1 | 0;
   if (i2 | 0) {
    HEAP32[i99 >> 2] = i3 + (HEAP32[i3 + 88 >> 2] | 0);
    HEAP32[i108 >> 2] = i2;
    HEAP32[i107 >> 2] = i1;
   }
   HEAP8[i100 >> 0] = i11 >>> 0 > 31 & 1;
   HEAP32[i101 >> 2] = i4;
   HEAP32[i102 >> 2] = i10;
   HEAP32[i103 >> 2] = i13;
   HEAP32[i104 >> 2] = 0;
   if ((HEAP32[i105 >> 2] | 0) <= (HEAP32[i106 >> 2] | 0)) {
    i27 = HEAP32[i90 >> 2] | 0;
    i25 = (i27 | 0) == 0;
    i26 = HEAP32[i92 >> 2] | 0;
    i27 = i27 + 8 | 0;
    if (i13 | 0) {
     i24 = i13;
     do {
      i1 = HEAP32[i104 >> 2] | 0;
      do if (!i1) {
       i11 = HEAP32[i101 >> 2] | 0;
       if (!(HEAP8[i100 >> 0] | 0)) {
        i2 = (HEAP32[i102 >> 2] | 0) + i11 | 0;
        i36 = HEAP32[i99 >> 2] | 0;
        i38 = HEAP32[i107 >> 2] | 0;
        i37 = i38 >> 5;
        i1 = i38 & 31;
        i1 = (HEAP32[i36 + (i37 + 1 << 2) >> 2] << 32 - i1 & -1 << (i1 ^ 31) | (HEAP32[i36 + (i37 << 2) >> 2] | 0) >>> i1) & (1 << i2) + -1;
        HEAP32[i107 >> 2] = i38 + i2;
        HEAP32[i108 >> 2] = (HEAP32[i108 >> 2] | 0) - i2;
        i2 = i1 & (1 << i11) + -1;
        HEAP32[i109 >> 2] = i2;
        i1 = i1 >>> i11;
        HEAP32[i104 >> 2] = i1;
        break;
       }
       i23 = HEAP32[i99 >> 2] | 0;
       i10 = HEAP32[i107 >> 2] | 0;
       i4 = i10 >> 5;
       i1 = i10 & 31;
       i2 = (HEAP32[i23 + (i4 << 2) >> 2] | 0) >>> i1;
       i3 = 32 - i1 | 0;
       i4 = HEAP32[i23 + (i4 + 1 << 2) >> 2] << i3;
       if ((i11 | 0) < 32) i2 = (i4 & -1 << (i1 ^ 31) | i2) & (1 << i11) + -1; else i2 = -1 << i3 & 0 - i1 >> 31 & i4 | i2;
       i13 = i10 + i11 | 0;
       HEAP32[i107 >> 2] = i13;
       i11 = (HEAP32[i108 >> 2] | 0) - i11 | 0;
       HEAP32[i108 >> 2] = i11;
       HEAP32[i109 >> 2] = i2;
       i12 = HEAP32[i102 >> 2] | 0;
       i1 = i13 >> 5;
       i3 = i13 & 31;
       i4 = (HEAP32[i23 + (i1 << 2) >> 2] | 0) >>> i3;
       i10 = 32 - i3 | 0;
       i1 = HEAP32[i23 + (i1 + 1 << 2) >> 2] << i10;
       if ((i12 | 0) < 32) i1 = (i1 & -1 << (i3 ^ 31) | i4) & (1 << i12) + -1; else i1 = -1 << i10 & 0 - i3 >> 31 & i1 | i4;
       HEAP32[i107 >> 2] = i12 + i13;
       HEAP32[i108 >> 2] = i11 - i12;
       HEAP32[i104 >> 2] = i1;
      } else i2 = HEAP32[i109 >> 2] | 0; while (0);
      HEAP32[i103 >> 2] = i24 + -1;
      HEAP32[i104 >> 2] = i1 + -1;
      HEAP32[i109 >> 2] = i2 + 1;
      if (!i25) i2 = HEAP32[i26 + (HEAP32[i27 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      i36 = i49 + (i2 * 24 | 0) | 0;
      f6 = Math_fround(HEAPF32[i36 >> 2]);
      f7 = Math_fround(HEAPF32[i36 + 4 >> 2]);
      f8 = Math_fround(HEAPF32[i36 + 8 >> 2]);
      f9 = Math_fround(HEAPF32[i36 + 12 >> 2]);
      f14 = Math_fround(HEAPF32[i36 + 16 >> 2]);
      f15 = Math_fround(HEAPF32[i36 + 20 >> 2]);
      f16 = Math_fround(HEAPF32[i110 >> 2]);
      f17 = Math_fround(HEAPF32[i111 >> 2]);
      f18 = Math_fround(HEAPF32[i112 >> 2]);
      f19 = Math_fround(HEAPF32[i113 >> 2]);
      f20 = Math_fround(HEAPF32[i114 >> 2]);
      f21 = Math_fround(HEAPF32[i115 >> 2]);
      i36 = (HEAP32[i116 >> 2] | 0) + (i2 >> 5 << 2) | 0;
      i38 = 1 << (i2 & 31);
      i37 = HEAP32[i36 >> 2] | 0;
      HEAP32[i36 >> 2] = i37 | i38;
      if (!(i37 & i38)) {
       f15 = Math_fround(Math_fround(f15 - f18) * f21);
       f141 = Math_fround(Math_fround(f14 - f17) * f20);
       f142 = Math_fround(Math_fround(f9 - f16) * f19);
       f21 = Math_fround(Math_fround(f8 - f18) * f21);
       f14 = Math_fround(Math_fround(f7 - f17) * f20);
       f9 = Math_fround(Math_fround(f6 - f16) * f19);
       f8 = Math_fround(HEAPF32[i117 >> 2]);
       f9 = Math_fround(f9 - f8);
       f17 = Math_fround(HEAPF32[i118 >> 2]);
       f14 = Math_fround(f14 - f17);
       f19 = Math_fround(HEAPF32[i58 >> 2]);
       f20 = Math_fround(f21 - f19);
       f21 = Math_fround(HEAPF32[i59 >> 2]);
       f9 = Math_fround(f9 * f21);
       f16 = Math_fround(HEAPF32[i60 >> 2]);
       f14 = Math_fround(f14 * f16);
       f18 = Math_fround(HEAPF32[i61 >> 2]);
       f20 = Math_fround(f20 * f18);
       f21 = Math_fround(Math_fround(f142 - f8) * f21);
       f16 = Math_fround(Math_fround(f141 - f17) * f16);
       f18 = Math_fround(Math_fround(f15 - f19) * f18);
       f19 = f9 <= f21 ? f9 : f21;
       f15 = f14 <= f16 ? f14 : f16;
       f17 = f20 <= f18 ? f20 : f18;
       f21 = f9 >= f21 ? f9 : f21;
       f16 = f14 >= f16 ? f14 : f16;
       f18 = f20 >= f18 ? f20 : f18;
       f20 = f19 >= f15 ? f19 : f15;
       f20 = f20 >= f17 ? f20 : f17;
       i37 = f15 > Math_fround(1.0) | f16 < Math_fround(0.0) | f20 > f16;
       i36 = f17 > Math_fround(1.0) | f18 < Math_fround(0.0) | f20 > f18;
       i38 = (f19 > Math_fround(1.0) | f21 < Math_fround(0.0) | f20 > f21) << 31 >> 31 >>> 31;
       if (!((i36 ? 4 : 0) | (i37 ? 2 : 0) | i38)) {
        i1 = HEAP32[i105 >> 2] | 0;
        if ((i1 | 0) < (HEAP32[i106 >> 2] | 0)) {
         HEAP32[(HEAP32[i131 >> 2] | 0) + (i1 << 2) >> 2] = i2;
         i1 = HEAP32[i105 >> 2] | 0;
        }
        HEAP32[i105 >> 2] = i1 + 1;
       }
      }
      if ((HEAP32[i105 >> 2] | 0) > (HEAP32[i106 >> 2] | 0)) break L19;
      i24 = HEAP32[i103 >> 2] | 0;
     } while ((i24 | 0) != 0);
    }
   }
  } while (0);
  i32 = i30 + i29 | 0;
  if ((i32 | 0) > 0) {
   i38 = HEAP32[i90 >> 2] | 0;
   i33 = (i38 | 0) == 0;
   i34 = i38 + 12 | 0;
   i35 = HEAP32[i91 >> 2] | 0;
   i36 = i35 + 112 | 0;
   i37 = i35 + 120 | 0;
   i38 = i38 + 16 | 0;
   i31 = 0;
   f6 = f40;
   f7 = f41;
   f8 = f42;
   f9 = f43;
   i11 = i39;
   i3 = i29;
   i2 = 0;
   i1 = i30;
   f14 = f44;
   f15 = f45;
   while (1) {
    if (!i1) {
     i25 = (i11 | 0) == 0 ? 0 : i22 + i11 | 0;
     i22 = 0;
     i11 = 0;
     i27 = 0;
     i26 = 1;
     i1 = (i25 | 0) == 0 ? 0 : i3;
    } else {
     i27 = i3;
     i26 = i2;
     i25 = i28;
    }
    i1 = i1 + -1 | 0;
    i28 = i25 + 16 | 0;
    i3 = HEAP32[i25 >> 2] | 0;
    L61 : do if (!(i3 & 67108864)) {
     if (!(i3 & 134217728)) {
      if (i3 & 268435456 | 0) break;
      if (!(1 << (i3 >>> 29) & i127)) break;
      i3 = i3 >>> 30;
      i4 = i25 + 4 | 0;
      i39 = HEAP32[i4 >> 2] & 65535;
      HEAP32[i135 + (i3 << 2) >> 2] = i39;
      HEAP32[i134 + (i3 << 2) >> 2] = i39;
      i3 = 1 << i3 & 3;
      i39 = i25 + 8 | 0;
      HEAP32[i134 + (i3 << 2) >> 2] = (HEAP32[i39 >> 2] | 0) >>> 16;
      HEAP32[i135 + (i3 << 2) >> 2] = HEAP32[i39 >> 2] & 65535;
      i3 = 1 << i3 & 3;
      i39 = i25 + 12 | 0;
      HEAP32[i134 + (i3 << 2) >> 2] = (HEAP32[i39 >> 2] | 0) >>> 16;
      HEAP32[i135 + (i3 << 2) >> 2] = HEAP32[i39 >> 2] & 65535;
      i3 = HEAP32[i25 >> 2] | 0;
     } else {
      i2 = HEAP32[i25 + 8 >> 2] | 0;
      i24 = i2 & 4095;
      L68 : do if (i24 | 0) {
       i12 = i2 >>> 12;
       i13 = i35 + (HEAP32[i37 >> 2] | 0) | 0;
       i23 = HEAP32[(HEAP32[HEAP32[i137 >> 2] >> 2] | 0) + 12 >> 2] | 0;
       i2 = (i23 | 0) == 0;
       i4 = HEAP32[i92 >> 2] | 0;
       if (i33) {
        if (i2) break; else i2 = 0;
        while (1) {
         i4 = HEAP32[i13 + (i2 + i12 << 2) >> 2] | 0;
         if ((i4 | 0) >= 0) if (!(HEAP32[i23 + (i4 >> 5 << 2) >> 2] & 1 << (i4 & 31))) break L61;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) >= (i24 | 0)) break L68;
        }
       }
       if (!i2) {
        i4 = i4 + (HEAP32[i38 >> 2] | 0) | 0;
        i2 = 0;
        do {
         i10 = HEAP32[i4 + (HEAP32[i13 + (i2 + i12 << 2) >> 2] << 2) >> 2] | 0;
         if ((i10 | 0) >= 0) if (!(HEAP32[i23 + (i10 >> 5 << 2) >> 2] & 1 << (i10 & 31))) break L61;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) < (i24 | 0));
       }
      } while (0);
      f44 = Math_fround(HEAPF32[i80 >> 2]);
      i39 = (HEAP32[i25 + 12 >> 2] | 0) >>> 12;
      i30 = i35 + (HEAP32[i36 >> 2] | 0) | 0;
      i4 = i30 + (i39 * 12 | 0) | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i4 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i4 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i4 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i4 + 3 >> 0];
      f7 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
      i29 = i30 + (i39 * 12 | 0) + 4 | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i29 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i29 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i29 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i29 + 3 >> 0];
      f15 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
      i39 = i30 + (i39 * 12 | 0) + 8 | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i39 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i39 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i39 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i39 + 3 >> 0];
      f45 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
      i39 = i4 + 12 | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i39 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i39 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i39 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i39 + 3 >> 0];
      f42 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
      i39 = i4 + 16 | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i39 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i39 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i39 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i39 + 3 >> 0];
      f141 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
      i4 = i4 + 20 | 0;
      HEAP8[tempDoublePtr >> 0] = HEAP8[i4 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i4 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i4 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i4 + 3 >> 0];
      f7 = Math_fround(f7 - f44);
      f15 = Math_fround(f15 - f44);
      f45 = Math_fround(f45 - f44);
      f42 = Math_fround(f44 + f42);
      f141 = Math_fround(f44 + f141);
      f44 = Math_fround(f44 + Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f43 = Math_fround(HEAPF32[i110 >> 2]);
      f7 = Math_fround(f7 - f43);
      f142 = Math_fround(HEAPF32[i111 >> 2]);
      f15 = Math_fround(f15 - f142);
      f8 = Math_fround(HEAPF32[i112 >> 2]);
      f45 = Math_fround(f45 - f8);
      f6 = Math_fround(HEAPF32[i113 >> 2]);
      f7 = Math_fround(f7 * f6);
      f14 = Math_fround(HEAPF32[i114 >> 2]);
      f15 = Math_fround(f15 * f14);
      f9 = Math_fround(HEAPF32[i115 >> 2]);
      i4 = i25 + 4 | 0;
      f6 = Math_fround(Math_fround(f42 - f43) * f6);
      f8 = Math_fround(Math_fround(f44 - f8) * f9);
      f9 = Math_fround(f45 * f9);
      f14 = Math_fround(Math_fround(f141 - f142) * f14);
     }
     i2 = i3 & 67108863;
     i10 = (HEAP32[i4 >> 2] | 0) >>> 16;
     if (!(i26 << 24 >> 24 != 0 | i33)) i2 = HEAP32[(HEAP32[i92 >> 2] | 0) + (HEAP32[i34 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i4 = (HEAP32[(HEAP32[i71 >> 2] | 0) + (Math_imul(HEAP32[i72 >> 2] | 0, i2) | 0) >> 2] | 0) + i10 | 0;
     if (!(1 << (i4 & 31) & HEAP32[(HEAP32[i96 >> 2] | 0) + (i4 >> 5 << 2) >> 2])) {
      if (!(i3 & 134217728)) {
       f45 = Math_fround(HEAP32[i134 >> 2] | 0);
       f142 = Math_fround(HEAP32[i73 >> 2] | 0);
       f141 = Math_fround(HEAP32[i74 >> 2] | 0);
       f6 = Math_fround(HEAP32[i135 >> 2] | 0);
       f14 = Math_fround(HEAP32[i75 >> 2] | 0);
       f8 = Math_fround(HEAP32[i76 >> 2] | 0);
       f7 = Math_fround(HEAPF32[i77 >> 2]);
       f7 = Math_fround(f7 * Math_fround(HEAPF32[i113 >> 2]));
       f15 = Math_fround(HEAPF32[i78 >> 2]);
       f15 = Math_fround(f15 * Math_fround(HEAPF32[i114 >> 2]));
       f9 = Math_fround(HEAPF32[i79 >> 2]);
       f9 = Math_fround(f9 * Math_fround(HEAPF32[i115 >> 2]));
       f6 = Math_fround(f6 + f7);
       f7 = Math_fround(f45 - f7);
       f8 = Math_fround(f8 + f9);
       f9 = Math_fround(f141 - f9);
       f14 = Math_fround(f14 + f15);
       f15 = Math_fround(f142 - f15);
      }
      f43 = Math_fround(HEAPF32[i117 >> 2]);
      f21 = Math_fround(f7 - f43);
      f41 = Math_fround(HEAPF32[i118 >> 2]);
      f40 = Math_fround(f15 - f41);
      f45 = Math_fround(HEAPF32[i58 >> 2]);
      f141 = Math_fround(f9 - f45);
      f142 = Math_fround(HEAPF32[i59 >> 2]);
      f21 = Math_fround(f21 * f142);
      f42 = Math_fround(HEAPF32[i60 >> 2]);
      f40 = Math_fround(f40 * f42);
      f44 = Math_fround(HEAPF32[i61 >> 2]);
      f141 = Math_fround(f141 * f44);
      f142 = Math_fround(Math_fround(f6 - f43) * f142);
      f42 = Math_fround(Math_fround(f14 - f41) * f42);
      f44 = Math_fround(Math_fround(f8 - f45) * f44);
      f45 = f21 <= f142 ? f21 : f142;
      f41 = f40 <= f42 ? f40 : f42;
      f43 = f141 <= f44 ? f141 : f44;
      f142 = f21 >= f142 ? f21 : f142;
      f42 = f40 >= f42 ? f40 : f42;
      f44 = f141 >= f44 ? f141 : f44;
      f141 = f45 >= f41 ? f45 : f41;
      f141 = f141 >= f43 ? f141 : f43;
      i30 = f41 > Math_fround(1.0) | f42 < Math_fround(0.0) | f141 > f42;
      i29 = f43 > Math_fround(1.0) | f44 < Math_fround(0.0) | f141 > f44;
      i39 = (f45 > Math_fround(1.0) | f142 < Math_fround(0.0) | f141 > f142) << 31 >> 31 >>> 31;
      if (!((i29 ? 4 : 0) | (i30 ? 2 : 0) | i39)) {
       i39 = HEAP32[i88 >> 2] | 0;
       HEAP32[i137 + 4 + (i39 * 12 | 0) >> 2] = i2;
       HEAP32[i137 + 4 + (i39 * 12 | 0) + 4 >> 2] = i10;
       HEAP32[i137 + 4 + (i39 * 12 | 0) + 8 >> 2] = i4;
       i2 = HEAP32[i88 >> 2] | 0;
       i39 = i2 + 1 & 255;
       HEAP32[i88 >> 2] = i39;
       if ((i39 | 0) == (HEAP32[i87 >> 2] | 0)) HEAP32[i87 >> 2] = i2 + 2 & 255;
      }
     }
    } while (0);
    i31 = i31 + 1 | 0;
    if ((i31 | 0) == (i32 | 0)) {
     f19 = f6;
     f18 = f7;
     f17 = f8;
     f16 = f9;
     break;
    } else {
     i3 = i27;
     i2 = i26;
    }
   }
  } else {
   f19 = f40;
   f18 = f41;
   f17 = f42;
   f16 = f43;
   i11 = i39;
   f14 = f44;
   f15 = f45;
  }
  i2 = i5 + (HEAP32[i5 + 56 >> 2] | 0) | 0;
  i36 = HEAP32[i2 + (i48 * 36 | 0) + 24 >> 2] | 0;
  i1 = HEAP32[i2 + (i48 * 36 | 0) + 28 >> 2] | 0;
  i2 = HEAP32[i2 + (i48 * 36 | 0) + 32 >> 2] | 0;
  i35 = ~~Math_fround(HEAPF32[i62 >> 2]);
  i37 = ~~Math_fround(HEAPF32[i63 >> 2]);
  i38 = ~~Math_fround(HEAPF32[i64 >> 2]);
  i39 = ~~Math_fround(HEAPF32[i65 >> 2]);
  f45 = (HEAP32[tempDoublePtr >> 2] = i36 >>> 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f141 = (HEAP32[tempDoublePtr >> 2] = i36 & 65535, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f142 = (HEAP32[tempDoublePtr >> 2] = i1 >>> 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f9 < Math_fround(0.0) | !(f45 > f6) & !(f141 > f7) & !(f142 > f8) ^ 1)) {
   f141 = (HEAP32[tempDoublePtr >> 2] = i1 & 65535, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f142 = (HEAP32[tempDoublePtr >> 2] = i2 >>> 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f6 > f141) & !(f7 > f142) & !(f8 > (HEAP32[tempDoublePtr >> 2] = i2 & 65535, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & !(f9 > Math_fround(0.0))) {
    i1 = HEAP32[i130 >> 2] | 0;
    i2 = HEAP32[i95 >> 2] | 0;
    if ((i1 | 0) == -1 | (i2 | 0) == -1) {
     i2 = HEAP32[i137 >> 2] | 0;
     i1 = __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i2, i129) | 0;
     if ((i1 | 0) == -1) {
      i1 = -1;
      i2 = -1;
     } else {
      HEAP32[i132 >> 2] = -1;
      HEAP32[i66 >> 2] = 0;
      HEAP32[i67 >> 2] = 0;
      HEAP32[i68 >> 2] = 0;
      HEAP32[i69 >> 2] = 0;
      HEAP32[i70 >> 2] = 0;
      __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i2, i132, i1);
      i3 = HEAP32[i69 >> 2] | 0;
      if (!i3) {
       i1 = -1;
       i2 = -1;
      } else {
       i2 = __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i2, i3, i129) | 0;
       if ((i2 | 0) == -1) {
        i1 = -1;
        i2 = -1;
       } else {
        i2 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i3, i2, i129) | 0;
        i2 = (i2 | 0) < (HEAP32[i3 + 52 >> 2] & 65535 | 0) ? i2 : -1;
       }
      }
     }
     i39 = i130;
     HEAP32[i39 >> 2] = i1;
     HEAP32[i39 + 4 >> 2] = i2;
    }
    if ((i47 | 0) == (i1 | 0) & (i48 | 0) == (i2 | 0)) {
     i3 = 1;
     break;
    }
   }
  }
  i1 = HEAP32[i88 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i87 >> 2] | 0)) {
   i3 = 0;
   break;
  } else {
   i2 = i46;
   f40 = f19;
   f41 = f18;
   f42 = f17;
   f43 = f16;
   f44 = f14;
   f45 = f15;
  }
 }
 i1 = HEAP32[i128 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i136 >> 2] | 0)) {
  HEAP32[i138 >> 2] = i139;
  STACKTOP = i140;
  return i3 | 0;
 }
 i2 = HEAP32[i137 + 4148 >> 2] | 0;
 do {
  i134 = HEAP32[i137 + 3084 + (i1 << 2) >> 2] | 0;
  i135 = i2 + (i134 >> 5 << 2) | 0;
  HEAP32[i135 >> 2] = HEAP32[i135 >> 2] & ~(1 << (i134 & 31));
  i1 = i1 + 1 & 255;
 } while ((i1 | 0) != (HEAP32[i136 >> 2] | 0));
 HEAP32[i138 >> 2] = i139;
 STACKTOP = i140;
 return i3 | 0;
}

function _regcomp(i26, i1, i24) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i30 + 56 | 0;
 i22 = i30 + 52 | 0;
 i16 = i30 + 48 | 0;
 i18 = i30 + 44 | 0;
 i5 = i30;
 i29 = _malloc(20) | 0;
 L1 : do if (!i29) i1 = 12; else {
  i28 = _malloc(2048) | 0;
  i27 = i29 + 16 | 0;
  HEAP32[i27 >> 2] = i28;
  if (!i28) {
   _free(i29);
   i1 = 12;
   break;
  }
  HEAP32[i29 >> 2] = 512;
  HEAP32[i29 + 4 >> 2] = 10240;
  HEAP32[i29 + 8 >> 2] = 128;
  i21 = i29 + 12 | 0;
  HEAP32[i21 >> 2] = 0;
  i28 = ___tre_mem_new_impl(0, 0) | 0;
  if (!i28) {
   _free(HEAP32[i27 >> 2] | 0);
   _free(i29);
   i1 = 12;
   break;
  }
  i2 = i5 + 4 + 4 | 0;
  i3 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i5 >> 2] = i28;
  HEAP32[i5 + 4 >> 2] = i29;
  HEAP32[i5 + 12 >> 2] = i1;
  HEAP32[i5 + 36 >> 2] = i24;
  i2 = i5 + 28 | 0;
  HEAP32[i2 >> 2] = -1;
  i1 = _tre_parse(i5) | 0;
  L9 : do if (!i1) {
   i4 = i5 + 20 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i26 >> 2] = i3 + -1;
   i17 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) > -1) if (HEAP32[i5 + 32 >> 2] | 0) {
    i4 = 0;
    i3 = 0;
    i2 = 0;
    i1 = 2;
    break;
   }
   if ((i1 | 0) < (i3 | 0)) {
    i25 = _calloc(1, 68) | 0;
    if (!i25) {
     i4 = i25;
     i3 = 0;
     i2 = 0;
     i1 = 12;
    } else {
     i23 = i1 >>> 31 ^ 1;
     HEAP32[i25 + 60 >> 2] = i23;
     HEAP32[i25 + 64 >> 2] = HEAP32[i5 + 32 >> 2];
     HEAP32[i25 + 28 >> 2] = i3;
     if ((i24 & 8 | 0) == 0 | (i23 | 0) != 0) {
      i1 = _tre_add_tags(0, i29, i17, i25) | 0;
      if (i1 | 0) {
       i4 = i25;
       i3 = 0;
       i2 = 0;
       break;
      }
      i3 = HEAP32[i25 + 40 >> 2] | 0;
      if ((i3 | 0) > 0) {
       i1 = (i3 << 2) + 4 | 0;
       i2 = _malloc(i1) | 0;
       if (!i2) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        i1 = 12;
        break;
       }
       HEAP32[i25 + 32 >> 2] = i2;
       _memset(i2 | 0, -1, i1 | 0) | 0;
      } else i2 = 0;
      i23 = _calloc(i3 << 1 | 1, 4) | 0;
      HEAP32[i25 + 36 >> 2] = i23;
      if (!i23) {
       i4 = i25;
       i3 = 0;
       i2 = 0;
       i1 = 12;
       break;
      }
      i1 = _calloc(HEAP32[i4 >> 2] | 0, 12) | 0;
      if (!i1) {
       i4 = i25;
       i3 = 0;
       i2 = 0;
       i1 = 12;
       break;
      }
      HEAP32[i25 + 16 >> 2] = i1;
      i1 = _tre_add_tags(i28, i29, i17, i25) | 0;
      if (i1) {
       i4 = i25;
       i3 = 0;
       i2 = 0;
       break;
      }
     } else i2 = 0;
     i23 = i5 + 24 | 0;
     i15 = HEAP32[i21 >> 2] | 0;
     HEAP32[i16 >> 2] = 0;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i22 >> 2] = i17;
     HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
     i1 = _tre_stack_push(i29, i20) | 0;
     L26 : do if (!i1) {
      HEAP32[i22 >> 2] = 0;
      HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
      i1 = _tre_stack_push(i29, i20) | 0;
      if (!i1) {
       i1 = HEAP32[i21 >> 2] | 0;
       do if ((i1 | 0) > (i15 | 0)) {
        i3 = 0;
        i14 = 0;
        i4 = 0;
        L30 : while (1) {
         i12 = i1 + -1 | 0;
         HEAP32[i21 >> 2] = i12;
         i5 = HEAP32[i27 >> 2] | 0;
         i12 = HEAP32[i5 + (i12 << 2) >> 2] | 0;
         i13 = i1 + -2 | 0;
         HEAP32[i21 >> 2] = i13;
         i13 = HEAP32[i5 + (i13 << 2) >> 2] | 0;
         L32 : do switch (i12 | 0) {
         case 0:
          {
           switch (HEAP32[i13 >> 2] | 0) {
           case 0:
            {
             i1 = HEAP32[i13 + 4 >> 2] | 0;
             i13 = HEAP32[i1 >> 2] | 0;
             if (!((i13 | 0) > -1 | (i13 | 0) == -4)) {
              i5 = i14;
              break L32;
             }
             i13 = i1 + 8 | 0;
             i1 = (HEAP32[i13 >> 2] | 0) + i4 | 0;
             HEAP32[i13 >> 2] = i1;
             if ((i1 | 0) <= (HEAP32[i18 >> 2] | 0)) {
              i5 = i14;
              break L32;
             }
             HEAP32[i18 >> 2] = i1;
             i5 = i14;
             break L32;
            }
           case 3:
            {
             i5 = HEAP32[i13 + 4 >> 2] | 0;
             HEAP32[i22 >> 2] = HEAP32[i5 + 4 >> 2];
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 0;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 0;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             break;
            }
           case 1:
            {
             i5 = HEAP32[i13 + 4 >> 2] | 0;
             HEAP32[i22 >> 2] = HEAP32[i5 + 4 >> 2];
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 0;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 0;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             break;
            }
           case 2:
            {
             i5 = HEAP32[i13 + 4 >> 2] | 0;
             HEAP32[i22 >> 2] = i4;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = i13;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 1;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             HEAP32[i22 >> 2] = 0;
             HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
             i1 = _tre_stack_push(i29, i20) | 0;
             if (i1 | 0) {
              i19 = 81;
              break L30;
             }
             if ((HEAP32[i5 + 4 >> 2] | 0) > 1) i19 = 43; else if ((HEAP32[i5 + 8 >> 2] | 0) > 1) i19 = 43; else i1 = i4;
             if ((i19 | 0) == 43) {
              i19 = 0;
              HEAP32[i16 >> 2] = 0;
              i1 = 0;
             }
             i5 = i14 + 1 | 0;
             i4 = i1;
             break L32;
            }
           default:
            {
             i5 = i14;
             break L32;
            }
           }
           if (!i1) i5 = i14; else {
            i19 = 81;
            break L30;
           }
           break;
          }
         case 1:
          {
           i11 = i13 + 4 | 0;
           i10 = HEAP32[i11 >> 2] | 0;
           i12 = i1 + -3 | 0;
           HEAP32[i21 >> 2] = i12;
           i12 = HEAP32[i5 + (i12 << 2) >> 2] | 0;
           HEAP32[i16 >> 2] = i12;
           i8 = i10 + 4 | 0;
           i5 = HEAP32[i8 >> 2] | 0;
           i1 = (i5 | 0) > 1;
           if (i1) {
            HEAP32[i20 >> 2] = 0;
            i19 = 50;
           } else {
            i6 = i10 + 8 | 0;
            i7 = HEAP32[i6 >> 2] | 0;
            if ((i7 | 0) > 1) {
             HEAP32[i20 >> 2] = 0;
             if ((i5 | 0) > 0) i19 = 50; else {
              i4 = i12;
              i9 = 0;
              i8 = i6;
              i1 = i7;
              i19 = 58;
             }
            } else i4 = i12;
           }
           do if ((i19 | 0) == 50) {
            i19 = 0;
            i1 = _tre_copy_ast(i28, i29, HEAP32[i10 >> 2] | 0, i1 ? 1 : 2, i16, i2, i22, i18) | 0;
            if (!i1) {
             i5 = 0;
             i6 = 1;
             i4 = i12;
            } else {
             i19 = 54;
             break L30;
            }
            while (1) {
             i1 = HEAP32[i22 >> 2] | 0;
             if (!i5) i5 = i1; else i5 = _tre_ast_new_catenation(i28, i5, i1) | 0;
             if (!i5) {
              i1 = 12;
              i19 = 54;
              break L30;
             }
             i7 = HEAP32[i8 >> 2] | 0;
             if ((i6 | 0) >= (i7 | 0)) break;
             i4 = HEAP32[i16 >> 2] | 0;
             i6 = i6 + 1 | 0;
             i1 = _tre_copy_ast(i28, i29, HEAP32[i10 >> 2] | 0, (i6 | 0) < (i7 | 0) ? 1 : 2, i16, i2, i22, i18) | 0;
             if (i1 | 0) {
              i19 = 54;
              break L30;
             }
            }
            i6 = i10 + 8 | 0;
            i1 = HEAP32[i6 >> 2] | 0;
            if ((i1 | 0) != -1) {
             i9 = i5;
             i5 = i7;
             i8 = i6;
             i19 = 58;
             break;
            }
            i4 = HEAP32[i16 >> 2] | 0;
            i1 = _tre_copy_ast(i28, i29, HEAP32[i10 >> 2] | 0, 0, i16, 0, i20, i18) | 0;
            if (i1 | 0) break L30;
            i1 = _tre_ast_new_iter(i28, HEAP32[i20 >> 2] | 0, 0, -1, 0) | 0;
            HEAP32[i20 >> 2] = i1;
            if (!i1) {
             i1 = 12;
             break L30;
            }
            HEAP32[i16 >> 2] = i4;
            i19 = 74;
           } while (0);
           do if ((i19 | 0) == 58) {
            if ((i5 | 0) < (i1 | 0)) {
             i6 = i5;
             i5 = 0;
             while (1) {
              i4 = HEAP32[i16 >> 2] | 0;
              i1 = _tre_copy_ast(i28, i29, HEAP32[i10 >> 2] | 0, 0, i16, 0, i22, i18) | 0;
              if (i1 | 0) {
               i19 = 70;
               break L30;
              }
              if (!i5) {
               i1 = HEAP32[i22 >> 2] | 0;
               HEAP32[i20 >> 2] = i1;
              } else {
               i1 = _tre_ast_new_catenation(i28, HEAP32[i22 >> 2] | 0, i5) | 0;
               HEAP32[i20 >> 2] = i1;
              }
              if (!i1) {
               i1 = 12;
               i19 = 70;
               break L30;
              }
              i5 = _tre_ast_new_node(i28, 0, 20) | 0;
              if (!i5) {
               i1 = 12;
               i19 = 70;
               break L30;
              }
              i19 = HEAP32[i5 + 4 >> 2] | 0;
              HEAP32[i19 >> 2] = -1;
              HEAP32[i19 + 4 >> 2] = -1;
              HEAP32[i19 + 8 >> 2] = -1;
              i1 = _tre_ast_new_union(i28, i5, i1) | 0;
              HEAP32[i20 >> 2] = i1;
              if (!i1) {
               i1 = 12;
               i19 = 70;
               break L30;
              }
              i6 = i6 + 1 | 0;
              if ((i6 | 0) >= (HEAP32[i8 >> 2] | 0)) break; else i5 = i1;
             }
            } else i1 = 0;
            HEAP32[i16 >> 2] = i4;
            if (!i9) {
             i19 = 75;
             break;
            }
            if (!i1) {
             i1 = i9;
             i19 = 76;
            } else {
             i5 = i9;
             i19 = 74;
            }
           } while (0);
           if ((i19 | 0) == 74) {
            i1 = _tre_ast_new_catenation(i28, i5, i1) | 0;
            i19 = 75;
           }
           if ((i19 | 0) == 75) {
            i19 = 0;
            if (!i1) {
             i1 = 12;
             break L30;
            } else i19 = 76;
           }
           if ((i19 | 0) == 76) {
            i19 = 0;
            HEAP32[i11 >> 2] = HEAP32[i1 + 4 >> 2];
            HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
           }
           i5 = i14 + -1 | 0;
           i1 = i4 - i12 + i3 | 0;
           if (!i5) {
            HEAP32[i16 >> 2] = i1;
            i3 = i1;
            i5 = 0;
            i4 = i1;
           } else i3 = i1;
           break;
          }
         default:
          i5 = i14;
         } while (0);
         i1 = HEAP32[i21 >> 2] | 0;
         if ((i1 | 0) <= (i15 | 0)) {
          i1 = 0;
          i19 = 81;
          break;
         } else i14 = i5;
        }
        if ((i19 | 0) != 54) if ((i19 | 0) != 70) if ((i19 | 0) == 81) {
         i2 = HEAP32[i18 >> 2] | 0;
         break;
        }
        break L26;
       } else {
        i1 = 0;
        i3 = 0;
        i2 = 0;
       } while (0);
       i18 = (HEAP32[i23 >> 2] | 0) + i3 | 0;
       i2 = (i2 | 0) > (i18 | 0) ? i2 : i18;
       HEAP32[i23 >> 2] = i2;
       if (i1 | 0) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        break L9;
       }
       HEAP32[i23 >> 2] = i2 + 1;
       i1 = _tre_ast_new_node(i28, 0, 20) | 0;
       if (!i1) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        i1 = 12;
        break L9;
       }
       i13 = HEAP32[i1 + 4 >> 2] | 0;
       HEAP32[i13 >> 2] = 0;
       HEAP32[i13 + 4 >> 2] = 0;
       HEAP32[i13 + 8 >> 2] = i2;
       i13 = _tre_ast_new_catenation(i28, i17, i1) | 0;
       if (!i13) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        i1 = 12;
        break L9;
       }
       i7 = HEAP32[i21 >> 2] | 0;
       HEAP32[i22 >> 2] = i13;
       HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
       i1 = _tre_stack_push(i29, i20) | 0;
       if (i1 | 0) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        break L9;
       }
       HEAP32[i22 >> 2] = 0;
       HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
       i1 = _tre_stack_push(i29, i20) | 0;
       if (i1 | 0) {
        i4 = i25;
        i3 = 0;
        i2 = 0;
        break L9;
       }
       i1 = HEAP32[i21 >> 2] | 0;
       L112 : do if ((i1 | 0) > (i7 | 0)) {
        L114 : while (1) {
         i18 = i1 + -1 | 0;
         HEAP32[i21 >> 2] = i18;
         i17 = HEAP32[i27 >> 2] | 0;
         i18 = HEAP32[i17 + (i18 << 2) >> 2] | 0;
         i6 = i1 + -2 | 0;
         HEAP32[i21 >> 2] = i6;
         i6 = HEAP32[i17 + (i6 << 2) >> 2] | 0;
         L116 : do switch (i18 | 0) {
         case 0:
          switch (HEAP32[i6 >> 2] | 0) {
          case 0:
           {
            i4 = HEAP32[i6 + 4 >> 2] | 0;
            i3 = HEAP32[i4 >> 2] | 0;
            if ((i3 | 0) == -4) {
             HEAP32[i6 + 8 >> 2] = 0;
             i1 = i4 + 8 | 0;
             i18 = _tre_set_one(i28, HEAP32[i1 >> 2] | 0, 0, 1114111, 0, 0, -1) | 0;
             HEAP32[i6 + 24 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             }
             i18 = _tre_set_one(i28, HEAP32[i1 >> 2] | 0, 0, 1114111, 0, 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
             HEAP32[i6 + 28 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             } else break L116;
            }
            i1 = i6 + 8 | 0;
            if ((i3 | 0) < 0) {
             HEAP32[i1 >> 2] = 1;
             i18 = _tre_set_empty(i28) | 0;
             HEAP32[i6 + 24 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             }
             i18 = _tre_set_empty(i28) | 0;
             HEAP32[i6 + 28 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             } else break L116;
            } else {
             HEAP32[i1 >> 2] = 0;
             i1 = i4 + 8 | 0;
             i2 = i4 + 4 | 0;
             i18 = _tre_set_one(i28, HEAP32[i1 >> 2] | 0, i3, HEAP32[i2 >> 2] | 0, 0, 0, -1) | 0;
             HEAP32[i6 + 24 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             }
             i18 = _tre_set_one(i28, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, -1) | 0;
             HEAP32[i6 + 28 >> 2] = i18;
             if (!i18) {
              i4 = i25;
              i3 = 0;
              i2 = 0;
              i1 = 12;
              break L9;
             } else break L116;
            }
           }
          case 3:
           {
            HEAP32[i22 >> 2] = i6;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 1;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            i2 = i6 + 4 | 0;
            HEAP32[i22 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2];
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 0;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = HEAP32[HEAP32[i2 >> 2] >> 2];
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 0;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (!i1) break L116; else {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
           }
          case 1:
           {
            HEAP32[i22 >> 2] = i6;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 2;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            i2 = i6 + 4 | 0;
            HEAP32[i22 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2];
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 0;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = HEAP32[HEAP32[i2 >> 2] >> 2];
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 0;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (!i1) break L116; else {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
           }
          case 2:
           {
            HEAP32[i22 >> 2] = i6;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 3;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = HEAP32[HEAP32[i6 + 4 >> 2] >> 2];
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (i1 | 0) {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
            HEAP32[i22 >> 2] = 0;
            HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
            i1 = _tre_stack_push(i29, i20) | 0;
            if (!i1) break L116; else {
             i4 = i25;
             i3 = 0;
             i2 = 0;
             break L9;
            }
           }
          default:
           break L116;
          }
         case 1:
          {
           i1 = HEAP32[i6 + 4 >> 2] | 0;
           i2 = HEAP32[i1 >> 2] | 0;
           i3 = i1 + 4 | 0;
           i4 = HEAP32[i3 >> 2] | 0;
           if (!(HEAP32[i2 + 8 >> 2] | 0)) i5 = (HEAP32[i4 + 8 >> 2] | 0) != 0; else i5 = 1;
           HEAP32[i6 + 8 >> 2] = i5 & 1;
           i18 = _tre_set_union(i28, HEAP32[i2 + 24 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0, 0, 0) | 0;
           HEAP32[i6 + 24 >> 2] = i18;
           if (!i18) {
            i4 = i25;
            i3 = 0;
            i2 = 0;
            i1 = 12;
            break L9;
           }
           i18 = _tre_set_union(i28, HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, 0, 0) | 0;
           HEAP32[i6 + 28 >> 2] = i18;
           if (!i18) {
            i4 = i25;
            i3 = 0;
            i2 = 0;
            i1 = 12;
            break L9;
           }
           break;
          }
         case 3:
          {
           i18 = HEAP32[i6 + 4 >> 2] | 0;
           i1 = HEAP32[i18 >> 2] | 0;
           do if (!(HEAP32[i18 + 4 >> 2] | 0)) i19 = 121; else {
            if (HEAP32[i1 + 8 >> 2] | 0) {
             i19 = 121;
             break;
            }
            HEAP32[i6 + 8 >> 2] = 0;
           } while (0);
           if ((i19 | 0) == 121) {
            i19 = 0;
            HEAP32[i6 + 8 >> 2] = 1;
           }
           HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
           HEAP32[i6 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
           break;
          }
         case 2:
          {
           i4 = HEAP32[i6 + 4 >> 2] | 0;
           i1 = HEAP32[i4 >> 2] | 0;
           i2 = i1 + 8 | 0;
           if (!(HEAP32[i2 >> 2] | 0)) i3 = 0; else i3 = (HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 8 >> 2] | 0) != 0;
           HEAP32[i6 + 8 >> 2] = i3 & 1;
           if (!(HEAP32[i2 >> 2] | 0)) {
            HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
            i3 = i4 + 4 | 0;
           } else {
            i1 = _tre_match_empty(i29, i1, 0, 0, i20) | 0;
            if (i1 | 0) break L114;
            i2 = _malloc((HEAP32[i20 >> 2] << 2) + 4 | 0) | 0;
            if (!i2) {
             i1 = 12;
             break L114;
            }
            HEAP32[i2 >> 2] = -1;
            HEAP32[i22 >> 2] = 0;
            i1 = _tre_match_empty(i29, HEAP32[i4 >> 2] | 0, i2, i22, 0) | 0;
            if (i1 | 0) {
             i19 = 131;
             break L114;
            }
            i1 = i4 + 4 | 0;
            i18 = i6 + 24 | 0;
            HEAP32[i18 >> 2] = _tre_set_union(i28, HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i2, HEAP32[i22 >> 2] | 0) | 0;
            _free(i2);
            if (!(HEAP32[i18 >> 2] | 0)) {
             i1 = 12;
             break L114;
            } else i3 = i1;
           }
           i1 = HEAP32[i3 >> 2] | 0;
           if (!(HEAP32[i1 + 8 >> 2] | 0)) HEAP32[i6 + 28 >> 2] = HEAP32[i1 + 28 >> 2]; else {
            i1 = _tre_match_empty(i29, i1, 0, 0, i20) | 0;
            if (i1 | 0) break L114;
            i2 = _malloc((HEAP32[i20 >> 2] << 2) + 4 | 0) | 0;
            if (!i2) {
             i1 = 12;
             break L114;
            }
            HEAP32[i2 >> 2] = -1;
            HEAP32[i22 >> 2] = 0;
            i1 = _tre_match_empty(i29, HEAP32[i3 >> 2] | 0, i2, i22, 0) | 0;
            if (i1 | 0) {
             i19 = 138;
             break L114;
            }
            i18 = i6 + 28 | 0;
            HEAP32[i18 >> 2] = _tre_set_union(i28, HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i2, HEAP32[i22 >> 2] | 0) | 0;
            _free(i2);
            if (!(HEAP32[i18 >> 2] | 0)) {
             i1 = 12;
             break L114;
            }
           }
           break;
          }
         default:
          {}
         } while (0);
         i1 = HEAP32[i21 >> 2] | 0;
         if ((i1 | 0) <= (i7 | 0)) break L112;
        }
        if ((i19 | 0) == 131) _free(i2); else if ((i19 | 0) == 138) _free(i2);
        i4 = i25;
        i3 = 0;
        i2 = 0;
        break L9;
       } while (0);
       i2 = HEAP32[i23 >> 2] | 0;
       i1 = i2 << 2;
       i11 = _malloc(i1) | 0;
       if (!i11) {
        i4 = i25;
        i3 = i11;
        i2 = 0;
        i1 = 12;
        break L9;
       }
       i12 = _malloc(i1) | 0;
       if (!i12) {
        i4 = i25;
        i3 = i11;
        i2 = i12;
        i1 = 12;
        break L9;
       }
       if ((i2 | 0) > 0) _memset(i11 | 0, 0, i2 << 2 | 0) | 0;
       _tre_ast_to_tnfa(i13, 0, i11, 0) | 0;
       i3 = HEAP32[i23 >> 2] | 0;
       if ((i3 | 0) > 0) {
        i1 = 0;
        i2 = 0;
        do {
         HEAP32[i12 + (i2 << 2) >> 2] = i1;
         i22 = i11 + (i2 << 2) | 0;
         i1 = i1 + 1 + (HEAP32[i22 >> 2] | 0) | 0;
         HEAP32[i22 >> 2] = 0;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) < (i3 | 0));
        i8 = i1;
       } else i8 = 0;
       i9 = _calloc(i8 + 1 | 0, 32) | 0;
       if (!i9) {
        i4 = i25;
        i3 = i11;
        i2 = i12;
        i1 = 12;
        break L9;
       }
       HEAP32[i25 >> 2] = i9;
       i10 = i25 + 4 | 0;
       HEAP32[i10 >> 2] = i8;
       i1 = _tre_ast_to_tnfa(i13, i9, i11, i12) | 0;
       if (i1 | 0) {
        i4 = i25;
        i3 = i11;
        i2 = i12;
        break L9;
       }
       HEAP32[i25 + 20 >> 2] = 0;
       i3 = i13 + 24 | 0;
       i1 = HEAP32[i3 >> 2] | 0;
       i2 = 0;
       while (1) {
        i2 = i2 + 1 | 0;
        if ((HEAP32[i1 >> 2] | 0) <= -1) break; else i1 = i1 + 32 | 0;
       }
       i7 = _calloc(i2, 32) | 0;
       if (!i7) {
        i4 = i25;
        i3 = i11;
        i2 = i12;
        i1 = 12;
        break L9;
       }
       HEAP32[i25 + 8 >> 2] = i7;
       i3 = HEAP32[i3 >> 2] | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if ((i2 | 0) > -1) {
        i1 = 0;
        do {
         HEAP32[i7 + (i1 << 5) + 8 >> 2] = i9 + (HEAP32[i12 + (i2 << 2) >> 2] << 5);
         HEAP32[i7 + (i1 << 5) + 12 >> 2] = i2;
         i5 = i7 + (i1 << 5) + 16 | 0;
         HEAP32[i5 >> 2] = 0;
         i6 = i3 + 12 | 0;
         i4 = HEAP32[i6 >> 2] | 0;
         if (i4 | 0) {
          i2 = 0;
          do {
           i22 = i2;
           i2 = i2 + 1 | 0;
          } while ((HEAP32[i4 + (i22 << 2) >> 2] | 0) > -1);
          i2 = i2 << 2;
          i4 = _malloc(i2) | 0;
          HEAP32[i5 >> 2] = i4;
          if (!i4) {
           i4 = i25;
           i3 = i11;
           i2 = i12;
           i1 = 12;
           break L9;
          }
          _memcpy(i4 | 0, HEAP32[i6 >> 2] | 0, i2 | 0) | 0;
         }
         HEAP32[i7 + (i1 << 5) + 20 >> 2] = HEAP32[i3 + 16 >> 2];
         i1 = i1 + 1 | 0;
         i3 = i3 + 32 | 0;
         i2 = HEAP32[i3 >> 2] | 0;
        } while ((i2 | 0) > -1);
       } else i1 = 0;
       HEAP32[i7 + (i1 << 5) + 8 >> 2] = 0;
       HEAP32[i10 >> 2] = i8;
       HEAP32[i25 + 12 >> 2] = i9 + (HEAP32[i12 + (HEAP32[HEAP32[i13 + 28 >> 2] >> 2] << 2) >> 2] << 5);
       HEAP32[i25 + 52 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i25 + 56 >> 2] = i24;
       ___tre_mem_destroy(i28);
       _free(HEAP32[i27 >> 2] | 0);
       _free(i29);
       _free(i11);
       _free(i12);
       HEAP32[i26 + 4 >> 2] = i25;
       i1 = 0;
       break L1;
      }
     } while (0);
     i4 = i25;
     i3 = 0;
     i2 = 0;
    }
   } else {
    i4 = 0;
    i3 = 0;
    i2 = 0;
    i1 = 6;
   }
  } else {
   i4 = 0;
   i3 = 0;
   i2 = 0;
  } while (0);
  ___tre_mem_destroy(i28);
  _free(HEAP32[i27 >> 2] | 0);
  _free(i29);
  if (i3 | 0) _free(i3);
  if (i2 | 0) _free(i2);
  HEAP32[i26 + 4 >> 2] = i4;
  _regfree(i26);
 } while (0);
 STACKTOP = i30;
 return i1 | 0;
}

function __Z21CreateMonoScriptCacheRK8UnityStrP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i1, i63, i2, i30, i3) {
 i1 = i1 | 0;
 i63 = i63 | 0;
 i2 = i2 | 0;
 i30 = i30 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i61 = i62 + 104 | 0;
 i54 = i62 + 88 | 0;
 i53 = i62 + 72 | 0;
 i48 = i62 + 56 | 0;
 i49 = i62 + 236 | 0;
 i50 = i62 + 224 | 0;
 i51 = i62 + 40 | 0;
 i52 = i62 + 212 | 0;
 i41 = i62 + 32 | 0;
 i42 = i62 + 200 | 0;
 i43 = i62 + 188 | 0;
 i44 = i62 + 176 | 0;
 i56 = i62 + 160 | 0;
 i45 = i62 + 144 | 0;
 i9 = i62 + 24 | 0;
 i10 = i62 + 16 | 0;
 i28 = i62 + 8 | 0;
 i29 = i62;
 i46 = i62 + 124 | 0;
 i57 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63728 | 0, 16, gb + 455851 | 0, 617) | 0;
 HEAP32[i57 >> 2] = 1;
 i47 = i57 + 8 | 0;
 HEAP32[i47 >> 2] = 0;
 i5 = i57 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i57 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i57 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i61, gb + 63664 | 0);
 i58 = i61;
 i8 = HEAP32[i58 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i58 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i57 + 28 | 0;
 HEAP32[i2 >> 2] = -1;
 i8 = i57 + 4 | 0;
 HEAP32[i57 + 44 >> 2] = 0;
 i58 = i57 + 36 | 0;
 HEAP8[i58 >> 0] = 0;
 i59 = i57 + 37 | 0;
 HEAP8[i59 >> 0] = 0;
 i60 = i57 + 40 | 0;
 HEAP32[i8 >> 2] = i63;
 HEAP32[i57 + 32 >> 2] = i63;
 HEAP32[i60 >> 2] = i3;
 if (!i63) {
  HEAP32[i2 >> 2] = -7;
  STACKTOP = i62;
  return i57 | 0;
 }
 if (__Z27scripting_class_is_abstractP11Il2CppClass(i63) | 0) {
  HEAP32[i2 >> 2] = -4;
  STACKTOP = i62;
  return i57 | 0;
 }
 if (!(__Z26scripting_class_is_genericP11Il2CppClass(i63) | 0)) if (!(__Z27scripting_class_is_inflatedP11Il2CppClass(i63) | 0)) {
  __Z14GetMonoManagerv() | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i63, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 264 >> 2] | 0) | 0) i1 = 0; else if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i63, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 356 >> 2] | 0) | 0) i1 = 1; else {
   HEAP32[i2 >> 2] = -2;
   STACKTOP = i62;
   return i57 | 0;
  }
  HEAP32[i2 >> 2] = i1;
  i39 = HEAP32[i8 >> 2] | 0;
  i40 = HEAP32[(__ZN14MessageHandler3GetEv() | 0) + 48 >> 2] | 0;
  i2 = i40 + 27 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i6 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i47 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i47 >> 2] | 0, i2 << 3, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i38 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i38 | 0, HEAP32[i47 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i47 >> 2] = i38;
   break;
  } while (0);
  if (i2 >>> 0 > i4 >>> 0) {
   i3 = (HEAP32[i47 >> 2] | 0) + (i4 << 3) | 0;
   i2 = i2 - i4 | 0;
   if (i2 | 0) {
    i1 = 0;
    do {
     i36 = gb + 1164176 | 0;
     i37 = HEAP32[i36 + 4 >> 2] | 0;
     i38 = i3 + (i1 << 3) | 0;
     HEAP32[i38 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i38 + 4 >> 2] = i37;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0;
  HEAP32[i56 >> 2] = 0;
  i38 = i56 + 4 | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i56 + 8 >> 2] = 0;
  HEAP32[i56 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  L28 : do if (i1 | 0) do {
   __Z27scripting_class_get_methodsP11Il2CppClassRNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE(i1, i56);
   if ((i1 | 0) == (i2 | 0)) break L28;
   i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
  } while ((i1 | 0) != 0); while (0);
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i45 + 12 >> 2] = 0;
  i37 = i45 + 4 | 0;
  HEAP32[i45 >> 2] = i37;
  i1 = HEAP32[i38 >> 2] | 0;
  i2 = HEAP32[i56 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   i1 = i1 + -8 | 0;
   i34 = i1;
   i35 = HEAP32[i34 + 4 >> 2] | 0;
   i36 = i9;
   HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i36 + 4 >> 2] = i35;
   HEAP32[i61 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i61 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   if (__Z28scripting_method_is_instance21ScriptingMethodIl2Cpp(i61) | 0) {
    i34 = i1;
    i35 = HEAP32[i34 + 4 >> 2] | 0;
    i36 = i10;
    HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i36 + 4 >> 2] = i35;
    HEAP32[i61 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i61 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i48 >> 2] = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i61) | 0;
    i36 = __ZNSt3__23mapIPKc21ScriptingMethodIl2Cpp14CStringCompare13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier1ELi16EEEixERS7_(i45, i48) | 0;
    HEAP32[i36 >> 2] = HEAP32[i1 >> 2];
    HEAP8[i36 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
   }
  } while ((i1 | 0) != (i2 | 0));
  i8 = i29 + 4 | 0;
  i10 = i51 + 11 | 0;
  i11 = i51 + 4 | 0;
  i12 = i50 + 11 | 0;
  i13 = i50 + 4 | 0;
  i14 = i49 + 11 | 0;
  i15 = i49 + 4 | 0;
  i16 = i48 + 11 | 0;
  i17 = i48 + 4 | 0;
  i35 = (i30 | 0) == 0;
  i18 = i61 + 11 | 0;
  i36 = i30 + 4 | 0;
  i19 = i51 + 11 | 0;
  i20 = i51 + 4 | 0;
  i21 = i50 + 11 | 0;
  i22 = i50 + 4 | 0;
  i23 = i49 + 11 | 0;
  i24 = i49 + 4 | 0;
  i25 = i48 + 11 | 0;
  i26 = i48 + 4 | 0;
  i27 = i61 + 11 | 0;
  i9 = i28 + 4 | 0;
  i7 = i48 + 4 | 0;
  i6 = 0;
  do {
   i5 = gb + 65144 + (i6 << 2) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if (i4 | 0) {
    i2 = HEAP32[i37 >> 2] | 0;
    if (!i2) i55 = 37; else {
     i1 = i37;
     L46 : while (1) {
      i3 = i2;
      while (1) {
       if ((_strcmp(HEAP32[i3 + 16 >> 2] | 0, i4) | 0) >= 0) break;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i2) break L46; else i3 = i2;
      }
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i1 = i3;
       break;
      } else i1 = i3;
     }
     if ((i1 | 0) == (i37 | 0)) i55 = 37; else if ((_strcmp(i4, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0) i55 = 37;
    }
    if ((i55 | 0) == 37) {
     i55 = 0;
     i1 = i37;
    }
    i1 = (i1 | 0) == (i37 | 0) ? gb + 1164176 | 0 : i1 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = __Z14GetMonoManagerv() | 0;
    do if (!i2) i2 = 0; else {
     i3 = HEAP32[gb + 65256 + (i6 << 2) >> 2] | 0;
     if (i3 | 0) {
      HEAP32[i28 >> 2] = i2;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i61 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i61 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
      mftCall_viiii(i3 | 0, i48 | 0, i61 | 0, i39 | 0, i30 | 0);
      i2 = HEAP32[i48 >> 2] | 0;
      i1 = HEAPU8[i7 >> 0] | i1 & -256;
      break;
     }
     HEAP32[i29 >> 2] = i2;
     HEAP32[i8 >> 2] = i1;
     HEAP32[i61 >> 2] = HEAP32[i29 >> 2];
     HEAP32[i61 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     if (__Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i61) | 0) {
      i3 = HEAP32[gb + 1164176 >> 2] | 0;
      i1 = HEAPU8[gb + 1164176 + 4 >> 0] | i1 & -256;
      i32 = __Z24scripting_class_get_nameP11Il2CppClass(i39) | 0;
      HEAP32[i51 >> 2] = 0;
      HEAP32[i51 + 4 >> 2] = 0;
      HEAP32[i51 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i51, gb + 455924 | 0, 14);
      HEAP32[i50 >> 2] = 0;
      HEAP32[i50 + 4 >> 2] = 0;
      HEAP32[i50 + 8 >> 2] = 0;
      i31 = HEAP8[i19 >> 0] | 0;
      i34 = i31 << 24 >> 24 < 0;
      i31 = i34 ? HEAP32[i20 >> 2] | 0 : i31 & 255;
      i33 = _strlen(i32) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i50, i34 ? HEAP32[i51 >> 2] | 0 : i51, i31, i31 + i33 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i50, i32, i33) | 0;
      HEAP32[i49 >> 2] = 0;
      HEAP32[i49 + 4 >> 2] = 0;
      HEAP32[i49 + 8 >> 2] = 0;
      i33 = HEAP8[i21 >> 0] | 0;
      i32 = i33 << 24 >> 24 < 0;
      i33 = i32 ? HEAP32[i22 >> 2] | 0 : i33 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i49, i32 ? HEAP32[i50 >> 2] | 0 : i50, i33, i33 + 3 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i49, gb + 455939 | 0, 3) | 0;
      i33 = HEAP32[i5 >> 2] | 0;
      HEAP32[i48 >> 2] = 0;
      HEAP32[i48 + 4 >> 2] = 0;
      HEAP32[i48 + 8 >> 2] = 0;
      i32 = HEAP8[i23 >> 0] | 0;
      i31 = i32 << 24 >> 24 < 0;
      i32 = i31 ? HEAP32[i24 >> 2] | 0 : i32 & 255;
      i34 = _strlen(i33) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i48, i31 ? HEAP32[i49 >> 2] | 0 : i49, i32, i32 + i34 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i48, i33, i34) | 0;
      HEAP32[i61 >> 2] = 0;
      HEAP32[i61 + 4 >> 2] = 0;
      HEAP32[i61 + 8 >> 2] = 0;
      i34 = HEAP8[i25 >> 0] | 0;
      i33 = i34 << 24 >> 24 < 0;
      i34 = i33 ? HEAP32[i26 >> 2] | 0 : i34 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i61, i33 ? HEAP32[i48 >> 2] | 0 : i48, i34, i34 + 27 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i61, gb + 455943 | 0, 27) | 0;
      if (i35) i2 = 0; else i2 = HEAP32[i36 >> 2] | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 472, 2052, i2, HEAP32[i4 + 4 >> 2] | 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i51);
      i2 = i3;
      break;
     }
     i3 = i48;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i3 + 4 >> 2] = i1;
     HEAP32[i61 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i61 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
     i3 = __Z31scripting_method_get_returntype21ScriptingMethodIl2Cpp(i61) | 0;
     if (!i3) break;
     i34 = __Z25scripting_class_from_typePK10Il2CppType(i3) | 0;
     if ((i34 | 0) == (HEAP32[i4 + 52 >> 2] | 0)) {
      if ((i6 + -5 | 0) >>> 0 < 2) {
       i2 = HEAP32[gb + 1164176 >> 2] | 0;
       i1 = HEAPU8[gb + 1164176 + 4 >> 0] | i1 & -256;
       break;
      }
      if ((i6 + -11 | 0) >>> 0 <= 1) break;
      i3 = HEAP32[gb + 1164176 >> 2] | 0;
      i1 = HEAPU8[gb + 1164176 + 4 >> 0] | i1 & -256;
      i32 = __Z24scripting_class_get_nameP11Il2CppClass(i39) | 0;
      HEAP32[i51 >> 2] = 0;
      HEAP32[i51 + 4 >> 2] = 0;
      HEAP32[i51 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i51, gb + 455924 | 0, 14);
      HEAP32[i50 >> 2] = 0;
      HEAP32[i50 + 4 >> 2] = 0;
      HEAP32[i50 + 8 >> 2] = 0;
      i31 = HEAP8[i10 >> 0] | 0;
      i34 = i31 << 24 >> 24 < 0;
      i31 = i34 ? HEAP32[i11 >> 2] | 0 : i31 & 255;
      i33 = _strlen(i32) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i50, i34 ? HEAP32[i51 >> 2] | 0 : i51, i31, i31 + i33 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i50, i32, i33) | 0;
      HEAP32[i49 >> 2] = 0;
      HEAP32[i49 + 4 >> 2] = 0;
      HEAP32[i49 + 8 >> 2] = 0;
      i33 = HEAP8[i12 >> 0] | 0;
      i32 = i33 << 24 >> 24 < 0;
      i33 = i32 ? HEAP32[i13 >> 2] | 0 : i33 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i49, i32 ? HEAP32[i50 >> 2] | 0 : i50, i33, i33 + 3 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i49, gb + 455939 | 0, 3) | 0;
      i33 = HEAP32[i5 >> 2] | 0;
      HEAP32[i48 >> 2] = 0;
      HEAP32[i48 + 4 >> 2] = 0;
      HEAP32[i48 + 8 >> 2] = 0;
      i32 = HEAP8[i14 >> 0] | 0;
      i31 = i32 << 24 >> 24 < 0;
      i32 = i31 ? HEAP32[i15 >> 2] | 0 : i32 & 255;
      i34 = _strlen(i33) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i48, i31 ? HEAP32[i49 >> 2] | 0 : i49, i32, i32 + i34 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i48, i33, i34) | 0;
      HEAP32[i61 >> 2] = 0;
      HEAP32[i61 + 4 >> 2] = 0;
      HEAP32[i61 + 8 >> 2] = 0;
      i34 = HEAP8[i16 >> 0] | 0;
      i33 = i34 << 24 >> 24 < 0;
      i34 = i33 ? HEAP32[i17 >> 2] | 0 : i34 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i61, i33 ? HEAP32[i48 >> 2] | 0 : i48, i34, i34 + 26 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i61, gb + 455971 | 0, 26) | 0;
      if (i35) i2 = 0; else i2 = HEAP32[i36 >> 2] | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 482, 2052, i2, HEAP32[i4 + 4 >> 2] | 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i51);
      i2 = i3;
     }
    } while (0);
    i34 = HEAP32[i47 >> 2] | 0;
    HEAP32[i34 + (i6 << 3) >> 2] = i2;
    HEAP8[i34 + (i6 << 3) + 4 >> 0] = i1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 27);
  if ((i40 | 0) > 0) {
   i10 = i46 + 16 | 0;
   i11 = i61 + 11 | 0;
   i12 = i50 + 11 | 0;
   i13 = i50 + 4 | 0;
   i14 = i61 + 11 | 0;
   i15 = i61 + 4 | 0;
   i16 = i49 + 11 | 0;
   i17 = i49 + 4 | 0;
   i18 = i52 + 11 | 0;
   i19 = i52 + 4 | 0;
   i20 = i50 + 11 | 0;
   i21 = i50 + 4 | 0;
   i22 = i61 + 11 | 0;
   i23 = i52 + 11 | 0;
   i24 = i52 + 4 | 0;
   i25 = i61 + 11 | 0;
   i26 = i61 + 4 | 0;
   i27 = i61 + 12 | 0;
   i28 = i44 + 11 | 0;
   i29 = i44 + 4 | 0;
   i30 = i43 + 11 | 0;
   i31 = i43 + 4 | 0;
   i32 = i42 + 11 | 0;
   i33 = i42 + 4 | 0;
   i34 = i52 + 11 | 0;
   i9 = 0;
   do {
    i1 = __ZN14MessageHandler3GetEv() | 0;
    __ZN14MessageHandler28MessageIDToMessageIdentifierEi(i46, i1, i9);
    if (HEAP32[i10 >> 2] & 1 | 0) {
     i4 = __ZN14MessageHandler15MessageIDToNameEi(i1, i9) | 0;
     i2 = HEAP32[i37 >> 2] | 0;
     if (!i2) i55 = 68; else {
      i1 = i37;
      L89 : while (1) {
       i3 = i2;
       while (1) {
        if ((_strcmp(HEAP32[i3 + 16 >> 2] | 0, i4) | 0) >= 0) break;
        i2 = HEAP32[i3 + 4 >> 2] | 0;
        if (!i2) break L89; else i3 = i2;
       }
       i2 = HEAP32[i3 >> 2] | 0;
       if (!i2) {
        i1 = i3;
        break;
       } else i1 = i3;
      }
      if ((i1 | 0) == (i37 | 0)) i55 = 68; else if ((_strcmp(i4, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0) i55 = 68;
     }
     if ((i55 | 0) == 68) {
      i55 = 0;
      i1 = i37;
     }
     i1 = (i1 | 0) == (i37 | 0) ? gb + 1164176 | 0 : i1 + 20 | 0;
     i7 = HEAP32[i1 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     L100 : do if (!i7) i2 = 0; else {
      i2 = (__Z6StrCmpPKcS0_(i4, HEAP32[gb + 65364 >> 2] | 0) | 0) == 0;
      do if (i35) {
       if (!i2) break;
       i6 = __Z24scripting_class_get_nameP11Il2CppClass(i39) | 0;
       i8 = HEAP32[gb + 65364 + 4 >> 2] | 0;
       HEAP32[i53 >> 2] = i4;
       HEAP32[i53 + 4 >> 2] = i6;
       HEAP32[i53 + 8 >> 2] = i8;
       __Z6FormatPKcz(i61, gb + 455998 | 0, i53);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 382, 512, 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
      } else {
       if (!i2) break;
       i6 = __Z24scripting_class_get_nameP11Il2CppClass(i39) | 0;
       i8 = HEAP32[gb + 65364 + 4 >> 2] | 0;
       HEAP32[i54 >> 2] = i4;
       HEAP32[i54 + 4 >> 2] = i6;
       HEAP32[i54 + 8 >> 2] = i8;
       __Z6FormatPKcz(i61, gb + 455998 | 0, i54);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 382, 512, HEAP32[i36 >> 2] | 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
      } while (0);
      i8 = __Z14GetMonoManagerv() | 0;
      i3 = __ZN14MessageHandler3GetEv() | 0;
      i2 = __ZN14MessageHandler15MessageIDToNameEi(i3, i9) | 0;
      HEAP32[i48 >> 2] = 0;
      HEAP32[i48 + 4 >> 2] = 0;
      HEAP32[i48 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i48, i2, _strlen(i2) | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i50, i48);
      HEAP32[i61 >> 2] = 0;
      HEAP32[i61 + 4 >> 2] = 0;
      HEAP32[i61 + 8 >> 2] = 0;
      i2 = HEAP8[i12 >> 0] | 0;
      i2 = i2 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i61, gb + 456020 | 0, 14, i2 + 14 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i61, (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50, i2) | 0;
      HEAP32[i49 >> 2] = 0;
      HEAP32[i49 + 4 >> 2] = 0;
      HEAP32[i49 + 8 >> 2] = 0;
      i2 = HEAP8[i14 >> 0] | 0;
      i6 = i2 << 24 >> 24 < 0;
      i2 = i6 ? HEAP32[i15 >> 2] | 0 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i49, i6 ? HEAP32[i61 >> 2] | 0 : i61, i2, i2 + 1 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i49, gb + 1074320 | 0, 1) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
      HEAP32[i50 >> 2] = 0;
      HEAP32[i50 + 4 >> 2] = 0;
      HEAP32[i50 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i50, gb + 456035 | 0, 28);
      i2 = i51;
      HEAP32[i2 >> 2] = i7;
      HEAP32[i2 + 4 >> 2] = i1;
      HEAP32[i61 >> 2] = HEAP32[i51 >> 2];
      HEAP32[i61 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
      i2 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i61) | 0;
      L108 : do if (i2 >>> 0 > 1) {
       HEAP32[i52 >> 2] = 0;
       HEAP32[i52 + 4 >> 2] = 0;
       HEAP32[i52 + 8 >> 2] = 0;
       i6 = HEAP8[i16 >> 0] | 0;
       i5 = i6 << 24 >> 24 < 0;
       i6 = i5 ? HEAP32[i17 >> 2] | 0 : i6 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i52, i5 ? HEAP32[i49 >> 2] | 0 : i49, i6, i6 + 41 | 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i52, gb + 456064 | 0, 41) | 0;
       HEAP32[i61 >> 2] = 0;
       HEAP32[i61 + 4 >> 2] = 0;
       HEAP32[i61 + 8 >> 2] = 0;
       i6 = HEAP8[i18 >> 0] | 0;
       i5 = i6 << 24 >> 24 < 0;
       i6 = i5 ? HEAP32[i19 >> 2] | 0 : i6 & 255;
       i7 = HEAP8[i20 >> 0] | 0;
       i7 = i7 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i7 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i61, i5 ? HEAP32[i52 >> 2] | 0 : i52, i6, i7 + i6 | 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i61, (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50, i7) | 0;
       if (i35) i2 = 0; else i2 = HEAP32[i36 >> 2] | 0;
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 180, 2052, i2, HEAP32[i8 + 4 >> 2] | 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
      } else {
       i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 56 >> 2] | 0;
       i4 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 44 >> 2] | 0;
       if ((i2 | 0) != 1) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
        i2 = i7;
        break L100;
       }
       if (!(__ZN14MessageHandler24MessageIDToParameterTypeEi(i3, i9) | 0)) {
        HEAP32[i52 >> 2] = 0;
        HEAP32[i52 + 4 >> 2] = 0;
        HEAP32[i52 + 8 >> 2] = 0;
        i6 = HEAP8[i16 >> 0] | 0;
        i5 = i6 << 24 >> 24 < 0;
        i6 = i5 ? HEAP32[i17 >> 2] | 0 : i6 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i52, i5 ? HEAP32[i49 >> 2] | 0 : i49, i6, i6 + 41 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i52, gb + 456106 | 0, 41) | 0;
        HEAP32[i61 >> 2] = 0;
        HEAP32[i61 + 4 >> 2] = 0;
        HEAP32[i61 + 8 >> 2] = 0;
        i6 = HEAP8[i23 >> 0] | 0;
        i5 = i6 << 24 >> 24 < 0;
        i6 = i5 ? HEAP32[i24 >> 2] | 0 : i6 & 255;
        i7 = HEAP8[i20 >> 0] | 0;
        i7 = i7 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i7 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i61, i5 ? HEAP32[i52 >> 2] | 0 : i52, i6, i7 + i6 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i61, (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50, i7) | 0;
        if (i35) i2 = 0; else i2 = HEAP32[i36 >> 2] | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i25 >> 0] | 0) < 0 ? HEAP32[i61 >> 2] | 0 : i61, 0, gb + 455851 | 0, 193, 2052, i2, HEAP32[i8 + 4 >> 2] | 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i61);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
        break;
       }
       i6 = i41;
       HEAP32[i6 >> 2] = i7;
       HEAP32[i6 + 4 >> 2] = i1;
       HEAP32[i61 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i61 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
       i6 = __Z25scripting_class_from_typePK10Il2CppType(__Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi(i61, 0) | 0) | 0;
       __ZN14MessageHandler28MessageIDToMessageIdentifierEi(i61, i3, i9);
       i2 = HEAP32[i26 >> 2] | 0;
       if (!i2) {
        i2 = gb + 1576256 | 0;
        i55 = 86;
       } else {
        i4 = __Z25scripting_class_from_namePK11Il2CppImagePKcS3_(i4, gb + 1049797 | 0, i2) | 0;
        if (!((i4 | 0) != 0 & (i6 | 0) == (i4 | 0))) {
         i2 = HEAP32[i26 >> 2] | 0;
         i55 = 86;
        }
       }
       L125 : do if ((i55 | 0) == 86) {
        i55 = 0;
        if ((i6 | 0) == (i5 | 0)) break;
        i3 = HEAP32[i27 >> 2] | 0;
        if (i3) {
         do if ((HEAP32[i3 + 16 >> 2] | 0) > 99999) {
          if ((i3 | 0) == (__ZN16ScriptingManager27NativeTypeForScriptingClassEP11Il2CppClass(__Z19GetScriptingManagerv() | 0, i6) | 0)) break L125;
          i2 = HEAP32[i27 >> 2] | 0;
         } else {
          if (!i6) {
           i2 = i3;
           break;
          }
          i3 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i6) | 0;
          i2 = HEAP32[i27 >> 2] | 0;
          if (!i3) break;
          if (((HEAP32[i2 + 24 >> 2] | 0) - (HEAP32[i3 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 28 >> 2] | 0) >>> 0) break L125;
         } while (0);
         if ((i2 | 0) == (gb + 29592 | 0)) break; else i2 = HEAP32[i2 + 8 >> 2] | 0;
        };
        HEAP32[i44 >> 2] = 0;
        HEAP32[i44 + 4 >> 2] = 0;
        HEAP32[i44 + 8 >> 2] = 0;
        i5 = HEAP8[i16 >> 0] | 0;
        i7 = i5 << 24 >> 24 < 0;
        i5 = i7 ? HEAP32[i17 >> 2] | 0 : i5 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i44, i7 ? HEAP32[i49 >> 2] | 0 : i49, i5, i5 + 42 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i44, gb + 456148 | 0, 42) | 0;
        HEAP32[i43 >> 2] = 0;
        HEAP32[i43 + 4 >> 2] = 0;
        HEAP32[i43 + 8 >> 2] = 0;
        i5 = HEAP8[i28 >> 0] | 0;
        i7 = i5 << 24 >> 24 < 0;
        i5 = i7 ? HEAP32[i29 >> 2] | 0 : i5 & 255;
        i6 = _strlen(i2) | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i43, i7 ? HEAP32[i44 >> 2] | 0 : i44, i5, i5 + i6 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i43, i2, i6) | 0;
        HEAP32[i42 >> 2] = 0;
        HEAP32[i42 + 4 >> 2] = 0;
        HEAP32[i42 + 8 >> 2] = 0;
        i6 = HEAP8[i30 >> 0] | 0;
        i5 = i6 << 24 >> 24 < 0;
        i6 = i5 ? HEAP32[i31 >> 2] | 0 : i6 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i42, i5 ? HEAP32[i43 >> 2] | 0 : i43, i6, i6 + 1 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i42, gb + 1074320 | 0, 1) | 0;
        HEAP32[i52 >> 2] = 0;
        HEAP32[i52 + 4 >> 2] = 0;
        HEAP32[i52 + 8 >> 2] = 0;
        i6 = HEAP8[i32 >> 0] | 0;
        i5 = i6 << 24 >> 24 < 0;
        i6 = i5 ? HEAP32[i33 >> 2] | 0 : i6 & 255;
        i7 = HEAP8[i20 >> 0] | 0;
        i7 = i7 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i7 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i52, i5 ? HEAP32[i42 >> 2] | 0 : i42, i6, i7 + i6 | 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i52, (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50, i7) | 0;
        if (i35) i2 = 0; else i2 = HEAP32[i36 >> 2] | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i34 >> 0] | 0) < 0 ? HEAP32[i52 >> 2] | 0 : i52, 0, gb + 455851 | 0, 249, 2052, i2, HEAP32[i8 + 4 >> 2] | 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i42);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
        break L108;
       } while (0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i50);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i49);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i48);
       i2 = i7;
       break L100;
      } while (0);
      i2 = HEAP32[gb + 1164176 >> 2] | 0;
      i1 = HEAPU8[gb + 1164176 + 4 >> 0] | i1 & -256;
     } while (0);
     i8 = i9 + 27 | 0;
     i7 = HEAP32[i47 >> 2] | 0;
     HEAP32[i7 + (i8 << 3) >> 2] = i2;
     HEAP8[i7 + (i8 << 3) + 4 >> 0] = i1;
    }
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i40 | 0));
  }
  __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i45, HEAP32[i37 >> 2] | 0);
  i1 = HEAP32[i56 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i38 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i38 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
   i56 = HEAP32[i56 + 12 >> 2] | 0;
   HEAP32[i61 >> 2] = 1;
   HEAP32[i61 + 4 >> 2] = i56;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i61);
  }
  if (!(HEAP32[i60 >> 2] | 0)) HEAP32[i60 >> 2] = __ZN23ManagedAttributeManager24GetDefaultExecutionOrderEP11Il2CppClass(__Z26GetManagedAttributeManagerv() | 0, i63) | 0;
  HEAP8[i58 >> 0] = (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i63, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 444 >> 2] | 0) | 0) & 1;
  HEAP8[i59 >> 0] = (__Z29scripting_class_has_attributeP11Il2CppClassS0_(i63, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 408 >> 2] | 0) | 0) & 1;
  STACKTOP = i62;
  return i57 | 0;
 }
 HEAP32[i2 >> 2] = -6;
 STACKTOP = i62;
 return i57 | 0;
}

function __ZL8Perlin3DRKN4math8floatNx3ERKf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0;
 f28 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f1);
 f119 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f1);
 f109 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f1);
 f91 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * f1);
 f89 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * f1);
 f79 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * f1);
 f62 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * f1);
 f45 = Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) * f1);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 32 >> 2]) * f1);
 f72 = Math_fround(Math_fround(HEAPF32[i3 + 36 >> 2]) * f1);
 f55 = Math_fround(Math_fround(HEAPF32[i3 + 40 >> 2]) * f1);
 f38 = Math_fround(Math_fround(HEAPF32[i3 + 44 >> 2]) * f1);
 f43 = Math_fround(Math_floor(Math_fround(f28)));
 f4 = Math_fround(Math_floor(Math_fround(f119)));
 f92 = Math_fround(Math_floor(Math_fround(f109)));
 f60 = Math_fround(Math_floor(Math_fround(f91)));
 f5 = Math_fround(Math_floor(Math_fround(f89)));
 f9 = Math_fround(Math_floor(Math_fround(f79)));
 f77 = Math_fround(Math_floor(Math_fround(f62)));
 f6 = Math_fround(Math_floor(Math_fround(f45)));
 f10 = Math_fround(Math_floor(Math_fround(f21)));
 f26 = Math_fround(Math_floor(Math_fround(f72)));
 f7 = Math_fround(Math_floor(Math_fround(f55)));
 f11 = Math_fround(Math_floor(Math_fround(f38)));
 f28 = Math_fround(f28 - f43);
 f119 = Math_fround(f119 - f4);
 f109 = Math_fround(f109 - f92);
 f91 = Math_fround(f91 - f60);
 f89 = Math_fround(f89 - f5);
 f79 = Math_fround(f79 - f9);
 f62 = Math_fround(f62 - f77);
 f45 = Math_fround(f45 - f6);
 f21 = Math_fround(f21 - f10);
 f72 = Math_fround(f72 - f26);
 f55 = Math_fround(f55 - f7);
 f38 = Math_fround(f38 - f11);
 f134 = Math_fround(f28 + Math_fround(-1.0));
 f130 = Math_fround(f119 + Math_fround(-1.0));
 f126 = Math_fround(f109 + Math_fround(-1.0));
 f122 = Math_fround(f91 + Math_fround(-1.0));
 f133 = Math_fround(f89 + Math_fround(-1.0));
 f129 = Math_fround(f79 + Math_fround(-1.0));
 f125 = Math_fround(f62 + Math_fround(-1.0));
 f121 = Math_fround(f45 + Math_fround(-1.0));
 f132 = Math_fround(f21 + Math_fround(-1.0));
 f128 = Math_fround(f72 + Math_fround(-1.0));
 f124 = Math_fround(f55 + Math_fround(-1.0));
 f120 = Math_fround(f38 + Math_fround(-1.0));
 i161 = ~~f43 & 255;
 i160 = ~~f4 & 255;
 i159 = ~~f92 & 255;
 i158 = ~~f60 & 255;
 i149 = ~~f5 & 255;
 i148 = ~~f9 & 255;
 i147 = ~~f77 & 255;
 i146 = ~~f6 & 255;
 i157 = ~~f10 & 255;
 i156 = ~~f26 & 255;
 i155 = ~~f7 & 255;
 i154 = ~~f11 & 255;
 i141 = i149 + 1 | 0;
 i139 = i148 + 1 | 0;
 i137 = i147 + 1 | 0;
 i135 = i146 + 1 | 0;
 i140 = i157 + 1 | 0;
 i138 = i156 + 1 | 0;
 i136 = i155 + 1 | 0;
 i3 = i154 + 1 | 0;
 i145 = HEAP32[gb + 80356 + (i161 << 2) >> 2] | 0;
 i144 = HEAP32[gb + 80356 + (i160 << 2) >> 2] | 0;
 i143 = HEAP32[gb + 80356 + (i159 << 2) >> 2] | 0;
 i142 = HEAP32[gb + 80356 + (i158 << 2) >> 2] | 0;
 i161 = HEAP32[gb + 80356 + (i161 + 1 << 2) >> 2] | 0;
 i160 = HEAP32[gb + 80356 + (i160 + 1 << 2) >> 2] | 0;
 i159 = HEAP32[gb + 80356 + (i159 + 1 << 2) >> 2] | 0;
 i158 = HEAP32[gb + 80356 + (i158 + 1 << 2) >> 2] | 0;
 i153 = HEAP32[gb + 80356 + (i145 + i149 << 2) >> 2] | 0;
 i152 = HEAP32[gb + 80356 + (i144 + i148 << 2) >> 2] | 0;
 i151 = HEAP32[gb + 80356 + (i143 + i147 << 2) >> 2] | 0;
 i150 = HEAP32[gb + 80356 + (i142 + i146 << 2) >> 2] | 0;
 i149 = HEAP32[gb + 80356 + (i161 + i149 << 2) >> 2] | 0;
 i148 = HEAP32[gb + 80356 + (i160 + i148 << 2) >> 2] | 0;
 i147 = HEAP32[gb + 80356 + (i159 + i147 << 2) >> 2] | 0;
 i146 = HEAP32[gb + 80356 + (i158 + i146 << 2) >> 2] | 0;
 i145 = HEAP32[gb + 80356 + (i145 + i141 << 2) >> 2] | 0;
 i144 = HEAP32[gb + 80356 + (i144 + i139 << 2) >> 2] | 0;
 i143 = HEAP32[gb + 80356 + (i143 + i137 << 2) >> 2] | 0;
 i142 = HEAP32[gb + 80356 + (i142 + i135 << 2) >> 2] | 0;
 i141 = HEAP32[gb + 80356 + (i161 + i141 << 2) >> 2] | 0;
 i139 = HEAP32[gb + 80356 + (i160 + i139 << 2) >> 2] | 0;
 i137 = HEAP32[gb + 80356 + (i159 + i137 << 2) >> 2] | 0;
 i135 = HEAP32[gb + 80356 + (i158 + i135 << 2) >> 2] | 0;
 i158 = HEAP32[gb + 80356 + (i153 + i157 << 2) >> 2] & 15;
 f11 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f7 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f26 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i152 + i156 << 2) >> 2] & 15;
 f10 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f6 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f77 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i151 + i155 << 2) >> 2] & 15;
 f9 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f5 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f60 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i150 + i154 << 2) >> 2] & 15;
 f92 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f4 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f43 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i149 + i157 << 2) >> 2] & 15;
 f18 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f86 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f23 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i148 + i156 << 2) >> 2] & 15;
 f116 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f69 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f117 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i147 + i155 << 2) >> 2] & 15;
 f106 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f52 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f107 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i146 + i154 << 2) >> 2] & 15;
 f99 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f35 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i145 + i157 << 2) >> 2] & 15;
 f17 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f85 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f87 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i144 + i156 << 2) >> 2] & 15;
 f115 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f68 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f74 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i143 + i155 << 2) >> 2] & 15;
 f105 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f51 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f57 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i158 = HEAP32[gb + 80356 + (i142 + i154 << 2) >> 2] & 15;
 f98 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) >> 2]);
 f34 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 4 >> 2]);
 f40 = Math_fround(HEAPF32[gb + 1451848 + (i158 * 12 | 0) + 8 >> 2]);
 i157 = HEAP32[gb + 80356 + (i141 + i157 << 2) >> 2] & 15;
 f12 = Math_fround(HEAPF32[gb + 1451848 + (i157 * 12 | 0) >> 2]);
 f80 = Math_fround(HEAPF32[gb + 1451848 + (i157 * 12 | 0) + 4 >> 2]);
 f22 = Math_fround(HEAPF32[gb + 1451848 + (i157 * 12 | 0) + 8 >> 2]);
 i156 = HEAP32[gb + 80356 + (i139 + i156 << 2) >> 2] & 15;
 f110 = Math_fround(HEAPF32[gb + 1451848 + (i156 * 12 | 0) >> 2]);
 f63 = Math_fround(HEAPF32[gb + 1451848 + (i156 * 12 | 0) + 4 >> 2]);
 f73 = Math_fround(HEAPF32[gb + 1451848 + (i156 * 12 | 0) + 8 >> 2]);
 i155 = HEAP32[gb + 80356 + (i137 + i155 << 2) >> 2] & 15;
 f100 = Math_fround(HEAPF32[gb + 1451848 + (i155 * 12 | 0) >> 2]);
 f46 = Math_fround(HEAPF32[gb + 1451848 + (i155 * 12 | 0) + 4 >> 2]);
 f56 = Math_fround(HEAPF32[gb + 1451848 + (i155 * 12 | 0) + 8 >> 2]);
 i154 = HEAP32[gb + 80356 + (i135 + i154 << 2) >> 2] & 15;
 f93 = Math_fround(HEAPF32[gb + 1451848 + (i154 * 12 | 0) >> 2]);
 f29 = Math_fround(HEAPF32[gb + 1451848 + (i154 * 12 | 0) + 4 >> 2]);
 f39 = Math_fround(HEAPF32[gb + 1451848 + (i154 * 12 | 0) + 8 >> 2]);
 i153 = HEAP32[gb + 80356 + (i153 + i140 << 2) >> 2] & 15;
 f16 = Math_fround(HEAPF32[gb + 1451848 + (i153 * 12 | 0) >> 2]);
 f84 = Math_fround(HEAPF32[gb + 1451848 + (i153 * 12 | 0) + 4 >> 2]);
 f24 = Math_fround(HEAPF32[gb + 1451848 + (i153 * 12 | 0) + 8 >> 2]);
 i152 = HEAP32[gb + 80356 + (i152 + i138 << 2) >> 2] & 15;
 f114 = Math_fround(HEAPF32[gb + 1451848 + (i152 * 12 | 0) >> 2]);
 f67 = Math_fround(HEAPF32[gb + 1451848 + (i152 * 12 | 0) + 4 >> 2]);
 f75 = Math_fround(HEAPF32[gb + 1451848 + (i152 * 12 | 0) + 8 >> 2]);
 i151 = HEAP32[gb + 80356 + (i151 + i136 << 2) >> 2] & 15;
 f104 = Math_fround(HEAPF32[gb + 1451848 + (i151 * 12 | 0) >> 2]);
 f50 = Math_fround(HEAPF32[gb + 1451848 + (i151 * 12 | 0) + 4 >> 2]);
 f58 = Math_fround(HEAPF32[gb + 1451848 + (i151 * 12 | 0) + 8 >> 2]);
 i150 = HEAP32[gb + 80356 + (i150 + i3 << 2) >> 2] & 15;
 f97 = Math_fround(HEAPF32[gb + 1451848 + (i150 * 12 | 0) >> 2]);
 f33 = Math_fround(HEAPF32[gb + 1451848 + (i150 * 12 | 0) + 4 >> 2]);
 f41 = Math_fround(HEAPF32[gb + 1451848 + (i150 * 12 | 0) + 8 >> 2]);
 i149 = HEAP32[gb + 80356 + (i149 + i140 << 2) >> 2] & 15;
 f13 = Math_fround(HEAPF32[gb + 1451848 + (i149 * 12 | 0) >> 2]);
 f81 = Math_fround(HEAPF32[gb + 1451848 + (i149 * 12 | 0) + 4 >> 2]);
 f25 = Math_fround(HEAPF32[gb + 1451848 + (i149 * 12 | 0) + 8 >> 2]);
 i148 = HEAP32[gb + 80356 + (i148 + i138 << 2) >> 2] & 15;
 f111 = Math_fround(HEAPF32[gb + 1451848 + (i148 * 12 | 0) >> 2]);
 f64 = Math_fround(HEAPF32[gb + 1451848 + (i148 * 12 | 0) + 4 >> 2]);
 f118 = Math_fround(HEAPF32[gb + 1451848 + (i148 * 12 | 0) + 8 >> 2]);
 i147 = HEAP32[gb + 80356 + (i147 + i136 << 2) >> 2] & 15;
 f101 = Math_fround(HEAPF32[gb + 1451848 + (i147 * 12 | 0) >> 2]);
 f47 = Math_fround(HEAPF32[gb + 1451848 + (i147 * 12 | 0) + 4 >> 2]);
 f108 = Math_fround(HEAPF32[gb + 1451848 + (i147 * 12 | 0) + 8 >> 2]);
 i146 = HEAP32[gb + 80356 + (i146 + i3 << 2) >> 2] & 15;
 f94 = Math_fround(HEAPF32[gb + 1451848 + (i146 * 12 | 0) >> 2]);
 f30 = Math_fround(HEAPF32[gb + 1451848 + (i146 * 12 | 0) + 4 >> 2]);
 f90 = Math_fround(HEAPF32[gb + 1451848 + (i146 * 12 | 0) + 8 >> 2]);
 i145 = HEAP32[gb + 80356 + (i145 + i140 << 2) >> 2] & 15;
 f14 = Math_fround(HEAPF32[gb + 1451848 + (i145 * 12 | 0) >> 2]);
 f82 = Math_fround(HEAPF32[gb + 1451848 + (i145 * 12 | 0) + 4 >> 2]);
 f88 = Math_fround(HEAPF32[gb + 1451848 + (i145 * 12 | 0) + 8 >> 2]);
 i144 = HEAP32[gb + 80356 + (i144 + i138 << 2) >> 2] & 15;
 f112 = Math_fround(HEAPF32[gb + 1451848 + (i144 * 12 | 0) >> 2]);
 f65 = Math_fround(HEAPF32[gb + 1451848 + (i144 * 12 | 0) + 4 >> 2]);
 f76 = Math_fround(HEAPF32[gb + 1451848 + (i144 * 12 | 0) + 8 >> 2]);
 i143 = HEAP32[gb + 80356 + (i143 + i136 << 2) >> 2] & 15;
 f102 = Math_fround(HEAPF32[gb + 1451848 + (i143 * 12 | 0) >> 2]);
 f48 = Math_fround(HEAPF32[gb + 1451848 + (i143 * 12 | 0) + 4 >> 2]);
 f59 = Math_fround(HEAPF32[gb + 1451848 + (i143 * 12 | 0) + 8 >> 2]);
 i142 = HEAP32[gb + 80356 + (i142 + i3 << 2) >> 2] & 15;
 f95 = Math_fround(HEAPF32[gb + 1451848 + (i142 * 12 | 0) >> 2]);
 f31 = Math_fround(HEAPF32[gb + 1451848 + (i142 * 12 | 0) + 4 >> 2]);
 f42 = Math_fround(HEAPF32[gb + 1451848 + (i142 * 12 | 0) + 8 >> 2]);
 i140 = HEAP32[gb + 80356 + (i141 + i140 << 2) >> 2] & 15;
 f15 = Math_fround(HEAPF32[gb + 1451848 + (i140 * 12 | 0) >> 2]);
 f83 = Math_fround(HEAPF32[gb + 1451848 + (i140 * 12 | 0) + 4 >> 2]);
 f131 = Math_fround(HEAPF32[gb + 1451848 + (i140 * 12 | 0) + 8 >> 2]);
 i138 = HEAP32[gb + 80356 + (i139 + i138 << 2) >> 2] & 15;
 f113 = Math_fround(HEAPF32[gb + 1451848 + (i138 * 12 | 0) >> 2]);
 f66 = Math_fround(HEAPF32[gb + 1451848 + (i138 * 12 | 0) + 4 >> 2]);
 f127 = Math_fround(HEAPF32[gb + 1451848 + (i138 * 12 | 0) + 8 >> 2]);
 i136 = HEAP32[gb + 80356 + (i137 + i136 << 2) >> 2] & 15;
 f103 = Math_fround(HEAPF32[gb + 1451848 + (i136 * 12 | 0) >> 2]);
 f49 = Math_fround(HEAPF32[gb + 1451848 + (i136 * 12 | 0) + 4 >> 2]);
 f123 = Math_fround(HEAPF32[gb + 1451848 + (i136 * 12 | 0) + 8 >> 2]);
 i3 = HEAP32[gb + 80356 + (i135 + i3 << 2) >> 2] & 15;
 f96 = Math_fround(HEAPF32[gb + 1451848 + (i3 * 12 | 0) >> 2]);
 f32 = Math_fround(HEAPF32[gb + 1451848 + (i3 * 12 | 0) + 4 >> 2]);
 f26 = Math_fround(Math_fround(Math_fround(f28 * f11) + Math_fround(f89 * f7)) + Math_fround(f21 * f26));
 f77 = Math_fround(Math_fround(Math_fround(f119 * f10) + Math_fround(f79 * f6)) + Math_fround(f72 * f77));
 f60 = Math_fround(Math_fround(Math_fround(f109 * f9) + Math_fround(f62 * f5)) + Math_fround(f55 * f60));
 f43 = Math_fround(Math_fround(Math_fround(f91 * f92) + Math_fround(f45 * f4)) + Math_fround(f38 * f43));
 f23 = Math_fround(Math_fround(Math_fround(f134 * f18) + Math_fround(f89 * f86)) + Math_fround(f21 * f23));
 f117 = Math_fround(Math_fround(Math_fround(f130 * f116) + Math_fround(f79 * f69)) + Math_fround(f72 * f117));
 f107 = Math_fround(Math_fround(Math_fround(f126 * f106) + Math_fround(f62 * f52)) + Math_fround(f55 * f107));
 f8 = Math_fround(Math_fround(Math_fround(f122 * f99) + Math_fround(f45 * f35)) + Math_fround(f38 * f8));
 f87 = Math_fround(Math_fround(Math_fround(f28 * f17) + Math_fround(f133 * f85)) + Math_fround(f21 * f87));
 f74 = Math_fround(Math_fround(Math_fround(f119 * f115) + Math_fround(f129 * f68)) + Math_fround(f72 * f74));
 f57 = Math_fround(Math_fround(Math_fround(f109 * f105) + Math_fround(f125 * f51)) + Math_fround(f55 * f57));
 f40 = Math_fround(Math_fround(Math_fround(f91 * f98) + Math_fround(f121 * f34)) + Math_fround(f38 * f40));
 f22 = Math_fround(Math_fround(Math_fround(f134 * f12) + Math_fround(f133 * f80)) + Math_fround(f21 * f22));
 f73 = Math_fround(Math_fround(Math_fround(f130 * f110) + Math_fround(f129 * f63)) + Math_fround(f72 * f73));
 f56 = Math_fround(Math_fround(Math_fround(f126 * f100) + Math_fround(f125 * f46)) + Math_fround(f55 * f56));
 f39 = Math_fround(Math_fround(Math_fround(f122 * f93) + Math_fround(f121 * f29)) + Math_fround(f38 * f39));
 f24 = Math_fround(Math_fround(Math_fround(f28 * f16) + Math_fround(f89 * f84)) + Math_fround(f132 * f24));
 f75 = Math_fround(Math_fround(Math_fround(f119 * f114) + Math_fround(f79 * f67)) + Math_fround(f128 * f75));
 f58 = Math_fround(Math_fround(Math_fround(f109 * f104) + Math_fround(f62 * f50)) + Math_fround(f124 * f58));
 f41 = Math_fround(Math_fround(Math_fround(f91 * f97) + Math_fround(f45 * f33)) + Math_fround(f120 * f41));
 f25 = Math_fround(Math_fround(Math_fround(f134 * f13) + Math_fround(f89 * f81)) + Math_fround(f132 * f25));
 f118 = Math_fround(Math_fround(Math_fround(f130 * f111) + Math_fround(f79 * f64)) + Math_fround(f128 * f118));
 f108 = Math_fround(Math_fround(Math_fround(f126 * f101) + Math_fround(f62 * f47)) + Math_fround(f124 * f108));
 f90 = Math_fround(Math_fround(Math_fround(f122 * f94) + Math_fround(f45 * f30)) + Math_fround(f120 * f90));
 f88 = Math_fround(Math_fround(Math_fround(f28 * f14) + Math_fround(f133 * f82)) + Math_fround(f132 * f88));
 f76 = Math_fround(Math_fround(Math_fround(f119 * f112) + Math_fround(f129 * f65)) + Math_fround(f128 * f76));
 f59 = Math_fround(Math_fround(Math_fround(f109 * f102) + Math_fround(f125 * f48)) + Math_fround(f124 * f59));
 f42 = Math_fround(Math_fround(Math_fround(f91 * f95) + Math_fround(f121 * f31)) + Math_fround(f120 * f42));
 f19 = Math_fround(Math_fround(f28 * Math_fround(f28 * f28)) * Math_fround(Math_fround(f28 * Math_fround(Math_fround(f28 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f70 = Math_fround(Math_fround(f119 * Math_fround(f119 * f119)) * Math_fround(Math_fround(f119 * Math_fround(Math_fround(f119 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f53 = Math_fround(Math_fround(f109 * Math_fround(f109 * f109)) * Math_fround(Math_fround(f109 * Math_fround(Math_fround(f109 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f36 = Math_fround(Math_fround(f91 * Math_fround(f91 * f91)) * Math_fround(Math_fround(f91 * Math_fround(Math_fround(f91 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f20 = Math_fround(Math_fround(f89 * Math_fround(f89 * f89)) * Math_fround(Math_fround(f89 * Math_fround(Math_fround(f89 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f71 = Math_fround(Math_fround(f79 * Math_fround(f79 * f79)) * Math_fround(Math_fround(f79 * Math_fround(Math_fround(f79 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f54 = Math_fround(Math_fround(f62 * Math_fround(f62 * f62)) * Math_fround(Math_fround(f62 * Math_fround(Math_fround(f62 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f37 = Math_fround(Math_fround(f45 * Math_fround(f45 * f45)) * Math_fround(Math_fround(f45 * Math_fround(Math_fround(f45 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f21 = Math_fround(Math_fround(f21 * Math_fround(f21 * f21)) * Math_fround(Math_fround(f21 * Math_fround(Math_fround(f21 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f72 = Math_fround(Math_fround(f72 * Math_fround(f72 * f72)) * Math_fround(Math_fround(f72 * Math_fround(Math_fround(f72 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f55 = Math_fround(Math_fround(f55 * Math_fround(f55 * f55)) * Math_fround(Math_fround(f55 * Math_fround(Math_fround(f55 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f38 = Math_fround(Math_fround(f38 * Math_fround(f38 * f38)) * Math_fround(Math_fround(f38 * Math_fround(Math_fround(f38 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f27 = Math_fround(f26 + Math_fround(Math_fround(f22 - f87) - f23));
 f78 = Math_fround(f77 + Math_fround(Math_fround(f73 - f74) - f117));
 f61 = Math_fround(f60 + Math_fround(Math_fround(f56 - f57) - f107));
 f44 = Math_fround(f43 + Math_fround(Math_fround(f39 - f40) - f8));
 f22 = Math_fround(Math_fround(f23 + Math_fround(f87 + Math_fround(Math_fround(f24 + Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f134 * f15) + Math_fround(f133 * f83)) + Math_fround(f132 * f131)) - f88) - f25)) - f22))) - f26);
 f73 = Math_fround(Math_fround(f117 + Math_fround(f74 + Math_fround(Math_fround(f75 + Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f130 * f113) + Math_fround(f129 * f66)) + Math_fround(f128 * f127)) - f76) - f118)) - f73))) - f77);
 f56 = Math_fround(Math_fround(f107 + Math_fround(f57 + Math_fround(Math_fround(f58 + Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f126 * f103) + Math_fround(f125 * f49)) + Math_fround(f124 * f123)) - f59) - f108)) - f56))) - f60);
 f39 = Math_fround(Math_fround(f8 + Math_fround(f40 + Math_fround(Math_fround(f41 + Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f122 * f96) + Math_fround(f121 * f32)) + Math_fround(f120 * Math_fround(HEAPF32[gb + 1451848 + (i3 * 12 | 0) + 8 >> 2]))) - f42) - f90)) - f39))) - f43);
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f119 * Math_fround(f119 * Math_fround(30.0))) * Math_fround(Math_fround(f119 * Math_fround(f119 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f117 - f77) + Math_fround(f71 * f78)) + Math_fround(f72 * Math_fround(Math_fround(f77 + Math_fround(Math_fround(f118 - f75) - f117)) + Math_fround(f71 * f73))))) + Math_fround(Math_fround(Math_fround(f10 + Math_fround(f70 * Math_fround(f116 - f10))) + Math_fround(f71 * Math_fround(Math_fround(f115 - f10) + Math_fround(f70 * Math_fround(f10 + Math_fround(Math_fround(f110 - f115) - f116)))))) + Math_fround(f72 * Math_fround(Math_fround(Math_fround(f114 - f10) + Math_fround(f70 * Math_fround(f10 + Math_fround(Math_fround(f111 - f114) - f116)))) + Math_fround(f71 * Math_fround(Math_fround(f10 + Math_fround(Math_fround(f112 - f114) - f115)) + Math_fround(f70 * Math_fround(Math_fround(f116 + Math_fround(f115 + Math_fround(Math_fround(f114 + Math_fround(Math_fround(f113 - f112) - f111)) - f110))) - f10)))))))) * f1);
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f109 * Math_fround(f109 * Math_fround(30.0))) * Math_fround(Math_fround(f109 * Math_fround(f109 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f107 - f60) + Math_fround(f54 * f61)) + Math_fround(f55 * Math_fround(Math_fround(f60 + Math_fround(Math_fround(f108 - f58) - f107)) + Math_fround(f54 * f56))))) + Math_fround(Math_fround(Math_fround(f9 + Math_fround(f53 * Math_fround(f106 - f9))) + Math_fround(f54 * Math_fround(Math_fround(f105 - f9) + Math_fround(f53 * Math_fround(f9 + Math_fround(Math_fround(f100 - f105) - f106)))))) + Math_fround(f55 * Math_fround(Math_fround(Math_fround(f104 - f9) + Math_fround(f53 * Math_fround(f9 + Math_fround(Math_fround(f101 - f104) - f106)))) + Math_fround(f54 * Math_fround(Math_fround(f9 + Math_fround(Math_fround(f102 - f104) - f105)) + Math_fround(f53 * Math_fround(Math_fround(f106 + Math_fround(f105 + Math_fround(Math_fround(f104 + Math_fround(Math_fround(f103 - f102) - f101)) - f100))) - f9)))))))) * f1);
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f92 + Math_fround(f36 * Math_fround(f99 - f92))) + Math_fround(f37 * Math_fround(Math_fround(f98 - f92) + Math_fround(f36 * Math_fround(f92 + Math_fround(Math_fround(f93 - f98) - f99)))))) + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f97 - f92) + Math_fround(f36 * Math_fround(f92 + Math_fround(Math_fround(f94 - f97) - f99)))) + Math_fround(f37 * Math_fround(Math_fround(f92 + Math_fround(Math_fround(f95 - f97) - f98)) + Math_fround(f36 * Math_fround(Math_fround(f99 + Math_fround(f98 + Math_fround(Math_fround(f97 + Math_fround(Math_fround(f96 - f95) - f94)) - f93))) - f92))))))) + Math_fround(Math_fround(Math_fround(f91 * Math_fround(f91 * Math_fround(30.0))) * Math_fround(Math_fround(f91 * Math_fround(f91 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f8 - f43) + Math_fround(f37 * f44)) + Math_fround(f38 * Math_fround(Math_fround(f43 + Math_fround(Math_fround(f90 - f41) - f8)) + Math_fround(f37 * f39)))))) * f1);
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f89 * Math_fround(f89 * Math_fround(30.0))) * Math_fround(Math_fround(f89 * Math_fround(f89 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f87 - f26) + Math_fround(f19 * f27)) + Math_fround(f21 * Math_fround(Math_fround(f26 + Math_fround(Math_fround(f88 - f24) - f87)) + Math_fround(f19 * f22))))) + Math_fround(Math_fround(Math_fround(f7 + Math_fround(f19 * Math_fround(f86 - f7))) + Math_fround(f20 * Math_fround(Math_fround(f85 - f7) + Math_fround(f19 * Math_fround(f7 + Math_fround(Math_fround(f80 - f85) - f86)))))) + Math_fround(f21 * Math_fround(Math_fround(Math_fround(f84 - f7) + Math_fround(f19 * Math_fround(f7 + Math_fround(Math_fround(f81 - f84) - f86)))) + Math_fround(f20 * Math_fround(Math_fround(f7 + Math_fround(Math_fround(f82 - f84) - f85)) + Math_fround(f19 * Math_fround(Math_fround(f86 + Math_fround(f85 + Math_fround(Math_fround(f84 + Math_fround(Math_fround(f83 - f82) - f81)) - f80))) - f7)))))))) * f1);
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f79 * Math_fround(f79 * Math_fround(30.0))) * Math_fround(Math_fround(f79 * Math_fround(f79 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f74 - f77) + Math_fround(f70 * f78)) + Math_fround(f72 * Math_fround(Math_fround(f77 + Math_fround(Math_fround(f76 - f75) - f74)) + Math_fround(f70 * f73))))) + Math_fround(Math_fround(Math_fround(f6 + Math_fround(f70 * Math_fround(f69 - f6))) + Math_fround(f71 * Math_fround(Math_fround(f68 - f6) + Math_fround(f70 * Math_fround(f6 + Math_fround(Math_fround(f63 - f68) - f69)))))) + Math_fround(f72 * Math_fround(Math_fround(Math_fround(f67 - f6) + Math_fround(f70 * Math_fround(f6 + Math_fround(Math_fround(f64 - f67) - f69)))) + Math_fround(f71 * Math_fround(Math_fround(f6 + Math_fround(Math_fround(f65 - f67) - f68)) + Math_fround(f70 * Math_fround(Math_fround(f69 + Math_fround(f68 + Math_fround(Math_fround(f67 + Math_fround(Math_fround(f66 - f65) - f64)) - f63))) - f6)))))))) * f1);
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f62 * Math_fround(f62 * Math_fround(30.0))) * Math_fround(Math_fround(f62 * Math_fround(f62 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f57 - f60) + Math_fround(f53 * f61)) + Math_fround(f55 * Math_fround(Math_fround(f60 + Math_fround(Math_fround(f59 - f58) - f57)) + Math_fround(f53 * f56))))) + Math_fround(Math_fround(Math_fround(f5 + Math_fround(f53 * Math_fround(f52 - f5))) + Math_fround(f54 * Math_fround(Math_fround(f51 - f5) + Math_fround(f53 * Math_fround(f5 + Math_fround(Math_fround(f46 - f51) - f52)))))) + Math_fround(f55 * Math_fround(Math_fround(Math_fround(f50 - f5) + Math_fround(f53 * Math_fround(f5 + Math_fround(Math_fround(f47 - f50) - f52)))) + Math_fround(f54 * Math_fround(Math_fround(f5 + Math_fround(Math_fround(f48 - f50) - f51)) + Math_fround(f53 * Math_fround(Math_fround(f52 + Math_fround(f51 + Math_fround(Math_fround(f50 + Math_fround(Math_fround(f49 - f48) - f47)) - f46))) - f5)))))))) * f1);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f45 * Math_fround(f45 * Math_fround(30.0))) * Math_fround(Math_fround(f45 * Math_fround(f45 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f40 - f43) + Math_fround(f36 * f44)) + Math_fround(f38 * Math_fround(Math_fround(f43 + Math_fround(Math_fround(f42 - f41) - f40)) + Math_fround(f36 * f39))))) + Math_fround(Math_fround(Math_fround(f4 + Math_fround(f36 * Math_fround(f35 - f4))) + Math_fround(f37 * Math_fround(Math_fround(f34 - f4) + Math_fround(f36 * Math_fround(f4 + Math_fround(Math_fround(f29 - f34) - f35)))))) + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f33 - f4) + Math_fround(f36 * Math_fround(f4 + Math_fround(Math_fround(f30 - f33) - f35)))) + Math_fround(f37 * Math_fround(Math_fround(f4 + Math_fround(Math_fround(f31 - f33) - f34)) + Math_fround(f36 * Math_fround(Math_fround(f35 + Math_fround(f34 + Math_fround(Math_fround(f33 + Math_fround(Math_fround(f32 - f31) - f30)) - f29))) - f4)))))))) * f1);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f28 * Math_fround(f28 * Math_fround(30.0))) * Math_fround(Math_fround(f28 * Math_fround(f28 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f23 - f26) + Math_fround(f20 * f27)) + Math_fround(f21 * Math_fround(Math_fround(f26 + Math_fround(Math_fround(f25 - f24) - f23)) + Math_fround(f20 * f22))))) + Math_fround(Math_fround(Math_fround(f11 + Math_fround(f19 * Math_fround(f18 - f11))) + Math_fround(f20 * Math_fround(Math_fround(f17 - f11) + Math_fround(f19 * Math_fround(f11 + Math_fround(Math_fround(f12 - f17) - f18)))))) + Math_fround(f21 * Math_fround(Math_fround(Math_fround(f16 - f11) + Math_fround(f19 * Math_fround(f11 + Math_fround(Math_fround(f13 - f16) - f18)))) + Math_fround(f20 * Math_fround(Math_fround(f11 + Math_fround(Math_fround(f14 - f16) - f17)) + Math_fround(f19 * Math_fround(Math_fround(f18 + Math_fround(f17 + Math_fround(Math_fround(f16 + Math_fround(Math_fround(f15 - f14) - f13)) - f12))) - f11)))))))) * f1);
 HEAPF32[i2 + 4 >> 2] = f10;
 HEAPF32[i2 + 8 >> 2] = f9;
 HEAPF32[i2 + 12 >> 2] = f8;
 HEAPF32[i2 + 16 >> 2] = f7;
 HEAPF32[i2 + 20 >> 2] = f6;
 HEAPF32[i2 + 24 >> 2] = f5;
 HEAPF32[i2 + 28 >> 2] = f4;
 return;
}

function __ZN25ParticleSystemGeometryJob12ScheduleJobsEPP12BaseRendererjPK6CameraRK10Matrix4x4f(i62, i63, i64, i65) {
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0;
 i83 = STACKTOP;
 STACKTOP = STACKTOP + 1664 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i75 = i83 + 1648 | 0;
 i77 = i83 + 1632 | 0;
 i80 = i83 + 1616 | 0;
 i81 = i83 + 1600 | 0;
 i82 = i83 + 1588 | 0;
 i10 = i83 + 1060 | 0;
 i73 = i83 + 1056 | 0;
 i7 = i83 + 532 | 0;
 i67 = i83 + 528 | 0;
 i8 = i83 + 4 | 0;
 i76 = i83;
 i66 = i83 + 1628 | 0;
 i71 = i83 + 1612 | 0;
 i74 = i83 + 1584 | 0;
 if ((HEAP16[gb + 1452200 + 6 >> 1] | 0) > -1) {
  HEAP32[i77 >> 2] = 0;
  HEAP32[i75 >> 2] = HEAP32[i77 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452200 | 0, i75);
  i78 = gb + 1452200 | 0;
 } else i78 = 0;
 HEAP32[i80 >> 2] = 0;
 i79 = i80 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i79;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 4 >> 2] = i4;
 i9 = i63 + 1 | 0;
 i1 = i9 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 621865 | 0, 967) | 0;
   i3 = gb + 64016 | 0;
   i72 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i80 >> 2] = i1;
   i4 = i79;
   HEAP32[i4 >> 2] = i72;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 i68 = i1 + 3 & -4;
 HEAP32[i81 >> 2] = 0;
 i72 = i81 + 4 | 0;
 i6 = i72;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i63 << 2;
 i5 = (i6 | 0) != 0;
 do if (i5) {
  i1 = i6 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 621865 | 0, 968) | 0;
   i3 = gb + 64016 | 0;
   i69 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i81 >> 2] = i2;
   i4 = i72;
   HEAP32[i4 >> 2] = i69;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i59 = i2 + 3 & -4;
 HEAP32[i82 >> 2] = 0;
 i69 = i82 + 4 | 0;
 i61 = i69;
 HEAP32[i61 >> 2] = i3;
 HEAP32[i61 + 4 >> 2] = i4;
 do if (i5) {
  i2 = i6 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 621865 | 0, 969) | 0;
   i60 = gb + 64016 | 0;
   i58 = HEAP32[i60 >> 2] | 0;
   i60 = HEAP32[i60 + 4 >> 2] | 0;
   HEAP32[i82 >> 2] = i1;
   i61 = i69;
   HEAP32[i61 >> 2] = i58;
   HEAP32[i61 + 4 >> 2] = i60;
   break;
  }
 } else i1 = 0; while (0);
 i61 = i1 + 3 & -4;
 __ZN14BatchAllocatorC2Ev(i10);
 HEAP32[i73 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i10, i73, -1, 24, 1, 4);
 HEAP32[i73 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i10, 0, 0, 20, i9, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i10, (HEAP32[i73 >> 2] | 0) + 4 | 0, 0, 788, i9, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i10, gb + 64024 | 0);
 __ZN14BatchAllocatorC2Ev(i7);
 HEAP32[i67 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i7, i67, -1, 24, 1, 4);
 HEAP32[i67 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i7, 0, 0, 20, i63, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i7, (HEAP32[i67 >> 2] | 0) + 4 | 0, 0, 788, i63, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i7, gb + 64024 | 0);
 __ZN14BatchAllocatorC2Ev(i8);
 HEAP32[i76 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, i76, -1, 24, 1, 4);
 HEAP32[i76 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, 0, 0, 20, i63, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, (HEAP32[i76 >> 2] | 0) + 4 | 0, 0, 268, i63, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i8, gb + 64024 | 0);
 i60 = __Z12GetGfxDevicev() | 0;
 i25 = __ZN9GfxDevice13GetDynamicVBOEv(i60) | 0;
 i26 = HEAP32[i73 >> 2] | 0;
 i27 = i60 + 4448 | 0;
 __ZN17UniqueIDGenerator8CreateIDEv(i75, i27);
 HEAP32[i26 + 8 >> 2] = HEAP32[i75 >> 2];
 i26 = HEAP32[i67 >> 2] | 0;
 __ZN17UniqueIDGenerator8CreateIDEv(i75, i27);
 HEAP32[i26 + 8 >> 2] = HEAP32[i75 >> 2];
 i26 = HEAP32[i76 >> 2] | 0;
 __ZN17UniqueIDGenerator8CreateIDEv(i75, i27);
 HEAP32[i26 + 8 >> 2] = HEAP32[i75 >> 2];
 i26 = __ZNK6Camera20GetWorldToClipMatrixEv(i64) | 0;
 i27 = HEAP32[i64 + 880 >> 2] | 0;
 f28 = Math_fround(__ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv(i64));
 if (!i63) {
  i3 = 0;
  i4 = 0;
  i70 = 90;
 } else {
  i29 = i65 + 4 | 0;
  i30 = i65 + 8 | 0;
  i31 = i65 + 12 | 0;
  i32 = i65 + 16 | 0;
  i33 = i65 + 20 | 0;
  i34 = i65 + 24 | 0;
  i35 = i65 + 28 | 0;
  i36 = i65 + 32 | 0;
  i37 = i65 + 36 | 0;
  i38 = i65 + 40 | 0;
  i39 = i65 + 44 | 0;
  i40 = i65 + 48 | 0;
  i41 = i65 + 52 | 0;
  i42 = i65 + 56 | 0;
  i43 = i65 + 60 | 0;
  i44 = i26 + 4 | 0;
  i45 = i26 + 8 | 0;
  i46 = i26 + 12 | 0;
  i47 = i26 + 16 | 0;
  i48 = i26 + 20 | 0;
  i49 = i26 + 24 | 0;
  i50 = i26 + 28 | 0;
  i51 = i26 + 32 | 0;
  i52 = i26 + 36 | 0;
  i53 = i26 + 40 | 0;
  i54 = i26 + 44 | 0;
  i55 = i26 + 48 | 0;
  i56 = i26 + 52 | 0;
  i57 = i26 + 56 | 0;
  i58 = i26 + 60 | 0;
  i4 = 0;
  i6 = 0;
  i3 = 0;
  i22 = 0;
  i1 = 0;
  i23 = 0;
  i2 = 0;
  i24 = 0;
  i20 = 0;
  while (1) {
   i17 = HEAP32[i62 + (i24 << 2) >> 2] | 0;
   i17 = (i17 | 0) == 0 ? 0 : i17 + -32 | 0;
   i18 = i17 + 592 | 0;
   do if (__ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle(i25, i18) | 0) if ((HEAP32[i17 + 996 >> 2] | 0) == (i27 | 0)) if ((HEAP32[i17 + 868 >> 2] | 0) == (HEAP32[i65 >> 2] | 0)) if ((HEAP32[i17 + 872 >> 2] | 0) == (HEAP32[i29 >> 2] | 0)) if ((HEAP32[i17 + 876 >> 2] | 0) == (HEAP32[i30 >> 2] | 0)) if ((HEAP32[i17 + 880 >> 2] | 0) == (HEAP32[i31 >> 2] | 0)) if ((HEAP32[i17 + 884 >> 2] | 0) == (HEAP32[i32 >> 2] | 0)) if ((HEAP32[i17 + 888 >> 2] | 0) == (HEAP32[i33 >> 2] | 0)) if ((HEAP32[i17 + 892 >> 2] | 0) == (HEAP32[i34 >> 2] | 0)) if ((HEAP32[i17 + 896 >> 2] | 0) == (HEAP32[i35 >> 2] | 0)) if ((HEAP32[i17 + 900 >> 2] | 0) == (HEAP32[i36 >> 2] | 0)) if ((HEAP32[i17 + 904 >> 2] | 0) == (HEAP32[i37 >> 2] | 0)) {
    if ((HEAP32[i17 + 908 >> 2] | 0) != (HEAP32[i38 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 912 >> 2] | 0) != (HEAP32[i39 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 916 >> 2] | 0) != (HEAP32[i40 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 920 >> 2] | 0) != (HEAP32[i41 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 924 >> 2] | 0) != (HEAP32[i42 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 928 >> 2] | 0) != (HEAP32[i43 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 932 >> 2] | 0) != (HEAP32[i26 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 936 >> 2] | 0) != (HEAP32[i44 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 940 >> 2] | 0) != (HEAP32[i45 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 944 >> 2] | 0) != (HEAP32[i46 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 948 >> 2] | 0) != (HEAP32[i47 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 952 >> 2] | 0) != (HEAP32[i48 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 956 >> 2] | 0) != (HEAP32[i49 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 960 >> 2] | 0) != (HEAP32[i50 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 964 >> 2] | 0) != (HEAP32[i51 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 968 >> 2] | 0) != (HEAP32[i52 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 972 >> 2] | 0) != (HEAP32[i53 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 976 >> 2] | 0) != (HEAP32[i54 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 980 >> 2] | 0) != (HEAP32[i55 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 984 >> 2] | 0) != (HEAP32[i56 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 988 >> 2] | 0) != (HEAP32[i57 >> 2] | 0)) {
     i70 = 52;
     break;
    }
    if ((HEAP32[i17 + 992 >> 2] | 0) == (HEAP32[i58 >> 2] | 0)) {
     i8 = i20;
     i7 = i22;
     i5 = i23;
    } else i70 = 52;
   } else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; else i70 = 52; while (0);
   L60 : do if ((i70 | 0) == 52) {
    i70 = 0;
    i19 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 80300 | 0) | 0;
    i8 = (i19 | 0) != 0;
    if (i8) {
     i5 = HEAP32[i19 + 32 >> 2] | 0;
     if (!i5) {
      i14 = 0;
      i5 = 0;
     } else i14 = HEAP32[i5 + 12 >> 2] | 0;
    } else {
     i14 = 0;
     i5 = 0;
    }
    HEAP32[i17 + 616 >> 2] = i14;
    i12 = i17 + 868 | 0;
    i7 = i65;
    i11 = i12 + 64 | 0;
    do {
     HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
     i12 = i12 + 4 | 0;
     i7 = i7 + 4 | 0;
    } while ((i12 | 0) < (i11 | 0));
    i12 = i17 + 932 | 0;
    i7 = i26;
    i11 = i12 + 64 | 0;
    do {
     HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
     i12 = i12 + 4 | 0;
     i7 = i7 + 4 | 0;
    } while ((i12 | 0) < (i11 | 0));
    HEAP32[i17 + 996 >> 2] = i27;
    __ZN22ParticleSystemRenderer23UpdateVertexInputLayoutEv(i17);
    i13 = i17 + 340 | 0;
    i21 = i17 + 400 | 0;
    HEAP32[i17 + 1004 >> 2] = HEAPU16[i21 >> 1];
    i7 = i17 + 1008 | 0;
    HEAP8[i7 >> 0] = 0;
    if (i8) {
     i16 = HEAP32[i19 + 40 >> 2] | 0;
     i15 = Math_fround(HEAPF32[i16 + 316 >> 2]) < Math_fround(0.0) & 1;
     i15 = (Math_fround(HEAPF32[i16 + 320 >> 2]) < Math_fround(0.0) & 1) + i15 | 0;
     HEAP8[i7 >> 0] = (i15 + (Math_fround(HEAPF32[i16 + 324 >> 2]) < Math_fround(0.0) & 1) | 2 | 0) == 3 & 1;
    }
    i7 = (HEAP16[i13 >> 1] | 0) == 4;
    do if (i7) {
     i8 = HEAP32[i17 + 408 >> 2] | 0;
     if (i8 | 0) if (HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 92 >> 2] | 0) break;
     HEAP16[i17 + 684 >> 1] = 0;
     HEAP16[i17 + 686 >> 1] = 0;
     HEAP32[i17 + 1028 >> 2] = 0;
     i8 = i20;
     i7 = i22;
     i5 = i23;
     break L60;
    } while (0);
    if (!i14) {
     i8 = i20;
     i7 = i22;
     i5 = i23;
    } else {
     if (i7) i16 = (HEAP32[(HEAP32[i67 >> 2] | 0) + 4 >> 2] | 0) + (i6 * 788 | 0) | 0; else i16 = (HEAP32[(HEAP32[i73 >> 2] | 0) + 4 >> 2] | 0) + (i4 * 788 | 0) | 0;
     HEAP32[i16 + 748 >> 2] = i5;
     i7 = i16 + 752 | 0;
     HEAP32[i7 >> 2] = HEAP32[i19 + 860 >> 2];
     HEAP32[i16 + 756 >> 2] = HEAP32[i19 + 900 >> 2];
     HEAP32[i16 + 760 >> 2] = HEAP32[i19 + 44 >> 2];
     HEAP32[i16 + 764 >> 2] = HEAP32[i19 + 856 >> 2];
     HEAP32[i16 + 768 >> 2] = HEAP32[i19 + 896 >> 2];
     HEAP32[i16 + 772 >> 2] = HEAP32[i19 + 852 >> 2];
     HEAP32[i16 + 776 >> 2] = HEAP32[i19 + 892 >> 2];
     HEAP32[i16 + 784 >> 2] = HEAP32[i19 + 864 >> 2];
     i10 = i19 + 908 | 0;
     HEAP32[i16 + 780 >> 2] = HEAP32[i10 >> 2];
     i15 = i5 + 884 | 0;
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
     i15 = i16 + 432 | 0;
     __ZNK22ParticleSystemRenderer16PrepareForRenderER14ParticleSystemRK6CameraRK10Matrix4x4ffP23ParticleSystemParticlesR22ParticleSystemTempData(i17, i19, i64, i65, f28, 0, i16);
     i11 = HEAP32[i13 >> 2] | 0;
     HEAP16[i16 + 616 >> 1] = i11;
     HEAP16[i16 + 618 >> 1] = i11 >>> 16;
     i11 = i17 + 344 | 0;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i5 = i16 + 620 | 0;
     HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i5 + 4 >> 2] = i12;
     HEAP32[i16 + 628 >> 2] = HEAP32[i17 + 352 >> 2];
     HEAP32[i16 + 632 >> 2] = HEAP32[i17 + 356 >> 2];
     HEAP32[i16 + 636 >> 2] = HEAP32[i17 + 360 >> 2];
     HEAP32[i16 + 640 >> 2] = HEAP32[i17 + 364 >> 2];
     HEAP32[i16 + 644 >> 2] = HEAP32[i17 + 368 >> 2];
     i5 = i16 + 648 | 0;
     HEAP32[i5 >> 2] = HEAP32[i17 + 372 >> 2];
     i12 = i16 + 652 | 0;
     i11 = i17 + 376 | 0;
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     i12 = HEAP16[i17 + 388 >> 1] | 0;
     HEAP8[i16 + 664 >> 0] = i12;
     HEAP8[i16 + 665 >> 0] = (i12 & 65535) >>> 8;
     HEAP32[i16 + 668 >> 2] = HEAP32[i17 + 392 >> 2];
     HEAP32[i16 + 672 >> 2] = HEAP32[i17 + 396 >> 2];
     i12 = HEAP32[i21 >> 2] | 0;
     HEAP16[i16 + 676 >> 1] = i12;
     HEAP16[i16 + 678 >> 1] = i12 >>> 16;
     HEAP32[i16 + 680 >> 2] = HEAP32[i17 + 404 >> 2];
     HEAP32[i16 + 684 >> 2] = HEAP32[i17 + 408 >> 2];
     HEAP32[i16 + 688 >> 2] = HEAP32[i17 + 412 >> 2];
     HEAP32[i16 + 692 >> 2] = HEAP32[i17 + 416 >> 2];
     HEAP32[i16 + 696 >> 2] = HEAP32[i17 + 420 >> 2];
     HEAP16[i15 >> 1] = 0;
     if (HEAP8[i19 + 48 + 212 >> 0] | 0) HEAP32[i5 >> 2] = 2;
     if (!(HEAP8[(HEAP32[i10 >> 2] | 0) + 4 >> 0] | 0)) HEAP32[i17 + 1028 >> 2] = 0; else {
      i9 = HEAP32[(HEAP32[i76 >> 2] | 0) + 4 >> 2] | 0;
      i12 = i9 + (i3 * 268 | 0) + 24 | 0;
      i11 = i12 + 36 | 0;
      do {
       HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
       i12 = i12 + 4 | 0;
       i7 = i7 + 4 | 0;
      } while ((i12 | 0) < (i11 | 0));
      i5 = HEAP32[i10 >> 2] | 0;
      HEAP8[i9 + (i3 * 268 | 0) + 264 >> 0] = HEAP8[i5 + 286 >> 0] | 0;
      HEAP8[i9 + (i3 * 268 | 0) + 265 >> 0] = HEAP8[i5 + 288 >> 0] | 0;
      HEAP8[i9 + (i3 * 268 | 0) + 266 >> 0] = (HEAP16[i17 + 340 >> 1] | 0) == 4 & 1;
      i5 = HEAP32[i19 + 32 >> 2] | 0;
      HEAP32[i9 + (i3 * 268 | 0) + 20 >> 2] = i5;
      i12 = i9 + (i3 * 268 | 0) + 252 | 0;
      i7 = i19 + 40 | 0;
      i11 = (HEAP32[i7 >> 2] | 0) + 316 | 0;
      HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      if (!(HEAP8[(HEAP32[i10 >> 2] | 0) + 284 >> 0] | 0)) i8 = 0; else i8 = (HEAP32[(HEAP32[i19 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1;
      HEAP8[i9 + (i3 * 268 | 0) + 267 >> 0] = i8 & 1;
      i5 = i5 + 884 | 0;
      HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
      i5 = i9 + (i3 * 268 | 0) + 60 | 0;
      if (i8) {
       i95 = HEAP32[i16 + 4 >> 2] | 0;
       i94 = HEAP32[i16 + 8 >> 2] | 0;
       i93 = HEAP32[i16 + 12 >> 2] | 0;
       i92 = HEAP32[i16 + 16 >> 2] | 0;
       i91 = HEAP32[i16 + 20 >> 2] | 0;
       i90 = HEAP32[i16 + 24 >> 2] | 0;
       i89 = HEAP32[i16 + 28 >> 2] | 0;
       i88 = HEAP32[i16 + 32 >> 2] | 0;
       i87 = HEAP32[i16 + 36 >> 2] | 0;
       i86 = HEAP32[i16 + 40 >> 2] | 0;
       i85 = HEAP32[i16 + 44 >> 2] | 0;
       i84 = HEAP32[i16 + 48 >> 2] | 0;
       i8 = HEAP32[i16 + 52 >> 2] | 0;
       i11 = HEAP32[i16 + 56 >> 2] | 0;
       i12 = HEAP32[i16 + 60 >> 2] | 0;
       HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i9 + (i3 * 268 | 0) + 64 >> 2] = i95;
       HEAP32[i9 + (i3 * 268 | 0) + 68 >> 2] = i94;
       HEAP32[i9 + (i3 * 268 | 0) + 72 >> 2] = i93;
       HEAP32[i9 + (i3 * 268 | 0) + 76 >> 2] = i92;
       HEAP32[i9 + (i3 * 268 | 0) + 80 >> 2] = i91;
       HEAP32[i9 + (i3 * 268 | 0) + 84 >> 2] = i90;
       HEAP32[i9 + (i3 * 268 | 0) + 88 >> 2] = i89;
       HEAP32[i9 + (i3 * 268 | 0) + 92 >> 2] = i88;
       HEAP32[i9 + (i3 * 268 | 0) + 96 >> 2] = i87;
       HEAP32[i9 + (i3 * 268 | 0) + 100 >> 2] = i86;
       HEAP32[i9 + (i3 * 268 | 0) + 104 >> 2] = i85;
       HEAP32[i9 + (i3 * 268 | 0) + 108 >> 2] = i84;
       HEAP32[i9 + (i3 * 268 | 0) + 112 >> 2] = i8;
       HEAP32[i9 + (i3 * 268 | 0) + 116 >> 2] = i11;
       HEAP32[i9 + (i3 * 268 | 0) + 120 >> 2] = i12;
      } else {
       i8 = HEAP32[i16 + 196 >> 2] | 0;
       i11 = HEAP32[i16 + 200 >> 2] | 0;
       i12 = HEAP32[i16 + 204 >> 2] | 0;
       i84 = HEAP32[i16 + 208 >> 2] | 0;
       i85 = HEAP32[i16 + 212 >> 2] | 0;
       i86 = HEAP32[i16 + 216 >> 2] | 0;
       i87 = HEAP32[i16 + 220 >> 2] | 0;
       i88 = HEAP32[i16 + 224 >> 2] | 0;
       i89 = HEAP32[i16 + 228 >> 2] | 0;
       i90 = HEAP32[i16 + 232 >> 2] | 0;
       i91 = HEAP32[i16 + 236 >> 2] | 0;
       i92 = HEAP32[i16 + 240 >> 2] | 0;
       i93 = HEAP32[i16 + 244 >> 2] | 0;
       i94 = HEAP32[i16 + 248 >> 2] | 0;
       i95 = HEAP32[i16 + 252 >> 2] | 0;
       HEAP32[i5 >> 2] = HEAP32[i16 + 192 >> 2];
       HEAP32[i9 + (i3 * 268 | 0) + 64 >> 2] = i8;
       HEAP32[i9 + (i3 * 268 | 0) + 68 >> 2] = i11;
       HEAP32[i9 + (i3 * 268 | 0) + 72 >> 2] = i12;
       HEAP32[i9 + (i3 * 268 | 0) + 76 >> 2] = i84;
       HEAP32[i9 + (i3 * 268 | 0) + 80 >> 2] = i85;
       HEAP32[i9 + (i3 * 268 | 0) + 84 >> 2] = i86;
       HEAP32[i9 + (i3 * 268 | 0) + 88 >> 2] = i87;
       HEAP32[i9 + (i3 * 268 | 0) + 92 >> 2] = i88;
       HEAP32[i9 + (i3 * 268 | 0) + 96 >> 2] = i89;
       HEAP32[i9 + (i3 * 268 | 0) + 100 >> 2] = i90;
       HEAP32[i9 + (i3 * 268 | 0) + 104 >> 2] = i91;
       HEAP32[i9 + (i3 * 268 | 0) + 108 >> 2] = i92;
       HEAP32[i9 + (i3 * 268 | 0) + 112 >> 2] = i93;
       HEAP32[i9 + (i3 * 268 | 0) + 116 >> 2] = i94;
       HEAP32[i9 + (i3 * 268 | 0) + 120 >> 2] = i95;
      }
      i5 = HEAP32[i16 + 68 >> 2] | 0;
      i95 = HEAP32[i16 + 72 >> 2] | 0;
      i94 = HEAP32[i16 + 76 >> 2] | 0;
      i93 = HEAP32[i16 + 80 >> 2] | 0;
      i92 = HEAP32[i16 + 84 >> 2] | 0;
      i91 = HEAP32[i16 + 88 >> 2] | 0;
      i90 = HEAP32[i16 + 92 >> 2] | 0;
      i89 = HEAP32[i16 + 96 >> 2] | 0;
      i88 = HEAP32[i16 + 100 >> 2] | 0;
      i87 = HEAP32[i16 + 104 >> 2] | 0;
      i86 = HEAP32[i16 + 108 >> 2] | 0;
      i85 = HEAP32[i16 + 112 >> 2] | 0;
      i84 = HEAP32[i16 + 116 >> 2] | 0;
      i12 = HEAP32[i16 + 120 >> 2] | 0;
      i11 = HEAP32[i16 + 124 >> 2] | 0;
      HEAP32[i9 + (i3 * 268 | 0) + 124 >> 2] = HEAP32[i16 + 64 >> 2];
      HEAP32[i9 + (i3 * 268 | 0) + 128 >> 2] = i5;
      HEAP32[i9 + (i3 * 268 | 0) + 132 >> 2] = i95;
      HEAP32[i9 + (i3 * 268 | 0) + 136 >> 2] = i94;
      HEAP32[i9 + (i3 * 268 | 0) + 140 >> 2] = i93;
      HEAP32[i9 + (i3 * 268 | 0) + 144 >> 2] = i92;
      HEAP32[i9 + (i3 * 268 | 0) + 148 >> 2] = i91;
      HEAP32[i9 + (i3 * 268 | 0) + 152 >> 2] = i90;
      HEAP32[i9 + (i3 * 268 | 0) + 156 >> 2] = i89;
      HEAP32[i9 + (i3 * 268 | 0) + 160 >> 2] = i88;
      HEAP32[i9 + (i3 * 268 | 0) + 164 >> 2] = i87;
      HEAP32[i9 + (i3 * 268 | 0) + 168 >> 2] = i86;
      HEAP32[i9 + (i3 * 268 | 0) + 172 >> 2] = i85;
      HEAP32[i9 + (i3 * 268 | 0) + 176 >> 2] = i84;
      HEAP32[i9 + (i3 * 268 | 0) + 180 >> 2] = i12;
      HEAP32[i9 + (i3 * 268 | 0) + 184 >> 2] = i11;
      i11 = HEAP32[i7 >> 2] | 0;
      i12 = HEAP32[i11 + 56 >> 2] | 0;
      i84 = HEAP32[i11 + 60 >> 2] | 0;
      i85 = HEAP32[i11 + 64 >> 2] | 0;
      i86 = HEAP32[i11 + 68 >> 2] | 0;
      i87 = HEAP32[i11 + 72 >> 2] | 0;
      i88 = HEAP32[i11 + 76 >> 2] | 0;
      i89 = HEAP32[i11 + 80 >> 2] | 0;
      i90 = HEAP32[i11 + 84 >> 2] | 0;
      i91 = HEAP32[i11 + 88 >> 2] | 0;
      i92 = HEAP32[i11 + 92 >> 2] | 0;
      i93 = HEAP32[i11 + 96 >> 2] | 0;
      i94 = HEAP32[i11 + 100 >> 2] | 0;
      i95 = HEAP32[i11 + 104 >> 2] | 0;
      i7 = HEAP32[i11 + 108 >> 2] | 0;
      i5 = HEAP32[i11 + 112 >> 2] | 0;
      HEAP32[i9 + (i3 * 268 | 0) + 188 >> 2] = HEAP32[i11 + 52 >> 2];
      HEAP32[i9 + (i3 * 268 | 0) + 192 >> 2] = i12;
      HEAP32[i9 + (i3 * 268 | 0) + 196 >> 2] = i84;
      HEAP32[i9 + (i3 * 268 | 0) + 200 >> 2] = i85;
      HEAP32[i9 + (i3 * 268 | 0) + 204 >> 2] = i86;
      HEAP32[i9 + (i3 * 268 | 0) + 208 >> 2] = i87;
      HEAP32[i9 + (i3 * 268 | 0) + 212 >> 2] = i88;
      HEAP32[i9 + (i3 * 268 | 0) + 216 >> 2] = i89;
      HEAP32[i9 + (i3 * 268 | 0) + 220 >> 2] = i90;
      HEAP32[i9 + (i3 * 268 | 0) + 224 >> 2] = i91;
      HEAP32[i9 + (i3 * 268 | 0) + 228 >> 2] = i92;
      HEAP32[i9 + (i3 * 268 | 0) + 232 >> 2] = i93;
      HEAP32[i9 + (i3 * 268 | 0) + 236 >> 2] = i94;
      HEAP32[i9 + (i3 * 268 | 0) + 240 >> 2] = i95;
      HEAP32[i9 + (i3 * 268 | 0) + 244 >> 2] = i7;
      HEAP32[i9 + (i3 * 268 | 0) + 248 >> 2] = i5;
      i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + 872 >> 2] | 0;
      i7 = i17 + 1028 | 0;
      HEAP32[i7 >> 2] = i5;
      if (i5) {
       i95 = HEAP32[HEAP32[i76 >> 2] >> 2] | 0;
       HEAP32[i95 + (i3 * 20 | 0) + 8 >> 2] = i5;
       HEAP32[i95 + (i3 * 20 | 0) + 12 >> 2] = 0;
       HEAP32[i95 + (i3 * 20 | 0) + 16 >> 2] = 24;
       HEAP32[i61 + (i3 << 2) >> 2] = i18;
       HEAP32[i17 + 1032 >> 2] = i2;
       i3 = i3 + 1 | 0;
       i2 = ((HEAP32[i7 >> 2] | 0) * 24 | 0) + i2 | 0;
      }
     }
     switch (HEAP16[i13 >> 1] | 0) {
     case 5:
      {
       i8 = i20;
       i7 = i22;
       i5 = i23;
       break L60;
      }
     case 4:
      break;
     default:
      {
       i94 = HEAPU16[i21 >> 1] | 0;
       i7 = i22 + -1 + i94 | 0;
       i7 = i7 - ((i7 >>> 0) % (i94 >>> 0) | 0) | 0;
       i8 = i14 + 3 & -4;
       i95 = HEAP32[HEAP32[i73 >> 2] >> 2] | 0;
       i5 = i8 << 2;
       HEAP32[i95 + (i4 * 20 | 0) + 8 >> 2] = i5;
       HEAP32[i95 + (i4 * 20 | 0) + 12 >> 2] = 0;
       HEAP32[i95 + (i4 * 20 | 0) + 16 >> 2] = i94;
       HEAP32[i17 + 608 >> 2] = i7;
       HEAP32[i17 + 612 >> 2] = 0;
       HEAP32[i68 + (i4 << 2) >> 2] = i18;
       i8 = i20 >>> 0 < i8 >>> 0 ? i8 : i20;
       i4 = i4 + 1 | 0;
       i7 = (Math_imul(HEAPU16[i21 >> 1] | 0, i5) | 0) + i7 | 0;
       i5 = i23;
       break L60;
      }
     }
     __ZNK22ParticleSystemRenderer20PrepareForMeshRenderER26ParticleSystemTempMeshDataR14ParticleSystem(i17, i15, i19);
     i8 = HEAPU16[i21 >> 1] | 0;
     i10 = i1 + -1 + i8 | 0;
     i10 = i10 - ((i10 >>> 0) % (i8 >>> 0) | 0) | 0;
     i7 = HEAP32[HEAP32[i67 >> 2] >> 2] | 0;
     i9 = i16 + 434 | 0;
     i1 = HEAP16[i9 >> 1] | 0;
     if (!(i1 << 16 >> 16)) {
      i1 = 0;
      i5 = 0;
     } else {
      i5 = (i1 & 65535) + -1 | 0;
      i1 = HEAP32[i16 + 472 + (i5 << 2) >> 2] | 0;
      i5 = HEAP32[i16 + 504 + (i5 << 2) >> 2] | 0;
     }
     HEAP32[i7 + (i6 * 20 | 0) + 8 >> 2] = i1;
     HEAP32[i7 + (i6 * 20 | 0) + 12 >> 2] = i5;
     HEAP32[i7 + (i6 * 20 | 0) + 16 >> 2] = i8;
     HEAP32[i17 + 608 >> 2] = i10;
     HEAP32[i17 + 612 >> 2] = i23;
     i12 = i17 + 620 | 0;
     i7 = i16 + 128 | 0;
     i11 = i12 + 64 | 0;
     do {
      HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
      i12 = i12 + 4 | 0;
      i7 = i7 + 4 | 0;
     } while ((i12 | 0) < (i11 | 0));
     i1 = i16 + 332 | 0;
     HEAP32[i1 >> 2] = ((HEAP32[(HEAP32[i19 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1 & 1) << 31 | HEAP32[i1 >> 2] & 2147483647;
     _memcpy(i17 + 684 | 0, i15 | 0, 184) | 0;
     HEAP32[i59 + (i6 << 2) >> 2] = i18;
     i1 = HEAP16[i9 >> 1] | 0;
     if (!(i1 << 16 >> 16)) {
      i5 = 0;
      i1 = i10;
     } else {
      i95 = (Math_imul(HEAPU16[i21 >> 1] | 0, HEAP32[i16 + 472 + ((i1 & 65535) + -1 << 2) >> 2] | 0) | 0) + i10 | 0;
      i5 = HEAP32[i16 + 504 + ((i1 & 65535) + -1 << 2) >> 2] | 0;
      i1 = i95;
     }
     i8 = i20;
     i6 = i6 + 1 | 0;
     i7 = i22;
     i5 = (i5 << 1) + i23 | 0;
    }
   } while (0);
   i24 = i24 + 1 | 0;
   if ((i24 | 0) == (i63 | 0)) break; else {
    i22 = i7;
    i23 = i5;
    i20 = i8;
   }
  }
  if (i8) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 480 >> 0] | 0)) {
   i95 = HEAP32[i73 >> 2] | 0;
   HEAP32[(HEAP32[i95 + 4 >> 2] | 0) + (i4 * 788 | 0) + 748 >> 2] = 0;
   i95 = HEAP32[i95 >> 2] | 0;
   HEAP32[i95 + (i4 * 20 | 0) + 8 >> 2] = 0;
   HEAP32[i95 + (i4 * 20 | 0) + 12 >> 2] = (i8 >>> 0 > 16384 ? 16384 : i8) * 6;
   HEAP32[i95 + (i4 * 20 | 0) + 16 >> 2] = 1;
   HEAP32[i68 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  }
  if (!i6) i70 = 90; else {
   HEAP32[i77 >> 2] = 0;
   HEAP32[i77 + 4 >> 2] = 0;
   HEAP32[i77 + 8 >> 2] = -1;
   HEAP32[i77 + 12 >> 2] = 0;
   i95 = HEAP32[i67 >> 2] | 0;
   i2 = HEAP32[i95 + 8 >> 2] | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i60 >> 2] | 0) + 252 >> 2] | 0, i60 | 0, fb + 3226 | 0, fb + 3717 | 0, i95 | 0, i6 | 0, 0, i77 | 0);
   HEAP32[i67 >> 2] = 0;
   if ((i6 | 0) > 0) {
    i1 = 0;
    do {
     i95 = HEAP32[i59 + (i1 << 2) >> 2] | 0;
     HEAP32[i95 >> 2] = HEAP32[i77 >> 2];
     HEAP32[i95 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
     HEAP32[i95 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
     HEAP32[i95 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   i5 = HEAP32[(HEAP32[i60 >> 2] | 0) + 256 >> 2] | 0;
   HEAP32[i66 >> 2] = i2;
   HEAP32[i75 >> 2] = HEAP32[i66 >> 2];
   mftCall_vii(i5 | 0, i60 | 0, i75 | 0);
   i5 = i3;
  }
 }
 if ((i70 | 0) == 90) {
  i2 = HEAP32[i67 >> 2] | 0;
  if ((HEAP16[gb + 1452212 + 6 >> 1] | 0) > -1) {
   HEAP32[i77 >> 2] = 0;
   HEAP32[i75 >> 2] = HEAP32[i77 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452212 | 0, i75);
   i1 = gb + 1452212 | 0;
  } else i1 = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  HEAP32[i67 >> 2] = 0;
  i6 = 0;
  i5 = i3;
 }
 if (!i4) {
  i2 = HEAP32[i73 >> 2] | 0;
  if ((HEAP16[gb + 1452212 + 6 >> 1] | 0) > -1) {
   HEAP32[i77 >> 2] = 0;
   HEAP32[i75 >> 2] = HEAP32[i77 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452212 | 0, i75);
   i1 = gb + 1452212 | 0;
  } else i1 = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  HEAP32[i73 >> 2] = 0;
 } else {
  HEAP32[i77 >> 2] = 0;
  HEAP32[i77 + 4 >> 2] = 0;
  HEAP32[i77 + 8 >> 2] = -1;
  HEAP32[i77 + 12 >> 2] = 0;
  i3 = HEAP32[(HEAP32[i73 >> 2] | 0) + 8 >> 2] | 0;
  i95 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 480 >> 0] | 0) != 0;
  mftCall_viiiiiii(HEAP32[(HEAP32[i60 >> 2] | 0) + 252 >> 2] | 0, i60 | 0, fb + 3226 | 0, fb + 3717 | 0, HEAP32[i73 >> 2] | 0, i4 | 0, (i95 ? 2 : 0) | 0, i77 | 0);
  HEAP32[i73 >> 2] = 0;
  if ((i4 | 0) > 0) {
   i1 = 0;
   do {
    i2 = HEAP32[i68 + (i1 << 2) >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i2 >> 2] = HEAP32[i77 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  i95 = HEAP32[(HEAP32[i60 >> 2] | 0) + 256 >> 2] | 0;
  HEAP32[i71 >> 2] = i3;
  HEAP32[i75 >> 2] = HEAP32[i71 >> 2];
  mftCall_vii(i95 | 0, i60 | 0, i75 | 0);
 }
 if (!i5) {
  i2 = HEAP32[i76 >> 2] | 0;
  if ((HEAP16[gb + 1452212 + 6 >> 1] | 0) > -1) {
   HEAP32[i77 >> 2] = 0;
   HEAP32[i75 >> 2] = HEAP32[i77 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452212 | 0, i75);
   i1 = gb + 1452212 | 0;
  } else i1 = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  HEAP32[i76 >> 2] = 0;
 } else {
  HEAP32[i77 >> 2] = 0;
  HEAP32[i77 + 4 >> 2] = 0;
  HEAP32[i77 + 8 >> 2] = -1;
  HEAP32[i77 + 12 >> 2] = 0;
  i95 = HEAP32[i76 >> 2] | 0;
  i2 = HEAP32[i95 + 8 >> 2] | 0;
  mftCall_viiiiiii(HEAP32[(HEAP32[i60 >> 2] | 0) + 252 >> 2] | 0, i60 | 0, fb + 3227 | 0, fb + 3717 | 0, i95 | 0, i5 | 0, 1, i77 | 0);
  HEAP32[i76 >> 2] = 0;
  if ((i5 | 0) > 0) {
   i1 = 0;
   do {
    i95 = (HEAP32[i61 + (i1 << 2) >> 2] | 0) + 420 | 0;
    HEAP32[i95 >> 2] = HEAP32[i77 >> 2];
    HEAP32[i95 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
    HEAP32[i95 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
    HEAP32[i95 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  i95 = HEAP32[(HEAP32[i60 >> 2] | 0) + 256 >> 2] | 0;
  HEAP32[i74 >> 2] = i2;
  HEAP32[i75 >> 2] = HEAP32[i74 >> 2];
  mftCall_vii(i95 | 0, i60 | 0, i75 | 0);
 }
 if (i6 | i5 | i4 | 0) mftCall_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 536 >> 2] | 0, i60 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i82 >> 2] | 0, i69);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i81 >> 2] | 0, i72);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i80 >> 2] | 0, i79);
 if (!i78) {
  STACKTOP = i83;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i78);
 STACKTOP = i83;
 return;
}

function __ZN5UmbraL21buildShadowCullerImplEPNS_8QueryExtEPNS_15ImpShadowCullerEPKNS_10VisibilityEPKNS_15CameraTransformERKNS_7Vector3EPSB_iPfjPS9_i(i1, i54, i13, i19, i42, i52, i53, i18, i14, i15, i6) {
 i1 = i1 | 0;
 i54 = i54 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 i42 = i42 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f16 = f0, f17 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i55 = 0, i56 = 0, d57 = 0.0, f58 = f0, f59 = f0, f60 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i56 + 848 | 0;
 i51 = i56 + 832 | 0;
 i55 = i56 + 768 | 0;
 i46 = i56 + 704 | 0;
 i47 = i56 + 640 | 0;
 i48 = i56 + 624 | 0;
 i20 = i56 + 620 | 0;
 i28 = i56 + 608 | 0;
 i49 = i56 + 544 | 0;
 i43 = i56 + 520 | 0;
 i23 = i56 + 912 | 0;
 i40 = i56 + 424 | 0;
 i30 = i56 + 168 | 0;
 i29 = i56 + 160 | 0;
 i41 = i56 + 136 | 0;
 i45 = i56 + 72 | 0;
 i44 = i56 + 8 | 0;
 i38 = i56 + 4 | 0;
 i37 = i56;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i55 >> 2] = i5;
 i2 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i55 + 4 >> 2] = i2;
 i39 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i39 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i39 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i55 + 8 >> 2] = i1;
 HEAP32[i55 + 12 >> 2] = i1 + i4;
 i2 = i55 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i55 + 20 >> 2] = i4;
 i39 = i55 + 24 | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 HEAP32[i39 + 12 >> 2] = 0;
 HEAP32[i55 + 40 >> 2] = -1;
 i39 = HEAP32[i5 + 84 >> 2] | 0;
 HEAP32[i55 + 44 >> 2] = i39;
 HEAP32[i55 + 48 >> 2] = i39;
 HEAP32[i55 + 52 >> 2] = 0;
 HEAP32[i55 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i55 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP32[i5 >> 2] | 0)) {
  i54 = 6;
  __ZN5Umbra12QueryContextD2Ev(i55);
  STACKTOP = i56;
  return i54 | 0;
 }
 if (i6 >>> 0 > 8) {
  i54 = 3;
  __ZN5Umbra12QueryContextD2Ev(i55);
  STACKTOP = i56;
  return i54 | 0;
 }
 if ((i15 | 0) == 0 & (i6 | 0) != 0) {
  i54 = 3;
  __ZN5Umbra12QueryContextD2Ev(i55);
  STACKTOP = i56;
  return i54 | 0;
 }
 HEAP32[i54 + 34480 >> 2] = i6;
 L17 : do if ((i6 | 0) > 0) {
  i2 = i50 + 4 | 0;
  i3 = i50 + 8 | 0;
  i1 = 0;
  while (1) {
   i4 = HEAP32[i15 + (i1 << 2) >> 2] | 0;
   if (!i4) break;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii(i54 + 34496 + (i1 * 1408 | 0) | 0, i4 + 3 & -4, i50, 0, 1, 0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) break L17;
  }
  i54 = 3;
  __ZN5Umbra12QueryContextD2Ev(i55);
  STACKTOP = i56;
  return i54 | 0;
 } while (0);
 HEAP32[i54 + 34476 >> 2] = i14;
 i39 = i54 + 34460 | 0;
 HEAP32[i39 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 i39 = (i13 | 0) == 0 ? 0 : i13 + 3 & -4;
 HEAPF32[i46 >> 2] = Math_fround(1.0);
 i15 = i46 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAPF32[i46 + 20 >> 2] = Math_fround(1.0);
 i25 = i46 + 24 | 0;
 i24 = i46 + 40 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAPF32[i24 >> 2] = Math_fround(1.0);
 i25 = i46 + 44 | 0;
 i26 = i46 + 60 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAPF32[i26 >> 2] = Math_fround(1.0);
 HEAPF32[i47 >> 2] = Math_fround(1.0);
 i3 = i47 + 4 | 0;
 i4 = i47 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i5 = i47 + 24 | 0;
 i6 = i47 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 i13 = i47 + 44 | 0;
 i14 = i47 + 60 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 HEAPF32[i48 >> 2] = Math_fround(0.0);
 i21 = i48 + 4 | 0;
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 i22 = i48 + 8 | 0;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 if (!i18) f7 = Math_fround(3402823469999999843913219.0e14); else f7 = Math_fround(HEAPF32[i18 >> 2]);
 HEAPF32[i20 >> 2] = f7;
 i18 = (i39 | 0) != 0;
 if (i18) {
  i1 = HEAP32[i39 + 8 >> 2] | 0;
  if (!i1) i1 = 7; else {
   i1 = i1 + 15 & -16;
   i2 = i1;
   if (!(HEAP8[i2 + 1412 >> 0] | 0)) i1 = 7; else if (!(HEAP32[i2 + 1408 >> 2] | 0)) i1 = 7; else {
    HEAP32[i46 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i46 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i46 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i46 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i46 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i46 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i46 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i46 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
    HEAP32[i46 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
    HEAP32[i46 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
    HEAP32[i46 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
    HEAP32[i46 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
    HEAP32[i46 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
    HEAP32[i46 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
    HEAP32[i46 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
    i27 = i2 + 1184 | 0;
    HEAP32[i48 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i48 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
    HEAP32[i48 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
    __ZN5Umbra9Matrix4x46invertERKS0_(i47, i46) | 0;
    f7 = Math_fround(HEAPF32[i2 + 1416 >> 2]);
    f16 = Math_fround(Math_fround(HEAPF32[i47 + 48 >> 2]) * Math_fround(0.0));
    f16 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i47 + 52 >> 2]) * Math_fround(0.0)));
    f16 = Math_fround(f16 + Math_fround(f7 * Math_fround(HEAPF32[i47 + 56 >> 2])));
    d57 = 1.0 / +Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f16);
    f16 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) * Math_fround(0.0));
    f16 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(0.0)));
    f16 = Math_fround(f16 + Math_fround(f7 * Math_fround(HEAPF32[i47 + 8 >> 2])));
    f16 = Math_fround(d57 * +Math_fround(Math_fround(HEAPF32[i47 + 12 >> 2]) + f16));
    f17 = Math_fround(Math_fround(HEAPF32[i47 + 16 >> 2]) * Math_fround(0.0));
    f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(0.0)));
    f17 = Math_fround(f17 + Math_fround(f7 * Math_fround(HEAPF32[i5 >> 2])));
    f17 = Math_fround(d57 * +Math_fround(Math_fround(HEAPF32[i47 + 28 >> 2]) + f17));
    f12 = Math_fround(Math_fround(HEAPF32[i47 + 32 >> 2]) * Math_fround(0.0));
    f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i47 + 36 >> 2]) * Math_fround(0.0)));
    f7 = Math_fround(f12 + Math_fround(f7 * Math_fround(HEAPF32[i6 >> 2])));
    f7 = Math_fround(d57 * +Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f7));
    f16 = Math_fround(f16 - Math_fround(HEAPF32[i48 >> 2]));
    f17 = Math_fround(f17 - Math_fround(HEAPF32[i21 >> 2]));
    f7 = Math_fround(f7 - Math_fround(HEAPF32[i22 >> 2]));
    f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f7 * f7))));
    HEAPF32[i50 >> 2] = f7;
    i27 = f7 <= Math_fround(HEAPF32[i20 >> 2]);
    i27 = HEAP32[(i27 ? i50 : i20) >> 2] | 0;
    HEAP32[i20 >> 2] = i27;
    f7 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i27 = 24;
   }
  }
 } else {
  i1 = (i19 | 0) == 0 ? 0 : i19 + 3 & -4;
  if (HEAP8[i1 + 436 >> 0] | 0) __ZN5Umbra18ImpCameraTransform6updateEv(i1);
  HEAP32[i46 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i46 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i46 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i46 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i46 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i46 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i46 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i46 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i46 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i46 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i46 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i46 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i46 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
  HEAP32[i46 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
  i27 = i1 + 320 | 0;
  HEAP32[i48 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  __ZN5Umbra9Matrix4x46invertERKS0_(i47, i46) | 0;
  i27 = 24;
 }
 if ((i27 | 0) == 24) {
  f11 = Math_fround(HEAPF32[i42 >> 2]);
  f12 = Math_fround(f11 * f11);
  f16 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f16 * f16));
  f17 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f17 * f17)))));
  f16 = Math_fround(f16 * f12);
  f17 = Math_fround(f17 * f12);
  HEAPF32[i28 >> 2] = Math_fround(f11 * f12);
  HEAPF32[i28 + 4 >> 2] = f16;
  HEAPF32[i28 + 8 >> 2] = f17;
  HEAPF32[i49 >> 2] = Math_fround(1.0);
  i36 = i49 + 4 | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i36 + 4 >> 2] = 0;
  HEAP32[i36 + 8 >> 2] = 0;
  HEAP32[i36 + 12 >> 2] = 0;
  HEAPF32[i49 + 20 >> 2] = Math_fround(1.0);
  i33 = i49 + 24 | 0;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  HEAP32[i33 + 12 >> 2] = 0;
  HEAPF32[i49 + 40 >> 2] = Math_fround(1.0);
  i33 = i49 + 44 | 0;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  HEAP32[i33 + 12 >> 2] = 0;
  HEAPF32[i49 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i43 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i33 = i43 + 4 | 0;
  HEAPF32[i33 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i35 = i43 + 8 | 0;
  HEAPF32[i35 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i31 = i43 + 12 | 0;
  HEAPF32[i31 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i32 = i43 + 16 | 0;
  HEAPF32[i32 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i34 = i43 + 20 | 0;
  HEAPF32[i34 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAP8[i23 >> 0] = 1;
  i1 = i40;
  i2 = i1 + 96 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  __ZN5Umbra11ShadowUtils13getClipPlanesERKNS_9Matrix4x4EPNS_7Vector4ERb(i46, i40, i23);
  i20 = f7 < Math_fround(3402823469999999843913219.0e14);
  i1 = (HEAP8[i23 >> 0] | 0) != 0;
  if (i20) {
   if (i1) {
    f8 = Math_fround(HEAPF32[i40 + 16 >> 2]);
    f9 = Math_fround(HEAPF32[i40 + 20 >> 2]);
    f10 = Math_fround(HEAPF32[i40 + 24 >> 2]);
    i4 = i40 + 28 | 0;
    i3 = HEAP32[i40 >> 2] | 0;
    i2 = HEAP32[i40 + 4 >> 2] | 0;
    i1 = HEAP32[i40 + 8 >> 2] | 0;
   } else {
    f12 = Math_fround(HEAPF32[i40 >> 2]);
    f8 = Math_fround(-f12);
    f16 = Math_fround(HEAPF32[i40 + 4 >> 2]);
    f9 = Math_fround(-f16);
    f17 = Math_fround(HEAPF32[i40 + 8 >> 2]);
    f10 = Math_fround(-f17);
    f11 = Math_fround(-Math_fround(HEAPF32[i40 + 12 >> 2]));
    HEAPF32[i40 + 16 >> 2] = f8;
    HEAPF32[i40 + 20 >> 2] = f9;
    HEAPF32[i40 + 24 >> 2] = f10;
    i4 = i40 + 28 | 0;
    HEAPF32[i4 >> 2] = f11;
    i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f59 = Math_fround(f8 * f7);
   f58 = Math_fround(f9 * f7);
   f11 = Math_fround(f10 * f7);
   f17 = Math_fround(HEAPF32[i48 >> 2]);
   f59 = Math_fround(f17 - f59);
   f16 = Math_fround(HEAPF32[i21 >> 2]);
   f58 = Math_fround(f16 - f58);
   f12 = Math_fround(HEAPF32[i22 >> 2]);
   HEAPF32[i4 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f8 * f59) + Math_fround(f9 * f58)) + Math_fround(f10 * Math_fround(f12 - f11))));
   HEAP8[i54 + 34473 >> 0] = 1;
   f8 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f8 * f8);
   f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f11 + Math_fround(f9 * f9));
   f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f11 + Math_fround(f10 * f10));
   if (f11 != Math_fround(0.0)) {
    d57 = 1.0 / +Math_sqrt(+(+f11));
    f59 = Math_fround(+f8 * d57);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
    f59 = Math_fround(+f9 * d57);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
    f59 = Math_fround(+f10 * d57);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7);
   f59 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7);
   f58 = Math_fround(f17 + f58);
   f59 = Math_fround(f59 + f16);
   f16 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7) + f12);
   f17 = Math_fround(f58 * Math_fround(HEAPF32[i46 + 48 >> 2]));
   f17 = Math_fround(f17 + Math_fround(f59 * Math_fround(HEAPF32[i46 + 52 >> 2])));
   f17 = Math_fround(f17 + Math_fround(f16 * Math_fround(HEAPF32[i46 + 56 >> 2])));
   d57 = 1.0 / +Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f17);
   f58 = Math_fround(f58 * Math_fround(HEAPF32[i46 + 32 >> 2]));
   f59 = Math_fround(f58 + Math_fround(f59 * Math_fround(HEAPF32[i46 + 36 >> 2])));
   f16 = Math_fround(f59 + Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2])));
   f16 = Math_fround(d57 * +Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f16));
   i27 = 32;
  } else if (i1) {
   f16 = Math_fround(1.0);
   i27 = 32;
  } else i1 = 3;
  if ((i27 | 0) == 32) {
   _memset(i30 | 0, 0, 256) | 0;
   HEAP32[i29 >> 2] = 0;
   __ZN5Umbra11ShadowUtils19getShadowClipPlanesERKNS_7Vector3EPNS_7Vector4ES5_Ri(i28, i40, i30, i29);
   i2 = HEAP32[i29 >> 2] | 0;
   HEAP32[i54 + 34432 >> 2] = 0;
   HEAP32[i54 + 34436 >> 2] = 1;
   i29 = i54 + 34248 | 0;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   HEAP32[i29 + 12 >> 2] = 0;
   HEAP8[i29 + 16 >> 0] = 0;
   HEAP32[i54 + 34236 >> 2] = i2;
   if ((i2 | 0) > 0) {
    i1 = 0;
    do {
     i29 = i54 + 33168 + (i1 << 4) | 0;
     i26 = i30 + (i1 << 4) | 0;
     HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i29 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i29 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     HEAP32[i29 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
     HEAP32[i54 + 34268 + (i1 << 2) >> 2] = i1;
     i26 = HEAP32[i29 >> 2] | 0;
     i27 = HEAP32[i29 + 4 >> 2] | 0;
     i28 = HEAP32[i29 + 8 >> 2] | 0;
     i29 = HEAP32[i29 + 12 >> 2] | 0;
     HEAP32[i54 + 33520 + (i1 << 4) >> 2] = i26;
     HEAP32[i54 + 33520 + (i1 << 4) + 4 >> 2] = i27;
     HEAP32[i54 + 33520 + (i1 << 4) + 8 >> 2] = i28;
     HEAP32[i54 + 33520 + (i1 << 4) + 12 >> 2] = i29;
     i26 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
     i27 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
     i28 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
     i29 = ((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) << 31 >> 31;
     HEAP32[i54 + 33872 + (i1 << 4) >> 2] = i26 << 31 >> 31;
     HEAP32[i54 + 33872 + (i1 << 4) + 4 >> 2] = i27 << 31 >> 31;
     HEAP32[i54 + 33872 + (i1 << 4) + 8 >> 2] = i28 << 31 >> 31;
     HEAP32[i54 + 33872 + (i1 << 4) + 12 >> 2] = i29;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   HEAPF32[i54 + 34356 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i54 + 34360 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i54 + 34364 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i54 + 34368 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i54 + 34372 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i54 + 34376 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i54 + 34380 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i54 + 34384 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i27 = HEAP32[i40 + 16 >> 2] | 0;
   i28 = HEAP32[i40 + 20 >> 2] | 0;
   i29 = HEAP32[i40 + 24 >> 2] | 0;
   i30 = HEAP32[i40 + 28 >> 2] | 0;
   HEAP32[i54 + 33024 >> 2] = i27;
   HEAP32[i54 + 33028 >> 2] = i28;
   HEAP32[i54 + 33032 >> 2] = i29;
   HEAP32[i54 + 33036 >> 2] = i30;
   i27 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i28 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i29 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i30 = ((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) << 31 >> 31;
   HEAP32[i54 + 33008 >> 2] = i27 << 31 >> 31;
   HEAP32[i54 + 33012 >> 2] = i28 << 31 >> 31;
   HEAP32[i54 + 33016 >> 2] = i29 << 31 >> 31;
   HEAP32[i54 + 33020 >> 2] = i30;
   i30 = i54 + 34448 | 0;
   HEAP32[i30 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
   L55 : do if (i18) {
    HEAPF32[i41 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i14 = i41 + 4 | 0;
    HEAPF32[i14 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i15 = i41 + 8 | 0;
    HEAPF32[i15 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i41 + 12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i18 = i41 + 16 | 0;
    HEAPF32[i18 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i19 = i41 + 20 | 0;
    HEAPF32[i19 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i6 = HEAP32[HEAP32[i55 >> 2] >> 2] | 0;
    i5 = HEAP32[i6 + 20 >> 2] | 0;
    i1 = HEAP32[i6 + 24 >> 2] | 0;
    i4 = HEAP32[i6 + 28 >> 2] | 0;
    HEAP32[i50 >> 2] = i5;
    HEAP32[i51 >> 2] = i1;
    HEAP32[i45 >> 2] = i4;
    i3 = HEAP32[i6 + 32 >> 2] | 0;
    i2 = HEAP32[i6 + 36 >> 2] | 0;
    i6 = HEAP32[i6 + 40 >> 2] | 0;
    HEAP32[i44 >> 2] = i3;
    HEAP32[i38 >> 2] = i2;
    HEAP32[i37 >> 2] = i6;
    i20 = (i53 | 0) > 0;
    if (i20) {
     i13 = 0;
     do {
      f10 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f58 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f59 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i6 = i13 << 1;
      i5 = i52 + (i6 * 12 | 0) | 0;
      i1 = f10 <= Math_fround(HEAPF32[i5 >> 2]);
      i5 = HEAP32[(i1 ? i50 : i5) >> 2] | 0;
      i1 = i52 + (i6 * 12 | 0) + 4 | 0;
      i4 = f11 <= Math_fround(HEAPF32[i1 >> 2]);
      i1 = HEAP32[(i4 ? i51 : i1) >> 2] | 0;
      i4 = i52 + (i6 * 12 | 0) + 8 | 0;
      i3 = f12 <= Math_fround(HEAPF32[i4 >> 2]);
      i4 = HEAP32[(i3 ? i45 : i4) >> 2] | 0;
      HEAP32[i50 >> 2] = i5;
      HEAP32[i51 >> 2] = i1;
      HEAP32[i45 >> 2] = i4;
      i6 = i6 | 1;
      i3 = i52 + (i6 * 12 | 0) | 0;
      i2 = f17 >= Math_fround(HEAPF32[i3 >> 2]);
      i3 = HEAP32[(i2 ? i44 : i3) >> 2] | 0;
      i2 = i52 + (i6 * 12 | 0) + 4 | 0;
      i30 = f58 >= Math_fround(HEAPF32[i2 >> 2]);
      i2 = HEAP32[(i30 ? i38 : i2) >> 2] | 0;
      i6 = i52 + (i6 * 12 | 0) + 8 | 0;
      i30 = f59 >= Math_fround(HEAPF32[i6 >> 2]);
      i6 = HEAP32[(i30 ? i37 : i6) >> 2] | 0;
      HEAP32[i44 >> 2] = i3;
      HEAP32[i38 >> 2] = i2;
      HEAP32[i37 >> 2] = i6;
      i13 = i13 + 1 | 0;
     } while ((i13 | 0) != (i53 | 0));
    }
    HEAP32[i41 >> 2] = i5;
    HEAP32[i14 >> 2] = i1;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i41 + 12 >> 2] = i3;
    HEAP32[i18 >> 2] = i2;
    HEAP32[i19 >> 2] = i6;
    f59 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f59 <= (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     f59 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f58 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (!(!((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= f17) | !(f58 <= f59))) {
      HEAPF32[i45 >> 2] = Math_fround(1.0);
      i1 = i45 + 4 | 0;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = 0;
      HEAP32[i1 + 12 >> 2] = 0;
      HEAPF32[i45 + 20 >> 2] = Math_fround(1.0);
      i2 = i45 + 24 | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAPF32[i45 + 40 >> 2] = Math_fround(1.0);
      i2 = i45 + 44 | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAPF32[i45 + 60 >> 2] = Math_fround(1.0);
      HEAPF32[i44 >> 2] = Math_fround(1.0);
      i2 = i44 + 4 | 0;
      i3 = i44 + 20 | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAPF32[i3 >> 2] = Math_fround(1.0);
      i4 = i44 + 24 | 0;
      i5 = i44 + 40 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      HEAP32[i4 + 12 >> 2] = 0;
      HEAPF32[i5 >> 2] = Math_fround(1.0);
      i6 = i44 + 44 | 0;
      i13 = i44 + 60 | 0;
      HEAP32[i6 >> 2] = 0;
      HEAP32[i6 + 4 >> 2] = 0;
      HEAP32[i6 + 8 >> 2] = 0;
      HEAP32[i6 + 12 >> 2] = 0;
      HEAPF32[i13 >> 2] = Math_fround(1.0);
      __ZN5Umbra11ShadowUtils21getWorldToLightMatrixERNS_9Matrix4x4ERKS1_RKNS_7Vector3E(i49, i46, i42);
      __ZN5Umbra11ShadowUtils17getLightSpaceAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector4ERKS1_(i43, i49, i40, i41);
      f12 = Math_fround(HEAPF32[i31 >> 2]);
      f11 = Math_fround(HEAPF32[i43 >> 2]);
      do if (!(f12 <= f11)) {
       f10 = Math_fround(HEAPF32[i32 >> 2]);
       f9 = Math_fround(HEAPF32[i33 >> 2]);
       if (f10 <= f9) break;
       f8 = Math_fround(HEAPF32[i34 >> 2]);
       f7 = Math_fround(HEAPF32[i35 >> 2]);
       if (f8 <= f7) break;
       f60 = Math_fround(f11 - f12);
       f17 = Math_fround(Math_fround(Math_fround(f12 * Math_fround(2.0)) / f60) + Math_fround(1.0));
       f58 = Math_fround(f9 - f10);
       f11 = Math_fround(Math_fround(-2.0) / f58);
       f58 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(2.0)) / f58) + Math_fround(1.0));
       f12 = Math_fround(Math_fround(1.0) / Math_fround(f8 - f7));
       f59 = Math_fround(-Math_fround(f7 * f12));
       HEAPF32[i44 >> 2] = Math_fround(Math_fround(-2.0) / f60);
       HEAP32[i44 + 16 >> 2] = 0;
       HEAP32[i44 + 32 >> 2] = 0;
       HEAP32[i44 + 48 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAPF32[i3 >> 2] = f11;
       HEAP32[i44 + 36 >> 2] = 0;
       HEAP32[i44 + 52 >> 2] = 0;
       HEAP32[i44 + 8 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAPF32[i5 >> 2] = f12;
       HEAP32[i44 + 56 >> 2] = 0;
       HEAPF32[i44 + 12 >> 2] = f17;
       HEAPF32[i44 + 28 >> 2] = f58;
       HEAPF32[i6 >> 2] = f59;
       HEAP32[i13 >> 2] = 1065353216;
       HEAP32[i50 >> 2] = HEAP32[i49 >> 2];
       i28 = i50 + 4 | 0;
       HEAP32[i28 >> 2] = HEAP32[i36 >> 2];
       i29 = i50 + 8 | 0;
       HEAP32[i29 >> 2] = HEAP32[i49 + 8 >> 2];
       i30 = i50 + 12 | 0;
       HEAP32[i30 >> 2] = HEAP32[i49 + 12 >> 2];
       i31 = i50 + 16 | 0;
       HEAP32[i31 >> 2] = HEAP32[i49 + 16 >> 2];
       i32 = i50 + 20 | 0;
       HEAP32[i32 >> 2] = HEAP32[i49 + 20 >> 2];
       i33 = i50 + 24 | 0;
       HEAP32[i33 >> 2] = HEAP32[i49 + 24 >> 2];
       i34 = i50 + 28 | 0;
       HEAP32[i34 >> 2] = HEAP32[i49 + 28 >> 2];
       i35 = i50 + 32 | 0;
       HEAP32[i35 >> 2] = HEAP32[i49 + 32 >> 2];
       i36 = i50 + 36 | 0;
       HEAP32[i36 >> 2] = HEAP32[i49 + 36 >> 2];
       i37 = i50 + 40 | 0;
       HEAP32[i37 >> 2] = HEAP32[i49 + 40 >> 2];
       i38 = i50 + 44 | 0;
       HEAP32[i38 >> 2] = HEAP32[i49 + 44 >> 2];
       i40 = i50 + 48 | 0;
       HEAP32[i40 >> 2] = HEAP32[i49 + 48 >> 2];
       i41 = i50 + 52 | 0;
       HEAP32[i41 >> 2] = HEAP32[i49 + 52 >> 2];
       i42 = i50 + 56 | 0;
       HEAP32[i42 >> 2] = HEAP32[i49 + 56 >> 2];
       i43 = i50 + 60 | 0;
       HEAP32[i43 >> 2] = HEAP32[i49 + 60 >> 2];
       __ZN5Umbra9Matrix4x4mLERKS0_(i50, i44) | 0;
       HEAP32[i45 >> 2] = HEAP32[i50 >> 2];
       HEAP32[i1 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i45 + 8 >> 2] = HEAP32[i29 >> 2];
       HEAP32[i45 + 12 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i45 + 16 >> 2] = HEAP32[i31 >> 2];
       HEAP32[i45 + 20 >> 2] = HEAP32[i32 >> 2];
       HEAP32[i45 + 24 >> 2] = HEAP32[i33 >> 2];
       HEAP32[i45 + 28 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i45 + 32 >> 2] = HEAP32[i35 >> 2];
       HEAP32[i45 + 36 >> 2] = HEAP32[i36 >> 2];
       HEAP32[i45 + 40 >> 2] = HEAP32[i37 >> 2];
       HEAP32[i45 + 44 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i45 + 48 >> 2] = HEAP32[i40 >> 2];
       HEAP32[i45 + 52 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i45 + 56 >> 2] = HEAP32[i42 >> 2];
       HEAP32[i45 + 60 >> 2] = HEAP32[i43 >> 2];
       i49 = HEAP32[i39 + 8 >> 2] | 0;
       __ZN5Umbra18ReceiverMaskCuller4initERKNS_7Vector3ERKNS_9Matrix4x4ES6_S6_PKNS_18ImpOcclusionBufferEf(i54, i48, i46, i47, i45, (i49 | 0) == 0 ? 0 : i49 + 15 & -16, f16);
       HEAP8[i54 + 34472 >> 0] = 1;
       if (i20) {
        i2 = i50 + 4 | 0;
        i3 = i50 + 8 | 0;
        i4 = i51 + 4 | 0;
        i5 = i51 + 8 | 0;
        i6 = i54 + 192 | 0;
        i1 = 0;
        do {
         i49 = i1 << 1;
         HEAPF32[i50 >> 2] = Math_fround(0.0);
         HEAPF32[i2 >> 2] = Math_fround(0.0);
         HEAPF32[i3 >> 2] = Math_fround(0.0);
         HEAPF32[i51 >> 2] = Math_fround(0.0);
         HEAPF32[i4 >> 2] = Math_fround(0.0);
         HEAPF32[i5 >> 2] = Math_fround(0.0);
         __ZNK5Umbra18ReceiverMaskCuller21computeLightSpaceAABBERNS_7Vector3ES2_RKS1_S4_(i54, i50, i51, i52 + (i49 * 12 | 0) | 0, i52 + ((i49 | 1) * 12 | 0) | 0);
         __ZN5Umbra12ReceiverMask7addAABBERKNS_7Vector3ES3_(i6, i50, i51) | 0;
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != (i53 | 0));
       }
       i2 = HEAP32[i39 + 24 >> 2] | 0;
       do if (!i2) {
        if (!(HEAP32[i39 >> 2] | 0)) break;
        i1 = HEAP32[(HEAP32[HEAP32[i55 >> 2] >> 2] | 0) + 64 >> 2] | 0;
        i53 = (i1 | 0) < 59905;
        HEAP8[i54 + 34474 >> 0] = i53 & 1;
        if (!i53) break;
        _memset(i54 + 45760 | 0, 0, i1 + 31 >> 5 << 2 | 0) | 0;
        i3 = HEAP32[i39 >> 2] | 0;
        i3 = (i3 | 0) == 0 ? 0 : i3 + 3 & -4;
        i2 = HEAP32[i3 >> 2] | 0;
        i53 = HEAP32[i3 + 8 >> 2] | 0;
        i3 = HEAP32[i3 + 4 >> 2] | 0;
        i3 = (i53 | 0) <= (i3 | 0) ? i53 : i3;
        if ((i3 | 0) > 0) i1 = 0; else break;
        do {
         i52 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
         i53 = i54 + 45760 + (i52 >> 5 << 2) | 0;
         HEAP32[i53 >> 2] = 1 << (i52 & 31) | HEAP32[i53 >> 2];
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) < (i3 | 0));
       } else {
        i1 = HEAP32[(HEAP32[HEAP32[i55 >> 2] >> 2] | 0) + 64 >> 2] | 0;
        i53 = (i1 | 0) < 59905;
        HEAP8[i54 + 34474 >> 0] = i53 & 1;
        if (!i53) break;
        _memcpy(i54 + 45760 | 0, i2 | 0, i1 + 31 >> 5 << 2 | 0) | 0;
       } while (0);
       break L55;
      } while (0);
      break;
     }
    }
   } while (0);
   i1 = 0;
  }
 }
 i54 = i1;
 __ZN5Umbra12QueryContextD2Ev(i55);
 STACKTOP = i56;
 return i54 | 0;
}

function __ZN8Animator21ProcessAnimationsStepEv(i22) {
 i22 = i22 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i23 + 56 | 0;
 i5 = i23 + 48 | 0;
 i2 = i23 + 36 | 0;
 i3 = i23 + 16 | 0;
 i10 = i23;
 if ((HEAP16[gb + 1466956 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i22;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466956 | 0, i4);
  i21 = gb + 1466956 | 0;
 } else i21 = 0;
 i11 = i22 + 272 | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i22 + 284 >> 2] = Math_fround(0.0);
 i11 = i22 + 288 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 i12 = i22 + 292 | 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 i13 = i22 + 296 | 0;
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 i9 = i22 + 300 | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i9 = i22 + 312 | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 4 | 0;
 HEAP8[i9 >> 0] = 0;
 i19 = i22 + 128 | 0;
 HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
 HEAP8[i4 + 4 >> 0] = 0;
 __ZN7mecanim5human12FullBodyMaskEv(i2);
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i3 + 4 + 12 >> 2] = 0;
 i18 = i22 + 132 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 24 >> 2];
 if (!(HEAP8[(HEAP32[i19 >> 2] | 0) + 17 >> 0] | 0)) i2 = HEAP32[i2 + 20 >> 2] | 0; else i2 = 0;
 HEAP32[i3 + 16 >> 2] = i2;
 HEAP32[i5 >> 2] = i3;
 i2 = HEAP32[i22 + 624 >> 2] | 0;
 if (!i2) i2 = HEAP32[(HEAP32[i22 + 628 >> 2] | 0) + 20 >> 2] | 0;
 if (HEAP8[i2 + 73 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, i22 + 40 | 0, 0);
 i3 = i22 + 40 | 0;
 if (HEAP8[i2 + 74 >> 0] | 0) __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(i2, i3);
 __Z30AnimationPlayableEvaluateBeginP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i3, i4, i5);
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
 __Z28AnimationPlayableEvaluateEndP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i3, i4, i5);
 i16 = HEAP32[i19 >> 2] | 0;
 HEAP8[i16 + 19 >> 0] = HEAP8[i9 >> 0] | 0;
 i17 = i22 + 136 | 0;
 i14 = i22 + 140 | 0;
 __ZN7mecanim9animation16EvaluateAvatarDXEPKNS0_25ControllerBindingConstantEPKNS0_11AvatarInputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEPNS0_12AvatarOutputE(HEAP32[(HEAP32[i22 + 168 >> 2] | 0) + 32 >> 2] | 0, i16, HEAP32[i17 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i18 >> 2] | 0);
 i16 = i22 + 124 | 0;
 i2 = (HEAP32[i16 >> 2] | 0) + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i2 = i2 + i3 | 0;
  i15 = i2 + 40 | 0;
  if (HEAP32[(HEAP32[i15 >> 2] | 0) + i15 >> 2] | 0) {
   i15 = HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i2 + 360 >> 2]);
   i5 = i15 + 292 | 0;
   f6 = Math_fround(f8 * Math_fround(HEAPF32[i5 >> 2]));
   i9 = i15 + 296 | 0;
   f7 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
   i15 = i15 + 300 | 0;
   f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
   HEAPF32[i5 >> 2] = f6;
   HEAPF32[i9 >> 2] = f7;
   HEAPF32[i15 >> 2] = f8;
  }
 }
 __ZN8Animator11TargetMatchEv(i22);
 HEAP8[i22 + 416 >> 0] = 0;
 i15 = i22 + 74 | 0;
 do if (!(HEAP8[i15 >> 0] | 0)) {
  if (!(HEAP8[i22 + 73 >> 0] | 0)) {
   if (!(HEAP8[i22 + 76 >> 0] | 0)) break;
   if (!(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0)) break;
  }
  i9 = i22 + 153 | 0;
  if (!(HEAP8[i9 >> 0] | 0)) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   i5 = HEAP32[i17 >> 2] | 0;
   f1 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f26 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f24 = Math_fround(f8 * f8);
   f25 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f24 = Math_fround(Math_fround(f26 + f6) + Math_fround(f24 + Math_fround(f25 * f25)));
   f6 = Math_fround(Math_sqrt(Math_fround(f24)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f25 / f6);
   i5 = f24 > Math_fround(1.0e-30);
   f1 = i5 ? f1 : Math_fround(0.0);
   f7 = i5 ? f7 : Math_fround(0.0);
   f8 = i5 ? f8 : Math_fround(0.0);
   f6 = i5 ? f6 : Math_fround(1.0);
  }
  __ZN7mecanim9animation28MotionOutputGetDeltaPositionEPKNS0_12MotionOutputE(i10, HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0);
  i2 = HEAP32[i17 >> 2] | 0;
  f34 = Math_fround(HEAPF32[i10 >> 2]);
  f35 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f26 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f24 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f26 = Math_fround(f34 * f26);
  f24 = Math_fround(f35 * f24);
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i2 + 36 >> 2]));
  f35 = Math_fround(f1 * Math_fround(2.0));
  f34 = Math_fround(f7 * Math_fround(2.0));
  f33 = Math_fround(f8 * Math_fround(2.0));
  f31 = Math_fround(f1 * f35);
  f28 = Math_fround(f7 * f34);
  f27 = Math_fround(f8 * f33);
  f25 = Math_fround(f1 * f34);
  f30 = Math_fround(f1 * f33);
  f32 = Math_fround(f7 * f33);
  f8 = Math_fround(f35 * f6);
  f7 = Math_fround(f34 * f6);
  f1 = Math_fround(f6 * f33);
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f25 + f1) * f26) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f31 + f27)) * f24)) + Math_fround(Math_fround(f32 - f8) * f29));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f30 - f7) * f26) + Math_fround(Math_fround(f32 + f8) * f24)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f31 + f28)) * f29));
  HEAPF32[i22 + 272 >> 2] = Math_fround(Math_fround(Math_fround(f30 + f7) * f29) + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f28 + f27)) * f26) + Math_fround(Math_fround(f25 - f1) * f24)));
  HEAPF32[i22 + 276 >> 2] = f6;
  HEAPF32[i22 + 280 >> 2] = f8;
  __ZN7mecanim9animation28MotionOutputGetDeltaRotationEPKNS0_12MotionOutputE(i10, HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0);
  f8 = Math_fround(HEAPF32[i10 >> 2]);
  f6 = Math_fround(f8 * f8);
  f24 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f1 = Math_fround(f24 * f24);
  f25 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f26 = Math_fround(f25 * f25);
  f7 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f26 = Math_fround(Math_fround(f6 + f1) + Math_fround(f26 + Math_fround(f7 * f7)));
  f1 = Math_fround(Math_sqrt(Math_fround(f26)));
  f8 = Math_fround(f8 / f1);
  f24 = Math_fround(f24 / f1);
  f25 = Math_fround(f25 / f1);
  f1 = Math_fround(f7 / f1);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = f26 > Math_fround(1.0e-30);
  i10 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i22 + 284 >> 2] = i5 ? i2 : 0;
  HEAP32[i11 >> 2] = i5 ? i3 : 0;
  HEAP32[i12 >> 2] = i5 ? i4 : 0;
  HEAP32[i13 >> 2] = i10;
  i3 = (HEAP8[i9 >> 0] | 0) == 0;
  i2 = HEAP32[i17 >> 2] | 0;
  if (i3) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f33 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f35 = Math_fround(f8 * f8);
   f34 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f35 = Math_fround(Math_fround(f33 + f6) + Math_fround(f35 + Math_fround(f34 * f34)));
   f6 = Math_fround(Math_sqrt(Math_fround(f35)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f34 / f6);
   i13 = f35 > Math_fround(1.0e-30);
   f1 = i13 ? f1 : Math_fround(0.0);
   f7 = i13 ? f7 : Math_fround(0.0);
   f8 = i13 ? f8 : Math_fround(0.0);
   f6 = i13 ? f6 : Math_fround(1.0);
  }
  i4 = (HEAP32[i18 >> 2] | 0) + 16 | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f27 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f33 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f30 = Math_fround(f26 * f30);
  f33 = Math_fround(f24 * f33);
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i2 + 36 >> 2]));
  f24 = Math_fround(f1 * Math_fround(2.0));
  f26 = Math_fround(f7 * Math_fround(2.0));
  f32 = Math_fround(f8 * Math_fround(2.0));
  f35 = Math_fround(f1 * f24);
  f28 = Math_fround(f7 * f26);
  f29 = Math_fround(f8 * f32);
  f31 = Math_fround(f1 * f26);
  f25 = Math_fround(f1 * f32);
  f8 = Math_fround(f7 * f32);
  f24 = Math_fround(f24 * f6);
  f26 = Math_fround(f26 * f6);
  f32 = Math_fround(f6 * f32);
  f34 = Math_fround(Math_fround(Math_fround(Math_fround(f31 + f32) * f30) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f35 + f29)) * f33)) + Math_fround(Math_fround(f8 - f24) * f27));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(f25 - f26) * f30) + Math_fround(Math_fround(f8 + f24) * f33)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f35 + f28)) * f27));
  HEAPF32[i22 + 300 >> 2] = Math_fround(Math_fround(Math_fround(f25 + f26) * f27) + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f28 + f29)) * f30) + Math_fround(Math_fround(f31 - f32) * f33)));
  HEAPF32[i22 + 304 >> 2] = f34;
  HEAPF32[i22 + 308 >> 2] = f35;
  if (i3) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f33 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f35 = Math_fround(f8 * f8);
   f34 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f35 = Math_fround(Math_fround(f33 + f6) + Math_fround(f35 + Math_fround(f34 * f34)));
   f6 = Math_fround(Math_sqrt(Math_fround(f35)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f34 / f6);
   i13 = f35 > Math_fround(1.0e-30);
   f1 = i13 ? f1 : Math_fround(0.0);
   f7 = i13 ? f7 : Math_fround(0.0);
   f8 = i13 ? f8 : Math_fround(0.0);
   f6 = i13 ? f6 : Math_fround(1.0);
  }
  i13 = HEAP32[i4 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i13 + 16 >> 2]);
  f33 = Math_fround(HEAPF32[i13 + 20 >> 2]);
  f27 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  f24 = Math_fround(f1 * Math_fround(2.0));
  f26 = Math_fround(f7 * Math_fround(2.0));
  f32 = Math_fround(f8 * Math_fround(2.0));
  f35 = Math_fround(f1 * f24);
  f29 = Math_fround(f7 * f26);
  f30 = Math_fround(f8 * f32);
  f31 = Math_fround(f1 * f26);
  f25 = Math_fround(f1 * f32);
  f8 = Math_fround(f7 * f32);
  f24 = Math_fround(f24 * f6);
  f26 = Math_fround(f26 * f6);
  f32 = Math_fround(f6 * f32);
  f34 = Math_fround(Math_fround(Math_fround(Math_fround(f31 + f32) * f28) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f35 + f30)) * f33)) + Math_fround(Math_fround(f8 - f24) * f27));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(f25 - f26) * f28) + Math_fround(Math_fround(f8 + f24) * f33)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f35 + f29)) * f27));
  HEAPF32[i22 + 312 >> 2] = Math_fround(Math_fround(Math_fround(f25 + f26) * f27) + Math_fround(Math_fround(f28 * Math_fround(Math_fround(1.0) - Math_fround(f29 + f30))) + Math_fround(Math_fround(f31 - f32) * f33)));
  HEAPF32[i22 + 316 >> 2] = f34;
  HEAPF32[i22 + 320 >> 2] = f35;
 } else {
  i9 = i22 + 153 | 0;
  if (!(HEAP8[i9 >> 0] | 0)) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   i5 = HEAP32[i17 >> 2] | 0;
   f1 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f33 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f35 = Math_fround(f8 * f8);
   f34 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f35 = Math_fround(Math_fround(f33 + f6) + Math_fround(f35 + Math_fround(f34 * f34)));
   f6 = Math_fround(Math_sqrt(Math_fround(f35)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f34 / f6);
   i5 = f35 > Math_fround(1.0e-30);
   f1 = i5 ? f1 : Math_fround(0.0);
   f7 = i5 ? f7 : Math_fround(0.0);
   f8 = i5 ? f8 : Math_fround(0.0);
   f6 = i5 ? f6 : Math_fround(1.0);
  }
  __ZN7mecanim9animation28MotionOutputGetDeltaPositionEPKNS0_12MotionOutputE(i10, HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0);
  i2 = HEAP32[i17 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i10 >> 2]);
  f28 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f33 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f31 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f33 = Math_fround(f27 * f33);
  f31 = Math_fround(f28 * f31);
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i2 + 36 >> 2]));
  i2 = (HEAP32[i16 >> 2] | 0) + 20 | 0;
  f28 = Math_fround(HEAPF32[i2 + (HEAP32[i2 >> 2] | 0) + 360 >> 2]);
  f33 = Math_fround(f33 * f28);
  f31 = Math_fround(f31 * f28);
  f28 = Math_fround(f32 * f28);
  f32 = Math_fround(f1 * Math_fround(2.0));
  f27 = Math_fround(f7 * Math_fround(2.0));
  f30 = Math_fround(f8 * Math_fround(2.0));
  f24 = Math_fround(f1 * f32);
  f35 = Math_fround(f7 * f27);
  f34 = Math_fround(f8 * f30);
  f29 = Math_fround(f1 * f27);
  f26 = Math_fround(f1 * f30);
  f25 = Math_fround(f7 * f30);
  f32 = Math_fround(f32 * f6);
  f27 = Math_fround(f27 * f6);
  f1 = Math_fround(f6 * f30);
  f30 = Math_fround(Math_fround(Math_fround(f25 - f32) * f28) + Math_fround(Math_fround(Math_fround(f29 + f1) * f33) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f24 + f34)) * f31)));
  f32 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f24 + f35)) * f28) + Math_fround(Math_fround(Math_fround(f26 - f27) * f33) + Math_fround(Math_fround(f25 + f32) * f31)));
  HEAPF32[i22 + 272 >> 2] = Math_fround(Math_fround(Math_fround(f26 + f27) * f28) + Math_fround(Math_fround(Math_fround(f29 - f1) * f31) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f35 + f34)) * f33)));
  HEAPF32[i22 + 276 >> 2] = f30;
  HEAPF32[i22 + 280 >> 2] = f32;
  __ZN7mecanim9animation28MotionOutputGetDeltaRotationEPKNS0_12MotionOutputE(i10, HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0);
  f32 = Math_fround(HEAPF32[i10 >> 2]);
  f30 = Math_fround(f32 * f32);
  f33 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f1 = Math_fround(f33 * f33);
  f34 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f35 = Math_fround(f34 * f34);
  f31 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f35 = Math_fround(Math_fround(f30 + f1) + Math_fround(f35 + Math_fround(f31 * f31)));
  f1 = Math_fround(Math_sqrt(Math_fround(f35)));
  f32 = Math_fround(f32 / f1);
  f33 = Math_fround(f33 / f1);
  f34 = Math_fround(f34 / f1);
  f1 = Math_fround(f31 / f1);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = f35 > Math_fround(1.0e-30);
  i10 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i22 + 284 >> 2] = i5 ? i2 : 0;
  HEAP32[i11 >> 2] = i5 ? i3 : 0;
  HEAP32[i12 >> 2] = i5 ? i4 : 0;
  HEAP32[i13 >> 2] = i10;
  i3 = (HEAP8[i9 >> 0] | 0) == 0;
  i2 = HEAP32[i17 >> 2] | 0;
  if (i3) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f33 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f35 = Math_fround(f8 * f8);
   f34 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f35 = Math_fround(Math_fround(f33 + f6) + Math_fround(f35 + Math_fround(f34 * f34)));
   f6 = Math_fround(Math_sqrt(Math_fround(f35)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f34 / f6);
   i13 = f35 > Math_fround(1.0e-30);
   f1 = i13 ? f1 : Math_fround(0.0);
   f7 = i13 ? f7 : Math_fround(0.0);
   f8 = i13 ? f8 : Math_fround(0.0);
   f6 = i13 ? f6 : Math_fround(1.0);
  }
  i4 = (HEAP32[i18 >> 2] | 0) + 16 | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f35 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f33 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f33 = Math_fround(f26 * f33);
  f30 = Math_fround(f27 * f30);
  f35 = Math_fround(f35 * Math_fround(HEAPF32[i2 + 36 >> 2]));
  i13 = (HEAP32[i16 >> 2] | 0) + 20 | 0;
  f27 = Math_fround(HEAPF32[i13 + (HEAP32[i13 >> 2] | 0) + 360 >> 2]);
  f33 = Math_fround(f33 * f27);
  f30 = Math_fround(f30 * f27);
  f27 = Math_fround(f35 * f27);
  f35 = Math_fround(f1 * Math_fround(2.0));
  f26 = Math_fround(f7 * Math_fround(2.0));
  f29 = Math_fround(f8 * Math_fround(2.0));
  f36 = Math_fround(f1 * f35);
  f31 = Math_fround(f7 * f26);
  f32 = Math_fround(f8 * f29);
  f28 = Math_fround(f1 * f26);
  f25 = Math_fround(f1 * f29);
  f24 = Math_fround(f7 * f29);
  f35 = Math_fround(f35 * f6);
  f26 = Math_fround(f26 * f6);
  f29 = Math_fround(f6 * f29);
  f34 = Math_fround(Math_fround(Math_fround(f24 - f35) * f27) + Math_fround(Math_fround(Math_fround(f28 + f29) * f33) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f36 + f32)) * f30)));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f36 + f31)) * f27) + Math_fround(Math_fround(Math_fround(f25 - f26) * f33) + Math_fround(Math_fround(f24 + f35) * f30)));
  HEAPF32[i22 + 300 >> 2] = Math_fround(Math_fround(Math_fround(f25 + f26) * f27) + Math_fround(Math_fround(Math_fround(f28 - f29) * f30) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f31 + f32)) * f33)));
  HEAPF32[i22 + 304 >> 2] = f34;
  HEAPF32[i22 + 308 >> 2] = f35;
  if (i3) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  } else {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f34 = Math_fround(f1 * f1);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f6 = Math_fround(f7 * f7);
   f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f36 = Math_fround(f8 * f8);
   f35 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f36 = Math_fround(Math_fround(f34 + f6) + Math_fround(f36 + Math_fround(f35 * f35)));
   f6 = Math_fround(Math_sqrt(Math_fround(f36)));
   f1 = Math_fround(f1 / f6);
   f7 = Math_fround(f7 / f6);
   f8 = Math_fround(f8 / f6);
   f6 = Math_fround(f35 / f6);
   i13 = f36 > Math_fround(1.0e-30);
   f1 = i13 ? f1 : Math_fround(0.0);
   f7 = i13 ? f7 : Math_fround(0.0);
   f8 = i13 ? f8 : Math_fround(0.0);
   f6 = i13 ? f6 : Math_fround(1.0);
  }
  i13 = HEAP32[i4 >> 2] | 0;
  f29 = Math_fround(HEAPF32[i13 + 16 >> 2]);
  f34 = Math_fround(HEAPF32[i13 + 20 >> 2]);
  f28 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  f25 = Math_fround(f1 * Math_fround(2.0));
  f27 = Math_fround(f7 * Math_fround(2.0));
  f33 = Math_fround(f8 * Math_fround(2.0));
  f36 = Math_fround(f1 * f25);
  f30 = Math_fround(f7 * f27);
  f31 = Math_fround(f8 * f33);
  f32 = Math_fround(f1 * f27);
  f26 = Math_fround(f1 * f33);
  f24 = Math_fround(f7 * f33);
  f25 = Math_fround(f25 * f6);
  f27 = Math_fround(f27 * f6);
  f33 = Math_fround(f6 * f33);
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(f32 + f33) * f29) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f36 + f31)) * f34)) + Math_fround(Math_fround(f24 - f25) * f28));
  f36 = Math_fround(Math_fround(Math_fround(Math_fround(f26 - f27) * f29) + Math_fround(Math_fround(f24 + f25) * f34)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f36 + f30)) * f28));
  HEAPF32[i22 + 312 >> 2] = Math_fround(Math_fround(Math_fround(f26 + f27) * f28) + Math_fround(Math_fround(f29 * Math_fround(Math_fround(1.0) - Math_fround(f30 + f31))) + Math_fround(Math_fround(f32 - f33) * f34)));
  HEAPF32[i22 + 316 >> 2] = f35;
  HEAPF32[i22 + 320 >> 2] = f36;
 } while (0);
 if (!(HEAP8[i15 >> 0] | 0)) {
  if (HEAP8[i22 + 73 >> 0] | 0) i20 = 35;
 } else i20 = 35;
 if ((i20 | 0) == 35) {
  __ZN7mecanim9animation15EvaluateAvatarXEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(HEAP32[i16 >> 2] | 0, HEAP32[i19 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i14 >> 2] | 0);
  i19 = HEAP32[i17 >> 2] | 0;
  i2 = (HEAP32[i18 >> 2] | 0) + 16 | 0;
  i20 = HEAP32[i2 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i20 + 292 >> 2]);
  f33 = Math_fround(HEAPF32[i20 + 296 >> 2]);
  f27 = Math_fround(HEAPF32[i20 + 300 >> 2]);
  f25 = Math_fround(HEAPF32[i19 + 28 >> 2]);
  f32 = Math_fround(HEAPF32[i19 + 32 >> 2]);
  f25 = Math_fround(f1 * f25);
  f32 = Math_fround(f33 * f32);
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i19 + 36 >> 2]));
  i20 = i19 + 16 | 0;
  f33 = Math_fround(HEAPF32[i20 >> 2]);
  i4 = i19 + 12 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i19 + 24 | 0;
  f36 = Math_fround(HEAPF32[i5 >> 2]);
  i3 = i19 + 20 | 0;
  f24 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(f33 * Math_fround(-2.0));
  f30 = Math_fround(f33 * Math_fround(2.0));
  f26 = Math_fround(f8 * f36);
  f31 = Math_fround(f24 * Math_fround(2.0));
  f28 = Math_fround(f24 * Math_fround(-2.0));
  f7 = Math_fround(f36 * f28);
  f35 = Math_fround(f1 * Math_fround(-2.0));
  f29 = Math_fround(f1 * Math_fround(2.0));
  f36 = Math_fround(f36 * f35);
  f34 = Math_fround(Math_fround(f25 + Math_fround(f25 * Math_fround(Math_fround(f33 * f8) - Math_fround(f24 * f31)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f29 * f24) - f26)) + Math_fround(f32 * Math_fround(f7 - Math_fround(f33 * f35)))));
  f29 = Math_fround(Math_fround(f32 + Math_fround(f25 * Math_fround(Math_fround(f1 * f30) - f7))) + Math_fround(Math_fround(f27 * Math_fround(f36 - Math_fround(f8 * f24))) + Math_fround(f32 * Math_fround(Math_fround(f24 * f28) - Math_fround(f1 * f29)))));
  f36 = Math_fround(Math_fround(f27 + Math_fround(f25 * Math_fround(f26 - Math_fround(f1 * f28)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f1 * f35) - Math_fround(f33 * f30))) + Math_fround(f32 * Math_fround(Math_fround(f33 * f31) - f36))));
  f31 = Math_fround(HEAPF32[i19 >> 2]);
  f33 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f29 = Math_fround(f33 + f29);
  f36 = Math_fround(Math_fround(HEAPF32[i19 + 8 >> 2]) + f36);
  HEAPF32[i22 + 336 >> 2] = Math_fround(f31 + f34);
  HEAPF32[i22 + 340 >> 2] = f29;
  HEAPF32[i22 + 344 >> 2] = f36;
  i2 = HEAP32[i2 >> 2] | 0;
  f36 = Math_fround(HEAPF32[i20 >> 2]);
  f29 = Math_fround(HEAPF32[i2 + 304 >> 2]);
  f34 = Math_fround(f36 * f29);
  f31 = Math_fround(HEAPF32[i5 >> 2]);
  f33 = Math_fround(HEAPF32[i2 + 316 >> 2]);
  f32 = Math_fround(f31 * f33);
  f30 = Math_fround(HEAPF32[i3 >> 2]);
  f35 = Math_fround(HEAPF32[i2 + 308 >> 2]);
  f1 = Math_fround(f30 * f35);
  f27 = Math_fround(HEAPF32[i4 >> 2]);
  f28 = Math_fround(HEAPF32[i2 + 312 >> 2]);
  f34 = Math_fround(Math_fround(Math_fround(f34 - Math_fround(f31 * f28)) - Math_fround(f33 * f30)) - Math_fround(f35 * f27));
  f32 = Math_fround(Math_fround(Math_fround(f32 - Math_fround(f29 * f27)) - Math_fround(f30 * f28)) - Math_fround(f36 * f35));
  f1 = Math_fround(Math_fround(Math_fround(f1 - Math_fround(f36 * f28)) - Math_fround(f29 * f31)) - Math_fround(f33 * f27));
  f33 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f28) - Math_fround(f29 * f30)) - Math_fround(f31 * f35)) - Math_fround(f36 * f33));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f33 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(f33 * f33);
  f34 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = Math_fround(f34 * f34);
  f35 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 + f36) + Math_fround(Math_fround(f32 * f32) + Math_fround(f35 * f35))))));
  f33 = Math_fround(f36 * f33);
  f34 = Math_fround(f36 * f34);
  f35 = Math_fround(f36 * f35);
  f32 = Math_fround(f36 * f32);
  f36 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(Math_fround(f32 * f32) + Math_fround(f35 * f35)));
  f1 = Math_fround(Math_sqrt(Math_fround(f36)));
  f33 = Math_fround(f33 / f1);
  f34 = Math_fround(f34 / f1);
  f35 = Math_fround(f35 / f1);
  f1 = Math_fround(f32 / f1);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = f36 > Math_fround(1.0e-30);
  i20 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i22 + 348 >> 2] = i5 ? i2 : 0;
  HEAP32[i22 + 352 >> 2] = i5 ? i3 : 0;
  HEAP32[i22 + 356 >> 2] = i5 ? i4 : 0;
  HEAP32[i22 + 360 >> 2] = i20;
  if (!(HEAP8[i15 >> 0] | 0)) f1 = Math_fround(1.0); else {
   i20 = (HEAP32[i16 >> 2] | 0) + 20 | 0;
   f1 = Math_fround(HEAPF32[i20 + (HEAP32[i20 >> 2] | 0) + 360 >> 2]);
  }
  i20 = HEAP32[i17 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i20 + 120 >> 2]);
  f32 = Math_fround(HEAPF32[i20 + 124 >> 2]);
  f28 = Math_fround(f1 * f28);
  f32 = Math_fround(f1 * f32);
  f27 = Math_fround(f1 * Math_fround(HEAPF32[i20 + 128 >> 2]));
  f24 = Math_fround(HEAPF32[i20 + 28 >> 2]);
  f31 = Math_fround(HEAPF32[i20 + 32 >> 2]);
  f24 = Math_fround(f28 * f24);
  f31 = Math_fround(f32 * f31);
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i20 + 36 >> 2]));
  f32 = Math_fround(HEAPF32[i20 + 16 >> 2]);
  f28 = Math_fround(HEAPF32[i20 + 12 >> 2]);
  f36 = Math_fround(HEAPF32[i20 + 24 >> 2]);
  f8 = Math_fround(HEAPF32[i20 + 20 >> 2]);
  f7 = Math_fround(f32 * Math_fround(-2.0));
  f30 = Math_fround(f32 * Math_fround(2.0));
  f25 = Math_fround(f7 * f36);
  f33 = Math_fround(f8 * Math_fround(2.0));
  f26 = Math_fround(f8 * Math_fround(-2.0));
  f6 = Math_fround(f36 * f26);
  f29 = Math_fround(f28 * Math_fround(-2.0));
  f35 = Math_fround(f28 * Math_fround(2.0));
  f36 = Math_fround(f36 * f29);
  f34 = Math_fround(Math_fround(f24 + Math_fround(f24 * Math_fround(Math_fround(f32 * f7) - Math_fround(f8 * f33)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f35 * f8) - f25)) + Math_fround(f31 * Math_fround(f6 - Math_fround(f32 * f29)))));
  f35 = Math_fround(Math_fround(f31 + Math_fround(f24 * Math_fround(Math_fround(f28 * f30) - f6))) + Math_fround(Math_fround(f27 * Math_fround(f36 - Math_fround(f7 * f8))) + Math_fround(f31 * Math_fround(Math_fround(f8 * f26) - Math_fround(f28 * f35)))));
  f36 = Math_fround(Math_fround(f27 + Math_fround(f24 * Math_fround(f25 - Math_fround(f28 * f26)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f28 * f29) - Math_fround(f32 * f30))) + Math_fround(f31 * Math_fround(Math_fround(f32 * f33) - f36))));
  f33 = Math_fround(HEAPF32[i20 >> 2]);
  f32 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f35 = Math_fround(f32 + f35);
  f36 = Math_fround(Math_fround(HEAPF32[i20 + 8 >> 2]) + f36);
  HEAPF32[i22 + 324 >> 2] = Math_fround(f33 + f34);
  HEAPF32[i22 + 328 >> 2] = f35;
  HEAPF32[i22 + 332 >> 2] = f36;
 }
 if (!i21) {
  STACKTOP = i23;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i21);
 STACKTOP = i23;
 return;
}

function __Z22PerformPlaneCollisionsRK13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesRK33ParticleSystemCollisionParametersR5RandNRKf(i90, i91, i96, i100, i83, i44, i97) {
 i90 = i90 | 0;
 i91 = i91 | 0;
 i96 = i96 | 0;
 i100 = i100 | 0;
 i83 = i83 | 0;
 i44 = i44 | 0;
 i97 = i97 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i98 = 0, i99 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0;
 i104 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i101 = i104 + 128 | 0;
 i102 = i104 + 116 | 0;
 i103 = i104 + 104 | 0;
 i92 = i104 + 80 | 0;
 i93 = i104 + 64 | 0;
 i94 = i104 + 48 | 0;
 i95 = i104;
 i84 = HEAP32[i90 + 12 >> 2] | 0;
 HEAP32[i101 >> 2] = 0;
 i99 = i101 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i99;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = (i84 << 2) + 12 | 0;
 i7 = i5 & -16;
 i6 = (i7 | 0) != 0;
 do if (i6) {
  i1 = i5 | 15;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, gb + 64016 | 0, 0, gb + 613323 | 0, 405) | 0;
   i3 = gb + 64016 | 0;
   i89 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i101 >> 2] = i2;
   i4 = i99;
   HEAP32[i4 >> 2] = i89;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i88 = i2 + 15 & -16;
 HEAP32[i102 >> 2] = 0;
 i89 = i102 + 4 | 0;
 i87 = i89;
 HEAP32[i87 >> 2] = i3;
 HEAP32[i87 + 4 >> 2] = i4;
 do if (i6) {
  i1 = i5 | 15;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, gb + 64016 | 0, 0, gb + 613323 | 0, 406) | 0;
   i3 = gb + 64016 | 0;
   i87 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i102 >> 2] = i2;
   i4 = i89;
   HEAP32[i4 >> 2] = i87;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i86 = i2 + 15 & -16;
 HEAP32[i103 >> 2] = 0;
 i87 = i103 + 4 | 0;
 i85 = i87;
 HEAP32[i85 >> 2] = i3;
 HEAP32[i85 + 4 >> 2] = i4;
 do if (i6) {
  i2 = i5 | 15;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, gb + 64016 | 0, 0, gb + 613323 | 0, 407) | 0;
   i82 = gb + 64016 | 0;
   i81 = HEAP32[i82 >> 2] | 0;
   i82 = HEAP32[i82 + 4 >> 2] | 0;
   HEAP32[i103 >> 2] = i1;
   i85 = i87;
   HEAP32[i85 >> 2] = i81;
   HEAP32[i85 + 4 >> 2] = i82;
   break;
  }
 } else i1 = 0; while (0);
 i85 = i1 + 15 & -16;
 if (!i84) {
  i98 = HEAP32[i100 + 12 >> 2] | 0;
  __ZN23ParticleSystemParticles12array_resizeEj(i100, i98);
  i103 = HEAP32[i103 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i87);
  i103 = HEAP32[i102 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i89);
  i103 = HEAP32[i101 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i99);
  STACKTOP = i104;
  return;
 }
 i5 = i44 + 4 | 0;
 i6 = i44 + 8 | 0;
 i7 = i44 + 12 | 0;
 i12 = i44 + 16 | 0;
 i13 = i44 + 20 | 0;
 i14 = i44 + 24 | 0;
 i15 = i44 + 28 | 0;
 i16 = i44 + 32 | 0;
 i17 = i44 + 36 | 0;
 i18 = i44 + 40 | 0;
 i19 = i44 + 44 | 0;
 i20 = i44 + 48 | 0;
 i21 = i44 + 52 | 0;
 i22 = i44 + 56 | 0;
 i23 = i44 + 60 | 0;
 i24 = i94 + 4 | 0;
 i25 = i94 + 8 | 0;
 i26 = i94 + 12 | 0;
 i27 = i92 + 4 | 0;
 i28 = i92 + 8 | 0;
 i29 = i92 + 12 | 0;
 i30 = i83 + 4 | 0;
 i31 = i94 + 4 | 0;
 i32 = i94 + 8 | 0;
 i33 = i94 + 12 | 0;
 i34 = i92 + 4 | 0;
 i35 = i92 + 8 | 0;
 i36 = i92 + 12 | 0;
 i37 = i83 + 8 | 0;
 i38 = i94 + 4 | 0;
 i39 = i94 + 8 | 0;
 i40 = i94 + 12 | 0;
 i41 = i92 + 4 | 0;
 i42 = i92 + 8 | 0;
 i43 = i92 + 12 | 0;
 i4 = 0;
 do {
  i1 = i88 + (i4 << 2) | 0;
  i2 = HEAP32[i83 >> 2] | 0;
  HEAP32[i93 >> 2] = 0;
  HEAP32[i93 + 4 >> 2] = 0;
  HEAP32[i93 + 8 >> 2] = 0;
  HEAP32[i93 + 12 >> 2] = 0;
  i76 = HEAP32[i44 >> 2] | 0;
  i77 = HEAP32[i5 >> 2] | 0;
  i78 = HEAP32[i6 >> 2] | 0;
  i79 = HEAP32[i7 >> 2] | 0;
  i76 = i76 << 11 ^ i76;
  i77 = i77 << 11 ^ i77;
  i78 = i78 << 11 ^ i78;
  i79 = i79 << 11 ^ i79;
  i80 = HEAP32[i13 >> 2] | 0;
  i81 = HEAP32[i14 >> 2] | 0;
  i82 = HEAP32[i15 >> 2] | 0;
  HEAP32[i44 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 >> 2] = i80;
  HEAP32[i6 >> 2] = i81;
  HEAP32[i7 >> 2] = i82;
  i82 = HEAP32[i17 >> 2] | 0;
  i81 = HEAP32[i18 >> 2] | 0;
  i80 = HEAP32[i19 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i13 >> 2] = i82;
  HEAP32[i14 >> 2] = i81;
  HEAP32[i15 >> 2] = i80;
  i80 = HEAP32[i20 >> 2] | 0;
  i81 = HEAP32[i21 >> 2] | 0;
  i82 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  HEAP32[i16 >> 2] = i80;
  HEAP32[i17 >> 2] = i81;
  HEAP32[i18 >> 2] = i82;
  HEAP32[i19 >> 2] = i3;
  i80 = i76 >>> 8 ^ i76 ^ i80 ^ i80 >>> 19;
  i81 = i77 >>> 8 ^ i77 ^ i81 ^ i81 >>> 19;
  i82 = i78 >>> 8 ^ i78 ^ i82 ^ i82 >>> 19;
  i3 = i79 >>> 8 ^ i79 ^ i3 ^ i3 >>> 19;
  HEAP32[i20 >> 2] = i80;
  HEAP32[i21 >> 2] = i81;
  HEAP32[i22 >> 2] = i82;
  HEAP32[i23 >> 2] = i3;
  f8 = Math_fround(Math_fround(i80 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f9 = Math_fround(Math_fround(i81 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f10 = Math_fround(Math_fround(i82 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f11 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i94 >> 2] = f8;
  HEAPF32[i24 >> 2] = f9;
  HEAPF32[i25 >> 2] = f10;
  HEAPF32[i26 >> 2] = f11;
  i3 = HEAP32[i2 + 84 >> 2] | 0;
  L25 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i82 = HEAP32[i2 + 80 >> 2] | 0;
    HEAP32[i29 >> 2] = i82;
    HEAP32[i28 >> 2] = i82;
    HEAP32[i27 >> 2] = i82;
    HEAP32[i92 >> 2] = i82;
    break;
   }
  case 3:
   {
    f53 = Math_fround(HEAPF32[(HEAP32[i2 + 232 >> 2] | 0) + 4 >> 2]);
    f54 = Math_fround(HEAPF32[i2 + 80 >> 2]);
    f53 = Math_fround(f53 * f54);
    f54 = Math_fround(Math_fround(f54 * Math_fround(HEAPF32[(HEAP32[i2 + 144 >> 2] | 0) + 4 >> 2])) - f53);
    f55 = Math_fround(f53 + Math_fround(f54 * f9));
    f56 = Math_fround(f53 + Math_fround(f54 * f10));
    f57 = Math_fround(f53 + Math_fround(f11 * f54));
    HEAPF32[i92 >> 2] = Math_fround(f53 + Math_fround(f8 * f54));
    HEAPF32[i27 >> 2] = f55;
    HEAPF32[i28 >> 2] = f56;
    HEAPF32[i29 >> 2] = f57;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i92, i2, i93, i94);
    break L25;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i92, i2, i93, i94);
    break L25;
   }
  } while (0);
  f11 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i92 >> 2]));
  f10 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i27 >> 2]));
  f9 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i28 >> 2]));
  f8 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i1 >> 2] = f11;
  HEAPF32[i1 + 4 >> 2] = f10;
  HEAPF32[i1 + 8 >> 2] = f9;
  HEAPF32[i1 + 12 >> 2] = f8;
  i1 = i86 + (i4 << 2) | 0;
  i2 = HEAP32[i30 >> 2] | 0;
  HEAP32[i93 >> 2] = 0;
  HEAP32[i93 + 4 >> 2] = 0;
  HEAP32[i93 + 8 >> 2] = 0;
  HEAP32[i93 + 12 >> 2] = 0;
  i76 = HEAP32[i44 >> 2] | 0;
  i77 = HEAP32[i5 >> 2] | 0;
  i78 = HEAP32[i6 >> 2] | 0;
  i79 = HEAP32[i7 >> 2] | 0;
  i76 = i76 << 11 ^ i76;
  i77 = i77 << 11 ^ i77;
  i78 = i78 << 11 ^ i78;
  i79 = i79 << 11 ^ i79;
  i80 = HEAP32[i13 >> 2] | 0;
  i81 = HEAP32[i14 >> 2] | 0;
  i82 = HEAP32[i15 >> 2] | 0;
  HEAP32[i44 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 >> 2] = i80;
  HEAP32[i6 >> 2] = i81;
  HEAP32[i7 >> 2] = i82;
  i82 = HEAP32[i17 >> 2] | 0;
  i81 = HEAP32[i18 >> 2] | 0;
  i80 = HEAP32[i19 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i13 >> 2] = i82;
  HEAP32[i14 >> 2] = i81;
  HEAP32[i15 >> 2] = i80;
  i80 = HEAP32[i20 >> 2] | 0;
  i81 = HEAP32[i21 >> 2] | 0;
  i82 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  HEAP32[i16 >> 2] = i80;
  HEAP32[i17 >> 2] = i81;
  HEAP32[i18 >> 2] = i82;
  HEAP32[i19 >> 2] = i3;
  i80 = i76 >>> 8 ^ i76 ^ i80 ^ i80 >>> 19;
  i81 = i77 >>> 8 ^ i77 ^ i81 ^ i81 >>> 19;
  i82 = i78 >>> 8 ^ i78 ^ i82 ^ i82 >>> 19;
  i3 = i79 >>> 8 ^ i79 ^ i3 ^ i3 >>> 19;
  HEAP32[i20 >> 2] = i80;
  HEAP32[i21 >> 2] = i81;
  HEAP32[i22 >> 2] = i82;
  HEAP32[i23 >> 2] = i3;
  f8 = Math_fround(Math_fround(i80 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f9 = Math_fround(Math_fround(i81 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f10 = Math_fround(Math_fround(i82 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f11 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i94 >> 2] = f8;
  HEAPF32[i31 >> 2] = f9;
  HEAPF32[i32 >> 2] = f10;
  HEAPF32[i33 >> 2] = f11;
  i3 = HEAP32[i2 + 84 >> 2] | 0;
  L33 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i82 = HEAP32[i2 + 80 >> 2] | 0;
    HEAP32[i36 >> 2] = i82;
    HEAP32[i35 >> 2] = i82;
    HEAP32[i34 >> 2] = i82;
    HEAP32[i92 >> 2] = i82;
    break;
   }
  case 3:
   {
    f53 = Math_fround(HEAPF32[(HEAP32[i2 + 232 >> 2] | 0) + 4 >> 2]);
    f54 = Math_fround(HEAPF32[i2 + 80 >> 2]);
    f53 = Math_fround(f53 * f54);
    f54 = Math_fround(Math_fround(f54 * Math_fround(HEAPF32[(HEAP32[i2 + 144 >> 2] | 0) + 4 >> 2])) - f53);
    f55 = Math_fround(f53 + Math_fround(f54 * f9));
    f56 = Math_fround(f53 + Math_fround(f54 * f10));
    f57 = Math_fround(f53 + Math_fround(f11 * f54));
    HEAPF32[i92 >> 2] = Math_fround(f53 + Math_fround(f8 * f54));
    HEAPF32[i34 >> 2] = f55;
    HEAPF32[i35 >> 2] = f56;
    HEAPF32[i36 >> 2] = f57;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i92, i2, i93, i94);
    break L33;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i92, i2, i93, i94);
    break L33;
   }
  } while (0);
  HEAP32[i1 >> 2] = HEAP32[i92 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i36 >> 2];
  i1 = i85 + (i4 << 2) | 0;
  i2 = HEAP32[i37 >> 2] | 0;
  HEAP32[i93 >> 2] = 0;
  HEAP32[i93 + 4 >> 2] = 0;
  HEAP32[i93 + 8 >> 2] = 0;
  HEAP32[i93 + 12 >> 2] = 0;
  i76 = HEAP32[i44 >> 2] | 0;
  i77 = HEAP32[i5 >> 2] | 0;
  i78 = HEAP32[i6 >> 2] | 0;
  i79 = HEAP32[i7 >> 2] | 0;
  i76 = i76 << 11 ^ i76;
  i77 = i77 << 11 ^ i77;
  i78 = i78 << 11 ^ i78;
  i79 = i79 << 11 ^ i79;
  i80 = HEAP32[i13 >> 2] | 0;
  i81 = HEAP32[i14 >> 2] | 0;
  i82 = HEAP32[i15 >> 2] | 0;
  HEAP32[i44 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 >> 2] = i80;
  HEAP32[i6 >> 2] = i81;
  HEAP32[i7 >> 2] = i82;
  i82 = HEAP32[i17 >> 2] | 0;
  i81 = HEAP32[i18 >> 2] | 0;
  i80 = HEAP32[i19 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i13 >> 2] = i82;
  HEAP32[i14 >> 2] = i81;
  HEAP32[i15 >> 2] = i80;
  i80 = HEAP32[i20 >> 2] | 0;
  i81 = HEAP32[i21 >> 2] | 0;
  i82 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  HEAP32[i16 >> 2] = i80;
  HEAP32[i17 >> 2] = i81;
  HEAP32[i18 >> 2] = i82;
  HEAP32[i19 >> 2] = i3;
  i80 = i76 >>> 8 ^ i76 ^ i80 ^ i80 >>> 19;
  i81 = i77 >>> 8 ^ i77 ^ i81 ^ i81 >>> 19;
  i82 = i78 >>> 8 ^ i78 ^ i82 ^ i82 >>> 19;
  i3 = i79 >>> 8 ^ i79 ^ i3 ^ i3 >>> 19;
  HEAP32[i20 >> 2] = i80;
  HEAP32[i21 >> 2] = i81;
  HEAP32[i22 >> 2] = i82;
  HEAP32[i23 >> 2] = i3;
  f8 = Math_fround(Math_fround(i80 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f9 = Math_fround(Math_fround(i81 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f10 = Math_fround(Math_fround(i82 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f11 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i94 >> 2] = f8;
  HEAPF32[i38 >> 2] = f9;
  HEAPF32[i39 >> 2] = f10;
  HEAPF32[i40 >> 2] = f11;
  i3 = HEAP32[i2 + 84 >> 2] | 0;
  L41 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i82 = HEAP32[i2 + 80 >> 2] | 0;
    HEAP32[i43 >> 2] = i82;
    HEAP32[i42 >> 2] = i82;
    HEAP32[i41 >> 2] = i82;
    HEAP32[i92 >> 2] = i82;
    break;
   }
  case 3:
   {
    f53 = Math_fround(HEAPF32[(HEAP32[i2 + 232 >> 2] | 0) + 4 >> 2]);
    f54 = Math_fround(HEAPF32[i2 + 80 >> 2]);
    f53 = Math_fround(f53 * f54);
    f54 = Math_fround(Math_fround(f54 * Math_fround(HEAPF32[(HEAP32[i2 + 144 >> 2] | 0) + 4 >> 2])) - f53);
    f55 = Math_fround(f53 + Math_fround(f54 * f9));
    f56 = Math_fround(f53 + Math_fround(f54 * f10));
    f57 = Math_fround(f53 + Math_fround(f11 * f54));
    HEAPF32[i92 >> 2] = Math_fround(f53 + Math_fround(f8 * f54));
    HEAPF32[i41 >> 2] = f55;
    HEAPF32[i42 >> 2] = f56;
    HEAPF32[i43 >> 2] = f57;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i92, i2, i93, i94);
    break L41;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i92, i2, i93, i94);
    break L41;
   }
  } while (0);
  f54 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i92 >> 2]));
  f55 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i41 >> 2]));
  f56 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i42 >> 2]));
  f57 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i43 >> 2]));
  HEAPF32[i1 >> 2] = f54;
  HEAPF32[i1 + 4 >> 2] = f55;
  HEAPF32[i1 + 8 >> 2] = f56;
  HEAPF32[i1 + 12 >> 2] = f57;
  i4 = i4 + 4 | 0;
 } while (i4 >>> 0 < i84 >>> 0);
 i1 = HEAP32[i100 + 12 >> 2] | 0;
 if ((i84 | 0) <= 0) {
  i98 = i1;
  __ZN23ParticleSystemParticles12array_resizeEj(i100, i98);
  i103 = HEAP32[i103 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i87);
  i103 = HEAP32[i102 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i89);
  i103 = HEAP32[i101 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i103, i99);
  STACKTOP = i104;
  return;
 }
 i18 = i100 + 20 | 0;
 i19 = i100 + 40 | 0;
 i20 = i100 + 120 | 0;
 i21 = i100 + 140 | 0;
 i22 = i100 + 160 | 0;
 i23 = i100 + 60 | 0;
 i24 = i100 + 80 | 0;
 i25 = i100 + 100 | 0;
 i26 = i83 + 24 | 0;
 i27 = i100 + 520 | 0;
 f57 = Math_fround(Math_fround(HEAPF32[gb + 62452 >> 2]) + Math_fround(100.0));
 i28 = i96 + 420 | 0;
 i29 = i100 + 875 | 0;
 i30 = i92 + 4 | 0;
 i31 = i92 + 8 | 0;
 i32 = i93 + 4 | 0;
 i33 = i93 + 8 | 0;
 i34 = i94 + 4 | 0;
 i35 = i94 + 8 | 0;
 i36 = i91 + 280 | 0;
 i37 = i100 + 620 | 0;
 i38 = i100 + 632 | 0;
 i39 = i100 + 636 | 0;
 i40 = i100 + 624 | 0;
 i41 = i95 + 4 | 0;
 i42 = i95 + 8 | 0;
 i43 = i95 + 12 | 0;
 i44 = i95 + 16 | 0;
 i58 = i95 + 20 | 0;
 i59 = i95 + 24 | 0;
 i60 = i95 + 28 | 0;
 i61 = i95 + 32 | 0;
 i62 = i95 + 36 | 0;
 i63 = i96 + 52 | 0;
 i64 = i96 + 68 | 0;
 i65 = i96 + 84 | 0;
 i66 = i96 + 100 | 0;
 i67 = i96 + 56 | 0;
 i68 = i96 + 72 | 0;
 i69 = i96 + 88 | 0;
 i70 = i96 + 104 | 0;
 i71 = i96 + 60 | 0;
 i72 = i96 + 76 | 0;
 i73 = i96 + 92 | 0;
 i74 = i96 + 108 | 0;
 i75 = i96 + 496 | 0;
 i76 = i92 + 4 | 0;
 i77 = i92 + 8 | 0;
 i78 = i92 + 12 | 0;
 i79 = i92 + 16 | 0;
 i80 = i92 + 20 | 0;
 i81 = i96 + 416 | 0;
 i82 = i83 + 12 | 0;
 i17 = i83 + 16 | 0;
 i15 = i84;
 do {
  i16 = i15;
  i15 = i15 + -1 | 0;
  i14 = HEAP32[i90 >> 2] | 0;
  i2 = HEAP32[i14 + (i15 * 60 | 0) + 40 >> 2] | 0;
  i6 = HEAP32[i14 + (i15 * 60 | 0) + 44 >> 2] | 0;
  i7 = HEAP32[i14 + (i15 * 60 | 0) + 48 >> 2] | 0;
  i13 = HEAP32[i14 + (i15 * 60 | 0) >> 2] | 0;
  i3 = HEAP32[(HEAP32[i100 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  i4 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  f51 = Math_fround(HEAPF32[(HEAP32[i20 >> 2] | 0) + (i13 << 2) >> 2]);
  f52 = Math_fround(HEAPF32[(HEAP32[i21 >> 2] | 0) + (i13 << 2) >> 2]);
  f53 = Math_fround(HEAPF32[(HEAP32[i22 >> 2] | 0) + (i13 << 2) >> 2]);
  f54 = Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + (i13 << 2) >> 2]);
  f55 = Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + (i13 << 2) >> 2]);
  f54 = Math_fround(f51 + f54);
  f55 = Math_fround(f52 + f55);
  f56 = Math_fround(f53 + Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + (i13 << 2) >> 2]));
  if (!(HEAP32[i26 >> 2] | 0)) {
   i12 = i2;
   i98 = 42;
  } else {
   f47 = Math_fround(HEAPF32[i97 >> 2]);
   f45 = Math_fround(f54 * f47);
   f46 = Math_fround(f55 * f47);
   f47 = Math_fround(f56 * f47);
   f48 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f45);
   f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f46);
   f50 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
   f8 = Math_fround(HEAPF32[i14 + (i15 * 60 | 0) + 28 >> 2]);
   f11 = Math_fround(f8 * f45);
   f9 = Math_fround(HEAPF32[i14 + (i15 * 60 | 0) + 32 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f46 * f9));
   f10 = Math_fround(HEAPF32[i14 + (i15 * 60 | 0) + 36 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f47 * f10));
   i84 = f11 < Math_fround(0.0);
   f105 = Math_fround(-f11);
   if (!(f11 >= Math_fround(0.0)) & !((i84 ? f105 : f11) < Math_fround(1.1920929e-07))) {
    f105 = Math_fround(Math_fround(Math_fround(f8 * f48) + Math_fround(f49 * f9)) + Math_fround(f50 * f10));
    f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
    f8 = Math_fround(f8 + Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f9));
    f8 = Math_fround(Math_fround(-Math_fround(f105 - Math_fround(f8 + Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f10)))) / f11);
    if (!(f8 < Math_fround(0.0) | f8 > Math_fround(1.0))) {
     f48 = Math_fround(f48 + Math_fround(f45 * f8));
     f49 = Math_fround(f49 + Math_fround(f46 * f8));
     f105 = Math_fround(f50 + Math_fround(f47 * f8));
     i12 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
     i98 = 42;
    }
   }
  }
  if ((i98 | 0) == 42) {
   i98 = 0;
   f50 = Math_fround(Math_fround(HEAPF32[i86 + (i15 << 2) >> 2]) * Math_fround(100.0));
   i2 = (HEAP32[i27 >> 2] | 0) + (i13 << 2) | 0;
   f50 = Math_fround(f50 + Math_fround(HEAPF32[i2 >> 2]));
   HEAPF32[i2 >> 2] = f50;
   f105 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f55 * f55)) + Math_fround(f56 * f56));
   i84 = f50 > Math_fround(100.0);
   i84 = i84 | f105 < Math_fround(HEAPF32[i82 >> 2]);
   if (i84 | f105 > Math_fround(HEAPF32[i17 >> 2])) HEAPF32[i2 >> 2] = f57;
   f107 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f46 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f107 = Math_fround(f107 - f46);
   f106 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f45 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f106 = Math_fround(f106 - f45);
   f48 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f48 = Math_fround(f48 - f11);
   i3 = i14 + (i15 * 60 | 0) + 28 | 0;
   f49 = Math_fround(HEAPF32[i3 >> 2]);
   f8 = Math_fround(f107 * f49);
   i4 = i14 + (i15 * 60 | 0) + 32 | 0;
   f50 = Math_fround(HEAPF32[i4 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f106 * f50));
   i5 = i14 + (i15 * 60 | 0) + 36 | 0;
   f108 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(Math_fround(f8 + Math_fround(f48 * f108)) * Math_fround(-2.0));
   f107 = Math_fround(f107 + Math_fround(f49 * f8));
   f106 = Math_fround(f106 + Math_fround(f50 * f8));
   f8 = Math_fround(f48 + Math_fround(f108 * f8));
   f48 = Math_fround(HEAPF32[i85 + (i15 << 2) >> 2]);
   f107 = Math_fround(f48 * f107);
   f106 = Math_fround(f48 * f106);
   f8 = Math_fround(f48 * f8);
   f109 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f49) + Math_fround(f55 * f50)) + Math_fround(f56 * f108)) * Math_fround(-2.0));
   f111 = Math_fround(f48 * Math_fround(f54 + Math_fround(f49 * f109)));
   f110 = Math_fround(f48 * Math_fround(f55 + Math_fround(f50 * f109)));
   f109 = Math_fround(f48 * Math_fround(f56 + Math_fround(f108 * f109)));
   f48 = Math_fround(Math_fround(f108 * f8) + Math_fround(Math_fround(f49 * f107) + Math_fround(f50 * f106)));
   f10 = Math_fround(f49 * f48);
   f47 = Math_fround(f50 * f48);
   f48 = Math_fround(f108 * f48);
   f9 = Math_fround(HEAPF32[i88 + (i15 << 2) >> 2]);
   f105 = Math_fround(Math_fround(f108 * f109) + Math_fround(Math_fround(f49 * f111) + Math_fround(f50 * f110)));
   f49 = Math_fround(f111 - Math_fround(f9 * Math_fround(f49 * f105)));
   f50 = Math_fround(f110 - Math_fround(f9 * Math_fround(f50 * f105)));
   f105 = Math_fround(f109 - Math_fround(f9 * Math_fround(f108 * f105)));
   f10 = Math_fround(f46 + Math_fround(f107 - Math_fround(f9 * f10)));
   f47 = Math_fround(f45 + Math_fround(f106 - Math_fround(f9 * f47)));
   f48 = Math_fround(f11 + Math_fround(f8 - Math_fround(f9 * f48)));
   HEAPF32[(HEAP32[i100 >> 2] | 0) + (i13 << 2) >> 2] = f10;
   HEAPF32[(HEAP32[i18 >> 2] | 0) + (i13 << 2) >> 2] = f47;
   HEAPF32[(HEAP32[i19 >> 2] | 0) + (i13 << 2) >> 2] = f48;
   f51 = Math_fround(f49 - f51);
   f52 = Math_fround(f50 - f52);
   f105 = Math_fround(f105 - f53);
   HEAPF32[(HEAP32[i23 >> 2] | 0) + (i13 << 2) >> 2] = f51;
   HEAPF32[(HEAP32[i24 >> 2] | 0) + (i13 << 2) >> 2] = f52;
   HEAPF32[(HEAP32[i25 >> 2] | 0) + (i13 << 2) >> 2] = f105;
   if (HEAP32[i28 >> 2] | 0) {
    i2 = 0;
    do {
     i84 = HEAP32[i75 >> 2] | 0;
     HEAPF32[i92 >> 2] = Math_fround(0.0);
     HEAPF32[i76 >> 2] = Math_fround(0.0);
     HEAP32[i77 >> 2] = i84;
     i84 = (Math_imul(i84, 1812433253) | 0) + 1 | 0;
     HEAP32[i78 >> 2] = i84;
     i84 = (Math_imul(i84, 1812433253) | 0) + 1 | 0;
     HEAP32[i79 >> 2] = i84;
     HEAP32[i80 >> 2] = (Math_imul(i84, 1812433253) | 0) + 1;
     __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i92, (HEAP32[i81 >> 2] | 0) + (i2 * 600 | 0) | 0, i91, i96, i100, 1, i2, i13, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0);
   }
   if (HEAP8[i29 >> 0] | 0) {
    i2 = HEAP32[i14 + (i15 * 60 | 0) + 52 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i92 >> 2] = i12;
     HEAP32[i30 >> 2] = i6;
     HEAP32[i31 >> 2] = i7;
     i13 = HEAP32[i3 >> 2] | 0;
     HEAP32[i93 >> 2] = i13;
     i83 = HEAP32[i4 >> 2] | 0;
     HEAP32[i32 >> 2] = i83;
     i84 = HEAP32[i5 >> 2] | 0;
     HEAP32[i33 >> 2] = i84;
     HEAPF32[i94 >> 2] = f54;
     HEAPF32[i34 >> 2] = f55;
     HEAPF32[i35 >> 2] = f56;
     f8 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i83, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f10 = (HEAP32[tempDoublePtr >> 2] = i84, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if ((HEAP32[i36 >> 2] | 0) != 1) {
      f107 = Math_fround(HEAPF32[i63 >> 2]);
      f49 = Math_fround(f107 * f46);
      f108 = Math_fround(HEAPF32[i64 >> 2]);
      f49 = Math_fround(f49 + Math_fround(f108 * f45));
      f109 = Math_fround(HEAPF32[i65 >> 2]);
      f49 = Math_fround(f49 + Math_fround(f109 * f11));
      f49 = Math_fround(Math_fround(HEAPF32[i66 >> 2]) + f49);
      f52 = Math_fround(HEAPF32[i67 >> 2]);
      f51 = Math_fround(f46 * f52);
      f53 = Math_fround(HEAPF32[i68 >> 2]);
      f51 = Math_fround(f51 + Math_fround(f45 * f53));
      f110 = Math_fround(HEAPF32[i69 >> 2]);
      f51 = Math_fround(f51 + Math_fround(f11 * f110));
      f51 = Math_fround(Math_fround(HEAPF32[i70 >> 2]) + f51);
      f105 = Math_fround(HEAPF32[i71 >> 2]);
      f50 = Math_fround(f46 * f105);
      f106 = Math_fround(HEAPF32[i72 >> 2]);
      f50 = Math_fround(f50 + Math_fround(f45 * f106));
      f111 = Math_fround(HEAPF32[i73 >> 2]);
      f50 = Math_fround(f50 + Math_fround(f11 * f111));
      f50 = Math_fround(Math_fround(HEAPF32[i74 >> 2]) + f50);
      HEAPF32[i92 >> 2] = f49;
      HEAPF32[i30 >> 2] = f51;
      HEAPF32[i31 >> 2] = f50;
      f50 = Math_fround(Math_fround(Math_fround(f8 * f52) + Math_fround(f9 * f53)) + Math_fround(f10 * f110));
      f51 = Math_fround(Math_fround(Math_fround(f8 * f105) + Math_fround(f9 * f106)) + Math_fround(f10 * f111));
      HEAPF32[i93 >> 2] = Math_fround(Math_fround(Math_fround(f107 * f8) + Math_fround(f108 * f9)) + Math_fround(f109 * f10));
      HEAPF32[i32 >> 2] = f50;
      HEAPF32[i33 >> 2] = f51;
      f110 = Math_fround(Math_fround(Math_fround(f54 * f52) + Math_fround(f55 * f53)) + Math_fround(f56 * f110));
      f111 = Math_fround(Math_fround(Math_fround(f54 * f105) + Math_fround(f55 * f106)) + Math_fround(f56 * f111));
      HEAPF32[i94 >> 2] = Math_fround(Math_fround(Math_fround(f107 * f54) + Math_fround(f108 * f55)) + Math_fround(f109 * f56));
      HEAPF32[i34 >> 2] = f110;
      HEAPF32[i35 >> 2] = f111;
     }
     __ZN22ParticleCollisionEventC2ERK8Vector3fS2_S2_ii(i95, i92, i93, i94, i2, HEAP32[i14 + (i15 * 60 | 0) + 56 >> 2] | 0);
     i3 = HEAP32[i38 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i39 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i39 >> 2] = i2;
       HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i2 * 44 | 0, 4, i40, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i84 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i40, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i84 | 0, HEAP32[i37 >> 2] | 0, (HEAP32[i38 >> 2] | 0) * 44 | 0) | 0;
       HEAP32[i39 >> 2] = i2;
       HEAP32[i37 >> 2] = i84;
       break;
      }
     } while (0);
     HEAP32[i38 >> 2] = i4;
     i84 = HEAP32[i37 >> 2] | 0;
     HEAP32[i84 + (i3 * 44 | 0) >> 2] = HEAP32[i95 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 4 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 8 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 12 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 16 >> 2] = HEAP32[i44 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 20 >> 2] = HEAP32[i58 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 24 >> 2] = HEAP32[i59 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 28 >> 2] = HEAP32[i60 >> 2];
     HEAP32[i84 + (i3 * 44 | 0) + 32 >> 2] = HEAP32[i61 >> 2];
     i14 = i62;
     i83 = HEAP32[i14 + 4 >> 2] | 0;
     i84 = i84 + (i3 * 44 | 0) + 36 | 0;
     HEAP32[i84 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i84 + 4 >> 2] = i83;
    }
   }
  }
 } while ((i16 | 0) > 1);
 __ZN23ParticleSystemParticles12array_resizeEj(i100, i1);
 i103 = HEAP32[i103 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i103, i87);
 i103 = HEAP32[i102 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i103, i89);
 i103 = HEAP32[i101 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i103, i99);
 STACKTOP = i104;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_(i1, i2, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i13 = i2;
 L1 : while (1) {
  i9 = i13;
  i12 = i13 + -20 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i2 = i9 - i8 | 0;
    switch ((i2 | 0) / 20 | 0 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 84;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 620) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i2 >>> 0) / 40 | 0) * 20 | 0) | 0;
    do if ((i2 | 0) > 19980) {
     i3 = (i2 >>> 0) / 80 | 0;
     i5 = i1 + (i3 * 20 | 0) | 0;
     i3 = i7 + (i3 * 20 | 0) | 0;
     i2 = __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i5, i7, i3, i11) | 0;
     if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i3 >> 2] | 0)) {
      i3 = i7;
      break;
     };
     HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
     i4 = i2 + 1 | 0;
     if ((HEAP32[i3 >> 2] | 0) < (HEAP32[i7 >> 2] | 0)) {
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      i3 = i2 + 2 | 0;
      if ((HEAP32[i7 >> 2] | 0) < (HEAP32[i5 >> 2] | 0)) {
       HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i14 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
       HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
       HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
       HEAP32[i7 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
       if ((HEAP32[i5 >> 2] | 0) < (HEAP32[i1 >> 2] | 0)) {
        HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
        HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
        HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
        HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
        HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
        HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
        HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
        HEAP32[i5 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
        i2 = i2 + 4 | 0;
        i3 = i7;
       } else {
        i2 = i2 + 3 | 0;
        i3 = i7;
       }
      } else {
       i2 = i3;
       i3 = i7;
      }
     } else {
      i2 = i4;
      i3 = i7;
     }
    } else {
     i6 = HEAP32[i7 >> 2] | 0;
     i2 = (HEAP32[i12 >> 2] | 0) < (i6 | 0);
     if ((i6 | 0) >= (HEAP32[i1 >> 2] | 0)) {
      if (!i2) {
       i2 = 0;
       i3 = i7;
       break;
      };
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      if ((HEAP32[i7 >> 2] | 0) >= (HEAP32[i1 >> 2] | 0)) {
       i2 = 1;
       i3 = i7;
       break;
      };
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i7 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      i2 = 2;
      i3 = i7;
      break;
     }
     if (i2) {
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      i2 = 1;
      i3 = i7;
      break;
     };
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
     if ((HEAP32[i12 >> 2] | 0) < (HEAP32[i7 >> 2] | 0)) {
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      i2 = 2;
      i3 = i7;
     } else {
      i2 = 1;
      i3 = i7;
     }
    } while (0);
    i5 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i12;
     break;
    } else i3 = i12;
    while (1) {
     i3 = i3 + -20 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if ((HEAP32[i3 >> 2] | 0) < (i4 | 0)) {
      i10 = 67;
      break L5;
     }
    }
    i2 = i1 + 20 | 0;
    if ((i5 | 0) >= (HEAP32[i12 >> 2] | 0)) {
     if ((i2 | 0) == (i12 | 0)) {
      i10 = 84;
      break L1;
     }
     while (1) {
      if ((i5 | 0) < (HEAP32[i2 >> 2] | 0)) break;
      i2 = i2 + 20 | 0;
      if ((i2 | 0) == (i12 | 0)) {
       i10 = 84;
       break L1;
      }
     }
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
     i2 = i2 + 20 | 0;
    }
    if ((i2 | 0) == (i12 | 0)) {
     i10 = 84;
     break L1;
    } else i3 = i12;
    while (1) {
     i5 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i4 = i2 + 20 | 0;
      if ((i5 | 0) < (HEAP32[i2 >> 2] | 0)) break; else i2 = i4;
     }
     do i3 = i3 + -20 | 0; while ((i5 | 0) < (HEAP32[i3 >> 2] | 0));
     if (i2 >>> 0 >= i3 >>> 0) {
      i1 = i2;
      continue L5;
     };
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
     i2 = i4;
    }
   }
   if ((i10 | 0) == 67) {
    i10 = 0;
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 20 | 0;
   L50 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i5 = i4 + 20 | 0;
     if ((HEAP32[i4 >> 2] | 0) < (i6 | 0)) i4 = i5; else break;
    }
    do i3 = i3 + -20 | 0; while ((HEAP32[i3 >> 2] | 0) >= (i6 | 0));
    if (i4 >>> 0 > i3 >>> 0) {
     i3 = i7;
     break L50;
    };
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
    i7 = (i7 | 0) == (i4 | 0) ? i3 : i7;
    i4 = i5;
    i2 = i2 + 1 | 0;
   } else i3 = i7; while (0);
   if ((i4 | 0) != (i3 | 0)) if ((HEAP32[i3 >> 2] | 0) < (HEAP32[i4 >> 2] | 0)) {
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
    i2 = i2 + 1 | 0;
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEbT0_S6_T_(i1, i4, i11) | 0;
    i3 = i4 + 20 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEbT0_S6_T_(i3, i13, i11) | 0) {
     i10 = 83;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i7 = i4;
   if ((i7 - i8 | 0) >= (i9 - i7 | 0)) {
    i10 = 82;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_(i1, i4, i11);
   i1 = i4 + 20 | 0;
  }
  if ((i10 | 0) == 82) {
   i10 = 0;
   __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_(i4 + 20 | 0, i13, i11);
   i13 = i4;
   continue;
  } else if ((i10 | 0) == 83) {
   i10 = 0;
   if (i2) {
    i10 = 84;
    break;
   } else {
    i13 = i4;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 20 | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  i3 = (HEAP32[i12 >> 2] | 0) < (i13 | 0);
  if ((i13 | 0) >= (HEAP32[i1 >> 2] | 0)) {
   if (!i3) {
    STACKTOP = i15;
    return;
   };
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   if ((HEAP32[i2 >> 2] | 0) >= (HEAP32[i1 >> 2] | 0)) {
    STACKTOP = i15;
    return;
   };
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   STACKTOP = i15;
   return;
  }
  if (i3) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i2 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i12, i11) | 0;
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 20 | 0;
  i3 = i1 + 40 | 0;
  i4 = i1 + 60 | 0;
  __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i2, i3, i4, i11) | 0;
  if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i4 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  if ((HEAP32[i4 >> 2] | 0) >= (HEAP32[i3 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  if ((HEAP32[i3 >> 2] | 0) >= (HEAP32[i2 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  if ((HEAP32[i2 >> 2] | 0) >= (HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 22) {
  i3 = i1 + 40 | 0;
  i2 = i1 + 20 | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i6 = (i5 | 0) < (i12 | 0);
  do if ((i12 | 0) < (i4 | 0)) {
   if (i6) {
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
    break;
   };
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   if ((i5 | 0) < (HEAP32[i2 >> 2] | 0)) {
    HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   }
  } else if (i6) {
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   if ((HEAP32[i2 >> 2] | 0) < (i4 | 0)) {
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   }
  } while (0);
  i2 = i1 + 60 | 0;
  if ((i2 | 0) == (i13 | 0)) {
   STACKTOP = i15;
   return;
  }
  while (1) {
   i5 = HEAP32[i2 >> 2] | 0;
   if ((i5 | 0) < (HEAP32[i3 >> 2] | 0)) {
    i4 = i2 + 4 | 0;
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i4 = i2;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i4 = i3 + -20 | 0;
     if ((i5 | 0) < (HEAP32[i4 >> 2] | 0)) {
      i12 = i3;
      i3 = i4;
      i4 = i12;
     } else break;
    }
    HEAP32[i3 >> 2] = i5;
    i12 = i3 + 4 | 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   }
   i3 = i2 + 20 | 0;
   if ((i3 | 0) == (i13 | 0)) break; else {
    i12 = i2;
    i2 = i3;
    i3 = i12;
   }
  }
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 84) {
  STACKTOP = i15;
  return;
 }
}

function __ZN5physx2Gu13GeometryUnion17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i2 + 832 | 0;
 i14 = i2 + 800 | 0;
 i13 = i2 + 768 | 0;
 i17 = i2 + 736 | 0;
 i26 = i2 + 480 | 0;
 i25 = i2 + 448 | 0;
 i24 = i2 + 352 | 0;
 i23 = i2 + 320 | 0;
 i22 = i2 + 224 | 0;
 i21 = i2 + 160 | 0;
 i29 = i2 + 704 | 0;
 i28 = i2 + 672 | 0;
 i27 = i2 + 640 | 0;
 i20 = i2 + 608 | 0;
 i19 = i2 + 576 | 0;
 i18 = i2 + 544 | 0;
 i16 = i2 + 512 | 0;
 i12 = i2 + 416 | 0;
 i11 = i2 + 384 | 0;
 i10 = i2 + 288 | 0;
 i9 = i2 + 256 | 0;
 i8 = i2 + 192 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i29 >> 2] = HEAP32[gb + 137348 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 137348 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 137348 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 137348 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 137348 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 137348 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 137348 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 137348 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 137380 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 137380 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 137380 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 137380 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 137380 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 137380 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 137380 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 137380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 137444 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 137444 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 137444 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 137444 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 137444 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 137444 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 137444 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 137444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 137476 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 137476 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 137476 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 137476 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 137476 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 137476 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 137476 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 137476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 137508 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 137508 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 137508 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 137508 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 137508 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 137508 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 137508 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 137508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 137540 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 137540 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 137540 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 137540 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 137540 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 137540 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 137540 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 137540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 137572 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 137572 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 137572 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 137572 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 137572 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 137572 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 137572 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 137572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137604 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137604 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137604 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137604 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137604 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137604 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137604 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137604 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 137444 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 137444 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 137444 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 137444 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 137444 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 137444 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 137444 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 137444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 137636 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 137636 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 137636 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 137636 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 137636 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 137636 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 137636 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 137636 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 137668 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 137668 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 137668 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 137668 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 137668 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 137668 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 137668 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 137668 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 137700 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 137700 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 137700 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 137700 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 137700 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 137700 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 137700 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 137700 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 137732 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 137732 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 137732 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 137732 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 137732 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 137732 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 137732 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 137732 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 137764 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 137764 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 137764 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 137764 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 137764 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 137764 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 137764 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 137764 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 137796 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 137796 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 137796 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 137796 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 137796 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 137796 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 137796 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 137796 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 137828 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 137828 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 137828 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 137828 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 137828 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 137828 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 137828 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 137828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 137860 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 137860 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 137860 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 137860 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 137860 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 137860 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 137860 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 137860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 137892 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 137892 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 137892 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 137892 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 137892 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 137892 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 137892 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 137892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 137924 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 137924 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 137924 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 137924 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 137924 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 137924 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 137924 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 137924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 137956 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 137956 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 137956 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 137956 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 137956 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 137956 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 137956 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 137956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 137988 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 137988 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 137988 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 137988 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 137988 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 137988 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 137988 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 137988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 138020 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 138020 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 138020 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 138020 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 138020 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 138020 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 138020 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 138020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 138052 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 138052 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 138052 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 138052 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 138052 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 138052 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 138052 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 138052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 138084 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 138084 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 138084 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 138084 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 138084 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 138084 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 138084 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 138084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 138116 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 138116 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 138116 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 138116 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 138116 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 138116 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 138116 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 138116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 138148 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 138148 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 138148 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 138148 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 138148 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 138148 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 138148 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 138148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 138180 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 138180 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 138180 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 138180 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 138180 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 138180 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 138180 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 138180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 138212 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 138212 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 138212 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 138212 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 138212 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 138212 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 138212 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 138212 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 138244 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 138244 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 138244 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 138244 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 138244 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 138244 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 138244 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 138244 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 138276 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 138276 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 138276 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 138276 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 138276 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 138276 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 138276 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 138276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 138308 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 138308 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 138308 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 138308 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 138308 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 138308 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 138308 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 138308 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 138340 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 138340 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 138340 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 138340 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 138340 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 138340 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 138340 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 138340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 138276 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 138276 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 138276 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 138276 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 138276 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 138276 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 138276 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 138276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 138372 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 138372 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 138372 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 138372 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 138372 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 138372 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 138372 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 138372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 138404 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 138404 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 138404 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 138404 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 138404 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 138404 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 138404 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 138404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 138436 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 138436 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 138436 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 138436 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 138436 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 138436 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 138436 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 138436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 137412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 137412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 137412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 137412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 137412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 137412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 137412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 137412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 138468 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 138468 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 138468 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 138468 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 138468 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 138468 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 138468 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 138468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 138500 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 138500 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 138500 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 138500 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 138500 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 138500 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 138500 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 138500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 138532 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 138532 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 138532 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 138532 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 138532 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 138532 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 138532 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 138532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 138564 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 138564 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 138564 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 138564 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 138564 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 138564 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 138564 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 138564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 138596 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 138596 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 138596 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 138596 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 138596 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 138596 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 138596 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 138596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 138628 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 138628 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 138628 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 138628 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 138628 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 138628 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 138628 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 138628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 138660 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 138660 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 138660 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 138660 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 138660 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 138660 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 138660 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 138660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 138692 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 138692 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 138692 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 138692 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 138692 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 138692 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 138692 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 138692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 138724 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 138724 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 138724 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 138724 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 138724 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 138724 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 138724 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 138724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 138756 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 138756 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 138756 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 138756 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 138756 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 138756 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 138756 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 138756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 138788 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 138788 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 138788 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 138788 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 138788 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 138788 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 138788 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 138788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z15GetPositionMeshIL20MeshDistributionMode1ELb1EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i53, i54, i58, i14, i15, i59, i60, i11, i1, i61, i55, i12, i13) {
 i53 = i53 | 0;
 i54 = i54 | 0;
 i58 = i58 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i55 = i55 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i62 + 384 | 0;
 i17 = i62 + 240 | 0;
 i49 = i62 + 96 | 0;
 i57 = i62 + 48 | 0;
 i16 = i62;
 i21 = HEAP32[i12 >> 2] | 0;
 i52 = i12 + 4 | 0;
 i22 = HEAP32[i52 >> 2] | 0;
 i51 = i12 + 8 | 0;
 i23 = HEAP32[i51 >> 2] | 0;
 i10 = i12 + 12 | 0;
 i24 = HEAP32[i10 >> 2] | 0;
 i21 = i21 << 11 ^ i21;
 i22 = i22 << 11 ^ i22;
 i23 = i23 << 11 ^ i23;
 i24 = i24 << 11 ^ i24;
 i47 = i12 + 16 | 0;
 i27 = i12 + 20 | 0;
 i20 = HEAP32[i27 >> 2] | 0;
 i26 = i12 + 24 | 0;
 i19 = HEAP32[i26 >> 2] | 0;
 i25 = i12 + 28 | 0;
 i18 = HEAP32[i25 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i52 >> 2] = i20;
 HEAP32[i51 >> 2] = i19;
 HEAP32[i10 >> 2] = i18;
 i10 = i12 + 32 | 0;
 i18 = i12 + 36 | 0;
 i51 = HEAP32[i18 >> 2] | 0;
 i19 = i12 + 40 | 0;
 i52 = HEAP32[i19 >> 2] | 0;
 i20 = i12 + 44 | 0;
 i48 = HEAP32[i20 >> 2] | 0;
 HEAP32[i47 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i27 >> 2] = i51;
 HEAP32[i26 >> 2] = i52;
 HEAP32[i25 >> 2] = i48;
 i25 = i12 + 48 | 0;
 i48 = HEAP32[i25 >> 2] | 0;
 i26 = i12 + 52 | 0;
 i52 = HEAP32[i26 >> 2] | 0;
 i27 = i12 + 56 | 0;
 i51 = HEAP32[i27 >> 2] | 0;
 i47 = i12 + 60 | 0;
 i50 = HEAP32[i47 >> 2] | 0;
 HEAP32[i10 >> 2] = i48;
 HEAP32[i18 >> 2] = i52;
 HEAP32[i19 >> 2] = i51;
 HEAP32[i20 >> 2] = i50;
 i48 = i21 >>> 8 ^ i21 ^ i48 ^ i48 >>> 19;
 i52 = i22 >>> 8 ^ i22 ^ i52 ^ i52 >>> 19;
 i51 = i23 >>> 8 ^ i23 ^ i51 ^ i51 >>> 19;
 i50 = i24 >>> 8 ^ i24 ^ i50 ^ i50 >>> 19;
 HEAP32[i25 >> 2] = i48;
 HEAP32[i26 >> 2] = i52;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i47 >> 2] = i50;
 f3 = Math_fround(Math_fround(i48 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(i52 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(i51 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f46 = Math_fround(Math_fround(i50 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f42 = Math_fround(f3 * Math_fround(0.0));
 f43 = Math_fround(f4 * Math_fround(0.0));
 f44 = Math_fround(f5 * Math_fround(0.0));
 f45 = Math_fround(f46 * Math_fround(0.0));
 f3 = Math_fround(Math_fround(1.0) - f3);
 f4 = Math_fround(Math_fround(1.0) - f4);
 f5 = Math_fround(Math_fround(1.0) - f5);
 f46 = Math_fround(Math_fround(1.0) - f46);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f42 + Math_fround(f3 * f6));
 f4 = Math_fround(f43 + Math_fround(f4 * f6));
 f5 = Math_fround(f44 + Math_fround(f5 * f6));
 f6 = Math_fround(f45 + Math_fround(f46 * f6));
 i50 = i56 + 12 | 0;
 i51 = i56 + 8 | 0;
 i52 = i56 + 4 | 0;
 HEAP32[i56 >> 2] = -1;
 HEAP32[i56 + 4 >> 2] = -1;
 HEAP32[i56 + 8 >> 2] = -1;
 HEAP32[i56 + 12 >> 2] = -1;
 do if ((i11 | 0) > 0) {
  i1 = 0;
  f2 = Math_fround(0.0);
  i7 = -1;
  i8 = -1;
  i9 = -1;
  i10 = -1;
  while (1) {
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i60 + (i1 << 4) + 4 >> 2]));
   i47 = (i7 | 0) != -1;
   i26 = (i8 | 0) != -1;
   i48 = (i9 | 0) != -1;
   i27 = (i10 | 0) != -1;
   i22 = i47 ? 0 : (f3 <= f2) << 31 >> 31;
   i23 = i26 ? 0 : (f4 <= f2) << 31 >> 31;
   i24 = i48 ? 0 : (f5 <= f2) << 31 >> 31;
   i25 = i27 ? 0 : (f6 <= f2) << 31 >> 31;
   i7 = i7 & ~i22 | i22 & i1;
   i8 = i8 & ~i23 | i23 & i1;
   i9 = i9 & ~i24 | i24 & i1;
   i10 = i10 & ~i25 | i25 & i1;
   i1 = i1 + 1 | 0;
   if (i26 & (i27 & (i47 & i48))) {
    i1 = 4;
    break;
   }
   if ((i1 | 0) >= (i11 | 0)) {
    i1 = 5;
    break;
   }
  }
  if ((i1 | 0) == 4) {
   HEAP32[i56 >> 2] = i7;
   HEAP32[i52 >> 2] = i8;
   HEAP32[i51 >> 2] = i9;
   HEAP32[i50 >> 2] = i10;
   break;
  } else if ((i1 | 0) == 5) {
   HEAP32[i56 >> 2] = i7;
   HEAP32[i52 >> 2] = i8;
   HEAP32[i51 >> 2] = i9;
   HEAP32[i50 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i17, i49, i57);
 HEAP32[i16 + 12 >> 2] = 1;
 HEAP32[i16 + 8 >> 2] = 1;
 HEAP32[i16 + 4 >> 2] = 1;
 HEAP32[i16 >> 2] = 1;
 i19 = i17 + 48 | 0;
 i7 = i49 + 48 | 0;
 i47 = i57 + 16 | 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i19, i7, i47);
 HEAP32[i16 + 12 >> 2] = 2;
 HEAP32[i16 + 8 >> 2] = 2;
 HEAP32[i16 + 4 >> 2] = 2;
 HEAP32[i16 >> 2] = 2;
 i18 = i17 + 96 | 0;
 i1 = i49 + 96 | 0;
 i48 = i57 + 32 | 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i18, i1, i48);
 __Z26RandomBarycentricCoordEdgeR5RandN(i16, i12);
 f36 = Math_fround(HEAPF32[i16 >> 2]);
 f37 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f40 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f41 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f43 = Math_fround(HEAPF32[i16 + 28 >> 2]);
 f44 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f45 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f46 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f35 = Math_fround(HEAPF32[i16 + 44 >> 2]);
 f33 = Math_fround(f36 * Math_fround(HEAPF32[i17 >> 2]));
 f32 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 4 >> 2]));
 f31 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 8 >> 2]));
 f30 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 12 >> 2]));
 f29 = Math_fround(f36 * Math_fround(HEAPF32[i17 + 16 >> 2]));
 f28 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 20 >> 2]));
 f6 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 24 >> 2]));
 f5 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 28 >> 2]));
 f4 = Math_fround(f36 * Math_fround(HEAPF32[i17 + 32 >> 2]));
 f3 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 36 >> 2]));
 f2 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 40 >> 2]));
 f34 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 44 >> 2]));
 f73 = Math_fround(f40 * Math_fround(HEAPF32[i19 >> 2]));
 f63 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 52 >> 2]));
 f64 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 56 >> 2]));
 f65 = Math_fround(f43 * Math_fround(HEAPF32[i17 + 60 >> 2]));
 f66 = Math_fround(f40 * Math_fround(HEAPF32[i17 + 64 >> 2]));
 f67 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 68 >> 2]));
 f68 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 72 >> 2]));
 f69 = Math_fround(f43 * Math_fround(HEAPF32[i17 + 76 >> 2]));
 f70 = Math_fround(f40 * Math_fround(HEAPF32[i17 + 80 >> 2]));
 f71 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 84 >> 2]));
 f72 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 88 >> 2]));
 f73 = Math_fround(f33 + f73);
 f63 = Math_fround(f32 + f63);
 f64 = Math_fround(f31 + f64);
 f65 = Math_fround(f30 + f65);
 f66 = Math_fround(f29 + f66);
 f67 = Math_fround(f28 + f67);
 f68 = Math_fround(f6 + f68);
 f69 = Math_fround(f5 + f69);
 f70 = Math_fround(f4 + f70);
 f71 = Math_fround(f3 + f71);
 f72 = Math_fround(f2 + f72);
 f34 = Math_fround(f34 + Math_fround(f43 * Math_fround(HEAPF32[i17 + 92 >> 2])));
 f2 = Math_fround(f44 * Math_fround(HEAPF32[i18 >> 2]));
 f3 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 100 >> 2]));
 f4 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 104 >> 2]));
 f5 = Math_fround(f35 * Math_fround(HEAPF32[i17 + 108 >> 2]));
 f6 = Math_fround(f44 * Math_fround(HEAPF32[i17 + 112 >> 2]));
 f28 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 116 >> 2]));
 f29 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 120 >> 2]));
 f30 = Math_fround(f35 * Math_fround(HEAPF32[i17 + 124 >> 2]));
 f31 = Math_fround(f44 * Math_fround(HEAPF32[i17 + 128 >> 2]));
 f32 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 132 >> 2]));
 f33 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 136 >> 2]));
 f3 = Math_fround(f63 + f3);
 f4 = Math_fround(f64 + f4);
 f5 = Math_fround(f65 + f5);
 f6 = Math_fround(f66 + f6);
 f28 = Math_fround(f67 + f28);
 f29 = Math_fround(f68 + f29);
 f30 = Math_fround(f69 + f30);
 f31 = Math_fround(f70 + f31);
 f32 = Math_fround(f71 + f32);
 f33 = Math_fround(f72 + f33);
 f34 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i17 + 140 >> 2])));
 HEAPF32[i53 >> 2] = Math_fround(f73 + f2);
 i17 = i53 + 4 | 0;
 HEAPF32[i17 >> 2] = f3;
 i18 = i53 + 8 | 0;
 HEAPF32[i18 >> 2] = f4;
 i19 = i53 + 12 | 0;
 HEAPF32[i19 >> 2] = f5;
 i20 = i53 + 16 | 0;
 HEAPF32[i20 >> 2] = f6;
 i21 = i53 + 20 | 0;
 HEAPF32[i21 >> 2] = f28;
 i22 = i53 + 24 | 0;
 HEAPF32[i22 >> 2] = f29;
 i23 = i53 + 28 | 0;
 HEAPF32[i23 >> 2] = f30;
 i24 = i53 + 32 | 0;
 HEAPF32[i24 >> 2] = f31;
 i25 = i53 + 36 | 0;
 HEAPF32[i25 >> 2] = f32;
 i26 = i53 + 40 | 0;
 HEAPF32[i26 >> 2] = f33;
 i27 = i53 + 44 | 0;
 HEAPF32[i27 >> 2] = f34;
 f34 = Math_fround(f36 * Math_fround(HEAPF32[i49 >> 2]));
 f33 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 4 >> 2]));
 f32 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 8 >> 2]));
 f31 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 12 >> 2]));
 f30 = Math_fround(f36 * Math_fround(HEAPF32[i49 + 16 >> 2]));
 f29 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 20 >> 2]));
 f28 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 24 >> 2]));
 f6 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 28 >> 2]));
 f5 = Math_fround(f36 * Math_fround(HEAPF32[i49 + 32 >> 2]));
 f4 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 36 >> 2]));
 f3 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 40 >> 2]));
 f2 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 44 >> 2]));
 f73 = Math_fround(f40 * Math_fround(HEAPF32[i7 >> 2]));
 f72 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 52 >> 2]));
 f71 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 56 >> 2]));
 f70 = Math_fround(f43 * Math_fround(HEAPF32[i49 + 60 >> 2]));
 f69 = Math_fround(f40 * Math_fround(HEAPF32[i49 + 64 >> 2]));
 f68 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 68 >> 2]));
 f67 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 72 >> 2]));
 f66 = Math_fround(f43 * Math_fround(HEAPF32[i49 + 76 >> 2]));
 f65 = Math_fround(f40 * Math_fround(HEAPF32[i49 + 80 >> 2]));
 f64 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 84 >> 2]));
 f63 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 88 >> 2]));
 f73 = Math_fround(f34 + f73);
 f72 = Math_fround(f33 + f72);
 f71 = Math_fround(f32 + f71);
 f70 = Math_fround(f31 + f70);
 f69 = Math_fround(f30 + f69);
 f68 = Math_fround(f29 + f68);
 f67 = Math_fround(f28 + f67);
 f66 = Math_fround(f6 + f66);
 f65 = Math_fround(f5 + f65);
 f64 = Math_fround(f4 + f64);
 f63 = Math_fround(f3 + f63);
 f2 = Math_fround(f2 + Math_fround(f43 * Math_fround(HEAPF32[i49 + 92 >> 2])));
 f3 = Math_fround(f44 * Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 100 >> 2]));
 f5 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 104 >> 2]));
 f6 = Math_fround(f35 * Math_fround(HEAPF32[i49 + 108 >> 2]));
 f28 = Math_fround(f44 * Math_fround(HEAPF32[i49 + 112 >> 2]));
 f29 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 116 >> 2]));
 f30 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 120 >> 2]));
 f31 = Math_fround(f35 * Math_fround(HEAPF32[i49 + 124 >> 2]));
 f32 = Math_fround(f44 * Math_fround(HEAPF32[i49 + 128 >> 2]));
 f33 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 132 >> 2]));
 f34 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 136 >> 2]));
 f3 = Math_fround(f73 + f3);
 f4 = Math_fround(f72 + f4);
 f5 = Math_fround(f71 + f5);
 f6 = Math_fround(f70 + f6);
 f28 = Math_fround(f69 + f28);
 f29 = Math_fround(f68 + f29);
 f30 = Math_fround(f67 + f30);
 f31 = Math_fround(f66 + f31);
 f32 = Math_fround(f65 + f32);
 f33 = Math_fround(f64 + f33);
 f34 = Math_fround(f63 + f34);
 f2 = Math_fround(f2 + Math_fround(f35 * Math_fround(HEAPF32[i49 + 140 >> 2])));
 HEAPF32[i54 >> 2] = f3;
 i1 = i54 + 4 | 0;
 HEAPF32[i1 >> 2] = f4;
 i7 = i54 + 8 | 0;
 HEAPF32[i7 >> 2] = f5;
 i8 = i54 + 12 | 0;
 HEAPF32[i8 >> 2] = f6;
 i9 = i54 + 16 | 0;
 HEAPF32[i9 >> 2] = f28;
 i10 = i54 + 20 | 0;
 HEAPF32[i10 >> 2] = f29;
 i11 = i54 + 24 | 0;
 HEAPF32[i11 >> 2] = f30;
 i12 = i54 + 28 | 0;
 HEAPF32[i12 >> 2] = f31;
 i13 = i54 + 32 | 0;
 HEAPF32[i13 >> 2] = f32;
 i14 = i54 + 36 | 0;
 HEAPF32[i14 >> 2] = f33;
 i15 = i54 + 40 | 0;
 HEAPF32[i15 >> 2] = f34;
 i16 = i54 + 44 | 0;
 HEAPF32[i16 >> 2] = f2;
 if (!(HEAP32[i59 + 4 >> 2] | 0)) {
  i54 = HEAP32[i60 + (HEAP32[i52 >> 2] << 4) >> 2] | 0;
  i57 = HEAP32[i60 + (HEAP32[i51 >> 2] << 4) >> 2] | 0;
  i59 = HEAP32[i60 + (HEAP32[i50 >> 2] << 4) >> 2] | 0;
  HEAP32[i58 >> 2] = HEAP32[i60 + (HEAP32[i56 >> 2] << 4) >> 2];
  HEAP32[i58 + 4 >> 2] = i54;
  HEAP32[i58 + 8 >> 2] = i57;
  HEAP32[i58 + 12 >> 2] = i59;
  f35 = f4;
  f36 = f5;
  f37 = f6;
  f42 = f28;
  f43 = f29;
  f44 = f30;
  f45 = f31;
  f66 = f32;
  f67 = f33;
  f68 = f34;
  f69 = f2;
  f33 = Math_fround(HEAPF32[i55 >> 2]);
  f38 = Math_fround(HEAPF32[i53 >> 2]);
  f38 = Math_fround(f33 * f38);
  f39 = Math_fround(HEAPF32[i17 >> 2]);
  f39 = Math_fround(f33 * f39);
  f40 = Math_fround(HEAPF32[i18 >> 2]);
  f40 = Math_fround(f33 * f40);
  f41 = Math_fround(HEAPF32[i19 >> 2]);
  f41 = Math_fround(f33 * f41);
  i59 = i53 + 16 | 0;
  f46 = Math_fround(HEAPF32[i59 >> 2]);
  f46 = Math_fround(f33 * f46);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f63 = Math_fround(f33 * f63);
  f64 = Math_fround(HEAPF32[i22 >> 2]);
  f64 = Math_fround(f33 * f64);
  f65 = Math_fround(HEAPF32[i23 >> 2]);
  f65 = Math_fround(f33 * f65);
  i60 = i53 + 32 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f33 * f70);
  f71 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(f33 * f71);
  f72 = Math_fround(HEAPF32[i26 >> 2]);
  f72 = Math_fround(f33 * f72);
  f73 = Math_fround(HEAPF32[i27 >> 2]);
  f73 = Math_fround(f33 * f73);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  HEAPF32[i24 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  f33 = Math_fround(HEAPF32[i61 >> 2]);
  f34 = Math_fround(f33 * f3);
  f35 = Math_fround(f33 * f35);
  f36 = Math_fround(f33 * f36);
  f37 = Math_fround(f33 * f37);
  f42 = Math_fround(f33 * f42);
  f43 = Math_fround(f33 * f43);
  f44 = Math_fround(f33 * f44);
  f45 = Math_fround(f33 * f45);
  f66 = Math_fround(f33 * f66);
  f67 = Math_fround(f33 * f67);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f33 * f69);
  f38 = Math_fround(f34 + f38);
  f39 = Math_fround(f35 + f39);
  f40 = Math_fround(f36 + f40);
  f41 = Math_fround(f37 + f41);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  f46 = Math_fround(f42 + f46);
  f63 = Math_fround(f43 + f63);
  f64 = Math_fround(f44 + f64);
  f65 = Math_fround(f45 + f65);
  HEAPF32[i59 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  f70 = Math_fround(f66 + f70);
  f71 = Math_fround(f67 + f71);
  f72 = Math_fround(f68 + f72);
  f73 = Math_fround(f69 + f73);
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  STACKTOP = i62;
  return;
 } else {
  i74 = ~~Math_fround(f36 * Math_fround(255.0));
  i50 = ~~Math_fround(f37 * Math_fround(255.0));
  i81 = ~~Math_fround(f38 * Math_fround(255.0));
  i77 = ~~Math_fround(f39 * Math_fround(255.0));
  i85 = HEAP32[i57 >> 2] | 0;
  i52 = HEAP32[i57 + 4 >> 2] | 0;
  i59 = HEAP32[i57 + 8 >> 2] | 0;
  i56 = HEAP32[i57 + 12 >> 2] | 0;
  i78 = (Math_imul(i85 & 255, i74 & 255) | 0) + 128 | 0;
  i78 = ((i78 >>> 8) + i78 | 0) >>> 8;
  i76 = (Math_imul(i85 >>> 8 & 255, i74 >>> 8 & 255) | 0) + 128 | 0;
  i76 = (i76 >>> 8) + i76 & 261888 | i78;
  i79 = (Math_imul(i85 >>> 16 & 255, i74 >>> 16 & 255) | 0) + 128 | 0;
  i74 = (Math_imul(i85 >>> 24, i74 >>> 24) | 0) + 128 | 0;
  i79 = i76 | ((i74 >>> 8) + i74 | 0) >>> 8 << 24 | ((i79 >>> 8) + i79 | 0) >>> 8 << 16;
  i74 = (Math_imul(i52 & 255, i50 & 255) | 0) + 128 | 0;
  i74 = ((i74 >>> 8) + i74 | 0) >>> 8;
  i85 = (Math_imul(i52 >>> 8 & 255, i50 >>> 8 & 255) | 0) + 128 | 0;
  i85 = (i85 >>> 8) + i85 & 261888 | i74;
  i89 = (Math_imul(i52 >>> 16 & 255, i50 >>> 16 & 255) | 0) + 128 | 0;
  i50 = (Math_imul(i52 >>> 24, i50 >>> 24) | 0) + 128 | 0;
  i89 = i85 | ((i50 >>> 8) + i50 | 0) >>> 8 << 24 | ((i89 >>> 8) + i89 | 0) >>> 8 << 16;
  i50 = (Math_imul(i59 & 255, i81 & 255) | 0) + 128 | 0;
  i50 = ((i50 >>> 8) + i50 | 0) >>> 8;
  i52 = (Math_imul(i59 >>> 8 & 255, i81 >>> 8 & 255) | 0) + 128 | 0;
  i52 = (i52 >>> 8) + i52 & 261888 | i50;
  i88 = (Math_imul(i59 >>> 16 & 255, i81 >>> 16 & 255) | 0) + 128 | 0;
  i81 = (Math_imul(i59 >>> 24, i81 >>> 24) | 0) + 128 | 0;
  i88 = i52 | ((i81 >>> 8) + i81 | 0) >>> 8 << 24 | ((i88 >>> 8) + i88 | 0) >>> 8 << 16;
  i81 = (Math_imul(i56 & 255, i77 & 255) | 0) + 128 | 0;
  i81 = ((i81 >>> 8) + i81 | 0) >>> 8;
  i59 = (Math_imul(i56 >>> 8 & 255, i77 >>> 8 & 255) | 0) + 128 | 0;
  i59 = (i59 >>> 8) + i59 & 261888 | i81;
  i83 = (Math_imul(i56 >>> 16 & 255, i77 >>> 16 & 255) | 0) + 128 | 0;
  i77 = (Math_imul(i56 >>> 24, i77 >>> 24) | 0) + 128 | 0;
  i83 = i59 | ((i77 >>> 8) + i77 | 0) >>> 8 << 24 | ((i83 >>> 8) + i83 | 0) >>> 8 << 16;
  i77 = ~~Math_fround(f40 * Math_fround(255.0));
  i56 = ~~Math_fround(f41 * Math_fround(255.0));
  i60 = ~~Math_fround(f42 * Math_fround(255.0));
  i90 = ~~Math_fround(f43 * Math_fround(255.0));
  i84 = HEAP32[i47 >> 2] | 0;
  i82 = HEAP32[i57 + 20 >> 2] | 0;
  i80 = HEAP32[i57 + 24 >> 2] | 0;
  i91 = HEAP32[i57 + 28 >> 2] | 0;
  i49 = (Math_imul(i84 & 255, i77 & 255) | 0) + 128 | 0;
  i49 = ((i49 >>> 8) + i49 | 0) >>> 8;
  i86 = (Math_imul(i84 >>> 8 & 255, i77 >>> 8 & 255) | 0) + 128 | 0;
  i86 = (i86 >>> 8) + i86 & 261888 | i49;
  i75 = (Math_imul(i84 >>> 16 & 255, i77 >>> 16 & 255) | 0) + 128 | 0;
  i77 = (Math_imul(i84 >>> 24, i77 >>> 24) | 0) + 128 | 0;
  i75 = i86 | ((i77 >>> 8) + i77 | 0) >>> 8 << 24 | ((i75 >>> 8) + i75 | 0) >>> 8 << 16;
  i77 = (Math_imul(i82 & 255, i56 & 255) | 0) + 128 | 0;
  i77 = ((i77 >>> 8) + i77 | 0) >>> 8;
  i84 = (Math_imul(i82 >>> 8 & 255, i56 >>> 8 & 255) | 0) + 128 | 0;
  i84 = (i84 >>> 8) + i84 & 261888 | i77;
  i87 = (Math_imul(i82 >>> 16 & 255, i56 >>> 16 & 255) | 0) + 128 | 0;
  i56 = (Math_imul(i82 >>> 24, i56 >>> 24) | 0) + 128 | 0;
  i87 = i84 | ((i56 >>> 8) + i56 | 0) >>> 8 << 24 | ((i87 >>> 8) + i87 | 0) >>> 8 << 16;
  i56 = (Math_imul(i80 & 255, i60 & 255) | 0) + 128 | 0;
  i56 = ((i56 >>> 8) + i56 | 0) >>> 8;
  i82 = (Math_imul(i80 >>> 8 & 255, i60 >>> 8 & 255) | 0) + 128 | 0;
  i82 = (i82 >>> 8) + i82 & 261888 | i56;
  i51 = (Math_imul(i80 >>> 16 & 255, i60 >>> 16 & 255) | 0) + 128 | 0;
  i60 = (Math_imul(i80 >>> 24, i60 >>> 24) | 0) + 128 | 0;
  i51 = i82 | ((i60 >>> 8) + i60 | 0) >>> 8 << 24 | ((i51 >>> 8) + i51 | 0) >>> 8 << 16;
  i60 = (Math_imul(i91 & 255, i90 & 255) | 0) + 128 | 0;
  i60 = ((i60 >>> 8) + i60 | 0) >>> 8;
  i80 = (Math_imul(i91 >>> 8 & 255, i90 >>> 8 & 255) | 0) + 128 | 0;
  i80 = (i80 >>> 8) + i80 & 261888 | i60;
  i47 = (Math_imul(i91 >>> 16 & 255, i90 >>> 16 & 255) | 0) + 128 | 0;
  i90 = (Math_imul(i91 >>> 24, i90 >>> 24) | 0) + 128 | 0;
  i47 = i80 | ((i90 >>> 8) + i90 | 0) >>> 8 << 24 | ((i47 >>> 8) + i47 | 0) >>> 8 << 16;
  i78 = (i49 & 255) + (i78 & 255) | 0;
  i78 = i78 >>> 0 < 255 ? i78 : 255;
  i76 = (i86 >>> 8 & 255) + (i76 >>> 8 & 255) | 0;
  i86 = (i75 >>> 16 & 255) + (i79 >>> 16 & 255) | 0;
  i79 = (i75 >>> 24) + (i79 >>> 24) | 0;
  i76 = (i76 >>> 0 < 255 ? i76 : 255) << 8 | i78;
  i86 = i76 | (i79 >>> 0 < 255 ? i79 : 255) << 24 | (i86 >>> 0 < 255 ? i86 : 255) << 16;
  i74 = (i77 & 255) + (i74 & 255) | 0;
  i74 = i74 >>> 0 < 255 ? i74 : 255;
  i85 = (i84 >>> 8 & 255) + (i85 >>> 8 & 255) | 0;
  i84 = (i87 >>> 16 & 255) + (i89 >>> 16 & 255) | 0;
  i89 = (i87 >>> 24) + (i89 >>> 24) | 0;
  i85 = (i85 >>> 0 < 255 ? i85 : 255) << 8 | i74;
  i84 = i85 | (i89 >>> 0 < 255 ? i89 : 255) << 24 | (i84 >>> 0 < 255 ? i84 : 255) << 16;
  i50 = (i56 & 255) + (i50 & 255) | 0;
  i50 = i50 >>> 0 < 255 ? i50 : 255;
  i52 = (i82 >>> 8 & 255) + (i52 >>> 8 & 255) | 0;
  i82 = (i51 >>> 16 & 255) + (i88 >>> 16 & 255) | 0;
  i88 = (i51 >>> 24) + (i88 >>> 24) | 0;
  i52 = (i52 >>> 0 < 255 ? i52 : 255) << 8 | i50;
  i82 = i52 | (i88 >>> 0 < 255 ? i88 : 255) << 24 | (i82 >>> 0 < 255 ? i82 : 255) << 16;
  i81 = (i60 & 255) + (i81 & 255) | 0;
  i81 = i81 >>> 0 < 255 ? i81 : 255;
  i59 = (i80 >>> 8 & 255) + (i59 >>> 8 & 255) | 0;
  i80 = (i47 >>> 16 & 255) + (i83 >>> 16 & 255) | 0;
  i47 = (i47 >>> 24) + (i83 >>> 24) | 0;
  i59 = (i59 >>> 0 < 255 ? i59 : 255) << 8 | i81;
  i80 = i59 | (i47 >>> 0 < 255 ? i47 : 255) << 24 | (i80 >>> 0 < 255 ? i80 : 255) << 16;
  i47 = ~~Math_fround(f44 * Math_fround(255.0));
  i83 = ~~Math_fround(f45 * Math_fround(255.0));
  i60 = ~~Math_fround(f46 * Math_fround(255.0));
  i88 = ~~Math_fround(f35 * Math_fround(255.0));
  i48 = HEAP32[i48 >> 2] | 0;
  i51 = HEAP32[i57 + 36 >> 2] | 0;
  i56 = HEAP32[i57 + 40 >> 2] | 0;
  i89 = HEAP32[i57 + 44 >> 2] | 0;
  i87 = (Math_imul(i48 & 255, i47 & 255) | 0) + 128 | 0;
  i87 = ((i87 >>> 8) + i87 | 0) >>> 8;
  i77 = (Math_imul(i48 >>> 8 & 255, i47 >>> 8 & 255) | 0) + 128 | 0;
  i77 = (i77 >>> 8) + i77 & 261888 | i87;
  i79 = (Math_imul(i48 >>> 16 & 255, i47 >>> 16 & 255) | 0) + 128 | 0;
  i48 = (Math_imul(i48 >>> 24, i47 >>> 24) | 0) + 128 | 0;
  i79 = i77 | ((i48 >>> 8) + i48 | 0) >>> 8 << 24 | ((i79 >>> 8) + i79 | 0) >>> 8 << 16;
  i48 = (Math_imul(i51 & 255, i83 & 255) | 0) + 128 | 0;
  i48 = ((i48 >>> 8) + i48 | 0) >>> 8;
  i47 = (Math_imul(i51 >>> 8 & 255, i83 >>> 8 & 255) | 0) + 128 | 0;
  i47 = (i47 >>> 8) + i47 & 261888 | i48;
  i75 = (Math_imul(i51 >>> 16 & 255, i83 >>> 16 & 255) | 0) + 128 | 0;
  i83 = (Math_imul(i51 >>> 24, i83 >>> 24) | 0) + 128 | 0;
  i75 = i47 | ((i83 >>> 8) + i83 | 0) >>> 8 << 24 | ((i75 >>> 8) + i75 | 0) >>> 8 << 16;
  i83 = (Math_imul(i56 & 255, i60 & 255) | 0) + 128 | 0;
  i83 = ((i83 >>> 8) + i83 | 0) >>> 8;
  i51 = (Math_imul(i56 >>> 8 & 255, i60 >>> 8 & 255) | 0) + 128 | 0;
  i51 = (i51 >>> 8) + i51 & 261888 | i83;
  i49 = (Math_imul(i56 >>> 16 & 255, i60 >>> 16 & 255) | 0) + 128 | 0;
  i57 = (Math_imul(i56 >>> 24, i60 >>> 24) | 0) + 128 | 0;
  i49 = i51 | ((i57 >>> 8) + i57 | 0) >>> 8 << 24 | ((i49 >>> 8) + i49 | 0) >>> 8 << 16;
  i57 = (Math_imul(i89 & 255, i88 & 255) | 0) + 128 | 0;
  i57 = ((i57 >>> 8) + i57 | 0) >>> 8;
  i60 = (Math_imul(i89 >>> 8 & 255, i88 >>> 8 & 255) | 0) + 128 | 0;
  i60 = (i60 >>> 8) + i60 & 261888 | i57;
  i56 = (Math_imul(i89 >>> 16 & 255, i88 >>> 16 & 255) | 0) + 128 | 0;
  i88 = (Math_imul(i89 >>> 24, i88 >>> 24) | 0) + 128 | 0;
  i56 = i60 | ((i88 >>> 8) + i88 | 0) >>> 8 << 24 | ((i56 >>> 8) + i56 | 0) >>> 8 << 16;
  i78 = (i87 & 255) + (i78 & 255) | 0;
  i77 = (i76 >>> 8 & 255) + (i77 >>> 8 & 255) | 0;
  i76 = (i86 >>> 16 & 255) + (i79 >>> 16 & 255) | 0;
  i79 = (i86 >>> 24) + (i79 >>> 24) | 0;
  i74 = (i48 & 255) + (i74 & 255) | 0;
  i47 = (i85 >>> 8 & 255) + (i47 >>> 8 & 255) | 0;
  i48 = (i84 >>> 16 & 255) + (i75 >>> 16 & 255) | 0;
  i75 = (i84 >>> 24) + (i75 >>> 24) | 0;
  i50 = (i83 & 255) + (i50 & 255) | 0;
  i51 = (i52 >>> 8 & 255) + (i51 >>> 8 & 255) | 0;
  i52 = (i82 >>> 16 & 255) + (i49 >>> 16 & 255) | 0;
  i49 = (i82 >>> 24) + (i49 >>> 24) | 0;
  i57 = (i57 & 255) + (i81 & 255) | 0;
  i60 = (i59 >>> 8 & 255) + (i60 >>> 8 & 255) | 0;
  i59 = (i80 >>> 16 & 255) + (i56 >>> 16 & 255) | 0;
  i56 = (i80 >>> 24) + (i56 >>> 24) | 0;
  HEAP32[i58 >> 2] = (i79 >>> 0 < 255 ? i79 : 255) << 24 | (i78 >>> 0 < 255 ? i78 : 255) | (i77 >>> 0 < 255 ? i77 : 255) << 8 | (i76 >>> 0 < 255 ? i76 : 255) << 16;
  HEAP32[i58 + 4 >> 2] = (i75 >>> 0 < 255 ? i75 : 255) << 24 | (i74 >>> 0 < 255 ? i74 : 255) | (i47 >>> 0 < 255 ? i47 : 255) << 8 | (i48 >>> 0 < 255 ? i48 : 255) << 16;
  HEAP32[i58 + 8 >> 2] = (i49 >>> 0 < 255 ? i49 : 255) << 24 | (i50 >>> 0 < 255 ? i50 : 255) | (i51 >>> 0 < 255 ? i51 : 255) << 8 | (i52 >>> 0 < 255 ? i52 : 255) << 16;
  HEAP32[i58 + 12 >> 2] = (i56 >>> 0 < 255 ? i56 : 255) << 24 | (i57 >>> 0 < 255 ? i57 : 255) | (i60 >>> 0 < 255 ? i60 : 255) << 8 | (i59 >>> 0 < 255 ? i59 : 255) << 16;
  f34 = Math_fround(HEAPF32[i54 >> 2]);
  f35 = Math_fround(HEAPF32[i1 >> 2]);
  f36 = Math_fround(HEAPF32[i7 >> 2]);
  f37 = Math_fround(HEAPF32[i8 >> 2]);
  f42 = Math_fround(HEAPF32[i9 >> 2]);
  f43 = Math_fround(HEAPF32[i10 >> 2]);
  f44 = Math_fround(HEAPF32[i11 >> 2]);
  f45 = Math_fround(HEAPF32[i12 >> 2]);
  f66 = Math_fround(HEAPF32[i13 >> 2]);
  f67 = Math_fround(HEAPF32[i14 >> 2]);
  f68 = Math_fround(HEAPF32[i15 >> 2]);
  f69 = Math_fround(HEAPF32[i16 >> 2]);
  f33 = Math_fround(HEAPF32[i55 >> 2]);
  f38 = Math_fround(HEAPF32[i53 >> 2]);
  f38 = Math_fround(f33 * f38);
  f39 = Math_fround(HEAPF32[i17 >> 2]);
  f39 = Math_fround(f33 * f39);
  f40 = Math_fround(HEAPF32[i18 >> 2]);
  f40 = Math_fround(f33 * f40);
  f41 = Math_fround(HEAPF32[i19 >> 2]);
  f41 = Math_fround(f33 * f41);
  i59 = i53 + 16 | 0;
  f46 = Math_fround(HEAPF32[i59 >> 2]);
  f46 = Math_fround(f33 * f46);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f63 = Math_fround(f33 * f63);
  f64 = Math_fround(HEAPF32[i22 >> 2]);
  f64 = Math_fround(f33 * f64);
  f65 = Math_fround(HEAPF32[i23 >> 2]);
  f65 = Math_fround(f33 * f65);
  i60 = i53 + 32 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f33 * f70);
  f71 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(f33 * f71);
  f72 = Math_fround(HEAPF32[i26 >> 2]);
  f72 = Math_fround(f33 * f72);
  f73 = Math_fround(HEAPF32[i27 >> 2]);
  f73 = Math_fround(f33 * f73);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  HEAPF32[i24 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  f33 = Math_fround(HEAPF32[i61 >> 2]);
  f34 = Math_fround(f33 * f34);
  f35 = Math_fround(f33 * f35);
  f36 = Math_fround(f33 * f36);
  f37 = Math_fround(f33 * f37);
  f42 = Math_fround(f33 * f42);
  f43 = Math_fround(f33 * f43);
  f44 = Math_fround(f33 * f44);
  f45 = Math_fround(f33 * f45);
  f66 = Math_fround(f33 * f66);
  f67 = Math_fround(f33 * f67);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f33 * f69);
  f38 = Math_fround(f34 + f38);
  f39 = Math_fround(f35 + f39);
  f40 = Math_fround(f36 + f40);
  f41 = Math_fround(f37 + f41);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  f46 = Math_fround(f42 + f46);
  f63 = Math_fround(f43 + f63);
  f64 = Math_fround(f44 + f64);
  f65 = Math_fround(f45 + f65);
  HEAPF32[i59 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  f70 = Math_fround(f66 + f70);
  f71 = Math_fround(f67 + f71);
  f72 = Math_fround(f68 + f72);
  f73 = Math_fround(f69 + f73);
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  STACKTOP = i62;
  return;
 }
}

function __Z15GetPositionMeshIL20MeshDistributionMode1ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i53, i54, i58, i14, i15, i59, i60, i11, i1, i61, i55, i12, i13) {
 i53 = i53 | 0;
 i54 = i54 | 0;
 i58 = i58 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i55 = i55 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i62 + 384 | 0;
 i17 = i62 + 240 | 0;
 i49 = i62 + 96 | 0;
 i57 = i62 + 48 | 0;
 i16 = i62;
 i21 = HEAP32[i12 >> 2] | 0;
 i52 = i12 + 4 | 0;
 i22 = HEAP32[i52 >> 2] | 0;
 i51 = i12 + 8 | 0;
 i23 = HEAP32[i51 >> 2] | 0;
 i10 = i12 + 12 | 0;
 i24 = HEAP32[i10 >> 2] | 0;
 i21 = i21 << 11 ^ i21;
 i22 = i22 << 11 ^ i22;
 i23 = i23 << 11 ^ i23;
 i24 = i24 << 11 ^ i24;
 i47 = i12 + 16 | 0;
 i27 = i12 + 20 | 0;
 i20 = HEAP32[i27 >> 2] | 0;
 i26 = i12 + 24 | 0;
 i19 = HEAP32[i26 >> 2] | 0;
 i25 = i12 + 28 | 0;
 i18 = HEAP32[i25 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i52 >> 2] = i20;
 HEAP32[i51 >> 2] = i19;
 HEAP32[i10 >> 2] = i18;
 i10 = i12 + 32 | 0;
 i18 = i12 + 36 | 0;
 i51 = HEAP32[i18 >> 2] | 0;
 i19 = i12 + 40 | 0;
 i52 = HEAP32[i19 >> 2] | 0;
 i20 = i12 + 44 | 0;
 i48 = HEAP32[i20 >> 2] | 0;
 HEAP32[i47 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i27 >> 2] = i51;
 HEAP32[i26 >> 2] = i52;
 HEAP32[i25 >> 2] = i48;
 i25 = i12 + 48 | 0;
 i48 = HEAP32[i25 >> 2] | 0;
 i26 = i12 + 52 | 0;
 i52 = HEAP32[i26 >> 2] | 0;
 i27 = i12 + 56 | 0;
 i51 = HEAP32[i27 >> 2] | 0;
 i47 = i12 + 60 | 0;
 i50 = HEAP32[i47 >> 2] | 0;
 HEAP32[i10 >> 2] = i48;
 HEAP32[i18 >> 2] = i52;
 HEAP32[i19 >> 2] = i51;
 HEAP32[i20 >> 2] = i50;
 i48 = i21 >>> 8 ^ i21 ^ i48 ^ i48 >>> 19;
 i52 = i22 >>> 8 ^ i22 ^ i52 ^ i52 >>> 19;
 i51 = i23 >>> 8 ^ i23 ^ i51 ^ i51 >>> 19;
 i50 = i24 >>> 8 ^ i24 ^ i50 ^ i50 >>> 19;
 HEAP32[i25 >> 2] = i48;
 HEAP32[i26 >> 2] = i52;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i47 >> 2] = i50;
 f3 = Math_fround(Math_fround(i48 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(i52 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(i51 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f46 = Math_fround(Math_fround(i50 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f42 = Math_fround(f3 * Math_fround(0.0));
 f43 = Math_fround(f4 * Math_fround(0.0));
 f44 = Math_fround(f5 * Math_fround(0.0));
 f45 = Math_fround(f46 * Math_fround(0.0));
 f3 = Math_fround(Math_fround(1.0) - f3);
 f4 = Math_fround(Math_fround(1.0) - f4);
 f5 = Math_fround(Math_fround(1.0) - f5);
 f46 = Math_fround(Math_fround(1.0) - f46);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f42 + Math_fround(f3 * f6));
 f4 = Math_fround(f43 + Math_fround(f4 * f6));
 f5 = Math_fround(f44 + Math_fround(f5 * f6));
 f6 = Math_fround(f45 + Math_fround(f46 * f6));
 i50 = i56 + 12 | 0;
 i51 = i56 + 8 | 0;
 i52 = i56 + 4 | 0;
 HEAP32[i56 >> 2] = -1;
 HEAP32[i56 + 4 >> 2] = -1;
 HEAP32[i56 + 8 >> 2] = -1;
 HEAP32[i56 + 12 >> 2] = -1;
 do if ((i11 | 0) > 0) {
  i1 = 0;
  f2 = Math_fround(0.0);
  i7 = -1;
  i8 = -1;
  i9 = -1;
  i10 = -1;
  while (1) {
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i60 + (i1 << 4) + 4 >> 2]));
   i47 = (i7 | 0) != -1;
   i26 = (i8 | 0) != -1;
   i48 = (i9 | 0) != -1;
   i27 = (i10 | 0) != -1;
   i22 = i47 ? 0 : (f3 <= f2) << 31 >> 31;
   i23 = i26 ? 0 : (f4 <= f2) << 31 >> 31;
   i24 = i48 ? 0 : (f5 <= f2) << 31 >> 31;
   i25 = i27 ? 0 : (f6 <= f2) << 31 >> 31;
   i7 = i7 & ~i22 | i22 & i1;
   i8 = i8 & ~i23 | i23 & i1;
   i9 = i9 & ~i24 | i24 & i1;
   i10 = i10 & ~i25 | i25 & i1;
   i1 = i1 + 1 | 0;
   if (i26 & (i27 & (i47 & i48))) {
    i1 = 4;
    break;
   }
   if ((i1 | 0) >= (i11 | 0)) {
    i1 = 5;
    break;
   }
  }
  if ((i1 | 0) == 4) {
   HEAP32[i56 >> 2] = i7;
   HEAP32[i52 >> 2] = i8;
   HEAP32[i51 >> 2] = i9;
   HEAP32[i50 >> 2] = i10;
   break;
  } else if ((i1 | 0) == 5) {
   HEAP32[i56 >> 2] = i7;
   HEAP32[i52 >> 2] = i8;
   HEAP32[i51 >> 2] = i9;
   HEAP32[i50 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i17, i49, i57);
 HEAP32[i16 + 12 >> 2] = 1;
 HEAP32[i16 + 8 >> 2] = 1;
 HEAP32[i16 + 4 >> 2] = 1;
 HEAP32[i16 >> 2] = 1;
 i19 = i17 + 48 | 0;
 i7 = i49 + 48 | 0;
 i47 = i57 + 16 | 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i19, i7, i47);
 HEAP32[i16 + 12 >> 2] = 2;
 HEAP32[i16 + 8 >> 2] = 2;
 HEAP32[i16 + 4 >> 2] = 2;
 HEAP32[i16 >> 2] = 2;
 i18 = i17 + 96 | 0;
 i1 = i49 + 96 | 0;
 i48 = i57 + 32 | 0;
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i14, i15, i59, i60, i56, i16, i13, i18, i1, i48);
 __Z22RandomBarycentricCoordR5RandN(i16, i12);
 f36 = Math_fround(HEAPF32[i16 >> 2]);
 f37 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f40 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f41 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f43 = Math_fround(HEAPF32[i16 + 28 >> 2]);
 f44 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f45 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f46 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f35 = Math_fround(HEAPF32[i16 + 44 >> 2]);
 f33 = Math_fround(f36 * Math_fround(HEAPF32[i17 >> 2]));
 f32 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 4 >> 2]));
 f31 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 8 >> 2]));
 f30 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 12 >> 2]));
 f29 = Math_fround(f36 * Math_fround(HEAPF32[i17 + 16 >> 2]));
 f28 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 20 >> 2]));
 f6 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 24 >> 2]));
 f5 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 28 >> 2]));
 f4 = Math_fround(f36 * Math_fround(HEAPF32[i17 + 32 >> 2]));
 f3 = Math_fround(f37 * Math_fround(HEAPF32[i17 + 36 >> 2]));
 f2 = Math_fround(f38 * Math_fround(HEAPF32[i17 + 40 >> 2]));
 f34 = Math_fround(f39 * Math_fround(HEAPF32[i17 + 44 >> 2]));
 f73 = Math_fround(f40 * Math_fround(HEAPF32[i19 >> 2]));
 f63 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 52 >> 2]));
 f64 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 56 >> 2]));
 f65 = Math_fround(f43 * Math_fround(HEAPF32[i17 + 60 >> 2]));
 f66 = Math_fround(f40 * Math_fround(HEAPF32[i17 + 64 >> 2]));
 f67 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 68 >> 2]));
 f68 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 72 >> 2]));
 f69 = Math_fround(f43 * Math_fround(HEAPF32[i17 + 76 >> 2]));
 f70 = Math_fround(f40 * Math_fround(HEAPF32[i17 + 80 >> 2]));
 f71 = Math_fround(f41 * Math_fround(HEAPF32[i17 + 84 >> 2]));
 f72 = Math_fround(f42 * Math_fround(HEAPF32[i17 + 88 >> 2]));
 f73 = Math_fround(f33 + f73);
 f63 = Math_fround(f32 + f63);
 f64 = Math_fround(f31 + f64);
 f65 = Math_fround(f30 + f65);
 f66 = Math_fround(f29 + f66);
 f67 = Math_fround(f28 + f67);
 f68 = Math_fround(f6 + f68);
 f69 = Math_fround(f5 + f69);
 f70 = Math_fround(f4 + f70);
 f71 = Math_fround(f3 + f71);
 f72 = Math_fround(f2 + f72);
 f34 = Math_fround(f34 + Math_fround(f43 * Math_fround(HEAPF32[i17 + 92 >> 2])));
 f2 = Math_fround(f44 * Math_fround(HEAPF32[i18 >> 2]));
 f3 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 100 >> 2]));
 f4 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 104 >> 2]));
 f5 = Math_fround(f35 * Math_fround(HEAPF32[i17 + 108 >> 2]));
 f6 = Math_fround(f44 * Math_fround(HEAPF32[i17 + 112 >> 2]));
 f28 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 116 >> 2]));
 f29 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 120 >> 2]));
 f30 = Math_fround(f35 * Math_fround(HEAPF32[i17 + 124 >> 2]));
 f31 = Math_fround(f44 * Math_fround(HEAPF32[i17 + 128 >> 2]));
 f32 = Math_fround(f45 * Math_fround(HEAPF32[i17 + 132 >> 2]));
 f33 = Math_fround(f46 * Math_fround(HEAPF32[i17 + 136 >> 2]));
 f3 = Math_fround(f63 + f3);
 f4 = Math_fround(f64 + f4);
 f5 = Math_fround(f65 + f5);
 f6 = Math_fround(f66 + f6);
 f28 = Math_fround(f67 + f28);
 f29 = Math_fround(f68 + f29);
 f30 = Math_fround(f69 + f30);
 f31 = Math_fround(f70 + f31);
 f32 = Math_fround(f71 + f32);
 f33 = Math_fround(f72 + f33);
 f34 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i17 + 140 >> 2])));
 HEAPF32[i53 >> 2] = Math_fround(f73 + f2);
 i17 = i53 + 4 | 0;
 HEAPF32[i17 >> 2] = f3;
 i18 = i53 + 8 | 0;
 HEAPF32[i18 >> 2] = f4;
 i19 = i53 + 12 | 0;
 HEAPF32[i19 >> 2] = f5;
 i20 = i53 + 16 | 0;
 HEAPF32[i20 >> 2] = f6;
 i21 = i53 + 20 | 0;
 HEAPF32[i21 >> 2] = f28;
 i22 = i53 + 24 | 0;
 HEAPF32[i22 >> 2] = f29;
 i23 = i53 + 28 | 0;
 HEAPF32[i23 >> 2] = f30;
 i24 = i53 + 32 | 0;
 HEAPF32[i24 >> 2] = f31;
 i25 = i53 + 36 | 0;
 HEAPF32[i25 >> 2] = f32;
 i26 = i53 + 40 | 0;
 HEAPF32[i26 >> 2] = f33;
 i27 = i53 + 44 | 0;
 HEAPF32[i27 >> 2] = f34;
 f34 = Math_fround(f36 * Math_fround(HEAPF32[i49 >> 2]));
 f33 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 4 >> 2]));
 f32 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 8 >> 2]));
 f31 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 12 >> 2]));
 f30 = Math_fround(f36 * Math_fround(HEAPF32[i49 + 16 >> 2]));
 f29 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 20 >> 2]));
 f28 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 24 >> 2]));
 f6 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 28 >> 2]));
 f5 = Math_fround(f36 * Math_fround(HEAPF32[i49 + 32 >> 2]));
 f4 = Math_fround(f37 * Math_fround(HEAPF32[i49 + 36 >> 2]));
 f3 = Math_fround(f38 * Math_fround(HEAPF32[i49 + 40 >> 2]));
 f2 = Math_fround(f39 * Math_fround(HEAPF32[i49 + 44 >> 2]));
 f73 = Math_fround(f40 * Math_fround(HEAPF32[i7 >> 2]));
 f72 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 52 >> 2]));
 f71 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 56 >> 2]));
 f70 = Math_fround(f43 * Math_fround(HEAPF32[i49 + 60 >> 2]));
 f69 = Math_fround(f40 * Math_fround(HEAPF32[i49 + 64 >> 2]));
 f68 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 68 >> 2]));
 f67 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 72 >> 2]));
 f66 = Math_fround(f43 * Math_fround(HEAPF32[i49 + 76 >> 2]));
 f65 = Math_fround(f40 * Math_fround(HEAPF32[i49 + 80 >> 2]));
 f64 = Math_fround(f41 * Math_fround(HEAPF32[i49 + 84 >> 2]));
 f63 = Math_fround(f42 * Math_fround(HEAPF32[i49 + 88 >> 2]));
 f73 = Math_fround(f34 + f73);
 f72 = Math_fround(f33 + f72);
 f71 = Math_fround(f32 + f71);
 f70 = Math_fround(f31 + f70);
 f69 = Math_fround(f30 + f69);
 f68 = Math_fround(f29 + f68);
 f67 = Math_fround(f28 + f67);
 f66 = Math_fround(f6 + f66);
 f65 = Math_fround(f5 + f65);
 f64 = Math_fround(f4 + f64);
 f63 = Math_fround(f3 + f63);
 f2 = Math_fround(f2 + Math_fround(f43 * Math_fround(HEAPF32[i49 + 92 >> 2])));
 f3 = Math_fround(f44 * Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 100 >> 2]));
 f5 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 104 >> 2]));
 f6 = Math_fround(f35 * Math_fround(HEAPF32[i49 + 108 >> 2]));
 f28 = Math_fround(f44 * Math_fround(HEAPF32[i49 + 112 >> 2]));
 f29 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 116 >> 2]));
 f30 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 120 >> 2]));
 f31 = Math_fround(f35 * Math_fround(HEAPF32[i49 + 124 >> 2]));
 f32 = Math_fround(f44 * Math_fround(HEAPF32[i49 + 128 >> 2]));
 f33 = Math_fround(f45 * Math_fround(HEAPF32[i49 + 132 >> 2]));
 f34 = Math_fround(f46 * Math_fround(HEAPF32[i49 + 136 >> 2]));
 f3 = Math_fround(f73 + f3);
 f4 = Math_fround(f72 + f4);
 f5 = Math_fround(f71 + f5);
 f6 = Math_fround(f70 + f6);
 f28 = Math_fround(f69 + f28);
 f29 = Math_fround(f68 + f29);
 f30 = Math_fround(f67 + f30);
 f31 = Math_fround(f66 + f31);
 f32 = Math_fround(f65 + f32);
 f33 = Math_fround(f64 + f33);
 f34 = Math_fround(f63 + f34);
 f2 = Math_fround(f2 + Math_fround(f35 * Math_fround(HEAPF32[i49 + 140 >> 2])));
 HEAPF32[i54 >> 2] = f3;
 i1 = i54 + 4 | 0;
 HEAPF32[i1 >> 2] = f4;
 i7 = i54 + 8 | 0;
 HEAPF32[i7 >> 2] = f5;
 i8 = i54 + 12 | 0;
 HEAPF32[i8 >> 2] = f6;
 i9 = i54 + 16 | 0;
 HEAPF32[i9 >> 2] = f28;
 i10 = i54 + 20 | 0;
 HEAPF32[i10 >> 2] = f29;
 i11 = i54 + 24 | 0;
 HEAPF32[i11 >> 2] = f30;
 i12 = i54 + 28 | 0;
 HEAPF32[i12 >> 2] = f31;
 i13 = i54 + 32 | 0;
 HEAPF32[i13 >> 2] = f32;
 i14 = i54 + 36 | 0;
 HEAPF32[i14 >> 2] = f33;
 i15 = i54 + 40 | 0;
 HEAPF32[i15 >> 2] = f34;
 i16 = i54 + 44 | 0;
 HEAPF32[i16 >> 2] = f2;
 if (!(HEAP32[i59 + 4 >> 2] | 0)) {
  i54 = HEAP32[i60 + (HEAP32[i52 >> 2] << 4) >> 2] | 0;
  i57 = HEAP32[i60 + (HEAP32[i51 >> 2] << 4) >> 2] | 0;
  i59 = HEAP32[i60 + (HEAP32[i50 >> 2] << 4) >> 2] | 0;
  HEAP32[i58 >> 2] = HEAP32[i60 + (HEAP32[i56 >> 2] << 4) >> 2];
  HEAP32[i58 + 4 >> 2] = i54;
  HEAP32[i58 + 8 >> 2] = i57;
  HEAP32[i58 + 12 >> 2] = i59;
  f35 = f4;
  f36 = f5;
  f37 = f6;
  f42 = f28;
  f43 = f29;
  f44 = f30;
  f45 = f31;
  f66 = f32;
  f67 = f33;
  f68 = f34;
  f69 = f2;
  f33 = Math_fround(HEAPF32[i55 >> 2]);
  f38 = Math_fround(HEAPF32[i53 >> 2]);
  f38 = Math_fround(f33 * f38);
  f39 = Math_fround(HEAPF32[i17 >> 2]);
  f39 = Math_fround(f33 * f39);
  f40 = Math_fround(HEAPF32[i18 >> 2]);
  f40 = Math_fround(f33 * f40);
  f41 = Math_fround(HEAPF32[i19 >> 2]);
  f41 = Math_fround(f33 * f41);
  i59 = i53 + 16 | 0;
  f46 = Math_fround(HEAPF32[i59 >> 2]);
  f46 = Math_fround(f33 * f46);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f63 = Math_fround(f33 * f63);
  f64 = Math_fround(HEAPF32[i22 >> 2]);
  f64 = Math_fround(f33 * f64);
  f65 = Math_fround(HEAPF32[i23 >> 2]);
  f65 = Math_fround(f33 * f65);
  i60 = i53 + 32 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f33 * f70);
  f71 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(f33 * f71);
  f72 = Math_fround(HEAPF32[i26 >> 2]);
  f72 = Math_fround(f33 * f72);
  f73 = Math_fround(HEAPF32[i27 >> 2]);
  f73 = Math_fround(f33 * f73);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  HEAPF32[i24 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  f33 = Math_fround(HEAPF32[i61 >> 2]);
  f34 = Math_fround(f33 * f3);
  f35 = Math_fround(f33 * f35);
  f36 = Math_fround(f33 * f36);
  f37 = Math_fround(f33 * f37);
  f42 = Math_fround(f33 * f42);
  f43 = Math_fround(f33 * f43);
  f44 = Math_fround(f33 * f44);
  f45 = Math_fround(f33 * f45);
  f66 = Math_fround(f33 * f66);
  f67 = Math_fround(f33 * f67);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f33 * f69);
  f38 = Math_fround(f34 + f38);
  f39 = Math_fround(f35 + f39);
  f40 = Math_fround(f36 + f40);
  f41 = Math_fround(f37 + f41);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  f46 = Math_fround(f42 + f46);
  f63 = Math_fround(f43 + f63);
  f64 = Math_fround(f44 + f64);
  f65 = Math_fround(f45 + f65);
  HEAPF32[i59 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  f70 = Math_fround(f66 + f70);
  f71 = Math_fround(f67 + f71);
  f72 = Math_fround(f68 + f72);
  f73 = Math_fround(f69 + f73);
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  STACKTOP = i62;
  return;
 } else {
  i74 = ~~Math_fround(f36 * Math_fround(255.0));
  i50 = ~~Math_fround(f37 * Math_fround(255.0));
  i81 = ~~Math_fround(f38 * Math_fround(255.0));
  i77 = ~~Math_fround(f39 * Math_fround(255.0));
  i85 = HEAP32[i57 >> 2] | 0;
  i52 = HEAP32[i57 + 4 >> 2] | 0;
  i59 = HEAP32[i57 + 8 >> 2] | 0;
  i56 = HEAP32[i57 + 12 >> 2] | 0;
  i78 = (Math_imul(i85 & 255, i74 & 255) | 0) + 128 | 0;
  i78 = ((i78 >>> 8) + i78 | 0) >>> 8;
  i76 = (Math_imul(i85 >>> 8 & 255, i74 >>> 8 & 255) | 0) + 128 | 0;
  i76 = (i76 >>> 8) + i76 & 261888 | i78;
  i79 = (Math_imul(i85 >>> 16 & 255, i74 >>> 16 & 255) | 0) + 128 | 0;
  i74 = (Math_imul(i85 >>> 24, i74 >>> 24) | 0) + 128 | 0;
  i79 = i76 | ((i74 >>> 8) + i74 | 0) >>> 8 << 24 | ((i79 >>> 8) + i79 | 0) >>> 8 << 16;
  i74 = (Math_imul(i52 & 255, i50 & 255) | 0) + 128 | 0;
  i74 = ((i74 >>> 8) + i74 | 0) >>> 8;
  i85 = (Math_imul(i52 >>> 8 & 255, i50 >>> 8 & 255) | 0) + 128 | 0;
  i85 = (i85 >>> 8) + i85 & 261888 | i74;
  i89 = (Math_imul(i52 >>> 16 & 255, i50 >>> 16 & 255) | 0) + 128 | 0;
  i50 = (Math_imul(i52 >>> 24, i50 >>> 24) | 0) + 128 | 0;
  i89 = i85 | ((i50 >>> 8) + i50 | 0) >>> 8 << 24 | ((i89 >>> 8) + i89 | 0) >>> 8 << 16;
  i50 = (Math_imul(i59 & 255, i81 & 255) | 0) + 128 | 0;
  i50 = ((i50 >>> 8) + i50 | 0) >>> 8;
  i52 = (Math_imul(i59 >>> 8 & 255, i81 >>> 8 & 255) | 0) + 128 | 0;
  i52 = (i52 >>> 8) + i52 & 261888 | i50;
  i88 = (Math_imul(i59 >>> 16 & 255, i81 >>> 16 & 255) | 0) + 128 | 0;
  i81 = (Math_imul(i59 >>> 24, i81 >>> 24) | 0) + 128 | 0;
  i88 = i52 | ((i81 >>> 8) + i81 | 0) >>> 8 << 24 | ((i88 >>> 8) + i88 | 0) >>> 8 << 16;
  i81 = (Math_imul(i56 & 255, i77 & 255) | 0) + 128 | 0;
  i81 = ((i81 >>> 8) + i81 | 0) >>> 8;
  i59 = (Math_imul(i56 >>> 8 & 255, i77 >>> 8 & 255) | 0) + 128 | 0;
  i59 = (i59 >>> 8) + i59 & 261888 | i81;
  i83 = (Math_imul(i56 >>> 16 & 255, i77 >>> 16 & 255) | 0) + 128 | 0;
  i77 = (Math_imul(i56 >>> 24, i77 >>> 24) | 0) + 128 | 0;
  i83 = i59 | ((i77 >>> 8) + i77 | 0) >>> 8 << 24 | ((i83 >>> 8) + i83 | 0) >>> 8 << 16;
  i77 = ~~Math_fround(f40 * Math_fround(255.0));
  i56 = ~~Math_fround(f41 * Math_fround(255.0));
  i60 = ~~Math_fround(f42 * Math_fround(255.0));
  i90 = ~~Math_fround(f43 * Math_fround(255.0));
  i84 = HEAP32[i47 >> 2] | 0;
  i82 = HEAP32[i57 + 20 >> 2] | 0;
  i80 = HEAP32[i57 + 24 >> 2] | 0;
  i91 = HEAP32[i57 + 28 >> 2] | 0;
  i49 = (Math_imul(i84 & 255, i77 & 255) | 0) + 128 | 0;
  i49 = ((i49 >>> 8) + i49 | 0) >>> 8;
  i86 = (Math_imul(i84 >>> 8 & 255, i77 >>> 8 & 255) | 0) + 128 | 0;
  i86 = (i86 >>> 8) + i86 & 261888 | i49;
  i75 = (Math_imul(i84 >>> 16 & 255, i77 >>> 16 & 255) | 0) + 128 | 0;
  i77 = (Math_imul(i84 >>> 24, i77 >>> 24) | 0) + 128 | 0;
  i75 = i86 | ((i77 >>> 8) + i77 | 0) >>> 8 << 24 | ((i75 >>> 8) + i75 | 0) >>> 8 << 16;
  i77 = (Math_imul(i82 & 255, i56 & 255) | 0) + 128 | 0;
  i77 = ((i77 >>> 8) + i77 | 0) >>> 8;
  i84 = (Math_imul(i82 >>> 8 & 255, i56 >>> 8 & 255) | 0) + 128 | 0;
  i84 = (i84 >>> 8) + i84 & 261888 | i77;
  i87 = (Math_imul(i82 >>> 16 & 255, i56 >>> 16 & 255) | 0) + 128 | 0;
  i56 = (Math_imul(i82 >>> 24, i56 >>> 24) | 0) + 128 | 0;
  i87 = i84 | ((i56 >>> 8) + i56 | 0) >>> 8 << 24 | ((i87 >>> 8) + i87 | 0) >>> 8 << 16;
  i56 = (Math_imul(i80 & 255, i60 & 255) | 0) + 128 | 0;
  i56 = ((i56 >>> 8) + i56 | 0) >>> 8;
  i82 = (Math_imul(i80 >>> 8 & 255, i60 >>> 8 & 255) | 0) + 128 | 0;
  i82 = (i82 >>> 8) + i82 & 261888 | i56;
  i51 = (Math_imul(i80 >>> 16 & 255, i60 >>> 16 & 255) | 0) + 128 | 0;
  i60 = (Math_imul(i80 >>> 24, i60 >>> 24) | 0) + 128 | 0;
  i51 = i82 | ((i60 >>> 8) + i60 | 0) >>> 8 << 24 | ((i51 >>> 8) + i51 | 0) >>> 8 << 16;
  i60 = (Math_imul(i91 & 255, i90 & 255) | 0) + 128 | 0;
  i60 = ((i60 >>> 8) + i60 | 0) >>> 8;
  i80 = (Math_imul(i91 >>> 8 & 255, i90 >>> 8 & 255) | 0) + 128 | 0;
  i80 = (i80 >>> 8) + i80 & 261888 | i60;
  i47 = (Math_imul(i91 >>> 16 & 255, i90 >>> 16 & 255) | 0) + 128 | 0;
  i90 = (Math_imul(i91 >>> 24, i90 >>> 24) | 0) + 128 | 0;
  i47 = i80 | ((i90 >>> 8) + i90 | 0) >>> 8 << 24 | ((i47 >>> 8) + i47 | 0) >>> 8 << 16;
  i78 = (i49 & 255) + (i78 & 255) | 0;
  i78 = i78 >>> 0 < 255 ? i78 : 255;
  i76 = (i86 >>> 8 & 255) + (i76 >>> 8 & 255) | 0;
  i86 = (i75 >>> 16 & 255) + (i79 >>> 16 & 255) | 0;
  i79 = (i75 >>> 24) + (i79 >>> 24) | 0;
  i76 = (i76 >>> 0 < 255 ? i76 : 255) << 8 | i78;
  i86 = i76 | (i79 >>> 0 < 255 ? i79 : 255) << 24 | (i86 >>> 0 < 255 ? i86 : 255) << 16;
  i74 = (i77 & 255) + (i74 & 255) | 0;
  i74 = i74 >>> 0 < 255 ? i74 : 255;
  i85 = (i84 >>> 8 & 255) + (i85 >>> 8 & 255) | 0;
  i84 = (i87 >>> 16 & 255) + (i89 >>> 16 & 255) | 0;
  i89 = (i87 >>> 24) + (i89 >>> 24) | 0;
  i85 = (i85 >>> 0 < 255 ? i85 : 255) << 8 | i74;
  i84 = i85 | (i89 >>> 0 < 255 ? i89 : 255) << 24 | (i84 >>> 0 < 255 ? i84 : 255) << 16;
  i50 = (i56 & 255) + (i50 & 255) | 0;
  i50 = i50 >>> 0 < 255 ? i50 : 255;
  i52 = (i82 >>> 8 & 255) + (i52 >>> 8 & 255) | 0;
  i82 = (i51 >>> 16 & 255) + (i88 >>> 16 & 255) | 0;
  i88 = (i51 >>> 24) + (i88 >>> 24) | 0;
  i52 = (i52 >>> 0 < 255 ? i52 : 255) << 8 | i50;
  i82 = i52 | (i88 >>> 0 < 255 ? i88 : 255) << 24 | (i82 >>> 0 < 255 ? i82 : 255) << 16;
  i81 = (i60 & 255) + (i81 & 255) | 0;
  i81 = i81 >>> 0 < 255 ? i81 : 255;
  i59 = (i80 >>> 8 & 255) + (i59 >>> 8 & 255) | 0;
  i80 = (i47 >>> 16 & 255) + (i83 >>> 16 & 255) | 0;
  i47 = (i47 >>> 24) + (i83 >>> 24) | 0;
  i59 = (i59 >>> 0 < 255 ? i59 : 255) << 8 | i81;
  i80 = i59 | (i47 >>> 0 < 255 ? i47 : 255) << 24 | (i80 >>> 0 < 255 ? i80 : 255) << 16;
  i47 = ~~Math_fround(f44 * Math_fround(255.0));
  i83 = ~~Math_fround(f45 * Math_fround(255.0));
  i60 = ~~Math_fround(f46 * Math_fround(255.0));
  i88 = ~~Math_fround(f35 * Math_fround(255.0));
  i48 = HEAP32[i48 >> 2] | 0;
  i51 = HEAP32[i57 + 36 >> 2] | 0;
  i56 = HEAP32[i57 + 40 >> 2] | 0;
  i89 = HEAP32[i57 + 44 >> 2] | 0;
  i87 = (Math_imul(i48 & 255, i47 & 255) | 0) + 128 | 0;
  i87 = ((i87 >>> 8) + i87 | 0) >>> 8;
  i77 = (Math_imul(i48 >>> 8 & 255, i47 >>> 8 & 255) | 0) + 128 | 0;
  i77 = (i77 >>> 8) + i77 & 261888 | i87;
  i79 = (Math_imul(i48 >>> 16 & 255, i47 >>> 16 & 255) | 0) + 128 | 0;
  i48 = (Math_imul(i48 >>> 24, i47 >>> 24) | 0) + 128 | 0;
  i79 = i77 | ((i48 >>> 8) + i48 | 0) >>> 8 << 24 | ((i79 >>> 8) + i79 | 0) >>> 8 << 16;
  i48 = (Math_imul(i51 & 255, i83 & 255) | 0) + 128 | 0;
  i48 = ((i48 >>> 8) + i48 | 0) >>> 8;
  i47 = (Math_imul(i51 >>> 8 & 255, i83 >>> 8 & 255) | 0) + 128 | 0;
  i47 = (i47 >>> 8) + i47 & 261888 | i48;
  i75 = (Math_imul(i51 >>> 16 & 255, i83 >>> 16 & 255) | 0) + 128 | 0;
  i83 = (Math_imul(i51 >>> 24, i83 >>> 24) | 0) + 128 | 0;
  i75 = i47 | ((i83 >>> 8) + i83 | 0) >>> 8 << 24 | ((i75 >>> 8) + i75 | 0) >>> 8 << 16;
  i83 = (Math_imul(i56 & 255, i60 & 255) | 0) + 128 | 0;
  i83 = ((i83 >>> 8) + i83 | 0) >>> 8;
  i51 = (Math_imul(i56 >>> 8 & 255, i60 >>> 8 & 255) | 0) + 128 | 0;
  i51 = (i51 >>> 8) + i51 & 261888 | i83;
  i49 = (Math_imul(i56 >>> 16 & 255, i60 >>> 16 & 255) | 0) + 128 | 0;
  i57 = (Math_imul(i56 >>> 24, i60 >>> 24) | 0) + 128 | 0;
  i49 = i51 | ((i57 >>> 8) + i57 | 0) >>> 8 << 24 | ((i49 >>> 8) + i49 | 0) >>> 8 << 16;
  i57 = (Math_imul(i89 & 255, i88 & 255) | 0) + 128 | 0;
  i57 = ((i57 >>> 8) + i57 | 0) >>> 8;
  i60 = (Math_imul(i89 >>> 8 & 255, i88 >>> 8 & 255) | 0) + 128 | 0;
  i60 = (i60 >>> 8) + i60 & 261888 | i57;
  i56 = (Math_imul(i89 >>> 16 & 255, i88 >>> 16 & 255) | 0) + 128 | 0;
  i88 = (Math_imul(i89 >>> 24, i88 >>> 24) | 0) + 128 | 0;
  i56 = i60 | ((i88 >>> 8) + i88 | 0) >>> 8 << 24 | ((i56 >>> 8) + i56 | 0) >>> 8 << 16;
  i78 = (i87 & 255) + (i78 & 255) | 0;
  i77 = (i76 >>> 8 & 255) + (i77 >>> 8 & 255) | 0;
  i76 = (i86 >>> 16 & 255) + (i79 >>> 16 & 255) | 0;
  i79 = (i86 >>> 24) + (i79 >>> 24) | 0;
  i74 = (i48 & 255) + (i74 & 255) | 0;
  i47 = (i85 >>> 8 & 255) + (i47 >>> 8 & 255) | 0;
  i48 = (i84 >>> 16 & 255) + (i75 >>> 16 & 255) | 0;
  i75 = (i84 >>> 24) + (i75 >>> 24) | 0;
  i50 = (i83 & 255) + (i50 & 255) | 0;
  i51 = (i52 >>> 8 & 255) + (i51 >>> 8 & 255) | 0;
  i52 = (i82 >>> 16 & 255) + (i49 >>> 16 & 255) | 0;
  i49 = (i82 >>> 24) + (i49 >>> 24) | 0;
  i57 = (i57 & 255) + (i81 & 255) | 0;
  i60 = (i59 >>> 8 & 255) + (i60 >>> 8 & 255) | 0;
  i59 = (i80 >>> 16 & 255) + (i56 >>> 16 & 255) | 0;
  i56 = (i80 >>> 24) + (i56 >>> 24) | 0;
  HEAP32[i58 >> 2] = (i79 >>> 0 < 255 ? i79 : 255) << 24 | (i78 >>> 0 < 255 ? i78 : 255) | (i77 >>> 0 < 255 ? i77 : 255) << 8 | (i76 >>> 0 < 255 ? i76 : 255) << 16;
  HEAP32[i58 + 4 >> 2] = (i75 >>> 0 < 255 ? i75 : 255) << 24 | (i74 >>> 0 < 255 ? i74 : 255) | (i47 >>> 0 < 255 ? i47 : 255) << 8 | (i48 >>> 0 < 255 ? i48 : 255) << 16;
  HEAP32[i58 + 8 >> 2] = (i49 >>> 0 < 255 ? i49 : 255) << 24 | (i50 >>> 0 < 255 ? i50 : 255) | (i51 >>> 0 < 255 ? i51 : 255) << 8 | (i52 >>> 0 < 255 ? i52 : 255) << 16;
  HEAP32[i58 + 12 >> 2] = (i56 >>> 0 < 255 ? i56 : 255) << 24 | (i57 >>> 0 < 255 ? i57 : 255) | (i60 >>> 0 < 255 ? i60 : 255) << 8 | (i59 >>> 0 < 255 ? i59 : 255) << 16;
  f34 = Math_fround(HEAPF32[i54 >> 2]);
  f35 = Math_fround(HEAPF32[i1 >> 2]);
  f36 = Math_fround(HEAPF32[i7 >> 2]);
  f37 = Math_fround(HEAPF32[i8 >> 2]);
  f42 = Math_fround(HEAPF32[i9 >> 2]);
  f43 = Math_fround(HEAPF32[i10 >> 2]);
  f44 = Math_fround(HEAPF32[i11 >> 2]);
  f45 = Math_fround(HEAPF32[i12 >> 2]);
  f66 = Math_fround(HEAPF32[i13 >> 2]);
  f67 = Math_fround(HEAPF32[i14 >> 2]);
  f68 = Math_fround(HEAPF32[i15 >> 2]);
  f69 = Math_fround(HEAPF32[i16 >> 2]);
  f33 = Math_fround(HEAPF32[i55 >> 2]);
  f38 = Math_fround(HEAPF32[i53 >> 2]);
  f38 = Math_fround(f33 * f38);
  f39 = Math_fround(HEAPF32[i17 >> 2]);
  f39 = Math_fround(f33 * f39);
  f40 = Math_fround(HEAPF32[i18 >> 2]);
  f40 = Math_fround(f33 * f40);
  f41 = Math_fround(HEAPF32[i19 >> 2]);
  f41 = Math_fround(f33 * f41);
  i59 = i53 + 16 | 0;
  f46 = Math_fround(HEAPF32[i59 >> 2]);
  f46 = Math_fround(f33 * f46);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f63 = Math_fround(f33 * f63);
  f64 = Math_fround(HEAPF32[i22 >> 2]);
  f64 = Math_fround(f33 * f64);
  f65 = Math_fround(HEAPF32[i23 >> 2]);
  f65 = Math_fround(f33 * f65);
  i60 = i53 + 32 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  f70 = Math_fround(f33 * f70);
  f71 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(f33 * f71);
  f72 = Math_fround(HEAPF32[i26 >> 2]);
  f72 = Math_fround(f33 * f72);
  f73 = Math_fround(HEAPF32[i27 >> 2]);
  f73 = Math_fround(f33 * f73);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  HEAPF32[i24 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  f33 = Math_fround(HEAPF32[i61 >> 2]);
  f34 = Math_fround(f33 * f34);
  f35 = Math_fround(f33 * f35);
  f36 = Math_fround(f33 * f36);
  f37 = Math_fround(f33 * f37);
  f42 = Math_fround(f33 * f42);
  f43 = Math_fround(f33 * f43);
  f44 = Math_fround(f33 * f44);
  f45 = Math_fround(f33 * f45);
  f66 = Math_fround(f33 * f66);
  f67 = Math_fround(f33 * f67);
  f68 = Math_fround(f33 * f68);
  f69 = Math_fround(f33 * f69);
  f38 = Math_fround(f34 + f38);
  f39 = Math_fround(f35 + f39);
  f40 = Math_fround(f36 + f40);
  f41 = Math_fround(f37 + f41);
  HEAPF32[i53 >> 2] = f38;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f40;
  HEAPF32[i19 >> 2] = f41;
  f46 = Math_fround(f42 + f46);
  f63 = Math_fround(f43 + f63);
  f64 = Math_fround(f44 + f64);
  f65 = Math_fround(f45 + f65);
  HEAPF32[i59 >> 2] = f46;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  f70 = Math_fround(f66 + f70);
  f71 = Math_fround(f67 + f71);
  f72 = Math_fround(f68 + f72);
  f73 = Math_fround(f69 + f73);
  HEAPF32[i60 >> 2] = f70;
  HEAPF32[i25 >> 2] = f71;
  HEAPF32[i26 >> 2] = f72;
  HEAPF32[i27 >> 2] = f73;
  STACKTOP = i62;
  return;
 }
}

function __ZN13SplatDatabase18RecalculateBasemapEb(i44, i42) {
 i44 = i44 | 0;
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i48 + 24 | 0;
 i17 = i48 + 8 | 0;
 i45 = i48 + 76 | 0;
 i5 = i48 + 16 | 0;
 i6 = i48;
 i46 = i48 + 56 | 0;
 i47 = i48 + 36 | 0;
 L1 : do if (i42) {
  i1 = HEAP32[i44 >> 2] | 0;
  i43 = (HEAP32[i44 + 4 >> 2] | 0) - i1 | 0;
  i2 = (i43 | 0) / 44 | 0;
  L3 : do if ((i43 | 0) > 0) {
   HEAP32[i34 >> 2] = HEAP32[i1 >> 2];
   if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i34) | 0)) {
    STACKTOP = i48;
    return;
   } else i1 = 1;
   while (1) {
    if ((i1 | 0) >= (i2 | 0)) break L3;
    HEAP32[i34 >> 2] = HEAP32[(HEAP32[i44 >> 2] | 0) + (i1 * 44 | 0) >> 2];
    if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i34) | 0)) break; else i1 = i1 + 1 | 0;
   }
   STACKTOP = i48;
   return;
  } while (0);
  i3 = i44 + 12 | 0;
  i4 = i44 + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) {
   i2 = 0;
   while (1) {
    HEAP32[i34 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
    if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i34) | 0)) break;
    i1 = HEAP32[i3 >> 2] | 0;
    if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0) break L1;
   }
   STACKTOP = i48;
   return;
  }
 } while (0);
 if ((HEAP16[gb + 1467320 + 6 >> 1] | 0) > -1) {
  HEAP32[i45 >> 2] = 0;
  HEAP32[i34 >> 2] = HEAP32[i45 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467320 | 0, i34);
  i43 = gb + 1467320 | 0;
 } else i43 = 0;
 i31 = HEAP32[i44 + 40 >> 2] | 0;
 i41 = i44 + 24 | 0;
 i1 = HEAP32[i41 >> 2] | 0;
 L21 : do if (!i1) {
  i40 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 930755 | 0, 111) | 0;
  i37 = gb + 63520 | 0;
  i38 = HEAP32[i37 + 4 >> 2] | 0;
  i39 = i5;
  HEAP32[i39 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i39 + 4 >> 2] = i38;
  HEAP32[i34 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i40, i34, 1);
  __Z19pop_allocation_rootv();
  i40 = __ZN6Object24CalculateCachedTypeIndexEPS_(i40) | 0;
  HEAP32[i41 >> 2] = i40;
  mftCall_vi(HEAP32[(HEAP32[i40 >> 2] | 0) + 24 >> 2] | 0, i40 | 0);
  i40 = HEAP32[i41 >> 2] | 0;
  if (mftCall_iiiiiiiii(HEAP32[(HEAP32[i40 >> 2] | 0) + 188 >> 2] | 0, i40 | 0, i31 | 0, i31 | 0, 4, 1, 1, -1, 0) | 0) i25 = 28; else {
   i1 = HEAP32[i44 + 32 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 930829 | 0, 0, gb + 930755 | 0, 123, 1, i1, 0, 0);
  }
 } else {
  do if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) == (i31 | 0)) {
   i40 = HEAP32[i41 >> 2] | 0;
   if ((mftCall_ii(HEAP32[(HEAP32[i40 >> 2] | 0) + 140 >> 2] | 0, i40 | 0) | 0) == (i31 | 0)) {
    i2 = HEAP32[i41 >> 2] | 0;
    i1 = HEAP32[i2 + 52 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i2 + 92 >> 2] | 0;
     if ((i1 | 0) == -1) break;
    } else i1 = HEAP32[i1 + 36 >> 2] | 0;
    if ((i1 | 0) == 4) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) {
     i25 = 28;
     break L21;
    }
   }
  } while (0);
  if (__ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(HEAP32[i41 >> 2] | 0, i31, i31, 4, 1) | 0) i25 = 28; else {
   i1 = HEAP32[i44 + 32 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 930829 | 0, 0, gb + 930755 | 0, 134, 1, i1, 0, 0);
  }
 } while (0);
 L41 : do if ((i25 | 0) == 28) {
  i32 = (i31 | 0) / 4 | 0;
  i39 = i44 + 36 | 0;
  i33 = HEAP32[i39 >> 2] | 0;
  i38 = (i33 | 0) < (i32 | 0) ? i33 : i32;
  i40 = i44 + 28 | 0;
  i1 = HEAP32[i40 >> 2] | 0;
  L43 : do if (!i1) {
   i37 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 930755 | 0, 142) | 0;
   i30 = gb + 63520 | 0;
   i35 = HEAP32[i30 + 4 >> 2] | 0;
   i36 = i6;
   HEAP32[i36 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i36 + 4 >> 2] = i35;
   HEAP32[i34 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i37, i34, 1);
   __Z19pop_allocation_rootv();
   i37 = __ZN6Object24CalculateCachedTypeIndexEPS_(i37) | 0;
   HEAP32[i40 >> 2] = i37;
   mftCall_vi(HEAP32[(HEAP32[i37 >> 2] | 0) + 24 >> 2] | 0, i37 | 0);
   i37 = HEAP32[i40 >> 2] | 0;
   if (!(mftCall_iiiiiiiii(HEAP32[(HEAP32[i37 >> 2] | 0) + 188 >> 2] | 0, i37 | 0, i38 | 0, i38 | 0, 4, 1, 1, -1, 0) | 0)) {
    i1 = HEAP32[i44 + 32 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 930829 | 0, 0, gb + 930755 | 0, 147, 1, i1, 0, 0);
    break L41;
   }
  } else {
   do if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) == (i38 | 0)) {
    i37 = HEAP32[i40 >> 2] | 0;
    if ((mftCall_ii(HEAP32[(HEAP32[i37 >> 2] | 0) + 140 >> 2] | 0, i37 | 0) | 0) == (i38 | 0)) {
     i2 = HEAP32[i40 >> 2] | 0;
     i1 = HEAP32[i2 + 52 >> 2] | 0;
     if (!i1) {
      i1 = HEAP32[i2 + 92 >> 2] | 0;
      if ((i1 | 0) == -1) break;
     } else i1 = HEAP32[i1 + 36 >> 2] | 0;
     if ((i1 | 0) == 4) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) break L43;
    }
   } while (0);
   if (!(__ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(HEAP32[i40 >> 2] | 0, i38, i38, 4, 1) | 0)) {
    i1 = HEAP32[i44 + 32 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 930829 | 0, 0, gb + 930755 | 0, 155, 1, i1, 0, 0);
    break L41;
   }
  } while (0);
  i16 = i44 + 32 | 0;
  i30 = HEAP32[i16 >> 2] | 0;
  f23 = Math_fround(HEAPF32[i30 + 336 >> 2]);
  f23 = Math_fround(f23 * Math_fround((HEAP32[i30 + 320 >> 2] | 0) + -1 | 0));
  f24 = Math_fround(HEAPF32[i30 + 344 >> 2]);
  f24 = Math_fround(f24 * Math_fround((HEAP32[i30 + 324 >> 2] | 0) + -1 | 0));
  i30 = i44 + 4 | 0;
  i1 = (HEAP32[i30 >> 2] | 0) - (HEAP32[i44 >> 2] | 0) | 0;
  i35 = (i1 | 0) / 44 | 0;
  i36 = i35 * 76 | 0;
  i36 = __Znaj(i35 >>> 0 > 56512727 | i36 >>> 0 > 4294967291 ? -1 : i36 + 4 | 0) | 0;
  HEAP32[i36 >> 2] = i35;
  i37 = i36 + 4 | 0;
  i29 = (i1 | 0) == 0;
  if (i29) i25 = 49; else {
   i2 = i37 + (i35 * 76 | 0) | 0;
   i3 = i37;
   do {
    HEAP32[i3 + 36 >> 2] = 0;
    HEAP32[i3 + 48 >> 2] = 0;
    HEAP32[i3 + 52 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
    i28 = i34;
    i27 = HEAP32[i28 + 4 >> 2] | 0;
    i26 = i3 + 40 | 0;
    HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i26 + 4 >> 2] = i27;
    HEAP32[i3 + 56 >> 2] = 0;
    HEAP32[i3 + 68 >> 2] = 0;
    HEAP32[i3 + 72 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
    i26 = i34;
    i27 = HEAP32[i26 + 4 >> 2] | 0;
    i28 = i3 + 60 | 0;
    HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i28 + 4 >> 2] = i27;
    i3 = i3 + 76 | 0;
   } while ((i3 | 0) != (i2 | 0));
   i1 = (i1 | 0) > 0;
   if (i1) {
    i14 = i34 + 11 | 0;
    f22 = Math_fround(i31 | 0);
    i15 = i44 + 49 | 0;
    i3 = 0;
    i13 = 0;
    do {
     HEAP32[i34 >> 2] = HEAP32[(HEAP32[i44 >> 2] | 0) + (i13 * 44 | 0) >> 2];
     i12 = __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i34) | 0;
     if (!i12) {
      HEAP32[i17 >> 2] = i13;
      __Z6FormatPKcz(i34, gb + 930855 | 0, i17);
      i2 = HEAP32[i16 >> 2] | 0;
      if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i34 >> 2] | 0 : i34, 0, gb + 930755 | 0, 204, 1, i2, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
      i4 = i37 + (i13 * 76 | 0) + 36 | 0;
      i5 = i37 + (i13 * 76 | 0) + 48 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      i7 = i6 + 1 | 0;
      i8 = i37 + (i13 * 76 | 0) + 52 | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      i10 = i9 & 2147483647;
      do if (i7 >>> 0 > i10 >>> 0) {
       i2 = i9 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
        HEAP32[i8 >> 2] = i2;
        HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 2, 4, i37 + (i13 * 76 | 0) + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i37 + (i13 * 76 | 0) + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i28 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
        HEAP32[i8 >> 2] = i2;
        HEAP32[i4 >> 2] = i28;
        break;
       }
      } while (0);
      HEAP32[i5 >> 2] = i7;
      HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = -1;
      HEAP32[i37 + (i13 * 76 | 0) + 32 >> 2] = 1;
      i28 = i37 + (i13 * 76 | 0) | 0;
      HEAP32[i28 >> 2] = 0;
      HEAP32[i28 + 4 >> 2] = 0;
      HEAP32[i28 + 8 >> 2] = 0;
      HEAP32[i28 + 12 >> 2] = 0;
      HEAP32[i28 + 16 >> 2] = 0;
      HEAP32[i28 + 20 >> 2] = 0;
     } else {
      i3 = i3 | (HEAP32[i12 + 60 >> 2] | 0) != 0;
      i4 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 136 >> 2] | 0, i12 | 0) | 0;
      i5 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 140 >> 2] | 0, i12 | 0) | 0;
      i6 = HEAP32[i44 >> 2] | 0;
      f18 = Math_fround(f23 / Math_fround(HEAPF32[i6 + (i13 * 44 | 0) + 8 >> 2]));
      f19 = Math_fround(f24 / Math_fround(HEAPF32[i6 + (i13 * 44 | 0) + 12 >> 2]));
      i9 = ~~Math_fround(f22 / f18);
      i2 = ~~Math_fround(f22 / f19);
      f49 = Math_fround((Math_imul(i5, i4) | 0) / (Math_imul((i2 | 0) < 1 ? 1 : i2, (i9 | 0) < 1 ? 1 : i9) | 0) | 0 | 0);
      f20 = Math_fround(f18 * Math_fround(Math_fround(HEAPF32[i6 + (i13 * 44 | 0) + 16 >> 2]) / f23));
      f21 = Math_fround(f19 * Math_fround(Math_fround(HEAPF32[i6 + (i13 * 44 | 0) + 20 >> 2]) / f24));
      i6 = ~~Math_fround(Math_fround(_log2f(f49)) * Math_fround(.5));
      i9 = (__ZNK9Texture2D16CountDataMipmapsEv(i12) | 0) + -1 | 0;
      i6 = (i6 | 0) < 0 ? 0 : (i6 | 0) > (i9 | 0) ? i9 : i6;
      i9 = i12 + 52 | 0;
      i2 = HEAP32[i9 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i12 + 92 >> 2] | 0;
       i2 = (i2 | 0) == -1 ? 5 : i2;
      } else i2 = HEAP32[i2 + 36 >> 2] | 0;
      i7 = __Z33GetMinimumTextureMipSizeForFormat13TextureFormat(i2) | 0;
      i11 = i4 >> i6;
      i11 = (i11 | 0) < (i7 | 0) ? i7 : i11;
      i8 = i5 >> i6;
      i8 = (i8 | 0) < (i7 | 0) ? i7 : i8;
      i7 = i37 + (i13 * 76 | 0) + 36 | 0;
      i10 = Math_imul(i11, i8) | 0;
      i2 = i37 + (i13 * 76 | 0) + 48 | 0;
      HEAP32[i2 >> 2] = i10;
      i4 = i37 + (i13 * 76 | 0) + 52 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      do if ((i5 & 2147483647) >>> 0 < i10 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i4 >> 2] = i10;
       i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i10 << 2, 4, i37 + (i13 * 76 | 0) + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i7 >> 2] = i2;
       break;
      } else {
       i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 << 2, 4, i37 + (i13 * 76 | 0) + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i28 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
       HEAP32[i4 >> 2] = i10;
       HEAP32[i7 >> 2] = i28;
       i2 = i28;
       break;
      } else i2 = HEAP32[i7 >> 2] | 0; while (0);
      if (!(__ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i(i12, i6, i2, i10) | 0)) {
       _memset(HEAP32[i7 >> 2] | 0, 0, i10 << 2 | 0) | 0;
       i2 = HEAP32[i16 >> 2] | 0;
       if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 930896 | 0, 0, gb + 930755 | 0, 244, 1, i2, 0, 0);
      }
      i5 = ~~Math_fround(Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + (i13 * 44 | 0) + 40 >> 2]) * Math_fround(255.0)) & 255;
      if (HEAP8[i15 >> 0] | 0) {
       i2 = HEAP32[i9 >> 2] | 0;
       if (!i2) {
        i2 = HEAP32[i12 + 92 >> 2] | 0;
        i2 = (i2 | 0) == -1 ? 5 : i2;
       } else i2 = HEAP32[i2 + 36 >> 2] | 0;
       if ((i10 | 0) != 0 & ((__Z21HasAlphaTextureFormat13TextureFormat(i2) | 0) ^ 1)) {
        i4 = HEAP32[i7 >> 2] | 0;
        i2 = 0;
        do {
         HEAP8[i4 + (i2 << 2) + 3 >> 0] = i5;
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < i10 >>> 0);
       }
      }
      HEAP32[i37 + (i13 * 76 | 0) + 32 >> 2] = i11;
      HEAP32[i37 + (i13 * 76 | 0) >> 2] = (i11 << 16) + -1;
      i28 = (i8 << 16) + -1 | 0;
      HEAP32[i37 + (i13 * 76 | 0) + 4 >> 2] = i28;
      f50 = Math_fround(i11 | 0);
      HEAP32[i37 + (i13 * 76 | 0) + 8 >> 2] = ~~Math_fround(Math_fround(Math_fround(f18 * f50) / f22) * Math_fround(65536.0));
      f49 = Math_fround(i8 | 0);
      i26 = ~~Math_fround(Math_fround(Math_fround(f19 * f49) / f22) * Math_fround(65536.0));
      HEAP32[i37 + (i13 * 76 | 0) + 12 >> 2] = i26;
      HEAP32[i37 + (i13 * 76 | 0) + 24 >> 2] = ~~Math_fround(Math_fround(f20 * f50) * Math_fround(65536.0));
      i27 = ~~Math_fround(Math_fround(f21 * f49) * Math_fround(65536.0));
      HEAP32[i37 + (i13 * 76 | 0) + 16 >> 2] = 0;
      HEAP32[i37 + (i13 * 76 | 0) + 20 >> 2] = ((i26 | 0) / 2 | 0) + i27 & i28;
     }
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) < (i35 | 0));
    i2 = HEAP32[i41 >> 2] | 0;
    if (i3) {
     __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i2, 1);
     i2 = (__Z19GetActiveColorSpacev() | 0) != 1;
     if (i2 | i1 ^ 1) {
      i1 = i2 & i1;
      i17 = i2 ^ 1;
     } else {
      i8 = 0;
      do {
       i7 = i37 + (i8 * 76 | 0) + 56 | 0;
       i2 = i37 + (i8 * 76 | 0) + 48 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i4 = i37 + (i8 * 76 | 0) + 68 | 0;
       HEAP32[i4 >> 2] = i3;
       i5 = i37 + (i8 * 76 | 0) + 72 | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       do if ((i6 & 2147483647) >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i5 >> 2] = i3;
        HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i3 << 4, 4, i37 + (i8 * 76 | 0) + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i37 + (i8 * 76 | 0) + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i28 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] << 4 | 0) | 0;
        HEAP32[i5 >> 2] = i3;
        HEAP32[i7 >> 2] = i28;
        break;
       } while (0);
       i5 = HEAP32[i2 >> 2] | 0;
       if (i5 | 0) {
        i3 = HEAP32[i7 >> 2] | 0;
        i4 = HEAP32[i37 + (i8 * 76 | 0) + 36 >> 2] | 0;
        i2 = 0;
        do {
         i28 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
         f24 = Math_fround(Math_fround((i28 & 65535) >>> 8 & 255) / Math_fround(255.0));
         f49 = Math_fround(Math_fround(i28 >>> 16 & 255) / Math_fround(255.0));
         f50 = Math_fround(Math_fround(i28 >>> 24 & 255) / Math_fround(255.0));
         HEAPF32[i3 + (i2 << 4) >> 2] = Math_fround(Math_fround(i28 & 255) / Math_fround(255.0));
         HEAPF32[i3 + (i2 << 4) + 4 >> 2] = f24;
         HEAPF32[i3 + (i2 << 4) + 8 >> 2] = f49;
         HEAPF32[i3 + (i2 << 4) + 12 >> 2] = f50;
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < i5 >>> 0);
       }
       i8 = i8 + 1 | 0;
      } while ((i8 | 0) < (i35 | 0));
      i17 = 1;
     }
    } else i25 = 51;
   } else i25 = 49;
  }
  if ((i25 | 0) == 49) {
   i2 = HEAP32[i41 >> 2] | 0;
   i1 = 0;
   i25 = 51;
  }
  if ((i25 | 0) == 51) {
   __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i2, 0);
   i17 = 0;
  }
  HEAP32[i45 >> 2] = 0;
  i2 = i45 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  i25 = i45 + 16 | 0;
  HEAP32[i25 >> 2] = 0;
  i26 = i45 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
  i28 = i34;
  i27 = HEAP32[i28 + 4 >> 2] | 0;
  i3 = i26;
  HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i3 + 4 >> 2] = i27;
  __ZN13SplatDatabase12GetAlphamapsER13dynamic_arrayIhLj1EEb(i44, i45, 0);
  HEAP32[i46 >> 2] = 0;
  i3 = i46 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  i27 = i46 + 16 | 0;
  HEAP32[i27 >> 2] = 0;
  i28 = i46 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
  i14 = i34;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i28;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i15;
  if (i17) {
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i4;
   i5 = HEAP32[i27 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i4 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i27 >> 2] = i4;
    HEAP32[i46 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i46 >> 2] | 0, i4 << 2, 4, i28, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i28, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i46 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i27 >> 2] = i4;
    HEAP32[i46 >> 2] = i16;
    break;
   } while (0);
   i5 = HEAP32[i2 >> 2] | 0;
   if (i5 | 0) {
    i3 = HEAP32[i45 >> 2] | 0;
    i4 = HEAP32[i46 >> 2] | 0;
    i2 = 0;
    do {
     HEAPF32[i4 + (i2 << 2) >> 2] = Math_fround(Math_fround(HEAPU8[i3 + i2 >> 0] | 0) / Math_fround(255.0));
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i5 >>> 0);
   }
  }
  i2 = HEAP32[i41 >> 2] | 0;
  __ZN9Texture2D18UnshareTextureDataEv(i2);
  i2 = HEAP32[i2 + 52 >> 2] | 0;
  if (!i2) i16 = 0; else i16 = HEAP32[i2 + 8 >> 2] | 0;
  i2 = HEAP32[i39 >> 2] | 0;
  i15 = (i2 << 16 | 0) / (i31 | 0) | 0;
  L148 : do if ((i31 | 0) > 0) {
   i3 = 0;
   i13 = 0;
   i14 = 0;
   while (1) {
    i12 = Math_imul(Math_imul(i14 >> 16, i35) | 0, i2) | 0;
    if (i1) {
     i2 = 0;
     do {
      HEAP32[i37 + (i2 * 76 | 0) + 16 >> 2] = ((HEAP32[i37 + (i2 * 76 | 0) + 8 >> 2] | 0) / 2 | 0) + (HEAP32[i37 + (i2 * 76 | 0) + 24 >> 2] | 0) & HEAP32[i37 + (i2 * 76 | 0) >> 2];
      HEAP32[i37 + (i2 * 76 | 0) + 28 >> 2] = Math_imul(HEAP32[i37 + (i2 * 76 | 0) + 20 >> 2] >> 16, HEAP32[i37 + (i2 * 76 | 0) + 32 >> 2] | 0) | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i35 | 0));
     i9 = 0;
     i10 = 0;
     i11 = i3;
    } else {
     i9 = 0;
     i10 = 0;
     i11 = i3;
    }
    while (1) {
     i2 = Math_imul(i10 >> 16, i35) | 0;
     if (i17) {
      if (i1) {
       i8 = i2 + i12 | 0;
       i7 = 0;
       i6 = 0;
       i5 = 0;
       i4 = 0;
       i2 = 0;
       do {
        i51 = i37 + (i7 * 76 | 0) + 16 | 0;
        i52 = HEAP32[i51 >> 2] | 0;
        i53 = (i52 >> 16) + (HEAP32[i37 + (i7 * 76 | 0) + 28 >> 2] | 0) | 0;
        i54 = HEAP32[i37 + (i7 * 76 | 0) + 56 >> 2] | 0;
        f23 = Math_fround(HEAPF32[i54 + (i53 << 4) >> 2]);
        f24 = Math_fround(HEAPF32[i54 + (i53 << 4) + 4 >> 2]);
        f49 = Math_fround(HEAPF32[i54 + (i53 << 4) + 8 >> 2]);
        f22 = Math_fround(HEAPF32[i54 + (i53 << 4) + 12 >> 2]);
        f23 = Math_fround(f23 * f23);
        f24 = Math_fround(f24 * f24);
        f49 = Math_fround(f49 * f49);
        f22 = Math_fround(f22 * f22);
        f50 = Math_fround(HEAPF32[(HEAP32[i46 >> 2] | 0) + (i8 + i7 << 2) >> 2]);
        f23 = Math_fround(f23 * f50);
        f24 = Math_fround(f24 * f50);
        f49 = Math_fround(f49 * f50);
        f50 = Math_fround(f22 * f50);
        f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f23);
        f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
        f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f49);
        f50 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f50);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
        i2 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
        HEAP32[i51 >> 2] = (HEAP32[i37 + (i7 * 76 | 0) + 8 >> 2] | 0) + i52 & HEAP32[i37 + (i7 * 76 | 0) >> 2];
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) < (i35 | 0));
      } else {
       i6 = 0;
       i5 = 0;
       i4 = 0;
       i2 = 0;
      }
      f49 = Math_fround(Math_sqrt(Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
      f24 = Math_fround(Math_sqrt(Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
      f50 = Math_fround(Math_sqrt(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
      HEAP32[i16 + (i11 << 2) >> 2] = (~~Math_fround(f24 * Math_fround(255.0)) & 255) << 8 | ~~Math_fround(f49 * Math_fround(255.0)) & 255 | (~~Math_fround(f50 * Math_fround(255.0)) & 255) << 16 | (~~Math_fround(Math_fround(Math_sqrt(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) * Math_fround(255.0)) & 255) << 24;
     } else {
      if (i1) {
       i5 = i2 + i12 | 0;
       i4 = 0;
       i2 = 0;
       do {
        i54 = i37 + (i4 * 76 | 0) + 16 | 0;
        i53 = HEAP32[i54 >> 2] | 0;
        i52 = HEAP32[(HEAP32[i37 + (i4 * 76 | 0) + 36 >> 2] | 0) + ((i53 >> 16) + (HEAP32[i37 + (i4 * 76 | 0) + 28 >> 2] | 0) << 2) >> 2] | 0;
        i51 = HEAPU8[(HEAP32[i45 >> 2] | 0) + (i5 + i4) >> 0] | 0;
        i2 = ((Math_imul(i51, i52 & 16711935) | 0) >>> 8 & 16711935 | (Math_imul(i51, i52 >>> 8 & 16711935) | 0) & -16711936) + i2 | 0;
        HEAP32[i54 >> 2] = (HEAP32[i37 + (i4 * 76 | 0) + 8 >> 2] | 0) + i53 & HEAP32[i37 + (i4 * 76 | 0) >> 2];
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) < (i35 | 0));
      } else i2 = 0;
      HEAP32[i16 + (i11 << 2) >> 2] = i2;
     }
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i31 | 0)) break; else {
      i10 = i10 + i15 | 0;
      i11 = i11 + 1 | 0;
     }
    }
    i3 = i31 + i3 | 0;
    if (i1) {
     i2 = 0;
     do {
      i54 = i37 + (i2 * 76 | 0) + 20 | 0;
      HEAP32[i54 >> 2] = (HEAP32[i37 + (i2 * 76 | 0) + 12 >> 2] | 0) + (HEAP32[i54 >> 2] | 0) & HEAP32[i37 + (i2 * 76 | 0) + 4 >> 2];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i35 | 0));
    }
    i2 = i13 + 1 | 0;
    if ((i2 | 0) == (i31 | 0)) break L148;
    i13 = i2;
    i14 = i14 + i15 | 0;
    i2 = HEAP32[i39 >> 2] | 0;
   }
  } while (0);
  if (i29) {
   i4 = Math_imul(i31, i31) | 0;
   i2 = HEAP32[i41 >> 2] | 0;
   i3 = HEAP32[i2 + 52 >> 2] | 0;
   if (!i3) {
    i2 = HEAP32[i2 + 92 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? 5 : i2;
   } else i2 = HEAP32[i3 + 36 >> 2] | 0;
   _memset(i16 | 0, -1, Math_imul(i4, __Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0) | 0) | 0;
  }
  i3 = ((HEAP32[i30 >> 2] | 0) - (HEAP32[i44 >> 2] | 0) | 0) / 44 | 0;
  HEAP32[i47 + 12 >> 2] = i3;
  i16 = i47 + 16 | 0;
  HEAP32[i16 >> 2] = i3;
  i17 = i47 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 64016 | 0);
  i52 = i34;
  i53 = HEAP32[i52 + 4 >> 2] | 0;
  i54 = i17;
  HEAP32[i54 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i54 + 4 >> 2] = i53;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i47 >> 2] = i3;
  if (i1) {
   i4 = HEAP32[i44 >> 2] | 0;
   if (!(HEAP8[i44 + 48 >> 0] | 0)) {
    i2 = 0;
    do {
     i54 = i4 + (i2 * 44 | 0) + 24 | 0;
     f24 = Math_fround(HEAPF32[i54 >> 2]);
     f49 = Math_fround(HEAPF32[i54 + 4 >> 2]);
     f50 = Math_fround(HEAPF32[i54 + 8 >> 2]);
     i54 = f24 < Math_fround(0.0);
     f24 = i54 ? Math_fround(0.0) : f24;
     i54 = f24 > Math_fround(1.0);
     i54 = ~~Math_fround(Math_fround((i54 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i53 = f49 < Math_fround(0.0);
     f49 = i53 ? Math_fround(0.0) : f49;
     i53 = f49 > Math_fround(1.0);
     i53 = ~~Math_fround(Math_fround((i53 ? Math_fround(1.0) : f49) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i52 = f50 < Math_fround(0.0);
     f50 = i52 ? Math_fround(0.0) : f50;
     i52 = f50 > Math_fround(1.0);
     HEAP32[i3 + (i2 << 2) >> 2] = ~~Math_fround(Math_fround((i52 ? Math_fround(1.0) : f50) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16 | i53 << 8 & 65280 | i54 & 255 | -16777216;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i35 | 0));
   } else {
    i2 = 0;
    do {
     f50 = Math_fround(HEAPF32[i4 + (i2 * 44 | 0) + 24 + 12 >> 2]);
     i54 = f50 < Math_fround(0.0);
     f50 = i54 ? Math_fround(0.0) : f50;
     i54 = f50 > Math_fround(1.0);
     i54 = ~~Math_fround(Math_fround((i54 ? Math_fround(1.0) : f50) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     HEAP32[i3 + (i2 << 2) >> 2] = i54 << 16 | i54 << 8 & 65280 | i54 & 255 | -16777216;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i35 | 0));
   }
  }
  i2 = HEAP32[i40 >> 2] | 0;
  __ZN9Texture2D18UnshareTextureDataEv(i2);
  i2 = HEAP32[i2 + 52 >> 2] | 0;
  if (!i2) i15 = 0; else i15 = HEAP32[i2 + 8 >> 2] | 0;
  i4 = HEAP32[i39 >> 2] | 0;
  i14 = (i4 << 16 | 0) / (i38 | 0) | 0;
  L195 : do if ((i38 | 0) > 0) {
   i13 = -4 - (((i32 | 0) > (i33 | 0) ? i33 : i32) << 2 ^ -4) | 0;
   i12 = 0;
   i2 = 0;
   i3 = 0;
   while (1) {
    i11 = Math_imul(i4, i12 >> 16) | 0;
    if (i1) {
     i9 = HEAP32[i45 >> 2] | 0;
     i10 = HEAP32[i47 >> 2] | 0;
     i7 = 0;
     i8 = 0;
     while (1) {
      i5 = Math_imul((i7 >> 16) + i11 | 0, i35) | 0;
      i4 = 0;
      i6 = 0;
      do {
       i54 = HEAPU8[i9 + (i4 + i5) >> 0] | 0;
       i53 = HEAP32[i10 + (i4 << 2) >> 2] | 0;
       i6 = ((Math_imul(i53 & 16711935, i54) | 0) >>> 8 & 16711935 | (Math_imul(i53 >>> 8 & 16711935, i54) | 0) & -16711936) + i6 | 0;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (i35 | 0));
      i4 = i3 + 1 | 0;
      HEAP32[i15 + (i3 << 2) >> 2] = i6;
      i8 = i8 + 1 | 0;
      if ((i8 | 0) >= (i38 | 0)) {
       i3 = i4;
       break;
      } else {
       i7 = i7 + i14 | 0;
       i3 = i4;
      }
     }
    } else {
     _memset(i15 + (i3 << 2) | 0, 0, i13 | 0) | 0;
     i4 = 0;
     do {
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i38 | 0));
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i38 | 0)) break L195;
    i12 = i12 + i14 | 0;
    i4 = HEAP32[i39 >> 2] | 0;
   }
  } while (0);
  i54 = HEAP32[i41 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i54 >> 2] | 0) + 200 >> 2] | 0, i54 | 0);
  i54 = HEAP32[i40 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i54 >> 2] | 0) + 200 >> 2] | 0, i54 | 0);
  if (!i42) __ZN13SplatDatabase13UploadBasemapEv(i44);
  i1 = i37 + ((HEAP32[i36 >> 2] | 0) * 76 | 0) | 0;
  if ((i37 | 0) != (i1 | 0)) do {
   i2 = i1 + -20 | 0;
   if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i1 + -40 | 0;
   if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -36 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i1 = i1 + -76 | 0;
  } while ((i1 | 0) != (i37 | 0));
  __ZdaPv(i36);
  HEAP32[i44 + 44 >> 2] = __Z19GetActiveColorSpacev() | 0;
  HEAP8[i44 + 50 >> 0] = 0;
  if ((HEAP32[i16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i47 >> 2] | 0, i17);
   HEAP32[i47 >> 2] = 0;
  }
  if ((HEAP32[i27 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i46 >> 2] | 0, i28);
   HEAP32[i46 >> 2] = 0;
  }
  if ((HEAP32[i25 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i26);
   HEAP32[i45 >> 2] = 0;
  }
 } while (0);
 if (!i43) {
  STACKTOP = i48;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i43);
 STACKTOP = i48;
 return;
}

function __ZN5physxL27PxcSweepAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE(i109, i110, i21, i57, i113, i119, f105, i120, i121, i98, i99) {
 i109 = i109 | 0;
 i110 = i110 | 0;
 i21 = i21 | 0;
 i57 = i57 | 0;
 i113 = i113 | 0;
 i119 = i119 | 0;
 f105 = Math_fround(f105);
 i120 = i120 | 0;
 i121 = i121 | 0;
 i98 = i98 | 0;
 i99 = i99 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i106 = 0, i107 = 0, i108 = 0, i111 = 0, i112 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i122 = 0, f123 = f0, f124 = f0, f125 = f0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0;
 i122 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i95 = i122 + 208 | 0;
 i104 = i122 + 592 | 0;
 i108 = i122 + 588 | 0;
 i112 = i122 + 584 | 0;
 i100 = i122 + 572 | 0;
 i101 = i122 + 552 | 0;
 i118 = i122 + 536 | 0;
 i3 = i122 + 488 | 0;
 i48 = i122 + 476 | 0;
 i49 = i122 + 464 | 0;
 i2 = i122 + 440 | 0;
 i117 = i122 + 424 | 0;
 i116 = i122 + 408 | 0;
 i47 = i122 + 392 | 0;
 i41 = i122 + 380 | 0;
 i42 = i122 + 368 | 0;
 i43 = i122 + 356 | 0;
 i102 = i122 + 32 | 0;
 i103 = i122;
 i111 = i122 + 344 | 0;
 i114 = i122 + 496 | 0;
 i106 = i122 + 332 | 0;
 i107 = i122 + 320 | 0;
 i115 = i122 + 64 | 0;
 i96 = i122 + 248 | 0;
 i22 = HEAP32[i110 >> 2] | 0;
 HEAP32[i101 + 12 >> 2] = HEAP32[i22 + 40 >> 2];
 HEAP32[i101 + 16 >> 2] = i22 + 36;
 HEAPF32[i101 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i22 + 44 >> 2]));
 HEAPF32[i101 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i22 + 48 >> 2]));
 HEAPF32[i101 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i22 + 52 >> 2]));
 __ZN5physx2Gu9ContainerC2Ev(i118);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i118, 64, i122 + 608 | 0, 1);
 HEAP32[i3 >> 2] = gb + 102868 + 8;
 HEAP32[i3 + 4 >> 2] = i118;
 i22 = i118 + 4 | 0;
 if (HEAP32[i22 >> 2] | 0) HEAP32[i22 >> 2] = 0;
 i54 = i109 + 12 | 0;
 f38 = Math_fround(HEAPF32[i109 + 56 >> 2]);
 i50 = i109 + 28 | 0;
 f38 = Math_fround(f38 - Math_fround(HEAPF32[i50 >> 2]));
 f27 = Math_fround(HEAPF32[i109 + 60 >> 2]);
 i51 = i109 + 32 | 0;
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i51 >> 2]));
 f17 = Math_fround(HEAPF32[i109 + 64 >> 2]);
 i52 = i109 + 36 | 0;
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i52 >> 2]));
 HEAPF32[i48 >> 2] = f38;
 HEAPF32[i48 + 4 >> 2] = f27;
 HEAPF32[i48 + 8 >> 2] = f17;
 i97 = i110 + 12 | 0;
 f44 = Math_fround(HEAPF32[i110 + 56 >> 2]);
 f44 = Math_fround(f44 - Math_fround(HEAPF32[i110 + 28 >> 2]));
 f45 = Math_fround(HEAPF32[i110 + 60 >> 2]);
 i55 = i110 + 32 | 0;
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i55 >> 2]));
 f46 = Math_fround(HEAPF32[i110 + 64 >> 2]);
 i56 = i110 + 36 | 0;
 f46 = Math_fround(f46 - Math_fround(HEAPF32[i56 >> 2]));
 HEAPF32[i49 >> 2] = f44;
 HEAPF32[i49 + 4 >> 2] = f45;
 HEAPF32[i49 + 8 >> 2] = f46;
 f44 = Math_fround(f38 - f44);
 f45 = Math_fround(f27 - f45);
 f46 = Math_fround(f17 - f46);
 f17 = Math_fround(f44 * Math_fround(.5));
 f27 = Math_fround(f45 * Math_fround(.5));
 f38 = Math_fround(f46 * Math_fround(.5));
 f23 = Math_fround(Math_abs(Math_fround(f17)));
 f15 = Math_fround(Math_abs(Math_fround(f27)));
 f16 = Math_fround(Math_abs(Math_fround(f38)));
 i5 = i109 + 68 | 0;
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i5 >> 2]));
 i19 = i109 + 72 | 0;
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 >> 2]));
 i20 = i109 + 76 | 0;
 f23 = Math_fround(f23 + f105);
 f15 = Math_fround(f15 + f105);
 f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i20 >> 2])) + f105);
 i6 = i109 + 80 | 0;
 f17 = Math_fround(f17 + Math_fround(HEAPF32[i6 >> 2]));
 i7 = i109 + 84 | 0;
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i7 >> 2]));
 i18 = i109 + 88 | 0;
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i18 >> 2]));
 f24 = Math_fround(f27 - f15);
 f25 = Math_fround(f38 - f16);
 f26 = Math_fround(f23 + f17);
 f27 = Math_fround(f15 + f27);
 f38 = Math_fround(f16 + f38);
 HEAPF32[i2 >> 2] = Math_fround(f17 - f23);
 HEAPF32[i2 + 4 >> 2] = f24;
 HEAPF32[i2 + 8 >> 2] = f25;
 HEAPF32[i2 + 12 >> 2] = f26;
 HEAPF32[i2 + 16 >> 2] = f27;
 HEAPF32[i2 + 20 >> 2] = f38;
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i101, i119, i2, 1, i3) | 0;
 __ZN5physx2Gu9ContainerC2Ev(i117);
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i117, 64, i2, 1);
 i3 = HEAP32[i22 >> 2] | 0;
 i4 = i117 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 + i3 | 0) >>> 0 > (HEAP32[i117 >> 2] | 0) >>> 0) {
  __ZN5physx2Gu9Container6ResizeEj(i117, i3) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2 + i3;
 __ZN5physx2Gu9ContainerC2Ev(i116);
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i116, 64, i2, 1);
 i3 = HEAP32[i22 >> 2] | 0;
 i4 = i116 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 + i3 | 0) >>> 0 > (HEAP32[i116 >> 2] | 0) >>> 0) {
  __ZN5physx2Gu9Container6ResizeEj(i116, i3) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2 + i3;
 i94 = HEAP32[i117 + 8 >> 2] | 0;
 i40 = HEAP32[i116 + 8 >> 2] | 0;
 HEAP32[i47 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i18 >> 2];
 f12 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f105);
 f13 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f105);
 f14 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f105);
 i93 = (i21 | 0) != 0;
 i39 = i109 + 8 | 0;
 f11 = Math_fround(HEAPF32[i39 >> 2]);
 f9 = i93 ? f11 : Math_fround(0.0);
 i53 = (i57 | 0) != 0;
 f10 = Math_fround(HEAPF32[i110 + 8 >> 2]);
 f10 = i53 ? f10 : Math_fround(0.0);
 if (i93) f1 = Math_fround(HEAPF32[(HEAP32[i21 + 60 >> 2] | 0) + 4 >> 2]); else f1 = Math_fround(1.0);
 if (i53) f8 = Math_fround(HEAPF32[(HEAP32[i57 + 60 >> 2] | 0) + 4 >> 2]); else f8 = Math_fround(1.0);
 f38 = Math_fround((f9 > f10 ? f9 : f10) * (f1 < f8 ? f1 : f8));
 i36 = HEAP32[i22 >> 2] | 0;
 i37 = HEAP32[i118 + 8 >> 2] | 0;
 if (!i36) i86 = 0; else {
  i28 = i95 + 12 | 0;
  i29 = i95 + 16 | 0;
  i30 = i95 + 4 | 0;
  i31 = i95 + 20 | 0;
  i32 = i95 + 8 | 0;
  i33 = i95 + 24 | 0;
  i34 = i95 + 28 | 0;
  i35 = i95 + 32 | 0;
  f27 = Math_fround(f12 * Math_fround(1.10000002));
  f26 = Math_fround(f13 * Math_fround(1.10000002));
  f25 = Math_fround(f14 * Math_fround(1.10000002));
  i6 = i41 + 4 | 0;
  i7 = i41 + 8 | 0;
  i18 = i42 + 4 | 0;
  i19 = i42 + 8 | 0;
  i20 = i43 + 4 | 0;
  i21 = i43 + 8 | 0;
  i22 = 0;
  i2 = 0;
  do {
   i5 = i37 + (i22 << 2) | 0;
   __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i101, i97, i95, 0, 0, HEAP32[i5 >> 2] | 0, 1, 1) | 0;
   f11 = Math_fround(HEAPF32[i28 >> 2]);
   f12 = Math_fround(HEAPF32[i95 >> 2]);
   f1 = Math_fround(f11 - f12);
   f13 = Math_fround(HEAPF32[i29 >> 2]);
   f14 = Math_fround(HEAPF32[i30 >> 2]);
   f8 = Math_fround(f13 - f14);
   f15 = Math_fround(HEAPF32[i31 >> 2]);
   f16 = Math_fround(HEAPF32[i32 >> 2]);
   f125 = Math_fround(f15 - f16);
   f17 = Math_fround(HEAPF32[i33 >> 2]);
   f124 = Math_fround(f17 - f12);
   f23 = Math_fround(HEAPF32[i34 >> 2]);
   f10 = Math_fround(f23 - f14);
   f24 = Math_fround(HEAPF32[i35 >> 2]);
   f9 = Math_fround(f24 - f16);
   f123 = Math_fround(Math_fround(f8 * f9) - Math_fround(f125 * f10));
   f9 = Math_fround(Math_fround(f125 * f124) - Math_fround(f1 * f9));
   f124 = Math_fround(Math_fround(f1 * f10) - Math_fround(f8 * f124));
   f8 = Math_fround(-f123);
   f10 = Math_fround(-f9);
   f1 = Math_fround(-f124);
   f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f124 * f124) + Math_fround(Math_fround(f123 * f123) + Math_fround(f9 * f9)))));
   if (f9 > Math_fround(0.0)) {
    f125 = Math_fround(Math_fround(1.0) / f9);
    f8 = Math_fround(f125 * f8);
    f9 = Math_fround(f125 * f10);
    f1 = Math_fround(f125 * f1);
   } else f9 = f10;
   if (Math_fround(Math_fround(f46 * f1) + Math_fround(Math_fround(f45 * f9) + Math_fround(f44 * f8))) >= f38) {
    i88 = f12 > Math_fround(8507058669999999534545717.0e13);
    i89 = f14 > Math_fround(8507058669999999534545717.0e13);
    i90 = f16 > Math_fround(8507058669999999534545717.0e13);
    i91 = f12 < Math_fround(-8507058669999999534545717.0e13);
    i92 = f14 < Math_fround(-8507058669999999534545717.0e13);
    i93 = f16 < Math_fround(-8507058669999999534545717.0e13);
    f124 = i88 ? Math_fround(8507058669999999534545717.0e13) : f12;
    f124 = f124 < f11 ? f124 : f11;
    f125 = i89 ? Math_fround(8507058669999999534545717.0e13) : f14;
    f125 = f125 < f13 ? f125 : f13;
    f8 = i90 ? Math_fround(8507058669999999534545717.0e13) : f16;
    f8 = f8 < f15 ? f8 : f15;
    f123 = i91 ? Math_fround(-8507058669999999534545717.0e13) : f12;
    f123 = f123 > f11 ? f123 : f11;
    f14 = i92 ? Math_fround(-8507058669999999534545717.0e13) : f14;
    f14 = f14 > f13 ? f14 : f13;
    f16 = i93 ? Math_fround(-8507058669999999534545717.0e13) : f16;
    f16 = f16 > f15 ? f16 : f15;
    f124 = f124 < f17 ? f124 : f17;
    f125 = f125 < f23 ? f125 : f23;
    f8 = f8 < f24 ? f8 : f24;
    f123 = f123 > f17 ? f123 : f17;
    f23 = f14 > f23 ? f14 : f23;
    f24 = f16 > f24 ? f16 : f24;
    HEAPF32[i41 >> 2] = f27;
    HEAPF32[i6 >> 2] = f26;
    HEAPF32[i7 >> 2] = f25;
    f16 = Math_fround(Math_fround(f125 + f23) * Math_fround(.5));
    f17 = Math_fround(Math_fround(f8 + f24) * Math_fround(.5));
    HEAPF32[i42 >> 2] = Math_fround(Math_fround(f124 + f123) * Math_fround(.5));
    HEAPF32[i18 >> 2] = f16;
    HEAPF32[i19 >> 2] = f17;
    f125 = Math_fround(Math_fround(Math_fround(Math_fround(f23 - f125) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
    f8 = Math_fround(Math_fround(Math_fround(Math_fround(f24 - f8) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
    HEAPF32[i43 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f123 - f124) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
    HEAPF32[i20 >> 2] = f125;
    HEAPF32[i21 >> 2] = f8;
    f8 = Math_fround(__Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i47, i41, i42, i43, i48, i49));
    if (f8 <= Math_fround(1.0)) {
     L26 : do if (!i2) i3 = 0; else {
      i4 = i2;
      while (1) {
       i3 = i4;
       i4 = i4 + -1 | 0;
       f1 = Math_fround(HEAPF32[i40 + (i4 << 2) >> 2]);
       if (f1 <= f8) break L26;
       HEAPF32[i40 + (i3 << 2) >> 2] = f1;
       HEAP32[i94 + (i3 << 2) >> 2] = HEAP32[i94 + (i4 << 2) >> 2];
       if (!i4) {
        i3 = 0;
        break;
       }
      }
     } while (0);
     HEAP32[i94 + (i3 << 2) >> 2] = HEAP32[i5 >> 2];
     HEAPF32[i40 + (i3 << 2) >> 2] = f8;
     i2 = i2 + 1 | 0;
    }
   }
   i22 = i22 + 1 | 0;
  } while ((i22 | 0) != (i36 | 0));
  f11 = Math_fround(HEAPF32[i39 >> 2]);
  i86 = i2;
 }
 HEAP32[i120 >> 2] = 0;
 i90 = i120 + 4 | 0;
 HEAP32[i90 >> 2] = 0;
 i91 = i120 + 8 | 0;
 HEAP32[i91 >> 2] = 0;
 HEAP32[i121 >> 2] = 0;
 i92 = i121 + 4 | 0;
 HEAP32[i92 >> 2] = 0;
 i93 = i121 + 8 | 0;
 HEAP32[i93 >> 2] = 0;
 i85 = i99 + 8744 | 0;
 HEAP32[i85 >> 2] = -1;
 f13 = Math_fround(HEAPF32[i50 >> 2]);
 f12 = Math_fround(HEAPF32[i51 >> 2]);
 f10 = Math_fround(HEAPF32[i52 >> 2]);
 f26 = Math_fround(f11 * f11);
 i18 = HEAP32[(HEAP32[i109 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i102 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i102 + 4 >> 2] = HEAP32[i109 + 16 >> 2];
 HEAP32[i102 + 8 >> 2] = HEAP32[i109 + 20 >> 2];
 HEAP32[i102 + 12 >> 2] = HEAP32[i109 + 24 >> 2];
 HEAPF32[i102 + 16 >> 2] = f13;
 HEAPF32[i102 + 20 >> 2] = f12;
 HEAPF32[i102 + 24 >> 2] = f10;
 i82 = HEAP32[i119 >> 2] | 0;
 HEAP32[i103 >> 2] = i82;
 i87 = i119 + 4 | 0;
 i83 = HEAP32[i87 >> 2] | 0;
 i2 = i103 + 4 | 0;
 HEAP32[i2 >> 2] = i83;
 i88 = i119 + 8 | 0;
 i84 = HEAP32[i88 >> 2] | 0;
 i3 = i103 + 8 | 0;
 HEAP32[i3 >> 2] = i84;
 i89 = i119 + 12 | 0;
 i81 = HEAP32[i89 >> 2] | 0;
 i4 = i103 + 12 | 0;
 HEAP32[i4 >> 2] = i81;
 i5 = i103 + 16 | 0;
 i78 = HEAP32[i119 + 16 >> 2] | 0;
 HEAP32[i5 >> 2] = i78;
 i79 = HEAP32[i119 + 20 >> 2] | 0;
 i6 = i103 + 20 | 0;
 HEAP32[i6 >> 2] = i79;
 i80 = HEAP32[i119 + 24 >> 2] | 0;
 i7 = i103 + 24 | 0;
 HEAP32[i7 >> 2] = i80;
 f1 = (HEAP32[tempDoublePtr >> 2] = i78, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i79, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i80, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i81, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i82, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i83, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i84, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i53) if (!(Math_fround(HEAPF32[(HEAP32[i57 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0))) {
  HEAP32[i103 >> 2] = HEAP32[i97 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i110 + 16 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i110 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i110 + 24 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i110 + 28 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i56 >> 2];
 }
 f23 = Math_fround(Math_fround(f13 - f1) * Math_fround(2.0));
 f46 = Math_fround(Math_fround(f12 - f8) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f10 - f9) * Math_fround(2.0));
 f123 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f24 = Math_fround(Math_fround(Math_fround(f23 * f15) + Math_fround(f46 * f16)) + Math_fround(f25 * f17));
 f124 = Math_fround(Math_fround(f16 * f24) + Math_fround(Math_fround(f46 * f123) - Math_fround(f14 * Math_fround(Math_fround(f23 * f17) - Math_fround(f25 * f15)))));
 f125 = Math_fround(Math_fround(Math_fround(f25 * f123) - Math_fround(f14 * Math_fround(Math_fround(f46 * f15) - Math_fround(f23 * f16)))) + Math_fround(f17 * f24));
 HEAPF32[i111 >> 2] = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f23 * f123) - Math_fround(f14 * Math_fround(Math_fround(f25 * f16) - Math_fround(f46 * f17)))));
 i83 = i111 + 4 | 0;
 HEAPF32[i83 >> 2] = f124;
 i84 = i111 + 8 | 0;
 HEAPF32[i84 >> 2] = f125;
 f125 = Math_fround(Math_fround(f13 - f1) * Math_fround(2.0));
 f124 = Math_fround(Math_fround(f12 - f8) * Math_fround(2.0));
 f46 = Math_fround(Math_fround(f10 - f9) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(Math_fround(f125 * f15) + Math_fround(f124 * f16)) + Math_fround(f46 * f17));
 f23 = Math_fround(Math_fround(f15 * f25) + Math_fround(Math_fround(f125 * f123) - Math_fround(f14 * Math_fround(Math_fround(f46 * f16) - Math_fround(f124 * f17)))));
 f24 = Math_fround(Math_fround(f16 * f25) + Math_fround(Math_fround(f124 * f123) - Math_fround(f14 * Math_fround(Math_fround(f125 * f17) - Math_fround(f46 * f15)))));
 f25 = Math_fround(Math_fround(Math_fround(f46 * f123) - Math_fround(f14 * Math_fround(Math_fround(f124 * f15) - Math_fround(f125 * f16)))) + Math_fround(f17 * f25));
 if (!i86) {
  i113 = 0;
  i112 = 0;
  i111 = 0;
  i119 = 0;
  i115 = 0;
  i114 = 0;
  f38 = f14;
  f27 = f15;
  f46 = f16;
  f45 = f17;
  f125 = Math_fround(3402823469999999843913219.0e14);
  f26 = (HEAP32[tempDoublePtr >> 2] = i111, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 * Math_fround(2.0));
  f25 = (HEAP32[tempDoublePtr >> 2] = i112, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f25 * Math_fround(2.0));
  f24 = (HEAP32[tempDoublePtr >> 2] = i113, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = Math_fround(f24 * Math_fround(2.0));
  f44 = Math_fround(f38 * f38);
  f44 = Math_fround(f44 + Math_fround(-.5));
  f124 = Math_fround(f26 * f27);
  f23 = Math_fround(f25 * f46);
  f23 = Math_fround(f124 + f23);
  f124 = Math_fround(f24 * f45);
  f124 = Math_fround(f23 + f124);
  f23 = Math_fround(f26 * f44);
  f17 = Math_fround(f24 * f46);
  f105 = Math_fround(f25 * f45);
  f105 = Math_fround(f17 - f105);
  f105 = Math_fround(f38 * f105);
  f105 = Math_fround(f23 + f105);
  f23 = Math_fround(f27 * f124);
  f105 = Math_fround(f23 + f105);
  f23 = Math_fround(f25 * f44);
  f17 = Math_fround(f26 * f45);
  f123 = Math_fround(f24 * f27);
  f123 = Math_fround(f17 - f123);
  f123 = Math_fround(f38 * f123);
  f123 = Math_fround(f23 + f123);
  f23 = Math_fround(f46 * f124);
  f123 = Math_fround(f23 + f123);
  f44 = Math_fround(f24 * f44);
  f27 = Math_fround(f25 * f27);
  f46 = Math_fround(f26 * f46);
  f46 = Math_fround(f27 - f46);
  f46 = Math_fround(f38 * f46);
  f46 = Math_fround(f44 + f46);
  f124 = Math_fround(f45 * f124);
  f124 = Math_fround(f46 + f124);
  HEAPF32[i120 >> 2] = f105;
  HEAPF32[i90 >> 2] = f123;
  HEAPF32[i91 >> 2] = f124;
  HEAP32[i121 >> 2] = i114;
  HEAP32[i92 >> 2] = i115;
  HEAP32[i93 >> 2] = i119;
  __ZN5physx2Gu9ContainerD2Ev(i116);
  __ZN5physx2Gu9ContainerD2Ev(i117);
  __ZN5physx2Gu9ContainerD2Ev(i118);
  STACKTOP = i122;
  return Math_fround(f125);
 }
 i55 = i114 + 4 | 0;
 i56 = i114 + 8 | 0;
 i57 = i114 + 12 | 0;
 i58 = i114 + 16 | 0;
 i59 = i114 + 20 | 0;
 i60 = i114 + 24 | 0;
 i61 = i114 + 28 | 0;
 i62 = i114 + 32 | 0;
 i63 = i115 + 64 | 0;
 i64 = i115 + 80 | 0;
 i65 = i115 + 16 | 0;
 i66 = i115 + 32 | 0;
 i67 = i115 + 48 | 0;
 i68 = i115 + 4 | 0;
 i69 = i115 + 8 | 0;
 i70 = i115 + 12 | 0;
 i71 = i115 + 96 | 0;
 i72 = i115 + 100 | 0;
 i73 = i115 + 104 | 0;
 i74 = i115 + 108 | 0;
 i75 = i115 + 112 | 0;
 i76 = i115 + 116 | 0;
 i77 = i115 + 120 | 0;
 i78 = i115 + 124 | 0;
 i79 = i115 + 128 | 0;
 i80 = i115 + 132 | 0;
 i81 = i115 + 136 | 0;
 i82 = i115 + 140 | 0;
 i19 = HEAP32[gb + 103160 + (i18 << 2) >> 2] | 0;
 i20 = i96 + 36 | 0;
 i21 = i96 + 4 | 0;
 i22 = i96 + 8 | 0;
 i28 = i96 + 12 | 0;
 i29 = i96 + 16 | 0;
 i30 = i96 + 20 | 0;
 i31 = i96 + 24 | 0;
 i32 = i96 + 28 | 0;
 i33 = i96 + 32 | 0;
 i34 = i96 + 40 | 0;
 i35 = i96 + 44 | 0;
 i36 = i96 + 48 | 0;
 i37 = i96 + 52 | 0;
 i39 = i96 + 56 | 0;
 i40 = i96 + 60 | 0;
 i41 = i96 + 64 | 0;
 i42 = i96 + 68 | 0;
 i43 = i107 + 4 | 0;
 i47 = i107 + 8 | 0;
 i48 = i95 + 4 | 0;
 i49 = i95 + 8 | 0;
 i50 = i104 + 4 | 0;
 i51 = i104 + 8 | 0;
 i52 = i100 + 4 | 0;
 i53 = i100 + 8 | 0;
 f16 = Math_fround(f11 * Math_fround(2.0));
 i2 = 0;
 i3 = 0;
 i4 = 0;
 i5 = 0;
 i6 = 0;
 i7 = 0;
 f1 = Math_fround(3402823469999999843913219.0e14);
 i54 = 0;
 do {
  i18 = i94 + (i54 << 2) | 0;
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i101, i97, i114, 0, 0, HEAP32[i18 >> 2] | 0, 0, 0) | 0;
  i134 = HEAP32[i114 >> 2] | 0;
  i133 = HEAP32[i55 >> 2] | 0;
  i132 = HEAP32[i56 >> 2] | 0;
  i131 = HEAP32[i57 >> 2] | 0;
  i130 = HEAP32[i58 >> 2] | 0;
  i129 = HEAP32[i59 >> 2] | 0;
  i128 = HEAP32[i60 >> 2] | 0;
  i127 = HEAP32[i61 >> 2] | 0;
  i126 = HEAP32[i62 >> 2] | 0;
  HEAP32[i64 >> 2] = 7;
  HEAPF32[i67 >> 2] = Math_fround(0.0);
  HEAP32[i95 >> 2] = 0;
  HEAP32[i95 + 4 >> 2] = 0;
  HEAP32[i95 + 8 >> 2] = 0;
  HEAP32[i95 + 12 >> 2] = 0;
  HEAP32[i63 >> 2] = HEAP32[i95 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
  HEAP32[i63 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
  f125 = (HEAP32[tempDoublePtr >> 2] = i134, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f124 = (HEAP32[tempDoublePtr >> 2] = i133, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i132, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = (HEAP32[tempDoublePtr >> 2] = i131, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f46 = (HEAP32[tempDoublePtr >> 2] = i130, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f123 = Math_fround(f125 + f123);
  f46 = Math_fround(f124 + f46);
  f8 = Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i129, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f124 = (HEAP32[tempDoublePtr >> 2] = i128, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f125 = (HEAP32[tempDoublePtr >> 2] = i127, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f125 = Math_fround(Math_fround(f46 + f125) * Math_fround(.333332986));
  f8 = Math_fround(Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i126, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.333332986));
  HEAPF32[i115 >> 2] = Math_fround(Math_fround(f123 + f124) * Math_fround(.333332986));
  HEAPF32[i68 >> 2] = f125;
  HEAPF32[i69 >> 2] = f8;
  HEAPF32[i70 >> 2] = Math_fround(0.0);
  HEAP32[i71 >> 2] = i134;
  HEAP32[i72 >> 2] = i133;
  HEAP32[i73 >> 2] = i132;
  HEAPF32[i74 >> 2] = Math_fround(0.0);
  HEAP32[i75 >> 2] = i131;
  HEAP32[i76 >> 2] = i130;
  HEAP32[i77 >> 2] = i129;
  HEAPF32[i78 >> 2] = Math_fround(0.0);
  HEAP32[i79 >> 2] = i128;
  HEAP32[i80 >> 2] = i127;
  HEAP32[i81 >> 2] = i126;
  HEAPF32[i82 >> 2] = Math_fround(0.0);
  HEAPF32[i65 >> 2] = Math_fround(0.0);
  HEAPF32[i66 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i96 >> 2] = 1065353216;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i29 >> 2] = 1065353216;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i32 >> 2] = 0;
  HEAP32[i33 >> 2] = 1065353216;
  HEAP32[i20 >> 2] = 1065353216;
  HEAP32[i34 >> 2] = 0;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i37 >> 2] = 1065353216;
  HEAP32[i39 >> 2] = 0;
  HEAP32[i40 >> 2] = 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i42 >> 2] = 1065353216;
  f8 = Math_fround(+mftCall_fiiiiiifiiiiiif(i19 | 0, i109 | 0, i110 | 0, i113 | 0, i119 | 0, i102 | 0, i103 | 0, +f105, i106 | 0, i107 | 0, i98 | 0, i99 | 0, i96 | 0, i115 | 0, 0.0));
  if (!(f8 <= Math_fround(0.0))) f12 = f8; else {
   f8 = Math_fround(HEAPF32[i57 >> 2]);
   f15 = Math_fround(HEAPF32[i114 >> 2]);
   f8 = Math_fround(f8 - f15);
   f9 = Math_fround(HEAPF32[i58 >> 2]);
   f125 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(f9 - f125);
   f10 = Math_fround(HEAPF32[i59 >> 2]);
   f124 = Math_fround(HEAPF32[i56 >> 2]);
   f10 = Math_fround(f10 - f124);
   f12 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f15);
   f13 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f125);
   f14 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) - f124);
   f46 = Math_fround(f9 + f125);
   f123 = Math_fround(f10 + f124);
   HEAPF32[i95 >> 2] = Math_fround(f8 + f15);
   HEAPF32[i48 >> 2] = f46;
   HEAPF32[i49 >> 2] = f123;
   f125 = Math_fround(f13 + f125);
   f124 = Math_fround(f14 + f124);
   HEAPF32[i104 >> 2] = Math_fround(f12 + f15);
   HEAPF32[i50 >> 2] = f125;
   HEAPF32[i51 >> 2] = f124;
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i100, i111, i114, i95, i104, i108, i112);
   f124 = Math_fround(HEAPF32[i100 >> 2]);
   f124 = Math_fround(f124 - Math_fround(HEAPF32[i111 >> 2]));
   f125 = Math_fround(HEAPF32[i52 >> 2]);
   f125 = Math_fround(f125 - Math_fround(HEAPF32[i83 >> 2]));
   f15 = Math_fround(HEAPF32[i53 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i84 >> 2]));
   f15 = Math_fround(Math_fround(Math_fround(f124 * f124) + Math_fround(f125 * f125)) + Math_fround(f15 * f15));
   if (f15 < f26) {
    f46 = Math_fround(Math_fround(f9 * f14) - Math_fround(f10 * f13));
    f123 = Math_fround(Math_fround(f10 * f12) - Math_fround(f8 * f14));
    f125 = Math_fround(Math_fround(f8 * f13) - Math_fround(f9 * f12));
    f8 = Math_fround(Math_sqrt(Math_fround(f15)));
    f9 = Math_fround(f8 - f11);
    f124 = Math_fround(f46 * Math_fround(HEAPF32[i114 >> 2]));
    f124 = Math_fround(f124 + Math_fround(f123 * Math_fround(HEAPF32[i55 >> 2])));
    if (Math_fround(Math_fround(Math_fround(f25 * f125) + Math_fround(Math_fround(f23 * f46) + Math_fround(f24 * f123))) - Math_fround(f124 + Math_fround(f125 * Math_fround(HEAPF32[i56 >> 2])))) > Math_fround(0.0)) f12 = Math_fround(-Math_fround(f16 - f8)); else f12 = f9;
   } else f12 = Math_fround(0.0);
  }
  if (f12 < f1) {
   f124 = Math_fround(HEAPF32[i57 >> 2]);
   f9 = Math_fround(HEAPF32[i114 >> 2]);
   f124 = Math_fround(f124 - f9);
   f10 = Math_fround(HEAPF32[i58 >> 2]);
   f125 = Math_fround(HEAPF32[i55 >> 2]);
   f10 = Math_fround(f10 - f125);
   f123 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i56 >> 2]);
   f123 = Math_fround(f123 - f8);
   f9 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f9);
   f125 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f125);
   f8 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) - f8);
   f1 = Math_fround(Math_fround(f10 * f8) - Math_fround(f123 * f125));
   f8 = Math_fround(Math_fround(f123 * f9) - Math_fround(f124 * f8));
   f9 = Math_fround(Math_fround(f124 * f125) - Math_fround(f10 * f9));
   f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f1 * f1) + Math_fround(f8 * f8)))));
   if (f10 > Math_fround(0.0)) {
    f125 = Math_fround(Math_fround(1.0) / f10);
    f9 = Math_fround(f9 * f125);
    f8 = Math_fround(f8 * f125);
    f1 = Math_fround(f1 * f125);
   }
   i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP32[i107 >> 2] | 0;
   i3 = HEAP32[i43 >> 2] | 0;
   i4 = HEAP32[i47 >> 2] | 0;
   HEAP32[i85 >> 2] = HEAP32[i18 >> 2];
   f1 = f12;
  }
  i54 = i54 + 1 | 0;
 } while ((i54 | 0) != (i86 | 0));
 f38 = Math_fround(HEAPF32[i89 >> 2]);
 f27 = Math_fround(HEAPF32[i119 >> 2]);
 f46 = Math_fround(HEAPF32[i87 >> 2]);
 i131 = i7;
 i130 = i6;
 i129 = i5;
 i134 = i4;
 i133 = i3;
 i132 = i2;
 f45 = Math_fround(HEAPF32[i88 >> 2]);
 f125 = f1;
 f26 = (HEAP32[tempDoublePtr >> 2] = i129, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f26 * Math_fround(2.0));
 f25 = (HEAP32[tempDoublePtr >> 2] = i130, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f25 * Math_fround(2.0));
 f24 = (HEAP32[tempDoublePtr >> 2] = i131, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f24 * Math_fround(2.0));
 f44 = Math_fround(f38 * f38);
 f44 = Math_fround(f44 + Math_fround(-.5));
 f124 = Math_fround(f26 * f27);
 f23 = Math_fround(f25 * f46);
 f23 = Math_fround(f124 + f23);
 f124 = Math_fround(f24 * f45);
 f124 = Math_fround(f23 + f124);
 f23 = Math_fround(f26 * f44);
 f17 = Math_fround(f24 * f46);
 f105 = Math_fround(f25 * f45);
 f105 = Math_fround(f17 - f105);
 f105 = Math_fround(f38 * f105);
 f105 = Math_fround(f23 + f105);
 f23 = Math_fround(f27 * f124);
 f105 = Math_fround(f23 + f105);
 f23 = Math_fround(f25 * f44);
 f17 = Math_fround(f26 * f45);
 f123 = Math_fround(f24 * f27);
 f123 = Math_fround(f17 - f123);
 f123 = Math_fround(f38 * f123);
 f123 = Math_fround(f23 + f123);
 f23 = Math_fround(f46 * f124);
 f123 = Math_fround(f23 + f123);
 f44 = Math_fround(f24 * f44);
 f27 = Math_fround(f25 * f27);
 f46 = Math_fround(f26 * f46);
 f46 = Math_fround(f27 - f46);
 f46 = Math_fround(f38 * f46);
 f46 = Math_fround(f44 + f46);
 f124 = Math_fround(f45 * f124);
 f124 = Math_fround(f46 + f124);
 HEAPF32[i120 >> 2] = f105;
 HEAPF32[i90 >> 2] = f123;
 HEAPF32[i91 >> 2] = f124;
 HEAP32[i121 >> 2] = i132;
 HEAP32[i92 >> 2] = i133;
 HEAP32[i93 >> 2] = i134;
 __ZN5physx2Gu9ContainerD2Ev(i116);
 __ZN5physx2Gu9ContainerD2Ev(i117);
 __ZN5physx2Gu9ContainerD2Ev(i118);
 STACKTOP = i122;
 return Math_fround(f125);
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i20, i24, i2, i1) {
 i20 = i20 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23;
 i19 = i2 >> 1;
 i22 = i20 + (i19 * 40 | 0) | 0;
 L1 : do if ((i2 | 0) < 65) {
  i8 = i20 + (i19 * 40 | 0) + 28 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i9 = i20 + 28 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i22;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i20;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i20 + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 8;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 8;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 8; while (0);
  if ((i18 | 0) == 8) {
   i1 = i21;
   i2 = i22;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i20 + 32 >> 1] | 0;
   HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i20 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i20 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i20 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = HEAP32[i24 + 28 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i3 = i24;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i22;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i24 + 32 >> 1] | 0;
    i7 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 15;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 15;
  } else if (i1 >>> 0 < i2 >>> 0) i18 = 15; while (0);
  if ((i18 | 0) == 15) {
   i1 = i21;
   i2 = i24;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i24 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i24 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i24 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   HEAP32[i24 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
   HEAP32[i24 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
   HEAP32[i24 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
   HEAP16[i24 + 32 >> 1] = HEAP16[i22 + 32 >> 1] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i4 = i22;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i20;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i3 | 0) == (i5 | 0) & (i4 | 0) == (i6 | 0)) {
    i1 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i2 = HEAP16[i20 + 32 >> 1] | 0;
    if (i1 << 16 >> 16 != i2 << 16 >> 16) if ((i1 & 65535) > (i2 & 65535)) break; else break L1;
   }
   if (!(i4 >>> 0 < i6 >>> 0 | (i4 | 0) == (i6 | 0) & i3 >>> 0 < i5 >>> 0)) break L1;
  } else if (i2 >>> 0 >= i1 >>> 0) break L1; while (0);
  i1 = i21;
  i2 = i22;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i22 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i22 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i22 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
  HEAP16[i22 + 32 >> 1] = HEAP16[i20 + 32 >> 1] | 0;
  HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i20 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i20 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  HEAP32[i20 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
  HEAP32[i20 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
  HEAP16[i20 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
 } else {
  i16 = i2 >> 3;
  i11 = i16 << 1;
  i17 = i20 + (i16 * 40 | 0) | 0;
  i8 = i20 + (i11 * 40 | 0) | 0;
  i15 = i20 + (i16 * 40 | 0) + 28 | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  i9 = i20 + 28 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i17;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i20;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i20 + (i16 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i20 + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 29;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 29;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 29; while (0);
  if ((i18 | 0) == 29) {
   i1 = i21;
   i2 = i17;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   HEAP32[i17 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
   HEAP16[i17 + 32 >> 1] = HEAP16[i20 + 32 >> 1] | 0;
   HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i20 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i20 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i20 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
  }
  i1 = HEAP32[i20 + (i11 * 40 | 0) + 28 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i3 = i8;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i17;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i20 + (i11 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i20 + (i16 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 36;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 36;
  } else if (i1 >>> 0 < i2 >>> 0) i18 = 36; while (0);
  if ((i18 | 0) == 36) {
   i1 = i21;
   i2 = i8;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
   HEAP32[i8 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
   HEAP16[i8 + 32 >> 1] = HEAP16[i17 + 32 >> 1] | 0;
   HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i17 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i17 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i2 = i17;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i20;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
    i5 = HEAP16[i20 + (i16 * 40 | 0) + 32 >> 1] | 0;
    i6 = HEAP16[i20 + 32 >> 1] | 0;
    if (i5 << 16 >> 16 != i6 << 16 >> 16) if ((i5 & 65535) > (i6 & 65535)) {
     i18 = 43;
     break;
    } else break;
   }
   if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) i18 = 43;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 43; while (0);
  if ((i18 | 0) == 43) {
   i1 = i21;
   i2 = i17;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   HEAP32[i17 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
   HEAP16[i17 + 32 >> 1] = HEAP16[i20 + 32 >> 1] | 0;
   HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i20 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i20 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i20 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
  }
  i13 = 0 - i16 | 0;
  i10 = i22 + (i13 * 40 | 0) | 0;
  i8 = i22 + (i16 * 40 | 0) | 0;
  i14 = i20 + (i19 * 40 | 0) + 28 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i9 = i10 + 28 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i22;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i10;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i10 + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 50;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 50;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 50; while (0);
  if ((i18 | 0) == 50) {
   i1 = i21;
   i2 = i22;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i10 + 32 >> 1] | 0;
   HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i10 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
  }
  i1 = HEAP32[i8 + 28 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i3 = i8;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i22;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i8 + 32 >> 1] | 0;
    i7 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 57;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 57;
  } else if (i1 >>> 0 < i2 >>> 0) i18 = 57; while (0);
  if ((i18 | 0) == 57) {
   i1 = i21;
   i2 = i8;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
   HEAP32[i8 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
   HEAP16[i8 + 32 >> 1] = HEAP16[i22 + 32 >> 1] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i2 = i22;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i10;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
    i5 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i6 = HEAP16[i10 + 32 >> 1] | 0;
    if (i5 << 16 >> 16 != i6 << 16 >> 16) if ((i5 & 65535) > (i6 & 65535)) {
     i18 = 64;
     break;
    } else break;
   }
   if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) i18 = 64;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 64; while (0);
  if ((i18 | 0) == 64) {
   i1 = i21;
   i2 = i22;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i10 + 32 >> 1] | 0;
   HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i10 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
  }
  i9 = 0 - i11 | 0;
  i10 = i24 + (i9 * 40 | 0) | 0;
  i12 = i24 + (i13 * 40 | 0) | 0;
  i11 = i24 + (i13 * 40 | 0) + 28 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i8 = i24 + (i9 * 40 | 0) + 28 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i12;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i10;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i24 + (i13 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i24 + (i9 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 71;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 71;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 71; while (0);
  if ((i18 | 0) == 71) {
   i1 = i21;
   i2 = i12;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i12 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
   HEAP16[i12 + 32 >> 1] = HEAP16[i10 + 32 >> 1] | 0;
   HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i10 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  }
  i1 = HEAP32[i24 + 28 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i3 = i24;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i12;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i24 + 32 >> 1] | 0;
    i7 = HEAP16[i24 + (i13 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 78;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 78;
  } else if (i1 >>> 0 < i2 >>> 0) i18 = 78; while (0);
  if ((i18 | 0) == 78) {
   i1 = i21;
   i2 = i24;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i24 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i24 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i24 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP32[i24 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i24 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
   HEAP16[i24 + 32 >> 1] = HEAP16[i12 + 32 >> 1] | 0;
   HEAP32[i12 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i12 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i12 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i12;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i10;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i24 + (i13 * 40 | 0) + 32 >> 1] | 0;
    i1 = HEAP16[i24 + (i9 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i1 << 16 >> 16) if ((i6 & 65535) > (i1 & 65535)) {
     i18 = 85;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) i18 = 85;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 85; while (0);
  if ((i18 | 0) == 85) {
   i1 = i21;
   i2 = i12;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i12 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
   HEAP16[i12 + 32 >> 1] = HEAP16[i10 + 32 >> 1] | 0;
   HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i10 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
  }
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i3 = i22;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i17;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i20 + (i16 * 40 | 0) + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) if ((i6 & 65535) > (i7 & 65535)) {
     i18 = 92;
     break;
    } else break;
   }
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0) i18 = 92;
  } else if (i2 >>> 0 < i1 >>> 0) i18 = 92; while (0);
  if ((i18 | 0) == 92) {
   i1 = i21;
   i2 = i22;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i17 + 32 >> 1] | 0;
   HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i17 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i17 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i5 = i12;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i22;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
    i1 = HEAP16[i24 + (i13 * 40 | 0) + 32 >> 1] | 0;
    i3 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    if (i1 << 16 >> 16 != i3 << 16 >> 16) if ((i1 & 65535) > (i3 & 65535)) {
     i18 = 99;
     break;
    } else break;
   }
   if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) i18 = 99;
  } else if (i1 >>> 0 < i2 >>> 0) i18 = 99; while (0);
  if ((i18 | 0) == 99) {
   i1 = i21;
   i2 = i12;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
   HEAP32[i12 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
   HEAP16[i12 + 32 >> 1] = HEAP16[i22 + 32 >> 1] | 0;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
   HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
   HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
   HEAP16[i22 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  do if ((i2 | 0) == (i1 | 0)) {
   i4 = i22;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i17;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i3 | 0) == (i5 | 0) & (i4 | 0) == (i6 | 0)) {
    i2 = HEAP16[i20 + (i19 * 40 | 0) + 32 >> 1] | 0;
    i1 = HEAP16[i20 + (i16 * 40 | 0) + 32 >> 1] | 0;
    if (i2 << 16 >> 16 != i1 << 16 >> 16) if ((i2 & 65535) > (i1 & 65535)) break; else break L1;
   }
   if (!(i4 >>> 0 < i6 >>> 0 | (i4 | 0) == (i6 | 0) & i3 >>> 0 < i5 >>> 0)) break L1;
  } else if (i2 >>> 0 >= i1 >>> 0) break L1; while (0);
  i1 = i21;
  i2 = i22;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i22 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  HEAP32[i22 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
  HEAP32[i22 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
  HEAP16[i22 + 32 >> 1] = HEAP16[i17 + 32 >> 1] | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
  HEAP16[i17 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
 } while (0);
 i1 = i21;
 i2 = i22;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i24 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[i24 + 28 >> 2];
 HEAP16[i22 + 32 >> 1] = HEAP16[i24 + 32 >> 1] | 0;
 HEAP32[i24 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
 HEAP16[i24 + 32 >> 1] = HEAP16[i21 + 32 >> 1] | 0;
 STACKTOP = i23;
 return;
}

function __Z14WorldCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjibibRKf(i77, i78, i82, i83, i85, i86, i67, i68, i69, i70, i79) {
 i77 = i77 | 0;
 i78 = i78 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i85 = i85 | 0;
 i86 = i86 | 0;
 i67 = i67 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i70 = i70 | 0;
 i79 = i79 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f65 = f0, i66 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i80 = 0, i81 = 0, i84 = 0, i87 = 0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, i92 = 0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0;
 i87 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i87;
 i80 = i87 + 32 | 0;
 i81 = i87 + 28 | 0;
 i75 = i87 + 8 | 0;
 i76 = i85 + 24 | 0;
 i73 = (HEAP32[i76 >> 2] | 0) != 0;
 i2 = HEAP32[i83 + 12 >> 2] | 0;
 i3 = HEAP32[i85 + 40 >> 2] | 0;
 i1 = i73 ? i3 : i86;
 i4 = HEAP32[i85 + 36 >> 2] | 0;
 if (i73) {
  i84 = i4 + i3 | 0;
  i84 = i2 >>> 0 < i84 >>> 0 ? i2 : i84;
 } else i84 = i2;
 HEAP32[i80 >> 2] = i1;
 HEAP32[i81 >> 2] = i2;
 i74 = i85 + 44 | 0;
 f65 = Math_fround(HEAPF32[i74 >> 2]);
 f45 = Math_fround(f65 * Math_fround(4.0));
 f65 = f65 < f45 ? f45 : f65;
 i2 = i84 - i1 | 0;
 HEAP32[i82 + 20 >> 2] = i4 + i3;
 i72 = i82 + 16 | 0;
 i71 = HEAP32[i72 >> 2] | 0;
 i71 = i71 >>> 0 > i2 >>> 0 ? 3 - i2 + i71 | 0 : 3;
 HEAP32[i72 >> 2] = i71 - ((i71 | 0) % 4 | 0);
 if (i2) {
  i64 = (i2 + 3 | 0) >>> 2;
  i66 = i75 + 12 | 0;
  HEAP32[i66 >> 2] = i64;
  i71 = i75 + 16 | 0;
  HEAP32[i71 >> 2] = i64;
  i72 = i75 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 64016 | 0);
  i61 = i5;
  i62 = HEAP32[i61 + 4 >> 2] | 0;
  i63 = i72;
  HEAP32[i63 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i63 + 4 >> 2] = i62;
  i64 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i64 << 7, 4, i72, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i75 >> 2] = i64;
  if (i84 >>> 0 > i1 >>> 0) {
   i50 = HEAP32[i83 >> 2] | 0;
   i51 = HEAP32[i83 + 20 >> 2] | 0;
   i52 = HEAP32[i83 + 40 >> 2] | 0;
   i53 = HEAP32[i83 + 60 >> 2] | 0;
   i54 = HEAP32[i83 + 80 >> 2] | 0;
   i55 = HEAP32[i83 + 100 >> 2] | 0;
   i56 = HEAP32[i83 + 120 >> 2] | 0;
   i57 = HEAP32[i83 + 140 >> 2] | 0;
   i58 = HEAP32[i83 + 160 >> 2] | 0;
   i59 = HEAP32[i83 + 420 >> 2] | 0;
   i60 = (HEAP8[i83 + 871 >> 0] | 0) == 0;
   i61 = i85 + 20 | 0;
   i62 = HEAP32[i83 + 440 >> 2] | 0;
   i63 = HEAP32[i83 + 460 >> 2] | 0;
   i46 = 0;
   i47 = i1;
   i48 = i1 + 2 | 0;
   i49 = i1 + 3 | 0;
   i5 = i1 + 1 | 0;
   while (1) {
    i9 = i50 + (i47 << 2) | 0;
    i6 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i9 + 4 >> 2] | 0;
    i8 = HEAP32[i9 + 8 >> 2] | 0;
    i9 = HEAP32[i9 + 12 >> 2] | 0;
    i28 = i51 + (i47 << 2) | 0;
    i10 = HEAP32[i28 >> 2] | 0;
    i26 = HEAP32[i28 + 4 >> 2] | 0;
    i27 = HEAP32[i28 + 8 >> 2] | 0;
    i28 = HEAP32[i28 + 12 >> 2] | 0;
    i32 = i52 + (i47 << 2) | 0;
    i29 = HEAP32[i32 >> 2] | 0;
    i30 = HEAP32[i32 + 4 >> 2] | 0;
    i31 = HEAP32[i32 + 8 >> 2] | 0;
    i32 = HEAP32[i32 + 12 >> 2] | 0;
    i4 = i53 + (i47 << 2) | 0;
    f42 = Math_fround(HEAPF32[i4 >> 2]);
    f40 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f38 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f36 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    i4 = i54 + (i47 << 2) | 0;
    f34 = Math_fround(HEAPF32[i4 >> 2]);
    f25 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f23 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f21 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    i4 = i55 + (i47 << 2) | 0;
    f19 = Math_fround(HEAPF32[i4 >> 2]);
    f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f45 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    i4 = i56 + (i47 << 2) | 0;
    f16 = Math_fround(HEAPF32[i4 >> 2]);
    f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f22 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    i4 = i57 + (i47 << 2) | 0;
    f24 = Math_fround(HEAPF32[i4 >> 2]);
    f33 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f35 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f37 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    i4 = i58 + (i47 << 2) | 0;
    f39 = Math_fround(HEAPF32[i4 >> 2]);
    f41 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f43 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    f16 = Math_fround(f42 + f16);
    f18 = Math_fround(f40 + f18);
    f20 = Math_fround(f38 + f20);
    f22 = Math_fround(f36 + f22);
    f24 = Math_fround(f34 + f24);
    f33 = Math_fround(f25 + f33);
    f35 = Math_fround(f23 + f35);
    f37 = Math_fround(f21 + f37);
    f39 = Math_fround(f19 + f39);
    f41 = Math_fround(f17 + f41);
    f43 = Math_fround(f15 + f43);
    f45 = Math_fround(f45 + Math_fround(HEAPF32[i4 + 12 >> 2]));
    f15 = Math_fround(HEAPF32[i79 >> 2]);
    f16 = Math_fround(f16 * f15);
    f18 = Math_fround(f18 * f15);
    f20 = Math_fround(f20 * f15);
    f22 = Math_fround(f22 * f15);
    f24 = Math_fround(f24 * f15);
    f33 = Math_fround(f33 * f15);
    f35 = Math_fround(f35 * f15);
    f37 = Math_fround(f37 * f15);
    f39 = Math_fround(f39 * f15);
    f41 = Math_fround(f41 * f15);
    f43 = Math_fround(f43 * f15);
    f45 = Math_fround(f15 * f45);
    f15 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = Math_fround(f15 - f16);
    f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = Math_fround(f17 - f18);
    f19 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f19 - f20);
    f21 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f22 = Math_fround(f21 - f22);
    f23 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f24 = Math_fround(f23 - f24);
    f25 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f33 = Math_fround(f25 - f33);
    f34 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f35 = Math_fround(f34 - f35);
    f36 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f36 - f37);
    f38 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f38 - f39);
    f40 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f41 = Math_fround(f40 - f41);
    f42 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f42 - f43);
    f44 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(f44 - f45);
    i4 = i59 + (i47 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    i3 = HEAP32[i4 + 8 >> 2] | 0;
    i4 = HEAP32[i4 + 12 >> 2] | 0;
    if (!i60) {
     i92 = i62 + (i47 << 2) | 0;
     f91 = Math_fround(HEAPF32[i92 >> 2]);
     f89 = Math_fround(HEAPF32[i92 + 4 >> 2]);
     f11 = Math_fround(HEAPF32[i92 + 8 >> 2]);
     f13 = Math_fround(HEAPF32[i92 + 12 >> 2]);
     f90 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f91 = f90 > f91 ? f90 : f91;
     f90 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f89 = f90 > f89 ? f90 : f89;
     f90 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f11 = f90 > f11 ? f90 : f11;
     f90 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = f90 > f13 ? f90 : f13;
     i1 = i63 + (i47 << 2) | 0;
     f90 = Math_fround(HEAPF32[i1 >> 2]);
     f88 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f14 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f91 > f90 ? f91 : f90, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f89 > f88 ? f89 : f88, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f11 > f12 ? f11 : f12, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f13 > f14 ? f13 : f14, HEAP32[tempDoublePtr >> 2] | 0);
    }
    f11 = Math_fround(HEAPF32[i61 >> 2]);
    f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
    f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
    f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
    f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
    if (i73) {
     f100 = Math_fround(f15 - f16);
     f99 = Math_fround(f17 - f18);
     f98 = Math_fround(f19 - f20);
     f97 = Math_fround(f21 - f22);
     f96 = Math_fround(f23 - f24);
     f95 = Math_fround(f25 - f33);
     f94 = Math_fround(f34 - f35);
     f93 = Math_fround(f36 - f37);
     f15 = Math_fround(f38 - f39);
     f17 = Math_fround(f40 - f41);
     f19 = Math_fround(f42 - f43);
     f21 = Math_fround(f44 - f45);
     f88 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f100 * f100) + Math_fround(f96 * f96))))));
     f89 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f99 * f99) + Math_fround(f95 * f95))))));
     f90 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f98 * f98) + Math_fround(f94 * f94))))));
     f91 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f97 * f97) + Math_fround(f93 * f93))))));
     f23 = Math_fround(f16 + Math_fround(f65 * Math_fround(f100 * f88)));
     f25 = Math_fround(f18 + Math_fround(f65 * Math_fround(f99 * f89)));
     f34 = Math_fround(f20 + Math_fround(f65 * Math_fround(f98 * f90)));
     f36 = Math_fround(f22 + Math_fround(f65 * Math_fround(f97 * f91)));
     f38 = Math_fround(f24 + Math_fround(f65 * Math_fround(f96 * f88)));
     f40 = Math_fround(f33 + Math_fround(f65 * Math_fround(f95 * f89)));
     f42 = Math_fround(f35 + Math_fround(f65 * Math_fround(f94 * f90)));
     f44 = Math_fround(f37 + Math_fround(f65 * Math_fround(f93 * f91)));
     f88 = Math_fround(f39 + Math_fround(f65 * Math_fround(f15 * f88)));
     f89 = Math_fround(f41 + Math_fround(f65 * Math_fround(f17 * f89)));
     f90 = Math_fround(f43 + Math_fround(f65 * Math_fround(f19 * f90)));
     f91 = Math_fround(f45 + Math_fround(f65 * Math_fround(f21 * f91)));
     HEAP32[i64 + (i46 << 7) >> 2] = i47;
     HEAP32[i64 + (i46 << 7) + 4 >> 2] = i5;
     HEAP32[i64 + (i46 << 7) + 8 >> 2] = i48;
     HEAP32[i64 + (i46 << 7) + 12 >> 2] = i49;
     HEAPF32[i64 + (i46 << 7) + 16 >> 2] = f16;
     HEAPF32[i64 + (i46 << 7) + 20 >> 2] = f18;
     HEAPF32[i64 + (i46 << 7) + 24 >> 2] = f20;
     HEAPF32[i64 + (i46 << 7) + 28 >> 2] = f22;
     HEAPF32[i64 + (i46 << 7) + 32 >> 2] = f24;
     HEAPF32[i64 + (i46 << 7) + 36 >> 2] = f33;
     HEAPF32[i64 + (i46 << 7) + 40 >> 2] = f35;
     HEAPF32[i64 + (i46 << 7) + 44 >> 2] = f37;
     HEAPF32[i64 + (i46 << 7) + 48 >> 2] = f39;
     HEAPF32[i64 + (i46 << 7) + 52 >> 2] = f41;
     HEAPF32[i64 + (i46 << 7) + 56 >> 2] = f43;
     HEAPF32[i64 + (i46 << 7) + 60 >> 2] = f45;
     HEAPF32[i64 + (i46 << 7) + 64 >> 2] = f23;
     HEAPF32[i64 + (i46 << 7) + 68 >> 2] = f25;
     HEAPF32[i64 + (i46 << 7) + 72 >> 2] = f34;
     HEAPF32[i64 + (i46 << 7) + 76 >> 2] = f36;
     HEAPF32[i64 + (i46 << 7) + 80 >> 2] = f38;
     HEAPF32[i64 + (i46 << 7) + 84 >> 2] = f40;
     HEAPF32[i64 + (i46 << 7) + 88 >> 2] = f42;
     HEAPF32[i64 + (i46 << 7) + 92 >> 2] = f44;
     HEAPF32[i64 + (i46 << 7) + 96 >> 2] = f88;
     HEAPF32[i64 + (i46 << 7) + 100 >> 2] = f89;
     HEAPF32[i64 + (i46 << 7) + 104 >> 2] = f90;
     HEAPF32[i64 + (i46 << 7) + 108 >> 2] = f91;
     HEAPF32[i64 + (i46 << 7) + 112 >> 2] = f14;
     HEAPF32[i64 + (i46 << 7) + 116 >> 2] = f13;
     HEAPF32[i64 + (i46 << 7) + 120 >> 2] = f12;
    } else {
     HEAP32[i64 + (i46 << 7) >> 2] = i47;
     HEAP32[i64 + (i46 << 7) + 4 >> 2] = i5;
     HEAP32[i64 + (i46 << 7) + 8 >> 2] = i48;
     HEAP32[i64 + (i46 << 7) + 12 >> 2] = i49;
     HEAPF32[i64 + (i46 << 7) + 16 >> 2] = f16;
     HEAPF32[i64 + (i46 << 7) + 20 >> 2] = f18;
     HEAPF32[i64 + (i46 << 7) + 24 >> 2] = f20;
     HEAPF32[i64 + (i46 << 7) + 28 >> 2] = f22;
     HEAPF32[i64 + (i46 << 7) + 32 >> 2] = f24;
     HEAPF32[i64 + (i46 << 7) + 36 >> 2] = f33;
     HEAPF32[i64 + (i46 << 7) + 40 >> 2] = f35;
     HEAPF32[i64 + (i46 << 7) + 44 >> 2] = f37;
     HEAPF32[i64 + (i46 << 7) + 48 >> 2] = f39;
     HEAPF32[i64 + (i46 << 7) + 52 >> 2] = f41;
     HEAPF32[i64 + (i46 << 7) + 56 >> 2] = f43;
     HEAPF32[i64 + (i46 << 7) + 60 >> 2] = f45;
     HEAP32[i64 + (i46 << 7) + 64 >> 2] = i6;
     HEAP32[i64 + (i46 << 7) + 68 >> 2] = i7;
     HEAP32[i64 + (i46 << 7) + 72 >> 2] = i8;
     HEAP32[i64 + (i46 << 7) + 76 >> 2] = i9;
     HEAP32[i64 + (i46 << 7) + 80 >> 2] = i10;
     HEAP32[i64 + (i46 << 7) + 84 >> 2] = i26;
     HEAP32[i64 + (i46 << 7) + 88 >> 2] = i27;
     HEAP32[i64 + (i46 << 7) + 92 >> 2] = i28;
     HEAP32[i64 + (i46 << 7) + 96 >> 2] = i29;
     HEAP32[i64 + (i46 << 7) + 100 >> 2] = i30;
     HEAP32[i64 + (i46 << 7) + 104 >> 2] = i31;
     HEAP32[i64 + (i46 << 7) + 108 >> 2] = i32;
     HEAPF32[i64 + (i46 << 7) + 112 >> 2] = f14;
     HEAPF32[i64 + (i46 << 7) + 116 >> 2] = f13;
     HEAPF32[i64 + (i46 << 7) + 120 >> 2] = f12;
    }
    HEAPF32[i64 + (i46 << 7) + 124 >> 2] = f11;
    i47 = i47 + 4 | 0;
    if (i47 >>> 0 >= i84 >>> 0) break; else {
     i46 = i46 + 1 | 0;
     i48 = i48 + 4 | 0;
     i49 = i49 + 4 | 0;
     i5 = i5 + 4 | 0;
    }
   }
   i31 = i75;
   i1 = HEAP32[i75 >> 2] | 0;
  } else {
   i31 = i75;
   i1 = i64;
  }
  i3 = (HEAP32[i66 >> 2] | 0) + -1 | 0;
  i6 = i1 + (i3 << 7) + 16 | 0;
  i7 = i1 + (i3 << 7) + 32 | 0;
  i8 = i1 + (i3 << 7) + 48 | 0;
  i9 = i1 + (i3 << 7) + 64 | 0;
  i10 = i1 + (i3 << 7) + 80 | 0;
  i4 = i1 + (i3 << 7) + 96 | 0;
  i5 = i1 + (i3 << 7) | 0;
  i3 = i1 + (i3 << 7) + 112 | 0;
  i1 = i84 & 3;
  if (i1 | 0) {
   i2 = i84;
   do {
    HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[i10 >> 2];
    HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + (i1 << 2) >> 2] = i84;
    HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 1 | 0;
    i1 = i2 & 3;
   } while ((i1 | 0) != 0);
  }
  i4 = i78 + 280 | 0;
  if ((HEAP32[i4 >> 2] | 0) != 1) {
   f11 = Math_fround(HEAPF32[i82 + 52 >> 2]);
   f12 = Math_fround(HEAPF32[i82 + 56 >> 2]);
   f13 = Math_fround(HEAPF32[i82 + 60 >> 2]);
   f14 = Math_fround(HEAPF32[i82 + 68 >> 2]);
   f15 = Math_fround(HEAPF32[i82 + 72 >> 2]);
   f16 = Math_fround(HEAPF32[i82 + 76 >> 2]);
   f17 = Math_fround(HEAPF32[i82 + 84 >> 2]);
   f18 = Math_fround(HEAPF32[i82 + 88 >> 2]);
   f19 = Math_fround(HEAPF32[i82 + 92 >> 2]);
   f20 = Math_fround(HEAPF32[i82 + 100 >> 2]);
   f21 = Math_fround(HEAPF32[i82 + 104 >> 2]);
   f22 = Math_fround(HEAPF32[i82 + 108 >> 2]);
   i2 = HEAP32[i66 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i31 >> 2] | 0;
    i1 = 0;
    do {
     i92 = i3 + (i1 << 7) + 16 | 0;
     f96 = Math_fround(HEAPF32[i92 >> 2]);
     f40 = Math_fround(f11 * f96);
     i66 = i3 + (i1 << 7) + 20 | 0;
     f100 = Math_fround(HEAPF32[i66 >> 2]);
     f94 = Math_fround(f11 * f100);
     i64 = i3 + (i1 << 7) + 24 | 0;
     f99 = Math_fround(HEAPF32[i64 >> 2]);
     f88 = Math_fround(f11 * f99);
     i63 = i3 + (i1 << 7) + 28 | 0;
     f45 = Math_fround(HEAPF32[i63 >> 2]);
     f39 = Math_fround(f11 * f45);
     i62 = i3 + (i1 << 7) + 32 | 0;
     f95 = Math_fround(HEAPF32[i62 >> 2]);
     f43 = Math_fround(f14 * f95);
     i61 = i3 + (i1 << 7) + 36 | 0;
     f90 = Math_fround(HEAPF32[i61 >> 2]);
     f44 = Math_fround(f14 * f90);
     i60 = i3 + (i1 << 7) + 40 | 0;
     f89 = Math_fround(HEAPF32[i60 >> 2]);
     f91 = Math_fround(f14 * f89);
     i59 = i3 + (i1 << 7) + 44 | 0;
     f93 = Math_fround(HEAPF32[i59 >> 2]);
     f43 = Math_fround(f40 + f43);
     f44 = Math_fround(f94 + f44);
     f91 = Math_fround(f88 + f91);
     f39 = Math_fround(f39 + Math_fround(f14 * f93));
     i58 = i3 + (i1 << 7) + 48 | 0;
     f88 = Math_fround(HEAPF32[i58 >> 2]);
     f94 = Math_fround(f17 * f88);
     i57 = i3 + (i1 << 7) + 52 | 0;
     f40 = Math_fround(HEAPF32[i57 >> 2]);
     f41 = Math_fround(f17 * f40);
     i56 = i3 + (i1 << 7) + 56 | 0;
     f98 = Math_fround(HEAPF32[i56 >> 2]);
     f65 = Math_fround(f17 * f98);
     i55 = i3 + (i1 << 7) + 60 | 0;
     f38 = Math_fround(HEAPF32[i55 >> 2]);
     f41 = Math_fround(f20 + Math_fround(f44 + f41));
     f65 = Math_fround(f20 + Math_fround(f91 + f65));
     f39 = Math_fround(f20 + Math_fround(f39 + Math_fround(f17 * f38)));
     f91 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f96) + Math_fround(f15 * f95)) + Math_fround(f18 * f88)));
     f44 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f100) + Math_fround(f15 * f90)) + Math_fround(f18 * f40)));
     f97 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f99) + Math_fround(f15 * f89)) + Math_fround(f18 * f98)));
     f42 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f45) + Math_fround(f15 * f93)) + Math_fround(f18 * f38)));
     f88 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f96) + Math_fround(f16 * f95)) + Math_fround(f19 * f88)));
     f40 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f100) + Math_fround(f16 * f90)) + Math_fround(f19 * f40)));
     f98 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f99) + Math_fround(f16 * f89)) + Math_fround(f19 * f98)));
     f38 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f45) + Math_fround(f16 * f93)) + Math_fround(f19 * f38)));
     HEAPF32[i92 >> 2] = Math_fround(f20 + Math_fround(f43 + f94));
     HEAPF32[i66 >> 2] = f41;
     HEAPF32[i64 >> 2] = f65;
     HEAPF32[i63 >> 2] = f39;
     HEAPF32[i62 >> 2] = f91;
     HEAPF32[i61 >> 2] = f44;
     HEAPF32[i60 >> 2] = f97;
     HEAPF32[i59 >> 2] = f42;
     HEAPF32[i58 >> 2] = f88;
     HEAPF32[i57 >> 2] = f40;
     HEAPF32[i56 >> 2] = f98;
     HEAPF32[i55 >> 2] = f38;
     i55 = i3 + (i1 << 7) + 64 | 0;
     f38 = Math_fround(HEAPF32[i55 >> 2]);
     f98 = Math_fround(f11 * f38);
     i56 = i3 + (i1 << 7) + 68 | 0;
     f40 = Math_fround(HEAPF32[i56 >> 2]);
     f88 = Math_fround(f11 * f40);
     i57 = i3 + (i1 << 7) + 72 | 0;
     f42 = Math_fround(HEAPF32[i57 >> 2]);
     f97 = Math_fround(f11 * f42);
     i58 = i3 + (i1 << 7) + 76 | 0;
     f44 = Math_fround(HEAPF32[i58 >> 2]);
     f91 = Math_fround(f11 * f44);
     i59 = i3 + (i1 << 7) + 80 | 0;
     f39 = Math_fround(HEAPF32[i59 >> 2]);
     f65 = Math_fround(f14 * f39);
     i60 = i3 + (i1 << 7) + 84 | 0;
     f41 = Math_fround(HEAPF32[i60 >> 2]);
     f94 = Math_fround(f14 * f41);
     i61 = i3 + (i1 << 7) + 88 | 0;
     f43 = Math_fround(HEAPF32[i61 >> 2]);
     f93 = Math_fround(f14 * f43);
     i62 = i3 + (i1 << 7) + 92 | 0;
     f45 = Math_fround(HEAPF32[i62 >> 2]);
     f65 = Math_fround(f98 + f65);
     f94 = Math_fround(f88 + f94);
     f93 = Math_fround(f97 + f93);
     f91 = Math_fround(f91 + Math_fround(f14 * f45));
     i63 = i3 + (i1 << 7) + 96 | 0;
     f97 = Math_fround(HEAPF32[i63 >> 2]);
     f88 = Math_fround(f17 * f97);
     i64 = i3 + (i1 << 7) + 100 | 0;
     f98 = Math_fround(HEAPF32[i64 >> 2]);
     f89 = Math_fround(f17 * f98);
     i66 = i3 + (i1 << 7) + 104 | 0;
     f99 = Math_fround(HEAPF32[i66 >> 2]);
     f90 = Math_fround(f17 * f99);
     i92 = i3 + (i1 << 7) + 108 | 0;
     f100 = Math_fround(HEAPF32[i92 >> 2]);
     f89 = Math_fround(f20 + Math_fround(f94 + f89));
     f90 = Math_fround(f20 + Math_fround(f93 + f90));
     f91 = Math_fround(f20 + Math_fround(f91 + Math_fround(f17 * f100)));
     f93 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f38) + Math_fround(f15 * f39)) + Math_fround(f18 * f97)));
     f94 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f40) + Math_fround(f15 * f41)) + Math_fround(f18 * f98)));
     f95 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f42) + Math_fround(f15 * f43)) + Math_fround(f18 * f99)));
     f96 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f12 * f44) + Math_fround(f15 * f45)) + Math_fround(f18 * f100)));
     f97 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f38) + Math_fround(f16 * f39)) + Math_fround(f19 * f97)));
     f98 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(f16 * f41)) + Math_fround(f19 * f98)));
     f99 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f42) + Math_fround(f16 * f43)) + Math_fround(f19 * f99)));
     f100 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f13 * f44) + Math_fround(f16 * f45)) + Math_fround(f19 * f100)));
     HEAPF32[i55 >> 2] = Math_fround(f20 + Math_fround(f65 + f88));
     HEAPF32[i56 >> 2] = f89;
     HEAPF32[i57 >> 2] = f90;
     HEAPF32[i58 >> 2] = f91;
     HEAPF32[i59 >> 2] = f93;
     HEAPF32[i60 >> 2] = f94;
     HEAPF32[i61 >> 2] = f95;
     HEAPF32[i62 >> 2] = f96;
     HEAPF32[i63 >> 2] = f97;
     HEAPF32[i64 >> 2] = f98;
     HEAPF32[i66 >> 2] = f99;
     HEAPF32[i92 >> 2] = f100;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
  }
  i1 = HEAP32[i85 + 28 >> 2] | 0;
  if (!i1) {
   i92 = HEAP32[i85 + 32 >> 2] | 0;
   mftCall_viiiiii(HEAP32[(HEAP32[i92 >> 2] | 0) + 28 >> 2] | 0, i92 | 0, i75 | 0, i84 | 0, i77 | 0, i67 | 0, i69 | 0);
  } else mftCall_viiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i75 | 0, i84 | 0, i77 | 0, i67 | 0, i68 | 0, i69 | 0, 0, i70 | 0);
  L35 : do if ((HEAP32[i4 >> 2] | 0) != 1) {
   i8 = i82 + 180 | 0;
   f11 = Math_fround(HEAPF32[i8 >> 2]);
   i6 = i82 + 184 | 0;
   f15 = Math_fround(HEAPF32[i6 >> 2]);
   i7 = i82 + 188 | 0;
   f14 = Math_fround(HEAPF32[i7 >> 2]);
   i9 = i82 + 196 | 0;
   f13 = Math_fround(HEAPF32[i9 >> 2]);
   i4 = i82 + 200 | 0;
   f16 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i82 + 204 | 0;
   f12 = Math_fround(HEAPF32[i5 >> 2]);
   i10 = i82 + 212 | 0;
   i2 = i82 + 216 | 0;
   i3 = i82 + 220 | 0;
   f23 = Math_fround(Math_fround(Math_fround(f11 * f13) + Math_fround(f15 * f16)) + Math_fround(Math_fround(f14 * f12) + Math_fround(0.0)));
   f20 = Math_fround(f13 - Math_fround(f11 * f23));
   f21 = Math_fround(f16 - Math_fround(f15 * f23));
   f23 = Math_fround(f12 - Math_fround(f14 * f23));
   f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f14 * f14) + Math_fround(0.0)))));
   f22 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(Math_fround(f23 * f23) + Math_fround(0.0)))));
   i26 = f19 > Math_fround(1.0e-30) & f22 > Math_fround(1.0e-30);
   f17 = Math_fround(f11 / f19);
   f18 = Math_fround(f15 / f19);
   f19 = Math_fround(f14 / f19);
   f20 = Math_fround(f20 / f22);
   f21 = Math_fround(f21 / f22);
   f22 = Math_fround(f23 / f22);
   f17 = i26 ? f17 : Math_fround(1.0);
   f18 = i26 ? f18 : Math_fround(0.0);
   f19 = i26 ? f19 : Math_fround(0.0);
   f20 = i26 ? f20 : Math_fround(0.0);
   f21 = i26 ? f21 : Math_fround(1.0);
   f22 = i26 ? f22 : Math_fround(0.0);
   f23 = Math_fround(Math_fround(f17 * f21) - Math_fround(f18 * f20));
   f24 = Math_fround(Math_fround(f18 * f22) - Math_fround(f19 * f21));
   f25 = Math_fround(Math_fround(f19 * f20) - Math_fround(f17 * f22));
   i26 = i77 + 12 | 0;
   if (HEAP32[i26 >> 2] | 0) {
    i27 = i82 + 228 | 0;
    i28 = i82 + 232 | 0;
    i29 = i82 + 236 | 0;
    i30 = HEAP32[i77 >> 2] | 0;
    i1 = 0;
    while (1) {
     i92 = i30 + (i1 * 60 | 0) + 40 | 0;
     f99 = Math_fround(HEAPF32[i92 >> 2]);
     f97 = Math_fround(f11 * f99);
     i70 = i30 + (i1 * 60 | 0) + 44 | 0;
     f98 = Math_fround(HEAPF32[i70 >> 2]);
     f97 = Math_fround(f97 + Math_fround(f13 * f98));
     f100 = Math_fround(HEAPF32[i10 >> 2]);
     i69 = i30 + (i1 * 60 | 0) + 48 | 0;
     f96 = Math_fround(HEAPF32[i69 >> 2]);
     f100 = Math_fround(f97 + Math_fround(f100 * f96));
     f100 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f100);
     f97 = Math_fround(Math_fround(f99 * f15) + Math_fround(f98 * f16));
     f97 = Math_fround(f97 + Math_fround(f96 * Math_fround(HEAPF32[i2 >> 2])));
     f97 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f97);
     f98 = Math_fround(Math_fround(f99 * f14) + Math_fround(f98 * f12));
     f96 = Math_fround(f98 + Math_fround(f96 * Math_fround(HEAPF32[i3 >> 2])));
     f96 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + f96);
     HEAPF32[i92 >> 2] = f100;
     HEAPF32[i70 >> 2] = f97;
     HEAPF32[i69 >> 2] = f96;
     i69 = i30 + (i1 * 60 | 0) + 28 | 0;
     f96 = Math_fround(HEAPF32[i69 >> 2]);
     f97 = Math_fround(f17 * f96);
     i70 = i30 + (i1 * 60 | 0) + 32 | 0;
     f100 = Math_fround(HEAPF32[i70 >> 2]);
     f97 = Math_fround(f97 + Math_fround(f20 * f100));
     i92 = i30 + (i1 * 60 | 0) + 36 | 0;
     f98 = Math_fround(HEAPF32[i92 >> 2]);
     f99 = Math_fround(Math_fround(Math_fround(f18 * f96) + Math_fround(f21 * f100)) + Math_fround(f25 * f98));
     f100 = Math_fround(Math_fround(Math_fround(f19 * f96) + Math_fround(f22 * f100)) + Math_fround(f23 * f98));
     HEAPF32[i69 >> 2] = Math_fround(f97 + Math_fround(f24 * f98));
     HEAPF32[i70 >> 2] = f99;
     HEAPF32[i92 >> 2] = f100;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) break L35;
     f11 = Math_fround(HEAPF32[i8 >> 2]);
     f13 = Math_fround(HEAPF32[i9 >> 2]);
     f15 = Math_fround(HEAPF32[i6 >> 2]);
     f16 = Math_fround(HEAPF32[i4 >> 2]);
     f14 = Math_fround(HEAPF32[i7 >> 2]);
     f12 = Math_fround(HEAPF32[i5 >> 2]);
    }
   }
  } while (0);
  if (i73) {
   i2 = i77 + 12 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i1 = 0;
    do {
     i92 = HEAP32[i77 >> 2] | 0;
     __ZN32PlaneColliderCache_dense_hashmap7ReplaceERK8Vector3fS2_S2_S2_iif(HEAP32[i76 >> 2] | 0, i92 + (i1 * 60 | 0) + 4 | 0, i92 + (i1 * 60 | 0) + 16 | 0, i92 + (i1 * 60 | 0) + 28 | 0, i92 + (i1 * 60 | 0) + 40 | 0, HEAP32[i92 + (i1 * 60 | 0) + 52 >> 2] | 0, HEAP32[i92 + (i1 * 60 | 0) + 56 >> 2] | 0, Math_fround(HEAPF32[i74 >> 2])) | 0;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
   }
  }
  if ((HEAP32[i71 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i75 >> 2] | 0, i72);
   HEAP32[i31 >> 2] = 0;
  }
  i1 = HEAP32[i80 >> 2] | 0;
 }
 if ((i1 | 0) != (i86 | 0)) __Z9ReadCacheR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjRKjRKf(i77, i78, i82, i83, i85, i86, i80, i79);
 if ((HEAP32[i81 >> 2] | 0) == (i84 | 0)) {
  STACKTOP = i87;
  return;
 }
 __Z9ReadCacheR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjRKjRKf(i77, i78, i82, i83, i85, i84, i81, i79);
 STACKTOP = i87;
 return;
}

function __ZN5physx3Cct10Controller4moveERNS0_11SweptVolumeERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextEb(i97, i89, i1, f86, f5, i84, i2, i82) {
 i97 = i97 | 0;
 i89 = i89 | 0;
 i1 = i1 | 0;
 f86 = Math_fround(f86);
 f5 = Math_fround(f5);
 i84 = i84 | 0;
 i2 = i2 | 0;
 i82 = i82 | 0;
 var i3 = 0, i4 = 0, i6 = 0, d7 = 0.0, i8 = 0, d9 = 0.0, i10 = 0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i83 = 0, i85 = 0, i87 = 0, i88 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i98 = 0, f99 = f0, f100 = f0, i101 = 0, d102 = 0.0, d103 = 0.0, d104 = 0.0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0;
 i98 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i71 = i98;
 i68 = i98 + 288 | 0;
 i69 = i98 + 240 | 0;
 i83 = i98 + 228 | 0;
 i6 = i98 + 224 | 0;
 i27 = i98 + 220 | 0;
 i28 = i98 + 216 | 0;
 i58 = i98 + 212 | 0;
 i59 = i98 + 184 | 0;
 i60 = i98 + 156 | 0;
 i70 = i98 + 152 | 0;
 i88 = i98 + 128 | 0;
 i87 = i98 + 112 | 0;
 i85 = i98 + 96 | 0;
 i90 = i98 + 84 | 0;
 i96 = i98 + 56 | 0;
 i91 = i97 + 468 | 0;
 HEAPF32[i91 >> 2] = Math_fround(Math_fround(HEAPF32[i91 >> 2]) + f5);
 i91 = i97 + 464 | 0;
 i72 = HEAP32[i91 >> 2] | 0;
 i73 = HEAP32[i72 + 8 >> 2] | 0;
 i62 = HEAP32[i72 + 12 >> 2] | 0;
 i76 = i97 + 88 | 0;
 HEAP32[i76 >> 2] = i73;
 HEAP32[i97 + 92 >> 2] = i62;
 i77 = i97 + 8 | 0;
 HEAP32[i97 + 312 >> 2] = HEAP32[i77 >> 2];
 i92 = i97 + 12 | 0;
 HEAP32[i97 + 316 >> 2] = HEAP32[i92 >> 2];
 i93 = i97 + 16 | 0;
 HEAP32[i97 + 320 >> 2] = HEAP32[i93 >> 2];
 i94 = i97 + 20 | 0;
 HEAP32[i97 + 324 >> 2] = HEAP32[i94 >> 2];
 i95 = i97 + 24 | 0;
 HEAP32[i97 + 328 >> 2] = HEAP32[i95 >> 2];
 i78 = i97 + 28 | 0;
 HEAP32[i97 + 332 >> 2] = HEAP32[i78 >> 2];
 i79 = i97 + 32 | 0;
 HEAP32[i97 + 336 >> 2] = HEAP32[i79 >> 2];
 i80 = i97 + 36 | 0;
 HEAP32[i97 + 340 >> 2] = HEAP32[i80 >> 2];
 i81 = i97 + 344 | 0;
 i8 = i97 + 40 | 0;
 HEAP32[i81 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i81 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i81 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i81 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i81 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i81 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i81 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i81 = i97 + 396 | 0;
 HEAP32[i81 >> 2] = HEAP32[i81 >> 2] | 128;
 f100 = Math_fround(HEAPF32[i72 + 128 >> 2]);
 HEAPF32[i97 + 364 >> 2] = Math_fround(f100 * f100);
 HEAP8[i97 + 368 >> 0] = HEAP8[i72 + 132 >> 0] | 0;
 HEAP8[i97 + 370 >> 0] = HEAP8[i72 + 133 >> 0] | 0;
 HEAP8[i97 + 371 >> 0] = HEAP8[i72 + 134 >> 0] | 0;
 HEAP8[i97 + 372 >> 0] = HEAP8[i72 + 135 >> 0] | 0;
 i72 = i97 + 388 | 0;
 i8 = i72;
 HEAP16[i8 >> 1] = 0;
 HEAP16[i8 + 2 >> 1] = 0 >>> 16;
 i72 = i72 + 4 | 0;
 HEAP16[i72 >> 1] = 0;
 HEAP16[i72 + 2 >> 1] = 0 >>> 16;
 i72 = i97 + 444 | 0;
 f100 = Math_fround(HEAPF32[i1 >> 2]);
 f100 = Math_fround(f100 + Math_fround(HEAPF32[i72 >> 2]));
 f99 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i8 = i97 + 448 | 0;
 f99 = Math_fround(f99 + Math_fround(HEAPF32[i8 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i4 = i97 + 452 | 0;
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i83 >> 2] = f100;
 i74 = i83 + 4 | 0;
 HEAPF32[i74 >> 2] = f99;
 i75 = i83 + 8 | 0;
 HEAPF32[i75 >> 2] = f5;
 HEAP32[i72 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i97 + 248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i8 = i97 + 244 | 0;
 L1 : do if (i1 | 0) if (HEAP32[i8 >> 2] | 0) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
  L4 : do if (i1 | 0) {
   i3 = 0;
   while (1) {
    HEAP32[i6 >> 2] = 0;
    i72 = HEAP32[i4 >> 2] | 0;
    mftCall_iiiii(HEAP32[(HEAP32[i72 >> 2] | 0) + 108 >> 2] | 0, i72 | 0, i6 | 0, 1, i3 | 0) | 0;
    i3 = i3 + 1 | 0;
    if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i8 >> 2] | 0)) break;
    if (i3 >>> 0 >= i1 >>> 0) break L4;
   }
   i72 = HEAP32[i4 >> 2] | 0;
   i72 = mftCall_ii(HEAP32[(HEAP32[i72 >> 2] | 0) + 28 >> 2] | 0, i72 | 0) | 0;
   if ((i72 | 0) != (HEAP32[i97 + 456 >> 2] | 0)) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    break L1;
   }
   i72 = HEAP32[i8 >> 2] | 0;
   if (!((mftCall_ii(HEAP32[(HEAP32[i72 >> 2] | 0) + 136 >> 2] | 0, i72 | 0) | 0) & 2)) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    break L1;
   }
   i1 = HEAP32[i84 >> 2] | 0;
   if (!i1) {
    HEAP32[i68 >> 2] = 0;
    HEAP32[i68 + 4 >> 2] = 0;
    HEAP32[i68 + 8 >> 2] = 0;
    HEAP32[i68 + 12 >> 2] = 0;
   } else {
    HEAP32[i68 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i68 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i68 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i68 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   };
   HEAP32[i71 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i71 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i71 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAP32[i71 + 12 >> 2] = HEAP32[i68 + 12 >> 2];
   HEAP16[i71 + 16 >> 1] = 6;
   HEAP8[i71 + 18 >> 0] = 0;
   HEAP16[i69 >> 1] = 4;
   i1 = HEAP32[i84 + 4 >> 2] | 0;
   if (!i1) break L1;
   if (mftCall_iiiiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i71 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i4 >> 2] | 0, i69 | 0) | 0) break L1;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   break L1;
  } while (0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 } while (0);
 if (!(HEAP32[i8 >> 2] | 0)) {
  i1 = i97 + 240 | 0;
  if ((HEAP32[i1 >> 2] | 0) == -1) {
   __ZN5physx3Cct10Controller17findTouchedObjectERKNS_19PxControllerFiltersEPKNS_17PxObstacleContextERKNS_6PxVec3E(i97, i84, i2, i78);
   if (!(HEAP32[i8 >> 2] | 0)) if ((HEAP32[i1 >> 2] | 0) == -1) {
    HEAP8[i97 + 485 >> 0] = 0;
    HEAP32[i97 + 432 >> 2] = 0;
    HEAP32[i97 + 436 >> 2] = 0;
    HEAP32[i97 + 440 >> 2] = 0;
    i72 = 0;
   } else i10 = 22; else i10 = 22;
  } else i10 = 22;
 } else i10 = 22;
 if ((i10 | 0) == 22) i72 = __ZN5physx3Cct10Controller19rideOnTouchedObjectERNS0_11SweptVolumeERKNS_6PxVec3ERS4_PKNS_17PxObstacleContextE(i97, i89, i78, i83, i2) | 0;
 i65 = HEAP32[i91 >> 2] | 0;
 i63 = i65 + 16 | 0;
 i64 = i65 + 28 | 0;
 i66 = i65 + 40 | 0;
 i67 = i65 + 52 | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i65 >> 2] | 0) + 8 >> 2] | 0, i65 | 0) | 0;
 i6 = __ZN5physx3Cct26CharacterControllerManager14getControllersEv(HEAP32[i91 >> 2] | 0) | 0;
 if (i4 | 0) {
  i8 = i84 + 12 | 0;
  i10 = i65 + 36 | 0;
  i12 = i65 + 32 | 0;
  i13 = i71 + 24 | 0;
  i14 = i71 + 28 | 0;
  i15 = i71 + 32 | 0;
  i16 = i71 + 36 | 0;
  i17 = i71 + 40 | 0;
  i18 = i71 + 44 | 0;
  i19 = i71 + 48 | 0;
  i20 = i65 + 24 | 0;
  i21 = i65 + 20 | 0;
  i22 = i65 + 60 | 0;
  i23 = i65 + 56 | 0;
  i24 = i65 + 48 | 0;
  i25 = i65 + 44 | 0;
  i26 = 0;
  do {
   i1 = HEAP32[i6 + (i26 << 2) >> 2] | 0;
   L37 : do if ((i1 | 0) != (i97 | 0)) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (i3 | 0) {
     i57 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
     i61 = mftCall_ii(HEAP32[(HEAP32[i97 >> 2] | 0) + 20 >> 2] | 0, i97 | 0) | 0;
     if (!(mftCall_iiii(i57 | 0, i3 | 0, i61 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) | 0)) break;
    }
    switch (HEAP32[i1 + 4 >> 2] | 0) {
    case 0:
     {
      __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE(i1 + -8 | 0, i71);
      i1 = HEAP32[i12 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i57 = HEAP32[i64 >> 2] | 0;
       i61 = i57 + (i1 * 56 | 0) | 0;
       HEAP32[i61 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i61 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i61 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i61 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i61 + 16 >> 2] = HEAP32[i71 + 16 >> 2];
       HEAP32[i61 + 20 >> 2] = HEAP32[i71 + 20 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 24 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 28 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 32 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i61 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i61 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i61 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i61 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i61 + 16 >> 2] = HEAP32[i71 + 16 >> 2];
       HEAP32[i61 + 20 >> 2] = HEAP32[i71 + 20 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 36 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 40 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 44 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i57 + (i1 * 56 | 0) + 48 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i61 >> 2] = HEAP32[i71 >> 2];
       HEAP32[i61 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
       HEAP32[i61 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
       HEAP32[i61 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
       HEAP32[i61 + 16 >> 2] = HEAP32[i71 + 16 >> 2];
       HEAP32[i61 + 20 >> 2] = HEAP32[i71 + 20 >> 2];
       HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i64, i71) | 0;
      i1 = i26 << 16;
      HEAP32[i27 >> 2] = i1;
      i3 = HEAP32[i21 >> 2] | 0;
      if ((HEAP32[i20 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i63 >> 2] | 0) + (i3 << 2) >> 2] = i1;
       HEAP32[i21 >> 2] = i3 + 1;
      } else __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i63, i27) | 0;
      break L37;
     }
    case 1:
     {
      __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE(i1 + -8 | 0, i71);
      i1 = HEAP32[i23 >> 2] | 0;
      if ((HEAP32[i22 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i3 = (HEAP32[i67 >> 2] | 0) + (i1 * 56 | 0) | 0;
       i1 = i71;
       i61 = i3 + 56 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
        i3 = i3 + 4 | 0;
        i1 = i1 + 4 | 0;
       } while ((i3 | 0) < (i61 | 0));
       HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i67, i71) | 0;
      i1 = i26 << 16;
      HEAP32[i28 >> 2] = i1;
      i3 = HEAP32[i25 >> 2] | 0;
      if ((HEAP32[i24 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i66 >> 2] | 0) + (i3 << 2) >> 2] = i1;
       HEAP32[i25 >> 2] = i3 + 1;
      } else __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i66, i28) | 0;
      break L37;
     }
    default:
     break L37;
    }
   } while (0);
   i26 = i26 + 1 | 0;
  } while ((i26 | 0) != (i4 | 0));
 }
 if (!i2) i2 = 0; else {
  i14 = HEAP32[i2 + 8 >> 2] | 0;
  if (i14 | 0) {
   i15 = i2 + 4 | 0;
   i16 = i71 + 24 | 0;
   i17 = i71 + 28 | 0;
   i18 = i71 + 32 | 0;
   i19 = i71 + 36 | 0;
   i20 = i71 + 40 | 0;
   i21 = i71 + 44 | 0;
   i22 = i71 + 48 | 0;
   i23 = i65 + 36 | 0;
   i24 = i65 + 32 | 0;
   i25 = i65 + 24 | 0;
   i26 = i65 + 20 | 0;
   i57 = (i73 | 0) == 0 | (i62 & 4 | 0) == 0;
   i27 = i68 + 36 | 0;
   i28 = i68 + 40 | 0;
   i29 = i68 + 56 | 0;
   i30 = i68 + 60 | 0;
   i31 = i68 + 76 | 0;
   i32 = i68 + 80 | 0;
   i33 = i68 + 96 | 0;
   i34 = i68 + 100 | 0;
   i35 = i59 + 4 | 0;
   i36 = i59 + 8 | 0;
   i37 = i59 + 12 | 0;
   i38 = i59 + 16 | 0;
   i39 = i59 + 20 | 0;
   i40 = i59 + 24 | 0;
   i41 = i60 + 4 | 0;
   i42 = i60 + 8 | 0;
   i43 = i60 + 12 | 0;
   i44 = i60 + 16 | 0;
   i45 = i60 + 20 | 0;
   i46 = i60 + 24 | 0;
   i56 = 0;
   do {
    i47 = HEAP32[i15 >> 2] | 0;
    i48 = i47 + (i56 * 72 | 0) + 16 | 0;
    HEAP32[i71 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i71 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
    HEAP32[i71 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
    HEAP32[i71 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
    HEAP32[i71 + 16 >> 2] = HEAP32[i48 + 16 >> 2];
    HEAP32[i71 + 20 >> 2] = HEAP32[i48 + 20 >> 2];
    i49 = i47 + (i56 * 72 | 0) + 56 | 0;
    i1 = HEAP32[i49 >> 2] | 0;
    HEAP32[i16 >> 2] = i1;
    i50 = i47 + (i56 * 72 | 0) + 60 | 0;
    i3 = HEAP32[i50 >> 2] | 0;
    HEAP32[i17 >> 2] = i3;
    i51 = i47 + (i56 * 72 | 0) + 64 | 0;
    i4 = HEAP32[i51 >> 2] | 0;
    HEAP32[i18 >> 2] = i4;
    i52 = i47 + (i56 * 72 | 0) + 40 | 0;
    i6 = HEAP32[i52 >> 2] | 0;
    HEAP32[i19 >> 2] = i6;
    i53 = i47 + (i56 * 72 | 0) + 44 | 0;
    i8 = HEAP32[i53 >> 2] | 0;
    HEAP32[i20 >> 2] = i8;
    i54 = i47 + (i56 * 72 | 0) + 48 | 0;
    i10 = HEAP32[i54 >> 2] | 0;
    HEAP32[i21 >> 2] = i10;
    i55 = i47 + (i56 * 72 | 0) + 52 | 0;
    i12 = HEAP32[i55 >> 2] | 0;
    HEAP32[i22 >> 2] = i12;
    i13 = HEAP32[i24 >> 2] | 0;
    if ((HEAP32[i23 >> 2] & 2147483647) >>> 0 > i13 >>> 0) {
     i101 = HEAP32[i64 >> 2] | 0;
     i61 = i101 + (i13 * 56 | 0) | 0;
     HEAP32[i101 + (i13 * 56 | 0) + 24 >> 2] = i1;
     HEAP32[i101 + (i13 * 56 | 0) + 28 >> 2] = i3;
     HEAP32[i101 + (i13 * 56 | 0) + 32 >> 2] = i4;
     HEAP32[i101 + (i13 * 56 | 0) + 36 >> 2] = i6;
     HEAP32[i101 + (i13 * 56 | 0) + 40 >> 2] = i8;
     HEAP32[i101 + (i13 * 56 | 0) + 44 >> 2] = i10;
     HEAP32[i101 + (i13 * 56 | 0) + 48 >> 2] = i12;
     HEAP32[i61 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i61 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
     HEAP32[i61 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
     HEAP32[i61 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
     HEAP32[i61 + 16 >> 2] = HEAP32[i71 + 16 >> 2];
     HEAP32[i61 + 20 >> 2] = HEAP32[i71 + 20 >> 2];
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i64, i71) | 0;
    i1 = i56 << 16 | 1;
    HEAP32[i58 >> 2] = i1;
    i3 = HEAP32[i26 >> 2] | 0;
    if ((HEAP32[i25 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP32[(HEAP32[i63 >> 2] | 0) + (i3 << 2) >> 2] = i1;
     HEAP32[i26 >> 2] = i3 + 1;
    } else __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i63, i58) | 0;
    if (!i57) {
     i3 = i68;
     i61 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = 0;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) < (i61 | 0));
     HEAPF32[i27 >> 2] = Math_fround(1.0);
     HEAP32[i28 >> 2] = 0;
     HEAP32[i28 + 4 >> 2] = 0;
     HEAP32[i28 + 8 >> 2] = 0;
     HEAP32[i28 + 12 >> 2] = 0;
     HEAPF32[i29 >> 2] = Math_fround(1.0);
     HEAP32[i30 >> 2] = 0;
     HEAP32[i30 + 4 >> 2] = 0;
     HEAP32[i30 + 8 >> 2] = 0;
     HEAP32[i30 + 12 >> 2] = 0;
     HEAPF32[i31 >> 2] = Math_fround(1.0);
     HEAP32[i32 >> 2] = 0;
     HEAP32[i32 + 4 >> 2] = 0;
     HEAP32[i32 + 8 >> 2] = 0;
     HEAP32[i32 + 12 >> 2] = 0;
     HEAPF32[i33 >> 2] = Math_fround(1.0);
     HEAP32[i34 >> 2] = i73;
     __ZN5physx2Cm12RenderOutputlsEj(i68, -16711681) | 0;
     f100 = Math_fround(+HEAPF64[i48 >> 3]);
     f99 = Math_fround(+HEAPF64[i47 + (i56 * 72 | 0) + 24 >> 3]);
     f5 = Math_fround(+HEAPF64[i47 + (i56 * 72 | 0) + 32 >> 3]);
     HEAP32[i59 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i53 >> 2];
     HEAP32[i36 >> 2] = HEAP32[i54 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i55 >> 2];
     HEAPF32[i38 >> 2] = f100;
     HEAPF32[i39 >> 2] = f99;
     HEAPF32[i40 >> 2] = f5;
     __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i68, i59) | 0;
     f5 = Math_fround(-Math_fround(HEAPF32[i49 >> 2]));
     f99 = Math_fround(-Math_fround(HEAPF32[i50 >> 2]));
     f100 = Math_fround(-Math_fround(HEAPF32[i51 >> 2]));
     HEAPF32[i60 >> 2] = f5;
     HEAPF32[i41 >> 2] = f99;
     HEAPF32[i42 >> 2] = f100;
     HEAP32[i43 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i44 >> 2] = HEAP32[i50 >> 2];
     HEAP32[i45 >> 2] = HEAP32[i51 >> 2];
     HEAP8[i46 >> 0] = 1;
     __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i68, i60) | 0;
    }
    i56 = i56 + 1 | 0;
   } while ((i56 | 0) != (i14 | 0));
  }
  i37 = HEAP32[i2 + 20 >> 2] | 0;
  if (i37) {
   i38 = i2 + 16 | 0;
   i39 = i71 + 8 | 0;
   i40 = i71 + 16 | 0;
   i41 = i71 + 24 | 0;
   i42 = i71 + 32 | 0;
   i43 = i71 + 40 | 0;
   i44 = i71 + 48 | 0;
   i45 = i65 + 60 | 0;
   i46 = i65 + 56 | 0;
   i47 = i65 + 48 | 0;
   i48 = i65 + 44 | 0;
   i18 = i68 + 36 | 0;
   i19 = i68 + 40 | 0;
   i20 = i68 + 56 | 0;
   i21 = i68 + 60 | 0;
   i22 = i68 + 76 | 0;
   i23 = i68 + 80 | 0;
   i24 = i68 + 96 | 0;
   i25 = i68 + 100 | 0;
   i26 = i69 + 4 | 0;
   i27 = i69 + 8 | 0;
   i28 = i69 + 12 | 0;
   i29 = i69 + 16 | 0;
   i30 = i69 + 20 | 0;
   i31 = i69 + 24 | 0;
   i32 = i69 + 28 | 0;
   i33 = i69 + 32 | 0;
   i34 = i69 + 36 | 0;
   i35 = i69 + 40 | 0;
   i36 = i69 + 44 | 0;
   if ((i73 | 0) == 0 | (i62 & 4 | 0) == 0) {
    i4 = 0;
    do {
     i1 = HEAP32[i38 >> 2] | 0;
     f106 = Math_fround(HEAPF32[i1 + (i4 << 6) + 40 >> 2]);
     f107 = Math_fround(f106 * Math_fround(2.0));
     f5 = Math_fround(HEAPF32[i1 + (i4 << 6) + 52 >> 2]);
     f105 = Math_fround(f5 * Math_fround(2.0));
     f5 = Math_fround(Math_fround(f106 * f107) + Math_fround(Math_fround(f5 * f105) + Math_fround(-1.0)));
     f106 = Math_fround(HEAPF32[i1 + (i4 << 6) + 48 >> 2]);
     f99 = Math_fround(f106 * f105);
     f100 = Math_fround(HEAPF32[i1 + (i4 << 6) + 44 >> 2]);
     f99 = Math_fround(f99 + Math_fround(f107 * f100));
     f100 = Math_fround(Math_fround(f107 * f106) - Math_fround(f105 * f100));
     f105 = Math_fround(HEAPF32[i1 + (i4 << 6) + 56 >> 2]);
     f5 = Math_fround(f105 * f5);
     f99 = Math_fround(f105 * f99);
     f100 = Math_fround(f105 * f100);
     d103 = +HEAPF64[i1 + (i4 << 6) + 16 >> 3];
     d104 = +f5;
     d7 = +HEAPF64[i1 + (i4 << 6) + 24 >> 3];
     d102 = +f99;
     d11 = +HEAPF64[i1 + (i4 << 6) + 32 >> 3];
     d9 = +f100;
     HEAPF64[i71 >> 3] = d103 - d104;
     HEAPF64[i39 >> 3] = d7 - d102;
     HEAPF64[i40 >> 3] = d11 - d9;
     HEAPF64[i41 >> 3] = d104 + d103;
     HEAPF64[i42 >> 3] = d102 + d7;
     HEAPF64[i43 >> 3] = d9 + d11;
     HEAP32[i44 >> 2] = HEAP32[i1 + (i4 << 6) + 60 >> 2];
     i1 = HEAP32[i46 >> 2] | 0;
     if ((HEAP32[i45 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
      i3 = (HEAP32[i67 >> 2] | 0) + (i1 * 56 | 0) | 0;
      i1 = i71;
      i61 = i3 + 56 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
       i3 = i3 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i3 | 0) < (i61 | 0));
      HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i67, i71) | 0;
     i1 = i4 << 16 | 2;
     HEAP32[i70 >> 2] = i1;
     i3 = HEAP32[i48 >> 2] | 0;
     if ((HEAP32[i47 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      HEAP32[(HEAP32[i66 >> 2] | 0) + (i3 << 2) >> 2] = i1;
      HEAP32[i48 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i66, i70) | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i37 | 0));
   } else {
    i17 = 0;
    do {
     i16 = HEAP32[i38 >> 2] | 0;
     i4 = i16 + (i17 << 6) + 40 | 0;
     f99 = Math_fround(HEAPF32[i4 >> 2]);
     f5 = Math_fround(f99 * Math_fround(2.0));
     i6 = i16 + (i17 << 6) + 52 | 0;
     f105 = Math_fround(HEAPF32[i6 >> 2]);
     f100 = Math_fround(f105 * Math_fround(2.0));
     f105 = Math_fround(Math_fround(f99 * f5) + Math_fround(Math_fround(f105 * f100) + Math_fround(-1.0)));
     i8 = i16 + (i17 << 6) + 48 | 0;
     f99 = Math_fround(HEAPF32[i8 >> 2]);
     f106 = Math_fround(f99 * f100);
     i10 = i16 + (i17 << 6) + 44 | 0;
     f107 = Math_fround(HEAPF32[i10 >> 2]);
     f106 = Math_fround(f106 + Math_fround(f5 * f107));
     f107 = Math_fround(Math_fround(f5 * f99) - Math_fround(f100 * f107));
     i12 = i16 + (i17 << 6) + 56 | 0;
     f100 = Math_fround(HEAPF32[i12 >> 2]);
     f105 = Math_fround(f100 * f105);
     f106 = Math_fround(f100 * f106);
     f107 = Math_fround(f100 * f107);
     i13 = i16 + (i17 << 6) + 16 | 0;
     d9 = +HEAPF64[i13 >> 3];
     d7 = +f105;
     i14 = i16 + (i17 << 6) + 24 | 0;
     d102 = +HEAPF64[i14 >> 3];
     d11 = +f106;
     i15 = i16 + (i17 << 6) + 32 | 0;
     d104 = +HEAPF64[i15 >> 3];
     d103 = +f107;
     HEAPF64[i71 >> 3] = d9 - d7;
     HEAPF64[i39 >> 3] = d102 - d11;
     HEAPF64[i40 >> 3] = d104 - d103;
     HEAPF64[i41 >> 3] = d7 + d9;
     HEAPF64[i42 >> 3] = d11 + d102;
     HEAPF64[i43 >> 3] = d103 + d104;
     i16 = i16 + (i17 << 6) + 60 | 0;
     HEAP32[i44 >> 2] = HEAP32[i16 >> 2];
     i1 = HEAP32[i46 >> 2] | 0;
     if ((HEAP32[i45 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
      i3 = (HEAP32[i67 >> 2] | 0) + (i1 * 56 | 0) | 0;
      i1 = i71;
      i61 = i3 + 56 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
       i3 = i3 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i3 | 0) < (i61 | 0));
      HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i67, i71) | 0;
     i1 = i17 << 16 | 2;
     HEAP32[i70 >> 2] = i1;
     i3 = HEAP32[i48 >> 2] | 0;
     if ((HEAP32[i47 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      HEAP32[(HEAP32[i66 >> 2] | 0) + (i3 << 2) >> 2] = i1;
      HEAP32[i48 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i66, i70) | 0;
     i3 = i68;
     i61 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = 0;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) < (i61 | 0));
     HEAPF32[i18 >> 2] = Math_fround(1.0);
     HEAP32[i19 >> 2] = 0;
     HEAP32[i19 + 4 >> 2] = 0;
     HEAP32[i19 + 8 >> 2] = 0;
     HEAP32[i19 + 12 >> 2] = 0;
     HEAPF32[i20 >> 2] = Math_fround(1.0);
     HEAP32[i21 >> 2] = 0;
     HEAP32[i21 + 4 >> 2] = 0;
     HEAP32[i21 + 8 >> 2] = 0;
     HEAP32[i21 + 12 >> 2] = 0;
     HEAPF32[i22 >> 2] = Math_fround(1.0);
     HEAP32[i23 >> 2] = 0;
     HEAP32[i23 + 4 >> 2] = 0;
     HEAP32[i23 + 8 >> 2] = 0;
     HEAP32[i23 + 12 >> 2] = 0;
     HEAPF32[i24 >> 2] = Math_fround(1.0);
     HEAP32[i25 >> 2] = i73;
     __ZN5physx2Cm12RenderOutputlsEj(i68, -16711681) | 0;
     f99 = Math_fround(HEAPF32[i4 >> 2]);
     f100 = Math_fround(HEAPF32[i10 >> 2]);
     f112 = Math_fround(HEAPF32[i8 >> 2]);
     f5 = Math_fround(HEAPF32[i6 >> 2]);
     f105 = Math_fround(f99 + f99);
     f107 = Math_fround(f100 + f100);
     f109 = Math_fround(f112 + f112);
     f111 = Math_fround(f100 * f107);
     f110 = Math_fround(f112 * f109);
     f100 = Math_fround(f105 * f100);
     f113 = Math_fround(f105 * f112);
     f106 = Math_fround(f105 * f5);
     f112 = Math_fround(f107 * f112);
     f107 = Math_fround(f107 * f5);
     f5 = Math_fround(f109 * f5);
     f109 = Math_fround(f100 + f5);
     f108 = Math_fround(f113 - f107);
     f5 = Math_fround(f100 - f5);
     f105 = Math_fround(Math_fround(1.0) - Math_fround(f99 * f105));
     f99 = Math_fround(f105 - f110);
     f100 = Math_fround(f112 + f106);
     f107 = Math_fround(f113 + f107);
     f106 = Math_fround(f112 - f106);
     f105 = Math_fround(f105 - f111);
     HEAPF32[i69 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f111) - f110);
     HEAPF32[i26 >> 2] = f109;
     HEAPF32[i27 >> 2] = f108;
     HEAPF32[i28 >> 2] = f5;
     HEAPF32[i29 >> 2] = f99;
     HEAPF32[i30 >> 2] = f100;
     HEAPF32[i31 >> 2] = f107;
     HEAPF32[i32 >> 2] = f106;
     HEAPF32[i33 >> 2] = f105;
     f105 = Math_fround(+HEAPF64[i13 >> 3]);
     f106 = Math_fround(+HEAPF64[i14 >> 3]);
     f107 = Math_fround(+HEAPF64[i15 >> 3]);
     HEAPF32[i34 >> 2] = f105;
     HEAPF32[i35 >> 2] = f106;
     HEAPF32[i36 >> 2] = f107;
     f107 = Math_fround(HEAPF32[i16 >> 2]);
     __ZN5physx2Cm12RenderOutput13outputCapsuleEffRKNS0_8Matrix34E(i68, f107, Math_fround(HEAPF32[i12 >> 2]), i69) | 0;
     i17 = i17 + 1 | 0;
    } while ((i17 | 0) != (i37 | 0));
   }
  }
 }
 i101 = HEAP32[i65 + 32 >> 2] | 0;
 HEAP32[i88 >> 2] = i101;
 if (!i101) {
  HEAP32[i88 + 4 >> 2] = 0;
  i1 = 0;
 } else {
  HEAP32[i88 + 4 >> 2] = HEAP32[i64 >> 2];
  i1 = HEAP32[i63 >> 2] | 0;
 }
 HEAP32[i88 + 8 >> 2] = i1;
 i101 = HEAP32[i65 + 56 >> 2] | 0;
 HEAP32[i88 + 12 >> 2] = i101;
 if (!i101) {
  HEAP32[i88 + 16 >> 2] = 0;
  i1 = 0;
 } else {
  HEAP32[i88 + 16 >> 2] = HEAP32[i67 >> 2];
  i1 = HEAP32[i66 >> 2] | 0;
 }
 HEAP32[i88 + 20 >> 2] = i1;
 HEAP32[i87 >> 2] = i97;
 HEAP32[i87 + 4 >> 2] = i2;
 HEAP32[i85 >> 2] = HEAP32[i97 + 456 >> 2];
 HEAP32[i85 + 4 >> 2] = i73;
 HEAP32[i85 + 8 >> 2] = (HEAP32[i91 >> 2] | 0) + 76;
 HEAP32[i81 >> 2] = HEAP32[i81 >> 2] & -3;
 i6 = i89 + 8 | 0;
 i2 = i89 + 8 | 0;
 d7 = +HEAPF64[i2 >> 3];
 i8 = i89 + 16 | 0;
 d9 = +HEAPF64[i8 >> 3];
 i10 = i89 + 24 | 0;
 d11 = +HEAPF64[i10 >> 3];
 i1 = __ZN5physx3Cct9SweepTest13moveCharacterEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERNS0_11SweptVolumeERKNS_6PxVec3ERKNS0_13UserObstaclesEfRKNS_19PxControllerFiltersEbb(i76, i85, i87, i89, i83, i88, f86, i84, i82, i72) | 0;
 i3 = HEAP32[i81 >> 2] | 0;
 if (i3 & 1) {
  HEAP32[i81 >> 2] = i3 | 2;
  HEAPF64[i2 >> 3] = d7;
  HEAPF64[i8 >> 3] = d9;
  HEAPF64[i10 >> 3] = d11;
  if ((HEAP32[i77 >> 2] | 0) == 1) {
   f111 = Math_fround(HEAPF32[i83 >> 2]);
   f110 = Math_fround(HEAPF32[i78 >> 2]);
   f111 = Math_fround(f111 * f110);
   f109 = Math_fround(HEAPF32[i74 >> 2]);
   f112 = Math_fround(HEAPF32[i79 >> 2]);
   f109 = Math_fround(f111 + Math_fround(f109 * f112));
   f111 = Math_fround(HEAPF32[i75 >> 2]);
   f113 = Math_fround(HEAPF32[i80 >> 2]);
   f111 = Math_fround(f109 + Math_fround(f111 * f113));
   f112 = Math_fround(f112 * f111);
   f113 = Math_fround(f113 * f111);
   HEAPF32[i90 >> 2] = Math_fround(f110 * f111);
   HEAPF32[i90 + 4 >> 2] = f112;
   HEAPF32[i90 + 8 >> 2] = f113;
  } else {
   HEAP32[i90 >> 2] = HEAP32[i83 >> 2];
   HEAP32[i90 + 4 >> 2] = HEAP32[i74 >> 2];
   HEAP32[i90 + 8 >> 2] = HEAP32[i75 >> 2];
  }
  i1 = __ZN5physx3Cct9SweepTest13moveCharacterEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERNS0_11SweptVolumeERKNS_6PxVec3ERKNS0_13UserObstaclesEfRKNS_19PxControllerFiltersEbb(i76, i85, i87, i89, i90, i88, f86, i84, i82, i72) | 0;
  HEAP32[i81 >> 2] = HEAP32[i81 >> 2] & -3;
 }
 HEAP8[i97 + 484 >> 0] = i1;
 i2 = i97 + 408 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 i3 = i97 + 400 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  i101 = HEAP32[i91 >> 2] | 0;
  __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv(i101);
  STACKTOP = i98;
  return i1 | 0;
 }
 f111 = Math_fround(d7 - +HEAPF64[i6 >> 3]);
 f112 = Math_fround(d9 - +HEAPF64[i8 >> 3]);
 f113 = Math_fround(d11 - +HEAPF64[i10 >> 3]);
 if (!(Math_fround(Math_fround(Math_fround(f111 * f111) + Math_fround(f112 * f112)) + Math_fround(f113 * f113)) != Math_fround(0.0))) {
  i101 = HEAP32[i91 >> 2] | 0;
  __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv(i101);
  STACKTOP = i98;
  return i1 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i96 | 0, i4 | 0);
 f111 = Math_fround(+HEAPF64[i2 >> 3]);
 f112 = Math_fround(+HEAPF64[i97 + 416 >> 3]);
 f113 = Math_fround(+HEAPF64[i97 + 424 >> 3]);
 HEAPF32[i96 + 16 >> 2] = f111;
 HEAPF32[i96 + 20 >> 2] = f112;
 HEAPF32[i96 + 24 >> 2] = f113;
 HEAP32[i96 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i96 + 4 >> 2] = HEAP32[i93 >> 2];
 HEAP32[i96 + 8 >> 2] = HEAP32[i94 >> 2];
 HEAP32[i96 + 12 >> 2] = HEAP32[i95 >> 2];
 i101 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i101 >> 2] | 0) + 224 >> 2] | 0, i101 | 0, i96 | 0);
 i101 = HEAP32[i91 >> 2] | 0;
 __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv(i101);
 STACKTOP = i98;
 return i1 | 0;
}

function __ZN11MemoryStats9SerializeER13dynamic_arrayIiLj4EE(i19, i20) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0;
 i5 = (HEAP32[i19 >> 2] | 0) >>> 10;
 i21 = i20 + 12 | 0;
 i6 = HEAP32[i21 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i22 = i20 + 16 | 0;
 i3 = HEAP32[i22 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i18 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i18;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i2;
 i7 = HEAP32[i20 >> 2] | 0;
 HEAP32[i7 + (i6 << 2) >> 2] = i5;
 i4 = (HEAP32[i19 + 4 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else i8 = i7;
 } else i8 = i7; while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 8 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 12 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i8;
   i7 = i8;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i8;
   i7 = i8;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 16 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 20 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 24 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 28 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 32 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 36 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 40 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 44 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = (HEAP32[i19 + 48 >> 2] | 0) >>> 10;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i4 = i19 + 52 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 56 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 60 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 64 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 68 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 72 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 76 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 80 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 84 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 88 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 92 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 96 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 100 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i4 = i19 + 104 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i18 = i19 + 200 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if ((i2 | 0) > -1) {
   HEAP32[i22 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i20 >> 2] = i7;
   i8 = i7;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i6;
 HEAP32[i8 + (i5 << 2) >> 2] = i4;
 i3 = HEAP32[i18 >> 2] | 0;
 if (!i3) {
  i9 = i7;
  i10 = i8;
  i2 = i7;
  i1 = i8;
 } else {
  i16 = i19 + 188 | 0;
  i17 = i20 + 4 | 0;
  i15 = 0;
  i4 = i7;
  i10 = i8;
  i2 = i7;
  i1 = i8;
  i9 = i7;
  i14 = i8;
  while (1) {
   if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + (i15 << 2) >> 2] | 0)) i5 = i14; else {
    i11 = HEAP32[i21 >> 2] | 0;
    i12 = i11 + 1 | 0;
    i5 = HEAP32[i22 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i12 >>> 0 > i6 >>> 0) {
     i3 = i5 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i6 >>> 0 >= i3 >>> 0) {
      i3 = i8;
      i13 = i7;
      i6 = i14;
      break;
     }
     if ((i5 | 0) > -1) {
      HEAP32[i22 >> 2] = i3;
      i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i3 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i20 >> 2] = i6;
      i3 = i6;
      i13 = i6;
      i10 = i6;
      i2 = i6;
      i1 = i6;
      i9 = i6;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
      HEAP32[i22 >> 2] = i3;
      HEAP32[i20 >> 2] = i6;
      i3 = i6;
      i13 = i6;
      i10 = i6;
      i2 = i6;
      i1 = i6;
      i9 = i6;
      break;
     }
    } else {
     i3 = i8;
     i13 = i7;
     i6 = i14;
    } while (0);
    HEAP32[i21 >> 2] = i12;
    HEAP32[i3 + (i11 << 2) >> 2] = i15;
    i7 = (HEAP32[i16 >> 2] | 0) + (i15 << 2) | 0;
    i8 = HEAP32[i21 >> 2] | 0;
    i11 = i8 + 1 | 0;
    i4 = HEAP32[i22 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i11 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 >= i3 >>> 0) break;
     if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i3;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i13, i3 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i20 >> 2] = i9;
      i6 = i9;
      i10 = i9;
      i2 = i9;
      i1 = i9;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
      HEAP32[i22 >> 2] = i3;
      HEAP32[i20 >> 2] = i9;
      i6 = i9;
      i10 = i9;
      i2 = i9;
      i1 = i9;
      break;
     }
    } while (0);
    HEAP32[i21 >> 2] = i11;
    HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i7 >> 2];
    i3 = HEAP32[i18 >> 2] | 0;
    i5 = i6;
    i7 = i6;
    i8 = i6;
    i4 = i6;
   }
   i15 = i15 + 1 | 0;
   if (i15 >>> 0 >= i3 >>> 0) break; else i14 = i5;
  }
 }
 i6 = HEAP32[i21 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i7 >>> 0 > i5 >>> 0) {
  i3 = i4 << 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  if (i5 >>> 0 >= i3 >>> 0) {
   i3 = i10;
   break;
  }
  if ((i4 | 0) > -1) {
   HEAP32[i22 >> 2] = i3;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i3 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i2;
   i1 = i2;
   i3 = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
   HEAP32[i22 >> 2] = i3;
   HEAP32[i20 >> 2] = i2;
   i1 = i2;
   i3 = i2;
   break;
  }
 } else i3 = i10; while (0);
 HEAP32[i21 >> 2] = i7;
 HEAP32[i1 + (i6 << 2) >> 2] = -1;
 i10 = i20 + 4 | 0;
 i9 = 0;
 i1 = i3;
 while (1) {
  i6 = HEAP32[i19 + 124 + (i9 << 2) >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i4 = HEAP32[i22 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i8 >>> 0 > i5 >>> 0) {
   i3 = i4 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i5 >>> 0 >= i3 >>> 0) break;
   if ((i4 | 0) > -1) {
    HEAP32[i22 >> 2] = i3;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i20 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
    HEAP32[i22 >> 2] = i3;
    HEAP32[i20 >> 2] = i1;
    break;
   }
  } while (0);
  HEAP32[i21 >> 2] = i8;
  HEAP32[i1 + (i7 << 2) >> 2] = i6;
  i9 = i9 + 1 | 0;
  if ((i9 | 0) == 16) break; else i2 = i1;
 }
 return;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_PS2_RNS3_18ImpulseAccumulatorE(i247, i1, i310, i267, i246) {
 i247 = i247 | 0;
 i1 = i1 | 0;
 i310 = i310 | 0;
 i267 = i267 | 0;
 i246 = i246 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, i158 = 0, i159 = 0, i160 = 0, i161 = 0, i162 = 0, i163 = 0, i164 = 0, i165 = 0, i166 = 0, i167 = 0, i168 = 0, i169 = 0, i170 = 0, i171 = 0, i172 = 0, i173 = 0, i174 = 0, i175 = 0, i176 = 0, i177 = 0, i178 = 0, i179 = 0, i180 = 0, i181 = 0, i182 = 0, i183 = 0, i184 = 0, i185 = 0, i186 = 0, i187 = 0, i188 = 0, i189 = 0, i190 = 0, i191 = 0, i192 = 0, i193 = 0, i194 = 0, i195 = 0, i196 = 0, i197 = 0, i198 = 0, i199 = 0, i200 = 0, i201 = 0, i202 = 0, i203 = 0, i204 = 0, i205 = 0, i206 = 0, i207 = 0, i208 = 0, i209 = 0, i210 = 0, i211 = 0, i212 = 0, i213 = 0, i214 = 0, i215 = 0, i216 = 0, i217 = 0, i218 = 0, i219 = 0, i220 = 0, i221 = 0, i222 = 0, i223 = 0, i224 = 0, i225 = 0, i226 = 0, i227 = 0, i228 = 0, i229 = 0, i230 = 0, i231 = 0, i232 = 0, i233 = 0, i234 = 0, i235 = 0, i236 = 0, i237 = 0, i238 = 0, i239 = 0, i240 = 0, i241 = 0, i242 = 0, i243 = 0, i244 = 0, i245 = 0, i248 = 0, i249 = 0, i250 = 0, i251 = 0, i252 = 0, i253 = 0, i254 = 0, i255 = 0, i256 = 0, i257 = 0, i258 = 0, i259 = 0, i260 = 0, i261 = 0, i262 = 0, i263 = 0, i264 = 0, i265 = 0, i266 = 0, i268 = 0, i269 = 0, i270 = 0, i271 = 0, i272 = 0, i273 = 0, i274 = 0, i275 = 0, i276 = 0, i277 = 0, i278 = 0, i279 = 0, i280 = 0, i281 = 0, i282 = 0, i283 = 0, i284 = 0, i285 = 0, i286 = 0, i287 = 0, i288 = 0, i289 = 0, i290 = 0, i291 = 0, i292 = 0, i293 = 0, i294 = 0, i295 = 0, i296 = 0, i297 = 0, i298 = 0, i299 = 0, i300 = 0, i301 = 0, i302 = 0, i303 = 0, i304 = 0, i305 = 0, i306 = 0, i307 = 0, i308 = 0, i309 = 0, i311 = 0, i312 = 0, i313 = 0, i314 = 0, i315 = 0, i316 = 0, i317 = 0, i318 = 0, i319 = 0, i320 = 0, i321 = 0, i322 = 0, i323 = 0, i324 = 0, i325 = 0, i326 = 0, i327 = 0, i328 = 0, i329 = 0, i330 = 0, i331 = 0, i332 = 0, i333 = 0, i334 = 0, i335 = 0, i336 = 0, i337 = 0, i338 = 0, i339 = 0, i340 = 0, i341 = 0, i342 = 0, i343 = 0;
 i340 = STACKTOP;
 STACKTOP = STACKTOP + 4848 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i326 = i340 + 4800 | 0;
 i296 = i340 + 4784 | 0;
 i2 = i340 + 4768 | 0;
 i332 = i340 + 4752 | 0;
 i5 = i340 + 4736 | 0;
 i116 = i340 + 4843 | 0;
 i258 = i340 + 4720 | 0;
 i169 = i340 + 4704 | 0;
 i180 = i340 + 4688 | 0;
 i307 = i340 + 4672 | 0;
 i191 = i340 + 4664 | 0;
 i303 = i340 + 4648 | 0;
 i202 = i340 + 4640 | 0;
 i304 = i340 + 4624 | 0;
 i305 = i340 + 4608 | 0;
 i306 = i340 + 4592 | 0;
 i312 = i340 + 4576 | 0;
 i316 = i340 + 4560 | 0;
 i213 = i340 + 4544 | 0;
 i317 = i340 + 4528 | 0;
 i224 = i340 + 4512 | 0;
 i318 = i340 + 4496 | 0;
 i235 = i340 + 4480 | 0;
 i313 = i340 + 4464 | 0;
 i6 = i340 + 4448 | 0;
 i17 = i340 + 4432 | 0;
 i314 = i340 + 4416 | 0;
 i28 = i340 + 4400 | 0;
 i39 = i340 + 4384 | 0;
 i315 = i340 + 4368 | 0;
 i50 = i340 + 4352 | 0;
 i61 = i340 + 4336 | 0;
 i308 = i340 + 4320 | 0;
 i72 = i340 + 4304 | 0;
 i83 = i340 + 4288 | 0;
 i94 = i340 + 4272 | 0;
 i105 = i340 + 4256 | 0;
 i311 = i340 + 4240 | 0;
 i117 = i340 + 4224 | 0;
 i128 = i340 + 4208 | 0;
 i264 = i340 + 4192 | 0;
 i139 = i340 + 4184 | 0;
 i260 = i340 + 4168 | 0;
 i148 = i340 + 4160 | 0;
 i261 = i340 + 4144 | 0;
 i262 = i340 + 4128 | 0;
 i263 = i340 + 4112 | 0;
 i270 = i340 + 4096 | 0;
 i259 = i340 + 4080 | 0;
 i155 = i340 + 4064 | 0;
 i160 = i340 + 4056 | 0;
 i275 = i340 + 4040 | 0;
 i165 = i340 + 4024 | 0;
 i276 = i340 + 4008 | 0;
 i166 = i340 + 3992 | 0;
 i277 = i340 + 3976 | 0;
 i167 = i340 + 3960 | 0;
 i272 = i340 + 3944 | 0;
 i168 = i340 + 3928 | 0;
 i170 = i340 + 3912 | 0;
 i273 = i340 + 3896 | 0;
 i171 = i340 + 3880 | 0;
 i172 = i340 + 3864 | 0;
 i274 = i340 + 3848 | 0;
 i173 = i340 + 3832 | 0;
 i174 = i340 + 3816 | 0;
 i265 = i340 + 3800 | 0;
 i175 = i340 + 3784 | 0;
 i176 = i340 + 3768 | 0;
 i177 = i340 + 3752 | 0;
 i178 = i340 + 3736 | 0;
 i268 = i340 + 3720 | 0;
 i179 = i340 + 3704 | 0;
 i181 = i340 + 3688 | 0;
 i271 = i340 + 3672 | 0;
 i182 = i340 + 3656 | 0;
 i183 = i340 + 3640 | 0;
 i184 = i340 + 3624 | 0;
 i185 = i340 + 3608 | 0;
 i186 = i340 + 3592 | 0;
 i187 = i340 + 3576 | 0;
 i188 = i340 + 3560 | 0;
 i189 = i340 + 3544 | 0;
 i190 = i340 + 3528 | 0;
 i192 = i340 + 4842 | 0;
 i193 = i340 + 3512 | 0;
 i194 = i340 + 3496 | 0;
 i195 = i340 + 3480 | 0;
 i196 = i340 + 3464 | 0;
 i197 = i340 + 4841 | 0;
 i198 = i340 + 3448 | 0;
 i309 = i340 + 3432 | 0;
 i266 = i340 + 3416 | 0;
 i289 = i340 + 3400 | 0;
 i199 = i340 + 3384 | 0;
 i200 = i340 + 3368 | 0;
 i201 = i340 + 3352 | 0;
 i203 = i340 + 3336 | 0;
 i204 = i340 + 3320 | 0;
 i205 = i340 + 3304 | 0;
 i288 = i340 + 3288 | 0;
 i206 = i340 + 3272 | 0;
 i207 = i340 + 3256 | 0;
 i208 = i340 + 3240 | 0;
 i209 = i340 + 3224 | 0;
 i210 = i340 + 3208 | 0;
 i211 = i340 + 3192 | 0;
 i287 = i340 + 3176 | 0;
 i212 = i340 + 3160 | 0;
 i285 = i340 + 3144 | 0;
 i214 = i340 + 3128 | 0;
 i215 = i340 + 3112 | 0;
 i331 = i340 + 3096 | 0;
 i290 = i340 + 3080 | 0;
 i297 = i340 + 3064 | 0;
 i216 = i340 + 3048 | 0;
 i333 = i340 + 3032 | 0;
 i217 = i340 + 3016 | 0;
 i218 = i340 + 3e3 | 0;
 i219 = i340 + 2984 | 0;
 i220 = i340 + 4840 | 0;
 i221 = i340 + 2968 | 0;
 i254 = i340 + 2952 | 0;
 i222 = i340 + 2936 | 0;
 i223 = i340 + 2920 | 0;
 i225 = i340 + 4839 | 0;
 i226 = i340 + 2904 | 0;
 i227 = i340 + 2888 | 0;
 i228 = i340 + 2872 | 0;
 i229 = i340 + 2856 | 0;
 i230 = i340 + 4838 | 0;
 i231 = i340 + 2840 | 0;
 i232 = i340 + 2824 | 0;
 i233 = i340 + 2808 | 0;
 i234 = i340 + 2792 | 0;
 i236 = i340 + 2776 | 0;
 i237 = i340 + 4837 | 0;
 i279 = i340 + 2760 | 0;
 i281 = i340 + 2744 | 0;
 i283 = i340 + 2728 | 0;
 i299 = i340 + 2712 | 0;
 i238 = i340 + 2696 | 0;
 i300 = i340 + 2680 | 0;
 i239 = i340 + 2664 | 0;
 i301 = i340 + 2648 | 0;
 i240 = i340 + 2632 | 0;
 i269 = i340 + 2616 | 0;
 i241 = i340 + 2600 | 0;
 i242 = i340 + 2584 | 0;
 i302 = i340 + 2568 | 0;
 i243 = i340 + 2552 | 0;
 i244 = i340 + 2544 | 0;
 i278 = i340 + 2528 | 0;
 i245 = i340 + 2512 | 0;
 i7 = i340 + 2496 | 0;
 i8 = i340 + 2480 | 0;
 i298 = i340 + 2464 | 0;
 i9 = i340 + 2448 | 0;
 i10 = i340 + 4836 | 0;
 i248 = i340 + 2432 | 0;
 i11 = i340 + 2416 | 0;
 i12 = i340 + 2400 | 0;
 i13 = i340 + 2384 | 0;
 i249 = i340 + 2368 | 0;
 i14 = i340 + 2352 | 0;
 i15 = i340 + 2336 | 0;
 i16 = i340 + 2320 | 0;
 i250 = i340 + 2304 | 0;
 i18 = i340 + 2288 | 0;
 i19 = i340 + 2272 | 0;
 i20 = i340 + 2256 | 0;
 i327 = i340 + 2240 | 0;
 i21 = i340 + 2224 | 0;
 i22 = i340 + 2208 | 0;
 i23 = i340 + 2192 | 0;
 i330 = i340 + 2176 | 0;
 i24 = i340 + 2160 | 0;
 i25 = i340 + 2144 | 0;
 i26 = i340 + 2128 | 0;
 i27 = i340 + 2112 | 0;
 i294 = i340 + 2096 | 0;
 i286 = i340 + 2080 | 0;
 i29 = i340 + 2064 | 0;
 i30 = i340 + 2048 | 0;
 i31 = i340 + 2032 | 0;
 i32 = i340 + 2016 | 0;
 i33 = i340 + 2e3 | 0;
 i329 = i340 + 1984 | 0;
 i34 = i340 + 1968 | 0;
 i35 = i340 + 1952 | 0;
 i36 = i340 + 1936 | 0;
 i37 = i340 + 1920 | 0;
 i38 = i340 + 1904 | 0;
 i40 = i340 + 1888 | 0;
 i292 = i340 + 1872 | 0;
 i41 = i340 + 1856 | 0;
 i42 = i340 + 1840 | 0;
 i43 = i340 + 1824 | 0;
 i44 = i340 + 4835 | 0;
 i251 = i340 + 1808 | 0;
 i45 = i340 + 1792 | 0;
 i46 = i340 + 1776 | 0;
 i324 = i340 + 1760 | 0;
 i47 = i340 + 1744 | 0;
 i256 = i340 + 1728 | 0;
 i48 = i340 + 1712 | 0;
 i49 = i340 + 1696 | 0;
 i51 = i340 + 1680 | 0;
 i52 = i340 + 4834 | 0;
 i53 = i340 + 1664 | 0;
 i54 = i340 + 4833 | 0;
 i55 = i340 + 1648 | 0;
 i56 = i340 + 1632 | 0;
 i57 = i340 + 1616 | 0;
 i58 = i340 + 1600 | 0;
 i59 = i340 + 1584 | 0;
 i60 = i340 + 1568 | 0;
 i62 = i340 + 1552 | 0;
 i63 = i340 + 1536 | 0;
 i64 = i340 + 1520 | 0;
 i65 = i340 + 1504 | 0;
 i66 = i340 + 1488 | 0;
 i67 = i340 + 1472 | 0;
 i68 = i340 + 1456 | 0;
 i69 = i340 + 1440 | 0;
 i70 = i340 + 1424 | 0;
 i71 = i340 + 1408 | 0;
 i73 = i340 + 1392 | 0;
 i74 = i340 + 1376 | 0;
 i75 = i340 + 1360 | 0;
 i76 = i340 + 1344 | 0;
 i77 = i340 + 1328 | 0;
 i78 = i340 + 1312 | 0;
 i79 = i340 + 1296 | 0;
 i80 = i340 + 1280 | 0;
 i81 = i340 + 1264 | 0;
 i82 = i340 + 1248 | 0;
 i84 = i340 + 1232 | 0;
 i85 = i340 + 4832 | 0;
 i86 = i340 + 1216 | 0;
 i87 = i340 + 1200 | 0;
 i88 = i340 + 1184 | 0;
 i89 = i340 + 1168 | 0;
 i90 = i340 + 1152 | 0;
 i91 = i340 + 1136 | 0;
 i92 = i340 + 1120 | 0;
 i93 = i340 + 1104 | 0;
 i95 = i340 + 1088 | 0;
 i96 = i340 + 1072 | 0;
 i97 = i340 + 1056 | 0;
 i98 = i340 + 1040 | 0;
 i99 = i340 + 1024 | 0;
 i100 = i340 + 1008 | 0;
 i255 = i340 + 992 | 0;
 i101 = i340 + 976 | 0;
 i253 = i340 + 960 | 0;
 i257 = i340 + 944 | 0;
 i102 = i340 + 928 | 0;
 i103 = i340 + 912 | 0;
 i104 = i340 + 896 | 0;
 i106 = i340 + 880 | 0;
 i107 = i340 + 864 | 0;
 i293 = i340 + 848 | 0;
 i108 = i340 + 832 | 0;
 i109 = i340 + 816 | 0;
 i110 = i340 + 800 | 0;
 i252 = i340 + 784 | 0;
 i111 = i340 + 768 | 0;
 i112 = i340 + 752 | 0;
 i291 = i340 + 736 | 0;
 i113 = i340 + 720 | 0;
 i295 = i340 + 704 | 0;
 i114 = i340 + 688 | 0;
 i115 = i340 + 672 | 0;
 i319 = i340 + 656 | 0;
 i118 = i340 + 640 | 0;
 i280 = i340 + 624 | 0;
 i119 = i340 + 608 | 0;
 i282 = i340 + 592 | 0;
 i120 = i340 + 576 | 0;
 i284 = i340 + 560 | 0;
 i121 = i340 + 544 | 0;
 i328 = i340 + 528 | 0;
 i122 = i340 + 512 | 0;
 i325 = i340 + 496 | 0;
 i123 = i340 + 480 | 0;
 i124 = i340 + 464 | 0;
 i125 = i340 + 448 | 0;
 i126 = i340 + 432 | 0;
 i127 = i340 + 416 | 0;
 i129 = i340 + 400 | 0;
 i320 = i340 + 384 | 0;
 i130 = i340 + 376 | 0;
 i321 = i340 + 360 | 0;
 i131 = i340 + 352 | 0;
 i322 = i340 + 336 | 0;
 i132 = i340 + 328 | 0;
 i323 = i340 + 312 | 0;
 i133 = i340 + 304 | 0;
 i334 = i340 + 288 | 0;
 i335 = i340 + 272 | 0;
 i336 = i340 + 256 | 0;
 i134 = i340 + 240 | 0;
 i135 = i340 + 224 | 0;
 i136 = i340 + 208 | 0;
 i137 = i340 + 192 | 0;
 i337 = i340 + 176 | 0;
 i138 = i340 + 160 | 0;
 i140 = i340 + 144 | 0;
 i141 = i340 + 128 | 0;
 i338 = i340 + 112 | 0;
 i142 = i340 + 96 | 0;
 i143 = i340 + 80 | 0;
 i144 = i340 + 64 | 0;
 i339 = i340 + 48 | 0;
 i145 = i340 + 32 | 0;
 i146 = i340 + 16 | 0;
 i147 = i340;
 i151 = HEAP32[i1 + 420 >> 2] | 0;
 i149 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i151) | 0;
 i150 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i151 + 16 | 0) | 0;
 i151 = i151 + 32 | 0;
 i154 = HEAP32[i1 + 428 >> 2] | 0;
 i152 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i154) | 0;
 i153 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i154 + 16 | 0) | 0;
 i154 = i154 + 32 | 0;
 i156 = i1 + 432 | 0;
 i157 = Math_fround(HEAPF32[(HEAP32[i156 >> 2] | 0) + 216 >> 2]) > Math_fround(0.0);
 __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_S5_(i326, i1, i310, i267);
 __ZN8Scalar4fC2ERKS_(i2, i326);
 __ZN5physx5cloth12horizontalOrE8Scalar4f(i296, i2);
 i2 = HEAP32[(__ZN5simdi5arrayER8Scalar4f(i296) | 0) >> 2] | 0;
 if (!i2) {
  i339 = i326 + 16 | 0;
  __ZN8Scalar4fC2ERKS_(i247, i339);
  STACKTOP = i340;
  return;
 }
 i158 = i310 + 16 | 0;
 i159 = i310 + 32 | 0;
 i161 = i267 + 16 | 0;
 i162 = i267 + 32 | 0;
 i163 = i326 + 16 | 0;
 i164 = i1 + 416 | 0;
 i4 = i1 + 424 | 0;
 do {
  i1 = __ZN5physx5cloth10findBitSetEj(i2 & 0 - i2) | 0;
  i3 = i1 * 48 | 0;
  i2 = i2 + -1 & i2;
  __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i5, i116);
  __ZN5simdimiERK8Scalar4fS2_(i332, i296, i5);
  __ZN12_GLOBAL__N_112andNotIsZeroI8Scalar4fEET_RKS2_S4_(i169, i326, i332);
  __Z6simd4fRK8Scalar4f(i258, i169);
  __ZanRK8Scalar4fS1_(i180, i296, i332);
  __ZN8Scalar4faSERKS_(i296, i180) | 0;
  __Z11loadAlignedPKfj(i191, i149, i3);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i307, i191);
  __Z11loadAlignedPKfj(i202, i150, i3);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i303, i202);
  __Z5splatILj0EE8Scalar4fRKS0_(i304, i303);
  __Z5splatILj1EE8Scalar4fRKS0_(i305, i303);
  __Z5splatILj2EE8Scalar4fRKS0_(i306, i303);
  __Z5splatILj3EE8Scalar4fRKS0_(i312, i303);
  __Z5splatILj0EE8Scalar4fRKS0_(i213, i307);
  __ZmiRK8Scalar4fS1_(i316, i310, i213);
  __Z5splatILj1EE8Scalar4fRKS0_(i224, i307);
  __ZmiRK8Scalar4fS1_(i317, i158, i224);
  __Z5splatILj2EE8Scalar4fRKS0_(i235, i307);
  __ZmiRK8Scalar4fS1_(i318, i159, i235);
  __ZmlRK8Scalar4fS1_(i6, i317, i306);
  __ZmlRK8Scalar4fS1_(i17, i318, i305);
  __ZmiRK8Scalar4fS1_(i313, i6, i17);
  __ZmlRK8Scalar4fS1_(i28, i318, i304);
  __ZmlRK8Scalar4fS1_(i39, i316, i306);
  __ZmiRK8Scalar4fS1_(i314, i28, i39);
  __ZmlRK8Scalar4fS1_(i50, i316, i305);
  __ZmlRK8Scalar4fS1_(i61, i317, i304);
  __ZmiRK8Scalar4fS1_(i315, i50, i61);
  __ZmlRK8Scalar4fS1_(i83, i316, i304);
  __ZmlRK8Scalar4fS1_(i94, i317, i305);
  __ZplRK8Scalar4fS1_(i72, i83, i94);
  __ZmlRK8Scalar4fS1_(i105, i318, i306);
  __ZplRK8Scalar4fS1_(i308, i72, i105);
  __ZmlRK8Scalar4fS1_(i117, i308, i312);
  __Z5splatILj3EE8Scalar4fRKS0_(i128, i307);
  __ZplRK8Scalar4fS1_(i311, i117, i128);
  __Z11loadAlignedPKfj(i139, i152, i3);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i264, i139);
  __Z11loadAlignedPKfj(i148, i153, i3);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i260, i148);
  __Z5splatILj0EE8Scalar4fRKS0_(i261, i260);
  __Z5splatILj1EE8Scalar4fRKS0_(i262, i260);
  __Z5splatILj2EE8Scalar4fRKS0_(i263, i260);
  __Z5splatILj3EE8Scalar4fRKS0_(i270, i260);
  __Z11loadAlignedPKfj(i160, i154, i3);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i155, i160);
  __Z6simd4iRK8Scalar4f(i259, i155);
  __Z5splatILj0EE8Scalar4fRKS0_(i165, i264);
  __ZmiRK8Scalar4fS1_(i275, i267, i165);
  __Z5splatILj1EE8Scalar4fRKS0_(i166, i264);
  __ZmiRK8Scalar4fS1_(i276, i161, i166);
  __Z5splatILj2EE8Scalar4fRKS0_(i167, i264);
  __ZmiRK8Scalar4fS1_(i277, i162, i167);
  __ZmlRK8Scalar4fS1_(i168, i276, i263);
  __ZmlRK8Scalar4fS1_(i170, i277, i262);
  __ZmiRK8Scalar4fS1_(i272, i168, i170);
  __ZmlRK8Scalar4fS1_(i171, i277, i261);
  __ZmlRK8Scalar4fS1_(i172, i275, i263);
  __ZmiRK8Scalar4fS1_(i273, i171, i172);
  __ZmlRK8Scalar4fS1_(i173, i275, i262);
  __ZmlRK8Scalar4fS1_(i174, i276, i261);
  __ZmiRK8Scalar4fS1_(i274, i173, i174);
  __ZmlRK8Scalar4fS1_(i176, i275, i261);
  __ZmlRK8Scalar4fS1_(i177, i276, i262);
  __ZplRK8Scalar4fS1_(i175, i176, i177);
  __ZmlRK8Scalar4fS1_(i178, i277, i263);
  __ZplRK8Scalar4fS1_(i265, i175, i178);
  __ZmlRK8Scalar4fS1_(i179, i265, i270);
  __Z5splatILj3EE8Scalar4fRKS0_(i181, i264);
  __ZplRK8Scalar4fS1_(i268, i179, i181);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i184, gb + 1097856 | 0);
  __ZmlRK8Scalar4fS1_(i185, i272, i272);
  __ZplRK8Scalar4fS1_(i183, i184, i185);
  __ZmlRK8Scalar4fS1_(i186, i273, i273);
  __ZplRK8Scalar4fS1_(i182, i183, i186);
  __ZmlRK8Scalar4fS1_(i187, i274, i274);
  __ZplRK8Scalar4fS1_(i271, i182, i187);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i190, i192);
  __Z3maxRK8Scalar4fS1_(i189, i311, i190);
  __ZcoRK8Scalar4f(i193, i258);
  __ZanRK8Scalar4fRK14ComplementExprIS_E(i188, i189, i193);
  __ZN8Scalar4faSERKS_(i311, i188) | 0;
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i196, i197);
  __Z3maxRK8Scalar4fS1_(i195, i268, i196);
  __ZcoRK8Scalar4f(i198, i258);
  __ZanRK8Scalar4fRK14ComplementExprIS_E(i194, i195, i198);
  __ZN8Scalar4faSERKS_(i268, i194) | 0;
  __ZmlRK8Scalar4fS1_(i309, i311, gb + 1458888 | 0);
  __ZmlRK8Scalar4fS1_(i266, i268, gb + 1458888 | 0);
  __ZmlRK8Scalar4fS1_(i201, i313, i313);
  __ZmlRK8Scalar4fS1_(i203, i314, i314);
  __ZplRK8Scalar4fS1_(i200, i201, i203);
  __ZmlRK8Scalar4fS1_(i204, i315, i315);
  __ZplRK8Scalar4fS1_(i199, i200, i204);
  __ZmlRK8Scalar4fS1_(i205, i309, i309);
  __ZmiRK8Scalar4fS1_(i289, i199, i205);
  __ZmlRK8Scalar4fS1_(i208, i313, i272);
  __ZmlRK8Scalar4fS1_(i209, i314, i273);
  __ZplRK8Scalar4fS1_(i207, i208, i209);
  __ZmlRK8Scalar4fS1_(i210, i315, i274);
  __ZplRK8Scalar4fS1_(i206, i207, i210);
  __ZmlRK8Scalar4fS1_(i211, i309, i266);
  __ZmiRK8Scalar4fS1_(i288, i206, i211);
  __ZmlRK8Scalar4fS1_(i212, i266, i266);
  __ZmiRK8Scalar4fS1_(i287, i271, i212);
  __ZmlRK8Scalar4fS1_(i214, i288, i288);
  __ZmlRK8Scalar4fS1_(i215, i287, i289);
  __ZmiRK8Scalar4fS1_(i285, i214, i215);
  __Z4sqrtRK8Scalar4f(i331, i285);
  __ZmiRK8Scalar4fS1_(i290, i288, i289);
  __ZmiRK8Scalar4fS1_(i216, i288, i287);
  __ZplRK8Scalar4fS1_(i297, i216, i290);
  __Z5recipRK8Scalar4f(i217, i297);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i219, i220);
  __ZplRK8Scalar4fS1_(i221, i290, i331);
  __Z3minRK8Scalar4fS1_(i218, i219, i221);
  __ZmlRK8Scalar4fS1_(i333, i217, i218);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i223, i225);
  __ZltRK8Scalar4fS1_(i222, i333, i223);
  __ZltRK8Scalar4fS1_(i226, i290, i331);
  __ZanRK8Scalar4fS1_(i254, i222, i226);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i229, i230);
  __ZgeRK8Scalar4fS1_(i228, i285, i229);
  __ZanRK8Scalar4fS1_(i227, i254, i228);
  __ZN8Scalar4faSERKS_(i254, i227) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i234, gb + 1097856 | 0);
  __ZngRK8Scalar4f(i233, i234);
  __ZltRK8Scalar4fS1_(i232, i297, i233);
  __ZanRK8Scalar4fS1_(i231, i254, i232);
  __ZN8Scalar4faSERKS_(i254, i231) | 0;
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i236, i237);
  if (!(__Z8allEqualRK8Scalar4fS1_(i254, i236) | 0)) {
   __ZmiRK8Scalar4fS1_(i279, i316, i275);
   __ZmiRK8Scalar4fS1_(i281, i317, i276);
   __ZmiRK8Scalar4fS1_(i283, i318, i277);
   __ZmlRK8Scalar4fS1_(i238, i279, i333);
   __ZmiRK8Scalar4fS1_(i299, i316, i238);
   __ZmlRK8Scalar4fS1_(i239, i281, i333);
   __ZmiRK8Scalar4fS1_(i300, i317, i239);
   __ZmlRK8Scalar4fS1_(i240, i283, i333);
   __ZmiRK8Scalar4fS1_(i301, i318, i240);
   __Z6simd4fRK8Scalar4f(i242, i259);
   __Z5splatILj1EE8Scalar4fRKS0_(i241, i242);
   __ZmlRK8Scalar4fS1_(i269, i260, i241);
   __Z11loadAlignedPKfj(i244, i151, i3);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i243, i244);
   __Z6simd4iRK8Scalar4f(i302, i243);
   __Z6simd4fRK8Scalar4f(i8, i302);
   __Z5splatILj1EE8Scalar4fRKS0_(i7, i8);
   __ZmlRK8Scalar4fS1_(i245, i303, i7);
   __ZmiRK8Scalar4fS1_(i278, i269, i245);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i9, i10);
   __ZmiRK8Scalar4fS1_(i298, i9, i333);
   __Z5splatILj0EE8Scalar4fRKS0_(i11, i269);
   __Z5splatILj0EE8Scalar4fRKS0_(i13, i278);
   __ZmlRK8Scalar4fS1_(i12, i13, i298);
   __ZmiRK8Scalar4fS1_(i248, i11, i12);
   __Z5splatILj1EE8Scalar4fRKS0_(i14, i269);
   __Z5splatILj1EE8Scalar4fRKS0_(i16, i278);
   __ZmlRK8Scalar4fS1_(i15, i16, i298);
   __ZmiRK8Scalar4fS1_(i249, i14, i15);
   __Z5splatILj2EE8Scalar4fRKS0_(i18, i269);
   __Z5splatILj2EE8Scalar4fRKS0_(i20, i278);
   __ZmlRK8Scalar4fS1_(i19, i20, i298);
   __ZmiRK8Scalar4fS1_(i250, i18, i19);
   __ZmlRK8Scalar4fS1_(i22, i312, i298);
   __ZmlRK8Scalar4fS1_(i23, i270, i333);
   __ZplRK8Scalar4fS1_(i21, i22, i23);
   __ZmlRK8Scalar4fS1_(i327, i21, gb + 1458888 | 0);
   __ZmlRK8Scalar4fS1_(i25, i248, i248);
   __ZmlRK8Scalar4fS1_(i26, i249, i249);
   __ZplRK8Scalar4fS1_(i24, i25, i26);
   __ZmlRK8Scalar4fS1_(i27, i250, i250);
   __ZplRK8Scalar4fS1_(i330, i24, i27);
   __Z5rsqrtRK8Scalar4f(i294, i330);
   __ZmlRK8Scalar4fS1_(i31, i299, i248);
   __ZmlRK8Scalar4fS1_(i32, i300, i249);
   __ZplRK8Scalar4fS1_(i30, i31, i32);
   __ZmlRK8Scalar4fS1_(i33, i301, i250);
   __ZplRK8Scalar4fS1_(i29, i30, i33);
   __ZmlRK8Scalar4fS1_(i286, i29, i294);
   __ZmlRK8Scalar4fS1_(i36, i299, i299);
   __ZmlRK8Scalar4fS1_(i37, i300, i300);
   __ZplRK8Scalar4fS1_(i35, i36, i37);
   __ZmlRK8Scalar4fS1_(i38, i301, i301);
   __ZplRK8Scalar4fS1_(i34, i35, i38);
   __ZmlRK8Scalar4fS1_(i40, i286, i286);
   __ZmiRK8Scalar4fS1_(i329, i34, i40);
   __Z5rsqrtRK8Scalar4f(i41, i329);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i43, i44);
   __ZgtRK8Scalar4fS1_(i42, i329, i43);
   __ZanRK8Scalar4fS1_(i292, i41, i42);
   __ZmlRK8Scalar4fS1_(i46, i327, i329);
   __ZmlRK8Scalar4fS1_(i45, i46, i292);
   __ZplRK8Scalar4fS1_(i251, i286, i45);
   __ZmlRK8Scalar4fS1_(i47, i251, i294);
   __ZanRK8Scalar4fS1_(i324, i47, i254);
   __Z3absRK8Scalar4f(i49, i324);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i51, i52);
   __ZltRK8Scalar4fS1_(i48, i49, i51);
   __ZanRK8Scalar4fS1_(i256, i48, i254);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i53, i54);
   if (!(__Z8allEqualRK8Scalar4fS1_(i256, i53) | 0)) {
    __Z5splatILj0EE8Scalar4fRKS0_(i57, i278);
    __ZmlRK8Scalar4fS1_(i56, i57, i324);
    __ZplRK8Scalar4fS1_(i55, i279, i56);
    __ZN8Scalar4faSERKS_(i279, i55) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i60, i278);
    __ZmlRK8Scalar4fS1_(i59, i60, i324);
    __ZplRK8Scalar4fS1_(i58, i281, i59);
    __ZN8Scalar4faSERKS_(i281, i58) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i64, i278);
    __ZmlRK8Scalar4fS1_(i63, i64, i324);
    __ZplRK8Scalar4fS1_(i62, i283, i63);
    __ZN8Scalar4faSERKS_(i283, i62) | 0;
    __ZanRK8Scalar4fS1_(i65, i298, i256);
    __ZN8Scalar4faSERKS_(i298, i65) | 0;
    __ZmlRK8Scalar4fS1_(i67, i279, i298);
    __ZplRK8Scalar4fS1_(i66, i275, i67);
    __ZN8Scalar4faSERKS_(i275, i66) | 0;
    __ZmlRK8Scalar4fS1_(i69, i281, i298);
    __ZplRK8Scalar4fS1_(i68, i276, i69);
    __ZN8Scalar4faSERKS_(i276, i68) | 0;
    __ZmlRK8Scalar4fS1_(i71, i283, i298);
    __ZplRK8Scalar4fS1_(i70, i277, i71);
    __ZN8Scalar4faSERKS_(i277, i70) | 0;
    __ZmlRK8Scalar4fS1_(i75, i275, i261);
    __ZmlRK8Scalar4fS1_(i76, i276, i262);
    __ZplRK8Scalar4fS1_(i74, i75, i76);
    __ZmlRK8Scalar4fS1_(i77, i277, i263);
    __ZplRK8Scalar4fS1_(i73, i74, i77);
    __ZN8Scalar4faSERKS_(i265, i73) | 0;
    __ZmlRK8Scalar4fS1_(i79, i265, i270);
    __Z5splatILj3EE8Scalar4fRKS0_(i80, i264);
    __ZplRK8Scalar4fS1_(i78, i79, i80);
    __ZN8Scalar4faSERKS_(i268, i78) | 0;
    __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i84, i85);
    __Z3maxRK8Scalar4fS1_(i82, i268, i84);
    __ZcoRK8Scalar4f(i86, i258);
    __ZanRK8Scalar4fRK14ComplementExprIS_E(i81, i82, i86);
    __ZN8Scalar4faSERKS_(i268, i81) | 0;
    __ZmlRK8Scalar4fS1_(i90, i275, i275);
    __ZmlRK8Scalar4fS1_(i91, i276, i276);
    __ZplRK8Scalar4fS1_(i89, i90, i91);
    __ZmlRK8Scalar4fS1_(i92, i277, i277);
    __ZplRK8Scalar4fS1_(i88, i89, i92);
    __ZmlRK8Scalar4fS1_(i93, i265, i265);
    __ZmiRK8Scalar4fS1_(i87, i88, i93);
    __ZN8Scalar4faSERKS_(i271, i87) | 0;
    __Z5splatILj0EE8Scalar4fRKS0_(i96, i264);
    __ZplRK8Scalar4fS1_(i95, i96, i275);
    __ZN8Scalar4faSERKS_(i267, i95) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i98, i264);
    __ZplRK8Scalar4fS1_(i97, i98, i276);
    __ZN8Scalar4faSERKS_(i161, i97) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i100, i264);
    __ZplRK8Scalar4fS1_(i99, i100, i277);
    __ZN8Scalar4faSERKS_(i162, i99) | 0;
   }
  }
  __ZmlRK8Scalar4fS1_(i101, i268, i268);
  i3 = __Z10anyGreaterRK8Scalar4fS1_RS_(i101, i271, i255) | 0;
  __Z5splatILj3EE8Scalar4fRKS0_(i253, i259);
  __ZorRK8Scalar4fS1_(i104, i254, i255);
  __Z6simd4iRK8Scalar4f(i103, i104);
  __ZcoRK8Scalar4f(i102, i103);
  __ZanRK8Scalar4fRK14ComplementExprIS_E(i257, i253, i102);
  __ZcoRK8Scalar4f(i107, i257);
  __ZanRK8Scalar4fRK14ComplementExprIS_E(i106, i163, i107);
  __ZN8Scalar4faSERKS_(i163, i106) | 0;
  if (i3 | 0) {
   __Z5rsqrtRK8Scalar4f(i108, i271);
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i110, gb + 1097776 | 0);
   __ZgtRK8Scalar4fS1_(i109, i271, i110);
   __ZanRK8Scalar4fS1_(i293, i108, i109);
   __ZmlRK8Scalar4fS1_(i112, i270, i271);
   __ZmlRK8Scalar4fS1_(i111, i112, i293);
   __ZplRK8Scalar4fS1_(i252, i265, i111);
   __Z6simd4fRK8Scalar4f(i113, i259);
   __Z5splatILj1EE8Scalar4fRKS0_(i291, i113);
   __ZngRK8Scalar4f(i115, i291);
   __ZltRK8Scalar4fS1_(i114, i252, i115);
   __Z6simd4iRK8Scalar4f(i295, i114);
   __ZgtRK8Scalar4fS1_(i118, i252, i291);
   __Z6simd4iRK8Scalar4f(i319, i118);
   __ZmlRK8Scalar4fS1_(i119, i252, i261);
   __ZmiRK8Scalar4fS1_(i280, i275, i119);
   __ZmlRK8Scalar4fS1_(i120, i252, i262);
   __ZmiRK8Scalar4fS1_(i282, i276, i120);
   __ZmlRK8Scalar4fS1_(i121, i252, i263);
   __ZmiRK8Scalar4fS1_(i284, i277, i121);
   __Z6simd4fRK8Scalar4f(i122, i259);
   __Z5splatILj0EE8Scalar4fRKS0_(i328, i122);
   __ZmlRK8Scalar4fS1_(i124, i268, i293);
   __ZmlRK8Scalar4fS1_(i123, i124, i328);
   __ZmiRK8Scalar4fS1_(i325, i123, i328);
   __ZorRK8Scalar4fS1_(i129, i295, i319);
   __Z6simd4fRK8Scalar4f(i127, i129);
   __ZcoRK8Scalar4f(i126, i127);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i125, i255, i126);
   __ZN8Scalar4faSERKS_(i255, i125) | 0;
   if (__Z7anyTrueRK8Scalar4f(i255) | 0) {
    __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator3addERKS2_S6_S6_S6_S6_(i246, i280, i282, i284, i325, i255);
    if (i157) {
     i343 = HEAP32[(HEAP32[i156 >> 2] | 0) + 156 >> 2] | 0;
     i3 = HEAP32[i343 + (i1 << 3) + 4 >> 2] | 0;
     i342 = HEAP32[i164 >> 2] | 0;
     i341 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP32[i343 + (i1 << 3) >> 2] << 4;
     __Z11loadAlignedPKfj(i130, i342, i1);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i320, i130);
     __Z11loadAlignedPKfj(i131, i341, i1);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i321, i131);
     i3 = i3 << 4;
     __Z11loadAlignedPKfj(i132, i342, i3);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i322, i132);
     __Z11loadAlignedPKfj(i133, i341, i3);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i323, i133);
     __ZmiRK8Scalar4fS1_(i334, i321, i320);
     __ZmiRK8Scalar4fS1_(i335, i323, i322);
     __ZmiRK8Scalar4fS1_(i336, i335, i334);
     __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i136, gb + 1097728 | 0);
     __ZmlRK8Scalar4fS1_(i135, i265, i136);
     __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i137, gb + 1097728 | 0);
     __ZplRK8Scalar4fS1_(i134, i135, i137);
     __ZN8Scalar4faSERKS_(i265, i134) | 0;
     __Z5splatILj0EE8Scalar4fRKS0_(i138, i334);
     __Z5splatILj0EE8Scalar4fRKS0_(i141, i336);
     __ZmlRK8Scalar4fS1_(i140, i265, i141);
     __ZplRK8Scalar4fS1_(i337, i138, i140);
     __Z5splatILj1EE8Scalar4fRKS0_(i142, i334);
     __Z5splatILj1EE8Scalar4fRKS0_(i144, i336);
     __ZmlRK8Scalar4fS1_(i143, i265, i144);
     __ZplRK8Scalar4fS1_(i338, i142, i143);
     __Z5splatILj2EE8Scalar4fRKS0_(i145, i334);
     __Z5splatILj2EE8Scalar4fRKS0_(i147, i336);
     __ZmlRK8Scalar4fS1_(i146, i265, i147);
     __ZplRK8Scalar4fS1_(i339, i145, i146);
     __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_(i246, i337, i338, i339, i255);
    }
   }
  }
 } while ((i2 | 0) != 0);
 i343 = i326 + 16 | 0;
 __ZN8Scalar4fC2ERKS_(i247, i343);
 STACKTOP = i340;
 return;
}

function __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 28 | 0, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i10 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 280 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 284 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 288 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 292 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 296 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 96 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 112 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 268 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 272 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i6 + 276 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 144 | 0, i7);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 264 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 300 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 304 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 308 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i6 + 312 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 328 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 332 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 336 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 337 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 340 | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 364 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 360 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 372 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 316 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 376 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 377 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 378 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 379 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 380 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 381 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 382 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 384 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 386 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 387 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 388 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 389 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 390 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 391 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 392 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 393 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 394 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 412 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 413 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 395 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 414 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 415 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 416 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 417 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 418 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 419 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 424 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 396 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 397 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i3 = i6 + 400 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i1) HEAP32[i3 >> 2] = 1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 404 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i6 + 408 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 420 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 425 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 426 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 427 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 428 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 429 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 430 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 383 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 385 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 432 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 436 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 440 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 444 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 448 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 452 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 504 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 508 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 512 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 513 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 514 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 515 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 516 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 517 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 520 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN12AspectRatios8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 320 | 0, i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 556 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 572 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i7, i6 + 604 | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 624 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 628 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 629 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 630 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 44 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 64 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 80 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = i6 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN5Umbra20RuntimeTomeGenerator14generateHeaderERNS_7ImpTomeERNS0_6ResultEPKS3_(i46, i30, i9, i38) {
 i46 = i46 | 0;
 i30 = i30 | 0;
 i9 = i9 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i51 + 80 | 0;
 i49 = i51 + 56 | 0;
 i47 = i51 + 24 | 0;
 i48 = i51;
 HEAP32[i50 >> 2] = HEAP32[i46 >> 2];
 i8 = i50 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
 }
 HEAP32[i8 >> 2] = gb + 1451688;
 i2 = i50 + 8 | 0;
 i3 = i50 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 1451688;
 i4 = i50 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i50 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i50 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i50 + 36 >> 2] = -1;
 if (!(__ZN5Umbra20RuntimeTomeGenerator12makeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEE(i46, i50) | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i50 = HEAP32[i3 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i1 + -16 | 0);
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i50 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i1 + -16 | 0);
  }
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i7 = __ZN5Umbra20RuntimeTomeGenerator17serializeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEERNS_7ImpTomeE(i46, i50, i30) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i45 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i1 + -16 | 0);
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i45 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i1 + -16 | 0);
 }
 if (!i7) {
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 HEAP32[i30 >> 2] = -704643054;
 i39 = i30 + 20 | 0;
 i44 = i46 + 104 | 0;
 HEAP32[i39 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 i39 = i30 + 32 | 0;
 i44 = i46 + 116 | 0;
 HEAP32[i39 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 i39 = i46 + 192 | 0;
 i44 = HEAP32[i39 >> 2] | 0;
 HEAP32[i30 + 144 >> 2] = i44;
 i35 = i30 + 12 | 0;
 HEAPF32[i35 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i24 = i30 + 124 | 0;
 HEAP32[i24 >> 2] = 0;
 i36 = i46 + 60 | 0;
 i45 = HEAP32[i36 >> 2] | 0;
 HEAP32[i30 + 176 >> 2] = i45;
 i25 = i46 + 300 | 0;
 if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i25, i44 + i45 << 5, 65536) | 0)) {
  HEAP32[i46 + 464 >> 2] = 1;
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i1 = HEAP32[i36 >> 2] | 0;
 if (!i1) {
  i26 = i46 + 444 | 0;
  i29 = i46 + 432 | 0;
  i27 = i46 + 452 | 0;
 } else {
  i43 = i1 << 5;
  i27 = i46 + 452 | 0;
  i26 = i46 + 444 | 0;
  i29 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i45 = HEAP32[i29 >> 2] | 0;
  _memset(i45 | 0, 0, i43 | 0) | 0;
  HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + i43;
  i29 = i46 + 432 | 0;
  i44 = HEAP32[i29 >> 2] | 0;
  HEAP32[i9 + 12 >> 2] = (HEAP32[i46 + 304 + (i44 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i44 << 3) >> 2] | 0);
  i44 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
  HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + i43;
  HEAP32[i46 + 456 >> 2] = i45;
 }
 i45 = HEAP32[i39 >> 2] << 5;
 i37 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i28 = HEAP32[i37 >> 2] | 0;
 _memset(i28 | 0, 0, i45 | 0) | 0;
 HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + i45;
 i37 = HEAP32[i29 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = (HEAP32[i46 + 304 + (i37 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i37 << 3) >> 2] | 0);
 i37 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
 HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + i45;
 i37 = i46 + 460 | 0;
 HEAP32[i37 >> 2] = i28;
 _memset(i28 | 0, 0, HEAP32[i39 >> 2] << 5 | 0) | 0;
 i28 = i46 + 436 | 0;
 HEAP8[i28 >> 0] = 0;
 i45 = HEAP32[i46 >> 2] | 0;
 HEAP32[i50 >> 2] = i45;
 if (!i45) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i50 >> 2] = gb + 1451688;
 }
 i44 = i50 + 4 | 0;
 HEAP32[i44 >> 2] = 0;
 i45 = i50 + 8 | 0;
 HEAP32[i45 >> 2] = 0;
 i21 = i50 + 12 | 0;
 HEAP32[i21 >> 2] = -1;
 i22 = i50 + 16 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i50 + 20 | 0;
 HEAP32[i23 >> 2] = 0;
 L37 : do if (__ZN5Umbra20RuntimeTomeGenerator13outputObjectsERNS_7ImpTomeERNS_4HashIjiEE(i46, i30, i50) | 0) {
  i3 = HEAP32[i36 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i4 = HEAP32[i46 + 56 >> 2] | 0;
   i1 = 0;
   i2 = 0;
   do {
    i43 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    i1 = ((((HEAP32[i43 + 44 >> 2] | 0) >>> 5) + 3 & 268435452) + ((HEAP32[i43 + 64 >> 2] | 0) + 3 & 1073741820) + ((HEAP32[i43 + 104 >> 2] | 0) + 3 & 1073741820) << 2) + i1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i3 | 0));
  } else i1 = 0;
  if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i25, i1, 65536) | 0)) {
   HEAP32[i46 + 464 >> 2] = 1;
   i2 = 0;
   break;
  }
  i2 = HEAP32[i46 >> 2] | 0;
  if (!i2) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
   i43 = gb + 1451688 | 0;
  } else i43 = gb + 1451688 | 0; else i43 = i2;
  i1 = HEAP32[i36 >> 2] | 0;
  do if ((i1 | 0) > 0) {
   i1 = i1 << 1;
   i1 = (i1 | 0) > 16 ? i1 : 16;
   i2 = mftCall_iiii(HEAP32[(HEAP32[i43 >> 2] | 0) + 8 >> 2] | 0, i43 | 0, (i1 << 2) + 16 | 0, 0) | 0;
   if (!i2) {
    HEAP32[i46 + 464 >> 2] = 1;
    i2 = 0;
    break L37;
   } else {
    HEAP32[i2 >> 2] = i1;
    i42 = i2 + 16 | 0;
    i1 = HEAP32[i46 >> 2] | 0;
    break;
   }
  } else {
   i42 = 0;
   i1 = i2;
  } while (0);
  HEAP32[i49 >> 2] = i1;
  if (!i1) {
   if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
    HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
    HEAP32[gb + 1451688 + 8 >> 2] = 1;
   }
   HEAP32[i49 >> 2] = gb + 1451688;
  }
  i40 = i49 + 4 | 0;
  HEAP32[i40 >> 2] = 0;
  i41 = i49 + 8 | 0;
  HEAP32[i41 >> 2] = 0;
  i31 = i49 + 12 | 0;
  HEAP32[i31 >> 2] = -1;
  i32 = i49 + 16 | 0;
  HEAP32[i32 >> 2] = 0;
  i33 = i49 + 20 | 0;
  HEAP32[i33 >> 2] = 0;
  if ((HEAP32[i36 >> 2] | 0) > 0) {
   i19 = i46 + 456 | 0;
   i20 = i46 + 56 | 0;
   i18 = 0;
   i1 = HEAP32[i20 >> 2] | 0;
   do {
    i9 = HEAP32[i19 >> 2] | 0;
    i2 = i1 + (i18 << 2) | 0;
    HEAP32[i9 + (i18 << 5) >> 2] = HEAP32[i2 >> 2];
    i2 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] << 2) + 15 & -16;
    i1 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
    i8 = HEAP32[i1 >> 2] | 0;
    _memset(i8 | 0, 0, i2 | 0) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
    i1 = HEAP32[i29 >> 2] | 0;
    HEAP32[i9 + (i18 << 5) + 8 >> 2] = (HEAP32[i46 + 304 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i1 << 3) >> 2] | 0);
    i1 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = ((HEAP32[(HEAP32[(HEAP32[i20 >> 2] | 0) + (i18 << 2) >> 2] | 0) + 44 >> 2] | 0) >>> 5 << 2) + 15 & 1073741808;
    i9 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
    i16 = HEAP32[i9 >> 2] | 0;
    _memset(i16 | 0, 0, i2 | 0) | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i2;
    i9 = HEAP32[i29 >> 2] | 0;
    HEAP32[i1 + (i18 << 5) + 12 >> 2] = (HEAP32[i46 + 304 + (i9 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i9 << 3) >> 2] | 0);
    i1 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = (HEAP32[(HEAP32[(HEAP32[i20 >> 2] | 0) + (i18 << 2) >> 2] | 0) + 104 >> 2] << 2) + 15 & -16;
    i9 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
    i17 = HEAP32[i9 >> 2] | 0;
    _memset(i17 | 0, 0, i2 | 0) | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i2;
    i9 = HEAP32[i29 >> 2] | 0;
    HEAP32[i1 + (i18 << 5) + 16 >> 2] = (HEAP32[i46 + 304 + (i9 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i9 << 3) >> 2] | 0);
    i1 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
    i1 = HEAP32[i20 >> 2] | 0;
    i2 = HEAP32[i1 + (i18 << 2) >> 2] | 0;
    i9 = i2 + 64 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i3 | 0) > 0) {
     i11 = i2 + 76 | 0;
     i12 = i2 + 64 | 0;
     i13 = i2 + 80 | 0;
     i14 = HEAP32[i44 >> 2] | 0;
     i15 = HEAP32[i45 >> 2] | 0;
     i7 = 0;
     do {
      i5 = HEAP32[i11 >> 2] | 0;
      i4 = (i5 | 0) == 0;
      i5 = i2 + i5 | 0;
      do if (i4 | (i5 | 0) == 0) {
       if ((HEAP32[i12 >> 2] | 0) <= (i7 | 0)) break;
       if (!i4) {
        i4 = -1;
        i34 = 52;
        break;
       }
       i4 = HEAP32[i13 >> 2] | 0;
       i4 = HEAP32[((i4 | 0) == 0 ? 0 : i2 + i4 | 0) + (i7 << 2) >> 2] | 0;
       i34 = 52;
      } else {
       i6 = HEAP32[i5 + (i7 << 2) >> 2] | 0;
       i4 = (HEAP32[i5 + (i7 + 1 << 2) >> 2] | 0) - i6 | 0;
       if ((i4 | 0) > 0) {
        i4 = HEAP32[i13 >> 2] | 0;
        i4 = HEAP32[((i4 | 0) == 0 ? 0 : i2 + i4 | 0) + (i6 << 2) >> 2] | 0;
        i34 = 52;
        break;
       } else if (!i4) break; else {
        i4 = 0;
        i34 = 52;
        break;
       }
      } while (0);
      if ((i34 | 0) == 52) {
       i34 = 0;
       i3 = HEAP32[i14 + (((i4 >>> 5) + i4 + (i4 >>> 10) + (i4 >>> 20) & (HEAP32[i22 >> 2] | 0) + -1) << 2) >> 2] | 0;
       if ((HEAP32[i15 + (i3 * 12 | 0) + 4 >> 2] | 0) != (i4 | 0)) do i3 = HEAP32[i15 + (i3 * 12 | 0) >> 2] | 0; while ((HEAP32[i15 + (i3 * 12 | 0) + 4 >> 2] | 0) != (i4 | 0));
       HEAP32[i8 + (i7 << 2) >> 2] = HEAP32[i15 + (i3 * 12 | 0) + 8 >> 2];
       i3 = HEAP32[i9 >> 2] | 0;
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (i3 | 0));
    }
    if ((HEAP32[i2 + 104 >> 2] | 0) > 0) {
     i7 = 0;
     do {
      i6 = HEAP32[i2 + 108 >> 2] | 0;
      i6 = HEAP32[((i6 | 0) == 0 ? 0 : i2 + i6 | 0) + (i7 << 2) >> 2] | 0;
      i5 = HEAP32[i32 >> 2] | 0;
      L90 : do if (!i5) i34 = 64; else {
       i2 = (HEAP32[i40 >> 2] | 0) + (((i6 >>> 5) + i6 + (i6 >>> 10) + (i6 >>> 20) & i5 + -1) << 2) | 0;
       if (!i2) {
        i34 = 64;
        break;
       }
       i2 = HEAP32[i2 >> 2] | 0;
       if ((i2 | 0) == -1) {
        i34 = 64;
        break;
       }
       i3 = HEAP32[i41 >> 2] | 0;
       while (1) {
        if ((HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) break;
        i2 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
        if ((i2 | 0) == -1) {
         i34 = 64;
         break L90;
        }
       }
       i2 = i3 + (i2 * 12 | 0) + 8 | 0;
      } while (0);
      if ((i34 | 0) == 64) {
       i34 = 0;
       i4 = HEAP32[i33 >> 2] | 0;
       i2 = HEAP32[i31 >> 2] | 0;
       if ((i2 | 0) == -1) {
        __ZN5Umbra4HashIjiE6rehashEj(i49, 0) | 0;
        i1 = HEAP32[i20 >> 2] | 0;
        i3 = HEAP32[i31 >> 2] | 0;
        i2 = HEAP32[i32 >> 2] | 0;
       } else {
        i3 = i2;
        i2 = i5;
       }
       i15 = HEAP32[i41 >> 2] | 0;
       i14 = i15 + (i3 * 12 | 0) | 0;
       HEAP32[i31 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i15 + (i3 * 12 | 0) + 4 >> 2] = i6;
       i15 = i15 + (i3 * 12 | 0) + 8 | 0;
       HEAP32[i15 >> 2] = i4;
       i2 = (HEAP32[i40 >> 2] | 0) + ((i2 + -1 & (i6 >>> 5) + i6 + (i6 >>> 10) + (i6 >>> 20)) << 2) | 0;
       HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i2 >> 2] = i3;
       HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + 1;
       i2 = i15;
      }
      HEAP32[i17 + (i7 << 2) >> 2] = HEAP32[i2 >> 2];
      i7 = i7 + 1 | 0;
      i2 = HEAP32[i1 + (i18 << 2) >> 2] | 0;
     } while ((i7 | 0) < (HEAP32[i2 + 104 >> 2] | 0));
    }
    HEAP32[i42 + (i18 << 2) >> 2] = i16;
    i1 = HEAP32[i20 >> 2] | 0;
    i17 = HEAP32[i1 + (i18 << 2) >> 2] | 0;
    HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + (HEAP32[i17 + 124 >> 2] | 0);
    f10 = Math_fround(HEAPF32[i17 + 12 >> 2]);
    HEAPF32[i47 >> 2] = f10;
    i17 = Math_fround(HEAPF32[i35 >> 2]) <= f10;
    HEAP32[i35 >> 2] = HEAP32[(i17 ? i35 : i47) >> 2];
    i18 = i18 + 1 | 0;
   } while ((i18 | 0) < (HEAP32[i36 >> 2] | 0));
  }
  HEAP8[i28 >> 0] = 0;
  i1 = HEAP32[i44 >> 2] | 0;
  if (i1 | 0) {
   i34 = HEAP32[i50 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 12 >> 2] | 0, i34 | 0, i1 + -16 | 0);
  }
  i1 = HEAP32[i45 >> 2] | 0;
  if (i1 | 0) {
   i34 = HEAP32[i50 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 12 >> 2] | 0, i34 | 0, i1 + -16 | 0);
  }
  HEAP32[i44 >> 2] = 0;
  HEAP32[i45 >> 2] = 0;
  HEAP32[i21 >> 2] = -1;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i23 >> 2] = 0;
  i34 = HEAP32[i33 >> 2] | 0;
  i1 = i30 + 104 | 0;
  HEAP32[i1 >> 2] = i34;
  L112 : do if (__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i25, (i34 << 2) + 52 + (HEAP32[i39 >> 2] << 3) | 0, 65536) | 0) {
   i34 = (HEAP32[i1 >> 2] << 2) + 15 & -16;
   i1 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i8 = HEAP32[i1 >> 2] | 0;
   _memset(i8 | 0, 0, i34 | 0) | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i34;
   i1 = HEAP32[i29 >> 2] | 0;
   HEAP32[i30 + 108 >> 2] = (HEAP32[i46 + 304 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i1 << 3) >> 2] | 0);
   i1 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i34;
   i1 = (HEAP32[i39 >> 2] << 2) + 15 & -16;
   i34 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i13 = HEAP32[i34 >> 2] | 0;
   _memset(i13 | 0, 0, i1 | 0) | 0;
   HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1;
   i34 = HEAP32[i29 >> 2] | 0;
   HEAP32[i30 + 156 >> 2] = (HEAP32[i46 + 304 + (i34 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i34 << 3) >> 2] | 0);
   i34 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
   HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1;
   i34 = (HEAP32[i39 >> 2] << 2) + 19 & -16;
   i1 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i27 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   _memset(i7 | 0, 0, i34 | 0) | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i34;
   i1 = HEAP32[i29 >> 2] | 0;
   HEAP32[i30 + 136 >> 2] = (HEAP32[i46 + 304 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i46 + 304 + (i1 << 3) >> 2] | 0);
   i1 = i46 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i34;
   HEAP8[i28 >> 0] = 0;
   i1 = HEAP32[i39 >> 2] | 0;
   if ((i1 | 0) > 0) {
    i4 = HEAP32[i46 + 148 >> 2] | 0;
    i5 = i46 + 76 | 0;
    i6 = i46 + 68 | 0;
    i3 = 0;
    i2 = 0;
    do {
     i1 = i4 + (i3 << 2) | 0;
     do if ((HEAP32[i1 >> 2] | 0) >= 0) {
      HEAP32[i7 + (i3 << 2) >> 2] = i2;
      i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i5 >> 2] | 0) > (i1 | 0)) {
       i2 = (HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 5) >> 2] | 0) + 52 >> 2] & 65535) + i2 | 0;
       break;
      } else {
       i2 = i2 + 1 | 0;
       break;
      }
     } while (0);
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i39 >> 2] | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else i2 = 0;
   HEAP32[i7 + (i1 << 2) >> 2] = i2;
   i3 = HEAP32[i32 >> 2] | 0;
   i5 = HEAP32[i40 >> 2] | 0;
   L125 : do if (!i3) {
    i1 = 0;
    i2 = -1;
   } else {
    i2 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) > 0 & (i2 | 0) == -1) i1 = 0; else {
     i1 = 0;
     break;
    }
    do {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) {
      i2 = -1;
      break L125;
     }
     i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == -1);
   } while (0);
   i4 = HEAP32[i41 >> 2] | 0;
   L131 : while (1) {
    while (1) {
     do {
      if (!((i2 | 0) != -1 & (i1 | 0) < (i3 | 0))) break L131;
      HEAP32[i8 + (HEAP32[i4 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2];
      i2 = HEAP32[i4 + (i2 * 12 | 0) >> 2] | 0;
      i3 = HEAP32[i32 >> 2] | 0;
     } while ((i2 | 0) != -1);
     if ((i1 | 0) < (i3 | 0)) break; else i2 = -1;
    }
    while (1) {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) {
      i2 = -1;
      continue L131;
     }
     i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
     if ((i2 | 0) != -1) continue L131;
    }
   }
   if (i5 | 0) {
    i34 = HEAP32[i49 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 12 >> 2] | 0, i34 | 0, i5 + -16 | 0);
   }
   i1 = HEAP32[i41 >> 2] | 0;
   if (i1 | 0) {
    i34 = HEAP32[i49 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 12 >> 2] | 0, i34 | 0, i1 + -16 | 0);
   }
   HEAP32[i40 >> 2] = 0;
   HEAP32[i41 >> 2] = 0;
   HEAP32[i31 >> 2] = -1;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i33 >> 2] = 0;
   i2 = HEAP32[i39 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i3 = HEAP32[i37 >> 2] | 0;
    i1 = 0;
    do {
     HEAPF32[i13 + (i1 << 2) >> 2] = Math_fround(1.0);
     HEAP32[i3 + (i1 << 5) >> 2] = -1;
     HEAP32[i3 + (i1 << 5) + 4 >> 2] = 0;
     HEAP32[i3 + (i1 << 5) + 16 >> 2] = -1;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i2 | 0));
   }
   i1 = HEAP32[i36 >> 2] | 0;
   L154 : do if (i1 | 0) {
    i8 = i46 + 76 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i2 | 0) <= 0) break;
    i9 = i46 + 56 | 0;
    i11 = i46 + 68 | 0;
    i12 = i46 + 164 | 0;
    i7 = 0;
    f10 = Math_fround(0.0);
    i3 = 0;
    i4 = 0;
    i5 = -1;
    i6 = HEAP32[i46 + 132 >> 2] | 0;
    while (1) {
     do if ((i5 | 0) < (i1 + -1 | 0)) {
      if ((i7 | 0) < (HEAP32[i6 >> 2] | 0)) break;
      i5 = i5 + 1 | 0;
      i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] | 0;
      i3 = HEAP32[i4 + 156 >> 2] | 0;
      f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
      f10 = Math_fround(f10 / Math_fround(HEAPF32[i35 >> 2]));
      i3 = (i3 | 0) == 0 ? 0 : i4 + i3 | 0;
      i4 = 0;
      i6 = i6 + 4 | 0;
     } while (0);
     if ((i7 | 0) < (i2 | 0)) i1 = (HEAP32[i11 >> 2] | 0) + (i7 << 5) + 4 | 0; else i1 = (HEAP32[i12 >> 2] | 0) + ((i7 - i2 | 0) * 40 | 0) + 24 | 0;
     i1 = HEAP32[i1 >> 2] | 0;
     i2 = (HEAP32[i42 + (i5 << 2) >> 2] | 0) + (i4 << 2) | 0;
     if ((i1 | 0) < 0) HEAP32[i2 >> 2] = 0; else {
      HEAP32[i2 >> 2] = i1;
      HEAPF32[i13 + (i1 << 2) >> 2] = Math_fround(f10 * Math_fround(HEAPF32[i3 + (i4 << 2) >> 2]));
      i34 = HEAP32[i37 >> 2] | 0;
      HEAP32[i34 + (i1 << 5) >> 2] = i5;
      HEAP32[i34 + (i1 << 5) + 8 >> 2] = 0;
      HEAP32[i34 + (i1 << 5) + 12 >> 2] = 0;
      i33 = HEAP32[i11 >> 2] | 0;
      HEAP32[i34 + (i1 << 5) + 4 >> 2] = HEAP32[i33 + (i7 << 5) + 20 >> 2];
      HEAP32[i34 + (i1 << 5) + 16 >> 2] = HEAP32[i33 + (i7 << 5) + 8 >> 2];
     }
     i1 = i7 + 1 | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((i1 | 0) >= (i2 | 0)) break L154;
     i7 = i1;
     i4 = i4 + 1 | 0;
     i1 = HEAP32[i36 >> 2] | 0;
    }
   } while (0);
   i7 = i46 + 172 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i4 = HEAP32[i46 + 164 >> 2] | 0;
    i2 = HEAP32[i37 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (HEAP32[i4 + (i1 * 40 | 0) + 24 >> 2] << 5) + 4 >> 2] = HEAP32[i4 + (i1 * 40 | 0) + 28 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i3 | 0));
   }
   L178 : do if (i38 | 0) {
    i24 = HEAP32[i38 + 4 >> 2] | 0;
    if (!i24) break;
    i2 = (HEAP32[i24 + 44 >> 2] | 0) >>> 5;
    i6 = HEAP32[i24 + 48 >> 2] | 0;
    i6 = (i6 | 0) == 0 ? 0 : i24 + i6 | 0;
    i1 = HEAP32[i24 + 60 >> 2] | 0;
    HEAP32[i47 >> 2] = i2;
    HEAP32[i47 + 4 >> 2] = i6;
    HEAP32[i47 + 8 >> 2] = i6 + (((i2 << 1) + 31 | 0) >>> 5 << 2);
    HEAP32[i47 + 12 >> 2] = i24;
    HEAP32[i47 + 16 >> 2] = i1;
    HEAP32[i47 + 20 >> 2] = 4;
    HEAP32[i47 + 24 >> 2] = i2;
    i1 = HEAP32[i46 >> 2] | 0;
    i6 = i46 + 228 | 0;
    HEAP32[i6 >> 2] = i1;
    if (!i1) {
     if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
      HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
      HEAP32[gb + 1451688 + 8 >> 2] = 1;
     }
     HEAP32[i6 >> 2] = gb + 1451688;
     i3 = i46 + 244 | 0;
     HEAP32[i3 >> 2] = i1;
     if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
      HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
      HEAP32[gb + 1451688 + 8 >> 2] = 1;
     }
     HEAP32[i3 >> 2] = gb + 1451688;
     i1 = gb + 1451688 | 0;
    } else {
     i3 = i46 + 244 | 0;
     HEAP32[i3 >> 2] = i1;
    }
    i4 = i46 + 236 | 0;
    do if ((HEAP32[i4 >> 2] | 0) < (i2 | 0)) {
     i5 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
     if (!i5) {
      i34 = 133;
      break;
     }
     HEAP32[i5 >> 2] = i2;
     HEAP32[i4 >> 2] = i2;
     i1 = i46 + 232 | 0;
     i4 = HEAP32[i1 >> 2] | 0;
     if (i4 | 0) {
      i38 = HEAP32[i6 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i38 >> 2] | 0) + 12 >> 2] | 0, i38 | 0, i4 + -16 | 0);
     }
     HEAP32[i1 >> 2] = i5 + 16;
     i34 = 126;
    } else i34 = 126; while (0);
    L197 : do if ((i34 | 0) == 126) {
     i6 = i46 + 240 | 0;
     HEAP32[i6 >> 2] = i2;
     i1 = HEAP32[i39 >> 2] | 0;
     i4 = i46 + 252 | 0;
     if ((HEAP32[i4 >> 2] | 0) < (i1 | 0)) {
      i5 = HEAP32[i3 >> 2] | 0;
      i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, (i1 << 2) + 16 | 0, 0) | 0;
      if (!i5) {
       i34 = 133;
       break;
      }
      HEAP32[i5 >> 2] = i1;
      HEAP32[i4 >> 2] = i1;
      i2 = i46 + 248 | 0;
      i4 = HEAP32[i2 >> 2] | 0;
      if (i4 | 0) {
       i39 = HEAP32[i3 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 12 >> 2] | 0, i39 | 0, i4 + -16 | 0);
      }
      HEAP32[i2 >> 2] = i5 + 16;
      i2 = HEAP32[i6 >> 2] | 0;
     }
     i3 = i46 + 256 | 0;
     HEAP32[i3 >> 2] = i1;
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i46 + 232 >> 2] | 0;
      i1 = 0;
      do {
       HEAP32[i2 + (i1 << 2) >> 2] = -1;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
      i1 = HEAP32[i3 >> 2] | 0;
     }
     if ((i1 | 0) > 0) {
      i2 = HEAP32[i46 + 248 >> 2] | 0;
      i1 = 0;
      do {
       HEAP32[i2 + (i1 << 2) >> 2] = -1;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
     }
     i1 = HEAP32[i46 >> 2] | 0;
     do if (!i1) {
      if (HEAP32[gb + 1451688 + 8 >> 2] | 0) {
       i23 = gb + 1451688 | 0;
       break;
      }
      HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
      HEAP32[gb + 1451688 + 8 >> 2] = 1;
      i23 = gb + 1451688 | 0;
     } else i23 = i1; while (0);
     i20 = i46 + 76 | 0;
     i21 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i20 >> 2] | 0) | 0;
     do if ((i21 | 0) > 0) {
      i11 = i21 << 1;
      i11 = (i11 | 0) > 16 ? i11 : 16;
      i22 = mftCall_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0, i23 | 0, (i11 << 2) + 16 | 0, 0) | 0;
      if (!i22) {
       HEAP32[i46 + 464 >> 2] = 1;
       break L197;
      }
      HEAP32[i22 >> 2] = i11;
      i1 = i22 + 16 | 0;
      i18 = i46 + 68 | 0;
      i12 = i24 + 20 | 0;
      i13 = i24 + 24 | 0;
      i14 = i24 + 28 | 0;
      i15 = i24 + 32 | 0;
      i16 = i24 + 36 | 0;
      i17 = i24 + 40 | 0;
      i19 = i46 + 164 | 0;
      i9 = 0;
      i2 = 0;
      do {
       i3 = HEAP32[i20 >> 2] | 0;
       do if ((i9 | 0) < (i3 | 0)) {
        if (!(HEAP32[(HEAP32[i18 >> 2] | 0) + (i9 << 5) >> 2] | 0)) break;
        i8 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i9 << 5) >> 2] | 0;
        i3 = i8;
        i4 = i8 + 16 | 0;
        i5 = i8 + 20 | 0;
        i6 = i8 + 4 | 0;
        i7 = i8 + 8 | 0;
        i8 = i8 + 12 | 0;
        i34 = 156;
       } else {
        i8 = i9 - i3 | 0;
        i34 = HEAP32[i19 >> 2] | 0;
        i3 = i34 + (i8 * 40 | 0) | 0;
        i4 = i34 + (i8 * 40 | 0) + 16 | 0;
        i5 = i34 + (i8 * 40 | 0) + 20 | 0;
        i6 = i34 + (i8 * 40 | 0) + 4 | 0;
        i7 = i34 + (i8 * 40 | 0) + 8 | 0;
        i8 = i34 + (i8 * 40 | 0) + 12 | 0;
        i34 = 156;
       } while (0);
       do if ((i34 | 0) == 156) {
        i34 = 0;
        f53 = Math_fround(HEAPF32[i12 >> 2]);
        f55 = Math_fround(HEAPF32[i13 >> 2]);
        f58 = Math_fround(HEAPF32[i14 >> 2]);
        f10 = Math_fround(HEAPF32[i15 >> 2]);
        f57 = Math_fround(HEAPF32[i16 >> 2]);
        f54 = Math_fround(HEAPF32[i3 >> 2]);
        f56 = Math_fround(HEAPF32[i6 >> 2]);
        f59 = Math_fround(HEAPF32[i7 >> 2]);
        f52 = Math_fround(HEAPF32[i8 >> 2]);
        if (!(f59 >= f58) | (!(Math_fround(HEAPF32[i4 >> 2]) <= f57) | (!(f56 >= f55) | (!(f54 >= f53) | !(f52 <= f10))))) break;
        f59 = Math_fround(HEAPF32[i17 >> 2]);
        if (!(Math_fround(HEAPF32[i5 >> 2]) <= f59)) break;
        HEAP32[i1 + (i2 << 2) >> 2] = i9;
        i2 = i2 + 1 | 0;
       } while (0);
       i9 = i9 + 1 | 0;
      } while ((i9 | 0) != (i21 | 0));
      if ((i11 | 0) >= (i2 | 0)) {
       i34 = 161;
       break;
      }
      i3 = i2 << 1;
      i3 = (i3 | 0) > 16 ? i3 : 16;
      i4 = mftCall_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0, i23 | 0, (i3 << 2) + 16 | 0, 0) | 0;
      if (!i4) {
       HEAP32[i46 + 464 >> 2] = 1;
       i2 = 1;
       break;
      }
      HEAP32[i4 >> 2] = i3;
      i5 = i4 + 16 | 0;
      do if (i21 | 0) {
       i4 = (i21 | 0) <= (i2 | 0) ? i21 : i2;
       if ((i4 | 0) > 0) i3 = 0; else break;
       do {
        HEAP32[i5 + (i3 << 2) >> 2] = HEAP32[i1 + (i3 << 2) >> 2];
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i4 | 0));
      } while (0);
      mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i22 | 0);
      i1 = i5;
      i34 = 161;
     } else {
      i2 = 0;
      i1 = 0;
      i34 = 161;
     } while (0);
     if ((i34 | 0) == 161) {
      i37 = i24 + 20 | 0;
      i38 = i24 + 32 | 0;
      i39 = i48 + 12 | 0;
      HEAP32[i48 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i48 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i48 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
      HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
      __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE(i46, i24, i47, 0, i1, i2, i48);
      i2 = 0;
     }
     if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 + -16 | 0);
     if (!i2) break L178; else {
      i2 = 0;
      break L112;
     }
    } while (0);
    if ((i34 | 0) == 133) HEAP32[i46 + 464 >> 2] = 1;
    i2 = 0;
    break L112;
   } while (0);
   i2 = 1;
  } else {
   HEAP32[i46 + 464 >> 2] = 1;
   i2 = 0;
  } while (0);
  i1 = HEAP32[i40 >> 2] | 0;
  if (i1 | 0) {
   i48 = HEAP32[i49 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i48 >> 2] | 0) + 12 >> 2] | 0, i48 | 0, i1 + -16 | 0);
  }
  i1 = HEAP32[i41 >> 2] | 0;
  if (i1 | 0) {
   i49 = HEAP32[i49 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 + -16 | 0);
  }
  if (!i42) break;
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 12 >> 2] | 0, i43 | 0, i42 + -16 | 0);
 } else i2 = 0; while (0);
 i1 = HEAP32[i44 >> 2] | 0;
 if (i1 | 0) {
  i49 = HEAP32[i50 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 + -16 | 0);
 }
 i1 = HEAP32[i45 >> 2] | 0;
 if (i1 | 0) {
  i50 = HEAP32[i50 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i1 + -16 | 0);
 }
 i50 = i2;
 STACKTOP = i51;
 return i50 | 0;
}

function __ZN5physx2Gu22pcmContactConvexConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i31, i32, i6, i7, i5, i1, i64) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i64 = i64 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 880 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i66 + 868 | 0;
 i38 = i66 + 752 | 0;
 i35 = i66 + 528 | 0;
 i36 = i66 + 304 | 0;
 i52 = i66 + 288 | 0;
 i57 = i66 + 256 | 0;
 i65 = i66 + 224 | 0;
 i39 = i66 + 768 | 0;
 i67 = i66 + 208 | 0;
 i47 = i66 + 192 | 0;
 i33 = i66 + 176 | 0;
 i34 = i66 + 160 | 0;
 i53 = i66 + 544 | 0;
 i54 = i66 + 320 | 0;
 i40 = i66 + 144 | 0;
 i41 = i66 + 128 | 0;
 i55 = i66 + 112 | 0;
 i46 = i66 + 96 | 0;
 i56 = i66 + 864 | 0;
 i44 = i66 + 80 | 0;
 i42 = i66 + 64 | 0;
 i48 = i66 + 848 | 0;
 i45 = i66 + 48 | 0;
 i43 = i66 + 32 | 0;
 i59 = i66 + 16 | 0;
 i49 = i66 + 832 | 0;
 i58 = i66;
 i63 = HEAP32[i1 >> 2] | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 i14 = i31 + 4 | 0;
 i15 = i31 + 8 | 0;
 i73 = HEAP32[i15 >> 2] | 0;
 i8 = i31 + 12 | 0;
 i19 = HEAP32[i8 >> 2] | 0;
 HEAP32[i35 >> 2] = HEAP32[i14 >> 2];
 i74 = i35 + 4 | 0;
 HEAP32[i74 >> 2] = i73;
 i73 = i35 + 8 | 0;
 HEAP32[i73 >> 2] = i19;
 HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
 i19 = i32 + 4 | 0;
 i20 = i32 + 8 | 0;
 i30 = HEAP32[i20 >> 2] | 0;
 i29 = i32 + 12 | 0;
 i17 = HEAP32[i29 >> 2] | 0;
 HEAP32[i36 >> 2] = HEAP32[i19 >> 2];
 i50 = i36 + 4 | 0;
 HEAP32[i50 >> 2] = i30;
 i30 = i36 + 8 | 0;
 HEAP32[i30 >> 2] = i17;
 HEAPF32[i36 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i52 >> 2] = HEAP32[i5 >> 2];
 i17 = HEAP32[i6 + 4 >> 2] | 0;
 i16 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i24 = i6 + 16 | 0;
 i26 = HEAP32[i24 >> 2] | 0;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i24 = HEAP32[i24 + 8 >> 2] | 0;
 HEAP32[i57 >> 2] = HEAP32[i6 >> 2];
 i18 = i57 + 4 | 0;
 HEAP32[i18 >> 2] = i17;
 i17 = i57 + 8 | 0;
 HEAP32[i17 >> 2] = i16;
 i16 = i57 + 12 | 0;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i57 + 16 >> 2] = i26;
 HEAP32[i57 + 20 >> 2] = i25;
 HEAP32[i57 + 24 >> 2] = i24;
 HEAPF32[i57 + 28 >> 2] = Math_fround(0.0);
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i28 = HEAP32[i7 + 8 >> 2] | 0;
 i27 = HEAP32[i7 + 12 >> 2] | 0;
 i21 = i7 + 16 | 0;
 i23 = HEAP32[i21 >> 2] | 0;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i21 = HEAP32[i21 + 8 >> 2] | 0;
 HEAP32[i65 >> 2] = i6;
 i60 = i65 + 4 | 0;
 HEAP32[i60 >> 2] = i1;
 i61 = i65 + 8 | 0;
 HEAP32[i61 >> 2] = i28;
 i62 = i65 + 12 | 0;
 HEAP32[i62 >> 2] = i27;
 HEAP32[i65 + 16 >> 2] = i23;
 HEAP32[i65 + 20 >> 2] = i22;
 HEAP32[i65 + 24 >> 2] = i21;
 HEAPF32[i65 + 28 >> 2] = Math_fround(0.0);
 f72 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f78 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f69 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f72 = Math_fround(-f72);
 f78 = Math_fround(-f78);
 f13 = Math_fround(-f13);
 f9 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f70 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f77 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f80 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f77 = Math_fround(f9 - f77);
 f80 = Math_fround(f70 - f80);
 f2 = Math_fround(f2 - (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f70 = Math_fround(Math_fround(f69 * f69) + Math_fround(-.5));
 f9 = Math_fround(Math_fround(Math_fround(f77 * f72) + Math_fround(f80 * f78)) + Math_fround(f2 * f13));
 f3 = Math_fround(Math_fround(Math_fround(f9 * f72) + Math_fround(Math_fround(f70 * f77) + Math_fround(f69 * Math_fround(Math_fround(f2 * f78) - Math_fround(f80 * f13))))) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(Math_fround(f9 * f78) + Math_fround(Math_fround(f70 * f80) + Math_fround(f69 * Math_fround(Math_fround(f77 * f13) - Math_fround(f2 * f72))))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f70 * f2) + Math_fround(f69 * Math_fround(Math_fround(f80 * f72) - Math_fround(f77 * f78)))) + Math_fround(f9 * f13)) * Math_fround(2.0));
 f77 = Math_fround(HEAPF32[i57 >> 2]);
 f80 = Math_fround(HEAPF32[i18 >> 2]);
 f2 = Math_fround(HEAPF32[i17 >> 2]);
 f70 = Math_fround(HEAPF32[i16 >> 2]);
 f10 = Math_fround(Math_fround(f69 * f70) - Math_fround(Math_fround(Math_fround(f77 * f72) + Math_fround(f80 * f78)) + Math_fround(f2 * f13)));
 f11 = Math_fround(Math_fround(Math_fround(f2 * f78) - Math_fround(f80 * f13)) + Math_fround(Math_fround(f69 * f77) + Math_fround(f70 * f72)));
 f12 = Math_fround(Math_fround(Math_fround(f77 * f13) - Math_fround(f2 * f72)) + Math_fround(Math_fround(f69 * f80) + Math_fround(f70 * f78)));
 f13 = Math_fround(Math_fround(Math_fround(f80 * f72) - Math_fround(f77 * f78)) + Math_fround(Math_fround(f69 * f2) + Math_fround(f70 * f13)));
 i16 = i39 + 48 | 0;
 HEAPF32[i16 >> 2] = f3;
 i17 = i39 + 52 | 0;
 HEAPF32[i17 >> 2] = f4;
 i18 = i39 + 56 | 0;
 HEAPF32[i18 >> 2] = f9;
 HEAPF32[i39 + 60 >> 2] = Math_fround(0.0);
 f70 = Math_fround(f11 + f11);
 f2 = Math_fround(f12 + f12);
 f69 = Math_fround(f13 + f13);
 f78 = Math_fround(f12 * f2);
 f77 = Math_fround(f13 * f69);
 f72 = Math_fround(f12 * f70);
 f80 = Math_fround(f13 * f70);
 f68 = Math_fround(f10 * f70);
 f79 = Math_fround(f13 * f2);
 f2 = Math_fround(f10 * f2);
 f69 = Math_fround(f10 * f69);
 f70 = Math_fround(Math_fround(1.0) - Math_fround(f11 * f70));
 f76 = Math_fround(f72 + f69);
 f75 = Math_fround(f80 - f2);
 f69 = Math_fround(f72 - f69);
 f72 = Math_fround(f70 - f77);
 f71 = Math_fround(f79 + f68);
 f2 = Math_fround(f80 + f2);
 f68 = Math_fround(f79 - f68);
 f70 = Math_fround(f70 - f78);
 HEAPF32[i39 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f78) - f77);
 i21 = i39 + 4 | 0;
 HEAPF32[i21 >> 2] = f76;
 i22 = i39 + 8 | 0;
 HEAPF32[i22 >> 2] = f75;
 HEAPF32[i39 + 12 >> 2] = Math_fround(0.0);
 i23 = i39 + 16 | 0;
 HEAPF32[i23 >> 2] = f69;
 i24 = i39 + 20 | 0;
 HEAPF32[i24 >> 2] = f72;
 i25 = i39 + 24 | 0;
 HEAPF32[i25 >> 2] = f71;
 HEAPF32[i39 + 28 >> 2] = Math_fround(0.0);
 i26 = i39 + 32 | 0;
 HEAPF32[i26 >> 2] = f2;
 i27 = i39 + 36 | 0;
 HEAPF32[i27 >> 2] = f68;
 i28 = i39 + 40 | 0;
 HEAPF32[i28 >> 2] = f70;
 HEAPF32[i39 + 44 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i31 + 36 >> 2] | 0;
 i7 = HEAP32[i32 + 36 >> 2] | 0;
 f70 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f68 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f71 = Math_fround(HEAPF32[i35 >> 2]);
 f72 = Math_fround(HEAPF32[i74 >> 2]);
 f71 = Math_fround(f70 * f71);
 f72 = Math_fround(f68 * f72);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i73 >> 2]));
 f72 = f71 <= f72 ? f71 : f72;
 f2 = Math_fround((f72 <= f2 ? f72 : f2) * Math_fround(.25));
 f72 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f71 = Math_fround(HEAPF32[i7 + 56 >> 2]);
 f68 = Math_fround(HEAPF32[i7 + 60 >> 2]);
 f70 = Math_fround(HEAPF32[i36 >> 2]);
 f69 = Math_fround(HEAPF32[i50 >> 2]);
 f70 = Math_fround(f72 * f70);
 f69 = Math_fround(f71 * f69);
 f68 = Math_fround(f68 * Math_fround(HEAPF32[i30 >> 2]));
 f69 = f70 <= f69 ? f70 : f69;
 f68 = Math_fround((f69 <= f68 ? f69 : f68) * Math_fround(.25));
 i30 = i63 + 32 | 0;
 i50 = HEAP8[i30 >> 0] | 0;
 f2 = f2 > f68 ? f68 : f2;
 HEAPF32[i67 >> 2] = Math_fround(f2 * Math_fround(.800000011));
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i63, i39, i67, i52);
 if ((HEAP8[i30 >> 0] | 0) == i50 << 24 >> 24) {
  i6 = i50 & 255;
  f76 = Math_fround(f2 * Math_fround(HEAPF32[gb + 105432 + (i6 << 2) >> 2]));
  f80 = Math_fround(HEAPF32[i63 + 16 >> 2]);
  f79 = Math_fround(HEAPF32[i63 + 20 >> 2]);
  f80 = Math_fround(f3 - f80);
  f79 = Math_fround(f4 - f79);
  f78 = Math_fround(f9 - Math_fround(HEAPF32[i63 + 24 >> 2]));
  f75 = Math_fround(-f80);
  f72 = Math_fround(-f79);
  f77 = Math_fround(-f78);
  f75 = f80 > f75 ? f80 : f75;
  f72 = f79 > f72 ? f79 : f72;
  f72 = f75 >= f72 ? f75 : f72;
  i74 = (f78 > f77 ? f78 : f77) >= Math_fround(0.0);
  f75 = i74 ? f75 : Math_fround(0.0);
  f77 = Math_fround(HEAPF32[gb + 105452 + (i6 << 2) >> 2]);
  f78 = Math_fround(HEAPF32[i63 >> 2]);
  f79 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f80 = Math_fround(HEAPF32[i63 + 8 >> 2]);
  if (!((f72 >= f75 ? f72 : f75) > f76 ? 1 : f77 > Math_fround(Math_fround(Math_fround(Math_fround(f11 * f78) + Math_fround(f12 * f79)) + Math_fround(f13 * f80)) + Math_fround(f10 * Math_fround(HEAPF32[i63 + 12 >> 2]))))) {
   if (!(i50 << 24 >> 24)) {
    i74 = 0;
    STACKTOP = i66;
    return i74 | 0;
   }
   i5 = HEAP32[i63 + 44 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f3 = Math_fround(HEAPF32[i5 + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   if ((i50 & 255) > 1) {
    i1 = 1;
    do {
     f79 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 32 >> 2]);
     f80 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 36 >> 2]);
     f2 = Math_fround(f2 + f79);
     f3 = Math_fround(f3 + f80);
     f4 = Math_fround(f4 + Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 40 >> 2]));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   f76 = Math_fround(HEAPF32[i65 >> 2]);
   f77 = Math_fround(HEAPF32[i60 >> 2]);
   f71 = Math_fround(HEAPF32[i61 >> 2]);
   f75 = Math_fround(HEAPF32[i62 >> 2]);
   f80 = Math_fround(Math_fround(f75 * f75) + Math_fround(-.5));
   f72 = Math_fround(Math_fround(Math_fround(f2 * f76) + Math_fround(f3 * f77)) + Math_fround(f4 * f71));
   f78 = Math_fround(Math_fround(Math_fround(f76 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f4 * f77) - Math_fround(f3 * f71))) + Math_fround(f2 * f80))) * Math_fround(2.0));
   f79 = Math_fround(Math_fround(Math_fround(f77 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f2 * f71) - Math_fround(f4 * f76))) + Math_fround(f3 * f80))) * Math_fround(2.0));
   f80 = Math_fround(Math_fround(Math_fround(f71 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f3 * f76) - Math_fround(f2 * f77))) + Math_fround(f4 * f80))) * Math_fround(2.0));
   f77 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f80 * f80) + Math_fround(Math_fround(f78 * f78) + Math_fround(f79 * f79))))));
   f79 = Math_fround(f77 * f79);
   f80 = Math_fround(f77 * f80);
   HEAPF32[i58 >> 2] = Math_fround(f77 * f78);
   HEAPF32[i58 + 4 >> 2] = f79;
   HEAPF32[i58 + 8 >> 2] = f80;
   HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i63, i64, i58, i65);
   i74 = 1;
   STACKTOP = i66;
   return i74 | 0;
  }
 }
 HEAPF32[i47 >> 2] = Math_fround(f2 * Math_fround(.0500000007));
 if (Math_fround(HEAPF32[i14 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i15 >> 2]) == Math_fround(1.0)) i6 = Math_fround(HEAPF32[i8 >> 2]) == Math_fround(1.0); else i6 = 0; else i6 = 0;
 if (Math_fround(HEAPF32[i19 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i20 >> 2]) == Math_fround(1.0)) i5 = Math_fround(HEAPF32[i29 >> 2]) == Math_fround(1.0); else i5 = 0; else i5 = 0;
 i74 = HEAP32[i31 + 20 >> 2] | 0;
 i73 = HEAP32[i31 + 24 >> 2] | 0;
 i67 = HEAP32[i31 + 28 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i31 + 16 >> 2];
 HEAP32[i33 + 4 >> 2] = i74;
 HEAP32[i33 + 8 >> 2] = i73;
 HEAP32[i33 + 12 >> 2] = i67;
 i67 = HEAP32[i32 + 20 >> 2] | 0;
 i73 = HEAP32[i32 + 24 >> 2] | 0;
 i74 = HEAP32[i32 + 28 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i32 + 16 >> 2];
 HEAP32[i34 + 4 >> 2] = i67;
 HEAP32[i34 + 8 >> 2] = i73;
 HEAP32[i34 + 12 >> 2] = i74;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i53, i1, i38, i35, i33);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i54, i7, i38, i36, i34);
 HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 HEAP32[i41 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i41 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i41 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i41 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 HEAP32[i55 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 HEAPF32[i46 >> 2] = Math_fround(0.0);
 i74 = i46 + 4 | 0;
 HEAP32[i74 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 do if (i6) if (i5) {
  i1 = __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i53, i54, i39, i52, i40, i41, i55, i46, i63 + 34 | 0, i63 + 38 | 0, i63 + 33 | 0) | 0;
  break;
 } else {
  i1 = __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i53, i54, i39, i52, i40, i41, i55, i46, i63 + 34 | 0, i63 + 38 | 0, i63 + 33 | 0) | 0;
  break;
 } else if (i5) {
  i1 = __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i53, i54, i39, i52, i40, i41, i55, i46, i63 + 34 | 0, i63 + 38 | 0, i63 + 33 | 0) | 0;
  break;
 } else {
  i1 = __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i53, i54, i39, i52, i40, i41, i55, i46, i63 + 34 | 0, i63 + 38 | 0, i63 + 33 | 0) | 0;
  break;
 } while (0);
 HEAPF32[i63 >> 2] = f11;
 HEAPF32[i63 + 4 >> 2] = f12;
 HEAPF32[i63 + 8 >> 2] = f13;
 HEAPF32[i63 + 12 >> 2] = f10;
 HEAPF32[i63 + 16 >> 2] = f3;
 HEAPF32[i63 + 20 >> 2] = f4;
 HEAPF32[i63 + 24 >> 2] = f9;
 HEAPF32[i63 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i56 >> 2] = 0;
 L31 : do switch (i1 | 0) {
 case 3:
  {
   i1 = __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb(i53, i54, i57, i65, i6, i5, i64, i56, i64, i63, i55, i52, 1) | 0;
   break;
  }
 case 0:
  {
   i1 = 0;
   break;
  }
 default:
  {
   i1 = (i1 | 0) == 1;
   if (!(HEAP8[i30 >> 0] | 0)) {
    L35 : do if (i1) {
     f79 = Math_fround(HEAPF32[i40 >> 2]);
     f78 = Math_fround(HEAPF32[i40 + 4 >> 2]);
     f80 = Math_fround(HEAPF32[i40 + 8 >> 2]);
     f76 = Math_fround(HEAPF32[i16 >> 2]);
     f77 = Math_fround(HEAPF32[i17 >> 2]);
     f76 = Math_fround(f79 - f76);
     f77 = Math_fround(f78 - f77);
     f80 = Math_fround(f80 - Math_fround(HEAPF32[i18 >> 2]));
     f78 = Math_fround(f76 * Math_fround(HEAPF32[i39 >> 2]));
     f78 = Math_fround(f78 + Math_fround(f77 * Math_fround(HEAPF32[i21 >> 2])));
     f78 = Math_fround(f78 + Math_fround(f80 * Math_fround(HEAPF32[i22 >> 2])));
     f79 = Math_fround(f76 * Math_fround(HEAPF32[i23 >> 2]));
     f79 = Math_fround(f79 + Math_fround(f77 * Math_fround(HEAPF32[i24 >> 2])));
     f79 = Math_fround(f79 + Math_fround(f80 * Math_fround(HEAPF32[i25 >> 2])));
     f76 = Math_fround(f76 * Math_fround(HEAPF32[i26 >> 2]));
     f77 = Math_fround(f76 + Math_fround(f77 * Math_fround(HEAPF32[i27 >> 2])));
     f80 = Math_fround(f77 + Math_fround(f80 * Math_fround(HEAPF32[i28 >> 2])));
     i67 = HEAP32[i55 >> 2] | 0;
     i73 = HEAP32[i55 + 4 >> 2] | 0;
     i74 = HEAP32[i55 + 8 >> 2] | 0;
     i1 = HEAP32[i46 >> 2] | 0;
     HEAPF32[i64 >> 2] = f78;
     HEAPF32[i64 + 4 >> 2] = f79;
     HEAPF32[i64 + 8 >> 2] = f80;
     HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
     i62 = i64 + 16 | 0;
     HEAP32[i62 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i62 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i62 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i62 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     HEAP32[i56 >> 2] = 1;
     HEAP32[i64 + 32 >> 2] = i67;
     HEAP32[i64 + 36 >> 2] = i73;
     HEAP32[i64 + 40 >> 2] = i74;
     HEAP32[i64 + 44 >> 2] = i1;
     i1 = 0;
    } else {
     HEAP32[i49 >> 2] = gb + 84804 + 8;
     HEAP32[i49 + 4 >> 2] = i53;
     HEAP32[i49 + 8 >> 2] = i54;
     HEAP32[i49 + 12 >> 2] = i39;
     switch (__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i53, i54, i49, i63 + 34 | 0, i63 + 38 | 0, HEAP8[i63 + 33 >> 0] | 0, i40, i41, i55, i46, 0) | 0) {
     case 6:
      {
       f78 = Math_fround(HEAPF32[i40 >> 2]);
       f77 = Math_fround(HEAPF32[i40 + 4 >> 2]);
       f80 = Math_fround(HEAPF32[i40 + 8 >> 2]);
       f76 = Math_fround(HEAPF32[i16 >> 2]);
       f76 = Math_fround(f78 - f76);
       f77 = Math_fround(f77 - Math_fround(HEAPF32[i17 >> 2]));
       f80 = Math_fround(f80 - Math_fround(HEAPF32[i18 >> 2]));
       f78 = Math_fround(Math_fround(Math_fround(f76 * Math_fround(HEAPF32[i39 >> 2])) + Math_fround(f77 * Math_fround(HEAPF32[i21 >> 2]))) + Math_fround(f80 * Math_fround(HEAPF32[i22 >> 2])));
       f79 = Math_fround(Math_fround(Math_fround(f76 * Math_fround(HEAPF32[i23 >> 2])) + Math_fround(f77 * Math_fround(HEAPF32[i24 >> 2]))) + Math_fround(f80 * Math_fround(HEAPF32[i25 >> 2])));
       f80 = Math_fround(Math_fround(Math_fround(f76 * Math_fround(HEAPF32[i26 >> 2])) + Math_fround(f77 * Math_fround(HEAPF32[i27 >> 2]))) + Math_fround(f80 * Math_fround(HEAPF32[i28 >> 2])));
       i62 = HEAP32[i55 >> 2] | 0;
       i67 = HEAP32[i55 + 4 >> 2] | 0;
       i73 = HEAP32[i55 + 8 >> 2] | 0;
       i74 = HEAP32[i46 >> 2] | 0;
       i1 = HEAP32[i56 >> 2] | 0;
       HEAPF32[i64 + (i1 * 48 | 0) >> 2] = f78;
       HEAPF32[i64 + (i1 * 48 | 0) + 4 >> 2] = f79;
       HEAPF32[i64 + (i1 * 48 | 0) + 8 >> 2] = f80;
       HEAPF32[i64 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
       i61 = i64 + (i1 * 48 | 0) + 16 | 0;
       HEAP32[i61 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i61 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
       HEAP32[i61 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
       HEAP32[i61 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
       HEAP32[i56 >> 2] = i1 + 1;
       HEAP32[i64 + (i1 * 48 | 0) + 32 >> 2] = i62;
       HEAP32[i64 + (i1 * 48 | 0) + 36 >> 2] = i67;
       HEAP32[i64 + (i1 * 48 | 0) + 40 >> 2] = i73;
       HEAP32[i64 + (i1 * 48 | 0) + 44 >> 2] = i74;
       i1 = 0;
       break L35;
      }
     case 4:
      {
       i1 = 1;
       break L35;
      }
     default:
      {
       i1 = 0;
       break L35;
      }
     }
    } while (0);
    i1 = __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb(i53, i54, i57, i65, i6, i5, i64, i56, i64, i63, i55, i52, i1) | 0;
    break L31;
   }
   L43 : do if (i1) {
    f79 = Math_fround(HEAPF32[i40 >> 2]);
    f78 = Math_fround(HEAPF32[i40 + 4 >> 2]);
    f80 = Math_fround(HEAPF32[i40 + 8 >> 2]);
    f76 = Math_fround(HEAPF32[i16 >> 2]);
    f77 = Math_fround(HEAPF32[i17 >> 2]);
    f76 = Math_fround(f79 - f76);
    f77 = Math_fround(f78 - f77);
    f80 = Math_fround(f80 - Math_fround(HEAPF32[i18 >> 2]));
    f78 = Math_fround(f76 * Math_fround(HEAPF32[i39 >> 2]));
    f78 = Math_fround(f78 + Math_fround(f77 * Math_fround(HEAPF32[i21 >> 2])));
    f78 = Math_fround(f78 + Math_fround(f80 * Math_fround(HEAPF32[i22 >> 2])));
    f79 = Math_fround(f76 * Math_fround(HEAPF32[i23 >> 2]));
    f79 = Math_fround(f79 + Math_fround(f77 * Math_fround(HEAPF32[i24 >> 2])));
    f79 = Math_fround(f79 + Math_fround(f80 * Math_fround(HEAPF32[i25 >> 2])));
    f76 = Math_fround(f76 * Math_fround(HEAPF32[i26 >> 2]));
    f77 = Math_fround(f76 + Math_fround(f77 * Math_fround(HEAPF32[i27 >> 2])));
    f80 = Math_fround(f77 + Math_fround(f80 * Math_fround(HEAPF32[i28 >> 2])));
    HEAPF32[i44 >> 2] = f78;
    HEAPF32[i44 + 4 >> 2] = f79;
    HEAPF32[i44 + 8 >> 2] = f80;
    HEAPF32[i44 + 12 >> 2] = Math_fround(0.0);
    i73 = HEAP32[i55 + 4 >> 2] | 0;
    i74 = HEAP32[i55 + 8 >> 2] | 0;
    i51 = HEAP32[i46 >> 2] | 0;
    HEAP32[i42 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i42 + 4 >> 2] = i73;
    HEAP32[i42 + 8 >> 2] = i74;
    HEAP32[i42 + 12 >> 2] = i51;
    HEAP32[i64 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i64 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
    HEAP32[i64 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
    HEAP32[i64 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
    i51 = i64 + 16 | 0;
    HEAP32[i51 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i51 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i51 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i51 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
    HEAP32[i56 >> 2] = 1;
    i51 = i64 + 32 | 0;
    HEAP32[i51 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i51 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
    HEAP32[i51 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
    HEAP32[i51 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
    __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i63, i44, i41, i42, i47) | 0;
    i51 = 23;
   } else {
    HEAP32[i48 >> 2] = gb + 84804 + 8;
    HEAP32[i48 + 4 >> 2] = i53;
    HEAP32[i48 + 8 >> 2] = i54;
    HEAP32[i48 + 12 >> 2] = i39;
    switch (__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i53, i54, i48, i63 + 34 | 0, i63 + 38 | 0, HEAP8[i63 + 33 >> 0] | 0, i40, i41, i55, i46, 0) | 0) {
    case 4:
     {
      i1 = 1;
      break L43;
     }
    case 6:
     break;
    default:
     {
      i51 = 23;
      break L43;
     }
    }
    f79 = Math_fround(HEAPF32[i40 >> 2]);
    f78 = Math_fround(HEAPF32[i40 + 4 >> 2]);
    f80 = Math_fround(HEAPF32[i40 + 8 >> 2]);
    f76 = Math_fround(HEAPF32[i16 >> 2]);
    f77 = Math_fround(HEAPF32[i17 >> 2]);
    f76 = Math_fround(f79 - f76);
    f77 = Math_fround(f78 - f77);
    f80 = Math_fround(f80 - Math_fround(HEAPF32[i18 >> 2]));
    f78 = Math_fround(f76 * Math_fround(HEAPF32[i39 >> 2]));
    f78 = Math_fround(f78 + Math_fround(f77 * Math_fround(HEAPF32[i21 >> 2])));
    f78 = Math_fround(f78 + Math_fround(f80 * Math_fround(HEAPF32[i22 >> 2])));
    f79 = Math_fround(f76 * Math_fround(HEAPF32[i23 >> 2]));
    f79 = Math_fround(f79 + Math_fround(f77 * Math_fround(HEAPF32[i24 >> 2])));
    f79 = Math_fround(f79 + Math_fround(f80 * Math_fround(HEAPF32[i25 >> 2])));
    f76 = Math_fround(f76 * Math_fround(HEAPF32[i26 >> 2]));
    f77 = Math_fround(f76 + Math_fround(f77 * Math_fround(HEAPF32[i27 >> 2])));
    f80 = Math_fround(f77 + Math_fround(f80 * Math_fround(HEAPF32[i28 >> 2])));
    HEAPF32[i45 >> 2] = f78;
    HEAPF32[i45 + 4 >> 2] = f79;
    HEAPF32[i45 + 8 >> 2] = f80;
    HEAPF32[i45 + 12 >> 2] = Math_fround(0.0);
    i73 = HEAP32[i55 + 4 >> 2] | 0;
    i74 = HEAP32[i55 + 8 >> 2] | 0;
    i51 = HEAP32[i46 >> 2] | 0;
    HEAP32[i43 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i43 + 4 >> 2] = i73;
    HEAP32[i43 + 8 >> 2] = i74;
    HEAP32[i43 + 12 >> 2] = i51;
    i51 = HEAP32[i56 >> 2] | 0;
    i74 = i64 + (i51 * 48 | 0) | 0;
    HEAP32[i74 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i74 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
    HEAP32[i74 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
    HEAP32[i74 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
    i74 = i64 + (i51 * 48 | 0) + 16 | 0;
    HEAP32[i74 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i74 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i74 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i74 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
    HEAP32[i56 >> 2] = i51 + 1;
    i51 = i64 + (i51 * 48 | 0) + 32 | 0;
    HEAP32[i51 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i51 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
    HEAP32[i51 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
    HEAP32[i51 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
    __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i63, i45, i41, i43, i47) | 0;
    i51 = 23;
   } while (0);
   if ((i51 | 0) == 23) {
    i1 = HEAP8[i30 >> 0] | 0;
    if ((i1 & 255) < (i50 & 255)) i1 = 0; else {
     i6 = HEAP32[i63 + 44 >> 2] | 0;
     f2 = Math_fround(HEAPF32[i6 + 32 >> 2]);
     f3 = Math_fround(HEAPF32[i6 + 36 >> 2]);
     f4 = Math_fround(HEAPF32[i6 + 40 >> 2]);
     if ((i1 & 255) > 1) {
      i5 = i1 & 255;
      i1 = 1;
      do {
       f79 = Math_fround(HEAPF32[i6 + (i1 * 48 | 0) + 32 >> 2]);
       f80 = Math_fround(HEAPF32[i6 + (i1 * 48 | 0) + 36 >> 2]);
       f2 = Math_fround(f2 + f79);
       f3 = Math_fround(f3 + f80);
       f4 = Math_fround(f4 + Math_fround(HEAPF32[i6 + (i1 * 48 | 0) + 40 >> 2]));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i5 | 0));
     }
     f76 = Math_fround(HEAPF32[i65 >> 2]);
     f77 = Math_fround(HEAPF32[i60 >> 2]);
     f71 = Math_fround(HEAPF32[i61 >> 2]);
     f75 = Math_fround(HEAPF32[i62 >> 2]);
     f80 = Math_fround(Math_fround(f75 * f75) + Math_fround(-.5));
     f72 = Math_fround(Math_fround(Math_fround(f2 * f76) + Math_fround(f3 * f77)) + Math_fround(f4 * f71));
     f78 = Math_fround(Math_fround(Math_fround(f76 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f4 * f77) - Math_fround(f3 * f71))) + Math_fround(f2 * f80))) * Math_fround(2.0));
     f79 = Math_fround(Math_fround(Math_fround(f77 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f2 * f71) - Math_fround(f4 * f76))) + Math_fround(f3 * f80))) * Math_fround(2.0));
     f80 = Math_fround(Math_fround(Math_fround(f71 * f72) + Math_fround(Math_fround(f75 * Math_fround(Math_fround(f3 * f76) - Math_fround(f2 * f77))) + Math_fround(f4 * f80))) * Math_fround(2.0));
     f77 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f80 * f80) + Math_fround(Math_fround(f78 * f78) + Math_fround(f79 * f79))))));
     f79 = Math_fround(f77 * f79);
     f80 = Math_fround(f77 * f80);
     HEAPF32[i59 >> 2] = Math_fround(f77 * f78);
     HEAPF32[i59 + 4 >> 2] = f79;
     HEAPF32[i59 + 8 >> 2] = f80;
     HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i63, i64, i59, i65);
     i1 = 1;
     break L31;
    }
   }
   i1 = __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb(i53, i54, i57, i65, i6, i5, i64, i56, i64, i63, i55, i52, i1) | 0;
  }
 } while (0);
 i74 = i1;
 STACKTOP = i66;
 return i74 | 0;
}

function __Z24CrowdUpdateMultiThreadedRK17ReadonlyCrowdInfoR15UpdateCrowdInfoP7dtCrowdf(i39, i42, i43, f44) {
 i39 = i39 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 f44 = Math_fround(f44);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i47;
 i38 = i47 + 476 | 0;
 i45 = i47 + 104 | 0;
 i46 = i47 + 96 | 0;
 HEAPF32[i45 + 368 >> 2] = f44;
 HEAP32[i45 + 364 >> 2] = i43;
 i1 = i45 + 320 | 0;
 i2 = i39;
 i3 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i45 + 256 | 0;
 i2 = gb + 1459460 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i36 = i42 + 12 | 0;
 i35 = HEAP32[i36 >> 2] | 0;
 i40 = i42 + 4 | 0;
 i41 = i42 + 8 | 0;
 i33 = HEAP32[i40 >> 2] | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 HEAP32[i45 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i45 + 4 >> 2] = i33;
 HEAP32[i45 + 8 >> 2] = i34;
 HEAP32[i45 + 12 >> 2] = i35;
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 3998 | 0, i45, 1, 0, 1);
 if (HEAP32[i46 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i46);
 i9 = HEAP32[i36 >> 2] | 0;
 if ((i9 | 0) > 0) {
  i10 = i43 + 16 | 0;
  i11 = i43 + 464 | 0;
  i12 = i43 + 432 | 0;
  i13 = i43 + 24 | 0;
  i8 = 0;
  do {
   i3 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i1 = HEAP32[i42 >> 2] | 0;
   i14 = i1 + (i3 * 608 | 0) + 602 | 0;
   if (HEAP8[i14 >> 0] & 32) {
    i2 = i1 + (i3 * 608 | 0) + 564 | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i7 + (i3 * 608 | 0) + 564 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i7 + (i3 * 608 | 0) + 568 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 568 >> 2];
    HEAP32[i7 + (i3 * 608 | 0) + 572 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 572 >> 2];
    i1 = i7 + (i3 * 608 | 0) + 602 | 0;
    HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 16;
    __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i11 >> 2] | 0, i2, i12, (HEAP32[i13 >> 2] | 0) + (i3 * 132 | 0) | 0, i37, i38) | 0;
    i2 = i37;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if ((i1 | 0) == 0 & (i2 | 0) == 0) {
     i35 = i7 + (i3 * 608 | 0) + 592 | 0;
     HEAP32[i35 >> 2] = 0;
     HEAP32[i35 + 4 >> 2] = 0;
    } else {
     __ZN7dtCrowd17requestMoveTargetEiyPKf(i43, i3, i1, i2, i38);
     i1 = i7 + (i3 * 608 | 0) + 601 | 0;
     if ((HEAP8[i1 >> 0] | 0) != 2) HEAP8[i1 >> 0] = 1;
    }
    HEAP8[i14 >> 0] = HEAP8[i14 >> 0] & -33;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i9 | 0));
 }
 __ZN7dtCrowd17UpdateMoveRequestEv(i43);
 __ZN7dtCrowd26UpdateTopologyOptimizationEf(i43, f44);
 if ((HEAP16[gb + 1459272 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459272 | 0, i37);
  i1 = gb + 1459272 | 0;
 } else i1 = 0;
 i34 = HEAP32[i43 + 400 >> 2] | 0;
 i34 = (i34 | 0) > 65535 ? 65535 : i34;
 i33 = 65535 - i34 | 0;
 i35 = HEAP32[i43 + 404 >> 2] | 0;
 i35 = (i33 | 0) < (i35 | 0) ? i33 : i35;
 i33 = i43 + 368 | 0;
 __ZNK7dtCrowd27UpdateProximityGridCellSizeEP15dtProximityGridii(i43, HEAP32[i33 >> 2] | 0, i34, i35);
 __ZNK7dtCrowd35InsertActiveAgentsIntoProximityGridEP15dtProximityGridii(i43, HEAP32[i33 >> 2] | 0, i34, i35);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 3999 | 0, i45, 1, 0, 1);
 if (HEAP32[i46 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i46);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 4e3 | 0, i45, 1, 0, 1);
 if (HEAP32[i46 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i46);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 4001 | 0, i45, 1, 0, 1);
 if (HEAP32[i46 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i46);
 if ((HEAP16[gb + 1459368 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459368 | 0, i37);
  i27 = gb + 1459368 | 0;
 } else i27 = 0;
 i32 = HEAP32[i36 >> 2] | 0;
 i33 = (i32 | 0) > 0;
 i34 = i39 + 16 | 0;
 i28 = i39 + 32 | 0;
 i29 = i39 + 24 | 0;
 i30 = i39 + 28 | 0;
 i31 = i39 + 20 | 0;
 i26 = 0;
 do {
  if (i33) {
   i7 = 0;
   do {
    i9 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i10 = HEAP32[i42 >> 2] | 0;
    i11 = i10 + (i9 * 608 | 0) - (HEAP32[i34 >> 2] | 0) | 0;
    if ((HEAP8[i10 + (i9 * 608 | 0) + 601 >> 0] | 0) != 2) {
     i12 = i10 + (i9 * 608 | 0) + 492 | 0;
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     i13 = i10 + (i9 * 608 | 0) + 496 | 0;
     HEAPF32[i13 >> 2] = Math_fround(0.0);
     i14 = i10 + (i9 * 608 | 0) + 500 | 0;
     HEAPF32[i14 >> 2] = Math_fround(0.0);
     i15 = HEAP32[i10 + (i9 * 608 | 0) + 384 >> 2] | 0;
     if ((i15 | 0) > 0) {
      i18 = i10 + (i9 * 608 | 0) + 480 | 0;
      i19 = i10 + (i9 * 608 | 0) + 488 | 0;
      i20 = i10 + (i9 * 608 | 0) + 292 | 0;
      i21 = i10 + (i9 * 608 | 0) + 512 | 0;
      i22 = i10 + (i9 * 608 | 0) + 504 | 0;
      i23 = i10 + (i9 * 608 | 0) + 316 | 0;
      i24 = i10 + (i9 * 608 | 0) + 484 | 0;
      i25 = i10 + (i9 * 608 | 0) + 296 | 0;
      f4 = Math_fround(0.0);
      i8 = 0;
      do {
       i1 = HEAP32[i10 + (i9 * 608 | 0) + 320 + (i8 << 3) >> 2] | 0;
       i2 = HEAP32[i28 >> 2] | 0;
       L45 : do if ((i1 | 0) < (i2 | 0)) {
        i1 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i1 << 2) >> 2] | 0;
        i2 = HEAP32[i34 >> 2] | 0;
        f17 = Math_fround(HEAPF32[i2 + (i1 * 608 | 0) + 292 >> 2]);
        i3 = i1 * 608 | 0;
        f6 = Math_fround(HEAPF32[i18 >> 2]);
        f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + (i1 * 608 | 0) + 480 >> 2]));
        f5 = Math_fround(HEAPF32[i19 >> 2]);
        f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + (i1 * 608 | 0) + 488 >> 2]));
        f16 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(f5 * f5));
        f17 = Math_fround(f17 + Math_fround(HEAPF32[i20 >> 2]));
        if (!(f16 > Math_fround(f17 * f17))) {
         f16 = Math_fround(Math_sqrt(Math_fround(f16)));
         do if (f16 < Math_fround(.0000999999974)) {
          f5 = Math_fround(HEAPF32[i21 >> 2]);
          if ((i11 | 0) > (i3 | 0)) {
           f6 = Math_fround(-f5);
           f16 = Math_fround(.00999999977);
           f5 = Math_fround(HEAPF32[i22 >> 2]);
           break;
          } else {
           f16 = Math_fround(.00999999977);
           f6 = f5;
           f5 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
           break;
          }
         } else {
          f48 = Math_fround(f17 - f16);
          i3 = HEAP8[i23 >> 0] | 0;
          i35 = HEAP8[i2 + (i1 * 608 | 0) + 316 >> 0] | 0;
          f17 = (i35 & 255) > (i3 & 255) ? Math_fround(1.0) : Math_fround(0.0);
          f16 = Math_fround(Math_fround(Math_fround(f48 * (i3 << 24 >> 24 == i35 << 24 >> 24 ? Math_fround(.5) : f17)) * Math_fround(.699999988)) / f16);
         } while (0);
         HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(f6 * f16));
         HEAPF32[i13 >> 2] = Math_fround(Math_fround(f16 * Math_fround(0.0)) + Math_fround(HEAPF32[i13 >> 2]));
         HEAPF32[i14 >> 2] = Math_fround(Math_fround(f5 * f16) + Math_fround(HEAPF32[i14 >> 2]));
         f4 = Math_fround(f4 + Math_fround(1.0));
        }
       } else {
        i2 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 - i2 << 2) >> 2] | 0;
        i3 = HEAP32[i31 >> 2] | 0;
        i1 = i3 + (i2 * 92 | 0) | 0;
        switch (HEAP32[i3 + (i2 * 92 | 0) + 84 >> 2] | 0) {
        case 1:
         {
          HEAPF32[i37 >> 2] = Math_fround(0.0);
          f17 = Math_fround(HEAPF32[i20 >> 2]);
          f48 = Math_fround(HEAPF32[i24 >> 2]);
          if (__Z38AlignedCylinderOverlapsOrientedCapsulePfPKfS1_S1_S1_fff(i37, i1, i3 + (i2 * 92 | 0) + 24 | 0, i3 + (i2 * 92 | 0) + 60 | 0, i18, f17, f48, Math_fround(f48 + Math_fround(HEAPF32[i25 >> 2]))) | 0) {
           f6 = Math_fround(HEAPF32[i18 >> 2]);
           f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
           f17 = Math_fround(HEAPF32[i19 >> 2]);
           f17 = Math_fround(f17 - Math_fround(HEAPF32[i3 + (i2 * 92 | 0) + 8 >> 2]));
           f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(f17 * f17))));
           if (f5 > Math_fround(.0000999999974)) {
            f5 = Math_fround(Math_fround(1.0) / f5);
            f6 = Math_fround(f6 * f5);
            f16 = Math_fround(f5 * Math_fround(0.0));
            f5 = Math_fround(f17 * f5);
           } else {
            f6 = Math_fround(1.0);
            f16 = Math_fround(0.0);
            f5 = Math_fround(0.0);
           }
           f48 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) * Math_fround(.699999988));
           HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(f6 * f48));
           HEAPF32[i13 >> 2] = Math_fround(Math_fround(f16 * f48) + Math_fround(HEAPF32[i13 >> 2]));
           HEAPF32[i14 >> 2] = Math_fround(Math_fround(f5 * f48) + Math_fround(HEAPF32[i14 >> 2]));
           f4 = Math_fround(f4 + Math_fround(1.0));
          }
          break L45;
         }
        case 2:
         {
          HEAPF32[i38 >> 2] = Math_fround(0.0);
          __Z27CalculateOrientedBoxCornersPfPKfS1_S1_S1_S1_(i37, i1, i3 + (i2 * 92 | 0) + 24 | 0, i3 + (i2 * 92 | 0) + 48 | 0, i3 + (i2 * 92 | 0) + 60 | 0, i3 + (i2 * 92 | 0) + 72 | 0);
          f17 = Math_fround(HEAPF32[i20 >> 2]);
          f48 = Math_fround(HEAPF32[i24 >> 2]);
          if (__Z34AlignedCylinderOverlapsOrientedBoxPfPKfS1_fff(i38, i37, i18, f17, f48, Math_fround(f48 + Math_fround(HEAPF32[i25 >> 2]))) | 0) {
           f6 = Math_fround(HEAPF32[i18 >> 2]);
           f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
           f17 = Math_fround(HEAPF32[i19 >> 2]);
           f17 = Math_fround(f17 - Math_fround(HEAPF32[i3 + (i2 * 92 | 0) + 8 >> 2]));
           f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(f17 * f17))));
           if (f5 > Math_fround(.0000999999974)) {
            f5 = Math_fround(Math_fround(1.0) / f5);
            f6 = Math_fround(f6 * f5);
            f16 = Math_fround(f5 * Math_fround(0.0));
            f5 = Math_fround(f17 * f5);
           } else {
            f6 = Math_fround(1.0);
            f16 = Math_fround(0.0);
            f5 = Math_fround(0.0);
           }
           f48 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * Math_fround(.699999988));
           HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(f6 * f48));
           HEAPF32[i13 >> 2] = Math_fround(Math_fround(f16 * f48) + Math_fround(HEAPF32[i13 >> 2]));
           HEAPF32[i14 >> 2] = Math_fround(Math_fround(f5 * f48) + Math_fround(HEAPF32[i14 >> 2]));
           f4 = Math_fround(f4 + Math_fround(1.0));
          }
          break L45;
         }
        default:
         break L45;
        }
       } while (0);
       i8 = i8 + 1 | 0;
      } while ((i8 | 0) != (i15 | 0));
      if (f4 > Math_fround(.0000999999974)) {
       f48 = Math_fround(Math_fround(1.0) / f4);
       HEAPF32[i12 >> 2] = Math_fround(f48 * Math_fround(HEAPF32[i12 >> 2]));
       HEAPF32[i13 >> 2] = Math_fround(f48 * Math_fround(HEAPF32[i13 >> 2]));
       HEAPF32[i14 >> 2] = Math_fround(f48 * Math_fround(HEAPF32[i14 >> 2]));
      }
     }
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i32 | 0));
   i2 = HEAP32[i41 >> 2] | 0;
   i3 = HEAP32[i42 >> 2] | 0;
   i1 = 0;
   do {
    i7 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
    if ((HEAP8[i3 + (i7 * 608 | 0) + 601 >> 0] | 0) != 2) {
     i35 = i3 + (i7 * 608 | 0) + 480 | 0;
     f48 = Math_fround(HEAPF32[i35 >> 2]);
     HEAPF32[i35 >> 2] = Math_fround(f48 + Math_fround(HEAPF32[i3 + (i7 * 608 | 0) + 492 >> 2]));
     i35 = i3 + (i7 * 608 | 0) + 484 | 0;
     f48 = Math_fround(HEAPF32[i35 >> 2]);
     HEAPF32[i35 >> 2] = Math_fround(f48 + Math_fround(HEAPF32[i3 + (i7 * 608 | 0) + 496 >> 2]));
     i35 = i3 + (i7 * 608 | 0) + 488 | 0;
     f48 = Math_fround(HEAPF32[i35 >> 2]);
     HEAPF32[i35 >> 2] = Math_fround(f48 + Math_fround(HEAPF32[i3 + (i7 * 608 | 0) + 500 >> 2]));
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i32 | 0));
  }
  i26 = i26 + 1 | 0;
 } while ((i26 | 0) != 4);
 if (i27 | 0) __Z12profiler_endP19ProfilerInformation(i27);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 4002 | 0, i45, 1, 0, 1);
 if (HEAP32[i46 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i46);
 if ((HEAP16[gb + 1459416 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459416 | 0, i37);
  i23 = gb + 1459416 | 0;
 } else i23 = 0;
 i24 = HEAP32[i36 >> 2] | 0;
 if ((i24 | 0) > 0) {
  i25 = HEAP32[i43 + 464 >> 2] | 0;
  i26 = i43 + 384 | 0;
  i27 = i43 + 380 | 0;
  i28 = i26;
  i29 = i43 + 384 | 0;
  i30 = i43 + 388 | 0;
  f5 = Math_fround(f44 * f44);
  i22 = 0;
  do {
   i31 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i22 << 2) >> 2] | 0;
   i32 = HEAP32[i42 >> 2] | 0;
   i33 = i32 + (i31 * 608 | 0) + 601 | 0;
   i2 = HEAP8[i33 >> 0] | 0;
   L96 : do if (i2 << 24 >> 24 != 2) {
    i34 = i32 + (i31 * 608 | 0) + 476 | 0;
    i1 = HEAP32[i34 >> 2] | 0;
    do if (i1 | 0) {
     i3 = i1 + -1 | 0;
     if (HEAP8[i32 + (i31 * 608 | 0) + 472 + i3 >> 0] & 4) {
      f48 = Math_fround(Math_fround(HEAPF32[i32 + (i31 * 608 | 0) + 292 >> 2]) * Math_fround(2.25));
      f48 = Math_fround(f48 * f48);
      i35 = i32 + (i31 * 608 | 0) + 480 | 0;
      i21 = i32 + (i31 * 608 | 0) + 424 + ((i1 * 3 | 0) + -3 << 2) | 0;
      f17 = Math_fround(HEAPF32[i21 >> 2]);
      f17 = Math_fround(f17 - Math_fround(HEAPF32[i35 >> 2]));
      f4 = Math_fround(HEAPF32[i21 + 8 >> 2]);
      i21 = i32 + (i31 * 608 | 0) + 488 | 0;
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i21 >> 2]));
      f4 = Math_fround(Math_fround(f17 * f17) + Math_fround(f4 * f4));
      if (!(f4 < f48)) {
       f48 = Math_fround(HEAPF32[i32 + (i31 * 608 | 0) + 516 >> 2]);
       f48 = Math_fround(f48 * f48);
       f17 = Math_fround(HEAPF32[i32 + (i31 * 608 | 0) + 520 >> 2]);
       f17 = Math_fround(f48 + Math_fround(f17 * f17));
       f48 = Math_fround(HEAPF32[i32 + (i31 * 608 | 0) + 524 >> 2]);
       if (!(f4 < Math_fround(f5 * Math_fround(f17 + Math_fround(f48 * f48))))) break;
      }
      HEAP8[i33 >> 0] = 3;
      i20 = i32 + (i31 * 608 | 0) + 392 + (i3 << 3) | 0;
      i19 = HEAP32[i20 >> 2] | 0;
      i20 = HEAP32[i20 + 4 >> 2] | 0;
      i2 = HEAP32[i26 >> 2] | 0;
      do if (i2 | 0) {
       i1 = i26;
       L105 : while (1) {
        i3 = i2;
        while (1) {
         i18 = i3 + 16 | 0;
         i15 = HEAP32[i18 + 4 >> 2] | 0;
         if (!(i15 >>> 0 < i20 >>> 0 | ((i15 | 0) == (i20 | 0) ? (HEAP32[i18 >> 2] | 0) >>> 0 < i19 >>> 0 : 0))) break;
         i2 = HEAP32[i3 + 4 >> 2] | 0;
         if (!i2) break L105; else i3 = i2;
        }
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i1 = i3;
         break;
        } else i1 = i3;
       }
       if ((i1 | 0) == (i26 | 0)) break;
       i18 = i1 + 16 | 0;
       i15 = HEAP32[i18 + 4 >> 2] | 0;
       if (!(i15 >>> 0 > i20 >>> 0 | ((i15 | 0) == (i20 | 0) ? (HEAP32[i18 >> 2] | 0) >>> 0 > i19 >>> 0 : 0))) break L96;
      } while (0);
      i14 = HEAP32[i40 >> 2] | 0;
      i10 = i32 + (i31 * 608 | 0) | 0;
      i15 = i14 + (i31 * 56 | 0) + 12 | 0;
      i18 = i14 + (i31 * 56 | 0) + 24 | 0;
      i11 = HEAP32[i32 + (i31 * 608 | 0) + 28 >> 2] | 0;
      i12 = i32 + (i31 * 608 | 0) + 32 | 0;
      i13 = HEAP32[i12 >> 2] | 0;
      i2 = i11;
      i3 = HEAP32[i2 >> 2] | 0;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      do if ((i13 | 0) < 1 | (i3 | 0) == (i19 | 0) & (i2 | 0) == (i20 | 0)) {
       i1 = 0;
       i7 = 0;
       i8 = 0;
      } else {
       if ((i13 | 0) < 2) {
        i1 = 1;
        i7 = i3;
        i8 = i2;
        break;
       } else {
        i1 = 1;
        i7 = i3;
       }
       while (1) {
        i9 = i11 + (i1 << 3) | 0;
        i3 = HEAP32[i9 >> 2] | 0;
        i9 = HEAP32[i9 + 4 >> 2] | 0;
        i1 = i1 + 1 | 0;
        if ((i13 | 0) <= (i1 | 0) | (i3 | 0) == (i19 | 0) & (i9 | 0) == (i20 | 0)) {
         i8 = i2;
         i2 = i9;
         break;
        } else {
         i7 = i3;
         i2 = i9;
        }
       }
      } while (0);
      do if ((i13 | 0) != (i1 | 0)) {
       i13 = i13 - i1 | 0;
       _memmove(i11 | 0, i11 + (i1 << 3) | 0, i13 << 3 | 0) | 0;
       HEAP32[i12 >> 2] = i13;
       if (!((__ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_(HEAP32[i25 >> 2] | 0, i7, i8, i3, i2, i15, i18) | 0) & 1073741824)) break;
       HEAP32[i10 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i32 + (i31 * 608 | 0) + 4 >> 2] = HEAP32[i14 + (i31 * 56 | 0) + 28 >> 2];
       i8 = i14 + (i31 * 56 | 0) + 32 | 0;
       HEAP32[i32 + (i31 * 608 | 0) + 8 >> 2] = HEAP32[i8 >> 2];
       i1 = HEAP32[i26 >> 2] | 0;
       do if (!i1) {
        HEAP32[i37 >> 2] = i26;
        i7 = i28;
        i3 = i26;
       } else {
        while (1) {
         i3 = i1 + 16 | 0;
         i2 = HEAP32[i3 >> 2] | 0;
         i3 = HEAP32[i3 + 4 >> 2] | 0;
         if (i3 >>> 0 > i20 >>> 0 | (i3 | 0) == (i20 | 0) & i2 >>> 0 > i19 >>> 0) {
          i2 = HEAP32[i1 >> 2] | 0;
          if (!i2) {
           i2 = 90;
           break;
          } else i1 = i2;
         } else {
          if (!(i3 >>> 0 < i20 >>> 0 | (i3 | 0) == (i20 | 0) & i2 >>> 0 < i19 >>> 0)) {
           i2 = 95;
           break;
          }
          i3 = i1 + 4 | 0;
          i2 = HEAP32[i3 >> 2] | 0;
          if (!i2) {
           i2 = 94;
           break;
          } else i1 = i2;
         }
        }
        if ((i2 | 0) == 90) {
         HEAP32[i37 >> 2] = i1;
         i7 = i1;
         i3 = i1;
         break;
        } else if ((i2 | 0) == 94) {
         HEAP32[i37 >> 2] = i1;
         i7 = i1;
         break;
        } else if ((i2 | 0) == 95) {
         HEAP32[i37 >> 2] = i1;
         i7 = i1;
         i3 = i37;
         break;
        }
       } while (0);
       if (!(HEAP32[i3 >> 2] | 0)) {
        i1 = __Znwj(24) | 0;
        i2 = i1 + 16 | 0;
        HEAP32[i2 >> 2] = i19;
        HEAP32[i2 + 4 >> 2] = i20;
        HEAP32[i1 >> 2] = 0;
        HEAP32[i1 + 4 >> 2] = 0;
        HEAP32[i1 + 8 >> 2] = i7;
        HEAP32[i3 >> 2] = i1;
        i2 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
        if (i2) {
         HEAP32[i27 >> 2] = i2;
         i1 = HEAP32[i3 >> 2] | 0;
        }
        __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 >> 2] | 0, i1);
        HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
       }
       HEAP32[i14 + (i31 * 56 | 0) >> 2] = HEAP32[i35 >> 2];
       HEAP32[i14 + (i31 * 56 | 0) + 4 >> 2] = HEAP32[i32 + (i31 * 608 | 0) + 484 >> 2];
       HEAP32[i14 + (i31 * 56 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
       i35 = i14 + (i31 * 56 | 0) + 40 | 0;
       HEAP32[i35 >> 2] = i19;
       HEAP32[i35 + 4 >> 2] = i20;
       HEAPF32[i14 + (i31 * 56 | 0) + 48 >> 2] = Math_fround(0.0);
       f17 = Math_fround(HEAPF32[i18 >> 2]);
       f17 = Math_fround(f17 - Math_fround(HEAPF32[i15 >> 2]));
       f48 = Math_fround(HEAPF32[i8 >> 2]);
       f48 = Math_fround(f48 - Math_fround(HEAPF32[i14 + (i31 * 56 | 0) + 20 >> 2]));
       HEAPF32[i14 + (i31 * 56 | 0) + 52 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f48 * f48))));
       HEAP8[i33 >> 0] = 2;
       HEAP32[i34 >> 2] = 0;
       HEAP32[i32 + (i31 * 608 | 0) + 384 >> 2] = 0;
       break L96;
      } while (0);
      i35 = i32 + (i31 * 608 | 0) + 44 | 0;
      HEAP8[i35 >> 0] = HEAPU8[i35 >> 0] & 254;
      break L96;
     }
    } while (0);
    if (i2 << 24 >> 24 == 3) HEAP8[i33 >> 0] = 1;
   } while (0);
   i22 = i22 + 1 | 0;
  } while ((i22 | 0) != (i24 | 0));
 }
 if (i23 | 0) __Z12profiler_endP19ProfilerInformation(i23);
 if ((HEAP16[gb + 1459428 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459428 | 0, i37);
  i15 = gb + 1459428 | 0;
 } else i15 = 0;
 i13 = HEAP32[i36 >> 2] | 0;
 if ((i13 | 0) > 0) {
  i14 = i43 + 464 | 0;
  i9 = i39 + 12 | 0;
  i8 = 0;
  do {
   i10 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i11 = HEAP32[i42 >> 2] | 0;
   do if (!(HEAP8[i11 + (i10 * 608 | 0) + 602 >> 0] & 8)) {
    i7 = HEAP32[i40 >> 2] | 0;
    i39 = i7 + (i10 * 56 | 0) + 40 | 0;
    if (!((HEAP32[i39 >> 2] | 0) == 0 & (HEAP32[i39 + 4 >> 2] | 0) == 0)) {
     if (!(HEAP8[i11 + (i10 * 608 | 0) + 317 >> 0] & 2)) break;
     i12 = i11 + (i10 * 608 | 0) + 304 | 0;
     f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0)) * f44);
     i1 = i7 + (i10 * 56 | 0) + 48 | 0;
     f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f5);
     HEAPF32[i1 >> 2] = f5;
     f48 = Math_fround(Math_fround(HEAPF32[i11 + (i10 * 608 | 0) + 292 >> 2]) * Math_fround(2.25));
     f4 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 52 >> 2]);
     f6 = Math_fround(f4 * Math_fround(.150000006));
     f6 = f48 < f6 ? f48 : f6;
     do if (f5 < f6) {
      i37 = f6 == Math_fround(0.0);
      f4 = Math_fround(f5 / f6);
      f4 = i37 ? Math_fround(1.0) : f4;
      i37 = i7 + (i10 * 56 | 0) | 0;
      i36 = i7 + (i10 * 56 | 0) + 12 | 0;
      f5 = Math_fround(HEAPF32[i37 >> 2]);
      HEAPF32[i11 + (i10 * 608 | 0) + 480 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 4 >> 2]);
      HEAPF32[i11 + (i10 * 608 | 0) + 484 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 16 >> 2]) - f5)));
      i39 = i7 + (i10 * 56 | 0) + 8 | 0;
      f5 = Math_fround(HEAPF32[i39 >> 2]);
      i38 = i7 + (i10 * 56 | 0) + 20 | 0;
      HEAPF32[i11 + (i10 * 608 | 0) + 488 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i38 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i36 >> 2]);
      f5 = Math_fround(f5 - Math_fround(HEAPF32[i37 >> 2]));
      f4 = Math_fround(HEAPF32[i38 >> 2]);
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i39 >> 2]));
      f6 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)) + Math_fround(f4 * f4));
      if (f6 == Math_fround(0.0)) break;
      f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
      f5 = Math_fround(f5 * f48);
      f4 = Math_fround(f4 * f48);
     } else if (f5 < f4) {
      f4 = Math_fround(f4 - f6);
      if (f4 == Math_fround(0.0)) f4 = Math_fround(1.0); else f4 = Math_fround(Math_fround(f5 - f6) / f4);
      i37 = i7 + (i10 * 56 | 0) + 12 | 0;
      i36 = i7 + (i10 * 56 | 0) + 24 | 0;
      f5 = Math_fround(HEAPF32[i37 >> 2]);
      HEAPF32[i11 + (i10 * 608 | 0) + 480 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 16 >> 2]);
      HEAPF32[i11 + (i10 * 608 | 0) + 484 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 28 >> 2]) - f5)));
      i39 = i7 + (i10 * 56 | 0) + 20 | 0;
      f5 = Math_fround(HEAPF32[i39 >> 2]);
      i38 = i7 + (i10 * 56 | 0) + 32 | 0;
      HEAPF32[i11 + (i10 * 608 | 0) + 488 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i38 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i36 >> 2]);
      f5 = Math_fround(f5 - Math_fround(HEAPF32[i37 >> 2]));
      f4 = Math_fround(HEAPF32[i38 >> 2]);
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i39 >> 2]));
      f6 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)) + Math_fround(f4 * f4));
      if (f6 == Math_fround(0.0)) break;
      f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
      f5 = Math_fround(f5 * f48);
      f4 = Math_fround(f4 * f48);
      break;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      i3 = (HEAP32[i9 >> 2] | 0) + (i10 * 132 | 0) | 0;
      __ZN7dtCrowd19completeOffMeshLinkEib(i43, i10, 0);
      f4 = Math_fround(f4 - f6);
      if (f4 == Math_fround(0.0)) f4 = Math_fround(1.0); else f4 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f6) / f4);
      i34 = i11 + (i10 * 608 | 0) + 480 | 0;
      i37 = i7 + (i10 * 56 | 0) + 24 | 0;
      f5 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 12 >> 2]);
      HEAPF32[i34 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i37 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 16 >> 2]);
      i38 = i11 + (i10 * 608 | 0) + 484 | 0;
      HEAPF32[i38 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 28 >> 2]) - f5)));
      f5 = Math_fround(HEAPF32[i7 + (i10 * 56 | 0) + 20 >> 2]);
      i39 = i7 + (i10 * 56 | 0) + 32 | 0;
      i35 = i11 + (i10 * 608 | 0) + 488 | 0;
      HEAPF32[i35 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i39 >> 2]) - f5)));
      i36 = i11 + (i10 * 608 | 0) | 0;
      __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i36, i34, i2, i3);
      i36 = HEAP32[i36 >> 2] | 0;
      HEAP32[i34 >> 2] = i36;
      HEAP32[i38 >> 2] = HEAP32[i11 + (i10 * 608 | 0) + 4 >> 2];
      i38 = HEAP32[i11 + (i10 * 608 | 0) + 8 >> 2] | 0;
      HEAP32[i35 >> 2] = i38;
      f5 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = Math_fround(f5 - Math_fround(HEAPF32[i37 >> 2]));
      f4 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i39 >> 2]));
      f6 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)));
      if (f6 == Math_fround(0.0)) break;
      f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
      f5 = Math_fround(f5 * f48);
      f4 = Math_fround(f4 * f48);
      break;
     } while (0);
     f48 = Math_fround(HEAPF32[i12 >> 2]);
     f16 = Math_fround(f5 * f48);
     f17 = Math_fround(f48 * Math_fround(0.0));
     f48 = Math_fround(f4 * f48);
     HEAPF32[i11 + (i10 * 608 | 0) + 516 >> 2] = f16;
     HEAPF32[i11 + (i10 * 608 | 0) + 520 >> 2] = f17;
     HEAPF32[i11 + (i10 * 608 | 0) + 524 >> 2] = f48;
     HEAPF32[i11 + (i10 * 608 | 0) + 528 >> 2] = f16;
     HEAPF32[i11 + (i10 * 608 | 0) + 532 >> 2] = f17;
     HEAPF32[i11 + (i10 * 608 | 0) + 536 >> 2] = f48;
    }
   } while (0);
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i13 | 0));
 }
 if (i15 | 0) __Z12profiler_endP19ProfilerInformation(i15);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i46, fb + 4003 | 0, i45, 1, 0, 1);
 if (!(HEAP32[i46 >> 2] | 0)) {
  STACKTOP = i47;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i46);
 STACKTOP = i47;
 return;
}

function __ZN13SpeedTreeWind8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481742 | 0, gb + 481752 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13SpeedTreeWind7SParams8TransferI14SafeBinaryReadEEvRT_(i7, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 1332 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481760 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 1336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481778 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 1340 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481796 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 1344 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481814 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1348 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481839 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1349 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481851 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1350 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481873 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1351 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481889 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481910 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1353 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481937 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1354 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481957 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1355 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481971 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1356 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 481992 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1357 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482008 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L179 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L179;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1358 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482029 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L191 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L191;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1359 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482056 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L203 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L203;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1360 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482076 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L215 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L215;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1361 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482090 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L227 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L227;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1362 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482111 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L239 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L239;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1363 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482139 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L251 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L251;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1364 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482162 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L263 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L263;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1365 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482176 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L275 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L275;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1366 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482190 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L287 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L287;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1367 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482207 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L299 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L299;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482235 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L311 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L311;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1369 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482258 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L323 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L323;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1370 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482272 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L335 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L335;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1371 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482286 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L347 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L347;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482303 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L359 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L359;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1373 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482326 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L371 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L371;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1374 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482349 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L383 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L383;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 1375 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 482378 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 L396 : do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i8 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L396;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _ps_hints_apply(i19, i17, i32, i20) {
 i19 = i19 | 0;
 i17 = i17 | 0;
 i32 = i32 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i39 + 136 | 0;
 i34 = i39 + 128 | 0;
 i38 = i39;
 i4 = i17 + 2 | 0;
 if (!(HEAP16[i4 >> 1] | 0)) {
  i38 = 0;
  STACKTOP = i39;
  return i38 | 0;
 }
 i3 = HEAP32[i17 >> 2] | 0;
 if (!((i3 & 65535) << 16 >> 16)) {
  i38 = 0;
  STACKTOP = i39;
  return i38 | 0;
 }
 i1 = i38;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i18 = HEAP32[i32 >> 2] | 0;
 i36 = i38 + 16 | 0;
 HEAP32[i36 >> 2] = i18;
 i37 = i38 + 8 | 0;
 HEAP32[i37 >> 2] = _UNITY_ft_mem_realloc(i18, 40, 0, i3 >> 16, 0, i33) | 0;
 i2 = HEAP32[i33 >> 2] | 0;
 if (!i2) {
  i1 = _UNITY_ft_mem_realloc(i18, 8, 0, HEAP16[i17 >> 1] | 0, 0, i33) | 0;
  i35 = i38 + 12 | 0;
  HEAP32[i35 >> 2] = i1;
  i2 = HEAP32[i33 >> 2] | 0;
  if (!i2) {
   i11 = HEAP16[i4 >> 1] | 0;
   HEAP32[i38 >> 2] = i11 << 16 >> 16;
   i30 = HEAP16[i17 >> 1] | 0;
   i9 = i30 << 16 >> 16;
   i4 = i38 + 4 | 0;
   HEAP32[i4 >> 2] = i9;
   i12 = HEAP32[i37 >> 2] | 0;
   if (i30 << 16 >> 16) {
    i10 = HEAP32[i17 + 12 >> 2] | 0;
    i8 = 0;
    i6 = 0;
    while (1) {
     i2 = i6;
     i6 = (HEAP16[i10 + (i8 << 1) >> 1] | 0) + 1 | 0;
     i3 = i6 - i2 | 0;
     i7 = i12 + (i2 * 40 | 0) | 0;
     HEAP32[i1 >> 2] = i7;
     HEAP32[i1 + 4 >> 2] = i3;
     if (i3 | 0) {
      HEAP32[i7 >> 2] = i12 + (i6 * 40 | 0) + -40;
      HEAP32[i12 + (i2 * 40 | 0) + 8 >> 2] = i1;
      if ((i3 | 0) == 1) i2 = i7; else {
       i5 = i7;
       while (1) {
        i2 = i5 + 40 | 0;
        HEAP32[i5 + 4 >> 2] = i2;
        HEAP32[i2 >> 2] = i5;
        HEAP32[i5 + 48 >> 2] = i1;
        i3 = i3 + -1 | 0;
        if (i3 >>> 0 <= 1) break; else i5 = i2;
       }
      }
      HEAP32[i2 + 4 >> 2] = i7;
     }
     i8 = i8 + 1 | 0;
     if (i8 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
    }
   }
   i16 = i17 + 4 | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   if (!(i11 << 16 >> 16)) {
    HEAP32[i38 + 20 >> 2] = i17;
    HEAP32[i38 + 24 >> 2] = i32;
   } else {
    i13 = i12;
    i14 = i17 + 8 | 0;
    i11 = i12;
    i12 = 0;
    while (1) {
     i1 = ((HEAP32[i11 >> 2] | 0) - i13 | 0) / 40 | 0;
     i5 = ((HEAP32[i11 + 4 >> 2] | 0) - i13 | 0) / 40 | 0;
     if (!(HEAP8[(HEAP32[i14 >> 2] | 0) + i12 >> 0] & 1)) HEAP32[i11 + 12 >> 2] = 1;
     i3 = HEAP32[i15 + (i12 << 3) >> 2] | 0;
     i10 = i3 - (HEAP32[i15 + (i1 << 3) >> 2] | 0) | 0;
     i6 = HEAP32[i15 + (i12 << 3) + 4 >> 2] | 0;
     i9 = i6 - (HEAP32[i15 + (i1 << 3) + 4 >> 2] | 0) | 0;
     i1 = (i10 | 0) < 0 ? 0 - i10 | 0 : i10;
     i2 = (i9 | 0) < 0 ? 0 - i9 | 0 : i9;
     if ((i2 * 12 | 0) < (i1 | 0)) i8 = i10 >> 31 & -4 | 2; else i8 = (i1 * 12 | 0) < (i2 | 0) ? (i9 >> 31 & 2) + -1 | 0 : 4;
     HEAP8[i11 + 20 >> 0] = i8;
     i7 = (HEAP32[i15 + (i5 << 3) >> 2] | 0) - i3 | 0;
     i5 = (HEAP32[i15 + (i5 << 3) + 4 >> 2] | 0) - i6 | 0;
     i1 = (i7 | 0) < 0 ? 0 - i7 | 0 : i7;
     i2 = (i5 | 0) < 0 ? 0 - i5 | 0 : i5;
     if ((i2 * 12 | 0) < (i1 | 0)) i2 = i7 >> 31 & -4 | 2; else i2 = (i1 * 12 | 0) < (i2 | 0) ? (i5 >> 31 & 2) + -1 | 0 : 4;
     HEAP8[i11 + 21 >> 0] = i2;
     i3 = i11 + 12 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     do if (!(i1 & 1)) {
      if ((i8 | 0) == (i2 | 0)) {
       if ((i8 | 0) == 4) {
        if (!(_UNITY_ft_corner_is_flat(i10, i9, i7, i5) | 0)) break;
        i1 = HEAP32[i3 >> 2] | 0;
       }
       HEAP32[i3 >> 2] = i1 | 2;
      }
     } else HEAP32[i3 >> 2] = i1 | 2; while (0);
     i12 = i12 + 1 | 0;
     i1 = HEAP32[i38 >> 2] | 0;
     if (i12 >>> 0 >= i1 >>> 0) break; else i11 = i11 + 40 | 0;
    }
    i3 = HEAP32[i37 >> 2] | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    HEAP32[i38 + 20 >> 2] = i17;
    HEAP32[i38 + 24 >> 2] = i32;
    if (i1 | 0) while (1) {
     HEAP32[i3 + 16 >> 2] = 0;
     HEAP32[i3 + 24 >> 2] = 0;
     HEAP32[i3 + 28 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 32 >> 2] = HEAP32[i2 + 4 >> 2];
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i3 = i3 + 40 | 0;
      i2 = i2 + 8 | 0;
     }
    }
   }
   if (HEAP32[i4 >> 2] | 0) {
    i14 = 0;
    do {
     i1 = HEAP32[i35 >> 2] | 0;
     L54 : do if ((HEAP32[i1 + (i14 << 3) + 4 >> 2] | 0) >>> 0 >= 4) {
      i5 = HEAP32[i1 + (i14 << 3) >> 2] | 0;
      i1 = i5 + 28 | 0;
      i3 = i5 + 32 | 0;
      i2 = i5;
      while (1) {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if ((i2 | 0) == (i5 | 0)) break L54;
       i8 = (HEAP32[i2 + 28 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
       i9 = (HEAP32[i2 + 32 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
       if (i9 | i8 | 0) {
        i1 = i5;
        break;
       }
      }
      while (1) {
       while (1) {
        i3 = HEAP32[i1 >> 2] | 0;
        if ((i3 | 0) == (i5 | 0)) break L54;
        i10 = (HEAP32[i1 + 28 >> 2] | 0) - (HEAP32[i3 + 28 >> 2] | 0) | 0;
        i7 = (HEAP32[i1 + 32 >> 2] | 0) - (HEAP32[i3 + 32 >> 2] | 0) | 0;
        if (!(i7 | i10)) i1 = i3; else break;
       }
       i6 = _UNITY_ft_corner_orientation(i8, i9, i10, i7) | 0;
       if (!i6) i1 = i3; else {
        i5 = i1;
        break;
       }
      }
      while (1) {
       i3 = 0;
       do {
        i13 = i2;
        i9 = HEAP32[i2 + 28 >> 2] | 0;
        i8 = HEAP32[i2 + 32 >> 2] | 0;
        while (1) {
         i2 = HEAP32[i13 + 4 >> 2] | 0;
         i3 = (i2 | 0) == (i1 | 0) ? 1 : i3;
         i11 = i9;
         i9 = HEAP32[i2 + 28 >> 2] | 0;
         i11 = i9 - i11 | 0;
         i12 = i8;
         i8 = HEAP32[i2 + 32 >> 2] | 0;
         i12 = i8 - i12 | 0;
         if (i12 | i11 | 0) break; else i13 = i2;
        }
        i8 = _UNITY_ft_corner_orientation(i10, i7, i11, i12) | 0;
       } while ((i8 | 0) == 0);
       if ((i8 ^ i6 | 0) < 0) {
        do {
         i30 = i5 + 12 | 0;
         HEAP32[i30 >> 2] = HEAP32[i30 >> 2] | 4;
         i5 = HEAP32[i5 + 4 >> 2] | 0;
        } while ((i5 | 0) != (i13 | 0));
        i30 = i13 + 12 | 0;
        HEAP32[i30 >> 2] = HEAP32[i30 >> 2] | 4;
       }
       if (!i3) {
        i5 = i13;
        i6 = i8;
        i7 = i12;
        i10 = i11;
       } else break;
      }
     } while (0);
     i14 = i14 + 1 | 0;
    } while (i14 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
   }
   i2 = _psh_hint_table_init(i38 + 28 | 0, i19 + 16 | 0, i19 + 28 | 0, i18) | 0;
   HEAP32[i33 >> 2] = i2;
   if (!i2) {
    i2 = _psh_hint_table_init(i38 + 68 | 0, i19 + 52 | 0, i19 + 64 | 0, i18) | 0;
    if (!i2) {
     i28 = i38 + 24 | 0;
     i30 = HEAP32[i28 >> 2] | 0;
     i29 = HEAP32[i30 + 200 >> 2] | 0;
     i30 = HEAP32[i30 + 404 >> 2] | 0;
     i1 = _UNITY_FT_MulFix(HEAP32[i32 + 416 >> 2] | 0, i30) | 0;
     i2 = i1 + 32 & -64;
     if ((i2 | 0) == 0 | (i1 | 0) == (i2 | 0)) i27 = 1; else {
      i3 = _UNITY_FT_MulDiv(i30, i2, i1) | 0;
      if ((i2 | 0) < (i1 | 0)) i1 = i29 - ((i29 | 0) / 50 | 0) | 0; else i1 = i29;
      _psh_globals_set_scale(HEAP32[i28 >> 2] | 0, i1, i3, 0, 0);
      i27 = 0;
     }
     HEAP8[i38 + 120 >> 0] = 1;
     HEAP8[i38 + 121 >> 0] = 1;
     HEAP8[i38 + 122 >> 0] = (i20 | 1 | 0) == 3 & 1;
     HEAP8[i38 + 123 >> 0] = ((i20 | 0) == 2 | (i20 | 0) == 4) & 1;
     HEAP8[i38 + 124 >> 0] = (i20 | 0) != 1 & 1;
     i20 = i38 + 20 | 0;
     i21 = i32 + 412 | 0;
     i22 = i32 + 416 | 0;
     i23 = i32 + 928 | 0;
     i24 = i32 + 2488 | 0;
     i25 = i32 + 2492 | 0;
     i26 = i32 + 2484 | 0;
     i19 = 0;
     while (1) {
      i12 = HEAP32[i38 >> 2] | 0;
      i13 = HEAP32[i37 >> 2] | 0;
      i1 = HEAP32[(HEAP32[i20 >> 2] | 0) + 4 >> 2] | 0;
      if (i12 | 0) if (!i19) {
       i3 = i13;
       i2 = i12;
       while (1) {
        HEAP32[i3 + 16 >> 2] = 0;
        HEAP32[i3 + 24 >> 2] = 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 4 >> 2];
        i2 = i2 + -1 | 0;
        if (!i2) break; else {
         i3 = i3 + 40 | 0;
         i1 = i1 + 8 | 0;
        }
       }
      } else {
       i3 = i13;
       i2 = i12;
       while (1) {
        HEAP32[i3 + 16 >> 2] = 0;
        HEAP32[i3 + 24 >> 2] = 0;
        HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i3 + 32 >> 2] = HEAP32[i1 >> 2];
        i2 = i2 + -1 | 0;
        if (!i2) break; else {
         i3 = i3 + 40 | 0;
         i1 = i1 + 8 | 0;
        }
       }
      }
      i10 = HEAP32[i4 >> 2] | 0;
      L98 : do if (!i10) i1 = 0; else {
       i11 = HEAP32[i35 >> 2] | 0;
       i1 = 0;
       while (1) {
        i2 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
        L102 : do if (HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0) {
         i3 = i2 + 28 | 0;
         i5 = i2;
         do {
          i5 = HEAP32[i5 >> 2] | 0;
          if ((i5 | 0) == (i2 | 0)) {
           i31 = 91;
           break L98;
          }
         } while ((HEAP32[i5 + 28 >> 2] | 0) == (HEAP32[i3 >> 2] | 0));
         i9 = HEAP32[i5 + 4 >> 2] | 0;
         i2 = i9;
         while (1) {
          i3 = i2 + 28 | 0;
          i8 = i2;
          do {
           i8 = HEAP32[i8 + 4 >> 2] | 0;
           if ((i8 | 0) == (i9 | 0)) break L102;
           i6 = HEAP32[i8 + 28 >> 2] | 0;
           i7 = HEAP32[i3 >> 2] | 0;
          } while ((i6 | 0) == (i7 | 0));
          if ((HEAP32[i5 + 28 >> 2] | 0) < (i7 | 0)) {
           if ((i6 | 0) < (i7 | 0)) i31 = 77;
          } else if ((i6 | 0) > (i7 | 0)) i31 = 77;
          if ((i31 | 0) == 77) while (1) {
           i31 = 0;
           i18 = i2 + 16 | 0;
           HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 64;
           i2 = HEAP32[i2 + 4 >> 2] | 0;
           if ((i2 | 0) == (i8 | 0)) break; else i31 = 77;
          }
          i2 = i8;
          i5 = HEAP32[i8 >> 2] | 0;
         }
        } while (0);
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= i10 >>> 0) {
         i1 = 0;
         break;
        }
       }
      } while (0);
      L122 : while (1) {
       if ((i31 | 0) == 91) {
        i31 = 0;
        i1 = i1 + 1 | 0;
       }
       if (i1 >>> 0 >= i12 >>> 0) break;
       i5 = i13 + (i1 * 40 | 0) | 0;
       i6 = i13 + (i1 * 40 | 0) + 16 | 0;
       i7 = HEAP32[i6 >> 2] | 0;
       if (!(i7 & 64)) {
        i31 = 91;
        continue;
       }
       i3 = i13 + (i1 * 40 | 0) + 32 | 0;
       i2 = i5;
       while (1) {
        i2 = HEAP32[i2 >> 2] | 0;
        if ((i2 | 0) == (i5 | 0)) {
         i31 = 91;
         continue L122;
        }
        i8 = HEAP32[i2 + 32 >> 2] | 0;
        i9 = HEAP32[i3 >> 2] | 0;
        if ((i8 | 0) != (i9 | 0)) {
         i2 = i5;
         break;
        }
       }
       while (1) {
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if ((i2 | 0) == (i5 | 0)) {
         i31 = 91;
         continue L122;
        }
        i3 = HEAP32[i2 + 32 >> 2] | 0;
        if ((i3 | 0) != (i9 | 0)) break;
       }
       if ((i8 | 0) < (i9 | 0) & (i3 | 0) > (i9 | 0)) {
        HEAP32[i6 >> 2] = i7 | 128;
        i31 = 91;
        continue;
       }
       if (!((i8 | 0) > (i9 | 0) & (i3 | 0) < (i9 | 0))) {
        i31 = 91;
        continue;
       }
       HEAP32[i6 >> 2] = i7 | 256;
       i31 = 91;
      }
      i12 = i38 + 28 + (i19 * 40 | 0) | 0;
      i3 = HEAP32[i28 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      if (i1) {
       i2 = HEAP32[i38 + 28 + (i19 * 40 | 0) + 8 >> 2] | 0;
       while (1) {
        _psh_hint_align(i2, i3, i19, i38);
        i1 = i1 + -1 | 0;
        if (!i1) break; else i2 = i2 + 28 | 0;
       }
       i3 = HEAP32[i28 >> 2] | 0;
      }
      i10 = i38 + 28 + (i19 * 40 | 0) + 32 | 0;
      i5 = HEAP32[i10 >> 2] | 0;
      i7 = HEAP32[i5 + 8 >> 2] | 0;
      i5 = HEAP32[i5 >> 2] | 0;
      i18 = (i19 | 0) == 0;
      i11 = i18 ? 1 : 2;
      i9 = _UNITY_FT_DivFix(32, HEAP32[i3 + 4 + (i19 * 204 | 0) + 196 >> 2] | 0) | 0;
      i9 = (i9 | 0) > 30 ? 30 : i9;
      L146 : do if (i5 >>> 0 > 1) {
       i6 = HEAP32[i38 >> 2] | 0;
       if (!i6) {
        i3 = 1;
        i7 = 0;
       } else {
        i8 = HEAP32[i7 + 12 >> 2] | 0;
        i2 = i38 + 28 + (i19 * 40 | 0) + 4 | 0;
        i1 = i38 + 28 + (i19 * 40 | 0) + 12 | 0;
        i3 = i5;
        i8 = i8 >>> 0 > i6 >>> 0 ? i6 : i8;
        i5 = i6;
        while (1) {
         i6 = i7 + 16 | 0;
         i31 = HEAP32[i7 + 28 >> 2] | 0;
         i5 = i31 >>> 0 < i5 >>> 0 ? i31 : i5;
         if (i5 >>> 0 > i8 >>> 0) {
          i31 = (HEAP32[i37 >> 2] | 0) + (i8 * 40 | 0) | 0;
          _psh_hint_table_activate_mask(i12, HEAP32[i6 >> 2] | 0, HEAP32[i7 + 24 >> 2] | 0);
          _psh_hint_table_find_strong_points(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, i31, i5 - i8 | 0, i9, i11);
         }
         i3 = i3 + -1 | 0;
         if (i3 >>> 0 <= 1) {
          i31 = 105;
          break L146;
         }
         i8 = i5;
         i7 = i6;
         i5 = HEAP32[i38 >> 2] | 0;
        }
       }
      } else if ((i5 | 0) == 1) {
       i2 = i38 + 28 + (i19 * 40 | 0) + 4 | 0;
       i1 = i38 + 28 + (i19 * 40 | 0) + 12 | 0;
       i31 = 105;
      } else i31 = 106; while (0);
      if ((i31 | 0) == 105) {
       i17 = HEAP32[i38 >> 2] | 0;
       i16 = HEAP32[i37 >> 2] | 0;
       i15 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
       _psh_hint_table_activate_mask(i12, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 8 >> 2] | 0);
       _psh_hint_table_find_strong_points(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, i16, i17, i9, i11);
       i31 = 106;
      }
      if ((i31 | 0) == 106) {
       i31 = 0;
       i7 = HEAP32[i38 >> 2] | 0;
       i3 = (i7 | 0) == 0;
       if (i3) {
        i3 = 1;
        i7 = 0;
       } else {
        i1 = i7;
        i2 = HEAP32[i37 >> 2] | 0;
        while (1) {
         do if (HEAP32[i2 + 24 >> 2] | 0) {
          i5 = i2 + 16 | 0;
          i6 = HEAP32[i5 >> 2] | 0;
          if (i6 & 16 | 0) break;
          HEAP32[i5 >> 2] = i6 | 16;
         } while (0);
         i1 = i1 + -1 | 0;
         if (!i1) break; else i2 = i2 + 40 | 0;
        }
       }
      }
      L169 : do if ((i19 | 0) == 1) if (i3) i1 = 0; else {
       i1 = HEAP32[i37 >> 2] | 0;
       i14 = i7;
       i15 = i1;
       while (1) {
        i2 = HEAP16[i15 + 20 >> 1] | 0;
        switch ((i2 & 255) << 24 >> 24) {
        case -2:
        case 2:
         {
          i31 = 118;
          break;
         }
        default:
         switch (((i2 & 65535) >>> 8 & 255) << 24 >> 24) {
         case -2:
         case 2:
          {
           i31 = 118;
           break;
          }
         default:
          {}
         }
        }
        L176 : do if ((i31 | 0) == 118) {
         i31 = 0;
         i12 = i15 + 16 | 0;
         i5 = HEAP32[i12 >> 2] | 0;
         if (i5 & 16 | 0) break;
         i13 = HEAP32[i15 + 28 >> 2] | 0;
         i2 = HEAP32[i21 >> 2] | 0;
         L179 : do if (i2) {
          i9 = HEAP32[i24 >> 2] | 0;
          i10 = 0 - i9 | 0;
          i11 = i15 + 36 | 0;
          i8 = i22;
          while (1) {
           i6 = i13 - (HEAP32[i8 + 12 >> 2] | 0) | 0;
           if ((i6 | 0) < (i10 | 0)) break L179;
           do if ((i13 | 0) <= ((HEAP32[i8 + 8 >> 2] | 0) + i9 | 0)) {
            if (!(HEAP8[i25 >> 0] | 0)) if ((i6 | 0) > (HEAP32[i26 >> 2] | 0)) break;
            HEAP32[i11 >> 2] = HEAP32[i8 + 24 >> 2];
            i5 = i5 | 48;
            HEAP32[i12 >> 2] = i5;
           } while (0);
           i2 = i2 + -1 | 0;
           if (!i2) break; else i8 = i8 + 32 | 0;
          }
         } while (0);
         i2 = HEAP32[i23 >> 2] | 0;
         if (!i2) break;
         i9 = HEAP32[i24 >> 2] | 0;
         i10 = 0 - i9 | 0;
         i11 = i15 + 36 | 0;
         i8 = i2;
         i6 = i32 + 932 + (i2 << 5) | 0;
         do {
          i2 = (HEAP32[i6 + -24 >> 2] | 0) - i13 | 0;
          if ((i2 | 0) < (i10 | 0)) break L176;
          do if ((i13 | 0) >= ((HEAP32[i6 + -20 >> 2] | 0) - i9 | 0)) {
           if (!(HEAP8[i25 >> 0] | 0)) if ((i2 | 0) >= (HEAP32[i26 >> 2] | 0)) break;
           HEAP32[i11 >> 2] = HEAP32[i6 + -4 >> 2];
           i5 = i5 | 48;
           HEAP32[i12 >> 2] = i5;
          } while (0);
          i6 = i6 + -32 | 0;
          i8 = i8 + -1 | 0;
         } while ((i8 | 0) != 0);
        } while (0);
        i14 = i14 + -1 | 0;
        if (!i14) {
         i31 = 136;
         break L169;
        } else i15 = i15 + 40 | 0;
       }
      } else {
       i1 = HEAP32[i37 >> 2] | 0;
       i31 = 136;
      } while (0);
      if ((i31 | 0) == 136) {
       i31 = 0;
       i10 = HEAP32[(HEAP32[i28 >> 2] | 0) + 4 + (i19 * 204 | 0) + 196 >> 2] | 0;
       if (i3) i1 = 0; else {
        while (1) {
         i3 = HEAP32[i1 + 24 >> 2] | 0;
         if (i3 | 0) {
          i9 = i1 + 16 | 0;
          i2 = HEAP32[i9 >> 2] | 0;
          do if (!(i2 & 512)) {
           if (i2 & 1024 | 0) {
            HEAP32[i1 + 36 >> 2] = (HEAP32[i3 + 12 >> 2] | 0) + (HEAP32[i3 + 8 >> 2] | 0);
            break;
           }
           i5 = (HEAP32[i1 + 28 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
           if ((i5 | 0) < 1) {
            i17 = HEAP32[i3 + 8 >> 2] | 0;
            HEAP32[i1 + 36 >> 2] = (_UNITY_FT_MulFix(i5, i10) | 0) + i17;
            break;
           }
           i6 = HEAP32[i3 + 4 >> 2] | 0;
           i8 = HEAP32[i3 + 8 >> 2] | 0;
           i2 = HEAP32[i3 + 12 >> 2] | 0;
           if ((i5 | 0) < (i6 | 0)) {
            HEAP32[i1 + 36 >> 2] = (_UNITY_FT_MulDiv(i5, i2, i6) | 0) + i8;
            break;
           } else {
            HEAP32[i1 + 36 >> 2] = i2 + i8 + (_UNITY_FT_MulFix(i5 - i6 | 0, i10) | 0);
            break;
           }
          } else HEAP32[i1 + 36 >> 2] = HEAP32[i3 + 8 >> 2]; while (0);
          HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 32;
         }
         i7 = i7 + -1 | 0;
         if (!i7) break; else i1 = i1 + 40 | 0;
        }
        i1 = HEAP32[i38 >> 2] | 0;
       }
      }
      i13 = HEAP32[(HEAP32[i28 >> 2] | 0) + 4 + (i19 * 204 | 0) + 196 >> 2] | 0;
      i14 = HEAP32[i36 >> 2] | 0;
      i9 = HEAP32[i37 >> 2] | 0;
      i15 = i9 + (i1 * 40 | 0) | 0;
      do if ((i1 | 0) > 0) {
       i1 = i9;
       i2 = 0;
       do {
        i2 = ((HEAP32[i1 + 16 >> 2] | 0) >>> 4 & 1) + i2 | 0;
        i1 = i1 + 40 | 0;
       } while (i1 >>> 0 < i15 >>> 0);
       if (i2 | 0) {
        if (i2 >>> 0 < 17) i1 = i33; else {
         i1 = _UNITY_ft_mem_realloc(i14, 4, 0, i2, 0, i34) | 0;
         if (HEAP32[i34 >> 2] | 0) break;
        }
        i8 = i9;
        i7 = 0;
        do {
         if (HEAP32[i8 + 16 >> 2] & 16) {
          i2 = i1 + (i7 << 2) | 0;
          L237 : do if ((i7 | 0) > 0) {
           i6 = HEAP32[i8 + 28 >> 2] | 0;
           while (1) {
            i3 = i2 + -4 | 0;
            i5 = HEAP32[i3 >> 2] | 0;
            if ((HEAP32[i5 + 28 >> 2] | 0) <= (i6 | 0)) break L237;
            HEAP32[i2 >> 2] = i5;
            if (i3 >>> 0 > i1 >>> 0) i2 = i3; else {
             i2 = i3;
             break;
            }
           }
          } while (0);
          HEAP32[i2 >> 2] = i8;
          i7 = i7 + 1 | 0;
         }
         i8 = i8 + 40 | 0;
        } while (i8 >>> 0 < i15 >>> 0);
        i11 = (i7 | 0) == 0;
        i12 = i1 + (i7 + -1 << 2) | 0;
        do {
         i10 = i9 + 16 | 0;
         i2 = HEAP32[i10 >> 2] | 0;
         do if (!(i2 & 16)) {
          i3 = i9 + 12 | 0;
          i5 = HEAP32[i3 >> 2] | 0;
          if (i5 & 2 | 0) {
           i6 = HEAP16[i9 + 20 >> 1] | 0;
           i8 = i6 & 255;
           if (i8 << 24 >> 24 == 4) break;
           if (i8 << 24 >> 24 != ((i6 & 65535) >>> 8 & 255) << 24 >> 24) break;
           if (!(i5 & 4 | i2 & 64)) break;
           HEAP32[i3 >> 2] = i5 & -3;
          }
          i8 = HEAP32[i9 + 28 >> 2] | 0;
          do if (i11) i31 = 174; else {
           i2 = 0;
           do {
            if ((HEAP32[(HEAP32[i1 + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0) > (i8 | 0)) {
             i31 = 173;
             break;
            }
            i2 = i2 + 1 | 0;
           } while (i2 >>> 0 < i7 >>> 0);
           if ((i31 | 0) == 173) {
            i31 = 0;
            if (!i2) {
             i31 = 174;
             break;
            }
           }
           i6 = HEAP32[i1 + (i2 + -1 << 2) >> 2] | 0;
           i2 = i7;
           while (1) {
            if (!i2) {
             i2 = 0;
             break;
            }
            i3 = i2 + -1 | 0;
            if ((HEAP32[(HEAP32[i1 + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0) < (i8 | 0)) break; else i2 = i3;
           }
           if ((i2 | 0) == (i7 | 0)) {
            i16 = HEAP32[i12 >> 2] | 0;
            i17 = HEAP32[i16 + 36 >> 2] | 0;
            HEAP32[i9 + 36 >> 2] = (_UNITY_FT_MulFix(i8 - (HEAP32[i16 + 28 >> 2] | 0) | 0, i13) | 0) + i17;
            break;
           }
           i2 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
           i3 = HEAP32[i6 + 28 >> 2] | 0;
           if ((i8 | 0) == (i3 | 0)) {
            HEAP32[i9 + 36 >> 2] = HEAP32[i6 + 36 >> 2];
            break;
           }
           i5 = HEAP32[i2 + 28 >> 2] | 0;
           i2 = HEAP32[i2 + 36 >> 2] | 0;
           if ((i8 | 0) == (i5 | 0)) {
            HEAP32[i9 + 36 >> 2] = i2;
            break;
           } else {
            i17 = HEAP32[i6 + 36 >> 2] | 0;
            HEAP32[i9 + 36 >> 2] = (_UNITY_FT_MulDiv(i8 - i3 | 0, i2 - i17 | 0, i5 - i3 | 0) | 0) + i17;
            break;
           }
          } while (0);
          if ((i31 | 0) == 174) {
           i31 = 0;
           i16 = HEAP32[i1 >> 2] | 0;
           i17 = HEAP32[i16 + 36 >> 2] | 0;
           HEAP32[i9 + 36 >> 2] = (_UNITY_FT_MulFix(i8 - (HEAP32[i16 + 28 >> 2] | 0) | 0, i13) | 0) + i17;
          }
          HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 32;
         } while (0);
         i9 = i9 + 40 | 0;
        } while (i9 >>> 0 < i15 >>> 0);
        if ((i1 | 0) == (i33 | 0)) break;
        _UNITY_ft_mem_free(i14, i1);
       }
      } while (0);
      i2 = HEAP32[i4 >> 2] | 0;
      i1 = HEAP32[i28 >> 2] | 0;
      i17 = HEAP32[i1 + 4 + (i19 * 204 | 0) + 196 >> 2] | 0;
      if (i2 | 0) {
       i1 = HEAP32[i1 + 4 + (i19 * 204 | 0) + 200 >> 2] | 0;
       i16 = HEAP32[i35 >> 2] | 0;
       while (1) {
        i3 = HEAP32[i16 >> 2] | 0;
        i15 = HEAP32[i16 + 4 >> 2] | 0;
        i7 = i3 + (i15 * 40 | 0) | 0;
        L286 : do if ((i15 | 0) > 0) {
         i5 = 0;
         i6 = i3;
         i15 = 0;
         do {
          i14 = HEAP32[i6 + 16 >> 2] & 32;
          i15 = (i14 | 0) == 0 ? i15 : (i15 | 0) == 0 ? i6 : i15;
          i5 = (i14 >>> 5) + i5 | 0;
          i6 = i6 + 40 | 0;
         } while (i6 >>> 0 < i7 >>> 0);
         if (i5 >>> 0 < 2) {
          if ((i5 | 0) == 1) {
           i1 = HEAP32[i15 + 36 >> 2] | 0;
           i1 = i1 - (_UNITY_FT_MulFix(HEAP32[i15 + 28 >> 2] | 0, i17) | 0) | 0;
          }
          while (1) {
           if ((i3 | 0) != (i15 | 0)) HEAP32[i3 + 36 >> 2] = (_UNITY_FT_MulFix(HEAP32[i3 + 28 >> 2] | 0, i17) | 0) + i1;
           i3 = i3 + 40 | 0;
           if (i3 >>> 0 >= i7 >>> 0) break L286;
          }
         } else i3 = i15;
         do {
          i5 = i3;
          while (1) {
           i11 = i5 + 4 | 0;
           i12 = HEAP32[i11 >> 2] | 0;
           if ((i12 | 0) == (i15 | 0)) break L286;
           if (!(HEAP32[i12 + 16 >> 2] & 32)) {
            i3 = i12;
            break;
           } else i5 = i12;
          }
          do i3 = HEAP32[i3 + 4 >> 2] | 0; while (!(HEAP32[i3 + 16 >> 2] & 32 | 0));
          i7 = HEAP32[i5 + 28 >> 2] | 0;
          i8 = HEAP32[i3 + 28 >> 2] | 0;
          i6 = HEAP32[i3 + 36 >> 2] | 0;
          i5 = HEAP32[i5 + 36 >> 2] | 0;
          if ((i7 | 0) > (i8 | 0)) {
           i10 = i5 - i6 | 0;
           i13 = i6;
           i14 = i7 - i8 | 0;
          } else {
           i10 = i6 - i5 | 0;
           i13 = i5;
           i14 = i8 - i7 | 0;
           i8 = i7;
          }
          if ((i14 | 0) > 0) {
           i9 = _UNITY_FT_DivFix(i10, i14) | 0;
           i5 = HEAP32[i11 >> 2] | 0;
          } else {
           i9 = 65536;
           i5 = i12;
          }
          i7 = i10 + i13 | 0;
          i6 = i5;
          do {
           i5 = (HEAP32[i6 + 28 >> 2] | 0) - i8 | 0;
           do if ((i5 | 0) < 1) i5 = (_UNITY_FT_MulFix(i5, i17) | 0) + i13 | 0; else if ((i5 | 0) < (i14 | 0)) {
            i5 = (_UNITY_FT_MulFix(i5, i9) | 0) + i13 | 0;
            break;
           } else {
            i5 = i7 + (_UNITY_FT_MulFix(i5 - i14 | 0, i17) | 0) | 0;
            break;
           } while (0);
           HEAP32[i6 + 36 >> 2] = i5;
           i6 = HEAP32[i6 + 4 >> 2] | 0;
          } while ((i6 | 0) != (i3 | 0));
         } while ((i3 | 0) != (i15 | 0));
        } while (0);
        i2 = i2 + -1 | 0;
        if (!i2) break; else i16 = i16 + 8 | 0;
       }
      }
      i1 = HEAP32[i37 >> 2] | 0;
      i6 = HEAP32[i20 >> 2] | 0;
      i5 = HEAP32[i6 + 4 >> 2] | 0;
      i6 = HEAP32[i6 + 8 >> 2] | 0;
      i2 = HEAP32[i38 >> 2] | 0;
      if (i2 | 0) {
       i7 = i18 ? 32 : 64;
       if (i18) {
        i3 = 0;
        while (1) {
         HEAP32[i5 + (i3 << 3) >> 2] = HEAP32[i1 + 36 >> 2];
         if (HEAP32[i1 + 16 >> 2] & 16) {
          i2 = i6 + i3 | 0;
          HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | i7;
          i2 = HEAP32[i38 >> 2] | 0;
         }
         i3 = i3 + 1 | 0;
         if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 40 | 0;
        }
       } else {
        i3 = 0;
        while (1) {
         HEAP32[i5 + (i3 << 3) + 4 >> 2] = HEAP32[i1 + 36 >> 2];
         if (HEAP32[i1 + 16 >> 2] & 16) {
          i2 = i6 + i3 | 0;
          HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | i7;
          i2 = HEAP32[i38 >> 2] | 0;
         }
         i3 = i3 + 1 | 0;
         if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 40 | 0;
        }
       }
      }
      if (!i27) _psh_globals_set_scale(HEAP32[i28 >> 2] | 0, i29, i30, 0, 0);
      i19 = i19 + 1 | 0;
      if ((i19 | 0) == 2) {
       i1 = i35;
       i5 = i38;
       i3 = i35;
       i2 = 0;
       break;
      }
     }
    } else {
     i1 = i35;
     i5 = i38;
     i3 = i35;
    }
   } else {
    i3 = i35;
    i1 = i35;
    i31 = 53;
   }
  } else {
   i3 = i35;
   i1 = i35;
   i31 = 53;
  }
 } else {
  i1 = i38 + 12 | 0;
  i3 = i1;
  i31 = 53;
 }
 if ((i31 | 0) == 53) {
  i5 = i38;
  i4 = i38 + 4 | 0;
 }
 i35 = HEAP32[i36 >> 2] | 0;
 i34 = i38 + 92 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i38 + 88 >> 2] = 0;
 HEAP32[i38 + 96 >> 2] = 0;
 i34 = i38 + 80 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 i34 = i38 + 76 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i38 + 72 >> 2] = 0;
 HEAP32[i38 + 68 >> 2] = 0;
 HEAP32[i38 + 84 >> 2] = 0;
 i34 = i38 + 52 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i38 + 48 >> 2] = 0;
 HEAP32[i38 + 56 >> 2] = 0;
 i34 = i38 + 40 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 i34 = i38 + 36 | 0;
 _UNITY_ft_mem_free(i35, HEAP32[i34 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i38 + 32 >> 2] = 0;
 HEAP32[i38 + 28 >> 2] = 0;
 HEAP32[i38 + 44 >> 2] = 0;
 _UNITY_ft_mem_free(i35, HEAP32[i37 >> 2] | 0);
 HEAP32[i37 >> 2] = 0;
 _UNITY_ft_mem_free(i35, HEAP32[i1 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 i38 = i2;
 STACKTOP = i39;
 return i38 | 0;
}

function __ZN12b2EPCollider7CollideEP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS7_(i33, i43, i13, i1, i38, i3) {
 i33 = i33 | 0;
 i43 = i43 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i38 = i38 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i45 + 72 | 0;
 i36 = i45 + 24 | 0;
 i37 = i45 + 48 | 0;
 i44 = i45;
 f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(f18 * f21);
 f19 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f19 * f6));
 f6 = Math_fround(Math_fround(f21 * f19) + Math_fround(f18 * f6));
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i1 >> 2]));
 f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f9 = Math_fround(Math_fround(f18 * f21) + Math_fround(f19 * f20));
 f21 = Math_fround(Math_fround(f18 * f20) - Math_fround(f19 * f21));
 i39 = i33 + 132 | 0;
 HEAPF32[i39 >> 2] = f9;
 i40 = i33 + 136 | 0;
 HEAPF32[i40 >> 2] = f21;
 i41 = i33 + 140 | 0;
 HEAPF32[i41 >> 2] = f2;
 i42 = i33 + 144 | 0;
 HEAPF32[i42 >> 2] = f6;
 f19 = Math_fround(HEAPF32[i38 + 12 >> 2]);
 f20 = Math_fround(f6 * f19);
 f18 = Math_fround(HEAPF32[i38 + 16 >> 2]);
 f20 = Math_fround(f9 + Math_fround(f20 - Math_fround(f2 * f18)));
 f21 = Math_fround(Math_fround(Math_fround(f19 * f2) + Math_fround(f6 * f18)) + f21);
 HEAPF32[i33 + 148 >> 2] = f20;
 HEAPF32[i33 + 152 >> 2] = f21;
 i28 = i13 + 28 | 0;
 i27 = HEAP32[i28 >> 2] | 0;
 i28 = HEAP32[i28 + 4 >> 2] | 0;
 i14 = i33 + 156 | 0;
 HEAP32[i14 >> 2] = i27;
 HEAP32[i14 + 4 >> 2] = i28;
 i14 = i33 + 164 | 0;
 i32 = i13 + 12 | 0;
 i34 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 4 >> 2] | 0;
 i25 = i14;
 HEAP32[i25 >> 2] = i34;
 HEAP32[i25 + 4 >> 2] = i32;
 i25 = i33 + 172 | 0;
 i35 = i13 + 20 | 0;
 i24 = HEAP32[i35 >> 2] | 0;
 i35 = HEAP32[i35 + 4 >> 2] | 0;
 i31 = i25;
 HEAP32[i31 >> 2] = i24;
 HEAP32[i31 + 4 >> 2] = i35;
 i31 = i13 + 36 | 0;
 i29 = HEAP32[i31 >> 2] | 0;
 i31 = HEAP32[i31 + 4 >> 2] | 0;
 i1 = i33 + 180 | 0;
 HEAP32[i1 >> 2] = i29;
 HEAP32[i1 + 4 >> 2] = i31;
 i1 = HEAP16[i13 + 44 >> 1] | 0;
 i3 = (i1 & 255) << 24 >> 24 != 0;
 i1 = (i1 & 65535) > 255;
 f18 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(f18 - f6);
 i34 = i33 + 176 | 0;
 f19 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i35 = i33 + 168 | 0;
 f9 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f19 - f9);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f5 * f5))));
 i32 = f4 < Math_fround(1.1920929e-07);
 f10 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i32) f26 = f2; else {
  f17 = Math_fround(Math_fround(1.0) / f4);
  f26 = Math_fround(f2 * f17);
  f5 = Math_fround(f5 * f17);
 }
 i24 = i33 + 196 | 0;
 f17 = Math_fround(-f26);
 HEAPF32[i24 >> 2] = f5;
 i32 = i33 + 200 | 0;
 HEAPF32[i32 >> 2] = f17;
 f17 = Math_fround(Math_fround(Math_fround(f20 - f6) * f5) + Math_fround(Math_fround(f21 - f9) * f17));
 if (i3) {
  f6 = Math_fround(f6 - f10);
  f2 = Math_fround(f9 - f11);
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f2 * f2))));
  if (f4 < Math_fround(1.1920929e-07)) f4 = f6; else {
   f9 = Math_fround(Math_fround(1.0) / f4);
   f4 = Math_fround(f6 * f9);
   f2 = Math_fround(f2 * f9);
  }
  f9 = Math_fround(-f4);
  HEAPF32[i33 + 188 >> 2] = f2;
  HEAPF32[i33 + 192 >> 2] = f9;
  f9 = Math_fround(Math_fround(Math_fround(f20 - f10) * f2) + Math_fround(Math_fround(f21 - f11) * f9));
  i8 = Math_fround(Math_fround(f5 * f4) - Math_fround(f26 * f2)) >= Math_fround(0.0);
 } else {
  f9 = Math_fround(0.0);
  i8 = 0;
 }
 do if (i1) {
  f4 = Math_fround(f12 - f18);
  f6 = Math_fround(f16 - f19);
  f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6))));
  if (!(f2 < Math_fround(1.1920929e-07))) {
   f16 = Math_fround(Math_fround(1.0) / f2);
   f4 = Math_fround(f4 * f16);
   f6 = Math_fround(f6 * f16);
  }
  f2 = Math_fround(-f4);
  HEAPF32[i33 + 204 >> 2] = f6;
  HEAPF32[i33 + 208 >> 2] = f2;
  i7 = Math_fround(Math_fround(f26 * f6) - Math_fround(f5 * f4)) > Math_fround(0.0);
  f2 = Math_fround(Math_fround(Math_fround(f20 - f18) * f6) + Math_fround(Math_fround(f21 - f19) * f2));
  if (!i3) {
   i3 = f17 >= Math_fround(0.0);
   i1 = f2 >= Math_fround(0.0);
   if (i7) {
    i31 = i3 | i1;
    HEAP8[i33 + 248 >> 0] = i31 & 1;
    i1 = i33 + 212 | 0;
    if (i31) {
     i31 = i24;
     i28 = HEAP32[i31 >> 2] | 0;
     i31 = HEAP32[i31 + 4 >> 2] | 0;
     i29 = i1;
     HEAP32[i29 >> 2] = i28;
     HEAP32[i29 + 4 >> 2] = i31;
     HEAPF32[i33 + 228 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     HEAPF32[i33 + 232 >> 2] = f26;
     i28 = i33 + 204 | 0;
     i29 = HEAP32[i28 + 4 >> 2] | 0;
     i31 = i33 + 236 | 0;
     HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 + 4 >> 2] = i29;
     break;
    } else {
     f21 = Math_fround(-f5);
     HEAPF32[i1 >> 2] = f21;
     HEAPF32[i33 + 216 >> 2] = f26;
     HEAPF32[i33 + 228 >> 2] = f21;
     HEAPF32[i33 + 232 >> 2] = f26;
     i28 = i24;
     i29 = HEAP32[i28 + 4 >> 2] | 0;
     i31 = i33 + 236 | 0;
     HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 + 4 >> 2] = i29;
     break;
    }
   } else {
    i31 = i3 & i1;
    HEAP8[i33 + 248 >> 0] = i31 & 1;
    i1 = i33 + 212 | 0;
    if (i31) {
     i29 = i24;
     i28 = HEAP32[i29 >> 2] | 0;
     i29 = HEAP32[i29 + 4 >> 2] | 0;
     i31 = i1;
     HEAP32[i31 >> 2] = i28;
     HEAP32[i31 + 4 >> 2] = i29;
     HEAPF32[i33 + 228 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     HEAPF32[i33 + 232 >> 2] = f26;
     i31 = i33 + 236 | 0;
     HEAP32[i31 >> 2] = i28;
     HEAP32[i31 + 4 >> 2] = i29;
     break;
    } else {
     HEAPF32[i1 >> 2] = Math_fround(-f5);
     HEAPF32[i33 + 216 >> 2] = f26;
     f21 = Math_fround(-Math_fround(HEAPF32[i33 + 204 >> 2]));
     f26 = Math_fround(-Math_fround(HEAPF32[i33 + 208 >> 2]));
     HEAPF32[i33 + 228 >> 2] = f21;
     HEAPF32[i33 + 232 >> 2] = f26;
     i28 = i24;
     i29 = HEAP32[i28 + 4 >> 2] | 0;
     i31 = i33 + 236 | 0;
     HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 + 4 >> 2] = i29;
     break;
    }
   }
  }
  if (i8 & i7) {
   i31 = f17 >= Math_fround(0.0) | f9 >= Math_fround(0.0) | f2 >= Math_fround(0.0);
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (i31) {
    i28 = i24;
    i29 = HEAP32[i28 + 4 >> 2] | 0;
    i31 = i1;
    HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i31 + 4 >> 2] = i29;
    i31 = i33 + 188 | 0;
    i29 = HEAP32[i31 + 4 >> 2] | 0;
    i28 = i33 + 228 | 0;
    HEAP32[i28 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i28 + 4 >> 2] = i29;
    i28 = i33 + 204 | 0;
    i29 = HEAP32[i28 + 4 >> 2] | 0;
    i31 = i33 + 236 | 0;
    HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i31 + 4 >> 2] = i29;
    break;
   } else {
    f21 = Math_fround(-f5);
    HEAPF32[i1 >> 2] = f21;
    HEAPF32[i33 + 216 >> 2] = f26;
    HEAPF32[i33 + 228 >> 2] = f21;
    HEAPF32[i33 + 232 >> 2] = f26;
    HEAPF32[i33 + 236 >> 2] = f21;
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   }
  }
  if (i8) {
   if (!(f9 >= Math_fround(0.0))) {
    i31 = f17 >= Math_fround(0.0) & f2 >= Math_fround(0.0);
    HEAP8[i33 + 248 >> 0] = i31 & 1;
    i1 = i33 + 212 | 0;
    if (!i31) {
     f21 = Math_fround(-f5);
     HEAPF32[i1 >> 2] = f21;
     HEAPF32[i33 + 216 >> 2] = f26;
     HEAPF32[i33 + 228 >> 2] = Math_fround(-f6);
     HEAPF32[i33 + 232 >> 2] = f4;
     HEAPF32[i33 + 236 >> 2] = f21;
     HEAPF32[i33 + 240 >> 2] = f26;
     break;
    }
   } else {
    HEAP8[i33 + 248 >> 0] = 1;
    i1 = i33 + 212 | 0;
   }
   i28 = i24;
   i29 = HEAP32[i28 + 4 >> 2] | 0;
   i31 = i1;
   HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i31 + 4 >> 2] = i29;
   i31 = i33 + 188 | 0;
   i29 = HEAP32[i31 + 4 >> 2] | 0;
   i28 = i33 + 228 | 0;
   HEAP32[i28 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i28 + 4 >> 2] = i29;
   i28 = i24;
   i29 = HEAP32[i28 + 4 >> 2] | 0;
   i31 = i33 + 236 | 0;
   HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i31 + 4 >> 2] = i29;
   break;
  }
  if (!i7) {
   i31 = f17 >= Math_fround(0.0) & f9 >= Math_fround(0.0) & f2 >= Math_fround(0.0);
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (i31) {
    i29 = i24;
    i28 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    i31 = i1;
    HEAP32[i31 >> 2] = i28;
    HEAP32[i31 + 4 >> 2] = i29;
    i31 = i33 + 228 | 0;
    HEAP32[i31 >> 2] = i28;
    HEAP32[i31 + 4 >> 2] = i29;
    i31 = i33 + 236 | 0;
    HEAP32[i31 >> 2] = i28;
    HEAP32[i31 + 4 >> 2] = i29;
    break;
   } else {
    HEAPF32[i1 >> 2] = Math_fround(-f5);
    HEAPF32[i33 + 216 >> 2] = f26;
    HEAPF32[i33 + 228 >> 2] = Math_fround(-f6);
    HEAPF32[i33 + 232 >> 2] = f4;
    f21 = Math_fround(-Math_fround(HEAPF32[i33 + 188 >> 2]));
    f26 = Math_fround(-Math_fround(HEAPF32[i33 + 192 >> 2]));
    HEAPF32[i33 + 236 >> 2] = f21;
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   }
  }
  if (!(f2 >= Math_fround(0.0))) {
   i31 = f17 >= Math_fround(0.0) & f9 >= Math_fround(0.0);
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (!i31) {
    f21 = Math_fround(-f5);
    HEAPF32[i1 >> 2] = f21;
    HEAPF32[i33 + 216 >> 2] = f26;
    HEAPF32[i33 + 228 >> 2] = f21;
    HEAPF32[i33 + 232 >> 2] = f26;
    f21 = Math_fround(-Math_fround(HEAPF32[i33 + 188 >> 2]));
    f26 = Math_fround(-Math_fround(HEAPF32[i33 + 192 >> 2]));
    HEAPF32[i33 + 236 >> 2] = f21;
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   }
  } else {
   HEAP8[i33 + 248 >> 0] = 1;
   i1 = i33 + 212 | 0;
  }
  i29 = i24;
  i31 = HEAP32[i29 >> 2] | 0;
  i29 = HEAP32[i29 + 4 >> 2] | 0;
  i28 = i1;
  HEAP32[i28 >> 2] = i31;
  HEAP32[i28 + 4 >> 2] = i29;
  i28 = i33 + 228 | 0;
  HEAP32[i28 >> 2] = i31;
  HEAP32[i28 + 4 >> 2] = i29;
  i28 = i33 + 204 | 0;
  i29 = HEAP32[i28 + 4 >> 2] | 0;
  i31 = i33 + 236 | 0;
  HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i31 + 4 >> 2] = i29;
 } else {
  if (!i3) {
   i31 = f17 >= Math_fround(0.0);
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (i31) {
    i28 = i24;
    i31 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i29 = i1;
    HEAP32[i29 >> 2] = i31;
    HEAP32[i29 + 4 >> 2] = i28;
    f21 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i33 + 228 >> 2] = f21;
    HEAPF32[i33 + 232 >> 2] = f26;
    HEAPF32[i33 + 236 >> 2] = f21;
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   } else {
    HEAPF32[i1 >> 2] = Math_fround(-f5);
    HEAPF32[i33 + 216 >> 2] = f26;
    i29 = i24;
    i28 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    i31 = i33 + 228 | 0;
    HEAP32[i31 >> 2] = i28;
    HEAP32[i31 + 4 >> 2] = i29;
    i31 = i33 + 236 | 0;
    HEAP32[i31 >> 2] = i28;
    HEAP32[i31 + 4 >> 2] = i29;
    break;
   }
  }
  i3 = f9 >= Math_fround(0.0);
  i1 = f17 >= Math_fround(0.0);
  if (i8) {
   i31 = i1 | i3;
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (i31) {
    i28 = i24;
    i31 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i27 = i1;
    HEAP32[i27 >> 2] = i31;
    HEAP32[i27 + 4 >> 2] = i28;
    i27 = i33 + 188 | 0;
    i28 = HEAP32[i27 + 4 >> 2] | 0;
    i29 = i33 + 228 | 0;
    HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i29 + 4 >> 2] = i28;
    HEAPF32[i33 + 236 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   } else {
    HEAPF32[i1 >> 2] = Math_fround(-f5);
    HEAPF32[i33 + 216 >> 2] = f26;
    i28 = i24;
    i31 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i29 = i33 + 228 | 0;
    HEAP32[i29 >> 2] = i31;
    HEAP32[i29 + 4 >> 2] = i28;
    HEAPF32[i33 + 236 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   }
  } else {
   i31 = i1 & i3;
   HEAP8[i33 + 248 >> 0] = i31 & 1;
   i1 = i33 + 212 | 0;
   if (i31) {
    i28 = i24;
    i31 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i29 = i1;
    HEAP32[i29 >> 2] = i31;
    HEAP32[i29 + 4 >> 2] = i28;
    i29 = i33 + 228 | 0;
    HEAP32[i29 >> 2] = i31;
    HEAP32[i29 + 4 >> 2] = i28;
    HEAPF32[i33 + 236 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   } else {
    HEAPF32[i1 >> 2] = Math_fround(-f5);
    HEAPF32[i33 + 216 >> 2] = f26;
    i28 = i24;
    i29 = HEAP32[i28 + 4 >> 2] | 0;
    i31 = i33 + 228 | 0;
    HEAP32[i31 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i31 + 4 >> 2] = i29;
    f21 = Math_fround(-Math_fround(HEAPF32[i33 + 188 >> 2]));
    f26 = Math_fround(-Math_fround(HEAPF32[i33 + 192 >> 2]));
    HEAPF32[i33 + 236 >> 2] = f21;
    HEAPF32[i33 + 240 >> 2] = f26;
    break;
   }
  }
 } while (0);
 i3 = i38 + 148 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = i33 + 128 | 0;
 HEAP32[i8 >> 2] = i1;
 if ((i1 | 0) > 0) {
  i1 = 0;
  do {
   f19 = Math_fround(HEAPF32[i42 >> 2]);
   f21 = Math_fround(HEAPF32[i38 + 20 + (i1 << 3) >> 2]);
   f18 = Math_fround(f19 * f21);
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f26 = Math_fround(HEAPF32[i38 + 20 + (i1 << 3) + 4 >> 2]);
   f18 = Math_fround(f18 - Math_fround(f20 * f26));
   f18 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) + f18);
   f26 = Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f26));
   f26 = Math_fround(f26 + Math_fround(HEAPF32[i40 >> 2]));
   HEAPF32[i33 + (i1 << 3) >> 2] = f18;
   HEAPF32[i33 + (i1 << 3) + 4 >> 2] = f26;
   f26 = Math_fround(HEAPF32[i42 >> 2]);
   f18 = Math_fround(HEAPF32[i38 + 84 + (i1 << 3) >> 2]);
   f19 = Math_fround(f26 * f18);
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f21 = Math_fround(HEAPF32[i38 + 84 + (i1 << 3) + 4 >> 2]);
   f26 = Math_fround(Math_fround(f18 * f20) + Math_fround(f26 * f21));
   HEAPF32[i33 + 64 + (i1 << 3) >> 2] = Math_fround(f19 - Math_fround(f20 * f21));
   HEAPF32[i33 + 64 + (i1 << 3) + 4 >> 2] = f26;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 f12 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i13 + 8 >> 2]));
 i29 = i33 + 244 | 0;
 HEAPF32[i29 >> 2] = f12;
 i31 = i43 + 60 | 0;
 HEAP32[i31 >> 2] = 0;
 i13 = i33 + 248 | 0;
 if ((i1 | 0) > 0) {
  f2 = Math_fround(HEAPF32[i33 + 164 >> 2]);
  f5 = Math_fround(HEAPF32[i35 >> 2]);
  f6 = Math_fround(HEAPF32[i33 + 212 >> 2]);
  f9 = Math_fround(HEAPF32[i33 + 216 >> 2]);
  i3 = 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
  f11 = Math_fround(3402823469999999843913219.0e14);
  while (1) {
   f10 = Math_fround(Math_fround(HEAPF32[i33 + (i3 << 3) >> 2]) - f2);
   f10 = Math_fround(Math_fround(f6 * f10) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i33 + (i3 << 3) + 4 >> 2]) - f5)));
   i7 = f10 < f11;
   f4 = i7 ? f10 : f4;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else f11 = i7 ? f10 : f11;
  }
 } else f4 = Math_fround(3402823469999999843913219.0e14);
 if (f4 > f12) {
  STACKTOP = i45;
  return;
 }
 __ZN12b2EPCollider24ComputePolygonSeparationEv(i15, i33);
 i3 = HEAP32[i15 >> 2] | 0;
 if (!i3) i30 = 58; else {
  f2 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  if (!(f2 > Math_fround(HEAPF32[i29 >> 2]))) if (f2 > Math_fround(Math_fround(f4 * Math_fround(.980000019)) + Math_fround(.00100000005))) {
   i7 = HEAP32[i15 + 4 >> 2] | 0;
   i1 = i43 + 56 | 0;
   if ((i3 | 0) == 1) {
    i22 = i36;
    i30 = 60;
   } else {
    HEAP32[i1 >> 2] = 2;
    i27 = i14;
    i13 = HEAP32[i27 >> 2] | 0;
    i27 = HEAP32[i27 + 4 >> 2] | 0;
    i23 = i36;
    HEAP32[i23 >> 2] = i13;
    HEAP32[i23 + 4 >> 2] = i27;
    i23 = i36 + 8 | 0;
    HEAP8[i23 >> 0] = 0;
    i3 = i7 & 255;
    HEAP8[i23 + 1 >> 0] = i3;
    HEAP8[i23 + 2 >> 0] = 0;
    HEAP8[i23 + 3 >> 0] = 1;
    i23 = i36 + 12 | 0;
    i1 = i25;
    i28 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i15 = i23;
    HEAP32[i15 >> 2] = i28;
    HEAP32[i15 + 4 >> 2] = i1;
    i15 = i36 + 20 | 0;
    HEAP8[i15 >> 0] = 0;
    HEAP8[i15 + 1 >> 0] = i3;
    HEAP8[i15 + 2 >> 0] = 0;
    HEAP8[i15 + 3 >> 0] = 1;
    i15 = i7 + 1 | 0;
    i8 = (i15 | 0) < (HEAP32[i8 >> 2] | 0) ? i15 : 0;
    f2 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i28 = i7;
    i27 = i8 & 255;
    i13 = i33 + (i7 << 3) | 0;
    i15 = i33 + (i7 << 3) + 4 | 0;
    i14 = i33 + (i8 << 3) | 0;
    i8 = i33 + (i8 << 3) + 4 | 0;
    i25 = HEAP32[i33 + 64 + (i7 << 3) >> 2] | 0;
    i24 = HEAP32[i33 + 64 + (i7 << 3) + 4 >> 2] | 0;
    f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i1 = i36;
    i22 = 0;
    i30 = 67;
   }
  } else i30 = 58;
 }
 if ((i30 | 0) == 58) {
  i1 = i43 + 56 | 0;
  i22 = i36;
  i30 = 60;
 }
 do if ((i30 | 0) == 60) {
  HEAP32[i1 >> 2] = 1;
  i8 = HEAP32[i8 >> 2] | 0;
  if ((i8 | 0) > 1) {
   f4 = Math_fround(HEAPF32[i33 + 212 >> 2]);
   f2 = Math_fround(f4 * Math_fround(HEAPF32[i33 + 64 >> 2]));
   f5 = Math_fround(HEAPF32[i33 + 216 >> 2]);
   i3 = 1;
   f2 = Math_fround(f2 + Math_fround(f5 * Math_fround(HEAPF32[i33 + 68 >> 2])));
   i1 = 0;
   while (1) {
    f6 = Math_fround(f4 * Math_fround(HEAPF32[i33 + 64 + (i3 << 3) >> 2]));
    f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i33 + 64 + (i3 << 3) + 4 >> 2])));
    i7 = f6 < f2;
    i1 = i7 ? i3 : i1;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i8 | 0)) break; else f2 = i7 ? f6 : f2;
   }
  } else i1 = 0;
  i23 = i1 + 1 | 0;
  i23 = (i23 | 0) < (i8 | 0) ? i23 : 0;
  i28 = i33 + (i1 << 3) | 0;
  i27 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i30 = i36;
  HEAP32[i30 >> 2] = i27;
  HEAP32[i30 + 4 >> 2] = i28;
  i30 = i36 + 8 | 0;
  HEAP8[i30 >> 0] = 0;
  i3 = i1 & 255;
  HEAP8[i30 + 1 >> 0] = i3;
  HEAP8[i30 + 2 >> 0] = 1;
  HEAP8[i30 + 3 >> 0] = 0;
  i1 = i36 + 12 | 0;
  i33 = i33 + (i23 << 3) | 0;
  i30 = HEAP32[i33 >> 2] | 0;
  i33 = HEAP32[i33 + 4 >> 2] | 0;
  i15 = i1;
  HEAP32[i15 >> 2] = i30;
  HEAP32[i15 + 4 >> 2] = i33;
  i36 = i36 + 20 | 0;
  HEAP8[i36 >> 0] = 0;
  HEAP8[i36 + 1 >> 0] = i23;
  HEAP8[i36 + 2 >> 0] = 1;
  HEAP8[i36 + 3 >> 0] = 0;
  f2 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(HEAP8[i13 >> 0] | 0)) {
   f9 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
   f10 = Math_fround(-Math_fround(HEAPF32[i32 >> 2]));
   i24 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i23 = i1;
   i28 = 1;
   i27 = 0;
   i13 = i25;
   i15 = i34;
   i8 = i35;
   i25 = i24;
   i24 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   f10 = f5;
   f9 = f6;
   i1 = i22;
   i22 = 1;
   i30 = 67;
   break;
  } else {
   i23 = i1;
   i28 = 0;
   i27 = 1;
   i13 = i14;
   i15 = i35;
   i14 = i25;
   i8 = i34;
   i25 = HEAP32[i24 >> 2] | 0;
   i24 = HEAP32[i32 >> 2] | 0;
   f10 = f5;
   f9 = f6;
   i1 = i22;
   i22 = 1;
   i30 = 67;
   break;
  }
 } while (0);
 if ((i30 | 0) == 67) {
  i13 = HEAP32[i13 >> 2] | 0;
  i7 = HEAP32[i15 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i14 >> 2]);
  f12 = Math_fround(HEAPF32[i8 >> 2]);
  f17 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(-f18);
  f16 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f17 * f16);
  f19 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f6 + Math_fround(f19 * f26));
  f11 = Math_fround(-f17);
  f12 = Math_fround(Math_fround(f5 * f11) + Math_fround(f18 * f12));
  f5 = Math_fround(Math_fround(Math_fround(f17 * f2) + Math_fround(f4 * f26)) - f6);
  f6 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f9 * f26)) - f6);
  if (!(f5 <= Math_fround(0.0))) i1 = 0; else {
   HEAP32[i37 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = 1;
  }
  if (f6 <= Math_fround(0.0)) {
   i36 = i37 + (i1 * 12 | 0) | 0;
   HEAP32[i36 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   i1 = i1 + 1 | 0;
  }
  if (Math_fround(f5 * f6) < Math_fround(0.0)) {
   f21 = Math_fround(f5 / Math_fround(f5 - f6));
   f26 = Math_fround(f4 + Math_fround(f21 * Math_fround(f9 - f4)));
   HEAPF32[i37 + (i1 * 12 | 0) >> 2] = Math_fround(f2 + Math_fround(f21 * Math_fround(f10 - f2)));
   HEAPF32[i37 + (i1 * 12 | 0) + 4 >> 2] = f26;
   i36 = i37 + (i1 * 12 | 0) + 8 | 0;
   HEAP8[i36 >> 0] = i28;
   HEAP8[i36 + 1 >> 0] = i3;
   HEAP8[i36 + 2 >> 0] = 0;
   HEAP8[i36 + 3 >> 0] = 1;
   i1 = i1 + 1 | 0;
  }
  if ((i1 | 0) >= 2) {
   f5 = Math_fround(HEAPF32[i37 >> 2]);
   f9 = Math_fround(f5 * f11);
   f6 = Math_fround(HEAPF32[i37 + 4 >> 2]);
   f9 = Math_fround(Math_fround(f9 + Math_fround(f18 * f6)) - f12);
   i3 = i37 + 12 | 0;
   f10 = Math_fround(HEAPF32[i3 >> 2]);
   f2 = Math_fround(f10 * f11);
   f4 = Math_fround(HEAPF32[i37 + 16 >> 2]);
   f2 = Math_fround(Math_fround(f2 + Math_fround(f18 * f4)) - f12);
   if (!(f9 <= Math_fround(0.0))) i1 = 0; else {
    HEAP32[i44 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i44 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i44 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    i1 = 1;
   }
   if (f2 <= Math_fround(0.0)) {
    i36 = i44 + (i1 * 12 | 0) | 0;
    HEAP32[i36 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   if (Math_fround(f9 * f2) < Math_fround(0.0)) {
    f21 = Math_fround(f9 / Math_fround(f9 - f2));
    f26 = Math_fround(f6 + Math_fround(f21 * Math_fround(f4 - f6)));
    HEAPF32[i44 + (i1 * 12 | 0) >> 2] = Math_fround(f5 + Math_fround(f21 * Math_fround(f10 - f5)));
    HEAPF32[i44 + (i1 * 12 | 0) + 4 >> 2] = f26;
    i36 = i44 + (i1 * 12 | 0) + 8 | 0;
    HEAP8[i36 >> 0] = i27;
    HEAP8[i36 + 1 >> 0] = HEAP8[i37 + 8 + 1 >> 0] | 0;
    HEAP8[i36 + 2 >> 0] = 0;
    HEAP8[i36 + 3 >> 0] = 1;
    i1 = i1 + 1 | 0;
   }
   if ((i1 | 0) >= 2) {
    i1 = i43 + 40 | 0;
    do if (i22) {
     HEAP32[i1 >> 2] = i25;
     HEAP32[i43 + 44 >> 2] = i24;
     HEAP32[i43 + 48 >> 2] = i13;
     HEAP32[i43 + 52 >> 2] = i7;
     f2 = Math_fround(HEAPF32[i44 >> 2]);
     f26 = Math_fround(f2 - f16);
     f4 = Math_fround(HEAPF32[i44 + 4 >> 2]);
     f26 = Math_fround(Math_fround(f18 * f26) + Math_fround(f17 * Math_fround(f4 - f19)));
     f5 = Math_fround(HEAPF32[i29 >> 2]);
     if (!(f26 <= f5)) i1 = 0; else {
      f5 = Math_fround(f2 - Math_fround(HEAPF32[i39 >> 2]));
      f21 = Math_fround(f4 - Math_fround(HEAPF32[i40 >> 2]));
      f12 = Math_fround(HEAPF32[i42 >> 2]);
      f20 = Math_fround(f5 * f12);
      f26 = Math_fround(HEAPF32[i41 >> 2]);
      f5 = Math_fround(Math_fround(f12 * f21) - Math_fround(f5 * f26));
      HEAPF32[i43 >> 2] = Math_fround(f20 + Math_fround(f21 * f26));
      HEAPF32[i43 + 4 >> 2] = f5;
      HEAP32[i43 + 16 >> 2] = HEAP32[i44 + 8 >> 2];
      i1 = 1;
      f5 = Math_fround(HEAPF32[i29 >> 2]);
     }
     f4 = Math_fround(HEAPF32[i44 + 12 >> 2]);
     f26 = Math_fround(f4 - f16);
     f2 = Math_fround(HEAPF32[i44 + 16 >> 2]);
     if (!(Math_fround(Math_fround(f18 * f26) + Math_fround(f17 * Math_fround(f2 - f19))) <= f5)) break;
     f26 = Math_fround(f4 - Math_fround(HEAPF32[i39 >> 2]));
     f20 = Math_fround(f2 - Math_fround(HEAPF32[i40 >> 2]));
     f18 = Math_fround(HEAPF32[i42 >> 2]);
     f19 = Math_fround(f26 * f18);
     f21 = Math_fround(HEAPF32[i41 >> 2]);
     f26 = Math_fround(Math_fround(f18 * f20) - Math_fround(f26 * f21));
     HEAPF32[i43 + (i1 * 20 | 0) >> 2] = Math_fround(f19 + Math_fround(f20 * f21));
     HEAPF32[i43 + (i1 * 20 | 0) + 4 >> 2] = f26;
     HEAP32[i43 + (i1 * 20 | 0) + 16 >> 2] = HEAP32[i44 + 20 >> 2];
     i1 = i1 + 1 | 0;
    } else {
     i42 = i38 + 84 + (i28 << 3) | 0;
     i41 = HEAP32[i42 + 4 >> 2] | 0;
     i40 = i1;
     HEAP32[i40 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i40 + 4 >> 2] = i41;
     i40 = i38 + 20 + (i28 << 3) | 0;
     i41 = HEAP32[i40 + 4 >> 2] | 0;
     i42 = i43 + 48 | 0;
     HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
     HEAP32[i42 + 4 >> 2] = i41;
     f26 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f16);
     f26 = Math_fround(Math_fround(f18 * f26) + Math_fround(f17 * Math_fround(Math_fround(HEAPF32[i44 + 4 >> 2]) - f19)));
     f2 = Math_fround(HEAPF32[i29 >> 2]);
     if (!(f26 <= f2)) i1 = 0; else {
      i41 = i44;
      i1 = HEAP32[i41 + 4 >> 2] | 0;
      i42 = i43;
      HEAP32[i42 >> 2] = HEAP32[i41 >> 2];
      HEAP32[i42 + 4 >> 2] = i1;
      i42 = i44 + 8 | 0;
      i1 = i43 + 16 | 0;
      HEAP8[i1 + 2 >> 0] = HEAP8[i42 + 3 >> 0] | 0;
      HEAP8[i1 + 3 >> 0] = HEAP8[i42 + 2 >> 0] | 0;
      HEAP8[i1 >> 0] = HEAP8[i42 + 1 >> 0] | 0;
      HEAP8[i1 + 1 >> 0] = HEAP8[i42 >> 0] | 0;
      i1 = 1;
      f2 = Math_fround(HEAPF32[i29 >> 2]);
     }
     i3 = i44 + 12 | 0;
     f26 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f16);
     if (!(Math_fround(Math_fround(f18 * f26) + Math_fround(f17 * Math_fround(Math_fround(HEAPF32[i44 + 16 >> 2]) - f19))) <= f2)) break;
     i40 = i3;
     i41 = HEAP32[i40 + 4 >> 2] | 0;
     i42 = i43 + (i1 * 20 | 0) | 0;
     HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
     HEAP32[i42 + 4 >> 2] = i41;
     i42 = i44 + 20 | 0;
     i44 = i43 + (i1 * 20 | 0) + 16 | 0;
     HEAP8[i44 + 2 >> 0] = HEAP8[i42 + 3 >> 0] | 0;
     HEAP8[i44 + 3 >> 0] = HEAP8[i42 + 2 >> 0] | 0;
     HEAP8[i44 >> 0] = HEAP8[i42 + 1 >> 0] | 0;
     HEAP8[i44 + 1 >> 0] = HEAP8[i42 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while (0);
    HEAP32[i31 >> 2] = i1;
   }
  }
 }
 STACKTOP = i45;
 return;
}

function __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE(i5, i148, i144, i4, i143, i6, i2) {
 i5 = i5 | 0;
 i148 = i148 | 0;
 i144 = i144 | 0;
 i4 = i4 | 0;
 i143 = i143 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i145 = 0, i146 = 0, i147 = 0, i149 = 0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, i154 = 0, f155 = f0, i156 = 0, f157 = f0, i158 = 0, f159 = f0, i160 = 0, f161 = f0, i162 = 0, f163 = f0, i164 = 0, f165 = f0, i166 = 0, f167 = f0, i168 = 0, f169 = f0, i170 = 0, f171 = f0, i172 = 0, f173 = f0, i174 = 0, f175 = f0, i176 = 0, f177 = f0, i178 = 0, f179 = f0, i180 = 0, f181 = f0, i182 = 0, f183 = f0, i184 = 0, f185 = f0, i186 = 0, f187 = f0, i188 = 0, f189 = f0, i190 = 0, f191 = f0, i192 = 0, f193 = f0, i194 = 0, f195 = f0, i196 = 0, f197 = f0, i198 = 0, f199 = f0, f200 = f0, f201 = f0;
 i149 = STACKTOP;
 STACKTOP = STACKTOP + 2208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i137 = i149 + 1664 | 0;
 i142 = i149 + 640 | 0;
 i1 = i149 + 2192 | 0;
 i145 = i149 + 1680 | 0;
 i146 = i149 + 352 | 0;
 i138 = i149 + 496 | 0;
 i139 = i149 + 208 | 0;
 i140 = i149 + 192 | 0;
 i147 = i149 + 48 | 0;
 i141 = i149;
 if (!i6) {
  STACKTOP = i149;
  return;
 }
 i7 = i143 >>> 0 > 1;
 if (i7) {
  i3 = 1;
  do {
   HEAP32[i142 + (i3 << 4) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
   i136 = i142 + (i3 << 4) + 4 | 0;
   HEAP32[i136 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i136 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i136 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i143 | 0));
 }
 i132 = HEAP32[i2 >> 2] | 0;
 i133 = i2 + 8 | 0;
 i134 = HEAP32[i133 >> 2] | 0;
 i135 = i132 + i134 | 0;
 i136 = i143 * 144 | 0;
 i134 = i134 + i136 | 0;
 i132 = i132 + i134 | 0;
 HEAP32[i133 >> 2] = i134 + i136;
 i133 = i5 + (((HEAPU16[i5 + 8 >> 1] | 0) * 432 | 0) + (HEAPU16[i5 + 24 >> 1] | 0)) | 0;
 i134 = i5 + (HEAPU16[i5 + 10 >> 1] | 0) | 0;
 if (i143 | 0) {
  i1 = 0;
  do {
   i131 = i145 + (i1 << 3) | 0;
   HEAP32[i131 >> 2] = HEAPU8[i5 + 64 + i1 >> 0];
   HEAP32[i131 + 4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i143 | 0));
 }
 i1 = i6 + -1 | 0;
 i64 = i140 + 4 | 0;
 i65 = i140 + 8 | 0;
 i66 = i140 + 12 | 0;
 i67 = i139 + 4 | 0;
 i68 = i139 + 8 | 0;
 i69 = i139 + 16 | 0;
 i70 = i139 + 20 | 0;
 i71 = i139 + 24 | 0;
 i72 = i139 + 32 | 0;
 i73 = i139 + 36 | 0;
 i74 = i139 + 40 | 0;
 i75 = i139 + 48 | 0;
 i76 = i139 + 52 | 0;
 i77 = i139 + 56 | 0;
 i78 = i139 + 64 | 0;
 i79 = i139 + 68 | 0;
 i80 = i139 + 72 | 0;
 i81 = i139 + 80 | 0;
 i82 = i139 + 84 | 0;
 i83 = i139 + 88 | 0;
 i84 = i139 + 96 | 0;
 i85 = i139 + 100 | 0;
 i86 = i139 + 104 | 0;
 i87 = i139 + 112 | 0;
 i88 = i139 + 116 | 0;
 i89 = i139 + 120 | 0;
 i90 = i139 + 128 | 0;
 i91 = i139 + 132 | 0;
 i92 = i139 + 136 | 0;
 i93 = i146 + 4 | 0;
 i94 = i146 + 8 | 0;
 i95 = i146 + 12 | 0;
 i96 = i146 + 16 | 0;
 i97 = i146 + 20 | 0;
 i98 = i146 + 24 | 0;
 i99 = i146 + 28 | 0;
 i100 = i146 + 32 | 0;
 i101 = i146 + 36 | 0;
 i102 = i146 + 40 | 0;
 i103 = i146 + 44 | 0;
 i104 = i146 + 48 | 0;
 i105 = i146 + 52 | 0;
 i106 = i146 + 56 | 0;
 i107 = i146 + 60 | 0;
 i108 = i146 + 64 | 0;
 i109 = i146 + 68 | 0;
 i110 = i146 + 72 | 0;
 i111 = i146 + 76 | 0;
 i112 = i146 + 80 | 0;
 i113 = i146 + 84 | 0;
 i114 = i146 + 88 | 0;
 i115 = i146 + 92 | 0;
 i116 = i146 + 96 | 0;
 i117 = i146 + 100 | 0;
 i118 = i146 + 104 | 0;
 i119 = i146 + 108 | 0;
 i120 = i146 + 112 | 0;
 i121 = i146 + 116 | 0;
 i122 = i146 + 120 | 0;
 i123 = i146 + 124 | 0;
 i124 = i146 + 128 | 0;
 i125 = i146 + 132 | 0;
 i126 = i146 + 136 | 0;
 i127 = i146 + 140 | 0;
 i128 = i147 + 4 | 0;
 i129 = i147 + 8 | 0;
 i130 = i147 + 16 | 0;
 i131 = i147 + 20 | 0;
 i8 = i147 + 24 | 0;
 i9 = i147 + 32 | 0;
 i10 = i147 + 36 | 0;
 i11 = i147 + 40 | 0;
 i12 = i147 + 48 | 0;
 i13 = i147 + 52 | 0;
 i14 = i147 + 56 | 0;
 i15 = i147 + 64 | 0;
 i16 = i147 + 68 | 0;
 i17 = i147 + 72 | 0;
 i18 = i147 + 80 | 0;
 i19 = i147 + 84 | 0;
 i20 = i147 + 88 | 0;
 i21 = i147 + 96 | 0;
 i22 = i147 + 100 | 0;
 i23 = i147 + 104 | 0;
 i24 = i147 + 112 | 0;
 i25 = i147 + 116 | 0;
 i26 = i147 + 120 | 0;
 i27 = i147 + 128 | 0;
 i28 = i147 + 132 | 0;
 i29 = i147 + 136 | 0;
 i30 = i138 + 4 | 0;
 i31 = i138 + 8 | 0;
 i32 = i138 + 16 | 0;
 i33 = i138 + 20 | 0;
 i34 = i138 + 24 | 0;
 i35 = i138 + 32 | 0;
 i36 = i138 + 36 | 0;
 i37 = i138 + 40 | 0;
 i38 = i138 + 48 | 0;
 i39 = i138 + 52 | 0;
 i40 = i138 + 56 | 0;
 i41 = i138 + 64 | 0;
 i42 = i138 + 68 | 0;
 i43 = i138 + 72 | 0;
 i44 = i138 + 80 | 0;
 i45 = i138 + 84 | 0;
 i46 = i138 + 88 | 0;
 i47 = i138 + 96 | 0;
 i48 = i138 + 100 | 0;
 i49 = i138 + 104 | 0;
 i50 = i138 + 112 | 0;
 i51 = i138 + 116 | 0;
 i52 = i138 + 120 | 0;
 i53 = i138 + 128 | 0;
 i54 = i138 + 132 | 0;
 i55 = i138 + 136 | 0;
 i56 = i146 + 16 | 0;
 i57 = i146 + 32 | 0;
 i58 = i146 + 48 | 0;
 i59 = i146 + 64 | 0;
 i60 = i146 + 80 | 0;
 i61 = i146 + 96 | 0;
 i62 = i146 + 112 | 0;
 i63 = i146 + 128 | 0;
 if (i7) while (1) {
  _memcpy(i135 | 0, i148 | 0, i136 | 0) | 0;
  i2 = i143;
  do {
   i2 = i2 + -1 | 0;
   i7 = i142 + (i2 << 4) | 0;
   HEAP32[i137 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i137 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i137 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i137 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE9propagateERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialERKNS_6shdfnd3aos6Mat33VENSA_6FloatVE(i146, i135 + (i2 * 144 | 0) | 0, i133 + (i2 * 96 | 0) | 0, i144 + (i2 * 48 | 0) | 0, i137);
   i7 = HEAP32[i145 + (i2 << 3) >> 2] | 0;
   i198 = i134 + (i2 << 5) | 0;
   HEAP32[i137 >> 2] = HEAP32[i198 >> 2];
   HEAP32[i137 + 4 >> 2] = HEAP32[i198 + 4 >> 2];
   HEAP32[i137 + 8 >> 2] = HEAP32[i198 + 8 >> 2];
   HEAP32[i137 + 12 >> 2] = HEAP32[i198 + 12 >> 2];
   __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE(i138, i137, i146);
   i198 = i135 + (i7 * 144 | 0) | 0;
   f201 = Math_fround(HEAPF32[i198 >> 2]);
   i196 = i135 + (i7 * 144 | 0) + 4 | 0;
   f200 = Math_fround(HEAPF32[i196 >> 2]);
   i194 = i135 + (i7 * 144 | 0) + 8 | 0;
   f195 = Math_fround(HEAPF32[i194 >> 2]);
   f199 = Math_fround(HEAPF32[i138 >> 2]);
   f197 = Math_fround(HEAPF32[i30 >> 2]);
   f199 = Math_fround(f201 + f199);
   f197 = Math_fround(f200 + f197);
   f195 = Math_fround(f195 + Math_fround(HEAPF32[i31 >> 2]));
   i192 = i135 + (i7 * 144 | 0) + 16 | 0;
   f200 = Math_fround(HEAPF32[i192 >> 2]);
   i190 = i135 + (i7 * 144 | 0) + 20 | 0;
   f201 = Math_fround(HEAPF32[i190 >> 2]);
   i188 = i135 + (i7 * 144 | 0) + 24 | 0;
   f189 = Math_fround(HEAPF32[i188 >> 2]);
   f193 = Math_fround(HEAPF32[i32 >> 2]);
   f191 = Math_fround(HEAPF32[i33 >> 2]);
   f193 = Math_fround(f200 + f193);
   f191 = Math_fround(f201 + f191);
   f189 = Math_fround(f189 + Math_fround(HEAPF32[i34 >> 2]));
   i186 = i135 + (i7 * 144 | 0) + 32 | 0;
   f201 = Math_fround(HEAPF32[i186 >> 2]);
   i184 = i135 + (i7 * 144 | 0) + 36 | 0;
   f200 = Math_fround(HEAPF32[i184 >> 2]);
   i182 = i135 + (i7 * 144 | 0) + 40 | 0;
   f183 = Math_fround(HEAPF32[i182 >> 2]);
   f187 = Math_fround(HEAPF32[i35 >> 2]);
   f185 = Math_fround(HEAPF32[i36 >> 2]);
   f187 = Math_fround(f201 + f187);
   f185 = Math_fround(f200 + f185);
   f183 = Math_fround(f183 + Math_fround(HEAPF32[i37 >> 2]));
   i180 = i135 + (i7 * 144 | 0) + 48 | 0;
   f200 = Math_fround(HEAPF32[i180 >> 2]);
   i178 = i135 + (i7 * 144 | 0) + 52 | 0;
   f201 = Math_fround(HEAPF32[i178 >> 2]);
   i176 = i135 + (i7 * 144 | 0) + 56 | 0;
   f177 = Math_fround(HEAPF32[i176 >> 2]);
   f181 = Math_fround(HEAPF32[i38 >> 2]);
   f179 = Math_fround(HEAPF32[i39 >> 2]);
   f181 = Math_fround(f200 + f181);
   f179 = Math_fround(f201 + f179);
   f177 = Math_fround(f177 + Math_fround(HEAPF32[i40 >> 2]));
   i174 = i135 + (i7 * 144 | 0) + 64 | 0;
   f201 = Math_fround(HEAPF32[i174 >> 2]);
   i172 = i135 + (i7 * 144 | 0) + 68 | 0;
   f200 = Math_fround(HEAPF32[i172 >> 2]);
   i170 = i135 + (i7 * 144 | 0) + 72 | 0;
   f171 = Math_fround(HEAPF32[i170 >> 2]);
   f175 = Math_fround(HEAPF32[i41 >> 2]);
   f173 = Math_fround(HEAPF32[i42 >> 2]);
   f175 = Math_fround(f201 + f175);
   f173 = Math_fround(f200 + f173);
   f171 = Math_fround(f171 + Math_fround(HEAPF32[i43 >> 2]));
   i168 = i135 + (i7 * 144 | 0) + 80 | 0;
   f200 = Math_fround(HEAPF32[i168 >> 2]);
   i166 = i135 + (i7 * 144 | 0) + 84 | 0;
   f201 = Math_fround(HEAPF32[i166 >> 2]);
   i164 = i135 + (i7 * 144 | 0) + 88 | 0;
   f165 = Math_fround(HEAPF32[i164 >> 2]);
   f169 = Math_fround(HEAPF32[i44 >> 2]);
   f167 = Math_fround(HEAPF32[i45 >> 2]);
   f169 = Math_fround(f200 + f169);
   f167 = Math_fround(f201 + f167);
   f165 = Math_fround(f165 + Math_fround(HEAPF32[i46 >> 2]));
   i162 = i135 + (i7 * 144 | 0) + 96 | 0;
   f201 = Math_fround(HEAPF32[i162 >> 2]);
   i160 = i135 + (i7 * 144 | 0) + 100 | 0;
   f200 = Math_fround(HEAPF32[i160 >> 2]);
   i158 = i135 + (i7 * 144 | 0) + 104 | 0;
   f159 = Math_fround(HEAPF32[i158 >> 2]);
   f163 = Math_fround(HEAPF32[i47 >> 2]);
   f161 = Math_fround(HEAPF32[i48 >> 2]);
   f163 = Math_fround(f201 + f163);
   f161 = Math_fround(f200 + f161);
   f159 = Math_fround(f159 + Math_fround(HEAPF32[i49 >> 2]));
   i156 = i135 + (i7 * 144 | 0) + 112 | 0;
   f200 = Math_fround(HEAPF32[i156 >> 2]);
   i154 = i135 + (i7 * 144 | 0) + 116 | 0;
   f201 = Math_fround(HEAPF32[i154 >> 2]);
   i3 = i135 + (i7 * 144 | 0) + 120 | 0;
   f153 = Math_fround(HEAPF32[i3 >> 2]);
   f157 = Math_fround(HEAPF32[i50 >> 2]);
   f155 = Math_fround(HEAPF32[i51 >> 2]);
   f157 = Math_fround(f200 + f157);
   f155 = Math_fround(f201 + f155);
   f153 = Math_fround(f153 + Math_fround(HEAPF32[i52 >> 2]));
   i4 = i135 + (i7 * 144 | 0) + 128 | 0;
   f201 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i135 + (i7 * 144 | 0) + 132 | 0;
   f200 = Math_fround(HEAPF32[i5 >> 2]);
   i6 = i135 + (i7 * 144 | 0) + 136 | 0;
   f150 = Math_fround(HEAPF32[i6 >> 2]);
   f152 = Math_fround(HEAPF32[i53 >> 2]);
   f151 = Math_fround(HEAPF32[i54 >> 2]);
   f152 = Math_fround(f201 + f152);
   f151 = Math_fround(f200 + f151);
   f150 = Math_fround(f150 + Math_fround(HEAPF32[i55 >> 2]));
   HEAPF32[i198 >> 2] = f199;
   HEAPF32[i196 >> 2] = f197;
   HEAPF32[i194 >> 2] = f195;
   HEAPF32[i135 + (i7 * 144 | 0) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i192 >> 2] = f193;
   HEAPF32[i190 >> 2] = f191;
   HEAPF32[i188 >> 2] = f189;
   HEAPF32[i135 + (i7 * 144 | 0) + 28 >> 2] = Math_fround(0.0);
   HEAPF32[i186 >> 2] = f187;
   HEAPF32[i184 >> 2] = f185;
   HEAPF32[i182 >> 2] = f183;
   HEAPF32[i135 + (i7 * 144 | 0) + 44 >> 2] = Math_fround(0.0);
   HEAPF32[i180 >> 2] = f181;
   HEAPF32[i178 >> 2] = f179;
   HEAPF32[i176 >> 2] = f177;
   HEAPF32[i135 + (i7 * 144 | 0) + 60 >> 2] = Math_fround(0.0);
   HEAPF32[i174 >> 2] = f175;
   HEAPF32[i172 >> 2] = f173;
   HEAPF32[i170 >> 2] = f171;
   HEAPF32[i135 + (i7 * 144 | 0) + 76 >> 2] = Math_fround(0.0);
   HEAPF32[i168 >> 2] = f169;
   HEAPF32[i166 >> 2] = f167;
   HEAPF32[i164 >> 2] = f165;
   HEAPF32[i135 + (i7 * 144 | 0) + 92 >> 2] = Math_fround(0.0);
   HEAPF32[i162 >> 2] = f163;
   HEAPF32[i160 >> 2] = f161;
   HEAPF32[i158 >> 2] = f159;
   HEAPF32[i135 + (i7 * 144 | 0) + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i156 >> 2] = f157;
   HEAPF32[i154 >> 2] = f155;
   HEAPF32[i3 >> 2] = f153;
   HEAPF32[i135 + (i7 * 144 | 0) + 124 >> 2] = Math_fround(0.0);
   HEAPF32[i4 >> 2] = f152;
   HEAPF32[i5 >> 2] = f151;
   HEAPF32[i6 >> 2] = f150;
   HEAPF32[i135 + (i7 * 144 | 0) + 140 >> 2] = Math_fround(0.0);
   i7 = i132 + (i2 * 144 | 0) | 0;
   HEAP32[i7 >> 2] = HEAP32[i146 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i146 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i146 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i146 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 32 | 0;
   HEAP32[i7 >> 2] = HEAP32[i57 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 48 | 0;
   HEAP32[i7 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 64 | 0;
   HEAP32[i7 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 80 | 0;
   HEAP32[i7 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 96 | 0;
   HEAP32[i7 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 112 | 0;
   HEAP32[i7 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
   i7 = i132 + (i2 * 144 | 0) + 128 | 0;
   HEAP32[i7 >> 2] = HEAP32[i63 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  } while (i2 >>> 0 > 1);
  i3 = 1;
  do {
   i5 = i133 + (i3 * 96 | 0) | 0;
   f155 = Math_fround(HEAPF32[i134 + (i3 << 5) >> 2]);
   f151 = Math_fround(HEAPF32[i134 + (i3 << 5) + 4 >> 2]);
   f151 = Math_fround(-f151);
   f150 = Math_fround(-Math_fround(HEAPF32[i134 + (i3 << 5) + 8 >> 2]));
   HEAPF32[i140 >> 2] = Math_fround(-f155);
   HEAPF32[i64 >> 2] = f151;
   HEAPF32[i65 >> 2] = f150;
   HEAPF32[i66 >> 2] = Math_fround(0.0);
   i4 = i135 + ((HEAP32[i145 + (i3 << 3) >> 2] | 0) * 144 | 0) | 0;
   HEAP32[i137 >> 2] = HEAP32[i140 >> 2];
   HEAP32[i137 + 4 >> 2] = HEAP32[i140 + 4 >> 2];
   HEAP32[i137 + 8 >> 2] = HEAP32[i140 + 8 >> 2];
   HEAP32[i137 + 12 >> 2] = HEAP32[i140 + 12 >> 2];
   __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE(i139, i137, i4);
   f150 = Math_fround(HEAPF32[i139 >> 2]);
   f151 = Math_fround(HEAPF32[i67 >> 2]);
   f155 = Math_fround(HEAPF32[i68 >> 2]);
   f152 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) >> 2]);
   f153 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 4 >> 2]);
   f152 = Math_fround(f150 - f152);
   f153 = Math_fround(f151 - f153);
   f155 = Math_fround(f155 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 8 >> 2]));
   f151 = Math_fround(HEAPF32[i69 >> 2]);
   f150 = Math_fround(HEAPF32[i70 >> 2]);
   f161 = Math_fround(HEAPF32[i71 >> 2]);
   f157 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 16 >> 2]);
   f159 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 20 >> 2]);
   f157 = Math_fround(f151 - f157);
   f159 = Math_fround(f150 - f159);
   f161 = Math_fround(f161 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 24 >> 2]));
   f150 = Math_fround(HEAPF32[i72 >> 2]);
   f151 = Math_fround(HEAPF32[i73 >> 2]);
   f167 = Math_fround(HEAPF32[i74 >> 2]);
   f163 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 32 >> 2]);
   f165 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 36 >> 2]);
   f163 = Math_fround(f150 - f163);
   f165 = Math_fround(f151 - f165);
   f167 = Math_fround(f167 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 40 >> 2]));
   f151 = Math_fround(HEAPF32[i75 >> 2]);
   f150 = Math_fround(HEAPF32[i76 >> 2]);
   f173 = Math_fround(HEAPF32[i77 >> 2]);
   f169 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 48 >> 2]);
   f171 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 52 >> 2]);
   f169 = Math_fround(f151 - f169);
   f171 = Math_fround(f150 - f171);
   f173 = Math_fround(f173 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 56 >> 2]));
   f150 = Math_fround(HEAPF32[i78 >> 2]);
   f151 = Math_fround(HEAPF32[i79 >> 2]);
   f179 = Math_fround(HEAPF32[i80 >> 2]);
   f175 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 64 >> 2]);
   f177 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 68 >> 2]);
   f175 = Math_fround(f150 - f175);
   f177 = Math_fround(f151 - f177);
   f179 = Math_fround(f179 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 72 >> 2]));
   f151 = Math_fround(HEAPF32[i81 >> 2]);
   f150 = Math_fround(HEAPF32[i82 >> 2]);
   f185 = Math_fround(HEAPF32[i83 >> 2]);
   f181 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 80 >> 2]);
   f183 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 84 >> 2]);
   f181 = Math_fround(f151 - f181);
   f183 = Math_fround(f150 - f183);
   f185 = Math_fround(f185 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 88 >> 2]));
   f150 = Math_fround(HEAPF32[i84 >> 2]);
   f151 = Math_fround(HEAPF32[i85 >> 2]);
   f191 = Math_fround(HEAPF32[i86 >> 2]);
   f187 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 96 >> 2]);
   f189 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 100 >> 2]);
   f187 = Math_fround(f150 - f187);
   f189 = Math_fround(f151 - f189);
   f191 = Math_fround(f191 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 104 >> 2]));
   f151 = Math_fround(HEAPF32[i87 >> 2]);
   f150 = Math_fround(HEAPF32[i88 >> 2]);
   f197 = Math_fround(HEAPF32[i89 >> 2]);
   f193 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 112 >> 2]);
   f195 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 116 >> 2]);
   f193 = Math_fround(f151 - f193);
   f195 = Math_fround(f150 - f195);
   f197 = Math_fround(f197 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 120 >> 2]));
   f150 = Math_fround(HEAPF32[i90 >> 2]);
   f151 = Math_fround(HEAPF32[i91 >> 2]);
   f201 = Math_fround(HEAPF32[i92 >> 2]);
   f199 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 128 >> 2]);
   f200 = Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 132 >> 2]);
   f199 = Math_fround(f150 - f199);
   f200 = Math_fround(f151 - f200);
   f201 = Math_fround(f201 - Math_fround(HEAPF32[i132 + (i3 * 144 | 0) + 136 >> 2]));
   HEAPF32[i146 >> 2] = f152;
   HEAPF32[i93 >> 2] = f153;
   HEAPF32[i94 >> 2] = f155;
   HEAPF32[i95 >> 2] = Math_fround(0.0);
   HEAPF32[i96 >> 2] = f157;
   HEAPF32[i97 >> 2] = f159;
   HEAPF32[i98 >> 2] = f161;
   HEAPF32[i99 >> 2] = Math_fround(0.0);
   HEAPF32[i100 >> 2] = f163;
   HEAPF32[i101 >> 2] = f165;
   HEAPF32[i102 >> 2] = f167;
   HEAPF32[i103 >> 2] = Math_fround(0.0);
   HEAPF32[i104 >> 2] = f169;
   HEAPF32[i105 >> 2] = f171;
   HEAPF32[i106 >> 2] = f173;
   HEAPF32[i107 >> 2] = Math_fround(0.0);
   HEAPF32[i108 >> 2] = f175;
   HEAPF32[i109 >> 2] = f177;
   HEAPF32[i110 >> 2] = f179;
   HEAPF32[i111 >> 2] = Math_fround(0.0);
   HEAPF32[i112 >> 2] = f181;
   HEAPF32[i113 >> 2] = f183;
   HEAPF32[i114 >> 2] = f185;
   HEAPF32[i115 >> 2] = Math_fround(0.0);
   HEAPF32[i116 >> 2] = f187;
   HEAPF32[i117 >> 2] = f189;
   HEAPF32[i118 >> 2] = f191;
   HEAPF32[i119 >> 2] = Math_fround(0.0);
   HEAPF32[i120 >> 2] = f193;
   HEAPF32[i121 >> 2] = f195;
   HEAPF32[i122 >> 2] = f197;
   HEAPF32[i123 >> 2] = Math_fround(0.0);
   HEAPF32[i124 >> 2] = f199;
   HEAPF32[i125 >> 2] = f200;
   HEAPF32[i126 >> 2] = f201;
   HEAPF32[i127 >> 2] = Math_fround(0.0);
   i4 = i144 + (i3 * 48 | 0) | 0;
   i2 = i142 + (i3 << 4) | 0;
   HEAP32[i137 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i137 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i137 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i137 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE9propagateERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialERKNS_6shdfnd3aos6Mat33VENSA_6FloatVE(i147, i146, i5, i4, i137);
   i2 = i135 + (i3 * 144 | 0) | 0;
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE19computeDriveInertiaERKNS_12PxcFsInertiaES5_PKNS_14PxcSIMDSpatialE(i141, i2, i146, i5);
   i5 = i141;
   i6 = i4 + 48 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   f150 = Math_fround(HEAPF32[i2 >> 2]);
   i5 = i135 + (i3 * 144 | 0) + 4 | 0;
   f151 = Math_fround(HEAPF32[i5 >> 2]);
   i6 = i135 + (i3 * 144 | 0) + 8 | 0;
   f155 = Math_fround(HEAPF32[i6 >> 2]);
   f152 = Math_fround(HEAPF32[i147 >> 2]);
   f153 = Math_fround(HEAPF32[i128 >> 2]);
   f152 = Math_fround(f150 + f152);
   f153 = Math_fround(f151 + f153);
   f155 = Math_fround(f155 + Math_fround(HEAPF32[i129 >> 2]));
   i7 = i135 + (i3 * 144 | 0) + 16 | 0;
   f151 = Math_fround(HEAPF32[i7 >> 2]);
   i154 = i135 + (i3 * 144 | 0) + 20 | 0;
   f150 = Math_fround(HEAPF32[i154 >> 2]);
   i156 = i135 + (i3 * 144 | 0) + 24 | 0;
   f161 = Math_fround(HEAPF32[i156 >> 2]);
   f157 = Math_fround(HEAPF32[i130 >> 2]);
   f159 = Math_fround(HEAPF32[i131 >> 2]);
   f157 = Math_fround(f151 + f157);
   f159 = Math_fround(f150 + f159);
   f161 = Math_fround(f161 + Math_fround(HEAPF32[i8 >> 2]));
   i158 = i135 + (i3 * 144 | 0) + 32 | 0;
   f150 = Math_fround(HEAPF32[i158 >> 2]);
   i160 = i135 + (i3 * 144 | 0) + 36 | 0;
   f151 = Math_fround(HEAPF32[i160 >> 2]);
   i162 = i135 + (i3 * 144 | 0) + 40 | 0;
   f167 = Math_fround(HEAPF32[i162 >> 2]);
   f163 = Math_fround(HEAPF32[i9 >> 2]);
   f165 = Math_fround(HEAPF32[i10 >> 2]);
   f163 = Math_fround(f150 + f163);
   f165 = Math_fround(f151 + f165);
   f167 = Math_fround(f167 + Math_fround(HEAPF32[i11 >> 2]));
   i164 = i135 + (i3 * 144 | 0) + 48 | 0;
   f151 = Math_fround(HEAPF32[i164 >> 2]);
   i166 = i135 + (i3 * 144 | 0) + 52 | 0;
   f150 = Math_fround(HEAPF32[i166 >> 2]);
   i168 = i135 + (i3 * 144 | 0) + 56 | 0;
   f173 = Math_fround(HEAPF32[i168 >> 2]);
   f169 = Math_fround(HEAPF32[i12 >> 2]);
   f171 = Math_fround(HEAPF32[i13 >> 2]);
   f169 = Math_fround(f151 + f169);
   f171 = Math_fround(f150 + f171);
   f173 = Math_fround(f173 + Math_fround(HEAPF32[i14 >> 2]));
   i170 = i135 + (i3 * 144 | 0) + 64 | 0;
   f150 = Math_fround(HEAPF32[i170 >> 2]);
   i172 = i135 + (i3 * 144 | 0) + 68 | 0;
   f151 = Math_fround(HEAPF32[i172 >> 2]);
   i174 = i135 + (i3 * 144 | 0) + 72 | 0;
   f179 = Math_fround(HEAPF32[i174 >> 2]);
   f175 = Math_fround(HEAPF32[i15 >> 2]);
   f177 = Math_fround(HEAPF32[i16 >> 2]);
   f175 = Math_fround(f150 + f175);
   f177 = Math_fround(f151 + f177);
   f179 = Math_fround(f179 + Math_fround(HEAPF32[i17 >> 2]));
   i176 = i135 + (i3 * 144 | 0) + 80 | 0;
   f151 = Math_fround(HEAPF32[i176 >> 2]);
   i178 = i135 + (i3 * 144 | 0) + 84 | 0;
   f150 = Math_fround(HEAPF32[i178 >> 2]);
   i180 = i135 + (i3 * 144 | 0) + 88 | 0;
   f185 = Math_fround(HEAPF32[i180 >> 2]);
   f181 = Math_fround(HEAPF32[i18 >> 2]);
   f183 = Math_fround(HEAPF32[i19 >> 2]);
   f181 = Math_fround(f151 + f181);
   f183 = Math_fround(f150 + f183);
   f185 = Math_fround(f185 + Math_fround(HEAPF32[i20 >> 2]));
   i182 = i135 + (i3 * 144 | 0) + 96 | 0;
   f150 = Math_fround(HEAPF32[i182 >> 2]);
   i184 = i135 + (i3 * 144 | 0) + 100 | 0;
   f151 = Math_fround(HEAPF32[i184 >> 2]);
   i186 = i135 + (i3 * 144 | 0) + 104 | 0;
   f191 = Math_fround(HEAPF32[i186 >> 2]);
   f187 = Math_fround(HEAPF32[i21 >> 2]);
   f189 = Math_fround(HEAPF32[i22 >> 2]);
   f187 = Math_fround(f150 + f187);
   f189 = Math_fround(f151 + f189);
   f191 = Math_fround(f191 + Math_fround(HEAPF32[i23 >> 2]));
   i188 = i135 + (i3 * 144 | 0) + 112 | 0;
   f151 = Math_fround(HEAPF32[i188 >> 2]);
   i190 = i135 + (i3 * 144 | 0) + 116 | 0;
   f150 = Math_fround(HEAPF32[i190 >> 2]);
   i192 = i135 + (i3 * 144 | 0) + 120 | 0;
   f197 = Math_fround(HEAPF32[i192 >> 2]);
   f193 = Math_fround(HEAPF32[i24 >> 2]);
   f195 = Math_fround(HEAPF32[i25 >> 2]);
   f193 = Math_fround(f151 + f193);
   f195 = Math_fround(f150 + f195);
   f197 = Math_fround(f197 + Math_fround(HEAPF32[i26 >> 2]));
   i194 = i135 + (i3 * 144 | 0) + 128 | 0;
   f150 = Math_fround(HEAPF32[i194 >> 2]);
   i196 = i135 + (i3 * 144 | 0) + 132 | 0;
   f151 = Math_fround(HEAPF32[i196 >> 2]);
   i198 = i135 + (i3 * 144 | 0) + 136 | 0;
   f201 = Math_fround(HEAPF32[i198 >> 2]);
   f199 = Math_fround(HEAPF32[i27 >> 2]);
   f200 = Math_fround(HEAPF32[i28 >> 2]);
   f199 = Math_fround(f150 + f199);
   f200 = Math_fround(f151 + f200);
   f201 = Math_fround(f201 + Math_fround(HEAPF32[i29 >> 2]));
   HEAPF32[i2 >> 2] = f152;
   HEAPF32[i5 >> 2] = f153;
   HEAPF32[i6 >> 2] = f155;
   HEAPF32[i135 + (i3 * 144 | 0) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i7 >> 2] = f157;
   HEAPF32[i154 >> 2] = f159;
   HEAPF32[i156 >> 2] = f161;
   HEAPF32[i135 + (i3 * 144 | 0) + 28 >> 2] = Math_fround(0.0);
   HEAPF32[i158 >> 2] = f163;
   HEAPF32[i160 >> 2] = f165;
   HEAPF32[i162 >> 2] = f167;
   HEAPF32[i135 + (i3 * 144 | 0) + 44 >> 2] = Math_fround(0.0);
   HEAPF32[i164 >> 2] = f169;
   HEAPF32[i166 >> 2] = f171;
   HEAPF32[i168 >> 2] = f173;
   HEAPF32[i135 + (i3 * 144 | 0) + 60 >> 2] = Math_fround(0.0);
   HEAPF32[i170 >> 2] = f175;
   HEAPF32[i172 >> 2] = f177;
   HEAPF32[i174 >> 2] = f179;
   HEAPF32[i135 + (i3 * 144 | 0) + 76 >> 2] = Math_fround(0.0);
   HEAPF32[i176 >> 2] = f181;
   HEAPF32[i178 >> 2] = f183;
   HEAPF32[i180 >> 2] = f185;
   HEAPF32[i135 + (i3 * 144 | 0) + 92 >> 2] = Math_fround(0.0);
   HEAPF32[i182 >> 2] = f187;
   HEAPF32[i184 >> 2] = f189;
   HEAPF32[i186 >> 2] = f191;
   HEAPF32[i135 + (i3 * 144 | 0) + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i188 >> 2] = f193;
   HEAPF32[i190 >> 2] = f195;
   HEAPF32[i192 >> 2] = f197;
   HEAPF32[i135 + (i3 * 144 | 0) + 124 >> 2] = Math_fround(0.0);
   HEAPF32[i194 >> 2] = f199;
   HEAPF32[i196 >> 2] = f200;
   HEAPF32[i198 >> 2] = f201;
   HEAPF32[i135 + (i3 * 144 | 0) + 140 >> 2] = Math_fround(0.0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i143 | 0));
  if (!i1) break; else i1 = i1 + -1 | 0;
 } else while (1) {
  _memcpy(i135 | 0, i148 | 0, i136 | 0) | 0;
  if (!i1) break; else i1 = i1 + -1 | 0;
 }
 STACKTOP = i149;
 return;
}

function __ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf(i81, i82, i86, i13, i88, f89, i93) {
 i81 = i81 | 0;
 i82 = i82 | 0;
 i86 = i86 | 0;
 i13 = i13 | 0;
 i88 = i88 | 0;
 f89 = Math_fround(f89);
 i93 = i93 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, f60 = f0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i83 = 0, i84 = 0, i85 = 0, i87 = 0, i90 = 0, i91 = 0, i92 = 0, i94 = 0, i95 = 0;
 i95 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i90 = i95 + 56 | 0;
 i91 = i95 + 44 | 0;
 i92 = i95 + 16 | 0;
 i83 = i95;
 i84 = i95 + 40 | 0;
 i7 = i95 + 36 | 0;
 i8 = i95 + 32 | 0;
 i1 = HEAP32[i81 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i6 + 92 >> 2] | 0;
 i10 = HEAP32[i6 + 96 >> 2] | 0;
 i9 = HEAP32[i6 + 100 >> 2] | 0;
 i11 = HEAP32[i6 + 104 >> 2] | 0;
 i5 = ((i13 | 0) != -1 & (i10 | 0) != 0 ? HEAP32[i6 + 108 >> 2] | 0 : 0) + i13 | 0;
 i85 = (i86 | 0) != 0;
 if (i85) if (HEAP32[i86 + (i5 >> 5 << 2) >> 2] & 1 << (i5 & 31) | 0) {
  i94 = 1;
  STACKTOP = i95;
  return i94 | 0;
 }
 i87 = (i82 | 0) != 0;
 do if (i87) {
  i3 = i82 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) < (HEAP32[i82 + 4 >> 2] | 0)) {
   HEAP32[(HEAP32[i82 >> 2] | 0) + (i4 << 2) >> 2] = i5;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   break;
  }
  HEAP32[i3 >> 2] = i4 + 1;
  HEAP32[i1 + 28 >> 2] = 2;
  i94 = 1;
  STACKTOP = i95;
  return i94 | 0;
 } while (0);
 i80 = i81 + 80112 | 0;
 _memset(HEAP32[i80 >> 2] | 0, 0, (HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0) + 31 >> 5 << 2 | 0) | 0;
 i1 = (HEAP32[i80 >> 2] | 0) + (i5 >> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i5 & 31);
 i1 = i9;
 i77 = HEAP32[i1 + 128 >> 2] | 0;
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 i78 = i81 + 40 | 0;
 HEAP32[i78 >> 2] = i1;
 i79 = i81 + 12 | 0;
 HEAP32[i79 >> 2] = (i77 | 0) == 0 ? 0 : i9 + i77 | 0;
 if (!i10) {
  i3 = 0;
  i4 = 0;
  i1 = 0;
 } else {
  i4 = HEAP32[i10 + 20 >> 2] | 0;
  i77 = (i4 | 0) == 0;
  i3 = i77 ? 0 : i11;
  i1 = i77 ? 0 : i1;
 }
 i77 = i81 + 76 | 0;
 HEAP32[i77 >> 2] = i1;
 i76 = i81 + 48 | 0;
 HEAP32[i76 >> 2] = (i4 | 0) == 0 ? 0 : i3 + i4 | 0;
 HEAP32[i81 + 112 >> 2] = i12;
 HEAP32[i81 + 116 >> 2] = i13;
 HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i75 = (i93 | 0) != 0;
 if (i75) i73 = (HEAP32[i81 + 4 >> 2] & 4 | 0) == 0 ? i8 : 0; else {
  i7 = 0;
  i73 = 0;
 }
 i52 = i81 + 28 | 0;
 i53 = i81 + 104 | 0;
 i54 = i81 + 108 | 0;
 i55 = i81 + 88 | 0;
 i56 = i81 + 84 | 0;
 i57 = i81 + 92 | 0;
 i58 = i81 + 96 | 0;
 i59 = !(f89 <= Math_fround(0.0));
 f60 = Math_fround(f89 * f89);
 i61 = i90 + 4 | 0;
 i62 = i90 + 8 | 0;
 i63 = i91 + 4 | 0;
 i64 = i91 + 8 | 0;
 i65 = i92 + 4 | 0;
 i66 = i92 + 8 | 0;
 i67 = i83 + 4 | 0;
 i68 = i83 + 8 | 0;
 i69 = i88 + 4 | 0;
 i70 = i88 + 8 | 0;
 i71 = (i7 | 0) != 0;
 i72 = (i73 | 0) != 0;
 i74 = (i73 | 0) == 0;
 i48 = (i7 | 0) == 0;
 i49 = i82 + 8 | 0;
 i50 = i82 + 4 | 0;
 i47 = i81 + 100 | 0;
 i51 = i81 + 64 | 0;
 i6 = 0;
 i8 = i12;
 i1 = i10;
 i5 = i11;
 i4 = i12;
 L18 : while (1) {
  i11 = i6 + -1 | 0;
  if ((i4 | 0) == (i8 | 0)) {
   i8 = i4;
   i10 = i5;
   i3 = HEAP32[i79 >> 2] | 0;
   i4 = HEAP32[i77 >> 2] | 0;
  } else {
   i3 = HEAP32[HEAP32[i81 >> 2] >> 2] | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i4 | 0) != -1 & (i1 | 0) != 0) {
    i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i4 << 5)) | 0;
    if (!i1) i94 = 17; else {
     i9 = HEAP32[i1 >> 2] | 0;
     i10 = HEAP32[i3 >> 2] | 0;
     i45 = HEAP32[i10 + (HEAP32[i10 + 180 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     i8 = i10 + (HEAP32[i10 + 184 >> 2] | 0) | 0;
     i46 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
     i8 = (HEAP32[i8 + (i4 + 1 << 2) >> 2] | 0) - i46 | 0;
     HEAP32[i3 + 92 >> 2] = i4;
     HEAP32[i3 + 96 >> 2] = i1;
     HEAP32[i3 + 100 >> 2] = i9;
     HEAP32[i3 + 104 >> 2] = i10;
     HEAP32[i3 + 108 >> 2] = i45;
     HEAP32[i3 + 112 >> 2] = i46;
     HEAP32[i3 + 116 >> 2] = i8;
     i8 = i4;
    }
   } else i94 = 17;
   if ((i94 | 0) == 17) {
    i94 = 0;
    i10 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 + 92 >> 2] = 0;
    HEAP32[i3 + 96 >> 2] = 0;
    HEAP32[i3 + 100 >> 2] = i10;
    HEAP32[i3 + 104 >> 2] = i10;
    HEAP32[i3 + 108 >> 2] = 0;
    HEAP32[i3 + 112 >> 2] = 0;
    HEAP32[i3 + 116 >> 2] = 0;
    i8 = 0;
    i1 = 0;
    i9 = i10;
   }
   i5 = i9;
   i3 = HEAP32[i5 + 128 >> 2] | 0;
   i5 = i5 + 124 | 0;
   i3 = (i3 | 0) == 0 ? 0 : i9 + i3 | 0;
   HEAP32[i78 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i79 >> 2] = i3;
   if (!i1) {
    i6 = 0;
    i4 = 0;
    i5 = 0;
   } else {
    i4 = HEAP32[i1 + 20 >> 2] | 0;
    if (!i4) {
     i6 = 0;
     i4 = 0;
     i5 = 0;
    } else {
     i6 = i10;
     i5 = HEAP32[i5 >> 2] | 0;
    }
   }
   HEAP32[i77 >> 2] = i5;
   HEAP32[i76 >> 2] = (i4 | 0) == 0 ? 0 : i6 + i4 | 0;
   i4 = i5;
  }
  i6 = i3 + (Math_imul(HEAP32[i52 >> 2] | 0, i13) | 0) | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  if (!i4) {
   i3 = 0;
   i4 = 0;
  } else {
   i4 = (HEAP32[i76 >> 2] | 0) + (Math_imul(HEAP32[i51 >> 2] | 0, i13) | 0) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
  }
  if ((i4 + i6 | 0) > 0) {
   HEAP32[i53 >> 2] = 0;
   HEAP8[i54 >> 0] = 0;
   if (!i1) i4 = 0; else if (!(HEAP32[i1 + 20 >> 2] | 0)) i4 = 0; else {
    i46 = (HEAP32[i1 + 24 >> 2] | 0) + (i3 << 4) | 0;
    HEAP32[i57 >> 2] = i10;
    HEAP32[i58 >> 2] = i46;
    HEAP32[i47 >> 2] = 16;
    HEAP32[i53 >> 2] = i4;
   }
   i3 = i9;
   i45 = (HEAP32[i3 + 132 >> 2] | 0) + (i5 << 4) | 0;
   i46 = i9;
   i45 = (i45 | 0) == 0 ? 0 : i46 + i45 | 0;
   i5 = (i45 | 0) == 0 ? 0 : i6;
   HEAP32[i55 >> 2] = i5;
   HEAP32[i56 >> 2] = i45;
   if ((i4 | 0) == (0 - i5 | 0)) i3 = i11; else {
    i40 = i3 + 20 | 0;
    i41 = i3 + 24 | 0;
    i42 = i3 + 28 | 0;
    i43 = i3 + 32 | 0;
    i44 = i3 + 36 | 0;
    i45 = i3 + 40 | 0;
    i39 = i3 + 112 | 0;
    i3 = i11;
    do {
     if (!i5) {
      HEAP8[i54 >> 0] = 1;
      i27 = HEAP32[i58 >> 2] | 0;
      i27 = (i27 | 0) == 0 ? 0 : (HEAP32[i57 >> 2] | 0) + i27 | 0;
      i4 = (i27 | 0) == 0 ? 0 : i4;
      HEAP32[i55 >> 2] = i4;
      HEAP32[i56 >> 2] = i27;
      HEAP32[i57 >> 2] = 0;
      HEAP32[i57 + 4 >> 2] = 0;
      HEAP32[i57 + 8 >> 2] = 0;
      HEAP32[i57 + 12 >> 2] = 0;
     } else {
      i4 = i5;
      i27 = HEAP32[i56 >> 2] | 0;
     }
     HEAP32[i55 >> 2] = i4 + -1;
     HEAP32[i56 >> 2] = i27 + 16;
     i16 = HEAP32[i81 >> 2] | 0;
     i21 = HEAP32[i27 >> 2] | 0;
     L50 : do if (!(i21 & 268435456)) {
      i22 = (i21 & 134217728 | 0) == 0;
      L52 : do if (!i22) {
       i4 = HEAP32[i27 + 8 >> 2] | 0;
       i14 = i4 & 4095;
       if (i14 | 0) {
        i5 = HEAP32[i16 >> 2] | 0;
        i12 = HEAP32[i5 + 100 >> 2] | 0;
        i11 = i4 >>> 12;
        i12 = i12 + (HEAP32[i12 + 120 >> 2] | 0) | 0;
        i38 = HEAP32[i5 + 96 >> 2] | 0;
        i13 = HEAP32[i5 + 12 >> 2] | 0;
        i4 = (i13 | 0) == 0;
        i5 = i5 + 104 | 0;
        i6 = i38 + 16 | 0;
        if (!i38) {
         if (i4) break; else i4 = 0;
         while (1) {
          i5 = HEAP32[i12 + (i4 + i11 << 2) >> 2] | 0;
          if ((i5 | 0) >= 0) if (!(HEAP32[i13 + (i5 >> 5 << 2) >> 2] & 1 << (i5 & 31))) break L50;
          i4 = i4 + 1 | 0;
          if ((i4 | 0) >= (i14 | 0)) break L52;
         }
        }
        if (!i4) {
         i5 = (HEAP32[i5 >> 2] | 0) + (HEAP32[i6 >> 2] | 0) | 0;
         i4 = 0;
         do {
          i6 = HEAP32[i5 + (HEAP32[i12 + (i4 + i11 << 2) >> 2] << 2) >> 2] | 0;
          if ((i6 | 0) >= 0) if (!(HEAP32[i13 + (i6 >> 5 << 2) >> 2] & 1 << (i6 & 31))) break L50;
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) < (i14 | 0));
        }
       }
      } while (0);
      if (!(HEAP8[i54 >> 0] | 0)) i38 = i8; else i38 = (HEAP32[i27 + 4 >> 2] | 0) >>> 16;
      i37 = i21 & 67108863;
      i4 = HEAP32[i16 >> 2] | 0;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i5) i16 = i37; else if (!(HEAP32[i5 + 44 >> 2] | 0)) i16 = i37; else {
       i16 = HEAP32[i4 >> 2] | 0;
       i16 = (HEAP32[i16 + (HEAP32[i16 + 180 >> 2] | 0) + (i38 << 2) >> 2] | 0) + i37 | 0;
      }
      i35 = i16 >> 5;
      i36 = 1 << (i16 & 31);
      if (!(HEAP32[(HEAP32[i80 >> 2] | 0) + (i35 << 2) >> 2] & i36)) {
       do if (i59) {
        if (i22) {
         HEAP32[i90 >> 2] = HEAP32[i40 >> 2];
         HEAP32[i61 >> 2] = HEAP32[i41 >> 2];
         HEAP32[i62 >> 2] = HEAP32[i42 >> 2];
         HEAP32[i91 >> 2] = HEAP32[i43 >> 2];
         HEAP32[i63 >> 2] = HEAP32[i44 >> 2];
         HEAP32[i64 >> 2] = HEAP32[i45 >> 2];
         HEAP32[i92 >> 2] = 0;
         HEAP32[i92 + 4 >> 2] = 0;
         HEAP32[i92 + 8 >> 2] = 0;
         HEAP32[i92 + 12 >> 2] = 0;
         HEAP32[i83 >> 2] = 0;
         HEAP32[i83 + 4 >> 2] = 0;
         HEAP32[i83 + 8 >> 2] = 0;
         HEAP32[i83 + 12 >> 2] = 0;
         i4 = i21 >>> 30;
         f29 = Math_fround(HEAP32[i27 + 4 >> 2] & 65535 | 0);
         f31 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
         f29 = Math_fround(f31 * f29);
         f28 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
         f26 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
         f30 = Math_fround(HEAPF32[gb + 1451432 + 12 >> 2]);
         i22 = HEAP32[i27 + 8 >> 2] | 0;
         i27 = HEAP32[i27 + 12 >> 2] | 0;
         f31 = Math_fround(f31 * Math_fround(i22 >>> 16 | 0));
         f28 = Math_fround(f28 * Math_fround(i22 & 65535 | 0));
         f26 = Math_fround(f26 * Math_fround(i27 >>> 16 | 0));
         f30 = Math_fround(f30 * Math_fround(i27 & 65535 | 0));
         f32 = Math_fround(HEAPF32[i90 + (i4 << 2) >> 2]);
         f29 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f29) * f32) + Math_fround(f29 * Math_fround(HEAPF32[i91 + (i4 << 2) >> 2])));
         HEAPF32[i83 + (i4 << 2) >> 2] = f29;
         HEAPF32[i92 + (i4 << 2) >> 2] = f29;
         i4 = ((i4 + 1 | 0) >>> 0) % 3 | 0;
         f29 = Math_fround(HEAPF32[i90 + (i4 << 2) >> 2]);
         f32 = Math_fround(HEAPF32[i91 + (i4 << 2) >> 2]);
         HEAPF32[i92 + (i4 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f31) * f29) + Math_fround(f31 * f32));
         HEAPF32[i83 + (i4 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f28) * f29) + Math_fround(f28 * f32)) + Math_fround(0.0));
         i4 = ((i4 + 1 | 0) >>> 0) % 3 | 0;
         f32 = Math_fround(HEAPF32[i90 + (i4 << 2) >> 2]);
         f28 = Math_fround(HEAPF32[i91 + (i4 << 2) >> 2]);
         HEAPF32[i92 + (i4 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f26) * f32) + Math_fround(f26 * f28));
         HEAPF32[i83 + (i4 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f30) * f32) + Math_fround(f30 * f28)) + Math_fround(0.0));
         f28 = Math_fround(HEAPF32[i92 >> 2]);
         f30 = Math_fround(HEAPF32[i65 >> 2]);
         f32 = Math_fround(HEAPF32[i66 >> 2]);
         f26 = Math_fround(HEAPF32[i83 >> 2]);
         f29 = Math_fround(HEAPF32[i67 >> 2]);
         f31 = Math_fround(HEAPF32[i68 >> 2]);
         f34 = Math_fround(HEAPF32[i88 >> 2]);
         f2 = Math_fround(HEAPF32[i69 >> 2]);
         f33 = Math_fround(HEAPF32[i70 >> 2]);
         f28 = f28 >= f34 ? f28 : f34;
         f30 = f30 >= f2 ? f30 : f2;
         f32 = f32 >= f33 ? f32 : f33;
         f34 = Math_fround((f26 <= f28 ? f26 : f28) - f34);
         f2 = Math_fround((f29 <= f30 ? f29 : f30) - f2);
         f33 = Math_fround((f31 <= f32 ? f31 : f32) - f33);
         f2 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f34 * f34) + Math_fround(f2 * f2))) + Math_fround(0.0));
         i4 = f2 <= f60;
         if (i71 & i4) {
          f34 = Math_fround(f89 - Math_fround(Math_sqrt(Math_fround(f2))));
          HEAPF32[i84 >> 2] = f34;
          i27 = Math_fround(HEAPF32[i7 >> 2]) <= f34;
          HEAP32[i7 >> 2] = HEAP32[(i27 ? i7 : i84) >> 2];
         }
         if (i72 & (i4 ^ 1)) {
          f34 = Math_fround(Math_fround(Math_sqrt(Math_fround(f2))) - f89);
          HEAPF32[i84 >> 2] = f34;
          i27 = Math_fround(HEAPF32[i73 >> 2]) <= f34;
          HEAP32[i73 >> 2] = HEAP32[(i27 ? i73 : i84) >> 2];
         }
         if (i4) break; else break L50;
        }
        i4 = HEAP32[i27 + 12 >> 2] | 0;
        i5 = i4 >>> 12;
        i4 = i4 & 4095;
        i14 = i46 + (HEAP32[i39 >> 2] | 0) | 0;
        f2 = Math_fround(HEAPF32[i14 + (i5 * 12 | 0) >> 2]);
        f17 = Math_fround(HEAPF32[i14 + (i5 * 12 | 0) + 4 >> 2]);
        f15 = Math_fround(HEAPF32[i14 + (i5 * 12 | 0) + 8 >> 2]);
        i27 = i5 + 2 | 0;
        f20 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 4 >> 2]);
        f19 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 8 >> 2]);
        i22 = i5 + 1 | 0;
        f32 = Math_fround(HEAPF32[i14 + (i22 * 12 | 0) >> 2]);
        f33 = Math_fround(HEAPF32[i14 + (i22 * 12 | 0) + 4 >> 2]);
        f34 = Math_fround(HEAPF32[i14 + (i22 * 12 | 0) + 8 >> 2]);
        f23 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) >> 2]);
        f28 = Math_fround(HEAPF32[i88 >> 2]);
        f26 = Math_fround(f32 * f28);
        f29 = Math_fround(HEAPF32[i69 >> 2]);
        f26 = Math_fround(f26 + Math_fround(f33 * f29));
        f30 = Math_fround(HEAPF32[i70 >> 2]);
        f26 = Math_fround(f23 + Math_fround(f26 + Math_fround(f34 * f30)));
        f23 = Math_fround(f2 - f28);
        f24 = Math_fround(f17 - f29);
        f25 = Math_fround(f15 - f30);
        f2 = Math_fround(Math_fround(f28 - Math_fround(f32 * f26)) - f2);
        f17 = Math_fround(Math_fround(f29 - Math_fround(f33 * f26)) - f17);
        f15 = Math_fround(Math_fround(f30 - Math_fround(f34 * f26)) - f15);
        f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f2 * f2) + Math_fround(f17 * f17)))));
        if (f26 != Math_fround(0.0)) {
         f34 = Math_fround(Math_fround(1.0) / f26);
         f2 = Math_fround(f34 * f2);
         f18 = Math_fround(f34 * f15);
         f17 = Math_fround(f34 * f17);
        } else f18 = f15;
        f15 = f19 <= f26 ? f19 : f26;
        f33 = Math_fround(f23 + Math_fround(f15 * f2));
        f34 = Math_fround(f24 + Math_fround(f15 * f17));
        f15 = Math_fround(f25 + Math_fround(f15 * f18));
        f15 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f15 * f15));
        if (f60 < f15) {
         if (i74) break L50;
         f34 = Math_fround(Math_fround(Math_sqrt(Math_fround(f15))) - f89);
         HEAPF32[i90 >> 2] = f34;
         i38 = Math_fround(HEAPF32[i73 >> 2]) <= f34;
         HEAP32[i73 >> 2] = HEAP32[(i38 ? i73 : i90) >> 2];
         break L50;
        }
        f32 = f20 <= f26 ? f20 : f26;
        f33 = Math_fround(f23 + Math_fround(f32 * f2));
        f34 = Math_fround(f24 + Math_fround(f32 * f17));
        f2 = Math_fround(f25 + Math_fround(f32 * f18));
        f2 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f2 * f2));
        if (f60 > f2) {
         if (i48) break;
         f34 = Math_fround(f89 - Math_fround(Math_sqrt(Math_fround(f2))));
         HEAPF32[i90 >> 2] = f34;
         i27 = Math_fround(HEAPF32[i7 >> 2]) <= f34;
         HEAP32[i7 >> 2] = HEAP32[(i27 ? i7 : i90) >> 2];
         break;
        }
        i13 = i4 + -5 | 0;
        if (i4 >>> 0 > 5) {
         i12 = i5 + 3 | 0;
         f32 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) >> 2]);
         f33 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) + 4 >> 2]);
         f34 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) + 8 >> 2]);
         i12 = i5 + 4 | 0;
         i11 = i5 + 5 | 0;
         f31 = Math_fround(f32 - f28);
         f29 = Math_fround(f33 - f29);
         f26 = Math_fround(f34 - f30);
         f28 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f29 * f29)) + Math_fround(f26 * f26));
         f2 = Math_fround(3402823469999999843913219.0e14);
         i6 = 0;
         do {
          i27 = i12 + i6 | 0;
          f30 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) >> 2]);
          f18 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 4 >> 2]);
          f24 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 8 >> 2]);
          i27 = i11 + i6 | 0;
          f17 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) >> 2]);
          f15 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 4 >> 2]);
          f30 = Math_fround(f30 - f32);
          f18 = Math_fround(f18 - f33);
          f24 = Math_fround(f24 - f34);
          f17 = Math_fround(f17 - f32);
          f15 = Math_fround(f15 - f33);
          f25 = Math_fround(Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 8 >> 2]) - f34);
          f20 = Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f18 * f18)) + Math_fround(f24 * f24));
          f19 = Math_fround(Math_fround(Math_fround(f30 * f17) + Math_fround(f18 * f15)) + Math_fround(f24 * f25));
          f23 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f15 * f15)) + Math_fround(f25 * f25));
          f24 = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f29 * f18)) + Math_fround(f26 * f24));
          f25 = Math_fround(Math_fround(Math_fround(f31 * f17) + Math_fround(f29 * f15)) + Math_fround(f26 * f25));
          f15 = Math_fround(Math_abs(Math_fround(Math_fround(f20 * f23) - Math_fround(f19 * f19))));
          f17 = Math_fround(Math_fround(f19 * f25) - Math_fround(f24 * f23));
          f18 = Math_fround(Math_fround(f24 * f19) - Math_fround(f20 * f25));
          if (f15 < Math_fround(.0000999999974)) f15 = Math_fround(3402823469999999843913219.0e14); else {
           i4 = f17 < Math_fround(0.0);
           do if (!(Math_fround(f17 + f18) <= f15)) {
            if (i4) {
             f15 = Math_fround(f24 + f19);
             f17 = Math_fround(f23 + f25);
             if (f17 > f15) {
              f15 = Math_fround(f17 - f15);
              f17 = Math_fround(f23 + Math_fround(f20 - Math_fround(f19 * Math_fround(2.0))));
              if (!(f15 >= f17)) {
               f30 = Math_fround(f15 / f17);
               f15 = Math_fround(Math_fround(1.0) - f30);
               f15 = Math_fround(f28 + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f24 * Math_fround(2.0)) + Math_fround(Math_fround(f20 * f30) + Math_fround(f19 * f15)))) + Math_fround(f15 * Math_fround(Math_fround(f25 * Math_fround(2.0)) + Math_fround(Math_fround(f19 * f30) + Math_fround(f23 * f15))))));
               break;
              } else {
               f15 = Math_fround(f28 + Math_fround(f20 + Math_fround(f24 * Math_fround(2.0))));
               break;
              }
             }
             if (f17 <= Math_fround(0.0)) {
              f15 = Math_fround(f28 + Math_fround(f23 + Math_fround(f25 * Math_fround(2.0))));
              break;
             }
             if (f25 >= Math_fround(0.0)) {
              f15 = f28;
              break;
             }
             f15 = Math_fround(f28 + Math_fround(f25 * Math_fround(Math_fround(-f25) / f23)));
             break;
            }
            if (!(f18 < Math_fround(0.0))) {
             f15 = Math_fround(Math_fround(Math_fround(f23 + f25) - f19) - f24);
             if (f15 <= Math_fround(0.0)) {
              f15 = Math_fround(f28 + Math_fround(f23 + Math_fround(f25 * Math_fround(2.0))));
              break;
             }
             f17 = Math_fround(f23 + Math_fround(f20 - Math_fround(f19 * Math_fround(2.0))));
             if (!(f15 >= f17)) {
              f30 = Math_fround(f15 / f17);
              f15 = Math_fround(Math_fround(1.0) - f30);
              f15 = Math_fround(f28 + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f24 * Math_fround(2.0)) + Math_fround(Math_fround(f20 * f30) + Math_fround(f19 * f15)))) + Math_fround(f15 * Math_fround(Math_fround(f25 * Math_fround(2.0)) + Math_fround(Math_fround(f19 * f30) + Math_fround(f23 * f15))))));
              break;
             } else {
              f15 = Math_fround(f28 + Math_fround(f20 + Math_fround(f24 * Math_fround(2.0))));
              break;
             }
            }
            f15 = Math_fround(f19 + f25);
            f17 = Math_fround(f20 + f24);
            if (f17 > f15) {
             f15 = Math_fround(f17 - f15);
             f17 = Math_fround(f23 + Math_fround(f20 - Math_fround(f19 * Math_fround(2.0))));
             if (!(f15 >= f17)) {
              f30 = Math_fround(f15 / f17);
              f15 = Math_fround(Math_fround(1.0) - f30);
              f15 = Math_fround(f28 + Math_fround(Math_fround(f15 * Math_fround(Math_fround(f24 * Math_fround(2.0)) + Math_fround(Math_fround(f19 * f30) + Math_fround(f20 * f15)))) + Math_fround(f30 * Math_fround(Math_fround(f25 * Math_fround(2.0)) + Math_fround(Math_fround(f23 * f30) + Math_fround(f19 * f15))))));
              break;
             } else {
              f15 = Math_fround(f28 + Math_fround(f23 + Math_fround(f25 * Math_fround(2.0))));
              break;
             }
            }
            if (f17 <= Math_fround(0.0)) {
             f15 = Math_fround(f28 + Math_fround(f20 + Math_fround(f24 * Math_fround(2.0))));
             break;
            }
            if (f24 >= Math_fround(0.0)) {
             f15 = f28;
             break;
            }
            f15 = Math_fround(f28 + Math_fround(f24 * Math_fround(Math_fround(-f24) / f20)));
           } else {
            i5 = f18 < Math_fround(0.0);
            if (!i4) {
             if (!i5) {
              f15 = Math_fround(Math_fround(1.0) / f15);
              f30 = Math_fround(f15 * f17);
              f15 = Math_fround(f15 * f18);
              f15 = Math_fround(f28 + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f24 * Math_fround(2.0)) + Math_fround(Math_fround(f20 * f30) + Math_fround(f19 * f15)))) + Math_fround(f15 * Math_fround(Math_fround(f25 * Math_fround(2.0)) + Math_fround(Math_fround(f19 * f30) + Math_fround(f23 * f15))))));
              break;
             }
             if (f24 >= Math_fround(0.0)) {
              f15 = f28;
              break;
             }
             f15 = Math_fround(-f24);
             if (!(f20 <= f15)) {
              f15 = Math_fround(f28 + Math_fround(f24 * Math_fround(f15 / f20)));
              break;
             } else {
              f15 = Math_fround(f28 + Math_fround(f20 + Math_fround(f24 * Math_fround(2.0))));
              break;
             }
            }
            if (!i5) {
             if (f25 >= Math_fround(0.0)) {
              f15 = f28;
              break;
             }
             f15 = Math_fround(-f25);
             if (!(f23 <= f15)) {
              f15 = Math_fround(f28 + Math_fround(f25 * Math_fround(f15 / f23)));
              break;
             } else {
              f15 = Math_fround(f28 + Math_fround(f23 + Math_fround(f25 * Math_fround(2.0))));
              break;
             }
            }
            if (f24 < Math_fround(0.0)) {
             f15 = Math_fround(-f24);
             if (!(f20 <= f15)) {
              f15 = Math_fround(f28 + Math_fround(f24 * Math_fround(f15 / f20)));
              break;
             } else {
              f15 = Math_fround(f28 + Math_fround(f20 + Math_fround(f24 * Math_fround(2.0))));
              break;
             }
            }
            if (f25 >= Math_fround(0.0)) {
             f15 = f28;
             break;
            }
            f15 = Math_fround(-f25);
            if (!(f23 <= f15)) {
             f15 = Math_fround(f28 + Math_fround(f25 * Math_fround(f15 / f23)));
             break;
            } else {
             f15 = Math_fround(f28 + Math_fround(f23 + Math_fround(f25 * Math_fround(2.0))));
             break;
            }
           } while (0);
           f15 = Math_fround(Math_abs(Math_fround(f15)));
          }
          f2 = f2 <= f15 ? f2 : f15;
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) < (i13 | 0) & (i71 | !(f2 <= f60)));
        } else f2 = Math_fround(3402823469999999843913219.0e14);
        i4 = f2 <= f60;
        if (i71 & i4) {
         f34 = Math_fround(f89 - Math_fround(Math_sqrt(Math_fround(f2))));
         HEAPF32[i90 >> 2] = f34;
         i27 = Math_fround(HEAPF32[i7 >> 2]) <= f34;
         HEAP32[i7 >> 2] = HEAP32[(i27 ? i7 : i90) >> 2];
        }
        if (i72 & (i4 ^ 1)) {
         f34 = Math_fround(Math_fround(Math_sqrt(Math_fround(f2))) - f89);
         HEAPF32[i90 >> 2] = f34;
         i27 = Math_fround(HEAPF32[i73 >> 2]) <= f34;
         HEAP32[i73 >> 2] = HEAP32[(i27 ? i73 : i90) >> 2];
         if (i4) break; else break L50;
        } else if (i4) break; else break L50;
       } while (0);
       if (i85) if (HEAP32[i86 + (i35 << 2) >> 2] & i36 | 0) {
        i1 = 1;
        break L18;
       }
       if (i87) {
        i4 = HEAP32[i49 >> 2] | 0;
        if ((i4 | 0) >= (HEAP32[i50 >> 2] | 0)) {
         i94 = 129;
         break L18;
        }
        HEAP32[(HEAP32[i82 >> 2] | 0) + (i4 << 2) >> 2] = i16;
        HEAP32[i49 >> 2] = (HEAP32[i49 >> 2] | 0) + 1;
       }
       if ((i3 | 0) > 2046) {
        i94 = 131;
        break L18;
       }
       i35 = (HEAP32[i80 >> 2] | 0) + (i35 << 2) | 0;
       HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i36;
       i3 = i3 + 1 | 0;
       HEAP32[i81 + 112 + (i3 << 3) + 4 >> 2] = i37;
       HEAP32[i81 + 112 + (i3 << 3) >> 2] = i38;
      }
     } while (0);
     i5 = HEAP32[i55 >> 2] | 0;
     i4 = HEAP32[i53 >> 2] | 0;
    } while ((i4 | 0) != (0 - i5 | 0));
   }
  } else i3 = i11;
  if ((i3 | 0) <= -1) {
   i94 = 133;
   break;
  }
  i6 = i3;
  i5 = i10;
  i4 = HEAP32[i81 + 112 + (i3 << 3) >> 2] | 0;
  i13 = HEAP32[i81 + 112 + (i3 << 3) + 4 >> 2] | 0;
 }
 if ((i94 | 0) == 129) {
  HEAP32[i49 >> 2] = i4 + 1;
  HEAP32[(HEAP32[i81 >> 2] | 0) + 28 >> 2] = 2;
  i1 = 1;
 } else if ((i94 | 0) == 131) {
  HEAP32[(HEAP32[i81 >> 2] | 0) + 28 >> 2] = 2;
  i1 = 1;
 } else if ((i94 | 0) == 133) if (i75) {
  HEAPF32[i93 >> 2] = Math_fround(3402823469999999843913219.0e14);
  if (i48) f2 = Math_fround(3402823469999999843913219.0e14); else {
   i94 = Math_fround(HEAPF32[i7 >> 2]) >= Math_fround(3402823469999999843913219.0e14);
   i94 = HEAP32[(i94 ? i93 : i7) >> 2] | 0;
   HEAP32[i93 >> 2] = i94;
   f2 = (HEAP32[tempDoublePtr >> 2] = i94, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
  if (i74) i1 = 0; else {
   i1 = f2 <= Math_fround(HEAPF32[i73 >> 2]);
   HEAP32[i93 >> 2] = HEAP32[(i1 ? i93 : i73) >> 2];
   i1 = 0;
  }
 } else i1 = 0;
 i94 = i1;
 STACKTOP = i95;
 return i94 | 0;
}

function _Render_Single_Pass(i27, i1) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i54 + 14 | 0;
 i49 = i54 + 12 | 0;
 i50 = i54 + 8 | 0;
 i51 = i54 + 4 | 0;
 i52 = i54;
 i53 = i27 + 1020 | 0;
 i2 = HEAP32[i53 >> 2] | 0;
 if ((i2 | 0) <= -1) {
  i53 = 0;
  STACKTOP = i54;
  return i53 | 0;
 }
 i28 = i27 + 4 | 0;
 i29 = i27 + 80 | 0;
 i30 = i27 + 76 | 0;
 i31 = i27 + 28 | 0;
 i32 = i27 + 40 | 0;
 i33 = i27 + 44 | 0;
 i34 = i27 + 92 | 0;
 i35 = i27 + 87 | 0;
 i36 = i27 + 86 | 0;
 i37 = i27 + 32 | 0;
 i39 = i27 + 36 | 0;
 i40 = i27 + 48 | 0;
 i41 = i27 + 88 | 0;
 i42 = i27 + 84 | 0;
 i43 = i27 + 128 | 0;
 i44 = i27 + 100 | 0;
 i45 = i27 + 96 | 0;
 i46 = i27 + 140 | 0;
 i47 = i27 + 132 | 0;
 i26 = i27 + 24 | 0;
 i48 = i27 + 8 | 0;
 i17 = i1 << 24 >> 24 != 0;
 i18 = i27 + 136 | 0;
 i19 = i27 + 68 | 0;
 i20 = i27 + 72 | 0;
 i21 = i27 + 176 | 0;
 i22 = i27 + 160 | 0;
 i23 = i27 + 172 | 0;
 i24 = i27 + 168 | 0;
 i25 = i27 + 164 | 0;
 i1 = i2;
 L4 : while (1) {
  i15 = HEAP32[i28 >> 2] | 0;
  HEAP32[i29 >> 2] = Math_imul(HEAP16[i27 + 956 + (i1 << 2) + 2 >> 1] | 0, i15) | 0;
  HEAP32[i30 >> 2] = Math_imul(HEAP16[i27 + 956 + (i1 << 2) >> 1] | 0, i15) | 0;
  i15 = HEAP32[i31 >> 2] | 0;
  HEAP32[i32 >> 2] = i15;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i34 >> 2] = 0;
  HEAP8[i35 >> 0] = 0;
  HEAP8[i36 >> 0] = 0;
  i1 = (HEAP32[i37 >> 2] | 0) + -32 | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i40 >> 2] = 0;
  i2 = i15;
  HEAP32[i41 >> 2] = i2;
  HEAP32[i2 + 8 >> 2] = i15;
  HEAP16[i42 >> 1] = 0;
  L6 : do if ((HEAP16[i43 >> 1] | 0) > 0) {
   i9 = 0;
   i13 = 0;
   i8 = HEAP32[i46 >> 2] | 0;
   i1 = HEAP32[i48 >> 2] | 0;
   while (1) {
    HEAP32[i44 >> 2] = 0;
    HEAP32[i45 >> 2] = 0;
    i15 = HEAP32[i47 >> 2] | 0;
    i7 = HEAPU16[i8 + (i13 << 1) >> 1] | 0;
    i4 = i15 + (i7 << 3) | 0;
    i3 = i9 & 65535;
    i9 = i15 + (i3 << 3) | 0;
    i2 = HEAP32[i26 >> 2] | 0;
    i6 = (HEAP32[i9 >> 2] << i2) - i1 | 0;
    i10 = (HEAP32[i15 + (i3 << 3) + 4 >> 2] << i2) - i1 | 0;
    i5 = (HEAP32[i4 >> 2] << i2) - i1 | 0;
    i2 = (HEAP32[i15 + (i7 << 3) + 4 >> 2] << i2) - i1 | 0;
    i8 = i17 ? i10 : i6;
    i10 = i17 ? i6 : i10;
    i6 = i17 ? i2 : i5;
    i2 = i17 ? i5 : i2;
    i5 = HEAP32[i18 >> 2] | 0;
    i1 = i5 + i3 | 0;
    i3 = HEAP8[i1 >> 0] | 0;
    if (i3 & 4) {
     HEAP8[i21 >> 0] = (i3 & 255) >>> 5;
     i3 = HEAP8[i1 >> 0] | 0;
    }
    switch (i3 & 3) {
    case 2:
     {
      i16 = 35;
      break L4;
     }
    case 0:
     {
      if ((HEAP8[i5 + i7 >> 0] & 3) == 1) {
       i4 = i4 + -8 | 0;
       i3 = i6;
      } else {
       i3 = (i6 + i8 | 0) / 2 | 0;
       i2 = (i2 + i10 | 0) / 2 | 0;
      }
      i5 = i9 + -8 | 0;
      i1 = i1 + -1 | 0;
      i12 = i3;
      i11 = i2;
      break;
     }
    default:
     {
      i5 = i9;
      i12 = i8;
      i11 = i10;
     }
    }
    HEAP32[i19 >> 2] = i12;
    HEAP32[i20 >> 2] = i11;
    L20 : do if (i5 >>> 0 < i4 >>> 0) {
     L21 : while (1) {
      i3 = i5 + 8 | 0;
      i6 = i1 + 1 | 0;
      L23 : do switch (HEAP8[i6 >> 0] & 3) {
      case 1:
       {
        i10 = HEAP32[i26 >> 2] | 0;
        i15 = HEAP32[i48 >> 2] | 0;
        i14 = (HEAP32[i3 >> 2] << i10) - i15 | 0;
        i15 = (HEAP32[i5 + 12 >> 2] << i10) - i15 | 0;
        if (!((_Line_To(i27, i17 ? i15 : i14, i17 ? i14 : i15) | 0) << 24 >> 24)) {
         i2 = i3;
         i1 = i6;
        } else {
         i16 = 90;
         break L6;
        }
        break;
       }
      case 0:
       {
        i15 = HEAP32[i26 >> 2] | 0;
        i1 = HEAP32[i48 >> 2] | 0;
        i2 = (HEAP32[i3 >> 2] << i15) - i1 | 0;
        i1 = (HEAP32[i5 + 12 >> 2] << i15) - i1 | 0;
        if (i17) {
         i5 = i2;
         while (1) {
          if (i3 >>> 0 >= i4 >>> 0) {
           i2 = i1;
           i1 = i5;
           break L21;
          }
          i2 = i3 + 8 | 0;
          i8 = i6 + 1 | 0;
          i14 = HEAP32[i26 >> 2] | 0;
          i15 = HEAP32[i48 >> 2] | 0;
          i7 = (HEAP32[i2 >> 2] << i14) - i15 | 0;
          i3 = (HEAP32[i3 + 12 >> 2] << i14) - i15 | 0;
          switch (HEAP8[i8 >> 0] & 3) {
          case 1:
           {
            i6 = (_Conic_To(i27, i1, i5, i3, i7) | 0) << 24 >> 24 == 0;
            i6 = i6 ? 7 : 12;
            break;
           }
          case 0:
           {
            i15 = (_Conic_To(i27, i1, i5, (i3 + i1 | 0) / 2 | 0, (i7 + i5 | 0) / 2 | 0) | 0) << 24 >> 24 == 0;
            i6 = i15 ? 15 : 12;
            i1 = i15 ? i3 : i1;
            i5 = i15 ? i7 : i5;
            break;
           }
          default:
           {
            i16 = 35;
            break L4;
           }
          }
          switch (i6 & 15) {
          case 6:
           {
            i16 = 35;
            break L4;
           }
          case 12:
           {
            i16 = 90;
            break L6;
           }
          case 7:
           {
            i1 = i8;
            break L23;
           }
          case 15:
           {
            i3 = i2;
            i6 = i8;
            break;
           }
          default:
           break L20;
          }
         }
        } else {
         i5 = i6;
         while (1) {
          if (i3 >>> 0 >= i4 >>> 0) break L21;
          i7 = i3 + 8 | 0;
          i8 = i5 + 1 | 0;
          i14 = HEAP32[i26 >> 2] | 0;
          i15 = HEAP32[i48 >> 2] | 0;
          i5 = (HEAP32[i7 >> 2] << i14) - i15 | 0;
          i3 = (HEAP32[i3 + 12 >> 2] << i14) - i15 | 0;
          switch (HEAP8[i8 >> 0] & 3) {
          case 1:
           {
            i6 = (_Conic_To(i27, i2, i1, i5, i3) | 0) << 24 >> 24 == 0;
            i6 = i6 ? 7 : 12;
            break;
           }
          case 0:
           {
            i15 = (_Conic_To(i27, i2, i1, (i5 + i2 | 0) / 2 | 0, (i3 + i1 | 0) / 2 | 0) | 0) << 24 >> 24 == 0;
            i6 = i15 ? 15 : 12;
            i2 = i15 ? i5 : i2;
            i1 = i15 ? i3 : i1;
            break;
           }
          default:
           {
            i16 = 35;
            break L4;
           }
          }
          switch (i6 & 15) {
          case 6:
           {
            i16 = 35;
            break L4;
           }
          case 12:
           {
            i16 = 90;
            break L6;
           }
          case 7:
           {
            i2 = i7;
            i1 = i8;
            break L23;
           }
          case 15:
           {
            i3 = i7;
            i5 = i8;
            break;
           }
          default:
           break L20;
          }
         }
        }
       }
      default:
       {
        if ((i5 + 16 | 0) >>> 0 > i4 >>> 0) {
         i16 = 35;
         break L4;
        }
        if ((HEAP8[i1 + 2 >> 0] & 3) != 2) {
         i16 = 35;
         break L4;
        }
        i10 = i5 + 24 | 0;
        i8 = HEAP32[i26 >> 2] | 0;
        i9 = HEAP32[i48 >> 2] | 0;
        i6 = (HEAP32[i5 + 8 >> 2] << i8) - i9 | 0;
        i3 = (HEAP32[i5 + 12 >> 2] << i8) - i9 | 0;
        i15 = (HEAP32[i5 + 16 >> 2] << i8) - i9 | 0;
        i7 = (HEAP32[i5 + 20 >> 2] << i8) - i9 | 0;
        i2 = i17 ? i3 : i6;
        i3 = i17 ? i6 : i3;
        i6 = i17 ? i7 : i15;
        i7 = i17 ? i15 : i7;
        if (i10 >>> 0 > i4 >>> 0) {
         i2 = (_Cubic_To(i27, i2, i3, i6, i7, i12, i11) | 0) << 24 >> 24 == 0;
         i2 = i2 ? 18 : 12;
        } else {
         i14 = (HEAP32[i10 >> 2] << i8) - i9 | 0;
         i15 = (HEAP32[i5 + 28 >> 2] << i8) - i9 | 0;
         i2 = (_Cubic_To(i27, i2, i3, i6, i7, i17 ? i15 : i14, i17 ? i14 : i15) | 0) << 24 >> 24 == 0;
         i2 = i2 ? 7 : 12;
        }
        switch (i2 & 31) {
        case 6:
         {
          i16 = 35;
          break L4;
         }
        case 12:
         {
          i16 = 90;
          break L6;
         }
        case 7:
         {
          i2 = i10;
          i1 = i1 + 3 | 0;
          break;
         }
        default:
         break L20;
        }
       }
      } while (0);
      if (i2 >>> 0 < i4 >>> 0) i5 = i2; else {
       i16 = 34;
       break L20;
      }
     }
     if ((_Conic_To(i27, i2, i1, i12, i11) | 0) << 24 >> 24) {
      i16 = 90;
      break L6;
     }
    } else i16 = 34; while (0);
    if ((i16 | 0) == 34) {
     i16 = 0;
     if ((_Line_To(i27, i12, i11) | 0) << 24 >> 24) {
      i16 = 90;
      break L6;
     }
    }
    i8 = HEAP32[i46 >> 2] | 0;
    i9 = (HEAPU16[i8 + (i13 << 1) >> 1] | 0) + 1 | 0;
    i3 = HEAP32[i20 >> 2] | 0;
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = i4 + -1 & i3;
    if (!i5) if ((i3 | 0) >= (HEAP32[i30 >> 2] | 0)) if ((i3 | 0) <= (HEAP32[i29 >> 2] | 0)) {
     i1 = HEAP32[i45 >> 2] | 0;
     if (i1 | 0) if (!((HEAP16[(HEAP32[i41 >> 2] | 0) + 12 >> 1] ^ HEAP16[i1 + 12 >> 1]) & 8)) HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + -4;
    }
    i7 = HEAP32[i41 >> 2] | 0;
    i2 = HEAP32[i32 >> 2] | 0;
    i15 = HEAP32[i7 + 8 >> 2] | 0;
    i6 = i2;
    i1 = i15;
    if ((i2 | 0) == (i15 | 0)) i16 = 45; else if (!(HEAP16[i7 + 12 >> 1] & 8)) i16 = 45; else {
     i4 = HEAP32[i48 >> 2] | 0;
     i3 = (i5 | 0) >= (i4 | 0);
    }
    if ((i16 | 0) == 45) {
     i16 = 0;
     i15 = HEAP32[i48 >> 2] | 0;
     i3 = ((i3 + -1 + i4 & 0 - i4) - i3 | 0) >= (i15 | 0);
     i4 = i15;
    }
    i1 = i6 - i1 | 0;
    if ((i1 | 0) < 0) {
     i16 = 47;
     break L4;
    }
    if (i1) {
     HEAP32[i7 + 16 >> 2] = i1 >> 2;
     do if (i3) {
      i1 = i7 + 12 | 0;
      i3 = HEAPU16[i1 >> 1] | 0;
      if (!(i3 & 8)) {
       HEAP16[i1 >> 1] = i3 | 32;
       break;
      } else {
       HEAP16[i1 >> 1] = i3 | 16;
       break;
      }
     } while (0);
     HEAP32[i41 >> 2] = i6;
     i15 = i2 + 32 | 0;
     HEAP32[i32 >> 2] = i15;
     HEAP32[i2 + 16 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = i15;
     HEAP32[i7 + 28 >> 2] = i6;
     HEAP16[i42 >> 1] = (HEAP16[i42 >> 1] | 0) + 1 << 16 >> 16;
     i2 = i15;
    }
    i1 = HEAP32[i39 >> 2] | 0;
    if (i2 >>> 0 >= i1 >>> 0) {
     i16 = 55;
     break;
    }
    HEAP8[i35 >> 0] = 0;
    i3 = HEAP32[i45 >> 2] | 0;
    if (i3 | 0) HEAP32[i7 + 28 >> 2] = i3;
    i13 = i13 + 1 | 0;
    if ((i13 | 0) >= (HEAP16[i43 >> 1] | 0)) break; else i1 = i4;
   }
   if ((i16 | 0) == 55) {
    HEAP32[i33 >> 2] = 98;
    i16 = 91;
    break;
   }
   i4 = HEAP16[i42 >> 1] | 0;
   i3 = HEAP32[i34 >> 2] | 0;
   if ((i4 & 65535) > 1 & (i3 | 0) != 0) {
    i15 = HEAP32[i37 >> 2] | 0;
    i8 = i3;
    i13 = i2;
    while (1) {
     i5 = HEAP32[i8 + 16 >> 2] | 0;
     if ((i4 & 65535) > 1) {
      i14 = (HEAP32[i8 + 8 >> 2] | 0) + (i5 << 2) | 0;
      HEAP32[i8 + 4 >> 2] = i14;
     } else {
      HEAP32[i8 + 4 >> 2] = 0;
      i14 = 0;
     }
     i6 = i8 + 20 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (!(HEAP16[i8 + 12 >> 1] & 8)) {
      i16 = i7 - i5 + 1 | 0;
      HEAP32[i6 >> 2] = i16;
      i12 = i8 + 8 | 0;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + (i5 + -1 << 2);
      i12 = i7;
      i5 = i16;
     } else {
      i12 = i5 + -1 + i7 | 0;
      i5 = i7;
     }
     i11 = HEAP32[i40 >> 2] | 0;
     i10 = i15 + (0 - i11 << 2) | 0;
     i9 = i11;
     while (1) {
      i6 = i9 + -1 | 0;
      if ((i9 | 0) <= 0) {
       i16 = 73;
       break;
      }
      i8 = i10 + (i6 << 2) | 0;
      i7 = HEAP32[i8 >> 2] | 0;
      if ((i7 | 0) > (i5 | 0)) i9 = i6; else {
       i16 = 70;
       break;
      }
     }
     if ((i16 | 0) == 70) if ((i7 | 0) < (i5 | 0)) {
      HEAP32[i8 >> 2] = i5;
      i6 = i9 + -2 | 0;
      if ((i9 | 0) > 1) while (1) {
       i16 = i10 + (i6 << 2) | 0;
       i5 = HEAP32[i16 >> 2] | 0;
       HEAP32[i16 >> 2] = i7;
       if ((i6 | 0) > 0) {
        i6 = i6 + -1 | 0;
        i7 = i5;
       } else {
        i16 = 74;
        break;
       }
      } else {
       i5 = i7;
       i16 = 73;
      }
     } else i16 = 73;
     if ((i16 | 0) == 73) {
      i16 = 0;
      if ((i6 | 0) < 0) i16 = 74;
     }
     if ((i16 | 0) == 74) {
      i1 = i1 + -4 | 0;
      HEAP32[i39 >> 2] = i1;
      if (i1 >>> 0 <= i13 >>> 0) {
       i16 = 76;
       break;
      }
      i16 = i11 + 1 | 0;
      HEAP32[i40 >> 2] = i16;
      HEAP32[i15 + (~i11 << 2) >> 2] = i5;
      i11 = i16;
     }
     i5 = i12 + 1 | 0;
     i10 = i15 + (0 - i11 << 2) | 0;
     i9 = i11;
     while (1) {
      i6 = i9 + -1 | 0;
      if ((i9 | 0) <= 0) {
       i16 = 83;
       break;
      }
      i8 = i10 + (i6 << 2) | 0;
      i7 = HEAP32[i8 >> 2] | 0;
      if ((i7 | 0) > (i5 | 0)) i9 = i6; else {
       i16 = 80;
       break;
      }
     }
     if ((i16 | 0) == 80) if ((i7 | 0) > (i12 | 0)) i16 = 83; else {
      HEAP32[i8 >> 2] = i5;
      i6 = i9 + -2 | 0;
      if ((i9 | 0) > 1) while (1) {
       i16 = i10 + (i6 << 2) | 0;
       i5 = HEAP32[i16 >> 2] | 0;
       HEAP32[i16 >> 2] = i7;
       if ((i6 | 0) > 0) {
        i6 = i6 + -1 | 0;
        i7 = i5;
       } else {
        i16 = 84;
        break;
       }
      } else {
       i5 = i7;
       i16 = 83;
      }
     }
     if ((i16 | 0) == 83) {
      i16 = 0;
      if ((i6 | 0) < 0) i16 = 84; else i5 = i13;
     }
     if ((i16 | 0) == 84) {
      i1 = i1 + -4 | 0;
      HEAP32[i39 >> 2] = i1;
      if (i1 >>> 0 <= i2 >>> 0) {
       i16 = 86;
       break;
      }
      HEAP32[i40 >> 2] = i11 + 1;
      HEAP32[i15 + (~i11 << 2) >> 2] = i5;
      i5 = i2;
     }
     i4 = i4 + -1 << 16 >> 16;
     if (!(i4 << 16 >> 16)) {
      i16 = 89;
      break L6;
     } else {
      i8 = i14;
      i13 = i5;
     }
    }
    if ((i16 | 0) == 76) {
     HEAP32[i33 >> 2] = 98;
     i16 = 91;
     break;
    } else if ((i16 | 0) == 86) {
     HEAP32[i33 >> 2] = 98;
     i16 = 91;
     break;
    }
   } else i16 = 88;
  } else i16 = 88; while (0);
  if ((i16 | 0) == 88) {
   HEAP32[i34 >> 2] = 0;
   i3 = 0;
   i16 = 89;
  }
  if ((i16 | 0) == 89) {
   i16 = 0;
   if (i2 >>> 0 < i1 >>> 0) {
    if (i3 | 0) {
     HEAP32[i50 >> 2] = 0;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i52 >> 2] = 0;
     i5 = HEAP32[i27 >> 2] | 0;
     i6 = HEAP32[i30 >> 2] >> i5 & 65535;
     HEAP16[i49 >> 1] = i6;
     i5 = HEAP32[i29 >> 2] >> i5 & 65535;
     HEAP16[i38 >> 1] = i5;
     while (1) {
      i8 = i3 + 4 | 0;
      i7 = i3;
      i3 = HEAP32[i8 >> 2] | 0;
      i1 = HEAP32[i7 + 20 >> 2] | 0;
      i2 = i1 + 65535 + (HEAP32[i7 + 16 >> 2] | 0) | 0;
      i4 = i2 & 65535;
      if ((i5 << 16 >> 16 | 0) > (i1 << 16 >> 16 | 0)) {
       i5 = i1 & 65535;
       HEAP16[i38 >> 1] = i5;
      }
      if ((i6 << 16 >> 16 | 0) < (i2 << 16 >> 16 | 0)) HEAP16[i49 >> 1] = i4; else i4 = i6;
      HEAP32[i7 >> 2] = 0;
      i1 = HEAP32[i50 >> 2] | 0;
      L140 : do if (!i1) {
       i2 = i50;
       i1 = 0;
      } else {
       i2 = i50;
       while (1) {
        if ((HEAP32[i1 >> 2] | 0) > 0) break L140;
        i2 = i1 + 4 | 0;
        i1 = HEAP32[i2 >> 2] | 0;
        if (!i1) {
         i1 = 0;
         break;
        }
       }
      } while (0);
      HEAP32[i8 >> 2] = i1;
      HEAP32[i2 >> 2] = i7;
      if (!i3) break; else i6 = i4;
     }
     if (!(HEAP32[i40 >> 2] | 0)) {
      i16 = 105;
      break;
     }
     mftCall_viii(HEAP32[i22 >> 2] | 0, i27 | 0, i38 | 0, i49 | 0);
     i2 = HEAP32[i50 >> 2] | 0;
     i1 = HEAP16[i38 >> 1] | 0;
     if (i2 | 0) {
      i3 = i1 << 16 >> 16;
      do {
       HEAP32[i2 + 24 >> 2] = (HEAP32[i2 + 20 >> 2] | 0) - i3;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
      } while ((i2 | 0) != 0);
     }
     i3 = HEAP32[i40 >> 2] | 0;
     if ((i3 | 0) > 0) {
      i4 = i3 + -1 | 0;
      if ((HEAP32[(HEAP32[i37 >> 2] | 0) + (0 - i3 << 2) >> 2] | 0) == (i1 << 16 >> 16 | 0)) {
       HEAP32[i40 >> 2] = i4;
       i2 = 0;
      } else {
       i2 = 0;
       i16 = 112;
      }
     } else {
      i2 = 0;
      i4 = i3;
     }
     L155 : while (1) {
      if ((i16 | 0) == 112) {
       i16 = 0;
       i4 = HEAP32[i40 >> 2] | 0;
      }
      if ((i4 | 0) <= 0) break;
      i3 = HEAP32[i50 >> 2] | 0;
      if (i3 | 0) {
       i9 = i2 << 16 >> 16;
       do {
        i8 = i3 + 4 | 0;
        i7 = i3;
        i3 = HEAP32[i8 >> 2] | 0;
        i14 = i7 + 24 | 0;
        i15 = (HEAP32[i14 >> 2] | 0) - i9 | 0;
        HEAP32[i14 >> 2] = i15;
        do if (!i15) {
         i5 = i50;
         while (1) {
          i2 = HEAP32[i5 >> 2] | 0;
          if (!i2) break;
          i6 = i2 + 4 | 0;
          if ((i2 | 0) == (i7 | 0)) {
           i16 = 120;
           break;
          } else i5 = i6;
         }
         if ((i16 | 0) == 120) {
          i16 = 0;
          HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
         }
         i6 = HEAP32[i7 >> 2] | 0;
         if (!(HEAP16[i7 + 12 >> 1] & 8)) {
          i2 = HEAP32[i52 >> 2] | 0;
          L173 : do if (!i2) {
           i5 = i52;
           i2 = 0;
          } else {
           i5 = i52;
           while (1) {
            if ((i6 | 0) < (HEAP32[i2 >> 2] | 0)) break L173;
            i5 = i2 + 4 | 0;
            i2 = HEAP32[i5 >> 2] | 0;
            if (!i2) {
             i2 = 0;
             break;
            }
           }
          } while (0);
          HEAP32[i8 >> 2] = i2;
          HEAP32[i5 >> 2] = i7;
          break;
         } else {
          i2 = HEAP32[i51 >> 2] | 0;
          L179 : do if (!i2) {
           i5 = i51;
           i2 = 0;
          } else {
           i5 = i51;
           while (1) {
            if ((i6 | 0) < (HEAP32[i2 >> 2] | 0)) break L179;
            i5 = i2 + 4 | 0;
            i2 = HEAP32[i5 >> 2] | 0;
            if (!i2) {
             i2 = 0;
             break;
            }
           }
          } while (0);
          HEAP32[i8 >> 2] = i2;
          HEAP32[i5 >> 2] = i7;
          break;
         }
        } while (0);
       } while ((i3 | 0) != 0);
      }
      i5 = HEAP32[i51 >> 2] | 0;
      if (i5 | 0) {
       i2 = i5;
       do {
        i15 = i2 + 8 | 0;
        i14 = HEAP32[i15 >> 2] | 0;
        HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i15 >> 2] = i14 + (((HEAP16[i2 + 12 >> 1] & 8) >>> 2) + -1 << 2);
        i15 = i2 + 16 | 0;
        HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
       } while ((i2 | 0) != 0);
       i2 = i5 + 4 | 0;
       i6 = HEAP32[i2 >> 2] | 0;
       if (i6 | 0) {
        i3 = i51;
        do {
         if ((HEAP32[i5 >> 2] | 0) > (HEAP32[i6 >> 2] | 0)) {
          HEAP32[i3 >> 2] = i6;
          i3 = i6 + 4 | 0;
          HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
          HEAP32[i3 >> 2] = i5;
          i3 = i51;
          i5 = HEAP32[i51 >> 2] | 0;
         } else {
          i3 = i2;
          i5 = i6;
         }
         i2 = i5 + 4 | 0;
         i6 = HEAP32[i2 >> 2] | 0;
        } while ((i6 | 0) != 0);
       }
      }
      i7 = HEAP32[i52 >> 2] | 0;
      if (!i7) i2 = 0; else {
       i2 = i7;
       do {
        i15 = i2 + 8 | 0;
        i14 = HEAP32[i15 >> 2] | 0;
        HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i15 >> 2] = i14 + (((HEAP16[i2 + 12 >> 1] & 8) >>> 2) + -1 << 2);
        i15 = i2 + 16 | 0;
        HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
       } while ((i2 | 0) != 0);
       i2 = i7 + 4 | 0;
       i5 = HEAP32[i2 >> 2] | 0;
       if (!i5) i2 = i7; else {
        i3 = i7;
        i6 = i52;
        i8 = i5;
        i5 = i7;
        do {
         if ((HEAP32[i5 >> 2] | 0) > (HEAP32[i8 >> 2] | 0)) {
          HEAP32[i6 >> 2] = i8;
          i3 = i8 + 4 | 0;
          HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
          HEAP32[i3 >> 2] = i5;
          i5 = HEAP32[i52 >> 2] | 0;
          i3 = i5;
          i6 = i52;
         } else {
          i6 = i2;
          i5 = i8;
         }
         i2 = i5 + 4 | 0;
         i8 = HEAP32[i2 >> 2] | 0;
        } while ((i8 | 0) != 0);
        i2 = i3;
       }
      }
      HEAP32[i40 >> 2] = i4 + -1;
      i12 = HEAP32[(HEAP32[i37 >> 2] | 0) + (0 - i4 << 2) >> 2] << 16 >> 16;
      i13 = i12 - (i1 & 65535) | 0;
      L206 : do if ((i1 << 16 >> 16 | 0) < (i12 | 0)) {
       i5 = i2;
       L207 : while (1) {
        i2 = HEAP32[i51 >> 2] | 0;
        i11 = (i2 | 0) == 0;
        do if (!i11) {
         i4 = 0;
         i3 = i2;
         while (1) {
          i8 = HEAP32[i3 >> 2] | 0;
          i7 = HEAP32[i5 >> 2] | 0;
          i10 = (i8 | 0) > (i7 | 0);
          i6 = i10 ? i7 : i8;
          i7 = i10 ? i8 : i7;
          i8 = HEAP32[i28 >> 2] | 0;
          i10 = 0 - i8 | 0;
          i9 = i6 & i10;
          i10 = i8 + -1 + i7 & i10;
          do if ((i7 - i6 | 0) > (i8 | 0) | (i9 | 0) == (i6 | 0) | (i10 | 0) == (i7 | 0)) i16 = 150; else {
           if (!((i9 | 0) > (i10 | 0) | (i10 | 0) == (i9 + i8 | 0))) {
            i16 = 150;
            break;
           }
           if ((HEAP16[i3 + 12 >> 1] & 7) == 2) break;
           HEAP32[i3 >> 2] = i6;
           HEAP32[i5 >> 2] = i7;
           HEAP32[i3 + 24 >> 2] = 1;
           i4 = i4 + 1 << 16 >> 16;
          } while (0);
          if ((i16 | 0) == 150) {
           i16 = 0;
           mftCall_viiiiii(HEAP32[i25 >> 2] | 0, i27 | 0, i1 | 0, i6 | 0, i7 | 0, i3 | 0, i5 | 0);
          }
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (!i3) break;
          i5 = HEAP32[i5 + 4 >> 2] | 0;
         }
         if (i4 << 16 >> 16 < 1) break; else {
          i5 = i2;
          i3 = i52;
         }
         while (1) {
          i3 = HEAP32[i3 >> 2] | 0;
          i4 = i5 + 24 | 0;
          if (HEAP32[i4 >> 2] | 0) {
           HEAP32[i4 >> 2] = 0;
           mftCall_viiiiii(HEAP32[i24 >> 2] | 0, i27 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0, i5 | 0, i3 | 0);
          }
          i5 = HEAP32[i5 + 4 >> 2] | 0;
          if (!i5) break; else i3 = i3 + 4 | 0;
         }
        } while (0);
        mftCall_vi(HEAP32[i23 >> 2] | 0, i27 | 0);
        i1 = i1 + 1 << 16 >> 16;
        if ((i1 << 16 >> 16 | 0) >= (i12 | 0)) break L206;
        do if (!i11) {
         i3 = i2;
         do {
          i15 = i3 + 8 | 0;
          i14 = HEAP32[i15 >> 2] | 0;
          HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
          HEAP32[i15 >> 2] = i14 + (((HEAP16[i3 + 12 >> 1] & 8) >>> 2) + -1 << 2);
          i15 = i3 + 16 | 0;
          HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
          i3 = HEAP32[i3 + 4 >> 2] | 0;
         } while ((i3 | 0) != 0);
         i3 = i2 + 4 | 0;
         i5 = HEAP32[i3 >> 2] | 0;
         if (!i5) break; else i4 = i51;
         do {
          if ((HEAP32[i2 >> 2] | 0) > (HEAP32[i5 >> 2] | 0)) {
           HEAP32[i4 >> 2] = i5;
           i4 = i5 + 4 | 0;
           HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
           HEAP32[i4 >> 2] = i2;
           i4 = i51;
           i2 = HEAP32[i51 >> 2] | 0;
          } else {
           i4 = i3;
           i2 = i5;
          }
          i3 = i2 + 4 | 0;
          i5 = HEAP32[i3 >> 2] | 0;
         } while ((i5 | 0) != 0);
        } while (0);
        i5 = HEAP32[i52 >> 2] | 0;
        if (!i5) {
         i5 = 0;
         continue;
        } else i2 = i5;
        do {
         i15 = i2 + 8 | 0;
         i14 = HEAP32[i15 >> 2] | 0;
         HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
         HEAP32[i15 >> 2] = i14 + (((HEAP16[i2 + 12 >> 1] & 8) >>> 2) + -1 << 2);
         i15 = i2 + 16 | 0;
         HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
         i2 = HEAP32[i2 + 4 >> 2] | 0;
        } while ((i2 | 0) != 0);
        i2 = i5 + 4 | 0;
        i3 = HEAP32[i2 >> 2] | 0;
        if (!i3) continue; else {
         i4 = i5;
         i6 = i52;
         i7 = i3;
         i3 = i5;
        }
        while (1) {
         if ((HEAP32[i3 >> 2] | 0) > (HEAP32[i7 >> 2] | 0)) {
          HEAP32[i6 >> 2] = i7;
          i4 = i7 + 4 | 0;
          HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
          HEAP32[i4 >> 2] = i3;
          i3 = HEAP32[i52 >> 2] | 0;
          i4 = i3;
          i6 = i52;
         } else {
          i6 = i2;
          i3 = i7;
         }
         i2 = i3 + 4 | 0;
         i5 = HEAP32[i2 >> 2] | 0;
         if (!i5) {
          i5 = i4;
          continue L207;
         } else i7 = i5;
        }
       }
      } else i2 = HEAP32[i51 >> 2] | 0; while (0);
      if (i2 | 0) do {
       i5 = i2;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       L251 : do if (!(HEAP32[i5 + 16 >> 2] | 0)) {
        i4 = i51;
        while (1) {
         i3 = HEAP32[i4 >> 2] | 0;
         if (!i3) break L251;
         i6 = i3 + 4 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i4 = i6;
        }
        HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
       } while (0);
      } while ((i2 | 0) != 0);
      i2 = HEAP32[i52 >> 2] | 0;
      if (!i2) {
       i2 = i13;
       i16 = 112;
       continue;
      }
      while (1) {
       i5 = HEAP32[i2 + 4 >> 2] | 0;
       L260 : do if (!(HEAP32[i2 + 16 >> 2] | 0)) {
        i4 = i52;
        while (1) {
         i3 = HEAP32[i4 >> 2] | 0;
         if (!i3) break L260;
         i6 = i3 + 4 | 0;
         if ((i3 | 0) == (i2 | 0)) break; else i4 = i6;
        }
        HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
       } while (0);
       if (!i5) {
        i2 = i13;
        i16 = 112;
        continue L155;
       } else i2 = i5;
      }
     }
     if (i1 << 16 >> 16 <= (HEAP16[i49 >> 1] | 0)) do {
      mftCall_vi(HEAP32[i23 >> 2] | 0, i27 | 0);
      i1 = i1 + 1 << 16 >> 16;
     } while (i1 << 16 >> 16 <= (HEAP16[i49 >> 1] | 0));
    }
    i1 = (HEAP32[i53 >> 2] | 0) + -1 | 0;
   } else i16 = 90;
  }
  if ((i16 | 0) == 90) if ((HEAP32[i33 >> 2] | 0) == 98) i16 = 91; else {
   i1 = 1;
   i16 = 186;
   break;
  }
  if ((i16 | 0) == 91) {
   i16 = 0;
   HEAP32[i33 >> 2] = 0;
   i1 = HEAP32[i53 >> 2] | 0;
   i2 = HEAP16[i27 + 956 + (i1 << 2) + 2 >> 1] | 0;
   i15 = HEAP16[i27 + 956 + (i1 << 2) >> 1] | 0;
   i3 = ((i2 << 16 >> 16) + i15 | 0) / 2 | 0;
   if ((i1 | 0) > 6 | (i3 | 0) < (i15 | 0)) {
    i16 = 92;
    break;
   }
   HEAP16[i27 + 956 + (i1 + 1 << 2) >> 1] = i3;
   HEAP16[i27 + 956 + ((HEAP32[i53 >> 2] | 0) + 1 << 2) + 2 >> 1] = i2;
   HEAP16[i27 + 956 + (HEAP32[i53 >> 2] << 2) + 2 >> 1] = i3 + 65535;
   i1 = (HEAP32[i53 >> 2] | 0) + 1 | 0;
  }
  HEAP32[i53 >> 2] = i1;
  if ((i1 | 0) <= -1) {
   i1 = 0;
   i16 = 186;
   break;
  }
 }
 if ((i16 | 0) == 35) {
  HEAP32[i33 >> 2] = 20;
  i53 = 1;
  STACKTOP = i54;
  return i53 | 0;
 } else if ((i16 | 0) == 47) {
  HEAP32[i33 >> 2] = 99;
  i53 = 1;
  STACKTOP = i54;
  return i53 | 0;
 } else if ((i16 | 0) == 92) {
  HEAP32[i53 >> 2] = 0;
  HEAP32[i33 >> 2] = 20;
  i53 = 20;
  STACKTOP = i54;
  return i53 | 0;
 } else if ((i16 | 0) == 105) {
  HEAP32[i33 >> 2] = 20;
  i53 = 20;
  STACKTOP = i54;
  return i53 | 0;
 } else if ((i16 | 0) == 186) {
  STACKTOP = i54;
  return i1 | 0;
 }
 return 0;
}

function __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb0EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, f122 = f0, i123 = 0, i124 = 0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, f151 = f0, f152 = f0, f153 = f0;
 i133 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i113 = i133 + 584 | 0;
 i115 = i133 + 580 | 0;
 i120 = i133 + 576 | 0;
 i121 = i133 + 408 | 0;
 i123 = i133 + 240 | 0;
 i124 = i133 + 224 | 0;
 i129 = i133 + 176 | 0;
 i130 = i133 + 144 | 0;
 i131 = i133 + 112 | 0;
 i132 = i133 + 80 | 0;
 i116 = i133 + 32 | 0;
 i117 = i133 + 16 | 0;
 i118 = i133;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i115 >> 2] = 0;
  HEAP32[i113 >> 2] = HEAP32[i115 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i113);
  i114 = gb + 1451836 | 0;
 } else i114 = 0;
 i119 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i113 >> 2] = f2;
 HEAP32[i115 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i120 >> 2] = HEAP32[i3 + 812 >> 2];
 f125 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f126 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f127 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f122 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i121 + 4 >> 2] = Math_fround(inf);
 HEAP32[i121 >> 2] = 0;
 i92 = i121 + 8 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 32 >> 2] = Math_fround(inf);
 HEAP32[i121 + 28 >> 2] = 0;
 i92 = i121 + 36 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 60 >> 2] = Math_fround(inf);
 HEAP32[i121 + 56 >> 2] = 0;
 i92 = i121 + 64 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 88 >> 2] = Math_fround(inf);
 HEAP32[i121 + 84 >> 2] = 0;
 i92 = i121 + 92 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 116 >> 2] = Math_fround(inf);
 HEAP32[i121 + 112 >> 2] = 0;
 i92 = i121 + 120 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 144 >> 2] = Math_fround(inf);
 HEAP32[i121 + 140 >> 2] = 0;
 i92 = i121 + 148 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f125 = Math_fround(f125 * Math_fround(100.0));
 f126 = Math_fround(f126 * Math_fround(100.0));
 f127 = Math_fround(f127 * Math_fround(100.0));
 f128 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i123 + 4 >> 2] = Math_fround(inf);
 HEAP32[i123 >> 2] = 0;
 i4 = i123 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 32 >> 2] = Math_fround(inf);
 HEAP32[i123 + 28 >> 2] = 0;
 i4 = i123 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 60 >> 2] = Math_fround(inf);
 HEAP32[i123 + 56 >> 2] = 0;
 i4 = i123 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 88 >> 2] = Math_fround(inf);
 HEAP32[i123 + 84 >> 2] = 0;
 i4 = i123 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 116 >> 2] = Math_fround(inf);
 HEAP32[i123 + 112 >> 2] = 0;
 i4 = i123 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 144 >> 2] = Math_fround(inf);
 HEAP32[i123 + 140 >> 2] = 0;
 i4 = i123 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i92 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i92 >> 2] | 0) >>> 0) {
  i93 = i119 + 520 | 0;
  i94 = i124 + 4 | 0;
  i95 = i124 + 8 | 0;
  i96 = i124 + 12 | 0;
  i97 = i119 + 500 | 0;
  i98 = i129 + 4 | 0;
  i99 = i129 + 8 | 0;
  i100 = i129 + 12 | 0;
  i101 = i3 + 8 | 0;
  i102 = i3 + 92 | 0;
  i103 = i130 + 4 | 0;
  i104 = i130 + 8 | 0;
  i105 = i130 + 12 | 0;
  i106 = i119 + 20 | 0;
  i107 = i119 + 40 | 0;
  i108 = i129 + 4 | 0;
  i109 = i129 + 8 | 0;
  i110 = i129 + 12 | 0;
  i111 = i129 + 16 | 0;
  i112 = i129 + 20 | 0;
  i48 = i129 + 24 | 0;
  i49 = i129 + 28 | 0;
  i50 = i129 + 32 | 0;
  i51 = i129 + 36 | 0;
  i52 = i129 + 40 | 0;
  i53 = i129 + 44 | 0;
  i54 = i3 + 808 | 0;
  i55 = i131 + 16 | 0;
  i56 = i132 + 4 | 0;
  i57 = i131 + 20 | 0;
  i58 = i132 + 8 | 0;
  i59 = i131 + 24 | 0;
  i60 = i132 + 12 | 0;
  i61 = i131 + 28 | 0;
  i62 = i116 + 4 | 0;
  i63 = i116 + 8 | 0;
  i64 = i116 + 12 | 0;
  i65 = i116 + 16 | 0;
  i66 = i132 + 16 | 0;
  i67 = i130 + 4 | 0;
  i68 = i132 + 20 | 0;
  i69 = i130 + 8 | 0;
  i70 = i132 + 24 | 0;
  i71 = i130 + 12 | 0;
  i72 = i132 + 28 | 0;
  i73 = i116 + 20 | 0;
  i74 = i116 + 24 | 0;
  i75 = i116 + 28 | 0;
  i76 = i116 + 32 | 0;
  i77 = i130 + 16 | 0;
  i78 = i131 + 4 | 0;
  i79 = i130 + 20 | 0;
  i80 = i131 + 8 | 0;
  i81 = i130 + 24 | 0;
  i82 = i131 + 12 | 0;
  i83 = i130 + 28 | 0;
  i84 = i116 + 36 | 0;
  i85 = i116 + 40 | 0;
  i86 = i116 + 44 | 0;
  i87 = i3 + 1884 | 0;
  i88 = i119 + 120 | 0;
  i89 = i119 + 140 | 0;
  i90 = i119 + 160 | 0;
  i91 = i116 + 16 | 0;
  f20 = Math_fround(f2 * Math_fround(.5));
  i21 = i3 + 1092 | 0;
  i22 = i118 + 12 | 0;
  i23 = i118 + 8 | 0;
  i24 = i118 + 4 | 0;
  i25 = i3 + 1176 | 0;
  i26 = i117 + 4 | 0;
  i27 = i117 + 8 | 0;
  i28 = i117 + 12 | 0;
  i29 = i123 + 56 | 0;
  i30 = i118 + 12 | 0;
  i31 = i118 + 8 | 0;
  i32 = i118 + 4 | 0;
  i33 = i117 + 4 | 0;
  i34 = i117 + 8 | 0;
  i35 = i117 + 12 | 0;
  i36 = i123 + 112 | 0;
  i37 = i118 + 12 | 0;
  i38 = i118 + 8 | 0;
  i39 = i118 + 4 | 0;
  i40 = i117 + 4 | 0;
  i41 = i117 + 8 | 0;
  i42 = i117 + 12 | 0;
  i43 = i3 + 1172 | 0;
  i44 = i3 + 1324 | 0;
  i45 = i3 + 1236 | 0;
  i46 = i3 + 88 | 0;
  i47 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  while (1) {
   i134 = (HEAP32[i93 >> 2] | 0) + (i4 << 2) | 0;
   f7 = Math_fround(HEAPF32[i134 >> 2]);
   f6 = Math_fround(HEAPF32[i134 + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i134 + 8 >> 2]);
   f6 = Math_fround(f6 * Math_fround(.00999999977));
   f5 = Math_fround(f5 * Math_fround(.00999999977));
   f2 = Math_fround(Math_fround(HEAPF32[i134 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i124 >> 2] = Math_fround(f7 * Math_fround(.00999999977));
   HEAPF32[i94 >> 2] = f6;
   HEAPF32[i95 >> 2] = f5;
   HEAPF32[i96 >> 2] = f2;
   i134 = (HEAP32[i97 >> 2] | 0) + (i4 << 2) | 0;
   i140 = (HEAP32[i134 >> 2] | 0) + 1054653076 | 0;
   i138 = (HEAP32[i134 + 4 >> 2] | 0) + 1054653076 | 0;
   i136 = (HEAP32[i134 + 8 >> 2] | 0) + 1054653076 | 0;
   i134 = (HEAP32[i134 + 12 >> 2] | 0) + 1054653076 | 0;
   i139 = (Math_imul(i140, 1790253981) | 0) + 1900727103 | 0;
   i137 = (Math_imul(i138, 1790253981) | 0) + 1900727103 | 0;
   i135 = (Math_imul(i136, 1790253981) | 0) + 1900727103 | 0;
   i1 = (Math_imul(i134, 1790253981) | 0) + 1900727103 | 0;
   i140 = i140 << 11 ^ i140;
   i138 = i138 << 11 ^ i138;
   i136 = i136 << 11 ^ i136;
   i134 = i134 << 11 ^ i134;
   f2 = Math_fround(Math_fround((i139 ^ i140 ^ i140 >>> 8) & 8388607 ^ i139 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround((i137 ^ i138 ^ i138 >>> 8) & 8388607 ^ i137 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f6 = Math_fround(Math_fround((i135 ^ i136 ^ i136 >>> 8) & 8388607 ^ i135 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround((i1 ^ i134 ^ i134 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i129 >> 2] = f2;
   HEAPF32[i98 >> 2] = f5;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f7;
   i1 = HEAP32[i102 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i140 = HEAP32[i46 >> 2] | 0;
     HEAP32[i105 >> 2] = i140;
     HEAP32[i104 >> 2] = i140;
     HEAP32[i103 >> 2] = i140;
     HEAP32[i130 >> 2] = i140;
     break;
    }
   case 3:
    {
     f15 = Math_fround(HEAPF32[(HEAP32[i47 >> 2] | 0) + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i46 >> 2]);
     f15 = Math_fround(f15 * f16);
     f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f15);
     f17 = Math_fround(f15 + Math_fround(f16 * f5));
     f18 = Math_fround(f15 + Math_fround(f16 * f6));
     f19 = Math_fround(f15 + Math_fround(f16 * f7));
     HEAPF32[i130 >> 2] = Math_fround(f15 + Math_fround(f2 * f16));
     HEAPF32[i103 >> 2] = f17;
     HEAPF32[i104 >> 2] = f18;
     HEAPF32[i105 >> 2] = f19;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i130, i101, i121, i124, i129);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i130, i101, i124, i129);
     break L8;
    }
   } while (0);
   f16 = Math_fround(HEAPF32[i130 >> 2]);
   f17 = Math_fround(HEAPF32[i103 >> 2]);
   f18 = Math_fround(HEAPF32[i104 >> 2]);
   f16 = Math_fround(f128 * f16);
   f17 = Math_fround(f128 * f17);
   f18 = Math_fround(f128 * f18);
   f19 = Math_fround(f128 * Math_fround(HEAPF32[i105 >> 2]));
   i140 = (HEAP32[i119 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i140 >> 2]);
   f15 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i106 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i140 >> 2]);
   f7 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i107 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i140 >> 2]);
   f8 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f13 = Math_fround(f125 + f13);
   f15 = Math_fround(f125 + f15);
   f14 = Math_fround(f125 + f14);
   f12 = Math_fround(f125 + f12);
   f5 = Math_fround(f126 + f5);
   f7 = Math_fround(f126 + f7);
   f9 = Math_fround(f126 + f9);
   f11 = Math_fround(f126 + f11);
   f10 = Math_fround(f127 + f10);
   f8 = Math_fround(f127 + f8);
   f6 = Math_fround(f127 + f6);
   f2 = Math_fround(f127 + Math_fround(HEAPF32[i140 + 12 >> 2]));
   HEAPF32[i129 >> 2] = f10;
   HEAPF32[i108 >> 2] = f8;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f2;
   HEAPF32[i111 >> 2] = f5;
   HEAPF32[i112 >> 2] = f7;
   HEAPF32[i48 >> 2] = f9;
   HEAPF32[i49 >> 2] = f11;
   f141 = Math_fround(f122 + f15);
   f142 = Math_fround(f122 + f14);
   f143 = Math_fround(f122 + f12);
   HEAPF32[i50 >> 2] = Math_fround(f122 + f13);
   HEAPF32[i51 >> 2] = f141;
   HEAPF32[i52 >> 2] = f142;
   HEAPF32[i53 >> 2] = f143;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i130, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f13 = Math_fround(f13 + Math_fround(100.0));
   f15 = Math_fround(f15 + Math_fround(100.0));
   f14 = Math_fround(f14 + Math_fround(100.0));
   f12 = Math_fround(f12 + Math_fround(100.0));
   HEAPF32[i129 >> 2] = f13;
   HEAPF32[i108 >> 2] = f15;
   HEAPF32[i109 >> 2] = f14;
   HEAPF32[i110 >> 2] = f12;
   HEAPF32[i111 >> 2] = f10;
   HEAPF32[i112 >> 2] = f8;
   HEAPF32[i48 >> 2] = f6;
   HEAPF32[i49 >> 2] = f2;
   f143 = Math_fround(f122 + f7);
   f142 = Math_fround(f122 + f9);
   f141 = Math_fround(f122 + f11);
   HEAPF32[i50 >> 2] = Math_fround(f122 + f5);
   HEAPF32[i51 >> 2] = f143;
   HEAPF32[i52 >> 2] = f142;
   HEAPF32[i53 >> 2] = f141;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i131, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   HEAPF32[i129 >> 2] = f5;
   HEAPF32[i108 >> 2] = f7;
   HEAPF32[i109 >> 2] = f9;
   HEAPF32[i110 >> 2] = f11;
   HEAPF32[i111 >> 2] = f13;
   HEAPF32[i112 >> 2] = f15;
   HEAPF32[i48 >> 2] = f14;
   HEAPF32[i49 >> 2] = f12;
   f8 = Math_fround(f122 + f8);
   f6 = Math_fround(f122 + f6);
   f2 = Math_fround(f122 + f2);
   HEAPF32[i50 >> 2] = Math_fround(f122 + f10);
   HEAPF32[i51 >> 2] = f8;
   HEAPF32[i52 >> 2] = f6;
   HEAPF32[i53 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i132, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f2 = Math_fround(HEAPF32[i132 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
   f6 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i57 >> 2]));
   f8 = Math_fround(HEAPF32[i58 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i59 >> 2]));
   f10 = Math_fround(HEAPF32[i60 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i61 >> 2]));
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f6;
   HEAPF32[i63 >> 2] = f8;
   HEAPF32[i64 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i130 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i66 >> 2]));
   f14 = Math_fround(HEAPF32[i67 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i68 >> 2]));
   f15 = Math_fround(HEAPF32[i69 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i70 >> 2]));
   f13 = Math_fround(HEAPF32[i71 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i72 >> 2]));
   HEAPF32[i65 >> 2] = f12;
   HEAPF32[i73 >> 2] = f14;
   HEAPF32[i74 >> 2] = f15;
   HEAPF32[i75 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i131 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i77 >> 2]));
   f9 = Math_fround(HEAPF32[i78 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i79 >> 2]));
   f7 = Math_fround(HEAPF32[i80 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i81 >> 2]));
   f5 = Math_fround(HEAPF32[i82 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i83 >> 2]));
   HEAPF32[i76 >> 2] = f11;
   HEAPF32[i84 >> 2] = f9;
   HEAPF32[i85 >> 2] = f7;
   HEAPF32[i86 >> 2] = f5;
   if (HEAP8[i87 >> 0] | 0) {
    f146 = Math_fround(Math_fround(Math_fround(f20 * f2) * Math_fround(.5)) + Math_fround(.5));
    f145 = Math_fround(Math_fround(Math_fround(f20 * f6) * Math_fround(.5)) + Math_fround(.5));
    f144 = Math_fround(Math_fround(Math_fround(f20 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f20 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f20 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f20 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f20 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f20 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f20 * f11) * Math_fround(.5)) + Math_fround(.5));
    f141 = Math_fround(Math_fround(Math_fround(f20 * f9) * Math_fround(.5)) + Math_fround(.5));
    f142 = Math_fround(Math_fround(Math_fround(f20 * f7) * Math_fround(.5)) + Math_fround(.5));
    f143 = Math_fround(Math_fround(Math_fround(f20 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f146 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f146;
    i1 = f145 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f145;
    i1 = f144 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f144;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f141 < Math_fround(0.0);
    f141 = i1 ? Math_fround(0.0) : f141;
    i1 = f142 < Math_fround(0.0);
    f142 = i1 ? Math_fround(0.0) : f142;
    i1 = f143 < Math_fround(0.0);
    f143 = i1 ? Math_fround(0.0) : f143;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f141 > Math_fround(1.0);
    f141 = i1 ? Math_fround(1.0) : f141;
    i1 = f142 > Math_fround(1.0);
    f142 = i1 ? Math_fround(1.0) : f142;
    i1 = f143 > Math_fround(1.0);
    f143 = i1 ? Math_fround(1.0) : f143;
    HEAPF32[i116 >> 2] = f7;
    HEAPF32[i62 >> 2] = f8;
    HEAPF32[i63 >> 2] = f9;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f11;
    HEAPF32[i73 >> 2] = f12;
    HEAPF32[i74 >> 2] = f13;
    HEAPF32[i75 >> 2] = f14;
    HEAPF32[i76 >> 2] = f15;
    HEAPF32[i84 >> 2] = f141;
    HEAPF32[i85 >> 2] = f142;
    HEAPF32[i86 >> 2] = f143;
    HEAPF32[i22 >> 2] = Math_fround(1.0);
    HEAPF32[i23 >> 2] = Math_fround(1.0);
    HEAPF32[i24 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L18 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i28 >> 2] = i140;
      HEAP32[i27 >> 2] = i140;
      HEAP32[i26 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i26 >> 2] = f146;
      HEAPF32[i27 >> 2] = f146;
      HEAPF32[i28 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i123, i116, i118);
      break L18;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i116, i118);
      break L18;
     }
    } while (0);
    i139 = HEAP32[i26 >> 2] | 0;
    i140 = HEAP32[i27 >> 2] | 0;
    i1 = HEAP32[i28 >> 2] | 0;
    HEAP32[i116 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i62 >> 2] = i139;
    HEAP32[i63 >> 2] = i140;
    HEAP32[i64 >> 2] = i1;
    HEAPF32[i30 >> 2] = Math_fround(1.0);
    HEAPF32[i31 >> 2] = Math_fround(1.0);
    HEAPF32[i32 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L26 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i35 >> 2] = i140;
      HEAP32[i34 >> 2] = i140;
      HEAP32[i33 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i33 >> 2] = f146;
      HEAPF32[i34 >> 2] = f146;
      HEAPF32[i35 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i29, i65, i118);
      break L26;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i65, i118);
      break L26;
     }
    } while (0);
    i139 = HEAP32[i33 >> 2] | 0;
    i140 = HEAP32[i34 >> 2] | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    HEAP32[i65 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i73 >> 2] = i139;
    HEAP32[i74 >> 2] = i140;
    HEAP32[i75 >> 2] = i1;
    HEAPF32[i37 >> 2] = Math_fround(1.0);
    HEAPF32[i38 >> 2] = Math_fround(1.0);
    HEAPF32[i39 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i42 >> 2] = i140;
      HEAP32[i41 >> 2] = i140;
      HEAP32[i40 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i40 >> 2] = f146;
      HEAPF32[i41 >> 2] = f146;
      HEAPF32[i42 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i36, i76, i118);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i76, i118);
      break L34;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i117 >> 2]);
    f9 = Math_fround(HEAPF32[i40 >> 2]);
    f7 = Math_fround(HEAPF32[i41 >> 2]);
    f5 = Math_fround(HEAPF32[i42 >> 2]);
    f146 = Math_fround(Math_fround(HEAPF32[i113 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i116 >> 2]) * f146);
    f6 = Math_fround(f146 * Math_fround(HEAPF32[i62 >> 2]));
    f8 = Math_fround(f146 * Math_fround(HEAPF32[i63 >> 2]));
    f10 = Math_fround(f146 * Math_fround(HEAPF32[i64 >> 2]));
    f12 = Math_fround(f146 * Math_fround(HEAPF32[i91 >> 2]));
    f14 = Math_fround(f146 * Math_fround(HEAPF32[i73 >> 2]));
    f15 = Math_fround(f146 * Math_fround(HEAPF32[i74 >> 2]));
    f13 = Math_fround(f146 * Math_fround(HEAPF32[i75 >> 2]));
    f11 = Math_fround(f146 * f11);
    f9 = Math_fround(f146 * f9);
    f7 = Math_fround(f146 * f7);
    f5 = Math_fround(f146 * f5);
    HEAPF32[i116 >> 2] = f2;
    HEAPF32[i62 >> 2] = f6;
    HEAPF32[i63 >> 2] = f8;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f12;
    HEAPF32[i73 >> 2] = f14;
    HEAPF32[i74 >> 2] = f15;
    HEAPF32[i75 >> 2] = f13;
    HEAPF32[i76 >> 2] = f11;
    HEAPF32[i84 >> 2] = f9;
    HEAPF32[i85 >> 2] = f7;
    HEAPF32[i86 >> 2] = f5;
   }
   f2 = Math_fround(f16 * f2);
   f153 = Math_fround(f17 * f6);
   f152 = Math_fround(f18 * f8);
   f151 = Math_fround(f19 * f10);
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f153;
   HEAPF32[i63 >> 2] = f152;
   HEAPF32[i64 >> 2] = f151;
   f6 = Math_fround(f16 * f12);
   f8 = Math_fround(f17 * f14);
   f141 = Math_fround(f18 * f15);
   f142 = Math_fround(f19 * f13);
   HEAPF32[i65 >> 2] = f6;
   HEAPF32[i73 >> 2] = f8;
   HEAPF32[i74 >> 2] = f141;
   HEAPF32[i75 >> 2] = f142;
   f143 = Math_fround(f16 * f11);
   f144 = Math_fround(f17 * f9);
   f145 = Math_fround(f18 * f7);
   f146 = Math_fround(f19 * f5);
   HEAPF32[i76 >> 2] = f143;
   HEAPF32[i84 >> 2] = f144;
   HEAPF32[i85 >> 2] = f145;
   HEAPF32[i86 >> 2] = f146;
   i150 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f14 = Math_fround(HEAPF32[i150 >> 2]);
   i149 = i150 + 4 | 0;
   f15 = Math_fround(HEAPF32[i149 >> 2]);
   i148 = i150 + 8 | 0;
   f16 = Math_fround(HEAPF32[i148 >> 2]);
   i147 = i150 + 12 | 0;
   f17 = Math_fround(HEAPF32[i147 >> 2]);
   i1 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   i134 = i1 + 4 | 0;
   f19 = Math_fround(HEAPF32[i134 >> 2]);
   i135 = i1 + 8 | 0;
   f9 = Math_fround(HEAPF32[i135 >> 2]);
   i136 = i1 + 12 | 0;
   f10 = Math_fround(HEAPF32[i136 >> 2]);
   i137 = (HEAP32[i90 >> 2] | 0) + (i4 << 2) | 0;
   f11 = Math_fround(HEAPF32[i137 >> 2]);
   i138 = i137 + 4 | 0;
   f12 = Math_fround(HEAPF32[i138 >> 2]);
   i139 = i137 + 8 | 0;
   f13 = Math_fround(HEAPF32[i139 >> 2]);
   i140 = i137 + 12 | 0;
   f15 = Math_fround(f15 + f153);
   f16 = Math_fround(f16 + f152);
   f17 = Math_fround(f17 + f151);
   f18 = Math_fround(f18 + f6);
   f19 = Math_fround(f19 + f8);
   f141 = Math_fround(f9 + f141);
   f142 = Math_fround(f10 + f142);
   f143 = Math_fround(f11 + f143);
   f144 = Math_fround(f12 + f144);
   f145 = Math_fround(f13 + f145);
   f146 = Math_fround(Math_fround(HEAPF32[i140 >> 2]) + f146);
   HEAPF32[i150 >> 2] = Math_fround(f14 + f2);
   HEAPF32[i149 >> 2] = f15;
   HEAPF32[i148 >> 2] = f16;
   HEAPF32[i147 >> 2] = f17;
   HEAPF32[i1 >> 2] = f18;
   HEAPF32[i134 >> 2] = f19;
   HEAPF32[i135 >> 2] = f141;
   HEAPF32[i136 >> 2] = f142;
   HEAPF32[i137 >> 2] = f143;
   HEAPF32[i138 >> 2] = f144;
   HEAPF32[i139 >> 2] = f145;
   HEAPF32[i140 >> 2] = f146;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i92 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i114) {
  STACKTOP = i133;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i114);
 STACKTOP = i133;
 return;
}

function __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb0EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, f122 = f0, i123 = 0, i124 = 0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, f151 = f0, f152 = f0, f153 = f0;
 i133 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i113 = i133 + 584 | 0;
 i115 = i133 + 580 | 0;
 i120 = i133 + 576 | 0;
 i121 = i133 + 408 | 0;
 i123 = i133 + 240 | 0;
 i124 = i133 + 224 | 0;
 i129 = i133 + 176 | 0;
 i130 = i133 + 144 | 0;
 i131 = i133 + 112 | 0;
 i132 = i133 + 80 | 0;
 i116 = i133 + 32 | 0;
 i117 = i133 + 16 | 0;
 i118 = i133;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i115 >> 2] = 0;
  HEAP32[i113 >> 2] = HEAP32[i115 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i113);
  i114 = gb + 1451836 | 0;
 } else i114 = 0;
 i119 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i113 >> 2] = f2;
 HEAP32[i115 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i120 >> 2] = HEAP32[i3 + 812 >> 2];
 f125 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f126 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f127 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f122 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i121 + 4 >> 2] = Math_fround(inf);
 HEAP32[i121 >> 2] = 0;
 i92 = i121 + 8 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 32 >> 2] = Math_fround(inf);
 HEAP32[i121 + 28 >> 2] = 0;
 i92 = i121 + 36 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 60 >> 2] = Math_fround(inf);
 HEAP32[i121 + 56 >> 2] = 0;
 i92 = i121 + 64 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 88 >> 2] = Math_fround(inf);
 HEAP32[i121 + 84 >> 2] = 0;
 i92 = i121 + 92 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 116 >> 2] = Math_fround(inf);
 HEAP32[i121 + 112 >> 2] = 0;
 i92 = i121 + 120 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 144 >> 2] = Math_fround(inf);
 HEAP32[i121 + 140 >> 2] = 0;
 i92 = i121 + 148 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f125 = Math_fround(f125 * Math_fround(100.0));
 f126 = Math_fround(f126 * Math_fround(100.0));
 f127 = Math_fround(f127 * Math_fround(100.0));
 f128 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i123 + 4 >> 2] = Math_fround(inf);
 HEAP32[i123 >> 2] = 0;
 i4 = i123 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 32 >> 2] = Math_fround(inf);
 HEAP32[i123 + 28 >> 2] = 0;
 i4 = i123 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 60 >> 2] = Math_fround(inf);
 HEAP32[i123 + 56 >> 2] = 0;
 i4 = i123 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 88 >> 2] = Math_fround(inf);
 HEAP32[i123 + 84 >> 2] = 0;
 i4 = i123 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 116 >> 2] = Math_fround(inf);
 HEAP32[i123 + 112 >> 2] = 0;
 i4 = i123 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 144 >> 2] = Math_fround(inf);
 HEAP32[i123 + 140 >> 2] = 0;
 i4 = i123 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i92 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i92 >> 2] | 0) >>> 0) {
  i93 = i119 + 520 | 0;
  i94 = i124 + 4 | 0;
  i95 = i124 + 8 | 0;
  i96 = i124 + 12 | 0;
  i97 = i119 + 500 | 0;
  i98 = i129 + 4 | 0;
  i99 = i129 + 8 | 0;
  i100 = i129 + 12 | 0;
  i101 = i3 + 8 | 0;
  i102 = i3 + 92 | 0;
  i103 = i130 + 4 | 0;
  i104 = i130 + 8 | 0;
  i105 = i130 + 12 | 0;
  i106 = i119 + 20 | 0;
  i107 = i119 + 40 | 0;
  i108 = i129 + 4 | 0;
  i109 = i129 + 8 | 0;
  i110 = i129 + 12 | 0;
  i111 = i129 + 16 | 0;
  i112 = i129 + 20 | 0;
  i48 = i129 + 24 | 0;
  i49 = i129 + 28 | 0;
  i50 = i129 + 32 | 0;
  i51 = i129 + 36 | 0;
  i52 = i129 + 40 | 0;
  i53 = i129 + 44 | 0;
  i54 = i3 + 808 | 0;
  i55 = i131 + 16 | 0;
  i56 = i132 + 4 | 0;
  i57 = i131 + 20 | 0;
  i58 = i132 + 8 | 0;
  i59 = i131 + 24 | 0;
  i60 = i132 + 12 | 0;
  i61 = i131 + 28 | 0;
  i62 = i116 + 4 | 0;
  i63 = i116 + 8 | 0;
  i64 = i116 + 12 | 0;
  i65 = i116 + 16 | 0;
  i66 = i132 + 16 | 0;
  i67 = i130 + 4 | 0;
  i68 = i132 + 20 | 0;
  i69 = i130 + 8 | 0;
  i70 = i132 + 24 | 0;
  i71 = i130 + 12 | 0;
  i72 = i132 + 28 | 0;
  i73 = i116 + 20 | 0;
  i74 = i116 + 24 | 0;
  i75 = i116 + 28 | 0;
  i76 = i116 + 32 | 0;
  i77 = i130 + 16 | 0;
  i78 = i131 + 4 | 0;
  i79 = i130 + 20 | 0;
  i80 = i131 + 8 | 0;
  i81 = i130 + 24 | 0;
  i82 = i131 + 12 | 0;
  i83 = i130 + 28 | 0;
  i84 = i116 + 36 | 0;
  i85 = i116 + 40 | 0;
  i86 = i116 + 44 | 0;
  i87 = i3 + 1884 | 0;
  i88 = i119 + 120 | 0;
  i89 = i119 + 140 | 0;
  i90 = i119 + 160 | 0;
  i91 = i116 + 16 | 0;
  f20 = Math_fround(f2 * Math_fround(.5));
  i21 = i3 + 1092 | 0;
  i22 = i118 + 12 | 0;
  i23 = i118 + 8 | 0;
  i24 = i118 + 4 | 0;
  i25 = i3 + 1176 | 0;
  i26 = i117 + 4 | 0;
  i27 = i117 + 8 | 0;
  i28 = i117 + 12 | 0;
  i29 = i123 + 56 | 0;
  i30 = i118 + 12 | 0;
  i31 = i118 + 8 | 0;
  i32 = i118 + 4 | 0;
  i33 = i117 + 4 | 0;
  i34 = i117 + 8 | 0;
  i35 = i117 + 12 | 0;
  i36 = i123 + 112 | 0;
  i37 = i118 + 12 | 0;
  i38 = i118 + 8 | 0;
  i39 = i118 + 4 | 0;
  i40 = i117 + 4 | 0;
  i41 = i117 + 8 | 0;
  i42 = i117 + 12 | 0;
  i43 = i3 + 1172 | 0;
  i44 = i3 + 1324 | 0;
  i45 = i3 + 1236 | 0;
  i46 = i3 + 88 | 0;
  i47 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  while (1) {
   i134 = (HEAP32[i93 >> 2] | 0) + (i4 << 2) | 0;
   f7 = Math_fround(HEAPF32[i134 >> 2]);
   f6 = Math_fround(HEAPF32[i134 + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i134 + 8 >> 2]);
   f6 = Math_fround(f6 * Math_fround(.00999999977));
   f5 = Math_fround(f5 * Math_fround(.00999999977));
   f2 = Math_fround(Math_fround(HEAPF32[i134 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i124 >> 2] = Math_fround(f7 * Math_fround(.00999999977));
   HEAPF32[i94 >> 2] = f6;
   HEAPF32[i95 >> 2] = f5;
   HEAPF32[i96 >> 2] = f2;
   i134 = (HEAP32[i97 >> 2] | 0) + (i4 << 2) | 0;
   i140 = (HEAP32[i134 >> 2] | 0) + 1054653076 | 0;
   i138 = (HEAP32[i134 + 4 >> 2] | 0) + 1054653076 | 0;
   i136 = (HEAP32[i134 + 8 >> 2] | 0) + 1054653076 | 0;
   i134 = (HEAP32[i134 + 12 >> 2] | 0) + 1054653076 | 0;
   i139 = (Math_imul(i140, 1790253981) | 0) + 1900727103 | 0;
   i137 = (Math_imul(i138, 1790253981) | 0) + 1900727103 | 0;
   i135 = (Math_imul(i136, 1790253981) | 0) + 1900727103 | 0;
   i1 = (Math_imul(i134, 1790253981) | 0) + 1900727103 | 0;
   i140 = i140 << 11 ^ i140;
   i138 = i138 << 11 ^ i138;
   i136 = i136 << 11 ^ i136;
   i134 = i134 << 11 ^ i134;
   f2 = Math_fround(Math_fround((i139 ^ i140 ^ i140 >>> 8) & 8388607 ^ i139 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround((i137 ^ i138 ^ i138 >>> 8) & 8388607 ^ i137 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f6 = Math_fround(Math_fround((i135 ^ i136 ^ i136 >>> 8) & 8388607 ^ i135 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround((i1 ^ i134 ^ i134 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i129 >> 2] = f2;
   HEAPF32[i98 >> 2] = f5;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f7;
   i1 = HEAP32[i102 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i140 = HEAP32[i46 >> 2] | 0;
     HEAP32[i105 >> 2] = i140;
     HEAP32[i104 >> 2] = i140;
     HEAP32[i103 >> 2] = i140;
     HEAP32[i130 >> 2] = i140;
     break;
    }
   case 3:
    {
     f15 = Math_fround(HEAPF32[(HEAP32[i47 >> 2] | 0) + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i46 >> 2]);
     f15 = Math_fround(f15 * f16);
     f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f15);
     f17 = Math_fround(f15 + Math_fround(f16 * f5));
     f18 = Math_fround(f15 + Math_fround(f16 * f6));
     f19 = Math_fround(f15 + Math_fround(f16 * f7));
     HEAPF32[i130 >> 2] = Math_fround(f15 + Math_fround(f2 * f16));
     HEAPF32[i103 >> 2] = f17;
     HEAPF32[i104 >> 2] = f18;
     HEAPF32[i105 >> 2] = f19;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i130, i101, i121, i124, i129);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i130, i101, i124, i129);
     break L8;
    }
   } while (0);
   f16 = Math_fround(HEAPF32[i130 >> 2]);
   f17 = Math_fround(HEAPF32[i103 >> 2]);
   f18 = Math_fround(HEAPF32[i104 >> 2]);
   f16 = Math_fround(f128 * f16);
   f17 = Math_fround(f128 * f17);
   f18 = Math_fround(f128 * f18);
   f19 = Math_fround(f128 * Math_fround(HEAPF32[i105 >> 2]));
   i140 = (HEAP32[i119 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i140 >> 2]);
   f8 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i106 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i140 >> 2]);
   f7 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i107 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i140 >> 2]);
   f15 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f10 = Math_fround(f125 + f10);
   f8 = Math_fround(f125 + f8);
   f6 = Math_fround(f125 + f6);
   f2 = Math_fround(f125 + f2);
   f5 = Math_fround(f126 + f5);
   f7 = Math_fround(f126 + f7);
   f9 = Math_fround(f126 + f9);
   f11 = Math_fround(f126 + f11);
   f13 = Math_fround(f127 + f13);
   f15 = Math_fround(f127 + f15);
   f14 = Math_fround(f127 + f14);
   f12 = Math_fround(f127 + Math_fround(HEAPF32[i140 + 12 >> 2]));
   HEAPF32[i129 >> 2] = f13;
   HEAPF32[i108 >> 2] = f15;
   HEAPF32[i109 >> 2] = f14;
   HEAPF32[i110 >> 2] = f12;
   HEAPF32[i50 >> 2] = f10;
   HEAPF32[i51 >> 2] = f8;
   HEAPF32[i52 >> 2] = f6;
   HEAPF32[i53 >> 2] = f2;
   f141 = Math_fround(f122 + f7);
   f142 = Math_fround(f122 + f9);
   f143 = Math_fround(f122 + f11);
   HEAPF32[i111 >> 2] = Math_fround(f122 + f5);
   HEAPF32[i112 >> 2] = f141;
   HEAPF32[i48 >> 2] = f142;
   HEAPF32[i49 >> 2] = f143;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i130, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f10 = Math_fround(f10 + Math_fround(100.0));
   f8 = Math_fround(f8 + Math_fround(100.0));
   f6 = Math_fround(f6 + Math_fround(100.0));
   f2 = Math_fround(f2 + Math_fround(100.0));
   HEAPF32[i129 >> 2] = f10;
   HEAPF32[i108 >> 2] = f8;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f2;
   HEAPF32[i50 >> 2] = f5;
   HEAPF32[i51 >> 2] = f7;
   HEAPF32[i52 >> 2] = f9;
   HEAPF32[i53 >> 2] = f11;
   f143 = Math_fround(f122 + f15);
   f142 = Math_fround(f122 + f14);
   f141 = Math_fround(f122 + f12);
   HEAPF32[i111 >> 2] = Math_fround(f122 + f13);
   HEAPF32[i112 >> 2] = f143;
   HEAPF32[i48 >> 2] = f142;
   HEAPF32[i49 >> 2] = f141;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i131, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   HEAPF32[i129 >> 2] = f5;
   HEAPF32[i108 >> 2] = f7;
   HEAPF32[i109 >> 2] = f9;
   HEAPF32[i110 >> 2] = f11;
   HEAPF32[i50 >> 2] = f13;
   HEAPF32[i51 >> 2] = f15;
   HEAPF32[i52 >> 2] = f14;
   HEAPF32[i53 >> 2] = f12;
   f8 = Math_fround(f122 + f8);
   f6 = Math_fround(f122 + f6);
   f2 = Math_fround(f122 + f2);
   HEAPF32[i111 >> 2] = Math_fround(f122 + f10);
   HEAPF32[i112 >> 2] = f8;
   HEAPF32[i48 >> 2] = f6;
   HEAPF32[i49 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i132, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f2 = Math_fround(HEAPF32[i132 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
   f6 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i57 >> 2]));
   f8 = Math_fround(HEAPF32[i58 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i59 >> 2]));
   f10 = Math_fround(HEAPF32[i60 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i61 >> 2]));
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f6;
   HEAPF32[i63 >> 2] = f8;
   HEAPF32[i64 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i130 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i66 >> 2]));
   f14 = Math_fround(HEAPF32[i67 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i68 >> 2]));
   f15 = Math_fround(HEAPF32[i69 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i70 >> 2]));
   f13 = Math_fround(HEAPF32[i71 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i72 >> 2]));
   HEAPF32[i65 >> 2] = f12;
   HEAPF32[i73 >> 2] = f14;
   HEAPF32[i74 >> 2] = f15;
   HEAPF32[i75 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i131 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i77 >> 2]));
   f9 = Math_fround(HEAPF32[i78 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i79 >> 2]));
   f7 = Math_fround(HEAPF32[i80 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i81 >> 2]));
   f5 = Math_fround(HEAPF32[i82 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i83 >> 2]));
   HEAPF32[i76 >> 2] = f11;
   HEAPF32[i84 >> 2] = f9;
   HEAPF32[i85 >> 2] = f7;
   HEAPF32[i86 >> 2] = f5;
   if (HEAP8[i87 >> 0] | 0) {
    f146 = Math_fround(Math_fround(Math_fround(f20 * f2) * Math_fround(.5)) + Math_fround(.5));
    f145 = Math_fround(Math_fround(Math_fround(f20 * f6) * Math_fround(.5)) + Math_fround(.5));
    f144 = Math_fround(Math_fround(Math_fround(f20 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f20 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f20 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f20 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f20 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f20 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f20 * f11) * Math_fround(.5)) + Math_fround(.5));
    f141 = Math_fround(Math_fround(Math_fround(f20 * f9) * Math_fround(.5)) + Math_fround(.5));
    f142 = Math_fround(Math_fround(Math_fround(f20 * f7) * Math_fround(.5)) + Math_fround(.5));
    f143 = Math_fround(Math_fround(Math_fround(f20 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f146 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f146;
    i1 = f145 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f145;
    i1 = f144 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f144;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f141 < Math_fround(0.0);
    f141 = i1 ? Math_fround(0.0) : f141;
    i1 = f142 < Math_fround(0.0);
    f142 = i1 ? Math_fround(0.0) : f142;
    i1 = f143 < Math_fround(0.0);
    f143 = i1 ? Math_fround(0.0) : f143;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f141 > Math_fround(1.0);
    f141 = i1 ? Math_fround(1.0) : f141;
    i1 = f142 > Math_fround(1.0);
    f142 = i1 ? Math_fround(1.0) : f142;
    i1 = f143 > Math_fround(1.0);
    f143 = i1 ? Math_fround(1.0) : f143;
    HEAPF32[i116 >> 2] = f7;
    HEAPF32[i62 >> 2] = f8;
    HEAPF32[i63 >> 2] = f9;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f11;
    HEAPF32[i73 >> 2] = f12;
    HEAPF32[i74 >> 2] = f13;
    HEAPF32[i75 >> 2] = f14;
    HEAPF32[i76 >> 2] = f15;
    HEAPF32[i84 >> 2] = f141;
    HEAPF32[i85 >> 2] = f142;
    HEAPF32[i86 >> 2] = f143;
    HEAPF32[i22 >> 2] = Math_fround(1.0);
    HEAPF32[i23 >> 2] = Math_fround(1.0);
    HEAPF32[i24 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L18 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i28 >> 2] = i140;
      HEAP32[i27 >> 2] = i140;
      HEAP32[i26 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i26 >> 2] = f146;
      HEAPF32[i27 >> 2] = f146;
      HEAPF32[i28 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i123, i116, i118);
      break L18;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i116, i118);
      break L18;
     }
    } while (0);
    i139 = HEAP32[i26 >> 2] | 0;
    i140 = HEAP32[i27 >> 2] | 0;
    i1 = HEAP32[i28 >> 2] | 0;
    HEAP32[i116 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i62 >> 2] = i139;
    HEAP32[i63 >> 2] = i140;
    HEAP32[i64 >> 2] = i1;
    HEAPF32[i30 >> 2] = Math_fround(1.0);
    HEAPF32[i31 >> 2] = Math_fround(1.0);
    HEAPF32[i32 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L26 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i35 >> 2] = i140;
      HEAP32[i34 >> 2] = i140;
      HEAP32[i33 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i33 >> 2] = f146;
      HEAPF32[i34 >> 2] = f146;
      HEAPF32[i35 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i29, i65, i118);
      break L26;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i65, i118);
      break L26;
     }
    } while (0);
    i139 = HEAP32[i33 >> 2] | 0;
    i140 = HEAP32[i34 >> 2] | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    HEAP32[i65 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i73 >> 2] = i139;
    HEAP32[i74 >> 2] = i140;
    HEAP32[i75 >> 2] = i1;
    HEAPF32[i37 >> 2] = Math_fround(1.0);
    HEAPF32[i38 >> 2] = Math_fround(1.0);
    HEAPF32[i39 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i42 >> 2] = i140;
      HEAP32[i41 >> 2] = i140;
      HEAP32[i40 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i40 >> 2] = f146;
      HEAPF32[i41 >> 2] = f146;
      HEAPF32[i42 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i36, i76, i118);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i76, i118);
      break L34;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i117 >> 2]);
    f9 = Math_fround(HEAPF32[i40 >> 2]);
    f7 = Math_fround(HEAPF32[i41 >> 2]);
    f5 = Math_fround(HEAPF32[i42 >> 2]);
    f146 = Math_fround(Math_fround(HEAPF32[i113 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i116 >> 2]) * f146);
    f6 = Math_fround(f146 * Math_fround(HEAPF32[i62 >> 2]));
    f8 = Math_fround(f146 * Math_fround(HEAPF32[i63 >> 2]));
    f10 = Math_fround(f146 * Math_fround(HEAPF32[i64 >> 2]));
    f12 = Math_fround(f146 * Math_fround(HEAPF32[i91 >> 2]));
    f14 = Math_fround(f146 * Math_fround(HEAPF32[i73 >> 2]));
    f15 = Math_fround(f146 * Math_fround(HEAPF32[i74 >> 2]));
    f13 = Math_fround(f146 * Math_fround(HEAPF32[i75 >> 2]));
    f11 = Math_fround(f146 * f11);
    f9 = Math_fround(f146 * f9);
    f7 = Math_fround(f146 * f7);
    f5 = Math_fround(f146 * f5);
    HEAPF32[i116 >> 2] = f2;
    HEAPF32[i62 >> 2] = f6;
    HEAPF32[i63 >> 2] = f8;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f12;
    HEAPF32[i73 >> 2] = f14;
    HEAPF32[i74 >> 2] = f15;
    HEAPF32[i75 >> 2] = f13;
    HEAPF32[i76 >> 2] = f11;
    HEAPF32[i84 >> 2] = f9;
    HEAPF32[i85 >> 2] = f7;
    HEAPF32[i86 >> 2] = f5;
   }
   f2 = Math_fround(f16 * f2);
   f153 = Math_fround(f17 * f6);
   f152 = Math_fround(f18 * f8);
   f151 = Math_fround(f19 * f10);
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f153;
   HEAPF32[i63 >> 2] = f152;
   HEAPF32[i64 >> 2] = f151;
   f6 = Math_fround(f16 * f12);
   f8 = Math_fround(f17 * f14);
   f141 = Math_fround(f18 * f15);
   f142 = Math_fround(f19 * f13);
   HEAPF32[i65 >> 2] = f6;
   HEAPF32[i73 >> 2] = f8;
   HEAPF32[i74 >> 2] = f141;
   HEAPF32[i75 >> 2] = f142;
   f143 = Math_fround(f16 * f11);
   f144 = Math_fround(f17 * f9);
   f145 = Math_fround(f18 * f7);
   f146 = Math_fround(f19 * f5);
   HEAPF32[i76 >> 2] = f143;
   HEAPF32[i84 >> 2] = f144;
   HEAPF32[i85 >> 2] = f145;
   HEAPF32[i86 >> 2] = f146;
   i150 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f14 = Math_fround(HEAPF32[i150 >> 2]);
   i149 = i150 + 4 | 0;
   f15 = Math_fround(HEAPF32[i149 >> 2]);
   i148 = i150 + 8 | 0;
   f16 = Math_fround(HEAPF32[i148 >> 2]);
   i147 = i150 + 12 | 0;
   f17 = Math_fround(HEAPF32[i147 >> 2]);
   i1 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   i134 = i1 + 4 | 0;
   f19 = Math_fround(HEAPF32[i134 >> 2]);
   i135 = i1 + 8 | 0;
   f9 = Math_fround(HEAPF32[i135 >> 2]);
   i136 = i1 + 12 | 0;
   f10 = Math_fround(HEAPF32[i136 >> 2]);
   i137 = (HEAP32[i90 >> 2] | 0) + (i4 << 2) | 0;
   f11 = Math_fround(HEAPF32[i137 >> 2]);
   i138 = i137 + 4 | 0;
   f12 = Math_fround(HEAPF32[i138 >> 2]);
   i139 = i137 + 8 | 0;
   f13 = Math_fround(HEAPF32[i139 >> 2]);
   i140 = i137 + 12 | 0;
   f15 = Math_fround(f15 + f153);
   f16 = Math_fround(f16 + f152);
   f17 = Math_fround(f17 + f151);
   f18 = Math_fround(f18 + f6);
   f19 = Math_fround(f19 + f8);
   f141 = Math_fround(f9 + f141);
   f142 = Math_fround(f10 + f142);
   f143 = Math_fround(f11 + f143);
   f144 = Math_fround(f12 + f144);
   f145 = Math_fround(f13 + f145);
   f146 = Math_fround(Math_fround(HEAPF32[i140 >> 2]) + f146);
   HEAPF32[i150 >> 2] = Math_fround(f14 + f2);
   HEAPF32[i149 >> 2] = f15;
   HEAPF32[i148 >> 2] = f16;
   HEAPF32[i147 >> 2] = f17;
   HEAPF32[i1 >> 2] = f18;
   HEAPF32[i134 >> 2] = f19;
   HEAPF32[i135 >> 2] = f141;
   HEAPF32[i136 >> 2] = f142;
   HEAPF32[i137 >> 2] = f143;
   HEAPF32[i138 >> 2] = f144;
   HEAPF32[i139 >> 2] = f145;
   HEAPF32[i140 >> 2] = f146;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i92 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i114) {
  STACKTOP = i133;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i114);
 STACKTOP = i133;
 return;
}

function __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb0EEEvP12NoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, f122 = f0, i123 = 0, i124 = 0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, f151 = f0, f152 = f0, f153 = f0;
 i133 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i113 = i133 + 584 | 0;
 i115 = i133 + 580 | 0;
 i120 = i133 + 576 | 0;
 i121 = i133 + 408 | 0;
 i123 = i133 + 240 | 0;
 i124 = i133 + 224 | 0;
 i129 = i133 + 176 | 0;
 i130 = i133 + 144 | 0;
 i131 = i133 + 112 | 0;
 i132 = i133 + 80 | 0;
 i116 = i133 + 32 | 0;
 i117 = i133 + 16 | 0;
 i118 = i133;
 if ((HEAP16[gb + 1451836 + 6 >> 1] | 0) > -1) {
  HEAP32[i115 >> 2] = 0;
  HEAP32[i113 >> 2] = HEAP32[i115 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451836 | 0, i113);
  i114 = gb + 1451836 | 0;
 } else i114 = 0;
 i119 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(_fmaxf(Math_fround(HEAPF32[i3 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i113 >> 2] = f2;
 HEAP32[i115 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i120 >> 2] = HEAP32[i3 + 812 >> 2];
 f125 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f126 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f127 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f122 = Math_fround(HEAPF32[i3 + 1088 >> 2]);
 i4 = (HEAP8[i3 + 805 >> 0] | 0) != 0;
 HEAPF32[i121 + 4 >> 2] = Math_fround(inf);
 HEAP32[i121 >> 2] = 0;
 i92 = i121 + 8 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 32 >> 2] = Math_fround(inf);
 HEAP32[i121 + 28 >> 2] = 0;
 i92 = i121 + 36 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 60 >> 2] = Math_fround(inf);
 HEAP32[i121 + 56 >> 2] = 0;
 i92 = i121 + 64 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 88 >> 2] = Math_fround(inf);
 HEAP32[i121 + 84 >> 2] = 0;
 i92 = i121 + 92 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 116 >> 2] = Math_fround(inf);
 HEAP32[i121 + 112 >> 2] = 0;
 i92 = i121 + 120 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 HEAPF32[i121 + 144 >> 2] = Math_fround(inf);
 HEAP32[i121 + 140 >> 2] = 0;
 i92 = i121 + 148 | 0;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 HEAP32[i92 + 16 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / f2);
 f125 = Math_fround(f125 * Math_fround(100.0));
 f126 = Math_fround(f126 * Math_fround(100.0));
 f127 = Math_fround(f127 * Math_fround(100.0));
 f128 = i4 ? f2 : Math_fround(1.0);
 HEAPF32[i123 + 4 >> 2] = Math_fround(inf);
 HEAP32[i123 >> 2] = 0;
 i4 = i123 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 32 >> 2] = Math_fround(inf);
 HEAP32[i123 + 28 >> 2] = 0;
 i4 = i123 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 60 >> 2] = Math_fround(inf);
 HEAP32[i123 + 56 >> 2] = 0;
 i4 = i123 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 88 >> 2] = Math_fround(inf);
 HEAP32[i123 + 84 >> 2] = 0;
 i4 = i123 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 116 >> 2] = Math_fround(inf);
 HEAP32[i123 + 112 >> 2] = 0;
 i4 = i123 + 120 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i123 + 144 >> 2] = Math_fround(inf);
 HEAP32[i123 + 140 >> 2] = 0;
 i4 = i123 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i92 = i1 + 12 | 0;
 L4 : do if (i4 >>> 0 < (HEAP32[i92 >> 2] | 0) >>> 0) {
  i93 = i119 + 520 | 0;
  i94 = i124 + 4 | 0;
  i95 = i124 + 8 | 0;
  i96 = i124 + 12 | 0;
  i97 = i119 + 500 | 0;
  i98 = i129 + 4 | 0;
  i99 = i129 + 8 | 0;
  i100 = i129 + 12 | 0;
  i101 = i3 + 8 | 0;
  i102 = i3 + 92 | 0;
  i103 = i130 + 4 | 0;
  i104 = i130 + 8 | 0;
  i105 = i130 + 12 | 0;
  i106 = i119 + 20 | 0;
  i107 = i119 + 40 | 0;
  i108 = i129 + 4 | 0;
  i109 = i129 + 8 | 0;
  i110 = i129 + 12 | 0;
  i111 = i129 + 16 | 0;
  i112 = i129 + 20 | 0;
  i48 = i129 + 24 | 0;
  i49 = i129 + 28 | 0;
  i50 = i129 + 32 | 0;
  i51 = i129 + 36 | 0;
  i52 = i129 + 40 | 0;
  i53 = i129 + 44 | 0;
  i54 = i3 + 808 | 0;
  i55 = i131 + 16 | 0;
  i56 = i132 + 4 | 0;
  i57 = i131 + 20 | 0;
  i58 = i132 + 8 | 0;
  i59 = i131 + 24 | 0;
  i60 = i132 + 12 | 0;
  i61 = i131 + 28 | 0;
  i62 = i116 + 4 | 0;
  i63 = i116 + 8 | 0;
  i64 = i116 + 12 | 0;
  i65 = i116 + 16 | 0;
  i66 = i132 + 16 | 0;
  i67 = i130 + 4 | 0;
  i68 = i132 + 20 | 0;
  i69 = i130 + 8 | 0;
  i70 = i132 + 24 | 0;
  i71 = i130 + 12 | 0;
  i72 = i132 + 28 | 0;
  i73 = i116 + 20 | 0;
  i74 = i116 + 24 | 0;
  i75 = i116 + 28 | 0;
  i76 = i116 + 32 | 0;
  i77 = i130 + 16 | 0;
  i78 = i131 + 4 | 0;
  i79 = i130 + 20 | 0;
  i80 = i131 + 8 | 0;
  i81 = i130 + 24 | 0;
  i82 = i131 + 12 | 0;
  i83 = i130 + 28 | 0;
  i84 = i116 + 36 | 0;
  i85 = i116 + 40 | 0;
  i86 = i116 + 44 | 0;
  i87 = i3 + 1884 | 0;
  i88 = i119 + 120 | 0;
  i89 = i119 + 140 | 0;
  i90 = i119 + 160 | 0;
  i91 = i116 + 16 | 0;
  f20 = Math_fround(f2 * Math_fround(.5));
  i21 = i3 + 1092 | 0;
  i22 = i118 + 12 | 0;
  i23 = i118 + 8 | 0;
  i24 = i118 + 4 | 0;
  i25 = i3 + 1176 | 0;
  i26 = i117 + 4 | 0;
  i27 = i117 + 8 | 0;
  i28 = i117 + 12 | 0;
  i29 = i123 + 56 | 0;
  i30 = i118 + 12 | 0;
  i31 = i118 + 8 | 0;
  i32 = i118 + 4 | 0;
  i33 = i117 + 4 | 0;
  i34 = i117 + 8 | 0;
  i35 = i117 + 12 | 0;
  i36 = i123 + 112 | 0;
  i37 = i118 + 12 | 0;
  i38 = i118 + 8 | 0;
  i39 = i118 + 4 | 0;
  i40 = i117 + 4 | 0;
  i41 = i117 + 8 | 0;
  i42 = i117 + 12 | 0;
  i43 = i3 + 1172 | 0;
  i44 = i3 + 1324 | 0;
  i45 = i3 + 1236 | 0;
  i46 = i3 + 88 | 0;
  i47 = i3 + 240 | 0;
  i3 = i3 + 152 | 0;
  while (1) {
   i134 = (HEAP32[i93 >> 2] | 0) + (i4 << 2) | 0;
   f7 = Math_fround(HEAPF32[i134 >> 2]);
   f6 = Math_fround(HEAPF32[i134 + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i134 + 8 >> 2]);
   f6 = Math_fround(f6 * Math_fround(.00999999977));
   f5 = Math_fround(f5 * Math_fround(.00999999977));
   f2 = Math_fround(Math_fround(HEAPF32[i134 + 12 >> 2]) * Math_fround(.00999999977));
   HEAPF32[i124 >> 2] = Math_fround(f7 * Math_fround(.00999999977));
   HEAPF32[i94 >> 2] = f6;
   HEAPF32[i95 >> 2] = f5;
   HEAPF32[i96 >> 2] = f2;
   i134 = (HEAP32[i97 >> 2] | 0) + (i4 << 2) | 0;
   i140 = (HEAP32[i134 >> 2] | 0) + 1054653076 | 0;
   i138 = (HEAP32[i134 + 4 >> 2] | 0) + 1054653076 | 0;
   i136 = (HEAP32[i134 + 8 >> 2] | 0) + 1054653076 | 0;
   i134 = (HEAP32[i134 + 12 >> 2] | 0) + 1054653076 | 0;
   i139 = (Math_imul(i140, 1790253981) | 0) + 1900727103 | 0;
   i137 = (Math_imul(i138, 1790253981) | 0) + 1900727103 | 0;
   i135 = (Math_imul(i136, 1790253981) | 0) + 1900727103 | 0;
   i1 = (Math_imul(i134, 1790253981) | 0) + 1900727103 | 0;
   i140 = i140 << 11 ^ i140;
   i138 = i138 << 11 ^ i138;
   i136 = i136 << 11 ^ i136;
   i134 = i134 << 11 ^ i134;
   f2 = Math_fround(Math_fround((i139 ^ i140 ^ i140 >>> 8) & 8388607 ^ i139 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f5 = Math_fround(Math_fround((i137 ^ i138 ^ i138 >>> 8) & 8388607 ^ i137 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f6 = Math_fround(Math_fround((i135 ^ i136 ^ i136 >>> 8) & 8388607 ^ i135 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f7 = Math_fround(Math_fround((i1 ^ i134 ^ i134 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i129 >> 2] = f2;
   HEAPF32[i98 >> 2] = f5;
   HEAPF32[i99 >> 2] = f6;
   HEAPF32[i100 >> 2] = f7;
   i1 = HEAP32[i102 >> 2] | 0;
   L8 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i140 = HEAP32[i46 >> 2] | 0;
     HEAP32[i105 >> 2] = i140;
     HEAP32[i104 >> 2] = i140;
     HEAP32[i103 >> 2] = i140;
     HEAP32[i130 >> 2] = i140;
     break;
    }
   case 3:
    {
     f15 = Math_fround(HEAPF32[(HEAP32[i47 >> 2] | 0) + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i46 >> 2]);
     f15 = Math_fround(f15 * f16);
     f16 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f15);
     f17 = Math_fround(f15 + Math_fround(f16 * f5));
     f18 = Math_fround(f15 + Math_fround(f16 * f6));
     f19 = Math_fround(f15 + Math_fround(f16 * f7));
     HEAPF32[i130 >> 2] = Math_fround(f15 + Math_fround(f2 * f16));
     HEAPF32[i103 >> 2] = f17;
     HEAPF32[i104 >> 2] = f18;
     HEAPF32[i105 >> 2] = f19;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i130, i101, i121, i124, i129);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i130, i101, i124, i129);
     break L8;
    }
   } while (0);
   f16 = Math_fround(HEAPF32[i130 >> 2]);
   f17 = Math_fround(HEAPF32[i103 >> 2]);
   f18 = Math_fround(HEAPF32[i104 >> 2]);
   f16 = Math_fround(f128 * f16);
   f17 = Math_fround(f128 * f17);
   f18 = Math_fround(f128 * f18);
   f19 = Math_fround(f128 * Math_fround(HEAPF32[i105 >> 2]));
   i140 = (HEAP32[i119 >> 2] | 0) + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i140 >> 2]);
   f7 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i106 >> 2] | 0) + (i4 << 2) | 0;
   f10 = Math_fround(HEAPF32[i140 >> 2]);
   f8 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i140 + 12 >> 2]);
   i140 = (HEAP32[i107 >> 2] | 0) + (i4 << 2) | 0;
   f13 = Math_fround(HEAPF32[i140 >> 2]);
   f15 = Math_fround(HEAPF32[i140 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i140 + 8 >> 2]);
   f5 = Math_fround(f125 + f5);
   f7 = Math_fround(f125 + f7);
   f9 = Math_fround(f125 + f9);
   f11 = Math_fround(f125 + f11);
   f10 = Math_fround(f126 + f10);
   f8 = Math_fround(f126 + f8);
   f6 = Math_fround(f126 + f6);
   f2 = Math_fround(f126 + f2);
   f13 = Math_fround(f127 + f13);
   f15 = Math_fround(f127 + f15);
   f14 = Math_fround(f127 + f14);
   f12 = Math_fround(f127 + Math_fround(HEAPF32[i140 + 12 >> 2]));
   HEAPF32[i111 >> 2] = f10;
   HEAPF32[i112 >> 2] = f8;
   HEAPF32[i48 >> 2] = f6;
   HEAPF32[i49 >> 2] = f2;
   HEAPF32[i50 >> 2] = f5;
   HEAPF32[i51 >> 2] = f7;
   HEAPF32[i52 >> 2] = f9;
   HEAPF32[i53 >> 2] = f11;
   f141 = Math_fround(f122 + f15);
   f142 = Math_fround(f122 + f14);
   f143 = Math_fround(f122 + f12);
   HEAPF32[i129 >> 2] = Math_fround(f122 + f13);
   HEAPF32[i108 >> 2] = f141;
   HEAPF32[i109 >> 2] = f142;
   HEAPF32[i110 >> 2] = f143;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i130, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f5 = Math_fround(f5 + Math_fround(100.0));
   f7 = Math_fround(f7 + Math_fround(100.0));
   f9 = Math_fround(f9 + Math_fround(100.0));
   f11 = Math_fround(f11 + Math_fround(100.0));
   HEAPF32[i111 >> 2] = f13;
   HEAPF32[i112 >> 2] = f15;
   HEAPF32[i48 >> 2] = f14;
   HEAPF32[i49 >> 2] = f12;
   HEAPF32[i50 >> 2] = f10;
   HEAPF32[i51 >> 2] = f8;
   HEAPF32[i52 >> 2] = f6;
   HEAPF32[i53 >> 2] = f2;
   f143 = Math_fround(f122 + f7);
   f142 = Math_fround(f122 + f9);
   f141 = Math_fround(f122 + f11);
   HEAPF32[i129 >> 2] = Math_fround(f122 + f5);
   HEAPF32[i108 >> 2] = f143;
   HEAPF32[i109 >> 2] = f142;
   HEAPF32[i110 >> 2] = f141;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i131, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   HEAPF32[i111 >> 2] = f5;
   HEAPF32[i112 >> 2] = f7;
   HEAPF32[i48 >> 2] = f9;
   HEAPF32[i49 >> 2] = f11;
   HEAPF32[i50 >> 2] = f13;
   HEAPF32[i51 >> 2] = f15;
   HEAPF32[i52 >> 2] = f14;
   HEAPF32[i53 >> 2] = f12;
   f8 = Math_fround(f122 + f8);
   f6 = Math_fround(f122 + f6);
   f2 = Math_fround(f122 + f2);
   HEAPF32[i129 >> 2] = Math_fround(f122 + f10);
   HEAPF32[i108 >> 2] = f8;
   HEAPF32[i109 >> 2] = f6;
   HEAPF32[i110 >> 2] = f2;
   __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i132, i129, i113, HEAP32[i54 >> 2] | 0, i115, i120);
   f2 = Math_fround(HEAPF32[i132 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i55 >> 2]));
   f6 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i57 >> 2]));
   f8 = Math_fround(HEAPF32[i58 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i59 >> 2]));
   f10 = Math_fround(HEAPF32[i60 >> 2]);
   f10 = Math_fround(f10 - Math_fround(HEAPF32[i61 >> 2]));
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f6;
   HEAPF32[i63 >> 2] = f8;
   HEAPF32[i64 >> 2] = f10;
   f12 = Math_fround(HEAPF32[i130 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i66 >> 2]));
   f14 = Math_fround(HEAPF32[i67 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i68 >> 2]));
   f15 = Math_fround(HEAPF32[i69 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i70 >> 2]));
   f13 = Math_fround(HEAPF32[i71 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i72 >> 2]));
   HEAPF32[i65 >> 2] = f12;
   HEAPF32[i73 >> 2] = f14;
   HEAPF32[i74 >> 2] = f15;
   HEAPF32[i75 >> 2] = f13;
   f11 = Math_fround(HEAPF32[i131 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i77 >> 2]));
   f9 = Math_fround(HEAPF32[i78 >> 2]);
   f9 = Math_fround(f9 - Math_fround(HEAPF32[i79 >> 2]));
   f7 = Math_fround(HEAPF32[i80 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i81 >> 2]));
   f5 = Math_fround(HEAPF32[i82 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i83 >> 2]));
   HEAPF32[i76 >> 2] = f11;
   HEAPF32[i84 >> 2] = f9;
   HEAPF32[i85 >> 2] = f7;
   HEAPF32[i86 >> 2] = f5;
   if (HEAP8[i87 >> 0] | 0) {
    f146 = Math_fround(Math_fround(Math_fround(f20 * f2) * Math_fround(.5)) + Math_fround(.5));
    f145 = Math_fround(Math_fround(Math_fround(f20 * f6) * Math_fround(.5)) + Math_fround(.5));
    f144 = Math_fround(Math_fround(Math_fround(f20 * f8) * Math_fround(.5)) + Math_fround(.5));
    f10 = Math_fround(Math_fround(Math_fround(f20 * f10) * Math_fround(.5)) + Math_fround(.5));
    f2 = Math_fround(Math_fround(Math_fround(f20 * f12) * Math_fround(.5)) + Math_fround(.5));
    f12 = Math_fround(Math_fround(Math_fround(f20 * f14) * Math_fround(.5)) + Math_fround(.5));
    f6 = Math_fround(Math_fround(Math_fround(f20 * f15) * Math_fround(.5)) + Math_fround(.5));
    f14 = Math_fround(Math_fround(Math_fround(f20 * f13) * Math_fround(.5)) + Math_fround(.5));
    f15 = Math_fround(Math_fround(Math_fround(f20 * f11) * Math_fround(.5)) + Math_fround(.5));
    f141 = Math_fround(Math_fround(Math_fround(f20 * f9) * Math_fround(.5)) + Math_fround(.5));
    f142 = Math_fround(Math_fround(Math_fround(f20 * f7) * Math_fround(.5)) + Math_fround(.5));
    f143 = Math_fround(Math_fround(Math_fround(f20 * f5) * Math_fround(.5)) + Math_fround(.5));
    i1 = f146 < Math_fround(0.0);
    f7 = i1 ? Math_fround(0.0) : f146;
    i1 = f145 < Math_fround(0.0);
    f8 = i1 ? Math_fround(0.0) : f145;
    i1 = f144 < Math_fround(0.0);
    f9 = i1 ? Math_fround(0.0) : f144;
    i1 = f10 < Math_fround(0.0);
    f10 = i1 ? Math_fround(0.0) : f10;
    i1 = f7 > Math_fround(1.0);
    f7 = i1 ? Math_fround(1.0) : f7;
    i1 = f8 > Math_fround(1.0);
    f8 = i1 ? Math_fround(1.0) : f8;
    i1 = f9 > Math_fround(1.0);
    f9 = i1 ? Math_fround(1.0) : f9;
    i1 = f10 > Math_fround(1.0);
    f10 = i1 ? Math_fround(1.0) : f10;
    i1 = f2 < Math_fround(0.0);
    f11 = i1 ? Math_fround(0.0) : f2;
    i1 = f12 < Math_fround(0.0);
    f12 = i1 ? Math_fround(0.0) : f12;
    i1 = f6 < Math_fround(0.0);
    f13 = i1 ? Math_fround(0.0) : f6;
    i1 = f14 < Math_fround(0.0);
    f14 = i1 ? Math_fround(0.0) : f14;
    i1 = f11 > Math_fround(1.0);
    f11 = i1 ? Math_fround(1.0) : f11;
    i1 = f12 > Math_fround(1.0);
    f12 = i1 ? Math_fround(1.0) : f12;
    i1 = f13 > Math_fround(1.0);
    f13 = i1 ? Math_fround(1.0) : f13;
    i1 = f14 > Math_fround(1.0);
    f14 = i1 ? Math_fround(1.0) : f14;
    i1 = f15 < Math_fround(0.0);
    f15 = i1 ? Math_fround(0.0) : f15;
    i1 = f141 < Math_fround(0.0);
    f141 = i1 ? Math_fround(0.0) : f141;
    i1 = f142 < Math_fround(0.0);
    f142 = i1 ? Math_fround(0.0) : f142;
    i1 = f143 < Math_fround(0.0);
    f143 = i1 ? Math_fround(0.0) : f143;
    i1 = f15 > Math_fround(1.0);
    f15 = i1 ? Math_fround(1.0) : f15;
    i1 = f141 > Math_fround(1.0);
    f141 = i1 ? Math_fround(1.0) : f141;
    i1 = f142 > Math_fround(1.0);
    f142 = i1 ? Math_fround(1.0) : f142;
    i1 = f143 > Math_fround(1.0);
    f143 = i1 ? Math_fround(1.0) : f143;
    HEAPF32[i116 >> 2] = f7;
    HEAPF32[i62 >> 2] = f8;
    HEAPF32[i63 >> 2] = f9;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f11;
    HEAPF32[i73 >> 2] = f12;
    HEAPF32[i74 >> 2] = f13;
    HEAPF32[i75 >> 2] = f14;
    HEAPF32[i76 >> 2] = f15;
    HEAPF32[i84 >> 2] = f141;
    HEAPF32[i85 >> 2] = f142;
    HEAPF32[i86 >> 2] = f143;
    HEAPF32[i22 >> 2] = Math_fround(1.0);
    HEAPF32[i23 >> 2] = Math_fround(1.0);
    HEAPF32[i24 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L18 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i28 >> 2] = i140;
      HEAP32[i27 >> 2] = i140;
      HEAP32[i26 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i26 >> 2] = f146;
      HEAPF32[i27 >> 2] = f146;
      HEAPF32[i28 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i123, i116, i118);
      break L18;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i116, i118);
      break L18;
     }
    } while (0);
    i139 = HEAP32[i26 >> 2] | 0;
    i140 = HEAP32[i27 >> 2] | 0;
    i1 = HEAP32[i28 >> 2] | 0;
    HEAP32[i116 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i62 >> 2] = i139;
    HEAP32[i63 >> 2] = i140;
    HEAP32[i64 >> 2] = i1;
    HEAPF32[i30 >> 2] = Math_fround(1.0);
    HEAPF32[i31 >> 2] = Math_fround(1.0);
    HEAPF32[i32 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L26 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i35 >> 2] = i140;
      HEAP32[i34 >> 2] = i140;
      HEAP32[i33 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i33 >> 2] = f146;
      HEAPF32[i34 >> 2] = f146;
      HEAPF32[i35 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i29, i65, i118);
      break L26;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i65, i118);
      break L26;
     }
    } while (0);
    i139 = HEAP32[i33 >> 2] | 0;
    i140 = HEAP32[i34 >> 2] | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    HEAP32[i65 >> 2] = HEAP32[i117 >> 2];
    HEAP32[i73 >> 2] = i139;
    HEAP32[i74 >> 2] = i140;
    HEAP32[i75 >> 2] = i1;
    HEAPF32[i37 >> 2] = Math_fround(1.0);
    HEAPF32[i38 >> 2] = Math_fround(1.0);
    HEAPF32[i39 >> 2] = Math_fround(1.0);
    HEAPF32[i118 >> 2] = Math_fround(1.0);
    i1 = HEAP32[i25 >> 2] | 0;
    L34 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i140 = HEAP32[i43 >> 2] | 0;
      HEAP32[i42 >> 2] = i140;
      HEAP32[i41 >> 2] = i140;
      HEAP32[i40 >> 2] = i140;
      HEAP32[i117 >> 2] = i140;
      break;
     }
    case 3:
     {
      f146 = Math_fround(HEAPF32[(HEAP32[i44 >> 2] | 0) + 4 >> 2]);
      f145 = Math_fround(HEAPF32[i43 >> 2]);
      f146 = Math_fround(f146 * f145);
      f146 = Math_fround(f146 + Math_fround(Math_fround(f145 * Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2])) - f146));
      HEAPF32[i117 >> 2] = f146;
      HEAPF32[i40 >> 2] = f146;
      HEAPF32[i41 >> 2] = f146;
      HEAPF32[i42 >> 2] = f146;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i117, i21, i36, i76, i118);
      break L34;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i117, i21, i76, i118);
      break L34;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i117 >> 2]);
    f9 = Math_fround(HEAPF32[i40 >> 2]);
    f7 = Math_fround(HEAPF32[i41 >> 2]);
    f5 = Math_fround(HEAPF32[i42 >> 2]);
    f146 = Math_fround(Math_fround(HEAPF32[i113 >> 2]) * Math_fround(2.0));
    f2 = Math_fround(Math_fround(HEAPF32[i116 >> 2]) * f146);
    f6 = Math_fround(f146 * Math_fround(HEAPF32[i62 >> 2]));
    f8 = Math_fround(f146 * Math_fround(HEAPF32[i63 >> 2]));
    f10 = Math_fround(f146 * Math_fround(HEAPF32[i64 >> 2]));
    f12 = Math_fround(f146 * Math_fround(HEAPF32[i91 >> 2]));
    f14 = Math_fround(f146 * Math_fround(HEAPF32[i73 >> 2]));
    f15 = Math_fround(f146 * Math_fround(HEAPF32[i74 >> 2]));
    f13 = Math_fround(f146 * Math_fround(HEAPF32[i75 >> 2]));
    f11 = Math_fround(f146 * f11);
    f9 = Math_fround(f146 * f9);
    f7 = Math_fround(f146 * f7);
    f5 = Math_fround(f146 * f5);
    HEAPF32[i116 >> 2] = f2;
    HEAPF32[i62 >> 2] = f6;
    HEAPF32[i63 >> 2] = f8;
    HEAPF32[i64 >> 2] = f10;
    HEAPF32[i65 >> 2] = f12;
    HEAPF32[i73 >> 2] = f14;
    HEAPF32[i74 >> 2] = f15;
    HEAPF32[i75 >> 2] = f13;
    HEAPF32[i76 >> 2] = f11;
    HEAPF32[i84 >> 2] = f9;
    HEAPF32[i85 >> 2] = f7;
    HEAPF32[i86 >> 2] = f5;
   }
   f2 = Math_fround(f16 * f2);
   f153 = Math_fround(f17 * f6);
   f152 = Math_fround(f18 * f8);
   f151 = Math_fround(f19 * f10);
   HEAPF32[i116 >> 2] = f2;
   HEAPF32[i62 >> 2] = f153;
   HEAPF32[i63 >> 2] = f152;
   HEAPF32[i64 >> 2] = f151;
   f6 = Math_fround(f16 * f12);
   f8 = Math_fround(f17 * f14);
   f141 = Math_fround(f18 * f15);
   f142 = Math_fround(f19 * f13);
   HEAPF32[i65 >> 2] = f6;
   HEAPF32[i73 >> 2] = f8;
   HEAPF32[i74 >> 2] = f141;
   HEAPF32[i75 >> 2] = f142;
   f143 = Math_fround(f16 * f11);
   f144 = Math_fround(f17 * f9);
   f145 = Math_fround(f18 * f7);
   f146 = Math_fround(f19 * f5);
   HEAPF32[i76 >> 2] = f143;
   HEAPF32[i84 >> 2] = f144;
   HEAPF32[i85 >> 2] = f145;
   HEAPF32[i86 >> 2] = f146;
   i150 = (HEAP32[i88 >> 2] | 0) + (i4 << 2) | 0;
   f14 = Math_fround(HEAPF32[i150 >> 2]);
   i149 = i150 + 4 | 0;
   f15 = Math_fround(HEAPF32[i149 >> 2]);
   i148 = i150 + 8 | 0;
   f16 = Math_fround(HEAPF32[i148 >> 2]);
   i147 = i150 + 12 | 0;
   f17 = Math_fround(HEAPF32[i147 >> 2]);
   i1 = (HEAP32[i89 >> 2] | 0) + (i4 << 2) | 0;
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   i134 = i1 + 4 | 0;
   f19 = Math_fround(HEAPF32[i134 >> 2]);
   i135 = i1 + 8 | 0;
   f9 = Math_fround(HEAPF32[i135 >> 2]);
   i136 = i1 + 12 | 0;
   f10 = Math_fround(HEAPF32[i136 >> 2]);
   i137 = (HEAP32[i90 >> 2] | 0) + (i4 << 2) | 0;
   f11 = Math_fround(HEAPF32[i137 >> 2]);
   i138 = i137 + 4 | 0;
   f12 = Math_fround(HEAPF32[i138 >> 2]);
   i139 = i137 + 8 | 0;
   f13 = Math_fround(HEAPF32[i139 >> 2]);
   i140 = i137 + 12 | 0;
   f15 = Math_fround(f15 + f153);
   f16 = Math_fround(f16 + f152);
   f17 = Math_fround(f17 + f151);
   f18 = Math_fround(f18 + f6);
   f19 = Math_fround(f19 + f8);
   f141 = Math_fround(f9 + f141);
   f142 = Math_fround(f10 + f142);
   f143 = Math_fround(f11 + f143);
   f144 = Math_fround(f12 + f144);
   f145 = Math_fround(f13 + f145);
   f146 = Math_fround(Math_fround(HEAPF32[i140 >> 2]) + f146);
   HEAPF32[i150 >> 2] = Math_fround(f14 + f2);
   HEAPF32[i149 >> 2] = f15;
   HEAPF32[i148 >> 2] = f16;
   HEAPF32[i147 >> 2] = f17;
   HEAPF32[i1 >> 2] = f18;
   HEAPF32[i134 >> 2] = f19;
   HEAPF32[i135 >> 2] = f141;
   HEAPF32[i136 >> 2] = f142;
   HEAPF32[i137 >> 2] = f143;
   HEAPF32[i138 >> 2] = f144;
   HEAPF32[i139 >> 2] = f145;
   HEAPF32[i140 >> 2] = f146;
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= (HEAP32[i92 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i114) {
  STACKTOP = i133;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i114);
 STACKTOP = i133;
 return;
}

function _read_markers(i96) {
 i96 = i96 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i97 = 0, i98 = 0, i99 = 0;
 i99 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i99 + 256 | 0;
 i25 = i99;
 i97 = i96 + 380 | 0;
 i98 = i96 + 404 | 0;
 i91 = i96 + 24 | 0;
 i66 = i96 + 202 | 0;
 i77 = i96 + 218 | 0;
 i88 = i96 + 234 | 0;
 i90 = i96 + 203 | 0;
 i15 = i96 + 219 | 0;
 i16 = i96 + 235 | 0;
 i17 = i96 + 204 | 0;
 i18 = i96 + 220 | 0;
 i19 = i96 + 236 | 0;
 i20 = i96 + 205 | 0;
 i21 = i96 + 221 | 0;
 i22 = i96 + 237 | 0;
 i23 = i96 + 206 | 0;
 i24 = i96 + 222 | 0;
 i26 = i96 + 238 | 0;
 i27 = i96 + 207 | 0;
 i28 = i96 + 223 | 0;
 i29 = i96 + 239 | 0;
 i30 = i96 + 208 | 0;
 i31 = i96 + 224 | 0;
 i32 = i96 + 240 | 0;
 i33 = i96 + 209 | 0;
 i34 = i96 + 225 | 0;
 i35 = i96 + 241 | 0;
 i36 = i96 + 210 | 0;
 i37 = i96 + 226 | 0;
 i38 = i96 + 242 | 0;
 i39 = i96 + 211 | 0;
 i40 = i96 + 227 | 0;
 i41 = i96 + 243 | 0;
 i42 = i96 + 212 | 0;
 i43 = i96 + 228 | 0;
 i44 = i96 + 244 | 0;
 i45 = i96 + 213 | 0;
 i46 = i96 + 229 | 0;
 i47 = i96 + 245 | 0;
 i48 = i96 + 214 | 0;
 i49 = i96 + 230 | 0;
 i50 = i96 + 246 | 0;
 i51 = i96 + 215 | 0;
 i52 = i96 + 231 | 0;
 i53 = i96 + 247 | 0;
 i54 = i96 + 216 | 0;
 i55 = i96 + 232 | 0;
 i56 = i96 + 248 | 0;
 i57 = i96 + 217 | 0;
 i58 = i96 + 233 | 0;
 i59 = i96 + 249 | 0;
 i60 = i96 + 252 | 0;
 i61 = i96 + 40 | 0;
 i62 = i96 + 266 | 0;
 i63 = i96 + 256 | 0;
 i64 = i96 + 257 | 0;
 i65 = i96 + 258 | 0;
 i67 = i96 + 259 | 0;
 i68 = i96 + 260 | 0;
 i69 = i96 + 262 | 0;
 i70 = i96 + 264 | 0;
 i71 = i96 + 265 | 0;
 i72 = i14 + 1 | 0;
 i73 = i14 + 2 | 0;
 i74 = i14 + 3 | 0;
 i75 = i14 + 4 | 0;
 i76 = i14 + 5 | 0;
 i78 = i14 + 6 | 0;
 i79 = i14 + 7 | 0;
 i80 = i14 + 8 | 0;
 i81 = i14 + 9 | 0;
 i82 = i14 + 10 | 0;
 i83 = i14 + 11 | 0;
 i84 = i14 + 12 | 0;
 i85 = i14 + 13 | 0;
 i86 = i14 + 14 | 0;
 i87 = i14 + 15 | 0;
 i89 = i14 + 16 | 0;
 i3 = HEAP32[i97 >> 2] | 0;
 L1 : while (1) {
  do if (!i3) {
   if (HEAP8[(HEAP32[i98 >> 2] | 0) + 12 >> 0] | 0) {
    if (!((_next_marker(i96) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    i3 = HEAP32[i97 >> 2] | 0;
    break;
   }
   i8 = HEAP32[i91 >> 2] | 0;
   i9 = i8 + 4 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if (!i3) {
    if (!((mftCall_ii(HEAP32[i8 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    i3 = HEAP32[i9 >> 2] | 0;
   }
   i6 = HEAP32[i8 >> 2] | 0;
   i3 = i3 + -1 | 0;
   i4 = i6 + 1 | 0;
   i6 = HEAP8[i6 >> 0] | 0;
   i7 = i6 & 255;
   if (!i3) {
    if (!((mftCall_ii(HEAP32[i8 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    i5 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i8 >> 2] | 0;
   } else i5 = i3;
   i13 = HEAP8[i4 >> 0] | 0;
   i3 = i13 & 255;
   if (i6 << 24 >> 24 != -1 | i13 << 24 >> 24 != -40) {
    i13 = HEAP32[i96 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 53;
    HEAP32[i13 + 24 >> 2] = i7;
    HEAP32[i13 + 28 >> 2] = i3;
    mftCall_vi(HEAP32[i13 >> 2] | 0, i96 | 0);
   }
   HEAP32[i97 >> 2] = i3;
   HEAP32[i8 >> 2] = i4 + 1;
   HEAP32[i9 >> 2] = i5 + -1;
  } while (0);
  do switch (i3 | 0) {
  case 218:
   {
    i15 = 24;
    break L1;
   }
  case 217:
   {
    i15 = 65;
    break L1;
   }
  case 216:
   {
    i3 = HEAP32[i96 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 102;
    mftCall_vii(HEAP32[i3 + 4 >> 2] | 0, i96 | 0, 1);
    i3 = HEAP32[i98 >> 2] | 0;
    if (HEAP8[i3 + 12 >> 0] | 0) {
     i3 = HEAP32[i96 >> 2] | 0;
     HEAP32[i3 + 20 >> 2] = 61;
     mftCall_vi(HEAP32[i3 >> 2] | 0, i96 | 0);
     i3 = HEAP32[i98 >> 2] | 0;
    }
    HEAP8[i66 >> 0] = 0;
    HEAP8[i77 >> 0] = 1;
    HEAP8[i88 >> 0] = 5;
    HEAP8[i90 >> 0] = 0;
    HEAP8[i15 >> 0] = 1;
    HEAP8[i16 >> 0] = 5;
    HEAP8[i17 >> 0] = 0;
    HEAP8[i18 >> 0] = 1;
    HEAP8[i19 >> 0] = 5;
    HEAP8[i20 >> 0] = 0;
    HEAP8[i21 >> 0] = 1;
    HEAP8[i22 >> 0] = 5;
    HEAP8[i23 >> 0] = 0;
    HEAP8[i24 >> 0] = 1;
    HEAP8[i26 >> 0] = 5;
    HEAP8[i27 >> 0] = 0;
    HEAP8[i28 >> 0] = 1;
    HEAP8[i29 >> 0] = 5;
    HEAP8[i30 >> 0] = 0;
    HEAP8[i31 >> 0] = 1;
    HEAP8[i32 >> 0] = 5;
    HEAP8[i33 >> 0] = 0;
    HEAP8[i34 >> 0] = 1;
    HEAP8[i35 >> 0] = 5;
    HEAP8[i36 >> 0] = 0;
    HEAP8[i37 >> 0] = 1;
    HEAP8[i38 >> 0] = 5;
    HEAP8[i39 >> 0] = 0;
    HEAP8[i40 >> 0] = 1;
    HEAP8[i41 >> 0] = 5;
    HEAP8[i42 >> 0] = 0;
    HEAP8[i43 >> 0] = 1;
    HEAP8[i44 >> 0] = 5;
    HEAP8[i45 >> 0] = 0;
    HEAP8[i46 >> 0] = 1;
    HEAP8[i47 >> 0] = 5;
    HEAP8[i48 >> 0] = 0;
    HEAP8[i49 >> 0] = 1;
    HEAP8[i50 >> 0] = 5;
    HEAP8[i51 >> 0] = 0;
    HEAP8[i52 >> 0] = 1;
    HEAP8[i53 >> 0] = 5;
    HEAP8[i54 >> 0] = 0;
    HEAP8[i55 >> 0] = 1;
    HEAP8[i56 >> 0] = 5;
    HEAP8[i57 >> 0] = 0;
    HEAP8[i58 >> 0] = 1;
    HEAP8[i59 >> 0] = 5;
    HEAP32[i60 >> 2] = 0;
    HEAP32[i61 >> 2] = 0;
    HEAP8[i62 >> 0] = 0;
    HEAP8[i63 >> 0] = 0;
    HEAP8[i64 >> 0] = 1;
    HEAP8[i65 >> 0] = 1;
    HEAP8[i67 >> 0] = 0;
    HEAP16[i68 >> 1] = 1;
    HEAP16[i69 >> 1] = 1;
    HEAP8[i70 >> 0] = 0;
    HEAP8[i71 >> 0] = 0;
    HEAP8[i3 + 12 >> 0] = 1;
    break;
   }
  case 193:
  case 192:
   {
    if (!((_get_sof(i96, 0, 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 194:
   {
    if (!((_get_sof(i96, 1, 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 201:
   {
    if (!((_get_sof(i96, 0, 1) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 202:
   {
    if (!((_get_sof(i96, 1, 1) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 207:
  case 206:
  case 205:
  case 203:
  case 200:
  case 199:
  case 198:
  case 197:
  case 195:
   {
    i13 = HEAP32[i96 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 60;
    HEAP32[i13 + 24 >> 2] = i3;
    mftCall_vi(HEAP32[i13 >> 2] | 0, i96 | 0);
    break;
   }
  case 204:
   {
    i6 = HEAP32[i91 >> 2] | 0;
    i7 = i6 + 4 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i7 >> 2] | 0;
    }
    i4 = HEAP32[i6 >> 2] | 0;
    i3 = i3 + -1 | 0;
    i5 = i4 + 1 | 0;
    i4 = HEAPU8[i4 >> 0] << 8;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i7 >> 2] | 0;
     i5 = HEAP32[i6 >> 2] | 0;
    }
    i13 = HEAPU8[i5 >> 0] | i4;
    i4 = i13 + -2 | 0;
    i12 = HEAP32[i96 >> 2] | 0;
    HEAP32[i12 + 20 >> 2] = 91;
    HEAP32[i12 + 24 >> 2] = HEAP32[i97 >> 2];
    HEAP32[i12 + 28 >> 2] = i4;
    mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i96 | 0, 1);
    HEAP32[i6 >> 2] = i5 + 1;
    HEAP32[i7 >> 2] = i3 + -1;
    if (i13 >>> 0 > 2) mftCall_vii(HEAP32[(HEAP32[i91 >> 2] | 0) + 16 >> 2] | 0, i96 | 0, i4 | 0);
    break;
   }
  case 196:
   {
    i12 = HEAP32[i91 >> 2] | 0;
    i13 = i12 + 4 | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i15 = 109;
      break L1;
     }
     i3 = HEAP32[i13 >> 2] | 0;
    }
    i6 = HEAP32[i12 >> 2] | 0;
    i3 = i3 + -1 | 0;
    i4 = i6 + 1 | 0;
    i6 = HEAPU8[i6 >> 0] << 8;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i15 = 109;
      break L1;
     }
     i3 = HEAP32[i13 >> 2] | 0;
     i5 = HEAP32[i12 >> 2] | 0;
    } else i5 = i4;
    i4 = i3 + -1 | 0;
    i3 = i5 + 1 | 0;
    i5 = (HEAPU8[i5 >> 0] | i6) + -2 | 0;
    if ((i5 | 0) > 16) {
     i11 = i12 + 12 | 0;
     do {
      if (!i4) {
       if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
        i15 = 109;
        break L1;
       }
       i4 = HEAP32[i13 >> 2] | 0;
       i3 = HEAP32[i12 >> 2] | 0;
      }
      i10 = HEAP8[i3 >> 0] | 0;
      i9 = i10 & 255;
      i6 = HEAP32[i96 >> 2] | 0;
      HEAP32[i6 + 20 >> 2] = 80;
      HEAP32[i6 + 24 >> 2] = i9;
      mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i96 | 0, 1);
      HEAP8[i14 >> 0] = 0;
      i6 = 1;
      i8 = 0;
      i3 = i3 + 1 | 0;
      i4 = i4 + -1 | 0;
      do {
       if (!i4) {
        if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
         i15 = 109;
         break L1;
        }
        i4 = HEAP32[i13 >> 2] | 0;
        i3 = HEAP32[i12 >> 2] | 0;
       }
       i7 = HEAP8[i3 >> 0] | 0;
       HEAP8[i14 + i6 >> 0] = i7;
       i8 = (i7 & 255) + i8 | 0;
       i6 = i6 + 1 | 0;
       i4 = i4 + -1 | 0;
       i3 = i3 + 1 | 0;
      } while ((i6 | 0) < 17);
      i7 = i5 + -17 | 0;
      i6 = HEAP32[i96 >> 2] | 0;
      HEAP32[i6 + 24 >> 2] = HEAPU8[i72 >> 0];
      HEAP32[i6 + 28 >> 2] = HEAPU8[i73 >> 0];
      HEAP32[i6 + 32 >> 2] = HEAPU8[i74 >> 0];
      HEAP32[i6 + 36 >> 2] = HEAPU8[i75 >> 0];
      HEAP32[i6 + 40 >> 2] = HEAPU8[i76 >> 0];
      HEAP32[i6 + 44 >> 2] = HEAPU8[i78 >> 0];
      HEAP32[i6 + 48 >> 2] = HEAPU8[i79 >> 0];
      HEAP32[i6 + 52 >> 2] = HEAPU8[i80 >> 0];
      HEAP32[i6 + 20 >> 2] = 86;
      mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i96 | 0, 2);
      i6 = HEAP32[i96 >> 2] | 0;
      HEAP32[i6 + 24 >> 2] = HEAPU8[i81 >> 0];
      HEAP32[i6 + 28 >> 2] = HEAPU8[i82 >> 0];
      HEAP32[i6 + 32 >> 2] = HEAPU8[i83 >> 0];
      HEAP32[i6 + 36 >> 2] = HEAPU8[i84 >> 0];
      HEAP32[i6 + 40 >> 2] = HEAPU8[i85 >> 0];
      HEAP32[i6 + 44 >> 2] = HEAPU8[i86 >> 0];
      HEAP32[i6 + 48 >> 2] = HEAPU8[i87 >> 0];
      HEAP32[i6 + 52 >> 2] = HEAPU8[i89 >> 0];
      HEAP32[i6 + 20 >> 2] = 86;
      mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i96 | 0, 2);
      if ((i8 | 0) > 256 | (i7 | 0) < (i8 | 0)) {
       i6 = HEAP32[i96 >> 2] | 0;
       HEAP32[i6 + 20 >> 2] = 8;
       mftCall_vi(HEAP32[i6 >> 2] | 0, i96 | 0);
      }
      if ((i8 | 0) > 0) {
       i6 = 0;
       while (1) {
        if (!i4) {
         if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
          i15 = 109;
          break L1;
         }
         i4 = HEAP32[i13 >> 2] | 0;
         i3 = HEAP32[i12 >> 2] | 0;
        }
        i4 = i4 + -1 | 0;
        i5 = i3 + 1 | 0;
        HEAP8[i25 + i6 >> 0] = HEAP8[i3 >> 0] | 0;
        i6 = i6 + 1 | 0;
        if ((i6 | 0) >= (i8 | 0)) {
         i3 = i5;
         break;
        } else i3 = i5;
       }
      }
      _memset(i25 + i8 | 0, 0, 256 - i8 | 0) | 0;
      i5 = i7 - i8 | 0;
      if (!(i9 & 16)) {
       if ((i10 & 255) > 3) {
        i10 = HEAP32[i96 >> 2] | 0;
        HEAP32[i10 + 20 >> 2] = 30;
        HEAP32[i10 + 24 >> 2] = i9;
        mftCall_vi(HEAP32[i10 >> 2] | 0, i96 | 0);
       }
       i9 = i96 + 160 + (i9 << 2) | 0;
      } else {
       i6 = i9 + -16 | 0;
       if ((i10 & 255) < 16 | (i6 | 0) > 3) {
        i10 = HEAP32[i96 >> 2] | 0;
        HEAP32[i10 + 20 >> 2] = 30;
        HEAP32[i10 + 24 >> 2] = i6;
        mftCall_vi(HEAP32[i10 >> 2] | 0, i96 | 0);
       }
       i9 = i96 + 176 + (i6 << 2) | 0;
      }
      i6 = HEAP32[i9 >> 2] | 0;
      if (!i6) {
       i6 = _jpeg_alloc_huff_table(i96) | 0;
       HEAP32[i9 >> 2] = i6;
      }
      i7 = i14;
      i8 = i6 + 17 | 0;
      do {
       HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
       i6 = i6 + 1 | 0;
       i7 = i7 + 1 | 0;
      } while ((i6 | 0) < (i8 | 0));
      _memcpy((HEAP32[i9 >> 2] | 0) + 17 | 0, i25 | 0, 256) | 0;
     } while ((i5 | 0) > 16);
    }
    if (i5 | 0) {
     i11 = HEAP32[i96 >> 2] | 0;
     HEAP32[i11 + 20 >> 2] = 11;
     mftCall_vi(HEAP32[i11 >> 2] | 0, i96 | 0);
    }
    HEAP32[i12 >> 2] = i3;
    HEAP32[i13 >> 2] = i4;
    break;
   }
  case 219:
   {
    i12 = HEAP32[i91 >> 2] | 0;
    i13 = i12 + 4 | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i13 >> 2] | 0;
    }
    i6 = HEAP32[i12 >> 2] | 0;
    i3 = i3 + -1 | 0;
    i4 = i6 + 1 | 0;
    i6 = HEAPU8[i6 >> 0] << 8;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i13 >> 2] | 0;
     i4 = HEAP32[i12 >> 2] | 0;
    }
    i5 = i3 + -1 | 0;
    i3 = i4 + 1 | 0;
    i11 = HEAPU8[i4 >> 0] | i6;
    i4 = i11 + -2 | 0;
    if (i11 >>> 0 > 2) {
     i11 = i12 + 12 | 0;
     do {
      if (!i5) {
       if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
        i92 = 0;
        i15 = 173;
        break L1;
       }
       i5 = HEAP32[i13 >> 2] | 0;
       i3 = HEAP32[i12 >> 2] | 0;
      }
      i6 = HEAPU8[i3 >> 0] | 0;
      i8 = i6 >>> 4;
      i6 = i6 & 15;
      i10 = HEAP32[i96 >> 2] | 0;
      HEAP32[i10 + 20 >> 2] = 81;
      HEAP32[i10 + 24 >> 2] = i6;
      HEAP32[i10 + 28 >> 2] = i8;
      mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i96 | 0, 1);
      if (i6 >>> 0 > 3) {
       i10 = HEAP32[i96 >> 2] | 0;
       HEAP32[i10 + 20 >> 2] = 31;
       HEAP32[i10 + 24 >> 2] = i6;
       mftCall_vi(HEAP32[i10 >> 2] | 0, i96 | 0);
      }
      i6 = i96 + 144 + (i6 << 2) | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      if (!i7) {
       i7 = _jpeg_alloc_quant_table(i96) | 0;
       HEAP32[i6 >> 2] = i7;
      }
      i5 = i5 + -1 | 0;
      i3 = i3 + 1 | 0;
      i10 = (i8 | 0) == 0;
      if (i10) {
       i6 = 0;
       do {
        if (!i5) {
         if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
          i92 = 0;
          i15 = 173;
          break L1;
         }
         i5 = HEAP32[i13 >> 2] | 0;
         i3 = HEAP32[i12 >> 2] | 0;
        }
        HEAP16[i7 + (HEAP32[gb + 15416 + (i6 << 2) >> 2] << 1) >> 1] = HEAPU8[i3 >> 0] | 0;
        i6 = i6 + 1 | 0;
        i5 = i5 + -1 | 0;
        i3 = i3 + 1 | 0;
       } while ((i6 | 0) < 64);
      } else {
       i9 = 0;
       do {
        if (!i5) {
         if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
          i92 = 0;
          i15 = 173;
          break L1;
         }
         i5 = HEAP32[i13 >> 2] | 0;
         i3 = HEAP32[i12 >> 2] | 0;
        }
        i5 = i5 + -1 | 0;
        i6 = i3 + 1 | 0;
        i8 = HEAPU8[i3 >> 0] << 8;
        if (!i5) {
         if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
          i92 = 0;
          i15 = 173;
          break L1;
         }
         i3 = HEAP32[i13 >> 2] | 0;
         i6 = HEAP32[i12 >> 2] | 0;
        } else i3 = i5;
        HEAP16[i7 + (HEAP32[gb + 15416 + (i9 << 2) >> 2] << 1) >> 1] = HEAPU8[i6 >> 0] | i8;
        i9 = i9 + 1 | 0;
        i5 = i3 + -1 | 0;
        i3 = i6 + 1 | 0;
       } while ((i9 | 0) < 64);
      }
      i8 = HEAP32[i96 >> 2] | 0;
      L135 : do if ((HEAP32[i8 + 104 >> 2] | 0) > 1) {
       i6 = 0;
       while (1) {
        HEAP32[i8 + 24 >> 2] = HEAPU16[i7 + (i6 << 1) >> 1];
        HEAP32[i8 + 28 >> 2] = HEAPU16[i7 + ((i6 | 1) << 1) >> 1];
        HEAP32[i8 + 32 >> 2] = HEAPU16[i7 + ((i6 | 2) << 1) >> 1];
        HEAP32[i8 + 36 >> 2] = HEAPU16[i7 + ((i6 | 3) << 1) >> 1];
        HEAP32[i8 + 40 >> 2] = HEAPU16[i7 + ((i6 | 4) << 1) >> 1];
        HEAP32[i8 + 44 >> 2] = HEAPU16[i7 + ((i6 | 5) << 1) >> 1];
        HEAP32[i8 + 48 >> 2] = HEAPU16[i7 + ((i6 | 6) << 1) >> 1];
        HEAP32[i8 + 52 >> 2] = HEAPU16[i7 + ((i6 | 7) << 1) >> 1];
        HEAP32[i8 + 20 >> 2] = 93;
        mftCall_vii(HEAP32[i8 + 4 >> 2] | 0, i96 | 0, 2);
        i6 = i6 + 8 | 0;
        if ((i6 | 0) >= 64) break L135;
        i8 = HEAP32[i96 >> 2] | 0;
       }
      } while (0);
      i4 = (i10 ? -65 : -129) + i4 | 0;
     } while ((i4 | 0) > 0);
    }
    if (i4 | 0) {
     i11 = HEAP32[i96 >> 2] | 0;
     HEAP32[i11 + 20 >> 2] = 11;
     mftCall_vi(HEAP32[i11 >> 2] | 0, i96 | 0);
    }
    HEAP32[i12 >> 2] = i3;
    HEAP32[i13 >> 2] = i5;
    break;
   }
  case 221:
   {
    i7 = HEAP32[i91 >> 2] | 0;
    i8 = i7 + 4 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i7 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i8 >> 2] | 0;
    }
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i3 + -1 | 0;
    i4 = i6 + 1 | 0;
    i6 = HEAPU8[i6 >> 0] << 8;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i7 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i8 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
    } else i5 = i4;
    i3 = i3 + -1 | 0;
    i4 = i5 + 1 | 0;
    if ((HEAPU8[i5 >> 0] | i6 | 0) != 4) {
     i13 = HEAP32[i96 >> 2] | 0;
     HEAP32[i13 + 20 >> 2] = 11;
     mftCall_vi(HEAP32[i13 >> 2] | 0, i96 | 0);
    }
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i7 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i8 >> 2] | 0;
     i4 = HEAP32[i7 >> 2] | 0;
    }
    i5 = i3 + -1 | 0;
    i3 = i4 + 1 | 0;
    i6 = HEAPU8[i4 >> 0] << 8;
    if (!i5) {
     if (!((mftCall_ii(HEAP32[i7 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i4 = HEAP32[i8 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
    } else i4 = i5;
    i13 = HEAPU8[i3 >> 0] | i6;
    i12 = HEAP32[i96 >> 2] | 0;
    HEAP32[i12 + 20 >> 2] = 82;
    HEAP32[i12 + 24 >> 2] = i13;
    mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i96 | 0, 1);
    HEAP32[i60 >> 2] = i13;
    HEAP32[i7 >> 2] = i3 + 1;
    HEAP32[i8 >> 2] = i4 + -1;
    break;
   }
  case 239:
  case 238:
  case 237:
  case 236:
  case 235:
  case 234:
  case 233:
  case 232:
  case 231:
  case 230:
  case 229:
  case 228:
  case 227:
  case 226:
  case 225:
  case 224:
   {
    if (!((mftCall_ii(HEAP32[(HEAP32[i98 >> 2] | 0) + 28 + (i3 + -224 << 2) >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 254:
   {
    if (!((mftCall_ii(HEAP32[(HEAP32[i98 >> 2] | 0) + 24 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
     i92 = 0;
     i15 = 173;
     break L1;
    }
    break;
   }
  case 1:
  case 215:
  case 214:
  case 213:
  case 212:
  case 211:
  case 210:
  case 209:
  case 208:
   {
    i13 = HEAP32[i96 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 92;
    HEAP32[i13 + 24 >> 2] = i3;
    mftCall_vii(HEAP32[i13 + 4 >> 2] | 0, i96 | 0, 1);
    break;
   }
  case 220:
   {
    i6 = HEAP32[i91 >> 2] | 0;
    i7 = i6 + 4 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i7 >> 2] | 0;
    }
    i4 = HEAP32[i6 >> 2] | 0;
    i3 = i3 + -1 | 0;
    i5 = i4 + 1 | 0;
    i4 = HEAPU8[i4 >> 0] << 8;
    if (!i3) {
     if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break L1;
     }
     i3 = HEAP32[i7 >> 2] | 0;
     i5 = HEAP32[i6 >> 2] | 0;
    }
    i13 = HEAPU8[i5 >> 0] | i4;
    i4 = i13 + -2 | 0;
    i12 = HEAP32[i96 >> 2] | 0;
    HEAP32[i12 + 20 >> 2] = 91;
    HEAP32[i12 + 24 >> 2] = HEAP32[i97 >> 2];
    HEAP32[i12 + 28 >> 2] = i4;
    mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i96 | 0, 1);
    HEAP32[i6 >> 2] = i5 + 1;
    HEAP32[i7 >> 2] = i3 + -1;
    if (i13 >>> 0 > 2) mftCall_vii(HEAP32[(HEAP32[i91 >> 2] | 0) + 16 >> 2] | 0, i96 | 0, i4 | 0);
    break;
   }
  default:
   {
    i13 = HEAP32[i96 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 68;
    HEAP32[i13 + 24 >> 2] = i3;
    mftCall_vi(HEAP32[i13 >> 2] | 0, i96 | 0);
   }
  } while (0);
  HEAP32[i97 >> 2] = 0;
  i3 = 0;
 }
 if ((i15 | 0) == 24) {
  i16 = HEAP32[i91 >> 2] | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  i17 = i16 + 4 | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  if (!(HEAP8[(HEAP32[i98 >> 2] | 0) + 13 >> 0] | 0)) {
   i92 = HEAP32[i96 >> 2] | 0;
   HEAP32[i92 + 20 >> 2] = 62;
   mftCall_vi(HEAP32[i92 >> 2] | 0, i96 | 0);
  }
  do if (!i3) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i3 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   break;
  } while (0);
  i3 = i3 + -1 | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAPU8[i4 >> 0] << 8;
  do if (!i3) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i3 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   break;
  } else i4 = i5; while (0);
  i3 = i3 + -1 | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAPU8[i4 >> 0] | i6;
  do if (!i3) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i3 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   break;
  } else i4 = i5; while (0);
  i5 = HEAP8[i4 >> 0] | 0;
  i14 = i5 & 255;
  i92 = HEAP32[i96 >> 2] | 0;
  HEAP32[i92 + 20 >> 2] = 103;
  HEAP32[i92 + 24 >> 2] = i14;
  mftCall_vii(HEAP32[i92 + 4 >> 2] | 0, i96 | 0, 1);
  if ((i5 + -1 & 255) > 3 | (i6 | 0) != ((i14 << 1) + 6 | 0)) {
   i92 = HEAP32[i96 >> 2] | 0;
   HEAP32[i92 + 20 >> 2] = 11;
   mftCall_vi(HEAP32[i92 >> 2] | 0, i96 | 0);
  }
  HEAP32[i96 + 292 >> 2] = i14;
  i6 = i96 + 296 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i6 = i3 + -1 | 0;
  i3 = i4 + 1 | 0;
  i7 = (i6 | 0) == 0;
  L210 : do if (!(i5 << 24 >> 24)) {
   i1 = i6;
   i2 = i3;
   i95 = i7;
  } else {
   i11 = i16 + 12 | 0;
   i12 = i96 + 196 | 0;
   i13 = i96 + 36 | 0;
   i4 = i6;
   i5 = i7;
   i10 = 0;
   while (1) {
    if (i5) {
     if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break;
     }
     i4 = HEAP32[i17 >> 2] | 0;
     i3 = HEAP32[i16 >> 2] | 0;
    }
    i4 = i4 + -1 | 0;
    i5 = i3 + 1 | 0;
    i9 = HEAPU8[i3 >> 0] | 0;
    if (!i4) {
     if (!((mftCall_ii(HEAP32[i11 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
      i92 = 0;
      i15 = 173;
      break;
     }
     i4 = HEAP32[i17 >> 2] | 0;
     i5 = HEAP32[i16 >> 2] | 0;
    }
    i7 = HEAPU8[i5 >> 0] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    i8 = HEAP32[i13 >> 2] | 0;
    L222 : do if ((i8 | 0) > 0) {
     i6 = 0;
     while (1) {
      if ((i9 | 0) == (HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i96 + 296 + (i6 << 2) >> 2] | 0)) {
       i94 = i3;
       break L222;
      }
      i6 = i6 + 1 | 0;
      i3 = i3 + 84 | 0;
      if (!((i6 | 0) < 4 & (i6 | 0) < (i8 | 0))) {
       i93 = i3;
       i15 = 49;
       break;
      }
     }
    } else {
     i93 = i3;
     i15 = 49;
    } while (0);
    if ((i15 | 0) == 49) {
     i15 = 0;
     i94 = HEAP32[i96 >> 2] | 0;
     HEAP32[i94 + 20 >> 2] = 5;
     HEAP32[i94 + 24 >> 2] = i9;
     mftCall_vi(HEAP32[i94 >> 2] | 0, i96 | 0);
     i94 = i93;
    }
    HEAP32[i96 + 296 + (i10 << 2) >> 2] = i94;
    i90 = i94 + 20 | 0;
    HEAP32[i90 >> 2] = i7 >>> 4;
    i91 = i94 + 24 | 0;
    HEAP32[i91 >> 2] = i7 & 15;
    i92 = HEAP32[i96 >> 2] | 0;
    HEAP32[i92 + 24 >> 2] = i9;
    HEAP32[i92 + 28 >> 2] = HEAP32[i90 >> 2];
    HEAP32[i92 + 32 >> 2] = HEAP32[i91 >> 2];
    HEAP32[i92 + 20 >> 2] = 104;
    mftCall_vii(HEAP32[i92 + 4 >> 2] | 0, i96 | 0, 1);
    if ((i10 | 0) > 0) {
     i3 = 0;
     do {
      if ((HEAP32[i96 + 296 + (i3 << 2) >> 2] | 0) == (i94 | 0)) {
       i92 = HEAP32[i96 >> 2] | 0;
       HEAP32[i92 + 20 >> 2] = 5;
       HEAP32[i92 + 24 >> 2] = i9;
       mftCall_vi(HEAP32[i92 >> 2] | 0, i96 | 0);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i10 | 0));
    }
    i10 = i10 + 1 | 0;
    i4 = i4 + -1 | 0;
    i3 = i5 + 1 | 0;
    i5 = (i4 | 0) == 0;
    if ((i10 | 0) >= (i14 | 0)) {
     i1 = i4;
     i2 = i3;
     i95 = i5;
     break L210;
    }
   }
   if ((i15 | 0) == 173) {
    STACKTOP = i99;
    return i92 | 0;
   }
  } while (0);
  do if (i95) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   break;
  } while (0);
  i1 = i1 + -1 | 0;
  i3 = i2 + 1 | 0;
  i5 = i96 + 364 | 0;
  HEAP32[i5 >> 2] = HEAPU8[i2 >> 0];
  do if (!i1) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
   break;
  } while (0);
  i2 = i1 + -1 | 0;
  i1 = i3 + 1 | 0;
  i4 = i96 + 368 | 0;
  HEAP32[i4 >> 2] = HEAPU8[i3 >> 0];
  do if (!i2) if (!((mftCall_ii(HEAP32[i16 + 12 >> 2] | 0, i96 | 0) | 0) << 24 >> 24)) {
   i98 = 0;
   STACKTOP = i99;
   return i98 | 0;
  } else {
   i2 = HEAP32[i17 >> 2] | 0;
   i1 = HEAP32[i16 >> 2] | 0;
   break;
  } while (0);
  i95 = HEAPU8[i1 >> 0] | 0;
  i93 = i96 + 372 | 0;
  HEAP32[i93 >> 2] = i95 >>> 4;
  i94 = i96 + 376 | 0;
  HEAP32[i94 >> 2] = i95 & 15;
  i95 = HEAP32[i96 >> 2] | 0;
  HEAP32[i95 + 24 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i95 + 28 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i95 + 32 >> 2] = HEAP32[i93 >> 2];
  HEAP32[i95 + 36 >> 2] = HEAP32[i94 >> 2];
  HEAP32[i95 + 20 >> 2] = 105;
  mftCall_vii(HEAP32[i95 + 4 >> 2] | 0, i96 | 0, 1);
  HEAP32[(HEAP32[i98 >> 2] | 0) + 16 >> 2] = 0;
  i98 = i96 + 124 | 0;
  HEAP32[i98 >> 2] = (HEAP32[i98 >> 2] | 0) + 1;
  HEAP32[i16 >> 2] = i1 + 1;
  HEAP32[i17 >> 2] = i2 + -1;
  HEAP32[i97 >> 2] = 0;
  i98 = 1;
  STACKTOP = i99;
  return i98 | 0;
 } else if ((i15 | 0) == 65) {
  i98 = HEAP32[i96 >> 2] | 0;
  HEAP32[i98 + 20 >> 2] = 85;
  mftCall_vii(HEAP32[i98 + 4 >> 2] | 0, i96 | 0, 1);
  HEAP32[i97 >> 2] = 0;
  i98 = 2;
  STACKTOP = i99;
  return i98 | 0;
 } else if ((i15 | 0) == 109) {
  i98 = 0;
  STACKTOP = i99;
  return i98 | 0;
 } else if ((i15 | 0) == 173) {
  STACKTOP = i99;
  return i92 | 0;
 }
 return 0;
}

function __ZN5physx22computeVolumeIntegralsERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsE(i2, f1, i80) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i80 = i80 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i81 = 0, i82 = 0, f83 = f0, f84 = f0, f85 = f0, d86 = 0.0, d87 = 0.0, d88 = 0.0, d89 = 0.0, d90 = 0.0, d91 = 0.0, d92 = 0.0, d93 = 0.0, d94 = 0.0, d95 = 0.0, d96 = 0.0, d97 = 0.0, d98 = 0.0, d99 = 0.0, d100 = 0.0, d101 = 0.0;
 i82 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i82 + 312 | 0;
 i81 = i82;
 i6 = HEAP16[i2 + 24 >> 1] | 0;
 i62 = i81 + 16 | 0;
 HEAP32[i62 >> 2] = 0;
 HEAP32[i62 + 4 >> 2] = 0;
 HEAP32[i62 + 8 >> 2] = 0;
 HEAP32[i62 + 12 >> 2] = 0;
 HEAP32[i62 + 16 >> 2] = 0;
 HEAP32[i62 + 20 >> 2] = 0;
 i79 = i81 + 8 | 0;
 HEAPF64[i79 >> 3] = +f1;
 HEAPF64[i81 >> 3] = 0.0;
 HEAP32[i62 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i62 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i62 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i62 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i62 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i62 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 i62 = i81 + 40 | 0;
 HEAP16[i62 >> 1] = i6;
 i75 = i81 + 304 | 0;
 i76 = i81 + 296 | 0;
 i77 = i81 + 288 | 0;
 i78 = i81 + 280 | 0;
 i74 = i81 + 272 | 0;
 i73 = i81 + 264 | 0;
 i70 = i81 + 256 | 0;
 i71 = i81 + 248 | 0;
 i72 = i81 + 240 | 0;
 i69 = i81 + 232 | 0;
 i7 = i69;
 i19 = i7 + 80 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i19 | 0));
 i32 = i81 + 36 | 0;
 if (!(HEAP32[i32 >> 2] | 0)) {
  d16 = 0.0;
  d17 = 0.0;
  d18 = 0.0;
  d3 = 0.0;
  d4 = 0.0;
  d5 = 0.0;
  d12 = 0.0;
  d13 = 0.0;
  d14 = 0.0;
  d15 = 0.0;
 } else {
  i33 = i68 + 32 | 0;
  i34 = i68 + 36 | 0;
  i35 = i68 + 40 | 0;
  i66 = i81 + 16 | 0;
  i67 = i81 + 20 | 0;
  i36 = i68 + 24 | 0;
  i37 = i68 + 8 | 0;
  i38 = i68 + 16 | 0;
  i39 = i81 + 52 | 0;
  i40 = i81 + 44 | 0;
  i41 = i81 + 48 | 0;
  i42 = i81 + 120 | 0;
  i43 = i81 + 104 | 0;
  i44 = i81 + 88 | 0;
  i45 = i81 + 72 | 0;
  i46 = i81 + 56 | 0;
  i47 = i81 + 128 | 0;
  i48 = i81 + 112 | 0;
  i49 = i81 + 96 | 0;
  i50 = i81 + 80 | 0;
  i51 = i81 + 64 | 0;
  i52 = i81 + 136 | 0;
  i53 = i81 + 144 | 0;
  i54 = i81 + 152 | 0;
  i55 = i81 + 160 | 0;
  i56 = i81 + 168 | 0;
  i57 = i81 + 176 | 0;
  i58 = i81 + 184 | 0;
  i59 = i81 + 192 | 0;
  i60 = i81 + 200 | 0;
  i61 = i81 + 208 | 0;
  i63 = i81 + 216 | 0;
  i64 = i81 + 224 | 0;
  i65 = i81 + 28 | 0;
  i2 = 0;
  i31 = HEAP32[i81 + 32 >> 2] | 0;
  while (1) {
   if (!(i6 & 2)) {
    i26 = HEAP32[i31 >> 2] | 0;
    HEAP32[i33 >> 2] = i26;
    i7 = HEAP32[i31 + 4 >> 2] | 0;
    HEAP32[i34 >> 2] = i7;
    i19 = HEAP32[i31 + 8 >> 2] | 0;
   } else {
    i26 = HEAPU16[i31 >> 1] | 0;
    HEAP32[i33 >> 2] = i26;
    i7 = HEAPU16[i31 + 2 >> 1] | 0;
    HEAP32[i34 >> 2] = i7;
    i19 = HEAPU16[i31 + 4 >> 1] | 0;
   }
   HEAP32[i35 >> 2] = i19;
   if (!(i6 & 1)) {
    i6 = i7;
    i7 = i19;
   } else {
    HEAP32[i34 >> 2] = i19;
    HEAP32[i35 >> 2] = i7;
    i6 = i19;
   }
   i29 = HEAP32[i66 >> 2] | 0;
   i30 = HEAP32[i67 >> 2] | 0;
   i27 = Math_imul(i29, i6) | 0;
   i28 = Math_imul(i29, i26) | 0;
   f1 = Math_fround(HEAPF32[i30 + i27 >> 2]);
   f23 = Math_fround(HEAPF32[i30 + i28 >> 2]);
   f84 = Math_fround(f1 - f23);
   f83 = Math_fround(HEAPF32[i30 + (i27 + 4) >> 2]);
   f24 = Math_fround(HEAPF32[i30 + (i28 + 4) >> 2]);
   f21 = Math_fround(f83 - f24);
   f22 = Math_fround(HEAPF32[i30 + (i27 + 8) >> 2]);
   f25 = Math_fround(HEAPF32[i30 + (i28 + 8) >> 2]);
   f85 = Math_fround(f22 - f25);
   i28 = Math_imul(i29, i7) | 0;
   f1 = Math_fround(Math_fround(HEAPF32[i30 + i28 >> 2]) - f1);
   f83 = Math_fround(Math_fround(HEAPF32[i30 + (i28 + 4) >> 2]) - f83);
   f22 = Math_fround(Math_fround(HEAPF32[i30 + (i28 + 8) >> 2]) - f22);
   f20 = Math_fround(Math_fround(f21 * f22) - Math_fround(f85 * f83));
   f22 = Math_fround(Math_fround(f85 * f1) - Math_fround(f84 * f22));
   f1 = Math_fround(Math_fround(f84 * f83) - Math_fround(f21 * f1));
   f21 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f20 * f20) + Math_fround(f22 * f22)))));
   if (f21 > Math_fround(0.0)) {
    f85 = Math_fround(Math_fround(1.0) / f21);
    f20 = Math_fround(f20 * f85);
    f21 = Math_fround(f22 * f85);
    f1 = Math_fround(f1 * f85);
   } else f21 = f22;
   HEAPF64[i36 >> 3] = +Math_fround(-Math_fround(Math_fround(f25 * f1) + Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * f20))));
   HEAPF64[i68 >> 3] = +f20;
   HEAPF64[i37 >> 3] = +f21;
   HEAPF64[i38 >> 3] = +f1;
   f83 = Math_fround(Math_abs(Math_fround(f20)));
   f84 = Math_fround(Math_abs(Math_fround(f21)));
   f85 = Math_fround(Math_abs(Math_fround(f1)));
   i27 = f83 > f84 & f83 > f85 ? 0 : f84 > f85 ? 1 : 2;
   HEAP32[i39 >> 2] = i27;
   i27 = ((i27 + 1 | 0) >>> 0) % 3 | 0;
   HEAP32[i40 >> 2] = i27;
   i28 = ((i27 + 1 | 0) >>> 0) % 3 | 0;
   HEAP32[i41 >> 2] = i28;
   i7 = i46;
   i19 = i7 + 80 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i19 | 0));
   d14 = 0.0;
   d13 = 0.0;
   d12 = 0.0;
   d11 = 0.0;
   d10 = 0.0;
   d9 = 0.0;
   d8 = 0.0;
   d5 = 0.0;
   d4 = 0.0;
   d3 = 0.0;
   i6 = 0;
   while (1) {
    i7 = i30 + (Math_imul(i26, i29) | 0) | 0;
    i6 = i6 + 1 | 0;
    i26 = (i6 | 0) == 3;
    i19 = i30 + (Math_imul(HEAP32[i68 + 32 + ((i26 ? 0 : i6) << 2) >> 2] | 0, i29) | 0) | 0;
    d88 = +Math_fround(HEAPF32[i7 + (i27 << 2) >> 2]);
    d17 = +Math_fround(HEAPF32[i7 + (i28 << 2) >> 2]);
    d89 = +Math_fround(HEAPF32[i19 + (i27 << 2) >> 2]);
    d15 = +Math_fround(HEAPF32[i19 + (i28 << 2) >> 2]);
    d90 = d89 - d88;
    d95 = d15 - d17;
    d101 = d88 * d88;
    d92 = d88 * d101;
    d86 = d17 * d17;
    d87 = d17 * d86;
    d94 = d89 * d89;
    d18 = d15 * d15;
    d16 = d15 * d18;
    d100 = d88 + d89;
    d99 = d101 + d89 * d100;
    d98 = d92 + d89 * d99;
    d97 = d86 + d15 * (d17 + d15);
    d96 = d87 + d15 * d97;
    d91 = d88 * (d89 * 2.0);
    d93 = d101 + (d94 * 3.0 + d91);
    d91 = d101 * 3.0 + (d94 + d91);
    d14 = d14 + d100 * d95;
    d13 = d13 + d95 * d99;
    d12 = d12 + d95 * d98;
    d11 = d11 + d95 * (d88 * d92 + d89 * d98);
    d10 = d10 + d90 * d97;
    d9 = d9 + d90 * d96;
    d8 = d8 + d90 * (d17 * d87 + d15 * d96);
    d5 = d5 + d95 * (d15 * d93 + d17 * d91);
    d4 = d4 + d95 * (d15 * (d89 * d94 * 4.0 + d88 * d93) + d17 * (d92 * 4.0 + d89 * d91));
    d3 = d3 + d90 * (d89 * (d87 + (d86 * (d15 * 2.0) + (d16 * 4.0 + d17 * (d18 * 3.0)))) + d88 * (d87 * 4.0 + (d86 * (d15 * 3.0) + (d16 + d17 * (d18 * 2.0)))));
    if (i26) break;
    i26 = HEAP32[i68 + 32 + (i6 << 2) >> 2] | 0;
   }
   d99 = d14 * .5;
   HEAPF64[i46 >> 3] = d99;
   d93 = d13 / 6.0;
   HEAPF64[i51 >> 3] = d93;
   d14 = d12 / 12.0;
   HEAPF64[i50 >> 3] = d14;
   d89 = d11 / 20.0;
   HEAPF64[i43 >> 3] = d89;
   d13 = d10 / -6.0;
   HEAPF64[i45 >> 3] = d13;
   d16 = d9 / -12.0;
   HEAPF64[i49 >> 3] = d16;
   d17 = d8 / -20.0;
   HEAPF64[i47 >> 3] = d17;
   d95 = d5 / 24.0;
   HEAPF64[i44 >> 3] = d95;
   d91 = d4 / 60.0;
   HEAPF64[i48 >> 3] = d91;
   d87 = d3 / -60.0;
   HEAPF64[i42 >> 3] = d87;
   d94 = +HEAPF64[i36 >> 3];
   d15 = 1.0 / +HEAPF64[i68 + (HEAP32[i39 >> 2] << 3) >> 3];
   d18 = d15 * d15;
   d86 = d15 * d18;
   d97 = d93 * d15;
   HEAPF64[i52 >> 3] = d97;
   d98 = d13 * d15;
   HEAPF64[i53 >> 3] = d98;
   d18 = -d18;
   i30 = HEAP32[i40 >> 2] | 0;
   d101 = +HEAPF64[i68 + (i30 << 3) >> 3];
   i29 = HEAP32[i41 >> 2] | 0;
   d96 = +HEAPF64[i68 + (i29 << 3) >> 3];
   d13 = d93 * d101 + d13 * d96;
   d12 = d99 * d94;
   d99 = (d12 + d13) * d18;
   HEAPF64[i54 >> 3] = d99;
   d100 = d14 * d15;
   HEAPF64[i55 >> 3] = d100;
   HEAPF64[i56 >> 3] = d16 * d15;
   d90 = d101 * d101;
   d92 = d101 * 2.0 * d96;
   d88 = d96 * d96;
   d14 = d16 * d88 + (d14 * d90 + d95 * d92);
   HEAPF64[i57 >> 3] = d86 * (d14 + d94 * (d12 + d13 * 2.0));
   HEAPF64[i58 >> 3] = d89 * d15;
   HEAPF64[i59 >> 3] = d17 * d15;
   HEAPF64[i60 >> 3] = -(d15 * d86 * (d94 * d94 * (d12 + d13 * 3.0) + (d94 * 3.0 * d14 + (d17 * (d96 * d88) + (d87 * (d101 * 3.0 * d88) + (d89 * (d101 * d90) + d91 * (d96 * (d90 * 3.0))))))));
   HEAPF64[i61 >> 3] = d91 * d15;
   HEAPF64[i63 >> 3] = (d16 * d94 + (d87 * d101 + d17 * d96)) * d18;
   HEAPF64[i64 >> 3] = d86 * (d87 * d88 + (d89 * d90 + d91 * d92) + d94 * (d93 * d94 + (d95 * d96 + d101 * +HEAPF64[i50 >> 3]) * 2.0));
   HEAPF64[i69 >> 3] = +HEAPF64[i69 >> 3] + +HEAPF64[i68 >> 3] * ((i30 | 0) == 0 ? d97 : (i29 | 0) == 0 ? d98 : d99);
   i30 = i81 + 240 + (i30 << 3) | 0;
   HEAPF64[i30 >> 3] = d100 * d101 + +HEAPF64[i30 >> 3];
   i30 = HEAP32[i41 >> 2] | 0;
   i29 = i81 + 240 + (i30 << 3) | 0;
   HEAPF64[i29 >> 3] = +HEAPF64[i29 >> 3] + +HEAPF64[i68 + (i30 << 3) >> 3] * +HEAPF64[i56 >> 3];
   i29 = HEAP32[i39 >> 2] | 0;
   i30 = i81 + 240 + (i29 << 3) | 0;
   HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + +HEAPF64[i68 + (i29 << 3) >> 3] * +HEAPF64[i57 >> 3];
   i30 = HEAP32[i40 >> 2] | 0;
   i29 = i81 + 264 + (i30 << 3) | 0;
   HEAPF64[i29 >> 3] = +HEAPF64[i29 >> 3] + +HEAPF64[i68 + (i30 << 3) >> 3] * +HEAPF64[i58 >> 3];
   i29 = HEAP32[i41 >> 2] | 0;
   i30 = i81 + 264 + (i29 << 3) | 0;
   HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + +HEAPF64[i68 + (i29 << 3) >> 3] * +HEAPF64[i59 >> 3];
   i30 = HEAP32[i39 >> 2] | 0;
   i29 = i81 + 264 + (i30 << 3) | 0;
   HEAPF64[i29 >> 3] = +HEAPF64[i29 >> 3] + +HEAPF64[i68 + (i30 << 3) >> 3] * +HEAPF64[i60 >> 3];
   i29 = HEAP32[i40 >> 2] | 0;
   i30 = i81 + 288 + (i29 << 3) | 0;
   HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + +HEAPF64[i68 + (i29 << 3) >> 3] * +HEAPF64[i61 >> 3];
   i30 = HEAP32[i41 >> 2] | 0;
   i29 = i81 + 288 + (i30 << 3) | 0;
   HEAPF64[i29 >> 3] = +HEAPF64[i29 >> 3] + +HEAPF64[i68 + (i30 << 3) >> 3] * +HEAPF64[i63 >> 3];
   i29 = HEAP32[i39 >> 2] | 0;
   i30 = i81 + 288 + (i29 << 3) | 0;
   HEAPF64[i30 >> 3] = +HEAPF64[i30 >> 3] + +HEAPF64[i68 + (i29 << 3) >> 3] * +HEAPF64[i64 >> 3];
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= (HEAP32[i32 >> 2] | 0) >>> 0) break;
   i6 = HEAP16[i62 >> 1] | 0;
   i31 = i31 + (HEAP32[i65 >> 2] | 0) | 0;
  }
  d16 = +HEAPF64[i72 >> 3] * .5;
  d17 = +HEAPF64[i71 >> 3] * .5;
  d18 = +HEAPF64[i70 >> 3] * .5;
  d3 = +HEAPF64[i73 >> 3];
  d4 = +HEAPF64[i74 >> 3];
  d5 = +HEAPF64[i78 >> 3];
  d12 = +HEAPF64[i77 >> 3] * .5;
  d13 = +HEAPF64[i76 >> 3] * .5;
  d14 = +HEAPF64[i75 >> 3] * .5;
  d15 = +HEAPF64[i69 >> 3];
 }
 HEAPF64[i72 >> 3] = d16;
 HEAPF64[i71 >> 3] = d17;
 HEAPF64[i70 >> 3] = d18;
 d8 = d3 / 3.0;
 HEAPF64[i73 >> 3] = d8;
 d4 = d4 / 3.0;
 HEAPF64[i74 >> 3] = d4;
 d3 = d5 / 3.0;
 HEAPF64[i78 >> 3] = d3;
 HEAPF64[i77 >> 3] = d12;
 HEAPF64[i76 >> 3] = d13;
 HEAPF64[i75 >> 3] = d14;
 if (d15 != 0.0) {
  f85 = Math_fround(d16 / d15);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f85 = Math_fround(d17 / d15);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
  f85 = Math_fround(d18 / d15);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i2 = 0;
  i6 = 0;
  i7 = 0;
 }
 HEAP32[i80 >> 2] = i2;
 HEAP32[i80 + 4 >> 2] = i6;
 HEAP32[i80 + 8 >> 2] = i7;
 i2 = i80 + 24 | 0;
 d101 = +HEAPF64[i79 >> 3];
 d11 = (d4 + d3) * d101;
 d10 = (d8 + d3) * d101;
 d9 = (d8 + d4) * d101;
 d8 = d12 * d101;
 d99 = -d8;
 d5 = d13 * d101;
 d4 = -d5;
 d3 = d14 * d101;
 d100 = -d3;
 HEAPF64[tempDoublePtr >> 3] = d11;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 32 | 0;
 HEAPF64[tempDoublePtr >> 3] = d99;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 40 | 0;
 HEAPF64[tempDoublePtr >> 3] = d100;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 48 | 0;
 HEAPF64[tempDoublePtr >> 3] = d99;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 56 | 0;
 HEAPF64[tempDoublePtr >> 3] = d10;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 64 | 0;
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 72 | 0;
 HEAPF64[tempDoublePtr >> 3] = d100;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 80 | 0;
 HEAPF64[tempDoublePtr >> 3] = d4;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 88 | 0;
 HEAPF64[tempDoublePtr >> 3] = d9;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i2 = i80 + 96 | 0;
 d4 = d101 * d15;
 HEAPF64[i81 >> 3] = d4;
 if (!(d15 != 0.0)) {
  f85 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f25 = Math_fround(0.0);
  f84 = Math_fround(d4);
  f24 = Math_fround(f84 * f85);
  f83 = Math_fround(f84 * f23);
  f84 = Math_fround(f84 * f25);
  f22 = Math_fround(f85 * f24);
  f21 = Math_fround(f23 * f83);
  f20 = Math_fround(f25 * f84);
  f1 = Math_fround(f20 + f21);
  d96 = +f1;
  d96 = d11 - d96;
  f20 = Math_fround(f20 + f22);
  d98 = +f20;
  d98 = d10 - d98;
  f22 = Math_fround(f21 + f22);
  d101 = +f22;
  d101 = d9 - d101;
  f24 = Math_fround(f23 * f24);
  d97 = +f24;
  d97 = d97 - d8;
  f83 = Math_fround(f25 * f83);
  d100 = +f83;
  d100 = d100 - d5;
  f85 = Math_fround(f84 * f85);
  d99 = +f85;
  d99 = d99 - d3;
  HEAPF64[tempDoublePtr >> 3] = d96;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 104 | 0;
  HEAPF64[tempDoublePtr >> 3] = d97;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 112 | 0;
  HEAPF64[tempDoublePtr >> 3] = d99;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 120 | 0;
  HEAPF64[tempDoublePtr >> 3] = d97;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 128 | 0;
  HEAPF64[tempDoublePtr >> 3] = d98;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 136 | 0;
  HEAPF64[tempDoublePtr >> 3] = d100;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 144 | 0;
  HEAPF64[tempDoublePtr >> 3] = d99;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 152 | 0;
  HEAPF64[tempDoublePtr >> 3] = d100;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 160 | 0;
  HEAPF64[tempDoublePtr >> 3] = d101;
  HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i81 = i80 + 16 | 0;
  HEAPF64[i81 >> 3] = d4;
  STACKTOP = i82;
  return 1;
 }
 f85 = Math_fround(d16 / d15);
 f23 = Math_fround(d17 / d15);
 f25 = Math_fround(d18 / d15);
 f84 = Math_fround(d4);
 f24 = Math_fround(f84 * f85);
 f83 = Math_fround(f84 * f23);
 f84 = Math_fround(f84 * f25);
 f22 = Math_fround(f85 * f24);
 f21 = Math_fround(f23 * f83);
 f20 = Math_fround(f25 * f84);
 f1 = Math_fround(f20 + f21);
 d96 = +f1;
 d96 = d11 - d96;
 f20 = Math_fround(f20 + f22);
 d98 = +f20;
 d98 = d10 - d98;
 f22 = Math_fround(f21 + f22);
 d101 = +f22;
 d101 = d9 - d101;
 f24 = Math_fround(f23 * f24);
 d97 = +f24;
 d97 = d97 - d8;
 f83 = Math_fround(f25 * f83);
 d100 = +f83;
 d100 = d100 - d5;
 f85 = Math_fround(f84 * f85);
 d99 = +f85;
 d99 = d99 - d3;
 HEAPF64[tempDoublePtr >> 3] = d96;
 HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 104 | 0;
 HEAPF64[tempDoublePtr >> 3] = d97;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 112 | 0;
 HEAPF64[tempDoublePtr >> 3] = d99;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 120 | 0;
 HEAPF64[tempDoublePtr >> 3] = d97;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 128 | 0;
 HEAPF64[tempDoublePtr >> 3] = d98;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 136 | 0;
 HEAPF64[tempDoublePtr >> 3] = d100;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 144 | 0;
 HEAPF64[tempDoublePtr >> 3] = d99;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 152 | 0;
 HEAPF64[tempDoublePtr >> 3] = d100;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 160 | 0;
 HEAPF64[tempDoublePtr >> 3] = d101;
 HEAP8[i81 >> 0] = HEAP8[tempDoublePtr >> 0];
 HEAP8[i81 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
 HEAP8[i81 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
 HEAP8[i81 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
 HEAP8[i81 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
 HEAP8[i81 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
 HEAP8[i81 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
 HEAP8[i81 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
 i81 = i80 + 16 | 0;
 HEAPF64[i81 >> 3] = d4;
 STACKTOP = i82;
 return 1;
}

function __ZN5physx23PxVehicleWheels4SimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1568 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i2 + 1536 | 0;
 i50 = i2 + 1504 | 0;
 i49 = i2 + 1472 | 0;
 i48 = i2 + 1440 | 0;
 i47 = i2 + 1408 | 0;
 i46 = i2 + 1376 | 0;
 i45 = i2 + 1344 | 0;
 i44 = i2 + 1312 | 0;
 i43 = i2 + 1280 | 0;
 i42 = i2 + 1248 | 0;
 i41 = i2 + 1216 | 0;
 i40 = i2 + 1184 | 0;
 i39 = i2 + 1152 | 0;
 i38 = i2 + 1120 | 0;
 i37 = i2 + 1088 | 0;
 i36 = i2 + 1056 | 0;
 i35 = i2 + 1024 | 0;
 i34 = i2 + 992 | 0;
 i33 = i2 + 960 | 0;
 i32 = i2 + 928 | 0;
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i51 >> 2] = HEAP32[gb + 164176 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[gb + 164176 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[gb + 164176 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[gb + 164176 + 12 >> 2];
 HEAP32[i51 + 16 >> 2] = HEAP32[gb + 164176 + 16 >> 2];
 HEAP32[i51 + 20 >> 2] = HEAP32[gb + 164176 + 20 >> 2];
 HEAP32[i51 + 24 >> 2] = HEAP32[gb + 164176 + 24 >> 2];
 HEAP32[i51 + 28 >> 2] = HEAP32[gb + 164176 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i51 | 0, 32) | 0;
 HEAP32[i50 >> 2] = HEAP32[gb + 164208 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[gb + 164208 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[gb + 164208 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[gb + 164208 + 12 >> 2];
 HEAP32[i50 + 16 >> 2] = HEAP32[gb + 164208 + 16 >> 2];
 HEAP32[i50 + 20 >> 2] = HEAP32[gb + 164208 + 20 >> 2];
 HEAP32[i50 + 24 >> 2] = HEAP32[gb + 164208 + 24 >> 2];
 HEAP32[i50 + 28 >> 2] = HEAP32[gb + 164208 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i50 | 0, 32) | 0;
 HEAP32[i49 >> 2] = HEAP32[gb + 164240 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[gb + 164240 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[gb + 164240 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[gb + 164240 + 12 >> 2];
 HEAP32[i49 + 16 >> 2] = HEAP32[gb + 164240 + 16 >> 2];
 HEAP32[i49 + 20 >> 2] = HEAP32[gb + 164240 + 20 >> 2];
 HEAP32[i49 + 24 >> 2] = HEAP32[gb + 164240 + 24 >> 2];
 HEAP32[i49 + 28 >> 2] = HEAP32[gb + 164240 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i49 | 0, 32) | 0;
 HEAP32[i48 >> 2] = HEAP32[gb + 164272 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[gb + 164272 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[gb + 164272 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[gb + 164272 + 12 >> 2];
 HEAP32[i48 + 16 >> 2] = HEAP32[gb + 164272 + 16 >> 2];
 HEAP32[i48 + 20 >> 2] = HEAP32[gb + 164272 + 20 >> 2];
 HEAP32[i48 + 24 >> 2] = HEAP32[gb + 164272 + 24 >> 2];
 HEAP32[i48 + 28 >> 2] = HEAP32[gb + 164272 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i48 | 0, 32) | 0;
 HEAP32[i47 >> 2] = HEAP32[gb + 164304 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[gb + 164304 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[gb + 164304 + 8 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[gb + 164304 + 12 >> 2];
 HEAP32[i47 + 16 >> 2] = HEAP32[gb + 164304 + 16 >> 2];
 HEAP32[i47 + 20 >> 2] = HEAP32[gb + 164304 + 20 >> 2];
 HEAP32[i47 + 24 >> 2] = HEAP32[gb + 164304 + 24 >> 2];
 HEAP32[i47 + 28 >> 2] = HEAP32[gb + 164304 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i47 | 0, 32) | 0;
 HEAP32[i46 >> 2] = HEAP32[gb + 164336 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[gb + 164336 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[gb + 164336 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[gb + 164336 + 12 >> 2];
 HEAP32[i46 + 16 >> 2] = HEAP32[gb + 164336 + 16 >> 2];
 HEAP32[i46 + 20 >> 2] = HEAP32[gb + 164336 + 20 >> 2];
 HEAP32[i46 + 24 >> 2] = HEAP32[gb + 164336 + 24 >> 2];
 HEAP32[i46 + 28 >> 2] = HEAP32[gb + 164336 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i46 | 0, 32) | 0;
 HEAP32[i45 >> 2] = HEAP32[gb + 164368 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[gb + 164368 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[gb + 164368 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[gb + 164368 + 12 >> 2];
 HEAP32[i45 + 16 >> 2] = HEAP32[gb + 164368 + 16 >> 2];
 HEAP32[i45 + 20 >> 2] = HEAP32[gb + 164368 + 20 >> 2];
 HEAP32[i45 + 24 >> 2] = HEAP32[gb + 164368 + 24 >> 2];
 HEAP32[i45 + 28 >> 2] = HEAP32[gb + 164368 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i45 | 0, 32) | 0;
 HEAP32[i44 >> 2] = HEAP32[gb + 164400 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[gb + 164400 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[gb + 164400 + 8 >> 2];
 HEAP32[i44 + 12 >> 2] = HEAP32[gb + 164400 + 12 >> 2];
 HEAP32[i44 + 16 >> 2] = HEAP32[gb + 164400 + 16 >> 2];
 HEAP32[i44 + 20 >> 2] = HEAP32[gb + 164400 + 20 >> 2];
 HEAP32[i44 + 24 >> 2] = HEAP32[gb + 164400 + 24 >> 2];
 HEAP32[i44 + 28 >> 2] = HEAP32[gb + 164400 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i44 | 0, 32) | 0;
 HEAP32[i43 >> 2] = HEAP32[gb + 164432 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[gb + 164432 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[gb + 164432 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[gb + 164432 + 12 >> 2];
 HEAP32[i43 + 16 >> 2] = HEAP32[gb + 164432 + 16 >> 2];
 HEAP32[i43 + 20 >> 2] = HEAP32[gb + 164432 + 20 >> 2];
 HEAP32[i43 + 24 >> 2] = HEAP32[gb + 164432 + 24 >> 2];
 HEAP32[i43 + 28 >> 2] = HEAP32[gb + 164432 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i43 | 0, 32) | 0;
 HEAP32[i42 >> 2] = HEAP32[gb + 164464 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[gb + 164464 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[gb + 164464 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[gb + 164464 + 12 >> 2];
 HEAP32[i42 + 16 >> 2] = HEAP32[gb + 164464 + 16 >> 2];
 HEAP32[i42 + 20 >> 2] = HEAP32[gb + 164464 + 20 >> 2];
 HEAP32[i42 + 24 >> 2] = HEAP32[gb + 164464 + 24 >> 2];
 HEAP32[i42 + 28 >> 2] = HEAP32[gb + 164464 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i42 | 0, 32) | 0;
 HEAP32[i41 >> 2] = HEAP32[gb + 164496 >> 2];
 HEAP32[i41 + 4 >> 2] = HEAP32[gb + 164496 + 4 >> 2];
 HEAP32[i41 + 8 >> 2] = HEAP32[gb + 164496 + 8 >> 2];
 HEAP32[i41 + 12 >> 2] = HEAP32[gb + 164496 + 12 >> 2];
 HEAP32[i41 + 16 >> 2] = HEAP32[gb + 164496 + 16 >> 2];
 HEAP32[i41 + 20 >> 2] = HEAP32[gb + 164496 + 20 >> 2];
 HEAP32[i41 + 24 >> 2] = HEAP32[gb + 164496 + 24 >> 2];
 HEAP32[i41 + 28 >> 2] = HEAP32[gb + 164496 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i41 | 0, 32) | 0;
 HEAP32[i40 >> 2] = HEAP32[gb + 164528 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[gb + 164528 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[gb + 164528 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[gb + 164528 + 12 >> 2];
 HEAP32[i40 + 16 >> 2] = HEAP32[gb + 164528 + 16 >> 2];
 HEAP32[i40 + 20 >> 2] = HEAP32[gb + 164528 + 20 >> 2];
 HEAP32[i40 + 24 >> 2] = HEAP32[gb + 164528 + 24 >> 2];
 HEAP32[i40 + 28 >> 2] = HEAP32[gb + 164528 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i40 | 0, 32) | 0;
 HEAP32[i39 >> 2] = HEAP32[gb + 164560 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[gb + 164560 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[gb + 164560 + 8 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[gb + 164560 + 12 >> 2];
 HEAP32[i39 + 16 >> 2] = HEAP32[gb + 164560 + 16 >> 2];
 HEAP32[i39 + 20 >> 2] = HEAP32[gb + 164560 + 20 >> 2];
 HEAP32[i39 + 24 >> 2] = HEAP32[gb + 164560 + 24 >> 2];
 HEAP32[i39 + 28 >> 2] = HEAP32[gb + 164560 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i39 | 0, 32) | 0;
 HEAP32[i38 >> 2] = HEAP32[gb + 164592 >> 2];
 HEAP32[i38 + 4 >> 2] = HEAP32[gb + 164592 + 4 >> 2];
 HEAP32[i38 + 8 >> 2] = HEAP32[gb + 164592 + 8 >> 2];
 HEAP32[i38 + 12 >> 2] = HEAP32[gb + 164592 + 12 >> 2];
 HEAP32[i38 + 16 >> 2] = HEAP32[gb + 164592 + 16 >> 2];
 HEAP32[i38 + 20 >> 2] = HEAP32[gb + 164592 + 20 >> 2];
 HEAP32[i38 + 24 >> 2] = HEAP32[gb + 164592 + 24 >> 2];
 HEAP32[i38 + 28 >> 2] = HEAP32[gb + 164592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i38 | 0, 32) | 0;
 HEAP32[i37 >> 2] = HEAP32[gb + 164624 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[gb + 164624 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[gb + 164624 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[gb + 164624 + 12 >> 2];
 HEAP32[i37 + 16 >> 2] = HEAP32[gb + 164624 + 16 >> 2];
 HEAP32[i37 + 20 >> 2] = HEAP32[gb + 164624 + 20 >> 2];
 HEAP32[i37 + 24 >> 2] = HEAP32[gb + 164624 + 24 >> 2];
 HEAP32[i37 + 28 >> 2] = HEAP32[gb + 164624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i37 | 0, 32) | 0;
 HEAP32[i36 >> 2] = HEAP32[gb + 164656 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[gb + 164656 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[gb + 164656 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[gb + 164656 + 12 >> 2];
 HEAP32[i36 + 16 >> 2] = HEAP32[gb + 164656 + 16 >> 2];
 HEAP32[i36 + 20 >> 2] = HEAP32[gb + 164656 + 20 >> 2];
 HEAP32[i36 + 24 >> 2] = HEAP32[gb + 164656 + 24 >> 2];
 HEAP32[i36 + 28 >> 2] = HEAP32[gb + 164656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i36 | 0, 32) | 0;
 HEAP32[i35 >> 2] = HEAP32[gb + 164688 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[gb + 164688 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[gb + 164688 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[gb + 164688 + 12 >> 2];
 HEAP32[i35 + 16 >> 2] = HEAP32[gb + 164688 + 16 >> 2];
 HEAP32[i35 + 20 >> 2] = HEAP32[gb + 164688 + 20 >> 2];
 HEAP32[i35 + 24 >> 2] = HEAP32[gb + 164688 + 24 >> 2];
 HEAP32[i35 + 28 >> 2] = HEAP32[gb + 164688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i35 | 0, 32) | 0;
 HEAP32[i34 >> 2] = HEAP32[gb + 164720 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[gb + 164720 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[gb + 164720 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[gb + 164720 + 12 >> 2];
 HEAP32[i34 + 16 >> 2] = HEAP32[gb + 164720 + 16 >> 2];
 HEAP32[i34 + 20 >> 2] = HEAP32[gb + 164720 + 20 >> 2];
 HEAP32[i34 + 24 >> 2] = HEAP32[gb + 164720 + 24 >> 2];
 HEAP32[i34 + 28 >> 2] = HEAP32[gb + 164720 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i34 | 0, 32) | 0;
 HEAP32[i33 >> 2] = HEAP32[gb + 164752 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[gb + 164752 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[gb + 164752 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[gb + 164752 + 12 >> 2];
 HEAP32[i33 + 16 >> 2] = HEAP32[gb + 164752 + 16 >> 2];
 HEAP32[i33 + 20 >> 2] = HEAP32[gb + 164752 + 20 >> 2];
 HEAP32[i33 + 24 >> 2] = HEAP32[gb + 164752 + 24 >> 2];
 HEAP32[i33 + 28 >> 2] = HEAP32[gb + 164752 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i33 | 0, 32) | 0;
 HEAP32[i32 >> 2] = HEAP32[gb + 164784 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[gb + 164784 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[gb + 164784 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[gb + 164784 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[gb + 164784 + 16 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[gb + 164784 + 20 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[gb + 164784 + 24 >> 2];
 HEAP32[i32 + 28 >> 2] = HEAP32[gb + 164784 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i32 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 164816 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 164816 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 164816 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 164816 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 164816 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 164816 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 164816 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 164816 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 164848 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 164848 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 164848 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 164848 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 164848 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 164848 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 164848 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 164848 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 164880 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 164880 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 164880 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 164880 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 164880 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 164880 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 164880 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 164880 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 164912 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 164912 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 164912 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 164912 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 164912 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 164912 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 164912 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 164912 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 164944 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 164944 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 164944 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 164944 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 164944 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 164944 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 164944 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 164944 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 164976 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 164976 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 164976 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 164976 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 164976 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 164976 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 164976 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 164976 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 165008 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 165008 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 165008 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 165008 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 165008 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 165008 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 165008 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 165008 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 165040 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 165040 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 165040 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 165040 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 165040 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 165040 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 165040 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 165040 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 165072 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 165072 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 165072 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 165072 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 165072 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 165072 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 165072 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 165072 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 165104 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 165104 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 165104 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 165104 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 165104 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 165104 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 165104 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 165104 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 165136 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 165136 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 165136 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 165136 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 165136 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 165136 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 165136 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 165136 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 165168 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 165168 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 165168 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 165168 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 165168 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 165168 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 165168 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 165168 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 165200 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 165200 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 165200 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 165200 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 165200 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 165200 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 165200 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 165200 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 165232 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 165232 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 165232 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 165232 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 165232 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 165232 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 165232 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 165232 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 165264 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 165264 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 165264 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 165264 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 165264 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 165264 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 165264 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 165264 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 165296 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 165296 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 165296 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 165296 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 165296 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 165296 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 165296 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 165296 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 165328 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 165328 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 165328 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 165328 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 165328 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 165328 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 165328 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 165328 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 165360 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 165360 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 165360 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 165360 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 165360 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 165360 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 165360 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 165360 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 165392 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 165392 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 165392 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 165392 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 165392 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 165392 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 165392 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 165392 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 165424 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 165424 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 165424 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 165424 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 165424 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 165424 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 165424 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 165424 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 165456 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 165456 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 165456 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 165456 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 165456 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 165456 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 165456 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 165456 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 165488 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 165488 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 165488 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 165488 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 165488 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 165488 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 165488 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 165488 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 165520 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 165520 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 165520 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 165520 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 165520 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 165520 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 165520 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 165520 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 165552 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 165552 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 165552 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 165552 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 165552 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 165552 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 165552 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 165552 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 165584 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 165584 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 165584 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 165584 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 165584 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 165584 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 165584 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 165584 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 165616 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 165616 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 165616 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 165616 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 165616 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 165616 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 165616 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 165616 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 165648 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 165648 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 165648 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 165648 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 165648 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 165648 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 165648 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 165648 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 165680 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 165680 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 165680 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 165680 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 165680 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 165680 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 165680 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 165680 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 165712 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 165712 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 165712 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 165712 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 165712 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 165712 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 165712 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 165712 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN14DetailRenderer6RenderEP6Camerafifb(i49, i41, f8, i46, f4, i47) {
 i49 = i49 | 0;
 i41 = i41 | 0;
 f8 = Math_fround(f8);
 i46 = i46 | 0;
 f4 = Math_fround(f4);
 i47 = i47 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i54 + 16 | 0;
 i52 = i54;
 i7 = i54 + 364 | 0;
 i11 = i54 + 360 | 0;
 i48 = i54 + 344 | 0;
 i25 = i54 + 248 | 0;
 i42 = i54 + 232 | 0;
 i53 = i54 + 120 | 0;
 i43 = i54 + 56 | 0;
 i44 = i54 + 40 | 0;
 i45 = i54 + 356 | 0;
 i5 = f4 < Math_fround(0.0);
 i1 = f4 > Math_fround(1.0);
 f9 = i1 ? Math_fround(1.0) : f4;
 f9 = i5 ? Math_fround(0.0) : f9;
 i5 = i49 + 12 | 0;
 HEAP32[i52 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i51, i1, i52);
   i2 = HEAP32[i51 >> 2] | 0;
   i50 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i50 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i50 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 8;
  }
 }
 if ((i6 | 0) == 6) i6 = 8;
 if ((i6 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i36 = i1 + 128 | 0;
 if (__Z14IsWorldPlayingv() | 0) {
  f4 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
  f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i36 + 76 >> 2])) * Math_fround(.0500000007));
 } else f4 = Math_fround(0.0);
 i40 = i49 + 116 | 0;
 HEAPF32[i40 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i40 >> 2]));
 i50 = i49 + 112 | 0;
 HEAP32[i50 >> 2] = (HEAP32[i50 >> 2] | 0) + 1;
 HEAP32[i52 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i51, i1, i52);
   i2 = HEAP32[i51 >> 2] | 0;
   i39 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i39 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i39 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 18;
  }
 }
 if ((i6 | 0) == 16) i6 = 18;
 if ((i6 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i3 = i1 + 248 | 0;
 f10 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f10 = Math_fround(f10 * Math_fround((HEAP32[i3 + 72 >> 2] | 0) + -1 | 0));
 i5 = HEAP32[i3 + 92 >> 2] | 0;
 f37 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f37 = Math_fround(f37 * Math_fround((HEAP32[i3 + 76 >> 2] | 0) + -1 | 0));
 i3 = i49 + 16 | 0;
 HEAPF32[i3 >> 2] = f10;
 HEAP32[i49 + 20 >> 2] = i5;
 i5 = i49 + 24 | 0;
 HEAPF32[i5 >> 2] = f37;
 i23 = i36 + 36 | 0;
 i17 = HEAP32[i23 >> 2] | 0;
 if (!i17) {
  STACKTOP = i54;
  return;
 }
 if (HEAP8[i36 >> 0] | 0) __ZN14DetailDatabase17RefreshPrototypesEv(i36);
 i2 = i36 + 56 | 0;
 i39 = HEAP32[i49 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1467616 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i7 >> 2];
 if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i39, i51) | 0) {
  i38 = HEAP32[i49 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[gb + 1467616 >> 2];
  i39 = HEAP32[i2 >> 2] | 0;
  HEAP32[i51 >> 2] = HEAP32[i11 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i38, i51, i39);
 }
 i1 = i49 + 4 | 0;
 i39 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1467616 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i7 >> 2];
 if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i39, i51) | 0) {
  i38 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[gb + 1467616 >> 2];
  i39 = HEAP32[i2 >> 2] | 0;
  HEAP32[i51 >> 2] = HEAP32[i11 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i38, i51, i39);
 }
 i1 = i49 + 8 | 0;
 i39 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1467616 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i7 >> 2];
 if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i39, i51) | 0) {
  i38 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[gb + 1467616 >> 2];
  i39 = HEAP32[i2 >> 2] | 0;
  HEAP32[i51 >> 2] = HEAP32[i11 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i38, i51, i39);
 }
 i24 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i41 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i51, i24);
 i28 = i49 + 100 | 0;
 f55 = Math_fround(HEAPF32[i51 >> 2]);
 f55 = Math_fround(f55 - Math_fround(HEAPF32[i28 >> 2]));
 f10 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 i21 = i49 + 104 | 0;
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 >> 2]));
 f56 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 i22 = i49 + 108 | 0;
 f56 = Math_fround(f56 - Math_fround(HEAPF32[i22 >> 2]));
 HEAPF32[i48 >> 2] = f55;
 i38 = i48 + 4 | 0;
 HEAPF32[i38 >> 2] = f10;
 i39 = i48 + 8 | 0;
 HEAPF32[i39 >> 2] = f56;
 f10 = Math_fround(i17 | 0);
 f55 = Math_fround(f10 * f55);
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f55 = Math_fround(Math_fround(f55 / f4) + Math_fround(.5));
 i34 = f55 >= Math_fround(0.0);
 f37 = Math_fround(f55 + Math_fround(-.99999994));
 i34 = ~~(i34 ? f55 : f37);
 f56 = Math_fround(f10 * f56);
 f37 = Math_fround(HEAPF32[i5 >> 2]);
 f56 = Math_fround(Math_fround(f56 / f37) + Math_fround(.5));
 i35 = f56 >= Math_fround(0.0);
 f55 = Math_fround(f56 + Math_fround(-.99999994));
 i35 = ~~(i35 ? f56 : f55);
 f10 = Math_fround(f10 * f8);
 i18 = ~~Math_fround(Math_fround(Math_ceil(Math_fround(f10 / f4))) + Math_fround(1.0));
 i19 = ~~Math_fround(Math_fround(Math_ceil(Math_fround(f10 / f37))) + Math_fround(1.0));
 i16 = i34 - i18 | 0;
 i16 = (i16 | 0) < 0 ? 0 : i16;
 i20 = i17 + -1 | 0;
 i1 = i35 - i19 | 0;
 i1 = (i1 | 0) < 0 ? 0 : i1;
 i18 = i34 + i18 | 0;
 i18 = (i18 | 0) < 0 ? 0 : i18;
 i19 = i35 + i19 | 0;
 i19 = (i19 | 0) < 0 ? 0 : i19;
 i19 = (i19 | 0) < (i17 | 0) ? i19 : i20;
 i16 = (i16 | 0) < (i17 | 0) ? i16 : i20;
 i1 = (i1 | 0) < (i17 | 0) ? i1 : i20;
 i20 = (i18 | 0) < (i17 | 0) ? i18 : i20;
 f37 = Math_fround(f8 * f8);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(__ZNK6Camera20GetWorldToClipMatrixEv(i41) | 0, i25);
 i18 = __ZNK6Shader11IsSupportedEv(__ZN8Material9GetShaderEv(HEAP32[i49 >> 2] | 0) | 0) | 0;
 if (i47) {
  if ((i1 | 0) <= (i19 | 0)) {
   i6 = (i16 | 0) > (i20 | 0);
   i7 = i36 + 4 | 0;
   i11 = i51 + 4 | 0;
   i12 = i51 + 8 | 0;
   i13 = i51 + 12 | 0;
   i14 = i51 + 16 | 0;
   i15 = i51 + 20 | 0;
   while (1) {
    if (!i6) {
     i5 = i16;
     while (1) {
      i35 = (Math_imul(HEAP32[i23 >> 2] | 0, i1) | 0) + i5 | 0;
      i34 = HEAP32[i7 >> 2] | 0;
      L51 : do if ((HEAP32[i34 + (i35 * 52 | 0) + 40 >> 2] | 0) != (HEAP32[i34 + (i35 * 52 | 0) + 44 >> 2] | 0)) {
       if (i18) {
        i3 = 0;
        while (1) {
         i2 = __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef(i49, i5, i1, i3, f9) | 0;
         if (!(HEAP8[i2 + 5 >> 0] | 0)) {
          i35 = HEAP32[i2 >> 2] | 0;
          HEAP32[i51 >> 2] = HEAP32[i35 + 48 >> 2];
          HEAP32[i11 >> 2] = HEAP32[i35 + 52 >> 2];
          HEAP32[i12 >> 2] = HEAP32[i35 + 56 >> 2];
          HEAP32[i13 >> 2] = HEAP32[i35 + 60 >> 2];
          HEAP32[i14 >> 2] = HEAP32[i35 + 64 >> 2];
          HEAP32[i15 >> 2] = HEAP32[i35 + 68 >> 2];
          i2 = i2 + 4 | 0;
          HEAP8[i2 >> 0] = 1;
          do if (Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i48, i51)) > f37) HEAP8[i2 >> 0] = 0; else {
           f56 = Math_fround(HEAPF32[i28 >> 2]);
           HEAPF32[i51 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i51 >> 2]));
           f56 = Math_fround(HEAPF32[i21 >> 2]);
           HEAPF32[i11 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i11 >> 2]));
           f56 = Math_fround(HEAPF32[i22 >> 2]);
           HEAPF32[i12 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i12 >> 2]));
           if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i51, i25) | 0) break;
           HEAP8[i2 >> 0] = 0;
          } while (0);
         } else HEAP8[i2 + 4 >> 0] = 0;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == 3) break L51;
        }
       } else i3 = 0;
       while (1) {
        if (!i3) {
         i3 = 1;
         continue;
        }
        i2 = __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef(i49, i5, i1, i3, f9) | 0;
        if (!(HEAP8[i2 + 5 >> 0] | 0)) {
         i35 = HEAP32[i2 >> 2] | 0;
         HEAP32[i51 >> 2] = HEAP32[i35 + 48 >> 2];
         HEAP32[i11 >> 2] = HEAP32[i35 + 52 >> 2];
         HEAP32[i12 >> 2] = HEAP32[i35 + 56 >> 2];
         HEAP32[i13 >> 2] = HEAP32[i35 + 60 >> 2];
         HEAP32[i14 >> 2] = HEAP32[i35 + 64 >> 2];
         HEAP32[i15 >> 2] = HEAP32[i35 + 68 >> 2];
         i2 = i2 + 4 | 0;
         HEAP8[i2 >> 0] = 1;
         do if (Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i48, i51)) > f37) HEAP8[i2 >> 0] = 0; else {
          f56 = Math_fround(HEAPF32[i28 >> 2]);
          HEAPF32[i51 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i51 >> 2]));
          f56 = Math_fround(HEAPF32[i21 >> 2]);
          HEAPF32[i11 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i11 >> 2]));
          f56 = Math_fround(HEAPF32[i22 >> 2]);
          HEAPF32[i12 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i12 >> 2]));
          if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i51, i25) | 0) break;
          HEAP8[i2 >> 0] = 0;
         } while (0);
        } else HEAP8[i2 + 4 >> 0] = 0;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == 3) break;
       }
      } while (0);
      if ((i5 | 0) < (i20 | 0)) i5 = i5 + 1 | 0; else break;
     }
    }
    if ((i1 | 0) < (i19 | 0)) i1 = i1 + 1 | 0; else break;
   }
  }
 } else if ((i17 | 0) > 0) {
  i6 = i36 + 4 | 0;
  i7 = i51 + 4 | 0;
  i11 = i51 + 8 | 0;
  i12 = i51 + 12 | 0;
  i13 = i51 + 16 | 0;
  i14 = i51 + 20 | 0;
  i5 = 0;
  do {
   i15 = (i5 | 0) > (i19 | 0);
   i3 = 0;
   do {
    i35 = (Math_imul(HEAP32[i23 >> 2] | 0, i5) | 0) + i3 | 0;
    i34 = HEAP32[i6 >> 2] | 0;
    L85 : do if ((HEAP32[i34 + (i35 * 52 | 0) + 40 >> 2] | 0) != (HEAP32[i34 + (i35 * 52 | 0) + 44 >> 2] | 0)) {
     i16 = i15 | (i3 | 0) > (i20 | 0);
     if (i18) {
      i2 = 0;
      while (1) {
       i1 = __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef(i49, i3, i5, i2, f9) | 0;
       do if (i16) HEAP8[i1 + 4 >> 0] = 0; else {
        if (HEAP8[i1 + 5 >> 0] | 0) {
         HEAP8[i1 + 4 >> 0] = 0;
         break;
        }
        i35 = HEAP32[i1 >> 2] | 0;
        HEAP32[i51 >> 2] = HEAP32[i35 + 48 >> 2];
        HEAP32[i7 >> 2] = HEAP32[i35 + 52 >> 2];
        HEAP32[i11 >> 2] = HEAP32[i35 + 56 >> 2];
        HEAP32[i12 >> 2] = HEAP32[i35 + 60 >> 2];
        HEAP32[i13 >> 2] = HEAP32[i35 + 64 >> 2];
        HEAP32[i14 >> 2] = HEAP32[i35 + 68 >> 2];
        i1 = i1 + 4 | 0;
        HEAP8[i1 >> 0] = 1;
        do if (Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i48, i51)) > f37) HEAP8[i1 >> 0] = 0; else {
         f56 = Math_fround(HEAPF32[i28 >> 2]);
         HEAPF32[i51 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i51 >> 2]));
         f56 = Math_fround(HEAPF32[i21 >> 2]);
         HEAPF32[i7 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i7 >> 2]));
         f56 = Math_fround(HEAPF32[i22 >> 2]);
         HEAPF32[i11 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i11 >> 2]));
         if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i51, i25) | 0) break;
         HEAP8[i1 >> 0] = 0;
        } while (0);
       } while (0);
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == 3) break L85;
      }
     } else i2 = 0;
     while (1) {
      if (!i2) {
       i2 = 1;
       continue;
      }
      i1 = __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef(i49, i3, i5, i2, f9) | 0;
      do if (i16) HEAP8[i1 + 4 >> 0] = 0; else {
       if (HEAP8[i1 + 5 >> 0] | 0) {
        HEAP8[i1 + 4 >> 0] = 0;
        break;
       }
       i35 = HEAP32[i1 >> 2] | 0;
       HEAP32[i51 >> 2] = HEAP32[i35 + 48 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i35 + 52 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i35 + 56 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i35 + 60 >> 2];
       HEAP32[i13 >> 2] = HEAP32[i35 + 64 >> 2];
       HEAP32[i14 >> 2] = HEAP32[i35 + 68 >> 2];
       i1 = i1 + 4 | 0;
       HEAP8[i1 >> 0] = 1;
       do if (Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i48, i51)) > f37) HEAP8[i1 >> 0] = 0; else {
        f56 = Math_fround(HEAPF32[i28 >> 2]);
        HEAPF32[i51 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i51 >> 2]));
        f56 = Math_fround(HEAPF32[i21 >> 2]);
        HEAPF32[i7 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i7 >> 2]));
        f56 = Math_fround(HEAPF32[i22 >> 2]);
        HEAPF32[i11 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i11 >> 2]));
        if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i51, i25) | 0) break;
        HEAP8[i1 >> 0] = 0;
       } while (0);
      } while (0);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 3) break;
     }
    } while (0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i17 | 0));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i17 | 0));
 }
 HEAPF32[i51 >> 2] = Math_fround(0.0);
 HEAPF32[i51 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i51 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i42, i24, i51);
 i26 = i42 + 8 | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 __ZNK9Transform18TransformDirectionERK8Vector3f(i51, i24, i42);
 HEAP32[i42 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
 f4 = Math_fround(HEAPF32[i42 >> 2]);
 f10 = Math_fround(f4 * f4);
 i27 = i42 + 4 | 0;
 f8 = Math_fround(HEAPF32[i27 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f8 * f8));
 f9 = Math_fround(HEAPF32[i26 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9))));
 if (f10 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f56 = Math_fround(f4 / f10);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  f56 = Math_fround(f8 / f10);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  f56 = Math_fround(f9 / f10);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = HEAP32[gb + 1162364 >> 2] | 0;
  i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 HEAP32[i42 >> 2] = i1;
 HEAP32[i27 >> 2] = i2;
 HEAP32[i26 >> 2] = i3;
 HEAP32[i53 + 4 >> 2] = 1;
 HEAP32[i53 >> 2] = gb + 33952 + 8;
 i32 = gb + 64016 | 0;
 i35 = HEAP32[i32 + 4 >> 2] | 0;
 i34 = i52;
 HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 HEAP32[i53 + 32 >> 2] = 0;
 HEAP32[i53 + 44 >> 2] = 0;
 i34 = i53 + 48 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i53 + 36 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i52);
 i32 = i51;
 i33 = HEAP32[i32 + 4 >> 2] | 0;
 i29 = i35;
 HEAP32[i29 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i29 + 4 >> 2] = i33;
 i29 = gb + 64016 | 0;
 i33 = HEAP32[i29 + 4 >> 2] | 0;
 i32 = i52;
 HEAP32[i32 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i32 + 4 >> 2] = i33;
 HEAP32[i53 + 52 >> 2] = 0;
 HEAP32[i53 + 64 >> 2] = 0;
 i32 = i53 + 68 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i53 + 56 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i52);
 i29 = i51;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 i31 = i33;
 HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i31 + 4 >> 2] = i30;
 i31 = gb + 64016 | 0;
 i30 = HEAP32[i31 + 4 >> 2] | 0;
 i29 = i52;
 HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i29 + 4 >> 2] = i30;
 i29 = i53 + 72 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i53 + 84 >> 2] = 0;
 i30 = i53 + 88 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i53 + 76 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i52);
 i25 = i51;
 i23 = HEAP32[i25 + 4 >> 2] | 0;
 i22 = i31;
 HEAP32[i22 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 HEAP32[i53 + 92 >> 2] = 0;
 HEAP32[i53 + 96 >> 2] = 0;
 i22 = gb + 64016 | 0;
 i23 = HEAP32[i22 + 4 >> 2] | 0;
 i25 = i53 + 100 | 0;
 HEAP32[i25 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i25 + 4 >> 2] = i23;
 HEAP8[i53 + 108 >> 0] = 1;
 i25 = i53 + 8 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAP32[i25 + 16 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i53, 6);
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 8 >> 2] = Math_fround(-1.0);
 __ZNK9Transform18TransformDirectionERK8Vector3f(i51, i24, i52);
 f10 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 f4 = Math_fround(f10 * f8);
 f57 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 f55 = Math_fround(HEAPF32[i27 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f57 * f55));
 f9 = Math_fround(HEAPF32[i42 >> 2]);
 f57 = Math_fround(f57 * f9);
 f56 = Math_fround(HEAPF32[i51 >> 2]);
 f8 = Math_fround(f57 - Math_fround(f8 * f56));
 f9 = Math_fround(Math_fround(f55 * f56) - Math_fround(f10 * f9));
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f4 * f4) + Math_fround(f8 * f8)))));
 if (f10 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f57 = Math_fround(f4 / f10);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  f57 = Math_fround(f8 / f10);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
  f57 = Math_fround(f9 / f10);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i23 = HEAP32[gb + 1162364 >> 2] | 0;
  i24 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i25 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i43, i28) | 0;
 i17 = i52 + 4 | 0;
 i18 = i52 + 8 | 0;
 f8 = Math_fround(Math_fround(1.0) / f37);
 i19 = i52 + 12 | 0;
 i20 = i36 + 84 | 0;
 i21 = i36 + 60 | 0;
 i22 = i49 + 28 | 0;
 i7 = i36 + 80 | 0;
 i11 = i49 + 32 | 0;
 i12 = i22 + 2 | 0;
 i13 = i49 + 48 | 0;
 i14 = i49 + 32 | 0;
 i15 = i22 + 2 | 0;
 i16 = i49 + 48 | 0;
 i6 = 0;
 do {
  i1 = HEAP32[i49 + (i6 << 2) >> 2] | 0;
  __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i53, gb + 1467620 | 0, f37, 0);
  HEAP32[i52 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i39 >> 2];
  HEAPF32[i19 >> 2] = f8;
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i53, gb + 1467624 | 0, i52, 0);
  HEAP32[i52 >> 2] = HEAP32[i40 >> 2];
  HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(.400000006));
  if ((i6 | 0) == 1) f4 = Math_fround(0.0); else f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(6.0));
  HEAPF32[i18 >> 2] = f4;
  HEAPF32[i19 >> 2] = f37;
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i53, gb + 1467628 | 0, i52, 0);
  HEAP32[i44 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i44 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i53, gb + 1467632 | 0, i44, 1);
  HEAP32[i52 >> 2] = i23;
  HEAP32[i17 >> 2] = i24;
  HEAP32[i18 >> 2] = i25;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i53, gb + 1467636 | 0, i52, 0);
  HEAP32[i52 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i26 >> 2];
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i53, gb + 1467640 | 0, i52, 0);
  __ZN19ShaderPropertySheet11ComputeHashEv(i53);
  i2 = HEAP32[i49 + 64 + (i6 * 12 | 0) >> 2] | 0;
  i5 = i49 + 64 + (i6 * 12 | 0) + 4 | 0;
  if ((i2 | 0) != (i5 | 0)) {
   i3 = i1 + 4 | 0;
   if (!i1) while (1) {
    if (HEAP8[i2 + 24 >> 0] | 0) {
     i36 = HEAP32[i2 + 20 >> 2] | 0;
     HEAP32[i45 >> 2] = 0;
     HEAP32[i51 >> 2] = HEAP32[i45 >> 2];
     i36 = __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i43, i36, i51, i46, 0, 1, 0, i41) | 0;
     __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i36, i53);
     i28 = HEAP16[i22 >> 1] | 0;
     __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType(i36, i28 << 16 >> 16 == -1 ? -1 : i28 & 65535, 0);
     __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i36, i11, 0);
     i28 = HEAP16[i12 >> 1] | 0;
     __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType(i36, i28 << 16 >> 16 == -1 ? -1 : i28 & 65535, 1);
     __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i36, i13, 1);
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   } else do {
    if (HEAP8[i2 + 24 >> 0] | 0) {
     i36 = HEAP32[i2 + 20 >> 2] | 0;
     HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i51 >> 2] = HEAP32[i45 >> 2];
     i36 = __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i43, i36, i51, i46, 0, 1, 0, i41) | 0;
     __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i36, i53);
     i28 = HEAP16[i22 >> 1] | 0;
     __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType(i36, i28 << 16 >> 16 == -1 ? -1 : i28 & 65535, 0);
     __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i36, i14, 0);
     i28 = HEAP16[i15 >> 1] | 0;
     __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType(i36, i28 << 16 >> 16 == -1 ? -1 : i28 & 65535, 1);
     __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i36, i16, 1);
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
      i2 = i1;
      break;
     } else i2 = i1;
    } else {
     i2 = i1;
     while (1) {
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break; else i2 = i1;
     }
    }
   } while ((i2 | 0) != (i5 | 0));
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 3);
 if (i47) {
  i6 = i49 + 64 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i49 + 68 | 0;
  i2 = i1;
  if ((i2 | 0) != (i7 | 0)) {
   i5 = i2;
   while (1) {
    i2 = HEAP32[i5 + 4 >> 2] | 0;
    if (!i2) {
     i3 = i1;
     while (1) {
      i2 = HEAP32[i3 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
     }
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((HEAP32[i5 + 28 >> 2] | 0) < (HEAP32[i50 >> 2] | 0)) {
     HEAP32[i52 >> 2] = i1;
     HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
     __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i6, i51) | 0;
    }
    if ((i2 | 0) == (i7 | 0)) break; else {
     i1 = i2;
     i5 = i2;
    }
   }
  }
  i6 = i49 + 76 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i49 + 80 | 0;
  i2 = i1;
  if ((i2 | 0) != (i7 | 0)) {
   i5 = i2;
   while (1) {
    i2 = HEAP32[i5 + 4 >> 2] | 0;
    if (!i2) {
     i3 = i1;
     while (1) {
      i2 = HEAP32[i3 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
     }
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((HEAP32[i5 + 28 >> 2] | 0) < (HEAP32[i50 >> 2] | 0)) {
     HEAP32[i52 >> 2] = i1;
     HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
     __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i6, i51) | 0;
    }
    if ((i2 | 0) == (i7 | 0)) break; else {
     i1 = i2;
     i5 = i2;
    }
   }
  }
  i7 = i49 + 88 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = i49 + 92 | 0;
  i2 = i1;
  if ((i2 | 0) != (i6 | 0)) {
   i5 = i1;
   while (1) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i3 = i5;
     while (1) {
      i1 = HEAP32[i3 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break; else i3 = i1;
     }
    } else while (1) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) break; else i1 = i3;
    }
    if ((HEAP32[i2 + 28 >> 2] | 0) < (HEAP32[i50 >> 2] | 0)) {
     HEAP32[i52 >> 2] = i5;
     HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
     __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i7, i51) | 0;
    }
    if ((i1 | 0) == (i6 | 0)) break; else {
     i5 = i1;
     i2 = i1;
    }
   }
  }
 }
 HEAP32[i53 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i30 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i31);
  HEAP32[i29 >> 2] = 0;
 }
 i1 = i53 + 52 | 0;
 if ((HEAP32[i32 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i33);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i53 + 32 | 0;
 if ((HEAP32[i34 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i35);
  HEAP32[i1 >> 2] = 0;
 }
 STACKTOP = i54;
 return;
}

function __ZN7mecanim9animation11SetIKOnFeetEbRKNS0_14AvatarConstantERKNS0_11AvatarInputERNS0_12AvatarMemoryERNS0_15AvatarWorkspaceERNS0_12AvatarOutputE(i30, i2, i1, i6, i3, i5) {
 i30 = i30 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0;
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 i21 = (HEAP8[i1 + 16 >> 0] | 0) == 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f27 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f28 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f29 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 i25 = i2 + 20 | 0;
 i26 = i25;
 f34 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f11 = Math_fround(f34 - f11);
 f13 = Math_fround(f9 - f13);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) - f12);
 f9 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f9 * Math_fround(-2.0));
 f31 = Math_fround(f9 * Math_fround(2.0));
 f35 = Math_fround(f7 * f14);
 f8 = Math_fround(f32 * Math_fround(2.0));
 f33 = Math_fround(f32 * Math_fround(-2.0));
 f37 = Math_fround(f7 * f33);
 f10 = Math_fround(f34 * Math_fround(-2.0));
 f36 = Math_fround(f34 * Math_fround(2.0));
 f4 = Math_fround(f7 * f10);
 f15 = Math_fround(Math_fround(f11 + Math_fround(Math_fround(Math_fround(f9 * f14) - Math_fround(f32 * f8)) * f11)) + Math_fround(Math_fround(Math_fround(f37 - Math_fround(f9 * f10)) * f13) + Math_fround(Math_fround(Math_fround(f36 * f32) - f35) * f12)));
 f14 = Math_fround(Math_fround(f13 + Math_fround(Math_fround(Math_fround(f34 * f31) - f37) * f11)) + Math_fround(Math_fround(Math_fround(Math_fround(f32 * f33) - Math_fround(f34 * f36)) * f13) + Math_fround(Math_fround(f4 - Math_fround(f32 * f14)) * f12)));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f35 - Math_fround(f34 * f33)) * f11) + f12) + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f8) - f4) * f13) + Math_fround(Math_fround(Math_fround(f34 * f10) - Math_fround(f9 * f31)) * f12)));
 f31 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f10 = Math_fround(f9 * f31);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f4 = Math_fround(f7 * f13);
 f8 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f11 = Math_fround(f32 * f8);
 f33 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f7 * f33)) - Math_fround(f32 * f13)) - Math_fround(f34 * f8));
 f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f34 * f31)) - Math_fround(f32 * f33)) - Math_fround(f9 * f8));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f9 * f33)) - Math_fround(f7 * f31)) - Math_fround(f34 * f13));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f33) - Math_fround(f32 * f31)) - Math_fround(f7 * f8)) - Math_fround(f9 * f13));
 i23 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i24 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f12 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))))) / f22);
 f14 = (HEAP32[tempDoublePtr >> 2] = i1 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_fround(+Math_atan(+Math_fround(f14 / f4))) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(+Math_atan(+Math_fround(f15 / f4))) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(+Math_atan(+Math_fround((HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f4))) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f4 * f4) + Math_fround(0.0))))) / f22);
 i23 = i30 & 1 ^ 1;
 i24 = i5 + 24 | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 HEAPF32[i1 + 68 + (i23 << 6) + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 68 + (i23 << 6) + 44 >> 2] = Math_fround(1.0);
 if (i21) {
  i24 = i1;
  f31 = i30 ? Math_fround(-1.0) : Math_fround(1.0);
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i26 | 0;
  i26 = i25 + 360 | 0;
  f14 = Math_fround(HEAPF32[i26 >> 2]);
  f14 = Math_fround(f31 * f14);
  i25 = i25 + 388 | 0;
  f31 = Math_fround(HEAPF32[i25 >> 2]);
  f31 = Math_fround(f14 * f31);
  i25 = i24 + 68 + (i23 << 6) + 16 | 0;
  f14 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 12 | 0;
  f13 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 24 | 0;
  f37 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 20 | 0;
  f15 = Math_fround(HEAPF32[i25 >> 2]);
  f32 = Math_fround(f14 * Math_fround(-2.0));
  f33 = Math_fround(f14 * Math_fround(2.0));
  f22 = Math_fround(f14 * f32);
  f32 = Math_fround(f32 * f37);
  f11 = Math_fround(f15 * Math_fround(2.0));
  f34 = Math_fround(f15 * Math_fround(-2.0));
  f36 = Math_fround(f15 * f11);
  f10 = Math_fround(f37 * f34);
  f34 = Math_fround(f13 * f34);
  f36 = Math_fround(f22 - f36);
  f34 = Math_fround(f32 - f34);
  f11 = Math_fround(f14 * f11);
  f22 = Math_fround(f13 * Math_fround(-2.0));
  f12 = Math_fround(f13 * Math_fround(2.0));
  f35 = Math_fround(f14 * f22);
  f37 = Math_fround(f37 * f22);
  f35 = Math_fround(f10 - f35);
  f37 = Math_fround(f11 - f37);
  f15 = Math_fround(f12 * f15);
  f22 = Math_fround(f13 * f22);
  f33 = Math_fround(f14 * f33);
  f32 = Math_fround(f15 - f32);
  f33 = Math_fround(f22 - f33);
  f36 = Math_fround(f36 * Math_fround(0.0));
  f34 = Math_fround(f34 * Math_fround(0.0));
  f36 = Math_fround(f36 + Math_fround(0.0));
  f34 = Math_fround(f31 + f34);
  f35 = Math_fround(f35 * Math_fround(0.0));
  f37 = Math_fround(f37 * Math_fround(0.0));
  f32 = Math_fround(f31 * f32);
  f33 = Math_fround(f31 * f33);
  f35 = Math_fround(f32 + f35);
  f37 = Math_fround(f33 + f37);
  f35 = Math_fround(f36 + f35);
  f37 = Math_fround(f34 + f37);
  f35 = Math_fround(f27 * f35);
  f34 = Math_fround(f28 * Math_fround(0.0));
  f37 = Math_fround(f29 * f37);
  i25 = i24 + 68 + (i23 << 6) | 0;
  f36 = Math_fround(HEAPF32[i25 >> 2]);
  f35 = Math_fround(f36 + f35);
  i26 = i24 + 68 + (i23 << 6) + 4 | 0;
  f36 = Math_fround(HEAPF32[i26 >> 2]);
  f36 = Math_fround(f34 + f36);
  i30 = i24 + 68 + (i23 << 6) + 8 | 0;
  f34 = Math_fround(HEAPF32[i30 >> 2]);
  f37 = Math_fround(f34 + f37);
  HEAPF32[i25 >> 2] = f35;
  HEAPF32[i26 >> 2] = f36;
  HEAPF32[i30 >> 2] = f37;
  return;
 }
 if (HEAP8[i6 + 136 >> 0] | 0) {
  i24 = i1;
  f31 = i30 ? Math_fround(-1.0) : Math_fround(1.0);
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i26 | 0;
  i26 = i25 + 360 | 0;
  f14 = Math_fround(HEAPF32[i26 >> 2]);
  f14 = Math_fround(f31 * f14);
  i25 = i25 + 388 | 0;
  f31 = Math_fround(HEAPF32[i25 >> 2]);
  f31 = Math_fround(f14 * f31);
  i25 = i24 + 68 + (i23 << 6) + 16 | 0;
  f14 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 12 | 0;
  f13 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 24 | 0;
  f37 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i24 + 68 + (i23 << 6) + 20 | 0;
  f15 = Math_fround(HEAPF32[i25 >> 2]);
  f32 = Math_fround(f14 * Math_fround(-2.0));
  f33 = Math_fround(f14 * Math_fround(2.0));
  f22 = Math_fround(f14 * f32);
  f32 = Math_fround(f32 * f37);
  f11 = Math_fround(f15 * Math_fround(2.0));
  f34 = Math_fround(f15 * Math_fround(-2.0));
  f36 = Math_fround(f15 * f11);
  f10 = Math_fround(f37 * f34);
  f34 = Math_fround(f13 * f34);
  f36 = Math_fround(f22 - f36);
  f34 = Math_fround(f32 - f34);
  f11 = Math_fround(f14 * f11);
  f22 = Math_fround(f13 * Math_fround(-2.0));
  f12 = Math_fround(f13 * Math_fround(2.0));
  f35 = Math_fround(f14 * f22);
  f37 = Math_fround(f37 * f22);
  f35 = Math_fround(f10 - f35);
  f37 = Math_fround(f11 - f37);
  f15 = Math_fround(f12 * f15);
  f22 = Math_fround(f13 * f22);
  f33 = Math_fround(f14 * f33);
  f32 = Math_fround(f15 - f32);
  f33 = Math_fround(f22 - f33);
  f36 = Math_fround(f36 * Math_fround(0.0));
  f34 = Math_fround(f34 * Math_fround(0.0));
  f36 = Math_fround(f36 + Math_fround(0.0));
  f34 = Math_fround(f31 + f34);
  f35 = Math_fround(f35 * Math_fround(0.0));
  f37 = Math_fround(f37 * Math_fround(0.0));
  f32 = Math_fround(f31 * f32);
  f33 = Math_fround(f31 * f33);
  f35 = Math_fround(f32 + f35);
  f37 = Math_fround(f33 + f37);
  f35 = Math_fround(f36 + f35);
  f37 = Math_fround(f34 + f37);
  f35 = Math_fround(f27 * f35);
  f34 = Math_fround(f28 * Math_fround(0.0));
  f37 = Math_fround(f29 * f37);
  i25 = i24 + 68 + (i23 << 6) | 0;
  f36 = Math_fround(HEAPF32[i25 >> 2]);
  f35 = Math_fround(f36 + f35);
  i26 = i24 + 68 + (i23 << 6) + 4 | 0;
  f36 = Math_fround(HEAPF32[i26 >> 2]);
  f36 = Math_fround(f34 + f36);
  i30 = i24 + 68 + (i23 << 6) + 8 | 0;
  f34 = Math_fround(HEAPF32[i30 >> 2]);
  f37 = Math_fround(f34 + f37);
  HEAPF32[i25 >> 2] = f35;
  HEAPF32[i26 >> 2] = f36;
  HEAPF32[i30 >> 2] = f37;
  return;
 }
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 f15 = Math_fround(f4 + Math_fround(HEAPF32[(i30 ? i5 + 272 | 0 : i5 + 280 | 0) >> 2]));
 i21 = i30 ? i6 + 40 | 0 : i6 + 80 | 0;
 f14 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 12 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 20 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 68 + (i23 << 6) + 24 >> 2]);
 i17 = i21 + 12 | 0;
 i18 = i21 + 16 | 0;
 i19 = i21 + 20 | 0;
 i20 = i21 + 24 | 0;
 f34 = Math_fround(HEAPF32[i20 >> 2]);
 f42 = Math_fround(HEAPF32[i21 >> 2]);
 i6 = i21 + 4 | 0;
 f39 = Math_fround(HEAPF32[i6 >> 2]);
 i16 = i21 + 8 | 0;
 f7 = Math_fround(HEAPF32[i16 >> 2]);
 f42 = Math_fround(f14 - f42);
 f39 = Math_fround(f9 - f39);
 f10 = Math_fround(f10 - f7);
 f9 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i18 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i17 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i19 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f9 * Math_fround(-2.0));
 f36 = Math_fround(f9 * Math_fround(2.0));
 f41 = Math_fround(f34 * f11);
 f38 = Math_fround(f32 * Math_fround(2.0));
 f40 = Math_fround(f32 * Math_fround(-2.0));
 f44 = Math_fround(f34 * f40);
 f4 = Math_fround(f14 * Math_fround(-2.0));
 f43 = Math_fround(f14 * Math_fround(2.0));
 f37 = Math_fround(f34 * f4);
 f8 = Math_fround(Math_fround(f42 + Math_fround(f42 * Math_fround(Math_fround(f9 * f11) - Math_fround(f32 * f38)))) + Math_fround(Math_fround(f39 * Math_fround(f44 - Math_fround(f9 * f4))) + Math_fround(Math_fround(Math_fround(f43 * f32) - f41) * f10)));
 f11 = Math_fround(Math_fround(f39 + Math_fround(f42 * Math_fround(Math_fround(f14 * f36) - f44))) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f32 * f40) - Math_fround(f14 * f43))) + Math_fround(Math_fround(f37 - Math_fround(f32 * f11)) * f10)));
 f10 = Math_fround(Math_fround(f10 + Math_fround(f42 * Math_fround(f41 - Math_fround(f14 * f40)))) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f9 * f38) - f37)) + Math_fround(Math_fround(Math_fround(f14 * f4) - Math_fround(f9 * f36)) * f10)));
 f36 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f9) - Math_fround(f13 * f34)) - Math_fround(f35 * f32)) - Math_fround(f33 * f14));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f34) - Math_fround(f31 * f14)) - Math_fround(f13 * f32)) - Math_fround(f33 * f9));
 f37 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) - Math_fround(f13 * f9)) - Math_fround(f31 * f34)) - Math_fround(f35 * f14));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f14) - Math_fround(f31 * f32)) - Math_fround(f33 * f34)) - Math_fround(f35 * f9));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i3 ^ -2147483648;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i1 = i1 ^ -2147483648;
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)))));
 if (f9 > Math_fround(0.0)) {
  f44 = Math_fround(f12 + Math_fround(HEAPF32[(i30 ? i5 + 268 | 0 : i5 + 276 | 0) >> 2]));
  f14 = Math_fround(f9 / f22);
  i5 = f44 > Math_fround(.100000001);
  f44 = i5 ? f44 : Math_fround(0.0);
  i5 = f44 > Math_fround(1.0);
  f43 = Math_fround(f44 * Math_fround(2.0));
  f44 = i5 ? f43 : f44;
  f14 = Math_fround((f44 < f14 ? f44 : f14) / f14);
  f8 = Math_fround(f8 * f14);
  f10 = Math_fround(f10 * f14);
  f14 = Math_fround(f11 * f14);
 } else f14 = f11;
 f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_fround(+Math_atan(+Math_fround(f9 / f4))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(+Math_atan(+Math_fround(f11 / f4))) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(+Math_atan(+Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f4))) * Math_fround(2.0));
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0)))));
 if (f13 > Math_fround(0.0)) {
  f42 = Math_fround(f13 / f22);
  i1 = f15 > Math_fround(.17453292);
  f38 = i1 ? f15 : Math_fround(0.0);
  i1 = f38 > Math_fround(1.74532926);
  f36 = Math_fround(f38 * Math_fround(2.0));
  f38 = i1 ? f36 : f38;
  f42 = Math_fround((f38 < f42 ? f38 : f42) / f42);
  f38 = Math_fround(f9 * f42);
  f36 = Math_fround(f11 * f42);
  f42 = Math_fround(f12 * f42);
  f44 = Math_fround(Math_fround(Math_abs(Math_fround(f38))) + Math_fround(3.14159274));
  f7 = Math_fround(Math_fround(Math_abs(Math_fround(f36))) + Math_fround(3.14159274));
  f43 = Math_fround(Math_fround(Math_abs(Math_fround(f42))) + Math_fround(3.14159274));
  f37 = Math_fround(f7 / Math_fround(6.28318548));
  f40 = Math_fround(f43 / Math_fround(6.28318548));
  f41 = Math_fround(_truncf(Math_fround(f44 / Math_fround(6.28318548))));
  f37 = Math_fround(_truncf(f37));
  f41 = Math_fround(Math_fround(f44 - Math_fround(f41 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f37 = Math_fround(Math_fround(f7 - Math_fround(f37 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  f40 = Math_fround(Math_fround(f43 - Math_fround(Math_fround(_truncf(f40)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 & -2147483648;
  i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 & -2147483648;
  i3 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) ^ i3 & -2147483648;
  f40 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = Math_fround(f37 * Math_fround(.5));
  f41 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
  f40 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f40 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f37 = Math_fround(_fminf(Math_fround(_fmaxf(f37, Math_fround(-1.57079542))), Math_fround(1.57079542)));
  f40 = Math_fround(f40 * Math_fround(.159154937));
  f37 = Math_fround(f37 * Math_fround(.159154937));
  f41 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f41, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
  f42 = Math_fround(+_roundf(+f40));
  f36 = Math_fround(+_roundf(+f37));
  f42 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f42))));
  f36 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f36))));
  f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f41 - Math_fround(+_roundf(+f41))))));
  f43 = Math_fround(f42 * f42);
  f7 = Math_fround(f36 * f36);
  f44 = Math_fround(f38 * f38);
  f39 = Math_fround(f43 * f43);
  f4 = Math_fround(f7 * f7);
  f35 = Math_fround(f44 * f44);
  f43 = Math_fround(f42 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f43 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f43 * Math_fround(76.5686187)))))));
  f7 = Math_fround(f36 * Math_fround(Math_fround(Math_fround(f4 * f4) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f4 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
  f44 = Math_fround(f38 * Math_fround(Math_fround(Math_fround(f35 * f35) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f44 * Math_fround(41.3416595))) + Math_fround(f35 * Math_fround(Math_fround(81.6018218) - Math_fround(f44 * Math_fround(76.5686187)))))));
  f40 = Math_fround(f40 + Math_fround(-.25));
  f37 = Math_fround(f37 + Math_fround(-.25));
  f41 = Math_fround(f41 + Math_fround(-.25));
  f35 = Math_fround(+_roundf(+f40));
  f38 = Math_fround(+_roundf(+f37));
  f35 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f35))));
  f38 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f37 - f38))));
  f41 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f41 - Math_fround(+_roundf(+f41))))));
  f37 = Math_fround(f35 * f35);
  f40 = Math_fround(f38 * f38);
  f4 = Math_fround(f41 * f41);
  f36 = Math_fround(f37 * f37);
  f39 = Math_fround(f40 * f40);
  f42 = Math_fround(f4 * f4);
  f43 = Math_fround(Math_fround(f35 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f37 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f37 * Math_fround(76.5686187))))))) / f43);
  f7 = Math_fround(Math_fround(f38 * Math_fround(Math_fround(Math_fround(f39 * f39) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f39 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187))))))) / f7);
  f44 = Math_fround(Math_fround(f41 * Math_fround(Math_fround(Math_fround(f42 * f42) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f42 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187))))))) / f44);
  f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f44 * f44) + Math_fround(1.0))))));
  f43 = Math_fround(f4 * f43);
  f7 = Math_fround(f4 * f7);
  f44 = Math_fround(f4 * f44);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f7 = Math_fround(HEAPF32[i16 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f36 = Math_fround(HEAPF32[i21 + 28 >> 2]);
 i45 = i21 + 32 | 0;
 f37 = Math_fround(HEAPF32[i45 >> 2]);
 i5 = i21 + 36 | 0;
 f15 = Math_fround(f8 * f36);
 f37 = Math_fround(f14 * f37);
 f40 = Math_fround(f10 * Math_fround(HEAPF32[i5 >> 2]));
 f39 = Math_fround(HEAPF32[i18 >> 2]);
 f33 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f32 = Math_fround(HEAPF32[i20 >> 2]);
 f43 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(f39 * Math_fround(-2.0));
 f38 = Math_fround(f39 * Math_fround(2.0));
 f22 = Math_fround(f14 * f32);
 f31 = Math_fround(f43 * Math_fround(2.0));
 f42 = Math_fround(f43 * Math_fround(-2.0));
 f13 = Math_fround(f32 * f42);
 f41 = Math_fround(f33 * Math_fround(-2.0));
 f34 = Math_fround(f33 * Math_fround(2.0));
 f35 = Math_fround(f32 * f41);
 f44 = Math_fround(Math_fround(f15 + Math_fround(f15 * Math_fround(Math_fround(f39 * f14) - Math_fround(f43 * f31)))) + Math_fround(Math_fround(f40 * Math_fround(Math_fround(f34 * f43) - f22)) + Math_fround(f37 * Math_fround(f13 - Math_fround(f39 * f41)))));
 f34 = Math_fround(Math_fround(f37 + Math_fround(f15 * Math_fround(Math_fround(f33 * f38) - f13))) + Math_fround(Math_fround(f40 * Math_fround(f35 - Math_fround(f14 * f43))) + Math_fround(f37 * Math_fround(Math_fround(f43 * f42) - Math_fround(f33 * f34)))));
 f35 = Math_fround(Math_fround(f40 + Math_fround(f15 * Math_fround(f22 - Math_fround(f33 * f42)))) + Math_fround(Math_fround(f40 * Math_fround(Math_fround(f33 * f41) - Math_fround(f39 * f38))) + Math_fround(f37 * Math_fround(Math_fround(f39 * f31) - f35))));
 f31 = Math_fround(HEAPF32[i21 >> 2]);
 f44 = Math_fround(f31 + f44);
 f34 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f34);
 f35 = Math_fround(f7 + f35);
 f31 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f31 * f39);
 f38 = Math_fround(f4 * f32);
 f41 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(f41 * f43);
 f42 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f42 * f32)) - Math_fround(f4 * f43)) - Math_fround(f41 * f33));
 f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f31 * f33)) - Math_fround(f42 * f43)) - Math_fround(f41 * f39));
 f40 = Math_fround(Math_fround(Math_fround(f40 - Math_fround(f42 * f39)) - Math_fround(f31 * f32)) - Math_fround(f4 * f33));
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f33) - Math_fround(f31 * f43)) - Math_fround(f41 * f32)) - Math_fround(f4 * f39));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i1 ^ -2147483648;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i3 = i3 ^ -2147483648;
 HEAPF32[i21 >> 2] = f44;
 HEAPF32[i6 >> 2] = f34;
 HEAPF32[i16 >> 2] = f35;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i18 >> 2] = i2;
 HEAP32[i19 >> 2] = i3;
 HEAPF32[i20 >> 2] = f38;
 i19 = i21 + 28 | 0;
 HEAPF32[i19 >> 2] = f36;
 i24 = HEAP32[i24 >> 2] | 0;
 HEAPF32[i24 + 68 + (i23 << 6) >> 2] = f44;
 HEAPF32[i24 + 68 + (i23 << 6) + 4 >> 2] = f34;
 HEAPF32[i24 + 68 + (i23 << 6) + 8 >> 2] = f35;
 HEAP32[i24 + 68 + (i23 << 6) + 12 >> 2] = i1;
 HEAP32[i24 + 68 + (i23 << 6) + 16 >> 2] = i2;
 HEAP32[i24 + 68 + (i23 << 6) + 20 >> 2] = i3;
 HEAPF32[i24 + 68 + (i23 << 6) + 24 >> 2] = f38;
 i20 = HEAP32[i45 >> 2] | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 HEAP32[i24 + 68 + (i23 << 6) + 28 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i24 + 68 + (i23 << 6) + 32 >> 2] = i20;
 HEAP32[i24 + 68 + (i23 << 6) + 36 >> 2] = i21;
 f38 = i30 ? Math_fround(-1.0) : Math_fround(1.0);
 i25 = HEAP32[i25 >> 2] | 0;
 i25 = i25 + i26 | 0;
 i26 = i25 + 360 | 0;
 f35 = Math_fround(HEAPF32[i26 >> 2]);
 f35 = Math_fround(f38 * f35);
 i25 = i25 + 388 | 0;
 f38 = Math_fround(HEAPF32[i25 >> 2]);
 f38 = Math_fround(f35 * f38);
 i25 = i24 + 68 + (i23 << 6) + 16 | 0;
 f35 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i24 + 68 + (i23 << 6) + 12 | 0;
 f34 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i24 + 68 + (i23 << 6) + 24 | 0;
 f44 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i24 + 68 + (i23 << 6) + 20 | 0;
 f36 = Math_fround(HEAPF32[i25 >> 2]);
 f39 = Math_fround(f35 * Math_fround(-2.0));
 f40 = Math_fround(f35 * Math_fround(2.0));
 f37 = Math_fround(f35 * f39);
 f39 = Math_fround(f39 * f44);
 f32 = Math_fround(f36 * Math_fround(2.0));
 f41 = Math_fround(f36 * Math_fround(-2.0));
 f43 = Math_fround(f36 * f32);
 f31 = Math_fround(f44 * f41);
 f41 = Math_fround(f34 * f41);
 f43 = Math_fround(f37 - f43);
 f41 = Math_fround(f39 - f41);
 f32 = Math_fround(f35 * f32);
 f37 = Math_fround(f34 * Math_fround(-2.0));
 f33 = Math_fround(f34 * Math_fround(2.0));
 f42 = Math_fround(f35 * f37);
 f44 = Math_fround(f44 * f37);
 f42 = Math_fround(f31 - f42);
 f44 = Math_fround(f32 - f44);
 f36 = Math_fround(f33 * f36);
 f37 = Math_fround(f34 * f37);
 f40 = Math_fround(f35 * f40);
 f39 = Math_fround(f36 - f39);
 f40 = Math_fround(f37 - f40);
 f43 = Math_fround(f43 * Math_fround(0.0));
 f41 = Math_fround(f41 * Math_fround(0.0));
 f43 = Math_fround(f43 + Math_fround(0.0));
 f41 = Math_fround(f38 + f41);
 f42 = Math_fround(f42 * Math_fround(0.0));
 f44 = Math_fround(f44 * Math_fround(0.0));
 f39 = Math_fround(f38 * f39);
 f40 = Math_fround(f38 * f40);
 f42 = Math_fround(f39 + f42);
 f44 = Math_fround(f40 + f44);
 f42 = Math_fround(f43 + f42);
 f44 = Math_fround(f41 + f44);
 f42 = Math_fround(f27 * f42);
 f41 = Math_fround(f28 * Math_fround(0.0));
 f44 = Math_fround(f29 * f44);
 i25 = i24 + 68 + (i23 << 6) | 0;
 f43 = Math_fround(HEAPF32[i25 >> 2]);
 f42 = Math_fround(f43 + f42);
 i26 = i24 + 68 + (i23 << 6) + 4 | 0;
 f43 = Math_fround(HEAPF32[i26 >> 2]);
 f43 = Math_fround(f41 + f43);
 i30 = i24 + 68 + (i23 << 6) + 8 | 0;
 f41 = Math_fround(HEAPF32[i30 >> 2]);
 f44 = Math_fround(f41 + f44);
 HEAPF32[i25 >> 2] = f42;
 HEAPF32[i26 >> 2] = f43;
 HEAPF32[i30 >> 2] = f44;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator9buildTomeERNS0_6ResultEPKS1_j(i52, i51, i28, i1) {
 i52 = i52 | 0;
 i51 = i51 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i53 = 0, i54 = 0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i54 + 64 | 0;
 i53 = i54 + 48 | 0;
 i30 = i54 + 24 | 0;
 i26 = i54;
 i48 = i52 + 300 | 0;
 __ZN5Umbra20RuntimeStructBuilder4initEPNS_9AllocatorEj(i48, HEAP32[i52 >> 2] | 0, 0) | 0;
 if (i1 | 0) if (!(__ZN5Umbra20RuntimeStructBuilder13reserveOutputEPNS_9AllocatorEj(i48, HEAP32[i52 + 4 >> 2] | 0, i1) | 0)) {
  i53 = 1;
  STACKTOP = i54;
  return i53 | 0;
 }
 i49 = i51 + 4 | 0;
 i50 = i51 + 16 | 0;
 HEAP32[i51 >> 2] = 0;
 HEAP32[i51 + 4 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 0;
 HEAP32[i51 + 12 >> 2] = 0;
 HEAP32[i51 + 16 >> 2] = 0;
 if (!(__ZN5Umbra20RuntimeTomeGenerator12collectTilesEv(i52) | 0)) {
  i53 = HEAP32[i52 + 464 >> 2] | 0;
  STACKTOP = i54;
  return i53 | 0;
 }
 if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i48, 336, 65536) | 0)) {
  HEAP32[i52 + 464 >> 2] = 1;
  i53 = 1;
  STACKTOP = i54;
  return i53 | 0;
 }
 i46 = i52 + 432 | 0;
 i44 = HEAP32[i52 + 304 + (HEAP32[i46 >> 2] << 3) + 4 >> 2] | 0;
 i31 = i52 + 452 | 0;
 i32 = i52 + 444 | 0;
 i45 = (HEAP32[i32 >> 2] | 0) + (((HEAP32[i31 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i47 = HEAP32[i45 >> 2] | 0;
 _memset(i47 | 0, 0, 336) | 0;
 HEAP32[i45 >> 2] = (HEAP32[i45 >> 2] | 0) + 336;
 i45 = HEAP32[i46 >> 2] | 0;
 i43 = i52 + 304 + (i45 << 3) + 4 | 0;
 i33 = (HEAP32[i43 >> 2] | 0) + 336 | 0;
 HEAP32[i43 >> 2] = i33;
 i45 = i45 + 1 | 0;
 HEAP32[i46 >> 2] = i45;
 HEAP32[i52 + 304 + (i45 << 3) >> 2] = i44;
 HEAP32[i52 + 304 + (HEAP32[i46 >> 2] << 3) + 4 >> 2] = i33;
 i33 = i52 + 436 | 0;
 HEAP8[i33 >> 0] = 0;
 if (!(__ZN5Umbra20RuntimeTomeGenerator14generateHeaderERNS_7ImpTomeERNS0_6ResultEPKS3_(i52, i47, i51, i28) | 0)) {
  HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
  HEAP32[i51 >> 2] = 0;
  HEAP32[i51 + 4 >> 2] = 0;
  HEAP32[i51 + 8 >> 2] = 0;
  HEAP32[i51 + 12 >> 2] = 0;
  HEAP32[i51 + 16 >> 2] = 0;
  i53 = HEAP32[i52 + 464 >> 2] | 0;
  STACKTOP = i54;
  return i53 | 0;
 }
 i1 = HEAP32[i52 >> 2] | 0;
 i45 = i52 + 284 | 0;
 HEAP32[i45 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i45 >> 2] = gb + 1451688;
  i2 = i52 + 268 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i2 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 } else {
  i2 = i52 + 268 | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i5 = HEAP32[i52 + 12 >> 2] | 0;
 i40 = i52 + 292 | 0;
 if ((HEAP32[i40 >> 2] | 0) < (i5 | 0)) {
  i4 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i5 << 2) + 16 | 0, 0) | 0;
  if (i4 | 0) {
   HEAP32[i4 >> 2] = i5;
   HEAP32[i40 >> 2] = i5;
   i1 = i52 + 288 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) {
    i44 = HEAP32[i45 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 12 >> 2] | 0, i44 | 0, i3 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i4 + 16;
   i36 = 21;
  }
 } else i36 = 21;
 L33 : do if ((i36 | 0) == 21) {
  i37 = i52 + 296 | 0;
  HEAP32[i37 >> 2] = i5;
  i38 = i52 + 276 | 0;
  do if ((HEAP32[i38 >> 2] | 0) < 512) {
   i1 = HEAP32[i2 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 14352, 0) | 0;
   if (!i1) break L33;
   HEAP32[i1 >> 2] = 512;
   i4 = i1 + 16 | 0;
   i1 = 0;
   do {
    HEAP32[i4 + (i1 * 28 | 0) + 8 >> 2] = 2147483647;
    HEAP32[i4 + (i1 * 28 | 0) + 12 >> 2] = 2147483647;
    HEAP32[i4 + (i1 * 28 | 0) + 16 >> 2] = -2147483647;
    HEAP32[i4 + (i1 * 28 | 0) + 20 >> 2] = -2147483647;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 512);
   HEAP32[i38 >> 2] = 512;
   i1 = i52 + 272 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    HEAP32[i1 >> 2] = i4;
    i1 = i52 + 280 | 0;
    HEAP32[i1 >> 2] = 512;
    i36 = 34;
    break;
   }
   i44 = HEAP32[i2 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 12 >> 2] | 0, i44 | 0, i3 + -16 | 0);
   i44 = HEAP32[i38 >> 2] | 0;
   HEAP32[i1 >> 2] = i4;
   i1 = i52 + 280 | 0;
   HEAP32[i1 >> 2] = 512;
   if ((i44 | 0) < 0) {
    i5 = HEAP32[i2 >> 2] | 0;
    i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 16, 0) | 0;
    if (!i5) i34 = i1; else {
     HEAP32[i5 >> 2] = 0;
     HEAP32[i38 >> 2] = 0;
     i3 = i52 + 272 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (i4 | 0) {
      i44 = HEAP32[i2 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 12 >> 2] | 0, i44 | 0, i4 + -16 | 0);
     }
     HEAP32[i3 >> 2] = i5 + 16;
     i36 = 34;
    }
   } else i36 = 34;
  } else {
   i1 = i52 + 280 | 0;
   HEAP32[i1 >> 2] = 512;
   i36 = 34;
  } while (0);
  if ((i36 | 0) == 34) {
   HEAP32[i1 >> 2] = 0;
   i34 = i1;
  }
  i35 = i52 + 192 | 0;
  if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i48, (HEAP32[i35 >> 2] << 3) + 16 | 0, 65536) | 0)) {
   HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
   HEAP32[i51 >> 2] = 0;
   HEAP32[i51 + 4 >> 2] = 0;
   HEAP32[i51 + 8 >> 2] = 0;
   HEAP32[i51 + 12 >> 2] = 0;
   HEAP32[i51 + 16 >> 2] = 0;
   HEAP32[i52 + 464 >> 2] = 1;
   i53 = 1;
   STACKTOP = i54;
   return i53 | 0;
  }
  i8 = (HEAP32[i35 >> 2] << 3) + 15 & -16;
  i1 = (HEAP32[i32 >> 2] | 0) + (((HEAP32[i31 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i27 = HEAP32[i1 >> 2] | 0;
  _memset(i27 | 0, 0, i8 | 0) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i8;
  i1 = HEAP32[i46 >> 2] | 0;
  HEAP32[i47 + 160 >> 2] = (HEAP32[i52 + 304 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i52 + 304 + (i1 << 3) >> 2] | 0);
  i1 = i52 + 304 + (HEAP32[i46 >> 2] << 3) + 4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i8;
  HEAP8[i33 >> 0] = 0;
  HEAP32[i52 + 260 >> 2] = 0;
  HEAP32[i52 + 264 >> 2] = 0;
  i1 = HEAP32[i52 >> 2] | 0;
  i8 = i52 + 176 | 0;
  HEAP32[i8 >> 2] = i1;
  i3 = (i1 | 0) == 0;
  if (i3) {
   if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
    HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
    HEAP32[gb + 1451688 + 8 >> 2] = 1;
   }
   HEAP32[i8 >> 2] = gb + 1451688;
   HEAP32[i29 >> 2] = i1;
   if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
    HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
    HEAP32[gb + 1451688 + 8 >> 2] = 1;
   }
   HEAP32[i29 >> 2] = gb + 1451688;
   i9 = gb + 1451688 | 0;
   i44 = i29;
  } else {
   HEAP32[i29 >> 2] = i1;
   i9 = i1;
   i44 = i29;
  }
  i41 = i29 + 4 | 0;
  HEAP32[i41 >> 2] = 0;
  i42 = i29 + 8 | 0;
  HEAP32[i42 >> 2] = 0;
  i43 = i29 + 12 | 0;
  HEAP32[i43 >> 2] = 0;
  HEAP32[i53 >> 2] = i1;
  if (i3) {
   if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
    HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
    HEAP32[gb + 1451688 + 8 >> 2] = 1;
   }
   HEAP32[i53 >> 2] = gb + 1451688;
   i1 = gb + 1451688 | 0;
  }
  i39 = i53 + 4 | 0;
  HEAP32[i39 >> 2] = 0;
  i24 = i53 + 8 | 0;
  HEAP32[i24 >> 2] = 0;
  i25 = i53 + 12 | 0;
  HEAP32[i25 >> 2] = 0;
  i7 = HEAP32[i52 + 172 >> 2] | 0;
  i4 = i52 + 184 | 0;
  if ((HEAP32[i4 >> 2] | 0) < (i7 | 0)) {
   i5 = i7 << 2;
   i3 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i5 + 16 | 0, 0) | 0;
   if (!i3) i36 = 63; else {
    HEAP32[i3 >> 2] = i7;
    i6 = i3 + 16 | 0;
    if ((i7 | 0) > 0) _memset(i6 | 0, 0, i5 | 0) | 0;
    HEAP32[i4 >> 2] = i7;
    i3 = i52 + 180 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i36 = HEAP32[i8 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i4 + -16 | 0);
    }
    HEAP32[i3 >> 2] = i6;
    i36 = HEAP32[i42 >> 2] | 0;
    HEAP32[i52 + 188 >> 2] = i7;
    if ((i36 | 0) < 4) i36 = 56; else i36 = 58;
   }
  } else {
   HEAP32[i52 + 188 >> 2] = i7;
   i36 = 56;
  }
  if ((i36 | 0) == 56) {
   i3 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, 32, 0) | 0;
   if (!i3) i36 = 63; else {
    HEAP32[i3 >> 2] = 4;
    HEAP32[i42 >> 2] = 4;
    HEAP32[i41 >> 2] = i3 + 16;
    i36 = 58;
   }
  }
  L86 : do if ((i36 | 0) == 58) {
   HEAP32[i43 >> 2] = 4;
   if ((HEAP32[i24 >> 2] | 0) < 16) {
    i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 80, 0) | 0;
    if (!i1) {
     i36 = 63;
     break;
    }
    HEAP32[i1 >> 2] = 16;
    HEAP32[i24 >> 2] = 16;
    HEAP32[i39 >> 2] = i1 + 16;
   }
   HEAP32[i25 >> 2] = 16;
   i1 = HEAP32[i35 >> 2] | 0;
   do if ((i1 | 0) > 0) {
    i7 = i52 + 148 | 0;
    i8 = i52 + 76 | 0;
    i9 = i52 + 68 | 0;
    i10 = i52 + 288 | 0;
    i11 = i52 + 272 | 0;
    i12 = i52 + 180 | 0;
    i13 = i30 + 12 | 0;
    i14 = i52 + 164 | 0;
    i15 = i30 + 4 | 0;
    i16 = i30 + 8 | 0;
    i17 = i30 + 16 | 0;
    i18 = i30 + 20 | 0;
    i19 = i47 + 20 | 0;
    i20 = i47 + 32 | 0;
    i21 = i26 + 12 | 0;
    i22 = i52 + 24 | 0;
    i23 = i52 + 460 | 0;
    i6 = 0;
    L94 : while (1) {
     i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
     i5 = i27 + (i6 << 3) | 0;
     HEAP32[i5 >> 2] = 0;
     do if ((i4 | 0) >= 0) {
      if ((HEAP32[i8 >> 2] | 0) > (i4 | 0)) if (!(HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 5) >> 2] | 0) + 44 >> 2] & 1)) break;
      _memset(HEAP32[i10 >> 2] | 0, 0, HEAP32[i37 >> 2] << 2 | 0) | 0;
      do if ((HEAP32[i38 >> 2] | 0) < 0) {
       i3 = HEAP32[i2 >> 2] | 0;
       i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
       if (!i3) break;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i38 >> 2] = 0;
       i1 = HEAP32[i11 >> 2] | 0;
       if (i1 | 0) {
        i36 = HEAP32[i2 >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 + -16 | 0);
       }
       HEAP32[i11 >> 2] = i3 + 16;
       i36 = 72;
      } else i36 = 72; while (0);
      if ((i36 | 0) == 72) {
       i36 = 0;
       HEAP32[i34 >> 2] = 0;
      }
      do if ((HEAP32[i24 >> 2] | 0) < 0) {
       i3 = HEAP32[i53 >> 2] | 0;
       i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
       if (!i3) break;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i24 >> 2] = 0;
       i1 = HEAP32[i39 >> 2] | 0;
       if (i1 | 0) {
        i36 = HEAP32[i53 >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 + -16 | 0);
       }
       HEAP32[i39 >> 2] = i3 + 16;
       i36 = 78;
      } else i36 = 78; while (0);
      if ((i36 | 0) == 78) {
       i36 = 0;
       HEAP32[i25 >> 2] = 0;
      }
      i1 = HEAP32[i8 >> 2] | 0;
      if ((i1 | 0) > (i4 | 0)) {
       if (HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 5) + 16 >> 2] | 0) i36 = 81;
      } else i36 = 81;
      if ((i36 | 0) == 81) {
       i36 = 0;
       HEAP32[i30 >> 2] = 0;
       HEAP32[i26 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
       HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
       HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
       __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi(i52, i53, i22, 0, i26, i4);
       __ZN5Umbra20RuntimeTomeGenerator15generatePortalsEiRNS_5ArrayIiEEPKNS0_6ResultERi(i52, i4, i53, i28, i30);
       __ZN5Umbra20RuntimeTomeGenerator23combineHierarchyPortalsEi(i52, i4);
       __ZN5Umbra20RuntimeTomeGenerator21makeNeighborBitvectorEiRKNS_5ArrayIiEEbRNS1_IjEEPKNS0_6ResultE(i52, 0, i53, 1, i29, i28);
       if ((HEAP32[i8 >> 2] | 0) > (i4 | 0)) i1 = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 5) >> 2] | 0) + 52 >> 2] & 65535; else i1 = 1;
       if (!(__ZN5Umbra20RuntimeTomeGenerator21outputExternalPortalsERNS_7ExtTileEiiPKNS0_6ResultERKNS_5ArrayIjEEi(i52, (HEAP32[i23 >> 2] | 0) + (i6 << 5) | 0, i1, i4, i28, i29, HEAP32[i30 >> 2] | 0) | 0)) {
        i36 = 85;
        break L94;
       }
       i1 = HEAP32[i8 >> 2] | 0;
      }
      if ((i4 | 0) < (i1 | 0)) {
       i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 5) >> 2] | 0;
       HEAP32[i5 >> 2] = i1;
      } else {
       i4 = i4 - i1 | 0;
       i1 = (HEAP32[i12 >> 2] | 0) + (i4 << 2) | 0;
       i3 = HEAP32[i14 >> 2] | 0;
       HEAP32[i30 >> 2] = HEAP32[i3 + (i4 * 40 | 0) >> 2];
       HEAP32[i15 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 4 >> 2];
       HEAP32[i16 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 8 >> 2];
       HEAP32[i13 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 12 >> 2];
       HEAP32[i17 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 16 >> 2];
       HEAP32[i18 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 20 >> 2];
       i1 = __ZN5Umbra20RuntimeTomeGenerator17generateEmptyTileERNS_7DataPtrERKNS_4AABBEi(i52, i1, i30, 0) | 0;
       HEAP32[i5 >> 2] = i1;
      }
      if (!i1) {
       i36 = 91;
       break L94;
      }
      i1 = HEAP32[i35 >> 2] | 0;
     } while (0);
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i1 | 0)) {
      i36 = 93;
      break;
     }
    }
    if ((i36 | 0) == 85) {
     HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     HEAP32[i51 + 8 >> 2] = 0;
     HEAP32[i51 + 12 >> 2] = 0;
     HEAP32[i51 + 16 >> 2] = 0;
     i2 = HEAP32[i52 + 464 >> 2] | 0;
     break L86;
    } else if ((i36 | 0) == 91) {
     HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     HEAP32[i51 + 8 >> 2] = 0;
     HEAP32[i51 + 12 >> 2] = 0;
     HEAP32[i51 + 16 >> 2] = 0;
     i2 = HEAP32[i52 + 464 >> 2] | 0;
     break L86;
    } else if ((i36 | 0) == 93) {
     if ((HEAP32[i24 >> 2] | 0) >= 0) {
      i36 = 98;
      break;
     }
     i3 = HEAP32[i53 >> 2] | 0;
     i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
     if (!i3) break;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i24 >> 2] = 0;
     i1 = HEAP32[i39 >> 2] | 0;
     if (i1 | 0) {
      i36 = HEAP32[i53 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 + -16 | 0);
     }
     HEAP32[i39 >> 2] = i3 + 16;
     i36 = 98;
     break;
    }
   } else i36 = 98; while (0);
   if ((i36 | 0) == 98) HEAP32[i25 >> 2] = 0;
   i1 = HEAP32[i35 >> 2] | 0;
   L146 : do if ((i1 | 0) > 0) {
    i8 = i52 + 148 | 0;
    i9 = i52 + 76 | 0;
    i10 = i52 + 68 | 0;
    i11 = i52 + 288 | 0;
    i12 = i52 + 272 | 0;
    i13 = (i28 | 0) == 0;
    i14 = i52 + 460 | 0;
    i15 = i52 + 256 | 0;
    i16 = i52 + 248 | 0;
    i17 = i28 + 4 | 0;
    i7 = 0;
    L148 : while (1) {
     i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     do if ((i6 | 0) >= 0) {
      if ((HEAP32[i9 >> 2] | 0) <= (i6 | 0)) break;
      if (HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 5) >> 2] | 0) + 44 >> 2] & 1 | 0) break;
      HEAP32[i30 >> 2] = 0;
      _memset(HEAP32[i11 >> 2] | 0, 0, HEAP32[i37 >> 2] << 2 | 0) | 0;
      do if ((HEAP32[i38 >> 2] | 0) < 0) {
       i3 = HEAP32[i2 >> 2] | 0;
       i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
       if (!i3) break;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i38 >> 2] = 0;
       i1 = HEAP32[i12 >> 2] | 0;
       if (i1 | 0) {
        i36 = HEAP32[i2 >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 + -16 | 0);
       }
       HEAP32[i12 >> 2] = i3 + 16;
       i36 = 109;
      } else i36 = 109; while (0);
      if ((i36 | 0) == 109) {
       i36 = 0;
       HEAP32[i34 >> 2] = 0;
      }
      do if (i13) i36 = 121; else {
       if (!(HEAP32[i15 >> 2] | 0)) {
        i36 = 121;
        break;
       }
       if ((HEAP32[(HEAP32[i16 >> 2] | 0) + (i7 << 2) >> 2] | 0) == -1) {
        i36 = 121;
        break;
       }
       i5 = (((HEAP32[(HEAP32[i17 >> 2] | 0) + 44 >> 2] | 0) >>> 5) + 31 | 0) >>> 5;
       if ((HEAP32[i42 >> 2] | 0) < (i5 | 0)) {
        i1 = HEAP32[i44 >> 2] | 0;
        i3 = i5 << 2;
        i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 + 16 | 0, 0) | 0;
        if (!i1) {
         i36 = 119;
         break L148;
        }
        HEAP32[i1 >> 2] = i5;
        i1 = i1 + 16 | 0;
        HEAP32[i42 >> 2] = i5;
        i4 = HEAP32[i41 >> 2] | 0;
        if (i4 | 0) {
         i26 = HEAP32[i44 >> 2] | 0;
         mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0, i4 + -16 | 0);
        }
        HEAP32[i41 >> 2] = i1;
       } else {
        i3 = i5 << 2;
        i1 = HEAP32[i41 >> 2] | 0;
       }
       HEAP32[i43 >> 2] = i5;
       _memset(i1 | 0, 0, i3 | 0) | 0;
      } while (0);
      do if ((i36 | 0) == 121) {
       i36 = 0;
       if ((HEAP32[i42 >> 2] | 0) < 0) {
        i1 = HEAP32[i44 >> 2] | 0;
        i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, 0) | 0;
        if (!i1) break;
        HEAP32[i1 >> 2] = 0;
        HEAP32[i42 >> 2] = 0;
        i3 = HEAP32[i41 >> 2] | 0;
        if (i3 | 0) {
         i26 = HEAP32[i44 >> 2] | 0;
         mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0, i3 + -16 | 0);
        }
        HEAP32[i41 >> 2] = i1 + 16;
       }
       HEAP32[i43 >> 2] = 0;
      } while (0);
      __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi(i52, i6, i7, 0, i29, i30);
      if (!(__ZN5Umbra20RuntimeTomeGenerator21outputExternalPortalsERNS_7ExtTileEiiPKNS0_6ResultERKNS_5ArrayIjEEi(i52, (HEAP32[i14 >> 2] | 0) + (i7 << 5) | 0, HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 5) >> 2] | 0) + 52 >> 2] & 65535, i6, i28, i29, HEAP32[i30 >> 2] | 0) | 0)) {
       i36 = 128;
       break L148;
      }
      HEAP32[i27 + (i7 << 3) >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 5) >> 2];
      i1 = HEAP32[i35 >> 2] | 0;
     } while (0);
     i7 = i7 + 1 | 0;
     if ((i7 | 0) >= (i1 | 0)) break L146;
    }
    if ((i36 | 0) == 119) {
     HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     HEAP32[i51 + 8 >> 2] = 0;
     HEAP32[i51 + 12 >> 2] = 0;
     HEAP32[i51 + 16 >> 2] = 0;
     HEAP32[i52 + 464 >> 2] = 1;
     i1 = 1;
    } else if ((i36 | 0) == 128) {
     HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i51 + 4 >> 2] = 0;
     HEAP32[i51 + 8 >> 2] = 0;
     HEAP32[i51 + 12 >> 2] = 0;
     HEAP32[i51 + 16 >> 2] = 0;
     i1 = HEAP32[i52 + 464 >> 2] | 0;
    }
    i2 = i1;
    break L86;
   } while (0);
   i4 = HEAP32[i52 + 20 >> 2] | 0;
   if ((HEAP32[i40 >> 2] | 0) < (i4 | 0)) {
    i5 = HEAP32[i45 >> 2] | 0;
    i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, (i4 << 2) + 16 | 0, 0) | 0;
    if (i5 | 0) {
     HEAP32[i5 >> 2] = i4;
     HEAP32[i40 >> 2] = i4;
     i1 = i52 + 288 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if (i3 | 0) {
      i36 = HEAP32[i45 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i3 + -16 | 0);
     }
     HEAP32[i1 >> 2] = i5 + 16;
     i36 = 137;
    }
   } else i36 = 137;
   if ((i36 | 0) == 137) HEAP32[i37 >> 2] = i4;
   i13 = i52 + 60 | 0;
   if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i48, (HEAP32[i13 >> 2] << 3) + 40 | 0, 65536) | 0)) {
    HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
    HEAP32[i51 >> 2] = 0;
    HEAP32[i51 + 4 >> 2] = 0;
    HEAP32[i51 + 8 >> 2] = 0;
    HEAP32[i51 + 12 >> 2] = 0;
    HEAP32[i51 + 16 >> 2] = 0;
    HEAP32[i52 + 464 >> 2] = 1;
    i2 = 1;
    break;
   }
   i1 = (HEAP32[i13 >> 2] << 2) + 19 & -16;
   i30 = (HEAP32[i32 >> 2] | 0) + (((HEAP32[i31 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i12 = HEAP32[i30 >> 2] | 0;
   _memset(i12 | 0, 0, i1 | 0) | 0;
   HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + i1;
   i30 = HEAP32[i46 >> 2] | 0;
   HEAP32[i47 + 180 >> 2] = (HEAP32[i52 + 304 + (i30 << 3) + 4 >> 2] | 0) - (HEAP32[i52 + 304 + (i30 << 3) >> 2] | 0);
   i30 = i52 + 304 + (HEAP32[i46 >> 2] << 3) + 4 | 0;
   HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + i1;
   i30 = (HEAP32[i13 >> 2] << 2) + 19 & -16;
   i1 = (HEAP32[i32 >> 2] | 0) + (((HEAP32[i31 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i11 = HEAP32[i1 >> 2] | 0;
   _memset(i11 | 0, 0, i30 | 0) | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i30;
   i1 = HEAP32[i46 >> 2] | 0;
   HEAP32[i47 + 184 >> 2] = (HEAP32[i52 + 304 + (i1 << 3) + 4 >> 2] | 0) - (HEAP32[i52 + 304 + (i1 << 3) >> 2] | 0);
   i1 = i52 + 304 + (HEAP32[i46 >> 2] << 3) + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i30;
   HEAP8[i33 >> 0] = 0;
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 | 0) > 0) {
    i7 = i52 + 288 | 0;
    i8 = i52 + 272 | 0;
    i9 = i52 + 132 | 0;
    i10 = i52 + 56 | 0;
    i6 = 0;
    i4 = 0;
    i3 = 0;
    do {
     _memset(HEAP32[i7 >> 2] | 0, 0, HEAP32[i37 >> 2] << 2 | 0) | 0;
     do if ((HEAP32[i38 >> 2] | 0) < 0) {
      i5 = HEAP32[i2 >> 2] | 0;
      i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 16, 0) | 0;
      if (!i5) break;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i38 >> 2] = 0;
      i1 = HEAP32[i8 >> 2] | 0;
      if (i1 | 0) {
       i36 = HEAP32[i2 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 + -16 | 0);
      }
      HEAP32[i8 >> 2] = i5 + 16;
      i36 = 160;
     } else i36 = 160; while (0);
     if ((i36 | 0) == 160) {
      i36 = 0;
      HEAP32[i34 >> 2] = 0;
     }
     if ((HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0) + 144 >> 2] | 0) > 0) {
      i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
      do {
       __ZN5Umbra20RuntimeTomeGenerator21combineClusterPortalsEii(i52, i6, i1);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < ((HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0) + 144 >> 2] | 0) + (HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0) | 0));
     }
     __ZN5Umbra20RuntimeTomeGenerator20outputClusterPortalsEi(i52, i6) | 0;
     HEAP32[i12 + (i6 << 2) >> 2] = i3;
     HEAP32[i11 + (i6 << 2) >> 2] = i4;
     i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0;
     i5 = HEAP32[i1 + 124 >> 2] | 0;
     i3 = i5 + i3 | 0;
     if (!(HEAP32[i1 + 180 >> 2] | 0)) {
      i33 = i5 + -1 | 0;
      i1 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
      i1 = (HEAP32[i1 + (i33 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i1 + (i33 * 20 | 0) >> 2] | 0) | 0;
     } else i1 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
     i4 = i1 + i4 + (HEAP32[i34 >> 2] | 0) | 0;
     i6 = i6 + 1 | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    } while ((i6 | 0) < (i1 | 0));
   } else {
    i4 = 0;
    i3 = 0;
   }
   HEAP32[i12 + (i1 << 2) >> 2] = i3;
   HEAP32[i11 + (HEAP32[i13 >> 2] << 2) >> 2] = i4;
   do if ((HEAP32[i40 >> 2] | 0) < 0) {
    i4 = HEAP32[i45 >> 2] | 0;
    i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 16, 0) | 0;
    if (!i4) break;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i40 >> 2] = 0;
    i1 = i52 + 288 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (i3 | 0) {
     i45 = HEAP32[i45 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i3 + -16 | 0);
    }
    HEAP32[i1 >> 2] = i4 + 16;
    i36 = 147;
   } else i36 = 147; while (0);
   if ((i36 | 0) == 147) HEAP32[i37 >> 2] = 0;
   do if ((HEAP32[i38 >> 2] | 0) < 0) {
    i4 = HEAP32[i2 >> 2] | 0;
    i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 16, 0) | 0;
    if (!i4) break;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i38 >> 2] = 0;
    i1 = i52 + 272 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (i3 | 0) {
     i45 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i3 + -16 | 0);
    }
    HEAP32[i1 >> 2] = i4 + 16;
    i36 = 153;
   } else i36 = 153; while (0);
   if ((i36 | 0) == 153) HEAP32[i34 >> 2] = 0;
   i9 = HEAP32[i46 >> 2] | 0;
   i45 = HEAP32[i52 + 304 + (i9 << 3) + 4 >> 2] | 0;
   i7 = i9 + -1 | 0;
   HEAP32[i52 + 304 + (i7 << 3) + 4 >> 2] = i45;
   i9 = i45 - (HEAP32[i52 + 304 + (i9 << 3) >> 2] | 0) | 0;
   HEAP32[i46 >> 2] = i7;
   HEAP32[i47 + 8 >> 2] = i9;
   i9 = i52 + 4 | 0;
   i7 = __ZN5Umbra20RuntimeStructBuilder8finalizeEPNS_9AllocatorE(i48, HEAP32[i9 >> 2] | 0) | 0;
   if (!i7) {
    HEAP32[i51 >> 2] = 0;
    HEAP32[i51 + 4 >> 2] = 0;
    HEAP32[i51 + 8 >> 2] = 0;
    HEAP32[i51 + 12 >> 2] = 0;
    HEAP32[i51 + 16 >> 2] = 0;
    HEAP32[i52 + 464 >> 2] = 1;
    i2 = 1;
    break;
   }
   i8 = HEAP32[i7 + 160 >> 2] | 0;
   i8 = (i8 | 0) == 0 ? 0 : i7 + i8 | 0;
   i2 = HEAP32[i35 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i3 = HEAP32[i52 + 148 >> 2] | 0;
    i4 = HEAP32[i52 + 76 >> 2] | 0;
    i5 = i52 + 180 | 0;
    i1 = 0;
    do {
     i6 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
     if ((i6 | 0) >= (i4 | 0)) {
      i48 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 - i4 << 2) >> 2] | 0;
      HEAP32[i8 + (i1 << 3) >> 2] = (i48 | 0) == 0 ? 0 : i7 + i48 | 0;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i2 | 0));
   }
   HEAP32[i51 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i49 >> 2] = i7;
   HEAP32[i50 >> 2] = HEAP32[i13 >> 2];
   i1 = i52 + 464 | 0;
   if (!(HEAP8[i52 + 196 >> 0] | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    break;
   } else {
    HEAP32[i1 >> 2] = 3;
    i2 = 3;
    break;
   }
  } while (0);
  if ((i36 | 0) == 63) {
   HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
   HEAP32[i51 >> 2] = 0;
   HEAP32[i51 + 4 >> 2] = 0;
   HEAP32[i51 + 8 >> 2] = 0;
   HEAP32[i51 + 12 >> 2] = 0;
   HEAP32[i51 + 16 >> 2] = 0;
   HEAP32[i52 + 464 >> 2] = 1;
   i2 = 1;
  }
  i1 = HEAP32[i39 >> 2] | 0;
  if (i1 | 0) {
   i53 = HEAP32[i53 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i53 >> 2] | 0) + 12 >> 2] | 0, i53 | 0, i1 + -16 | 0);
  }
  i1 = HEAP32[i41 >> 2] | 0;
  if (i1 | 0) {
   i53 = HEAP32[i44 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i53 >> 2] | 0) + 12 >> 2] | 0, i53 | 0, i1 + -16 | 0);
  }
  HEAP32[i41 >> 2] = 0;
  HEAP32[i42 >> 2] = 0;
  HEAP32[i43 >> 2] = 0;
  i53 = i2;
  STACKTOP = i54;
  return i53 | 0;
 } while (0);
 HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + -1;
 HEAP32[i51 >> 2] = 0;
 HEAP32[i51 + 4 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 0;
 HEAP32[i51 + 12 >> 2] = 0;
 HEAP32[i51 + 16 >> 2] = 0;
 HEAP32[i52 + 464 >> 2] = 1;
 i53 = 1;
 STACKTOP = i54;
 return i53 | 0;
}

function __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0;
 i95 = STACKTOP;
 STACKTOP = STACKTOP + 2544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i95 + 8 | 0;
 i10 = i95;
 i105 = i95 + 2536 | 0;
 i104 = i95 + 2528 | 0;
 i103 = i95 + 2520 | 0;
 i102 = i95 + 2512 | 0;
 i101 = i95 + 2504 | 0;
 i100 = i95 + 2496 | 0;
 i99 = i95 + 2488 | 0;
 i98 = i95 + 2480 | 0;
 i97 = i95 + 2472 | 0;
 i96 = i95 + 2464 | 0;
 i2 = i95 + 2456 | 0;
 i3 = i95 + 2448 | 0;
 i5 = i95 + 2440 | 0;
 i4 = i95 + 2432 | 0;
 i6 = i95 + 2424 | 0;
 i7 = i95 + 2416 | 0;
 i8 = i95 + 2408 | 0;
 i38 = i95 + 2400 | 0;
 i39 = i95 + 2340 | 0;
 i40 = i95 + 2336 | 0;
 i41 = i95 + 2276 | 0;
 i42 = i95 + 2272 | 0;
 i43 = i95 + 2212 | 0;
 i44 = i95 + 2208 | 0;
 i45 = i95 + 2148 | 0;
 i46 = i95 + 2144 | 0;
 i47 = i95 + 2136 | 0;
 i48 = i95 + 2076 | 0;
 i49 = i95 + 2072 | 0;
 i50 = i95 + 2012 | 0;
 i51 = i95 + 2008 | 0;
 i52 = i95 + 2e3 | 0;
 i53 = i95 + 1940 | 0;
 i54 = i95 + 1936 | 0;
 i55 = i95 + 1876 | 0;
 i56 = i95 + 1872 | 0;
 i57 = i95 + 1812 | 0;
 i58 = i95 + 1808 | 0;
 i59 = i95 + 1800 | 0;
 i60 = i95 + 1740 | 0;
 i61 = i95 + 1736 | 0;
 i62 = i95 + 1676 | 0;
 i63 = i95 + 1672 | 0;
 i64 = i95 + 1612 | 0;
 i65 = i95 + 1608 | 0;
 i66 = i95 + 1548 | 0;
 i67 = i95 + 1544 | 0;
 i68 = i95 + 1536 | 0;
 i69 = i95 + 1476 | 0;
 i70 = i95 + 1472 | 0;
 i71 = i95 + 1412 | 0;
 i72 = i95 + 1408 | 0;
 i73 = i95 + 1348 | 0;
 i74 = i95 + 1344 | 0;
 i75 = i95 + 1284 | 0;
 i76 = i95 + 1280 | 0;
 i77 = i95 + 1272 | 0;
 i78 = i95 + 1212 | 0;
 i79 = i95 + 1208 | 0;
 i80 = i95 + 1148 | 0;
 i81 = i95 + 1144 | 0;
 i82 = i95 + 1136 | 0;
 i83 = i95 + 1076 | 0;
 i84 = i95 + 1072 | 0;
 i85 = i95 + 1012 | 0;
 i86 = i95 + 1008 | 0;
 i87 = i95 + 1e3 | 0;
 i88 = i95 + 940 | 0;
 i89 = i95 + 936 | 0;
 i90 = i95 + 876 | 0;
 i91 = i95 + 872 | 0;
 i92 = i95 + 812 | 0;
 i93 = i95 + 808 | 0;
 i94 = i95 + 800 | 0;
 i11 = i95 + 740 | 0;
 i12 = i95 + 736 | 0;
 i13 = i95 + 676 | 0;
 i14 = i95 + 672 | 0;
 i15 = i95 + 612 | 0;
 i16 = i95 + 608 | 0;
 i17 = i95 + 548 | 0;
 i18 = i95 + 544 | 0;
 i19 = i95 + 536 | 0;
 i20 = i95 + 476 | 0;
 i21 = i95 + 472 | 0;
 i22 = i95 + 412 | 0;
 i23 = i95 + 408 | 0;
 i24 = i95 + 348 | 0;
 i25 = i95 + 344 | 0;
 i26 = i95 + 284 | 0;
 i27 = i95 + 280 | 0;
 i28 = i95 + 272 | 0;
 i29 = i95 + 212 | 0;
 i30 = i95 + 208 | 0;
 i31 = i95 + 148 | 0;
 i32 = i95 + 144 | 0;
 i33 = i95 + 84 | 0;
 i34 = i95 + 80 | 0;
 i35 = i95 + 20 | 0;
 i36 = i95 + 16 | 0;
 i37 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 248, gb + 774161 | 0, gb + 774188 | 0, 1321) | 0;
 __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplC2ERN5physx19PxAllocatorCallbackE(i37, i1);
 HEAP32[i105 >> 2] = gb + 774285;
 HEAP32[i105 + 4 >> 2] = gb + 774310;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i105, 1) | 0;
 HEAP32[i1 + 28 >> 2] = 12;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = 12;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i104 >> 2] = gb + 776474;
 HEAP32[i104 + 4 >> 2] = gb + 774320;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i104, 65) | 0;
 HEAP32[i1 + 28 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = 1;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 1;
 HEAP32[i1 + 24 >> 2] = 65;
 HEAP32[i103 >> 2] = gb + 776474;
 HEAP32[i103 + 4 >> 2] = gb + 827872;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i103, 66) | 0;
 HEAP32[i1 + 28 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = 1;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 1;
 HEAP32[i1 + 24 >> 2] = 66;
 HEAP32[i102 >> 2] = gb + 776474;
 HEAP32[i102 + 4 >> 2] = gb + 774325;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i102, 75) | 0;
 HEAP32[i1 + 28 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = 1;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 1;
 HEAP32[i1 + 24 >> 2] = 75;
 HEAP32[i101 >> 2] = gb + 776474;
 HEAP32[i101 + 4 >> 2] = gb + 774333;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i101, 67) | 0;
 HEAP32[i1 + 28 >> 2] = 2;
 HEAP32[i1 + 36 >> 2] = 2;
 HEAP32[i1 + 48 >> 2] = 2;
 HEAP32[i1 + 56 >> 2] = 2;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 2;
 HEAP32[i1 + 24 >> 2] = 67;
 HEAP32[i100 >> 2] = gb + 776474;
 HEAP32[i100 + 4 >> 2] = gb + 774339;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i100, 68) | 0;
 HEAP32[i1 + 28 >> 2] = 2;
 HEAP32[i1 + 36 >> 2] = 2;
 HEAP32[i1 + 48 >> 2] = 2;
 HEAP32[i1 + 56 >> 2] = 2;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 2;
 HEAP32[i1 + 24 >> 2] = 68;
 HEAP32[i99 >> 2] = gb + 776474;
 HEAP32[i99 + 4 >> 2] = gb + 774345;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i99, 69) | 0;
 HEAP32[i1 + 28 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = 4;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i1 + 24 >> 2] = 69;
 HEAP32[i98 >> 2] = gb + 776474;
 HEAP32[i98 + 4 >> 2] = gb + 827882;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i98, 70) | 0;
 HEAP32[i1 + 28 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = 4;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i1 + 24 >> 2] = 70;
 HEAP32[i97 >> 2] = gb + 776474;
 HEAP32[i97 + 4 >> 2] = gb + 827882;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i97, 70) | 0;
 HEAP32[i1 + 28 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = 4;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i1 + 24 >> 2] = 70;
 HEAP32[i96 >> 2] = gb + 776474;
 HEAP32[i96 + 4 >> 2] = gb + 774351;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i96, 71) | 0;
 HEAP32[i1 + 28 >> 2] = 8;
 HEAP32[i1 + 36 >> 2] = 8;
 HEAP32[i1 + 48 >> 2] = 8;
 HEAP32[i1 + 56 >> 2] = 8;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 8;
 HEAP32[i1 + 24 >> 2] = 71;
 HEAP32[i2 >> 2] = gb + 776474;
 HEAP32[i2 + 4 >> 2] = gb + 774357;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i2, 72) | 0;
 HEAP32[i1 + 28 >> 2] = 8;
 HEAP32[i1 + 36 >> 2] = 8;
 HEAP32[i1 + 48 >> 2] = 8;
 HEAP32[i1 + 56 >> 2] = 8;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 8;
 HEAP32[i1 + 24 >> 2] = 72;
 HEAP32[i3 >> 2] = gb + 776474;
 HEAP32[i3 + 4 >> 2] = gb + 774363;
 i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i3, 73) | 0;
 HEAP32[i1 + 28 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = 4;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i1 + 24 >> 2] = 73;
 HEAP32[i5 >> 2] = gb + 776474;
 HEAP32[i5 + 4 >> 2] = gb + 774369;
 i5 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i5, 74) | 0;
 HEAP32[i5 + 28 >> 2] = 8;
 HEAP32[i5 + 36 >> 2] = 8;
 HEAP32[i5 + 48 >> 2] = 8;
 HEAP32[i5 + 56 >> 2] = 8;
 HEAP8[i5 + 68 >> 0] = 1;
 HEAP32[i5 + 20 >> 2] = 8;
 HEAP32[i5 + 24 >> 2] = 74;
 HEAP32[i4 >> 2] = gb + 776474;
 HEAP32[i4 + 4 >> 2] = gb + 774375;
 i4 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i4, 77) | 0;
 HEAP32[i4 + 28 >> 2] = 4;
 HEAP32[i4 + 36 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = 8;
 HEAP32[i4 + 56 >> 2] = 8;
 HEAP8[i4 + 68 >> 0] = 1;
 HEAP32[i9 >> 2] = 2;
 HEAP32[i9 + 4 >> 2] = 0;
 i5 = i4 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 + 116 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i103 = i9;
  i104 = HEAP32[i103 + 4 >> 2] | 0;
  i105 = (HEAP32[i4 + 108 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i105 >> 2] = HEAP32[i103 >> 2];
  HEAP32[i105 + 4 >> 2] = i104;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 96 | 0, i9) | 0;
 HEAP32[i10 >> 2] = 2;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i4 + 136 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 + 140 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i2 = i4 + 132 | 0;
  i104 = i10;
  i105 = HEAP32[i104 + 4 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i104 >> 2];
  HEAP32[i1 + 4 >> 2] = i105;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 120 | 0, i10) | 0;
  i2 = i4 + 132 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i105 = HEAP32[i4 + 108 >> 2] | 0;
 i5 = i105 + (HEAP32[i5 >> 2] << 3) | 0;
 HEAP32[i4 + 40 >> 2] = i105;
 HEAP32[i4 + 44 >> 2] = i5;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = i5;
 HEAP32[i4 + 64 >> 2] = i5 + (i1 << 3);
 HEAP32[i6 >> 2] = gb + 776474;
 HEAP32[i6 + 4 >> 2] = gb + 776443;
 i4 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i6, 80) | 0;
 HEAP32[i4 + 28 >> 2] = 4;
 HEAP32[i4 + 36 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = 8;
 HEAP32[i4 + 56 >> 2] = 8;
 HEAP8[i4 + 68 >> 0] = 1;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = 0;
 i5 = i4 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 + 116 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i103 = i9;
  i104 = HEAP32[i103 + 4 >> 2] | 0;
  i105 = (HEAP32[i4 + 108 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i105 >> 2] = HEAP32[i103 >> 2];
  HEAP32[i105 + 4 >> 2] = i104;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 96 | 0, i9) | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i4 + 136 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 + 140 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i2 = i4 + 132 | 0;
  i104 = i10;
  i105 = HEAP32[i104 + 4 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i104 >> 2];
  HEAP32[i1 + 4 >> 2] = i105;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 120 | 0, i10) | 0;
  i2 = i4 + 132 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i105 = HEAP32[i4 + 108 >> 2] | 0;
 i5 = i105 + (HEAP32[i5 >> 2] << 3) | 0;
 HEAP32[i4 + 40 >> 2] = i105;
 HEAP32[i4 + 44 >> 2] = i5;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = i5;
 HEAP32[i4 + 64 >> 2] = i5 + (i1 << 3);
 HEAP32[i7 >> 2] = gb + 776474;
 HEAP32[i7 + 4 >> 2] = gb + 776461;
 i4 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i7, 78) | 0;
 HEAP32[i4 + 28 >> 2] = 4;
 HEAP32[i4 + 36 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = 8;
 HEAP32[i4 + 56 >> 2] = 8;
 HEAP8[i4 + 68 >> 0] = 1;
 HEAP32[i9 >> 2] = 2;
 HEAP32[i9 + 4 >> 2] = 0;
 i5 = i4 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 + 116 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i103 = i9;
  i104 = HEAP32[i103 + 4 >> 2] | 0;
  i105 = (HEAP32[i4 + 108 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i105 >> 2] = HEAP32[i103 >> 2];
  HEAP32[i105 + 4 >> 2] = i104;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 96 | 0, i9) | 0;
 HEAP32[i10 >> 2] = 2;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i4 + 136 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 + 140 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i2 = i4 + 132 | 0;
  i104 = i10;
  i105 = HEAP32[i104 + 4 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i104 >> 2];
  HEAP32[i1 + 4 >> 2] = i105;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 120 | 0, i10) | 0;
  i2 = i4 + 132 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i105 = HEAP32[i4 + 108 >> 2] | 0;
 i5 = i105 + (HEAP32[i5 >> 2] << 3) | 0;
 HEAP32[i4 + 40 >> 2] = i105;
 HEAP32[i4 + 44 >> 2] = i5;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = i5;
 HEAP32[i4 + 64 >> 2] = i5 + (i1 << 3);
 HEAP32[i8 >> 2] = gb + 776474;
 HEAP32[i8 + 4 >> 2] = gb + 776451;
 i4 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i8, 79) | 0;
 HEAP32[i4 + 28 >> 2] = 4;
 HEAP32[i4 + 36 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = 8;
 HEAP32[i4 + 56 >> 2] = 8;
 HEAP8[i4 + 68 >> 0] = 1;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = 0;
 i5 = i4 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 + 116 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i103 = i9;
  i104 = HEAP32[i103 + 4 >> 2] | 0;
  i105 = (HEAP32[i4 + 108 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i105 >> 2] = HEAP32[i103 >> 2];
  HEAP32[i105 + 4 >> 2] = i104;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 96 | 0, i9) | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i4 + 136 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 + 140 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i2 = i4 + 132 | 0;
  i104 = i10;
  i105 = HEAP32[i104 + 4 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i104 >> 2];
  HEAP32[i1 + 4 >> 2] = i105;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 120 | 0, i10) | 0;
  i2 = i4 + 132 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i104 = HEAP32[i4 + 108 >> 2] | 0;
 i105 = i104 + (HEAP32[i5 >> 2] << 3) | 0;
 HEAP32[i4 + 40 >> 2] = i104;
 HEAP32[i4 + 44 >> 2] = i105;
 i105 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = i105;
 HEAP32[i4 + 64 >> 2] = i105 + (i1 << 3);
 HEAP32[i38 >> 2] = gb + 776474;
 HEAP32[i38 + 4 >> 2] = gb + 774382;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i38, 76) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i39 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i40 >> 2] = 66;
 mftCall_viiiiiii(i104 | 0, i95 + 2344 | 0, i37 | 0, i39 | 0, gb + 1084155 | 0, gb + 1576256 | 0, i40 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i41 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i42 >> 2] = 66;
 mftCall_viiiiiii(i104 | 0, i95 + 2280 | 0, i37 | 0, i41 | 0, gb + 1086064 | 0, gb + 1576256 | 0, i42 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i43 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i44 >> 2] = 66;
 mftCall_viiiiiii(i104 | 0, i95 + 2216 | 0, i37 | 0, i43 | 0, gb + 1085890 | 0, gb + 1576256 | 0, i44 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i45 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i46 >> 2] = 66;
 mftCall_viiiiiii(i104 | 0, i95 + 2152 | 0, i37 | 0, i45 | 0, gb + 1085926 | 0, gb + 1576256 | 0, i46 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i47 >> 2] = gb + 776474;
 HEAP32[i47 + 4 >> 2] = gb + 774391;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i47, 81) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i48 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i49 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 2080 | 0, i37 | 0, i48 | 0, gb + 1085989 | 0, gb + 1576256 | 0, i49 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i50 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i51 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 2016 | 0, i37 | 0, i50 | 0, gb + 1085998 | 0, gb + 1576256 | 0, i51 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i52 >> 2] = gb + 776474;
 HEAP32[i52 + 4 >> 2] = gb + 829437;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i52, 82) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i53 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i54 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1944 | 0, i37 | 0, i53 | 0, gb + 1085989 | 0, gb + 1576256 | 0, i54 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i55 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i56 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1880 | 0, i37 | 0, i55 | 0, gb + 1085998 | 0, gb + 1576256 | 0, i56 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i57 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i58 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1816 | 0, i37 | 0, i57 | 0, gb + 1084342 | 0, gb + 1576256 | 0, i58 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i59 >> 2] = gb + 776474;
 HEAP32[i59 + 4 >> 2] = gb + 774398;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i59, 83) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i60 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i61 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1744 | 0, i37 | 0, i60 | 0, gb + 1085989 | 0, gb + 1576256 | 0, i61 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i62 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i63 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1680 | 0, i37 | 0, i62 | 0, gb + 1085998 | 0, gb + 1576256 | 0, i63 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i64 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i65 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1616 | 0, i37 | 0, i64 | 0, gb + 1084342 | 0, gb + 1576256 | 0, i65 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i66 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i67 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1552 | 0, i37 | 0, i66 | 0, gb + 1085899 | 0, gb + 1576256 | 0, i67 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i68 >> 2] = gb + 776474;
 HEAP32[i68 + 4 >> 2] = gb + 774405;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i68, 85) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i69 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i70 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1480 | 0, i37 | 0, i69 | 0, gb + 1085989 | 0, gb + 1576256 | 0, i70 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i71 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i72 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1416 | 0, i37 | 0, i71 | 0, gb + 1085998 | 0, gb + 1576256 | 0, i72 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i73 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i74 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1352 | 0, i37 | 0, i73 | 0, gb + 1084342 | 0, gb + 1576256 | 0, i74 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i75 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i76 >> 2] = 73;
 mftCall_viiiiiii(i104 | 0, i95 + 1288 | 0, i37 | 0, i75 | 0, gb + 1085899 | 0, gb + 1576256 | 0, i76 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i77 >> 2] = gb + 776474;
 HEAP32[i77 + 4 >> 2] = gb + 774412;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i77, 84) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i78 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i79 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 1216 | 0, i37 | 0, i78 | 0, gb + 774422 | 0, gb + 1576256 | 0, i79 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i80 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i81 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 1152 | 0, i37 | 0, i80 | 0, gb + 774430 | 0, gb + 1576256 | 0, i81 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i82 >> 2] = gb + 776474;
 HEAP32[i82 + 4 >> 2] = gb + 774438;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i82, 86) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i83 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i84 >> 2] = 85;
 mftCall_viiiiiii(i104 | 0, i95 + 1080 | 0, i37 | 0, i83 | 0, gb + 1084124 | 0, gb + 1576256 | 0, i84 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i85 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i86 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 1016 | 0, i37 | 0, i85 | 0, gb + 1084092 | 0, gb + 1576256 | 0, i86 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i87 >> 2] = gb + 776474;
 HEAP32[i87 + 4 >> 2] = gb + 774450;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i87, 87) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i88 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i89 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 944 | 0, i37 | 0, i88 | 0, gb + 774458 | 0, gb + 1576256 | 0, i89 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i90 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i91 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 880 | 0, i37 | 0, i90 | 0, gb + 774466 | 0, gb + 1576256 | 0, i91 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i92 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i93 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 816 | 0, i37 | 0, i92 | 0, gb + 774474 | 0, gb + 1576256 | 0, i93 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i94 >> 2] = gb + 776474;
 HEAP32[i94 + 4 >> 2] = gb + 774482;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i94, 88) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i12 >> 2] = 83;
 mftCall_viiiiiii(i104 | 0, i95 + 744 | 0, i37 | 0, i11 | 0, gb + 774458 | 0, gb + 1576256 | 0, i12 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i14 >> 2] = 83;
 mftCall_viiiiiii(i104 | 0, i95 + 680 | 0, i37 | 0, i13 | 0, gb + 774466 | 0, gb + 1576256 | 0, i14 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i16 >> 2] = 83;
 mftCall_viiiiiii(i104 | 0, i95 + 616 | 0, i37 | 0, i15 | 0, gb + 774474 | 0, gb + 1576256 | 0, i16 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i18 >> 2] = 83;
 mftCall_viiiiiii(i104 | 0, i95 + 552 | 0, i37 | 0, i17 | 0, gb + 774490 | 0, gb + 1576256 | 0, i18 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i19 >> 2] = gb + 776474;
 HEAP32[i19 + 4 >> 2] = gb + 774498;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i19, 89) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i20 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i21 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 480 | 0, i37 | 0, i20 | 0, gb + 774458 | 0, gb + 1576256 | 0, i21 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i23 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 416 | 0, i37 | 0, i22 | 0, gb + 774466 | 0, gb + 1576256 | 0, i23 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i24 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i25 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 352 | 0, i37 | 0, i24 | 0, gb + 774474 | 0, gb + 1576256 | 0, i25 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i27 >> 2] = 82;
 mftCall_viiiiiii(i104 | 0, i95 + 288 | 0, i37 | 0, i26 | 0, gb + 774490 | 0, gb + 1576256 | 0, i27 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 HEAP32[i28 >> 2] = gb + 776474;
 HEAP32[i28 + 4 >> 2] = gb + 774512;
 i105 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i37, i28, 90) | 0;
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 i103 = i105 + 12 | 0;
 HEAP32[i29 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i30 >> 2] = 70;
 mftCall_viiiiiii(i104 | 0, i95 + 216 | 0, i37 | 0, i29 | 0, gb + 774522 | 0, gb + 1576256 | 0, i30 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i31 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i32 >> 2] = 70;
 mftCall_viiiiiii(i104 | 0, i95 + 152 | 0, i37 | 0, i31 | 0, gb + 774525 | 0, gb + 1576256 | 0, i32 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i34 >> 2] = 70;
 mftCall_viiiiiii(i104 | 0, i95 + 88 | 0, i37 | 0, i33 | 0, gb + 774528 | 0, gb + 1576256 | 0, i34 | 0, 1);
 i104 = HEAP32[(HEAP32[i37 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i35 >> 2] = HEAP32[i103 >> 2];
 HEAP32[i36 >> 2] = 70;
 mftCall_viiiiiii(i104 | 0, i95 + 24 | 0, i37 | 0, i35 | 0, gb + 774531 | 0, gb + 1576256 | 0, i36 | 0, 1);
 HEAP8[i105 + 68 >> 0] = 1;
 STACKTOP = i95;
 return i37 | 0;
}

function __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb(i2, i13, i3, i114, i12, i1, i121, i115) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i114 = i114 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i121 = i121 | 0;
 i115 = i115 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, f89 = f0, f90 = f0, i91 = 0, i92 = 0, f93 = f0, f94 = f0, f95 = f0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i116 = 0, f117 = f0, i118 = 0, i119 = 0, i120 = 0, i122 = 0;
 i122 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i120 = i122 + 400 | 0;
 i1 = i122 + 220 | 0;
 i4 = i122 + 216 | 0;
 i109 = i122 + 268 | 0;
 i108 = i122 + 224 | 0;
 i99 = i122 + 72 | 0;
 i110 = i122 + 60 | 0;
 i111 = i122 + 56 | 0;
 i107 = i122 + 48 | 0;
 i113 = i122 + 36 | 0;
 i112 = i122 + 24 | 0;
 i100 = i122 + 12 | 0;
 i106 = i122 + 88 | 0;
 i103 = i122;
 i104 = HEAP32[i13 + 4 >> 2] | 0;
 HEAP32[i120 + 12 >> 2] = i104;
 i105 = i120 + 16 | 0;
 HEAP32[i105 >> 2] = i13;
 i101 = i120 + 4 | 0;
 HEAPF32[i101 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i13 + 8 >> 2]));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i13 + 12 >> 2]));
 HEAPF32[i120 >> 2] = f10;
 f11 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i13 + 16 >> 2]));
 i102 = i120 + 8 | 0;
 HEAPF32[i102 >> 2] = f11;
 f117 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f117 * Math_fround(.100000001));
 i118 = i3 + 16 | 0;
 f90 = Math_fround(HEAPF32[i118 >> 2]);
 f90 = Math_fround(f90 - Math_fround(HEAPF32[i114 + 16 >> 2]));
 i119 = i3 + 20 | 0;
 f53 = Math_fround(HEAPF32[i119 >> 2]);
 f53 = Math_fround(f53 - Math_fround(HEAPF32[i114 + 20 >> 2]));
 i116 = i3 + 24 | 0;
 f50 = Math_fround(HEAPF32[i116 >> 2]);
 f90 = Math_fround(f90 * Math_fround(2.0));
 f53 = Math_fround(f53 * Math_fround(2.0));
 f50 = Math_fround(Math_fround(f50 - Math_fround(HEAPF32[i114 + 24 >> 2])) * Math_fround(2.0));
 i96 = i114 + 12 | 0;
 f52 = Math_fround(HEAPF32[i96 >> 2]);
 f51 = Math_fround(Math_fround(f52 * f52) + Math_fround(-.5));
 f89 = Math_fround(HEAPF32[i114 >> 2]);
 f95 = Math_fround(f90 * f89);
 i97 = i114 + 4 | 0;
 f6 = Math_fround(HEAPF32[i97 >> 2]);
 f95 = Math_fround(f95 + Math_fround(f53 * f6));
 i98 = i114 + 8 | 0;
 f5 = Math_fround(HEAPF32[i98 >> 2]);
 f95 = Math_fround(f95 + Math_fround(f50 * f5));
 f93 = Math_fround(Math_fround(f89 * f95) + Math_fround(Math_fround(f90 * f51) - Math_fround(f52 * Math_fround(Math_fround(f50 * f6) - Math_fround(f53 * f5)))));
 f94 = Math_fround(Math_fround(f6 * f95) + Math_fround(Math_fround(f53 * f51) - Math_fround(f52 * Math_fround(Math_fround(f90 * f5) - Math_fround(f50 * f89)))));
 f95 = Math_fround(Math_fround(Math_fround(f50 * f51) - Math_fround(f52 * Math_fround(Math_fround(f53 * f89) - Math_fround(f90 * f6)))) + Math_fround(f5 * f95));
 f5 = Math_fround(f10 * f93);
 f6 = Math_fround(f11 * f95);
 do if (f6 >= Math_fround(0.0) & f5 >= Math_fround(0.0)) if (f5 < Math_fround(Math_fround(HEAPF32[i104 + 24 >> 2]) + Math_fround(1.0))) if (f6 < Math_fround(Math_fround(HEAPF32[i104 + 28 >> 2]) + Math_fround(1.0))) {
  i2 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i104, f5, f6, i1, i4) | 0;
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f9 = Math_fround(f94 - Math_fround(__ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff(i120, i2, f7, f5)));
  i1 = i104 + 40 | 0;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  if (!(f6 <= f9) | (!(f9 <= f8) | !(f6 <= Math_fround(0.0)))) if (!(f6 > f9 & (f9 > Math_fround(-f8) & f6 > Math_fround(0.0)))) {
   f5 = Math_fround(HEAPF32[i120 >> 2]);
   f6 = Math_fround(HEAPF32[i102 >> 2]);
   break;
  }
  i4 = __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff(i120, i2, f7, f5) | 0;
  if ((i4 | 0) == -1) {
   i121 = 0;
   STACKTOP = i122;
   return i121 | 0;
  }
  f90 = Math_fround(HEAPF32[i97 >> 2]);
  f93 = Math_fround(f90 * Math_fround(2.0));
  f6 = Math_fround(HEAPF32[i96 >> 2]);
  f95 = Math_fround(f6 * Math_fround(2.0));
  f94 = Math_fround(HEAPF32[i98 >> 2]);
  f5 = Math_fround(f94 * f95);
  f7 = Math_fround(HEAPF32[i114 >> 2]);
  f5 = Math_fround(Math_fround(f93 * f7) - f5);
  f6 = Math_fround(Math_fround(f90 * f93) + Math_fround(Math_fround(f6 * f95) + Math_fround(-1.0)));
  f7 = Math_fround(Math_fround(f93 * f94) + Math_fround(f95 * f7));
  i120 = !(Math_fround(HEAPF32[i1 >> 2]) <= Math_fround(0.0));
  i1 = i121 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2 >>> 0 > 63;
  if (i120) {
   if (i3) {
    i121 = 1;
    STACKTOP = i122;
    return i121 | 0;
   }
   f117 = Math_fround(Math_fround(-f9) - f117);
   f95 = Math_fround(-f7);
   f94 = Math_fround(-f6);
   f93 = Math_fround(-f5);
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i121 + (i2 << 6) >> 2] = f93;
   HEAPF32[i121 + (i2 << 6) + 4 >> 2] = f94;
   HEAPF32[i121 + (i2 << 6) + 8 >> 2] = f95;
   HEAP32[i121 + (i2 << 6) + 16 >> 2] = HEAP32[i118 >> 2];
   HEAP32[i121 + (i2 << 6) + 20 >> 2] = HEAP32[i119 >> 2];
   HEAP32[i121 + (i2 << 6) + 24 >> 2] = HEAP32[i116 >> 2];
   HEAPF32[i121 + (i2 << 6) + 12 >> 2] = f117;
   HEAP32[i121 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i121 + (i2 << 6) + 52 >> 2] = i4;
   i121 = 1;
   STACKTOP = i122;
   return i121 | 0;
  } else {
   if (i3) {
    i121 = 1;
    STACKTOP = i122;
    return i121 | 0;
   }
   f117 = Math_fround(f9 - f117);
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i121 + (i2 << 6) >> 2] = f5;
   HEAPF32[i121 + (i2 << 6) + 4 >> 2] = f6;
   HEAPF32[i121 + (i2 << 6) + 8 >> 2] = f7;
   HEAP32[i121 + (i2 << 6) + 16 >> 2] = HEAP32[i118 >> 2];
   HEAP32[i121 + (i2 << 6) + 20 >> 2] = HEAP32[i119 >> 2];
   HEAP32[i121 + (i2 << 6) + 24 >> 2] = HEAP32[i116 >> 2];
   HEAPF32[i121 + (i2 << 6) + 12 >> 2] = f117;
   HEAP32[i121 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i121 + (i2 << 6) + 52 >> 2] = i4;
   i121 = 1;
   STACKTOP = i122;
   return i121 | 0;
  }
 } else {
  f5 = f10;
  f6 = f11;
 } else {
  f5 = f10;
  f6 = f11;
 } else {
  f5 = f10;
  f6 = f11;
 } while (0);
 f90 = Math_fround(f8 * f8);
 f53 = Math_fround(f117 + Math_fround(HEAPF32[i12 >> 2]));
 f89 = Math_fround(f53 * f53);
 f50 = Math_fround(f93 * f5);
 f52 = Math_fround(f95 * f6);
 f51 = Math_fround(f53 * Math_fround(Math_abs(Math_fround(f10))));
 f53 = Math_fround(f53 * Math_fround(Math_abs(Math_fround(f11))));
 i77 = ~~Math_fround(Math_floor(Math_fround(f50 - f51)));
 i80 = HEAP32[i104 + 16 >> 2] | 0;
 i78 = i80 + -2 | 0;
 i77 = (i77 | 0) > 0 ? i77 : 0;
 i77 = (i77 | 0) > (i78 | 0) ? i78 : i77;
 i78 = ~~Math_fround(Math_ceil(Math_fround(f50 + f51)));
 i80 = i80 + -1 | 0;
 i78 = (i78 | 0) > 0 ? i78 : 0;
 i78 = (i78 | 0) > (i80 | 0) ? i80 : i78;
 i80 = ~~Math_fround(Math_floor(Math_fround(f52 - f53)));
 i91 = i104 + 20 | 0;
 i79 = HEAP32[i91 >> 2] | 0;
 i81 = i79 + -2 | 0;
 i80 = (i80 | 0) > 0 ? i80 : 0;
 i80 = (i80 | 0) > (i81 | 0) ? i81 : i80;
 i81 = ~~Math_fround(Math_ceil(Math_fround(f52 + f53)));
 i82 = i79 + -1 | 0;
 i81 = (i81 | 0) > 0 ? i81 : 0;
 i81 = (i81 | 0) > (i82 | 0) ? i82 : i81;
 i82 = i77 >>> 0 < i78 >>> 0;
 i92 = i121 + 4096 | 0;
 i83 = i80 >>> 0 < i81 >>> 0;
 i84 = i99 + 4 | 0;
 i85 = i99 + 8 | 0;
 i86 = i110 + 4 | 0;
 i87 = i110 + 8 | 0;
 i88 = i104 + 40 | 0;
 i64 = i13 + 20 | 0;
 i65 = i103 + 4 | 0;
 i66 = i103 + 8 | 0;
 i67 = i100 + 4 | 0;
 i68 = i100 + 8 | 0;
 i69 = i104 + 36 | 0;
 i70 = i112 + 8 | 0;
 i71 = i112 + 4 | 0;
 i72 = i113 + 4 | 0;
 i73 = i113 + 8 | 0;
 i74 = i104 + 16 | 0;
 i75 = i107 + 4 | 0;
 i3 = 0;
 i4 = 0;
 i1 = 0;
 i76 = 0;
 i2 = 0;
 while (1) {
  i63 = (i76 | 0) == 0;
  if (i82) {
   i62 = i63 ^ 1;
   i61 = i77;
   while (1) {
    if (i83) {
     i60 = i80;
     do {
      HEAPF32[i99 >> 2] = f93;
      HEAPF32[i84 >> 2] = f94;
      HEAPF32[i85 >> 2] = f95;
      i59 = __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb(i120, i61, i60, i99, i109, i108, i63, i62, 1) | 0;
      if (i59) {
       i58 = 0;
       do {
        i54 = i109 + (i58 * 12 | 0) | 0;
        f6 = Math_fround(HEAPF32[i54 >> 2]);
        f7 = Math_fround(f93 - f6);
        f8 = Math_fround(f94 - Math_fround(HEAPF32[i109 + (i58 * 12 | 0) + 4 >> 2]));
        i55 = i109 + (i58 * 12 | 0) + 8 | 0;
        f5 = Math_fround(HEAPF32[i55 >> 2]);
        f9 = Math_fround(f95 - f5);
        HEAPF32[i110 >> 2] = f7;
        HEAPF32[i86 >> 2] = f8;
        HEAPF32[i87 >> 2] = f9;
        f10 = Math_fround(HEAPF32[i88 >> 2]);
        if (f8 > Math_fround(0.0) & f10 <= Math_fround(0.0)) i14 = 20; else if (f8 < Math_fround(0.0) & f10 > Math_fround(0.0)) i14 = 20;
        if ((i14 | 0) == 20) {
         i14 = 0;
         f53 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
         if (!(f53 > f89)) {
          HEAPF32[i111 >> 2] = Math_fround(-1.0);
          i56 = i108 + (i58 << 2) | 0;
          i12 = HEAP32[i56 >> 2] | 0;
          i57 = i12 >>> 30;
          L41 : do switch (i57 | 0) {
          case 1:
           {
            i13 = i12 & 1073741823;
            i14 = (i13 >>> 0) / 3 | 0;
            i3 = HEAP32[i91 >> 2] | 0;
            i4 = (i14 >>> 0) / (i3 >>> 0) | 0;
            i12 = (i14 >>> 0) % (i3 >>> 0) | 0;
            switch (i13 + (Math_imul(i14, -3) | 0) | 0) {
            case 0:
             {
              if (i12 >>> 0 < (i3 + -1 | 0) >>> 0) {
               if (!i4) i1 = 0; else {
                i1 = i14 - i3 | 0;
                HEAP32[i107 >> 2] = (i1 << 1 | 1) - ((HEAPU8[(HEAP32[i69 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >>> 7 & 255);
                i1 = 1;
               }
               if (i4 >>> 0 < ((HEAP32[i74 >> 2] | 0) + -1 | 0) >>> 0) {
                HEAP32[i107 + (i1 << 2) >> 2] = (HEAPU8[(HEAP32[i69 >> 2] | 0) + (i14 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i14 << 1;
                i47 = i1 + 1 | 0;
               } else i47 = i1;
              } else i47 = 0;
              break;
             }
            case 1:
             {
              if (i12 >>> 0 < (i3 + -1 | 0) >>> 0 ? i4 >>> 0 < ((HEAP32[i74 >> 2] | 0) + -1 | 0) >>> 0 : 0) {
               i47 = i14 << 1;
               HEAP32[i107 >> 2] = i47;
               HEAP32[i75 >> 2] = i47 | 1;
               i47 = 2;
              } else i47 = 0;
              break;
             }
            case 2:
             {
              if (i4 >>> 0 < ((HEAP32[i74 >> 2] | 0) + -1 | 0) >>> 0) {
               if (!i12) i1 = 0; else {
                HEAP32[i107 >> 2] = (i14 << 1) + -1;
                i1 = 1;
               }
               if (i12 >>> 0 < (i3 + -1 | 0) >>> 0) {
                HEAP32[i107 + (i1 << 2) >> 2] = i14 << 1;
                i47 = i1 + 1 | 0;
               } else i47 = i1;
              } else i47 = 0;
              break;
             }
            default:
             i47 = 0;
            }
            __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_(i120, i13, i14, (i14 >>> 0) / (i79 >>> 0) | 0, (i14 >>> 0) % (i79 >>> 0) | 0, i113, i112);
            f45 = Math_fround(HEAPF32[i54 >> 2]);
            __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf(i100, i120, HEAPU8[i64 >> 0] | 0, i110, i114, f53, f45, Math_fround(HEAPF32[i55 >> 2]), f90, i111);
            i3 = HEAP32[i100 >> 2] | 0;
            i4 = HEAP32[i67 >> 2] | 0;
            i1 = HEAP32[i68 >> 2] | 0;
            f45 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
            f44 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
            f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
            f48 = Math_fround(HEAPF32[i96 >> 2]);
            f49 = Math_fround(Math_fround(f48 * f48) + Math_fround(-.5));
            f50 = Math_fround(HEAPF32[i114 >> 2]);
            f29 = Math_fround(f45 * f50);
            f51 = Math_fround(HEAPF32[i97 >> 2]);
            f29 = Math_fround(f29 + Math_fround(f44 * f51));
            f52 = Math_fround(HEAPF32[i98 >> 2]);
            f29 = Math_fround(f29 + Math_fround(f43 * f52));
            f27 = Math_fround(Math_fround(f50 * f29) + Math_fround(Math_fround(f45 * f49) - Math_fround(f48 * Math_fround(Math_fround(f43 * f51) - Math_fround(f44 * f52)))));
            f28 = Math_fround(Math_fround(f51 * f29) + Math_fround(Math_fround(f44 * f49) - Math_fround(f48 * Math_fround(Math_fround(f45 * f52) - Math_fround(f43 * f50)))));
            f29 = Math_fround(Math_fround(Math_fround(f43 * f49) - Math_fround(f48 * Math_fround(Math_fround(f44 * f50) - Math_fround(f45 * f51)))) + Math_fround(f52 * f29));
            if (!i47) i14 = 75; else {
             i30 = HEAP32[i69 >> 2] | 0;
             i31 = HEAP32[i91 >> 2] | 0;
             i46 = Math_fround(HEAPF32[i88 >> 2]) >= Math_fround(0.0);
             f32 = i46 ? Math_fround(-1.0) : Math_fround(1.0);
             f33 = Math_fround(HEAPF32[i120 >> 2]);
             f34 = Math_fround(f32 * Math_fround(HEAPF32[i101 >> 2]));
             f35 = Math_fround(HEAPF32[i102 >> 2]);
             f36 = Math_fround(f34 * f34);
             i46 = HEAP32[i105 >> 2] | 0;
             f37 = Math_fround(HEAPF32[i46 + 12 >> 2]);
             f38 = Math_fround(HEAPF32[i46 + 8 >> 2]);
             f39 = Math_fround(HEAPF32[i46 + 16 >> 2]);
             f40 = Math_fround(HEAPF32[i70 >> 2]);
             f41 = Math_fround(HEAPF32[i71 >> 2]);
             f42 = Math_fround(HEAPF32[i112 >> 2]);
             f43 = Math_fround(HEAPF32[i113 >> 2]);
             f44 = Math_fround(HEAPF32[i72 >> 2]);
             f45 = Math_fround(HEAPF32[i73 >> 2]);
             i46 = 0;
             while (1) {
              i26 = HEAP32[i107 + (i46 << 2) >> 2] | 0;
              i16 = i26 >>> 1;
              i25 = (HEAP8[i30 + (i16 << 2) + 2 >> 0] | 0) < 0;
              i26 = (i26 & 1 | 0) == 0;
              do if (i25) if (i26) {
               i13 = i31 + i16 | 0;
               i14 = i16;
               i12 = i16 + 1 + i31 | 0;
               break;
              } else {
               i14 = i16 + 1 | 0;
               i13 = i14;
               i14 = i31 + i14 | 0;
               i12 = i16;
               break;
              } else {
               i12 = i16 + 1 | 0;
               if (i26) {
                i13 = i16;
                i14 = i12;
                i12 = i31 + i16 | 0;
                break;
               } else {
                i13 = i31 + i12 | 0;
                i14 = i31 + i16 | 0;
                break;
               }
              } while (0);
              i15 = HEAP16[i30 + (i13 << 2) >> 1] | 0;
              i13 = HEAP16[i30 + (i14 << 2) >> 1] | 0;
              i12 = HEAP16[i30 + (i12 << 2) >> 1] | 0;
              do if (i25) if (i26) {
               f6 = Math_fround(Math_fround(i13 - i15 | 0) * f32);
               f5 = Math_fround(f32 * Math_fround(i15 - i12 | 0));
               break;
              } else {
               f6 = Math_fround(Math_fround(i15 - i13 | 0) * f32);
               f5 = Math_fround(f32 * Math_fround(i12 - i15 | 0));
               break;
              } else if (i26) {
               f6 = Math_fround(f32 * Math_fround(i15 - i12 | 0));
               f5 = Math_fround(Math_fround(i15 - i13 | 0) * f32);
               break;
              } else {
               f6 = Math_fround(f32 * Math_fround(i12 - i15 | 0));
               f5 = Math_fround(Math_fround(i13 - i15 | 0) * f32);
               break;
              } while (0);
              f8 = Math_fround(f6 * f33);
              f5 = Math_fround(f5 * f35);
              f6 = Math_fround(Math_fround(Math_fround(f8 * f8) + f36) + Math_fround(f5 * f5));
              if (f6 > Math_fround(0.0)) {
               f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
               f7 = Math_fround(f5 * f24);
               f6 = Math_fround(f34 * f24);
               f5 = Math_fround(f8 * f24);
              } else {
               f7 = Math_fround(0.0);
               f6 = Math_fround(0.0);
               f5 = Math_fround(0.0);
              }
              i12 = (i16 >>> 0) / (i31 >>> 0) | 0;
              i13 = (i16 >>> 0) % (i31 >>> 0) | 0;
              f8 = Math_fround(HEAP16[i30 + (i16 << 2) >> 1] | 0);
              f19 = Math_fround(HEAP16[i30 + (i16 + 1 << 2) >> 1] | 0);
              i16 = i31 + i16 | 0;
              f9 = Math_fround(HEAP16[i30 + (i16 << 2) >> 1] | 0);
              f11 = Math_fround(HEAP16[i30 + (i16 + 1 << 2) >> 1] | 0);
              do if (i26) if (i25) {
               f10 = Math_fround((i12 + 1 | 0) >>> 0);
               f24 = Math_fround(i13 >>> 0);
               f17 = f10;
               f18 = Math_fround(i12 >>> 0);
               f20 = f9;
               f21 = f8;
               f23 = f24;
               f8 = f11;
               f9 = Math_fround((i13 + 1 | 0) >>> 0);
               break;
              } else {
               f18 = Math_fround(i12 >>> 0);
               f22 = Math_fround(i13 >>> 0);
               f17 = f18;
               f20 = f8;
               f21 = f19;
               f23 = f22;
               f24 = Math_fround((i13 + 1 | 0) >>> 0);
               f10 = Math_fround((i12 + 1 | 0) >>> 0);
               f8 = f9;
               f9 = f22;
               break;
              } else if (i25) {
               f10 = Math_fround(i12 >>> 0);
               f24 = Math_fround((i13 + 1 | 0) >>> 0);
               f17 = f10;
               f18 = Math_fround((i12 + 1 | 0) >>> 0);
               f20 = f19;
               f21 = f11;
               f23 = f24;
               f9 = Math_fround(i13 >>> 0);
               break;
              } else {
               f18 = Math_fround((i12 + 1 | 0) >>> 0);
               f22 = Math_fround((i13 + 1 | 0) >>> 0);
               f17 = f18;
               f20 = f11;
               f21 = f9;
               f23 = f22;
               f24 = Math_fround(i13 >>> 0);
               f10 = Math_fround(i12 >>> 0);
               f8 = f19;
               f9 = f22;
               break;
              } while (0);
              f22 = Math_fround(Math_fround(Math_fround(Math_fround(f17 + f18) + f10) * Math_fround(.333333343)) * f37);
              f19 = Math_fround(Math_fround(Math_fround(Math_fround(f20 + f21) + f8) * Math_fround(.333333343)) * f38);
              f18 = Math_fround(Math_fround(Math_fround(Math_fround(f23 + f24) + f9) * Math_fround(.333333343)) * f39);
              f17 = Math_fround(Math_fround(f6 * f40) - Math_fround(f7 * f41));
              f11 = Math_fround(Math_fround(f7 * f42) - Math_fround(f5 * f40));
              f8 = Math_fround(Math_fround(f5 * f41) - Math_fround(f6 * f42));
              f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f17 * f17) + Math_fround(f11 * f11)));
              if (f9 > Math_fround(0.0)) {
               f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9))));
               f10 = Math_fround(f8 * f24);
               f9 = Math_fround(f11 * f24);
               f8 = Math_fround(f17 * f24);
              } else {
               f10 = Math_fround(0.0);
               f9 = Math_fround(0.0);
               f8 = Math_fround(0.0);
              }
              if (Math_fround(Math_fround(Math_fround(f8 * Math_fround(f22 - f43)) + Math_fround(f9 * Math_fround(f19 - f44))) + Math_fround(f10 * Math_fround(f18 - f45))) < Math_fround(0.0)) {
               f10 = Math_fround(-f10);
               f9 = Math_fround(-f9);
               f8 = Math_fround(-f8);
              }
              i46 = i46 + 1 | 0;
              if (Math_fround(Math_fround(f29 * f10) + Math_fround(Math_fround(f28 * f9) + Math_fround(f27 * f8))) > Math_fround(0.0)) break;
              if (i46 >>> 0 >= i47 >>> 0) {
               i14 = 75;
               break L41;
              }
             }
             f42 = Math_fround(f5 * Math_fround(2.0));
             f41 = Math_fround(f6 * Math_fround(2.0));
             f40 = Math_fround(f7 * Math_fround(2.0));
             f43 = Math_fround(Math_fround(Math_fround(f42 * f50) + Math_fround(f41 * f51)) + Math_fround(f40 * f52));
             f44 = Math_fround(Math_fround(f50 * f43) + Math_fround(Math_fround(f42 * f49) + Math_fround(f48 * Math_fround(Math_fround(f40 * f51) - Math_fround(f41 * f52)))));
             f45 = Math_fround(Math_fround(f51 * f43) + Math_fround(Math_fround(f41 * f49) + Math_fround(f48 * Math_fround(Math_fround(f42 * f52) - Math_fround(f40 * f50)))));
             f52 = Math_fround(Math_fround(Math_fround(f40 * f49) + Math_fround(f48 * Math_fround(Math_fround(f41 * f50) - Math_fround(f42 * f51)))) + Math_fround(f52 * f43));
             i3 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
             i4 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
             i1 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
             i14 = 75;
            }
            break;
           }
          case 2:
           {
            i16 = HEAP32[i92 >> 2] | 0;
            i15 = i12 & 1073741823;
            i15 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(i104, i15, (i15 >>> 0) / (i79 >>> 0) | 0, (i15 >>> 0) % (i79 >>> 0) | 0, i106) | 0;
            if (!(i2 >>> 0 >= i16 >>> 0 | (i15 | 0) == 0)) {
             i14 = i2;
             do {
              L107 : do if ((HEAP32[i121 + (i14 << 6) + 48 >> 2] | 0) == 1) {
               i12 = HEAP32[i121 + (i14 << 6) + 52 >> 2] | 0;
               i13 = 0;
               while (1) {
                if ((HEAP32[i106 + (i13 << 4) >> 2] | 0) == (i12 | 0)) break;
                i13 = i13 + 1 | 0;
                if (i13 >>> 0 >= i15 >>> 0) break L107;
               }
               i3 = HEAP32[i121 + (i14 << 6) >> 2] | 0;
               i4 = HEAP32[i121 + (i14 << 6) + 4 >> 2] | 0;
               i1 = HEAP32[i121 + (i14 << 6) + 8 >> 2] | 0;
               HEAPF32[i111 >> 2] = Math_fround(Math_sqrt(Math_fround(f53)));
              } while (0);
              i14 = i14 + 1 | 0;
             } while ((i14 | 0) != (i16 | 0));
            }
            i14 = 75;
            break;
           }
          default:
           i14 = 77;
          } while (0);
          if ((i14 | 0) == 75) {
           i14 = 0;
           if (Math_fround(HEAPF32[i111 >> 2]) == Math_fround(-1.0)) {
            f6 = Math_fround(HEAPF32[i54 >> 2]);
            f5 = Math_fround(HEAPF32[i55 >> 2]);
            i14 = 77;
           }
          }
          if ((i14 | 0) == 77) {
           i14 = 0;
           __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf(i103, i120, HEAPU8[i64 >> 0] | 0, i110, i114, f53, f6, f5, f90, i111);
           i1 = HEAP32[i66 >> 2] | 0;
           i4 = HEAP32[i65 >> 2] | 0;
           i3 = HEAP32[i103 >> 2] | 0;
          }
          i12 = HEAP32[i92 >> 2] | 0;
          if (i12 >>> 0 <= 63) {
           i56 = HEAP32[i56 >> 2] & 1073741823;
           f53 = Math_fround(Math_fround(HEAPF32[i111 >> 2]) - f117);
           f52 = Math_fround(HEAPF32[i116 >> 2]);
           f52 = Math_fround(f52 - Math_fround(f117 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
           f51 = Math_fround(HEAPF32[i119 >> 2]);
           f51 = Math_fround(f51 - Math_fround(f117 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
           f50 = Math_fround(HEAPF32[i118 >> 2]);
           f50 = Math_fround(f50 - Math_fround(f117 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
           HEAP32[i92 >> 2] = i12 + 1;
           HEAP32[i121 + (i12 << 6) >> 2] = i3;
           HEAP32[i121 + (i12 << 6) + 4 >> 2] = i4;
           HEAP32[i121 + (i12 << 6) + 8 >> 2] = i1;
           HEAPF32[i121 + (i12 << 6) + 16 >> 2] = f50;
           HEAPF32[i121 + (i12 << 6) + 20 >> 2] = f51;
           HEAPF32[i121 + (i12 << 6) + 24 >> 2] = f52;
           HEAPF32[i121 + (i12 << 6) + 12 >> 2] = f53;
           HEAP32[i121 + (i12 << 6) + 48 >> 2] = i57;
           HEAP32[i121 + (i12 << 6) + 52 >> 2] = i56;
          }
         }
        }
        i58 = i58 + 1 | 0;
       } while ((i58 | 0) != (i59 | 0));
      }
      i60 = i60 + 1 | 0;
     } while (i60 >>> 0 < i81 >>> 0);
    }
    i61 = i61 + 1 | 0;
    if (i61 >>> 0 >= i78 >>> 0) {
     i12 = i1;
     break;
    }
   }
  } else i12 = i1;
  i1 = HEAP32[i92 >> 2] | 0;
  i2 = i63 ? i1 : i2;
  i76 = i76 + 1 | 0;
  if ((i76 | 0) == 2) break; else i1 = i12;
 }
 if (!i115) if (!i2) i2 = 0; else {
  i3 = 0;
  do {
   HEAP32[i121 + (i3 << 6) + 48 >> 2] = -1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 L132 : do if (i2 >>> 0 < i1 >>> 0) while (1) {
  i1 = i121 + (i2 << 6) + 52 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i121 + (i2 << 6) + 48 | 0;
  switch (HEAP32[i4 >> 2] | 0) {
  case 1:
   {
    HEAP32[i1 >> 2] = __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i120, i3) | 0;
    break;
   }
  case 2:
   {
    i119 = HEAP32[i91 >> 2] | 0;
    HEAP32[i1 >> 2] = __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj(i120, i3, (i3 >>> 0) / (i119 >>> 0) | 0, (i3 >>> 0) % (i119 >>> 0) | 0) | 0;
    break;
   }
  default:
   {}
  }
  HEAP32[i4 >> 2] = -1;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i92 >> 2] | 0;
  if (i2 >>> 0 >= i1 >>> 0) break L132;
 } while (0);
 i121 = (i1 | 0) != 0;
 STACKTOP = i122;
 return i121 | 0;
}

function __ZN5physx3Cct26CharacterControllerManager19computeInteractionsEfPNS_26PxControllerFilterCallbackE(i1, f11, i133) {
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 i133 = i133 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, f77 = f0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0;
 i144 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i131 = i144 + 56 | 0;
 i132 = i144;
 i136 = i144 + 268 | 0;
 i138 = i144 + 256 | 0;
 i140 = i144 + 252 | 0;
 i141 = i144 + 248 | 0;
 i126 = i144 + 236 | 0;
 i127 = i144 + 224 | 0;
 i135 = i144 + 212 | 0;
 i137 = i144 + 200 | 0;
 i142 = i144 + 196 | 0;
 i134 = i144 + 184 | 0;
 i129 = i144 + 148 | 0;
 i130 = i144 + 124 | 0;
 i139 = i144 + 136 | 0;
 i10 = i144 + 112 | 0;
 i128 = i144 + 280 | 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i125 = i1 + 64 | 0;
 i2 = HEAP32[i125 >> 2] | 0;
 i1 = i3 * 24 | 0;
 i124 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i144 + 281 | 0, i1, gb + 657349 | 0, 623) | 0;
 if (!i3) i1 = i124; else {
  i5 = i131 + 8 | 0;
  i6 = i131 + 16 | 0;
  i7 = i131 + 24 | 0;
  i8 = i131 + 32 | 0;
  i9 = i131 + 40 | 0;
  i1 = i124 + i1 | 0;
  i4 = i124;
  while (1) {
   i3 = i3 + -1 | 0;
   i123 = HEAP32[i2 >> 2] | 0;
   mftCall_iii(HEAP32[(HEAP32[i123 >> 2] | 0) + 16 >> 2] | 0, i123 | 0, i131 | 0) | 0;
   f54 = Math_fround(+HEAPF64[i131 >> 3]);
   f55 = Math_fround(+HEAPF64[i5 >> 3]);
   f56 = Math_fround(+HEAPF64[i6 >> 3]);
   f57 = Math_fround(+HEAPF64[i7 >> 3]);
   f58 = Math_fround(+HEAPF64[i8 >> 3]);
   f77 = Math_fround(+HEAPF64[i9 >> 3]);
   HEAPF32[i4 >> 2] = f54;
   HEAPF32[i4 + 4 >> 2] = f55;
   HEAPF32[i4 + 8 >> 2] = f56;
   HEAPF32[i4 + 12 >> 2] = f57;
   HEAPF32[i4 + 16 >> 2] = f58;
   HEAPF32[i4 + 20 >> 2] = f77;
   if (!i3) break; else {
    i2 = i2 + 4 | 0;
    i4 = i4 + 24 | 0;
   }
  }
 }
 HEAP32[i139 >> 2] = 0;
 i122 = i139 + 4 | 0;
 HEAP32[i122 >> 2] = 0;
 i123 = i139 + 8 | 0;
 HEAP32[i123 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 2;
 HEAP32[i10 + 8 >> 2] = 1;
 __ZN5physx2Gu18CompleteBoxPruningEPKNS_9PxBounds3EjRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE(i124, (i1 - i124 | 0) / 24 | 0, i139, i10) | 0;
 i1 = (HEAP32[i122 >> 2] | 0) >>> 1;
 if (i1 | 0) {
  i104 = (i133 | 0) == 0;
  i105 = i131 + 8 | 0;
  i106 = i131 + 16 | 0;
  i107 = i131 + 36 | 0;
  i108 = i131 + 40 | 0;
  i109 = i131 + 44 | 0;
  i110 = i131 + 48 | 0;
  i111 = i132 + 8 | 0;
  i112 = i132 + 16 | 0;
  i113 = i132 + 36 | 0;
  i114 = i132 + 40 | 0;
  i115 = i132 + 44 | 0;
  i116 = i132 + 48 | 0;
  i117 = i131 + 24 | 0;
  i118 = i132 + 24 | 0;
  i119 = i118 + 4 | 0;
  i120 = i118 + 8 | 0;
  i121 = i117 + 4 | 0;
  i122 = i117 + 8 | 0;
  f77 = Math_fround(f11 * Math_fround(4.0));
  i78 = i131 + 48 | 0;
  i79 = i132 + 48 | 0;
  i80 = i131 + 8 | 0;
  i81 = i131 + 16 | 0;
  i82 = i136 + 4 | 0;
  i83 = i136 + 8 | 0;
  i84 = i131 + 24 | 0;
  i85 = i131 + 32 | 0;
  i86 = i131 + 40 | 0;
  i87 = i132 + 8 | 0;
  i88 = i132 + 16 | 0;
  i89 = i138 + 4 | 0;
  i90 = i138 + 8 | 0;
  i91 = i132 + 24 | 0;
  i92 = i132 + 32 | 0;
  i93 = i132 + 40 | 0;
  i94 = i126 + 4 | 0;
  i95 = i126 + 8 | 0;
  i96 = i127 + 4 | 0;
  i97 = i127 + 8 | 0;
  i98 = i132 + 8 | 0;
  i99 = i132 + 16 | 0;
  i100 = i135 + 4 | 0;
  i101 = i135 + 8 | 0;
  i102 = i132 + 24 | 0;
  i103 = i132 + 32 | 0;
  i8 = i132 + 40 | 0;
  i9 = i137 + 4 | 0;
  i10 = i137 + 8 | 0;
  i59 = i131 + 36 | 0;
  i60 = i131 + 40 | 0;
  i61 = i131 + 44 | 0;
  i62 = i131 + 48 | 0;
  i63 = i129 + 4 | 0;
  i64 = i129 + 8 | 0;
  i65 = i129 + 12 | 0;
  i66 = i129 + 16 | 0;
  i67 = i129 + 20 | 0;
  i68 = i129 + 24 | 0;
  i69 = i129 + 28 | 0;
  i70 = i129 + 32 | 0;
  i71 = i131 + 8 | 0;
  i72 = i131 + 16 | 0;
  i73 = i130 + 4 | 0;
  i74 = i130 + 8 | 0;
  i75 = i131 + 24 | 0;
  i76 = i132 + 48 | 0;
  i7 = HEAP32[i139 >> 2] | 0;
  do {
   i1 = i1 + -1 | 0;
   i3 = HEAP32[i125 >> 2] | 0;
   i2 = HEAP32[i3 + (HEAP32[i7 >> 2] << 2) >> 2] | 0;
   i3 = HEAP32[i3 + (HEAP32[i7 + 4 >> 2] << 2) >> 2] | 0;
   i7 = i7 + 8 | 0;
   if (i104) i143 = 9; else {
    i5 = HEAP32[(HEAP32[i133 >> 2] | 0) + 8 >> 2] | 0;
    i6 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
    if (mftCall_iiii(i5 | 0, i133 | 0, i6 | 0, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0) | 0) i143 = 9;
   }
   if ((i143 | 0) == 9) {
    i143 = 0;
    i6 = i2;
    i5 = i3;
    i4 = (HEAP32[i2 + 4 >> 2] | 0) > (HEAP32[i3 + 4 >> 2] | 0);
    i3 = i4 ? i5 : i6;
    i5 = i4 ? i6 : i5;
    i6 = i3;
    switch (HEAP32[i6 + 4 >> 2] | 0) {
    case 1:
     {
      i2 = i5;
      if ((HEAP32[i2 + 4 >> 2] | 0) == 1) {
       __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE((i3 | 0) == 0 ? 0 : i6 + -8 | 0, i131);
       __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE((i5 | 0) == 0 ? 0 : i2 + -8 | 0, i132);
       f17 = Math_fround(HEAPF32[i78 >> 2]);
       f17 = Math_fround(f17 + Math_fround(HEAPF32[i79 >> 2]));
       f54 = Math_fround(+HEAPF64[i131 >> 3]);
       f55 = Math_fround(+HEAPF64[i80 >> 3]);
       f56 = Math_fround(+HEAPF64[i81 >> 3]);
       HEAPF32[i136 >> 2] = f54;
       HEAPF32[i82 >> 2] = f55;
       HEAPF32[i83 >> 2] = f56;
       f11 = Math_fround(+HEAPF64[i84 >> 3]);
       f12 = Math_fround(+HEAPF64[i85 >> 3]);
       f13 = Math_fround(+HEAPF64[i86 >> 3]);
       f57 = Math_fround(+HEAPF64[i132 >> 3]);
       f58 = Math_fround(+HEAPF64[i87 >> 3]);
       f18 = Math_fround(+HEAPF64[i88 >> 3]);
       HEAPF32[i138 >> 2] = f57;
       HEAPF32[i89 >> 2] = f58;
       HEAPF32[i90 >> 2] = f18;
       f14 = Math_fround(+HEAPF64[i91 >> 3]);
       f15 = Math_fround(+HEAPF64[i92 >> 3]);
       f16 = Math_fround(+HEAPF64[i93 >> 3]);
       f55 = Math_fround(f12 - f55);
       f56 = Math_fround(f13 - f56);
       HEAPF32[i126 >> 2] = Math_fround(f11 - f54);
       HEAPF32[i94 >> 2] = f55;
       HEAPF32[i95 >> 2] = f56;
       f58 = Math_fround(f15 - f58);
       f18 = Math_fround(f16 - f18);
       HEAPF32[i127 >> 2] = Math_fround(f14 - f57);
       HEAPF32[i96 >> 2] = f58;
       HEAPF32[i97 >> 2] = f18;
       f18 = Math_fround(Math_sqrt(Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i136, i126, i138, i127, i140, i141))));
       if (f18 < f17) {
        f58 = Math_fround(HEAPF32[i140 >> 2]);
        f54 = Math_fround(HEAPF32[i136 >> 2]);
        f55 = Math_fround(HEAPF32[i82 >> 2]);
        f56 = Math_fround(Math_fround(1.0) - f58);
        f54 = Math_fround(Math_fround(f58 * f54) + Math_fround(f11 * f56));
        f55 = Math_fround(Math_fround(f12 * f56) + Math_fround(f58 * f55));
        f13 = Math_fround(Math_fround(f13 * f56) + Math_fround(f58 * Math_fround(HEAPF32[i83 >> 2])));
        f58 = Math_fround(HEAPF32[i141 >> 2]);
        f56 = Math_fround(HEAPF32[i138 >> 2]);
        f57 = Math_fround(HEAPF32[i89 >> 2]);
        f11 = Math_fround(Math_fround(1.0) - f58);
        f56 = Math_fround(Math_fround(f58 * f56) + Math_fround(f14 * f11));
        f57 = Math_fround(Math_fround(f15 * f11) + Math_fround(f58 * f57));
        f58 = Math_fround(Math_fround(f16 * f11) + Math_fround(f58 * Math_fround(HEAPF32[i90 >> 2])));
        f11 = Math_fround(HEAPF32[i6 + 332 >> 2]);
        f12 = Math_fround(HEAPF32[i6 + 336 >> 2]);
        f14 = Math_fround(HEAPF32[i6 + 340 >> 2]);
        f56 = Math_fround(f54 - f56);
        f57 = Math_fround(f55 - f57);
        f58 = Math_fround(f13 - f58);
        f13 = Math_fround(Math_fround(Math_fround(f56 * f11) + Math_fround(f57 * f12)) + Math_fround(f58 * f14));
        f11 = Math_fround(f56 - Math_fround(f11 * f13));
        f12 = Math_fround(f57 - Math_fround(f12 * f13));
        f13 = Math_fround(f58 - Math_fround(f14 * f13));
        f14 = Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)));
        if (f14 > Math_fround(0.0)) {
         f58 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14))));
         f56 = Math_fround(f11 * f58);
         f57 = Math_fround(f12 * f58);
         f58 = Math_fround(f13 * f58);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i2 = 0;
         i4 = 0;
         i3 = 0;
        }
        f11 = Math_fround(f17 - f18);
       } else {
        i2 = 0;
        i4 = 0;
        i3 = 0;
        f11 = Math_fround(0.0);
       }
      } else i143 = 23;
      break;
     }
    case 0:
     {
      i2 = i5;
      if ((HEAP32[i2 + 4 >> 2] | 0) == 1) {
       __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE((i3 | 0) == 0 ? 0 : i6 + -8 | 0, i131);
       __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE((i5 | 0) == 0 ? 0 : i2 + -8 | 0, i132);
       f56 = Math_fround(+HEAPF64[i132 >> 3]);
       f51 = Math_fround(+HEAPF64[i98 >> 3]);
       f55 = Math_fround(+HEAPF64[i99 >> 3]);
       HEAPF32[i135 >> 2] = f56;
       HEAPF32[i100 >> 2] = f51;
       HEAPF32[i101 >> 2] = f55;
       f55 = Math_fround(+HEAPF64[i102 >> 3]);
       f51 = Math_fround(+HEAPF64[i103 >> 3]);
       f56 = Math_fround(+HEAPF64[i8 >> 3]);
       HEAPF32[i137 >> 2] = f55;
       HEAPF32[i9 >> 2] = f51;
       HEAPF32[i10 >> 2] = f56;
       f56 = Math_fround(HEAPF32[i59 >> 2]);
       f51 = Math_fround(HEAPF32[i60 >> 2]);
       f55 = Math_fround(HEAPF32[i61 >> 2]);
       f52 = Math_fround(HEAPF32[i62 >> 2]);
       f16 = Math_fround(f56 + f56);
       f15 = Math_fround(f51 + f51);
       f50 = Math_fround(f55 + f55);
       f56 = Math_fround(f56 * f16);
       f58 = Math_fround(f51 * f15);
       f53 = Math_fround(f55 * f50);
       f51 = Math_fround(f16 * f51);
       f57 = Math_fround(f16 * f55);
       f16 = Math_fround(f16 * f52);
       f55 = Math_fround(f15 * f55);
       f15 = Math_fround(f15 * f52);
       f52 = Math_fround(f50 * f52);
       f50 = Math_fround(f51 + f52);
       f54 = Math_fround(f57 - f15);
       HEAPF32[i129 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f58) - f53);
       HEAPF32[i63 >> 2] = f50;
       HEAPF32[i64 >> 2] = f54;
       f56 = Math_fround(Math_fround(1.0) - f56);
       f53 = Math_fround(f56 - f53);
       f54 = Math_fround(f55 + f16);
       HEAPF32[i65 >> 2] = Math_fround(f51 - f52);
       HEAPF32[i66 >> 2] = f53;
       HEAPF32[i67 >> 2] = f54;
       f16 = Math_fround(f55 - f16);
       f58 = Math_fround(f56 - f58);
       HEAPF32[i68 >> 2] = Math_fround(f57 + f15);
       HEAPF32[i69 >> 2] = f16;
       HEAPF32[i70 >> 2] = f58;
       f58 = Math_fround(+HEAPF64[i131 >> 3]);
       f16 = Math_fround(+HEAPF64[i71 >> 3]);
       f15 = Math_fround(+HEAPF64[i72 >> 3]);
       HEAPF32[i130 >> 2] = f58;
       HEAPF32[i73 >> 2] = f16;
       HEAPF32[i74 >> 2] = f15;
       f15 = Math_fround(Math_sqrt(Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i135, i137, i130, i75, i129, i142, i134))));
       f16 = Math_fround(HEAPF32[i76 >> 2]);
       if (f15 < f16) {
        f54 = Math_fround(HEAPF32[i130 >> 2]);
        f55 = Math_fround(HEAPF32[i73 >> 2]);
        f13 = Math_fround(HEAPF32[i74 >> 2]);
        f56 = Math_fround(HEAPF32[i135 >> 2]);
        f56 = Math_fround(f56 + Math_fround(HEAPF32[i137 >> 2]));
        f57 = Math_fround(HEAPF32[i100 >> 2]);
        f57 = Math_fround(f57 + Math_fround(HEAPF32[i9 >> 2]));
        f58 = Math_fround(HEAPF32[i101 >> 2]);
        f56 = Math_fround(f56 * Math_fround(.5));
        f57 = Math_fround(f57 * Math_fround(.5));
        f58 = Math_fround(Math_fround(f58 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
        f11 = Math_fround(HEAPF32[i6 + 332 >> 2]);
        f12 = Math_fround(HEAPF32[i6 + 336 >> 2]);
        f14 = Math_fround(HEAPF32[i6 + 340 >> 2]);
        f56 = Math_fround(f54 - f56);
        f57 = Math_fround(f55 - f57);
        f58 = Math_fround(f13 - f58);
        f13 = Math_fround(Math_fround(Math_fround(f56 * f11) + Math_fround(f57 * f12)) + Math_fround(f58 * f14));
        f11 = Math_fround(f56 - Math_fround(f11 * f13));
        f12 = Math_fround(f57 - Math_fround(f12 * f13));
        f13 = Math_fround(f58 - Math_fround(f14 * f13));
        f14 = Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)));
        if (f14 > Math_fround(0.0)) {
         f58 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14))));
         f56 = Math_fround(f11 * f58);
         f57 = Math_fround(f12 * f58);
         f58 = Math_fround(f13 * f58);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i2 = 0;
         i4 = 0;
         i3 = 0;
        }
        f11 = Math_fround(f16 - f15);
       } else {
        i2 = 0;
        i4 = 0;
        i3 = 0;
        f11 = Math_fround(0.0);
       }
      } else i143 = 23;
      break;
     }
    default:
     {
      i2 = i5;
      i143 = 23;
     }
    }
    if ((i143 | 0) == 23) {
     i143 = 0;
     __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE((i3 | 0) == 0 ? 0 : i6 + -8 | 0, i131);
     __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE((i5 | 0) == 0 ? 0 : i2 + -8 | 0, i132);
     f20 = Math_fround(+HEAPF64[i105 >> 3]);
     f36 = Math_fround(+HEAPF64[i106 >> 3]);
     f44 = Math_fround(HEAPF32[i107 >> 2]);
     f29 = Math_fround(HEAPF32[i108 >> 2]);
     f13 = Math_fround(HEAPF32[i109 >> 2]);
     f54 = Math_fround(HEAPF32[i110 >> 2]);
     f14 = Math_fround(f44 + f44);
     f55 = Math_fround(f29 + f29);
     f11 = Math_fround(f13 + f13);
     f45 = Math_fround(f29 * f55);
     f49 = Math_fround(f13 * f11);
     f29 = Math_fround(f14 * f29);
     f47 = Math_fround(f14 * f13);
     f50 = Math_fround(f14 * f54);
     f13 = Math_fround(f55 * f13);
     f55 = Math_fround(f55 * f54);
     f54 = Math_fround(f11 * f54);
     f11 = Math_fround(Math_fround(Math_fround(1.0) - f45) - f49);
     f12 = Math_fround(f29 + f54);
     f15 = Math_fround(f47 - f55);
     f54 = Math_fround(f29 - f54);
     f14 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f14));
     f49 = Math_fround(f14 - f49);
     f44 = Math_fround(f13 + f50);
     f55 = Math_fround(f47 + f55);
     f50 = Math_fround(f13 - f50);
     f45 = Math_fround(f14 - f45);
     f14 = Math_fround(+HEAPF64[i111 >> 3]);
     f13 = Math_fround(+HEAPF64[i112 >> 3]);
     f47 = Math_fround(HEAPF32[i113 >> 2]);
     f29 = Math_fround(HEAPF32[i114 >> 2]);
     f22 = Math_fround(HEAPF32[i115 >> 2]);
     f57 = Math_fround(HEAPF32[i116 >> 2]);
     f21 = Math_fround(f47 + f47);
     f58 = Math_fround(f29 + f29);
     f56 = Math_fround(f22 + f22);
     f48 = Math_fround(f29 * f58);
     f52 = Math_fround(f22 * f56);
     f29 = Math_fround(f21 * f29);
     f28 = Math_fround(f21 * f22);
     f53 = Math_fround(f21 * f57);
     f22 = Math_fround(f58 * f22);
     f58 = Math_fround(f58 * f57);
     f57 = Math_fround(f56 * f57);
     f56 = Math_fround(Math_fround(Math_fround(1.0) - f48) - f52);
     f51 = Math_fround(f29 + f57);
     f46 = Math_fround(f28 - f58);
     f57 = Math_fround(f29 - f57);
     f21 = Math_fround(Math_fround(1.0) - Math_fround(f47 * f21));
     f52 = Math_fround(f21 - f52);
     f47 = Math_fround(f22 + f53);
     f58 = Math_fround(f28 + f58);
     f53 = Math_fround(f22 - f53);
     f48 = Math_fround(f21 - f48);
     f20 = Math_fround(f14 - f20);
     f36 = Math_fround(f13 - f36);
     f13 = Math_fround(Math_fround(f15 * f46) + Math_fround(Math_fround(f11 * f56) + Math_fround(f12 * f51)));
     f14 = Math_fround(Math_fround(Math_abs(Math_fround(f13))) + Math_fround(9.99999997e-07));
     f21 = Math_fround(Math_fround(f15 * f47) + Math_fround(Math_fround(f11 * f57) + Math_fround(f12 * f52)));
     f22 = Math_fround(Math_fround(Math_abs(Math_fround(f21))) + Math_fround(9.99999997e-07));
     f28 = Math_fround(Math_fround(f15 * f48) + Math_fround(Math_fround(f11 * f58) + Math_fround(f12 * f53)));
     f29 = Math_fround(Math_fround(Math_abs(Math_fround(f28))) + Math_fround(9.99999997e-07));
     f16 = Math_fround(Math_fround(f44 * f46) + Math_fround(Math_fround(f54 * f56) + Math_fround(f49 * f51)));
     f17 = Math_fround(Math_fround(Math_abs(Math_fround(f16))) + Math_fround(9.99999997e-07));
     f23 = Math_fround(Math_fround(f44 * f47) + Math_fround(Math_fround(f54 * f57) + Math_fround(f49 * f52)));
     f24 = Math_fround(Math_fround(Math_abs(Math_fround(f23))) + Math_fround(9.99999997e-07));
     f30 = Math_fround(Math_fround(f44 * f48) + Math_fround(Math_fround(f54 * f58) + Math_fround(f49 * f53)));
     f31 = Math_fround(Math_fround(Math_abs(Math_fround(f30))) + Math_fround(9.99999997e-07));
     f18 = Math_fround(Math_fround(f45 * f46) + Math_fround(Math_fround(f55 * f56) + Math_fround(f50 * f51)));
     f19 = Math_fround(Math_fround(Math_abs(Math_fround(f18))) + Math_fround(9.99999997e-07));
     f25 = Math_fround(Math_fround(f45 * f47) + Math_fround(Math_fround(f55 * f57) + Math_fround(f50 * f52)));
     f26 = Math_fround(Math_fround(Math_abs(Math_fround(f25))) + Math_fround(9.99999997e-07));
     f32 = Math_fround(Math_fround(f45 * f48) + Math_fround(Math_fround(f55 * f58) + Math_fround(f50 * f53)));
     f33 = Math_fround(Math_fround(Math_abs(Math_fround(f32))) + Math_fround(9.99999997e-07));
     f27 = Math_fround(Math_fround(+HEAPF64[i132 >> 3]) - Math_fround(+HEAPF64[i131 >> 3]));
     f34 = Math_fround(Math_fround(Math_fround(f11 * f27) + Math_fround(f12 * f20)) + Math_fround(f15 * f36));
     f35 = Math_fround(Math_fround(Math_fround(f54 * f27) + Math_fround(f49 * f20)) + Math_fround(f44 * f36));
     f36 = Math_fround(Math_fround(Math_fround(f55 * f27) + Math_fround(f50 * f20)) + Math_fround(f45 * f36));
     f20 = Math_fround(HEAPF32[i118 >> 2]);
     f27 = Math_fround(HEAPF32[i119 >> 2]);
     f37 = Math_fround(HEAPF32[i120 >> 2]);
     f38 = Math_fround(HEAPF32[i117 >> 2]);
     f41 = Math_fround(Math_fround(f38 + Math_fround(Math_fround(Math_fround(f14 * f20) + Math_fround(f22 * f27)) + Math_fround(f29 * f37))) - Math_fround(Math_abs(Math_fround(f34))));
     if (f41 < Math_fround(0.0)) {
      i2 = 0;
      i4 = 0;
      i3 = 0;
      f11 = Math_fround(0.0);
     } else {
      f39 = Math_fround(HEAPF32[i121 >> 2]);
      f42 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(f24 * f27)) + Math_fround(f31 * f37)) + f39) - Math_fround(Math_abs(Math_fround(f35))));
      if (f42 < Math_fround(0.0)) {
       i2 = 0;
       i4 = 0;
       i3 = 0;
       f11 = Math_fround(0.0);
      } else {
       f40 = Math_fround(HEAPF32[i122 >> 2]);
       f43 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(f26 * f27)) + Math_fround(f33 * f37)) + f40) - Math_fround(Math_abs(Math_fround(f36))));
       if (f43 < Math_fround(0.0)) {
        i2 = 0;
        i4 = 0;
        i3 = 0;
        f11 = Math_fround(0.0);
       } else {
        f16 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(Math_fround(f14 * f38) + Math_fround(f17 * f39)) + Math_fround(f19 * f40))) - Math_fround(Math_abs(Math_fround(Math_fround(f36 * f18) + Math_fround(Math_fround(f34 * f13) + Math_fround(f35 * f16))))));
        if (f16 < Math_fround(0.0)) {
         i2 = 0;
         i4 = 0;
         i3 = 0;
         f11 = Math_fround(0.0);
        } else {
         f14 = Math_fround(Math_fround(f27 + Math_fround(Math_fround(Math_fround(f22 * f38) + Math_fround(f24 * f39)) + Math_fround(f26 * f40))) - Math_fround(Math_abs(Math_fround(Math_fround(f36 * f25) + Math_fround(Math_fround(f34 * f21) + Math_fround(f35 * f23))))));
         if (f14 < Math_fround(0.0)) {
          i2 = 0;
          i4 = 0;
          i3 = 0;
          f11 = Math_fround(0.0);
         } else {
          f13 = Math_fround(Math_fround(f37 + Math_fround(Math_fround(Math_fround(f29 * f38) + Math_fround(f31 * f39)) + Math_fround(f33 * f40))) - Math_fround(Math_abs(Math_fround(Math_fround(f36 * f32) + Math_fround(Math_fround(f34 * f28) + Math_fround(f35 * f30))))));
          if (f13 < Math_fround(0.0)) {
           i2 = 0;
           i4 = 0;
           i3 = 0;
           f11 = Math_fround(0.0);
          } else {
           i4 = f42 < f41;
           f42 = i4 ? f42 : f41;
           i3 = f43 < f42;
           f43 = i3 ? f43 : f42;
           i2 = f16 < f43;
           f16 = i2 ? f16 : f43;
           i145 = f14 < f16;
           f16 = i145 ? f14 : f16;
           i146 = f13 < f16;
           f16 = i146 ? f13 : f16;
           switch ((i146 ? 5 : i145 ? 4 : i2 ? 3 : i3 ? 2 : i4 & 1) | 0) {
           case 0:
            break;
           case 1:
            {
             f15 = f44;
             f12 = f49;
             f11 = f54;
             break;
            }
           case 2:
            {
             f15 = f45;
             f12 = f50;
             f11 = f55;
             break;
            }
           case 5:
            {
             f15 = f48;
             f12 = f53;
             f11 = f58;
             break;
            }
           case 4:
            {
             f15 = f47;
             f12 = f52;
             f11 = f57;
             break;
            }
           default:
            {
             f15 = f46;
             f12 = f51;
             f11 = f56;
            }
           }
           f54 = Math_fround(+HEAPF64[i131 >> 3]);
           f56 = Math_fround(+HEAPF64[i105 >> 3]);
           f58 = Math_fround(+HEAPF64[i106 >> 3]);
           f55 = Math_fround(+HEAPF64[i132 >> 3]);
           f57 = Math_fround(+HEAPF64[i111 >> 3]);
           if (Math_fround(Math_fround(Math_fround(f11 * Math_fround(f54 - f55)) + Math_fround(f12 * Math_fround(f56 - f57))) + Math_fround(f15 * Math_fround(f58 - Math_fround(+HEAPF64[i112 >> 3])))) < Math_fround(0.0)) {
            f15 = Math_fround(-f15);
            f12 = Math_fround(-f12);
            f11 = Math_fround(-f11);
           }
           f14 = Math_fround(HEAPF32[i6 + 332 >> 2]);
           f13 = Math_fround(HEAPF32[i6 + 336 >> 2]);
           f57 = Math_fround(HEAPF32[i6 + 340 >> 2]);
           f58 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f13)) + Math_fround(f15 * f57));
           f14 = Math_fround(f11 - Math_fround(f14 * f58));
           f13 = Math_fround(f12 - Math_fround(f13 * f58));
           f11 = Math_fround(f15 - Math_fround(f57 * f58));
           f12 = Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)));
           if (f12 > Math_fround(0.0)) {
            f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12))));
            f57 = Math_fround(f14 * f56);
            f58 = Math_fround(f13 * f56);
            f11 = Math_fround(f11 * f56);
            i3 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
            i4 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
            i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
            f11 = f16;
           } else {
            i2 = 0;
            i4 = 0;
            i3 = 0;
            f11 = f16;
           }
          }
         }
        }
       }
      }
     }
    }
    if (f11 != Math_fround(0.0)) {
     f58 = f11 > f77 ? f77 : f11;
     f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
     f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
     f56 = Math_fround(f56 * Math_fround(.5));
     f57 = Math_fround(f57 * Math_fround(.5));
     f58 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58) * Math_fround(.5));
     i146 = i6 + 444 | 0;
     HEAPF32[i146 >> 2] = Math_fround(f56 + Math_fround(HEAPF32[i146 >> 2]));
     i146 = i6 + 448 | 0;
     HEAPF32[i146 >> 2] = Math_fround(f57 + Math_fround(HEAPF32[i146 >> 2]));
     i146 = i6 + 452 | 0;
     HEAPF32[i146 >> 2] = Math_fround(f58 + Math_fround(HEAPF32[i146 >> 2]));
     i146 = i5;
     i145 = i146 + 444 | 0;
     HEAPF32[i145 >> 2] = Math_fround(Math_fround(HEAPF32[i145 >> 2]) - f56);
     i145 = i146 + 448 | 0;
     HEAPF32[i145 >> 2] = Math_fround(Math_fround(HEAPF32[i145 >> 2]) - f57);
     i146 = i146 + 452 | 0;
     HEAPF32[i146 >> 2] = Math_fround(Math_fround(HEAPF32[i146 >> 2]) - f58);
    }
   }
  } while ((i1 | 0) != 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i128, i124);
 i146 = HEAP32[i123 >> 2] | 0;
 if (!((i146 | 0) > -1 & (i146 & 2147483647 | 0) != 0)) {
  STACKTOP = i144;
  return;
 }
 i1 = HEAP32[i139 >> 2] | 0;
 if (!i1) {
  STACKTOP = i144;
  return;
 }
 i146 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i146 >> 2] | 0) + 12 >> 2] | 0, i146 | 0, i1 | 0);
 STACKTOP = i144;
 return;
}

function __ZL20ForwardRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i104, i85) {
 i104 = i104 | 0;
 i85 = i85 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, f112 = f0;
 i111 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i84 = i111 + 1e3 | 0;
 i92 = i111 + 992 | 0;
 i94 = i111 + 984 | 0;
 i103 = i111 + 968 | 0;
 i1 = i111 + 1064 | 0;
 i110 = i111 + 768 | 0;
 i96 = i111 + 544 | 0;
 i97 = i111 + 408 | 0;
 i98 = i111 + 396 | 0;
 i86 = i111 + 296 | 0;
 i87 = i111 + 284 | 0;
 i88 = i111 + 272 | 0;
 i89 = i111 + 148 | 0;
 i90 = i111 + 24 | 0;
 i91 = i111;
 if ((HEAP16[gb + 1114896 + 6 >> 1] | 0) > -1) {
  HEAP32[i92 >> 2] = 0;
  HEAP32[i84 >> 2] = HEAP32[i92 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114896 | 0, i84);
  i107 = gb + 1114896 | 0;
 } else i107 = 0;
 i108 = HEAP32[gb + 1114896 >> 2] | 0;
 i100 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i100 >> 2] | 0) + 648 >> 2] | 0, i100 | 0, i108 | 0);
 i108 = i104 + 12 | 0;
 i100 = HEAP32[i104 + 8 >> 2] | 0;
 i93 = HEAP32[i85 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i100 >> 2] | 0) + 172 >> 2] | 0, i103 | 0, i100 | 0);
 i101 = mftCall_ii(HEAP32[(HEAP32[i100 >> 2] | 0) + 168 >> 2] | 0, i100 | 0) | 0;
 i102 = i85 + 8 | 0;
 i109 = HEAP32[(HEAP32[i102 >> 2] | 0) + 1832 >> 2] | 0;
 i95 = i85 + 524 | 0;
 i7 = HEAP8[i95 >> 0] | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i110, i1, i109, (i7 & 2) != 0, (i7 & 4) != 0);
 __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats(i96, i110, i1);
 __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats(i97, i110, i1);
 __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats(i98, i110, i1);
 HEAP32[i86 >> 2] = 0;
 HEAP32[i86 >> 2] = HEAP32[(__ZN10builtintex16GetDefaultTexEnvE16TextureDimension(3) | 0) >> 2];
 HEAPF32[i86 + 4 >> 2] = Math_fround(1.0);
 i7 = i86 + 8 | 0;
 i9 = i84 + 12 | 0;
 HEAP32[i84 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i84 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i84 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i84 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i84 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i84 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i84 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i84 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i84 + 20 >> 2];
 i7 = i86 + 32 | 0;
 i9 = gb + 1162292 | 0;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 HEAP8[i86 + 96 >> 0] = 1;
 HEAP32[i87 + 4 >> 2] = i110;
 HEAP32[i87 + 8 >> 2] = i1;
 HEAP8[i87 >> 0] = 1;
 i4 = __Z12GetGfxDevicev() | 0;
 HEAPF32[i4 + 980 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 984 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 988 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 992 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 996 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 1e3 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 1004 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 1008 >> 2] = Math_fround(0.0);
 HEAP32[i88 >> 2] = i110;
 i4 = __Z12GetGfxDevicev() | 0;
 HEAP32[i88 + 4 >> 2] = i4 + 4;
 HEAPF32[i88 + 8 >> 2] = Math_fround(0.0);
 i4 = i4 + 964 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i4 = HEAP32[(HEAP32[i102 >> 2] | 0) + 1828 >> 2] | 0;
 i83 = i4 + 65728 | 0;
 HEAP32[i89 >> 2] = HEAP32[i4 + 65816 >> 2];
 HEAP32[i89 + 4 >> 2] = HEAP32[i4 + 65820 >> 2];
 HEAP32[i89 + 8 >> 2] = HEAP32[i4 + 65824 >> 2];
 HEAP32[i89 + 12 >> 2] = HEAP32[i4 + 65828 >> 2];
 HEAP32[i89 + 16 >> 2] = HEAP32[i4 + 65832 >> 2];
 HEAP32[i89 + 20 >> 2] = HEAP32[i4 + 65836 >> 2];
 HEAP32[i89 + 24 >> 2] = HEAP32[i4 + 65840 >> 2];
 HEAP32[i89 + 28 >> 2] = HEAP32[i4 + 65844 >> 2];
 HEAP32[i89 + 32 >> 2] = HEAP32[i4 + 65848 >> 2];
 HEAP32[i89 + 36 >> 2] = HEAP32[i4 + 65852 >> 2];
 HEAP32[i89 + 40 >> 2] = HEAP32[i4 + 65856 >> 2];
 HEAP32[i89 + 44 >> 2] = HEAP32[i4 + 65860 >> 2];
 HEAP32[i89 + 48 >> 2] = HEAP32[i4 + 65864 >> 2];
 HEAP32[i89 + 52 >> 2] = HEAP32[i4 + 65868 >> 2];
 HEAP32[i89 + 56 >> 2] = HEAP32[i4 + 65872 >> 2];
 HEAP32[i89 + 60 >> 2] = HEAP32[i4 + 65876 >> 2];
 HEAP32[i89 + 64 >> 2] = HEAP32[i4 + 65880 >> 2];
 HEAP32[i89 + 68 >> 2] = HEAP32[i4 + 65884 >> 2];
 HEAP32[i89 + 72 >> 2] = HEAP32[i4 + 65888 >> 2];
 HEAP32[i89 + 76 >> 2] = HEAP32[i4 + 65892 >> 2];
 HEAP32[i89 + 80 >> 2] = HEAP32[i4 + 65896 >> 2];
 HEAP32[i89 + 84 >> 2] = HEAP32[i4 + 65900 >> 2];
 HEAP32[i89 + 88 >> 2] = HEAP32[i4 + 65904 >> 2];
 HEAP32[i89 + 92 >> 2] = HEAP32[i4 + 65908 >> 2];
 HEAP32[i89 + 96 >> 2] = HEAP32[i4 + 65912 >> 2];
 HEAP32[i89 + 100 >> 2] = HEAP32[i4 + 65916 >> 2];
 HEAP32[i89 + 104 >> 2] = HEAP32[i4 + 65920 >> 2];
 HEAP32[i89 + 108 >> 2] = HEAP32[i4 + 65924 >> 2];
 HEAP32[i89 + 112 >> 2] = HEAP32[i4 + 65928 >> 2];
 HEAP32[i89 + 116 >> 2] = HEAP32[i4 + 65932 >> 2];
 HEAP32[i89 + 120 >> 2] = HEAP32[i4 + 65936 >> 2];
 __ZN16ReflectionSampleC2Ev(i90);
 i6 = HEAP32[i104 + 180 >> 2] | 0;
 i1 = HEAP32[i104 + 176 >> 2] | 0;
 i105 = i109 + 32804 | 0;
 i106 = i109 + 32808 | 0;
 i2 = (HEAP32[i106 >> 2] | 0) + (HEAP32[i105 >> 2] | 0) | 0;
 L4 : do if (i1 >>> 0 < i2 >>> 0) {
  i3 = HEAP32[i109 >> 2] | 0;
  do {
   if ((HEAP32[i3 + (i1 * 360 | 0) + 240 >> 2] | 0) >= (i6 | 0)) break L4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 } while (0);
 i2 = HEAP32[i104 + 168 >> 2] | 0;
 i39 = i104 + 172 | 0;
 if (i2 >>> 0 < (HEAP32[i39 >> 2] | 0) >>> 0) {
  i40 = i85 + 168 | 0;
  i41 = i85 + 108 | 0;
  i42 = i85 + 128 | 0;
  i43 = i85 + 148 | 0;
  i3 = i104 + 16 | 0;
  i44 = i91 + 4 | 0;
  i45 = i91 + 12 | 0;
  i46 = i91 + 16 | 0;
  i47 = i91 + 8 | 0;
  i48 = i91 + 20 | 0;
  i49 = i91 + 12 | 0;
  i50 = i100 + 608 | 0;
  i51 = i84 + 20 | 0;
  i52 = i84 + 48 | 0;
  i53 = i84 + 52 | 0;
  i54 = i100 + 2404 | 0;
  i55 = i96 + 108 | 0;
  i56 = i96 + 216 | 0;
  i57 = i85 + 520 | 0;
  i58 = i92 + 4 | 0;
  i59 = i85 + 20 | 0;
  i60 = i85 + 64 | 0;
  i61 = i85 + 372 | 0;
  i62 = i110 + 8 | 0;
  i63 = i110 + 52 | 0;
  i64 = i110 + 132 | 0;
  i65 = i110 + 168 | 0;
  i66 = i110 + 4 | 0;
  i67 = i85 + 188 | 0;
  i68 = i85 + 368 | 0;
  i69 = i85 + 340 | 0;
  i70 = i85 + 352 | 0;
  i71 = i85 + 12 | 0;
  i72 = i91 + 16 | 0;
  i73 = i110 + 184 | 0;
  i74 = i110 + 188 | 0;
  i75 = (i93 | 0) != 0;
  i76 = i67 + 4 | 0;
  i77 = i67 + 52 | 0;
  i78 = i69 + 12 | 0;
  i79 = i97 + 128 | 0;
  i80 = i90 + 24 | 0;
  i81 = i90 + 84 | 0;
  i82 = i98 + 4 | 0;
  i37 = i4 + 65940 | 0;
  i38 = i110 + 192 | 0;
  i24 = 0;
  i36 = i2;
  i4 = 0;
  i5 = -1;
  i7 = -1;
  i9 = -1;
  i2 = 0;
  i10 = 0;
  i11 = 0;
  i12 = 0;
  while (1) {
   i15 = HEAP32[i40 >> 2] | 0;
   i17 = i15 + (i36 * 12 | 0) | 0;
   i33 = HEAP32[i15 + (i36 * 12 | 0) + 4 >> 2] | 0;
   i34 = HEAP32[i41 >> 2] | 0;
   i16 = i34 + (i33 << 5) | 0;
   i19 = (HEAP32[i43 >> 2] | 0) + (HEAP32[(HEAP32[i42 >> 2] | 0) + (i33 << 2) >> 2] | 0) | 0;
   i32 = i34 + (i33 << 5) + 8 | 0;
   i29 = HEAP32[i32 >> 2] | 0;
   i30 = HEAP32[i109 >> 2] | 0;
   i31 = i30 + (i29 * 360 | 0) | 0;
   i14 = HEAP16[i34 + (i33 << 5) + 12 >> 1] | 0;
   L14 : do if ((i14 | 0) > (i6 | 0)) {
    __ZN13BatchRenderer5FlushEv(i110);
    if (!(HEAP8[(HEAP32[i102 >> 2] | 0) + 1825 >> 0] | 0)) if (i1 >>> 0 < ((HEAP32[i106 >> 2] | 0) + (HEAP32[i105 >> 2] | 0) | 0) >>> 0) {
     i13 = i4;
     while (1) {
      i4 = HEAP32[i109 >> 2] | 0;
      if ((HEAP32[i4 + (i1 * 360 | 0) + 240 >> 2] | 0) > (i14 | 0)) {
       i6 = i14;
       i21 = i5;
       i20 = i7;
       i18 = i9;
       i14 = i10;
       break L14;
      }
      if ((HEAP32[i4 + (i1 * 360 | 0) + 236 >> 2] | 0) == 1) {
       HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -16777217;
       i4 = HEAP32[i4 + (i1 * 360 | 0) + 332 >> 2] | 0;
       if (!i4) {
        i4 = 0;
        i5 = -1;
        i7 = -1;
        i9 = -1;
        i10 = 0;
        i11 = 0;
        i12 = 0;
       } else {
        mftCall_viii(i4 | 0, i109 | 0, i1 | 0, i108 | 0);
        i4 = 0;
        i5 = -1;
        i7 = -1;
        i9 = -1;
        i10 = 0;
        i11 = 0;
        i12 = 0;
       }
      } else i4 = i13;
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 < ((HEAP32[i106 >> 2] | 0) + (HEAP32[i105 >> 2] | 0) | 0) >>> 0) i13 = i4; else {
       i6 = i14;
       i13 = i4;
       i21 = i5;
       i20 = i7;
       i18 = i9;
       i14 = i10;
       break;
      }
     }
    } else {
     i6 = i14;
     i13 = i4;
     i21 = i5;
     i20 = i7;
     i18 = i9;
     i14 = i10;
    } else {
     i6 = i14;
     i13 = i4;
     i21 = i5;
     i20 = i7;
     i18 = i9;
     i14 = i10;
    }
   } else {
    i13 = i4;
    i21 = i5;
    i20 = i7;
    i18 = i9;
    i14 = i10;
   } while (0);
   i25 = i15 + (i36 * 12 | 0) + 8 | 0;
   i23 = HEAP32[i25 >> 2] | 0;
   i35 = i23 & 255;
   i23 = i23 >>> 8;
   i22 = i23 & 255;
   i4 = HEAP32[(HEAP32[i30 + (i29 * 360 | 0) + 324 >> 2] | 0) + (HEAPU16[i34 + (i33 << 5) + 18 >> 1] << 3) >> 2] | 0;
   HEAP32[i91 >> 2] = i4;
   HEAP32[i44 >> 2] = HEAP32[i16 >> 2];
   i15 = i30 + (i29 * 360 | 0) + 252 | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i5 = ((i5 & 2147483647 | 0) == 0 ? 0 : i5 >> 15 & 131072 | 65536) | (HEAP32[i30 + (i29 * 360 | 0) + 176 >> 2] << 13 & 32768 | HEAPU16[i34 + (i33 << 5) + 16 >> 1] & 32767);
   HEAP32[i45 >> 2] = i5;
   HEAP32[i46 >> 2] = HEAP32[i30 + (i29 * 360 | 0) + 224 >> 2];
   HEAP32[i47 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i48 >> 2] = i19;
   if (!(HEAP8[i95 >> 0] & 1)) {
    i7 = 0;
    i9 = i4;
   } else {
    i28 = i30 + (i29 * 360 | 0) + 232 | 0;
    if (!((HEAPU16[i28 >> 1] | HEAPU8[i28 + 2 >> 0] << 16) & 256)) {
     i7 = 0;
     i9 = i4;
    } else {
     i7 = __Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB((HEAP32[i102 >> 2] | 0) + 12 | 0, i30 + (i29 * 360 | 0) + 128 | 0) | 0;
     i5 = HEAP32[i49 >> 2] | 0;
     i9 = HEAP32[i91 >> 2] | 0;
    }
   }
   i4 = i5 & -262145 | (i7 & 1) << 18;
   HEAP32[i49 >> 2] = i4;
   i19 = (i22 | 0) == 5;
   L29 : do if ((i13 | 0) == (i9 | 0) & ((i24 | i19) ^ 1)) if (((i11 | 0) == (HEAP32[i44 >> 2] | 0) ? (i12 | 0) == (HEAP32[i47 >> 2] | 0) : 0) & (i21 | 0) == (i4 | 0)) if ((i14 | 0) == 0 ? 1 : ((i18 & 65535) << 16 | i20 & 65535 | 0) != (HEAP32[i46 >> 2] | 0)) i99 = 38; else {
    i10 = HEAP32[i48 >> 2] | 0;
    if (!i10) i99 = 38; else if ((HEAP32[i14 + 108 >> 2] | 0) == (HEAP32[i10 + 108 >> 2] | 0)) {
     i4 = HEAP32[i14 + 116 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i10 + 116 >> 2] | 0)) {
      i5 = HEAP32[i14 + 112 >> 2] | 0;
      if ((i5 | 0) == (HEAP32[i10 + 112 >> 2] | 0)) {
       i5 = i5 + i4 | 0;
       i7 = i14 + 132 | 0;
       i9 = i10 + 132 | 0;
       if ((i5 | 0) > 0) {
        i4 = 0;
        do {
         if ((HEAP32[i7 + (i4 << 2) >> 2] | 0) != (HEAP32[i9 + (i4 << 2) >> 2] | 0)) {
          i99 = 38;
          break L29;
         }
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) < (i5 | 0));
       }
       f8 = Math_fround(HEAPF32[i14 + 120 >> 2]);
       f8 = Math_fround(f8 - Math_fround(HEAPF32[i10 + 120 >> 2]));
       i28 = f8 < Math_fround(0.0);
       f112 = Math_fround(-f8);
       if (!((i28 ? f112 : f8) <= Math_fround(9.99999997e-07))) i99 = 38; else {
        f112 = Math_fround(HEAPF32[i14 + 124 >> 2]);
        f112 = Math_fround(f112 - Math_fround(HEAPF32[i10 + 124 >> 2]));
        i28 = f112 < Math_fround(0.0);
        f8 = Math_fround(-f112);
        if (!((i28 ? f8 : f112) <= Math_fround(9.99999997e-07))) i99 = 38; else {
         f112 = Math_fround(HEAPF32[i14 + 128 >> 2]);
         f112 = Math_fround(f112 - Math_fround(HEAPF32[i10 + 128 >> 2]));
         i28 = f112 < Math_fround(0.0);
         f8 = Math_fround(-f112);
         if (!((i28 ? f8 : f112) <= Math_fround(9.99999997e-07))) i99 = 38; else if ((HEAP32[i30 + (i29 * 360 | 0) + 260 >> 2] | 0) == (HEAP32[i38 >> 2] | 0)) {
          i17 = 0;
          i28 = i13;
          i27 = i14;
          i26 = i11;
         } else i99 = 38;
        }
       }
      } else i99 = 38;
     } else i99 = 38;
    } else i99 = 38;
   } else i99 = 38; else i99 = 38; while (0);
   if ((i99 | 0) == 38) {
    i99 = 0;
    __ZN13BatchRenderer5FlushEv(i110);
    i4 = HEAP32[i91 >> 2] | 0;
    i11 = HEAP32[i44 >> 2] | 0;
    i12 = HEAP32[i47 >> 2] | 0;
    i5 = HEAP32[i45 >> 2] | 0;
    i9 = HEAP32[i46 >> 2] | 0;
    i7 = i9 & 65535;
    i9 = i9 >>> 16 & 65535;
    i10 = HEAP32[i48 >> 2] | 0;
    switch (i5 << 14 >> 30 | 0) {
    case 1:
     {
      HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -12582913 | 8388608;
      break;
     }
    case -1:
     {
      HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -12582913 | 4194304;
      break;
     }
    default:
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -12582913;
    }
    HEAPF32[i50 >> 2] = i5 & 32768 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
    i17 = 1;
    i24 = i19;
    i28 = i4;
    i21 = i5;
    i20 = i7;
    i18 = i9;
    i27 = i10;
    i26 = i11;
   }
   __ZN15LightmapSTCache5ApplyERK10RenderNode(i87, i31);
   if ((i22 | 1 | 0) == 3) {
    i16 = i30 + (i29 * 360 | 0) + 224 | 0;
    if ((HEAPU16[i16 >> 1] | 0) < 65534 ? 1 : (HEAPU16[i16 + 2 >> 1] | 0) < 65534) if (!(HEAP16[i30 + (i29 * 360 | 0) + 182 >> 1] | 0)) {
     i4 = HEAP32[i30 + (i29 * 360 | 0) + 192 >> 2] | 0;
     i5 = HEAP32[i30 + (i29 * 360 | 0) + 196 >> 2] | 0;
     i7 = HEAP32[i30 + (i29 * 360 | 0) + 200 >> 2] | 0;
     i9 = HEAP32[i30 + (i29 * 360 | 0) + 204 >> 2] | 0;
    } else {
     i4 = 1065353216;
     i5 = 1065353216;
     i7 = 0;
     i9 = 0;
    } else {
     i4 = 1065353216;
     i5 = 1065353216;
     i7 = 0;
     i9 = 0;
    }
    __ZN10Matrix4x4f11SetIdentityEv(i84) | 0;
    HEAP32[i84 >> 2] = i4;
    HEAP32[i51 >> 2] = i5;
    HEAP32[i52 >> 2] = i7;
    HEAP32[i53 >> 2] = i9;
    i7 = i54;
    i9 = i84;
    i10 = i7 + 64 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     i7 = i7 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i7 | 0) < (i10 | 0));
   }
   __ZN12LODFadeCache14ApplyValueOnlyEf(i88, Math_fround(HEAPF32[i15 >> 2]));
   L60 : do if ((i22 | 0) == 4) {
    i5 = HEAP32[i48 >> 2] | 0;
    i4 = 0;
    while (1) {
     if ((HEAP32[i55 + (i4 << 2) >> 2] | 0) != (HEAP32[i5 + (i4 << 2) >> 2] | 0)) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= 27) break L60;
    }
    i7 = i55;
    i9 = i5;
    i10 = i7 + 108 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     i7 = i7 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i7 | 0) < (i10 | 0));
    __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2(HEAP32[i56 >> 2] | 0, i5);
   } else {
    i4 = 0;
    while (1) {
     if ((HEAP32[i55 + (i4 << 2) >> 2] | 0) != (HEAP32[i96 + (i4 << 2) >> 2] | 0)) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= 27) break L60;
    }
    i7 = i55;
    i9 = i96;
    i10 = i7 + 108 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     i7 = i7 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i7 | 0) < (i10 | 0));
    __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2(HEAP32[i56 >> 2] | 0, i96);
   } while (0);
   if (HEAP8[i57 >> 0] & 1) {
    i4 = HEAP16[i30 + (i29 * 360 | 0) + 268 >> 1] | 0;
    if (i4 << 16 >> 16 != -1) {
     i5 = (HEAP32[i37 >> 2] | 0) + ((i4 << 16 >> 16) * 100 | 0) | 0;
     i7 = i86;
     i9 = i5;
     i10 = i7 + 96 | 0;
     do {
      HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
      i7 = i7 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i7 | 0) < (i10 | 0));
     HEAP8[i86 + 96 >> 0] = HEAP8[i5 + 96 >> 0] | 0;
    }
    if ((HEAP16[i98 >> 1] | 0) != i4 << 16 >> 16) {
     HEAP16[i98 >> 1] = i4;
     __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb(HEAP32[i82 >> 2] | 0, i86, i4 << 16 >> 16 != -1);
    }
   }
   __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_(i83, i31, i89, i90);
   if (_memcmp(i97, i90, 124) | 0) {
    i7 = i97;
    i9 = i90;
    i10 = i7 + 124 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     i7 = i7 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i7 | 0) < (i10 | 0));
    i4 = HEAP32[i79 >> 2] | 0;
    if (HEAP32[i4 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i4);
    __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i4, i90);
    HEAP32[i92 >> 2] = HEAP32[i80 >> 2];
    HEAP32[i84 >> 2] = HEAP32[i92 >> 2];
    __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i4, 19, 4, 0, i84);
    HEAP32[i94 >> 2] = HEAP32[i81 >> 2];
    HEAP32[i84 >> 2] = HEAP32[i94 >> 2];
    __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i4, 20, 4, 0, i84);
   }
   i16 = HEAP32[i32 >> 2] | 0;
   HEAP32[i92 >> 2] = i16;
   i15 = HEAPU16[i34 + (i33 << 5) + 14 >> 1] | 0;
   HEAP32[i58 >> 2] = i15;
   if (i19) {
    i13 = HEAP32[i48 >> 2] | 0;
    i11 = HEAP32[i13 + 112 >> 2] | 0;
    i13 = i13 + 132 | 0;
    if ((i11 | 0) > 0) {
     i14 = i11 + -1 | 0;
     i10 = 0;
     do {
      i7 = HEAP32[i13 + (i10 << 2) >> 2] | 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((i10 | 0) == (i14 | 0)) f8 = Math_fround(HEAPF32[(HEAP32[i48 >> 2] | 0) + 120 >> 2]); else f8 = Math_fround(1.0);
      __Z20SetupForwardAddLightRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_(i4, f8, i108, i7 + 84 | 0, i59, i60);
      i9 = i4 + 40 | 0;
      if ((HEAP32[i9 >> 2] | 0) != 1) __Z19SetLightScissorRectPK5RectTIfEbRS1_bR9GfxDevice(i7 + 48 | 0, (HEAP8[i7 + 80 >> 0] | 0) != 0, (HEAP32[i102 >> 2] | 0) + 1796 | 0, 0, i100);
      L95 : do if (!(HEAP32[i49 >> 2] & 262144)) i99 = 81; else {
       if (!(HEAP32[i4 + 96 >> 2] | 0)) {
        i99 = 81;
        break;
       }
       if ((HEAP32[i67 >> 2] | 0) == (i7 | 0)) i4 = i67; else {
        i4 = HEAP32[i69 >> 2] | 0;
        i34 = HEAP32[i70 >> 2] | 0;
        i5 = i4 + (i34 * 152 | 0) | 0;
        if (!i34) {
         i99 = 81;
         break;
        }
        while (1) {
         if ((HEAP32[i4 >> 2] | 0) == (i7 | 0)) break;
         i4 = i4 + 152 | 0;
         if ((i4 | 0) == (i5 | 0)) {
          i99 = 81;
          break L95;
         }
        }
        if (!i4) {
         i99 = 81;
         break;
        }
       }
       i5 = i4 + 4 | 0;
       if (!(HEAP32[i5 >> 2] | 0)) {
        i99 = 81;
        break;
       }
       i34 = HEAP32[i7 >> 2] | 0;
       i33 = i34 + 40 | 0;
       i2 = (HEAP32[i33 >> 2] | 0) == 1;
       __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i85, i34, i5, i4 + 52 | 0, i108);
       __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i108, HEAP32[i33 >> 2] | 0, HEAP32[i34 + 96 >> 2] | 0, HEAP32[i68 >> 2] | 0, i2, (HEAP8[i95 >> 0] & 8) != 0);
       i2 = 1;
      } while (0);
      do if ((i99 | 0) == 81) {
       i99 = 0;
       if (!(i2 << 24 >> 24)) {
        i2 = 0;
        break;
       }
       __Z20SetNoShadowsKeywordsR17ShaderPassContext(i108);
       i2 = 0;
      } while (0);
      i4 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(HEAP32[i91 >> 2] | 0, i108, HEAP32[i44 >> 2] | 0, HEAP32[i47 >> 2] | 0, i35, 1, i61, 0) | 0;
      if (HEAP32[i63 >> 2] | HEAP32[i64 >> 2] | 0) {
       __ZN20DynamicPropertySheet10FlushQueueEv(i62);
       i34 = HEAP32[i66 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 184 >> 2] | 0, i34 | 0, i62 | 0);
       __ZN19ShaderPropertySheet5ClearEb(i62, 1);
      }
      if (i4 | 0) {
       i34 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
       __Z17SetupObjectMatrixRK10Matrix4x4fi(i34 + (i16 * 360 | 0) | 0, HEAP32[i34 + (i16 * 360 | 0) + 176 >> 2] | 0);
       mftCall_viiii(HEAP32[i34 + (i16 * 360 | 0) + 332 >> 2] | 0, HEAP32[i65 >> 2] | 0, i16 | 0, i4 | 0, i15 | 0);
      }
      if ((HEAP32[i9 >> 2] | 0) != 1) __Z16ClearScissorRectbRK5RectTIiER9GfxDevice(i101, i103, i100);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i11 | 0));
    }
   } else {
    if (i17) {
     L122 : do switch ((i23 & 255) << 24 >> 24) {
     case 0:
      {
       __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(0, 0, i108);
       break;
      }
     case 4:
      {
       __Z22SetupForwardBaseLightsRK18ForwardLightsBlockR17ShaderPassContextRK10TextureRefS6_(HEAP32[i48 >> 2] | 0, i108, i59, i60);
       i4 = HEAP32[i49 >> 2] & 262144;
       if (i75 & (i4 | 0) != 0) if ((HEAP32[(HEAP32[i48 >> 2] | 0) + 108 >> 2] | 0) == (i93 | 0)) {
        i2 = HEAP32[i93 >> 2] | 0;
        __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i85, i2, i76, i77, i108);
        __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i108, HEAP32[i2 + 40 >> 2] | 0, HEAP32[i2 + 96 >> 2] | 0, HEAP32[i68 >> 2] | 0, 1, (HEAP8[i95 >> 0] & 8) != 0);
        i2 = 1;
        break L122;
       }
       L129 : do if (i4 | 0) {
        i7 = HEAP32[(HEAP32[i48 >> 2] | 0) + 108 >> 2] | 0;
        if (!i7) break;
        i9 = HEAP32[i7 >> 2] | 0;
        i10 = i9 + 96 | 0;
        if (!(HEAP32[i10 >> 2] | 0)) break;
        i4 = HEAP32[i69 >> 2] | 0;
        i34 = HEAP32[i78 >> 2] | 0;
        i11 = i4 + (i34 * 152 | 0) | 0;
        if (!i34) break;
        while (1) {
         if ((HEAP32[i4 >> 2] | 0) == (i7 | 0)) {
          i5 = i4 + 4 | 0;
          if (HEAP32[i5 >> 2] | 0) break;
         }
         i4 = i4 + 152 | 0;
         if ((i4 | 0) == (i11 | 0)) break L129;
        }
        i34 = i9 + 40 | 0;
        i2 = (HEAP32[i34 >> 2] | 0) == 1;
        __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i85, i9, i5, i4 + 52 | 0, i108);
        __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i108, HEAP32[i34 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i68 >> 2] | 0, i2, (HEAP8[i95 >> 0] & 8) != 0);
        i2 = 1;
        break L122;
       } while (0);
       if (!(i2 << 24 >> 24)) i2 = 0; else {
        __Z20SetNoShadowsKeywordsR17ShaderPassContext(i108);
        i2 = 0;
       }
       break;
      }
     case 3:
     case 2:
     case 1:
      {
       mftCall_vii(HEAP32[(HEAP32[i100 >> 2] | 0) + 108 >> 2] | 0, i100 | 0, gb + 1162292 | 0);
       i34 = HEAP32[i48 >> 2] | 0;
       __Z17SetupVertexLightsiPKPK11ActiveLightR17ShaderPassContext(HEAP32[i34 + 116 >> 2] | 0, i34 + 132 | 0, i108);
       break;
      }
     default:
      {}
     } while (0);
     __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext(HEAP32[i71 >> 2] | 0, i72, i108);
     i34 = HEAP32[i91 >> 2] | 0;
     i7 = HEAP32[i44 >> 2] | 0;
     i4 = HEAP32[i47 >> 2] | 0;
     i5 = HEAP32[i25 >> 2] | 0;
     HEAP32[i84 >> 2] = 0;
     HEAP32[i84 + 4 >> 2] = 0;
     HEAP32[i84 + 8 >> 2] = 0;
     HEAP32[i84 + 12 >> 2] = 0;
     HEAP32[i84 + 16 >> 2] = 0;
     HEAP32[i84 + 20 >> 2] = 0;
     i4 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i34, i108, i7, i4, i35, (HEAP32[i4 + 744 >> 2] | 0) == 0, i61, i84) | 0;
     HEAP32[i73 >> 2] = i4;
     if (!i4) i4 = 0; else i4 = HEAP32[i4 >> 2] & 1;
     i35 = i4 | (i5 >>> 25 & 1) << 1 & 255 | HEAP8[i74 >> 0] & -4;
     HEAP8[i74 >> 0] = i35;
     HEAP8[i74 >> 0] = (HEAP32[(HEAP32[i7 + 32 >> 2] | 0) + 64 >> 2] & 255) << 2 & 12 | i35 & -13;
    }
    __ZN13BatchRenderer3AddERK17BatchInstanceData(i110, i92);
   }
   i36 = i36 + 1 | 0;
   if (i36 >>> 0 >= (HEAP32[i39 >> 2] | 0) >>> 0) break; else {
    i4 = i28;
    i5 = i21;
    i7 = i20;
    i9 = i18;
    i10 = i27;
    i11 = i26;
   }
  }
 } else {
  i3 = i104 + 16 | 0;
  i2 = 0;
 }
 __ZN13BatchRenderer5FlushEv(i110);
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -16777217;
 if (i2 << 24 >> 24) __Z20SetNoShadowsKeywordsR17ShaderPassContext(i108);
 __Z16ClearScissorRectbRK5RectTIiER9GfxDevice(i101, i103, i100);
 L153 : do if (HEAP8[i104 + 192 >> 0] | 0) if (!(HEAP8[(HEAP32[i102 >> 2] | 0) + 1825 >> 0] | 0)) {
  i2 = HEAP32[i105 >> 2] | 0;
  i3 = HEAP32[i106 >> 2] | 0;
  i5 = i3 + i2 | 0;
  L156 : do if (i1 >>> 0 < i5 >>> 0) {
   i4 = HEAP32[i109 >> 2] | 0;
   do {
    if ((HEAP32[i4 + (i1 * 360 | 0) + 240 >> 2] | 0) >= (i6 | 0)) break L156;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
  } while (0);
  if (i1 >>> 0 < i5 >>> 0) {
   i5 = i104 + 188 | 0;
   i4 = i1;
   while (1) {
    i1 = HEAP32[i109 >> 2] | 0;
    if ((HEAP32[i1 + (i4 * 360 | 0) + 240 >> 2] | 0) >= (HEAP32[i5 >> 2] | 0)) break L153;
    if ((HEAP32[i1 + (i4 * 360 | 0) + 236 >> 2] | 0) == 1) {
     i1 = HEAP32[i1 + (i4 * 360 | 0) + 332 >> 2] | 0;
     if (!i1) i1 = i3; else {
      mftCall_viii(i1 | 0, i109 | 0, i4 | 0, i108 | 0);
      i1 = HEAP32[i106 >> 2] | 0;
      i2 = HEAP32[i105 >> 2] | 0;
     }
    } else i1 = i3;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (i1 + i2 | 0) >>> 0) break; else i3 = i1;
   }
  }
 } while (0);
 __ZN13BatchRendererD2Ev(i110);
 i110 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i110 >> 2] | 0) + 652 >> 2] | 0, i110 | 0);
 if (!i107) {
  STACKTOP = i111;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i107);
 STACKTOP = i111;
 return;
}

function __ZN7mecanim9animation22MotionAddOverrideLayerEPNS0_12MotionOutputEPKS1_fbbRKNS_6bitsetILj66EEE(i3, i4, f5, i1, i2, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0;
 if (!(f5 < Math_fround(1.0))) {
  __ZN7mecanim9animation16MotionOutputCopyEPNS0_12MotionOutputEPKS1_bbRKNS_6bitsetILj66EEE(i3, i4, i1, i2, i6);
  return;
 }
 do if (i1) i7 = 5; else if (i2) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!(i1 & 1)) break; else {
   i7 = 5;
   break;
  }
 } else return; while (0);
 do if ((i7 | 0) == 5) {
  f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  i7 = i3 + 4 | 0;
  f19 = Math_fround(HEAPF32[i7 >> 2]);
  i22 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i22 >> 2]);
  i10 = i3 + 12 | 0;
  f25 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(f8 + Math_fround(Math_fround(f9 - f8) * f5));
  f25 = Math_fround(f25 + Math_fround(Math_fround(f21 - f25) * f5));
  HEAPF32[i7 >> 2] = Math_fround(f19 + Math_fround(Math_fround(f15 - f19) * f5));
  HEAPF32[i22 >> 2] = f8;
  HEAPF32[i10 >> 2] = f25;
  f25 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  i10 = i3 + 16 | 0;
  f15 = Math_fround(HEAPF32[i10 >> 2]);
  i22 = i3 + 20 | 0;
  f21 = Math_fround(HEAPF32[i22 >> 2]);
  i7 = i3 + 24 | 0;
  f9 = Math_fround(HEAPF32[i7 >> 2]);
  f21 = Math_fround(f21 + Math_fround(Math_fround(f8 - f21) * f5));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f19 - f9) * f5));
  HEAPF32[i10 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f25 - f15) * f5));
  HEAPF32[i22 >> 2] = f21;
  HEAPF32[i7 >> 2] = f9;
  i7 = i3 + 284 | 0;
  f9 = Math_fround(HEAPF32[i7 >> 2]);
  HEAPF32[i7 >> 2] = Math_fround(f9 + Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 284 >> 2]) - f9) * f5));
  f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  i7 = i3 + 28 | 0;
  f25 = Math_fround(HEAPF32[i7 >> 2]);
  i22 = i3 + 32 | 0;
  f19 = Math_fround(HEAPF32[i22 >> 2]);
  i10 = i3 + 36 | 0;
  f8 = Math_fround(HEAPF32[i10 >> 2]);
  f25 = Math_fround(f25 + Math_fround(Math_fround(f9 - f25) * f5));
  f19 = Math_fround(f19 + Math_fround(Math_fround(f21 - f19) * f5));
  f8 = Math_fround(f8 + Math_fround(Math_fround(f15 - f8) * f5));
  i12 = i3 + 40 | 0;
  f15 = Math_fround(HEAPF32[i12 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 40 >> 2]);
  f9 = Math_fround(f15 * f21);
  i14 = i3 + 44 | 0;
  f26 = Math_fround(HEAPF32[i14 >> 2]);
  f30 = Math_fround(HEAPF32[i4 + 44 >> 2]);
  f27 = Math_fround(f26 * f30);
  i16 = i3 + 48 | 0;
  f28 = Math_fround(HEAPF32[i16 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 48 >> 2]);
  f17 = Math_fround(f28 * f23);
  i18 = i3 + 52 | 0;
  f13 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 52 >> 2]);
  f17 = Math_fround(Math_fround(f9 + f27) + Math_fround(f17 + Math_fround(f13 * f11)));
  i20 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = i20 & -2147483648;
  i29 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
  f11 = Math_fround(f15 + Math_fround(f11 * f5));
  f23 = Math_fround(f26 + Math_fround(f23 * f5));
  f30 = Math_fround(f28 + Math_fround(f30 * f5));
  f13 = Math_fround(f13 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13) * f5));
  f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f23 * f23)) + Math_fround(Math_fround(f30 * f30) + Math_fround(f13 * f13))))));
  f11 = Math_fround(f28 * f11);
  f23 = Math_fround(f28 * f23);
  f30 = Math_fround(f28 * f30);
  f13 = Math_fround(f28 * f13);
  f28 = Math_fround(HEAPF32[i4 + 56 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 60 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 64 >> 2]);
  i20 = i3 + 56 | 0;
  f21 = Math_fround(HEAPF32[i20 >> 2]);
  i1 = i3 + 60 | 0;
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  i24 = i3 + 64 | 0;
  f27 = Math_fround(HEAPF32[i24 >> 2]);
  f21 = Math_fround(f21 + Math_fround(Math_fround(f28 - f21) * f5));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f26 - f17) * f5));
  f27 = Math_fround(f27 + Math_fround(Math_fround(f15 - f27) * f5));
  HEAPF32[i7 >> 2] = f25;
  HEAPF32[i22 >> 2] = f19;
  HEAPF32[i10 >> 2] = f8;
  HEAPF32[i12 >> 2] = f11;
  HEAPF32[i14 >> 2] = f23;
  HEAPF32[i16 >> 2] = f30;
  HEAPF32[i18 >> 2] = f13;
  HEAPF32[i20 >> 2] = f21;
  HEAPF32[i1 >> 2] = f17;
  HEAPF32[i24 >> 2] = f27;
  f27 = Math_fround(HEAPF32[i4 + 68 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 72 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 76 >> 2]);
  i24 = i3 + 68 | 0;
  f13 = Math_fround(HEAPF32[i24 >> 2]);
  i1 = i3 + 72 | 0;
  f30 = Math_fround(HEAPF32[i1 >> 2]);
  i20 = i3 + 76 | 0;
  f23 = Math_fround(HEAPF32[i20 >> 2]);
  f13 = Math_fround(f13 + Math_fround(Math_fround(f27 - f13) * f5));
  f30 = Math_fround(f30 + Math_fround(Math_fround(f17 - f30) * f5));
  f23 = Math_fround(f23 + Math_fround(Math_fround(f21 - f23) * f5));
  i18 = i3 + 80 | 0;
  f21 = Math_fround(HEAPF32[i18 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 80 >> 2]);
  f27 = Math_fround(f21 * f17);
  i16 = i3 + 84 | 0;
  f11 = Math_fround(HEAPF32[i16 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 84 >> 2]);
  f19 = Math_fround(f11 * f8);
  i14 = i3 + 88 | 0;
  f25 = Math_fround(HEAPF32[i14 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 88 >> 2]);
  f26 = Math_fround(f25 * f15);
  i12 = i3 + 92 | 0;
  f28 = Math_fround(HEAPF32[i12 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 92 >> 2]);
  f26 = Math_fround(Math_fround(f27 + f19) + Math_fround(f26 + Math_fround(f28 * f9)));
  i10 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 & -2147483648;
  i22 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
  f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f25);
  f9 = Math_fround(f21 + Math_fround(f9 * f5));
  f15 = Math_fround(f11 + Math_fround(f15 * f5));
  f8 = Math_fround(f25 + Math_fround(f8 * f5));
  f28 = Math_fround(f28 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28) * f5));
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f8 * f8) + Math_fround(f28 * f28))))));
  f9 = Math_fround(f25 * f9);
  f15 = Math_fround(f25 * f15);
  f8 = Math_fround(f25 * f8);
  f28 = Math_fround(f25 * f28);
  f25 = Math_fround(HEAPF32[i4 + 96 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 100 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 104 >> 2]);
  i10 = i3 + 96 | 0;
  f17 = Math_fround(HEAPF32[i10 >> 2]);
  i29 = i3 + 100 | 0;
  f26 = Math_fround(HEAPF32[i29 >> 2]);
  i7 = i3 + 104 | 0;
  f19 = Math_fround(HEAPF32[i7 >> 2]);
  f17 = Math_fround(f17 + Math_fround(Math_fround(f25 - f17) * f5));
  f26 = Math_fround(f26 + Math_fround(Math_fround(f11 - f26) * f5));
  f19 = Math_fround(f19 + Math_fround(Math_fround(f21 - f19) * f5));
  HEAPF32[i24 >> 2] = f13;
  HEAPF32[i1 >> 2] = f30;
  HEAPF32[i20 >> 2] = f23;
  HEAPF32[i18 >> 2] = f9;
  HEAPF32[i16 >> 2] = f15;
  HEAPF32[i14 >> 2] = f8;
  HEAPF32[i12 >> 2] = f28;
  HEAPF32[i10 >> 2] = f17;
  HEAPF32[i29 >> 2] = f26;
  HEAPF32[i7 >> 2] = f19;
  f19 = Math_fround(HEAPF32[i4 + 108 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 112 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 116 >> 2]);
  i7 = i3 + 108 | 0;
  f28 = Math_fround(HEAPF32[i7 >> 2]);
  i29 = i3 + 112 | 0;
  f8 = Math_fround(HEAPF32[i29 >> 2]);
  i10 = i3 + 116 | 0;
  f15 = Math_fround(HEAPF32[i10 >> 2]);
  f28 = Math_fround(f28 + Math_fround(Math_fround(f19 - f28) * f5));
  f8 = Math_fround(f8 + Math_fround(Math_fround(f26 - f8) * f5));
  f15 = Math_fround(f15 + Math_fround(Math_fround(f17 - f15) * f5));
  i12 = i3 + 120 | 0;
  f17 = Math_fround(HEAPF32[i12 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f19 = Math_fround(f17 * f26);
  i14 = i3 + 124 | 0;
  f9 = Math_fround(HEAPF32[i14 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 124 >> 2]);
  f30 = Math_fround(f9 * f23);
  i16 = i3 + 128 | 0;
  f13 = Math_fround(HEAPF32[i16 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  f11 = Math_fround(f13 * f21);
  i18 = i3 + 132 | 0;
  f25 = Math_fround(HEAPF32[i18 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f11 = Math_fround(Math_fround(f19 + f30) + Math_fround(f11 + Math_fround(f25 * f27)));
  i20 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = i20 & -2147483648;
  i1 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = i20 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f17);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  f27 = Math_fround(f17 + Math_fround(f27 * f5));
  f21 = Math_fround(f9 + Math_fround(f21 * f5));
  f23 = Math_fround(f13 + Math_fround(f23 * f5));
  f25 = Math_fround(f25 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f25) * f5));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f21 * f21)) + Math_fround(Math_fround(f23 * f23) + Math_fround(f25 * f25))))));
  f27 = Math_fround(f13 * f27);
  f21 = Math_fround(f13 * f21);
  f23 = Math_fround(f13 * f23);
  f25 = Math_fround(f13 * f25);
  f13 = Math_fround(HEAPF32[i4 + 136 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 140 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 144 >> 2]);
  i20 = i3 + 136 | 0;
  f26 = Math_fround(HEAPF32[i20 >> 2]);
  i22 = i3 + 140 | 0;
  f11 = Math_fround(HEAPF32[i22 >> 2]);
  i24 = i3 + 144 | 0;
  f30 = Math_fround(HEAPF32[i24 >> 2]);
  f26 = Math_fround(f26 + Math_fround(Math_fround(f13 - f26) * f5));
  f11 = Math_fround(f11 + Math_fround(Math_fround(f9 - f11) * f5));
  f30 = Math_fround(f30 + Math_fround(Math_fround(f17 - f30) * f5));
  HEAPF32[i7 >> 2] = f28;
  HEAPF32[i29 >> 2] = f8;
  HEAPF32[i10 >> 2] = f15;
  HEAPF32[i12 >> 2] = f27;
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i16 >> 2] = f23;
  HEAPF32[i18 >> 2] = f25;
  HEAPF32[i20 >> 2] = f26;
  HEAPF32[i22 >> 2] = f11;
  HEAPF32[i24 >> 2] = f30;
  f30 = Math_fround(HEAPF32[i4 + 148 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 152 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 156 >> 2]);
  i24 = i3 + 148 | 0;
  f25 = Math_fround(HEAPF32[i24 >> 2]);
  i22 = i3 + 152 | 0;
  f23 = Math_fround(HEAPF32[i22 >> 2]);
  i20 = i3 + 156 | 0;
  f21 = Math_fround(HEAPF32[i20 >> 2]);
  f25 = Math_fround(f25 + Math_fround(Math_fround(f30 - f25) * f5));
  f23 = Math_fround(f23 + Math_fround(Math_fround(f11 - f23) * f5));
  f21 = Math_fround(f21 + Math_fround(Math_fround(f26 - f21) * f5));
  i18 = i3 + 160 | 0;
  f26 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 160 >> 2]);
  f30 = Math_fround(f26 * f11);
  i16 = i3 + 164 | 0;
  f27 = Math_fround(HEAPF32[i16 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 164 >> 2]);
  f8 = Math_fround(f27 * f15);
  i14 = i3 + 168 | 0;
  f28 = Math_fround(HEAPF32[i14 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 168 >> 2]);
  f9 = Math_fround(f28 * f17);
  i12 = i3 + 172 | 0;
  f13 = Math_fround(HEAPF32[i12 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 172 >> 2]);
  f9 = Math_fround(Math_fround(f30 + f8) + Math_fround(f9 + Math_fround(f13 * f19)));
  i10 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 & -2147483648;
  i29 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i10 ^ (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
  f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
  f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
  f19 = Math_fround(f26 + Math_fround(f19 * f5));
  f17 = Math_fround(f27 + Math_fround(f17 * f5));
  f15 = Math_fround(f28 + Math_fround(f15 * f5));
  f13 = Math_fround(f13 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13) * f5));
  f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f17 * f17)) + Math_fround(Math_fround(f15 * f15) + Math_fround(f13 * f13))))));
  f19 = Math_fround(f28 * f19);
  f17 = Math_fround(f28 * f17);
  f15 = Math_fround(f28 * f15);
  f13 = Math_fround(f28 * f13);
  f28 = Math_fround(HEAPF32[i4 + 176 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 180 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 184 >> 2]);
  i10 = i3 + 176 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  i1 = i3 + 180 | 0;
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  i7 = i3 + 184 | 0;
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  f11 = Math_fround(f11 + Math_fround(Math_fround(f28 - f11) * f5));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f27 - f9) * f5));
  f8 = Math_fround(f8 + Math_fround(Math_fround(f26 - f8) * f5));
  HEAPF32[i24 >> 2] = f25;
  HEAPF32[i22 >> 2] = f23;
  HEAPF32[i20 >> 2] = f21;
  HEAPF32[i18 >> 2] = f19;
  HEAPF32[i16 >> 2] = f17;
  HEAPF32[i14 >> 2] = f15;
  HEAPF32[i12 >> 2] = f13;
  HEAPF32[i10 >> 2] = f11;
  HEAPF32[i1 >> 2] = f9;
  HEAPF32[i7 >> 2] = f8;
  if (i2) {
   i1 = HEAP32[i6 >> 2] | 0;
   break;
  } else return;
 } while (0);
 if (i1 & 1 | 0) {
  f8 = Math_fround(HEAPF32[i4 + 292 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 296 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 300 >> 2]);
  i7 = i3 + 292 | 0;
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  i10 = i3 + 296 | 0;
  f17 = Math_fround(HEAPF32[i10 >> 2]);
  i12 = i3 + 300 | 0;
  f19 = Math_fround(HEAPF32[i12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(Math_fround(f8 - f15) * f5));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f27 - f17) * f5));
  f19 = Math_fround(f19 + Math_fround(Math_fround(f13 - f19) * f5));
  i14 = i3 + 304 | 0;
  f13 = Math_fround(HEAPF32[i14 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 304 >> 2]);
  f8 = Math_fround(f13 * f27);
  i16 = i3 + 308 | 0;
  f11 = Math_fround(HEAPF32[i16 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 308 >> 2]);
  f30 = Math_fround(f11 * f25);
  i18 = i3 + 312 | 0;
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 312 >> 2]);
  f28 = Math_fround(f9 * f23);
  i20 = i3 + 316 | 0;
  f26 = Math_fround(HEAPF32[i20 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 316 >> 2]);
  f28 = Math_fround(Math_fround(f8 + f30) + Math_fround(f28 + Math_fround(f26 * f21)));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 & -2147483648;
  i2 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f21 = Math_fround(f13 + Math_fround(f21 * f5));
  f23 = Math_fround(f11 + Math_fround(f23 * f5));
  f25 = Math_fround(f9 + Math_fround(f25 * f5));
  f26 = Math_fround(f26 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26) * f5));
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
  f21 = Math_fround(f9 * f21);
  f23 = Math_fround(f9 * f23);
  f25 = Math_fround(f9 * f25);
  f26 = Math_fround(f9 * f26);
  f9 = Math_fround(HEAPF32[i4 + 320 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 324 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 328 >> 2]);
  i22 = i3 + 320 | 0;
  f27 = Math_fround(HEAPF32[i22 >> 2]);
  i24 = i3 + 324 | 0;
  f28 = Math_fround(HEAPF32[i24 >> 2]);
  i29 = i3 + 328 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f27 = Math_fround(f27 + Math_fround(Math_fround(f9 - f27) * f5));
  f28 = Math_fround(f28 + Math_fround(Math_fround(f11 - f28) * f5));
  f30 = Math_fround(f30 + Math_fround(Math_fround(f13 - f30) * f5));
  HEAPF32[i7 >> 2] = f15;
  HEAPF32[i10 >> 2] = f17;
  HEAPF32[i12 >> 2] = f19;
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i16 >> 2] = f23;
  HEAPF32[i18 >> 2] = f25;
  HEAPF32[i20 >> 2] = f26;
  HEAPF32[i22 >> 2] = f27;
  HEAPF32[i24 >> 2] = f28;
  HEAPF32[i29 >> 2] = f30;
 }
 if (__ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE(i6) | 0) {
  f8 = Math_fround(HEAPF32[i4 + 188 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 192 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 196 >> 2]);
  i7 = i3 + 188 | 0;
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  i10 = i3 + 192 | 0;
  f17 = Math_fround(HEAPF32[i10 >> 2]);
  i12 = i3 + 196 | 0;
  f19 = Math_fround(HEAPF32[i12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(Math_fround(f8 - f15) * f5));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f27 - f17) * f5));
  f19 = Math_fround(f19 + Math_fround(Math_fround(f13 - f19) * f5));
  i14 = i3 + 200 | 0;
  f13 = Math_fround(HEAPF32[i14 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 200 >> 2]);
  f8 = Math_fround(f13 * f27);
  i16 = i3 + 204 | 0;
  f11 = Math_fround(HEAPF32[i16 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 204 >> 2]);
  f30 = Math_fround(f11 * f25);
  i18 = i3 + 208 | 0;
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 208 >> 2]);
  f28 = Math_fround(f9 * f23);
  i20 = i3 + 212 | 0;
  f26 = Math_fround(HEAPF32[i20 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 212 >> 2]);
  f28 = Math_fround(Math_fround(f8 + f30) + Math_fround(f28 + Math_fround(f26 * f21)));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 & -2147483648;
  i2 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f21 = Math_fround(f13 + Math_fround(f21 * f5));
  f23 = Math_fround(f11 + Math_fround(f23 * f5));
  f25 = Math_fround(f9 + Math_fround(f25 * f5));
  f26 = Math_fround(f26 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26) * f5));
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
  f21 = Math_fround(f9 * f21);
  f23 = Math_fround(f9 * f23);
  f25 = Math_fround(f9 * f25);
  f26 = Math_fround(f9 * f26);
  f9 = Math_fround(HEAPF32[i4 + 216 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 220 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 224 >> 2]);
  i22 = i3 + 216 | 0;
  f27 = Math_fround(HEAPF32[i22 >> 2]);
  i24 = i3 + 220 | 0;
  f28 = Math_fround(HEAPF32[i24 >> 2]);
  i29 = i3 + 224 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f27 = Math_fround(f27 + Math_fround(Math_fround(f9 - f27) * f5));
  f28 = Math_fround(f28 + Math_fround(Math_fround(f11 - f28) * f5));
  f30 = Math_fround(f30 + Math_fround(Math_fround(f13 - f30) * f5));
  HEAPF32[i7 >> 2] = f15;
  HEAPF32[i10 >> 2] = f17;
  HEAPF32[i12 >> 2] = f19;
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i16 >> 2] = f23;
  HEAPF32[i18 >> 2] = f25;
  HEAPF32[i20 >> 2] = f26;
  HEAPF32[i22 >> 2] = f27;
  HEAPF32[i24 >> 2] = f28;
  HEAPF32[i29 >> 2] = f30;
  i29 = i3 + 268 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 268 >> 2]);
  HEAPF32[i29 >> 2] = f30 < f28 ? f28 : f30;
  i29 = i3 + 272 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 272 >> 2]);
  HEAPF32[i29 >> 2] = f30 < f28 ? f28 : f30;
 }
 if (__ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE(i6) | 0) {
  f8 = Math_fround(HEAPF32[i4 + 228 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 232 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 236 >> 2]);
  i7 = i3 + 228 | 0;
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  i10 = i3 + 232 | 0;
  f17 = Math_fround(HEAPF32[i10 >> 2]);
  i12 = i3 + 236 | 0;
  f19 = Math_fround(HEAPF32[i12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(Math_fround(f8 - f15) * f5));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f27 - f17) * f5));
  f19 = Math_fround(f19 + Math_fround(Math_fround(f13 - f19) * f5));
  i14 = i3 + 240 | 0;
  f13 = Math_fround(HEAPF32[i14 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 240 >> 2]);
  f8 = Math_fround(f13 * f27);
  i16 = i3 + 244 | 0;
  f11 = Math_fround(HEAPF32[i16 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 244 >> 2]);
  f30 = Math_fround(f11 * f25);
  i18 = i3 + 248 | 0;
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 248 >> 2]);
  f28 = Math_fround(f9 * f23);
  i20 = i3 + 252 | 0;
  f26 = Math_fround(HEAPF32[i20 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 252 >> 2]);
  f28 = Math_fround(Math_fround(f8 + f30) + Math_fround(f28 + Math_fround(f26 * f21)));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 & -2147483648;
  i6 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i22 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f21 = Math_fround(f13 + Math_fround(f21 * f5));
  f23 = Math_fround(f11 + Math_fround(f23 * f5));
  f25 = Math_fround(f9 + Math_fround(f25 * f5));
  f26 = Math_fround(f26 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26) * f5));
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
  f21 = Math_fround(f9 * f21);
  f23 = Math_fround(f9 * f23);
  f25 = Math_fround(f9 * f25);
  f26 = Math_fround(f9 * f26);
  f9 = Math_fround(HEAPF32[i4 + 256 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 260 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 264 >> 2]);
  i22 = i3 + 256 | 0;
  f27 = Math_fround(HEAPF32[i22 >> 2]);
  i24 = i3 + 260 | 0;
  f28 = Math_fround(HEAPF32[i24 >> 2]);
  i29 = i3 + 264 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f27 = Math_fround(f27 + Math_fround(Math_fround(f9 - f27) * f5));
  f28 = Math_fround(f28 + Math_fround(Math_fround(f11 - f28) * f5));
  f30 = Math_fround(f30 + Math_fround(Math_fround(f13 - f30) * f5));
  HEAPF32[i7 >> 2] = f15;
  HEAPF32[i10 >> 2] = f17;
  HEAPF32[i12 >> 2] = f19;
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i16 >> 2] = f23;
  HEAPF32[i18 >> 2] = f25;
  HEAPF32[i20 >> 2] = f26;
  HEAPF32[i22 >> 2] = f27;
  HEAPF32[i24 >> 2] = f28;
  HEAPF32[i29 >> 2] = f30;
  i29 = i3 + 276 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 276 >> 2]);
  HEAPF32[i29 >> 2] = f30 < f28 ? f28 : f30;
  i29 = i3 + 280 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 280 >> 2]);
  HEAPF32[i29 >> 2] = f30 < f28 ? f28 : f30;
 }
 i29 = i3 + 288 | 0;
 f30 = Math_fround(HEAPF32[i29 >> 2]);
 HEAPF32[i29 >> 2] = Math_fround(f30 + Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 288 >> 2]) - f30) * f5));
 return;
}

function __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet(i31, i41, i43) {
 i31 = i31 | 0;
 i41 = i41 | 0;
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 1184 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i47 + 1048 | 0;
 i37 = i47 + 1040 | 0;
 i39 = i47 + 16 | 0;
 i46 = i47 + 1164 | 0;
 i27 = i47 + 1160 | 0;
 i28 = i47 + 1156 | 0;
 i29 = i47 + 1152 | 0;
 i38 = i47 + 1148 | 0;
 i14 = i47 + 1144 | 0;
 i42 = i47 + 1092 | 0;
 i32 = i47 + 1056 | 0;
 i33 = i47;
 i25 = i47 + 1080 | 0;
 i26 = i47 + 1068 | 0;
 i34 = i47 + 1052 | 0;
 i35 = i47 + 1064 | 0;
 i36 = i47 + 1060 | 0;
 i45 = gb + 64016 | 0;
 i44 = HEAP32[i45 + 4 >> 2] | 0;
 i40 = i39;
 HEAP32[i40 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i40 + 4 >> 2] = i44;
 HEAP32[i46 >> 2] = 0;
 i40 = i46 + 12 | 0;
 HEAP32[i40 >> 2] = 0;
 i44 = i46 + 16 | 0;
 HEAP32[i44 >> 2] = 0;
 i45 = i46 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, i39);
 i21 = i37;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i23 = i45;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = i22;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i29 >> 2] = -1;
 HEAP32[i38 >> 2] = 0;
 if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 121 >> 0] | 0) {
  HEAP32[i14 >> 2] = 0;
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 92 >> 2] | 0, i31 | 0, 35382, i14 | 0);
  i12 = i41 + 80 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i13 = i41 + 84 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) do {
   i2 = i1 + -52 | 0;
   HEAP32[i13 >> 2] = i2;
   i3 = i1 + -48 | 0;
   if ((HEAP32[i1 + -32 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -44 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i13 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
  __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE7reserveEj(i12, HEAP32[i14 >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i3 = i42 + 4 | 0;
   i4 = i42 + 16 | 0;
   i5 = i42 + 20 | 0;
   i6 = i42 + 8 | 0;
   i7 = i42 + 24 | 0;
   i8 = i42 + 28 | 0;
   i9 = i41 + 88 | 0;
   i10 = i42 + 4 | 0;
   i1 = 0;
   do {
    mftCall_viiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 216 >> 2] | 0, i31 | 0, i1 | 0, 1024, i38 | 0, i39 | 0);
    mftCall_viiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 212 >> 2] | 0, i31 | 0, i1 | 0, 35392, i28 | 0);
    HEAP32[i42 >> 2] = -1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
    i22 = i37;
    i23 = HEAP32[i22 + 4 >> 2] | 0;
    i11 = i6;
    HEAP32[i11 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i11 + 4 >> 2] = i23;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    HEAP32[i7 + 20 >> 2] = 0;
    HEAP32[i7 + 24 >> 2] = 0;
    HEAP32[i37 >> 2] = -1;
    __ZN9ShaderLab16FastPropertyName4InitEPKc(i37, i39);
    HEAP32[i42 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i8 >> 2] = i1;
    mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 220 >> 2] | 0, i31 | 0, i1 | 0, i1 | 0);
    i11 = HEAP32[i13 >> 2] | 0;
    if ((i11 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i42); else {
     HEAP32[i11 >> 2] = HEAP32[i42 >> 2];
     __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i11 + 4 | 0, i10);
     i23 = i11 + 24 | 0;
     HEAP32[i23 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i23 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 52;
    }
    if ((HEAP32[i5 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6);
     HEAP32[i10 >> 2] = 0;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  mftCall_viiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 248 >> 2] | 0, i31 | 0, 37568, 37621, i37 | 0);
  i1 = HEAP32[i37 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i8 = i41 + 112 | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   i9 = i41 + 116 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i6;
   if ((i2 | 0) != (i6 | 0)) {
    i2 = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2) | 0;
    HEAP32[i9 >> 2] = i2;
   }
   i7 = i41 + 120 | 0;
   if ((HEAP32[i7 >> 2] | 0) - i3 >> 2 >>> 0 < i1 >>> 0) {
    i3 = i2 - i3 | 0;
    i2 = i3 >> 2;
    if (!i1) i5 = 0; else i5 = __Znwj(i1 << 2) | 0;
    i4 = i5 + (i2 << 2) | 0;
    i2 = i4 + (0 - i2 << 2) | 0;
    if ((i3 | 0) > 0) _memcpy(i2 | 0, i6 | 0, i3 | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i9 >> 2] = i4;
    HEAP32[i7 >> 2] = i5 + (i1 << 2);
    if (i6) {
     __ZdlPv(i6);
     i1 = HEAP32[i37 >> 2] | 0;
    }
   }
   if ((i1 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i42 >> 2] = 37634;
     mftCall_viiiiiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 256 >> 2] | 0, i31 | 0, 37568, i1 | 0, 1, i42 | 0, 1, i32 | 0, i14 | 0);
     i2 = HEAP32[i14 >> 2] | 0;
     HEAP32[i33 >> 2] = i2;
     i3 = HEAP32[i9 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i33); else {
      HEAP32[i3 >> 2] = i2;
      HEAP32[i9 >> 2] = i3 + 4;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i37 >> 2] | 0));
   }
  }
 }
 mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 92 >> 2] | 0, i31 | 0, 35718, i14 | 0);
 HEAP32[i37 >> 2] = 0;
 i9 = HEAP32[i14 >> 2] | 0;
 if ((i9 | 0) > 0) {
  i10 = i39 + 10 | 0;
  i11 = i25 + 11 | 0;
  i12 = i39 + 12 | 0;
  i13 = i26 + 11 | 0;
  i14 = i39 + 13 | 0;
  i15 = i33 + 11 | 0;
  i16 = i41 + 112 | 0;
  i17 = i41 + 36 | 0;
  i18 = i41 + 40 | 0;
  i19 = i33 + 4 | 0;
  i20 = i41 + 92 | 0;
  i21 = i41 + 104 | 0;
  i22 = i41 + 108 | 0;
  i23 = i41 + 96 | 0;
  i1 = 0;
  do {
   mftCall_viiiiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 76 >> 2] | 0, i31 | 0, i1 | 0, 1024, i38 | 0, i28 | 0, i27 | 0, i39 | 0);
   if (_strncmp(i39, gb + 605740 | 0, 3) | 0) {
    HEAP32[i42 >> 2] = -1;
    HEAP32[i29 >> 2] = -1;
    i8 = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 104 >> 2] | 0, i31 | 0, i39 | 0) | 0;
    HEAP32[i42 >> 2] = i8;
    if ((i8 | 0) == -1) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 661 >> 0] | 0) {
     mftCall_viiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 204 >> 2] | 0, i31 | 0, 1, i37 | 0, 35387, i42 | 0);
     mftCall_viiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 204 >> 2] | 0, i31 | 0, 1, i37 | 0, 35386, i29 | 0);
     if ((HEAP32[i29 >> 2] | 0) < 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
      HEAP32[i32 >> 2] = 37633;
      mftCall_viiiiiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 256 >> 2] | 0, i31 | 0, 37601, HEAP32[i37 >> 2] | 0, 1, i32 | 0, 1, i33 | 0, i29 | 0);
     }
    }
    if (!(_strncmp(i39, gb + 605744 | 0, 10) | 0)) {
     i1 = HEAP8[i10 >> 0] | 0;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i25 + 4 >> 2] = 0;
     HEAP32[i25 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i25, 1, i1);
     i1 = _atoi((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
     i3 = HEAP8[i12 >> 0] | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i26, 1, i3);
     i3 = _atoi((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i26 >> 2] | 0 : i26) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     i1 = i1 + -2 | 0;
     i2 = i3 + -2 | 0;
     if (i1 >>> 0 < 3 & i2 >>> 0 < 3) HEAP32[i27 >> 2] = HEAP32[gb + 77188 + (i2 * 12 | 0) + (i1 << 2) >> 2];
     HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) / (i3 | 0) | 0;
     _memmove(i39 | 0, i14 | 0, (_strnlen(i39, 1024) | 0) + -12 | 0) | 0;
     i1 = _strnlen(i39, 1024) | 0;
     HEAP32[i38 >> 2] = i1;
     i2 = HEAP32[i28 >> 2] | 0;
     if ((i2 | 0) == 1) {
      HEAP8[i39 + (i1 + -3) >> 0] = 0;
      i3 = 3;
      i2 = 1;
     } else i3 = 3;
    } else {
     i3 = 1;
     i1 = HEAP32[i38 >> 2] | 0;
     i2 = HEAP32[i28 >> 2] | 0;
    }
    HEAP8[i32 >> 0] = 0;
    do if (__ZN4glsl22IsShaderParameterArrayEPKciiPb(i39, i1, i2, i32) | 0) if (!(HEAP8[i32 >> 0] | 0)) {
     HEAP32[i30 >> 2] = i39;
     __Z6FormatPKcz(i33, gb + 605755 | 0, i30);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33, 0, gb + 605794 | 0, 244, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
     break;
    } else {
     HEAP8[i39 + ((HEAP32[i38 >> 2] | 0) + -3) >> 0] = 0;
     i24 = 54;
     break;
    } else {
     HEAP32[i28 >> 2] = 0;
     i1 = __Z28GetGLSLPropertyNameRemapGLESPKc(i39) | 0;
     if (!i1) i24 = 54; else {
      _strcpy(i39, i1) | 0;
      i24 = 54;
     }
    } while (0);
    L76 : do if ((i24 | 0) == 54) {
     i24 = 0;
     i1 = HEAP32[i27 >> 2] | 0;
     L78 : do if ((i1 | 0) < 36293) {
      if ((i1 | 0) >= 35674) do switch (i1 | 0) {
      case 35680:
       {
        i24 = 89;
        break L78;
       }
      case 35679:
       {
        i24 = 91;
        break L78;
       }
      case 35682:
      case 35678:
       {
        i1 = 2;
        break L78;
       }
      case 35674:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 2, 2, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35685:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 3, 2, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35686:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 4, 2, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35687:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 2, 3, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35675:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 3, 3, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35688:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 4, 3, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35689:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 2, 4, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35690:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 3, 4, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 35676:
       {
        __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 4, 4, HEAP32[i29 >> 2] | 0, i3, i43);
        break L76;
       }
      case 36289:
       {
        i8 = (HEAP32[i18 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) >> 4;
        mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i42 >> 2] | 0, i8 | 0);
        __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(i41, i39, i8, -1, 5, i43);
        break L76;
       }
      default:
       break L76;
      } while (0);
      if ((i1 | 0) >= 35667) switch (i1 | 0) {
      case 35667:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 1, 2, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35668:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 1, 3, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35669:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 1, 4, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35670:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 2, 1, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35671:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 2, 2, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35672:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 2, 3, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35673:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 2, 4, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      default:
       break L76;
      }
      if ((i1 | 0) < 35664) switch (i1 | 0) {
      case 5126:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 1, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 5124:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 1, 1, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 5125:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 5, 1, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      default:
       break L76;
      } else switch (i1 | 0) {
      case 35664:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 2, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35665:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 3, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      case 35666:
       {
        __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 0, 4, HEAP32[i29 >> 2] | 0, i43);
        break L76;
       }
      default:
       break L76;
      }
     } else switch (i1 | 0) {
     case 36308:
     case 36293:
     case 36300:
      {
       i24 = 89;
       break L78;
      }
     case 36299:
     case 36307:
      {
       i24 = 91;
       break L78;
      }
     case 37130:
     case 37129:
     case 37128:
     case 36306:
     case 36298:
      {
       i1 = 2;
       break L78;
      }
     case 36294:
      {
       __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 5, 2, HEAP32[i29 >> 2] | 0, i43);
       break L76;
      }
     case 36295:
      {
       __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 5, 3, HEAP32[i29 >> 2] | 0, i43);
       break L76;
      }
     case 36296:
      {
       __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i41, i39, HEAP32[i42 >> 2] | 0, HEAP32[i28 >> 2] | 0, 5, 4, HEAP32[i29 >> 2] | 0, i43);
       break L76;
      }
     case 37595:
      {
       if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0)) break L76;
       i1 = HEAP32[i38 >> 2] | 0;
       if ((i1 | 0) <= 8) break L76;
       i1 = i39 + i1 + -8 | 0;
       if (_strcmp(i1, gb + 605886 | 0) | 0) break L76;
       HEAP8[i1 >> 0] = 0;
       HEAP32[i33 >> 2] = -1;
       __ZN9ShaderLab16FastPropertyName4InitEPKc(i33, i39);
       i2 = HEAP32[i33 >> 2] | 0;
       i3 = HEAP32[(HEAP32[i16 >> 2] | 0) + (HEAP32[i29 >> 2] << 2) >> 2] | 0;
       i4 = HEAP32[i42 >> 2] | 0;
       i5 = HEAP32[i40 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i7 = HEAP32[i44 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i6 >>> 0 > i8 >>> 0) {
        i1 = i7 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i44 >> 2] = i1;
         HEAP32[i46 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i46 >> 2] | 0, i1 * 12 | 0, 4, i45, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i45, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i46 >> 2] | 0, (HEAP32[i40 >> 2] | 0) * 12 | 0) | 0;
         HEAP32[i44 >> 2] = i1;
         HEAP32[i46 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i40 >> 2] = i6;
       i8 = HEAP32[i46 >> 2] | 0;
       HEAP32[i8 + (i5 * 12 | 0) >> 2] = i2;
       HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] = i3;
       HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] = i4;
       break L76;
      }
     case 36963:
     case 36964:
     case 36966:
     case 36969:
     case 36958:
     case 36955:
     case 36953:
     case 36952:
     case 36947:
     case 36944:
     case 36942:
     case 36941:
      {
       HEAP32[i33 >> 2] = -1;
       HEAP32[i19 >> 2] = 0;
       HEAP32[i34 >> 2] = -1;
       __ZN9ShaderLab16FastPropertyName4InitEPKc(i34, i39);
       HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
       mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 100 >> 2] | 0, i31 | 0, HEAP32[i42 >> 2] | 0, i19 | 0);
       i2 = HEAP32[i21 >> 2] | 0;
       i3 = i2 + 1 | 0;
       i4 = HEAP32[i22 >> 2] | 0;
       i5 = i4 & 2147483647;
       do if (i3 >>> 0 > i5 >>> 0) {
        i1 = i4 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
         HEAP32[i22 >> 2] = i1;
         HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 3, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 3 | 0) | 0;
         HEAP32[i22 >> 2] = i1;
         HEAP32[i20 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i21 >> 2] = i3;
       i6 = i33;
       i7 = HEAP32[i6 + 4 >> 2] | 0;
       i8 = (HEAP32[i20 >> 2] | 0) + (i2 << 3) | 0;
       HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i8 + 4 >> 2] = i7;
       break L76;
      }
     case 36876:
      {
       i8 = (HEAP32[i18 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) >> 4;
       mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i42 >> 2] | 0, i8 | 0);
       __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(i41, i39, i8, -1, 6, i43);
       break L76;
      }
     default:
      break L76;
     } while (0);
     if ((i24 | 0) == 89) {
      i24 = 0;
      i1 = 4;
     } else if ((i24 | 0) == 91) {
      i24 = 0;
      i8 = (HEAP32[i18 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) >> 4;
      mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i42 >> 2] | 0, i8 | 0);
      __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(i41, i39, i8, -1, 3, i43);
      break;
     }
     i8 = (HEAP32[i18 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) >> 4;
     mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i42 >> 2] | 0, i8 | 0);
     __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(i41, i39, i8, -1, i1, i43);
    } while (0);
   }
   i1 = (HEAP32[i37 >> 2] | 0) + 1 | 0;
   HEAP32[i37 >> 2] = i1;
  } while ((i1 | 0) < (i9 | 0));
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  HEAP32[i42 >> 2] = 0;
  i10 = i42 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i42 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i42 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
  i28 = i37;
  i29 = HEAP32[i28 + 4 >> 2] | 0;
  i30 = i12;
  HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i30 + 4 >> 2] = i29;
  mftCall_viiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 248 >> 2] | 0, i31 | 0, 37606, 37621, i37 | 0);
  if ((HEAP32[i37 >> 2] | 0) > 0) {
   i9 = 0;
   do {
    HEAP32[i33 >> 2] = 37634;
    mftCall_viiiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 252 >> 2] | 0, i31 | 0, 37606, i9 | 0, 1024, i38 | 0, i39 | 0);
    mftCall_viiiiiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 256 >> 2] | 0, i31 | 0, 37606, i9 | 0, 1, i33 | 0, 1, i34 | 0, i32 | 0);
    HEAP32[i35 >> 2] = -1;
    __ZN9ShaderLab16FastPropertyName4InitEPKc(i35, i39);
    i7 = HEAP32[i35 >> 2] | 0;
    i8 = HEAP32[i40 >> 2] | 0;
    if ((i8 | 0) > 0) {
     i5 = 0;
     i6 = 0;
     i4 = -1;
     i3 = i8;
     while (1) {
      i1 = HEAP32[i46 >> 2] | 0;
      i2 = i1 + (i5 * 12 | 0) | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) {
       i4 = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] | 0;
       i30 = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] | 0;
       i29 = i2 + 12 | 0;
       _memmove(i2 | 0, i29 | 0, i1 + (i3 * 12 | 0) - i29 | 0) | 0;
       i3 = (HEAP32[i40 >> 2] | 0) + -1 | 0;
       HEAP32[i40 >> 2] = i3;
       i1 = i8;
       i2 = i30;
      } else {
       i1 = i5;
       i2 = i6;
      }
      i5 = i1 + 1 | 0;
      if ((i5 | 0) >= (i8 | 0)) {
       i7 = i2;
       i6 = i4;
       break;
      } else i6 = i2;
     }
    } else {
     i7 = 0;
     i6 = -1;
    }
    i2 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i32 >> 2] | 0;
    if (i2 >>> 0 < (i1 + 1 | 0) >>> 0) do {
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i11 >> 2] = i1;
       HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i1 << 4, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i30 | 0, HEAP32[i42 >> 2] | 0, HEAP32[i10 >> 2] << 4 | 0) | 0;
       HEAP32[i11 >> 2] = i1;
       HEAP32[i42 >> 2] = i30;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i3;
     i1 = HEAP32[i42 >> 2] | 0;
     HEAP32[i1 + (i2 << 4) >> 2] = -1;
     HEAP32[i1 + (i2 << 4) + 4 >> 2] = 0;
     HEAP32[i1 + (i2 << 4) + 8 >> 2] = -1;
     HEAP32[i1 + (i2 << 4) + 12 >> 2] = -1;
     i2 = HEAP32[i10 >> 2] | 0;
     i1 = HEAP32[i32 >> 2] | 0;
    } while (i2 >>> 0 < (i1 + 1 | 0) >>> 0);
    i30 = HEAP32[i42 >> 2] | 0;
    HEAP32[i36 >> 2] = -1;
    __ZN9ShaderLab16FastPropertyName4InitEPKc(i36, i39);
    i29 = HEAP32[i32 >> 2] | 0;
    HEAP32[i30 + (i1 << 4) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i30 + (i1 << 4) + 4 >> 2] = i29;
    HEAP32[i30 + (i1 << 4) + 8 >> 2] = i6;
    HEAP32[i30 + (i1 << 4) + 12 >> 2] = i7;
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) < (HEAP32[i37 >> 2] | 0));
   i2 = HEAP32[i10 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i1 = 0;
    do {
     i38 = __ZNK9ShaderLab16FastPropertyName7GetNameEv((HEAP32[i42 >> 2] | 0) + (i1 << 4) | 0) | 0;
     i39 = HEAP32[i42 >> 2] | 0;
     __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii(i41, i38, HEAP32[i39 + (i1 << 4) + 4 >> 2] | 0, i43, HEAP32[i39 + (i1 << 4) + 8 >> 2] | 0, HEAP32[i39 + (i1 << 4) + 12 >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i2 = HEAP32[i40 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    i39 = __ZNK9ShaderLab16FastPropertyName7GetNameEv((HEAP32[i46 >> 2] | 0) + (i1 * 12 | 0) | 0) | 0;
    i40 = HEAP32[i46 >> 2] | 0;
    __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii(i41, i39, -1, i43, HEAP32[i40 + (i1 * 12 | 0) + 4 >> 2] | 0, HEAP32[i40 + (i1 * 12 | 0) + 8 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i12);
   HEAP32[i42 >> 2] = 0;
  }
 }
 __ZN20GpuProgramParameters21UpdateParamBufferSizeEv(i41);
 if ((HEAP32[i44 >> 2] | 0) <= -1) {
  STACKTOP = i47;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i46 >> 2] | 0, i45);
 HEAP32[i46 >> 2] = 0;
 STACKTOP = i47;
 return;
}

function __ZN25TransformFeedbackSkinning8SkinMeshERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb(i19, i20, i21, i22, i23, i24, i25, i26) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i34 + 32 | 0;
 i12 = i34 + 24 | 0;
 i6 = i34 + 16 | 0;
 i32 = i34 + 208 | 0;
 i33 = i34 + 72 | 0;
 i31 = i34;
 i15 = i34 + 60 | 0;
 i5 = i34 + 48 | 0;
 i18 = i34 + 36 | 0;
 i7 = mftCall_ii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0) | 0;
 i13 = HEAP32[(HEAP32[i21 + 8 >> 2] | 0) + 4 >> 2] | 0;
 i10 = ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 < 4;
 i4 = HEAP32[gb + 1451164 >> 2] | 0;
 i17 = _i64Add(i24 << 16 | 0, 0, i25 | 0, 0) | 0;
 i16 = i13 << 19;
 i17 = _i64Add(i17 | 0, getTempRet0() | 0, i7 << 25 | 0, 0) | 0;
 i16 = _i64Add(i17 | 0, getTempRet0() | 0, i16 | 0, ((i16 | 0) < 0) << 31 >> 31 | 0) | 0;
 i17 = getTempRet0() | 0;
 i4 = i4 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i8 = 9; else {
  i1 = i4;
  L2 : while (1) {
   i3 = i2;
   while (1) {
    i30 = i3 + 16 | 0;
    i29 = HEAP32[i30 + 4 >> 2] | 0;
    if (!(i29 >>> 0 < i17 >>> 0 | ((i29 | 0) == (i17 | 0) ? (HEAP32[i30 >> 2] | 0) >>> 0 < i16 >>> 0 : 0))) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L2; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i4 | 0)) i8 = 9; else {
   i30 = i1 + 16 | 0;
   i29 = HEAP32[i30 + 4 >> 2] | 0;
   if (i17 >>> 0 < i29 >>> 0 | ((i17 | 0) == (i29 | 0) ? i16 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0 : 0)) i8 = 9; else i7 = i1 + 24 | 0;
  }
 }
 if ((i8 | 0) == 9) {
  HEAP32[i15 >> 2] = 0;
  i9 = i15 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  i11 = i15 + 8 | 0;
  HEAP32[i11 >> 2] = 0;
  do if (!(HEAP32[gb + 1451256 >> 2] | 0)) {
   i1 = i33 + 4 | 0;
   HEAP32[i33 >> 2] = gb + 77468 + 12;
   i2 = i33 + 56 | 0;
   HEAP32[i2 >> 2] = gb + 77468 + 32;
   __ZNSt3__28ios_base4initEPv(i33 + 56 | 0, i1);
   HEAP32[i33 + 128 >> 2] = 0;
   HEAP32[i33 + 132 >> 2] = -1;
   HEAP32[i33 >> 2] = gb + 77508 + 12;
   HEAP32[i33 + 56 >> 2] = gb + 77508 + 32;
   __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
   HEAP32[i1 >> 2] = gb + 77548 + 8;
   i3 = i33 + 36 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i33 + 52 >> 2] = 16;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i32 + 4 >> 2] = 0;
   HEAP32[i32 + 8 >> 2] = 0;
   __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i1, i32);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
   i30 = __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609687 | 0, 9) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, i10 ? gb + 609697 | 0 : gb + 609704 | 0, i10 ? 6 : 3) | 0, gb + 1074320 | 0, 1) | 0, gb + 1074320 | 0, 1) | 0;
   if (i10) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609708 | 0, 22) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609731 | 0, 17) | 0, gb + 609749 | 0, 55) | 0;
   i30 = HEAP32[gb + 1451080 >> 2] | 0;
   __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i5, i1);
   i30 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i30, 4, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0;
   HEAP32[gb + 1451256 >> 2] = i30;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (__ZN7ApiGLES11CheckShaderERjb(HEAP32[gb + 1451080 >> 2] | 0, gb + 1451256 | 0, 0) | 0) {
    HEAP32[i33 >> 2] = gb + 77508 + 12;
    HEAP32[i2 >> 2] = gb + 77508 + 32;
    HEAP32[i1 >> 2] = gb + 77548 + 8;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
    __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i33, gb + 77612 + 4 | 0);
    __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i2);
    i8 = 15;
    break;
   } else {
    _printf_console(gb + 609805 | 0, i6);
    HEAP32[i33 >> 2] = gb + 77508 + 12;
    HEAP32[i2 >> 2] = gb + 77508 + 32;
    HEAP32[i1 >> 2] = gb + 77548 + 8;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
    __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i33, gb + 77612 + 4 | 0);
    __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i2);
    i1 = 0;
    break;
   }
  } else i8 = 15; while (0);
  if ((i8 | 0) == 15) {
   i8 = i33 + 4 | 0;
   HEAP32[i33 >> 2] = gb + 77468 + 12;
   i4 = i33 + 56 | 0;
   HEAP32[i4 >> 2] = gb + 77468 + 32;
   __ZNSt3__28ios_base4initEPv(i33 + 56 | 0, i8);
   HEAP32[i33 + 128 >> 2] = 0;
   HEAP32[i33 + 132 >> 2] = -1;
   HEAP32[i33 >> 2] = gb + 77508 + 12;
   HEAP32[i33 + 56 >> 2] = gb + 77508 + 32;
   __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i8);
   HEAP32[i8 >> 2] = gb + 77548 + 8;
   i5 = i33 + 36 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i33 + 52 >> 2] = 16;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i32 + 4 >> 2] = 0;
   HEAP32[i32 + 8 >> 2] = 0;
   __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i8, i32);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
   i30 = __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609687 | 0, 9) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, i10 ? gb + 609867 | 0 : gb + 609875 | 0, i10 ? 7 : 4) | 0, gb + 1074320 | 0, 1) | 0;
   if (!i10) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609880 | 0, 52) | 0;
   i30 = __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEj(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 609933 | 0, 27) | 0, i7) | 0, gb + 609961 | 0, 7) | 0;
   i3 = i10 ? gb + 609969 | 0 : gb + 1086395 | 0;
   i6 = i10 ? 7 : 1;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i30, i3, i6) | 0, gb + 609977 | 0, 62) | 0, i3, i6) | 0, gb + 610040 | 0, 62) | 0, 0) | 0, gb + 610103 | 0, 21) | 0;
   i6 = i25 & 2;
   i3 = (i6 | 0) != 0;
   if (i3) {
    __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, 1) | 0, gb + 610142 | 0, 21) | 0;
    i1 = 2;
   } else i1 = 1;
   switch (i24 | 0) {
   case 4:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1) | 0, gb + 610246 | 0, 27) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1 + 1 | 0) | 0, gb + 610274 | 0, 27) | 0;
     i1 = i1 + 2 | 0;
     break;
    }
   case 2:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1) | 0, gb + 610190 | 0, 27) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1 + 1 | 0) | 0, gb + 610218 | 0, 27) | 0;
     i1 = i1 + 2 | 0;
     break;
    }
   default:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1) | 0, gb + 610164 | 0, 25) | 0;
     i1 = i1 + 1 | 0;
    }
   }
   i7 = i25 & 128;
   i2 = (i7 | 0) != 0;
   if (i2) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(__ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610125 | 0, 16) | 0, i1) | 0, gb + 610302 | 0, 22) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610325 | 0, 18) | 0;
   if (i3) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610344 | 0, 21) | 0;
   if (i2) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610366 | 0, 22) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 1074320 | 0, 1) | 0;
   switch (i13 | 0) {
   case 0:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610389 | 0, 38) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610428 | 0, 24) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610453 | 0, 73) | 0;
     break;
    }
   case 1:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610527 | 0, 61) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610428 | 0, 24) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610589 | 0, 100) | 0;
     break;
    }
   default:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610690 | 0, 25) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610428 | 0, 24) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610716 | 0, 5) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610722 | 0, 85) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610808 | 0, 83) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610892 | 0, 84) | 0;
    }
   }
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 610977 | 0, 87) | 0;
   switch (i24 | 0) {
   case 4:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611121 | 0, 77) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611199 | 0, 29) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611229 | 0, 76) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611306 | 0, 29) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611336 | 0, 76) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611413 | 0, 29) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611443 | 0, 76) | 0;
     break;
    }
   case 2:
    {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611121 | 0, 77) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611199 | 0, 29) | 0;
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611229 | 0, 76) | 0;
     break;
    }
   default:
    __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611065 | 0, 55) | 0;
   }
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611520 | 0, 84) | 0;
   if (i3) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611605 | 0, 68) | 0;
   if (i2) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 611674 | 0, 91) | 0;
   __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i33, gb + 1046929 | 0, 2) | 0;
   __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i31, i8);
   i30 = (HEAP8[i31 + 11 >> 0] | 0) < 0 ? HEAP32[i31 >> 2] | 0 : i31;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i30, _strlen(i30) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
   HEAP32[i33 >> 2] = gb + 77508 + 12;
   HEAP32[i4 >> 2] = gb + 77508 + 32;
   HEAP32[i8 >> 2] = gb + 77548 + 8;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i8);
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i33, gb + 77612 + 4 | 0);
   __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i4);
   HEAP32[i9 >> 2] = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 0, (HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18) | 0;
   if (__ZN7ApiGLES11CheckShaderERjb(HEAP32[gb + 1451080 >> 2] | 0, i9, 0) | 0) {
    i2 = __ZN7ApiGLES21CreateGraphicsProgramEjjjjj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i9 >> 2] | 0, 0, 0, 0, HEAP32[gb + 1451256 >> 2] | 0) | 0;
    HEAP32[i15 >> 2] = i2;
    HEAP32[i33 >> 2] = 0;
    HEAP32[i33 + 4 >> 2] = 0;
    HEAP32[i33 + 8 >> 2] = 0;
    if (!(i25 & 1)) i1 = 0; else {
     HEAP32[i33 >> 2] = gb + 611826;
     i1 = 1;
    }
    if (i6) {
     HEAP32[i33 + (i1 << 2) >> 2] = gb + 611834;
     i1 = i1 + 1 | 0;
    }
    if (i7) {
     HEAP32[i33 + (i1 << 2) >> 2] = gb + 611845;
     i1 = i1 + 1 | 0;
    }
    mftCall_viiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 200 >> 2] | 0, i2 | 0, i1 | 0, i33 | 0, 35980);
    __ZN7ApiGLES11LinkProgramEj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i15 >> 2] | 0);
    if (__ZN7ApiGLES12CheckProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i15) | 0) {
     switch (i13 | 0) {
     case 1:
      {
       i30 = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 208 >> 2] | 0, HEAP32[i15 >> 2] | 0, gb + 611913 | 0) | 0;
       HEAP32[i11 >> 2] = i30;
       mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 220 >> 2] | 0, HEAP32[i15 >> 2] | 0, i30 | 0, 0);
       break;
      }
     case 2:
      {
       HEAP32[i11 >> 2] = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 104 >> 2] | 0, HEAP32[i15 >> 2] | 0, gb + 611907 | 0) | 0;
       __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, HEAP32[i15 >> 2] | 0, 0, 0);
       mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i11 >> 2] | 0, 0);
       break;
      }
     default:
      HEAP32[i11 >> 2] = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 104 >> 2] | 0, HEAP32[i15 >> 2] | 0, gb + 611907 | 0) | 0;
     }
     i5 = HEAP32[gb + 1451164 >> 2] | 0;
     HEAP32[i31 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     i2 = i5 + 4 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     do if (!i1) {
      HEAP32[i32 >> 2] = i2;
      i4 = i2;
      i3 = i2;
     } else {
      while (1) {
       i3 = i1 + 16 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (i17 >>> 0 < i3 >>> 0 | (i17 | 0) == (i3 | 0) & i16 >>> 0 < i2 >>> 0) {
        i2 = HEAP32[i1 >> 2] | 0;
        if (!i2) {
         i8 = 58;
         break;
        } else i1 = i2;
       } else {
        if (!(i3 >>> 0 < i17 >>> 0 | (i3 | 0) == (i17 | 0) & i2 >>> 0 < i16 >>> 0)) {
         i8 = 63;
         break;
        }
        i3 = i1 + 4 | 0;
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i8 = 62;
         break;
        } else i1 = i2;
       }
      }
      if ((i8 | 0) == 58) {
       HEAP32[i32 >> 2] = i1;
       i4 = i1;
       i3 = i1;
       break;
      } else if ((i8 | 0) == 62) {
       HEAP32[i32 >> 2] = i1;
       i4 = i1;
       break;
      } else if ((i8 | 0) == 63) {
       HEAP32[i32 >> 2] = i1;
       i4 = i1;
       i3 = i32;
       break;
      }
     } while (0);
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      i1 = __Znwj(40) | 0;
      i2 = i1 + 16 | 0;
      HEAP32[i2 >> 2] = i16;
      HEAP32[i2 + 4 >> 2] = i17;
      i2 = i1 + 24 | 0;
      HEAP32[i2 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i4;
      HEAP32[i3 >> 2] = i1;
      i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      if (!i2) i2 = i1; else {
       HEAP32[i5 >> 2] = i2;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
      i30 = i5 + 8 | 0;
      HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
     }
     i1 = i1 + 24 | 0;
    } else {
     _printf_console(gb + 611857 | 0, i14);
     i1 = 0;
    }
   } else {
    _printf_console(gb + 611766 | 0, i12);
    i1 = 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  }
  i7 = i1;
 }
 i5 = i19;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[gb + 1451244 + 4 >> 2] | 0;
 do if (!i1) {
  i2 = gb + 1451244 + 4 | 0;
  i3 = gb + 1451244 + 4 | 0;
 } else {
  while (1) if (i6 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i8 = 76;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i8 = 79;
    break;
   } else i1 = i2;
  }
  if ((i8 | 0) == 76) {
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i8 | 0) == 79) {
   i2 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(56) | 0;
 HEAP32[i1 + 16 >> 2] = i6;
 i30 = i1 + 20 | 0;
 HEAP32[i30 >> 2] = i4;
 HEAP32[i30 + 4 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = i7;
 HEAP32[i1 + 32 >> 2] = i22;
 HEAP32[i1 + 36 >> 2] = i21;
 HEAP32[i1 + 40 >> 2] = i20;
 HEAP32[i1 + 44 >> 2] = i23;
 HEAP32[i1 + 48 >> 2] = i24;
 HEAP32[i1 + 52 >> 2] = i25;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[gb + 1451244 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[gb + 1451244 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[gb + 1451244 + 4 >> 2] | 0, i1);
 HEAP32[gb + 1451244 + 8 >> 2] = (HEAP32[gb + 1451244 + 8 >> 2] | 0) + 1;
 if (!i26) {
  STACKTOP = i34;
  return;
 }
 __ZN7ApiGLES6EnableEN2gl10EnabledCapE(HEAP32[gb + 1451080 >> 2] | 0, 11);
 i1 = HEAP32[gb + 1451244 >> 2] | 0;
 L120 : do if ((i1 | 0) != (gb + 1451244 + 4 | 0)) {
  i9 = i31 + 8 | 0;
  i10 = i31 + 12 | 0;
  i11 = i33 + 4 | 0;
  i12 = i33 + 5 | 0;
  i13 = i33 + 6 | 0;
  i14 = i33 + 7 | 0;
  i15 = i33 + 20 | 0;
  i16 = i33 + 21 | 0;
  i17 = i33 + 22 | 0;
  i18 = i33 + 23 | 0;
  i19 = i33 + 24 | 0;
  i20 = i33 + 25 | 0;
  i21 = i33 + 26 | 0;
  i22 = i33 + 27 | 0;
  i23 = i33 + 32 | 0;
  i24 = i33 + 33 | 0;
  i25 = i33 + 34 | 0;
  i26 = i33 + 35 | 0;
  i27 = i33 + 8 | 0;
  i28 = i33 + 9 | 0;
  i29 = i33 + 10 | 0;
  i30 = i33 + 11 | 0;
  i8 = i1;
  while (1) {
   i4 = HEAP32[i8 + 32 >> 2] | 0;
   __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE12EnsureBufferEj(i4, HEAP32[i4 + 24 >> 2] | 0);
   i4 = HEAP32[i4 + 28 >> 2] | 0;
   __ZN7ApiGLES27BindTransformFeedbackBufferEjj(HEAP32[gb + 1451080 >> 2] | 0, 0, HEAP32[i4 + 4 >> 2] | 0);
   i2 = i8 + 28 | 0;
   __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, HEAP32[HEAP32[i2 >> 2] >> 2] | 0, 0, 0);
   i5 = i8 + 36 | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0);
   i2 = HEAP32[i8 + 52 >> 2] | 0;
   i3 = i2 & 2;
   i6 = (i2 & 128 | 0) == 0;
   i2 = i2 & 130;
   HEAP32[i32 >> 2] = i2 | 17;
   i7 = HEAP32[i8 + 48 >> 2] | 0;
   if ((i7 | 0) > 1) HEAP32[i32 >> 2] = i2 | 49;
   HEAP32[i33 >> 2] = gb + 77004 + 8;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i11 + 24 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = 0;
   i36 = i9;
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   i36 = i8 + 20 | 0;
   i35 = HEAP32[i36 + 4 >> 2] | 0;
   i2 = i31;
   HEAP32[i2 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i2 + 4 >> 2] = i35;
   HEAP32[i9 >> 2] = HEAP32[i8 + 40 >> 2];
   switch (i7 | 0) {
   case 1:
    {
     i2 = 4;
     break;
    }
   case 2:
    {
     i2 = 16;
     break;
    }
   case 4:
    {
     i2 = 32;
     break;
    }
   default:
    i2 = 1;
   }
   HEAP32[i10 >> 2] = i2;
   HEAP8[i11 >> 0] = 0;
   HEAP8[i12 >> 0] = 0;
   HEAP8[i13 >> 0] = 0;
   HEAP8[i14 >> 0] = 3;
   if (!i3) i2 = 12; else {
    HEAP8[i27 >> 0] = 0;
    HEAP8[i28 >> 0] = 12;
    HEAP8[i29 >> 0] = 0;
    HEAP8[i30 >> 0] = 3;
    i2 = 24;
   }
   if (!i6) {
    HEAP8[i23 >> 0] = 0;
    HEAP8[i24 >> 0] = i2;
    HEAP8[i25 >> 0] = 0;
    HEAP8[i26 >> 0] = 4;
   }
   switch (i7 | 0) {
   case 1:
    {
     HEAP8[i15 >> 0] = 1;
     HEAP8[i16 >> 0] = 0;
     HEAP8[i17 >> 0] = 4;
     HEAP8[i18 >> 0] = 1;
     break;
    }
   case 2:
    {
     HEAP8[i15 >> 0] = 1;
     HEAP8[i16 >> 0] = 8;
     HEAP8[i17 >> 0] = 4;
     HEAP8[i18 >> 0] = 2;
     HEAP8[i19 >> 0] = 1;
     HEAP8[i20 >> 0] = 0;
     HEAP8[i21 >> 0] = 0;
     HEAP8[i22 >> 0] = 2;
     break;
    }
   case 4:
    {
     HEAP8[i15 >> 0] = 1;
     HEAP8[i16 >> 0] = 16;
     HEAP8[i17 >> 0] = 4;
     HEAP8[i18 >> 0] = 4;
     HEAP8[i19 >> 0] = 1;
     HEAP8[i20 >> 0] = 0;
     HEAP8[i21 >> 0] = 0;
     HEAP8[i22 >> 0] = 4;
     break;
    }
   default:
    {}
   }
   __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj(i32, i33, i31, 0, 2, 0);
   __ZN7ApiGLES11DrawCaptureE16GfxPrimitiveTypej(HEAP32[gb + 1451080 >> 2] | 0, 5, HEAP32[i8 + 44 >> 2] | 0);
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   __ZN14DataBufferGLES12RecordUpdateEv(i4);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (gb + 1451244 + 4 | 0)) break L120; else i8 = i1;
  }
 } while (0);
 __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(gb + 1451244 | 0, HEAP32[gb + 1451244 + 4 >> 2] | 0);
 HEAP32[gb + 1451244 + 8 >> 2] = 0;
 HEAP32[gb + 1451244 >> 2] = gb + 1451244 + 4;
 HEAP32[gb + 1451244 + 4 >> 2] = 0;
 __ZN7ApiGLES7DisableEN2gl10EnabledCapE(HEAP32[gb + 1451080 >> 2] | 0, 11);
 if ((HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 20 >> 2] | 0) > 0) __ZN7ApiGLES17BindUniformBufferEjj(HEAP32[gb + 1451080 >> 2] | 0, 0, 0);
 __ZN7ApiGLES27BindTransformFeedbackBufferEjj(HEAP32[gb + 1451080 >> 2] | 0, 0, 0);
 STACKTOP = i34;
 return;
}

function __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i11, i14, i15) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i13 = i16 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i14, i15, i11, i12);
 i6 = HEAP32[i11 + 32 >> 2] | 0;
 i5 = HEAP32[i11 + 24 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 i7 = i14 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i8 = i14 + 8 | 0;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i10 = i14 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 12 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 48 >> 2] | 0;
 i5 = HEAP32[i11 + 40 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i17 = i12;
  i4 = HEAP32[i17 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 64 >> 2] | 0;
 i5 = HEAP32[i11 + 56 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i12;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 72 | 0, i15 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 88 | 0, i15 + 5 | 0);
 i5 = i11 + 104 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i12;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i17 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj649ENS_22PxRepXPropertyAccessorILj649ES4_KffEEEEvRKT0_(i14, i13);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 120 | 0, i15 + 7 | 0);
 i5 = i11 + 136 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i12;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i17 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj651ENS_22PxRepXPropertyAccessorILj651ES4_KffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 152 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i17 = i13 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i12;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj652ENS_22PxRepXPropertyAccessorILj652ES4_KffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 176 >> 2] | 0;
 i5 = HEAP32[i11 + 168 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i12;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 192 >> 2] | 0;
 i5 = HEAP32[i11 + 184 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i12;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 208 >> 2] | 0;
 i5 = HEAP32[i11 + 200 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i12;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i4 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i4 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, (i4 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 216 | 0, i15 + 13 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 232 | 0, i15 + 14 | 0);
 i5 = i11 + 248 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i17 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i17 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj658ENS_22PxRepXPropertyAccessorILj658ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 264 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i17 = i13 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i17 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj659ENS_22PxRepXPropertyAccessorILj659ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 280 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i17 = i13 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i11 = i12;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i17 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj660ENS_22PxRepXPropertyAccessorILj660ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i17 = i15 + 18 | 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i17 = i15 + 18 | 0;
 STACKTOP = i16;
 return i17 | 0;
}

function _LzmaDec_DecodeReal2(i44, i45, i56) {
 i44 = i44 | 0;
 i45 = i45 | 0;
 i56 = i56 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0;
 i57 = i44 + 48 | 0;
 i58 = i44 + 12 | 0;
 i59 = i44 + 44 | 0;
 i60 = i44 + 36 | 0;
 i61 = i44 + 16 | 0;
 i62 = i44 + 52 | 0;
 i63 = i44 + 56 | 0;
 i46 = i44 + 60 | 0;
 i47 = i44 + 64 | 0;
 i48 = i44 + 68 | 0;
 i49 = i44 + 8 | 0;
 i50 = i44 + 4 | 0;
 i51 = i44 + 20 | 0;
 i52 = i44 + 40 | 0;
 i53 = i44 + 24 | 0;
 i54 = i44 + 28 | 0;
 i55 = i44 + 32 | 0;
 i64 = i44 + 72 | 0;
 L1 : do {
  i23 = HEAP32[i57 >> 2] | 0;
  i24 = (i23 | 0) == 0;
  if (i24) {
   i6 = HEAP32[i59 >> 2] | 0;
   i22 = (HEAP32[i58 >> 2] | 0) - i6 | 0;
   i1 = HEAP32[i60 >> 2] | 0;
   i22 = (i45 - i1 | 0) >>> 0 > i22 >>> 0 ? i1 + i22 | 0 : i45;
  } else {
   i22 = i45;
   i6 = HEAP32[i59 >> 2] | 0;
   i1 = HEAP32[i60 >> 2] | 0;
  }
  i25 = HEAP32[i61 >> 2] | 0;
  i26 = (1 << HEAP32[i49 >> 2]) + -1 | 0;
  i27 = (1 << HEAP32[i50 >> 2]) + -1 | 0;
  i28 = HEAP32[i44 >> 2] | 0;
  i29 = HEAP32[i51 >> 2] | 0;
  i30 = HEAP32[i52 >> 2] | 0;
  i31 = i25 + 3692 | 0;
  i32 = 8 - i28 | 0;
  i33 = i25 + 384 | 0;
  i34 = i25 + 1636 | 0;
  i35 = i25 + 864 | 0;
  i36 = i25 + 1376 | 0;
  i37 = i25 + 1604 | 0;
  i38 = i25 + 1606 | 0;
  i39 = i25 + 408 | 0;
  i40 = i25 + 480 | 0;
  i41 = i25 + 2664 | 0;
  i42 = i25 + 432 | 0;
  i43 = i25 + 456 | 0;
  i5 = HEAP32[i62 >> 2] | 0;
  i7 = HEAP32[i63 >> 2] | 0;
  i12 = HEAP32[i46 >> 2] | 0;
  i10 = HEAP32[i47 >> 2] | 0;
  i9 = HEAP32[i48 >> 2] | 0;
  i3 = HEAP32[i55 >> 2] | 0;
  i2 = HEAP32[i54 >> 2] | 0;
  i11 = HEAP32[i53 >> 2] | 0;
  i8 = 0;
  L7 : do {
   i18 = i6 & i26;
   i17 = i5 << 4;
   i13 = i25 + (i17 << 1) + (i18 << 1) | 0;
   i14 = HEAPU16[i13 >> 1] | 0;
   if (i2 >>> 0 < 16777216) {
    i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
    i2 = i2 << 8;
    i11 = i11 + 1 | 0;
   }
   i4 = Math_imul(i2 >>> 11, i14) | 0;
   L12 : do if (i3 >>> 0 < i4 >>> 0) {
    HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
    if (!(i6 | i23)) i21 = i31; else i21 = i31 + ((((HEAPU8[i29 + (((i1 | 0) == 0 ? i30 : i1) + -1) >> 0] | 0) >>> i32) + ((i6 & i27) << i28) | 0) * 768 << 1) | 0;
    do if (i5 >>> 0 < 7) {
     i5 = i5 - (i5 >>> 0 > 3 ? 3 : i5) | 0;
     i14 = i21 + 2 | 0;
     i13 = HEAPU16[i14 >> 1] | 0;
     if (i4 >>> 0 < 16777216) {
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i4 = i4 << 8;
      i11 = i11 + 1 | 0;
     }
     i2 = Math_imul(i4 >>> 11, i13) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      i15 = 2;
      i4 = i2;
      i2 = ((2048 - i13 | 0) >>> 5) + i13 | 0;
     } else {
      i15 = 3;
      i3 = i3 - i2 | 0;
      i4 = i4 - i2 | 0;
      i2 = i13 - (i13 >>> 5) | 0;
     }
     HEAP16[i14 >> 1] = i2;
     i13 = i21 + (i15 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i4 >>> 0 < 16777216) {
      i16 = i11 + 1 | 0;
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i4 = i4 << 8;
     } else i16 = i11;
     i2 = Math_imul(i4 >>> 11, i14) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i14 = i15 << 1;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i14 = i15 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i4 - i2 | 0;
     }
     i11 = i21 + (i14 << 1) | 0;
     i13 = HEAPU16[i11 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i17 = i16 + 1 | 0;
      i3 = HEAPU8[i16 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i17 = i16;
     i4 = Math_imul(i2 >>> 11, i13) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i11 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i15 = i14 << 1;
      i2 = i4;
     } else {
      HEAP16[i11 >> 1] = i13 - (i13 >>> 5);
      i15 = i14 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
     }
     i13 = i21 + (i15 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i11 = i17 + 1 | 0;
      i3 = HEAPU8[i17 >> 0] | 0 | i3 << 8;
      i4 = i2 << 8;
     } else {
      i11 = i17;
      i4 = i2;
     }
     i2 = Math_imul(i4 >>> 11, i14) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i15 = i15 << 1;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i15 = i15 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i4 - i2 | 0;
     }
     i13 = i21 + (i15 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
      i11 = i11 + 1 | 0;
     }
     i4 = Math_imul(i2 >>> 11, i14) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i2 = i4;
      i15 = i15 << 1;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i15 = i15 << 1 | 1;
     }
     i13 = i21 + (i15 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
      i11 = i11 + 1 | 0;
     }
     i4 = Math_imul(i2 >>> 11, i14) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i2 = i4;
      i15 = i15 << 1;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i15 = i15 << 1 | 1;
     }
     i13 = i21 + (i15 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
      i11 = i11 + 1 | 0;
     }
     i4 = Math_imul(i2 >>> 11, i14) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i2 = i4;
      i15 = i15 << 1;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i15 = i15 << 1 | 1;
     }
     i4 = i21 + (i15 << 1) | 0;
     i13 = HEAPU16[i4 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i14 = i2 << 8;
      i11 = i11 + 1 | 0;
     } else i14 = i2;
     i2 = Math_imul(i14 >>> 11, i13) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i4 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i4 = i15 << 1;
      break;
     } else {
      HEAP16[i4 >> 1] = i13 - (i13 >>> 5);
      i4 = i15 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i14 - i2 | 0;
      break;
     }
    } else {
     i20 = HEAPU8[i29 + (i1 - i7 + (i1 >>> 0 < i7 >>> 0 ? i30 : 0)) >> 0] | 0;
     i5 = i5 - (i5 >>> 0 < 10 ? 3 : 6) | 0;
     i13 = i20 << 1 & 256;
     i14 = i21 + 512 + (i13 << 1) + 2 | 0;
     i15 = HEAPU16[i14 >> 1] | 0;
     if (i4 >>> 0 < 16777216) {
      i17 = i11 + 1 | 0;
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i4 = i4 << 8;
     } else i17 = i11;
     i2 = Math_imul(i4 >>> 11, i15) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i14 >> 1] = ((2048 - i15 | 0) >>> 5) + i15;
      i13 = i13 ^ 256;
      i16 = 2;
     } else {
      HEAP16[i14 >> 1] = i15 - (i15 >>> 5);
      i3 = i3 - i2 | 0;
      i2 = i4 - i2 | 0;
      i16 = 3;
     }
     i11 = i13 & i20 << 2;
     i14 = i21 + (i13 << 1) + (i11 << 1) + (i16 << 1) | 0;
     i15 = HEAPU16[i14 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i18 = i17 + 1 | 0;
      i3 = HEAPU8[i17 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i18 = i17;
     i4 = Math_imul(i2 >>> 11, i15) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i14 >> 1] = ((2048 - i15 | 0) >>> 5) + i15;
      i11 = i11 ^ i13;
      i2 = i4;
      i16 = i16 << 1;
     } else {
      HEAP16[i14 >> 1] = i15 - (i15 >>> 5);
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i16 = i16 << 1 | 1;
     }
     i13 = i11 & i20 << 3;
     i14 = i21 + (i11 << 1) + (i13 << 1) + (i16 << 1) | 0;
     i15 = HEAPU16[i14 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i17 = i18 + 1 | 0;
      i3 = HEAPU8[i18 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i17 = i18;
     i4 = Math_imul(i2 >>> 11, i15) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i14 >> 1] = ((2048 - i15 | 0) >>> 5) + i15;
      i13 = i13 ^ i11;
      i2 = i4;
      i11 = i16 << 1;
     } else {
      HEAP16[i14 >> 1] = i15 - (i15 >>> 5);
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i11 = i16 << 1 | 1;
     }
     i16 = i13 & i20 << 4;
     i14 = i21 + (i13 << 1) + (i16 << 1) + (i11 << 1) | 0;
     i15 = HEAPU16[i14 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i18 = i17 + 1 | 0;
      i3 = HEAPU8[i17 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i18 = i17;
     i4 = Math_imul(i2 >>> 11, i15) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i14 >> 1] = ((2048 - i15 | 0) >>> 5) + i15;
      i17 = i11 << 1;
      i2 = i4;
      i14 = i16 ^ i13;
     } else {
      HEAP16[i14 >> 1] = i15 - (i15 >>> 5);
      i17 = i11 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i14 = i16;
     }
     i15 = i14 & i20 << 5;
     i11 = i21 + (i14 << 1) + (i15 << 1) + (i17 << 1) | 0;
     i13 = HEAPU16[i11 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i19 = i18 + 1 | 0;
      i3 = HEAPU8[i18 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i19 = i18;
     i4 = Math_imul(i2 >>> 11, i13) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i11 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i16 = i17 << 1;
      i2 = i4;
      i14 = i15 ^ i14;
     } else {
      HEAP16[i11 >> 1] = i13 - (i13 >>> 5);
      i16 = i17 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
      i14 = i15;
     }
     i15 = i14 & i20 << 6;
     i11 = i21 + (i14 << 1) + (i15 << 1) + (i16 << 1) | 0;
     i13 = HEAPU16[i11 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i18 = i19 + 1 | 0;
      i3 = HEAPU8[i19 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i18 = i19;
     i4 = Math_imul(i2 >>> 11, i13) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i11 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i16 = i16 << 1;
      i15 = i15 ^ i14;
     } else {
      HEAP16[i11 >> 1] = i13 - (i13 >>> 5);
      i16 = i16 << 1 | 1;
      i3 = i3 - i4 | 0;
      i4 = i2 - i4 | 0;
     }
     i2 = i15 & i20 << 7;
     i11 = i21 + (i15 << 1) + (i2 << 1) + (i16 << 1) | 0;
     i13 = HEAPU16[i11 >> 1] | 0;
     if (i4 >>> 0 < 16777216) {
      i17 = i18 + 1 | 0;
      i3 = HEAPU8[i18 >> 0] | 0 | i3 << 8;
      i4 = i4 << 8;
     } else i17 = i18;
     i14 = Math_imul(i4 >>> 11, i13) | 0;
     if (i3 >>> 0 < i14 >>> 0) {
      HEAP16[i11 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i16 = i16 << 1;
      i2 = i2 ^ i15;
     } else {
      HEAP16[i11 >> 1] = i13 - (i13 >>> 5);
      i16 = i16 << 1 | 1;
      i3 = i3 - i14 | 0;
      i14 = i4 - i14 | 0;
     }
     i4 = i21 + (i2 << 1) + ((i2 & i20 << 8) << 1) + (i16 << 1) | 0;
     i13 = HEAPU16[i4 >> 1] | 0;
     if (i14 >>> 0 < 16777216) {
      i11 = i17 + 1 | 0;
      i3 = HEAPU8[i17 >> 0] | 0 | i3 << 8;
      i14 = i14 << 8;
     } else i11 = i17;
     i2 = Math_imul(i14 >>> 11, i13) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i4 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i4 = i16 << 1;
      break;
     } else {
      HEAP16[i4 >> 1] = i13 - (i13 >>> 5);
      i4 = i16 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i14 - i2 | 0;
      break;
     }
    } while (0);
    HEAP8[i29 + i1 >> 0] = i4;
    i6 = i6 + 1 | 0;
    i1 = i1 + 1 | 0;
   } else {
    i2 = i2 - i4 | 0;
    i3 = i3 - i4 | 0;
    HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
    i13 = i33 + (i5 << 1) | 0;
    i14 = HEAPU16[i13 >> 1] | 0;
    if (i2 >>> 0 < 16777216) {
     i16 = i11 + 1 | 0;
     i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
     i2 = i2 << 8;
    } else i16 = i11;
    i4 = Math_imul(i2 >>> 11, i14) | 0;
    if (i3 >>> 0 < i4 >>> 0) {
     HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
     i15 = i34;
     i5 = i5 + 12 | 0;
     i11 = i16;
    } else {
     i2 = i2 - i4 | 0;
     i3 = i3 - i4 | 0;
     HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
     if (!(i6 | i23)) {
      i1 = 1;
      i65 = 225;
      break L1;
     }
     i4 = i39 + (i5 << 1) | 0;
     i11 = HEAPU16[i4 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i15 = i16 + 1 | 0;
      i3 = HEAPU8[i16 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i15 = i16;
     i14 = Math_imul(i2 >>> 11, i11) | 0;
     do if (i3 >>> 0 < i14 >>> 0) {
      HEAP16[i4 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
      i4 = i40 + (i17 << 1) + (i18 << 1) | 0;
      i13 = HEAPU16[i4 >> 1] | 0;
      if (i14 >>> 0 < 16777216) {
       i11 = i15 + 1 | 0;
       i3 = HEAPU8[i15 >> 0] | 0 | i3 << 8;
       i14 = i14 << 8;
      } else i11 = i15;
      i2 = Math_imul(i14 >>> 11, i13) | 0;
      if (i3 >>> 0 < i2 >>> 0) {
       HEAP16[i4 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
       HEAP8[i29 + i1 >> 0] = HEAP8[i29 + (i1 - i7 + (i1 >>> 0 < i7 >>> 0 ? i30 : 0)) >> 0] | 0;
       i6 = i6 + 1 | 0;
       i1 = i1 + 1 | 0;
       i5 = i5 >>> 0 < 7 ? 9 : 11;
       break L12;
      } else {
       HEAP16[i4 >> 1] = i13 - (i13 >>> 5);
       i8 = i7;
       i13 = i12;
       i3 = i3 - i2 | 0;
       i4 = i14 - i2 | 0;
       break;
      }
     } else {
      i2 = i2 - i14 | 0;
      i3 = i3 - i14 | 0;
      HEAP16[i4 >> 1] = i11 - (i11 >>> 5);
      i8 = i42 + (i5 << 1) | 0;
      i13 = HEAPU16[i8 >> 1] | 0;
      if (i2 >>> 0 < 16777216) {
       i11 = i15 + 1 | 0;
       i3 = HEAPU8[i15 >> 0] | 0 | i3 << 8;
       i2 = i2 << 8;
      } else i11 = i15;
      i4 = Math_imul(i2 >>> 11, i13) | 0;
      if (i3 >>> 0 < i4 >>> 0) {
       HEAP16[i8 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
       i8 = i12;
       i13 = i7;
       break;
      }
      i2 = i2 - i4 | 0;
      i3 = i3 - i4 | 0;
      HEAP16[i8 >> 1] = i13 - (i13 >>> 5);
      i14 = i43 + (i5 << 1) | 0;
      i13 = HEAPU16[i14 >> 1] | 0;
      if (i2 >>> 0 < 16777216) {
       i15 = i11 + 1 | 0;
       i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
       i2 = i2 << 8;
      } else i15 = i11;
      i4 = Math_imul(i2 >>> 11, i13) | 0;
      if (i3 >>> 0 < i4 >>> 0) {
       i8 = i10;
       i2 = ((2048 - i13 | 0) >>> 5) + i13 | 0;
      } else {
       i8 = i9;
       i9 = i10;
       i3 = i3 - i4 | 0;
       i4 = i2 - i4 | 0;
       i2 = i13 - (i13 >>> 5) | 0;
      }
      HEAP16[i14 >> 1] = i2;
      i13 = i7;
      i10 = i12;
      i11 = i15;
     } while (0);
     i15 = i41;
     i5 = i5 >>> 0 < 7 ? 8 : 11;
     i7 = i8;
     i12 = i13;
    }
    i8 = HEAPU16[i15 >> 1] | 0;
    if (i4 >>> 0 < 16777216) {
     i14 = i11 + 1 | 0;
     i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
     i4 = i4 << 8;
    } else i14 = i11;
    i2 = Math_imul(i4 >>> 11, i8) | 0;
    do if (i3 >>> 0 < i2 >>> 0) {
     HEAP16[i15 >> 1] = ((2048 - i8 | 0) >>> 5) + i8;
     i15 = i15 + 4 + (i18 << 3 << 1) | 0;
     i16 = 0;
     i17 = 8;
     i8 = i14;
    } else {
     i11 = i4 - i2 | 0;
     i3 = i3 - i2 | 0;
     HEAP16[i15 >> 1] = i8 - (i8 >>> 5);
     i4 = i15 + 2 | 0;
     i8 = HEAPU16[i4 >> 1] | 0;
     if (i11 >>> 0 < 16777216) {
      i13 = i14 + 1 | 0;
      i3 = HEAPU8[i14 >> 0] | 0 | i3 << 8;
      i11 = i11 << 8;
     } else i13 = i14;
     i2 = Math_imul(i11 >>> 11, i8) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i4 >> 1] = ((2048 - i8 | 0) >>> 5) + i8;
      i15 = i15 + 260 + (i18 << 3 << 1) | 0;
      i16 = 8;
      i17 = 8;
      i8 = i13;
      break;
     } else {
      HEAP16[i4 >> 1] = i8 - (i8 >>> 5);
      i15 = i15 + 516 | 0;
      i16 = 16;
      i17 = 256;
      i8 = i13;
      i3 = i3 - i2 | 0;
      i2 = i11 - i2 | 0;
      break;
     }
    } while (0);
    i4 = 1;
    while (1) {
     i13 = i15 + (i4 << 1) | 0;
     i14 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i11 = i8 + 1 | 0;
      i3 = HEAPU8[i8 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i11 = i8;
     i8 = Math_imul(i2 >>> 11, i14) | 0;
     if (i3 >>> 0 < i8 >>> 0) {
      HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
      i4 = i4 << 1;
      i2 = i8;
     } else {
      HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
      i4 = i4 << 1 | 1;
      i3 = i3 - i8 | 0;
      i2 = i2 - i8 | 0;
     }
     if (i4 >>> 0 < i17 >>> 0) i8 = i11; else break;
    }
    i19 = i4 - i17 + i16 | 0;
    if (i5 >>> 0 > 11) {
     i17 = i35 + ((i19 >>> 0 > 3 ? 3 : i19) << 6 << 1) | 0;
     i13 = i17 + 2 | 0;
     i8 = HEAPU16[i13 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i15 = i11 + 1 | 0;
      i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i15 = i11;
     i4 = Math_imul(i2 >>> 11, i8) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      i14 = 2;
      i2 = ((2048 - i8 | 0) >>> 5) + i8 | 0;
     } else {
      i14 = 3;
      i3 = i3 - i4 | 0;
      i4 = i2 - i4 | 0;
      i2 = i8 - (i8 >>> 5) | 0;
     }
     HEAP16[i13 >> 1] = i2;
     i8 = i17 + (i14 << 1) | 0;
     i11 = HEAPU16[i8 >> 1] | 0;
     if (i4 >>> 0 < 16777216) {
      i16 = i15 + 1 | 0;
      i3 = HEAPU8[i15 >> 0] | 0 | i3 << 8;
      i4 = i4 << 8;
     } else i16 = i15;
     i2 = Math_imul(i4 >>> 11, i11) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i8 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
      i13 = i14 << 1;
     } else {
      HEAP16[i8 >> 1] = i11 - (i11 >>> 5);
      i13 = i14 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i4 - i2 | 0;
     }
     i8 = i17 + (i13 << 1) | 0;
     i11 = HEAPU16[i8 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i14 = i16 + 1 | 0;
      i3 = HEAPU8[i16 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i14 = i16;
     i4 = Math_imul(i2 >>> 11, i11) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i8 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
      i13 = i13 << 1;
      i2 = i4;
     } else {
      HEAP16[i8 >> 1] = i11 - (i11 >>> 5);
      i13 = i13 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
     }
     i8 = i17 + (i13 << 1) | 0;
     i11 = HEAPU16[i8 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i15 = i14 + 1 | 0;
      i3 = HEAPU8[i14 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i15 = i14;
     i4 = Math_imul(i2 >>> 11, i11) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i8 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
      i13 = i13 << 1;
      i2 = i4;
     } else {
      HEAP16[i8 >> 1] = i11 - (i11 >>> 5);
      i13 = i13 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
     }
     i8 = i17 + (i13 << 1) | 0;
     i11 = HEAPU16[i8 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i16 = i15 + 1 | 0;
      i3 = HEAPU8[i15 >> 0] | 0 | i3 << 8;
      i2 = i2 << 8;
     } else i16 = i15;
     i4 = Math_imul(i2 >>> 11, i11) | 0;
     if (i3 >>> 0 < i4 >>> 0) {
      HEAP16[i8 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
      i14 = i13 << 1;
      i2 = i4;
     } else {
      HEAP16[i8 >> 1] = i11 - (i11 >>> 5);
      i14 = i13 << 1 | 1;
      i3 = i3 - i4 | 0;
      i2 = i2 - i4 | 0;
     }
     i8 = i17 + (i14 << 1) | 0;
     i13 = HEAPU16[i8 >> 1] | 0;
     if (i2 >>> 0 < 16777216) {
      i11 = i16 + 1 | 0;
      i3 = HEAPU8[i16 >> 0] | 0 | i3 << 8;
      i4 = i2 << 8;
     } else {
      i11 = i16;
      i4 = i2;
     }
     i2 = Math_imul(i4 >>> 11, i13) | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      HEAP16[i8 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
      i14 = i14 << 1;
     } else {
      HEAP16[i8 >> 1] = i13 - (i13 >>> 5);
      i14 = i14 << 1 | 1;
      i3 = i3 - i2 | 0;
      i2 = i4 - i2 | 0;
     }
     i8 = i14 + -64 | 0;
     L233 : do if (i8 >>> 0 > 3) {
      i13 = i8 >>> 1;
      i15 = i13 + -1 | 0;
      i4 = i8 & 1 | 2;
      if (i8 >>> 0 < 14) {
       i8 = i4 << i15;
       i18 = i36 + (i8 << 1) + (64 - i14 << 1) + -2 | 0;
       i4 = 1;
       i17 = 1;
       while (1) {
        i13 = i18 + (i4 << 1) | 0;
        i14 = HEAPU16[i13 >> 1] | 0;
        if (i2 >>> 0 < 16777216) {
         i16 = i11 + 1 | 0;
         i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
         i2 = i2 << 8;
        } else i16 = i11;
        i9 = Math_imul(i2 >>> 11, i14) | 0;
        if (i3 >>> 0 < i9 >>> 0) {
         HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
         i4 = i4 << 1;
         i2 = i9;
        } else {
         HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
         i4 = i4 << 1 | 1;
         i3 = i3 - i9 | 0;
         i2 = i2 - i9 | 0;
         i8 = i17 | i8;
        }
        i15 = i15 + -1 | 0;
        if (!i15) {
         i11 = i16;
         break L233;
        } else {
         i17 = i17 << 1;
         i11 = i16;
        }
       }
      }
      i14 = i13 + -5 | 0;
      while (1) {
       if (i2 >>> 0 < 16777216) {
        i13 = i11 + 1 | 0;
        i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
        i8 = i2 << 8;
       } else {
        i13 = i11;
        i8 = i2;
       }
       i2 = i8 >>> 1;
       i3 = i3 - i2 | 0;
       i21 = i3 >> 31;
       i4 = i21 + (i4 << 1 | 1) | 0;
       i3 = (i21 & i2) + i3 | 0;
       i14 = i14 + -1 | 0;
       if (!i14) break; else i11 = i13;
      }
      i4 = i4 << 4;
      i11 = HEAPU16[i38 >> 1] | 0;
      if (i8 >>> 0 < 33554432) {
       i15 = i13 + 1 | 0;
       i3 = HEAPU8[i13 >> 0] | 0 | i3 << 8;
       i2 = i2 << 8;
      } else i15 = i13;
      i8 = Math_imul(i2 >>> 11, i11) | 0;
      if (i3 >>> 0 < i8 >>> 0) {
       HEAP16[i38 >> 1] = ((2048 - i11 | 0) >>> 5) + i11;
       i14 = 2;
      } else {
       HEAP16[i38 >> 1] = i11 - (i11 >>> 5);
       i14 = 3;
       i3 = i3 - i8 | 0;
       i8 = i2 - i8 | 0;
       i4 = i4 | 1;
      }
      i11 = i37 + (i14 << 1) | 0;
      i13 = HEAPU16[i11 >> 1] | 0;
      if (i8 >>> 0 < 16777216) {
       i16 = i15 + 1 | 0;
       i3 = HEAPU8[i15 >> 0] | 0 | i3 << 8;
       i8 = i8 << 8;
      } else i16 = i15;
      i2 = Math_imul(i8 >>> 11, i13) | 0;
      if (i3 >>> 0 < i2 >>> 0) {
       HEAP16[i11 >> 1] = ((2048 - i13 | 0) >>> 5) + i13;
       i15 = i14 << 1;
      } else {
       HEAP16[i11 >> 1] = i13 - (i13 >>> 5);
       i4 = i4 | 2;
       i15 = i14 << 1 | 1;
       i3 = i3 - i2 | 0;
       i2 = i8 - i2 | 0;
      }
      i13 = i37 + (i15 << 1) | 0;
      i14 = HEAPU16[i13 >> 1] | 0;
      if (i2 >>> 0 < 16777216) {
       i17 = i16 + 1 | 0;
       i3 = HEAPU8[i16 >> 0] | 0 | i3 << 8;
       i11 = i2 << 8;
      } else {
       i17 = i16;
       i11 = i2;
      }
      i8 = Math_imul(i11 >>> 11, i14) | 0;
      if (i3 >>> 0 < i8 >>> 0) {
       HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14;
       i2 = i15 << 1;
      } else {
       HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
       i4 = i4 | 4;
       i2 = i15 << 1 | 1;
       i3 = i3 - i8 | 0;
       i8 = i11 - i8 | 0;
      }
      i13 = i37 + (i2 << 1) | 0;
      i14 = HEAPU16[i13 >> 1] | 0;
      if (i8 >>> 0 < 16777216) {
       i11 = i17 + 1 | 0;
       i3 = HEAPU8[i17 >> 0] | 0 | i3 << 8;
       i8 = i8 << 8;
      } else i11 = i17;
      i2 = Math_imul(i8 >>> 11, i14) | 0;
      if (i3 >>> 0 < i2 >>> 0) HEAP16[i13 >> 1] = ((2048 - i14 | 0) >>> 5) + i14; else {
       HEAP16[i13 >> 1] = i14 - (i14 >>> 5);
       i4 = i4 | 8;
       i3 = i3 - i2 | 0;
       i2 = i8 - i2 | 0;
      }
      if ((i4 | 0) == -1) {
       i5 = i5 + -12 | 0;
       i8 = i19 + 274 | 0;
       break L7;
      } else i8 = i4;
     } while (0);
     i4 = i8 + 1 | 0;
     if (i24) {
      if (i8 >>> 0 >= i6 >>> 0) {
       i1 = 1;
       i65 = 225;
       break L1;
      }
     } else if (i8 >>> 0 >= i23 >>> 0) {
      i1 = 1;
      i65 = 225;
      break L1;
     }
     i15 = i7;
     i14 = i12;
     i5 = i5 >>> 0 < 19 ? 7 : 10;
     i9 = i10;
    } else {
     i4 = i7;
     i15 = i12;
     i14 = i10;
    }
    i7 = i19 + 2 | 0;
    if ((i22 | 0) == (i1 | 0)) {
     i1 = 1;
     i65 = 225;
     break L1;
    }
    i13 = i22 - i1 | 0;
    i13 = i13 >>> 0 < i7 >>> 0 ? i13 : i7;
    i10 = (i1 >>> 0 < i4 >>> 0 ? i30 : 0) + (i1 - i4) | 0;
    i6 = i13 + i6 | 0;
    i8 = i7 - i13 | 0;
    if ((i10 + i13 | 0) >>> 0 > i30 >>> 0) {
     i7 = i13;
     while (1) {
      i12 = i1 + 1 | 0;
      HEAP8[i29 + i1 >> 0] = HEAP8[i29 + i10 >> 0] | 0;
      i1 = i10 + 1 | 0;
      i7 = i7 + -1 | 0;
      if (!i7) {
       i1 = i12;
       i7 = i4;
       i12 = i15;
       i10 = i14;
       break L12;
      } else {
       i10 = (i1 | 0) == (i30 | 0) ? 0 : i1;
       i1 = i12;
      }
     }
    }
    i7 = i29 + i1 | 0;
    i10 = i10 - i1 | 0;
    i12 = i7 + i13 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i7 + i10 >> 0] | 0;
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i12 | 0));
    i1 = i13 + i1 | 0;
    i7 = i4;
    i12 = i15;
    i10 = i14;
   } while (0);
  } while (i1 >>> 0 < i22 >>> 0 & i11 >>> 0 < i56 >>> 0);
  if (i2 >>> 0 < 16777216) {
   i4 = i11 + 1 | 0;
   i3 = HEAPU8[i11 >> 0] | 0 | i3 << 8;
   i2 = i2 << 8;
  } else i4 = i11;
  HEAP32[i53 >> 2] = i4;
  HEAP32[i54 >> 2] = i2;
  HEAP32[i55 >> 2] = i3;
  HEAP32[i64 >> 2] = i8;
  HEAP32[i60 >> 2] = i1;
  HEAP32[i59 >> 2] = i6;
  HEAP32[i63 >> 2] = i7;
  HEAP32[i46 >> 2] = i12;
  HEAP32[i47 >> 2] = i10;
  HEAP32[i48 >> 2] = i9;
  HEAP32[i62 >> 2] = i5;
  i3 = HEAP32[i58 >> 2] | 0;
  if (i3 >>> 0 <= i6 >>> 0) HEAP32[i57 >> 2] = i3;
  if ((i8 + -1 | 0) >>> 0 < 273) {
   i4 = HEAP32[i51 >> 2] | 0;
   i5 = HEAP32[i52 >> 2] | 0;
   i2 = i45 - i1 | 0;
   i2 = i2 >>> 0 < i8 >>> 0 ? i2 : i8;
   if (!((HEAP32[i57 >> 2] | 0) != 0 | (i3 - i6 | 0) >>> 0 > i2 >>> 0)) HEAP32[i57 >> 2] = i3;
   HEAP32[i59 >> 2] = i6 + i2;
   HEAP32[i64 >> 2] = i8 - i2;
   if (i2) do {
    i2 = i2 + -1 | 0;
    HEAP8[i4 + i1 >> 0] = HEAP8[i4 + (i1 - i7 + (i1 >>> 0 < i7 >>> 0 ? i5 : 0)) >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i2 | 0) != 0);
   HEAP32[i60 >> 2] = i1;
  }
  if (i1 >>> 0 >= i45 >>> 0) {
   i65 = 222;
   break;
  }
  if ((HEAP32[i53 >> 2] | 0) >>> 0 >= i56 >>> 0) {
   i65 = 222;
   break;
  }
  i1 = HEAP32[i64 >> 2] | 0;
 } while (i1 >>> 0 < 274);
 if ((i65 | 0) == 222) i1 = HEAP32[i64 >> 2] | 0; else if ((i65 | 0) == 225) return i1 | 0;
 if (i1 >>> 0 <= 274) {
  i65 = 0;
  return i65 | 0;
 }
 HEAP32[i64 >> 2] = 274;
 i65 = 0;
 return i65 | 0;
}

function __ZN5physx2Gu19pcmContactBoxConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i6, i31, i7, i8, i4, i1, i62) {
 i6 = i6 | 0;
 i31 = i31 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i62 = i62 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i64 + 752 | 0;
 i34 = i64 + 672 | 0;
 i52 = i64 + 656 | 0;
 i33 = i64 + 432 | 0;
 i56 = i64 + 240 | 0;
 i63 = i64 + 208 | 0;
 i37 = i64 + 688 | 0;
 i51 = i64 + 192 | 0;
 i44 = i64 + 176 | 0;
 i38 = i64 + 160 | 0;
 i39 = i64 + 144 | 0;
 i54 = i64 + 128 | 0;
 i43 = i64 + 112 | 0;
 i32 = i64 + 96 | 0;
 i53 = i64 + 448 | 0;
 i49 = i64 + 272 | 0;
 i55 = i64 + 800 | 0;
 i40 = i64 + 80 | 0;
 i36 = i64 + 64 | 0;
 i45 = i64 + 784 | 0;
 i42 = i64 + 48 | 0;
 i41 = i64 + 32 | 0;
 i47 = i64 + 16 | 0;
 i46 = i64 + 768 | 0;
 i60 = i64;
 i61 = HEAP32[i1 >> 2] | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 HEAP32[i52 >> 2] = HEAP32[i4 >> 2];
 i48 = i6 + 4 | 0;
 i29 = HEAP32[i48 >> 2] | 0;
 i18 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = i31 + 4 | 0;
 i16 = i31 + 8 | 0;
 i28 = HEAP32[i16 >> 2] | 0;
 i17 = i31 + 12 | 0;
 i19 = HEAP32[i17 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i6 >> 2];
 i35 = i33 + 4 | 0;
 HEAP32[i35 >> 2] = i28;
 i28 = i33 + 8 | 0;
 HEAP32[i28 >> 2] = i19;
 HEAPF32[i33 + 12 >> 2] = Math_fround(0.0);
 i19 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i74 = HEAP32[i7 + 12 >> 2] | 0;
 i23 = i7 + 16 | 0;
 i25 = HEAP32[i23 >> 2] | 0;
 i24 = HEAP32[i23 + 4 >> 2] | 0;
 i23 = HEAP32[i23 + 8 >> 2] | 0;
 HEAP32[i56 >> 2] = HEAP32[i7 >> 2];
 i20 = i56 + 4 | 0;
 HEAP32[i20 >> 2] = i19;
 i19 = i56 + 8 | 0;
 HEAP32[i19 >> 2] = i1;
 i7 = i56 + 12 | 0;
 HEAP32[i7 >> 2] = i74;
 HEAP32[i56 + 16 >> 2] = i25;
 HEAP32[i56 + 20 >> 2] = i24;
 HEAP32[i56 + 24 >> 2] = i23;
 HEAPF32[i56 + 28 >> 2] = Math_fround(0.0);
 i74 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i27 = HEAP32[i8 + 8 >> 2] | 0;
 i26 = HEAP32[i8 + 12 >> 2] | 0;
 i8 = i8 + 16 | 0;
 i22 = HEAP32[i8 >> 2] | 0;
 i21 = HEAP32[i8 + 4 >> 2] | 0;
 i8 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i63 >> 2] = i74;
 i57 = i63 + 4 | 0;
 HEAP32[i57 >> 2] = i1;
 i58 = i63 + 8 | 0;
 HEAP32[i58 >> 2] = i27;
 i59 = i63 + 12 | 0;
 HEAP32[i59 >> 2] = i26;
 HEAP32[i63 + 16 >> 2] = i22;
 HEAP32[i63 + 20 >> 2] = i21;
 HEAP32[i63 + 24 >> 2] = i8;
 HEAPF32[i63 + 28 >> 2] = Math_fround(0.0);
 f65 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f71 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f67 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = Math_fround(-f65);
 f71 = Math_fround(-f71);
 f15 = Math_fround(-f15);
 f11 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f66 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f70 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f73 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f70 = Math_fround(f11 - f70);
 f73 = Math_fround(f66 - f73);
 f2 = Math_fround(f2 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f66 = Math_fround(Math_fround(f67 * f67) + Math_fround(-.5));
 f11 = Math_fround(Math_fround(Math_fround(f70 * f65) + Math_fround(f73 * f71)) + Math_fround(f2 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f11 * f65) + Math_fround(Math_fround(f66 * f70) + Math_fround(f67 * Math_fround(Math_fround(f2 * f71) - Math_fround(f73 * f15))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f11 * f71) + Math_fround(Math_fround(f66 * f73) + Math_fround(f67 * Math_fround(Math_fround(f70 * f15) - Math_fround(f2 * f65))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f66 * f2) + Math_fround(f67 * Math_fround(Math_fround(f73 * f65) - Math_fround(f70 * f71)))) + Math_fround(f11 * f15)) * Math_fround(2.0));
 f70 = Math_fround(HEAPF32[i56 >> 2]);
 f73 = Math_fround(HEAPF32[i20 >> 2]);
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 f66 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(Math_fround(f67 * f66) - Math_fround(Math_fround(Math_fround(f70 * f65) + Math_fround(f73 * f71)) + Math_fround(f2 * f15)));
 f13 = Math_fround(Math_fround(Math_fround(f2 * f71) - Math_fround(f73 * f15)) + Math_fround(Math_fround(f67 * f70) + Math_fround(f66 * f65)));
 f14 = Math_fround(Math_fround(Math_fround(f70 * f15) - Math_fround(f2 * f65)) + Math_fround(Math_fround(f67 * f73) + Math_fround(f66 * f71)));
 f15 = Math_fround(Math_fround(Math_fround(f73 * f65) - Math_fround(f70 * f71)) + Math_fround(Math_fround(f67 * f2) + Math_fround(f66 * f15)));
 i7 = i37 + 48 | 0;
 HEAPF32[i7 >> 2] = f9;
 i8 = i37 + 52 | 0;
 HEAPF32[i8 >> 2] = f10;
 i19 = i37 + 56 | 0;
 HEAPF32[i19 >> 2] = f11;
 HEAPF32[i37 + 60 >> 2] = Math_fround(0.0);
 f66 = Math_fround(f13 + f13);
 f2 = Math_fround(f14 + f14);
 f67 = Math_fround(f15 + f15);
 f71 = Math_fround(f14 * f2);
 f70 = Math_fround(f15 * f67);
 f65 = Math_fround(f14 * f66);
 f73 = Math_fround(f15 * f66);
 f3 = Math_fround(f12 * f66);
 f72 = Math_fround(f15 * f2);
 f2 = Math_fround(f12 * f2);
 f67 = Math_fround(f12 * f67);
 f66 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f66));
 f69 = Math_fround(f65 + f67);
 f68 = Math_fround(f73 - f2);
 f67 = Math_fround(f65 - f67);
 f65 = Math_fround(f66 - f70);
 f5 = Math_fround(f72 + f3);
 f2 = Math_fround(f73 + f2);
 f3 = Math_fround(f72 - f3);
 f66 = Math_fround(f66 - f71);
 HEAPF32[i37 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f71) - f70);
 i20 = i37 + 4 | 0;
 HEAPF32[i20 >> 2] = f69;
 i21 = i37 + 8 | 0;
 HEAPF32[i21 >> 2] = f68;
 HEAPF32[i37 + 12 >> 2] = Math_fround(0.0);
 i22 = i37 + 16 | 0;
 HEAPF32[i22 >> 2] = f67;
 i23 = i37 + 20 | 0;
 HEAPF32[i23 >> 2] = f65;
 i24 = i37 + 24 | 0;
 HEAPF32[i24 >> 2] = f5;
 HEAPF32[i37 + 28 >> 2] = Math_fround(0.0);
 i25 = i37 + 32 | 0;
 HEAPF32[i25 >> 2] = f2;
 i26 = i37 + 36 | 0;
 HEAPF32[i26 >> 2] = f3;
 i27 = i37 + 40 | 0;
 HEAPF32[i27 >> 2] = f66;
 HEAPF32[i37 + 44 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i31 + 36 >> 2] | 0;
 f66 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f5 = Math_fround(HEAPF32[i33 >> 2]);
 f65 = Math_fround(HEAPF32[i35 >> 2]);
 f5 = Math_fround(f66 * f5);
 f65 = Math_fround(f3 * f65);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i28 >> 2]));
 f65 = f5 <= f65 ? f5 : f65;
 f2 = Math_fround((f65 <= f2 ? f65 : f2) * Math_fround(.25));
 f65 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = f65 <= f5 ? f65 : f5;
 f3 = f5 <= f3 ? f5 : f3;
 f5 = Math_fround(f3 * Math_fround(.150000006));
 f2 = f2 > f5 ? f5 : f2;
 HEAPF32[i51 >> 2] = Math_fround(f2 * Math_fround(.800000011));
 i28 = i61 + 32 | 0;
 i35 = HEAP8[i28 >> 0] | 0;
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i61, i37, i51, i52);
 if ((HEAP8[i28 >> 0] | 0) == i35 << 24 >> 24) {
  i51 = i35 & 255;
  f69 = Math_fround(f2 * Math_fround(HEAPF32[gb + 105432 + (i51 << 2) >> 2]));
  f73 = Math_fround(HEAPF32[i61 + 16 >> 2]);
  f72 = Math_fround(HEAPF32[i61 + 20 >> 2]);
  f73 = Math_fround(f9 - f73);
  f72 = Math_fround(f10 - f72);
  f71 = Math_fround(f11 - Math_fround(HEAPF32[i61 + 24 >> 2]));
  f68 = Math_fround(-f73);
  f67 = Math_fround(-f72);
  f70 = Math_fround(-f71);
  f68 = f73 > f68 ? f73 : f68;
  f67 = f72 > f67 ? f72 : f67;
  f67 = f68 >= f67 ? f68 : f67;
  i74 = (f71 > f70 ? f71 : f70) >= Math_fround(0.0);
  f68 = i74 ? f68 : Math_fround(0.0);
  f70 = Math_fround(HEAPF32[gb + 105452 + (i51 << 2) >> 2]);
  f71 = Math_fround(HEAPF32[i61 >> 2]);
  f72 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f73 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  if (!((f67 >= f68 ? f67 : f68) > f69 ? 1 : f70 > Math_fround(Math_fround(Math_fround(Math_fround(f13 * f71) + Math_fround(f14 * f72)) + Math_fround(f15 * f73)) + Math_fround(f12 * Math_fround(HEAPF32[i61 + 12 >> 2]))))) {
   if (!(i35 << 24 >> 24)) {
    i74 = 0;
    STACKTOP = i64;
    return i74 | 0;
   }
   i4 = HEAP32[i61 + 44 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i4 + 32 >> 2]);
   f3 = Math_fround(HEAPF32[i4 + 36 >> 2]);
   f5 = Math_fround(HEAPF32[i4 + 40 >> 2]);
   if ((i35 & 255) > 1) {
    i1 = 1;
    do {
     f72 = Math_fround(HEAPF32[i4 + (i1 * 48 | 0) + 32 >> 2]);
     f73 = Math_fround(HEAPF32[i4 + (i1 * 48 | 0) + 36 >> 2]);
     f2 = Math_fround(f2 + f72);
     f3 = Math_fround(f3 + f73);
     f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + (i1 * 48 | 0) + 40 >> 2]));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i51 | 0));
   }
   f69 = Math_fround(HEAPF32[i63 >> 2]);
   f70 = Math_fround(HEAPF32[i57 >> 2]);
   f66 = Math_fround(HEAPF32[i58 >> 2]);
   f68 = Math_fround(HEAPF32[i59 >> 2]);
   f73 = Math_fround(Math_fround(f68 * f68) + Math_fround(-.5));
   f67 = Math_fround(Math_fround(Math_fround(f2 * f69) + Math_fround(f3 * f70)) + Math_fround(f5 * f66));
   f71 = Math_fround(Math_fround(Math_fround(f69 * f67) + Math_fround(Math_fround(f68 * Math_fround(Math_fround(f5 * f70) - Math_fround(f3 * f66))) + Math_fround(f2 * f73))) * Math_fround(2.0));
   f72 = Math_fround(Math_fround(Math_fround(f70 * f67) + Math_fround(Math_fround(f68 * Math_fround(Math_fround(f2 * f66) - Math_fround(f5 * f69))) + Math_fround(f3 * f73))) * Math_fround(2.0));
   f73 = Math_fround(Math_fround(Math_fround(f66 * f67) + Math_fround(Math_fround(f68 * Math_fround(Math_fround(f3 * f69) - Math_fround(f2 * f70))) + Math_fround(f5 * f73))) * Math_fround(2.0));
   f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f73 * f73) + Math_fround(Math_fround(f71 * f71) + Math_fround(f72 * f72))))));
   f72 = Math_fround(f70 * f72);
   f73 = Math_fround(f70 * f73);
   HEAPF32[i60 >> 2] = Math_fround(f70 * f71);
   HEAPF32[i60 + 4 >> 2] = f72;
   HEAPF32[i60 + 8 >> 2] = f73;
   HEAPF32[i60 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i61, i62, i60, i63);
   i74 = 1;
   STACKTOP = i64;
   return i74 | 0;
  }
 }
 HEAPF32[i44 >> 2] = Math_fround(f2 * Math_fround(.0500000007));
 HEAP32[i38 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i38 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i38 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i38 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i39 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i54 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAPF32[i43 >> 2] = Math_fround(0.0);
 i51 = HEAP32[i31 + 20 >> 2] | 0;
 i60 = HEAP32[i31 + 24 >> 2] | 0;
 i74 = HEAP32[i31 + 28 >> 2] | 0;
 HEAP32[i32 >> 2] = HEAP32[i31 + 16 >> 2];
 HEAP32[i32 + 4 >> 2] = i51;
 HEAP32[i32 + 8 >> 2] = i60;
 HEAP32[i32 + 12 >> 2] = i74;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i53, i1, i34, i33, i32);
 i74 = i49 + 64 | 0;
 HEAP32[i49 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i49 + 80 >> 2] = 3;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i74 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 HEAP32[i49 + 144 >> 2] = i29;
 HEAP32[i49 + 148 >> 2] = i18;
 HEAP32[i49 + 152 >> 2] = i4;
 HEAPF32[i49 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i49 + 16 >> 2] = f5;
 HEAPF32[i49 + 32 >> 2] = Math_fround(f3 * Math_fround(.0500000007));
 f73 = Math_fround(f5 * f5);
 HEAPF32[i49 + 48 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(f73 + Math_fround(f73 + f73)))) - f5);
 if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i16 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i17 >> 2]) == Math_fround(1.0)) {
  i6 = 1;
  i4 = __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i49, i53, i37, i52, i38, i39, i54, i43, i61 + 34 | 0, i61 + 38 | 0, i61 + 33 | 0) | 0;
 } else i50 = 7; else i50 = 7; else i50 = 7;
 if ((i50 | 0) == 7) {
  i6 = 0;
  i4 = __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i49, i53, i37, i52, i38, i39, i54, i43, i61 + 34 | 0, i61 + 38 | 0, i61 + 33 | 0) | 0;
 }
 HEAPF32[i61 >> 2] = f13;
 HEAPF32[i61 + 4 >> 2] = f14;
 HEAPF32[i61 + 8 >> 2] = f15;
 HEAPF32[i61 + 12 >> 2] = f12;
 HEAPF32[i61 + 16 >> 2] = f9;
 HEAPF32[i61 + 20 >> 2] = f10;
 HEAPF32[i61 + 24 >> 2] = f11;
 HEAPF32[i61 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i55 >> 2] = 0;
 L20 : do switch (i4 | 0) {
 case 3:
  {
   i1 = __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb(i48, i49, i53, i56, i63, i62, i55, i62, i61, i54, i52, i6, 1) | 0;
   break;
  }
 case 0:
  {
   i1 = 0;
   break;
  }
 default:
  {
   i1 = (i4 | 0) == 1;
   if (!(HEAP8[i28 >> 0] | 0)) {
    if (i1) {
     f72 = Math_fround(HEAPF32[i38 >> 2]);
     f71 = Math_fround(HEAPF32[i38 + 4 >> 2]);
     f73 = Math_fround(HEAPF32[i38 + 8 >> 2]);
     f69 = Math_fround(HEAPF32[i7 >> 2]);
     f70 = Math_fround(HEAPF32[i8 >> 2]);
     f69 = Math_fround(f72 - f69);
     f70 = Math_fround(f71 - f70);
     f73 = Math_fround(f73 - Math_fround(HEAPF32[i19 >> 2]));
     f71 = Math_fround(f69 * Math_fround(HEAPF32[i37 >> 2]));
     f71 = Math_fround(f71 + Math_fround(f70 * Math_fround(HEAPF32[i20 >> 2])));
     f71 = Math_fround(f71 + Math_fround(f73 * Math_fround(HEAPF32[i21 >> 2])));
     f72 = Math_fround(f69 * Math_fround(HEAPF32[i22 >> 2]));
     f72 = Math_fround(f72 + Math_fround(f70 * Math_fround(HEAPF32[i23 >> 2])));
     f72 = Math_fround(f72 + Math_fround(f73 * Math_fround(HEAPF32[i24 >> 2])));
     f69 = Math_fround(f69 * Math_fround(HEAPF32[i25 >> 2]));
     f70 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i26 >> 2])));
     f73 = Math_fround(f70 + Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2])));
     i59 = HEAP32[i54 >> 2] | 0;
     i60 = HEAP32[i54 + 4 >> 2] | 0;
     i74 = HEAP32[i54 + 8 >> 2] | 0;
     i1 = HEAP32[i43 >> 2] | 0;
     HEAPF32[i62 >> 2] = f71;
     HEAPF32[i62 + 4 >> 2] = f72;
     HEAPF32[i62 + 8 >> 2] = f73;
     HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
     i58 = i62 + 16 | 0;
     HEAP32[i58 >> 2] = HEAP32[i39 >> 2];
     HEAP32[i58 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAP32[i58 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
     HEAP32[i58 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
     HEAP32[i55 >> 2] = 1;
     HEAP32[i62 + 32 >> 2] = i59;
     HEAP32[i62 + 36 >> 2] = i60;
     HEAP32[i62 + 40 >> 2] = i74;
     HEAP32[i62 + 44 >> 2] = i1;
     i1 = 0;
    } else if ((i4 | 0) == 6) {
     HEAP32[i46 >> 2] = gb + 85484 + 8;
     HEAP32[i46 + 4 >> 2] = i49;
     HEAP32[i46 + 8 >> 2] = i53;
     HEAP32[i46 + 12 >> 2] = i37;
     if ((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i49, i53, i46, i61 + 34 | 0, i61 + 38 | 0, HEAP8[i61 + 33 >> 0] | 0, i38, i39, i54, i43, 0) | 0) == 6) {
      f72 = Math_fround(HEAPF32[i38 >> 2]);
      f71 = Math_fround(HEAPF32[i38 + 4 >> 2]);
      f73 = Math_fround(HEAPF32[i38 + 8 >> 2]);
      f69 = Math_fround(HEAPF32[i7 >> 2]);
      f70 = Math_fround(HEAPF32[i8 >> 2]);
      f69 = Math_fround(f72 - f69);
      f70 = Math_fround(f71 - f70);
      f73 = Math_fround(f73 - Math_fround(HEAPF32[i19 >> 2]));
      f71 = Math_fround(f69 * Math_fround(HEAPF32[i37 >> 2]));
      f71 = Math_fround(f71 + Math_fround(f70 * Math_fround(HEAPF32[i20 >> 2])));
      f71 = Math_fround(f71 + Math_fround(f73 * Math_fround(HEAPF32[i21 >> 2])));
      f72 = Math_fround(f69 * Math_fround(HEAPF32[i22 >> 2]));
      f72 = Math_fround(f72 + Math_fround(f70 * Math_fround(HEAPF32[i23 >> 2])));
      f72 = Math_fround(f72 + Math_fround(f73 * Math_fround(HEAPF32[i24 >> 2])));
      f69 = Math_fround(f69 * Math_fround(HEAPF32[i25 >> 2]));
      f70 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i26 >> 2])));
      f73 = Math_fround(f70 + Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2])));
      i58 = HEAP32[i54 >> 2] | 0;
      i59 = HEAP32[i54 + 4 >> 2] | 0;
      i60 = HEAP32[i54 + 8 >> 2] | 0;
      i74 = HEAP32[i43 >> 2] | 0;
      i1 = HEAP32[i55 >> 2] | 0;
      HEAPF32[i62 + (i1 * 48 | 0) >> 2] = f71;
      HEAPF32[i62 + (i1 * 48 | 0) + 4 >> 2] = f72;
      HEAPF32[i62 + (i1 * 48 | 0) + 8 >> 2] = f73;
      HEAPF32[i62 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
      i57 = i62 + (i1 * 48 | 0) + 16 | 0;
      HEAP32[i57 >> 2] = HEAP32[i39 >> 2];
      HEAP32[i57 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
      HEAP32[i57 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
      HEAP32[i57 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
      HEAP32[i55 >> 2] = i1 + 1;
      HEAP32[i62 + (i1 * 48 | 0) + 32 >> 2] = i58;
      HEAP32[i62 + (i1 * 48 | 0) + 36 >> 2] = i59;
      HEAP32[i62 + (i1 * 48 | 0) + 40 >> 2] = i60;
      HEAP32[i62 + (i1 * 48 | 0) + 44 >> 2] = i74;
      i1 = 0;
     } else i1 = 1;
    } else i1 = 0;
    i1 = __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb(i48, i49, i53, i56, i63, i62, i55, i62, i61, i54, i52, i6, i1) | 0;
    break L20;
   }
   if (i1) {
    f72 = Math_fround(HEAPF32[i38 >> 2]);
    f71 = Math_fround(HEAPF32[i38 + 4 >> 2]);
    f73 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f69 = Math_fround(HEAPF32[i7 >> 2]);
    f70 = Math_fround(HEAPF32[i8 >> 2]);
    f69 = Math_fround(f72 - f69);
    f70 = Math_fround(f71 - f70);
    f73 = Math_fround(f73 - Math_fround(HEAPF32[i19 >> 2]));
    f71 = Math_fround(f69 * Math_fround(HEAPF32[i37 >> 2]));
    f71 = Math_fround(f71 + Math_fround(f70 * Math_fround(HEAPF32[i20 >> 2])));
    f71 = Math_fround(f71 + Math_fround(f73 * Math_fround(HEAPF32[i21 >> 2])));
    f72 = Math_fround(f69 * Math_fround(HEAPF32[i22 >> 2]));
    f72 = Math_fround(f72 + Math_fround(f70 * Math_fround(HEAPF32[i23 >> 2])));
    f72 = Math_fround(f72 + Math_fround(f73 * Math_fround(HEAPF32[i24 >> 2])));
    f69 = Math_fround(f69 * Math_fround(HEAPF32[i25 >> 2]));
    f70 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i26 >> 2])));
    f73 = Math_fround(f70 + Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2])));
    i60 = HEAP32[i54 + 4 >> 2] | 0;
    i74 = HEAP32[i54 + 8 >> 2] | 0;
    i50 = HEAP32[i43 >> 2] | 0;
    HEAP32[i40 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i40 + 4 >> 2] = i60;
    HEAP32[i40 + 8 >> 2] = i74;
    HEAP32[i40 + 12 >> 2] = i50;
    HEAPF32[i62 >> 2] = f71;
    HEAPF32[i62 + 4 >> 2] = f72;
    HEAPF32[i62 + 8 >> 2] = f73;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    i50 = i62 + 16 | 0;
    HEAP32[i50 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i50 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i50 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i50 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    HEAP32[i55 >> 2] = 1;
    i50 = i62 + 32 | 0;
    HEAP32[i50 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i50 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i50 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i50 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAPF32[i36 >> 2] = f71;
    HEAPF32[i36 + 4 >> 2] = f72;
    HEAPF32[i36 + 8 >> 2] = f73;
    HEAPF32[i36 + 12 >> 2] = Math_fround(0.0);
    __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i61, i36, i39, i40, i44) | 0;
    i50 = 15;
   } else {
    HEAP32[i45 >> 2] = gb + 85484 + 8;
    HEAP32[i45 + 4 >> 2] = i49;
    HEAP32[i45 + 8 >> 2] = i53;
    HEAP32[i45 + 12 >> 2] = i37;
    if ((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i49, i53, i45, i61 + 34 | 0, i61 + 38 | 0, HEAP8[i61 + 33 >> 0] | 0, i38, i39, i54, i43, 0) | 0) == 6) {
     f72 = Math_fround(HEAPF32[i38 >> 2]);
     f71 = Math_fround(HEAPF32[i38 + 4 >> 2]);
     f73 = Math_fround(HEAPF32[i38 + 8 >> 2]);
     f69 = Math_fround(HEAPF32[i7 >> 2]);
     f70 = Math_fround(HEAPF32[i8 >> 2]);
     f69 = Math_fround(f72 - f69);
     f70 = Math_fround(f71 - f70);
     f73 = Math_fround(f73 - Math_fround(HEAPF32[i19 >> 2]));
     f71 = Math_fround(f69 * Math_fround(HEAPF32[i37 >> 2]));
     f71 = Math_fround(f71 + Math_fround(f70 * Math_fround(HEAPF32[i20 >> 2])));
     f71 = Math_fround(f71 + Math_fround(f73 * Math_fround(HEAPF32[i21 >> 2])));
     f72 = Math_fround(f69 * Math_fround(HEAPF32[i22 >> 2]));
     f72 = Math_fround(f72 + Math_fround(f70 * Math_fround(HEAPF32[i23 >> 2])));
     f72 = Math_fround(f72 + Math_fround(f73 * Math_fround(HEAPF32[i24 >> 2])));
     f69 = Math_fround(f69 * Math_fround(HEAPF32[i25 >> 2]));
     f70 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i26 >> 2])));
     f73 = Math_fround(f70 + Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2])));
     HEAPF32[i42 >> 2] = f71;
     HEAPF32[i42 + 4 >> 2] = f72;
     HEAPF32[i42 + 8 >> 2] = f73;
     HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
     i60 = HEAP32[i54 + 4 >> 2] | 0;
     i74 = HEAP32[i54 + 8 >> 2] | 0;
     i50 = HEAP32[i43 >> 2] | 0;
     HEAP32[i41 >> 2] = HEAP32[i54 >> 2];
     HEAP32[i41 + 4 >> 2] = i60;
     HEAP32[i41 + 8 >> 2] = i74;
     HEAP32[i41 + 12 >> 2] = i50;
     i50 = HEAP32[i55 >> 2] | 0;
     i74 = i62 + (i50 * 48 | 0) | 0;
     HEAP32[i74 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i74 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
     HEAP32[i74 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
     HEAP32[i74 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
     i74 = i62 + (i50 * 48 | 0) + 16 | 0;
     HEAP32[i74 >> 2] = HEAP32[i39 >> 2];
     HEAP32[i74 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
     HEAP32[i74 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
     HEAP32[i74 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
     HEAP32[i55 >> 2] = i50 + 1;
     i50 = i62 + (i50 * 48 | 0) + 32 | 0;
     HEAP32[i50 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i50 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
     HEAP32[i50 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
     HEAP32[i50 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
     __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i61, i42, i39, i41, i44) | 0;
     i50 = 15;
    } else {
     i1 = i49;
     i4 = 1;
    }
   }
   do if ((i50 | 0) == 15) if ((HEAPU8[i28 >> 0] | 0) < (i35 & 255)) {
    i1 = i49;
    i4 = 0;
    break;
   } else {
    f14 = Math_fround(HEAPF32[i63 >> 2]);
    f68 = Math_fround(HEAPF32[i57 >> 2]);
    f70 = Math_fround(HEAPF32[i58 >> 2]);
    f67 = Math_fround(HEAPF32[i59 >> 2]);
    f65 = Math_fround(HEAPF32[i54 >> 2]);
    f71 = Math_fround(HEAPF32[i54 + 4 >> 2]);
    f69 = Math_fround(HEAPF32[i54 + 8 >> 2]);
    f66 = Math_fround(Math_fround(f67 * f67) + Math_fround(-.5));
    f15 = Math_fround(Math_fround(Math_fround(f14 * f65) + Math_fround(f68 * f71)) + Math_fround(f70 * f69));
    f72 = Math_fround(Math_fround(Math_fround(f68 * f15) + Math_fround(Math_fround(f66 * f71) + Math_fround(f67 * Math_fround(Math_fround(f70 * f65) - Math_fround(f14 * f69))))) * Math_fround(2.0));
    f73 = Math_fround(Math_fround(Math_fround(Math_fround(f66 * f69) + Math_fround(f67 * Math_fround(Math_fround(f14 * f71) - Math_fround(f68 * f65)))) + Math_fround(f70 * f15)) * Math_fround(2.0));
    HEAPF32[i47 >> 2] = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(Math_fround(f65 * f66) + Math_fround(f67 * Math_fround(Math_fround(f68 * f69) - Math_fround(f70 * f71))))) * Math_fround(2.0));
    HEAPF32[i47 + 4 >> 2] = f72;
    HEAPF32[i47 + 8 >> 2] = f73;
    HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
    __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i61, i62, i47, i63);
    i1 = 1;
    break L20;
   } while (0);
   i1 = __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb(i48, i1, i53, i56, i63, i62, i55, i62, i61, i54, i52, i6, i4) | 0;
  }
 } while (0);
 i74 = i1;
 STACKTOP = i64;
 return i74 | 0;
}

function __ZN5physx30setupFinalizeSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff(i12, i133, i134, i6, i7, i1, i13, i8, i9, i10, i11, f135, f132, f3, f2, f4, f5) {
 i12 = i12 | 0;
 i133 = i133 | 0;
 i134 = i134 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f135 = Math_fround(f135);
 f132 = Math_fround(f132);
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, i70 = 0, f71 = f0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, i91 = 0, i92 = 0, i93 = 0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, i130 = 0, i131 = 0, i136 = 0, i137 = 0, i138 = 0, f139 = f0;
 if (!(HEAP32[i133 + 4096 >> 2] | 0)) return;
 i130 = i12 + 22 | 0;
 i131 = (HEAPU16[i130 >> 1] | 0) >>> 8 & 1;
 f129 = Math_fround(HEAPF32[i12 + 84 >> 2]);
 f118 = Math_fround(HEAPF32[i12 + 88 >> 2]);
 f121 = Math_fround(f129 * f3);
 f120 = Math_fround(f118 * f4);
 f129 = Math_fround(f129 * f2);
 f118 = Math_fround(f118 * f5);
 f119 = Math_fround(HEAPF32[i10 + 48 >> 2]);
 f119 = Math_fround(f121 * f119);
 f120 = Math_fround(f120 * Math_fround(HEAPF32[i11 + 48 >> 2]));
 f121 = Math_fround(-f120);
 f122 = Math_fround(HEAPF32[i12 + 92 >> 2]);
 f123 = Math_fround(HEAPF32[i10 + 52 >> 2]);
 f117 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 f117 = f123 > f117 ? f123 : f117;
 f123 = Math_fround(HEAPF32[i6 >> 2]);
 f124 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f125 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f126 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f127 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f128 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f110 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f111 = Math_fround(HEAPF32[i7 >> 2]);
 f112 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f113 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f114 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f115 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f116 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f101 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f102 = Math_fround(HEAPF32[i8 >> 2]);
 f103 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f104 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f105 = Math_fround(HEAPF32[i9 >> 2]);
 f106 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f107 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f108 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f109 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f98 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 f99 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f100 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f97 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f73 = Math_fround(HEAPF32[i10 >> 2]);
 f74 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f75 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f76 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f77 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f78 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f79 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f80 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 f81 = Math_fround(HEAPF32[i10 + 32 >> 2]);
 f82 = Math_fround(HEAPF32[i11 >> 2]);
 f83 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f84 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f85 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f86 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f87 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f88 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f89 = Math_fround(HEAPF32[i11 + 28 >> 2]);
 f90 = Math_fround(HEAPF32[i11 + 32 >> 2]);
 f71 = Math_fround(f135 * Math_fround(.800000011));
 i72 = (HEAP16[i130 >> 1] & 24) != 0;
 f73 = Math_fround(f129 * f73);
 f74 = Math_fround(f129 * f74);
 f75 = Math_fround(f129 * f75);
 f76 = Math_fround(f129 * f76);
 f77 = Math_fround(f129 * f77);
 f78 = Math_fround(f129 * f78);
 f79 = Math_fround(f129 * f79);
 f80 = Math_fround(f129 * f80);
 f81 = Math_fround(f129 * f81);
 f82 = Math_fround(f118 * f82);
 f83 = Math_fround(f118 * f83);
 f84 = Math_fround(f118 * f84);
 f85 = Math_fround(f118 * f85);
 f86 = Math_fround(f118 * f86);
 f87 = Math_fround(f118 * f87);
 f88 = Math_fround(f118 * f88);
 f89 = Math_fround(f118 * f89);
 f90 = Math_fround(f118 * f90);
 i91 = i134 + 4232 | 0;
 i1 = HEAP32[i91 >> 2] | 0;
 if (!i1) return;
 i92 = i72 ? 112 : 80;
 i93 = i72 ? 128 : 96;
 i70 = i72 ? 3 : 6;
 f94 = Math_fround(f102 - f105);
 f95 = Math_fround(f103 - f106);
 f96 = Math_fround(f104 - f107);
 i67 = i12 + 40 | 0;
 i46 = i93 << 1;
 i47 = i93 + 80 | 0;
 f68 = Math_fround(Math_fround(f126 * f126) + Math_fround(-.5));
 f69 = Math_fround(Math_fround(f114 * f114) + Math_fround(-.5));
 i48 = i93 | 4;
 i49 = i93 | 8;
 i50 = i93 | 12;
 i63 = i93 | 16;
 i51 = i93 | 20;
 i52 = i93 | 24;
 i53 = i93 | 28;
 i64 = i93 + 32 | 0;
 i54 = i93 + 36 | 0;
 i55 = i93 + 40 | 0;
 i56 = i93 + 44 | 0;
 i65 = i93 + 48 | 0;
 i57 = i93 + 52 | 0;
 i58 = i93 + 56 | 0;
 i59 = i93 + 60 | 0;
 i66 = i93 + 64 | 0;
 i60 = i93 + 68 | 0;
 i61 = i93 + 72 | 0;
 i62 = i93 + 76 | 0;
 i7 = 0;
 i45 = 0;
 while (1) {
  i34 = HEAP32[i134 + 3840 + (i45 << 2) >> 2] | 0;
  if (!i34) i6 = i13; else {
   i44 = i134 + 3968 + (i45 << 2) | 0;
   i33 = HEAPU16[i134 + ((HEAP32[i44 >> 2] | 0) * 12 | 0) >> 1] | 0;
   f14 = Math_fround(HEAPF32[i133 + (i33 << 6) + 60 >> 2]);
   i6 = i13 + 32 | 0;
   HEAP8[i13 + 4 >> 0] = i131;
   i1 = HEAP32[i44 >> 2] | 0;
   i8 = HEAP16[i134 + (i1 * 12 | 0) >> 1] | 0;
   i32 = i8 & 65535;
   i30 = HEAP32[i133 + (i32 << 6) >> 2] | 0;
   i31 = HEAP32[i133 + (i32 << 6) + 4 >> 2] | 0;
   i32 = HEAP32[i133 + (i32 << 6) + 8 >> 2] | 0;
   f20 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = Math_fround(f20 * f20);
   f21 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = Math_fround(f18 + Math_fround(f21 * f21));
   f19 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = Math_fround(f18 + Math_fround(f19 * f19));
   f15 = Math_fround(Math_fround(Math_fround(f102 * f20) + Math_fround(f103 * f21)) + Math_fround(f104 * f19));
   f16 = Math_fround(Math_fround(Math_fround(f105 * f20) + Math_fround(f106 * f21)) + Math_fround(f107 * f19));
   f17 = Math_fround(f119 * f18);
   f18 = Math_fround(f18 * f121);
   L11 : do if ((i1 | 0) != 65535) if (f14 > Math_fround(0.0)) while (1) {
    i9 = HEAP16[i134 + (i1 * 12 | 0) + 2 >> 1] | 0;
    i12 = i8 & 65535;
    if (i9 << 16 >> 16) {
     i9 = i9 & 65535;
     i8 = Math_imul(i92, i9) | 0;
     i10 = 0;
     i11 = i6;
     while (1) {
      i138 = i10 + i12 | 0;
      f29 = Math_fround(HEAPF32[i133 + (i138 << 6) + 16 >> 2]);
      f4 = Math_fround(HEAPF32[i133 + (i138 << 6) + 20 >> 2]);
      f3 = Math_fround(HEAPF32[i133 + (i138 << 6) + 24 >> 2]);
      f5 = Math_fround(HEAPF32[i133 + (i138 << 6) + 12 >> 2]);
      f2 = Math_fround(HEAPF32[i133 + (i138 << 6) + 32 >> 2]);
      f27 = Math_fround(HEAPF32[i133 + (i138 << 6) + 36 >> 2]);
      f27 = Math_fround(Math_fround(Math_fround(f20 * f2) + Math_fround(f21 * f27)) + Math_fround(f19 * Math_fround(HEAPF32[i133 + (i138 << 6) + 40 >> 2])));
      f2 = Math_fround(f29 - f127);
      f43 = Math_fround(f4 - f128);
      f42 = Math_fround(f3 - f110);
      f29 = Math_fround(f29 - f115);
      f4 = Math_fround(f4 - f116);
      f3 = Math_fround(f3 - f101);
      f41 = Math_fround(Math_fround(f19 * f43) - Math_fround(f21 * f42));
      f42 = Math_fround(Math_fround(f20 * f42) - Math_fround(f19 * f2));
      f43 = Math_fround(Math_fround(f21 * f2) - Math_fround(f20 * f43));
      f2 = Math_fround(Math_fround(f19 * f4) - Math_fround(f21 * f3));
      f3 = Math_fround(Math_fround(f20 * f3) - Math_fround(f19 * f29));
      f4 = Math_fround(Math_fround(f21 * f29) - Math_fround(f20 * f4));
      f29 = Math_fround(Math_fround(f79 * f43) + Math_fround(Math_fround(f76 * f42) + Math_fround(f73 * f41)));
      f35 = Math_fround(Math_fround(f80 * f43) + Math_fround(Math_fround(f77 * f42) + Math_fround(f74 * f41)));
      f36 = Math_fround(Math_fround(f81 * f43) + Math_fround(Math_fround(f78 * f42) + Math_fround(f75 * f41)));
      f38 = Math_fround(Math_fround(f88 * f4) + Math_fround(Math_fround(f85 * f3) + Math_fround(f82 * f2)));
      f39 = Math_fround(Math_fround(f89 * f4) + Math_fround(Math_fround(f86 * f3) + Math_fround(f83 * f2)));
      f40 = Math_fround(Math_fround(f90 * f4) + Math_fround(Math_fround(f87 * f3) + Math_fround(f84 * f2)));
      f28 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(f43 * f36) + Math_fround(Math_fround(f41 * f29) + Math_fround(f42 * f35)))) + Math_fround(Math_fround(Math_fround(f4 * f40) + Math_fround(Math_fround(f2 * f38) + Math_fround(f3 * f39))) - f18));
      f26 = Math_fround(Math_fround(f15 + Math_fround(Math_fround(f98 * f43) + Math_fround(Math_fround(f108 * f41) + Math_fround(f109 * f42)))) - Math_fround(f16 + Math_fround(Math_fround(f97 * f4) + Math_fround(Math_fround(f99 * f2) + Math_fround(f100 * f3)))));
      i137 = f28 > Math_fround(0.0);
      f28 = Math_fround(Math_fround(1.0) / f28);
      f28 = i137 ? f28 : Math_fround(0.0);
      f5 = Math_fround(f5 - f122);
      f25 = Math_fround(f5 * f135);
      f5 = Math_fround(f71 * f5);
      f5 = Math_fround((f117 > f5 ? f117 : f5) * f28);
      f37 = Math_fround(-f26);
      i137 = f25 < f37 & f26 < f132;
      f37 = Math_fround(f14 * f37);
      f37 = Math_fround(f27 + (i137 ? f37 : Math_fround(0.0)));
      HEAP32[i11 >> 2] = i30;
      HEAP32[i11 + 4 >> 2] = i31;
      HEAP32[i11 + 8 >> 2] = i32;
      HEAPF32[i11 + 12 >> 2] = f28;
      HEAPF32[i11 + 48 >> 2] = f29;
      HEAPF32[i11 + 52 >> 2] = f35;
      HEAPF32[i11 + 56 >> 2] = f36;
      HEAPF32[i11 + 60 >> 2] = f37;
      f38 = Math_fround(-f38);
      f39 = Math_fround(-f39);
      f40 = Math_fround(-f40);
      i138 = HEAP32[i133 + (i138 << 6) + 28 >> 2] | 0;
      HEAPF32[i11 + 64 >> 2] = f38;
      HEAPF32[i11 + 68 >> 2] = f39;
      HEAPF32[i11 + 72 >> 2] = f40;
      HEAP32[i11 + 76 >> 2] = i138;
      HEAPF32[i11 + 16 >> 2] = f41;
      HEAPF32[i11 + 20 >> 2] = f42;
      HEAPF32[i11 + 24 >> 2] = f43;
      HEAP32[i11 + 28 >> 2] = 0;
      i138 = i137 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
      HEAPF32[i11 + 32 >> 2] = f2;
      HEAPF32[i11 + 36 >> 2] = f3;
      HEAPF32[i11 + 40 >> 2] = f4;
      HEAP32[i11 + 44 >> 2] = i138;
      i10 = i10 + 1 | 0;
      if ((i10 | 0) == (i9 | 0)) break; else i11 = i11 + i92 | 0;
     }
     i6 = i6 + i8 | 0;
    }
    i138 = HEAP16[i134 + (i1 * 12 | 0) + 4 >> 1] | 0;
    i1 = i138 & 65535;
    if (i138 << 16 >> 16 == -1) break L11;
    i8 = HEAP16[i134 + (i1 * 12 | 0) >> 1] | 0;
   } else {
    i9 = i8;
    while (1) {
     i8 = HEAP16[i134 + (i1 * 12 | 0) + 2 >> 1] | 0;
     i12 = i9 & 65535;
     if (i8 << 16 >> 16) {
      i8 = i8 & 65535;
      i9 = Math_imul(i92, i8) | 0;
      i10 = 0;
      i11 = i6;
      while (1) {
       i138 = i10 + i12 | 0;
       f25 = Math_fround(HEAPF32[i133 + (i138 << 6) + 16 >> 2]);
       f42 = Math_fround(HEAPF32[i133 + (i138 << 6) + 20 >> 2]);
       f41 = Math_fround(HEAPF32[i133 + (i138 << 6) + 24 >> 2]);
       f43 = Math_fround(HEAPF32[i133 + (i138 << 6) + 12 >> 2]);
       f40 = Math_fround(HEAPF32[i133 + (i138 << 6) + 32 >> 2]);
       f28 = Math_fround(HEAPF32[i133 + (i138 << 6) + 36 >> 2]);
       f28 = Math_fround(Math_fround(Math_fround(f20 * f40) + Math_fround(f21 * f28)) + Math_fround(f19 * Math_fround(HEAPF32[i133 + (i138 << 6) + 40 >> 2])));
       f40 = Math_fround(f25 - f127);
       f39 = Math_fround(f42 - f128);
       f38 = Math_fround(f41 - f110);
       f25 = Math_fround(f25 - f115);
       f42 = Math_fround(f42 - f116);
       f41 = Math_fround(f41 - f101);
       f37 = Math_fround(Math_fround(f19 * f39) - Math_fround(f21 * f38));
       f38 = Math_fround(Math_fround(f20 * f38) - Math_fround(f19 * f40));
       f39 = Math_fround(Math_fround(f21 * f40) - Math_fround(f20 * f39));
       f40 = Math_fround(Math_fround(f19 * f42) - Math_fround(f21 * f41));
       f41 = Math_fround(Math_fround(f20 * f41) - Math_fround(f19 * f25));
       f42 = Math_fround(Math_fround(f21 * f25) - Math_fround(f20 * f42));
       f25 = Math_fround(Math_fround(f79 * f39) + Math_fround(Math_fround(f76 * f38) + Math_fround(f73 * f37)));
       f26 = Math_fround(Math_fround(f80 * f39) + Math_fround(Math_fround(f77 * f38) + Math_fround(f74 * f37)));
       f27 = Math_fround(Math_fround(f81 * f39) + Math_fround(Math_fround(f78 * f38) + Math_fround(f75 * f37)));
       f29 = Math_fround(Math_fround(f88 * f42) + Math_fround(Math_fround(f85 * f41) + Math_fround(f82 * f40)));
       f35 = Math_fround(Math_fround(f89 * f42) + Math_fround(Math_fround(f86 * f41) + Math_fround(f83 * f40)));
       f36 = Math_fround(Math_fround(f90 * f42) + Math_fround(Math_fround(f87 * f41) + Math_fround(f84 * f40)));
       f24 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(f39 * f27) + Math_fround(Math_fround(f37 * f25) + Math_fround(f38 * f26)))) + Math_fround(Math_fround(Math_fround(f42 * f36) + Math_fround(Math_fround(f40 * f29) + Math_fround(f41 * f35))) - f18));
       i137 = f24 > Math_fround(0.0);
       f24 = Math_fround(Math_fround(1.0) / f24);
       f24 = i137 ? f24 : Math_fround(0.0);
       f43 = Math_fround(f71 * Math_fround(f43 - f122));
       f43 = Math_fround((f117 > f43 ? f117 : f43) * f24);
       f28 = Math_fround(f28 + Math_fround(0.0));
       HEAP32[i11 >> 2] = i30;
       HEAP32[i11 + 4 >> 2] = i31;
       HEAP32[i11 + 8 >> 2] = i32;
       HEAPF32[i11 + 12 >> 2] = f24;
       HEAPF32[i11 + 48 >> 2] = f25;
       HEAPF32[i11 + 52 >> 2] = f26;
       HEAPF32[i11 + 56 >> 2] = f27;
       HEAPF32[i11 + 60 >> 2] = f28;
       f29 = Math_fround(-f29);
       f35 = Math_fround(-f35);
       f36 = Math_fround(-f36);
       i138 = HEAP32[i133 + (i138 << 6) + 28 >> 2] | 0;
       HEAPF32[i11 + 64 >> 2] = f29;
       HEAPF32[i11 + 68 >> 2] = f35;
       HEAPF32[i11 + 72 >> 2] = f36;
       HEAP32[i11 + 76 >> 2] = i138;
       HEAPF32[i11 + 16 >> 2] = f37;
       HEAPF32[i11 + 20 >> 2] = f38;
       HEAPF32[i11 + 24 >> 2] = f39;
       HEAP32[i11 + 28 >> 2] = 0;
       HEAPF32[i11 + 32 >> 2] = f40;
       HEAPF32[i11 + 36 >> 2] = f41;
       HEAPF32[i11 + 40 >> 2] = f42;
       HEAPF32[i11 + 44 >> 2] = f43;
       i10 = i10 + 1 | 0;
       if ((i10 | 0) == (i8 | 0)) break; else i11 = i11 + i92 | 0;
      }
      i6 = i6 + i9 | 0;
     }
     i138 = HEAP16[i134 + (i1 * 12 | 0) + 4 >> 1] | 0;
     i1 = i138 & 65535;
     if (i138 << 16 >> 16 == -1) break L11;
     i9 = HEAP16[i134 + (i1 * 12 | 0) >> 1] | 0;
    }
   } while (0);
   i9 = HEAP32[i133 + (i33 << 6) + 44 >> 2] | 0;
   i10 = HEAP32[i133 + (i33 << 6) + 56 >> 2] | 0;
   if (!(HEAP32[i133 + (i33 << 6) + 52 >> 2] & 1)) {
    i1 = HEAP16[i134 + 768 + (i45 * 96 | 0) + 16 >> 1] | 0;
    HEAP8[i13 + 5 >> 0] = i34;
    if (!(i1 << 16 >> 16)) i136 = 22; else {
     HEAP8[i13 + 6 >> 0] = (i1 & 65535) << 1;
     if (i72) {
      i1 = i70;
      i8 = 1;
     } else {
      i1 = (HEAP16[i130 >> 1] & 64) >>> 4 ^ 5;
      i8 = 1;
     }
    }
   } else {
    HEAP8[i13 + 5 >> 0] = i34;
    i136 = 22;
   }
   if ((i136 | 0) == 22) {
    i136 = 0;
    HEAP8[i13 + 6 >> 0] = 0;
    i1 = i70;
    i8 = 0;
   }
   HEAP8[i13 >> 0] = i1;
   HEAP32[i13 + 16 >> 2] = i9;
   HEAP32[i13 + 20 >> 2] = i10;
   HEAPF32[i13 + 24 >> 2] = f119;
   HEAPF32[i13 + 28 >> 2] = f121;
   HEAPF32[i13 + 8 >> 2] = f129;
   HEAPF32[i13 + 12 >> 2] = f118;
   if (i8) {
    f41 = Math_fround(-f19);
    f40 = Math_fround(-f21);
    i9 = Math_fround(Math_abs(Math_fround(f20))) < Math_fround(.707106769);
    f40 = i9 ? Math_fround(0.0) : f40;
    f42 = i9 ? f21 : Math_fround(0.0);
    f43 = Math_fround(Math_fround(Math_fround(f94 * f20) + Math_fround(f95 * f21)) + Math_fround(f96 * f19));
    f38 = Math_fround(f94 - Math_fround(f20 * f43));
    f39 = Math_fround(f95 - Math_fround(f21 * f43));
    f43 = Math_fround(f96 - Math_fround(f19 * f43));
    i8 = Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39))) > Math_fround(.100000001);
    f40 = i8 ? f38 : f40;
    f41 = i8 ? f39 : i9 ? f41 : f20;
    f42 = i8 ? f43 : f42;
    f43 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f42 * f42) + Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41))))));
    f40 = Math_fround(f43 * f40);
    f41 = Math_fround(f43 * f41);
    f42 = Math_fround(f43 * f42);
    f43 = Math_fround(Math_fround(f21 * f42) - Math_fround(f19 * f41));
    f39 = Math_fround(Math_fround(f19 * f40) - Math_fround(f20 * f42));
    f38 = Math_fround(Math_fround(f20 * f41) - Math_fround(f21 * f40));
    i8 = (HEAP32[i67 >> 2] | 0) + (i7 * 96 | 0) | 0;
    i9 = i134 + 768 + (i45 * 96 | 0) + 16 | 0;
    if (HEAP16[i9 >> 1] | 0) {
     i10 = 0;
     i1 = i6;
     while (1) {
      i6 = i1 + i46 | 0;
      f27 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 48 + (i10 * 12 | 0) >> 2]);
      f28 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 48 + (i10 * 12 | 0) + 4 >> 2]);
      f29 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 48 + (i10 * 12 | 0) + 8 >> 2]);
      f35 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 72 + (i10 * 12 | 0) >> 2]);
      f36 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 72 + (i10 * 12 | 0) + 4 >> 2]);
      f37 = Math_fround(HEAPF32[i134 + 768 + (i45 * 96 | 0) + 72 + (i10 * 12 | 0) + 8 >> 2]);
      HEAP32[i1 + 80 >> 2] = i8;
      HEAP32[i1 + i47 >> 2] = i8;
      f24 = Math_fround(Math_fround(Math_fround(f123 * f27) + Math_fround(f124 * f28)) + Math_fround(f125 * f29));
      f25 = Math_fround(Math_fround(Math_fround(f123 * f24) + Math_fround(Math_fround(f68 * f27) + Math_fround(f126 * Math_fround(Math_fround(f124 * f29) - Math_fround(f125 * f28))))) * Math_fround(2.0));
      f26 = Math_fround(Math_fround(Math_fround(f124 * f24) + Math_fround(Math_fround(f68 * f28) + Math_fround(f126 * Math_fround(Math_fround(f125 * f27) - Math_fround(f123 * f29))))) * Math_fround(2.0));
      f24 = Math_fround(Math_fround(Math_fround(Math_fround(f68 * f29) + Math_fround(f126 * Math_fround(Math_fround(f123 * f28) - Math_fround(f124 * f27)))) + Math_fround(f125 * f24)) * Math_fround(2.0));
      f27 = Math_fround(Math_fround(Math_fround(f111 * f35) + Math_fround(f112 * f36)) + Math_fround(f113 * f37));
      f28 = Math_fround(Math_fround(Math_fround(f111 * f27) + Math_fround(Math_fround(f69 * f35) + Math_fround(f114 * Math_fround(Math_fround(f112 * f37) - Math_fround(f113 * f36))))) * Math_fround(2.0));
      f29 = Math_fround(Math_fround(Math_fround(f112 * f27) + Math_fround(Math_fround(f69 * f36) + Math_fround(f114 * Math_fround(Math_fround(f113 * f35) - Math_fround(f111 * f37))))) * Math_fround(2.0));
      f27 = Math_fround(Math_fround(Math_fround(Math_fround(f69 * f37) + Math_fround(f114 * Math_fround(Math_fround(f111 * f36) - Math_fround(f112 * f35)))) + Math_fround(f113 * f27)) * Math_fround(2.0));
      f35 = Math_fround(Math_fround(f127 + f25) - Math_fround(f115 + f28));
      f36 = Math_fround(Math_fround(f128 + f26) - Math_fround(f116 + f29));
      f37 = Math_fround(Math_fround(f110 + f24) - Math_fround(f101 + f27));
      f2 = Math_fround(Math_fround(f42 * f26) - Math_fround(f41 * f24));
      f3 = Math_fround(Math_fround(f40 * f24) - Math_fround(f42 * f25));
      f4 = Math_fround(Math_fround(f41 * f25) - Math_fround(f40 * f26));
      f5 = Math_fround(Math_fround(f42 * f29) - Math_fround(f41 * f27));
      f14 = Math_fround(Math_fround(f40 * f27) - Math_fround(f42 * f28));
      f15 = Math_fround(Math_fround(f41 * f28) - Math_fround(f40 * f29));
      f16 = Math_fround(Math_fround(f79 * f4) + Math_fround(Math_fround(f73 * f2) + Math_fround(f76 * f3)));
      f17 = Math_fround(Math_fround(f80 * f4) + Math_fround(Math_fround(f74 * f2) + Math_fround(f77 * f3)));
      f18 = Math_fround(Math_fround(f81 * f4) + Math_fround(Math_fround(f75 * f2) + Math_fround(f78 * f3)));
      f19 = Math_fround(Math_fround(f88 * f15) + Math_fround(Math_fround(f82 * f5) + Math_fround(f85 * f14)));
      f20 = Math_fround(Math_fround(f89 * f15) + Math_fround(Math_fround(f83 * f5) + Math_fround(f86 * f14)));
      f21 = Math_fround(Math_fround(f90 * f15) + Math_fround(Math_fround(f84 * f5) + Math_fround(f87 * f14)));
      f22 = Math_fround(Math_fround(f119 + Math_fround(Math_fround(f4 * f18) + Math_fround(Math_fround(f2 * f16) + Math_fround(f3 * f17)))) + Math_fround(f120 + Math_fround(Math_fround(f15 * f21) + Math_fround(Math_fround(f5 * f19) + Math_fround(f14 * f20)))));
      i138 = f22 > Math_fround(0.0);
      f22 = Math_fround(Math_fround(.800000011) / f22);
      i137 = HEAPU16[i134 + ((HEAP32[i44 >> 2] | 0) * 12 | 0) >> 1] | 0;
      f139 = Math_fround(HEAPF32[i133 + (i137 << 6) + 32 >> 2]);
      f23 = Math_fround(HEAPF32[i133 + (i137 << 6) + 36 >> 2]);
      f23 = Math_fround(Math_fround(Math_fround(f40 * f139) + Math_fround(f41 * f23)) + Math_fround(f42 * Math_fround(HEAPF32[i133 + (i137 << 6) + 40 >> 2])));
      HEAPF32[i1 >> 2] = f40;
      HEAPF32[i1 + 4 >> 2] = f41;
      HEAPF32[i1 + 8 >> 2] = f42;
      HEAP32[i1 + 12 >> 2] = 0;
      i138 = i138 ? (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      HEAPF32[i1 + 16 >> 2] = f2;
      HEAPF32[i1 + 20 >> 2] = f3;
      HEAPF32[i1 + 24 >> 2] = f4;
      HEAP32[i1 + 28 >> 2] = i138;
      f22 = Math_fround(Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f40 * f35) + Math_fround(f41 * f36))) * f135);
      HEAPF32[i1 + 32 >> 2] = f5;
      HEAPF32[i1 + 36 >> 2] = f14;
      HEAPF32[i1 + 40 >> 2] = f15;
      HEAPF32[i1 + 44 >> 2] = f22;
      HEAPF32[i1 + 48 >> 2] = f16;
      HEAPF32[i1 + 52 >> 2] = f17;
      HEAPF32[i1 + 56 >> 2] = f18;
      HEAP32[i1 + 60 >> 2] = 0;
      f20 = Math_fround(-f20);
      f22 = Math_fround(-f21);
      HEAPF32[i1 + 64 >> 2] = Math_fround(-f19);
      HEAPF32[i1 + 68 >> 2] = f20;
      HEAPF32[i1 + 72 >> 2] = f22;
      HEAPF32[i1 + 76 >> 2] = f23;
      f23 = Math_fround(Math_fround(f38 * f26) - Math_fround(f39 * f24));
      f22 = Math_fround(Math_fround(f43 * f24) - Math_fround(f38 * f25));
      f20 = Math_fround(Math_fround(f39 * f25) - Math_fround(f43 * f26));
      f21 = Math_fround(Math_fround(f38 * f29) - Math_fround(f39 * f27));
      f19 = Math_fround(Math_fround(f43 * f27) - Math_fround(f38 * f28));
      f2 = Math_fround(Math_fround(f39 * f28) - Math_fround(f43 * f29));
      f3 = Math_fround(Math_fround(f79 * f20) + Math_fround(Math_fround(f73 * f23) + Math_fround(f76 * f22)));
      f4 = Math_fround(Math_fround(f80 * f20) + Math_fround(Math_fround(f74 * f23) + Math_fround(f77 * f22)));
      f5 = Math_fround(Math_fround(f81 * f20) + Math_fround(Math_fround(f75 * f23) + Math_fround(f78 * f22)));
      f14 = Math_fround(Math_fround(f88 * f2) + Math_fround(Math_fround(f82 * f21) + Math_fround(f85 * f19)));
      f15 = Math_fround(Math_fround(f89 * f2) + Math_fround(Math_fround(f83 * f21) + Math_fround(f86 * f19)));
      f16 = Math_fround(Math_fround(f90 * f2) + Math_fround(Math_fround(f84 * f21) + Math_fround(f87 * f19)));
      f17 = Math_fround(Math_fround(f119 + Math_fround(Math_fround(f20 * f5) + Math_fround(Math_fround(f23 * f3) + Math_fround(f22 * f4)))) + Math_fround(f120 + Math_fround(Math_fround(f2 * f16) + Math_fround(Math_fround(f21 * f14) + Math_fround(f19 * f15)))));
      i138 = f17 > Math_fround(0.0);
      f17 = Math_fround(Math_fround(.800000011) / f17);
      i137 = HEAPU16[i134 + ((HEAP32[i44 >> 2] | 0) * 12 | 0) >> 1] | 0;
      f139 = Math_fround(HEAPF32[i133 + (i137 << 6) + 32 >> 2]);
      f18 = Math_fround(HEAPF32[i133 + (i137 << 6) + 36 >> 2]);
      f18 = Math_fround(Math_fround(Math_fround(f43 * f139) + Math_fround(f39 * f18)) + Math_fround(f38 * Math_fround(HEAPF32[i133 + (i137 << 6) + 40 >> 2])));
      HEAPF32[i1 + i93 >> 2] = f43;
      HEAPF32[i1 + i48 >> 2] = f39;
      HEAPF32[i1 + i49 >> 2] = f38;
      HEAP32[i1 + i50 >> 2] = 0;
      i138 = i138 ? (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      HEAPF32[i1 + i63 >> 2] = f23;
      HEAPF32[i1 + i51 >> 2] = f22;
      HEAPF32[i1 + i52 >> 2] = f20;
      HEAP32[i1 + i53 >> 2] = i138;
      f37 = Math_fround(Math_fround(Math_fround(f38 * f37) + Math_fround(Math_fround(f43 * f35) + Math_fround(f39 * f36))) * f135);
      HEAPF32[i1 + i64 >> 2] = f21;
      HEAPF32[i1 + i54 >> 2] = f19;
      HEAPF32[i1 + i55 >> 2] = f2;
      HEAPF32[i1 + i56 >> 2] = f37;
      HEAPF32[i1 + i65 >> 2] = f3;
      HEAPF32[i1 + i57 >> 2] = f4;
      HEAPF32[i1 + i58 >> 2] = f5;
      HEAP32[i1 + i59 >> 2] = 0;
      f37 = Math_fround(-f15);
      f139 = Math_fround(-f16);
      HEAPF32[i1 + i66 >> 2] = Math_fround(-f14);
      HEAPF32[i1 + i60 >> 2] = f37;
      HEAPF32[i1 + i61 >> 2] = f139;
      HEAPF32[i1 + i62 >> 2] = f18;
      i10 = i10 + 1 | 0;
      if (i10 >>> 0 >= (HEAPU16[i9 >> 1] | 0) >>> 0) break; else i1 = i6;
     }
    }
   }
   i1 = HEAP32[i91 >> 2] | 0;
   i7 = i7 + 1 | 0;
  }
  i45 = i45 + 1 | 0;
  if (i45 >>> 0 >= i1 >>> 0) break; else i13 = i6;
 }
 return;
}

function __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i50, i15, i7, i8, i1, i16, i9, i10, i3, f13, f2, f4, f11, i5, i6, i17, i18, i19, i12, i14, i20, i21, i22) {
 i50 = i50 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 f13 = Math_fround(f13);
 f2 = Math_fround(f2);
 f4 = Math_fround(f4);
 f11 = Math_fround(f11);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i51;
 i23 = i48 + 4 | 0;
 HEAP32[i23 >> 2] = i7;
 i24 = i48 + 8 | 0;
 HEAP32[i24 >> 2] = i8;
 i45 = i48 + 20 | 0;
 HEAP32[i45 >> 2] = i9;
 i49 = i48 + 24 | 0;
 HEAP32[i49 >> 2] = i10;
 i44 = i48 + 64 | 0;
 HEAP32[i44 >> 2] = i6;
 HEAPF32[i48 + 32 >> 2] = f13;
 HEAPF32[i48 + 36 >> 2] = f2;
 HEAPF32[i48 + 40 >> 2] = f4;
 HEAPF32[i48 + 44 >> 2] = f11;
 if (!i5) {
  f55 = Math_fround(i7 | 0);
  f54 = Math_fround(f4 - f13);
  f52 = Math_fround(Math_fround(Math_fround(i9 | 0) / f55) / f54);
  HEAPF32[i48 + 56 >> 2] = f52;
  f53 = Math_fround(i8 | 0);
  f11 = Math_fround(f11 - f2);
  f4 = Math_fround(Math_fround(Math_fround(i10 | 0) / f53) / f11);
  HEAPF32[i48 + 60 >> 2] = f4;
  HEAPF32[i48 + 48 >> 2] = Math_fround(Math_fround(f55 * f13) / f54);
  HEAPF32[i48 + 52 >> 2] = Math_fround(Math_fround(f53 * f2) / f11);
  f2 = f52;
 } else {
  i46 = HEAP32[i5 >> 2] | 0;
  HEAP32[i48 + 56 >> 2] = i46;
  i47 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i48 + 60 >> 2] = i47;
  HEAP32[i48 + 48 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i48 + 52 >> 2] = HEAP32[i5 + 12 >> 2];
  f2 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 i10 = f2 > Math_fround(1.0);
 i5 = f4 > Math_fround(1.0);
 i9 = i48 + 80 | 0;
 HEAP32[i9 >> 2] = (i12 | 0) == 0 ? (i10 ? 4 : 5) : i12;
 i10 = i48 + 84 | 0;
 HEAP32[i10 >> 2] = (i14 | 0) == 0 ? (i5 ? 4 : 5) : i14;
 i5 = __ZL23stbir__calculate_memoryP11stbir__info(i48) | 0;
 i46 = i50 + 8 | 0;
 i47 = mftCall_iii(HEAP32[i50 >> 2] | 0, i5 | 0, HEAP32[i46 >> 2] | 0) | 0;
 if (!i47) {
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i6 = __ZL23stbir__calculate_memoryP11stbir__info(i48) | 0;
 i7 = HEAP32[i44 >> 2] | 0;
 if (!i1) {
  i1 = Math_imul(HEAP32[i23 >> 2] | 0, i7) | 0;
  i1 = Math_imul(i1, HEAPU8[gb + 581912 + i19 >> 0] | 0) | 0;
 }
 if (!i3) {
  i3 = Math_imul(HEAP32[i45 >> 2] | 0, i7) | 0;
  i3 = Math_imul(i3, HEAPU8[gb + 581912 + i19 >> 0] | 0) | 0;
 }
 L14 : do if (i7 >>> 0 > 64 | (HEAP32[i9 >> 2] | 0) >>> 0 > 6 | (HEAP32[i10 >> 2] | 0) >>> 0 > 6) i1 = 0; else if (i6 >>> 0 > i5 >>> 0 | (i7 | 0) <= (i17 | 0)) i1 = 0; else {
  _memset(i47 | 0, 0, i5 | 0) | 0;
  HEAP32[i48 >> 2] = i15;
  HEAP32[i48 + 12 >> 2] = i1;
  i43 = i48 + 16 | 0;
  HEAP32[i43 >> 2] = i16;
  i39 = i48 + 28 | 0;
  HEAP32[i39 >> 2] = i3;
  i41 = i48 + 68 | 0;
  HEAP32[i41 >> 2] = i17;
  HEAP32[i48 + 72 >> 2] = (i17 | 0) < 0 ? i18 | 3 : i18;
  i42 = i48 + 76 | 0;
  HEAP32[i42 >> 2] = i19;
  HEAP32[i48 + 88 >> 2] = i20;
  HEAP32[i48 + 92 >> 2] = i21;
  i38 = i48 + 96 | 0;
  HEAP32[i38 >> 2] = i22;
  i37 = i48 + 56 | 0;
  f2 = Math_fround(HEAPF32[i37 >> 2]);
  i40 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i9 >> 2] << 3) + 4 >> 2] | 0;
  if (i40) f2 = Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))); else f2 = Math_fround(+mftCall_ff(i1 | 0, +f2));
  HEAP32[i48 + 128 >> 2] = ~~Math_fround(Math_ceil(Math_fround(f2 * Math_fround(2.0))));
  i8 = i48 + 60 | 0;
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  i40 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i10 >> 2] << 3) + 4 >> 2] | 0;
  if (i40) f2 = Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))); else f2 = Math_fround(+mftCall_ff(i1 | 0, +f2));
  i35 = i48 + 132 | 0;
  HEAP32[i35 >> 2] = ~~Math_fround(Math_ceil(Math_fround(f2 * Math_fround(2.0))));
  f2 = Math_fround(HEAPF32[i37 >> 2]);
  i40 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i9 >> 2] << 3) + 4 >> 2] | 0;
  if (i40) f2 = Math_fround(Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))) * Math_fround(2.0)); else f2 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i1 | 0, +f2)) * Math_fround(2.0)) / f2);
  HEAP32[i48 + 136 >> 2] = ~~Math_fround(Math_ceil(Math_fround(f2)));
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  i40 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i10 >> 2] << 3) + 4 >> 2] | 0;
  if (i40) f2 = Math_fround(Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))) * Math_fround(2.0)); else f2 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i1 | 0, +f2)) * Math_fround(2.0)) / f2);
  i40 = i48 + 140 | 0;
  HEAP32[i40 >> 2] = ~~Math_fround(Math_ceil(Math_fround(f2)));
  f2 = Math_fround(HEAPF32[i37 >> 2]);
  i36 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i9 >> 2] << 3) + 4 >> 2] | 0;
  if (i36) f2 = Math_fround(Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))) * Math_fround(2.0)); else f2 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i1 | 0, +f2)) * Math_fround(2.0)) / f2);
  i3 = i48 + 144 | 0;
  HEAP32[i3 >> 2] = (~~Math_fround(Math_ceil(Math_fround(f2))) | 0) / 2 | 0;
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  i36 = f2 > Math_fround(1.0);
  i1 = HEAP32[gb + 71848 + (HEAP32[i10 >> 2] << 3) + 4 >> 2] | 0;
  if (i36) f2 = Math_fround(Math_fround(+mftCall_ff(i1 | 0, +Math_fround(Math_fround(1.0) / f2))) * Math_fround(2.0)); else f2 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i1 | 0, +f2)) * Math_fround(2.0)) / f2);
  i29 = i48 + 148 | 0;
  HEAP32[i29 >> 2] = (~~Math_fround(Math_ceil(Math_fround(f2))) | 0) / 2 | 0;
  i7 = HEAP32[i45 >> 2] | 0;
  i34 = i48 + 160 | 0;
  HEAP32[i34 >> 2] = Math_imul(i7 << 2, HEAP32[i44 >> 2] | 0) | 0;
  i6 = HEAP32[i23 >> 2] | 0;
  HEAP32[i48 + 116 >> 2] = (HEAP32[i3 >> 2] << 1) + i6;
  HEAP32[i48 + 100 >> 2] = i47;
  i5 = i47 + (HEAP32[i48 + 184 >> 2] | 0) | 0;
  HEAP32[i48 + 104 >> 2] = i5;
  i1 = i5 + (HEAP32[i48 + 188 >> 2] | 0) | 0;
  i32 = i48 + 108 | 0;
  HEAP32[i32 >> 2] = i1;
  i1 = i1 + (HEAP32[i48 + 192 >> 2] | 0) | 0;
  i33 = i48 + 112 | 0;
  HEAP32[i33 >> 2] = i1;
  i1 = i1 + (HEAP32[i48 + 196 >> 2] | 0) | 0;
  HEAP32[i48 + 120 >> 2] = i1;
  i36 = Math_fround(HEAPF32[i8 >> 2]) > Math_fround(1.0);
  i3 = HEAP32[i48 + 200 >> 2] | 0;
  if (i36) {
   HEAP32[i48 + 124 >> 2] = 0;
   i36 = i1 + i3 | 0;
   HEAP32[i48 + 176 >> 2] = i36;
   HEAP32[i48 + 180 >> 2] = i36 + (HEAP32[i48 + 208 >> 2] | 0);
  } else {
   i36 = i1 + i3 | 0;
   HEAP32[i48 + 124 >> 2] = i36;
   HEAP32[i48 + 176 >> 2] = i36 + (HEAP32[i48 + 204 >> 2] | 0);
   HEAP32[i48 + 180 >> 2] = 0;
  }
  i36 = i48 + 172 | 0;
  HEAP32[i36 >> 2] = -1;
  f55 = Math_fround(HEAPF32[i37 >> 2]);
  __ZL24stbir__calculate_filtersP11stbir__infoP19stbir__contributorsPf12stbir_filterffii(i47, i5, HEAP32[i9 >> 2] | 0, f55, Math_fround(HEAPF32[i48 + 48 >> 2]), i6, i7);
  f55 = Math_fround(HEAPF32[i8 >> 2]);
  i31 = i48 + 52 | 0;
  f11 = Math_fround(HEAPF32[i31 >> 2]);
  __ZL24stbir__calculate_filtersP11stbir__infoP19stbir__contributorsPf12stbir_filterffii(HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0, HEAP32[i10 >> 2] | 0, f55, f11, HEAP32[i24 >> 2] | 0, HEAP32[i49 >> 2] | 0);
  f11 = Math_fround(HEAPF32[i8 >> 2]);
  if (!(f11 > Math_fround(1.0))) {
   i27 = HEAP32[i49 >> 2] | 0;
   f4 = Math_fround(Math_fround(+mftCall_ff(HEAP32[gb + 71848 + (HEAP32[i10 >> 2] << 3) + 4 >> 2] | 0, +f11)) / f11);
   i1 = HEAP32[i29 >> 2] | 0;
   i23 = (HEAP32[i24 >> 2] | 0) + i1 | 0;
   i1 = 0 - i1 | 0;
   i28 = i48 + 176 | 0;
   if ((i23 | 0) > (i1 | 0)) {
    i24 = i48 + 164 | 0;
    i25 = i48 + 168 | 0;
    i26 = i48 + 124 | 0;
    do {
     f55 = Math_fround(HEAPF32[i31 >> 2]);
     f54 = Math_fround(Math_fround(i1 | 0) + Math_fround(.5));
     i3 = ~~+Math_floor(+(+Math_fround(Math_fround(f11 * Math_fround(f54 - f4)) - f55) + .5));
     i17 = ~~+Math_floor(+(+Math_fround(Math_fround(f11 * Math_fround(f4 + f54)) - f55) + -.5));
     L51 : do if ((i3 | 0) < (i27 | 0) & (i17 | 0) > -1) {
      i7 = HEAP32[i39 >> 2] | 0;
      i8 = HEAP32[i44 >> 2] | 0;
      i9 = HEAP32[i41 >> 2] | 0;
      i10 = HEAP32[i45 >> 2] | 0;
      i12 = HEAP32[i43 >> 2] | 0;
      i14 = (HEAP32[i42 >> 2] << 1) + (HEAP32[i38 >> 2] | 0) | 0;
      i15 = HEAP32[i28 >> 2] | 0;
      i16 = (HEAP32[i34 >> 2] | 0) >>> 2;
      i6 = HEAP32[i36 >> 2] | 0;
      L53 : do if ((i6 | 0) > -1) {
       i5 = HEAP32[i24 >> 2] | 0;
       if ((i5 | 0) >= (i3 | 0)) break;
       while (1) {
        if ((i5 | 0) > -1 ? (i5 | 0) < (HEAP32[i49 >> 2] | 0) : 0) {
         __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii(i48, i10, i12 + (Math_imul(i5, i7) | 0) | 0, i15 + ((Math_imul(i6, i16) | 0) << 2) | 0, i8, i9, i14);
         i5 = HEAP32[i24 >> 2] | 0;
        }
        if ((i5 | 0) == (HEAP32[i25 >> 2] | 0)) break;
        i5 = i5 + 1 | 0;
        HEAP32[i24 >> 2] = i5;
        i6 = ((HEAP32[i36 >> 2] | 0) + 1 | 0) % (HEAP32[i40 >> 2] | 0) | 0;
        HEAP32[i36 >> 2] = i6;
        if ((i5 | 0) >= (i3 | 0)) break L53;
       }
       HEAP32[i36 >> 2] = -1;
       HEAP32[i24 >> 2] = 0;
       HEAP32[i25 >> 2] = 0;
      } while (0);
      __ZL22stbir__decode_scanlineP11stbir__infoi(i48, i1);
      _memset(HEAP32[i26 >> 2] | 0, 0, Math_imul(HEAP32[i45 >> 2] << 2, HEAP32[i44 >> 2] | 0) | 0) | 0;
      i30 = Math_fround(HEAPF32[i37 >> 2]) > Math_fround(1.0);
      i5 = HEAP32[i26 >> 2] | 0;
      if (i30) __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf(i48, i5); else __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf(i48, i5);
      if ((HEAP32[i36 >> 2] | 0) < 0) {
       HEAP32[i36 >> 2] = 0;
       HEAP32[i24 >> 2] = i3;
       _memset(HEAP32[i28 >> 2] | 0, 0, HEAP32[i34 >> 2] | 0) | 0;
       HEAP32[i25 >> 2] = i3;
      } else i3 = HEAP32[i25 >> 2] | 0;
      if ((i17 | 0) > (i3 | 0)) do {
       i3 = i3 + 1 | 0;
       i5 = HEAP32[i36 >> 2] | 0;
       if ((i5 | 0) < 0) {
        HEAP32[i36 >> 2] = 0;
        HEAP32[i24 >> 2] = i3;
        i5 = 0;
       } else i5 = (i3 + i5 - (HEAP32[i24 >> 2] | 0) | 0) % (HEAP32[i40 >> 2] | 0) | 0;
       i30 = HEAP32[i34 >> 2] | 0;
       _memset((HEAP32[i28 >> 2] | 0) + ((Math_imul(i30 >>> 2, i5) | 0) << 2) | 0, 0, i30 | 0) | 0;
       HEAP32[i25 >> 2] = i3;
      } while ((i3 | 0) != (i17 | 0));
      i15 = HEAP32[i45 >> 2] | 0;
      i22 = HEAP32[i32 >> 2] | 0;
      i16 = HEAP32[i33 >> 2] | 0;
      i17 = HEAP32[i44 >> 2] | 0;
      i18 = HEAP32[i40 >> 2] | 0;
      i19 = HEAP32[i26 >> 2] | 0;
      i3 = (HEAP32[i29 >> 2] | 0) + i1 | 0;
      i20 = HEAP32[i28 >> 2] | 0;
      i21 = (HEAP32[i34 >> 2] | 0) >>> 2;
      i5 = HEAP32[i22 + (i3 << 3) >> 2] | 0;
      i22 = HEAP32[i22 + (i3 << 3) + 4 >> 2] | 0;
      if ((i5 | 0) > (i22 | 0)) break;
      i9 = (Math_imul(HEAP32[i35 >> 2] | 0, i3) | 0) - i5 | 0;
      i10 = (HEAP32[i36 >> 2] | 0) - (HEAP32[i24 >> 2] | 0) | 0;
      i12 = (i15 | 0) > 0;
      i14 = (i17 | 0) < 1 | i12 ^ 1;
      while (1) {
       f2 = Math_fround(HEAPF32[i16 + (i9 + i5 << 2) >> 2]);
       i8 = i20 + ((Math_imul((i10 + i5 | 0) % (i18 | 0) | 0, i21) | 0) << 2) | 0;
       L82 : do switch (i17 | 0) {
       case 1:
        {
         if (i12) i3 = 0; else break L82;
         do {
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i3 << 2) >> 2]));
          i30 = i8 + (i3 << 2) | 0;
          HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f55);
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i15 | 0));
         break;
        }
       case 2:
        {
         if (i12) i3 = 0; else break L82;
         do {
          i30 = i3 << 1;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i7 = i8 + (i30 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i30 = i30 | 1;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i30 = i8 + (i30 << 2) | 0;
          HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f55);
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i15 | 0));
         break;
        }
       case 3:
        {
         if (i12) i3 = 0; else break L82;
         do {
          i30 = i3 * 3 | 0;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i7 = i8 + (i30 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i7 = i30 + 1 | 0;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i7 << 2) >> 2]));
          i7 = i8 + (i7 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i30 = i30 + 2 | 0;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i30 = i8 + (i30 << 2) | 0;
          HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f55);
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i15 | 0));
         break;
        }
       case 4:
        {
         if (i12) i3 = 0; else break L82;
         do {
          i30 = i3 << 2;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i7 = i8 + (i30 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i7 = i30 | 1;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i7 << 2) >> 2]));
          i7 = i8 + (i7 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i7 = i30 | 2;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i7 << 2) >> 2]));
          i7 = i8 + (i7 << 2) | 0;
          HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f55);
          i30 = i30 | 3;
          f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
          i30 = i8 + (i30 << 2) | 0;
          HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f55);
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i15 | 0));
         break;
        }
       default:
        {
         if (i14) break L82; else i6 = 0;
         do {
          i7 = Math_imul(i6, i17) | 0;
          i3 = 0;
          do {
           i30 = i3 + i7 | 0;
           f55 = Math_fround(f2 * Math_fround(HEAPF32[i19 + (i30 << 2) >> 2]));
           i30 = i8 + (i30 << 2) | 0;
           HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f55);
           i3 = i3 + 1 | 0;
          } while ((i3 | 0) != (i17 | 0));
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i15 | 0));
        }
       } while (0);
       if ((i5 | 0) < (i22 | 0)) i5 = i5 + 1 | 0; else break L51;
      }
     } while (0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i23 | 0));
   }
   i18 = HEAP32[i49 >> 2] | 0;
   i17 = HEAP32[i39 >> 2] | 0;
   i16 = HEAP32[i44 >> 2] | 0;
   i15 = HEAP32[i41 >> 2] | 0;
   i14 = HEAP32[i45 >> 2] | 0;
   i12 = HEAP32[i43 >> 2] | 0;
   i10 = (HEAP32[i42 >> 2] << 1) + (HEAP32[i38 >> 2] | 0) | 0;
   i9 = HEAP32[i28 >> 2] | 0;
   i6 = (HEAP32[i34 >> 2] | 0) >>> 2;
   i3 = HEAP32[i36 >> 2] | 0;
   if ((i3 | 0) <= -1) {
    i1 = 1;
    break;
   }
   i7 = i48 + 164 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) >= (i18 | 0)) {
    i1 = 1;
    break;
   }
   i8 = i48 + 168 | 0;
   i5 = i18;
   while (1) {
    if ((i1 | 0) > -1 & (i1 | 0) < (i5 | 0)) {
     __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii(i48, i14, i12 + (Math_imul(i1, i17) | 0) | 0, i9 + ((Math_imul(i3, i6) | 0) << 2) | 0, i16, i15, i10);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (HEAP32[i8 >> 2] | 0)) break;
    i1 = i1 + 1 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = ((HEAP32[i36 >> 2] | 0) + 1 | 0) % (HEAP32[i40 >> 2] | 0) | 0;
    HEAP32[i36 >> 2] = i3;
    if ((i1 | 0) >= (i18 | 0)) {
     i1 = 1;
     break L14;
    }
    i5 = HEAP32[i49 >> 2] | 0;
   }
   HEAP32[i36 >> 2] = -1;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 1;
   break;
  }
  f4 = Math_fround(f11 * Math_fround(+mftCall_ff(HEAP32[gb + 71848 + (HEAP32[i10 >> 2] << 3) + 4 >> 2] | 0, +Math_fround(Math_fround(1.0) / f11))));
  if ((HEAP32[i49 >> 2] | 0) > 0) {
   i26 = i48 + 164 | 0;
   i27 = i48 + 168 | 0;
   i28 = i48 + 176 | 0;
   i29 = i48 + 180 | 0;
   i25 = 0;
   while (1) {
    f54 = Math_fround(HEAPF32[i31 >> 2]);
    f55 = Math_fround(Math_fround(i25 | 0) + Math_fround(.5));
    i7 = ~~+Math_floor(+(+Math_fround(Math_fround(f54 + Math_fround(f55 - f4)) / f11) + .5));
    i8 = ~~+Math_floor(+(+Math_fround(Math_fround(f54 + Math_fround(f4 + f55)) / f11) + -.5));
    i3 = HEAP32[i36 >> 2] | 0;
    do if ((i3 | 0) > -1) {
     i1 = HEAP32[i26 >> 2] | 0;
     if ((i7 | 0) > (i1 | 0)) {
      i5 = HEAP32[i27 >> 2] | 0;
      i6 = HEAP32[i40 >> 2] | 0;
      while (1) {
       if ((i1 | 0) == (i5 | 0)) {
        i30 = 39;
        break;
       }
       i1 = i1 + 1 | 0;
       HEAP32[i26 >> 2] = i1;
       i3 = (i3 + 1 | 0) % (i6 | 0) | 0;
       HEAP32[i36 >> 2] = i3;
       if ((i7 | 0) <= (i1 | 0)) {
        i30 = 41;
        break;
       }
      }
      if ((i30 | 0) == 39) {
       HEAP32[i36 >> 2] = -1;
       HEAP32[i26 >> 2] = 0;
       HEAP32[i27 >> 2] = 0;
       i30 = 42;
       break;
      } else if ((i30 | 0) == 41) {
       i30 = 0;
       if ((i3 | 0) < 0) {
        i30 = 42;
        break;
       } else break;
      }
     }
    } else i30 = 42; while (0);
    do if ((i30 | 0) == 42) {
     i30 = 0;
     __ZL22stbir__decode_scanlineP11stbir__infoi(i48, i7);
     i3 = Math_fround(HEAPF32[i37 >> 2]) > Math_fround(1.0);
     i1 = HEAP32[i36 >> 2] | 0;
     if ((i1 | 0) < 0) {
      HEAP32[i36 >> 2] = 0;
      HEAP32[i26 >> 2] = i7;
      i1 = 0;
     } else i1 = (i1 + 1 + (HEAP32[i27 >> 2] | 0) - (HEAP32[i26 >> 2] | 0) | 0) % (HEAP32[i40 >> 2] | 0) | 0;
     i24 = HEAP32[i34 >> 2] | 0;
     i1 = (HEAP32[i28 >> 2] | 0) + ((Math_imul(i24 >>> 2, i1) | 0) << 2) | 0;
     _memset(i1 | 0, 0, i24 | 0) | 0;
     HEAP32[i27 >> 2] = i7;
     if (i3) {
      __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf(i48, i1);
      break;
     } else {
      __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf(i48, i1);
      break;
     }
    } while (0);
    i1 = HEAP32[i27 >> 2] | 0;
    if ((i8 | 0) > (i1 | 0)) do {
     i3 = i1 + 1 | 0;
     __ZL22stbir__decode_scanlineP11stbir__infoi(i48, i3);
     i5 = Math_fround(HEAPF32[i37 >> 2]) > Math_fround(1.0);
     i1 = HEAP32[i36 >> 2] | 0;
     if ((i1 | 0) < 0) {
      HEAP32[i36 >> 2] = 0;
      HEAP32[i26 >> 2] = i3;
      i1 = 0;
     } else i1 = (i1 + 1 + (HEAP32[i27 >> 2] | 0) - (HEAP32[i26 >> 2] | 0) | 0) % (HEAP32[i40 >> 2] | 0) | 0;
     i24 = HEAP32[i34 >> 2] | 0;
     i1 = (HEAP32[i28 >> 2] | 0) + ((Math_imul(i24 >>> 2, i1) | 0) << 2) | 0;
     _memset(i1 | 0, 0, i24 | 0) | 0;
     HEAP32[i27 >> 2] = i3;
     if (i5) __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf(i48, i1); else __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf(i48, i1);
     i1 = HEAP32[i27 >> 2] | 0;
    } while ((i8 | 0) > (i1 | 0));
    i10 = HEAP32[i45 >> 2] | 0;
    i23 = HEAP32[i32 >> 2] | 0;
    i12 = HEAP32[i33 >> 2] | 0;
    i14 = HEAP32[i44 >> 2] | 0;
    i15 = HEAP32[i41 >> 2] | 0;
    i16 = HEAP32[i40 >> 2] | 0;
    i17 = HEAP32[i43 >> 2] | 0;
    i18 = HEAP32[i29 >> 2] | 0;
    i19 = (HEAP32[i42 >> 2] << 1) + (HEAP32[i38 >> 2] | 0) | 0;
    i20 = HEAP32[i28 >> 2] | 0;
    i1 = HEAP32[i36 >> 2] | 0;
    i3 = HEAP32[i26 >> 2] | 0;
    i21 = (HEAP32[i34 >> 2] | 0) >>> 2;
    i22 = Math_imul(HEAP32[i35 >> 2] | 0, i25) | 0;
    i5 = HEAP32[i23 + (i25 << 3) >> 2] | 0;
    i23 = HEAP32[i23 + (i25 << 3) + 4 >> 2] | 0;
    i24 = Math_imul(HEAP32[i39 >> 2] | 0, i25) | 0;
    _memset(i18 | 0, 0, Math_imul(i10 << 2, i14) | 0) | 0;
    L149 : do switch (i14 | 0) {
    case 1:
     {
      if ((i5 | 0) > (i23 | 0)) break L149;
      i7 = i1 - i3 | 0;
      if ((i10 | 0) > 0) {
       i3 = i5;
       i5 = 0;
      } else break L149;
      while (1) {
       i6 = i20 + ((Math_imul((i7 + i3 | 0) % (i16 | 0) | 0, i21) | 0) << 2) | 0;
       f2 = Math_fround(HEAPF32[i12 + (i5 + i22 << 2) >> 2]);
       i1 = 0;
       do {
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]));
        i9 = i18 + (i1 << 2) | 0;
        HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f55);
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i10 | 0));
       if ((i3 | 0) < (i23 | 0)) {
        i3 = i3 + 1 | 0;
        i5 = i5 + 1 | 0;
       } else break;
      }
      break;
     }
    case 2:
     {
      if ((i5 | 0) > (i23 | 0)) break L149;
      i7 = i1 - i3 | 0;
      if ((i10 | 0) > 0) {
       i1 = i5;
       i3 = 0;
      } else break L149;
      while (1) {
       i6 = i20 + ((Math_imul((i7 + i1 | 0) % (i16 | 0) | 0, i21) | 0) << 2) | 0;
       f2 = Math_fround(HEAPF32[i12 + (i3 + i22 << 2) >> 2]);
       i5 = 0;
       do {
        i9 = i5 << 1;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i8 = i18 + (i9 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i9 = i9 | 1;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i9 = i18 + (i9 << 2) | 0;
        HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f55);
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i10 | 0));
       if ((i1 | 0) < (i23 | 0)) {
        i1 = i1 + 1 | 0;
        i3 = i3 + 1 | 0;
       } else break;
      }
      break;
     }
    case 3:
     {
      if ((i5 | 0) > (i23 | 0)) break L149;
      i7 = i1 - i3 | 0;
      if ((i10 | 0) > 0) {
       i1 = i5;
       i3 = 0;
      } else break L149;
      while (1) {
       i6 = i20 + ((Math_imul((i7 + i1 | 0) % (i16 | 0) | 0, i21) | 0) << 2) | 0;
       f2 = Math_fround(HEAPF32[i12 + (i3 + i22 << 2) >> 2]);
       i5 = 0;
       do {
        i9 = i5 * 3 | 0;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i8 = i18 + (i9 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i8 = i9 + 1 | 0;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]));
        i8 = i18 + (i8 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i9 = i9 + 2 | 0;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i9 = i18 + (i9 << 2) | 0;
        HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f55);
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i10 | 0));
       if ((i1 | 0) < (i23 | 0)) {
        i1 = i1 + 1 | 0;
        i3 = i3 + 1 | 0;
       } else break;
      }
      break;
     }
    case 4:
     {
      if ((i5 | 0) > (i23 | 0)) break L149;
      i7 = i1 - i3 | 0;
      if ((i10 | 0) > 0) {
       i1 = i5;
       i3 = 0;
      } else break L149;
      while (1) {
       i6 = i20 + ((Math_imul((i7 + i1 | 0) % (i16 | 0) | 0, i21) | 0) << 2) | 0;
       f2 = Math_fround(HEAPF32[i12 + (i3 + i22 << 2) >> 2]);
       i5 = 0;
       do {
        i9 = i5 << 2;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i8 = i18 + (i9 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i8 = i9 | 1;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]));
        i8 = i18 + (i8 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i8 = i9 | 2;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i8 << 2) >> 2]));
        i8 = i18 + (i8 << 2) | 0;
        HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f55);
        i9 = i9 | 3;
        f55 = Math_fround(f2 * Math_fround(HEAPF32[i6 + (i9 << 2) >> 2]));
        i9 = i18 + (i9 << 2) | 0;
        HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f55);
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i10 | 0));
       if ((i1 | 0) < (i23 | 0)) {
        i1 = i1 + 1 | 0;
        i3 = i3 + 1 | 0;
       } else break;
      }
      break;
     }
    default:
     {
      if ((i5 | 0) > (i23 | 0)) break L149;
      i9 = i1 - i3 | 0;
      if ((i10 | 0) > 0 & (i14 | 0) > 0) i6 = 0; else break L149;
      while (1) {
       i7 = i20 + ((Math_imul((i9 + i5 | 0) % (i16 | 0) | 0, i21) | 0) << 2) | 0;
       f2 = Math_fround(HEAPF32[i12 + (i6 + i22 << 2) >> 2]);
       i3 = 0;
       do {
        i8 = Math_imul(i3, i14) | 0;
        i1 = 0;
        do {
         i56 = i1 + i8 | 0;
         f55 = Math_fround(f2 * Math_fround(HEAPF32[i7 + (i56 << 2) >> 2]));
         i56 = i18 + (i56 << 2) | 0;
         HEAPF32[i56 >> 2] = Math_fround(Math_fround(HEAPF32[i56 >> 2]) + f55);
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != (i14 | 0));
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i10 | 0));
       if ((i5 | 0) < (i23 | 0)) {
        i5 = i5 + 1 | 0;
        i6 = i6 + 1 | 0;
       } else break;
      }
     }
    } while (0);
    __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii(i48, i10, i17 + i24 | 0, i18, i14, i15, i19);
    i25 = i25 + 1 | 0;
    if ((i25 | 0) >= (HEAP32[i49 >> 2] | 0)) {
     i1 = 1;
     break L14;
    }
   }
  } else i1 = 1;
 } while (0);
 mftCall_vii(HEAP32[i50 + 4 >> 2] | 0, i47 | 0, HEAP32[i46 >> 2] | 0);
 i56 = i1;
 STACKTOP = i51;
 return i56 | 0;
}

function __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 64 | 0;
 i21 = i23;
 i20 = i2;
 L1 : while (1) {
  i15 = i20;
  i19 = i20 + -92 | 0;
  i18 = i20 + -64 | 0;
  while (1) {
   L5 : while (1) {
    i12 = i1;
    i2 = i15 - i12 | 0;
    switch ((i2 | 0) / 92 | 0 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 7;
      break L1;
     }
    case 4:
     {
      i16 = 15;
      break L1;
     }
    case 5:
     {
      i16 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 84;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 2852) {
     i16 = 22;
     break L1;
    }
    i6 = (i2 >>> 0) / 184 | 0;
    i11 = i1 + (i6 * 92 | 0) | 0;
    do if ((i2 | 0) > 91908) {
     i9 = (i2 >>> 0) / 368 | 0;
     i10 = i1 + (i9 * 92 | 0) | 0;
     i5 = i11 + (i9 * 92 | 0) | 0;
     i2 = __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i1, i10, i11, i5, i17) | 0;
     f8 = Math_fround(HEAPF32[i18 >> 2]);
     i4 = i5 + 28 | 0;
     if (!(f8 < Math_fround(HEAPF32[i4 >> 2]))) {
      i3 = i1 + (i6 * 92 | 0) + 28 | 0;
      break;
     }
     i3 = i22;
     i13 = i5;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i5;
     i13 = i19;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i19;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i2 + 1 | 0;
     f8 = Math_fround(HEAPF32[i4 >> 2]);
     i6 = i1 + (i6 * 92 | 0) + 28 | 0;
     if (f8 < Math_fround(HEAPF32[i6 >> 2])) {
      i3 = i22;
      i13 = i11;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i11;
      i13 = i5;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i5;
      i13 = i22;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i2 + 2 | 0;
      f8 = Math_fround(HEAPF32[i6 >> 2]);
      i4 = i1 + (i9 * 92 | 0) + 28 | 0;
      if (f8 < Math_fround(HEAPF32[i4 >> 2])) {
       i3 = i22;
       i13 = i10;
       i14 = i3 + 92 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
        i3 = i3 + 4 | 0;
        i13 = i13 + 4 | 0;
       } while ((i3 | 0) < (i14 | 0));
       i3 = i10;
       i13 = i11;
       i14 = i3 + 92 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
        i3 = i3 + 4 | 0;
        i13 = i13 + 4 | 0;
       } while ((i3 | 0) < (i14 | 0));
       i3 = i11;
       i13 = i22;
       i14 = i3 + 92 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
        i3 = i3 + 4 | 0;
        i13 = i13 + 4 | 0;
       } while ((i3 | 0) < (i14 | 0));
       i3 = i2 + 3 | 0;
       f8 = Math_fround(HEAPF32[i4 >> 2]);
       if (f8 < Math_fround(HEAPF32[i1 + 28 >> 2])) {
        i3 = i22;
        i13 = i1;
        i14 = i3 + 92 | 0;
        do {
         HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
         i3 = i3 + 4 | 0;
         i13 = i13 + 4 | 0;
        } while ((i3 | 0) < (i14 | 0));
        i3 = i1;
        i13 = i10;
        i14 = i3 + 92 | 0;
        do {
         HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
         i3 = i3 + 4 | 0;
         i13 = i13 + 4 | 0;
        } while ((i3 | 0) < (i14 | 0));
        i3 = i10;
        i13 = i22;
        i14 = i3 + 92 | 0;
        do {
         HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
         i3 = i3 + 4 | 0;
         i13 = i13 + 4 | 0;
        } while ((i3 | 0) < (i14 | 0));
        i2 = i2 + 4 | 0;
        i3 = i6;
       } else {
        i2 = i3;
        i3 = i6;
       }
      } else {
       i2 = i3;
       i3 = i6;
      }
     } else {
      i2 = i3;
      i3 = i6;
     }
    } else {
     i5 = i1 + (i6 * 92 | 0) + 28 | 0;
     f8 = Math_fround(HEAPF32[i5 >> 2]);
     i4 = i1 + 28 | 0;
     i14 = f8 < Math_fround(HEAPF32[i4 >> 2]);
     i2 = Math_fround(HEAPF32[i18 >> 2]) < f8;
     if (!i14) {
      if (!i2) {
       i2 = 0;
       i3 = i5;
       break;
      }
      i3 = i22;
      i13 = i11;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i11;
      i13 = i19;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i19;
      i13 = i22;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      f8 = Math_fround(HEAPF32[i5 >> 2]);
      if (!(f8 < Math_fround(HEAPF32[i4 >> 2]))) {
       i2 = 1;
       i3 = i5;
       break;
      }
      i3 = i22;
      i13 = i1;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i1;
      i13 = i11;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i11;
      i13 = i22;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i2 = 2;
      i3 = i5;
      break;
     }
     if (i2) {
      i3 = i22;
      i13 = i1;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i1;
      i13 = i19;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i19;
      i13 = i22;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i2 = 1;
      i3 = i5;
      break;
     }
     i3 = i22;
     i13 = i1;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i1;
     i13 = i11;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i11;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     f8 = Math_fround(HEAPF32[i18 >> 2]);
     if (f8 < Math_fround(HEAPF32[i5 >> 2])) {
      i3 = i22;
      i13 = i11;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i11;
      i13 = i19;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i3 = i19;
      i13 = i22;
      i14 = i3 + 92 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
       i3 = i3 + 4 | 0;
       i13 = i13 + 4 | 0;
      } while ((i3 | 0) < (i14 | 0));
      i2 = 2;
      i3 = i5;
     } else {
      i2 = 1;
      i3 = i5;
     }
    } while (0);
    i5 = i1 + 28 | 0;
    f8 = Math_fround(HEAPF32[i5 >> 2]);
    f7 = Math_fround(HEAPF32[i3 >> 2]);
    if (f8 < f7) {
     i3 = i19;
     break;
    } else i4 = i19;
    while (1) {
     i3 = i4;
     i4 = i4 + -92 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (Math_fround(HEAPF32[i3 + -64 >> 2]) < f7) {
      i16 = 67;
      break L5;
     }
    }
    i1 = i1 + 92 | 0;
    if (!(f8 < Math_fround(HEAPF32[i18 >> 2]))) {
     if ((i1 | 0) == (i19 | 0)) {
      i16 = 84;
      break L1;
     }
     while (1) {
      if (f8 < Math_fround(HEAPF32[i1 + 28 >> 2])) break;
      i1 = i1 + 92 | 0;
      if ((i1 | 0) == (i19 | 0)) {
       i16 = 84;
       break L1;
      }
     }
     i3 = i22;
     i13 = i1;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i1;
     i13 = i19;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i19;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i1 = i1 + 92 | 0;
    }
    if ((i1 | 0) == (i19 | 0)) {
     i16 = 84;
     break L1;
    } else i2 = i19;
    while (1) {
     f7 = Math_fround(HEAPF32[i5 >> 2]);
     while (1) {
      i4 = i1 + 92 | 0;
      if (f7 < Math_fround(HEAPF32[i1 + 28 >> 2])) break; else i1 = i4;
     }
     do {
      i14 = i2;
      i2 = i2 + -92 | 0;
     } while (f7 < Math_fround(HEAPF32[i14 + -64 >> 2]));
     if (i1 >>> 0 >= i2 >>> 0) continue L5;
     i3 = i22;
     i13 = i1;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i1;
     i13 = i2;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i2;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i1 = i4;
    }
   }
   if ((i16 | 0) == 67) {
    i16 = 0;
    i3 = i22;
    i13 = i1;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i1;
    i13 = i4;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i4;
    i13 = i22;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i4;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 92 | 0;
   L50 : do if (i4 >>> 0 < i3 >>> 0) {
    i9 = i11;
    while (1) {
     f7 = Math_fround(HEAPF32[i9 + 28 >> 2]);
     while (1) {
      i6 = i4 + 92 | 0;
      if (Math_fround(HEAPF32[i4 + 28 >> 2]) < f7) i4 = i6; else {
       i5 = i3;
       break;
      }
     }
     do {
      i14 = i5;
      i5 = i5 + -92 | 0;
     } while (!(Math_fround(HEAPF32[i14 + -64 >> 2]) < f7));
     if (i4 >>> 0 > i5 >>> 0) {
      i5 = i9;
      break L50;
     }
     i3 = i22;
     i13 = i4;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i4;
     i13 = i5;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i5;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i9 = (i9 | 0) == (i4 | 0) ? i5 : i9;
     i3 = i5;
     i4 = i6;
     i2 = i2 + 1 | 0;
    }
   } else i5 = i11; while (0);
   if ((i4 | 0) != (i5 | 0)) {
    f8 = Math_fround(HEAPF32[i5 + 28 >> 2]);
    if (f8 < Math_fround(HEAPF32[i4 + 28 >> 2])) {
     i3 = i22;
     i13 = i4;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i4;
     i13 = i5;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i3 = i5;
     i13 = i22;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRN15Cast2DQueryBase14FixtureContactEPS2_EEbT0_S5_T_(i1, i4, i17) | 0;
    i3 = i4 + 92 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN15Cast2DQueryBase14FixtureContactEPS2_EEbT0_S5_T_(i3, i20, i17) | 0) {
     i16 = 83;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i14 = i4;
   if ((i14 - i12 | 0) >= (i15 - i14 | 0)) {
    i16 = 82;
    break;
   }
   __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_(i1, i4, i17);
   i1 = i4 + 92 | 0;
  }
  if ((i16 | 0) == 82) {
   i16 = 0;
   __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_(i4 + 92 | 0, i20, i17);
   i20 = i4;
   continue;
  } else if ((i16 | 0) == 83) {
   i16 = 0;
   if (i2) {
    i16 = 84;
    break;
   } else {
    i20 = i4;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  f8 = Math_fround(HEAPF32[i18 >> 2]);
  if (!(f8 < Math_fround(HEAPF32[i1 + 28 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i1;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i1;
  i13 = i19;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i19;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  STACKTOP = i23;
  return;
 } else if ((i16 | 0) == 7) {
  i4 = i1 + 92 | 0;
  i5 = i1 + 120 | 0;
  f8 = Math_fround(HEAPF32[i5 >> 2]);
  i6 = i1 + 28 | 0;
  i21 = f8 < Math_fround(HEAPF32[i6 >> 2]);
  i2 = Math_fround(HEAPF32[i18 >> 2]) < f8;
  if (!i21) {
   if (!i2) {
    STACKTOP = i23;
    return;
   }
   i3 = i22;
   i13 = i4;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i4;
   i13 = i19;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i19;
   i13 = i22;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   f8 = Math_fround(HEAPF32[i5 >> 2]);
   if (!(f8 < Math_fround(HEAPF32[i6 >> 2]))) {
    STACKTOP = i23;
    return;
   }
   i3 = i22;
   i13 = i1;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i1;
   i13 = i4;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i4;
   i13 = i22;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   STACKTOP = i23;
   return;
  }
  if (i2) {
   i3 = i22;
   i13 = i1;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i1;
   i13 = i19;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i19;
   i13 = i22;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i1;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i1;
  i13 = i4;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i4;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  f8 = Math_fround(HEAPF32[i18 >> 2]);
  if (!(f8 < Math_fround(HEAPF32[i5 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i4;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i4;
  i13 = i19;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i19;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  STACKTOP = i23;
  return;
 } else if ((i16 | 0) == 15) {
  __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i1, i1 + 92 | 0, i1 + 184 | 0, i19, i17) | 0;
  STACKTOP = i23;
  return;
 } else if ((i16 | 0) == 16) {
  i5 = i1 + 92 | 0;
  i6 = i1 + 184 | 0;
  i4 = i1 + 276 | 0;
  __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i1, i5, i6, i4, i17) | 0;
  f8 = Math_fround(HEAPF32[i18 >> 2]);
  i2 = i1 + 304 | 0;
  if (!(f8 < Math_fround(HEAPF32[i2 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i4;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i4;
  i13 = i19;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i19;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i2 = i1 + 212 | 0;
  if (!(f8 < Math_fround(HEAPF32[i2 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i6;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i6;
  i13 = i4;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i4;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i2 = i1 + 120 | 0;
  if (!(f8 < Math_fround(HEAPF32[i2 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i5;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i5;
  i13 = i6;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i6;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f8 < Math_fround(HEAPF32[i1 + 28 >> 2]))) {
   STACKTOP = i23;
   return;
  }
  i3 = i22;
  i13 = i1;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i1;
  i13 = i5;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  i3 = i5;
  i13 = i22;
  i14 = i3 + 92 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   i3 = i3 + 4 | 0;
   i13 = i13 + 4 | 0;
  } while ((i3 | 0) < (i14 | 0));
  STACKTOP = i23;
  return;
 } else if ((i16 | 0) == 22) {
  i4 = i1 + 184 | 0;
  i5 = i1 + 92 | 0;
  i6 = i1 + 120 | 0;
  f24 = Math_fround(HEAPF32[i6 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 212 >> 2]);
  i2 = f8 < f24;
  do if (f24 < f7) {
   if (i2) {
    i3 = i22;
    i13 = i1;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i1;
    i13 = i4;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i4;
    i13 = i22;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    break;
   }
   i3 = i22;
   i13 = i1;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i1;
   i13 = i5;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i5;
   i13 = i22;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   if (f8 < Math_fround(HEAPF32[i6 >> 2])) {
    i3 = i22;
    i13 = i5;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i5;
    i13 = i4;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i4;
    i13 = i22;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
   }
  } else if (i2) {
   i3 = i22;
   i13 = i5;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i5;
   i13 = i4;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   i3 = i4;
   i13 = i22;
   i14 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
    i3 = i3 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i3 | 0) < (i14 | 0));
   if (Math_fround(HEAPF32[i6 >> 2]) < f7) {
    i3 = i22;
    i13 = i1;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i1;
    i13 = i5;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i5;
    i13 = i22;
    i14 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
   }
  } while (0);
  i2 = i1 + 276 | 0;
  if ((i2 | 0) == (i20 | 0)) {
   STACKTOP = i23;
   return;
  }
  while (1) {
   f7 = Math_fround(HEAPF32[i2 + 28 >> 2]);
   if (f7 < Math_fround(HEAPF32[i4 + 28 >> 2])) {
    HEAP32[i22 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i22 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    i3 = i21;
    i13 = i2 + 32 | 0;
    i14 = i3 + 60 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
    i3 = i2;
    while (1) {
     i13 = i4;
     i14 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      i3 = i3 + 4 | 0;
      i13 = i13 + 4 | 0;
     } while ((i3 | 0) < (i14 | 0));
     if ((i4 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     if (f7 < Math_fround(HEAPF32[i4 + -64 >> 2])) {
      i3 = i4;
      i4 = i4 + -92 | 0;
     } else {
      i3 = i4;
      break;
     }
    }
    HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
    HEAPF32[i3 + 28 >> 2] = f7;
    i3 = i3 + 32 | 0;
    i13 = i21;
    i14 = i3 + 60 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     i3 = i3 + 4 | 0;
     i13 = i13 + 4 | 0;
    } while ((i3 | 0) < (i14 | 0));
   }
   i3 = i2 + 92 | 0;
   if ((i3 | 0) == (i20 | 0)) break; else {
    i4 = i2;
    i2 = i3;
   }
  }
  STACKTOP = i23;
  return;
 } else if ((i16 | 0) == 84) {
  STACKTOP = i23;
  return;
 }
}

function _printf_core(i28, i3, i52, i53, i54) {
 i28 = i28 | 0;
 i3 = i3 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i55 + 24 | 0;
 i49 = i55 + 16 | 0;
 i50 = i55 + 588 | 0;
 i39 = i55 + 576 | 0;
 i51 = i55;
 i34 = i55 + 536 | 0;
 i29 = i55 + 8 | 0;
 i30 = i55 + 528 | 0;
 i31 = (i28 | 0) != 0;
 i32 = i34 + 40 | 0;
 i33 = i32;
 i34 = i34 + 39 | 0;
 i35 = i29 + 4 | 0;
 i36 = i50;
 i37 = 0 - i36 | 0;
 i38 = i39 + 12 | 0;
 i39 = i39 + 11 | 0;
 i40 = i38;
 i41 = i40 - i36 | 0;
 i42 = -2 - i36 | 0;
 i43 = i40 + 2 | 0;
 i44 = i48 + 288 | 0;
 i45 = i50 + 9 | 0;
 i46 = i45;
 i47 = i50 + 8 | 0;
 i2 = 0;
 i1 = 0;
 i8 = 0;
 L1 : while (1) {
  do if ((i1 | 0) > -1) if ((i2 | 0) > (2147483647 - i1 | 0)) {
   HEAP32[(___errno_location() | 0) >> 2] = 75;
   i1 = -1;
   break;
  } else {
   i1 = i2 + i1 | 0;
   break;
  } while (0);
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i27 = 243;
   break;
  } else i4 = i3;
  L9 : while (1) {
   switch (i2 << 24 >> 24) {
   case 37:
    {
     i2 = i4;
     i27 = 9;
     break L9;
    }
   case 0:
    {
     i2 = i4;
     break L9;
    }
   default:
    {}
   }
   i2 = i4 + 1 | 0;
   i4 = i2;
   i2 = HEAP8[i2 >> 0] | 0;
  }
  L12 : do if ((i27 | 0) == 9) while (1) {
   i27 = 0;
   if ((HEAP8[i4 + 1 >> 0] | 0) != 37) break L12;
   i2 = i2 + 1 | 0;
   i4 = i4 + 2 | 0;
   if ((HEAP8[i4 >> 0] | 0) == 37) i27 = 9; else break;
  } while (0);
  i2 = i2 - i3 | 0;
  if (i31) if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, i2, i28) | 0;
  if (i2 | 0) {
   i3 = i4;
   continue;
  }
  i7 = i4 + 1 | 0;
  i5 = HEAP8[i7 >> 0] | 0;
  i2 = (i5 << 24 >> 24) + -48 | 0;
  if (i2 >>> 0 < 10) {
   i10 = (HEAP8[i4 + 2 >> 0] | 0) == 36;
   i7 = i10 ? i4 + 3 | 0 : i7;
   i12 = i10 ? i2 : -1;
   i10 = i10 ? 1 : i8;
   i2 = HEAP8[i7 >> 0] | 0;
  } else {
   i12 = -1;
   i10 = i8;
   i2 = i5;
  }
  i4 = (i2 << 24 >> 24) + -32 | 0;
  L25 : do if (i4 >>> 0 < 32) {
   i5 = 0;
   do {
    if (!(1 << i4 & 75913)) break L25;
    i5 = 1 << (i2 << 24 >> 24) + -32 | i5;
    i7 = i7 + 1 | 0;
    i2 = HEAP8[i7 >> 0] | 0;
    i4 = (i2 << 24 >> 24) + -32 | 0;
   } while (i4 >>> 0 < 32);
  } else i5 = 0; while (0);
  do if (i2 << 24 >> 24 == 42) {
   i9 = i7 + 1 | 0;
   i2 = HEAP8[i9 >> 0] | 0;
   i4 = (i2 << 24 >> 24) + -48 | 0;
   if (i4 >>> 0 < 10) if ((HEAP8[i7 + 2 >> 0] | 0) == 36) {
    HEAP32[i54 + (i4 << 2) >> 2] = 10;
    i2 = HEAP32[i53 + ((HEAP8[i9 >> 0] | 0) + -48 << 3) >> 2] | 0;
    i4 = 1;
    i9 = i7 + 3 | 0;
   } else i27 = 24; else i27 = 24;
   if ((i27 | 0) == 24) {
    i27 = 0;
    if (i10 | 0) {
     i1 = -1;
     break L1;
    }
    if (!i31) {
     i8 = 0;
     i26 = 0;
     i7 = i9;
     break;
    }
    i4 = (HEAP32[i52 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i52 >> 2] = i4 + 4;
    i4 = 0;
   }
   i26 = (i2 | 0) < 0;
   i8 = i26 ? 0 - i2 | 0 : i2;
   i5 = i26 ? i5 | 8192 : i5;
   i26 = i4;
   i7 = i9;
   i2 = HEAP8[i9 >> 0] | 0;
  } else {
   i4 = (i2 << 24 >> 24) + -48 | 0;
   if (i4 >>> 0 < 10) {
    i8 = 0;
    do {
     i8 = (i8 * 10 | 0) + i4 | 0;
     i7 = i7 + 1 | 0;
     i2 = HEAP8[i7 >> 0] | 0;
     i4 = (i2 << 24 >> 24) + -48 | 0;
    } while (i4 >>> 0 < 10);
    if ((i8 | 0) < 0) {
     i1 = -1;
     break L1;
    } else i26 = i10;
   } else {
    i8 = 0;
    i26 = i10;
   }
  } while (0);
  L45 : do if (i2 << 24 >> 24 == 46) {
   i2 = i7 + 1 | 0;
   i4 = HEAP8[i2 >> 0] | 0;
   if (i4 << 24 >> 24 != 42) {
    i7 = (i4 << 24 >> 24) + -48 | 0;
    if (i7 >>> 0 < 10) i4 = 0; else {
     i13 = 0;
     break;
    }
    while (1) {
     i4 = (i4 * 10 | 0) + i7 | 0;
     i2 = i2 + 1 | 0;
     i7 = (HEAP8[i2 >> 0] | 0) + -48 | 0;
     if (i7 >>> 0 >= 10) {
      i13 = i4;
      break L45;
     }
    }
   }
   i2 = i7 + 2 | 0;
   i4 = (HEAP8[i2 >> 0] | 0) + -48 | 0;
   if (i4 >>> 0 < 10) if ((HEAP8[i7 + 3 >> 0] | 0) == 36) {
    HEAP32[i54 + (i4 << 2) >> 2] = 10;
    i13 = HEAP32[i53 + ((HEAP8[i2 >> 0] | 0) + -48 << 3) >> 2] | 0;
    i2 = i7 + 4 | 0;
    break;
   }
   if (i26 | 0) {
    i1 = -1;
    break L1;
   }
   if (i31) {
    i25 = (HEAP32[i52 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i13 = HEAP32[i25 >> 2] | 0;
    HEAP32[i52 >> 2] = i25 + 4;
   } else i13 = 0;
  } else {
   i13 = -1;
   i2 = i7;
  } while (0);
  i10 = 0;
  while (1) {
   i4 = (HEAP8[i2 >> 0] | 0) + -65 | 0;
   if (i4 >>> 0 > 57) {
    i1 = -1;
    break L1;
   }
   i25 = i2 + 1 | 0;
   i4 = HEAP8[gb + 1057055 + (i10 * 58 | 0) + i4 >> 0] | 0;
   i7 = i4 & 255;
   if ((i7 + -1 | 0) >>> 0 < 8) {
    i10 = i7;
    i2 = i25;
   } else break;
  }
  if (!(i4 << 24 >> 24)) {
   i1 = -1;
   break;
  }
  i9 = (i12 | 0) > -1;
  do if (i4 << 24 >> 24 == 19) if (i9) {
   i1 = -1;
   break L1;
  } else i27 = 51; else {
   if (i9) {
    HEAP32[i54 + (i12 << 2) >> 2] = i7;
    i23 = i53 + (i12 << 3) | 0;
    i24 = HEAP32[i23 + 4 >> 2] | 0;
    i27 = i51;
    HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i27 + 4 >> 2] = i24;
    i27 = 51;
    break;
   }
   if (!i31) {
    i1 = 0;
    break L1;
   }
   _pop_arg(i51, i7, i52);
  } while (0);
  if ((i27 | 0) == 51) {
   i27 = 0;
   if (!i31) {
    i2 = 0;
    i8 = i26;
    i3 = i25;
    continue;
   }
  }
  i20 = HEAP8[i2 >> 0] | 0;
  i20 = (i10 | 0) != 0 & (i20 & 15 | 0) == 3 ? i20 & -33 : i20;
  i9 = i5 & -65537;
  i24 = (i5 & 8192 | 0) == 0 ? i5 : i9;
  L74 : do switch (i20 | 0) {
  case 110:
   switch ((i10 & 255) << 24 >> 24) {
   case 0:
    {
     HEAP32[HEAP32[i51 >> 2] >> 2] = i1;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 1:
    {
     HEAP32[HEAP32[i51 >> 2] >> 2] = i1;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 2:
    {
     i2 = HEAP32[i51 >> 2] | 0;
     HEAP32[i2 >> 2] = i1;
     HEAP32[i2 + 4 >> 2] = ((i1 | 0) < 0) << 31 >> 31;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 3:
    {
     HEAP16[HEAP32[i51 >> 2] >> 1] = i1;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 4:
    {
     HEAP8[HEAP32[i51 >> 2] >> 0] = i1;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 6:
    {
     HEAP32[HEAP32[i51 >> 2] >> 2] = i1;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   case 7:
    {
     i2 = HEAP32[i51 >> 2] | 0;
     HEAP32[i2 >> 2] = i1;
     HEAP32[i2 + 4 >> 2] = ((i1 | 0) < 0) << 31 >> 31;
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   default:
    {
     i2 = 0;
     i8 = i26;
     i3 = i25;
     continue L1;
    }
   }
  case 112:
   {
    i9 = 120;
    i10 = i13 >>> 0 > 8 ? i13 : 8;
    i2 = i24 | 8;
    i27 = 63;
    break;
   }
  case 88:
  case 120:
   {
    i9 = i20;
    i10 = i13;
    i2 = i24;
    i27 = 63;
    break;
   }
  case 111:
   {
    i4 = i51;
    i2 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i2 | 0) == 0 & (i4 | 0) == 0) i3 = i32; else {
     i3 = i32;
     do {
      i3 = i3 + -1 | 0;
      HEAP8[i3 >> 0] = i2 & 7 | 48;
      i2 = _bitshift64Lshr(i2 | 0, i4 | 0, 3) | 0;
      i4 = getTempRet0() | 0;
     } while (!((i2 | 0) == 0 & (i4 | 0) == 0));
    }
    if (!(i24 & 8)) {
     i4 = 0;
     i5 = gb + 1057535 | 0;
     i7 = i13;
     i2 = i24;
     i27 = 76;
    } else {
     i7 = i33 - i3 | 0;
     i4 = 0;
     i5 = gb + 1057535 | 0;
     i7 = (i13 | 0) > (i7 | 0) ? i13 : i7 + 1 | 0;
     i2 = i24;
     i27 = 76;
    }
    break;
   }
  case 105:
  case 100:
   {
    i3 = i51;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i3 | 0) < 0) {
     i2 = _i64Subtract(0, 0, i2 | 0, i3 | 0) | 0;
     i3 = getTempRet0() | 0;
     i4 = i51;
     HEAP32[i4 >> 2] = i2;
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = 1;
     i5 = gb + 1057535 | 0;
     i27 = 75;
     break L74;
    }
    if (!(i24 & 2048)) {
     i5 = i24 & 1;
     i4 = i5;
     i5 = (i5 | 0) == 0 ? gb + 1057535 | 0 : gb + 1057535 + 2 | 0;
     i27 = 75;
    } else {
     i4 = 1;
     i5 = gb + 1057535 + 1 | 0;
     i27 = 75;
    }
    break;
   }
  case 117:
   {
    i3 = i51;
    i4 = 0;
    i5 = gb + 1057535 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i27 = 75;
    break;
   }
  case 99:
   {
    HEAP8[i34 >> 0] = HEAP32[i51 >> 2];
    i3 = i34;
    i12 = 0;
    i10 = gb + 1057535 | 0;
    i4 = i32;
    i2 = 1;
    break;
   }
  case 109:
   {
    i2 = _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0;
    i27 = 81;
    break;
   }
  case 115:
   {
    i2 = HEAP32[i51 >> 2] | 0;
    i2 = i2 | 0 ? i2 : gb + 1057545 | 0;
    i27 = 81;
    break;
   }
  case 67:
   {
    HEAP32[i29 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i35 >> 2] = 0;
    HEAP32[i51 >> 2] = i29;
    i9 = -1;
    i4 = i29;
    i27 = 85;
    break;
   }
  case 83:
   {
    i2 = HEAP32[i51 >> 2] | 0;
    if (!i13) {
     _pad(i28, 32, i8, 0, i24);
     i2 = 0;
     i27 = 96;
    } else {
     i9 = i13;
     i4 = i2;
     i27 = 85;
    }
    break;
   }
  case 65:
  case 71:
  case 70:
  case 69:
  case 97:
  case 103:
  case 102:
  case 101:
   {
    d6 = +HEAPF64[i51 >> 3];
    HEAP32[i49 >> 2] = 0;
    HEAPF64[tempDoublePtr >> 3] = d6;
    if ((HEAP32[tempDoublePtr + 4 >> 2] | 0) < 0) {
     d6 = -d6;
     i22 = 1;
     i23 = gb + 1057552 | 0;
    } else {
     i2 = i24 & 1;
     if (!(i24 & 2048)) {
      i22 = i2;
      i23 = (i2 | 0) == 0 ? gb + 1057552 + 1 | 0 : gb + 1057552 + 6 | 0;
     } else {
      i22 = 1;
      i23 = gb + 1057552 + 3 | 0;
     }
    }
    HEAPF64[tempDoublePtr >> 3] = d6;
    i21 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
    do if (i21 >>> 0 < 2146435072 | (i21 | 0) == 2146435072 & 0 < 0) {
     d11 = +_frexpl(d6, i49) * 2.0;
     i3 = d11 != 0.0;
     if (i3) HEAP32[i49 >> 2] = (HEAP32[i49 >> 2] | 0) + -1;
     i15 = i20 | 32;
     if ((i15 | 0) == 97) {
      i7 = i20 & 32;
      i12 = (i7 | 0) == 0 ? i23 : i23 + 9 | 0;
      i10 = i22 | 2;
      i2 = 12 - i13 | 0;
      do if (i13 >>> 0 > 11 | (i2 | 0) == 0) d6 = d11; else {
       d6 = 8.0;
       do {
        i2 = i2 + -1 | 0;
        d6 = d6 * 16.0;
       } while ((i2 | 0) != 0);
       if ((HEAP8[i12 >> 0] | 0) == 45) {
        d6 = -(d6 + (-d11 - d6));
        break;
       } else {
        d6 = d11 + d6 - d6;
        break;
       }
      } while (0);
      i3 = HEAP32[i49 >> 2] | 0;
      i2 = (i3 | 0) < 0 ? 0 - i3 | 0 : i3;
      i2 = _fmt_u(i2, ((i2 | 0) < 0) << 31 >> 31, i38) | 0;
      if ((i2 | 0) == (i38 | 0)) {
       HEAP8[i39 >> 0] = 48;
       i2 = i39;
      }
      HEAP8[i2 + -1 >> 0] = (i3 >> 31 & 2) + 43;
      i9 = i2 + -2 | 0;
      HEAP8[i9 >> 0] = i20 + 15;
      i5 = (i13 | 0) < 1;
      i4 = (i24 & 8 | 0) == 0;
      i2 = i50;
      do {
       i23 = ~~d6;
       i3 = i2 + 1 | 0;
       HEAP8[i2 >> 0] = HEAPU8[gb + 1057519 + i23 >> 0] | i7;
       d6 = (d6 - +(i23 | 0)) * 16.0;
       do if ((i3 - i36 | 0) == 1) {
        if (i4 & (i5 & d6 == 0.0)) {
         i2 = i3;
         break;
        }
        HEAP8[i3 >> 0] = 46;
        i2 = i2 + 2 | 0;
       } else i2 = i3; while (0);
      } while (d6 != 0.0);
      i5 = i9;
      i4 = (i13 | 0) != 0 & (i42 + i2 | 0) < (i13 | 0) ? i43 + i13 - i5 | 0 : i41 - i5 + i2 | 0;
      i7 = i4 + i10 | 0;
      _pad(i28, 32, i8, i7, i24);
      if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i12, i10, i28) | 0;
      _pad(i28, 48, i8, i7, i24 ^ 65536);
      i3 = i2 - i36 | 0;
      if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i50, i3, i28) | 0;
      i2 = i40 - i5 | 0;
      _pad(i28, 48, i4 - (i3 + i2) | 0, 0, 0);
      if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i9, i2, i28) | 0;
      _pad(i28, 32, i8, i7, i24 ^ 8192);
      i2 = (i7 | 0) < (i8 | 0) ? i8 : i7;
      break;
     }
     i2 = (i13 | 0) < 0 ? 6 : i13;
     if (i3) {
      i3 = (HEAP32[i49 >> 2] | 0) + -28 | 0;
      HEAP32[i49 >> 2] = i3;
      d6 = d11 * 268435456.0;
     } else {
      d6 = d11;
      i3 = HEAP32[i49 >> 2] | 0;
     }
     i21 = (i3 | 0) < 0 ? i48 : i44;
     i4 = i21;
     do {
      i19 = ~~d6 >>> 0;
      HEAP32[i4 >> 2] = i19;
      i4 = i4 + 4 | 0;
      d6 = (d6 - +(i19 >>> 0)) * 1.0e9;
     } while (d6 != 0.0);
     if ((i3 | 0) > 0) {
      i5 = i21;
      i9 = i4;
      while (1) {
       i7 = (i3 | 0) > 29 ? 29 : i3;
       i3 = i9 + -4 | 0;
       do if (i3 >>> 0 >= i5 >>> 0) {
        i4 = 0;
        do {
         i18 = _bitshift64Shl(HEAP32[i3 >> 2] | 0, 0, i7 | 0) | 0;
         i18 = _i64Add(i18 | 0, getTempRet0() | 0, i4 | 0, 0) | 0;
         i19 = getTempRet0() | 0;
         i17 = ___uremdi3(i18 | 0, i19 | 0, 1e9, 0) | 0;
         getTempRet0() | 0;
         HEAP32[i3 >> 2] = i17;
         i4 = ___udivdi3(i18 | 0, i19 | 0, 1e9, 0) | 0;
         getTempRet0() | 0;
         i3 = i3 + -4 | 0;
        } while (i3 >>> 0 >= i5 >>> 0);
        if (!i4) break;
        i5 = i5 + -4 | 0;
        HEAP32[i5 >> 2] = i4;
       } while (0);
       i4 = i9;
       while (1) {
        if (i4 >>> 0 <= i5 >>> 0) break;
        i3 = i4 + -4 | 0;
        if (!(HEAP32[i3 >> 2] | 0)) i4 = i3; else break;
       }
       i3 = (HEAP32[i49 >> 2] | 0) - i7 | 0;
       HEAP32[i49 >> 2] = i3;
       if ((i3 | 0) > 0) i9 = i4; else break;
      }
     } else i5 = i21;
     if ((i3 | 0) < 0) {
      i13 = ((i2 + 25 | 0) / 9 | 0) + 1 | 0;
      i14 = (i15 | 0) == 102;
      do {
       i12 = 0 - i3 | 0;
       i12 = (i12 | 0) > 9 ? 9 : i12;
       do if (i5 >>> 0 < i4 >>> 0) {
        i7 = (1 << i12) + -1 | 0;
        i9 = 1e9 >>> i12;
        i10 = 0;
        i3 = i5;
        do {
         i19 = HEAP32[i3 >> 2] | 0;
         HEAP32[i3 >> 2] = (i19 >>> i12) + i10;
         i10 = Math_imul(i19 & i7, i9) | 0;
         i3 = i3 + 4 | 0;
        } while (i3 >>> 0 < i4 >>> 0);
        i3 = (HEAP32[i5 >> 2] | 0) == 0 ? i5 + 4 | 0 : i5;
        if (!i10) {
         i5 = i3;
         i3 = i4;
         break;
        }
        HEAP32[i4 >> 2] = i10;
        i5 = i3;
        i3 = i4 + 4 | 0;
       } else {
        i5 = (HEAP32[i5 >> 2] | 0) == 0 ? i5 + 4 | 0 : i5;
        i3 = i4;
       } while (0);
       i4 = i14 ? i21 : i5;
       i4 = (i3 - i4 >> 2 | 0) > (i13 | 0) ? i4 + (i13 << 2) | 0 : i3;
       i3 = (HEAP32[i49 >> 2] | 0) + i12 | 0;
       HEAP32[i49 >> 2] = i3;
      } while ((i3 | 0) < 0);
     }
     i19 = i21;
     do if (i5 >>> 0 < i4 >>> 0) {
      i3 = (i19 - i5 >> 2) * 9 | 0;
      i9 = HEAP32[i5 >> 2] | 0;
      if (i9 >>> 0 < 10) break; else i7 = 10;
      do {
       i7 = i7 * 10 | 0;
       i3 = i3 + 1 | 0;
      } while (i9 >>> 0 >= i7 >>> 0);
     } else i3 = 0; while (0);
     i16 = (i15 | 0) == 103;
     i17 = (i2 | 0) != 0;
     i7 = i2 - ((i15 | 0) != 102 ? i3 : 0) + ((i17 & i16) << 31 >> 31) | 0;
     if ((i7 | 0) < (((i4 - i19 >> 2) * 9 | 0) + -9 | 0)) {
      i7 = i7 + 9216 | 0;
      i10 = i21 + 4 + (((i7 | 0) / 9 | 0) + -1024 << 2) | 0;
      i7 = ((i7 | 0) % 9 | 0) + 1 | 0;
      if ((i7 | 0) < 9) {
       i9 = 10;
       do {
        i9 = i9 * 10 | 0;
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) != 9);
      } else i9 = 10;
      i13 = HEAP32[i10 >> 2] | 0;
      i14 = (i13 >>> 0) % (i9 >>> 0) | 0;
      i7 = (i10 + 4 | 0) == (i4 | 0);
      do if (i7 & (i14 | 0) == 0) i7 = i10; else {
       d11 = (((i13 >>> 0) / (i9 >>> 0) | 0) & 1 | 0) == 0 ? 9007199254740992.0 : 9007199254740994.0;
       i12 = (i9 | 0) / 2 | 0;
       if (i14 >>> 0 < i12 >>> 0) d6 = .5; else d6 = i7 & (i14 | 0) == (i12 | 0) ? 1.0 : 1.5;
       do if (i22) {
        if ((HEAP8[i23 >> 0] | 0) != 45) break;
        d6 = -d6;
        d11 = -d11;
       } while (0);
       i7 = i13 - i14 | 0;
       HEAP32[i10 >> 2] = i7;
       if (!(d11 + d6 != d11)) {
        i7 = i10;
        break;
       }
       i18 = i7 + i9 | 0;
       HEAP32[i10 >> 2] = i18;
       if (i18 >>> 0 > 999999999) {
        i7 = i10;
        while (1) {
         i3 = i7 + -4 | 0;
         HEAP32[i7 >> 2] = 0;
         if (i3 >>> 0 < i5 >>> 0) {
          i5 = i5 + -4 | 0;
          HEAP32[i5 >> 2] = 0;
         }
         i18 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
         HEAP32[i3 >> 2] = i18;
         if (i18 >>> 0 > 999999999) i7 = i3; else {
          i10 = i3;
          break;
         }
        }
       }
       i3 = (i19 - i5 >> 2) * 9 | 0;
       i9 = HEAP32[i5 >> 2] | 0;
       if (i9 >>> 0 < 10) {
        i7 = i10;
        break;
       } else i7 = 10;
       do {
        i7 = i7 * 10 | 0;
        i3 = i3 + 1 | 0;
       } while (i9 >>> 0 >= i7 >>> 0);
       i7 = i10;
      } while (0);
      i18 = i7 + 4 | 0;
      i4 = i4 >>> 0 > i18 >>> 0 ? i18 : i4;
     }
     i14 = 0 - i3 | 0;
     i18 = i4;
     while (1) {
      if (i18 >>> 0 <= i5 >>> 0) {
       i15 = 0;
       break;
      }
      i4 = i18 + -4 | 0;
      if (!(HEAP32[i4 >> 2] | 0)) i18 = i4; else {
       i15 = 1;
       break;
      }
     }
     do if (i16) {
      i2 = (i17 & 1 ^ 1) + i2 | 0;
      if ((i2 | 0) > (i3 | 0) & (i3 | 0) > -5) {
       i10 = i20 + -1 | 0;
       i2 = i2 + -1 - i3 | 0;
      } else {
       i10 = i20 + -2 | 0;
       i2 = i2 + -1 | 0;
      }
      i4 = i24 & 8;
      if (i4 | 0) {
       i12 = i4;
       break;
      }
      do if (i15) {
       i9 = HEAP32[i18 + -4 >> 2] | 0;
       if (!i9) {
        i7 = 9;
        break;
       }
       if (!((i9 >>> 0) % 10 | 0)) {
        i7 = 0;
        i4 = 10;
       } else {
        i7 = 0;
        break;
       }
       do {
        i4 = i4 * 10 | 0;
        i7 = i7 + 1 | 0;
       } while (!((i9 >>> 0) % (i4 >>> 0) | 0 | 0));
      } else i7 = 9; while (0);
      i4 = ((i18 - i19 >> 2) * 9 | 0) + -9 | 0;
      if ((i10 | 32 | 0) == 102) {
       i12 = i4 - i7 | 0;
       i12 = (i12 | 0) < 0 ? 0 : i12;
       i2 = (i2 | 0) < (i12 | 0) ? i2 : i12;
       i12 = 0;
       break;
      } else {
       i12 = i4 + i3 - i7 | 0;
       i12 = (i12 | 0) < 0 ? 0 : i12;
       i2 = (i2 | 0) < (i12 | 0) ? i2 : i12;
       i12 = 0;
       break;
      }
     } else {
      i10 = i20;
      i12 = i24 & 8;
     } while (0);
     i13 = i2 | i12;
     i7 = (i13 | 0) != 0 & 1;
     i9 = (i10 | 32 | 0) == 102;
     if (i9) {
      i14 = 0;
      i3 = (i3 | 0) > 0 ? i3 : 0;
     } else {
      i4 = (i3 | 0) < 0 ? i14 : i3;
      i4 = _fmt_u(i4, ((i4 | 0) < 0) << 31 >> 31, i38) | 0;
      if ((i40 - i4 | 0) < 2) do {
       i4 = i4 + -1 | 0;
       HEAP8[i4 >> 0] = 48;
      } while ((i40 - i4 | 0) < 2);
      HEAP8[i4 + -1 >> 0] = (i3 >> 31 & 2) + 43;
      i3 = i4 + -2 | 0;
      HEAP8[i3 >> 0] = i10;
      i14 = i3;
      i3 = i40 - i3 | 0;
     }
     i16 = i22 + 1 + i2 + i7 + i3 | 0;
     _pad(i28, 32, i8, i16, i24);
     if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i23, i22, i28) | 0;
     _pad(i28, 48, i8, i16, i24 ^ 65536);
     do if (i9) {
      i5 = i5 >>> 0 > i21 >>> 0 ? i21 : i5;
      i4 = i5;
      do {
       i3 = _fmt_u(HEAP32[i4 >> 2] | 0, 0, i45) | 0;
       do if ((i4 | 0) == (i5 | 0)) {
        if ((i3 | 0) != (i45 | 0)) break;
        HEAP8[i47 >> 0] = 48;
        i3 = i47;
       } else {
        if (i3 >>> 0 <= i50 >>> 0) break;
        _memset(i50 | 0, 48, i3 - i36 | 0) | 0;
        do i3 = i3 + -1 | 0; while (i3 >>> 0 > i50 >>> 0);
       } while (0);
       if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, i46 - i3 | 0, i28) | 0;
       i4 = i4 + 4 | 0;
      } while (i4 >>> 0 <= i21 >>> 0);
      do if (i13 | 0) {
       if (HEAP32[i28 >> 2] & 32 | 0) break;
       ___fwritex(gb + 1087625 | 0, 1, i28) | 0;
      } while (0);
      if ((i2 | 0) > 0 & i4 >>> 0 < i18 >>> 0) while (1) {
       i3 = _fmt_u(HEAP32[i4 >> 2] | 0, 0, i45) | 0;
       if (i3 >>> 0 > i50 >>> 0) {
        _memset(i50 | 0, 48, i3 - i36 | 0) | 0;
        do i3 = i3 + -1 | 0; while (i3 >>> 0 > i50 >>> 0);
       }
       if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, (i2 | 0) > 9 ? 9 : i2, i28) | 0;
       i4 = i4 + 4 | 0;
       i3 = i2 + -9 | 0;
       if (!((i2 | 0) > 9 & i4 >>> 0 < i18 >>> 0)) {
        i2 = i3;
        break;
       } else i2 = i3;
      }
      _pad(i28, 48, i2 + 9 | 0, 9, 0);
     } else {
      i10 = i15 ? i18 : i5 + 4 | 0;
      if ((i2 | 0) > -1) {
       i9 = (i12 | 0) == 0;
       i7 = i5;
       do {
        i3 = _fmt_u(HEAP32[i7 >> 2] | 0, 0, i45) | 0;
        if ((i3 | 0) == (i45 | 0)) {
         HEAP8[i47 >> 0] = 48;
         i3 = i47;
        }
        do if ((i7 | 0) == (i5 | 0)) {
         i4 = i3 + 1 | 0;
         if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, 1, i28) | 0;
         if (i9 & (i2 | 0) < 1) {
          i3 = i4;
          break;
         }
         if (HEAP32[i28 >> 2] & 32 | 0) {
          i3 = i4;
          break;
         }
         ___fwritex(gb + 1087625 | 0, 1, i28) | 0;
         i3 = i4;
        } else {
         if (i3 >>> 0 <= i50 >>> 0) break;
         _memset(i50 | 0, 48, i3 + i37 | 0) | 0;
         do i3 = i3 + -1 | 0; while (i3 >>> 0 > i50 >>> 0);
        } while (0);
        i4 = i46 - i3 | 0;
        if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, (i2 | 0) > (i4 | 0) ? i4 : i2, i28) | 0;
        i2 = i2 - i4 | 0;
        i7 = i7 + 4 | 0;
       } while (i7 >>> 0 < i10 >>> 0 & (i2 | 0) > -1);
      }
      _pad(i28, 48, i2 + 18 | 0, 18, 0);
      if (HEAP32[i28 >> 2] & 32 | 0) break;
      ___fwritex(i14, i40 - i14 | 0, i28) | 0;
     } while (0);
     _pad(i28, 32, i8, i16, i24 ^ 8192);
     i2 = (i16 | 0) < (i8 | 0) ? i8 : i16;
    } else {
     i4 = (i20 & 32 | 0) != 0;
     i5 = d6 != d6 | 0.0 != 0.0;
     i3 = i5 ? 0 : i22;
     i4 = i5 ? (i4 ? gb + 1069350 | 0 : gb + 1057579 | 0) : i4 ? gb + 1057571 | 0 : gb + 1057575 | 0;
     i5 = i3 + 3 | 0;
     _pad(i28, 32, i8, i5, i9);
     i2 = HEAP32[i28 >> 2] | 0;
     if (!(i2 & 32)) {
      ___fwritex(i23, i3, i28) | 0;
      i2 = HEAP32[i28 >> 2] | 0;
     }
     if (!(i2 & 32)) ___fwritex(i4, 3, i28) | 0;
     _pad(i28, 32, i8, i5, i24 ^ 8192);
     i2 = (i5 | 0) < (i8 | 0) ? i8 : i5;
    } while (0);
    i8 = i26;
    i3 = i25;
    continue L1;
   }
  default:
   {
    i12 = 0;
    i10 = gb + 1057535 | 0;
    i4 = i32;
    i2 = i13;
    i9 = i24;
   }
  } while (0);
  L310 : do if ((i27 | 0) == 63) {
   i5 = i51;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i9 & 32;
   if ((i4 | 0) == 0 & (i5 | 0) == 0) {
    i3 = i32;
    i4 = 0;
    i5 = 0;
   } else {
    i3 = i32;
    do {
     i3 = i3 + -1 | 0;
     HEAP8[i3 >> 0] = HEAPU8[(i4 & 15) + (gb + 1057519) >> 0] | i7;
     i4 = _bitshift64Lshr(i4 | 0, i5 | 0, 4) | 0;
     i5 = getTempRet0() | 0;
    } while (!((i4 | 0) == 0 & (i5 | 0) == 0));
    i5 = i51;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
   }
   i5 = (i2 & 8 | 0) == 0 | (i4 | 0) == 0 & (i5 | 0) == 0;
   i4 = i5 ? 0 : 2;
   i5 = i5 ? gb + 1057535 | 0 : (i9 >> 4) + (gb + 1057535) | 0;
   i7 = i10;
   i27 = 76;
  } else if ((i27 | 0) == 75) {
   i3 = _fmt_u(i2, i3, i32) | 0;
   i7 = i13;
   i2 = i24;
   i27 = 76;
  } else if ((i27 | 0) == 81) {
   i27 = 0;
   i24 = _memchr(i2, 0, i13) | 0;
   i23 = (i24 | 0) == 0;
   i3 = i2;
   i12 = 0;
   i10 = gb + 1057535 | 0;
   i4 = i23 ? i2 + i13 | 0 : i24;
   i2 = i23 ? i13 : i24 - i2 | 0;
  } else if ((i27 | 0) == 85) {
   i27 = 0;
   i7 = i4;
   i2 = 0;
   i3 = 0;
   while (1) {
    i5 = HEAP32[i7 >> 2] | 0;
    if (!i5) break;
    i3 = _wctomb(i30, i5) | 0;
    if ((i3 | 0) < 0 | i3 >>> 0 > (i9 - i2 | 0) >>> 0) break;
    i2 = i3 + i2 | 0;
    if (i9 >>> 0 > i2 >>> 0) i7 = i7 + 4 | 0; else break;
   }
   if ((i3 | 0) < 0) {
    i1 = -1;
    break L1;
   }
   _pad(i28, 32, i8, i2, i24);
   if (!i2) {
    i2 = 0;
    i27 = 96;
   } else {
    i5 = 0;
    while (1) {
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i27 = 96;
      break L310;
     }
     i3 = _wctomb(i30, i3) | 0;
     i5 = i3 + i5 | 0;
     if ((i5 | 0) > (i2 | 0)) {
      i27 = 96;
      break L310;
     }
     if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i30, i3, i28) | 0;
     if (i5 >>> 0 >= i2 >>> 0) {
      i27 = 96;
      break;
     } else i4 = i4 + 4 | 0;
    }
   }
  } while (0);
  if ((i27 | 0) == 96) {
   i27 = 0;
   _pad(i28, 32, i8, i2, i24 ^ 8192);
   i2 = (i8 | 0) > (i2 | 0) ? i8 : i2;
   i8 = i26;
   i3 = i25;
   continue;
  }
  if ((i27 | 0) == 76) {
   i27 = 0;
   i9 = (i7 | 0) > -1 ? i2 & -65537 : i2;
   i2 = i51;
   i2 = (HEAP32[i2 >> 2] | 0) != 0 | (HEAP32[i2 + 4 >> 2] | 0) != 0;
   if ((i7 | 0) != 0 | i2) {
    i2 = (i2 & 1 ^ 1) + (i33 - i3) | 0;
    i12 = i4;
    i10 = i5;
    i4 = i32;
    i2 = (i7 | 0) > (i2 | 0) ? i7 : i2;
   } else {
    i3 = i32;
    i12 = i4;
    i10 = i5;
    i4 = i32;
    i2 = 0;
   }
  }
  i7 = i4 - i3 | 0;
  i4 = (i2 | 0) < (i7 | 0) ? i7 : i2;
  i5 = i4 + i12 | 0;
  i2 = (i8 | 0) < (i5 | 0) ? i5 : i8;
  _pad(i28, 32, i2, i5, i9);
  if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i10, i12, i28) | 0;
  _pad(i28, 48, i2, i5, i9 ^ 65536);
  _pad(i28, 48, i4, i7, 0);
  if (!(HEAP32[i28 >> 2] & 32)) ___fwritex(i3, i7, i28) | 0;
  _pad(i28, 32, i2, i5, i9 ^ 8192);
  i8 = i26;
  i3 = i25;
 }
 L345 : do if ((i27 | 0) == 243) if (!i28) if (!i8) i1 = 0; else {
  i1 = 1;
  while (1) {
   i2 = HEAP32[i54 + (i1 << 2) >> 2] | 0;
   if (!i2) break;
   _pop_arg(i53 + (i1 << 3) | 0, i2, i52);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 10) {
    i1 = 1;
    break L345;
   }
  }
  while (1) {
   if (HEAP32[i54 + (i1 << 2) >> 2] | 0) {
    i1 = -1;
    break L345;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 10) {
    i1 = 1;
    break;
   }
  }
 } while (0);
 STACKTOP = i55;
 return i1 | 0;
}

function __Z20DoDeferredRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb(i53, i11, i35, i33, i40, i55, i41) {
 i53 = i53 | 0;
 i11 = i11 | 0;
 i35 = i35 | 0;
 i33 = i33 | 0;
 i40 = i40 | 0;
 i55 = i55 | 0;
 i41 = i41 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, f61 = f0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i60 + 24 | 0;
 i51 = i60 + 16 | 0;
 i56 = i60 + 160 | 0;
 i19 = i60 + 144 | 0;
 i28 = i60;
 i21 = i60 + 136 | 0;
 i45 = i60 + 120 | 0;
 i22 = i60 + 104 | 0;
 i23 = i60 + 96 | 0;
 i24 = i60 + 92 | 0;
 i54 = i60 + 88 | 0;
 i47 = i60 + 72 | 0;
 i42 = i60 + 68 | 0;
 i27 = i60 + 8 | 0;
 i58 = i60 + 48 | 0;
 i48 = i60 + 44 | 0;
 i36 = i60 + 40 | 0;
 i37 = i60 + 208 | 0;
 i38 = i60 + 204 | 0;
 i39 = i60 + 200 | 0;
 i43 = i60 + 196 | 0;
 i44 = i60 + 192 | 0;
 i49 = i60 + 152 | 0;
 i50 = HEAP32[gb + 1166248 >> 2] | 0;
 i57 = i50 + 4 | 0;
 HEAP32[i56 >> 2] = HEAP32[i57 >> 2];
 HEAP32[i56 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
 HEAP32[i56 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
 HEAP32[i56 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
 HEAP32[i56 + 16 >> 2] = HEAP32[i57 + 16 >> 2];
 HEAP32[i56 + 20 >> 2] = HEAP32[i57 + 20 >> 2];
 HEAP32[i56 + 24 >> 2] = HEAP32[i57 + 24 >> 2];
 HEAP32[i56 + 28 >> 2] = HEAP32[i57 + 28 >> 2];
 HEAP32[i40 >> 2] = 0;
 HEAP32[i55 >> 2] = 0;
 HEAP8[i41 >> 0] = 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(__ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 0) | 0, gb + 1115120 | 0, 2);
 if (!(HEAP32[gb + 1115120 >> 2] | 0)) {
  STACKTOP = i60;
  return;
 }
 i59 = __ZnwjRK10MemLabelIdiPKci(412, gb + 64024 | 0, 16, gb + 387579 | 0, 1457) | 0;
 i14 = gb + 64024 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i59 + 4 >> 2] = 1;
 HEAP32[i59 >> 2] = gb + 36776 + 8;
 i17 = i51;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i17 + 4 >> 2] = i14;
 i17 = i59 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i59 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 i4 = i59 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = i59 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i34 = i52;
 i30 = HEAP32[i34 + 4 >> 2] | 0;
 i31 = i9;
 HEAP32[i31 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i31 + 4 >> 2] = i30;
 i31 = i51;
 HEAP32[i31 >> 2] = i15;
 HEAP32[i31 + 4 >> 2] = i14;
 HEAP32[i59 + 36 >> 2] = 0;
 HEAP32[i59 + 48 >> 2] = 0;
 HEAP32[i59 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i31 = i52;
 i30 = HEAP32[i31 + 4 >> 2] | 0;
 i34 = i59 + 40 | 0;
 HEAP32[i34 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i34 + 4 >> 2] = i30;
 i34 = i59 + 56 | 0;
 HEAP32[i34 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i30 = i59 + 68 | 0;
 HEAPF32[i30 >> 2] = f6;
 i31 = i59 + 72 | 0;
 HEAPF32[i31 >> 2] = f7;
 i32 = i59 + 76 | 0;
 HEAPF32[i32 >> 2] = f8;
 i20 = i59 + 84 | 0;
 HEAP32[i20 >> 2] = 0;
 i13 = i51;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i59 + 88 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i59 + 100 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i59 + 104 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i59 + 92 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i12 = i52;
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 i46 = i16;
 HEAP32[i46 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i46 + 4 >> 2] = i10;
 i46 = i59 + 408 | 0;
 HEAP8[i46 >> 0] = HEAP8[i46 >> 0] & -4 | 2;
 HEAP32[i59 + 8 >> 2] = i53;
 i10 = HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0;
 HEAP8[i46 >> 0] = (i10 << 24 >> 24 != 0 & (HEAP8[i50 + 149 >> 0] | 0) == 0 & 1) << 1 & 255 | HEAP8[i46 >> 0] & -3;
 i10 = HEAP32[i11 >> 2] | 0;
 i12 = i11 + 12 | 0;
 i1 = HEAP32[i12 >> 2] << 5;
 i2 = i1 >> 5;
 HEAP32[i18 >> 2] = i2;
 i3 = HEAP32[i4 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i17 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] << 5 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i17 >> 2] = i1;
  break;
 } else i1 = HEAP32[i17 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i10 | 0, HEAP32[i18 >> 2] << 5 | 0) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i15 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 2, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i26 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i13 >> 2] = i26;
  break;
 } while (0);
 HEAP32[i14 >> 2] = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i26 = HEAP32[i12 >> 2] | 0;
 i12 = i1 + (i26 << 5) | 0;
 L17 : do if (i26 | 0) {
  i11 = 0;
  i4 = 0;
  while (1) {
   i3 = i4 + 1 | 0;
   i9 = HEAP32[i15 >> 2] | 0;
   i10 = i9 & 2147483647;
   do if (i3 >>> 0 > i10 >>> 0) {
    i2 = i9 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
     HEAP32[i15 >> 2] = i2;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i26 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i13 >> 2] = i26;
     break;
    }
   } while (0);
   HEAP32[i14 >> 2] = i3;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] = i11;
   i1 = i1 + 32 | 0;
   if ((i1 | 0) == (i12 | 0)) break L17;
   i11 = i11 + 1 | 0;
   i4 = HEAP32[i14 >> 2] | 0;
  }
 } while (0);
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 i26 = i53 + 8 | 0;
 i2 = (HEAP32[i26 >> 2] | 0) + 1064 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 509 >> 0] | 0)) i1 = 1; else {
  i1 = HEAP32[i2 >> 2] | 0;
  i29 = 16;
 } else i29 = 16;
 if ((i29 | 0) == 16) i1 = (i1 | 0) == 1;
 i9 = HEAP32[i53 + 1832 >> 2] | 0;
 i25 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
 HEAP32[i3 >> 2] = i25;
 HEAP32[i3 + 4 >> 2] = i25 + (i4 << 5);
 HEAP32[i3 + 8 >> 2] = i4 << 5 >> 5;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = i1 & 1;
 HEAP32[i4 + 4 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = gb + 1114588;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i19, fb + 3345 | 0, i3, i52, 0);
 i3 = __Z19GetLightmapSettingsv() | 0;
 i4 = i59 + 276 | 0;
 i1 = (__Z17GetRenderSettingsv() | 0) + 192 | 0;
 i9 = i4 + 108 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i9 | 0));
 HEAP32[i59 + 384 >> 2] = HEAP32[i3 + 80 >> 2];
 i1 = __ZNK16LightmapSettings14GetLightProbesEv(i3) | 0;
 if (!i1) i29 = 20; else {
  i2 = i1 + 32 | 0;
  if (!(__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2) | 0)) i29 = 20; else {
   HEAP32[i59 + 388 >> 2] = i2;
   HEAP32[i59 + 392 >> 2] = i1 + 148;
   HEAP32[i59 + 396 >> 2] = i1 + 168;
   HEAP32[i59 + 400 >> 2] = HEAP32[i1 + 188 >> 2];
  }
 }
 if ((i29 | 0) == 20) {
  i25 = i59 + 388 | 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
 }
 i1 = (__ZNK16LightmapSettings19AreLightProbesBakedEv(i3) | 0) & 1;
 i25 = i59 + 404 | 0;
 HEAP8[i25 >> 0] = HEAP8[i25 >> 0] & -2 | i1;
 i1 = __ZNK16LightmapSettings23HasLightProbeTetrahedraEv(i3) | 0;
 i3 = HEAP8[i25 >> 0] | 0;
 HEAP8[i25 >> 0] = (i1 ? i3 << 1 & 2 : 0) | i3 & -3;
 i25 = __ZnwjRK10MemLabelIdiPKci(184, gb + 64024 | 0, 16, gb + 387579 | 0, 1487) | 0;
 HEAP32[i25 + 4 >> 2] = 1;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 >> 2] = gb + 36756 + 8;
 i3 = i25 + 12 | 0;
 i1 = i25 + 48 | 0;
 i2 = i25 + 52 | 0;
 i4 = i3;
 i9 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i9 | 0));
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 i4 = gb + 64024 | 0;
 i17 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = i51;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i25 + 80 >> 2] = 0;
 HEAP32[i25 + 92 >> 2] = 0;
 HEAP32[i25 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i16 = i52;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = i25 + 84 | 0;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i4 + 4 >> 2] = i17;
 i4 = gb + 64024 | 0;
 i17 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = i51;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i25 + 100 >> 2] = 0;
 HEAP32[i25 + 112 >> 2] = 0;
 HEAP32[i25 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i16 = i52;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = i25 + 104 | 0;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i4 + 4 >> 2] = i17;
 i4 = gb + 64024 | 0;
 i17 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = i51;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i25 + 120 >> 2] = 0;
 HEAP32[i25 + 132 >> 2] = 0;
 HEAP32[i25 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i51);
 i16 = i52;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = i25 + 124 | 0;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i4 + 4 >> 2] = i17;
 HEAP32[i25 + 140 >> 2] = 0;
 HEAP32[i25 + 144 >> 2] = 0;
 i4 = gb + 64024 | 0;
 i17 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = i25 + 148 | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 i16 = i25 + 156 | 0;
 HEAP8[i16 >> 0] = 1;
 i17 = i25 + 56 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 i17 = i25 + 160 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP8[i25 + 161 >> 0] = 0;
 HEAP32[i25 + 164 >> 2] = 0;
 i4 = i25 + 172 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i25 + 176 >> 2] = 0;
 HEAP32[i25 + 180 >> 2] = HEAP32[i18 >> 2];
 __ZN17ShaderPassContext8CopyFromERKS_(i3, i50);
 HEAP8[i16 >> 0] = 0;
 HEAP8[i17 >> 0] = 0;
 i18 = i33 + 312 | 0;
 if (!(HEAP8[i33 + 332 >> 0] | 0)) {
  i1 = 0;
  i16 = 0;
  i17 = 0;
 } else {
  i1 = HEAP32[i18 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i16 = 0;
   i17 = 0;
  } else {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i1 = 0;
    i16 = 0;
    i17 = 0;
   } else {
    if ((HEAP32[i2 + 40 >> 2] | 0) == 3) i1 = 2; else i1 = HEAP32[i2 + 80 >> 2] | 0;
    i1 = (i1 | 0) == 1 & 1;
    i16 = i2;
    i17 = 1;
   }
  }
 }
 HEAP8[i4 >> 0] = i1;
 HEAP32[i20 >> 2] = i35;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i21 >> 2] = i25;
 HEAP32[i21 + 4 >> 2] = i59;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i28, fb + 3346 | 0, i21, i19, 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i19);
 i13 = __Z12GetGfxDevicev() | 0;
 __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_(HEAP32[i26 >> 2] | 0, i22, i23, i24);
 f8 = Math_fround(HEAPF32[i23 >> 2]);
 __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f(HEAP32[i26 >> 2] | 0, Math_fround(1.0), f8, Math_fround(HEAPF32[i24 >> 2]), i45);
 i24 = i13 + 948 | 0;
 HEAP32[i24 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 __ZNK14RenderSettings19GetFlatAmbientColorEv(i52, __Z17GetRenderSettingsv() | 0);
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f5 = Math_fround(HEAPF32[i52 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f7 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  f5 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f6 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  f5 = Math_fround(HEAPF32[i52 + 8 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = i52 + 12 | 0;
 } else {
  i3 = HEAP32[i52 >> 2] | 0;
  i4 = HEAP32[i52 + 4 >> 2] | 0;
  i1 = HEAP32[i52 + 8 >> 2] | 0;
  i2 = i52 + 12 | 0;
 }
 i15 = HEAP32[i2 >> 2] | 0;
 HEAP32[i13 + 692 >> 2] = i3;
 HEAP32[i13 + 696 >> 2] = i4;
 HEAP32[i13 + 700 >> 2] = i1;
 HEAP32[i13 + 704 >> 2] = i15;
 i15 = __Z12GetGfxDevicev() | 0;
 i14 = HEAP32[(HEAP32[i26 >> 2] | 0) + 1144 >> 2] | 0;
 HEAP32[i54 >> 2] = i14;
 __ZN13RenderTexture6CreateEv(i14) | 0;
 i14 = i59 + 108 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i24 = HEAP32[i33 + 324 >> 2] | 0;
 i3 = i1 + (i24 * 180 | 0) | 0;
 if (!i24) i10 = 0; else {
  i2 = -1;
  do {
   i24 = HEAP32[i1 + 16 >> 2] | 0;
   i2 = ((i24 | 0) == 0 ? -1 : i24) & i2;
   i1 = i1 + 180 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i10 = ~i2;
 }
 HEAP32[i14 >> 2] = i10;
 i4 = i59 + 112 | 0;
 i9 = i4 + 128 | 0;
 do {
  HEAP32[i4 >> 2] = -1;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i9 | 0));
 i9 = i59 + 240 | 0;
 HEAP32[i9 >> 2] = 0;
 i3 = 1;
 i2 = 3;
 i4 = 0;
 i1 = 0;
 while (1) {
  if (i3 & i10) {
   if ((i1 | 0) < 4) {
    HEAP32[i14 + 4 + (i4 << 2) >> 2] = i2;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == 32) break; else i3 = i3 << 1;
 }
 i11 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 1) | 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(i11, gb + 1115116 | 0, 1);
 HEAP8[i46 >> 0] = (HEAP32[i11 + 4 >> 2] | 0) != 0 & (HEAP32[gb + 1115116 >> 2] | 0) != 0 & 1 | HEAP8[i46 >> 0] & -2;
 i11 = i50 + 148 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = (HEAP8[(HEAP32[i26 >> 2] | 0) + 1092 >> 0] | 0) != 0;
 i24 = HEAP32[i45 + 4 >> 2] | 0;
 i10 = i13 + 708 | 0;
 HEAP32[i10 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i13 + 712 >> 2] = i24;
 HEAP32[i13 + 716 >> 2] = 1065353216;
 HEAP32[i13 + 720 >> 2] = 1065353216;
 i24 = HEAP32[i54 >> 2] | 0;
 i21 = i28;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i23 = i27;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = i22;
 __ZN18DeferredRenderLoop13RenderGBufferEP13RenderTexturePS1_b8JobFencePK25DeferredRenderLoopScratchRi(i59, i24, i47, i12, i27, i25, i42);
 HEAP32[i40 >> 2] = HEAP32[i47 >> 2];
 if (HEAP32[i28 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i28);
 f8 = Math_fround(HEAPF32[i34 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f8 == f5) {
  f7 = Math_fround(HEAPF32[i59 + 60 >> 2]);
  if (f7 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f7 = Math_fround(HEAPF32[i59 + 64 >> 2]);
   if (!(f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2]))) i29 = 69;
  } else i29 = 69;
 } else i29 = 69;
 do if ((i29 | 0) == 69) {
  f5 = Math_fround(-f5);
  f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  f7 = Math_fround(HEAPF32[i30 >> 2]);
  if (f7 == f5) {
   f61 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f5 = Math_fround(HEAPF32[i31 >> 2]);
   if (f5 == f61) if (!(Math_fround(HEAPF32[i32 >> 2]) != f6)) break;
  } else f5 = Math_fround(HEAPF32[i31 >> 2]);
  HEAPF32[i34 >> 2] = Math_fround(f8 + Math_fround(-.00999999977));
  i29 = i59 + 60 | 0;
  HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + Math_fround(-.00999999977));
  i29 = i59 + 64 | 0;
  HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + Math_fround(-.00999999977));
  HEAPF32[i30 >> 2] = Math_fround(f7 + Math_fround(.00999999977));
  HEAPF32[i31 >> 2] = Math_fround(f5 + Math_fround(.00999999977));
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + Math_fround(.00999999977));
 } while (0);
 HEAP32[i58 + 8 >> 2] = 0;
 i9 = i58 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i58 + 16 >> 2] = 0;
 __Z24SetupActiveLightsContextR21ActiveLightingContextRK12ActiveLightsRK11CullResultsP14ShadowMapCacheRK10MinMaxAABB(i58, i18, i33, HEAP32[i53 + 1728 >> 2] | 0, i34);
 i4 = HEAP32[i54 >> 2] | 0;
 HEAP32[i48 >> 2] = HEAP32[i4 + 124 >> 2];
 i4 = HEAP32[i4 + 100 >> 2] | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) {
  if (i17) if ((HEAP32[i16 + 40 >> 2] | 0) == 1) i1 = (HEAP32[i16 + 96 >> 2] | 0) != 0; else i1 = 0; else i1 = 0;
  i2 = HEAP32[i26 >> 2] | 0;
  i3 = HEAP32[i2 + 1072 >> 2] & 1;
  if (!((i3 | 0) == 0 & (i1 ^ 1))) {
   if ((HEAP16[gb + 1114648 + 6 >> 1] | 0) > -1) {
    HEAP32[i51 >> 2] = i2;
    HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114648 | 0, i52);
    i1 = gb + 1114648 | 0;
   } else i1 = 0;
   i2 = HEAP32[gb + 1114648 >> 2] | 0;
   i34 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 648 >> 2] | 0, i34 | 0, i2 | 0);
   i2 = HEAP32[gb + 1163232 >> 2] | 0;
   HEAP32[gb + 1163232 >> 2] = 1;
   i34 = HEAP32[i54 >> 2] | 0;
   HEAP32[i36 >> 2] = HEAP32[i34 + 128 >> 2];
   HEAP32[i37 >> 2] = HEAP32[(HEAP32[i47 >> 2] | 0) + 128 >> 2];
   HEAP32[i38 >> 2] = HEAP32[i34 + 136 >> 2];
   HEAP32[i51 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i52 >> 2] = HEAP32[i38 >> 2];
   __Z29RenderForwardObjectsIntoDepthRK17RenderLoopContextP13RenderTextureP13dynamic_arrayI16RenderObjectDataLj4EE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseESC_iib(i53, i34, i35, i51, i52, 0, 0, (i3 | 0) != 0);
   if (i12) {
    HEAP32[i39 >> 2] = HEAP32[(HEAP32[i54 >> 2] | 0) + 136 >> 2];
    HEAP32[i52 >> 2] = HEAP32[i39 >> 2];
    __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i36, i52, i54, 0, -1, 0, 0) | 0;
   }
   HEAP32[gb + 1163232 >> 2] = i2;
   i39 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i39 >> 2] | 0) + 652 >> 2] | 0, i39 | 0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  }
 }
 __Z31ResolveDepthIntoTextureIfNeededR9GfxDeviceR10RenderLoop17DepthBufferFormatRP13RenderTextureP9TextureIDPb(i15, HEAP32[i53 + 1888 >> 2] | 0, i4, i40, i48, i41);
 i1 = HEAP32[i54 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i54 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0) | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) {
  i41 = i50 + 36 | 0;
  i40 = HEAP32[i48 >> 2] | 0;
  HEAP32[i43 >> 2] = i40;
  i39 = HEAP32[i54 >> 2] | 0;
  f61 = Math_fround(HEAPF32[i39 + 68 >> 2]);
  f8 = Math_fround(HEAPF32[i39 + 72 >> 2]);
  HEAP32[i52 >> 2] = HEAP32[i43 >> 2];
  __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff(i41, gb + 1114752 | 0, i52, i1, i2, f61, f8);
  HEAP32[i44 >> 2] = i40;
  i43 = HEAP32[i54 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i43 + 68 >> 2]);
  f61 = Math_fround(HEAPF32[i43 + 72 >> 2]);
  HEAP32[i52 >> 2] = HEAP32[i44 >> 2];
  __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff(i41, gb + 1114760 | 0, i52, i1, i2, f8, f61);
 }
 i2 = HEAP32[i42 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i3 = i50 + 36 | 0;
  i1 = 0;
  do {
   __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i3, gb + 1114772 + (i1 << 2) | 0, HEAP32[i47 + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
 }
 if (HEAP8[i46 >> 0] & 1) {
  __ZN18DeferredRenderLoop17RenderReflectionsEP13RenderTexturePS1_(i59, HEAP32[i54 >> 2] | 0, i52);
  __ZN18DeferredRenderLoop24AddReflectionsToEmissionEP13RenderTextureS1_(i59, HEAP32[i52 >> 2] | 0, HEAP32[i47 + 12 >> 2] | 0);
 };
 HEAP32[i10 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = HEAP32[i54 >> 2] | 0;
 HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
 i48 = (HEAP8[i59 + 80 >> 0] | 0) != 0;
 HEAP32[i52 >> 2] = HEAP32[i49 >> 2];
 __ZN18DeferredRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDPS3_iRK8Vector4fRK14LightingLayersR10MinMaxAABBb(i59, i58, i46, i52, i47, 0, i45, i14, 0, i48);
 HEAP8[i11 >> 0] = 1;
 if (i12) {
  i49 = HEAP32[i26 >> 2] | 0;
  i48 = i53 + 1836 | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i49 + 1136 | 0, 8, i50, HEAP32[i48 >> 2] | 0, gb + 1159956 | 0, HEAP32[i49 + 4 >> 2] | 0);
  i49 = HEAP32[i26 >> 2] | 0;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i49 + 1136 | 0, 8, i50, HEAP32[i48 >> 2] | 0, gb + 1159956 | 0, HEAP32[i49 + 4 >> 2] | 0);
  i49 = HEAP32[i26 >> 2] | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i49 + 1136 | 0, 9, i50, HEAP32[i48 >> 2] | 0, gb + 1159956 | 0, HEAP32[i49 + 4 >> 2] | 0);
  i49 = HEAP32[i26 >> 2] | 0;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i49 + 1136 | 0, 9, i50, HEAP32[i48 >> 2] | 0, gb + 1159956 | 0, HEAP32[i49 + 4 >> 2] | 0);
 } else __ZN18DeferredRenderLoop15RenderFinalPassEP13RenderTextureS1_(i59, HEAP32[i54 >> 2] | 0, HEAP32[i47 + 12 >> 2] | 0);
 i50 = HEAP32[i26 >> 2] | 0;
 i1 = i50;
 if (HEAP32[i50 + 1072 >> 2] & 2 | 0) {
  if ((HEAP16[gb + 1114660 + 6 >> 1] | 0) > -1) {
   HEAP32[i51 >> 2] = i1;
   HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114660 | 0, i52);
   i1 = gb + 1114660 | 0;
  } else i1 = 0;
  i51 = HEAP32[gb + 1114660 >> 2] | 0;
  i50 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 648 >> 2] | 0, i50 | 0, i51 | 0);
  HEAP32[i55 >> 2] = __Z26CombineDepthNormalsTextureRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EE(i53, 0) | 0;
  i55 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i55 >> 2] | 0) + 652 >> 2] | 0, i55 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i54 >> 2] | 0, 0, -1, 0, 0);
 if (HEAP8[(HEAP32[i26 >> 2] | 0) + 1093 >> 0] | 0) {
  HEAP32[i52 >> 2] = 0;
  HEAP32[i52 + 4 >> 2] = 0;
  HEAP32[i52 + 8 >> 2] = 0;
  HEAP32[i52 + 12 >> 2] = 0;
  mftCall_viiifi(HEAP32[(HEAP32[i15 >> 2] | 0) + 32 >> 2] | 0, i15 | 0, 4, i52 | 0, 1.0, 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0, i53 + 1732 | 0);
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 148 >> 2] | 0, i15 | 0, 0);
 HEAPF32[i15 + 608 >> 2] = Math_fround(1.0);
 i2 = HEAP32[i58 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i3 = HEAP32[i58 + 4 >> 2] | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0;
   do if (i4 | 0) {
    i55 = i4 + 4 | 0;
    HEAP32[i55 >> 2] = (HEAP32[i55 >> 2] | 0) + -1;
    if (HEAP32[i55 >> 2] | 0) break;
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 do if (i1 | 0) {
  i55 = i1 + 4 | 0;
  HEAP32[i55 >> 2] = (HEAP32[i55 >> 2] | 0) + -1;
  if (HEAP32[i55 >> 2] | 0) break;
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 } while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i58 + 4 >> 2] | 0, gb + 64016 | 0);
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 296 >> 2] | 0, i15 | 0, i25 | 0);
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 296 >> 2] | 0, i15 | 0, i59 | 0);
 HEAP32[i57 >> 2] = HEAP32[i56 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
 HEAP32[i57 + 16 >> 2] = HEAP32[i56 + 16 >> 2];
 HEAP32[i57 + 20 >> 2] = HEAP32[i56 + 20 >> 2];
 HEAP32[i57 + 24 >> 2] = HEAP32[i56 + 24 >> 2];
 HEAP32[i57 + 28 >> 2] = HEAP32[i56 + 28 >> 2];
 STACKTOP = i60;
 return;
}

function __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378523 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378530 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378537 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378544 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378551 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378558 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378565 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378572 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378579 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378586 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378593 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378600 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378607 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378614 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378621 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378628 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 171; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 171;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378635 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 182; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 182;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 182) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378642 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 193; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 193;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 193) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378649 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 204; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 204;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 204) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378656 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 215; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 215;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 215) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378663 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 226; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 226;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 226) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378670 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 237; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 237;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 237) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378677 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 248; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 248;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 248) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378684 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 259; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 259;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 259) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378691 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 270; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 270;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 270) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378698 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 281; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 281;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 281) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378705 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 292; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 292;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 292) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i9 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx19PxsFluidSpatialHash14getHaloRegionsERNS_25PxsFluidPacketHaloRegionsERKNS_17PxcGridCellVectorEPKNS_15PxsParticleCellEPKNS_22PxsFluidPacketSectionsEj(i25, i7, i24, i23, i1) {
 i25 = i25 | 0;
 i7 = i7 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 _memset(i25 | 0, 0, 788) | 0;
 i3 = HEAP16[i7 >> 1] | 0;
 i21 = (i3 & 65535) + 65535 | 0;
 i2 = i21 & 65535;
 i6 = i7 + 2 | 0;
 i4 = HEAP16[i6 >> 1] | 0;
 i8 = i7 + 4 | 0;
 i5 = HEAP16[i8 >> 1] | 0;
 i22 = i1 + -1 | 0;
 i1 = (i21 << 16 >> 16) + ((i4 << 16 >> 16) * 101 | 0) + ((i5 << 16 >> 16) * 7919 | 0) & i22;
 L1 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i2 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L1;
  }
  if (i24 + (i1 << 4) | 0) {
   i2 = i25 + 392 | 0;
   i3 = i23 + (i1 * 216 | 0) + 144 | 0;
   i4 = i2 + 36 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i25;
   i3 = i23 + (i1 * 216 | 0) + 36 | 0;
   i4 = i2 + 36 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i3 = HEAP16[i7 >> 1] | 0;
   i4 = HEAP16[i6 >> 1] | 0;
   i5 = HEAP16[i8 >> 1] | 0;
  }
 } while (0);
 i1 = (i3 & 65535) + 1 | 0;
 i2 = i1 & 65535;
 i1 = (i1 << 16 >> 16) + ((i4 << 16 >> 16) * 101 | 0) + ((i5 << 16 >> 16) * 7919 | 0) & i22;
 L11 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i2 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L11;
  }
  if (i24 + (i1 << 4) | 0) {
   i2 = i25 + 428 | 0;
   i3 = i23 + (i1 * 216 | 0) + 108 | 0;
   i4 = i2 + 36 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i25 + 36 | 0;
   i3 = i23 + (i1 * 216 | 0) | 0;
   i4 = i2 + 36 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i4 = HEAP16[i6 >> 1] | 0;
   i3 = HEAP16[i7 >> 1] | 0;
   i5 = HEAP16[i8 >> 1] | 0;
  }
 } while (0);
 i2 = i4 & 65535;
 i16 = i2 + 65535 | 0;
 i20 = i16 & 65535;
 i9 = i3 << 16 >> 16;
 i16 = (i16 << 16 >> 16) * 101 | 0;
 i7 = (i5 << 16 >> 16) * 7919 | 0;
 i6 = i7 + i9 | 0;
 i1 = i6 + i16 & i22;
 L21 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i20 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L21;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 464 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
   HEAP32[i25 + 72 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
   HEAP32[i25 + 468 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
   HEAP32[i25 + 76 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
   HEAP32[i25 + 472 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 128 >> 2];
   HEAP32[i25 + 80 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 20 >> 2];
   HEAP32[i25 + 476 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
   HEAP32[i25 + 84 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
   HEAP32[i25 + 480 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
   HEAP32[i25 + 88 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
   HEAP32[i25 + 484 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 164 >> 2];
   HEAP32[i25 + 92 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 56 >> 2];
   HEAP32[i25 + 488 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 192 >> 2];
   HEAP32[i25 + 96 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 84 >> 2];
   HEAP32[i25 + 492 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 196 >> 2];
   HEAP32[i25 + 100 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 88 >> 2];
   HEAP32[i25 + 496 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 200 >> 2];
   HEAP32[i25 + 104 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 92 >> 2];
  }
 } while (0);
 i19 = i2 + 1 | 0;
 i21 = i19 & 65535;
 i19 = (i19 << 16 >> 16) * 101 | 0;
 i1 = i6 + i19 & i22;
 L31 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i21 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L31;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 500 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
   HEAP32[i25 + 108 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
   HEAP32[i25 + 504 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
   HEAP32[i25 + 112 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
   HEAP32[i25 + 508 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 116 >> 2];
   HEAP32[i25 + 116 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 8 >> 2];
   HEAP32[i25 + 512 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
   HEAP32[i25 + 120 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
   HEAP32[i25 + 516 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
   HEAP32[i25 + 124 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
   HEAP32[i25 + 520 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 152 >> 2];
   HEAP32[i25 + 128 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 44 >> 2];
   HEAP32[i25 + 524 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 180 >> 2];
   HEAP32[i25 + 132 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 72 >> 2];
   HEAP32[i25 + 528 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 184 >> 2];
   HEAP32[i25 + 136 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 76 >> 2];
   HEAP32[i25 + 532 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 188 >> 2];
   HEAP32[i25 + 140 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 80 >> 2];
  }
 } while (0);
 i2 = i5 & 65535;
 i15 = i2 + 65535 | 0;
 i18 = i15 & 65535;
 i8 = (i4 << 16 >> 16) * 101 | 0;
 i6 = i8 + i9 | 0;
 i15 = (i15 << 16 >> 16) * 7919 | 0;
 i1 = i6 + i15 & i22;
 L41 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L41;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 536 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
   HEAP32[i25 + 144 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
   HEAP32[i25 + 540 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
   HEAP32[i25 + 148 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
   HEAP32[i25 + 544 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 136 >> 2];
   HEAP32[i25 + 152 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 28 >> 2];
   HEAP32[i25 + 548 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
   HEAP32[i25 + 156 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
   HEAP32[i25 + 552 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
   HEAP32[i25 + 160 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
   HEAP32[i25 + 556 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 172 >> 2];
   HEAP32[i25 + 164 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 64 >> 2];
   HEAP32[i25 + 560 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 184 >> 2];
   HEAP32[i25 + 168 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 76 >> 2];
   HEAP32[i25 + 564 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 196 >> 2];
   HEAP32[i25 + 172 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 88 >> 2];
   HEAP32[i25 + 568 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 208 >> 2];
   HEAP32[i25 + 176 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 100 >> 2];
  }
 } while (0);
 i14 = i2 + 1 | 0;
 i17 = i14 & 65535;
 i14 = (i14 << 16 >> 16) * 7919 | 0;
 i1 = i6 + i14 & i22;
 L51 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L51;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 572 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
   HEAP32[i25 + 180 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
   HEAP32[i25 + 576 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
   HEAP32[i25 + 184 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
   HEAP32[i25 + 580 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 132 >> 2];
   HEAP32[i25 + 188 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 24 >> 2];
   HEAP32[i25 + 584 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
   HEAP32[i25 + 192 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
   HEAP32[i25 + 588 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
   HEAP32[i25 + 196 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
   HEAP32[i25 + 592 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 168 >> 2];
   HEAP32[i25 + 200 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 60 >> 2];
   HEAP32[i25 + 596 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 180 >> 2];
   HEAP32[i25 + 204 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 72 >> 2];
   HEAP32[i25 + 600 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 192 >> 2];
   HEAP32[i25 + 208 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 84 >> 2];
   HEAP32[i25 + 604 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 204 >> 2];
   HEAP32[i25 + 212 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 96 >> 2];
  }
 } while (0);
 i2 = i3 & 65535;
 i10 = i2 + 65535 | 0;
 i11 = i10 & 65535;
 i10 = i10 << 16 >> 16;
 i6 = i7 + i10 | 0;
 i1 = i6 + i16 & i22;
 L61 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i20 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L61;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 608 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
   HEAP32[i25 + 216 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
   HEAP32[i25 + 612 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
   HEAP32[i25 + 220 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
   HEAP32[i25 + 616 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 164 >> 2];
   HEAP32[i25 + 224 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 56 >> 2];
  }
 } while (0);
 i12 = i2 + 1 | 0;
 i13 = i12 & 65535;
 i12 = i12 << 16 >> 16;
 i2 = i7 + i12 | 0;
 i1 = i2 + i16 & i22;
 L71 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i20 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L71;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 620 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
   HEAP32[i25 + 228 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
   HEAP32[i25 + 624 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
   HEAP32[i25 + 232 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
   HEAP32[i25 + 628 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 128 >> 2];
   HEAP32[i25 + 236 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 20 >> 2];
  }
 } while (0);
 i1 = i6 + i19 & i22;
 L81 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i21 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L81;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 632 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
   HEAP32[i25 + 240 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
   HEAP32[i25 + 636 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
   HEAP32[i25 + 244 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
   HEAP32[i25 + 640 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 152 >> 2];
   HEAP32[i25 + 248 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 44 >> 2];
  }
 } while (0);
 i1 = i2 + i19 & i22;
 L91 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i21 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L91;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 644 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
   HEAP32[i25 + 252 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
   HEAP32[i25 + 648 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
   HEAP32[i25 + 256 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
   HEAP32[i25 + 652 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 116 >> 2];
   HEAP32[i25 + 260 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 8 >> 2];
  }
 } while (0);
 i5 = i10 + i8 | 0;
 i1 = i5 + i15 & i22;
 L101 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L101;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 656 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
   HEAP32[i25 + 264 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
   HEAP32[i25 + 660 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
   HEAP32[i25 + 268 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
   HEAP32[i25 + 664 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 172 >> 2];
   HEAP32[i25 + 272 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 64 >> 2];
  }
 } while (0);
 i2 = i12 + i8 | 0;
 i1 = i2 + i15 & i22;
 L111 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L111;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 668 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
   HEAP32[i25 + 276 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
   HEAP32[i25 + 672 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
   HEAP32[i25 + 280 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
   HEAP32[i25 + 676 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 136 >> 2];
   HEAP32[i25 + 284 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 28 >> 2];
  }
 } while (0);
 i1 = i5 + i14 & i22;
 L121 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L121;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 680 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
   HEAP32[i25 + 288 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
   HEAP32[i25 + 684 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
   HEAP32[i25 + 292 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
   HEAP32[i25 + 688 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 168 >> 2];
   HEAP32[i25 + 296 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 60 >> 2];
  }
 } while (0);
 i1 = i2 + i14 & i22;
 L131 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L131;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 692 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
   HEAP32[i25 + 300 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
   HEAP32[i25 + 696 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
   HEAP32[i25 + 304 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
   HEAP32[i25 + 700 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 132 >> 2];
   HEAP32[i25 + 308 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 24 >> 2];
  }
 } while (0);
 i4 = i16 + i9 | 0;
 i1 = i4 + i15 & i22;
 L141 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  while (1) {
   if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) if (i20 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break;
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L141;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 704 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
   HEAP32[i25 + 312 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
   HEAP32[i25 + 708 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
   HEAP32[i25 + 316 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
   HEAP32[i25 + 712 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 196 >> 2];
   HEAP32[i25 + 320 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 88 >> 2];
  }
 } while (0);
 i2 = i19 + i9 | 0;
 i1 = i2 + i15 & i22;
 L151 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L152 : while (1) {
   do if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L152;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L151;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 716 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
   HEAP32[i25 + 324 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
   HEAP32[i25 + 720 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
   HEAP32[i25 + 328 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
   HEAP32[i25 + 724 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 184 >> 2];
   HEAP32[i25 + 332 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 76 >> 2];
  }
 } while (0);
 i1 = i4 + i14 & i22;
 L161 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L162 : while (1) {
   do if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i20 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L162;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L161;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 728 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
   HEAP32[i25 + 336 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
   HEAP32[i25 + 732 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
   HEAP32[i25 + 340 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
   HEAP32[i25 + 736 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 192 >> 2];
   HEAP32[i25 + 344 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 84 >> 2];
  }
 } while (0);
 i1 = i2 + i14 & i22;
 L171 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L172 : while (1) {
   do if (i3 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L172;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L171;
  }
  if (i24 + (i1 << 4) | 0) {
   HEAP32[i25 + 740 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
   HEAP32[i25 + 348 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
   HEAP32[i25 + 744 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
   HEAP32[i25 + 352 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
   HEAP32[i25 + 748 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 180 >> 2];
   HEAP32[i25 + 356 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 72 >> 2];
  }
 } while (0);
 i2 = i16 + i10 | 0;
 i1 = i2 + i15 & i22;
 L181 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L182 : while (1) {
   do if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i20 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L182;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L181;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 752 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 160 >> 2];
  HEAP32[i25 + 360 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 52 >> 2];
 } while (0);
 i1 = i2 + i14 & i22;
 L191 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L192 : while (1) {
   do if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i20 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L192;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L191;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 756 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 156 >> 2];
  HEAP32[i25 + 364 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 48 >> 2];
 } while (0);
 i2 = i19 + i10 | 0;
 i1 = i2 + i15 & i22;
 L201 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L202 : while (1) {
   do if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L202;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L201;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 760 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 148 >> 2];
  HEAP32[i25 + 368 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 40 >> 2];
 } while (0);
 i1 = i2 + i14 & i22;
 L211 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L212 : while (1) {
   do if (i11 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L212;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L211;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 764 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 144 >> 2];
  HEAP32[i25 + 372 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 36 >> 2];
 } while (0);
 i2 = i16 + i12 | 0;
 i1 = i2 + i15 & i22;
 L221 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L222 : while (1) {
   do if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i20 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L222;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L221;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 768 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 124 >> 2];
  HEAP32[i25 + 376 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 16 >> 2];
 } while (0);
 i1 = i2 + i14 & i22;
 L231 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L232 : while (1) {
   do if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i20 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L232;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L231;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 772 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 120 >> 2];
  HEAP32[i25 + 380 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 12 >> 2];
 } while (0);
 i2 = i19 + i12 | 0;
 i1 = i2 + i15 & i22;
 L241 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L242 : while (1) {
   do if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i18 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L242;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L241;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 776 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 112 >> 2];
  HEAP32[i25 + 384 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 4 >> 2];
 } while (0);
 i1 = i2 + i14 & i22;
 L251 : do if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) != -1) {
  L252 : while (1) {
   do if (i13 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) >> 1] | 0)) {
    if (i21 << 16 >> 16 != (HEAP16[i24 + (i1 << 4) + 2 >> 1] | 0)) break;
    if (i17 << 16 >> 16 == (HEAP16[i24 + (i1 << 4) + 4 >> 1] | 0)) break L252;
   } while (0);
   i1 = i1 + 1 & i22;
   if ((HEAP32[i24 + (i1 << 4) + 8 >> 2] | 0) == -1) break L251;
  }
  if (!(i24 + (i1 << 4) | 0)) break;
  HEAP32[i25 + 780 >> 2] = HEAP32[i23 + (i1 * 216 | 0) + 108 >> 2];
  HEAP32[i25 + 388 >> 2] = HEAP32[i23 + (i1 * 216 | 0) >> 2];
 } while (0);
 i1 = i25 + 784 | 0;
 i2 = 0;
 i3 = 0;
 do {
  i24 = HEAP32[i25 + (i3 << 2) >> 2] | 0;
  i2 = i2 >>> 0 < i24 >>> 0 ? i24 : i2;
  HEAP32[i1 >> 2] = i2;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 98);
 return;
}

function __ZN5physx2Gu28computeConvex_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbjRNS_10PxSweepHitE(i3, i142, i139, i24, f22, f1, i141, i140, i26) {
 i3 = i3 | 0;
 i142 = i142 | 0;
 i139 = i139 | 0;
 i24 = i24 | 0;
 f22 = Math_fround(f22);
 f1 = Math_fround(f1);
 i141 = i141 | 0;
 i140 = i140 | 0;
 i26 = i26 | 0;
 var f2 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, f109 = f0, i110 = 0, f111 = f0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, f118 = f0, f119 = f0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i149 = 0, i150 = 0, i151 = 0, i152 = 0, i153 = 0, f154 = f0, f155 = f0, f156 = f0, f157 = f0, f158 = f0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, f164 = f0, f165 = f0, f166 = f0, f167 = f0, f168 = f0, f169 = f0, f170 = f0, f171 = f0, f172 = f0, f173 = f0, f174 = f0, f175 = f0, f176 = f0;
 i153 = STACKTOP;
 STACKTOP = STACKTOP + 6176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i130 = i153 + 6164 | 0;
 i135 = i153 + 6152 | 0;
 i126 = i153 + 6140 | 0;
 i127 = i153 + 6120 | 0;
 i23 = i153 + 4512 | 0;
 i131 = i153 + 416 | 0;
 i134 = i153 + 6040 | 0;
 i18 = i153 + 6048 | 0;
 i125 = i153 + 112 | 0;
 i21 = i153 + 96 | 0;
 i20 = i153 + 80 | 0;
 i124 = i153 + 208 | 0;
 i123 = i153 + 144 | 0;
 i129 = i153;
 i152 = i153 + 4608 | 0;
 i136 = i153 + 5968 | 0;
 i133 = i153 + 4596 | 0;
 i137 = i153 + 4568 | 0;
 i128 = i153 + 5904 | 0;
 i122 = i153 + 4544 | 0;
 i132 = i153 + 16 | 0;
 i121 = i153 + 4528 | 0;
 i138 = i153 + 4624 | 0;
 HEAP32[i127 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i127 + 16 >> 2] = i3;
 HEAPF32[i127 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i127 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i127 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i134 >> 2] = 0;
 i120 = HEAP32[i139 + 32 >> 2] | 0;
 i19 = i120 + 16 | 0;
 i3 = i139 + 4 | 0;
 f119 = Math_fround(HEAPF32[i3 >> 2]);
 i150 = f119 == Math_fround(1.0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
 if (i150) if (Math_fround(HEAPF32[i139 + 8 >> 2]) == Math_fround(1.0)) i25 = Math_fround(HEAPF32[i139 + 12 >> 2]) == Math_fround(1.0); else i25 = 0; else i25 = 0;
 HEAP32[i18 >> 2] = 1065353216;
 i12 = i18 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i18 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i14 = i18 + 16 | 0;
 HEAP32[i14 >> 2] = 1065353216;
 i15 = i18 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 i16 = i18 + 28 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 32 | 0;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i18 + 36 >> 2] = 1065353216;
 HEAP32[i18 + 40 >> 2] = 0;
 HEAP32[i18 + 44 >> 2] = 0;
 HEAP32[i18 + 48 >> 2] = 0;
 HEAP32[i18 + 52 >> 2] = 1065353216;
 HEAP32[i18 + 56 >> 2] = 0;
 HEAP32[i18 + 60 >> 2] = 0;
 HEAP32[i18 + 64 >> 2] = 0;
 HEAP32[i18 + 68 >> 2] = 1065353216;
 if (i25) {
  f1 = Math_fround(1.0);
  f2 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(1.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(1.0);
 } else {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i18, i3, i139 + 16 | 0);
  f1 = Math_fround(HEAPF32[i18 >> 2]);
  f2 = Math_fround(HEAPF32[i12 >> 2]);
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f6 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f8 = Math_fround(HEAPF32[i15 >> 2]);
  f9 = Math_fround(HEAPF32[i18 + 24 >> 2]);
  f10 = Math_fround(HEAPF32[i16 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  i4 = HEAP32[i3 >> 2] | 0;
 }
 f111 = Math_fround(HEAPF32[i120 + 40 >> 2]);
 f119 = Math_fround(f111 * f1);
 f118 = Math_fround(f111 * f2);
 f111 = Math_fround(f111 * f5);
 f48 = Math_fround(HEAPF32[i120 + 44 >> 2]);
 f119 = Math_fround(f119 + Math_fround(f48 * f6));
 f118 = Math_fround(f118 + Math_fround(f48 * f7));
 f48 = Math_fround(f111 + Math_fround(f48 * f8));
 f111 = Math_fround(HEAPF32[i120 + 48 >> 2]);
 f119 = Math_fround(f119 + Math_fround(f111 * f9));
 f118 = Math_fround(f118 + Math_fround(f111 * f10));
 f111 = Math_fround(f48 + Math_fround(f111 * f11));
 i113 = HEAP32[i24 + 4 >> 2] | 0;
 i114 = HEAP32[i24 + 8 >> 2] | 0;
 i115 = HEAP32[i24 + 12 >> 2] | 0;
 i14 = i24 + 16 | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i14 = HEAP32[i14 + 8 >> 2] | 0;
 HEAP32[i125 >> 2] = HEAP32[i24 >> 2];
 i112 = i125 + 4 | 0;
 HEAP32[i112 >> 2] = i113;
 i113 = i125 + 8 | 0;
 HEAP32[i113 >> 2] = i114;
 i114 = i125 + 12 | 0;
 HEAP32[i114 >> 2] = i115;
 HEAP32[i125 + 16 >> 2] = i12;
 i115 = i125 + 20 | 0;
 HEAP32[i115 >> 2] = i13;
 i116 = i125 + 24 | 0;
 HEAP32[i116 >> 2] = i14;
 i117 = i125 + 28 | 0;
 HEAPF32[i117 >> 2] = Math_fround(0.0);
 i150 = HEAP32[i139 + 8 >> 2] | 0;
 i3 = HEAP32[i139 + 12 >> 2] | 0;
 HEAP32[i21 >> 2] = i4;
 HEAP32[i21 + 4 >> 2] = i150;
 HEAP32[i21 + 8 >> 2] = i3;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 i146 = i139 + 16 | 0;
 i147 = HEAP32[i146 + 4 >> 2] | 0;
 i148 = HEAP32[i146 + 8 >> 2] | 0;
 i149 = HEAP32[i146 + 12 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i146 >> 2];
 HEAP32[i20 + 4 >> 2] = i147;
 HEAP32[i20 + 8 >> 2] = i148;
 HEAP32[i20 + 12 >> 2] = i149;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i124, i19, i23, i21, i20);
 f48 = Math_fround(HEAPF32[i120 + 68 >> 2]);
 f49 = Math_fround(HEAPF32[i120 + 72 >> 2]);
 f109 = Math_fround(HEAPF32[i120 + 76 >> 2]);
 f50 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i150, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = Math_fround(f48 * f50);
 f51 = Math_fround(f49 * f51);
 f109 = Math_fround(f109 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f51 = f50 <= f51 ? f50 : f51;
 f109 = Math_fround(Math_fround((f51 <= f109 ? f51 : f109) * Math_fround(.25)) + f22);
 HEAPF32[i129 >> 2] = f109;
 __ZN5physx2Gu9ContainerC2Ev(i152);
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i152, 128, i3, 1);
 f9 = Math_fround(HEAPF32[i23 >> 2]);
 f10 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i110 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i124, i25, i136);
 f36 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAP32[i137 >> 2] = HEAP32[i24 >> 2];
 i103 = i137 + 4 | 0;
 HEAP32[i103 >> 2] = HEAP32[i24 + 4 >> 2];
 i104 = i137 + 8 | 0;
 HEAP32[i104 >> 2] = HEAP32[i24 + 8 >> 2];
 i105 = i137 + 12 | 0;
 HEAP32[i105 >> 2] = HEAP32[i24 + 12 >> 2];
 i106 = i137 + 16 | 0;
 HEAP32[i106 >> 2] = HEAP32[i24 + 16 >> 2];
 i107 = i137 + 20 | 0;
 HEAP32[i107 >> 2] = HEAP32[i24 + 20 >> 2];
 i108 = i137 + 24 | 0;
 HEAP32[i108 >> 2] = HEAP32[i24 + 24 >> 2];
 f45 = Math_fround(HEAPF32[i142 >> 2]);
 f49 = Math_fround(f45 + f45);
 f50 = Math_fround(HEAPF32[i142 + 4 >> 2]);
 f48 = Math_fround(f50 + f50);
 f40 = Math_fround(HEAPF32[i142 + 8 >> 2]);
 f44 = Math_fround(f40 + f40);
 f43 = Math_fround(HEAPF32[i142 + 12 >> 2]);
 f47 = Math_fround(f49 * f43);
 f46 = Math_fround(f48 * f43);
 f43 = Math_fround(f43 * f44);
 f1 = Math_fround(f45 * f48);
 f51 = Math_fround(f45 * f44);
 f48 = Math_fround(f50 * f48);
 f50 = Math_fround(f50 * f44);
 f44 = Math_fround(f40 * f44);
 f40 = Math_fround(Math_fround(Math_fround(1.0) - f48) - f44);
 f41 = Math_fround(f1 + f43);
 f42 = Math_fround(f51 - f46);
 f43 = Math_fround(f1 - f43);
 f49 = Math_fround(Math_fround(1.0) - Math_fround(f45 * f49));
 f44 = Math_fround(f49 - f44);
 f45 = Math_fround(f50 + f47);
 f46 = Math_fround(f51 + f46);
 f47 = Math_fround(f50 - f47);
 f48 = Math_fround(f49 - f48);
 f49 = Math_fround(HEAPF32[i142 + 16 >> 2]);
 f50 = Math_fround(HEAPF32[i142 + 20 >> 2]);
 f51 = Math_fround(HEAPF32[i142 + 24 >> 2]);
 i52 = i152 + 4 | 0;
 i53 = i125 + 16 | 0;
 i54 = i124 + 96 | 0;
 i55 = i124 + 144 | 0;
 i56 = i123 + 32 | 0;
 i57 = i123 + 36 | 0;
 i58 = i123 + 40 | 0;
 i59 = i123 + 44 | 0;
 i60 = i25 & 1;
 i61 = i123 + 48 | 0;
 i62 = i123 + 16 | 0;
 i63 = i123 + 20 | 0;
 i64 = i123 + 24 | 0;
 i65 = i123 + 28 | 0;
 i66 = i128 + 48 | 0;
 i67 = i128 + 52 | 0;
 i68 = i128 + 56 | 0;
 i69 = i128 + 4 | 0;
 i70 = i128 + 8 | 0;
 i71 = i128 + 12 | 0;
 i72 = i128 + 16 | 0;
 i73 = i128 + 20 | 0;
 i74 = i128 + 24 | 0;
 i75 = i128 + 28 | 0;
 i76 = i128 + 32 | 0;
 i77 = i128 + 36 | 0;
 i78 = i128 + 40 | 0;
 i79 = i128 + 44 | 0;
 i80 = i122 + 4 | 0;
 i81 = i122 + 8 | 0;
 i82 = i122 + 12 | 0;
 i83 = i122 + 16 | 0;
 i84 = i122 + 20 | 0;
 i85 = i130 + 4 | 0;
 i86 = i137 + 16 | 0;
 i87 = i132 + 48 | 0;
 i88 = i132 + 52 | 0;
 i89 = i132 + 56 | 0;
 i90 = i132 + 60 | 0;
 i91 = i132 + 4 | 0;
 i92 = i132 + 8 | 0;
 i93 = i132 + 12 | 0;
 i94 = i132 + 16 | 0;
 i95 = i132 + 20 | 0;
 i96 = i132 + 24 | 0;
 i97 = i132 + 28 | 0;
 i98 = i132 + 32 | 0;
 i99 = i132 + 36 | 0;
 i100 = i132 + 40 | 0;
 i101 = i132 + 44 | 0;
 i102 = i152 + 8 | 0;
 i144 = i26 + 40 | 0;
 i145 = i26 + 16 | 0;
 i146 = i26 + 20 | 0;
 i147 = i26 + 24 | 0;
 i148 = i26 + 28 | 0;
 i149 = i26 + 32 | 0;
 i150 = i26 + 36 | 0;
 i143 = i26 + 8 | 0;
 i39 = i131 + 44 | 0;
 i35 = i25 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 f1 = f9;
 f5 = f10;
 f8 = f11;
 i4 = 268435455;
 f6 = f9;
 f7 = f10;
 f2 = f11;
 i12 = i34;
 i13 = i110;
 i14 = i3;
 i3 = 0;
 i110 = 0;
 while (1) {
  if (HEAP32[i52 >> 2] | 0) HEAP32[i52 >> 2] = 0;
  HEAPF32[i106 >> 2] = f36;
  HEAPF32[i107 >> 2] = f37;
  HEAPF32[i108 >> 2] = f38;
  HEAPF32[i53 >> 2] = f36;
  HEAPF32[i115 >> 2] = f37;
  HEAPF32[i116 >> 2] = f38;
  HEAPF32[i117 >> 2] = Math_fround(0.0);
  HEAP32[i56 >> 2] = i125;
  HEAP32[i57 >> 2] = i54;
  HEAP32[i58 >> 2] = i55;
  HEAP8[i59 >> 0] = i60;
  HEAP32[i123 >> 2] = i35;
  HEAP32[i61 >> 2] = i124;
  HEAPF32[i62 >> 2] = f119;
  HEAPF32[i63 >> 2] = f118;
  HEAPF32[i64 >> 2] = f111;
  HEAPF32[i65 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE(i128, i139, i120, i137);
  f155 = Math_fround(f109 + Math_fround(HEAPF32[i66 >> 2]));
  HEAPF32[i66 >> 2] = f155;
  f27 = Math_fround(f109 + Math_fround(HEAPF32[i67 >> 2]));
  HEAPF32[i67 >> 2] = f27;
  f156 = Math_fround(f109 + Math_fround(HEAPF32[i68 >> 2]));
  HEAPF32[i68 >> 2] = f156;
  f22 = Math_fround(f155 * Math_fround(HEAPF32[i128 >> 2]));
  f154 = Math_fround(f155 * Math_fround(HEAPF32[i69 >> 2]));
  f155 = Math_fround(f155 * Math_fround(HEAPF32[i70 >> 2]));
  f29 = Math_fround(f27 * Math_fround(HEAPF32[i71 >> 2]));
  f28 = Math_fround(f27 * Math_fround(HEAPF32[i72 >> 2]));
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i73 >> 2]));
  f158 = Math_fround(f156 * Math_fround(HEAPF32[i74 >> 2]));
  f157 = Math_fround(f156 * Math_fround(HEAPF32[i75 >> 2]));
  f158 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f22))) + Math_fround(Math_abs(Math_fround(f29)))) + Math_fround(Math_abs(Math_fround(f158))));
  f157 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f154))) + Math_fround(Math_abs(Math_fround(f28)))) + Math_fround(Math_abs(Math_fround(f157))));
  f156 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f155))) + Math_fround(Math_abs(Math_fround(f27)))) + Math_fround(Math_abs(Math_fround(f156 * Math_fround(HEAPF32[i76 >> 2])))));
  f27 = Math_fround(HEAPF32[i77 >> 2]);
  f155 = Math_fround(f27 - f158);
  f28 = Math_fround(HEAPF32[i78 >> 2]);
  f154 = Math_fround(f28 - f157);
  f29 = Math_fround(HEAPF32[i79 >> 2]);
  f22 = Math_fround(f29 - f156);
  f27 = Math_fround(f158 + f27);
  f28 = Math_fround(f157 + f28);
  f29 = Math_fround(f156 + f29);
  HEAPF32[i122 >> 2] = f155;
  HEAPF32[i80 >> 2] = f154;
  HEAPF32[i81 >> 2] = f22;
  HEAPF32[i82 >> 2] = f27;
  HEAPF32[i83 >> 2] = f28;
  HEAPF32[i84 >> 2] = f29;
  HEAP32[i130 >> 2] = gb + 84656 + 8;
  HEAP32[i85 >> 2] = i152;
  __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i127, i142, i122, i140, i130) | 0;
  i32 = HEAP32[i52 >> 2] | 0;
  if (!i32) {
   i151 = 10;
   break;
  }
  f170 = Math_fround(HEAPF32[i86 >> 2]);
  f165 = Math_fround(HEAPF32[i107 >> 2]);
  f170 = Math_fround(f170 * Math_fround(-2.0));
  f165 = Math_fround(f165 * Math_fround(-2.0));
  f167 = Math_fround(Math_fround(HEAPF32[i108 >> 2]) * Math_fround(-2.0));
  f168 = Math_fround(HEAPF32[i105 >> 2]);
  f169 = Math_fround(Math_fround(f168 * f168) + Math_fround(-.5));
  f172 = Math_fround(HEAPF32[i137 >> 2]);
  f171 = Math_fround(f170 * f172);
  f166 = Math_fround(HEAPF32[i103 >> 2]);
  f171 = Math_fround(f171 + Math_fround(f165 * f166));
  f164 = Math_fround(HEAPF32[i104 >> 2]);
  f171 = Math_fround(f171 + Math_fround(f167 * f164));
  f22 = Math_fround(-f172);
  f27 = Math_fround(-f166);
  f160 = Math_fround(-f164);
  f159 = Math_fround(f22 - f172);
  f174 = Math_fround(f27 - f166);
  f162 = Math_fround(f160 - f164);
  f176 = Math_fround(f168 * f159);
  f28 = Math_fround(f168 * f174);
  f161 = Math_fround(f168 * f162);
  f29 = Math_fround(f174 * f22);
  f163 = Math_fround(f162 * f22);
  f174 = Math_fround(f174 * f27);
  f27 = Math_fround(f162 * f27);
  f160 = Math_fround(f162 * f160);
  f162 = Math_fround(Math_fround(Math_fround(1.0) - f174) - f160);
  f175 = Math_fround(f29 + f161);
  f173 = Math_fround(f163 - f28);
  f161 = Math_fround(f29 - f161);
  f22 = Math_fround(Math_fround(1.0) - Math_fround(f159 * f22));
  f160 = Math_fround(f22 - f160);
  f159 = Math_fround(f176 + f27);
  f163 = Math_fround(f28 + f163);
  f176 = Math_fround(f27 - f176);
  f174 = Math_fround(f22 - f174);
  f22 = Math_fround(Math_fround(f42 * f163) + Math_fround(Math_fround(f40 * f162) + Math_fround(f41 * f161)));
  f27 = Math_fround(Math_fround(f42 * f176) + Math_fround(Math_fround(f40 * f175) + Math_fround(f41 * f160)));
  f28 = Math_fround(Math_fround(f42 * f174) + Math_fround(Math_fround(f40 * f173) + Math_fround(f41 * f159)));
  f29 = Math_fround(Math_fround(f45 * f163) + Math_fround(Math_fround(f43 * f162) + Math_fround(f44 * f161)));
  f154 = Math_fround(Math_fround(f45 * f176) + Math_fround(Math_fround(f43 * f175) + Math_fround(f44 * f160)));
  f155 = Math_fround(Math_fround(f45 * f174) + Math_fround(Math_fround(f43 * f173) + Math_fround(f44 * f159)));
  f156 = Math_fround(Math_fround(f48 * f163) + Math_fround(Math_fround(f46 * f162) + Math_fround(f47 * f161)));
  f157 = Math_fround(Math_fround(f48 * f176) + Math_fround(Math_fround(f46 * f175) + Math_fround(f47 * f160)));
  f158 = Math_fround(Math_fround(f48 * f174) + Math_fround(Math_fround(f46 * f173) + Math_fround(f47 * f159)));
  f160 = Math_fround(Math_fround(Math_fround(f166 * f171) + Math_fround(Math_fround(f165 * f169) - Math_fround(f168 * Math_fround(Math_fround(f170 * f164) - Math_fround(f167 * f172))))) + Math_fround(Math_fround(f51 * f176) + Math_fround(Math_fround(f49 * f175) + Math_fround(f50 * f160))));
  f159 = Math_fround(Math_fround(Math_fround(Math_fround(f167 * f169) - Math_fround(f168 * Math_fround(Math_fround(f165 * f172) - Math_fround(f170 * f166)))) + Math_fround(f164 * f171)) + Math_fround(Math_fround(f51 * f174) + Math_fround(Math_fround(f49 * f173) + Math_fround(f50 * f159))));
  HEAPF32[i87 >> 2] = Math_fround(Math_fround(Math_fround(f172 * f171) + Math_fround(Math_fround(f170 * f169) - Math_fround(f168 * Math_fround(Math_fround(f167 * f166) - Math_fround(f165 * f164))))) + Math_fround(Math_fround(f51 * f163) + Math_fround(Math_fround(f49 * f162) + Math_fround(f50 * f161))));
  HEAPF32[i88 >> 2] = f160;
  HEAPF32[i89 >> 2] = f159;
  HEAPF32[i90 >> 2] = Math_fround(0.0);
  HEAPF32[i132 >> 2] = f22;
  HEAPF32[i91 >> 2] = f27;
  HEAPF32[i92 >> 2] = f28;
  HEAPF32[i93 >> 2] = Math_fround(0.0);
  HEAPF32[i94 >> 2] = f29;
  HEAPF32[i95 >> 2] = f154;
  HEAPF32[i96 >> 2] = f155;
  HEAPF32[i97 >> 2] = Math_fround(0.0);
  HEAPF32[i98 >> 2] = f156;
  HEAPF32[i99 >> 2] = f157;
  HEAPF32[i100 >> 2] = f158;
  HEAPF32[i101 >> 2] = Math_fround(0.0);
  i33 = HEAP32[i102 >> 2] | 0;
  HEAP32[i133 >> 2] = HEAP32[i121 >> 2];
  HEAP32[i133 + 4 >> 2] = HEAP32[i121 + 4 >> 2];
  HEAP32[i133 + 8 >> 2] = HEAP32[i121 + 8 >> 2];
  i34 = (i32 + 31 | 0) >>> 5;
  if (!i34) {
   i151 = 30;
   break;
  }
  i18 = 2139095039;
  i26 = 0;
  i30 = 0;
  i31 = ~i32;
  while (1) {
   i15 = i31 >>> 0 > 4294967263 ? ~i31 : 32;
   i24 = i26 << 5;
   i25 = i32 - i24 | 0;
   i25 = i25 >>> 0 < 32 ? i25 : 32;
   i16 = (i25 | 0) == 0;
   if (i16) {
    HEAP32[i126 >> 2] = HEAP32[i133 >> 2];
    HEAP32[i126 + 4 >> 2] = HEAP32[i133 + 4 >> 2];
    HEAP32[i126 + 8 >> 2] = HEAP32[i133 + 8 >> 2];
    i15 = i18;
    i16 = i12;
    f27 = f9;
    f28 = f10;
    f29 = f11;
    i12 = 0;
   } else {
    i17 = 0;
    do {
     __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i127, i142, i138 + (i17 * 40 | 0) | 0, 0, 0, HEAP32[i33 + (i17 + i24 << 2) >> 2] | 0, 0, 0) | 0;
     HEAP8[i138 + (i17 * 40 | 0) + 36 >> 0] = 56;
     i17 = i17 + 1 | 0;
    } while ((i17 | 0) != (i15 | 0));
    HEAP32[i126 >> 2] = HEAP32[i133 >> 2];
    HEAP32[i126 + 4 >> 2] = HEAP32[i133 + 4 >> 2];
    HEAP32[i126 + 8 >> 2] = HEAP32[i133 + 8 >> 2];
    if (i16) {
     i15 = i18;
     i16 = i12;
     f27 = f9;
     f28 = f10;
     f29 = f11;
     i12 = 0;
    } else {
     i15 = i18;
     i21 = i12;
     i12 = 0;
     i23 = 0;
     while (1) {
      HEAP32[i134 >> 2] = 0;
      i20 = i23 + i24 | 0;
      __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i136, i123, i138 + (i23 * 40 | 0) | 0, i20, HEAP8[i138 + (i23 * 40 | 0) + 36 >> 0] | 0, i129, i141, i125, i132, i131, i134) | 0;
      i19 = HEAP32[i134 >> 2] | 0;
      if (!i19) i16 = i21; else {
       i12 = HEAP32[i39 >> 2] | 0;
       if (i19 >>> 0 > 1) {
        i16 = i12;
        i17 = 0;
        i18 = 1;
        while (1) {
         i12 = HEAP32[i131 + (i18 << 6) + 44 >> 2] | 0;
         f176 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f176 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
          HEAP32[i130 >> 2] = HEAP32[i135 >> 2];
          HEAP32[i130 + 4 >> 2] = HEAP32[i135 + 4 >> 2];
          HEAP32[i130 + 8 >> 2] = HEAP32[i135 + 8 >> 2];
          i17 = i18;
         } else i12 = i16;
         i18 = i18 + 1 | 0;
         if ((i18 | 0) == (i19 | 0)) break; else i16 = i12;
        }
       } else i17 = 0;
       f176 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f176 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
        HEAP32[i126 >> 2] = HEAP32[i130 >> 2];
        HEAP32[i126 + 4 >> 2] = HEAP32[i130 + 4 >> 2];
        HEAP32[i126 + 8 >> 2] = HEAP32[i130 + 8 >> 2];
        f9 = Math_fround(HEAPF32[i131 + (i17 << 6) + 16 >> 2]);
        f10 = Math_fround(HEAPF32[i131 + (i17 << 6) + 20 >> 2]);
        f11 = Math_fround(HEAPF32[i131 + (i17 << 6) + 24 >> 2]);
        i14 = HEAP32[i131 + (i17 << 6) + 40 >> 2] | 0;
        i13 = HEAP32[i131 + (i17 << 6) + 36 >> 2] | 0;
        i16 = HEAP32[i131 + (i17 << 6) + 32 >> 2] | 0;
        i4 = i20;
        i15 = i12;
       } else i16 = i21;
       i12 = 1;
      }
      i23 = i23 + 1 | 0;
      if ((i23 | 0) == (i25 | 0)) {
       f27 = f9;
       f28 = f10;
       f29 = f11;
       break;
      } else i21 = i16;
     }
    }
   };
   HEAP32[i133 >> 2] = HEAP32[i126 >> 2];
   HEAP32[i133 + 4 >> 2] = HEAP32[i126 + 4 >> 2];
   HEAP32[i133 + 8 >> 2] = HEAP32[i126 + 8 >> 2];
   i30 = i30 | i12;
   i26 = i26 + 1 | 0;
   if ((i26 | 0) == (i34 | 0)) break; else {
    i18 = i15;
    i12 = i16;
    f9 = f27;
    f10 = f28;
    f11 = f29;
    i31 = i31 + 32 | 0;
   }
  }
  if (!i30) {
   i151 = 30;
   break;
  }
  i4 = HEAP32[i33 + (i4 << 2) >> 2] | 0;
  f176 = Math_fround(HEAPF32[i125 >> 2]);
  f22 = Math_fround(HEAPF32[i112 >> 2]);
  f173 = Math_fround(HEAPF32[i113 >> 2]);
  f175 = Math_fround(HEAPF32[i114 >> 2]);
  f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(Math_fround(f175 * f175) + Math_fround(-.5));
  f174 = Math_fround(Math_fround(Math_fround(f6 * f176) + Math_fround(f7 * f22)) + Math_fround(f9 * f173));
  f11 = Math_fround(Math_fround(Math_fround(f176 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f9 * f22) - Math_fround(f7 * f173))) + Math_fround(f6 * f2))) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(Math_fround(f22 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f6 * f173) - Math_fround(f9 * f176))) + Math_fround(f7 * f2))) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(Math_fround(f173 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f7 * f176) - Math_fround(f6 * f22))) + Math_fround(f9 * f2))) * Math_fround(2.0));
  f6 = Math_fround(HEAPF32[i53 >> 2]);
  f7 = Math_fround(HEAPF32[i115 >> 2]);
  f174 = Math_fround(Math_fround(Math_fround(f27 * f176) + Math_fround(f28 * f22)) + Math_fround(f29 * f173));
  f6 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f176 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f29 * f22) - Math_fround(f28 * f173))) + Math_fround(f27 * f2))) * Math_fround(2.0)));
  f7 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f22 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f27 * f173) - Math_fround(f29 * f176))) + Math_fround(f28 * f2))) * Math_fround(2.0)));
  f2 = Math_fround(Math_fround(HEAPF32[i116 >> 2]) + Math_fround(Math_fround(Math_fround(f173 * f174) + Math_fround(Math_fround(f175 * Math_fround(Math_fround(f28 * f176) - Math_fround(f27 * f22))) + Math_fround(f29 * f2))) * Math_fround(2.0)));
  f22 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f22 <= Math_fround(0.0))) {
   i3 = i110;
   i151 = 29;
   break;
  }
  f174 = Math_fround(f22 * f11);
  f175 = Math_fround(f22 * f10);
  f176 = Math_fround(f22 * f9);
  f1 = Math_fround(f1 - f174);
  f5 = Math_fround(f5 - f175);
  f8 = Math_fround(f8 - f176);
  f36 = Math_fround(f36 - f174);
  f37 = Math_fround(f37 - f175);
  f38 = Math_fround(f38 - f176);
  i110 = i110 + 1 | 0;
  if (i110 >>> 0 >= 2) {
   f10 = f1;
   f9 = f2;
   i3 = 1;
   break;
  } else {
   i12 = i16;
   f9 = f27;
   f10 = f28;
   f11 = f29;
   i3 = 1;
  }
 }
 if ((i151 | 0) == 10) {
  f10 = f1;
  f9 = f2;
 } else if ((i151 | 0) == 29) if (!i3) {
  HEAPF32[i144 >> 2] = Math_fround(0.0);
  HEAPF32[i145 >> 2] = f6;
  HEAPF32[i146 >> 2] = f7;
  HEAPF32[i147 >> 2] = f2;
  HEAPF32[i148 >> 2] = f11;
  HEAPF32[i149 >> 2] = f10;
  HEAPF32[i150 >> 2] = f9;
  HEAP32[i143 >> 2] = i4;
  i151 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i152);
  STACKTOP = i153;
  return i151 | 0;
 } else {
  i3 = 1;
  i151 = 30;
 }
 if ((i151 | 0) == 30) {
  f10 = f1;
  f9 = f2;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f5 * f5) + Math_fround(f10 * f10)))));
 f2 = Math_fround(Math_fround(1.0) / f1);
 if (!i3) {
  i151 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i152);
  STACKTOP = i153;
  return i151 | 0;
 }
 f176 = Math_fround(f8 * f2);
 f175 = Math_fround(f5 * f2);
 f174 = Math_fround(f10 * f2);
 HEAPF32[i144 >> 2] = Math_fround(-f1);
 HEAPF32[i145 >> 2] = f6;
 HEAPF32[i146 >> 2] = f7;
 HEAPF32[i147 >> 2] = f9;
 HEAPF32[i148 >> 2] = f174;
 HEAPF32[i149 >> 2] = f175;
 HEAPF32[i150 >> 2] = f176;
 HEAP32[i143 >> 2] = i4;
 i151 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i152);
 STACKTOP = i153;
 return i151 | 0;
}

function __ZN14TerrainManager15CullAllTerrainsEP6CameraRK17CullingParameters(i2, i22, i3) {
 i2 = i2 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i30 + 16 | 0;
 i26 = i30;
 i27 = i30 + 52 | 0;
 i28 = i30 + 32 | 0;
 i25 = gb + 64016 | 0;
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i23 = i26;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i27 >> 2] = 0;
 i23 = i27 + 12 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i27 + 16 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i26);
 i19 = i21;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i25;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i24 >> 2] = i1;
  HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 3, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i16 = i2 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) != (i16 | 0)) {
  i13 = i3 + 192 | 0;
  i14 = i28 + 4 | 0;
  i15 = i28 + 8 | 0;
  do {
   i12 = HEAP32[i1 + 8 >> 2] | 0;
   i10 = i12;
   i1 = HEAP32[i12 + 28 >> 2] | 0;
   if (1 << HEAP32[i1 + 48 >> 2] & HEAP32[i13 >> 2] | 0) {
    __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
    i1 = i12 + 36 | 0;
    f5 = Math_fround(HEAPF32[i28 >> 2]);
    if (f5 != Math_fround(HEAPF32[i1 >> 2])) i29 = 11; else {
     f5 = Math_fround(HEAPF32[i14 >> 2]);
     if (f5 != Math_fround(HEAPF32[i12 + 40 >> 2])) i29 = 11; else {
      f5 = Math_fround(HEAPF32[i15 >> 2]);
      if (f5 != Math_fround(HEAPF32[i12 + 44 >> 2])) i29 = 11;
     }
    }
    if ((i29 | 0) == 11) {
     i29 = 0;
     HEAP32[i1 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
     __ZN7Terrain5FlushEv(i12);
    }
    __ZN7Terrain23GarbageCollectRenderersEv(i12);
    if ((HEAP16[gb + 1467404 + 6 >> 1] | 0) > -1) {
     HEAP32[i26 >> 2] = i10;
     HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467404 | 0, i21);
     i1 = gb + 1467404 | 0;
    } else i1 = 0;
    __ZN7Terrain10FlushDirtyEv(i12);
    if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
    i11 = __ZN7Terrain11GetRendererEPK6Camerab(i12, i22, 1) | 0;
    i8 = i11;
    do if (i11 | 0) {
     i9 = i12 + 48 | 0;
     i6 = HEAP32[i9 >> 2] | 0;
     HEAP32[i26 >> 2] = i6;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 22; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i3 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
       i3 = HEAP32[i21 >> 2] | 0;
       i20 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i3 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i29 = 22; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 24;
      }
     }
     if ((i29 | 0) == 22) i29 = 24;
     if ((i29 | 0) == 24) {
      i29 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
     }
     i20 = i1 + 248 | 0;
     f31 = Math_fround(HEAPF32[i20 + 88 >> 2]);
     f31 = Math_fround(f31 * Math_fround((HEAP32[i20 + 72 >> 2] | 0) + -1 | 0));
     f5 = Math_fround(HEAPF32[i20 + 96 >> 2]);
     if (!(f31 == Math_fround(0.0) ? 1 : Math_fround(f5 * Math_fround((HEAP32[i20 + 76 >> 2] | 0) + -1 | 0)) == Math_fround(0.0))) {
      i3 = HEAP32[i23 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i6 = HEAP32[i24 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i4 >>> 0 > i7 >>> 0) {
       i1 = i6 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i24 >> 2] = i1;
        HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i1 << 3, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i20 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i23 >> 2] << 3 | 0) | 0;
        HEAP32[i24 >> 2] = i1;
        HEAP32[i27 >> 2] = i20;
        break;
       }
      } while (0);
      HEAP32[i23 >> 2] = i4;
      i1 = (HEAP32[i27 >> 2] | 0) + (i3 << 3) | 0;
      HEAP32[i1 >> 2] = i10;
      HEAP32[i1 + 4 >> 2] = i8;
      HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i29 = 36; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i3 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
        i3 = HEAP32[i21 >> 2] | 0;
        i20 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i3 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i29 = 36; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i29 = 38;
       }
      }
      if ((i29 | 0) == 36) i29 = 38;
      if ((i29 | 0) == 38) {
       i29 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
      }
      i1 = i1 + 32 | 0;
      if (HEAP8[i1 + 50 >> 0] | 0) __ZN13SplatDatabase18RecalculateBasemapEb(i1, 0);
      i3 = i12 + 204 | 0;
      i1 = HEAP32[i3 >> 2] | 0;
      if (i1 & 1 | 0) if (HEAP8[i12 + 89 >> 0] | 0) {
       if ((HEAP16[gb + 1467416 + 6 >> 1] | 0) > -1) {
        HEAP32[i26 >> 2] = i10;
        HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
        __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467416 | 0, i21);
        i4 = gb + 1467416 | 0;
        i1 = HEAP32[i3 >> 2] | 0;
       } else i4 = 0;
       if ((i1 | 0) == 1) f5 = Math_fround(3402823469999999843913219.0e14); else f5 = Math_fround(HEAPF32[i12 + 60 >> 2]);
       __ZN15TerrainRenderer11RenderStep1EPK6Cameraiff(HEAP32[i11 + 4 >> 2] | 0, i22, HEAP32[i12 + 56 >> 2] | 0, Math_fround(HEAPF32[i12 + 52 >> 2]), f5);
       if (!i4) break;
       __Z12profiler_endP19ProfilerInformation(i4);
      }
     }
    } while (0);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i16 | 0));
 }
 i1 = HEAP32[i23 >> 2] | 0;
 if (i1 | 0) {
  i12 = i22 + 880 | 0;
  i11 = 0;
  do {
   i10 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i11 << 3) >> 2] | 0;
   if (HEAP32[i10 + 204 >> 2] & 1) if (HEAP8[i10 + 89 >> 0] | 0) {
    i4 = i10 + 208 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    L78 : do if (!i1) i2 = 0; else {
     HEAP32[i26 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 61; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
       i2 = HEAP32[i21 >> 2] | 0;
       i20 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 61; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 63;
      }
     }
     if ((i29 | 0) == 61) i29 = 63;
     if ((i29 | 0) == 63) {
      i29 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) {
       i2 = 0;
       break;
      }
     }
     if (!(HEAP32[i1 + 204 >> 2] & 1)) i2 = 0; else if (!(HEAP8[i1 + 89 >> 0] | 0)) i2 = 0; else if (!(1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i12 >> 2])) i2 = 0; else {
      i4 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
      i6 = HEAP32[i1 + 240 >> 2] | 0;
      if (!i6) i2 = 0; else {
       i3 = HEAP32[i1 + 228 >> 2] | 0;
       i1 = 0;
       while (1) {
        i2 = i3 + (i1 * 20 | 0) | 0;
        if ((HEAP32[i2 >> 2] | 0) == (i22 | 0)) break;
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= i6 >>> 0) {
         i2 = 0;
         break L78;
        }
       }
       HEAP32[i3 + (i1 * 20 | 0) + 16 >> 2] = i4;
      }
     }
    } while (0);
    i6 = i10 + 220 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    L101 : do if (!i1) i3 = 0; else {
     HEAP32[i26 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 78; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i3 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
       i3 = HEAP32[i21 >> 2] | 0;
       i20 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i3 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i29 = 78; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 80;
      }
     }
     if ((i29 | 0) == 78) i29 = 80;
     if ((i29 | 0) == 80) {
      i29 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      if (!i1) {
       i3 = 0;
       break;
      }
     }
     if (!(HEAP32[i1 + 204 >> 2] & 1)) i3 = 0; else if (!(HEAP8[i1 + 89 >> 0] | 0)) i3 = 0; else if (!(1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i12 >> 2])) i3 = 0; else {
      i6 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
      i7 = HEAP32[i1 + 240 >> 2] | 0;
      if (!i7) i3 = 0; else {
       i4 = HEAP32[i1 + 228 >> 2] | 0;
       i1 = 0;
       while (1) {
        i3 = i4 + (i1 * 20 | 0) | 0;
        if ((HEAP32[i3 >> 2] | 0) == (i22 | 0)) break;
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= i7 >>> 0) {
         i3 = 0;
         break L101;
        }
       }
       HEAP32[i4 + (i1 * 20 | 0) + 16 >> 2] = i6;
      }
     }
    } while (0);
    i7 = i10 + 212 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    L124 : do if (!i1) i4 = 0; else {
     HEAP32[i26 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 95; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i4 = HEAP32[i1 + 28 >> 2] | 0;
       i6 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i4 + (i6 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
       i4 = HEAP32[i21 >> 2] | 0;
       i20 = HEAP32[i1 + 28 >> 2] | 0;
       i6 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i4 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i4 << 3) | 0;
       i4 = HEAP32[i6 + 28 >> 2] | 0;
       i6 = HEAP32[i6 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i4 + (i6 << 3) | 0)) i29 = 95; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 97;
      }
     }
     if ((i29 | 0) == 95) i29 = 97;
     if ((i29 | 0) == 97) {
      i29 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
      if (!i1) {
       i4 = 0;
       break;
      }
     }
     if (!(HEAP32[i1 + 204 >> 2] & 1)) i4 = 0; else if (!(HEAP8[i1 + 89 >> 0] | 0)) i4 = 0; else if (!(1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i12 >> 2])) i4 = 0; else {
      i7 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
      i8 = HEAP32[i1 + 240 >> 2] | 0;
      if (!i8) i4 = 0; else {
       i6 = HEAP32[i1 + 228 >> 2] | 0;
       i1 = 0;
       while (1) {
        i4 = i6 + (i1 * 20 | 0) | 0;
        if ((HEAP32[i4 >> 2] | 0) == (i22 | 0)) break;
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= i8 >>> 0) {
         i4 = 0;
         break L124;
        }
       }
       HEAP32[i6 + (i1 * 20 | 0) + 16 >> 2] = i7;
      }
     }
    } while (0);
    i8 = i10 + 216 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    L147 : do if (!i1) i6 = 0; else {
     HEAP32[i26 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i29 = 112; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i6 = HEAP32[i1 + 28 >> 2] | 0;
       i7 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i6 + (i7 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
       i6 = HEAP32[i21 >> 2] | 0;
       i20 = HEAP32[i1 + 28 >> 2] | 0;
       i7 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i6 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i6 << 3) | 0;
       i6 = HEAP32[i7 + 28 >> 2] | 0;
       i7 = HEAP32[i7 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i6 + (i7 << 3) | 0)) i29 = 112; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i29 = 114;
      }
     }
     if ((i29 | 0) == 112) i29 = 114;
     if ((i29 | 0) == 114) {
      i29 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
      if (!i1) {
       i6 = 0;
       break;
      }
     }
     if (!(HEAP32[i1 + 204 >> 2] & 1)) i6 = 0; else if (!(HEAP8[i1 + 89 >> 0] | 0)) i6 = 0; else if (!(1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i12 >> 2])) i6 = 0; else {
      i8 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
      i9 = HEAP32[i1 + 240 >> 2] | 0;
      if (!i9) i6 = 0; else {
       i7 = HEAP32[i1 + 228 >> 2] | 0;
       i1 = 0;
       while (1) {
        i6 = i7 + (i1 * 20 | 0) | 0;
        if ((HEAP32[i6 >> 2] | 0) == (i22 | 0)) break;
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= i9 >>> 0) {
         i6 = 0;
         break L147;
        }
       }
       HEAP32[i7 + (i1 * 20 | 0) + 16 >> 2] = i8;
      }
     }
    } while (0);
    i9 = HEAP32[(HEAP32[(HEAP32[i27 >> 2] | 0) + (i11 << 3) + 4 >> 2] | 0) + 4 >> 2] | 0;
    i8 = HEAP32[i9 + 28 >> 2] | 0;
    if (!i2) i7 = 0; else {
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if ((HEAP32[i1 + 28 >> 2] | 0) == (i8 | 0)) i7 = i1; else {
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 934308 | 0, 84);
      __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 512, HEAP32[i10 + 4 >> 2] | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      i7 = 0;
     }
    }
    if (!i3) i3 = 0; else {
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if ((HEAP32[i1 + 28 >> 2] | 0) == (i8 | 0)) i3 = i1; else {
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 934393 | 0, 83);
      __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 512, HEAP32[i10 + 4 >> 2] | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      i3 = 0;
     }
    }
    if (!i4) i2 = 0; else {
     i1 = HEAP32[i4 + 4 >> 2] | 0;
     if ((HEAP32[i1 + 28 >> 2] | 0) == (i8 | 0)) i2 = i1; else {
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 934477 | 0, 85);
      __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 512, HEAP32[i10 + 4 >> 2] | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      i2 = 0;
     }
    }
    if (!i6) i1 = 0; else {
     i1 = HEAP32[i6 + 4 >> 2] | 0;
     if ((HEAP32[i1 + 28 >> 2] | 0) != (i8 | 0)) {
      HEAP32[i21 >> 2] = 0;
      HEAP32[i21 + 4 >> 2] = 0;
      HEAP32[i21 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 934563 | 0, 86);
      __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 512, HEAP32[i10 + 4 >> 2] | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      i1 = 0;
     }
    }
    HEAP32[i9 >> 2] = i3;
    HEAP32[i9 + 4 >> 2] = i2;
    HEAP32[i9 + 8 >> 2] = i1;
    HEAP32[i9 + 12 >> 2] = i7;
    i1 = HEAP32[i23 >> 2] | 0;
   }
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i4 = 0;
   do {
    i3 = HEAP32[i27 >> 2] | 0;
    i1 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
    if (HEAP32[i1 + 204 >> 2] & 1 | 0) if (HEAP8[i1 + 89 >> 0] | 0) {
     if ((HEAP16[gb + 1467428 + 6 >> 1] | 0) > -1) {
      HEAP32[i26 >> 2] = i1;
      HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
      __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467428 | 0, i21);
      i2 = gb + 1467428 | 0;
      i1 = HEAP32[i27 >> 2] | 0;
     } else {
      i2 = 0;
      i1 = i3;
     }
     i20 = HEAP32[(HEAP32[i1 + (i4 << 3) + 4 >> 2] | 0) + 4 >> 2] | 0;
     __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i20, (HEAP32[i20 + 20 >> 2] | 0) + -64 | 0);
     if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
    }
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i23 >> 2] | 0;
   } while (i4 >>> 0 < i1 >>> 0);
   if (i1 | 0) {
    i14 = i26 + 4 | 0;
    i15 = i26 + 12 | 0;
    i16 = i21 + 4 | 0;
    i17 = i26 + 4 | 0;
    i18 = i28 + 12 | 0;
    i19 = i28 + 16 | 0;
    i20 = i28 + 4 | 0;
    i13 = 0;
    do {
     i10 = HEAP32[i27 >> 2] | 0;
     i11 = HEAP32[i10 + (i13 << 3) >> 2] | 0;
     i2 = i11 + 28 | 0;
     i12 = HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0;
     i10 = HEAP32[i10 + (i13 << 3) + 4 >> 2] | 0;
     i7 = i11 + 204 | 0;
     if (HEAP32[i7 >> 2] & 1 | 0) if (HEAP8[i11 + 89 >> 0] | 0) {
      if ((HEAP16[gb + 1467440 + 6 >> 1] | 0) > -1) {
       HEAP32[i26 >> 2] = i11;
       HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
       __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467440 | 0, i21);
       i4 = gb + 1467440 | 0;
      } else i4 = 0;
      i6 = gb + 64016 | 0;
      i3 = HEAP32[i6 + 4 >> 2] | 0;
      i1 = i26;
      HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i1 + 4 >> 2] = i3;
      HEAP32[i28 >> 2] = 0;
      HEAP32[i18 >> 2] = 0;
      HEAP32[i19 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i26);
      i1 = i21;
      i3 = HEAP32[i1 + 4 >> 2] | 0;
      i6 = i20;
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i6 + 4 >> 2] = i3;
      i6 = i11 + 112 | 0;
      __ZNK14SplatMaterials12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE(HEAP32[i6 >> 2] | 0, i28);
      i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + 72 >> 2] | 0;
      i3 = i11 + 92 | 0;
      i1 = HEAP32[i3 >> 2] | 0;
      if ((i1 | 0) > 0) {
       i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0;
       i1 = HEAP32[i3 >> 2] | 0;
      } else i2 = 0;
      __ZN15TerrainRenderer11RenderStep3EP6Cameraib20ReflectionProbeUsageP9TransformRK13dynamic_arrayIP8MaterialLj4EES7_(HEAP32[i10 + 4 >> 2] | 0, i22, i12, (HEAP8[i11 + 88 >> 0] | 0) != 0, i1, i2, i28, i6);
      if ((HEAP32[i19 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i20);
       HEAP32[i28 >> 2] = 0;
      }
      if (i4 | 0) __Z12profiler_endP19ProfilerInformation(i4);
     }
     if (HEAP32[i7 >> 2] & 4 | 0) if (HEAP8[i11 + 90 >> 0] | 0) {
      i1 = i11 + 80 | 0;
      f5 = Math_fround(HEAPF32[i1 >> 2]);
      if (+f5 > .001) {
       if ((HEAP16[gb + 1467452 + 6 >> 1] | 0) > -1) {
        HEAP32[i26 >> 2] = i11;
        HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
        __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467452 | 0, i21);
        f5 = Math_fround(HEAPF32[i1 >> 2]);
        i1 = gb + 1467452 | 0;
       } else i1 = 0;
       f31 = Math_fround(HEAPF32[i11 + 84 >> 2]);
       __ZN14DetailRenderer6RenderEP6Camerafifb(HEAP32[i10 + 12 >> 2] | 0, i22, f5, i12, f31, (HEAP8[i11 + 200 >> 0] | 0) != 0);
       if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
      }
     }
     if (HEAP32[i7 >> 2] & 2 | 0) if (HEAP8[i11 + 90 >> 0] | 0) {
      i8 = i11 + 64 | 0;
      if (+Math_fround(HEAPF32[i8 >> 2]) > .001) {
       if ((HEAP16[gb + 1467464 + 6 >> 1] | 0) > -1) {
        HEAP32[i26 >> 2] = i11;
        HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
        __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467464 | 0, i21);
        i9 = gb + 1467464 | 0;
       } else i9 = 0;
       i6 = i10 + 8 | 0;
       i7 = HEAP32[i6 >> 2] | 0;
       do if (!(HEAP8[i11 + 188 >> 0] | 0)) {
        i1 = 0;
        i2 = -1;
       } else {
        i4 = HEAP32[i11 + 48 >> 2] | 0;
        if (!i4) {
         i1 = 0;
         i2 = -1;
        } else {
         HEAP32[i26 >> 2] = i4;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i1) i29 = 178; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i2 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[i1 + 32 >> 2] | 0;
           i1 = i2 + (i3 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i26);
           i2 = HEAP32[i21 >> 2] | 0;
           i10 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[gb + 1104264 >> 2] | 0;
           i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
           i2 = HEAP32[i3 + 28 >> 2] | 0;
           i3 = HEAP32[i3 + 32 >> 2] | 0;
          }
          if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
           i29 = 178;
           break;
          }
          if (!(HEAP32[i1 + 4 >> 2] | 0)) i29 = 180;
         } while (0);
         if ((i29 | 0) == 178) i29 = 180;
         if ((i29 | 0) == 180) {
          i29 = 0;
          if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
           i1 = 0;
           i2 = -1;
           break;
          }
         }
         if (!(__ZN16LightmapSettings14GetLightProbesEv(__Z19GetLightmapSettingsv() | 0) | 0)) {
          i1 = 0;
          i2 = -1;
         } else {
          i1 = __ZN16LightmapSettings24GetEnlightenSceneMappingEv(__Z19GetLightmapSettingsv() | 0) | 0;
          __ZNK21EnlightenSceneMapping22GetTerrainInstanceHashEi(i21, i1, HEAP32[i11 + 4 >> 2] | 0);
          __ZNK11LightProbes47GetNonTetrahedralizedProbeSetIndexOffsetAndSizeERK7Hash128(i26, __ZN16LightmapSettings14GetLightProbesEv(__Z19GetLightmapSettingsv() | 0) | 0, i21);
          i1 = HEAP32[i17 >> 2] | 0;
          i2 = HEAP32[i26 >> 2] | 0;
         }
        }
       } while (0);
       __ZN12TreeRenderer16UpdateProbeIndexEii(i7, i2, i1);
       __ZN12LightManager9GetLightsE9LightTypei(i26, __Z15GetLightManagerv() | 0, 1, i12);
       f32 = Math_fround(HEAPF32[i8 >> 2]);
       f5 = Math_fround(HEAPF32[i11 + 68 >> 2]);
       f31 = Math_fround(HEAPF32[i11 + 72 >> 2]);
       __ZN12TreeRenderer6RenderER6CameraRKNSt3__26vectorIP5Light13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEfffii(HEAP32[i6 >> 2] | 0, i22, i26, f32, f5, f31, HEAP32[i11 + 76 >> 2] | 0, i12);
       i1 = HEAP32[i26 >> 2] | 0;
       i2 = i1;
       if (i1 | 0) {
        i3 = HEAP32[i14 >> 2] | 0;
        if ((i3 | 0) != (i1 | 0)) HEAP32[i14 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
        i12 = HEAP32[i15 >> 2] | 0;
        HEAP32[i21 >> 2] = 52;
        HEAP32[i16 >> 2] = i12;
        __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
       }
       if (i9 | 0) __Z12profiler_endP19ProfilerInformation(i9);
      }
     }
     i13 = i13 + 1 | 0;
    } while (i13 >>> 0 < (HEAP32[i23 >> 2] | 0) >>> 0);
   }
  }
 }
 if ((HEAP32[i24 >> 2] | 0) <= -1) {
  STACKTOP = i30;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i25);
 HEAP32[i27 >> 2] = 0;
 STACKTOP = i30;
 return;
}

function ___floatscan(i23, i2, i20) {
 i23 = i23 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 var d1 = 0.0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, d31 = 0.0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i30;
 switch (i2 | 0) {
 case 0:
  {
   i27 = -149;
   i29 = 24;
   i19 = 4;
   break;
  }
 case 1:
  {
   i27 = -1074;
   i29 = 53;
   i19 = 4;
   break;
  }
 case 2:
  {
   i27 = -1074;
   i29 = 53;
   i19 = 4;
   break;
  }
 default:
  d1 = 0.0;
 }
 L4 : do if ((i19 | 0) == 4) {
  i22 = i23 + 4 | 0;
  i21 = i23 + 100 | 0;
  do {
   i2 = HEAP32[i22 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
    HEAP32[i22 >> 2] = i2 + 1;
    i2 = HEAPU8[i2 >> 0] | 0;
   } else i2 = ___shgetc(i23) | 0;
  } while ((_isspace(i2) | 0) != 0);
  L13 : do switch (i2 | 0) {
  case 43:
  case 45:
   {
    i3 = 1 - (((i2 | 0) == 45 & 1) << 1) | 0;
    i2 = HEAP32[i22 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
     HEAP32[i22 >> 2] = i2 + 1;
     i5 = HEAPU8[i2 >> 0] | 0;
     i28 = i3;
     break L13;
    } else {
     i5 = ___shgetc(i23) | 0;
     i28 = i3;
     break L13;
    }
   }
  default:
   {
    i5 = i2;
    i28 = 1;
   }
  } while (0);
  i2 = 0;
  do {
   if ((i5 | 32 | 0) != (HEAP8[gb + 1069341 + i2 >> 0] | 0)) break;
   do if (i2 >>> 0 < 7) {
    i3 = HEAP32[i22 >> 2] | 0;
    if (i3 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
     HEAP32[i22 >> 2] = i3 + 1;
     i5 = HEAPU8[i3 >> 0] | 0;
     break;
    } else {
     i5 = ___shgetc(i23) | 0;
     break;
    }
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < 8);
  L29 : do switch (i2 | 0) {
  case 8:
   break;
  case 3:
   {
    i19 = 23;
    break;
   }
  default:
   {
    i6 = (i20 | 0) != 0;
    if (i6 & i2 >>> 0 > 3) if ((i2 | 0) == 8) break L29; else {
     i19 = 23;
     break L29;
    }
    L34 : do if (!i2) {
     i2 = 0;
     do {
      if ((i5 | 32 | 0) != (HEAP8[gb + 1069350 + i2 >> 0] | 0)) break L34;
      do if (i2 >>> 0 < 2) {
       i3 = HEAP32[i22 >> 2] | 0;
       if (i3 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i3 + 1;
        i5 = HEAPU8[i3 >> 0] | 0;
        break;
       } else {
        i5 = ___shgetc(i23) | 0;
        break;
       }
      } while (0);
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < 3);
    } while (0);
    switch (i2 | 0) {
    case 3:
     {
      i2 = HEAP32[i22 >> 2] | 0;
      if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
       HEAP32[i22 >> 2] = i2 + 1;
       i2 = HEAPU8[i2 >> 0] | 0;
      } else i2 = ___shgetc(i23) | 0;
      if ((i2 | 0) == 40) i2 = 1; else {
       if (!(HEAP32[i21 >> 2] | 0)) {
        d1 = nan;
        break L4;
       }
       HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
       d1 = nan;
       break L4;
      }
      while (1) {
       i3 = HEAP32[i22 >> 2] | 0;
       if (i3 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i3 + 1;
        i3 = HEAPU8[i3 >> 0] | 0;
       } else i3 = ___shgetc(i23) | 0;
       if (!((i3 + -48 | 0) >>> 0 < 10 | (i3 + -65 | 0) >>> 0 < 26)) if (!((i3 | 0) == 95 | (i3 + -97 | 0) >>> 0 < 26)) break;
       i2 = i2 + 1 | 0;
      }
      if ((i3 | 0) == 41) {
       d1 = nan;
       break L4;
      }
      i3 = (HEAP32[i21 >> 2] | 0) == 0;
      if (!i3) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
      if (!i6) {
       HEAP32[(___errno_location() | 0) >> 2] = 22;
       ___shlim(i23, 0);
       d1 = 0.0;
       break L4;
      }
      if (!i2) {
       d1 = nan;
       break L4;
      }
      while (1) {
       i2 = i2 + -1 | 0;
       if (!i3) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
       if (!i2) {
        d1 = nan;
        break L4;
       }
      }
     }
    case 0:
     {
      do if ((i5 | 0) == 48) {
       i2 = HEAP32[i22 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i2 + 1;
        i2 = HEAPU8[i2 >> 0] | 0;
       } else i2 = ___shgetc(i23) | 0;
       if ((i2 | 32 | 0) != 120) {
        if (!(HEAP32[i21 >> 2] | 0)) {
         i5 = 48;
         break;
        }
        HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
        i5 = 48;
        break;
       }
       i2 = HEAP32[i22 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i2 + 1;
        i3 = HEAPU8[i2 >> 0] | 0;
        i5 = 0;
       } else {
        i3 = ___shgetc(i23) | 0;
        i5 = 0;
       }
       L94 : while (1) {
        switch (i3 | 0) {
        case 46:
         {
          i19 = 74;
          break L94;
         }
        case 48:
         break;
        default:
         {
          i14 = 0;
          i7 = 0;
          d10 = 1.0;
          d1 = 0.0;
          i2 = 0;
          i6 = i3;
          i15 = i5;
          i17 = 0;
          i16 = 0;
          i5 = 0;
          i3 = 0;
          break L94;
         }
        }
        i2 = HEAP32[i22 >> 2] | 0;
        if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
         HEAP32[i22 >> 2] = i2 + 1;
         i3 = HEAPU8[i2 >> 0] | 0;
         i5 = 1;
         continue;
        } else {
         i3 = ___shgetc(i23) | 0;
         i5 = 1;
         continue;
        }
       }
       if ((i19 | 0) == 74) {
        i2 = HEAP32[i22 >> 2] | 0;
        if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
         HEAP32[i22 >> 2] = i2 + 1;
         i3 = HEAPU8[i2 >> 0] | 0;
        } else i3 = ___shgetc(i23) | 0;
        if ((i3 | 0) == 48) {
         i5 = 0;
         i3 = 0;
         do {
          i2 = HEAP32[i22 >> 2] | 0;
          if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
           HEAP32[i22 >> 2] = i2 + 1;
           i6 = HEAPU8[i2 >> 0] | 0;
          } else i6 = ___shgetc(i23) | 0;
          i5 = _i64Add(i5 | 0, i3 | 0, -1, -1) | 0;
          i3 = getTempRet0() | 0;
         } while ((i6 | 0) == 48);
         i14 = 1;
         i7 = 0;
         d10 = 1.0;
         d1 = 0.0;
         i2 = 0;
         i15 = 1;
         i17 = 0;
         i16 = 0;
        } else {
         i14 = 1;
         i7 = 0;
         d10 = 1.0;
         d1 = 0.0;
         i2 = 0;
         i6 = i3;
         i15 = i5;
         i17 = 0;
         i16 = 0;
         i5 = 0;
         i3 = 0;
        }
       }
       while (1) {
        i9 = i6 + -48 | 0;
        i8 = i6 | 32;
        if (i9 >>> 0 < 10) i19 = 86; else {
         i12 = (i6 | 0) == 46;
         if (!(i12 | (i8 + -97 | 0) >>> 0 < 6)) break;
         if (i12) if (!i14) {
          i14 = 1;
          d4 = d10;
          i12 = i15;
          i5 = i16;
          i3 = i17;
          i9 = i16;
          i8 = i17;
         } else {
          i6 = 46;
          break;
         } else i19 = 86;
        }
        if ((i19 | 0) == 86) {
         i19 = 0;
         i6 = (i6 | 0) > 57 ? i8 + -87 | 0 : i9;
         do if ((i17 | 0) < 0 | (i17 | 0) == 0 & i16 >>> 0 < 8) {
          d4 = d10;
          i2 = i6 + (i2 << 4) | 0;
         } else {
          if ((i17 | 0) < 0 | (i17 | 0) == 0 & i16 >>> 0 < 14) {
           d13 = d10 * .0625;
           d4 = d13;
           d1 = d1 + d13 * +(i6 | 0);
           break;
          }
          if ((i7 | 0) != 0 | (i6 | 0) == 0) d4 = d10; else {
           i7 = 1;
           d4 = d10;
           d1 = d1 + d10 * .5;
          }
         } while (0);
         i9 = _i64Add(i16 | 0, i17 | 0, 1, 0) | 0;
         i12 = 1;
         i8 = getTempRet0() | 0;
        }
        i6 = HEAP32[i22 >> 2] | 0;
        if (i6 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
         HEAP32[i22 >> 2] = i6 + 1;
         d10 = d4;
         i6 = HEAPU8[i6 >> 0] | 0;
         i15 = i12;
         i17 = i8;
         i16 = i9;
         continue;
        } else {
         d10 = d4;
         i6 = ___shgetc(i23) | 0;
         i15 = i12;
         i17 = i8;
         i16 = i9;
         continue;
        }
       }
       if (!i15) {
        i2 = (HEAP32[i21 >> 2] | 0) == 0;
        if (!i2) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
        if (!i20) ___shlim(i23, 0); else if (!i2) {
         i2 = HEAP32[i22 >> 2] | 0;
         HEAP32[i22 >> 2] = i2 + -1;
         if (i14 | 0) HEAP32[i22 >> 2] = i2 + -2;
        }
        d1 = +(i28 | 0) * 0.0;
        break L4;
       }
       i8 = (i14 | 0) == 0;
       i9 = i8 ? i16 : i5;
       i8 = i8 ? i17 : i3;
       if ((i17 | 0) < 0 | (i17 | 0) == 0 & i16 >>> 0 < 8) {
        i5 = i16;
        i3 = i17;
        do {
         i2 = i2 << 4;
         i5 = _i64Add(i5 | 0, i3 | 0, 1, 0) | 0;
         i3 = getTempRet0() | 0;
        } while ((i3 | 0) < 0 | (i3 | 0) == 0 & i5 >>> 0 < 8);
        i7 = i2;
       } else i7 = i2;
       if ((i6 | 32 | 0) == 112) {
        i3 = _scanexp(i23, i20) | 0;
        i2 = getTempRet0() | 0;
        if ((i3 | 0) == 0 & (i2 | 0) == -2147483648) {
         if (!i20) {
          ___shlim(i23, 0);
          d1 = 0.0;
          break L4;
         }
         if (!(HEAP32[i21 >> 2] | 0)) {
          i3 = 0;
          i2 = 0;
         } else {
          HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
          i3 = 0;
          i2 = 0;
         }
        }
       } else if (!(HEAP32[i21 >> 2] | 0)) {
        i3 = 0;
        i2 = 0;
       } else {
        HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
        i3 = 0;
        i2 = 0;
       }
       i5 = _bitshift64Shl(i9 | 0, i8 | 0, 2) | 0;
       i5 = _i64Add(i5 | 0, getTempRet0() | 0, -32, -1) | 0;
       i5 = _i64Add(i5 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
       i2 = getTempRet0() | 0;
       if (!i7) {
        d1 = +(i28 | 0) * 0.0;
        break L4;
       }
       if ((i2 | 0) > 0 | (i2 | 0) == 0 & i5 >>> 0 > (0 - i27 | 0) >>> 0) {
        HEAP32[(___errno_location() | 0) >> 2] = 34;
        d1 = +(i28 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
        break L4;
       }
       i26 = i27 + -106 | 0;
       i25 = ((i26 | 0) < 0) << 31 >> 31;
       if ((i2 | 0) < (i25 | 0) | (i2 | 0) == (i25 | 0) & i5 >>> 0 < i26 >>> 0) {
        HEAP32[(___errno_location() | 0) >> 2] = 34;
        d1 = +(i28 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
        break L4;
       }
       if ((i7 | 0) > -1) {
        i3 = i7;
        do {
         i25 = !(d1 >= .5);
         i26 = i25 & 1 | i3 << 1;
         i3 = i26 ^ 1;
         d1 = d1 + (i25 ? d1 : d1 + -1.0);
         i5 = _i64Add(i5 | 0, i2 | 0, -1, -1) | 0;
         i2 = getTempRet0() | 0;
        } while ((i26 | 0) > -1);
        d10 = d1;
        i6 = i3;
       } else {
        d10 = d1;
        i6 = i7;
       }
       i27 = _i64Subtract(32, 0, i27 | 0, ((i27 | 0) < 0) << 31 >> 31 | 0) | 0;
       i2 = _i64Add(i5 | 0, i2 | 0, i27 | 0, getTempRet0() | 0) | 0;
       i27 = getTempRet0() | 0;
       if (0 > (i27 | 0) | 0 == (i27 | 0) & i29 >>> 0 > i2 >>> 0) if ((i2 | 0) < 0) {
        i3 = 0;
        i2 = 84;
        i19 = 127;
       } else i19 = 125; else {
        i2 = i29;
        i19 = 125;
       }
       if ((i19 | 0) == 125) if ((i2 | 0) < 53) {
        i3 = i2;
        i2 = 84 - i2 | 0;
        i19 = 127;
       } else {
        d4 = 0.0;
        d1 = +(i28 | 0);
       }
       if ((i19 | 0) == 127) {
        d1 = +(i28 | 0);
        d4 = +_copysignl(+_scalbn(1.0, i2), d1);
        i2 = i3;
       }
       i29 = (i6 & 1 | 0) == 0 & (d10 != 0.0 & (i2 | 0) < 32);
       d1 = d1 * (i29 ? 0.0 : d10) + (d4 + d1 * +(((i29 & 1) + i6 | 0) >>> 0)) - d4;
       if (!(d1 != 0.0)) HEAP32[(___errno_location() | 0) >> 2] = 34;
       d1 = +_scalbnl(d1, i5);
       break L4;
      } while (0);
      i24 = i27 + i29 | 0;
      i25 = 0 - i24 | 0;
      i3 = 0;
      L184 : while (1) {
       switch (i5 | 0) {
       case 46:
        {
         i19 = 138;
         break L184;
        }
       case 48:
        break;
       default:
        {
         i7 = 0;
         i6 = i3;
         i8 = 0;
         i2 = 0;
         break L184;
        }
       }
       i2 = HEAP32[i22 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i2 + 1;
        i5 = HEAPU8[i2 >> 0] | 0;
        i3 = 1;
        continue;
       } else {
        i5 = ___shgetc(i23) | 0;
        i3 = 1;
        continue;
       }
      }
      if ((i19 | 0) == 138) {
       i2 = HEAP32[i22 >> 2] | 0;
       if (i2 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
        HEAP32[i22 >> 2] = i2 + 1;
        i5 = HEAPU8[i2 >> 0] | 0;
       } else i5 = ___shgetc(i23) | 0;
       if ((i5 | 0) == 48) {
        i3 = 0;
        i2 = 0;
        do {
         i3 = _i64Add(i3 | 0, i2 | 0, -1, -1) | 0;
         i2 = getTempRet0() | 0;
         i5 = HEAP32[i22 >> 2] | 0;
         if (i5 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
          HEAP32[i22 >> 2] = i5 + 1;
          i5 = HEAPU8[i5 >> 0] | 0;
         } else i5 = ___shgetc(i23) | 0;
        } while ((i5 | 0) == 48);
        i7 = 1;
        i6 = 1;
        i8 = i3;
       } else {
        i7 = 1;
        i6 = i3;
        i8 = 0;
        i2 = 0;
       }
      }
      HEAP32[i26 >> 2] = 0;
      i12 = i5 + -48 | 0;
      i9 = (i5 | 0) == 46;
      L203 : do if (i9 | i12 >>> 0 < 10) {
       i19 = i26 + 496 | 0;
       i15 = 0;
       i3 = 0;
       i18 = 0;
       i16 = i7;
       i17 = i6;
       i7 = 0;
       i6 = 0;
       L205 : while (1) {
        do if (i9) if (!i16) {
         i16 = 1;
         i14 = i18;
         i8 = i7;
         i2 = i6;
        } else break L205; else {
         i7 = _i64Add(i7 | 0, i6 | 0, 1, 0) | 0;
         i6 = getTempRet0() | 0;
         i14 = (i5 | 0) != 48;
         if ((i3 | 0) >= 125) {
          if (!i14) {
           i14 = i18;
           break;
          }
          HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 1;
          i14 = i18;
          break;
         }
         i9 = i26 + (i3 << 2) | 0;
         if (!i15) i5 = i12; else i5 = i5 + -48 + ((HEAP32[i9 >> 2] | 0) * 10 | 0) | 0;
         HEAP32[i9 >> 2] = i5;
         i15 = i15 + 1 | 0;
         i17 = (i15 | 0) == 9;
         i15 = i17 ? 0 : i15;
         i3 = (i17 & 1) + i3 | 0;
         i14 = i14 ? i7 : i18;
         i17 = 1;
        } while (0);
        i5 = HEAP32[i22 >> 2] | 0;
        if (i5 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) {
         HEAP32[i22 >> 2] = i5 + 1;
         i5 = HEAPU8[i5 >> 0] | 0;
        } else i5 = ___shgetc(i23) | 0;
        i12 = i5 + -48 | 0;
        i9 = (i5 | 0) == 46;
        if (!(i9 | i12 >>> 0 < 10)) {
         i9 = i14;
         i14 = i16;
         i12 = i17;
         i16 = i7;
         i19 = 161;
         break L203;
        } else i18 = i14;
       }
       i12 = i15;
       i9 = i18;
       i5 = (i17 | 0) != 0;
       i19 = 169;
      } else {
       i15 = 0;
       i3 = 0;
       i9 = 0;
       i14 = i7;
       i12 = i6;
       i16 = 0;
       i6 = 0;
       i19 = 161;
      } while (0);
      do if ((i19 | 0) == 161) {
       i14 = (i14 | 0) == 0;
       i8 = i14 ? i16 : i8;
       i2 = i14 ? i6 : i2;
       i14 = (i12 | 0) != 0;
       if (!(i14 & (i5 | 32 | 0) == 101)) if ((i5 | 0) > -1) {
        i12 = i15;
        i7 = i16;
        i5 = i14;
        i19 = 169;
        break;
       } else {
        i12 = i15;
        i7 = i16;
        i5 = i14;
        i19 = 171;
        break;
       }
       i7 = _scanexp(i23, i20) | 0;
       i5 = getTempRet0() | 0;
       if ((i7 | 0) == 0 & (i5 | 0) == -2147483648) {
        if (!i20) {
         ___shlim(i23, 0);
         d1 = 0.0;
         break;
        }
        if (!(HEAP32[i21 >> 2] | 0)) {
         i7 = 0;
         i5 = 0;
        } else {
         HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
         i7 = 0;
         i5 = 0;
        }
       }
       i17 = _i64Add(i7 | 0, i5 | 0, i8 | 0, i2 | 0) | 0;
       i12 = i15;
       i7 = i16;
       i2 = getTempRet0() | 0;
       i19 = 173;
      } while (0);
      if ((i19 | 0) == 169) if (!(HEAP32[i21 >> 2] | 0)) i19 = 171; else {
       HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
       if (i5) {
        i17 = i8;
        i19 = 173;
       } else i19 = 172;
      }
      if ((i19 | 0) == 171) if (i5) {
       i17 = i8;
       i19 = 173;
      } else i19 = 172;
      do if ((i19 | 0) == 172) {
       HEAP32[(___errno_location() | 0) >> 2] = 22;
       ___shlim(i23, 0);
       d1 = 0.0;
      } else if ((i19 | 0) == 173) {
       i5 = HEAP32[i26 >> 2] | 0;
       if (!i5) {
        d1 = +(i28 | 0) * 0.0;
        break;
       }
       if (((i6 | 0) < 0 | (i6 | 0) == 0 & i7 >>> 0 < 10) & ((i17 | 0) == (i7 | 0) & (i2 | 0) == (i6 | 0))) if (i29 >>> 0 > 30 | (i5 >>> i29 | 0) == 0) {
        d1 = +(i28 | 0) * +(i5 >>> 0);
        break;
       }
       i23 = (i27 | 0) / -2 | 0;
       i22 = ((i23 | 0) < 0) << 31 >> 31;
       if ((i2 | 0) > (i22 | 0) | (i2 | 0) == (i22 | 0) & i17 >>> 0 > i23 >>> 0) {
        HEAP32[(___errno_location() | 0) >> 2] = 34;
        d1 = +(i28 | 0) * 1797693134862315708145274.0e284 * 1797693134862315708145274.0e284;
        break;
       }
       i23 = i27 + -106 | 0;
       i22 = ((i23 | 0) < 0) << 31 >> 31;
       if ((i2 | 0) < (i22 | 0) | (i2 | 0) == (i22 | 0) & i17 >>> 0 < i23 >>> 0) {
        HEAP32[(___errno_location() | 0) >> 2] = 34;
        d1 = +(i28 | 0) * 2.2250738585072014e-308 * 2.2250738585072014e-308;
        break;
       }
       if (i12) {
        if ((i12 | 0) < 9) {
         i6 = i26 + (i3 << 2) | 0;
         i2 = i12;
         i5 = HEAP32[i6 >> 2] | 0;
         do {
          i5 = i5 * 10 | 0;
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) != 9);
         HEAP32[i6 >> 2] = i5;
        }
        i3 = i3 + 1 | 0;
       }
       if ((i9 | 0) < 9) if ((i9 | 0) <= (i17 | 0) & (i17 | 0) < 18) {
        if ((i17 | 0) == 9) {
         d1 = +(i28 | 0) * +((HEAP32[i26 >> 2] | 0) >>> 0);
         break;
        }
        if ((i17 | 0) < 9) {
         d1 = +(i28 | 0) * +((HEAP32[i26 >> 2] | 0) >>> 0) / +(HEAP32[gb + 206632 + (8 - i17 << 2) >> 2] | 0);
         break;
        }
        i23 = i29 + 27 + (Math_imul(i17, -3) | 0) | 0;
        i2 = HEAP32[i26 >> 2] | 0;
        if ((i23 | 0) > 30 | (i2 >>> i23 | 0) == 0) {
         d1 = +(i28 | 0) * +(i2 >>> 0) * +(HEAP32[gb + 206632 + (i17 + -10 << 2) >> 2] | 0);
         break;
        }
       }
       i2 = (i17 | 0) % 9 | 0;
       if (!i2) {
        i2 = 0;
        i6 = 0;
       } else {
        i12 = (i17 | 0) > -1 ? i2 : i2 + 9 | 0;
        i8 = HEAP32[gb + 206632 + (8 - i12 << 2) >> 2] | 0;
        if (!i3) {
         i6 = 0;
         i3 = 0;
         i5 = i17;
        } else {
         i9 = 1e9 / (i8 | 0) | 0;
         i6 = 0;
         i7 = 0;
         i5 = i17;
         i2 = 0;
         do {
          i21 = i26 + (i2 << 2) | 0;
          i22 = HEAP32[i21 >> 2] | 0;
          i23 = ((i22 >>> 0) / (i8 >>> 0) | 0) + i6 | 0;
          HEAP32[i21 >> 2] = i23;
          i6 = Math_imul((i22 >>> 0) % (i8 >>> 0) | 0, i9) | 0;
          i23 = (i2 | 0) == (i7 | 0) & (i23 | 0) == 0;
          i5 = i23 ? i5 + -9 | 0 : i5;
          i7 = i23 ? i7 + 1 & 127 : i7;
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) != (i3 | 0));
         if (!i6) i6 = i7; else {
          HEAP32[i26 + (i3 << 2) >> 2] = i6;
          i6 = i7;
          i3 = i3 + 1 | 0;
         }
        }
        i2 = 0;
        i17 = 9 - i12 + i5 | 0;
       }
       L284 : while (1) {
        i12 = (i17 | 0) < 18;
        i14 = (i17 | 0) == 18;
        i15 = i26 + (i6 << 2) | 0;
        while (1) {
         if (!i12) {
          if (!i14) {
           i5 = i17;
           break L284;
          }
          if ((HEAP32[i15 >> 2] | 0) >>> 0 >= 9007199) {
           i5 = 18;
           break L284;
          }
         }
         i5 = 0;
         i16 = i3;
         i3 = i3 + 127 | 0;
         while (1) {
          i7 = i3 & 127;
          i8 = i26 + (i7 << 2) | 0;
          i3 = _bitshift64Shl(HEAP32[i8 >> 2] | 0, 0, 29) | 0;
          i3 = _i64Add(i3 | 0, getTempRet0() | 0, i5 | 0, 0) | 0;
          i5 = getTempRet0() | 0;
          if (i5 >>> 0 > 0 | (i5 | 0) == 0 & i3 >>> 0 > 1e9) {
           i9 = ___udivdi3(i3 | 0, i5 | 0, 1e9, 0) | 0;
           getTempRet0() | 0;
           i3 = ___uremdi3(i3 | 0, i5 | 0, 1e9, 0) | 0;
           getTempRet0() | 0;
          } else i9 = 0;
          HEAP32[i8 >> 2] = i3;
          i23 = (i7 | 0) == (i6 | 0);
          i16 = (i7 | 0) != (i16 + 127 & 127 | 0) | i23 ? i16 : (i3 | 0) == 0 ? i7 : i16;
          if (i23) break; else {
           i5 = i9;
           i3 = i7 + -1 | 0;
          }
         }
         i2 = i2 + -29 | 0;
         if (i9 | 0) break; else i3 = i16;
        }
        i6 = i6 + 127 & 127;
        i3 = i16 + 127 & 127;
        i5 = i26 + ((i16 + 126 & 127) << 2) | 0;
        if ((i6 | 0) == (i16 | 0)) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | HEAP32[i26 + (i3 << 2) >> 2]; else i3 = i16;
        HEAP32[i26 + (i6 << 2) >> 2] = i9;
        i17 = i17 + 9 | 0;
       }
       L302 : while (1) {
        i16 = i3 + 1 & 127;
        i17 = i26 + ((i3 + 127 & 127) << 2) | 0;
        i14 = i5;
        while (1) {
         i8 = (i14 | 0) == 18;
         i15 = (i14 | 0) > 27 ? 9 : 1;
         i18 = i6;
         while (1) {
          i5 = 0;
          while (1) {
           i6 = i5 + i18 & 127;
           if ((i6 | 0) == (i3 | 0)) {
            i5 = 2;
            i19 = 220;
            break;
           }
           i6 = HEAP32[i26 + (i6 << 2) >> 2] | 0;
           i7 = HEAP32[gb + 206664 + (i5 << 2) >> 2] | 0;
           if (i6 >>> 0 < i7 >>> 0) {
            i5 = 2;
            i19 = 220;
            break;
           }
           if (i6 >>> 0 > i7 >>> 0) break;
           i5 = i5 + 1 | 0;
           if ((i5 | 0) >= 2) {
            i19 = 220;
            break;
           }
          }
          if ((i19 | 0) == 220) {
           i19 = 0;
           if (i8 & (i5 | 0) == 2) {
            d1 = 0.0;
            i7 = 0;
            break L302;
           }
          }
          i2 = i2 + i15 | 0;
          if ((i18 | 0) == (i3 | 0)) i18 = i3; else break;
         }
         i9 = (1 << i15) + -1 | 0;
         i12 = 1e9 >>> i15;
         i8 = 0;
         i6 = i18;
         i5 = i14;
         i7 = i18;
         do {
          i21 = i26 + (i7 << 2) | 0;
          i22 = HEAP32[i21 >> 2] | 0;
          i23 = (i22 >>> i15) + i8 | 0;
          HEAP32[i21 >> 2] = i23;
          i8 = Math_imul(i22 & i9, i12) | 0;
          i23 = (i7 | 0) == (i6 | 0) & (i23 | 0) == 0;
          i5 = i23 ? i5 + -9 | 0 : i5;
          i6 = i23 ? i6 + 1 & 127 : i6;
          i7 = i7 + 1 & 127;
         } while ((i7 | 0) != (i3 | 0));
         if (!i8) {
          i14 = i5;
          continue;
         }
         if ((i16 | 0) != (i6 | 0)) break;
         HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 1;
         i14 = i5;
        }
        HEAP32[i26 + (i3 << 2) >> 2] = i8;
        i3 = i16;
       }
       while (1) {
        i6 = i7 + i18 & 127;
        i5 = i3 + 1 & 127;
        if ((i6 | 0) == (i3 | 0)) HEAP32[i26 + (i5 + -1 << 2) >> 2] = 0; else i5 = i3;
        d1 = d1 * 1.0e9 + +((HEAP32[i26 + (i6 << 2) >> 2] | 0) >>> 0);
        i7 = i7 + 1 | 0;
        if ((i7 | 0) == 2) break; else i3 = i5;
       }
       d13 = +(i28 | 0);
       d4 = d13 * d1;
       i8 = i2 + 53 | 0;
       i9 = i8 - i27 | 0;
       i12 = (i9 | 0) < (i29 | 0);
       i3 = i12 & 1;
       i7 = i12 ? ((i9 | 0) < 0 ? 0 : i9) : i29;
       if ((i7 | 0) < 53) {
        d31 = +_copysignl(+_scalbn(1.0, 105 - i7 | 0), d4);
        d10 = +_fmodl(d4, +_scalbn(1.0, 53 - i7 | 0));
        d11 = d31;
        d1 = d10;
        d10 = d31 + (d4 - d10);
       } else {
        d11 = 0.0;
        d1 = 0.0;
        d10 = d4;
       }
       i6 = i18 + 2 & 127;
       do if ((i6 | 0) == (i5 | 0)) d4 = d1; else {
        i6 = HEAP32[i26 + (i6 << 2) >> 2] | 0;
        do if (i6 >>> 0 < 5e8) {
         if (!i6) if ((i18 + 3 & 127 | 0) == (i5 | 0)) break;
         d1 = d13 * .25 + d1;
        } else {
         if ((i6 | 0) != 5e8) {
          d1 = d13 * .75 + d1;
          break;
         }
         if ((i18 + 3 & 127 | 0) == (i5 | 0)) {
          d1 = d13 * .5 + d1;
          break;
         } else {
          d1 = d13 * .75 + d1;
          break;
         }
        } while (0);
        if ((53 - i7 | 0) > 1) {
         if (+_fmodl(d1, 1.0) != 0.0) {
          d4 = d1;
          break;
         }
         d4 = d1 + 1.0;
        } else d4 = d1;
       } while (0);
       d1 = d10 + d4 - d11;
       do if ((i8 & 2147483647 | 0) > (-2 - i24 | 0)) {
        if (+Math_abs(+d1) >= 9007199254740992.0) {
         d1 = d1 * .5;
         i3 = i12 & (i7 | 0) == (i9 | 0) ? 0 : i3;
         i2 = i2 + 1 | 0;
        }
        if ((i2 + 50 | 0) <= (i25 | 0)) if (!(d4 != 0.0 & (i3 | 0) != 0)) break;
        HEAP32[(___errno_location() | 0) >> 2] = 34;
       } while (0);
       d1 = +_scalbnl(d1, i2);
      } while (0);
      break L4;
     }
    default:
     {
      if (HEAP32[i21 >> 2] | 0) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
      HEAP32[(___errno_location() | 0) >> 2] = 22;
      ___shlim(i23, 0);
      d1 = 0.0;
      break L4;
     }
    }
   }
  } while (0);
  if ((i19 | 0) == 23) {
   i3 = (HEAP32[i21 >> 2] | 0) == 0;
   if (!i3) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
   if ((i20 | 0) != 0 & i2 >>> 0 > 3) do {
    if (!i3) HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
    i2 = i2 + -1 | 0;
   } while (i2 >>> 0 > 3);
  }
  d1 = +Math_fround(Math_fround(i28 | 0) * Math_fround(inf));
 } while (0);
 STACKTOP = i30;
 return +d1;
}

function __ZN7mecanim9animation14DeltasFromClipERKNS0_18ClipMuscleConstantERKNS0_12ClipBindingsERKNS_14ValueArrayMaskERNS_10ValueArrayESB_SB_(i40, i39, i38, i41, i42, i43) {
 i40 = i40 | 0;
 i39 = i39 | 0;
 i38 = i38 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 i45 = i40 + 1720 | 0;
 i1 = HEAP32[i45 >> 2] | 0;
 i44 = (i1 | 0) != 0;
 i11 = HEAP32[i41 >> 2] | 0;
 L1 : do if (i11 | 0) {
  i4 = i38 + 4 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i5 = HEAP32[i39 >> 2] | 0;
  i6 = i40 + 1712 | 0;
  i7 = i6;
  i8 = i41 + 4 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i9 = i42 + 4 | 0;
  i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
  i10 = i43 + 4 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  if (!i44) {
   i1 = 0;
   while (1) {
    if (HEAP8[i4 + i1 >> 0] | 0) {
     i37 = HEAP16[i5 + (i1 << 1) >> 1] | 0;
     i2 = i37 << 16 >> 16;
     if (i37 << 16 >> 16 != -1) {
      i31 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
      i35 = HEAP32[i31 + (i2 << 3) >> 2] | 0;
      i33 = i2 + 1 | 0;
      i36 = HEAP32[i31 + (i33 << 3) >> 2] | 0;
      i34 = i2 + 2 | 0;
      i37 = HEAP32[i31 + (i34 << 3) >> 2] | 0;
      i32 = HEAP32[i31 + (i2 << 3) + 4 >> 2] | 0;
      i33 = HEAP32[i31 + (i33 << 3) + 4 >> 2] | 0;
      i34 = HEAP32[i31 + (i34 << 3) + 4 >> 2] | 0;
      HEAP32[i8 + (i1 * 12 | 0) >> 2] = i35;
      HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] = i36;
      HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] = i37;
      HEAP32[i9 + (i1 * 12 | 0) >> 2] = i32;
      HEAP32[i9 + (i1 * 12 | 0) + 4 >> 2] = i33;
      HEAP32[i9 + (i1 * 12 | 0) + 8 >> 2] = i34;
      HEAP32[i10 + (i1 * 12 | 0) >> 2] = i35;
      HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2] = i36;
      HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2] = i37;
     }
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i11 | 0)) break L1;
   }
  }
  i2 = i1 + i45 | 0;
  i1 = 0;
  do {
   if (HEAP8[i4 + i1 >> 0] | 0) {
    i37 = HEAP16[i5 + (i1 << 1) >> 1] | 0;
    i3 = i37 << 16 >> 16;
    if (i37 << 16 >> 16 != -1) {
     i29 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
     i36 = i3 + 1 | 0;
     i30 = HEAP32[i29 + (i36 << 3) >> 2] | 0;
     i37 = i3 + 2 | 0;
     i31 = HEAP32[i29 + (i37 << 3) >> 2] | 0;
     i32 = HEAP32[i29 + (i3 << 3) + 4 >> 2] | 0;
     i33 = HEAP32[i29 + (i36 << 3) + 4 >> 2] | 0;
     i34 = HEAP32[i29 + (i37 << 3) + 4 >> 2] | 0;
     i35 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     i36 = HEAP32[i2 + (i36 << 2) >> 2] | 0;
     i37 = HEAP32[i2 + (i37 << 2) >> 2] | 0;
     HEAP32[i8 + (i1 * 12 | 0) >> 2] = HEAP32[i29 + (i3 << 3) >> 2];
     HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] = i30;
     HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] = i31;
     HEAP32[i9 + (i1 * 12 | 0) >> 2] = i32;
     HEAP32[i9 + (i1 * 12 | 0) + 4 >> 2] = i33;
     HEAP32[i9 + (i1 * 12 | 0) + 8 >> 2] = i34;
     HEAP32[i10 + (i1 * 12 | 0) >> 2] = i35;
     HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2] = i36;
     HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2] = i37;
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 } while (0);
 i30 = HEAP32[i41 + 8 >> 2] | 0;
 if (i30 | 0) {
  i31 = i38 + 12 | 0;
  i31 = (HEAP32[i31 >> 2] | 0) + i31 | 0;
  i32 = HEAP32[i39 + 4 >> 2] | 0;
  i33 = HEAP32[i39 + 8 >> 2] | 0;
  i34 = HEAP32[i39 + 12 >> 2] | 0;
  i35 = i40 + 1712 | 0;
  i36 = i35;
  i37 = i45;
  i21 = i41 + 12 | 0;
  i27 = i21;
  i22 = i42 + 12 | 0;
  i28 = i22;
  i23 = i43 + 12 | 0;
  i29 = i23;
  i24 = (HEAP32[i21 >> 2] | 0) + i27 | 0;
  i25 = (HEAP32[i22 >> 2] | 0) + i28 | 0;
  i26 = (HEAP32[i23 >> 2] | 0) + i29 | 0;
  i27 = (HEAP32[i21 >> 2] | 0) + i27 | 0;
  i28 = (HEAP32[i22 >> 2] | 0) + i28 | 0;
  i29 = (HEAP32[i23 >> 2] | 0) + i29 | 0;
  i23 = 0;
  do {
   do if (HEAP8[i31 + i23 >> 0] | 0) {
    i1 = HEAP16[i32 + (i23 << 1) >> 1] | 0;
    i4 = i1 << 16 >> 16;
    i2 = HEAP16[i33 + (i23 << 1) >> 1] | 0;
    i3 = i2 << 16 >> 16;
    if ((i2 & i1) << 16 >> 16 != -1) {
     if (i1 << 16 >> 16 != -1) {
      i22 = (HEAP32[i35 >> 2] | 0) + i36 | 0;
      i6 = HEAP32[i22 + (i4 << 3) >> 2] | 0;
      i1 = i4 + 1 | 0;
      i7 = HEAP32[i22 + (i1 << 3) >> 2] | 0;
      i2 = i4 + 2 | 0;
      i8 = HEAP32[i22 + (i2 << 3) >> 2] | 0;
      i5 = i4 + 3 | 0;
      i9 = HEAP32[i22 + (i5 << 3) >> 2] | 0;
      i10 = HEAP32[i22 + (i4 << 3) + 4 >> 2] | 0;
      i11 = HEAP32[i22 + (i1 << 3) + 4 >> 2] | 0;
      i21 = HEAP32[i22 + (i2 << 3) + 4 >> 2] | 0;
      i22 = HEAP32[i22 + (i5 << 3) + 4 >> 2] | 0;
      if (i44) {
       i46 = (HEAP32[i45 >> 2] | 0) + i37 | 0;
       i4 = HEAP32[i46 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i46 + (i1 << 2) >> 2] | 0;
       i2 = HEAP32[i46 + (i2 << 2) >> 2] | 0;
       i1 = HEAP32[i46 + (i5 << 2) >> 2] | 0;
      } else {
       i4 = i6;
       i3 = i7;
       i2 = i8;
       i1 = i9;
      }
      HEAP32[i27 + (i23 << 4) >> 2] = i6;
      HEAP32[i27 + (i23 << 4) + 4 >> 2] = i7;
      HEAP32[i27 + (i23 << 4) + 8 >> 2] = i8;
      HEAP32[i27 + (i23 << 4) + 12 >> 2] = i9;
      HEAP32[i28 + (i23 << 4) >> 2] = i10;
      HEAP32[i28 + (i23 << 4) + 4 >> 2] = i11;
      HEAP32[i28 + (i23 << 4) + 8 >> 2] = i21;
      HEAP32[i28 + (i23 << 4) + 12 >> 2] = i22;
      HEAP32[i29 + (i23 << 4) >> 2] = i4;
      HEAP32[i29 + (i23 << 4) + 4 >> 2] = i3;
      HEAP32[i29 + (i23 << 4) + 8 >> 2] = i2;
      HEAP32[i29 + (i23 << 4) + 12 >> 2] = i1;
      break;
     }
     if (i2 << 16 >> 16 != -1) {
      i4 = HEAP16[i34 + (i23 << 1) >> 1] | 0;
      i46 = (HEAP32[i35 >> 2] | 0) + i36 | 0;
      f15 = Math_fround(HEAPF32[i46 + (i3 << 3) >> 2]);
      i1 = i3 + 1 | 0;
      f16 = Math_fround(HEAPF32[i46 + (i1 << 3) >> 2]);
      i2 = i3 + 2 | 0;
      f17 = Math_fround(HEAPF32[i46 + (i2 << 3) >> 2]);
      f18 = Math_fround(HEAPF32[i46 + (i3 << 3) + 4 >> 2]);
      f19 = Math_fround(HEAPF32[i46 + (i1 << 3) + 4 >> 2]);
      f20 = Math_fround(HEAPF32[i46 + (i2 << 3) + 4 >> 2]);
      if (i44) {
       i46 = (HEAP32[i45 >> 2] | 0) + i37 | 0;
       f13 = Math_fround(HEAPF32[i46 + (i3 << 2) >> 2]);
       f14 = Math_fround(HEAPF32[i46 + (i1 << 2) >> 2]);
       f12 = Math_fround(HEAPF32[i46 + (i2 << 2) >> 2]);
      } else {
       f13 = f15;
       f14 = f16;
       f12 = f17;
      }
      f52 = Math_fround(Math_fround(Math_fround(f15 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f49 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f50 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f53 = Math_fround(+_roundf(+f52));
      f54 = Math_fround(+_roundf(+f49));
      f53 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f52 - f53))));
      f54 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f49 - f54))));
      f48 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f50 - Math_fround(+_roundf(+f50))))));
      f15 = Math_fround(f53 * f53);
      f47 = Math_fround(f54 * f54);
      f55 = Math_fround(f48 * f48);
      f16 = Math_fround(f15 * f15);
      f51 = Math_fround(f47 * f47);
      f17 = Math_fround(f55 * f55);
      f15 = Math_fround(f53 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f15 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f15 * Math_fround(76.5686187)))))));
      f47 = Math_fround(f54 * Math_fround(Math_fround(Math_fround(f51 * f51) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f47 * Math_fround(41.3416595))) + Math_fround(f51 * Math_fround(Math_fround(81.6018218) - Math_fround(f47 * Math_fround(76.5686187)))))));
      f55 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f55 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f55 * Math_fround(76.5686187)))))));
      f52 = Math_fround(f52 + Math_fround(-.25));
      f49 = Math_fround(f49 + Math_fround(-.25));
      f50 = Math_fround(f50 + Math_fround(-.25));
      f17 = Math_fround(+_roundf(+f52));
      f48 = Math_fround(+_roundf(+f49));
      f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f52 - f17))));
      f48 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f49 - f48))));
      f50 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f50 - Math_fround(+_roundf(+f50))))));
      f49 = Math_fround(f17 * f17);
      f52 = Math_fround(f48 * f48);
      f51 = Math_fround(f50 * f50);
      f54 = Math_fround(f49 * f49);
      f16 = Math_fround(f52 * f52);
      f53 = Math_fround(f51 * f51);
      f49 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f54 * f54) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f49 * Math_fround(41.3416595))) + Math_fround(f54 * Math_fround(Math_fround(81.6018218) - Math_fround(f49 * Math_fround(76.5686187)))))));
      f52 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f52 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f52 * Math_fround(76.5686187)))))));
      f51 = Math_fround(f50 * Math_fround(Math_fround(Math_fround(f53 * f53) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f51 * Math_fround(41.3416595))) + Math_fround(f53 * Math_fround(Math_fround(81.6018218) - Math_fround(f51 * Math_fround(76.5686187)))))));
      f53 = Math_fround(f55 * f49);
      f49 = Math_fround(f49 * f51);
      f51 = Math_fround(f15 * f51);
      f55 = Math_fround(f15 * f55);
      f15 = Math_fround(f47 * f53);
      f50 = Math_fround(f47 * f49);
      f16 = Math_fround(f47 * f51);
      f47 = Math_fround(f47 * f55);
      i46 = i4 << 1;
      i7 = gb + 1466580 + (i46 << 4) | 0;
      f15 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f15);
      i8 = gb + 1466580 + (i46 << 4) + 4 | 0;
      f50 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f50);
      i9 = gb + 1466580 + (i46 << 4) + 8 | 0;
      f16 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f16);
      i10 = gb + 1466580 + (i46 << 4) + 12 | 0;
      f47 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f47);
      i46 = i46 | 1;
      i11 = gb + 1466580 + (i46 << 4) | 0;
      f48 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f52);
      i21 = gb + 1466580 + (i46 << 4) + 4 | 0;
      f54 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f52);
      i22 = gb + 1466580 + (i46 << 4) + 8 | 0;
      f17 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f52);
      i46 = gb + 1466580 + (i46 << 4) + 12 | 0;
      f50 = Math_fround(Math_fround(f55 * f54) + f50);
      f16 = Math_fround(Math_fround(f53 * f17) + f16);
      f49 = Math_fround(f47 + Math_fround(Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f52) * f49));
      HEAPF32[i24 + (i23 << 4) >> 2] = Math_fround(f15 + Math_fround(f48 * f51));
      HEAPF32[i24 + (i23 << 4) + 4 >> 2] = f50;
      HEAPF32[i24 + (i23 << 4) + 8 >> 2] = f16;
      HEAPF32[i24 + (i23 << 4) + 12 >> 2] = f49;
      f49 = Math_fround(Math_fround(Math_fround(f18 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f16 = Math_fround(Math_fround(Math_fround(f19 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f18 = Math_fround(Math_fround(Math_fround(f20 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f50 = Math_fround(+_roundf(+f49));
      f51 = Math_fround(+_roundf(+f16));
      f50 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f49 - f50))));
      f51 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - f51))));
      f48 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f18 - Math_fround(+_roundf(+f18))))));
      f15 = Math_fround(f50 * f50);
      f19 = Math_fround(f51 * f51);
      f52 = Math_fround(f48 * f48);
      f20 = Math_fround(f15 * f15);
      f47 = Math_fround(f19 * f19);
      f17 = Math_fround(f52 * f52);
      f15 = Math_fround(f50 * Math_fround(Math_fround(Math_fround(f20 * f20) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f15 * Math_fround(41.3416595))) + Math_fround(f20 * Math_fround(Math_fround(81.6018218) - Math_fround(f15 * Math_fround(76.5686187)))))));
      f19 = Math_fround(f51 * Math_fround(Math_fround(Math_fround(f47 * f47) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f19 * Math_fround(41.3416595))) + Math_fround(f47 * Math_fround(Math_fround(81.6018218) - Math_fround(f19 * Math_fround(76.5686187)))))));
      f52 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f52 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f52 * Math_fround(76.5686187)))))));
      f49 = Math_fround(f49 + Math_fround(-.25));
      f16 = Math_fround(f16 + Math_fround(-.25));
      f18 = Math_fround(f18 + Math_fround(-.25));
      f17 = Math_fround(+_roundf(+f49));
      f48 = Math_fround(+_roundf(+f16));
      f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f49 - f17))));
      f48 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - f48))));
      f18 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f18 - Math_fround(+_roundf(+f18))))));
      f16 = Math_fround(f17 * f17);
      f49 = Math_fround(f48 * f48);
      f47 = Math_fround(f18 * f18);
      f51 = Math_fround(f16 * f16);
      f20 = Math_fround(f49 * f49);
      f50 = Math_fround(f47 * f47);
      f16 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f51 * f51) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f16 * Math_fround(41.3416595))) + Math_fround(f51 * Math_fround(Math_fround(81.6018218) - Math_fround(f16 * Math_fround(76.5686187)))))));
      f49 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f20 * f20) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f49 * Math_fround(41.3416595))) + Math_fround(f20 * Math_fround(Math_fround(81.6018218) - Math_fround(f49 * Math_fround(76.5686187)))))));
      f47 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f50 * f50) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f47 * Math_fround(41.3416595))) + Math_fround(f50 * Math_fround(Math_fround(81.6018218) - Math_fround(f47 * Math_fround(76.5686187)))))));
      f50 = Math_fround(f52 * f16);
      f16 = Math_fround(f16 * f47);
      f47 = Math_fround(f15 * f47);
      f52 = Math_fround(f15 * f52);
      f15 = Math_fround(f19 * f50);
      f18 = Math_fround(f19 * f16);
      f20 = Math_fround(f19 * f47);
      f19 = Math_fround(f19 * f52);
      f15 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f15);
      f18 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f18);
      f20 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f20);
      f19 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f19);
      f48 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f49);
      f51 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f49);
      f17 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f49);
      f18 = Math_fround(Math_fround(f52 * f51) + f18);
      f20 = Math_fround(Math_fround(f50 * f17) + f20);
      f16 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f49) * f16));
      HEAPF32[i25 + (i23 << 4) >> 2] = Math_fround(f15 + Math_fround(f48 * f47));
      HEAPF32[i25 + (i23 << 4) + 4 >> 2] = f18;
      HEAPF32[i25 + (i23 << 4) + 8 >> 2] = f20;
      HEAPF32[i25 + (i23 << 4) + 12 >> 2] = f16;
      f16 = Math_fround(Math_fround(Math_fround(f13 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f20 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f18 = Math_fround(Math_fround(Math_fround(f12 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
      f47 = Math_fround(+_roundf(+f16));
      f48 = Math_fround(+_roundf(+f20));
      f47 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - f47))));
      f48 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f20 - f48))));
      f12 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f18 - Math_fround(+_roundf(+f18))))));
      f15 = Math_fround(f47 * f47);
      f13 = Math_fround(f48 * f48);
      f49 = Math_fround(f12 * f12);
      f19 = Math_fround(f15 * f15);
      f17 = Math_fround(f13 * f13);
      f14 = Math_fround(f49 * f49);
      f15 = Math_fround(f47 * Math_fround(Math_fround(Math_fround(f19 * f19) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f15 * Math_fround(41.3416595))) + Math_fround(f19 * Math_fround(Math_fround(81.6018218) - Math_fround(f15 * Math_fround(76.5686187)))))));
      f13 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f13 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f13 * Math_fround(76.5686187)))))));
      f49 = Math_fround(f12 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f49 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f49 * Math_fround(76.5686187)))))));
      f14 = Math_fround(f16 + Math_fround(-.25));
      f20 = Math_fround(f20 + Math_fround(-.25));
      f18 = Math_fround(f18 + Math_fround(-.25));
      f12 = Math_fround(+_roundf(+f14));
      f16 = Math_fround(+_roundf(+f20));
      f12 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f14 - f12))));
      f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f20 - f16))));
      f18 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f18 - Math_fround(+_roundf(+f18))))));
      f20 = Math_fround(f12 * f12);
      f14 = Math_fround(f16 * f16);
      f17 = Math_fround(f18 * f18);
      f48 = Math_fround(f20 * f20);
      f19 = Math_fround(f14 * f14);
      f47 = Math_fround(f17 * f17);
      f20 = Math_fround(f12 * Math_fround(Math_fround(Math_fround(f48 * f48) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f20 * Math_fround(41.3416595))) + Math_fround(f48 * Math_fround(Math_fround(81.6018218) - Math_fround(f20 * Math_fround(76.5686187)))))));
      f14 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f19 * f19) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f14 * Math_fround(41.3416595))) + Math_fround(f19 * Math_fround(Math_fround(81.6018218) - Math_fround(f14 * Math_fround(76.5686187)))))));
      f17 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f47 * f47) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f17 * Math_fround(41.3416595))) + Math_fround(f47 * Math_fround(Math_fround(81.6018218) - Math_fround(f17 * Math_fround(76.5686187)))))));
      f47 = Math_fround(f49 * f20);
      f20 = Math_fround(f20 * f17);
      f17 = Math_fround(f15 * f17);
      f49 = Math_fround(f15 * f49);
      f15 = Math_fround(f13 * f47);
      f18 = Math_fround(f13 * f20);
      f19 = Math_fround(f13 * f17);
      f13 = Math_fround(f13 * f49);
      f15 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f15);
      f18 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f18);
      f19 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f19);
      f13 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f13);
      f16 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f14);
      f48 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f14);
      f12 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f14);
      f18 = Math_fround(Math_fround(f49 * f48) + f18);
      f19 = Math_fround(Math_fround(f47 * f12) + f19);
      f20 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f14) * f20));
      HEAPF32[i26 + (i23 << 4) >> 2] = Math_fround(f15 + Math_fround(f16 * f17));
      HEAPF32[i26 + (i23 << 4) + 4 >> 2] = f18;
      HEAPF32[i26 + (i23 << 4) + 8 >> 2] = f19;
      HEAPF32[i26 + (i23 << 4) + 12 >> 2] = f20;
     }
    }
   } while (0);
   i23 = i23 + 1 | 0;
  } while ((i23 | 0) != (i30 | 0));
 }
 i4 = HEAP32[i41 + 16 >> 2] | 0;
 if (i4 | 0) {
  i5 = i38 + 20 | 0;
  i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
  i6 = HEAP32[i39 + 16 >> 2] | 0;
  i7 = i40 + 1712 | 0;
  i8 = i7;
  i2 = i45;
  i9 = i41 + 20 | 0;
  i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
  i10 = i42 + 20 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i11 = i43 + 20 | 0;
  i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
  if (i44) {
   i1 = 0;
   do {
    if (HEAP8[i5 + i1 >> 0] | 0) {
     i46 = HEAP16[i6 + (i1 << 1) >> 1] | 0;
     i3 = i46 << 16 >> 16;
     if (i46 << 16 >> 16 != -1) {
      i30 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
      i37 = i3 + 1 | 0;
      i31 = HEAP32[i30 + (i37 << 3) >> 2] | 0;
      i46 = i3 + 2 | 0;
      i32 = HEAP32[i30 + (i46 << 3) >> 2] | 0;
      i33 = HEAP32[i30 + (i3 << 3) + 4 >> 2] | 0;
      i34 = HEAP32[i30 + (i37 << 3) + 4 >> 2] | 0;
      i35 = HEAP32[i30 + (i46 << 3) + 4 >> 2] | 0;
      i29 = (HEAP32[i45 >> 2] | 0) + i2 | 0;
      i36 = HEAP32[i29 + (i3 << 2) >> 2] | 0;
      i37 = HEAP32[i29 + (i37 << 2) >> 2] | 0;
      i46 = HEAP32[i29 + (i46 << 2) >> 2] | 0;
      HEAP32[i9 + (i1 * 12 | 0) >> 2] = HEAP32[i30 + (i3 << 3) >> 2];
      HEAP32[i9 + (i1 * 12 | 0) + 4 >> 2] = i31;
      HEAP32[i9 + (i1 * 12 | 0) + 8 >> 2] = i32;
      HEAP32[i10 + (i1 * 12 | 0) >> 2] = i33;
      HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2] = i34;
      HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2] = i35;
      HEAP32[i11 + (i1 * 12 | 0) >> 2] = i36;
      HEAP32[i11 + (i1 * 12 | 0) + 4 >> 2] = i37;
      HEAP32[i11 + (i1 * 12 | 0) + 8 >> 2] = i46;
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  } else {
   i1 = 0;
   do {
    if (HEAP8[i5 + i1 >> 0] | 0) {
     i46 = HEAP16[i6 + (i1 << 1) >> 1] | 0;
     i2 = i46 << 16 >> 16;
     if (i46 << 16 >> 16 != -1) {
      i32 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
      i36 = HEAP32[i32 + (i2 << 3) >> 2] | 0;
      i34 = i2 + 1 | 0;
      i37 = HEAP32[i32 + (i34 << 3) >> 2] | 0;
      i35 = i2 + 2 | 0;
      i46 = HEAP32[i32 + (i35 << 3) >> 2] | 0;
      i33 = HEAP32[i32 + (i2 << 3) + 4 >> 2] | 0;
      i34 = HEAP32[i32 + (i34 << 3) + 4 >> 2] | 0;
      i35 = HEAP32[i32 + (i35 << 3) + 4 >> 2] | 0;
      HEAP32[i9 + (i1 * 12 | 0) >> 2] = i36;
      HEAP32[i9 + (i1 * 12 | 0) + 4 >> 2] = i37;
      HEAP32[i9 + (i1 * 12 | 0) + 8 >> 2] = i46;
      HEAP32[i10 + (i1 * 12 | 0) >> 2] = i33;
      HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2] = i34;
      HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2] = i35;
      HEAP32[i11 + (i1 * 12 | 0) >> 2] = i36;
      HEAP32[i11 + (i1 * 12 | 0) + 4 >> 2] = i37;
      HEAP32[i11 + (i1 * 12 | 0) + 8 >> 2] = i46;
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 i11 = HEAP32[i41 + 24 >> 2] | 0;
 if (!i11) return;
 i10 = i38 + 28 | 0;
 i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
 i9 = HEAP32[i39 + 20 >> 2] | 0;
 i7 = i40 + 1712 | 0;
 i8 = i7;
 i6 = i41 + 28 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i5 = i42 + 28 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i3 = i45;
 i4 = i43 + 28 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 if (i44) {
  i1 = 0;
  do {
   if (HEAP8[i10 + i1 >> 0] | 0) {
    i46 = HEAP16[i9 + (i1 << 1) >> 1] | 0;
    i2 = i46 << 16 >> 16;
    if (i46 << 16 >> 16 != -1) {
     i46 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
     HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i46 + (i2 << 3) >> 2];
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i46 + (i2 << 3) + 4 >> 2];
     HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i45 >> 2] | 0) + i3 + (i2 << 2) >> 2];
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  return;
 } else {
  i1 = 0;
  do {
   if (HEAP8[i10 + i1 >> 0] | 0) {
    i46 = HEAP16[i9 + (i1 << 1) >> 1] | 0;
    i2 = i46 << 16 >> 16;
    if (i46 << 16 >> 16 != -1) {
     i45 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
     i46 = i45 + (i2 << 3) | 0;
     HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i46 >> 2];
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i45 + (i2 << 3) + 4 >> 2];
     HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i46 >> 2];
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  return;
 }
}

function __Z17FastCompressImageiiPKhPhbb(i28, i29, i39, i1, i60, i71) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i60 = i60 | 0;
 i71 = i71 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, d99 = 0.0;
 i82 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i82 + 88 | 0;
 i79 = i82 + 76 | 0;
 i80 = i82 + 64 | 0;
 i81 = i82 + 136 | 0;
 i30 = i82 + 120 | 0;
 i31 = i82;
 i32 = i60 ? 16 : 8;
 if ((i29 | 0) <= 0) {
  STACKTOP = i82;
  return;
 }
 i33 = (i28 | 0) > 0;
 i34 = i28 << 2;
 i35 = i31 + 3 | 0;
 i36 = i31 + 4 | 0;
 i37 = i31 + 8 | 0;
 i38 = i31 + 12 | 0;
 i40 = i31 + 16 | 0;
 i41 = i31 + 20 | 0;
 i42 = i31 + 24 | 0;
 i43 = i31 + 28 | 0;
 i44 = i31 + 32 | 0;
 i45 = i31 + 36 | 0;
 i46 = i31 + 40 | 0;
 i47 = i31 + 44 | 0;
 i48 = i31 + 48 | 0;
 i49 = i31 + 52 | 0;
 i50 = i31 + 56 | 0;
 i51 = i31 + 60 | 0;
 i52 = i31 + 1 | 0;
 i53 = i31 + 2 | 0;
 i54 = i78 + 16 | 0;
 i55 = i71 ? i81 : i31;
 i56 = i78 + 4 | 0;
 i57 = i78 + 8 | 0;
 i58 = i80 + 4 | 0;
 i59 = i79 + 4 | 0;
 i61 = i80 + 8 | 0;
 i62 = i79 + 8 | 0;
 i63 = i30 + 1 | 0;
 i64 = i30 + 2 | 0;
 i65 = i30 + 3 | 0;
 i66 = i30 + 4 | 0;
 i67 = i30 + 5 | 0;
 i68 = i30 + 6 | 0;
 i69 = i30 + 7 | 0;
 i70 = i30 + 8 | 0;
 i72 = i30 + 9 | 0;
 i73 = i30 + 10 | 0;
 i74 = i30 + 12 | 0;
 i75 = i30 + 13 | 0;
 i76 = i30 + 14 | 0;
 i77 = i71 & 1;
 i27 = 0;
 do {
  if (i33) {
   i20 = i39 + (Math_imul(i34, i27) | 0) | 0;
   i22 = i27 | 1;
   i21 = (i22 | 0) < (i29 | 0);
   i22 = i39 + (Math_imul(i34, i22) | 0) | 0;
   i24 = i27 | 2;
   i23 = (i24 | 0) < (i29 | 0);
   i24 = i39 + (Math_imul(i34, i24) | 0) | 0;
   i26 = i27 | 3;
   i25 = (i26 | 0) < (i29 | 0);
   i26 = i39 + (Math_imul(i34, i26) | 0) | 0;
   i19 = 0;
   do {
    i4 = (i19 | 3 | 0) < (i28 | 0) ? 4 : i28 - i19 | 0;
    i2 = i19 << 2;
    i3 = i4 << 2;
    _memcpy(i31 | 0, i20 + i2 | 0, i3 | 0) | 0;
    if (i21) {
     _memcpy(i40 | 0, i22 + i2 | 0, i3 | 0) | 0;
     if (i23) {
      _memcpy(i44 | 0, i24 + i2 | 0, i3 | 0) | 0;
      if (i25) {
       _memcpy(i48 | 0, i26 + i2 | 0, i3 | 0) | 0;
       i8 = 4;
      } else i8 = 3;
     } else i8 = 2;
    } else i8 = 1;
    L15 : do if ((i4 | 0) < 4) switch (i4 | 0) {
    case 1:
    case 0:
     {
      i2 = 0;
      do {
       i18 = i31 + (i2 << 4) | 0;
       HEAP32[i18 + 4 >> 2] = HEAP32[i18 >> 2];
       i16 = i18;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i18 = i18 + 8 | 0;
       HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i18 + 4 >> 2] = i17;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i8 | 0));
      break;
     }
    case 2:
     {
      i2 = 0;
      do {
       i18 = i31 + (i2 << 4) | 0;
       i16 = i18;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i18 = i18 + 8 | 0;
       HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i18 + 4 >> 2] = i17;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i8 | 0));
      break;
     }
    case 3:
     {
      i2 = 0;
      do {
       i18 = i31 + (i2 << 4) | 0;
       HEAP32[i18 + 12 >> 2] = HEAP32[i18 + 4 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i8 | 0));
      break;
     }
    default:
     break L15;
    } while (0);
    if (i8 >>> 0 < 4) {
     i4 = 4 - i8 | 0;
     i3 = 0;
     i2 = i8;
     while (1) {
      i18 = i31 + (i2 << 4) | 0;
      i17 = i31 + (i3 << 4) | 0;
      HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
      HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + 1 | 0;
     }
    }
    if (!(HEAP32[gb + 1157840 >> 2] | 0)) {
     i2 = 0;
     do {
      HEAP8[gb + 1544241 + i2 >> 0] = i2 << 3 | i2 >>> 2;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 32);
     i2 = 0;
     do {
      HEAP8[gb + 1544273 + i2 >> 0] = i2 << 2 | i2 >>> 4;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 64);
     i2 = 0;
     do {
      i18 = i2 + -8 | 0;
      i18 = (i2 | 0) < 8 ? 0 : (i18 | 0) > 255 ? 255 : i18;
      i17 = (i18 * 31 | 0) + 128 | 0;
      HEAP8[gb + 1544337 + i2 >> 0] = HEAP8[((i17 >> 8) + i17 >> 8) + (gb + 1544241) >> 0] | 0;
      i18 = (i18 * 63 | 0) + 128 | 0;
      HEAP8[gb + 1544609 + i2 >> 0] = HEAP8[((i18 >> 8) + i18 >> 8) + (gb + 1544273) >> 0] | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 272);
     i10 = 0;
     do {
      i12 = i10 << 1;
      i11 = (i12 | 1) + (gb + 1544881) | 0;
      i12 = gb + 1544881 + i12 | 0;
      i4 = 0;
      i2 = 256;
      do {
       i13 = i4 & 255;
       i14 = HEAPU8[gb + 1544241 + i4 >> 0] | 0;
       i8 = 0;
       do {
        i3 = HEAPU8[gb + 1544241 + i8 >> 0] | 0;
        i18 = ((i14 - i3 | 0) * 85 | 0) + 128 | 0;
        i3 = ((i18 >> 8) + i18 >> 8) + (i3 - i10) | 0;
        i3 = (i3 | 0) > -1 ? i3 : 0 - i3 | 0;
        if ((i3 | 0) < (i2 | 0)) {
         HEAP8[i12 >> 0] = i8;
         HEAP8[i11 >> 0] = i13;
         i2 = i3;
        }
        i8 = i8 + 1 | 0;
       } while ((i8 | 0) != 32);
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != 32);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != 256);
     i10 = 0;
     do {
      i12 = i10 << 1;
      i11 = (i12 | 1) + (gb + 1545393) | 0;
      i12 = gb + 1545393 + i12 | 0;
      i4 = 0;
      i2 = 256;
      do {
       i13 = i4 & 255;
       i14 = HEAPU8[gb + 1544273 + i4 >> 0] | 0;
       i8 = 0;
       do {
        i3 = HEAPU8[gb + 1544273 + i8 >> 0] | 0;
        i18 = ((i14 - i3 | 0) * 85 | 0) + 128 | 0;
        i3 = ((i18 >> 8) + i18 >> 8) + (i3 - i10) | 0;
        i3 = (i3 | 0) > -1 ? i3 : 0 - i3 | 0;
        if ((i3 | 0) < (i2 | 0)) {
         HEAP8[i12 >> 0] = i8;
         HEAP8[i11 >> 0] = i13;
         i2 = i3;
        }
        i8 = i8 + 1 | 0;
       } while ((i8 | 0) != 64);
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != 64);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != 256);
     HEAP32[gb + 1157840 >> 2] = 1;
    }
    if (i60) {
     i15 = HEAPU8[i35 >> 0] | 0;
     i2 = 1;
     i3 = i15;
     do {
      i18 = HEAPU8[i31 + (i2 << 2 | 3) >> 0] | 0;
      i17 = (i18 | 0) < (i15 | 0);
      i15 = i17 ? i18 : i15;
      i3 = i17 ? i3 : (i18 | 0) > (i3 | 0) ? i18 : i3;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 16);
     HEAP8[i1 >> 0] = i3;
     HEAP8[i1 + 1 >> 0] = i15;
     i11 = i3 - i15 | 0;
     i12 = i11 >> 1;
     i13 = i11 << 2;
     i14 = i11 << 1;
     i8 = i1 + 2 | 0;
     i3 = 0;
     i2 = 0;
     i10 = 0;
     do {
      i18 = (((HEAPU8[i31 + (i10 << 2 | 3) >> 0] | 0) - i15 | 0) * 7 | 0) + i12 | 0;
      i17 = i13 - i18 >> 31;
      i18 = i18 - (i17 & i13) | 0;
      i4 = i14 - i18 >> 31;
      i4 = 0 - (i4 & 2 | i17 & 4 | (i11 - i18 + (i4 & i14) | 0) >>> 31) & 7;
      i2 = (i4 >>> 0 < 2 ^ i4) << i3 | i2;
      i4 = i3 + 3 | 0;
      if ((i4 | 0) > 7) {
       HEAP8[i8 >> 0] = i2;
       i8 = i8 + 1 | 0;
       i3 = i3 + -5 | 0;
       i2 = i2 >> 8;
      } else i3 = i4;
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != 16);
     i18 = i1 + 8 | 0;
    } else i18 = i1;
    i2 = HEAP32[i31 >> 2] | 0;
    if (((HEAP32[i36 >> 2] | 0) == (i2 | 0) ? (HEAP32[i37 >> 2] | 0) == (i2 | 0) : 0) & (HEAP32[i38 >> 2] | 0) == (i2 | 0) & (HEAP32[i40 >> 2] | 0) == (i2 | 0) & (HEAP32[i41 >> 2] | 0) == (i2 | 0) & (HEAP32[i42 >> 2] | 0) == (i2 | 0) & (HEAP32[i43 >> 2] | 0) == (i2 | 0) & (HEAP32[i44 >> 2] | 0) == (i2 | 0) & (HEAP32[i45 >> 2] | 0) == (i2 | 0) & (HEAP32[i46 >> 2] | 0) == (i2 | 0) & (HEAP32[i47 >> 2] | 0) == (i2 | 0) & (HEAP32[i48 >> 2] | 0) == (i2 | 0) & (HEAP32[i49 >> 2] | 0) == (i2 | 0) & (HEAP32[i50 >> 2] | 0) == (i2 | 0) & (HEAP32[i51 >> 2] | 0) == (i2 | 0)) {
     i2 = i2 & 255;
     i17 = HEAPU8[i52 >> 0] | 0;
     i3 = HEAPU8[i53 >> 0] | 0;
     i4 = ((HEAPU8[gb + 1545393 + (i17 << 1) + 1 >> 0] | 0) << 5 | (HEAPU8[gb + 1544881 + (i2 << 1) + 1 >> 0] | 0) << 11 | (HEAPU8[gb + 1544881 + (i3 << 1) + 1 >> 0] | 0)) & 65535;
     i3 = ((HEAPU8[gb + 1545393 + (i17 << 1) >> 0] | 0) << 5 | (HEAPU8[gb + 1544881 + (i2 << 1) >> 0] | 0) << 11 | (HEAPU8[gb + 1544881 + (i3 << 1) >> 0] | 0)) & 65535;
     i2 = -1431655766;
    } else {
     if (i71) {
      i11 = 0;
      i2 = i54;
      i3 = i78;
      while (1) {
       i13 = (i11 | 0) == 1 ? gb + 1544609 + 8 | 0 : gb + 1544337 + 8 | 0;
       HEAP32[i78 >> 2] = 0;
       HEAP32[i78 + 4 >> 2] = 0;
       HEAP32[i78 + 8 >> 2] = 0;
       HEAP32[i78 + 12 >> 2] = 0;
       HEAP32[i78 + 16 >> 2] = 0;
       HEAP32[i78 + 20 >> 2] = 0;
       HEAP32[i78 + 24 >> 2] = 0;
       HEAP32[i78 + 28 >> 2] = 0;
       i4 = i81 + i11 | 0;
       i8 = i31 + i11 | 0;
       i10 = 0;
       i12 = i2;
       i2 = i3;
       while (1) {
        i16 = HEAPU8[i8 >> 0] | 0;
        i15 = i12 + 4 | 0;
        i3 = HEAP8[i13 + ((((HEAP32[i12 >> 2] | 0) * 5 | 0) + ((HEAP32[i15 >> 2] | 0) * 3 | 0) >> 4) + i16) >> 0] | 0;
        HEAP8[i4 >> 0] = i3;
        i3 = i16 - (i3 & 255) | 0;
        HEAP32[i2 >> 2] = i3;
        i16 = HEAPU8[i8 + 4 >> 0] | 0;
        i17 = i12 + 8 | 0;
        i3 = HEAP8[i13 + ((((HEAP32[i17 >> 2] | 0) * 3 | 0) + (i3 * 7 | 0) + ((HEAP32[i15 >> 2] | 0) * 5 | 0) + (HEAP32[i12 >> 2] | 0) >> 4) + i16) >> 0] | 0;
        HEAP8[i4 + 4 >> 0] = i3;
        i3 = i16 - (i3 & 255) | 0;
        HEAP32[i2 + 4 >> 2] = i3;
        i16 = HEAPU8[i8 + 8 >> 0] | 0;
        i14 = i12 + 12 | 0;
        i15 = HEAP8[i13 + ((((HEAP32[i14 >> 2] | 0) * 3 | 0) + (i3 * 7 | 0) + ((HEAP32[i17 >> 2] | 0) * 5 | 0) + (HEAP32[i15 >> 2] | 0) >> 4) + i16) >> 0] | 0;
        HEAP8[i4 + 8 >> 0] = i15;
        i15 = i16 - (i15 & 255) | 0;
        HEAP32[i2 + 8 >> 2] = i15;
        i16 = HEAPU8[i8 + 12 >> 0] | 0;
        i17 = HEAP8[i13 + ((((HEAP32[i14 >> 2] | 0) * 5 | 0) + (i15 * 7 | 0) + (HEAP32[i17 >> 2] | 0) >> 4) + i16) >> 0] | 0;
        HEAP8[i4 + 12 >> 0] = i17;
        HEAP32[i2 + 12 >> 2] = i16 - (i17 & 255);
        i10 = i10 + 1 | 0;
        if ((i10 | 0) == 4) break; else {
         i17 = i2;
         i4 = i4 + 16 | 0;
         i8 = i8 + 16 | 0;
         i2 = i12;
         i12 = i17;
        }
       }
       i11 = i11 + 1 | 0;
       if ((i11 | 0) == 3) break; else i3 = i12;
      }
     }
     i2 = 0;
     do {
      i13 = i55 + i2 | 0;
      i14 = HEAP8[i13 >> 0] | 0;
      i91 = i14 & 255;
      i88 = HEAP8[i13 + 4 >> 0] | 0;
      i90 = i88 & 255;
      i17 = (i88 & 255) < (i14 & 255);
      i14 = i17 ? i88 : i14;
      i17 = i17 ? i91 : i90 >>> 0 > i91 >>> 0 ? i90 : i91;
      i88 = HEAP8[i13 + 8 >> 0] | 0;
      i89 = i88 & 255;
      i87 = (i88 & 255) < (i14 & 255);
      i14 = i87 ? i88 : i14;
      i17 = i87 ? i17 : (i89 | 0) > (i17 | 0) ? i89 : i17;
      i87 = HEAP8[i13 + 12 >> 0] | 0;
      i88 = i87 & 255;
      i86 = (i87 & 255) < (i14 & 255);
      i14 = i86 ? i87 : i14;
      i17 = i86 ? i17 : (i88 | 0) > (i17 | 0) ? i88 : i17;
      i86 = HEAP8[i13 + 16 >> 0] | 0;
      i87 = i86 & 255;
      i85 = (i86 & 255) < (i14 & 255);
      i14 = i85 ? i86 : i14;
      i17 = i85 ? i17 : (i87 | 0) > (i17 | 0) ? i87 : i17;
      i85 = HEAP8[i13 + 20 >> 0] | 0;
      i86 = i85 & 255;
      i84 = (i85 & 255) < (i14 & 255);
      i14 = i84 ? i85 : i14;
      i17 = i84 ? i17 : (i86 | 0) > (i17 | 0) ? i86 : i17;
      i84 = HEAP8[i13 + 24 >> 0] | 0;
      i85 = i84 & 255;
      i83 = (i84 & 255) < (i14 & 255);
      i14 = i83 ? i84 : i14;
      i17 = i83 ? i17 : (i85 | 0) > (i17 | 0) ? i85 : i17;
      i83 = HEAP8[i13 + 28 >> 0] | 0;
      i84 = i83 & 255;
      i3 = (i83 & 255) < (i14 & 255);
      i14 = i3 ? i83 : i14;
      i17 = i3 ? i17 : (i84 | 0) > (i17 | 0) ? i84 : i17;
      i3 = HEAP8[i13 + 32 >> 0] | 0;
      i83 = i3 & 255;
      i4 = (i3 & 255) < (i14 & 255);
      i14 = i4 ? i3 : i14;
      i17 = i4 ? i17 : (i83 | 0) > (i17 | 0) ? i83 : i17;
      i4 = HEAP8[i13 + 36 >> 0] | 0;
      i3 = i4 & 255;
      i8 = (i4 & 255) < (i14 & 255);
      i14 = i8 ? i4 : i14;
      i17 = i8 ? i17 : (i3 | 0) > (i17 | 0) ? i3 : i17;
      i8 = HEAP8[i13 + 40 >> 0] | 0;
      i4 = i8 & 255;
      i10 = (i8 & 255) < (i14 & 255);
      i14 = i10 ? i8 : i14;
      i17 = i10 ? i17 : (i4 | 0) > (i17 | 0) ? i4 : i17;
      i10 = HEAP8[i13 + 44 >> 0] | 0;
      i8 = i10 & 255;
      i11 = (i10 & 255) < (i14 & 255);
      i14 = i11 ? i10 : i14;
      i17 = i11 ? i17 : (i8 | 0) > (i17 | 0) ? i8 : i17;
      i11 = HEAP8[i13 + 48 >> 0] | 0;
      i10 = i11 & 255;
      i12 = (i11 & 255) < (i14 & 255);
      i14 = i12 ? i11 : i14;
      i17 = i12 ? i17 : (i10 | 0) > (i17 | 0) ? i10 : i17;
      i12 = HEAP8[i13 + 52 >> 0] | 0;
      i11 = i12 & 255;
      i15 = (i12 & 255) < (i14 & 255);
      i14 = i15 ? i12 : i14;
      i17 = i15 ? i17 : (i11 | 0) > (i17 | 0) ? i11 : i17;
      i15 = HEAP8[i13 + 56 >> 0] | 0;
      i12 = i15 & 255;
      i16 = (i15 & 255) < (i14 & 255);
      i14 = i16 ? i15 : i14;
      i17 = i16 ? i17 : (i12 | 0) > (i17 | 0) ? i12 : i17;
      i13 = HEAP8[i13 + 60 >> 0] | 0;
      i16 = i13 & 255;
      i15 = (i13 & 255) < (i14 & 255);
      HEAP32[i78 + (i2 << 2) >> 2] = i91 + 8 + i90 + i89 + i88 + i87 + i86 + i85 + i84 + i83 + i3 + i4 + i8 + i10 + i11 + i12 + i16 >> 4;
      HEAP32[i79 + (i2 << 2) >> 2] = (i15 ? i13 : i14) & 255;
      HEAP32[i80 + (i2 << 2) >> 2] = i15 ? i17 : (i16 | 0) > (i17 | 0) ? i16 : i17;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 3);
     i3 = HEAP32[i78 >> 2] | 0;
     i4 = HEAP32[i56 >> 2] | 0;
     i8 = HEAP32[i57 >> 2] | 0;
     i2 = 0;
     i10 = 0;
     i11 = 0;
     i12 = 0;
     i13 = 0;
     i14 = 0;
     i15 = 0;
     do {
      i91 = i2 << 2;
      i89 = (HEAPU8[i55 + i91 >> 0] | 0) - i3 | 0;
      i90 = (HEAPU8[i55 + (i91 | 1) >> 0] | 0) - i4 | 0;
      i91 = (HEAPU8[i55 + (i91 | 2) >> 0] | 0) - i8 | 0;
      i10 = (Math_imul(i89, i89) | 0) + i10 | 0;
      i11 = (Math_imul(i90, i89) | 0) + i11 | 0;
      i12 = (Math_imul(i91, i89) | 0) + i12 | 0;
      i13 = (Math_imul(i90, i90) | 0) + i13 | 0;
      i14 = (Math_imul(i91, i90) | 0) + i14 | 0;
      i15 = (Math_imul(i91, i91) | 0) + i15 | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 16);
     f6 = Math_fround(Math_fround(i10 | 0) / Math_fround(255.0));
     f96 = Math_fround(Math_fround(i11 | 0) / Math_fround(255.0));
     f93 = Math_fround(Math_fround(i12 | 0) / Math_fround(255.0));
     f7 = Math_fround(Math_fround(i13 | 0) / Math_fround(255.0));
     f5 = Math_fround(Math_fround(i14 | 0) / Math_fround(255.0));
     f95 = Math_fround(Math_fround(i15 | 0) / Math_fround(255.0));
     f94 = Math_fround((HEAP32[i80 >> 2] | 0) - (HEAP32[i79 >> 2] | 0) | 0);
     f97 = Math_fround((HEAP32[i58 >> 2] | 0) - (HEAP32[i59 >> 2] | 0) | 0);
     f9 = Math_fround((HEAP32[i61 >> 2] | 0) - (HEAP32[i62 >> 2] | 0) | 0);
     f92 = Math_fround(Math_fround(Math_fround(f6 * f94) + Math_fround(f96 * f97)) + Math_fround(f93 * f9));
     f98 = Math_fround(Math_fround(Math_fround(f96 * f94) + Math_fround(f7 * f97)) + Math_fround(f5 * f9));
     f9 = Math_fround(Math_fround(Math_fround(f93 * f94) + Math_fround(f5 * f97)) + Math_fround(f95 * f9));
     f97 = Math_fround(Math_fround(f93 * f9) + Math_fround(Math_fround(f6 * f92) + Math_fround(f96 * f98)));
     f94 = Math_fround(Math_fround(f5 * f9) + Math_fround(Math_fround(f96 * f92) + Math_fround(f7 * f98)));
     f98 = Math_fround(Math_fround(f95 * f9) + Math_fround(Math_fround(f93 * f92) + Math_fround(f5 * f98)));
     f92 = Math_fround(Math_fround(f93 * f98) + Math_fround(Math_fround(f6 * f97) + Math_fround(f96 * f94)));
     f9 = Math_fround(Math_fround(f5 * f98) + Math_fround(Math_fround(f96 * f97) + Math_fround(f7 * f94)));
     f94 = Math_fround(Math_fround(f95 * f98) + Math_fround(Math_fround(f93 * f97) + Math_fround(f5 * f94)));
     f6 = Math_fround(Math_fround(f93 * f94) + Math_fround(Math_fround(f6 * f92) + Math_fround(f96 * f9)));
     f7 = Math_fround(Math_fround(f5 * f94) + Math_fround(Math_fround(f96 * f92) + Math_fround(f7 * f9)));
     f9 = Math_fround(Math_fround(f95 * f94) + Math_fround(Math_fround(f93 * f92) + Math_fround(f5 * f9)));
     f5 = Math_fround(Math_abs(Math_fround(f6)));
     f92 = Math_fround(Math_abs(Math_fround(f7)));
     f5 = f92 > f5 ? f92 : f5;
     f92 = Math_fround(Math_abs(Math_fround(f9)));
     f5 = f92 > f5 ? f92 : f5;
     if (f5 < Math_fround(4.0)) {
      i16 = 148;
      i14 = 300;
      i4 = 58;
     } else {
      d99 = 512.0 / +f5;
      i16 = ~~(d99 * +f6);
      i14 = ~~(d99 * +f7);
      i4 = ~~(d99 * +f9);
     }
     i2 = -2147483647;
     i15 = 0;
     i3 = 0;
     i8 = 2147483647;
     i10 = 0;
     while (1) {
      i11 = i10 << 2;
      i91 = i55 + i11 | 0;
      i12 = Math_imul(HEAPU8[i91 >> 0] | 0, i16) | 0;
      i12 = (Math_imul(HEAPU8[i55 + (i11 | 1) >> 0] | 0, i14) | 0) + i12 | 0;
      i11 = i12 + (Math_imul(HEAPU8[i55 + (i11 | 2) >> 0] | 0, i4) | 0) | 0;
      i12 = (i11 | 0) < (i8 | 0);
      i15 = i12 ? i91 : i15;
      i13 = (i11 | 0) > (i2 | 0);
      i3 = i13 ? i91 : i3;
      i10 = i10 + 1 | 0;
      if ((i10 | 0) == 16) break; else {
       i2 = i13 ? i11 : i2;
       i8 = i12 ? i11 : i8;
      }
     }
     i17 = ((HEAPU8[i3 >> 0] | 0) * 31 | 0) + 128 | 0;
     i16 = ((HEAPU8[i3 + 1 >> 0] | 0) * 63 | 0) + 128 | 0;
     i3 = ((HEAPU8[i3 + 2 >> 0] | 0) * 31 | 0) + 128 | 0;
     i3 = (((i16 >>> 8) + i16 | 0) >>> 8 << 5) + (((i17 >>> 8) + i17 | 0) >>> 8 << 11) + (((i3 >>> 8) + i3 | 0) >>> 8) | 0;
     i17 = i3 & 65535;
     i16 = ((HEAPU8[i15 >> 0] | 0) * 31 | 0) + 128 | 0;
     i91 = ((HEAPU8[i15 + 1 >> 0] | 0) * 63 | 0) + 128 | 0;
     i2 = ((HEAPU8[i15 + 2 >> 0] | 0) * 31 | 0) + 128 | 0;
     i2 = (((i91 >>> 8) + i91 | 0) >>> 8 << 5) + (((i16 >>> 8) + i16 | 0) >>> 8 << 11) + (((i2 >>> 8) + i2 | 0) >>> 8) | 0;
     i16 = i2 & 65535;
     if (i17 << 16 >> 16 == i16 << 16 >> 16) i2 = 0; else {
      i88 = HEAP8[(i3 >>> 11 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i30 >> 0] = i88;
      i90 = HEAP8[(i3 >>> 5 & 63) + (gb + 1544273) >> 0] | 0;
      HEAP8[i63 >> 0] = i90;
      i86 = HEAP8[(i3 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i64 >> 0] = i86;
      HEAP8[i65 >> 0] = 0;
      i87 = HEAP8[(i2 >>> 11 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i66 >> 0] = i87;
      i89 = HEAP8[(i2 >>> 5 & 63) + (gb + 1544273) >> 0] | 0;
      HEAP8[i67 >> 0] = i89;
      i91 = HEAP8[(i2 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i68 >> 0] = i91;
      HEAP8[i69 >> 0] = 0;
      i88 = i88 & 255;
      i87 = (i87 & 255) - i88 | 0;
      i2 = (i87 * 85 | 0) + 128 | 0;
      HEAP8[i70 >> 0] = (((i2 >>> 8) + i2 | 0) >>> 8) + i88;
      i90 = i90 & 255;
      i89 = (i89 & 255) - i90 | 0;
      i2 = (i89 * 85 | 0) + 128 | 0;
      HEAP8[i72 >> 0] = (((i2 >>> 8) + i2 | 0) >>> 8) + i90;
      i2 = i86 & 255;
      i91 = (i91 & 255) - i2 | 0;
      i86 = (i91 * 85 | 0) + 128 | 0;
      HEAP8[i73 >> 0] = (((i86 >>> 8) + i86 | 0) >>> 8) + i2;
      i87 = (i87 * 170 | 0) + 128 | 0;
      HEAP8[i74 >> 0] = (((i87 >>> 8) + i87 | 0) >>> 8) + i88;
      i89 = (i89 * 170 | 0) + 128 | 0;
      HEAP8[i75 >> 0] = (((i89 >>> 8) + i89 | 0) >>> 8) + i90;
      i91 = (i91 * 170 | 0) + 128 | 0;
      HEAP8[i76 >> 0] = (((i91 >>> 8) + i91 | 0) >>> 8) + i2;
      i2 = __ZL21stb__MatchColorsBlockPhS_i(i31, i30, i77) | 0;
     }
     if ((i2 << 2 ^ i2) >>> 0 < 4) {
      i3 = 0;
      i4 = 8;
      i8 = 8;
      i10 = 8;
      do {
       i91 = i3 << 2;
       i10 = (HEAPU8[i55 + i91 >> 0] | 0) + i10 | 0;
       i8 = (HEAPU8[i55 + (i91 | 1) >> 0] | 0) + i8 | 0;
       i4 = (HEAPU8[i55 + (i91 | 2) >> 0] | 0) + i4 | 0;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 16);
      i91 = i10 >> 4;
      i90 = i8 >> 4;
      i8 = i4 >> 4;
      i4 = (HEAPU8[gb + 1545393 + (i90 << 1) + 1 >> 0] | 0) << 5 | (HEAPU8[gb + 1544881 + (i91 << 1) + 1 >> 0] | 0) << 11 | (HEAPU8[gb + 1544881 + (i8 << 1) + 1 >> 0] | 0);
      i8 = (HEAPU8[gb + 1545393 + (i90 << 1) >> 0] | 0) << 5 | (HEAPU8[gb + 1544881 + (i91 << 1) >> 0] | 0) << 11 | (HEAPU8[gb + 1544881 + (i8 << 1) >> 0] | 0);
     } else {
      i3 = 0;
      i4 = 0;
      i8 = i2;
      i10 = 0;
      i11 = 0;
      i12 = 0;
      i13 = 0;
      i14 = 0;
      i15 = 0;
      while (1) {
       i87 = i8 & 3;
       i88 = HEAP32[gb + 41976 + (i87 << 2) >> 2] | 0;
       i91 = i15 << 2;
       i89 = HEAPU8[i55 + i91 >> 0] | 0;
       i90 = HEAPU8[i55 + (i91 | 1) >> 0] | 0;
       i91 = HEAPU8[i55 + (i91 | 2) >> 0] | 0;
       i3 = (HEAP32[gb + 41992 + (i87 << 2) >> 2] | 0) + i3 | 0;
       i4 = (Math_imul(i89, i88) | 0) + i4 | 0;
       i14 = (Math_imul(i90, i88) | 0) + i14 | 0;
       i13 = (Math_imul(i91, i88) | 0) + i13 | 0;
       i12 = i89 + i12 | 0;
       i11 = i90 + i11 | 0;
       i10 = i91 + i10 | 0;
       i15 = i15 + 1 | 0;
       if ((i15 | 0) == 16) break; else i8 = i8 >>> 2;
      }
      i88 = (i12 * 3 | 0) - i4 | 0;
      i85 = (i11 * 3 | 0) - i14 | 0;
      i86 = (i10 * 3 | 0) - i13 | 0;
      i87 = i3 >> 16;
      i91 = i3 >>> 8 & 255;
      i89 = i3 & 255;
      f98 = Math_fround(Math_fround(.36470589) / Math_fround((Math_imul(i91, i87) | 0) - (Math_imul(i89, i89) | 0) | 0));
      f97 = Math_fround(Math_fround(f98 * Math_fround(63.0)) / Math_fround(31.0));
      i90 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i91, i4) | 0) - (Math_imul(i89, i88) | 0) | 0) * f98) + Math_fround(.5));
      i8 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i91, i14) | 0) - (Math_imul(i89, i85) | 0) | 0) * f97) + Math_fround(.5));
      i91 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i91, i13) | 0) - (Math_imul(i86, i89) | 0) | 0) * f98) + Math_fround(.5));
      i88 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i87, i88) | 0) - (Math_imul(i89, i4) | 0) | 0) * f98) + Math_fround(.5));
      i4 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i87, i85) | 0) - (Math_imul(i89, i14) | 0) | 0) * f97) + Math_fround(.5));
      i89 = ~~Math_fround(Math_fround(Math_fround((Math_imul(i86, i87) | 0) - (Math_imul(i89, i13) | 0) | 0) * f98) + Math_fround(.5));
      i4 = ((i88 | 0) < 0 ? 0 : ((i88 | 0) > 31 ? 31 : i88) << 11) | ((i89 | 0) < 0 ? 0 : (i89 | 0) > 31 ? 31 : i89) | ((i4 | 0) < 0 ? 0 : ((i4 | 0) > 63 ? 63 : i4) << 5);
      i8 = ((i90 | 0) < 0 ? 0 : ((i90 | 0) > 31 ? 31 : i90) << 11) | ((i91 | 0) < 0 ? 0 : (i91 | 0) > 31 ? 31 : i91) | ((i8 | 0) < 0 ? 0 : ((i8 | 0) > 63 ? 63 : i8) << 5);
     }
     i10 = i4 & 65535;
     i3 = i8 & 65535;
     if (i17 << 16 >> 16 != i3 << 16 >> 16 ? 1 : i16 << 16 >> 16 != i10 << 16 >> 16) if (i3 << 16 >> 16 == i10 << 16 >> 16) {
      i4 = i10;
      i3 = i10;
      i2 = 0;
     } else {
      i89 = HEAP8[(i8 >>> 11 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i30 >> 0] = i89;
      i91 = HEAP8[(i8 >>> 5 & 63) + (gb + 1544273) >> 0] | 0;
      HEAP8[i63 >> 0] = i91;
      i87 = HEAP8[(i8 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i64 >> 0] = i87;
      HEAP8[i65 >> 0] = 0;
      i88 = HEAP8[(i4 >>> 11 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i66 >> 0] = i88;
      i90 = HEAP8[(i4 >>> 5 & 63) + (gb + 1544273) >> 0] | 0;
      HEAP8[i67 >> 0] = i90;
      i2 = HEAP8[(i4 & 31) + (gb + 1544241) >> 0] | 0;
      HEAP8[i68 >> 0] = i2;
      HEAP8[i69 >> 0] = 0;
      i89 = i89 & 255;
      i88 = (i88 & 255) - i89 | 0;
      i4 = (i88 * 85 | 0) + 128 | 0;
      HEAP8[i70 >> 0] = (((i4 >>> 8) + i4 | 0) >>> 8) + i89;
      i91 = i91 & 255;
      i90 = (i90 & 255) - i91 | 0;
      i4 = (i90 * 85 | 0) + 128 | 0;
      HEAP8[i72 >> 0] = (((i4 >>> 8) + i4 | 0) >>> 8) + i91;
      i4 = i87 & 255;
      i2 = (i2 & 255) - i4 | 0;
      i87 = (i2 * 85 | 0) + 128 | 0;
      HEAP8[i73 >> 0] = (((i87 >>> 8) + i87 | 0) >>> 8) + i4;
      i88 = (i88 * 170 | 0) + 128 | 0;
      HEAP8[i74 >> 0] = (((i88 >>> 8) + i88 | 0) >>> 8) + i89;
      i90 = (i90 * 170 | 0) + 128 | 0;
      HEAP8[i75 >> 0] = (((i90 >>> 8) + i90 | 0) >>> 8) + i91;
      i2 = (i2 * 170 | 0) + 128 | 0;
      HEAP8[i76 >> 0] = (((i2 >>> 8) + i2 | 0) >>> 8) + i4;
      i4 = i10;
      i2 = __ZL21stb__MatchColorsBlockPhS_i(i31, i30, i77) | 0;
     } else {
      i4 = i16;
      i3 = i17;
     }
    }
    i91 = (i3 & 65535) < (i4 & 65535);
    HEAP16[i18 >> 1] = i91 ? i4 : i3;
    HEAP16[i18 + 2 >> 1] = i91 ? i3 : i4;
    HEAP32[i18 + 4 >> 2] = i91 ? i2 ^ 1431655765 : i2;
    i1 = i1 + i32 | 0;
    i19 = i19 + 4 | 0;
   } while ((i19 | 0) < (i28 | 0));
  }
  i27 = i27 + 4 | 0;
 } while ((i27 | 0) < (i29 | 0));
 STACKTOP = i82;
 return;
}

function __ZN5physx27partitionContactConstraintsERNS_23ConstraintPartitionArgsE(i35) {
 i35 = i35 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i36 + 24 | 0;
 i27 = i36 + 20 | 0;
 i19 = i36 + 30 | 0;
 i20 = i36 + 29 | 0;
 i15 = i36 + 16 | 0;
 i16 = i36 + 12 | 0;
 i17 = i36 + 8 | 0;
 i24 = i36;
 i3 = i36 + 28 | 0;
 i32 = HEAP32[i35 + 4 >> 2] | 0;
 i33 = HEAP32[i35 >> 2] | 0;
 i23 = HEAP32[i35 + 12 >> 2] | 0;
 i34 = HEAP32[i35 + 20 >> 2] | 0;
 i9 = HEAP32[i35 + 16 >> 2] | 0;
 i28 = HEAP32[i35 + 24 >> 2] | 0;
 i29 = HEAP32[i35 + 28 >> 2] | 0;
 i30 = HEAP32[i35 + 48 >> 2] | 0;
 i25 = i30 + 4 | 0;
 HEAP32[i25 >> 2] = 0;
 i31 = (i32 | 0) == 0;
 if (!i31) {
  HEAP32[i33 + 28 >> 2] = 0;
  HEAP16[i33 + 14 >> 1] = 0;
  HEAP16[i33 + 12 >> 1] = 0;
  if ((i32 | 0) != 1) {
   i1 = 1;
   do {
    i22 = HEAP32[i35 >> 2] | 0;
    HEAP32[i22 + (i1 << 5) + 28 >> 2] = 0;
    HEAP16[i22 + (i1 << 5) + 14 >> 1] = 0;
    HEAP16[i22 + (i1 << 5) + 12 >> 1] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i32 | 0));
  }
 }
 if (!i23) {
  HEAP32[i25 >> 2] = 32;
  i2 = HEAP32[i30 >> 2] | 0;
  i4 = i2 + 128 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i15 = (i34 | 0) == 0;
  L8 : do if (!i15) {
   i11 = i33;
   i12 = i9;
   i2 = 0;
   i1 = 0;
   while (1) {
    i8 = HEAP32[i12 >> 2] | 0;
    i10 = HEAP32[i12 + 4 >> 2] | 0;
    i3 = i8 - i11 >> 5 >>> 0 < i32 >>> 0;
    i4 = i10 - i11 >> 5 >>> 0 < i32 >>> 0;
    do if (i3 & i4) {
     i4 = i8 + 28 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i10 + 28 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i3 = i7 | i5;
     if ((i3 | 0) == -1) {
      i24 = i29 + (i1 << 5) | 0;
      HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i24 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i24 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      HEAP32[i24 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
      HEAP32[i24 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
      HEAP32[i24 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
      i1 = i1 + 1 | 0;
      break;
     } else {
      i22 = (Math_imul(i3 + 1 & ~i3, 125613361) | 0) >>> 27;
      i22 = HEAP32[gb + 90668 + (i22 << 2) >> 2] | 0;
      i24 = HEAP32[gb + 106028 + (i22 << 2) >> 2] | 0;
      HEAP32[i4 >> 2] = i24 | i5;
      HEAP32[i6 >> 2] = i24 | i7;
      i24 = (HEAP32[i30 >> 2] | 0) + (i22 << 2) | 0;
      HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
      i24 = i8 + 12 | 0;
      i23 = HEAP16[i24 >> 1] | 0;
      i22 = i22 + 1 & 65535;
      HEAP16[i24 >> 1] = (i23 & 65535) < (i22 & 65535) ? i22 : i23;
      i24 = i10 + 12 | 0;
      i23 = HEAP16[i24 >> 1] | 0;
      HEAP16[i24 >> 1] = (i23 & 65535) < (i22 & 65535) ? i22 : i23;
      break;
     }
    } else {
     if (i3) {
      i24 = i8 + 14 | 0;
      HEAP16[i24 >> 1] = (HEAP16[i24 >> 1] | 0) + 1 << 16 >> 16;
      break;
     }
     if (i4) {
      i24 = i10 + 14 | 0;
      HEAP16[i24 >> 1] = (HEAP16[i24 >> 1] | 0) + 1 << 16 >> 16;
     }
    } while (0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i34 | 0)) break; else i12 = i12 + 32 | 0;
   }
   if (i1 | 0) {
    i3 = 0;
    do {
     if (!i31) {
      i2 = 0;
      do {
       HEAP32[i33 + (i2 << 5) + 28 >> 2] = 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i32 | 0));
     }
     i3 = i3 + 32 | 0;
     i2 = (HEAP32[i25 >> 2] | 0) + 32 | 0;
     HEAP32[i26 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i2, i26);
     i2 = (HEAP32[i30 >> 2] | 0) + (i3 << 2) | 0;
     i4 = i2 + 128 | 0;
     do {
      HEAP8[i2 >> 0] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i4 | 0));
     if (!i1) break L8;
     i13 = HEAP32[i30 >> 2] | 0;
     i14 = 0;
     i2 = 0;
     do {
      i5 = i29 + (i14 << 5) | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      i7 = i6 + 28 | 0;
      i8 = HEAP32[i7 >> 2] | 0;
      i10 = HEAP32[i29 + (i14 << 5) + 4 >> 2] | 0;
      i11 = i10 + 28 | 0;
      i12 = HEAP32[i11 >> 2] | 0;
      i4 = i12 | i8;
      if ((i4 | 0) == -1) {
       i24 = i29 + (i2 << 5) | 0;
       HEAP32[i24 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i24 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i24 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i24 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i24 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i24 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       HEAP32[i24 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
       HEAP32[i24 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
       i2 = i2 + 1 | 0;
      } else {
       i22 = (Math_imul(i4 + 1 & ~i4, 125613361) | 0) >>> 27;
       i22 = HEAP32[gb + 90668 + (i22 << 2) >> 2] | 0;
       i24 = HEAP32[gb + 106028 + (i22 << 2) >> 2] | 0;
       HEAP32[i7 >> 2] = i24 | i8;
       HEAP32[i11 >> 2] = i24 | i12;
       i22 = i22 + i3 | 0;
       i24 = i13 + (i22 << 2) | 0;
       HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
       i24 = i6 + 12 | 0;
       i23 = HEAP16[i24 >> 1] | 0;
       i22 = i22 + 1 & 65535;
       HEAP16[i24 >> 1] = (i23 & 65535) < (i22 & 65535) ? i22 : i23;
       i24 = i10 + 12 | 0;
       i23 = HEAP16[i24 >> 1] | 0;
       HEAP16[i24 >> 1] = (i23 & 65535) < (i22 & 65535) ? i22 : i23;
      }
      i14 = i14 + 1 | 0;
     } while ((i14 | 0) != (i1 | 0));
     i1 = i2;
    } while ((i1 | 0) != 0);
   }
  } while (0);
  if (!i31) {
   i5 = 0;
   do {
    HEAP32[i33 + (i5 << 5) + 28 >> 2] = 0;
    i4 = i33 + (i5 << 5) + 12 | 0;
    i1 = i33 + (i5 << 5) + 14 | 0;
    i2 = HEAP16[i1 >> 1] | 0;
    i3 = (i2 & 65535) + (HEAPU16[i4 >> 1] | 0) | 0;
    if (i3 >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) {
     HEAP32[i27 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i3, i27);
     i2 = HEAP16[i1 >> 1] | 0;
    }
    if (i2 << 16 >> 16) {
     i3 = HEAPU16[i4 >> 1] | 0;
     i4 = HEAP32[i30 >> 2] | 0;
     i1 = i2 & 65535;
     i2 = 0;
     do {
      i26 = i4 + (i2 + i3 << 2) | 0;
      HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i1 | 0));
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i32 | 0));
  }
  if (HEAP32[i25 >> 2] | 0) {
   i1 = HEAP32[i30 >> 2] | 0;
   i3 = 0;
   i4 = 0;
   while (1) {
    i27 = i1 + (i3 << 2) | 0;
    i2 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = i4;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= (HEAP32[i25 >> 2] | 0) >>> 0) break; else i4 = i2 + i4 | 0;
   }
  }
  if (!i31) {
   i1 = 0;
   do {
    i27 = HEAP32[i35 >> 2] | 0;
    HEAP32[i27 + (i1 << 5) + 28 >> 2] = 0;
    HEAP16[i27 + (i1 << 5) + 14 >> 1] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i32 | 0));
  }
  L60 : do if (!i15) {
   i10 = i33;
   i2 = 0;
   i1 = 0;
   while (1) {
    i3 = HEAP32[i9 >> 2] | 0;
    i6 = HEAP32[i9 + 4 >> 2] | 0;
    i4 = i3 - i10 >> 5 >>> 0 < i32 >>> 0;
    i5 = i6 - i10 >> 5 >>> 0 < i32 >>> 0;
    do if (i4 & i5) {
     i7 = i3 + 28 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i4 = i6 + 28 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i3 = i5 | i8;
     if ((i3 | 0) == -1) {
      i27 = i29 + (i1 << 5) | 0;
      HEAP32[i27 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i27 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
      HEAP32[i27 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
      HEAP32[i27 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
      HEAP32[i27 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
      i1 = i1 + 1 | 0;
      break;
     } else {
      i26 = (Math_imul(i3 + 1 & ~i3, 125613361) | 0) >>> 27;
      i26 = HEAP32[gb + 90668 + (i26 << 2) >> 2] | 0;
      i27 = HEAP32[gb + 106028 + (i26 << 2) >> 2] | 0;
      HEAP32[i7 >> 2] = i27 | i8;
      HEAP32[i4 >> 2] = i27 | i5;
      i26 = (HEAP32[i30 >> 2] | 0) + (i26 << 2) | 0;
      i27 = HEAP32[i26 >> 2] | 0;
      HEAP32[i26 >> 2] = i27 + 1;
      i27 = i28 + (i27 << 5) | 0;
      HEAP32[i27 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i27 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
      HEAP32[i27 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
      HEAP32[i27 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
      HEAP32[i27 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
      break;
     }
    } else {
     if (i4) {
      i27 = HEAPU16[i3 + 12 >> 1] | 0;
      i26 = i3 + 14 | 0;
      i3 = HEAP16[i26 >> 1] | 0;
      HEAP16[i26 >> 1] = i3 + 1 << 16 >> 16;
      i3 = (i3 & 65535) + i27 | 0;
     } else if (i5) {
      i3 = HEAPU16[i6 + 12 >> 1] | 0;
      i26 = i6 + 14 | 0;
      i27 = HEAP16[i26 >> 1] | 0;
      HEAP16[i26 >> 1] = i27 + 1 << 16 >> 16;
      i3 = (i27 & 65535) + i3 | 0;
     } else i3 = 0;
     i26 = (HEAP32[i30 >> 2] | 0) + (i3 << 2) | 0;
     i27 = HEAP32[i26 >> 2] | 0;
     HEAP32[i26 >> 2] = i27 + 1;
     i27 = i28 + (i27 << 5) | 0;
     HEAP32[i27 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i27 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i27 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i27 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i27 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i27 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i27 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i27 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
    } while (0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i34 | 0)) break; else i9 = i9 + 32 | 0;
   }
   if (i1 | 0) {
    i3 = 0;
    do {
     if (!i31) {
      i2 = 0;
      do {
       HEAP32[i33 + (i2 << 5) + 28 >> 2] = 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i32 | 0));
      if (!i1) break L60;
     }
     i3 = i3 + 32 | 0;
     i10 = 0;
     i2 = 0;
     do {
      i5 = i29 + (i10 << 5) | 0;
      i6 = (HEAP32[i5 >> 2] | 0) + 28 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      i8 = (HEAP32[i29 + (i10 << 5) + 4 >> 2] | 0) + 28 | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      i4 = i9 | i7;
      if ((i4 | 0) == -1) {
       i27 = i29 + (i2 << 5) | 0;
       HEAP32[i27 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i27 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i27 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i27 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i27 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i27 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       HEAP32[i27 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
       HEAP32[i27 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
       i2 = i2 + 1 | 0;
      } else {
       i26 = (Math_imul(i4 + 1 & ~i4, 125613361) | 0) >>> 27;
       i26 = HEAP32[gb + 90668 + (i26 << 2) >> 2] | 0;
       i27 = HEAP32[gb + 106028 + (i26 << 2) >> 2] | 0;
       HEAP32[i6 >> 2] = i27 | i7;
       HEAP32[i8 >> 2] = i27 | i9;
       i26 = (HEAP32[i30 >> 2] | 0) + (i26 + i3 << 2) | 0;
       i27 = HEAP32[i26 >> 2] | 0;
       HEAP32[i26 >> 2] = i27 + 1;
       i27 = i28 + (i27 << 5) | 0;
       HEAP32[i27 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i27 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i27 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i27 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i27 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i27 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       HEAP32[i27 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
       HEAP32[i27 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
      }
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i1 | 0));
     i1 = i2;
    } while ((i1 | 0) != 0);
   }
  } while (0);
  i33 = __ZN5physx19normalizePartitionsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_(i30, i28, i33, i34, i32, HEAP32[i35 + 52 >> 2] | 0) | 0;
  i32 = i35 + 36 | 0;
  HEAP32[i32 >> 2] = 0;
  i32 = i35 + 40 | 0;
  HEAP32[i32 >> 2] = i34;
  i35 = i35 + 44 | 0;
  HEAP32[i35 >> 2] = 0;
  STACKTOP = i36;
  return i33 | 0;
 }
 i4 = HEAP32[i35 + 8 >> 2] | 0;
 i2 = i23 << 2;
 i21 = i2 >>> 0 > 1024;
 i22 = i24 + 4 | 0;
 HEAP8[i22 >> 0] = i21 & 1;
 if (i21) {
  i21 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i3, i2, gb + 720042 | 0, 914) | 0;
  HEAP32[i24 >> 2] = i21;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i24 >> 2] = i1;
  i21 = i1;
 }
 i1 = 0;
 do {
  i18 = HEAP32[i4 + (i1 * 40 | 0) >> 2] | 0;
  HEAP32[i21 + (i1 << 2) >> 2] = i18;
  HEAP32[i18 + 28 >> 2] = 0;
  HEAP16[i18 + 14 >> 1] = 0;
  HEAP16[i18 + 12 >> 1] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 HEAP32[i25 >> 2] = 32;
 i2 = HEAP32[i30 >> 2] | 0;
 i4 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i18 = (i34 | 0) == 0;
 L101 : do if (!i18) {
  i11 = i9;
  i2 = 0;
  i1 = 0;
  while (1) {
   do if (__ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i11, i33, i32, i21, i23, i26, i27, i19, i20) | 0) {
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = i4 + 28 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i7 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = i7 + 28 | 0;
    i10 = HEAP32[i8 >> 2] | 0;
    i3 = i10 | i6;
    if ((i3 | 0) == -1) {
     i14 = i29 + (i1 << 5) | 0;
     HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i14 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i14 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i14 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
     HEAP32[i14 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
     i1 = i1 + 1 | 0;
     break;
    } else {
     i12 = (Math_imul(i3 + 1 & ~i3, 125613361) | 0) >>> 27;
     i12 = HEAP32[gb + 90668 + (i12 << 2) >> 2] | 0;
     i14 = HEAP32[gb + 106028 + (i12 << 2) >> 2] | 0;
     HEAP32[i5 >> 2] = i14 | i6;
     HEAP32[i8 >> 2] = i14 | i10;
     i14 = (HEAP32[i30 >> 2] | 0) + (i12 << 2) | 0;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
     i14 = i4 + 12 | 0;
     i13 = HEAP16[i14 >> 1] | 0;
     i12 = i12 + 1 & 65535;
     HEAP16[i14 >> 1] = (i13 & 65535) < (i12 & 65535) ? i12 : i13;
     i14 = i7 + 12 | 0;
     i13 = HEAP16[i14 >> 1] | 0;
     HEAP16[i14 >> 1] = (i13 & 65535) < (i12 & 65535) ? i12 : i13;
     break;
    }
   } else {
    if (HEAP8[i19 >> 0] | 0) {
     i14 = (HEAP32[i11 >> 2] | 0) + 14 | 0;
     HEAP16[i14 >> 1] = (HEAP16[i14 >> 1] | 0) + 1 << 16 >> 16;
     break;
    }
    if (HEAP8[i20 >> 0] | 0) {
     i14 = (HEAP32[i11 + 4 >> 2] | 0) + 14 | 0;
     HEAP16[i14 >> 1] = (HEAP16[i14 >> 1] | 0) + 1 << 16 >> 16;
    }
   } while (0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i34 | 0)) break; else i11 = i11 + 32 | 0;
  }
  if (i1 | 0) {
   i3 = 0;
   do {
    if (i31) i2 = 0; else {
     i2 = 0;
     do {
      HEAP32[i33 + (i2 << 5) + 28 >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i32 | 0));
     i2 = 0;
    }
    do {
     HEAP32[(HEAP32[i21 + (i2 << 2) >> 2] | 0) + 28 >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i23 | 0));
    i3 = i3 + 32 | 0;
    i2 = (HEAP32[i25 >> 2] | 0) + 32 | 0;
    HEAP32[i15 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i2, i15);
    i2 = (HEAP32[i30 >> 2] | 0) + (i3 << 2) | 0;
    i4 = i2 + 128 | 0;
    do {
     HEAP8[i2 >> 0] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i4 | 0));
    if (!i1) break L101;
    i13 = HEAP32[i30 >> 2] | 0;
    i14 = 0;
    i2 = 0;
    do {
     i5 = i29 + (i14 << 5) | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i7 = i6 + 28 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i10 = HEAP32[i29 + (i14 << 5) + 4 >> 2] | 0;
     i11 = i10 + 28 | 0;
     i12 = HEAP32[i11 >> 2] | 0;
     i4 = i12 | i8;
     if ((i4 | 0) == -1) {
      i12 = i29 + (i2 << 5) | 0;
      HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
      HEAP32[i12 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
      HEAP32[i12 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
      HEAP32[i12 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
      HEAP32[i12 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
      i2 = i2 + 1 | 0;
     } else {
      i5 = (Math_imul(i4 + 1 & ~i4, 125613361) | 0) >>> 27;
      i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | 0;
      i4 = HEAP32[gb + 106028 + (i5 << 2) >> 2] | 0;
      HEAP32[i7 >> 2] = i4 | i8;
      HEAP32[i11 >> 2] = i4 | i12;
      i8 = i5 + i3 | 0;
      i12 = i13 + (i8 << 2) | 0;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i12 = i6 + 12 | 0;
      i11 = HEAP16[i12 >> 1] | 0;
      i8 = i8 + 1 & 65535;
      HEAP16[i12 >> 1] = (i11 & 65535) < (i8 & 65535) ? i8 : i11;
      i12 = i10 + 12 | 0;
      i11 = HEAP16[i12 >> 1] | 0;
      HEAP16[i12 >> 1] = (i11 & 65535) < (i8 & 65535) ? i8 : i11;
     }
     i14 = i14 + 1 | 0;
    } while ((i14 | 0) != (i1 | 0));
    i1 = i2;
   } while ((i1 | 0) != 0);
  }
 } while (0);
 if (i31) i5 = 0; else {
  i5 = 0;
  do {
   HEAP32[i33 + (i5 << 5) + 28 >> 2] = 0;
   i4 = i33 + (i5 << 5) + 12 | 0;
   i1 = i33 + (i5 << 5) + 14 | 0;
   i2 = HEAP16[i1 >> 1] | 0;
   i3 = (i2 & 65535) + (HEAPU16[i4 >> 1] | 0) | 0;
   if (i3 >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) {
    HEAP32[i16 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i3, i16);
    i2 = HEAP16[i1 >> 1] | 0;
   }
   if (i2 << 16 >> 16) {
    i3 = HEAPU16[i4 >> 1] | 0;
    i4 = HEAP32[i30 >> 2] | 0;
    i1 = i2 & 65535;
    i2 = 0;
    do {
     i15 = i4 + (i2 + i3 << 2) | 0;
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i32 | 0));
  i5 = 0;
 }
 do {
  i1 = HEAP32[i21 + (i5 << 2) >> 2] | 0;
  HEAP32[i1 + 28 >> 2] = 0;
  i4 = i1 + 12 | 0;
  i1 = i1 + 14 | 0;
  i2 = HEAP16[i1 >> 1] | 0;
  i3 = (i2 & 65535) + (HEAPU16[i4 >> 1] | 0) | 0;
  if (i3 >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) {
   HEAP32[i17 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i3, i17);
   i2 = HEAP16[i1 >> 1] | 0;
  }
  if (i2 << 16 >> 16) {
   i3 = HEAPU16[i4 >> 1] | 0;
   i4 = HEAP32[i30 >> 2] | 0;
   i1 = i2 & 65535;
   i2 = 0;
   do {
    i16 = i4 + (i2 + i3 << 2) | 0;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i23 | 0));
 if (HEAP32[i25 >> 2] | 0) {
  i1 = HEAP32[i30 >> 2] | 0;
  i3 = 0;
  i4 = 0;
  while (1) {
   i17 = i1 + (i3 << 2) | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = i4;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= (HEAP32[i25 >> 2] | 0) >>> 0) break; else i4 = i2 + i4 | 0;
  }
 }
 if (i31) i1 = 0; else {
  i1 = 0;
  do {
   i25 = HEAP32[i35 >> 2] | 0;
   HEAP32[i25 + (i1 << 5) + 28 >> 2] = 0;
   HEAP16[i25 + (i1 << 5) + 14 >> 1] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i32 | 0));
  i1 = 0;
 }
 do {
  i25 = HEAP32[i21 + (i1 << 2) >> 2] | 0;
  HEAP32[i25 + 28 >> 2] = 0;
  HEAP16[i25 + 14 >> 1] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 L166 : do if (!i18) {
  i2 = 0;
  i1 = 0;
  while (1) {
   do if (__ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i9, i33, i32, i21, i23, i26, i27, i19, i20) | 0) {
    i4 = (HEAP32[i9 >> 2] | 0) + 28 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = (HEAP32[i9 + 4 >> 2] | 0) + 28 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i3 = i7 | i5;
    if ((i3 | 0) == -1) {
     i25 = i29 + (i1 << 5) | 0;
     HEAP32[i25 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     i1 = i1 + 1 | 0;
     break;
    } else {
     i18 = (Math_imul(i3 + 1 & ~i3, 125613361) | 0) >>> 27;
     i18 = HEAP32[gb + 90668 + (i18 << 2) >> 2] | 0;
     i25 = HEAP32[gb + 106028 + (i18 << 2) >> 2] | 0;
     HEAP32[i4 >> 2] = i25 | i5;
     HEAP32[i6 >> 2] = i25 | i7;
     i18 = (HEAP32[i30 >> 2] | 0) + (i18 << 2) | 0;
     i25 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = i25 + 1;
     i25 = i28 + (i25 << 5) | 0;
     HEAP32[i25 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i25 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i25 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i25 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i25 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     break;
    }
   } else {
    if (!(HEAP8[i19 >> 0] | 0)) if (!(HEAP8[i20 >> 0] | 0)) i3 = 0; else {
     i18 = HEAP32[i9 + 4 >> 2] | 0;
     i3 = HEAPU16[i18 + 12 >> 1] | 0;
     i18 = i18 + 14 | 0;
     i25 = HEAP16[i18 >> 1] | 0;
     HEAP16[i18 >> 1] = i25 + 1 << 16 >> 16;
     i3 = (i25 & 65535) + i3 | 0;
    } else {
     i18 = HEAP32[i9 >> 2] | 0;
     i3 = HEAPU16[i18 + 12 >> 1] | 0;
     i18 = i18 + 14 | 0;
     i25 = HEAP16[i18 >> 1] | 0;
     HEAP16[i18 >> 1] = i25 + 1 << 16 >> 16;
     i3 = (i25 & 65535) + i3 | 0;
    }
    i18 = (HEAP32[i30 >> 2] | 0) + (i3 << 2) | 0;
    i25 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = i25 + 1;
    i25 = i28 + (i25 << 5) | 0;
    HEAP32[i25 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i25 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i25 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i25 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i25 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    HEAP32[i25 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
    HEAP32[i25 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
    HEAP32[i25 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
   } while (0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i34 | 0)) break; else i9 = i9 + 32 | 0;
  }
  if (i1 | 0) {
   i3 = 0;
   do {
    if (i31) i2 = 0; else {
     i2 = 0;
     do {
      HEAP32[i33 + (i2 << 5) + 28 >> 2] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i32 | 0));
     i2 = 0;
    }
    do {
     HEAP32[(HEAP32[i21 + (i2 << 2) >> 2] | 0) + 28 >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i23 | 0));
    i3 = i3 + 32 | 0;
    if (!i1) break L166; else {
     i10 = 0;
     i2 = 0;
    }
    do {
     i5 = i29 + (i10 << 5) | 0;
     i6 = (HEAP32[i5 >> 2] | 0) + 28 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i8 = (HEAP32[i29 + (i10 << 5) + 4 >> 2] | 0) + 28 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     i4 = i9 | i7;
     if ((i4 | 0) == -1) {
      i27 = i29 + (i2 << 5) | 0;
      HEAP32[i27 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
      HEAP32[i27 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
      HEAP32[i27 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
      HEAP32[i27 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
      HEAP32[i27 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
      i2 = i2 + 1 | 0;
     } else {
      i26 = (Math_imul(i4 + 1 & ~i4, 125613361) | 0) >>> 27;
      i26 = HEAP32[gb + 90668 + (i26 << 2) >> 2] | 0;
      i27 = HEAP32[gb + 106028 + (i26 << 2) >> 2] | 0;
      HEAP32[i6 >> 2] = i27 | i7;
      HEAP32[i8 >> 2] = i27 | i9;
      i26 = (HEAP32[i30 >> 2] | 0) + (i26 + i3 << 2) | 0;
      i27 = HEAP32[i26 >> 2] | 0;
      HEAP32[i26 >> 2] = i27 + 1;
      i27 = i28 + (i27 << 5) | 0;
      HEAP32[i27 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
      HEAP32[i27 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
      HEAP32[i27 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
      HEAP32[i27 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
      HEAP32[i27 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
     }
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i1 | 0));
    i1 = i2;
   } while ((i1 | 0) != 0);
  }
 } while (0);
 i1 = __ZN5physx36normalizePartitionsWithArticulationsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_Pjj(i30, i28, i33, i34, i32, HEAP32[i35 + 52 >> 2] | 0, i21, i23) | 0;
 if (!(HEAP8[i22 >> 0] | 0)) {
  i33 = i1;
  i32 = i35 + 36 | 0;
  HEAP32[i32 >> 2] = 0;
  i32 = i35 + 40 | 0;
  HEAP32[i32 >> 2] = i34;
  i35 = i35 + 44 | 0;
  HEAP32[i35 >> 2] = 0;
  STACKTOP = i36;
  return i33 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i24, HEAP32[i24 >> 2] | 0);
 i33 = i1;
 i32 = i35 + 36 | 0;
 HEAP32[i32 >> 2] = 0;
 i32 = i35 + 40 | 0;
 HEAP32[i32 >> 2] = i34;
 i35 = i35 + 44 | 0;
 HEAP32[i35 >> 2] = 0;
 STACKTOP = i36;
 return i33 | 0;
}

function __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 4 | 0;
 i5 = i11;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 28 | 0, i8);
 i1 = i7 + 280 | 0;
 i9 = i8 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 284 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 292 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 296 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 96 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 112 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 268 | 0, i8);
 i1 = i7 + 272 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 276 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 144 | 0, i8);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 264 | 0, i8);
 i1 = i7 + 300 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 304 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 308 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 312 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 328 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 332 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 336 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 337 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i7 + 340 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i12 = i8 + 8 | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = i7 + 344 | 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i3, i1, i6, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 i1 = i7 + 364 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 360 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 316 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 376 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 377 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 378 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 379 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 380 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 381 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 382 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 384 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 386 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 387 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 388 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 389 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 390 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 391 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 392 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 393 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 394 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 412 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 413 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 395 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 414 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 415 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 416 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 417 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 418 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 419 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 424 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 396 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 397 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i7 + 400 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!i1) HEAP32[i3 >> 2] = 1;
 i1 = i7 + 404 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 408 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 420 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 425 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 426 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 427 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 428 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 429 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 430 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 383 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 385 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 432 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 436 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 440 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 444 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 448 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 452 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 504 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 508 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 512 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 513 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 514 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 515 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 516 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 517 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 520 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 __ZN12AspectRatios8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 320 | 0, i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 556 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 572 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i8, i7 + 604 | 0, 0);
 i4 = i7 + 624 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i7 + 628 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 629 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 630 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 44 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 64 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i7 + 80 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE(i13, i14, i1, i58, i12, i59, i74, i71, i72, i70) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i58 = i58 | 0;
 i12 = i12 | 0;
 i59 = i59 | 0;
 i74 = i74 | 0;
 i71 = i71 | 0;
 i72 = i72 | 0;
 i70 = i70 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i76;
 i73 = i76 + 16 | 0;
 i54 = i76 + 64 | 0;
 i10 = (HEAP32[i13 + 32 >> 2] | 0) + (HEAPU16[i1 + 16 >> 1] | 0) | 0;
 i61 = HEAP32[i12 + 40 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f56 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f63 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f55 = Math_fround(f33 * Math_fround(HEAPF32[i61 >> 2]));
 f55 = Math_fround(f55 + Math_fround(f56 * Math_fround(HEAPF32[i61 + 4 >> 2])));
 f55 = Math_fround(f55 + Math_fround(f63 * Math_fround(HEAPF32[i61 + 8 >> 2])));
 f57 = Math_fround(f33 * Math_fround(HEAPF32[i61 + 16 >> 2]));
 f57 = Math_fround(f57 + Math_fround(f56 * Math_fround(HEAPF32[i61 + 20 >> 2])));
 f57 = Math_fround(f57 + Math_fround(f63 * Math_fround(HEAPF32[i61 + 24 >> 2])));
 f33 = Math_fround(f33 * Math_fround(HEAPF32[i61 + 32 >> 2]));
 f56 = Math_fround(f33 + Math_fround(f56 * Math_fround(HEAPF32[i61 + 36 >> 2])));
 f63 = Math_fround(f56 + Math_fround(f63 * Math_fround(HEAPF32[i61 + 40 >> 2])));
 f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f57 * f57)) + Math_fround(f63 * f63)))));
 f57 = Math_fround(f57 * f56);
 f63 = Math_fround(f63 * f56);
 HEAPF32[i60 >> 2] = Math_fround(f55 * f56);
 i61 = i60 + 4 | 0;
 HEAPF32[i61 >> 2] = f57;
 i62 = i60 + 8 | 0;
 HEAPF32[i62 >> 2] = f63;
 HEAPF32[i60 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE(i73, i60);
 i11 = (HEAP32[i14 + 32 >> 2] | 0) + (HEAPU16[i58 + 16 >> 1] | 0) | 0;
 i69 = i1 + 18 | 0;
 i9 = HEAPU8[i69 >> 0] | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((i9 << 4) + 16 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i1 + 15 & -16;
 i67 = i17;
 i68 = i58 + 18 | 0;
 i4 = HEAPU8[i68 >> 0] | 0;
 i5 = (i4 << 4) + 16 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 15 & -16;
 i65 = i6;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i4 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i64 = i1 + 15 & -16;
 mftCall_viiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, i10 | 0, i9 | 0, HEAP32[i13 + 28 >> 2] | 0, i67 | 0);
 mftCall_viiiii(HEAP32[(HEAP32[i59 >> 2] | 0) + 16 >> 2] | 0, i59 | 0, i11 | 0, HEAPU8[i68 >> 0] | 0, HEAP32[i14 + 28 >> 2] | 0, i65 | 0);
 i53 = i6;
 f30 = Math_fround(HEAPF32[i6 >> 2]);
 f31 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 if (!(HEAP8[i69 >> 0] | 0)) {
  f27 = Math_fround(3402823469999999843913219.0e14);
  f26 = Math_fround(3402823469999999843913219.0e14);
  f25 = Math_fround(-3402823469999999843913219.0e14);
  f24 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  i1 = i73 + 16 | 0;
  i4 = i73 + 32 | 0;
  i5 = i73 + 4 | 0;
  i6 = i73 + 20 | 0;
  i9 = i73 + 36 | 0;
  i10 = i73 + 8 | 0;
  i11 = i73 + 24 | 0;
  i12 = i73 + 40 | 0;
  f7 = Math_fround(3402823469999999843913219.0e14);
  f2 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  i13 = 0;
  do {
   i51 = i67 + (i13 << 4) | 0;
   f33 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i67 + (i13 << 4) + 4 | 0;
   f55 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = i67 + (i13 << 4) + 8 | 0;
   f56 = Math_fround(HEAPF32[i53 >> 2]);
   f57 = Math_fround(f33 * Math_fround(HEAPF32[i73 >> 2]));
   f57 = Math_fround(f57 + Math_fround(f55 * Math_fround(HEAPF32[i1 >> 2])));
   f57 = Math_fround(f57 + Math_fround(f56 * Math_fround(HEAPF32[i4 >> 2])));
   f63 = Math_fround(f33 * Math_fround(HEAPF32[i5 >> 2]));
   f63 = Math_fround(f63 + Math_fround(f55 * Math_fround(HEAPF32[i6 >> 2])));
   f63 = Math_fround(f63 + Math_fround(f56 * Math_fround(HEAPF32[i9 >> 2])));
   f33 = Math_fround(f33 * Math_fround(HEAPF32[i10 >> 2]));
   f55 = Math_fround(f33 + Math_fround(f55 * Math_fround(HEAPF32[i11 >> 2])));
   f56 = Math_fround(f55 + Math_fround(f56 * Math_fround(HEAPF32[i12 >> 2])));
   HEAPF32[i51 >> 2] = f57;
   HEAPF32[i52 >> 2] = f63;
   HEAPF32[i53 >> 2] = f56;
   HEAPF32[i67 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   f7 = f7 < f57 ? f7 : f57;
   f2 = f2 < f63 ? f2 : f63;
   f8 = f8 > f57 ? f8 : f57;
   f3 = f3 > f63 ? f3 : f63;
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < (HEAPU8[i69 >> 0] | 0) >>> 0);
  f27 = Math_fround(f2 + Math_fround(-1.1920929e-07));
  f26 = Math_fround(f7 + Math_fround(-1.1920929e-07));
  f25 = Math_fround(f3 + Math_fround(1.1920929e-07));
  f24 = Math_fround(f8 + Math_fround(1.1920929e-07));
 }
 i53 = HEAP32[i17 + 8 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i70 >> 2]);
 f63 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(f63 + f23);
 i1 = HEAP8[i68 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f29 = Math_fround(3402823469999999843913219.0e14);
  f28 = Math_fround(3402823469999999843913219.0e14);
  f27 = Math_fround(-3402823469999999843913219.0e14);
  f26 = Math_fround(-3402823469999999843913219.0e14);
  i4 = i1 & 255;
  i5 = 0;
  i1 = 0;
 } else {
  i17 = i74 + 48 | 0;
  i34 = i74 + 52 | 0;
  i35 = i74 + 56 | 0;
  i36 = i74 + 4 | 0;
  i37 = i74 + 8 | 0;
  i38 = i74 + 16 | 0;
  i39 = i74 + 20 | 0;
  i40 = i74 + 24 | 0;
  i41 = i74 + 32 | 0;
  i42 = i74 + 36 | 0;
  i43 = i74 + 40 | 0;
  i44 = i73 + 16 | 0;
  i45 = i73 + 32 | 0;
  i46 = i73 + 4 | 0;
  i47 = i73 + 20 | 0;
  i48 = i73 + 36 | 0;
  i49 = i73 + 8 | 0;
  i50 = i73 + 24 | 0;
  i51 = i73 + 40 | 0;
  f7 = Math_fround(3402823469999999843913219.0e14);
  f2 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  i52 = 0;
  i1 = 0;
  do {
   i10 = i65 + (i52 << 4) | 0;
   f20 = Math_fround(HEAPF32[i10 >> 2]);
   i11 = i65 + (i52 << 4) + 4 | 0;
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   i12 = i65 + (i52 << 4) + 8 | 0;
   f22 = Math_fround(HEAPF32[i12 >> 2]);
   i4 = i65 + (i52 << 4) + 12 | 0;
   i13 = HEAP32[i4 >> 2] | 0;
   f55 = Math_fround(HEAPF32[i17 >> 2]);
   f56 = Math_fround(HEAPF32[i34 >> 2]);
   f55 = Math_fround(f20 - f55);
   f56 = Math_fround(f21 - f56);
   f57 = Math_fround(f22 - Math_fround(HEAPF32[i35 >> 2]));
   f29 = Math_fround(f55 * Math_fround(HEAPF32[i74 >> 2]));
   f29 = Math_fround(f29 + Math_fround(f56 * Math_fround(HEAPF32[i36 >> 2])));
   f29 = Math_fround(f29 + Math_fround(f57 * Math_fround(HEAPF32[i37 >> 2])));
   f33 = Math_fround(f55 * Math_fround(HEAPF32[i38 >> 2]));
   f33 = Math_fround(f33 + Math_fround(f56 * Math_fround(HEAPF32[i39 >> 2])));
   f33 = Math_fround(f33 + Math_fround(f57 * Math_fround(HEAPF32[i40 >> 2])));
   f55 = Math_fround(f55 * Math_fround(HEAPF32[i41 >> 2]));
   f56 = Math_fround(f55 + Math_fround(f56 * Math_fround(HEAPF32[i42 >> 2])));
   f57 = Math_fround(f56 + Math_fround(f57 * Math_fround(HEAPF32[i43 >> 2])));
   f56 = Math_fround(f29 * Math_fround(HEAPF32[i73 >> 2]));
   f56 = Math_fround(f56 + Math_fround(f33 * Math_fround(HEAPF32[i44 >> 2])));
   f56 = Math_fround(f56 + Math_fround(f57 * Math_fround(HEAPF32[i45 >> 2])));
   f55 = Math_fround(f29 * Math_fround(HEAPF32[i46 >> 2]));
   f55 = Math_fround(f55 + Math_fround(f33 * Math_fround(HEAPF32[i47 >> 2])));
   f55 = Math_fround(f55 + Math_fround(f57 * Math_fround(HEAPF32[i48 >> 2])));
   f29 = Math_fround(f29 * Math_fround(HEAPF32[i49 >> 2]));
   f33 = Math_fround(f29 + Math_fround(f33 * Math_fround(HEAPF32[i50 >> 2])));
   f57 = Math_fround(f33 + Math_fround(f57 * Math_fround(HEAPF32[i51 >> 2])));
   HEAPF32[i10 >> 2] = f56;
   HEAPF32[i11 >> 2] = f55;
   HEAPF32[i12 >> 2] = f57;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   i14 = i64 + (i52 << 4) | 0;
   HEAPF32[i14 >> 2] = Math_fround(f57 - f63);
   i9 = i64 + (i52 << 4) + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   f55 = Math_fround(HEAPF32[i10 >> 2]);
   f56 = Math_fround(HEAPF32[i11 >> 2]);
   HEAP32[i12 >> 2] = i53;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   f7 = f7 < f55 ? f7 : f55;
   f2 = f2 < f56 ? f2 : f56;
   f8 = f8 > f55 ? f8 : f55;
   f3 = f3 > f56 ? f3 : f56;
   i4 = i66 + i52 | 0;
   L11 : do if (f23 > f57) {
    HEAP8[i4 >> 0] = 1;
    i9 = HEAP8[i69 >> 0] | 0;
    i6 = i9 & 255;
    f16 = Math_fround(HEAPF32[i10 >> 2]);
    f18 = Math_fround(HEAPF32[i11 >> 2]);
    if (!(i9 << 24 >> 24 == 0 | (f26 > f16 | f16 > f24 | (f27 > f18 | f18 > f25)))) {
     i5 = i6 + -1 | 0;
     f19 = Math_fround(HEAPF32[i67 + (i5 << 4) + 4 >> 2]);
     i9 = 0;
     i4 = 0;
     while (1) {
      f15 = f19;
      f19 = Math_fround(HEAPF32[i67 + (i9 << 4) + 4 >> 2]);
      if (f15 > f18 ^ f19 > f18) {
       f57 = Math_fround(HEAPF32[i67 + (i5 << 4) >> 2]);
       f55 = Math_fround(f19 - f15);
       f56 = Math_fround(f16 * f55);
       i5 = f55 > Math_fround(0.0);
       f57 = Math_fround(Math_fround(f55 * Math_fround(f57 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f18 - f15) * Math_fround(Math_fround(HEAPF32[i67 + (i9 << 4) >> 2]) - f57)));
       if ((i5 ? f57 : f56) >= (i5 ? f56 : f57)) {
        if ((i4 | 0) == 1) break L11;
        i4 = i4 + 1 | 0;
       }
      }
      i5 = i9 + 1 | 0;
      if (i5 >>> 0 >= i6 >>> 0) break; else {
       i77 = i9;
       i9 = i5;
       i5 = i77;
      }
     }
     if (i4) {
      i5 = HEAP32[i60 >> 2] | 0;
      i6 = HEAP32[i61 >> 2] | 0;
      i9 = HEAP32[i62 >> 2] | 0;
      i14 = HEAP32[i14 >> 2] | 0;
      i77 = HEAP32[i72 >> 2] | 0;
      HEAPF32[i71 + (i77 * 48 | 0) >> 2] = f20;
      HEAPF32[i71 + (i77 * 48 | 0) + 4 >> 2] = f21;
      HEAPF32[i71 + (i77 * 48 | 0) + 8 >> 2] = f22;
      HEAP32[i71 + (i77 * 48 | 0) + 12 >> 2] = i13;
      i77 = HEAP32[i72 >> 2] | 0;
      f29 = Math_fround(HEAPF32[i10 >> 2]);
      f33 = Math_fround(HEAPF32[i11 >> 2]);
      f57 = Math_fround(HEAPF32[i12 >> 2]);
      f55 = Math_fround(f29 * Math_fround(HEAPF32[i73 >> 2]));
      f55 = Math_fround(f55 + Math_fround(f33 * Math_fround(HEAPF32[i46 >> 2])));
      f55 = Math_fround(f55 + Math_fround(f57 * Math_fround(HEAPF32[i49 >> 2])));
      f56 = Math_fround(f29 * Math_fround(HEAPF32[i44 >> 2]));
      f56 = Math_fround(f56 + Math_fround(f33 * Math_fround(HEAPF32[i47 >> 2])));
      f56 = Math_fround(f56 + Math_fround(f57 * Math_fround(HEAPF32[i50 >> 2])));
      f29 = Math_fround(f29 * Math_fround(HEAPF32[i45 >> 2]));
      f33 = Math_fround(f29 + Math_fround(f33 * Math_fround(HEAPF32[i48 >> 2])));
      f57 = Math_fround(f33 + Math_fround(f57 * Math_fround(HEAPF32[i51 >> 2])));
      HEAPF32[i71 + (i77 * 48 | 0) + 16 >> 2] = f55;
      HEAPF32[i71 + (i77 * 48 | 0) + 20 >> 2] = f56;
      HEAPF32[i71 + (i77 * 48 | 0) + 24 >> 2] = f57;
      HEAPF32[i71 + (i77 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
      i77 = HEAP32[i72 >> 2] | 0;
      HEAP32[i72 >> 2] = i77 + 1;
      HEAP32[i71 + (i77 * 48 | 0) + 32 >> 2] = i5;
      HEAP32[i71 + (i77 * 48 | 0) + 36 >> 2] = i6;
      HEAP32[i71 + (i77 * 48 | 0) + 40 >> 2] = i9;
      HEAP32[i71 + (i77 * 48 | 0) + 44 >> 2] = i14;
      i1 = i1 + 1 | 0;
     }
    }
   } else HEAP8[i4 >> 0] = 0; while (0);
   i52 = i52 + 1 | 0;
   i5 = HEAP8[i68 >> 0] | 0;
   i4 = i5 & 255;
  } while (i52 >>> 0 < i4 >>> 0);
  f29 = Math_fround(f2 + Math_fround(-1.1920929e-07));
  f28 = Math_fround(f7 + Math_fround(-1.1920929e-07));
  f27 = Math_fround(f3 + Math_fround(1.1920929e-07));
  f26 = Math_fround(f8 + Math_fround(1.1920929e-07));
 }
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i76;
  return;
 }
 i40 = HEAP32[i59 + 40 >> 2] | 0;
 f56 = Math_fround(HEAPF32[i58 >> 2]);
 f25 = Math_fround(HEAPF32[i58 + 4 >> 2]);
 f57 = Math_fround(HEAPF32[i58 + 8 >> 2]);
 f23 = Math_fround(f56 * Math_fround(HEAPF32[i40 >> 2]));
 f23 = Math_fround(f23 + Math_fround(f25 * Math_fround(HEAPF32[i40 + 4 >> 2])));
 f23 = Math_fround(f23 + Math_fround(f57 * Math_fround(HEAPF32[i40 + 8 >> 2])));
 f24 = Math_fround(f56 * Math_fround(HEAPF32[i40 + 16 >> 2]));
 f24 = Math_fround(f24 + Math_fround(f25 * Math_fround(HEAPF32[i40 + 20 >> 2])));
 f24 = Math_fround(f24 + Math_fround(f57 * Math_fround(HEAPF32[i40 + 24 >> 2])));
 f56 = Math_fround(f56 * Math_fround(HEAPF32[i40 + 32 >> 2]));
 f25 = Math_fround(f56 + Math_fround(f25 * Math_fround(HEAPF32[i40 + 36 >> 2])));
 f57 = Math_fround(f25 + Math_fround(f57 * Math_fround(HEAPF32[i40 + 40 >> 2])));
 f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f24 * f24)) + Math_fround(f57 * f57)))));
 f23 = Math_fround(f23 * f25);
 f24 = Math_fround(f24 * f25);
 f25 = Math_fround(f57 * f25);
 f57 = Math_fround(HEAPF32[i60 >> 2]);
 f56 = Math_fround(HEAPF32[i61 >> 2]);
 f55 = Math_fround(HEAPF32[i62 >> 2]);
 f19 = Math_fround(f57 * Math_fround(HEAPF32[i74 >> 2]));
 i40 = i74 + 16 | 0;
 f19 = Math_fround(f19 + Math_fround(f56 * Math_fround(HEAPF32[i40 >> 2])));
 i41 = i74 + 32 | 0;
 f19 = Math_fround(f19 + Math_fround(f55 * Math_fround(HEAPF32[i41 >> 2])));
 i42 = i74 + 4 | 0;
 f20 = Math_fround(f57 * Math_fround(HEAPF32[i42 >> 2]));
 i43 = i74 + 20 | 0;
 f20 = Math_fround(f20 + Math_fround(f56 * Math_fround(HEAPF32[i43 >> 2])));
 i44 = i74 + 36 | 0;
 f20 = Math_fround(f20 + Math_fround(f55 * Math_fround(HEAPF32[i44 >> 2])));
 i45 = i74 + 8 | 0;
 f21 = Math_fround(f57 * Math_fround(HEAPF32[i45 >> 2]));
 i46 = i74 + 24 | 0;
 f21 = Math_fround(f21 + Math_fround(f56 * Math_fround(HEAPF32[i46 >> 2])));
 i47 = i74 + 40 | 0;
 f21 = Math_fround(f21 + Math_fround(f55 * Math_fround(HEAPF32[i47 >> 2])));
 i1 = HEAP8[i69 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i76;
  return;
 }
 i11 = i73 + 4 | 0;
 i12 = i73 + 8 | 0;
 i13 = i73 + 16 | 0;
 i14 = i73 + 20 | 0;
 i17 = i73 + 24 | 0;
 i34 = i73 + 32 | 0;
 i35 = i73 + 36 | 0;
 i36 = i73 + 40 | 0;
 i37 = i74 + 48 | 0;
 i38 = i74 + 52 | 0;
 i39 = i74 + 56 | 0;
 f22 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f24 * f20)) + Math_fround(f25 * f21));
 i4 = 0;
 while (1) {
  i10 = i5 & 255;
  f7 = Math_fround(HEAPF32[i67 + (i4 << 4) >> 2]);
  f8 = Math_fround(HEAPF32[i67 + (i4 << 4) + 4 >> 2]);
  L35 : do if (!(i5 << 24 >> 24 == 0 | (f28 > f7 | f7 > f26 | (f29 > f8 | f8 > f27)))) {
   i6 = i10 + -1 | 0;
   f3 = Math_fround(HEAPF32[i65 + (i6 << 4) + 4 >> 2]);
   i9 = 0;
   i5 = 0;
   while (1) {
    f2 = f3;
    f3 = Math_fround(HEAPF32[i65 + (i9 << 4) + 4 >> 2]);
    if (f2 > f8 ^ f3 > f8) {
     f33 = Math_fround(HEAPF32[i65 + (i6 << 4) >> 2]);
     f16 = Math_fround(f3 - f2);
     f18 = Math_fround(f7 * f16);
     i77 = f16 > Math_fround(0.0);
     f33 = Math_fround(Math_fround(f16 * Math_fround(f33 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f8 - f2) * Math_fround(Math_fround(HEAPF32[i65 + (i9 << 4) >> 2]) - f33)));
     if ((i77 ? f33 : f18) >= (i77 ? f18 : f33)) {
      if ((i5 | 0) == 1) break L35;
      i5 = i5 + 1 | 0;
     }
    }
    i6 = i9 + 1 | 0;
    if (i6 >>> 0 >= i10 >>> 0) break; else {
     i77 = i9;
     i9 = i6;
     i6 = i77;
    }
   }
   if (i5) {
    f2 = Math_fround(HEAPF32[i67 + (i4 << 4) + 8 >> 2]);
    f16 = Math_fround(f7 * Math_fround(HEAPF32[i73 >> 2]));
    f16 = Math_fround(f16 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])));
    f16 = Math_fround(f16 + Math_fround(f2 * Math_fround(HEAPF32[i12 >> 2])));
    f18 = Math_fround(f7 * Math_fround(HEAPF32[i13 >> 2]));
    f18 = Math_fround(f18 + Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2])));
    f18 = Math_fround(f18 + Math_fround(f2 * Math_fround(HEAPF32[i17 >> 2])));
    f78 = Math_fround(f7 * Math_fround(HEAPF32[i34 >> 2]));
    f78 = Math_fround(f78 + Math_fround(f8 * Math_fround(HEAPF32[i35 >> 2])));
    f2 = Math_fround(f78 + Math_fround(f2 * Math_fround(HEAPF32[i36 >> 2])));
    f78 = Math_fround(HEAPF32[i37 >> 2]);
    f33 = Math_fround(HEAPF32[i38 >> 2]);
    f15 = Math_fround(HEAPF32[i39 >> 2]);
    f3 = Math_fround(f16 * Math_fround(HEAPF32[i74 >> 2]));
    f3 = Math_fround(f3 + Math_fround(f18 * Math_fround(HEAPF32[i40 >> 2])));
    f3 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i41 >> 2])));
    f7 = Math_fround(f16 * Math_fround(HEAPF32[i42 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f18 * Math_fround(HEAPF32[i43 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f2 * Math_fround(HEAPF32[i44 >> 2])));
    f8 = Math_fround(f16 * Math_fround(HEAPF32[i45 >> 2]));
    f8 = Math_fround(f8 + Math_fround(f18 * Math_fround(HEAPF32[i46 >> 2])));
    f3 = Math_fround(f78 + f3);
    f7 = Math_fround(f33 + f7);
    f8 = Math_fround(f15 + Math_fround(f8 + Math_fround(f2 * Math_fround(HEAPF32[i47 >> 2]))));
    f15 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * Math_fround(f30 - f3)) + Math_fround(f24 * Math_fround(f31 - f7))) + Math_fround(f25 * Math_fround(f32 - f8))) / f22);
    if (!(f15 > Math_fround(HEAPF32[i70 >> 2]))) {
     f3 = Math_fround(f3 + Math_fround(f19 * f15));
     f33 = Math_fround(f7 + Math_fround(f20 * f15));
     f78 = Math_fround(Math_fround(f21 * f15) + f8);
     i1 = HEAP32[i72 >> 2] | 0;
     HEAPF32[i71 + (i1 * 48 | 0) >> 2] = f3;
     HEAPF32[i71 + (i1 * 48 | 0) + 4 >> 2] = f33;
     HEAPF32[i71 + (i1 * 48 | 0) + 8 >> 2] = f78;
     HEAPF32[i71 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
     i1 = HEAP32[i72 >> 2] | 0;
     HEAPF32[i71 + (i1 * 48 | 0) + 16 >> 2] = f16;
     HEAPF32[i71 + (i1 * 48 | 0) + 20 >> 2] = f18;
     HEAPF32[i71 + (i1 * 48 | 0) + 24 >> 2] = f2;
     HEAPF32[i71 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
     i1 = HEAP32[i72 >> 2] | 0;
     HEAP32[i72 >> 2] = i1 + 1;
     HEAPF32[i71 + (i1 * 48 | 0) + 32 >> 2] = f57;
     HEAPF32[i71 + (i1 * 48 | 0) + 36 >> 2] = f56;
     HEAPF32[i71 + (i1 * 48 | 0) + 40 >> 2] = f55;
     HEAPF32[i71 + (i1 * 48 | 0) + 44 >> 2] = f15;
     i1 = HEAP8[i69 >> 0] | 0;
    }
   }
  } while (0);
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= (i1 & 255) >>> 0) break;
  i5 = HEAP8[i68 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i76;
  return;
 }
 i4 = HEAP8[i68 >> 0] | 0;
 if (!(i4 << 24 >> 24)) {
  STACKTOP = i76;
  return;
 }
 i10 = i73 + 4 | 0;
 i11 = i73 + 8 | 0;
 i12 = i73 + 16 | 0;
 i13 = i73 + 20 | 0;
 i14 = i73 + 24 | 0;
 i17 = i73 + 32 | 0;
 i34 = i73 + 36 | 0;
 i35 = i73 + 40 | 0;
 i36 = i74 + 56 | 0;
 i37 = i74 + 52 | 0;
 i38 = i74 + 48 | 0;
 i6 = i1;
 i5 = i1;
 i1 = (i4 & 255) + -1 | 0;
 i9 = 0;
 while (1) {
  if (!(HEAP8[i66 + i9 >> 0] | 0)) if (!(HEAP8[i66 + i1 >> 0] | 0)) i1 = i6; else i75 = 40; else i75 = 40;
  if ((i75 | 0) == 40) {
   i75 = 0;
   f25 = Math_fround(HEAPF32[i65 + (i9 << 4) >> 2]);
   f26 = Math_fround(HEAPF32[i65 + (i9 << 4) + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i65 + (i1 << 4) >> 2]);
   f28 = Math_fround(HEAPF32[i65 + (i1 << 4) + 4 >> 2]);
   f29 = Math_fround(f63 + Math_fround(HEAPF32[i64 + (i9 << 4) >> 2]));
   f30 = f25 < f27 ? f25 : f27;
   f31 = f26 < f28 ? f26 : f28;
   f32 = f25 > f27 ? f25 : f27;
   f33 = f26 > f28 ? f26 : f28;
   if (!(i6 << 24 >> 24)) i1 = 0; else {
    f23 = Math_fround(f27 - f25);
    f24 = Math_fround(f28 - f26);
    f22 = Math_fround(Math_fround(f63 + Math_fround(HEAPF32[i64 + (i1 << 4) >> 2])) - f29);
    i4 = i5;
    i1 = (i5 & 255) + -1 | 0;
    i5 = 0;
    while (1) {
     f8 = Math_fround(HEAPF32[i67 + (i5 << 4) >> 2]);
     f15 = Math_fround(HEAPF32[i67 + (i5 << 4) + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i67 + (i1 << 4) >> 2]);
     f2 = Math_fround(HEAPF32[i67 + (i1 << 4) + 4 >> 2]);
     if (!(((f8 < f16 ? f8 : f16) > f32 ? 1 : f30 > (f8 > f16 ? f8 : f16)) | ((f15 < f2 ? f15 : f2) > f33 ? 1 : f31 > (f15 > f2 ? f15 : f2)))) {
      f3 = Math_fround(Math_fround(Math_fround(f8 - f25) * Math_fround(f2 - f26)) - Math_fround(Math_fround(f15 - f26) * Math_fround(f16 - f25)));
      f7 = Math_fround(Math_fround(Math_fround(f8 - f27) * Math_fround(f2 - f28)) - Math_fround(Math_fround(f15 - f28) * Math_fround(f16 - f27)));
      if (Math_fround(f3 * f7) < Math_fround(0.0)) if (Math_fround(Math_fround(Math_fround(Math_fround(f25 - f8) * Math_fround(f28 - f15)) - Math_fround(Math_fround(f27 - f8) * Math_fround(f26 - f15))) * Math_fround(Math_fround(Math_fround(f25 - f16) * Math_fround(f28 - f2)) - Math_fround(Math_fround(f27 - f16) * Math_fround(f26 - f2)))) < Math_fround(0.0)) {
       f21 = Math_fround(f3 / Math_fround(f7 - f3));
       f79 = Math_fround(f25 - Math_fround(f23 * f21));
       f20 = Math_fround(f26 - Math_fround(f24 * f21));
       f21 = Math_fround(f29 - Math_fround(f22 * f21));
       f15 = Math_fround(HEAPF32[i73 >> 2]);
       f8 = Math_fround(HEAPF32[i10 >> 2]);
       f2 = Math_fround(HEAPF32[i11 >> 2]);
       f18 = Math_fround(HEAPF32[i12 >> 2]);
       f16 = Math_fround(HEAPF32[i13 >> 2]);
       f3 = Math_fround(HEAPF32[i14 >> 2]);
       f78 = Math_fround(HEAPF32[i17 >> 2]);
       f19 = Math_fround(HEAPF32[i34 >> 2]);
       f7 = Math_fround(HEAPF32[i35 >> 2]);
       f8 = Math_fround(Math_fround(f15 * f79) + Math_fround(f8 * f20));
       f15 = Math_fround(f8 + Math_fround(f21 * f2));
       f16 = Math_fround(Math_fround(f79 * f18) + Math_fround(f20 * f16));
       f18 = Math_fround(f16 + Math_fround(f21 * f3));
       f19 = Math_fround(Math_fround(f79 * f78) + Math_fround(f20 * f19));
       f20 = Math_fround(f19 + Math_fround(f21 * f7));
       f21 = Math_fround(f21 - f63);
       if (!(f21 > Math_fround(HEAPF32[i70 >> 2]))) {
        f79 = Math_fround(HEAPF32[i36 >> 2]);
        f80 = Math_fround(f15 * Math_fround(HEAPF32[i45 >> 2]));
        f80 = Math_fround(f80 + Math_fround(f18 * Math_fround(HEAPF32[i46 >> 2])));
        f80 = Math_fround(f79 + Math_fround(f80 + Math_fround(f20 * Math_fround(HEAPF32[i47 >> 2]))));
        f79 = Math_fround(HEAPF32[i37 >> 2]);
        f81 = Math_fround(f15 * Math_fround(HEAPF32[i42 >> 2]));
        f81 = Math_fround(f81 + Math_fround(f18 * Math_fround(HEAPF32[i43 >> 2])));
        f81 = Math_fround(f79 + Math_fround(f81 + Math_fround(f20 * Math_fround(HEAPF32[i44 >> 2]))));
        f79 = Math_fround(HEAPF32[i38 >> 2]);
        f78 = Math_fround(f15 * Math_fround(HEAPF32[i74 >> 2]));
        f18 = Math_fround(f78 + Math_fround(f18 * Math_fround(HEAPF32[i40 >> 2])));
        f18 = Math_fround(f79 + Math_fround(f18 + Math_fround(f20 * Math_fround(HEAPF32[i41 >> 2]))));
        f79 = Math_fround(f19 + Math_fround(f63 * f7));
        f78 = Math_fround(f16 + Math_fround(f63 * f3));
        f20 = Math_fround(f8 + Math_fround(f63 * f2));
        i4 = HEAP32[i72 >> 2] | 0;
        HEAPF32[i71 + (i4 * 48 | 0) >> 2] = f18;
        HEAPF32[i71 + (i4 * 48 | 0) + 4 >> 2] = f81;
        HEAPF32[i71 + (i4 * 48 | 0) + 8 >> 2] = f80;
        HEAPF32[i71 + (i4 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
        i4 = HEAP32[i72 >> 2] | 0;
        HEAPF32[i71 + (i4 * 48 | 0) + 16 >> 2] = f20;
        HEAPF32[i71 + (i4 * 48 | 0) + 20 >> 2] = f78;
        HEAPF32[i71 + (i4 * 48 | 0) + 24 >> 2] = f79;
        HEAPF32[i71 + (i4 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
        i4 = HEAP32[i72 >> 2] | 0;
        HEAP32[i72 >> 2] = i4 + 1;
        HEAPF32[i71 + (i4 * 48 | 0) + 32 >> 2] = f57;
        HEAPF32[i71 + (i4 * 48 | 0) + 36 >> 2] = f56;
        HEAPF32[i71 + (i4 * 48 | 0) + 40 >> 2] = f55;
        HEAPF32[i71 + (i4 * 48 | 0) + 44 >> 2] = f21;
        i4 = HEAP8[i69 >> 0] | 0;
       }
      }
     }
     i1 = i5 + 1 | 0;
     if (i1 >>> 0 < (i4 & 255) >>> 0) {
      i77 = i5;
      i5 = i1;
      i1 = i77;
     } else {
      i5 = i4;
      i1 = i4;
      break;
     }
    }
   }
  }
  i4 = i9 + 1 | 0;
  if (i4 >>> 0 < (HEAPU8[i68 >> 0] | 0) >>> 0) {
   i77 = i9;
   i6 = i1;
   i9 = i4;
   i1 = i77;
  } else break;
 }
 STACKTOP = i76;
 return;
}

function __ZN5physx11RTreeCooker18buildFromTrianglesERNS_2Gu5RTreeEPKNS_6PxVec3EjPKtPKjjRNS_6shdfnd5ArrayIjNSB_19ReflectionAllocatorIjEEEEPNS0_13RemapCallbackEfNS_17PxMeshCookingHint4EnumE(i56, i20, i1, i9, i10, i50, i45, i53, f51, i27) {
 i56 = i56 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i50 = i50 | 0;
 i45 = i45 | 0;
 i53 = i53 | 0;
 f51 = Math_fround(f51);
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i61 + 296 | 0;
 i21 = i61 + 288 | 0;
 i22 = i61 + 284 | 0;
 i23 = i61 + 280 | 0;
 i58 = i61 + 268 | 0;
 i55 = i61 + 264 | 0;
 i47 = i61 + 252 | 0;
 i26 = i61 + 248 | 0;
 i48 = i61 + 236 | 0;
 i28 = i61 + 232 | 0;
 i42 = i61 + 220 | 0;
 i29 = i61 + 216 | 0;
 i44 = i61 + 204 | 0;
 i30 = i61 + 200 | 0;
 i46 = i61 + 188 | 0;
 i31 = i61 + 184 | 0;
 i34 = i61 + 172 | 0;
 i32 = i61 + 168 | 0;
 i36 = i61 + 160 | 0;
 i38 = i61 + 152 | 0;
 i40 = i61 + 144 | 0;
 i25 = i61 + 116 | 0;
 i24 = i61 + 32 | 0;
 i57 = i61 + 92 | 0;
 i52 = i61 + 64 | 0;
 i54 = i61 + 352 | 0;
 i60 = i61 + 104 | 0;
 i11 = i61;
 HEAP32[i60 >> 2] = 0;
 i12 = i60 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i59 = i60 + 8 | 0;
 HEAP32[i59 >> 2] = 0;
 i41 = (i50 | 0) == 0;
 if (i41) {
  i43 = 2139095039;
  i39 = 2139095039;
  i37 = 2139095039;
  i35 = -8388609;
  i33 = -8388609;
  i20 = -8388609;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i60, i50);
  i13 = i11 + 4 | 0;
  i14 = i11 + 8 | 0;
  i15 = i11 + 12 | 0;
  i16 = i11 + 16 | 0;
  i17 = i11 + 20 | 0;
  i18 = i11 + 24 | 0;
  i19 = i11 + 28 | 0;
  if (!i9) {
   i5 = 2139095039;
   i3 = 2139095039;
   i1 = 2139095039;
   i6 = -8388609;
   i4 = -8388609;
   i2 = -8388609;
   i8 = 0;
   while (1) {
    i7 = i8 * 3 | 0;
    i39 = HEAP32[i10 + (i7 << 2) >> 2] | 0;
    i43 = HEAP32[i10 + (i7 + 1 << 2) >> 2] | 0;
    i7 = HEAP32[i10 + (i7 + 2 << 2) >> 2] | 0;
    f73 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) >> 2]);
    f72 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) + 4 >> 2]);
    f71 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) + 8 >> 2]);
    f70 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) >> 2]);
    f69 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) + 4 >> 2]);
    f68 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) + 8 >> 2]);
    f64 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) + 4 >> 2]);
    f62 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) + 8 >> 2]);
    f67 = f73 < f70 ? f73 : f70;
    f66 = f72 < f69 ? f72 : f69;
    f65 = f71 < f68 ? f71 : f68;
    f67 = Math_fround((f67 < f64 ? f67 : f64) + Math_fround(-.000500000024));
    f66 = Math_fround((f66 < f63 ? f66 : f63) + Math_fround(-.000500000024));
    f65 = Math_fround((f65 < f62 ? f65 : f62) + Math_fround(-.000500000024));
    f70 = f73 > f70 ? f73 : f70;
    f69 = f72 > f69 ? f72 : f69;
    f68 = f71 > f68 ? f71 : f68;
    f64 = Math_fround((f70 > f64 ? f70 : f64) + Math_fround(.000500000024));
    f63 = Math_fround((f69 > f63 ? f69 : f63) + Math_fround(.000500000024));
    f62 = Math_fround((f68 > f62 ? f68 : f62) + Math_fround(.000500000024));
    f68 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f69 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f70 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f68 < f67 ? f68 : f67, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f69 < f66 ? f69 : f66, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f70 < f65 ? f70 : f65, HEAP32[tempDoublePtr >> 2] | 0);
    f70 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f69 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f68 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f70 > f64 ? f70 : f64, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f69 > f63 ? f69 : f63, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f68 > f62 ? f68 : f62, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i11 >> 2] = f67;
    HEAPF32[i13 >> 2] = f66;
    HEAPF32[i14 >> 2] = f65;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    HEAPF32[i16 >> 2] = f64;
    HEAPF32[i17 >> 2] = f63;
    HEAPF32[i18 >> 2] = f62;
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    i1 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i59 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i43 = (HEAP32[i60 >> 2] | 0) + (i1 << 5) | 0;
     HEAP32[i43 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i43 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i43 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i43 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i43 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i43 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i43 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
     HEAP32[i43 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
     HEAP32[i12 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i60, i11) | 0;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i50 | 0)) {
     i43 = i7;
     i39 = i3;
     i37 = i5;
     i35 = i2;
     i33 = i4;
     i20 = i6;
     break;
    } else i1 = i7;
   }
  } else {
   i5 = 2139095039;
   i3 = 2139095039;
   i1 = 2139095039;
   i6 = -8388609;
   i4 = -8388609;
   i2 = -8388609;
   i8 = 0;
   while (1) {
    i7 = i8 * 3 | 0;
    i39 = HEAPU16[i9 + (i7 << 1) >> 1] | 0;
    i43 = HEAPU16[i9 + (i7 + 1 << 1) >> 1] | 0;
    i7 = HEAPU16[i9 + (i7 + 2 << 1) >> 1] | 0;
    f62 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) >> 2]);
    f63 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) + 4 >> 2]);
    f64 = Math_fround(HEAPF32[i20 + (i39 * 12 | 0) + 8 >> 2]);
    f65 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) >> 2]);
    f66 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) + 4 >> 2]);
    f67 = Math_fround(HEAPF32[i20 + (i43 * 12 | 0) + 8 >> 2]);
    f71 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) >> 2]);
    f72 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) + 4 >> 2]);
    f73 = Math_fround(HEAPF32[i20 + (i7 * 12 | 0) + 8 >> 2]);
    f68 = f62 < f65 ? f62 : f65;
    f69 = f63 < f66 ? f63 : f66;
    f70 = f64 < f67 ? f64 : f67;
    f68 = Math_fround((f68 < f71 ? f68 : f71) + Math_fround(-.000500000024));
    f69 = Math_fround((f69 < f72 ? f69 : f72) + Math_fround(-.000500000024));
    f70 = Math_fround((f70 < f73 ? f70 : f73) + Math_fround(-.000500000024));
    f65 = f62 > f65 ? f62 : f65;
    f66 = f63 > f66 ? f63 : f66;
    f67 = f64 > f67 ? f64 : f67;
    f71 = Math_fround((f65 > f71 ? f65 : f71) + Math_fround(.000500000024));
    f72 = Math_fround((f66 > f72 ? f66 : f72) + Math_fround(.000500000024));
    f73 = Math_fround((f67 > f73 ? f67 : f73) + Math_fround(.000500000024));
    f67 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f66 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f65 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f67 < f68 ? f67 : f68, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f66 < f69 ? f66 : f69, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f65 < f70 ? f65 : f70, HEAP32[tempDoublePtr >> 2] | 0);
    f65 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f66 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f67 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f65 > f71 ? f65 : f71, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f66 > f72 ? f66 : f72, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f67 > f73 ? f67 : f73, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i11 >> 2] = f68;
    HEAPF32[i13 >> 2] = f69;
    HEAPF32[i14 >> 2] = f70;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    HEAPF32[i16 >> 2] = f71;
    HEAPF32[i17 >> 2] = f72;
    HEAPF32[i18 >> 2] = f73;
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    i1 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i59 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i43 = (HEAP32[i60 >> 2] | 0) + (i1 << 5) | 0;
     HEAP32[i43 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i43 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i43 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i43 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i43 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i43 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i43 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
     HEAP32[i43 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
     HEAP32[i12 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i60, i11) | 0;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i50 | 0)) {
     i43 = i7;
     i39 = i3;
     i37 = i5;
     i35 = i2;
     i33 = i4;
     i20 = i6;
     break;
    } else i1 = i7;
   }
  }
 }
 i18 = HEAP32[i60 >> 2] | 0;
 HEAP32[i21 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i45, 0, i21);
 i1 = i50 + 1 | 0;
 i3 = i45 + 8 | 0;
 if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i45, i1);
 HEAP32[i22 >> 2] = 0;
 i17 = i45 + 4 | 0;
 if (!i41) {
  i2 = 0;
  do {
   i1 = HEAP32[i17 >> 2] | 0;
   if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[(HEAP32[i45 >> 2] | 0) + (i1 << 2) >> 2] = i2;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i45, i22) | 0;
   i2 = i2 + 1 | 0;
   HEAP32[i22 >> 2] = i2;
  } while ((i2 | 0) != (i50 | 0));
 }
 HEAP32[i23 >> 2] = -1412567295;
 i1 = HEAP32[i17 >> 2] | 0;
 if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i45 >> 2] | 0) + (i1 << 2) >> 2] = -1412567295;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i45, i23) | 0;
 HEAP32[i58 >> 2] = 0;
 i16 = i58 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i19 = i58 + 8 | 0;
 HEAP32[i19 >> 2] = 0;
 i15 = i50 << 1;
 if (i15 | 0) __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i58, i15);
 HEAP32[i55 >> 2] = 0;
 if (!i27) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i47 >> 2] = 0;
  HEAP32[i47 + 4 >> 2] = 0;
  i14 = i47 + 8 | 0;
  HEAP32[i14 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i47, i50, i26);
  HEAP32[i28 >> 2] = 0;
  HEAP32[i48 >> 2] = 0;
  HEAP32[i48 + 4 >> 2] = 0;
  i13 = i48 + 8 | 0;
  HEAP32[i13 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i48, i50, i28);
  HEAP32[i29 >> 2] = 0;
  HEAP32[i42 >> 2] = 0;
  HEAP32[i42 + 4 >> 2] = 0;
  i12 = i42 + 8 | 0;
  HEAP32[i12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i42, i50, i29);
  HEAP32[i30 >> 2] = 0;
  HEAP32[i44 >> 2] = 0;
  i29 = i44 + 4 | 0;
  HEAP32[i29 >> 2] = 0;
  i11 = i44 + 8 | 0;
  HEAP32[i11 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i44, i50, i30);
  HEAP32[i31 >> 2] = 0;
  HEAP32[i46 >> 2] = 0;
  i4 = i46 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  i10 = i46 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i46, i50, i31);
  HEAP32[i32 >> 2] = 0;
  HEAP32[i34 >> 2] = 0;
  i6 = i34 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  i9 = i34 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i34, i50, i32);
  i3 = HEAP32[i44 >> 2] | 0;
  i32 = i50 << 2;
  _memcpy(i3 | 0, HEAP32[i45 >> 2] | 0, i32 | 0) | 0;
  i5 = HEAP32[i46 >> 2] | 0;
  _memcpy(i5 | 0, HEAP32[i45 >> 2] | 0, i32 | 0) | 0;
  i8 = HEAP32[i34 >> 2] | 0;
  _memcpy(i8 | 0, HEAP32[i45 >> 2] | 0, i32 | 0) | 0;
  i34 = HEAP32[i29 >> 2] | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i36 + 4 >> 2] = i18;
  __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i3, i34, i36, i49, 32);
  if (i41) {
   i36 = HEAP32[i4 >> 2] | 0;
   HEAP32[i38 >> 2] = 1;
   HEAP32[i38 + 4 >> 2] = i18;
   __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i5, i36, i38, i49, 32);
  } else {
   i1 = HEAP32[i47 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (HEAP32[i3 + (i2 << 2) >> 2] << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i50 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i38 >> 2] = 1;
   HEAP32[i38 + 4 >> 2] = i18;
   __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i5, i1, i38, i49, 32);
   i1 = HEAP32[i48 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (HEAP32[i5 + (i2 << 2) >> 2] << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i50 | 0));
  }
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i40 >> 2] = 2;
  HEAP32[i40 + 4 >> 2] = i18;
  __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i8, i7, i40, i49, 32);
  i7 = i8;
  if (i41) {
   i5 = HEAP32[i42 >> 2] | 0;
   i6 = i5;
  } else {
   i3 = HEAP32[i42 >> 2] | 0;
   i1 = i3;
   i2 = 0;
   do {
    HEAP32[i3 + (HEAP32[i8 + (i2 << 2) >> 2] << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i50 | 0));
   i6 = i1;
   i5 = i3;
  }
  i42 = HEAP32[i45 >> 2] | 0;
  i4 = HEAP32[i44 >> 2] | 0;
  i3 = HEAP32[i46 >> 2] | 0;
  i2 = HEAP32[i47 >> 2] | 0;
  i1 = HEAP32[i48 >> 2] | 0;
  HEAP32[i49 >> 2] = i42;
  HEAP32[i49 + 8 >> 2] = i18;
  HEAP32[i49 + 20 >> 2] = i4;
  HEAP32[i49 + 24 >> 2] = i3;
  HEAP32[i49 + 28 >> 2] = i7;
  HEAP32[i49 + 32 >> 2] = i2;
  HEAP32[i49 + 36 >> 2] = i1;
  HEAP32[i49 + 40 >> 2] = i6;
  HEAP32[i49 + 48 >> 2] = i50;
  i48 = i50 >>> 0 > 1073741823 ? -1 : i50 << 2;
  i45 = __Znaj(i48) | 0;
  HEAP32[i49 + 12 >> 2] = i45;
  i46 = __Znaj(i48) | 0;
  HEAP32[i49 + 16 >> 2] = i46;
  i47 = i15 | 1;
  i47 = __Znaj(i47 >>> 0 > 1073741823 ? -1 : i47 << 2) | 0;
  HEAP32[i49 + 4 >> 2] = i47;
  i48 = __Znaj(i48) | 0;
  HEAP32[i49 + 44 >> 2] = i48;
  i41 = f51 < Math_fround(0.0);
  i44 = ~~Math_fround(f51 * Math_fround(15.0)) >>> 0;
  i44 = i41 ? 0 : i44;
  HEAP32[i49 + 52 >> 2] = i44 >>> 0 < 14 ? i44 : 14;
  __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i49, i42, i50, i58, i55, 0, 0);
  __ZdaPv(i45);
  __ZdaPv(i46);
  __ZdaPv(i47);
  __ZdaPv(i48);
  i50 = HEAP32[i9 >> 2] | 0;
  if (!((i8 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i8 | 0);
  }
  i50 = HEAP32[i10 >> 2] | 0;
  if (!((i3 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i3 | 0);
  }
  i50 = HEAP32[i11 >> 2] | 0;
  if (!((i4 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i4 | 0);
  }
  i50 = HEAP32[i12 >> 2] | 0;
  if (!((i5 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i5 | 0);
  }
  i50 = HEAP32[i13 >> 2] | 0;
  if (!((i1 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i1 | 0);
  }
  i50 = HEAP32[i14 >> 2] | 0;
  if (!((i2 | 0) == 0 | ((i50 | 0) < 0 | (i50 & 2147483647 | 0) == 0))) {
   i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i2 | 0);
  }
 } else {
  __ZN5physx12SubSortQuickC2EPjPKNS_10PxBounds3VEjf(i25, HEAP32[i45 >> 2] | 0, i18, i50, f51);
  __ZN5physx12SubSortQuick5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjRNS_10PxBounds3VEj(i25, HEAP32[i45 >> 2] | 0, (HEAP32[i17 >> 2] | 0) + -1 | 0, i58, i55, i24, 0);
  i50 = HEAP32[i25 + 20 >> 2] | 0;
  if ((i50 | 0) > -1 & (i50 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i25 + 12 >> 2] | 0;
   if (i1 | 0) {
    i50 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i50 >> 2] | 0) + 12 >> 2] | 0, i50 | 0, i1 | 0);
   }
  }
 }
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
 HEAP32[i57 >> 2] = 0;
 i14 = i57 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i57 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 i5 = HEAP32[i16 >> 2] | 0;
 if (!i5) i1 = 0; else {
  __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i57, i5);
  i6 = HEAP32[i58 >> 2] | 0;
  i7 = i52 + 24 | 0;
  i8 = i52 + 8 | 0;
  i9 = i52 + 4 | 0;
  i10 = i52 + 20 | 0;
  i11 = i52 + 16 | 0;
  i12 = i52 + 12 | 0;
  i2 = -1;
  i13 = 0;
  do {
   i1 = HEAP32[i6 + (i13 << 5) + 28 >> 2] | 0;
   i3 = (i1 | 0) > 0;
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i3 ? i4 | 1 : i4 & -2;
   i4 = HEAP32[i6 + (i13 << 5) + 24 >> 2] | 0;
   do if ((i4 | 0) == -1) {
    i2 = (i2 | 0) == -1 ? HEAP32[i14 >> 2] | 0 : i2;
    HEAPF32[i8 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i9 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i52 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i10 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i11 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAP32[i7 >> 2] = i2 * 28 | 1;
   } else {
    HEAP32[i52 >> 2] = HEAP32[i6 + (i13 << 5) >> 2];
    HEAP32[i9 >> 2] = HEAP32[i6 + (i13 << 5) + 4 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i6 + (i13 << 5) + 8 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i6 + (i13 << 5) + 12 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i6 + (i13 << 5) + 16 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i6 + (i13 << 5) + 20 >> 2];
    if (i3) {
     HEAP32[i7 >> 2] = i4;
     mftCall_viiii(HEAP32[(HEAP32[i53 >> 2] | 0) + 8 >> 2] | 0, i53 | 0, i7 | 0, i4 | 0, i1 | 0);
     break;
    } else {
     HEAP32[i7 >> 2] = i4 * 28;
     break;
    }
   } while (0);
   i1 = HEAP32[i14 >> 2] | 0;
   if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i50 = (HEAP32[i57 >> 2] | 0) + (i1 * 28 | 0) | 0;
    HEAP32[i50 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i50 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i50 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    HEAP32[i50 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
    HEAP32[i50 + 16 >> 2] = HEAP32[i52 + 16 >> 2];
    HEAP32[i50 + 20 >> 2] = HEAP32[i52 + 20 >> 2];
    HEAP32[i50 + 24 >> 2] = HEAP32[i52 + 24 >> 2];
    HEAP32[i14 >> 2] = i1 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i57, i52) | 0;
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i5 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 HEAP32[i56 + 32 >> 2] = 1065353216;
 HEAP32[i56 + 36 >> 2] = 1065353216;
 HEAP32[i56 + 40 >> 2] = 1065353216;
 HEAP32[i56 + 44 >> 2] = 1065353216;
 HEAP32[i56 + 76 >> 2] = i1;
 i1 = i1 >>> 2;
 i4 = i56 + 80 | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i54, (i1 * 112 | 0) + 131 | 0, gb + 731288 | 0, 845) | 0;
 if (!i1) i3 = 0; else {
  i3 = i1 + 131 & -128;
  HEAP32[i3 + -4 >> 2] = i3 - i1;
 }
 HEAP32[i56 + 92 >> 2] = i3;
 HEAP32[i56 >> 2] = i37;
 HEAP32[i56 + 4 >> 2] = i39;
 HEAP32[i56 + 8 >> 2] = i43;
 HEAP32[i56 + 12 >> 2] = 0;
 HEAP32[i56 + 16 >> 2] = i20;
 HEAP32[i56 + 20 >> 2] = i33;
 HEAP32[i56 + 24 >> 2] = i35;
 HEAP32[i56 + 28 >> 2] = 0;
 f71 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f71 = Math_fround(f71 - (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f72 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f72 = Math_fround(f72 - (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f73 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f72 = Math_fround(f72 * Math_fround(.0000152590219));
 f73 = Math_fround(Math_fround(f73 - (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.0000152590219));
 HEAPF32[i56 + 48 >> 2] = Math_fround(f71 * Math_fround(.0000152590219));
 HEAPF32[i56 + 52 >> 2] = f72;
 HEAPF32[i56 + 56 >> 2] = f73;
 HEAPF32[i56 + 60 >> 2] = Math_fround(0.0);
 HEAP32[i56 + 64 >> 2] = 4;
 HEAP32[i56 + 72 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i56 + 88 >> 2] = 0;
 HEAP32[i56 + 68 >> 2] = 1;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = HEAP32[i57 >> 2] | 0;
  i2 = 0;
  do {
   i56 = i2 << 2;
   HEAP32[i3 + (i2 * 112 | 0) + 48 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 12 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 64 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 16 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 80 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 20 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) >> 2] = HEAP32[i1 + (i56 * 28 | 0) >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 16 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 4 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 32 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 8 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 96 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 24 >> 2];
   i55 = i56 | 1;
   HEAP32[i3 + (i2 * 112 | 0) + 52 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 12 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 68 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 16 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 84 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 20 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 4 >> 2] = HEAP32[i1 + (i55 * 28 | 0) >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 20 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 4 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 36 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 8 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 100 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 24 >> 2];
   i55 = i56 | 2;
   HEAP32[i3 + (i2 * 112 | 0) + 56 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 12 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 72 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 16 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 88 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 20 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 8 >> 2] = HEAP32[i1 + (i55 * 28 | 0) >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 24 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 4 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 40 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 8 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 104 >> 2] = HEAP32[i1 + (i55 * 28 | 0) + 24 >> 2];
   i56 = i56 | 3;
   HEAP32[i3 + (i2 * 112 | 0) + 60 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 12 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 76 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 16 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 92 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 20 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 12 >> 2] = HEAP32[i1 + (i56 * 28 | 0) >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 28 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 4 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 44 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 8 >> 2];
   HEAP32[i3 + (i2 * 112 | 0) + 108 >> 2] = HEAP32[i1 + (i56 * 28 | 0) + 24 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i56 = HEAP32[i15 >> 2] | 0;
 if ((i56 | 0) > -1 & (i56 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i57 >> 2] | 0;
  if (i1 | 0) {
   i57 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i57 >> 2] | 0) + 12 >> 2] | 0, i57 | 0, i1 | 0);
  }
 }
 i57 = HEAP32[i19 >> 2] | 0;
 if ((i57 | 0) > -1 & (i57 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i58 >> 2] | 0;
  if (i1 | 0) {
   i58 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i58 >> 2] | 0) + 12 >> 2] | 0, i58 | 0, i1 | 0);
  }
 }
 i59 = HEAP32[i59 >> 2] | 0;
 if (!((i59 | 0) > -1 & (i59 & 2147483647 | 0) != 0)) {
  STACKTOP = i61;
  return;
 }
 i1 = HEAP32[i60 >> 2] | 0;
 if (!i1) {
  STACKTOP = i61;
  return;
 }
 i60 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i60 >> 2] | 0) + 12 >> 2] | 0, i60 | 0, i1 | 0);
 STACKTOP = i61;
 return;
}

function __ZN11AudioSource8TransferI14SafeBinaryReadEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 12 | 0;
 i10 = i14 + 8 | 0;
 i7 = i14 + 4 | 0;
 i8 = i14;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i12, i13);
 __ZN14SafeBinaryRead10SetVersionEi(i13, 4);
 if (!(__ZN14SafeBinaryRead16IsCurrentVersionEv(i13) | 0)) HEAP8[i12 + 548 >> 0] = 1;
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i13, 1) | 0) {
  i2 = i12 + 436 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867600 | 0, gb + 867612 | 0, i11, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrI9AudioClipE8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i3 = i12 + 497 | 0;
  i6 = HEAP32[gb + 36972 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867628 | 0, i6, i11, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i5 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break;
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i4 = i12 + 412 | 0;
  i5 = HEAP32[gb + 37012 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867642 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i3 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i9 = 24; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 24; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i9 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i4 = i12 + 408 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867651 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i3 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i9 = 35; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 35; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i9 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867659 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i4 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i9 = 46; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 46; else {
      HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i9 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
    if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867671 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i4 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i9 = 57; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 57; else {
      HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i9 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
    if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867683 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i5 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i9 = 68; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 68; else {
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i9 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
    if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  i3 = i12 + 420 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867699 | 0, i6, i11, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i13 + 16 | 0;
    i11 = HEAP32[i13 + 20 >> 2] | 0;
    i2 = i11 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break;
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  f16 = Math_fround(HEAPF32[i8 >> 2]);
  f15 = Math_fround(HEAPF32[i10 >> 2]);
  __ZN11AudioSource19CreateOpenALRolloffEfff(i12, f16, f15, Math_fround(HEAPF32[i7 >> 2]));
  HEAP32[i12 + 416 >> 2] = 2;
  STACKTOP = i14;
  return;
 }
 i2 = i12 + 440 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867704 | 0, gb + 863920 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i12 + 436 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867600 | 0, gb + 867612 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9AudioClipE8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 497 | 0;
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867628 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 412 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867642 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 110; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 110; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 110) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 408 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867651 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 121; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 121; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 121) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 420 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867699 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 421 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867726 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 422 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867731 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 423 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867742 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 388 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867764 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 168; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 168; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 168) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 392 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867773 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 179; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 179; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 179) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 396 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867786 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 190; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i9 = 190; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 190) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i6 = i12 + 400 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867798 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i4 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i4 >>> 0) i9 = 201; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i9 = 201;
     break;
    }
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 201) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 404 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867810 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i9 = 212; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i9 = 212;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 212) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i13 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 416 | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867816 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i9 = 223; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i9 = 223;
     break;
    }
    HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 223) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
   if (!(HEAP32[i13 >> 2] & 512)) break;
   HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i10 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 i3 = i12 + 424 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867828 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  L313 : do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i10 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i10 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L313;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 425 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867842 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  L325 : do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i10 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i10 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L325;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 426 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867864 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  L337 : do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i10 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i10 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L337;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i5 = i12 + 300 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867882 | 0, gb + 1034188 | 0, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i5, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i5 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867901 | 0, gb + 1034188 | 0, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i4, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 212 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867921 | 0, gb + 1034188 | 0, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i3, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i12 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 867939 | 0, gb + 1034188 | 0, i11, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i13, 2) | 0) {
  __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i5, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i6 >> 2])));
  __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i4, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i6 >> 2])));
  __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i3, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i6 >> 2])));
 }
 STACKTOP = i14;
 return;
}

function __ZNSt3__26locale5__impC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i10, i3, i2) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 HEAP32[i10 + 4 >> 2] = i2 + -1;
 HEAP32[i10 >> 2] = gb + 212688 + 8;
 i13 = i10 + 8 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i13 | 0, 28);
 i14 = __THREW__;
 __THREW__ = 0;
 if (i14 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i14 = i10 + 144 | 0;
  __THREW__ = 0;
  invoke_vii(fb + 4529 | 0, i14 | 0, i3 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  do if (i9 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_i(fb + 319 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   do if (i9 & 1) i11 = 11; else {
    i2 = HEAP32[i2 >> 2] | 0;
    if ((i2 | 0) != (i10 | 0)) {
     __THREW__ = 0;
     invoke_viii(fb + 1050 | 0, i13 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) {
      i11 = 11;
      break;
     }
    }
    i4 = i10 + 12 | 0;
    i3 = 0;
    while (1) {
     i2 = HEAP32[i13 >> 2] | 0;
     if (i3 >>> 0 >= (HEAP32[i4 >> 2] | 0) - i2 >> 2 >>> 0) break;
     i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i2);
     i3 = i3 + 1 | 0;
    }
    __THREW__ = 0;
    i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) i11 = 11; else {
     __THREW__ = 0;
     invoke_viii(fb + 1051 | 0, i2 | 0, i14 | 0, 0);
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) {
      i5 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      __ZdlPv(i2);
      i2 = i5;
      i5 = i13;
      break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4567 | 0, i10 | 0, i2 | 0);
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) i11 = 11; else {
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
      i9 = __THREW__;
      __THREW__ = 0;
      if (i9 & 1) i11 = 11; else {
       __THREW__ = 0;
       invoke_viii(fb + 1052 | 0, i2 | 0, i14 | 0, 0);
       i9 = __THREW__;
       __THREW__ = 0;
       if (i9 & 1) {
        i5 = ___cxa_find_matching_catch_3(0) | 0;
        getTempRet0() | 0;
        __ZdlPv(i2);
        i2 = i5;
        i5 = i13;
        break;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4568 | 0, i10 | 0, i2 | 0);
       i9 = __THREW__;
       __THREW__ = 0;
       if (i9 & 1) i11 = 11; else {
        __THREW__ = 0;
        i2 = invoke_ii(fb + 1570 | 0, 20) | 0;
        i9 = __THREW__;
        __THREW__ = 0;
        if (i9 & 1) i11 = 11; else {
         __THREW__ = 0;
         invoke_viii(fb + 1053 | 0, i2 | 0, i14 | 0, 0);
         i9 = __THREW__;
         __THREW__ = 0;
         if (i9 & 1) {
          i5 = ___cxa_find_matching_catch_3(0) | 0;
          getTempRet0() | 0;
          __ZdlPv(i2);
          i2 = i5;
          i5 = i13;
          break;
         }
         __THREW__ = 0;
         invoke_vii(fb + 4569 | 0, i10 | 0, i2 | 0);
         i9 = __THREW__;
         __THREW__ = 0;
         if (i9 & 1) i11 = 11; else {
          __THREW__ = 0;
          i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
          i9 = __THREW__;
          __THREW__ = 0;
          if (i9 & 1) i11 = 11; else {
           __THREW__ = 0;
           invoke_viii(fb + 1054 | 0, i2 | 0, i14 | 0, 0);
           i9 = __THREW__;
           __THREW__ = 0;
           if (i9 & 1) {
            i5 = ___cxa_find_matching_catch_3(0) | 0;
            getTempRet0() | 0;
            __ZdlPv(i2);
            i2 = i5;
            i5 = i13;
            break;
           }
           __THREW__ = 0;
           invoke_vii(fb + 4570 | 0, i10 | 0, i2 | 0);
           i9 = __THREW__;
           __THREW__ = 0;
           if (i9 & 1) i11 = 11; else {
            __THREW__ = 0;
            i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
            i9 = __THREW__;
            __THREW__ = 0;
            if (i9 & 1) i11 = 11; else {
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 212420 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4571 | 0, i10 | 0, i2 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             i9 = i14 + 11 | 0;
             __THREW__ = 0;
             invoke_viii(fb + 1055 | 0, i2 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0, 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             HEAP32[i2 >> 2] = gb + 212468 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4572 | 0, i10 | 0, i2 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 212564 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4573 | 0, i10 | 0, i2 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 212612 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4574 | 0, i10 | 0, i2 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 24) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             invoke_viii(fb + 1056 | 0, i2 | 0, i14 | 0, 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4575 | 0, i10 | 0, i2 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 28) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             invoke_viii(fb + 1057 | 0, i2 | 0, i14 | 0, 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4576 | 0, i10 | 0, i2 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i7 = invoke_ii(fb + 1570 | 0, 72) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i7 + 4 >> 2] = -1;
             HEAP32[i7 >> 2] = gb + 211860 + 8;
             i8 = i7 + 12 | 0;
             HEAP32[i8 >> 2] = 0;
             HEAP32[i8 + 4 >> 2] = 0;
             HEAP32[i8 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i8 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i6 = i7 + 24 | 0;
             HEAP32[i6 >> 2] = 0;
             HEAP32[i6 + 4 >> 2] = 0;
             HEAP32[i6 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i6 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i5 = i7 + 36 | 0;
             HEAP32[i5 >> 2] = 0;
             HEAP32[i5 + 4 >> 2] = 0;
             HEAP32[i5 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i5 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i3 = i7 + 48 | 0;
             HEAP32[i3 >> 2] = 0;
             HEAP32[i3 + 4 >> 2] = 0;
             HEAP32[i3 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4528 | 0, i7 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0);
             i2 = __THREW__;
             __THREW__ = 0;
             if (i2 & 1) {
              i2 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
              __ZdlPv(i7);
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4577 | 0, i10 | 0, i7 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i7 = invoke_ii(fb + 1570 | 0, 72) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i7 + 4 >> 2] = -1;
             HEAP32[i7 >> 2] = gb + 211916 + 8;
             i8 = i7 + 12 | 0;
             HEAP32[i8 >> 2] = 0;
             HEAP32[i8 + 4 >> 2] = 0;
             HEAP32[i8 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i8 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i6 = i7 + 24 | 0;
             HEAP32[i6 >> 2] = 0;
             HEAP32[i6 + 4 >> 2] = 0;
             HEAP32[i6 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i6 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i5 = i7 + 36 | 0;
             HEAP32[i5 >> 2] = 0;
             HEAP32[i5 + 4 >> 2] = 0;
             HEAP32[i5 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i5 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i3 = i7 + 48 | 0;
             HEAP32[i3 >> 2] = 0;
             HEAP32[i3 + 4 >> 2] = 0;
             HEAP32[i3 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4530 | 0, i7 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0);
             i2 = __THREW__;
             __THREW__ = 0;
             if (i2 & 1) {
              i2 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
              __ZdlPv(i7);
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4578 | 0, i10 | 0, i7 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i7 = invoke_ii(fb + 1570 | 0, 76) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i7 + 4 >> 2] = -1;
             HEAP32[i7 >> 2] = gb + 211972 + 8;
             i8 = i7 + 16 | 0;
             HEAP32[i8 >> 2] = 0;
             HEAP32[i8 + 4 >> 2] = 0;
             HEAP32[i8 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i8 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i6 = i7 + 28 | 0;
             HEAP32[i6 >> 2] = 0;
             HEAP32[i6 + 4 >> 2] = 0;
             HEAP32[i6 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i6 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i5 = i7 + 40 | 0;
             HEAP32[i5 >> 2] = 0;
             HEAP32[i5 + 4 >> 2] = 0;
             HEAP32[i5 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i5 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i3 = i7 + 52 | 0;
             HEAP32[i3 >> 2] = 0;
             HEAP32[i3 + 4 >> 2] = 0;
             HEAP32[i3 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4531 | 0, i7 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0);
             i2 = __THREW__;
             __THREW__ = 0;
             if (i2 & 1) {
              i2 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
              __ZdlPv(i7);
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4579 | 0, i10 | 0, i7 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i7 = invoke_ii(fb + 1570 | 0, 76) | 0;
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i7 + 4 >> 2] = -1;
             HEAP32[i7 >> 2] = gb + 212028 + 8;
             i8 = i7 + 16 | 0;
             HEAP32[i8 >> 2] = 0;
             HEAP32[i8 + 4 >> 2] = 0;
             HEAP32[i8 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i8 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i6 = i7 + 28 | 0;
             HEAP32[i6 >> 2] = 0;
             HEAP32[i6 + 4 >> 2] = 0;
             HEAP32[i6 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i6 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i5 = i7 + 40 | 0;
             HEAP32[i5 >> 2] = 0;
             HEAP32[i5 + 4 >> 2] = 0;
             HEAP32[i5 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i5 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             i3 = i7 + 52 | 0;
             HEAP32[i3 >> 2] = 0;
             HEAP32[i3 + 4 >> 2] = 0;
             HEAP32[i3 + 8 >> 2] = 0;
             i2 = 0;
             while (1) {
              if ((i2 | 0) == 3) break;
              HEAP32[i3 + (i2 << 2) >> 2] = 0;
              i2 = i2 + 1 | 0;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4533 | 0, i7 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i2 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
              __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
              __ZdlPv(i7);
              i5 = i13;
              break;
             }
             __THREW__ = 0;
             invoke_vii(fb + 4580 | 0, i10 | 0, i7 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 544) | 0;
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             i3 = i2 + 8 | 0;
             HEAP32[i2 >> 2] = gb + 209868 + 8;
             HEAP32[i3 >> 2] = gb + 209868 + 56;
             __THREW__ = 0;
             invoke_vii(fb + 4519 | 0, i2 + 12 | 0, i14 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             HEAP32[i2 >> 2] = gb + 211316 + 8;
             HEAP32[i3 >> 2] = gb + 211316 + 84;
             __THREW__ = 0;
             invoke_vii(fb + 4581 | 0, i10 | 0, i2 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 544) | 0;
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             i3 = i2 + 8 | 0;
             HEAP32[i2 >> 2] = gb + 209952 + 8;
             HEAP32[i3 >> 2] = gb + 209952 + 56;
             __THREW__ = 0;
             invoke_vii(fb + 4524 | 0, i2 + 12 | 0, i14 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             HEAP32[i2 >> 2] = gb + 211428 + 8;
             HEAP32[i3 >> 2] = gb + 211428 + 84;
             __THREW__ = 0;
             invoke_vii(fb + 4582 | 0, i10 | 0, i2 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 213148 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4527 | 0, i2 + 8 | 0, i14 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             HEAP32[i2 >> 2] = gb + 211588 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4583 | 0, i10 | 0, i2 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 213148 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4527 | 0, i2 + 8 | 0, i14 | 0);
             i9 = __THREW__;
             __THREW__ = 0;
             if (i9 & 1) {
              i5 = ___cxa_find_matching_catch_3(0) | 0;
              getTempRet0() | 0;
              __ZdlPv(i2);
              i2 = i5;
              i5 = i13;
              break;
             }
             HEAP32[i2 >> 2] = gb + 211612 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4584 | 0, i10 | 0, i2 | 0);
             i11 = __THREW__;
             __THREW__ = 0;
             if (i11 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
             i11 = __THREW__;
             __THREW__ = 0;
             if (i11 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 212356 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4585 | 0, i10 | 0, i2 | 0);
             i11 = __THREW__;
             __THREW__ = 0;
             if (i11 & 1) {
              i11 = 11;
              break;
             }
             __THREW__ = 0;
             i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
             i11 = __THREW__;
             __THREW__ = 0;
             if (i11 & 1) {
              i11 = 11;
              break;
             }
             HEAP32[i2 + 4 >> 2] = -1;
             HEAP32[i2 >> 2] = gb + 212388 + 8;
             __THREW__ = 0;
             invoke_vii(fb + 4586 | 0, i10 | 0, i2 | 0);
             i11 = __THREW__;
             __THREW__ = 0;
             if (i11 & 1) {
              i11 = 11;
              break;
             }
             return;
            }
           }
          }
         }
        }
       }
      }
     }
    }
   } while (0);
   if ((i11 | 0) == 11) {
    i2 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i4 = i10 + 12 | 0;
    i5 = i13;
   }
   ___cxa_begin_catch(i2 | 0) | 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i5 >> 2] | 0;
    if (i3 >>> 0 >= (HEAP32[i4 >> 2] | 0) - i2 >> 2 >>> 0) break;
    i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
    if (i2 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
    i3 = i3 + 1 | 0;
   }
   __THREW__ = 0;
   invoke_v(fb + 460 | 0);
   __THREW__ = 0;
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __THREW__ = 0;
   invoke_v(fb + 458 | 0);
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i1 = i2;
    break;
   }
  } while (0);
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i13);
 }
 ___resumeException(i1 | 0);
}

function __ZNK5physx2Gu12TriangleMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_11PxMeshScaleERKNS_9PxBounds3Eyfj(i22, i55, i54, i6, i5, i21, i1, f34, i2) {
 i22 = i22 | 0;
 i55 = i55 | 0;
 i54 = i54 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 f34 = Math_fround(f34);
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i53 + 376 | 0;
 i48 = i53 + 316 | 0;
 i4 = i53 + 443 | 0;
 i3 = i53 + 216 | 0;
 i2 = i53 + 280 | 0;
 i1 = i53 + 200 | 0;
 i42 = i53 + 244 | 0;
 i18 = i53 + 172 | 0;
 i37 = i53 + 160 | 0;
 i38 = i53 + 148 | 0;
 i39 = i53 + 136 | 0;
 i40 = i53 + 124 | 0;
 i41 = i53 + 112 | 0;
 i35 = i53 + 100 | 0;
 i36 = i53 + 442 | 0;
 i16 = i53 + 72 | 0;
 i17 = i53 + 441 | 0;
 i20 = i53 + 440 | 0;
 i32 = i53 + 60 | 0;
 i33 = i53 + 48 | 0;
 i43 = i53 + 36 | 0;
 i44 = i53 + 24 | 0;
 i45 = i53 + 12 | 0;
 i46 = i53;
 HEAPF32[i52 >> 2] = Math_fround(1.0);
 i47 = i52 + 4 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAPF32[i52 + 20 >> 2] = Math_fround(1.0);
 i47 = i52 + 24 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAPF32[i52 + 40 >> 2] = Math_fround(1.0);
 i47 = i52 + 44 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAPF32[i52 + 60 >> 2] = Math_fround(1.0);
 i47 = HEAP32[i22 + 20 >> 2] | 0;
 i19 = HEAP32[i22 + 16 >> 2] | 0;
 i49 = HEAP32[i22 + 24 >> 2] | 0;
 i50 = HEAP32[i22 + 28 >> 2] | 0;
 i51 = (HEAP8[i22 + 172 >> 0] & 2) != 0;
 if (!((i21 & 1073741824 | 0) == 0 & 0 == 0)) {
  f56 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f29 = Math_fround(HEAPF32[i5 >> 2]);
  f26 = Math_fround(f56 + f29);
  f24 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f30 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f27 = Math_fround(f24 + f30);
  f25 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f31 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f26 = Math_fround(f26 * Math_fround(.5));
  f27 = Math_fround(f27 * Math_fround(.5));
  f28 = Math_fround(Math_fround(f25 + f31) * Math_fround(.5));
  f29 = Math_fround(Math_fround(f56 - f29) * Math_fround(.5));
  f30 = Math_fround(Math_fround(f24 - f30) * Math_fround(.5));
  f31 = Math_fround(Math_fround(f25 - f31) * Math_fround(.5));
  HEAP32[i48 >> 2] = 1065353216;
  HEAP32[i48 + 4 >> 2] = 0;
  HEAP32[i48 + 8 >> 2] = 0;
  HEAP32[i48 + 12 >> 2] = 0;
  HEAP32[i48 + 16 >> 2] = 1065353216;
  HEAP32[i48 + 20 >> 2] = 0;
  HEAP32[i48 + 24 >> 2] = 0;
  HEAP32[i48 + 28 >> 2] = 0;
  HEAP32[i48 + 32 >> 2] = 1065353216;
  HEAPF32[i48 + 36 >> 2] = f26;
  HEAPF32[i48 + 40 >> 2] = f27;
  HEAPF32[i48 + 44 >> 2] = f28;
  HEAPF32[i48 + 48 >> 2] = f29;
  HEAPF32[i48 + 52 >> 2] = f30;
  HEAPF32[i48 + 56 >> 2] = f31;
  i33 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i53 + 444 | 0, i47 * 12 | 0, gb + 689458 | 0, 375) | 0;
  HEAP8[i4 >> 0] = 0;
  HEAP32[i2 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i54 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i54 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i54 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i54 + 28 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i54 + 32 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i54 + 36 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i54 + 40 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i54 + 44 >> 2];
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i1, i2);
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i32 = __ZN5physx2Gu18findOverlapOBBMeshERKNS0_3BoxERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i48, i22 + 32 | 0, i3, i6, i33, i47 * 3 | 0, 0, i4) | 0;
  if (!(f34 == Math_fround(0.0) | (i32 | 0) == 0)) {
   i1 = i42 + 12 | 0;
   i2 = i42 + 4 | 0;
   i3 = i42 + 16 | 0;
   i4 = i42 + 8 | 0;
   i5 = i42 + 20 | 0;
   i6 = i42 + 24 | 0;
   i7 = i42 + 28 | 0;
   i8 = i42 + 32 | 0;
   i9 = i18 + 4 | 0;
   i10 = i18 + 8 | 0;
   i11 = i18 + 12 | 0;
   i12 = i18 + 16 | 0;
   i13 = i18 + 20 | 0;
   i14 = i18 + 24 | 0;
   i15 = 0;
   do {
    __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(HEAP32[i33 + (i15 << 2) >> 2] | 0, i42, i49, i50, i54, i51);
    f59 = Math_fround(HEAPF32[i42 >> 2]);
    f26 = Math_fround(HEAPF32[i1 >> 2]);
    f29 = Math_fround(f59 + f26);
    f58 = Math_fround(HEAPF32[i2 >> 2]);
    f25 = Math_fround(HEAPF32[i3 >> 2]);
    f30 = Math_fround(f58 + f25);
    f28 = Math_fround(HEAPF32[i4 >> 2]);
    f57 = Math_fround(HEAPF32[i5 >> 2]);
    f31 = Math_fround(f28 + f57);
    f24 = Math_fround(HEAPF32[i6 >> 2]);
    f29 = Math_fround(f29 + f24);
    f56 = Math_fround(HEAPF32[i7 >> 2]);
    f30 = Math_fround(f30 + f56);
    f27 = Math_fround(HEAPF32[i8 >> 2]);
    f29 = Math_fround(f29 * Math_fround(.333333343));
    f30 = Math_fround(f30 * Math_fround(.333333343));
    f31 = Math_fround(Math_fround(f31 + f27) * Math_fround(.333333343));
    f26 = Math_fround(f59 - f26);
    f25 = Math_fround(f58 - f25);
    f57 = Math_fround(f28 - f57);
    f24 = Math_fround(f59 - f24);
    f56 = Math_fround(f58 - f56);
    f27 = Math_fround(f28 - f27);
    f28 = Math_fround(Math_fround(f25 * f27) - Math_fround(f57 * f56));
    f27 = Math_fround(Math_fround(f57 * f24) - Math_fround(f26 * f27));
    f24 = Math_fround(Math_fround(f26 * f56) - Math_fround(f25 * f24));
    f25 = Math_fround(Math_fround(f24 * f24) + Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)));
    if (f25 > Math_fround(0.0)) {
     f59 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25))));
     f26 = Math_fround(f24 * f59);
     f25 = Math_fround(f27 * f59);
     f24 = Math_fround(f28 * f59);
    } else {
     f26 = Math_fround(0.0);
     f25 = Math_fround(0.0);
     f24 = Math_fround(0.0);
    }
    i48 = __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -2004353024) | 0;
    f57 = Math_fround(f24 * f34);
    f58 = Math_fround(f25 * f34);
    f59 = Math_fround(f26 * f34);
    HEAPF32[i18 >> 2] = f29;
    HEAPF32[i9 >> 2] = f30;
    HEAPF32[i10 >> 2] = f31;
    f30 = Math_fround(f30 + f58);
    f56 = Math_fround(f31 + f59);
    HEAPF32[i11 >> 2] = Math_fround(f29 + f57);
    HEAPF32[i12 >> 2] = f30;
    HEAPF32[i13 >> 2] = f56;
    HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f58 * f58)) + Math_fround(f59 * f59)))) * Math_fround(.150000006));
    __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i48, i18) | 0;
    i15 = i15 + 1 | 0;
   } while ((i15 | 0) != (i32 | 0));
  }
  if (!((i21 & 8192 | 0) == 0 & 0 == 0)) {
   __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -65281) | 0;
   i1 = i55 + 100 | 0;
   i48 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i48 + 20 >> 2] | 0;
   __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i48 + 16 | 0, i2 + (i32 * 3 | 0) | 0);
   if (i32 | 0) {
    i3 = i42 + 12 | 0;
    i4 = i42 + 4 | 0;
    i5 = i42 + 8 | 0;
    i6 = i42 + 16 | 0;
    i7 = i42 + 20 | 0;
    i8 = i42 + 24 | 0;
    i9 = i42 + 28 | 0;
    i10 = i42 + 32 | 0;
    i11 = 0;
    i1 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 5) | 0;
    while (1) {
     __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(HEAP32[i33 + (i11 << 2) >> 2] | 0, i42, i49, i50, i54, i51);
     i44 = HEAP32[i4 >> 2] | 0;
     i45 = HEAP32[i5 >> 2] | 0;
     i46 = HEAP32[i3 >> 2] | 0;
     i47 = HEAP32[i6 >> 2] | 0;
     i48 = HEAP32[i7 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i1 + 4 >> 2] = i44;
     HEAP32[i1 + 8 >> 2] = i45;
     HEAP32[i1 + 12 >> 2] = -65281;
     HEAP32[i1 + 16 >> 2] = i46;
     HEAP32[i1 + 20 >> 2] = i47;
     HEAP32[i1 + 24 >> 2] = i48;
     HEAP32[i1 + 28 >> 2] = -65281;
     i48 = HEAP32[i6 >> 2] | 0;
     i47 = HEAP32[i7 >> 2] | 0;
     i46 = HEAP32[i8 >> 2] | 0;
     i45 = HEAP32[i9 >> 2] | 0;
     i44 = HEAP32[i10 >> 2] | 0;
     HEAP32[i1 + 32 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 36 >> 2] = i48;
     HEAP32[i1 + 40 >> 2] = i47;
     HEAP32[i1 + 44 >> 2] = -65281;
     HEAP32[i1 + 48 >> 2] = i46;
     HEAP32[i1 + 52 >> 2] = i45;
     HEAP32[i1 + 56 >> 2] = i44;
     HEAP32[i1 + 60 >> 2] = -65281;
     i44 = HEAP32[i9 >> 2] | 0;
     i45 = HEAP32[i10 >> 2] | 0;
     i46 = HEAP32[i42 >> 2] | 0;
     i47 = HEAP32[i4 >> 2] | 0;
     i48 = HEAP32[i5 >> 2] | 0;
     HEAP32[i1 + 64 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 68 >> 2] = i44;
     HEAP32[i1 + 72 >> 2] = i45;
     HEAP32[i1 + 76 >> 2] = -65281;
     HEAP32[i1 + 80 >> 2] = i46;
     HEAP32[i1 + 84 >> 2] = i47;
     HEAP32[i1 + 88 >> 2] = i48;
     HEAP32[i1 + 92 >> 2] = -65281;
     i11 = i11 + 1 | 0;
     if ((i11 | 0) == (i32 | 0)) break; else i1 = i1 + 96 | 0;
    }
   }
  }
  if (!((i21 & 131072 | 0) == 0 & 0 == 0)) {
   i1 = i22 + 168 | 0;
   if (!((HEAP32[i1 >> 2] | 0) == 0 | (i32 | 0) == 0)) {
    i2 = i41 + 4 | 0;
    i3 = i42 + 4 | 0;
    i4 = i41 + 8 | 0;
    i5 = i42 + 8 | 0;
    i6 = i42 + 24 | 0;
    i7 = i35 + 4 | 0;
    i8 = i42 + 28 | 0;
    i9 = i35 + 8 | 0;
    i10 = i42 + 32 | 0;
    i11 = i42 + 12 | 0;
    i12 = i39 + 4 | 0;
    i13 = i42 + 16 | 0;
    i14 = i39 + 8 | 0;
    i15 = i42 + 20 | 0;
    i16 = i40 + 4 | 0;
    i17 = i40 + 8 | 0;
    i18 = i37 + 4 | 0;
    i19 = i37 + 8 | 0;
    i20 = i38 + 4 | 0;
    i21 = i38 + 8 | 0;
    i23 = 0;
    do {
     i22 = HEAP32[i33 + (i23 << 2) >> 2] | 0;
     __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(i22, i42, i49, i50, i54, i51);
     i22 = HEAPU8[(HEAP32[i1 >> 2] | 0) + i22 >> 0] | 0;
     if (i22 & 8 | 0) {
      i48 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
      HEAP32[i37 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
      i48 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i37) | 0;
      HEAP32[i38 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i38) | 0;
     }
     if (i22 & 16 | 0) {
      i48 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
      HEAP32[i39 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
      i48 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i39) | 0;
      HEAP32[i40 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i40) | 0;
     }
     if (i22 & 32 | 0) {
      i48 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
      HEAP32[i41 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i48 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i41) | 0;
      HEAP32[i35 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i48, i35) | 0;
     }
     i23 = i23 + 1 | 0;
    } while ((i23 | 0) != (i32 | 0));
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i36, i33);
  STACKTOP = i53;
  return;
 }
 if (!(f34 == Math_fround(0.0) | (i47 | 0) == 0)) {
  i1 = i48 + 12 | 0;
  i2 = i48 + 4 | 0;
  i3 = i48 + 16 | 0;
  i4 = i48 + 8 | 0;
  i5 = i48 + 20 | 0;
  i6 = i48 + 24 | 0;
  i7 = i48 + 28 | 0;
  i8 = i48 + 32 | 0;
  i9 = i16 + 4 | 0;
  i10 = i16 + 8 | 0;
  i11 = i16 + 12 | 0;
  i12 = i16 + 16 | 0;
  i13 = i16 + 20 | 0;
  i14 = i16 + 24 | 0;
  i15 = 0;
  do {
   __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(i15, i48, i49, i50, i54, i51);
   f26 = Math_fround(HEAPF32[i48 >> 2]);
   f58 = Math_fround(HEAPF32[i1 >> 2]);
   f29 = Math_fround(f26 + f58);
   f56 = Math_fround(HEAPF32[i2 >> 2]);
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   f30 = Math_fround(f56 + f25);
   f28 = Math_fround(HEAPF32[i4 >> 2]);
   f57 = Math_fround(HEAPF32[i5 >> 2]);
   f31 = Math_fround(f28 + f57);
   f24 = Math_fround(HEAPF32[i6 >> 2]);
   f29 = Math_fround(f29 + f24);
   f59 = Math_fround(HEAPF32[i7 >> 2]);
   f30 = Math_fround(f30 + f59);
   f27 = Math_fround(HEAPF32[i8 >> 2]);
   f29 = Math_fround(f29 * Math_fround(.333333343));
   f30 = Math_fround(f30 * Math_fround(.333333343));
   f31 = Math_fround(Math_fround(f31 + f27) * Math_fround(.333333343));
   f58 = Math_fround(f26 - f58);
   f25 = Math_fround(f56 - f25);
   f57 = Math_fround(f28 - f57);
   f24 = Math_fround(f26 - f24);
   f59 = Math_fround(f56 - f59);
   f27 = Math_fround(f28 - f27);
   f28 = Math_fround(Math_fround(f25 * f27) - Math_fround(f57 * f59));
   f27 = Math_fround(Math_fround(f57 * f24) - Math_fround(f58 * f27));
   f24 = Math_fround(Math_fround(f58 * f59) - Math_fround(f25 * f24));
   f25 = Math_fround(Math_fround(f24 * f24) + Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)));
   if (f25 > Math_fround(0.0)) {
    f59 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25))));
    f26 = Math_fround(f24 * f59);
    f25 = Math_fround(f27 * f59);
    f24 = Math_fround(f28 * f59);
   } else {
    f26 = Math_fround(0.0);
    f25 = Math_fround(0.0);
    f24 = Math_fround(0.0);
   }
   i42 = __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -2004353024) | 0;
   f57 = Math_fround(f24 * f34);
   f58 = Math_fround(f25 * f34);
   f59 = Math_fround(f26 * f34);
   HEAPF32[i16 >> 2] = f29;
   HEAPF32[i9 >> 2] = f30;
   HEAPF32[i10 >> 2] = f31;
   f30 = Math_fround(f30 + f58);
   f56 = Math_fround(f31 + f59);
   HEAPF32[i11 >> 2] = Math_fround(f29 + f57);
   HEAPF32[i12 >> 2] = f30;
   HEAPF32[i13 >> 2] = f56;
   HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f58 * f58)) + Math_fround(f59 * f59)))) * Math_fround(.150000006));
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i42, i16) | 0;
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i47 | 0));
 }
 if (!((i21 & 8192 | 0) == 0 & 0 == 0)) {
  __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -65281) | 0;
  i13 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i19 * 12 | 0, gb + 689458 | 0, 480) | 0;
  if (i19 | 0) {
   i1 = i54 + 4 | 0;
   i2 = i54 + 8 | 0;
   i3 = i54 + 12 | 0;
   i4 = i54 + 16 | 0;
   i5 = i54 + 20 | 0;
   i6 = i54 + 24 | 0;
   i7 = i54 + 28 | 0;
   i8 = i54 + 32 | 0;
   i9 = i54 + 36 | 0;
   i10 = i54 + 40 | 0;
   i11 = i54 + 44 | 0;
   i12 = 0;
   do {
    f59 = Math_fround(HEAPF32[i49 + (i12 * 12 | 0) >> 2]);
    f58 = Math_fround(f59 * Math_fround(HEAPF32[i54 >> 2]));
    f57 = Math_fround(f59 * Math_fround(HEAPF32[i1 >> 2]));
    f59 = Math_fround(f59 * Math_fround(HEAPF32[i2 >> 2]));
    f56 = Math_fround(HEAPF32[i49 + (i12 * 12 | 0) + 4 >> 2]);
    f31 = Math_fround(f56 * Math_fround(HEAPF32[i3 >> 2]));
    f34 = Math_fround(f56 * Math_fround(HEAPF32[i4 >> 2]));
    f31 = Math_fround(f58 + f31);
    f34 = Math_fround(f57 + f34);
    f56 = Math_fround(f59 + Math_fround(f56 * Math_fround(HEAPF32[i5 >> 2])));
    f59 = Math_fround(HEAPF32[i49 + (i12 * 12 | 0) + 8 >> 2]);
    f57 = Math_fround(f59 * Math_fround(HEAPF32[i6 >> 2]));
    f58 = Math_fround(f59 * Math_fround(HEAPF32[i7 >> 2]));
    f57 = Math_fround(f31 + f57);
    f58 = Math_fround(f34 + f58);
    f59 = Math_fround(f56 + Math_fround(f59 * Math_fround(HEAPF32[i8 >> 2])));
    f57 = Math_fround(f57 + Math_fround(HEAPF32[i9 >> 2]));
    f58 = Math_fround(f58 + Math_fround(HEAPF32[i10 >> 2]));
    f59 = Math_fround(f59 + Math_fround(HEAPF32[i11 >> 2]));
    HEAPF32[i13 + (i12 * 12 | 0) >> 2] = f57;
    HEAPF32[i13 + (i12 * 12 | 0) + 4 >> 2] = f58;
    HEAPF32[i13 + (i12 * 12 | 0) + 8 >> 2] = f59;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) != (i19 | 0));
  }
  i42 = i55 + 100 | 0;
  i41 = HEAP32[i42 >> 2] | 0;
  i1 = HEAP32[i41 + 20 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i41 + 16 | 0, i1 + (i47 * 3 | 0) | 0);
  i1 = (HEAP32[(HEAP32[i42 >> 2] | 0) + 16 >> 2] | 0) + (i1 << 5) | 0;
  if (i47 | 0) {
   i3 = i48 + 4 | 0;
   i4 = i48 + 8 | 0;
   i5 = i48 + 12 | 0;
   i6 = i48 + 16 | 0;
   i7 = i48 + 20 | 0;
   i8 = i48 + 24 | 0;
   i9 = i48 + 28 | 0;
   i10 = i48 + 32 | 0;
   if (i51) {
    i2 = 0;
    while (1) {
     i42 = i2 * 3 | 0;
     i38 = HEAPU16[i50 + (i42 << 1) >> 1] | 0;
     i41 = HEAPU16[i50 + (i42 + 1 << 1) >> 1] | 0;
     i42 = HEAPU16[i50 + (i42 + 2 << 1) >> 1] | 0;
     i36 = HEAP32[i13 + (i38 * 12 | 0) >> 2] | 0;
     i37 = HEAP32[i13 + (i38 * 12 | 0) + 4 >> 2] | 0;
     i38 = HEAP32[i13 + (i38 * 12 | 0) + 8 >> 2] | 0;
     i39 = HEAP32[i13 + (i41 * 12 | 0) >> 2] | 0;
     i40 = HEAP32[i13 + (i41 * 12 | 0) + 4 >> 2] | 0;
     i41 = HEAP32[i13 + (i41 * 12 | 0) + 8 >> 2] | 0;
     i23 = HEAP32[i13 + (i42 * 12 | 0) >> 2] | 0;
     i35 = HEAP32[i13 + (i42 * 12 | 0) + 4 >> 2] | 0;
     i42 = HEAP32[i13 + (i42 * 12 | 0) + 8 >> 2] | 0;
     HEAP32[i48 >> 2] = i36;
     HEAP32[i3 >> 2] = i37;
     HEAP32[i4 >> 2] = i38;
     HEAP32[i5 >> 2] = i39;
     HEAP32[i6 >> 2] = i40;
     HEAP32[i7 >> 2] = i41;
     HEAP32[i8 >> 2] = i23;
     HEAP32[i9 >> 2] = i35;
     HEAP32[i10 >> 2] = i42;
     i42 = (((mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 48 >> 2] | 0, i22 | 0, i2 | 0) | 0) & 65535) % 12 | 0) & 65535;
     i42 = HEAP32[gb + 94052 + (i42 << 2) >> 2] | 0;
     HEAP32[i1 >> 2] = i36;
     HEAP32[i1 + 4 >> 2] = i37;
     HEAP32[i1 + 8 >> 2] = i38;
     HEAP32[i1 + 12 >> 2] = i42;
     HEAP32[i1 + 16 >> 2] = i39;
     HEAP32[i1 + 20 >> 2] = i40;
     HEAP32[i1 + 24 >> 2] = i41;
     HEAP32[i1 + 28 >> 2] = i42;
     i41 = HEAP32[i6 >> 2] | 0;
     i40 = HEAP32[i7 >> 2] | 0;
     i39 = HEAP32[i8 >> 2] | 0;
     i38 = HEAP32[i9 >> 2] | 0;
     i37 = HEAP32[i10 >> 2] | 0;
     HEAP32[i1 + 32 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i1 + 36 >> 2] = i41;
     HEAP32[i1 + 40 >> 2] = i40;
     HEAP32[i1 + 44 >> 2] = i42;
     HEAP32[i1 + 48 >> 2] = i39;
     HEAP32[i1 + 52 >> 2] = i38;
     HEAP32[i1 + 56 >> 2] = i37;
     HEAP32[i1 + 60 >> 2] = i42;
     i37 = HEAP32[i9 >> 2] | 0;
     i38 = HEAP32[i10 >> 2] | 0;
     i39 = HEAP32[i48 >> 2] | 0;
     i40 = HEAP32[i3 >> 2] | 0;
     i41 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + 64 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 68 >> 2] = i37;
     HEAP32[i1 + 72 >> 2] = i38;
     HEAP32[i1 + 76 >> 2] = i42;
     HEAP32[i1 + 80 >> 2] = i39;
     HEAP32[i1 + 84 >> 2] = i40;
     HEAP32[i1 + 88 >> 2] = i41;
     HEAP32[i1 + 92 >> 2] = i42;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i47 | 0)) break; else i1 = i1 + 96 | 0;
    }
   } else {
    i2 = 0;
    while (1) {
     i42 = i2 * 3 | 0;
     i38 = HEAP32[i50 + (i42 << 2) >> 2] | 0;
     i41 = HEAP32[i50 + (i42 + 1 << 2) >> 2] | 0;
     i42 = HEAP32[i50 + (i42 + 2 << 2) >> 2] | 0;
     i36 = HEAP32[i13 + (i38 * 12 | 0) >> 2] | 0;
     i37 = HEAP32[i13 + (i38 * 12 | 0) + 4 >> 2] | 0;
     i38 = HEAP32[i13 + (i38 * 12 | 0) + 8 >> 2] | 0;
     i39 = HEAP32[i13 + (i41 * 12 | 0) >> 2] | 0;
     i40 = HEAP32[i13 + (i41 * 12 | 0) + 4 >> 2] | 0;
     i41 = HEAP32[i13 + (i41 * 12 | 0) + 8 >> 2] | 0;
     i23 = HEAP32[i13 + (i42 * 12 | 0) >> 2] | 0;
     i35 = HEAP32[i13 + (i42 * 12 | 0) + 4 >> 2] | 0;
     i42 = HEAP32[i13 + (i42 * 12 | 0) + 8 >> 2] | 0;
     HEAP32[i48 >> 2] = i36;
     HEAP32[i3 >> 2] = i37;
     HEAP32[i4 >> 2] = i38;
     HEAP32[i5 >> 2] = i39;
     HEAP32[i6 >> 2] = i40;
     HEAP32[i7 >> 2] = i41;
     HEAP32[i8 >> 2] = i23;
     HEAP32[i9 >> 2] = i35;
     HEAP32[i10 >> 2] = i42;
     i42 = (((mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 48 >> 2] | 0, i22 | 0, i2 | 0) | 0) & 65535) % 12 | 0) & 65535;
     i42 = HEAP32[gb + 94052 + (i42 << 2) >> 2] | 0;
     HEAP32[i1 >> 2] = i36;
     HEAP32[i1 + 4 >> 2] = i37;
     HEAP32[i1 + 8 >> 2] = i38;
     HEAP32[i1 + 12 >> 2] = i42;
     HEAP32[i1 + 16 >> 2] = i39;
     HEAP32[i1 + 20 >> 2] = i40;
     HEAP32[i1 + 24 >> 2] = i41;
     HEAP32[i1 + 28 >> 2] = i42;
     i41 = HEAP32[i6 >> 2] | 0;
     i40 = HEAP32[i7 >> 2] | 0;
     i39 = HEAP32[i8 >> 2] | 0;
     i38 = HEAP32[i9 >> 2] | 0;
     i37 = HEAP32[i10 >> 2] | 0;
     HEAP32[i1 + 32 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i1 + 36 >> 2] = i41;
     HEAP32[i1 + 40 >> 2] = i40;
     HEAP32[i1 + 44 >> 2] = i42;
     HEAP32[i1 + 48 >> 2] = i39;
     HEAP32[i1 + 52 >> 2] = i38;
     HEAP32[i1 + 56 >> 2] = i37;
     HEAP32[i1 + 60 >> 2] = i42;
     i37 = HEAP32[i9 >> 2] | 0;
     i38 = HEAP32[i10 >> 2] | 0;
     i39 = HEAP32[i48 >> 2] | 0;
     i40 = HEAP32[i3 >> 2] | 0;
     i41 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + 64 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 68 >> 2] = i37;
     HEAP32[i1 + 72 >> 2] = i38;
     HEAP32[i1 + 76 >> 2] = i42;
     HEAP32[i1 + 80 >> 2] = i39;
     HEAP32[i1 + 84 >> 2] = i40;
     HEAP32[i1 + 88 >> 2] = i41;
     HEAP32[i1 + 92 >> 2] = i42;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i47 | 0)) break; else i1 = i1 + 96 | 0;
    }
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i13);
 }
 if ((i21 & 131072 | 0) == 0 & 0 == 0) {
  STACKTOP = i53;
  return;
 }
 i1 = i22 + 168 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 0 | (i47 | 0) == 0) {
  STACKTOP = i53;
  return;
 }
 i2 = i45 + 4 | 0;
 i3 = i48 + 4 | 0;
 i4 = i45 + 8 | 0;
 i5 = i48 + 8 | 0;
 i6 = i48 + 24 | 0;
 i7 = i46 + 4 | 0;
 i8 = i48 + 28 | 0;
 i9 = i46 + 8 | 0;
 i10 = i48 + 32 | 0;
 i11 = i48 + 12 | 0;
 i12 = i43 + 4 | 0;
 i13 = i48 + 16 | 0;
 i14 = i43 + 8 | 0;
 i15 = i48 + 20 | 0;
 i16 = i44 + 4 | 0;
 i17 = i44 + 8 | 0;
 i18 = i32 + 4 | 0;
 i19 = i32 + 8 | 0;
 i20 = i33 + 4 | 0;
 i21 = i33 + 8 | 0;
 i23 = 0;
 do {
  __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(i23, i48, i49, i50, i54, i51);
  i22 = HEAPU8[(HEAP32[i1 >> 2] | 0) + i23 >> 0] | 0;
  if (i22 & 8 | 0) {
   i42 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
   HEAP32[i32 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
   i42 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i32) | 0;
   HEAP32[i33 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
   __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i33) | 0;
  }
  if (i22 & 16 | 0) {
   i42 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
   HEAP32[i43 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   i42 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i43) | 0;
   HEAP32[i44 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
   __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i44) | 0;
  }
  if (i22 & 32 | 0) {
   i42 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i55, i52) | 0, -256) | 0, 1) | 0;
   HEAP32[i45 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i42 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i45) | 0;
   HEAP32[i46 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i42, i46) | 0;
  }
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) != (i47 | 0));
 STACKTOP = i53;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i14 = i2;
 L1 : while (1) {
  i10 = i14;
  i13 = i14 + -16 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i2 = i10 - i9 | 0;
    i3 = i2 >> 4;
    switch (i3 | 0) {
    case 2:
     {
      i11 = 5;
      break L1;
     }
    case 3:
     {
      i11 = 7;
      break L1;
     }
    case 4:
     {
      i11 = 15;
      break L1;
     }
    case 5:
     {
      i11 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i11 = 84;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 496) {
     i11 = 22;
     break L1;
    }
    i8 = i1 + (((i3 | 0) / 2 | 0) << 4) | 0;
    do if ((i2 | 0) > 15984) {
     i3 = (i3 | 0) / 4 | 0;
     i7 = i1 + (i3 << 4) | 0;
     i3 = i8 + (i3 << 4) | 0;
     i2 = __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i7, i8, i3, i12) | 0;
     f6 = Math_fround(HEAPF32[i13 >> 2]);
     if (!(f6 < Math_fround(HEAPF32[i3 >> 2]))) {
      i3 = i8;
      break;
     };
     HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
     HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i4 = i2 + 1 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     if (f6 < Math_fround(HEAPF32[i8 >> 2])) {
      HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i3 = i2 + 2 | 0;
      f6 = Math_fround(HEAPF32[i8 >> 2]);
      if (f6 < Math_fround(HEAPF32[i7 >> 2])) {
       HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i15 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i15 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
       HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
       HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
       HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
       HEAP32[i8 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
       f6 = Math_fround(HEAPF32[i7 >> 2]);
       if (f6 < Math_fround(HEAPF32[i1 >> 2])) {
        HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
        HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
        HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
        HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i7 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
        HEAP32[i7 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
        HEAP32[i7 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
        i2 = i2 + 4 | 0;
        i3 = i8;
       } else {
        i2 = i2 + 3 | 0;
        i3 = i8;
       }
      } else {
       i2 = i3;
       i3 = i8;
      }
     } else {
      i2 = i4;
      i3 = i8;
     }
    } else {
     f6 = Math_fround(HEAPF32[i8 >> 2]);
     i7 = f6 < Math_fround(HEAPF32[i1 >> 2]);
     i2 = Math_fround(HEAPF32[i13 >> 2]) < f6;
     if (!i7) {
      if (!i2) {
       i2 = 0;
       i3 = i8;
       break;
      };
      HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      f6 = Math_fround(HEAPF32[i8 >> 2]);
      if (!(f6 < Math_fround(HEAPF32[i1 >> 2]))) {
       i2 = 1;
       i3 = i8;
       break;
      };
      HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i2 = 2;
      i3 = i8;
      break;
     }
     if (i2) {
      HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i2 = 1;
      i3 = i8;
      break;
     };
     HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     f6 = Math_fround(HEAPF32[i13 >> 2]);
     if (f6 < Math_fround(HEAPF32[i8 >> 2])) {
      HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i2 = 2;
      i3 = i8;
     } else {
      i2 = 1;
      i3 = i8;
     }
    } while (0);
    f6 = Math_fround(HEAPF32[i1 >> 2]);
    f5 = Math_fround(HEAPF32[i3 >> 2]);
    if (f6 < f5) {
     i3 = i13;
     break;
    } else i3 = i13;
    while (1) {
     i3 = i3 + -16 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if (Math_fround(HEAPF32[i3 >> 2]) < f5) {
      i11 = 67;
      break L5;
     }
    }
    i2 = i1 + 16 | 0;
    if (!(f6 < Math_fround(HEAPF32[i13 >> 2]))) {
     if ((i2 | 0) == (i13 | 0)) {
      i11 = 84;
      break L1;
     }
     while (1) {
      if (f6 < Math_fround(HEAPF32[i2 >> 2])) break;
      i2 = i2 + 16 | 0;
      if ((i2 | 0) == (i13 | 0)) {
       i11 = 84;
       break L1;
      }
     }
     HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
     HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i2 = i2 + 16 | 0;
    }
    if ((i2 | 0) == (i13 | 0)) {
     i11 = 84;
     break L1;
    } else i3 = i13;
    while (1) {
     f5 = Math_fround(HEAPF32[i1 >> 2]);
     while (1) {
      i4 = i2 + 16 | 0;
      if (f5 < Math_fround(HEAPF32[i2 >> 2])) break; else i2 = i4;
     }
     do i3 = i3 + -16 | 0; while (f5 < Math_fround(HEAPF32[i3 >> 2]));
     if (i2 >>> 0 >= i3 >>> 0) {
      i1 = i2;
      continue L5;
     };
     HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i2 = i4;
    }
   }
   if ((i11 | 0) == 67) {
    i11 = 0;
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 16 | 0;
   L50 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    f5 = Math_fround(HEAPF32[i8 >> 2]);
    while (1) {
     i7 = i4 + 16 | 0;
     if (Math_fround(HEAPF32[i4 >> 2]) < f5) i4 = i7; else break;
    }
    do i3 = i3 + -16 | 0; while (!(Math_fround(HEAPF32[i3 >> 2]) < f5));
    if (i4 >>> 0 > i3 >>> 0) {
     i3 = i8;
     break L50;
    };
    HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    i8 = (i8 | 0) == (i4 | 0) ? i3 : i8;
    i4 = i7;
    i2 = i2 + 1 | 0;
   } else i3 = i8; while (0);
   if ((i4 | 0) != (i3 | 0)) {
    f6 = Math_fround(HEAPF32[i3 >> 2]);
    if (f6 < Math_fround(HEAPF32[i4 >> 2])) {
     HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEbT0_S7_T_(i1, i4, i12) | 0;
    i3 = i4 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEbT0_S7_T_(i3, i14, i12) | 0) {
     i11 = 83;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i8 = i4;
   if ((i8 - i9 | 0) >= (i10 - i8 | 0)) {
    i11 = 82;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_(i1, i4, i12);
   i1 = i4 + 16 | 0;
  }
  if ((i11 | 0) == 82) {
   i11 = 0;
   __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_(i4 + 16 | 0, i14, i12);
   i14 = i4;
   continue;
  } else if ((i11 | 0) == 83) {
   i11 = 0;
   if (i2) {
    i11 = 84;
    break;
   } else {
    i14 = i4;
    continue;
   }
  }
 }
 if ((i11 | 0) == 5) {
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i1 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 7) {
  i2 = i1 + 16 | 0;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i14 = f6 < Math_fround(HEAPF32[i1 >> 2]);
  i3 = Math_fround(HEAPF32[i13 >> 2]) < f6;
  if (!i14) {
   if (!i3) {
    STACKTOP = i16;
    return;
   };
   HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   if (!(f6 < Math_fround(HEAPF32[i1 >> 2]))) {
    STACKTOP = i16;
    return;
   };
   HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   STACKTOP = i16;
   return;
  }
  if (i3) {
   HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i2 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i13, i12) | 0;
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 16) {
  i2 = i1 + 16 | 0;
  i3 = i1 + 32 | 0;
  i4 = i1 + 48 | 0;
  __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i2, i3, i4, i12) | 0;
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i4 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i3 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i2 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f6 < Math_fround(HEAPF32[i1 >> 2]))) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 22) {
  i3 = i1 + 32 | 0;
  i2 = i1 + 16 | 0;
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = f6 < f17;
  do if (f17 < f5) {
   if (i4) {
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    break;
   };
   HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   if (f6 < Math_fround(HEAPF32[i2 >> 2])) {
    HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   }
  } else if (i4) {
   HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   if (Math_fround(HEAPF32[i2 >> 2]) < f5) {
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   }
  } while (0);
  i2 = i1 + 48 | 0;
  if ((i2 | 0) == (i14 | 0)) {
   STACKTOP = i16;
   return;
  }
  while (1) {
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   if (f5 < Math_fround(HEAPF32[i3 >> 2])) {
    i4 = i2 + 4 | 0;
    HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    i4 = i2;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i4 = i3 + -16 | 0;
     if (f5 < Math_fround(HEAPF32[i4 >> 2])) {
      i13 = i3;
      i3 = i4;
      i4 = i13;
     } else break;
    }
    HEAPF32[i3 >> 2] = f5;
    i13 = i3 + 4 | 0;
    HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   }
   i3 = i2 + 16 | 0;
   if ((i3 | 0) == (i14 | 0)) break; else {
    i13 = i2;
    i2 = i3;
    i3 = i13;
   }
  }
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 84) {
  STACKTOP = i16;
  return;
 }
}

function __ZNK5Umbra18ImpOcclusionBuffer8dump8bppEPhRKNS_15OcclusionBuffer10BufferDescE(i2, i25, i23) {
 i2 = i2 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 2576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i32 + 16 | 0;
 i30 = i32;
 i31 = i32 + 2064 | 0;
 i26 = HEAP32[i2 + 1408 >> 2] | 0;
 if (!i26) {
  i31 = 4;
  STACKTOP = i32;
  return i31 | 0;
 }
 _memset(i24 | 0, 0, 2048) | 0;
 i20 = HEAP16[i2 + 1364 >> 1] | 0;
 i21 = (i20 & 255) << 24 >> 24 == 0;
 f28 = Math_fround(HEAPF32[i2 + 128 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + 132 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 136 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 140 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 1184 >> 2]);
 f27 = Math_fround(f28 * f1);
 f3 = Math_fround(HEAPF32[i2 + 1188 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f29 * f3));
 f4 = Math_fround(HEAPF32[i2 + 1192 >> 2]);
 f5 = Math_fround(Math_fround(-Math_fround(f18 + Math_fround(f27 + Math_fround(f5 * f4)))) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(f5 * f5)))));
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 if (i21) {
  i14 = 0;
  i2 = i6;
 } else {
  f27 = Math_fround(HEAPF32[i2 + 144 >> 2]);
  f18 = Math_fround(f1 * f27);
  f28 = Math_fround(HEAPF32[i2 + 148 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f3 * f28));
  f29 = Math_fround(HEAPF32[i2 + 152 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f4 * f29));
  f29 = Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 156 >> 2]) + f18) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28)) + Math_fround(f29 * f29)))));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  if (f29 < f5) i14 = i6; else {
   i14 = i2;
   i2 = i6;
  }
 }
 i13 = 0;
 i12 = 0;
 i10 = 1065353216;
 i8 = 1065353216;
 i9 = 0;
 i6 = 1065353216;
 i7 = 0;
 i22 = 1065353216;
 i11 = 0;
 do {
  i36 = i26 + (i13 << 2) | 0;
  f17 = Math_fround(HEAPF32[i36 >> 2]);
  f15 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i36 + 8 >> 2]);
  f1 = Math_fround(HEAPF32[i36 + 12 >> 2]);
  f18 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = f18 <= f17 ? f18 : f17;
  f16 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = f16 <= f15 ? f16 : f15;
  f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = f5 <= f4 ? f5 : f4;
  f3 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = f3 <= f1 ? f3 : f1;
  i10 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i36 = f17 != Math_fround(1.0);
  i35 = f15 != Math_fround(1.0);
  i34 = f4 != Math_fround(1.0);
  i33 = f1 != Math_fround(1.0);
  f29 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = i36 ? f17 : Math_fround(0.0);
  f17 = f29 >= f17 ? f29 : f17;
  f29 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = i35 ? f15 : Math_fround(0.0);
  f15 = f29 >= f15 ? f29 : f15;
  f29 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = i34 ? f4 : Math_fround(0.0);
  f4 = f29 >= f4 ? f29 : f4;
  f29 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = i33 ? f1 : Math_fround(0.0);
  f1 = f29 >= f1 ? f29 : f1;
  i12 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = i13 + 4 | 0;
 } while ((i13 | 0) < 4096);
 if (f18 == Math_fround(1.0) & f16 == Math_fround(1.0)) if (f3 == Math_fround(1.0) & f5 == Math_fround(1.0)) _memset(i25 | 0, -1, 4096) | 0; else i19 = 10; else i19 = 10;
 if ((i19 | 0) == 10) {
  f29 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f27 * Math_fround(f29 * Math_fround(2.0)));
  i21 = i21 | (i20 & 65535) > 255;
  if (i21) i2 = i22; else {
   f40 = Math_fround(Math_fround(f27 + Math_fround(f29 * f18)) - Math_fround(f27 * f18));
   f39 = Math_fround(Math_fround(f27 + Math_fround(f29 * f16)) - Math_fround(f27 * f16));
   f38 = Math_fround(Math_fround(f27 + Math_fround(f29 * f5)) - Math_fround(f27 * f5));
   f18 = Math_fround(Math_fround(f27 + Math_fround(f29 * f3)) - Math_fround(f27 * f3));
   i10 = f40 == Math_fround(0.0);
   f16 = Math_fround(Math_fround(1.0) / f40);
   f16 = i10 ? Math_fround(1.0) : f16;
   i10 = f39 == Math_fround(0.0);
   f5 = Math_fround(Math_fround(1.0) / f39);
   f5 = i10 ? Math_fround(1.0) : f5;
   i10 = f38 == Math_fround(0.0);
   f3 = Math_fround(Math_fround(1.0) / f38);
   f3 = i10 ? Math_fround(1.0) : f3;
   i10 = f18 == Math_fround(0.0);
   f37 = Math_fround(Math_fround(1.0) / f18);
   f37 = i10 ? Math_fround(1.0) : f37;
   f16 = Math_fround(f28 * Math_fround(Math_fround(f16 + f16) - Math_fround(f16 * Math_fround(f40 * f16))));
   f5 = Math_fround(f28 * Math_fround(Math_fround(f5 + f5) - Math_fround(f5 * Math_fround(f39 * f5))));
   f3 = Math_fround(f28 * Math_fround(Math_fround(f3 + f3) - Math_fround(f3 * Math_fround(f38 * f3))));
   f37 = Math_fround(f28 * Math_fround(Math_fround(f37 + f37) - Math_fround(f37 * Math_fround(f18 * f37))));
   i10 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   f37 = Math_fround(Math_fround(f27 + Math_fround(f29 * f17)) - Math_fround(f27 * f17));
   f3 = Math_fround(Math_fround(f27 + Math_fround(f29 * f15)) - Math_fround(f27 * f15));
   f4 = Math_fround(Math_fround(f27 + Math_fround(f29 * f4)) - Math_fround(f27 * f4));
   f5 = Math_fround(Math_fround(f27 + Math_fround(f29 * f1)) - Math_fround(f27 * f1));
   i12 = f37 == Math_fround(0.0);
   f15 = Math_fround(Math_fround(1.0) / f37);
   f15 = i12 ? Math_fround(1.0) : f15;
   i12 = f3 == Math_fround(0.0);
   f16 = Math_fround(Math_fround(1.0) / f3);
   f16 = i12 ? Math_fround(1.0) : f16;
   i12 = f4 == Math_fround(0.0);
   f17 = Math_fround(Math_fround(1.0) / f4);
   f17 = i12 ? Math_fround(1.0) : f17;
   i12 = f5 == Math_fround(0.0);
   f18 = Math_fround(Math_fround(1.0) / f5);
   f18 = i12 ? Math_fround(1.0) : f18;
   f15 = Math_fround(f28 * Math_fround(Math_fround(f15 + f15) - Math_fround(f15 * Math_fround(f37 * f15))));
   f16 = Math_fround(f28 * Math_fround(Math_fround(f16 + f16) - Math_fround(f16 * Math_fround(f3 * f16))));
   f17 = Math_fround(f28 * Math_fround(Math_fround(f17 + f17) - Math_fround(f17 * Math_fround(f4 * f17))));
   f18 = Math_fround(f28 * Math_fround(Math_fround(f18 + f18) - Math_fround(f18 * Math_fround(f5 * f18))));
   i12 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f39 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = f39 <= f3 ? f39 : f3;
  f39 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = f1 <= f3 ? f1 : f3;
  f3 = f39 <= f3 ? f39 : f3;
  f39 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i36 = f39 >= (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i36 ? i9 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f40 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = f39 >= f1 ? f39 : f1;
  f1 = f40 >= f1 ? f40 : f1;
  if (f3 == f1) {
   f15 = Math_fround(-f3);
   f16 = Math_fround(1.0);
  } else if (f3 < f1) {
   f16 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(f1 - f3)) * Math_fround(511.0));
   f15 = Math_fround(-Math_fround(f3 * f16));
  } else {
   f15 = Math_fround(0.0);
   f16 = Math_fround(0.0);
  };
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  HEAP32[i30 + 12 >> 2] = 0;
  i14 = i30 + 4 | 0;
  i19 = i30 + 8 | 0;
  i20 = i30 + 12 | 0;
  i13 = 0;
  i10 = 0;
  i6 = 2147483647;
  while (1) {
   i9 = i26 + (i13 << 2) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = HEAP32[i9 + 8 >> 2] | 0;
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   if (!i21) {
    f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f29 * f4);
    f5 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f29 * f5);
    f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f29 * f17);
    f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = Math_fround(Math_fround(f27 + f39) - Math_fround(f27 * f4));
    f5 = Math_fround(Math_fround(f27 + f38) - Math_fround(f27 * f5));
    f17 = Math_fround(Math_fround(f27 + f37) - Math_fround(f27 * f17));
    f18 = Math_fround(Math_fround(f27 + Math_fround(f29 * f18)) - Math_fround(f27 * f18));
    i2 = f4 == Math_fround(0.0);
    f37 = Math_fround(Math_fround(1.0) / f4);
    f37 = i2 ? Math_fround(1.0) : f37;
    i2 = f5 == Math_fround(0.0);
    f38 = Math_fround(Math_fround(1.0) / f5);
    f38 = i2 ? Math_fround(1.0) : f38;
    i2 = f17 == Math_fround(0.0);
    f39 = Math_fround(Math_fround(1.0) / f17);
    f39 = i2 ? Math_fround(1.0) : f39;
    i2 = f18 == Math_fround(0.0);
    f40 = Math_fround(Math_fround(1.0) / f18);
    f40 = i2 ? Math_fround(1.0) : f40;
    f37 = Math_fround(f28 * Math_fround(Math_fround(f37 + f37) - Math_fround(f37 * Math_fround(f4 * f37))));
    f38 = Math_fround(f28 * Math_fround(Math_fround(f38 + f38) - Math_fround(f38 * Math_fround(f5 * f38))));
    f39 = Math_fround(f28 * Math_fround(Math_fround(f39 + f39) - Math_fround(f39 * Math_fround(f17 * f39))));
    f40 = Math_fround(f28 * Math_fround(Math_fround(f40 + f40) - Math_fround(f40 * Math_fround(f18 * f40))));
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f38 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f39 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f40 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i8 = ~~Math_fround(f15 + f38);
   i11 = ~~Math_fround(f15 + f39);
   i12 = ~~Math_fround(f15 + f40);
   i7 = ~~Math_fround(f15 + Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   if (i8 >>> 0 > 511) i2 = i10; else {
    i2 = i24 + (i8 << 2) | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = i10 + 1 | 0;
    i6 = (i6 | 0) <= (i8 | 0) ? i6 : i8;
   }
   if (i11 >>> 0 <= 511) {
    i36 = i24 + (i11 << 2) | 0;
    HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
    i6 = (i6 | 0) <= (i11 | 0) ? i6 : i11;
   }
   if (i12 >>> 0 <= 511) {
    i36 = i24 + (i12 << 2) | 0;
    HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
    i6 = (i6 | 0) <= (i12 | 0) ? i6 : i12;
   }
   if (i7 >>> 0 <= 511) {
    i36 = i24 + (i7 << 2) | 0;
    HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
    i6 = (i6 | 0) <= (i7 | 0) ? i6 : i7;
   }
   i13 = i13 + 4 | 0;
   if ((i13 | 0) >= 4096) break; else i10 = i2;
  }
  HEAP32[i30 >> 2] = i8;
  HEAP32[i14 >> 2] = i11;
  HEAP32[i19 >> 2] = i12;
  HEAP32[i20 >> 2] = i7;
  if (i2 | 0) {
   i8 = HEAP32[i24 + (i6 << 2) >> 2] | 0;
   i7 = i2 - i8 | 0;
   f1 = Math_fround(i7 | 0);
   f1 = (i7 | 0) == 0 ? Math_fround(1.0) : f1;
   i7 = 0;
   i2 = 0;
   do {
    i6 = HEAP32[i24 + (i7 << 2) >> 2] | 0;
    if (!i6) i6 = 0; else {
     i6 = i6 + i2 | 0;
     i2 = i6;
     i6 = ~~Math_fround(Math_fround(Math_fround(i6 - i8 | 0) / f1) * Math_fround(254.0)) & 255;
    }
    HEAP8[i31 + i7 >> 0] = i6;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != 512);
  }
  i12 = i23 + 8 | 0;
  i11 = 0;
  while (1) {
   i9 = 0;
   i10 = i26;
   while (1) {
    i8 = i9 << 2;
    i7 = i25 + i8 | 0;
    f1 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i10 + 8 >> 2]);
    f3 = Math_fround(HEAPF32[i10 + 12 >> 2]);
    i36 = f1 <= Math_fround(0.0);
    f1 = i36 ? Math_fround(0.0) : f1;
    i36 = f4 <= Math_fround(0.0);
    f4 = i36 ? Math_fround(0.0) : f4;
    i36 = f5 <= Math_fround(0.0);
    f5 = i36 ? Math_fround(0.0) : f5;
    i36 = f3 <= Math_fround(0.0);
    f3 = i36 ? Math_fround(0.0) : f3;
    if (!i21) {
     f37 = Math_fround(Math_fround(f27 + Math_fround(f29 * f1)) - Math_fround(f27 * f1));
     f38 = Math_fround(Math_fround(f27 + Math_fround(f29 * f4)) - Math_fround(f27 * f4));
     f39 = Math_fround(Math_fround(f27 + Math_fround(f29 * f5)) - Math_fround(f27 * f5));
     f40 = Math_fround(Math_fround(f27 + Math_fround(f29 * f3)) - Math_fround(f27 * f3));
     i36 = f37 == Math_fround(0.0);
     f1 = Math_fround(Math_fround(1.0) / f37);
     f1 = i36 ? Math_fround(1.0) : f1;
     i36 = f38 == Math_fround(0.0);
     f4 = Math_fround(Math_fround(1.0) / f38);
     f4 = i36 ? Math_fround(1.0) : f4;
     i36 = f39 == Math_fround(0.0);
     f5 = Math_fround(Math_fround(1.0) / f39);
     f5 = i36 ? Math_fround(1.0) : f5;
     i36 = f40 == Math_fround(0.0);
     f3 = Math_fround(Math_fround(1.0) / f40);
     f3 = i36 ? Math_fround(1.0) : f3;
     f1 = Math_fround(f28 * Math_fround(Math_fround(f1 + f1) - Math_fround(f1 * Math_fround(f37 * f1))));
     f4 = Math_fround(f28 * Math_fround(Math_fround(f4 + f4) - Math_fround(f4 * Math_fround(f38 * f4))));
     f5 = Math_fround(f28 * Math_fround(Math_fround(f5 + f5) - Math_fround(f5 * Math_fround(f39 * f5))));
     f3 = Math_fround(f28 * Math_fround(Math_fround(f3 + f3) - Math_fround(f3 * Math_fround(f40 * f3))));
    }
    i2 = ~~Math_fround(f15 + Math_fround(f16 * f1));
    i34 = ~~Math_fround(f15 + Math_fround(f16 * f4));
    i35 = ~~Math_fround(f15 + Math_fround(f16 * f5));
    i36 = ~~Math_fround(f15 + Math_fround(f16 * f3));
    HEAP32[i30 >> 2] = i2;
    HEAP32[i14 >> 2] = i34;
    HEAP32[i19 >> 2] = i35;
    HEAP32[i20 >> 2] = i36;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i6 = i7 + 1 | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i14 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i7 = i6 + 1 | 0;
    HEAP8[i6 >> 0] = i2;
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i20 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 + 1 >> 0] = i2;
    i7 = i25 + ((HEAP32[i12 >> 2] | 0) + i8) | 0;
    f1 = Math_fround(HEAPF32[i10 + 16 >> 2]);
    f4 = Math_fround(HEAPF32[i10 + 20 >> 2]);
    f5 = Math_fround(HEAPF32[i10 + 24 >> 2]);
    f3 = Math_fround(HEAPF32[i10 + 28 >> 2]);
    i36 = f1 <= Math_fround(0.0);
    f1 = i36 ? Math_fround(0.0) : f1;
    i36 = f4 <= Math_fround(0.0);
    f4 = i36 ? Math_fround(0.0) : f4;
    i36 = f5 <= Math_fround(0.0);
    f5 = i36 ? Math_fround(0.0) : f5;
    i36 = f3 <= Math_fround(0.0);
    f3 = i36 ? Math_fround(0.0) : f3;
    if (!i21) {
     f37 = Math_fround(Math_fround(f27 + Math_fround(f29 * f1)) - Math_fround(f27 * f1));
     f38 = Math_fround(Math_fround(f27 + Math_fround(f29 * f4)) - Math_fround(f27 * f4));
     f39 = Math_fround(Math_fround(f27 + Math_fround(f29 * f5)) - Math_fround(f27 * f5));
     f40 = Math_fround(Math_fround(f27 + Math_fround(f29 * f3)) - Math_fround(f27 * f3));
     i36 = f37 == Math_fround(0.0);
     f1 = Math_fround(Math_fround(1.0) / f37);
     f1 = i36 ? Math_fround(1.0) : f1;
     i36 = f38 == Math_fround(0.0);
     f4 = Math_fround(Math_fround(1.0) / f38);
     f4 = i36 ? Math_fround(1.0) : f4;
     i36 = f39 == Math_fround(0.0);
     f5 = Math_fround(Math_fround(1.0) / f39);
     f5 = i36 ? Math_fround(1.0) : f5;
     i36 = f40 == Math_fround(0.0);
     f3 = Math_fround(Math_fround(1.0) / f40);
     f3 = i36 ? Math_fround(1.0) : f3;
     f1 = Math_fround(f28 * Math_fround(Math_fround(f1 + f1) - Math_fround(f1 * Math_fround(f37 * f1))));
     f4 = Math_fround(f28 * Math_fround(Math_fround(f4 + f4) - Math_fround(f4 * Math_fround(f38 * f4))));
     f5 = Math_fround(f28 * Math_fround(Math_fround(f5 + f5) - Math_fround(f5 * Math_fround(f39 * f5))));
     f3 = Math_fround(f28 * Math_fround(Math_fround(f3 + f3) - Math_fround(f3 * Math_fround(f40 * f3))));
    }
    i2 = ~~Math_fround(f15 + Math_fround(f16 * f1));
    i34 = ~~Math_fround(f15 + Math_fround(f16 * f4));
    i35 = ~~Math_fround(f15 + Math_fround(f16 * f5));
    i36 = ~~Math_fround(f15 + Math_fround(f16 * f3));
    HEAP32[i30 >> 2] = i2;
    HEAP32[i14 >> 2] = i34;
    HEAP32[i19 >> 2] = i35;
    HEAP32[i20 >> 2] = i36;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i6 = i7 + 1 | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i14 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i7 = i6 + 1 | 0;
    HEAP8[i6 >> 0] = i2;
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i20 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 + 1 >> 0] = i2;
    i7 = i25 + ((HEAP32[i12 >> 2] << 1) + i8) | 0;
    f1 = Math_fround(HEAPF32[i10 + 32 >> 2]);
    f4 = Math_fround(HEAPF32[i10 + 36 >> 2]);
    f5 = Math_fround(HEAPF32[i10 + 40 >> 2]);
    f3 = Math_fround(HEAPF32[i10 + 44 >> 2]);
    i36 = f1 <= Math_fround(0.0);
    f1 = i36 ? Math_fround(0.0) : f1;
    i36 = f4 <= Math_fround(0.0);
    f4 = i36 ? Math_fround(0.0) : f4;
    i36 = f5 <= Math_fround(0.0);
    f5 = i36 ? Math_fround(0.0) : f5;
    i36 = f3 <= Math_fround(0.0);
    f3 = i36 ? Math_fround(0.0) : f3;
    if (!i21) {
     f37 = Math_fround(Math_fround(f27 + Math_fround(f29 * f1)) - Math_fround(f27 * f1));
     f38 = Math_fround(Math_fround(f27 + Math_fround(f29 * f4)) - Math_fround(f27 * f4));
     f39 = Math_fround(Math_fround(f27 + Math_fround(f29 * f5)) - Math_fround(f27 * f5));
     f40 = Math_fround(Math_fround(f27 + Math_fround(f29 * f3)) - Math_fround(f27 * f3));
     i36 = f37 == Math_fround(0.0);
     f1 = Math_fround(Math_fround(1.0) / f37);
     f1 = i36 ? Math_fround(1.0) : f1;
     i36 = f38 == Math_fround(0.0);
     f4 = Math_fround(Math_fround(1.0) / f38);
     f4 = i36 ? Math_fround(1.0) : f4;
     i36 = f39 == Math_fround(0.0);
     f5 = Math_fround(Math_fround(1.0) / f39);
     f5 = i36 ? Math_fround(1.0) : f5;
     i36 = f40 == Math_fround(0.0);
     f3 = Math_fround(Math_fround(1.0) / f40);
     f3 = i36 ? Math_fround(1.0) : f3;
     f1 = Math_fround(f28 * Math_fround(Math_fround(f1 + f1) - Math_fround(f1 * Math_fround(f37 * f1))));
     f4 = Math_fround(f28 * Math_fround(Math_fround(f4 + f4) - Math_fround(f4 * Math_fround(f38 * f4))));
     f5 = Math_fround(f28 * Math_fround(Math_fround(f5 + f5) - Math_fround(f5 * Math_fround(f39 * f5))));
     f3 = Math_fround(f28 * Math_fround(Math_fround(f3 + f3) - Math_fround(f3 * Math_fround(f40 * f3))));
    }
    i2 = ~~Math_fround(f15 + Math_fround(f16 * f1));
    i34 = ~~Math_fround(f15 + Math_fround(f16 * f4));
    i35 = ~~Math_fround(f15 + Math_fround(f16 * f5));
    i36 = ~~Math_fround(f15 + Math_fround(f16 * f3));
    HEAP32[i30 >> 2] = i2;
    HEAP32[i14 >> 2] = i34;
    HEAP32[i19 >> 2] = i35;
    HEAP32[i20 >> 2] = i36;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i6 = i7 + 1 | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i14 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i7 = i6 + 1 | 0;
    HEAP8[i6 >> 0] = i2;
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i20 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 + 1 >> 0] = i2;
    i7 = i25 + (((HEAP32[i12 >> 2] | 0) * 3 | 0) + i8) | 0;
    f1 = Math_fround(HEAPF32[i10 + 48 >> 2]);
    f4 = Math_fround(HEAPF32[i10 + 52 >> 2]);
    f5 = Math_fround(HEAPF32[i10 + 56 >> 2]);
    f3 = Math_fround(HEAPF32[i10 + 60 >> 2]);
    i36 = f1 <= Math_fround(0.0);
    f1 = i36 ? Math_fround(0.0) : f1;
    i36 = f4 <= Math_fround(0.0);
    f4 = i36 ? Math_fround(0.0) : f4;
    i36 = f5 <= Math_fround(0.0);
    f5 = i36 ? Math_fround(0.0) : f5;
    i36 = f3 <= Math_fround(0.0);
    f3 = i36 ? Math_fround(0.0) : f3;
    if (!i21) {
     f37 = Math_fround(Math_fround(f27 + Math_fround(f29 * f1)) - Math_fround(f27 * f1));
     f38 = Math_fround(Math_fround(f27 + Math_fround(f29 * f4)) - Math_fround(f27 * f4));
     f39 = Math_fround(Math_fround(f27 + Math_fround(f29 * f5)) - Math_fround(f27 * f5));
     f40 = Math_fround(Math_fround(f27 + Math_fround(f29 * f3)) - Math_fround(f27 * f3));
     i36 = f37 == Math_fround(0.0);
     f1 = Math_fround(Math_fround(1.0) / f37);
     f1 = i36 ? Math_fround(1.0) : f1;
     i36 = f38 == Math_fround(0.0);
     f4 = Math_fround(Math_fround(1.0) / f38);
     f4 = i36 ? Math_fround(1.0) : f4;
     i36 = f39 == Math_fround(0.0);
     f5 = Math_fround(Math_fround(1.0) / f39);
     f5 = i36 ? Math_fround(1.0) : f5;
     i36 = f40 == Math_fround(0.0);
     f3 = Math_fround(Math_fround(1.0) / f40);
     f3 = i36 ? Math_fround(1.0) : f3;
     f1 = Math_fround(f28 * Math_fround(Math_fround(f1 + f1) - Math_fround(f1 * Math_fround(f37 * f1))));
     f4 = Math_fround(f28 * Math_fround(Math_fround(f4 + f4) - Math_fround(f4 * Math_fround(f38 * f4))));
     f5 = Math_fround(f28 * Math_fround(Math_fround(f5 + f5) - Math_fround(f5 * Math_fround(f39 * f5))));
     f3 = Math_fround(f28 * Math_fround(Math_fround(f3 + f3) - Math_fround(f3 * Math_fround(f40 * f3))));
    }
    i2 = ~~Math_fround(f15 + Math_fround(f16 * f1));
    i34 = ~~Math_fround(f15 + Math_fround(f16 * f4));
    i35 = ~~Math_fround(f15 + Math_fround(f16 * f5));
    i36 = ~~Math_fround(f15 + Math_fround(f16 * f3));
    HEAP32[i30 >> 2] = i2;
    HEAP32[i14 >> 2] = i34;
    HEAP32[i19 >> 2] = i35;
    HEAP32[i20 >> 2] = i36;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i6 = i7 + 1 | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i14 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    i7 = i6 + 1 | 0;
    HEAP8[i6 >> 0] = i2;
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 >> 0] = i2;
    i2 = HEAP32[i20 >> 2] | 0;
    if (i2 >>> 0 > 511) i2 = -1; else i2 = HEAP8[i31 + i2 >> 0] | 0;
    HEAP8[i7 + 1 >> 0] = i2;
    i9 = i9 + 1 | 0;
    if ((i9 | 0) == 16) break; else i10 = i10 + 64 | 0;
   }
   i11 = i11 + 1 | 0;
   if ((i11 | 0) == 16) break; else {
    i25 = i25 + (HEAP32[i12 >> 2] << 2) | 0;
    i26 = i26 + 1024 | 0;
   }
  }
 }
 i36 = 0;
 STACKTOP = i32;
 return i36 | 0;
}

function __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEEEEjT_j(i11, i14, i15) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i13 = i16 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11, i15);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 16 | 0, i15 + 1 | 0);
 i5 = i11 + 32 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i4 = i13 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_(i14, i13);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj66ES3_NS_28PxArticulationJointDriveType4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i11 + 64 | 0, i15 + 4 | 0);
 i5 = i11 + 80 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj67ENS_22PxRepXPropertyAccessorILj67ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 96 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj68ENS_22PxRepXPropertyAccessorILj68ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 112 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj69ENS_22PxRepXPropertyAccessorILj69ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 128 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj70ENS_22PxRepXPropertyAccessorILj70ES4_ffEEEEvRKT0_(i14, i13);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i14, i11 + 144 | 0, i15 + 9 | 0);
 i5 = i11 + 168 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj72ENS_22PxRepXPropertyAccessorILj72ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 184 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj73ENS_22PxRepXPropertyAccessorILj73ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 200 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj74ENS_22PxRepXPropertyAccessorILj74ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i11 + 224 >> 2] | 0;
 i5 = HEAP32[i11 + 216 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i12;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 i7 = i14 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i8 = i14 + 8 | 0;
 i3 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i10 = i14 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 12 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i14, i11 + 232 | 0, i15 + 14 | 0);
 i6 = HEAP32[i11 + 264 >> 2] | 0;
 i5 = HEAP32[i11 + 256 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i17 = i12;
  i4 = HEAP32[i17 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i4 = mftCall_ii(i6 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i4 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, (i4 ? 4 : 5) | 0) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i11 + 272 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i17 = i13 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i12 >> 2] = i5;
 HEAP8[i12 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i11 = i12;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i17 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i17 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i12) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj78ENS_22PxRepXPropertyAccessorILj78ES4_ffEEEEvRKT0_(i14, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i17 = i15 + 18 | 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i17 = i15 + 18 | 0;
 STACKTOP = i16;
 return i17 | 0;
}

function __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b(i2, i3, i1, i73, i74, i75, i76) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i76 = i76 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, f59 = f0, i60 = 0, f61 = f0, f62 = f0, i63 = 0, i64 = 0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = f0;
 i79 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i79;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + -5 | 0) >>> 0 > 1) {
  STACKTOP = i79;
  return;
 }
 i72 = __Z20IsFloatTextureFormat13TextureFormat(i1) | 0;
 i77 = HEAP32[i2 >> 2] | 0;
 if (!i72) {
  __ZN20SphericalHarmonicsL27SetZeroEv(i78);
  i60 = HEAP32[i3 + 4 >> 2] | 0;
  f62 = Math_fround(i60 | 0);
  f65 = Math_fround(Math_fround(1.0) / f62);
  f61 = Math_fround(f65 + Math_fround(-1.0));
  f62 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f65) * Math_fround(2.0)) / Math_fround(f62 + Math_fround(-1.0)));
  if ((i60 | 0) > 0) {
   i63 = i3 + 16 | 0;
   i51 = i3 + 12 | 0;
   i52 = i73 + 4 | 0;
   i53 = i73 + 8 | 0;
   i54 = i75 + 4 | 0;
   i55 = i75 + 8 | 0;
   i56 = i74 + 4 | 0;
   i57 = i74 + 8 | 0;
   i38 = i78 + 4 | 0;
   i36 = i78 + 8 | 0;
   i35 = i78 + 12 | 0;
   i34 = i78 + 16 | 0;
   i33 = i78 + 20 | 0;
   i32 = i78 + 24 | 0;
   i31 = i78 + 28 | 0;
   i30 = i78 + 32 | 0;
   i29 = i78 + 36 | 0;
   i28 = i78 + 40 | 0;
   i27 = i78 + 44 | 0;
   i26 = i78 + 48 | 0;
   i25 = i78 + 52 | 0;
   i24 = i78 + 56 | 0;
   i3 = i78 + 60 | 0;
   i2 = i78 + 64 | 0;
   i1 = i78 + 68 | 0;
   i64 = i78 + 72 | 0;
   i66 = i78 + 76 | 0;
   i67 = i78 + 80 | 0;
   i68 = i78 + 84 | 0;
   i69 = i78 + 88 | 0;
   i70 = i78 + 92 | 0;
   i71 = i78 + 96 | 0;
   i72 = i78 + 100 | 0;
   i40 = i78 + 104 | 0;
   i48 = 0;
   f4 = Math_fround(0.0);
   do {
    f58 = Math_fround(f61 + Math_fround(f62 * Math_fround(i48 | 0)));
    f59 = Math_fround(f58 * f58);
    i49 = (HEAP32[i63 >> 2] | 0) + (Math_imul(HEAP32[i51 >> 2] | 0, i48) | 0) | 0;
    i50 = 0;
    while (1) {
     f37 = Math_fround(f61 + Math_fround(f62 * Math_fround(i50 | 0)));
     f41 = Math_fround(f59 + Math_fround(Math_fround(f37 * f37) + Math_fround(1.0)));
     f41 = Math_fround(Math_fround(4.0) / Math_fround(Math_fround(Math_sqrt(Math_fround(f41))) * f41));
     f39 = Math_fround(Math_fround(HEAPF32[i73 >> 2]) * f37);
     f46 = Math_fround(f37 * Math_fround(HEAPF32[i52 >> 2]));
     f37 = Math_fround(f37 * Math_fround(HEAPF32[i53 >> 2]));
     f39 = Math_fround(f39 + Math_fround(HEAPF32[i75 >> 2]));
     f46 = Math_fround(f46 + Math_fround(HEAPF32[i54 >> 2]));
     f37 = Math_fround(f37 + Math_fround(HEAPF32[i55 >> 2]));
     f5 = Math_fround(f58 * Math_fround(HEAPF32[i74 >> 2]));
     f47 = Math_fround(f58 * Math_fround(HEAPF32[i56 >> 2]));
     f5 = Math_fround(f39 + f5);
     f47 = Math_fround(f46 + f47);
     f37 = Math_fround(f37 + Math_fround(f58 * Math_fround(HEAPF32[i57 >> 2])));
     f46 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f47 * f47)) + Math_fround(f37 * f37))));
     f5 = Math_fround(f5 / f46);
     f47 = Math_fround(f47 / f46);
     f46 = Math_fround(f37 / f46);
     f37 = Math_fround(f47 * Math_fround(-.488602519));
     f39 = Math_fround(f46 * Math_fround(.488602519));
     f42 = Math_fround(f5 * Math_fround(-.488602519));
     f43 = Math_fround(Math_fround(f5 * f47) * Math_fround(1.09254849));
     f44 = Math_fround(Math_fround(f47 * f46) * Math_fround(-1.09254849));
     f45 = Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(-.333333343)) * Math_fround(.946174681));
     f46 = Math_fround(Math_fround(f5 * f46) * Math_fround(-1.09254849));
     f47 = Math_fround(Math_fround(Math_fround(f5 * f5) - Math_fround(f47 * f47)) * Math_fround(.546274245));
     f5 = Math_fround(Math_fround(HEAPU8[i49 + 1 >> 0] | 0) * Math_fround(.00392156886));
     f6 = Math_fround(Math_fround(HEAPU8[i49 + 2 >> 0] | 0) * Math_fround(.00392156886));
     f7 = Math_fround(Math_fround(HEAPU8[i49 + 3 >> 0] | 0) * Math_fround(.00392156886));
     do if (i76) {
      do if (!(f5 <= Math_fround(.0404499993))) {
       if (f5 < Math_fround(1.0)) {
        f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
        break;
       }
       if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
      } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
      do if (!(f6 <= Math_fround(.0404499993))) {
       if (f6 < Math_fround(1.0)) {
        f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f6 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
        break;
       }
       if (f6 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f6, 2.20000005));
      } else f6 = Math_fround(f6 / Math_fround(12.9200001)); while (0);
      if (f7 <= Math_fround(.0404499993)) {
       f7 = Math_fround(f7 / Math_fround(12.9200001));
       break;
      }
      if (f7 < Math_fround(1.0)) {
       f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
     } while (0);
     f17 = Math_fround(f41 * f5);
     f8 = Math_fround(f41 * f6);
     f65 = Math_fround(f41 * f7);
     f20 = Math_fround(HEAPF32[i78 >> 2]);
     f21 = Math_fround(HEAPF32[i38 >> 2]);
     f23 = Math_fround(HEAPF32[i36 >> 2]);
     f21 = Math_fround(Math_fround(f37 * f17) + f21);
     f23 = Math_fround(Math_fround(f39 * f17) + f23);
     f22 = Math_fround(Math_fround(f42 * f17) + Math_fround(HEAPF32[i35 >> 2]));
     HEAPF32[i78 >> 2] = Math_fround(Math_fround(f17 * Math_fround(.282094806)) + f20);
     HEAPF32[i38 >> 2] = f21;
     HEAPF32[i36 >> 2] = f23;
     HEAPF32[i35 >> 2] = f22;
     f21 = Math_fround(HEAPF32[i34 >> 2]);
     f20 = Math_fround(HEAPF32[i33 >> 2]);
     f19 = Math_fround(HEAPF32[i32 >> 2]);
     f21 = Math_fround(Math_fround(f43 * f17) + f21);
     f20 = Math_fround(Math_fround(f44 * f17) + f20);
     f19 = Math_fround(Math_fround(f45 * f17) + f19);
     f18 = Math_fround(Math_fround(f46 * f17) + Math_fround(HEAPF32[i31 >> 2]));
     HEAPF32[i34 >> 2] = f21;
     HEAPF32[i33 >> 2] = f20;
     HEAPF32[i32 >> 2] = f19;
     HEAPF32[i31 >> 2] = f18;
     f17 = Math_fround(Math_fround(f47 * f17) + Math_fround(HEAPF32[i30 >> 2]));
     HEAPF32[i30 >> 2] = f17;
     f16 = Math_fround(HEAPF32[i29 >> 2]);
     f15 = Math_fround(HEAPF32[i28 >> 2]);
     f14 = Math_fround(HEAPF32[i27 >> 2]);
     f16 = Math_fround(Math_fround(f8 * Math_fround(.282094806)) + f16);
     f15 = Math_fround(Math_fround(f37 * f8) + f15);
     f14 = Math_fround(Math_fround(f39 * f8) + f14);
     f13 = Math_fround(Math_fround(f42 * f8) + Math_fround(HEAPF32[i26 >> 2]));
     HEAPF32[i29 >> 2] = f16;
     HEAPF32[i28 >> 2] = f15;
     HEAPF32[i27 >> 2] = f14;
     HEAPF32[i26 >> 2] = f13;
     f12 = Math_fround(HEAPF32[i25 >> 2]);
     f11 = Math_fround(HEAPF32[i24 >> 2]);
     f10 = Math_fround(HEAPF32[i3 >> 2]);
     f12 = Math_fround(Math_fround(f43 * f8) + f12);
     f11 = Math_fround(Math_fround(f44 * f8) + f11);
     f10 = Math_fround(Math_fround(f45 * f8) + f10);
     f9 = Math_fround(Math_fround(f46 * f8) + Math_fround(HEAPF32[i2 >> 2]));
     HEAPF32[i25 >> 2] = f12;
     HEAPF32[i24 >> 2] = f11;
     HEAPF32[i3 >> 2] = f10;
     HEAPF32[i2 >> 2] = f9;
     f8 = Math_fround(Math_fround(f47 * f8) + Math_fround(HEAPF32[i1 >> 2]));
     HEAPF32[i1 >> 2] = f8;
     f7 = Math_fround(HEAPF32[i64 >> 2]);
     f6 = Math_fround(HEAPF32[i66 >> 2]);
     f5 = Math_fround(HEAPF32[i67 >> 2]);
     f7 = Math_fround(Math_fround(f65 * Math_fround(.282094806)) + f7);
     f6 = Math_fround(Math_fround(f37 * f65) + f6);
     f5 = Math_fround(Math_fround(f39 * f65) + f5);
     f42 = Math_fround(Math_fround(f42 * f65) + Math_fround(HEAPF32[i68 >> 2]));
     HEAPF32[i64 >> 2] = f7;
     HEAPF32[i66 >> 2] = f6;
     HEAPF32[i67 >> 2] = f5;
     HEAPF32[i68 >> 2] = f42;
     f42 = Math_fround(HEAPF32[i69 >> 2]);
     f37 = Math_fround(HEAPF32[i70 >> 2]);
     f39 = Math_fround(HEAPF32[i71 >> 2]);
     f44 = Math_fround(Math_fround(f44 * f65) + f37);
     f45 = Math_fround(Math_fround(f45 * f65) + f39);
     f46 = Math_fround(Math_fround(f46 * f65) + Math_fround(HEAPF32[i72 >> 2]));
     HEAPF32[i69 >> 2] = Math_fround(Math_fround(f43 * f65) + f42);
     HEAPF32[i70 >> 2] = f44;
     HEAPF32[i71 >> 2] = f45;
     HEAPF32[i72 >> 2] = f46;
     HEAPF32[i40 >> 2] = Math_fround(Math_fround(f47 * f65) + Math_fround(HEAPF32[i40 >> 2]));
     f4 = Math_fround(f4 + f41);
     i50 = i50 + 1 | 0;
     if ((i50 | 0) == (i60 | 0)) break; else i49 = i49 + 4 | 0;
    }
    i48 = i48 + 1 | 0;
   } while ((i48 | 0) != (i60 | 0));
   i53 = i78;
   i52 = i68;
   i51 = i69;
   i50 = i70;
   i49 = i71;
   i48 = i72;
  } else {
   i36 = i78 + 8 | 0;
   i35 = i78 + 12 | 0;
   i34 = i78 + 16 | 0;
   i33 = i78 + 20 | 0;
   i32 = i78 + 24 | 0;
   i31 = i78 + 28 | 0;
   i30 = i78 + 32 | 0;
   i29 = i78 + 36 | 0;
   i28 = i78 + 40 | 0;
   i27 = i78 + 44 | 0;
   i26 = i78 + 48 | 0;
   i25 = i78 + 52 | 0;
   i24 = i78 + 56 | 0;
   i3 = i78 + 60 | 0;
   i2 = i78 + 64 | 0;
   i1 = i78 + 68 | 0;
   i64 = i78 + 72 | 0;
   i66 = i78 + 76 | 0;
   i76 = i78 + 80 | 0;
   f23 = Math_fround(HEAPF32[i36 >> 2]);
   f22 = Math_fround(HEAPF32[i35 >> 2]);
   f21 = Math_fround(HEAPF32[i34 >> 2]);
   f20 = Math_fround(HEAPF32[i33 >> 2]);
   f19 = Math_fround(HEAPF32[i32 >> 2]);
   f18 = Math_fround(HEAPF32[i31 >> 2]);
   f17 = Math_fround(HEAPF32[i30 >> 2]);
   f16 = Math_fround(HEAPF32[i29 >> 2]);
   f15 = Math_fround(HEAPF32[i28 >> 2]);
   f14 = Math_fround(HEAPF32[i27 >> 2]);
   f13 = Math_fround(HEAPF32[i26 >> 2]);
   f12 = Math_fround(HEAPF32[i25 >> 2]);
   f11 = Math_fround(HEAPF32[i24 >> 2]);
   f10 = Math_fround(HEAPF32[i3 >> 2]);
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   f8 = Math_fround(HEAPF32[i1 >> 2]);
   f7 = Math_fround(HEAPF32[i64 >> 2]);
   f6 = Math_fround(HEAPF32[i66 >> 2]);
   f4 = Math_fround(0.0);
   i53 = i78;
   i67 = i76;
   i52 = i78 + 84 | 0;
   i51 = i78 + 88 | 0;
   i50 = i78 + 92 | 0;
   i49 = i78 + 96 | 0;
   i48 = i78 + 100 | 0;
   i40 = i78 + 104 | 0;
   i38 = i78 + 4 | 0;
   f5 = Math_fround(HEAPF32[i76 >> 2]);
  }
  f44 = Math_fround(HEAPF32[gb + 0 >> 2]);
  HEAPF32[i53 >> 2] = Math_fround(f44 * Math_fround(HEAPF32[i53 >> 2]));
  f45 = Math_fround(HEAPF32[gb + 0 + 4 >> 2]);
  HEAPF32[i38 >> 2] = Math_fround(f45 * Math_fround(HEAPF32[i38 >> 2]));
  f46 = Math_fround(HEAPF32[gb + 0 + 8 >> 2]);
  HEAPF32[i36 >> 2] = Math_fround(f46 * f23);
  f47 = Math_fround(HEAPF32[gb + 0 + 12 >> 2]);
  HEAPF32[i35 >> 2] = Math_fround(f47 * f22);
  f58 = Math_fround(HEAPF32[gb + 0 + 16 >> 2]);
  HEAPF32[i34 >> 2] = Math_fround(f58 * f21);
  f59 = Math_fround(HEAPF32[gb + 0 + 20 >> 2]);
  HEAPF32[i33 >> 2] = Math_fround(f59 * f20);
  f61 = Math_fround(HEAPF32[gb + 0 + 24 >> 2]);
  HEAPF32[i32 >> 2] = Math_fround(f61 * f19);
  f62 = Math_fround(HEAPF32[gb + 0 + 28 >> 2]);
  HEAPF32[i31 >> 2] = Math_fround(f62 * f18);
  f65 = Math_fround(HEAPF32[gb + 0 + 32 >> 2]);
  HEAPF32[i30 >> 2] = Math_fround(f65 * f17);
  HEAPF32[i29 >> 2] = Math_fround(f44 * f16);
  HEAPF32[i28 >> 2] = Math_fround(f45 * f15);
  HEAPF32[i27 >> 2] = Math_fround(f46 * f14);
  HEAPF32[i26 >> 2] = Math_fround(f47 * f13);
  HEAPF32[i25 >> 2] = Math_fround(f58 * f12);
  HEAPF32[i24 >> 2] = Math_fround(f59 * f11);
  HEAPF32[i3 >> 2] = Math_fround(f61 * f10);
  HEAPF32[i2 >> 2] = Math_fround(f62 * f9);
  HEAPF32[i1 >> 2] = Math_fround(f65 * f8);
  HEAPF32[i64 >> 2] = Math_fround(f44 * f7);
  HEAPF32[i66 >> 2] = Math_fround(f45 * f6);
  HEAPF32[i67 >> 2] = Math_fround(f46 * f5);
  HEAPF32[i52 >> 2] = Math_fround(f47 * Math_fround(HEAPF32[i52 >> 2]));
  HEAPF32[i51 >> 2] = Math_fround(f58 * Math_fround(HEAPF32[i51 >> 2]));
  HEAPF32[i50 >> 2] = Math_fround(f59 * Math_fround(HEAPF32[i50 >> 2]));
  HEAPF32[i49 >> 2] = Math_fround(f61 * Math_fround(HEAPF32[i49 >> 2]));
  HEAPF32[i48 >> 2] = Math_fround(f62 * Math_fround(HEAPF32[i48 >> 2]));
  HEAPF32[i40 >> 2] = Math_fround(f65 * Math_fround(HEAPF32[i40 >> 2]));
  __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i77, i78, Math_fround(Math_fround(Math_fround(12.566371) / f4) / Math_fround(6.0)));
  STACKTOP = i79;
  return;
 }
 __ZN20SphericalHarmonicsL27SetZeroEv(i78);
 i60 = HEAP32[i3 + 4 >> 2] | 0;
 f65 = Math_fround(i60 | 0);
 f61 = Math_fround(Math_fround(1.0) / f65);
 f62 = Math_fround(f61 + Math_fround(-1.0));
 f65 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f61) * Math_fround(2.0)) / Math_fround(f65 + Math_fround(-1.0)));
 if ((i60 | 0) > 0) {
  i63 = HEAP32[i3 + 16 >> 2] | 0;
  i51 = HEAP32[i3 + 12 >> 2] | 0;
  i52 = i73 + 4 | 0;
  i53 = i73 + 8 | 0;
  i54 = i75 + 4 | 0;
  i55 = i75 + 8 | 0;
  i56 = i74 + 4 | 0;
  i57 = i74 + 8 | 0;
  i36 = i78 + 4 | 0;
  i35 = i78 + 8 | 0;
  i34 = i78 + 12 | 0;
  i33 = i78 + 16 | 0;
  i32 = i78 + 20 | 0;
  i31 = i78 + 24 | 0;
  i30 = i78 + 28 | 0;
  i29 = i78 + 32 | 0;
  i28 = i78 + 36 | 0;
  i27 = i78 + 40 | 0;
  i26 = i78 + 44 | 0;
  i25 = i78 + 48 | 0;
  i24 = i78 + 52 | 0;
  i3 = i78 + 56 | 0;
  i2 = i78 + 60 | 0;
  i1 = i78 + 64 | 0;
  i64 = i78 + 68 | 0;
  i66 = i78 + 72 | 0;
  i67 = i78 + 76 | 0;
  i68 = i78 + 80 | 0;
  i69 = i78 + 84 | 0;
  i70 = i78 + 88 | 0;
  i71 = i78 + 92 | 0;
  i72 = i78 + 96 | 0;
  i40 = i78 + 100 | 0;
  i38 = i78 + 104 | 0;
  i48 = 0;
  f4 = Math_fround(0.0);
  f5 = Math_fround(HEAPF32[i78 >> 2]);
  while (1) {
   f59 = Math_fround(f62 + Math_fround(f65 * Math_fround(i48 | 0)));
   f61 = Math_fround(f59 * f59);
   i49 = i63 + (Math_imul(i48, i51) | 0) | 0;
   i50 = 0;
   f58 = f4;
   while (1) {
    f37 = Math_fround(f62 + Math_fround(f65 * Math_fround(i50 | 0)));
    f47 = Math_fround(f61 + Math_fround(Math_fround(f37 * f37) + Math_fround(1.0)));
    f47 = Math_fround(Math_fround(4.0) / Math_fround(Math_fround(Math_sqrt(Math_fround(f47))) * f47));
    f39 = Math_fround(Math_fround(HEAPF32[i73 >> 2]) * f37);
    f45 = Math_fround(f37 * Math_fround(HEAPF32[i52 >> 2]));
    f37 = Math_fround(f37 * Math_fround(HEAPF32[i53 >> 2]));
    f39 = Math_fround(f39 + Math_fround(HEAPF32[i75 >> 2]));
    f45 = Math_fround(f45 + Math_fround(HEAPF32[i54 >> 2]));
    f37 = Math_fround(f37 + Math_fround(HEAPF32[i55 >> 2]));
    f4 = Math_fround(f59 * Math_fround(HEAPF32[i74 >> 2]));
    f46 = Math_fround(f59 * Math_fround(HEAPF32[i56 >> 2]));
    f4 = Math_fround(f39 + f4);
    f46 = Math_fround(f45 + f46);
    f37 = Math_fround(f37 + Math_fround(f59 * Math_fround(HEAPF32[i57 >> 2])));
    f45 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f46 * f46)) + Math_fround(f37 * f37))));
    f4 = Math_fround(f4 / f45);
    f46 = Math_fround(f46 / f45);
    f45 = Math_fround(f37 / f45);
    f37 = Math_fround(f46 * Math_fround(-.488602519));
    f39 = Math_fround(f45 * Math_fround(.488602519));
    f41 = Math_fround(f4 * Math_fround(-.488602519));
    f42 = Math_fround(Math_fround(f4 * f46) * Math_fround(1.09254849));
    f43 = Math_fround(Math_fround(f46 * f45) * Math_fround(-1.09254849));
    f44 = Math_fround(Math_fround(Math_fround(f45 * f45) + Math_fround(-.333333343)) * Math_fround(.946174681));
    f45 = Math_fround(Math_fround(f4 * f45) * Math_fround(-1.09254849));
    f46 = Math_fround(Math_fround(Math_fround(f4 * f4) - Math_fround(f46 * f46)) * Math_fround(.546274245));
    f4 = Math_fround(HEAPF32[i49 + 4 >> 2]);
    f6 = Math_fround(HEAPF32[i49 + 8 >> 2]);
    f7 = Math_fround(HEAPF32[i49 + 12 >> 2]);
    do if (i76) {
     do if (!(f4 <= Math_fround(.0404499993))) {
      if (f4 < Math_fround(1.0)) {
       f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
     } else f4 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
     do if (!(f6 <= Math_fround(.0404499993))) {
      if (f6 < Math_fround(1.0)) {
       f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f6 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f6 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f6, 2.20000005));
     } else f6 = Math_fround(f6 / Math_fround(12.9200001)); while (0);
     if (f7 <= Math_fround(.0404499993)) {
      f7 = Math_fround(f7 / Math_fround(12.9200001));
      break;
     }
     if (f7 < Math_fround(1.0)) {
      f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
    } while (0);
    f17 = Math_fround(f47 * f4);
    f8 = Math_fround(f47 * f6);
    f80 = Math_fround(f47 * f7);
    f21 = Math_fround(HEAPF32[i36 >> 2]);
    f23 = Math_fround(HEAPF32[i35 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f17 * Math_fround(.282094806)));
    f23 = Math_fround(Math_fround(f39 * f17) + f23);
    f22 = Math_fround(Math_fround(f41 * f17) + Math_fround(HEAPF32[i34 >> 2]));
    HEAPF32[i36 >> 2] = Math_fround(Math_fround(f37 * f17) + f21);
    HEAPF32[i35 >> 2] = f23;
    HEAPF32[i34 >> 2] = f22;
    f21 = Math_fround(HEAPF32[i33 >> 2]);
    f20 = Math_fround(HEAPF32[i32 >> 2]);
    f19 = Math_fround(HEAPF32[i31 >> 2]);
    f21 = Math_fround(Math_fround(f42 * f17) + f21);
    f20 = Math_fround(Math_fround(f43 * f17) + f20);
    f19 = Math_fround(Math_fround(f44 * f17) + f19);
    f18 = Math_fround(Math_fround(f45 * f17) + Math_fround(HEAPF32[i30 >> 2]));
    HEAPF32[i33 >> 2] = f21;
    HEAPF32[i32 >> 2] = f20;
    HEAPF32[i31 >> 2] = f19;
    HEAPF32[i30 >> 2] = f18;
    f17 = Math_fround(Math_fround(f46 * f17) + Math_fround(HEAPF32[i29 >> 2]));
    HEAPF32[i29 >> 2] = f17;
    f16 = Math_fround(HEAPF32[i28 >> 2]);
    f15 = Math_fround(HEAPF32[i27 >> 2]);
    f14 = Math_fround(HEAPF32[i26 >> 2]);
    f16 = Math_fround(Math_fround(f8 * Math_fround(.282094806)) + f16);
    f15 = Math_fround(Math_fround(f37 * f8) + f15);
    f14 = Math_fround(Math_fround(f39 * f8) + f14);
    f13 = Math_fround(Math_fround(f41 * f8) + Math_fround(HEAPF32[i25 >> 2]));
    HEAPF32[i28 >> 2] = f16;
    HEAPF32[i27 >> 2] = f15;
    HEAPF32[i26 >> 2] = f14;
    HEAPF32[i25 >> 2] = f13;
    f12 = Math_fround(HEAPF32[i24 >> 2]);
    f11 = Math_fround(HEAPF32[i3 >> 2]);
    f10 = Math_fround(HEAPF32[i2 >> 2]);
    f12 = Math_fround(Math_fround(f42 * f8) + f12);
    f11 = Math_fround(Math_fround(f43 * f8) + f11);
    f10 = Math_fround(Math_fround(f44 * f8) + f10);
    f9 = Math_fround(Math_fround(f45 * f8) + Math_fround(HEAPF32[i1 >> 2]));
    HEAPF32[i24 >> 2] = f12;
    HEAPF32[i3 >> 2] = f11;
    HEAPF32[i2 >> 2] = f10;
    HEAPF32[i1 >> 2] = f9;
    f8 = Math_fround(Math_fround(f46 * f8) + Math_fround(HEAPF32[i64 >> 2]));
    HEAPF32[i64 >> 2] = f8;
    f7 = Math_fround(HEAPF32[i66 >> 2]);
    f6 = Math_fround(HEAPF32[i67 >> 2]);
    f4 = Math_fround(HEAPF32[i68 >> 2]);
    f7 = Math_fround(Math_fround(f80 * Math_fround(.282094806)) + f7);
    f6 = Math_fround(Math_fround(f37 * f80) + f6);
    f4 = Math_fround(Math_fround(f39 * f80) + f4);
    f41 = Math_fround(Math_fround(f41 * f80) + Math_fround(HEAPF32[i69 >> 2]));
    HEAPF32[i66 >> 2] = f7;
    HEAPF32[i67 >> 2] = f6;
    HEAPF32[i68 >> 2] = f4;
    HEAPF32[i69 >> 2] = f41;
    f41 = Math_fround(HEAPF32[i70 >> 2]);
    f37 = Math_fround(HEAPF32[i71 >> 2]);
    f39 = Math_fround(HEAPF32[i72 >> 2]);
    f43 = Math_fround(Math_fround(f43 * f80) + f37);
    f44 = Math_fround(Math_fround(f44 * f80) + f39);
    f45 = Math_fround(Math_fround(f45 * f80) + Math_fround(HEAPF32[i40 >> 2]));
    HEAPF32[i70 >> 2] = Math_fround(Math_fround(f42 * f80) + f41);
    HEAPF32[i71 >> 2] = f43;
    HEAPF32[i72 >> 2] = f44;
    HEAPF32[i40 >> 2] = f45;
    HEAPF32[i38 >> 2] = Math_fround(Math_fround(f46 * f80) + Math_fround(HEAPF32[i38 >> 2]));
    f58 = Math_fround(f58 + f47);
    i50 = i50 + 1 | 0;
    if ((i50 | 0) == (i60 | 0)) break; else i49 = i49 + 16 | 0;
   }
   i48 = i48 + 1 | 0;
   if ((i48 | 0) == (i60 | 0)) break; else f4 = f58;
  }
  HEAPF32[i78 >> 2] = f5;
  i53 = i78;
  i52 = i68;
  i51 = i69;
  i50 = i70;
  i49 = i71;
  i48 = i72;
 } else {
  i35 = i78 + 8 | 0;
  i34 = i78 + 12 | 0;
  i33 = i78 + 16 | 0;
  i32 = i78 + 20 | 0;
  i31 = i78 + 24 | 0;
  i30 = i78 + 28 | 0;
  i29 = i78 + 32 | 0;
  i28 = i78 + 36 | 0;
  i27 = i78 + 40 | 0;
  i26 = i78 + 44 | 0;
  i25 = i78 + 48 | 0;
  i24 = i78 + 52 | 0;
  i3 = i78 + 56 | 0;
  i2 = i78 + 60 | 0;
  i1 = i78 + 64 | 0;
  i64 = i78 + 68 | 0;
  i66 = i78 + 72 | 0;
  i67 = i78 + 76 | 0;
  i76 = i78 + 80 | 0;
  f5 = Math_fround(HEAPF32[i78 >> 2]);
  f23 = Math_fround(HEAPF32[i35 >> 2]);
  f22 = Math_fround(HEAPF32[i34 >> 2]);
  f21 = Math_fround(HEAPF32[i33 >> 2]);
  f20 = Math_fround(HEAPF32[i32 >> 2]);
  f19 = Math_fround(HEAPF32[i31 >> 2]);
  f18 = Math_fround(HEAPF32[i30 >> 2]);
  f17 = Math_fround(HEAPF32[i29 >> 2]);
  f16 = Math_fround(HEAPF32[i28 >> 2]);
  f15 = Math_fround(HEAPF32[i27 >> 2]);
  f14 = Math_fround(HEAPF32[i26 >> 2]);
  f13 = Math_fround(HEAPF32[i25 >> 2]);
  f12 = Math_fround(HEAPF32[i24 >> 2]);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(HEAPF32[i64 >> 2]);
  f7 = Math_fround(HEAPF32[i66 >> 2]);
  f6 = Math_fround(HEAPF32[i67 >> 2]);
  f58 = Math_fround(0.0);
  i53 = i78;
  i52 = i76;
  i51 = i78 + 84 | 0;
  i50 = i78 + 88 | 0;
  i49 = i78 + 92 | 0;
  i48 = i78 + 96 | 0;
  i40 = i78 + 100 | 0;
  i38 = i78 + 104 | 0;
  i36 = i78 + 4 | 0;
  f4 = Math_fround(HEAPF32[i76 >> 2]);
 }
 f44 = Math_fround(HEAPF32[gb + 0 >> 2]);
 HEAPF32[i53 >> 2] = Math_fround(f44 * f5);
 f45 = Math_fround(HEAPF32[gb + 0 + 4 >> 2]);
 HEAPF32[i36 >> 2] = Math_fround(f45 * Math_fround(HEAPF32[i36 >> 2]));
 f46 = Math_fround(HEAPF32[gb + 0 + 8 >> 2]);
 HEAPF32[i35 >> 2] = Math_fround(f46 * f23);
 f47 = Math_fround(HEAPF32[gb + 0 + 12 >> 2]);
 HEAPF32[i34 >> 2] = Math_fround(f47 * f22);
 f59 = Math_fround(HEAPF32[gb + 0 + 16 >> 2]);
 HEAPF32[i33 >> 2] = Math_fround(f59 * f21);
 f61 = Math_fround(HEAPF32[gb + 0 + 20 >> 2]);
 HEAPF32[i32 >> 2] = Math_fround(f61 * f20);
 f62 = Math_fround(HEAPF32[gb + 0 + 24 >> 2]);
 HEAPF32[i31 >> 2] = Math_fround(f62 * f19);
 f65 = Math_fround(HEAPF32[gb + 0 + 28 >> 2]);
 HEAPF32[i30 >> 2] = Math_fround(f65 * f18);
 f80 = Math_fround(HEAPF32[gb + 0 + 32 >> 2]);
 HEAPF32[i29 >> 2] = Math_fround(f80 * f17);
 HEAPF32[i28 >> 2] = Math_fround(f44 * f16);
 HEAPF32[i27 >> 2] = Math_fround(f45 * f15);
 HEAPF32[i26 >> 2] = Math_fround(f46 * f14);
 HEAPF32[i25 >> 2] = Math_fround(f47 * f13);
 HEAPF32[i24 >> 2] = Math_fround(f59 * f12);
 HEAPF32[i3 >> 2] = Math_fround(f61 * f11);
 HEAPF32[i2 >> 2] = Math_fround(f62 * f10);
 HEAPF32[i1 >> 2] = Math_fround(f65 * f9);
 HEAPF32[i64 >> 2] = Math_fround(f80 * f8);
 HEAPF32[i66 >> 2] = Math_fround(f44 * f7);
 HEAPF32[i67 >> 2] = Math_fround(f45 * f6);
 HEAPF32[i52 >> 2] = Math_fround(f46 * f4);
 HEAPF32[i51 >> 2] = Math_fround(f47 * Math_fround(HEAPF32[i51 >> 2]));
 HEAPF32[i50 >> 2] = Math_fround(f59 * Math_fround(HEAPF32[i50 >> 2]));
 HEAPF32[i49 >> 2] = Math_fround(f61 * Math_fround(HEAPF32[i49 >> 2]));
 HEAPF32[i48 >> 2] = Math_fround(f62 * Math_fround(HEAPF32[i48 >> 2]));
 HEAPF32[i40 >> 2] = Math_fround(f65 * Math_fround(HEAPF32[i40 >> 2]));
 HEAPF32[i38 >> 2] = Math_fround(f80 * Math_fround(HEAPF32[i38 >> 2]));
 __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i77, i78, Math_fround(Math_fround(Math_fround(12.566371) / f58) / Math_fround(6.0)));
 STACKTOP = i79;
 return;
}

function __ZN5physx2Gu29computeConvex_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbRNS_10PxSweepHitE(i129, i128, i126, i25, f23, f1, i127, i27) {
 i129 = i129 | 0;
 i128 = i128 | 0;
 i126 = i126 | 0;
 i25 = i25 | 0;
 f23 = Math_fround(f23);
 f1 = Math_fround(f1);
 i127 = i127 | 0;
 i27 = i27 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i26 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, f97 = f0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f105 = f0, f106 = f0, f107 = f0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0, f156 = f0, f157 = f0, f158 = f0, f159 = f0, f160 = f0, f161 = f0, f162 = f0, f163 = f0, i164 = 0;
 i140 = STACKTOP;
 STACKTOP = STACKTOP + 6256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i114 = i140 + 6240 | 0;
 i122 = i140 + 6228 | 0;
 i115 = i140 + 6216 | 0;
 i118 = i140 + 432 | 0;
 i121 = i140 + 6136 | 0;
 i5 = i140 + 6144 | 0;
 i18 = i140 + 6064 | 0;
 i113 = i140 + 192 | 0;
 i22 = i140 + 112 | 0;
 i21 = i140 + 96 | 0;
 i112 = i140 + 224 | 0;
 i20 = i140 + 80 | 0;
 i111 = i140 + 128 | 0;
 i117 = i140;
 i139 = i140 + 4584 | 0;
 i26 = i140 + 6016 | 0;
 i123 = i140 + 5944 | 0;
 i120 = i140 + 4568 | 0;
 i124 = i140 + 4540 | 0;
 i116 = i140 + 5880 | 0;
 i119 = i140 + 16 | 0;
 i108 = i140 + 4528 | 0;
 i125 = i140 + 4600 | 0;
 i29 = HEAP32[i129 + 36 >> 2] | 0;
 i109 = HEAP32[i126 + 32 >> 2] | 0;
 i110 = HEAP32[i29 + 168 >> 2] | 0;
 HEAP32[i121 >> 2] = 0;
 i24 = i129 + 4 | 0;
 if (Math_fround(HEAPF32[i24 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i129 + 8 >> 2]) == Math_fround(1.0)) i3 = Math_fround(HEAPF32[i129 + 12 >> 2]) == Math_fround(1.0); else i3 = 0; else i3 = 0;
 HEAP32[i5 >> 2] = 1065353216;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 1065353216;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 1065353216;
 HEAP32[i5 + 36 >> 2] = 1065353216;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 1065353216;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 1065353216;
 if (!i3) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i5, i24, i129 + 16 | 0);
 i19 = i109 + 16 | 0;
 i3 = i126 + 4 | 0;
 f107 = Math_fround(HEAPF32[i3 >> 2]);
 i137 = f107 == Math_fround(1.0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f107, HEAP32[tempDoublePtr >> 2] | 0);
 if (i137) if (Math_fround(HEAPF32[i126 + 8 >> 2]) == Math_fround(1.0)) i28 = Math_fround(HEAPF32[i126 + 12 >> 2]) == Math_fround(1.0); else i28 = 0; else i28 = 0;
 HEAP32[i18 >> 2] = 1065353216;
 i12 = i18 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i18 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i14 = i18 + 16 | 0;
 HEAP32[i14 >> 2] = 1065353216;
 i15 = i18 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 i16 = i18 + 28 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 32 | 0;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i18 + 36 >> 2] = 1065353216;
 HEAP32[i18 + 40 >> 2] = 0;
 HEAP32[i18 + 44 >> 2] = 0;
 HEAP32[i18 + 48 >> 2] = 0;
 HEAP32[i18 + 52 >> 2] = 1065353216;
 HEAP32[i18 + 56 >> 2] = 0;
 HEAP32[i18 + 60 >> 2] = 0;
 HEAP32[i18 + 64 >> 2] = 0;
 HEAP32[i18 + 68 >> 2] = 1065353216;
 if (i28) {
  f1 = Math_fround(1.0);
  f2 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(1.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(1.0);
 } else {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i18, i3, i126 + 16 | 0);
  f1 = Math_fround(HEAPF32[i18 >> 2]);
  f2 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f6 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f8 = Math_fround(HEAPF32[i15 >> 2]);
  f9 = Math_fround(HEAPF32[i18 + 24 >> 2]);
  f10 = Math_fround(HEAPF32[i16 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  i5 = HEAP32[i3 >> 2] | 0;
 }
 f105 = Math_fround(HEAPF32[i109 + 40 >> 2]);
 f107 = Math_fround(f105 * f1);
 f106 = Math_fround(f105 * f2);
 f105 = Math_fround(f105 * f4);
 f87 = Math_fround(HEAPF32[i109 + 44 >> 2]);
 f107 = Math_fround(f107 + Math_fround(f87 * f6));
 f106 = Math_fround(f106 + Math_fround(f87 * f7));
 f87 = Math_fround(f105 + Math_fround(f87 * f8));
 f105 = Math_fround(HEAPF32[i109 + 48 >> 2]);
 f107 = Math_fround(f107 + Math_fround(f105 * f9));
 f106 = Math_fround(f106 + Math_fround(f105 * f10));
 f105 = Math_fround(f87 + Math_fround(f105 * f11));
 i100 = HEAP32[i25 + 4 >> 2] | 0;
 i101 = HEAP32[i25 + 8 >> 2] | 0;
 i102 = HEAP32[i25 + 12 >> 2] | 0;
 i14 = i25 + 16 | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i14 = HEAP32[i14 + 8 >> 2] | 0;
 HEAP32[i113 >> 2] = HEAP32[i25 >> 2];
 i99 = i113 + 4 | 0;
 HEAP32[i99 >> 2] = i100;
 i100 = i113 + 8 | 0;
 HEAP32[i100 >> 2] = i101;
 i101 = i113 + 12 | 0;
 HEAP32[i101 >> 2] = i102;
 HEAP32[i113 + 16 >> 2] = i12;
 i102 = i113 + 20 | 0;
 HEAP32[i102 >> 2] = i13;
 i103 = i113 + 24 | 0;
 HEAP32[i103 >> 2] = i14;
 i104 = i113 + 28 | 0;
 HEAPF32[i104 >> 2] = Math_fround(0.0);
 i137 = HEAP32[i126 + 8 >> 2] | 0;
 i3 = HEAP32[i126 + 12 >> 2] | 0;
 HEAP32[i22 >> 2] = i5;
 HEAP32[i22 + 4 >> 2] = i137;
 HEAP32[i22 + 8 >> 2] = i3;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 i133 = i126 + 16 | 0;
 i134 = HEAP32[i133 + 4 >> 2] | 0;
 i135 = HEAP32[i133 + 8 >> 2] | 0;
 i136 = HEAP32[i133 + 12 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i133 >> 2];
 HEAP32[i21 + 4 >> 2] = i134;
 HEAP32[i21 + 8 >> 2] = i135;
 HEAP32[i21 + 12 >> 2] = i136;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i112, i19, i20, i22, i21);
 f87 = Math_fround(HEAPF32[i109 + 68 >> 2]);
 f88 = Math_fround(HEAPF32[i109 + 72 >> 2]);
 f97 = Math_fround(HEAPF32[i109 + 76 >> 2]);
 f89 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f90 = (HEAP32[tempDoublePtr >> 2] = i137, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f89 = Math_fround(f87 * f89);
 f90 = Math_fround(f88 * f90);
 f97 = Math_fround(f97 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f90 = f89 <= f90 ? f89 : f90;
 f97 = Math_fround(Math_fround((f90 <= f97 ? f90 : f97) * Math_fround(.25)) + f23);
 HEAPF32[i117 >> 2] = f97;
 __ZN5physx2Gu9ContainerC2Ev(i139);
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i139, 128, i3, 1);
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i26, i128, i24);
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i112, i28, i123);
 f38 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAP32[i124 >> 2] = HEAP32[i25 >> 2];
 i91 = i124 + 4 | 0;
 HEAP32[i91 >> 2] = HEAP32[i25 + 4 >> 2];
 i92 = i124 + 8 | 0;
 HEAP32[i92 >> 2] = HEAP32[i25 + 8 >> 2];
 i93 = i124 + 12 | 0;
 HEAP32[i93 >> 2] = HEAP32[i25 + 12 >> 2];
 i94 = i124 + 16 | 0;
 HEAP32[i94 >> 2] = HEAP32[i25 + 16 >> 2];
 i95 = i124 + 20 | 0;
 HEAP32[i95 >> 2] = HEAP32[i25 + 20 >> 2];
 i96 = i124 + 24 | 0;
 HEAP32[i96 >> 2] = HEAP32[i25 + 24 >> 2];
 i62 = i139 + 4 | 0;
 i63 = i113 + 16 | 0;
 i64 = i112 + 96 | 0;
 i65 = i112 + 144 | 0;
 i66 = i111 + 32 | 0;
 i67 = i111 + 36 | 0;
 i68 = i111 + 40 | 0;
 i69 = i111 + 44 | 0;
 i70 = i28 & 1;
 i71 = i111 + 48 | 0;
 i72 = i111 + 16 | 0;
 i73 = i111 + 20 | 0;
 i74 = i111 + 24 | 0;
 i75 = i111 + 28 | 0;
 i76 = i116 + 48 | 0;
 i77 = i116 + 52 | 0;
 i78 = i116 + 56 | 0;
 i79 = i124 + 16 | 0;
 f80 = Math_fround(HEAPF32[i26 >> 2]);
 f81 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f82 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f83 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f84 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 f85 = Math_fround(HEAPF32[i26 + 20 >> 2]);
 f86 = Math_fround(HEAPF32[i26 + 24 >> 2]);
 f87 = Math_fround(HEAPF32[i26 + 28 >> 2]);
 f88 = Math_fround(HEAPF32[i26 + 32 >> 2]);
 f89 = Math_fround(HEAPF32[i26 + 36 >> 2]);
 f90 = Math_fround(HEAPF32[i26 + 40 >> 2]);
 f45 = Math_fround(HEAPF32[i26 + 44 >> 2]);
 i46 = i119 + 48 | 0;
 i47 = i119 + 52 | 0;
 i48 = i119 + 56 | 0;
 i49 = i119 + 60 | 0;
 i50 = i119 + 4 | 0;
 i51 = i119 + 8 | 0;
 i52 = i119 + 12 | 0;
 i53 = i119 + 16 | 0;
 i54 = i119 + 20 | 0;
 i55 = i119 + 24 | 0;
 i56 = i119 + 28 | 0;
 i57 = i119 + 32 | 0;
 i58 = i119 + 36 | 0;
 i59 = i119 + 40 | 0;
 i60 = i119 + 44 | 0;
 i61 = i139 + 8 | 0;
 i131 = i27 + 40 | 0;
 i132 = i27 + 16 | 0;
 i133 = i27 + 20 | 0;
 i134 = i27 + 24 | 0;
 i135 = i27 + 28 | 0;
 i136 = i27 + 32 | 0;
 i137 = i27 + 36 | 0;
 i130 = i27 + 8 | 0;
 i42 = i118 + 44 | 0;
 i43 = i29 + 172 | 0;
 i44 = i29 + 28 | 0;
 i41 = i29 + 24 | 0;
 i37 = i28 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 f11 = Math_fround(0.0);
 f8 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 i5 = 268435455;
 i12 = 0;
 i13 = 0;
 i14 = 0;
 f7 = Math_fround(0.0);
 f9 = Math_fround(0.0);
 f10 = Math_fround(0.0);
 i3 = 0;
 i98 = 0;
 while (1) {
  if (HEAP32[i62 >> 2] | 0) HEAP32[i62 >> 2] = 0;
  HEAPF32[i94 >> 2] = f38;
  HEAPF32[i95 >> 2] = f39;
  HEAPF32[i96 >> 2] = f40;
  HEAPF32[i63 >> 2] = f38;
  HEAPF32[i102 >> 2] = f39;
  HEAPF32[i103 >> 2] = f40;
  HEAPF32[i104 >> 2] = Math_fround(0.0);
  HEAP32[i66 >> 2] = i113;
  HEAP32[i67 >> 2] = i64;
  HEAP32[i68 >> 2] = i65;
  HEAP8[i69 >> 0] = i70;
  HEAP32[i111 >> 2] = i37;
  HEAP32[i71 >> 2] = i112;
  HEAPF32[i72 >> 2] = f107;
  HEAPF32[i73 >> 2] = f106;
  HEAPF32[i74 >> 2] = f105;
  HEAPF32[i75 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE(i116, i126, i109, i124);
  HEAPF32[i76 >> 2] = Math_fround(f97 + Math_fround(HEAPF32[i76 >> 2]));
  HEAPF32[i77 >> 2] = Math_fround(f97 + Math_fround(HEAPF32[i77 >> 2]));
  HEAPF32[i78 >> 2] = Math_fround(f97 + Math_fround(HEAPF32[i78 >> 2]));
  __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE(i129, i128, i116, i139);
  i34 = HEAP32[i62 >> 2] | 0;
  if (!i34) {
   i138 = 15;
   break;
  }
  f157 = Math_fround(HEAPF32[i79 >> 2]);
  f152 = Math_fround(HEAPF32[i95 >> 2]);
  f157 = Math_fround(f157 * Math_fround(-2.0));
  f152 = Math_fround(f152 * Math_fround(-2.0));
  f154 = Math_fround(Math_fround(HEAPF32[i96 >> 2]) * Math_fround(-2.0));
  f155 = Math_fround(HEAPF32[i93 >> 2]);
  f156 = Math_fround(Math_fround(f155 * f155) + Math_fround(-.5));
  f159 = Math_fround(HEAPF32[i124 >> 2]);
  f158 = Math_fround(f157 * f159);
  f153 = Math_fround(HEAPF32[i91 >> 2]);
  f158 = Math_fround(f158 + Math_fround(f152 * f153));
  f151 = Math_fround(HEAPF32[i92 >> 2]);
  f158 = Math_fround(f158 + Math_fround(f154 * f151));
  f145 = Math_fround(-f159);
  f144 = Math_fround(-f153);
  f162 = Math_fround(-f151);
  f160 = Math_fround(f145 - f159);
  f146 = Math_fround(f144 - f153);
  f150 = Math_fround(f162 - f151);
  f147 = Math_fround(f155 * f160);
  f143 = Math_fround(f155 * f146);
  f149 = Math_fround(f155 * f150);
  f142 = Math_fround(f146 * f145);
  f148 = Math_fround(f150 * f145);
  f146 = Math_fround(f146 * f144);
  f144 = Math_fround(f150 * f144);
  f162 = Math_fround(f150 * f162);
  f150 = Math_fround(Math_fround(Math_fround(1.0) - f146) - f162);
  f163 = Math_fround(f142 + f149);
  f161 = Math_fround(f148 - f143);
  f149 = Math_fround(f142 - f149);
  f145 = Math_fround(Math_fround(1.0) - Math_fround(f160 * f145));
  f162 = Math_fround(f145 - f162);
  f160 = Math_fround(f147 + f144);
  f148 = Math_fround(f143 + f148);
  f147 = Math_fround(f144 - f147);
  f146 = Math_fround(f145 - f146);
  f145 = Math_fround(Math_fround(f82 * f148) + Math_fround(Math_fround(f80 * f150) + Math_fround(f81 * f149)));
  f144 = Math_fround(Math_fround(f82 * f147) + Math_fround(Math_fround(f80 * f163) + Math_fround(f81 * f162)));
  f143 = Math_fround(Math_fround(f146 * f82) + Math_fround(Math_fround(f80 * f161) + Math_fround(f81 * f160)));
  f142 = Math_fround(Math_fround(Math_fround(f150 * f83) + Math_fround(f149 * f84)) + Math_fround(f148 * f85));
  f141 = Math_fround(Math_fround(Math_fround(f163 * f83) + Math_fround(f162 * f84)) + Math_fround(f147 * f85));
  f23 = Math_fround(Math_fround(Math_fround(f161 * f83) + Math_fround(f160 * f84)) + Math_fround(f146 * f85));
  f30 = Math_fround(Math_fround(Math_fround(f150 * f86) + Math_fround(f149 * f87)) + Math_fround(f148 * f88));
  f31 = Math_fround(Math_fround(Math_fround(f163 * f86) + Math_fround(f162 * f87)) + Math_fround(f147 * f88));
  f32 = Math_fround(Math_fround(Math_fround(f161 * f86) + Math_fround(f160 * f87)) + Math_fround(f146 * f88));
  f147 = Math_fround(Math_fround(Math_fround(f153 * f158) + Math_fround(Math_fround(f152 * f156) - Math_fround(f155 * Math_fround(Math_fround(f157 * f151) - Math_fround(f154 * f159))))) + Math_fround(Math_fround(Math_fround(f163 * f89) + Math_fround(f162 * f90)) + Math_fround(f147 * f45)));
  f146 = Math_fround(Math_fround(Math_fround(Math_fround(f154 * f156) - Math_fround(f155 * Math_fround(Math_fround(f152 * f159) - Math_fround(f157 * f153)))) + Math_fround(f151 * f158)) + Math_fround(Math_fround(Math_fround(f161 * f89) + Math_fround(f160 * f90)) + Math_fround(f146 * f45)));
  HEAPF32[i46 >> 2] = Math_fround(Math_fround(Math_fround(f159 * f158) + Math_fround(Math_fround(f157 * f156) - Math_fround(f155 * Math_fround(Math_fround(f154 * f153) - Math_fround(f152 * f151))))) + Math_fround(Math_fround(Math_fround(f150 * f89) + Math_fround(f149 * f90)) + Math_fround(f148 * f45)));
  HEAPF32[i47 >> 2] = f147;
  HEAPF32[i48 >> 2] = f146;
  HEAPF32[i49 >> 2] = Math_fround(0.0);
  HEAPF32[i119 >> 2] = f145;
  HEAPF32[i50 >> 2] = f144;
  HEAPF32[i51 >> 2] = f143;
  HEAPF32[i52 >> 2] = Math_fround(0.0);
  HEAPF32[i53 >> 2] = f142;
  HEAPF32[i54 >> 2] = f141;
  HEAPF32[i55 >> 2] = f23;
  HEAPF32[i56 >> 2] = Math_fround(0.0);
  HEAPF32[i57 >> 2] = f30;
  HEAPF32[i58 >> 2] = f31;
  HEAPF32[i59 >> 2] = f32;
  HEAPF32[i60 >> 2] = Math_fround(0.0);
  i35 = HEAP32[i61 >> 2] | 0;
  HEAP32[i120 >> 2] = HEAP32[i108 >> 2];
  HEAP32[i120 + 4 >> 2] = HEAP32[i108 + 4 >> 2];
  HEAP32[i120 + 8 >> 2] = HEAP32[i108 + 8 >> 2];
  i36 = (i34 + 31 | 0) >>> 5;
  if (!i36) {
   i138 = 39;
   break;
  }
  i15 = 2139095039;
  i28 = 0;
  i29 = 0;
  i33 = ~i34;
  while (1) {
   i17 = i33 >>> 0 > 4294967263 ? ~i33 : 32;
   i26 = i28 << 5;
   i27 = i34 - i26 | 0;
   i27 = i27 >>> 0 < 32 ? i27 : 32;
   i18 = (i27 | 0) == 0;
   if (i18) {
    HEAP32[i115 >> 2] = HEAP32[i120 >> 2];
    HEAP32[i115 + 4 >> 2] = HEAP32[i120 + 4 >> 2];
    HEAP32[i115 + 8 >> 2] = HEAP32[i120 + 8 >> 2];
    i16 = i12;
    f30 = f7;
    f31 = f9;
    f32 = f10;
    i12 = 0;
   } else {
    i16 = HEAP32[i44 >> 2] | 0;
    i19 = (HEAP8[i43 >> 0] & 2) == 0;
    i21 = 0;
    do {
     i20 = HEAP32[i35 + (i21 + i26 << 2) >> 2] | 0;
     if (i19) {
      i22 = HEAP32[i16 + (i20 * 12 | 0) >> 2] | 0;
      i24 = HEAP32[i16 + (i20 * 12 | 0) + 4 >> 2] | 0;
      i25 = HEAP32[i16 + (i20 * 12 | 0) + 8 >> 2] | 0;
     } else {
      i22 = HEAPU16[i16 + (i20 * 6 | 0) >> 1] | 0;
      i24 = HEAPU16[i16 + (i20 * 6 | 0) + 2 >> 1] | 0;
      i25 = HEAPU16[i16 + (i20 * 6 | 0) + 4 >> 1] | 0;
     }
     i164 = HEAP32[i41 >> 2] | 0;
     HEAP32[i125 + (i21 * 40 | 0) >> 2] = HEAP32[i164 + (i22 * 12 | 0) >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 4 >> 2] = HEAP32[i164 + (i22 * 12 | 0) + 4 >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 8 >> 2] = HEAP32[i164 + (i22 * 12 | 0) + 8 >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 12 >> 2] = HEAP32[i164 + (i24 * 12 | 0) >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 16 >> 2] = HEAP32[i164 + (i24 * 12 | 0) + 4 >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 20 >> 2] = HEAP32[i164 + (i24 * 12 | 0) + 8 >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 24 >> 2] = HEAP32[i164 + (i25 * 12 | 0) >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 28 >> 2] = HEAP32[i164 + (i25 * 12 | 0) + 4 >> 2];
     HEAP32[i125 + (i21 * 40 | 0) + 32 >> 2] = HEAP32[i164 + (i25 * 12 | 0) + 8 >> 2];
     HEAP8[i125 + (i21 * 40 | 0) + 36 >> 0] = HEAP8[i110 + i20 >> 0] | 0;
     i21 = i21 + 1 | 0;
    } while ((i21 | 0) != (i17 | 0));
    HEAP32[i115 >> 2] = HEAP32[i120 >> 2];
    HEAP32[i115 + 4 >> 2] = HEAP32[i120 + 4 >> 2];
    HEAP32[i115 + 8 >> 2] = HEAP32[i120 + 8 >> 2];
    if (i18) {
     i16 = i12;
     f30 = f7;
     f31 = f9;
     f32 = f10;
     i12 = 0;
    } else {
     i21 = i12;
     i12 = 0;
     i22 = 0;
     while (1) {
      HEAP32[i121 >> 2] = 0;
      i20 = i22 + i26 | 0;
      __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i123, i111, i125 + (i22 * 40 | 0) | 0, i20, HEAP8[i125 + (i22 * 40 | 0) + 36 >> 0] | 0, i117, i127, i113, i119, i118, i121) | 0;
      i19 = HEAP32[i121 >> 2] | 0;
      if (!i19) i16 = i21; else {
       i12 = HEAP32[i42 >> 2] | 0;
       if (i19 >>> 0 > 1) {
        i16 = i12;
        i17 = 0;
        i18 = 1;
        while (1) {
         i12 = HEAP32[i118 + (i18 << 6) + 44 >> 2] | 0;
         f163 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f163 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
          HEAP32[i114 >> 2] = HEAP32[i122 >> 2];
          HEAP32[i114 + 4 >> 2] = HEAP32[i122 + 4 >> 2];
          HEAP32[i114 + 8 >> 2] = HEAP32[i122 + 8 >> 2];
          i17 = i18;
         } else i12 = i16;
         i18 = i18 + 1 | 0;
         if ((i18 | 0) == (i19 | 0)) break; else i16 = i12;
        }
       } else i17 = 0;
       f163 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f163 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
        HEAP32[i115 >> 2] = HEAP32[i114 >> 2];
        HEAP32[i115 + 4 >> 2] = HEAP32[i114 + 4 >> 2];
        HEAP32[i115 + 8 >> 2] = HEAP32[i114 + 8 >> 2];
        f7 = Math_fround(HEAPF32[i118 + (i17 << 6) + 16 >> 2]);
        f9 = Math_fround(HEAPF32[i118 + (i17 << 6) + 20 >> 2]);
        f10 = Math_fround(HEAPF32[i118 + (i17 << 6) + 24 >> 2]);
        i14 = HEAP32[i118 + (i17 << 6) + 40 >> 2] | 0;
        i13 = HEAP32[i118 + (i17 << 6) + 36 >> 2] | 0;
        i16 = HEAP32[i118 + (i17 << 6) + 32 >> 2] | 0;
        i5 = i20;
        i15 = i12;
       } else i16 = i21;
       i12 = 1;
      }
      i22 = i22 + 1 | 0;
      if ((i22 | 0) == (i27 | 0)) {
       f30 = f7;
       f31 = f9;
       f32 = f10;
       break;
      } else i21 = i16;
     }
    }
   };
   HEAP32[i120 >> 2] = HEAP32[i115 >> 2];
   HEAP32[i120 + 4 >> 2] = HEAP32[i115 + 4 >> 2];
   HEAP32[i120 + 8 >> 2] = HEAP32[i115 + 8 >> 2];
   i29 = i29 | i12;
   i28 = i28 + 1 | 0;
   if ((i28 | 0) == (i36 | 0)) break; else {
    i12 = i16;
    f7 = f30;
    f9 = f31;
    f10 = f32;
    i33 = i33 + 32 | 0;
   }
  }
  if (!i29) {
   i138 = 39;
   break;
  }
  i5 = HEAP32[i35 + (i5 << 2) >> 2] | 0;
  f163 = Math_fround(HEAPF32[i113 >> 2]);
  f23 = Math_fround(HEAPF32[i99 >> 2]);
  f160 = Math_fround(HEAPF32[i100 >> 2]);
  f162 = Math_fround(HEAPF32[i101 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(Math_fround(f162 * f162) + Math_fround(-.5));
  f161 = Math_fround(Math_fround(Math_fround(f11 * f163) + Math_fround(f8 * f23)) + Math_fround(f7 * f160));
  f10 = Math_fround(Math_fround(Math_fround(f163 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f7 * f23) - Math_fround(f8 * f160))) + Math_fround(f11 * f6))) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(Math_fround(f23 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f11 * f160) - Math_fround(f7 * f163))) + Math_fround(f8 * f6))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(Math_fround(f160 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f8 * f163) - Math_fround(f11 * f23))) + Math_fround(f7 * f6))) * Math_fround(2.0));
  f11 = Math_fround(HEAPF32[i63 >> 2]);
  f8 = Math_fround(HEAPF32[i102 >> 2]);
  f161 = Math_fround(Math_fround(Math_fround(f30 * f163) + Math_fround(f31 * f23)) + Math_fround(f32 * f160));
  f11 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f163 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f32 * f23) - Math_fround(f31 * f160))) + Math_fround(f30 * f6))) * Math_fround(2.0)));
  f8 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f23 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f30 * f160) - Math_fround(f32 * f163))) + Math_fround(f31 * f6))) * Math_fround(2.0)));
  f6 = Math_fround(Math_fround(HEAPF32[i103 >> 2]) + Math_fround(Math_fround(Math_fround(f160 * f161) + Math_fround(Math_fround(f162 * Math_fround(Math_fround(f31 * f163) - Math_fround(f30 * f23))) + Math_fround(f32 * f6))) * Math_fround(2.0)));
  f23 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f23 <= Math_fround(0.0))) {
   i3 = i98;
   i138 = 38;
   break;
  }
  f161 = Math_fround(f23 * f10);
  f162 = Math_fround(f23 * f9);
  f163 = Math_fround(f23 * f7);
  f1 = Math_fround(f1 - f161);
  f2 = Math_fround(f2 - f162);
  f4 = Math_fround(f4 - f163);
  f38 = Math_fround(f38 - f161);
  f39 = Math_fround(f39 - f162);
  f40 = Math_fround(f40 - f163);
  i98 = i98 + 1 | 0;
  if (i98 >>> 0 >= 2) {
   f9 = f1;
   f7 = f2;
   i3 = 1;
   break;
  } else {
   i12 = i16;
   f7 = f30;
   f9 = f31;
   f10 = f32;
   i3 = 1;
  }
 }
 if ((i138 | 0) == 15) {
  f9 = f1;
  f7 = f2;
 } else if ((i138 | 0) == 38) if (!i3) {
  HEAPF32[i131 >> 2] = Math_fround(0.0);
  HEAPF32[i132 >> 2] = f11;
  HEAPF32[i133 >> 2] = f8;
  HEAPF32[i134 >> 2] = f6;
  HEAPF32[i135 >> 2] = f10;
  HEAPF32[i136 >> 2] = f9;
  HEAPF32[i137 >> 2] = f7;
  HEAP32[i130 >> 2] = i5;
  i164 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i139);
  STACKTOP = i140;
  return i164 | 0;
 } else {
  i3 = 1;
  i138 = 39;
 }
 if ((i138 | 0) == 39) {
  f9 = f1;
  f7 = f2;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f9 * f9)))));
 f2 = Math_fround(Math_fround(1.0) / f1);
 if (!i3) {
  i164 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i139);
  STACKTOP = i140;
  return i164 | 0;
 }
 f163 = Math_fround(f4 * f2);
 f162 = Math_fround(f7 * f2);
 f161 = Math_fround(f9 * f2);
 HEAPF32[i131 >> 2] = Math_fround(-f1);
 HEAPF32[i132 >> 2] = f11;
 HEAPF32[i133 >> 2] = f8;
 HEAPF32[i134 >> 2] = f6;
 HEAPF32[i135 >> 2] = f161;
 HEAPF32[i136 >> 2] = f162;
 HEAPF32[i137 >> 2] = f163;
 HEAP32[i130 >> 2] = i5;
 i164 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i139);
 STACKTOP = i140;
 return i164 | 0;
}

function __ZNK12PhysXRaycast12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP8Colliderj(i1, i113, i45, i46) {
 i1 = i1 | 0;
 i113 = i113 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, i126 = 0;
 i112 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i106 = i112 + 48 | 0;
 i111 = i112;
 i44 = i112 + 248 | 0;
 i107 = i112 + 228 | 0;
 i108 = i112 + 208 | 0;
 i109 = i112 + 192 | 0;
 i110 = i112 + 144 | 0;
 i103 = i112 + 132 | 0;
 i104 = i112 + 120 | 0;
 i105 = i112 + 96 | 0;
 i2 = HEAP32[i113 >> 2] | 0;
 i102 = i113 + 12 | 0;
 i3 = HEAP32[i102 >> 2] | 0;
 if (!i3) {
  f23 = Math_fround(-inf);
  f26 = Math_fround(inf);
  f28 = Math_fround(0.0);
  f29 = Math_fround(0.0);
  f33 = Math_fround(-inf);
  f36 = Math_fround(inf);
  f38 = Math_fround(0.0);
  f42 = Math_fround(-inf);
  f43 = Math_fround(inf);
  f41 = Math_fround(-inf);
  f40 = Math_fround(inf);
  f39 = Math_fround(-inf);
  f37 = Math_fround(inf);
  f35 = Math_fround(-inf);
  f34 = Math_fround(inf);
  f32 = Math_fround(-inf);
  f31 = Math_fround(inf);
  f30 = Math_fround(-inf);
  f27 = Math_fround(inf);
  f25 = Math_fround(-inf);
  f24 = Math_fround(inf);
  f22 = Math_fround(-inf);
  f21 = Math_fround(inf);
  f20 = Math_fround(0.0);
  f19 = Math_fround(-inf);
  f18 = Math_fround(inf);
  f15 = Math_fround(-inf);
  f14 = Math_fround(inf);
 } else {
  i1 = 0;
  f23 = Math_fround(-inf);
  f26 = Math_fround(inf);
  f28 = Math_fround(0.0);
  f29 = Math_fround(0.0);
  f33 = Math_fround(-inf);
  f36 = Math_fround(inf);
  f38 = Math_fround(0.0);
  f42 = Math_fround(-inf);
  f43 = Math_fround(inf);
  f41 = Math_fround(-inf);
  f40 = Math_fround(inf);
  f39 = Math_fround(-inf);
  f37 = Math_fround(inf);
  f35 = Math_fround(-inf);
  f34 = Math_fround(inf);
  f32 = Math_fround(-inf);
  f31 = Math_fround(inf);
  f30 = Math_fround(-inf);
  f27 = Math_fround(inf);
  f25 = Math_fround(-inf);
  f24 = Math_fround(inf);
  f22 = Math_fround(-inf);
  f21 = Math_fround(inf);
  f20 = Math_fround(0.0);
  f19 = Math_fround(-inf);
  f18 = Math_fround(inf);
  f15 = Math_fround(-inf);
  f14 = Math_fround(inf);
  do {
   f125 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 16 >> 2]);
   f26 = f26 < f125 ? f26 : f125;
   f124 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 20 >> 2]);
   f14 = f14 < f124 ? f14 : f124;
   f123 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 24 >> 2]);
   f36 = f36 < f123 ? f36 : f123;
   f122 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 28 >> 2]);
   f43 = f43 < f122 ? f43 : f122;
   f121 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 32 >> 2]);
   f40 = f40 < f121 ? f40 : f121;
   f120 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 36 >> 2]);
   f37 = f37 < f120 ? f37 : f120;
   f119 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 40 >> 2]);
   f34 = f34 < f119 ? f34 : f119;
   f118 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 44 >> 2]);
   f31 = f31 < f118 ? f31 : f118;
   f117 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 48 >> 2]);
   f27 = f27 < f117 ? f27 : f117;
   f116 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 52 >> 2]);
   f24 = f24 < f116 ? f24 : f116;
   f115 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 56 >> 2]);
   f21 = f21 < f115 ? f21 : f115;
   f114 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 60 >> 2]);
   f18 = f18 < f114 ? f18 : f114;
   f125 = f23 > f125 ? f23 : f125;
   f124 = f15 > f124 ? f15 : f124;
   f123 = f33 > f123 ? f33 : f123;
   f122 = f42 > f122 ? f42 : f122;
   f121 = f41 > f121 ? f41 : f121;
   f120 = f39 > f120 ? f39 : f120;
   f119 = f35 > f119 ? f35 : f119;
   f118 = f32 > f118 ? f32 : f118;
   f117 = f30 > f117 ? f30 : f117;
   f116 = f25 > f116 ? f25 : f116;
   f115 = f22 > f115 ? f22 : f115;
   f114 = f19 > f114 ? f19 : f114;
   f23 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 64 >> 2]);
   f26 = f26 < f23 ? f26 : f23;
   f15 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 68 >> 2]);
   f14 = f14 < f15 ? f14 : f15;
   f33 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 72 >> 2]);
   f36 = f36 < f33 ? f36 : f33;
   f42 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 76 >> 2]);
   f43 = f43 < f42 ? f43 : f42;
   f41 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 80 >> 2]);
   f40 = f40 < f41 ? f40 : f41;
   f39 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 84 >> 2]);
   f37 = f37 < f39 ? f37 : f39;
   f35 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 88 >> 2]);
   f34 = f34 < f35 ? f34 : f35;
   f32 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 92 >> 2]);
   f31 = f31 < f32 ? f31 : f32;
   f30 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 96 >> 2]);
   f27 = f27 < f30 ? f27 : f30;
   f25 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 100 >> 2]);
   f24 = f24 < f25 ? f24 : f25;
   f22 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 104 >> 2]);
   f21 = f21 < f22 ? f21 : f22;
   f19 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 108 >> 2]);
   f18 = f18 < f19 ? f18 : f19;
   f23 = f125 > f23 ? f125 : f23;
   f15 = f124 > f15 ? f124 : f15;
   f33 = f123 > f33 ? f123 : f33;
   f42 = f122 > f42 ? f122 : f42;
   f41 = f121 > f41 ? f121 : f41;
   f39 = f120 > f39 ? f120 : f39;
   f35 = f119 > f35 ? f119 : f35;
   f32 = f118 > f32 ? f118 : f32;
   f30 = f117 > f30 ? f117 : f30;
   f25 = f116 > f25 ? f116 : f25;
   f22 = f115 > f22 ? f115 : f22;
   f19 = f114 > f19 ? f114 : f19;
   f114 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 112 >> 2]);
   f28 = f28 > f114 ? f28 : f114;
   f114 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 116 >> 2]);
   f20 = f20 > f114 ? f20 : f114;
   f114 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 120 >> 2]);
   f29 = f29 > f114 ? f29 : f114;
   f114 = Math_fround(HEAPF32[i2 + (i1 * 144 | 0) + 124 >> 2]);
   f38 = f38 > f114 ? f38 : f114;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 f123 = Math_fround(_fminf(f26, f14));
 f123 = Math_fround(_fminf(f123, Math_fround(_fminf(f36, f43))));
 f124 = Math_fround(_fminf(f40, f37));
 f124 = Math_fround(_fminf(f124, Math_fround(_fminf(f34, f31))));
 f125 = Math_fround(_fminf(f27, f24));
 f125 = Math_fround(_fminf(f125, Math_fround(_fminf(f21, f18))));
 f122 = Math_fround(_fmaxf(f23, f15));
 f122 = Math_fround(_fmaxf(f122, Math_fround(_fmaxf(f33, f42))));
 f120 = Math_fround(_fmaxf(f41, f39));
 f120 = Math_fround(_fmaxf(f120, Math_fround(_fmaxf(f35, f32))));
 f118 = Math_fround(_fmaxf(f30, f25));
 f118 = Math_fround(_fmaxf(f118, Math_fround(_fmaxf(f22, f19))));
 f121 = Math_fround(_fmaxf(f28, f20));
 f121 = Math_fround(_fmaxf(f121, Math_fround(_fmaxf(f29, f38))));
 f123 = Math_fround(Math_fround(f123 - f121) + Math_fround(-9.99999974e-06));
 f124 = Math_fround(Math_fround(f124 - f121) + Math_fround(-9.99999974e-06));
 f125 = Math_fround(Math_fround(f125 - f121) + Math_fround(-9.99999974e-06));
 f122 = Math_fround(Math_fround(f122 + f121) + Math_fround(9.99999974e-06));
 f120 = Math_fround(Math_fround(f120 + f121) + Math_fround(9.99999974e-06));
 f121 = Math_fround(Math_fround(f118 + f121) + Math_fround(9.99999974e-06));
 f118 = Math_fround(Math_fround(f124 + f120) * Math_fround(.5));
 f119 = Math_fround(Math_fround(f125 + f121) * Math_fround(.5));
 HEAPF32[i44 >> 2] = Math_fround(Math_fround(f123 + f122) * Math_fround(.5));
 HEAPF32[i44 + 4 >> 2] = f118;
 HEAPF32[i44 + 8 >> 2] = f119;
 f124 = Math_fround(Math_fround(f120 - f124) * Math_fround(.5));
 f125 = Math_fround(Math_fround(f121 - f125) * Math_fround(.5));
 HEAPF32[i44 + 12 >> 2] = Math_fround(Math_fround(f122 - f123) * Math_fround(.5));
 HEAPF32[i44 + 16 >> 2] = f124;
 HEAPF32[i44 + 20 >> 2] = f125;
 i99 = gb + 64016 | 0;
 i98 = HEAP32[i99 + 4 >> 2] | 0;
 i16 = i111;
 HEAP32[i16 >> 2] = HEAP32[i99 >> 2];
 HEAP32[i16 + 4 >> 2] = i98;
 HEAP32[i107 >> 2] = 0;
 i16 = i107 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i98 = i107 + 16 | 0;
 HEAP32[i98 >> 2] = 0;
 i99 = i107 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i106, i111);
 i17 = i106;
 i100 = HEAP32[i17 + 4 >> 2] | 0;
 i101 = i99;
 HEAP32[i101 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i101 + 4 >> 2] = i100;
 i101 = gb + 64016 | 0;
 i100 = HEAP32[i101 + 4 >> 2] | 0;
 i17 = i111;
 HEAP32[i17 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i17 + 4 >> 2] = i100;
 HEAP32[i108 >> 2] = 0;
 i17 = i108 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i100 = i108 + 16 | 0;
 HEAP32[i100 >> 2] = 0;
 i101 = i108 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i106, i111);
 i96 = i106;
 i97 = HEAP32[i96 + 4 >> 2] | 0;
 i1 = i101;
 HEAP32[i1 >> 2] = HEAP32[i96 >> 2];
 HEAP32[i1 + 4 >> 2] = i97;
 i1 = HEAP32[i98 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i46 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i98 >> 2] = i46;
  HEAP32[i107 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i107 >> 2] | 0, i46 << 4, 4, i99, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i46 << 4, 4, i99, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i97 | 0, HEAP32[i107 >> 2] | 0, HEAP32[i16 >> 2] << 4 | 0) | 0;
  HEAP32[i98 >> 2] = i46;
  HEAP32[i107 >> 2] = i97;
  break;
 } while (0);
 i1 = HEAP32[i100 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i46 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i100 >> 2] = i46;
  HEAP32[i108 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i108 >> 2] | 0, i46 * 24 | 0, 4, i101, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i46 * 24 | 0, 4, i101, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i97 | 0, HEAP32[i108 >> 2] | 0, (HEAP32[i17 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i100 >> 2] = i46;
  HEAP32[i108 >> 2] = i97;
  break;
 } while (0);
 if (i46 | 0) {
  i7 = i106 + 4 | 0;
  i8 = i106 + 8 | 0;
  i9 = i111 + 4 | 0;
  i10 = i111 + 8 | 0;
  i11 = i111 + 12 | 0;
  i12 = i111 + 16 | 0;
  i13 = i111 + 20 | 0;
  i6 = 0;
  do {
   i1 = i45 + (i6 << 2) | 0;
   i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
   if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
    HEAP32[i106 >> 2] = 0;
    HEAP32[i8 >> 2] = -1;
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    if (i1 | 0) {
     HEAP32[i106 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
     __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE(i111, i106);
     if (__Z17IntersectAABBAABBRK4AABBS1_(i111, i44) | 0) {
      i2 = HEAP32[i16 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i98 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i98 >> 2] = i1;
        HEAP32[i107 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i107 >> 2] | 0, i1 << 4, 4, i99, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i99, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i97 | 0, HEAP32[i107 >> 2] | 0, HEAP32[i16 >> 2] << 4 | 0) | 0;
        HEAP32[i98 >> 2] = i1;
        HEAP32[i107 >> 2] = i97;
        break;
       }
      } while (0);
      HEAP32[i16 >> 2] = i3;
      i2 = (HEAP32[i107 >> 2] | 0) + (i2 << 4) | 0;
      HEAP32[i2 >> 2] = HEAP32[i106 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i106 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i106 + 8 >> 2];
      HEAP32[i2 + 12 >> 2] = HEAP32[i106 + 12 >> 2];
      i2 = HEAP32[i17 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i100 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i100 >> 2] = i1;
        HEAP32[i108 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i108 >> 2] | 0, i1 * 24 | 0, 4, i101, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i97 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i101, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i97 | 0, HEAP32[i108 >> 2] | 0, (HEAP32[i17 >> 2] | 0) * 24 | 0) | 0;
        HEAP32[i100 >> 2] = i1;
        HEAP32[i108 >> 2] = i97;
        break;
       }
      } while (0);
      HEAP32[i17 >> 2] = i3;
      i97 = HEAP32[i108 >> 2] | 0;
      HEAP32[i97 + (i2 * 24 | 0) >> 2] = HEAP32[i111 >> 2];
      HEAP32[i97 + (i2 * 24 | 0) + 4 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i97 + (i2 * 24 | 0) + 8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i97 + (i2 * 24 | 0) + 12 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i97 + (i2 * 24 | 0) + 16 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i97 + (i2 * 24 | 0) + 20 >> 2] = HEAP32[i13 >> 2];
     }
    }
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i46 | 0));
 }
 i80 = HEAP32[i16 >> 2] | 0;
 if (!((i80 | 0) == 0 | (HEAP32[i102 >> 2] | 0) == 0)) {
  i57 = i106 + 4 | 0;
  i68 = i106 + 8 | 0;
  i78 = i106 + 12 | 0;
  i81 = i106 + 16 | 0;
  i54 = i106 + 20 | 0;
  i65 = i106 + 24 | 0;
  i75 = i106 + 28 | 0;
  i82 = i106 + 32 | 0;
  i51 = i106 + 36 | 0;
  i61 = i106 + 40 | 0;
  i72 = i106 + 44 | 0;
  i58 = i111 + 4 | 0;
  i69 = i111 + 8 | 0;
  i79 = i111 + 12 | 0;
  i83 = i111 + 16 | 0;
  i55 = i111 + 20 | 0;
  i66 = i111 + 24 | 0;
  i76 = i111 + 28 | 0;
  i84 = i111 + 32 | 0;
  i52 = i111 + 36 | 0;
  i62 = i111 + 40 | 0;
  i73 = i111 + 44 | 0;
  i85 = i109 + 4 | 0;
  i86 = i109 + 8 | 0;
  i87 = i109 + 12 | 0;
  i56 = i110 + 4 | 0;
  i67 = i110 + 8 | 0;
  i77 = i110 + 12 | 0;
  i48 = i110 + 16 | 0;
  i53 = i110 + 20 | 0;
  i64 = i110 + 24 | 0;
  i74 = i110 + 28 | 0;
  i47 = i110 + 32 | 0;
  i49 = i110 + 36 | 0;
  i60 = i110 + 40 | 0;
  i71 = i110 + 44 | 0;
  i88 = i103 + 4 | 0;
  i89 = i103 + 8 | 0;
  i90 = i110 + 16 | 0;
  i91 = i110 + 32 | 0;
  i92 = i104 + 4 | 0;
  i93 = i104 + 8 | 0;
  i59 = i105 + 4 | 0;
  i70 = i105 + 8 | 0;
  i46 = i105 + 12 | 0;
  i50 = i105 + 16 | 0;
  i63 = i105 + 20 | 0;
  i45 = 0;
  do {
   i44 = HEAP32[i113 >> 2] | 0;
   f15 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 64 >> 2]);
   i94 = i44 + (i45 * 144 | 0) + 16 | 0;
   f32 = Math_fround(HEAPF32[i94 >> 2]);
   f15 = Math_fround(f15 - f32);
   f18 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 68 >> 2]);
   f33 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 20 >> 2]);
   f18 = Math_fround(f18 - f33);
   f19 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 72 >> 2]);
   f34 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 24 >> 2]);
   f19 = Math_fround(f19 - f34);
   f20 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 76 >> 2]);
   f35 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 28 >> 2]);
   f20 = Math_fround(f20 - f35);
   f21 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 80 >> 2]);
   i95 = i44 + (i45 * 144 | 0) + 32 | 0;
   f36 = Math_fround(HEAPF32[i95 >> 2]);
   f21 = Math_fround(f21 - f36);
   f22 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 84 >> 2]);
   f37 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 36 >> 2]);
   f22 = Math_fround(f22 - f37);
   f23 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 88 >> 2]);
   f38 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 40 >> 2]);
   f23 = Math_fround(f23 - f38);
   f24 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 92 >> 2]);
   f39 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 44 >> 2]);
   f24 = Math_fround(f24 - f39);
   f25 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 96 >> 2]);
   i96 = i44 + (i45 * 144 | 0) + 48 | 0;
   f125 = Math_fround(HEAPF32[i96 >> 2]);
   f25 = Math_fround(f25 - f125);
   f26 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 100 >> 2]);
   f124 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 52 >> 2]);
   f26 = Math_fround(f26 - f124);
   f27 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 104 >> 2]);
   f123 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 56 >> 2]);
   f27 = Math_fround(f27 - f123);
   f28 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 108 >> 2]);
   f122 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 60 >> 2]);
   f28 = Math_fround(f28 - f122);
   f114 = Math_fround(f15 * Math_fround(.5));
   f115 = Math_fround(f18 * Math_fround(.5));
   f116 = Math_fround(f19 * Math_fround(.5));
   f117 = Math_fround(f20 * Math_fround(.5));
   f118 = Math_fround(f21 * Math_fround(.5));
   f119 = Math_fround(f22 * Math_fround(.5));
   f120 = Math_fround(f23 * Math_fround(.5));
   f121 = Math_fround(f24 * Math_fround(.5));
   f40 = Math_fround(f25 * Math_fround(.5));
   f41 = Math_fround(f26 * Math_fround(.5));
   f42 = Math_fround(f27 * Math_fround(.5));
   f43 = Math_fround(f28 * Math_fround(.5));
   f33 = Math_fround(f115 + f33);
   f34 = Math_fround(f116 + f34);
   f35 = Math_fround(f117 + f35);
   f36 = Math_fround(f118 + f36);
   f37 = Math_fround(f119 + f37);
   f38 = Math_fround(f120 + f38);
   f39 = Math_fround(f121 + f39);
   f125 = Math_fround(f40 + f125);
   f124 = Math_fround(f41 + f124);
   f123 = Math_fround(f42 + f123);
   f122 = Math_fround(f43 + f122);
   HEAPF32[i106 >> 2] = Math_fround(f114 + f32);
   HEAPF32[i57 >> 2] = f33;
   HEAPF32[i68 >> 2] = f34;
   HEAPF32[i78 >> 2] = f35;
   HEAPF32[i81 >> 2] = f36;
   HEAPF32[i54 >> 2] = f37;
   HEAPF32[i65 >> 2] = f38;
   HEAPF32[i75 >> 2] = f39;
   HEAPF32[i82 >> 2] = f125;
   HEAPF32[i51 >> 2] = f124;
   HEAPF32[i61 >> 2] = f123;
   HEAPF32[i72 >> 2] = f122;
   f114 = Math_fround(Math_abs(Math_fround(f114)));
   f115 = Math_fround(Math_abs(Math_fround(f115)));
   f116 = Math_fround(Math_abs(Math_fround(f116)));
   f117 = Math_fround(Math_abs(Math_fround(f117)));
   f118 = Math_fround(Math_abs(Math_fround(f118)));
   f119 = Math_fround(Math_abs(Math_fround(f119)));
   f120 = Math_fround(Math_abs(Math_fround(f120)));
   f121 = Math_fround(Math_abs(Math_fround(f121)));
   f40 = Math_fround(Math_abs(Math_fround(f40)));
   f41 = Math_fround(Math_abs(Math_fround(f41)));
   f42 = Math_fround(Math_abs(Math_fround(f42)));
   f43 = Math_fround(Math_abs(Math_fround(f43)));
   i97 = i44 + (i45 * 144 | 0) + 112 | 0;
   f122 = Math_fround(HEAPF32[i97 >> 2]);
   f114 = Math_fround(f114 + f122);
   f123 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 116 >> 2]);
   f115 = Math_fround(f115 + f123);
   f124 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 120 >> 2]);
   f116 = Math_fround(f116 + f124);
   f125 = Math_fround(HEAPF32[i44 + (i45 * 144 | 0) + 124 >> 2]);
   f117 = Math_fround(f117 + f125);
   f118 = Math_fround(f118 + f122);
   f119 = Math_fround(f119 + f123);
   f120 = Math_fround(f120 + f124);
   f121 = Math_fround(f121 + f125);
   f122 = Math_fround(f40 + f122);
   f123 = Math_fround(f41 + f123);
   f124 = Math_fround(f42 + f124);
   f125 = Math_fround(f43 + f125);
   HEAPF32[i111 >> 2] = f114;
   HEAPF32[i58 >> 2] = f115;
   HEAPF32[i69 >> 2] = f116;
   HEAPF32[i79 >> 2] = f117;
   HEAPF32[i83 >> 2] = f118;
   HEAPF32[i55 >> 2] = f119;
   HEAPF32[i66 >> 2] = f120;
   HEAPF32[i76 >> 2] = f121;
   HEAPF32[i84 >> 2] = f122;
   HEAPF32[i52 >> 2] = f123;
   HEAPF32[i62 >> 2] = f124;
   HEAPF32[i73 >> 2] = f125;
   if (__ZN8IRaycast12IntersectAnyERKN4math8floatNx3ES3_P4AABBj(i106, i111, HEAP32[i108 >> 2] | 0, i80) | 0) {
    f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f21 * f21)) + Math_fround(f25 * f25))));
    f123 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f22 * f22)) + Math_fround(f26 * f26))));
    f124 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f23 * f23)) + Math_fround(f27 * f27))));
    f125 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f24 * f24)) + Math_fround(f28 * f28))));
    HEAPF32[i109 >> 2] = f14;
    HEAPF32[i85 >> 2] = f123;
    HEAPF32[i86 >> 2] = f124;
    HEAPF32[i87 >> 2] = f125;
    f42 = Math_fround(f15 / f14);
    f43 = Math_fround(f18 / f123);
    f114 = Math_fround(f19 / f124);
    f115 = Math_fround(f20 / f125);
    f116 = Math_fround(f21 / f14);
    f117 = Math_fround(f22 / f123);
    f118 = Math_fround(f23 / f124);
    f119 = Math_fround(f24 / f125);
    f120 = Math_fround(f25 / f14);
    f121 = Math_fround(f26 / f123);
    f122 = Math_fround(f27 / f124);
    f15 = Math_fround(f28 / f125);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f114, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f115, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f116, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f117, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f118, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f119, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f120, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f121, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f122, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = f14 > Math_fround(9.99999974e-06);
    i13 = f123 > Math_fround(9.99999974e-06);
    i16 = f124 > Math_fround(9.99999974e-06);
    i17 = f125 > Math_fround(9.99999974e-06);
    i126 = i17 ? (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    HEAP32[i110 >> 2] = i12 ? i1 : 0;
    HEAP32[i56 >> 2] = i13 ? i2 : 0;
    HEAP32[i67 >> 2] = i16 ? i3 : 0;
    HEAP32[i77 >> 2] = i17 ? i4 : 0;
    HEAP32[i48 >> 2] = i12 ? i5 : 1065353216;
    HEAP32[i53 >> 2] = i13 ? i6 : 1065353216;
    HEAP32[i64 >> 2] = i16 ? i7 : 1065353216;
    HEAP32[i74 >> 2] = i17 ? i8 : 1065353216;
    HEAP32[i47 >> 2] = i12 ? i9 : 0;
    HEAP32[i49 >> 2] = i13 ? i10 : 0;
    HEAP32[i60 >> 2] = i16 ? i11 : 0;
    HEAP32[i71 >> 2] = i126;
    i3 = i44 + (i45 * 144 | 0) + 128 | 0;
    i2 = 0;
    while (1) {
     i16 = HEAP32[i95 + (i2 << 2) >> 2] | 0;
     i17 = HEAP32[i96 + (i2 << 2) >> 2] | 0;
     HEAP32[i103 >> 2] = HEAP32[i94 + (i2 << 2) >> 2];
     HEAP32[i88 >> 2] = i16;
     HEAP32[i89 >> 2] = i17;
     i17 = HEAP32[i90 + (i2 << 2) >> 2] | 0;
     i16 = HEAP32[i91 + (i2 << 2) >> 2] | 0;
     HEAP32[i104 >> 2] = HEAP32[i110 + (i2 << 2) >> 2];
     HEAP32[i92 >> 2] = i17;
     HEAP32[i93 >> 2] = i16;
     i16 = HEAP32[i81 + (i2 << 2) >> 2] | 0;
     i17 = HEAP32[i82 + (i2 << 2) >> 2] | 0;
     i44 = HEAP32[i111 + (i2 << 2) >> 2] | 0;
     i126 = HEAP32[i83 + (i2 << 2) >> 2] | 0;
     i1 = HEAP32[i84 + (i2 << 2) >> 2] | 0;
     HEAP32[i105 >> 2] = HEAP32[i106 + (i2 << 2) >> 2];
     HEAP32[i59 >> 2] = i16;
     HEAP32[i70 >> 2] = i17;
     HEAP32[i46 >> 2] = i44;
     HEAP32[i50 >> 2] = i126;
     HEAP32[i63 >> 2] = i1;
     f125 = Math_fround(HEAPF32[i97 + (i2 << 2) >> 2]);
     HEAP32[i3 + (i2 << 2) >> 2] = (__ZNK12PhysXRaycast7OverlapERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_j(0, i103, i104, i105, f14, f125, HEAP32[i107 >> 2] | 0, HEAP32[i108 >> 2] | 0, i80) | 0) & 1;
     i1 = i2 + 1 | 0;
     if ((i1 | 0) == 4) break;
     i2 = i1;
     f14 = Math_fround(HEAPF32[i109 + (i1 << 2) >> 2]);
    }
   }
   i45 = i45 + 1 | 0;
  } while (i45 >>> 0 < (HEAP32[i102 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i100 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i108 >> 2] | 0, i101);
  HEAP32[i108 >> 2] = 0;
 }
 if ((HEAP32[i98 >> 2] | 0) <= -1) {
  STACKTOP = i112;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i107 >> 2] | 0, i99);
 HEAP32[i107 >> 2] = 0;
 STACKTOP = i112;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_(i1, i2, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i13 = i2;
 L1 : while (1) {
  i9 = i13;
  i12 = i13 + -16 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i2 = i9 - i8 | 0;
    i3 = i2 >> 4;
    switch (i3 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 84;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 496) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i3 | 0) / 2 | 0) << 4) | 0;
    do if ((i2 | 0) > 15984) {
     i3 = (i3 | 0) / 4 | 0;
     i5 = i1 + (i3 << 4) | 0;
     i3 = i7 + (i3 << 4) | 0;
     i2 = __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i1, i5, i7, i3, i11) | 0;
     if ((HEAP32[i12 >> 2] | 0) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
      i3 = i7;
      break;
     };
     HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     i4 = i2 + 1 | 0;
     if ((HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i3 = i2 + 2 | 0;
      if ((HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
       HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
       HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
       if ((HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0) {
        HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
        HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
        HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
        HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
        HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
        HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
        HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
        HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
        i2 = i2 + 4 | 0;
        i3 = i7;
       } else {
        i2 = i2 + 3 | 0;
        i3 = i7;
       }
      } else {
       i2 = i3;
       i3 = i7;
      }
     } else {
      i2 = i4;
      i3 = i7;
     }
    } else {
     i6 = HEAP32[i7 >> 2] | 0;
     i2 = (HEAP32[i12 >> 2] | 0) >>> 0 < i6 >>> 0;
     if (i6 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
      if (!i2) {
       i2 = 0;
       i3 = i7;
       break;
      };
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      if ((HEAP32[i7 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
       i2 = 1;
       i3 = i7;
       break;
      };
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i2 = 2;
      i3 = i7;
      break;
     }
     if (i2) {
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i2 = 1;
      i3 = i7;
      break;
     };
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     if ((HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
      HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i2 = 2;
      i3 = i7;
     } else {
      i2 = 1;
      i3 = i7;
     }
    } while (0);
    i5 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i5 >>> 0 < i4 >>> 0) {
     i3 = i12;
     break;
    } else i3 = i12;
    while (1) {
     i3 = i3 + -16 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if ((HEAP32[i3 >> 2] | 0) >>> 0 < i4 >>> 0) {
      i10 = 67;
      break L5;
     }
    }
    i2 = i1 + 16 | 0;
    if (i5 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
     if ((i2 | 0) == (i12 | 0)) {
      i10 = 84;
      break L1;
     }
     while (1) {
      if (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) break;
      i2 = i2 + 16 | 0;
      if ((i2 | 0) == (i12 | 0)) {
       i10 = 84;
       break L1;
      }
     }
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     i2 = i2 + 16 | 0;
    }
    if ((i2 | 0) == (i12 | 0)) {
     i10 = 84;
     break L1;
    } else i3 = i12;
    while (1) {
     i5 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i4 = i2 + 16 | 0;
      if (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) break; else i2 = i4;
     }
     do i3 = i3 + -16 | 0; while (i5 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
     if (i2 >>> 0 >= i3 >>> 0) {
      i1 = i2;
      continue L5;
     };
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     i2 = i4;
    }
   }
   if ((i10 | 0) == 67) {
    i10 = 0;
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 16 | 0;
   L50 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i5 = i4 + 16 | 0;
     if ((HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0) i4 = i5; else break;
    }
    do i3 = i3 + -16 | 0; while ((HEAP32[i3 >> 2] | 0) >>> 0 >= i6 >>> 0);
    if (i4 >>> 0 > i3 >>> 0) {
     i3 = i7;
     break L50;
    };
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    i7 = (i7 | 0) == (i4 | 0) ? i3 : i7;
    i4 = i5;
    i2 = i2 + 1 | 0;
   } else i3 = i7; while (0);
   if ((i4 | 0) != (i3 | 0)) if ((HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    i2 = i2 + 1 | 0;
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEbT0_S8_T_(i1, i4, i11) | 0;
    i3 = i4 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEbT0_S8_T_(i3, i13, i11) | 0) {
     i10 = 83;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i7 = i4;
   if ((i7 - i8 | 0) >= (i9 - i7 | 0)) {
    i10 = 82;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_(i1, i4, i11);
   i1 = i4 + 16 | 0;
  }
  if ((i10 | 0) == 82) {
   i10 = 0;
   __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_(i4 + 16 | 0, i13, i11);
   i13 = i4;
   continue;
  } else if ((i10 | 0) == 83) {
   i10 = 0;
   if (i2) {
    i10 = 84;
    break;
   } else {
    i13 = i4;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if ((HEAP32[i12 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 16 | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  i3 = (HEAP32[i12 >> 2] | 0) >>> 0 < i13 >>> 0;
  if (i13 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
   if (!i3) {
    STACKTOP = i15;
    return;
   };
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   if ((HEAP32[i2 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
    STACKTOP = i15;
    return;
   };
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   STACKTOP = i15;
   return;
  }
  if (i3) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  if ((HEAP32[i12 >> 2] | 0) >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i12, i11) | 0;
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 16 | 0;
  i3 = i1 + 32 | 0;
  i4 = i1 + 48 | 0;
  __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i1, i2, i3, i4, i11) | 0;
  if ((HEAP32[i12 >> 2] | 0) >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  if ((HEAP32[i4 >> 2] | 0) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  if ((HEAP32[i3 >> 2] | 0) >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  if ((HEAP32[i2 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return;
  };
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 22) {
  i3 = i1 + 32 | 0;
  i2 = i1 + 16 | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i6 = i5 >>> 0 < i12 >>> 0;
  do if (i12 >>> 0 < i4 >>> 0) {
   if (i6) {
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    break;
   };
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   if (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   }
  } else if (i6) {
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i4 >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   }
  } while (0);
  i2 = i1 + 48 | 0;
  if ((i2 | 0) == (i13 | 0)) {
   STACKTOP = i15;
   return;
  }
  while (1) {
   i5 = HEAP32[i2 >> 2] | 0;
   if (i5 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
    i4 = i2 + 4 | 0;
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    i4 = i2;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i4 = i3 + -16 | 0;
     if (i5 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
      i12 = i3;
      i3 = i4;
      i4 = i12;
     } else break;
    }
    HEAP32[i3 >> 2] = i5;
    i12 = i3 + 4 | 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   }
   i3 = i2 + 16 | 0;
   if ((i3 | 0) == (i13 | 0)) break; else {
    i12 = i2;
    i2 = i3;
    i3 = i12;
   }
  }
  STACKTOP = i15;
  return;
 } else if ((i10 | 0) == 84) {
  STACKTOP = i15;
  return;
 }
}

function __ZN5physx10PxsContext28runModifiableContactManagersEv(i31) {
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i29 = i31 + 5908 | 0;
 if (!(HEAP32[i29 >> 2] | 0)) return;
 i32 = i31 + 5840 | 0;
 i33 = i31 + 5844 | 0;
 i2 = HEAP32[i33 >> 2] | 0;
 i15 = i2 & 2147483647;
 L4 : do if (!i15) i3 = 0; else {
  i5 = HEAP32[i32 >> 2] | 0;
  i3 = 0;
  while (1) {
   i4 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
   if (i4 | 0) break;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i15 >>> 0) {
    i3 = 0;
    break L4;
   }
  }
  i6 = (Math_imul(i4 & 0 - i4, 125613361) | 0) >>> 27;
  i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i3 << 5;
  i4 = i4 + -1 & i4;
  L10 : do if (!i4) do {
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i15 >>> 0) {
    i4 = 0;
    break L10;
   }
   i4 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
  } while ((i4 | 0) == 0); while (0);
  if ((i6 | 0) == -1) i3 = 0; else {
   i5 = 0;
   while (1) {
    i7 = i3 << 5;
    while (1) {
     i5 = i5 + 1 | 0;
     if (!i4) {
      i3 = i5;
      break L4;
     }
     i6 = (Math_imul(i4 & 0 - i4, 125613361) | 0) >>> 27;
     i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i7;
     i4 = i4 + -1 & i4;
     if (!i4) break;
     if ((i6 | 0) == -1) {
      i3 = i5;
      break L4;
     }
    }
    do {
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 >= i15 >>> 0) {
      i4 = 0;
      break;
     }
     i4 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    } while ((i4 | 0) == 0);
    if ((i6 | 0) == -1) {
     i3 = i5;
     break;
    }
   }
  }
 } while (0);
 i28 = i31 + 5852 | 0;
 i26 = i31 + 5856 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i31 + 5860 | 0;
 if ((HEAP32[i27 >> 2] & 2147483647) >>> 0 < i3 >>> 0) {
  __ZN5physx6shdfnd5ArrayINS_19PxContactModifyPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i28, i3);
  i2 = HEAP32[i33 >> 2] | 0;
 }
 i6 = i2 & 2147483647;
 L31 : do if (i6 | 0) {
  i5 = HEAP32[i32 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break L31;
  }
  i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
  i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i2 << 5;
  i3 = i3 + -1 & i3;
  L37 : do if (!i3) do {
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i6 >>> 0) {
    i3 = 0;
    break L37;
   }
   i3 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  } while ((i3 | 0) == 0); while (0);
  if ((i4 | 0) != -1) {
   i23 = i31 + 708 | 0;
   i24 = i31 + 720 | 0;
   i25 = i31 + 696 | 0;
   do {
    i22 = i2 << 5;
    while (1) {
     i21 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i4 >>> (HEAP32[i23 >> 2] | 0) << 2) >> 2] | 0;
     i19 = (HEAP32[i25 >> 2] | 0) + -1 & i4;
     i18 = HEAP16[i21 + (i19 << 7) + 36 >> 1] | 0;
     i20 = i18 & 65535;
     if (i18 << 16 >> 16) {
      i4 = HEAP32[i27 >> 2] | 0;
      i5 = i4 & 2147483647;
      i6 = HEAP32[i26 >> 2] | 0;
      if (i5 >>> 0 <= i6 >>> 0) {
       __ZN5physx6shdfnd5ArrayINS_19PxContactModifyPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i28, (i5 | 0) == 0 ? 1 : i4 << 1);
       i6 = HEAP32[i26 >> 2] | 0;
      }
      i18 = HEAP32[i28 >> 2] | 0;
      HEAP32[i26 >> 2] = i6 + 1;
      i4 = i21 + (i19 << 7) + 88 | 0;
      i15 = HEAP32[gb + 1457360 >> 2] | 0;
      HEAP32[i18 + (i6 * 80 | 0) + 8 >> 2] = (HEAP32[i4 >> 2] | 0) + i15;
      i16 = i21 + (i19 << 7) + 92 | 0;
      HEAP32[i18 + (i6 * 80 | 0) + 12 >> 2] = (HEAP32[i16 >> 2] | 0) + i15;
      i15 = i21 + (i19 << 7) + 38 | 0;
      i7 = HEAP16[i15 >> 1] | 0;
      i35 = (i7 & 32) == 0;
      i5 = i21 + (i19 << 7) + 80 | 0;
      i36 = HEAP32[gb + 1457360 + 4 >> 2] | 0;
      i37 = HEAP32[gb + 1457360 + 8 >> 2] | 0;
      HEAP32[i18 + (i6 * 80 | 0) >> 2] = (HEAP32[i5 >> 2] | 0) + (i35 ? i37 : i36);
      i17 = i21 + (i19 << 7) + 84 | 0;
      HEAP32[i18 + (i6 * 80 | 0) + 4 >> 2] = (HEAP32[i17 >> 2] | 0) + ((i7 & 64) == 0 ? i37 : i36);
      i4 = HEAP32[i4 >> 2] | 0;
      i5 = HEAP32[i5 >> 2] | 0;
      f8 = Math_fround(HEAPF32[i4 + 16 >> 2]);
      if (i35) {
       f44 = Math_fround(f8 * Math_fround(2.0));
       f39 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
       f13 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
       f41 = Math_fround(HEAPF32[i5 + 12 >> 2]);
       f42 = Math_fround(Math_fround(f41 * f41) + Math_fround(-.5));
       f40 = Math_fround(HEAPF32[i5 >> 2]);
       f8 = Math_fround(f44 * f40);
       f43 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f8 = Math_fround(f8 + Math_fround(f39 * f43));
       f38 = Math_fround(HEAPF32[i5 + 8 >> 2]);
       f8 = Math_fround(f8 + Math_fround(f13 * f38));
       f10 = Math_fround(Math_fround(f40 * f8) + Math_fround(Math_fround(f44 * f42) + Math_fround(f41 * Math_fround(Math_fround(f13 * f43) - Math_fround(f39 * f38)))));
       f9 = Math_fround(Math_fround(f43 * f8) + Math_fround(Math_fround(f39 * f42) + Math_fround(f41 * Math_fround(Math_fround(f44 * f38) - Math_fround(f13 * f40)))));
       f8 = Math_fround(Math_fround(Math_fround(f13 * f42) + Math_fround(f41 * Math_fround(Math_fround(f39 * f40) - Math_fround(f44 * f43)))) + Math_fround(f38 * f8));
       f10 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) + f10);
       f9 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) + f9);
       f8 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) + f8);
       f44 = Math_fround(HEAPF32[i4 >> 2]);
       f39 = Math_fround(f41 * f44);
       f42 = Math_fround(HEAPF32[i4 + 12 >> 2]);
       f39 = Math_fround(f39 + Math_fround(f40 * f42));
       f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
       f39 = Math_fround(f39 + Math_fround(f43 * f13));
       f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
       f11 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f42) - Math_fround(f40 * f44)) - Math_fround(f43 * f14)) - Math_fround(f38 * f13));
       f12 = Math_fround(Math_fround(Math_fround(f40 * f14) + Math_fround(Math_fround(f38 * f42) + Math_fround(f41 * f13))) - Math_fround(f43 * f44));
       f13 = Math_fround(Math_fround(Math_fround(f38 * f44) + Math_fround(Math_fround(f43 * f42) + Math_fround(f41 * f14))) - Math_fround(f40 * f13));
       f14 = Math_fround(f39 - Math_fround(f38 * f14));
      } else {
       f13 = Math_fround(HEAPF32[i5 + 48 >> 2]);
       f39 = Math_fround(HEAPF32[i5 + 52 >> 2]);
       f13 = Math_fround(f13 * Math_fround(-2.0));
       f39 = Math_fround(f39 * Math_fround(-2.0));
       f10 = Math_fround(Math_fround(HEAPF32[i5 + 56 >> 2]) * Math_fround(-2.0));
       f45 = Math_fround(HEAPF32[i5 + 44 >> 2]);
       f41 = Math_fround(Math_fround(f45 * f45) + Math_fround(-.5));
       f43 = Math_fround(HEAPF32[i5 + 32 >> 2]);
       f44 = Math_fround(f13 * f43);
       f46 = Math_fround(HEAPF32[i5 + 36 >> 2]);
       f44 = Math_fround(f44 + Math_fround(f39 * f46));
       f12 = Math_fround(HEAPF32[i5 + 40 >> 2]);
       f44 = Math_fround(f44 + Math_fround(f10 * f12));
       f11 = Math_fround(-f43);
       f14 = Math_fround(-f46);
       f38 = Math_fround(-f12);
       f40 = Math_fround(Math_fround(Math_fround(f43 * f44) + Math_fround(Math_fround(f13 * f41) - Math_fround(f45 * Math_fround(Math_fround(f10 * f46) - Math_fround(f39 * f12))))) * Math_fround(2.0));
       f42 = Math_fround(Math_fround(Math_fround(f46 * f44) + Math_fround(Math_fround(f39 * f41) - Math_fround(f45 * Math_fround(Math_fround(f13 * f12) - Math_fround(f10 * f43))))) * Math_fround(2.0));
       f44 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f41) - Math_fround(f45 * Math_fround(Math_fround(f39 * f43) - Math_fround(f13 * f46)))) + Math_fround(f12 * f44)) * Math_fround(2.0));
       f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
       f46 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
       f13 = Math_fround(HEAPF32[i5 >> 2]);
       f43 = Math_fround(f13 * f40);
       f39 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f43 = Math_fround(f43 + Math_fround(f39 * f42));
       f41 = Math_fround(HEAPF32[i5 + 8 >> 2]);
       f43 = Math_fround(Math_fround(f41 * f44) + f43);
       f10 = Math_fround(Math_fround(f13 * f43) + Math_fround(Math_fround(f46 * f40) + Math_fround(f12 * Math_fround(Math_fround(f39 * f44) - Math_fround(f41 * f42)))));
       f9 = Math_fround(Math_fround(f39 * f43) + Math_fround(Math_fround(f46 * f42) + Math_fround(f12 * Math_fround(Math_fround(f41 * f40) - Math_fround(f13 * f44)))));
       f43 = Math_fround(Math_fround(Math_fround(f46 * f44) + Math_fround(f12 * Math_fround(Math_fround(f13 * f42) - Math_fround(f39 * f40)))) + Math_fround(f41 * f43));
       f10 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) + f10);
       f9 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) + f9);
       f43 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) + f43);
       f40 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f45 * f13)) + Math_fround(f39 * f38)) - Math_fround(f41 * f14));
       f42 = Math_fround(Math_fround(Math_fround(f41 * f11) + Math_fround(Math_fround(f12 * f14) + Math_fround(f45 * f39))) - Math_fround(f13 * f38));
       f44 = Math_fround(Math_fround(Math_fround(f13 * f14) + Math_fround(Math_fround(f12 * f38) + Math_fround(f45 * f41))) - Math_fround(f39 * f11));
       f38 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f12) - Math_fround(f13 * f11)) - Math_fround(f39 * f14)) - Math_fround(f41 * f38));
       f41 = Math_fround(f8 * Math_fround(2.0));
       f14 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
       f39 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
       f11 = Math_fround(Math_fround(f38 * f38) + Math_fround(-.5));
       f8 = Math_fround(Math_fround(Math_fround(f40 * f41) + Math_fround(f42 * f14)) + Math_fround(f44 * f39));
       f10 = Math_fround(f10 + Math_fround(Math_fround(f40 * f8) + Math_fround(Math_fround(f11 * f41) + Math_fround(f38 * Math_fround(Math_fround(f42 * f39) - Math_fround(f44 * f14))))));
       f9 = Math_fround(f9 + Math_fround(Math_fround(f42 * f8) + Math_fround(Math_fround(f11 * f14) + Math_fround(f38 * Math_fround(Math_fround(f44 * f41) - Math_fround(f40 * f39))))));
       f8 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f11 * f39) + Math_fround(f38 * Math_fround(Math_fround(f40 * f14) - Math_fround(f42 * f41)))) + Math_fround(f44 * f8)));
       f41 = Math_fround(HEAPF32[i4 >> 2]);
       f14 = Math_fround(f38 * f41);
       f39 = Math_fround(HEAPF32[i4 + 12 >> 2]);
       f14 = Math_fround(f14 + Math_fround(f40 * f39));
       f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
       f14 = Math_fround(f14 + Math_fround(f42 * f11));
       f43 = Math_fround(HEAPF32[i4 + 4 >> 2]);
       f14 = Math_fround(f14 - Math_fround(f44 * f43));
       f13 = Math_fround(Math_fround(Math_fround(f44 * f41) + Math_fround(Math_fround(f42 * f39) + Math_fround(f38 * f43))) - Math_fround(f40 * f11));
       f12 = Math_fround(Math_fround(Math_fround(f40 * f43) + Math_fround(Math_fround(f44 * f39) + Math_fround(f38 * f11))) - Math_fround(f42 * f41));
       f11 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) - Math_fround(f40 * f41)) - Math_fround(f42 * f43)) - Math_fround(f44 * f11));
       i7 = HEAP16[i15 >> 1] | 0;
      }
      HEAPF32[i18 + (i6 * 80 | 0) + 16 >> 2] = f14;
      HEAPF32[i18 + (i6 * 80 | 0) + 20 >> 2] = f13;
      HEAPF32[i18 + (i6 * 80 | 0) + 24 >> 2] = f12;
      HEAPF32[i18 + (i6 * 80 | 0) + 28 >> 2] = f11;
      HEAPF32[i18 + (i6 * 80 | 0) + 32 >> 2] = f10;
      HEAPF32[i18 + (i6 * 80 | 0) + 36 >> 2] = f9;
      HEAPF32[i18 + (i6 * 80 | 0) + 40 >> 2] = f8;
      i5 = HEAP32[i16 >> 2] | 0;
      i4 = HEAP32[i17 >> 2] | 0;
      f8 = Math_fround(HEAPF32[i5 + 16 >> 2]);
      if (!(i7 & 64)) {
       f40 = Math_fround(f8 * Math_fround(2.0));
       f45 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * Math_fround(2.0));
       f13 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(2.0));
       f43 = Math_fround(HEAPF32[i4 + 12 >> 2]);
       f42 = Math_fround(Math_fround(f43 * f43) + Math_fround(-.5));
       f44 = Math_fround(HEAPF32[i4 >> 2]);
       f8 = Math_fround(f40 * f44);
       f41 = Math_fround(HEAPF32[i4 + 4 >> 2]);
       f8 = Math_fround(f8 + Math_fround(f45 * f41));
       f46 = Math_fround(HEAPF32[i4 + 8 >> 2]);
       f8 = Math_fround(f8 + Math_fround(f13 * f46));
       f10 = Math_fround(Math_fround(f44 * f8) + Math_fround(Math_fround(f40 * f42) + Math_fround(f43 * Math_fround(Math_fround(f13 * f41) - Math_fround(f45 * f46)))));
       f9 = Math_fround(Math_fround(f41 * f8) + Math_fround(Math_fround(f45 * f42) + Math_fround(f43 * Math_fround(Math_fround(f40 * f46) - Math_fround(f13 * f44)))));
       f8 = Math_fround(Math_fround(Math_fround(f13 * f42) + Math_fround(f43 * Math_fround(Math_fround(f45 * f44) - Math_fround(f40 * f41)))) + Math_fround(f46 * f8));
       f10 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f10);
       f9 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f9);
       f8 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f8);
       f40 = Math_fround(HEAPF32[i5 >> 2]);
       f45 = Math_fround(f43 * f40);
       f42 = Math_fround(HEAPF32[i5 + 12 >> 2]);
       f45 = Math_fround(f45 + Math_fround(f44 * f42));
       f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
       f45 = Math_fround(f45 + Math_fround(f41 * f13));
       f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f11 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f42) - Math_fround(f44 * f40)) - Math_fround(f41 * f14)) - Math_fround(f46 * f13));
       f12 = Math_fround(Math_fround(Math_fround(f44 * f14) + Math_fround(Math_fround(f46 * f42) + Math_fround(f43 * f13))) - Math_fround(f41 * f40));
       f13 = Math_fround(Math_fround(Math_fround(f46 * f40) + Math_fround(Math_fround(f41 * f42) + Math_fround(f43 * f14))) - Math_fround(f44 * f13));
       f14 = Math_fround(f45 - Math_fround(f46 * f14));
      } else {
       f11 = Math_fround(HEAPF32[i4 + 48 >> 2]);
       f42 = Math_fround(HEAPF32[i4 + 52 >> 2]);
       f11 = Math_fround(f11 * Math_fround(-2.0));
       f42 = Math_fround(f42 * Math_fround(-2.0));
       f10 = Math_fround(Math_fround(HEAPF32[i4 + 56 >> 2]) * Math_fround(-2.0));
       f39 = Math_fround(HEAPF32[i4 + 44 >> 2]);
       f40 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
       f14 = Math_fround(HEAPF32[i4 + 32 >> 2]);
       f46 = Math_fround(f11 * f14);
       f38 = Math_fround(HEAPF32[i4 + 36 >> 2]);
       f46 = Math_fround(f46 + Math_fround(f42 * f38));
       f12 = Math_fround(HEAPF32[i4 + 40 >> 2]);
       f46 = Math_fround(f46 + Math_fround(f10 * f12));
       f13 = Math_fround(-f14);
       f45 = Math_fround(-f38);
       f43 = Math_fround(-f12);
       f44 = Math_fround(Math_fround(Math_fround(f14 * f46) + Math_fround(Math_fround(f11 * f40) - Math_fround(f39 * Math_fround(Math_fround(f10 * f38) - Math_fround(f42 * f12))))) * Math_fround(2.0));
       f41 = Math_fround(Math_fround(Math_fround(f38 * f46) + Math_fround(Math_fround(f42 * f40) - Math_fround(f39 * Math_fround(Math_fround(f11 * f12) - Math_fround(f10 * f14))))) * Math_fround(2.0));
       f46 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f40) - Math_fround(f39 * Math_fround(Math_fround(f42 * f14) - Math_fround(f11 * f38)))) + Math_fround(f12 * f46)) * Math_fround(2.0));
       f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
       f38 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
       f11 = Math_fround(HEAPF32[i4 >> 2]);
       f14 = Math_fround(f11 * f44);
       f42 = Math_fround(HEAPF32[i4 + 4 >> 2]);
       f14 = Math_fround(f14 + Math_fround(f42 * f41));
       f40 = Math_fround(HEAPF32[i4 + 8 >> 2]);
       f14 = Math_fround(Math_fround(f40 * f46) + f14);
       f10 = Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f38 * f44) + Math_fround(f12 * Math_fround(Math_fround(f42 * f46) - Math_fround(f40 * f41)))));
       f9 = Math_fround(Math_fround(f42 * f14) + Math_fround(Math_fround(f38 * f41) + Math_fround(f12 * Math_fround(Math_fround(f40 * f44) - Math_fround(f11 * f46)))));
       f14 = Math_fround(Math_fround(Math_fround(f38 * f46) + Math_fround(f12 * Math_fround(Math_fround(f11 * f41) - Math_fround(f42 * f44)))) + Math_fround(f40 * f14));
       f10 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f10);
       f9 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f9);
       f14 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f14);
       f44 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f39 * f11)) + Math_fround(f42 * f43)) - Math_fround(f40 * f45));
       f41 = Math_fround(Math_fround(Math_fround(f40 * f13) + Math_fround(Math_fround(f12 * f45) + Math_fround(f39 * f42))) - Math_fround(f11 * f43));
       f46 = Math_fround(Math_fround(Math_fround(f11 * f45) + Math_fround(Math_fround(f12 * f43) + Math_fround(f39 * f40))) - Math_fround(f42 * f13));
       f43 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f12) - Math_fround(f11 * f13)) - Math_fround(f42 * f45)) - Math_fround(f40 * f43));
       f40 = Math_fround(f8 * Math_fround(2.0));
       f45 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * Math_fround(2.0));
       f42 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(2.0));
       f13 = Math_fround(Math_fround(f43 * f43) + Math_fround(-.5));
       f8 = Math_fround(Math_fround(Math_fround(f44 * f40) + Math_fround(f41 * f45)) + Math_fround(f46 * f42));
       f10 = Math_fround(f10 + Math_fround(Math_fround(f44 * f8) + Math_fround(Math_fround(f13 * f40) + Math_fround(f43 * Math_fround(Math_fround(f41 * f42) - Math_fround(f46 * f45))))));
       f9 = Math_fround(f9 + Math_fround(Math_fround(f41 * f8) + Math_fround(Math_fround(f13 * f45) + Math_fround(f43 * Math_fround(Math_fround(f46 * f40) - Math_fround(f44 * f42))))));
       f8 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f13 * f42) + Math_fround(f43 * Math_fround(Math_fround(f44 * f45) - Math_fround(f41 * f40)))) + Math_fround(f46 * f8)));
       f40 = Math_fround(HEAPF32[i5 >> 2]);
       f45 = Math_fround(f43 * f40);
       f42 = Math_fround(HEAPF32[i5 + 12 >> 2]);
       f45 = Math_fround(f45 + Math_fround(f44 * f42));
       f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
       f45 = Math_fround(f45 + Math_fround(f41 * f13));
       f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f11 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f42) - Math_fround(f44 * f40)) - Math_fround(f41 * f14)) - Math_fround(f46 * f13));
       f12 = Math_fround(Math_fround(Math_fround(f44 * f14) + Math_fround(Math_fround(f46 * f42) + Math_fround(f43 * f13))) - Math_fround(f41 * f40));
       f13 = Math_fround(Math_fround(Math_fround(f46 * f40) + Math_fround(Math_fround(f41 * f42) + Math_fround(f43 * f14))) - Math_fround(f44 * f13));
       f14 = Math_fround(f45 - Math_fround(f46 * f14));
      }
      HEAPF32[i18 + (i6 * 80 | 0) + 44 >> 2] = f14;
      HEAPF32[i18 + (i6 * 80 | 0) + 48 >> 2] = f13;
      HEAPF32[i18 + (i6 * 80 | 0) + 52 >> 2] = f12;
      HEAPF32[i18 + (i6 * 80 | 0) + 56 >> 2] = f11;
      HEAPF32[i18 + (i6 * 80 | 0) + 60 >> 2] = f10;
      HEAPF32[i18 + (i6 * 80 | 0) + 64 >> 2] = f9;
      HEAPF32[i18 + (i6 * 80 | 0) + 68 >> 2] = f8;
      i37 = (HEAP32[i21 + (i19 << 7) + 44 >> 2] | 0) + 24 | 0;
      HEAP32[i18 + (i6 * 80 | 0) + 72 >> 2] = i20;
      HEAP32[i18 + (i6 * 80 | 0) + 76 >> 2] = i37;
      i37 = HEAP8[i21 + (i19 << 7) + 112 >> 0] | 0;
      i36 = HEAP8[i21 + (i19 << 7) + 113 >> 0] | 0;
      i35 = (i37 & 255) < (i36 & 255);
      i37 = i31 + 7372 + (((i35 ? i37 : i36) & 255) * 28 | 0) + (((i35 ? i36 : i37) & 255) << 2) | 0;
      HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + 1;
     }
     if (!i3) break L31;
     i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i22;
     i3 = i3 + -1 & i3;
     if (!i3) break;
     if ((i4 | 0) == -1) break L31;
    }
    i5 = HEAP32[i33 >> 2] & 2147483647;
    do {
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i5 >>> 0) {
      i3 = 0;
      break;
     }
     i3 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    } while ((i3 | 0) == 0);
   } while ((i4 | 0) != -1);
  }
 } while (0);
 i2 = HEAP32[i26 >> 2] | 0;
 if (i2 | 0) {
  i37 = HEAP32[i29 >> 2] | 0;
  mftCall_viii(HEAP32[HEAP32[i37 >> 2] >> 2] | 0, i37 | 0, HEAP32[i28 >> 2] | 0, i2 | 0);
 }
 i5 = HEAP32[i33 >> 2] & 2147483647;
 if (!i5) return;
 i4 = HEAP32[i32 >> 2] | 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  if (i3 | 0) {
   i1 = i2;
   i30 = i3;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i5 >>> 0) {
   i34 = 83;
   break;
  }
 }
 if ((i34 | 0) == 83) return;
 i3 = (Math_imul(i30 & 0 - i30, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
 i2 = i30 + -1 & i30;
 L81 : do if (!i2) do {
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i2 = 0;
   break L81;
  }
  i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
 } while ((i2 | 0) == 0); while (0);
 if ((i3 | 0) == -1) return;
 i24 = i31 + 708 | 0;
 i25 = i31 + 720 | 0;
 i23 = i31 + 696 | 0;
 L89 : while (1) {
  i22 = i1 << 5;
  while (1) {
   i21 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i3 >>> (HEAP32[i24 >> 2] | 0) << 2) >> 2] | 0;
   i20 = (HEAP32[i23 >> 2] | 0) + -1 & i3;
   i19 = i21 + (i20 << 7) + 36 | 0;
   if (!(HEAP16[i19 >> 1] | 0)) i34 = 72; else {
    i3 = HEAP32[i21 + (i20 << 7) + 44 >> 2] | 0;
    i16 = HEAP32[i21 + (i20 << 7) + 48 >> 2] | 0;
    if (!i16) {
     i5 = 0;
     i17 = 0;
     i18 = 0;
     i4 = 0;
    } else {
     i18 = HEAPU16[i3 + 2 >> 1] | 0;
     i4 = i18 & 2;
     i37 = (i4 | 0) != 0;
     i5 = i37;
     i17 = i37 ? 4 : 32;
     i18 = i37 ? 72 : i18 << 3 & 8 | 16;
     i4 = i3 + (i4 << 3 | 4) | 0;
    }
    i15 = i3;
    if ((i4 - i15 | 0) >>> 0 < i16 >>> 0) {
     if (i5) {
      i3 = 0;
      do {
       i37 = HEAP16[i4 >> 1] | 0;
       i7 = i37 & 65535;
       i5 = i4;
       i4 = i4 + ((Math_imul(i7, i18) | 0) + i17) | 0;
       if (i37 << 16 >> 16) {
        i5 = i5 + i17 | 0;
        i6 = 0;
        while (1) {
         i6 = i6 + 1 | 0;
         i3 = (Math_fround(HEAPF32[i5 + 48 >> 2]) != Math_fround(0.0) & 1) + i3 | 0;
         if ((i6 | 0) == (i7 | 0)) break; else i5 = i5 + i18 | 0;
        }
       }
      } while ((i4 - i15 | 0) >>> 0 < i16 >>> 0);
     } else {
      i3 = 0;
      do {
       i37 = HEAPU16[i4 >> 1] | 0;
       i4 = i4 + ((Math_imul(i37, i18) | 0) + i17) | 0;
       i3 = i3 + i37 | 0;
      } while ((i4 - i15 | 0) >>> 0 < i16 >>> 0);
     }
     if (!i3) i34 = 72;
    } else i34 = 72;
   }
   if ((i34 | 0) == 72) {
    i34 = 0;
    HEAP16[i19 >> 1] = 0;
    i4 = i21 + (i20 << 7) + 40 | 0;
    HEAP32[i21 + (i20 << 7) + 64 >> 2] = 0;
    HEAP16[i21 + (i20 << 7) + 72 >> 1] = 0;
    HEAP32[i21 + (i20 << 7) + 68 >> 2] = 0;
    i3 = i21 + (i20 << 7) + 60 | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP32[i4 + 16 >> 2] = 0;
    i4 = HEAP32[i3 >> 2] | 0;
    do if (i4 | 0) if (!(i4 & 1)) {
     i37 = i4;
     HEAP8[i37 + 33 >> 0] = 0;
     HEAP8[i37 + 32 >> 0] = 0;
     HEAP32[i37 + 16 >> 2] = 2139095039;
     HEAP32[i37 + 20 >> 2] = 2139095039;
     HEAP32[i37 + 24 >> 2] = 2139095039;
     HEAPF32[i37 + 28 >> 2] = Math_fround(0.0);
     HEAP32[i4 >> 2] = 0;
     HEAP32[i37 + 4 >> 2] = 0;
     HEAP32[i37 + 8 >> 2] = 0;
     HEAP32[i37 + 12 >> 2] = 1065353216;
     break;
    } else {
     HEAP32[i3 >> 2] = 1;
     break;
    } while (0);
    i37 = i21 + (i20 << 7) + 114 | 0;
    HEAP16[i37 >> 1] = HEAPU16[i37 >> 1] & 65531;
   }
   if (!i2) {
    i34 = 83;
    break L89;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i22;
   i2 = i2 + -1 & i2;
   if (!i2) break;
   if ((i3 | 0) == -1) {
    i34 = 83;
    break L89;
   }
  }
  i4 = HEAP32[i33 >> 2] & 2147483647;
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i2 = 0;
    break;
   }
   i2 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
  if ((i3 | 0) == -1) {
   i34 = 83;
   break;
  }
 }
 if ((i34 | 0) == 83) return;
}

function __ZN5physx16PxcContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i15, i16, i5, i14, i13, i1, i86) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i86 = i86 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i89 + 184 | 0;
 i49 = i89 + 160 | 0;
 i88 = i89 + 112 | 0;
 i87 = i89 + 96 | 0;
 i76 = i89 + 48 | 0;
 i77 = i89;
 i85 = i1 + 4 | 0;
 i48 = HEAP32[i85 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f84 = Math_fround(f3 + f3);
 f2 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f80 = Math_fround(f2 + f2);
 f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f72 = Math_fround(f4 + f4);
 f73 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f82 = Math_fround(f84 * f73);
 f6 = Math_fround(f80 * f73);
 f73 = Math_fround(f73 * f72);
 f84 = Math_fround(f3 * f84);
 f74 = Math_fround(f3 * f80);
 f3 = Math_fround(f3 * f72);
 f80 = Math_fround(f2 * f80);
 f2 = Math_fround(f2 * f72);
 f72 = Math_fround(f4 * f72);
 HEAPF32[i76 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f80) - f72);
 i91 = i76 + 4 | 0;
 HEAPF32[i91 >> 2] = Math_fround(f74 + f73);
 i90 = i76 + 8 | 0;
 HEAPF32[i90 >> 2] = Math_fround(f3 - f6);
 i1 = i76 + 12 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f74 - f73);
 f84 = Math_fround(Math_fround(1.0) - f84);
 i20 = i76 + 16 | 0;
 HEAPF32[i20 >> 2] = Math_fround(f84 - f72);
 i21 = i76 + 20 | 0;
 HEAPF32[i21 >> 2] = Math_fround(f2 + f82);
 i22 = i76 + 24 | 0;
 HEAPF32[i22 >> 2] = Math_fround(f3 + f6);
 i23 = i76 + 28 | 0;
 HEAPF32[i23 >> 2] = Math_fround(f2 - f82);
 i24 = i76 + 32 | 0;
 HEAPF32[i24 >> 2] = Math_fround(f84 - f80);
 i93 = i76 + 40 | 0;
 i92 = i76 + 44 | 0;
 HEAP32[i76 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i93 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i92 >> 2] = HEAP32[i5 + 24 >> 2];
 f80 = Math_fround(HEAPF32[i14 >> 2]);
 f84 = Math_fround(f80 + f80);
 f82 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f2 = Math_fround(f82 + f82);
 f6 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f3 = Math_fround(f6 + f6);
 f72 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f73 = Math_fround(f84 * f72);
 f74 = Math_fround(f2 * f72);
 f72 = Math_fround(f72 * f3);
 f84 = Math_fround(f80 * f84);
 f4 = Math_fround(f80 * f2);
 f80 = Math_fround(f80 * f3);
 f2 = Math_fround(f82 * f2);
 f82 = Math_fround(f82 * f3);
 f3 = Math_fround(f6 * f3);
 f6 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f3);
 HEAPF32[i77 >> 2] = f6;
 f7 = Math_fround(f4 + f72);
 i54 = i77 + 4 | 0;
 HEAPF32[i54 >> 2] = f7;
 f8 = Math_fround(f80 - f74);
 i59 = i77 + 8 | 0;
 HEAPF32[i59 >> 2] = f8;
 f72 = Math_fround(f4 - f72);
 i60 = i77 + 12 | 0;
 HEAPF32[i60 >> 2] = f72;
 f84 = Math_fround(Math_fround(1.0) - f84);
 f3 = Math_fround(f84 - f3);
 i61 = i77 + 16 | 0;
 HEAPF32[i61 >> 2] = f3;
 f4 = Math_fround(f82 + f73);
 i62 = i77 + 20 | 0;
 HEAPF32[i62 >> 2] = f4;
 f74 = Math_fround(f80 + f74);
 i63 = i77 + 24 | 0;
 HEAPF32[i63 >> 2] = f74;
 f73 = Math_fround(f82 - f73);
 i64 = i77 + 28 | 0;
 HEAPF32[i64 >> 2] = f73;
 f2 = Math_fround(f84 - f2);
 i65 = i77 + 32 | 0;
 HEAPF32[i65 >> 2] = f2;
 i94 = HEAP32[i14 + 16 >> 2] | 0;
 HEAP32[i77 + 36 >> 2] = i94;
 i5 = HEAP32[i14 + 20 >> 2] | 0;
 HEAP32[i77 + 40 >> 2] = i5;
 i14 = HEAP32[i14 + 24 >> 2] | 0;
 HEAP32[i77 + 44 >> 2] = i14;
 f84 = Math_fround(HEAPF32[i13 >> 2]);
 f82 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f80 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f79 = Math_fround(HEAPF32[i15 + 12 >> 2]);
 f81 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f83 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f78 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f67 = (HEAP32[tempDoublePtr >> 2] = i94, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f68 = Math_fround(HEAPF32[i76 + 36 >> 2]);
 f9 = Math_fround(f67 - f68);
 f56 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f57 = Math_fround(HEAPF32[i93 >> 2]);
 f39 = Math_fround(f56 - f57);
 f50 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = Math_fround(HEAPF32[i92 >> 2]);
 f40 = Math_fround(f50 - f51);
 f66 = Math_fround(HEAPF32[i76 >> 2]);
 f41 = Math_fround(f66 * f6);
 f58 = Math_fround(HEAPF32[i91 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f58 * f7));
 f53 = Math_fround(HEAPF32[i90 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f53 * f8));
 f42 = Math_fround(Math_fround(Math_fround(f66 * f72) + Math_fround(f58 * f3)) + Math_fround(f53 * f4));
 f43 = Math_fround(Math_fround(Math_fround(f66 * f74) + Math_fround(f58 * f73)) + Math_fround(f53 * f2));
 f44 = Math_fround(Math_fround(Math_fround(f9 * f66) + Math_fround(f39 * f58)) + Math_fround(f40 * f53));
 f45 = Math_fround(Math_fround(Math_abs(Math_fround(f41))) + Math_fround(9.99999997e-07));
 f46 = Math_fround(Math_fround(Math_abs(Math_fround(f42))) + Math_fround(9.99999997e-07));
 f47 = Math_fround(Math_fround(Math_abs(Math_fround(f43))) + Math_fround(9.99999997e-07));
 HEAPF32[i55 >> 2] = f44;
 f19 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f82 + Math_fround(f81 * f45)) + Math_fround(f83 * f46)) + Math_fround(f78 * f47)) - Math_fround(Math_abs(Math_fround(f44)))));
 HEAPF32[i49 >> 2] = f19;
 if (f19 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 f69 = Math_fround(HEAPF32[i1 >> 2]);
 f32 = Math_fround(f6 * f69);
 f70 = Math_fround(HEAPF32[i20 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f7 * f70));
 f52 = Math_fround(HEAPF32[i21 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f8 * f52));
 f33 = Math_fround(Math_fround(Math_fround(f72 * f69) + Math_fround(f3 * f70)) + Math_fround(f4 * f52));
 f34 = Math_fround(Math_fround(Math_fround(f74 * f69) + Math_fround(f73 * f70)) + Math_fround(f2 * f52));
 f35 = Math_fround(Math_fround(Math_fround(f9 * f69) + Math_fround(f39 * f70)) + Math_fround(f40 * f52));
 f36 = Math_fround(Math_fround(Math_abs(Math_fround(f32))) + Math_fround(9.99999997e-07));
 f37 = Math_fround(Math_fround(Math_abs(Math_fround(f33))) + Math_fround(9.99999997e-07));
 f38 = Math_fround(Math_fround(Math_abs(Math_fround(f34))) + Math_fround(9.99999997e-07));
 HEAPF32[i55 + 4 >> 2] = f35;
 f18 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f80 + Math_fround(f81 * f36)) + Math_fround(f83 * f37)) + Math_fround(f78 * f38)) - Math_fround(Math_abs(Math_fround(f35)))));
 i15 = i49 + 4 | 0;
 HEAPF32[i15 >> 2] = f18;
 if (f18 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 f10 = Math_fround(HEAPF32[i22 >> 2]);
 f25 = Math_fround(f6 * f10);
 f71 = Math_fround(HEAPF32[i23 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f7 * f71));
 f75 = Math_fround(HEAPF32[i24 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f8 * f75));
 f26 = Math_fround(Math_fround(Math_fround(f72 * f10) + Math_fround(f3 * f71)) + Math_fround(f4 * f75));
 f27 = Math_fround(Math_fround(Math_fround(f74 * f10) + Math_fround(f73 * f71)) + Math_fround(f2 * f75));
 f28 = Math_fround(Math_fround(Math_fround(f9 * f10) + Math_fround(f39 * f71)) + Math_fround(f40 * f75));
 f29 = Math_fround(Math_fround(Math_abs(Math_fround(f25))) + Math_fround(9.99999997e-07));
 f30 = Math_fround(Math_fround(Math_abs(Math_fround(f26))) + Math_fround(9.99999997e-07));
 f31 = Math_fround(Math_fround(Math_abs(Math_fround(f27))) + Math_fround(9.99999997e-07));
 HEAPF32[i55 + 8 >> 2] = f28;
 f17 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f79 + Math_fround(f81 * f29)) + Math_fround(f83 * f30)) + Math_fround(f78 * f31)) - Math_fround(Math_abs(Math_fround(f28)))));
 i1 = i49 + 8 | 0;
 HEAPF32[i1 >> 2] = f17;
 if (f17 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 f12 = Math_fround(Math_fround(Math_fround(f9 * f6) + Math_fround(f39 * f7)) + Math_fround(f40 * f8));
 HEAPF32[i55 + 12 >> 2] = f12;
 f12 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f81 + Math_fround(f82 * f45)) + Math_fround(f80 * f36)) + Math_fround(f79 * f29)) - Math_fround(Math_abs(Math_fround(f12)))));
 i5 = i49 + 12 | 0;
 HEAPF32[i5 >> 2] = f12;
 if (f12 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 f11 = Math_fround(Math_fround(Math_fround(f9 * f72) + Math_fround(f39 * f3)) + Math_fround(f40 * f4));
 HEAPF32[i55 + 16 >> 2] = f11;
 f11 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f83 + Math_fround(f82 * f46)) + Math_fround(f80 * f37)) + Math_fround(f79 * f30)) - Math_fround(Math_abs(Math_fround(f11)))));
 i13 = i49 + 16 | 0;
 HEAPF32[i13 >> 2] = f11;
 if (f11 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 f9 = Math_fround(Math_fround(Math_fround(f9 * f74) + Math_fround(f39 * f73)) + Math_fround(f40 * f2));
 HEAPF32[i55 + 20 >> 2] = f9;
 f9 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f78 + Math_fround(f82 * f47)) + Math_fround(f80 * f38)) + Math_fround(f79 * f31)) - Math_fround(Math_abs(Math_fround(f9)))));
 i14 = i49 + 20 | 0;
 HEAPF32[i14 >> 2] = f9;
 if (f9 < Math_fround(0.0)) {
  i94 = 0;
  i93 = i48;
  i94 = (i94 | 0) == 0;
  i93 = i94 ? 0 : i93;
  HEAP32[i85 >> 2] = i93;
  i94 = i94 ^ 1;
  STACKTOP = i89;
  return i94 | 0;
 }
 if (!i48) {
  if (Math_fround(Math_abs(Math_fround(Math_fround(f32 * f28) - Math_fround(f35 * f25)))) > Math_fround(Math_fround(f78 * f46) + Math_fround(Math_fround(f83 * f47) + Math_fround(Math_fround(f79 * f36) + Math_fround(f84 + Math_fround(f80 * f29)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f33 * f28) - Math_fround(f35 * f26)))) > Math_fround(Math_fround(f78 * f45) + Math_fround(Math_fround(f81 * f47) + Math_fround(Math_fround(f79 * f37) + Math_fround(f84 + Math_fround(f80 * f30)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f34 * f28) - Math_fround(f35 * f27)))) > Math_fround(Math_fround(f83 * f45) + Math_fround(Math_fround(f81 * f46) + Math_fround(Math_fround(f79 * f38) + Math_fround(f84 + Math_fround(f80 * f31)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f44 * f25) - Math_fround(f41 * f28)))) > Math_fround(Math_fround(f78 * f37) + Math_fround(Math_fround(f83 * f38) + Math_fround(Math_fround(f79 * f45) + Math_fround(f84 + Math_fround(f82 * f29)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f44 * f26) - Math_fround(f42 * f28)))) > Math_fround(Math_fround(f78 * f36) + Math_fround(Math_fround(f81 * f38) + Math_fround(Math_fround(f79 * f46) + Math_fround(f84 + Math_fround(f82 * f30)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f44 * f27) - Math_fround(f43 * f28)))) > Math_fround(Math_fround(f83 * f36) + Math_fround(Math_fround(f81 * f37) + Math_fround(Math_fround(f79 * f47) + Math_fround(f84 + Math_fround(f82 * f31)))))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f41 * f35) - Math_fround(f44 * f32)))) > Math_fround(Math_fround(f78 * f30) + Math_fround(Math_fround(Math_fround(f80 * f45) + Math_fround(f84 + Math_fround(f82 * f36))) + Math_fround(f83 * f31)))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f42 * f35) - Math_fround(f44 * f33)))) > Math_fround(Math_fround(f78 * f29) + Math_fround(Math_fround(Math_fround(f80 * f46) + Math_fround(f84 + Math_fround(f82 * f37))) + Math_fround(f81 * f31)))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f43 * f35) - Math_fround(f44 * f34)))) > Math_fround(Math_fround(f83 * f29) + Math_fround(Math_fround(Math_fround(f80 * f47) + Math_fround(f84 + Math_fround(f82 * f38))) + Math_fround(f81 * f30)))) {
   i94 = 0;
   i93 = 0;
   i94 = (i94 | 0) == 0;
   i93 = i94 ? 0 : i93;
   HEAP32[i85 >> 2] = i93;
   i94 = i94 ^ 1;
   STACKTOP = i89;
   return i94 | 0;
  }
 } else {
  i94 = i49 + (i48 + -1 << 2) | 0;
  HEAPF32[i94 >> 2] = Math_fround(Math_fround(HEAPF32[i94 >> 2]) * Math_fround(.999000012));
  f19 = Math_fround(HEAPF32[i49 >> 2]);
  f18 = Math_fround(HEAPF32[i15 >> 2]);
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(HEAPF32[i13 >> 2]);
  f9 = Math_fround(HEAPF32[i14 >> 2]);
 }
 i94 = f19 >= Math_fround(0.0) & f19 < Math_fround(3402823469999999843913219.0e14);
 f47 = i94 ? f19 : Math_fround(3402823469999999843913219.0e14);
 i94 = f18 >= Math_fround(0.0) & f18 < f47;
 f47 = i94 ? f18 : f47;
 i15 = f17 >= Math_fround(0.0) & f17 < f47;
 f47 = i15 ? f17 : f47;
 i14 = f12 >= Math_fround(0.0) & f12 < f47;
 f47 = i14 ? f12 : f47;
 i93 = f11 >= Math_fround(0.0) & f11 < f47;
 i92 = f9 >= Math_fround(0.0) & f9 < (i93 ? f11 : f47);
 i94 = i92 ? 5 : i93 ? 4 : i14 ? 3 : i15 ? 2 : i94 & 1;
 i15 = i94 + 1 | 0;
 i14 = Math_fround(HEAPF32[i55 + (i94 << 2) >> 2]) < Math_fround(0.0);
 switch (i94 | 0) {
 case 0:
  {
   if (i14) {
    HEAPF32[i87 >> 2] = f66;
    HEAPF32[i87 + 4 >> 2] = f58;
    HEAPF32[i87 + 8 >> 2] = f53;
    HEAPF32[i88 >> 2] = f66;
    HEAPF32[i88 + 4 >> 2] = f58;
    HEAPF32[i88 + 8 >> 2] = f53;
    f8 = f52;
    f7 = Math_fround(f51 - Math_fround(f82 * f53));
    f6 = Math_fround(f57 - Math_fround(f82 * f58));
    f4 = Math_fround(f68 - Math_fround(f82 * f66));
    f3 = f70;
    f2 = f69;
   } else {
    f6 = Math_fround(-f66);
    f7 = Math_fround(-f58);
    f8 = Math_fround(-f53);
    HEAPF32[i87 >> 2] = f6;
    HEAPF32[i87 + 4 >> 2] = f7;
    HEAPF32[i87 + 8 >> 2] = f8;
    HEAPF32[i88 >> 2] = f6;
    HEAPF32[i88 + 4 >> 2] = f7;
    HEAPF32[i88 + 8 >> 2] = f8;
    f8 = Math_fround(-f52);
    f7 = Math_fround(Math_fround(f82 * f53) + f51);
    f6 = Math_fround(Math_fround(f82 * f58) + f57);
    f4 = Math_fround(Math_fround(f82 * f66) + f68);
    f3 = Math_fround(-f70);
    f2 = Math_fround(-f69);
   }
   HEAPF32[i88 + 12 >> 2] = f2;
   HEAPF32[i88 + 16 >> 2] = f3;
   HEAPF32[i88 + 20 >> 2] = f8;
   HEAPF32[i88 + 24 >> 2] = f10;
   HEAPF32[i88 + 28 >> 2] = f71;
   HEAPF32[i88 + 32 >> 2] = f75;
   HEAPF32[i88 + 36 >> 2] = f4;
   HEAPF32[i88 + 40 >> 2] = f6;
   HEAPF32[i88 + 44 >> 2] = f7;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f80, f79, f81, f83, f78, i88, i77, f84) | 0;
   break;
  }
 case 1:
  {
   HEAPF32[i88 + 24 >> 2] = f66;
   HEAPF32[i88 + 28 >> 2] = f58;
   HEAPF32[i88 + 32 >> 2] = f53;
   if (i14) {
    HEAPF32[i87 >> 2] = f69;
    f11 = f71;
    f9 = Math_fround(f51 - Math_fround(f80 * f52));
    f8 = Math_fround(f57 - Math_fround(f80 * f70));
    f7 = Math_fround(f68 - Math_fround(f80 * f69));
    f6 = f69;
    f4 = f52;
    f3 = f70;
    f2 = f75;
   } else {
    f6 = Math_fround(-f69);
    f3 = Math_fround(-f70);
    f4 = Math_fround(-f52);
    HEAPF32[i87 >> 2] = f6;
    f11 = Math_fround(-f71);
    f10 = Math_fround(-f10);
    f9 = Math_fround(Math_fround(f80 * f52) + f51);
    f8 = Math_fround(Math_fround(f80 * f70) + f57);
    f7 = Math_fround(Math_fround(f80 * f69) + f68);
    f2 = Math_fround(-f75);
   }
   HEAPF32[i87 + 4 >> 2] = f3;
   HEAPF32[i87 + 8 >> 2] = f4;
   HEAPF32[i88 >> 2] = f6;
   HEAPF32[i88 + 4 >> 2] = f3;
   HEAPF32[i88 + 8 >> 2] = f4;
   HEAPF32[i88 + 12 >> 2] = f10;
   HEAPF32[i88 + 16 >> 2] = f11;
   HEAPF32[i88 + 20 >> 2] = f2;
   HEAPF32[i88 + 36 >> 2] = f7;
   HEAPF32[i88 + 40 >> 2] = f8;
   HEAPF32[i88 + 44 >> 2] = f9;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f79, f82, f81, f83, f78, i88, i77, f84) | 0;
   break;
  }
 case 2:
  {
   HEAPF32[i88 + 24 >> 2] = f69;
   HEAPF32[i88 + 28 >> 2] = f70;
   HEAPF32[i88 + 32 >> 2] = f52;
   if (i14) {
    HEAPF32[i87 >> 2] = f10;
    f12 = Math_fround(f51 - Math_fround(f79 * f75));
    f11 = Math_fround(f57 - Math_fround(f79 * f71));
    f9 = Math_fround(f68 - Math_fround(f79 * f10));
    f8 = f53;
    f7 = f58;
    f6 = f66;
    f4 = f10;
    f3 = f75;
    f2 = f71;
   } else {
    f4 = Math_fround(-f10);
    f2 = Math_fround(-f71);
    f3 = Math_fround(-f75);
    HEAPF32[i87 >> 2] = f4;
    f12 = Math_fround(Math_fround(f79 * f75) + f51);
    f11 = Math_fround(Math_fround(f79 * f71) + f57);
    f9 = Math_fround(Math_fround(f79 * f10) + f68);
    f8 = Math_fround(-f53);
    f7 = Math_fround(-f58);
    f6 = Math_fround(-f66);
   }
   HEAPF32[i87 + 4 >> 2] = f2;
   HEAPF32[i87 + 8 >> 2] = f3;
   HEAPF32[i88 >> 2] = f4;
   HEAPF32[i88 + 4 >> 2] = f2;
   HEAPF32[i88 + 8 >> 2] = f3;
   HEAPF32[i88 + 12 >> 2] = f6;
   HEAPF32[i88 + 16 >> 2] = f7;
   HEAPF32[i88 + 20 >> 2] = f8;
   HEAPF32[i88 + 36 >> 2] = f9;
   HEAPF32[i88 + 40 >> 2] = f11;
   HEAPF32[i88 + 44 >> 2] = f12;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f82, f80, f81, f83, f78, i88, i77, f84) | 0;
   break;
  }
 case 3:
  {
   if (i14) {
    HEAPF32[i87 >> 2] = f6;
    HEAPF32[i87 + 4 >> 2] = f7;
    HEAPF32[i87 + 8 >> 2] = f8;
    f3 = Math_fround(-f7);
    f75 = Math_fround(-f8);
    HEAPF32[i88 >> 2] = Math_fround(-f6);
    HEAPF32[i88 + 4 >> 2] = f3;
    HEAPF32[i88 + 8 >> 2] = f75;
    f75 = Math_fround(-Math_fround(HEAPF32[i60 >> 2]));
    f3 = Math_fround(-Math_fround(HEAPF32[i61 >> 2]));
    f4 = Math_fround(-Math_fround(HEAPF32[i62 >> 2]));
    HEAPF32[i88 + 12 >> 2] = f75;
    f8 = Math_fround(Math_fround(f81 * f8) + f50);
    f7 = Math_fround(Math_fround(f81 * f7) + f56);
    f6 = Math_fround(Math_fround(f81 * f6) + f67);
   } else {
    f6 = Math_fround(HEAPF32[i77 >> 2]);
    f70 = Math_fround(-f6);
    f7 = Math_fround(HEAPF32[i54 >> 2]);
    f71 = Math_fround(-f7);
    f8 = Math_fround(HEAPF32[i59 >> 2]);
    f75 = Math_fround(-f8);
    HEAPF32[i87 >> 2] = f70;
    HEAPF32[i87 + 4 >> 2] = f71;
    HEAPF32[i87 + 8 >> 2] = f75;
    HEAPF32[i88 >> 2] = f6;
    HEAPF32[i88 + 4 >> 2] = f7;
    HEAPF32[i88 + 8 >> 2] = f8;
    HEAPF32[i88 + 12 >> 2] = f72;
    f8 = Math_fround(f50 - Math_fround(f81 * f8));
    f7 = Math_fround(f56 - Math_fround(f81 * f7));
    f6 = Math_fround(f67 - Math_fround(f81 * f6));
   }
   HEAPF32[i88 + 16 >> 2] = f3;
   HEAPF32[i88 + 20 >> 2] = f4;
   HEAPF32[i88 + 24 >> 2] = f74;
   HEAPF32[i88 + 28 >> 2] = f73;
   HEAPF32[i88 + 32 >> 2] = f2;
   HEAPF32[i88 + 36 >> 2] = f6;
   HEAPF32[i88 + 40 >> 2] = f7;
   HEAPF32[i88 + 44 >> 2] = f8;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f83, f78, f82, f80, f79, i88, i76, f84) | 0;
   break;
  }
 case 4:
  {
   i1 = i88 + 24 | 0;
   HEAPF32[i1 >> 2] = f6;
   i5 = i88 + 28 | 0;
   HEAPF32[i5 >> 2] = f7;
   i13 = i88 + 32 | 0;
   HEAPF32[i13 >> 2] = f8;
   if (i14) {
    HEAPF32[i87 >> 2] = f72;
    HEAPF32[i87 + 4 >> 2] = f3;
    HEAPF32[i87 + 8 >> 2] = f4;
    f6 = Math_fround(-f3);
    f75 = Math_fround(-f4);
    HEAPF32[i88 >> 2] = Math_fround(-f72);
    HEAPF32[i88 + 4 >> 2] = f6;
    HEAPF32[i88 + 8 >> 2] = f75;
    f75 = Math_fround(-Math_fround(HEAPF32[i63 >> 2]));
    f6 = Math_fround(-Math_fround(HEAPF32[i64 >> 2]));
    f2 = Math_fround(-Math_fround(HEAPF32[i65 >> 2]));
    HEAPF32[i88 + 12 >> 2] = f75;
    HEAPF32[i88 + 16 >> 2] = f6;
    f6 = Math_fround(Math_fround(f83 * f4) + f50);
    f4 = Math_fround(Math_fround(f83 * f3) + f56);
    f3 = Math_fround(Math_fround(f83 * f72) + f67);
   } else {
    f3 = Math_fround(HEAPF32[i60 >> 2]);
    f70 = Math_fround(-f3);
    f4 = Math_fround(HEAPF32[i61 >> 2]);
    f71 = Math_fround(-f4);
    f75 = Math_fround(HEAPF32[i62 >> 2]);
    f72 = Math_fround(-f75);
    HEAPF32[i87 >> 2] = f70;
    HEAPF32[i87 + 4 >> 2] = f71;
    HEAPF32[i87 + 8 >> 2] = f72;
    HEAPF32[i88 >> 2] = f3;
    HEAPF32[i88 + 4 >> 2] = f4;
    HEAPF32[i88 + 8 >> 2] = f75;
    HEAPF32[i88 + 12 >> 2] = f74;
    HEAPF32[i88 + 16 >> 2] = f73;
    HEAPF32[i1 >> 2] = f6;
    HEAPF32[i5 >> 2] = f7;
    HEAPF32[i13 >> 2] = f8;
    f6 = Math_fround(f50 - Math_fround(f83 * f75));
    f4 = Math_fround(f56 - Math_fround(f83 * f4));
    f3 = Math_fround(f67 - Math_fround(f83 * f3));
   }
   HEAPF32[i88 + 20 >> 2] = f2;
   HEAPF32[i88 + 36 >> 2] = f3;
   HEAPF32[i88 + 40 >> 2] = f4;
   HEAPF32[i88 + 44 >> 2] = f6;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f78, f81, f82, f80, f79, i88, i76, f84) | 0;
   break;
  }
 case 5:
  {
   HEAPF32[i88 + 24 >> 2] = f72;
   HEAPF32[i88 + 28 >> 2] = f3;
   HEAPF32[i88 + 32 >> 2] = f4;
   if (i14) {
    HEAPF32[i87 >> 2] = f74;
    HEAPF32[i87 + 4 >> 2] = f73;
    HEAPF32[i87 + 8 >> 2] = f2;
    f4 = Math_fround(-f74);
    f3 = Math_fround(-f73);
    f75 = Math_fround(-f2);
    f6 = Math_fround(-Math_fround(HEAPF32[i77 >> 2]));
    f7 = Math_fround(-Math_fround(HEAPF32[i54 >> 2]));
    f11 = Math_fround(Math_fround(f78 * f2) + f50);
    f10 = Math_fround(Math_fround(f78 * f73) + f56);
    f9 = Math_fround(Math_fround(f78 * f74) + f67);
    f8 = Math_fround(-Math_fround(HEAPF32[i59 >> 2]));
    f2 = f75;
   } else {
    f4 = Math_fround(HEAPF32[i63 >> 2]);
    f9 = Math_fround(-f4);
    f3 = Math_fround(HEAPF32[i64 >> 2]);
    f10 = Math_fround(-f3);
    f11 = Math_fround(-f2);
    HEAPF32[i87 >> 2] = f9;
    HEAPF32[i87 + 4 >> 2] = f10;
    HEAPF32[i87 + 8 >> 2] = f11;
    f11 = Math_fround(f50 - Math_fround(f78 * f2));
    f10 = Math_fround(f56 - Math_fround(f78 * f3));
    f9 = Math_fround(f67 - Math_fround(f78 * f4));
   }
   HEAPF32[i88 >> 2] = f4;
   HEAPF32[i88 + 4 >> 2] = f3;
   HEAPF32[i88 + 8 >> 2] = f2;
   HEAPF32[i88 + 12 >> 2] = f6;
   HEAPF32[i88 + 16 >> 2] = f7;
   HEAPF32[i88 + 20 >> 2] = f8;
   HEAPF32[i88 + 36 >> 2] = f9;
   HEAPF32[i88 + 40 >> 2] = f10;
   HEAPF32[i88 + 44 >> 2] = f11;
   i1 = __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i86, i87, f81, f83, f82, f80, f79, i88, i76, f84) | 0;
   break;
  }
 default:
  i1 = 0;
 }
 i94 = i1;
 i93 = i15;
 i94 = (i94 | 0) == 0;
 i93 = i94 ? 0 : i93;
 HEAP32[i85 >> 2] = i93;
 i94 = i94 ^ 1;
 STACKTOP = i89;
 return i94 | 0;
}

function __Z26GarbageCollectSharedAssetsb(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, d49 = 0.0, d50 = 0.0, d51 = 0.0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i47 + 144 | 0;
 i43 = i47 + 104 | 0;
 i42 = i47 + 96 | 0;
 i40 = i47 + 88 | 0;
 i32 = i47;
 i29 = i47 + 280 | 0;
 i30 = i47 + 260 | 0;
 i2 = i47 + 336 | 0;
 i46 = i47 + 152 | 0;
 i41 = i47 + 304 | 0;
 if ((HEAP16[gb + 1162744 + 6 >> 1] | 0) > -1) {
  HEAP32[i29 >> 2] = 0;
  HEAP32[i44 >> 2] = HEAP32[i29 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162744 | 0, i44);
  i45 = gb + 1162744 | 0;
 } else i45 = 0;
 __Z11FormatBytesx(i2, __Z15GetUsedHeapSizev() | 0, 0);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i32 >> 2] = (i1 | 0) == 0 ? i2 + 4 | 0 : i1;
 _printf_console(gb + 451430 | 0, i32);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i2 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2 + 24 | 0);
 d8 = +_emscripten_get_now() * 1.0e6;
 i33 = ~~d8 >>> 0;
 i34 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i31 = HEAP32[gb + 1104264 >> 2] | 0;
 i31 = (HEAP32[i31 + 36 >> 2] | 0) - (HEAP32[i31 + 4 >> 2] | 0) | 0;
 i37 = gb + 64016 | 0;
 i36 = HEAP32[i37 + 4 >> 2] | 0;
 i27 = i32;
 HEAP32[i27 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i27 + 4 >> 2] = i36;
 HEAP32[i46 >> 2] = 0;
 i27 = i46 + 12 | 0;
 HEAP32[i27 >> 2] = 0;
 i36 = i46 + 16 | 0;
 HEAP32[i36 >> 2] = 0;
 i37 = i46 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, i32);
 i39 = i44;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i18 = i37;
 HEAP32[i18 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i18 + 4 >> 2] = i38;
 HEAP32[i46 + 20 >> 2] = 0;
 i18 = i46 + 32 | 0;
 HEAP32[i18 >> 2] = 0;
 i38 = i46 + 36 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i46 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, gb + 63664 | 0);
 i22 = i44;
 i19 = HEAP32[i22 + 4 >> 2] | 0;
 i12 = i39;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = i19;
 HEAP32[i46 + 48 >> 2] = 0;
 HEAP8[i46 + 52 >> 0] = 0;
 HEAP8[i46 + 53 >> 0] = 0;
 i12 = i46 + 56 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 i12 = i46 + 76 | 0;
 HEAP32[i12 >> 2] = 32;
 HEAP32[i46 + 80 >> 2] = 0;
 HEAP32[i46 + 96 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f48 = Math_fround((HEAP32[i12 >> 2] | 0) >>> 0);
 HEAP32[i46 + 88 >> 2] = ~~Math_fround(f48 * Math_fround(.5)) >>> 0;
 HEAP32[i46 + 84 >> 2] = ~~Math_fround(f48 * Math_fround(.200000003)) >>> 0;
 HEAP8[i46 + 92 >> 0] = 0;
 i12 = i46 + 105 | 0;
 HEAP8[i12 >> 0] = 0;
 i19 = i46 + 104 | 0;
 HEAP8[i19 >> 0] = i3 & 1;
 i22 = i46 + 100 | 0;
 HEAP32[i22 >> 2] = i31;
 d8 = +_emscripten_get_now() * 1.0e6;
 i13 = ~~d8 >>> 0;
 i14 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 __ZL18FindAllLiveObjectsR21GarbageCollectorState(i46);
 i1 = HEAP32[i27 >> 2] | 0;
 i11 = HEAP32[i46 >> 2] | 0;
 i35 = i46 + 20 | 0;
 i2 = HEAP32[i38 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i38 >> 2] = i1;
  HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i1 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i26 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
  HEAP32[i38 >> 2] = i1;
  HEAP32[i35 >> 2] = i26;
  break;
 } while (0);
 L14 : do if ((i1 | 0) > 0) {
  i10 = 0;
  do {
   i6 = i11 + (i10 << 3) | 0;
   i9 = i11 + (i10 << 3) + 4 | 0;
   L18 : while (1) {
    i5 = HEAP32[i9 >> 2] | 0;
    i4 = i5 & 536870911;
    L20 : do if (!(i5 & 1073741824)) {
     switch (i5 & 536870911 | 0) {
     case 114:
      {
       i28 = 19;
       break L18;
      }
     case 4:
     case 1:
      break L20;
     default:
      {}
     }
     i2 = HEAP32[gb + 1110260 >> 2] | 0;
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     if (i4 >>> 0 > 99999) i2 = (HEAP32[i2 + 24 >> 2] | 0) + (i4 + -1e5 << 3) | 0; else i2 = i3 + (i4 << 3) | 0;
     if (((HEAP32[i2 >> 2] | 0) - (HEAP32[i3 + 16 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 20 >> 2] | 0) >>> 0) {
      i28 = 27;
      break L18;
     } else i28 = 24;
    } else i28 = 24; while (0);
    if ((i28 | 0) == 24) {
     i28 = 0;
     if ((i4 | 0) != 142) {
      i28 = 25;
      break;
     }
    }
    i1 = i1 + -1 | 0;
    i24 = i11 + (i1 << 3) | 0;
    i25 = HEAP32[i24 + 4 >> 2] | 0;
    i26 = i6;
    HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i26 + 4 >> 2] = i25;
    if ((i10 | 0) >= (i1 | 0)) break L14;
   }
   if ((i28 | 0) == 19) if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0)) i28 = 25; else i28 = 27;
   if ((i28 | 0) == 25) {
    i28 = 0;
    if (i5 >> 31 & 2 | 0) i28 = 27;
   }
   if ((i28 | 0) == 27) {
    i28 = 0;
    i25 = (HEAP32[i46 >> 2] | 0) + (i10 << 3) + 4 | 0;
    i26 = HEAP32[i25 >> 2] | 0;
    HEAP32[i25 >> 2] = i26 | 536870912;
    i26 = i26 & 536870911;
    if ((i26 | 0) != 78 & (((i26 | 0) == 43 | ((i26 | 0) == 142 | ((i26 | 0) == 84 | ((i26 | 0) == 158 | ((i26 | 0) == 171 | ((i26 | 0) == 89 | ((i26 + -187 | 0) >>> 0 < 2 | ((i26 | 0) == 117 | ((i26 + -27 | 0) >>> 0 < 2 | ((i26 | 0) == 150 | ((i26 | 0) == 147 | ((i26 | 0) == 115 | (i26 | 0) == 149)))))))))))) ^ 1) & 1 | HEAPU8[i12 >> 0] | 0) {
     i3 = HEAP32[i18 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i38 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i38 >> 2] = i2;
       HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i26 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
       HEAP32[i38 >> 2] = i2;
       HEAP32[i35 >> 2] = i26;
       break;
      }
     } while (0);
     HEAP32[i18 >> 2] = i4;
     HEAP32[(HEAP32[i35 >> 2] | 0) + (i3 << 2) >> 2] = i10;
    }
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) < (i1 | 0));
 } while (0);
 HEAP32[i27 >> 2] = i1;
 i2 = HEAP32[i36 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i36 >> 2] = i1;
  HEAP32[i46 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i46 >> 2] | 0, i1 << 3, 4, i37, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i37, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i26 | 0, HEAP32[i46 >> 2] | 0, HEAP32[i27 >> 2] << 3 | 0) | 0;
  HEAP32[i36 >> 2] = i1;
  HEAP32[i46 >> 2] = i26;
  break;
 } while (0);
 d7 = +_emscripten_get_now() * 1.0e6;
 i2 = ~~d7 >>> 0;
 i3 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 d7 = +_emscripten_get_now() * 1.0e6;
 __ZL44CreateObjectToIndexMappingFromNonRootObjectsR21GarbageCollectorState(i46);
 d8 = +_emscripten_get_now() * 1.0e6;
 i4 = ~~d8 >>> 0;
 i5 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 d8 = +_emscripten_get_now() * 1.0e6;
 i1 = 0;
 do {
  if (__Z24GetManagerPtrFromContexti(i1) | 0) __Z20MarkInstanceIDAsRootiR21GarbageCollectorState(HEAP32[(__Z24GetManagerPtrFromContexti(i1) | 0) + 4 >> 2] | 0, i46);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i25 = _i64Subtract(i2 | 0, i3 | 0, i13 | 0, i14 | 0) | 0;
 i26 = getTempRet0() | 0;
 i23 = _i64Subtract(i4 | 0, i5 | 0, ~~d7 >>> 0 | 0, (+Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0) | 0;
 i24 = getTempRet0() | 0;
 i17 = ~~d8 >>> 0;
 i16 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i32;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i29 >> 2] = 0;
 i2 = i29 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i29 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i29 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, i32);
 i15 = i44;
 i20 = HEAP32[i15 + 4 >> 2] | 0;
 i21 = i4;
 HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 __ZN18AssetBundleManager55CollectPreloadObjectsFromAssetBundleLoadAssetOperationsER13dynamic_arrayIiLj4EE(__Z21GetAssetBundleManagerv() | 0, i29);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __Z20MarkInstanceIDAsRootiR21GarbageCollectorState(HEAP32[(HEAP32[i29 >> 2] | 0) + (i1 << 2) >> 2] | 0, i46);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i4);
  HEAP32[i29 >> 2] = 0;
 }
 if ((HEAP16[gb + 1162756 + 6 >> 1] | 0) > -1) {
  HEAP32[i32 >> 2] = 0;
  HEAP32[i44 >> 2] = HEAP32[i32 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162756 | 0, i44);
  i12 = gb + 1162756 | 0;
 } else i12 = 0;
 i5 = i32 + 4 | 0;
 HEAP32[i5 >> 2] = i46;
 i6 = i32 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i32 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 i13 = i32 + 24 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i32 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, gb + 63664 | 0);
 i1 = i44;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = i14;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb(i32 + 36 | 0, 33562624, 0);
 i10 = i32 + 80 | 0;
 HEAP32[i10 >> 2] = gb + 64712 + 8;
 HEAP32[i32 + 84 >> 2] = i32;
 HEAP32[i32 + 52 >> 2] = i10;
 i10 = i32 + 28 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i32 + 32 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0;
 i15 = i32 + 8 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i15 >> 2] = i21;
  break;
 } while (0);
 if (HEAP8[(HEAP32[i5 >> 2] | 0) + 104 >> 0] | 0) {
  i21 = __Z19GetScriptingManagerv() | 0;
  HEAP32[i32 >> 2] = __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_(HEAP32[(HEAP32[i21 + 168 >> 2] | 0) + (HEAP32[gb + 28304 + 24 >> 2] << 2) >> 2] | 0, i1, fb + 533 | 0, i32, fb + 73 | 0, fb + 74 | 0) | 0;
 }
 HEAP32[i46 + 40 >> 2] = HEAP32[i18 >> 2];
 if (HEAP8[i19 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6172 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 5404 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 5404 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i4 >> 2] | 0, i32 | 0); else mftCall_vii(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 5404 + (i1 * 12 | 0) + 4 >> 2] | 0, i32 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (HEAP8[(HEAP32[i5 >> 2] | 0) + 104 >> 0] | 0) __Z43scripting_liveness_calculation_from_staticsPv(HEAP32[i32 >> 2] | 0);
 d7 = +_emscripten_get_now();
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 40 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i3 = i3 + 20 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) > -1) {
   __Z16MarkDependenciesR27GarbageCollectorThreadStatej(i32, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) i28 = 64;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break; else i28 = 64;
  }
  if ((i28 | 0) == 64) while (1) {
   i28 = 0;
   i20 = i1 + -1 | 0;
   i21 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i20 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i20;
   __Z16MarkDependenciesR27GarbageCollectorThreadStatej(i32, i21);
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break; else i28 = 64;
  }
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 }
 d8 = d7 * 1.0e6;
 i21 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 d7 = +_emscripten_get_now() * 1.0e6;
 i21 = _i64Subtract(~~d7 >>> 0 | 0, (+Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, ~~d8 >>> 0 | 0, i21 | 0) | 0;
 i21 = __Z17TimeToNanosecondsy(i21, getTempRet0() | 0) | 0;
 f48 = Math_fround((+(i21 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09);
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f48);
 if (HEAP8[i19 >> 0] | 0) __Z16GetMemoryManagerv() | 0;
 if (HEAP8[(HEAP32[i5 >> 2] | 0) + 104 >> 0] | 0) __Z34scripting_liveness_calculation_endPv(HEAP32[i32 >> 2] | 0);
 i1 = HEAP32[i32 + 56 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i32 + 60 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i21 = HEAP32[i32 + 68 >> 2] | 0;
  HEAP32[i44 >> 2] = 1;
  HEAP32[i44 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i44);
 }
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
  HEAP32[i15 >> 2] = 0;
 }
 if (i12 | 0) __Z12profiler_endP19ProfilerInformation(i12);
 d8 = +_emscripten_get_now() * 1.0e6;
 i20 = _i64Subtract(~~d8 >>> 0 | 0, (+Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i17 | 0, i16 | 0) | 0;
 i21 = getTempRet0() | 0;
 i19 = HEAP32[gb + 1104264 >> 2] | 0;
 if ((HEAP32[i22 >> 2] | 0) != ((HEAP32[i19 + 36 >> 2] | 0) - (HEAP32[i19 + 4 >> 2] | 0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 451464 | 0, 0, gb + 451565 | 0, 275, 1, 0, 0, 0);
 d8 = +_emscripten_get_now() * 1.0e6;
 i13 = ~~d8 >>> 0;
 i14 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 if ((HEAP16[gb + 1162804 + 6 >> 1] | 0) > -1) {
  HEAP32[i32 >> 2] = 0;
  HEAP32[i44 >> 2] = HEAP32[i32 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162804 | 0, i44);
  i12 = gb + 1162804 | 0;
 } else i12 = 0;
 HEAP32[i29 >> 2] = 0;
 i15 = i29 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i29 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i29 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, gb + 63664 | 0);
 i19 = i44;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i11 = i17;
 HEAP32[i11 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i11 + 4 >> 2] = i18;
 HEAP32[i30 >> 2] = 0;
 i11 = i30 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i18 = i30 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i30 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, gb + 63664 | 0);
 i22 = i44;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i16 >> 2] = i1;
  HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i1 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i29 >> 2] = i22;
  break;
 } while (0);
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i18 >> 2] = i1;
   HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i22 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i30 >> 2] = i22;
  }
  i1 = HEAP32[i27 >> 2] | 0;
 }
 if (i1 | 0) {
  i10 = 0;
  do {
   i1 = HEAP32[i46 >> 2] | 0;
   i6 = i1 + (i10 << 3) + 4 | 0;
   do if (!(HEAP32[i6 >> 2] & 536870912)) {
    i9 = HEAP32[(HEAP32[i1 + (i10 << 3) >> 2] | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i15 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 >= i1 >>> 0) break;
     if ((i4 | 0) > -1) {
      HEAP32[i16 >> 2] = i1;
      HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i1 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i22 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP32[i29 >> 2] = i22;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i3;
    HEAP32[(HEAP32[i29 >> 2] | 0) + (i2 << 2) >> 2] = i9;
    if ((HEAP32[i6 >> 2] & 536870911 | 0) != 114) break;
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 >= i1 >>> 0) break;
     if ((i4 | 0) > -1) {
      HEAP32[i18 >> 2] = i1;
      HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i22 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i18 >> 2] = i1;
      HEAP32[i30 >> 2] = i22;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i3;
    HEAP32[(HEAP32[i30 >> 2] | 0) + (i2 << 2) >> 2] = i9;
   } while (0);
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i27 >> 2] | 0) >>> 0);
 }
 i9 = HEAP32[i30 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 if ((HEAP16[gb + 1162816 + 6 >> 1] | 0) > -1) {
  HEAP32[i32 >> 2] = 0;
  HEAP32[i44 >> 2] = HEAP32[i32 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162816 | 0, i44);
  i5 = gb + 1162816 | 0;
 } else i5 = 0;
 if ((i6 | 0) > 0) {
  i4 = 0;
  do {
   HEAP32[i32 >> 2] = HEAP32[i9 + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   do if (!i1) i28 = 104; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i1, i32);
     i2 = HEAP32[i44 >> 2] | 0;
     i27 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
     i28 = 104;
     break;
    }
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break;
    __ZN13MonoBehaviour26WillUnloadScriptableObjectEv(i1) | 0;
   } while (0);
   if ((i28 | 0) == 104) i28 = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
 }
 if (i5 | 0) __Z12profiler_endP19ProfilerInformation(i5);
 __Z25BatchDeleteObjectInternalPKii(HEAP32[i29 >> 2] | 0, HEAP32[i15 >> 2] | 0);
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i19);
  HEAP32[i30 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i17);
  HEAP32[i29 >> 2] = 0;
 }
 if (i12 | 0) __Z12profiler_endP19ProfilerInformation(i12);
 d8 = +_emscripten_get_now() * 1.0e6;
 i5 = _i64Subtract(~~d8 >>> 0 | 0, (+Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i13 | 0, i14 | 0) | 0;
 i6 = getTempRet0() | 0;
 i4 = HEAP32[gb + 1104264 >> 2] | 0;
 i4 = i31 - (HEAP32[i4 + 36 >> 2] | 0) + (HEAP32[i4 + 4 >> 2] | 0) | 0;
 d8 = +_emscripten_get_now() * 1.0e6;
 i2 = _i64Subtract(~~d8 >>> 0 | 0, (+Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i33 | 0, i34 | 0) | 0;
 i3 = getTempRet0() | 0;
 __Z11FormatBytesx(i41, __Z15GetUsedHeapSizev() | 0, 0);
 i1 = HEAP32[i41 >> 2] | 0;
 HEAP32[i40 >> 2] = (i1 | 0) == 0 ? i41 + 4 | 0 : i1;
 _printf_console(gb + 451649 | 0, i40);
 i1 = HEAP32[i41 >> 2] | 0;
 do if (i1 | 0) {
  if (!(HEAP32[i41 + 4 >> 2] | 0)) break;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i41 + 24 | 0);
 } while (0);
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 i1 = (HEAP32[i1 + 36 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i42 >> 2] = i4;
 HEAP32[i42 + 4 >> 2] = i1;
 _printf_console(gb + 451682 | 0, i42);
 i1 = __Z17TimeToNanosecondsy(i2, i3) | 0;
 d51 = +Math_fround(Math_fround((+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 i1 = __Z17TimeToNanosecondsy(i25, i26) | 0;
 d50 = +Math_fround(Math_fround((+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 i1 = __Z17TimeToNanosecondsy(i23, i24) | 0;
 d49 = +Math_fround(Math_fround((+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 i1 = __Z17TimeToNanosecondsy(i20, i21) | 0;
 d7 = +Math_fround(Math_fround((+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 i1 = __Z17TimeToNanosecondsy(i5, i6) | 0;
 d8 = +Math_fround(Math_fround((+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 HEAPF64[i43 >> 3] = d51;
 HEAPF64[i43 + 8 >> 3] = d50;
 HEAPF64[i43 + 16 >> 3] = d49;
 HEAPF64[i43 + 24 >> 3] = d7;
 HEAPF64[i43 + 32 >> 3] = d8;
 _printf_console(gb + 451759 | 0, i43);
 i1 = HEAP32[i46 + 72 >> 2] | 0;
 if (i1 | 0) {
  i43 = HEAP32[i46 + 96 >> 2] | 0;
  HEAP32[i44 >> 2] = 1;
  HEAP32[i44 + 4 >> 2] = i43;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i44);
 }
 if ((HEAP32[i38 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i39);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i46 >> 2] | 0, i37);
  HEAP32[i46 >> 2] = 0;
 }
 if (!i45) {
  STACKTOP = i47;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i45);
 STACKTOP = i47;
 return;
}

function _load_truetype_glyph(i42, i22, i17, i4) {
 i42 = i42 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i44 + 40 | 0;
 i39 = i44 + 32 | 0;
 i43 = i44 + 28 | 0;
 i19 = i44;
 i20 = i44 + 8 | 0;
 HEAP32[i43 >> 2] = 0;
 i23 = HEAP32[i42 >> 2] | 0;
 i33 = i42 + 12 | 0;
 i18 = HEAP32[i33 >> 2] | 0;
 if (i17 >>> 0 > 1) if ((HEAPU16[i23 + 290 >> 1] | 0) >>> 0 < i17 >>> 0) HEAP32[i43 >> 2] = 21; else i38 = 4; else i38 = 4;
 L4 : do if ((i38 | 0) == 4) {
  if ((HEAP32[i23 + 16 >> 2] | 0) >>> 0 <= i22 >>> 0) {
   HEAP32[i43 >> 2] = 16;
   break;
  }
  i13 = i42 + 20 | 0;
  HEAP32[i13 >> 2] = i22;
  i41 = i42 + 16 | 0;
  if (!(HEAP32[i41 >> 2] & 1)) {
   i25 = HEAP32[i42 + 4 >> 2] | 0;
   i24 = HEAP32[i25 + 48 >> 2] | 0;
   i25 = HEAP32[i25 + 52 >> 2] | 0;
  } else {
   i24 = 65536;
   i25 = 65536;
  }
  i30 = i42 + 28 | 0;
  i2 = _UNITY_tt_face_get_location(i23, i22, i30) | 0;
  i1 = HEAP32[i30 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i3 = HEAP32[i42 + 84 >> 2] | 0;
   if (!i3) {
    HEAP32[i43 >> 2] = 8;
    break;
   }
   i37 = mftCall_iiiii(HEAP32[i23 + 512 >> 2] | 0, i42 | 0, i22 | 0, i3 + i2 | 0, i1 | 0) | 0;
   HEAP32[i43 >> 2] = i37;
   if (i37 | 0) break;
   i37 = mftCall_ii(HEAP32[i23 + 520 >> 2] | 0, i42 | 0) | 0;
   HEAP32[i43 >> 2] = i37;
   if (!i37) {
    i37 = _tt_get_metrics(i42, i22) | 0;
    HEAP32[i43 >> 2] = i37;
    if (!(i4 << 24 >> 24 != 0 | (i37 | 0) != 0)) {
     i21 = 1;
     i1 = HEAP32[i30 >> 2] | 0;
     i38 = 15;
    }
   }
  } else {
   i21 = 0;
   i38 = 15;
  }
  if ((i38 | 0) == 15) {
   do if (!i1) i38 = 17; else {
    i1 = HEAP16[i42 + 32 >> 1] | 0;
    if (!(i1 << 16 >> 16)) i38 = 17; else {
     i14 = (HEAP32[i42 + 36 >> 2] | 0) - (HEAP32[i42 + 52 >> 2] | 0) | 0;
     i34 = i42 + 68 | 0;
     HEAP32[i34 >> 2] = i14;
     i12 = i42 + 72 | 0;
     HEAP32[i12 >> 2] = 0;
     i35 = i42 + 76 | 0;
     HEAP32[i35 >> 2] = (HEAP32[i42 + 56 >> 2] | 0) + i14;
     i14 = i42 + 80 | 0;
     HEAP32[i14 >> 2] = 0;
     i36 = i42 + 184 | 0;
     HEAP32[i36 >> 2] = 0;
     i32 = (HEAP32[i42 + 176 >> 2] | 0) + (HEAP32[i42 + 48 >> 2] | 0) | 0;
     i15 = i42 + 188 | 0;
     HEAP32[i15 >> 2] = i32;
     i37 = i42 + 192 | 0;
     HEAP32[i37 >> 2] = 0;
     i16 = i42 + 196 | 0;
     HEAP32[i16 >> 2] = i32 - (HEAP32[i42 + 180 >> 2] | 0);
     if (i1 << 16 >> 16 > 0) {
      i40 = mftCall_ii(HEAP32[i23 + 524 >> 2] | 0, i42 | 0) | 0;
      HEAP32[i43 >> 2] = i40;
      if (i40 | 0) break;
      mftCall_vi(HEAP32[i23 + 516 >> 2] | 0, i42 | 0);
      i2 = HEAP32[i33 >> 2] | 0;
      i3 = i2 + 56 | 0;
      i4 = i2 + 58 | 0;
      i7 = HEAP16[i4 >> 1] | 0;
      i8 = i7 << 16 >> 16;
      i9 = i2 + 60 | 0;
      i6 = i34;
      i1 = HEAP32[i6 + 4 >> 2] | 0;
      i10 = (HEAP32[i9 >> 2] | 0) + (i8 << 3) | 0;
      HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i10 + 4 >> 2] = i1;
      i10 = i8 + 1 | 0;
      i1 = i35;
      i6 = HEAP32[i1 + 4 >> 2] | 0;
      i11 = (HEAP32[i9 >> 2] | 0) + (i10 << 3) | 0;
      HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i11 + 4 >> 2] = i6;
      i11 = i8 + 2 | 0;
      i6 = i36;
      i1 = HEAP32[i6 + 4 >> 2] | 0;
      i12 = (HEAP32[i9 >> 2] | 0) + (i11 << 3) | 0;
      HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i12 + 4 >> 2] = i1;
      i12 = i8 + 3 | 0;
      i1 = i37;
      i6 = HEAP32[i1 + 4 >> 2] | 0;
      i5 = (HEAP32[i9 >> 2] | 0) + (i12 << 3) | 0;
      HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i5 + 4 >> 2] = i6;
      i5 = i2 + 64 | 0;
      HEAP8[(HEAP32[i5 >> 2] | 0) + i8 >> 0] = 0;
      HEAP8[(HEAP32[i5 >> 2] | 0) + i10 >> 0] = 0;
      HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = 0;
      HEAP8[(HEAP32[i5 >> 2] | 0) + i12 >> 0] = 0;
      i6 = i8 + 4 | 0;
      i1 = HEAP32[i42 >> 2] | 0;
      if (HEAP8[i1 + 672 >> 0] | 0) {
       i1 = _UNITY_TT_Vary_Apply_Glyph_Deltas(i1, HEAP32[i13 >> 2] | 0, i3, i6) | 0;
       if (i1 | 0) {
        HEAP32[i43 >> 2] = i1;
        break L4;
       }
      }
      i1 = HEAP32[i41 >> 2] | 0;
      if (!(i1 & 2)) {
       i1 = HEAP16[i4 >> 1] | 0;
       HEAP16[i42 + 132 >> 1] = i1;
       HEAP16[i42 + 134 >> 1] = HEAP16[i3 >> 1] | 0;
       HEAP32[i42 + 136 >> 2] = HEAP32[i2 + 76 >> 2];
       i40 = HEAP32[i9 >> 2] | 0;
       HEAP32[i42 + 140 >> 2] = i40;
       i39 = HEAP32[i2 + 80 >> 2] | 0;
       HEAP32[i42 + 144 >> 2] = i39;
       HEAP32[i42 + 148 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i42 + 152 >> 2] = HEAP32[i2 + 68 >> 2];
       HEAP16[i42 + 156 >> 1] = 0;
       _memcpy(i39 | 0, i40 | 0, ((i1 & 65535) << 3) + 32 | 0) | 0;
       i1 = HEAP32[i41 >> 2] | 0;
      }
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = i2 + (i6 << 3) | 0;
      if (!(i1 & 1)) {
       i5 = HEAP32[i42 + 4 >> 2] | 0;
       i4 = HEAP32[i5 + 48 >> 2] | 0;
       i5 = HEAP32[i5 + 52 >> 2] | 0;
       if (i7 << 16 >> 16 > -4) {
        do {
         HEAP32[i2 >> 2] = _UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i4) | 0;
         i40 = i2 + 4 | 0;
         HEAP32[i40 >> 2] = _UNITY_FT_MulFix(HEAP32[i40 >> 2] | 0, i5) | 0;
         i2 = i2 + 8 | 0;
        } while (i2 >>> 0 < i3 >>> 0);
        i1 = HEAP32[i41 >> 2] | 0;
        i2 = HEAP32[i9 >> 2] | 0;
       }
       i41 = i2 + (i8 << 3) | 0;
       i40 = HEAP32[i41 + 4 >> 2] | 0;
       i39 = i34;
       HEAP32[i39 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i39 + 4 >> 2] = i40;
       i39 = (HEAP32[i9 >> 2] | 0) + (i10 << 3) | 0;
       i40 = HEAP32[i39 + 4 >> 2] | 0;
       i41 = i35;
       HEAP32[i41 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i41 + 4 >> 2] = i40;
       i41 = (HEAP32[i9 >> 2] | 0) + (i11 << 3) | 0;
       i40 = HEAP32[i41 + 4 >> 2] | 0;
       i39 = i36;
       HEAP32[i39 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i39 + 4 >> 2] = i40;
       i39 = (HEAP32[i9 >> 2] | 0) + (i12 << 3) | 0;
       i40 = HEAP32[i39 + 4 >> 2] | 0;
       i41 = i37;
       HEAP32[i41 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i41 + 4 >> 2] = i40;
      }
      if (!(i1 & 2)) {
       i41 = i42 + 132 | 0;
       HEAP16[i41 >> 1] = (HEAPU16[i41 >> 1] | 0) + 4;
       i42 = _TT_Hint_Glyph(i42, 0) | 0;
       HEAP32[i43 >> 2] = i42;
       if (i42 | 0) break L4;
      } else HEAP32[i43 >> 2] = 0;
      _UNITY_FT_GlyphLoader_Add(i18);
      break L4;
     }
     if (i1 << 16 >> 16 != -1) {
      HEAP32[i43 >> 2] = 20;
      break;
     }
     i26 = i18 + 22 | 0;
     i31 = HEAP16[i26 >> 1] | 0;
     i29 = i31 << 16 >> 16;
     i32 = HEAP16[i18 + 20 >> 1] | 0;
     i28 = mftCall_ii(HEAP32[i23 + 528 >> 2] | 0, i42 | 0) | 0;
     HEAP32[i43 >> 2] = i28;
     if (!i28) {
      i28 = i42 + 168 | 0;
      i27 = HEAP32[i28 >> 2] | 0;
      mftCall_vi(HEAP32[i23 + 516 >> 2] | 0, i42 | 0);
      if (HEAP8[i23 + 672 >> 0] | 0) {
       i10 = HEAP32[i23 + 100 >> 2] | 0;
       i1 = HEAP32[i18 + 84 >> 2] | 0;
       i11 = i1 + 4 | 0;
       i21 = i11 & 65535;
       i4 = i40 + 2 | 0;
       HEAP16[i4 >> 1] = i21;
       HEAP16[i40 >> 1] = i21;
       i11 = _UNITY_ft_mem_realloc(i10, 8, 0, i11 << 16 >> 16, 0, i43) | 0;
       if (!(HEAP32[i43 >> 2] | 0)) {
        i5 = _UNITY_ft_mem_realloc(i10, 1, 0, HEAP16[i4 >> 1] | 0, 0, i43) | 0;
        if (!(HEAP32[i43 >> 2] | 0)) {
         i6 = _UNITY_ft_mem_realloc(i10, 2, 0, HEAP16[i4 >> 1] | 0, 0, i43) | 0;
         if (!(HEAP32[i43 >> 2] | 0)) {
          i8 = i18 + 88 | 0;
          i7 = i1 << 16;
          i9 = i7 >> 16;
          i7 = (i7 | 0) > 0;
          if (i7) {
           i2 = 0;
           i3 = HEAP32[i8 >> 2] | 0;
           i1 = 0;
           while (1) {
            HEAP32[i11 + (i1 << 3) >> 2] = HEAP32[i3 + 8 >> 2];
            HEAP32[i11 + (i1 << 3) + 4 >> 2] = HEAP32[i3 + 12 >> 2];
            HEAP8[i5 + i1 >> 0] = 1;
            HEAP16[i6 + (i1 << 1) >> 1] = i2;
            i2 = i2 + 1 << 16 >> 16;
            i1 = i2 << 16 >> 16;
            if ((i1 | 0) < (i9 | 0)) i3 = i3 + 32 | 0; else break;
           }
          } else {
           i2 = 0;
           i1 = 0;
          }
          HEAP32[i11 + (i1 << 3) >> 2] = HEAP32[i34 >> 2];
          HEAP32[i11 + (i1 << 3) + 4 >> 2] = HEAP32[i12 >> 2];
          HEAP8[i5 + i1 >> 0] = 1;
          HEAP16[i6 + (i1 << 1) >> 1] = i2;
          i20 = i2 + 1 << 16 >> 16;
          i21 = i20 << 16 >> 16;
          HEAP32[i11 + (i21 << 3) >> 2] = HEAP32[i35 >> 2];
          HEAP32[i11 + (i21 << 3) + 4 >> 2] = HEAP32[i14 >> 2];
          HEAP8[i5 + i21 >> 0] = 1;
          HEAP16[i6 + (i21 << 1) >> 1] = i20;
          i21 = i2 + 2 << 16 >> 16;
          i20 = i21 << 16 >> 16;
          HEAP32[i11 + (i20 << 3) >> 2] = HEAP32[i36 >> 2];
          HEAP32[i11 + (i20 << 3) + 4 >> 2] = HEAP32[i15 >> 2];
          HEAP8[i5 + i20 >> 0] = 1;
          HEAP16[i6 + (i20 << 1) >> 1] = i21;
          i20 = i2 + 3 << 16 >> 16;
          i21 = i20 << 16 >> 16;
          HEAP32[i11 + (i21 << 3) >> 2] = HEAP32[i37 >> 2];
          HEAP32[i11 + (i21 << 3) + 4 >> 2] = HEAP32[i16 >> 2];
          HEAP8[i5 + i21 >> 0] = 1;
          HEAP16[i6 + (i21 << 1) >> 1] = i20;
          HEAP32[i40 + 4 >> 2] = i11;
          HEAP32[i40 + 8 >> 2] = i5;
          HEAP32[i40 + 12 >> 2] = i6;
          i23 = _UNITY_TT_Vary_Apply_Glyph_Deltas(i23, i22, i40, HEAP16[i4 >> 1] | 0) | 0;
          HEAP32[i43 >> 2] = i23;
          if (!i23) {
           i2 = HEAP32[i11 >> 2] | 0;
           if (i7) {
            i4 = 0;
            i3 = HEAP32[i8 >> 2] | 0;
            i1 = 0;
            while (1) {
             HEAP32[i3 + 8 >> 2] = i2 << 16 >> 16;
             HEAP32[i3 + 12 >> 2] = HEAP32[i11 + (i1 << 3) + 4 >> 2] << 16 >> 16;
             i4 = i4 + 1 << 16 >> 16;
             i1 = i4 << 16 >> 16;
             i2 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
             if ((i1 | 0) >= (i9 | 0)) break; else i3 = i3 + 32 | 0;
            }
           } else i1 = 0;
           HEAP32[i34 >> 2] = i2;
           HEAP32[i12 >> 2] = HEAP32[i11 + (i1 << 3) + 4 >> 2];
           i23 = i1 + 1 | 0;
           HEAP32[i35 >> 2] = HEAP32[i11 + (i23 << 3) >> 2];
           HEAP32[i14 >> 2] = HEAP32[i11 + (i23 << 3) + 4 >> 2];
           i23 = i1 + 2 | 0;
           HEAP32[i36 >> 2] = HEAP32[i11 + (i23 << 3) >> 2];
           HEAP32[i15 >> 2] = HEAP32[i11 + (i23 << 3) + 4 >> 2];
           i23 = i1 + 3 | 0;
           HEAP32[i37 >> 2] = HEAP32[i11 + (i23 << 3) >> 2];
           HEAP32[i16 >> 2] = HEAP32[i11 + (i23 << 3) + 4 >> 2];
          }
         }
        }
       }
       i23 = i40 + 4 | 0;
       _UNITY_ft_mem_free(i10, HEAP32[i23 >> 2] | 0);
       HEAP32[i23 >> 2] = 0;
       i23 = i40 + 8 | 0;
       _UNITY_ft_mem_free(i10, HEAP32[i23 >> 2] | 0);
       HEAP32[i23 >> 2] = 0;
       _UNITY_ft_mem_free(i10, HEAP32[i40 + 12 >> 2] | 0);
       if (HEAP32[i43 >> 2] | 0) break L4;
      }
      i1 = HEAP32[i41 >> 2] | 0;
      if (!(i1 & 1)) {
       HEAP32[i34 >> 2] = _UNITY_FT_MulFix(HEAP32[i34 >> 2] | 0, i24) | 0;
       HEAP32[i35 >> 2] = _UNITY_FT_MulFix(HEAP32[i35 >> 2] | 0, i24) | 0;
       HEAP32[i36 >> 2] = _UNITY_FT_MulFix(HEAP32[i36 >> 2] | 0, i24) | 0;
       HEAP32[i15 >> 2] = _UNITY_FT_MulFix(HEAP32[i15 >> 2] | 0, i25) | 0;
       HEAP32[i37 >> 2] = _UNITY_FT_MulFix(HEAP32[i37 >> 2] | 0, i24) | 0;
       HEAP32[i16 >> 2] = _UNITY_FT_MulFix(HEAP32[i16 >> 2] | 0, i25) | 0;
       i1 = HEAP32[i41 >> 2] | 0;
      }
      if (i1 & 1024 | 0) {
       _UNITY_FT_GlyphLoader_Add(i18);
       HEAP32[(HEAP32[i42 + 8 >> 2] | 0) + 72 >> 2] = 1668246896;
       break L4;
      }
      i20 = HEAP32[i18 + 84 >> 2] | 0;
      i21 = HEAP32[i18 + 48 >> 2] | 0;
      i24 = i42 + 24 | 0;
      i22 = HEAP32[i24 >> 2] | 0;
      i23 = HEAP32[i30 >> 2] | 0;
      _UNITY_FT_GlyphLoader_Add(i18);
      L77 : do if (!i20) {
       i2 = i29;
       i1 = 0;
      } else {
       i19 = i18 + 52 | 0;
       i15 = i17 + 1 | 0;
       i16 = i40 + 4 | 0;
       i17 = i40 + 2 | 0;
       i18 = i42 + 4 | 0;
       i2 = i29;
       i14 = 0;
       L79 : while (1) {
        i1 = (HEAP32[i19 >> 2] | 0) + (i21 << 5) + (i14 << 5) | 0;
        i4 = i34;
        i3 = HEAP32[i4 >> 2] | 0;
        i4 = HEAP32[i4 + 4 >> 2] | 0;
        i6 = i35;
        i5 = HEAP32[i6 >> 2] | 0;
        i6 = HEAP32[i6 + 4 >> 2] | 0;
        i8 = i36;
        i7 = HEAP32[i8 >> 2] | 0;
        i8 = HEAP32[i8 + 4 >> 2] | 0;
        i10 = i37;
        i9 = HEAP32[i10 >> 2] | 0;
        i10 = HEAP32[i10 + 4 >> 2] | 0;
        i11 = HEAP16[i26 >> 1] | 0;
        i13 = i11 << 16 >> 16;
        i25 = _load_truetype_glyph(i42, HEAP32[i1 >> 2] | 0, i15, 0) | 0;
        HEAP32[i43 >> 2] = i25;
        do if (!i25) {
         i1 = (HEAP32[i19 >> 2] | 0) + (i21 << 5) + (i14 << 5) | 0;
         i12 = i1 + 4 | 0;
         if (!(HEAP16[i12 >> 1] & 512)) {
          i25 = i34;
          HEAP32[i25 >> 2] = i3;
          HEAP32[i25 + 4 >> 2] = i4;
          i25 = i35;
          HEAP32[i25 >> 2] = i5;
          HEAP32[i25 + 4 >> 2] = i6;
          i25 = i36;
          HEAP32[i25 >> 2] = i7;
          HEAP32[i25 + 4 >> 2] = i8;
          i25 = i37;
          HEAP32[i25 >> 2] = i9;
          HEAP32[i25 + 4 >> 2] = i10;
         }
         i25 = HEAP16[i26 >> 1] | 0;
         i2 = i25 << 16 >> 16;
         if (i25 << 16 >> 16 == i11 << 16 >> 16) {
          i3 = 24;
          break;
         }
         i8 = HEAP32[i33 >> 2] | 0;
         i7 = i8 + 24 | 0;
         HEAP32[i16 >> 2] = (HEAP32[i7 >> 2] | 0) + (i13 << 3);
         i8 = i8 + 22 | 0;
         HEAP16[i17 >> 1] = (HEAPU16[i8 >> 1] | 0) - i13;
         i3 = HEAP16[i12 >> 1] | 0;
         i6 = (i3 & 200) == 0;
         if (!i6) {
          _UNITY_FT_Outline_Transform(i40, i1 + 16 | 0);
          i3 = HEAP16[i12 >> 1] | 0;
         }
         i5 = i3 & 65535;
         i4 = HEAP32[i1 + 8 >> 2] | 0;
         i3 = HEAP32[i1 + 12 >> 2] | 0;
         do if (!(i5 & 2)) {
          i5 = i4 + i29 | 0;
          i3 = i3 + i13 | 0;
          if (i5 >>> 0 >= i13 >>> 0) {
           i3 = 21;
           break;
          }
          if (i3 >>> 0 >= (HEAP16[i8 >> 1] | 0) >>> 0) {
           i3 = 21;
           break;
          }
          i38 = HEAP32[i7 >> 2] | 0;
          i4 = (HEAP32[i38 + (i5 << 3) >> 2] | 0) - (HEAP32[i38 + (i3 << 3) >> 2] | 0) | 0;
          i3 = (HEAP32[i38 + (i5 << 3) + 4 >> 2] | 0) - (HEAP32[i38 + (i3 << 3) + 4 >> 2] | 0) | 0;
          i38 = 77;
         } else {
          if (!(i3 | i4)) {
           i3 = 0;
           break;
          }
          if (!(i6 | (i5 & 2048 | 0) == 0)) {
           i25 = _UNITY_FT_Hypot(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0) | 0;
           i38 = _UNITY_FT_Hypot(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0) | 0;
           i4 = _UNITY_FT_MulFix(i4, i25) | 0;
           i3 = _UNITY_FT_MulFix(i3, i38) | 0;
          }
          if (HEAP32[i41 >> 2] & 1 | 0) {
           i38 = 77;
           break;
          }
          i25 = HEAP32[i18 >> 2] | 0;
          i38 = HEAP32[i25 + 52 >> 2] | 0;
          i4 = _UNITY_FT_MulFix(i4, HEAP32[i25 + 48 >> 2] | 0) | 0;
          i3 = _UNITY_FT_MulFix(i3, i38) | 0;
          i38 = (HEAP16[i12 >> 1] & 4) == 0;
          i4 = i38 ? i4 : i4 + 32 & -64;
          i3 = i38 ? i3 : i3 + 32 & -64;
          i38 = 77;
         } while (0);
         do if ((i38 | 0) == 77) {
          i38 = 0;
          if (!(i4 | i3)) {
           i3 = 0;
           break;
          }
          _UNITY_FT_Outline_Translate(i40, i4, i3);
          i3 = 0;
         } while (0);
         HEAP32[i43 >> 2] = i3;
         i3 = (i3 | 0) == 0 ? 0 : 2;
        } else i3 = 2; while (0);
        switch (i3 & 31) {
        case 2:
         break L4;
        case 24:
        case 0:
         break;
        default:
         {
          i1 = 0;
          break L79;
         }
        }
        i14 = i14 + 1 | 0;
        if (i14 >>> 0 >= i20 >>> 0) break L77;
       }
       STACKTOP = i44;
       return i1 | 0;
      } while (0);
      HEAP32[i24 >> 2] = i22;
      HEAP32[i30 >> 2] = i23;
      HEAP32[i28 >> 2] = i27;
      if (HEAP32[i41 >> 2] & 2 | 0) break L4;
      if (!(i2 >>> 0 > i29 >>> 0 ? (HEAP16[i1 + 4 >> 1] & 256) != 0 : 0)) break L4;
      i4 = HEAP32[i33 >> 2] | 0;
      i5 = i4 + 22 | 0;
      i1 = HEAP16[i5 >> 1] | 0;
      i2 = i1 << 16 >> 16;
      i3 = i2 + 4 | 0;
      do if (!i3) i38 = 86; else {
       if ((i3 + i2 + (HEAP16[i4 + 58 >> 1] | 0) | 0) >>> 0 <= (HEAP32[i4 + 4 >> 2] | 0) >>> 0) {
        i38 = 86;
        break;
       }
       i1 = _UNITY_FT_GlyphLoader_CheckPoints(i4, i3, 0) | 0;
       HEAP32[i40 >> 2] = i1;
       if (!i1) {
        i1 = HEAP16[i5 >> 1] | 0;
        break;
       } else {
        HEAP32[i43 >> 2] = i1;
        break L4;
       }
      } while (0);
      if ((i38 | 0) == 86) HEAP32[i40 >> 2] = 0;
      i27 = i4 + 24 | 0;
      i26 = i34;
      i34 = HEAP32[i26 + 4 >> 2] | 0;
      i41 = (HEAP32[i27 >> 2] | 0) + (i1 << 16 >> 16 << 3) | 0;
      HEAP32[i41 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i41 + 4 >> 2] = i34;
      i41 = HEAP32[i35 + 4 >> 2] | 0;
      i1 = (HEAP32[i27 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 1 << 3) | 0;
      HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
      HEAP32[i1 + 4 >> 2] = i41;
      i1 = HEAP32[i36 + 4 >> 2] | 0;
      i41 = (HEAP32[i27 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 2 << 3) | 0;
      HEAP32[i41 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i41 + 4 >> 2] = i1;
      i41 = HEAP32[i37 + 4 >> 2] | 0;
      i1 = (HEAP32[i27 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 3 << 3) | 0;
      HEAP32[i1 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i1 + 4 >> 2] = i41;
      i1 = i4 + 28 | 0;
      HEAP8[(HEAP32[i1 >> 2] | 0) + (HEAP16[i5 >> 1] | 0) >> 0] = 0;
      HEAP8[(HEAP32[i1 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 1) >> 0] = 0;
      HEAP8[(HEAP32[i1 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 2) >> 0] = 0;
      HEAP8[(HEAP32[i1 >> 2] | 0) + ((HEAP16[i5 >> 1] | 0) + 3) >> 0] = 0;
      i5 = HEAP32[i24 >> 2] | 0;
      i1 = _UNITY_FT_Stream_Seek(i5, HEAP32[i28 >> 2] | 0) | 0;
      HEAP32[i40 >> 2] = i1;
      do if (!i1) {
       i2 = _UNITY_FT_Stream_ReadUShort(i5, i40) | 0;
       i1 = HEAP32[i40 >> 2] | 0;
       if (i1 | 0) {
        i38 = 98;
        break;
       }
       i4 = i2 & 65535;
       if ((i2 & 65535) > (HEAPU16[(HEAP32[i42 >> 2] | 0) + 286 >> 1] | 0)) {
        if ((i4 | 0) > (HEAP32[i30 >> 2] | 0)) {
         i1 = 22;
         i38 = 98;
         break;
        }
        i2 = i42 + 160 | 0;
        i1 = HEAP32[i2 >> 2] | 0;
        HEAP32[i39 >> 2] = HEAP32[i1 + 388 >> 2];
        i1 = _Update_Max(HEAP32[i1 + 8 >> 2] | 0, i39, 1, i1 + 392 | 0, i4) | 0;
        HEAP32[i40 >> 2] = i1;
        i3 = HEAP32[i2 >> 2] | 0;
        HEAP32[i3 + 388 >> 2] = HEAP32[i39 >> 2] & 65535;
        if (!i1) i1 = i3; else {
         i38 = 98;
         break;
        }
       } else {
        if (!(i2 << 16 >> 16)) {
         i1 = 0;
         i38 = 98;
         break;
        }
        i1 = i42 + 160 | 0;
        i2 = i1;
        i1 = HEAP32[i1 >> 2] | 0;
       }
       i1 = _UNITY_FT_Stream_Read(i5, HEAP32[i1 + 392 >> 2] | 0, i4) | 0;
       HEAP32[i40 >> 2] = i1;
       if (i1 | 0) {
        i38 = 98;
        break;
       }
       i40 = HEAP32[i42 + 8 >> 2] | 0;
       HEAP32[i40 + 136 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 392 >> 2];
       HEAP32[i40 + 140 >> 2] = i4;
       i40 = HEAP32[i33 >> 2] | 0;
       i2 = (HEAPU16[i40 + 22 >> 1] | 0) - i29 | 0;
       i41 = i2 & 65535;
       i4 = i42 + 132 | 0;
       HEAP16[i4 >> 1] = i41;
       HEAP16[i42 + 134 >> 1] = (HEAPU16[i40 + 20 >> 1] | 0) - i32;
       HEAP32[i42 + 136 >> 2] = (HEAP32[i40 + 40 >> 2] | 0) + (i29 << 3);
       HEAP32[i42 + 140 >> 2] = (HEAP32[i40 + 24 >> 2] | 0) + (i29 << 3);
       HEAP32[i42 + 144 >> 2] = (HEAP32[i40 + 44 >> 2] | 0) + (i29 << 3);
       i1 = (HEAP32[i40 + 28 >> 2] | 0) + i29 | 0;
       i3 = i42 + 148 | 0;
       HEAP32[i3 >> 2] = i1;
       HEAP32[i42 + 152 >> 2] = (HEAP32[i40 + 32 >> 2] | 0) + (i32 << 1);
       HEAP16[i42 + 156 >> 1] = i31;
       do if (!(i41 << 16 >> 16)) i1 = i2 & 65535; else {
        HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & 231;
        i1 = HEAP16[i4 >> 1] | 0;
        if ((i1 & 65535) > 1) i2 = 1; else {
         i1 = i1 & 65535;
         break;
        }
        do {
         i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
         HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & 231;
         i2 = i2 + 1 | 0;
         i1 = HEAPU16[i4 >> 1] | 0;
        } while (i2 >>> 0 < i1 >>> 0);
       } while (0);
       HEAP16[i4 >> 1] = i1 + 4;
       i1 = _TT_Hint_Glyph(i42, 1) | 0;
      } else i38 = 98; while (0);
      HEAP32[i43 >> 2] = i1;
      break L4;
     }
    }
   } while (0);
   L137 : do if ((i38 | 0) == 17) {
    i1 = i42 + 36 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    i38 = _tt_get_metrics(i42, i22) | 0;
    HEAP32[i43 >> 2] = i38;
    if (!(i4 << 24 >> 24 != 0 | (i38 | 0) != 0)) {
     i1 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i42 + 52 >> 2] | 0) | 0;
     i13 = i42 + 68 | 0;
     HEAP32[i13 >> 2] = i1;
     i9 = i42 + 72 | 0;
     HEAP32[i9 >> 2] = 0;
     i2 = (HEAP32[i42 + 56 >> 2] | 0) + i1 | 0;
     i14 = i42 + 76 | 0;
     HEAP32[i14 >> 2] = i2;
     i10 = i42 + 80 | 0;
     HEAP32[i10 >> 2] = 0;
     i15 = i42 + 184 | 0;
     HEAP32[i15 >> 2] = 0;
     i3 = (HEAP32[i42 + 176 >> 2] | 0) + (HEAP32[i42 + 48 >> 2] | 0) | 0;
     i16 = i42 + 188 | 0;
     HEAP32[i16 >> 2] = i3;
     i17 = i42 + 192 | 0;
     HEAP32[i17 >> 2] = 0;
     i11 = i3 - (HEAP32[i42 + 180 >> 2] | 0) | 0;
     i18 = i42 + 196 | 0;
     HEAP32[i18 >> 2] = i11;
     i12 = HEAP32[i42 >> 2] | 0;
     do if (HEAP8[i12 + 672 >> 0] | 0) {
      HEAP32[i39 >> 2] = 16843009;
      i7 = i19;
      HEAP32[i7 >> 2] = 65536;
      HEAP32[i7 + 4 >> 2] = 196610;
      HEAP32[i40 >> 2] = i1;
      i7 = i40 + 4 | 0;
      HEAP32[i7 >> 2] = 0;
      i8 = i40 + 8 | 0;
      HEAP32[i8 >> 2] = i2;
      i4 = i40 + 12 | 0;
      HEAP32[i4 >> 2] = 0;
      i5 = i40 + 16 | 0;
      HEAP32[i5 >> 2] = 0;
      i6 = i40 + 20 | 0;
      HEAP32[i6 >> 2] = i3;
      i1 = i40 + 24 | 0;
      HEAP32[i1 >> 2] = 0;
      i2 = i40 + 28 | 0;
      HEAP32[i2 >> 2] = i11;
      HEAP16[i20 + 2 >> 1] = 4;
      HEAP16[i20 >> 1] = 4;
      HEAP32[i20 + 4 >> 2] = i40;
      HEAP32[i20 + 8 >> 2] = i39;
      HEAP32[i20 + 12 >> 2] = i19;
      i39 = _UNITY_TT_Vary_Apply_Glyph_Deltas(i12, i22, i20, 4) | 0;
      HEAP32[i43 >> 2] = i39;
      if (!i39) {
       i40 = HEAP32[i40 >> 2] | 0;
       HEAP32[i13 >> 2] = i40;
       HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
       HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
       i1 = i40;
       break;
      } else break L137;
     } while (0);
     if (!(HEAP32[i41 >> 2] & 1)) {
      HEAP32[i13 >> 2] = _UNITY_FT_MulFix(i1, i24) | 0;
      HEAP32[i14 >> 2] = _UNITY_FT_MulFix(HEAP32[i14 >> 2] | 0, i24) | 0;
      HEAP32[i15 >> 2] = _UNITY_FT_MulFix(HEAP32[i15 >> 2] | 0, i24) | 0;
      HEAP32[i16 >> 2] = _UNITY_FT_MulFix(HEAP32[i16 >> 2] | 0, i25) | 0;
      HEAP32[i17 >> 2] = _UNITY_FT_MulFix(HEAP32[i17 >> 2] | 0, i24) | 0;
      HEAP32[i18 >> 2] = _UNITY_FT_MulFix(HEAP32[i18 >> 2] | 0, i25) | 0;
     }
     HEAP32[i43 >> 2] = 0;
    }
   } while (0);
   if (!(i21 << 24 >> 24)) break;
  }
  mftCall_vi(HEAP32[i23 + 516 >> 2] | 0, i42 | 0);
 } while (0);
 i43 = HEAP32[i43 >> 2] | 0;
 STACKTOP = i44;
 return i43 | 0;
}

function __ZN12TreeRenderer25CreateLODRenderersForTreeEi(i48, i34) {
 i48 = i48 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i49 + 16 | 0;
 i39 = i49;
 i36 = i49 + 232 | 0;
 i44 = i49 + 208 | 0;
 i31 = i49 + 144 | 0;
 i45 = i49 + 80 | 0;
 i46 = i49 + 244 | 0;
 i17 = HEAP32[i48 >> 2] | 0;
 i35 = HEAP32[i17 + 16 >> 2] | 0;
 i16 = i35 + (i34 * 40 | 0) + 32 | 0;
 i18 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i17 + 28 >> 2] | 0;
 i19 = HEAP32[i48 + 364 >> 2] | 0;
 i4 = i17 + (i18 * 156 | 0) + 8 | 0;
 HEAP32[i39 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i47 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i1, i39);
   i2 = HEAP32[i43 >> 2] | 0;
   i42 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i42 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i42 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i47 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i47 = 8; else i40 = i1;
  }
 }
 if ((i47 | 0) == 6) i47 = 8;
 if ((i47 | 0) == 8) i40 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i42 = i48 + 400 | 0;
 HEAP32[(HEAP32[i48 + 236 >> 2] | 0) + (i34 << 2) >> 2] = HEAP32[i48 + 412 >> 2];
 f51 = Math_fround(HEAPF32[i35 + (i34 * 40 | 0) >> 2]);
 f51 = Math_fround(f51 * Math_fround(HEAPF32[i48 + 120 >> 2]));
 f52 = Math_fround(HEAPF32[i35 + (i34 * 40 | 0) + 4 >> 2]);
 f52 = Math_fround(f52 * Math_fround(HEAPF32[i48 + 124 >> 2]));
 f53 = Math_fround(HEAPF32[i35 + (i34 * 40 | 0) + 8 >> 2]);
 f53 = Math_fround(f53 * Math_fround(HEAPF32[i48 + 128 >> 2]));
 f51 = Math_fround(f51 + Math_fround(HEAPF32[i48 + 136 >> 2]));
 f52 = Math_fround(f52 + Math_fround(HEAPF32[i48 + 140 >> 2]));
 f53 = Math_fround(f53 + Math_fround(HEAPF32[i48 + 144 >> 2]));
 HEAPF32[i36 >> 2] = f51;
 i14 = i36 + 4 | 0;
 HEAPF32[i14 >> 2] = f52;
 i15 = i36 + 8 | 0;
 HEAPF32[i15 >> 2] = f53;
 i32 = HEAP32[i16 >> 2] | 0;
 i33 = HEAP32[(HEAP32[i48 >> 2] | 0) + 28 >> 2] | 0;
 f53 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 20 >> 2]);
 f52 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 24 >> 2]);
 f51 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 28 >> 2]);
 f50 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 32 >> 2]);
 f9 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 36 >> 2]);
 f10 = Math_fround(HEAPF32[i33 + (i32 * 156 | 0) + 40 >> 2]);
 i32 = i35 + (i34 * 40 | 0) + 12 | 0;
 f11 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i35 + (i34 * 40 | 0) + 16 | 0;
 f12 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i44 >> 2] = Math_fround(f53 * f11);
 HEAPF32[i44 + 4 >> 2] = Math_fround(f52 * f12);
 HEAPF32[i44 + 8 >> 2] = Math_fround(f51 * f11);
 HEAPF32[i44 + 12 >> 2] = Math_fround(f50 * f11);
 HEAPF32[i44 + 16 >> 2] = Math_fround(f9 * f12);
 HEAPF32[i44 + 20 >> 2] = Math_fround(f10 * f11);
 i41 = f11 == Math_fround(0.0) | f12 == Math_fround(0.0);
 i38 = i17 + (i18 * 156 | 0) + 12 | 0;
 i1 = HEAP32[i38 >> 2] | 0;
 if (!i1) i8 = 0; else {
  HEAP32[i39 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i47 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i1, i39);
    i2 = HEAP32[i43 >> 2] | 0;
    i37 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i37 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i37 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i47 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i47 = 17;
   }
  }
  if ((i47 | 0) == 15) i47 = 17;
  if ((i47 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i38 >> 2] | 0) | 0;
  i8 = (i1 | 0) != 0;
 }
 i37 = i19 + (i18 * 44 | 0) + 40 | 0;
 i28 = i8 & (HEAP32[i37 >> 2] | 0) != 0;
 if (!(HEAP32[i19 + (i18 * 44 | 0) + 24 >> 2] | 0)) i13 = -1; else {
  i2 = i48 + 380 | 0;
  i3 = i48 + 392 | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  i4 = i13 + 1 | 0;
  i5 = i48 + 396 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 88 | 0, 4, i48 + 384 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 88 | 0, 4, i48 + 384 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i30 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 88 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = i30;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i4;
  i30 = HEAP32[i2 >> 2] | 0;
  HEAP16[i30 + (i13 * 88 | 0) >> 1] = 0;
  HEAP32[i30 + (i13 * 88 | 0) + 32 >> 2] = 0;
  __ZN18SpeedTreeWindTimesC2Ev(i30 + (i13 * 88 | 0) + 36 | 0);
  i1 = i30 + (i13 * 88 | 0) + 80 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i30 + (i13 * 88 | 0) + 84 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP16[i30 + (i13 * 88 | 0) + 2 >> 1] = HEAP32[i16 >> 2];
  i29 = i30 + (i13 * 88 | 0) + 4 | 0;
  HEAP32[i29 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  HEAP32[i29 + 16 >> 2] = HEAP32[i44 + 16 >> 2];
  HEAP32[i29 + 20 >> 2] = HEAP32[i44 + 20 >> 2];
  f53 = Math_fround(HEAPF32[i36 >> 2]);
  HEAPF32[i29 >> 2] = Math_fround(f53 + Math_fround(HEAPF32[i29 >> 2]));
  f53 = Math_fround(HEAPF32[i14 >> 2]);
  i29 = i30 + (i13 * 88 | 0) + 8 | 0;
  HEAPF32[i29 >> 2] = Math_fround(f53 + Math_fround(HEAPF32[i29 >> 2]));
  f53 = Math_fround(HEAPF32[i15 >> 2]);
  i29 = i30 + (i13 * 88 | 0) + 12 | 0;
  HEAPF32[i29 >> 2] = Math_fround(f53 + Math_fround(HEAPF32[i29 >> 2]));
  HEAP32[i30 + (i13 * 88 | 0) + 28 >> 2] = HEAP32[i19 + (i18 * 44 | 0) + 28 >> 2];
  if (((((HEAP32[i40 + 60 >> 2] | 0) - (HEAP32[i40 + 56 >> 2] | 0) | 0) / 28 | 0) + (i8 << 31 >> 31) | 0) > 0) {
   i30 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 934736 | 0, 1338) | 0;
   HEAP32[i30 + 4 >> 2] = 1;
   HEAP32[i30 >> 2] = gb + 33952 + 8;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 32 >> 2] = 0;
   HEAP32[i30 + 44 >> 2] = 0;
   HEAP32[i30 + 48 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 36 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 52 >> 2] = 0;
   HEAP32[i30 + 64 >> 2] = 0;
   HEAP32[i30 + 68 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 56 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 72 >> 2] = 0;
   HEAP32[i30 + 84 >> 2] = 0;
   HEAP32[i30 + 88 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 76 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   HEAP32[i30 + 92 >> 2] = 0;
   HEAP32[i30 + 96 >> 2] = 0;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i30 + 100 | 0;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP8[i30 + 108 >> 0] = 1;
   i29 = i30 + 8 | 0;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   HEAP32[i29 + 12 >> 2] = 0;
   HEAP32[i29 + 16 >> 2] = 0;
   HEAP32[i29 + 20 >> 2] = 0;
   HEAP32[i1 >> 2] = i30;
  }
  if (i28) {
   i30 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 934736 | 0, 1340) | 0;
   HEAP32[i30 + 4 >> 2] = 1;
   HEAP32[i30 >> 2] = gb + 33952 + 8;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 32 >> 2] = 0;
   HEAP32[i30 + 44 >> 2] = 0;
   HEAP32[i30 + 48 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 36 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 52 >> 2] = 0;
   HEAP32[i30 + 64 >> 2] = 0;
   HEAP32[i30 + 68 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 56 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i39;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP32[i30 + 72 >> 2] = 0;
   HEAP32[i30 + 84 >> 2] = 0;
   HEAP32[i30 + 88 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i43, i39);
   i29 = i43;
   i27 = HEAP32[i29 + 4 >> 2] | 0;
   i26 = i30 + 76 | 0;
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   HEAP32[i30 + 92 >> 2] = 0;
   HEAP32[i30 + 96 >> 2] = 0;
   i26 = gb + 63616 | 0;
   i27 = HEAP32[i26 + 4 >> 2] | 0;
   i29 = i30 + 100 | 0;
   HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i29 + 4 >> 2] = i27;
   HEAP8[i30 + 108 >> 0] = 1;
   i29 = i30 + 8 | 0;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   HEAP32[i29 + 12 >> 2] = 0;
   HEAP32[i29 + 16 >> 2] = 0;
   HEAP32[i29 + 20 >> 2] = 0;
   HEAP32[i2 >> 2] = i30;
  }
 }
 f50 = Math_fround(HEAPF32[i32 >> 2]);
 f52 = Math_fround(HEAPF32[i33 >> 2]);
 i25 = i17 + (i18 * 156 | 0) + 44 | 0;
 i26 = i17 + (i18 * 156 | 0) + 52 | 0;
 f53 = Math_fround(HEAPF32[i25 >> 2]);
 f51 = Math_fround(HEAPF32[i26 >> 2]);
 f53 = Math_fround(f50 * (f53 < f51 ? f51 : f53));
 i27 = i17 + (i18 * 156 | 0) + 48 | 0;
 f52 = Math_fround(f52 * Math_fround(HEAPF32[i27 >> 2]));
 i29 = i48 + 304 | 0;
 i30 = __ZN15LODGroupManager11AddLODGroupER8LODGroupRK8Vector3ff(i29, i40, i36, Math_fround(Math_fround(HEAPF32[i40 + 44 >> 2]) * (f53 < f52 ? f52 : f53))) | 0;
 f53 = Math_fround(HEAPF32[i32 >> 2]);
 f52 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i43 >> 2] = Math_fround(f53 * Math_fround(HEAPF32[i25 >> 2]));
 HEAPF32[i43 + 4 >> 2] = Math_fround(f52 * Math_fround(HEAPF32[i27 >> 2]));
 HEAPF32[i43 + 8 >> 2] = Math_fround(f53 * Math_fround(HEAPF32[i26 >> 2]));
 if ((HEAP32[i17 + (i18 * 156 | 0) + 4 >> 2] | 0) == 2) {
  f11 = Math_fround(Math_fround(HEAPF32[i35 + (i34 * 40 | 0) + 20 >> 2]) * Math_fround(.5));
  f9 = Math_fround(+Math_sin(+f11));
  f11 = Math_fround(+Math_cos(+f11));
  f10 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62536 >> 2]));
  f12 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2]));
  f9 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]));
 } else {
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(1.0);
  f12 = Math_fround(0.0);
 }
 HEAPF32[i39 + 12 >> 2] = f11;
 HEAPF32[i39 >> 2] = f10;
 HEAPF32[i39 + 4 >> 2] = f12;
 HEAPF32[i39 + 8 >> 2] = f9;
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i31, i36, i39, i43);
 i24 = i19 + (i18 * 44 | 0) + 16 | 0;
 if (HEAP32[i24 >> 2] | 0) {
  i14 = i19 + (i18 * 44 | 0) + 4 | 0;
  i15 = i48 + 204 | 0;
  i16 = i48 + 296 | 0;
  i17 = i48 + 300 | 0;
  i18 = i30 & 65535;
  i19 = (i41 & 1) << 2 & 255;
  i20 = i48 + 420 | 0;
  i21 = i48 + 432 | 0;
  i22 = i48 + 436 | 0;
  i23 = i48 + 424 | 0;
  i8 = 0;
  do {
   i7 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[i7 + (i8 * 72 | 0) >> 2] | 0;
   do if (i4 | 0) {
    HEAP32[i39 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i47 = 40; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i1, i39);
      i2 = HEAP32[i43 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i47 = 40; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i47 = 42;
     }
    }
    if ((i47 | 0) == 40) i47 = 42;
    if ((i47 | 0) == 42) {
     i47 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
     if (!i1) break;
    }
    if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30912 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30912 + 28 >> 2] | 0) >>> 0)) {
     __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i31, i7 + (i8 * 72 | 0) + 4 | 0, i43);
     HEAP32[gb + 1467256 >> 2] = i15;
     i6 = __ZN22ForwardLinearAllocator8allocateEjj(i15, 292, 4) | 0;
     __ZN23LODTreeInstanceRendererC2ER12TreeRendereriR12MeshRendererRK10Matrix4x4fi(i6, i48, i34, i1, i43, i13);
     HEAP32[gb + 1467256 >> 2] = 0;
     i55 = HEAP32[i16 >> 2] | 0;
     i54 = HEAP32[i6 + 272 >> 2] | 0;
     i1 = i54 + i55 | 0;
     i2 = i6 + 236 | 0;
     i3 = HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16;
     i4 = (i3 & 196608 | 0) == 0;
     i5 = i6 + 232 | 0;
     if ((i55 | 0) > -1 ? (i54 | 0) < (HEAP32[i17 >> 2] | 0) : 0) {
      if (!i4) {
       i55 = i3 | 8192;
       HEAP16[i2 >> 1] = i55;
       HEAP8[i2 + 2 >> 0] = i55 >>> 16;
       HEAP32[i5 >> 2] = i1;
      }
     } else if (!i4) {
      i55 = i3 & 16769023;
      HEAP16[i2 >> 1] = i55;
      HEAP8[i2 + 2 >> 0] = i55 >>> 16;
      HEAP32[i5 >> 2] = -1;
     }
     i2 = __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv(i42) | 0;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
     HEAP16[i2 + 12 >> 1] = HEAP32[i29 >> 2];
     HEAP16[i2 + 14 >> 1] = i18;
     HEAP32[i2 + 16 >> 2] = HEAP32[i7 + (i8 * 72 | 0) + 68 >> 2];
     i2 = i2 + 20 | 0;
     HEAP8[i2 >> 0] = HEAP8[i2 >> 0] & -5 | i19;
     i2 = HEAP32[i21 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i22 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i22 >> 2] = i1;
       HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 * 24 | 0, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i55 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i55 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i21 >> 2] | 0) * 24 | 0) | 0;
       HEAP32[i22 >> 2] = i1;
       HEAP32[i20 >> 2] = i55;
       break;
      }
     } while (0);
     HEAP32[i21 >> 2] = i3;
     __ZN12BaseRenderer12GetWorldAABBER4AABB(i6, (HEAP32[i20 >> 2] | 0) + (i2 * 24 | 0) | 0);
    }
   } while (0);
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0);
 }
 if (!i28) {
  STACKTOP = i49;
  return;
 }
 i14 = i48 + 204 | 0;
 HEAP32[gb + 1467256 >> 2] = i14;
 i14 = __ZN22ForwardLinearAllocator8allocateEjj(i14, 304, 4) | 0;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i47 = 61; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i1, i39);
   i2 = HEAP32[i43 >> 2] | 0;
   i55 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i55 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i55 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i47 = 61; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i47 = 63;
  }
 }
 if ((i47 | 0) == 61) i47 = 63;
 if ((i47 | 0) == 63) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i38 >> 2] | 0) | 0;
 i2 = i1 + 32 + 236 | 0;
 i2 = ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 196608 | 0) == 65536;
 __ZN20IntermediateRendererC2Ev(i14);
 HEAP32[i14 + 264 >> 2] = 2;
 HEAP32[i14 + 268 >> 2] = i48;
 i5 = i14 + 272 | 0;
 HEAP32[i5 >> 2] = i34;
 HEAP32[i14 >> 2] = gb + 184660 + 8;
 HEAP32[i14 + 280 >> 2] = i13;
 HEAPF32[i14 + 296 >> 2] = Math_fround(0.0);
 HEAP8[i14 + 300 >> 0] = 1;
 i6 = i14 + 236 | 0;
 i2 = (HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16) & 16580607 | (i2 & 1) << 16;
 HEAP16[i6 >> 1] = i2;
 HEAP8[i6 + 2 >> 0] = i2 >>> 16;
 HEAP32[gb + 1467256 >> 2] = 0;
 f52 = Math_fround(HEAPF32[i32 >> 2]);
 f53 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i43 >> 2] = Math_fround(f52 * Math_fround(HEAPF32[i25 >> 2]));
 HEAPF32[i43 + 4 >> 2] = Math_fround(f53 * Math_fround(HEAPF32[i27 >> 2]));
 HEAPF32[i43 + 8 >> 2] = Math_fround(f52 * Math_fround(HEAPF32[i26 >> 2]));
 HEAPF32[i39 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 12 >> 2] = Math_fround(1.0);
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i45, i36, i39, i43);
 f52 = Math_fround(HEAPF32[i25 >> 2]);
 f53 = Math_fround(HEAPF32[i27 >> 2]);
 HEAPF32[i14 + 284 >> 2] = Math_fround(f52 * Math_fround(HEAPF32[i32 >> 2]));
 HEAPF32[i14 + 288 >> 2] = Math_fround(f53 * Math_fround(HEAPF32[i33 >> 2]));
 HEAP32[i14 + 292 >> 2] = HEAP32[i35 + (i34 * 40 | 0) + 20 >> 2];
 HEAP32[i46 >> 2] = HEAP32[(HEAP32[i37 >> 2] | 0) + 36 >> 2];
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i47 = 69; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i2, i39);
   i1 = HEAP32[i43 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i55 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
   i3 = HEAP32[i55 + 28 >> 2] | 0;
   i4 = HEAP32[i55 + 32 >> 2] | 0;
   i2 = i55;
  }
  if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i47 = 69; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i47 = 71;
  }
 }
 if ((i47 | 0) == 69) i47 = 71;
 if ((i47 | 0) == 71) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i38 >> 2] | 0) | 0;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
 }
 i4 = i1 + 32 + 236 | 0;
 i4 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 if (!i2) i47 = 77; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i55 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i55 + (i3 << 3) | 0;
   i2 = i55;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i2, i39);
   i1 = HEAP32[i43 >> 2] | 0;
   i55 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i55 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i55 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i47 = 77; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i47 = 79;
  }
 }
 if ((i47 | 0) == 77) i47 = 79;
 if ((i47 | 0) == 79) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i38 >> 2] | 0) | 0;
 i54 = i1 + 32 + 236 | 0;
 i54 = ((HEAPU16[i54 >> 1] | 0 | (HEAPU8[i54 + 2 >> 0] | 0) << 16) & 256 | 0) != 0;
 HEAP32[i43 >> 2] = HEAP32[i46 >> 2];
 __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i14, i45, i44, i43, 0, i4, i54);
 HEAP32[i14 + 276 >> 2] = HEAP32[i37 >> 2];
 i54 = HEAP32[i48 + 296 >> 2] | 0;
 i55 = HEAP32[i5 >> 2] | 0;
 i1 = i55 + i54 | 0;
 i2 = HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16;
 i3 = (i2 & 196608 | 0) == 0;
 i4 = i14 + 232 | 0;
 if ((i54 | 0) > -1 ? (i55 | 0) < (HEAP32[i48 + 300 >> 2] | 0) : 0) {
  if (!i3) {
   i55 = i2 | 8192;
   HEAP16[i6 >> 1] = i55;
   HEAP8[i6 + 2 >> 0] = i55 >>> 16;
   HEAP32[i4 >> 2] = i1;
  }
 } else if (!i3) {
  i55 = i2 & 16769023;
  HEAP16[i6 >> 1] = i55;
  HEAP8[i6 + 2 >> 0] = i55 >>> 16;
  HEAP32[i4 >> 2] = -1;
 }
 i2 = __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv(i42) | 0;
 HEAP32[i2 >> 2] = i14;
 i3 = i2 + 20 | 0;
 HEAP8[i3 >> 0] = HEAP8[i3 >> 0] & -5 | (i41 & 1) << 2 & 255;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
 HEAP16[i2 + 12 >> 1] = HEAP32[i29 >> 2];
 HEAP16[i2 + 14 >> 1] = i30;
 HEAP32[i2 + 16 >> 2] = 1 << (((HEAP32[i40 + 60 >> 2] | 0) - (HEAP32[i40 + 56 >> 2] | 0) | 0) / 28 | 0) + -1;
 i2 = i48 + 420 | 0;
 i3 = i48 + 432 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i48 + 436 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i48 + 424 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i55 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i48 + 424 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i55 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i55;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 __ZN12BaseRenderer12GetWorldAABBER4AABB(i14, (HEAP32[i2 >> 2] | 0) + (i4 * 24 | 0) | 0);
 STACKTOP = i49;
 return;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i2 = i11;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i8 + 4;
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i2 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901608 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 8 | 0;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901635 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901655 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901672 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i3 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i5 >>> 0) i7 = 34; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i7 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 20 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901689 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901707 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901736 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 32 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901753 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 78; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 78; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 78) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901780 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 89; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 89; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901804 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 100; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 100; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 100) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901827 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 111; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 111; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 111) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901847 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 122; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 122; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 122) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901867 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 133; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 133; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 133) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901895 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 144; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 144; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 144) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901920 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 155; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 155;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 155) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901945 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 166; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 166;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 166) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901967 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 177; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 177;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 177) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 903232 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 188; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 188;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 188) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 903253 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 199; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 199;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 199) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 80 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 901984 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L281 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L281;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 81 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902010 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L293 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L293;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 82 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902025 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L305 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L305;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 83 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902047 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L317 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L317;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902065 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L329 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L329;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 85 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902083 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  L341 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L341;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 86 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 902106 | 0, i4, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 L354 : do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i9 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L354;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZL28CalculateCarveHullFromPointsR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fffPS7_i(i32, i30, i29, f31, f22, i25, i26) {
 i32 = i32 | 0;
 i30 = i30 | 0;
 i29 = i29 | 0;
 f31 = Math_fround(f31);
 f22 = Math_fround(f22);
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i44 + 8 | 0;
 i28 = i44;
 i42 = i44 + 60 | 0;
 i43 = i44 + 40 | 0;
 i35 = i44 + 20 | 0;
 i24 = i44 + 16 | 0;
 i33 = i32 + 12 | 0;
 HEAP32[i33 >> 2] = 0;
 i34 = i32 + 16 | 0;
 i3 = gb + 64016 | 0;
 i37 = HEAP32[i3 + 4 >> 2] | 0;
 i36 = i28;
 HEAP32[i36 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i36 + 4 >> 2] = i37;
 HEAP32[i42 >> 2] = 0;
 i36 = i42 + 16 | 0;
 HEAP32[i36 >> 2] = 0;
 i37 = i42 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i28);
 i3 = i27;
 i38 = HEAP32[i3 + 4 >> 2] | 0;
 i39 = i37;
 HEAP32[i39 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i39 + 4 >> 2] = i38;
 i39 = gb + 64016 | 0;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i3 = i28;
 HEAP32[i3 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i3 + 4 >> 2] = i38;
 HEAP32[i43 >> 2] = 0;
 i3 = i43 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i38 = i43 + 16 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i43 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i28);
 i17 = i27;
 i40 = HEAP32[i17 + 4 >> 2] | 0;
 i41 = i39;
 HEAP32[i41 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i41 + 4 >> 2] = i40;
 i41 = gb + 64016 | 0;
 i40 = HEAP32[i41 + 4 >> 2] | 0;
 i17 = i28;
 HEAP32[i17 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i17 + 4 >> 2] = i40;
 HEAP32[i35 >> 2] = 0;
 i17 = i35 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i40 = i35 + 16 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i28);
 i16 = i27;
 i18 = HEAP32[i16 + 4 >> 2] | 0;
 i23 = i41;
 HEAP32[i23 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i23 + 4 >> 2] = i18;
 HEAP32[i42 + 12 >> 2] = i26;
 if (!i26) i1 = 0; else {
  HEAP32[i36 >> 2] = i26;
  HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i26 << 3, 4, i37, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i38 >> 2] | 0;
 }
 i2 = i26 + 1 | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i38 >> 2] = i2;
  HEAP32[i43 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i43 >> 2] | 0, i2 << 3, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i23 | 0, HEAP32[i43 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i38 >> 2] = i2;
  HEAP32[i43 >> 2] = i23;
  break;
 } while (0);
 i1 = HEAP32[i40 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i40 >> 2] = i2;
  HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2 << 3, 4, i41, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i41, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i23 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
  HEAP32[i40 >> 2] = i2;
  HEAP32[i35 >> 2] = i23;
  break;
 } while (0);
 i23 = (i26 | 0) > 0;
 if (i23) {
  i1 = 0;
  do {
   i18 = HEAP32[i42 >> 2] | 0;
   i16 = HEAP32[i25 + (i1 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i18 + (i1 << 3) >> 2] = HEAP32[i25 + (i1 * 12 | 0) >> 2];
   HEAP32[i18 + (i1 << 3) + 4 >> 2] = i16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i26 | 0));
 }
 __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i43, i42);
 __ZL16SimplifyPolylineR13dynamic_arrayI8Vector2fLj4EEf(i43, Math_fround(f22 * Math_fround(.100000001)));
 i16 = HEAP32[i3 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 i1 = HEAP32[i40 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i16 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i40 >> 2] = i16;
  HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i16 << 3, 4, i41, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16 << 3, 4, i41, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i18 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
  HEAP32[i40 >> 2] = i16;
  HEAP32[i35 >> 2] = i18;
  break;
 } while (0);
 if ((i16 | 0) > 0) {
  f21 = Math_fround(HEAPF32[gb + 62456 >> 2]);
  i14 = 0;
  do {
   i13 = HEAP32[i43 >> 2] | 0;
   f19 = Math_fround(HEAPF32[i13 + (i14 << 3) >> 2]);
   f20 = Math_fround(HEAPF32[i13 + (i14 << 3) + 4 >> 2]);
   i15 = ((i14 | 0) == 0 ? i16 : i14) + -1 | 0;
   f6 = Math_fround(HEAPF32[i13 + (i15 << 3) >> 2]);
   f7 = Math_fround(HEAPF32[i13 + (i15 << 3) + 4 >> 2]);
   i14 = i14 + 1 | 0;
   i15 = (i14 | 0) == (i16 | 0);
   i18 = i15 ? 0 : i14;
   f9 = Math_fround(HEAPF32[i13 + (i18 << 3) >> 2]);
   f10 = Math_fround(HEAPF32[i13 + (i18 << 3) + 4 >> 2]);
   f6 = Math_fround(f19 - f6);
   f7 = Math_fround(f20 - f7);
   f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))));
   if (f8 > f21) {
    f12 = Math_fround(f6 / f8);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f12 = Math_fround(f7 / f8);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i4 = HEAP32[gb + 1162356 >> 2] | 0;
    i3 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
   }
   f8 = Math_fround(f9 - f19);
   f6 = Math_fround(f10 - f20);
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(f6 * f6))));
   if (f7 > f21) {
    f12 = Math_fround(f8 / f7);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f12 = Math_fround(f6 / f7);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i2 = HEAP32[gb + 1162356 >> 2] | 0;
    i1 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
   }
   f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(-f6);
   f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(Math_fround(f8 * f12) + Math_fround(f7 * f6));
   if (f6 < Math_fround(-.00174542004)) {
    i4 = f6 < Math_fround(0.0);
    f10 = Math_fround(-f6);
    f10 = Math_fround(Math_fround((i4 ? f10 : f6) * Math_fround(.75)) + Math_fround(.25));
    f9 = Math_fround(f19 + Math_fround(Math_fround(f8 * f10) * f22));
    f10 = Math_fround(f20 + Math_fround(Math_fround(f7 * f10) * f22));
    f7 = Math_fround(f9 - Math_fround(f7 * f22));
    f6 = Math_fround(Math_fround(f8 * f22) + f10);
    i4 = HEAP32[i17 >> 2] | 0;
    i13 = i4 + 1 | 0;
    i2 = HEAP32[i40 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i13 >>> 0 > i3 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i40 >> 2] = i1;
      HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i1 << 3, 4, i41, 0, gb + 1047584 | 0, 464) | 0;
      i5 = HEAP32[i40 >> 2] | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i41, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
      HEAP32[i40 >> 2] = i1;
      HEAP32[i35 >> 2] = i5;
      i5 = i1;
      break;
     } else i5 = i2;
    } else i5 = i2; while (0);
    HEAP32[i17 >> 2] = i13;
    i2 = HEAP32[i35 >> 2] | 0;
    HEAPF32[i2 + (i4 << 3) >> 2] = f7;
    HEAPF32[i2 + (i4 << 3) + 4 >> 2] = f6;
    f7 = Math_fround(Math_fround(f22 * f11) + f9);
    f6 = Math_fround(Math_fround(f12 * f22) + f10);
    i1 = i4 + 2 | 0;
    i4 = i5 & 2147483647;
    do if (i1 >>> 0 > i4 >>> 0) {
     i3 = i5 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i4 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i40 >> 2] = i3;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 3, 4, i41, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i35 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i41, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
      HEAP32[i40 >> 2] = i3;
      HEAP32[i35 >> 2] = i2;
      break;
     }
    } while (0);
    HEAP32[i17 >> 2] = i1;
    HEAPF32[i2 + (i13 << 3) >> 2] = f7;
    HEAPF32[i2 + (i13 << 3) + 4 >> 2] = f6;
   } else {
    f6 = Math_fround(Math_fround(f11 - f7) * Math_fround(.5));
    f7 = Math_fround(Math_fround(f8 + f12) * Math_fround(.5));
    f8 = Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6));
    if (f8 > Math_fround(0.0)) {
     f12 = Math_fround(Math_fround(1.0) / f8);
     f6 = Math_fround(f6 * f12);
     f7 = Math_fround(f7 * f12);
    }
    f8 = Math_fround(f19 + Math_fround(f6 * f22));
    f6 = Math_fround(f20 + Math_fround(f7 * f22));
    i3 = HEAP32[i17 >> 2] | 0;
    i1 = i3 + 1 | 0;
    i4 = HEAP32[i40 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i1 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i40 >> 2] = i2;
      HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2 << 3, 4, i41, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i41, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i18 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
      HEAP32[i40 >> 2] = i2;
      HEAP32[i35 >> 2] = i18;
      break;
     }
    } while (0);
    HEAP32[i17 >> 2] = i1;
    i18 = HEAP32[i35 >> 2] | 0;
    HEAPF32[i18 + (i3 << 3) >> 2] = f8;
    HEAPF32[i18 + (i3 << 3) + 4 >> 2] = f6;
   }
  } while (!i15);
 } else i1 = HEAP32[i17 >> 2] | 0;
 if (i1 >>> 0 < 3) i1 = 0; else {
  f19 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  if ((i1 | 0) > 0) {
   i18 = i32 + 4 | 0;
   i17 = 0;
   do {
    i15 = HEAP32[i35 >> 2] | 0;
    f9 = Math_fround(HEAPF32[i15 + (i17 << 3) >> 2]);
    f10 = Math_fround(HEAPF32[i15 + (i17 << 3) + 4 >> 2]);
    i17 = i17 + 1 | 0;
    i16 = (i17 | 0) == (i1 | 0) ? 0 : i17;
    f6 = Math_fround(Math_fround(HEAPF32[i15 + (i16 << 3) >> 2]) - f9);
    f7 = Math_fround(Math_fround(HEAPF32[i15 + (i16 << 3) + 4 >> 2]) - f10);
    f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f7 * f7) + Math_fround(0.0)))));
    if (f8 > f19) {
     f22 = Math_fround(Math_fround(-f7) / f8);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(Math_fround(0.0) / f8);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(f6 / f8);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i2 = HEAP32[gb + 1162364 >> 2] | 0;
     i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
     i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
    }
    i13 = HEAP32[i33 >> 2] | 0;
    i14 = i13 + 1 | 0;
    i15 = HEAP32[i34 >> 2] | 0;
    i16 = i15 & 2147483647;
    do if (i14 >>> 0 > i16 >>> 0) {
     i5 = i15 << 1;
     i5 = (i5 | 0) == 0 ? 1 : i5;
     if (i16 >>> 0 < i5 >>> 0) if ((i15 | 0) > -1) {
      HEAP32[i34 >> 2] = i5;
      HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i5 << 4, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 4 | 0) | 0;
      HEAP32[i34 >> 2] = i5;
      HEAP32[i32 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i33 >> 2] = i14;
    i16 = HEAP32[i32 >> 2] | 0;
    HEAP32[i16 + (i13 << 4) >> 2] = i2;
    HEAP32[i16 + (i13 << 4) + 4 >> 2] = i3;
    HEAP32[i16 + (i13 << 4) + 8 >> 2] = i4;
    f22 = Math_fround(f9 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f22 = Math_fround(f22 + Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0)));
    HEAPF32[i16 + (i13 << 4) + 12 >> 2] = Math_fround(-Math_fround(f22 + Math_fround(f10 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
   } while ((i17 | 0) != (i1 | 0));
  }
  i1 = HEAP32[gb + 1162364 >> 2] | 0;
  i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i30 + 32 >> 2]);
  f46 = Math_fround(f10 * Math_fround(HEAPF32[i30 + 28 >> 2]));
  f7 = Math_fround(f10 * f10);
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i30 + 36 >> 2]));
  f45 = Math_fround(HEAPF32[i30 + 20 >> 2]);
  f22 = Math_fround(HEAPF32[i30 + 24 >> 2]);
  f6 = f45 < f22 ? f22 : f45;
  f46 = Math_fround(f46 * f6);
  f7 = Math_fround(f7 * f6);
  f6 = Math_fround(f10 * f6);
  f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f46 = Math_fround(f10 + f46);
  f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f11 + f7);
  f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f12 + f6);
  f9 = Math_fround(HEAPF32[i30 + 44 >> 2]);
  f20 = Math_fround(f9 * Math_fround(HEAPF32[i30 + 40 >> 2]));
  f21 = Math_fround(f9 * f9);
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i30 + 48 >> 2]));
  f8 = Math_fround(HEAPF32[i30 + 16 >> 2]);
  f22 = f22 < f8 ? f8 : f22;
  f20 = Math_fround(f46 + Math_fround(f20 * f22));
  f21 = Math_fround(f7 + Math_fround(f21 * f22));
  f22 = Math_fround(f6 + Math_fround(f9 * f22));
  f9 = Math_fround(HEAPF32[i30 + 56 >> 2]);
  f6 = Math_fround(f9 * Math_fround(HEAPF32[i30 + 52 >> 2]));
  f7 = Math_fround(f9 * f9);
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i30 + 60 >> 2]));
  f8 = f8 < f45 ? f45 : f8;
  f6 = Math_fround(f20 + Math_fround(f6 * f8));
  f7 = Math_fround(f21 + Math_fround(f7 * f8));
  f8 = Math_fround(f22 + Math_fround(f9 * f8));
  f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)))));
  if (f9 > f19) {
   f46 = Math_fround(f6 / f9);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
   f46 = Math_fround(f7 / f9);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
   f46 = Math_fround(f8 / f9);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f22 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f45 = Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f46 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  if (!(Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f45 * f45)) + Math_fround(f46 * f46)) <= Math_fround(f19 * f19))) {
   i15 = i1;
   i14 = i2;
   i13 = i3;
  } else {
   i15 = HEAP32[gb + 62536 >> 2] | 0;
   i14 = HEAP32[gb + 62536 + 4 >> 2] | 0;
   i13 = HEAP32[gb + 62536 + 8 >> 2] | 0;
  }
  HEAP32[i27 >> 2] = 2139095039;
  HEAP32[i28 >> 2] = -8388609;
  if (i23) {
   f8 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = 0;
   f7 = Math_fround(-3402823469999999843913219.0e14);
   f6 = Math_fround(3402823469999999843913219.0e14);
   do {
    f46 = Math_fround(f8 * Math_fround(HEAPF32[i25 + (i1 * 12 | 0) >> 2]));
    f46 = Math_fround(f46 + Math_fround(f9 * Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 4 >> 2])));
    f46 = Math_fround(f46 + Math_fround(f10 * Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 8 >> 2])));
    HEAPF32[i24 >> 2] = f46;
    i18 = HEAP32[(f46 < f6 ? i24 : i27) >> 2] | 0;
    HEAP32[i27 >> 2] = i18;
    i23 = HEAP32[(f7 < f46 ? i24 : i28) >> 2] | 0;
    HEAP32[i28 >> 2] = i23;
    i1 = i1 + 1 | 0;
    f6 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   } while ((i1 | 0) != (i26 | 0));
   f10 = f7;
  } else {
   f10 = Math_fround(-3402823469999999843913219.0e14);
   f6 = Math_fround(3402823469999999843913219.0e14);
  }
  i5 = HEAP32[i33 >> 2] | 0;
  i2 = i5 + 1 | 0;
  i3 = HEAP32[i34 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i2 >>> 0 > i4 >>> 0) {
   i1 = i3 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i34 >> 2] = i1;
    HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i28 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 4 | 0) | 0;
    HEAP32[i34 >> 2] = i1;
    HEAP32[i32 >> 2] = i28;
    break;
   }
  } while (0);
  HEAP32[i33 >> 2] = i2;
  i2 = HEAP32[i32 >> 2] | 0;
  f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(-f7);
  f8 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f46 = Math_fround(-f8);
  f9 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = Math_fround(-f9);
  f19 = Math_fround(f6 - f31);
  f21 = Math_fround(f7 * f19);
  f45 = Math_fround(f8 * f19);
  f19 = Math_fround(f9 * f19);
  HEAPF32[i2 + (i5 << 4) >> 2] = f22;
  HEAPF32[i2 + (i5 << 4) + 4 >> 2] = f46;
  HEAPF32[i2 + (i5 << 4) + 8 >> 2] = f20;
  HEAPF32[i2 + (i5 << 4) + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f19 * f20) + Math_fround(Math_fround(f21 * f22) + Math_fround(f45 * f46))));
  i2 = HEAP32[i33 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i34 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i34 >> 2] = i1;
    HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i28 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 4 | 0) | 0;
    HEAP32[i34 >> 2] = i1;
    HEAP32[i32 >> 2] = i28;
    break;
   }
  } while (0);
  HEAP32[i33 >> 2] = i3;
  i28 = HEAP32[i32 >> 2] | 0;
  f45 = Math_fround(f7 * f10);
  f46 = Math_fround(f8 * f10);
  f22 = Math_fround(f9 * f10);
  HEAP32[i28 + (i2 << 4) >> 2] = i15;
  HEAP32[i28 + (i2 << 4) + 4 >> 2] = i14;
  HEAP32[i28 + (i2 << 4) + 8 >> 2] = i13;
  HEAPF32[i28 + (i2 << 4) + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f9 * f22) + Math_fround(Math_fround(f7 * f45) + Math_fround(f8 * f46))));
  f46 = Math_fround(f7 * Math_fround(HEAPF32[gb + 62536 >> 2]));
  f46 = Math_fround(f46 + Math_fround(f8 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2])));
  f46 = Math_fround(f46 + Math_fround(f9 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2])));
  i28 = f46 < Math_fround(0.0);
  f45 = Math_fround(-f46);
  if (!((i28 ? f45 : f46) > Math_fround(.984807729))) {
   f7 = Math_fround(HEAPF32[i30 + 64 >> 2]);
   f10 = Math_fround(HEAPF32[i29 >> 2]);
   f7 = Math_fround(f7 - f10);
   f8 = Math_fround(HEAPF32[i30 + 68 >> 2]);
   f11 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f8 = Math_fround(f8 - f11);
   f6 = Math_fround(HEAPF32[i30 + 72 >> 2]);
   f9 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f6 = Math_fround(f6 - f9);
   f10 = Math_fround(Math_fround(HEAPF32[i30 + 76 >> 2]) - f10);
   f11 = Math_fround(Math_fround(HEAPF32[i30 + 80 >> 2]) - f11);
   f9 = Math_fround(Math_fround(HEAPF32[i30 + 84 >> 2]) - f9);
   i2 = HEAP32[i33 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i34 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i34 >> 2] = i1;
     HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i30 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 4 | 0) | 0;
     HEAP32[i34 >> 2] = i1;
     HEAP32[i32 >> 2] = i30;
     break;
    }
   } while (0);
   HEAP32[i33 >> 2] = i3;
   i3 = HEAP32[i32 >> 2] | 0;
   f19 = Math_fround(HEAPF32[gb + 62536 >> 2]);
   f20 = Math_fround(-f19);
   f21 = Math_fround(HEAPF32[gb + 62536 + 4 >> 2]);
   f22 = Math_fround(-f21);
   f45 = Math_fround(HEAPF32[gb + 62536 + 8 >> 2]);
   f46 = Math_fround(-f45);
   f19 = Math_fround(f7 - Math_fround(f19 * f31));
   f21 = Math_fround(f8 - Math_fround(f21 * f31));
   f45 = Math_fround(f6 - Math_fround(f45 * f31));
   HEAPF32[i3 + (i2 << 4) >> 2] = f20;
   HEAPF32[i3 + (i2 << 4) + 4 >> 2] = f22;
   HEAPF32[i3 + (i2 << 4) + 8 >> 2] = f46;
   HEAPF32[i3 + (i2 << 4) + 12 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * f22)) + Math_fround(f45 * f46)));
   i2 = HEAP32[i33 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i34 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i34 >> 2] = i1;
     HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i30 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 4 | 0) | 0;
     HEAP32[i34 >> 2] = i1;
     HEAP32[i32 >> 2] = i30;
     break;
    }
   } while (0);
   HEAP32[i33 >> 2] = i3;
   i34 = HEAP32[i32 >> 2] | 0;
   i33 = i34 + (i2 << 4) | 0;
   HEAP32[i33 >> 2] = HEAP32[gb + 62536 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
   f46 = Math_fround(f10 * Math_fround(HEAPF32[gb + 62536 >> 2]));
   f46 = Math_fround(f46 + Math_fround(f11 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2])));
   HEAPF32[i34 + (i2 << 4) + 12 >> 2] = Math_fround(-Math_fround(f46 + Math_fround(f9 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]))));
  }
  i1 = 1;
 }
 if ((HEAP32[i40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i41);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i38 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 >> 2] | 0, i39);
  HEAP32[i43 >> 2] = 0;
 }
 if ((HEAP32[i36 >> 2] | 0) <= -1) {
  STACKTOP = i44;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i37);
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i44;
 return i1 | 0;
}

function __ZN7b2World8SolveTOIERK10b2TimeStep(i3, i54) {
 i3 = i3 | 0;
 i54 = i54 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i61 = i74;
 i68 = i74 + 240 | 0;
 i69 = i74 + 204 | 0;
 i70 = i74 + 168 | 0;
 i71 = i74 + 160 | 0;
 i72 = i74 + 136 | 0;
 i67 = i3 + 68 | 0;
 i73 = i3 + 102872 | 0;
 i55 = i3 + 102944 | 0;
 i62 = HEAP32[i55 >> 2] | 0;
 i56 = i68 + 40 | 0;
 HEAP32[i56 >> 2] = 64;
 i57 = i68 + 44 | 0;
 HEAP32[i57 >> 2] = 32;
 HEAP32[i68 + 48 >> 2] = 0;
 i58 = i68 + 28 | 0;
 HEAP32[i58 >> 2] = 0;
 i59 = i68 + 36 | 0;
 HEAP32[i59 >> 2] = 0;
 i60 = i68 + 32 | 0;
 HEAP32[i60 >> 2] = 0;
 HEAP32[i68 >> 2] = i67;
 HEAP32[i68 + 4 >> 2] = i62;
 i62 = i68 + 8 | 0;
 HEAP32[i62 >> 2] = __ZN16b2StackAllocator8AllocateEi(i67, 256) | 0;
 i63 = i68 + 12 | 0;
 HEAP32[i63 >> 2] = __ZN16b2StackAllocator8AllocateEi(i67, 128) | 0;
 i64 = i68 + 16 | 0;
 HEAP32[i64 >> 2] = __ZN16b2StackAllocator8AllocateEi(i67, 0) | 0;
 i65 = i68 + 24 | 0;
 HEAP32[i65 >> 2] = __ZN16b2StackAllocator8AllocateEi(i67, 768) | 0;
 i66 = i68 + 20 | 0;
 HEAP32[i66 >> 2] = __ZN16b2StackAllocator8AllocateEi(i67, 768) | 0;
 i67 = i3 + 102999 | 0;
 if (!(HEAP8[i67 >> 0] | 0)) i2 = i3 + 102932 | 0; else {
  i1 = HEAP32[i3 + 102956 >> 2] | 0;
  if (i1 | 0) do {
   i53 = i1 + 4 | 0;
   HEAP16[i53 >> 1] = HEAPU16[i53 >> 1] & 65534;
   HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
   i1 = HEAP32[i1 + 96 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i2 = i3 + 102932 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1) do {
   i53 = i1 + 4 | 0;
   HEAP32[i53 >> 2] = HEAP32[i53 >> 2] & -34;
   HEAP32[i1 + 136 >> 2] = 0;
   HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
   i1 = HEAP32[i1 + 12 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i47 = i71 + 4 | 0;
 i48 = i72 + 4 | 0;
 i49 = i72 + 8 | 0;
 i50 = i72 + 16 | 0;
 i51 = i54 + 12 | 0;
 i52 = i72 + 12 | 0;
 i53 = i72 + 20 | 0;
 i33 = i3 + 102998 | 0;
 i34 = i61 + 8 | 0;
 i35 = i61 + 12 | 0;
 i32 = i61 + 4 | 0;
 i36 = i61 + 16 | 0;
 i37 = i61 + 20 | 0;
 i38 = i61 + 24 | 0;
 i39 = i61 + 44 | 0;
 i40 = i61 + 48 | 0;
 i41 = i61 + 52 | 0;
 i42 = i61 + 28 | 0;
 i43 = i61 + 56 | 0;
 i44 = i61 + 92 | 0;
 i45 = i61 + 128 | 0;
 i46 = i69 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 L11 : do if (i1 | 0) {
  while (1) {
   i14 = 0;
   f15 = Math_fround(1.0);
   do {
    i13 = i1 + 4 | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    do if (i3 & 4) if ((HEAP32[i1 + 136 >> 2] | 0) <= 8) {
     if (!(i3 & 32)) {
      i10 = HEAP32[i1 + 48 >> 2] | 0;
      i11 = HEAP32[i1 + 52 >> 2] | 0;
      if (HEAP8[i10 + 58 >> 0] | 0) break;
      if (HEAP8[i11 + 58 >> 0] | 0) break;
      i7 = HEAP32[i10 + 28 >> 2] | 0;
      i8 = HEAP32[i11 + 28 >> 2] | 0;
      i3 = HEAP16[i7 + 4 >> 1] | 0;
      i5 = HEAP16[i8 + 4 >> 1] | 0;
      if (!((HEAP32[i7 >> 2] | 0) != 0 & (i3 & 2) != 0 | (HEAP32[i8 >> 2] | 0) != 0 & (i5 & 2) != 0)) break;
      if (!((i5 | i3) & 8)) break;
      i6 = i7 + 28 | 0;
      i3 = i7 + 60 | 0;
      f4 = Math_fround(HEAPF32[i3 >> 2]);
      i12 = i8 + 28 | 0;
      i5 = i8 + 60 | 0;
      f9 = Math_fround(HEAPF32[i5 >> 2]);
      if (f4 < f9) {
       f76 = Math_fround(Math_fround(f9 - f4) / Math_fround(Math_fround(1.0) - f4));
       f77 = Math_fround(HEAPF32[i7 + 44 >> 2]);
       i30 = i7 + 36 | 0;
       f78 = Math_fround(HEAPF32[i30 >> 2]);
       f77 = Math_fround(f77 - f78);
       f75 = Math_fround(HEAPF32[i7 + 48 >> 2]);
       i31 = i7 + 40 | 0;
       f4 = Math_fround(HEAPF32[i31 >> 2]);
       f75 = Math_fround(f76 * Math_fround(f75 - f4));
       HEAPF32[i30 >> 2] = Math_fround(f78 + Math_fround(f76 * f77));
       HEAPF32[i31 >> 2] = Math_fround(f4 + f75);
       f75 = Math_fround(HEAPF32[i7 + 56 >> 2]);
       i31 = i7 + 52 | 0;
       f4 = Math_fround(HEAPF32[i31 >> 2]);
       HEAPF32[i31 >> 2] = Math_fround(f4 + Math_fround(f76 * Math_fround(f75 - f4)));
       HEAPF32[i3 >> 2] = f9;
       f4 = f9;
      } else if (f9 < f4) {
       f76 = Math_fround(Math_fround(f4 - f9) / Math_fround(Math_fround(1.0) - f9));
       f75 = Math_fround(HEAPF32[i8 + 44 >> 2]);
       i30 = i8 + 36 | 0;
       f9 = Math_fround(HEAPF32[i30 >> 2]);
       f75 = Math_fround(f75 - f9);
       f77 = Math_fround(HEAPF32[i8 + 48 >> 2]);
       i31 = i8 + 40 | 0;
       f78 = Math_fround(HEAPF32[i31 >> 2]);
       f77 = Math_fround(f76 * Math_fround(f77 - f78));
       HEAPF32[i30 >> 2] = Math_fround(f9 + Math_fround(f76 * f75));
       HEAPF32[i31 >> 2] = Math_fround(f78 + f77);
       f77 = Math_fround(HEAPF32[i8 + 56 >> 2]);
       i31 = i8 + 52 | 0;
       f78 = Math_fround(HEAPF32[i31 >> 2]);
       HEAPF32[i31 >> 2] = Math_fround(f78 + Math_fround(f76 * Math_fround(f77 - f78)));
       HEAPF32[i5 >> 2] = f4;
      }
      i30 = HEAP32[i1 + 56 >> 2] | 0;
      i31 = HEAP32[i1 + 60 >> 2] | 0;
      HEAP32[i36 >> 2] = 0;
      HEAP32[i37 >> 2] = 0;
      HEAPF32[i38 >> 2] = Math_fround(0.0);
      HEAP32[i39 >> 2] = 0;
      HEAP32[i40 >> 2] = 0;
      HEAPF32[i41 >> 2] = Math_fround(0.0);
      __ZN15b2DistanceProxy3SetEPK7b2Shapei(i61, HEAP32[i10 + 32 >> 2] | 0, i30);
      __ZN15b2DistanceProxy3SetEPK7b2Shapei(i42, HEAP32[i11 + 32 >> 2] | 0, i31);
      i31 = i43;
      i30 = i31 + 36 | 0;
      do {
       HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
       i31 = i31 + 4 | 0;
       i6 = i6 + 4 | 0;
      } while ((i31 | 0) < (i30 | 0));
      i31 = i44;
      i6 = i12;
      i30 = i31 + 36 | 0;
      do {
       HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
       i31 = i31 + 4 | 0;
       i6 = i6 + 4 | 0;
      } while ((i31 | 0) < (i30 | 0));
      HEAPF32[i45 >> 2] = Math_fround(1.0);
      HEAP32[i38 >> 2] = HEAP32[i1 + 128 >> 2];
      HEAP32[i41 >> 2] = HEAP32[i1 + 132 >> 2];
      __Z14b2TimeOfImpactP11b2TOIOutputPK10b2TOIInput(i69, i61);
      if ((HEAP32[i69 >> 2] | 0) == 3) {
       f4 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(1.0) - f4) * Math_fround(HEAPF32[i46 >> 2])));
       i31 = f4 < Math_fround(1.0);
       f4 = i31 ? f4 : Math_fround(1.0);
      } else f4 = Math_fround(1.0);
      HEAPF32[i1 + 140 >> 2] = f4;
      HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 32;
     } else f4 = Math_fround(HEAPF32[i1 + 140 >> 2]);
     i31 = f4 < f15;
     i14 = i31 ? i1 : i14;
     f15 = i31 ? f4 : f15;
    } while (0);
    i1 = HEAP32[i1 + 12 >> 2] | 0;
   } while ((i1 | 0) != 0);
   if (f15 > Math_fround(.999998807) | (i14 | 0) == 0) break L11;
   i29 = HEAP32[(HEAP32[i14 + 48 >> 2] | 0) + 28 >> 2] | 0;
   i28 = HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + 28 >> 2] | 0;
   i7 = i29 + 28 | 0;
   i31 = i69;
   i6 = i7;
   i30 = i31 + 36 | 0;
   do {
    HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
    i31 = i31 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i31 | 0) < (i30 | 0));
   i8 = i28 + 28 | 0;
   i31 = i70;
   i6 = i8;
   i30 = i31 + 36 | 0;
   do {
    HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
    i31 = i31 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i31 | 0) < (i30 | 0));
   i19 = i29 + 60 | 0;
   f9 = Math_fround(HEAPF32[i19 >> 2]);
   f9 = Math_fround(Math_fround(f15 - f9) / Math_fround(Math_fround(1.0) - f9));
   i10 = i29 + 44 | 0;
   f77 = Math_fround(HEAPF32[i10 >> 2]);
   i3 = i29 + 36 | 0;
   f75 = Math_fround(HEAPF32[i3 >> 2]);
   f77 = Math_fround(f77 - f75);
   i11 = i29 + 48 | 0;
   f76 = Math_fround(HEAPF32[i11 >> 2]);
   i12 = i29 + 40 | 0;
   f78 = Math_fround(HEAPF32[i12 >> 2]);
   f76 = Math_fround(f9 * Math_fround(f76 - f78));
   HEAPF32[i3 >> 2] = Math_fround(f75 + Math_fround(f9 * f77));
   HEAPF32[i12 >> 2] = Math_fround(f78 + f76);
   i12 = i29 + 56 | 0;
   f76 = Math_fround(HEAPF32[i12 >> 2]);
   i3 = i29 + 52 | 0;
   f78 = Math_fround(HEAPF32[i3 >> 2]);
   f78 = Math_fround(f78 + Math_fround(f9 * Math_fround(f76 - f78)));
   HEAPF32[i3 >> 2] = f78;
   HEAPF32[i19 >> 2] = f15;
   i19 = i29 + 36 | 0;
   i3 = HEAP32[i19 >> 2] | 0;
   i19 = HEAP32[i19 + 4 >> 2] | 0;
   i13 = i29 + 44 | 0;
   HEAP32[i13 >> 2] = i3;
   HEAP32[i13 + 4 >> 2] = i19;
   HEAPF32[i12 >> 2] = f78;
   f76 = Math_fround(+Math_sin(+f78));
   i13 = i29 + 20 | 0;
   HEAPF32[i13 >> 2] = f76;
   f78 = Math_fround(+Math_cos(+f78));
   i16 = i29 + 24 | 0;
   HEAPF32[i16 >> 2] = f78;
   i17 = i29 + 28 | 0;
   f9 = Math_fround(HEAPF32[i17 >> 2]);
   f77 = Math_fround(f78 * f9);
   i18 = i29 + 32 | 0;
   f75 = Math_fround(HEAPF32[i18 >> 2]);
   f77 = Math_fround(f77 - Math_fround(f76 * f75));
   f75 = Math_fround(Math_fround(f76 * f9) + Math_fround(f78 * f75));
   f77 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f77);
   f75 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f75);
   i19 = i29 + 12 | 0;
   HEAPF32[i19 >> 2] = f77;
   i3 = i29 + 16 | 0;
   HEAPF32[i3 >> 2] = f75;
   i27 = i28 + 60 | 0;
   f75 = Math_fround(HEAPF32[i27 >> 2]);
   f75 = Math_fround(Math_fround(f15 - f75) / Math_fround(Math_fround(1.0) - f75));
   i20 = i28 + 44 | 0;
   f77 = Math_fround(HEAPF32[i20 >> 2]);
   i5 = i28 + 36 | 0;
   f78 = Math_fround(HEAPF32[i5 >> 2]);
   f77 = Math_fround(f77 - f78);
   i21 = i28 + 48 | 0;
   f9 = Math_fround(HEAPF32[i21 >> 2]);
   i22 = i28 + 40 | 0;
   f76 = Math_fround(HEAPF32[i22 >> 2]);
   f9 = Math_fround(f75 * Math_fround(f9 - f76));
   HEAPF32[i5 >> 2] = Math_fround(f78 + Math_fround(f75 * f77));
   HEAPF32[i22 >> 2] = Math_fround(f76 + f9);
   i22 = i28 + 56 | 0;
   f9 = Math_fround(HEAPF32[i22 >> 2]);
   i5 = i28 + 52 | 0;
   f76 = Math_fround(HEAPF32[i5 >> 2]);
   f76 = Math_fround(f76 + Math_fround(f75 * Math_fround(f9 - f76)));
   HEAPF32[i5 >> 2] = f76;
   HEAPF32[i27 >> 2] = f15;
   i27 = i28 + 36 | 0;
   i5 = HEAP32[i27 >> 2] | 0;
   i27 = HEAP32[i27 + 4 >> 2] | 0;
   i23 = i28 + 44 | 0;
   HEAP32[i23 >> 2] = i5;
   HEAP32[i23 + 4 >> 2] = i27;
   HEAPF32[i22 >> 2] = f76;
   f9 = Math_fround(+Math_sin(+f76));
   i23 = i28 + 20 | 0;
   HEAPF32[i23 >> 2] = f9;
   f76 = Math_fround(+Math_cos(+f76));
   i24 = i28 + 24 | 0;
   HEAPF32[i24 >> 2] = f76;
   i25 = i28 + 28 | 0;
   f75 = Math_fround(HEAPF32[i25 >> 2]);
   f77 = Math_fround(f76 * f75);
   i26 = i28 + 32 | 0;
   f78 = Math_fround(HEAPF32[i26 >> 2]);
   f77 = Math_fround(f77 - Math_fround(f9 * f78));
   f78 = Math_fround(Math_fround(f9 * f75) + Math_fround(f76 * f78));
   f77 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f77);
   f78 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f78);
   i27 = i28 + 12 | 0;
   HEAPF32[i27 >> 2] = f77;
   i5 = i28 + 16 | 0;
   HEAPF32[i5 >> 2] = f78;
   __ZN9b2Contact6UpdateEP17b2ContactListener(i14, HEAP32[i55 >> 2] | 0);
   i6 = i14 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i1 & -33;
   i31 = i14 + 136 | 0;
   HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
   if ((i1 & 6 | 0) == 6) {
    i5 = i29 + 4 | 0;
    i1 = HEAPU16[i5 >> 1] | 0;
    if (!(HEAP32[i29 >> 2] | 0)) {
     HEAP16[i5 >> 1] = i1 & 65533;
     HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
     i31 = i29 + 64 | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     HEAP32[i31 + 8 >> 2] = 0;
     HEAP32[i31 + 12 >> 2] = 0;
     HEAP32[i31 + 16 >> 2] = 0;
     HEAP32[i31 + 20 >> 2] = 0;
    } else if (!(i1 & 2)) {
     HEAP16[i5 >> 1] = i1 | 2;
     HEAPF32[i29 + 144 >> 2] = Math_fround(0.0);
    }
    i3 = i28 + 4 | 0;
    i1 = HEAPU16[i3 >> 1] | 0;
    if (!(HEAP32[i28 >> 2] | 0)) {
     HEAP16[i3 >> 1] = i1 & 65533;
     HEAPF32[i28 + 144 >> 2] = Math_fround(0.0);
     i31 = i28 + 64 | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     HEAP32[i31 + 8 >> 2] = 0;
     HEAP32[i31 + 12 >> 2] = 0;
     HEAP32[i31 + 16 >> 2] = 0;
     HEAP32[i31 + 20 >> 2] = 0;
    } else if (!(i1 & 2)) {
     HEAP16[i3 >> 1] = i1 | 2;
     HEAPF32[i28 + 144 >> 2] = Math_fround(0.0);
    }
    HEAP32[i60 >> 2] = 0;
    i18 = i29 + 8 | 0;
    HEAP32[i18 >> 2] = 0;
    i16 = HEAP32[i62 >> 2] | 0;
    HEAP32[i16 >> 2] = i29;
    i19 = i28 + 8 | 0;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i16 + 4 >> 2] = i28;
    HEAP32[i58 >> 2] = 2;
    HEAP32[i59 >> 2] = 1;
    HEAP32[HEAP32[i63 >> 2] >> 2] = i14;
    HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 1;
    HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 1;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
    HEAP32[i71 >> 2] = i29;
    HEAP32[i47 >> 2] = i28;
    i16 = HEAP32[i56 >> 2] | 0;
    i17 = HEAP32[i57 >> 2] | 0;
    i20 = HEAP32[i63 >> 2] | 0;
    i21 = HEAP32[i62 >> 2] | 0;
    i14 = 0;
    i5 = i29;
    i3 = 2;
    while (1) {
     L52 : do if ((HEAP32[i5 >> 2] | 0) == 2) {
      i1 = HEAP32[i5 + 112 >> 2] | 0;
      if (i1) {
       i13 = i5 + 4 | 0;
       do {
        i7 = HEAP32[i59 >> 2] | 0;
        if ((i3 | 0) == (i16 | 0) | (i7 | 0) == (i17 | 0)) break L52;
        i8 = HEAP32[i1 + 4 >> 2] | 0;
        i10 = i8 + 4 | 0;
        do if (!(HEAP32[i10 >> 2] & 1)) {
         i12 = HEAP32[i1 >> 2] | 0;
         if ((HEAP32[i12 >> 2] | 0) == 2) if (!(HEAP16[i13 >> 1] & 8)) if (!(HEAP16[i12 + 4 >> 1] & 8)) break;
         if (!(HEAP8[(HEAP32[i8 + 48 >> 2] | 0) + 58 >> 0] | 0)) if (!(HEAP8[(HEAP32[i8 + 52 >> 2] | 0) + 58 >> 0] | 0)) {
          i11 = i12 + 28 | 0;
          i31 = i61;
          i6 = i11;
          i30 = i31 + 36 | 0;
          do {
           HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
           i31 = i31 + 4 | 0;
           i6 = i6 + 4 | 0;
          } while ((i31 | 0) < (i30 | 0));
          i6 = i12 + 4 | 0;
          if (!(HEAP16[i6 >> 1] & 1)) {
           i31 = i12 + 60 | 0;
           f75 = Math_fround(HEAPF32[i31 >> 2]);
           f75 = Math_fround(Math_fround(f15 - f75) / Math_fround(Math_fround(1.0) - f75));
           f77 = Math_fround(HEAPF32[i12 + 44 >> 2]);
           i30 = i12 + 36 | 0;
           f78 = Math_fround(HEAPF32[i30 >> 2]);
           f77 = Math_fround(f77 - f78);
           f9 = Math_fround(HEAPF32[i12 + 48 >> 2]);
           i29 = i12 + 40 | 0;
           f76 = Math_fround(HEAPF32[i29 >> 2]);
           f9 = Math_fround(f75 * Math_fround(f9 - f76));
           HEAPF32[i30 >> 2] = Math_fround(f78 + Math_fround(f75 * f77));
           HEAPF32[i29 >> 2] = Math_fround(f76 + f9);
           i29 = i12 + 56 | 0;
           f9 = Math_fround(HEAPF32[i29 >> 2]);
           i30 = i12 + 52 | 0;
           f76 = Math_fround(HEAPF32[i30 >> 2]);
           f76 = Math_fround(f76 + Math_fround(f75 * Math_fround(f9 - f76)));
           HEAPF32[i30 >> 2] = f76;
           HEAPF32[i31 >> 2] = f15;
           i31 = i12 + 36 | 0;
           i30 = HEAP32[i31 >> 2] | 0;
           i31 = HEAP32[i31 + 4 >> 2] | 0;
           i28 = i12 + 44 | 0;
           HEAP32[i28 >> 2] = i30;
           HEAP32[i28 + 4 >> 2] = i31;
           HEAPF32[i29 >> 2] = f76;
           f9 = Math_fround(+Math_sin(+f76));
           HEAPF32[i12 + 20 >> 2] = f9;
           f76 = Math_fround(+Math_cos(+f76));
           HEAPF32[i12 + 24 >> 2] = f76;
           f75 = Math_fround(HEAPF32[i12 + 28 >> 2]);
           f77 = Math_fround(f76 * f75);
           f78 = Math_fround(HEAPF32[i12 + 32 >> 2]);
           f77 = Math_fround(f77 - Math_fround(f9 * f78));
           f78 = Math_fround(Math_fround(f9 * f75) + Math_fround(f76 * f78));
           f77 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f77);
           f78 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f78);
           HEAPF32[i12 + 12 >> 2] = f77;
           HEAPF32[i12 + 16 >> 2] = f78;
          }
          __ZN9b2Contact6UpdateEP17b2ContactListener(i8, HEAP32[i55 >> 2] | 0);
          i5 = HEAP32[i10 >> 2] | 0;
          do if (!(i5 & 4)) {
           i31 = i11;
           i6 = i61;
           i30 = i31 + 36 | 0;
           do {
            HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
            i31 = i31 + 4 | 0;
            i6 = i6 + 4 | 0;
           } while ((i31 | 0) < (i30 | 0));
           f76 = Math_fround(HEAPF32[i12 + 56 >> 2]);
           f9 = Math_fround(+Math_sin(+f76));
           HEAPF32[i12 + 20 >> 2] = f9;
           f76 = Math_fround(+Math_cos(+f76));
           HEAPF32[i12 + 24 >> 2] = f76;
           f75 = Math_fround(HEAPF32[i12 + 28 >> 2]);
           f77 = Math_fround(f76 * f75);
           f78 = Math_fround(HEAPF32[i12 + 32 >> 2]);
           f77 = Math_fround(f77 - Math_fround(f9 * f78));
           f78 = Math_fround(Math_fround(f9 * f75) + Math_fround(f76 * f78));
           f77 = Math_fround(Math_fround(HEAPF32[i12 + 44 >> 2]) - f77);
           f78 = Math_fround(Math_fround(HEAPF32[i12 + 48 >> 2]) - f78);
           HEAPF32[i12 + 12 >> 2] = f77;
           HEAPF32[i12 + 16 >> 2] = f78;
          } else {
           if (!(i5 & 2)) {
            i31 = i11;
            i6 = i61;
            i30 = i31 + 36 | 0;
            do {
             HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
             i31 = i31 + 4 | 0;
             i6 = i6 + 4 | 0;
            } while ((i31 | 0) < (i30 | 0));
            f76 = Math_fround(HEAPF32[i12 + 56 >> 2]);
            f9 = Math_fround(+Math_sin(+f76));
            HEAPF32[i12 + 20 >> 2] = f9;
            f76 = Math_fround(+Math_cos(+f76));
            HEAPF32[i12 + 24 >> 2] = f76;
            f75 = Math_fround(HEAPF32[i12 + 28 >> 2]);
            f77 = Math_fround(f76 * f75);
            f78 = Math_fround(HEAPF32[i12 + 32 >> 2]);
            f77 = Math_fround(f77 - Math_fround(f9 * f78));
            f78 = Math_fround(Math_fround(f9 * f75) + Math_fround(f76 * f78));
            f77 = Math_fround(Math_fround(HEAPF32[i12 + 44 >> 2]) - f77);
            f78 = Math_fround(Math_fround(HEAPF32[i12 + 48 >> 2]) - f78);
            HEAPF32[i12 + 12 >> 2] = f77;
            HEAPF32[i12 + 16 >> 2] = f78;
            break;
           }
           HEAP32[i10 >> 2] = i5 | 1;
           HEAP32[i59 >> 2] = i7 + 1;
           HEAP32[i20 + (i7 << 2) >> 2] = i8;
           i5 = HEAPU16[i6 >> 1] | 0;
           if (i5 & 1 | 0) break;
           HEAP16[i6 >> 1] = i5 | 1;
           if ((i5 & 2 | 0) == 0 & (HEAP32[i12 >> 2] | 0) != 0) {
            HEAP16[i6 >> 1] = i5 | 3;
            HEAPF32[i12 + 144 >> 2] = Math_fround(0.0);
           }
           HEAP32[i12 + 8 >> 2] = i3;
           HEAP32[i21 + (i3 << 2) >> 2] = i12;
           i3 = i3 + 1 | 0;
           HEAP32[i58 >> 2] = i3;
          } while (0);
         }
        } while (0);
        i1 = HEAP32[i1 + 12 >> 2] | 0;
       } while ((i1 | 0) != 0);
      }
     } while (0);
     i1 = i14 + 1 | 0;
     if ((i1 | 0) == 2) break;
     i14 = i1;
     i5 = HEAP32[i71 + (i1 << 2) >> 2] | 0;
    }
    f78 = Math_fround(Math_fround(1.0) - f15);
    f78 = Math_fround(f78 * Math_fround(HEAPF32[i54 >> 2]));
    HEAPF32[i72 >> 2] = f78;
    HEAPF32[i48 >> 2] = Math_fround(Math_fround(1.0) / f78);
    HEAPF32[i49 >> 2] = Math_fround(1.0);
    HEAP32[i50 >> 2] = 20;
    HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
    HEAP8[i53 >> 0] = 0;
    __ZN8b2Island8SolveTOIERK10b2TimeStepii(i68, i72, HEAP32[i18 >> 2] | 0, HEAP32[i19 >> 2] | 0);
    if ((i3 | 0) > 0) {
     i8 = HEAP32[i58 >> 2] | 0;
     i7 = 0;
     do {
      i3 = HEAP32[i21 + (i7 << 2) >> 2] | 0;
      i31 = i3 + 4 | 0;
      HEAP16[i31 >> 1] = HEAPU16[i31 >> 1] & 65534;
      if ((HEAP32[i3 >> 2] | 0) == 2) {
       f76 = Math_fround(HEAPF32[i3 + 52 >> 2]);
       f15 = Math_fround(+Math_sin(+f76));
       HEAPF32[i34 >> 2] = f15;
       f76 = Math_fround(+Math_cos(+f76));
       HEAPF32[i35 >> 2] = f76;
       f75 = Math_fround(HEAPF32[i3 + 28 >> 2]);
       f77 = Math_fround(f76 * f75);
       f78 = Math_fround(HEAPF32[i3 + 32 >> 2]);
       f77 = Math_fround(f77 - Math_fround(f15 * f78));
       f78 = Math_fround(Math_fround(f15 * f75) + Math_fround(f76 * f78));
       f77 = Math_fround(Math_fround(HEAPF32[i3 + 36 >> 2]) - f77);
       f78 = Math_fround(Math_fround(HEAPF32[i3 + 40 >> 2]) - f78);
       HEAPF32[i61 >> 2] = f77;
       HEAPF32[i32 >> 2] = f78;
       i5 = (HEAP32[i3 + 88 >> 2] | 0) + 102872 | 0;
       i1 = HEAP32[i3 + 100 >> 2] | 0;
       if (i1 | 0) {
        i6 = i3 + 12 | 0;
        do {
         __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i1, i5, i61, i6);
         i1 = HEAP32[i1 + 24 >> 2] | 0;
        } while ((i1 | 0) != 0);
       }
       i1 = HEAP32[i3 + 112 >> 2] | 0;
       if (i1 | 0) do {
        i31 = (HEAP32[i1 + 4 >> 2] | 0) + 4 | 0;
        HEAP32[i31 >> 2] = HEAP32[i31 >> 2] & -34;
        i1 = HEAP32[i1 + 12 >> 2] | 0;
       } while ((i1 | 0) != 0);
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (i8 | 0));
    }
    __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i73, i73);
    if (HEAP8[i33 >> 0] | 0) break;
   } else {
    HEAP32[i6 >> 2] = i1 & -37;
    i31 = i7;
    i6 = i69;
    i30 = i31 + 36 | 0;
    do {
     HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
     i31 = i31 + 4 | 0;
     i6 = i6 + 4 | 0;
    } while ((i31 | 0) < (i30 | 0));
    i31 = i8;
    i6 = i70;
    i30 = i31 + 36 | 0;
    do {
     HEAP32[i31 >> 2] = HEAP32[i6 >> 2];
     i31 = i31 + 4 | 0;
     i6 = i6 + 4 | 0;
    } while ((i31 | 0) < (i30 | 0));
    f75 = Math_fround(HEAPF32[i12 >> 2]);
    f78 = Math_fround(+Math_sin(+f75));
    HEAPF32[i13 >> 2] = f78;
    f75 = Math_fround(+Math_cos(+f75));
    HEAPF32[i16 >> 2] = f75;
    f77 = Math_fround(HEAPF32[i17 >> 2]);
    f15 = Math_fround(f75 * f77);
    f76 = Math_fround(HEAPF32[i18 >> 2]);
    f15 = Math_fround(f15 - Math_fround(f78 * f76));
    f76 = Math_fround(Math_fround(f78 * f77) + Math_fround(f75 * f76));
    f15 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f15);
    f76 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f76);
    HEAPF32[i19 >> 2] = f15;
    HEAPF32[i3 >> 2] = f76;
    f76 = Math_fround(HEAPF32[i22 >> 2]);
    f15 = Math_fround(+Math_sin(+f76));
    HEAPF32[i23 >> 2] = f15;
    f76 = Math_fround(+Math_cos(+f76));
    HEAPF32[i24 >> 2] = f76;
    f75 = Math_fround(HEAPF32[i25 >> 2]);
    f77 = Math_fround(f76 * f75);
    f78 = Math_fround(HEAPF32[i26 >> 2]);
    f77 = Math_fround(f77 - Math_fround(f15 * f78));
    f78 = Math_fround(Math_fround(f15 * f75) + Math_fround(f76 * f78));
    f77 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f77);
    f78 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f78);
    HEAPF32[i27 >> 2] = f77;
    HEAPF32[i5 >> 2] = f78;
   }
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) break L11;
  }
  HEAP8[i67 >> 0] = 0;
  i71 = i20;
  i73 = i21;
  i72 = HEAP32[i68 >> 2] | 0;
  i70 = HEAP32[i66 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i72, i70);
  i70 = HEAP32[i65 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i72, i70);
  i70 = HEAP32[i64 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i72, i70);
  __ZN16b2StackAllocator4FreeEPv(i72, i71);
  __ZN16b2StackAllocator4FreeEPv(i72, i73);
  STACKTOP = i74;
  return;
 } while (0);
 HEAP8[i67 >> 0] = 1;
 i71 = HEAP32[i63 >> 2] | 0;
 i73 = HEAP32[i62 >> 2] | 0;
 i72 = HEAP32[i68 >> 2] | 0;
 i70 = HEAP32[i66 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i72, i70);
 i70 = HEAP32[i65 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i72, i70);
 i70 = HEAP32[i64 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i72, i70);
 __ZN16b2StackAllocator4FreeEPv(i72, i71);
 __ZN16b2StackAllocator4FreeEPv(i72, i73);
 STACKTOP = i74;
 return;
}

function __ZN12TreeRenderer6RenderER6CameraRKNSt3__26vectorIP5Light13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEfffii(i81, i29, i24, f7, f5, f6, i1, i79) {
 i81 = i81 | 0;
 i29 = i29 | 0;
 i24 = i24 | 0;
 f7 = Math_fround(f7);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i1 = i1 | 0;
 i79 = i79 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i80 = 0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, i89 = 0, f90 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i62 = i80 + 72 | 0;
 i77 = i80 + 8 | 0;
 i78 = i80 + 552 | 0;
 i14 = i80 + 432 | 0;
 i15 = i80 + 420 | 0;
 i63 = i80 + 408 | 0;
 i64 = i80 + 388 | 0;
 i65 = i80 + 368 | 0;
 i19 = i80 + 304 | 0;
 i20 = i80 + 240 | 0;
 i21 = i80 + 536 | 0;
 i25 = i80 + 532 | 0;
 i26 = i80 + 528 | 0;
 i28 = i80;
 i66 = i80 + 236 | 0;
 i67 = i80 + 232 | 0;
 i68 = i80 + 228 | 0;
 i69 = i80 + 224 | 0;
 i70 = i80 + 220 | 0;
 i71 = i80 + 216 | 0;
 i72 = i80 + 212 | 0;
 i30 = i80 + 208 | 0;
 i73 = i80 + 184 | 0;
 i74 = i80 + 168 | 0;
 i75 = i80 + 104 | 0;
 i76 = i80 + 88 | 0;
 i22 = HEAP32[gb + 1166248 >> 2] | 0;
 if (!(HEAP32[i81 >> 2] | 0)) {
  STACKTOP = i80;
  return;
 }
 i1 = i81 + 232 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  __ZN12TreeRenderer23UpdateWindAssetPointersEv(i81);
  __ZN12TreeRenderer28UpdateBillboardAssetPointersEv(i81);
  __ZN12TreeRenderer24UpdateLegacyMeshPointersEv(i81);
 } else {
  __ZN12TreeRenderer14ClearRenderersEv(i81);
  __ZN12TreeRenderer17PopulateRenderersEv(i81);
  HEAP8[i1 >> 0] = 0;
 }
 f61 = Math_fround(HEAPF32[(__Z18GetLODGroupManagerv() | 0) + 24 >> 2]);
 HEAPF32[i81 + 328 >> 2] = Math_fround(f61 * Math_fround(HEAPF32[i81 + 360 >> 2]));
 HEAP32[i81 + 332 >> 2] = HEAP32[(__Z18GetLODGroupManagerv() | 0) + 28 >> 2];
 HEAP32[i81 + 336 >> 2] = HEAP32[(__Z18GetLODGroupManagerv() | 0) + 32 >> 2];
 i2 = i81 + 132 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i79 | 0)) {
  i3 = HEAP32[i81 + 412 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i81 + 400 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i4 + (i1 * 24 | 0) + 4 >> 2] = i79;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 HEAP32[i2 >> 2] = i79;
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(__ZNK6Camera20GetWorldToClipMatrixEv(i29) | 0, i14);
 i10 = i81 + 148 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i1 = i81 + 156 | 0;
  i2 = i81 + 172 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i81 + 160 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i81 + 168 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 } else {
  f60 = f7 < f5 ? f7 : f5;
  f61 = Math_fround(f7 - f60);
  i59 = f6 < Math_fround(0.0);
  f61 = i59 ? Math_fround(0.0) : f61 < f6 ? f61 : f6;
  f5 = Math_fround(f7 * f7);
  f60 = Math_fround(f60 + f61);
  f6 = Math_fround(f60 * f60);
  i59 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i29 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  __ZNK9Transform11GetPositionEv(i15, i59);
  __ZNK9Transform18TransformDirectionERK8Vector3f(i63, i59, gb + 62548 | 0);
  i59 = __Z19GetActiveColorSpacev() | 0;
  i1 = i81 + 200 | 0;
  if ((i59 | 0) == (HEAP32[i1 >> 2] | 0)) i8 = i81 + 176 | 0; else {
   HEAP32[i1 >> 2] = __Z19GetActiveColorSpacev() | 0;
   i8 = i81 + 176 | 0;
   i9 = i81 + 188 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) {
    i4 = 0;
    do {
     i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     i3 = i2 + 60 | 0;
     if (HEAP32[i3 >> 2] | 0) {
      i1 = i2 + 48 | 0;
      __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
      HEAP32[i1 >> 2] = 0;
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i9 >> 2] | 0;
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i1 >>> 0);
   }
   i1 = i81 + 192 | 0;
   if ((HEAP32[i1 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i81 + 180 | 0);
    HEAP32[i8 >> 2] = 0;
   }
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i59 = i81 + 152 | 0;
   __Z19DestroySingleObjectP6Object(HEAP32[i59 >> 2] | 0);
   HEAP32[i59 >> 2] = 0;
  }
  __ZN13dynamic_arrayIP14TreeBinaryTreeLj4EEC2ERKS2_(i64, i8);
  i9 = i64 + 12 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i64 >> 2] | 0;
   i1 = 0;
   do {
    i4 = (HEAP32[i3 + (i1 << 2) >> 2] | 0) + 60 | 0;
    if ((HEAP32[i4 >> 2] | 0) == 1) HEAP32[i4 >> 2] = -1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  i1 = i81 + 192 | 0;
  i13 = i81 + 176 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i81 + 180 | 0);
   HEAP32[i13 >> 2] = 0;
  }
  HEAP32[i13 >> 2] = 0;
  i12 = i81 + 188 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i57 = i81 + 168 | 0;
  HEAP32[i57 >> 2] = 0;
  i59 = gb + 64016 | 0;
  i58 = HEAP32[i59 + 4 >> 2] | 0;
  i11 = i77;
  HEAP32[i11 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i11 + 4 >> 2] = i58;
  HEAP32[i65 >> 2] = 0;
  i11 = i65 + 12 | 0;
  HEAP32[i11 >> 2] = 0;
  i58 = i65 + 16 | 0;
  HEAP32[i58 >> 2] = 0;
  i59 = i65 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i62, i77);
  i55 = i62;
  i56 = HEAP32[i55 + 4 >> 2] | 0;
  i1 = i59;
  HEAP32[i1 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i1 + 4 >> 2] = i56;
  __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i81, HEAP32[i10 >> 2] | 0, i14, i65, i15, f6, f5);
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i4 = 0;
   do {
    i2 = HEAP32[(HEAP32[i64 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i3 = i2 + 60 | 0;
    if ((HEAP32[i3 >> 2] | 0) == -1) {
     i1 = i2 + 48 | 0;
     __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
     HEAP32[i1 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i9 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i1 >>> 0);
  }
  i56 = HEAP32[i65 >> 2] | 0;
  i2 = i56 + (HEAP32[i11 >> 2] << 2) | 0;
  HEAP32[i62 >> 2] = (HEAP32[i81 >> 2] | 0) + 16;
  __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_(i56, i2, i62);
  i2 = HEAP32[i24 >> 2] | 0;
  i56 = (HEAP32[i24 + 4 >> 2] | 0) - i2 | 0;
  i4 = i56 >> 2;
  i3 = (i4 | 0) > 4 ? 4 : i4;
  L53 : do if ((i56 | 0) > 0) {
   i8 = i21 + 4 | 0;
   i9 = i21 + 8 | 0;
   i10 = i21 + 12 | 0;
   i1 = 0;
   while (1) {
    i56 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
    __ZNK9Transform11GetRotationEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i56 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f82 = Math_fround(HEAPF32[i21 >> 2]);
    f85 = Math_fround(-f82);
    f84 = Math_fround(HEAPF32[i8 >> 2]);
    f83 = Math_fround(-f84);
    f27 = Math_fround(HEAPF32[i9 >> 2]);
    f87 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
    f82 = Math_fround(f82 * Math_fround(-2.0));
    f84 = Math_fround(f84 * Math_fround(-2.0));
    f23 = Math_fround(f27 * Math_fround(-2.0));
    f16 = Math_fround(f82 * f85);
    f54 = Math_fround(f84 * f83);
    f27 = Math_fround(f27 * f23);
    f88 = Math_fround(f84 * f85);
    f85 = Math_fround(f23 * f85);
    f83 = Math_fround(f23 * f83);
    f82 = Math_fround(f82 * f87);
    f84 = Math_fround(f84 * f87);
    f87 = Math_fround(f23 * f87);
    f23 = Math_fround(Math_fround(1.0) - Math_fround(f54 - f27));
    f86 = Math_fround(HEAPF32[gb + 62548 >> 2]);
    f23 = Math_fround(f86 * f23);
    f17 = Math_fround(f88 - f87);
    f7 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
    f23 = Math_fround(Math_fround(f17 * f7) + f23);
    f17 = Math_fround(f85 + f84);
    f18 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
    f27 = Math_fround(-Math_fround(Math_fround(Math_fround(f83 - f82) * f18) + Math_fround(Math_fround(f86 * Math_fround(f88 + f87)) + Math_fround(f7 * Math_fround(Math_fround(1.0) - Math_fround(f16 - f27))))));
    f54 = Math_fround(-Math_fround(Math_fround(Math_fround(f86 * Math_fround(f85 - f84)) + Math_fround(Math_fround(f83 + f82) * f7)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f16 + f54)) * f18)));
    HEAPF32[i19 + (i1 << 4) >> 2] = Math_fround(-Math_fround(Math_fround(f17 * f18) + f23));
    HEAPF32[i19 + (i1 << 4) + 4 >> 2] = f27;
    HEAPF32[i19 + (i1 << 4) + 8 >> 2] = f54;
    HEAPF32[i19 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
    _memmove(i20 + (i1 << 4) | 0, (HEAP32[i56 + 44 >> 2] | 0) + 156 | 0, 16) | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) break L53;
    i2 = HEAP32[i24 >> 2] | 0;
   }
  } while (0);
  if (i3 >>> 0 < 4) {
   i56 = (((i4 | 0) < 4 ? i4 : 4) << 4 ^ -16) + 80 | 0;
   _memset(i19 + (i3 << 4) | 0, 0, i56 | 0) | 0;
   _memset(i20 + (i3 << 4) | 0, 0, i56 | 0) | 0;
  }
  i4 = i22 + 36 | 0;
  __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i4, gb + 1467476 | 0, 1, i19, 16, 4) | 0;
  __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i4, gb + 1467480 | 0, 1, i20, 16, 4) | 0;
  i4 = i81 + 196 | 0;
  if (__ZN21ImposterRenderTexture15UpdateImpostersERK6Camera(HEAP32[i4 >> 2] | 0, i29) | 0) {
   i1 = i81 + 4 | 0;
   i56 = HEAP32[i1 >> 2] | 0;
   HEAP32[i25 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(i25, gb + 1046318 | 0);
   HEAP32[i62 >> 2] = HEAP32[i25 >> 2];
   if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i56, i62) | 0) {
    i55 = HEAP32[i1 >> 2] | 0;
    HEAP32[i26 >> 2] = -1;
    __ZN9ShaderLab16FastPropertyName4InitEPKc(i26, gb + 1046318 | 0);
    i56 = HEAP32[i4 >> 2] | 0;
    i56 = HEAP32[((HEAP8[i56 + 36 >> 0] | 0) == 0 ? i56 + 20 | 0 : i56 + 24 | 0) >> 2] | 0;
    HEAP32[i62 >> 2] = HEAP32[i26 >> 2];
    __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i55, i62, i56);
   }
  }
  __ZN12TreeRenderer17UpdateShaderPropsERK6Cameraf(i81, i29, f5);
  if (HEAP32[i12 >> 2] | 0) {
   i2 = i81 + 4 | 0;
   i3 = i81 + 8 | 0;
   i1 = 0;
   do {
    i56 = HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 48 >> 2] | 0;
    i55 = HEAP32[i2 >> 2] | 0;
    __ZN10Matrix4x4f11SetIdentityEv(i77) | 0;
    HEAP32[i78 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i62 >> 2] = HEAP32[i78 >> 2];
    __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(__Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i77, i56, i62, i79, 1, 1, 0, i29) | 0, i3);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
  }
  if (HEAP32[i11 >> 2] | 0) {
   i2 = i81 + 152 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i55 = gb + 63520 | 0;
    i56 = HEAP32[i55 + 4 >> 2] | 0;
    i1 = i28;
    HEAP32[i1 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i1 + 4 >> 2] = i56;
    HEAP32[i62 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i62 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
    i1 = __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId(4, i62) | 0;
    HEAP32[i2 >> 2] = i1;
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
    __ZN4Mesh11MarkDynamicEv(HEAP32[i2 >> 2] | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   __ZN12TreeRenderer21GenerateBillboardMeshER4MeshRK13dynamic_arrayIjLj4EEb(i81, i1, i65, 1);
   i56 = HEAP32[i2 >> 2] | 0;
   i55 = HEAP32[i81 + 4 >> 2] | 0;
   __ZN10Matrix4x4f11SetIdentityEv(i77) | 0;
   HEAP32[i78 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i62 >> 2] = HEAP32[i78 >> 2];
   __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(__Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i77, i56, i62, i79, 1, 1, 0, i29) | 0, i81 + 8 | 0);
  }
  i55 = __Z14GetTimeManagerv() | 0;
  f5 = Math_fround(+HEAPF64[i55 + 96 >> 3] + +HEAPF64[i55 + 168 >> 3]);
  HEAP32[i66 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i66, gb + 933893 | 0);
  HEAP32[i67 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i67, gb + 934650 | 0);
  HEAP32[i68 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i68, gb + 934669 | 0);
  HEAP32[i69 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i69, gb + 934688 | 0);
  HEAP32[i70 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i70, gb + 934707 | 0);
  HEAP32[i71 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i71, gb + 936464 | 0);
  HEAPF32[i72 >> 2] = Math_fround(1.0);
  __ZNK21ImposterRenderTexture18GetBillboardParamsERfS0_(HEAP32[i4 >> 2] | 0, i30, i72);
  i55 = i81 + 236 | 0;
  i11 = HEAP32[i81 >> 2] | 0;
  i8 = i11 + 16 | 0;
  i56 = i81 + 156 | 0;
  i10 = HEAP32[i56 >> 2] | 0;
  i53 = HEAP32[i57 >> 2] | 0;
  i9 = i10 + (i53 << 2) | 0;
  L77 : do if (!i53) {
   i1 = i10;
   i31 = 55;
  } else {
   i2 = HEAP32[i55 >> 2] | 0;
   i1 = i10;
   while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == -1) {
     i31 = 55;
     break L77;
    }
    if (Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + (i3 * 40 | 0) + 36 >> 2]) >= f6) {
     i31 = 55;
     break L77;
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
   }
  } while (0);
  L83 : do if ((i31 | 0) == 55) if ((i1 | 0) == (i9 | 0)) i1 = i9; else {
   i2 = i1 + 4 | 0;
   if ((i2 | 0) != (i9 | 0)) {
    i4 = HEAP32[i55 >> 2] | 0;
    do {
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if ((HEAP32[i4 + (i3 << 2) >> 2] | 0) != -1) if (!(Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + (i3 * 40 | 0) + 36 >> 2]) >= f6)) break;
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i9 | 0)) break L83;
     }
     HEAP32[i1 >> 2] = i3;
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i9 | 0));
   }
  } while (0);
  i53 = HEAP32[i57 >> 2] | 0;
  i53 = i53 - (i10 + (i53 << 2) - i1 >> 2) | 0;
  HEAP32[i57 >> 2] = i53;
  L96 : do if (i53 | 0) {
   i48 = i81 + 256 | 0;
   i49 = f61 < Math_fround(0.0);
   f54 = Math_fround(-f61);
   i49 = !((i49 ? f54 : f61) <= Math_fround(9.99999997e-07));
   i37 = i81 + 136 | 0;
   i38 = i81 + 140 | 0;
   i39 = i81 + 144 | 0;
   i40 = i81 + 120 | 0;
   i41 = i81 + 124 | 0;
   i42 = i81 + 128 | 0;
   i45 = i73 + 4 | 0;
   i47 = i73 + 8 | 0;
   i43 = i73 + 12 | 0;
   i44 = i73 + 16 | 0;
   i46 = i73 + 20 | 0;
   i50 = i74 + 4 | 0;
   i51 = i74 + 8 | 0;
   i52 = i74 + 12 | 0;
   i53 = i62 + 8 | 0;
   f54 = Math_fround(f5 * Math_fround(4.69999981));
   f27 = Math_fround(f5 * Math_fround(4.30000019));
   i15 = i62 + 12 | 0;
   i19 = i78 + 4 | 0;
   i20 = i78 + 8 | 0;
   i21 = i77 + 12 | 0;
   i22 = i77 + 8 | 0;
   i24 = i77 + 4 | 0;
   i25 = i78 + 4 | 0;
   i26 = i78 + 8 | 0;
   i28 = i78 + 12 | 0;
   i29 = i63 + 4 | 0;
   i30 = i63 + 8 | 0;
   i31 = i62 + 4 | 0;
   i32 = i62 + 8 | 0;
   i33 = i62 + 12 | 0;
   i34 = i62 + 4 | 0;
   i35 = i62 + 8 | 0;
   i36 = i62 + 12 | 0;
   i1 = 0;
   i2 = i10;
   i3 = i11;
   while (1) {
    i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
    i4 = HEAP32[i3 + 16 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i55 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i12 = HEAP32[i48 >> 2] | 0;
    i13 = HEAP32[i12 + (i11 * 24 | 0) >> 2] | 0;
    i14 = HEAP32[i4 + (i2 * 40 | 0) + 32 >> 2] | 0;
    i3 = HEAP32[i3 + 28 >> 2] | 0;
    if (i49) {
     f5 = Math_fround(Math_fround(f60 - Math_fround(Math_sqrt(Math_fround(HEAPF32[i4 + (i2 * 40 | 0) + 36 >> 2])))) / f61);
     i10 = f5 < Math_fround(0.0);
     i9 = f5 > Math_fround(1.0);
     f5 = i9 ? Math_fround(1.0) : f5;
     f5 = i10 ? Math_fround(0.0) : f5;
     f5 = Math_fround(Math_fround(f5 * Math_fround(f5 * Math_fround(3.0))) + Math_fround(f5 * Math_fround(f5 * Math_fround(f5 * Math_fround(-2.0)))));
     f5 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(0.0)));
    } else f5 = Math_fround(1.0);
    f23 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(.0399999991)));
    i8 = f5 >= Math_fround(1.0);
    f18 = Math_fround(HEAPF32[i37 >> 2]);
    f6 = Math_fround(HEAPF32[i38 >> 2]);
    f16 = Math_fround(HEAPF32[i39 >> 2]);
    f86 = Math_fround(HEAPF32[i40 >> 2]);
    f87 = Math_fround(HEAPF32[i41 >> 2]);
    f88 = Math_fround(HEAPF32[i42 >> 2]);
    f86 = Math_fround(f86 * Math_fround(HEAPF32[i4 + (i2 * 40 | 0) >> 2]));
    f87 = Math_fround(f87 * Math_fround(HEAPF32[i4 + (i2 * 40 | 0) + 4 >> 2]));
    f86 = Math_fround(f18 + f86);
    f87 = Math_fround(f6 + f87);
    f88 = Math_fround(f16 + Math_fround(f88 * Math_fround(HEAPF32[i4 + (i2 * 40 | 0) + 8 >> 2])));
    i9 = i4 + (i2 * 40 | 0) + 12 | 0;
    f16 = Math_fround(HEAPF32[i9 >> 2]);
    i10 = i4 + (i2 * 40 | 0) + 16 | 0;
    f6 = Math_fround(HEAPF32[i10 >> 2]);
    f18 = Math_fround(f16 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 32 >> 2]));
    f6 = Math_fround(f6 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 36 >> 2]));
    f16 = Math_fround(f16 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 40 >> 2]));
    HEAPF32[i73 >> 2] = f86;
    HEAPF32[i45 >> 2] = f87;
    HEAPF32[i47 >> 2] = f88;
    HEAPF32[i43 >> 2] = f18;
    HEAPF32[i44 >> 2] = f6;
    HEAPF32[i46 >> 2] = f16;
    i89 = HEAP32[i4 + (i2 * 40 | 0) + 24 >> 2] | 0;
    i4 = HEAP32[i4 + (i2 * 40 | 0) + 28 >> 2] | 0;
    i2 = i89 >>> 8;
    f16 = Math_fround(Math_fround(((Math_imul((i4 >>> 8 & 255) + 1 | 0, i2 & 255) | 0) & 65535) >>> 8 & 255) / Math_fround(255.0));
    f6 = Math_fround(Math_fround((Math_imul((i4 >>> 16 & 255) + 1 | 0, i89 & 16711680) | 0) >>> 24 & 255) / Math_fround(255.0));
    f18 = Math_fround(Math_fround((Math_imul((i4 >>> 24) + 1 | 0, i2 & 16711680) | 0) >>> 24 & 255) / Math_fround(255.0));
    HEAPF32[i74 >> 2] = Math_fround(Math_fround((Math_imul((i4 & 255) + 1 | 0, i89 & 255) | 0) >>> 8 & 255) / Math_fround(255.0));
    HEAPF32[i50 >> 2] = f16;
    HEAPF32[i51 >> 2] = f6;
    HEAPF32[i52 >> 2] = f18;
    f18 = Math_fround(f5 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 152 >> 2]));
    __ZN11WindManager16ComputeWindForceERK4AABB(i62, __ZN11WindManager11GetInstanceEv() | 0, i73);
    f5 = Math_fround(HEAPF32[i53 >> 2]);
    f6 = Math_fround(HEAPF32[i62 >> 2]);
    f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)) + Math_fround(f6 * f6))));
    if (f16 > Math_fround(9.99999974e-06)) {
     f17 = f16;
     f7 = Math_fround(f5 / f16);
     f6 = Math_fround(Math_fround(-f6) / f16);
     f5 = Math_fround(Math_fround(0.0) / f16);
    } else {
     f17 = Math_fround(0.0);
     f7 = f5;
     f6 = Math_fround(1.0);
     f5 = Math_fround(0.0);
    }
    f83 = Math_fround(HEAPF32[i73 >> 2]);
    f83 = Math_fround(Math_fround(Math_fround(Math_fround(__ZN11PerlinNoise5NoiseEff(Math_fround(Math_fround(f83 * Math_fround(.219999999)) - f54), Math_fround(f83 * Math_fround(9.00500011)))) + Math_fround(.689999997)) / Math_fround(1.48300004)) * Math_fround(.699999988));
    f90 = Math_fround(HEAPF32[i47 >> 2]);
    f90 = Math_fround(Math_fround(Math_fround(Math_fround(__ZN11PerlinNoise5NoiseEff(Math_fround(Math_fround(f90 * Math_fround(.219999999)) - f27), Math_fround(f90 * Math_fround(9.00500011)))) + Math_fround(.689999997)) / Math_fround(1.48300004)) * Math_fround(.5));
    f82 = Math_fround(f18 * Math_fround(.0174532924));
    f82 = Math_fround(f82 * Math_fround(HEAPF32[i15 >> 2]));
    f84 = Math_fround(f82 * Math_fround(0.0));
    f90 = Math_fround(f90 * f82);
    HEAPF32[i78 >> 2] = Math_fround(f83 * f82);
    HEAPF32[i19 >> 2] = f84;
    HEAPF32[i20 >> 2] = f90;
    __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i77, i78, 4);
    f90 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * Math_fround(7.0)) * Math_fround(.0174532924)) * f17) * Math_fround(.5));
    f84 = Math_fround(+Math_sin(+f90));
    f90 = Math_fround(+Math_cos(+f90));
    f17 = Math_fround(f7 * f84);
    f82 = Math_fround(f5 * f84);
    f84 = Math_fround(f6 * f84);
    f18 = Math_fround(HEAPF32[i77 >> 2]);
    f83 = Math_fround(f90 * f18);
    f16 = Math_fround(HEAPF32[i21 >> 2]);
    f83 = Math_fround(f83 + Math_fround(f17 * f16));
    f88 = Math_fround(HEAPF32[i22 >> 2]);
    f83 = Math_fround(f83 + Math_fround(f82 * f88));
    f85 = Math_fround(HEAPF32[i24 >> 2]);
    f86 = Math_fround(Math_fround(Math_fround(f84 * f18) + Math_fround(Math_fround(f82 * f16) + Math_fround(f90 * f85))) - Math_fround(f17 * f88));
    f87 = Math_fround(Math_fround(Math_fround(Math_fround(f84 * f16) + Math_fround(f90 * f88)) + Math_fround(f17 * f85)) - Math_fround(f82 * f18));
    f88 = Math_fround(Math_fround(Math_fround(Math_fround(f90 * f16) - Math_fround(f17 * f18)) - Math_fround(f82 * f85)) - Math_fround(f84 * f88));
    HEAPF32[i78 >> 2] = Math_fround(f83 - Math_fround(f84 * f85));
    HEAPF32[i25 >> 2] = f86;
    HEAPF32[i26 >> 2] = f87;
    HEAPF32[i28 >> 2] = f88;
    __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i75, gb + 1162364 | 0, i78, gb + 62512 | 0);
    HEAP32[i76 >> 2] = HEAP32[i62 >> 2];
    HEAP32[i76 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
    HEAP32[i76 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
    HEAP32[i76 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
    f88 = Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 144 >> 2]);
    f87 = Math_fround(HEAPF32[i9 >> 2]);
    f88 = Math_fround(Math_fround(f88 * f87) * Math_fround(.5));
    i2 = HEAP32[i63 >> 2] | 0;
    i4 = HEAP32[i29 >> 2] | 0;
    i9 = HEAP32[i30 >> 2] | 0;
    f86 = Math_fround(HEAPF32[i10 >> 2]);
    f85 = Math_fround(f87 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 44 >> 2]));
    f86 = Math_fround(f86 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 48 >> 2]));
    f87 = Math_fround(f87 * Math_fround(HEAPF32[i3 + (i14 * 156 | 0) + 52 >> 2]));
    i89 = HEAP32[i13 + 256 >> 2] | 0;
    __ZN19ShaderPropertySheet20ReservePropertyCountEj(i89, 6);
    __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i89, i66, i75, 0);
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i89, i67, i74, 1);
    HEAPF32[i62 >> 2] = f85;
    HEAPF32[i31 >> 2] = f86;
    HEAPF32[i32 >> 2] = f87;
    HEAPF32[i33 >> 2] = Math_fround(1.0);
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i89, i68, i62, 0);
    f88 = Math_fround(f88 * Math_fround(HEAPF32[i72 >> 2]));
    HEAP32[i62 >> 2] = i2;
    HEAP32[i34 >> 2] = i4;
    HEAP32[i35 >> 2] = i9;
    HEAPF32[i36 >> 2] = f88;
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i89, i69, i62, 0);
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i89, i70, f23, 0);
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i89, i71, i76, 0);
    __ZN19ShaderPropertySheet11ComputeHashEv(i89);
    i89 = i13 + 236 | 0;
    i14 = i8 & 1;
    i14 = i14 << 8 | i14 << 6 | (HEAPU16[i89 >> 1] | HEAPU8[i89 + 2 >> 0] << 16) & 16776767;
    HEAP16[i89 >> 1] = i14;
    HEAP8[i89 + 2 >> 0] = i14 >>> 16;
    HEAP32[i12 + (i11 * 24 | 0) + 4 >> 2] = i79;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[i57 >> 2] | 0) >>> 0) break L96;
    i2 = HEAP32[i56 >> 2] | 0;
    i3 = HEAP32[i81 >> 2] | 0;
   }
  } while (0);
  if ((HEAP32[i58 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i65 >> 2] | 0, i59);
   HEAP32[i65 >> 2] = 0;
  }
  if ((HEAP32[i64 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i64 >> 2] | 0, i64 + 4 | 0);
   HEAP32[i64 >> 2] = 0;
  }
 }
 STACKTOP = i80;
 return;
}

function __ZN5physx2Sc5SceneC2ERKNS_11PxSceneDescERNS_2Cm13EventProfilerE(i28, i27, i5) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i29 + 18 | 0;
 i15 = i29 + 4 | 0;
 i8 = i29 + 17 | 0;
 i16 = i29;
 i26 = i29 + 16 | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, 4115, gb + 710719 | 0, 43) | 0;
 if (!i1) i1 = 0; else {
  i24 = i1 + 19 & -16;
  HEAP32[i24 + -4 >> 2] = i24 - i1;
  i1 = i24;
 }
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = 128;
 i2 = 0;
 do {
  HEAP32[i1 + (i2 << 5) + 20 >> 2] = -1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 128);
 i23 = i28 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 0;
 HEAP32[i23 + 28 >> 2] = 0;
 i24 = i28 + 60 | 0;
 HEAP32[i24 >> 2] = 1;
 HEAPF32[i28 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i28 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[i28 + 72 >> 2] = Math_fround(0.0);
 HEAP32[i28 + 76 >> 2] = 1;
 i6 = i28 + 80 | 0;
 HEAP32[i28 + 100 >> 2] = 0;
 HEAP32[i28 + 104 >> 2] = 0;
 HEAP32[i28 + 108 >> 2] = 0;
 i1 = i28 + 192 | 0;
 i2 = i28 + 476 | 0;
 i3 = i28 + 480 | 0;
 HEAP32[i28 + 484 >> 2] = 0;
 i4 = i28 + 488 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i28 + 116 | 0;
 i7 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i3 >> 2] = i28 + 220;
 HEAP32[i4 >> 2] = 64;
 HEAP32[i28 + 492 >> 2] = 64;
 HEAP32[i28 + 496 >> 2] = 0;
 HEAP32[i28 + 500 >> 2] = 0;
 HEAP32[i28 + 504 >> 2] = 8192;
 HEAP32[i28 + 508 >> 2] = 0;
 HEAP32[i28 + 780 >> 2] = 0;
 HEAP8[i28 + 772 >> 0] = 1;
 HEAP32[i28 + 776 >> 2] = i28 + 516;
 HEAP32[i28 + 784 >> 2] = 64;
 HEAP32[i28 + 788 >> 2] = 32;
 HEAP32[i28 + 792 >> 2] = 0;
 HEAP32[i28 + 796 >> 2] = 0;
 HEAP32[i28 + 800 >> 2] = 8192;
 HEAP32[i28 + 804 >> 2] = 0;
 HEAP32[i28 + 1076 >> 2] = 0;
 HEAP8[i28 + 1068 >> 0] = 1;
 HEAP32[i28 + 1072 >> 2] = i28 + 812;
 HEAP32[i28 + 1080 >> 2] = 64;
 HEAP32[i28 + 1084 >> 2] = 21;
 HEAP32[i28 + 1088 >> 2] = 0;
 HEAP32[i28 + 1092 >> 2] = 0;
 HEAP32[i28 + 1096 >> 2] = 8192;
 HEAP32[i28 + 1100 >> 2] = 0;
 i19 = i28 + 1104 | 0;
 HEAP32[i19 >> 2] = 0;
 i21 = i28 + 1124 | 0;
 i22 = i28 + 1128 | 0;
 i20 = i27 + 100 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 20 >> 2] = 0;
 i17 = HEAP16[i20 >> 1] | 0;
 HEAP8[i28 + 1150 >> 0] = (i17 & 65535) >>> 14 & 1;
 i10 = i28 + 1152 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i28 + 1156 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i28 + 1160 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i28 + 1168 | 0;
 i6 = i5;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i13;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i28 + 1176 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i28 + 1188 >> 2] = 0;
 HEAP16[i28 + 1192 >> 1] = i17;
 i17 = i28 + 1208 | 0;
 HEAP32[i17 >> 2] = 0;
 i2 = i28 + 1236 | 0;
 i1 = i28 + 1264 | 0;
 HEAPF32[i28 + 1408 >> 2] = Math_fround(0.0);
 HEAP8[i28 + 1412 >> 0] = 0;
 HEAP32[i28 + 1416 >> 2] = 0;
 HEAP32[i28 + 1420 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i28 + 1452 >> 2] = HEAP32[i27 + 152 >> 2];
 __ZN5physx2Cm10FanoutTaskC2EPKc(i28 + 1456 | 0, gb + 710808 | 0);
 i1 = i28 + 1548 | 0;
 HEAP16[i28 + 1552 >> 1] = -1;
 HEAP16[i28 + 1554 >> 1] = 0;
 HEAP32[i28 + 1556 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 1560 >> 2] = 0;
 HEAP32[i28 + 1564 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 101856 + 8;
 HEAP32[i28 + 1568 >> 2] = i28;
 HEAP32[i28 + 1572 >> 2] = gb + 710826;
 i1 = i28 + 1576 | 0;
 HEAP16[i28 + 1580 >> 1] = -1;
 HEAP16[i28 + 1582 >> 1] = 0;
 HEAP32[i28 + 1584 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 1588 >> 2] = 0;
 HEAP32[i28 + 1592 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 101900 + 8;
 HEAP32[i28 + 1596 >> 2] = i28;
 HEAP32[i28 + 1600 >> 2] = gb + 710853;
 __ZN5physx2Cm10FanoutTaskC2EPKc(i28 + 1604 | 0, gb + 710877 | 0);
 i1 = i28 + 1696 | 0;
 __ZN5physx2Cm10FanoutTaskC2EPKc(i1, gb + 710906 | 0);
 HEAP32[i1 >> 2] = gb + 101944 + 8;
 HEAP32[i28 + 1788 >> 2] = i28;
 i1 = i28 + 1792 | 0;
 __ZN5physx2Cm10FanoutTaskC2EPKc(i1, gb + 710935 | 0);
 HEAP32[i1 >> 2] = gb + 101988 + 8;
 HEAP32[i28 + 1884 >> 2] = i28;
 i1 = i28 + 1888 | 0;
 HEAP16[i28 + 1892 >> 1] = -1;
 HEAP16[i28 + 1894 >> 1] = 0;
 HEAP32[i28 + 1896 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 1900 >> 2] = 0;
 HEAP32[i28 + 1904 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 102032 + 8;
 HEAP32[i28 + 1908 >> 2] = i28;
 HEAP32[i28 + 1912 >> 2] = gb + 710961;
 i1 = i28 + 1956 | 0;
 i2 = i28 + 1960 | 0;
 i6 = i28 + 1916 | 0;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP16[i2 >> 1] = -1;
 HEAP16[i28 + 1962 >> 1] = 0;
 HEAP32[i28 + 1964 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 1968 >> 2] = 0;
 HEAP32[i28 + 1972 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 102076 + 8;
 HEAP32[i28 + 1976 >> 2] = i28;
 HEAP32[i28 + 1980 >> 2] = gb + 710988;
 i9 = i28 + 1984 | 0;
 HEAP16[i28 + 1988 >> 1] = -1;
 HEAP16[i28 + 1990 >> 1] = 0;
 HEAP32[i28 + 1992 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 1996 >> 2] = 0;
 HEAP32[i28 + 2e3 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102120 + 8;
 HEAP32[i28 + 2004 >> 2] = i28;
 HEAP32[i28 + 2008 >> 2] = gb + 711007;
 i9 = i28 + 2012 | 0;
 HEAP16[i28 + 2016 >> 1] = -1;
 HEAP16[i28 + 2018 >> 1] = 0;
 HEAP32[i28 + 2020 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2024 >> 2] = 0;
 HEAP32[i28 + 2028 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102164 + 8;
 HEAP32[i28 + 2032 >> 2] = i28;
 HEAP32[i28 + 2036 >> 2] = gb + 711031;
 i9 = i28 + 2040 | 0;
 HEAP16[i28 + 2044 >> 1] = -1;
 HEAP16[i28 + 2046 >> 1] = 0;
 HEAP32[i28 + 2048 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2052 >> 2] = 0;
 HEAP32[i28 + 2056 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102208 + 8;
 HEAP32[i28 + 2060 >> 2] = i28;
 HEAP32[i28 + 2064 >> 2] = gb + 711063;
 i9 = i28 + 2068 | 0;
 HEAP16[i28 + 2072 >> 1] = -1;
 HEAP16[i28 + 2074 >> 1] = 0;
 HEAP32[i28 + 2076 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2080 >> 2] = 0;
 HEAP32[i28 + 2084 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102252 + 8;
 HEAP32[i28 + 2088 >> 2] = i28;
 HEAP32[i28 + 2092 >> 2] = gb + 711091;
 i9 = i28 + 2096 | 0;
 HEAP16[i28 + 2100 >> 1] = -1;
 HEAP16[i28 + 2102 >> 1] = 0;
 HEAP32[i28 + 2104 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2108 >> 2] = 0;
 HEAP32[i28 + 2112 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102296 + 8;
 HEAP32[i28 + 2116 >> 2] = i28;
 HEAP32[i28 + 2120 >> 2] = gb + 711114;
 i9 = i28 + 2124 | 0;
 HEAP16[i28 + 2128 >> 1] = -1;
 HEAP16[i28 + 2130 >> 1] = 0;
 HEAP32[i28 + 2132 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2136 >> 2] = 0;
 HEAP32[i28 + 2140 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102340 + 8;
 HEAP32[i28 + 2144 >> 2] = i28;
 HEAP32[i28 + 2148 >> 2] = gb + 711136;
 i9 = i28 + 2152 | 0;
 HEAP16[i28 + 2156 >> 1] = -1;
 HEAP16[i28 + 2158 >> 1] = 0;
 HEAP32[i28 + 2160 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2164 >> 2] = 0;
 HEAP32[i28 + 2168 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102384 + 8;
 HEAP32[i28 + 2172 >> 2] = i28;
 HEAP32[i28 + 2176 >> 2] = gb + 711154;
 i9 = i28 + 2180 | 0;
 __ZN5physx2Cm10FanoutTaskC2EPKc(i9, gb + 711183 | 0);
 HEAP32[i9 >> 2] = gb + 102428 + 8;
 HEAP32[i28 + 2272 >> 2] = i28;
 i9 = i28 + 2276 | 0;
 HEAP16[i28 + 2280 >> 1] = -1;
 HEAP16[i28 + 2282 >> 1] = 0;
 HEAP32[i28 + 2284 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2288 >> 2] = 0;
 HEAP32[i28 + 2292 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102472 + 8;
 HEAP32[i28 + 2296 >> 2] = i28;
 HEAP32[i28 + 2300 >> 2] = gb + 711206;
 i9 = i28 + 2304 | 0;
 HEAP16[i28 + 2308 >> 1] = -1;
 HEAP16[i28 + 2310 >> 1] = 0;
 HEAP32[i28 + 2312 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2316 >> 2] = 0;
 HEAP32[i28 + 2320 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102516 + 8;
 HEAP32[i28 + 2324 >> 2] = i28;
 HEAP32[i28 + 2328 >> 2] = gb + 711225;
 i9 = i28 + 2332 | 0;
 HEAP16[i28 + 2336 >> 1] = -1;
 HEAP16[i28 + 2338 >> 1] = 0;
 HEAP32[i28 + 2340 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i28 + 2344 >> 2] = 0;
 HEAP32[i28 + 2348 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 102560 + 8;
 HEAP32[i28 + 2352 >> 2] = i28;
 HEAP32[i28 + 2356 >> 2] = gb + 711243;
 i9 = i28 + 2360 | 0;
 __ZN5physx2Cm9FlushPoolC2Ej(i9, 16384);
 HEAP8[i28 + 2392 >> 0] = 0;
 HEAP32[i28 + 2396 >> 2] = 0;
 i6 = i28 + 168 | 0;
 i7 = i6 + 24 | 0;
 do {
  HEAP8[i6 >> 0] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i1 | 0, i18 | 0, 1012, (i3 ? gb + 711263 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 166) | 0;
 __ZN5physx2Sc16InteractionSceneC2ERNS0_5SceneE(i3, i28);
 i18 = i28 + 1204 | 0;
 HEAP32[i18 >> 2] = i3;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i1 | 0, i3 | 0, 188, (i4 ? gb + 711391 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 167) | 0;
 __ZN5physx2Sc8SimStatsC2Ev(i4);
 HEAP32[i28 + 1184 >> 2] = i4;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i3 | 0, i4 | 0, 40, (i1 ? gb + 711503 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 168) | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i28 + 1196 >> 2] = i1;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i4 | 0, i1 | 0, 40, (i3 ? gb + 711503 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 169) | 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i28 + 1200 >> 2] = i3;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, 12, gb + 680241 | 0, 171) | 0;
 HEAP32[i28 + 112 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i1 | 0, i3 | 0, 32, (i4 ? gb + 711629 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 174) | 0;
 HEAP32[i4 >> 2] = 64;
 HEAP32[i4 + 4 >> 2] = 60;
 i3 = i4 + 8 | 0;
 i1 = i4 + 12 | 0;
 i2 = i4 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 1;
 HEAP32[i4 + 28 >> 2] = gb + 711804;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, 3840, gb + 681700 | 0, 43) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 20 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = (HEAP32[i1 >> 2] | 0) + (i3 * 12 | 0) | 0;
  HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i15) | 0;
 i5 = i28 + 1216 | 0;
 HEAP32[i5 >> 2] = i4;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i2 | 0, i4 | 0, 32, (i1 ? gb + 711814 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 175) | 0;
 HEAP32[i1 >> 2] = 64;
 HEAP32[i1 + 4 >> 2] = 192;
 i4 = i1 + 8 | 0;
 i2 = i1 + 12 | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP8[i1 + 24 >> 0] = 1;
 HEAP32[i1 + 28 >> 2] = gb + 711985;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, 12288, gb + 681700 | 0, 43) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  i8 = (HEAP32[i2 >> 2] | 0) + (i4 * 12 | 0) | 0;
  HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i15) | 0;
 HEAP32[i28 + 1220 >> 2] = i1;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i3 | 0, i1 | 0, 32, (i2 ? gb + 711993 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 176) | 0;
 HEAP32[i2 >> 2] = 64;
 HEAP32[i2 + 4 >> 2] = 32;
 i1 = i2 + 8 | 0;
 i3 = i2 + 12 | 0;
 i4 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 1;
 HEAP32[i2 + 28 >> 2] = gb + 712166;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, 2048, gb + 681700 | 0, 43) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 20 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i14 = (HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) | 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 HEAP32[i28 + 1212 >> 2] = i2;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i15 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i15 | 0, i2 | 0, 296, (i1 ? gb + 712175 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 177) | 0;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP8[i1 + 260 >> 0] = 1;
 HEAP32[i1 + 264 >> 2] = i1 + 4;
 HEAP32[i1 + 272 >> 2] = 64;
 HEAP32[i1 + 276 >> 2] = 32;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 4096;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i28 + 1224 >> 2] = i1;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i15 = _PxGetFoundation() | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
 i15 = mftCall_iiiiii(i2 | 0, i1 | 0, 296, (i15 ? gb + 712466 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 178) | 0;
 HEAP32[i15 + 268 >> 2] = 0;
 HEAP8[i15 + 260 >> 0] = 1;
 HEAP32[i15 + 264 >> 2] = i15 + 4;
 HEAP32[i15 + 272 >> 2] = 64;
 HEAP32[i15 + 276 >> 2] = 32;
 HEAP32[i15 + 280 >> 2] = 0;
 HEAP32[i15 + 284 >> 2] = 0;
 HEAP32[i15 + 288 >> 2] = 1280;
 HEAP32[i15 + 292 >> 2] = 0;
 HEAP32[i28 + 1228 >> 2] = i15;
 i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i1 | 0, i15 | 0, 296, (i2 ? gb + 712789 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 180) | 0;
 HEAP32[i2 + 268 >> 2] = 0;
 HEAP8[i2 + 260 >> 0] = 1;
 HEAP32[i2 + 264 >> 2] = i2 + 4;
 HEAP32[i2 + 272 >> 2] = 64;
 HEAP32[i2 + 276 >> 2] = 32;
 HEAP32[i2 + 280 >> 2] = 0;
 HEAP32[i2 + 284 >> 2] = 0;
 HEAP32[i2 + 288 >> 2] = 2048;
 HEAP32[i2 + 292 >> 2] = 0;
 HEAP32[i28 + 1232 >> 2] = i2;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i15 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i15 | 0, i2 | 0, 24, (i1 ? gb + 707409 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 182) | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP32[i16 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i11 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i16) | 0;
 i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 i16 = _PxGetFoundation() | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
 i16 = mftCall_iiiiii(i14 | 0, i15 | 0, 380, (i16 ? gb + 713076 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 183) | 0;
 __ZN5physx2Sc27ConstraintProjectionManagerC2Ev(i16);
 HEAP32[i28 + 96 >> 2] = i16;
 i16 = __ZN5physx13PxTaskManager17createTaskManagerEPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE(HEAP32[i27 + 104 >> 2] | 0, HEAP32[i27 + 108 >> 2] | 0, HEAP32[i27 + 112 >> 2] | 0) | 0;
 HEAP32[i28 + 2388 >> 2] = i16;
 i15 = i28 + 1424 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 if (!(__ZN5physx2Sc16InteractionScene4initERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS7_13EventProfilerE(HEAP32[i18 >> 2] | 0, i27, i16, i9, i13) | 0)) {
  STACKTOP = i29;
  return;
 }
 __ZN5physx10PxsContext18setSolverBatchSizeEj(HEAP32[(HEAP32[i18 >> 2] | 0) + 1e3 >> 2] | 0, HEAP32[i27 + 132 >> 2] | 0);
 i6 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i6 + 6160 >> 2] = HEAP32[i27 + 80 >> 2];
 HEAP32[i6 + 6164 >> 2] = HEAP32[i27 + 88 >> 2];
 HEAP32[(HEAP32[i6 + 12 >> 2] | 0) + 144 >> 2] = HEAP32[i27 + 96 >> 2];
 HEAP32[i6 + 6168 >> 2] = HEAP32[HEAP32[gb + 1457332 >> 2] >> 2];
 __ZN5physx10PxsContext18setBounceThresholdEf(i6, Math_fround(-Math_fround(HEAPF32[i27 + 92 >> 2])));
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i7 = _PxGetFoundation() | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
 i7 = mftCall_iiiiii(i3 | 0, i6 | 0, 48, (i7 ? gb + 713226 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 211) | 0;
 __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE(i7, 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 1065353216;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP8[i6 + 12 >> 0] = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) {
    i25 = 23;
    break;
   }
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
  if (!i1) i1 = 0; else i25 = 23;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i25 = 23;
 } while (0);
 if ((i25 | 0) == 23) __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE(i1, i28, i7);
 HEAP32[i17 >> 2] = i1;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i25 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i25 | 0, i2 | 0, 2552, (i1 ? gb + 713342 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 215) | 0;
 __ZN5physx2Sc10NPhaseCoreC2ERNS0_5SceneERKNS_11PxSceneDescE(i1, i28, i27);
 HEAP32[i19 >> 2] = i1;
 i1 = 0;
 i2 = -2;
 while (1) {
  HEAP32[i28 + 1280 + (i1 << 2) >> 2] = ~i2;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break; else i2 = i2 << 1;
 }
 HEAP8[i28 + 1148 >> 0] = 1;
 HEAP8[i28 + 1149 >> 0] = 1;
 i2 = i27 + 48 | 0;
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i2 = HEAP32[i28 + 1152 >> 2] | 0;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] = HEAP32[i27 + 44 >> 2];
 HEAP32[i28 + 48 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i28 + 52 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i28 + 56 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i24 >> 2] = 1;
 i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i1 + 7600 >> 2] = HEAP32[i27 + 84 >> 2];
 i25 = HEAP16[i20 >> 1] | 0;
 HEAP8[i1 + 7604 >> 0] = (i25 & 65535) >>> 9 & 1;
 HEAP8[i1 + 7605 >> 0] = (i25 & 65535) >>> 11 & 1 ^ 1;
 i1 = HEAP32[i27 + 12 >> 2] | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + 16 | 0;
 if ((i1 | 0) != 0 & (HEAP32[i2 >> 2] | 0) == 0) if (HEAP32[i22 >> 2] | 0) {
  i3 = 0;
  do {
   i25 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i21 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) + 144 | 0;
   HEAP16[i25 >> 1] = HEAPU16[i25 >> 1] | 0 | 64;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i1 + 5908 >> 2] = HEAP32[i27 + 16 >> 2];
 __ZN5physx10PxsContext27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(i1, HEAP32[i27 + 20 >> 2] | 0);
 __ZN5physx10PxsContext15setCCDMaxPassesEj(HEAP32[(HEAP32[i18 >> 2] | 0) + 1e3 >> 2] | 0, HEAP32[i27 + 148 >> 2] | 0);
 i1 = i27 + 24 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i28 + 1108 >> 2] = 0;
  i1 = 0;
 } else {
  i25 = i27 + 28 | 0;
  i26 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26, HEAP32[i25 >> 2] | 0, gb + 680241 | 0, 247) | 0;
  HEAP32[i28 + 1108 >> 2] = i26;
  _memcpy(i26 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i25 >> 2] | 0) | 0;
  i1 = HEAP32[i25 >> 2] | 0;
 }
 HEAP32[i28 + 1112 >> 2] = i1;
 HEAP32[i28 + 1116 >> 2] = HEAP32[i27 + 32 >> 2];
 HEAP32[i28 + 1120 >> 2] = HEAP32[i27 + 36 >> 2];
 __ZN5physx2Sc5Scene17createClothSolverEv(i28);
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu23pcmContactCapsuleConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i6, i40, i7, i8, i5, i1, i66) {
 i6 = i6 | 0;
 i40 = i40 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i66 = i66 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i70 + 704 | 0;
 i44 = i70 + 624 | 0;
 i42 = i70 + 400 | 0;
 i57 = i70 + 384 | 0;
 i65 = i70 + 224 | 0;
 i68 = i70 + 192 | 0;
 i69 = i70 + 160 | 0;
 i55 = i70 + 640 | 0;
 i35 = i70 + 144 | 0;
 i50 = i70 + 128 | 0;
 i45 = i70 + 112 | 0;
 i52 = i70 + 96 | 0;
 i67 = i70 + 80 | 0;
 i43 = i70 + 736 | 0;
 i46 = i70 + 64 | 0;
 i41 = i70 + 48 | 0;
 i58 = i70 + 416 | 0;
 i56 = i70 + 240 | 0;
 i59 = i70 + 732 | 0;
 i47 = i70 + 720 | 0;
 i54 = i70 + 32 | 0;
 i53 = i70 + 16 | 0;
 i51 = i70;
 i64 = HEAP32[i1 >> 2] | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 i37 = i40 + 4 | 0;
 i38 = i40 + 8 | 0;
 i1 = HEAP32[i38 >> 2] | 0;
 i36 = i40 + 12 | 0;
 i34 = HEAP32[i36 >> 2] | 0;
 HEAP32[i42 >> 2] = HEAP32[i37 >> 2];
 i49 = i42 + 4 | 0;
 HEAP32[i49 >> 2] = i1;
 i1 = i42 + 8 | 0;
 HEAP32[i1 >> 2] = i34;
 HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i57 >> 2] = HEAP32[i5 >> 2];
 f13 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 HEAP32[i65 >> 2] = HEAP32[i6 + 4 >> 2];
 i34 = HEAP32[i40 + 36 >> 2] | 0;
 i24 = HEAP32[i7 + 4 >> 2] | 0;
 i23 = HEAP32[i7 + 8 >> 2] | 0;
 i21 = HEAP32[i7 + 12 >> 2] | 0;
 i29 = i7 + 16 | 0;
 i31 = HEAP32[i29 >> 2] | 0;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 i29 = HEAP32[i29 + 8 >> 2] | 0;
 HEAP32[i68 >> 2] = HEAP32[i7 >> 2];
 i25 = i68 + 4 | 0;
 HEAP32[i25 >> 2] = i24;
 i24 = i68 + 8 | 0;
 HEAP32[i24 >> 2] = i23;
 i23 = i68 + 12 | 0;
 HEAP32[i23 >> 2] = i21;
 HEAP32[i68 + 16 >> 2] = i31;
 HEAP32[i68 + 20 >> 2] = i30;
 HEAP32[i68 + 24 >> 2] = i29;
 HEAPF32[i68 + 28 >> 2] = Math_fround(0.0);
 i21 = HEAP32[i8 >> 2] | 0;
 i22 = HEAP32[i8 + 4 >> 2] | 0;
 i33 = HEAP32[i8 + 8 >> 2] | 0;
 i32 = HEAP32[i8 + 12 >> 2] | 0;
 i26 = i8 + 16 | 0;
 i28 = HEAP32[i26 >> 2] | 0;
 i27 = HEAP32[i26 + 4 >> 2] | 0;
 i26 = HEAP32[i26 + 8 >> 2] | 0;
 HEAP32[i69 >> 2] = i21;
 i61 = i69 + 4 | 0;
 HEAP32[i61 >> 2] = i22;
 i62 = i69 + 8 | 0;
 HEAP32[i62 >> 2] = i33;
 i63 = i69 + 12 | 0;
 HEAP32[i63 >> 2] = i32;
 HEAP32[i69 + 16 >> 2] = i28;
 HEAP32[i69 + 20 >> 2] = i27;
 HEAP32[i69 + 24 >> 2] = i26;
 HEAPF32[i69 + 28 >> 2] = Math_fround(0.0);
 f20 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f72 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(-f20);
 f72 = Math_fround(-f72);
 f12 = Math_fround(-f12);
 f4 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f71 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f74 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f71 = Math_fround(f4 - f71);
 f74 = Math_fround(f17 - f74);
 f48 = Math_fround(f48 - (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f71 * f20) + Math_fround(f74 * f72)) + Math_fround(f48 * f12));
 f2 = Math_fround(Math_fround(Math_fround(f4 * f20) + Math_fround(Math_fround(f17 * f71) + Math_fround(f16 * Math_fround(Math_fround(f48 * f72) - Math_fround(f74 * f12))))) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(Math_fround(f4 * f72) + Math_fround(Math_fround(f17 * f74) + Math_fround(f16 * Math_fround(Math_fround(f71 * f12) - Math_fround(f48 * f20))))) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f48) + Math_fround(f16 * Math_fround(Math_fround(f74 * f20) - Math_fround(f71 * f72)))) + Math_fround(f4 * f12)) * Math_fround(2.0));
 f71 = Math_fround(HEAPF32[i68 >> 2]);
 f74 = Math_fround(HEAPF32[i25 >> 2]);
 f48 = Math_fround(HEAPF32[i24 >> 2]);
 f17 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(Math_fround(f16 * f17) - Math_fround(Math_fround(Math_fround(f71 * f20) + Math_fround(f74 * f72)) + Math_fround(f48 * f12)));
 f10 = Math_fround(Math_fround(Math_fround(f48 * f72) - Math_fround(f74 * f12)) + Math_fround(Math_fround(f16 * f71) + Math_fround(f17 * f20)));
 f11 = Math_fround(Math_fround(Math_fround(f71 * f12) - Math_fround(f48 * f20)) + Math_fround(Math_fround(f16 * f74) + Math_fround(f17 * f72)));
 f12 = Math_fround(Math_fround(Math_fround(f74 * f20) - Math_fround(f71 * f72)) + Math_fround(Math_fround(f16 * f48) + Math_fround(f17 * f12)));
 i23 = i55 + 48 | 0;
 HEAPF32[i23 >> 2] = f2;
 i24 = i55 + 52 | 0;
 HEAPF32[i24 >> 2] = f3;
 i25 = i55 + 56 | 0;
 HEAPF32[i25 >> 2] = f4;
 HEAPF32[i55 + 60 >> 2] = Math_fround(0.0);
 f17 = Math_fround(f10 + f10);
 f48 = Math_fround(f11 + f11);
 f16 = Math_fround(f12 + f12);
 f72 = Math_fround(f11 * f48);
 f71 = Math_fround(f12 * f16);
 f20 = Math_fround(f11 * f17);
 f74 = Math_fround(f12 * f17);
 f18 = Math_fround(f9 * f17);
 f73 = Math_fround(f12 * f48);
 f48 = Math_fround(f9 * f48);
 f16 = Math_fround(f9 * f16);
 f17 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f17));
 f14 = Math_fround(f20 + f16);
 f15 = Math_fround(f74 - f48);
 f16 = Math_fround(f20 - f16);
 f20 = Math_fround(f17 - f71);
 f19 = Math_fround(f73 + f18);
 f48 = Math_fround(f74 + f48);
 f18 = Math_fround(f73 - f18);
 f17 = Math_fround(f17 - f72);
 HEAPF32[i55 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f72) - f71);
 i26 = i55 + 4 | 0;
 HEAPF32[i26 >> 2] = f14;
 i27 = i55 + 8 | 0;
 HEAPF32[i27 >> 2] = f15;
 HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
 i28 = i55 + 16 | 0;
 HEAPF32[i28 >> 2] = f16;
 i29 = i55 + 20 | 0;
 HEAPF32[i29 >> 2] = f20;
 i30 = i55 + 24 | 0;
 HEAPF32[i30 >> 2] = f19;
 HEAPF32[i55 + 28 >> 2] = Math_fround(0.0);
 i31 = i55 + 32 | 0;
 HEAPF32[i31 >> 2] = f48;
 i32 = i55 + 36 | 0;
 HEAPF32[i32 >> 2] = f18;
 i33 = i55 + 40 | 0;
 HEAPF32[i33 >> 2] = f17;
 HEAPF32[i55 + 44 >> 2] = Math_fround(0.0);
 f17 = Math_fround(HEAPF32[i34 + 52 >> 2]);
 f18 = Math_fround(HEAPF32[i34 + 56 >> 2]);
 f48 = Math_fround(HEAPF32[i34 + 60 >> 2]);
 f19 = Math_fround(HEAPF32[i42 >> 2]);
 f20 = Math_fround(HEAPF32[i49 >> 2]);
 f19 = Math_fround(f17 * f19);
 f20 = Math_fround(f18 * f20);
 f48 = Math_fround(f48 * Math_fround(HEAPF32[i1 >> 2]));
 f20 = f19 <= f20 ? f19 : f20;
 f48 = Math_fround((f20 <= f48 ? f20 : f48) * Math_fround(.25));
 f20 = Math_fround(HEAPF32[i65 >> 2]);
 f19 = Math_fround(f20 * Math_fround(.0500000007));
 f48 = f48 > f19 ? f19 : f48;
 i1 = i64 + 32 | 0;
 i49 = HEAP8[i1 >> 0] | 0;
 HEAPF32[i35 >> 2] = Math_fround(f48 * Math_fround(1.25));
 HEAPF32[i50 >> 2] = Math_fround(Math_fround(HEAPF32[i57 >> 2]) + f20);
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i64, i55, i35, i50);
 i50 = (HEAP8[i1 >> 0] | 0) != i49 << 24 >> 24;
 HEAP32[i45 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 HEAP32[i52 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i52 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 HEAP32[i67 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 HEAPF32[i46 >> 2] = Math_fround(0.0);
 i35 = i46 + 4 | 0;
 HEAP32[i35 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 if (i50) {
  i22 = i64 + 4 | 0;
  i8 = i64 + 8 | 0;
  i21 = i64 + 12 | 0;
  i7 = i64 + 16 | 0;
  i6 = i64 + 20 | 0;
  i1 = i64 + 24 | 0;
  i5 = i64;
 } else {
  i22 = HEAP8[i1 >> 0] | 0;
  i35 = i22 & 255;
  f20 = Math_fround(f48 * Math_fround(HEAPF32[gb + 105492 + (i35 << 2) >> 2]));
  i7 = i64 + 16 | 0;
  f74 = Math_fround(HEAPF32[i7 >> 2]);
  i6 = i64 + 20 | 0;
  f73 = Math_fround(HEAPF32[i6 >> 2]);
  i1 = i64 + 24 | 0;
  f74 = Math_fround(f2 - f74);
  f73 = Math_fround(f3 - f73);
  f72 = Math_fround(f4 - Math_fround(HEAPF32[i1 >> 2]));
  f19 = Math_fround(-f74);
  f18 = Math_fround(-f73);
  f71 = Math_fround(-f72);
  f19 = f74 > f19 ? f74 : f19;
  f18 = f73 > f18 ? f73 : f18;
  f18 = f19 >= f18 ? f19 : f18;
  i5 = (f72 > f71 ? f72 : f71) >= Math_fround(0.0);
  f19 = i5 ? f19 : Math_fround(0.0);
  f71 = Math_fround(HEAPF32[gb + 105504 + (i35 << 2) >> 2]);
  f72 = Math_fround(HEAPF32[i64 >> 2]);
  i5 = i64 + 4 | 0;
  f73 = Math_fround(HEAPF32[i5 >> 2]);
  i8 = i64 + 8 | 0;
  f74 = Math_fround(HEAPF32[i8 >> 2]);
  i21 = i64 + 12 | 0;
  if ((f18 >= f19 ? f18 : f19) > f20 ? 1 : f71 > Math_fround(Math_fround(Math_fround(Math_fround(f10 * f72) + Math_fround(f11 * f73)) + Math_fround(f12 * f74)) + Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2])))) {
   i22 = i5;
   i5 = i64;
  } else {
   if (!(i22 << 24 >> 24)) {
    i69 = 0;
    STACKTOP = i70;
    return i69 | 0;
   }
   i5 = HEAP32[i64 + 44 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f3 = Math_fround(HEAPF32[i5 + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   if ((i22 & 255) > 1) {
    i1 = 1;
    do {
     f73 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 32 >> 2]);
     f74 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 36 >> 2]);
     f2 = Math_fround(f2 + f73);
     f3 = Math_fround(f3 + f74);
     f4 = Math_fround(f4 + Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 40 >> 2]));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i35 | 0));
   }
   f48 = Math_fround(HEAPF32[i69 >> 2]);
   f71 = Math_fround(HEAPF32[i61 >> 2]);
   f18 = Math_fround(HEAPF32[i62 >> 2]);
   f20 = Math_fround(HEAPF32[i63 >> 2]);
   f74 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
   f19 = Math_fround(Math_fround(Math_fround(f2 * f48) + Math_fround(f3 * f71)) + Math_fround(f4 * f18));
   f72 = Math_fround(Math_fround(Math_fround(f48 * f19) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f4 * f71) - Math_fround(f3 * f18))) + Math_fround(f2 * f74))) * Math_fround(2.0));
   f73 = Math_fround(Math_fround(Math_fround(f71 * f19) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f2 * f18) - Math_fround(f4 * f48))) + Math_fround(f3 * f74))) * Math_fround(2.0));
   f74 = Math_fround(Math_fround(Math_fround(f18 * f19) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f3 * f48) - Math_fround(f2 * f71))) + Math_fround(f4 * f74))) * Math_fround(2.0));
   f71 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f74 * f74) + Math_fround(Math_fround(f72 * f72) + Math_fround(f73 * f73))))));
   f73 = Math_fround(f71 * f73);
   f74 = Math_fround(f71 * f74);
   HEAPF32[i67 >> 2] = Math_fround(f71 * f72);
   HEAPF32[i67 + 4 >> 2] = f73;
   HEAPF32[i67 + 8 >> 2] = f74;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i64, i66, i67, i68, i65);
   i69 = 1;
   STACKTOP = i70;
   return i69 | 0;
  }
 }
 HEAPF32[i5 >> 2] = f10;
 HEAPF32[i22 >> 2] = f11;
 HEAPF32[i8 >> 2] = f12;
 HEAPF32[i21 >> 2] = f9;
 HEAPF32[i7 >> 2] = f2;
 HEAPF32[i6 >> 2] = f3;
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i64 + 28 >> 2] = Math_fround(0.0);
 i21 = HEAP32[i40 + 20 >> 2] | 0;
 i22 = HEAP32[i40 + 24 >> 2] | 0;
 i35 = HEAP32[i40 + 28 >> 2] | 0;
 HEAP32[i41 >> 2] = HEAP32[i40 + 16 >> 2];
 HEAP32[i41 + 4 >> 2] = i21;
 HEAP32[i41 + 8 >> 2] = i22;
 HEAP32[i41 + 12 >> 2] = i35;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i58, i34, i44, i42, i41);
 HEAPF32[i58 + 16 >> 2] = Math_fround(0.0);
 i44 = i58 + 20 | 0;
 HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 i43 = i55 + 48 | 0;
 f74 = Math_fround(f13 * Math_fround(0.0));
 f72 = Math_fround(f13 * Math_fround(HEAPF32[i55 >> 2]));
 f72 = Math_fround(f72 + Math_fround(f74 * Math_fround(HEAPF32[i28 >> 2])));
 f72 = Math_fround(f72 + Math_fround(f74 * Math_fround(HEAPF32[i31 >> 2])));
 f73 = Math_fround(f13 * Math_fround(HEAPF32[i26 >> 2]));
 f73 = Math_fround(f73 + Math_fround(f74 * Math_fround(HEAPF32[i29 >> 2])));
 f73 = Math_fround(f73 + Math_fround(f74 * Math_fround(HEAPF32[i32 >> 2])));
 f71 = Math_fround(f13 * Math_fround(HEAPF32[i27 >> 2]));
 f71 = Math_fround(f71 + Math_fround(f74 * Math_fround(HEAPF32[i30 >> 2])));
 f74 = Math_fround(f71 + Math_fround(f74 * Math_fround(HEAPF32[i33 >> 2])));
 i44 = i56 + 64 | 0;
 HEAP32[i56 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i56 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i56 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i56 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
 HEAP32[i56 + 80 >> 2] = 4;
 HEAPF32[i56 + 48 >> 2] = Math_fround(0.0);
 i42 = i56 + 128 | 0;
 HEAP32[i42 >> 2] = HEAP32[i65 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i65 + 12 >> 2];
 f71 = Math_fround(HEAPF32[i43 >> 2]);
 f19 = Math_fround(HEAPF32[i24 >> 2]);
 f20 = Math_fround(HEAPF32[i25 >> 2]);
 f17 = Math_fround(f73 + f19);
 f18 = Math_fround(f74 + f20);
 HEAPF32[i56 + 96 >> 2] = Math_fround(f72 + f71);
 HEAPF32[i56 + 100 >> 2] = f17;
 HEAPF32[i56 + 104 >> 2] = f18;
 HEAPF32[i56 + 108 >> 2] = Math_fround(0.0);
 f73 = Math_fround(f19 - f73);
 f74 = Math_fround(f20 - f74);
 HEAPF32[i56 + 112 >> 2] = Math_fround(f71 - f72);
 HEAPF32[i56 + 116 >> 2] = f73;
 HEAPF32[i56 + 120 >> 2] = f74;
 HEAPF32[i56 + 124 >> 2] = Math_fround(0.0);
 i43 = i56 + 16 | 0;
 HEAP32[i43 >> 2] = HEAP32[i65 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i65 + 12 >> 2];
 i43 = i56 + 32 | 0;
 HEAP32[i43 >> 2] = HEAP32[i65 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i65 + 12 >> 2];
 HEAP32[i39 >> 2] = -1;
 HEAP32[i39 + 4 >> 2] = -1;
 HEAP32[i39 + 8 >> 2] = -1;
 HEAP32[i39 + 12 >> 2] = -1;
 HEAP32[i44 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
 HEAP32[i44 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
 if (Math_fround(HEAPF32[i37 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i38 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i36 >> 2]) == Math_fround(1.0)) {
  i8 = 1;
  i1 = __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i56, i58, i57, i45, i52, i67, i46, i64 + 34 | 0, i64 + 38 | 0, i64 + 33 | 0, 1) | 0;
 } else i60 = 8; else i60 = 8; else i60 = 8;
 if ((i60 | 0) == 8) {
  i8 = 0;
  i1 = __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i56, i58, i57, i45, i52, i67, i46, i64 + 34 | 0, i64 + 38 | 0, i64 + 33 | 0, 1) | 0;
 }
 HEAP32[i59 >> 2] = 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 3:
  {
   i1 = __ZN5physx2GuL35fullContactsGenerationCapsuleConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVESE_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i56, i58, i55, i68, i69, i66, i59, i66, i8, i64, i67, i57, 1) | 0;
   break;
  }
 case 1:
  {
   f2 = Math_fround(HEAPF32[i45 >> 2]);
   f4 = Math_fround(HEAPF32[i45 + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i45 + 8 >> 2]);
   f3 = Math_fround(HEAPF32[i23 >> 2]);
   f9 = Math_fround(HEAPF32[i24 >> 2]);
   f11 = Math_fround(HEAPF32[i25 >> 2]);
   f20 = Math_fround(f2 - f3);
   f71 = Math_fround(f4 - f9);
   f74 = Math_fround(f10 - f11);
   f12 = Math_fround(HEAPF32[i55 >> 2]);
   f72 = Math_fround(f20 * f12);
   f13 = Math_fround(HEAPF32[i26 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f71 * f13));
   f14 = Math_fround(HEAPF32[i27 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f74 * f14));
   f15 = Math_fround(HEAPF32[i28 >> 2]);
   f73 = Math_fround(f20 * f15);
   f16 = Math_fround(HEAPF32[i29 >> 2]);
   f73 = Math_fround(f73 + Math_fround(f71 * f16));
   f17 = Math_fround(HEAPF32[i30 >> 2]);
   f73 = Math_fround(f73 + Math_fround(f74 * f17));
   f18 = Math_fround(HEAPF32[i31 >> 2]);
   f20 = Math_fround(f20 * f18);
   f19 = Math_fround(HEAPF32[i32 >> 2]);
   f71 = Math_fround(f20 + Math_fround(f71 * f19));
   f20 = Math_fround(HEAPF32[i33 >> 2]);
   f74 = Math_fround(f71 + Math_fround(f74 * f20));
   i1 = HEAP32[i67 >> 2] | 0;
   i5 = HEAP32[i67 + 4 >> 2] | 0;
   i6 = HEAP32[i67 + 8 >> 2] | 0;
   i7 = HEAP32[i46 >> 2] | 0;
   HEAPF32[i66 >> 2] = f72;
   HEAPF32[i66 + 4 >> 2] = f73;
   HEAPF32[i66 + 8 >> 2] = f74;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   i60 = i66 + 16 | 0;
   HEAP32[i60 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i60 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i60 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i60 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
   HEAP32[i59 >> 2] = 1;
   HEAP32[i66 + 32 >> 2] = i1;
   HEAP32[i66 + 36 >> 2] = i5;
   HEAP32[i66 + 40 >> 2] = i6;
   HEAP32[i66 + 44 >> 2] = i7;
   i60 = 14;
   break;
  }
 default:
  {
   HEAP32[i47 >> 2] = gb + 84832 + 8;
   HEAP32[i47 + 4 >> 2] = i56;
   HEAP32[i47 + 8 >> 2] = i58;
   if ((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i56, i58, i47, i64 + 34 | 0, i64 + 38 | 0, HEAP8[i64 + 33 >> 0] | 0, i45, i52, i67, i46, 1) | 0) == 6) {
    f2 = Math_fround(HEAPF32[i45 >> 2]);
    f4 = Math_fround(HEAPF32[i45 + 4 >> 2]);
    f10 = Math_fround(HEAPF32[i45 + 8 >> 2]);
    f3 = Math_fround(HEAPF32[i23 >> 2]);
    f9 = Math_fround(HEAPF32[i24 >> 2]);
    f11 = Math_fround(HEAPF32[i25 >> 2]);
    f20 = Math_fround(f2 - f3);
    f71 = Math_fround(f4 - f9);
    f74 = Math_fround(f10 - f11);
    f12 = Math_fround(HEAPF32[i55 >> 2]);
    f72 = Math_fround(f20 * f12);
    f13 = Math_fround(HEAPF32[i26 >> 2]);
    f72 = Math_fround(f72 + Math_fround(f71 * f13));
    f14 = Math_fround(HEAPF32[i27 >> 2]);
    f72 = Math_fround(f72 + Math_fround(f74 * f14));
    f15 = Math_fround(HEAPF32[i28 >> 2]);
    f73 = Math_fround(f20 * f15);
    f16 = Math_fround(HEAPF32[i29 >> 2]);
    f73 = Math_fround(f73 + Math_fround(f71 * f16));
    f17 = Math_fround(HEAPF32[i30 >> 2]);
    f73 = Math_fround(f73 + Math_fround(f74 * f17));
    f18 = Math_fround(HEAPF32[i31 >> 2]);
    f20 = Math_fround(f20 * f18);
    f19 = Math_fround(HEAPF32[i32 >> 2]);
    f71 = Math_fround(f20 + Math_fround(f71 * f19));
    f20 = Math_fround(HEAPF32[i33 >> 2]);
    f74 = Math_fround(f71 + Math_fround(f74 * f20));
    i1 = HEAP32[i67 >> 2] | 0;
    i5 = HEAP32[i67 + 4 >> 2] | 0;
    i6 = HEAP32[i67 + 8 >> 2] | 0;
    i7 = HEAP32[i46 >> 2] | 0;
    i60 = HEAP32[i59 >> 2] | 0;
    HEAPF32[i66 + (i60 * 48 | 0) >> 2] = f72;
    HEAPF32[i66 + (i60 * 48 | 0) + 4 >> 2] = f73;
    HEAPF32[i66 + (i60 * 48 | 0) + 8 >> 2] = f74;
    HEAPF32[i66 + (i60 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
    i47 = i66 + (i60 * 48 | 0) + 16 | 0;
    HEAP32[i47 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i47 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i47 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    HEAP32[i47 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
    HEAP32[i59 >> 2] = i60 + 1;
    HEAP32[i66 + (i60 * 48 | 0) + 32 >> 2] = i1;
    HEAP32[i66 + (i60 * 48 | 0) + 36 >> 2] = i5;
    HEAP32[i66 + (i60 * 48 | 0) + 40 >> 2] = i6;
    HEAP32[i66 + (i60 * 48 | 0) + 44 >> 2] = i7;
    i60 = 14;
   } else {
    i1 = 1;
    i60 = 15;
   }
  }
 }
 if ((i60 | 0) == 14) if (i49 << 24 >> 24 == 0 | i50) {
  i1 = 0;
  i60 = 15;
 } else {
  HEAPF32[i54 >> 2] = Math_fround(f48 * Math_fround(.0500000007));
  i58 = i67 + 4 | 0;
  i59 = i67 + 8 | 0;
  HEAP32[i53 >> 2] = i1;
  HEAP32[i53 + 4 >> 2] = i5;
  HEAP32[i53 + 8 >> 2] = i6;
  HEAP32[i53 + 12 >> 2] = i7;
  f73 = Math_fround(f2 - f3);
  f48 = Math_fround(f4 - f9);
  f72 = Math_fround(f10 - f11);
  f71 = Math_fround(Math_fround(Math_fround(f73 * f15) + Math_fround(f48 * f16)) + Math_fround(f72 * f17));
  f15 = Math_fround(Math_fround(Math_fround(f73 * f18) + Math_fround(f48 * f19)) + Math_fround(f72 * f20));
  HEAPF32[i51 >> 2] = Math_fround(Math_fround(Math_fround(f73 * f12) + Math_fround(f48 * f13)) + Math_fround(f72 * f14));
  HEAPF32[i51 + 4 >> 2] = f71;
  HEAPF32[i51 + 8 >> 2] = f15;
  HEAPF32[i51 + 12 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i64, i51, i52, i53, i54) | 0;
  f15 = Math_fround(HEAPF32[i69 >> 2]);
  f20 = Math_fround(HEAPF32[i61 >> 2]);
  f71 = Math_fround(HEAPF32[i62 >> 2]);
  f19 = Math_fround(HEAPF32[i63 >> 2]);
  f17 = Math_fround(HEAPF32[i67 >> 2]);
  f72 = Math_fround(HEAPF32[i58 >> 2]);
  f48 = Math_fround(HEAPF32[i59 >> 2]);
  f18 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f16 = Math_fround(Math_fround(Math_fround(f15 * f17) + Math_fround(f20 * f72)) + Math_fround(f71 * f48));
  f73 = Math_fround(Math_fround(Math_fround(f20 * f16) + Math_fround(Math_fround(f18 * f72) + Math_fround(f19 * Math_fround(Math_fround(f71 * f17) - Math_fround(f15 * f48))))) * Math_fround(2.0));
  f74 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f48) + Math_fround(f19 * Math_fround(Math_fround(f15 * f72) - Math_fround(f20 * f17)))) + Math_fround(f71 * f16)) * Math_fround(2.0));
  HEAPF32[i67 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f16) + Math_fround(Math_fround(f17 * f18) + Math_fround(f19 * Math_fround(Math_fround(f20 * f48) - Math_fround(f71 * f72))))) * Math_fround(2.0));
  HEAPF32[i58 >> 2] = f73;
  HEAPF32[i59 >> 2] = f74;
  HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i64, i66, i67, i68, i65);
  i1 = 1;
 }
 if ((i60 | 0) == 15) i1 = __ZN5physx2GuL35fullContactsGenerationCapsuleConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVESE_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i56, i58, i55, i68, i69, i66, i59, i66, i8, i64, i67, i57, i1) | 0;
 i69 = i1;
 STACKTOP = i70;
 return i69 | 0;
}

function __ZN5physx2Gu20pcmContactCapsuleBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i9, i5, i7, i8, i6, i1, i65) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i65 = i65 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i68 + 704 | 0;
 i11 = i68 + 688 | 0;
 i56 = i68 + 672 | 0;
 i66 = i68 + 576 | 0;
 i67 = i68 + 320 | 0;
 i15 = i68 + 608 | 0;
 i64 = i68 + 160 | 0;
 i16 = i68 + 144 | 0;
 i17 = i68 + 128 | 0;
 i33 = i68 + 112 | 0;
 i49 = i68 + 96 | 0;
 i57 = i68 + 80 | 0;
 i30 = i68 + 748 | 0;
 i34 = i68 + 64 | 0;
 i53 = i68 + 512 | 0;
 i54 = i68 + 352 | 0;
 i55 = i68 + 176 | 0;
 i58 = i68 + 744 | 0;
 i32 = i68 + 732 | 0;
 i52 = i68 + 720 | 0;
 i51 = i68 + 48 | 0;
 i50 = i68 + 32 | 0;
 i47 = i68 + 16 | 0;
 i12 = i68;
 i63 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i48 = i5 + 4 | 0;
 i29 = HEAP32[i48 >> 2] | 0;
 i46 = i5 + 8 | 0;
 i28 = HEAP32[i46 >> 2] | 0;
 i45 = i5 + 12 | 0;
 i27 = HEAP32[i45 >> 2] | 0;
 HEAP32[i56 >> 2] = HEAP32[i6 >> 2];
 i36 = HEAP32[i7 + 4 >> 2] | 0;
 i14 = HEAP32[i7 + 8 >> 2] | 0;
 i72 = HEAP32[i7 + 12 >> 2] | 0;
 i6 = i7 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i66 >> 2] = HEAP32[i7 >> 2];
 i44 = i66 + 4 | 0;
 HEAP32[i44 >> 2] = i36;
 i36 = i66 + 8 | 0;
 HEAP32[i36 >> 2] = i14;
 i14 = i66 + 12 | 0;
 HEAP32[i14 >> 2] = i72;
 HEAP32[i66 + 16 >> 2] = i1;
 HEAP32[i66 + 20 >> 2] = i5;
 HEAP32[i66 + 24 >> 2] = i6;
 HEAPF32[i66 + 28 >> 2] = Math_fround(0.0);
 i72 = HEAP32[i8 >> 2] | 0;
 i71 = HEAP32[i8 + 4 >> 2] | 0;
 i70 = HEAP32[i8 + 8 >> 2] | 0;
 i7 = HEAP32[i8 + 12 >> 2] | 0;
 i13 = i8 + 16 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i10 = HEAP32[i13 + 4 >> 2] | 0;
 i13 = HEAP32[i13 + 8 >> 2] | 0;
 HEAP32[i67 >> 2] = i72;
 i60 = i67 + 4 | 0;
 HEAP32[i60 >> 2] = i71;
 i61 = i67 + 8 | 0;
 HEAP32[i61 >> 2] = i70;
 i62 = i67 + 12 | 0;
 HEAP32[i62 >> 2] = i7;
 i26 = i67 + 16 | 0;
 HEAP32[i26 >> 2] = i8;
 HEAP32[i67 + 20 >> 2] = i10;
 HEAP32[i67 + 24 >> 2] = i13;
 HEAPF32[i67 + 28 >> 2] = Math_fround(0.0);
 f22 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(-f22);
 f25 = Math_fround(-f25);
 f43 = Math_fround(-f43);
 f39 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(f39 - f21);
 f35 = Math_fround(f2 - f35);
 f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f2 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f39 = Math_fround(Math_fround(Math_fround(f21 * f22) + Math_fround(f35 * f25)) + Math_fround(f23 * f43));
 f37 = Math_fround(Math_fround(Math_fround(f39 * f22) + Math_fround(Math_fround(f2 * f21) + Math_fround(f20 * Math_fround(Math_fround(f23 * f25) - Math_fround(f35 * f43))))) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(Math_fround(f39 * f25) + Math_fround(Math_fround(f2 * f35) + Math_fround(f20 * Math_fround(Math_fround(f21 * f43) - Math_fround(f23 * f22))))) * Math_fround(2.0));
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f23) + Math_fround(f20 * Math_fround(Math_fround(f35 * f22) - Math_fround(f21 * f25)))) + Math_fround(f39 * f43)) * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i66 >> 2]);
 f35 = Math_fround(HEAPF32[i44 >> 2]);
 f23 = Math_fround(HEAPF32[i36 >> 2]);
 f2 = Math_fround(HEAPF32[i14 >> 2]);
 f40 = Math_fround(Math_fround(f20 * f2) - Math_fround(Math_fround(Math_fround(f21 * f22) + Math_fround(f35 * f25)) + Math_fround(f23 * f43)));
 f41 = Math_fround(Math_fround(Math_fround(f23 * f25) - Math_fround(f35 * f43)) + Math_fround(Math_fround(f20 * f21) + Math_fround(f2 * f22)));
 f42 = Math_fround(Math_fround(Math_fround(f21 * f43) - Math_fround(f23 * f22)) + Math_fround(Math_fround(f20 * f35) + Math_fround(f2 * f25)));
 f43 = Math_fround(Math_fround(Math_fround(f35 * f22) - Math_fround(f21 * f25)) + Math_fround(Math_fround(f20 * f23) + Math_fround(f2 * f43)));
 HEAPF32[i15 + 48 >> 2] = f37;
 HEAPF32[i15 + 52 >> 2] = f38;
 HEAPF32[i15 + 56 >> 2] = f39;
 HEAPF32[i15 + 60 >> 2] = Math_fround(0.0);
 f2 = Math_fround(f41 + f41);
 f23 = Math_fround(f42 + f42);
 f20 = Math_fround(f43 + f43);
 f25 = Math_fround(f42 * f23);
 f21 = Math_fround(f43 * f20);
 f22 = Math_fround(f42 * f2);
 f35 = Math_fround(f43 * f2);
 f24 = Math_fround(f40 * f2);
 f69 = Math_fround(f43 * f23);
 f23 = Math_fround(f40 * f23);
 f20 = Math_fround(f40 * f20);
 f2 = Math_fround(Math_fround(1.0) - Math_fround(f41 * f2));
 f4 = Math_fround(Math_fround(Math_fround(1.0) - f25) - f21);
 f18 = Math_fround(f22 + f20);
 f19 = Math_fround(f35 - f23);
 f20 = Math_fround(f22 - f20);
 f21 = Math_fround(f2 - f21);
 f22 = Math_fround(f69 + f24);
 f23 = Math_fround(f35 + f23);
 f24 = Math_fround(f69 - f24);
 f25 = Math_fround(f2 - f25);
 HEAPF32[i15 >> 2] = f4;
 HEAPF32[i15 + 4 >> 2] = f18;
 HEAPF32[i15 + 8 >> 2] = f19;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 16 >> 2] = f20;
 HEAPF32[i15 + 20 >> 2] = f21;
 HEAPF32[i15 + 24 >> 2] = f22;
 HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 32 >> 2] = f23;
 HEAPF32[i15 + 36 >> 2] = f24;
 HEAPF32[i15 + 40 >> 2] = f25;
 HEAPF32[i15 + 44 >> 2] = Math_fround(0.0);
 i14 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i64 >> 2] = i14;
 f2 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i36 = i63 + 32 | 0;
 i44 = HEAP8[i36 >> 0] | 0;
 f69 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = f69 <= f35 ? f69 : f35;
 f3 = f35 <= f3 ? f35 : f3;
 f35 = Math_fround(f3 * Math_fround(.150000006));
 f69 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = f35 > f69 ? f69 : f35;
 HEAPF32[i16 >> 2] = Math_fround(f35 * Math_fround(.800000011));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i56 >> 2]) + f69);
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i63, i15, i16, i17);
 i36 = (HEAP8[i36 >> 0] | 0) != i44 << 24 >> 24;
 if (i36) {
  i10 = i63 + 4 | 0;
  i8 = i63 + 8 | 0;
  i9 = i63 + 12 | 0;
  i7 = i63 + 16 | 0;
  i6 = i63 + 20 | 0;
  i1 = i63 + 24 | 0;
  i5 = i63;
 } else {
  i10 = i44 & 255;
  f76 = Math_fround(f35 * Math_fround(HEAPF32[gb + 105492 + (i10 << 2) >> 2]));
  i7 = i63 + 16 | 0;
  f69 = Math_fround(HEAPF32[i7 >> 2]);
  i6 = i63 + 20 | 0;
  f73 = Math_fround(HEAPF32[i6 >> 2]);
  i1 = i63 + 24 | 0;
  f69 = Math_fround(f37 - f69);
  f73 = Math_fround(f38 - f73);
  f74 = Math_fround(f39 - Math_fround(HEAPF32[i1 >> 2]));
  f77 = Math_fround(-f69);
  f78 = Math_fround(-f73);
  f75 = Math_fround(-f74);
  f77 = f69 > f77 ? f69 : f77;
  f78 = f73 > f78 ? f73 : f78;
  f78 = f77 >= f78 ? f77 : f78;
  i5 = (f74 > f75 ? f74 : f75) >= Math_fround(0.0);
  f77 = i5 ? f77 : Math_fround(0.0);
  f75 = Math_fround(HEAPF32[gb + 105504 + (i10 << 2) >> 2]);
  f74 = Math_fround(HEAPF32[i63 >> 2]);
  i5 = i63 + 4 | 0;
  f73 = Math_fround(HEAPF32[i5 >> 2]);
  i8 = i63 + 8 | 0;
  f69 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i63 + 12 | 0;
  if ((f78 >= f77 ? f78 : f77) > f76 ? 1 : f75 > Math_fround(Math_fround(Math_fround(Math_fround(f41 * f74) + Math_fround(f42 * f73)) + Math_fround(f43 * f69)) + Math_fround(f40 * Math_fround(HEAPF32[i9 >> 2])))) {
   i10 = i5;
   i5 = i63;
  } else {
   if (!(i44 << 24 >> 24)) {
    i72 = 0;
    STACKTOP = i68;
    return i72 | 0;
   }
   i5 = HEAP32[i63 + 44 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f3 = Math_fround(HEAPF32[i5 + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   if ((i44 & 255) > 1) {
    i1 = 1;
    do {
     f77 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 32 >> 2]);
     f78 = Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 36 >> 2]);
     f2 = Math_fround(f2 + f77);
     f3 = Math_fround(f3 + f78);
     f4 = Math_fround(f4 + Math_fround(HEAPF32[i5 + (i1 * 48 | 0) + 40 >> 2]));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i10 | 0));
   }
   f74 = Math_fround(HEAPF32[i67 >> 2]);
   f75 = Math_fround(HEAPF32[i60 >> 2]);
   f43 = Math_fround(HEAPF32[i61 >> 2]);
   f73 = Math_fround(HEAPF32[i62 >> 2]);
   f78 = Math_fround(Math_fround(f73 * f73) + Math_fround(-.5));
   f69 = Math_fround(Math_fround(Math_fround(f2 * f74) + Math_fround(f3 * f75)) + Math_fround(f4 * f43));
   f76 = Math_fround(Math_fround(Math_fround(f74 * f69) + Math_fround(Math_fround(f73 * Math_fround(Math_fround(f4 * f75) - Math_fround(f3 * f43))) + Math_fround(f2 * f78))) * Math_fround(2.0));
   f77 = Math_fround(Math_fround(Math_fround(f75 * f69) + Math_fround(Math_fround(f73 * Math_fround(Math_fround(f2 * f43) - Math_fround(f4 * f74))) + Math_fround(f3 * f78))) * Math_fround(2.0));
   f78 = Math_fround(Math_fround(Math_fround(f43 * f69) + Math_fround(Math_fround(f73 * Math_fround(Math_fround(f3 * f74) - Math_fround(f2 * f75))) + Math_fround(f4 * f78))) * Math_fround(2.0));
   f75 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f78 * f78) + Math_fround(Math_fround(f76 * f76) + Math_fround(f77 * f77))))));
   f77 = Math_fround(f75 * f77);
   f78 = Math_fround(f75 * f78);
   HEAPF32[i12 >> 2] = Math_fround(f75 * f76);
   HEAPF32[i12 + 4 >> 2] = f77;
   HEAPF32[i12 + 8 >> 2] = f78;
   HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i63, i65, i12, i66, i64);
   i72 = 1;
   STACKTOP = i68;
   return i72 | 0;
  }
 };
 HEAP32[i33 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i49 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i57 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAPF32[i34 >> 2] = Math_fround(0.0);
 i11 = i34 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAPF32[i5 >> 2] = f41;
 HEAPF32[i10 >> 2] = f42;
 HEAPF32[i8 >> 2] = f43;
 HEAPF32[i9 >> 2] = f40;
 HEAPF32[i7 >> 2] = f37;
 HEAPF32[i6 >> 2] = f38;
 HEAPF32[i1 >> 2] = f39;
 HEAPF32[i63 + 28 >> 2] = Math_fround(0.0);
 i7 = i53 + 48 | 0;
 HEAPF32[i7 >> 2] = f37;
 i8 = i53 + 52 | 0;
 HEAPF32[i8 >> 2] = f38;
 i9 = i53 + 56 | 0;
 HEAPF32[i9 >> 2] = f39;
 HEAPF32[i53 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i53 >> 2] = f4;
 i10 = i53 + 4 | 0;
 HEAPF32[i10 >> 2] = f18;
 i11 = i53 + 8 | 0;
 HEAPF32[i11 >> 2] = f19;
 HEAPF32[i53 + 12 >> 2] = Math_fround(0.0);
 i12 = i53 + 16 | 0;
 HEAPF32[i12 >> 2] = f20;
 i13 = i53 + 20 | 0;
 HEAPF32[i13 >> 2] = f21;
 i14 = i53 + 24 | 0;
 HEAPF32[i14 >> 2] = f22;
 HEAPF32[i53 + 28 >> 2] = Math_fround(0.0);
 i15 = i53 + 32 | 0;
 HEAPF32[i15 >> 2] = f23;
 i16 = i53 + 36 | 0;
 HEAPF32[i16 >> 2] = f24;
 i17 = i53 + 40 | 0;
 HEAPF32[i17 >> 2] = f25;
 HEAPF32[i53 + 44 >> 2] = Math_fround(0.0);
 i5 = i54 + 64 | 0;
 HEAP32[i54 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 HEAP32[i54 + 80 >> 2] = 3;
 HEAPF32[i54 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
 HEAP32[i54 + 144 >> 2] = i29;
 HEAP32[i54 + 148 >> 2] = i28;
 HEAP32[i54 + 152 >> 2] = i27;
 HEAPF32[i54 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i54 + 32 >> 2] = Math_fround(f3 * Math_fround(.0500000007));
 HEAPF32[i54 + 16 >> 2] = Math_fround(0.0);
 i5 = i54 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 i5 = i53 + 48 | 0;
 f78 = Math_fround(f2 * Math_fround(0.0));
 f76 = Math_fround(Math_fround(Math_fround(f2 * f4) + Math_fround(f78 * f20)) + Math_fround(f78 * f23));
 f77 = Math_fround(Math_fround(Math_fround(f2 * f18) + Math_fround(f78 * f21)) + Math_fround(f78 * f24));
 f78 = Math_fround(Math_fround(Math_fround(f2 * f19) + Math_fround(f78 * f22)) + Math_fround(f78 * f25));
 i1 = i55 + 64 | 0;
 HEAP32[i55 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i55 + 80 >> 2] = 4;
 HEAPF32[i55 + 48 >> 2] = Math_fround(0.0);
 i6 = i55 + 128 | 0;
 HEAP32[i6 >> 2] = HEAP32[i64 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f74 = Math_fround(f77 + f3);
 f75 = Math_fround(f78 + f4);
 HEAPF32[i55 + 96 >> 2] = Math_fround(f76 + f2);
 HEAPF32[i55 + 100 >> 2] = f74;
 HEAPF32[i55 + 104 >> 2] = f75;
 HEAPF32[i55 + 108 >> 2] = Math_fround(0.0);
 f77 = Math_fround(f3 - f77);
 f78 = Math_fround(f4 - f78);
 HEAPF32[i55 + 112 >> 2] = Math_fround(f2 - f76);
 HEAPF32[i55 + 116 >> 2] = f77;
 HEAPF32[i55 + 120 >> 2] = f78;
 HEAPF32[i55 + 124 >> 2] = Math_fround(0.0);
 i5 = i55 + 16 | 0;
 HEAP32[i5 >> 2] = HEAP32[i64 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
 i5 = i55 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i64 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
 HEAP32[i31 >> 2] = -1;
 HEAP32[i31 + 4 >> 2] = -1;
 HEAP32[i31 + 8 >> 2] = -1;
 HEAP32[i31 + 12 >> 2] = -1;
 HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
 i1 = i63 + 34 | 0;
 i5 = i63 + 38 | 0;
 i6 = i63 + 33 | 0;
 i72 = __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i55, i54, i56, i33, i49, i57, i34, i1, i5, i6, 1) | 0;
 HEAP32[i58 >> 2] = 0;
 switch (i72 | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 3:
  {
   HEAP32[i32 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i45 >> 2];
   i1 = __ZN5physx2GuL32fullContactsGenerationCapsuleBoxERKNS0_8CapsuleVERKNS0_4BoxVENS_6PxVec3ERKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVESF_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS9_5Vec3VERKNS9_6FloatVEb(i55, i54, i32, i53, i66, i67, i65, i58, i65, i63, i57, i56, 1) | 0;
   break;
  }
 case 1:
  {
   f76 = Math_fround(HEAPF32[i33 >> 2]);
   f77 = Math_fround(HEAPF32[i33 + 4 >> 2]);
   f78 = Math_fround(HEAPF32[i33 + 8 >> 2]);
   f74 = Math_fround(f76 - f2);
   f75 = Math_fround(f77 - f3);
   f2 = Math_fround(f78 - f4);
   f4 = Math_fround(Math_fround(Math_fround(f74 * Math_fround(HEAPF32[i53 >> 2])) + Math_fround(f75 * Math_fround(HEAPF32[i10 >> 2]))) + Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2])));
   f3 = Math_fround(Math_fround(Math_fround(f74 * Math_fround(HEAPF32[i12 >> 2])) + Math_fround(f75 * Math_fround(HEAPF32[i13 >> 2]))) + Math_fround(f2 * Math_fround(HEAPF32[i14 >> 2])));
   f2 = Math_fround(Math_fround(Math_fround(f74 * Math_fround(HEAPF32[i15 >> 2])) + Math_fround(f75 * Math_fround(HEAPF32[i16 >> 2]))) + Math_fround(f2 * Math_fround(HEAPF32[i17 >> 2])));
   i1 = HEAP32[i57 >> 2] | 0;
   i5 = HEAP32[i57 + 4 >> 2] | 0;
   i6 = HEAP32[i57 + 8 >> 2] | 0;
   i7 = HEAP32[i34 >> 2] | 0;
   HEAPF32[i65 >> 2] = f4;
   HEAPF32[i65 + 4 >> 2] = f3;
   HEAPF32[i65 + 8 >> 2] = f2;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   i59 = i65 + 16 | 0;
   HEAP32[i59 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i59 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i59 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i59 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
   HEAP32[i58 >> 2] = 1;
   HEAP32[i65 + 32 >> 2] = i1;
   HEAP32[i65 + 36 >> 2] = i5;
   HEAP32[i65 + 40 >> 2] = i6;
   HEAP32[i65 + 44 >> 2] = i7;
   f2 = f76;
   f3 = f77;
   f4 = f78;
   i59 = 9;
   break;
  }
 default:
  if ((__ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb(i55, i54, i33, i49, i57, i34, i1, i5, i6, 1) | 0) == 6) {
   f2 = Math_fround(HEAPF32[i33 >> 2]);
   f3 = Math_fround(HEAPF32[i33 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i33 + 8 >> 2]);
   f74 = Math_fround(HEAPF32[i7 >> 2]);
   f75 = Math_fround(HEAPF32[i8 >> 2]);
   f74 = Math_fround(f2 - f74);
   f75 = Math_fround(f3 - f75);
   f78 = Math_fround(f4 - Math_fround(HEAPF32[i9 >> 2]));
   f76 = Math_fround(f74 * Math_fround(HEAPF32[i53 >> 2]));
   f76 = Math_fround(f76 + Math_fround(f75 * Math_fround(HEAPF32[i10 >> 2])));
   f76 = Math_fround(f76 + Math_fround(f78 * Math_fround(HEAPF32[i11 >> 2])));
   f77 = Math_fround(f74 * Math_fround(HEAPF32[i12 >> 2]));
   f77 = Math_fround(f77 + Math_fround(f75 * Math_fround(HEAPF32[i13 >> 2])));
   f77 = Math_fround(f77 + Math_fround(f78 * Math_fround(HEAPF32[i14 >> 2])));
   f74 = Math_fround(f74 * Math_fround(HEAPF32[i15 >> 2]));
   f75 = Math_fround(f74 + Math_fround(f75 * Math_fround(HEAPF32[i16 >> 2])));
   f78 = Math_fround(f75 + Math_fround(f78 * Math_fround(HEAPF32[i17 >> 2])));
   i1 = HEAP32[i57 >> 2] | 0;
   i5 = HEAP32[i57 + 4 >> 2] | 0;
   i6 = HEAP32[i57 + 8 >> 2] | 0;
   i7 = HEAP32[i34 >> 2] | 0;
   i59 = HEAP32[i58 >> 2] | 0;
   HEAPF32[i65 + (i59 * 48 | 0) >> 2] = f76;
   HEAPF32[i65 + (i59 * 48 | 0) + 4 >> 2] = f77;
   HEAPF32[i65 + (i59 * 48 | 0) + 8 >> 2] = f78;
   HEAPF32[i65 + (i59 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
   i72 = i65 + (i59 * 48 | 0) + 16 | 0;
   HEAP32[i72 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i72 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
   HEAP32[i58 >> 2] = i59 + 1;
   HEAP32[i65 + (i59 * 48 | 0) + 32 >> 2] = i1;
   HEAP32[i65 + (i59 * 48 | 0) + 36 >> 2] = i5;
   HEAP32[i65 + (i59 * 48 | 0) + 40 >> 2] = i6;
   HEAP32[i65 + (i59 * 48 | 0) + 44 >> 2] = i7;
   i59 = 9;
  } else {
   i1 = 1;
   i59 = 10;
  }
 }
 if ((i59 | 0) == 9) if (i44 << 24 >> 24 == 0 | i36) {
  i1 = 0;
  i59 = 10;
 } else {
  HEAPF32[i51 >> 2] = Math_fround(f35 * Math_fround(.100000001));
  i71 = i57 + 4 | 0;
  i72 = i57 + 8 | 0;
  HEAP32[i50 >> 2] = i1;
  HEAP32[i50 + 4 >> 2] = i5;
  HEAP32[i50 + 8 >> 2] = i6;
  HEAP32[i50 + 12 >> 2] = i7;
  f74 = Math_fround(f2 - f37);
  f69 = Math_fround(f3 - f38);
  f76 = Math_fround(f4 - f39);
  f77 = Math_fround(Math_fround(f40 * f40) + Math_fround(-.5));
  f78 = Math_fround(Math_fround(Math_fround(f41 * f74) + Math_fround(f42 * f69)) + Math_fround(f43 * f76));
  f75 = Math_fround(Math_fround(Math_fround(f42 * f78) + Math_fround(Math_fround(f77 * f69) - Math_fround(f40 * Math_fround(Math_fround(f43 * f74) - Math_fround(f41 * f76))))) * Math_fround(2.0));
  f73 = Math_fround(Math_fround(Math_fround(Math_fround(f77 * f76) - Math_fround(f40 * Math_fround(Math_fround(f41 * f69) - Math_fround(f42 * f74)))) + Math_fround(f43 * f78)) * Math_fround(2.0));
  HEAPF32[i47 >> 2] = Math_fround(Math_fround(Math_fround(f41 * f78) + Math_fround(Math_fround(f77 * f74) - Math_fround(f40 * Math_fround(Math_fround(f42 * f76) - Math_fround(f43 * f69))))) * Math_fround(2.0));
  HEAPF32[i47 + 4 >> 2] = f75;
  HEAPF32[i47 + 8 >> 2] = f73;
  HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i63, i47, i49, i50, i51) | 0;
  f40 = Math_fround(HEAPF32[i67 >> 2]);
  f73 = Math_fround(HEAPF32[i60 >> 2]);
  f75 = Math_fround(HEAPF32[i61 >> 2]);
  f69 = Math_fround(HEAPF32[i62 >> 2]);
  f42 = Math_fround(HEAPF32[i57 >> 2]);
  f76 = Math_fround(HEAPF32[i71 >> 2]);
  f74 = Math_fround(HEAPF32[i72 >> 2]);
  f43 = Math_fround(Math_fround(f69 * f69) + Math_fround(-.5));
  f41 = Math_fround(Math_fround(Math_fround(f40 * f42) + Math_fround(f73 * f76)) + Math_fround(f75 * f74));
  f77 = Math_fround(Math_fround(Math_fround(f73 * f41) + Math_fround(Math_fround(f43 * f76) + Math_fround(f69 * Math_fround(Math_fround(f75 * f42) - Math_fround(f40 * f74))))) * Math_fround(2.0));
  f78 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f74) + Math_fround(f69 * Math_fround(Math_fround(f40 * f76) - Math_fround(f73 * f42)))) + Math_fround(f75 * f41)) * Math_fround(2.0));
  HEAPF32[i57 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f41) + Math_fround(Math_fround(f42 * f43) + Math_fround(f69 * Math_fround(Math_fround(f73 * f74) - Math_fround(f75 * f76))))) * Math_fround(2.0));
  HEAPF32[i71 >> 2] = f77;
  HEAPF32[i72 >> 2] = f78;
  HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i63, i65, i57, i66, i64);
  i1 = 1;
 }
 if ((i59 | 0) == 10) {
  HEAP32[i52 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i45 >> 2];
  i1 = __ZN5physx2GuL32fullContactsGenerationCapsuleBoxERKNS0_8CapsuleVERKNS0_4BoxVENS_6PxVec3ERKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVESF_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS9_5Vec3VERKNS9_6FloatVEb(i55, i54, i52, i53, i66, i67, i65, i58, i65, i63, i57, i56, i1) | 0;
 }
 i72 = i1;
 STACKTOP = i68;
 return i72 | 0;
}

function __ZN25ParticleSystemGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj(i1, i77) {
 i1 = i1 | 0;
 i77 = i77 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0;
 i81 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i79 = i81 + 244 | 0;
 i73 = i81 + 8 | 0;
 i67 = i81 + 196 | 0;
 i68 = i81 + 184 | 0;
 i69 = i81 + 120 | 0;
 i70 = i81 + 80 | 0;
 i71 = i81 + 76 | 0;
 i72 = i81 + 72 | 0;
 i74 = i81 + 48 | 0;
 i12 = i81 + 208 | 0;
 i78 = i81;
 if ((HEAP16[gb + 1452212 + 6 >> 1] | 0) > -1) {
  HEAP32[i73 >> 2] = 0;
  HEAP32[i79 >> 2] = HEAP32[i73 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452212 | 0, i79);
  i80 = gb + 1452212 | 0;
 } else i80 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i11 = i3 + (i77 * 20 | 0) | 0;
 i76 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i3 + (i77 * 20 | 0) + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) == 0;
 if (!i1) {
  if (!i2) i75 = 9;
 } else if (i2) {
  i74 = HEAP32[i3 + (i77 * 20 | 0) + 12 >> 2] | 0;
  i3 = ((i74 >>> 0) / 6 | 0) << 2;
  if (i74 >>> 0 > 5) {
   i2 = 0;
   while (1) {
    i73 = i2 & 65535;
    HEAP16[i1 >> 1] = i73;
    HEAP16[i1 + 2 >> 1] = i2 | 1;
    i74 = (i2 | 2) & 65535;
    HEAP16[i1 + 4 >> 1] = i74;
    HEAP16[i1 + 6 >> 1] = i73;
    HEAP16[i1 + 8 >> 1] = i74;
    HEAP16[i1 + 10 >> 1] = i2 | 3;
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 12 | 0;
   }
  }
 } else i75 = 9;
 if ((i75 | 0) == 9) {
  i65 = HEAP32[i76 + (i77 * 788 | 0) + 748 >> 2] | 0;
  i66 = i76 + (i77 * 788 | 0) | 0;
  i10 = i76 + (i77 * 788 | 0) + 616 | 0;
  i8 = i76 + (i77 * 788 | 0) + 752 | 0;
  i1 = HEAP32[i76 + (i77 * 788 | 0) + 784 >> 2] | 0;
  if (!(HEAP8[i1 + 4 >> 0] | 0)) i6 = 0; else if ((HEAP32[i1 + 536 >> 2] | 0) > 1) i6 = 1; else i6 = (HEAP32[i1 + 540 >> 2] | 0) > 1;
  i13 = i65 + 12 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i64 = i65 + 871 | 0;
  i3 = (HEAP8[i64 >> 0] | 0) != 0;
  i7 = (HEAP16[i76 + (i77 * 788 | 0) + 618 >> 1] | 0) != 0;
  i61 = i74 + 16 | 0;
  i62 = i74 + 20 | 0;
  i63 = i74 + 12 | 0;
  HEAP32[i74 >> 2] = 0;
  HEAP32[i74 + 4 >> 2] = 0;
  HEAP32[i74 + 8 >> 2] = 0;
  HEAP32[i74 + 12 >> 2] = 0;
  HEAP32[i74 + 16 >> 2] = 0;
  HEAP32[i74 + 20 >> 2] = 0;
  if (i1 | 0) {
   i4 = i74 + 8 | 0;
   i2 = i1 + 3 & -4;
   i5 = i2 << 2;
   i1 = (Math_imul(i5, i3 ? 3 : 1) | 0) + i5 | 0;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + (i6 ? i5 : 0) + (i7 ? i2 << 3 : 0) | 0, 16, gb + 64024 | 0, 0, gb + 621865 | 0, 1585) | 0;
   HEAP32[i74 >> 2] = i2;
   i2 = i2 + i5 | 0;
   HEAP32[i74 + 4 >> 2] = i2;
   i1 = i2 + i5 | 0;
   if (i3) {
    HEAP32[i4 >> 2] = i1;
    i1 = i1 + i5 | 0;
    HEAP32[i63 >> 2] = i1;
    i1 = i1 + i5 | 0;
   } else {
    HEAP32[i4 >> 2] = i2;
    HEAP32[i63 >> 2] = i2;
   }
   if (i6) {
    HEAP32[i61 >> 2] = i1;
    i1 = i1 + i5 | 0;
   }
   if (i7) HEAP32[i62 >> 2] = i1;
  }
  __ZN22ParticleSystemRenderer24PrepareForRenderThreadedERK32ParticleSystemGeometryJobModulesR31ParticleSystemParticlesTempDataP23ParticleSystemParticlesR22ParticleSystemTempDataRK26ParticleSystemRendererData(i8, i74, i65, i66, i10);
  i53 = i76 + (i77 * 788 | 0) + 432 | 0;
  i2 = HEAP16[i53 >> 1] | 0;
  do if (!(i2 << 16 >> 16)) {
   i5 = i12;
   i4 = i5 + 36 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
    i5 = i5 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
   i5 = i73;
   i8 = i12;
   i4 = i5 + 36 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
    i5 = i5 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
   f58 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 652 >> 2]);
   f58 = Math_fround(f58 * f58);
   f57 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 656 >> 2]);
   f57 = Math_fround(f58 + Math_fround(f57 * f57));
   f58 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 660 >> 2]);
   f58 = Math_fround(f57 + Math_fround(f58 * f58));
   if (f58 > Math_fround(HEAPF32[gb + 62456 >> 2])) i75 = 83; else if (!(HEAP8[i64 >> 0] | 0)) {
    i5 = i79;
    i8 = i73;
    i4 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
     i5 = i5 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    __ZL22DrawParticlesWithPivotILb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i1, i66, i10, i79, i65, i74);
   } else i75 = 83;
   if ((i75 | 0) == 83) {
    i5 = i79;
    i8 = i73;
    i4 = i5 + 36 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
     i5 = i5 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i5 | 0) < (i4 | 0));
    __ZL22DrawParticlesWithPivotILb1EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData(i1, i66, i10, i79, i65, i74);
   }
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i59 = i76 + (i77 * 788 | 0) + 332 | 0;
   i60 = (HEAP32[i59 >> 2] | 0) < 0;
   if (i2 << 16 >> 16 == 1) {
    HEAP32[i73 >> 2] = i1;
    f57 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 652 >> 2]);
    f55 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 660 >> 2]);
    f56 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 656 >> 2]);
    i13 = HEAP32[i13 >> 2] | 0;
    if (i13 | 0) {
     i21 = i65 + 20 | 0;
     i22 = i65 + 40 | 0;
     i23 = i67 + 4 | 0;
     i24 = i67 + 8 | 0;
     i25 = i74 + 4 | 0;
     i26 = i65 + 520 | 0;
     i27 = i68 + 4 | 0;
     i28 = i68 + 8 | 0;
     i29 = i65 + 870 | 0;
     i30 = i65 + 240 | 0;
     i31 = i65 + 260 | 0;
     i32 = i65 + 280 | 0;
     f33 = Math_fround(HEAPF32[gb + 62452 >> 2]);
     i34 = i65 + 340 | 0;
     i35 = i79 + 12 | 0;
     i36 = i79 + 4 | 0;
     i37 = i79 + 8 | 0;
     i38 = i69 + 4 | 0;
     i39 = i69 + 8 | 0;
     i40 = i69 + 16 | 0;
     i41 = i69 + 20 | 0;
     i42 = i69 + 24 | 0;
     i43 = i69 + 32 | 0;
     i44 = i69 + 36 | 0;
     i45 = i69 + 40 | 0;
     i46 = i76 + (i77 * 788 | 0) + 536 | 0;
     i47 = i76 + (i77 * 788 | 0) + 544 | 0;
     i11 = i76 + (i77 * 788 | 0) + 672 | 0;
     i12 = i76 + (i77 * 788 | 0) + 678 | 0;
     i48 = i76 + (i77 * 788 | 0) + 540 | 0;
     i49 = i76 + (i77 * 788 | 0) + 420 | 0;
     i50 = i65 + 300 | 0;
     i51 = i65 + 320 | 0;
     i52 = i70 + 4 | 0;
     i53 = i70 + 8 | 0;
     i54 = i74 + 8 | 0;
     i10 = 0;
     i2 = i3;
     i3 = 0;
     i7 = 0;
     while (1) {
      i1 = HEAP32[i62 >> 2] | 0;
      if (!i1) i9 = i10; else i9 = HEAP32[i1 + (i10 << 3) >> 2] | 0;
      i6 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      i8 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      HEAP32[i67 >> 2] = HEAP32[(HEAP32[i65 >> 2] | 0) + (i9 << 2) >> 2];
      HEAP32[i23 >> 2] = i6;
      HEAP32[i24 >> 2] = i8;
      f14 = Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + (i9 << 2) >> 2]);
      if (!(HEAP8[i64 >> 0] | 0)) {
       f15 = f14;
       f16 = f14;
      } else {
       f16 = Math_fround(HEAPF32[(HEAP32[i54 >> 2] | 0) + (i9 << 2) >> 2]);
       f15 = Math_fround(HEAPF32[(HEAP32[i63 >> 2] | 0) + (i9 << 2) >> 2]);
      }
      if (Math_fround(HEAPF32[(HEAP32[i26 >> 2] | 0) + (i9 << 2) >> 2]) >= Math_fround(100.0)) {
       f14 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
       f16 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
       f15 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
      }
      i6 = HEAP32[(HEAP32[i74 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      f20 = Math_fround(-Math_fround(f55 * f16));
      f58 = Math_fround(f56 * f15);
      HEAPF32[i68 >> 2] = Math_fround(f57 * f14);
      HEAPF32[i27 >> 2] = f20;
      HEAPF32[i28 >> 2] = f58;
      if (!(HEAP8[i29 >> 0] | 0)) {
       f17 = Math_fround(HEAPF32[(HEAP32[i30 >> 2] | 0) + (i9 << 2) >> 2]);
       f18 = Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + (i9 << 2) >> 2]);
       f19 = Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + (i9 << 2) >> 2]);
       f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19))));
       if (f20 > f33) {
        f58 = Math_fround(f17 / f20);
        i1 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
        f58 = Math_fround(f18 / f20);
        i4 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
        f58 = Math_fround(f19 / f20);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        i1 = HEAP32[gb + 62536 >> 2] | 0;
        i4 = HEAP32[gb + 62536 + 4 >> 2] | 0;
        i5 = HEAP32[gb + 62536 + 8 >> 2] | 0;
       }
       f20 = Math_fround(Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + (i9 << 2) >> 2]) * Math_fround(.5));
       f58 = Math_fround(+Math_sin(+f20));
       HEAPF32[i35 >> 2] = Math_fround(+Math_cos(+f20));
       HEAPF32[i79 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
       HEAPF32[i36 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
       HEAPF32[i37 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f58);
       __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i69, i67, i79);
      } else {
       i5 = HEAP32[(HEAP32[i51 >> 2] | 0) + (i9 << 2) >> 2] | 0;
       i8 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i9 << 2) >> 2] | 0;
       HEAP32[i70 >> 2] = HEAP32[(HEAP32[i50 >> 2] | 0) + (i9 << 2) >> 2];
       HEAP32[i52 >> 2] = i5;
       HEAP32[i53 >> 2] = i8;
       __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i79, i70, 4);
       __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i69, i67, i79);
      }
      __ZN10Matrix3x3fC2ERK10Matrix4x4f(i70, i69);
      HEAPF32[i69 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i69 >> 2]));
      HEAPF32[i38 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i38 >> 2]));
      HEAPF32[i39 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i39 >> 2]));
      HEAPF32[i40 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i40 >> 2]));
      HEAPF32[i41 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i41 >> 2]));
      HEAPF32[i42 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i42 >> 2]));
      HEAPF32[i43 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i43 >> 2]));
      HEAPF32[i44 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i44 >> 2]));
      HEAPF32[i45 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i45 >> 2]));
      if (!i60) {
       i5 = i69;
       i8 = __ZN10Matrix4x4f5ScaleERK8Vector3f(i69, i49) | 0;
       i4 = i5 + 64 | 0;
       do {
        HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
        i5 = i5 + 4 | 0;
        i8 = i8 + 4 | 0;
       } while ((i5 | 0) < (i4 | 0));
      }
      if (((HEAP32[(HEAP32[i47 >> 2] | 0) + 100 >> 2] | 0) + i3 | 0) >>> 0 > 65534) {
       i1 = i7 + 1 | 0;
       if ((i1 | 0) == 8) {
        i4 = 0;
        i3 = 0;
        i1 = 8;
       } else {
        i3 = 0;
        i75 = 40;
       }
      } else {
       i1 = i7;
       i75 = 40;
      }
      if ((i75 | 0) == 40) {
       i75 = 0;
       if (!(HEAP32[i59 >> 2] & 268435456)) {
        HEAP32[i72 >> 2] = i6;
        i7 = HEAP32[i11 >> 2] | 0;
        i8 = HEAP16[i12 >> 1] | 0;
        HEAP32[i79 >> 2] = HEAP32[i72 >> 2];
        __ZL32TransformParticleMeshAnimatedUVsILb0EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i46, i9, i79, i7, i8, i69, i70, i68, i65, i73);
       } else {
        HEAP32[i71 >> 2] = i6;
        i6 = HEAP32[i61 >> 2] | 0;
        i7 = HEAP32[i11 >> 2] | 0;
        i8 = HEAP16[i12 >> 1] | 0;
        HEAP32[i79 >> 2] = HEAP32[i71 >> 2];
        __ZL32TransformParticleMeshAnimatedUVsILb1EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i46, i9, i66, i6, i79, i7, i8, i69, i70, i68, i65, i73);
       }
       i7 = HEAP32[i46 >> 2] | 0;
       i5 = i7 + -2 | 0;
       if ((i7 | 0) > 2) {
        i6 = HEAP32[i48 >> 2] | 0;
        i4 = 0;
        do {
         HEAP16[i2 + (i4 << 1) >> 1] = (HEAPU16[i6 + (i4 << 1) >> 1] | 0) + i3;
         i9 = i4 + 1 | 0;
         HEAP16[i2 + (i9 << 1) >> 1] = (HEAPU16[i6 + (i9 << 1) >> 1] | 0) + i3;
         i9 = i4 + 2 | 0;
         HEAP16[i2 + (i9 << 1) >> 1] = (HEAPU16[i6 + (i9 << 1) >> 1] | 0) + i3;
         i4 = i4 + 3 | 0;
        } while ((i4 | 0) < (i5 | 0));
       }
       i4 = 1;
       i2 = i2 + (i7 << 1) | 0;
       i3 = (HEAP32[(HEAP32[i47 >> 2] | 0) + 100 >> 2] | 0) + i3 | 0;
      }
      i10 = i10 + 1 | 0;
      if (!(i10 >>> 0 < i13 >>> 0 & i4)) break; else i7 = i1;
     }
    }
    break;
   }
   HEAP32[i73 >> 2] = i1;
   f56 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 652 >> 2]);
   f57 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 660 >> 2]);
   f58 = Math_fround(HEAPF32[i76 + (i77 * 788 | 0) + 656 >> 2]);
   i52 = HEAP32[i13 >> 2] | 0;
   f33 = Math_fround(Math_fround(1.0) / Math_fround(i2 & 65535));
   if (i52 | 0) {
    i13 = i65 + 20 | 0;
    i21 = i65 + 40 | 0;
    i22 = i67 + 4 | 0;
    i23 = i67 + 8 | 0;
    i24 = i74 + 4 | 0;
    i25 = i65 + 520 | 0;
    i26 = i68 + 4 | 0;
    i27 = i68 + 8 | 0;
    i28 = i65 + 870 | 0;
    i29 = i65 + 240 | 0;
    i30 = i65 + 260 | 0;
    i31 = i65 + 280 | 0;
    f55 = Math_fround(HEAPF32[gb + 62452 >> 2]);
    i32 = i65 + 340 | 0;
    i34 = i79 + 12 | 0;
    i35 = i79 + 4 | 0;
    i36 = i79 + 8 | 0;
    i37 = i69 + 4 | 0;
    i38 = i69 + 8 | 0;
    i39 = i69 + 16 | 0;
    i40 = i69 + 20 | 0;
    i41 = i69 + 24 | 0;
    i42 = i69 + 32 | 0;
    i43 = i69 + 36 | 0;
    i44 = i69 + 40 | 0;
    i45 = i65 + 500 | 0;
    i11 = i76 + (i77 * 788 | 0) + 672 | 0;
    i12 = i76 + (i77 * 788 | 0) + 678 | 0;
    i46 = i76 + (i77 * 788 | 0) + 420 | 0;
    i47 = i65 + 300 | 0;
    i48 = i65 + 320 | 0;
    i49 = i70 + 4 | 0;
    i50 = i70 + 8 | 0;
    i51 = i74 + 8 | 0;
    i7 = 0;
    i2 = 0;
    i10 = 0;
    while (1) {
     i1 = HEAP32[i62 >> 2] | 0;
     if (!i1) i9 = i10; else i9 = HEAP32[i1 + (i10 << 3) >> 2] | 0;
     i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i9 << 2) >> 2] | 0;
     i54 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i9 << 2) >> 2] | 0;
     HEAP32[i67 >> 2] = HEAP32[(HEAP32[i65 >> 2] | 0) + (i9 << 2) >> 2];
     HEAP32[i22 >> 2] = i8;
     HEAP32[i23 >> 2] = i54;
     f14 = Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + (i9 << 2) >> 2]);
     if (!(HEAP8[i64 >> 0] | 0)) {
      f15 = f14;
      f16 = f14;
     } else {
      f16 = Math_fround(HEAPF32[(HEAP32[i51 >> 2] | 0) + (i9 << 2) >> 2]);
      f15 = Math_fround(HEAPF32[(HEAP32[i63 >> 2] | 0) + (i9 << 2) >> 2]);
     }
     if (Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + (i9 << 2) >> 2]) >= Math_fround(100.0)) {
      f14 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
      f16 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
      f15 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
     }
     i6 = HEAP32[(HEAP32[i74 >> 2] | 0) + (i9 << 2) >> 2] | 0;
     f19 = Math_fround(-Math_fround(f57 * f16));
     f20 = Math_fround(f58 * f15);
     HEAPF32[i68 >> 2] = Math_fround(f56 * f14);
     HEAPF32[i26 >> 2] = f19;
     HEAPF32[i27 >> 2] = f20;
     if (!(HEAP8[i28 >> 0] | 0)) {
      f17 = Math_fround(HEAPF32[(HEAP32[i29 >> 2] | 0) + (i9 << 2) >> 2]);
      f18 = Math_fround(HEAPF32[(HEAP32[i30 >> 2] | 0) + (i9 << 2) >> 2]);
      f19 = Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + (i9 << 2) >> 2]);
      f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19))));
      if (f20 > f55) {
       f17 = Math_fround(f17 / f20);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       f18 = Math_fround(f18 / f20);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
       f20 = Math_fround(f19 / f20);
       i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
      } else {
       i1 = HEAP32[gb + 62536 >> 2] | 0;
       i4 = HEAP32[gb + 62536 + 4 >> 2] | 0;
       i5 = HEAP32[gb + 62536 + 8 >> 2] | 0;
      }
      f19 = Math_fround(Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + (i9 << 2) >> 2]) * Math_fround(.5));
      f20 = Math_fround(+Math_sin(+f19));
      HEAPF32[i34 >> 2] = Math_fround(+Math_cos(+f19));
      HEAPF32[i79 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f20);
      HEAPF32[i35 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f20);
      HEAPF32[i36 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f20);
      __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i69, i67, i79);
     } else {
      i8 = HEAP32[(HEAP32[i48 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      i54 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      HEAP32[i70 >> 2] = HEAP32[(HEAP32[i47 >> 2] | 0) + (i9 << 2) >> 2];
      HEAP32[i49 >> 2] = i8;
      HEAP32[i50 >> 2] = i54;
      __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i79, i70, 4);
      __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i69, i67, i79);
     }
     __ZN10Matrix3x3fC2ERK10Matrix4x4f(i70, i69);
     HEAPF32[i69 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i69 >> 2]));
     HEAPF32[i37 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i37 >> 2]));
     HEAPF32[i38 >> 2] = Math_fround(f14 * Math_fround(HEAPF32[i38 >> 2]));
     HEAPF32[i39 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i40 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i40 >> 2]));
     HEAPF32[i41 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i41 >> 2]));
     HEAPF32[i42 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i42 >> 2]));
     HEAPF32[i43 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i43 >> 2]));
     HEAPF32[i44 >> 2] = Math_fround(f15 * Math_fround(HEAPF32[i44 >> 2]));
     if (!i60) {
      i5 = i69;
      i8 = __ZN10Matrix4x4f5ScaleERK8Vector3f(i69, i46) | 0;
      i4 = i5 + 64 | 0;
      do {
       HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
       i5 = i5 + 4 | 0;
       i8 = i8 + 4 | 0;
      } while ((i5 | 0) < (i4 | 0));
     }
     i54 = (HEAP32[(HEAP32[i45 >> 2] | 0) + (i9 << 2) >> 2] | 0) + -1135456673 | 0;
     i1 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
     i54 = i54 << 11 ^ i54;
     f14 = Math_fround(Math_fround(((i1 ^ i54 ^ i54 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
     i1 = HEAP16[i53 >> 1] | 0;
     L103 : do if (!(i1 << 16 >> 16)) i4 = 0; else {
      i5 = i1 & 65535;
      i1 = 0;
      while (1) {
       i4 = i1;
       i1 = i1 + 1 | 0;
       if (f14 >= Math_fround(f33 * Math_fround(i4 | 0))) if (f14 <= Math_fround(f33 * Math_fround(i1 | 0))) break L103;
       if ((i1 | 0) >= (i5 | 0)) {
        i4 = 0;
        break;
       }
      }
     } while (0);
     i1 = i76 + (i77 * 788 | 0) + 536 + (i4 * 12 | 0) | 0;
     i8 = i76 + (i77 * 788 | 0) + 536 + (i4 * 12 | 0) + 8 | 0;
     if (((HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0) + i7 | 0) >>> 0 > 65534) {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i4 = 0;
       i1 = 0;
       i2 = 8;
      } else {
       i7 = 0;
       i75 = 72;
      }
     } else i75 = 72;
     if ((i75 | 0) == 72) {
      i75 = 0;
      if (!(HEAP32[i59 >> 2] & 268435456)) {
       HEAP32[i72 >> 2] = i6;
       i6 = HEAP32[i11 >> 2] | 0;
       i54 = HEAP16[i12 >> 1] | 0;
       HEAP32[i79 >> 2] = HEAP32[i72 >> 2];
       __ZL32TransformParticleMeshAnimatedUVsILb0EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i1, i9, i79, i6, i54, i69, i70, i68, i65, i73);
      } else {
       HEAP32[i71 >> 2] = i6;
       i5 = HEAP32[i61 >> 2] | 0;
       i6 = HEAP32[i11 >> 2] | 0;
       i54 = HEAP16[i12 >> 1] | 0;
       HEAP32[i79 >> 2] = HEAP32[i71 >> 2];
       __ZL32TransformParticleMeshAnimatedUVsILb1EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh(i1, i9, i66, i5, i79, i6, i54, i69, i70, i68, i65, i73);
      }
      i5 = HEAP32[i1 >> 2] | 0;
      i6 = i5 + -2 | 0;
      if ((i5 | 0) > 2) {
       i4 = HEAP32[i76 + (i77 * 788 | 0) + 536 + (i4 * 12 | 0) + 4 >> 2] | 0;
       i1 = 0;
       do {
        HEAP16[i3 + (i1 << 1) >> 1] = (HEAPU16[i4 + (i1 << 1) >> 1] | 0) + i7;
        i54 = i1 + 1 | 0;
        HEAP16[i3 + (i54 << 1) >> 1] = (HEAPU16[i4 + (i54 << 1) >> 1] | 0) + i7;
        i54 = i1 + 2 | 0;
        HEAP16[i3 + (i54 << 1) >> 1] = (HEAPU16[i4 + (i54 << 1) >> 1] | 0) + i7;
        i1 = i1 + 3 | 0;
       } while ((i1 | 0) < (i6 | 0));
      }
      i3 = i3 + (i5 << 1) | 0;
      i4 = 1;
      i1 = (HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0) + i7 | 0;
     }
     i10 = i10 + 1 | 0;
     if (!(i10 >>> 0 < i52 >>> 0 & i4)) break; else i7 = i1;
    }
   }
  } while (0);
  i1 = HEAP32[i74 >> 2] | 0;
  if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 }
 i5 = i76 + (i77 * 788 | 0) + 748 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = i76 + (i77 * 788 | 0) + 432 | 0;
  i2 = HEAP16[i4 >> 1] | 0;
  if (i2 << 16 >> 16) {
   i3 = 0;
   i1 = i2;
   do {
    i2 = HEAP32[i76 + (i77 * 788 | 0) + 536 + (i3 * 12 | 0) + 8 >> 2] | 0;
    i75 = i2 + 4 | 0;
    HEAP32[i75 >> 2] = (HEAP32[i75 >> 2] | 0) + -1;
    if (!(HEAP32[i75 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
     i1 = HEAP16[i4 >> 1] | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i1 & 65535 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i75 = i1 + 884 | 0;
  HEAP32[i75 >> 2] = (HEAP32[i75 >> 2] | 0) + -1;
  if (!(HEAP32[i75 >> 2] | 0)) {
   i74 = gb + 63264 | 0;
   i75 = HEAP32[i74 + 4 >> 2] | 0;
   i1 = i78;
   HEAP32[i1 >> 2] = HEAP32[i74 >> 2];
   HEAP32[i1 + 4 >> 2] = i75;
   HEAP32[i79 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i79 + 4 >> 2] = HEAP32[i78 + 4 >> 2];
   __ZN32ParticleSystemGeometryJobModules7ReleaseE10MemLabelId(i76 + (i77 * 788 | 0) + 752 | 0, i79);
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) __ZN23ParticleSystemParticlesD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
   HEAP32[i5 >> 2] = 0;
  }
 }
 if (!i80) {
  STACKTOP = i81;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i80);
 STACKTOP = i81;
 return;
}

function __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb(i21, i1, i13, i23) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i32 + 8 | 0;
 i26 = i32;
 i30 = i32 + 40 | 0;
 i31 = i32 + 20 | 0;
 if ((HEAP16[gb + 1466800 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466800 | 0, i25);
  i27 = gb + 1466800 | 0;
 } else i27 = 0;
 i22 = HEAP32[i21 + 12 >> 2] | 0;
 i14 = (i22 | 0) == 0;
 if (i14) f29 = Math_fround(0.0); else {
  i20 = __ZN18PlayableController12GetFrameDataEv(HEAP32[HEAP32[i21 >> 2] >> 2] | 0) | 0;
  f29 = Math_fround(+HEAPF64[i20 + 8 >> 3] - +HEAPF64[i20 + 32 >> 3]);
 }
 f28 = Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 184 >> 3]);
 if (i1) {
  i12 = gb + 64016 | 0;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i10 = i26;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i30 >> 2] = 0;
  i10 = i30 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i30 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i30 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i26);
  i19 = i25;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i12;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = i20;
  i1 = HEAP32[i11 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i22 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i11 >> 2] = i22;
   HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i22 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i20 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i11 >> 2] = i22;
   HEAP32[i30 >> 2] = i20;
   break;
  } while (0);
  if ((HEAP16[gb + 1466812 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466812 | 0, i25);
   i9 = gb + 1466812 | 0;
  } else i9 = 0;
  if (!i14) {
   i8 = 0;
   do {
    i1 = HEAP32[i21 >> 2] | 0;
    i3 = HEAP32[i1 + (i8 * 24 | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i1 + (i8 * 24 | 0) + 12 >> 2] | 0;
    L22 : do if (i2 | 0) {
     __ZN8Animator11SetPlayableEP8Playablei(i3, i2, HEAP32[i1 + (i8 * 24 | 0) + 8 >> 2] | 0);
     i1 = i3 + 628 | 0;
     if (__ZNK9HPlayable7IsValidEv(i1) | 0) if (HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0 | i23) {
      i2 = i3 + 153 | 0;
      if (!(HEAP8[i2 >> 0] | 0)) i24 = 43; else if (!(HEAP32[i3 + 168 >> 2] | 0)) i24 = 43;
      if ((i24 | 0) == 43) {
       i24 = 0;
       __ZN8Animator12CreateObjectEv(i3);
      }
      if (HEAP32[i3 + 108 >> 2] | 0) {
       i1 = HEAP32[i3 + 624 >> 2] | 0;
       if (i1 | 0) {
        i1 = HEAP32[i1 + 96 >> 2] | 0;
        if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i3 + 420 >> 2];
       }
      }
      if (HEAP8[i2 >> 0] | 0) if (HEAP32[i3 + 168 >> 2] | 0) {
       do if (!(HEAP8[(HEAP32[i3 + 136 >> 2] | 0) + 136 >> 0] | 0)) {
        if (HEAP8[i3 + 88 >> 0] | 0) break;
        if ((HEAP32[i3 + 92 >> 2] | 0) == 2) break L22;
       } while (0);
       i2 = i3;
       i3 = HEAP32[i10 >> 2] | 0;
       i4 = i3 + 1 | 0;
       i5 = HEAP32[i11 >> 2] | 0;
       i7 = i5 & 2147483647;
       do if (i4 >>> 0 > i7 >>> 0) {
        i1 = i5 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i7 >>> 0 >= i1 >>> 0) break;
        if ((i5 | 0) > -1) {
         HEAP32[i11 >> 2] = i1;
         HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i20 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
         HEAP32[i11 >> 2] = i1;
         HEAP32[i30 >> 2] = i20;
         break;
        }
       } while (0);
       HEAP32[i10 >> 2] = i4;
       HEAP32[(HEAP32[i30 >> 2] | 0) + (i3 << 2) >> 2] = i2;
      }
     }
    } while (0);
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != (i22 | 0));
  }
  L52 : do if (!(HEAP32[i10 >> 2] | 0)) i1 = 0; else {
   if (i23) {
    i5 = 0;
    while (1) {
     i4 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i5 << 2) >> 2] | 0;
     if ((HEAP32[i4 + 96 >> 2] | 0) == 2) if (__Z14IsWorldPlayingv() | 0) f6 = f28; else i24 = 18; else i24 = 18;
     if ((i24 | 0) == 18) {
      i24 = 0;
      f6 = f29;
     }
     i2 = i4 + 548 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) == 2) if (Math_fround(HEAPF32[i4 + 420 >> 2]) < Math_fround(0.0)) {
      __ZN8Animator23SetPlaybackTimeInternalEf(i4, Math_fround(f6 + Math_fround(__ZN14AvatarPlayback10CursorTimeEv(i4 + 504 | 0))));
      i1 = HEAP32[i2 >> 2] | 0;
     } else i24 = 21; else i24 = 21;
     if ((i24 | 0) == 21) {
      i24 = 0;
      HEAPF32[HEAP32[i4 + 128 >> 2] >> 2] = f6;
     }
     switch (i1 | 0) {
     case 1:
      {
       i24 = 25;
       break;
      }
     case 2:
      {
       if (Math_fround(HEAPF32[i4 + 420 >> 2]) < Math_fround(0.0)) i24 = 25;
       break;
      }
     default:
      {}
     }
     if ((i24 | 0) == 25) {
      i24 = 0;
      i20 = i4 + 552 | 0;
      HEAP32[HEAP32[i4 + 128 >> 2] >> 2] = HEAP32[i20 >> 2];
      HEAPF32[i20 >> 2] = Math_fround(0.0);
     }
     i2 = i4 + 128 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     HEAP8[i1 + 18 >> 0] = HEAP8[i4 + 418 >> 0] | 0;
     i3 = i4 + 188 | 0;
     if (HEAP32[i3 >> 2] | 0) {
      __Z21CompleteFenceInternalR8JobFence(i3);
      i1 = HEAP32[i2 >> 2] | 0;
     }
     HEAP8[(HEAP32[i4 + 136 >> 2] | 0) + 137 >> 0] = 0;
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     i3 = i4 + 624 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i1 + 100 >> 2] | 0;
      do if (!(HEAP32[i2 + 20 >> 2] | 0)) {
       if (f6 == Math_fround(0.0)) {
        i20 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0;
        i1 = HEAP32[i3 >> 2] | 0;
        if (i20) break;
        i2 = HEAP32[i1 + 100 >> 2] | 0;
       }
       HEAP32[i2 + 20 >> 2] = 1;
      } while (0);
      __ZN26AnimatorControllerPlayable11UpdateGraphEf(i1, f6);
      __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[i3 >> 2] | 0, i4 + 40 | 0);
     }
     i5 = i5 + 1 | 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if (i5 >>> 0 >= i1 >>> 0) break L52;
    }
   } else i7 = 0;
   while (1) {
    i5 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    if ((HEAP32[i5 + 96 >> 2] | 0) == 2) if (__Z14IsWorldPlayingv() | 0) f6 = f28; else i24 = 65; else i24 = 65;
    if ((i24 | 0) == 65) {
     i24 = 0;
     f6 = f29;
    }
    i4 = i5 + 548 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) == 2) if (Math_fround(HEAPF32[i5 + 420 >> 2]) < Math_fround(0.0)) {
     __ZN8Animator23SetPlaybackTimeInternalEf(i5, Math_fround(f6 + Math_fround(__ZN14AvatarPlayback10CursorTimeEv(i5 + 504 | 0))));
     i1 = HEAP32[i4 >> 2] | 0;
    } else i24 = 69; else i24 = 69;
    if ((i24 | 0) == 69) {
     i24 = 0;
     HEAPF32[HEAP32[i5 + 128 >> 2] >> 2] = f6;
    }
    switch (i1 | 0) {
    case 1:
     {
      i24 = 72;
      break;
     }
    case 2:
     {
      if (Math_fround(HEAPF32[i5 + 420 >> 2]) < Math_fround(0.0)) i24 = 72;
      break;
     }
    default:
     {}
    }
    if ((i24 | 0) == 72) {
     i24 = 0;
     i20 = i5 + 552 | 0;
     HEAP32[HEAP32[i5 + 128 >> 2] >> 2] = HEAP32[i20 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
    }
    i3 = i5 + 128 | 0;
    HEAP8[(HEAP32[i3 >> 2] | 0) + 18 >> 0] = HEAP8[i5 + 418 >> 0] | 0;
    i2 = i5 + 188 | 0;
    if (HEAP32[i2 >> 2] | 0) {
     __Z21CompleteFenceInternalR8JobFence(i2);
     i1 = HEAP32[i4 >> 2] | 0;
    }
    HEAP8[(HEAP32[i5 + 136 >> 2] | 0) + 137 >> 0] = 0;
    switch (i1 | 0) {
    case 1:
     {
      i24 = 77;
      break;
     }
    case 2:
     {
      if (Math_fround(HEAPF32[i5 + 420 >> 2]) < Math_fround(0.0)) i24 = 77;
      break;
     }
    default:
     {}
    }
    if ((i24 | 0) == 77) {
     i24 = 0;
     f6 = Math_fround(HEAPF32[HEAP32[i3 >> 2] >> 2]);
     i3 = i5 + 624 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i1 + 100 >> 2] | 0;
      do if (!(HEAP32[i2 + 20 >> 2] | 0)) {
       if (f6 == Math_fround(0.0)) {
        i20 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0;
        i1 = HEAP32[i3 >> 2] | 0;
        if (i20) break;
        i2 = HEAP32[i1 + 100 >> 2] | 0;
       }
       HEAP32[i2 + 20 >> 2] = 1;
      } while (0);
      __ZN26AnimatorControllerPlayable11UpdateGraphEf(i1, f6);
      __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[i3 >> 2] | 0, i5 + 40 | 0);
     }
    }
    i7 = i7 + 1 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
    if (i7 >>> 0 >= i1 >>> 0) break L52;
   }
  } while (0);
  if (i9) {
   __Z12profiler_endP19ProfilerInformation(i9);
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i5 = HEAP32[i30 >> 2] | 0;
  if (i1 | 0) {
   i4 = 0;
   do {
    i2 = i5 + (i4 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (HEAP8[i3 + 153 >> 0] | 0) if (HEAP32[i3 + 168 >> 2] | 0) {
     __ZN8Animator21ProcessAnimationsStepEv(i3);
     i2 = HEAP32[i2 >> 2] | 0;
     if (__ZNK9HPlayable7IsValidEv(i2 + 628 | 0) | 0) if (!(HEAP32[i2 + 100 >> 2] & 8)) {
      i20 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
      mftCall_vifi(HEAP32[(HEAP32[i20 >> 2] | 0) + 88 >> 2] | 0, i20 | 0, 1.0, i2 + 564 | 0);
     }
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i1 | 0));
  }
  if ((HEAP16[gb + 1466824 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466824 | 0, i25);
   i2 = gb + 1466824 | 0;
  } else i2 = 0;
  i3 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
  if (HEAP32[i10 >> 2] | 0) {
   i1 = 0;
   do {
    i4 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i5 = i4 + 153 | 0;
    if (HEAP8[i5 >> 0] | 0) {
     i7 = i4 + 168 | 0;
     if (HEAP32[i7 >> 2] | 0) {
      __ZN8Animator19FireAnimationEventsEv(i4);
      if (HEAP8[i5 >> 0] | 0) if (HEAP32[i7 >> 2] | 0) __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE(i4, 7) | 0;
     }
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  }
  __Z24SetExecutionRestrictions21ExecutionRestrictions(i3) | 0;
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  if ((HEAP16[gb + 1466836 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466836 | 0, i25);
   i3 = gb + 1466836 | 0;
  } else i3 = 0;
  if (HEAP32[i10 >> 2] | 0) {
   i1 = 0;
   do {
    i4 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    do if (HEAP8[i4 + 153 >> 0] | 0) if (HEAP32[i4 + 168 >> 2] | 0) {
     __ZN8Animator19ApplyOnAnimatorMoveEv(i4);
     i5 = i4 + 584 | 0;
     i7 = i4 + 596 | 0;
     if (HEAP32[i7 >> 2] | 0) {
      i2 = HEAP32[i5 >> 2] | 0;
      do {
       __ZN26AnimatorControllerPlayable24ClearFirstEvaluationFlagEv(HEAP32[i2 >> 2] | 0);
       i2 = i2 + 4 | 0;
      } while ((i2 | 0) != ((HEAP32[i5 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0));
     }
     if (HEAP8[i4 + 88 >> 0] | 0) break;
     __ZN7mecanim9animation31UpdateAvatarMemoryFirstEvalFlagEPNS0_12AvatarMemoryEf(HEAP32[i4 + 136 >> 2] | 0, f29);
    } while (0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  }
  if (i3 | 0) __Z12profiler_endP19ProfilerInformation(i3);
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i12);
   HEAP32[i30 >> 2] = 0;
  }
 }
 if (i13) {
  i20 = gb + 64016 | 0;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = i26;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  HEAP32[i30 >> 2] = 0;
  i18 = i30 + 12 | 0;
  HEAP32[i18 >> 2] = 0;
  i19 = i30 + 16 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i30 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i26);
  i16 = i25;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = i20;
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = i17;
  i1 = HEAP32[i19 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i22 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i19 >> 2] = i22;
   HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i22 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i17 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
   HEAP32[i19 >> 2] = i22;
   HEAP32[i30 >> 2] = i17;
   break;
  } while (0);
  i17 = gb + 64016 | 0;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i15 = i26;
  HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i15 + 4 >> 2] = i16;
  HEAP32[i31 >> 2] = 0;
  i15 = i31 + 12 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i31 + 16 | 0;
  HEAP32[i16 >> 2] = 0;
  i17 = i31 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i26);
  i12 = i25;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i17;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  i1 = HEAP32[i16 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i22 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i16 >> 2] = i22;
   HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i22 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
   HEAP32[i16 >> 2] = i22;
   HEAP32[i31 >> 2] = i13;
   break;
  } while (0);
  if ((HEAP16[gb + 1466848 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466848 | 0, i25);
   i11 = gb + 1466848 | 0;
  } else i11 = 0;
  if (i14) i14 = 0; else {
   i1 = 0;
   i10 = 0;
   do {
    i9 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i10 * 24 | 0) + 4 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 112 >> 2] | 0, i9 | 0) | 0 | i23) {
     i3 = i9 + 153 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) i24 = 138; else if (!(HEAP32[i9 + 168 >> 2] | 0)) i24 = 138;
     if ((i24 | 0) == 138) {
      i24 = 0;
      __ZN8Animator12CreateObjectEv(i9);
     }
     if (HEAP32[i9 + 108 >> 2] | 0) {
      i2 = HEAP32[i9 + 624 >> 2] | 0;
      if (i2 | 0) {
       i2 = HEAP32[i2 + 96 >> 2] | 0;
       if (i2 | 0) HEAP32[i2 >> 2] = HEAP32[i9 + 420 >> 2];
      }
     }
     if (HEAP8[i3 >> 0] | 0) if (HEAP32[i9 + 168 >> 2] | 0) if (HEAP8[i9 + 88 >> 0] | 0) {
      i8 = i9;
      i3 = HEAP32[i18 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i5 = HEAP32[i19 >> 2] | 0;
      i7 = i5 & 2147483647;
      do if (i4 >>> 0 > i7 >>> 0) {
       i2 = i5 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i7 >>> 0 >= i2 >>> 0) break;
       if ((i5 | 0) > -1) {
        HEAP32[i19 >> 2] = i2;
        HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i2 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i14 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
        HEAP32[i19 >> 2] = i2;
        HEAP32[i30 >> 2] = i14;
        break;
       }
      } while (0);
      HEAP32[i18 >> 2] = i4;
      HEAP32[(HEAP32[i30 >> 2] | 0) + (i3 << 2) >> 2] = i8;
      i3 = i9 + 584 | 0;
      i4 = i9 + 596 | 0;
      if (HEAP32[i4 >> 2] | 0) {
       i2 = HEAP32[i3 >> 2] | 0;
       do {
        i14 = __ZNK26AnimatorControllerPlayable13GetLayerCountEv(HEAP32[i2 >> 2] | 0) | 0;
        i1 = (i14 | 0) > (i1 | 0) ? i14 : i1;
        i2 = i2 + 4 | 0;
       } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
      }
      if (__ZNK8Animator7IsHumanEv(i9) | 0) {
       i3 = HEAP32[i15 >> 2] | 0;
       i4 = i3 + 1 | 0;
       i5 = HEAP32[i16 >> 2] | 0;
       i7 = i5 & 2147483647;
       do if (i4 >>> 0 > i7 >>> 0) {
        i2 = i5 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i7 >>> 0 >= i2 >>> 0) break;
        if ((i5 | 0) > -1) {
         HEAP32[i16 >> 2] = i2;
         HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i2 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i14 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
         HEAP32[i16 >> 2] = i2;
         HEAP32[i31 >> 2] = i14;
         break;
        }
       } while (0);
       HEAP32[i15 >> 2] = i4;
       HEAP32[(HEAP32[i31 >> 2] | 0) + (i3 << 2) >> 2] = i8;
       i2 = HEAP32[i9 + 140 >> 2] | 0;
       HEAP8[i2 + 52 >> 0] = 1;
       HEAP8[i2 + 53 >> 0] = 1;
      } else i2 = HEAP32[i9 + 140 >> 2] | 0;
      HEAP8[i2 + 54 >> 0] = 1;
     }
    }
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i22 | 0));
   i14 = i1;
  }
  if (i11 | 0) __Z12profiler_endP19ProfilerInformation(i11);
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i31 >> 2] | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (HEAP8[i4 + 153 >> 0] | 0) if (HEAP32[i4 + 168 >> 2] | 0) __ZN8Animator12RetargetStepEv(i4);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i31 >> 2] | 0;
   if (i2 | 0) {
    i1 = 0;
    do {
     i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
     if (HEAP8[i4 + 153 >> 0] | 0) if (HEAP32[i4 + 168 >> 2] | 0) __ZN8Animator6IKStepEv(i4);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
    i2 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i31 >> 2] | 0;
    if (i2 | 0) {
     i1 = 0;
     do {
      i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
      if (HEAP8[i4 + 153 >> 0] | 0) if (HEAP32[i4 + 168 >> 2] | 0) __ZN8Animator9WriteStepEv(i4);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
  }
  if ((i14 | 0) > 0) {
   i12 = i25 + 8 | 0;
   i13 = i25 + 4 | 0;
   i11 = 0;
   do {
    if (HEAP32[i15 >> 2] | 0) {
     i10 = 0;
     i5 = HEAP32[i31 >> 2] | 0;
     do {
      i7 = HEAP32[i5 + (i10 << 2) >> 2] | 0;
      i4 = i7 + 584 | 0;
      i8 = i7 + 153 | 0;
      i9 = i7 + 168 | 0;
      i5 = i7 + 596 | 0;
      if (!(HEAP32[i5 >> 2] | 0)) i1 = 0; else {
       i3 = HEAP32[i4 >> 2] | 0;
       i1 = 0;
       do {
        if (!(HEAP8[i8 >> 0] | 0)) break;
        if (!(HEAP32[i9 >> 2] | 0)) break;
        i24 = HEAP32[i3 >> 2] | 0;
        if (mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 180 >> 2] | 0, i24 | 0) | 0) {
         i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0;
         if ((HEAP32[i2 >> 2] | 0) > (i11 | 0)) {
          i2 = i2 + 4 | 0;
          i2 = (HEAP32[i2 >> 2] | 0) + i2 + (i11 << 2) | 0;
          i2 = (HEAP8[i2 + (HEAP32[i2 >> 2] | 0) + 36 >> 0] | 0) != 0;
         } else i2 = 0;
         i1 = i1 | i2;
        }
        i3 = i3 + 4 | 0;
       } while ((i3 | 0) != ((HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
       if (i1) {
        i2 = i7 + 100 | 0;
        HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 4;
        if (HEAP32[(HEAP32[i7 + 28 >> 2] | 0) + 60 >> 2] & 128 | 0) {
         HEAP32[i25 >> 2] = gb + 29192;
         HEAP32[i12 >> 2] = 0;
         HEAP32[i13 >> 2] = i11;
         __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i7, gb + 1105476 | 0, i25);
        }
        i24 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
        __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE(i7, 16) | 0;
        __Z24SetExecutionRestrictions21ExecutionRestrictions(i24) | 0;
        HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -5;
       } else i1 = 0;
      }
      do if (HEAP8[i8 >> 0] | 0) {
       if (!(HEAP32[i9 >> 2] | 0)) break;
       i24 = HEAP32[i7 + 140 >> 2] | 0;
       HEAP8[i24 + 52 >> 0] = 0;
       i23 = i1 & 1;
       HEAP8[i24 + 53 >> 0] = i23;
       HEAP8[i24 + 54 >> 0] = i23;
      } while (0);
      i10 = i10 + 1 | 0;
      i3 = HEAP32[i15 >> 2] | 0;
      i5 = HEAP32[i31 >> 2] | 0;
     } while (i10 >>> 0 < i3 >>> 0);
     if (!i3) {
      i4 = 0;
      i2 = i5;
     } else {
      i1 = 0;
      do {
       i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
       do if (HEAP8[i2 + 153 >> 0] | 0) {
        if (!(HEAP32[i2 + 168 >> 2] | 0)) break;
        __ZN8Animator6IKStepEv(i2);
       } while (0);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
      i4 = HEAP32[i15 >> 2] | 0;
      i2 = HEAP32[i31 >> 2] | 0;
     }
     if (i4 | 0) {
      i1 = 0;
      do {
       i3 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
       do if (HEAP8[i3 + 153 >> 0] | 0) {
        if (!(HEAP32[i3 + 168 >> 2] | 0)) break;
        __ZN8Animator9WriteStepEv(i3);
       } while (0);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i4 | 0));
     }
    }
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i14 | 0));
  }
  i2 = HEAP32[i18 >> 2] | 0;
  i3 = HEAP32[i30 >> 2] | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (HEAP8[i4 + 153 >> 0] | 0) if (HEAP32[i4 + 168 >> 2] | 0) __ZN8Animator9WriteStepEv(i4);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  if ((HEAP16[gb + 1466860 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466860 | 0, i25);
   i2 = gb + 1466860 | 0;
  } else i2 = 0;
  i3 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
  if (HEAP32[i18 >> 2] | 0) {
   i1 = 0;
   do {
    __ZN8Animator15WritePropertiesEff(HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0, f29, f28);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
  }
  __Z24SetExecutionRestrictions21ExecutionRestrictions(i3) | 0;
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  if ((HEAP32[i16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i17);
   HEAP32[i31 >> 2] = 0;
  }
  if ((HEAP32[i19 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i20);
   HEAP32[i30 >> 2] = 0;
  }
 }
 if (!i27) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i27);
 STACKTOP = i32;
 return;
}

function __Z15DecodeBC6HBlockP9HDRColorAPKh(i31, i32) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34;
 i29 = HEAPU8[i32 >> 0] | 0;
 i30 = i29 & 3;
 i1 = (i30 & 255) < 2;
 i29 = i1 ? i30 : i29 & 31;
 i30 = HEAP32[gb + 46504 + (i29 << 2) >> 2] | 0;
 if (!(1145359567 >>> i29 & 1)) {
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 28 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 56 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 64 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 72 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 76 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 88 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 92 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 96 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 100 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 104 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 108 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 116 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 120 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 124 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 128 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 132 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 136 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 140 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 144 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 148 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 152 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 156 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 160 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 164 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 168 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 172 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 176 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 180 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 184 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 188 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 192 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 196 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 200 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 204 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 208 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 212 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 216 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 220 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 224 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 228 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 232 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 236 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 240 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 244 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 248 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 252 >> 2] = Math_fround(1.0);
  STACKTOP = i34;
  return;
 }
 i3 = i1 ? 2 : 5;
 i1 = i33;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i28 = HEAP8[gb + 1546029 + (i30 * 20 | 0) + 1 >> 0] | 0;
 i29 = i28 << 24 >> 24 != 0;
 i16 = i29 ? 82 : 65;
 i17 = i33 + 16 | 0;
 i18 = i33 + 32 | 0;
 i19 = i33 + 48 | 0;
 i20 = i33 + 4 | 0;
 i21 = i33 + 20 | 0;
 i22 = i33 + 36 | 0;
 i23 = i33 + 52 | 0;
 i24 = i33 + 8 | 0;
 i25 = i33 + 24 | 0;
 i26 = i33 + 40 | 0;
 i27 = i33 + 56 | 0;
 i15 = 0;
 i2 = i3;
 i14 = 0;
 i3 = 0;
 i4 = 0;
 i5 = 0;
 i6 = 0;
 i7 = 0;
 i8 = 0;
 i9 = 0;
 i10 = 0;
 i11 = 0;
 i12 = 0;
 i13 = 0;
 L5 : while (1) {
  i35 = i2 >>> 3;
  i1 = i2;
  i2 = i2 + 1 | 0;
  L7 : do if (!(HEAPU8[i32 + i35 >> 0] & 1 << i1 - (i35 << 3))) i1 = i14; else do switch (HEAP32[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) >> 2] | 0) {
  case 2:
   {
    i15 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i15;
    i1 = i14;
    break L7;
   }
  case 3:
   {
    i5 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i5;
    HEAP32[i33 >> 2] = i5;
    i1 = i14;
    break L7;
   }
  case 4:
   {
    i6 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i6;
    HEAP32[i17 >> 2] = i6;
    i1 = i14;
    break L7;
   }
  case 5:
   {
    i7 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i7;
    HEAP32[i18 >> 2] = i7;
    i1 = i14;
    break L7;
   }
  case 6:
   {
    i8 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i8;
    HEAP32[i19 >> 2] = i8;
    i1 = i14;
    break L7;
   }
  case 7:
   {
    i9 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i9;
    HEAP32[i20 >> 2] = i9;
    i1 = i14;
    break L7;
   }
  case 8:
   {
    i10 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i10;
    HEAP32[i21 >> 2] = i10;
    i1 = i14;
    break L7;
   }
  case 9:
   {
    i11 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i11;
    HEAP32[i22 >> 2] = i11;
    i1 = i14;
    break L7;
   }
  case 10:
   {
    i12 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i12;
    HEAP32[i23 >> 2] = i12;
    i1 = i14;
    break L7;
   }
  case 11:
   {
    i13 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i13;
    HEAP32[i24 >> 2] = i13;
    i1 = i14;
    break L7;
   }
  case 12:
   {
    i1 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i14;
    HEAP32[i25 >> 2] = i1;
    break L7;
   }
  case 13:
   {
    i3 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i3;
    HEAP32[i26 >> 2] = i3;
    i1 = i14;
    break L7;
   }
  case 14:
   {
    i4 = 1 << HEAPU8[gb + 46632 + (i30 * 656 | 0) + (i1 << 3) + 4 >> 0] | i4;
    HEAP32[i27 >> 2] = i4;
    i1 = i14;
    break L7;
   }
  default:
   {
    i1 = 20;
    break L5;
   }
  } while (0); while (0);
  if (i2 >>> 0 >= i16 >>> 0) {
   i1 = 21;
   break;
  } else i14 = i1;
 }
 L24 : do if ((i1 | 0) == 20) {
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 28 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 56 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 64 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 72 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 76 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 88 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 92 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 96 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 100 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 104 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 108 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 116 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 120 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 124 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 128 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 132 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 136 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 140 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 144 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 148 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 152 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 156 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 160 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 164 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 168 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 172 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 176 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 180 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 184 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 188 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 192 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 196 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 200 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 204 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 208 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 212 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 216 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 220 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 224 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 228 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 232 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 236 >> 2] = Math_fround(1.0);
  HEAPF32[i31 + 240 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 244 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 248 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 252 >> 2] = Math_fround(1.0);
 } else if ((i1 | 0) == 21) {
  if (HEAP8[gb + 1546029 + (i30 * 20 | 0) + 2 >> 0] | 0) {
   i3 = i28 & 255;
   i1 = 0;
   while (1) {
    if (i1 | 0) {
     i35 = i33 + (i1 << 5) | 0;
     i16 = HEAP32[i35 >> 2] | 0;
     i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) >> 0] | 0;
     HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
     i35 = i33 + (i1 << 5) + 4 | 0;
     i16 = HEAP32[i35 >> 2] | 0;
     i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) + 1 >> 0] | 0;
     HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
     i35 = i33 + (i1 << 5) + 8 | 0;
     i16 = HEAP32[i35 >> 2] | 0;
     i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) + 2 >> 0] | 0;
     HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
    }
    i35 = i33 + (i1 << 5) + 16 | 0;
    i16 = HEAP32[i35 >> 2] | 0;
    i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) + 4 >> 0] | 0;
    HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
    i35 = i33 + (i1 << 5) + 20 | 0;
    i16 = HEAP32[i35 >> 2] | 0;
    i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) + 5 >> 0] | 0;
    HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
    i35 = i33 + (i1 << 5) + 24 | 0;
    i16 = HEAP32[i35 >> 2] | 0;
    i14 = HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 + (i1 << 3) + 6 >> 0] | 0;
    HEAP32[i35 >> 2] = ((1 << i14 + -1 & i16 | 0) == 0 ? 0 : -1 << i14) | i16;
    if ((i1 | 0) == (i3 | 0)) break; else i1 = i1 + 1 | 0;
   }
   i14 = (1 << HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 4 >> 0]) + -1 | 0;
   i16 = (1 << HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 5 >> 0]) + -1 | 0;
   i35 = (1 << HEAPU8[gb + 1546029 + (i30 * 20 | 0) + 6 >> 0]) + -1 | 0;
   i13 = HEAP32[i33 >> 2] | 0;
   i20 = HEAP32[i20 >> 2] | 0;
   i11 = (HEAP32[i21 >> 2] | 0) + i20 | 0;
   i24 = HEAP32[i24 >> 2] | 0;
   i12 = (HEAP32[i25 >> 2] | 0) + i24 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i13 & i14;
   HEAP32[i21 >> 2] = i11 & i16;
   HEAP32[i25 >> 2] = i12 & i35;
   i21 = (HEAP32[i22 >> 2] | 0) + i20 | 0;
   i25 = (HEAP32[i26 >> 2] | 0) + i24 | 0;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + i13 & i14;
   HEAP32[i22 >> 2] = i21 & i16;
   HEAP32[i26 >> 2] = i25 & i35;
   i25 = (HEAP32[i23 >> 2] | 0) + i20 | 0;
   i26 = (HEAP32[i27 >> 2] | 0) + i24 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i13 & i14;
   HEAP32[i23 >> 2] = i25 & i16;
   HEAP32[i27 >> 2] = i26 & i35;
  }
  i20 = gb + 1546029 + (i30 * 20 | 0) + 3 | 0;
  i21 = gb + 1546029 + (i30 * 20 | 0) + 4 | 0;
  i22 = gb + 1546029 + (i30 * 20 | 0) + 5 | 0;
  i19 = gb + 1546029 + (i30 * 20 | 0) + 6 | 0;
  i17 = i28 & 255;
  i18 = i29 ? 8 : 16;
  i16 = i29 ? gb + 46456 | 0 : gb + 46392 | 0;
  i14 = 0;
  while (1) {
   i1 = 0;
   while (1) {
    if ((HEAPU8[gb + 412525 + (i17 * 192 | 0) + (i15 * 3 | 0) + i1 >> 0] | 0) == (i14 | 0)) {
     i1 = -1;
     break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 > i17 >>> 0) {
     i1 = 0;
     break;
    }
   }
   i3 = (HEAPU8[i20 >> 0] | 0) + i1 | 0;
   i5 = i3 + i2 | 0;
   if (i5 >>> 0 > 128) {
    i1 = 32;
    break;
   }
   do if (!i3) {
    i1 = 0;
    i5 = i2;
   } else {
    i4 = i2 >>> 3;
    i1 = i2 - (i4 << 3) | 0;
    i2 = HEAP8[i32 + i4 >> 0] | 0;
    if ((i3 + i1 | 0) >>> 0 > 8) {
     i35 = 8 - i1 | 0;
     i1 = (HEAPU8[i32 + (i4 + 1) >> 0] & (1 << i3 - i35) + -1) << i35 | (i2 & 255) >>> i1;
     break;
    } else {
     i1 = (i2 & 255) >>> i1 & (1 << i3) + 255;
     break;
    }
   } while (0);
   i13 = i1 & 255;
   if (i13 >>> 0 >= i18 >>> 0) {
    i1 = 38;
    break;
   }
   i11 = HEAPU8[gb + 413101 + (i17 << 10) + (i15 << 4) + i14 >> 0] | 0;
   i1 = HEAP32[i33 + (i11 << 5) >> 2] | 0;
   i6 = HEAP8[i21 >> 0] | 0;
   i4 = i6 & 255;
   i6 = (i6 & 255) > 14;
   if (!i6) if (!i1) i1 = 0; else i1 = ((1 << i4) + -1 | 0) == (i1 | 0) ? 65535 : (i1 << 16 | 32768) >> i4;
   i2 = HEAP32[i33 + (i11 << 5) + 4 >> 2] | 0;
   i8 = HEAP8[i22 >> 0] | 0;
   i7 = i8 & 255;
   i8 = (i8 & 255) > 14;
   if (!i8) if (!i2) i2 = 0; else i2 = ((1 << i7) + -1 | 0) == (i2 | 0) ? 65535 : (i2 << 16 | 32768) >> i7;
   i3 = HEAP32[i33 + (i11 << 5) + 8 >> 2] | 0;
   i10 = HEAP8[i19 >> 0] | 0;
   i9 = i10 & 255;
   i10 = (i10 & 255) > 14;
   if (i10) i12 = i3; else if (!i3) i12 = 0; else i12 = ((1 << i9) + -1 | 0) == (i3 | 0) ? 65535 : (i3 << 16 | 32768) >> i9;
   i3 = HEAP32[i33 + (i11 << 5) + 16 >> 2] | 0;
   if (i6) i4 = i3; else if (!i3) i4 = 0; else i4 = ((1 << i4) + -1 | 0) == (i3 | 0) ? 65535 : (i3 << 16 | 32768) >> i4;
   i3 = HEAP32[i33 + (i11 << 5) + 20 >> 2] | 0;
   if (i8) i6 = i3; else if (!i3) i6 = 0; else i6 = ((1 << i7) + -1 | 0) == (i3 | 0) ? 65535 : (i3 << 16 | 32768) >> i7;
   i3 = HEAP32[i33 + (i11 << 5) + 24 >> 2] | 0;
   if (!i10) if (!i3) i3 = 0; else i3 = ((1 << i9) + -1 | 0) == (i3 | 0) ? 65535 : (i3 << 16 | 32768) >> i9;
   i35 = HEAP32[i16 + (i13 << 2) >> 2] | 0;
   i7 = 64 - i35 | 0;
   i4 = ((((Math_imul(i35, i4) | 0) + 32 + (Math_imul(i7, i1) | 0) | 0) >>> 6) * 31 | 0) >>> 6;
   i6 = ((((Math_imul(i35, i6) | 0) + 32 + (Math_imul(i7, i2) | 0) | 0) >>> 6) * 31 | 0) >>> 6;
   i7 = ((((Math_imul(i35, i3) | 0) + 32 + (Math_imul(i7, i12) | 0) | 0) >>> 6) * 31 | 0) >>> 6;
   i3 = i31 + (i14 << 4) | 0;
   i1 = i4 & 32767;
   L73 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L75 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L75;
     }
     f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
     break L73;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L75;
     }
     i1 = i1 | 1879048192;
     break L73;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i3 >> 2] = i1 | i4 << 16 & -2147483648;
   i3 = i31 + (i14 << 4) + 4 | 0;
   i1 = i6 & 32767;
   L82 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L84 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L84;
     }
     f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
     break L82;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L84;
     }
     i1 = i1 | 1879048192;
     break L82;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i3 >> 2] = i1 | i6 << 16 & -2147483648;
   i3 = i31 + (i14 << 4) + 8 | 0;
   i1 = i7 & 32767;
   L91 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L93 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L93;
     }
     f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
     break L91;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L93;
     }
     i1 = i1 | 1879048192;
     break L91;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i3 >> 2] = i1 | i7 << 16 & -2147483648;
   HEAPF32[i31 + (i14 << 4) + 12 >> 2] = Math_fround(1.0);
   i14 = i14 + 1 | 0;
   if (i14 >>> 0 >= 16) break L24; else i2 = i5;
  }
  if ((i1 | 0) == 32) {
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 40 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 48 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 56 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 60 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 64 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 68 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 72 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 76 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 92 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 104 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 108 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 112 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 116 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 120 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 124 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 128 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 132 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 136 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 140 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 148 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 152 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 156 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 160 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 164 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 168 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 172 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 176 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 180 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 184 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 188 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 192 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 196 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 200 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 204 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 208 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 212 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 216 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 220 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 224 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 228 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 232 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 236 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 240 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 244 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 248 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 252 >> 2] = Math_fround(1.0);
   break;
  } else if ((i1 | 0) == 38) {
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 40 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 48 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 56 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 60 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 64 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 68 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 72 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 76 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 92 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 104 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 108 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 112 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 116 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 120 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 124 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 128 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 132 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 136 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 140 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 148 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 152 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 156 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 160 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 164 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 168 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 172 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 176 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 180 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 184 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 188 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 192 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 196 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 200 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 204 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 208 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 212 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 216 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 220 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 224 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 228 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 232 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 236 >> 2] = Math_fround(1.0);
   HEAPF32[i31 + 240 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 244 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 248 >> 2] = Math_fround(0.0);
   HEAPF32[i31 + 252 >> 2] = Math_fround(1.0);
   break;
  }
 } while (0);
 STACKTOP = i34;
 return;
}

function __ZNK12PhysXRaycast14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEjbi23QueryTriggerInteractionb(i1, i130, i131, i132, i32, i33, i34, i35, i133) {
 i1 = i1 | 0;
 i130 = i130 | 0;
 i131 = i131 | 0;
 i132 = i132 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i133 = i133 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, i146 = 0;
 i129 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i128 = i129;
 i119 = i129 + 292 | 0;
 i120 = i129 + 272 | 0;
 i121 = i129 + 224 | 0;
 i122 = i129 + 208 | 0;
 i123 = i129 + 160 | 0;
 i124 = i129 + 96 | 0;
 i125 = i129 + 84 | 0;
 i126 = i129 + 72 | 0;
 i127 = i129 + 48 | 0;
 if ((i34 | 0) < 1) {
  STACKTOP = i129;
  return;
 }
 i30 = HEAP32[i130 >> 2] | 0;
 i118 = i130 + 12 | 0;
 i31 = HEAP32[i118 >> 2] | 0;
 if (!i31) {
  f9 = Math_fround(-inf);
  f12 = Math_fround(inf);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f19 = Math_fround(-inf);
  f22 = Math_fround(inf);
  f24 = Math_fround(0.0);
  f28 = Math_fround(-inf);
  f29 = Math_fround(inf);
  f27 = Math_fround(-inf);
  f26 = Math_fround(inf);
  f25 = Math_fround(-inf);
  f23 = Math_fround(inf);
  f21 = Math_fround(-inf);
  f20 = Math_fround(inf);
  f18 = Math_fround(-inf);
  f17 = Math_fround(inf);
  f16 = Math_fround(-inf);
  f13 = Math_fround(inf);
  f11 = Math_fround(-inf);
  f10 = Math_fround(inf);
  f8 = Math_fround(-inf);
  f7 = Math_fround(inf);
  f6 = Math_fround(0.0);
  f5 = Math_fround(-inf);
  f4 = Math_fround(inf);
  f3 = Math_fround(-inf);
  f2 = Math_fround(inf);
 } else {
  i1 = 0;
  f9 = Math_fround(-inf);
  f12 = Math_fround(inf);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f19 = Math_fround(-inf);
  f22 = Math_fround(inf);
  f24 = Math_fround(0.0);
  f28 = Math_fround(-inf);
  f29 = Math_fround(inf);
  f27 = Math_fround(-inf);
  f26 = Math_fround(inf);
  f25 = Math_fround(-inf);
  f23 = Math_fround(inf);
  f21 = Math_fround(-inf);
  f20 = Math_fround(inf);
  f18 = Math_fround(-inf);
  f17 = Math_fround(inf);
  f16 = Math_fround(-inf);
  f13 = Math_fround(inf);
  f11 = Math_fround(-inf);
  f10 = Math_fround(inf);
  f8 = Math_fround(-inf);
  f7 = Math_fround(inf);
  f6 = Math_fround(0.0);
  f5 = Math_fround(-inf);
  f4 = Math_fround(inf);
  f3 = Math_fround(-inf);
  f2 = Math_fround(inf);
  do {
   f145 = Math_fround(HEAPF32[i30 + (i1 << 7) + 16 >> 2]);
   f12 = f12 < f145 ? f12 : f145;
   f144 = Math_fround(HEAPF32[i30 + (i1 << 7) + 20 >> 2]);
   f2 = f2 < f144 ? f2 : f144;
   f143 = Math_fround(HEAPF32[i30 + (i1 << 7) + 24 >> 2]);
   f22 = f22 < f143 ? f22 : f143;
   f142 = Math_fround(HEAPF32[i30 + (i1 << 7) + 28 >> 2]);
   f29 = f29 < f142 ? f29 : f142;
   f141 = Math_fround(HEAPF32[i30 + (i1 << 7) + 32 >> 2]);
   f26 = f26 < f141 ? f26 : f141;
   f140 = Math_fround(HEAPF32[i30 + (i1 << 7) + 36 >> 2]);
   f23 = f23 < f140 ? f23 : f140;
   f139 = Math_fround(HEAPF32[i30 + (i1 << 7) + 40 >> 2]);
   f20 = f20 < f139 ? f20 : f139;
   f138 = Math_fround(HEAPF32[i30 + (i1 << 7) + 44 >> 2]);
   f17 = f17 < f138 ? f17 : f138;
   f137 = Math_fround(HEAPF32[i30 + (i1 << 7) + 48 >> 2]);
   f13 = f13 < f137 ? f13 : f137;
   f136 = Math_fround(HEAPF32[i30 + (i1 << 7) + 52 >> 2]);
   f10 = f10 < f136 ? f10 : f136;
   f135 = Math_fround(HEAPF32[i30 + (i1 << 7) + 56 >> 2]);
   f7 = f7 < f135 ? f7 : f135;
   f134 = Math_fround(HEAPF32[i30 + (i1 << 7) + 60 >> 2]);
   f4 = f4 < f134 ? f4 : f134;
   f145 = f9 > f145 ? f9 : f145;
   f144 = f3 > f144 ? f3 : f144;
   f143 = f19 > f143 ? f19 : f143;
   f142 = f28 > f142 ? f28 : f142;
   f141 = f27 > f141 ? f27 : f141;
   f140 = f25 > f140 ? f25 : f140;
   f139 = f21 > f139 ? f21 : f139;
   f138 = f18 > f138 ? f18 : f138;
   f137 = f16 > f137 ? f16 : f137;
   f136 = f11 > f136 ? f11 : f136;
   f135 = f8 > f135 ? f8 : f135;
   f134 = f5 > f134 ? f5 : f134;
   f9 = Math_fround(HEAPF32[i30 + (i1 << 7) + 64 >> 2]);
   f12 = f12 < f9 ? f12 : f9;
   f3 = Math_fround(HEAPF32[i30 + (i1 << 7) + 68 >> 2]);
   f2 = f2 < f3 ? f2 : f3;
   f19 = Math_fround(HEAPF32[i30 + (i1 << 7) + 72 >> 2]);
   f22 = f22 < f19 ? f22 : f19;
   f28 = Math_fround(HEAPF32[i30 + (i1 << 7) + 76 >> 2]);
   f29 = f29 < f28 ? f29 : f28;
   f27 = Math_fround(HEAPF32[i30 + (i1 << 7) + 80 >> 2]);
   f26 = f26 < f27 ? f26 : f27;
   f25 = Math_fround(HEAPF32[i30 + (i1 << 7) + 84 >> 2]);
   f23 = f23 < f25 ? f23 : f25;
   f21 = Math_fround(HEAPF32[i30 + (i1 << 7) + 88 >> 2]);
   f20 = f20 < f21 ? f20 : f21;
   f18 = Math_fround(HEAPF32[i30 + (i1 << 7) + 92 >> 2]);
   f17 = f17 < f18 ? f17 : f18;
   f16 = Math_fround(HEAPF32[i30 + (i1 << 7) + 96 >> 2]);
   f13 = f13 < f16 ? f13 : f16;
   f11 = Math_fround(HEAPF32[i30 + (i1 << 7) + 100 >> 2]);
   f10 = f10 < f11 ? f10 : f11;
   f8 = Math_fround(HEAPF32[i30 + (i1 << 7) + 104 >> 2]);
   f7 = f7 < f8 ? f7 : f8;
   f5 = Math_fround(HEAPF32[i30 + (i1 << 7) + 108 >> 2]);
   f4 = f4 < f5 ? f4 : f5;
   f9 = f145 > f9 ? f145 : f9;
   f3 = f144 > f3 ? f144 : f3;
   f19 = f143 > f19 ? f143 : f19;
   f28 = f142 > f28 ? f142 : f28;
   f27 = f141 > f27 ? f141 : f27;
   f25 = f140 > f25 ? f140 : f25;
   f21 = f139 > f21 ? f139 : f21;
   f18 = f138 > f18 ? f138 : f18;
   f16 = f137 > f16 ? f137 : f16;
   f11 = f136 > f11 ? f136 : f11;
   f8 = f135 > f8 ? f135 : f8;
   f5 = f134 > f5 ? f134 : f5;
   f134 = Math_fround(HEAPF32[i30 + (i1 << 7) + 112 >> 2]);
   f14 = f14 > f134 ? f14 : f134;
   f134 = Math_fround(HEAPF32[i30 + (i1 << 7) + 116 >> 2]);
   f6 = f6 > f134 ? f6 : f134;
   f134 = Math_fround(HEAPF32[i30 + (i1 << 7) + 120 >> 2]);
   f15 = f15 > f134 ? f15 : f134;
   f134 = Math_fround(HEAPF32[i30 + (i1 << 7) + 124 >> 2]);
   f24 = f24 > f134 ? f24 : f134;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i31 | 0));
 }
 f143 = Math_fround(_fminf(f12, f2));
 f143 = Math_fround(_fminf(f143, Math_fround(_fminf(f22, f29))));
 f144 = Math_fround(_fminf(f26, f23));
 f144 = Math_fround(_fminf(f144, Math_fround(_fminf(f20, f17))));
 f145 = Math_fround(_fminf(f13, f10));
 f145 = Math_fround(_fminf(f145, Math_fround(_fminf(f7, f4))));
 f142 = Math_fround(_fmaxf(f9, f3));
 f142 = Math_fround(_fmaxf(f142, Math_fround(_fmaxf(f19, f28))));
 f140 = Math_fround(_fmaxf(f27, f25));
 f140 = Math_fround(_fmaxf(f140, Math_fround(_fmaxf(f21, f18))));
 f138 = Math_fround(_fmaxf(f16, f11));
 f138 = Math_fround(_fmaxf(f138, Math_fround(_fmaxf(f8, f5))));
 f141 = Math_fround(_fmaxf(f14, f6));
 f141 = Math_fround(_fmaxf(f141, Math_fround(_fmaxf(f15, f24))));
 f143 = Math_fround(Math_fround(f143 - f141) + Math_fround(-9.99999974e-06));
 f144 = Math_fround(Math_fround(f144 - f141) + Math_fround(-9.99999974e-06));
 f145 = Math_fround(Math_fround(f145 - f141) + Math_fround(-9.99999974e-06));
 f142 = Math_fround(Math_fround(f142 + f141) + Math_fround(9.99999974e-06));
 f140 = Math_fround(Math_fround(f140 + f141) + Math_fround(9.99999974e-06));
 f141 = Math_fround(Math_fround(f138 + f141) + Math_fround(9.99999974e-06));
 HEAP32[i119 + 12 >> 2] = i34;
 i114 = i119 + 16 | 0;
 HEAP32[i114 >> 2] = i34;
 i115 = i119 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i128, gb + 64016 | 0);
 i111 = i128;
 i117 = HEAP32[i111 + 4 >> 2] | 0;
 i116 = i115;
 HEAP32[i116 >> 2] = HEAP32[i111 >> 2];
 HEAP32[i116 + 4 >> 2] = i117;
 HEAP32[i119 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 << 4, 4, i115, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i120 + 12 >> 2] = i34;
 i116 = i120 + 16 | 0;
 HEAP32[i116 >> 2] = i34;
 i117 = i120 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i128, gb + 64016 | 0);
 i111 = i128;
 i112 = HEAP32[i111 + 4 >> 2] | 0;
 i113 = i117;
 HEAP32[i113 >> 2] = HEAP32[i111 >> 2];
 HEAP32[i113 + 4 >> 2] = i112;
 HEAP32[i120 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i34 * 24 | 0, 4, i117, 0, gb + 1047584 | 0, 446) | 0;
 f138 = Math_fround(Math_fround(f144 + f140) * Math_fround(.5));
 f139 = Math_fround(Math_fround(f145 + f141) * Math_fround(.5));
 HEAPF32[i128 >> 2] = Math_fround(Math_fround(f143 + f142) * Math_fround(.5));
 HEAPF32[i128 + 4 >> 2] = f138;
 HEAPF32[i128 + 8 >> 2] = f139;
 f144 = Math_fround(Math_fround(f140 - f144) * Math_fround(.5));
 f145 = Math_fround(Math_fround(f141 - f145) * Math_fround(.5));
 HEAPF32[i128 + 12 >> 2] = Math_fround(Math_fround(f142 - f143) * Math_fround(.5));
 HEAPF32[i128 + 16 >> 2] = f144;
 HEAPF32[i128 + 20 >> 2] = f145;
 i113 = __ZNK12PhysXRaycast9GetShapesERK4AABBiPN5physx12PxOverlapHitEjb23QueryTriggerInteraction(0, i128, i34, HEAP32[i119 >> 2] | 0, i32, i33, i35) | 0;
 if (i113 | 0) {
  i1 = 0;
  do {
   __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE((HEAP32[i120 >> 2] | 0) + (i1 * 24 | 0) | 0, (HEAP32[i119 >> 2] | 0) + (i1 << 4) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i113 | 0));
  if (HEAP32[i118 >> 2] | 0) {
   i57 = i128 + 4 | 0;
   i68 = i128 + 8 | 0;
   i78 = i128 + 12 | 0;
   i80 = i128 + 16 | 0;
   i54 = i128 + 20 | 0;
   i65 = i128 + 24 | 0;
   i75 = i128 + 28 | 0;
   i81 = i128 + 32 | 0;
   i51 = i128 + 36 | 0;
   i61 = i128 + 40 | 0;
   i72 = i128 + 44 | 0;
   i58 = i121 + 4 | 0;
   i69 = i121 + 8 | 0;
   i79 = i121 + 12 | 0;
   i82 = i121 + 16 | 0;
   i55 = i121 + 20 | 0;
   i66 = i121 + 24 | 0;
   i76 = i121 + 28 | 0;
   i83 = i121 + 32 | 0;
   i52 = i121 + 36 | 0;
   i62 = i121 + 40 | 0;
   i73 = i121 + 44 | 0;
   i84 = i122 + 4 | 0;
   i85 = i122 + 8 | 0;
   i86 = i122 + 12 | 0;
   i56 = i123 + 4 | 0;
   i67 = i123 + 8 | 0;
   i77 = i123 + 12 | 0;
   i48 = i123 + 16 | 0;
   i53 = i123 + 20 | 0;
   i64 = i123 + 24 | 0;
   i74 = i123 + 28 | 0;
   i47 = i123 + 32 | 0;
   i49 = i123 + 36 | 0;
   i60 = i123 + 40 | 0;
   i71 = i123 + 44 | 0;
   i87 = i125 + 4 | 0;
   i88 = i125 + 8 | 0;
   i89 = i123 + 16 | 0;
   i90 = i123 + 32 | 0;
   i91 = i126 + 4 | 0;
   i92 = i126 + 8 | 0;
   i59 = i127 + 4 | 0;
   i70 = i127 + 8 | 0;
   i46 = i127 + 12 | 0;
   i50 = i127 + 16 | 0;
   i63 = i127 + 20 | 0;
   i93 = i132 + 12 | 0;
   i94 = i132 + 16 | 0;
   i95 = i132 + 4 | 0;
   i96 = i124 + 4 | 0;
   i97 = i124 + 8 | 0;
   i98 = i124 + 12 | 0;
   i99 = i124 + 16 | 0;
   i100 = i124 + 20 | 0;
   i101 = i124 + 24 | 0;
   i102 = i124 + 28 | 0;
   i103 = i124 + 32 | 0;
   i104 = i124 + 36 | 0;
   i105 = i124 + 40 | 0;
   i106 = i124 + 44 | 0;
   i107 = i124 + 48 | 0;
   i108 = i124 + 52 | 0;
   i45 = 0;
   do {
    i44 = HEAP32[i130 >> 2] | 0;
    f2 = Math_fround(HEAPF32[i44 + (i45 << 7) + 64 >> 2]);
    i109 = i44 + (i45 << 7) + 16 | 0;
    f18 = Math_fround(HEAPF32[i109 >> 2]);
    f2 = Math_fround(f2 - f18);
    f3 = Math_fround(HEAPF32[i44 + (i45 << 7) + 68 >> 2]);
    f19 = Math_fround(HEAPF32[i44 + (i45 << 7) + 20 >> 2]);
    f3 = Math_fround(f3 - f19);
    f4 = Math_fround(HEAPF32[i44 + (i45 << 7) + 72 >> 2]);
    f20 = Math_fround(HEAPF32[i44 + (i45 << 7) + 24 >> 2]);
    f4 = Math_fround(f4 - f20);
    f5 = Math_fround(HEAPF32[i44 + (i45 << 7) + 76 >> 2]);
    f21 = Math_fround(HEAPF32[i44 + (i45 << 7) + 28 >> 2]);
    f5 = Math_fround(f5 - f21);
    f6 = Math_fround(HEAPF32[i44 + (i45 << 7) + 80 >> 2]);
    i110 = i44 + (i45 << 7) + 32 | 0;
    f22 = Math_fround(HEAPF32[i110 >> 2]);
    f6 = Math_fround(f6 - f22);
    f7 = Math_fround(HEAPF32[i44 + (i45 << 7) + 84 >> 2]);
    f23 = Math_fround(HEAPF32[i44 + (i45 << 7) + 36 >> 2]);
    f7 = Math_fround(f7 - f23);
    f8 = Math_fround(HEAPF32[i44 + (i45 << 7) + 88 >> 2]);
    f24 = Math_fround(HEAPF32[i44 + (i45 << 7) + 40 >> 2]);
    f8 = Math_fround(f8 - f24);
    f9 = Math_fround(HEAPF32[i44 + (i45 << 7) + 92 >> 2]);
    f25 = Math_fround(HEAPF32[i44 + (i45 << 7) + 44 >> 2]);
    f9 = Math_fround(f9 - f25);
    f10 = Math_fround(HEAPF32[i44 + (i45 << 7) + 96 >> 2]);
    i111 = i44 + (i45 << 7) + 48 | 0;
    f145 = Math_fround(HEAPF32[i111 >> 2]);
    f10 = Math_fround(f10 - f145);
    f11 = Math_fround(HEAPF32[i44 + (i45 << 7) + 100 >> 2]);
    f144 = Math_fround(HEAPF32[i44 + (i45 << 7) + 52 >> 2]);
    f11 = Math_fround(f11 - f144);
    f12 = Math_fround(HEAPF32[i44 + (i45 << 7) + 104 >> 2]);
    f143 = Math_fround(HEAPF32[i44 + (i45 << 7) + 56 >> 2]);
    f12 = Math_fround(f12 - f143);
    f13 = Math_fround(HEAPF32[i44 + (i45 << 7) + 108 >> 2]);
    f142 = Math_fround(HEAPF32[i44 + (i45 << 7) + 60 >> 2]);
    f13 = Math_fround(f13 - f142);
    f134 = Math_fround(f2 * Math_fround(.5));
    f135 = Math_fround(f3 * Math_fround(.5));
    f136 = Math_fround(f4 * Math_fround(.5));
    f137 = Math_fround(f5 * Math_fround(.5));
    f138 = Math_fround(f6 * Math_fround(.5));
    f139 = Math_fround(f7 * Math_fround(.5));
    f140 = Math_fround(f8 * Math_fround(.5));
    f141 = Math_fround(f9 * Math_fround(.5));
    f26 = Math_fround(f10 * Math_fround(.5));
    f27 = Math_fround(f11 * Math_fround(.5));
    f28 = Math_fround(f12 * Math_fround(.5));
    f29 = Math_fround(f13 * Math_fround(.5));
    f19 = Math_fround(f135 + f19);
    f20 = Math_fround(f136 + f20);
    f21 = Math_fround(f137 + f21);
    f22 = Math_fround(f138 + f22);
    f23 = Math_fround(f139 + f23);
    f24 = Math_fround(f140 + f24);
    f25 = Math_fround(f141 + f25);
    f145 = Math_fround(f26 + f145);
    f144 = Math_fround(f27 + f144);
    f143 = Math_fround(f28 + f143);
    f142 = Math_fround(f29 + f142);
    HEAPF32[i128 >> 2] = Math_fround(f134 + f18);
    HEAPF32[i57 >> 2] = f19;
    HEAPF32[i68 >> 2] = f20;
    HEAPF32[i78 >> 2] = f21;
    HEAPF32[i80 >> 2] = f22;
    HEAPF32[i54 >> 2] = f23;
    HEAPF32[i65 >> 2] = f24;
    HEAPF32[i75 >> 2] = f25;
    HEAPF32[i81 >> 2] = f145;
    HEAPF32[i51 >> 2] = f144;
    HEAPF32[i61 >> 2] = f143;
    HEAPF32[i72 >> 2] = f142;
    f134 = Math_fround(Math_abs(Math_fround(f134)));
    f135 = Math_fround(Math_abs(Math_fround(f135)));
    f136 = Math_fround(Math_abs(Math_fround(f136)));
    f137 = Math_fround(Math_abs(Math_fround(f137)));
    f138 = Math_fround(Math_abs(Math_fround(f138)));
    f139 = Math_fround(Math_abs(Math_fround(f139)));
    f140 = Math_fround(Math_abs(Math_fround(f140)));
    f141 = Math_fround(Math_abs(Math_fround(f141)));
    f26 = Math_fround(Math_abs(Math_fround(f26)));
    f27 = Math_fround(Math_abs(Math_fround(f27)));
    f28 = Math_fround(Math_abs(Math_fround(f28)));
    f29 = Math_fround(Math_abs(Math_fround(f29)));
    i112 = i44 + (i45 << 7) + 112 | 0;
    f142 = Math_fround(HEAPF32[i112 >> 2]);
    f134 = Math_fround(f134 + f142);
    f143 = Math_fround(HEAPF32[i44 + (i45 << 7) + 116 >> 2]);
    f135 = Math_fround(f135 + f143);
    f144 = Math_fround(HEAPF32[i44 + (i45 << 7) + 120 >> 2]);
    f136 = Math_fround(f136 + f144);
    f145 = Math_fround(HEAPF32[i44 + (i45 << 7) + 124 >> 2]);
    f137 = Math_fround(f137 + f145);
    f138 = Math_fround(f138 + f142);
    f139 = Math_fround(f139 + f143);
    f140 = Math_fround(f140 + f144);
    f141 = Math_fround(f141 + f145);
    f142 = Math_fround(f26 + f142);
    f143 = Math_fround(f27 + f143);
    f144 = Math_fround(f28 + f144);
    f145 = Math_fround(f29 + f145);
    HEAPF32[i121 >> 2] = f134;
    HEAPF32[i58 >> 2] = f135;
    HEAPF32[i69 >> 2] = f136;
    HEAPF32[i79 >> 2] = f137;
    HEAPF32[i82 >> 2] = f138;
    HEAPF32[i55 >> 2] = f139;
    HEAPF32[i66 >> 2] = f140;
    HEAPF32[i76 >> 2] = f141;
    HEAPF32[i83 >> 2] = f142;
    HEAPF32[i52 >> 2] = f143;
    HEAPF32[i62 >> 2] = f144;
    HEAPF32[i73 >> 2] = f145;
    if (__ZN8IRaycast12IntersectAnyERKN4math8floatNx3ES3_P4AABBj(i128, i121, HEAP32[i120 >> 2] | 0, i113) | 0) {
     f142 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6)) + Math_fround(f10 * f10))));
     f143 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f7 * f7)) + Math_fround(f11 * f11))));
     f144 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f8 * f8)) + Math_fround(f12 * f12))));
     f145 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9)) + Math_fround(f13 * f13))));
     HEAPF32[i122 >> 2] = f142;
     HEAPF32[i84 >> 2] = f143;
     HEAPF32[i85 >> 2] = f144;
     HEAPF32[i86 >> 2] = f145;
     f27 = Math_fround(f2 / f142);
     f28 = Math_fround(f3 / f143);
     f29 = Math_fround(f4 / f144);
     f134 = Math_fround(f5 / f145);
     f135 = Math_fround(f6 / f142);
     f136 = Math_fround(f7 / f143);
     f137 = Math_fround(f8 / f144);
     f138 = Math_fround(f9 / f145);
     f139 = Math_fround(f10 / f142);
     f140 = Math_fround(f11 / f143);
     f141 = Math_fround(f12 / f144);
     f2 = Math_fround(f13 / f145);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
     i30 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
     i31 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
     i32 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
     i33 = (HEAPF32[tempDoublePtr >> 2] = f135, HEAP32[tempDoublePtr >> 2] | 0);
     i34 = (HEAPF32[tempDoublePtr >> 2] = f136, HEAP32[tempDoublePtr >> 2] | 0);
     i35 = (HEAPF32[tempDoublePtr >> 2] = f137, HEAP32[tempDoublePtr >> 2] | 0);
     i36 = (HEAPF32[tempDoublePtr >> 2] = f138, HEAP32[tempDoublePtr >> 2] | 0);
     i37 = (HEAPF32[tempDoublePtr >> 2] = f139, HEAP32[tempDoublePtr >> 2] | 0);
     i38 = (HEAPF32[tempDoublePtr >> 2] = f140, HEAP32[tempDoublePtr >> 2] | 0);
     i39 = (HEAPF32[tempDoublePtr >> 2] = f141, HEAP32[tempDoublePtr >> 2] | 0);
     i40 = f142 > Math_fround(9.99999997e-07);
     i41 = f143 > Math_fround(9.99999997e-07);
     i42 = f144 > Math_fround(9.99999997e-07);
     i43 = f145 > Math_fround(9.99999997e-07);
     i146 = i43 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     HEAP32[i123 >> 2] = i40 ? i1 : 0;
     HEAP32[i56 >> 2] = i41 ? i30 : 0;
     HEAP32[i67 >> 2] = i42 ? i31 : 0;
     HEAP32[i77 >> 2] = i43 ? i32 : 0;
     HEAP32[i48 >> 2] = i40 ? i33 : 0;
     HEAP32[i53 >> 2] = i41 ? i34 : 0;
     HEAP32[i64 >> 2] = i42 ? i35 : 0;
     HEAP32[i74 >> 2] = i43 ? i36 : 0;
     HEAP32[i47 >> 2] = i40 ? i37 : 0;
     HEAP32[i49 >> 2] = i41 ? i38 : 0;
     HEAP32[i60 >> 2] = i42 ? i39 : 0;
     HEAP32[i71 >> 2] = i146;
     i35 = i44 + (i45 << 7) | 0;
     i34 = 0;
     do {
      i1 = HEAP32[i35 + (i34 << 2) >> 2] | 0;
      if (i1 >>> 0 < i131 >>> 0) {
       HEAP32[i124 >> 2] = i1;
       i41 = HEAP32[i110 + (i34 << 2) >> 2] | 0;
       i42 = HEAP32[i111 + (i34 << 2) >> 2] | 0;
       HEAP32[i125 >> 2] = HEAP32[i109 + (i34 << 2) >> 2];
       HEAP32[i87 >> 2] = i41;
       HEAP32[i88 >> 2] = i42;
       i42 = HEAP32[i89 + (i34 << 2) >> 2] | 0;
       i41 = HEAP32[i90 + (i34 << 2) >> 2] | 0;
       HEAP32[i126 >> 2] = HEAP32[i123 + (i34 << 2) >> 2];
       HEAP32[i91 >> 2] = i42;
       HEAP32[i92 >> 2] = i41;
       i41 = HEAP32[i80 + (i34 << 2) >> 2] | 0;
       i42 = HEAP32[i81 + (i34 << 2) >> 2] | 0;
       i43 = HEAP32[i121 + (i34 << 2) >> 2] | 0;
       i44 = HEAP32[i82 + (i34 << 2) >> 2] | 0;
       i146 = HEAP32[i83 + (i34 << 2) >> 2] | 0;
       HEAP32[i127 >> 2] = HEAP32[i128 + (i34 << 2) >> 2];
       HEAP32[i59 >> 2] = i41;
       HEAP32[i70 >> 2] = i42;
       HEAP32[i46 >> 2] = i43;
       HEAP32[i50 >> 2] = i44;
       HEAP32[i63 >> 2] = i146;
       f144 = Math_fround(HEAPF32[i122 + (i34 << 2) >> 2]);
       f145 = Math_fround(HEAPF32[i112 + (i34 << 2) >> 2]);
       if (__ZNK12PhysXRaycast9IntersectERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_jR20BatchedRaycastResultb(0, i125, i126, i127, f144, f145, HEAP32[i119 >> 2] | 0, HEAP32[i120 >> 2] | 0, i113, i124, i133) | 0) {
        i30 = HEAP32[i93 >> 2] | 0;
        i31 = i30 + 1 | 0;
        i32 = HEAP32[i94 >> 2] | 0;
        i33 = i32 & 2147483647;
        do if (i31 >>> 0 > i33 >>> 0) {
         i1 = i32 << 1;
         i1 = (i1 | 0) == 0 ? 1 : i1;
         if (i33 >>> 0 < i1 >>> 0) if ((i32 | 0) > -1) {
          HEAP32[i94 >> 2] = i1;
          HEAP32[i132 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i132 >> 2] | 0, i1 * 60 | 0, 4, i95, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i146 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 60 | 0, 4, i95, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i146 | 0, HEAP32[i132 >> 2] | 0, (HEAP32[i93 >> 2] | 0) * 60 | 0) | 0;
          HEAP32[i94 >> 2] = i1;
          HEAP32[i132 >> 2] = i146;
          break;
         }
        } while (0);
        HEAP32[i93 >> 2] = i31;
        i146 = HEAP32[i132 >> 2] | 0;
        HEAP32[i146 + (i30 * 60 | 0) >> 2] = HEAP32[i124 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 4 >> 2] = HEAP32[i96 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 8 >> 2] = HEAP32[i97 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 12 >> 2] = HEAP32[i98 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 16 >> 2] = HEAP32[i99 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 20 >> 2] = HEAP32[i100 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 24 >> 2] = HEAP32[i101 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 28 >> 2] = HEAP32[i102 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 32 >> 2] = HEAP32[i103 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 36 >> 2] = HEAP32[i104 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 40 >> 2] = HEAP32[i105 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 44 >> 2] = HEAP32[i106 >> 2];
        HEAP32[i146 + (i30 * 60 | 0) + 48 >> 2] = HEAP32[i107 >> 2];
        i43 = i108;
        i44 = HEAP32[i43 + 4 >> 2] | 0;
        i146 = i146 + (i30 * 60 | 0) + 52 | 0;
        HEAP32[i146 >> 2] = HEAP32[i43 >> 2];
        HEAP32[i146 + 4 >> 2] = i44;
       }
      }
      i34 = i34 + 1 | 0;
     } while ((i34 | 0) != 4);
    }
    i45 = i45 + 1 | 0;
   } while (i45 >>> 0 < (HEAP32[i118 >> 2] | 0) >>> 0);
  }
 }
 if ((HEAP32[i116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i120 >> 2] | 0, i117);
  HEAP32[i120 >> 2] = 0;
 }
 if ((HEAP32[i114 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i119 >> 2] | 0, i115);
  HEAP32[i119 >> 2] = 0;
 }
 STACKTOP = i129;
 return;
}

function __ZN19SpriteMeshGenerator4path8simplifyEfi(i42, f6, i43) {
 i42 = i42 | 0;
 f6 = Math_fround(f6);
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i44;
 i34 = i44 + 96 | 0;
 i9 = i44 + 124 | 0;
 i35 = i44 + 64 | 0;
 i10 = i44 + 112 | 0;
 i38 = i44 + 32 | 0;
 i39 = i44 + 16 | 0;
 i32 = i44 + 80 | 0;
 i33 = i44 + 48 | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 i41 = i42 + 4 | 0;
 i2 = HEAP32[i41 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i41 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 i36 = i42 + 44 | 0;
 __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i42, HEAP32[i36 >> 2] | 0, HEAP32[i42 + 48 >> 2] | 0);
 i5 = HEAP32[i41 >> 2] | 0;
 i4 = HEAP32[i42 >> 2] | 0;
 i19 = i5 - i4 | 0;
 i40 = i19 >> 5;
 f15 = Math_fround(i40 | 0);
 i1 = f6 < Math_fround(0.0);
 i31 = f6 > Math_fround(1.0);
 f14 = Math_fround(Math_fround(1.0) - (i31 ? Math_fround(1.0) : f6));
 i1 = ~~Math_fround((i1 ? Math_fround(1.0) : f14) * f15);
 L4 : do if ((i19 | 0) >= 160) {
  if ((i43 | 0) == 1) {
   i8 = (i1 | 0) < 5 ? 5 : i1;
   HEAP32[i37 >> 2] = 0;
   i9 = i42 + 60 | 0;
   i1 = i42 + 64 | 0;
   i10 = i42 + 56 | 0;
   i3 = 0;
   do {
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i10, i37); else {
     HEAP32[i2 >> 2] = i3;
     HEAP32[i9 >> 2] = i2 + 4;
    }
    i3 = (HEAP32[i37 >> 2] | 0) + 1 | 0;
    HEAP32[i37 >> 2] = i3;
   } while ((i3 | 0) < (i40 | 0));
   i5 = i42 + 56 | 0;
   while (1) {
    i7 = (HEAP32[i41 >> 2] | 0) - (HEAP32[i42 >> 2] | 0) >> 5;
    i1 = HEAP32[i10 >> 2] | 0;
    i3 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
    i4 = i3 >> 2;
    i3 = (i3 | 0) > 0;
    if (i3) {
     i2 = 0;
     do {
      __ZN19SpriteMeshGenerator4path3decEi(i42, HEAP32[i1 + (i2 << 2) >> 2] | 0) | 0;
      __ZN19SpriteMeshGenerator4path3infEi(i42, HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0;
      i2 = i2 + 1 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
     } while ((i2 | 0) < (i4 | 0));
     if (i3) {
      i2 = 0;
      do {
       i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
       if ((HEAP32[(HEAP32[i42 >> 2] | 0) + (i1 << 5) + 16 >> 2] | 0) > 0) __ZN19SpriteMeshGenerator4path8cve_costEi(i42, i1) | 0; else __ZN19SpriteMeshGenerator4path8cvx_costEi(i42, i1) | 0;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i5 >> 2] | 0;
      } while ((i2 | 0) < (i4 | 0));
     }
    }
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
    if (!((i7 | 0) > (i8 | 0) & (__ZN19SpriteMeshGenerator4path6selectEv(i42) | 0))) break L4;
   }
  }
  i31 = (i1 | 0) < 4 ? 4 : i1;
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f13 = Math_fround(f14 - f14);
  f6 = Math_fround(f15 - f15);
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(f6 * f6))));
  i2 = f6 < Math_fround(-1.0);
  i1 = i2 << 31 >> 31;
  if ((i19 | 0) > 32) {
   f11 = Math_fround(-1.0);
   i3 = 1;
   do {
    f11 = i2 ? f11 : f6;
    f12 = Math_fround(HEAPF32[i4 + (i3 << 5) >> 2]);
    f12 = Math_fround(f12 - f14);
    f13 = Math_fround(Math_fround(HEAPF32[i4 + (i3 << 5) + 4 >> 2]) - f15);
    f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13))));
    i2 = f6 < f11;
    i1 = i2 ? i1 : i3;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i40 | 0));
   i18 = i1;
  } else i18 = i1;
  f12 = Math_fround(HEAPF32[i4 + (i18 << 5) >> 2]);
  f13 = Math_fround(HEAPF32[i4 + (i18 << 5) + 4 >> 2]);
  f14 = Math_fround(f14 - f12);
  f6 = Math_fround(f15 - f13);
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(f6 * f6))));
  i2 = f6 < Math_fround(-1.0);
  i1 = i2 << 31 >> 31;
  if ((i19 | 0) > 32) {
   f11 = Math_fround(-1.0);
   i3 = 1;
   do {
    f11 = i2 ? f11 : f6;
    f14 = Math_fround(HEAPF32[i4 + (i3 << 5) >> 2]);
    f14 = Math_fround(f14 - f12);
    f15 = Math_fround(Math_fround(HEAPF32[i4 + (i3 << 5) + 4 >> 2]) - f13);
    f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))));
    i2 = f6 < f11;
    i1 = i2 ? i1 : i3;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i40 | 0));
   i17 = i1;
  } else i17 = i1;
  HEAP32[i9 >> 2] = 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i16 = (i40 | 0) == 0;
  if (!i16) {
   if (i40 >>> 0 > 134217727) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
    i1 = HEAP32[i42 >> 2] | 0;
    i5 = HEAP32[i41 >> 2] | 0;
   } else i1 = i4;
   i4 = __Znwj(i19) | 0;
   HEAP32[i8 >> 2] = i4;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i9 + 8 >> 2] = i4 + (i40 << 5);
   if ((i1 | 0) != (i5 | 0)) {
    i7 = ((i5 + -32 - i1 | 0) >>> 5) + 1 | 0;
    i2 = i4;
    i3 = i4;
    while (1) {
     HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     i30 = i2 + 16 | 0;
     i29 = i1 + 16 | 0;
     HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i30 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     i1 = i1 + 32 | 0;
     i3 = i3 + 32 | 0;
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i3;
    }
    HEAP32[i8 >> 2] = i4 + (i7 << 5);
   }
  }
  __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i34, i9, i18, i17);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
   __ZdlPv(i1);
  }
  HEAP32[i10 >> 2] = 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i2 = HEAP32[i41 >> 2] | 0;
  i1 = HEAP32[i42 >> 2] | 0;
  i3 = i2 - i1 | 0;
  i4 = i3 >> 5;
  if (i4 | 0) {
   if (i4 >>> 0 > 134217727) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
    i1 = HEAP32[i42 >> 2] | 0;
    i2 = HEAP32[i41 >> 2] | 0;
   }
   i7 = __Znwj(i3) | 0;
   HEAP32[i8 >> 2] = i7;
   HEAP32[i10 >> 2] = i7;
   HEAP32[i10 + 8 >> 2] = i7 + (i4 << 5);
   if ((i1 | 0) != (i2 | 0)) {
    i5 = ((i2 + -32 - i1 | 0) >>> 5) + 1 | 0;
    i3 = i7;
    i4 = i7;
    while (1) {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     i30 = i3 + 16 | 0;
     i29 = i1 + 16 | 0;
     HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i30 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     i1 = i1 + 32 | 0;
     i4 = i4 + 32 | 0;
     if ((i1 | 0) == (i2 | 0)) break; else i3 = i4;
    }
    HEAP32[i8 >> 2] = i7 + (i5 << 5);
   }
  }
  __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i35, i10, i17, i18);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
   __ZdlPv(i1);
  }
  HEAP32[i38 >> 2] = 0;
  i30 = i38 + 4 | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  i29 = i34 + 8 | 0;
  if ((HEAP32[i29 >> 2] | 0) > -1) {
   __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i38, i34);
   i3 = HEAP32[i30 >> 2] | 0;
   i2 = HEAP32[i38 >> 2] | 0;
   i1 = i3 - i2 | 0;
   if ((i1 | 0) > 16) {
    i1 = ((i1 >> 4) + -2 | 0) / 2 | 0;
    i5 = i3;
    i3 = i5 + -16 | 0;
    i5 = HEAP32[i5 + -4 >> 2] | 0;
    if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) < (i5 | 0)) {
     HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i37 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i37 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     while (1) {
      i28 = i3;
      i3 = i2 + (i1 << 4) | 0;
      HEAP32[i28 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i28 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      if (!i1) {
       i1 = 0;
       break;
      }
      i4 = (i1 + -1 | 0) / 2 | 0;
      if ((HEAP32[i2 + (i4 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break; else i1 = i4;
     }
     HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i2 + (i1 << 4) + 12 >> 2] = i5;
    }
   }
  }
  i28 = i35 + 8 | 0;
  if ((HEAP32[i28 >> 2] | 0) > -1) {
   i1 = HEAP32[i30 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i38 + 8 >> 2] | 0)) {
    __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i38, i35);
    i3 = HEAP32[i30 >> 2] | 0;
   } else {
    HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
    i3 = (HEAP32[i30 >> 2] | 0) + 16 | 0;
    HEAP32[i30 >> 2] = i3;
   }
   i2 = HEAP32[i38 >> 2] | 0;
   i1 = i3 - i2 | 0;
   if ((i1 | 0) > 16) {
    i1 = ((i1 >> 4) + -2 | 0) / 2 | 0;
    i5 = i3;
    i3 = i5 + -16 | 0;
    i5 = HEAP32[i5 + -4 >> 2] | 0;
    if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) < (i5 | 0)) {
     HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i37 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i37 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     while (1) {
      i27 = i3;
      i3 = i2 + (i1 << 4) | 0;
      HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      if (!i1) {
       i1 = 0;
       break;
      }
      i4 = (i1 + -1 | 0) / 2 | 0;
      if ((HEAP32[i2 + (i4 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break; else i1 = i4;
     }
     HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i2 + (i1 << 4) + 12 >> 2] = i5;
    }
   }
  }
  HEAP32[i39 >> 2] = 0;
  i1 = i39 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i39 + 8 | 0;
  HEAP32[i2 >> 2] = 0;
  if (i16) {
   i3 = 0;
   i1 = 0;
  } else {
   if ((i19 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i39);
   i27 = ((i40 + -1 | 0) >>> 5) + 1 | 0;
   i3 = __Znwj(i27 << 2) | 0;
   HEAP32[i39 >> 2] = i3;
   HEAP32[i2 >> 2] = i27;
   HEAP32[i1 >> 2] = i40;
   i2 = i40 >>> 5;
   _memset(i3 | 0, 0, i2 << 2 | 0) | 0;
   i1 = i40 - (i2 << 5) | 0;
   i2 = i3 + (i2 << 2) | 0;
   if (!i1) i1 = i40; else {
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(-1 >>> (32 - i1 | 0));
    i1 = i40;
   }
  }
  i4 = i3;
  i1 = (i4 + (i1 >>> 5 << 2) - i3 << 3) + (i1 & 31) | 0;
  if (i1 | 0) {
   i27 = i1 >>> 5;
   _memset(i3 | 0, 0, i27 << 2 | 0) | 0;
   i2 = i1 - (i27 << 5) | 0;
   i1 = i4 + (i27 << 2) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(-1 >>> (32 - i2 | 0));
  }
  i2 = HEAP32[i39 >> 2] | 0;
  i1 = i2 + (i18 >>> 5 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i18 & 31);
  i2 = i2 + (i17 >>> 5 << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i17 & 31);
  i2 = HEAP32[i38 >> 2] | 0;
  i1 = HEAP32[i30 >> 2] | 0;
  L105 : do if ((i2 | 0) != (i1 | 0)) {
   i21 = i32 + 4 | 0;
   i22 = i32 + 8 | 0;
   i23 = i38 + 8 | 0;
   i24 = i33 + 4 | 0;
   i25 = i33 + 8 | 0;
   i26 = i33 + 8 | 0;
   i27 = i32 + 8 | 0;
   i20 = 2;
   do {
    i17 = HEAP32[i2 >> 2] | 0;
    i18 = HEAP32[i2 + 4 >> 2] | 0;
    i19 = HEAP32[i2 + 8 >> 2] | 0;
    i16 = i1 - i2 | 0;
    i3 = i16 >> 4;
    do if ((i16 | 0) > 16) {
     i16 = i1 + -16 | 0;
     HEAP32[i37 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i37 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i37 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i37 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i16 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
     i16 = i3 + -1 | 0;
     if ((i3 | 0) != 2) {
      i9 = i3 + -3 | 0;
      i10 = (i9 | 0) / 2 | 0;
      if ((i9 | 0) < -1) break;
      i1 = i2 + 16 | 0;
      if ((i16 | 0) > 2) {
       i9 = (HEAP32[i2 + 28 >> 2] | 0) < (HEAP32[i2 + 44 >> 2] | 0);
       i3 = i9 ? 2 : 1;
       i1 = i9 ? i2 + 32 | 0 : i1;
      } else i3 = 1;
      i9 = HEAP32[i2 + 12 >> 2] | 0;
      if ((HEAP32[i1 + 12 >> 2] | 0) < (i9 | 0)) break;
      HEAP32[i37 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i37 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i37 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i8 = i2;
      while (1) {
       i7 = i8;
       i8 = i1;
       HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
       HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
       if ((i10 | 0) < (i3 | 0)) break;
       i3 = i3 << 1 | 1;
       i5 = i2 + (i3 << 4) | 0;
       i4 = i5;
       i7 = i3 + 1 | 0;
       if ((i7 | 0) < (i16 | 0)) {
        i5 = i5 + 16 | 0;
        i45 = (HEAP32[i2 + (i3 << 4) + 12 >> 2] | 0) < (HEAP32[i5 + 12 >> 2] | 0);
        i3 = i45 ? i7 : i3;
        i4 = i45 ? i5 : i4;
       }
       if ((HEAP32[i4 + 12 >> 2] | 0) < (i9 | 0)) break; else i1 = i4;
      }
      HEAP32[i8 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = i9;
     }
    } while (0);
    HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + -16;
    i45 = (HEAP32[i39 >> 2] | 0) + (i19 >>> 5 << 2) | 0;
    HEAP32[i45 >> 2] = HEAP32[i45 >> 2] | 1 << (i19 & 31);
    i20 = i20 + 1 | 0;
    if ((i20 | 0) == (i31 | 0)) break L105;
    HEAP32[i32 >> 2] = 0;
    HEAP32[i21 >> 2] = 0;
    HEAP32[i22 >> 2] = 0;
    i2 = HEAP32[i41 >> 2] | 0;
    i1 = HEAP32[i42 >> 2] | 0;
    i3 = i2 - i1 | 0;
    i4 = i3 >> 5;
    do if (i4 | 0) {
     if (i4 >>> 0 > 134217727) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i32);
      i1 = HEAP32[i42 >> 2] | 0;
      i2 = HEAP32[i41 >> 2] | 0;
     }
     i7 = __Znwj(i3) | 0;
     HEAP32[i21 >> 2] = i7;
     HEAP32[i32 >> 2] = i7;
     HEAP32[i27 >> 2] = i7 + (i4 << 5);
     if ((i1 | 0) == (i2 | 0)) break;
     i5 = (i2 + -32 - i1 | 0) >>> 5;
     i3 = i7;
     i4 = i7;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      i45 = i3 + 16 | 0;
      i16 = i1 + 16 | 0;
      HEAP32[i45 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      i1 = i1 + 32 | 0;
      i4 = i4 + 32 | 0;
      if ((i1 | 0) == (i2 | 0)) break; else i3 = i4;
     }
     HEAP32[i21 >> 2] = i7 + 32 + (i5 << 5);
    } while (0);
    __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i37, i32, i17, i19);
    HEAP32[i34 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i34 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i34 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    HEAP32[i34 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
    i1 = HEAP32[i32 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = HEAP32[i21 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i21 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
     __ZdlPv(i1);
    }
    do if ((HEAP32[i29 >> 2] | 0) > -1) {
     i1 = HEAP32[i30 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
      __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i38, i34);
      i3 = HEAP32[i30 >> 2] | 0;
     } else {
      HEAP32[i1 >> 2] = HEAP32[i34 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
      i3 = (HEAP32[i30 >> 2] | 0) + 16 | 0;
      HEAP32[i30 >> 2] = i3;
     }
     i2 = HEAP32[i38 >> 2] | 0;
     i1 = i3 - i2 | 0;
     if ((i1 | 0) <= 16) break;
     i1 = ((i1 >> 4) + -2 | 0) / 2 | 0;
     i5 = i3;
     i3 = i5 + -16 | 0;
     i5 = HEAP32[i5 + -4 >> 2] | 0;
     if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break;
     HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i37 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i37 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     while (1) {
      i45 = i3;
      i3 = i2 + (i1 << 4) | 0;
      HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      if (!i1) {
       i1 = 0;
       break;
      }
      i4 = (i1 + -1 | 0) / 2 | 0;
      if ((HEAP32[i2 + (i4 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break; else i1 = i4;
     }
     HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i2 + (i1 << 4) + 12 >> 2] = i5;
    } while (0);
    HEAP32[i33 >> 2] = 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i25 >> 2] = 0;
    i2 = HEAP32[i41 >> 2] | 0;
    i1 = HEAP32[i42 >> 2] | 0;
    i3 = i2 - i1 | 0;
    i4 = i3 >> 5;
    do if (i4 | 0) {
     if (i4 >>> 0 > 134217727) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i33);
      i1 = HEAP32[i42 >> 2] | 0;
      i2 = HEAP32[i41 >> 2] | 0;
     }
     i7 = __Znwj(i3) | 0;
     HEAP32[i24 >> 2] = i7;
     HEAP32[i33 >> 2] = i7;
     HEAP32[i26 >> 2] = i7 + (i4 << 5);
     if ((i1 | 0) == (i2 | 0)) break;
     i5 = (i2 + -32 - i1 | 0) >>> 5;
     i3 = i7;
     i4 = i7;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      i45 = i3 + 16 | 0;
      i17 = i1 + 16 | 0;
      HEAP32[i45 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
      i1 = i1 + 32 | 0;
      i4 = i4 + 32 | 0;
      if ((i1 | 0) == (i2 | 0)) break; else i3 = i4;
     }
     HEAP32[i24 >> 2] = i7 + 32 + (i5 << 5);
    } while (0);
    __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i37, i33, i19, i18);
    HEAP32[i35 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
    i1 = HEAP32[i33 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = HEAP32[i24 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
     __ZdlPv(i1);
    }
    do if ((HEAP32[i28 >> 2] | 0) > -1) {
     i1 = HEAP32[i30 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
      __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i38, i35);
      i3 = HEAP32[i30 >> 2] | 0;
     } else {
      HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
      i3 = (HEAP32[i30 >> 2] | 0) + 16 | 0;
      HEAP32[i30 >> 2] = i3;
     }
     i2 = HEAP32[i38 >> 2] | 0;
     i1 = i3 - i2 | 0;
     if ((i1 | 0) <= 16) break;
     i1 = ((i1 >> 4) + -2 | 0) / 2 | 0;
     i5 = i3;
     i3 = i5 + -16 | 0;
     i5 = HEAP32[i5 + -4 >> 2] | 0;
     if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break;
     HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i37 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i37 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     while (1) {
      i45 = i3;
      i3 = i2 + (i1 << 4) | 0;
      HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      if (!i1) {
       i1 = 0;
       break;
      }
      i4 = (i1 + -1 | 0) / 2 | 0;
      if ((HEAP32[i2 + (i4 << 4) + 12 >> 2] | 0) >= (i5 | 0)) break; else i1 = i4;
     }
     HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i2 + (i1 << 4) + 12 >> 2] = i5;
    } while (0);
    i2 = HEAP32[i38 >> 2] | 0;
    i1 = HEAP32[i30 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
  } while (0);
  i1 = HEAP32[i42 >> 2] | 0;
  i2 = HEAP32[i41 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i41 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
  i5 = i42 + 8 | 0;
  i4 = 0;
  i1 = HEAP32[i39 >> 2] | 0;
  do {
   do if (HEAP32[i1 + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31) | 0) {
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = i1 + (i4 << 5) | 0;
    i3 = HEAP32[i41 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) {
     __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i42, i2);
     break;
    } else {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + (i4 << 5) + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + (i4 << 5) + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + (i4 << 5) + 12 >> 2];
     i45 = i3 + 16 | 0;
     i37 = i1 + (i4 << 5) + 16 | 0;
     HEAP32[i45 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i45 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i45 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i45 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
     HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 32;
     break;
    }
   } while (0);
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
  } while ((i4 | 0) < (i40 | 0));
  if (i1 | 0) __ZdlPv(i1);
  i1 = HEAP32[i38 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i30 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i30 >> 2] = i3 + (~((i3 + -16 - i2 | 0) >>> 4) << 4);
   __ZdlPv(i1);
  }
 } while (0);
 if (!((i43 | 0) == 1 ? (HEAP32[i42 + 20 >> 2] | 0) == 43 : 0)) {
  STACKTOP = i44;
  return;
 }
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i42, 1);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i42, 2);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i42, 8);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i42, 4);
 STACKTOP = i44;
 return;
}

function __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j(i8, i11, i12) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 24 | 0;
 i10 = i13;
 i7 = i13 + 32 | 0;
 i5 = i8 + 120 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i10 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 136 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 152 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 168 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 184 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 200 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i8 + 224 >> 2] | 0;
 i5 = HEAP32[i8 + 216 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i14 = i9;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(i6 | 0, i7 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i6 = i11 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i4, i10) | 0;
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 256 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 272 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 288 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 304 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 332 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i9;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i14 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 15 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 15 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i8, i11, i12) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 24 | 0;
 i10 = i13;
 i7 = i13 + 32 | 0;
 i5 = i8 + 120 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i3 = i10 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 136 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 152 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 168 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 184 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 200 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i8 + 224 >> 2] | 0;
 i5 = HEAP32[i8 + 216 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i11 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i14 = i9;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(i6 | 0, i7 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i6 = i11 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i4, i10) | 0;
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 256 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 272 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 288 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 304 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i8 + 332 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i14 = i10 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i9;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i14 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i14 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i9) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i11, i10);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 15 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 15 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN12LineRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f(i93, i94, i4, i95) {
 i93 = i93 | 0;
 i94 = i94 | 0;
 i4 = i4 | 0;
 i95 = i95 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0, f156 = f0, f157 = f0;
 i105 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i99 = i105 + 672 | 0;
 i100 = i105 + 608 | 0;
 i104 = i105 + 596 | 0;
 i3 = i105 + 68 | 0;
 i101 = i105 + 64 | 0;
 i96 = i105;
 i97 = i105 + 592 | 0;
 if ((HEAP16[gb + 1158256 + 6 >> 1] | 0) > -1) {
  HEAP32[i100 >> 2] = 0;
  HEAP32[i99 >> 2] = HEAP32[i100 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158256 | 0, i99);
  i102 = gb + 1158256 | 0;
 } else i102 = 0;
 HEAP32[i104 >> 2] = 0;
 i103 = i104 + 4 | 0;
 i91 = gb + 63160 | 0;
 i92 = HEAP32[i91 + 4 >> 2] | 0;
 i1 = i103;
 HEAP32[i1 >> 2] = HEAP32[i91 >> 2];
 HEAP32[i1 + 4 >> 2] = i92;
 i1 = i94 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 406663 | 0, 293) | 0;
   i91 = gb + 64016 | 0;
   i90 = HEAP32[i91 >> 2] | 0;
   i91 = HEAP32[i91 + 4 >> 2] | 0;
   HEAP32[i104 >> 2] = i1;
   i92 = i103;
   HEAP32[i92 >> 2] = i90;
   HEAP32[i92 + 4 >> 2] = i91;
   break;
  }
 } while (0);
 i92 = i1 + 3 & -4;
 __ZN14BatchAllocatorC2Ev(i3);
 HEAP32[i101 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, i101, -1, 24, 1, 4);
 HEAP32[i101 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, 0, 0, 20, i94, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, (HEAP32[i101 >> 2] | 0) + 4 | 0, 0, 140, i94, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i3, gb + 64024 | 0);
 __Z25InvertMatrix4x4_General3DPKfPf(i95, i96) | 0;
 i90 = __ZNK6Camera20GetWorldToClipMatrixEv(i4) | 0;
 i43 = HEAP32[i4 + 880 >> 2] | 0;
 i91 = __Z12GetGfxDevicev() | 0;
 i44 = __ZN9GfxDevice13GetDynamicVBOEv(i91) | 0;
 i89 = HEAP32[i101 >> 2] | 0;
 __ZN17UniqueIDGenerator8CreateIDEv(i99, i91 + 4448 | 0);
 HEAP32[i89 + 8 >> 2] = HEAP32[i99 >> 2];
 if (!i94) i98 = 55; else {
  i45 = i95 + 4 | 0;
  i46 = i95 + 8 | 0;
  i47 = i95 + 12 | 0;
  i48 = i95 + 16 | 0;
  i49 = i95 + 20 | 0;
  i50 = i95 + 24 | 0;
  i51 = i95 + 28 | 0;
  i52 = i95 + 32 | 0;
  i53 = i95 + 36 | 0;
  i54 = i95 + 40 | 0;
  i55 = i95 + 44 | 0;
  i56 = i95 + 48 | 0;
  i57 = i95 + 52 | 0;
  i58 = i95 + 56 | 0;
  i59 = i95 + 60 | 0;
  i60 = i90 + 4 | 0;
  i61 = i90 + 8 | 0;
  i62 = i90 + 12 | 0;
  i63 = i90 + 16 | 0;
  i64 = i90 + 20 | 0;
  i65 = i90 + 24 | 0;
  i66 = i90 + 28 | 0;
  i67 = i90 + 32 | 0;
  i68 = i90 + 36 | 0;
  i69 = i90 + 40 | 0;
  i70 = i90 + 44 | 0;
  i71 = i90 + 48 | 0;
  i72 = i90 + 52 | 0;
  i73 = i90 + 56 | 0;
  i74 = i90 + 60 | 0;
  i75 = i96 + 4 | 0;
  i76 = i96 + 8 | 0;
  i77 = i96 + 12 | 0;
  i78 = i96 + 16 | 0;
  i79 = i96 + 20 | 0;
  i80 = i96 + 24 | 0;
  i81 = i96 + 28 | 0;
  i82 = i96 + 32 | 0;
  i83 = i96 + 36 | 0;
  i84 = i96 + 40 | 0;
  i85 = i96 + 44 | 0;
  i86 = i96 + 48 | 0;
  i87 = i96 + 52 | 0;
  i88 = i96 + 56 | 0;
  i89 = i96 + 60 | 0;
  i13 = i99 + 32 | 0;
  i14 = i99 + 36 | 0;
  i15 = i99 + 40 | 0;
  i16 = i99 + 48 | 0;
  i17 = i99 + 52 | 0;
  i18 = i99 + 56 | 0;
  i19 = i99 + 4 | 0;
  i20 = i99 + 8 | 0;
  i21 = i99 + 12 | 0;
  i22 = i99 + 16 | 0;
  i23 = i99 + 20 | 0;
  i24 = i99 + 24 | 0;
  i25 = i99 + 28 | 0;
  i26 = i99 + 44 | 0;
  i27 = i99 + 60 | 0;
  i28 = i100 + 4 | 0;
  i29 = i100 + 8 | 0;
  i30 = i100 + 12 | 0;
  i31 = i100 + 16 | 0;
  i32 = i100 + 20 | 0;
  i33 = i100 + 24 | 0;
  i34 = i100 + 28 | 0;
  i35 = i100 + 32 | 0;
  i36 = i100 + 36 | 0;
  i37 = i100 + 40 | 0;
  i38 = i100 + 44 | 0;
  i39 = i100 + 48 | 0;
  i40 = i100 + 52 | 0;
  i41 = i100 + 56 | 0;
  i42 = i100 + 60 | 0;
  i3 = 0;
  i1 = 0;
  i12 = 0;
  do {
   i8 = HEAP32[i93 + (i12 << 2) >> 2] | 0;
   i8 = (i8 | 0) == 0 ? 0 : i8 + -32 | 0;
   i9 = i8 + 352 | 0;
   do if (__ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle(i44, i9) | 0) if ((HEAP32[i8 + 500 >> 2] | 0) == (i43 | 0)) if ((HEAP32[i8 + 372 >> 2] | 0) == (HEAP32[i95 >> 2] | 0)) if ((HEAP32[i8 + 376 >> 2] | 0) == (HEAP32[i45 >> 2] | 0)) if ((HEAP32[i8 + 380 >> 2] | 0) == (HEAP32[i46 >> 2] | 0)) if ((HEAP32[i8 + 384 >> 2] | 0) == (HEAP32[i47 >> 2] | 0)) if ((HEAP32[i8 + 388 >> 2] | 0) == (HEAP32[i48 >> 2] | 0)) if ((HEAP32[i8 + 392 >> 2] | 0) == (HEAP32[i49 >> 2] | 0)) if ((HEAP32[i8 + 396 >> 2] | 0) == (HEAP32[i50 >> 2] | 0)) if ((HEAP32[i8 + 400 >> 2] | 0) == (HEAP32[i51 >> 2] | 0)) if ((HEAP32[i8 + 404 >> 2] | 0) == (HEAP32[i52 >> 2] | 0)) if ((HEAP32[i8 + 408 >> 2] | 0) == (HEAP32[i53 >> 2] | 0)) if ((HEAP32[i8 + 412 >> 2] | 0) == (HEAP32[i54 >> 2] | 0)) if ((HEAP32[i8 + 416 >> 2] | 0) == (HEAP32[i55 >> 2] | 0)) {
    if ((HEAP32[i8 + 420 >> 2] | 0) != (HEAP32[i56 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 424 >> 2] | 0) != (HEAP32[i57 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 428 >> 2] | 0) != (HEAP32[i58 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 432 >> 2] | 0) != (HEAP32[i59 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 436 >> 2] | 0) != (HEAP32[i90 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 440 >> 2] | 0) != (HEAP32[i60 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 444 >> 2] | 0) != (HEAP32[i61 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 448 >> 2] | 0) != (HEAP32[i62 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 452 >> 2] | 0) != (HEAP32[i63 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 456 >> 2] | 0) != (HEAP32[i64 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 460 >> 2] | 0) != (HEAP32[i65 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 464 >> 2] | 0) != (HEAP32[i66 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 468 >> 2] | 0) != (HEAP32[i67 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 472 >> 2] | 0) != (HEAP32[i68 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 476 >> 2] | 0) != (HEAP32[i69 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 480 >> 2] | 0) != (HEAP32[i70 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 484 >> 2] | 0) != (HEAP32[i71 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 488 >> 2] | 0) != (HEAP32[i72 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 492 >> 2] | 0) != (HEAP32[i73 >> 2] | 0)) {
     i98 = 44;
     break;
    }
    if ((HEAP32[i8 + 496 >> 2] | 0) != (HEAP32[i74 >> 2] | 0)) i98 = 44;
   } else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; else i98 = 44; while (0);
   if ((i98 | 0) == 44) {
    i98 = 0;
    i2 = HEAP32[i8 + 348 >> 2] | 0;
    i4 = HEAP32[i2 + 20 >> 2] | 0;
    if (i4 >>> 0 >= 2) {
     i10 = HEAP32[(HEAP32[i101 >> 2] | 0) + 4 >> 2] | 0;
     i7 = i2 + 4 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i7 = HEAP32[i8 + 344 >> 2] | 0;
     i106 = i7 + 4 | 0;
     HEAP32[i106 >> 2] = (HEAP32[i106 >> 2] | 0) + 1;
     i106 = HEAP32[i7 + 180 >> 2] | 0;
     i106 = Math_imul((i106 | 0) < 0 ? 0 : i106, i4 + -2 | 0) | 0;
     i11 = HEAP32[i7 + 184 >> 2] | 0;
     i11 = (i106 + i4 << 1) + ((i11 | 0) > 0 ? (i11 << 2) + 8 | 0 : 0) | 0;
     HEAP32[i10 + (i3 * 140 | 0) + 136 >> 2] = i4;
     HEAP32[i10 + (i3 * 140 | 0) + 4 >> 2] = i2;
     HEAP32[i10 + (i3 * 140 | 0) >> 2] = i7;
     if (!(HEAP32[i7 + 188 >> 2] | 0)) {
      i107 = HEAP32[i45 >> 2] | 0;
      i108 = HEAP32[i46 >> 2] | 0;
      i109 = HEAP32[i47 >> 2] | 0;
      i110 = HEAP32[i48 >> 2] | 0;
      i111 = HEAP32[i49 >> 2] | 0;
      i112 = HEAP32[i50 >> 2] | 0;
      i113 = HEAP32[i51 >> 2] | 0;
      i114 = HEAP32[i52 >> 2] | 0;
      i115 = HEAP32[i53 >> 2] | 0;
      i116 = HEAP32[i54 >> 2] | 0;
      i117 = HEAP32[i55 >> 2] | 0;
      i118 = HEAP32[i56 >> 2] | 0;
      i119 = HEAP32[i57 >> 2] | 0;
      i2 = HEAP32[i58 >> 2] | 0;
      i4 = HEAP32[i59 >> 2] | 0;
      HEAP32[i10 + (i3 * 140 | 0) + 8 >> 2] = HEAP32[i95 >> 2];
      HEAP32[i10 + (i3 * 140 | 0) + 12 >> 2] = i107;
      HEAP32[i10 + (i3 * 140 | 0) + 16 >> 2] = i108;
      HEAP32[i10 + (i3 * 140 | 0) + 20 >> 2] = i109;
      HEAP32[i10 + (i3 * 140 | 0) + 24 >> 2] = i110;
      HEAP32[i10 + (i3 * 140 | 0) + 28 >> 2] = i111;
      HEAP32[i10 + (i3 * 140 | 0) + 32 >> 2] = i112;
      HEAP32[i10 + (i3 * 140 | 0) + 36 >> 2] = i113;
      HEAP32[i10 + (i3 * 140 | 0) + 40 >> 2] = i114;
      HEAP32[i10 + (i3 * 140 | 0) + 44 >> 2] = i115;
      HEAP32[i10 + (i3 * 140 | 0) + 48 >> 2] = i116;
      HEAP32[i10 + (i3 * 140 | 0) + 52 >> 2] = i117;
      HEAP32[i10 + (i3 * 140 | 0) + 56 >> 2] = i118;
      HEAP32[i10 + (i3 * 140 | 0) + 60 >> 2] = i119;
      HEAP32[i10 + (i3 * 140 | 0) + 64 >> 2] = i2;
      HEAP32[i10 + (i3 * 140 | 0) + 68 >> 2] = i4;
      i119 = HEAP32[i75 >> 2] | 0;
      i118 = HEAP32[i76 >> 2] | 0;
      i117 = HEAP32[i77 >> 2] | 0;
      i116 = HEAP32[i78 >> 2] | 0;
      i115 = HEAP32[i79 >> 2] | 0;
      i114 = HEAP32[i80 >> 2] | 0;
      i113 = HEAP32[i81 >> 2] | 0;
      i112 = HEAP32[i82 >> 2] | 0;
      i111 = HEAP32[i83 >> 2] | 0;
      i110 = HEAP32[i84 >> 2] | 0;
      i109 = HEAP32[i85 >> 2] | 0;
      i108 = HEAP32[i86 >> 2] | 0;
      i107 = HEAP32[i87 >> 2] | 0;
      i7 = HEAP32[i88 >> 2] | 0;
      i106 = HEAP32[i89 >> 2] | 0;
      HEAP32[i10 + (i3 * 140 | 0) + 72 >> 2] = HEAP32[i96 >> 2];
      HEAP32[i10 + (i3 * 140 | 0) + 76 >> 2] = i119;
      HEAP32[i10 + (i3 * 140 | 0) + 80 >> 2] = i118;
      HEAP32[i10 + (i3 * 140 | 0) + 84 >> 2] = i117;
      HEAP32[i10 + (i3 * 140 | 0) + 88 >> 2] = i116;
      HEAP32[i10 + (i3 * 140 | 0) + 92 >> 2] = i115;
      HEAP32[i10 + (i3 * 140 | 0) + 96 >> 2] = i114;
      HEAP32[i10 + (i3 * 140 | 0) + 100 >> 2] = i113;
      HEAP32[i10 + (i3 * 140 | 0) + 104 >> 2] = i112;
      HEAP32[i10 + (i3 * 140 | 0) + 108 >> 2] = i111;
      HEAP32[i10 + (i3 * 140 | 0) + 112 >> 2] = i110;
      HEAP32[i10 + (i3 * 140 | 0) + 116 >> 2] = i109;
      HEAP32[i10 + (i3 * 140 | 0) + 120 >> 2] = i108;
      HEAP32[i10 + (i3 * 140 | 0) + 124 >> 2] = i107;
      HEAP32[i10 + (i3 * 140 | 0) + 128 >> 2] = i7;
      HEAP32[i10 + (i3 * 140 | 0) + 132 >> 2] = i106;
     } else {
      i2 = i99;
      i4 = i8 + 36 | 0;
      i7 = i2 + 64 | 0;
      do {
       HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
       i2 = i2 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i2 | 0) < (i7 | 0));
      i110 = HEAP32[i13 >> 2] | 0;
      i109 = HEAP32[i14 >> 2] | 0;
      i108 = HEAP32[i15 >> 2] | 0;
      HEAP32[i16 >> 2] = i110;
      HEAP32[i17 >> 2] = i109;
      HEAP32[i18 >> 2] = i108;
      i118 = HEAP32[i19 >> 2] | 0;
      i117 = HEAP32[i20 >> 2] | 0;
      i116 = HEAP32[i21 >> 2] | 0;
      i115 = HEAP32[i22 >> 2] | 0;
      i114 = HEAP32[i23 >> 2] | 0;
      i113 = HEAP32[i24 >> 2] | 0;
      i112 = HEAP32[i25 >> 2] | 0;
      i111 = HEAP32[i26 >> 2] | 0;
      i107 = HEAP32[i27 >> 2] | 0;
      HEAP32[i10 + (i3 * 140 | 0) + 72 >> 2] = HEAP32[i99 >> 2];
      HEAP32[i10 + (i3 * 140 | 0) + 76 >> 2] = i118;
      HEAP32[i10 + (i3 * 140 | 0) + 80 >> 2] = i117;
      HEAP32[i10 + (i3 * 140 | 0) + 84 >> 2] = i116;
      HEAP32[i10 + (i3 * 140 | 0) + 88 >> 2] = i115;
      HEAP32[i10 + (i3 * 140 | 0) + 92 >> 2] = i114;
      HEAP32[i10 + (i3 * 140 | 0) + 96 >> 2] = i113;
      HEAP32[i10 + (i3 * 140 | 0) + 100 >> 2] = i112;
      HEAP32[i10 + (i3 * 140 | 0) + 104 >> 2] = i110;
      HEAP32[i10 + (i3 * 140 | 0) + 108 >> 2] = i109;
      HEAP32[i10 + (i3 * 140 | 0) + 112 >> 2] = i108;
      HEAP32[i10 + (i3 * 140 | 0) + 116 >> 2] = i111;
      HEAP32[i10 + (i3 * 140 | 0) + 120 >> 2] = i110;
      HEAP32[i10 + (i3 * 140 | 0) + 124 >> 2] = i109;
      HEAP32[i10 + (i3 * 140 | 0) + 128 >> 2] = i108;
      HEAP32[i10 + (i3 * 140 | 0) + 132 >> 2] = i107;
      __Z25InvertMatrix4x4_General3DPKfPf(i99, i100) | 0;
      i107 = HEAP32[i28 >> 2] | 0;
      i108 = HEAP32[i29 >> 2] | 0;
      i109 = HEAP32[i30 >> 2] | 0;
      i110 = HEAP32[i31 >> 2] | 0;
      i111 = HEAP32[i32 >> 2] | 0;
      i112 = HEAP32[i33 >> 2] | 0;
      i113 = HEAP32[i34 >> 2] | 0;
      i114 = HEAP32[i35 >> 2] | 0;
      i115 = HEAP32[i36 >> 2] | 0;
      i116 = HEAP32[i37 >> 2] | 0;
      i117 = HEAP32[i38 >> 2] | 0;
      i118 = HEAP32[i39 >> 2] | 0;
      i119 = HEAP32[i40 >> 2] | 0;
      i2 = HEAP32[i41 >> 2] | 0;
      i4 = HEAP32[i42 >> 2] | 0;
      HEAP32[i10 + (i3 * 140 | 0) + 8 >> 2] = HEAP32[i100 >> 2];
      HEAP32[i10 + (i3 * 140 | 0) + 12 >> 2] = i107;
      HEAP32[i10 + (i3 * 140 | 0) + 16 >> 2] = i108;
      HEAP32[i10 + (i3 * 140 | 0) + 20 >> 2] = i109;
      HEAP32[i10 + (i3 * 140 | 0) + 24 >> 2] = i110;
      HEAP32[i10 + (i3 * 140 | 0) + 28 >> 2] = i111;
      HEAP32[i10 + (i3 * 140 | 0) + 32 >> 2] = i112;
      HEAP32[i10 + (i3 * 140 | 0) + 36 >> 2] = i113;
      HEAP32[i10 + (i3 * 140 | 0) + 40 >> 2] = i114;
      HEAP32[i10 + (i3 * 140 | 0) + 44 >> 2] = i115;
      HEAP32[i10 + (i3 * 140 | 0) + 48 >> 2] = i116;
      HEAP32[i10 + (i3 * 140 | 0) + 52 >> 2] = i117;
      HEAP32[i10 + (i3 * 140 | 0) + 56 >> 2] = i118;
      HEAP32[i10 + (i3 * 140 | 0) + 60 >> 2] = i119;
      HEAP32[i10 + (i3 * 140 | 0) + 64 >> 2] = i2;
      HEAP32[i10 + (i3 * 140 | 0) + 68 >> 2] = i4;
     }
     f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (!(HEAP8[i8 + 340 >> 0] | 0)) {
      f129 = Math_fround(HEAPF32[i8 + 36 >> 2]);
      f149 = Math_fround(HEAPF32[i8 + 40 >> 2]);
      f131 = Math_fround(HEAPF32[i8 + 44 >> 2]);
      f130 = Math_fround(HEAPF32[i8 + 48 >> 2]);
      f125 = Math_fround(HEAPF32[i8 + 52 >> 2]);
      f124 = Math_fround(HEAPF32[i8 + 56 >> 2]);
      f127 = Math_fround(HEAPF32[i8 + 60 >> 2]);
      f126 = Math_fround(HEAPF32[i8 + 64 >> 2]);
      f153 = Math_fround(HEAPF32[i8 + 68 >> 2]);
      f154 = Math_fround(HEAPF32[i8 + 72 >> 2]);
      f123 = Math_fround(HEAPF32[i8 + 76 >> 2]);
      f152 = Math_fround(HEAPF32[i8 + 80 >> 2]);
      f141 = Math_fround(HEAPF32[i8 + 84 >> 2]);
      f143 = Math_fround(HEAPF32[i8 + 88 >> 2]);
      f138 = Math_fround(HEAPF32[i8 + 92 >> 2]);
      f139 = Math_fround(HEAPF32[i8 + 96 >> 2]);
      i110 = i10 + (i3 * 140 | 0) + 24 | 0;
      f151 = Math_fround(HEAPF32[i110 >> 2]);
      f156 = Math_fround(f149 * f151);
      i111 = i10 + (i3 * 140 | 0) + 28 | 0;
      f148 = Math_fround(HEAPF32[i111 >> 2]);
      f146 = Math_fround(f149 * f148);
      i112 = i10 + (i3 * 140 | 0) + 32 | 0;
      f145 = Math_fround(HEAPF32[i112 >> 2]);
      f135 = Math_fround(f149 * f145);
      i113 = i10 + (i3 * 140 | 0) + 36 | 0;
      f142 = Math_fround(HEAPF32[i113 >> 2]);
      f149 = Math_fround(f149 * f142);
      i106 = i10 + (i3 * 140 | 0) + 8 | 0;
      f150 = Math_fround(HEAPF32[i106 >> 2]);
      f136 = Math_fround(f129 * f150);
      i107 = i10 + (i3 * 140 | 0) + 12 | 0;
      f147 = Math_fround(HEAPF32[i107 >> 2]);
      f157 = Math_fround(f129 * f147);
      i108 = i10 + (i3 * 140 | 0) + 16 | 0;
      f144 = Math_fround(HEAPF32[i108 >> 2]);
      f155 = Math_fround(f129 * f144);
      i109 = i10 + (i3 * 140 | 0) + 20 | 0;
      f140 = Math_fround(HEAPF32[i109 >> 2]);
      f136 = Math_fround(f156 + f136);
      f157 = Math_fround(f146 + f157);
      f155 = Math_fround(f135 + f155);
      f129 = Math_fround(f149 + Math_fround(f129 * f140));
      i118 = i10 + (i3 * 140 | 0) + 56 | 0;
      f149 = Math_fround(HEAPF32[i118 >> 2]);
      f135 = Math_fround(f130 * f149);
      i119 = i10 + (i3 * 140 | 0) + 60 | 0;
      f146 = Math_fround(HEAPF32[i119 >> 2]);
      f156 = Math_fround(f130 * f146);
      f128 = Math_fround(f130 * f6);
      f130 = Math_fround(f130 * f5);
      i114 = i10 + (i3 * 140 | 0) + 40 | 0;
      f122 = Math_fround(HEAPF32[i114 >> 2]);
      f134 = Math_fround(f131 * f122);
      i115 = i10 + (i3 * 140 | 0) + 44 | 0;
      f121 = Math_fround(HEAPF32[i115 >> 2]);
      f133 = Math_fround(f131 * f121);
      i116 = i10 + (i3 * 140 | 0) + 48 | 0;
      f120 = Math_fround(HEAPF32[i116 >> 2]);
      f132 = Math_fround(f131 * f120);
      i117 = i10 + (i3 * 140 | 0) + 52 | 0;
      f137 = Math_fround(HEAPF32[i117 >> 2]);
      f133 = Math_fround(f157 + Math_fround(f156 + f133));
      f132 = Math_fround(f155 + Math_fround(f128 + f132));
      f131 = Math_fround(f129 + Math_fround(f130 + Math_fround(f131 * f137)));
      f130 = Math_fround(Math_fround(Math_fround(f124 * f151) + Math_fround(f125 * f150)) + Math_fround(Math_fround(f126 * f149) + Math_fround(f127 * f122)));
      f129 = Math_fround(Math_fround(Math_fround(f124 * f148) + Math_fround(f125 * f147)) + Math_fround(Math_fround(f126 * f146) + Math_fround(f127 * f121)));
      f128 = Math_fround(Math_fround(Math_fround(f124 * f145) + Math_fround(f125 * f144)) + Math_fround(Math_fround(f126 * f6) + Math_fround(f127 * f120)));
      f127 = Math_fround(Math_fround(Math_fround(f124 * f142) + Math_fround(f125 * f140)) + Math_fround(Math_fround(f126 * f5) + Math_fround(f127 * f137)));
      f126 = Math_fround(Math_fround(Math_fround(f154 * f151) + Math_fround(f153 * f150)) + Math_fround(Math_fround(f152 * f149) + Math_fround(f123 * f122)));
      f125 = Math_fround(Math_fround(Math_fround(f154 * f148) + Math_fround(f153 * f147)) + Math_fround(Math_fround(f152 * f146) + Math_fround(f123 * f121)));
      f124 = Math_fround(Math_fround(Math_fround(f154 * f145) + Math_fround(f153 * f144)) + Math_fround(Math_fround(f152 * f6) + Math_fround(f123 * f120)));
      f123 = Math_fround(Math_fround(Math_fround(f154 * f142) + Math_fround(f153 * f140)) + Math_fround(Math_fround(f152 * f5) + Math_fround(f123 * f137)));
      f122 = Math_fround(Math_fround(Math_fround(f143 * f151) + Math_fround(f141 * f150)) + Math_fround(Math_fround(f139 * f149) + Math_fround(f138 * f122)));
      f121 = Math_fround(Math_fround(Math_fround(f143 * f148) + Math_fround(f141 * f147)) + Math_fround(Math_fround(f139 * f146) + Math_fround(f138 * f121)));
      f120 = Math_fround(Math_fround(Math_fround(f143 * f145) + Math_fround(f141 * f144)) + Math_fround(Math_fround(f139 * f6) + Math_fround(f138 * f120)));
      f6 = Math_fround(Math_fround(Math_fround(f143 * f142) + Math_fround(f141 * f140)) + Math_fround(Math_fround(f139 * f5) + Math_fround(f138 * f137)));
      HEAPF32[i106 >> 2] = Math_fround(f136 + Math_fround(f135 + f134));
      HEAPF32[i107 >> 2] = f133;
      HEAPF32[i108 >> 2] = f132;
      HEAPF32[i109 >> 2] = f131;
      HEAPF32[i110 >> 2] = f130;
      HEAPF32[i111 >> 2] = f129;
      HEAPF32[i112 >> 2] = f128;
      HEAPF32[i113 >> 2] = f127;
      HEAPF32[i114 >> 2] = f126;
      HEAPF32[i115 >> 2] = f125;
      HEAPF32[i116 >> 2] = f124;
      HEAPF32[i117 >> 2] = f123;
      HEAPF32[i118 >> 2] = f122;
      HEAPF32[i119 >> 2] = f121;
      HEAPF32[i10 + (i3 * 140 | 0) + 64 >> 2] = f120;
      HEAPF32[i10 + (i3 * 140 | 0) + 68 >> 2] = f6;
     }
     i2 = HEAP32[HEAP32[i101 >> 2] >> 2] | 0;
     HEAP32[i2 + (i3 * 20 | 0) + 8 >> 2] = i11;
     HEAP32[i2 + (i3 * 20 | 0) + 12 >> 2] = 0;
     HEAP32[i2 + (i3 * 20 | 0) + 16 >> 2] = 24;
     HEAP32[i8 + 368 >> 2] = i1;
     i2 = i8 + 372 | 0;
     i4 = i95;
     i7 = i2 + 64 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      i2 = i2 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i2 | 0) < (i7 | 0));
     i2 = i8 + 436 | 0;
     i4 = i90;
     i7 = i2 + 64 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      i2 = i2 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i2 | 0) < (i7 | 0));
     HEAP32[i8 + 500 >> 2] = i43;
     HEAP32[i92 + (i3 << 2) >> 2] = i9;
     i3 = i3 + 1 | 0;
     i1 = (i11 * 24 | 0) + i1 | 0;
    }
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i94 | 0));
  if (!i3) i98 = 55; else {
   HEAP32[i100 >> 2] = 0;
   HEAP32[i100 + 4 >> 2] = 0;
   HEAP32[i100 + 8 >> 2] = -1;
   HEAP32[i100 + 12 >> 2] = 0;
   i119 = HEAP32[i101 >> 2] | 0;
   i2 = HEAP32[i119 + 8 >> 2] | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i91 >> 2] | 0) + 252 >> 2] | 0, i91 | 0, fb + 2412 | 0, fb + 3379 | 0, i119 | 0, i3 | 0, 1, i100 | 0);
   HEAP32[i101 >> 2] = 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     i119 = HEAP32[i92 + (i1 << 2) >> 2] | 0;
     HEAP32[i119 >> 2] = HEAP32[i100 >> 2];
     HEAP32[i119 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
     HEAP32[i119 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
     HEAP32[i119 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i119 = HEAP32[(HEAP32[i91 >> 2] | 0) + 256 >> 2] | 0;
   HEAP32[i97 >> 2] = i2;
   HEAP32[i99 >> 2] = HEAP32[i97 >> 2];
   mftCall_vii(i119 | 0, i91 | 0, i99 | 0);
  }
 }
 if ((i98 | 0) == 55) {
  i2 = HEAP32[i101 >> 2] | 0;
  if ((HEAP16[gb + 1158268 + 6 >> 1] | 0) > -1) {
   HEAP32[i100 >> 2] = 0;
   HEAP32[i99 >> 2] = HEAP32[i100 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158268 | 0, i99);
   i1 = gb + 1158268 | 0;
  } else i1 = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  HEAP32[i101 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i104 >> 2] | 0, i103);
 if (!i102) {
  STACKTOP = i105;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i102);
 STACKTOP = i105;
 return;
}

function __ZN20ObjectMemoryProfiler18TakeMemorySnapshotER13dynamic_arrayIiLj4EEb(i24, i1) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i38 + 16 | 0;
 i16 = i38;
 i31 = i38 + 104 | 0;
 i33 = i38 + 84 | 0;
 i35 = i38 + 64 | 0;
 i36 = i38 + 44 | 0;
 i37 = i38 + 24 | 0;
 HEAP32[i31 >> 2] = 0;
 i18 = i31 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i25 = i31 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i31 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i28 = i15;
 i27 = HEAP32[i28 + 4 >> 2] | 0;
 i17 = i26;
 HEAP32[i17 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i17 + 4 >> 2] = i27;
 HEAP32[i33 >> 2] = 0;
 i17 = i33 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i27 = i33 + 16 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i33 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i34 = i15;
 i30 = HEAP32[i34 + 4 >> 2] | 0;
 i29 = i28;
 HEAP32[i29 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i29 + 4 >> 2] = i30;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 i29 = i35 + 16 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i34 = i15;
 i32 = HEAP32[i34 + 4 >> 2] | 0;
 i9 = i30;
 HEAP32[i9 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i9 + 4 >> 2] = i32;
 HEAP32[i36 >> 2] = 0;
 i9 = i36 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i32 = i36 + 16 | 0;
 HEAP32[i32 >> 2] = 0;
 i34 = i36 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i19 = i15;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = i34;
 HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 __Z28CalculateAllObjectReferencesR13dynamic_arrayIP6ObjectLj4EERS_IPKcLj4EERS_IjLj4EES9_b(i31, i33, i35, i36, i1);
 i21 = gb + 63576 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = i16;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 4 >> 2] = i20;
 HEAP32[i37 >> 2] = 0;
 i19 = i37 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i37 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i37 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i16);
 i2 = i15;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i22 = i21;
 HEAP32[i22 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i22 + 4 >> 2] = i5;
 __ZN14MemoryProfiler22GetRootAllocationInfosER13dynamic_arrayINS_18RootAllocationInfoELj4EE(HEAP32[gb + 1163236 >> 2] | 0, i37);
 i22 = i24 + 12 | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i2 = i5 + 1 | 0;
 i23 = i24 + 16 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i2;
 i4 = HEAP32[i24 >> 2] | 0;
 HEAP32[i4 + (i5 << 2) >> 2] = 1;
 i5 = HEAP32[i22 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i24 >> 2] = i1;
   i2 = i1;
   i8 = i1;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i14;
   i2 = i14;
   i8 = i14;
   i1 = i14;
   break;
  } else {
   i2 = i4;
   i8 = i4;
   i1 = i4;
  }
 } else {
  i2 = i4;
  i8 = i4;
  i1 = i4;
 } while (0);
 HEAP32[i22 >> 2] = i6;
 HEAP32[i2 + (i5 << 2) >> 2] = 2;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i22 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i7 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i23 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i24 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i2;
   HEAP32[i24 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i7;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i24, HEAP32[i36 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 i2 = (HEAP32[i18 >> 2] | 0) + 1 + (HEAP32[i17 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
 i3 = HEAP32[i22 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = HEAP32[i23 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i4 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i4;
 HEAP32[(HEAP32[i24 >> 2] | 0) + (i3 << 2) >> 2] = i2;
 if (!(HEAP32[i18 >> 2] | 0)) i2 = 0; else {
  i11 = i24 + 4 | 0;
  i12 = i16 + 11 | 0;
  i13 = i16 + 12 | 0;
  i14 = i15 + 4 | 0;
  i10 = 0;
  do {
   i8 = HEAP32[(HEAP32[i31 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i7 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i9 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i23 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i4;
   HEAP32[(HEAP32[i24 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   i5 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0) | 0;
   i6 = HEAP32[i22 >> 2] | 0;
   i2 = i6 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i2 >>> 0 > i4 >>> 0) {
    i1 = i3 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i4 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = i4;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i2;
   i1 = HEAP32[i24 >> 2] | 0;
   HEAP32[i1 + (i6 << 2) >> 2] = i5;
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i6 >>> 0 > i4 >>> 0) {
    i2 = i3 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = i1;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i6;
   HEAP32[i1 + (i5 << 2) >> 2] = i7;
   i2 = __Z21GetLoadedObjectReasonP6Object(i8) | 0;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i23 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i4;
   HEAP32[(HEAP32[i24 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   if (((HEAP32[i8 + 8 >> 2] | 0) >>> 21 | 0) == (HEAP32[gb + 27592 + 24 >> 2] | 0)) {
    __ZN13MonoBehaviour22GetScriptFullClassNameEv(i16, i8);
    __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16);
    if ((HEAP8[i12 >> 0] | 0) < 0) {
     i9 = HEAP32[i16 >> 2] | 0;
     i7 = HEAP32[i13 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i14 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i9, i15);
    }
   } else __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, i9);
   __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, __ZNK6Object12GetClassNameEv(i8) | 0);
   i10 = i10 + 1 | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } while (i10 >>> 0 < i2 >>> 0);
 }
 L67 : do if (HEAP32[i17 >> 2] | 0) {
  i11 = i24 + 4 | 0;
  i1 = 0;
  while (1) {
   i10 = HEAP32[(HEAP32[i33 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i9 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i2 + i1 << 2) >> 2] | 0;
   i6 = HEAP32[i22 >> 2] | 0;
   i3 = i6 + 1 | 0;
   i4 = HEAP32[i23 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i2 = i4 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i16 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = i16;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i3;
   i5 = HEAP32[i24 >> 2] | 0;
   HEAP32[i5 + (i6 << 2) >> 2] = 0;
   i6 = HEAP32[i22 >> 2] | 0;
   i7 = i6 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i7 >>> 0 > i4 >>> 0) {
    i2 = i3 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i2;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i8;
     i2 = i8;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = i8;
     i2 = i8;
     break;
    } else {
     i2 = i5;
     i8 = i5;
    }
   } else {
    i2 = i5;
    i8 = i5;
   } while (0);
   HEAP32[i22 >> 2] = i7;
   HEAP32[i2 + (i6 << 2) >> 2] = 0;
   i6 = HEAP32[i22 >> 2] | 0;
   i7 = i6 + 1 | 0;
   i4 = HEAP32[i23 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i7 >>> 0 > i5 >>> 0) {
    i3 = i4 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i23 >> 2] = i3;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i3 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i8;
     i2 = i8;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i3;
     HEAP32[i24 >> 2] = i8;
     i2 = i8;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i7;
   HEAP32[i2 + (i6 << 2) >> 2] = i9;
   i6 = HEAP32[i22 >> 2] | 0;
   i7 = i6 + 1 | 0;
   i4 = HEAP32[i23 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i7 >>> 0 > i5 >>> 0) {
    i3 = i4 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i23 >> 2] = i3;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i3 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i2;
     break;
    } else {
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i2 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i3;
     HEAP32[i24 >> 2] = i2;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i7;
   HEAP32[i2 + (i6 << 2) >> 2] = 10;
   __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, i10);
   __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, gb + 1576256 | 0);
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i17 >> 2] | 0) >>> 0) break L67;
   i2 = HEAP32[i18 >> 2] | 0;
  }
 } while (0);
 if (HEAP32[i19 >> 2] | 0) {
  i10 = i24 + 4 | 0;
  i9 = 0;
  do {
   i8 = HEAP32[i37 >> 2] | 0;
   i11 = HEAP32[i8 + (i9 * 12 | 0) >> 2] | 0;
   i12 = HEAP32[i8 + (i9 * 12 | 0) + 4 >> 2] | 0;
   i8 = HEAP32[i8 + (i9 * 12 | 0) + 8 >> 2] | 0;
   i5 = HEAP32[i22 >> 2] | 0;
   i2 = i5 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i2 >>> 0 > i4 >>> 0) {
    i1 = i3 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i18 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = i18;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i2;
   i4 = HEAP32[i24 >> 2] | 0;
   HEAP32[i4 + (i5 << 2) >> 2] = 0;
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i2 = HEAP32[i23 >> 2] | 0;
   i3 = i2 & 2147483647;
   do if (i6 >>> 0 > i3 >>> 0) {
    i1 = i2 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
     HEAP32[i23 >> 2] = i1;
     i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i7;
     i1 = i7;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i1;
     HEAP32[i24 >> 2] = i7;
     i1 = i7;
     break;
    } else {
     i1 = i4;
     i7 = i4;
    }
   } else {
    i1 = i4;
    i7 = i4;
   } while (0);
   HEAP32[i22 >> 2] = i6;
   HEAP32[i1 + (i5 << 2) >> 2] = i8;
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i6 >>> 0 > i4 >>> 0) {
    i2 = i3 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i2;
     i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i7;
     i1 = i7;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = i7;
     i1 = i7;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i6;
   HEAP32[i1 + (i5 << 2) >> 2] = 0;
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i6 >>> 0 > i4 >>> 0) {
    i2 = i3 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i23 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i24 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i24 >> 2] = i1;
     break;
    }
   } while (0);
   HEAP32[i22 >> 2] = i6;
   HEAP32[i1 + (i5 << 2) >> 2] = 10;
   __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, i12);
   __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, i11);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0);
 }
 i8 = (__ZN10systeminfo19GetExecutableSizeMBEv() | 0) << 20;
 i5 = HEAP32[i22 >> 2] | 0;
 i2 = i5 + 1 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i19 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i19;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i2;
 i4 = HEAP32[i24 >> 2] | 0;
 HEAP32[i4 + (i5 << 2) >> 2] = 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i24 >> 2] = i7;
   i1 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i7;
   i1 = i7;
   break;
  } else {
   i1 = i4;
   i7 = i4;
  }
 } else {
  i1 = i4;
  i7 = i4;
 } while (0);
 HEAP32[i22 >> 2] = i6;
 HEAP32[i1 + (i5 << 2) >> 2] = i8;
 i5 = HEAP32[i22 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i6 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i23 >> 2] = i2;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i24 >> 2] = i7;
   i1 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i2;
   HEAP32[i24 >> 2] = i7;
   i1 = i7;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i6;
 HEAP32[i1 + (i5 << 2) >> 2] = 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i6 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i23 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i24 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i2;
   HEAP32[i24 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i6;
 HEAP32[i1 + (i5 << 2) >> 2] = 10;
 __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, gb + 1576256 | 0);
 __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i24, gb + 462277 | 0);
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i3 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i19 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] << 2 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = i19;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i3;
 HEAP32[(HEAP32[i24 >> 2] | 0) + (i2 << 2) >> 2] = -1347440721;
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i21);
  HEAP32[i37 >> 2] = 0;
 }
 if ((HEAP32[i32 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i34);
  HEAP32[i36 >> 2] = 0;
 }
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i30);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i27 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i28);
  HEAP32[i33 >> 2] = 0;
 }
 if ((HEAP32[i25 >> 2] | 0) <= -1) {
  STACKTOP = i38;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i26);
 HEAP32[i31 >> 2] = 0;
 STACKTOP = i38;
 return;
}

function _UNITY_FT_Stroker_CubicTo(i60, i2, i3, i70) {
 i60 = i60 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i70 = i70 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i71 = 0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i71 + 336 | 0;
 i64 = i71 + 320 | 0;
 i65 = i71 + 24 | 0;
 i66 = i71 + 16 | 0;
 i67 = i71 + 8 | 0;
 i68 = i71 + 328 | 0;
 i61 = i71;
 if (!((i60 | 0) != 0 & (i2 | 0) != 0 & (i3 | 0) != 0 & (i70 | 0) != 0)) {
  i70 = 6;
  STACKTOP = i71;
  return i70 | 0;
 }
 i69 = i60 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i62 = i60 + 12 | 0;
 if (((HEAP32[i69 >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (((HEAP32[i62 >> 2] | 0) + 1 - i4 | 0) >>> 0 < 3) {
   i5 = HEAP32[i3 >> 2] | 0;
   if ((i1 + 1 - i5 | 0) >>> 0 < 3) {
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i4 + 1 - i1 | 0) >>> 0 < 3) if ((i5 + 1 - (HEAP32[i70 >> 2] | 0) | 0) >>> 0 < 3) if ((i1 + 1 - (HEAP32[i70 + 4 >> 2] | 0) | 0) >>> 0 < 3) {
     i67 = i70;
     i68 = HEAP32[i67 + 4 >> 2] | 0;
     i70 = i69;
     HEAP32[i70 >> 2] = HEAP32[i67 >> 2];
     HEAP32[i70 + 4 >> 2] = i68;
     i70 = 0;
     STACKTOP = i71;
     return i70 | 0;
    }
   }
  }
 }
 i53 = i70;
 i54 = HEAP32[i53 + 4 >> 2] | 0;
 i55 = i65;
 HEAP32[i55 >> 2] = HEAP32[i53 >> 2];
 HEAP32[i55 + 4 >> 2] = i54;
 i55 = i3;
 i54 = HEAP32[i55 + 4 >> 2] | 0;
 i53 = i65 + 8 | 0;
 HEAP32[i53 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i53 + 4 >> 2] = i54;
 i53 = i2;
 i54 = HEAP32[i53 + 4 >> 2] | 0;
 i55 = i65 + 16 | 0;
 HEAP32[i55 >> 2] = HEAP32[i53 >> 2];
 HEAP32[i55 + 4 >> 2] = i54;
 i55 = i69;
 i54 = HEAP32[i55 + 4 >> 2] | 0;
 i53 = i65 + 24 | 0;
 HEAP32[i53 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i53 + 4 >> 2] = i54;
 i53 = i60 + 20 | 0;
 i54 = i60 + 4 | 0;
 i55 = i60 + 48 | 0;
 i56 = i60 + 52 | 0;
 i57 = i60 + 60 | 0;
 i58 = i60 + 40 | 0;
 i59 = i60 + 64 | 0;
 i32 = i64 + 4 | 0;
 i33 = i66 + 4 | 0;
 i34 = i67 + 4 | 0;
 i35 = i68 + 4 | 0;
 i36 = i61 + 4 | 0;
 i37 = i60 + 8 | 0;
 i38 = i64 + 4 | 0;
 i39 = i60 + 84 | 0;
 i40 = i60 + 64 | 0;
 i41 = i60 + 72 | 0;
 i31 = i60 + 76 | 0;
 i42 = i60 + 80 | 0;
 i43 = i60 + 68 | 0;
 i44 = i60 + 88 | 0;
 i45 = i60 + 116 | 0;
 i46 = i60 + 96 | 0;
 i47 = i60 + 104 | 0;
 i30 = i60 + 108 | 0;
 i48 = i60 + 112 | 0;
 i49 = i60 + 100 | 0;
 i50 = i60 + 120 | 0;
 i51 = i60 + 24 | 0;
 i52 = i60 + 36 | 0;
 i1 = 0;
 i3 = 0;
 i2 = i65;
 i20 = 1;
 L13 : while (1) {
  while (1) {
   i12 = HEAP32[i60 >> 2] | 0;
   if ((i3 | 0) >= 32) {
    i28 = i12;
    i11 = i12;
    i10 = i12;
    break;
   }
   i13 = i2 + 16 | 0;
   i6 = HEAP32[i13 >> 2] | 0;
   i14 = i2 + 24 | 0;
   i4 = i6 - (HEAP32[i14 >> 2] | 0) | 0;
   i15 = i2 + 20 | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   i16 = i2 + 28 | 0;
   i5 = i7 - (HEAP32[i16 >> 2] | 0) | 0;
   i17 = i2 + 8 | 0;
   i9 = HEAP32[i17 >> 2] | 0;
   i6 = i9 - i6 | 0;
   i18 = i2 + 12 | 0;
   i10 = HEAP32[i18 >> 2] | 0;
   i7 = i10 - i7 | 0;
   i9 = (HEAP32[i2 >> 2] | 0) - i9 | 0;
   i19 = i65 + (i3 << 3) + 4 | 0;
   i10 = (HEAP32[i19 >> 2] | 0) - i10 | 0;
   i8 = (i6 + 1 | 0) >>> 0 < 3 & (i7 + 1 | 0) >>> 0 < 3;
   i11 = (i9 + 1 | 0) >>> 0 < 3 & (i10 + 1 | 0) >>> 0 < 3;
   do if ((i4 + 1 | 0) >>> 0 < 3 & (i5 + 1 | 0) >>> 0 < 3) if (i8) {
    if (i11) {
     i6 = i12;
     i5 = i12;
     i4 = i12;
     break;
    }
    i4 = _UNITY_FT_Atan2(i9, i10) | 0;
    i6 = i4;
    i5 = i4;
    break;
   } else {
    i4 = _UNITY_FT_Atan2(i6, i7) | 0;
    if (i11) {
     i6 = i4;
     i5 = i4;
     break;
    }
    i6 = _UNITY_FT_Atan2(i9, i10) | 0;
    i5 = i4;
    break;
   } else {
    i4 = _UNITY_FT_Atan2(i4, i5) | 0;
    if (i8) {
     if (i11) {
      i6 = i4;
      i5 = i4;
      break;
     }
     i5 = _UNITY_FT_Atan2(i9, i10) | 0;
     i6 = i5;
     i5 = ((_UNITY_FT_Angle_Diff(i4, i5) | 0) / 2 | 0) + i4 | 0;
     break;
    } else {
     i5 = _UNITY_FT_Atan2(i6, i7) | 0;
     if (i11) {
      i6 = i5;
      break;
     }
     i6 = _UNITY_FT_Atan2(i9, i10) | 0;
     break;
    }
   } while (0);
   i27 = _UNITY_FT_Angle_Diff(i4, i5) | 0;
   i28 = _UNITY_FT_Angle_Diff(i5, i6) | 0;
   if ((((i27 | 0) > -1 ? i27 : 0 - i27 | 0) | 0) < 1474560 ? (((i28 | 0) > -1 ? i28 : 0 - i28 | 0) | 0) < 1474560 : 0) {
    i28 = i6;
    i11 = i5;
    i10 = i4;
    break;
   }
   if (HEAP8[i53 >> 0] | 0) HEAP32[i60 >> 2] = i4;
   i25 = HEAP32[i14 >> 2] | 0;
   HEAP32[i2 + 48 >> 2] = i25;
   i26 = HEAP32[i17 >> 2] | 0;
   i27 = HEAP32[i13 >> 2] | 0;
   i28 = ((HEAP32[i2 >> 2] | 0) + i26 | 0) / 2 | 0;
   HEAP32[i17 >> 2] = i28;
   i25 = (i27 + i25 | 0) / 2 | 0;
   HEAP32[i2 + 40 >> 2] = i25;
   i26 = (i27 + i26 | 0) / 2 | 0;
   i28 = (i28 + i26 | 0) / 2 | 0;
   HEAP32[i13 >> 2] = i28;
   i26 = (i25 + i26 | 0) / 2 | 0;
   HEAP32[i2 + 32 >> 2] = i26;
   HEAP32[i14 >> 2] = (i28 + i26 | 0) / 2 | 0;
   i26 = HEAP32[i16 >> 2] | 0;
   HEAP32[i2 + 52 >> 2] = i26;
   i28 = HEAP32[i18 >> 2] | 0;
   i25 = HEAP32[i15 >> 2] | 0;
   i27 = ((HEAP32[i19 >> 2] | 0) + i28 | 0) / 2 | 0;
   HEAP32[i18 >> 2] = i27;
   i26 = (i25 + i26 | 0) / 2 | 0;
   HEAP32[i2 + 44 >> 2] = i26;
   i28 = (i25 + i28 | 0) / 2 | 0;
   i27 = (i27 + i28 | 0) / 2 | 0;
   HEAP32[i15 >> 2] = i27;
   i28 = (i26 + i28 | 0) / 2 | 0;
   HEAP32[i2 + 36 >> 2] = i28;
   HEAP32[i16 >> 2] = (i27 + i28 | 0) / 2 | 0;
   i2 = i3 + 3 | 0;
   if ((i2 | 0) > -1) {
    i3 = i2;
    i2 = i65 + (i2 << 3) | 0;
   } else {
    i29 = 139;
    break L13;
   }
  }
  do if (!(i20 << 24 >> 24)) {
   i29 = _UNITY_FT_Angle_Diff(HEAP32[i60 >> 2] | 0, i10) | 0;
   if ((((i29 | 0) > -1 ? i29 : 0 - i29 | 0) | 0) > 368640) {
    i27 = i2 + 24 | 0;
    i29 = HEAP32[i27 + 4 >> 2] | 0;
    i1 = i69;
    HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i1 + 4 >> 2] = i29;
    HEAP32[i54 >> 2] = i10;
    HEAP32[i55 >> 2] = 0;
    i1 = _UNITY_FT_Angle_Diff(HEAP32[i60 >> 2] | 0, i10) | 0;
    if (!i1) i1 = 0; else {
     i4 = i1 >>> 31;
     i1 = _ft_stroker_inside(i60, i4, 0) | 0;
     if (!i1) i1 = _ft_stroker_outside(i60, i4 ^ 1, 0) | 0;
    }
    HEAP32[i55 >> 2] = HEAP32[i56 >> 2];
    i29 = 74;
   } else i29 = 74;
  } else {
   if (!(HEAP8[i53 >> 0] | 0)) {
    HEAP32[i54 >> 2] = i10;
    i1 = _UNITY_FT_Angle_Diff(HEAP32[i60 >> 2] | 0, i10) | 0;
    if (!i1) break;
    i4 = i1 >>> 31;
    i1 = _ft_stroker_inside(i60, i4, 0) | 0;
    if (i1 | 0) {
     i29 = 140;
     break L13;
    }
    i1 = _ft_stroker_outside(i60, i4 ^ 1, 0) | 0;
    i29 = 74;
    break;
   }
   _UNITY_FT_Vector_From_Polar(i64, HEAP32[i57 >> 2] | 0, i10 + 5898240 | 0);
   i8 = (HEAP32[i64 >> 2] | 0) + (HEAP32[i37 >> 2] | 0) | 0;
   i9 = (HEAP32[i38 >> 2] | 0) + (HEAP32[i62 >> 2] | 0) | 0;
   i1 = HEAP32[i39 >> 2] | 0;
   if ((i1 | 0) > -1) {
    i4 = HEAP32[i40 >> 2] | 0;
    if (i4 >>> 0 > (i1 + 1 | 0) >>> 0) {
     i26 = i4 + -1 | 0;
     HEAP32[i40 >> 2] = i26;
     i29 = HEAP32[i41 >> 2] | 0;
     i26 = i29 + (i26 << 3) | 0;
     i27 = HEAP32[i26 + 4 >> 2] | 0;
     i29 = i29 + (i1 << 3) | 0;
     HEAP32[i29 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i29 + 4 >> 2] = i27;
     i29 = (HEAP32[i31 >> 2] | 0) + i1 | 0;
     HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] | 4;
     i29 = (HEAP32[i31 >> 2] | 0) + (i4 + -2) | 0;
     HEAP8[i29 >> 0] = HEAPU8[i29 >> 0] | 8;
    } else HEAP32[i40 >> 2] = i1;
    HEAP32[i39 >> 2] = -1;
    HEAP8[i42 >> 0] = 0;
   }
   i5 = HEAP32[i40 >> 2] | 0;
   HEAP32[i39 >> 2] = i5;
   HEAP8[i42 >> 0] = 0;
   if (!i5) i29 = 37; else {
    i1 = i5 + -1 | 0;
    i4 = HEAP32[i41 >> 2] | 0;
    if ((1 - i8 + (HEAP32[i4 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i9 + (HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) i29 = 46; else i29 = 37; else i29 = 37;
   }
   L60 : do if ((i29 | 0) == 37) {
    i29 = 0;
    i6 = HEAP32[i43 >> 2] | 0;
    i1 = i5 + 1 | 0;
    HEAP32[i63 >> 2] = 0;
    do if (i1 >>> 0 > i6 >>> 0) {
     i4 = HEAP32[i44 >> 2] | 0;
     i7 = i6;
     do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i1 >>> 0);
     HEAP32[i41 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i6, i7, HEAP32[i41 >> 2] | 0, i63) | 0;
     i1 = HEAP32[i63 >> 2] | 0;
     if (!i1) {
      i5 = _UNITY_ft_mem_realloc(i4, 1, i6, i7, HEAP32[i31 >> 2] | 0, i63) | 0;
      HEAP32[i31 >> 2] = i5;
      i1 = HEAP32[i63 >> 2] | 0;
      if (!i1) {
       HEAP32[i43 >> 2] = i7;
       i4 = HEAP32[i40 >> 2] | 0;
       i1 = i5;
       break;
      }
     }
     HEAP8[i42 >> 0] = 0;
     break L60;
    } else {
     i4 = i5;
     i1 = HEAP32[i31 >> 2] | 0;
    } while (0);
    i29 = (HEAP32[i41 >> 2] | 0) + (i4 << 3) | 0;
    HEAP32[i29 >> 2] = i8;
    HEAP32[i29 + 4 >> 2] = i9;
    HEAP8[i1 + i4 >> 0] = 1;
    HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + 1;
    HEAP8[i42 >> 0] = 0;
    i29 = 46;
   } while (0);
   if ((i29 | 0) == 46) {
    i29 = 0;
    i8 = (HEAP32[i37 >> 2] | 0) - (HEAP32[i64 >> 2] | 0) | 0;
    i9 = (HEAP32[i62 >> 2] | 0) - (HEAP32[i38 >> 2] | 0) | 0;
    i1 = HEAP32[i45 >> 2] | 0;
    if ((i1 | 0) > -1) {
     i4 = HEAP32[i46 >> 2] | 0;
     if (i4 >>> 0 > (i1 + 1 | 0) >>> 0) {
      i25 = i4 + -1 | 0;
      HEAP32[i46 >> 2] = i25;
      i27 = HEAP32[i47 >> 2] | 0;
      i25 = i27 + (i25 << 3) | 0;
      i26 = HEAP32[i25 + 4 >> 2] | 0;
      i27 = i27 + (i1 << 3) | 0;
      HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i27 + 4 >> 2] = i26;
      i27 = (HEAP32[i30 >> 2] | 0) + i1 | 0;
      HEAP8[i27 >> 0] = HEAPU8[i27 >> 0] | 4;
      i27 = (HEAP32[i30 >> 2] | 0) + (i4 + -2) | 0;
      HEAP8[i27 >> 0] = HEAPU8[i27 >> 0] | 8;
     } else HEAP32[i46 >> 2] = i1;
     HEAP32[i45 >> 2] = -1;
     HEAP8[i48 >> 0] = 0;
    }
    i5 = HEAP32[i46 >> 2] | 0;
    HEAP32[i45 >> 2] = i5;
    HEAP8[i48 >> 0] = 0;
    if (!i5) i29 = 54; else {
     i1 = i5 + -1 | 0;
     i4 = HEAP32[i47 >> 2] | 0;
     if ((1 - i8 + (HEAP32[i4 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i9 + (HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) i1 = 0; else i29 = 54; else i29 = 54;
    }
    if ((i29 | 0) == 54) {
     i29 = 0;
     i6 = HEAP32[i49 >> 2] | 0;
     i1 = i5 + 1 | 0;
     HEAP32[i63 >> 2] = 0;
     do if (i1 >>> 0 > i6 >>> 0) {
      i4 = HEAP32[i50 >> 2] | 0;
      i7 = i6;
      do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i1 >>> 0);
      HEAP32[i47 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i6, i7, HEAP32[i47 >> 2] | 0, i63) | 0;
      i1 = HEAP32[i63 >> 2] | 0;
      if (!i1) {
       i5 = _UNITY_ft_mem_realloc(i4, 1, i6, i7, HEAP32[i30 >> 2] | 0, i63) | 0;
       HEAP32[i30 >> 2] = i5;
       i1 = HEAP32[i63 >> 2] | 0;
       if (!i1) {
        HEAP32[i49 >> 2] = i7;
        i4 = HEAP32[i46 >> 2] | 0;
        i1 = i5;
        i29 = 62;
        break;
       }
      }
     } else {
      i4 = i5;
      i1 = HEAP32[i30 >> 2] | 0;
      i29 = 62;
     } while (0);
     if ((i29 | 0) == 62) {
      i29 = (HEAP32[i47 >> 2] | 0) + (i4 << 3) | 0;
      HEAP32[i29 >> 2] = i8;
      HEAP32[i29 + 4 >> 2] = i9;
      HEAP8[i1 + i4 >> 0] = 1;
      HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 1;
      i1 = 0;
     }
     HEAP8[i48 >> 0] = 0;
    }
    HEAP32[i51 >> 2] = i10;
    HEAP8[i53 >> 0] = 0;
    HEAP32[i52 >> 2] = 0;
   }
   i29 = 74;
  } while (0);
  if ((i29 | 0) == 74) if (i1 | 0) {
   i29 = 140;
   break;
  }
  i20 = (_UNITY_FT_Angle_Diff(i10, i11) | 0) / 2 | 0;
  i21 = (_UNITY_FT_Angle_Diff(i11, i28) | 0) / 2 | 0;
  i27 = ((_UNITY_FT_Angle_Diff(i10, i11) | 0) / 2 | 0) + i10 | 0;
  i19 = ((_UNITY_FT_Angle_Diff(i11, i28) | 0) / 2 | 0) + i11 | 0;
  i29 = HEAP32[i57 >> 2] | 0;
  i20 = _UNITY_FT_DivFix(i29, _UNITY_FT_Cos(i20) | 0) | 0;
  i29 = HEAP32[i57 >> 2] | 0;
  i21 = _UNITY_FT_DivFix(i29, _UNITY_FT_Cos(i21) | 0) | 0;
  if (!(HEAP8[i58 >> 0] | 0)) {
   i14 = 0;
   i16 = i65 + (i3 << 3) + 4 | 0;
   i17 = i2 + 24 | 0;
   i18 = i2 + 28 | 0;
  } else {
   i17 = i2 + 24 | 0;
   i16 = i65 + (i3 << 3) + 4 | 0;
   i18 = i2 + 28 | 0;
   i14 = _UNITY_FT_Atan2((HEAP32[i2 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0, (HEAP32[i16 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) | 0;
  }
  i22 = i2 + 16 | 0;
  i23 = i2 + 20 | 0;
  i24 = i2 + 8 | 0;
  i25 = i2 + 12 | 0;
  i26 = i59;
  i15 = 0;
  L109 : while (1) {
   i1 = (Math_imul(i15, -11796480) | 0) + 5898240 | 0;
   _UNITY_FT_Vector_From_Polar(i64, i20, i27 + i1 | 0);
   HEAP32[i64 >> 2] = (HEAP32[i64 >> 2] | 0) + (HEAP32[i22 >> 2] | 0);
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + (HEAP32[i23 >> 2] | 0);
   _UNITY_FT_Vector_From_Polar(i66, i21, i19 + i1 | 0);
   HEAP32[i66 >> 2] = (HEAP32[i66 >> 2] | 0) + (HEAP32[i24 >> 2] | 0);
   HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + (HEAP32[i25 >> 2] | 0);
   _UNITY_FT_Vector_From_Polar(i67, HEAP32[i57 >> 2] | 0, i1 + i28 | 0);
   i1 = (HEAP32[i67 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) | 0;
   HEAP32[i67 >> 2] = i1;
   i4 = (HEAP32[i34 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) | 0;
   HEAP32[i34 >> 2] = i4;
   do if (!(HEAP8[i58 >> 0] | 0)) i29 = 126; else {
    i12 = i26 + 8 | 0;
    i11 = (HEAP32[i12 >> 2] | 0) + ((HEAP32[i26 >> 2] | 0) + -1 << 3) | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i1 = _UNITY_FT_Atan2(i1 - i10 | 0, i4 - i11 | 0) | 0;
    i29 = _UNITY_FT_Angle_Diff(i14, i1) | 0;
    if ((((i29 | 0) > -1 ? i29 : 0 - i29 | 0) | 0) > 5898240) {
     i4 = _UNITY_FT_Atan2((HEAP32[i17 >> 2] | 0) - i10 | 0, (HEAP32[i18 >> 2] | 0) - i11 | 0) | 0;
     i5 = _UNITY_FT_Atan2((HEAP32[i2 >> 2] | 0) - (HEAP32[i67 >> 2] | 0) | 0, (HEAP32[i16 >> 2] | 0) - (HEAP32[i34 >> 2] | 0) | 0) | 0;
     HEAP32[i68 >> 2] = (HEAP32[i67 >> 2] | 0) - i10;
     HEAP32[i35 >> 2] = (HEAP32[i34 >> 2] | 0) - i11;
     i29 = _UNITY_FT_Vector_Length(i68) | 0;
     i13 = _UNITY_FT_Sin(i1 - i5 | 0) | 0;
     i5 = _UNITY_FT_Sin(i4 - i5 | 0) | 0;
     _UNITY_FT_Vector_From_Polar(i61, _UNITY_FT_MulDiv(i29, (i13 | 0) > -1 ? i13 : 0 - i13 | 0, (i5 | 0) > -1 ? i5 : 0 - i5 | 0) | 0, i4);
     i4 = (HEAP32[i61 >> 2] | 0) + i10 | 0;
     HEAP32[i61 >> 2] = i4;
     i5 = (HEAP32[i36 >> 2] | 0) + i11 | 0;
     HEAP32[i36 >> 2] = i5;
     i13 = i26 + 16 | 0;
     HEAP8[i13 >> 0] = 0;
     i1 = HEAP32[i26 >> 2] | 0;
     if (!i1) i29 = 84; else {
      i6 = i1 + -1 | 0;
      i7 = HEAP32[i12 >> 2] | 0;
      if (((HEAP32[i7 + (i6 << 3) >> 2] | 0) + 1 - i4 | 0) >>> 0 < 3) if (((HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) i29 = 93; else i29 = 84; else i29 = 84;
     }
     if ((i29 | 0) == 84) {
      i8 = i26 + 4 | 0;
      i6 = HEAP32[i8 >> 2] | 0;
      i4 = i1 + 1 | 0;
      HEAP32[i63 >> 2] = 0;
      if (i4 >>> 0 > i6 >>> 0) {
       i5 = HEAP32[i26 + 24 >> 2] | 0;
       i7 = i6;
       do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i4 >>> 0);
       HEAP32[i12 >> 2] = _UNITY_ft_mem_realloc(i5, 8, i6, i7, HEAP32[i12 >> 2] | 0, i63) | 0;
       i1 = HEAP32[i63 >> 2] | 0;
       if (i1 | 0) {
        i29 = 91;
        break L109;
       }
       i1 = i26 + 12 | 0;
       i4 = _UNITY_ft_mem_realloc(i5, 1, i6, i7, HEAP32[i1 >> 2] | 0, i63) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i63 >> 2] | 0;
       if (i1 | 0) {
        i29 = 91;
        break L109;
       }
       HEAP32[i8 >> 2] = i7;
       i1 = HEAP32[i26 >> 2] | 0;
      } else i4 = HEAP32[i26 + 12 >> 2] | 0;
      i8 = i61;
      i9 = HEAP32[i8 + 4 >> 2] | 0;
      i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 3) | 0;
      HEAP32[i29 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i29 + 4 >> 2] = i9;
      HEAP8[i4 + i1 >> 0] = 1;
      i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
      HEAP32[i26 >> 2] = i1;
      HEAP8[i13 >> 0] = 0;
      if (!i1) {
       i1 = 0;
       i29 = 95;
      } else i29 = 93;
     }
     if ((i29 | 0) == 93) {
      i29 = 0;
      i4 = i1 + -1 | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - (HEAP32[i67 >> 2] | 0) | 0) >>> 0 < 3) {
       if (((HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) + 1 - (HEAP32[i34 >> 2] | 0) | 0) >>> 0 >= 3) i29 = 95;
      } else i29 = 95;
     }
     if ((i29 | 0) == 95) {
      i29 = 0;
      i8 = i26 + 4 | 0;
      i6 = HEAP32[i8 >> 2] | 0;
      i4 = i1 + 1 | 0;
      HEAP32[i63 >> 2] = 0;
      if (i4 >>> 0 > i6 >>> 0) {
       i5 = HEAP32[i26 + 24 >> 2] | 0;
       i7 = i6;
       do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i4 >>> 0);
       HEAP32[i12 >> 2] = _UNITY_ft_mem_realloc(i5, 8, i6, i7, HEAP32[i12 >> 2] | 0, i63) | 0;
       i1 = HEAP32[i63 >> 2] | 0;
       if (i1 | 0) {
        i29 = 103;
        break L109;
       }
       i1 = i26 + 12 | 0;
       i4 = _UNITY_ft_mem_realloc(i5, 1, i6, i7, HEAP32[i1 >> 2] | 0, i63) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i63 >> 2] | 0;
       if (i1 | 0) {
        i29 = 103;
        break L109;
       }
       HEAP32[i8 >> 2] = i7;
       i1 = HEAP32[i26 >> 2] | 0;
      } else i4 = HEAP32[i26 + 12 >> 2] | 0;
      i7 = i67;
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      i9 = (HEAP32[i12 >> 2] | 0) + (i1 << 3) | 0;
      HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i9 + 4 >> 2] = i8;
      HEAP8[i4 + i1 >> 0] = 1;
      i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
      HEAP32[i26 >> 2] = i1;
      HEAP8[i13 >> 0] = 0;
     }
     i9 = i26 + 4 | 0;
     i7 = HEAP32[i9 >> 2] | 0;
     i4 = i1 + 3 | 0;
     HEAP32[i63 >> 2] = 0;
     if (i4 >>> 0 > i7 >>> 0) {
      i5 = HEAP32[i26 + 24 >> 2] | 0;
      i8 = i7;
      do i8 = i8 + 16 + (i8 >>> 1) | 0; while (i8 >>> 0 < i4 >>> 0);
      HEAP32[i12 >> 2] = _UNITY_ft_mem_realloc(i5, 8, i7, i8, HEAP32[i12 >> 2] | 0, i63) | 0;
      i1 = HEAP32[i63 >> 2] | 0;
      if (i1 | 0) {
       i29 = 111;
       break L109;
      }
      i6 = i26 + 12 | 0;
      i4 = _UNITY_ft_mem_realloc(i5, 1, i7, i8, HEAP32[i6 >> 2] | 0, i63) | 0;
      HEAP32[i6 >> 2] = i4;
      i1 = HEAP32[i63 >> 2] | 0;
      if (i1 | 0) {
       i29 = 111;
       break L109;
      }
      HEAP32[i9 >> 2] = i8;
      i7 = i6;
      i1 = HEAP32[i26 >> 2] | 0;
     } else {
      i4 = i26 + 12 | 0;
      i7 = i4;
      i4 = HEAP32[i4 >> 2] | 0;
     }
     i8 = (HEAP32[i12 >> 2] | 0) + (i1 << 3) | 0;
     i6 = i4 + i1 | 0;
     i4 = i66;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i1 = i8;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i1 + 4 >> 2] = i5;
     i1 = i64;
     i5 = HEAP32[i1 + 4 >> 2] | 0;
     i4 = i8 + 8 | 0;
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 + 4 >> 2] = i5;
     i4 = i8 + 16 | 0;
     HEAP32[i4 >> 2] = i10;
     HEAP32[i4 + 4 >> 2] = i11;
     HEAP8[i6 >> 0] = 2;
     HEAP8[i6 + 1 >> 0] = 2;
     HEAP8[i6 + 2 >> 0] = 1;
     i6 = HEAP32[i26 >> 2] | 0;
     i4 = i6 + 3 | 0;
     HEAP32[i26 >> 2] = i4;
     HEAP8[i13 >> 0] = 0;
     if (i4 | 0) {
      i1 = i6 + 2 | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      if (((HEAP32[i5 + (i1 << 3) >> 2] | 0) + 1 - (HEAP32[i67 >> 2] | 0) | 0) >>> 0 < 3) if (((HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0) + 1 - (HEAP32[i34 >> 2] | 0) | 0) >>> 0 < 3) break;
     }
     i5 = HEAP32[i9 >> 2] | 0;
     i1 = i6 + 4 | 0;
     HEAP32[i63 >> 2] = 0;
     if (i1 >>> 0 > i5 >>> 0) {
      i4 = HEAP32[i26 + 24 >> 2] | 0;
      i6 = i5;
      do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
      HEAP32[i12 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i5, i6, HEAP32[i12 >> 2] | 0, i63) | 0;
      i1 = HEAP32[i63 >> 2] | 0;
      if (i1 | 0) {
       i29 = 123;
       break L109;
      }
      i5 = _UNITY_ft_mem_realloc(i4, 1, i5, i6, HEAP32[i7 >> 2] | 0, i63) | 0;
      HEAP32[i7 >> 2] = i5;
      i1 = HEAP32[i63 >> 2] | 0;
      if (i1 | 0) {
       i29 = 123;
       break L109;
      }
      HEAP32[i9 >> 2] = i6;
      i4 = HEAP32[i26 >> 2] | 0;
      i1 = i5;
     } else i1 = HEAP32[i7 >> 2] | 0;
     i10 = i67;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = (HEAP32[i12 >> 2] | 0) + (i4 << 3) | 0;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     HEAP8[i1 + i4 >> 0] = 1;
     HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
     HEAP8[i13 >> 0] = 0;
    } else i29 = 126;
   } while (0);
   if ((i29 | 0) == 126) {
    i29 = 0;
    i8 = i26 + 4 | 0;
    i6 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i26 >> 2] | 0;
    i1 = i4 + 3 | 0;
    HEAP32[i63 >> 2] = 0;
    if (i1 >>> 0 > i6 >>> 0) {
     i4 = HEAP32[i26 + 24 >> 2] | 0;
     i7 = i6;
     do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i1 >>> 0);
     i5 = i26 + 8 | 0;
     HEAP32[i5 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i6, i7, HEAP32[i5 >> 2] | 0, i63) | 0;
     i1 = HEAP32[i63 >> 2] | 0;
     if (i1 | 0) {
      i29 = 134;
      break;
     }
     i1 = i26 + 12 | 0;
     i6 = _UNITY_ft_mem_realloc(i4, 1, i6, i7, HEAP32[i1 >> 2] | 0, i63) | 0;
     HEAP32[i1 >> 2] = i6;
     i1 = HEAP32[i63 >> 2] | 0;
     if (i1 | 0) {
      i29 = 134;
      break;
     }
     HEAP32[i8 >> 2] = i7;
     i4 = HEAP32[i26 >> 2] | 0;
     i1 = i6;
    } else {
     i5 = i26 + 8 | 0;
     i1 = HEAP32[i26 + 12 >> 2] | 0;
    }
    i12 = (HEAP32[i5 >> 2] | 0) + (i4 << 3) | 0;
    i13 = i1 + i4 | 0;
    i10 = i64;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i9 = i12;
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = i11;
    i9 = i66;
    i11 = HEAP32[i9 + 4 >> 2] | 0;
    i10 = i12 + 8 | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i67;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i12 + 16 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP8[i13 >> 0] = 2;
    HEAP8[i13 + 1 >> 0] = 2;
    HEAP8[i13 + 2 >> 0] = 1;
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 3;
    HEAP8[i26 + 16 >> 0] = 0;
   }
   i15 = i15 + 1 | 0;
   if ((i15 | 0) >= 2) {
    i2 = 0;
    i1 = 0;
    break;
   } else i26 = i26 + 32 | 0;
  }
  if ((i29 | 0) == 91) {
   HEAP8[i13 >> 0] = 0;
   i29 = 124;
  } else if ((i29 | 0) == 103) {
   HEAP8[i13 >> 0] = 0;
   i29 = 124;
  } else if ((i29 | 0) == 111) {
   HEAP8[i13 >> 0] = 0;
   i29 = 124;
  } else if ((i29 | 0) == 123) {
   i29 = 0;
   HEAP8[i13 >> 0] = 0;
   i2 = (i1 | 0) == 0 ? 7 : 2;
  } else if ((i29 | 0) == 134) {
   i29 = 0;
   HEAP8[i26 + 16 >> 0] = 0;
   i2 = 2;
  }
  if ((i29 | 0) == 124) {
   i29 = 0;
   i2 = 2;
  }
  switch (i2 & 7) {
  case 0:
   {
    HEAP32[i60 >> 2] = i28;
    i2 = i3 + -3 | 0;
    break;
   }
  case 3:
   {
    i2 = i3;
    break;
   }
  default:
   {
    i29 = 140;
    break L13;
   }
  }
  if ((i2 | 0) > -1) {
   i3 = i2;
   i2 = i65 + (i2 << 3) | 0;
   i20 = 0;
  } else {
   i29 = 139;
   break;
  }
 }
 if ((i29 | 0) == 139) {
  i67 = i70;
  i68 = HEAP32[i67 + 4 >> 2] | 0;
  i70 = i69;
  HEAP32[i70 >> 2] = HEAP32[i67 >> 2];
  HEAP32[i70 + 4 >> 2] = i68;
  i70 = i1;
  STACKTOP = i71;
  return i70 | 0;
 } else if ((i29 | 0) == 140) {
  STACKTOP = i71;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_LZ4_decompress_safe_usingDict(i25, i24, i3, i23, i1, i2) {
 i25 = i25 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i26 = 0;
 if (!i2) {
  i15 = i25 + i3 | 0;
  i16 = i24 + i23 | 0;
  i17 = i16 + -12 | 0;
  if (!i23) {
   if ((i3 | 0) == 1) i1 = (HEAP8[i25 >> 0] | 0) != 0; else i1 = 1;
   i26 = i1 << 31 >> 31;
   return i26 | 0;
  }
  i9 = i15 + -15 | 0;
  i10 = i15 + -8 | 0;
  i11 = i15 + -5 | 0;
  i12 = i16 + -5 | 0;
  i13 = i16 + -8 | 0;
  i14 = i13;
  i2 = i25;
  i3 = i24;
  L10 : while (1) {
   i1 = i2 + 1 | 0;
   i7 = HEAPU8[i2 >> 0] | 0;
   i2 = i7 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1 & i1 >>> 0 < i9 >>> 0);
    if ((i2 | 0) < 0) break;
   }
   i8 = i3 + i2 | 0;
   i4 = i1 + i2 | 0;
   if (i8 >>> 0 > i17 >>> 0 | i4 >>> 0 > i10 >>> 0) {
    i26 = 11;
    break;
   } else i2 = i3;
   while (1) {
    i22 = i1;
    i20 = i22;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i23 = i2;
    i21 = i23;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i22;
    HEAP8[i23 + 1 >> 0] = i22 >> 8;
    HEAP8[i23 + 2 >> 0] = i22 >> 16;
    HEAP8[i23 + 3 >> 0] = i22 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i3 = HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 >> 0];
   i5 = i3 & 65535;
   i6 = i8 + (0 - i3) | 0;
   i1 = i4 + 2 | 0;
   if (i6 >>> 0 < i24 >>> 0) break;
   i2 = i7 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i11 >>> 0) break L10;
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) break;
   }
   i7 = i8 + (i2 + 4) | 0;
   if ((i5 & 65535) < 8) {
    i23 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
    HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
    HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
    i3 = i6 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
    i22 = i8 + 4 | 0;
    i21 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i3 = i3 + (0 - i23) | 0;
   } else {
    i23 = i6;
    i21 = i23;
    i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
    i23 = i23 + 4 | 0;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i3 = i8;
    i22 = i3;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i23;
    HEAP8[i3 + 1 >> 0] = i23 >> 8;
    HEAP8[i3 + 2 >> 0] = i23 >> 16;
    HEAP8[i3 + 3 >> 0] = i23 >> 24;
    i3 = i6 + 8 | 0;
   }
   i2 = i8 + 8 | 0;
   if (i7 >>> 0 <= i17 >>> 0) while (1) {
    i22 = i3;
    i20 = i22;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i23 = i2;
    i21 = i23;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i22;
    HEAP8[i23 + 1 >> 0] = i22 >> 8;
    HEAP8[i23 + 2 >> 0] = i22 >> 16;
    HEAP8[i23 + 3 >> 0] = i22 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
     i2 = i1;
     i3 = i7;
     continue L10;
    }
   }
   if (i7 >>> 0 > i12 >>> 0) break;
   if (i2 >>> 0 < i13 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i22 = i5;
     i20 = i22;
     i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
     i22 = i22 + 4 | 0;
     i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
     i23 = i4;
     i21 = i23;
     HEAP8[i21 >> 0] = i20;
     HEAP8[i21 + 1 >> 0] = i20 >> 8;
     HEAP8[i21 + 2 >> 0] = i20 >> 16;
     HEAP8[i21 + 3 >> 0] = i20 >> 24;
     i23 = i23 + 4 | 0;
     HEAP8[i23 >> 0] = i22;
     HEAP8[i23 + 1 >> 0] = i22 >> 8;
     HEAP8[i23 + 2 >> 0] = i22 >> 16;
     HEAP8[i23 + 3 >> 0] = i22 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i13 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i14 - i2) | 0;
    i2 = i13;
   }
   if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i1;
    i3 = i7;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i7 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i2 = i1;
     i3 = i7;
     continue L10;
    }
   }
  }
  if ((i26 | 0) == 11) if (!(i8 >>> 0 > i16 >>> 0 | (i4 | 0) != (i15 | 0))) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   i26 = i8 - i24 | 0;
   return i26 | 0;
  }
  i26 = i25 + -1 - i1 | 0;
  return i26 | 0;
 }
 i19 = i1 + i2 | 0;
 if ((i19 | 0) != (i24 | 0)) {
  i20 = i25 + i3 | 0;
  i21 = i24 + i23 | 0;
  i22 = i24 + (0 - i2) | 0;
  i17 = i2 >>> 0 < 65536;
  i18 = i21 + -12 | 0;
  if (!i23) {
   if ((i3 | 0) == 1) i1 = (HEAP8[i25 >> 0] | 0) != 0; else i1 = 1;
   i26 = i1 << 31 >> 31;
   return i26 | 0;
  }
  i10 = i20 + -15 | 0;
  i11 = i20 + -8 | 0;
  i12 = i20 + -5 | 0;
  i13 = i21 + -5 | 0;
  i14 = i24;
  i15 = i21 + -8 | 0;
  i16 = i15;
  i5 = i25;
  i4 = i24;
  L59 : while (1) {
   i1 = i5 + 1 | 0;
   i8 = HEAPU8[i5 >> 0] | 0;
   i2 = i8 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1 & i1 >>> 0 < i10 >>> 0);
    if ((i2 | 0) < 0) break;
   }
   i9 = i4 + i2 | 0;
   i3 = i1 + i2 | 0;
   if (i9 >>> 0 > i18 >>> 0 | i3 >>> 0 > i11 >>> 0) {
    i26 = 100;
    break;
   } else i2 = i4;
   while (1) {
    i7 = i1;
    i5 = i7;
    i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
    i7 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i23 = i2;
    i6 = i23;
    HEAP8[i6 >> 0] = i5;
    HEAP8[i6 + 1 >> 0] = i5 >> 8;
    HEAP8[i6 + 2 >> 0] = i5 >> 16;
    HEAP8[i6 + 3 >> 0] = i5 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i7;
    HEAP8[i23 + 1 >> 0] = i7 >> 8;
    HEAP8[i23 + 2 >> 0] = i7 >> 16;
    HEAP8[i23 + 3 >> 0] = i7 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i5 = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 >> 0];
   i6 = i5 & 65535;
   i7 = i9 + (0 - i5) | 0;
   i1 = i3 + 2 | 0;
   if (i17 & i7 >>> 0 < i22 >>> 0) break;
   i2 = i8 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i12 >>> 0) break L59;
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) break;
   }
   i4 = i2 + 4 | 0;
   i8 = i9 + i4 | 0;
   if (i7 >>> 0 < i24 >>> 0) {
    if (i8 >>> 0 > i13 >>> 0) break;
    i3 = i14 - i7 | 0;
    i2 = i19 + (0 - i3) | 0;
    if (i4 >>> 0 <= i3 >>> 0) {
     _memcpy(i9 | 0, i2 | 0, i4 | 0) | 0;
     i5 = i1;
     i4 = i8;
     continue;
    }
    _memcpy(i9 | 0, i2 | 0, i3 | 0) | 0;
    i2 = i9 + i3 | 0;
    i3 = i4 - i3 | 0;
    if (i3 >>> 0 <= (i2 - i14 | 0) >>> 0) {
     _memcpy(i2 | 0, i24 | 0, i3 | 0) | 0;
     i5 = i1;
     i4 = i2 + i3 | 0;
     continue;
    }
    i5 = i2 + i3 | 0;
    if ((i3 | 0) > 0) i3 = i24; else {
     i5 = i1;
     i4 = i2;
     continue;
    }
    while (1) {
     i4 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     if (i4 >>> 0 < i5 >>> 0) {
      i3 = i3 + 1 | 0;
      i2 = i4;
     } else {
      i5 = i1;
      continue L59;
     }
    }
   }
   if ((i6 & 65535) < 8) {
    i3 = HEAP32[gb + 74112 + (i5 << 2) >> 2] | 0;
    HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
    HEAP8[i9 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
    HEAP8[i9 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
    HEAP8[i9 + 3 >> 0] = HEAP8[i7 + 3 >> 0] | 0;
    i23 = i7 + (HEAP32[gb + 74144 + (i5 << 2) >> 2] | 0) | 0;
    i7 = i9 + 4 | 0;
    i6 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i3 = i23 + (0 - i3) | 0;
   } else {
    i23 = i7;
    i5 = i23;
    i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
    i23 = i23 + 4 | 0;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i3 = i9;
    i6 = i3;
    HEAP8[i6 >> 0] = i5;
    HEAP8[i6 + 1 >> 0] = i5 >> 8;
    HEAP8[i6 + 2 >> 0] = i5 >> 16;
    HEAP8[i6 + 3 >> 0] = i5 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i23;
    HEAP8[i3 + 1 >> 0] = i23 >> 8;
    HEAP8[i3 + 2 >> 0] = i23 >> 16;
    HEAP8[i3 + 3 >> 0] = i23 >> 24;
    i3 = i7 + 8 | 0;
   }
   i2 = i9 + 8 | 0;
   if (i8 >>> 0 <= i18 >>> 0) while (1) {
    i9 = i3;
    i6 = i9;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i9 = i9 + 4 | 0;
    i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
    i23 = i2;
    i7 = i23;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i9;
    HEAP8[i23 + 1 >> 0] = i9 >> 8;
    HEAP8[i23 + 2 >> 0] = i9 >> 16;
    HEAP8[i23 + 3 >> 0] = i9 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i8 >>> 0) i3 = i3 + 8 | 0; else {
     i5 = i1;
     i4 = i8;
     continue L59;
    }
   }
   if (i8 >>> 0 > i13 >>> 0) break;
   if (i2 >>> 0 < i15 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i9 = i5;
     i6 = i9;
     i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
     i9 = i9 + 4 | 0;
     i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
     i23 = i4;
     i7 = i23;
     HEAP8[i7 >> 0] = i6;
     HEAP8[i7 + 1 >> 0] = i6 >> 8;
     HEAP8[i7 + 2 >> 0] = i6 >> 16;
     HEAP8[i7 + 3 >> 0] = i6 >> 24;
     i23 = i23 + 4 | 0;
     HEAP8[i23 >> 0] = i9;
     HEAP8[i23 + 1 >> 0] = i9 >> 8;
     HEAP8[i23 + 2 >> 0] = i9 >> 16;
     HEAP8[i23 + 3 >> 0] = i9 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i15 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i16 - i2) | 0;
    i2 = i15;
   }
   if (i2 >>> 0 >= i8 >>> 0) {
    i5 = i1;
    i4 = i8;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i8 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i5 = i1;
     i4 = i8;
     continue L59;
    }
   }
  }
  if ((i26 | 0) == 100) if (!(i9 >>> 0 > i21 >>> 0 | (i3 | 0) != (i20 | 0))) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i26 = i9 - i14 | 0;
   return i26 | 0;
  }
  i26 = i25 + -1 - i1 | 0;
  return i26 | 0;
 }
 if ((i2 | 0) > 65534) {
  i16 = i25 + i3 | 0;
  i1 = i24 + i23 | 0;
  i17 = i1 + -12 | 0;
  if (!i23) {
   if ((i3 | 0) == 1) i1 = (HEAP8[i25 >> 0] | 0) != 0; else i1 = 1;
   i26 = i1 << 31 >> 31;
   return i26 | 0;
  }
  i12 = i16 + -15 | 0;
  i13 = i16 + -8 | 0;
  i14 = i16 + -5 | 0;
  i15 = i1 + -5 | 0;
  i10 = i1 + -8 | 0;
  i11 = i10;
  i2 = i25;
  i3 = 0;
  L120 : while (1) {
   i4 = i24 + i3 | 0;
   i1 = i2 + 1 | 0;
   i8 = HEAPU8[i2 >> 0] | 0;
   i2 = i8 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i22 = i1;
     i1 = i1 + 1 | 0;
     i22 = HEAP8[i22 >> 0] | 0;
     i2 = (i22 & 255) + i2 | 0;
    } while (i22 << 24 >> 24 == -1 & i1 >>> 0 < i12 >>> 0);
    if ((i2 | 0) < 0) break;
   }
   i7 = i2 + i3 | 0;
   i9 = i24 + i7 | 0;
   i3 = i1 + i2 | 0;
   if (i9 >>> 0 > i17 >>> 0 | i3 >>> 0 > i13 >>> 0) {
    i26 = 42;
    break;
   } else i2 = i4;
   while (1) {
    i21 = i1;
    i19 = i21;
    i19 = HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24;
    i21 = i21 + 4 | 0;
    i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
    i22 = i2;
    i20 = i22;
    HEAP8[i20 >> 0] = i19;
    HEAP8[i20 + 1 >> 0] = i19 >> 8;
    HEAP8[i20 + 2 >> 0] = i19 >> 16;
    HEAP8[i20 + 3 >> 0] = i19 >> 24;
    i22 = i22 + 4 | 0;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i5 = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 >> 0];
   i6 = i5 & 65535;
   i22 = i7 - i5 | 0;
   i4 = i24 + i22 | 0;
   i1 = i3 + 2 | 0;
   if ((i22 | 0) < -65536) break;
   i2 = i8 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i14 >>> 0) break L120;
     i22 = i1;
     i1 = i1 + 1 | 0;
     i22 = HEAP8[i22 >> 0] | 0;
     i2 = (i22 & 255) + i2 | 0;
    } while (i22 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) break;
   }
   i8 = i7 + 4 + i2 | 0;
   i7 = i24 + i8 | 0;
   if ((i6 & 65535) < 8) {
    i3 = HEAP32[gb + 74112 + (i5 << 2) >> 2] | 0;
    HEAP8[i9 >> 0] = HEAP8[i4 >> 0] | 0;
    HEAP8[i9 + 1 >> 0] = HEAP8[i4 + 1 >> 0] | 0;
    HEAP8[i9 + 2 >> 0] = HEAP8[i4 + 2 >> 0] | 0;
    HEAP8[i9 + 3 >> 0] = HEAP8[i4 + 3 >> 0] | 0;
    i22 = i4 + (HEAP32[gb + 74144 + (i5 << 2) >> 2] | 0) | 0;
    i21 = i9 + 4 | 0;
    i20 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i3 = i22 + (0 - i3) | 0;
   } else {
    i22 = i4;
    i20 = i22;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i3 = i9;
    i21 = i3;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i22;
    HEAP8[i3 + 1 >> 0] = i22 >> 8;
    HEAP8[i3 + 2 >> 0] = i22 >> 16;
    HEAP8[i3 + 3 >> 0] = i22 >> 24;
    i3 = i4 + 8 | 0;
   }
   i2 = i9 + 8 | 0;
   if (i7 >>> 0 <= i17 >>> 0) while (1) {
    i21 = i3;
    i19 = i21;
    i19 = HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24;
    i21 = i21 + 4 | 0;
    i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
    i22 = i2;
    i20 = i22;
    HEAP8[i20 >> 0] = i19;
    HEAP8[i20 + 1 >> 0] = i19 >> 8;
    HEAP8[i20 + 2 >> 0] = i19 >> 16;
    HEAP8[i20 + 3 >> 0] = i19 >> 24;
    i22 = i22 + 4 | 0;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
     i2 = i1;
     i3 = i8;
     continue L120;
    }
   }
   if (i7 >>> 0 > i15 >>> 0) break;
   if (i2 >>> 0 < i10 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i21 = i5;
     i19 = i21;
     i19 = HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24;
     i21 = i21 + 4 | 0;
     i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
     i22 = i4;
     i20 = i22;
     HEAP8[i20 >> 0] = i19;
     HEAP8[i20 + 1 >> 0] = i19 >> 8;
     HEAP8[i20 + 2 >> 0] = i19 >> 16;
     HEAP8[i20 + 3 >> 0] = i19 >> 24;
     i22 = i22 + 4 | 0;
     HEAP8[i22 >> 0] = i21;
     HEAP8[i22 + 1 >> 0] = i21 >> 8;
     HEAP8[i22 + 2 >> 0] = i21 >> 16;
     HEAP8[i22 + 3 >> 0] = i21 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i10 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i11 - i2) | 0;
    i2 = i10;
   }
   if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i1;
    i3 = i8;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i7 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i2 = i1;
     i3 = i8;
     continue L120;
    }
   }
  }
  if ((i26 | 0) == 42) if (!((i7 | 0) > (i23 | 0) | (i3 | 0) != (i16 | 0))) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i26 = i7;
   return i26 | 0;
  }
  i26 = i25 + -1 - i1 | 0;
  return i26 | 0;
 } else {
  i15 = i24 + (0 - i2) | 0;
  i16 = i25 + i3 | 0;
  i17 = i24 + i23 | 0;
  i18 = i17 + -12 | 0;
  if (!i23) {
   if ((i3 | 0) == 1) i1 = (HEAP8[i25 >> 0] | 0) != 0; else i1 = 1;
   i26 = i1 << 31 >> 31;
   return i26 | 0;
  }
  i9 = i16 + -15 | 0;
  i10 = i16 + -8 | 0;
  i11 = i16 + -5 | 0;
  i12 = i17 + -5 | 0;
  i13 = i17 + -8 | 0;
  i14 = i13;
  i2 = i25;
  i3 = i24;
  L167 : while (1) {
   i1 = i2 + 1 | 0;
   i7 = HEAPU8[i2 >> 0] | 0;
   i2 = i7 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1 & i1 >>> 0 < i9 >>> 0);
    if ((i2 | 0) < 0) break;
   }
   i8 = i3 + i2 | 0;
   i4 = i1 + i2 | 0;
   if (i8 >>> 0 > i18 >>> 0 | i4 >>> 0 > i10 >>> 0) {
    i26 = 71;
    break;
   } else i2 = i3;
   while (1) {
    i22 = i1;
    i20 = i22;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i23 = i2;
    i21 = i23;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i22;
    HEAP8[i23 + 1 >> 0] = i22 >> 8;
    HEAP8[i23 + 2 >> 0] = i22 >> 16;
    HEAP8[i23 + 3 >> 0] = i22 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i3 = HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 >> 0];
   i5 = i3 & 65535;
   i6 = i8 + (0 - i3) | 0;
   i1 = i4 + 2 | 0;
   if (i6 >>> 0 < i15 >>> 0) break;
   i2 = i7 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i11 >>> 0) break L167;
     i23 = i1;
     i1 = i1 + 1 | 0;
     i23 = HEAP8[i23 >> 0] | 0;
     i2 = (i23 & 255) + i2 | 0;
    } while (i23 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) break;
   }
   i7 = i8 + (i2 + 4) | 0;
   if ((i5 & 65535) < 8) {
    i23 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
    HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
    HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
    i3 = i6 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
    i22 = i8 + 4 | 0;
    i21 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i3 = i3 + (0 - i23) | 0;
   } else {
    i23 = i6;
    i21 = i23;
    i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
    i23 = i23 + 4 | 0;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i3 = i8;
    i22 = i3;
    HEAP8[i22 >> 0] = i21;
    HEAP8[i22 + 1 >> 0] = i21 >> 8;
    HEAP8[i22 + 2 >> 0] = i21 >> 16;
    HEAP8[i22 + 3 >> 0] = i21 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i23;
    HEAP8[i3 + 1 >> 0] = i23 >> 8;
    HEAP8[i3 + 2 >> 0] = i23 >> 16;
    HEAP8[i3 + 3 >> 0] = i23 >> 24;
    i3 = i6 + 8 | 0;
   }
   i2 = i8 + 8 | 0;
   if (i7 >>> 0 <= i18 >>> 0) while (1) {
    i22 = i3;
    i20 = i22;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i23 = i2;
    i21 = i23;
    HEAP8[i21 >> 0] = i20;
    HEAP8[i21 + 1 >> 0] = i20 >> 8;
    HEAP8[i21 + 2 >> 0] = i20 >> 16;
    HEAP8[i21 + 3 >> 0] = i20 >> 24;
    i23 = i23 + 4 | 0;
    HEAP8[i23 >> 0] = i22;
    HEAP8[i23 + 1 >> 0] = i22 >> 8;
    HEAP8[i23 + 2 >> 0] = i22 >> 16;
    HEAP8[i23 + 3 >> 0] = i22 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
     i2 = i1;
     i3 = i7;
     continue L167;
    }
   }
   if (i7 >>> 0 > i12 >>> 0) break;
   if (i2 >>> 0 < i13 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i22 = i5;
     i20 = i22;
     i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
     i22 = i22 + 4 | 0;
     i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
     i23 = i4;
     i21 = i23;
     HEAP8[i21 >> 0] = i20;
     HEAP8[i21 + 1 >> 0] = i20 >> 8;
     HEAP8[i21 + 2 >> 0] = i20 >> 16;
     HEAP8[i21 + 3 >> 0] = i20 >> 24;
     i23 = i23 + 4 | 0;
     HEAP8[i23 >> 0] = i22;
     HEAP8[i23 + 1 >> 0] = i22 >> 8;
     HEAP8[i23 + 2 >> 0] = i22 >> 16;
     HEAP8[i23 + 3 >> 0] = i22 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i13 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i14 - i2) | 0;
    i2 = i13;
   }
   if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i1;
    i3 = i7;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i7 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i2 = i1;
     i3 = i7;
     continue L167;
    }
   }
  }
  if ((i26 | 0) == 71) if (!(i8 >>> 0 > i17 >>> 0 | (i4 | 0) != (i16 | 0))) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   i26 = i8 - i24 | 0;
   return i26 | 0;
  }
  i26 = i25 + -1 - i1 | 0;
  return i26 | 0;
 }
 return 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i18, i14) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 64 | 0;
 i15 = i19 + 40 | 0;
 i7 = i19 + 24 | 0;
 i8 = i19 + 12 | 0;
 i6 = i19;
 L1 : do if ((i1 | 0) != (i18 | 0)) {
  i2 = HEAP8[i1 >> 0] | 0;
  i3 = i2 << 24 >> 24;
  switch (i3 | 0) {
  case 68:
  case 67:
   {
    L6 : do if ((i18 - i1 | 0) > 1) {
     i4 = i14 + 4 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i14 >> 2] | 0) != (i2 | 0)) {
      L9 : do switch (i3 | 0) {
      case 67:
       {
        switch (HEAP8[i1 + 1 >> 0] | 0) {
        case 53:
        case 51:
        case 50:
        case 49:
         break;
        default:
         break L6;
        }
        __ZN10__cxxabiv112_GLOBAL__N_19base_nameINSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEEEET_RS9_(i7, i2 + -24 | 0);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i16, i7);
        i2 = HEAP32[i4 >> 2] | 0;
        i18 = HEAP32[i14 + 8 >> 2] | 0;
        i5 = i18;
        do if (i2 >>> 0 < i18 >>> 0) {
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i16);
         HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 24;
        } else {
         i4 = HEAP32[i14 >> 2] | 0;
         i2 = (i2 - i4 | 0) / 24 | 0;
         i3 = i2 + 1 | 0;
         if (i3 >>> 0 > 178956970) {
          __THREW__ = 0;
          invoke_vi(fb + 4014 | 0, i14 | 0);
          __THREW__ = 0;
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i16);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
          break L9;
         } else {
          i17 = (i5 - i4 | 0) / 24 | 0;
          i18 = i17 << 1;
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i17 >>> 0 < 89478485 ? (i18 >>> 0 < i3 >>> 0 ? i3 : i18) : 178956970, i2, i14 + 12 | 0);
          i18 = i15 + 8 | 0;
          i17 = HEAP32[i18 >> 2] | 0;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i17, i16);
          HEAP32[i18 >> 2] = i17 + 24;
          __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
          __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
          break;
         }
        } while (0);
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i16);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
        HEAP8[i14 + 60 >> 0] = 1;
        i1 = i1 + 2 | 0;
        break L6;
       }
      case 68:
       {
        switch (HEAP8[i1 + 1 >> 0] | 0) {
        case 53:
        case 50:
        case 49:
        case 48:
         break;
        default:
         break L6;
        }
        __ZN10__cxxabiv112_GLOBAL__N_19base_nameINSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEEEET_RS9_(i6, i2 + -24 | 0);
        __THREW__ = 0;
        i3 = invoke_iiii(fb + 520 | 0, i6 | 0, 0, gb + 1086597 | 0) | 0;
        i18 = __THREW__;
        __THREW__ = 0;
        L21 : do if (i18 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         i2 = 0;
         while (1) {
          if ((i2 | 0) == 3) break;
          HEAP32[i3 + (i2 << 2) >> 2] = 0;
          i2 = i2 + 1 | 0;
         }
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i8);
         i2 = HEAP32[i4 >> 2] | 0;
         i18 = HEAP32[i14 + 8 >> 2] | 0;
         i5 = i18;
         do if (i2 >>> 0 < i18 >>> 0) {
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i15);
          HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 24;
         } else {
          i4 = HEAP32[i14 >> 2] | 0;
          i2 = (i2 - i4 | 0) / 24 | 0;
          i3 = i2 + 1 | 0;
          if (i3 >>> 0 > 178956970) {
           __THREW__ = 0;
           invoke_vi(fb + 4014 | 0, i14 | 0);
           __THREW__ = 0;
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
           break L21;
          } else {
           i17 = (i5 - i4 | 0) / 24 | 0;
           i18 = i17 << 1;
           __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i16, i17 >>> 0 < 89478485 ? (i18 >>> 0 < i3 >>> 0 ? i3 : i18) : 178956970, i2, i14 + 12 | 0);
           i18 = i16 + 8 | 0;
           i17 = HEAP32[i18 >> 2] | 0;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i17, i15);
           HEAP32[i18 >> 2] = i17 + 24;
           __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i16);
           __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i16);
           break;
          }
         } while (0);
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
         HEAP8[i14 + 60 >> 0] = 1;
         i1 = i1 + 2 | 0;
         break L6;
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
        break;
       }
      default:
       break L6;
      } while (0);
      ___resumeException(i1 | 0);
     }
    } while (0);
    break L1;
   }
  case 85:
   {
    L39 : do if ((i18 - i1 | 0) > 2 & i2 << 24 >> 24 == 85) {
     L41 : do switch (HEAP8[i1 + 1 >> 0] | 0) {
     case 116:
      {
       HEAP32[i7 >> 2] = 0;
       HEAP32[i7 + 4 >> 2] = 0;
       HEAP32[i7 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i7, gb + 1086599 | 0, 8);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i16, i7);
       i6 = i14 + 4 | 0;
       i2 = HEAP32[i6 >> 2] | 0;
       i17 = HEAP32[i14 + 8 >> 2] | 0;
       i4 = i17;
       do if (i2 >>> 0 < i17 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i16);
        HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 24;
       } else {
        i5 = HEAP32[i14 >> 2] | 0;
        i2 = (i2 - i5 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i14 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i16);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
         break L41;
        } else {
         i13 = (i4 - i5 | 0) / 24 | 0;
         i17 = i13 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i13 >>> 0 < 89478485 ? (i17 >>> 0 < i3 >>> 0 ? i3 : i17) : 178956970, i2, i14 + 12 | 0);
         i17 = i15 + 8 | 0;
         i13 = HEAP32[i17 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i13, i16);
         HEAP32[i17 >> 2] = i13 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i16);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
       i3 = i1 + 2 | 0;
       if ((i3 | 0) == (i18 | 0)) {
        i3 = HEAP32[i6 >> 2] | 0;
        i2 = i3 + -24 | 0;
        while (1) {
         if ((i3 | 0) == (i2 | 0)) break L39;
         i18 = i3 + -24 | 0;
         HEAP32[i6 >> 2] = i18;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
         i3 = HEAP32[i6 >> 2] | 0;
        }
       }
       if (((HEAP8[i3 >> 0] | 0) + -48 | 0) >>> 0 < 10) {
        i2 = i1 + 3 | 0;
        while (1) {
         if ((i2 | 0) == (i18 | 0)) {
          i2 = i18;
          break;
         }
         if (((HEAP8[i2 >> 0] | 0) + -48 | 0) >>> 0 >= 10) break;
         i2 = i2 + 1 | 0;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISC_EE5valueERS7_E4typeESC_SC_((HEAP32[i6 >> 2] | 0) + -24 | 0, i3, i2);
       } else i2 = i3;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc((HEAP32[i6 >> 2] | 0) + -24 | 0, 39);
       if ((i2 | 0) != (i18 | 0)) if ((HEAP8[i2 >> 0] | 0) == 95) {
        i1 = i2 + 1 | 0;
        break L39;
       }
       i3 = HEAP32[i6 >> 2] | 0;
       i2 = i3 + -24 | 0;
       while (1) {
        if ((i3 | 0) == (i2 | 0)) break L39;
        i18 = i3 + -24 | 0;
        HEAP32[i6 >> 2] = i18;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
        i3 = HEAP32[i6 >> 2] | 0;
       }
      }
     case 108:
      {
       HEAP32[i8 >> 2] = 0;
       HEAP32[i8 + 4 >> 2] = 0;
       HEAP32[i8 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i8, gb + 1086608 | 0, 9);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i8);
       i17 = i14 + 4 | 0;
       i2 = HEAP32[i17 >> 2] | 0;
       i12 = HEAP32[i14 + 8 >> 2] | 0;
       i4 = i12;
       do if (i2 >>> 0 < i12 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i15);
        HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 24;
       } else {
        i5 = HEAP32[i14 >> 2] | 0;
        i2 = (i2 - i5 | 0) / 24 | 0;
        i3 = i2 + 1 | 0;
        if (i3 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i14 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
         break L41;
        } else {
         i11 = (i4 - i5 | 0) / 24 | 0;
         i12 = i11 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i16, i11 >>> 0 < 89478485 ? (i12 >>> 0 < i3 >>> 0 ? i3 : i12) : 178956970, i2, i14 + 12 | 0);
         i12 = i16 + 8 | 0;
         i11 = HEAP32[i12 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i11, i15);
         HEAP32[i12 >> 2] = i11 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i16);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i16);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
       i3 = i1 + 2 | 0;
       L79 : do if ((HEAP8[i3 >> 0] | 0) == 118) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc((HEAP32[i17 >> 2] | 0) + -24 | 0, 41);
        i2 = i1 + 3 | 0;
       } else {
        i2 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i3, i18, i14) | 0;
        if ((i2 | 0) == (i3 | 0)) {
         i3 = HEAP32[i17 >> 2] | 0;
         i2 = i3 + -24 | 0;
         while (1) {
          if ((i3 | 0) == (i2 | 0)) break L39;
          i18 = i3 + -24 | 0;
          HEAP32[i17 >> 2] = i18;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
          i3 = HEAP32[i17 >> 2] | 0;
         }
        }
        i3 = HEAP32[i17 >> 2] | 0;
        if (((i3 - (HEAP32[i14 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L39;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i16, i3 + -24 | 0);
        i5 = HEAP32[i17 >> 2] | 0;
        i3 = i5 + -24 | 0;
        i4 = i5;
        while (1) {
         if ((i4 | 0) == (i3 | 0)) break;
         i12 = i4 + -24 | 0;
         HEAP32[i17 >> 2] = i12;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i12);
         i4 = HEAP32[i17 >> 2] | 0;
        }
        i11 = i16 + 11 | 0;
        i10 = HEAP8[i11 >> 0] | 0;
        i9 = i10 << 24 >> 24 < 0;
        i12 = i16 + 4 | 0;
        __THREW__ = 0;
        invoke_iiii(fb + 519 | 0, i5 + -48 | 0, (i9 ? HEAP32[i16 >> 2] | 0 : i16) | 0, (i9 ? HEAP32[i12 >> 2] | 0 : i10 & 255) | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        do if (i10 & 1) i13 = 71; else {
         i10 = i16 + 8 | 0;
         while (1) {
          __THREW__ = 0;
          i9 = invoke_iiii(fb + 521 | 0, i2 | 0, i18 | 0, i14 | 0) | 0;
          i8 = __THREW__;
          __THREW__ = 0;
          if (i8 & 1) {
           i13 = 70;
           break;
          }
          if ((i9 | 0) == (i2 | 0)) {
           i13 = 105;
           break;
          }
          i2 = HEAP32[i17 >> 2] | 0;
          if (((i2 - (HEAP32[i14 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) {
           i13 = 146;
           break;
          }
          __THREW__ = 0;
          invoke_vii(fb + 4619 | 0, i15 | 0, i2 + -24 | 0);
          i8 = __THREW__;
          __THREW__ = 0;
          if (i8 & 1) {
           i13 = 104;
           break;
          }
          do if ((HEAP8[i11 >> 0] | 0) < 0) {
           HEAP8[HEAP32[i16 >> 2] >> 0] = 0;
           HEAP32[i12 >> 2] = 0;
           i2 = HEAP8[i11 >> 0] | 0;
           if (i2 << 24 >> 24 >= 0) {
            i13 = 79;
            break;
           }
           i8 = 0;
           i6 = (HEAP32[i10 >> 2] & 2147483647) + -1 | 0;
           i5 = 1;
          } else {
           HEAP8[i16 >> 0] = 0;
           HEAP8[i11 >> 0] = 0;
           i2 = 0;
           i13 = 79;
          } while (0);
          if ((i13 | 0) == 79) {
           i13 = 0;
           i8 = i2 & 255;
           i6 = 10;
           i5 = 0;
          }
          i3 = i8 >>> 0 < 11;
          i7 = i3 ? 10 : (i8 + 16 & 496) + -1 | 0;
          L108 : do if ((i7 | 0) != (i6 | 0)) {
           do if (i3) {
            i3 = HEAP32[i16 >> 2] | 0;
            if (i5) {
             i2 = 0;
             i4 = i16;
             i13 = 86;
            } else {
             i5 = 0;
             i6 = 1;
             i4 = i16;
             i13 = 87;
            }
           } else {
            i4 = _malloc(i7 + 1 | 0) | 0;
            if (i7 >>> 0 <= i6 >>> 0 & (i4 | 0) == 0) break L108;
            if (!i5) {
             i5 = 1;
             i6 = 0;
             i3 = i16;
             i13 = 87;
             break;
            }
            i2 = 1;
            i3 = HEAP32[i16 >> 2] | 0;
            i13 = 86;
           } while (0);
           if ((i13 | 0) == 86) {
            i13 = 0;
            i5 = i2;
            i6 = 1;
            i2 = HEAP32[i12 >> 2] | 0;
           } else if ((i13 | 0) == 87) {
            i13 = 0;
            i2 = i2 & 255;
           }
           i2 = i2 + 1 | 0;
           if (i2 | 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
           if (i6) _free(i3);
           if (i5) {
            HEAP32[i10 >> 2] = i7 + 1 | -2147483648;
            HEAP32[i12 >> 2] = i8;
            HEAP32[i16 >> 2] = i4;
            break;
           } else {
            HEAP8[i11 >> 0] = i8;
            break;
           }
          } while (0);
          HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
          HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
          HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
          i2 = 0;
          while (1) {
           if ((i2 | 0) == 3) break;
           HEAP32[i15 + (i2 << 2) >> 2] = 0;
           i2 = i2 + 1 | 0;
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
          i2 = HEAP32[i17 >> 2] | 0;
          i3 = i2 + -24 | 0;
          i4 = i2;
          while (1) {
           if ((i4 | 0) == (i3 | 0)) break;
           i8 = i4 + -24 | 0;
           HEAP32[i17 >> 2] = i8;
           __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i8);
           i4 = HEAP32[i17 >> 2] | 0;
          }
          i8 = HEAP8[i11 >> 0] | 0;
          if (!((i8 << 24 >> 24 < 0 ? HEAP32[i12 >> 2] | 0 : i8 & 255) | 0)) {
           i2 = i9;
           continue;
          }
          __THREW__ = 0;
          invoke_iii(fb + 1152 | 0, i2 + -48 | 0, gb + 1086385 | 0) | 0;
          i8 = __THREW__;
          __THREW__ = 0;
          if (i8 & 1) {
           i13 = 70;
           break;
          }
          i8 = HEAP8[i11 >> 0] | 0;
          i7 = i8 << 24 >> 24 < 0;
          __THREW__ = 0;
          invoke_iiii(fb + 519 | 0, (HEAP32[i17 >> 2] | 0) + -24 | 0, (i7 ? HEAP32[i16 >> 2] | 0 : i16) | 0, (i7 ? HEAP32[i12 >> 2] | 0 : i8 & 255) | 0) | 0;
          i8 = __THREW__;
          __THREW__ = 0;
          if (i8 & 1) {
           i13 = 70;
           break;
          } else i2 = i9;
         }
         if ((i13 | 0) == 70) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          i13 = 72;
          break;
         } else if ((i13 | 0) == 104) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          break;
         } else if ((i13 | 0) == 105) {
          __THREW__ = 0;
          invoke_iii(fb + 1152 | 0, (HEAP32[i17 >> 2] | 0) + -24 | 0, gb + 1086288 | 0) | 0;
          i15 = __THREW__;
          __THREW__ = 0;
          if (i15 & 1) {
           i13 = 71;
           break;
          }
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
          break L79;
         } else if ((i13 | 0) == 146) {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
          break L39;
         }
        } while (0);
        if ((i13 | 0) == 71) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         i13 = 72;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
        break L41;
       } while (0);
       if ((i2 | 0) != (i18 | 0)) if ((HEAP8[i2 >> 0] | 0) == 69) {
        i4 = i2 + 1 | 0;
        if ((i4 | 0) == (i18 | 0)) {
         i3 = HEAP32[i17 >> 2] | 0;
         i2 = i3 + -24 | 0;
         while (1) {
          if ((i3 | 0) == (i2 | 0)) break L39;
          i18 = i3 + -24 | 0;
          HEAP32[i17 >> 2] = i18;
          __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
          i3 = HEAP32[i17 >> 2] | 0;
         }
        }
        L160 : do if (((HEAP8[i4 >> 0] | 0) + -48 | 0) >>> 0 < 10) {
         i2 = i2 + 2 | 0;
         while (1) {
          if ((i2 | 0) == (i18 | 0)) {
           i2 = i18;
           break;
          }
          if (((HEAP8[i2 >> 0] | 0) + -48 | 0) >>> 0 >= 10) break;
          i2 = i2 + 1 | 0;
         }
         i11 = HEAP32[i17 >> 2] | 0;
         i5 = i11 + -24 | 0;
         i12 = i5 + 11 | 0;
         i3 = HEAP8[i12 >> 0] | 0;
         i8 = i3 << 24 >> 24 < 0;
         if (i8) {
          i7 = HEAP32[i5 >> 2] | 0;
          i6 = i7;
          i9 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
          i10 = HEAP32[i11 + -20 >> 2] | 0;
         } else {
          i6 = i5;
          i7 = i5;
          i9 = 10;
          i10 = i3 & 255;
         }
         i7 = i7 + 7 - i6 | 0;
         i6 = i2 - i4 | 0;
         if (i6) {
          if ((i9 - i10 | 0) >>> 0 < i6 >>> 0) {
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj(i5, i9, i10 + i6 - i9 | 0, i10, i7, i6);
           i5 = HEAP32[i5 >> 2] | 0;
          } else {
           if (i8) i5 = HEAP32[i5 >> 2] | 0;
           i3 = i10 - i7 | 0;
           if (i3) {
            i16 = i5 + i7 | 0;
            _memmove(i16 + i6 | 0, i16 | 0, i3 | 0) | 0;
           }
          }
          i3 = i10 + i6 | 0;
          if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i11 + -20 >> 2] = i3; else HEAP8[i12 >> 0] = i3;
          HEAP8[i5 + i3 >> 0] = 0;
          i3 = i5 + i7 | 0;
          while (1) {
           if ((i4 | 0) == (i2 | 0)) break L160;
           HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
           i4 = i4 + 1 | 0;
           i3 = i3 + 1 | 0;
          }
         }
        } else i2 = i4; while (0);
        if ((i2 | 0) != (i18 | 0)) if ((HEAP8[i2 >> 0] | 0) == 95) {
         i1 = i2 + 1 | 0;
         break L39;
        }
        i3 = HEAP32[i17 >> 2] | 0;
        i2 = i3 + -24 | 0;
        while (1) {
         if ((i3 | 0) == (i2 | 0)) break L39;
         i18 = i3 + -24 | 0;
         HEAP32[i17 >> 2] = i18;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
         i3 = HEAP32[i17 >> 2] | 0;
        }
       }
       i3 = HEAP32[i17 >> 2] | 0;
       i2 = i3 + -24 | 0;
       while (1) {
        if ((i3 | 0) == (i2 | 0)) break L39;
        i18 = i3 + -24 | 0;
        HEAP32[i17 >> 2] = i18;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i18);
        i3 = HEAP32[i17 >> 2] | 0;
       }
      }
     default:
      break L39;
     } while (0);
     ___resumeException(i1 | 0);
    } while (0);
    break L1;
   }
  case 57:
  case 56:
  case 55:
  case 54:
  case 53:
  case 52:
  case 51:
  case 50:
  case 49:
   {
    i1 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i18, i14) | 0;
    break L1;
   }
  default:
   {
    i18 = __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i18, i14) | 0;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
 } while (0);
 STACKTOP = i19;
 return i1 | 0;
}

function __ZN5physx37setupFinalizeSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffjffff(i8, i93, i94, i2, i3, i1, i65, i4, i5, i6, i7, f58, f57, i95, f11, f9, f12, f10) {
 i8 = i8 | 0;
 i93 = i93 | 0;
 i94 = i94 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i65 = i65 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f58 = Math_fround(f58);
 f57 = Math_fround(f57);
 i95 = i95 | 0;
 f11 = Math_fround(f11);
 f9 = Math_fround(f9);
 f12 = Math_fround(f12);
 f10 = Math_fround(f10);
 var f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, i103 = 0;
 i1 = i8 + 22 | 0;
 i55 = (HEAPU16[i1 >> 1] | 0) >>> 8 & 1;
 f56 = Math_fround(HEAPF32[i8 + 92 >> 2]);
 i59 = HEAP32[i2 + 16 >> 2] | 0;
 i60 = HEAP32[i2 + 20 >> 2] | 0;
 i61 = HEAP32[i2 + 24 >> 2] | 0;
 i62 = HEAP32[i3 + 16 >> 2] | 0;
 i63 = HEAP32[i3 + 20 >> 2] | 0;
 i64 = HEAP32[i3 + 24 >> 2] | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 i1 = (i2 & 24 | 0) != 0;
 i90 = HEAP32[i94 + 1796 >> 2] | 0;
 i2 = i2 >>> 6;
 i91 = i1 ? 112 : 80;
 i92 = i1 ? 128 : 96;
 if (i1) i50 = 3; else i50 = (i2 << 2 & 4 ^ 5) & 255;
 i89 = i1 ? 12 : (i2 & 1 ^ 11) & 255;
 i48 = HEAP32[i4 >> 2] | 0;
 i51 = HEAP32[i4 + 4 >> 2] | 0;
 i53 = HEAP32[i4 + 8 >> 2] | 0;
 i49 = HEAP32[i5 >> 2] | 0;
 i52 = HEAP32[i5 + 4 >> 2] | 0;
 i54 = HEAP32[i5 + 8 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f47 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f43 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f44 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f45 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f34 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f67 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f68 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f41 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f41 = f68 > f41 ? f68 : f41;
 f68 = Math_fround(HEAPF32[i6 >> 2]);
 f69 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f70 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f71 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f72 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f73 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f74 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f75 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f35 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f77 = Math_fround(HEAPF32[i7 >> 2]);
 f78 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f79 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f80 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f81 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f82 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f83 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f84 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f36 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f40 = Math_fround(f58 * Math_fround(.800000011));
 i88 = i8 + 84 | 0;
 f86 = Math_fround(HEAPF32[i88 >> 2]);
 i87 = i8 + 88 | 0;
 f66 = Math_fround(HEAPF32[i87 >> 2]);
 f76 = Math_fround(f86 * f9);
 f85 = Math_fround(-Math_fround(f66 * f10));
 f86 = Math_fround(f34 * Math_fround(f86 * f11));
 f66 = Math_fround(f67 * Math_fround(f66 * f12));
 f67 = Math_fround(-f66);
 f68 = Math_fround(f68 * f76);
 f69 = Math_fround(f69 * f76);
 f70 = Math_fround(f70 * f76);
 f71 = Math_fround(f71 * f76);
 f72 = Math_fround(f72 * f76);
 f73 = Math_fround(f73 * f76);
 f74 = Math_fround(f74 * f76);
 f75 = Math_fround(f75 * f76);
 f76 = Math_fround(f35 * f76);
 f77 = Math_fround(f77 * f85);
 f78 = Math_fround(f78 * f85);
 f79 = Math_fround(f79 * f85);
 f80 = Math_fround(f80 * f85);
 f81 = Math_fround(f81 * f85);
 f82 = Math_fround(f82 * f85);
 f83 = Math_fround(f83 * f85);
 f84 = Math_fround(f84 * f85);
 f85 = Math_fround(f36 * f85);
 i39 = (i90 | 0) == 0;
 if (i39) {
  i95 = 0;
  i94 = i65;
  HEAP8[i94 >> 0] = 0;
  return i95 | 0;
 }
 f25 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i38 = 0;
 i3 = i65;
 while (1) {
  i2 = HEAP32[i94 + 1408 + (i38 << 2) >> 2] | 0;
  if (!i2) i1 = i3; else {
   i37 = i94 + 1536 + (i38 << 2) | 0;
   i6 = HEAP32[i94 + 768 + (i38 * 20 | 0) >> 2] | 0;
   i7 = HEAP32[i94 + 768 + (i38 * 20 | 0) + 4 >> 2] | 0;
   i8 = HEAP32[i94 + 768 + (i38 * 20 | 0) + 8 >> 2] | 0;
   i5 = i93 + ((HEAPU16[i94 + ((HEAP32[i37 >> 2] | 0) * 12 | 0) >> 1] | 0) << 6) + 60 | 0;
   f19 = Math_fround(HEAPF32[i5 >> 2]);
   f22 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f25 * f22);
   f23 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f20 + Math_fround(f26 * f23));
   f24 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f20 + Math_fround(f27 * f24));
   f21 = Math_fround(Math_fround(Math_fround(f28 * f22) + Math_fround(f29 * f23)) + Math_fround(f30 * f24));
   i1 = i3 + 48 | 0;
   HEAP8[i3 + 1 >> 0] = i2;
   HEAP8[i3 >> 0] = i50;
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAPF32[i3 + 8 >> 2] = f86;
   HEAPF32[i3 + 12 >> 2] = f67;
   HEAP32[i3 + 16 >> 2] = i6;
   HEAP32[i3 + 20 >> 2] = i7;
   HEAP32[i3 + 24 >> 2] = i8;
   HEAP8[i3 + 36 >> 0] = i55;
   i2 = HEAP32[i37 >> 2] | 0;
   if ((i2 | 0) != 65535) if (f19 > Math_fround(0.0)) while (1) {
    i3 = HEAP16[i94 + (i2 * 12 | 0) + 2 >> 1] | 0;
    i37 = HEAPU16[i94 + (i2 * 12 | 0) >> 1] | 0;
    if (i3 << 16 >> 16) {
     i6 = i3 & 65535;
     i3 = Math_imul(i91, i6) | 0;
     i7 = 0;
     i8 = i1;
     while (1) {
      i4 = i7 + i37 | 0;
      f102 = Math_fround(HEAPF32[i93 + (i4 << 6) + 16 >> 2]);
      f15 = Math_fround(HEAPF32[i93 + (i4 << 6) + 20 >> 2]);
      f14 = Math_fround(HEAPF32[i93 + (i4 << 6) + 24 >> 2]);
      f97 = Math_fround(HEAPF32[i93 + (i4 << 6) + 12 >> 2]);
      f13 = Math_fround(HEAPF32[i93 + (i4 << 6) + 32 >> 2]);
      f9 = Math_fround(HEAPF32[i93 + (i4 << 6) + 36 >> 2]);
      f9 = Math_fround(Math_fround(Math_fround(f22 * f13) + Math_fround(f23 * f9)) + Math_fround(f24 * Math_fround(HEAPF32[i93 + (i4 << 6) + 40 >> 2])));
      f13 = Math_fround(f102 - f31);
      f12 = Math_fround(f15 - f32);
      f11 = Math_fround(f14 - f33);
      f102 = Math_fround(f102 - f34);
      f15 = Math_fround(f15 - f35);
      f14 = Math_fround(f14 - f36);
      i4 = HEAP32[i93 + (i4 << 6) + 28 >> 2] | 0;
      f10 = Math_fround(Math_fround(f24 * f12) - Math_fround(f23 * f11));
      f11 = Math_fround(Math_fround(f22 * f11) - Math_fround(f24 * f13));
      f12 = Math_fround(Math_fround(f23 * f13) - Math_fround(f22 * f12));
      f13 = Math_fround(Math_fround(f24 * f15) - Math_fround(f23 * f14));
      f14 = Math_fround(Math_fround(f22 * f14) - Math_fround(f24 * f102));
      f15 = Math_fround(Math_fround(f23 * f102) - Math_fround(f22 * f15));
      f102 = Math_fround(Math_fround(f74 * f12) + Math_fround(Math_fround(f68 * f10) + Math_fround(f71 * f11)));
      f101 = Math_fround(Math_fround(f75 * f12) + Math_fround(Math_fround(f69 * f10) + Math_fround(f72 * f11)));
      f100 = Math_fround(Math_fround(f76 * f12) + Math_fround(Math_fround(f70 * f10) + Math_fround(f73 * f11)));
      f99 = Math_fround(Math_fround(f83 * f15) + Math_fround(Math_fround(f77 * f13) + Math_fround(f80 * f14)));
      f98 = Math_fround(Math_fround(f84 * f15) + Math_fround(Math_fround(f78 * f13) + Math_fround(f81 * f14)));
      f18 = Math_fround(Math_fround(f85 * f15) + Math_fround(Math_fround(f79 * f13) + Math_fround(f82 * f14)));
      f16 = Math_fround(Math_fround(f86 + Math_fround(Math_fround(f12 * f100) + Math_fround(Math_fround(f10 * f102) + Math_fround(f11 * f101)))) - Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f13 * f99) + Math_fround(f14 * f98))) - f66));
      f96 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(f43 * f12) + Math_fround(Math_fround(f46 * f10) + Math_fround(f47 * f11)))) - Math_fround(f21 + Math_fround(Math_fround(f42 * f15) + Math_fround(Math_fround(f44 * f13) + Math_fround(f45 * f14)))));
      i5 = f16 > Math_fround(0.0);
      f16 = Math_fround(Math_fround(1.0) / f16);
      f16 = i5 ? f16 : Math_fround(0.0);
      f97 = Math_fround(f97 - f56);
      f17 = Math_fround(f40 * f97);
      f17 = Math_fround((f41 > f17 ? f41 : f17) * f16);
      f97 = Math_fround(f97 * f58);
      HEAPF32[i8 + 48 >> 2] = f102;
      HEAPF32[i8 + 52 >> 2] = f101;
      HEAPF32[i8 + 56 >> 2] = f100;
      HEAPF32[i8 + 60 >> 2] = f86;
      HEAPF32[i8 + 64 >> 2] = f99;
      HEAPF32[i8 + 68 >> 2] = f98;
      HEAPF32[i8 + 72 >> 2] = f18;
      HEAPF32[i8 + 76 >> 2] = f67;
      f18 = Math_fround(-f96);
      i5 = f97 < f18 & f96 < f57;
      i103 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
      f102 = Math_fround(f19 * f18);
      f102 = Math_fround(f9 + (i5 ? f102 : Math_fround(0.0)));
      HEAPF32[i8 >> 2] = f10;
      HEAPF32[i8 + 4 >> 2] = f11;
      HEAPF32[i8 + 8 >> 2] = f12;
      HEAP32[i8 + 12 >> 2] = 0;
      HEAPF32[i8 + 16 >> 2] = f13;
      HEAPF32[i8 + 20 >> 2] = f14;
      HEAPF32[i8 + 24 >> 2] = f15;
      HEAPF32[i8 + 28 >> 2] = f16;
      HEAP32[i8 + 32 >> 2] = i103;
      HEAPF32[i8 + 36 >> 2] = f102;
      HEAP32[i8 + 40 >> 2] = i4;
      HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
      i7 = i7 + 1 | 0;
      if ((i7 | 0) == (i6 | 0)) break; else i8 = i8 + i91 | 0;
     }
     i1 = i1 + i3 | 0;
    }
    i2 = HEAP16[i94 + (i2 * 12 | 0) + 4 >> 1] | 0;
    if (i2 << 16 >> 16 == -1) break; else i2 = i2 & 65535;
   } else {
    i7 = i2;
    while (1) {
     i2 = HEAP16[i94 + (i7 * 12 | 0) + 2 >> 1] | 0;
     i6 = HEAPU16[i94 + (i7 * 12 | 0) >> 1] | 0;
     if (i2 << 16 >> 16) {
      i2 = i2 & 65535;
      i3 = Math_imul(i91, i2) | 0;
      i4 = 0;
      i5 = i1;
      while (1) {
       i103 = i4 + i6 | 0;
       f14 = Math_fround(HEAPF32[i93 + (i103 << 6) + 16 >> 2]);
       f99 = Math_fround(HEAPF32[i93 + (i103 << 6) + 20 >> 2]);
       f98 = Math_fround(HEAPF32[i93 + (i103 << 6) + 24 >> 2]);
       f101 = Math_fround(HEAPF32[i93 + (i103 << 6) + 12 >> 2]);
       f97 = Math_fround(HEAPF32[i93 + (i103 << 6) + 32 >> 2]);
       f102 = Math_fround(HEAPF32[i93 + (i103 << 6) + 36 >> 2]);
       f102 = Math_fround(Math_fround(Math_fround(f22 * f97) + Math_fround(f23 * f102)) + Math_fround(f24 * Math_fround(HEAPF32[i93 + (i103 << 6) + 40 >> 2])));
       f97 = Math_fround(f14 - f31);
       f96 = Math_fround(f99 - f32);
       f21 = Math_fround(f98 - f33);
       f14 = Math_fround(f14 - f34);
       f99 = Math_fround(f99 - f35);
       f98 = Math_fround(f98 - f36);
       i103 = HEAP32[i93 + (i103 << 6) + 28 >> 2] | 0;
       f20 = Math_fround(Math_fround(f24 * f96) - Math_fround(f23 * f21));
       f21 = Math_fround(Math_fround(f22 * f21) - Math_fround(f24 * f97));
       f96 = Math_fround(Math_fround(f23 * f97) - Math_fround(f22 * f96));
       f97 = Math_fround(Math_fround(f24 * f99) - Math_fround(f23 * f98));
       f98 = Math_fround(Math_fround(f22 * f98) - Math_fround(f24 * f14));
       f99 = Math_fround(Math_fround(f23 * f14) - Math_fround(f22 * f99));
       f14 = Math_fround(Math_fround(f74 * f96) + Math_fround(Math_fround(f68 * f20) + Math_fround(f71 * f21)));
       f15 = Math_fround(Math_fround(f75 * f96) + Math_fround(Math_fround(f69 * f20) + Math_fround(f72 * f21)));
       f16 = Math_fround(Math_fround(f76 * f96) + Math_fround(Math_fround(f70 * f20) + Math_fround(f73 * f21)));
       f17 = Math_fround(Math_fround(f83 * f99) + Math_fround(Math_fround(f77 * f97) + Math_fround(f80 * f98)));
       f18 = Math_fround(Math_fround(f84 * f99) + Math_fround(Math_fround(f78 * f97) + Math_fround(f81 * f98)));
       f19 = Math_fround(Math_fround(f85 * f99) + Math_fround(Math_fround(f79 * f97) + Math_fround(f82 * f98)));
       f100 = Math_fround(Math_fround(f86 + Math_fround(Math_fround(f96 * f16) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f15)))) - Math_fround(Math_fround(Math_fround(f99 * f19) + Math_fround(Math_fround(f97 * f17) + Math_fround(f98 * f18))) - f66));
       i37 = f100 > Math_fround(0.0);
       f100 = Math_fround(Math_fround(1.0) / f100);
       f100 = i37 ? f100 : Math_fround(0.0);
       f101 = Math_fround(f40 * Math_fround(f101 - f56));
       f101 = Math_fround((f41 > f101 ? f41 : f101) * f100);
       HEAPF32[i5 + 48 >> 2] = f14;
       HEAPF32[i5 + 52 >> 2] = f15;
       HEAPF32[i5 + 56 >> 2] = f16;
       HEAPF32[i5 + 60 >> 2] = f86;
       HEAPF32[i5 + 64 >> 2] = f17;
       HEAPF32[i5 + 68 >> 2] = f18;
       HEAPF32[i5 + 72 >> 2] = f19;
       HEAPF32[i5 + 76 >> 2] = f67;
       f102 = Math_fround(f102 + Math_fround(0.0));
       HEAPF32[i5 >> 2] = f20;
       HEAPF32[i5 + 4 >> 2] = f21;
       HEAPF32[i5 + 8 >> 2] = f96;
       HEAP32[i5 + 12 >> 2] = 0;
       HEAPF32[i5 + 16 >> 2] = f97;
       HEAPF32[i5 + 20 >> 2] = f98;
       HEAPF32[i5 + 24 >> 2] = f99;
       HEAPF32[i5 + 28 >> 2] = f100;
       HEAPF32[i5 + 32 >> 2] = f101;
       HEAPF32[i5 + 36 >> 2] = f102;
       HEAP32[i5 + 40 >> 2] = i103;
       HEAPF32[i5 + 44 >> 2] = Math_fround(0.0);
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i2 | 0)) break; else i5 = i5 + i91 | 0;
      }
      i1 = i1 + i3 | 0;
     }
     i2 = HEAP16[i94 + (i7 * 12 | 0) + 4 >> 1] | 0;
     if (i2 << 16 >> 16 == -1) break; else i7 = i2 & 65535;
    }
   }
  }
  i38 = i38 + 1 | 0;
  if ((i38 | 0) == (i90 | 0)) break; else i3 = i1;
 }
 if (i39) {
  i103 = 0;
  i95 = i1;
  HEAP8[i95 >> 0] = 0;
  return i103 | 0;
 }
 f56 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f56 = Math_fround(f56 - (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f47 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f47 - (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f46 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = Math_fround(f46 - (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f45 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i48 = (i95 | 0) == 0;
 i49 = Math_imul(i92, i95) | 0;
 i2 = 0;
 i50 = 0;
 i8 = i1;
 i3 = i65;
 while (1) {
  i4 = HEAP32[i94 + 1408 + (i50 << 2) >> 2] | 0;
  L36 : do if (!i4) i1 = i8; else {
   i5 = i94 + 1536 + (i50 << 2) | 0;
   i7 = HEAPU16[i94 + ((HEAP32[i5 >> 2] | 0) * 12 | 0) >> 1] | 0;
   HEAP16[i3 + 2 >> 1] = i8 - i3;
   i3 = i3 + ((Math_imul(HEAPU8[i3 + 1 >> 0] | 0, i91) | 0) + 48) | 0;
   i6 = HEAP32[i93 + (i7 << 6) + 44 >> 2] | 0;
   i7 = (HEAP32[i93 + (i7 << 6) + 52 >> 2] & 1 | 0) == 0;
   HEAP8[i8 + 1 >> 0] = i4;
   if (i7) i1 = HEAPU16[i94 + 768 + (i50 * 20 | 0) + 16 >> 1] | 0; else i1 = 0;
   HEAP8[i8 + 2 >> 0] = i1;
   i1 = i8 + ((i4 << 2) + 44 & -16) | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP16[i94 + (i5 * 12 | 0) >> 1] | 0;
   i65 = i4 & 65535;
   f13 = Math_fround(HEAPF32[i93 + (i65 << 6) >> 2]);
   f14 = Math_fround(HEAPF32[i93 + (i65 << 6) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i93 + (i65 << 6) + 8 >> 2]);
   f11 = Math_fround(-f10);
   f15 = Math_fround(-f14);
   i65 = Math_fround(Math_abs(Math_fround(f13))) < Math_fround(.707106769);
   f15 = i65 ? Math_fround(0.0) : f15;
   f9 = i65 ? f14 : Math_fround(0.0);
   f102 = Math_fround(Math_fround(Math_fround(f56 * f13) + Math_fround(f47 * f14)) + Math_fround(f46 * f10));
   f100 = Math_fround(f56 - Math_fround(f13 * f102));
   f101 = Math_fround(f47 - Math_fround(f14 * f102));
   f102 = Math_fround(f46 - Math_fround(f10 * f102));
   i103 = Math_fround(Math_fround(f102 * f102) + Math_fround(Math_fround(f100 * f100) + Math_fround(f101 * f101))) > Math_fround(9.99999974e-06);
   f15 = i103 ? f100 : f15;
   f11 = i103 ? f101 : i65 ? f11 : f13;
   f9 = i103 ? f102 : f9;
   f102 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f15 * f15) + Math_fround(f11 * f11))))));
   f15 = Math_fround(f102 * f15);
   f11 = Math_fround(f102 * f11);
   f9 = Math_fround(f102 * f9);
   if (i7) {
    HEAP32[i8 + 4 >> 2] = i6;
    HEAP32[i8 + 8 >> 2] = HEAP32[i88 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i87 >> 2];
    HEAP8[i8 >> 0] = i89;
    if ((i5 | 0) != 65535) {
     f16 = Math_fround(Math_fround(f10 * f11) - Math_fround(f14 * f9));
     f12 = Math_fround(Math_fround(f13 * f9) - Math_fround(f10 * f15));
     f10 = Math_fround(Math_fround(f14 * f15) - Math_fround(f13 * f11));
     i39 = 0;
     while (1) {
      i38 = i94 + (i5 * 12 | 0) + 2 | 0;
      i6 = HEAP16[i38 >> 1] | 0;
      i37 = i4 & 65535;
      if (!(i6 << 16 >> 16)) {
       f13 = f16;
       i6 = 0;
      } else if (i48) {
       f13 = f16;
       i2 = 1;
      } else {
       i8 = i6 & 65535;
       i7 = 0;
       while (1) {
        i6 = i7 + i39 | 0;
        i2 = i7 + i37 | 0;
        f31 = Math_fround(HEAPF32[i93 + (i2 << 6) + 16 >> 2]);
        f29 = Math_fround(HEAPF32[i93 + (i2 << 6) + 20 >> 2]);
        f30 = Math_fround(HEAPF32[i93 + (i2 << 6) + 24 >> 2]);
        f28 = Math_fround(f31 - f45);
        f26 = Math_fround(f29 - f44);
        f27 = Math_fround(f30 - f43);
        f31 = Math_fround(f31 - f42);
        f29 = Math_fround(f29 - f41);
        f30 = Math_fround(f30 - f40);
        f32 = Math_fround(HEAPF32[i93 + (i2 << 6) + 32 >> 2]);
        f33 = Math_fround(HEAPF32[i93 + (i2 << 6) + 36 >> 2]);
        f34 = Math_fround(HEAPF32[i93 + (i2 << 6) + 40 >> 2]);
        f36 = f9;
        f35 = f11;
        f13 = f15;
        f9 = f10;
        f11 = f12;
        f15 = f16;
        i2 = 0;
        i4 = i1;
        while (1) {
         HEAP32[i4 + 80 >> 2] = i6;
         f12 = Math_fround(Math_fround(f26 * f36) - Math_fround(f27 * f35));
         f14 = Math_fround(Math_fround(f27 * f13) - Math_fround(f28 * f36));
         f16 = Math_fround(Math_fround(f28 * f35) - Math_fround(f26 * f13));
         f17 = Math_fround(Math_fround(f29 * f36) - Math_fround(f30 * f35));
         f18 = Math_fround(Math_fround(f30 * f13) - Math_fround(f31 * f36));
         f19 = Math_fround(Math_fround(f31 * f35) - Math_fround(f29 * f13));
         f20 = Math_fround(Math_fround(f74 * f16) + Math_fround(Math_fround(f68 * f12) + Math_fround(f71 * f14)));
         f21 = Math_fround(Math_fround(f75 * f16) + Math_fround(Math_fround(f69 * f12) + Math_fround(f72 * f14)));
         f22 = Math_fround(Math_fround(f76 * f16) + Math_fround(Math_fround(f70 * f12) + Math_fround(f73 * f14)));
         f23 = Math_fround(Math_fround(f83 * f19) + Math_fround(Math_fround(f77 * f17) + Math_fround(f80 * f18)));
         f24 = Math_fround(Math_fround(f84 * f19) + Math_fround(Math_fround(f78 * f17) + Math_fround(f81 * f18)));
         f25 = Math_fround(Math_fround(f85 * f19) + Math_fround(Math_fround(f79 * f17) + Math_fround(f82 * f18)));
         f10 = Math_fround(Math_fround(f86 + Math_fround(Math_fround(f16 * f22) + Math_fround(Math_fround(f12 * f20) + Math_fround(f14 * f21)))) - Math_fround(Math_fround(Math_fround(f19 * f25) + Math_fround(Math_fround(f17 * f23) + Math_fround(f18 * f24))) - f66));
         i103 = f10 > Math_fround(0.0);
         f10 = Math_fround(-Math_fround(Math_fround(1.0) / f10));
         HEAPF32[i4 >> 2] = f13;
         HEAPF32[i4 + 4 >> 2] = f35;
         HEAPF32[i4 + 8 >> 2] = f36;
         HEAP32[i4 + 12 >> 2] = 0;
         i103 = i103 ? (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) : -2147483648;
         HEAPF32[i4 + 16 >> 2] = f12;
         HEAPF32[i4 + 20 >> 2] = f14;
         HEAPF32[i4 + 24 >> 2] = f16;
         HEAP32[i4 + 28 >> 2] = i103;
         f102 = Math_fround(Math_fround(f34 * f36) + Math_fround(Math_fround(f33 * f35) + Math_fround(f32 * f13)));
         HEAPF32[i4 + 32 >> 2] = f17;
         HEAPF32[i4 + 36 >> 2] = f18;
         HEAPF32[i4 + 40 >> 2] = f19;
         HEAPF32[i4 + 44 >> 2] = f102;
         HEAPF32[i4 + 48 >> 2] = f20;
         HEAPF32[i4 + 52 >> 2] = f21;
         HEAPF32[i4 + 56 >> 2] = f22;
         HEAPF32[i4 + 60 >> 2] = f86;
         HEAPF32[i4 + 64 >> 2] = f23;
         HEAPF32[i4 + 68 >> 2] = f24;
         HEAPF32[i4 + 72 >> 2] = f25;
         HEAPF32[i4 + 76 >> 2] = f67;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i95 | 0)) {
          f12 = f35;
          f10 = f36;
          break;
         } else {
          f100 = f15;
          f101 = f11;
          f102 = f9;
          i4 = i4 + i92 | 0;
          f15 = f13;
          f11 = f35;
          f9 = f36;
          f13 = f100;
          f35 = f101;
          f36 = f102;
         }
        }
        i1 = i1 + i49 | 0;
        i7 = i7 + 1 | 0;
        if ((i7 | 0) == (i8 | 0)) break; else f16 = f13;
       }
       i6 = HEAP16[i38 >> 1] | 0;
       i2 = 1;
      }
      i103 = HEAP16[i94 + (i5 * 12 | 0) + 4 >> 1] | 0;
      i5 = i103 & 65535;
      if (i103 << 16 >> 16 == -1) break L36;
      i4 = HEAP16[i94 + (i5 * 12 | 0) >> 1] | 0;
      f16 = f13;
      i39 = (i6 & 65535) + i39 | 0;
     }
    }
   }
  } while (0);
  i50 = i50 + 1 | 0;
  if ((i50 | 0) == (i90 | 0)) break; else i8 = i1;
 }
 HEAP8[i1 >> 0] = 0;
 return i2 | 0;
}

function __ZN14SplatMaterials20UpdateSplatMaterialsEP8Materialb(i50, i51, i62) {
 i50 = i50 | 0;
 i51 = i51 | 0;
 i62 = i62 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, f87 = f0, i88 = 0;
 i86 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i86 + 200 | 0;
 i73 = i86 + 184 | 0;
 i79 = i86 + 176 | 0;
 i80 = i86 + 160 | 0;
 i81 = i86 + 156 | 0;
 i82 = i86 + 152 | 0;
 i83 = i86 + 148 | 0;
 i84 = i86 + 144 | 0;
 i52 = i86 + 140 | 0;
 i53 = i86 + 136 | 0;
 i54 = i86 + 132 | 0;
 i55 = i86 + 128 | 0;
 i56 = i86 + 124 | 0;
 i57 = i86 + 120 | 0;
 i58 = i86 + 88 | 0;
 i59 = i86 + 80 | 0;
 i60 = i86 + 76 | 0;
 i61 = i86 + 72 | 0;
 i63 = i86 + 68 | 0;
 i64 = i86 + 64 | 0;
 i65 = i86 + 60 | 0;
 i66 = i86 + 56 | 0;
 i67 = i86 + 52 | 0;
 i68 = i86 + 48 | 0;
 i69 = i86 + 40 | 0;
 i70 = i86 + 32 | 0;
 i71 = i86 + 24 | 0;
 i72 = i86 + 20 | 0;
 i74 = i86 + 16 | 0;
 i75 = i86 + 12 | 0;
 i76 = i86 + 8 | 0;
 i77 = i86 + 4 | 0;
 i78 = i86;
 i1 = HEAP32[i50 >> 2] | 0;
 do if (!i1) {
  i1 = 0;
  i31 = 1;
  i32 = 1;
 } else {
  HEAP32[i73 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i85 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i73);
    i2 = HEAP32[i49 >> 2] | 0;
    i48 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i48 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i48 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i85 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i85 = 9;
   }
  }
  if ((i85 | 0) == 7) i85 = 9;
  if ((i85 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i50 >> 2] | 0) | 0;
   if (!i1) {
    i1 = 0;
    i31 = 1;
    i32 = 1;
    break;
   }
  }
  i31 = i1 + 32 | 0;
  i31 = (HEAP32[i31 + 16 >> 2] | 0) - (HEAP32[i31 + 12 >> 2] | 0) >> 2;
  i31 = (i31 | 0) < 1 ? 1 : i31;
  i32 = 0;
 } while (0);
 i33 = (i51 | 0) == 0;
 i34 = i50 + 24 | 0;
 i35 = i50 + 20 | 0;
 i36 = i80 + 4 | 0;
 i37 = i80 + 8 | 0;
 i38 = i80 + 12 | 0;
 i39 = i1 + 32 | 0;
 i40 = i1 + 76 | 0;
 i41 = i1 + 56 | 0;
 i42 = i1 + 336 | 0;
 i43 = i1 + 320 | 0;
 i44 = i1 + 344 | 0;
 i45 = i1 + 324 | 0;
 i46 = i1 + 44 | 0;
 i47 = i1 + 48 | 0;
 i48 = i1 + 36 | 0;
 i25 = i1 + 44 | 0;
 i26 = i69 + 4 | 0;
 i27 = i70 + 4 | 0;
 i28 = i73 + 4 | 0;
 i29 = i73 + 8 | 0;
 i30 = i73 + 12 | 0;
 i24 = 0;
 do {
  i23 = i50 + 40 + (i24 << 2) | 0;
  i1 = HEAP32[i23 >> 2] | 0;
  if ((i24 | 0) < (i31 | 0)) {
   if (!i1) {
    i1 = __ZN8Material14CreateMaterialER6Shaderib(HEAP32[i50 + 28 + (((i24 | 0) == 0 ? 1 : 2) << 2) >> 2] | 0, 61, 0) | 0;
    __ZN8Material20SetCustomRenderQueueEi(i1, (__ZNK8Material20GetActualRenderQueueEv(i1) | 0) + i24 | 0);
    HEAP32[i23 >> 2] = i1;
   }
   if (!i33) {
    i22 = HEAP32[i1 + 36 >> 2] | 0;
    __ZN8Material26CopyPropertiesFromMaterialERS_(i1, i51);
    __ZN8Material20SetCustomRenderQueueEi(HEAP32[i23 >> 2] | 0, i22);
    i1 = HEAP32[i23 >> 2] | 0;
   }
   if (!(HEAP8[gb + 1573582 >> 0] | 0)) {
    i22 = __ZN8keywords6CreateEPKc(gb + 931201 | 0) | 0;
    HEAP32[gb + 1467332 >> 2] = i22;
    HEAP8[gb + 1573582 >> 0] = 1;
   }
   i2 = HEAP32[gb + 1467248 >> 2] | 0;
   if (i32) {
    HEAP32[i79 >> 2] = i2;
    HEAP32[i49 >> 2] = HEAP32[i79 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i80 >> 2] = HEAP32[gb + 1467248 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i80 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i81 >> 2] = HEAP32[gb + 1467336 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i81 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i82 >> 2] = HEAP32[gb + 1467336 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i82 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i83 >> 2] = HEAP32[gb + 1467340 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i83 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i84 >> 2] = HEAP32[gb + 1467340 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i84 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i52 >> 2] = HEAP32[gb + 1467356 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i52 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i53 >> 2] = HEAP32[gb + 1467356 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i53 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i83 >> 2] = HEAP32[gb + 1467340 + 4 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i83 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i84 >> 2] = HEAP32[gb + 1467340 + 4 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i84 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i52 >> 2] = HEAP32[gb + 1467356 + 4 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i52 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i53 >> 2] = HEAP32[gb + 1467356 + 4 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i53 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i83 >> 2] = HEAP32[gb + 1467340 + 8 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i83 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i84 >> 2] = HEAP32[gb + 1467340 + 8 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i84 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i52 >> 2] = HEAP32[gb + 1467356 + 8 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i52 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i53 >> 2] = HEAP32[gb + 1467356 + 8 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i53 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i83 >> 2] = HEAP32[gb + 1467340 + 12 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i83 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i84 >> 2] = HEAP32[gb + 1467340 + 12 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i84 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
    HEAP32[i52 >> 2] = HEAP32[gb + 1467356 + 12 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i52 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i53 >> 2] = HEAP32[gb + 1467356 + 12 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i53 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
    }
   } else {
    HEAP32[i54 >> 2] = i2;
    HEAP32[i49 >> 2] = HEAP32[i54 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i55 >> 2] = HEAP32[gb + 1467248 >> 2];
     i22 = HEAP32[i40 >> 2] | 0;
     if ((i22 | 0) != (__Z19GetActiveColorSpacev() | 0)) __ZN13SplatDatabase18RecalculateBasemapEb(i39, 0);
     i2 = HEAP32[i41 >> 2] | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0 ? i2 : 0;
     HEAP32[i49 >> 2] = HEAP32[i55 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, i2);
    }
    f20 = Math_fround(HEAPF32[i42 >> 2]);
    f20 = Math_fround(f20 * Math_fround((HEAP32[i43 >> 2] | 0) + -1 | 0));
    f21 = Math_fround(HEAPF32[i44 >> 2]);
    f21 = Math_fround(f21 * Math_fround((HEAP32[i45 >> 2] | 0) + -1 | 0));
    i2 = HEAP32[i47 >> 2] | 0;
    i3 = HEAP32[i46 >> 2] | 0;
    i22 = ((HEAP32[i48 >> 2] | 0) - (HEAP32[i39 >> 2] | 0) | 0) / 44 | 0;
    HEAP32[i56 >> 2] = HEAP32[gb + 1467336 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i56 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i57 >> 2] = HEAP32[gb + 1467336 >> 2];
     if ((i2 - i3 >> 2 | 0) > (i24 | 0)) {
      i6 = (HEAP32[i25 >> 2] | 0) + (i24 << 2) | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      if (!i2) i2 = 0; else {
       HEAP32[i73 >> 2] = i2;
       i2 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i2) i85 = 45; else {
        if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
         i3 = HEAP32[i2 + 28 >> 2] | 0;
         i5 = HEAP32[i2 + 32 >> 2] | 0;
         i2 = i3 + (i5 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i2, i73);
         i3 = HEAP32[i49 >> 2] | 0;
         i19 = HEAP32[i2 + 28 >> 2] | 0;
         i5 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
         i3 = HEAP32[i5 + 28 >> 2] | 0;
         i5 = HEAP32[i5 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i3 + (i5 << 3) | 0)) i85 = 45; else {
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i85 = 47;
        }
       }
       if ((i85 | 0) == 45) i85 = 47;
       if ((i85 | 0) == 47) {
        i85 = 0;
        i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
       }
      }
     } else i2 = 0;
     HEAP32[i49 >> 2] = HEAP32[i57 >> 2];
     __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, i2);
    }
    i17 = (HEAP32[i1 + 100 >> 2] | 0) + 124 | 0;
    HEAP32[i58 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i58 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i58 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i58 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
    HEAP32[i58 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
    HEAP32[i58 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
    HEAP32[i58 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
    HEAP32[i58 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
    i17 = HEAP32[gb + 1467332 >> 2] | 0;
    i18 = i58 + (i17 >>> 5 << 2) | 0;
    HEAP32[i18 >> 2] = HEAP32[i18 >> 2] & ~(1 << (i17 & 31));
    i18 = i24 << 2;
    i17 = 0;
    do {
     i15 = i17 + i18 | 0;
     i6 = gb + 1467340 + (i17 << 2) | 0;
     HEAP32[i59 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i59 >> 2];
     i2 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0;
     i8 = gb + 1467356 + (i17 << 2) | 0;
     HEAP32[i60 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i60 >> 2];
     i7 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0;
     i9 = gb + 1467372 + (i17 << 2) | 0;
     HEAP32[i61 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i61 >> 2];
     i10 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0;
     i11 = gb + 1467288 + (i17 << 2) | 0;
     HEAP32[i63 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i63 >> 2];
     i12 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0;
     i19 = gb + 1467272 + (i17 << 2) | 0;
     HEAP32[i64 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i64 >> 2];
     i13 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0;
     if ((i15 | 0) < (i22 | 0)) {
      i16 = HEAP32[i39 >> 2] | 0;
      i14 = i16 + (i15 * 44 | 0) | 0;
      if (i2) {
       f87 = Math_fround(f20 / Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 8 >> 2]));
       f4 = Math_fround(f21 / Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 12 >> 2]));
       HEAPF32[i69 >> 2] = f87;
       HEAPF32[i26 >> 2] = f4;
       f87 = Math_fround(f87 * Math_fround(Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 16 >> 2]) / f20));
       f4 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 20 >> 2]) / f21));
       HEAPF32[i70 >> 2] = f87;
       HEAPF32[i27 >> 2] = f4;
       HEAP32[i71 >> 2] = HEAP32[i6 >> 2];
       i2 = HEAP32[i14 >> 2] | 0;
       if (!i2) i2 = 0; else {
        HEAP32[i73 >> 2] = i2;
        i2 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i2) i85 = 68; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i3 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[i2 + 32 >> 2] | 0;
          i2 = i3 + (i5 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i2, i73);
          i3 = HEAP32[i49 >> 2] | 0;
          i88 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[gb + 1104264 >> 2] | 0;
          i2 = (i3 | 0) == -1 ? i88 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i88 + (i3 << 3) | 0;
          i3 = HEAP32[i5 + 28 >> 2] | 0;
          i5 = HEAP32[i5 + 32 >> 2] | 0;
         }
         if ((i2 | 0) == (i3 + (i5 << 3) | 0)) {
          i85 = 68;
          break;
         }
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i85 = 70;
        } while (0);
        if ((i85 | 0) == 68) i85 = 70;
        if ((i85 | 0) == 70) {
         i85 = 0;
         i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
        }
       };
       HEAP32[i49 >> 2] = HEAP32[i71 >> 2];
       __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, i2);
       HEAP32[i72 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i72 >> 2];
       __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i1, i49, i69, i70);
      }
      L110 : do if (i7) {
       i6 = i16 + (i15 * 44 | 0) + 4 | 0;
       i2 = HEAP32[i6 >> 2] | 0;
       do if (i2 | 0) {
        HEAP32[i73 >> 2] = i2;
        i2 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i2) i85 = 80; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i3 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[i2 + 32 >> 2] | 0;
          i2 = i3 + (i5 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i2, i73);
          i3 = HEAP32[i49 >> 2] | 0;
          i88 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[gb + 1104264 >> 2] | 0;
          i2 = (i3 | 0) == -1 ? i88 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i88 + (i3 << 3) | 0;
          i3 = HEAP32[i5 + 28 >> 2] | 0;
          i5 = HEAP32[i5 + 32 >> 2] | 0;
         }
         if ((i2 | 0) == (i3 + (i5 << 3) | 0)) {
          i85 = 80;
          break;
         }
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i85 = 82;
        } while (0);
        if ((i85 | 0) == 80) i85 = 82;
        if ((i85 | 0) == 82) {
         i85 = 0;
         i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
         if (!i2) break;
        }
        i7 = HEAP32[gb + 1467332 >> 2] | 0;
        i88 = i58 + (i7 >>> 5 << 2) | 0;
        HEAP32[i88 >> 2] = 1 << (i7 & 31) | HEAP32[i88 >> 2];
        HEAP32[i74 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i49 >> 2] = HEAP32[i74 >> 2];
        __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, i2);
        break L110;
       } while (0);
       HEAP32[i75 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i75 >> 2];
       __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
      } while (0);
      if (i10) {
       HEAP32[i76 >> 2] = HEAP32[i9 >> 2];
       i10 = HEAP32[i16 + (i15 * 44 | 0) + 28 >> 2] | 0;
       i88 = HEAP32[i16 + (i15 * 44 | 0) + 32 >> 2] | 0;
       HEAP32[i73 >> 2] = HEAP32[i16 + (i15 * 44 | 0) + 24 >> 2];
       HEAP32[i28 >> 2] = i10;
       HEAP32[i29 >> 2] = i88;
       HEAPF32[i30 >> 2] = Math_fround(0.0);
       HEAP32[i49 >> 2] = HEAP32[i76 >> 2];
       __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i1, i49, i73);
      }
      if (i12) {
       HEAP32[i77 >> 2] = HEAP32[i11 >> 2];
       f87 = Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 36 >> 2]);
       HEAP32[i49 >> 2] = HEAP32[i77 >> 2];
       __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i49, f87);
      }
      if (i13) {
       i2 = HEAP32[i14 >> 2] | 0;
       do if (!i2) i85 = 112; else {
        HEAP32[i73 >> 2] = i2;
        i2 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i2) i85 = 96; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i5 = HEAP32[i2 + 28 >> 2] | 0;
          i6 = HEAP32[i2 + 32 >> 2] | 0;
          i3 = i5 + (i6 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i2, i73);
          i3 = HEAP32[i49 >> 2] | 0;
          i5 = HEAP32[i2 + 28 >> 2] | 0;
          i88 = HEAP32[gb + 1104264 >> 2] | 0;
          i3 = (i3 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
          i5 = HEAP32[i88 + 28 >> 2] | 0;
          i6 = HEAP32[i88 + 32 >> 2] | 0;
          i2 = i88;
         }
         if ((i3 | 0) == (i5 + (i6 << 3) | 0)) {
          i85 = 96;
          break;
         }
         if (!(HEAP32[i3 + 4 >> 2] | 0)) i85 = 98;
        } while (0);
        if ((i85 | 0) == 96) i85 = 98;
        if ((i85 | 0) == 98) {
         i85 = 0;
         if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0)) {
          i85 = 112;
          break;
         }
         i2 = HEAP32[gb + 1104264 >> 2] | 0;
        }
        HEAP32[i73 >> 2] = HEAP32[i14 >> 2];
        do if (!i2) i85 = 105; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i3 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[i2 + 32 >> 2] | 0;
          i2 = i3 + (i5 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i2, i73);
          i3 = HEAP32[i49 >> 2] | 0;
          i88 = HEAP32[i2 + 28 >> 2] | 0;
          i5 = HEAP32[gb + 1104264 >> 2] | 0;
          i2 = (i3 | 0) == -1 ? i88 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i88 + (i3 << 3) | 0;
          i3 = HEAP32[i5 + 28 >> 2] | 0;
          i5 = HEAP32[i5 + 32 >> 2] | 0;
         }
         if ((i2 | 0) == (i3 + (i5 << 3) | 0)) {
          i85 = 105;
          break;
         }
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i85 = 107;
        } while (0);
        if ((i85 | 0) == 105) i85 = 107;
        if ((i85 | 0) == 107) {
         i85 = 0;
         i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
        }
        i3 = HEAP32[i2 + 52 >> 2] | 0;
        if (!i3) {
         i2 = HEAP32[i2 + 92 >> 2] | 0;
         i2 = (i2 | 0) == -1 ? 5 : i2;
        } else i2 = HEAP32[i3 + 36 >> 2] | 0;
        if (__Z21HasAlphaTextureFormat13TextureFormat(i2) | 0) f4 = Math_fround(1.0); else i85 = 112;
       } while (0);
       if ((i85 | 0) == 112) {
        i85 = 0;
        f4 = Math_fround(HEAPF32[i16 + (i15 * 44 | 0) + 40 >> 2]);
       }
       HEAP32[i78 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i78 >> 2];
       __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i49, f4);
      }
     } else {
      if (i2) {
       HEAP32[i65 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i65 >> 2];
       __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
      }
      if (i7) {
       HEAP32[i66 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i66 >> 2];
       __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i49, 0);
      }
      if (i10) {
       HEAP32[i67 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i73 >> 2] = 0;
       HEAP32[i73 + 4 >> 2] = 0;
       HEAP32[i73 + 8 >> 2] = 0;
       HEAP32[i73 + 12 >> 2] = 0;
       HEAP32[i49 >> 2] = HEAP32[i67 >> 2];
       __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i1, i49, i73);
      }
      if (i12) {
       HEAP32[i68 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i68 >> 2];
       __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i49, Math_fround(0.0));
      }
     }
     i17 = i17 + 1 | 0;
    } while ((i17 | 0) != 4);
    __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet(i1, i58);
   }
   if (i62) {
    i1 = HEAP32[i23 >> 2] | 0;
    f4 = Math_fround(HEAPF32[i34 >> 2]);
    HEAP32[i73 >> 2] = HEAP32[gb + 1467312 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i73 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i79 >> 2] = HEAP32[gb + 1467312 >> 2];
     i88 = HEAP32[i35 >> 2] | 0;
     f20 = Math_fround(Math_fround((i88 & 65535) >>> 8 & 255) / Math_fround(255.0));
     f21 = Math_fround(Math_fround(i88 >>> 16 & 255) / Math_fround(255.0));
     f87 = Math_fround(Math_fround(i88 >>> 24 & 255) / Math_fround(255.0));
     HEAPF32[i80 >> 2] = Math_fround(Math_fround(i88 & 255) / Math_fround(255.0));
     HEAPF32[i36 >> 2] = f20;
     HEAPF32[i37 >> 2] = f21;
     HEAPF32[i38 >> 2] = f87;
     HEAP32[i49 >> 2] = HEAP32[i79 >> 2];
     __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i1, i49, i80);
    }
    HEAP32[i81 >> 2] = HEAP32[gb + 1467316 >> 2];
    HEAP32[i49 >> 2] = HEAP32[i81 >> 2];
    if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i49) | 0) {
     HEAP32[i82 >> 2] = HEAP32[gb + 1467316 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i82 >> 2];
     __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i49, f4);
    }
   }
  } else {
   __Z19DestroySingleObjectP6Object(i1);
   HEAP32[i23 >> 2] = 0;
  }
  i24 = i24 + 1 | 0;
 } while ((i24 | 0) != 8);
 STACKTOP = i86;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i1, i4, i15) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 L1 : while (1) {
  i13 = i4;
  i17 = i4 + -24 | 0;
  i14 = i4 + -48 | 0;
  i18 = i4 + -20 | 0;
  while (1) {
   L5 : while (1) {
    i12 = i1;
    i5 = i13 - i12 | 0;
    switch ((i5 | 0) / 24 | 0 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 9;
      break L1;
     }
    case 4:
     {
      i16 = 27;
      break L1;
     }
    case 5:
     {
      i16 = 28;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 106;
      break L1;
     }
    default:
     {}
    }
    if ((i5 | 0) < 744) {
     i16 = 30;
     break L1;
    }
    i7 = (i5 >>> 0) / 48 | 0;
    i10 = i1 + (i7 * 24 | 0) | 0;
    do if ((i5 | 0) > 23976) {
     i5 = (i5 >>> 0) / 96 | 0;
     i5 = __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i1, i1 + (i5 * 24 | 0) | 0, i10, i10 + (i5 * 24 | 0) | 0, i17, i15) | 0;
     i6 = i10;
     i9 = i1;
    } else {
     f3 = Math_fround(HEAPF32[i10 >> 2]);
     f2 = Math_fround(HEAPF32[i1 >> 2]);
     if (f3 != f2) i6 = f3 < f2; else i6 = (HEAP32[i1 + (i7 * 24 | 0) + 4 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0);
     f2 = Math_fround(HEAPF32[i17 >> 2]);
     if (f2 != f3) i5 = f2 < f3; else i5 = (HEAP32[i18 >> 2] | 0) < (HEAP32[i1 + (i7 * 24 | 0) + 4 >> 2] | 0);
     if (!i6) {
      if (!i5) {
       i5 = 0;
       i6 = i10;
       i9 = i1;
       break;
      };
      HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      HEAP32[i19 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
      HEAP32[i19 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
      HEAP32[i19 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
      HEAP32[i10 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
      HEAP32[i10 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
      HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
      HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
      HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
      f2 = Math_fround(HEAPF32[i10 >> 2]);
      f3 = Math_fround(HEAPF32[i1 >> 2]);
      if (f2 != f3) {
       if (!(f2 < f3)) {
        i5 = 1;
        i6 = i10;
        i9 = i1;
        break;
       }
      } else if ((HEAP32[i1 + (i7 * 24 | 0) + 4 >> 2] | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
       i5 = 1;
       i6 = i10;
       i9 = i1;
       break;
      };
      HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
      HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
      HEAP32[i10 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
      HEAP32[i10 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
      i5 = 2;
      i6 = i10;
      i9 = i1;
      break;
     }
     if (i5) {
      HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
      HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
      HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
      HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
      HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
      i5 = 1;
      i6 = i10;
      i9 = i1;
      break;
     };
     HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i10 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i10 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     f2 = Math_fround(HEAPF32[i17 >> 2]);
     f3 = Math_fround(HEAPF32[i10 >> 2]);
     if (f2 != f3) {
      if (!(f2 < f3)) {
       i5 = 1;
       i6 = i10;
       i9 = i1;
       break;
      }
     } else if ((HEAP32[i18 >> 2] | 0) >= (HEAP32[i1 + (i7 * 24 | 0) + 4 >> 2] | 0)) {
      i5 = 1;
      i6 = i10;
      i9 = i1;
      break;
     };
     HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     HEAP32[i10 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
     HEAP32[i10 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     i5 = 2;
     i6 = i10;
     i9 = i1;
    } while (0);
    f11 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(HEAPF32[i6 >> 2]);
    if (f11 != f3) {
     if (f11 < f3) {
      i6 = i17;
      break;
     }
    } else if ((HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i1 + (i7 * 24 | 0) + 4 >> 2] | 0)) {
     i6 = i17;
     break;
    }
    if ((i1 | 0) != (i14 | 0)) {
     i8 = i1 + (i7 * 24 | 0) + 4 | 0;
     i7 = i17;
     i6 = i14;
     while (1) {
      f2 = Math_fround(HEAPF32[i6 >> 2]);
      if (f2 != f3) {
       if (f2 < f3) {
        i16 = 82;
        break L5;
       }
      } else if ((HEAP32[i7 + -20 >> 2] | 0) < (HEAP32[i8 >> 2] | 0)) {
       i16 = 82;
       break L5;
      }
      i7 = i6 + -24 | 0;
      if ((i1 | 0) == (i7 | 0)) break; else {
       i21 = i6;
       i6 = i7;
       i7 = i21;
      }
     }
    }
    i5 = i1 + 24 | 0;
    f2 = Math_fround(HEAPF32[i17 >> 2]);
    if (f11 != f2) {
     if (!(f11 < f2)) i16 = 59;
    } else if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i18 >> 2] | 0)) i16 = 59;
    if ((i16 | 0) == 59) {
     i16 = 0;
     if ((i5 | 0) == (i17 | 0)) {
      i16 = 106;
      break L1;
     }
     i6 = i1 + 4 | 0;
     while (1) {
      f2 = Math_fround(HEAPF32[i5 >> 2]);
      if (f11 != f2) {
       if (f11 < f2) break;
      } else if ((HEAP32[i6 >> 2] | 0) < (HEAP32[i5 + 4 >> 2] | 0)) break;
      i5 = i5 + 24 | 0;
      if ((i5 | 0) == (i17 | 0)) {
       i16 = 106;
       break L1;
      }
     }
     HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     i5 = i5 + 24 | 0;
    }
    if ((i5 | 0) == (i17 | 0)) {
     i16 = 106;
     break L1;
    }
    i7 = i1 + 4 | 0;
    i6 = i17;
    i1 = i5;
    while (1) {
     f3 = Math_fround(HEAPF32[i9 >> 2]);
     while (1) {
      f2 = Math_fround(HEAPF32[i1 >> 2]);
      if (f3 != f2) {
       if (f3 < f2) {
        i5 = i6;
        break;
       }
      } else if ((HEAP32[i7 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0)) {
       i5 = i6;
       break;
      }
      i1 = i1 + 24 | 0;
     }
     while (1) {
      i6 = i5 + -24 | 0;
      f2 = Math_fround(HEAPF32[i6 >> 2]);
      if (f3 != f2) if (f3 < f2) {
       i5 = i6;
       continue;
      } else break; else if ((HEAP32[i7 >> 2] | 0) < (HEAP32[i5 + -20 >> 2] | 0)) {
       i5 = i6;
       continue;
      } else break;
     }
     if (i1 >>> 0 >= i6 >>> 0) continue L5;
     HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     i1 = i1 + 24 | 0;
    }
   }
   if ((i16 | 0) == 82) {
    i16 = 0;
    HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i5 = i5 + 1 | 0;
   }
   i7 = i1 + 24 | 0;
   L82 : do if (i7 >>> 0 < i6 >>> 0) while (1) {
    f3 = Math_fround(HEAPF32[i10 >> 2]);
    i9 = i10 + 4 | 0;
    while (1) {
     f2 = Math_fround(HEAPF32[i7 >> 2]);
     if (f2 != f3) {
      if (!(f2 < f3)) break;
     } else if ((HEAP32[i7 + 4 >> 2] | 0) >= (HEAP32[i9 >> 2] | 0)) break;
     i7 = i7 + 24 | 0;
    }
    while (1) {
     i8 = i6 + -24 | 0;
     f2 = Math_fround(HEAPF32[i8 >> 2]);
     if (f2 != f3) if (f2 < f3) break; else {
      i6 = i8;
      continue;
     } else if ((HEAP32[i6 + -20 >> 2] | 0) < (HEAP32[i9 >> 2] | 0)) break; else {
      i6 = i8;
      continue;
     }
    }
    if (i7 >>> 0 > i8 >>> 0) {
     i6 = i10;
     break L82;
    };
    HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i8 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i10 = (i10 | 0) == (i7 | 0) ? i8 : i10;
    i6 = i8;
    i7 = i7 + 24 | 0;
    i5 = i5 + 1 | 0;
   } else i6 = i10; while (0);
   do if ((i7 | 0) != (i6 | 0)) {
    f2 = Math_fround(HEAPF32[i6 >> 2]);
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    if (f2 != f3) {
     if (!(f2 < f3)) break;
    } else if ((HEAP32[i6 + 4 >> 2] | 0) >= (HEAP32[i7 + 4 >> 2] | 0)) break;
    HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i5 = i5 + 1 | 0;
   } while (0);
   if (!i5) {
    i5 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEbT0_S6_T_(i1, i7, i15) | 0;
    i6 = i7 + 24 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEbT0_S6_T_(i6, i4, i15) | 0) {
     i16 = 105;
     break;
    }
    if (i5) {
     i1 = i6;
     continue;
    }
   }
   i21 = i7;
   if ((i21 - i12 | 0) >= (i13 - i21 | 0)) {
    i16 = 104;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i1, i7, i15);
   i1 = i7 + 24 | 0;
  }
  if ((i16 | 0) == 104) {
   i16 = 0;
   __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i7 + 24 | 0, i4, i15);
   i4 = i7;
   continue;
  } else if ((i16 | 0) == 105) {
   i16 = 0;
   if (i5) {
    i16 = 106;
    break;
   } else {
    i4 = i7;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  f2 = Math_fround(HEAPF32[i17 >> 2]);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  if (f2 != f3) {
   if (!(f2 < f3)) {
    STACKTOP = i20;
    return;
   }
  } else if ((HEAP32[i18 >> 2] | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
   STACKTOP = i20;
   return;
  };
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 9) {
  i6 = i1 + 24 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  if (f3 != f2) i5 = f3 < f2; else i5 = (HEAP32[i1 + 28 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0);
  f2 = Math_fround(HEAPF32[i17 >> 2]);
  if (f2 != f3) i4 = f2 < f3; else i4 = (HEAP32[i18 >> 2] | 0) < (HEAP32[i1 + 28 >> 2] | 0);
  if (!i5) {
   if (!i4) {
    STACKTOP = i20;
    return;
   };
   HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i19 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i19 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
   f2 = Math_fround(HEAPF32[i6 >> 2]);
   f3 = Math_fround(HEAPF32[i1 >> 2]);
   if (f2 != f3) {
    if (!(f2 < f3)) {
     STACKTOP = i20;
     return;
    }
   } else if ((HEAP32[i1 + 28 >> 2] | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
    STACKTOP = i20;
    return;
   };
   HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
   STACKTOP = i20;
   return;
  }
  if (i4) {
   HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
   STACKTOP = i20;
   return;
  };
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
  f2 = Math_fround(HEAPF32[i17 >> 2]);
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  if (f2 != f3) {
   if (!(f2 < f3)) {
    STACKTOP = i20;
    return;
   }
  } else if ((HEAP32[i18 >> 2] | 0) >= (HEAP32[i1 + 28 >> 2] | 0)) {
   STACKTOP = i20;
   return;
  };
  HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 27) {
  __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i17, i15) | 0;
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 28) {
  __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i1 + 72 | 0, i17, i15) | 0;
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 30) {
  __ZNSt3__218__insertion_sort_3IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i1, i4, i15);
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 106) {
  STACKTOP = i20;
  return;
 }
}

function __ZN5physx2Gu25computeBox_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbjRNS_10PxSweepHitE(i3, i126, i4, i12, f2, f1, i125, i124, i13) {
 i3 = i3 | 0;
 i126 = i126 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 i125 = i125 | 0;
 i124 = i124 | 0;
 i13 = i13 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, f148 = f0, f149 = f0, f150 = f0, f151 = f0, f152 = f0, f153 = f0, f154 = f0, f155 = f0;
 i138 = STACKTOP;
 STACKTOP = STACKTOP + 6768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i107 = i138 + 4480 | 0;
 i121 = i138 + 6244 | 0;
 i113 = i138 + 6208 | 0;
 i117 = i138 + 384 | 0;
 i120 = i138 + 6240 | 0;
 i137 = i138 + 6224 | 0;
 i114 = i138 + 6188 | 0;
 i109 = i138 + 6128 | 0;
 i116 = i138 + 208 | 0;
 i112 = i138 + 224 | 0;
 i122 = i138 + 6056 | 0;
 i58 = i138 + 5832 | 0;
 i115 = i138 + 160 | 0;
 i111 = i138 + 64 | 0;
 i119 = i138 + 4536 | 0;
 i108 = i138 + 4512 | 0;
 i110 = i138 + 96 | 0;
 i118 = i138;
 i106 = i138 + 4496 | 0;
 i123 = i138 + 4552 | 0;
 HEAP32[i120 >> 2] = 0;
 __ZN5physx2Gu9ContainerC2Ev(i137);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i137, 128, i138 + 6256 | 0, 1);
 HEAP32[i114 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i114 + 16 >> 2] = i3;
 HEAPF32[i114 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i114 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i114 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 HEAP32[i109 >> 2] = HEAP32[i4 >> 2];
 i93 = i109 + 4 | 0;
 HEAP32[i93 >> 2] = HEAP32[i4 + 4 >> 2];
 i94 = i109 + 8 | 0;
 HEAP32[i94 >> 2] = HEAP32[i4 + 8 >> 2];
 i95 = i109 + 12 | 0;
 HEAP32[i95 >> 2] = HEAP32[i4 + 12 >> 2];
 i96 = i109 + 16 | 0;
 HEAP32[i96 >> 2] = HEAP32[i4 + 16 >> 2];
 i97 = i109 + 20 | 0;
 HEAP32[i97 >> 2] = HEAP32[i4 + 20 >> 2];
 i98 = i109 + 24 | 0;
 HEAP32[i98 >> 2] = HEAP32[i4 + 24 >> 2];
 i99 = i109 + 28 | 0;
 HEAP32[i99 >> 2] = HEAP32[i4 + 28 >> 2];
 i100 = i109 + 32 | 0;
 HEAP32[i100 >> 2] = HEAP32[i4 + 32 >> 2];
 i101 = i109 + 36 | 0;
 HEAP32[i101 >> 2] = HEAP32[i4 + 36 >> 2];
 i102 = i109 + 40 | 0;
 HEAP32[i102 >> 2] = HEAP32[i4 + 40 >> 2];
 i103 = i109 + 44 | 0;
 HEAP32[i103 >> 2] = HEAP32[i4 + 44 >> 2];
 i59 = i4 + 48 | 0;
 i38 = HEAP32[i59 >> 2] | 0;
 i104 = i109 + 52 | 0;
 i37 = HEAP32[i4 + 52 >> 2] | 0;
 i105 = i109 + 56 | 0;
 i36 = HEAP32[i4 + 56 >> 2] | 0;
 i51 = HEAP32[i12 >> 2] | 0;
 i52 = HEAP32[i12 + 4 >> 2] | 0;
 i53 = HEAP32[i12 + 8 >> 2] | 0;
 i54 = HEAP32[i12 + 12 >> 2] | 0;
 i57 = i12 + 16 | 0;
 i55 = HEAP32[i57 >> 2] | 0;
 i56 = HEAP32[i57 + 4 >> 2] | 0;
 i57 = HEAP32[i57 + 8 >> 2] | 0;
 f43 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = f43 <= f39 ? f43 : f39;
 f44 = f44 <= f47 ? f44 : f47;
 f48 = Math_fround(f44 * Math_fround(.150000006));
 f49 = Math_fround(f48 + f2);
 HEAPF32[i116 >> 2] = f49;
 i92 = i109 + 48 | 0;
 HEAPF32[i92 >> 2] = Math_fround(f43 + f49);
 HEAPF32[i104 >> 2] = Math_fround(f39 + f49);
 HEAPF32[i105 >> 2] = Math_fround(f47 + f49);
 i60 = i112 + 64 | 0;
 HEAP32[i112 >> 2] = 0;
 HEAP32[i112 + 4 >> 2] = 0;
 HEAP32[i112 + 8 >> 2] = 0;
 HEAP32[i112 + 12 >> 2] = 0;
 HEAP32[i112 + 80 >> 2] = 3;
 HEAPF32[i112 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i107 >> 2] = 0;
 HEAP32[i107 + 4 >> 2] = 0;
 HEAP32[i107 + 8 >> 2] = 0;
 HEAP32[i107 + 12 >> 2] = 0;
 HEAP32[i60 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAP32[i112 + 144 >> 2] = i38;
 HEAP32[i112 + 148 >> 2] = i37;
 HEAP32[i112 + 152 >> 2] = i36;
 HEAPF32[i112 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i112 + 16 >> 2] = f48;
 HEAPF32[i112 + 32 >> 2] = Math_fround(f44 * Math_fround(.0500000007));
 i36 = HEAP32[i101 >> 2] | 0;
 i37 = HEAP32[i102 >> 2] | 0;
 i38 = HEAP32[i103 >> 2] | 0;
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i58, i59);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i58, i122);
 HEAPF32[i115 >> 2] = Math_fround(1.0);
 i58 = i115 + 4 | 0;
 HEAP32[i58 >> 2] = 0;
 HEAP32[i58 + 4 >> 2] = 0;
 HEAP32[i58 + 8 >> 2] = 0;
 HEAP32[i58 + 12 >> 2] = 0;
 HEAPF32[i115 + 20 >> 2] = Math_fround(1.0);
 i58 = i115 + 24 | 0;
 HEAP32[i58 >> 2] = 0;
 HEAP32[i58 + 4 >> 2] = 0;
 HEAP32[i58 + 8 >> 2] = 0;
 HEAP32[i58 + 12 >> 2] = 0;
 HEAPF32[i115 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i115 + 44 >> 2] = Math_fround(0.0);
 f44 = Math_fround(HEAPF32[i126 >> 2]);
 f48 = Math_fround(f44 + f44);
 f49 = Math_fround(HEAPF32[i126 + 4 >> 2]);
 f47 = Math_fround(f49 + f49);
 f39 = Math_fround(HEAPF32[i126 + 8 >> 2]);
 f43 = Math_fround(f39 + f39);
 f42 = Math_fround(HEAPF32[i126 + 12 >> 2]);
 f46 = Math_fround(f48 * f42);
 f45 = Math_fround(f47 * f42);
 f42 = Math_fround(f42 * f43);
 f1 = Math_fround(f44 * f47);
 f50 = Math_fround(f44 * f43);
 f47 = Math_fround(f49 * f47);
 f49 = Math_fround(f49 * f43);
 f43 = Math_fround(f39 * f43);
 f39 = Math_fround(Math_fround(Math_fround(1.0) - f47) - f43);
 f40 = Math_fround(f1 + f42);
 f41 = Math_fround(f50 - f45);
 f42 = Math_fround(f1 - f42);
 f48 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f48));
 f43 = Math_fround(f48 - f43);
 f44 = Math_fround(f49 + f46);
 f45 = Math_fround(f50 + f45);
 f46 = Math_fround(f49 - f46);
 f47 = Math_fround(f48 - f47);
 f48 = Math_fround(HEAPF32[i126 + 16 >> 2]);
 f49 = Math_fround(HEAPF32[i126 + 20 >> 2]);
 f50 = Math_fround(HEAPF32[i126 + 24 >> 2]);
 HEAP32[i111 >> 2] = i51;
 i51 = i111 + 4 | 0;
 HEAP32[i51 >> 2] = i52;
 i52 = i111 + 8 | 0;
 HEAP32[i52 >> 2] = i53;
 i53 = i111 + 12 | 0;
 HEAP32[i53 >> 2] = i54;
 i54 = i111 + 16 | 0;
 HEAP32[i54 >> 2] = i55;
 i55 = i111 + 20 | 0;
 HEAP32[i55 >> 2] = i56;
 i56 = i111 + 24 | 0;
 HEAP32[i56 >> 2] = i57;
 i57 = i111 + 28 | 0;
 HEAPF32[i57 >> 2] = Math_fround(0.0);
 i58 = i137 + 4 | 0;
 i59 = i107 + 4 | 0;
 i60 = i107 + 8 | 0;
 i61 = i107 + 12 | 0;
 i62 = i108 + 4 | 0;
 i63 = i108 + 8 | 0;
 i64 = i108 + 12 | 0;
 i65 = i108 + 16 | 0;
 i66 = i108 + 20 | 0;
 i67 = i107 + 4 | 0;
 i68 = i110 + 32 | 0;
 i69 = i110 + 36 | 0;
 i70 = i110 + 40 | 0;
 i71 = i110 + 44 | 0;
 i72 = i110 + 48 | 0;
 i73 = i110 + 16 | 0;
 i74 = i109 + 36 | 0;
 i75 = i118 + 48 | 0;
 i76 = i118 + 52 | 0;
 i77 = i118 + 56 | 0;
 i78 = i118 + 60 | 0;
 i79 = i118 + 4 | 0;
 i80 = i118 + 8 | 0;
 i81 = i118 + 12 | 0;
 i82 = i118 + 16 | 0;
 i83 = i118 + 20 | 0;
 i84 = i118 + 24 | 0;
 i85 = i118 + 28 | 0;
 i86 = i118 + 32 | 0;
 i87 = i118 + 36 | 0;
 i88 = i118 + 40 | 0;
 i89 = i118 + 44 | 0;
 i90 = i137 + 8 | 0;
 i91 = i111 + 16 | 0;
 i129 = i13 + 40 | 0;
 i130 = i13 + 16 | 0;
 i131 = i13 + 20 | 0;
 i132 = i13 + 24 | 0;
 i133 = i13 + 28 | 0;
 i134 = i13 + 32 | 0;
 i135 = i13 + 36 | 0;
 i128 = i13 + 8 | 0;
 i35 = i117 + 44 | 0;
 f1 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f11 = Math_fround(0.0);
 i4 = 268435455;
 f9 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 i12 = 0;
 i13 = 0;
 i15 = 0;
 f7 = Math_fround(0.0);
 f8 = Math_fround(0.0);
 f10 = Math_fround(0.0);
 i3 = 0;
 i127 = 0;
 while (1) {
  if (HEAP32[i58 >> 2] | 0) HEAP32[i58 >> 2] = 0;
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i107, i109);
  f24 = Math_fround(HEAPF32[i107 >> 2]);
  f150 = Math_fround(HEAPF32[i59 >> 2]);
  f148 = Math_fround(HEAPF32[i60 >> 2]);
  f146 = Math_fround(HEAPF32[i61 >> 2]);
  f141 = Math_fround(HEAPF32[i101 >> 2]);
  f143 = Math_fround(HEAPF32[i102 >> 2]);
  f142 = Math_fround(HEAPF32[i103 >> 2]);
  f22 = Math_fround(f24 + f24);
  f140 = Math_fround(f150 + f150);
  f147 = Math_fround(f148 + f148);
  f139 = Math_fround(f150 * f140);
  f144 = Math_fround(f148 * f147);
  f150 = Math_fround(f22 * f150);
  f149 = Math_fround(f22 * f148);
  f23 = Math_fround(f22 * f146);
  f148 = Math_fround(f140 * f148);
  f140 = Math_fround(f140 * f146);
  f146 = Math_fround(f147 * f146);
  f147 = Math_fround(Math_fround(Math_fround(1.0) - f139) - f144);
  f145 = Math_fround(f150 + f146);
  f14 = Math_fround(f149 - f140);
  f146 = Math_fround(f150 - f146);
  f22 = Math_fround(Math_fround(1.0) - Math_fround(f24 * f22));
  f144 = Math_fround(f22 - f144);
  f24 = Math_fround(f148 + f23);
  f140 = Math_fround(f149 + f140);
  f23 = Math_fround(f148 - f23);
  f139 = Math_fround(f22 - f139);
  f22 = Math_fround(HEAPF32[i92 >> 2]);
  f147 = Math_fround(f147 * f22);
  f145 = Math_fround(f145 * f22);
  f22 = Math_fround(f14 * f22);
  f14 = Math_fround(HEAPF32[i104 >> 2]);
  f146 = Math_fround(f146 * f14);
  f144 = Math_fround(f144 * f14);
  f14 = Math_fround(f24 * f14);
  f24 = Math_fround(HEAPF32[i105 >> 2]);
  f140 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f147))) + Math_fround(Math_abs(Math_fround(f146)))) + Math_fround(Math_abs(Math_fround(f140 * f24))));
  f23 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f145))) + Math_fround(Math_abs(Math_fround(f144)))) + Math_fround(Math_abs(Math_fround(f23 * f24))));
  f24 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f22))) + Math_fround(Math_abs(Math_fround(f14)))) + Math_fround(Math_abs(Math_fround(f139 * f24))));
  f139 = Math_fround(f143 - f23);
  f14 = Math_fround(f142 - f24);
  f22 = Math_fround(f141 + f140);
  f23 = Math_fround(f143 + f23);
  f24 = Math_fround(f142 + f24);
  HEAPF32[i108 >> 2] = Math_fround(f141 - f140);
  HEAPF32[i62 >> 2] = f139;
  HEAPF32[i63 >> 2] = f14;
  HEAPF32[i64 >> 2] = f22;
  HEAPF32[i65 >> 2] = f23;
  HEAPF32[i66 >> 2] = f24;
  HEAP32[i107 >> 2] = gb + 84656 + 8;
  HEAP32[i67 >> 2] = i137;
  __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i114, i126, i108, i124, i107) | 0;
  i32 = HEAP32[i58 >> 2] | 0;
  if (!i32) {
   f8 = f1;
   f7 = f2;
   break;
  }
  HEAP32[i54 >> 2] = i36;
  HEAP32[i55 >> 2] = i37;
  HEAP32[i56 >> 2] = i38;
  HEAPF32[i57 >> 2] = Math_fround(0.0);
  HEAP32[i68 >> 2] = i111;
  HEAP32[i69 >> 2] = i115;
  HEAP32[i70 >> 2] = i115;
  HEAP8[i71 >> 0] = 1;
  HEAP32[i110 >> 2] = gb + 84376 + 8;
  HEAP32[i72 >> 2] = i112;
  HEAP32[i73 >> 2] = 0;
  HEAP32[i73 + 4 >> 2] = 0;
  HEAP32[i73 + 8 >> 2] = 0;
  HEAP32[i73 + 12 >> 2] = 0;
  f151 = Math_fround(HEAPF32[i109 >> 2]);
  f22 = Math_fround(HEAPF32[i93 >> 2]);
  f24 = Math_fround(HEAPF32[i94 >> 2]);
  f155 = Math_fround(HEAPF32[i95 >> 2]);
  f154 = Math_fround(HEAPF32[i96 >> 2]);
  f140 = Math_fround(HEAPF32[i97 >> 2]);
  f153 = Math_fround(HEAPF32[i98 >> 2]);
  f152 = Math_fround(HEAPF32[i99 >> 2]);
  f141 = Math_fround(HEAPF32[i100 >> 2]);
  f14 = Math_fround(HEAPF32[i74 >> 2]);
  f23 = Math_fround(HEAPF32[i102 >> 2]);
  f14 = Math_fround(-f14);
  f23 = Math_fround(-f23);
  f139 = Math_fround(-Math_fround(HEAPF32[i103 >> 2]));
  f142 = Math_fround(Math_fround(Math_fround(f39 * f151) + Math_fround(f40 * f22)) + Math_fround(f41 * f24));
  f143 = Math_fround(Math_fround(Math_fround(f39 * f155) + Math_fround(f40 * f154)) + Math_fround(f41 * f140));
  f144 = Math_fround(Math_fround(Math_fround(f39 * f153) + Math_fround(f40 * f152)) + Math_fround(f41 * f141));
  f145 = Math_fround(Math_fround(Math_fround(f42 * f151) + Math_fround(f43 * f22)) + Math_fround(f44 * f24));
  f146 = Math_fround(Math_fround(Math_fround(f42 * f155) + Math_fround(f43 * f154)) + Math_fround(f44 * f140));
  f147 = Math_fround(Math_fround(Math_fround(f42 * f153) + Math_fround(f43 * f152)) + Math_fround(f44 * f141));
  f148 = Math_fround(Math_fround(Math_fround(f45 * f151) + Math_fround(f46 * f22)) + Math_fround(f47 * f24));
  f149 = Math_fround(Math_fround(Math_fround(f45 * f155) + Math_fround(f46 * f154)) + Math_fround(f47 * f140));
  f150 = Math_fround(Math_fround(Math_fround(f45 * f153) + Math_fround(f46 * f152)) + Math_fround(f47 * f141));
  f140 = Math_fround(Math_fround(Math_fround(Math_fround(f48 * f155) + Math_fround(f49 * f154)) + Math_fround(f50 * f140)) + Math_fround(Math_fround(Math_fround(f155 * f14) + Math_fround(f154 * f23)) + Math_fround(f140 * f139)));
  f141 = Math_fround(Math_fround(Math_fround(Math_fround(f48 * f153) + Math_fround(f49 * f152)) + Math_fround(f50 * f141)) + Math_fround(Math_fround(Math_fround(f153 * f14) + Math_fround(f152 * f23)) + Math_fround(f141 * f139)));
  HEAPF32[i75 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f48 * f151) + Math_fround(f49 * f22)) + Math_fround(f50 * f24)) + Math_fround(Math_fround(Math_fround(f151 * f14) + Math_fround(f22 * f23)) + Math_fround(f24 * f139)));
  HEAPF32[i76 >> 2] = f140;
  HEAPF32[i77 >> 2] = f141;
  HEAPF32[i78 >> 2] = Math_fround(0.0);
  HEAPF32[i118 >> 2] = f142;
  HEAPF32[i79 >> 2] = f143;
  HEAPF32[i80 >> 2] = f144;
  HEAPF32[i81 >> 2] = Math_fround(0.0);
  HEAPF32[i82 >> 2] = f145;
  HEAPF32[i83 >> 2] = f146;
  HEAPF32[i84 >> 2] = f147;
  HEAPF32[i85 >> 2] = Math_fround(0.0);
  HEAPF32[i86 >> 2] = f148;
  HEAPF32[i87 >> 2] = f149;
  HEAPF32[i88 >> 2] = f150;
  HEAPF32[i89 >> 2] = Math_fround(0.0);
  i33 = HEAP32[i90 >> 2] | 0;
  HEAP32[i119 >> 2] = HEAP32[i106 >> 2];
  HEAP32[i119 + 4 >> 2] = HEAP32[i106 + 4 >> 2];
  HEAP32[i119 + 8 >> 2] = HEAP32[i106 + 8 >> 2];
  i34 = (i32 + 31 | 0) >>> 5;
  if (!i34) {
   f7 = f11;
   i136 = 24;
   break;
  }
  i19 = 2139095039;
  i29 = 0;
  i30 = 0;
  i31 = ~i32;
  while (1) {
   i16 = i31 >>> 0 > 4294967263 ? ~i31 : 32;
   i27 = i29 << 5;
   i28 = i32 - i27 | 0;
   i28 = i28 >>> 0 < 32 ? i28 : 32;
   i17 = (i28 | 0) == 0;
   if (i17) {
    HEAP32[i113 >> 2] = HEAP32[i119 >> 2];
    HEAP32[i113 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
    HEAP32[i113 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
    i16 = i19;
    i17 = i12;
    f22 = f7;
    f23 = f8;
    f24 = f10;
    i12 = 0;
   } else {
    i18 = 0;
    do {
     __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i114, i126, i123 + (i18 * 40 | 0) | 0, 0, 0, HEAP32[i33 + (i18 + i27 << 2) >> 2] | 0, 0, 0) | 0;
     HEAP8[i123 + (i18 * 40 | 0) + 36 >> 0] = 56;
     i18 = i18 + 1 | 0;
    } while ((i18 | 0) != (i16 | 0));
    HEAP32[i113 >> 2] = HEAP32[i119 >> 2];
    HEAP32[i113 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
    HEAP32[i113 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
    if (i17) {
     i16 = i19;
     i17 = i12;
     f22 = f7;
     f23 = f8;
     f24 = f10;
     i12 = 0;
    } else {
     i16 = i19;
     i25 = i12;
     i12 = 0;
     i26 = 0;
     while (1) {
      HEAP32[i120 >> 2] = 0;
      i21 = i26 + i27 | 0;
      __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i122, i110, i123 + (i26 * 40 | 0) | 0, i21, HEAP8[i123 + (i26 * 40 | 0) + 36 >> 0] | 0, i116, i125, i111, i118, i117, i120) | 0;
      i20 = HEAP32[i120 >> 2] | 0;
      if (!i20) i17 = i25; else {
       i12 = HEAP32[i35 >> 2] | 0;
       if (i20 >>> 0 > 1) {
        i17 = i12;
        i18 = 0;
        i19 = 1;
        while (1) {
         i12 = HEAP32[i117 + (i19 << 6) + 44 >> 2] | 0;
         f155 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f155 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
          HEAP32[i107 >> 2] = HEAP32[i121 >> 2];
          HEAP32[i107 + 4 >> 2] = HEAP32[i121 + 4 >> 2];
          HEAP32[i107 + 8 >> 2] = HEAP32[i121 + 8 >> 2];
          i18 = i19;
         } else i12 = i17;
         i19 = i19 + 1 | 0;
         if ((i19 | 0) == (i20 | 0)) break; else i17 = i12;
        }
       } else i18 = 0;
       f155 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f155 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
        HEAP32[i113 >> 2] = HEAP32[i107 >> 2];
        HEAP32[i113 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
        HEAP32[i113 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
        f7 = Math_fround(HEAPF32[i117 + (i18 << 6) + 16 >> 2]);
        f8 = Math_fround(HEAPF32[i117 + (i18 << 6) + 20 >> 2]);
        f10 = Math_fround(HEAPF32[i117 + (i18 << 6) + 24 >> 2]);
        i15 = HEAP32[i117 + (i18 << 6) + 40 >> 2] | 0;
        i13 = HEAP32[i117 + (i18 << 6) + 36 >> 2] | 0;
        i17 = HEAP32[i117 + (i18 << 6) + 32 >> 2] | 0;
        i4 = i21;
        i16 = i12;
       } else i17 = i25;
       i12 = 1;
      }
      i26 = i26 + 1 | 0;
      if ((i26 | 0) == (i28 | 0)) {
       f22 = f7;
       f23 = f8;
       f24 = f10;
       break;
      } else i25 = i17;
     }
    }
   };
   HEAP32[i119 >> 2] = HEAP32[i113 >> 2];
   HEAP32[i119 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
   HEAP32[i119 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
   i30 = i30 | i12;
   i29 = i29 + 1 | 0;
   if ((i29 | 0) == (i34 | 0)) break; else {
    i19 = i16;
    i12 = i17;
    f7 = f22;
    f8 = f23;
    f10 = f24;
    i31 = i31 + 32 | 0;
   }
  }
  if (!i30) {
   f7 = f11;
   i136 = 24;
   break;
  }
  i4 = HEAP32[i33 + (i4 << 2) >> 2] | 0;
  f155 = Math_fround(HEAPF32[i111 >> 2]);
  f14 = Math_fround(HEAPF32[i51 >> 2]);
  f152 = Math_fround(HEAPF32[i52 >> 2]);
  f154 = Math_fround(HEAPF32[i53 >> 2]);
  f9 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(Math_fround(f154 * f154) + Math_fround(-.5));
  f153 = Math_fround(Math_fround(Math_fround(f9 * f155) + Math_fround(f6 * f14)) + Math_fround(f7 * f152));
  f10 = Math_fround(Math_fround(Math_fround(f155 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f7 * f14) - Math_fround(f6 * f152))) + Math_fround(f9 * f2))) * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(f14 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f9 * f152) - Math_fround(f7 * f155))) + Math_fround(f6 * f2))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(Math_fround(f152 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f6 * f155) - Math_fround(f9 * f14))) + Math_fround(f7 * f2))) * Math_fround(2.0));
  f9 = Math_fround(HEAPF32[i91 >> 2]);
  f6 = Math_fround(HEAPF32[i55 >> 2]);
  f153 = Math_fround(Math_fround(Math_fround(f22 * f155) + Math_fround(f23 * f14)) + Math_fround(f24 * f152));
  f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f155 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f24 * f14) - Math_fround(f23 * f152))) + Math_fround(f22 * f2))) * Math_fround(2.0)));
  f6 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f14 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f22 * f152) - Math_fround(f24 * f155))) + Math_fround(f23 * f2))) * Math_fround(2.0)));
  f2 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) + Math_fround(Math_fround(Math_fround(f152 * f153) + Math_fround(Math_fround(f154 * Math_fround(Math_fround(f23 * f155) - Math_fround(f22 * f14))) + Math_fround(f24 * f2))) * Math_fround(2.0)));
  f14 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f14 <= Math_fround(0.0))) {
   i3 = i127;
   i136 = 23;
   break;
  }
  f153 = Math_fround(f14 * f10);
  f154 = Math_fround(f14 * f8);
  f155 = Math_fround(f14 * f7);
  f1 = Math_fround(f1 - f153);
  f5 = Math_fround(f5 - f154);
  f11 = Math_fround(f11 - f155);
  f153 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f153);
  f154 = Math_fround((HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f154);
  f155 = Math_fround((HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f155);
  i36 = (HEAPF32[tempDoublePtr >> 2] = f153, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f154, HEAP32[tempDoublePtr >> 2] | 0);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f155, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i101 >> 2] = f153;
  HEAPF32[i102 >> 2] = f154;
  HEAPF32[i103 >> 2] = f155;
  i127 = i127 + 1 | 0;
  if (i127 >>> 0 >= 4) {
   f8 = f1;
   f7 = f2;
   i3 = 1;
   break;
  } else {
   i12 = i17;
   f7 = f22;
   f8 = f23;
   f10 = f24;
   i3 = 1;
  }
 }
 if ((i136 | 0) == 23) if (!i3) {
  HEAPF32[i129 >> 2] = Math_fround(0.0);
  HEAPF32[i130 >> 2] = f9;
  HEAPF32[i131 >> 2] = f6;
  HEAPF32[i132 >> 2] = f2;
  HEAPF32[i133 >> 2] = f10;
  HEAPF32[i134 >> 2] = f8;
  HEAPF32[i135 >> 2] = f7;
  HEAP32[i128 >> 2] = i4;
  i136 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i137);
  STACKTOP = i138;
  return i136 | 0;
 } else {
  f7 = f11;
  i3 = 1;
  i136 = 24;
 }
 if ((i136 | 0) == 24) {
  f8 = f1;
  f11 = f7;
  f7 = f2;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f5 * f5) + Math_fround(f8 * f8)))));
 f2 = Math_fround(Math_fround(1.0) / f1);
 if (!i3) {
  i136 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i137);
  STACKTOP = i138;
  return i136 | 0;
 }
 f155 = Math_fround(f11 * f2);
 f154 = Math_fround(f5 * f2);
 f153 = Math_fround(f8 * f2);
 HEAPF32[i129 >> 2] = Math_fround(-f1);
 HEAPF32[i130 >> 2] = f9;
 HEAPF32[i131 >> 2] = f6;
 HEAPF32[i132 >> 2] = f7;
 HEAPF32[i133 >> 2] = f153;
 HEAPF32[i134 >> 2] = f154;
 HEAPF32[i135 >> 2] = f155;
 HEAP32[i128 >> 2] = i4;
 i136 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i137);
 STACKTOP = i138;
 return i136 | 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i120, i107, i106, i1, i109, i108, i122, i123, i121, f2) {
 i120 = i120 | 0;
 i107 = i107 | 0;
 i106 = i106 | 0;
 i1 = i1 | 0;
 i109 = i109 | 0;
 i108 = i108 | 0;
 i122 = i122 | 0;
 i123 = i123 | 0;
 i121 = i121 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, f110 = f0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i124 = 0, f125 = f0, f126 = f0, i127 = 0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0;
 i124 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i119 = i124 + 288 | 0;
 i114 = i124 + 384 | 0;
 i118 = i124 + 380 | 0;
 i77 = i124 + 144 | 0;
 i70 = i124 + 128 | 0;
 i113 = i124 + 304 | 0;
 i111 = i124 + 224 | 0;
 i112 = i124 + 160 | 0;
 i72 = i124 + 112 | 0;
 i73 = i124 + 96 | 0;
 i71 = i124 + 368 | 0;
 i84 = i124 + 80 | 0;
 i85 = i124 + 64 | 0;
 i86 = i124 + 48 | 0;
 i117 = i124 + 32 | 0;
 i115 = i124 + 16 | 0;
 i116 = i124;
 HEAP32[i119 >> 2] = 0;
 HEAP32[i119 + 4 >> 2] = 0;
 HEAP32[i119 + 8 >> 2] = 0;
 HEAP32[i119 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i108 >> 2]);
 i91 = i108 + 4 | 0;
 f8 = Math_fround(HEAPF32[i91 >> 2]);
 i97 = i108 + 8 | 0;
 f13 = Math_fround(HEAPF32[i97 >> 2]);
 f4 = Math_fround(HEAPF32[i109 >> 2]);
 i74 = i109 + 4 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i109 + 8 | 0;
 f9 = Math_fround(HEAPF32[i75 >> 2]);
 HEAP32[i118 >> 2] = 1;
 i76 = i106 + 48 | 0;
 f31 = Math_fround(HEAPF32[i76 >> 2]);
 i82 = i106 + 52 | 0;
 f21 = Math_fround(HEAPF32[i82 >> 2]);
 i83 = i106 + 56 | 0;
 f27 = Math_fround(HEAPF32[i83 >> 2]);
 i87 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f21 * f21)) + Math_fround(f27 * f27)) > Math_fround(1.1920929e-07);
 f31 = i87 ? f31 : Math_fround(1.0);
 f21 = i87 ? f21 : Math_fround(0.0);
 f27 = i87 ? f27 : Math_fround(0.0);
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f31 * f31) + Math_fround(f21 * f21))))));
 f31 = Math_fround(f31 * f20);
 f21 = Math_fround(f21 * f20);
 f20 = Math_fround(f27 * f20);
 HEAPF32[i77 >> 2] = f31;
 HEAPF32[i77 + 4 >> 2] = f21;
 HEAPF32[i77 + 8 >> 2] = f20;
 HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
 f31 = Math_fround(-f31);
 f21 = Math_fround(-f21);
 f20 = Math_fround(-f20);
 f27 = Math_fround(HEAPF32[i106 >> 2]);
 f12 = Math_fround(f27 * f31);
 i87 = i106 + 4 | 0;
 f30 = Math_fround(HEAPF32[i87 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f30 * f21));
 i88 = i106 + 8 | 0;
 f16 = Math_fround(HEAPF32[i88 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f16 * f20));
 i89 = i106 + 16 | 0;
 f33 = Math_fround(HEAPF32[i89 >> 2]);
 f17 = Math_fround(f33 * f31);
 i90 = i106 + 20 | 0;
 f32 = Math_fround(HEAPF32[i90 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f32 * f21));
 i92 = i106 + 24 | 0;
 f14 = Math_fround(HEAPF32[i92 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f14 * f20));
 i93 = i106 + 32 | 0;
 f26 = Math_fround(HEAPF32[i93 >> 2]);
 f31 = Math_fround(f26 * f31);
 i94 = i106 + 36 | 0;
 f29 = Math_fround(HEAPF32[i94 >> 2]);
 f21 = Math_fround(f31 + Math_fround(f29 * f21));
 i95 = i106 + 40 | 0;
 f31 = Math_fround(HEAPF32[i95 >> 2]);
 f20 = Math_fround(f21 + Math_fround(f31 * f20));
 i96 = i120 + 96 | 0;
 f21 = Math_fround(HEAPF32[i96 >> 2]);
 i98 = i120 + 100 | 0;
 f23 = Math_fround(HEAPF32[i98 >> 2]);
 i99 = i120 + 104 | 0;
 f28 = Math_fround(HEAPF32[i99 >> 2]);
 i100 = i120 + 112 | 0;
 f22 = Math_fround(HEAPF32[i100 >> 2]);
 i101 = i120 + 116 | 0;
 f24 = Math_fround(HEAPF32[i101 >> 2]);
 i102 = i120 + 120 | 0;
 f25 = Math_fround(HEAPF32[i102 >> 2]);
 i103 = i120 + 128 | 0;
 f15 = Math_fround(HEAPF32[i103 >> 2]);
 i104 = i120 + 132 | 0;
 f110 = Math_fround(HEAPF32[i104 >> 2]);
 i105 = i120 + 136 | 0;
 f6 = Math_fround(HEAPF32[i105 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f12 * f21) + Math_fround(f17 * f23)) + Math_fround(f20 * f28));
 f19 = Math_fround(Math_fround(Math_fround(f12 * f22) + Math_fround(f17 * f24)) + Math_fround(f20 * f25));
 f20 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(f17 * f110)) + Math_fround(f20 * f6));
 i79 = f18 > f19 & f18 > f20;
 i78 = f19 > f20;
 f15 = i79 ? f21 : i78 ? f22 : f15;
 f110 = i79 ? f23 : i78 ? f24 : f110;
 f6 = i79 ? f28 : i78 ? f25 : f6;
 f25 = Math_fround(HEAPF32[i76 >> 2]);
 f28 = Math_fround(HEAPF32[i82 >> 2]);
 f33 = Math_fround(f25 + Math_fround(Math_fround(f26 * f6) + Math_fround(Math_fround(f27 * f15) + Math_fround(f33 * f110))));
 f32 = Math_fround(f28 + Math_fround(Math_fround(f29 * f6) + Math_fround(Math_fround(f30 * f15) + Math_fround(f32 * f110))));
 f110 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) + Math_fround(Math_fround(f31 * f6) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f110))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i70, i107, i77);
 f14 = Math_fround(HEAPF32[i70 >> 2]);
 f15 = Math_fround(HEAPF32[i70 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f110 - Math_fround(HEAPF32[i70 + 8 >> 2]));
 HEAPF32[i113 >> 2] = f14;
 i77 = i113 + 4 | 0;
 HEAPF32[i77 >> 2] = f15;
 i78 = i113 + 8 | 0;
 HEAPF32[i78 >> 2] = f16;
 i79 = i113 + 12 | 0;
 HEAPF32[i79 >> 2] = Math_fround(0.0);
 i80 = i113 + 16 | 0;
 HEAP32[i80 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i80 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i80 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i80 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i80 = i113 + 32 | 0;
 HEAP32[i80 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i80 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i80 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i80 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i80 = i113 + 48 | 0;
 HEAP32[i80 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i80 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i80 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i80 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 HEAPF32[i111 >> 2] = f33;
 i80 = i111 + 4 | 0;
 HEAPF32[i80 >> 2] = f32;
 i81 = i111 + 8 | 0;
 HEAPF32[i81 >> 2] = f110;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 i69 = i111 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i69 = i111 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i69 = i111 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 HEAP32[i112 >> 2] = HEAP32[i70 >> 2];
 HEAP32[i112 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
 HEAP32[i112 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
 HEAP32[i112 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
 i70 = i112 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i70 = i112 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 i70 = i112 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 f110 = Math_fround(HEAPF32[i107 + 32 >> 2]);
 i70 = f110 < Math_fround(3402823469999999843913219.0e14);
 f110 = Math_fround(f110 * Math_fround(.100000001));
 f110 = i70 ? f110 : Math_fround(3402823469999999938360549.0e13);
 f32 = Math_fround(f110 + f2);
 f110 = Math_fround(f110 * f110);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f110) {
  i3 = i73 + 4 | 0;
  i34 = i73 + 8 | 0;
  i35 = i73 + 12 | 0;
  i36 = i72 + 4 | 0;
  i37 = i72 + 8 | 0;
  i38 = i112 + 4 | 0;
  i39 = i112 + 8 | 0;
  i40 = i112 + 12 | 0;
  i41 = i112 + 16 | 0;
  i42 = i112 + 20 | 0;
  i43 = i112 + 24 | 0;
  i44 = i112 + 28 | 0;
  i45 = i112 + 32 | 0;
  i46 = i112 + 36 | 0;
  i47 = i112 + 40 | 0;
  i48 = i112 + 44 | 0;
  i49 = i111 + 16 | 0;
  i50 = i111 + 20 | 0;
  i51 = i111 + 24 | 0;
  i52 = i113 + 16 | 0;
  i53 = i113 + 20 | 0;
  i54 = i113 + 24 | 0;
  i55 = i113 + 28 | 0;
  i56 = i111 + 32 | 0;
  i57 = i111 + 36 | 0;
  i58 = i111 + 40 | 0;
  i59 = i113 + 32 | 0;
  i60 = i113 + 36 | 0;
  i61 = i113 + 40 | 0;
  i62 = i113 + 44 | 0;
  i63 = i85 + 4 | 0;
  i64 = i85 + 8 | 0;
  i65 = i85 + 12 | 0;
  i66 = i84 + 4 | 0;
  i67 = i84 + 8 | 0;
  i68 = i86 + 4 | 0;
  i69 = i86 + 8 | 0;
  i70 = i86 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f125 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f18 = Math_fround(HEAPF32[i106 >> 2]);
   f136 = Math_fround(f18 * f125);
   f24 = Math_fround(HEAPF32[i87 >> 2]);
   f136 = Math_fround(f136 + Math_fround(f24 * f13));
   f21 = Math_fround(HEAPF32[i88 >> 2]);
   f136 = Math_fround(f136 + Math_fround(f21 * f8));
   f25 = Math_fround(HEAPF32[i89 >> 2]);
   f135 = Math_fround(f25 * f125);
   f26 = Math_fround(HEAPF32[i90 >> 2]);
   f135 = Math_fround(f135 + Math_fround(f26 * f13));
   f16 = Math_fround(HEAPF32[i92 >> 2]);
   f135 = Math_fround(f135 + Math_fround(f16 * f8));
   f19 = Math_fround(HEAPF32[i93 >> 2]);
   f132 = Math_fround(f19 * f125);
   f7 = Math_fround(HEAPF32[i94 >> 2]);
   f132 = Math_fround(f132 + Math_fround(f7 * f13));
   f23 = Math_fround(HEAPF32[i95 >> 2]);
   f132 = Math_fround(f132 + Math_fround(f23 * f8));
   f131 = Math_fround(HEAPF32[i96 >> 2]);
   f129 = Math_fround(HEAPF32[i98 >> 2]);
   f17 = Math_fround(HEAPF32[i99 >> 2]);
   f130 = Math_fround(HEAPF32[i100 >> 2]);
   f128 = Math_fround(HEAPF32[i101 >> 2]);
   f126 = Math_fround(HEAPF32[i102 >> 2]);
   f20 = Math_fround(HEAPF32[i103 >> 2]);
   f27 = Math_fround(HEAPF32[i104 >> 2]);
   f22 = Math_fround(HEAPF32[i105 >> 2]);
   f134 = Math_fround(Math_fround(Math_fround(f136 * f131) + Math_fround(f135 * f129)) + Math_fround(f132 * f17));
   f133 = Math_fround(Math_fround(Math_fround(f136 * f130) + Math_fround(f135 * f128)) + Math_fround(f132 * f126));
   f132 = Math_fround(Math_fround(Math_fround(f136 * f20) + Math_fround(f135 * f27)) + Math_fround(f132 * f22));
   i127 = f134 > f133 & f134 > f132;
   i1 = f133 > f132;
   f20 = i127 ? f131 : i1 ? f130 : f20;
   f27 = i127 ? f129 : i1 ? f128 : f27;
   f22 = i127 ? f17 : i1 ? f126 : f22;
   f126 = Math_fround(HEAPF32[i76 >> 2]);
   f17 = Math_fround(HEAPF32[i82 >> 2]);
   f25 = Math_fround(f126 + Math_fround(Math_fround(f19 * f22) + Math_fround(Math_fround(f18 * f20) + Math_fround(f25 * f27))));
   f26 = Math_fround(f17 + Math_fround(Math_fround(f7 * f22) + Math_fround(Math_fround(f24 * f20) + Math_fround(f26 * f27))));
   f27 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) + Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f21 * f20) + Math_fround(f16 * f27))));
   HEAPF32[i73 >> 2] = f9;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i34 >> 2] = f15;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i72, i107, i73);
   f16 = Math_fround(HEAPF32[i72 >> 2]);
   f20 = Math_fround(HEAPF32[i36 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i37 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23))) - f32);
   f17 = Math_fround(HEAPF32[i108 >> 2]);
   f18 = Math_fround(HEAPF32[i91 >> 2]);
   f19 = Math_fround(HEAPF32[i97 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f125) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i114 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i114 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i114 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f136 = Math_fround(HEAPF32[i109 >> 2]);
     f135 = Math_fround(HEAPF32[i74 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f136);
     f18 = Math_fround(Math_fround(f13 * f18) + f135);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i75 >> 2]));
     f135 = Math_fround(f17 - f31);
     f136 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i112 >> 2]);
     f4 = Math_fround(HEAPF32[i38 >> 2]);
     f2 = Math_fround(f135 + f2);
     f4 = Math_fround(f136 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f22 = Math_fround(HEAPF32[i41 >> 2]);
     f21 = Math_fround(HEAPF32[i42 >> 2]);
     f22 = Math_fround(f135 + f22);
     f21 = Math_fround(f136 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i43 >> 2]));
     f16 = Math_fround(HEAPF32[i45 >> 2]);
     f7 = Math_fround(HEAPF32[i46 >> 2]);
     f16 = Math_fround(f135 + f16);
     f7 = Math_fround(f136 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i47 >> 2]));
     HEAPF32[i112 >> 2] = f2;
     HEAPF32[i38 >> 2] = f4;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     HEAPF32[i41 >> 2] = f22;
     HEAPF32[i42 >> 2] = f21;
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = Math_fround(0.0);
     HEAPF32[i45 >> 2] = f16;
     HEAPF32[i46 >> 2] = f7;
     HEAPF32[i47 >> 2] = f8;
     HEAPF32[i48 >> 2] = Math_fround(0.0);
     f136 = Math_fround(HEAPF32[i111 >> 2]);
     f135 = Math_fround(HEAPF32[i80 >> 2]);
     f4 = Math_fround(f135 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i81 >> 2]) - f5);
     HEAPF32[i113 >> 2] = Math_fround(f136 - f2);
     HEAPF32[i77 >> 2] = f4;
     HEAPF32[i78 >> 2] = f5;
     HEAPF32[i79 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i49 >> 2]);
     f4 = Math_fround(HEAPF32[i50 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f20);
     HEAPF32[i52 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i53 >> 2] = f21;
     HEAPF32[i54 >> 2] = f20;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i56 >> 2]);
     f21 = Math_fround(HEAPF32[i57 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f8);
     HEAPF32[i59 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i60 >> 2] = f7;
     HEAPF32[i61 >> 2] = f8;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i85 >> 2] = f9;
     HEAPF32[i63 >> 2] = f14;
     HEAPF32[i64 >> 2] = f15;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i84, i107, i85);
     f9 = Math_fround(HEAPF32[i84 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i67 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i127 = HEAP32[i118 >> 2] | 0;
   HEAPF32[i111 + (i127 << 4) >> 2] = f25;
   HEAPF32[i111 + (i127 << 4) + 4 >> 2] = f26;
   HEAPF32[i111 + (i127 << 4) + 8 >> 2] = f27;
   HEAPF32[i111 + (i127 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i112 + (i127 << 4) >> 2] = f16;
   HEAPF32[i112 + (i127 << 4) + 4 >> 2] = f20;
   HEAPF32[i112 + (i127 << 4) + 8 >> 2] = f21;
   HEAPF32[i112 + (i127 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i118 >> 2] = i127 + 1;
   HEAPF32[i113 + (i127 << 4) >> 2] = f9;
   HEAPF32[i113 + (i127 << 4) + 4 >> 2] = f8;
   HEAPF32[i113 + (i127 << 4) + 8 >> 2] = f7;
   HEAPF32[i113 + (i127 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i127 | 0) {
   case 0:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i113 >> 2]);
     f7 = Math_fround(HEAPF32[i77 >> 2]);
     f8 = Math_fround(HEAPF32[i78 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f134 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i127 = f134 > Math_fround(1.0);
      f134 = i127 ? Math_fround(1.0) : f134;
      i127 = f134 > Math_fround(0.0);
      f134 = i127 ? f134 : Math_fround(0.0);
      f135 = Math_fround(f7 + Math_fround(f14 * f134));
      f136 = Math_fround(f8 + Math_fround(f15 * f134));
      HEAPF32[i86 >> 2] = Math_fround(f6 + Math_fround(f9 * f134));
      HEAPF32[i68 >> 2] = f135;
      HEAPF32[i69 >> 2] = f136;
      HEAPF32[i70 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i118 >> 2] = 1;
      HEAP32[i86 >> 2] = HEAP32[i113 >> 2];
      HEAP32[i86 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
      HEAP32[i86 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
      HEAP32[i86 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i113, i111, i112, i118);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i113, i111, i112, i118);
     break;
    }
   default:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i86 >> 2]);
   f8 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i124;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i108 = HEAP32[i120 + 64 >> 2] | 0;
 i109 = HEAP32[i120 + 68 >> 2] | 0;
 i127 = HEAP32[i120 + 72 >> 2] | 0;
 i107 = f6 > f110 & i1;
 f131 = i107 ? f7 : f2;
 f133 = i107 ? f8 : f4;
 f135 = i107 ? f9 : f5;
 f130 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f135 * f135) + Math_fround(Math_fround(f133 * f133) + Math_fround(f131 * f131))))));
 f131 = Math_fround(f131 * f130);
 f133 = Math_fround(f133 * f130);
 f130 = Math_fround(f135 * f130);
 HEAPF32[i123 >> 2] = f131;
 HEAPF32[i123 + 4 >> 2] = f133;
 HEAPF32[i123 + 8 >> 2] = f130;
 HEAPF32[i123 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i122 >> 2] = f13;
 i123 = i122 + 4 | 0;
 HEAP32[i123 >> 2] = HEAP32[i114 >> 2];
 HEAP32[i123 + 4 >> 2] = HEAP32[i114 + 4 >> 2];
 HEAP32[i123 + 8 >> 2] = HEAP32[i114 + 8 >> 2];
 HEAPF32[i117 >> 2] = i1 ? f7 : f10;
 HEAPF32[i117 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i117 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i117 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i115 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 HEAP32[i116 >> 2] = HEAP32[i119 >> 2];
 HEAP32[i116 + 4 >> 2] = HEAP32[i119 + 4 >> 2];
 HEAP32[i116 + 8 >> 2] = HEAP32[i119 + 8 >> 2];
 HEAP32[i116 + 12 >> 2] = HEAP32[i119 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i113, i111, i112, i117, i115, i116, HEAP32[i118 >> 2] | 0);
 f135 = Math_fround(HEAPF32[i120 + 16 >> 2]);
 f132 = Math_fround(HEAPF32[i115 >> 2]);
 f134 = Math_fround(HEAPF32[i115 + 4 >> 2]);
 f136 = Math_fround(HEAPF32[i115 + 8 >> 2]);
 f131 = Math_fround(f132 - Math_fround(f131 * f135));
 f133 = Math_fround(f134 - Math_fround(f133 * f135));
 f135 = Math_fround(f136 - Math_fround(f130 * f135));
 HEAPF32[i121 >> 2] = i108 | 0 ? f131 : f132;
 HEAPF32[i121 + 4 >> 2] = i109 | 0 ? f133 : f134;
 HEAPF32[i121 + 8 >> 2] = i127 | 0 ? f135 : f136;
 HEAPF32[i121 + 12 >> 2] = Math_fround(0.0);
 i127 = 1;
 STACKTOP = i124;
 return i127 | 0;
}

function __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i9, i12) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i13 = i14 + 4 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i12, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i9, 1); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 16 | 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405573 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405589 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405597 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405614 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405631 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 36 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405646 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405661 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 78; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 78; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 78) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405683 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 89; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 89; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i9 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405703 | 0, HEAP32[gb + 37324 >> 2] | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405723 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 106; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 106; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 106) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405736 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 117; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 117; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 117) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405751 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 128; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 128; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 128) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405771 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 139; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 139; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 139) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 80 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405784 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  L199 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L199;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 81 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405798 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  L211 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L211;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 82 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405813 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  L223 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L223;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 83 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405838 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  L235 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L235;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405867 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i4 >>> 0) i10 = 186; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 186;
     break;
    }
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 186) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405878 | 0, i7, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 197; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 197;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 197) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405886 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 208; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 208;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 208) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405902 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 219; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 219;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 219) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405924 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 230; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 230;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 230) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405945 | 0, i8, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i9 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i9 >>> 0) i10 = 241; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 241;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 241) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 1) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 405967 | 0, i6, i11, 0) | 0;
 if (!i1) i1 = 0; else {
  L340 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i11 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i11 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i13 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = i3;
    break L340;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i13, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i13 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP8[i13 >> 0] | 0;
 }
 HEAP32[i5 >> 2] = i1 & 255;
 STACKTOP = i14;
 return;
}

function __ZN5physx21PxcArticulationHelper22setupSolverConstraintsERNS_9PxcFsDataEjRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPKNS_19PxsArticulationLinkEPKNS_30PxcArticulationJointTransformsEfRjRNS_25PxsConstraintBlockManagerE(i83, i1, i86, i80, i85, i84, f81, i78, i79) {
 i83 = i83 | 0;
 i1 = i1 | 0;
 i86 = i86 | 0;
 i80 = i80 | 0;
 i85 = i85 | 0;
 i84 = i84 | 0;
 f81 = Math_fround(f81);
 i78 = i78 | 0;
 i79 = i79 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i82 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i91 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i91 + 32 | 0;
 i69 = i91;
 i87 = i91 + 96 | 0;
 i82 = i91 + 80 | 0;
 i88 = i91 + 68 | 0;
 i89 = i91 + 64 | 0;
 HEAP32[i78 >> 2] = 0;
 i72 = HEAP16[i83 + 8 >> 1] | 0;
 f73 = Math_fround(Math_fround(1.0) / f81);
 if ((i72 & 65535) <= 1) {
  i90 = 0;
  STACKTOP = i91;
  return i90 | 0;
 }
 i74 = i72 & 65535;
 i75 = i87 + 4 | 0;
 i76 = i87 + 8 | 0;
 i77 = i87 + 12 | 0;
 i70 = i82 + 4 | 0;
 i71 = i82 + 8 | 0;
 i27 = i1 & 65535;
 i28 = i88 + 4 | 0;
 i29 = i88 + 8 | 0;
 i30 = i68 + 16 | 0;
 i31 = i68 + 20 | 0;
 i32 = i68 + 24 | 0;
 i33 = i68 + 28 | 0;
 i34 = i69 + 16 | 0;
 i35 = i69 + 20 | 0;
 i36 = i69 + 24 | 0;
 i37 = i69 + 28 | 0;
 i38 = i68 + 16 | 0;
 i39 = i68 + 20 | 0;
 i40 = i68 + 24 | 0;
 i41 = i68 + 28 | 0;
 i42 = i69 + 4 | 0;
 i43 = i69 + 8 | 0;
 i44 = i69 + 12 | 0;
 i45 = i69 + 16 | 0;
 i46 = i69 + 20 | 0;
 i47 = i69 + 24 | 0;
 i48 = i69 + 28 | 0;
 f49 = Math_fround(f81 * f81);
 i50 = i68 + 16 | 0;
 i51 = i68 + 20 | 0;
 i52 = i68 + 24 | 0;
 i53 = i68 + 28 | 0;
 i54 = i69 + 16 | 0;
 i55 = i69 + 20 | 0;
 i56 = i69 + 24 | 0;
 i57 = i69 + 28 | 0;
 i58 = i68 + 16 | 0;
 i59 = i68 + 20 | 0;
 i60 = i68 + 24 | 0;
 i61 = i68 + 28 | 0;
 i62 = i69 + 16 | 0;
 i63 = i69 + 20 | 0;
 i64 = i69 + 24 | 0;
 i65 = i69 + 28 | 0;
 i66 = i86 + 4 | 0;
 i26 = i86 + 8 | 0;
 i20 = 0;
 i67 = 1;
 while (1) {
  i24 = HEAP32[i85 + (i67 << 5) + 24 >> 2] | 0;
  i25 = i67;
  i67 = i67 + 1 | 0;
  if (i67 >>> 0 < i74 >>> 0) {
   i3 = HEAP32[i85 + (i67 << 5) + 24 >> 2] | 0;
   i2 = i3;
   i17 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
   i18 = getTempRet0() | 0;
   i2 = _i64Add(i2 | 0, 0, 171, 0) | 0;
   i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
   i1 = getTempRet0() | 0;
   i18 = _i64Subtract(1, 0, i17 | 0, i18 | 0) | 0;
   i1 = _i64Add(i18 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
   i2 = getTempRet0() | 0;
   while (1) {
    i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
    i2 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
   }
   i3 = i84 + (i67 * 84 | 0) | 0;
   i2 = i3;
   i17 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
   i18 = getTempRet0() | 0;
   i2 = _i64Add(i2 | 0, 0, 83, 0) | 0;
   i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
   i1 = getTempRet0() | 0;
   i18 = _i64Subtract(1, 0, i17 | 0, i18 | 0) | 0;
   i1 = _i64Add(i18 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
   i2 = getTempRet0() | 0;
   while (1) {
    i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
    i2 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
   }
  }
  i8 = i24 + 144 | 0;
  if (!(HEAP8[i8 >> 0] | 0)) if (!(HEAP8[i24 + 120 >> 0] | 0)) i1 = i20; else i90 = 10; else i90 = 10;
  if ((i90 | 0) == 10) {
   i90 = 0;
   f4 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 56 >> 2]);
   i18 = f4 != Math_fround(0.0);
   f5 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 68 >> 2]);
   if (i18) {
    f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(0.0)) + Math_fround(f5 * f5)))));
    f21 = Math_fround(f4 * f23);
    f22 = Math_fround(f23 * Math_fround(0.0));
    f23 = Math_fround(f5 * f23);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i1 = 0;
    i2 = 0;
    i3 = 1065353216;
   }
   f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f92 = Math_fround(-f7);
   f95 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f11 = Math_fround(f5 * f92);
   f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f11 + Math_fround(f6 * f4));
   f22 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 60 >> 2]);
   f23 = Math_fround(f22 * f95);
   f11 = Math_fround(f11 + f23);
   f93 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 64 >> 2]);
   f19 = Math_fround(f93 * f95);
   f94 = Math_fround(f5 * f95);
   f95 = Math_fround(f4 * f95);
   f21 = Math_fround(Math_fround(Math_fround(f94 + Math_fround(f6 * f22)) + Math_fround(f93 * f92)) - f95);
   f22 = Math_fround(Math_fround(f95 + Math_fround(f94 + Math_fround(f6 * f93))) - Math_fround(f22 * f92));
   f23 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f5) - Math_fround(f4 * f92)) - f23) - f19);
   HEAPF32[i87 >> 2] = Math_fround(f11 - f19);
   HEAPF32[i75 >> 2] = f21;
   HEAPF32[i76 >> 2] = f22;
   HEAPF32[i77 >> 2] = f23;
   i17 = HEAP32[i24 + 152 >> 2] | 0;
   i18 = HEAP32[i24 + 156 >> 2] | 0;
   HEAP32[i82 >> 2] = HEAP32[i24 + 148 >> 2];
   HEAP32[i70 >> 2] = i17;
   HEAP32[i71 >> 2] = i18;
   HEAPF32[i89 >> 2] = Math_fround(0.0);
   if (!(HEAP8[i24 + 120 >> 0] | 0)) {
    i12 = 0;
    i13 = 0;
   } else if (__ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf(i82, i87, i88, i89) | 0) if (Math_fround(HEAPF32[i24 + 124 >> 2]) > Math_fround(0.0)) {
    i12 = 1;
    i13 = 1;
   } else {
    i12 = 1;
    i13 = Math_fround(HEAPF32[i24 + 128 >> 2]) > Math_fround(0.0);
   } else {
    i12 = 0;
    i13 = 0;
   }
   f93 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 40 >> 2]);
   f92 = Math_fround(Math_fround(f93 * f93) + Math_fround(-.5));
   f94 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 28 >> 2]);
   f23 = Math_fround(f94 * Math_fround(2.0));
   f95 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 32 >> 2]);
   f22 = Math_fround(f95 * Math_fround(0.0));
   f23 = Math_fround(f23 + f22);
   f19 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 36 >> 2]);
   f21 = Math_fround(f19 * Math_fround(0.0));
   f23 = Math_fround(f23 + f21);
   f21 = Math_fround(Math_fround(f94 * f23) + Math_fround(Math_fround(f92 * Math_fround(2.0)) + Math_fround(f93 * Math_fround(f22 - f21))));
   f92 = Math_fround(f92 * Math_fround(0.0));
   f94 = Math_fround(f94 * Math_fround(0.0));
   f22 = Math_fround(Math_fround(f95 * f23) + Math_fround(f92 + Math_fround(f93 * Math_fround(Math_fround(f19 * Math_fround(2.0)) - f94))));
   f23 = Math_fround(Math_fround(f92 + Math_fround(f93 * Math_fround(f94 - Math_fround(f95 * Math_fround(2.0))))) + Math_fround(f19 * f23));
   f19 = Math_fround(f7 / Math_fround(f6 + Math_fround(1.0)));
   if (!(HEAP8[i8 >> 0] | 0)) {
    i14 = 0;
    i15 = 0;
   } else {
    f94 = Math_fround(HEAPF32[i24 + 164 >> 2]);
    f95 = Math_fround(HEAPF32[i24 + 168 >> 2]);
    i15 = f19 < Math_fround(Math_fround(f94 + f95) / Math_fround(Math_fround(1.0) - Math_fround(f94 * f95)));
    f94 = Math_fround(HEAPF32[i24 + 160 >> 2]);
    i14 = f19 > Math_fround(Math_fround(f94 - f95) / Math_fround(Math_fround(f94 * f95) + Math_fround(1.0)));
   }
   i16 = (i13 & 1) + (i12 & 1) + (i15 & 1) + (i14 & 1) | 0;
   i10 = i16 & 255;
   if (!(i10 << 24 >> 24)) i1 = i20; else {
    i1 = i20 + 1 | 0;
    HEAP32[i80 + (i20 << 5) >> 2] = i83;
    i17 = i85 + (i25 << 5) + 28 | 0;
    HEAP16[i80 + (i20 << 5) + 8 >> 1] = HEAP32[i17 >> 2];
    HEAP16[i80 + (i20 << 5) + 10 >> 1] = i27;
    HEAP32[i80 + (i20 << 5) + 4 >> 2] = i83;
    HEAP16[i80 + (i20 << 5) + 12 >> 1] = i25;
    HEAP16[i80 + (i20 << 5) + 14 >> 1] = i27;
    i2 = i16 * 176 | 0;
    i18 = i80 + (i20 << 5) + 26 | 0;
    HEAP16[i18 >> 1] = (i2 + 48 | 0) >>> 4;
    i2 = i2 + 79 & -16;
    do if (i2 >>> 0 > 16384) i2 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i86 >> 2] | 0, i2) | 0; else {
     i3 = HEAP32[i66 >> 2] | 0;
     if (i3 | 0) {
      i8 = HEAP32[i26 >> 2] | 0;
      i9 = i8 + i2 | 0;
      if (i9 >>> 0 <= 16384) {
       HEAP32[i26 >> 2] = i9;
       i2 = i3 + i8 | 0;
       break;
      }
     }
     i9 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i86 >> 2] | 0, i79) | 0;
     HEAP32[i66 >> 2] = i9;
     HEAP32[i26 >> 2] = i2;
     i2 = i9;
    } while (0);
    i8 = i80 + (i20 << 5) + 16 | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i80 + (i20 << 5) + 20 >> 2] = 0;
    i3 = i2 + 48 | 0;
    HEAP8[i2 >> 0] = 4;
    HEAP8[i2 + 1 >> 0] = i10;
    HEAP8[i2 + 2 >> 0] = 0;
    HEAP32[i2 + 32 >> 2] = 1065353216;
    HEAP32[i2 + 36 >> 2] = 1065353216;
    HEAPF32[i2 + 40 >> 2] = Math_fround(-1.0);
    HEAPF32[i2 + 44 >> 2] = Math_fround(-1.0);
    if (i12) {
     f95 = Math_fround(Math_fround(HEAPF32[i88 >> 2]) * Math_fround(2.0));
     f11 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(2.0));
     f97 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(2.0));
     f7 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 12 >> 2]);
     f96 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
     f94 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) >> 2]);
     f4 = Math_fround(f95 * f94);
     f92 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 4 >> 2]);
     f4 = Math_fround(f4 + Math_fround(f11 * f92));
     f93 = Math_fround(HEAPF32[i84 + (i25 * 84 | 0) + 8 >> 2]);
     f4 = Math_fround(f4 + Math_fround(f97 * f93));
     f5 = Math_fround(Math_fround(f94 * f4) + Math_fround(Math_fround(f95 * f96) + Math_fround(f7 * Math_fround(Math_fround(f97 * f92) - Math_fround(f11 * f93)))));
     f6 = Math_fround(Math_fround(f92 * f4) + Math_fround(Math_fround(f11 * f96) + Math_fround(f7 * Math_fround(Math_fround(f95 * f93) - Math_fround(f97 * f94)))));
     f4 = Math_fround(Math_fround(Math_fround(f97 * f96) + Math_fround(f7 * Math_fround(Math_fround(f11 * f94) - Math_fround(f95 * f92)))) + Math_fround(f93 * f4));
     f93 = Math_fround(HEAPF32[i89 >> 2]);
     HEAP32[i3 >> 2] = 0;
     HEAP32[i2 + 52 >> 2] = 0;
     HEAP32[i2 + 56 >> 2] = 0;
     HEAP32[i2 + 64 >> 2] = 0;
     HEAP32[i2 + 68 >> 2] = 0;
     HEAP32[i2 + 72 >> 2] = 0;
     HEAPF32[i2 + 80 >> 2] = f5;
     HEAPF32[i2 + 84 >> 2] = f6;
     HEAPF32[i2 + 88 >> 2] = f4;
     HEAPF32[i2 + 96 >> 2] = f5;
     HEAPF32[i2 + 100 >> 2] = f6;
     HEAPF32[i2 + 104 >> 2] = f4;
     HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + 148 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP32[i2 + 156 >> 2] = 0;
     HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
     i20 = HEAP32[i17 >> 2] | 0;
     HEAP32[i68 >> 2] = 0;
     HEAP32[i68 + 4 >> 2] = 0;
     HEAP32[i68 + 8 >> 2] = 0;
     HEAP32[i68 + 12 >> 2] = 0;
     HEAPF32[i30 >> 2] = f5;
     HEAPF32[i31 >> 2] = f6;
     HEAPF32[i32 >> 2] = f4;
     HEAPF32[i33 >> 2] = Math_fround(0.0);
     f92 = Math_fround(-f5);
     f95 = Math_fround(-f6);
     f94 = Math_fround(-f4);
     HEAP32[i69 >> 2] = 0;
     HEAP32[i69 + 4 >> 2] = 0;
     HEAP32[i69 + 8 >> 2] = 0;
     HEAP32[i69 + 12 >> 2] = 0;
     HEAPF32[i34 >> 2] = f92;
     HEAPF32[i35 >> 2] = f95;
     HEAPF32[i36 >> 2] = f94;
     HEAPF32[i37 >> 2] = Math_fround(0.0);
     __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i83, i20, i68, i2 + 160 | 0, i25, i69, i2 + 192 | 0);
     f94 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 176 >> 2]));
     f94 = Math_fround(f94 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 180 >> 2])));
     f94 = Math_fround(f94 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 184 >> 2])));
     f95 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 208 >> 2]));
     f95 = Math_fround(f95 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 212 >> 2])));
     f95 = Math_fround(f94 - Math_fround(f95 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 216 >> 2]))));
     i20 = f95 <= Math_fround(0.0);
     f95 = Math_fround(Math_fround(1.0) / f95);
     f95 = i20 ? Math_fround(0.0) : f95;
     f94 = Math_fround(-Math_fround(f73 * Math_fround(f93 * f95)));
     HEAPF32[i2 + 60 >> 2] = f94;
     i20 = f93 > Math_fround(0.0);
     HEAPF32[i2 + 76 >> 2] = i20 ? f94 : Math_fround(0.0);
     HEAPF32[i2 + 92 >> 2] = Math_fround(-f95);
     HEAPF32[i2 + 108 >> 2] = Math_fround(1.0);
     if (i13) {
      f11 = Math_fround(Math_fround(f22 * f4) - Math_fround(f23 * f6));
      f7 = Math_fround(Math_fround(f23 * f5) - Math_fround(f21 * f4));
      f4 = Math_fround(Math_fround(f21 * f6) - Math_fround(f22 * f5));
      f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f11 * f11) + Math_fround(f7 * f7)));
      if (f5 > Math_fround(0.0)) {
       f97 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
       f6 = Math_fround(f4 * f97);
       f5 = Math_fround(f7 * f97);
       f4 = Math_fround(f11 * f97);
      } else {
       f6 = Math_fround(0.0);
       f5 = Math_fround(0.0);
       f4 = Math_fround(0.0);
      }
      f97 = Math_fround(HEAPF32[i24 + 124 >> 2]);
      f95 = Math_fround(HEAPF32[i24 + 128 >> 2]);
      HEAP32[i2 + 224 >> 2] = 0;
      HEAP32[i2 + 228 >> 2] = 0;
      HEAP32[i2 + 232 >> 2] = 0;
      HEAP32[i2 + 240 >> 2] = 0;
      HEAP32[i2 + 244 >> 2] = 0;
      HEAP32[i2 + 248 >> 2] = 0;
      HEAPF32[i2 + 256 >> 2] = f4;
      HEAPF32[i2 + 260 >> 2] = f5;
      HEAPF32[i2 + 264 >> 2] = f6;
      HEAPF32[i2 + 272 >> 2] = f4;
      HEAPF32[i2 + 276 >> 2] = f5;
      HEAPF32[i2 + 280 >> 2] = f6;
      HEAPF32[i2 + 320 >> 2] = Math_fround(-3402823469999999843913219.0e14);
      HEAPF32[i2 + 324 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAP32[i2 + 332 >> 2] = 0;
      HEAPF32[i2 + 328 >> 2] = Math_fround(0.0);
      i20 = HEAP32[i17 >> 2] | 0;
      HEAP32[i68 >> 2] = 0;
      HEAP32[i68 + 4 >> 2] = 0;
      HEAP32[i68 + 8 >> 2] = 0;
      HEAP32[i68 + 12 >> 2] = 0;
      HEAPF32[i38 >> 2] = f4;
      HEAPF32[i39 >> 2] = f5;
      HEAPF32[i40 >> 2] = f6;
      HEAPF32[i41 >> 2] = Math_fround(0.0);
      f93 = Math_fround(-f4);
      f96 = Math_fround(-f5);
      f94 = Math_fround(-f6);
      HEAP32[i69 >> 2] = -2147483648;
      HEAP32[i42 >> 2] = -2147483648;
      HEAP32[i43 >> 2] = -2147483648;
      HEAPF32[i44 >> 2] = Math_fround(0.0);
      HEAPF32[i45 >> 2] = f93;
      HEAPF32[i46 >> 2] = f96;
      HEAPF32[i47 >> 2] = f94;
      HEAPF32[i48 >> 2] = Math_fround(0.0);
      __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i83, i20, i68, i2 + 336 | 0, i25, i69, i2 + 368 | 0);
      f94 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 352 >> 2]));
      f94 = Math_fround(f94 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 356 >> 2])));
      f94 = Math_fround(f94 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 360 >> 2])));
      f96 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 384 >> 2]));
      f96 = Math_fround(f96 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 388 >> 2])));
      f96 = Math_fround(f94 - Math_fround(f96 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 392 >> 2]))));
      i20 = f96 <= Math_fround(0.0);
      f96 = Math_fround(Math_fround(1.0) / f96);
      f96 = i20 ? Math_fround(0.0) : f96;
      f95 = Math_fround(Math_fround(f49 * f97) + Math_fround(f95 * f81));
      f97 = Math_fround(Math_fround(1.0) / Math_fround(f95 + Math_fround(1.0)));
      HEAPF32[i2 + 252 >> 2] = Math_fround(0.0);
      HEAPF32[i2 + 236 >> 2] = Math_fround(0.0);
      HEAPF32[i2 + 268 >> 2] = Math_fround(-Math_fround(f95 * Math_fround(f97 * f96)));
      HEAPF32[i2 + 284 >> 2] = Math_fround(Math_fround(1.0) - f97);
      i2 = 2;
     } else i2 = 1;
    } else i2 = 0;
    if (i14) {
     f95 = Math_fround(Math_fround(Math_fround(HEAPF32[i24 + 160 >> 2]) - f19) * Math_fround(4.0));
     HEAP32[i3 + (i2 * 176 | 0) >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 4 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 8 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 16 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 20 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 24 >> 2] = 0;
     HEAPF32[i3 + (i2 * 176 | 0) + 32 >> 2] = f21;
     HEAPF32[i3 + (i2 * 176 | 0) + 36 >> 2] = f22;
     HEAPF32[i3 + (i2 * 176 | 0) + 40 >> 2] = f23;
     HEAPF32[i3 + (i2 * 176 | 0) + 48 >> 2] = f21;
     HEAPF32[i3 + (i2 * 176 | 0) + 52 >> 2] = f22;
     HEAPF32[i3 + (i2 * 176 | 0) + 56 >> 2] = f23;
     HEAPF32[i3 + (i2 * 176 | 0) + 96 >> 2] = Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 100 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP32[i3 + (i2 * 176 | 0) + 108 >> 2] = 0;
     HEAPF32[i3 + (i2 * 176 | 0) + 104 >> 2] = Math_fround(0.0);
     i20 = HEAP32[i17 >> 2] | 0;
     HEAP32[i68 >> 2] = 0;
     HEAP32[i68 + 4 >> 2] = 0;
     HEAP32[i68 + 8 >> 2] = 0;
     HEAP32[i68 + 12 >> 2] = 0;
     HEAPF32[i50 >> 2] = f21;
     HEAPF32[i51 >> 2] = f22;
     HEAPF32[i52 >> 2] = f23;
     HEAPF32[i53 >> 2] = Math_fround(0.0);
     f94 = Math_fround(-f21);
     f97 = Math_fround(-f22);
     f96 = Math_fround(-f23);
     HEAP32[i69 >> 2] = 0;
     HEAP32[i69 + 4 >> 2] = 0;
     HEAP32[i69 + 8 >> 2] = 0;
     HEAP32[i69 + 12 >> 2] = 0;
     HEAPF32[i54 >> 2] = f94;
     HEAPF32[i55 >> 2] = f97;
     HEAPF32[i56 >> 2] = f96;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i83, i20, i68, i3 + (i2 * 176 | 0) + 112 | 0, i25, i69, i3 + (i2 * 176 | 0) + 144 | 0);
     f96 = Math_fround(f21 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 128 >> 2]));
     f96 = Math_fround(f96 + Math_fround(f22 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 132 >> 2])));
     f96 = Math_fround(f96 + Math_fround(f23 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 136 >> 2])));
     f97 = Math_fround(f21 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 160 >> 2]));
     f97 = Math_fround(f97 + Math_fround(f22 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 164 >> 2])));
     f97 = Math_fround(f96 - Math_fround(f97 + Math_fround(f23 * Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 168 >> 2]))));
     i20 = f97 <= Math_fround(0.0);
     f97 = Math_fround(Math_fround(1.0) / f97);
     f97 = i20 ? Math_fround(0.0) : f97;
     f96 = Math_fround(-Math_fround(f73 * Math_fround(f95 * f97)));
     HEAPF32[i3 + (i2 * 176 | 0) + 12 >> 2] = f96;
     i20 = f95 > Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 28 >> 2] = i20 ? f96 : Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 44 >> 2] = Math_fround(-f97);
     HEAPF32[i3 + (i2 * 176 | 0) + 60 >> 2] = Math_fround(1.0);
     i2 = i2 + 1 | 0;
    }
    if (i15) {
     f93 = Math_fround(-f21);
     f96 = Math_fround(-f22);
     f97 = Math_fround(-f23);
     f95 = Math_fround(Math_fround(Math_fround(HEAPF32[i24 + 164 >> 2]) - f19) * Math_fround(-4.0));
     HEAP32[i3 + (i2 * 176 | 0) >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 4 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 8 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 16 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 20 >> 2] = 0;
     HEAP32[i3 + (i2 * 176 | 0) + 24 >> 2] = 0;
     HEAPF32[i3 + (i2 * 176 | 0) + 32 >> 2] = f93;
     HEAPF32[i3 + (i2 * 176 | 0) + 36 >> 2] = f96;
     HEAPF32[i3 + (i2 * 176 | 0) + 40 >> 2] = f97;
     HEAPF32[i3 + (i2 * 176 | 0) + 48 >> 2] = f93;
     HEAPF32[i3 + (i2 * 176 | 0) + 52 >> 2] = f96;
     HEAPF32[i3 + (i2 * 176 | 0) + 56 >> 2] = f97;
     HEAPF32[i3 + (i2 * 176 | 0) + 96 >> 2] = Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 100 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP32[i3 + (i2 * 176 | 0) + 108 >> 2] = 0;
     HEAPF32[i3 + (i2 * 176 | 0) + 104 >> 2] = Math_fround(0.0);
     i24 = HEAP32[i17 >> 2] | 0;
     HEAP32[i68 >> 2] = 0;
     HEAP32[i68 + 4 >> 2] = 0;
     HEAP32[i68 + 8 >> 2] = 0;
     HEAP32[i68 + 12 >> 2] = 0;
     HEAPF32[i58 >> 2] = f93;
     HEAPF32[i59 >> 2] = f96;
     HEAPF32[i60 >> 2] = f97;
     HEAPF32[i61 >> 2] = Math_fround(0.0);
     HEAP32[i69 >> 2] = 0;
     HEAP32[i69 + 4 >> 2] = 0;
     HEAP32[i69 + 8 >> 2] = 0;
     HEAP32[i69 + 12 >> 2] = 0;
     HEAPF32[i62 >> 2] = f21;
     HEAPF32[i63 >> 2] = f22;
     HEAPF32[i64 >> 2] = f23;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i83, i24, i68, i3 + (i2 * 176 | 0) + 112 | 0, i25, i69, i3 + (i2 * 176 | 0) + 144 | 0);
     f94 = Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 128 >> 2]) * f93);
     f94 = Math_fround(f94 + Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 132 >> 2]) * f96));
     f94 = Math_fround(f94 + Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 136 >> 2]) * f97));
     f93 = Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 160 >> 2]) * f93);
     f96 = Math_fround(f93 + Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 164 >> 2]) * f96));
     f97 = Math_fround(f94 - Math_fround(f96 + Math_fround(Math_fround(HEAPF32[i3 + (i2 * 176 | 0) + 168 >> 2]) * f97)));
     i25 = f97 <= Math_fround(0.0);
     f97 = Math_fround(Math_fround(1.0) / f97);
     f97 = i25 ? Math_fround(0.0) : f97;
     f96 = Math_fround(-Math_fround(f73 * Math_fround(f95 * f97)));
     HEAPF32[i3 + (i2 * 176 | 0) + 12 >> 2] = f96;
     i25 = f95 > Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 28 >> 2] = i25 ? f96 : Math_fround(0.0);
     HEAPF32[i3 + (i2 * 176 | 0) + 44 >> 2] = Math_fround(-f97);
     HEAPF32[i3 + (i2 * 176 | 0) + 60 >> 2] = Math_fround(1.0);
    }
    HEAP8[(HEAP32[i8 >> 2] | 0) + (HEAPU16[i18 >> 1] << 4) >> 0] = 0;
    HEAP32[i78 >> 2] = (HEAP32[i78 >> 2] | 0) + i16;
   }
  }
  if ((i67 & 65535) << 16 >> 16 == i72 << 16 >> 16) break; else i20 = i1;
 }
 STACKTOP = i91;
 return i1 | 0;
}

function _unity_z_inflateBack(i46, i15, i20, i42, i43) {
 i46 = i46 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i48;
 if (!i46) {
  i47 = -2;
  STACKTOP = i48;
  return i47 | 0;
 }
 i40 = HEAP32[i46 + 28 >> 2] | 0;
 if (!i40) {
  i47 = -2;
  STACKTOP = i48;
  return i47 | 0;
 }
 i16 = i46 + 24 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i40 >> 2] = 11;
 i17 = i40 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i40 + 44 | 0;
 HEAP32[i18 >> 2] = 0;
 i41 = HEAP32[i46 >> 2] | 0;
 HEAP32[i47 >> 2] = i41;
 i45 = i46 + 4 | 0;
 if (!i41) i1 = 0; else i1 = HEAP32[i45 >> 2] | 0;
 i41 = i40 + 52 | 0;
 i19 = i40 + 40 | 0;
 i21 = i40 + 64 | 0;
 i22 = i40 + 84 | 0;
 i23 = i40 + 76 | 0;
 i24 = i40 + 72 | 0;
 i25 = i40 + 88 | 0;
 i26 = i40 + 80 | 0;
 i27 = i40 + 68 | 0;
 i28 = i40 + 96 | 0;
 i29 = i40 + 100 | 0;
 i30 = i40 + 92 | 0;
 i31 = i40 + 104 | 0;
 i32 = i40 + 1328 | 0;
 i33 = i40 + 108 | 0;
 i34 = i40 + 112 | 0;
 i35 = i40 + 752 | 0;
 i36 = i46 + 12 | 0;
 i37 = i46 + 16 | 0;
 i38 = i40 + 56 | 0;
 i39 = i40 + 60 | 0;
 i4 = 0;
 i6 = 0;
 i3 = HEAP32[i19 >> 2] | 0;
 i5 = HEAP32[i41 >> 2] | 0;
 i7 = 11;
 L10 : while (1) {
  L12 : while (1) {
   L14 : do switch (i7 | 0) {
   case 26:
    {
     i44 = 173;
     break L10;
    }
   case 27:
    {
     i2 = -3;
     i44 = 175;
     break L10;
    }
   case 11:
    {
     if (!(HEAP32[i17 >> 2] | 0)) {
      i44 = 10;
      break L12;
     }
     i7 = i4 & 7;
     HEAP32[i40 >> 2] = 26;
     i12 = i5;
     i13 = i3;
     i4 = i4 - i7 | 0;
     i6 = i6 >>> i7;
     i7 = 26;
     i5 = i12;
     i3 = i13;
     continue L12;
    }
   case 13:
    {
     i13 = i4 & 7;
     i6 = i6 >>> i13;
     i4 = i4 - i13 | 0;
     if (i4 >>> 0 < 32) do {
      if (!i1) {
       i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
       if (!i1) {
        i44 = 27;
        break L10;
       }
      }
      i1 = i1 + -1 | 0;
      i13 = HEAP32[i47 >> 2] | 0;
      HEAP32[i47 >> 2] = i13 + 1;
      i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
      i4 = i4 + 8 | 0;
     } while (i4 >>> 0 < 32);
     i7 = i6 & 65535;
     if ((i7 | 0) != (i6 >>> 16 ^ 65535 | 0)) {
      HEAP32[i16 >> 2] = gb + 362732;
      HEAP32[i40 >> 2] = 27;
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
     HEAP32[i21 >> 2] = i7;
     if (i7) {
      i4 = i5;
      while (1) {
       if (!i1) {
        i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
        if (!i1) {
         i44 = 34;
         break L10;
        }
       }
       if (!i3) {
        i4 = HEAP32[i41 >> 2] | 0;
        i3 = HEAP32[i19 >> 2] | 0;
        HEAP32[i18 >> 2] = i3;
        if (mftCall_iiii(i42 | 0, i43 | 0, i4 | 0, i3 | 0) | 0) {
         i2 = -5;
         i14 = i1;
         break L10;
        }
       }
       i13 = i7 >>> 0 > i1 >>> 0 ? i1 : i7;
       i13 = i13 >>> 0 > i3 >>> 0 ? i3 : i13;
       _memcpy(i4 | 0, HEAP32[i47 >> 2] | 0, i13 | 0) | 0;
       i1 = i1 - i13 | 0;
       HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + i13;
       i3 = i3 - i13 | 0;
       i4 = i4 + i13 | 0;
       i7 = (HEAP32[i21 >> 2] | 0) - i13 | 0;
       HEAP32[i21 >> 2] = i7;
       if (!i7) {
        i5 = i4;
        break;
       }
      }
     }
     HEAP32[i40 >> 2] = 11;
     i4 = 0;
     i6 = 0;
     i7 = 11;
     continue L12;
    }
   case 15:
    {
     if (i4 >>> 0 < 14) do {
      if (!i1) {
       i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
       if (!i1) {
        i44 = 41;
        break L10;
       }
      }
      i1 = i1 + -1 | 0;
      i13 = HEAP32[i47 >> 2] | 0;
      HEAP32[i47 >> 2] = i13 + 1;
      i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
      i4 = i4 + 8 | 0;
     } while (i4 >>> 0 < 14);
     i12 = (i6 & 31) + 257 | 0;
     HEAP32[i28 >> 2] = i12;
     i13 = (i6 >>> 5 & 31) + 1 | 0;
     HEAP32[i29 >> 2] = i13;
     i7 = (i6 >>> 10 & 15) + 4 | 0;
     HEAP32[i30 >> 2] = i7;
     i6 = i6 >>> 14;
     i4 = i4 + -14 | 0;
     if (i12 >>> 0 > 286 | i13 >>> 0 > 30) {
      HEAP32[i16 >> 2] = gb + 362761;
      HEAP32[i40 >> 2] = 27;
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
     HEAP32[i31 >> 2] = 0;
     i9 = i7;
     i7 = 0;
     do {
      if (i4 >>> 0 < 3) {
       if (!i1) {
        i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
        if (!i1) {
         i44 = 50;
         break L10;
        }
       }
       i9 = HEAP32[i47 >> 2] | 0;
       HEAP32[i47 >> 2] = i9 + 1;
       i1 = i1 + -1 | 0;
       i8 = i4 + 8 | 0;
       i6 = ((HEAPU8[i9 >> 0] | 0) << i4) + i6 | 0;
       i4 = HEAP32[i31 >> 2] | 0;
       i9 = HEAP32[i30 >> 2] | 0;
      } else {
       i8 = i4;
       i4 = i7;
      }
      i7 = i4 + 1 | 0;
      HEAP32[i31 >> 2] = i7;
      HEAP16[i40 + 112 + ((HEAPU16[gb + 222788 + (i4 << 1) >> 1] | 0) << 1) >> 1] = i6 & 7;
      i6 = i6 >>> 3;
      i4 = i8 + -3 | 0;
     } while (i7 >>> 0 < i9 >>> 0);
     if (i7 >>> 0 < 19) do {
      i13 = i7;
      i7 = i7 + 1 | 0;
      HEAP32[i31 >> 2] = i7;
      HEAP16[i40 + 112 + ((HEAPU16[gb + 222788 + (i13 << 1) >> 1] | 0) << 1) >> 1] = 0;
     } while ((i7 | 0) != 19);
     HEAP32[i33 >> 2] = i32;
     HEAP32[i23 >> 2] = i32;
     HEAP32[i22 >> 2] = 7;
     if (_inflate_table(0, i34, 19, i33, i22, i35) | 0) {
      HEAP32[i16 >> 2] = gb + 362797;
      HEAP32[i40 >> 2] = 27;
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
     HEAP32[i31 >> 2] = 0;
     i7 = HEAP32[i28 >> 2] | 0;
     L65 : do if ((HEAP32[i29 >> 2] | 0) != (0 - i7 | 0)) {
      L66 : while (1) {
       i10 = HEAP32[i22 >> 2] | 0;
       i9 = (1 << i10) + -1 & i6;
       i8 = HEAP32[i23 >> 2] | 0;
       i7 = i8 + (i9 << 2) + 2 | 0;
       i9 = HEAPU8[i8 + (i9 << 2) + 1 >> 0] | 0;
       if (i9 >>> 0 > i4 >>> 0) {
        i7 = i10;
        do {
         if (!i1) {
          i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
          if (!i1) {
           i44 = 61;
           break L10;
          }
          i7 = HEAP32[i22 >> 2] | 0;
          i8 = HEAP32[i23 >> 2] | 0;
         }
         i1 = i1 + -1 | 0;
         i10 = HEAP32[i47 >> 2] | 0;
         HEAP32[i47 >> 2] = i10 + 1;
         i6 = ((HEAPU8[i10 >> 0] | 0) << i4) + i6 | 0;
         i4 = i4 + 8 | 0;
         i10 = (1 << i7) + -1 & i6;
         i9 = HEAPU8[i8 + (i10 << 2) + 1 >> 0] | 0;
        } while (i9 >>> 0 > i4 >>> 0);
        i7 = i8 + (i10 << 2) + 2 | 0;
       }
       i7 = HEAP16[i7 >> 1] | 0;
       if ((i7 & 65535) < 16) {
        if (i4 >>> 0 < i9 >>> 0) do {
         if (!i1) {
          i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
          if (!i1) {
           i44 = 68;
           break L10;
          }
         }
         i1 = i1 + -1 | 0;
         i13 = HEAP32[i47 >> 2] | 0;
         HEAP32[i47 >> 2] = i13 + 1;
         i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
         i4 = i4 + 8 | 0;
        } while (i4 >>> 0 < i9 >>> 0);
        i13 = HEAP32[i31 >> 2] | 0;
        HEAP32[i31 >> 2] = i13 + 1;
        HEAP16[i40 + 112 + (i13 << 1) >> 1] = i7;
        i4 = i4 - i9 | 0;
        i6 = i6 >>> i9;
       } else {
        switch (i7 << 16 >> 16) {
        case 16:
         {
          i7 = i9 + 2 | 0;
          if (i4 >>> 0 < i7 >>> 0) do {
           if (!i1) {
            i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
            if (!i1) {
             i44 = 78;
             break L10;
            }
           }
           i1 = i1 + -1 | 0;
           i13 = HEAP32[i47 >> 2] | 0;
           HEAP32[i47 >> 2] = i13 + 1;
           i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
           i4 = i4 + 8 | 0;
          } while (i4 >>> 0 < i7 >>> 0);
          i7 = i6 >>> i9;
          i4 = i4 - i9 | 0;
          i6 = HEAP32[i31 >> 2] | 0;
          if (!i6) {
           i44 = 81;
           break L66;
          }
          i10 = HEAPU16[i40 + 112 + (i6 + -1 << 1) >> 1] | 0;
          i4 = i4 + -2 | 0;
          i6 = i7 >>> 2;
          i7 = (i7 & 3) + 3 | 0;
          break;
         }
        case 17:
         {
          i7 = i9 + 3 | 0;
          if (i4 >>> 0 < i7 >>> 0) do {
           if (!i1) {
            i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
            if (!i1) {
             i44 = 85;
             break L10;
            }
           }
           i1 = i1 + -1 | 0;
           i13 = HEAP32[i47 >> 2] | 0;
           HEAP32[i47 >> 2] = i13 + 1;
           i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
           i4 = i4 + 8 | 0;
          } while (i4 >>> 0 < i7 >>> 0);
          i7 = i6 >>> i9;
          i10 = 0;
          i4 = -3 - i9 + i4 | 0;
          i6 = i7 >>> 3;
          i7 = (i7 & 7) + 3 | 0;
          break;
         }
        default:
         {
          i7 = i9 + 7 | 0;
          if (i4 >>> 0 < i7 >>> 0) do {
           if (!i1) {
            i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
            if (!i1) {
             i44 = 90;
             break L10;
            }
           }
           i1 = i1 + -1 | 0;
           i13 = HEAP32[i47 >> 2] | 0;
           HEAP32[i47 >> 2] = i13 + 1;
           i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
           i4 = i4 + 8 | 0;
          } while (i4 >>> 0 < i7 >>> 0);
          i7 = i6 >>> i9;
          i10 = 0;
          i4 = -7 - i9 + i4 | 0;
          i6 = i7 >>> 7;
          i7 = (i7 & 127) + 11 | 0;
         }
        }
        i8 = HEAP32[i31 >> 2] | 0;
        if ((i8 + i7 | 0) >>> 0 > ((HEAP32[i29 >> 2] | 0) + (HEAP32[i28 >> 2] | 0) | 0) >>> 0) {
         i44 = 95;
         break;
        }
        i9 = i10 & 65535;
        i7 = i7 + -1 | 0;
        HEAP32[i31 >> 2] = i8 + 1;
        HEAP16[i40 + 112 + (i8 << 1) >> 1] = i9;
        if (i7) do {
         i13 = HEAP32[i31 >> 2] | 0;
         i7 = i7 + -1 | 0;
         HEAP32[i31 >> 2] = i13 + 1;
         HEAP16[i40 + 112 + (i13 << 1) >> 1] = i9;
        } while ((i7 | 0) != 0);
       }
       i7 = HEAP32[i28 >> 2] | 0;
       if ((HEAP32[i31 >> 2] | 0) >>> 0 >= ((HEAP32[i29 >> 2] | 0) + i7 | 0) >>> 0) break L65;
      }
      if ((i44 | 0) == 81) {
       i44 = 0;
       HEAP32[i16 >> 2] = gb + 362822;
       HEAP32[i40 >> 2] = 27;
       i12 = i5;
       i13 = i3;
       i6 = i7;
       i7 = 27;
       i5 = i12;
       i3 = i13;
       continue L12;
      } else if ((i44 | 0) == 95) {
       i44 = 0;
       HEAP32[i16 >> 2] = gb + 362822;
       HEAP32[i40 >> 2] = 27;
       i12 = i5;
       i13 = i3;
       i7 = 27;
       i5 = i12;
       i3 = i13;
       continue L12;
      }
     } while (0);
     if ((HEAP32[i40 >> 2] | 0) == 27) {
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
     HEAP32[i33 >> 2] = i32;
     HEAP32[i23 >> 2] = i32;
     HEAP32[i22 >> 2] = 9;
     if (_inflate_table(1, i34, i7, i33, i22, i35) | 0) {
      HEAP32[i16 >> 2] = gb + 362848;
      HEAP32[i40 >> 2] = 27;
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
     HEAP32[i26 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i25 >> 2] = 6;
     if (!(_inflate_table(2, i40 + 112 + (HEAP32[i28 >> 2] << 1) | 0, HEAP32[i29 >> 2] | 0, i33, i25, i35) | 0)) {
      HEAP32[i40 >> 2] = 18;
      break L14;
     } else {
      HEAP32[i16 >> 2] = gb + 362876;
      HEAP32[i40 >> 2] = 27;
      i12 = i5;
      i13 = i3;
      i7 = 27;
      i5 = i12;
      i3 = i13;
      continue L12;
     }
    }
   case 18:
    break;
   default:
    {
     i2 = -2;
     i14 = i1;
     break L10;
    }
   } while (0);
   if (i3 >>> 0 > 257 & i1 >>> 0 > 5) {
    i44 = 105;
    break;
   }
   i7 = HEAP32[i22 >> 2] | 0;
   i12 = (1 << i7) + -1 & i6;
   i8 = HEAP32[i23 >> 2] | 0;
   i11 = i8 + (i12 << 2) | 0;
   i9 = HEAP8[i8 + (i12 << 2) + 1 >> 0] | 0;
   i12 = i8 + (i12 << 2) + 2 | 0;
   i10 = i9 & 255;
   if (i10 >>> 0 > i4 >>> 0) {
    do {
     if (!i1) {
      i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
      if (!i1) {
       i44 = 111;
       break L10;
      }
      i7 = HEAP32[i22 >> 2] | 0;
      i8 = HEAP32[i23 >> 2] | 0;
     }
     i1 = i1 + -1 | 0;
     i12 = HEAP32[i47 >> 2] | 0;
     HEAP32[i47 >> 2] = i12 + 1;
     i6 = ((HEAPU8[i12 >> 0] | 0) << i4) + i6 | 0;
     i4 = i4 + 8 | 0;
     i12 = (1 << i7) + -1 & i6;
     i9 = HEAP8[i8 + (i12 << 2) + 1 >> 0] | 0;
     i10 = i9 & 255;
    } while (i10 >>> 0 > i4 >>> 0);
    i13 = i10;
    i11 = i8 + (i12 << 2) | 0;
    i7 = i8 + (i12 << 2) + 2 | 0;
   } else {
    i13 = i10;
    i7 = i12;
   }
   i7 = HEAP16[i7 >> 1] | 0;
   i11 = HEAP8[i11 >> 0] | 0;
   i10 = i11 & 255;
   if (i11 << 24 >> 24 != 0 & (i10 & 240 | 0) == 0) {
    i11 = i7 & 65535;
    i10 = (1 << i13 + i10) + -1 | 0;
    i7 = ((i6 & i10) >>> i13) + i11 | 0;
    i9 = HEAP8[i8 + (i7 << 2) + 1 >> 0] | 0;
    if (((i9 & 255) + i13 | 0) >>> 0 > i4 >>> 0) do {
     if (!i1) {
      i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
      if (!i1) {
       i44 = 119;
       break L10;
      }
      i8 = HEAP32[i23 >> 2] | 0;
     }
     i1 = i1 + -1 | 0;
     i7 = HEAP32[i47 >> 2] | 0;
     HEAP32[i47 >> 2] = i7 + 1;
     i6 = ((HEAPU8[i7 >> 0] | 0) << i4) + i6 | 0;
     i4 = i4 + 8 | 0;
     i7 = ((i6 & i10) >>> i13) + i11 | 0;
     i9 = HEAP8[i8 + (i7 << 2) + 1 >> 0] | 0;
    } while (((i9 & 255) + i13 | 0) >>> 0 > i4 >>> 0);
    i4 = i4 - i13 | 0;
    i6 = i6 >>> i13;
    i11 = HEAP8[i8 + (i7 << 2) >> 0] | 0;
    i7 = HEAP16[i8 + (i7 << 2) + 2 >> 1] | 0;
   }
   i8 = i9 & 255;
   i6 = i6 >>> i8;
   i4 = i4 - i8 | 0;
   i7 = i7 & 65535;
   HEAP32[i21 >> 2] = i7;
   i8 = i11 & 255;
   if (!(i11 << 24 >> 24)) {
    if (!i3) {
     i5 = HEAP32[i41 >> 2] | 0;
     i3 = HEAP32[i19 >> 2] | 0;
     HEAP32[i18 >> 2] = i3;
     if (mftCall_iiii(i42 | 0, i43 | 0, i5 | 0, i3 | 0) | 0) {
      i2 = -5;
      i44 = 175;
      break L10;
     }
     i7 = HEAP32[i21 >> 2] | 0;
    }
    HEAP8[i5 >> 0] = i7;
    HEAP32[i40 >> 2] = 18;
    i3 = i3 + -1 | 0;
    i5 = i5 + 1 | 0;
    i7 = 18;
    continue;
   }
   if (i8 & 32 | 0) {
    HEAP32[i40 >> 2] = 11;
    i12 = i5;
    i13 = i3;
    i7 = 11;
    i5 = i12;
    i3 = i13;
    continue;
   }
   if (i8 & 64 | 0) {
    HEAP32[i16 >> 2] = gb + 362898;
    HEAP32[i40 >> 2] = 27;
    i12 = i5;
    i13 = i3;
    i7 = 27;
    i5 = i12;
    i3 = i13;
    continue;
   }
   i8 = i8 & 15;
   HEAP32[i24 >> 2] = i8;
   if (i8) {
    if (i4 >>> 0 < i8 >>> 0) {
     i7 = i8;
     do {
      if (!i1) {
       i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
       if (!i1) {
        i44 = 136;
        break L10;
       }
       i7 = HEAP32[i24 >> 2] | 0;
      }
      i1 = i1 + -1 | 0;
      i13 = HEAP32[i47 >> 2] | 0;
      HEAP32[i47 >> 2] = i13 + 1;
      i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
      i4 = i4 + 8 | 0;
     } while (i4 >>> 0 < i7 >>> 0);
     i8 = i7;
     i7 = HEAP32[i21 >> 2] | 0;
    }
    HEAP32[i21 >> 2] = i7 + ((1 << i8) + -1 & i6);
    i4 = i4 - i8 | 0;
    i6 = i6 >>> i8;
   }
   i7 = HEAP32[i25 >> 2] | 0;
   i9 = (1 << i7) + -1 & i6;
   i8 = HEAP32[i26 >> 2] | 0;
   i11 = i8 + (i9 << 2) | 0;
   i12 = HEAP8[i8 + (i9 << 2) + 1 >> 0] | 0;
   i9 = i8 + (i9 << 2) + 2 | 0;
   i10 = i12 & 255;
   if (i10 >>> 0 > i4 >>> 0) {
    do {
     if (!i1) {
      i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
      if (!i1) {
       i44 = 144;
       break L10;
      }
      i7 = HEAP32[i25 >> 2] | 0;
      i8 = HEAP32[i26 >> 2] | 0;
     }
     i1 = i1 + -1 | 0;
     i12 = HEAP32[i47 >> 2] | 0;
     HEAP32[i47 >> 2] = i12 + 1;
     i6 = ((HEAPU8[i12 >> 0] | 0) << i4) + i6 | 0;
     i4 = i4 + 8 | 0;
     i12 = (1 << i7) + -1 & i6;
     i10 = HEAP8[i8 + (i12 << 2) + 1 >> 0] | 0;
     i9 = i10 & 255;
    } while (i9 >>> 0 > i4 >>> 0);
    i13 = i9;
    i11 = i8 + (i12 << 2) | 0;
    i7 = i10;
    i9 = i8 + (i12 << 2) + 2 | 0;
   } else {
    i13 = i10;
    i7 = i12;
   }
   i9 = HEAP16[i9 >> 1] | 0;
   i11 = HEAP8[i11 >> 0] | 0;
   i10 = i11 & 255;
   if (!(i10 & 240)) {
    i11 = i9 & 65535;
    i10 = (1 << i13 + i10) + -1 | 0;
    i9 = ((i6 & i10) >>> i13) + i11 | 0;
    i7 = HEAP8[i8 + (i9 << 2) + 1 >> 0] | 0;
    if (((i7 & 255) + i13 | 0) >>> 0 > i4 >>> 0) do {
     if (!i1) {
      i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
      if (!i1) {
       i44 = 152;
       break L10;
      }
      i8 = HEAP32[i26 >> 2] | 0;
     }
     i1 = i1 + -1 | 0;
     i9 = HEAP32[i47 >> 2] | 0;
     HEAP32[i47 >> 2] = i9 + 1;
     i6 = ((HEAPU8[i9 >> 0] | 0) << i4) + i6 | 0;
     i4 = i4 + 8 | 0;
     i9 = ((i6 & i10) >>> i13) + i11 | 0;
     i7 = HEAP8[i8 + (i9 << 2) + 1 >> 0] | 0;
    } while (((i7 & 255) + i13 | 0) >>> 0 > i4 >>> 0);
    i4 = i4 - i13 | 0;
    i6 = i6 >>> i13;
    i11 = HEAP8[i8 + (i9 << 2) >> 0] | 0;
    i9 = HEAP16[i8 + (i9 << 2) + 2 >> 1] | 0;
   }
   i8 = i7 & 255;
   i6 = i6 >>> i8;
   i4 = i4 - i8 | 0;
   i8 = i11 & 255;
   if (i8 & 64 | 0) {
    HEAP32[i16 >> 2] = gb + 362926;
    HEAP32[i40 >> 2] = 27;
    i12 = i5;
    i13 = i3;
    i7 = 27;
    i5 = i12;
    i3 = i13;
    continue;
   }
   i7 = i9 & 65535;
   HEAP32[i27 >> 2] = i7;
   i8 = i8 & 15;
   HEAP32[i24 >> 2] = i8;
   if (i8) {
    if (i4 >>> 0 < i8 >>> 0) {
     i7 = i8;
     do {
      if (!i1) {
       i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
       if (!i1) {
        i44 = 162;
        break L10;
       }
       i7 = HEAP32[i24 >> 2] | 0;
      }
      i1 = i1 + -1 | 0;
      i13 = HEAP32[i47 >> 2] | 0;
      HEAP32[i47 >> 2] = i13 + 1;
      i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
      i4 = i4 + 8 | 0;
     } while (i4 >>> 0 < i7 >>> 0);
     i8 = i7;
     i7 = HEAP32[i27 >> 2] | 0;
    }
    i7 = i7 + ((1 << i8) + -1 & i6) | 0;
    HEAP32[i27 >> 2] = i7;
    i4 = i4 - i8 | 0;
    i6 = i6 >>> i8;
   }
   i13 = HEAP32[i19 >> 2] | 0;
   if (i7 >>> 0 <= (i13 - ((HEAP32[i18 >> 2] | 0) >>> 0 < i13 >>> 0 ? i3 : 0) | 0) >>> 0) {
    i44 = 168;
    break;
   }
   HEAP32[i16 >> 2] = gb + 362948;
   HEAP32[i40 >> 2] = 27;
   i12 = i5;
   i13 = i3;
   i7 = 27;
   i5 = i12;
   i3 = i13;
  }
  if ((i44 | 0) == 10) {
   i44 = 0;
   if (i4 >>> 0 < 3) {
    if (!i1) {
     i1 = mftCall_iii(i15 | 0, i20 | 0, i47 | 0) | 0;
     if (!i1) {
      i44 = 14;
      break;
     }
    }
    i13 = HEAP32[i47 >> 2] | 0;
    HEAP32[i47 >> 2] = i13 + 1;
    i7 = i4 + 8 | 0;
    i6 = ((HEAPU8[i13 >> 0] | 0) << i4) + i6 | 0;
    i1 = i1 + -1 | 0;
   } else i7 = i4;
   HEAP32[i17 >> 2] = i6 & 1;
   switch (i6 >>> 1 & 3) {
   case 0:
    {
     HEAP32[i40 >> 2] = 13;
     break;
    }
   case 1:
    {
     HEAP32[i23 >> 2] = gb + 220612;
     HEAP32[i22 >> 2] = 9;
     HEAP32[i26 >> 2] = gb + 222660;
     HEAP32[i25 >> 2] = 5;
     HEAP32[i40 >> 2] = 18;
     break;
    }
   case 2:
    {
     HEAP32[i40 >> 2] = 15;
     break;
    }
   case 3:
    {
     HEAP32[i16 >> 2] = gb + 362713;
     HEAP32[i40 >> 2] = 27;
     break;
    }
   default:
    {
     i44 = 21;
     break L10;
    }
   }
   i4 = i7 + -3 | 0;
   i6 = i6 >>> 3;
  } else if ((i44 | 0) == 105) {
   i44 = 0;
   HEAP32[i36 >> 2] = i5;
   HEAP32[i37 >> 2] = i3;
   HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i45 >> 2] = i1;
   HEAP32[i38 >> 2] = i6;
   HEAP32[i39 >> 2] = i4;
   i1 = HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i18 >> 2] | 0) >>> 0 < i1 >>> 0) HEAP32[i18 >> 2] = i1 - i3;
   _inflate_fast(i46, i1);
   i5 = HEAP32[i36 >> 2] | 0;
   i3 = HEAP32[i37 >> 2] | 0;
   HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
   i4 = HEAP32[i39 >> 2] | 0;
   i6 = HEAP32[i38 >> 2] | 0;
   i1 = HEAP32[i45 >> 2] | 0;
  } else if ((i44 | 0) == 168) while (1) {
   i44 = 0;
   if (!i3) {
    i5 = HEAP32[i41 >> 2] | 0;
    i3 = HEAP32[i19 >> 2] | 0;
    HEAP32[i18 >> 2] = i3;
    if (mftCall_iiii(i42 | 0, i43 | 0, i5 | 0, i3 | 0) | 0) {
     i2 = -5;
     i14 = i1;
     break L10;
    }
   }
   i8 = HEAP32[i27 >> 2] | 0;
   i9 = (HEAP32[i19 >> 2] | 0) - i8 | 0;
   i13 = i3 >>> 0 > i9 >>> 0;
   i7 = i3 - (i13 ? i9 : 0) | 0;
   i12 = HEAP32[i21 >> 2] | 0;
   i7 = i7 >>> 0 > i12 >>> 0 ? i12 : i7;
   HEAP32[i21 >> 2] = i12 - i7;
   i8 = i5 + (i13 ? i9 : 0 - i8 | 0) | 0;
   i9 = i7;
   while (1) {
    i13 = i5;
    i5 = i5 + 1 | 0;
    HEAP8[i13 >> 0] = HEAP8[i8 >> 0] | 0;
    i9 = i9 + -1 | 0;
    if (!i9) break; else i8 = i8 + 1 | 0;
   }
   i3 = i3 - i7 | 0;
   if (!(HEAP32[i21 >> 2] | 0)) break; else i44 = 168;
  }
  i7 = HEAP32[i40 >> 2] | 0;
 }
 switch (i44 | 0) {
 case 14:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 21:
  break;
 case 27:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 34:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 41:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 50:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 61:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 68:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 78:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 85:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 90:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 111:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 119:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 136:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 144:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 152:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 162:
  {
   HEAP32[i47 >> 2] = 0;
   i2 = -5;
   i14 = 0;
   break;
  }
 case 173:
  {
   i2 = HEAP32[i19 >> 2] | 0;
   if (i2 >>> 0 > i3 >>> 0) {
    i2 = (mftCall_iiii(i42 | 0, i43 | 0, HEAP32[i41 >> 2] | 0, i2 - i3 | 0) | 0) == 0;
    i2 = i2 ? 1 : -5;
    i14 = i1;
   } else {
    i2 = 1;
    i14 = i1;
   }
   break;
  }
 case 175:
  {
   i14 = i1;
   break;
  }
 }
 HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i45 >> 2] = i14;
 i47 = i2;
 STACKTOP = i48;
 return i47 | 0;
}

function __ZN5physx2Gu22pcmContactSphereConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i31, i4, i5, i3, i1, i47) {
 i2 = i2 | 0;
 i31 = i31 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i47 = i47 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i56 + 640 | 0;
 i55 = i56 + 560 | 0;
 i34 = i56 + 336 | 0;
 i32 = i56 + 736 | 0;
 i48 = i56 + 176 | 0;
 i53 = i56 + 144 | 0;
 i54 = i56 + 112 | 0;
 i30 = i56 + 576 | 0;
 i7 = i56 + 96 | 0;
 i19 = i56 + 80 | 0;
 i39 = i56 + 64 | 0;
 i46 = i56 + 48 | 0;
 i50 = i56 + 32 | 0;
 i35 = i56 + 724 | 0;
 i52 = i56 + 16 | 0;
 i33 = i56;
 i49 = i56 + 352 | 0;
 i45 = i56 + 192 | 0;
 i37 = i56 + 712 | 0;
 i40 = i56 + 708 | 0;
 i41 = i56 + 696 | 0;
 i42 = i56 + 684 | 0;
 i44 = i56 + 672 | 0;
 i51 = i56 + 668 | 0;
 i9 = i56 + 656 | 0;
 i38 = HEAP32[i1 >> 2] | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i55 + 4 >> 2] = 0;
 HEAP32[i55 + 8 >> 2] = 0;
 HEAP32[i55 + 12 >> 2] = 0;
 i26 = i31 + 4 | 0;
 i27 = i31 + 8 | 0;
 i18 = HEAP32[i27 >> 2] | 0;
 i28 = i31 + 12 | 0;
 i17 = HEAP32[i28 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i26 >> 2];
 i8 = i34 + 4 | 0;
 HEAP32[i8 >> 2] = i18;
 i18 = i34 + 8 | 0;
 HEAP32[i18 >> 2] = i17;
 HEAPF32[i34 + 12 >> 2] = Math_fround(0.0);
 f36 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 HEAP32[i48 >> 2] = HEAP32[i3 >> 2];
 i17 = HEAP32[i31 + 36 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i25 = HEAP32[i4 + 8 >> 2] | 0;
 i24 = HEAP32[i4 + 12 >> 2] | 0;
 i69 = i4 + 16 | 0;
 i71 = HEAP32[i69 >> 2] | 0;
 i70 = HEAP32[i69 + 4 >> 2] | 0;
 i69 = HEAP32[i69 + 8 >> 2] | 0;
 HEAP32[i53 >> 2] = HEAP32[i4 >> 2];
 i2 = i53 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i53 + 8 | 0;
 HEAP32[i3 >> 2] = i25;
 i4 = i53 + 12 | 0;
 HEAP32[i4 >> 2] = i24;
 HEAP32[i53 + 16 >> 2] = i71;
 i24 = i53 + 20 | 0;
 HEAP32[i24 >> 2] = i70;
 i25 = i53 + 24 | 0;
 HEAP32[i25 >> 2] = i69;
 HEAPF32[i53 + 28 >> 2] = Math_fround(0.0);
 i74 = HEAP32[i5 >> 2] | 0;
 i73 = HEAP32[i5 + 4 >> 2] | 0;
 i72 = HEAP32[i5 + 8 >> 2] | 0;
 i23 = HEAP32[i5 + 12 >> 2] | 0;
 i5 = i5 + 16 | 0;
 i68 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i54 >> 2] = i74;
 i20 = i54 + 4 | 0;
 HEAP32[i20 >> 2] = i73;
 i21 = i54 + 8 | 0;
 HEAP32[i21 >> 2] = i72;
 i22 = i54 + 12 | 0;
 HEAP32[i22 >> 2] = i23;
 HEAP32[i54 + 16 >> 2] = i68;
 HEAP32[i54 + 20 >> 2] = i1;
 HEAP32[i54 + 24 >> 2] = i5;
 HEAPF32[i54 + 28 >> 2] = Math_fround(0.0);
 f57 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = (HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f61 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f57 = Math_fround(-f57);
 f65 = Math_fround(-f65);
 f16 = Math_fround(-f16);
 i23 = i53 + 16 | 0;
 f12 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f60 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f64 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f67 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f64 = Math_fround(f12 - f64);
 f67 = Math_fround(f60 - f67);
 f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f60 = Math_fround(Math_fround(f61 * f61) + Math_fround(-.5));
 f12 = Math_fround(Math_fround(Math_fround(f64 * f57) + Math_fround(f67 * f65)) + Math_fround(f6 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f12 * f57) + Math_fround(Math_fround(f60 * f64) + Math_fround(f61 * Math_fround(Math_fround(f6 * f65) - Math_fround(f67 * f16))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(f12 * f65) + Math_fround(Math_fround(f60 * f67) + Math_fround(f61 * Math_fround(Math_fround(f64 * f16) - Math_fround(f6 * f57))))) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f6) + Math_fround(f61 * Math_fround(Math_fround(f67 * f57) - Math_fround(f64 * f65)))) + Math_fround(f12 * f16)) * Math_fround(2.0));
 f64 = Math_fround(HEAPF32[i53 >> 2]);
 f67 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f60 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(Math_fround(f61 * f60) - Math_fround(Math_fround(Math_fround(f64 * f57) + Math_fround(f67 * f65)) + Math_fround(f6 * f16)));
 f14 = Math_fround(Math_fround(Math_fround(f6 * f65) - Math_fround(f67 * f16)) + Math_fround(Math_fround(f61 * f64) + Math_fround(f60 * f57)));
 f15 = Math_fround(Math_fround(Math_fround(f64 * f16) - Math_fround(f6 * f57)) + Math_fround(Math_fround(f61 * f67) + Math_fround(f60 * f65)));
 f16 = Math_fround(Math_fround(Math_fround(f67 * f57) - Math_fround(f64 * f65)) + Math_fround(Math_fround(f61 * f6) + Math_fround(f60 * f16)));
 HEAPF32[i30 + 48 >> 2] = f10;
 HEAPF32[i30 + 52 >> 2] = f11;
 HEAPF32[i30 + 56 >> 2] = f12;
 HEAPF32[i30 + 60 >> 2] = Math_fround(0.0);
 f60 = Math_fround(f14 + f14);
 f6 = Math_fround(f15 + f15);
 f61 = Math_fround(f16 + f16);
 f65 = Math_fround(f15 * f6);
 f64 = Math_fround(f16 * f61);
 f57 = Math_fround(f15 * f60);
 f67 = Math_fround(f16 * f60);
 f59 = Math_fround(f13 * f60);
 f66 = Math_fround(f16 * f6);
 f6 = Math_fround(f13 * f6);
 f61 = Math_fround(f13 * f61);
 f60 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f60));
 f63 = Math_fround(f57 + f61);
 f62 = Math_fround(f67 - f6);
 f61 = Math_fround(f57 - f61);
 f57 = Math_fround(f60 - f64);
 f58 = Math_fround(f66 + f59);
 f6 = Math_fround(f67 + f6);
 f59 = Math_fround(f66 - f59);
 f60 = Math_fround(f60 - f65);
 HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f65) - f64);
 HEAPF32[i30 + 4 >> 2] = f63;
 HEAPF32[i30 + 8 >> 2] = f62;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 16 >> 2] = f61;
 HEAPF32[i30 + 20 >> 2] = f57;
 HEAPF32[i30 + 24 >> 2] = f58;
 HEAPF32[i30 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 32 >> 2] = f6;
 HEAPF32[i30 + 36 >> 2] = f59;
 HEAPF32[i30 + 40 >> 2] = f60;
 HEAPF32[i30 + 44 >> 2] = Math_fround(0.0);
 f60 = Math_fround(HEAPF32[i17 + 52 >> 2]);
 f59 = Math_fround(HEAPF32[i17 + 56 >> 2]);
 f6 = Math_fround(HEAPF32[i17 + 60 >> 2]);
 f58 = Math_fround(HEAPF32[i34 >> 2]);
 f57 = Math_fround(HEAPF32[i8 >> 2]);
 f58 = Math_fround(f60 * f58);
 f57 = Math_fround(f59 * f57);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 f57 = f58 <= f57 ? f58 : f57;
 f6 = Math_fround((f57 <= f6 ? f57 : f6) * Math_fround(.25));
 i18 = i38 + 32 | 0;
 i8 = HEAP8[i18 >> 0] | 0;
 f6 = f6 > f36 ? f36 : f6;
 HEAPF32[i7 >> 2] = Math_fround(f6 * Math_fround(.0500000007));
 HEAPF32[i19 >> 2] = Math_fround(f36 + Math_fround(HEAPF32[i48 >> 2]));
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i38, i30, i7, i19);
 i8 = (HEAP8[i18 >> 0] | 0) == i8 << 24 >> 24;
 HEAP32[i39 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
 HEAP32[i46 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
 HEAP32[i50 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 i19 = i52 + 4 | 0;
 HEAP32[i19 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 if (i8) {
  i5 = HEAP8[i18 >> 0] | 0;
  i2 = i5 & 255;
  f63 = Math_fround(f6 * Math_fround(HEAPF32[gb + 105492 + (i2 << 2) >> 2]));
  i4 = i38 + 16 | 0;
  f67 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i38 + 20 | 0;
  f66 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = i38 + 24 | 0;
  f67 = Math_fround(f10 - f67);
  f66 = Math_fround(f11 - f66);
  f65 = Math_fround(f12 - Math_fround(HEAPF32[i1 >> 2]));
  f62 = Math_fround(-f67);
  f61 = Math_fround(-f66);
  f64 = Math_fround(-f65);
  f62 = f67 > f62 ? f67 : f62;
  f61 = f66 > f61 ? f66 : f61;
  f61 = f62 >= f61 ? f62 : f61;
  i7 = (f65 > f64 ? f65 : f64) >= Math_fround(0.0);
  f62 = i7 ? f62 : Math_fround(0.0);
  f64 = Math_fround(HEAPF32[gb + 105504 + (i2 << 2) >> 2]);
  f65 = Math_fround(HEAPF32[i38 >> 2]);
  i2 = i38 + 4 | 0;
  f66 = Math_fround(HEAPF32[i2 >> 2]);
  i7 = i38 + 8 | 0;
  f67 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i38 + 12 | 0;
  if ((f61 >= f62 ? f61 : f62) > f63 ? 1 : f64 > Math_fround(Math_fround(Math_fround(Math_fround(f14 * f65) + Math_fround(f15 * f66)) + Math_fround(f16 * f67)) + Math_fround(f13 * Math_fround(HEAPF32[i8 >> 2])))) {
   i9 = i2;
   i5 = i8;
   i2 = i38;
  } else {
   if (!(i5 << 24 >> 24)) {
    i74 = 0;
    STACKTOP = i56;
    return i74 | 0;
   }
   i73 = HEAP32[i38 + 44 >> 2] | 0;
   f66 = Math_fround(HEAPF32[i73 + 32 >> 2]);
   f60 = Math_fround(HEAPF32[i73 + 36 >> 2]);
   f64 = Math_fround(HEAPF32[i73 + 40 >> 2]);
   f67 = Math_fround(HEAPF32[i54 >> 2]);
   f65 = Math_fround(HEAPF32[i20 >> 2]);
   f57 = Math_fround(HEAPF32[i21 >> 2]);
   f59 = Math_fround(HEAPF32[i22 >> 2]);
   f63 = Math_fround(Math_fround(f59 * f59) + Math_fround(-.5));
   f58 = Math_fround(Math_fround(Math_fround(f66 * f67) + Math_fround(f60 * f65)) + Math_fround(f64 * f57));
   f61 = Math_fround(Math_fround(Math_fround(f67 * f58) + Math_fround(Math_fround(f59 * Math_fround(Math_fround(f64 * f65) - Math_fround(f60 * f57))) + Math_fround(f66 * f63))) * Math_fround(2.0));
   f62 = Math_fround(Math_fround(Math_fround(f65 * f58) + Math_fround(Math_fround(f59 * Math_fround(Math_fround(f66 * f57) - Math_fround(f64 * f67))) + Math_fround(f60 * f63))) * Math_fround(2.0));
   f63 = Math_fround(Math_fround(Math_fround(f57 * f58) + Math_fround(Math_fround(f59 * Math_fround(Math_fround(f60 * f67) - Math_fround(f66 * f65))) + Math_fround(f64 * f63))) * Math_fround(2.0));
   f64 = Math_fround(HEAPF32[i23 >> 2]);
   f65 = Math_fround(HEAPF32[i24 >> 2]);
   f64 = Math_fround(f64 - Math_fround(f36 * f61));
   f65 = Math_fround(f65 - Math_fround(f36 * f62));
   f66 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - Math_fround(f36 * f63));
   f67 = Math_fround(Math_fround(HEAPF32[i73 + 44 >> 2]) - f36);
   HEAPF32[i52 >> 2] = f67;
   HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i73 = i47 + 4096 | 0;
   i74 = HEAP32[i73 >> 2] | 0;
   HEAP32[i73 >> 2] = i74 + 1;
   i73 = i47 + (i74 << 6) | 0;
   HEAPF32[i73 >> 2] = f61;
   HEAPF32[i73 + 4 >> 2] = f62;
   HEAPF32[i73 + 8 >> 2] = f63;
   HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
   i73 = i47 + (i74 << 6) + 16 | 0;
   HEAPF32[i73 >> 2] = f64;
   HEAPF32[i73 + 4 >> 2] = f65;
   HEAPF32[i73 + 8 >> 2] = f66;
   HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i47 + (i74 << 6) + 12 >> 2] = f67;
   HEAP32[i47 + (i74 << 6) + 48 >> 2] = -1;
   HEAP32[i47 + (i74 << 6) + 52 >> 2] = -1;
   i74 = 1;
   STACKTOP = i56;
   return i74 | 0;
  }
 } else {
  i9 = i38 + 4 | 0;
  i7 = i38 + 8 | 0;
  i5 = i38 + 12 | 0;
  i4 = i38 + 16 | 0;
  i3 = i38 + 20 | 0;
  i1 = i38 + 24 | 0;
  i2 = i38;
 }
 HEAPF32[i2 >> 2] = f14;
 HEAPF32[i9 >> 2] = f15;
 HEAPF32[i7 >> 2] = f16;
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i1 >> 2] = f12;
 HEAPF32[i38 + 28 >> 2] = Math_fround(0.0);
 i71 = HEAP32[i31 + 20 >> 2] | 0;
 i74 = HEAP32[i31 + 24 >> 2] | 0;
 i72 = HEAP32[i31 + 28 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i31 + 16 >> 2];
 HEAP32[i33 + 4 >> 2] = i71;
 HEAP32[i33 + 8 >> 2] = i74;
 HEAP32[i33 + 12 >> 2] = i72;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i49, i17, i55, i34, i33);
 HEAPF32[i49 + 16 >> 2] = Math_fround(0.0);
 i72 = i49 + 20 | 0;
 HEAP32[i72 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i72 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i72 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 i72 = i30 + 48 | 0;
 i74 = i45 + 64 | 0;
 HEAP32[i45 + 80 >> 2] = 4;
 HEAPF32[i45 + 48 >> 2] = Math_fround(0.0);
 i71 = i45 + 96 | 0;
 i73 = i45 + 112 | 0;
 HEAP32[i45 >> 2] = HEAP32[i72 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i72 + 12 >> 2];
 HEAPF32[i45 + 128 >> 2] = f36;
 i70 = i45 + 132 | 0;
 HEAP32[i70 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i71 >> 2] = HEAP32[i72 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[i72 + 12 >> 2];
 HEAP32[i73 >> 2] = HEAP32[i72 >> 2];
 HEAP32[i73 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
 HEAP32[i73 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
 HEAP32[i73 + 12 >> 2] = HEAP32[i72 + 12 >> 2];
 HEAPF32[i45 + 16 >> 2] = f36;
 i73 = i45 + 20 | 0;
 HEAP32[i73 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i73 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i73 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAPF32[i45 + 32 >> 2] = f36;
 i73 = i45 + 36 | 0;
 HEAP32[i73 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i73 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i73 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i29 >> 2] = -1;
 HEAP32[i29 + 4 >> 2] = -1;
 HEAP32[i29 + 8 >> 2] = -1;
 HEAP32[i29 + 12 >> 2] = -1;
 HEAP32[i74 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
 if (Math_fround(HEAPF32[i26 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i27 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i28 >> 2]) == Math_fround(1.0)) {
  i2 = 1;
  i1 = __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i45, i49, i48, i39, i46, i50, i52, i38 + 34 | 0, i38 + 38 | 0, i38 + 33 | 0, 1) | 0;
 } else i43 = 8; else i43 = 8; else i43 = 8;
 if ((i43 | 0) == 8) {
  i2 = 0;
  i1 = __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i45, i49, i48, i39, i46, i50, i52, i38 + 34 | 0, i38 + 38 | 0, i38 + 33 | 0, 1) | 0;
 }
 L17 : do switch (i1 | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 1:
  {
   i73 = HEAP32[i38 + 44 >> 2] | 0;
   HEAP32[i73 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i73 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i73 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   HEAP32[i73 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
   i1 = i73 + 16 | 0;
   HEAP32[i1 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
   i1 = i50 + 4 | 0;
   i70 = HEAP32[i1 >> 2] | 0;
   i74 = i50 + 8 | 0;
   i71 = HEAP32[i74 >> 2] | 0;
   i72 = HEAP32[i52 >> 2] | 0;
   HEAP32[i73 + 32 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i73 + 36 >> 2] = i70;
   HEAP32[i73 + 40 >> 2] = i71;
   HEAP32[i73 + 44 >> 2] = i72;
   HEAP8[i18 >> 0] = 1;
   f60 = Math_fround(HEAPF32[i54 >> 2]);
   f66 = Math_fround(HEAPF32[i20 >> 2]);
   f64 = Math_fround(HEAPF32[i21 >> 2]);
   f59 = Math_fround(HEAPF32[i22 >> 2]);
   f65 = Math_fround(HEAPF32[i50 >> 2]);
   f67 = Math_fround(HEAPF32[i1 >> 2]);
   f58 = Math_fround(HEAPF32[i74 >> 2]);
   f57 = Math_fround(Math_fround(f59 * f59) + Math_fround(-.5));
   f63 = Math_fround(Math_fround(Math_fround(f60 * f65) + Math_fround(f66 * f67)) + Math_fround(f64 * f58));
   f61 = Math_fround(Math_fround(Math_fround(f60 * f63) + Math_fround(Math_fround(f65 * f57) + Math_fround(f59 * Math_fround(Math_fround(f66 * f58) - Math_fround(f64 * f67))))) * Math_fround(2.0));
   f62 = Math_fround(Math_fround(Math_fround(f66 * f63) + Math_fround(Math_fround(f57 * f67) + Math_fround(f59 * Math_fround(Math_fround(f64 * f65) - Math_fround(f60 * f58))))) * Math_fround(2.0));
   f63 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f58) + Math_fround(f59 * Math_fround(Math_fround(f60 * f67) - Math_fround(f66 * f65)))) + Math_fround(f64 * f63)) * Math_fround(2.0));
   f64 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - Math_fround(f36 * f61));
   f65 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - Math_fround(f36 * f62));
   f66 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - Math_fround(f36 * f63));
   f67 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f36);
   HEAPF32[i52 >> 2] = f67;
   HEAP32[i19 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   i74 = i47 + 4096 | 0;
   i1 = HEAP32[i74 >> 2] | 0;
   HEAP32[i74 >> 2] = i1 + 1;
   i74 = i47 + (i1 << 6) | 0;
   HEAPF32[i74 >> 2] = f61;
   HEAPF32[i74 + 4 >> 2] = f62;
   HEAPF32[i74 + 8 >> 2] = f63;
   HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
   i74 = i47 + (i1 << 6) + 16 | 0;
   HEAPF32[i74 >> 2] = f64;
   HEAPF32[i74 + 4 >> 2] = f65;
   HEAPF32[i74 + 8 >> 2] = f66;
   HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i47 + (i1 << 6) + 12 >> 2] = f67;
   HEAP32[i47 + (i1 << 6) + 48 >> 2] = -1;
   HEAP32[i47 + (i1 << 6) + 52 >> 2] = -1;
   i1 = 1;
   break;
  }
 case 3:
  {
   HEAP32[i40 >> 2] = 0;
   i1 = __ZN5physx2GuL34fullContactsGenerationSphereConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESB_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i45, i49, i53, i54, i47, i40, i47, i2, i38, i50, i48) | 0;
   break;
  }
 case 6:
  {
   if (i2) {
    HEAP32[i41 >> 2] = gb + 105536 + 8;
    HEAP32[i41 + 4 >> 2] = i45;
    HEAP32[i41 + 8 >> 2] = i49;
    i1 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i45, i49, i41, i38 + 34 | 0, i38 + 38 | 0, HEAP8[i38 + 33 >> 0] | 0, i39, i46, i50, i52, 1) | 0;
   } else {
    HEAP32[i42 >> 2] = gb + 84832 + 8;
    HEAP32[i42 + 4 >> 2] = i45;
    HEAP32[i42 + 8 >> 2] = i49;
    i1 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i45, i49, i42, i38 + 34 | 0, i38 + 38 | 0, HEAP8[i38 + 33 >> 0] | 0, i39, i46, i50, i52, 1) | 0;
   }
   if ((i1 | 0) == 6) {
    i73 = HEAP32[i38 + 44 >> 2] | 0;
    HEAP32[i73 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    HEAP32[i73 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
    i1 = i73 + 16 | 0;
    HEAP32[i1 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
    i1 = i50 + 4 | 0;
    i70 = HEAP32[i1 >> 2] | 0;
    i74 = i50 + 8 | 0;
    i71 = HEAP32[i74 >> 2] | 0;
    i72 = HEAP32[i52 >> 2] | 0;
    HEAP32[i73 + 32 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i73 + 36 >> 2] = i70;
    HEAP32[i73 + 40 >> 2] = i71;
    HEAP32[i73 + 44 >> 2] = i72;
    HEAP8[i18 >> 0] = 1;
    f60 = Math_fround(HEAPF32[i54 >> 2]);
    f66 = Math_fround(HEAPF32[i20 >> 2]);
    f64 = Math_fround(HEAPF32[i21 >> 2]);
    f59 = Math_fround(HEAPF32[i22 >> 2]);
    f65 = Math_fround(HEAPF32[i50 >> 2]);
    f67 = Math_fround(HEAPF32[i1 >> 2]);
    f58 = Math_fround(HEAPF32[i74 >> 2]);
    f57 = Math_fround(Math_fround(f59 * f59) + Math_fround(-.5));
    f63 = Math_fround(Math_fround(Math_fround(f60 * f65) + Math_fround(f66 * f67)) + Math_fround(f64 * f58));
    f61 = Math_fround(Math_fround(Math_fround(f60 * f63) + Math_fround(Math_fround(f65 * f57) + Math_fround(f59 * Math_fround(Math_fround(f66 * f58) - Math_fround(f64 * f67))))) * Math_fround(2.0));
    f62 = Math_fround(Math_fround(Math_fround(f66 * f63) + Math_fround(Math_fround(f57 * f67) + Math_fround(f59 * Math_fround(Math_fround(f64 * f65) - Math_fround(f60 * f58))))) * Math_fround(2.0));
    f63 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f58) + Math_fround(f59 * Math_fround(Math_fround(f60 * f67) - Math_fround(f66 * f65)))) + Math_fround(f64 * f63)) * Math_fround(2.0));
    f64 = Math_fround(HEAPF32[i23 >> 2]);
    f65 = Math_fround(HEAPF32[i24 >> 2]);
    f64 = Math_fround(f64 - Math_fround(f36 * f61));
    f65 = Math_fround(f65 - Math_fround(f36 * f62));
    f66 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - Math_fround(f36 * f63));
    f67 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f36);
    HEAPF32[i52 >> 2] = f67;
    HEAP32[i19 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
    i74 = i47 + 4096 | 0;
    i1 = HEAP32[i74 >> 2] | 0;
    HEAP32[i74 >> 2] = i1 + 1;
    i74 = i47 + (i1 << 6) | 0;
    HEAPF32[i74 >> 2] = f61;
    HEAPF32[i74 + 4 >> 2] = f62;
    HEAPF32[i74 + 8 >> 2] = f63;
    HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
    i74 = i47 + (i1 << 6) + 16 | 0;
    HEAPF32[i74 >> 2] = f64;
    HEAPF32[i74 + 4 >> 2] = f65;
    HEAPF32[i74 + 8 >> 2] = f66;
    HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i47 + (i1 << 6) + 12 >> 2] = f67;
    HEAP32[i47 + (i1 << 6) + 48 >> 2] = -1;
    HEAP32[i47 + (i1 << 6) + 52 >> 2] = -1;
    i1 = 1;
    break L17;
   } else {
    HEAP32[i51 >> 2] = 0;
    i1 = __ZN5physx2GuL34fullContactsGenerationSphereConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESB_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i45, i49, i53, i54, i47, i51, i47, i2, i38, i50, i48) | 0;
    break L17;
   }
  }
 default:
  {
   i74 = 0;
   STACKTOP = i56;
   return i74 | 0;
  }
 } while (0);
 i74 = i1;
 STACKTOP = i56;
 return i74 | 0;
}

function __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i36, i33, i7) {
 i36 = i36 | 0;
 i33 = i33 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i39 + 140 | 0;
 i27 = i39 + 128 | 0;
 i28 = i39 + 112 | 0;
 i29 = i39 + 76 | 0;
 i8 = i39 + 16 | 0;
 i30 = i39 + 40 | 0;
 i9 = i39 + 8 | 0;
 i31 = i39 + 28 | 0;
 i17 = i39 + 24 | 0;
 i24 = i39;
 if ((HEAP16[gb + 1159852 + 6 >> 1] | 0) > -1) {
  HEAP32[i27 >> 2] = 0;
  HEAP32[i35 >> 2] = HEAP32[i27 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159852 | 0, i35);
  i38 = gb + 1159852 | 0;
 } else i38 = 0;
 i37 = i36 + 100 | 0;
 i1 = HEAP32[i37 >> 2] | 0;
 L4 : do if ((i1 | 0) == (i33 | 0)) i1 = 1; else {
  i26 = i36 + 28 | 0;
  if (!(HEAP32[(HEAP32[i26 >> 2] | 0) + 56 >> 2] & 16)) {
   i34 = (i33 | 0) != 0;
   if (i34) if (HEAP32[(HEAP32[i33 + 28 >> 2] | 0) + 56 >> 2] & 16 | 0) {
    i1 = 0;
    break;
   }
   if (!i1) i10 = 9; else if (!(HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 56 >> 2] & 15)) i10 = 9;
   do if ((i10 | 0) == 9) {
    if (i34) {
     if (!(HEAP32[(HEAP32[i33 + 28 >> 2] | 0) + 56 >> 2] & 15)) i1 = i33; else break;
     while (1) {
      if ((i1 | 0) == (i36 | 0)) {
       i1 = 0;
       break L4;
      }
      i1 = HEAP32[i1 + 100 >> 2] | 0;
      if (!i1) {
       i32 = 0;
       break;
      }
     }
    } else i32 = 1;
    i12 = (i7 & 8 | 0) == 0;
    if (i12) {
     HEAP32[i35 >> 2] = 0;
     HEAP32[i35 + 4 >> 2] = 0;
     HEAP32[i35 + 8 >> 2] = 0;
     i1 = HEAP32[i36 + 32 >> 2] | 0;
     i3 = HEAP32[i36 + 36 >> 2] | 0;
     i5 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if (i5 | 0) {
      i6 = i1 + 24 | 0;
      i4 = i1 + 68 | 0;
      i2 = 0;
      i1 = i3;
      while (1) {
       __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, gb + 1105036 | 0, i35);
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
      }
     }
    }
    i22 = (i7 & 1 | 0) == 0;
    if (!i22) {
     i25 = i36 + 32 | 0;
     i21 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     i23 = i8;
     HEAP32[i23 >> 2] = i21;
     HEAP32[i23 + 4 >> 2] = i25;
     HEAP32[i35 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i35 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i35, i27, i28);
     i23 = i9;
     HEAP32[i23 >> 2] = i21;
     HEAP32[i23 + 4 >> 2] = i25;
     HEAP32[i35 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i35 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E(i30, i35, i28);
     i23 = HEAP32[i30 + 4 >> 2] | 0;
     i25 = HEAP32[i30 + 8 >> 2] | 0;
     HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i29 + 4 >> 2] = i23;
     HEAP32[i29 + 8 >> 2] = i25;
     i25 = HEAP32[i30 + 16 >> 2] | 0;
     i23 = HEAP32[i30 + 20 >> 2] | 0;
     HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
     HEAP32[i29 + 16 >> 2] = i25;
     HEAP32[i29 + 20 >> 2] = i23;
     i23 = HEAP32[i30 + 28 >> 2] | 0;
     i25 = HEAP32[i30 + 32 >> 2] | 0;
     HEAP32[i29 + 24 >> 2] = HEAP32[i30 + 24 >> 2];
     HEAP32[i29 + 28 >> 2] = i23;
     HEAP32[i29 + 32 >> 2] = i25;
    }
    i25 = i36 + 8 | 0;
    if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i25 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 28980 | 0)) {
     __ZNK2UI13RectTransform13GetWorldSpaceER8Vector3fR8Vector2f(i36, i31, i30);
     i21 = i36;
    } else i21 = 0;
    i1 = HEAP32[i37 >> 2] | 0;
    i23 = (i1 | 0) != 0;
    if (i23) {
     i2 = HEAP32[i1 + 80 >> 2] | 0;
     i3 = i1 + 92 | 0;
     i20 = HEAP32[i3 >> 2] | 0;
     i4 = i2 + (i20 << 2) | 0;
     L36 : do if (!i20) i2 = i4; else while (1) {
      if ((HEAP32[i2 >> 2] | 0) == (i36 | 0)) break L36;
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i4 | 0)) {
       i2 = i4;
       break;
      }
     } while (0);
     i20 = i2 + 4 | 0;
     _memmove(i2 | 0, i20 | 0, i4 - i20 | 0) | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
    }
    if (i34) {
     if (i12) {
      if (!i1) {
       i2 = HEAP32[i33 + 32 >> 2] | 0;
       i10 = 34;
      } else {
       i2 = HEAP32[i33 + 32 >> 2] | 0;
       if ((HEAP32[i1 + 32 >> 2] | 0) != (i2 | 0)) i10 = 34;
      }
      if ((i10 | 0) == 34) {
       i3 = (HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + (HEAP32[(HEAP32[(HEAP32[i36 + 32 >> 2] | 0) + 16 >> 2] | 0) + (HEAP32[i36 + 36 >> 2] << 2) >> 2] | 0) | 0;
       if (i3 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) __ZN9Transform20SetHierarchyCapacityEj(i33, i3 << 1);
      }
      i4 = i33 + 92 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!i5) i2 = i33; else {
       i2 = i33;
       i3 = i5;
       do {
        i2 = HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0;
        i3 = HEAP32[i2 + 92 >> 2] | 0;
       } while ((i3 | 0) != 0);
      }
      i11 = HEAP32[i2 + 36 >> 2] | 0;
     } else {
      i5 = i33 + 92 | 0;
      i11 = 0;
      i4 = i5;
      i5 = HEAP32[i5 >> 2] | 0;
     }
     i3 = i33 + 80 | 0;
     i6 = i36;
     i7 = i5 + 1 | 0;
     i8 = i33 + 96 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     i10 = i9 & 2147483647;
     do if (i7 >>> 0 > i10 >>> 0) {
      i2 = i9 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
       HEAP32[i8 >> 2] = i2;
       HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i33 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i33 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i20 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
       HEAP32[i8 >> 2] = i2;
       HEAP32[i3 >> 2] = i20;
       break;
      }
     } while (0);
     HEAP32[i4 >> 2] = i7;
     HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i6;
    } else i11 = 0;
    HEAP32[i37 >> 2] = i33;
    do if (i12) {
     i20 = HEAP32[gb + 1158396 >> 2] | 0;
     i19 = HEAP32[i20 + 32 >> 2] | 0;
     i2 = (i1 | 0) == 0;
     L69 : do if (i34 & i2) {
      i10 = HEAP32[i36 + 32 >> 2] | 0;
      i6 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (HEAP32[i36 + 36 >> 2] << 2) >> 2] | 0;
      i9 = HEAP32[i33 + 32 >> 2] | 0;
      HEAP32[i35 >> 2] = 0;
      HEAP32[i17 >> 2] = 0;
      __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb(i10, 0, i9, i35, i17, i19, 0);
      i2 = HEAP32[i35 >> 2] | 0;
      i3 = HEAP32[i17 >> 2] | 0;
      i8 = i9 + 68 | 0;
      i19 = HEAP32[i8 >> 2] | 0;
      i5 = i19 + (i11 << 2) | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      HEAP32[i5 >> 2] = i2;
      i5 = HEAP32[i9 + 72 >> 2] | 0;
      HEAP32[i5 + (i2 << 2) >> 2] = i11;
      HEAP32[i19 + (i3 << 2) >> 2] = i4;
      if ((i4 | 0) != -1) HEAP32[i5 + (i4 << 2) >> 2] = i3;
      i3 = HEAP32[i33 + 36 >> 2] | 0;
      i4 = HEAP32[i9 + 16 >> 2] | 0;
      i7 = HEAP32[i9 + 12 >> 2] | 0;
      if ((i3 | 0) != -1) do {
       i19 = i4 + (i3 << 2) | 0;
       HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i6;
       i3 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
      } while ((i3 | 0) != -1);
      i5 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      i6 = HEAP32[i9 + 24 >> 2] | 0;
      i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
      HEAP32[i3 + 32 >> 2] = i9;
      HEAP32[i3 + 36 >> 2] = i2;
      if (!i2) i3 = -1; else i3 = HEAP32[(HEAP32[i3 + 100 >> 2] | 0) + 36 >> 2] | 0;
      HEAP32[i7 + (i2 << 2) >> 2] = i3;
      i4 = HEAP32[i8 >> 2] | 0;
      if (i5 >>> 0 > 1) {
       i3 = 1;
       do {
        i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
        i19 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
        HEAP32[i19 + 32 >> 2] = i9;
        HEAP32[i19 + 36 >> 2] = i2;
        HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i19 + 100 >> 2] | 0) + 36 >> 2];
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i5 | 0));
      }
      if (i10 | 0) {
       i2 = HEAP32[gb + 1158396 >> 2] | 0;
       i3 = i10 + 32 | 0;
       i4 = HEAP32[i3 >> 2] | 0;
       if ((i4 | 0) != -1) {
        i17 = i2 + 12 | 0;
        i16 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
        i19 = HEAP32[i2 >> 2] | 0;
        i18 = i19 + (i16 << 2) | 0;
        HEAP32[(HEAP32[i18 >> 2] | 0) + 32 >> 2] = i4;
        i19 = i19 + (HEAP32[i3 >> 2] << 2) | 0;
        HEAP32[i17 >> 2] = i16;
        HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
        HEAP32[i3 >> 2] = -1;
       }
       __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 63160 | 0);
      }
     } else {
      if (!(i34 | i2)) {
       i13 = HEAP32[i36 + 36 >> 2] | 0;
       i15 = HEAP32[i36 + 32 >> 2] | 0;
       i14 = i15 + 16 | 0;
       i16 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 2) >> 2] | 0;
       i2 = HEAP32[i36 + 92 >> 2] | 0;
       if (!i2) i12 = i13; else {
        i3 = i36;
        do {
         i3 = HEAP32[(HEAP32[i3 + 80 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
         i2 = HEAP32[i3 + 92 >> 2] | 0;
        } while ((i2 | 0) != 0);
        i12 = HEAP32[i3 + 36 >> 2] | 0;
       }
       i18 = __ZN17TransformInternal24CreateTransformHierarchyEj(i16) | 0;
       i11 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 2) >> 2] | 0;
       i17 = i18 + 68 | 0;
       i2 = (HEAP32[i17 >> 2] | 0) + (i11 + -1 << 2) | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       HEAP32[i18 + 4 >> 2] = i3;
       if ((i3 | 0) != -1) HEAP32[(HEAP32[i18 + 72 >> 2] | 0) + (i3 << 2) >> 2] = -1;
       HEAP32[i2 >> 2] = -1;
       if (!i11) i3 = HEAP32[i15 + 68 >> 2] | 0; else {
        i5 = i18 + 56 | 0;
        i6 = i18 + 60 | 0;
        i7 = i15 + 68 | 0;
        i8 = i15 + 60 | 0;
        i9 = i15 + 56 | 0;
        i10 = i18 + 36 | 0;
        i2 = i13;
        i4 = 0;
        while (1) {
         __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i15, i2, i18, i4);
         i40 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
         i3 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | i40 & i19;
         HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i3;
         HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i40;
         HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i3;
         i3 = HEAP32[i7 >> 2] | 0;
         i4 = i4 + 1 | 0;
         if ((i4 | 0) == (i11 | 0)) break; else i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
        }
       }
       i5 = HEAP32[i15 + 72 >> 2] | 0;
       i40 = i5 + (i13 << 2) | 0;
       i2 = HEAP32[i40 >> 2] | 0;
       i6 = i3 + (i12 << 2) | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       HEAP32[i40 >> 2] = -1;
       HEAP32[i3 + (i2 << 2) >> 2] = i4;
       HEAP32[i6 >> 2] = -1;
       if ((i4 | 0) != -1) HEAP32[i5 + (i4 << 2) >> 2] = i2;
       i40 = i15 + 4 | 0;
       i2 = HEAP32[i40 >> 2] | 0;
       HEAP32[i40 >> 2] = i13;
       HEAP32[i6 >> 2] = i2;
       if ((i2 | 0) != -1) HEAP32[i5 + (i2 << 2) >> 2] = i12;
       i2 = HEAP32[i1 + 36 >> 2] | 0;
       if ((i2 | 0) != -1) {
        i4 = HEAP32[i14 >> 2] | 0;
        i3 = HEAP32[i15 + 12 >> 2] | 0;
        do {
         i40 = i4 + (i2 << 2) | 0;
         HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) - i16;
         i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
        } while ((i2 | 0) != -1);
       }
       i5 = HEAP32[HEAP32[i18 + 16 >> 2] >> 2] | 0;
       i6 = HEAP32[i18 + 24 >> 2] | 0;
       i7 = HEAP32[i18 + 12 >> 2] | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       HEAP32[i4 + 32 >> 2] = i18;
       HEAP32[i4 + 36 >> 2] = 0;
       HEAP32[i7 >> 2] = -1;
       i4 = HEAP32[i17 >> 2] | 0;
       if (i5 >>> 0 > 1) {
        i2 = 1;
        i3 = 0;
       } else break;
       while (1) {
        i3 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
        i40 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
        HEAP32[i40 + 32 >> 2] = i18;
        HEAP32[i40 + 36 >> 2] = i3;
        HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[(HEAP32[i40 + 100 >> 2] | 0) + 36 >> 2];
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i5 | 0)) break L69;
       }
      }
      i14 = HEAP32[i33 + 32 >> 2] | 0;
      i5 = (HEAP32[i1 + 32 >> 2] | 0) == (i14 | 0);
      i2 = HEAP32[i36 + 36 >> 2] | 0;
      i15 = HEAP32[i36 + 32 >> 2] | 0;
      i8 = i15 + 16 | 0;
      i10 = HEAP32[i8 >> 2] | 0;
      i12 = i10 + (i2 << 2) | 0;
      i16 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP32[i36 + 92 >> 2] | 0;
      if (!i3) i13 = i2; else {
       i4 = i36;
       do {
        i4 = HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0;
        i3 = HEAP32[i4 + 92 >> 2] | 0;
       } while ((i3 | 0) != 0);
       i13 = HEAP32[i4 + 36 >> 2] | 0;
      }
      if (i5) {
       i6 = HEAP32[i15 + 72 >> 2] | 0;
       i7 = i6 + (i2 << 2) | 0;
       i3 = HEAP32[i7 >> 2] | 0;
       i9 = i15 + 68 | 0;
       i5 = HEAP32[i9 >> 2] | 0;
       i8 = i5 + (i13 << 2) | 0;
       i4 = HEAP32[i8 >> 2] | 0;
       HEAP32[i7 >> 2] = -1;
       HEAP32[i5 + (i3 << 2) >> 2] = i4;
       HEAP32[i8 >> 2] = -1;
       if ((i4 | 0) != -1) HEAP32[i6 + (i4 << 2) >> 2] = i3;
       i3 = HEAP32[i1 + 36 >> 2] | 0;
       if ((i3 | 0) != -1) {
        i4 = HEAP32[i15 + 12 >> 2] | 0;
        do {
         i40 = i10 + (i3 << 2) | 0;
         HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) - i16;
         i3 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
        } while ((i3 | 0) != -1);
       }
       i40 = i5 + (i11 << 2) | 0;
       i3 = HEAP32[i40 >> 2] | 0;
       HEAP32[i40 >> 2] = i2;
       HEAP32[i7 >> 2] = i11;
       HEAP32[i8 >> 2] = i3;
       if ((i3 | 0) != -1) HEAP32[i6 + (i3 << 2) >> 2] = i13;
       i3 = HEAP32[i33 + 36 >> 2] | 0;
       i7 = HEAP32[i15 + 12 >> 2] | 0;
       if ((i3 | 0) != -1) do {
        i40 = i10 + (i3 << 2) | 0;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i16;
        i3 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
       } while ((i3 | 0) != -1);
       i5 = HEAP32[i12 >> 2] | 0;
       i6 = HEAP32[i15 + 24 >> 2] | 0;
       i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
       HEAP32[i3 + 32 >> 2] = i15;
       HEAP32[i3 + 36 >> 2] = i2;
       if (!i2) i3 = -1; else i3 = HEAP32[(HEAP32[i3 + 100 >> 2] | 0) + 36 >> 2] | 0;
       HEAP32[i7 + (i2 << 2) >> 2] = i3;
       i4 = HEAP32[i9 >> 2] | 0;
       if (i5 >>> 0 > 1) i3 = 1; else break;
       while (1) {
        i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
        i40 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
        HEAP32[i40 + 32 >> 2] = i15;
        HEAP32[i40 + 36 >> 2] = i2;
        HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i40 + 100 >> 2] | 0) + 36 >> 2];
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i5 | 0)) break L69;
       }
      }
      HEAP32[i35 >> 2] = 0;
      HEAP32[i17 >> 2] = 0;
      __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb(i15, i2, i14, i35, i17, i19, 0);
      i6 = HEAP32[i15 + 72 >> 2] | 0;
      i19 = i6 + (i2 << 2) | 0;
      i3 = HEAP32[i19 >> 2] | 0;
      i40 = HEAP32[i15 + 68 >> 2] | 0;
      i7 = i40 + (i13 << 2) | 0;
      i4 = HEAP32[i7 >> 2] | 0;
      HEAP32[i19 >> 2] = -1;
      HEAP32[i40 + (i3 << 2) >> 2] = i4;
      HEAP32[i7 >> 2] = -1;
      if ((i4 | 0) != -1) HEAP32[i6 + (i4 << 2) >> 2] = i3;
      i3 = HEAP32[i1 + 36 >> 2] | 0;
      if ((i3 | 0) != -1) {
       i4 = HEAP32[i8 >> 2] | 0;
       i5 = HEAP32[i15 + 12 >> 2] | 0;
       do {
        i40 = i4 + (i3 << 2) | 0;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) - i16;
        i3 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
       } while ((i3 | 0) != -1);
      }
      i40 = i15 + 4 | 0;
      i3 = HEAP32[i40 >> 2] | 0;
      HEAP32[i40 >> 2] = i2;
      HEAP32[i7 >> 2] = i3;
      if ((i3 | 0) != -1) HEAP32[i6 + (i3 << 2) >> 2] = i13;
      i2 = HEAP32[i35 >> 2] | 0;
      i3 = HEAP32[i17 >> 2] | 0;
      i9 = i14 + 68 | 0;
      i40 = HEAP32[i9 >> 2] | 0;
      i5 = i40 + (i11 << 2) | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      HEAP32[i5 >> 2] = i2;
      i5 = HEAP32[i14 + 72 >> 2] | 0;
      HEAP32[i5 + (i2 << 2) >> 2] = i11;
      HEAP32[i40 + (i3 << 2) >> 2] = i4;
      if ((i4 | 0) != -1) HEAP32[i5 + (i4 << 2) >> 2] = i3;
      i3 = HEAP32[i33 + 36 >> 2] | 0;
      i4 = HEAP32[i14 + 16 >> 2] | 0;
      i6 = i14 + 12 | 0;
      if ((i3 | 0) != -1) {
       i5 = HEAP32[i6 >> 2] | 0;
       do {
        i40 = i4 + (i3 << 2) | 0;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + i16;
        i3 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
       } while ((i3 | 0) != -1);
      }
      i7 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      i8 = HEAP32[i14 + 24 >> 2] | 0;
      i5 = HEAP32[i6 >> 2] | 0;
      i3 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
      HEAP32[i3 + 32 >> 2] = i14;
      HEAP32[i3 + 36 >> 2] = i2;
      if (!i2) i3 = -1; else i3 = HEAP32[(HEAP32[i3 + 100 >> 2] | 0) + 36 >> 2] | 0;
      HEAP32[i5 + (i2 << 2) >> 2] = i3;
      i4 = HEAP32[i9 >> 2] | 0;
      if (i7 >>> 0 > 1) {
       i3 = 1;
       do {
        i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
        i40 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
        HEAP32[i40 + 32 >> 2] = i14;
        HEAP32[i40 + 36 >> 2] = i2;
        HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i40 + 100 >> 2] | 0) + 36 >> 2];
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
     } while (0);
     i9 = HEAP32[i20 + 36 >> 2] | 0;
     if (i23) {
      i5 = i1 + 32 | 0;
      i2 = i5;
      i3 = HEAP32[i2 + 4 >> 2] | 0;
      i2 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != -1) {
       i6 = HEAP32[i2 + 60 >> 2] | 0;
       i7 = HEAP32[i2 + 56 >> 2] | 0;
       i8 = i2 + 36 | 0;
       i4 = HEAP32[i2 + 12 >> 2] | 0;
       i2 = i3;
       do {
        i40 = HEAP32[i6 + (i2 << 2) >> 2] & i9;
        i19 = i7 + (i2 << 2) | 0;
        HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i40;
        HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i40;
        i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
       } while ((i2 | 0) != -1);
       i2 = HEAP32[i5 >> 2] | 0;
      }
      __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i20, i2);
     }
     if (i34) {
      i3 = i33 + 32 | 0;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = HEAP32[i3 >> 2] | 0;
      if ((i2 | 0) != -1) {
       i4 = HEAP32[i3 + 60 >> 2] | 0;
       i5 = HEAP32[i3 + 56 >> 2] | 0;
       i6 = i3 + 36 | 0;
       i3 = HEAP32[i3 + 12 >> 2] | 0;
       do {
        i40 = HEAP32[i4 + (i2 << 2) >> 2] & i9;
        i19 = i5 + (i2 << 2) | 0;
        HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i40;
        HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i40;
        i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
       } while ((i2 | 0) != -1);
      }
     }
     i6 = i36 + 32 | 0;
     i2 = i6;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     i2 = HEAP32[i2 >> 2] | 0;
     i7 = HEAP32[i2 + 44 >> 2] | HEAP32[i2 + 40 >> 2] | HEAP32[i2 + 48 >> 2];
     i8 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     if (i8 | 0) {
      i9 = HEAP32[i2 + 60 >> 2] | 0;
      i10 = HEAP32[i2 + 56 >> 2] | 0;
      i11 = i2 + 36 | 0;
      i5 = HEAP32[i2 + 68 >> 2] | 0;
      i3 = 0;
      i2 = i4;
      while (1) {
       i40 = HEAP32[i9 + (i2 << 2) >> 2] & i7;
       i19 = i10 + (i2 << 2) | 0;
       HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i40;
       HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | i40;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i8 | 0)) break; else i2 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
      }
     }
     do if (!i22) {
      i19 = i6;
      i22 = HEAP32[i19 + 4 >> 2] | 0;
      i40 = i24;
      HEAP32[i40 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i40 + 4 >> 2] = i22;
      HEAP32[i35 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i35 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E(i35, i27, i28, i29) | 0;
      if (!i21) break;
      __ZN2UI13RectTransform13SetWorldSpaceERK8Vector3fRK8Vector2fb(i21, i31, i30, 1);
     } while (0);
     i4 = i36 + 36 | 0;
     __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i20, HEAP32[i6 >> 2] | 0);
     i2 = i36 + 32 | 0;
     __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, 75);
     __ZN10GameObject25TransformParentHasChangedEv(HEAP32[i26 >> 2] | 0);
     HEAP32[i35 >> 2] = 0;
     HEAP32[i35 + 4 >> 2] = 0;
     HEAP32[i35 + 8 >> 2] = 0;
     i2 = HEAP32[i2 >> 2] | 0;
     i4 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     if (i6 | 0) {
      i7 = i2 + 24 | 0;
      i5 = i2 + 68 | 0;
      i3 = 0;
      i2 = i4;
      while (1) {
       __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0, gb + 1105056 | 0, i35);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i6 | 0)) break; else i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      }
     }
     if (i23) {
      HEAP32[i35 >> 2] = 0;
      HEAP32[i35 + 4 >> 2] = 0;
      HEAP32[i35 + 8 >> 2] = 0;
      __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105076 | 0, i35);
     }
     if (!i34) break;
     HEAP32[i35 >> 2] = 0;
     HEAP32[i35 + 4 >> 2] = 0;
     HEAP32[i35 + 8 >> 2] = 0;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i33, gb + 1105076 | 0, i35);
    } while (0);
    do if (!i1) __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i36, 1); else if (i32) {
     if (!(HEAP32[i1 + 104 >> 2] | 0)) while (1) {
      i2 = HEAP32[i1 + 100 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     i1 = HEAP32[i1 + 116 >> 2] | 0;
     if (!i1) i1 = __ZN19RuntimeSceneManager14GetActiveSceneEv(__Z15GetSceneManagerv() | 0) | 0;
     if (!(HEAP32[i37 >> 2] | 0)) {
      if (!((i1 | 0) != 0 & (HEAP32[i25 >> 2] & 1048576 | 0) == 0)) break;
      __ZN10UnityScene14AddRootToSceneERS_R9Transform(i1, i36);
     }
    } while (0);
    i1 = 1;
    break L4;
   } while (0);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 422107 | 0, 0, gb + 421343 | 0, 486, 1, HEAP32[i36 + 4 >> 2] | 0, 0, 0);
   i1 = 0;
  } else i1 = 0;
 } while (0);
 if (!i38) {
  STACKTOP = i39;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i38);
 STACKTOP = i39;
 return i1 | 0;
}

function __ZN5physx2Gu11sweepBoxBoxERKNS0_3BoxES3_RKNS_6PxVec3EfRS4_S7_RfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i50, i51, i71, f3, i61, i75, i76, i1) {
 i50 = i50 | 0;
 i51 = i51 | 0;
 i71 = i71 | 0;
 f3 = Math_fround(f3);
 i61 = i61 | 0;
 i75 = i75 | 0;
 i76 = i76 | 0;
 i1 = i1 | 0;
 var f2 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i73 = 0, i74 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i77 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i77 + 616 | 0;
 i58 = i77 + 520 | 0;
 i32 = i77 + 504 | 0;
 i31 = i77 + 344 | 0;
 i34 = i77 + 196 | 0;
 i33 = i77 + 192 | 0;
 i28 = i77 + 180 | 0;
 i29 = i77 + 168 | 0;
 i43 = i77 + 156 | 0;
 i42 = i77 + 144 | 0;
 i44 = i77 + 132 | 0;
 i46 = i77 + 128 | 0;
 i45 = i77 + 124 | 0;
 i40 = i77 + 112 | 0;
 i72 = i77 + 100 | 0;
 i73 = i77 + 88 | 0;
 i59 = i77 + 360 | 0;
 i60 = i77 + 200 | 0;
 i63 = i77 + 76 | 0;
 i64 = i77 + 64 | 0;
 i65 = i77 + 52 | 0;
 i66 = i77 + 40 | 0;
 i56 = i77 + 36 | 0;
 i62 = i77 + 24 | 0;
 i69 = i77 + 12 | 0;
 i70 = i77;
 if (!(HEAP16[i1 >> 1] & 16)) {
  i6 = i50 + 48 | 0;
  i1 = i50 + 36 | 0;
  i8 = i51 + 48 | 0;
  i7 = i51 + 36 | 0;
  if (__ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b(i6, i1, i50, i8, i7, i51, 1) | 0) {
   HEAPF32[i76 >> 2] = Math_fround(0.0);
   f25 = Math_fround(-Math_fround(HEAPF32[i71 >> 2]));
   f26 = Math_fround(-Math_fround(HEAPF32[i71 + 4 >> 2]));
   f27 = Math_fround(-Math_fround(HEAPF32[i71 + 8 >> 2]));
   HEAPF32[i75 >> 2] = f25;
   HEAPF32[i75 + 4 >> 2] = f26;
   HEAPF32[i75 + 8 >> 2] = f27;
   HEAP32[i61 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i61 + 4 >> 2] = HEAP32[i50 + 40 >> 2];
   HEAP32[i61 + 8 >> 2] = HEAP32[i50 + 44 >> 2];
   i76 = 1;
   STACKTOP = i77;
   return i76 | 0;
  }
 } else {
  i6 = i50 + 48 | 0;
  i7 = i51 + 36 | 0;
  i8 = i51 + 48 | 0;
  i1 = i50 + 36 | 0;
 }
 i39 = i50 + 12 | 0;
 i48 = i50 + 24 | 0;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i57, i1, i6, i50, i39, i48);
 i30 = i51 + 12 | 0;
 i35 = i51 + 24 | 0;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i58, i7, i8, i51, i30, i35);
 f15 = Math_fround(HEAPF32[i50 + 48 >> 2]);
 f18 = Math_fround(-f15);
 f14 = Math_fround(HEAPF32[i50 + 52 >> 2]);
 f17 = Math_fround(-f14);
 f13 = Math_fround(HEAPF32[i50 + 56 >> 2]);
 f16 = Math_fround(-f13);
 HEAPF32[i32 >> 2] = f18;
 HEAPF32[i32 + 4 >> 2] = f17;
 HEAPF32[i32 + 8 >> 2] = f16;
 HEAPF32[i31 >> 2] = f15;
 HEAPF32[i31 + 4 >> 2] = f14;
 HEAPF32[i31 + 8 >> 2] = f13;
 f13 = Math_fround(HEAPF32[i50 >> 2]);
 i36 = i50 + 4 | 0;
 f14 = Math_fround(HEAPF32[i36 >> 2]);
 i37 = i50 + 8 | 0;
 f15 = Math_fround(HEAPF32[i37 >> 2]);
 f16 = Math_fround(HEAPF32[i39 >> 2]);
 i39 = i50 + 16 | 0;
 f17 = Math_fround(HEAPF32[i39 >> 2]);
 i41 = i50 + 20 | 0;
 f18 = Math_fround(HEAPF32[i41 >> 2]);
 f20 = Math_fround(HEAPF32[i48 >> 2]);
 i48 = i50 + 28 | 0;
 f21 = Math_fround(HEAPF32[i48 >> 2]);
 i49 = i50 + 32 | 0;
 f22 = Math_fround(HEAPF32[i49 >> 2]);
 f4 = Math_fround(HEAPF32[i50 + 36 >> 2]);
 f10 = Math_fround(HEAPF32[i50 + 40 >> 2]);
 f4 = Math_fround(-f4);
 f10 = Math_fround(-f10);
 f27 = Math_fround(-Math_fround(HEAPF32[i50 + 44 >> 2]));
 f25 = Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f14 * f10)) + Math_fround(f15 * f27));
 f26 = Math_fround(Math_fround(Math_fround(f16 * f4) + Math_fround(f17 * f10)) + Math_fround(f18 * f27));
 f27 = Math_fround(Math_fround(Math_fround(f20 * f4) + Math_fround(f21 * f10)) + Math_fround(f22 * f27));
 f10 = Math_fround(HEAPF32[i71 >> 2]);
 f4 = Math_fround(f13 * f10);
 f5 = Math_fround(f16 * f10);
 f10 = Math_fround(f20 * f10);
 i54 = i71 + 4 | 0;
 f2 = Math_fround(HEAPF32[i54 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f14 * f2));
 f5 = Math_fround(f5 + Math_fround(f17 * f2));
 f2 = Math_fround(f10 + Math_fround(f21 * f2));
 i55 = i71 + 8 | 0;
 f10 = Math_fround(HEAPF32[i55 >> 2]);
 i12 = i28 + 4 | 0;
 i19 = i28 + 8 | 0;
 f4 = Math_fround(-Math_fround(f4 + Math_fround(f15 * f10)));
 f5 = Math_fround(-Math_fround(f5 + Math_fround(f18 * f10)));
 f10 = Math_fround(-Math_fround(f2 + Math_fround(f22 * f10)));
 i23 = i29 + 4 | 0;
 i24 = i29 + 8 | 0;
 i38 = i50 + 12 | 0;
 i47 = i50 + 24 | 0;
 i67 = i75 + 4 | 0;
 i68 = i75 + 8 | 0;
 i52 = i61 + 4 | 0;
 i53 = i61 + 8 | 0;
 i1 = -1;
 i11 = 0;
 while (1) {
  i6 = i58 + (i11 * 12 | 0) | 0;
  f79 = Math_fround(HEAPF32[i6 >> 2]);
  f80 = Math_fround(f13 * f79);
  f78 = Math_fround(f16 * f79);
  f79 = Math_fround(f20 * f79);
  i7 = i58 + (i11 * 12 | 0) + 4 | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f80 = Math_fround(f80 + Math_fround(f14 * f2));
  f78 = Math_fround(f78 + Math_fround(f17 * f2));
  f2 = Math_fround(f79 + Math_fround(f21 * f2));
  i8 = i58 + (i11 * 12 | 0) + 8 | 0;
  f79 = Math_fround(HEAPF32[i8 >> 2]);
  f78 = Math_fround(f26 + Math_fround(f78 + Math_fround(f18 * f79)));
  f2 = Math_fround(f27 + Math_fround(f2 + Math_fround(f22 * f79)));
  HEAPF32[i28 >> 2] = Math_fround(f25 + Math_fround(f80 + Math_fround(f15 * f79)));
  HEAPF32[i12 >> 2] = f78;
  HEAPF32[i19 >> 2] = f2;
  HEAPF32[i29 >> 2] = f4;
  HEAPF32[i23 >> 2] = f5;
  HEAPF32[i24 >> 2] = f10;
  i9 = __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i32, i31, i28, i29, i34, i33) | 0;
  f2 = Math_fround(HEAPF32[i34 >> 2]);
  if (!(f2 <= f3) | ((i9 | 0) == -1 | f2 < Math_fround(0.0))) f2 = f3; else {
   f80 = Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) >> 2]);
   f79 = Math_fround(f80 * Math_fround(HEAPF32[i50 >> 2]));
   f78 = Math_fround(f80 * Math_fround(HEAPF32[i36 >> 2]));
   f80 = Math_fround(f80 * Math_fround(HEAPF32[i37 >> 2]));
   f81 = Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) + 4 >> 2]);
   f3 = Math_fround(f81 * Math_fround(HEAPF32[i38 >> 2]));
   f82 = Math_fround(f81 * Math_fround(HEAPF32[i39 >> 2]));
   f3 = Math_fround(f79 + f3);
   f82 = Math_fround(f78 + f82);
   f81 = Math_fround(f80 + Math_fround(f81 * Math_fround(HEAPF32[i41 >> 2])));
   f80 = Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) + 8 >> 2]);
   f78 = Math_fround(f80 * Math_fround(HEAPF32[i47 >> 2]));
   f79 = Math_fround(f80 * Math_fround(HEAPF32[i48 >> 2]));
   f79 = Math_fround(f82 + f79);
   f80 = Math_fround(f81 + Math_fround(f80 * Math_fround(HEAPF32[i49 >> 2])));
   HEAPF32[i75 >> 2] = Math_fround(f3 + f78);
   HEAPF32[i67 >> 2] = f79;
   HEAPF32[i68 >> 2] = f80;
   HEAP32[i61 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i52 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i53 >> 2] = HEAP32[i8 >> 2];
   i1 = 0;
  }
  i11 = i11 + 1 | 0;
  if ((i11 | 0) == 8) break; else f3 = f2;
 }
 f22 = Math_fround(HEAPF32[i51 + 48 >> 2]);
 f18 = Math_fround(-f22);
 f21 = Math_fround(HEAPF32[i51 + 52 >> 2]);
 f17 = Math_fround(-f21);
 f20 = Math_fround(HEAPF32[i51 + 56 >> 2]);
 f16 = Math_fround(-f20);
 HEAPF32[i43 >> 2] = f18;
 HEAPF32[i43 + 4 >> 2] = f17;
 HEAPF32[i43 + 8 >> 2] = f16;
 HEAPF32[i42 >> 2] = f22;
 HEAPF32[i42 + 4 >> 2] = f21;
 HEAPF32[i42 + 8 >> 2] = f20;
 f20 = Math_fround(HEAPF32[i51 >> 2]);
 i23 = i51 + 4 | 0;
 f21 = Math_fround(HEAPF32[i23 >> 2]);
 i28 = i51 + 8 | 0;
 f22 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(HEAPF32[i30 >> 2]);
 i29 = i51 + 16 | 0;
 f17 = Math_fround(HEAPF32[i29 >> 2]);
 i30 = i51 + 20 | 0;
 f18 = Math_fround(HEAPF32[i30 >> 2]);
 f3 = Math_fround(HEAPF32[i35 >> 2]);
 i32 = i51 + 28 | 0;
 f4 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i51 + 32 | 0;
 f5 = Math_fround(HEAPF32[i33 >> 2]);
 f79 = Math_fround(HEAPF32[i51 + 36 >> 2]);
 f80 = Math_fround(HEAPF32[i51 + 40 >> 2]);
 f79 = Math_fround(-f79);
 f80 = Math_fround(-f80);
 f15 = Math_fround(-Math_fround(HEAPF32[i51 + 44 >> 2]));
 f13 = Math_fround(Math_fround(Math_fround(f20 * f79) + Math_fround(f21 * f80)) + Math_fround(f22 * f15));
 f14 = Math_fround(Math_fround(Math_fround(f16 * f79) + Math_fround(f17 * f80)) + Math_fround(f18 * f15));
 f15 = Math_fround(Math_fround(Math_fround(f3 * f79) + Math_fround(f4 * f80)) + Math_fround(f5 * f15));
 f80 = Math_fround(HEAPF32[i71 >> 2]);
 f79 = Math_fround(f20 * f80);
 f81 = Math_fround(f16 * f80);
 f80 = Math_fround(f3 * f80);
 f82 = Math_fround(HEAPF32[i54 >> 2]);
 f79 = Math_fround(f79 + Math_fround(f21 * f82));
 f81 = Math_fround(f81 + Math_fround(f17 * f82));
 f82 = Math_fround(f80 + Math_fround(f4 * f82));
 f80 = Math_fround(HEAPF32[i55 >> 2]);
 f81 = Math_fround(f81 + Math_fround(f18 * f80));
 f82 = Math_fround(f82 + Math_fround(f5 * f80));
 HEAPF32[i44 >> 2] = Math_fround(f79 + Math_fround(f22 * f80));
 HEAPF32[i44 + 4 >> 2] = f81;
 HEAPF32[i44 + 8 >> 2] = f82;
 i12 = i40 + 4 | 0;
 i19 = i40 + 8 | 0;
 i24 = i51 + 12 | 0;
 i31 = i51 + 24 | 0;
 i11 = 0;
 while (1) {
  i6 = i57 + (i11 * 12 | 0) | 0;
  f81 = Math_fround(HEAPF32[i6 >> 2]);
  f80 = Math_fround(f20 * f81);
  f82 = Math_fround(f16 * f81);
  f81 = Math_fround(f3 * f81);
  i7 = i57 + (i11 * 12 | 0) + 4 | 0;
  f10 = Math_fround(HEAPF32[i7 >> 2]);
  f80 = Math_fround(f80 + Math_fround(f21 * f10));
  f82 = Math_fround(f82 + Math_fround(f17 * f10));
  f10 = Math_fround(f81 + Math_fround(f4 * f10));
  i8 = i57 + (i11 * 12 | 0) + 8 | 0;
  f81 = Math_fround(HEAPF32[i8 >> 2]);
  f82 = Math_fround(f14 + Math_fround(f82 + Math_fround(f18 * f81)));
  f10 = Math_fround(f15 + Math_fround(f10 + Math_fround(f5 * f81)));
  HEAPF32[i40 >> 2] = Math_fround(f13 + Math_fround(f80 + Math_fround(f22 * f81)));
  HEAPF32[i12 >> 2] = f82;
  HEAPF32[i19 >> 2] = f10;
  i9 = __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i43, i42, i40, i44, i46, i45) | 0;
  f10 = Math_fround(HEAPF32[i46 >> 2]);
  if (!(f10 <= f2) | ((i9 | 0) == -1 | f10 < Math_fround(0.0))) f10 = f2; else {
   f82 = Math_fround(-Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) >> 2]));
   f78 = Math_fround(-Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) + 4 >> 2]));
   f80 = Math_fround(-Math_fround(HEAPF32[gb + 85248 + (i9 * 12 | 0) + 8 >> 2]));
   f26 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) * f82);
   f81 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * f82);
   f82 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f82);
   f79 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f78);
   f27 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * f78);
   f79 = Math_fround(f26 + f79);
   f27 = Math_fround(f81 + f27);
   f78 = Math_fround(f82 + Math_fround(Math_fround(HEAPF32[i30 >> 2]) * f78));
   f82 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * f80);
   f81 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * f80);
   f81 = Math_fround(f27 + f81);
   f80 = Math_fround(f78 + Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f80));
   HEAPF32[i75 >> 2] = Math_fround(f79 + f82);
   HEAPF32[i67 >> 2] = f81;
   HEAPF32[i68 >> 2] = f80;
   f80 = Math_fround(HEAPF32[i71 >> 2]);
   f81 = Math_fround(HEAPF32[i54 >> 2]);
   f80 = Math_fround(f10 * f80);
   f81 = Math_fround(f10 * f81);
   f82 = Math_fround(f10 * Math_fround(HEAPF32[i55 >> 2]));
   f80 = Math_fround(f80 + Math_fround(HEAPF32[i6 >> 2]));
   f81 = Math_fround(f81 + Math_fround(HEAPF32[i7 >> 2]));
   f82 = Math_fround(f82 + Math_fround(HEAPF32[i8 >> 2]));
   HEAPF32[i61 >> 2] = f80;
   HEAPF32[i52 >> 2] = f81;
   HEAPF32[i53 >> 2] = f82;
   i1 = 1;
  }
  i11 = i11 + 1 | 0;
  if ((i11 | 0) == 8) break; else f2 = f10;
 }
 i42 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
 i43 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
 f17 = Math_fround(HEAPF32[i50 >> 2]);
 f16 = Math_fround(HEAPF32[i36 >> 2]);
 f15 = Math_fround(HEAPF32[i37 >> 2]);
 f14 = Math_fround(HEAPF32[i38 >> 2]);
 f13 = Math_fround(HEAPF32[i39 >> 2]);
 f5 = Math_fround(HEAPF32[i41 >> 2]);
 f4 = Math_fround(HEAPF32[i47 >> 2]);
 f3 = Math_fround(HEAPF32[i48 >> 2]);
 f2 = Math_fround(HEAPF32[i49 >> 2]);
 i6 = 0;
 do {
  f80 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) >> 2]);
  f79 = Math_fround(f80 * f17);
  f81 = Math_fround(f80 * f16);
  f80 = Math_fround(f80 * f15);
  f82 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) + 4 >> 2]);
  f79 = Math_fround(f79 + Math_fround(f82 * f14));
  f81 = Math_fround(f81 + Math_fround(f82 * f13));
  f82 = Math_fround(f80 + Math_fround(f82 * f5));
  f80 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) + 8 >> 2]);
  f81 = Math_fround(f81 + Math_fround(f80 * f3));
  f82 = Math_fround(f82 + Math_fround(f80 * f2));
  HEAPF32[i59 + (i6 * 12 | 0) >> 2] = Math_fround(f79 + Math_fround(f80 * f4));
  HEAPF32[i59 + (i6 * 12 | 0) + 4 >> 2] = f81;
  HEAPF32[i59 + (i6 * 12 | 0) + 8 >> 2] = f82;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 12);
 f17 = Math_fround(HEAPF32[i51 >> 2]);
 f16 = Math_fround(HEAPF32[i23 >> 2]);
 f15 = Math_fround(HEAPF32[i28 >> 2]);
 f14 = Math_fround(HEAPF32[i24 >> 2]);
 f13 = Math_fround(HEAPF32[i29 >> 2]);
 f5 = Math_fround(HEAPF32[i30 >> 2]);
 f4 = Math_fround(HEAPF32[i31 >> 2]);
 f3 = Math_fround(HEAPF32[i32 >> 2]);
 f2 = Math_fround(HEAPF32[i33 >> 2]);
 i6 = 0;
 do {
  f80 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) >> 2]);
  f79 = Math_fround(f80 * f17);
  f81 = Math_fround(f80 * f16);
  f80 = Math_fround(f80 * f15);
  f82 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) + 4 >> 2]);
  f79 = Math_fround(f79 + Math_fround(f82 * f14));
  f81 = Math_fround(f81 + Math_fround(f82 * f13));
  f82 = Math_fround(f80 + Math_fround(f82 * f5));
  f80 = Math_fround(HEAPF32[gb + 84976 + (i6 * 12 | 0) + 8 >> 2]);
  f81 = Math_fround(f81 + Math_fround(f80 * f3));
  f82 = Math_fround(f82 + Math_fround(f80 * f2));
  HEAPF32[i60 + (i6 * 12 | 0) >> 2] = Math_fround(f79 + Math_fround(f80 * f4));
  HEAPF32[i60 + (i6 * 12 | 0) + 4 >> 2] = f81;
  HEAPF32[i60 + (i6 * 12 | 0) + 8 >> 2] = f82;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 12);
 i24 = i63 + 4 | 0;
 i28 = i63 + 8 | 0;
 i29 = i64 + 4 | 0;
 i30 = i64 + 8 | 0;
 i31 = i65 + 4 | 0;
 i32 = i65 + 8 | 0;
 i33 = i66 + 4 | 0;
 i34 = i66 + 8 | 0;
 i37 = i72 + 4 | 0;
 i38 = i72 + 8 | 0;
 i39 = i73 + 4 | 0;
 i40 = i73 + 8 | 0;
 i35 = i62 + 4 | 0;
 i36 = i62 + 8 | 0;
 i6 = 0;
 i7 = 0;
 i8 = 0;
 i9 = 0;
 i11 = 0;
 i12 = 0;
 i23 = 0;
 do {
  f25 = Math_fround(HEAPF32[i59 + (i23 * 12 | 0) >> 2]);
  f2 = Math_fround(HEAPF32[i71 >> 2]);
  f82 = Math_fround(f25 * f2);
  f26 = Math_fround(HEAPF32[i59 + (i23 * 12 | 0) + 4 >> 2]);
  f21 = Math_fround(HEAPF32[i54 >> 2]);
  f82 = Math_fround(f82 + Math_fround(f26 * f21));
  f27 = Math_fround(HEAPF32[i59 + (i23 * 12 | 0) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i55 >> 2]);
  L27 : do if (Math_fround(f82 + Math_fround(f27 * f22)) >= Math_fround(0.0)) {
   i50 = i23 << 1;
   i51 = HEAPU8[i42 + i50 >> 0] | 0;
   i47 = HEAP32[i57 + (i51 * 12 | 0) >> 2] | 0;
   HEAP32[i63 >> 2] = i47;
   i49 = HEAP32[i57 + (i51 * 12 | 0) + 4 >> 2] | 0;
   HEAP32[i24 >> 2] = i49;
   i51 = HEAP32[i57 + (i51 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i28 >> 2] = i51;
   i50 = HEAPU8[i42 + (i50 | 1) >> 0] | 0;
   i46 = HEAP32[i57 + (i50 * 12 | 0) >> 2] | 0;
   HEAP32[i64 >> 2] = i46;
   i48 = HEAP32[i57 + (i50 * 12 | 0) + 4 >> 2] | 0;
   HEAP32[i29 >> 2] = i48;
   i50 = HEAP32[i57 + (i50 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i30 >> 2] = i50;
   f3 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(f3 - f4);
   f13 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = Math_fround(f13 - f14);
   f16 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = Math_fround(f16 - f17);
   f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f15 * f15)) + Math_fround(f18 * f18))));
   if (f20 > Math_fround(0.0)) {
    f82 = Math_fround(Math_fround(.00999999977) / f20);
    f80 = Math_fround(f5 * f82);
    f81 = Math_fround(f15 * f82);
    f82 = Math_fround(f18 * f82);
    HEAPF32[i63 >> 2] = Math_fround(f4 - f80);
    HEAPF32[i24 >> 2] = Math_fround(f14 - f81);
    HEAPF32[i28 >> 2] = Math_fround(f17 - f82);
    HEAPF32[i64 >> 2] = Math_fround(f80 + f3);
    HEAPF32[i29 >> 2] = Math_fround(f81 + f13);
    HEAPF32[i30 >> 2] = Math_fround(f82 + f16);
    i19 = 0;
   } else i19 = 0;
   while (1) {
    f4 = Math_fround(HEAPF32[i60 + (i19 * 12 | 0) >> 2]);
    f82 = Math_fround(f4 * f2);
    f3 = Math_fround(HEAPF32[i60 + (i19 * 12 | 0) + 4 >> 2]);
    f82 = Math_fround(f82 + Math_fround(f3 * f21));
    f2 = Math_fround(HEAPF32[i60 + (i19 * 12 | 0) + 8 >> 2]);
    if (!(Math_fround(f82 + Math_fround(f2 * f22)) >= Math_fround(0.0))) if (!(Math_fround(Math_fround(Math_fround(f4 * f25) + Math_fround(f3 * f26)) + Math_fround(f2 * f27)) >= Math_fround(0.0))) {
     i50 = i19 << 1;
     i51 = HEAPU8[i43 + i50 >> 0] | 0;
     i47 = HEAP32[i58 + (i51 * 12 | 0) >> 2] | 0;
     HEAP32[i65 >> 2] = i47;
     i49 = HEAP32[i58 + (i51 * 12 | 0) + 4 >> 2] | 0;
     HEAP32[i31 >> 2] = i49;
     i51 = HEAP32[i58 + (i51 * 12 | 0) + 8 >> 2] | 0;
     HEAP32[i32 >> 2] = i51;
     i50 = HEAPU8[i43 + (i50 | 1) >> 0] | 0;
     i46 = HEAP32[i58 + (i50 * 12 | 0) >> 2] | 0;
     HEAP32[i66 >> 2] = i46;
     i48 = HEAP32[i58 + (i50 * 12 | 0) + 4 >> 2] | 0;
     HEAP32[i33 >> 2] = i48;
     i50 = HEAP32[i58 + (i50 * 12 | 0) + 8 >> 2] | 0;
     HEAP32[i34 >> 2] = i50;
     f2 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = Math_fround(f2 - f3);
     f5 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f5 - f13);
     f15 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f16 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = Math_fround(f15 - f16);
     f18 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f14 * f14)) + Math_fround(f17 * f17))));
     if (f18 > Math_fround(0.0)) {
      f82 = Math_fround(Math_fround(.00999999977) / f18);
      f80 = Math_fround(f4 * f82);
      f81 = Math_fround(f14 * f82);
      f82 = Math_fround(f17 * f82);
      HEAPF32[i65 >> 2] = Math_fround(f3 - f80);
      HEAPF32[i31 >> 2] = Math_fround(f13 - f81);
      HEAPF32[i32 >> 2] = Math_fround(f16 - f82);
      HEAPF32[i66 >> 2] = Math_fround(f80 + f2);
      HEAPF32[i33 >> 2] = Math_fround(f81 + f5);
      HEAPF32[i34 >> 2] = Math_fround(f82 + f15);
     }
     i51 = (__ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_(i63, i64, i71, i65, i66, i56, i62) | 0) ^ 1;
     f2 = Math_fround(HEAPF32[i56 >> 2]);
     if (!(!(f2 <= f10) | i51)) {
      HEAP32[i72 >> 2] = HEAP32[i63 >> 2];
      HEAP32[i37 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i38 >> 2] = HEAP32[i28 >> 2];
      i9 = HEAP32[i64 >> 2] | 0;
      i11 = HEAP32[i29 >> 2] | 0;
      i12 = HEAP32[i30 >> 2] | 0;
      HEAP32[i73 >> 2] = HEAP32[i65 >> 2];
      HEAP32[i39 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i32 >> 2];
      i6 = HEAP32[i66 >> 2] | 0;
      i7 = HEAP32[i33 >> 2] | 0;
      i8 = HEAP32[i34 >> 2] | 0;
      f81 = Math_fround(HEAPF32[i71 >> 2]);
      f82 = Math_fround(HEAPF32[i54 >> 2]);
      f81 = Math_fround(f2 * f81);
      f82 = Math_fround(f2 * f82);
      f10 = Math_fround(f2 * Math_fround(HEAPF32[i55 >> 2]));
      f81 = Math_fround(f81 + Math_fround(HEAPF32[i62 >> 2]));
      f82 = Math_fround(f82 + Math_fround(HEAPF32[i35 >> 2]));
      f10 = Math_fround(f10 + Math_fround(HEAPF32[i36 >> 2]));
      HEAPF32[i61 >> 2] = f81;
      HEAPF32[i52 >> 2] = f82;
      HEAPF32[i53 >> 2] = f10;
      f10 = f2;
      i1 = 2;
     }
    }
    i19 = i19 + 1 | 0;
    if ((i19 | 0) == 12) break L27;
    f2 = Math_fround(HEAPF32[i71 >> 2]);
    f21 = Math_fround(HEAPF32[i54 >> 2]);
    f22 = Math_fround(HEAPF32[i55 >> 2]);
   }
  } while (0);
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) != 12);
 switch (i1 | 0) {
 case -1:
  {
   i1 = 0;
   break;
  }
 case 2:
  {
   f2 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i72 >> 2]));
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i37 >> 2]));
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i38 >> 2]));
   HEAPF32[i69 >> 2] = f2;
   HEAPF32[i69 + 4 >> 2] = f5;
   HEAPF32[i69 + 8 >> 2] = f3;
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i73 >> 2]));
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i39 >> 2]));
   f2 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) - Math_fround(HEAPF32[i40 >> 2]));
   HEAPF32[i70 >> 2] = f3;
   HEAPF32[i70 + 4 >> 2] = f5;
   HEAPF32[i70 + 8 >> 2] = f2;
   __ZN5physx2Gu21computeEdgeEdgeNormalERNS_6PxVec3ERKS1_S4_S4_S4_S4_f(i75, i72, i69, i73, i70, i71, f10);
   f2 = Math_fround(HEAPF32[i75 >> 2]);
   f5 = Math_fround(f2 * f2);
   f3 = Math_fround(HEAPF32[i67 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f3 * f3));
   f4 = Math_fround(HEAPF32[i68 >> 2]);
   f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f4 * f4))));
   if (f5 > Math_fround(0.0)) {
    f82 = Math_fround(Math_fround(1.0) / f5);
    HEAPF32[i75 >> 2] = Math_fround(f2 * f82);
    HEAPF32[i67 >> 2] = Math_fround(f3 * f82);
    HEAPF32[i68 >> 2] = Math_fround(f4 * f82);
    i74 = 33;
   } else i74 = 33;
   break;
  }
 default:
  i74 = 33;
 }
 if ((i74 | 0) == 33) {
  HEAPF32[i76 >> 2] = f10;
  i1 = 1;
 }
 i76 = i1;
 STACKTOP = i77;
 return i76 | 0;
}

function __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i12, i61, i40, i3, i37, i39, i57, i58, i55, i56) {
 i12 = i12 | 0;
 i61 = i61 | 0;
 i40 = i40 | 0;
 i3 = i3 | 0;
 i37 = i37 | 0;
 i39 = i39 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 var i1 = 0, i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i59 = 0, i60 = 0, i62 = 0, i63 = 0, f64 = f0, i65 = 0, f66 = f0, f67 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i63 + 48 | 0;
 i59 = i63;
 i35 = i63 + 96 | 0;
 i53 = HEAP32[i58 >> 2] | 0;
 __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE(i60, i56);
 i38 = (HEAP32[i3 + 32 >> 2] | 0) + (HEAPU16[i37 + 16 >> 1] | 0) | 0;
 i54 = i37 + 18 | 0;
 i4 = HEAPU8[i54 >> 0] | 0;
 i2 = (i4 << 4) + 16 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i1 + 15 & -16;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i4 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i12 + 96 | 0;
 HEAP32[i59 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i59 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i59 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i59 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 i36 = i59 + 16 | 0;
 i42 = i12 + 112 | 0;
 HEAP32[i36 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
 i36 = i59 + 32 | 0;
 i42 = i12 + 128 | 0;
 HEAP32[i36 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
 i36 = i3 + 28 | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i39 >> 2] | 0) + 16 >> 2] | 0, i39 | 0, i38 | 0, i4 | 0, HEAP32[i36 >> 2] | 0, i52 | 0);
 f6 = Math_fround(HEAPF32[i60 >> 2]);
 i42 = i60 + 16 | 0;
 f7 = Math_fround(HEAPF32[i42 >> 2]);
 i43 = i60 + 32 | 0;
 f20 = Math_fround(HEAPF32[i43 >> 2]);
 i44 = i60 + 4 | 0;
 f8 = Math_fround(HEAPF32[i44 >> 2]);
 i45 = i60 + 20 | 0;
 f9 = Math_fround(HEAPF32[i45 >> 2]);
 i46 = i60 + 36 | 0;
 f28 = Math_fround(HEAPF32[i46 >> 2]);
 i47 = i60 + 8 | 0;
 f11 = Math_fround(HEAPF32[i47 >> 2]);
 i48 = i60 + 24 | 0;
 f14 = Math_fround(HEAPF32[i48 >> 2]);
 i49 = i60 + 40 | 0;
 f16 = Math_fround(HEAPF32[i49 >> 2]);
 f19 = Math_fround(HEAPF32[i59 >> 2]);
 i32 = i59 + 4 | 0;
 f18 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i59 + 8 | 0;
 f50 = Math_fround(HEAPF32[i33 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f6) + Math_fround(f18 * f7)) + Math_fround(f50 * f20));
 f10 = Math_fround(Math_fround(Math_fround(f19 * f8) + Math_fround(f18 * f9)) + Math_fround(f50 * f28));
 f50 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f18 * f14)) + Math_fround(f50 * f16));
 HEAPF32[i59 >> 2] = f13;
 HEAPF32[i32 >> 2] = f10;
 HEAPF32[i33 >> 2] = f50;
 HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
 i33 = f13 > Math_fround(3402823469999999843913219.0e14);
 f18 = i33 ? Math_fround(3402823469999999843913219.0e14) : f13;
 i33 = f10 > Math_fround(3402823469999999843913219.0e14);
 f19 = i33 ? Math_fround(3402823469999999843913219.0e14) : f10;
 i33 = f13 < Math_fround(-3402823469999999843913219.0e14);
 f13 = i33 ? Math_fround(-3402823469999999843913219.0e14) : f13;
 i33 = f10 < Math_fround(-3402823469999999843913219.0e14);
 f10 = i33 ? Math_fround(-3402823469999999843913219.0e14) : f10;
 i33 = i59 + 16 | 0;
 f64 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i59 + 20 | 0;
 f5 = Math_fround(HEAPF32[i34 >> 2]);
 i30 = i59 + 24 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f17 = Math_fround(Math_fround(Math_fround(f64 * f6) + Math_fround(f5 * f7)) + Math_fround(f15 * f20));
 f29 = Math_fround(Math_fround(Math_fround(f64 * f8) + Math_fround(f5 * f9)) + Math_fround(f15 * f28));
 f15 = Math_fround(Math_fround(Math_fround(f64 * f11) + Math_fround(f5 * f14)) + Math_fround(f15 * f16));
 HEAPF32[i33 >> 2] = f17;
 HEAPF32[i34 >> 2] = f29;
 HEAPF32[i30 >> 2] = f15;
 HEAPF32[i59 + 28 >> 2] = Math_fround(0.0);
 f18 = f18 < f17 ? f18 : f17;
 f19 = f19 < f29 ? f19 : f29;
 f17 = f13 > f17 ? f13 : f17;
 f29 = f10 > f29 ? f10 : f29;
 i30 = i59 + 32 | 0;
 f10 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i59 + 36 | 0;
 f13 = Math_fround(HEAPF32[i31 >> 2]);
 i41 = i59 + 40 | 0;
 f15 = Math_fround(HEAPF32[i41 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f10 * f6) + Math_fround(f13 * f7)) + Math_fround(f15 * f20));
 f28 = Math_fround(Math_fround(Math_fround(f10 * f8) + Math_fround(f13 * f9)) + Math_fround(f15 * f28));
 f16 = Math_fround(Math_fround(Math_fround(f10 * f11) + Math_fround(f13 * f14)) + Math_fround(f15 * f16));
 HEAPF32[i30 >> 2] = f20;
 HEAPF32[i31 >> 2] = f28;
 HEAPF32[i41 >> 2] = f16;
 HEAPF32[i59 + 44 >> 2] = Math_fround(0.0);
 i41 = i1 + 15 & -16;
 f18 = Math_fround((f18 < f20 ? f18 : f20) + Math_fround(-1.1920929e-07));
 f19 = Math_fround((f19 < f28 ? f19 : f28) + Math_fround(-1.1920929e-07));
 f20 = Math_fround((f17 > f20 ? f17 : f20) + Math_fround(1.1920929e-07));
 f28 = Math_fround((f29 > f28 ? f29 : f28) + Math_fround(1.1920929e-07));
 f29 = Math_fround(f50 + Math_fround(HEAPF32[i55 >> 2]));
 i1 = HEAP8[i54 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f19 = Math_fround(3402823469999999843913219.0e14);
  f18 = Math_fround(3402823469999999843913219.0e14);
  f17 = Math_fround(-3402823469999999843913219.0e14);
  f16 = Math_fround(-3402823469999999843913219.0e14);
  i2 = i1 & 255;
  i1 = 0;
 } else {
  i24 = i56 + 4 | 0;
  i25 = i56 + 8 | 0;
  i26 = i12 + 96 | 0;
  i27 = i12 + 100 | 0;
  i22 = i12 + 104 | 0;
  f7 = Math_fround(3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f6 = Math_fround(-3402823469999999843913219.0e14);
  i23 = 0;
  i1 = 0;
  do {
   i2 = i52 + (i23 << 4) | 0;
   f15 = Math_fround(HEAPF32[i2 >> 2]);
   i3 = i52 + (i23 << 4) + 4 | 0;
   f16 = Math_fround(HEAPF32[i3 >> 2]);
   i4 = i52 + (i23 << 4) + 8 | 0;
   f17 = Math_fround(HEAPF32[i4 >> 2]);
   i12 = i52 + (i23 << 4) + 12 | 0;
   i21 = HEAP32[i12 >> 2] | 0;
   f14 = Math_fround(f15 * Math_fround(HEAPF32[i60 >> 2]));
   f14 = Math_fround(f14 + Math_fround(f16 * Math_fround(HEAPF32[i42 >> 2])));
   f14 = Math_fround(f14 + Math_fround(f17 * Math_fround(HEAPF32[i43 >> 2])));
   f13 = Math_fround(f15 * Math_fround(HEAPF32[i44 >> 2]));
   f13 = Math_fround(f13 + Math_fround(f16 * Math_fround(HEAPF32[i45 >> 2])));
   f13 = Math_fround(f13 + Math_fround(f17 * Math_fround(HEAPF32[i46 >> 2])));
   f64 = Math_fround(f15 * Math_fround(HEAPF32[i47 >> 2]));
   f64 = Math_fround(f64 + Math_fround(f16 * Math_fround(HEAPF32[i48 >> 2])));
   f64 = Math_fround(f64 + Math_fround(f17 * Math_fround(HEAPF32[i49 >> 2])));
   HEAPF32[i2 >> 2] = f14;
   HEAPF32[i3 >> 2] = f13;
   HEAPF32[i4 >> 2] = f64;
   HEAPF32[i12 >> 2] = Math_fround(0.0);
   HEAPF32[i41 + (i23 << 4) >> 2] = Math_fround(f64 - f50);
   i65 = i41 + (i23 << 4) + 4 | 0;
   HEAP32[i65 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i65 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i65 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   f13 = Math_fround(HEAPF32[i2 >> 2]);
   f14 = Math_fround(HEAPF32[i3 >> 2]);
   HEAPF32[i4 >> 2] = f50;
   HEAPF32[i12 >> 2] = Math_fround(0.0);
   f7 = f7 < f13 ? f7 : f13;
   f5 = f5 < f14 ? f5 : f14;
   f8 = f8 > f13 ? f8 : f13;
   f6 = f6 > f14 ? f6 : f14;
   do if (f29 > f64) {
    HEAP8[i51 + i23 >> 0] = 1;
    f14 = Math_fround(HEAPF32[i2 >> 2]);
    f11 = Math_fround(HEAPF32[i3 >> 2]);
    if (!(f18 > f14 | f14 > f20 | (f19 > f11 | f11 > f28))) {
     f10 = Math_fround(HEAPF32[i31 >> 2]);
     f9 = Math_fround(HEAPF32[i32 >> 2]);
     i4 = f10 > f11;
     i3 = f9 > f11;
     if (i4 ^ i3) {
      f64 = Math_fround(HEAPF32[i30 >> 2]);
      f66 = Math_fround(f9 - f10);
      f13 = Math_fround(f14 * f66);
      i65 = f66 > Math_fround(0.0);
      f64 = Math_fround(Math_fround(f66 * Math_fround(f64 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f10) * Math_fround(Math_fround(HEAPF32[i59 >> 2]) - f64)));
      if (!((i65 ? f64 : f13) >= (i65 ? f13 : f64))) i2 = 0; else i2 = 1;
     } else i2 = 0;
     f13 = Math_fround(HEAPF32[i34 >> 2]);
     i12 = f13 > f11;
     if (i3 ^ i12) {
      f66 = Math_fround(HEAPF32[i59 >> 2]);
      f67 = Math_fround(f13 - f9);
      f64 = Math_fround(f14 * f67);
      i65 = f67 > Math_fround(0.0);
      f66 = Math_fround(Math_fround(f67 * Math_fround(f66 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f9) * Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f66)));
      if ((i65 ? f66 : f64) >= (i65 ? f64 : f66)) if ((i2 | 0) == 1) break; else i2 = 1;
     }
     if (i12 ^ i4) {
      f67 = Math_fround(HEAPF32[i33 >> 2]);
      f64 = Math_fround(f10 - f13);
      f66 = Math_fround(f14 * f64);
      i65 = f64 > Math_fround(0.0);
      f67 = Math_fround(Math_fround(f64 * Math_fround(f67 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f13) * Math_fround(Math_fround(HEAPF32[i30 >> 2]) - f67)));
      if (!((i65 ? f67 : f66) >= (i65 ? f66 : f67))) i62 = 46; else if ((i2 | 0) == 1) break;
     } else i62 = 46;
     if ((i62 | 0) == 46) {
      i62 = 0;
      if (!i2) break;
     }
     f14 = Math_fround(HEAPF32[i56 >> 2]);
     f64 = Math_fround(HEAPF32[i24 >> 2]);
     f66 = Math_fround(HEAPF32[i25 >> 2]);
     f10 = Math_fround(HEAPF32[i26 >> 2]);
     f67 = Math_fround(HEAPF32[i27 >> 2]);
     f67 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(f10 - f15)) + Math_fround(f64 * Math_fround(f67 - f16))) + Math_fround(f66 * Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f17)));
     f10 = Math_fround(f15 + Math_fround(f14 * f67));
     f11 = Math_fround(f16 + Math_fround(f64 * f67));
     f13 = Math_fround(f17 + Math_fround(f66 * f67));
     f67 = Math_fround(-f67);
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) >> 2] = f15;
     HEAPF32[i57 + (i65 << 6) + 4 >> 2] = f16;
     HEAPF32[i57 + (i65 << 6) + 8 >> 2] = f17;
     HEAP32[i57 + (i65 << 6) + 12 >> 2] = i21;
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) + 16 >> 2] = f10;
     HEAPF32[i57 + (i65 << 6) + 20 >> 2] = f11;
     HEAPF32[i57 + (i65 << 6) + 24 >> 2] = f13;
     HEAPF32[i57 + (i65 << 6) + 28 >> 2] = Math_fround(0.0);
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) + 32 >> 2] = f14;
     HEAPF32[i57 + (i65 << 6) + 36 >> 2] = f64;
     HEAPF32[i57 + (i65 << 6) + 40 >> 2] = f66;
     HEAPF32[i57 + (i65 << 6) + 44 >> 2] = f67;
     i65 = HEAP32[i58 >> 2] | 0;
     HEAP32[i58 >> 2] = i65 + 1;
     HEAP32[i57 + (i65 << 6) + 48 >> 2] = i61;
     i1 = i1 + 1 | 0;
    }
   } while (0);
   i23 = i23 + 1 | 0;
   i2 = HEAPU8[i54 >> 0] | 0;
  } while (i23 >>> 0 < i2 >>> 0);
  f19 = Math_fround(f5 + Math_fround(-1.1920929e-07));
  f18 = Math_fround(f7 + Math_fround(-1.1920929e-07));
  f17 = Math_fround(f6 + Math_fround(1.1920929e-07));
  f16 = Math_fround(f8 + Math_fround(1.1920929e-07));
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i63;
  return;
 }
 i23 = HEAP32[i39 + 40 >> 2] | 0;
 f67 = Math_fround(HEAPF32[i37 >> 2]);
 f15 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f13 = Math_fround(f67 * Math_fround(HEAPF32[i23 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 4 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f29 * Math_fround(HEAPF32[i23 + 8 >> 2])));
 f14 = Math_fround(f67 * Math_fround(HEAPF32[i23 + 16 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 20 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f29 * Math_fround(HEAPF32[i23 + 24 >> 2])));
 f67 = Math_fround(f67 * Math_fround(HEAPF32[i23 + 32 >> 2]));
 f15 = Math_fround(f67 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 36 >> 2])));
 f29 = Math_fround(f15 + Math_fround(f29 * Math_fround(HEAPF32[i23 + 40 >> 2])));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f29 * f29)))));
 f13 = Math_fround(f13 * f15);
 f14 = Math_fround(f14 * f15);
 f15 = Math_fround(f29 * f15);
 i23 = HEAP32[i39 + 36 >> 2] | 0;
 i24 = HEAPU8[i38 >> 0] | 0;
 i12 = HEAP32[i36 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) >> 2]);
 f67 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) + 8 >> 2]);
 f64 = Math_fround(f29 * Math_fround(HEAPF32[i23 >> 2]));
 f64 = Math_fround(f64 + Math_fround(f67 * Math_fround(HEAPF32[i23 + 16 >> 2])));
 f64 = Math_fround(f64 + Math_fround(f11 * Math_fround(HEAPF32[i23 + 32 >> 2])));
 f66 = Math_fround(f29 * Math_fround(HEAPF32[i23 + 4 >> 2]));
 f66 = Math_fround(f66 + Math_fround(f67 * Math_fround(HEAPF32[i23 + 20 >> 2])));
 f66 = Math_fround(f66 + Math_fround(f11 * Math_fround(HEAPF32[i23 + 36 >> 2])));
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i23 + 8 >> 2]));
 f67 = Math_fround(f29 + Math_fround(f67 * Math_fround(HEAPF32[i23 + 24 >> 2])));
 f11 = Math_fround(Math_fround(Math_fround(f13 * f64) + Math_fround(f14 * f66)) + Math_fround(f15 * Math_fround(f67 + Math_fround(f11 * Math_fround(HEAPF32[i23 + 40 >> 2])))));
 i23 = i56 + 4 | 0;
 i24 = i56 + 8 | 0;
 i12 = 0;
 while (1) {
  i65 = HEAP8[i54 >> 0] | 0;
  i3 = i65 & 255;
  f9 = Math_fround(HEAPF32[i59 + (i12 << 4) >> 2]);
  f10 = Math_fround(HEAPF32[i59 + (i12 << 4) + 4 >> 2]);
  L30 : do if (!(i65 << 24 >> 24 == 0 | (f18 > f9 | f9 > f16 | (f19 > f10 | f10 > f17)))) {
   i2 = i3 + -1 | 0;
   f6 = Math_fround(HEAPF32[i52 + (i2 << 4) + 4 >> 2]);
   i4 = 0;
   i1 = 0;
   while (1) {
    f5 = f6;
    f6 = Math_fround(HEAPF32[i52 + (i4 << 4) + 4 >> 2]);
    if (f5 > f10 ^ f6 > f10) {
     f67 = Math_fround(HEAPF32[i52 + (i2 << 4) >> 2]);
     f64 = Math_fround(f6 - f5);
     f66 = Math_fround(f9 * f64);
     i65 = f64 > Math_fround(0.0);
     f67 = Math_fround(Math_fround(f64 * Math_fround(f67 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f10 - f5) * Math_fround(Math_fround(HEAPF32[i52 + (i4 << 4) >> 2]) - f67)));
     if ((i65 ? f67 : f66) >= (i65 ? f66 : f67)) {
      if ((i1 | 0) == 1) break L30;
      i1 = i1 + 1 | 0;
     }
    }
    i2 = i4 + 1 | 0;
    if (i2 >>> 0 >= i3 >>> 0) break; else {
     i65 = i4;
     i4 = i2;
     i2 = i65;
    }
   }
   if (i1 | 0) {
    f5 = Math_fround(HEAPF32[i59 + (i12 << 4) + 8 >> 2]);
    f7 = Math_fround(f9 * Math_fround(HEAPF32[i60 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f10 * Math_fround(HEAPF32[i44 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i47 >> 2])));
    f8 = Math_fround(f9 * Math_fround(HEAPF32[i42 >> 2]));
    f8 = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i45 >> 2])));
    f8 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i48 >> 2])));
    f6 = Math_fround(f9 * Math_fround(HEAPF32[i43 >> 2]));
    f6 = Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i46 >> 2])));
    f5 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i49 >> 2])));
    f6 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f14 * f8)) + Math_fround(f15 * f5)) - f11);
    if (!(f6 > Math_fround(HEAPF32[i55 >> 2]))) {
     f10 = Math_fround(f7 - Math_fround(f13 * f6));
     f20 = Math_fround(f8 - Math_fround(f14 * f6));
     f28 = Math_fround(f5 - Math_fround(f15 * f6));
     f6 = Math_fround(f10 - f7);
     f9 = Math_fround(f20 - f8);
     f67 = Math_fround(f28 - f5);
     f29 = Math_fround(HEAPF32[i56 >> 2]);
     f64 = Math_fround(HEAPF32[i23 >> 2]);
     f66 = Math_fround(HEAPF32[i24 >> 2]);
     f67 = Math_fround(Math_fround(Math_fround(f6 * f29) + Math_fround(f9 * f64)) + Math_fround(f67 * f66));
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) >> 2] = f10;
     HEAPF32[i57 + (i65 << 6) + 4 >> 2] = f20;
     HEAPF32[i57 + (i65 << 6) + 8 >> 2] = f28;
     HEAPF32[i57 + (i65 << 6) + 12 >> 2] = Math_fround(0.0);
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) + 16 >> 2] = f7;
     HEAPF32[i57 + (i65 << 6) + 20 >> 2] = f8;
     HEAPF32[i57 + (i65 << 6) + 24 >> 2] = f5;
     HEAPF32[i57 + (i65 << 6) + 28 >> 2] = Math_fround(0.0);
     i65 = HEAP32[i58 >> 2] | 0;
     HEAPF32[i57 + (i65 << 6) + 32 >> 2] = f29;
     HEAPF32[i57 + (i65 << 6) + 36 >> 2] = f64;
     HEAPF32[i57 + (i65 << 6) + 40 >> 2] = f66;
     HEAPF32[i57 + (i65 << 6) + 44 >> 2] = f67;
     i65 = HEAP32[i58 >> 2] | 0;
     HEAP32[i58 >> 2] = i65 + 1;
     HEAP32[i57 + (i65 << 6) + 48 >> 2] = i61;
    }
   }
  } while (0);
  i12 = i12 + 1 | 0;
  if ((i12 | 0) == 3) {
   i22 = 0;
   i1 = i40;
   break;
  }
 }
 while (1) {
  i12 = i1 & 255;
  if (i12 & 248 | 0) {
   i1 = 2;
   i21 = 0;
   while (1) {
    if (1 << i1 + 3 & i12 | 0) {
     f18 = Math_fround(HEAPF32[i59 + (i21 << 4) >> 2]);
     f19 = Math_fround(HEAPF32[i59 + (i21 << 4) + 4 >> 2]);
     f20 = Math_fround(HEAPF32[i59 + (i1 << 4) >> 2]);
     f13 = Math_fround(HEAPF32[i59 + (i1 << 4) + 4 >> 2]);
     f14 = f18 < f20 ? f18 : f20;
     f15 = f19 < f13 ? f19 : f13;
     f16 = f18 > f20 ? f18 : f20;
     f17 = f19 > f13 ? f19 : f13;
     i1 = HEAP8[i54 >> 0] | 0;
     if (i1 << 24 >> 24) {
      i3 = i1;
      i1 = (i1 & 255) + -1 | 0;
      i4 = 0;
      while (1) {
       if (!(HEAP8[i51 + i4 >> 0] | 0)) if (!(HEAP8[i51 + i1 >> 0] | 0)) i1 = i3; else i62 = 31; else i62 = 31;
       if ((i62 | 0) == 31) {
        i62 = 0;
        f5 = Math_fround(HEAPF32[i52 + (i4 << 4) >> 2]);
        f9 = Math_fround(HEAPF32[i52 + (i4 << 4) + 4 >> 2]);
        f6 = Math_fround(HEAPF32[i52 + (i1 << 4) >> 2]);
        f10 = Math_fround(HEAPF32[i52 + (i1 << 4) + 4 >> 2]);
        if ((f14 > (f5 > f6 ? f5 : f6) ? 1 : (f5 < f6 ? f5 : f6) > f16) | (f15 > (f9 > f10 ? f9 : f10) ? 1 : (f9 < f10 ? f9 : f10) > f17)) i1 = i3; else {
         f7 = Math_fround(Math_fround(Math_fround(f18 - f5) * Math_fround(f13 - f9)) - Math_fround(Math_fround(f20 - f5) * Math_fround(f19 - f9)));
         f8 = Math_fround(Math_fround(Math_fround(f18 - f6) * Math_fround(f13 - f10)) - Math_fround(Math_fround(f20 - f6) * Math_fround(f19 - f10)));
         if (Math_fround(f7 * f8) < Math_fround(0.0)) if (Math_fround(Math_fround(Math_fround(Math_fround(f5 - f18) * Math_fround(f10 - f19)) - Math_fround(Math_fround(f9 - f19) * Math_fround(f6 - f18))) * Math_fround(Math_fround(Math_fround(f5 - f20) * Math_fround(f10 - f13)) - Math_fround(Math_fround(f9 - f13) * Math_fround(f6 - f20)))) < Math_fround(0.0)) {
          f8 = Math_fround(f7 * Math_fround(Math_fround(1.0) / Math_fround(f8 - f7)));
          f7 = Math_fround(f50 + Math_fround(HEAPF32[i41 + (i4 << 4) >> 2]));
          f11 = Math_fround(f5 - Math_fround(f8 * Math_fround(f6 - f5)));
          f10 = Math_fround(f9 - Math_fround(f8 * Math_fround(f10 - f9)));
          f5 = Math_fround(f7 - Math_fround(f8 * Math_fround(Math_fround(f50 + Math_fround(HEAPF32[i41 + (i1 << 4) >> 2])) - f7)));
          f6 = Math_fround(HEAPF32[i47 >> 2]);
          f7 = Math_fround(HEAPF32[i48 >> 2]);
          f8 = Math_fround(HEAPF32[i49 >> 2]);
          f9 = Math_fround(f5 - f50);
          if (f9 > Math_fround(HEAPF32[i55 >> 2])) i1 = i3; else {
           f67 = Math_fround(HEAPF32[i46 >> 2]);
           f29 = Math_fround(HEAPF32[i43 >> 2]);
           f66 = Math_fround(HEAPF32[i45 >> 2]);
           f28 = Math_fround(HEAPF32[i42 >> 2]);
           f64 = Math_fround(HEAPF32[i44 >> 2]);
           f67 = Math_fround(Math_fround(f11 * f29) + Math_fround(f10 * f67));
           f29 = Math_fround(f67 + Math_fround(f5 * f8));
           f66 = Math_fround(Math_fround(f11 * f28) + Math_fround(f10 * f66));
           f28 = Math_fround(f66 + Math_fround(f5 * f7));
           f64 = Math_fround(Math_fround(Math_fround(HEAPF32[i60 >> 2]) * f11) + Math_fround(f64 * f10));
           f11 = Math_fround(f64 + Math_fround(f6 * f5));
           f67 = Math_fround(f67 + Math_fround(f50 * f8));
           f66 = Math_fround(f66 + Math_fround(f50 * f7));
           f64 = Math_fround(f64 + Math_fround(f50 * f6));
           i39 = HEAP32[i56 >> 2] | 0;
           i40 = HEAP32[i23 >> 2] | 0;
           i65 = HEAP32[i24 >> 2] | 0;
           i1 = HEAP32[i58 >> 2] | 0;
           HEAPF32[i57 + (i1 << 6) >> 2] = f11;
           HEAPF32[i57 + (i1 << 6) + 4 >> 2] = f28;
           HEAPF32[i57 + (i1 << 6) + 8 >> 2] = f29;
           HEAPF32[i57 + (i1 << 6) + 12 >> 2] = Math_fround(0.0);
           i1 = HEAP32[i58 >> 2] | 0;
           HEAPF32[i57 + (i1 << 6) + 16 >> 2] = f64;
           HEAPF32[i57 + (i1 << 6) + 20 >> 2] = f66;
           HEAPF32[i57 + (i1 << 6) + 24 >> 2] = f67;
           HEAPF32[i57 + (i1 << 6) + 28 >> 2] = Math_fround(0.0);
           i1 = HEAP32[i58 >> 2] | 0;
           HEAP32[i57 + (i1 << 6) + 32 >> 2] = i39;
           HEAP32[i57 + (i1 << 6) + 36 >> 2] = i40;
           HEAP32[i57 + (i1 << 6) + 40 >> 2] = i65;
           HEAPF32[i57 + (i1 << 6) + 44 >> 2] = f9;
           i1 = HEAP32[i58 >> 2] | 0;
           HEAP32[i58 >> 2] = i1 + 1;
           HEAP32[i57 + (i1 << 6) + 48 >> 2] = i61;
           i1 = HEAP8[i54 >> 0] | 0;
          }
         } else i1 = i3; else i1 = i3;
        }
       }
       i2 = i4 + 1 | 0;
       if (i2 >>> 0 < (i1 & 255) >>> 0) {
        i65 = i4;
        i3 = i1;
        i4 = i2;
        i1 = i65;
       } else break;
      }
     }
    }
    i1 = i21 + 1 | 0;
    if ((i1 | 0) == 3) break; else {
     i65 = i21;
     i21 = i1;
     i1 = i65;
    }
   }
  }
  if ((i53 | 0) != (HEAP32[i58 >> 2] | 0)) {
   i62 = 40;
   break;
  }
  i22 = i22 + 1 | 0;
  if (i22 >>> 0 >= 2) {
   i62 = 40;
   break;
  } else i1 = (i12 ^ 255) & 255;
 }
 if ((i62 | 0) == 40) {
  STACKTOP = i63;
  return;
 }
}

function __ZN7mecanim9animation26InitClipMuscleAverageSpeedERNS0_18ClipMuscleConstantEi(i65, i59) {
 i65 = i65 | 0;
 i59 = i59 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, i75 = 0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i68 + 8 | 0;
 i63 = i68;
 i66 = i68 + 28 | 0;
 i2 = gb + 64016 | 0;
 i61 = HEAP32[i2 + 4 >> 2] | 0;
 i67 = i63;
 HEAP32[i67 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i67 + 4 >> 2] = i61;
 HEAP32[i66 >> 2] = gb + 175924 + 8;
 i67 = i66 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i63);
 i61 = i6;
 i2 = HEAP32[i61 + 4 >> 2] | 0;
 i60 = i67;
 HEAP32[i60 >> 2] = HEAP32[i61 >> 2];
 HEAP32[i60 + 4 >> 2] = i2;
 i60 = i65 + 1060 | 0;
 i2 = HEAP32[i60 >> 2] | 0;
 i61 = i60;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i61 | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] | 0) | 0;
 i67 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4, 4, i67, 0, gb + 913345 | 0, 415) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i66 >> 2] >> 2] | 0, i66 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i67 >> 2] = i1;
 i56 = HEAP32[i60 >> 2] | 0;
 i56 = (i56 | 0) == 0 ? 0 : i56 + i61 | 0;
 i5 = i56 + 8 | 0;
 i57 = i56 + 16 | 0;
 i56 = (HEAP32[i57 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) + (HEAP32[i56 + 36 >> 2] | 0) | 0;
 i62 = mftCall_iiii(HEAP32[HEAP32[i66 >> 2] >> 2] | 0, i66 | 0, 20, 4) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i62 + 16 >> 2] = i56 - i2 - (HEAP32[i57 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i66 >> 2] >> 2] | 0, i66 | 0, i2 * 20 | 0, 4) | 0;
  i3 = i1 + (i2 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i62 >> 2] = i1;
 HEAP32[i62 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAPF32[i62 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i62 + 12 >> 2] = 0;
 f44 = Math_fround(HEAPF32[i65 + 1068 >> 2]);
 f7 = Math_fround(HEAPF32[i65 + 1064 >> 2]);
 f58 = Math_fround(i59 | 0);
 f44 = Math_fround(Math_fround(f44 - f7) / f58);
 if ((i59 | 0) < 0) {
  f4 = Math_fround(0.0);
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i45 = i65 + 1088 | 0;
  i46 = i65 + 1092 | 0;
  i47 = i65 + 1096 | 0;
  i48 = i65 + 1100 | 0;
  i49 = i65 + 1104 | 0;
  i50 = i65 + 1108 | 0;
  i51 = i65 + 1112 | 0;
  i52 = i65 + 1116 | 0;
  i53 = i65 + 1120 | 0;
  i54 = i65 + 1124 | 0;
  i55 = i65 + 1128 | 0;
  i56 = i65 + 1132 | 0;
  i57 = i65 + 1136 | 0;
  i35 = i65 + 1140 | 0;
  i36 = i65 + 1072 | 0;
  i37 = i65 + 1731 | 0;
  i38 = i65 + 900 | 0;
  i39 = i65 + 1727 | 0;
  i40 = i65 + 904 | 0;
  i41 = i65 + 908 | 0;
  i42 = i65 + 912 | 0;
  i43 = i65 + 1724 | 0;
  i34 = 0;
  f4 = Math_fround(0.0);
  i3 = 0;
  i29 = 0;
  i2 = 0;
  i30 = 0;
  i31 = 0;
  i32 = 1065353216;
  i28 = 0;
  i1 = 0;
  i27 = 0;
  i33 = 0;
  while (1) {
   HEAPF32[i63 >> 2] = f7;
   i6 = HEAP32[i60 >> 2] | 0;
   __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i6 | 0) == 0 ? 0 : i6 + i61 | 0, i63, i62, i67);
   i6 = HEAP32[i45 >> 2] | 0;
   do if ((i6 | 0) == -1) {
    i5 = HEAP32[i46 >> 2] | 0;
    if ((i5 | 0) == -1) if ((HEAP32[i47 >> 2] | 0) == -1) if ((HEAP32[i48 >> 2] | 0) == -1) if ((HEAP32[i49 >> 2] | 0) == -1) if ((HEAP32[i50 >> 2] | 0) == -1) if ((HEAP32[i51 >> 2] | 0) == -1) {
     i6 = HEAP32[i67 >> 2] | 0;
     i5 = HEAP32[i52 >> 2] | 0;
     if ((i5 | 0) == -1) i25 = 0; else i25 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
     i5 = HEAP32[i53 >> 2] | 0;
     if ((i5 | 0) == -1) i26 = 0; else i26 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
     i5 = HEAP32[i54 >> 2] | 0;
     if ((i5 | 0) == -1) i24 = 0; else i24 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
     i5 = HEAP32[i55 >> 2] | 0;
     if ((i5 | 0) == -1) f13 = Math_fround(0.0); else f13 = Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]);
     i5 = HEAP32[i56 >> 2] | 0;
     if ((i5 | 0) == -1) f10 = Math_fround(0.0); else f10 = Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]);
     i5 = HEAP32[i57 >> 2] | 0;
     if ((i5 | 0) == -1) f9 = Math_fround(0.0); else f9 = Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]);
     i5 = HEAP32[i35 >> 2] | 0;
     if ((i5 | 0) == -1) f8 = Math_fround(1.0); else f8 = Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]);
     f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8))))));
     f22 = Math_fround(f13 * f20);
     f21 = Math_fround(f10 * f20);
     f23 = Math_fround(f9 * f20);
     f8 = Math_fround(f8 * f20);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     i18 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
     i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     f8 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(.0174532924));
     f23 = Math_fround(Math_fround(Math_abs(Math_fround(f8))) + Math_fround(3.14159274));
     f23 = Math_fround(Math_fround(f23 - Math_fround(Math_fround(_truncf(Math_fround(f23 / Math_fround(6.28318548)))) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
     i5 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
     f8 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(Math_fround((HEAP32[tempDoublePtr >> 2] = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
     f23 = Math_fround(f8 + Math_fround(-.25));
     f8 = Math_fround(f8 + Math_fround(0.0));
     f21 = Math_fround(+_roundf(+f23));
     f21 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f23 - f21))));
     f8 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f8 - Math_fround(+_roundf(+f8))))));
     f23 = Math_fround(f21 * f21);
     f10 = Math_fround(f8 * f8);
     f22 = Math_fround(f23 * f23);
     f9 = Math_fround(f10 * f10);
     f10 = Math_fround(Math_fround(f21 * Math_fround(Math_fround(Math_fround(f22 * f22) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f23 * Math_fround(41.3416595))) + Math_fround(f22 * Math_fround(Math_fround(81.6018218) - Math_fround(f23 * Math_fround(76.5686187))))))) / Math_fround(f8 * Math_fround(Math_fround(Math_fround(f9 * f9) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f10 * Math_fround(41.3416595))) + Math_fround(f9 * Math_fround(Math_fround(81.6018218) - Math_fround(f10 * Math_fround(76.5686187))))))));
     f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)) + Math_fround(1.0)))));
     f8 = Math_fround(f9 * Math_fround(0.0));
     f10 = Math_fround(f9 * f10);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     i15 = HEAP32[i38 >> 2] | 0;
     if (!(HEAP8[i37 >> 0] | 0)) {
      i14 = i5;
      i12 = i5;
      f8 = f10;
      i5 = HEAP32[i40 >> 2] | 0;
      i6 = HEAP32[i41 >> 2] | 0;
      i11 = HEAP32[i42 >> 2] | 0;
     } else {
      i5 = HEAP32[i40 >> 2] | 0;
      i6 = HEAP32[i41 >> 2] | 0;
      f23 = Math_fround(HEAPF32[i42 >> 2]);
      f70 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f73 = Math_fround(f70 * f10);
      f20 = Math_fround(f9 * f23);
      f21 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f72 = Math_fround(f8 * f21);
      f71 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f69 = Math_fround(f8 * f71);
      f22 = Math_fround(f8 * f70);
      f13 = Math_fround(f8 * f23);
      f8 = Math_fround(Math_fround(Math_fround(f73 - Math_fround(f9 * f71)) - f13) - f72);
      f20 = Math_fround(Math_fround(Math_fround(f20 - f22) - f69) - Math_fround(f10 * f21));
      f13 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f10 * f71)) - Math_fround(f9 * f70)) - f13);
      f21 = Math_fround(Math_fround(Math_fround(f69 - f22) - Math_fround(f9 * f21)) - Math_fround(f10 * f23));
      i14 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
      f21 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f13 = Math_fround(f21 * f21);
      f8 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = Math_fround(f8 * f8);
      f22 = (HEAP32[tempDoublePtr >> 2] = i14 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 + f9) + Math_fround(Math_fround(f20 * f20) + Math_fround(f22 * f22))))));
      f21 = Math_fround(f9 * f21);
      f8 = Math_fround(f9 * f8);
      f22 = Math_fround(f9 * f22);
      f9 = Math_fround(f9 * f20);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
     }
     i76 = HEAPU8[i39 >> 0] | 0;
     i75 = 0 - i76 | 0;
     i76 = i76 + -1 | 0;
     f73 = (HEAP32[tempDoublePtr >> 2] = i76 & i19 | i11 & i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f69 = (HEAP32[tempDoublePtr >> 2] = i76 & i16 | i15 & i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f74 = Math_fround(f69 * f73);
     f71 = (HEAP32[tempDoublePtr >> 2] = i76 & i17 | i5 & i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f10 = (HEAP32[tempDoublePtr >> 2] = i76 & i18 | i6 & i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f70 = Math_fround(Math_fround(f69 * f71) - Math_fround(f10 * f73));
     f20 = Math_fround(Math_fround(f71 * f71) + Math_fround(Math_fround(f73 * f73) + Math_fround(-.5)));
     f74 = Math_fround(Math_fround(f71 * f10) + f74);
     f70 = Math_fround(f70 + f70);
     f20 = Math_fround(f20 + f20);
     f74 = Math_fround(f74 + f74);
     f13 = Math_fround(f20 * Math_fround(0.0));
     f23 = Math_fround(f74 * Math_fround(0.0));
     f21 = Math_fround(f70 * Math_fround(0.0));
     f72 = Math_fround(f70 - f13);
     f13 = Math_fround(f13 - f74);
     f22 = Math_fround(f23 - f21);
     f23 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f74 * f74) + Math_fround(0.0)) + Math_fround(Math_fround(f70 * f70) + Math_fround(f20 * f20))))) + Math_fround(Math_fround(f20 + f21) + Math_fround(f23 + Math_fround(0.0))));
     f21 = Math_fround(Math_fround(Math_fround(Math_fround(f69 * f22) - Math_fround(f10 * f23)) - Math_fround(f73 * f72)) - Math_fround(f71 * f13));
     f20 = Math_fround(Math_fround(Math_fround(Math_fround(f73 * f23) - Math_fround(f69 * f13)) - Math_fround(f10 * f72)) - Math_fround(f71 * f22));
     f70 = Math_fround(Math_fround(Math_fround(Math_fround(f71 * f72) - Math_fround(f10 * f22)) - Math_fround(f69 * f23)) - Math_fround(f73 * f13));
     f22 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f13) - Math_fround(f69 * f72)) - Math_fround(f71 * f23)) - Math_fround(f73 * f22));
     i15 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     i19 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
     f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
     f70 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
     f21 = Math_fround(f22 * f22);
     f73 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f73 * f73) + f21) + Math_fround(Math_fround(f20 * f20) + Math_fround(f70 * f70))))));
     f22 = Math_fround(f21 * f22);
     f73 = Math_fround(f21 * f73);
     f70 = Math_fround(f21 * f70);
     f20 = Math_fround(f21 * f20);
     f21 = Math_fround(f8 * f22);
     f23 = Math_fround(f9 * f20);
     f71 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f72 = Math_fround(f71 * f73);
     f69 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f9 * f70)) - Math_fround(f71 * f20)) - Math_fround(f69 * f73));
     f23 = Math_fround(Math_fround(Math_fround(f23 - Math_fround(f69 * f22)) - Math_fround(f71 * f70)) - Math_fround(f8 * f73));
     f72 = Math_fround(Math_fround(Math_fround(f72 - Math_fround(f8 * f70)) - Math_fround(f9 * f22)) - Math_fround(f69 * f20));
     f20 = Math_fround(Math_fround(Math_fround(Math_fround(f69 * f70) - Math_fround(f71 * f22)) - Math_fround(f9 * f73)) - Math_fround(f8 * f20));
     i16 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i15 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
     f20 = (HEAP32[tempDoublePtr >> 2] = i14 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f72 = Math_fround(f20 * f20);
     f21 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f73 = Math_fround(f21 * f21);
     f22 = (HEAP32[tempDoublePtr >> 2] = i16 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f73 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f72 + f73) + Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22))))));
     f23 = Math_fround(f73 * f23);
     f22 = Math_fround(f73 * f22);
     f21 = Math_fround(f73 * f21);
     f20 = Math_fround(f73 * f20);
     i16 = i25;
     i15 = i24;
     i14 = i26;
     break;
    }
    i11 = HEAP32[i67 >> 2] | 0;
    i12 = 0;
    i64 = 23;
   } else {
    i12 = HEAP32[i67 >> 2] | 0;
    i5 = HEAP32[i46 >> 2] | 0;
    i11 = i12;
    i12 = HEAP32[i12 + (i6 << 2) >> 2] | 0;
    i64 = 23;
   } while (0);
   if ((i64 | 0) == 23) {
    i64 = 0;
    if ((i5 | 0) == -1) i14 = 0; else i14 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
    i5 = HEAP32[i47 >> 2] | 0;
    if ((i5 | 0) == -1) i6 = 0; else i6 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
    i5 = HEAP32[i48 >> 2] | 0;
    if ((i5 | 0) == -1) f13 = Math_fround(0.0); else f13 = Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]);
    i5 = HEAP32[i49 >> 2] | 0;
    if ((i5 | 0) == -1) f10 = Math_fround(0.0); else f10 = Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]);
    i5 = HEAP32[i50 >> 2] | 0;
    if ((i5 | 0) == -1) f9 = Math_fround(0.0); else f9 = Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]);
    i5 = HEAP32[i51 >> 2] | 0;
    if ((i5 | 0) == -1) f8 = Math_fround(1.0); else f8 = Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]);
    f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8))))));
    f23 = Math_fround(f8 * f20);
    f22 = Math_fround(f9 * f20);
    f21 = Math_fround(f10 * f20);
    f20 = Math_fround(f13 * f20);
    i16 = i12;
    i15 = i6;
   }
   i12 = i33;
   i33 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i30;
   i30 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = i31;
   i31 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = i32;
   i32 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i34 | 0) > 0) {
    f73 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f71 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f74 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f79 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f69 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f79 = Math_fround(f71 - f79);
    f69 = Math_fround(f74 - f69);
    f10 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f74 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f71 = (HEAP32[tempDoublePtr >> 2] = i12 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f72 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = Math_fround(f74 * Math_fround(-2.0));
    f13 = Math_fround(f74 * Math_fround(2.0));
    f81 = Math_fround(f73 * f9);
    f78 = Math_fround(f72 * Math_fround(2.0));
    f80 = Math_fround(f72 * Math_fround(-2.0));
    f83 = Math_fround(f73 * f80);
    f70 = Math_fround(f71 * Math_fround(-2.0));
    f82 = Math_fround(f71 * Math_fround(2.0));
    f77 = Math_fround(f73 * f70);
    f8 = Math_fround(Math_fround(f79 + Math_fround(Math_fround(Math_fround(f74 * f9) - Math_fround(f72 * f78)) * f79)) + Math_fround(Math_fround(Math_fround(f83 - Math_fround(f74 * f70)) * f69) + Math_fround(Math_fround(Math_fround(f72 * f82) - f81) * f10)));
    f9 = Math_fround(Math_fround(f69 + Math_fround(Math_fround(Math_fround(f71 * f13) - f83) * f79)) + Math_fround(Math_fround(Math_fround(Math_fround(f72 * f80) - Math_fround(f71 * f82)) * f69) + Math_fround(Math_fround(f77 - Math_fround(f72 * f9)) * f10)));
    f10 = Math_fround(Math_fround(Math_fround(Math_fround(f81 - Math_fround(f80 * f71)) * f79) + f10) + Math_fround(Math_fround(Math_fround(Math_fround(f74 * f78) - f77) * f69) + Math_fround(Math_fround(Math_fround(f71 * f70) - Math_fround(f74 * f13)) * f10)));
    f13 = Math_fround(Math_fround(Math_fround(Math_fround(f73 * f23) - Math_fround(f71 * f20)) - Math_fround(f72 * f22)) - Math_fround(f74 * f21));
    f74 = Math_fround(Math_fround(Math_fround(Math_fround(f71 * f22) - Math_fround(f72 * f20)) - Math_fround(f73 * f21)) - Math_fround(f74 * f23));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    if (HEAP8[i43 >> 0] | 0) {
     f8 = Math_fround(-f8);
     f83 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i5 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
    }
    f4 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(+Math_atan(+Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f13))) * Math_fround(2.0)) / f44));
    f81 = Math_fround(f8 / f44);
    f82 = Math_fround(f9 / f44);
    f83 = Math_fround(f10 / f44);
    f79 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f80 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f81 = Math_fround(f79 + f81);
    f82 = Math_fround(f80 + f82);
    f83 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f83);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f7 = Math_fround(f44 + f7);
   if ((i34 | 0) == (i59 | 0)) break; else {
    i34 = i34 + 1 | 0;
    i29 = i16;
    i28 = i14;
    i27 = i15;
   }
  }
 }
 HEAPF32[i65 + 1084 >> 2] = Math_fround(f4 / f58);
 f81 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f82 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f81 = Math_fround(f81 / f58);
 f82 = Math_fround(f82 / f58);
 f83 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f58);
 i64 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
 i75 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
 i63 = (HEAPU8[i65 + 1729 >> 0] | 0) + -1 | 0;
 i75 = (HEAPU8[i65 + 1728 >> 0] | 0) + -1 & i75;
 i76 = i63 & (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i65 + 1048 >> 2] = i63 & i64;
 HEAP32[i65 + 1052 >> 2] = i75;
 HEAP32[i65 + 1056 >> 2] = i76;
 if (i67 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i66 >> 2] | 0) + 4 >> 2] | 0, i66 | 0, HEAP32[i67 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i66 >> 2] | 0) + 4 >> 2] | 0, i66 | 0, i67 | 0);
 }
 if (!i62) {
  STACKTOP = i68;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i66 >> 2] | 0) + 4 >> 2] | 0, i66 | 0, HEAP32[i62 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i66 >> 2] | 0) + 4 >> 2] | 0, i66 | 0, i62 | 0);
 STACKTOP = i68;
 return;
}

function __ZNK5Umbra18ImpOcclusionBuffer13isAABBVisibleERKNS_7Vector3ES3_Pf(i55, i1, i6, i16) {
 i55 = i55 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, f91 = f0, f92 = f0, f93 = f0, f94 = f0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i58 + 216 | 0;
 i26 = i58 + 200 | 0;
 i21 = i58 + 184 | 0;
 i22 = i58 + 168 | 0;
 i60 = i58 + 56 | 0;
 i59 = i58 + 40 | 0;
 i17 = i58 + 72 | 0;
 i18 = i58 + 24 | 0;
 i19 = i58 + 8 | 0;
 i24 = i58;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i20 = i21 + 4 | 0;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i14 = i21 + 8 | 0;
 i23 = i21 + 12 | 0;
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i15 = i22 + 4 | 0;
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i1 = i22 + 8 | 0;
 i6 = i22 + 12 | 0;
 f53 = Math_fround(HEAPF32[i55 + 1208 >> 2]);
 f56 = Math_fround(HEAPF32[i55 + 1212 >> 2]);
 f57 = Math_fround(HEAPF32[i55 + 1216 >> 2]);
 f10 = Math_fround(HEAPF32[i55 + 1220 >> 2]);
 f2 = Math_fround(f2 - f53);
 f3 = Math_fround(f3 - f56);
 f4 = Math_fround(f4 - f57);
 f5 = Math_fround(Math_fround(1.0) - f10);
 HEAPF32[i21 >> 2] = f2;
 HEAPF32[i20 >> 2] = f3;
 HEAPF32[i14 >> 2] = f4;
 HEAPF32[i23 >> 2] = f5;
 f7 = Math_fround(f53 + f7);
 f8 = Math_fround(f56 + f8);
 f9 = Math_fround(f57 + f9);
 f10 = Math_fround(f10 + Math_fround(1.0));
 HEAPF32[i22 >> 2] = f7;
 HEAPF32[i15 >> 2] = f8;
 HEAPF32[i1 >> 2] = f9;
 HEAPF32[i6 >> 2] = f10;
 i16 = (i16 | 0) == 0 ? i58 + 164 | 0 : i16;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 HEAPF32[i60 >> 2] = f2;
 HEAPF32[i60 + 4 >> 2] = f3;
 HEAPF32[i60 + 8 >> 2] = f4;
 HEAPF32[i60 + 12 >> 2] = f5;
 HEAPF32[i59 >> 2] = f7;
 HEAPF32[i59 + 4 >> 2] = f8;
 HEAPF32[i59 + 8 >> 2] = f9;
 HEAPF32[i59 + 12 >> 2] = f10;
 if (!(__ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i55, i60, i59) | 0)) {
  i60 = 0;
  STACKTOP = i58;
  return i60 | 0;
 }
 HEAPF32[i25 >> 2] = f2;
 HEAPF32[i25 + 4 >> 2] = f3;
 HEAPF32[i25 + 8 >> 2] = f4;
 HEAPF32[i25 + 12 >> 2] = f5;
 HEAPF32[i26 >> 2] = f7;
 HEAPF32[i26 + 4 >> 2] = f8;
 HEAPF32[i26 + 8 >> 2] = f9;
 HEAPF32[i26 + 12 >> 2] = f10;
 if (__ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i55, i17, 0, i25, i26) | 0) {
  HEAPF32[i18 >> 2] = f2;
  HEAPF32[i18 + 4 >> 2] = f3;
  HEAPF32[i18 + 8 >> 2] = f4;
  HEAPF32[i18 + 12 >> 2] = f5;
  HEAPF32[i19 >> 2] = f7;
  HEAPF32[i19 + 4 >> 2] = f8;
  HEAPF32[i19 + 8 >> 2] = f9;
  HEAPF32[i19 + 12 >> 2] = f10;
  __ZNK5Umbra11Transformer16frustumShrinkBoxEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_RS4_S5_(i55, i17, i18, i19, i21, i22);
 }
 if (!(HEAP32[i55 + 1408 >> 2] | 0)) {
  f32 = Math_fround(HEAPF32[i21 >> 2]);
  f57 = Math_fround(HEAPF32[i20 >> 2]);
  f56 = Math_fround(HEAPF32[i14 >> 2]);
  f5 = Math_fround(HEAPF32[i22 >> 2]);
  f12 = Math_fround(HEAPF32[i15 >> 2]);
  f5 = Math_fround(f5 - f32);
  f12 = Math_fround(f12 - f57);
  f37 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f56);
  f31 = Math_fround(HEAPF32[i55 + 64 >> 2]);
  f27 = Math_fround(HEAPF32[i55 + 68 >> 2]);
  f8 = Math_fround(HEAPF32[i55 + 76 >> 2]);
  f3 = Math_fround(f5 * f31);
  f4 = Math_fround(f5 * f27);
  f5 = Math_fround(f5 * f8);
  f30 = Math_fround(HEAPF32[i55 + 80 >> 2]);
  f13 = Math_fround(HEAPF32[i55 + 84 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 92 >> 2]);
  f10 = Math_fround(f12 * f30);
  f11 = Math_fround(f12 * f13);
  f12 = Math_fround(f12 * f7);
  f28 = Math_fround(HEAPF32[i55 + 96 >> 2]);
  f9 = Math_fround(HEAPF32[i55 + 100 >> 2]);
  f2 = Math_fround(HEAPF32[i55 + 108 >> 2]);
  f29 = Math_fround(f37 * f28);
  f33 = Math_fround(f37 * f9);
  f37 = Math_fround(f37 * f2);
  f31 = Math_fround(f32 * f31);
  f27 = Math_fround(f32 * f27);
  f8 = Math_fround(f32 * f8);
  f30 = Math_fround(f57 * f30);
  f13 = Math_fround(f57 * f13);
  f7 = Math_fround(f57 * f7);
  f28 = Math_fround(f56 * f28);
  f9 = Math_fround(f56 * f9);
  f2 = Math_fround(f56 * f2);
  f56 = Math_fround(HEAPF32[i55 + 112 >> 2]);
  f57 = Math_fround(HEAPF32[i55 + 116 >> 2]);
  f56 = Math_fround(f31 + Math_fround(f30 + Math_fround(f28 + f56)));
  f57 = Math_fround(f27 + Math_fround(f13 + Math_fround(f9 + f57)));
  f2 = Math_fround(f8 + Math_fround(f7 + Math_fround(f2 + Math_fround(HEAPF32[i55 + 124 >> 2]))));
  f3 = Math_fround(f3 + f56);
  f4 = Math_fround(f4 + f57);
  f5 = Math_fround(f5 + f2);
  f7 = Math_fround(f10 + f3);
  f8 = Math_fround(f11 + f4);
  f9 = Math_fround(f12 + f5);
  f10 = Math_fround(f10 + f56);
  f11 = Math_fround(f11 + f57);
  f12 = Math_fround(f12 + f2);
  f13 = Math_fround(f29 + f56);
  f27 = Math_fround(f29 + f3);
  f28 = Math_fround(f29 + f7);
  f29 = Math_fround(f29 + f10);
  f30 = Math_fround(f33 + f57);
  f31 = Math_fround(f33 + f4);
  f32 = Math_fround(f33 + f8);
  f33 = Math_fround(f33 + f11);
  f34 = Math_fround(f37 + f2);
  f35 = Math_fround(f37 + f5);
  f36 = Math_fround(f37 + f9);
  f37 = Math_fround(f37 + f12);
  i60 = f2 == Math_fround(0.0);
  f42 = Math_fround(Math_fround(1.0) / f2);
  f42 = i60 ? Math_fround(1.0) : f42;
  i60 = f5 == Math_fround(0.0);
  f43 = Math_fround(Math_fround(1.0) / f5);
  f43 = i60 ? Math_fround(1.0) : f43;
  i60 = f9 == Math_fround(0.0);
  f44 = Math_fround(Math_fround(1.0) / f9);
  f44 = i60 ? Math_fround(1.0) : f44;
  i60 = f12 == Math_fround(0.0);
  f45 = Math_fround(Math_fround(1.0) / f12);
  f45 = i60 ? Math_fround(1.0) : f45;
  i60 = f34 == Math_fround(0.0);
  f50 = Math_fround(Math_fround(1.0) / f34);
  f50 = i60 ? Math_fround(1.0) : f50;
  i60 = f35 == Math_fround(0.0);
  f51 = Math_fround(Math_fround(1.0) / f35);
  f51 = i60 ? Math_fround(1.0) : f51;
  i60 = f36 == Math_fround(0.0);
  f52 = Math_fround(Math_fround(1.0) / f36);
  f52 = i60 ? Math_fround(1.0) : f52;
  i60 = f37 == Math_fround(0.0);
  f53 = Math_fround(Math_fround(1.0) / f37);
  f53 = i60 ? Math_fround(1.0) : f53;
  f38 = Math_fround(f56 * f42);
  f39 = Math_fround(f3 * f43);
  f40 = Math_fround(f7 * f44);
  f41 = Math_fround(f10 * f45);
  f42 = Math_fround(f57 * f42);
  f43 = Math_fround(f4 * f43);
  f44 = Math_fround(f8 * f44);
  f45 = Math_fround(f11 * f45);
  f46 = Math_fround(f13 * f50);
  f47 = Math_fround(f27 * f51);
  f48 = Math_fround(f28 * f52);
  f49 = Math_fround(f29 * f53);
  f50 = Math_fround(f30 * f50);
  f51 = Math_fround(f31 * f51);
  f52 = Math_fround(f32 * f52);
  f53 = Math_fround(f33 * f53);
  if (!((f12 <= f37 ? f12 : f37) < Math_fround(0.0)) & (((f2 <= f34 ? f2 : f34) < Math_fround(0.0) ? 0 : !((f5 <= f35 ? f5 : f35) < Math_fround(0.0))) & !((f9 <= f36 ? f9 : f36) < Math_fround(0.0)))) {
   f36 = f38 <= f46 ? f38 : f46;
   f56 = f39 <= f47 ? f39 : f47;
   f37 = f40 <= f48 ? f40 : f48;
   f2 = f41 <= f49 ? f41 : f49;
   f4 = f42 <= f50 ? f42 : f50;
   f3 = f43 <= f51 ? f43 : f51;
   f57 = f44 <= f52 ? f44 : f52;
   f5 = f45 <= f53 ? f45 : f53;
   f37 = f36 <= f37 ? f36 : f37;
   f57 = f4 <= f57 ? f4 : f57;
   f2 = f56 <= f2 ? f56 : f2;
   f5 = f3 <= f5 ? f3 : f5;
   f46 = f38 >= f46 ? f38 : f46;
   f47 = f39 >= f47 ? f39 : f47;
   f48 = f40 >= f48 ? f40 : f48;
   f3 = f41 >= f49 ? f41 : f49;
   f50 = f42 >= f50 ? f42 : f50;
   f51 = f43 >= f51 ? f43 : f51;
   f56 = f44 >= f52 ? f44 : f52;
   f4 = f45 >= f53 ? f45 : f53;
   f53 = f46 >= f48 ? f46 : f48;
   f56 = f50 >= f56 ? f50 : f56;
   f3 = f47 >= f3 ? f47 : f3;
   f4 = f51 >= f4 ? f51 : f4;
   f2 = f37 <= f2 ? f37 : f2;
   f3 = f53 >= f3 ? f53 : f3;
   f4 = f56 >= f4 ? f56 : f4;
   f5 = f57 <= f5 ? f57 : f5;
  } else {
   f94 = Math_fround(-f2);
   f93 = Math_fround(-f5);
   f92 = Math_fround(-f9);
   f91 = Math_fround(-f12);
   i90 = f56 > f94;
   i88 = f3 > f93;
   i86 = f7 > f92;
   i84 = f10 > f91;
   i81 = f2 > f56;
   i77 = f5 > f3;
   i73 = f9 > f7;
   i69 = f12 > f10;
   i66 = f57 > f94;
   i64 = f4 > f93;
   i62 = f8 > f92;
   i1 = f11 > f91;
   i15 = f2 > f57;
   i20 = f5 > f4;
   i24 = f9 > f8;
   i55 = f12 > f11;
   f57 = Math_fround(-f34);
   f3 = Math_fround(-f35);
   f2 = Math_fround(-f36);
   f4 = Math_fround(-f37);
   i89 = f13 > f57;
   i87 = f27 > f3;
   i85 = f28 > f2;
   i83 = f29 > f4;
   i79 = f34 > f13;
   i75 = f35 > f27;
   i71 = f36 > f28;
   i67 = f37 > f29;
   i65 = f30 > f57;
   i63 = f31 > f3;
   i61 = f32 > f2;
   i6 = f33 > f4;
   i18 = f34 > f30;
   i22 = f35 > f31;
   i26 = f36 > f32;
   i60 = f37 > f33;
   i82 = i81 & i90;
   i78 = i77 & i88;
   i74 = i73 & i86;
   i70 = i69 & i84;
   i14 = i15 & i66;
   i19 = i20 & i64;
   i23 = i24 & i62;
   i54 = i55 & i1;
   i80 = i79 & i89;
   i76 = i75 & i87;
   i72 = i71 & i85;
   i68 = i67 & i83;
   i17 = i18 & i65;
   i21 = i22 & i63;
   i25 = i26 & i61;
   i59 = i60 & i6;
   f4 = i82 ? f38 : Math_fround(1.0);
   f4 = i90 ? f4 : Math_fround(-1.0);
   f35 = i80 ? f46 : Math_fround(1.0);
   f35 = i89 ? f35 : Math_fround(-1.0);
   f35 = f4 <= f35 ? f4 : f35;
   f4 = i78 ? f39 : Math_fround(1.0);
   f4 = i88 ? f4 : Math_fround(-1.0);
   f37 = i76 ? f47 : Math_fround(1.0);
   f37 = i87 ? f37 : Math_fround(-1.0);
   f37 = f4 <= f37 ? f4 : f37;
   f4 = i74 ? f40 : Math_fround(1.0);
   f4 = i86 ? f4 : Math_fround(-1.0);
   f36 = i72 ? f48 : Math_fround(1.0);
   f36 = i85 ? f36 : Math_fround(-1.0);
   f36 = f4 <= f36 ? f4 : f36;
   f4 = i70 ? f41 : Math_fround(1.0);
   f4 = i84 ? f4 : Math_fround(-1.0);
   f2 = i68 ? f49 : Math_fround(1.0);
   f2 = i83 ? f2 : Math_fround(-1.0);
   f2 = f4 <= f2 ? f4 : f2;
   f4 = i82 ? f38 : Math_fround(-1.0);
   f4 = i81 ? f4 : Math_fround(1.0);
   f46 = i80 ? f46 : Math_fround(-1.0);
   f46 = i79 ? f46 : Math_fround(1.0);
   f46 = f4 >= f46 ? f4 : f46;
   f4 = i78 ? f39 : Math_fround(-1.0);
   f4 = i77 ? f4 : Math_fround(1.0);
   f47 = i76 ? f47 : Math_fround(-1.0);
   f47 = i75 ? f47 : Math_fround(1.0);
   f47 = f4 >= f47 ? f4 : f47;
   f4 = i74 ? f40 : Math_fround(-1.0);
   f4 = i73 ? f4 : Math_fround(1.0);
   f48 = i72 ? f48 : Math_fround(-1.0);
   f48 = i71 ? f48 : Math_fround(1.0);
   f48 = f4 >= f48 ? f4 : f48;
   f4 = i70 ? f41 : Math_fround(-1.0);
   f4 = i69 ? f4 : Math_fround(1.0);
   f3 = i68 ? f49 : Math_fround(-1.0);
   f3 = i67 ? f3 : Math_fround(1.0);
   f3 = f4 >= f3 ? f4 : f3;
   f4 = i14 ? f42 : Math_fround(1.0);
   f4 = i66 ? f4 : Math_fround(-1.0);
   f41 = i17 ? f50 : Math_fround(1.0);
   f41 = i65 ? f41 : Math_fround(-1.0);
   f41 = f4 <= f41 ? f4 : f41;
   f4 = i19 ? f43 : Math_fround(1.0);
   f4 = i64 ? f4 : Math_fround(-1.0);
   f49 = i21 ? f51 : Math_fround(1.0);
   f49 = i63 ? f49 : Math_fround(-1.0);
   f49 = f4 <= f49 ? f4 : f49;
   f4 = i23 ? f44 : Math_fround(1.0);
   f4 = i62 ? f4 : Math_fround(-1.0);
   f57 = i25 ? f52 : Math_fround(1.0);
   f57 = i61 ? f57 : Math_fround(-1.0);
   f57 = f4 <= f57 ? f4 : f57;
   f4 = i54 ? f45 : Math_fround(1.0);
   f4 = i1 ? f4 : Math_fround(-1.0);
   f5 = i59 ? f53 : Math_fround(1.0);
   f5 = i6 ? f5 : Math_fround(-1.0);
   f5 = f4 <= f5 ? f4 : f5;
   f4 = i14 ? f42 : Math_fround(-1.0);
   f4 = i15 ? f4 : Math_fround(1.0);
   f50 = i17 ? f50 : Math_fround(-1.0);
   f50 = i18 ? f50 : Math_fround(1.0);
   f50 = f4 >= f50 ? f4 : f50;
   f4 = i19 ? f43 : Math_fround(-1.0);
   f4 = i20 ? f4 : Math_fround(1.0);
   f51 = i21 ? f51 : Math_fround(-1.0);
   f51 = i22 ? f51 : Math_fround(1.0);
   f51 = f4 >= f51 ? f4 : f51;
   f4 = i23 ? f44 : Math_fround(-1.0);
   f4 = i24 ? f4 : Math_fround(1.0);
   f56 = i25 ? f52 : Math_fround(-1.0);
   f56 = i26 ? f56 : Math_fround(1.0);
   f56 = f4 >= f56 ? f4 : f56;
   f52 = i54 ? f45 : Math_fround(-1.0);
   f52 = i55 ? f52 : Math_fround(1.0);
   f4 = i59 ? f53 : Math_fround(-1.0);
   f4 = i60 ? f4 : Math_fround(1.0);
   f4 = f52 >= f4 ? f52 : f4;
   f52 = f35 <= f36 ? f35 : f36;
   f57 = f41 <= f57 ? f41 : f57;
   f2 = f37 <= f2 ? f37 : f2;
   f5 = f49 <= f5 ? f49 : f5;
   f53 = f46 >= f48 ? f46 : f48;
   f56 = f50 >= f56 ? f50 : f56;
   f3 = f47 >= f3 ? f47 : f3;
   f4 = f51 >= f4 ? f51 : f4;
   f2 = f52 <= f2 ? f52 : f2;
   f3 = f53 >= f3 ? f53 : f3;
   f4 = f56 >= f4 ? f56 : f4;
   f5 = f57 <= f5 ? f57 : f5;
  }
  i1 = f2 <= Math_fround(1.0);
  f92 = i1 ? f2 : Math_fround(1.0);
  i1 = f5 <= Math_fround(1.0);
  f94 = i1 ? f5 : Math_fround(1.0);
  i1 = f3 <= Math_fround(1.0);
  f91 = i1 ? f3 : Math_fround(1.0);
  i1 = f4 <= Math_fround(1.0);
  f93 = i1 ? f4 : Math_fround(1.0);
  i1 = f92 >= Math_fround(-1.0);
  f92 = i1 ? f92 : Math_fround(-1.0);
  i1 = f94 >= Math_fround(-1.0);
  f94 = i1 ? f94 : Math_fround(-1.0);
  i1 = f91 >= Math_fround(-1.0);
  f91 = i1 ? f91 : Math_fround(-1.0);
  i1 = f93 >= Math_fround(-1.0);
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(Math_fround(f91 - f92) * Math_fround((i1 ? f93 : Math_fround(-1.0)) - f94)) * Math_fround(.25));
  i1 = 1;
 } else {
  i84 = HEAP32[i21 >> 2] | 0;
  i85 = HEAP32[i20 >> 2] | 0;
  i86 = HEAP32[i14 >> 2] | 0;
  i87 = HEAP32[i22 >> 2] | 0;
  i88 = HEAP32[i15 >> 2] | 0;
  i89 = HEAP32[i1 >> 2] | 0;
  i81 = HEAP32[i55 + 832 >> 2] | 0;
  i82 = HEAP32[i55 + 836 >> 2] | 0;
  i83 = HEAP32[i55 + 840 >> 2] | 0;
  i90 = HEAP32[i55 + 844 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i55 + 32 >> 2]);
  f3 = Math_fround(HEAPF32[i55 + 36 >> 2]);
  f5 = Math_fround(HEAPF32[i55 + 40 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 44 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i87 & ~i81 | i81 & i84, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(f11 * f4);
  f12 = (HEAP32[tempDoublePtr >> 2] = i88 & ~i82 | i82 & i85, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(f12 * f3);
  f13 = (HEAP32[tempDoublePtr >> 2] = i89 & ~i83 | i83 & i86, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f13 * f5);
  f2 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 >> 2] & ~i90 | i90 & HEAP32[i23 >> 2], Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f2 * f7) + Math_fround(f5 + Math_fround(f4 + f3)));
  i90 = !(f3 <= Math_fround(0.0));
  f4 = (HEAP32[tempDoublePtr >> 2] = i84, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i85, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i86, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i87, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i89, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i90) {
   f93 = Math_fround(f2 * Math_fround(HEAPF32[i55 + 60 >> 2]));
   f94 = Math_fround(f13 * Math_fround(HEAPF32[i55 + 56 >> 2]));
   f2 = Math_fround(f11 * Math_fround(HEAPF32[i55 + 48 >> 2]));
   f2 = Math_fround(f3 / Math_fround(f93 + Math_fround(f94 + Math_fround(f2 + Math_fround(f12 * Math_fround(HEAPF32[i55 + 52 >> 2]))))));
   HEAPF32[i25 >> 2] = f2;
   if (f2 == Math_fround(0.0)) i54 = 12; else {
    HEAPF32[i26 >> 2] = Math_fround(1.0);
    i1 = f2 <= Math_fround(1.0);
    HEAP32[i25 >> 2] = HEAP32[(i1 ? i25 : i26) >> 2];
    i1 = i55 + 1376 | 0;
    i85 = HEAP32[i1 >> 2] | 0;
    i87 = HEAP32[i1 + 4 >> 2] | 0;
    i89 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    f47 = Math_fround(f8 - f4);
    f49 = Math_fround(f9 - f5);
    f94 = Math_fround(f10 - f7);
    f40 = Math_fround(HEAPF32[i55 + 64 >> 2]);
    f56 = Math_fround(HEAPF32[i55 + 68 >> 2]);
    f39 = Math_fround(HEAPF32[i55 + 76 >> 2]);
    f43 = Math_fround(f47 * f40);
    f41 = Math_fround(f47 * f56);
    f47 = Math_fround(f47 * f39);
    f91 = Math_fround(HEAPF32[i55 + 80 >> 2]);
    f50 = Math_fround(HEAPF32[i55 + 84 >> 2]);
    f44 = Math_fround(HEAPF32[i55 + 92 >> 2]);
    f45 = Math_fround(f49 * f91);
    f37 = Math_fround(f49 * f50);
    f49 = Math_fround(f49 * f44);
    f57 = Math_fround(HEAPF32[i55 + 96 >> 2]);
    f48 = Math_fround(HEAPF32[i55 + 100 >> 2]);
    f46 = Math_fround(HEAPF32[i55 + 108 >> 2]);
    f93 = Math_fround(f94 * f57);
    f36 = Math_fround(f94 * f48);
    f94 = Math_fround(f94 * f46);
    f40 = Math_fround(f4 * f40);
    f56 = Math_fround(f4 * f56);
    f39 = Math_fround(f4 * f39);
    f91 = Math_fround(f5 * f91);
    f50 = Math_fround(f5 * f50);
    f44 = Math_fround(f5 * f44);
    f57 = Math_fround(f7 * f57);
    f48 = Math_fround(f7 * f48);
    f46 = Math_fround(f7 * f46);
    f42 = Math_fround(HEAPF32[i55 + 112 >> 2]);
    f92 = Math_fround(HEAPF32[i55 + 116 >> 2]);
    f42 = Math_fround(f40 + Math_fround(f91 + Math_fround(f57 + f42)));
    f92 = Math_fround(f56 + Math_fround(f50 + Math_fround(f48 + f92)));
    f46 = Math_fround(f39 + Math_fround(f44 + Math_fround(f46 + Math_fround(HEAPF32[i55 + 124 >> 2]))));
    f43 = Math_fround(f43 + f42);
    f41 = Math_fround(f41 + f92);
    f47 = Math_fround(f47 + f46);
    f44 = Math_fround(f45 + f43);
    f39 = Math_fround(f37 + f41);
    f48 = Math_fround(f49 + f47);
    f45 = Math_fround(f45 + f42);
    f37 = Math_fround(f37 + f92);
    f49 = Math_fround(f49 + f46);
    f50 = Math_fround(f93 + f42);
    f56 = Math_fround(f93 + f43);
    f57 = Math_fround(f93 + f44);
    f93 = Math_fround(f93 + f45);
    f91 = Math_fround(f36 + f92);
    f40 = Math_fround(f36 + f41);
    f38 = Math_fround(f36 + f39);
    f36 = Math_fround(f36 + f37);
    f51 = Math_fround(f94 + f46);
    f52 = Math_fround(f94 + f47);
    f53 = Math_fround(f94 + f48);
    f94 = Math_fround(f94 + f49);
    i84 = f46 == Math_fround(0.0);
    f46 = Math_fround(Math_fround(1.0) / f46);
    f46 = i84 ? Math_fround(1.0) : f46;
    i84 = f47 == Math_fround(0.0);
    f47 = Math_fround(Math_fround(1.0) / f47);
    f47 = i84 ? Math_fround(1.0) : f47;
    i84 = f48 == Math_fround(0.0);
    f48 = Math_fround(Math_fround(1.0) / f48);
    f48 = i84 ? Math_fround(1.0) : f48;
    i84 = f49 == Math_fround(0.0);
    f49 = Math_fround(Math_fround(1.0) / f49);
    f49 = i84 ? Math_fround(1.0) : f49;
    i84 = f51 == Math_fround(0.0);
    f51 = Math_fround(Math_fround(1.0) / f51);
    f51 = i84 ? Math_fround(1.0) : f51;
    i84 = f52 == Math_fround(0.0);
    f52 = Math_fround(Math_fround(1.0) / f52);
    f52 = i84 ? Math_fround(1.0) : f52;
    i84 = f53 == Math_fround(0.0);
    f53 = Math_fround(Math_fround(1.0) / f53);
    f53 = i84 ? Math_fround(1.0) : f53;
    i84 = f94 == Math_fround(0.0);
    f94 = Math_fround(Math_fround(1.0) / f94);
    f94 = i84 ? Math_fround(1.0) : f94;
    f42 = Math_fround(f42 * f46);
    f43 = Math_fround(f43 * f47);
    f44 = Math_fround(f44 * f48);
    f45 = Math_fround(f45 * f49);
    f46 = Math_fround(f92 * f46);
    f47 = Math_fround(f41 * f47);
    f48 = Math_fround(f39 * f48);
    f49 = Math_fround(f37 * f49);
    f50 = Math_fround(f50 * f51);
    f56 = Math_fround(f56 * f52);
    f57 = Math_fround(f57 * f53);
    f93 = Math_fround(f93 * f94);
    f51 = Math_fround(f91 * f51);
    f52 = Math_fround(f40 * f52);
    f53 = Math_fround(f38 * f53);
    f94 = Math_fround(f36 * f94);
    f36 = f42 <= f50 ? f42 : f50;
    f38 = f43 <= f56 ? f43 : f56;
    f40 = f44 <= f57 ? f44 : f57;
    f91 = f45 <= f93 ? f45 : f93;
    f37 = f46 <= f51 ? f46 : f51;
    f39 = f47 <= f52 ? f47 : f52;
    f41 = f48 <= f53 ? f48 : f53;
    f92 = f49 <= f94 ? f49 : f94;
    f40 = f36 <= f40 ? f36 : f40;
    f41 = f37 <= f41 ? f37 : f41;
    f91 = f38 <= f91 ? f38 : f91;
    f92 = f39 <= f92 ? f39 : f92;
    f91 = f40 <= f91 ? f40 : f91;
    f92 = f41 <= f92 ? f41 : f92;
    f50 = f42 >= f50 ? f42 : f50;
    f56 = f43 >= f56 ? f43 : f56;
    f57 = f44 >= f57 ? f44 : f57;
    f93 = f45 >= f93 ? f45 : f93;
    f51 = f46 >= f51 ? f46 : f51;
    f52 = f47 >= f52 ? f47 : f52;
    f53 = f48 >= f53 ? f48 : f53;
    f94 = f49 >= f94 ? f49 : f94;
    f57 = f50 >= f57 ? f50 : f57;
    f53 = f51 >= f53 ? f51 : f53;
    f93 = f56 >= f93 ? f56 : f93;
    f94 = f52 >= f94 ? f52 : f94;
    f93 = f57 >= f93 ? f57 : f93;
    f94 = f53 >= f94 ? f53 : f94;
    i84 = f91 <= Math_fround(1.0);
    f53 = i84 ? f91 : Math_fround(1.0);
    i84 = f92 <= Math_fround(1.0);
    f57 = i84 ? f92 : Math_fround(1.0);
    i84 = f93 <= Math_fround(1.0);
    f52 = i84 ? f93 : Math_fround(1.0);
    i84 = f94 <= Math_fround(1.0);
    f56 = i84 ? f94 : Math_fround(1.0);
    i84 = f53 >= Math_fround(-1.0);
    f53 = i84 ? f53 : Math_fround(-1.0);
    i84 = f57 >= Math_fround(-1.0);
    f57 = i84 ? f57 : Math_fround(-1.0);
    i84 = f52 >= Math_fround(-1.0);
    f52 = i84 ? f52 : Math_fround(-1.0);
    i84 = f56 >= Math_fround(-1.0);
    HEAPF32[i16 >> 2] = Math_fround(Math_fround(Math_fround(f52 - f53) * Math_fround((i84 ? f56 : Math_fround(-1.0)) - f57)) * Math_fround(.25));
    i84 = ~~Math_fround(Math_fround(f91 * Math_fround(32.0)) + Math_fround(32.0));
    i86 = ~~Math_fround(Math_fround(f92 * Math_fround(32.0)) + Math_fround(32.0));
    i88 = ~~Math_fround(Math_fround(f93 * Math_fround(32.0)) + Math_fround(32.9999962));
    i90 = ~~Math_fround(Math_fround(f94 * Math_fround(32.0)) + Math_fround(32.9999962));
    HEAP32[i26 >> 2] = (i84 | 0) >= (i85 | 0) ? i84 : i85;
    HEAP32[i26 + 4 >> 2] = (i86 | 0) >= (i87 | 0) ? i86 : i87;
    HEAP32[i24 >> 2] = (i88 | 0) <= (i89 | 0) ? i88 : i89;
    HEAP32[i24 + 4 >> 2] = (i90 | 0) <= (i1 | 0) ? i90 : i1;
    i1 = __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f(i55, i26, i24, Math_fround(HEAPF32[i25 >> 2])) | 0;
   }
  } else {
   HEAP32[i25 >> 2] = 0;
   i54 = 12;
  }
  if ((i54 | 0) == 12) {
   HEAPF32[i16 >> 2] = Math_fround(1.0);
   i1 = 1;
  }
 }
 i90 = i1;
 STACKTOP = i58;
 return i90 | 0;
}

function __ZNK5physx2Sq16BucketPrunerCore5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE(i48, i1, i23, i49, i47) {
 i48 = i48 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i49 = i49 | 0;
 i47 = i47 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i51 + 24 | 0;
 i22 = i51 + 12 | 0;
 i21 = i51;
 f38 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f43 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f40 = Math_fround(f38 - f43);
 f39 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f44 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f41 = Math_fround(f39 - f44);
 f2 = Math_fround(HEAPF32[i1 + 140 >> 2]);
 f45 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f40 = Math_fround(f40 * Math_fround(.5));
 f41 = Math_fround(f41 * Math_fround(.5));
 f42 = Math_fround(Math_fround(f2 - f45) * Math_fround(.5));
 f43 = Math_fround(Math_fround(f38 + f43) * Math_fround(.5));
 f44 = Math_fround(Math_fround(f39 + f44) * Math_fround(.5));
 f45 = Math_fround(Math_fround(f2 + f45) * Math_fround(.5));
 HEAPF32[i22 >> 2] = f43;
 HEAPF32[i22 + 4 >> 2] = f44;
 HEAPF32[i22 + 8 >> 2] = f45;
 HEAPF32[i21 >> 2] = f40;
 HEAPF32[i21 + 4 >> 2] = f41;
 HEAPF32[i21 + 8 >> 2] = f42;
 f2 = Math_fround(HEAPF32[i49 >> 2]);
 if (f2 == Math_fround(3402823469999999843913219.0e14)) {
  f37 = Math_fround(HEAPF32[i48 + 608 >> 2]);
  f2 = Math_fround(HEAPF32[i48 + 624 >> 2]);
  f5 = Math_fround(f37 - f2);
  f38 = Math_fround(HEAPF32[i48 + 612 >> 2]);
  f3 = Math_fround(HEAPF32[i48 + 628 >> 2]);
  f6 = Math_fround(f38 - f3);
  f39 = Math_fround(HEAPF32[i48 + 616 >> 2]);
  f4 = Math_fround(HEAPF32[i48 + 632 >> 2]);
  f5 = Math_fround(f5 - f40);
  f6 = Math_fround(f6 - f41);
  f7 = Math_fround(Math_fround(f39 - f4) - f42);
  f2 = Math_fround(Math_fround(f37 + f2) + f40);
  f3 = Math_fround(Math_fround(f38 + f3) + f41);
  f4 = Math_fround(Math_fround(f39 + f4) + f42);
  i14 = HEAP32[i48 + 28 >> 2] | 0;
  if (i14) {
   i15 = 2122317823;
   i16 = 2122317823;
   i17 = 2122317823;
   i18 = -25165825;
   i19 = -25165825;
   i1 = -25165825;
   i20 = 0;
   while (1) {
    f39 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) >> 2]);
    f13 = f39 < f13 ? f39 : f13;
    f39 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) + 4 >> 2]);
    f12 = f39 < f12 ? f39 : f12;
    f39 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) + 8 >> 2]);
    f11 = f39 < f11 ? f39 : f11;
    i15 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i17 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    f39 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) + 12 >> 2]);
    f10 = f39 > f10 ? f39 : f10;
    f39 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) + 16 >> 2]);
    f9 = f39 > f9 ? f39 : f9;
    f39 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f8 = Math_fround(HEAPF32[i48 + 160 + (i20 * 24 | 0) + 20 >> 2]);
    f8 = f39 > f8 ? f39 : f8;
    i18 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    i19 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
    i20 = i20 + 1 | 0;
    if ((i20 | 0) == (i14 | 0)) break; else i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f36 = Math_fround(f13 - f40);
   f35 = Math_fround(f12 - f41);
   f13 = Math_fround(f11 - f42);
   f39 = Math_fround(f40 + f10);
   f38 = Math_fround(f41 + f9);
   f37 = Math_fround(f42 + f8);
   f7 = f7 < f13 ? f7 : f13;
   f6 = f6 < f35 ? f6 : f35;
   f5 = f5 < f36 ? f5 : f36;
   f4 = f4 > f37 ? f4 : f37;
   f3 = f3 > f38 ? f3 : f38;
   f2 = f2 > f39 ? f2 : f39;
  }
  f35 = Math_fround(HEAPF32[i23 >> 2]);
  i16 = i23 + 4 | 0;
  f39 = Math_fround(HEAPF32[i16 >> 2]);
  i17 = i23 + 8 | 0;
  f38 = Math_fround(HEAPF32[i17 >> 2]);
  f36 = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
  f13 = Math_fround(Math_fround(f3 - f6) * Math_fround(.5));
  f12 = Math_fround(Math_fround(f4 - f7) * Math_fround(.5));
  f37 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f5 + f2) * Math_fround(.5)) * f35) + Math_fround(Math_fround(Math_fround(f6 + f3) * Math_fround(.5)) * f39)) + Math_fround(Math_fround(Math_fround(f7 + f4) * Math_fround(.5)) * f38));
  f36 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f13 * f13) + Math_fround(f36 * f36)))));
  f2 = Math_fround(Math_fround(Math_fround(f43 * f35) + Math_fround(f44 * f39)) + Math_fround(f45 * f38));
  f38 = Math_fround(f36 * Math_fround(2.0));
  f39 = Math_fround(Math_abs(Math_fround(Math_fround(f37 - f36) - f2)));
  f2 = Math_fround(Math_abs(Math_fround(Math_fround(f36 + f37) - f2)));
  f2 = Math_fround(Math_fround(f38 * Math_fround(2.0)) + (f39 < f2 ? f39 : f2));
  HEAPF32[i49 >> 2] = f2;
  i1 = i23;
 } else {
  i1 = i23;
  i16 = i23 + 4 | 0;
  i17 = i23 + 8 | 0;
 }
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f35 = Math_fround(HEAPF32[i16 >> 2]);
 f36 = Math_fround(HEAPF32[i17 >> 2]);
 f37 = Math_fround(-f13);
 f38 = Math_fround(-f35);
 f39 = Math_fround(-f36);
 f37 = f13 > f37 ? f13 : f37;
 f38 = f35 > f38 ? f35 : f38;
 f39 = f36 > f39 ? f36 : f39;
 if (!(f2 >= Math_fround(3402823469999999843913219.0e14))) {
  f5 = Math_fround(f45 + Math_fround(f2 * f36));
  f4 = Math_fround(f44 + Math_fround(f2 * f35));
  f3 = Math_fround(f43 + Math_fround(f2 * f13));
 } else {
  i34 = f13 == Math_fround(0.0);
  i33 = f13 >= Math_fround(0.0);
  f3 = i33 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f3 = i34 ? f43 : f3;
  i34 = f35 == Math_fround(0.0);
  i33 = f35 >= Math_fround(0.0);
  f2 = i33 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f2 = i34 ? f44 : f2;
  if (f36 == Math_fround(0.0)) {
   f5 = f45;
   f4 = f2;
  } else {
   i34 = f36 >= Math_fround(0.0);
   f5 = i34 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
   f4 = f2;
  }
 }
 f2 = f43 < f3 ? f43 : f3;
 f6 = f44 < f4 ? f44 : f4;
 f7 = f45 < f5 ? f45 : f5;
 f8 = f43 > f3 ? f43 : f3;
 f9 = f44 > f4 ? f44 : f4;
 f10 = f45 > f5 ? f45 : f5;
 i15 = i48 + 28 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 L15 : do if (i1 | 0) {
  i14 = 0;
  while (1) {
   f57 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) >> 2]);
   f54 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) + 12 >> 2]);
   f58 = Math_fround(f57 + f54);
   f53 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) + 16 >> 2]);
   f56 = Math_fround(f53 + f11);
   f4 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) + 8 >> 2]);
   f52 = Math_fround(HEAPF32[i48 + 160 + (i14 * 24 | 0) + 20 >> 2]);
   f58 = Math_fround(f58 * Math_fround(.5));
   f56 = Math_fround(f56 * Math_fround(.5));
   f12 = Math_fround(Math_fround(f4 + f52) * Math_fround(.5));
   f57 = Math_fround(f40 + Math_fround(Math_fround(f54 - f57) * Math_fround(.5)));
   f53 = Math_fround(f41 + Math_fround(Math_fround(f11 - f53) * Math_fround(.5)));
   f4 = Math_fround(f42 + Math_fround(Math_fround(f52 - f4) * Math_fround(.5)));
   f52 = Math_fround(f43 - f58);
   f11 = Math_fround(f44 - f56);
   f54 = Math_fround(f45 - f12);
   f3 = Math_fround(Math_fround(f13 * f11) - Math_fround(f35 * f52));
   f11 = Math_fround(Math_fround(f35 * f54) - Math_fround(f36 * f11));
   f54 = Math_fround(Math_fround(f36 * f52) - Math_fround(f13 * f54));
   f52 = Math_fround(Math_fround(f38 * f57) + Math_fround(f37 * f53));
   f5 = Math_fround(Math_fround(f39 * f53) + Math_fround(f38 * f4));
   f55 = Math_fround(Math_fround(f39 * f57) + Math_fround(f37 * f4));
   i31 = Math_fround(f58 + f57) >= f2;
   i33 = Math_fround(f56 + f53) >= f6;
   i29 = Math_fround(f12 + f4) >= f7;
   i32 = f8 >= Math_fround(f58 - f57);
   i34 = f9 >= Math_fround(f56 - f53);
   i30 = f10 >= Math_fround(f12 - f4);
   f4 = Math_fround(-f3);
   f12 = Math_fround(-f11);
   f53 = Math_fround(-f54);
   if (i29 & i30 & f55 >= (f54 > f53 ? f54 : f53) & (i31 & i32 & f52 >= (f3 > f4 ? f3 : f4) & (i33 & i34 & f5 >= (f11 > f12 ? f11 : f12)))) {
    if (!(mftCall_iiiii(HEAP32[HEAP32[i47 >> 2] >> 2] | 0, i47 | 0, i49 | 0, i48 + 32 + (i14 << 3) | 0, 1) | 0)) {
     i1 = 0;
     break;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   i14 = i14 + 1 | 0;
   if (i14 >>> 0 >= i1 >>> 0) break L15;
  }
  STACKTOP = i51;
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i48 + 584 >> 2] | 0)) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 }
 f3 = Math_fround(HEAPF32[i48 + 608 >> 2]);
 f5 = Math_fround(HEAPF32[i48 + 612 >> 2]);
 f58 = Math_fround(HEAPF32[i48 + 616 >> 2]);
 f4 = Math_fround(HEAPF32[i48 + 624 >> 2]);
 f52 = Math_fround(HEAPF32[i48 + 628 >> 2]);
 f4 = Math_fround(f40 + f4);
 f52 = Math_fround(f41 + f52);
 f55 = Math_fround(f42 + Math_fround(HEAPF32[i48 + 632 >> 2]));
 f53 = Math_fround(f43 - f3);
 f57 = Math_fround(f44 - f5);
 f12 = Math_fround(f45 - f58);
 f54 = Math_fround(Math_fround(f13 * f57) - Math_fround(f35 * f53));
 f57 = Math_fround(Math_fround(f35 * f12) - Math_fround(f36 * f57));
 f12 = Math_fround(Math_fround(f36 * f53) - Math_fround(f13 * f12));
 f53 = Math_fround(Math_fround(f38 * f4) + Math_fround(f37 * f52));
 f56 = Math_fround(Math_fround(f39 * f52) + Math_fround(f38 * f55));
 f11 = Math_fround(Math_fround(f39 * f4) + Math_fround(f37 * f55));
 i31 = Math_fround(f3 + f4) >= f2;
 i33 = Math_fround(f5 + f52) >= f6;
 i29 = Math_fround(f58 + f55) >= f7;
 i32 = f8 >= Math_fround(f3 - f4);
 i34 = f9 >= Math_fround(f5 - f52);
 i30 = f10 >= Math_fround(f58 - f55);
 f55 = Math_fround(-f54);
 f58 = Math_fround(-f57);
 f52 = Math_fround(-f12);
 if (!(f11 >= (f12 > f52 ? f12 : f52) & (i29 & i30) & (i31 & i32 & f53 >= (f54 > f55 ? f54 : f55) & (i33 & i34 & f56 >= (f57 > f58 ? f57 : f58))))) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 }
 i34 = HEAP32[i48 + 592 >> 2] | 0;
 f58 = Math_fround(HEAPF32[i49 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + (i34 << 2) >> 2]);
 f11 = Math_fround(HEAPF32[i22 + (i34 << 2) >> 2]);
 i34 = i23 + (i34 << 2) | 0;
 f3 = Math_fround(f11 + Math_fround(f58 * Math_fround(HEAPF32[i34 >> 2])));
 f4 = Math_fround((f11 < f3 ? f11 : f3) - f12);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 f3 = Math_fround(f12 + (f11 > f3 ? f11 : f3));
 i14 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i46 >> 2] = f58;
 i31 = (HEAP32[i16 >> 2] | 0) >>> 31 << 1 | (HEAP32[i23 >> 2] | 0) >>> 31 << 2 | (HEAP32[i17 >> 2] | 0) >>> 31;
 i32 = i48 + 20 | 0;
 i33 = i48 + 24 | 0;
 i14 = (i14 | 0) < 0 ? ~i14 : i14 | -2147483648;
 i15 = (i15 | 0) < 0 ? ~i15 : i15 | -2147483648;
 f3 = f6;
 f4 = f7;
 f5 = f8;
 f6 = f9;
 f7 = f58;
 i29 = 0;
 i30 = HEAPU16[i48 + 848 + (i31 << 1) >> 1] | 0;
 L31 : do {
  i27 = i30 & 7;
  i30 = i30 >>> 3;
  if (HEAP32[i48 + 640 + (i27 << 2) >> 2] | 0) {
   f61 = Math_fround(HEAPF32[i48 + 688 + (i27 << 5) >> 2]);
   f59 = Math_fround(HEAPF32[i48 + 688 + (i27 << 5) + 4 >> 2]);
   f58 = Math_fround(HEAPF32[i48 + 688 + (i27 << 5) + 8 >> 2]);
   f60 = Math_fround(HEAPF32[i48 + 688 + (i27 << 5) + 16 >> 2]);
   f52 = Math_fround(HEAPF32[i48 + 688 + (i27 << 5) + 20 >> 2]);
   f60 = Math_fround(f40 + f60);
   f52 = Math_fround(f41 + f52);
   f55 = Math_fround(f42 + Math_fround(HEAPF32[i48 + 688 + (i27 << 5) + 24 >> 2]));
   f53 = Math_fround(f43 - f61);
   f57 = Math_fround(f44 - f59);
   f9 = Math_fround(f45 - f58);
   f54 = Math_fround(Math_fround(f13 * f57) - Math_fround(f35 * f53));
   f57 = Math_fround(Math_fround(f35 * f9) - Math_fround(f36 * f57));
   f9 = Math_fround(Math_fround(f36 * f53) - Math_fround(f13 * f9));
   f53 = Math_fround(Math_fround(f38 * f60) + Math_fround(f37 * f52));
   f56 = Math_fround(Math_fround(f39 * f52) + Math_fround(f38 * f55));
   f8 = Math_fround(Math_fround(f39 * f60) + Math_fround(f37 * f55));
   i24 = Math_fround(f61 + f60) >= f2;
   i26 = Math_fround(f59 + f52) >= f3;
   i22 = Math_fround(f58 + f55) >= f4;
   i25 = f5 >= Math_fround(f61 - f60);
   i28 = f6 >= Math_fround(f59 - f52);
   i23 = f10 >= Math_fround(f58 - f55);
   f55 = Math_fround(-f54);
   f58 = Math_fround(-f57);
   f52 = Math_fround(-f9);
   if (f8 >= (f9 > f52 ? f9 : f52) & (i22 & i23) & (i24 & i25 & f53 >= (f54 > f55 ? f54 : f55) & (i26 & i28 & f56 >= (f57 > f58 ? f57 : f58)))) {
    i28 = i48 + 660 + (i27 << 2) | 0;
    i25 = 0;
    i26 = HEAPU16[i48 + 864 + (i27 * 224 | 0) + 208 + (i31 << 1) >> 1] | 0;
    do {
     i23 = i26 & 7;
     i26 = i26 >>> 3;
     if (HEAP32[i48 + 864 + (i27 * 224 | 0) + (i23 << 2) >> 2] | 0) {
      f8 = Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) >> 2]);
      f52 = Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 4 >> 2]);
      f61 = Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 8 >> 2]);
      f9 = Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 16 >> 2]);
      f55 = Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 20 >> 2]);
      f9 = Math_fround(f40 + f9);
      f55 = Math_fround(f41 + f55);
      f58 = Math_fround(f42 + Math_fround(HEAPF32[i48 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 24 >> 2]));
      f56 = Math_fround(f43 - f8);
      f60 = Math_fround(f44 - f52);
      f54 = Math_fround(f45 - f61);
      f57 = Math_fround(Math_fround(f13 * f60) - Math_fround(f35 * f56));
      f60 = Math_fround(Math_fround(f35 * f54) - Math_fround(f36 * f60));
      f54 = Math_fround(Math_fround(f36 * f56) - Math_fround(f13 * f54));
      f56 = Math_fround(Math_fround(f38 * f9) + Math_fround(f37 * f55));
      f59 = Math_fround(Math_fround(f39 * f55) + Math_fround(f38 * f58));
      f53 = Math_fround(Math_fround(f39 * f9) + Math_fround(f37 * f58));
      i20 = Math_fround(f8 + f9) >= f2;
      i22 = Math_fround(f52 + f55) >= f3;
      i18 = Math_fround(f61 + f58) >= f4;
      i21 = f5 >= Math_fround(f8 - f9);
      i24 = f6 >= Math_fround(f52 - f55);
      i19 = f10 >= Math_fround(f61 - f58);
      f58 = Math_fround(-f57);
      f61 = Math_fround(-f60);
      f55 = Math_fround(-f54);
      if (f53 >= (f54 > f55 ? f54 : f55) & (i18 & i19) & (i20 & i21 & f56 >= (f57 > f58 ? f57 : f58) & (i22 & i24 & f59 >= (f60 > f61 ? f60 : f61)))) {
       i24 = (HEAP32[i48 + 864 + (i27 * 224 | 0) + 20 + (i23 << 2) >> 2] | 0) + (HEAP32[i28 >> 2] | 0) | 0;
       i19 = i14;
       i18 = i15;
       i21 = 0;
       i22 = HEAPU16[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 208 + (i31 << 1) >> 1] | 0;
       while (1) {
        i14 = i22 & 7;
        i22 = i22 >>> 3;
        i15 = HEAP32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + (i14 << 2) >> 2] | 0;
        L43 : do if (!i15) {
         i14 = i19;
         i15 = i18;
        } else {
         f8 = Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) >> 2]);
         f52 = Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) + 4 >> 2]);
         f61 = Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) + 8 >> 2]);
         f9 = Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) + 16 >> 2]);
         f55 = Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) + 20 >> 2]);
         f9 = Math_fround(f40 + f9);
         f55 = Math_fround(f41 + f55);
         f58 = Math_fround(f42 + Math_fround(HEAPF32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i14 << 5) + 24 >> 2]));
         f56 = Math_fround(f43 - f8);
         f60 = Math_fround(f44 - f52);
         f54 = Math_fround(f45 - f61);
         f57 = Math_fround(Math_fround(f13 * f60) - Math_fround(f35 * f56));
         f60 = Math_fround(Math_fround(f35 * f54) - Math_fround(f36 * f60));
         f54 = Math_fround(Math_fround(f36 * f56) - Math_fround(f13 * f54));
         f56 = Math_fround(Math_fround(f38 * f9) + Math_fround(f37 * f55));
         f59 = Math_fround(Math_fround(f39 * f55) + Math_fround(f38 * f58));
         f53 = Math_fround(Math_fround(f39 * f9) + Math_fround(f37 * f58));
         i62 = Math_fround(f8 + f9) >= f2;
         i17 = Math_fround(f52 + f55) >= f3;
         i64 = Math_fround(f61 + f58) >= f4;
         i16 = f5 >= Math_fround(f8 - f9);
         i20 = f6 >= Math_fround(f52 - f55);
         i63 = f10 >= Math_fround(f61 - f58);
         f58 = Math_fround(-f57);
         f61 = Math_fround(-f60);
         f55 = Math_fround(-f54);
         if (f53 >= (f54 > f55 ? f54 : f55) & (i64 & i63) & (i62 & i16 & f56 >= (f57 > f58 ? f57 : f58) & (i17 & i20 & f59 >= (f60 > f61 ? f60 : f61)))) {
          i17 = i24 + (HEAP32[i48 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 20 + (i14 << 2) >> 2] | 0) | 0;
          i16 = HEAP32[i32 >> 2] | 0;
          i20 = i16 + (i17 + i15 << 5) | 0;
          i16 = i16 + (i17 << 5) | 0;
          i17 = (HEAP32[i33 >> 2] | 0) + (i17 << 3) | 0;
          while (1) {
           f8 = f7;
           L48 : while (1) {
            i14 = i16;
            i16 = i16 + 32 | 0;
            i15 = i17;
            i17 = i17 + 8 | 0;
            do if ((HEAP32[i14 + 28 >> 2] | 0) >>> 0 < i18 >>> 0) f7 = f8; else {
             if ((HEAP32[i14 + 12 >> 2] | 0) >>> 0 > i19 >>> 0) {
              i14 = i19;
              i15 = i18;
              f7 = f8;
              break L43;
             }
             f7 = Math_fround(HEAPF32[i14 >> 2]);
             f52 = Math_fround(HEAPF32[i14 + 4 >> 2]);
             f61 = Math_fround(HEAPF32[i14 + 8 >> 2]);
             f9 = Math_fround(HEAPF32[i14 + 16 >> 2]);
             f55 = Math_fround(HEAPF32[i14 + 20 >> 2]);
             f9 = Math_fround(f40 + f9);
             f55 = Math_fround(f41 + f55);
             f58 = Math_fround(f42 + Math_fround(HEAPF32[i14 + 24 >> 2]));
             f56 = Math_fround(f43 - f7);
             f60 = Math_fround(f44 - f52);
             f54 = Math_fround(f45 - f61);
             f57 = Math_fround(Math_fround(f13 * f60) - Math_fround(f35 * f56));
             f60 = Math_fround(Math_fround(f35 * f54) - Math_fround(f36 * f60));
             f54 = Math_fround(Math_fround(f36 * f56) - Math_fround(f13 * f54));
             f56 = Math_fround(Math_fround(f38 * f9) + Math_fround(f37 * f55));
             f59 = Math_fround(Math_fround(f39 * f55) + Math_fround(f38 * f58));
             f53 = Math_fround(Math_fround(f39 * f9) + Math_fround(f37 * f58));
             i14 = Math_fround(f7 + f9) >= f2;
             i63 = Math_fround(f52 + f55) >= f3;
             i66 = Math_fround(f61 + f58) >= f4;
             i62 = f5 >= Math_fround(f7 - f9);
             i64 = f6 >= Math_fround(f52 - f55);
             i65 = f10 >= Math_fround(f61 - f58);
             f58 = Math_fround(-f57);
             f61 = Math_fround(-f60);
             f55 = Math_fround(-f54);
             if (!(f53 >= (f54 > f55 ? f54 : f55) & (i66 & i65) & (i14 & i62 & f56 >= (f57 > f58 ? f57 : f58) & (i63 & i64 & f59 >= (f60 > f61 ? f60 : f61))))) {
              f7 = f8;
              break;
             }
             if (!(mftCall_iiiii(HEAP32[HEAP32[i47 >> 2] >> 2] | 0, i47 | 0, i46 | 0, i15 | 0, 1) | 0)) {
              i1 = 0;
              i50 = 41;
              break L31;
             }
             f7 = Math_fround(HEAPF32[i46 >> 2]);
             i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
             if (f7 < f8) break L48;
            } while (0);
            if ((i16 | 0) == (i20 | 0)) {
             i14 = i19;
             i15 = i18;
             break L43;
            } else f8 = f7;
           }
           f5 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i34 >> 2])));
           f6 = Math_fround((f11 < f5 ? f11 : f5) - f12);
           i15 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
           f5 = Math_fround(f12 + (f11 > f5 ? f11 : f5));
           i14 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
           f5 = Math_fround(f43 + Math_fround(f13 * f7));
           f6 = Math_fround(f44 + Math_fround(f35 * f7));
           f10 = Math_fround(f45 + Math_fround(f36 * f7));
           f2 = f43 < f5 ? f43 : f5;
           f3 = f44 < f6 ? f44 : f6;
           f4 = f45 < f10 ? f45 : f10;
           f5 = f43 > f5 ? f43 : f5;
           f6 = f44 > f6 ? f44 : f6;
           f10 = f45 > f10 ? f45 : f10;
           i15 = (i15 | 0) < 0 ? ~i15 : i15 | -2147483648;
           i14 = (i14 | 0) < 0 ? ~i14 : i14 | -2147483648;
           if ((i16 | 0) == (i20 | 0)) break; else {
            i19 = i14;
            i18 = i15;
           }
          }
         } else {
          i14 = i19;
          i15 = i18;
         }
        } while (0);
        i21 = i21 + 1 | 0;
        if (i21 >>> 0 >= 5) break; else {
         i19 = i14;
         i18 = i15;
        }
       }
      }
     }
     i25 = i25 + 1 | 0;
    } while (i25 >>> 0 < 5);
   }
  }
  i29 = i29 + 1 | 0;
 } while (i29 >>> 0 < 5);
 if ((i50 | 0) == 41) {
  STACKTOP = i51;
  return i1 | 0;
 }
 HEAP32[i49 >> 2] = i1;
 i66 = 1;
 STACKTOP = i51;
 return i66 | 0;
}

function __ZL11RenderLightRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionRP13RenderTextureS9_iiPK18DeviceStencilStateRK10MinMaxAABBRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(i26, i16, i17, i23, i33, i2, i19, i34, i61, i35, i27, i52) {
 i26 = i26 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i23 = i23 | 0;
 i33 = i33 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i34 = i34 | 0;
 i61 = i61 | 0;
 i35 = i35 | 0;
 i27 = i27 | 0;
 i52 = i52 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i62;
 i28 = i62 + 920 | 0;
 i53 = i62 + 908 | 0;
 i29 = i62 + 904 | 0;
 i30 = i62 + 900 | 0;
 i4 = i62 + 880 | 0;
 i5 = i62 + 864 | 0;
 i6 = i62 + 896 | 0;
 i14 = i62 + 848 | 0;
 i7 = i62 + 784 | 0;
 i10 = i62 + 720 | 0;
 i11 = i62 + 656 | 0;
 i54 = i62 + 292 | 0;
 i15 = i62 + 648 | 0;
 i24 = i62 + 644 | 0;
 i31 = i62 + 640 | 0;
 i32 = i62 + 288 | 0;
 i55 = i62 + 220 | 0;
 i56 = i62 + 208 | 0;
 i57 = i62 + 924 | 0;
 i36 = i62 + 196 | 0;
 HEAP32[i28 >> 2] = i2;
 i58 = HEAP32[i16 >> 2] | 0;
 i43 = HEAP32[i58 >> 2] | 0;
 if ((HEAP16[gb + 1115036 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1115036 | 0, HEAP32[i43 + 16 >> 2] | 0);
  i51 = gb + 1115036 | 0;
 } else i51 = 0;
 i59 = HEAP32[gb + 1115036 >> 2] | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 648 >> 2] | 0, i1 | 0, i59 | 0);
 i59 = i43 + 40 | 0;
 i1 = HEAP32[i59 >> 2] | 0;
 if ((i1 | 0) == 3) i46 = 2; else if ((HEAP32[i43 + 88 >> 2] | 0) > -1) i46 = (HEAP32[i43 + 80 >> 2] | 0) == 1 ? 1 : 2; else i46 = 0;
 i60 = i43 + 216 | 0;
 i20 = i43 + 264 | 0;
 i21 = i43 + 268 | 0;
 i13 = HEAP32[i21 >> 2] | 0;
 i22 = i43 + 272 | 0;
 i18 = HEAP32[i22 >> 2] | 0;
 HEAP32[i53 >> 2] = HEAP32[i20 >> 2];
 i12 = i53 + 4 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i53 + 8 | 0;
 HEAP32[i13 >> 2] = i18;
 i18 = i43 + 96 | 0;
 if (!((HEAP32[i18 >> 2] | 0) == 0 | (i1 | 0) == 1)) __Z16GetBuildSettingsv() | 0;
 i47 = __Z16GetBuildSettingsv() | 0;
 i25 = __Z18GetQualitySettingsv() | 0;
 i49 = HEAP32[i25 + 44 >> 2] | 0;
 i25 = HEAP32[i25 + 28 >> 2] | 0;
 i47 = HEAP16[i47 + 116 >> 1] | 0;
 __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf((i47 & 255) << 24 >> 24 != 0, (i47 & 65535) > 255, HEAP32[i25 + (i49 * 108 | 0) + 20 >> 2] | 0, Math_fround(HEAPF32[i25 + (i49 * 108 | 0) + 36 >> 2])) | 0;
 i49 = __Z12GetGfxDevicev() | 0;
 HEAP32[i29 >> 2] = 0;
 i25 = HEAP32[i2 + 136 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i2 + 128 >> 2];
 i47 = i26 + 8 | 0;
 i48 = HEAP32[i47 >> 2] | 0;
 i3 = (HEAP8[i48 + 1092 >> 0] | 0) != 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = HEAP32[i33 >> 2] | 0;
 if (!i1) {
  i1 = __Z22GetRenderBufferManagerv() | 0;
  if (i3) {
   i2 = __Z12GetGfxDevicev() | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 708 >> 2] | 0, i2 | 0) | 0;
  } else i2 = 0;
  i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i1, -1, -1, 0, i2, 0, 1, 0, 1) | 0;
  HEAP32[i33 >> 2] = i1;
  if (!i1) i1 = 0; else {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 388167 | 0);
   i1 = HEAP32[i33 >> 2] | 0;
  }
  __ZN13RenderTexture6CreateEv(i1) | 0;
  __ZN7Texture13SetFilterModeEi(HEAP32[i33 >> 2] | 0, 0);
  HEAP32[i29 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + 128 >> 2];
  HEAP32[i6 >> 2] = i25;
  HEAP32[i50 >> 2] = HEAP32[i6 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i29, i50, i33, 0, -1, 0, 4) | 0;
  __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(1, i3 ? i5 : i4, Math_fround(1.0), 0, i52);
  __Z15gpu_time_samplev();
  i2 = i29;
  i1 = HEAP32[i33 >> 2] | 0;
 } else i2 = i29;
 HEAP32[i2 >> 2] = HEAP32[i1 + 128 >> 2];
 __Z23SetupLightShaderKeywordRK15SharedLightDataR17ShaderPassContext(i43, i52);
 i1 = HEAP32[i43 + 248 >> 2] | 0;
 i2 = HEAP32[i43 + 252 >> 2] | 0;
 i3 = HEAP32[i43 + 256 >> 2] | 0;
 i45 = i43 + 156 | 0;
 HEAP32[i14 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 switch (HEAP32[i59 >> 2] | 0) {
 case 0:
  {
   i9 = i50;
   i5 = i43 + 280 | 0;
   i8 = i9 + 64 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
    i9 = i9 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i9 | 0) < (i8 | 0));
   HEAPF32[i54 >> 2] = Math_fround(-.5);
   HEAPF32[i54 + 4 >> 2] = Math_fround(-.5);
   HEAPF32[i54 + 8 >> 2] = Math_fround(1.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i7, i54) | 0;
   HEAPF32[i54 >> 2] = Math_fround(.5);
   HEAPF32[i54 + 4 >> 2] = Math_fround(.5);
   HEAPF32[i54 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i10, i54) | 0;
   __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i11, Math_fround(HEAPF32[i43 + 68 >> 2]), Math_fround(0.0), Math_fround(HEAPF32[((HEAP32[i59 >> 2] | 0) == 3 ? i43 + 204 | 0 : i43 + 48 | 0) >> 2])) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i11, i54);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i54, i7, i10);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i50, i49 + 2724 | 0);
   break;
  }
 case 2:
  {
   i9 = i49 + 2724 | 0;
   i5 = i43 + 280 | 0;
   i8 = i9 + 64 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
    i9 = i9 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i9 | 0) < (i8 | 0));
   break;
  }
 case 1:
  {
   f63 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i43 + 64 >> 2]));
   HEAPF32[i50 >> 2] = f63;
   HEAPF32[i50 + 4 >> 2] = f63;
   HEAPF32[i50 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i7, i50) | 0;
   HEAPF32[i50 >> 2] = Math_fround(.5);
   HEAPF32[i50 + 4 >> 2] = Math_fround(.5);
   HEAPF32[i50 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i10, i50) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i7, i11);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i11, i43 + 280 | 0, i49 + 2724 | 0);
   break;
  }
 default:
  {}
 }
 __Z22AssignCookieToMaterialRK15SharedLightDataP8Material(i43, HEAP32[gb + 1115112 >> 2] | 0) | 0;
 i44 = i58 + 20 | 0;
 i45 = HEAP16[i44 >> 1] | 0;
 if ((i45 & 255) << 24 >> 24 == 0 | (i45 & 65535) < 256) i45 = (HEAP32[i59 >> 2] | 0) == 1; else i45 = 1;
 i7 = i52 + 36 | 0;
 f63 = i45 ? Math_fround(1.0) : Math_fround(0.0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i7, gb + 1115104 | 0, f63, 0);
 i41 = HEAP32[i12 >> 2] | 0;
 i42 = HEAP32[i13 >> 2] | 0;
 i5 = i43 + 48 | 0;
 f63 = Math_fround(HEAPF32[((HEAP32[i59 >> 2] | 0) == 3 ? i43 + 204 | 0 : i5) >> 2]);
 f63 = Math_fround(Math_fround(1.0) / Math_fround(f63 * f63));
 HEAP32[i50 >> 2] = HEAP32[i53 >> 2];
 HEAP32[i50 + 4 >> 2] = i41;
 HEAP32[i50 + 8 >> 2] = i42;
 HEAPF32[i50 + 12 >> 2] = f63;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i7, gb + 1115084 | 0, i50, 0);
 HEAP32[i50 >> 2] = i1;
 HEAP32[i50 + 4 >> 2] = i2;
 HEAP32[i50 + 8 >> 2] = i3;
 HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i7, gb + 1115088 | 0, i50, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i7, gb + 1115092 | 0, i14, 0);
 i3 = HEAP32[gb + 1115112 >> 2] | 0;
 HEAP32[i15 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i15, gb + 387690 | 0);
 i7 = __ZN10builtintex21GetAttenuationTextureEv() | 0;
 HEAP32[i50 >> 2] = HEAP32[i15 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i3, i50, i7);
 i7 = __ZNK6Camera16GetStereoEnabledEv(HEAP32[i47 >> 2] | 0) | 0;
 i3 = i16 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = i16 + 8 | 0;
  if ((i17 | 0) != 0 & (HEAP32[i1 >> 2] | 0) != 0) {
   i6 = i1;
   i2 = 25;
  } else i2 = 50;
 } else if (!i17) i2 = 50; else {
  i6 = i16 + 8 | 0;
  i2 = 25;
 }
 if ((i2 | 0) == 25) {
  i4 = HEAP32[i18 >> 2] | 0;
  i4 = (i17 | 0) == 1 & (i4 | 0) != 0 ? 1 : i4;
  __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i52, HEAP32[i59 >> 2] | 0, i4, i23, 0, 1);
  mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 112 >> 2] | 0, i49 | 0, i26 + 1732 | 0);
  mftCall_viii(HEAP32[(HEAP32[i49 >> 2] | 0) + 72 >> 2] | 0, i49 | 0, i19 | 0, 0);
  HEAP32[i54 >> 2] = 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   if (i7) {
    __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE(HEAP32[i47 >> 2] | 0, i50);
    __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f(HEAP32[i47 >> 2] | 0, i26 + 1664 | 0);
    __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(HEAP32[i47 >> 2] | 0, i26 + 1600 | 0);
   }
   mftCall_vi(HEAP32[(HEAP32[i49 >> 2] | 0) + 340 >> 2] | 0, i49 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i54 >> 2] = __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext(i1, i52) | 0;
   HEAP32[i54 + 344 >> 2] = HEAP32[i1 + 35884 >> 2];
   if (i7) __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE(HEAP32[i47 >> 2] | 0, i50);
   _memcpy(i54 + 4 | 0, i1 + 34040 | 0, 256) | 0;
   i9 = i54 + 260 | 0;
   i5 = i1 + 35824 | 0;
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   i9 = i54 + 280 | 0;
   i5 = i1 + 35760 | 0;
   i8 = i9 + 64 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
    i9 = i9 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i9 | 0) < (i8 | 0));
  } else {
   _memcpy(i54 | 0, i1 | 0, 348) | 0;
   if ((HEAP32[i59 >> 2] | 0) == 2) {
    f63 = Math_fround(HEAPF32[i5 >> 2]);
    i41 = HEAP32[i21 >> 2] | 0;
    i42 = HEAP32[i22 >> 2] | 0;
    f63 = Math_fround(Math_fround(1.0) / f63);
    HEAP32[i49 + 676 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i49 + 680 >> 2] = i41;
    HEAP32[i49 + 684 >> 2] = i42;
    HEAPF32[i49 + 688 >> 2] = f63;
   }
  }
  i1 = HEAP32[i54 >> 2] | 0;
  do if (!i1) {
   __Z20SetNoShadowsKeywordsR17ShaderPassContext(i52);
   i1 = 0;
   i2 = 0;
  } else {
   HEAPF32[i49 + 788 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i43 + 108 >> 2]));
   HEAPF32[i49 + 792 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 796 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 800 >> 2] = Math_fround(0.0);
   switch (HEAP32[i59 >> 2] | 0) {
   case 1:
    {
     i2 = i54 + 4 | 0;
     i9 = i49 + 2148 | 0;
     i5 = i2;
     i8 = i9 + 64 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
      i9 = i9 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i9 | 0) < (i8 | 0));
     i42 = HEAP32[i54 + 344 >> 2] | 0;
     f64 = Math_fround(HEAP32[i1 + 80 >> 2] | 0);
     f63 = Math_fround(HEAP32[i1 + 84 >> 2] | 0);
     HEAPF32[i50 >> 2] = f64;
     HEAPF32[i50 + 4 >> 2] = f63;
     __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext(i2, i42, i54 + 260 | 0, i54 + 280 | 0, i50, i52);
     if (i7 | (HEAP32[i6 >> 2] | 0) == 0) {
      i1 = __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext(HEAP32[i47 >> 2] | 0, i43, i1, i4, i23, i52) | 0;
      if (!i7) HEAP32[i54 >> 2] = i1;
      i2 = i7 & 1;
     } else i2 = 0;
     break;
    }
   case 0:
    {
     i9 = i49 + 2148 | 0;
     i5 = i54 + 4 | 0;
     i8 = i9 + 64 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
      i9 = i9 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i9 | 0) < (i8 | 0));
     i2 = 0;
     break;
    }
   default:
    i2 = 0;
   }
   f63 = Math_fround(Math_fround(.5) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0));
   f64 = Math_fround(Math_fround(.5) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0));
   f65 = Math_fround(-f63);
   f66 = Math_fround(-f64);
   HEAPF32[i49 + 724 >> 2] = f65;
   HEAPF32[i49 + 728 >> 2] = f66;
   HEAPF32[i49 + 732 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 736 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 740 >> 2] = f63;
   HEAPF32[i49 + 744 >> 2] = f66;
   HEAPF32[i49 + 748 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 752 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 756 >> 2] = f65;
   HEAPF32[i49 + 760 >> 2] = f64;
   HEAPF32[i49 + 764 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 768 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 772 >> 2] = f63;
   HEAPF32[i49 + 776 >> 2] = f64;
   HEAPF32[i49 + 780 >> 2] = Math_fround(0.0);
   HEAPF32[i49 + 784 >> 2] = Math_fround(0.0);
   i42 = HEAP32[gb + 1115112 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[gb + 1115108 >> 2];
   HEAP32[i50 >> 2] = HEAP32[i24 >> 2];
   __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i42, i50, i1);
   if (!(HEAP32[i6 >> 2] | 0)) {
    i42 = __Z19GetGraphicsSettingsv() | 0;
    if (!(HEAP8[i42 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0)) i3 = (HEAP32[i59 >> 2] | 0) == 1; else i3 = 0;
    if ((i3 | i27 ^ 1) & (i7 ^ 1)) i2 = 1; else __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai(HEAP32[i26 + 1728 >> 2] | 0, i54, HEAP32[(HEAP32[i58 >> 2] | 0) + 16 >> 2] | 0);
   }
   if (!(HEAP32[i33 >> 2] | 0)) {
    HEAP32[i32 >> 2] = i25;
    HEAP32[i50 >> 2] = HEAP32[i32 >> 2];
    __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i30, i50, i28, 0, -1, 0, 0) | 0;
    break;
   } else {
    HEAP32[i31 >> 2] = i25;
    HEAP32[i50 >> 2] = HEAP32[i31 >> 2];
    __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i29, i50, i33, 0, -1, 0, 0) | 0;
    break;
   }
  } while (0);
  mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 116 >> 2] | 0, i49 | 0, i34 + 132 | 0);
  mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 112 >> 2] | 0, i49 | 0, i34 + 68 | 0);
  __Z27SetClippingPlaneShaderPropsR9GfxDevice(__Z12GetGfxDevicev() | 0);
  mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 148 >> 2] | 0, i49 | 0, 0);
  i42 = (i2 & 1) == 0;
 } else if ((i2 | 0) == 50) {
  __Z20SetNoShadowsKeywordsR17ShaderPassContext(i52);
  i1 = 0;
  i42 = 1;
 }
 i40 = i50;
 HEAP32[i40 >> 2] = 64;
 HEAP32[i40 + 4 >> 2] = 0;
 i40 = (i46 | 0) == 0;
 if (i40) {
  HEAP32[i50 >> 2] = 0;
  i39 = 1;
 } else if ((i46 | 0) == 1) {
  HEAP32[i50 >> 2] = 64;
  i39 = 1;
 } else i39 = 2;
 i41 = HEAP16[i44 >> 1] | 0;
 if ((i41 & 255) << 24 >> 24 == 0 & (i40 & (i41 & 65535) < 256)) i41 = (HEAP32[i59 >> 2] | 2 | 0) == 2; else i41 = 0;
 i2 = HEAP32[i58 + 16 >> 2] | 0;
 if ((i2 | 0) == -1) i2 = 0; else {
  i4 = 0;
  i3 = ~i2;
  i2 = 0;
  while (1) {
   if (i3 & 1) {
    i38 = HEAP32[i35 + 4 + (i4 << 2) >> 2] | 0;
    i2 = ((i38 | 0) == -1 ? 0 : 1 << i38) | i2;
   }
   i3 = i3 >>> 1;
   if (!i3) break; else i4 = i4 + 1 | 0;
  }
 }
 __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i54, __Z12GetGfxDevicev() | 0);
 if (i45) __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i48)), i49);
 if (i41) {
  i33 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(__ZN8Material23GetStencilWriteMaterialEv() | 0, 0, i52, 0, 1) | 0;
  HEAP8[i55 + 1 >> 0] = 1;
  HEAP8[i55 + 2 >> 0] = 0;
  HEAP8[i55 + 3 >> 0] = 1;
  HEAP32[i55 + 4 >> 2] = 0;
  HEAP8[i55 + 8 >> 0] = 15;
  HEAP8[i55 + 9 >> 0] = 1;
  HEAP8[i55 + 10 >> 0] = 0;
  HEAP8[i55 + 11 >> 0] = 1;
  HEAP32[i55 + 12 >> 2] = 0;
  HEAP8[i55 + 16 >> 0] = 15;
  HEAP8[i55 + 17 >> 0] = 1;
  HEAP8[i55 + 18 >> 0] = 0;
  HEAP8[i55 + 19 >> 0] = 1;
  HEAP32[i55 + 20 >> 2] = 0;
  HEAP8[i55 + 24 >> 0] = 15;
  HEAP8[i55 + 25 >> 0] = 1;
  HEAP8[i55 + 26 >> 0] = 0;
  HEAP8[i55 + 27 >> 0] = 1;
  HEAP32[i55 + 28 >> 2] = 0;
  HEAP8[i55 + 32 >> 0] = 15;
  HEAP8[i55 + 33 >> 0] = 1;
  HEAP8[i55 + 34 >> 0] = 0;
  HEAP8[i55 + 35 >> 0] = 1;
  HEAP32[i55 + 36 >> 2] = 0;
  HEAP8[i55 + 40 >> 0] = 15;
  HEAP8[i55 + 41 >> 0] = 1;
  HEAP8[i55 + 42 >> 0] = 0;
  HEAP8[i55 + 43 >> 0] = 1;
  HEAP32[i55 + 44 >> 2] = 0;
  HEAP8[i55 + 48 >> 0] = 15;
  HEAP8[i55 + 49 >> 0] = 1;
  HEAP8[i55 + 50 >> 0] = 0;
  HEAP8[i55 + 51 >> 0] = 1;
  HEAP32[i55 + 52 >> 2] = 0;
  HEAP8[i55 + 56 >> 0] = 15;
  HEAP8[i55 + 57 >> 0] = 1;
  HEAP8[i55 + 58 >> 0] = 0;
  HEAP8[i55 + 59 >> 0] = 1;
  HEAP32[i55 + 60 >> 2] = 0;
  HEAP32[i55 + 64 >> 2] = 0;
  HEAP8[i55 >> 0] = 0;
  i34 = HEAP32[i49 >> 2] | 0;
  i35 = HEAP32[i34 + 60 >> 2] | 0;
  mftCall_vii(i35 | 0, i49 | 0, mftCall_iii(HEAP32[i34 + 44 >> 2] | 0, i49 | 0, i55 | 0) | 0);
  HEAP32[i56 + 4 >> 2] = 0;
  HEAPF32[i56 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i56 >> 2] = 0;
  i34 = HEAP32[i49 >> 2] | 0;
  i35 = HEAP32[i34 + 64 >> 2] | 0;
  mftCall_vii(i35 | 0, i49 | 0, mftCall_iii(HEAP32[i34 + 56 >> 2] | 0, i49 | 0, i56 | 0) | 0);
  HEAP8[i57 >> 0] = 0;
  HEAP8[i57 + 1 >> 0] = 4;
  i34 = HEAP32[i49 >> 2] | 0;
  i35 = HEAP32[i34 + 68 >> 2] | 0;
  mftCall_vii(i35 | 0, i49 | 0, mftCall_iii(HEAP32[i34 + 48 >> 2] | 0, i49 | 0, i57 | 0) | 0);
  HEAP8[i36 + 3 >> 0] = 0;
  HEAP8[i36 + 6 >> 0] = 0;
  HEAP8[i36 + 10 >> 0] = 0;
  HEAP8[i36 >> 0] = 1;
  HEAP8[i36 + 1 >> 0] = -1;
  HEAP8[i36 + 2 >> 0] = 16;
  HEAP8[i36 + 11 >> 0] = 5;
  HEAP8[i36 + 7 >> 0] = 5;
  HEAP8[i36 + 9 >> 0] = 0;
  HEAP8[i36 + 5 >> 0] = 0;
  i34 = i2 | 0 ? 6 : 8;
  HEAP8[i36 + 8 >> 0] = i34;
  HEAP8[i36 + 4 >> 0] = i34;
  i34 = HEAP32[i49 >> 2] | 0;
  i35 = HEAP32[i34 + 72 >> 2] | 0;
  mftCall_viii(i35 | 0, i49 | 0, mftCall_iii(HEAP32[i34 + 52 >> 2] | 0, i49 | 0, i36 | 0) | 0, i2 | 192 | 0);
  __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns(i49, i48, i58, i53, i60, i45, i33);
  HEAP8[i55 >> 0] = 15;
  i33 = HEAP32[i49 >> 2] | 0;
  i34 = HEAP32[i33 + 60 >> 2] | 0;
  mftCall_vii(i34 | 0, i49 | 0, mftCall_iii(HEAP32[i33 + 44 >> 2] | 0, i49 | 0, i55 | 0) | 0);
  i33 = i49;
  i34 = i49;
  i35 = i49;
 } else {
  i33 = i49;
  i34 = i49;
  i35 = i49;
 }
 i36 = i61 + 4 | 0;
 i37 = i61 + 8 | 0;
 i38 = i61 + 12 | 0;
 i20 = i43 + 108 | 0;
 i13 = i49 + 708 | 0;
 i14 = i49 + 712 | 0;
 i16 = i49 + 716 | 0;
 i18 = i49 + 720 | 0;
 i21 = i49 + 788 | 0;
 i15 = i49 + 792 | 0;
 i17 = i49 + 796 | 0;
 i19 = i49 + 800 | 0;
 i22 = i55 + 1 | 0;
 i23 = i55 + 2 | 0;
 i24 = i55 + 3 | 0;
 i25 = i55 + 4 | 0;
 i26 = i55 + 5 | 0;
 i27 = i55 + 6 | 0;
 i28 = i55 + 7 | 0;
 i29 = i55 + 8 | 0;
 i30 = i55 + 9 | 0;
 i31 = i55 + 10 | 0;
 i32 = i55 + 11 | 0;
 i8 = (i46 | 0) == 1;
 i7 = i8 ? -64 : -128;
 i9 = (i7 & 255 | 32) & 255;
 i10 = i56 + 4 | 0;
 i11 = i56 + 8 | 0;
 i12 = i57 + 1 | 0;
 i6 = 0;
 do {
  i5 = HEAP32[i36 >> 2] | 0;
  i43 = HEAP32[i37 >> 2] | 0;
  i3 = HEAP32[i38 >> 2] | 0;
  f66 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i20 >> 2]));
  i46 = i40 | (i6 | 0) == 0;
  HEAP32[i13 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i14 >> 2] = i5;
  HEAP32[i16 >> 2] = i46 ? 0 : i43;
  HEAP32[i18 >> 2] = i46 ? 0 : i3;
  HEAPF32[i21 >> 2] = f66;
  HEAP32[i15 >> 2] = i5;
  HEAP32[i17 >> 2] = i46 ? i43 : 0;
  HEAP32[i19 >> 2] = i46 ? i3 : 0;
  i3 = HEAP32[gb + 1115112 >> 2] | 0;
  if (!(HEAP8[(HEAP32[i47 >> 2] | 0) + 1092 >> 0] | 0)) i5 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i3, 0, i52, 0, 1) | 0; else i5 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i3, 1, i52, 0, 1) | 0;
  HEAP8[i23 >> 0] = -1;
  HEAP8[i24 >> 0] = 0;
  HEAP8[i26 >> 0] = 0;
  HEAP8[i27 >> 0] = 0;
  HEAP8[i28 >> 0] = 0;
  HEAP8[i30 >> 0] = 0;
  HEAP8[i31 >> 0] = 0;
  HEAP8[i32 >> 0] = 0;
  HEAP8[i55 >> 0] = 1;
  HEAP8[i29 >> 0] = 3;
  HEAP8[i25 >> 0] = 3;
  i4 = (i8 & (i6 | 0) != 0 ? i9 : i7) & 255 | i2;
  HEAP8[i22 >> 0] = i4;
  i3 = (HEAP32[i50 + (i6 << 2) >> 2] | 0) + 128 | 0;
  if (i41) {
   HEAP8[i23 >> 0] = 16;
   HEAP8[i32 >> 0] = 1;
   HEAP8[i28 >> 0] = 1;
   HEAP8[i30 >> 0] = 1;
   HEAP8[i26 >> 0] = 1;
   HEAP8[i31 >> 0] = 1;
   HEAP8[i27 >> 0] = 1;
   HEAP8[i22 >> 0] = i4 | 16;
   i3 = i3 | 16;
  }
  i46 = mftCall_iii(HEAP32[(HEAP32[i49 >> 2] | 0) + 52 >> 2] | 0, i49 | 0, i55 | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 72 >> 2] | 0, i49 | 0, i46 | 0, i3 | 0);
  HEAP32[i56 >> 2] = 2;
  HEAP32[i10 >> 2] = 0;
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAP8[i12 >> 0] = 2;
  HEAP8[i57 >> 0] = 0;
  i46 = HEAP16[i44 >> 1] | 0;
  L102 : do if ((i46 & 255) << 24 >> 24 != 0 & (i46 & 65535) < 256) {
   switch (HEAP32[i59 >> 2] | 0) {
   case 2:
   case 0:
    break;
   default:
    {
     i3 = 4;
     break L102;
    }
   }
   HEAP32[i56 >> 2] = 1;
   i3 = 5;
  } else i3 = 4; while (0);
  HEAP8[i12 >> 0] = i3;
  i46 = HEAP32[i34 >> 2] | 0;
  i43 = HEAP32[i46 + 64 >> 2] | 0;
  mftCall_vii(i43 | 0, i49 | 0, mftCall_iii(HEAP32[i46 + 56 >> 2] | 0, i49 | 0, i56 | 0) | 0);
  i46 = HEAP32[i35 >> 2] | 0;
  i43 = HEAP32[i46 + 68 >> 2] | 0;
  mftCall_vii(i43 | 0, i49 | 0, mftCall_iii(HEAP32[i46 + 48 >> 2] | 0, i49 | 0, i57 | 0) | 0);
  __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns(i49, i48, i58, i53, i60, i45, i5);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i39 | 0));
 if (!(i42 | (i1 | 0) == 0)) __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i1);
 __ZN27DeviceViewProjMatricesStateD2Ev(i54);
 i61 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i61 >> 2] | 0) + 652 >> 2] | 0, i61 | 0);
 if (!i51) {
  STACKTOP = i62;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i51);
 STACKTOP = i62;
 return;
}

function __ZN19ClampVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i5, i2, i3, i4, i6, i105, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i105 = i105 | 0;
 i1 = i1 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0;
 i106 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i103 = i106 + 184 | 0;
 i100 = i106 + 148 | 0;
 i101 = i106 + 112 | 0;
 i102 = i106 + 64 | 0;
 i96 = i106 + 48 | 0;
 i97 = i106 + 32 | 0;
 i98 = i106 + 16 | 0;
 i99 = i106;
 if ((HEAP16[gb + 1451776 + 6 >> 1] | 0) > -1) {
  HEAP32[i100 >> 2] = 0;
  HEAP32[i103 >> 2] = HEAP32[i100 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451776 | 0, i103);
  i104 = gb + 1451776 | 0;
 } else i104 = 0;
 f26 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i5 + 1068 >> 2]));
 f27 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(30.0));
 f28 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(30.0));
 f29 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(30.0));
 f28 = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(+f26, +f28)));
 f29 = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(+f26, +f29)));
 f30 = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(+f26, +Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(30.0)))));
 HEAPF32[i103 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(+f26, +f27)));
 i93 = i103 + 4 | 0;
 HEAPF32[i93 >> 2] = f28;
 i94 = i103 + 8 | 0;
 HEAPF32[i94 >> 2] = f29;
 i95 = i103 + 12 | 0;
 HEAPF32[i95 >> 2] = f30;
 do if (!(HEAP8[i5 + 1065 >> 0] | 0)) {
  i3 = i5 + 800 | 0;
  i1 = HEAP32[i5 + 884 >> 2] | 0;
  i2 = i1 & 65535;
  if (!(i2 << 16 >> 16)) {
   __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i3, i4, i6, i105, i103);
   break;
  }
  if (!(i1 & 16711680)) {
   __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i3, i4, i6, i105, i103);
   break;
  }
  if ((i2 | 1) << 16 >> 16 == 3) {
   __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i3, i4, i6, i105, i103);
   break;
  } else {
   __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i3, i4, i6, i105, i103);
   break;
  }
 } else {
  i79 = __Z25GetTransformationMatricesPN4math8float3x3ES1_bbRK10Matrix4x4fS4_(i100, i101, (HEAP32[i2 + 280 >> 2] | 0) == 1, (HEAP8[i5 + 1064 >> 0] | 0) != 0, i3 + 52 | 0, i3 + 180 | 0) | 0;
  L16 : do if (i6 >>> 0 < i105 >>> 0) {
   i80 = i4 + 500 | 0;
   i81 = i96 + 4 | 0;
   i82 = i96 + 8 | 0;
   i83 = i96 + 12 | 0;
   i84 = i4 + 520 | 0;
   i85 = i96 + 4 | 0;
   i86 = i96 + 8 | 0;
   i87 = i96 + 12 | 0;
   i88 = i4 + 120 | 0;
   i89 = i4 + 140 | 0;
   i90 = i4 + 160 | 0;
   i91 = i4 + 60 | 0;
   i92 = i4 + 80 | 0;
   i46 = i4 + 100 | 0;
   i47 = i100 + 12 | 0;
   i48 = i100 + 24 | 0;
   i49 = i100 + 4 | 0;
   i50 = i100 + 16 | 0;
   i51 = i100 + 28 | 0;
   i52 = i100 + 8 | 0;
   i53 = i100 + 20 | 0;
   i54 = i100 + 32 | 0;
   i55 = i5 + 8 | 0;
   i56 = i5 + 92 | 0;
   i57 = i5 + 272 | 0;
   i58 = i102 + 16 | 0;
   i59 = i5 + 356 | 0;
   i60 = i5 + 536 | 0;
   i61 = i102 + 32 | 0;
   i62 = i5 + 620 | 0;
   i63 = i97 + 4 | 0;
   i64 = i97 + 8 | 0;
   i65 = i97 + 12 | 0;
   i66 = i98 + 4 | 0;
   i67 = i98 + 8 | 0;
   i68 = i98 + 12 | 0;
   i69 = i99 + 4 | 0;
   i70 = i99 + 8 | 0;
   i71 = i99 + 12 | 0;
   i72 = i101 + 12 | 0;
   i73 = i101 + 24 | 0;
   i74 = i101 + 4 | 0;
   i75 = i101 + 16 | 0;
   i76 = i101 + 28 | 0;
   i77 = i101 + 8 | 0;
   i78 = i101 + 20 | 0;
   i31 = i101 + 32 | 0;
   i32 = i5 + 616 | 0;
   i33 = i5 + 768 | 0;
   i34 = i5 + 680 | 0;
   i35 = i102 + 36 | 0;
   i36 = i102 + 40 | 0;
   i37 = i102 + 44 | 0;
   i38 = i5 + 352 | 0;
   i39 = i5 + 504 | 0;
   i40 = i5 + 416 | 0;
   i41 = i102 + 20 | 0;
   i42 = i102 + 24 | 0;
   i43 = i102 + 28 | 0;
   i44 = i5 + 88 | 0;
   i45 = i5 + 240 | 0;
   i2 = i5 + 152 | 0;
   i3 = i102 + 4 | 0;
   i4 = i102 + 8 | 0;
   i5 = i102 + 12 | 0;
   while (1) {
    i109 = (HEAP32[i80 >> 2] | 0) + (i6 << 2) | 0;
    i108 = (HEAP32[i109 + 4 >> 2] | 0) + 322376503 | 0;
    i107 = (HEAP32[i109 + 8 >> 2] | 0) + 322376503 | 0;
    i1 = (HEAP32[i109 + 12 >> 2] | 0) + 322376503 | 0;
    HEAP32[i96 >> 2] = (HEAP32[i109 >> 2] | 0) + 322376503;
    HEAP32[i81 >> 2] = i108;
    HEAP32[i82 >> 2] = i107;
    HEAP32[i83 >> 2] = i1;
    __Z17GenerateRandomNx3RKN4math5_int4E(i102, i96);
    i1 = (HEAP32[i84 >> 2] | 0) + (i6 << 2) | 0;
    f22 = Math_fround(HEAPF32[i1 >> 2]);
    f21 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f20 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f21 = Math_fround(f21 * Math_fround(.00999999977));
    f20 = Math_fround(f20 * Math_fround(.00999999977));
    f19 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
    HEAPF32[i96 >> 2] = Math_fround(f22 * Math_fround(.00999999977));
    HEAPF32[i85 >> 2] = f21;
    HEAPF32[i86 >> 2] = f20;
    HEAPF32[i87 >> 2] = f19;
    i1 = (HEAP32[i88 >> 2] | 0) + (i6 << 2) | 0;
    f19 = Math_fround(HEAPF32[i1 >> 2]);
    f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f22 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = (HEAP32[i89 >> 2] | 0) + (i6 << 2) | 0;
    f23 = Math_fround(HEAPF32[i1 >> 2]);
    f24 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f25 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f26 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = (HEAP32[i90 >> 2] | 0) + (i6 << 2) | 0;
    f27 = Math_fround(HEAPF32[i1 >> 2]);
    f28 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f30 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = (HEAP32[i91 >> 2] | 0) + (i6 << 2) | 0;
    f7 = Math_fround(HEAPF32[i1 >> 2]);
    f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f15 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = (HEAP32[i92 >> 2] | 0) + (i6 << 2) | 0;
    f17 = Math_fround(HEAPF32[i1 >> 2]);
    f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f14 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = (HEAP32[i46 >> 2] | 0) + (i6 << 2) | 0;
    f12 = Math_fround(HEAPF32[i1 >> 2]);
    f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
    f7 = Math_fround(f19 + f7);
    f11 = Math_fround(f20 + f11);
    f13 = Math_fround(f21 + f13);
    f15 = Math_fround(f22 + f15);
    f17 = Math_fround(f23 + f17);
    f18 = Math_fround(f24 + f18);
    f16 = Math_fround(f25 + f16);
    f14 = Math_fround(f26 + f14);
    f12 = Math_fround(f27 + f12);
    f10 = Math_fround(f28 + f10);
    f8 = Math_fround(f29 + f8);
    f9 = Math_fround(f30 + Math_fround(HEAPF32[i1 + 12 >> 2]));
    if (i79) {
     f117 = Math_fround(HEAPF32[i100 >> 2]);
     f120 = Math_fround(f7 * f117);
     f119 = Math_fround(f11 * f117);
     f118 = Math_fround(f13 * f117);
     f117 = Math_fround(f15 * f117);
     f113 = Math_fround(HEAPF32[i47 >> 2]);
     f120 = Math_fround(f120 + Math_fround(f17 * f113));
     f119 = Math_fround(f119 + Math_fround(f18 * f113));
     f118 = Math_fround(f118 + Math_fround(f16 * f113));
     f113 = Math_fround(f117 + Math_fround(f14 * f113));
     f117 = Math_fround(HEAPF32[i48 >> 2]);
     f120 = Math_fround(f120 + Math_fround(f12 * f117));
     f119 = Math_fround(f119 + Math_fround(f10 * f117));
     f118 = Math_fround(f118 + Math_fround(f8 * f117));
     f117 = Math_fround(f113 + Math_fround(f9 * f117));
     f113 = Math_fround(HEAPF32[i49 >> 2]);
     f116 = Math_fround(f7 * f113);
     f115 = Math_fround(f11 * f113);
     f114 = Math_fround(f13 * f113);
     f113 = Math_fround(f15 * f113);
     f110 = Math_fround(HEAPF32[i50 >> 2]);
     f116 = Math_fround(f116 + Math_fround(f17 * f110));
     f115 = Math_fround(f115 + Math_fround(f18 * f110));
     f114 = Math_fround(f114 + Math_fround(f16 * f110));
     f110 = Math_fround(f113 + Math_fround(f14 * f110));
     f113 = Math_fround(HEAPF32[i51 >> 2]);
     f116 = Math_fround(f116 + Math_fround(f12 * f113));
     f115 = Math_fround(f115 + Math_fround(f10 * f113));
     f114 = Math_fround(f114 + Math_fround(f8 * f113));
     f113 = Math_fround(f110 + Math_fround(f9 * f113));
     f110 = Math_fround(HEAPF32[i52 >> 2]);
     f112 = Math_fround(f7 * f110);
     f111 = Math_fround(f11 * f110);
     f13 = Math_fround(f13 * f110);
     f110 = Math_fround(f15 * f110);
     f11 = Math_fround(HEAPF32[i53 >> 2]);
     f112 = Math_fround(f112 + Math_fround(f17 * f11));
     f111 = Math_fround(f111 + Math_fround(f18 * f11));
     f13 = Math_fround(f13 + Math_fround(f16 * f11));
     f11 = Math_fround(f110 + Math_fround(f14 * f11));
     f110 = Math_fround(HEAPF32[i54 >> 2]);
     f7 = f120;
     f8 = Math_fround(f13 + Math_fround(f8 * f110));
     f9 = Math_fround(f11 + Math_fround(f9 * f110));
     f11 = f119;
     f13 = f118;
     f15 = f117;
     f17 = f116;
     f18 = f115;
     f16 = f114;
     f14 = f113;
     f12 = Math_fround(f112 + Math_fround(f12 * f110));
     f10 = Math_fround(f111 + Math_fround(f10 * f110));
    }
    i1 = HEAP32[i56 >> 2] | 0;
    L23 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i109 = HEAP32[i44 >> 2] | 0;
      HEAP32[i65 >> 2] = i109;
      HEAP32[i64 >> 2] = i109;
      HEAP32[i63 >> 2] = i109;
      HEAP32[i97 >> 2] = i109;
      break;
     }
    case 3:
     {
      f116 = Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 4 >> 2]);
      f120 = Math_fround(HEAPF32[i44 >> 2]);
      f116 = Math_fround(f116 * f120);
      f120 = Math_fround(Math_fround(f120 * Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + 4 >> 2])) - f116);
      f117 = Math_fround(Math_fround(HEAPF32[i102 >> 2]) * f120);
      f118 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i3 >> 2])));
      f119 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i4 >> 2])));
      f120 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i5 >> 2])));
      HEAPF32[i97 >> 2] = Math_fround(f116 + f117);
      HEAPF32[i63 >> 2] = f118;
      HEAPF32[i64 >> 2] = f119;
      HEAPF32[i65 >> 2] = f120;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i97, i55, i96, i102);
      break L23;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i97, i55, i96, i102);
      break L23;
     }
    } while (0);
    i1 = HEAP32[i59 >> 2] | 0;
    L31 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i109 = HEAP32[i38 >> 2] | 0;
      HEAP32[i68 >> 2] = i109;
      HEAP32[i67 >> 2] = i109;
      HEAP32[i66 >> 2] = i109;
      HEAP32[i98 >> 2] = i109;
      break;
     }
    case 3:
     {
      f116 = Math_fround(HEAPF32[(HEAP32[i39 >> 2] | 0) + 4 >> 2]);
      f120 = Math_fround(HEAPF32[i38 >> 2]);
      f116 = Math_fround(f116 * f120);
      f120 = Math_fround(Math_fround(f120 * Math_fround(HEAPF32[(HEAP32[i40 >> 2] | 0) + 4 >> 2])) - f116);
      f117 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f120);
      f118 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i41 >> 2])));
      f119 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i42 >> 2])));
      f120 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i43 >> 2])));
      HEAPF32[i98 >> 2] = Math_fround(f116 + f117);
      HEAPF32[i66 >> 2] = f118;
      HEAPF32[i67 >> 2] = f119;
      HEAPF32[i68 >> 2] = f120;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i98, i57, i96, i58);
      break L31;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i98, i57, i96, i58);
      break L31;
     }
    } while (0);
    i1 = HEAP32[i62 >> 2] | 0;
    L39 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i109 = HEAP32[i32 >> 2] | 0;
      HEAP32[i71 >> 2] = i109;
      HEAP32[i70 >> 2] = i109;
      HEAP32[i69 >> 2] = i109;
      HEAP32[i99 >> 2] = i109;
      break;
     }
    case 3:
     {
      f116 = Math_fround(HEAPF32[(HEAP32[i33 >> 2] | 0) + 4 >> 2]);
      f120 = Math_fround(HEAPF32[i32 >> 2]);
      f116 = Math_fround(f116 * f120);
      f120 = Math_fround(Math_fround(f120 * Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + 4 >> 2])) - f116);
      f117 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) * f120);
      f118 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i35 >> 2])));
      f119 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i36 >> 2])));
      f120 = Math_fround(f116 + Math_fround(f120 * Math_fround(HEAPF32[i37 >> 2])));
      HEAPF32[i99 >> 2] = Math_fround(f116 + f117);
      HEAPF32[i69 >> 2] = f118;
      HEAPF32[i70 >> 2] = f119;
      HEAPF32[i71 >> 2] = f120;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i99, i60, i96, i61);
      break L39;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i99, i60, i96, i61);
      break L39;
     }
    } while (0);
    f111 = Math_fround((f7 > Math_fround(0.0) & 1) - (f7 < Math_fround(0.0) & 1) | 0);
    f116 = Math_fround((f11 > Math_fround(0.0) & 1) - (f11 < Math_fround(0.0) & 1) | 0);
    f123 = Math_fround((f13 > Math_fround(0.0) & 1) - (f13 < Math_fround(0.0) & 1) | 0);
    f115 = Math_fround((f15 > Math_fround(0.0) & 1) - (f15 < Math_fround(0.0) & 1) | 0);
    f126 = Math_fround(Math_abs(Math_fround(f7)));
    f125 = Math_fround(Math_abs(Math_fround(f11)));
    f124 = Math_fround(Math_abs(Math_fround(f13)));
    f15 = Math_fround(Math_abs(Math_fround(f15)));
    f11 = Math_fround(HEAPF32[i97 >> 2]);
    f110 = Math_fround(f11 - f126);
    f122 = Math_fround(HEAPF32[i63 >> 2]);
    f13 = Math_fround(f122 - f125);
    f114 = Math_fround(HEAPF32[i64 >> 2]);
    f7 = Math_fround(f114 - f124);
    f113 = Math_fround(HEAPF32[i65 >> 2]);
    f117 = Math_fround(f113 - f15);
    f129 = Math_fround(HEAPF32[i103 >> 2]);
    f110 = Math_fround(f110 * f129);
    f128 = Math_fround(HEAPF32[i93 >> 2]);
    f13 = Math_fround(f13 * f128);
    f127 = Math_fround(HEAPF32[i94 >> 2]);
    f7 = Math_fround(f7 * f127);
    f120 = Math_fround(HEAPF32[i95 >> 2]);
    f110 = Math_fround(f126 + f110);
    f13 = Math_fround(f125 + f13);
    f7 = Math_fround(f124 + f7);
    f117 = Math_fround(f15 + Math_fround(f117 * f120));
    f126 = Math_fround(f111 * (f126 > f11 ? f110 : f126));
    f125 = Math_fround(f116 * (f125 > f122 ? f13 : f125));
    f124 = Math_fround(f123 * (f124 > f114 ? f7 : f124));
    f15 = Math_fround(f115 * (f15 > f113 ? f117 : f15));
    f117 = Math_fround((f17 > Math_fround(0.0) & 1) - (f17 < Math_fround(0.0) & 1) | 0);
    f113 = Math_fround((f18 > Math_fround(0.0) & 1) - (f18 < Math_fround(0.0) & 1) | 0);
    f7 = Math_fround((f16 > Math_fround(0.0) & 1) - (f16 < Math_fround(0.0) & 1) | 0);
    f115 = Math_fround((f14 > Math_fround(0.0) & 1) - (f14 < Math_fround(0.0) & 1) | 0);
    f114 = Math_fround(Math_abs(Math_fround(f17)));
    f13 = Math_fround(Math_abs(Math_fround(f18)));
    f123 = Math_fround(Math_abs(Math_fround(f16)));
    f122 = Math_fround(Math_abs(Math_fround(f14)));
    f116 = Math_fround(HEAPF32[i98 >> 2]);
    f14 = Math_fround(f116 - f114);
    f110 = Math_fround(HEAPF32[i66 >> 2]);
    f11 = Math_fround(f110 - f13);
    f111 = Math_fround(HEAPF32[i67 >> 2]);
    f118 = Math_fround(f111 - f123);
    f112 = Math_fround(HEAPF32[i68 >> 2]);
    f14 = Math_fround(f114 + Math_fround(f129 * f14));
    f11 = Math_fround(f13 + Math_fround(f128 * f11));
    f118 = Math_fround(f123 + Math_fround(f127 * f118));
    f121 = Math_fround(f122 + Math_fround(f120 * Math_fround(f112 - f122)));
    f14 = Math_fround(f117 * (f114 > f116 ? f14 : f114));
    f13 = Math_fround(f113 * (f13 > f110 ? f11 : f13));
    f123 = Math_fround(f7 * (f123 > f111 ? f118 : f123));
    f122 = Math_fround(f115 * (f122 > f112 ? f121 : f122));
    f121 = Math_fround((f12 > Math_fround(0.0) & 1) - (f12 < Math_fround(0.0) & 1) | 0);
    f112 = Math_fround((f10 > Math_fround(0.0) & 1) - (f10 < Math_fround(0.0) & 1) | 0);
    f115 = Math_fround((f8 > Math_fround(0.0) & 1) - (f8 < Math_fround(0.0) & 1) | 0);
    f118 = Math_fround((f9 > Math_fround(0.0) & 1) - (f9 < Math_fround(0.0) & 1) | 0);
    f111 = Math_fround(Math_abs(Math_fround(f12)));
    f7 = Math_fround(Math_abs(Math_fround(f10)));
    f10 = Math_fround(Math_abs(Math_fround(f8)));
    f11 = Math_fround(Math_abs(Math_fround(f9)));
    f110 = Math_fround(HEAPF32[i99 >> 2]);
    f8 = Math_fround(f110 - f111);
    f113 = Math_fround(HEAPF32[i69 >> 2]);
    f114 = Math_fround(f113 - f7);
    f116 = Math_fround(HEAPF32[i70 >> 2]);
    f117 = Math_fround(f116 - f10);
    f119 = Math_fround(HEAPF32[i71 >> 2]);
    f8 = Math_fround(f111 + Math_fround(f129 * f8));
    f114 = Math_fround(f7 + Math_fround(f128 * f114));
    f117 = Math_fround(f10 + Math_fround(f127 * f117));
    f120 = Math_fround(f11 + Math_fround(f120 * Math_fround(f119 - f11)));
    f18 = Math_fround(f126 - f19);
    f17 = Math_fround(f125 - f20);
    f16 = Math_fround(f124 - f21);
    f15 = Math_fround(f15 - f22);
    f14 = Math_fround(f14 - f23);
    f13 = Math_fround(f13 - f24);
    f12 = Math_fround(f123 - f25);
    f9 = Math_fround(f122 - f26);
    f8 = Math_fround(Math_fround(f121 * (f111 > f110 ? f8 : f111)) - f27);
    f7 = Math_fround(Math_fround(f112 * (f7 > f113 ? f114 : f7)) - f28);
    f10 = Math_fround(Math_fround(f115 * (f10 > f116 ? f117 : f10)) - f29);
    f11 = Math_fround(Math_fround(f118 * (f11 > f119 ? f120 : f11)) - f30);
    if (i79) {
     f122 = Math_fround(HEAPF32[i101 >> 2]);
     f119 = Math_fround(f18 * f122);
     f120 = Math_fround(f17 * f122);
     f121 = Math_fround(f16 * f122);
     f122 = Math_fround(f15 * f122);
     f126 = Math_fround(HEAPF32[i72 >> 2]);
     f119 = Math_fround(f119 + Math_fround(f14 * f126));
     f120 = Math_fround(f120 + Math_fround(f13 * f126));
     f121 = Math_fround(f121 + Math_fround(f12 * f126));
     f126 = Math_fround(f122 + Math_fround(f9 * f126));
     f122 = Math_fround(HEAPF32[i73 >> 2]);
     f119 = Math_fround(f119 + Math_fround(f8 * f122));
     f120 = Math_fround(f120 + Math_fround(f7 * f122));
     f121 = Math_fround(f121 + Math_fround(f10 * f122));
     f122 = Math_fround(f126 + Math_fround(f11 * f122));
     f126 = Math_fround(HEAPF32[i74 >> 2]);
     f123 = Math_fround(f18 * f126);
     f124 = Math_fround(f17 * f126);
     f125 = Math_fround(f16 * f126);
     f126 = Math_fround(f15 * f126);
     f129 = Math_fround(HEAPF32[i75 >> 2]);
     f123 = Math_fround(f123 + Math_fround(f14 * f129));
     f124 = Math_fround(f124 + Math_fround(f13 * f129));
     f125 = Math_fround(f125 + Math_fround(f12 * f129));
     f129 = Math_fround(f126 + Math_fround(f9 * f129));
     f126 = Math_fround(HEAPF32[i76 >> 2]);
     f123 = Math_fround(f123 + Math_fround(f8 * f126));
     f124 = Math_fround(f124 + Math_fround(f7 * f126));
     f125 = Math_fround(f125 + Math_fround(f10 * f126));
     f126 = Math_fround(f129 + Math_fround(f11 * f126));
     f129 = Math_fround(HEAPF32[i77 >> 2]);
     f127 = Math_fround(f18 * f129);
     f128 = Math_fround(f17 * f129);
     f16 = Math_fround(f16 * f129);
     f129 = Math_fround(f15 * f129);
     f17 = Math_fround(HEAPF32[i78 >> 2]);
     f127 = Math_fround(f127 + Math_fround(f14 * f17));
     f128 = Math_fround(f128 + Math_fround(f13 * f17));
     f16 = Math_fround(f16 + Math_fround(f12 * f17));
     f17 = Math_fround(f129 + Math_fround(f9 * f17));
     f129 = Math_fround(HEAPF32[i31 >> 2]);
     f18 = f119;
     f10 = Math_fround(f16 + Math_fround(f10 * f129));
     f11 = Math_fround(f17 + Math_fround(f11 * f129));
     f17 = f120;
     f16 = f121;
     f15 = f122;
     f14 = f123;
     f13 = f124;
     f12 = f125;
     f9 = f126;
     f8 = Math_fround(f127 + Math_fround(f8 * f129));
     f7 = Math_fround(f128 + Math_fround(f7 * f129));
    }
    i109 = (HEAP32[i91 >> 2] | 0) + (i6 << 2) | 0;
    HEAPF32[i109 >> 2] = f18;
    HEAPF32[i109 + 4 >> 2] = f17;
    HEAPF32[i109 + 8 >> 2] = f16;
    HEAPF32[i109 + 12 >> 2] = f15;
    i109 = (HEAP32[i92 >> 2] | 0) + (i6 << 2) | 0;
    HEAPF32[i109 >> 2] = f14;
    HEAPF32[i109 + 4 >> 2] = f13;
    HEAPF32[i109 + 8 >> 2] = f12;
    HEAPF32[i109 + 12 >> 2] = f9;
    i109 = (HEAP32[i46 >> 2] | 0) + (i6 << 2) | 0;
    HEAPF32[i109 >> 2] = f8;
    HEAPF32[i109 + 4 >> 2] = f7;
    HEAPF32[i109 + 8 >> 2] = f10;
    HEAPF32[i109 + 12 >> 2] = f11;
    i6 = i6 + 4 | 0;
    if (i6 >>> 0 >= i105 >>> 0) break L16;
   }
  } while (0);
 } while (0);
 if (!i104) {
  STACKTOP = i106;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i104);
 STACKTOP = i106;
 return;
}

function __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_(i23, i24, i36, i22, i31, i32, i33, i25) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i36 = i36 | 0;
 i22 = i22 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i25 = i25 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f26 = f0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i34 = 0, i35 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37 + 4 | 0;
 i34 = i37;
 f20 = Math_fround(HEAPF32[i23 >> 2]);
 f21 = Math_fround(HEAPF32[i24 >> 2]);
 f28 = Math_fround(-f21);
 i29 = i31 + 4 | 0;
 i30 = i31 + 8 | 0;
 i4 = 2139095039;
 i5 = 2139095039;
 f1 = Math_fround(-3402823469999999843913219.0e14);
 f2 = Math_fround(-3402823469999999843913219.0e14);
 i7 = 0;
 do {
  i6 = i36 + (i7 << 4) | 0;
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  f12 = Math_fround(HEAPF32[i36 + (i7 << 4) + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i36 + (i7 << 4) + 8 >> 2]);
  f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = f10 < f11 ? f10 : f11;
  f13 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = f13 < f12 ? f13 : f12;
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f1 = f1 > f11 ? f1 : f11;
  f2 = f2 > f12 ? f2 : f12;
  f8 = Math_fround(-f9);
  i3 = i35 + i7 | 0;
  do if (Math_fround(HEAPF32[i25 >> 2]) > f8) {
   HEAP8[i3 >> 0] = 1;
   f17 = Math_fround(-f11);
   f26 = Math_fround(-f12);
   i3 = i34 + i7 | 0;
   if ((f20 >= (f11 > f17 ? f11 : f17) ? !(f21 >= (f12 > f26 ? f12 : f26)) : 1) | !((f9 > f8 ? f9 : f8) <= Math_fround(3402823469999999843913219.0e14))) {
    HEAP8[i3 >> 0] = 0;
    break;
   } else {
    HEAP8[i3 >> 0] = 1;
    i19 = HEAP32[i33 >> 2] | 0;
    HEAPF32[i32 + (i19 * 48 | 0) >> 2] = f11;
    HEAPF32[i32 + (i19 * 48 | 0) + 4 >> 2] = f12;
    HEAP32[i32 + (i19 * 48 | 0) + 8 >> 2] = 0;
    HEAPF32[i32 + (i19 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
    i19 = i32 + ((HEAP32[i33 >> 2] | 0) * 48 | 0) + 16 | 0;
    HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i19 = HEAP32[i33 >> 2] | 0;
    HEAP32[i33 >> 2] = i19 + 1;
    i15 = HEAP32[i29 >> 2] | 0;
    i18 = HEAP32[i30 >> 2] | 0;
    HEAP32[i32 + (i19 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i32 + (i19 * 48 | 0) + 36 >> 2] = i15;
    HEAP32[i32 + (i19 * 48 | 0) + 40 >> 2] = i18;
    HEAPF32[i32 + (i19 * 48 | 0) + 44 >> 2] = f8;
    break;
   }
  } else {
   HEAP8[i3 >> 0] = 0;
   HEAP8[i34 + i7 >> 0] = 0;
  } while (0);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 4);
 f14 = f1;
 f16 = f2;
 f26 = Math_fround(-f20);
 i15 = HEAP32[i33 >> 2] | 0;
 if ((i15 | 0) == 4) {
  STACKTOP = i37;
  return;
 }
 i19 = i22 + 8 | 0;
 f17 = Math_fround(HEAPF32[i19 >> 2]);
 i7 = HEAP32[i23 >> 2] | 0;
 i18 = HEAP32[i24 >> 2] | 0;
 f9 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (!(f10 > f9 | f9 > f14 | (f13 > f11 | f11 > f16))) {
  f8 = Math_fround(HEAPF32[i36 + 52 >> 2]);
  f12 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  i6 = f8 > f11;
  i4 = f12 > f11;
  if (i6 ^ i4) {
   f2 = Math_fround(HEAPF32[i36 + 48 >> 2]);
   f38 = Math_fround(f12 - f8);
   f1 = Math_fround(f9 * f38);
   i5 = f38 > Math_fround(0.0);
   f2 = Math_fround(Math_fround(f38 * Math_fround(f2 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f8) * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f2)));
   if (!((i5 ? f2 : f1) >= (i5 ? f1 : f2))) i3 = 0; else i3 = 1;
  } else i3 = 0;
  f2 = Math_fround(HEAPF32[i36 + 20 >> 2]);
  i5 = f2 > f11;
  if (i4 ^ i5) {
   f38 = Math_fround(HEAPF32[i36 >> 2]);
   f39 = Math_fround(f2 - f12);
   f1 = Math_fround(f9 * f39);
   i4 = f39 > Math_fround(0.0);
   f38 = Math_fround(Math_fround(f39 * Math_fround(f38 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f12) * Math_fround(Math_fround(HEAPF32[i36 + 16 >> 2]) - f38)));
   if ((i4 ? f38 : f1) >= (i4 ? f1 : f38)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  f1 = Math_fround(HEAPF32[i36 + 36 >> 2]);
  i4 = f1 > f11;
  if (i5 ^ i4) {
   f39 = Math_fround(HEAPF32[i36 + 16 >> 2]);
   f40 = Math_fround(f1 - f2);
   f38 = Math_fround(f9 * f40);
   i5 = f40 > Math_fround(0.0);
   f39 = Math_fround(Math_fround(f40 * Math_fround(f39 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f2) * Math_fround(Math_fround(HEAPF32[i36 + 32 >> 2]) - f39)));
   if ((i5 ? f39 : f38) >= (i5 ? f38 : f39)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  if (i4 ^ i6) {
   f40 = Math_fround(HEAPF32[i36 + 32 >> 2]);
   f38 = Math_fround(f8 - f1);
   f39 = Math_fround(f9 * f38);
   i6 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f1) * Math_fround(Math_fround(HEAPF32[i36 + 48 >> 2]) - f40)));
   if (!((i6 ? f40 : f39) >= (i6 ? f39 : f40))) i27 = 88; else if ((i3 | 0) == 1) break;
  } else i27 = 88;
  if ((i27 | 0) == 88) if (!i3) break;
  f40 = Math_fround(HEAPF32[i22 >> 2]);
  f1 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i36 >> 2]);
  f1 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(HEAPF32[i36 + 8 >> 2])) + Math_fround(Math_fround(f40 * Math_fround(f2 - f9)) + Math_fround(f1 * Math_fround(f12 - f11)))) / f17);
  f2 = Math_fround(-f1);
  if (Math_fround(HEAPF32[i25 >> 2]) > f2) {
   HEAP32[i32 + (i15 * 48 | 0) >> 2] = i7;
   HEAP32[i32 + (i15 * 48 | 0) + 4 >> 2] = i18;
   HEAP32[i32 + (i15 * 48 | 0) + 8 >> 2] = 0;
   HEAPF32[i32 + (i15 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
   i15 = HEAP32[i33 >> 2] | 0;
   HEAP32[i32 + (i15 * 48 | 0) + 16 >> 2] = i7;
   HEAP32[i32 + (i15 * 48 | 0) + 20 >> 2] = i18;
   HEAPF32[i32 + (i15 * 48 | 0) + 24 >> 2] = f1;
   HEAPF32[i32 + (i15 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
   i7 = HEAP32[i33 >> 2] | 0;
   HEAP32[i33 >> 2] = i7 + 1;
   i15 = HEAP32[i29 >> 2] | 0;
   i18 = HEAP32[i30 >> 2] | 0;
   HEAP32[i32 + (i7 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i7 * 48 | 0) + 36 >> 2] = i15;
   HEAP32[i32 + (i7 * 48 | 0) + 40 >> 2] = i18;
   HEAPF32[i32 + (i7 * 48 | 0) + 44 >> 2] = f2;
   i7 = HEAP32[i23 >> 2] | 0;
  }
 } while (0);
 f9 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = f13 > f28 | f16 < f28;
 do if (!(i18 | (f10 > f9 | f9 > f14))) {
  f8 = Math_fround(HEAPF32[i36 + 52 >> 2]);
  f11 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  i6 = f8 > f28;
  i4 = f11 > f28;
  if (i6 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 48 >> 2]);
   f38 = Math_fround(f11 - f8);
   f39 = Math_fround(f9 * f38);
   i15 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f8) * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f40)));
   if (!((i15 ? f40 : f39) >= (i15 ? f39 : f40))) i3 = 0; else i3 = 1;
  } else i3 = 0;
  f2 = Math_fround(HEAPF32[i36 + 20 >> 2]);
  i5 = f2 > f28;
  if (i4 ^ i5) {
   f40 = Math_fround(HEAPF32[i36 >> 2]);
   f38 = Math_fround(f2 - f11);
   f39 = Math_fround(f9 * f38);
   i15 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f11) * Math_fround(Math_fround(HEAPF32[i36 + 16 >> 2]) - f40)));
   if ((i15 ? f40 : f39) >= (i15 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  f1 = Math_fround(HEAPF32[i36 + 36 >> 2]);
  i4 = f1 > f28;
  if (i5 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 16 >> 2]);
   f38 = Math_fround(f1 - f2);
   f39 = Math_fround(f9 * f38);
   i15 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f2) * Math_fround(Math_fround(HEAPF32[i36 + 32 >> 2]) - f40)));
   if ((i15 ? f40 : f39) >= (i15 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  if (i4 ^ i6) {
   f40 = Math_fround(HEAPF32[i36 + 32 >> 2]);
   f38 = Math_fround(f8 - f1);
   f39 = Math_fround(f9 * f38);
   i15 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f1) * Math_fround(Math_fround(HEAPF32[i36 + 48 >> 2]) - f40)));
   if (!((i15 ? f40 : f39) >= (i15 ? f39 : f40))) i27 = 79; else if ((i3 | 0) == 1) break;
  } else i27 = 79;
  if ((i27 | 0) == 79) if (!i3) break;
  f40 = Math_fround(HEAPF32[i22 >> 2]);
  f1 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i19 >> 2]);
  f2 = Math_fround(HEAPF32[i36 >> 2]);
  f1 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(HEAPF32[i36 + 8 >> 2])) + Math_fround(Math_fround(f40 * Math_fround(f2 - f9)) + Math_fround(f1 * Math_fround(f21 + f11)))) / f17);
  f2 = Math_fround(-f1);
  if (Math_fround(HEAPF32[i25 >> 2]) > f2) {
   i15 = HEAP32[i33 >> 2] | 0;
   HEAP32[i32 + (i15 * 48 | 0) >> 2] = i7;
   HEAPF32[i32 + (i15 * 48 | 0) + 4 >> 2] = f28;
   HEAP32[i32 + (i15 * 48 | 0) + 8 >> 2] = 0;
   HEAPF32[i32 + (i15 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
   i15 = HEAP32[i33 >> 2] | 0;
   HEAP32[i32 + (i15 * 48 | 0) + 16 >> 2] = i7;
   HEAPF32[i32 + (i15 * 48 | 0) + 20 >> 2] = f28;
   HEAPF32[i32 + (i15 * 48 | 0) + 24 >> 2] = f1;
   HEAPF32[i32 + (i15 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
   i15 = HEAP32[i33 >> 2] | 0;
   HEAP32[i33 >> 2] = i15 + 1;
   i6 = HEAP32[i29 >> 2] | 0;
   i7 = HEAP32[i30 >> 2] | 0;
   HEAP32[i32 + (i15 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i15 * 48 | 0) + 36 >> 2] = i6;
   HEAP32[i32 + (i15 * 48 | 0) + 40 >> 2] = i7;
   HEAPF32[i32 + (i15 * 48 | 0) + 44 >> 2] = f2;
  }
 } while (0);
 i15 = HEAP32[i24 >> 2] | 0;
 f11 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = f10 > f26 | f14 < f26;
 do if (!(i7 | (f13 > f11 | f11 > f16))) {
  f8 = Math_fround(HEAPF32[i36 + 52 >> 2]);
  f9 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  i6 = f8 > f11;
  i4 = f9 > f11;
  if (i6 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 48 >> 2]);
   f38 = Math_fround(f9 - f8);
   f39 = Math_fround(f38 * f26);
   i5 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f8) * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f40)));
   if (!((i5 ? f40 : f39) >= (i5 ? f39 : f40))) i3 = 0; else i3 = 1;
  } else i3 = 0;
  f2 = Math_fround(HEAPF32[i36 + 20 >> 2]);
  i5 = f2 > f11;
  if (i4 ^ i5) {
   f40 = Math_fround(HEAPF32[i36 >> 2]);
   f38 = Math_fround(f2 - f9);
   f39 = Math_fround(f38 * f26);
   i4 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f9) * Math_fround(Math_fround(HEAPF32[i36 + 16 >> 2]) - f40)));
   if ((i4 ? f40 : f39) >= (i4 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  f1 = Math_fround(HEAPF32[i36 + 36 >> 2]);
  i4 = f1 > f11;
  if (i5 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 16 >> 2]);
   f38 = Math_fround(f1 - f2);
   f39 = Math_fround(f38 * f26);
   i5 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f2) * Math_fround(Math_fround(HEAPF32[i36 + 32 >> 2]) - f40)));
   if ((i5 ? f40 : f39) >= (i5 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  if (i4 ^ i6) {
   f40 = Math_fround(HEAPF32[i36 + 32 >> 2]);
   f38 = Math_fround(f8 - f1);
   f39 = Math_fround(f38 * f26);
   i6 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f11 - f1) * Math_fround(Math_fround(HEAPF32[i36 + 48 >> 2]) - f40)));
   if (!((i6 ? f40 : f39) >= (i6 ? f39 : f40))) i27 = 70; else if ((i3 | 0) == 1) break;
  } else i27 = 70;
  if ((i27 | 0) == 70) if (!i3) break;
  f40 = Math_fround(HEAPF32[i22 >> 2]);
  f1 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i19 >> 2]);
  f2 = Math_fround(HEAPF32[i36 >> 2]);
  f1 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(HEAPF32[i36 + 8 >> 2])) + Math_fround(Math_fround(f40 * Math_fround(f20 + f2)) + Math_fround(f1 * Math_fround(f9 - f11)))) / f17);
  f2 = Math_fround(-f1);
  if (Math_fround(HEAPF32[i25 >> 2]) > f2) {
   i5 = HEAP32[i33 >> 2] | 0;
   HEAPF32[i32 + (i5 * 48 | 0) >> 2] = f26;
   HEAP32[i32 + (i5 * 48 | 0) + 4 >> 2] = i15;
   HEAP32[i32 + (i5 * 48 | 0) + 8 >> 2] = 0;
   HEAPF32[i32 + (i5 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
   i5 = HEAP32[i33 >> 2] | 0;
   HEAPF32[i32 + (i5 * 48 | 0) + 16 >> 2] = f26;
   HEAP32[i32 + (i5 * 48 | 0) + 20 >> 2] = i15;
   HEAPF32[i32 + (i5 * 48 | 0) + 24 >> 2] = f1;
   HEAPF32[i32 + (i5 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
   i15 = HEAP32[i33 >> 2] | 0;
   HEAP32[i33 >> 2] = i15 + 1;
   i5 = HEAP32[i29 >> 2] | 0;
   i6 = HEAP32[i30 >> 2] | 0;
   HEAP32[i32 + (i15 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i15 * 48 | 0) + 36 >> 2] = i5;
   HEAP32[i32 + (i15 * 48 | 0) + 40 >> 2] = i6;
   HEAPF32[i32 + (i15 * 48 | 0) + 44 >> 2] = f2;
  }
 } while (0);
 do if (!(i18 | i7)) {
  f8 = Math_fround(HEAPF32[i36 + 52 >> 2]);
  f9 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  i6 = f8 > f28;
  i4 = f9 > f28;
  if (i6 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 48 >> 2]);
   f38 = Math_fround(f9 - f8);
   f39 = Math_fround(f38 * f26);
   i18 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f8) * Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f40)));
   if (!((i18 ? f40 : f39) >= (i18 ? f39 : f40))) i3 = 0; else i3 = 1;
  } else i3 = 0;
  f2 = Math_fround(HEAPF32[i36 + 20 >> 2]);
  i5 = f2 > f28;
  if (i4 ^ i5) {
   f40 = Math_fround(HEAPF32[i36 >> 2]);
   f38 = Math_fround(f2 - f9);
   f39 = Math_fround(f38 * f26);
   i18 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f9) * Math_fround(Math_fround(HEAPF32[i36 + 16 >> 2]) - f40)));
   if ((i18 ? f40 : f39) >= (i18 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  f1 = Math_fround(HEAPF32[i36 + 36 >> 2]);
  i4 = f1 > f28;
  if (i5 ^ i4) {
   f40 = Math_fround(HEAPF32[i36 + 16 >> 2]);
   f38 = Math_fround(f1 - f2);
   f39 = Math_fround(f38 * f26);
   i18 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f2) * Math_fround(Math_fround(HEAPF32[i36 + 32 >> 2]) - f40)));
   if ((i18 ? f40 : f39) >= (i18 ? f39 : f40)) if ((i3 | 0) == 1) break; else i3 = 1;
  }
  if (i4 ^ i6) {
   f40 = Math_fround(HEAPF32[i36 + 32 >> 2]);
   f38 = Math_fround(f8 - f1);
   f39 = Math_fround(f38 * f26);
   i18 = f38 > Math_fround(0.0);
   f40 = Math_fround(Math_fround(f38 * Math_fround(f40 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f28 - f1) * Math_fround(Math_fround(HEAPF32[i36 + 48 >> 2]) - f40)));
   if (!((i18 ? f40 : f39) >= (i18 ? f39 : f40))) i27 = 61; else if ((i3 | 0) == 1) break;
  } else i27 = 61;
  if ((i27 | 0) == 61) if (!i3) break;
  f40 = Math_fround(HEAPF32[i22 >> 2]);
  f1 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i19 >> 2]);
  f2 = Math_fround(HEAPF32[i36 >> 2]);
  f1 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(HEAPF32[i36 + 8 >> 2])) + Math_fround(Math_fround(f40 * Math_fround(f20 + f2)) + Math_fround(f1 * Math_fround(f21 + f9)))) / f17);
  f2 = Math_fround(-f1);
  if (Math_fround(HEAPF32[i25 >> 2]) > f2) {
   i22 = HEAP32[i33 >> 2] | 0;
   HEAPF32[i32 + (i22 * 48 | 0) >> 2] = f26;
   HEAPF32[i32 + (i22 * 48 | 0) + 4 >> 2] = f28;
   HEAP32[i32 + (i22 * 48 | 0) + 8 >> 2] = 0;
   HEAPF32[i32 + (i22 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
   i22 = HEAP32[i33 >> 2] | 0;
   HEAPF32[i32 + (i22 * 48 | 0) + 16 >> 2] = f26;
   HEAPF32[i32 + (i22 * 48 | 0) + 20 >> 2] = f28;
   HEAPF32[i32 + (i22 * 48 | 0) + 24 >> 2] = f1;
   HEAPF32[i32 + (i22 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
   i22 = HEAP32[i33 >> 2] | 0;
   HEAP32[i33 >> 2] = i22 + 1;
   i18 = HEAP32[i29 >> 2] | 0;
   i19 = HEAP32[i30 >> 2] | 0;
   HEAP32[i32 + (i22 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i22 * 48 | 0) + 36 >> 2] = i18;
   HEAP32[i32 + (i22 * 48 | 0) + 40 >> 2] = i19;
   HEAPF32[i32 + (i22 * 48 | 0) + 44 >> 2] = f2;
  }
 } while (0);
 f17 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(HEAPF32[i24 >> 2]);
 f14 = Math_fround(-Math_fround(Math_fround(HEAPF32[i25 >> 2]) + Math_fround(1.1920929e-07)));
 i5 = 3;
 i15 = 0;
 while (1) {
  f11 = Math_fround(HEAPF32[i36 + (i15 << 4) >> 2]);
  f12 = Math_fround(HEAPF32[i36 + (i15 << 4) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i36 + (i15 << 4) + 8 >> 2]);
  f1 = Math_fround(HEAPF32[i36 + (i5 << 4) >> 2]);
  f2 = Math_fround(HEAPF32[i36 + (i5 << 4) + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i36 + (i5 << 4) + 8 >> 2]);
  i3 = i35 + i15 | 0;
  i4 = HEAP8[i35 + i5 >> 0] | 0;
  do if (!(HEAP8[i3 >> 0] | 0)) {
   if (i4 << 24 >> 24) if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = 0;
    i4 = (HEAP8[i34 + i5 >> 0] | 0) != 0;
    i27 = 45;
    break;
   } else {
    i3 = (HEAP8[i34 + i15 >> 0] | 0) != 0;
    i27 = 44;
    break;
   }
  } else {
   i3 = (HEAP8[i34 + i15 >> 0] | 0) != 0;
   if (!(i4 << 24 >> 24)) {
    i4 = 0;
    i27 = 45;
   } else i27 = 44;
  } while (0);
  if ((i27 | 0) == 44) {
   i27 = 0;
   i4 = (HEAP8[i34 + i5 >> 0] | 0) != 0;
   if (!(i3 & i4)) i27 = 45;
  }
  if ((i27 | 0) == 45) {
   i27 = 0;
   f10 = Math_fround(f1 - f11);
   f9 = Math_fround(f2 - f12);
   f8 = Math_fround(f8 - f13);
   f38 = Math_fround(-f10);
   f39 = Math_fround(-f9);
   f40 = Math_fround(-f8);
   i5 = (f10 > f38 ? f10 : f38) < Math_fround(9.99999997e-07);
   i6 = (f9 > f39 ? f9 : f39) < Math_fround(9.99999997e-07);
   i7 = (f8 > f40 ? f8 : f40) < Math_fround(9.99999997e-07);
   if (!((f11 > f17 | f11 < f26) & i5 | (f12 > f16 | f12 < f28) & i6 | (f13 > Math_fround(3402823469999999843913219.0e14) | f13 < f14) & i7)) {
    f39 = Math_fround(Math_fround(1.0) / f10);
    f40 = Math_fround(Math_fround(1.0) / f9);
    f1 = Math_fround(Math_fround(1.0) / f8);
    f42 = Math_fround(Math_fround(f26 - f11) * f39);
    f41 = Math_fround(Math_fround(f28 - f12) * f40);
    f20 = Math_fround(Math_fround(f14 - f13) * f1);
    f42 = i5 ? Math_fround(0.0) : f42;
    f41 = i6 ? Math_fround(0.0) : f41;
    f20 = i7 ? Math_fround(0.0) : f20;
    f39 = Math_fround(Math_fround(f17 - f11) * f39);
    f40 = Math_fround(Math_fround(f16 - f12) * f40);
    f1 = Math_fround(Math_fround(Math_fround(3402823469999999843913219.0e14) - f13) * f1);
    f39 = i5 ? Math_fround(3402823469999999843913219.0e14) : f39;
    f40 = i6 ? Math_fround(3402823469999999843913219.0e14) : f40;
    f1 = i7 ? Math_fround(3402823469999999843913219.0e14) : f1;
    f21 = f42 < f39 ? f42 : f39;
    f38 = f41 < f40 ? f41 : f40;
    f2 = f20 < f1 ? f20 : f1;
    f39 = f42 > f39 ? f42 : f39;
    f40 = f41 > f40 ? f41 : f40;
    f1 = f20 > f1 ? f20 : f1;
    f38 = f21 >= f38 ? f21 : f38;
    f2 = f38 >= f2 ? f38 : f2;
    f40 = f39 <= f40 ? f39 : f40;
    f1 = f40 <= f1 ? f40 : f1;
    i25 = f2 > Math_fround(0.0);
    f2 = i25 ? f2 : Math_fround(0.0);
    i25 = f1 < Math_fround(1.0);
    f1 = i25 ? f1 : Math_fround(1.0);
    if (!(f2 > f1) & !(f2 > Math_fround(1.0))) {
     if (!i3) {
      f40 = Math_fround(f11 + Math_fround(f10 * f2));
      f41 = Math_fround(f12 + Math_fround(f9 * f2));
      f42 = Math_fround(f13 + Math_fround(f8 * f2));
      i25 = HEAP32[i33 >> 2] | 0;
      HEAPF32[i32 + (i25 * 48 | 0) >> 2] = f40;
      HEAPF32[i32 + (i25 * 48 | 0) + 4 >> 2] = f41;
      HEAP32[i32 + (i25 * 48 | 0) + 8 >> 2] = 0;
      HEAPF32[i32 + (i25 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
      i25 = HEAP32[i33 >> 2] | 0;
      HEAPF32[i32 + (i25 * 48 | 0) + 16 >> 2] = f40;
      HEAPF32[i32 + (i25 * 48 | 0) + 20 >> 2] = f41;
      HEAPF32[i32 + (i25 * 48 | 0) + 24 >> 2] = f42;
      HEAPF32[i32 + (i25 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
      i25 = HEAP32[i33 >> 2] | 0;
      HEAP32[i33 >> 2] = i25 + 1;
      i23 = HEAP32[i29 >> 2] | 0;
      i24 = HEAP32[i30 >> 2] | 0;
      f42 = Math_fround(-f42);
      HEAP32[i32 + (i25 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i32 + (i25 * 48 | 0) + 36 >> 2] = i23;
      HEAP32[i32 + (i25 * 48 | 0) + 40 >> 2] = i24;
      HEAPF32[i32 + (i25 * 48 | 0) + 44 >> 2] = f42;
     }
     if (!i4) {
      f40 = Math_fround(f11 + Math_fround(f10 * f1));
      f41 = Math_fround(f12 + Math_fround(f9 * f1));
      f42 = Math_fround(f13 + Math_fround(f8 * f1));
      i25 = HEAP32[i33 >> 2] | 0;
      HEAPF32[i32 + (i25 * 48 | 0) >> 2] = f40;
      HEAPF32[i32 + (i25 * 48 | 0) + 4 >> 2] = f41;
      HEAP32[i32 + (i25 * 48 | 0) + 8 >> 2] = 0;
      HEAPF32[i32 + (i25 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
      i25 = HEAP32[i33 >> 2] | 0;
      HEAPF32[i32 + (i25 * 48 | 0) + 16 >> 2] = f40;
      HEAPF32[i32 + (i25 * 48 | 0) + 20 >> 2] = f41;
      HEAPF32[i32 + (i25 * 48 | 0) + 24 >> 2] = f42;
      HEAPF32[i32 + (i25 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
      i25 = HEAP32[i33 >> 2] | 0;
      HEAP32[i33 >> 2] = i25 + 1;
      i23 = HEAP32[i29 >> 2] | 0;
      i24 = HEAP32[i30 >> 2] | 0;
      f42 = Math_fround(-f42);
      HEAP32[i32 + (i25 * 48 | 0) + 32 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i32 + (i25 * 48 | 0) + 36 >> 2] = i23;
      HEAP32[i32 + (i25 * 48 | 0) + 40 >> 2] = i24;
      HEAPF32[i32 + (i25 * 48 | 0) + 44 >> 2] = f42;
     }
    }
   }
  }
  i3 = i15 + 1 | 0;
  if ((i3 | 0) == 4) break; else {
   i5 = i15;
   i15 = i3;
  }
 }
 STACKTOP = i37;
 return;
}

function __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i51, i52, i2, i53, i50, i1, i56, i55) {
 i51 = i51 | 0;
 i52 = i52 | 0;
 i2 = i2 | 0;
 i53 = i53 | 0;
 i50 = i50 | 0;
 i1 = i1 | 0;
 i56 = i56 | 0;
 i55 = i55 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i54 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i54 + 32 | 0;
 i49 = i54;
 i27 = i54 + 60 | 0;
 i47 = i54 + 64 | 0;
 if (i2 >>> 0 >= i53 >>> 0) {
  i53 = 0;
  i52 = 0;
  i51 = HEAP32[i56 >> 2] | 0;
  i52 = i51 + i52 | 0;
  HEAP32[i56 >> 2] = i52;
  i56 = HEAP32[i55 >> 2] | 0;
  i56 = i56 + i53 | 0;
  HEAP32[i55 >> 2] = i56;
  STACKTOP = i54;
  return;
 }
 i38 = i51 + 4496 | 0;
 i40 = i48 + 4 | 0;
 i41 = i48 + 8 | 0;
 i42 = i48 + 12 | 0;
 i43 = i48 + 16 | 0;
 i44 = i48 + 20 | 0;
 i45 = i48 + 24 | 0;
 i46 = i49 + 4 | 0;
 i28 = i49 + 8 | 0;
 i29 = i49 + 12 | 0;
 i30 = i49 + 16 | 0;
 i31 = i49 + 20 | 0;
 i32 = i49 + 24 | 0;
 i33 = i51 + 4480 | 0;
 i34 = i51 + 384 | 0;
 i35 = i51 + 4548 | 0;
 i36 = i38 + 53 | 0;
 i37 = i51 + 356 | 0;
 i39 = i38 | 1;
 i26 = i2;
 i2 = 0;
 i1 = 0;
 do {
  i24 = HEAP32[i52 + (i26 * 12 | 0) >> 2] | 0;
  i15 = HEAP32[i24 + 72 >> 2] | 0;
  i16 = HEAP32[i24 + 76 >> 2] | 0;
  i7 = HEAP32[i15 + 36 >> 2] | 0;
  i8 = HEAP32[i16 + 36 >> 2] | 0;
  i17 = HEAP32[i24 + 64 >> 2] | 0;
  i18 = HEAP32[i24 + 68 >> 2] | 0;
  i20 = HEAPU16[i24 + 22 >> 1] | 0;
  i19 = i20 & 32;
  i20 = i20 & 64;
  i25 = i24 + 44 | 0;
  i3 = HEAP32[i25 >> 2] | 0;
  if (!(i3 & 1)) {
   i6 = HEAP32[i25 >> 2] | 0;
   i22 = _bitshift64Lshr(i6 | 0, 0, 6) | 0;
   i23 = getTempRet0() | 0;
   i4 = _i64Add(i6 | 0, 0, 127, 0) | 0;
   i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
   i3 = getTempRet0() | 0;
   i23 = _i64Subtract(1, 0, i22 | 0, i23 | 0) | 0;
   i3 = _i64Add(i23 | 0, getTempRet0() | 0, i4 | 0, i3 | 0) | 0;
   i4 = getTempRet0() | 0;
   while (1) {
    i3 = _i64Add(i3 | 0, i4 | 0, -1, -1) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) break; else i6 = i6 + 64 | 0;
   }
   i6 = HEAP32[i25 >> 2] | 0;
   i22 = _bitshift64Lshr(i6 | 0, 0, 6) | 0;
   i23 = getTempRet0() | 0;
   i4 = _i64Add(i6 | 0, 0, 255, 0) | 0;
   i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
   i3 = getTempRet0() | 0;
   i23 = _i64Subtract(1, 0, i22 | 0, i23 | 0) | 0;
   i3 = _i64Add(i23 | 0, getTempRet0() | 0, i4 | 0, i3 | 0) | 0;
   i4 = getTempRet0() | 0;
   while (1) {
    i3 = _i64Add(i3 | 0, i4 | 0, -1, -1) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i23 = 0;
     break;
    } else i6 = i6 + 64 | 0;
   }
  } else {
   __ZN5physx2Gu33MultiplePersistentContactManifold10fromBufferEPh(i38, i3 & -2);
   HEAP32[i25 >> 2] = i39;
   i23 = 1;
  }
  i22 = (i8 | 0) < (i7 | 0);
  i21 = i22 ? i8 : i7;
  i6 = i22 ? i7 : i8;
  i7 = i51 + 104 + (i21 * 28 | 0) + (i6 << 2) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  i7 = i22 ? i16 : i15;
  i3 = i22 ? i18 : i17;
  f5 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  if (!((i22 ? i20 : i19) | 0)) {
   f63 = Math_fround(f5 * Math_fround(2.0));
   f58 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
   f13 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
   f60 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f61 = Math_fround(Math_fround(f60 * f60) + Math_fround(-.5));
   f59 = Math_fround(HEAPF32[i3 >> 2]);
   f5 = Math_fround(f63 * f59);
   f62 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f58 * f62));
   f57 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f13 * f57));
   f10 = Math_fround(Math_fround(f59 * f5) + Math_fround(Math_fround(f63 * f61) + Math_fround(f60 * Math_fround(Math_fround(f13 * f62) - Math_fround(f58 * f57)))));
   f9 = Math_fround(Math_fround(f62 * f5) + Math_fround(Math_fround(f58 * f61) + Math_fround(f60 * Math_fround(Math_fround(f63 * f57) - Math_fround(f13 * f59)))));
   f5 = Math_fround(Math_fround(Math_fround(f13 * f61) + Math_fround(f60 * Math_fround(Math_fround(f58 * f59) - Math_fround(f63 * f62)))) + Math_fround(f57 * f5));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
   f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
   f5 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f5);
   f63 = Math_fround(HEAPF32[i7 >> 2]);
   f58 = Math_fround(f60 * f63);
   f61 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f59 * f61));
   f13 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f62 * f13));
   f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f61) - Math_fround(f59 * f63)) - Math_fround(f62 * f14)) - Math_fround(f57 * f13));
   f12 = Math_fround(Math_fround(Math_fround(f59 * f14) + Math_fround(Math_fround(f57 * f61) + Math_fround(f60 * f13))) - Math_fround(f62 * f63));
   f13 = Math_fround(Math_fround(Math_fround(f57 * f63) + Math_fround(Math_fround(f62 * f61) + Math_fround(f60 * f14))) - Math_fround(f59 * f13));
   f14 = Math_fround(f58 - Math_fround(f57 * f14));
  } else {
   f11 = Math_fround(HEAPF32[i3 + 48 >> 2]);
   f59 = Math_fround(HEAPF32[i3 + 52 >> 2]);
   f11 = Math_fround(f11 * Math_fround(-2.0));
   f59 = Math_fround(f59 * Math_fround(-2.0));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) * Math_fround(-2.0));
   f64 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f57 = Math_fround(Math_fround(f64 * f64) + Math_fround(-.5));
   f14 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f63 = Math_fround(f11 * f14);
   f65 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f63 = Math_fround(f63 + Math_fround(f59 * f65));
   f12 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f63 = Math_fround(f63 + Math_fround(f10 * f12));
   f13 = Math_fround(-f14);
   f62 = Math_fround(-f65);
   f60 = Math_fround(-f12);
   f61 = Math_fround(Math_fround(Math_fround(f14 * f63) + Math_fround(Math_fround(f11 * f57) - Math_fround(f64 * Math_fround(Math_fround(f10 * f65) - Math_fround(f59 * f12))))) * Math_fround(2.0));
   f58 = Math_fround(Math_fround(Math_fround(f65 * f63) + Math_fround(Math_fround(f59 * f57) - Math_fround(f64 * Math_fround(Math_fround(f11 * f12) - Math_fround(f10 * f14))))) * Math_fround(2.0));
   f63 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f57) - Math_fround(f64 * Math_fround(Math_fround(f59 * f14) - Math_fround(f11 * f65)))) + Math_fround(f12 * f63)) * Math_fround(2.0));
   f12 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f65 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
   f11 = Math_fround(HEAPF32[i3 >> 2]);
   f14 = Math_fround(f11 * f61);
   f59 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f14 = Math_fround(f14 + Math_fround(f59 * f58));
   f57 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f14 = Math_fround(Math_fround(f57 * f63) + f14);
   f10 = Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f65 * f61) + Math_fround(f12 * Math_fround(Math_fround(f59 * f63) - Math_fround(f57 * f58)))));
   f9 = Math_fround(Math_fround(f59 * f14) + Math_fround(Math_fround(f65 * f58) + Math_fround(f12 * Math_fround(Math_fround(f57 * f61) - Math_fround(f11 * f63)))));
   f14 = Math_fround(Math_fround(Math_fround(f65 * f63) + Math_fround(f12 * Math_fround(Math_fround(f11 * f58) - Math_fround(f59 * f61)))) + Math_fround(f57 * f14));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
   f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
   f14 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f14);
   f61 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f64 * f11)) + Math_fround(f59 * f60)) - Math_fround(f57 * f62));
   f58 = Math_fround(Math_fround(Math_fround(f57 * f13) + Math_fround(Math_fround(f12 * f62) + Math_fround(f64 * f59))) - Math_fround(f11 * f60));
   f63 = Math_fround(Math_fround(Math_fround(f11 * f62) + Math_fround(Math_fround(f12 * f60) + Math_fround(f64 * f57))) - Math_fround(f59 * f13));
   f60 = Math_fround(Math_fround(Math_fround(Math_fround(f64 * f12) - Math_fround(f11 * f13)) - Math_fround(f59 * f62)) - Math_fround(f57 * f60));
   f57 = Math_fround(f5 * Math_fround(2.0));
   f62 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
   f59 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
   f13 = Math_fround(Math_fround(f60 * f60) + Math_fround(-.5));
   f5 = Math_fround(Math_fround(Math_fround(f61 * f57) + Math_fround(f58 * f62)) + Math_fround(f63 * f59));
   f10 = Math_fround(f10 + Math_fround(Math_fround(f61 * f5) + Math_fround(Math_fround(f13 * f57) + Math_fround(f60 * Math_fround(Math_fround(f58 * f59) - Math_fround(f63 * f62))))));
   f9 = Math_fround(f9 + Math_fround(Math_fround(f58 * f5) + Math_fround(Math_fround(f13 * f62) + Math_fround(f60 * Math_fround(Math_fround(f63 * f57) - Math_fround(f61 * f59))))));
   f5 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f13 * f59) + Math_fround(f60 * Math_fround(Math_fround(f61 * f62) - Math_fround(f58 * f57)))) + Math_fround(f63 * f5)));
   f57 = Math_fround(HEAPF32[i7 >> 2]);
   f62 = Math_fround(f60 * f57);
   f59 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f61 * f59));
   f13 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f62 = Math_fround(f62 + Math_fround(f58 * f13));
   f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(Math_fround(f60 * f59) - Math_fround(f61 * f57)) - Math_fround(f58 * f14)) - Math_fround(f63 * f13));
   f12 = Math_fround(Math_fround(Math_fround(f61 * f14) + Math_fround(Math_fround(f63 * f59) + Math_fround(f60 * f13))) - Math_fround(f58 * f57));
   f13 = Math_fround(Math_fround(Math_fround(f63 * f57) + Math_fround(Math_fround(f58 * f59) + Math_fround(f60 * f14))) - Math_fround(f61 * f13));
   f14 = Math_fround(f62 - Math_fround(f63 * f14));
  }
  HEAPF32[i48 >> 2] = f14;
  HEAPF32[i40 >> 2] = f13;
  HEAPF32[i41 >> 2] = f12;
  HEAPF32[i42 >> 2] = f11;
  HEAPF32[i43 >> 2] = f10;
  HEAPF32[i44 >> 2] = f9;
  HEAPF32[i45 >> 2] = f5;
  i4 = i22 ? i15 : i16;
  i3 = i22 ? i17 : i18;
  f5 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  if (!((i22 ? i19 : i20) | 0)) {
   f59 = Math_fround(f5 * Math_fround(2.0));
   f64 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
   f13 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
   f62 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f61 = Math_fround(Math_fround(f62 * f62) + Math_fround(-.5));
   f63 = Math_fround(HEAPF32[i3 >> 2]);
   f5 = Math_fround(f59 * f63);
   f60 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f64 * f60));
   f65 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f13 * f65));
   f10 = Math_fround(Math_fround(f63 * f5) + Math_fround(Math_fround(f59 * f61) + Math_fround(f62 * Math_fround(Math_fround(f13 * f60) - Math_fround(f64 * f65)))));
   f9 = Math_fround(Math_fround(f60 * f5) + Math_fround(Math_fround(f64 * f61) + Math_fround(f62 * Math_fround(Math_fround(f59 * f65) - Math_fround(f13 * f63)))));
   f5 = Math_fround(Math_fround(Math_fround(f13 * f61) + Math_fround(f62 * Math_fround(Math_fround(f64 * f63) - Math_fround(f59 * f60)))) + Math_fround(f65 * f5));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
   f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
   f5 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f5);
   f59 = Math_fround(HEAPF32[i4 >> 2]);
   f64 = Math_fround(f62 * f59);
   f61 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f64 = Math_fround(f64 + Math_fround(f63 * f61));
   f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f64 = Math_fround(f64 + Math_fround(f60 * f13));
   f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(Math_fround(f62 * f61) - Math_fround(f63 * f59)) - Math_fround(f60 * f14)) - Math_fround(f65 * f13));
   f12 = Math_fround(Math_fround(Math_fround(f63 * f14) + Math_fround(Math_fround(f65 * f61) + Math_fround(f62 * f13))) - Math_fround(f60 * f59));
   f13 = Math_fround(Math_fround(Math_fround(f65 * f59) + Math_fround(Math_fround(f60 * f61) + Math_fround(f62 * f14))) - Math_fround(f63 * f13));
   f14 = Math_fround(f64 - Math_fround(f65 * f14));
  } else {
   f11 = Math_fround(HEAPF32[i3 + 48 >> 2]);
   f61 = Math_fround(HEAPF32[i3 + 52 >> 2]);
   f11 = Math_fround(f11 * Math_fround(-2.0));
   f61 = Math_fround(f61 * Math_fround(-2.0));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) * Math_fround(-2.0));
   f58 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f59 = Math_fround(Math_fround(f58 * f58) + Math_fround(-.5));
   f14 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f65 = Math_fround(f11 * f14);
   f57 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f65 = Math_fround(f65 + Math_fround(f61 * f57));
   f12 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f65 = Math_fround(f65 + Math_fround(f10 * f12));
   f13 = Math_fround(-f14);
   f64 = Math_fround(-f57);
   f62 = Math_fround(-f12);
   f63 = Math_fround(Math_fround(Math_fround(f14 * f65) + Math_fround(Math_fround(f11 * f59) - Math_fround(f58 * Math_fround(Math_fround(f10 * f57) - Math_fround(f61 * f12))))) * Math_fround(2.0));
   f60 = Math_fround(Math_fround(Math_fround(f57 * f65) + Math_fround(Math_fround(f61 * f59) - Math_fround(f58 * Math_fround(Math_fround(f11 * f12) - Math_fround(f10 * f14))))) * Math_fround(2.0));
   f65 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f59) - Math_fround(f58 * Math_fround(Math_fround(f61 * f14) - Math_fround(f11 * f57)))) + Math_fround(f12 * f65)) * Math_fround(2.0));
   f12 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f57 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
   f11 = Math_fround(HEAPF32[i3 >> 2]);
   f14 = Math_fround(f11 * f63);
   f61 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f14 = Math_fround(f14 + Math_fround(f61 * f60));
   f59 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f14 = Math_fround(Math_fround(f59 * f65) + f14);
   f10 = Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f57 * f63) + Math_fround(f12 * Math_fround(Math_fround(f61 * f65) - Math_fround(f59 * f60)))));
   f9 = Math_fround(Math_fround(f61 * f14) + Math_fround(Math_fround(f57 * f60) + Math_fround(f12 * Math_fround(Math_fround(f59 * f63) - Math_fround(f11 * f65)))));
   f14 = Math_fround(Math_fround(Math_fround(f57 * f65) + Math_fround(f12 * Math_fround(Math_fround(f11 * f60) - Math_fround(f61 * f63)))) + Math_fround(f59 * f14));
   f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
   f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
   f14 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f14);
   f63 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f58 * f11)) + Math_fround(f61 * f62)) - Math_fround(f59 * f64));
   f60 = Math_fround(Math_fround(Math_fround(f59 * f13) + Math_fround(Math_fround(f12 * f64) + Math_fround(f58 * f61))) - Math_fround(f11 * f62));
   f65 = Math_fround(Math_fround(Math_fround(f11 * f64) + Math_fround(Math_fround(f12 * f62) + Math_fround(f58 * f59))) - Math_fround(f61 * f13));
   f62 = Math_fround(Math_fround(Math_fround(Math_fround(f58 * f12) - Math_fround(f11 * f13)) - Math_fround(f61 * f64)) - Math_fround(f59 * f62));
   f59 = Math_fround(f5 * Math_fround(2.0));
   f64 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
   f61 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
   f13 = Math_fround(Math_fround(f62 * f62) + Math_fround(-.5));
   f5 = Math_fround(Math_fround(Math_fround(f63 * f59) + Math_fround(f60 * f64)) + Math_fround(f65 * f61));
   f10 = Math_fround(f10 + Math_fround(Math_fround(f63 * f5) + Math_fround(Math_fround(f13 * f59) + Math_fround(f62 * Math_fround(Math_fround(f60 * f61) - Math_fround(f65 * f64))))));
   f9 = Math_fround(f9 + Math_fround(Math_fround(f60 * f5) + Math_fround(Math_fround(f13 * f64) + Math_fround(f62 * Math_fround(Math_fround(f65 * f59) - Math_fround(f63 * f61))))));
   f5 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f13 * f61) + Math_fround(f62 * Math_fround(Math_fround(f63 * f64) - Math_fround(f60 * f59)))) + Math_fround(f65 * f5)));
   f59 = Math_fround(HEAPF32[i4 >> 2]);
   f64 = Math_fround(f62 * f59);
   f61 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f64 = Math_fround(f64 + Math_fround(f63 * f61));
   f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f64 = Math_fround(f64 + Math_fround(f60 * f13));
   f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(Math_fround(f62 * f61) - Math_fround(f63 * f59)) - Math_fround(f60 * f14)) - Math_fround(f65 * f13));
   f12 = Math_fround(Math_fround(Math_fround(f63 * f14) + Math_fround(Math_fround(f65 * f61) + Math_fround(f62 * f13))) - Math_fround(f60 * f59));
   f13 = Math_fround(Math_fround(Math_fround(f65 * f59) + Math_fround(Math_fround(f60 * f61) + Math_fround(f62 * f14))) - Math_fround(f63 * f13));
   f14 = Math_fround(f64 - Math_fround(f65 * f14));
  }
  HEAPF32[i49 >> 2] = f14;
  HEAPF32[i46 >> 2] = f13;
  HEAPF32[i28 >> 2] = f12;
  HEAPF32[i29 >> 2] = f11;
  HEAPF32[i30 >> 2] = f10;
  HEAPF32[i31 >> 2] = f9;
  HEAPF32[i32 >> 2] = f5;
  i19 = i24 + 98 | 0;
  i20 = (HEAPU16[i19 >> 1] | 0) & 2;
  HEAP32[i33 >> 2] = 0;
  HEAP16[i19 >> 1] = 0;
  HEAP16[i24 + 20 >> 1] = 0;
  HEAP32[i24 + 24 >> 2] = 0;
  HEAP32[i24 >> 2] = 0;
  HEAP16[i24 + 16 >> 1] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 28 >> 2] = 0;
  HEAP32[i24 + 32 >> 2] = 0;
  i18 = HEAP32[gb + 105216 + (i21 * 28 | 0) + (i6 << 2) >> 2] | 0;
  f65 = Math_fround(HEAPF32[i7 + 28 >> 2]);
  HEAPF32[i27 >> 2] = Math_fround(f65 + Math_fround(HEAPF32[i4 + 28 >> 2]));
  mftCall_iiiiiiii(i18 | 0, i7 + 36 | 0, i4 + 36 | 0, i48 | 0, i49 | 0, i27 | 0, i25 | 0, i34 | 0) | 0;
  mftCall_iiiii(HEAP32[gb + 104828 + (i21 * 28 | 0) + (i6 << 2) >> 2] | 0, i7 | 0, i4 | 0, i51 | 0, i47 | 0) | 0;
  if (i22) if (HEAP32[i33 >> 2] | 0) {
   i3 = 0;
   do {
    i22 = i51 + 384 + (i3 << 6) | 0;
    f63 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
    i18 = i51 + 384 + (i3 << 6) + 4 | 0;
    f64 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
    i21 = i51 + 384 + (i3 << 6) + 8 | 0;
    f65 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
    HEAPF32[i22 >> 2] = f63;
    HEAPF32[i18 >> 2] = f64;
    HEAPF32[i21 >> 2] = f65;
    i21 = i51 + 384 + (i3 << 6) + 48 | 0;
    i18 = i51 + 384 + (i3 << 6) + 52 | 0;
    i22 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i18 >> 2] = i22;
    i18 = i47 + (i3 << 2) | 0;
    i22 = i47 + (i3 << 2) + 2 | 0;
    i21 = HEAP16[i18 >> 1] | 0;
    HEAP16[i18 >> 1] = HEAP16[i22 >> 1] | 0;
    HEAP16[i22 >> 1] = i21;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i33 >> 2] | 0) >>> 0);
  }
  __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i24, i51, i47) | 0;
  if (i23) {
   i17 = ((HEAPU8[i35 >> 0] | 0) << 4) + 48 + ((HEAPU8[i36 >> 0] | 0) * 48 | 0) | 0;
   i18 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i37, i17) | 0;
   i3 = HEAP8[i35 >> 0] | 0;
   HEAP32[i18 + 32 >> 2] = i3 & 255;
   HEAP32[i18 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i38 + 16 >> 2];
   HEAP32[i18 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
   HEAP32[i18 + 24 >> 2] = HEAP32[i38 + 24 >> 2];
   HEAP32[i18 + 28 >> 2] = HEAP32[i38 + 28 >> 2];
   if (i3 << 24 >> 24) {
    i15 = 0;
    i16 = i18 + 48 | 0;
    while (1) {
     i6 = i16 + 16 | 0;
     i7 = HEAPU8[i38 + 48 + i15 >> 0] | 0;
     i8 = i38 + 64 + (i7 * 400 | 0) + 384 | 0;
     i23 = HEAP32[i8 >> 2] | 0;
     HEAP32[i16 >> 2] = i23;
     if (!i23) i4 = 0; else {
      i4 = 0;
      do {
       i3 = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 4 >> 2] | 0;
       i23 = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 8 >> 2] | 0;
       i22 = i6 + (i4 * 48 | 0) | 0;
       HEAP32[i22 >> 2] = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) >> 2];
       HEAP32[i22 + 4 >> 2] = i3;
       HEAP32[i22 + 8 >> 2] = i23;
       HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
       i22 = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 20 >> 2] | 0;
       i23 = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 24 >> 2] | 0;
       i3 = i6 + (i4 * 48 | 0) + 16 | 0;
       HEAP32[i3 >> 2] = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 16 >> 2];
       HEAP32[i3 + 4 >> 2] = i22;
       HEAP32[i3 + 8 >> 2] = i23;
       HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
       _memmove(i6 + (i4 * 48 | 0) + 32 | 0, i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 32 | 0, 16) | 0;
       HEAP32[i6 + (i4 * 48 | 0) + 12 >> 2] = HEAP32[i38 + 64 + (i7 * 400 | 0) + (i4 << 6) + 48 >> 2];
       i4 = i4 + 1 | 0;
       i3 = HEAP32[i8 >> 2] | 0;
      } while (i4 >>> 0 < i3 >>> 0);
      i4 = i3;
      i3 = HEAP8[i35 >> 0] | 0;
     }
     i15 = i15 + 1 | 0;
     if (i15 >>> 0 >= (i3 & 255) >>> 0) break; else i16 = i16 + ((i4 * 48 | 0) + 16) | 0;
    }
   }
   HEAP32[i25 >> 2] = i18 | 1;
   HEAP16[i24 + 56 >> 1] = i17;
  }
  do if ((i20 | 0) != ((HEAPU16[i19 >> 1] | 0) & 2 | 0)) {
   i24 = HEAP32[i52 + (i26 * 12 | 0) + 4 >> 2] | 0;
   i25 = i50 + (i24 >>> 5 << 2) | 0;
   HEAP32[i25 >> 2] = 1 << (i24 & 31) | HEAP32[i25 >> 2];
   if (!i20) {
    i2 = i2 + 1 | 0;
    break;
   } else {
    i1 = i1 + 1 | 0;
    break;
   }
  } while (0);
  i26 = i26 + 1 | 0;
 } while ((i26 | 0) != (i53 | 0));
 i53 = HEAP32[i56 >> 2] | 0;
 i53 = i53 + i1 | 0;
 HEAP32[i56 >> 2] = i53;
 i56 = HEAP32[i55 >> 2] | 0;
 i56 = i56 + i2 | 0;
 HEAP32[i55 >> 2] = i56;
 STACKTOP = i54;
 return;
}

function __ZN5physx2Gu26intersectHeightFieldConvexERKNS0_15HeightFieldUtilERKNS_11PxTransformERKNS0_10ConvexMeshES6_RKNS_11PxMeshScaleE(i60, i1, i31, i2, i3) {
 i60 = i60 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, f85 = f0;
 i84 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i82 = i84 + 48 | 0;
 i29 = i84 + 24 | 0;
 i61 = i84 + 12 | 0;
 i62 = i84;
 i59 = i84 + 176 | 0;
 f53 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(f53 + f53);
 f58 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f56 = Math_fround(f58 + f58);
 f48 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f52 = Math_fround(f48 + f48);
 f51 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f55 = Math_fround(f57 * f51);
 f54 = Math_fround(f56 * f51);
 f51 = Math_fround(f51 * f52);
 f42 = Math_fround(f53 * f56);
 f22 = Math_fround(f53 * f52);
 f56 = Math_fround(f58 * f56);
 f58 = Math_fround(f58 * f52);
 f52 = Math_fround(f48 * f52);
 f48 = Math_fround(Math_fround(Math_fround(1.0) - f56) - f52);
 f49 = Math_fround(f42 + f51);
 f50 = Math_fround(f22 - f54);
 f51 = Math_fround(f42 - f51);
 f57 = Math_fround(Math_fround(1.0) - Math_fround(f53 * f57));
 f52 = Math_fround(f57 - f52);
 f53 = Math_fround(f58 + f55);
 f54 = Math_fround(f22 + f54);
 f55 = Math_fround(f58 - f55);
 f56 = Math_fround(f57 - f56);
 f57 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f58 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f42 = Math_fround(HEAPF32[i2 >> 2]);
 f46 = Math_fround(f42 + f42);
 f47 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f45 = Math_fround(f47 + f47);
 f23 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f41 = Math_fround(f23 + f23);
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f44 = Math_fround(f46 * f26);
 f43 = Math_fround(f45 * f26);
 f26 = Math_fround(f26 * f41);
 f74 = Math_fround(f42 * f45);
 f21 = Math_fround(f42 * f41);
 f45 = Math_fround(f47 * f45);
 f47 = Math_fround(f47 * f41);
 f41 = Math_fround(f23 * f41);
 f23 = Math_fround(Math_fround(Math_fround(1.0) - f45) - f41);
 f24 = Math_fround(f74 + f26);
 f25 = Math_fround(f21 - f43);
 f26 = Math_fround(f74 - f26);
 f46 = Math_fround(Math_fround(1.0) - Math_fround(f42 * f46));
 f41 = Math_fround(f46 - f41);
 f42 = Math_fround(f47 + f44);
 f43 = Math_fround(f21 + f43);
 f44 = Math_fround(f47 - f44);
 f45 = Math_fround(f46 - f45);
 f46 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f47 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f74 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f78 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f18 = Math_fround(f74 + f74);
 f17 = Math_fround(f9 + f9);
 f69 = Math_fround(f78 + f78);
 f15 = Math_fround(f9 * f17);
 f7 = Math_fround(f78 * f69);
 f9 = Math_fround(f18 * f9);
 f79 = Math_fround(f18 * f78);
 f16 = Math_fround(f18 * f6);
 f78 = Math_fround(f17 * f78);
 f17 = Math_fround(f17 * f6);
 f6 = Math_fround(f69 * f6);
 f69 = Math_fround(Math_fround(Math_fround(1.0) - f15) - f7);
 f66 = Math_fround(f9 + f6);
 f73 = Math_fround(f79 - f17);
 f6 = Math_fround(f9 - f6);
 f18 = Math_fround(Math_fround(1.0) - Math_fround(f74 * f18));
 f7 = Math_fround(f18 - f7);
 f74 = Math_fround(f78 + f16);
 f17 = Math_fround(f79 + f17);
 f16 = Math_fround(f78 - f16);
 f15 = Math_fround(f18 - f15);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f78 = Math_fround(f18 * f69);
 f79 = Math_fround(f18 * f6);
 f18 = Math_fround(f18 * f17);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(f66 * f9);
 f19 = Math_fround(f7 * f9);
 f9 = Math_fround(f16 * f9);
 f75 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f67 = Math_fround(f73 * f75);
 f70 = Math_fround(f74 * f75);
 f75 = Math_fround(f15 * f75);
 f65 = Math_fround(Math_fround(Math_fround(f69 * f78) + Math_fround(f66 * f20)) + Math_fround(f73 * f67));
 f68 = Math_fround(Math_fround(Math_fround(f69 * f79) + Math_fround(f66 * f19)) + Math_fround(f73 * f70));
 f73 = Math_fround(Math_fround(Math_fround(f69 * f18) + Math_fround(f66 * f9)) + Math_fround(f73 * f75));
 f66 = Math_fround(Math_fround(Math_fround(f6 * f78) + Math_fround(f7 * f20)) + Math_fround(f74 * f67));
 f69 = Math_fround(Math_fround(Math_fround(f6 * f79) + Math_fround(f7 * f19)) + Math_fround(f74 * f70));
 f74 = Math_fround(Math_fround(Math_fround(f6 * f18) + Math_fround(f7 * f9)) + Math_fround(f74 * f75));
 f67 = Math_fround(Math_fround(Math_fround(f17 * f78) + Math_fround(f16 * f20)) + Math_fround(f15 * f67));
 f70 = Math_fround(Math_fround(Math_fround(f17 * f79) + Math_fround(f16 * f19)) + Math_fround(f15 * f70));
 f75 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(f16 * f9)) + Math_fround(f15 * f75));
 f15 = Math_fround(Math_fround(f43 * f73) + Math_fround(Math_fround(f23 * f65) + Math_fround(f26 * f68)));
 f9 = Math_fround(Math_fround(f44 * f73) + Math_fround(Math_fround(f24 * f65) + Math_fround(f41 * f68)));
 f16 = Math_fround(Math_fround(f45 * f73) + Math_fround(Math_fround(f25 * f65) + Math_fround(f42 * f68)));
 f18 = Math_fround(Math_fround(f43 * f74) + Math_fround(Math_fround(f23 * f66) + Math_fround(f26 * f69)));
 f17 = Math_fround(Math_fround(f44 * f74) + Math_fround(Math_fround(f24 * f66) + Math_fround(f41 * f69)));
 f19 = Math_fround(Math_fround(f45 * f74) + Math_fround(Math_fround(f25 * f66) + Math_fround(f42 * f69)));
 f79 = Math_fround(Math_fround(f43 * f75) + Math_fround(Math_fround(f23 * f67) + Math_fround(f26 * f70)));
 f20 = Math_fround(Math_fround(f44 * f75) + Math_fround(Math_fround(f24 * f67) + Math_fround(f41 * f70)));
 f78 = Math_fround(Math_fround(f45 * f75) + Math_fround(Math_fround(f25 * f67) + Math_fround(f42 * f70)));
 f7 = Math_fround(Math_fround(f46 + Math_fround(Math_fround(f43 * Math_fround(0.0)) + Math_fround(Math_fround(f23 * Math_fround(0.0)) + Math_fround(f26 * Math_fround(0.0))))) - f57);
 f6 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(f44 * Math_fround(0.0)) + Math_fround(Math_fround(f24 * Math_fround(0.0)) + Math_fround(f41 * Math_fround(0.0))))) - f58);
 f8 = Math_fround(Math_fround(f21 + Math_fround(Math_fround(f45 * Math_fround(0.0)) + Math_fround(Math_fround(f25 * Math_fround(0.0)) + Math_fround(f42 * Math_fround(0.0))))) - f22);
 f4 = Math_fround(Math_fround(f50 * f8) + Math_fround(Math_fround(f48 * f7) + Math_fround(f49 * f6)));
 f5 = Math_fround(Math_fround(f53 * f8) + Math_fround(Math_fround(f51 * f7) + Math_fround(f52 * f6)));
 f6 = Math_fround(Math_fround(f56 * f8) + Math_fround(Math_fround(f54 * f7) + Math_fround(f55 * f6)));
 f7 = Math_fround(Math_fround(f50 * f16) + Math_fround(Math_fround(f48 * f15) + Math_fround(f49 * f9)));
 f8 = Math_fround(Math_fround(f53 * f16) + Math_fround(Math_fround(f51 * f15) + Math_fround(f52 * f9)));
 f9 = Math_fround(Math_fround(f56 * f16) + Math_fround(Math_fround(f54 * f15) + Math_fround(f55 * f9)));
 f15 = Math_fround(Math_fround(f50 * f19) + Math_fround(Math_fround(f48 * f18) + Math_fround(f49 * f17)));
 f16 = Math_fround(Math_fround(f53 * f19) + Math_fround(Math_fround(f51 * f18) + Math_fround(f52 * f17)));
 f17 = Math_fround(Math_fround(f56 * f19) + Math_fround(Math_fround(f54 * f18) + Math_fround(f55 * f17)));
 f18 = Math_fround(Math_fround(f50 * f78) + Math_fround(Math_fround(f48 * f79) + Math_fround(f49 * f20)));
 f19 = Math_fround(Math_fround(f53 * f78) + Math_fround(Math_fround(f51 * f79) + Math_fround(f52 * f20)));
 f20 = Math_fround(Math_fround(f56 * f78) + Math_fround(Math_fround(f54 * f79) + Math_fround(f55 * f20)));
 i30 = i31 + 54 | 0;
 i1 = HEAP8[i30 >> 0] | 0;
 i2 = i1 & 255;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i2 * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i80 = i31 + 56 | 0;
 i81 = i31 + 55 | 0;
 i3 = (HEAP32[i80 >> 2] | 0) + ((HEAPU8[i81 >> 0] | 0) * 20 | 0) | 0;
 if (i1 << 24 >> 24) {
  i1 = 0;
  do {
   f77 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
   f85 = Math_fround(f7 * f77);
   f78 = Math_fround(f8 * f77);
   f77 = Math_fround(f9 * f77);
   f79 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
   f85 = Math_fround(f85 + Math_fround(f15 * f79));
   f78 = Math_fround(f78 + Math_fround(f16 * f79));
   f79 = Math_fround(f77 + Math_fround(f17 * f79));
   f77 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
   f78 = Math_fround(f5 + Math_fround(f78 + Math_fround(f19 * f77)));
   f79 = Math_fround(f6 + Math_fround(f79 + Math_fround(f20 * f77)));
   HEAPF32[i40 + (i1 * 12 | 0) >> 2] = Math_fround(f4 + Math_fround(f85 + Math_fround(f18 * f77)));
   HEAPF32[i40 + (i1 * 12 | 0) + 4 >> 2] = f78;
   HEAPF32[i40 + (i1 * 12 | 0) + 8 >> 2] = f79;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E(i29, i2, i40);
 i76 = i60 + 12 | 0;
 i39 = HEAP32[i76 >> 2] | 0;
 i37 = i39 + 40 | 0;
 f9 = Math_fround(HEAPF32[i37 >> 2]);
 i28 = f9 <= Math_fround(0.0);
 f8 = i28 ? Math_fround(-3402823469999999843913219.0e14) : Math_fround(3402823469999999843913219.0e14);
 f4 = Math_fround(HEAPF32[i60 >> 2]);
 i28 = i60 + 8 | 0;
 f7 = Math_fround(HEAPF32[i28 >> 2]);
 f77 = Math_fround(Math_fround(1.0) / f4);
 f78 = Math_fround(Math_fround(1.0) / f7);
 f79 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i60 + 4 >> 2]));
 i72 = f4 > Math_fround(0.0);
 f5 = Math_fround(HEAPF32[i29 >> 2]);
 i1 = HEAP32[i39 + 16 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i29 + 12 >> 2]);
 if (i72) {
  i12 = ~~Math_fround(Math_floor(Math_fround(f4 * f5)));
  i71 = i1 + -2 | 0;
  i12 = (i12 | 0) > 0 ? i12 : 0;
  i72 = ~~Math_fround(Math_ceil(Math_fround(f4 * f6)));
  i64 = i1 + -1 | 0;
  i72 = (i72 | 0) > 0 ? i72 : 0;
  i72 = (i72 | 0) > (i64 | 0) ? i64 : i72;
  i12 = (i12 | 0) > (i71 | 0) ? i71 : i12;
 } else {
  i12 = ~~Math_fround(Math_floor(Math_fround(f4 * f6)));
  i71 = i1 + -2 | 0;
  i12 = (i12 | 0) > 0 ? i12 : 0;
  i72 = ~~Math_fround(Math_ceil(Math_fround(f4 * f5)));
  i64 = i1 + -1 | 0;
  i72 = (i72 | 0) > 0 ? i72 : 0;
  i72 = (i72 | 0) > (i64 | 0) ? i64 : i72;
  i12 = (i12 | 0) > (i71 | 0) ? i71 : i12;
 }
 i64 = f7 > Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 i71 = i39 + 20 | 0;
 i27 = HEAP32[i71 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i29 + 20 >> 2]);
 if (i64) {
  i64 = ~~Math_fround(Math_floor(Math_fround(f7 * f4)));
  i38 = i27 + -2 | 0;
  i64 = (i64 | 0) > 0 ? i64 : 0;
  i63 = ~~Math_fround(Math_ceil(Math_fround(f7 * f5)));
  i36 = i27 + -1 | 0;
  i63 = (i63 | 0) > 0 ? i63 : 0;
  i63 = (i63 | 0) > (i36 | 0) ? i36 : i63;
  i64 = (i64 | 0) > (i38 | 0) ? i38 : i64;
 } else {
  i64 = ~~Math_fround(Math_floor(Math_fround(f7 * f5)));
  i38 = i27 + -2 | 0;
  i64 = (i64 | 0) > 0 ? i64 : 0;
  i63 = ~~Math_fround(Math_ceil(Math_fround(f7 * f4)));
  i36 = i27 + -1 | 0;
  i63 = (i63 | 0) > 0 ? i63 : 0;
  i63 = (i63 | 0) > (i36 | 0) ? i36 : i63;
  i64 = (i64 | 0) > (i38 | 0) ? i38 : i64;
 }
 i38 = i12 >>> 0 > i72 >>> 0;
 if (i38) f4 = f8; else {
  i11 = i64 >>> 0 > i63 >>> 0;
  i13 = i39 + 36 | 0;
  i14 = !(f9 <= Math_fround(0.0));
  f4 = f8;
  i10 = i12;
  do {
   if (!i11) {
    i2 = Math_imul(i27, i10) | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    if (i14) {
     i1 = i64;
     do {
      f85 = Math_fround(HEAP16[i3 + (i2 + i1 << 2) >> 1] | 0);
      f4 = f4 < f85 ? f4 : f85;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 <= i63 >>> 0);
    } else {
     i1 = i64;
     do {
      f85 = Math_fround(HEAP16[i3 + (i2 + i1 << 2) >> 1] | 0);
      f4 = f4 > f85 ? f4 : f85;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 <= i63 >>> 0);
    }
   }
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 <= i72 >>> 0);
 }
 f6 = Math_fround(f79 * f4);
 if (!(f9 <= Math_fround(0.0))) {
  if (Math_fround(HEAPF32[i29 + 16 >> 2]) < f6) {
   i83 = 0;
   STACKTOP = i84;
   return i83 | 0;
  }
 } else if (Math_fround(HEAPF32[i29 + 4 >> 2]) > f6) {
  i83 = 0;
  STACKTOP = i84;
  return i83 | 0;
 }
 L32 : do if (!(HEAP8[i30 >> 0] | 0)) i3 = 0; else {
  i13 = i60 + 16 | 0;
  f4 = f9;
  i2 = 0;
  L34 : while (1) {
   i36 = f4 <= Math_fround(0.0);
   i1 = i40 + (i2 * 12 | 0) + 4 | 0;
   f85 = Math_fround(HEAPF32[i1 >> 2]);
   do if (i36 ? f85 < f6 : f85 > f6) {
    i10 = i40 + (i2 * 12 | 0) | 0;
    f4 = Math_fround(HEAPF32[i10 >> 2]);
    i11 = i40 + (i2 * 12 | 0) + 8 | 0;
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    f4 = Math_fround(f4 * Math_fround(HEAPF32[i60 >> 2]));
    f5 = Math_fround(f5 * Math_fround(HEAPF32[i28 >> 2]));
    if (f4 >= Math_fround(0.0) & f5 >= Math_fround(0.0)) {
     i3 = HEAP32[i76 >> 2] | 0;
     if (f4 < Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + Math_fround(1.0))) if (f5 < Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) + Math_fround(1.0))) {
      f85 = Math_fround(HEAPF32[(HEAP32[i13 >> 2] | 0) + 8 >> 2]);
      f4 = Math_fround(f85 * Math_fround(__ZNK5physx2Gu11HeightField17getHeightInternalEff(i3, f4, f5)));
      f4 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f4);
      f5 = Math_fround(HEAPF32[i37 >> 2]);
      if (!(f5 <= f4) | (!(f4 <= Math_fround(0.0)) | !(f5 <= Math_fround(0.0)))) if (!(f5 > f4 & (f4 > Math_fround(-0.0) & f5 > Math_fround(0.0)))) break;
      f85 = Math_fround(HEAPF32[i10 >> 2]);
      if ((__ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff(i60, f85, Math_fround(HEAPF32[i11 >> 2])) | 0) != -1) {
       i1 = 1;
       break L34;
      }
     }
    }
   } while (0);
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i30 >> 0] | 0;
   if (i2 >>> 0 >= (i1 & 255) >>> 0) {
    i3 = i1;
    break L32;
   }
   f4 = Math_fround(HEAPF32[i37 >> 2]);
  }
  STACKTOP = i84;
  return i1 | 0;
 } while (0);
 i1 = i82;
 i2 = i1 + 128 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i35 = HEAP8[i81 >> 0] | 0;
 i1 = i35 & 255;
 i36 = HEAP32[i80 >> 2] | 0;
 i31 = ((i3 & 255) * 15 | 0) + (i1 * 20 | 0) + (HEAPU16[i31 + 52 >> 1] << 1) | 0;
 L48 : do if (i35 << 24 >> 24) {
  i32 = i61 + 4 | 0;
  i33 = i61 + 8 | 0;
  i34 = i62 + 4 | 0;
  i35 = i62 + 8 | 0;
  i30 = i36;
  L50 : while (1) {
   i1 = i1 + -1 | 0;
   i3 = HEAPU8[i30 + 18 >> 0] | 0;
   i28 = (HEAPU16[i30 + 16 >> 1] | 0) + i31 | 0;
   i30 = i30 + 20 | 0;
   i2 = i3 + -1 | 0;
   i29 = 0;
   L52 : while (1) {
    i13 = i36 + (i28 + i2) | 0;
    i14 = i36 + (i28 + i29) | 0;
    i2 = i3;
    while (1) {
     i3 = i2 + -1 | 0;
     if (!i2) break L52;
     i10 = HEAP8[i13 >> 0] | 0;
     i27 = HEAP8[i14 >> 0] | 0;
     i2 = (i27 & 255) < (i10 & 255);
     i11 = (i2 ? i27 : i10) & 255;
     i27 = (i2 ? i10 : i27) & 255;
     i10 = i11 << 8 | i27;
     i2 = i10 + ~(i10 << 15) | 0;
     i2 = (i2 >>> 10 ^ i2) * 9 | 0;
     i2 = i2 >>> 6 ^ i2;
     i2 = i2 + ~(i2 << 11) | 0;
     i2 = i82 + (((i2 >>> 16 ^ i2) & 63) << 1) | 0;
     if ((HEAPU16[i2 >> 1] | 0) == (i10 | 0)) i2 = i3; else break;
    }
    HEAP16[i2 >> 1] = i10;
    i2 = i40 + (i11 * 12 | 0) | 0;
    i10 = i40 + (i27 * 12 | 0) | 0;
    i13 = i29 + 1 | 0;
    i14 = !(Math_fround(HEAPF32[i37 >> 2]) <= Math_fround(0.0));
    f4 = Math_fround(HEAPF32[i40 + (i11 * 12 | 0) + 4 >> 2]);
    if (i14) {
     if (f4 < f6) if (Math_fround(HEAPF32[i40 + (i27 * 12 | 0) + 4 >> 2]) < f6) {
      i2 = i29;
      i29 = i13;
      continue;
     }
    } else if (f4 > f6) if (Math_fround(HEAPF32[i40 + (i27 * 12 | 0) + 4 >> 2]) > f6) {
     i2 = i29;
     i29 = i13;
     continue;
    }
    HEAP32[i61 >> 2] = HEAP32[i2 >> 2];
    HEAPF32[i32 >> 2] = f4;
    HEAP32[i33 >> 2] = HEAP32[i40 + (i11 * 12 | 0) + 8 >> 2];
    HEAP32[i62 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i40 + (i27 * 12 | 0) + 4 >> 2];
    HEAP32[i35 >> 2] = HEAP32[i40 + (i27 * 12 | 0) + 8 >> 2];
    HEAP8[i59 >> 0] = 0;
    __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_27TriggerTraceSegmentCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i60, i61, i62, i59, 0);
    if (!(HEAP8[i59 >> 0] | 0)) {
     i2 = i29;
     i29 = i13;
    } else break L50;
   }
   if (!i1) break L48;
  }
  i83 = 1;
  STACKTOP = i84;
  return i83 | 0;
 } while (0);
 f57 = Math_fround(f57 - f46);
 f20 = Math_fround(f58 - f47);
 f58 = Math_fround(f22 - f21);
 f85 = Math_fround(Math_fround(Math_fround(f57 * f23) + Math_fround(f24 * f20)) + Math_fround(f25 * f58));
 f15 = Math_fround(Math_fround(Math_fround(f57 * f26) + Math_fround(f41 * f20)) + Math_fround(f42 * f58));
 f58 = Math_fround(Math_fround(Math_fround(f57 * f43) + Math_fround(f44 * f20)) + Math_fround(f45 * f58));
 f21 = Math_fround(Math_fround(f50 * f25) + Math_fround(Math_fround(f48 * f23) + Math_fround(f49 * f24)));
 f20 = Math_fround(Math_fround(f50 * f42) + Math_fround(Math_fround(f48 * f26) + Math_fround(f49 * f41)));
 f22 = Math_fround(Math_fround(f50 * f45) + Math_fround(Math_fround(f48 * f43) + Math_fround(f49 * f44)));
 f50 = Math_fround(Math_fround(f53 * f25) + Math_fround(Math_fround(f51 * f23) + Math_fround(f52 * f24)));
 f57 = Math_fround(Math_fround(f53 * f42) + Math_fround(Math_fround(f51 * f26) + Math_fround(f52 * f41)));
 f53 = Math_fround(Math_fround(f53 * f45) + Math_fround(Math_fround(f51 * f43) + Math_fround(f52 * f44)));
 f17 = Math_fround(Math_fround(f56 * f25) + Math_fround(Math_fround(f54 * f23) + Math_fround(f55 * f24)));
 f26 = Math_fround(Math_fround(f56 * f42) + Math_fround(Math_fround(f54 * f26) + Math_fround(f55 * f41)));
 f16 = Math_fround(Math_fround(f56 * f45) + Math_fround(Math_fround(f54 * f43) + Math_fround(f55 * f44)));
 f18 = Math_fround(Math_fround(f22 * f67) + Math_fround(Math_fround(f21 * f65) + Math_fround(f20 * f66)));
 f19 = Math_fround(Math_fround(f22 * f70) + Math_fround(Math_fround(f21 * f68) + Math_fround(f20 * f69)));
 f20 = Math_fround(Math_fround(f22 * f75) + Math_fround(Math_fround(f21 * f73) + Math_fround(f20 * f74)));
 f21 = Math_fround(Math_fround(f53 * f67) + Math_fround(Math_fround(f50 * f65) + Math_fround(f57 * f66)));
 f22 = Math_fround(Math_fround(f53 * f70) + Math_fround(Math_fround(f50 * f68) + Math_fround(f57 * f69)));
 f23 = Math_fround(Math_fround(f53 * f75) + Math_fround(Math_fround(f50 * f73) + Math_fround(f57 * f74)));
 f24 = Math_fround(Math_fround(f16 * f67) + Math_fround(Math_fround(f17 * f65) + Math_fround(f26 * f66)));
 f25 = Math_fround(Math_fround(f16 * f70) + Math_fround(Math_fround(f17 * f68) + Math_fround(f26 * f69)));
 f26 = Math_fround(Math_fround(f16 * f75) + Math_fround(Math_fround(f17 * f73) + Math_fround(f26 * f74)));
 f17 = Math_fround(Math_fround(Math_fround(f58 * f67) + Math_fround(Math_fround(f85 * f65) + Math_fround(f15 * f66))) + Math_fround(0.0));
 f16 = Math_fround(Math_fround(Math_fround(f58 * f70) + Math_fround(Math_fround(f85 * f68) + Math_fround(f15 * f69))) + Math_fround(0.0));
 f15 = Math_fround(Math_fround(Math_fround(f58 * f75) + Math_fround(Math_fround(f85 * f73) + Math_fround(f15 * f74))) + Math_fround(0.0));
 if (i38) {
  i83 = 0;
  STACKTOP = i84;
  return i83 | 0;
 }
 i14 = i64 >>> 0 > i63 >>> 0;
 i13 = i39 + 36 | 0;
 L71 : while (1) {
  if (!i14) {
   f9 = Math_fround(f77 * Math_fround(i12 >>> 0));
   f7 = Math_fround(f18 * f9);
   f8 = Math_fround(f19 * f9);
   f9 = Math_fround(f20 * f9);
   i10 = (i12 | 0) == 0;
   i11 = i64;
   do {
    i2 = (Math_imul(HEAP32[i71 >> 2] | 0, i12) | 0) + i11 | 0;
    i62 = HEAP32[i76 >> 2] | 0;
    do if (!((mftCall_ii(HEAP32[(HEAP32[i62 >> 2] | 0) + 56 >> 2] | 0, i62 | 0) | 0) & 1)) {
     i1 = HEAP32[i76 >> 2] | 0;
     i83 = 55;
    } else {
     i1 = HEAP32[i76 >> 2] | 0;
     if (!(i10 | (i11 | 0) == 0)) if (((HEAP32[i1 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i12 >>> 0) if (((HEAP32[i1 + 20 >> 2] | 0) + -1 | 0) >>> 0 > i11 >>> 0) {
      i83 = 55;
      break;
     }
     if ((HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + (i2 << 2) + 2 >> 0] & 127) == 127) if (__ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb(i1, i2, i12, i11, 127, i82) | 0) {
      i83 = 56;
      break;
     } else break; else {
      i83 = 56;
      break;
     }
    } while (0);
    if ((i83 | 0) == 55) {
     i83 = 0;
     if ((HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + (i2 << 2) + 3 >> 0] | 0) < 0) i83 = 56;
    }
    L89 : do if ((i83 | 0) == 56) {
     i83 = 0;
     f6 = Math_fround(f79 * Math_fround(HEAP16[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 1] | 0));
     f85 = Math_fround(f78 * Math_fround(i11 >>> 0));
     f4 = Math_fround(f17 + Math_fround(Math_fround(f24 * f85) + Math_fround(f7 + Math_fround(f21 * f6))));
     f5 = Math_fround(f16 + Math_fround(Math_fround(f25 * f85) + Math_fround(f8 + Math_fround(f22 * f6))));
     f6 = Math_fround(f15 + Math_fround(Math_fround(f26 * f85) + Math_fround(f9 + Math_fround(f23 * f6))));
     i1 = HEAP8[i81 >> 0] | 0;
     if (!(i1 << 24 >> 24)) {
      i1 = 1;
      i83 = 63;
      break L71;
     }
     i3 = HEAP32[i80 >> 2] | 0;
     i1 = i1 & 255;
     i2 = 0;
     while (1) {
      f85 = Math_fround(f4 * Math_fround(HEAPF32[i3 + (i2 * 20 | 0) >> 2]));
      f85 = Math_fround(f85 + Math_fround(f5 * Math_fround(HEAPF32[i3 + (i2 * 20 | 0) + 4 >> 2])));
      f85 = Math_fround(f85 + Math_fround(f6 * Math_fround(HEAPF32[i3 + (i2 * 20 | 0) + 8 >> 2])));
      if (Math_fround(Math_fround(HEAPF32[i3 + (i2 * 20 | 0) + 12 >> 2]) + f85) >= Math_fround(0.0)) break L89;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i1 >>> 0) {
       i1 = 1;
       i83 = 63;
       break L71;
      }
     }
    } while (0);
    i11 = i11 + 1 | 0;
   } while (i11 >>> 0 <= i63 >>> 0);
  }
  i12 = i12 + 1 | 0;
  if (i12 >>> 0 > i72 >>> 0) {
   i1 = 0;
   i83 = 63;
   break;
  }
 }
 if ((i83 | 0) == 63) {
  STACKTOP = i84;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx21PxcCacheLocalContactsENS_14PxGeometryType4EnumES1_RNS_18PxcNpThreadContextERNS_10PxcNpCacheERKNS_11PxTransformES8_fPFbRKNS_2Gu13GeometryUnionESC_S8_S8_RKfS5_RNS9_13ContactBufferEESC_SC_(i1, i2, i83, i18, i22, i52, f3, i17, i19, i20) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i83 = i83 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i52 = i52 | 0;
 f3 = Math_fround(f3);
 i17 = i17 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i84 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i85;
 HEAPF32[i15 >> 2] = f3;
 i82 = i18 + 8 | 0;
 i1 = HEAP32[i82 >> 2] | 0;
 if (i1 | 0) {}
 i84 = i83 + 384 | 0;
 i25 = i83 + 4480 | 0;
 HEAP32[i25 >> 2] = 0;
 i1 = HEAP32[i82 >> 2] | 0;
 if (!i1) {
  HEAP32[i82 >> 2] = 0;
  i29 = i18 + 12 | 0;
  HEAP16[i29 >> 1] = 0;
  i2 = i22 + 8 | 0;
  i4 = i22 + 12 | 0;
  i7 = i22 + 20 | 0;
  i8 = i22 + 24 | 0;
  i9 = i52 + 4 | 0;
  i10 = i52 + 8 | 0;
  i11 = i52 + 12 | 0;
  i12 = i52 + 20 | 0;
  i14 = i52 + 24 | 0;
  i1 = i22 + 4 | 0;
  i16 = 0;
 } else {
  i24 = HEAP32[i1 >> 2] | 0;
  i26 = HEAP32[i1 + 4 >> 2] | 0;
  i27 = HEAP32[i1 + 8 >> 2] | 0;
  i28 = HEAP32[i1 + 12 >> 2] | 0;
  i68 = HEAP32[i1 + 16 >> 2] | 0;
  i69 = HEAP32[i1 + 20 >> 2] | 0;
  i70 = HEAP32[i1 + 24 >> 2] | 0;
  i71 = HEAP32[i1 + 28 >> 2] | 0;
  i72 = HEAP32[i1 + 32 >> 2] | 0;
  i73 = HEAP32[i1 + 36 >> 2] | 0;
  i74 = HEAP32[i1 + 40 >> 2] | 0;
  i75 = HEAP32[i1 + 44 >> 2] | 0;
  i76 = HEAP32[i1 + 48 >> 2] | 0;
  i77 = HEAP32[i1 + 52 >> 2] | 0;
  i78 = HEAP16[i1 + 56 >> 1] | 0;
  i79 = HEAP8[i1 + 58 >> 0] | 0;
  i16 = HEAP8[i1 + 59 >> 0] | 0;
  i80 = HEAP32[i1 + 60 >> 2] | 0;
  i23 = i1 + 64 | 0;
  HEAP32[i82 >> 2] = 0;
  i29 = i18 + 12 | 0;
  HEAP16[i29 >> 1] = 0;
  f34 = Math_fround(-Math_fround(HEAPF32[i52 >> 2]));
  i9 = i52 + 4 | 0;
  f35 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
  i10 = i52 + 8 | 0;
  f36 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
  i11 = i52 + 12 | 0;
  f37 = Math_fround(HEAPF32[i11 >> 2]);
  i21 = i22 + 16 | 0;
  f3 = Math_fround(HEAPF32[i21 >> 2]);
  i13 = i52 + 16 | 0;
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i13 >> 2]));
  i7 = i22 + 20 | 0;
  f5 = Math_fround(HEAPF32[i7 >> 2]);
  i12 = i52 + 20 | 0;
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i12 >> 2]));
  i8 = i22 + 24 | 0;
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  i14 = i52 + 24 | 0;
  f3 = Math_fround(f3 * Math_fround(2.0));
  f5 = Math_fround(f5 * Math_fround(2.0));
  f6 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i14 >> 2])) * Math_fround(2.0));
  f30 = Math_fround(Math_fround(f37 * f37) + Math_fround(-.5));
  f49 = Math_fround(Math_fround(Math_fround(f3 * f34) + Math_fround(f5 * f35)) + Math_fround(f6 * f36));
  f46 = Math_fround(Math_fround(f49 * f34) + Math_fround(Math_fround(f30 * f3) + Math_fround(f37 * Math_fround(Math_fround(f6 * f35) - Math_fround(f5 * f36)))));
  f47 = Math_fround(Math_fround(f49 * f35) + Math_fround(Math_fround(f30 * f5) + Math_fround(f37 * Math_fround(Math_fround(f3 * f36) - Math_fround(f6 * f34)))));
  f49 = Math_fround(Math_fround(Math_fround(f30 * f6) + Math_fround(f37 * Math_fround(Math_fround(f5 * f34) - Math_fround(f3 * f35)))) + Math_fround(f49 * f36));
  f3 = Math_fround(HEAPF32[i22 >> 2]);
  i4 = i22 + 12 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = i22 + 8 | 0;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i1 = i22 + 4 | 0;
  f30 = Math_fround(HEAPF32[i1 >> 2]);
  f53 = (HEAP32[tempDoublePtr >> 2] = i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(-f53);
  f54 = (HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f32 = Math_fround(-f54);
  f55 = (HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(-f55);
  f56 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = (HEAP32[tempDoublePtr >> 2] = i68, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f57 - f58);
  f59 = (HEAP32[tempDoublePtr >> 2] = i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = Math_fround(f59 - f60);
  f61 = (HEAP32[tempDoublePtr >> 2] = i70, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = (HEAP32[tempDoublePtr >> 2] = i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f64 * Math_fround(2.0));
  f65 = Math_fround(f65 * Math_fround(2.0));
  f66 = Math_fround(Math_fround(f61 - f62) * Math_fround(2.0));
  f63 = Math_fround(Math_fround(f56 * f56) + Math_fround(-.5));
  f51 = Math_fround(Math_fround(Math_fround(f64 * f31) + Math_fround(f65 * f32)) + Math_fround(f66 * f33));
  f48 = Math_fround(Math_fround(f51 * f31) + Math_fround(Math_fround(f63 * f64) + Math_fround(f56 * Math_fround(Math_fround(f66 * f32) - Math_fround(f65 * f33)))));
  f50 = Math_fround(Math_fround(f51 * f32) + Math_fround(Math_fround(f63 * f65) + Math_fround(f56 * Math_fround(Math_fround(f64 * f33) - Math_fround(f66 * f31)))));
  f51 = Math_fround(Math_fround(Math_fround(f63 * f66) + Math_fround(f56 * Math_fround(Math_fround(f65 * f31) - Math_fround(f64 * f32)))) + Math_fround(f51 * f33));
  f64 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f67 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f48 = Math_fround(Math_abs(Math_fround(f46 - f48)));
  f50 = Math_fround(Math_abs(Math_fround(f47 - f50)));
  f50 = f48 > f50 ? f48 : f50;
  f51 = Math_fround(Math_abs(Math_fround(f49 - f51)));
  if ((f50 > f51 ? f50 : f51) < Math_fround(Math_fround(HEAPF32[i83 + 8768 >> 2]) * Math_fround(.00999999977))) {
   f51 = Math_fround(Math_fround(Math_fround(Math_fround(f65 * f56) - Math_fround(f64 * f31)) - Math_fround(f67 * f32)) - Math_fround(f66 * f33));
   f50 = Math_fround(Math_fround(Math_fround(f67 * f31) + Math_fround(Math_fround(f65 * f33) + Math_fround(f66 * f56))) - Math_fround(f64 * f32));
   f49 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f5) - Math_fround(f3 * f34)) - Math_fround(f30 * f35)) - Math_fround(f6 * f36));
   f47 = Math_fround(Math_fround(Math_fround(f30 * f34) + Math_fround(Math_fround(f5 * f36) + Math_fround(f37 * f6))) - Math_fround(f3 * f35));
   f46 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f37 * f3) + Math_fround(f5 * f34)) + Math_fround(f6 * f35)) - Math_fround(f30 * f36)) - Math_fround(Math_fround(Math_fround(f66 * f32) + Math_fround(Math_fround(f65 * f31) + Math_fround(f64 * f56))) - Math_fround(f67 * f33)))));
   f48 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(Math_fround(f3 * f36) + Math_fround(Math_fround(f5 * f35) + Math_fround(f37 * f30))) - Math_fround(f6 * f34)) - Math_fround(Math_fround(Math_fround(f64 * f33) + Math_fround(Math_fround(f65 * f32) + Math_fround(f67 * f56))) - Math_fround(f66 * f31)))));
   f48 = f46 > f48 ? f46 : f48;
   f50 = Math_fround(Math_abs(Math_fround(f47 - f50)));
   f50 = f48 > f50 ? f48 : f50;
   f51 = Math_fround(Math_abs(Math_fround(f49 - f51)));
   if ((f50 > f51 ? f50 : f51) < Math_fround(.00999999977)) {
    i17 = i78 & 65535;
    i81 = i80 + 79 | 0;
    i15 = i81 & 65520;
    HEAP16[i29 >> 1] = i15;
    i15 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i83 + 356 | 0, i15) | 0;
    i15 = (i15 | 0) == 0 | (i15 | 0) != (-1 | 0) ? i15 : 0;
    HEAP32[i82 >> 2] = i15;
    HEAP32[i25 >> 2] = i17;
    if (i78 << 16 >> 16) {
     f48 = Math_fround(HEAPF32[i52 >> 2]);
     f42 = Math_fround(f48 + f48);
     f41 = Math_fround(HEAPF32[i9 >> 2]);
     f51 = Math_fround(f41 + f41);
     f43 = Math_fround(HEAPF32[i10 >> 2]);
     f47 = Math_fround(f43 + f43);
     f46 = Math_fround(HEAPF32[i11 >> 2]);
     f50 = Math_fround(f42 * f46);
     f49 = Math_fround(f51 * f46);
     f46 = Math_fround(f46 * f47);
     f36 = Math_fround(f48 * f51);
     f40 = Math_fround(f48 * f47);
     f51 = Math_fround(f41 * f51);
     f41 = Math_fround(f41 * f47);
     f47 = Math_fround(f43 * f47);
     f43 = Math_fround(Math_fround(Math_fround(1.0) - f51) - f47);
     f44 = Math_fround(f36 + f46);
     f45 = Math_fround(f40 - f49);
     f46 = Math_fround(f36 - f46);
     f42 = Math_fround(Math_fround(1.0) - Math_fround(f48 * f42));
     f47 = Math_fround(f42 - f47);
     f48 = Math_fround(f41 + f50);
     f49 = Math_fround(f40 + f49);
     f50 = Math_fround(f41 - f50);
     f51 = Math_fround(f42 - f51);
     f42 = Math_fround(HEAPF32[i13 >> 2]);
     f41 = Math_fround(HEAPF32[i12 >> 2]);
     f40 = Math_fround(HEAPF32[i14 >> 2]);
     f36 = Math_fround(HEAPF32[i22 >> 2]);
     f30 = Math_fround(f36 + f36);
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     f39 = Math_fround(f6 + f6);
     f31 = Math_fround(HEAPF32[i2 >> 2]);
     f35 = Math_fround(f31 + f31);
     f34 = Math_fround(HEAPF32[i4 >> 2]);
     f38 = Math_fround(f30 * f34);
     f37 = Math_fround(f39 * f34);
     f34 = Math_fround(f34 * f35);
     f5 = Math_fround(f36 * f39);
     f3 = Math_fround(f36 * f35);
     f39 = Math_fround(f6 * f39);
     f6 = Math_fround(f6 * f35);
     f35 = Math_fround(f31 * f35);
     f31 = Math_fround(Math_fround(Math_fround(1.0) - f39) - f35);
     f32 = Math_fround(f5 + f34);
     f33 = Math_fround(f3 - f37);
     f34 = Math_fround(f5 - f34);
     f30 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f30));
     f35 = Math_fround(f30 - f35);
     f36 = Math_fround(f6 + f38);
     f37 = Math_fround(f3 + f37);
     f38 = Math_fround(f6 - f38);
     f39 = Math_fround(f30 - f39);
     f30 = Math_fround(HEAPF32[i21 >> 2]);
     f6 = Math_fround(HEAPF32[i7 >> 2]);
     f3 = Math_fround(HEAPF32[i8 >> 2]);
     i10 = i16 << 24 >> 24 == 0;
     i11 = i17 + -1 | 0;
     f5 = Math_fround(Math_fround(f65 * f65) + Math_fround(-.5));
     i12 = i79 << 24 >> 24 == 0;
     i1 = i23;
     i7 = i84;
     i8 = 0;
     i9 = 0;
     while (1) {
      i2 = i10 | (i8 | 0) == 0;
      i9 = i2 ? i1 : i9;
      i2 = i2 ? i1 + 12 | 0 : i1;
      i1 = i2 + 16 | 0;
      f88 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      f92 = Math_fround(HEAPF32[i2 >> 2]);
      f91 = Math_fround(HEAPF32[i2 + 4 >> 2]);
      f87 = Math_fround(HEAPF32[i2 + 8 >> 2]);
      f93 = Math_fround(Math_fround(f92 - f57) * Math_fround(2.0));
      f95 = Math_fround(Math_fround(f91 - f59) * Math_fround(2.0));
      f90 = Math_fround(Math_fround(f87 - f61) * Math_fround(2.0));
      f89 = Math_fround(Math_fround(Math_fround(f64 * f93) + Math_fround(f67 * f95)) + Math_fround(f66 * f90));
      f86 = Math_fround(Math_fround(f64 * f89) + Math_fround(Math_fround(f5 * f93) - Math_fround(f65 * Math_fround(Math_fround(f67 * f90) - Math_fround(f66 * f95)))));
      f94 = Math_fround(Math_fround(f67 * f89) + Math_fround(Math_fround(f5 * f95) - Math_fround(f65 * Math_fround(Math_fround(f66 * f93) - Math_fround(f64 * f90)))));
      f89 = Math_fround(Math_fround(Math_fround(f5 * f90) - Math_fround(f65 * Math_fround(Math_fround(f64 * f95) - Math_fround(f67 * f93)))) + Math_fround(f66 * f89));
      f93 = Math_fround(f30 + Math_fround(Math_fround(f37 * f89) + Math_fround(Math_fround(f31 * f86) + Math_fround(f34 * f94))));
      f95 = Math_fround(f6 + Math_fround(Math_fround(f38 * f89) + Math_fround(Math_fround(f32 * f86) + Math_fround(f35 * f94))));
      f94 = Math_fround(f3 + Math_fround(Math_fround(f39 * f89) + Math_fround(Math_fround(f33 * f86) + Math_fround(f36 * f94))));
      f92 = Math_fround(Math_fround(f92 - f58) * Math_fround(2.0));
      f91 = Math_fround(Math_fround(f91 - f60) * Math_fround(2.0));
      f87 = Math_fround(Math_fround(f87 - f62) * Math_fround(2.0));
      f86 = Math_fround(Math_fround(Math_fround(f53 * f92) + Math_fround(f54 * f91)) + Math_fround(f55 * f87));
      f89 = Math_fround(Math_fround(f53 * f86) + Math_fround(Math_fround(f63 * f92) - Math_fround(f56 * Math_fround(Math_fround(f54 * f87) - Math_fround(f55 * f91)))));
      f90 = Math_fround(Math_fround(f54 * f86) + Math_fround(Math_fround(f63 * f91) - Math_fround(f56 * Math_fround(Math_fround(f55 * f92) - Math_fround(f53 * f87)))));
      f86 = Math_fround(Math_fround(Math_fround(f63 * f87) - Math_fround(f56 * Math_fround(Math_fround(f53 * f91) - Math_fround(f54 * f92)))) + Math_fround(f55 * f86));
      f92 = Math_fround(f42 + Math_fround(Math_fround(f49 * f86) + Math_fround(Math_fround(f43 * f89) + Math_fround(f46 * f90))));
      f91 = Math_fround(f41 + Math_fround(Math_fround(f50 * f86) + Math_fround(Math_fround(f44 * f89) + Math_fround(f47 * f90))));
      f90 = Math_fround(f40 + Math_fround(Math_fround(f51 * f86) + Math_fround(Math_fround(f45 * f89) + Math_fround(f48 * f90))));
      f89 = Math_fround(f93 - f92);
      f86 = Math_fround(f95 - f91);
      f87 = Math_fround(f94 - f90);
      HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
      i83 = i9 + 4 | 0;
      HEAP32[i7 + 4 >> 2] = HEAP32[i83 >> 2];
      i84 = i9 + 8 | 0;
      HEAP32[i7 + 8 >> 2] = HEAP32[i84 >> 2];
      f91 = Math_fround(Math_fround(f95 + f91) * Math_fround(.5));
      f90 = Math_fround(Math_fround(f94 + f90) * Math_fround(.5));
      HEAPF32[i7 + 16 >> 2] = Math_fround(Math_fround(f93 + f92) * Math_fround(.5));
      HEAPF32[i7 + 20 >> 2] = f91;
      HEAPF32[i7 + 24 >> 2] = f90;
      f89 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f89);
      f86 = Math_fround(f89 + Math_fround(Math_fround(HEAPF32[i83 >> 2]) * f86));
      HEAPF32[i7 + 12 >> 2] = Math_fround(f88 + Math_fround(Math_fround(Math_fround(HEAPF32[i84 >> 2]) * f87) + f86));
      if (i12) {
       HEAP32[i7 + 48 >> 2] = -1;
       i4 = -1;
      } else {
       HEAP32[i7 + 48 >> 2] = HEAP32[i1 >> 2];
       i4 = HEAP32[i2 + 20 >> 2] | 0;
       i1 = i2 + 24 | 0;
      }
      HEAP32[i7 + 52 >> 2] = i4;
      i8 = i8 + 1 | 0;
      if ((i8 | 0) == (i17 | 0)) break; else i7 = i7 + 64 | 0;
     }
    }
    if (!i15) {
     STACKTOP = i85;
     return;
    }
    HEAP32[i15 >> 2] = i24;
    HEAP32[i15 + 4 >> 2] = i26;
    HEAP32[i15 + 8 >> 2] = i27;
    HEAP32[i15 + 12 >> 2] = i28;
    HEAP32[i15 + 16 >> 2] = i68;
    HEAP32[i15 + 20 >> 2] = i69;
    HEAP32[i15 + 24 >> 2] = i70;
    HEAP32[i15 + 28 >> 2] = i71;
    HEAP32[i15 + 32 >> 2] = i72;
    HEAP32[i15 + 36 >> 2] = i73;
    HEAP32[i15 + 40 >> 2] = i74;
    HEAP32[i15 + 44 >> 2] = i75;
    HEAP32[i15 + 48 >> 2] = i76;
    HEAP32[i15 + 52 >> 2] = i77;
    HEAP16[i15 + 56 >> 1] = i78;
    HEAP8[i15 + 58 >> 0] = i79;
    HEAP8[i15 + 59 >> 0] = i16;
    HEAP32[i15 + 60 >> 2] = i80;
    _memcpy(i15 + 64 | 0, i23 | 0, i80 | 0) | 0;
    STACKTOP = i85;
    return;
   }
  }
 }
 mftCall_iiiiiiii(i17 | 0, i19 | 0, i20 | 0, i22 | 0, i52 | 0, i15 | 0, i18 | 0, i84 | 0) | 0;
 i28 = HEAP32[i22 >> 2] | 0;
 i27 = HEAP32[i1 >> 2] | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 i24 = HEAP32[i4 >> 2] | 0;
 i23 = HEAP32[i22 + 16 >> 2] | 0;
 i22 = HEAP32[i7 >> 2] | 0;
 i20 = HEAP32[i8 >> 2] | 0;
 i21 = HEAP32[i52 >> 2] | 0;
 i19 = HEAP32[i9 >> 2] | 0;
 i18 = HEAP32[i10 >> 2] | 0;
 i17 = HEAP32[i11 >> 2] | 0;
 i15 = HEAP32[i52 + 16 >> 2] | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 if (!i25) {
  HEAP16[i29 >> 1] = 64;
  i1 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i83 + 356 | 0, 64) | 0;
  HEAP32[i82 >> 2] = i1;
  switch (i1 | 0) {
  case -1:
   {
    HEAP32[i82 >> 2] = 0;
    STACKTOP = i85;
    return;
   }
  case 0:
   {
    STACKTOP = i85;
    return;
   }
  default:
   {
    HEAP32[i1 >> 2] = i28;
    HEAP32[i1 + 4 >> 2] = i27;
    HEAP32[i1 + 8 >> 2] = i26;
    HEAP32[i1 + 12 >> 2] = i24;
    HEAP32[i1 + 16 >> 2] = i23;
    HEAP32[i1 + 20 >> 2] = i22;
    HEAP32[i1 + 24 >> 2] = i20;
    HEAP32[i1 + 28 >> 2] = i21;
    HEAP32[i1 + 32 >> 2] = i19;
    HEAP32[i1 + 36 >> 2] = i18;
    HEAP32[i1 + 40 >> 2] = i17;
    HEAP32[i1 + 44 >> 2] = i15;
    HEAP32[i1 + 48 >> 2] = i13;
    HEAP32[i1 + 52 >> 2] = i12;
    HEAP16[i1 + 56 >> 1] = 0;
    HEAP8[i1 + 58 >> 0] = 0;
    HEAP8[i1 + 59 >> 0] = i16;
    HEAP32[i1 + 60 >> 2] = 0;
    STACKTOP = i85;
    return;
   }
  }
 }
 i11 = (HEAP32[i83 + 436 >> 2] & HEAP32[i83 + 432 >> 2] | 0) != -1;
 i9 = i25 & 65535;
 i10 = i11 & 1;
 f3 = Math_fround(HEAPF32[i84 >> 2]);
 i14 = i83 + 388 | 0;
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 i16 = i83 + 392 | 0;
 f6 = Math_fround(HEAPF32[i16 >> 2]);
 L39 : do if (i25 >>> 0 > 1) {
  i1 = 1;
  while (1) {
   if (Math_fround(HEAPF32[i83 + 384 + (i1 << 6) >> 2]) != f3) break;
   if (Math_fround(HEAPF32[i83 + 384 + (i1 << 6) + 4 >> 2]) != f5) break;
   if (Math_fround(HEAPF32[i83 + 384 + (i1 << 6) + 8 >> 2]) != f6) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i25 >>> 0) {
    i81 = 27;
    break L39;
   }
  }
  i7 = 0;
  i4 = Math_imul(i11 ? 36 : 28, i25) | 0;
  i8 = 1;
 } else i81 = 27; while (0);
 if ((i81 | 0) == 27) {
  i7 = 1;
  i4 = (Math_imul(i11 ? 24 : 16, i25) | 0) + 12 | 0;
  i8 = 0;
 }
 i2 = i83 + 356 | 0;
 i1 = i4 + 79 & 65520;
 HEAP16[i29 >> 1] = i1;
 i1 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i2, i1) | 0;
 i1 = (i1 | 0) == 0 | (i1 | 0) != (-1 | 0) ? i1 : 0;
 HEAP32[i82 >> 2] = i1;
 if (!i1) {
  HEAP16[i29 >> 1] = 64;
  i1 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i2, 64) | 0;
  HEAP32[i82 >> 2] = i1;
  switch (i1 | 0) {
  case -1:
   {
    HEAP32[i82 >> 2] = 0;
    STACKTOP = i85;
    return;
   }
  case 0:
   {
    STACKTOP = i85;
    return;
   }
  default:
   {
    HEAP32[i1 >> 2] = i28;
    HEAP32[i1 + 4 >> 2] = i27;
    HEAP32[i1 + 8 >> 2] = i26;
    HEAP32[i1 + 12 >> 2] = i24;
    HEAP32[i1 + 16 >> 2] = i23;
    HEAP32[i1 + 20 >> 2] = i22;
    HEAP32[i1 + 24 >> 2] = i20;
    HEAP32[i1 + 28 >> 2] = i21;
    HEAP32[i1 + 32 >> 2] = i19;
    HEAP32[i1 + 36 >> 2] = i18;
    HEAP32[i1 + 40 >> 2] = i17;
    HEAP32[i1 + 44 >> 2] = i15;
    HEAP32[i1 + 48 >> 2] = i13;
    HEAP32[i1 + 52 >> 2] = i12;
    HEAP16[i1 + 56 >> 1] = 0;
    HEAP8[i1 + 58 >> 0] = i10;
    HEAP8[i1 + 59 >> 0] = i7;
    HEAP32[i1 + 60 >> 2] = 0;
    STACKTOP = i85;
    return;
   }
  }
 }
 HEAP32[i1 >> 2] = i28;
 HEAP32[i1 + 4 >> 2] = i27;
 HEAP32[i1 + 8 >> 2] = i26;
 HEAP32[i1 + 12 >> 2] = i24;
 HEAP32[i1 + 16 >> 2] = i23;
 HEAP32[i1 + 20 >> 2] = i22;
 HEAP32[i1 + 24 >> 2] = i20;
 HEAP32[i1 + 28 >> 2] = i21;
 HEAP32[i1 + 32 >> 2] = i19;
 HEAP32[i1 + 36 >> 2] = i18;
 HEAP32[i1 + 40 >> 2] = i17;
 HEAP32[i1 + 44 >> 2] = i15;
 HEAP32[i1 + 48 >> 2] = i13;
 HEAP32[i1 + 52 >> 2] = i12;
 HEAP16[i1 + 56 >> 1] = i9;
 HEAP8[i1 + 58 >> 0] = i10;
 HEAP8[i1 + 59 >> 0] = i7;
 HEAP32[i1 + 60 >> 2] = i4;
 i1 = i1 + 64 | 0;
 if (i8) if (i11) {
  i2 = 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i83 + 384 + (i2 << 6) >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 16 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 20 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 24 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 12 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 48 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 52 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i25 | 0)) break; else i1 = i1 + 36 | 0;
  }
  STACKTOP = i85;
  return;
 } else {
  i2 = 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i83 + 384 + (i2 << 6) >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 16 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 20 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 24 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 12 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i25 | 0)) break; else i1 = i1 + 28 | 0;
  }
  STACKTOP = i85;
  return;
 }
 i4 = i83 + 384 | 0;
 if (i11) {
  i2 = 0;
  while (1) {
   if (!i2) {
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
    i1 = i1 + 12 | 0;
   }
   HEAP32[i1 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 16 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 20 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 24 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 48 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 52 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i25 | 0)) break; else i1 = i1 + 24 | 0;
  }
  STACKTOP = i85;
  return;
 } else {
  i2 = 0;
  while (1) {
   if (!i2) {
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i16 >> 2];
    i1 = i1 + 12 | 0;
   }
   HEAP32[i1 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 16 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 20 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 24 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i83 + 384 + (i2 << 6) + 12 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i25 | 0)) break; else i1 = i1 + 16 | 0;
  }
  STACKTOP = i85;
  return;
 }
}

function __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i1, i2, i25) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i31;
 f27 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i28 = i25 + 24 | 0;
 i29 = i25 + 4 | 0;
 i30 = i25 + 8 | 0;
 L1 : while (1) {
  i21 = i2;
  i24 = i2 + -12 | 0;
  i19 = i2 + -24 | 0;
  i20 = i2 + -4 | 0;
  i22 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i18 = i1;
    i5 = i21 - i18 | 0;
    switch ((i5 | 0) / 12 | 0 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 11;
      break L1;
     }
    case 4:
     {
      i23 = 12;
      break L1;
     }
    case 5:
     {
      i23 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 92;
      break L1;
     }
    default:
     {}
    }
    if ((i5 | 0) < 372) {
     i23 = 15;
     break L1;
    }
    i6 = (i5 >>> 0) / 24 | 0;
    i8 = i1 + (i6 * 12 | 0) | 0;
    if ((i5 | 0) > 11988) {
     i5 = (i5 >>> 0) / 48 | 0;
     i5 = __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i5 * 12 | 0) | 0, i8, i8 + (i5 * 12 | 0) | 0, i24, i25) | 0;
    } else i5 = __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i8, i24, i25) | 0;
    i17 = i1 + 8 | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i15 = HEAP32[i1 + (i6 * 12 | 0) + 8 >> 2] | 0;
    do if ((i16 | 0) == (i15 | 0)) {
     f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f4 = Math_fround(HEAPF32[i1 + (i6 * 12 | 0) + 4 >> 2]);
     f12 = Math_fround(f3 - f4);
     if (Math_fround(f12 * f12) > f27) if (f3 > f4) {
      i6 = i24;
      break L5;
     } else break; else {
      i14 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      f32 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) >> 2]);
      f3 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) + 4 >> 2]);
      f4 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) + 8 >> 2]);
      i14 = HEAP32[i8 >> 2] | 0;
      f35 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) >> 2]);
      f34 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) + 4 >> 2]);
      f33 = Math_fround(HEAPF32[i13 + (i14 * 24 | 0) + 8 >> 2]);
      f10 = Math_fround(HEAPF32[i25 >> 2]);
      f32 = Math_fround(f32 - f10);
      f11 = Math_fround(HEAPF32[i29 >> 2]);
      f3 = Math_fround(f3 - f11);
      f12 = Math_fround(HEAPF32[i30 >> 2]);
      f4 = Math_fround(f4 - f12);
      f10 = Math_fround(f35 - f10);
      f11 = Math_fround(f34 - f11);
      f12 = Math_fround(f33 - f12);
      if (Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f3 * f3)) + Math_fround(f4 * f4)) < Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f12 * f12))) {
       i6 = i24;
       break L5;
      } else break;
     }
    } else if ((i16 | 0) > (i15 | 0)) {
     i6 = i24;
     break L5;
    } while (0);
    if ((i1 | 0) != (i19 | 0)) {
     i13 = i1 + (i6 * 12 | 0) + 4 | 0;
     i14 = HEAP32[i28 >> 2] | 0;
     f10 = Math_fround(HEAPF32[i25 >> 2]);
     f11 = Math_fround(HEAPF32[i29 >> 2]);
     f12 = Math_fround(HEAPF32[i30 >> 2]);
     i7 = i24;
     i6 = i19;
     while (1) {
      i9 = HEAP32[i7 + -4 >> 2] | 0;
      do if ((i9 | 0) == (i15 | 0)) {
       f3 = Math_fround(HEAPF32[i7 + -8 >> 2]);
       f4 = Math_fround(HEAPF32[i13 >> 2]);
       f35 = Math_fround(f3 - f4);
       if (Math_fround(f35 * f35) > f27) if (f3 > f4) {
        i23 = 62;
        break L5;
       } else break; else {
        i9 = HEAP32[i6 >> 2] | 0;
        i7 = HEAP32[i14 >> 2] | 0;
        f3 = Math_fround(HEAPF32[i7 + (i9 * 24 | 0) >> 2]);
        f4 = Math_fround(HEAPF32[i7 + (i9 * 24 | 0) + 4 >> 2]);
        f32 = Math_fround(HEAPF32[i7 + (i9 * 24 | 0) + 8 >> 2]);
        i9 = HEAP32[i8 >> 2] | 0;
        f33 = Math_fround(HEAPF32[i7 + (i9 * 24 | 0) >> 2]);
        f34 = Math_fround(HEAPF32[i7 + (i9 * 24 | 0) + 4 >> 2]);
        f3 = Math_fround(f3 - f10);
        f4 = Math_fround(f4 - f11);
        f32 = Math_fround(f32 - f12);
        f33 = Math_fround(f33 - f10);
        f34 = Math_fround(f34 - f11);
        f35 = Math_fround(Math_fround(HEAPF32[i7 + (i9 * 24 | 0) + 8 >> 2]) - f12);
        if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) {
         i23 = 62;
         break L5;
        } else break;
       }
      } else if ((i9 | 0) > (i15 | 0)) {
       i23 = 62;
       break L5;
      } while (0);
      i7 = i6 + -12 | 0;
      if ((i1 | 0) == (i7 | 0)) break; else {
       i9 = i6;
       i6 = i7;
       i7 = i9;
      }
     }
    }
    i5 = i1 + 12 | 0;
    i6 = HEAP32[i20 >> 2] | 0;
    do if ((i16 | 0) == (i6 | 0)) {
     f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f4 = Math_fround(HEAPF32[i22 >> 2]);
     f35 = Math_fround(f3 - f4);
     if (Math_fround(f35 * f35) > f27) if (f3 > f4) break; else {
      i23 = 31;
      break;
     } else {
      i18 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      f11 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) >> 2]);
      f12 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 4 >> 2]);
      f32 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 8 >> 2]);
      i18 = HEAP32[i24 >> 2] | 0;
      f3 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) >> 2]);
      f4 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 4 >> 2]);
      f10 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 8 >> 2]);
      f33 = Math_fround(HEAPF32[i25 >> 2]);
      f11 = Math_fround(f11 - f33);
      f34 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(f12 - f34);
      f35 = Math_fround(HEAPF32[i30 >> 2]);
      f32 = Math_fround(f32 - f35);
      f33 = Math_fround(f3 - f33);
      f34 = Math_fround(f4 - f34);
      f35 = Math_fround(f10 - f35);
      if (Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break; else {
       i23 = 31;
       break;
      }
     }
    } else if ((i16 | 0) <= (i6 | 0)) i23 = 31; while (0);
    if ((i23 | 0) == 31) {
     i23 = 0;
     if ((i5 | 0) == (i24 | 0)) {
      i23 = 92;
      break L1;
     }
     i7 = i1 + 4 | 0;
     i8 = HEAP32[i28 >> 2] | 0;
     f10 = Math_fround(HEAPF32[i25 >> 2]);
     f11 = Math_fround(HEAPF32[i29 >> 2]);
     f12 = Math_fround(HEAPF32[i30 >> 2]);
     L41 : while (1) {
      i6 = HEAP32[i5 + 8 >> 2] | 0;
      do if ((i16 | 0) == (i6 | 0)) {
       f3 = Math_fround(HEAPF32[i7 >> 2]);
       f4 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f35 = Math_fround(f3 - f4);
       if (Math_fround(f35 * f35) > f27) if (f3 > f4) break L41; else break; else {
        i18 = HEAP32[i1 >> 2] | 0;
        i15 = HEAP32[i8 >> 2] | 0;
        f3 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) >> 2]);
        f4 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 4 >> 2]);
        f32 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 8 >> 2]);
        i18 = HEAP32[i5 >> 2] | 0;
        f33 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) >> 2]);
        f34 = Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 4 >> 2]);
        f3 = Math_fround(f3 - f10);
        f4 = Math_fround(f4 - f11);
        f32 = Math_fround(f32 - f12);
        f33 = Math_fround(f33 - f10);
        f34 = Math_fround(f34 - f11);
        f35 = Math_fround(Math_fround(HEAPF32[i15 + (i18 * 24 | 0) + 8 >> 2]) - f12);
        if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break L41; else break;
       }
      } else if ((i16 | 0) > (i6 | 0)) break L41; while (0);
      i5 = i5 + 12 | 0;
      if ((i5 | 0) == (i24 | 0)) {
       i23 = 92;
       break L1;
      }
     }
     HEAP32[i26 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i26 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i26 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     i5 = i5 + 12 | 0;
    }
    if ((i5 | 0) == (i24 | 0)) {
     i23 = 92;
     break L1;
    }
    i14 = i1 + 4 | 0;
    i7 = i24;
    while (1) {
     i9 = HEAP32[i17 >> 2] | 0;
     i13 = HEAP32[i28 >> 2] | 0;
     f10 = Math_fround(HEAPF32[i25 >> 2]);
     f11 = Math_fround(HEAPF32[i29 >> 2]);
     f12 = Math_fround(HEAPF32[i30 >> 2]);
     L55 : while (1) {
      i6 = HEAP32[i5 + 8 >> 2] | 0;
      do if ((i9 | 0) == (i6 | 0)) {
       f3 = Math_fround(HEAPF32[i14 >> 2]);
       f4 = Math_fround(HEAPF32[i5 + 4 >> 2]);
       f35 = Math_fround(f3 - f4);
       if (Math_fround(f35 * f35) > f27) if (f3 > f4) break L55; else break; else {
        i18 = HEAP32[i1 >> 2] | 0;
        i16 = HEAP32[i13 >> 2] | 0;
        f3 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) >> 2]);
        f4 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 4 >> 2]);
        f32 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 8 >> 2]);
        i18 = HEAP32[i5 >> 2] | 0;
        f33 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) >> 2]);
        f34 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 4 >> 2]);
        f3 = Math_fround(f3 - f10);
        f4 = Math_fround(f4 - f11);
        f32 = Math_fround(f32 - f12);
        f33 = Math_fround(f33 - f10);
        f34 = Math_fround(f34 - f11);
        f35 = Math_fround(Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 8 >> 2]) - f12);
        if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break L55; else break;
       }
      } else if ((i9 | 0) > (i6 | 0)) break L55; while (0);
      i5 = i5 + 12 | 0;
     }
     while (1) {
      i8 = i7 + -12 | 0;
      i6 = HEAP32[i7 + -4 >> 2] | 0;
      if ((i9 | 0) != (i6 | 0)) if ((i9 | 0) > (i6 | 0)) {
       i7 = i8;
       continue;
      } else break;
      f4 = Math_fround(HEAPF32[i14 >> 2]);
      f3 = Math_fround(HEAPF32[i7 + -8 >> 2]);
      f35 = Math_fround(f4 - f3);
      if (Math_fround(f35 * f35) > f27) if (f4 > f3) {
       i7 = i8;
       continue;
      } else break; else {
       i18 = HEAP32[i1 >> 2] | 0;
       i16 = HEAP32[i13 >> 2] | 0;
       f3 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) >> 2]);
       f4 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 4 >> 2]);
       f32 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 8 >> 2]);
       i18 = HEAP32[i8 >> 2] | 0;
       f33 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) >> 2]);
       f34 = Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 4 >> 2]);
       f3 = Math_fround(f3 - f10);
       f4 = Math_fround(f4 - f11);
       f32 = Math_fround(f32 - f12);
       f33 = Math_fround(f33 - f10);
       f34 = Math_fround(f34 - f11);
       f35 = Math_fround(Math_fround(HEAPF32[i16 + (i18 * 24 | 0) + 8 >> 2]) - f12);
       if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) {
        i7 = i8;
        continue;
       } else break;
      }
     }
     if (i5 >>> 0 >= i8 >>> 0) {
      i1 = i5;
      continue L5;
     };
     HEAP32[i26 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i26 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i26 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     i7 = i8;
     i5 = i5 + 12 | 0;
    }
   }
   if ((i23 | 0) == 62) {
    i23 = 0;
    HEAP32[i26 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i26 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    i5 = i5 + 1 | 0;
   }
   i7 = i1 + 12 | 0;
   L77 : do if (i7 >>> 0 < i6 >>> 0) while (1) {
    i14 = HEAP32[i8 + 8 >> 2] | 0;
    i15 = i8 + 4 | 0;
    i16 = HEAP32[i28 >> 2] | 0;
    f10 = Math_fround(HEAPF32[i25 >> 2]);
    f11 = Math_fround(HEAPF32[i29 >> 2]);
    f12 = Math_fround(HEAPF32[i30 >> 2]);
    L80 : while (1) {
     i9 = HEAP32[i7 + 8 >> 2] | 0;
     do if ((i9 | 0) == (i14 | 0)) {
      f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
      f4 = Math_fround(HEAPF32[i15 >> 2]);
      f35 = Math_fround(f3 - f4);
      if (Math_fround(f35 * f35) > f27) if (f3 > f4) break; else break L80; else {
       i17 = HEAP32[i7 >> 2] | 0;
       i13 = HEAP32[i16 >> 2] | 0;
       f3 = Math_fround(HEAPF32[i13 + (i17 * 24 | 0) >> 2]);
       f4 = Math_fround(HEAPF32[i13 + (i17 * 24 | 0) + 4 >> 2]);
       f32 = Math_fround(HEAPF32[i13 + (i17 * 24 | 0) + 8 >> 2]);
       i17 = HEAP32[i8 >> 2] | 0;
       f33 = Math_fround(HEAPF32[i13 + (i17 * 24 | 0) >> 2]);
       f34 = Math_fround(HEAPF32[i13 + (i17 * 24 | 0) + 4 >> 2]);
       f3 = Math_fround(f3 - f10);
       f4 = Math_fround(f4 - f11);
       f32 = Math_fround(f32 - f12);
       f33 = Math_fround(f33 - f10);
       f34 = Math_fround(f34 - f11);
       f35 = Math_fround(Math_fround(HEAPF32[i13 + (i17 * 24 | 0) + 8 >> 2]) - f12);
       if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break; else break L80;
      }
     } else if ((i9 | 0) <= (i14 | 0)) break L80; while (0);
     i7 = i7 + 12 | 0;
    }
    while (1) {
     i13 = i6 + -12 | 0;
     i9 = HEAP32[i6 + -4 >> 2] | 0;
     if ((i9 | 0) != (i14 | 0)) if ((i9 | 0) > (i14 | 0)) break; else {
      i6 = i13;
      continue;
     }
     f3 = Math_fround(HEAPF32[i6 + -8 >> 2]);
     f4 = Math_fround(HEAPF32[i15 >> 2]);
     f35 = Math_fround(f3 - f4);
     if (Math_fround(f35 * f35) > f27) if (f3 > f4) break; else {
      i6 = i13;
      continue;
     } else {
      i17 = HEAP32[i13 >> 2] | 0;
      i9 = HEAP32[i16 >> 2] | 0;
      f3 = Math_fround(HEAPF32[i9 + (i17 * 24 | 0) >> 2]);
      f4 = Math_fround(HEAPF32[i9 + (i17 * 24 | 0) + 4 >> 2]);
      f32 = Math_fround(HEAPF32[i9 + (i17 * 24 | 0) + 8 >> 2]);
      i17 = HEAP32[i8 >> 2] | 0;
      f33 = Math_fround(HEAPF32[i9 + (i17 * 24 | 0) >> 2]);
      f34 = Math_fround(HEAPF32[i9 + (i17 * 24 | 0) + 4 >> 2]);
      f3 = Math_fround(f3 - f10);
      f4 = Math_fround(f4 - f11);
      f32 = Math_fround(f32 - f12);
      f33 = Math_fround(f33 - f10);
      f34 = Math_fround(f34 - f11);
      f35 = Math_fround(Math_fround(HEAPF32[i9 + (i17 * 24 | 0) + 8 >> 2]) - f12);
      if (Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break; else {
       i6 = i13;
       continue;
      }
     }
    }
    if (i7 >>> 0 > i13 >>> 0) {
     i9 = i7;
     break L77;
    };
    HEAP32[i26 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i26 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    i8 = (i8 | 0) == (i7 | 0) ? i13 : i8;
    i6 = i13;
    i7 = i7 + 12 | 0;
    i5 = i5 + 1 | 0;
   } else i9 = i7; while (0);
   L100 : do if ((i9 | 0) != (i8 | 0)) {
    i6 = HEAP32[i8 + 8 >> 2] | 0;
    i7 = HEAP32[i9 + 8 >> 2] | 0;
    do if ((i6 | 0) == (i7 | 0)) {
     f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
     f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
     f35 = Math_fround(f3 - f4);
     if (Math_fround(f35 * f35) > f27) if (f3 > f4) break; else break L100; else {
      i17 = HEAP32[i8 >> 2] | 0;
      i16 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      f11 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) >> 2]);
      f12 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) + 4 >> 2]);
      f32 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) + 8 >> 2]);
      i17 = HEAP32[i9 >> 2] | 0;
      f3 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) >> 2]);
      f4 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) + 4 >> 2]);
      f10 = Math_fround(HEAPF32[i16 + (i17 * 24 | 0) + 8 >> 2]);
      f33 = Math_fround(HEAPF32[i25 >> 2]);
      f11 = Math_fround(f11 - f33);
      f34 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(f12 - f34);
      f35 = Math_fround(HEAPF32[i30 >> 2]);
      f32 = Math_fround(f32 - f35);
      f33 = Math_fround(f3 - f33);
      f34 = Math_fround(f4 - f34);
      f35 = Math_fround(f10 - f35);
      if (Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break; else break L100;
     }
    } else if ((i6 | 0) <= (i7 | 0)) break L100; while (0);
    HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i26 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    i5 = i5 + 1 | 0;
   } while (0);
   if (!i5) {
    i5 = __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEbT0_S5_T_(i1, i9, i25) | 0;
    i6 = i9 + 12 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEbT0_S5_T_(i6, i2, i25) | 0) {
     i23 = 91;
     break;
    }
    if (i5) {
     i1 = i6;
     continue;
    }
   }
   i17 = i9;
   if ((i17 - i18 | 0) >= (i21 - i17 | 0)) {
    i23 = 90;
    break;
   }
   __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i1, i9, i25);
   i1 = i9 + 12 | 0;
  }
  if ((i23 | 0) == 90) {
   i23 = 0;
   __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i9 + 12 | 0, i2, i25);
   i2 = i9;
   continue;
  } else if ((i23 | 0) == 91) {
   i23 = 0;
   if (i5) {
    i23 = 92;
    break;
   } else {
    i2 = i9;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  i2 = HEAP32[i20 >> 2] | 0;
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  do if ((i2 | 0) == (i5 | 0)) {
   f3 = Math_fround(HEAPF32[i22 >> 2]);
   f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f35 = Math_fround(f3 - f4);
   if (Math_fround(f35 * f35) > f27) {
    if (f3 > f4) break;
    STACKTOP = i31;
    return;
   } else {
    i22 = HEAP32[i24 >> 2] | 0;
    i23 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    f12 = Math_fround(HEAPF32[i23 + (i22 * 24 | 0) >> 2]);
    f27 = Math_fround(HEAPF32[i23 + (i22 * 24 | 0) + 4 >> 2]);
    f32 = Math_fround(HEAPF32[i23 + (i22 * 24 | 0) + 8 >> 2]);
    i28 = HEAP32[i1 >> 2] | 0;
    f4 = Math_fround(HEAPF32[i23 + (i28 * 24 | 0) >> 2]);
    f10 = Math_fround(HEAPF32[i23 + (i28 * 24 | 0) + 4 >> 2]);
    f11 = Math_fround(HEAPF32[i23 + (i28 * 24 | 0) + 8 >> 2]);
    f33 = Math_fround(HEAPF32[i25 >> 2]);
    f12 = Math_fround(f12 - f33);
    f34 = Math_fround(HEAPF32[i29 >> 2]);
    f27 = Math_fround(f27 - f34);
    f35 = Math_fround(HEAPF32[i30 >> 2]);
    f32 = Math_fround(f32 - f35);
    f33 = Math_fround(f4 - f33);
    f34 = Math_fround(f10 - f34);
    f35 = Math_fround(f11 - f35);
    if (Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f27 * f27)) + Math_fround(f32 * f32)) < Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35))) break;
    STACKTOP = i31;
    return;
   }
  } else if ((i2 | 0) <= (i5 | 0)) {
   STACKTOP = i31;
   return;
  } while (0);
  HEAP32[i26 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  STACKTOP = i31;
  return;
 } else if ((i23 | 0) == 11) {
  __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i1 + 12 | 0, i24, i25) | 0;
  STACKTOP = i31;
  return;
 } else if ((i23 | 0) == 12) {
  __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i24, i25) | 0;
  STACKTOP = i31;
  return;
 } else if ((i23 | 0) == 13) {
  __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i1 + 36 | 0, i24, i25) | 0;
  STACKTOP = i31;
  return;
 } else if ((i23 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i1, i2, i25);
  STACKTOP = i31;
  return;
 } else if ((i23 | 0) == 92) {
  STACKTOP = i31;
  return;
 }
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i110, i3, i98, i1, i100, i99, i112, i113, i111, f2) {
 i110 = i110 | 0;
 i3 = i3 | 0;
 i98 = i98 | 0;
 i1 = i1 | 0;
 i100 = i100 | 0;
 i99 = i99 | 0;
 i112 = i112 | 0;
 i113 = i113 | 0;
 i111 = i111 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i114 = 0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, i120 = 0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0;
 i114 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i109 = i114 + 192 | 0;
 i104 = i114 + 288 | 0;
 i108 = i114 + 284 | 0;
 i103 = i114 + 208 | 0;
 i101 = i114 + 128 | 0;
 i102 = i114 + 64 | 0;
 i67 = i114 + 272 | 0;
 i68 = i114 + 48 | 0;
 i107 = i114 + 32 | 0;
 i105 = i114 + 16 | 0;
 i106 = i114;
 HEAP32[i109 >> 2] = 0;
 HEAP32[i109 + 4 >> 2] = 0;
 HEAP32[i109 + 8 >> 2] = 0;
 HEAP32[i109 + 12 >> 2] = 0;
 f4 = Math_fround(HEAPF32[i99 >> 2]);
 i77 = i99 + 4 | 0;
 f7 = Math_fround(HEAPF32[i77 >> 2]);
 i78 = i99 + 8 | 0;
 f13 = Math_fround(HEAPF32[i78 >> 2]);
 f5 = Math_fround(HEAPF32[i100 >> 2]);
 i87 = i100 + 4 | 0;
 f8 = Math_fround(HEAPF32[i87 >> 2]);
 i97 = i100 + 8 | 0;
 f9 = Math_fround(HEAPF32[i97 >> 2]);
 HEAP32[i108 >> 2] = 1;
 i69 = i98 + 48 | 0;
 f20 = Math_fround(HEAPF32[i69 >> 2]);
 i70 = i98 + 52 | 0;
 f23 = Math_fround(HEAPF32[i70 >> 2]);
 i76 = i98 + 56 | 0;
 f33 = Math_fround(HEAPF32[i76 >> 2]);
 i79 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f23 * f23)) + Math_fround(f33 * f33)) > Math_fround(1.1920929e-07);
 f26 = i79 ? f20 : Math_fround(1.0);
 f27 = i79 ? f23 : Math_fround(0.0);
 f6 = i79 ? f33 : Math_fround(0.0);
 f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f26 * f26) + Math_fround(f27 * f27))))));
 f26 = Math_fround(f26 * f28);
 f27 = Math_fround(f27 * f28);
 f28 = Math_fround(f6 * f28);
 f6 = Math_fround(-f26);
 f10 = Math_fround(-f27);
 f115 = Math_fround(-f28);
 f22 = Math_fround(HEAPF32[i98 >> 2]);
 f119 = Math_fround(f22 * f6);
 i79 = i98 + 4 | 0;
 f32 = Math_fround(HEAPF32[i79 >> 2]);
 f119 = Math_fround(f119 + Math_fround(f32 * f10));
 i80 = i98 + 8 | 0;
 f14 = Math_fround(HEAPF32[i80 >> 2]);
 f119 = Math_fround(f119 + Math_fround(f14 * f115));
 i81 = i98 + 16 | 0;
 f29 = Math_fround(HEAPF32[i81 >> 2]);
 f118 = Math_fround(f29 * f6);
 i82 = i98 + 20 | 0;
 f30 = Math_fround(HEAPF32[i82 >> 2]);
 f118 = Math_fround(f118 + Math_fround(f30 * f10));
 i83 = i98 + 24 | 0;
 f16 = Math_fround(HEAPF32[i83 >> 2]);
 f118 = Math_fround(f118 + Math_fround(f16 * f115));
 i84 = i98 + 32 | 0;
 f21 = Math_fround(HEAPF32[i84 >> 2]);
 f6 = Math_fround(f21 * f6);
 i85 = i98 + 36 | 0;
 f24 = Math_fround(HEAPF32[i85 >> 2]);
 f10 = Math_fround(f6 + Math_fround(f24 * f10));
 i86 = i98 + 40 | 0;
 f6 = Math_fround(HEAPF32[i86 >> 2]);
 f115 = Math_fround(f10 + Math_fround(f6 * f115));
 i88 = i110 + 96 | 0;
 f10 = Math_fround(HEAPF32[i88 >> 2]);
 i89 = i110 + 100 | 0;
 f12 = Math_fround(HEAPF32[i89 >> 2]);
 i90 = i110 + 104 | 0;
 f18 = Math_fround(HEAPF32[i90 >> 2]);
 i91 = i110 + 112 | 0;
 f11 = Math_fround(HEAPF32[i91 >> 2]);
 i92 = i110 + 116 | 0;
 f17 = Math_fround(HEAPF32[i92 >> 2]);
 i93 = i110 + 120 | 0;
 f19 = Math_fround(HEAPF32[i93 >> 2]);
 i94 = i110 + 128 | 0;
 f15 = Math_fround(HEAPF32[i94 >> 2]);
 i95 = i110 + 132 | 0;
 f31 = Math_fround(HEAPF32[i95 >> 2]);
 i96 = i110 + 136 | 0;
 f25 = Math_fround(HEAPF32[i96 >> 2]);
 f117 = Math_fround(Math_fround(Math_fround(f119 * f10) + Math_fround(f118 * f12)) + Math_fround(f115 * f18));
 f116 = Math_fround(Math_fround(Math_fround(f119 * f11) + Math_fround(f118 * f17)) + Math_fround(f115 * f19));
 f115 = Math_fround(Math_fround(Math_fround(f119 * f15) + Math_fround(f118 * f31)) + Math_fround(f115 * f25));
 i72 = f117 > f116 & f117 > f115;
 i71 = f116 > f115;
 f15 = i72 ? f10 : i71 ? f11 : f15;
 f31 = i72 ? f12 : i71 ? f17 : f31;
 f25 = i72 ? f18 : i71 ? f19 : f25;
 f29 = Math_fround(f20 + Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f22 * f15) + Math_fround(f29 * f31))));
 f30 = Math_fround(f23 + Math_fround(Math_fround(f24 * f25) + Math_fround(Math_fround(f32 * f15) + Math_fround(f30 * f31))));
 f31 = Math_fround(f33 + Math_fround(Math_fround(f6 * f25) + Math_fround(Math_fround(f14 * f15) + Math_fround(f16 * f31))));
 i71 = i3 + 96 | 0;
 f16 = Math_fround(HEAPF32[i71 >> 2]);
 i72 = i3 + 100 | 0;
 f15 = Math_fround(HEAPF32[i72 >> 2]);
 i73 = i3 + 104 | 0;
 f14 = Math_fround(HEAPF32[i73 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f26 * f16) + Math_fround(f27 * f15)) + Math_fround(f28 * f14));
 i74 = i3 + 112 | 0;
 f6 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i3 + 116 | 0;
 f33 = Math_fround(HEAPF32[i75 >> 2]);
 i58 = i3 + 120 | 0;
 f32 = Math_fround(HEAPF32[i58 >> 2]);
 i59 = f25 > Math_fround(Math_fround(Math_fround(f26 * f6) + Math_fround(f27 * f33)) + Math_fround(f28 * f32));
 f6 = i59 ? f16 : f6;
 f33 = i59 ? f15 : f33;
 f32 = i59 ? f14 : f32;
 f14 = Math_fround(f29 - f6);
 f15 = Math_fround(f30 - f33);
 f16 = Math_fround(f31 - f32);
 HEAPF32[i103 >> 2] = f14;
 i59 = i103 + 4 | 0;
 HEAPF32[i59 >> 2] = f15;
 i60 = i103 + 8 | 0;
 HEAPF32[i60 >> 2] = f16;
 i61 = i103 + 12 | 0;
 HEAPF32[i61 >> 2] = Math_fround(0.0);
 i62 = i103 + 16 | 0;
 HEAP32[i62 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i62 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i62 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i62 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i62 = i103 + 32 | 0;
 HEAP32[i62 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i62 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i62 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i62 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i62 = i103 + 48 | 0;
 HEAP32[i62 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i62 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i62 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i62 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAPF32[i101 >> 2] = f29;
 i62 = i101 + 4 | 0;
 HEAPF32[i62 >> 2] = f30;
 i63 = i101 + 8 | 0;
 HEAPF32[i63 >> 2] = f31;
 HEAPF32[i101 + 12 >> 2] = Math_fround(0.0);
 i64 = i101 + 16 | 0;
 HEAP32[i64 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i64 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i64 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i64 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i64 = i101 + 32 | 0;
 HEAP32[i64 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i64 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i64 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i64 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i64 = i101 + 48 | 0;
 HEAP32[i64 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i64 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i64 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i64 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAPF32[i102 >> 2] = f6;
 i64 = i102 + 4 | 0;
 HEAPF32[i64 >> 2] = f33;
 i65 = i102 + 8 | 0;
 HEAPF32[i65 >> 2] = f32;
 i66 = i102 + 12 | 0;
 HEAPF32[i66 >> 2] = Math_fround(0.0);
 i57 = i102 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i57 = i102 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i57 = i102 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 f32 = Math_fround(f2 + Math_fround(0.0));
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > Math_fround(0.0)) {
  i3 = i102 + 16 | 0;
  i34 = i102 + 20 | 0;
  i35 = i102 + 24 | 0;
  i36 = i102 + 28 | 0;
  i37 = i102 + 32 | 0;
  i38 = i102 + 36 | 0;
  i39 = i102 + 40 | 0;
  i40 = i102 + 44 | 0;
  i41 = i101 + 16 | 0;
  i42 = i101 + 20 | 0;
  i43 = i101 + 24 | 0;
  i44 = i103 + 16 | 0;
  i45 = i103 + 20 | 0;
  i46 = i103 + 24 | 0;
  i47 = i103 + 28 | 0;
  i48 = i101 + 32 | 0;
  i49 = i101 + 36 | 0;
  i50 = i101 + 40 | 0;
  i51 = i103 + 32 | 0;
  i52 = i103 + 36 | 0;
  i53 = i103 + 40 | 0;
  i54 = i103 + 44 | 0;
  i55 = i68 + 4 | 0;
  i56 = i68 + 8 | 0;
  i57 = i68 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f4 * Math_fround(0.0)) + f5);
  f30 = Math_fround(Math_fround(f7 * Math_fround(0.0)) + f8);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f17 = Math_fround(f10 * f18);
   f7 = Math_fround(f11 * f18);
   f18 = Math_fround(f12 * f18);
   f118 = Math_fround(-f17);
   f119 = Math_fround(-f7);
   f8 = Math_fround(-f18);
   f24 = Math_fround(HEAPF32[i98 >> 2]);
   f126 = Math_fround(f24 * f118);
   f14 = Math_fround(HEAPF32[i79 >> 2]);
   f126 = Math_fround(f126 + Math_fround(f14 * f119));
   f16 = Math_fround(HEAPF32[i80 >> 2]);
   f126 = Math_fround(f126 + Math_fround(f16 * f8));
   f25 = Math_fround(HEAPF32[i81 >> 2]);
   f125 = Math_fround(f25 * f118);
   f26 = Math_fround(HEAPF32[i82 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f26 * f119));
   f21 = Math_fround(HEAPF32[i83 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f21 * f8));
   f19 = Math_fround(HEAPF32[i84 >> 2]);
   f122 = Math_fround(f19 * f118);
   f15 = Math_fround(HEAPF32[i85 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f15 * f119));
   f9 = Math_fround(HEAPF32[i86 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f9 * f8));
   f121 = Math_fround(HEAPF32[i88 >> 2]);
   f115 = Math_fround(HEAPF32[i89 >> 2]);
   f23 = Math_fround(HEAPF32[i90 >> 2]);
   f13 = Math_fround(HEAPF32[i91 >> 2]);
   f116 = Math_fround(HEAPF32[i92 >> 2]);
   f117 = Math_fround(HEAPF32[i93 >> 2]);
   f20 = Math_fround(HEAPF32[i94 >> 2]);
   f27 = Math_fround(HEAPF32[i95 >> 2]);
   f22 = Math_fround(HEAPF32[i96 >> 2]);
   f124 = Math_fround(Math_fround(Math_fround(f126 * f121) + Math_fround(f125 * f115)) + Math_fround(f122 * f23));
   f123 = Math_fround(Math_fround(Math_fround(f126 * f13) + Math_fround(f125 * f116)) + Math_fround(f122 * f117));
   f122 = Math_fround(Math_fround(Math_fround(f126 * f20) + Math_fround(f125 * f27)) + Math_fround(f122 * f22));
   i120 = f124 > f123 & f124 > f122;
   i1 = f123 > f122;
   f20 = i120 ? f121 : i1 ? f13 : f20;
   f27 = i120 ? f115 : i1 ? f116 : f27;
   f22 = i120 ? f23 : i1 ? f117 : f22;
   f117 = Math_fround(HEAPF32[i69 >> 2]);
   f23 = Math_fround(HEAPF32[i70 >> 2]);
   f25 = Math_fround(f117 + Math_fround(Math_fround(f19 * f22) + Math_fround(Math_fround(f24 * f20) + Math_fround(f25 * f27))));
   f26 = Math_fround(f23 + Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f14 * f20) + Math_fround(f26 * f27))));
   f27 = Math_fround(Math_fround(HEAPF32[i76 >> 2]) + Math_fround(Math_fround(f9 * f22) + Math_fround(Math_fround(f16 * f20) + Math_fround(f21 * f27))));
   f21 = Math_fround(HEAPF32[i71 >> 2]);
   f20 = Math_fround(HEAPF32[i72 >> 2]);
   f16 = Math_fround(HEAPF32[i73 >> 2]);
   f22 = Math_fround(Math_fround(Math_fround(f17 * f21) + Math_fround(f7 * f20)) + Math_fround(f18 * f16));
   f9 = Math_fround(HEAPF32[i74 >> 2]);
   f14 = Math_fround(HEAPF32[i75 >> 2]);
   f15 = Math_fround(HEAPF32[i58 >> 2]);
   i1 = f22 > Math_fround(Math_fround(Math_fround(f17 * f9) + Math_fround(f7 * f14)) + Math_fround(f18 * f15));
   f9 = i1 ? f21 : f9;
   f14 = i1 ? f20 : f14;
   f15 = i1 ? f16 : f15;
   f16 = Math_fround(f31 + f9);
   f20 = Math_fround(f30 + f14);
   f21 = Math_fround(f29 + f15);
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f18 * f24) + Math_fround(Math_fround(f17 * f22) + Math_fround(f7 * f23))) - f32);
   f17 = Math_fround(HEAPF32[i99 >> 2]);
   f18 = Math_fround(HEAPF32[i77 >> 2]);
   f19 = Math_fround(HEAPF32[i78 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f118) + Math_fround(f18 * f119)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i104 >> 2] = HEAP32[i67 >> 2];
    HEAP32[i104 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
    HEAP32[i104 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f126 = Math_fround(HEAPF32[i100 >> 2]);
     f125 = Math_fround(HEAPF32[i87 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f126);
     f18 = Math_fround(Math_fround(f13 * f18) + f125);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i97 >> 2]));
     f125 = Math_fround(f17 - f31);
     f126 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i102 >> 2]);
     f4 = Math_fround(HEAPF32[i64 >> 2]);
     f2 = Math_fround(f125 + f2);
     f4 = Math_fround(f126 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i65 >> 2]));
     f22 = Math_fround(HEAPF32[i3 >> 2]);
     f21 = Math_fround(HEAPF32[i34 >> 2]);
     f22 = Math_fround(f125 + f22);
     f21 = Math_fround(f126 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i35 >> 2]));
     f16 = Math_fround(HEAPF32[i37 >> 2]);
     f7 = Math_fround(HEAPF32[i38 >> 2]);
     f16 = Math_fround(f125 + f16);
     f7 = Math_fround(f126 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i102 >> 2] = f2;
     HEAPF32[i64 >> 2] = f4;
     HEAPF32[i65 >> 2] = f5;
     HEAPF32[i66 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f22;
     HEAPF32[i34 >> 2] = f21;
     HEAPF32[i35 >> 2] = f20;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f16;
     HEAPF32[i38 >> 2] = f7;
     HEAPF32[i39 >> 2] = f8;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f126 = Math_fround(HEAPF32[i101 >> 2]);
     f125 = Math_fround(HEAPF32[i62 >> 2]);
     f4 = Math_fround(f125 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) - f5);
     HEAPF32[i103 >> 2] = Math_fround(f126 - f2);
     HEAPF32[i59 >> 2] = f4;
     HEAPF32[i60 >> 2] = f5;
     HEAPF32[i61 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i41 >> 2]);
     f4 = Math_fround(HEAPF32[i42 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f20);
     HEAPF32[i44 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i45 >> 2] = f21;
     HEAPF32[i46 >> 2] = f20;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i48 >> 2]);
     f21 = Math_fround(HEAPF32[i49 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f8);
     HEAPF32[i51 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i52 >> 2] = f7;
     HEAPF32[i53 >> 2] = f8;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f14);
     f7 = Math_fround(f19 + f15);
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i120 = HEAP32[i108 >> 2] | 0;
   HEAPF32[i101 + (i120 << 4) >> 2] = f25;
   HEAPF32[i101 + (i120 << 4) + 4 >> 2] = f26;
   HEAPF32[i101 + (i120 << 4) + 8 >> 2] = f27;
   HEAPF32[i101 + (i120 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i102 + (i120 << 4) >> 2] = f16;
   HEAPF32[i102 + (i120 << 4) + 4 >> 2] = f20;
   HEAPF32[i102 + (i120 << 4) + 8 >> 2] = f21;
   HEAPF32[i102 + (i120 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i108 >> 2] = i120 + 1;
   HEAPF32[i103 + (i120 << 4) >> 2] = f9;
   HEAPF32[i103 + (i120 << 4) + 4 >> 2] = f8;
   HEAPF32[i103 + (i120 << 4) + 8 >> 2] = f7;
   HEAPF32[i103 + (i120 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i120 | 0) {
   case 0:
    {
     HEAPF32[i68 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i103 >> 2]);
     f7 = Math_fround(HEAPF32[i59 >> 2]);
     f8 = Math_fround(HEAPF32[i60 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f124 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i120 = f124 > Math_fround(1.0);
      f124 = i120 ? Math_fround(1.0) : f124;
      i120 = f124 > Math_fround(0.0);
      f124 = i120 ? f124 : Math_fround(0.0);
      f125 = Math_fround(f7 + Math_fround(f14 * f124));
      f126 = Math_fround(f8 + Math_fround(f15 * f124));
      HEAPF32[i68 >> 2] = Math_fround(f6 + Math_fround(f9 * f124));
      HEAPF32[i55 >> 2] = f125;
      HEAPF32[i56 >> 2] = f126;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i108 >> 2] = 1;
      HEAP32[i68 >> 2] = HEAP32[i103 >> 2];
      HEAP32[i68 + 4 >> 2] = HEAP32[i103 + 4 >> 2];
      HEAP32[i68 + 8 >> 2] = HEAP32[i103 + 8 >> 2];
      HEAP32[i68 + 12 >> 2] = HEAP32[i103 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i68, i103, i101, i102, i108);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i68, i103, i101, i102, i108);
     break;
    }
   default:
    {
     HEAPF32[i68 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i68 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i114;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i99 = HEAP32[i110 + 64 >> 2] | 0;
 i100 = HEAP32[i110 + 68 >> 2] | 0;
 i120 = HEAP32[i110 + 72 >> 2] | 0;
 i98 = f6 > Math_fround(0.0) & i1;
 f121 = i98 ? f7 : f2;
 f123 = i98 ? f8 : f4;
 f125 = i98 ? f9 : f5;
 f119 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f125 * f125) + Math_fround(Math_fround(f123 * f123) + Math_fround(f121 * f121))))));
 f121 = Math_fround(f121 * f119);
 f123 = Math_fround(f123 * f119);
 f119 = Math_fround(f125 * f119);
 HEAPF32[i113 >> 2] = f121;
 HEAPF32[i113 + 4 >> 2] = f123;
 HEAPF32[i113 + 8 >> 2] = f119;
 HEAPF32[i113 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i112 >> 2] = f13;
 i113 = i112 + 4 | 0;
 HEAP32[i113 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i113 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i113 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAPF32[i107 >> 2] = i1 ? f7 : f10;
 HEAPF32[i107 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i107 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i107 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i105 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i105 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i105 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i105 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAP32[i106 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i106 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i106 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i106 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i103, i101, i102, i107, i105, i106, HEAP32[i108 >> 2] | 0);
 f125 = Math_fround(HEAPF32[i110 + 16 >> 2]);
 f122 = Math_fround(HEAPF32[i105 >> 2]);
 f124 = Math_fround(HEAPF32[i105 + 4 >> 2]);
 f126 = Math_fround(HEAPF32[i105 + 8 >> 2]);
 f121 = Math_fround(f122 - Math_fround(f121 * f125));
 f123 = Math_fround(f124 - Math_fround(f123 * f125));
 f125 = Math_fround(f126 - Math_fround(f119 * f125));
 HEAPF32[i111 >> 2] = i99 | 0 ? f121 : f122;
 HEAPF32[i111 + 4 >> 2] = i100 | 0 ? f123 : f124;
 HEAPF32[i111 + 8 >> 2] = i120 | 0 ? f125 : f126;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 i120 = 1;
 STACKTOP = i114;
 return i120 | 0;
}

function __ZN5Umbra10PathFinder4findERNS_7ImpPathERKNS_7Vector3ES5_(i81, i82, i83, i84) {
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i85 = 0, f86 = f0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i85 + 56 | 0;
 i2 = i85 + 48 | 0;
 i74 = i85 + 32 | 0;
 i75 = i85 + 8 | 0;
 i76 = i85 + 16 | 0;
 i77 = i85;
 i71 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(HEAP32[i81 >> 2] | 0, i84) | 0;
 i73 = HEAP32[i81 >> 2] | 0;
 i72 = HEAP32[(HEAP32[i73 >> 2] | 0) + 92 >> 2] | 0;
 i73 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i73, i83) | 0;
 i1 = HEAP32[i81 >> 2] | 0;
 if ((i71 | 0) == -1 | (i73 | 0) == -1) {
  HEAP32[i1 + 28 >> 2] = 5;
  STACKTOP = i85;
  return;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i8 + 92 >> 2] | 0;
 i4 = HEAP32[i8 + 96 >> 2] | 0;
 i5 = HEAP32[i8 + 100 >> 2] | 0;
 i6 = HEAP32[i8 + 104 >> 2] | 0;
 i7 = HEAP32[i8 + 112 >> 2] | 0;
 i8 = HEAP32[i8 + 116 >> 2] | 0;
 i69 = i81 + 148 | 0;
 _memset(HEAP32[i81 + 152 >> 2] | 0, 0, (HEAP32[i81 + 160 >> 2] | 0) + 31 >> 5 << 3 | 0) | 0;
 i70 = i81 + 24172 | 0;
 HEAP32[i2 >> 2] = HEAPU16[i70 >> 1];
 HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
 HEAP32[i78 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i69, i78, Math_fround(0.0)) | 0;
 i46 = i81 + 24168 | 0;
 HEAP16[(HEAP32[i46 >> 2] | 0) + (HEAPU16[i70 >> 1] << 1) >> 1] = -1;
 i47 = i81 + 164 | 0;
 i1 = HEAP32[i47 >> 2] | 0;
 L5 : do if (i1 | 0) {
  i48 = i81 + 168 | 0;
  i49 = i81 + 8168 | 0;
  i42 = i81 + 8168 | 0;
  i43 = i81 + 8172 | 0;
  i50 = i81 + 156 | 0;
  i80 = i81 + 24174 | 0;
  i40 = i83 + 4 | 0;
  i38 = i83 + 8 | 0;
  i51 = i81 + 36 | 0;
  i52 = i81 + 8 | 0;
  i53 = i81 + 72 | 0;
  i54 = i81 + 44 | 0;
  i55 = i81 + 108 | 0;
  i56 = i81 + 80 | 0;
  i57 = i81 + 144 | 0;
  i58 = i81 + 116 | 0;
  i59 = i84 + 4 | 0;
  i60 = i84 + 8 | 0;
  i45 = i75 + 4 | 0;
  i61 = i81 + 24 | 0;
  i62 = i81 + 60 | 0;
  i63 = i81 + 96 | 0;
  i64 = i76 + 4 | 0;
  i65 = i76 + 8 | 0;
  i44 = i77 + 4 | 0;
  i66 = i74 + 8 | 0;
  i67 = i81 + 132 | 0;
  i41 = i74 + 4 | 0;
  i39 = i74 + 8 | 0;
  i68 = i78 + 4 | 0;
  L7 : while (1) {
   i18 = HEAP32[i48 >> 2] | 0;
   i19 = HEAP32[i42 >> 2] | 0;
   i37 = HEAP32[i43 >> 2] | 0;
   i15 = HEAP32[i49 >> 2] | 0;
   i10 = i1 + -1 | 0;
   HEAP32[i47 >> 2] = i10;
   if (i10 | 0) {
    f14 = Math_fround(HEAPF32[i81 + 168 + (i10 << 2) >> 2]);
    i12 = i81 + 8168 + (i10 << 3) | 0;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    L11 : do if ((i10 | 0) > 1) {
     i9 = 0;
     i2 = 1;
     while (1) {
      i1 = i2 + 1 | 0;
      if ((i1 | 0) < (i10 | 0)) {
       f36 = Math_fround(HEAPF32[i81 + 168 + (i1 << 2) >> 2]);
       if (!(f36 <= Math_fround(HEAPF32[i81 + 168 + (i2 << 2) >> 2]))) i1 = i2;
      } else i1 = i2;
      f13 = Math_fround(HEAPF32[i81 + 168 + (i1 << 2) >> 2]);
      if (f14 <= f13) {
       i1 = i9;
       break L11;
      }
      HEAPF32[i81 + 168 + (i9 << 2) >> 2] = f13;
      i33 = i81 + 8168 + (i1 << 3) | 0;
      i34 = HEAP32[i33 + 4 >> 2] | 0;
      i2 = i81 + 8168 + (i9 << 3) | 0;
      HEAP32[i2 >> 2] = HEAP32[i33 >> 2];
      HEAP32[i2 + 4 >> 2] = i34;
      i2 = i1 << 1 | 1;
      if ((i2 | 0) >= (i10 | 0)) break; else i9 = i1;
     }
    } else i1 = 0; while (0);
    HEAPF32[i81 + 168 + (i1 << 2) >> 2] = f14;
    i34 = i81 + 8168 + (i1 << 3) | 0;
    HEAP32[i34 >> 2] = i11;
    HEAP32[i34 + 4 >> 2] = i12;
   }
   i1 = (HEAP32[i50 >> 2] | 0) + (i15 >> 5 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i15 & 31);
   i1 = HEAP16[i80 >> 1] | 0;
   if ((i19 | 0) == (i1 & 65535 | 0)) {
    i79 = 14;
    break;
   }
   if ((i19 | 0) == (HEAPU16[i70 >> 1] | 0)) {
    f13 = Math_fround(HEAPF32[i83 >> 2]);
    f17 = Math_fround(HEAPF32[i40 >> 2]);
    f14 = Math_fround(HEAPF32[i38 >> 2]);
    i10 = i5;
    i11 = i10 + 128 | 0;
    i16 = HEAP32[i11 >> 2] | 0;
    i12 = i10 + 124 | 0;
    i15 = i5;
    HEAP32[i51 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i52 >> 2] = (i16 | 0) == 0 ? 0 : i15 + i16 | 0;
    i16 = (i4 | 0) == 0;
    if (i16) {
     i9 = 0;
     i1 = 0;
     i2 = 0;
    } else {
     i1 = HEAP32[i4 + 20 >> 2] | 0;
     if (!i1) {
      i9 = 0;
      i1 = 0;
      i2 = 0;
     } else {
      i9 = i6;
      i2 = HEAP32[i12 >> 2] | 0;
     }
    }
    HEAP32[i53 >> 2] = i2;
    HEAP32[i54 >> 2] = (i1 | 0) == 0 ? 0 : i9 + i1 | 0;
    i2 = HEAP32[i10 + 132 >> 2] | 0;
    i9 = i10 + 180 | 0;
    if (!(HEAP32[i9 >> 2] | 0)) {
     i1 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
     i34 = i15 + (HEAP32[i11 >> 2] | 0) | 0;
     i1 = (HEAP32[i34 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i1 * 20 | 0) >> 2] | 0) | 0;
    } else i1 = HEAP32[i15 + (HEAP32[i10 + 184 >> 2] | 0) + (HEAP32[i10 + 176 >> 2] << 2) >> 2] | 0;
    HEAP32[i55 >> 2] = i1;
    HEAP32[i56 >> 2] = (i2 | 0) == 0 ? 0 : i15 + i2 | 0;
    if (i16) {
     i2 = 0;
     i9 = 0;
     i1 = 0;
    } else {
     if (!(HEAP32[i9 >> 2] | 0)) {
      i1 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
      i34 = i15 + (HEAP32[i11 >> 2] | 0) | 0;
      i1 = (HEAP32[i34 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i1 * 20 | 0) >> 2] | 0) | 0;
     } else i1 = HEAP32[i15 + (HEAP32[i10 + 184 >> 2] | 0) + (HEAP32[i10 + 176 >> 2] << 2) >> 2] | 0;
     i2 = i6;
     i9 = HEAP32[i4 + 24 >> 2] | 0;
     i1 = i8 - i1 | 0;
    }
    HEAP32[i57 >> 2] = i1;
    HEAP32[i58 >> 2] = (i9 | 0) == 0 ? 0 : i2 + i9 | 0;
    i2 = i73;
    f36 = f13;
    f35 = f14;
   } else {
    HEAP32[i78 >> 2] = 0;
    HEAP32[i78 + 4 >> 2] = 0;
    HEAP32[i78 + 8 >> 2] = 0;
    HEAP32[i78 + 12 >> 2] = 0;
    i9 = __ZN5Umbra10QueryState23findTomeByClusterPortalEi(HEAP32[HEAP32[i81 >> 2] >> 2] | 0, i19) | 0;
    if ((i9 | 0) == (i3 | 0)) {
     i9 = i3;
     i1 = i4;
    } else {
     i2 = HEAP32[HEAP32[i81 >> 2] >> 2] | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if ((i9 | 0) != -1 & (i1 | 0) != 0) {
      i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i9 << 5)) | 0;
      if (!i1) i79 = 35; else {
       i5 = HEAP32[i1 >> 2] | 0;
       i6 = HEAP32[i2 >> 2] | 0;
       i34 = HEAP32[i6 + (HEAP32[i6 + 180 >> 2] | 0) + (i9 << 2) >> 2] | 0;
       i8 = i6 + (HEAP32[i6 + 184 >> 2] | 0) | 0;
       i7 = HEAP32[i8 + (i9 << 2) >> 2] | 0;
       i8 = (HEAP32[i8 + (i9 + 1 << 2) >> 2] | 0) - i7 | 0;
       HEAP32[i2 + 92 >> 2] = i9;
       HEAP32[i2 + 96 >> 2] = i1;
       HEAP32[i2 + 100 >> 2] = i5;
       HEAP32[i2 + 104 >> 2] = i6;
       HEAP32[i2 + 108 >> 2] = i34;
       HEAP32[i2 + 112 >> 2] = i7;
       HEAP32[i2 + 116 >> 2] = i8;
      }
     } else i79 = 35;
     if ((i79 | 0) == 35) {
      i79 = 0;
      i6 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 + 92 >> 2] = 0;
      HEAP32[i2 + 96 >> 2] = 0;
      HEAP32[i2 + 100 >> 2] = i6;
      HEAP32[i2 + 104 >> 2] = i6;
      HEAP32[i2 + 108 >> 2] = 0;
      HEAP32[i2 + 112 >> 2] = 0;
      HEAP32[i2 + 116 >> 2] = 0;
      i9 = 0;
      i1 = 0;
      i5 = i6;
      i7 = 0;
      i8 = 0;
     }
     i4 = i5;
     i10 = i5;
     i11 = HEAP32[i4 + 132 >> 2] | 0;
     i12 = i4 + 180 | 0;
     if (!(HEAP32[i12 >> 2] | 0)) {
      i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
      i34 = i10 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
      i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i10 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
     HEAP32[i55 >> 2] = i2;
     HEAP32[i56 >> 2] = (i11 | 0) == 0 ? 0 : i10 + i11 | 0;
     if (!i1) {
      i4 = 0;
      i10 = 0;
      i2 = 0;
     } else {
      if (!(HEAP32[i12 >> 2] | 0)) {
       i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
       i34 = i10 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
       i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
      } else i2 = HEAP32[i10 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
      i4 = i6;
      i10 = HEAP32[i1 + 24 >> 2] | 0;
      i2 = i8 - i2 | 0;
     }
     HEAP32[i57 >> 2] = i2;
     HEAP32[i58 >> 2] = (i10 | 0) == 0 ? 0 : i4 + i10 | 0;
    }
    i10 = i19 - ((i1 | 0) == 0 ? 0 : i7) | 0;
    i11 = i5;
    i4 = (HEAP32[i11 + 180 >> 2] | 0) == 0;
    if (i4) {
     i2 = (HEAP32[i11 + 124 >> 2] | 0) + -1 | 0;
     i34 = i5 + (HEAP32[i11 + 128 >> 2] | 0) | 0;
     i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
    } else i2 = HEAP32[i5 + (HEAP32[i11 + 184 >> 2] | 0) + (HEAP32[i11 + 176 >> 2] << 2) >> 2] | 0;
    if ((i10 | 0) < (i2 | 0)) {
     i4 = (HEAP32[i56 >> 2] | 0) + (Math_imul(HEAP32[i63 >> 2] | 0, i10) | 0) | 0;
     HEAP32[i78 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i78 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i78 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i78 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     i4 = i9;
    } else {
     if (i4) {
      i2 = (HEAP32[i11 + 124 >> 2] | 0) + -1 | 0;
      i34 = i5 + (HEAP32[i11 + 128 >> 2] | 0) | 0;
      i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i5 + (HEAP32[i11 + 184 >> 2] | 0) + (HEAP32[i11 + 176 >> 2] << 2) >> 2] | 0;
     i4 = (HEAP32[i58 >> 2] | 0) + (Math_imul(HEAP32[i67 >> 2] | 0, i10 - i2 | 0) | 0) | 0;
     HEAP32[i78 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i78 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i78 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i78 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     i4 = (HEAP32[i68 >> 2] | 0) >>> 16;
    }
    i15 = HEAP32[i78 >> 2] & 67108863;
    __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i74, i11, i78);
    f13 = Math_fround(HEAPF32[i74 >> 2]);
    f17 = Math_fround(HEAPF32[i41 >> 2]);
    f14 = Math_fround(HEAPF32[i39 >> 2]);
    if ((i4 | 0) != (i9 | 0)) {
     i2 = HEAP32[HEAP32[i81 >> 2] >> 2] | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if ((i4 | 0) != -1 & (i1 | 0) != 0) {
      i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i4 << 5)) | 0;
      if (!i1) i79 = 58; else {
       i5 = HEAP32[i1 >> 2] | 0;
       i6 = HEAP32[i2 >> 2] | 0;
       i9 = HEAP32[i6 + (HEAP32[i6 + 180 >> 2] | 0) + (i4 << 2) >> 2] | 0;
       i8 = i6 + (HEAP32[i6 + 184 >> 2] | 0) | 0;
       i7 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
       i8 = (HEAP32[i8 + (i4 + 1 << 2) >> 2] | 0) - i7 | 0;
       HEAP32[i2 + 92 >> 2] = i4;
       HEAP32[i2 + 96 >> 2] = i1;
       HEAP32[i2 + 100 >> 2] = i5;
       HEAP32[i2 + 104 >> 2] = i6;
       HEAP32[i2 + 108 >> 2] = i9;
       HEAP32[i2 + 112 >> 2] = i7;
       HEAP32[i2 + 116 >> 2] = i8;
       i9 = i4;
      }
     } else i79 = 58;
     if ((i79 | 0) == 58) {
      i79 = 0;
      i6 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 + 92 >> 2] = 0;
      HEAP32[i2 + 96 >> 2] = 0;
      HEAP32[i2 + 100 >> 2] = i6;
      HEAP32[i2 + 104 >> 2] = i6;
      HEAP32[i2 + 108 >> 2] = 0;
      HEAP32[i2 + 112 >> 2] = 0;
      HEAP32[i2 + 116 >> 2] = 0;
      i9 = 0;
      i1 = 0;
      i5 = i6;
      i7 = 0;
      i8 = 0;
     }
     i4 = i5;
     i10 = i5;
     i11 = HEAP32[i4 + 132 >> 2] | 0;
     i12 = i4 + 180 | 0;
     if (!(HEAP32[i12 >> 2] | 0)) {
      i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
      i34 = i10 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
      i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i10 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
     HEAP32[i55 >> 2] = i2;
     HEAP32[i56 >> 2] = (i11 | 0) == 0 ? 0 : i10 + i11 | 0;
     if (!i1) {
      i4 = 0;
      i10 = 0;
      i2 = 0;
     } else {
      if (!(HEAP32[i12 >> 2] | 0)) {
       i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
       i34 = i10 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
       i2 = (HEAP32[i34 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i34 + (i2 * 20 | 0) >> 2] | 0) | 0;
      } else i2 = HEAP32[i10 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
      i4 = i6;
      i10 = HEAP32[i1 + 24 >> 2] | 0;
      i2 = i8 - i2 | 0;
     }
     HEAP32[i57 >> 2] = i2;
     HEAP32[i58 >> 2] = (i10 | 0) == 0 ? 0 : i4 + i10 | 0;
    }
    if ((i9 | 0) != (i3 | 0)) {
     i4 = i5;
     i34 = HEAP32[i4 + 128 >> 2] | 0;
     i4 = i4 + 124 | 0;
     HEAP32[i51 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i52 >> 2] = (i34 | 0) == 0 ? 0 : i5 + i34 | 0;
     if (!i1) {
      i10 = 0;
      i3 = 0;
      i2 = 0;
     } else {
      i2 = HEAP32[i1 + 20 >> 2] | 0;
      if (!i2) {
       i10 = 0;
       i3 = 0;
       i2 = 0;
      } else {
       i10 = i6;
       i3 = i2;
       i2 = HEAP32[i4 >> 2] | 0;
      }
     }
     HEAP32[i53 >> 2] = i2;
     HEAP32[i54 >> 2] = (i3 | 0) == 0 ? 0 : i10 + i3 | 0;
    }
    i2 = i15;
    f36 = f13;
    i3 = i9;
    f35 = f14;
    i4 = i1;
   }
   if ((i3 | 0) == (i72 | 0) & (i2 | 0) == (i71 | 0)) {
    i1 = HEAPU16[i80 >> 1] | 0;
    f14 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f27 = Math_fround(Math_fround(HEAPF32[i84 >> 2]) - f36);
    f28 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) - f17);
    f36 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f35);
    f36 = Math_fround(f13 + Math_fround(f14 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28)) + Math_fround(f36 * f36))))));
    HEAP32[i75 >> 2] = i1;
    HEAP32[i45 >> 2] = i37;
    HEAP32[i78 >> 2] = HEAP32[i75 >> 2];
    HEAP32[i78 + 4 >> 2] = HEAP32[i75 + 4 >> 2];
    if (__ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i69, i78, f36) | 0) HEAP16[(HEAP32[i46 >> 2] | 0) + (i1 << 1) >> 1] = i19;
    i1 = HEAP32[i47 >> 2] | 0;
    if ((i1 | 0) > 1999) {
     i79 = 80;
     break;
    }
   } else {
    i34 = (HEAP32[i52 >> 2] | 0) + (Math_imul(HEAP32[i61 >> 2] | 0, i2) | 0) | 0;
    i33 = HEAP32[i34 >> 2] | 0;
    i34 = HEAP32[i34 + 4 >> 2] | 0;
    if (!(HEAP32[i53 >> 2] | 0)) {
     i32 = 0;
     i1 = 0;
    } else {
     i1 = (HEAP32[i54 >> 2] | 0) + (Math_imul(HEAP32[i62 >> 2] | 0, i2) | 0) | 0;
     i32 = HEAP32[i1 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    i29 = i1 + i34 | 0;
    if ((i29 | 0) > 0) {
     i30 = (i4 | 0) == 0 ? 0 : i7;
     i31 = i5;
     f27 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f28 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i20 = i19 & 65535;
     i21 = i31 + 180 | 0;
     i22 = i31 + 128 | 0;
     i23 = i31 + 124 | 0;
     i24 = i5;
     i25 = i31 + 184 | 0;
     i26 = i31 + 176 | 0;
     i19 = 0;
     do {
      HEAP32[i74 >> 2] = 0;
      HEAP32[i74 + 4 >> 2] = 0;
      HEAP32[i74 + 8 >> 2] = 0;
      HEAP32[i74 + 12 >> 2] = 0;
      if ((i19 | 0) < (i34 | 0)) {
       i18 = i19 + i33 | 0;
       i16 = (HEAP32[i56 >> 2] | 0) + (Math_imul(HEAP32[i63 >> 2] | 0, i18) | 0) | 0;
       HEAP32[i74 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i74 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
       HEAP32[i74 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
       HEAP32[i74 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
       i18 = i18 + i30 | 0;
      } else {
       i2 = i19 - i34 + i32 | 0;
       i18 = (HEAP32[i58 >> 2] | 0) + (Math_imul(HEAP32[i67 >> 2] | 0, i2) | 0) | 0;
       HEAP32[i74 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i74 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
       HEAP32[i74 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
       HEAP32[i74 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
       if (!(HEAP32[i21 >> 2] | 0)) {
        i1 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
        i18 = i24 + (HEAP32[i22 >> 2] | 0) | 0;
        i1 = (HEAP32[i18 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i18 + (i1 * 20 | 0) >> 2] | 0) | 0;
       } else i1 = HEAP32[i24 + (HEAP32[i25 >> 2] | 0) + (HEAP32[i26 >> 2] << 2) >> 2] | 0;
       i18 = i2 + i30 + i1 | 0;
      }
      L121 : do if (!(1 << (i18 & 31) & HEAP32[(HEAP32[i50 >> 2] | 0) + (i18 >> 5 << 2) >> 2])) {
       i2 = HEAP32[i81 >> 2] | 0;
       i1 = HEAP32[i74 >> 2] | 0;
       if (!(i1 & 268435456)) {
        L124 : do if (i1 & 134217728 | 0) {
         i1 = HEAP32[i66 >> 2] | 0;
         i15 = i1 & 4095;
         if (i15 | 0) {
          i2 = HEAP32[i2 >> 2] | 0;
          i11 = HEAP32[i2 + 100 >> 2] | 0;
          i10 = i1 >>> 12;
          i11 = i11 + (HEAP32[i11 + 120 >> 2] | 0) | 0;
          i16 = HEAP32[i2 + 96 >> 2] | 0;
          i12 = HEAP32[i2 + 12 >> 2] | 0;
          i1 = (i12 | 0) == 0;
          i2 = i2 + 104 | 0;
          i9 = i16 + 16 | 0;
          if (!i16) {
           if (i1) break; else i1 = 0;
           while (1) {
            i2 = HEAP32[i11 + (i1 + i10 << 2) >> 2] | 0;
            if ((i2 | 0) >= 0) if (!(HEAP32[i12 + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31))) {
             i79 = 123;
             break L121;
            }
            i1 = i1 + 1 | 0;
            if ((i1 | 0) >= (i15 | 0)) break L124;
           }
          }
          if (i1) break;
          i2 = (HEAP32[i2 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
          i1 = 0;
          do {
           i9 = HEAP32[i2 + (HEAP32[i11 + (i1 + i10 << 2) >> 2] << 2) >> 2] | 0;
           if ((i9 | 0) >= 0) if (!(HEAP32[i12 + (i9 >> 5 << 2) >> 2] & 1 << (i9 & 31))) {
            i79 = 123;
            break L121;
           }
           i1 = i1 + 1 | 0;
          } while ((i1 | 0) < (i15 | 0));
         }
        } while (0);
        __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i76, i31, i74);
        f86 = Math_fround(Math_fround(HEAPF32[i76 >> 2]) - f36);
        f14 = Math_fround(Math_fround(HEAPF32[i64 >> 2]) - f17);
        f13 = Math_fround(Math_fround(HEAPF32[i65 >> 2]) - f35);
        f13 = Math_fround(f27 + Math_fround(f28 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f86 * f86) + Math_fround(f14 * f14)) + Math_fround(f13 * f13))))));
        i15 = HEAP32[i81 >> 2] | 0;
        do if (!(HEAP32[i74 >> 2] & 134217728)) i1 = i37; else {
         i16 = HEAP32[i15 >> 2] | 0;
         i11 = HEAP32[i16 + 16 >> 2] | 0;
         if (!i11) {
          i1 = i37;
          break;
         }
         i1 = HEAP32[i66 >> 2] | 0;
         i12 = i1 & 4095;
         L145 : do if (!i12) f14 = Math_fround(0.0); else {
          i10 = HEAP32[i16 + 100 >> 2] | 0;
          i9 = i1 >>> 12;
          i10 = i10 + (HEAP32[i10 + 120 >> 2] | 0) | 0;
          i1 = HEAP32[i16 + 96 >> 2] | 0;
          if (!i1) {
           f14 = Math_fround(0.0);
           i1 = 0;
           while (1) {
            f14 = Math_fround(f14 + Math_fround(HEAPF32[i11 + (HEAP32[i10 + (i1 + i9 << 2) >> 2] << 2) >> 2]));
            i1 = i1 + 1 | 0;
            if ((i1 | 0) == (i12 | 0)) break L145;
           }
          }
          i2 = (HEAP32[i16 + 104 >> 2] | 0) + (HEAP32[i1 + 16 >> 2] | 0) | 0;
          f14 = Math_fround(0.0);
          i1 = 0;
          do {
           f14 = Math_fround(f14 + Math_fround(HEAPF32[i11 + (HEAP32[i2 + (HEAP32[i10 + (i1 + i9 << 2) >> 2] << 2) >> 2] << 2) >> 2]));
           i1 = i1 + 1 | 0;
          } while ((i1 | 0) != (i12 | 0));
         } while (0);
         if (!(HEAP8[i16 + 20 >> 0] | 0)) {
          if (f14 < Math_fround(1.0)) {
           i79 = 114;
           break L7;
          }
          f86 = Math_fround(f28 * f14);
          f13 = Math_fround(f13 * f14);
          i1 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
          break;
         } else {
          if (f14 < Math_fround(0.0)) {
           i79 = 117;
           break L7;
          }
          f13 = Math_fround(f13 + f14);
          i1 = i37;
          break;
         }
        } while (0);
        HEAP32[i77 >> 2] = i18;
        HEAP32[i44 >> 2] = i1;
        HEAP32[i78 >> 2] = HEAP32[i77 >> 2];
        HEAP32[i78 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
        if (__ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i69, i78, f13) | 0) HEAP16[(HEAP32[i46 >> 2] | 0) + (i18 << 1) >> 1] = i20;
        if ((HEAP32[i47 >> 2] | 0) > 1999) {
         i79 = 122;
         break L7;
        }
       } else i79 = 123;
      } else i79 = 123; while (0);
      if ((i79 | 0) == 123) i79 = 0;
      i19 = i19 + 1 | 0;
     } while ((i19 | 0) < (i29 | 0));
    }
    i1 = HEAP32[i47 >> 2] | 0;
   }
   if (!i1) break L5;
  }
  if ((i79 | 0) == 14) {
   i4 = HEAP32[i46 >> 2] | 0;
   i2 = HEAP16[i4 + (i19 << 1) >> 1] | 0;
   if (i2 << 16 >> 16 != -1) {
    while (1) {
     i79 = i4 + ((i2 & 65535) << 1) | 0;
     i3 = HEAP16[i79 >> 1] | 0;
     HEAP16[i79 >> 1] = i1;
     if (i3 << 16 >> 16 == -1) break; else {
      i1 = i2;
      i2 = i3;
     }
    }
    i1 = HEAP16[i80 >> 1] | 0;
   }
   HEAP16[i4 + ((i1 & 65535) << 1) >> 1] = -1;
   __ZN5Umbra10PathFinder10outputPathERNS_7ImpPathEfRKNS_7Vector3ES5_(i81, i82, (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])), i83, i84);
   STACKTOP = i85;
   return;
  } else if ((i79 | 0) == 80) {
   HEAP32[(HEAP32[i81 >> 2] | 0) + 28 >> 2] = 2;
   STACKTOP = i85;
   return;
  } else if ((i79 | 0) == 114) HEAP32[i15 + 28 >> 2] = 3; else if ((i79 | 0) == 117) HEAP32[i15 + 28 >> 2] = 3; else if ((i79 | 0) == 122) HEAP32[(HEAP32[i81 >> 2] | 0) + 28 >> 2] = 2;
  STACKTOP = i85;
  return;
 } while (0);
 HEAP32[(HEAP32[i81 >> 2] | 0) + 28 >> 2] = 8;
 STACKTOP = i85;
 return;
}

function __ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE(i31, i35, i23, i36, i32, i34) {
 i31 = i31 | 0;
 i35 = i35 | 0;
 i23 = i23 | 0;
 i36 = i36 | 0;
 i32 = i32 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i37 + 144 | 0;
 i24 = i37 + 128 | 0;
 i22 = i37 + 120 | 0;
 i21 = i37 + 112 | 0;
 i20 = i37 + 104 | 0;
 i19 = i37 + 96 | 0;
 i18 = i37 + 88 | 0;
 i17 = i37 + 80 | 0;
 i16 = i37 + 72 | 0;
 i15 = i37 + 64 | 0;
 i14 = i37 + 56 | 0;
 i13 = i37 + 48 | 0;
 i12 = i37 + 32 | 0;
 i4 = i37 + 16 | 0;
 i3 = i37 + 8 | 0;
 i1 = i37;
 i26 = i37 + 160 | 0;
 if (HEAP32[i31 + 56 >> 2] & 16 | 0) {
  if (!i34) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  __Z6FormatPKcz(i26, gb + 445285 | 0, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 if ((i35 | 0) > 99999) {
  i2 = (HEAP32[i1 + 24 >> 2] | 0) + (i35 + -1e5 << 3) | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i1 + (i35 << 3) | 0;
 }
 if (((HEAP32[i2 >> 2] | 0) - (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
  if (!i34) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  HEAP32[i3 >> 2] = __ZN6Object15ClassIDToStringEi(i35) | 0;
  __Z6FormatPKcz(i26, gb + 445116 | 0, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i1 = __ZNK10GameObject27FindConflictingComponentPtrEi(i31, i35) | 0;
 if (i1 | 0) {
  if (!i34) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  i33 = __ZN6Object15ClassIDToStringEi(i35) | 0;
  i35 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
  i36 = __ZNK6Object12GetClassNameEv(i1) | 0;
  HEAP32[i4 >> 2] = i33;
  HEAP32[i4 + 4 >> 2] = i35;
  HEAP32[i4 + 8 >> 2] = i36;
  __Z6FormatPKcz(i26, gb + 445340 | 0, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i27 = i32 + 12 | 0;
 L26 : do if (HEAP32[i27 >> 2] | 0) {
  i11 = __Z25FindConflictingComponentsi(i35) | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  if ((i10 | 0) != (i11 | 0)) {
   i2 = HEAP32[i32 >> 2] | 0;
   i1 = HEAP32[i27 >> 2] | 0;
   if (i1 | 0) {
    i7 = i2 + (i1 << 3) | 0;
    i9 = HEAP32[gb + 1110260 >> 2] | 0;
    i8 = i9 + 24 | 0;
    i9 = i9 + 4 | 0;
    L30 : while (1) {
     i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) > 99999) {
      i6 = HEAP32[i8 >> 2] | 0;
      i4 = HEAP32[i6 + (i1 + -1e5 << 3) >> 2] | 0;
      i3 = i10;
      do {
       i1 = HEAP32[i3 >> 2] | 0;
       if ((i1 | 0) > 99999) i5 = i6 + (i1 + -1e5 << 3) | 0; else i5 = (HEAP32[i9 >> 2] | 0) + (i1 << 3) | 0;
       if ((i4 - (HEAP32[i5 >> 2] | 0) | 0) >>> 0 < (HEAP32[i5 + 4 >> 2] | 0) >>> 0) break L30;
       i3 = i3 + 4 | 0;
      } while ((i3 | 0) != (i11 | 0));
     } else {
      i6 = HEAP32[i9 >> 2] | 0;
      i4 = HEAP32[i6 + (i1 << 3) >> 2] | 0;
      i3 = i10;
      do {
       i1 = HEAP32[i3 >> 2] | 0;
       if ((i1 | 0) > 99999) i5 = (HEAP32[i8 >> 2] | 0) + (i1 + -1e5 << 3) | 0; else i5 = i6 + (i1 << 3) | 0;
       if ((i4 - (HEAP32[i5 >> 2] | 0) | 0) >>> 0 < (HEAP32[i5 + 4 >> 2] | 0) >>> 0) break L30;
       i3 = i3 + 4 | 0;
      } while ((i3 | 0) != (i11 | 0));
     }
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i7 | 0)) break L26;
    }
    if ((i1 | 0) > -1) {
     if (!i34) {
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
     i33 = __ZN6Object15ClassIDToStringEi(i35) | 0;
     i35 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
     i36 = __ZN6Object15ClassIDToStringEi(i1) | 0;
     HEAP32[i12 >> 2] = i33;
     HEAP32[i12 + 4 >> 2] = i35;
     HEAP32[i12 + 8 >> 2] = i36;
     __Z6FormatPKcz(i26, gb + 445434 | 0, i12);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     i36 = 0;
     STACKTOP = i37;
     return i36 | 0;
    }
   }
  }
 } while (0);
 if (!(__ZNK10GameObject22CountDerivedComponentsEi(i31, i35) | 0)) i33 = 42; else {
  __Z25InitComponentRequirementsv();
  i4 = (HEAP32[gb + 1162552 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) {
   i1 = i4;
   L59 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i35 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L59; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i35 | 0)) i33 = 42;
  }
 }
 if ((i33 | 0) == 42) if (!(__ZNK10GameObject27FindConflictingComponentPtrEi(i31, i35) | 0)) {
  if ((HEAP32[i31 + 8 >> 2] & 1114112 | 0) == 1114112) {
   if (!i34) {
    i36 = 0;
    STACKTOP = i37;
    return i36 | 0;
   }
   i35 = __ZN6Object15ClassIDToStringEi(i35) | 0;
   i36 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
   HEAP32[i14 >> 2] = i35;
   HEAP32[i14 + 4 >> 2] = i36;
   __Z6FormatPKcz(i26, gb + 445612 | 0, i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (HEAP8[(__ZN6Object13ClassIDToRTTIEi(i35) | 0) + 32 >> 0] | 0) {
   if (!i34) {
    i36 = 0;
    STACKTOP = i37;
    return i36 | 0;
   }
   i33 = __ZN6Object15ClassIDToStringEi(i35) | 0;
   i36 = __ZN6Object15ClassIDToStringEi(i35) | 0;
   HEAP32[i15 >> 2] = i33;
   HEAP32[i15 + 4 >> 2] = i36;
   __Z6FormatPKcz(i26, gb + 445745 | 0, i15);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  i11 = i23;
  i2 = HEAP32[i27 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = i32 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i3 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i1;
    HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 3, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i15 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i27 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i32 >> 2] = i15;
    break;
   }
  } while (0);
  HEAP32[i27 >> 2] = i3;
  i10 = HEAP32[i32 >> 2] | 0;
  HEAP32[i10 + (i2 << 3) >> 2] = i35;
  HEAP32[i10 + (i2 << 3) + 4 >> 2] = i11;
  i10 = __Z34FindRequiredComponentsForComponenti(i35) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + 4 | 0;
  L91 : do if ((i1 | 0) != (HEAP32[i10 >> 2] | 0)) {
   L92 : while (1) {
    L94 : do if (!(__ZNK10GameObject22CountDerivedComponentsEi(i31, HEAP32[i1 >> 2] | 0) | 0)) {
     i6 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i32 >> 2] | 0;
     i15 = HEAP32[i27 >> 2] | 0;
     i7 = i2 + (i15 << 3) | 0;
     if (i15 | 0) {
      i9 = HEAP32[gb + 1110260 >> 2] | 0;
      i8 = i9 + 24 | 0;
      i5 = i6 + -1e5 | 0;
      i9 = i9 + 4 | 0;
      if ((i6 | 0) > 99999) do {
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) > 99999) {
        i4 = HEAP32[i8 >> 2] | 0;
        i3 = i4 + (i3 + -1e5 << 3) | 0;
       } else {
        i3 = (HEAP32[i9 >> 2] | 0) + (i3 << 3) | 0;
        i4 = HEAP32[i8 >> 2] | 0;
       }
       i2 = i2 + 8 | 0;
       if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i4 + (i5 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0) >>> 0) break L94;
      } while ((i2 | 0) != (i7 | 0)); else do {
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) > 99999) {
        i3 = (HEAP32[i8 >> 2] | 0) + (i3 + -1e5 << 3) | 0;
        i4 = HEAP32[i9 >> 2] | 0;
       } else {
        i4 = HEAP32[i9 >> 2] | 0;
        i3 = i4 + (i3 << 3) | 0;
       }
       i2 = i2 + 8 | 0;
       if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i4 + (i6 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + (i6 << 3) + 4 >> 2] | 0) >>> 0) break L94;
      } while ((i2 | 0) != (i7 | 0));
     }
     if (!(__Z21CheckForAbstractClassR10GameObject11ClassIDTypePNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i31, i6, i34) | 0)) {
      i1 = 0;
      i33 = 141;
      break L92;
     }
     if (!(__ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE(i31, HEAP32[i1 >> 2] | 0, 0, i36, i32, i34) | 0)) {
      i1 = 0;
      i33 = 141;
      break L92;
     }
    } while (0);
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) break L91;
   }
   if ((i33 | 0) == 141) {
    STACKTOP = i37;
    return i1 | 0;
   }
  } while (0);
  L120 : do if ((i35 | 0) == 114) {
   i8 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i23) | 0;
   if (i8 | 0) {
    i2 = __ZNK10MonoScript13GetScriptTypeEv(i8) | 0;
    if (i2 | 0) {
     i1 = (i34 | 0) != 0;
     if ((i2 | 0) == -3) {
      if (!i1) {
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
      HEAP32[i16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
      __Z6FormatPKcz(i26, gb + 445860 | 0, i16);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
     if (!i1) {
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
     if (HEAP8[i8 + 140 >> 0] | 0) {
      HEAP32[i17 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
      __Z6FormatPKcz(i26, gb + 445973 | 0, i17);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
     switch (i2 | 0) {
     case -1:
      {
       HEAP32[i18 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       __Z6FormatPKcz(i26, gb + 446098 | 0, i18);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
     case -4:
      {
       HEAP32[i19 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       __Z6FormatPKcz(i26, gb + 446214 | 0, i19);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
     case -5:
      {
       HEAP32[i20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       __Z6FormatPKcz(i26, gb + 446281 | 0, i20);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
     case -6:
      {
       HEAP32[i21 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       __Z6FormatPKcz(i26, gb + 446346 | 0, i21);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
     default:
      {
       HEAP32[i22 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       __Z6FormatPKcz(i26, gb + 446419 | 0, i22);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
       i36 = 0;
       STACKTOP = i37;
       return i36 | 0;
      }
     }
    }
   }
   i5 = __ZN23ManagedAttributeManager41GetParentTypeDisallowingMultipleInclusionEP11Il2CppClass(__Z26GetManagedAttributeManagerv() | 0, i23) | 0;
   L151 : do if (i5 | 0) {
    i6 = i31 + 40 | 0;
    if ((HEAP32[i6 >> 2] | 0) > 0) {
     i7 = i31 + 28 | 0;
     i1 = 0;
     i4 = 0;
     L154 : while (1) {
      i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
      do if ((i2 | 0) == 0 ? 1 : (((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) i3 = 4; else {
       i2 = __ZNK13MonoBehaviour8GetClassEv(i2) | 0;
       if (!i2) {
        i3 = 0;
        break;
       }
       i22 = __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i5) | 0;
       i3 = i22 & 1;
       i1 = i22 ? i2 : i1;
      } while (0);
      switch (i3 & 7) {
      case 4:
      case 0:
       break;
      default:
       break L154;
      }
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (HEAP32[i6 >> 2] | 0)) break L151;
     }
     if (!i34) {
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
     if ((i5 | 0) == (i1 | 0)) {
      i33 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0, i8 | 0) | 0;
      i33 = (HEAP8[i33 + 11 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33;
      i35 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
      i36 = __Z24scripting_class_get_nameP11Il2CppClass(i5) | 0;
      HEAP32[i24 >> 2] = i33;
      HEAP32[i24 + 4 >> 2] = i35;
      HEAP32[i24 + 8 >> 2] = i36;
      __Z6FormatPKcz(i26, gb + 446497 | 0, i24);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     } else {
      i32 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0, i8 | 0) | 0;
      i32 = (HEAP8[i32 + 11 >> 0] | 0) < 0 ? HEAP32[i32 >> 2] | 0 : i32;
      i33 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
      i35 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
      i36 = __Z24scripting_class_get_nameP11Il2CppClass(i5) | 0;
      HEAP32[i25 >> 2] = i32;
      HEAP32[i25 + 4 >> 2] = i33;
      HEAP32[i25 + 8 >> 2] = i35;
      HEAP32[i25 + 12 >> 2] = i36;
      __Z6FormatPKcz(i26, gb + 446570 | 0, i25);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      i36 = 0;
      STACKTOP = i37;
      return i36 | 0;
     }
    }
   } while (0);
   i7 = __Z20RequiredComponentsOfP11Il2CppClass(i23) | 0;
   if (i7 | 0) if ((__Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0) > 0) {
    i8 = i31 + 40 | 0;
    i9 = i31 + 28 | 0;
    i6 = 0;
    L173 : while (1) {
     i1 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i7, i6) | 0;
     L175 : do if (i1 | 0) {
      i5 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
      i4 = (i5 | 0) == 0;
      if (!(i4 | (HEAP32[i27 >> 2] | 0) == 0)) {
       i3 = 0;
       do {
        i1 = HEAP32[i32 >> 2] | 0;
        i2 = HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0;
        if (!i2) {
         i26 = __Z14GetMonoManagerv() | 0;
         i1 = HEAP32[(__ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) + 24 >> 2] | 0;
         i1 = HEAP32[(HEAP32[i26 + 168 >> 2] | 0) + (i1 << 2) >> 2] | 0;
         if (i1 | 0) {
          i28 = i1;
          i33 = 107;
         }
        } else {
         i28 = i2;
         i33 = 107;
        }
        if ((i33 | 0) == 107) {
         i33 = 0;
         if ((i28 | 0) == (i5 | 0)) break L175;
         if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i28, i5) | 0) break L175;
        }
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < (HEAP32[i27 >> 2] | 0) >>> 0);
      }
      L187 : do if ((HEAP32[i8 >> 2] | 0) > 0) {
       if (i4) {
        i1 = 0;
        while (1) {
         i2 = (HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0) + 8 >> 2] | 0) >>> 21;
         if ((i2 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
          i26 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + (i2 << 2) >> 2] | 0) + 16 >> 2] | 0;
          __Z14GetMonoManagerv() | 0;
          __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i26) | 0;
         }
         i1 = i1 + 1 | 0;
         if ((i1 | 0) >= (HEAP32[i8 >> 2] | 0)) break L187;
        }
       } else i3 = 0;
       do {
        i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
        i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
        if ((i2 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0; else {
         i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + (i2 << 2) >> 2] | 0) + 16 >> 2] | 0;
         i26 = __Z14GetMonoManagerv() | 0;
         i1 = HEAP32[(__ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0) + 24 >> 2] | 0;
         i1 = HEAP32[(HEAP32[i26 + 168 >> 2] | 0) + (i1 << 2) >> 2] | 0;
        }
        if (i1 | 0) {
         if ((i1 | 0) == (i5 | 0)) break L175;
         if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i5) | 0) break L175;
        }
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) < (HEAP32[i8 >> 2] | 0));
      } while (0);
      i26 = __Z29scripting_class_get_namespaceP11Il2CppClass(i5) | 0;
      do if (!(__Z7StrICmpPKcS0_(i26, HEAP32[gb + 64324 >> 2] | 0) | 0)) {
       i2 = __ZN6Object15StringToClassIDEPKc(__Z24scripting_class_get_nameP11Il2CppClass(i5) | 0) | 0;
       if ((i2 | 0) == -1) {
        i33 = 129;
        break;
       }
       i1 = HEAP32[gb + 1110260 >> 2] | 0;
       if ((i2 | 0) > 99999) {
        i3 = (HEAP32[i1 + 24 >> 2] | 0) + (i2 + -1e5 << 3) | 0;
        i1 = HEAP32[i1 + 4 >> 2] | 0;
       } else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        i3 = i1 + (i2 << 3) | 0;
       }
       if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
        i29 = 0;
        i30 = i2;
       } else i33 = 129;
      } else i33 = 129; while (0);
      if ((i33 | 0) == 129) {
       i33 = 0;
       i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i5) | 0;
       if (!i1) break; else {
        i29 = i1;
        i30 = 114;
       }
      }
      if (!(__Z21CheckForAbstractClassR10GameObject11ClassIDTypePNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i31, i30, i34) | 0)) {
       i1 = 0;
       i33 = 141;
       break L173;
      }
      if (!i29) i1 = 0; else i1 = __ZN10MonoScript8GetClassEv(i29) | 0;
      if (!(__ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE(i31, i30, i1, i36, i32, i34) | 0)) {
       i1 = 0;
       i33 = 141;
       break L173;
      }
     } while (0);
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (__Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0)) break L120;
    }
    if ((i33 | 0) == 141) {
     STACKTOP = i37;
     return i1 | 0;
    }
   }
  } while (0);
  i2 = i36 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i36 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1 << 3, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i34 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i34 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i36 >> 2] = i34;
    break;
   }
  } while (0);
  HEAP32[i2 >> 2] = i4;
  i36 = HEAP32[i36 >> 2] | 0;
  HEAP32[i36 + (i3 << 3) >> 2] = i35;
  HEAP32[i36 + (i3 << 3) + 4 >> 2] = i11;
  i36 = 1;
  STACKTOP = i37;
  return i36 | 0;
 }
 if (!i34) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i35 = __ZN6Object15ClassIDToStringEi(i35) | 0;
 i36 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i31 | 0) | 0;
 HEAP32[i13 >> 2] = i35;
 HEAP32[i13 + 4 >> 2] = i36;
 __Z6FormatPKcz(i26, gb + 445519 | 0, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 i36 = 0;
 STACKTOP = i37;
 return i36 | 0;
}

function __ZN5physx20InternalTriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i31 >> 2] = HEAP32[gb + 133828 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 133828 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 133828 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 133828 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 133828 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 133828 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 133828 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 133828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 133860 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 133860 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 133860 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 133860 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 133860 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 133860 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 133860 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 133860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 133892 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 133892 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 133892 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 133892 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 133892 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 133892 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 133892 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 133892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 133924 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 133924 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 133924 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 133924 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 133924 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 133924 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 133924 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 133924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 133956 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 133956 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 133956 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 133956 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 133956 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 133956 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 133956 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 133956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 133988 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 133988 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 133988 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 133988 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 133988 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 133988 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 133988 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 133988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 134020 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 134020 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 134020 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 134020 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 134020 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 134020 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 134020 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 134020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 134052 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 134052 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 134052 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 134052 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 134052 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 134052 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 134052 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 134052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 134084 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 134084 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 134084 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 134084 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 134084 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 134084 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 134084 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 134084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 134116 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 134116 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 134116 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 134116 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 134116 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 134116 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 134116 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 134116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 134148 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 134148 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 134148 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 134148 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 134148 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 134148 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 134148 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 134148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 134180 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 134180 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 134180 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 134180 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 134180 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 134180 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 134180 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 134180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 __ZN5physx2Gu5RTree17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i31 >> 2] = HEAP32[gb + 134212 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 134212 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 134212 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 134212 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 134212 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 134212 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 134212 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 134212 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 134244 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 134244 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 134244 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 134244 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 134244 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 134244 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 134244 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 134244 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 134276 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 134276 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 134276 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 134276 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 134276 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 134276 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 134276 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 134276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 134308 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 134308 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 134308 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 134308 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 134308 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 134308 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 134308 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 134308 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 134340 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 134340 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 134340 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 134340 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 134340 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 134340 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 134340 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 134340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 134372 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 134372 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 134372 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 134372 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 134372 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 134372 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 134372 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 134372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 134404 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 134404 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 134404 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 134404 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 134404 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 134404 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 134404 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 134404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 134436 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 134436 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 134436 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 134436 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 134436 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 134436 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 134436 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 134436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 134468 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 134468 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 134468 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 134468 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 134468 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 134468 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 134468 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 134468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 134500 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 134500 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 134500 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 134500 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 134500 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 134500 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 134500 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 134500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 134532 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 134532 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 134532 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 134532 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 134532 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 134532 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 134532 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 134532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 134564 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 134564 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 134564 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 134564 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 134564 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 134564 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 134564 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 134564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 134564 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 134564 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 134564 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 134564 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 134564 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 134564 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 134564 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 134564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 134596 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 134596 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 134596 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 134596 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 134596 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 134596 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 134596 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 134596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 134628 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 134628 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 134628 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 134628 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 134628 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 134628 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 134628 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 134628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 134628 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 134628 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 134628 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 134628 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 134628 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 134628 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 134628 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 134628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 134660 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 134660 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 134660 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 134660 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 134660 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 134660 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 134660 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 134660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 134692 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 134692 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 134692 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 134692 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 134692 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 134692 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 134692 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 134692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 134724 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 134724 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 134724 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 134724 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 134724 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 134724 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 134724 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 134724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 134756 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 134756 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 134756 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 134756 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 134756 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 134756 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 134756 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 134756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 134788 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 134788 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 134788 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 134788 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 134788 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 134788 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 134788 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 134788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 134820 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 134820 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 134820 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 134820 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 134820 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 134820 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 134820 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 134820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 134852 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 134852 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 134852 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 134852 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 134852 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 134852 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 134852 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 134852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 134884 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 134884 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 134884 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 134884 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 134884 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 134884 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 134884 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 134884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 134916 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 134916 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 134916 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 134916 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 134916 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 134916 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 134916 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 134916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 134948 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 134948 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 134948 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 134948 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 134948 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 134948 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 134948 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 134948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 134980 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 134980 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 134980 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 134980 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 134980 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 134980 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 134980 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 134980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 135012 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 135012 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 135012 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 135012 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 135012 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 135012 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 135012 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 135012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 135044 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 135044 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 135044 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 135044 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 135044 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 135044 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 135044 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 135044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __GLOBAL__sub_I_CmEventProfiler_cpp() {
 HEAP32[gb + 1452908 >> 2] = gb + 662675;
 HEAP32[gb + 1452908 + 4 >> 2] = 65536;
 HEAP32[gb + 1452908 + 8 >> 2] = gb + 662691;
 HEAP32[gb + 1452908 + 12 >> 2] = 65537;
 HEAP32[gb + 1452908 + 16 >> 2] = gb + 662708;
 HEAP32[gb + 1452908 + 20 >> 2] = 65538;
 HEAP32[gb + 1452908 + 24 >> 2] = gb + 662726;
 HEAP32[gb + 1452908 + 28 >> 2] = 65539;
 HEAP32[gb + 1452908 + 32 >> 2] = gb + 662748;
 HEAP32[gb + 1452908 + 36 >> 2] = 65540;
 HEAP32[gb + 1452908 + 40 >> 2] = gb + 662764;
 HEAP32[gb + 1452908 + 44 >> 2] = 65541;
 HEAP32[gb + 1452908 + 48 >> 2] = gb + 662779;
 HEAP32[gb + 1452908 + 52 >> 2] = 65542;
 HEAP32[gb + 1452908 + 56 >> 2] = gb + 662799;
 HEAP32[gb + 1452908 + 60 >> 2] = 65543;
 HEAP32[gb + 1452908 + 64 >> 2] = gb + 662814;
 HEAP32[gb + 1452908 + 68 >> 2] = 65544;
 HEAP32[gb + 1452908 + 72 >> 2] = gb + 662833;
 HEAP32[gb + 1452908 + 76 >> 2] = 65545;
 HEAP32[gb + 1452908 + 80 >> 2] = gb + 662854;
 HEAP32[gb + 1452908 + 84 >> 2] = 65546;
 HEAP32[gb + 1452908 + 88 >> 2] = gb + 662873;
 HEAP32[gb + 1452908 + 92 >> 2] = 65547;
 HEAP32[gb + 1452908 + 96 >> 2] = gb + 662894;
 HEAP32[gb + 1452908 + 100 >> 2] = 65548;
 HEAP32[gb + 1452908 + 104 >> 2] = gb + 662917;
 HEAP32[gb + 1452908 + 108 >> 2] = 65549;
 HEAP32[gb + 1452908 + 112 >> 2] = gb + 662931;
 HEAP32[gb + 1452908 + 116 >> 2] = 65550;
 HEAP32[gb + 1452908 + 120 >> 2] = gb + 662946;
 HEAP32[gb + 1452908 + 124 >> 2] = 65551;
 HEAP32[gb + 1452908 + 128 >> 2] = gb + 662963;
 HEAP32[gb + 1452908 + 132 >> 2] = 65552;
 HEAP32[gb + 1452908 + 136 >> 2] = gb + 662981;
 HEAP32[gb + 1452908 + 140 >> 2] = 65553;
 HEAP32[gb + 1452908 + 144 >> 2] = gb + 662999;
 HEAP32[gb + 1452908 + 148 >> 2] = 65554;
 HEAP32[gb + 1452908 + 152 >> 2] = gb + 663020;
 HEAP32[gb + 1452908 + 156 >> 2] = 65555;
 HEAP32[gb + 1452908 + 160 >> 2] = gb + 663041;
 HEAP32[gb + 1452908 + 164 >> 2] = 65556;
 HEAP32[gb + 1452908 + 168 >> 2] = gb + 663065;
 HEAP32[gb + 1452908 + 172 >> 2] = 65557;
 HEAP32[gb + 1452908 + 176 >> 2] = gb + 663084;
 HEAP32[gb + 1452908 + 180 >> 2] = 65558;
 HEAP32[gb + 1452908 + 184 >> 2] = gb + 663107;
 HEAP32[gb + 1452908 + 188 >> 2] = 65559;
 HEAP32[gb + 1452908 + 192 >> 2] = gb + 663133;
 HEAP32[gb + 1452908 + 196 >> 2] = 65560;
 HEAP32[gb + 1452908 + 200 >> 2] = gb + 663155;
 HEAP32[gb + 1452908 + 204 >> 2] = 65561;
 HEAP32[gb + 1452908 + 208 >> 2] = gb + 663180;
 HEAP32[gb + 1452908 + 212 >> 2] = 65562;
 HEAP32[gb + 1452908 + 216 >> 2] = gb + 663194;
 HEAP32[gb + 1452908 + 220 >> 2] = 65563;
 HEAP32[gb + 1452908 + 224 >> 2] = gb + 663211;
 HEAP32[gb + 1452908 + 228 >> 2] = 65564;
 HEAP32[gb + 1452908 + 232 >> 2] = gb + 663233;
 HEAP32[gb + 1452908 + 236 >> 2] = 65565;
 HEAP32[gb + 1452908 + 240 >> 2] = gb + 663256;
 HEAP32[gb + 1452908 + 244 >> 2] = 65566;
 HEAP32[gb + 1452908 + 248 >> 2] = gb + 663285;
 HEAP32[gb + 1452908 + 252 >> 2] = 65567;
 HEAP32[gb + 1452908 + 256 >> 2] = gb + 663302;
 HEAP32[gb + 1452908 + 260 >> 2] = 32;
 HEAP32[gb + 1452908 + 264 >> 2] = gb + 663321;
 HEAP32[gb + 1452908 + 268 >> 2] = 33;
 HEAP32[gb + 1452908 + 272 >> 2] = gb + 663345;
 HEAP32[gb + 1452908 + 276 >> 2] = 34;
 HEAP32[gb + 1452908 + 280 >> 2] = gb + 663365;
 HEAP32[gb + 1452908 + 284 >> 2] = 35;
 HEAP32[gb + 1452908 + 288 >> 2] = gb + 663390;
 HEAP32[gb + 1452908 + 292 >> 2] = 36;
 HEAP32[gb + 1452908 + 296 >> 2] = gb + 663409;
 HEAP32[gb + 1452908 + 300 >> 2] = 37;
 HEAP32[gb + 1452908 + 304 >> 2] = gb + 663433;
 HEAP32[gb + 1452908 + 308 >> 2] = 38;
 HEAP32[gb + 1452908 + 312 >> 2] = gb + 663462;
 HEAP32[gb + 1452908 + 316 >> 2] = 39;
 HEAP32[gb + 1452908 + 320 >> 2] = gb + 663490;
 HEAP32[gb + 1452908 + 324 >> 2] = 65576;
 HEAP32[gb + 1452908 + 328 >> 2] = gb + 663513;
 HEAP32[gb + 1452908 + 332 >> 2] = 65577;
 HEAP32[gb + 1452908 + 336 >> 2] = gb + 663536;
 HEAP32[gb + 1452908 + 340 >> 2] = 65578;
 HEAP32[gb + 1452908 + 344 >> 2] = gb + 663558;
 HEAP32[gb + 1452908 + 348 >> 2] = 65579;
 HEAP32[gb + 1452908 + 352 >> 2] = gb + 663578;
 HEAP32[gb + 1452908 + 356 >> 2] = 65580;
 HEAP32[gb + 1452908 + 360 >> 2] = gb + 663600;
 HEAP32[gb + 1452908 + 364 >> 2] = 65581;
 HEAP32[gb + 1452908 + 368 >> 2] = gb + 663622;
 HEAP32[gb + 1452908 + 372 >> 2] = 65582;
 HEAP32[gb + 1452908 + 376 >> 2] = gb + 663641;
 HEAP32[gb + 1452908 + 380 >> 2] = 65583;
 HEAP32[gb + 1452908 + 384 >> 2] = gb + 663662;
 HEAP32[gb + 1452908 + 388 >> 2] = 65584;
 HEAP32[gb + 1452908 + 392 >> 2] = gb + 663689;
 HEAP32[gb + 1452908 + 396 >> 2] = 65585;
 HEAP32[gb + 1452908 + 400 >> 2] = gb + 663712;
 HEAP32[gb + 1452908 + 404 >> 2] = 65586;
 HEAP32[gb + 1452908 + 408 >> 2] = gb + 663736;
 HEAP32[gb + 1452908 + 412 >> 2] = 65587;
 HEAP32[gb + 1452908 + 416 >> 2] = gb + 663756;
 HEAP32[gb + 1452908 + 420 >> 2] = 65588;
 HEAP32[gb + 1452908 + 424 >> 2] = gb + 663777;
 HEAP32[gb + 1452908 + 428 >> 2] = 65589;
 HEAP32[gb + 1452908 + 432 >> 2] = gb + 663793;
 HEAP32[gb + 1452908 + 436 >> 2] = 65590;
 HEAP32[gb + 1452908 + 440 >> 2] = gb + 663819;
 HEAP32[gb + 1452908 + 444 >> 2] = 65591;
 HEAP32[gb + 1452908 + 448 >> 2] = gb + 663840;
 HEAP32[gb + 1452908 + 452 >> 2] = 65592;
 HEAP32[gb + 1452908 + 456 >> 2] = gb + 663857;
 HEAP32[gb + 1452908 + 460 >> 2] = 65593;
 HEAP32[gb + 1452908 + 464 >> 2] = gb + 663875;
 HEAP32[gb + 1452908 + 468 >> 2] = 65594;
 HEAP32[gb + 1452908 + 472 >> 2] = gb + 663902;
 HEAP32[gb + 1452908 + 476 >> 2] = 65595;
 HEAP32[gb + 1452908 + 480 >> 2] = gb + 663930;
 HEAP32[gb + 1452908 + 484 >> 2] = 65596;
 HEAP32[gb + 1452908 + 488 >> 2] = gb + 663958;
 HEAP32[gb + 1452908 + 492 >> 2] = 65597;
 HEAP32[gb + 1452908 + 496 >> 2] = gb + 663975;
 HEAP32[gb + 1452908 + 500 >> 2] = 65598;
 HEAP32[gb + 1452908 + 504 >> 2] = gb + 663998;
 HEAP32[gb + 1452908 + 508 >> 2] = 65599;
 HEAP32[gb + 1452908 + 512 >> 2] = gb + 664016;
 HEAP32[gb + 1452908 + 516 >> 2] = 65600;
 HEAP32[gb + 1452908 + 520 >> 2] = gb + 664040;
 HEAP32[gb + 1452908 + 524 >> 2] = 65601;
 HEAP32[gb + 1452908 + 528 >> 2] = gb + 664066;
 HEAP32[gb + 1452908 + 532 >> 2] = 65602;
 HEAP32[gb + 1452908 + 536 >> 2] = gb + 664087;
 HEAP32[gb + 1452908 + 540 >> 2] = 65603;
 HEAP32[gb + 1452908 + 544 >> 2] = gb + 664101;
 HEAP32[gb + 1452908 + 548 >> 2] = 65604;
 HEAP32[gb + 1452908 + 552 >> 2] = gb + 664120;
 HEAP32[gb + 1452908 + 556 >> 2] = 65605;
 HEAP32[gb + 1452908 + 560 >> 2] = gb + 664133;
 HEAP32[gb + 1452908 + 564 >> 2] = 65606;
 HEAP32[gb + 1452908 + 568 >> 2] = gb + 664148;
 HEAP32[gb + 1452908 + 572 >> 2] = 65607;
 HEAP32[gb + 1452908 + 576 >> 2] = gb + 664166;
 HEAP32[gb + 1452908 + 580 >> 2] = 65608;
 HEAP32[gb + 1452908 + 584 >> 2] = gb + 664193;
 HEAP32[gb + 1452908 + 588 >> 2] = 65609;
 HEAP32[gb + 1452908 + 592 >> 2] = gb + 664225;
 HEAP32[gb + 1452908 + 596 >> 2] = 65610;
 HEAP32[gb + 1452908 + 600 >> 2] = gb + 664249;
 HEAP32[gb + 1452908 + 604 >> 2] = 65611;
 HEAP32[gb + 1452908 + 608 >> 2] = gb + 664278;
 HEAP32[gb + 1452908 + 612 >> 2] = 65612;
 HEAP32[gb + 1452908 + 616 >> 2] = gb + 664302;
 HEAP32[gb + 1452908 + 620 >> 2] = 65613;
 HEAP32[gb + 1452908 + 624 >> 2] = gb + 664324;
 HEAP32[gb + 1452908 + 628 >> 2] = 65614;
 HEAP32[gb + 1452908 + 632 >> 2] = gb + 664357;
 HEAP32[gb + 1452908 + 636 >> 2] = 65615;
 HEAP32[gb + 1452908 + 640 >> 2] = gb + 664382;
 HEAP32[gb + 1452908 + 644 >> 2] = 65616;
 HEAP32[gb + 1452908 + 648 >> 2] = gb + 664405;
 HEAP32[gb + 1452908 + 652 >> 2] = 65617;
 HEAP32[gb + 1452908 + 656 >> 2] = gb + 664431;
 HEAP32[gb + 1452908 + 660 >> 2] = 65618;
 HEAP32[gb + 1452908 + 664 >> 2] = gb + 664445;
 HEAP32[gb + 1452908 + 668 >> 2] = 65619;
 HEAP32[gb + 1452908 + 672 >> 2] = gb + 664471;
 HEAP32[gb + 1452908 + 676 >> 2] = 65620;
 HEAP32[gb + 1452908 + 680 >> 2] = gb + 664488;
 HEAP32[gb + 1452908 + 684 >> 2] = 65621;
 HEAP32[gb + 1452908 + 688 >> 2] = gb + 664510;
 HEAP32[gb + 1452908 + 692 >> 2] = 65622;
 HEAP32[gb + 1452908 + 696 >> 2] = gb + 664532;
 HEAP32[gb + 1452908 + 700 >> 2] = 65623;
 HEAP32[gb + 1452908 + 704 >> 2] = gb + 664552;
 HEAP32[gb + 1452908 + 708 >> 2] = 65624;
 HEAP32[gb + 1452908 + 712 >> 2] = gb + 664587;
 HEAP32[gb + 1452908 + 716 >> 2] = 65625;
 HEAP32[gb + 1452908 + 720 >> 2] = gb + 664615;
 HEAP32[gb + 1452908 + 724 >> 2] = 65626;
 HEAP32[gb + 1452908 + 728 >> 2] = gb + 664641;
 HEAP32[gb + 1452908 + 732 >> 2] = 65627;
 HEAP32[gb + 1452908 + 736 >> 2] = gb + 664661;
 HEAP32[gb + 1452908 + 740 >> 2] = 65628;
 HEAP32[gb + 1452908 + 744 >> 2] = gb + 664689;
 HEAP32[gb + 1452908 + 748 >> 2] = 65629;
 HEAP32[gb + 1452908 + 752 >> 2] = gb + 664705;
 HEAP32[gb + 1452908 + 756 >> 2] = 65630;
 HEAP32[gb + 1452908 + 760 >> 2] = gb + 664730;
 HEAP32[gb + 1452908 + 764 >> 2] = 65631;
 HEAP32[gb + 1452908 + 768 >> 2] = gb + 664754;
 HEAP32[gb + 1452908 + 772 >> 2] = 65632;
 HEAP32[gb + 1452908 + 776 >> 2] = gb + 664781;
 HEAP32[gb + 1452908 + 780 >> 2] = 65633;
 HEAP32[gb + 1452908 + 784 >> 2] = gb + 664812;
 HEAP32[gb + 1452908 + 788 >> 2] = 65634;
 HEAP32[gb + 1452908 + 792 >> 2] = gb + 664839;
 HEAP32[gb + 1452908 + 796 >> 2] = 65635;
 HEAP32[gb + 1452908 + 800 >> 2] = gb + 664861;
 HEAP32[gb + 1452908 + 804 >> 2] = 65636;
 HEAP32[gb + 1452908 + 808 >> 2] = gb + 664885;
 HEAP32[gb + 1452908 + 812 >> 2] = 65637;
 HEAP32[gb + 1452908 + 816 >> 2] = gb + 664912;
 HEAP32[gb + 1452908 + 820 >> 2] = 65638;
 HEAP32[gb + 1452908 + 824 >> 2] = gb + 664939;
 HEAP32[gb + 1452908 + 828 >> 2] = 65639;
 HEAP32[gb + 1452908 + 832 >> 2] = gb + 664965;
 HEAP32[gb + 1452908 + 836 >> 2] = 65640;
 HEAP32[gb + 1452908 + 840 >> 2] = gb + 664988;
 HEAP32[gb + 1452908 + 844 >> 2] = 65641;
 HEAP32[gb + 1452908 + 848 >> 2] = gb + 665014;
 HEAP32[gb + 1452908 + 852 >> 2] = 65642;
 HEAP32[gb + 1452908 + 856 >> 2] = gb + 665042;
 HEAP32[gb + 1452908 + 860 >> 2] = 65643;
 HEAP32[gb + 1452908 + 864 >> 2] = gb + 665070;
 HEAP32[gb + 1452908 + 868 >> 2] = 65644;
 HEAP32[gb + 1452908 + 872 >> 2] = gb + 665091;
 HEAP32[gb + 1452908 + 876 >> 2] = 65645;
 HEAP32[gb + 1452908 + 880 >> 2] = gb + 665116;
 HEAP32[gb + 1452908 + 884 >> 2] = 65646;
 HEAP32[gb + 1452908 + 888 >> 2] = gb + 665140;
 HEAP32[gb + 1452908 + 892 >> 2] = 65647;
 HEAP32[gb + 1452908 + 896 >> 2] = gb + 665168;
 HEAP32[gb + 1452908 + 900 >> 2] = 65648;
 HEAP32[gb + 1452908 + 904 >> 2] = gb + 665194;
 HEAP32[gb + 1452908 + 908 >> 2] = 65649;
 HEAP32[gb + 1452908 + 912 >> 2] = gb + 665224;
 HEAP32[gb + 1452908 + 916 >> 2] = 65650;
 HEAP32[gb + 1452908 + 920 >> 2] = gb + 665249;
 HEAP32[gb + 1452908 + 924 >> 2] = 65651;
 HEAP32[gb + 1452908 + 928 >> 2] = gb + 665276;
 HEAP32[gb + 1452908 + 932 >> 2] = 65652;
 HEAP32[gb + 1452908 + 936 >> 2] = gb + 665306;
 HEAP32[gb + 1452908 + 940 >> 2] = 65653;
 HEAP32[gb + 1452908 + 944 >> 2] = gb + 665339;
 HEAP32[gb + 1452908 + 948 >> 2] = 65654;
 HEAP32[gb + 1452908 + 952 >> 2] = gb + 665374;
 HEAP32[gb + 1452908 + 956 >> 2] = 65655;
 HEAP32[gb + 1452908 + 960 >> 2] = gb + 665409;
 HEAP32[gb + 1452908 + 964 >> 2] = 65656;
 HEAP32[gb + 1452908 + 968 >> 2] = gb + 665440;
 HEAP32[gb + 1452908 + 972 >> 2] = 65657;
 HEAP32[gb + 1452908 + 976 >> 2] = gb + 665473;
 HEAP32[gb + 1452908 + 980 >> 2] = 65658;
 HEAP32[gb + 1452908 + 984 >> 2] = gb + 665505;
 HEAP32[gb + 1452908 + 988 >> 2] = 65659;
 HEAP32[gb + 1452908 + 992 >> 2] = gb + 665533;
 HEAP32[gb + 1452908 + 996 >> 2] = 65660;
 HEAP32[gb + 1452908 + 1e3 >> 2] = gb + 665562;
 HEAP32[gb + 1452908 + 1004 >> 2] = 65661;
 HEAP32[gb + 1452908 + 1008 >> 2] = gb + 665589;
 HEAP32[gb + 1452908 + 1012 >> 2] = 65662;
 HEAP32[gb + 1452908 + 1016 >> 2] = gb + 665615;
 HEAP32[gb + 1452908 + 1020 >> 2] = 65663;
 HEAP32[gb + 1452908 + 1024 >> 2] = gb + 665653;
 HEAP32[gb + 1452908 + 1028 >> 2] = 65664;
 HEAP32[gb + 1452908 + 1032 >> 2] = gb + 665687;
 HEAP32[gb + 1452908 + 1036 >> 2] = 65665;
 HEAP32[gb + 1452908 + 1040 >> 2] = gb + 665719;
 HEAP32[gb + 1452908 + 1044 >> 2] = 65666;
 HEAP32[gb + 1452908 + 1048 >> 2] = gb + 665756;
 HEAP32[gb + 1452908 + 1052 >> 2] = 65667;
 HEAP32[gb + 1452908 + 1056 >> 2] = gb + 665788;
 HEAP32[gb + 1452908 + 1060 >> 2] = 65668;
 HEAP32[gb + 1452908 + 1064 >> 2] = gb + 665813;
 HEAP32[gb + 1452908 + 1068 >> 2] = 65669;
 HEAP32[gb + 1452908 + 1072 >> 2] = gb + 665848;
 HEAP32[gb + 1452908 + 1076 >> 2] = 65670;
 HEAP32[gb + 1452908 + 1080 >> 2] = gb + 665886;
 HEAP32[gb + 1452908 + 1084 >> 2] = 65671;
 HEAP32[gb + 1452908 + 1088 >> 2] = gb + 665915;
 HEAP32[gb + 1452908 + 1092 >> 2] = 65672;
 HEAP32[gb + 1452908 + 1096 >> 2] = gb + 665942;
 HEAP32[gb + 1452908 + 1100 >> 2] = 65673;
 HEAP32[gb + 1452908 + 1104 >> 2] = gb + 665971;
 HEAP32[gb + 1452908 + 1108 >> 2] = 65674;
 HEAP32[gb + 1452908 + 1112 >> 2] = gb + 665993;
 HEAP32[gb + 1452908 + 1116 >> 2] = 65675;
 HEAP32[gb + 1452908 + 1120 >> 2] = gb + 666019;
 HEAP32[gb + 1452908 + 1124 >> 2] = 65676;
 HEAP32[gb + 1452908 + 1128 >> 2] = gb + 666044;
 HEAP32[gb + 1452908 + 1132 >> 2] = 65677;
 HEAP32[gb + 1452908 + 1136 >> 2] = gb + 666073;
 HEAP32[gb + 1452908 + 1140 >> 2] = 65678;
 HEAP32[gb + 1452908 + 1144 >> 2] = gb + 666095;
 HEAP32[gb + 1452908 + 1148 >> 2] = 65679;
 HEAP32[gb + 1452908 + 1152 >> 2] = gb + 666121;
 HEAP32[gb + 1452908 + 1156 >> 2] = 65680;
 HEAP32[gb + 1452908 + 1160 >> 2] = gb + 666146;
 HEAP32[gb + 1452908 + 1164 >> 2] = 65681;
 HEAP32[gb + 1452908 + 1168 >> 2] = gb + 666175;
 HEAP32[gb + 1452908 + 1172 >> 2] = 65682;
 HEAP32[gb + 1452908 + 1176 >> 2] = gb + 666204;
 HEAP32[gb + 1452908 + 1180 >> 2] = 65683;
 HEAP32[gb + 1452908 + 1184 >> 2] = gb + 666240;
 HEAP32[gb + 1452908 + 1188 >> 2] = 65684;
 HEAP32[gb + 1452908 + 1192 >> 2] = gb + 666276;
 HEAP32[gb + 1452908 + 1196 >> 2] = 65685;
 HEAP32[gb + 1452908 + 1200 >> 2] = gb + 666300;
 HEAP32[gb + 1452908 + 1204 >> 2] = 65686;
 HEAP32[gb + 1452908 + 1208 >> 2] = gb + 666331;
 HEAP32[gb + 1452908 + 1212 >> 2] = 65687;
 HEAP32[gb + 1452908 + 1216 >> 2] = gb + 666360;
 HEAP32[gb + 1452908 + 1220 >> 2] = 65688;
 HEAP32[gb + 1452908 + 1224 >> 2] = gb + 666384;
 HEAP32[gb + 1452908 + 1228 >> 2] = 65689;
 HEAP32[gb + 1452908 + 1232 >> 2] = gb + 666407;
 HEAP32[gb + 1452908 + 1236 >> 2] = 65690;
 HEAP32[gb + 1452908 + 1240 >> 2] = gb + 666431;
 HEAP32[gb + 1452908 + 1244 >> 2] = 65691;
 HEAP32[gb + 1452908 + 1248 >> 2] = gb + 666466;
 HEAP32[gb + 1452908 + 1252 >> 2] = 65692;
 HEAP32[gb + 1452908 + 1256 >> 2] = gb + 666495;
 HEAP32[gb + 1452908 + 1260 >> 2] = 65693;
 HEAP32[gb + 1452908 + 1264 >> 2] = gb + 666529;
 HEAP32[gb + 1452908 + 1268 >> 2] = 65694;
 HEAP32[gb + 1452908 + 1272 >> 2] = gb + 666552;
 HEAP32[gb + 1452908 + 1276 >> 2] = 65695;
 HEAP32[gb + 1452908 + 1280 >> 2] = gb + 666581;
 HEAP32[gb + 1452908 + 1284 >> 2] = 65696;
 HEAP32[gb + 1452908 + 1288 >> 2] = gb + 666601;
 HEAP32[gb + 1452908 + 1292 >> 2] = 65697;
 HEAP32[gb + 1452908 + 1296 >> 2] = gb + 666626;
 HEAP32[gb + 1452908 + 1300 >> 2] = 65698;
 HEAP32[gb + 1452908 + 1304 >> 2] = gb + 666644;
 HEAP32[gb + 1452908 + 1308 >> 2] = 65699;
 HEAP32[gb + 1452908 + 1312 >> 2] = gb + 666662;
 HEAP32[gb + 1452908 + 1316 >> 2] = 65700;
 HEAP32[gb + 1452908 + 1320 >> 2] = gb + 666682;
 HEAP32[gb + 1452908 + 1324 >> 2] = 65701;
 HEAP32[gb + 1452908 + 1328 >> 2] = gb + 666711;
 HEAP32[gb + 1452908 + 1332 >> 2] = 65702;
 HEAP32[gb + 1452908 + 1336 >> 2] = gb + 666728;
 HEAP32[gb + 1452908 + 1340 >> 2] = 65703;
 HEAP32[gb + 1452908 + 1344 >> 2] = gb + 666751;
 HEAP32[gb + 1452908 + 1348 >> 2] = 65704;
 HEAP32[gb + 1452908 + 1352 >> 2] = gb + 666775;
 HEAP32[gb + 1452908 + 1356 >> 2] = 65705;
 HEAP32[gb + 1452908 + 1360 >> 2] = gb + 666800;
 HEAP32[gb + 1452908 + 1364 >> 2] = 65706;
 HEAP32[gb + 1452908 + 1368 >> 2] = gb + 666819;
 HEAP32[gb + 1452908 + 1372 >> 2] = 65707;
 HEAP32[gb + 1098824 >> 2] = 172;
 HEAP32[gb + 1098824 + 4 >> 2] = gb + 1452908;
 HEAP32[gb + 1454284 >> 2] = 65536;
 HEAP32[gb + 1454288 >> 2] = 65537;
 HEAP32[gb + 1454292 >> 2] = 65538;
 HEAP32[gb + 1454296 >> 2] = 65539;
 HEAP32[gb + 1454300 >> 2] = 65540;
 HEAP32[gb + 1454304 >> 2] = 65541;
 HEAP32[gb + 1454308 >> 2] = 65542;
 HEAP32[gb + 1454312 >> 2] = 65543;
 HEAP32[gb + 1454316 >> 2] = 65544;
 HEAP32[gb + 1454320 >> 2] = 65545;
 HEAP32[gb + 1454324 >> 2] = 65546;
 HEAP32[gb + 1454328 >> 2] = 65547;
 HEAP32[gb + 1454332 >> 2] = 65548;
 HEAP32[gb + 1454336 >> 2] = 65549;
 HEAP32[gb + 1454340 >> 2] = 65550;
 HEAP32[gb + 1454344 >> 2] = 65551;
 HEAP32[gb + 1454348 >> 2] = 65552;
 HEAP32[gb + 1454352 >> 2] = 65553;
 HEAP32[gb + 1454356 >> 2] = 65554;
 HEAP32[gb + 1454360 >> 2] = 65555;
 HEAP32[gb + 1454364 >> 2] = 65556;
 HEAP32[gb + 1454368 >> 2] = 65557;
 HEAP32[gb + 1454372 >> 2] = 65558;
 HEAP32[gb + 1454376 >> 2] = 65559;
 HEAP32[gb + 1454380 >> 2] = 65560;
 HEAP32[gb + 1454384 >> 2] = 65561;
 HEAP32[gb + 1454388 >> 2] = 65562;
 HEAP32[gb + 1454392 >> 2] = 65563;
 HEAP32[gb + 1454396 >> 2] = 65564;
 HEAP32[gb + 1454400 >> 2] = 65565;
 HEAP32[gb + 1454404 >> 2] = 65566;
 HEAP32[gb + 1454408 >> 2] = 65567;
 HEAP32[gb + 1454412 >> 2] = 32;
 HEAP32[gb + 1454416 >> 2] = 33;
 HEAP32[gb + 1454420 >> 2] = 34;
 HEAP32[gb + 1454424 >> 2] = 35;
 HEAP32[gb + 1454428 >> 2] = 36;
 HEAP32[gb + 1454432 >> 2] = 37;
 HEAP32[gb + 1454436 >> 2] = 38;
 HEAP32[gb + 1454440 >> 2] = 39;
 HEAP32[gb + 1454444 >> 2] = 65576;
 HEAP32[gb + 1454448 >> 2] = 65577;
 HEAP32[gb + 1454452 >> 2] = 65578;
 HEAP32[gb + 1454456 >> 2] = 65579;
 HEAP32[gb + 1454460 >> 2] = 65580;
 HEAP32[gb + 1454464 >> 2] = 65581;
 HEAP32[gb + 1454468 >> 2] = 65582;
 HEAP32[gb + 1454472 >> 2] = 65583;
 HEAP32[gb + 1454476 >> 2] = 65584;
 HEAP32[gb + 1454480 >> 2] = 65585;
 HEAP32[gb + 1454484 >> 2] = 65586;
 HEAP32[gb + 1454488 >> 2] = 65587;
 HEAP32[gb + 1454492 >> 2] = 65588;
 HEAP32[gb + 1454496 >> 2] = 65589;
 HEAP32[gb + 1454500 >> 2] = 65590;
 HEAP32[gb + 1454504 >> 2] = 65591;
 HEAP32[gb + 1454508 >> 2] = 65592;
 HEAP32[gb + 1454512 >> 2] = 65593;
 HEAP32[gb + 1454516 >> 2] = 65594;
 HEAP32[gb + 1454520 >> 2] = 65595;
 HEAP32[gb + 1454524 >> 2] = 65596;
 HEAP32[gb + 1454528 >> 2] = 65597;
 HEAP32[gb + 1454532 >> 2] = 65598;
 HEAP32[gb + 1454536 >> 2] = 65599;
 HEAP32[gb + 1454540 >> 2] = 65600;
 HEAP32[gb + 1454544 >> 2] = 65601;
 HEAP32[gb + 1454548 >> 2] = 65602;
 HEAP32[gb + 1454552 >> 2] = 65603;
 HEAP32[gb + 1454556 >> 2] = 65604;
 HEAP32[gb + 1454560 >> 2] = 65605;
 HEAP32[gb + 1454564 >> 2] = 65606;
 HEAP32[gb + 1454568 >> 2] = 65607;
 HEAP32[gb + 1454572 >> 2] = 65608;
 HEAP32[gb + 1454576 >> 2] = 65609;
 HEAP32[gb + 1454580 >> 2] = 65610;
 HEAP32[gb + 1454584 >> 2] = 65611;
 HEAP32[gb + 1454588 >> 2] = 65612;
 HEAP32[gb + 1454592 >> 2] = 65613;
 HEAP32[gb + 1454596 >> 2] = 65614;
 HEAP32[gb + 1454600 >> 2] = 65615;
 HEAP32[gb + 1454604 >> 2] = 65616;
 HEAP32[gb + 1454608 >> 2] = 65617;
 HEAP32[gb + 1454612 >> 2] = 65618;
 HEAP32[gb + 1454616 >> 2] = 65619;
 HEAP32[gb + 1454620 >> 2] = 65620;
 HEAP32[gb + 1454624 >> 2] = 65621;
 HEAP32[gb + 1454628 >> 2] = 65622;
 HEAP32[gb + 1454632 >> 2] = 65623;
 HEAP32[gb + 1454636 >> 2] = 65624;
 HEAP32[gb + 1454640 >> 2] = 65625;
 HEAP32[gb + 1454644 >> 2] = 65626;
 HEAP32[gb + 1454648 >> 2] = 65627;
 HEAP32[gb + 1454652 >> 2] = 65628;
 HEAP32[gb + 1454656 >> 2] = 65629;
 HEAP32[gb + 1454660 >> 2] = 65630;
 HEAP32[gb + 1454664 >> 2] = 65631;
 HEAP32[gb + 1454668 >> 2] = 65632;
 HEAP32[gb + 1454672 >> 2] = 65633;
 HEAP32[gb + 1454676 >> 2] = 65634;
 HEAP32[gb + 1454680 >> 2] = 65635;
 HEAP32[gb + 1454684 >> 2] = 65636;
 HEAP32[gb + 1454688 >> 2] = 65637;
 HEAP32[gb + 1454692 >> 2] = 65638;
 HEAP32[gb + 1454696 >> 2] = 65639;
 HEAP32[gb + 1454700 >> 2] = 65640;
 HEAP32[gb + 1454704 >> 2] = 65641;
 HEAP32[gb + 1454708 >> 2] = 65642;
 HEAP32[gb + 1454712 >> 2] = 65643;
 HEAP32[gb + 1454716 >> 2] = 65644;
 HEAP32[gb + 1454720 >> 2] = 65645;
 HEAP32[gb + 1454724 >> 2] = 65646;
 HEAP32[gb + 1454728 >> 2] = 65647;
 HEAP32[gb + 1454732 >> 2] = 65648;
 HEAP32[gb + 1454736 >> 2] = 65649;
 HEAP32[gb + 1454740 >> 2] = 65650;
 HEAP32[gb + 1454744 >> 2] = 65651;
 HEAP32[gb + 1454748 >> 2] = 65652;
 HEAP32[gb + 1454752 >> 2] = 65653;
 HEAP32[gb + 1454756 >> 2] = 65654;
 HEAP32[gb + 1454760 >> 2] = 65655;
 HEAP32[gb + 1454764 >> 2] = 65656;
 HEAP32[gb + 1454768 >> 2] = 65657;
 HEAP32[gb + 1454772 >> 2] = 65658;
 HEAP32[gb + 1454776 >> 2] = 65659;
 HEAP32[gb + 1454780 >> 2] = 65660;
 HEAP32[gb + 1454784 >> 2] = 65661;
 HEAP32[gb + 1454788 >> 2] = 65662;
 HEAP32[gb + 1454792 >> 2] = 65663;
 HEAP32[gb + 1454796 >> 2] = 65664;
 HEAP32[gb + 1454800 >> 2] = 65665;
 HEAP32[gb + 1454804 >> 2] = 65666;
 HEAP32[gb + 1454808 >> 2] = 65667;
 HEAP32[gb + 1454812 >> 2] = 65668;
 HEAP32[gb + 1454816 >> 2] = 65669;
 HEAP32[gb + 1454820 >> 2] = 65670;
 HEAP32[gb + 1454824 >> 2] = 65671;
 HEAP32[gb + 1454828 >> 2] = 65672;
 HEAP32[gb + 1454832 >> 2] = 65673;
 HEAP32[gb + 1454836 >> 2] = 65674;
 HEAP32[gb + 1454840 >> 2] = 65675;
 HEAP32[gb + 1454844 >> 2] = 65676;
 HEAP32[gb + 1454848 >> 2] = 65677;
 HEAP32[gb + 1454852 >> 2] = 65678;
 HEAP32[gb + 1454856 >> 2] = 65679;
 HEAP32[gb + 1454860 >> 2] = 65680;
 HEAP32[gb + 1454864 >> 2] = 65681;
 HEAP32[gb + 1454868 >> 2] = 65682;
 HEAP32[gb + 1454872 >> 2] = 65683;
 HEAP32[gb + 1454876 >> 2] = 65684;
 HEAP32[gb + 1454880 >> 2] = 65685;
 HEAP32[gb + 1454884 >> 2] = 65686;
 HEAP32[gb + 1454888 >> 2] = 65687;
 HEAP32[gb + 1454892 >> 2] = 65688;
 HEAP32[gb + 1454896 >> 2] = 65689;
 HEAP32[gb + 1454900 >> 2] = 65690;
 HEAP32[gb + 1454904 >> 2] = 65691;
 HEAP32[gb + 1454908 >> 2] = 65692;
 HEAP32[gb + 1454912 >> 2] = 65693;
 HEAP32[gb + 1454916 >> 2] = 65694;
 HEAP32[gb + 1454920 >> 2] = 65695;
 HEAP32[gb + 1454924 >> 2] = 65696;
 HEAP32[gb + 1454928 >> 2] = 65697;
 HEAP32[gb + 1454932 >> 2] = 65698;
 HEAP32[gb + 1454936 >> 2] = 65699;
 HEAP32[gb + 1454940 >> 2] = 65700;
 HEAP32[gb + 1454944 >> 2] = 65701;
 HEAP32[gb + 1454948 >> 2] = 65702;
 HEAP32[gb + 1454952 >> 2] = 65703;
 HEAP32[gb + 1454956 >> 2] = 65704;
 HEAP32[gb + 1454960 >> 2] = 65705;
 HEAP32[gb + 1454964 >> 2] = 65706;
 HEAP32[gb + 1454968 >> 2] = 65707;
 return;
}

function _UNITY_LZ4_decompress_fast_usingDict(i18, i3, i14, i1, i2) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 if (!i2) {
  i12 = i3 + i14 | 0;
  i13 = i12 + -12 | 0;
  if (!i14) {
   i19 = (HEAP8[i18 >> 0] | 0) == 0 ? 1 : -1;
   return i19 | 0;
  }
  i11 = i12 + -5 | 0;
  i9 = i12 + -8 | 0;
  i10 = i9;
  i2 = i18;
  L7 : while (1) {
   i1 = i2 + 1 | 0;
   i7 = HEAPU8[i2 >> 0] | 0;
   i2 = i7 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i4 = i1 + 1 | 0;
     i17 = HEAP8[i1 >> 0] | 0;
     i2 = (i17 & 255) + i2 | 0;
     if (i17 << 24 >> 24 == -1) i1 = i4; else {
      i1 = i4;
      break;
     }
    }
   }
   i8 = i3 + i2 | 0;
   if (i8 >>> 0 > i9 >>> 0) {
    i19 = 8;
    break;
   } else i4 = i1;
   while (1) {
    i16 = i4;
    i14 = i16;
    i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
    i16 = i16 + 4 | 0;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i17 = i3;
    i15 = i17;
    HEAP8[i15 >> 0] = i14;
    HEAP8[i15 + 1 >> 0] = i14 >> 8;
    HEAP8[i15 + 2 >> 0] = i14 >> 16;
    HEAP8[i15 + 3 >> 0] = i14 >> 24;
    i17 = i17 + 4 | 0;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i3 = i3 + 8 | 0;
    if (i3 >>> 0 >= i8 >>> 0) break; else i4 = i4 + 8 | 0;
   }
   i1 = i1 + i2 | 0;
   i4 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i5 = i4 & 65535;
   i6 = i8 + (0 - i4) | 0;
   i1 = i1 + 2 | 0;
   i2 = i7 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i3 = i1 + 1 | 0;
     i17 = HEAP8[i1 >> 0] | 0;
     i2 = (i17 & 255) + i2 | 0;
     if (i17 << 24 >> 24 == -1) i1 = i3; else {
      i1 = i3;
      break;
     }
    }
   }
   i7 = i8 + (i2 + 4) | 0;
   if ((i5 & 65535) < 8) {
    i3 = HEAP32[gb + 74112 + (i4 << 2) >> 2] | 0;
    HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
    HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
    i17 = i6 + (HEAP32[gb + 74144 + (i4 << 2) >> 2] | 0) | 0;
    i16 = i8 + 4 | 0;
    i15 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    HEAP8[i16 >> 0] = i15;
    HEAP8[i16 + 1 >> 0] = i15 >> 8;
    HEAP8[i16 + 2 >> 0] = i15 >> 16;
    HEAP8[i16 + 3 >> 0] = i15 >> 24;
    i3 = i17 + (0 - i3) | 0;
   } else {
    i17 = i6;
    i15 = i17;
    i15 = HEAPU8[i15 >> 0] | HEAPU8[i15 + 1 >> 0] << 8 | HEAPU8[i15 + 2 >> 0] << 16 | HEAPU8[i15 + 3 >> 0] << 24;
    i17 = i17 + 4 | 0;
    i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    i3 = i8;
    i16 = i3;
    HEAP8[i16 >> 0] = i15;
    HEAP8[i16 + 1 >> 0] = i15 >> 8;
    HEAP8[i16 + 2 >> 0] = i15 >> 16;
    HEAP8[i16 + 3 >> 0] = i15 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i17;
    HEAP8[i3 + 1 >> 0] = i17 >> 8;
    HEAP8[i3 + 2 >> 0] = i17 >> 16;
    HEAP8[i3 + 3 >> 0] = i17 >> 24;
    i3 = i6 + 8 | 0;
   }
   i2 = i8 + 8 | 0;
   if (i7 >>> 0 <= i13 >>> 0) while (1) {
    i16 = i3;
    i14 = i16;
    i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
    i16 = i16 + 4 | 0;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i17 = i2;
    i15 = i17;
    HEAP8[i15 >> 0] = i14;
    HEAP8[i15 + 1 >> 0] = i14 >> 8;
    HEAP8[i15 + 2 >> 0] = i14 >> 16;
    HEAP8[i15 + 3 >> 0] = i14 >> 24;
    i17 = i17 + 4 | 0;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
     i2 = i1;
     i3 = i7;
     continue L7;
    }
   }
   if (i7 >>> 0 > i11 >>> 0) break;
   if (i2 >>> 0 < i9 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i16 = i5;
     i14 = i16;
     i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
     i16 = i16 + 4 | 0;
     i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
     i17 = i4;
     i15 = i17;
     HEAP8[i15 >> 0] = i14;
     HEAP8[i15 + 1 >> 0] = i14 >> 8;
     HEAP8[i15 + 2 >> 0] = i14 >> 16;
     HEAP8[i15 + 3 >> 0] = i14 >> 24;
     i17 = i17 + 4 | 0;
     HEAP8[i17 >> 0] = i16;
     HEAP8[i17 + 1 >> 0] = i16 >> 8;
     HEAP8[i17 + 2 >> 0] = i16 >> 16;
     HEAP8[i17 + 3 >> 0] = i16 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i9 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i10 - i2) | 0;
    i2 = i9;
   }
   if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i1;
    i3 = i7;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i7 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i2 = i1;
     i3 = i7;
     continue L7;
    }
   }
  }
  if ((i19 | 0) == 8) if ((i8 | 0) == (i12 | 0)) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   i19 = i1 + i2 - i18 | 0;
   return i19 | 0;
  }
  i19 = i18 + -1 - i1 | 0;
  return i19 | 0;
 }
 i17 = i1 + i2 | 0;
 if ((i17 | 0) != (i3 | 0)) {
  i15 = i3 + i14 | 0;
  i16 = i15 + -12 | 0;
  if (!i14) {
   i19 = (HEAP8[i18 >> 0] | 0) == 0 ? 1 : -1;
   return i19 | 0;
  }
  i11 = i15 + -5 | 0;
  i12 = i3;
  i13 = i15 + -8 | 0;
  i14 = i13;
  i5 = i18;
  i4 = i3;
  L49 : while (1) {
   i1 = i5 + 1 | 0;
   i9 = HEAPU8[i5 >> 0] | 0;
   i2 = i9 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i5 = i1 + 1 | 0;
     i10 = HEAP8[i1 >> 0] | 0;
     i2 = (i10 & 255) + i2 | 0;
     if (i10 << 24 >> 24 == -1) i1 = i5; else {
      i1 = i5;
      break;
     }
    }
   }
   i10 = i4 + i2 | 0;
   if (i10 >>> 0 > i13 >>> 0) {
    i19 = 79;
    break;
   } else i5 = i1;
   while (1) {
    i7 = i5;
    i20 = i7;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i7 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i8 = i4;
    i6 = i8;
    HEAP8[i6 >> 0] = i20;
    HEAP8[i6 + 1 >> 0] = i20 >> 8;
    HEAP8[i6 + 2 >> 0] = i20 >> 16;
    HEAP8[i6 + 3 >> 0] = i20 >> 24;
    i8 = i8 + 4 | 0;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i10 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i1 = i1 + i2 | 0;
   i6 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i7 = i6 & 65535;
   i8 = i10 + (0 - i6) | 0;
   i1 = i1 + 2 | 0;
   i2 = i9 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i4 = i1 + 1 | 0;
     i20 = HEAP8[i1 >> 0] | 0;
     i2 = (i20 & 255) + i2 | 0;
     if (i20 << 24 >> 24 == -1) i1 = i4; else {
      i1 = i4;
      break;
     }
    }
   }
   i5 = i2 + 4 | 0;
   i9 = i10 + i5 | 0;
   if (i8 >>> 0 < i3 >>> 0) {
    if (i9 >>> 0 > i11 >>> 0) break;
    i4 = i12 - i8 | 0;
    i2 = i17 + (0 - i4) | 0;
    if (i5 >>> 0 <= i4 >>> 0) {
     _memcpy(i10 | 0, i2 | 0, i5 | 0) | 0;
     i5 = i1;
     i4 = i9;
     continue;
    }
    _memcpy(i10 | 0, i2 | 0, i4 | 0) | 0;
    i2 = i10 + i4 | 0;
    i4 = i5 - i4 | 0;
    if (i4 >>> 0 <= (i2 - i12 | 0) >>> 0) {
     _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
     i5 = i1;
     i4 = i2 + i4 | 0;
     continue;
    }
    i6 = i2 + i4 | 0;
    if ((i4 | 0) > 0) i5 = i3; else {
     i5 = i1;
     i4 = i2;
     continue;
    }
    while (1) {
     i4 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
     if (i4 >>> 0 < i6 >>> 0) {
      i5 = i5 + 1 | 0;
      i2 = i4;
     } else {
      i5 = i1;
      continue L49;
     }
    }
   }
   if ((i7 & 65535) < 8) {
    i4 = HEAP32[gb + 74112 + (i6 << 2) >> 2] | 0;
    HEAP8[i10 >> 0] = HEAP8[i8 >> 0] | 0;
    HEAP8[i10 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
    HEAP8[i10 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
    HEAP8[i10 + 3 >> 0] = HEAP8[i8 + 3 >> 0] | 0;
    i20 = i8 + (HEAP32[gb + 74144 + (i6 << 2) >> 2] | 0) | 0;
    i8 = i10 + 4 | 0;
    i7 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i4 = i20 + (0 - i4) | 0;
   } else {
    i20 = i8;
    i6 = i20;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i20 = i20 + 4 | 0;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i4 = i10;
    i7 = i4;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i4 = i4 + 4 | 0;
    HEAP8[i4 >> 0] = i20;
    HEAP8[i4 + 1 >> 0] = i20 >> 8;
    HEAP8[i4 + 2 >> 0] = i20 >> 16;
    HEAP8[i4 + 3 >> 0] = i20 >> 24;
    i4 = i8 + 8 | 0;
   }
   i2 = i10 + 8 | 0;
   if (i9 >>> 0 <= i16 >>> 0) while (1) {
    i10 = i4;
    i7 = i10;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i10 = i10 + 4 | 0;
    i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
    i20 = i2;
    i8 = i20;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i20 = i20 + 4 | 0;
    HEAP8[i20 >> 0] = i10;
    HEAP8[i20 + 1 >> 0] = i10 >> 8;
    HEAP8[i20 + 2 >> 0] = i10 >> 16;
    HEAP8[i20 + 3 >> 0] = i10 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i9 >>> 0) i4 = i4 + 8 | 0; else {
     i5 = i1;
     i4 = i9;
     continue L49;
    }
   }
   if (i9 >>> 0 > i11 >>> 0) break;
   if (i2 >>> 0 < i13 >>> 0) {
    i5 = i2;
    i6 = i4;
    while (1) {
     i10 = i6;
     i7 = i10;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i10 = i10 + 4 | 0;
     i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
     i20 = i5;
     i8 = i20;
     HEAP8[i8 >> 0] = i7;
     HEAP8[i8 + 1 >> 0] = i7 >> 8;
     HEAP8[i8 + 2 >> 0] = i7 >> 16;
     HEAP8[i8 + 3 >> 0] = i7 >> 24;
     i20 = i20 + 4 | 0;
     HEAP8[i20 >> 0] = i10;
     HEAP8[i20 + 1 >> 0] = i10 >> 8;
     HEAP8[i20 + 2 >> 0] = i10 >> 16;
     HEAP8[i20 + 3 >> 0] = i10 >> 24;
     i5 = i5 + 8 | 0;
     if (i5 >>> 0 >= i13 >>> 0) break; else i6 = i6 + 8 | 0;
    }
    i4 = i4 + (i14 - i2) | 0;
    i2 = i13;
   }
   if (i2 >>> 0 >= i9 >>> 0) {
    i5 = i1;
    i4 = i9;
    continue;
   }
   while (1) {
    i5 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
    if (i5 >>> 0 < i9 >>> 0) {
     i4 = i4 + 1 | 0;
     i2 = i5;
    } else {
     i5 = i1;
     i4 = i9;
     continue L49;
    }
   }
  }
  if ((i19 | 0) == 79) if ((i10 | 0) == (i15 | 0)) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i20 = i1 + i2 - i18 | 0;
   return i20 | 0;
  }
  i20 = i18 + -1 - i1 | 0;
  return i20 | 0;
 }
 i12 = i3 + i14 | 0;
 i15 = i12 + -12 | 0;
 i1 = (i14 | 0) == 0;
 if ((i2 | 0) > 65534) {
  if (i1) {
   i20 = (HEAP8[i18 >> 0] | 0) == 0 ? 1 : -1;
   return i20 | 0;
  }
  i13 = i12 + -5 | 0;
  i11 = i12 + -8 | 0;
  i12 = i11;
  i2 = i18;
  i6 = 0;
  L103 : while (1) {
   i4 = i3 + i6 | 0;
   i1 = i2 + 1 | 0;
   i9 = HEAPU8[i2 >> 0] | 0;
   i2 = i9 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i5 = i1 + 1 | 0;
     i20 = HEAP8[i1 >> 0] | 0;
     i2 = (i20 & 255) + i2 | 0;
     if (i20 << 24 >> 24 == -1) i1 = i5; else {
      i1 = i5;
      break;
     }
    }
   }
   i8 = i2 + i6 | 0;
   i10 = i3 + i8 | 0;
   if (i10 >>> 0 > i11 >>> 0) {
    i19 = 33;
    break;
   } else i5 = i1;
   while (1) {
    i17 = i5;
    i7 = i17;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i17 = i17 + 4 | 0;
    i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    i20 = i4;
    i16 = i20;
    HEAP8[i16 >> 0] = i7;
    HEAP8[i16 + 1 >> 0] = i7 >> 8;
    HEAP8[i16 + 2 >> 0] = i7 >> 16;
    HEAP8[i16 + 3 >> 0] = i7 >> 24;
    i20 = i20 + 4 | 0;
    HEAP8[i20 >> 0] = i17;
    HEAP8[i20 + 1 >> 0] = i17 >> 8;
    HEAP8[i20 + 2 >> 0] = i17 >> 16;
    HEAP8[i20 + 3 >> 0] = i17 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i10 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i1 = i1 + i2 | 0;
   i6 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i7 = i6 & 65535;
   i5 = i3 + (i8 - i6) | 0;
   i1 = i1 + 2 | 0;
   i2 = i9 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i4 = i1 + 1 | 0;
     i20 = HEAP8[i1 >> 0] | 0;
     i2 = (i20 & 255) + i2 | 0;
     if (i20 << 24 >> 24 == -1) i1 = i4; else {
      i1 = i4;
      break;
     }
    }
   }
   i9 = i8 + 4 + i2 | 0;
   i8 = i3 + i9 | 0;
   if ((i7 & 65535) < 8) {
    i4 = HEAP32[gb + 74112 + (i6 << 2) >> 2] | 0;
    HEAP8[i10 >> 0] = HEAP8[i5 >> 0] | 0;
    HEAP8[i10 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
    HEAP8[i10 + 2 >> 0] = HEAP8[i5 + 2 >> 0] | 0;
    HEAP8[i10 + 3 >> 0] = HEAP8[i5 + 3 >> 0] | 0;
    i20 = i5 + (HEAP32[gb + 74144 + (i6 << 2) >> 2] | 0) | 0;
    i17 = i10 + 4 | 0;
    i16 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i4 = i20 + (0 - i4) | 0;
   } else {
    i20 = i5;
    i16 = i20;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i20 = i20 + 4 | 0;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i4 = i10;
    i17 = i4;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i4 = i4 + 4 | 0;
    HEAP8[i4 >> 0] = i20;
    HEAP8[i4 + 1 >> 0] = i20 >> 8;
    HEAP8[i4 + 2 >> 0] = i20 >> 16;
    HEAP8[i4 + 3 >> 0] = i20 >> 24;
    i4 = i5 + 8 | 0;
   }
   i2 = i10 + 8 | 0;
   if (i8 >>> 0 <= i15 >>> 0) while (1) {
    i17 = i4;
    i10 = i17;
    i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
    i17 = i17 + 4 | 0;
    i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    i20 = i2;
    i16 = i20;
    HEAP8[i16 >> 0] = i10;
    HEAP8[i16 + 1 >> 0] = i10 >> 8;
    HEAP8[i16 + 2 >> 0] = i10 >> 16;
    HEAP8[i16 + 3 >> 0] = i10 >> 24;
    i20 = i20 + 4 | 0;
    HEAP8[i20 >> 0] = i17;
    HEAP8[i20 + 1 >> 0] = i17 >> 8;
    HEAP8[i20 + 2 >> 0] = i17 >> 16;
    HEAP8[i20 + 3 >> 0] = i17 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i8 >>> 0) i4 = i4 + 8 | 0; else {
     i2 = i1;
     i6 = i9;
     continue L103;
    }
   }
   if (i8 >>> 0 > i13 >>> 0) break;
   if (i2 >>> 0 < i11 >>> 0) {
    i5 = i2;
    i6 = i4;
    while (1) {
     i17 = i6;
     i10 = i17;
     i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
     i17 = i17 + 4 | 0;
     i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
     i20 = i5;
     i16 = i20;
     HEAP8[i16 >> 0] = i10;
     HEAP8[i16 + 1 >> 0] = i10 >> 8;
     HEAP8[i16 + 2 >> 0] = i10 >> 16;
     HEAP8[i16 + 3 >> 0] = i10 >> 24;
     i20 = i20 + 4 | 0;
     HEAP8[i20 >> 0] = i17;
     HEAP8[i20 + 1 >> 0] = i17 >> 8;
     HEAP8[i20 + 2 >> 0] = i17 >> 16;
     HEAP8[i20 + 3 >> 0] = i17 >> 24;
     i5 = i5 + 8 | 0;
     if (i5 >>> 0 >= i11 >>> 0) break; else i6 = i6 + 8 | 0;
    }
    i4 = i4 + (i12 - i2) | 0;
    i2 = i11;
   }
   if (i2 >>> 0 >= i8 >>> 0) {
    i2 = i1;
    i6 = i9;
    continue;
   }
   while (1) {
    i5 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
    if (i5 >>> 0 < i8 >>> 0) {
     i4 = i4 + 1 | 0;
     i2 = i5;
    } else {
     i2 = i1;
     i6 = i9;
     continue L103;
    }
   }
  }
  if ((i19 | 0) == 33) if ((i8 | 0) == (i14 | 0)) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i20 = i1 + i2 - i18 | 0;
   return i20 | 0;
  }
  i20 = i18 + -1 - i1 | 0;
  return i20 | 0;
 } else {
  if (i1) {
   i20 = (HEAP8[i18 >> 0] | 0) == 0 ? 1 : -1;
   return i20 | 0;
  }
  i9 = i12 + -5 | 0;
  i10 = i12 + -8 | 0;
  i11 = i10;
  i2 = i18;
  L143 : while (1) {
   i1 = i2 + 1 | 0;
   i7 = HEAPU8[i2 >> 0] | 0;
   i2 = i7 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i4 = i1 + 1 | 0;
     i20 = HEAP8[i1 >> 0] | 0;
     i2 = (i20 & 255) + i2 | 0;
     if (i20 << 24 >> 24 == -1) i1 = i4; else {
      i1 = i4;
      break;
     }
    }
   }
   i8 = i3 + i2 | 0;
   if (i8 >>> 0 > i10 >>> 0) {
    i19 = 56;
    break;
   } else i4 = i1;
   while (1) {
    i17 = i4;
    i14 = i17;
    i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
    i17 = i17 + 4 | 0;
    i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    i20 = i3;
    i16 = i20;
    HEAP8[i16 >> 0] = i14;
    HEAP8[i16 + 1 >> 0] = i14 >> 8;
    HEAP8[i16 + 2 >> 0] = i14 >> 16;
    HEAP8[i16 + 3 >> 0] = i14 >> 24;
    i20 = i20 + 4 | 0;
    HEAP8[i20 >> 0] = i17;
    HEAP8[i20 + 1 >> 0] = i17 >> 8;
    HEAP8[i20 + 2 >> 0] = i17 >> 16;
    HEAP8[i20 + 3 >> 0] = i17 >> 24;
    i3 = i3 + 8 | 0;
    if (i3 >>> 0 >= i8 >>> 0) break; else i4 = i4 + 8 | 0;
   }
   i1 = i1 + i2 | 0;
   i4 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i5 = i4 & 65535;
   i6 = i8 + (0 - i4) | 0;
   i1 = i1 + 2 | 0;
   i2 = i7 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i3 = i1 + 1 | 0;
     i20 = HEAP8[i1 >> 0] | 0;
     i2 = (i20 & 255) + i2 | 0;
     if (i20 << 24 >> 24 == -1) i1 = i3; else {
      i1 = i3;
      break;
     }
    }
   }
   i7 = i8 + (i2 + 4) | 0;
   if ((i5 & 65535) < 8) {
    i3 = HEAP32[gb + 74112 + (i4 << 2) >> 2] | 0;
    HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
    HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
    i20 = i6 + (HEAP32[gb + 74144 + (i4 << 2) >> 2] | 0) | 0;
    i17 = i8 + 4 | 0;
    i16 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i3 = i20 + (0 - i3) | 0;
   } else {
    i20 = i6;
    i16 = i20;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i20 = i20 + 4 | 0;
    i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
    i3 = i8;
    i17 = i3;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i20;
    HEAP8[i3 + 1 >> 0] = i20 >> 8;
    HEAP8[i3 + 2 >> 0] = i20 >> 16;
    HEAP8[i3 + 3 >> 0] = i20 >> 24;
    i3 = i6 + 8 | 0;
   }
   i2 = i8 + 8 | 0;
   if (i7 >>> 0 <= i15 >>> 0) while (1) {
    i17 = i3;
    i14 = i17;
    i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
    i17 = i17 + 4 | 0;
    i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
    i20 = i2;
    i16 = i20;
    HEAP8[i16 >> 0] = i14;
    HEAP8[i16 + 1 >> 0] = i14 >> 8;
    HEAP8[i16 + 2 >> 0] = i14 >> 16;
    HEAP8[i16 + 3 >> 0] = i14 >> 24;
    i20 = i20 + 4 | 0;
    HEAP8[i20 >> 0] = i17;
    HEAP8[i20 + 1 >> 0] = i17 >> 8;
    HEAP8[i20 + 2 >> 0] = i17 >> 16;
    HEAP8[i20 + 3 >> 0] = i17 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
     i2 = i1;
     i3 = i7;
     continue L143;
    }
   }
   if (i7 >>> 0 > i9 >>> 0) break;
   if (i2 >>> 0 < i10 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i17 = i5;
     i14 = i17;
     i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24;
     i17 = i17 + 4 | 0;
     i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
     i20 = i4;
     i16 = i20;
     HEAP8[i16 >> 0] = i14;
     HEAP8[i16 + 1 >> 0] = i14 >> 8;
     HEAP8[i16 + 2 >> 0] = i14 >> 16;
     HEAP8[i16 + 3 >> 0] = i14 >> 24;
     i20 = i20 + 4 | 0;
     HEAP8[i20 >> 0] = i17;
     HEAP8[i20 + 1 >> 0] = i17 >> 8;
     HEAP8[i20 + 2 >> 0] = i17 >> 16;
     HEAP8[i20 + 3 >> 0] = i17 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i10 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i11 - i2) | 0;
    i2 = i10;
   }
   if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i1;
    i3 = i7;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i7 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i2 = i1;
     i3 = i7;
     continue L143;
    }
   }
  }
  if ((i19 | 0) == 56) if ((i8 | 0) == (i12 | 0)) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   i20 = i1 + i2 - i18 | 0;
   return i20 | 0;
  }
  i20 = i18 + -1 - i1 | 0;
  return i20 | 0;
 }
 return 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i108, i3, i95, i1, i97, i96, i110, i111, i109, f2) {
 i108 = i108 | 0;
 i3 = i3 | 0;
 i95 = i95 | 0;
 i1 = i1 | 0;
 i97 = i97 | 0;
 i96 = i96 | 0;
 i110 = i110 | 0;
 i111 = i111 | 0;
 i109 = i109 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, f98 = f0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i112 = 0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, i117 = 0, i118 = 0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0;
 i112 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i107 = i112 + 192 | 0;
 i102 = i112 + 288 | 0;
 i106 = i112 + 284 | 0;
 i101 = i112 + 208 | 0;
 i99 = i112 + 128 | 0;
 i100 = i112 + 64 | 0;
 i58 = i112 + 272 | 0;
 i59 = i112 + 48 | 0;
 i105 = i112 + 32 | 0;
 i103 = i112 + 16 | 0;
 i104 = i112;
 HEAP32[i107 >> 2] = 0;
 HEAP32[i107 + 4 >> 2] = 0;
 HEAP32[i107 + 8 >> 2] = 0;
 HEAP32[i107 + 12 >> 2] = 0;
 f4 = Math_fround(HEAPF32[i96 >> 2]);
 i74 = i96 + 4 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i96 + 8 | 0;
 f13 = Math_fround(HEAPF32[i75 >> 2]);
 f5 = Math_fround(HEAPF32[i97 >> 2]);
 i84 = i97 + 4 | 0;
 f8 = Math_fround(HEAPF32[i84 >> 2]);
 i94 = i97 + 8 | 0;
 f9 = Math_fround(HEAPF32[i94 >> 2]);
 HEAP32[i106 >> 2] = 1;
 i60 = i95 + 48 | 0;
 f21 = Math_fround(HEAPF32[i60 >> 2]);
 i61 = i95 + 52 | 0;
 f24 = Math_fround(HEAPF32[i61 >> 2]);
 i65 = i95 + 56 | 0;
 f27 = Math_fround(HEAPF32[i65 >> 2]);
 i76 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f24 * f24)) + Math_fround(f27 * f27)) > Math_fround(1.1920929e-07);
 f14 = i76 ? f21 : Math_fround(1.0);
 f15 = i76 ? f24 : Math_fround(0.0);
 f28 = i76 ? f27 : Math_fround(0.0);
 f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f28 * f28) + Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))))));
 f14 = Math_fround(f14 * f16);
 f15 = Math_fround(f15 * f16);
 f16 = Math_fround(f28 * f16);
 f28 = Math_fround(-f14);
 f11 = Math_fround(-f15);
 f10 = Math_fround(-f16);
 f23 = Math_fround(HEAPF32[i95 >> 2]);
 f116 = Math_fround(f23 * f28);
 i76 = i95 + 4 | 0;
 f26 = Math_fround(HEAPF32[i76 >> 2]);
 f116 = Math_fround(f116 + Math_fround(f26 * f11));
 i77 = i95 + 8 | 0;
 f98 = Math_fround(HEAPF32[i77 >> 2]);
 f116 = Math_fround(f116 + Math_fround(f98 * f10));
 i78 = i95 + 16 | 0;
 f30 = Math_fround(HEAPF32[i78 >> 2]);
 f115 = Math_fround(f30 * f28);
 i79 = i95 + 20 | 0;
 f31 = Math_fround(HEAPF32[i79 >> 2]);
 f115 = Math_fround(f115 + Math_fround(f31 * f11));
 i80 = i95 + 24 | 0;
 f33 = Math_fround(HEAPF32[i80 >> 2]);
 f115 = Math_fround(f115 + Math_fround(f33 * f10));
 i81 = i95 + 32 | 0;
 f22 = Math_fround(HEAPF32[i81 >> 2]);
 f28 = Math_fround(f22 * f28);
 i82 = i95 + 36 | 0;
 f25 = Math_fround(HEAPF32[i82 >> 2]);
 f11 = Math_fround(f28 + Math_fround(f25 * f11));
 i83 = i95 + 40 | 0;
 f28 = Math_fround(HEAPF32[i83 >> 2]);
 f10 = Math_fround(f11 + Math_fround(f28 * f10));
 i85 = i108 + 96 | 0;
 f11 = Math_fround(HEAPF32[i85 >> 2]);
 i86 = i108 + 100 | 0;
 f17 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i108 + 104 | 0;
 f19 = Math_fround(HEAPF32[i87 >> 2]);
 i88 = i108 + 112 | 0;
 f12 = Math_fround(HEAPF32[i88 >> 2]);
 i89 = i108 + 116 | 0;
 f18 = Math_fround(HEAPF32[i89 >> 2]);
 i90 = i108 + 120 | 0;
 f20 = Math_fround(HEAPF32[i90 >> 2]);
 i91 = i108 + 128 | 0;
 f32 = Math_fround(HEAPF32[i91 >> 2]);
 i92 = i108 + 132 | 0;
 f6 = Math_fround(HEAPF32[i92 >> 2]);
 i93 = i108 + 136 | 0;
 f29 = Math_fround(HEAPF32[i93 >> 2]);
 f114 = Math_fround(Math_fround(Math_fround(f116 * f11) + Math_fround(f115 * f17)) + Math_fround(f10 * f19));
 f113 = Math_fround(Math_fround(Math_fround(f116 * f12) + Math_fround(f115 * f18)) + Math_fround(f10 * f20));
 f10 = Math_fround(Math_fround(Math_fround(f116 * f32) + Math_fround(f115 * f6)) + Math_fround(f10 * f29));
 i67 = f114 > f113 & f114 > f10;
 i68 = f113 > f10;
 f32 = i67 ? f11 : i68 ? f12 : f32;
 f6 = i67 ? f17 : i68 ? f18 : f6;
 f29 = i67 ? f19 : i68 ? f20 : f29;
 f30 = Math_fround(f21 + Math_fround(Math_fround(f22 * f29) + Math_fround(Math_fround(f23 * f32) + Math_fround(f30 * f6))));
 f31 = Math_fround(f24 + Math_fround(Math_fround(f25 * f29) + Math_fround(Math_fround(f26 * f32) + Math_fround(f31 * f6))));
 f6 = Math_fround(f27 + Math_fround(Math_fround(f28 * f29) + Math_fround(Math_fround(f98 * f32) + Math_fround(f33 * f6))));
 i68 = f14 > Math_fround(0.0);
 i67 = f15 > Math_fround(0.0);
 i66 = f16 > Math_fround(0.0);
 i62 = i3 + 144 | 0;
 f16 = Math_fround(HEAPF32[i62 >> 2]);
 i63 = i3 + 148 | 0;
 f15 = Math_fround(HEAPF32[i63 >> 2]);
 i64 = i3 + 152 | 0;
 f14 = Math_fround(HEAPF32[i64 >> 2]);
 f33 = Math_fround(-f16);
 f32 = Math_fround(-f15);
 f98 = Math_fround(-f14);
 f33 = i68 ? f16 : f33;
 f32 = i67 ? f15 : f32;
 f98 = i66 ? f14 : f98;
 f14 = Math_fround(f30 - f33);
 f15 = Math_fround(f31 - f32);
 f16 = Math_fround(f6 - f98);
 HEAPF32[i101 >> 2] = f14;
 i66 = i101 + 4 | 0;
 HEAPF32[i66 >> 2] = f15;
 i67 = i101 + 8 | 0;
 HEAPF32[i67 >> 2] = f16;
 i68 = i101 + 12 | 0;
 HEAPF32[i68 >> 2] = Math_fround(0.0);
 i69 = i101 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i69 = i101 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i69 = i101 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAPF32[i99 >> 2] = f30;
 i69 = i99 + 4 | 0;
 HEAPF32[i69 >> 2] = f31;
 i70 = i99 + 8 | 0;
 HEAPF32[i70 >> 2] = f6;
 HEAPF32[i99 + 12 >> 2] = Math_fround(0.0);
 i71 = i99 + 16 | 0;
 HEAP32[i71 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i71 = i99 + 32 | 0;
 HEAP32[i71 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i71 = i99 + 48 | 0;
 HEAP32[i71 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i71 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i71 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i71 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAPF32[i100 >> 2] = f33;
 i71 = i100 + 4 | 0;
 HEAPF32[i71 >> 2] = f32;
 i72 = i100 + 8 | 0;
 HEAPF32[i72 >> 2] = f98;
 i73 = i100 + 12 | 0;
 HEAPF32[i73 >> 2] = Math_fround(0.0);
 i57 = i100 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i57 = i100 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i57 = i100 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 f98 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i57 = f98 < Math_fround(3402823469999999843913219.0e14);
 f98 = Math_fround(f98 * Math_fround(.100000001));
 f98 = i57 ? f98 : Math_fround(3402823469999999938360549.0e13);
 f32 = Math_fround(f98 + f2);
 f98 = Math_fround(f98 * f98);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f98) {
  i3 = i100 + 16 | 0;
  i34 = i100 + 20 | 0;
  i35 = i100 + 24 | 0;
  i36 = i100 + 28 | 0;
  i37 = i100 + 32 | 0;
  i38 = i100 + 36 | 0;
  i39 = i100 + 40 | 0;
  i40 = i100 + 44 | 0;
  i41 = i99 + 16 | 0;
  i42 = i99 + 20 | 0;
  i43 = i99 + 24 | 0;
  i44 = i101 + 16 | 0;
  i45 = i101 + 20 | 0;
  i46 = i101 + 24 | 0;
  i47 = i101 + 28 | 0;
  i48 = i99 + 32 | 0;
  i49 = i99 + 36 | 0;
  i50 = i99 + 40 | 0;
  i51 = i101 + 32 | 0;
  i52 = i101 + 36 | 0;
  i53 = i101 + 40 | 0;
  i54 = i101 + 44 | 0;
  i55 = i59 + 4 | 0;
  i56 = i59 + 8 | 0;
  i57 = i59 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f4 * Math_fround(0.0)) + f5);
  f30 = Math_fround(Math_fround(f7 * Math_fround(0.0)) + f8);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f17 = Math_fround(f10 * f18);
   f7 = Math_fround(f11 * f18);
   f18 = Math_fround(f12 * f18);
   f115 = Math_fround(-f17);
   f116 = Math_fround(-f7);
   f8 = Math_fround(-f18);
   f24 = Math_fround(HEAPF32[i95 >> 2]);
   f125 = Math_fround(f24 * f115);
   f15 = Math_fround(HEAPF32[i76 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f15 * f116));
   f16 = Math_fround(HEAPF32[i77 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f16 * f8));
   f25 = Math_fround(HEAPF32[i78 >> 2]);
   f124 = Math_fround(f25 * f115);
   f26 = Math_fround(HEAPF32[i79 >> 2]);
   f124 = Math_fround(f124 + Math_fround(f26 * f116));
   f21 = Math_fround(HEAPF32[i80 >> 2]);
   f124 = Math_fround(f124 + Math_fround(f21 * f8));
   f19 = Math_fround(HEAPF32[i81 >> 2]);
   f121 = Math_fround(f19 * f115);
   f22 = Math_fround(HEAPF32[i82 >> 2]);
   f121 = Math_fround(f121 + Math_fround(f22 * f116));
   f14 = Math_fround(HEAPF32[i83 >> 2]);
   f121 = Math_fround(f121 + Math_fround(f14 * f8));
   f120 = Math_fround(HEAPF32[i85 >> 2]);
   f13 = Math_fround(HEAPF32[i86 >> 2]);
   f23 = Math_fround(HEAPF32[i87 >> 2]);
   f119 = Math_fround(HEAPF32[i88 >> 2]);
   f113 = Math_fround(HEAPF32[i89 >> 2]);
   f114 = Math_fround(HEAPF32[i90 >> 2]);
   f20 = Math_fround(HEAPF32[i91 >> 2]);
   f27 = Math_fround(HEAPF32[i92 >> 2]);
   f9 = Math_fround(HEAPF32[i93 >> 2]);
   f123 = Math_fround(Math_fround(Math_fround(f125 * f120) + Math_fround(f124 * f13)) + Math_fround(f121 * f23));
   f122 = Math_fround(Math_fround(Math_fround(f125 * f119) + Math_fround(f124 * f113)) + Math_fround(f121 * f114));
   f121 = Math_fround(Math_fround(Math_fround(f125 * f20) + Math_fround(f124 * f27)) + Math_fround(f121 * f9));
   i117 = f123 > f122 & f123 > f121;
   i118 = f122 > f121;
   f20 = i117 ? f120 : i118 ? f119 : f20;
   f27 = i117 ? f13 : i118 ? f113 : f27;
   f9 = i117 ? f23 : i118 ? f114 : f9;
   f114 = Math_fround(HEAPF32[i60 >> 2]);
   f23 = Math_fround(HEAPF32[i61 >> 2]);
   f25 = Math_fround(f114 + Math_fround(Math_fround(f19 * f9) + Math_fround(Math_fround(f24 * f20) + Math_fround(f25 * f27))));
   f26 = Math_fround(f23 + Math_fround(Math_fround(f22 * f9) + Math_fround(Math_fround(f15 * f20) + Math_fround(f26 * f27))));
   f27 = Math_fround(Math_fround(HEAPF32[i65 >> 2]) + Math_fround(Math_fround(f14 * f9) + Math_fround(Math_fround(f16 * f20) + Math_fround(f21 * f27))));
   i118 = f17 > Math_fround(0.0);
   i117 = f7 > Math_fround(0.0);
   i1 = f18 > Math_fround(0.0);
   f21 = Math_fround(HEAPF32[i62 >> 2]);
   f20 = Math_fround(HEAPF32[i63 >> 2]);
   f16 = Math_fround(HEAPF32[i64 >> 2]);
   f9 = Math_fround(-f21);
   f14 = Math_fround(-f20);
   f15 = Math_fround(-f16);
   f9 = i118 ? f21 : f9;
   f14 = i117 ? f20 : f14;
   f15 = i1 ? f16 : f15;
   f16 = Math_fround(f31 + f9);
   f20 = Math_fround(f30 + f14);
   f21 = Math_fround(f29 + f15);
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f18 * f24) + Math_fround(Math_fround(f17 * f22) + Math_fround(f7 * f23))) - f32);
   f17 = Math_fround(HEAPF32[i96 >> 2]);
   f18 = Math_fround(HEAPF32[i74 >> 2]);
   f19 = Math_fround(HEAPF32[i75 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f115) + Math_fround(f18 * f116)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i102 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i102 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i102 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f125 = Math_fround(HEAPF32[i97 >> 2]);
     f124 = Math_fround(HEAPF32[i84 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f125);
     f18 = Math_fround(Math_fround(f13 * f18) + f124);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i94 >> 2]));
     f124 = Math_fround(f17 - f31);
     f125 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i100 >> 2]);
     f4 = Math_fround(HEAPF32[i71 >> 2]);
     f2 = Math_fround(f124 + f2);
     f4 = Math_fround(f125 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i72 >> 2]));
     f22 = Math_fround(HEAPF32[i3 >> 2]);
     f21 = Math_fround(HEAPF32[i34 >> 2]);
     f22 = Math_fround(f124 + f22);
     f21 = Math_fround(f125 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i35 >> 2]));
     f16 = Math_fround(HEAPF32[i37 >> 2]);
     f7 = Math_fround(HEAPF32[i38 >> 2]);
     f16 = Math_fround(f124 + f16);
     f7 = Math_fround(f125 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i100 >> 2] = f2;
     HEAPF32[i71 >> 2] = f4;
     HEAPF32[i72 >> 2] = f5;
     HEAPF32[i73 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f22;
     HEAPF32[i34 >> 2] = f21;
     HEAPF32[i35 >> 2] = f20;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f16;
     HEAPF32[i38 >> 2] = f7;
     HEAPF32[i39 >> 2] = f8;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f125 = Math_fround(HEAPF32[i99 >> 2]);
     f124 = Math_fround(HEAPF32[i69 >> 2]);
     f4 = Math_fround(f124 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i70 >> 2]) - f5);
     HEAPF32[i101 >> 2] = Math_fround(f125 - f2);
     HEAPF32[i66 >> 2] = f4;
     HEAPF32[i67 >> 2] = f5;
     HEAPF32[i68 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i41 >> 2]);
     f4 = Math_fround(HEAPF32[i42 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f20);
     HEAPF32[i44 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i45 >> 2] = f21;
     HEAPF32[i46 >> 2] = f20;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i48 >> 2]);
     f21 = Math_fround(HEAPF32[i49 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f8);
     HEAPF32[i51 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i52 >> 2] = f7;
     HEAPF32[i53 >> 2] = f8;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f14);
     f7 = Math_fround(f19 + f15);
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i118 = HEAP32[i106 >> 2] | 0;
   HEAPF32[i99 + (i118 << 4) >> 2] = f25;
   HEAPF32[i99 + (i118 << 4) + 4 >> 2] = f26;
   HEAPF32[i99 + (i118 << 4) + 8 >> 2] = f27;
   HEAPF32[i99 + (i118 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i100 + (i118 << 4) >> 2] = f16;
   HEAPF32[i100 + (i118 << 4) + 4 >> 2] = f20;
   HEAPF32[i100 + (i118 << 4) + 8 >> 2] = f21;
   HEAPF32[i100 + (i118 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i106 >> 2] = i118 + 1;
   HEAPF32[i101 + (i118 << 4) >> 2] = f9;
   HEAPF32[i101 + (i118 << 4) + 4 >> 2] = f8;
   HEAPF32[i101 + (i118 << 4) + 8 >> 2] = f7;
   HEAPF32[i101 + (i118 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i118 | 0) {
   case 0:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i101 >> 2]);
     f7 = Math_fround(HEAPF32[i66 >> 2]);
     f8 = Math_fround(HEAPF32[i67 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f123 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i118 = f123 > Math_fround(1.0);
      f123 = i118 ? Math_fround(1.0) : f123;
      i118 = f123 > Math_fround(0.0);
      f123 = i118 ? f123 : Math_fround(0.0);
      f124 = Math_fround(f7 + Math_fround(f14 * f123));
      f125 = Math_fround(f8 + Math_fround(f15 * f123));
      HEAPF32[i59 >> 2] = Math_fround(f6 + Math_fround(f9 * f123));
      HEAPF32[i55 >> 2] = f124;
      HEAPF32[i56 >> 2] = f125;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i106 >> 2] = 1;
      HEAP32[i59 >> 2] = HEAP32[i101 >> 2];
      HEAP32[i59 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
      HEAP32[i59 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
      HEAP32[i59 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i101, i99, i100, i106);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i101, i99, i100, i106);
     break;
    }
   default:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i112;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i97 = HEAP32[i108 + 64 >> 2] | 0;
 i117 = HEAP32[i108 + 68 >> 2] | 0;
 i118 = HEAP32[i108 + 72 >> 2] | 0;
 i96 = f6 > f98 & i1;
 f120 = i96 ? f7 : f2;
 f122 = i96 ? f8 : f4;
 f124 = i96 ? f9 : f5;
 f119 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f124 * f124) + Math_fround(Math_fround(f122 * f122) + Math_fround(f120 * f120))))));
 f120 = Math_fround(f120 * f119);
 f122 = Math_fround(f122 * f119);
 f119 = Math_fround(f124 * f119);
 HEAPF32[i111 >> 2] = f120;
 HEAPF32[i111 + 4 >> 2] = f122;
 HEAPF32[i111 + 8 >> 2] = f119;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i110 >> 2] = f13;
 i111 = i110 + 4 | 0;
 HEAP32[i111 >> 2] = HEAP32[i102 >> 2];
 HEAP32[i111 + 4 >> 2] = HEAP32[i102 + 4 >> 2];
 HEAP32[i111 + 8 >> 2] = HEAP32[i102 + 8 >> 2];
 HEAPF32[i105 >> 2] = i1 ? f7 : f10;
 HEAPF32[i105 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i105 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i105 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i103 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i103 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i103 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i103 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAP32[i104 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i104 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i104 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i104 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i101, i99, i100, i105, i103, i104, HEAP32[i106 >> 2] | 0);
 f124 = Math_fround(HEAPF32[i108 + 16 >> 2]);
 f121 = Math_fround(HEAPF32[i103 >> 2]);
 f123 = Math_fround(HEAPF32[i103 + 4 >> 2]);
 f125 = Math_fround(HEAPF32[i103 + 8 >> 2]);
 f120 = Math_fround(f121 - Math_fround(f120 * f124));
 f122 = Math_fround(f123 - Math_fround(f122 * f124));
 f124 = Math_fround(f125 - Math_fround(f119 * f124));
 HEAPF32[i109 >> 2] = i97 | 0 ? f120 : f121;
 HEAPF32[i109 + 4 >> 2] = i117 | 0 ? f122 : f123;
 HEAPF32[i109 + 8 >> 2] = i118 | 0 ? f124 : f125;
 HEAPF32[i109 + 12 >> 2] = Math_fround(0.0);
 i118 = 1;
 STACKTOP = i112;
 return i118 | 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i118, i105, i104, i1, i107, i106, i120, i121, i119, f2) {
 i118 = i118 | 0;
 i105 = i105 | 0;
 i104 = i104 | 0;
 i1 = i1 | 0;
 i107 = i107 | 0;
 i106 = i106 | 0;
 i120 = i120 | 0;
 i121 = i121 | 0;
 i119 = i119 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, f108 = f0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i122 = 0, f123 = f0;
 i122 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i102 = i122 + 384 | 0;
 i103 = i122 + 368 | 0;
 i117 = i122 + 352 | 0;
 i112 = i122 + 416 | 0;
 i116 = i122 + 412 | 0;
 i80 = i122 + 208 | 0;
 i75 = i122 + 192 | 0;
 i111 = i122 + 288 | 0;
 i109 = i122 + 224 | 0;
 i110 = i122 + 128 | 0;
 i77 = i122 + 112 | 0;
 i78 = i122 + 96 | 0;
 i76 = i122 + 400 | 0;
 i89 = i122 + 80 | 0;
 i90 = i122 + 64 | 0;
 i91 = i122 + 48 | 0;
 i115 = i122 + 32 | 0;
 i113 = i122 + 16 | 0;
 i114 = i122;
 HEAP32[i117 >> 2] = 0;
 HEAP32[i117 + 4 >> 2] = 0;
 HEAP32[i117 + 8 >> 2] = 0;
 HEAP32[i117 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i106 >> 2]);
 i96 = i106 + 4 | 0;
 f8 = Math_fround(HEAPF32[i96 >> 2]);
 i101 = i106 + 8 | 0;
 f13 = Math_fround(HEAPF32[i101 >> 2]);
 f4 = Math_fround(HEAPF32[i107 >> 2]);
 i79 = i107 + 4 | 0;
 f7 = Math_fround(HEAPF32[i79 >> 2]);
 i83 = i107 + 8 | 0;
 f9 = Math_fround(HEAPF32[i83 >> 2]);
 HEAP32[i116 >> 2] = 1;
 i86 = i104 + 48 | 0;
 f14 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i104 + 52 | 0;
 f31 = Math_fround(HEAPF32[i87 >> 2]);
 i88 = i104 + 56 | 0;
 f15 = Math_fround(HEAPF32[i88 >> 2]);
 i92 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f31 * f31)) + Math_fround(f15 * f15)) > Math_fround(1.1920929e-07);
 f14 = i92 ? f14 : Math_fround(1.0);
 f31 = i92 ? f31 : Math_fround(0.0);
 f15 = i92 ? f15 : Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f14 * f14) + Math_fround(f31 * f31))))));
 f14 = Math_fround(f14 * f6);
 f31 = Math_fround(f31 * f6);
 f6 = Math_fround(f15 * f6);
 HEAPF32[i80 >> 2] = f14;
 HEAPF32[i80 + 4 >> 2] = f31;
 HEAPF32[i80 + 8 >> 2] = f6;
 HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
 f14 = Math_fround(-f14);
 f31 = Math_fround(-f31);
 f6 = Math_fround(-f6);
 f15 = Math_fround(Math_fround(HEAPF32[i104 >> 2]) * f14);
 i92 = i104 + 4 | 0;
 f15 = Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i92 >> 2]) * f31));
 i93 = i104 + 8 | 0;
 f15 = Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i93 >> 2]) * f6));
 i94 = i104 + 16 | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i94 >> 2]) * f14);
 i95 = i104 + 20 | 0;
 f16 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i95 >> 2]) * f31));
 i97 = i104 + 24 | 0;
 f16 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i97 >> 2]) * f6));
 i98 = i104 + 32 | 0;
 f14 = Math_fround(Math_fround(HEAPF32[i98 >> 2]) * f14);
 i99 = i104 + 36 | 0;
 f31 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i99 >> 2]) * f31));
 i100 = i104 + 40 | 0;
 f6 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i100 >> 2]) * f6));
 HEAPF32[i102 >> 2] = f15;
 HEAPF32[i102 + 4 >> 2] = f16;
 HEAPF32[i102 + 8 >> 2] = f6;
 HEAPF32[i102 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i103, i118, i102);
 f6 = Math_fround(HEAPF32[i86 >> 2]);
 f16 = Math_fround(HEAPF32[i87 >> 2]);
 f15 = Math_fround(HEAPF32[i88 >> 2]);
 f31 = Math_fround(HEAPF32[i103 >> 2]);
 f14 = Math_fround(HEAPF32[i103 + 4 >> 2]);
 f108 = Math_fround(HEAPF32[i103 + 8 >> 2]);
 f33 = Math_fround(f31 * Math_fround(HEAPF32[i104 >> 2]));
 f33 = Math_fround(f33 + Math_fround(f14 * Math_fround(HEAPF32[i94 >> 2])));
 f33 = Math_fround(f33 + Math_fround(f108 * Math_fround(HEAPF32[i98 >> 2])));
 f32 = Math_fround(f31 * Math_fround(HEAPF32[i92 >> 2]));
 f32 = Math_fround(f32 + Math_fround(f14 * Math_fround(HEAPF32[i95 >> 2])));
 f32 = Math_fround(f32 + Math_fround(f108 * Math_fround(HEAPF32[i99 >> 2])));
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i93 >> 2]));
 f14 = Math_fround(f31 + Math_fround(f14 * Math_fround(HEAPF32[i97 >> 2])));
 f33 = Math_fround(f6 + f33);
 f32 = Math_fround(f16 + f32);
 f108 = Math_fround(f15 + Math_fround(f14 + Math_fround(f108 * Math_fround(HEAPF32[i100 >> 2]))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i75, i105, i80);
 f14 = Math_fround(HEAPF32[i75 >> 2]);
 f15 = Math_fround(HEAPF32[i75 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f108 - Math_fround(HEAPF32[i75 + 8 >> 2]));
 HEAPF32[i111 >> 2] = f14;
 i80 = i111 + 4 | 0;
 HEAPF32[i80 >> 2] = f15;
 i81 = i111 + 8 | 0;
 HEAPF32[i81 >> 2] = f16;
 i82 = i111 + 12 | 0;
 HEAPF32[i82 >> 2] = Math_fround(0.0);
 i84 = i111 + 16 | 0;
 HEAP32[i84 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i84 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i84 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i84 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i84 = i111 + 32 | 0;
 HEAP32[i84 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i84 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i84 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i84 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i84 = i111 + 48 | 0;
 HEAP32[i84 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i84 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i84 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i84 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 HEAPF32[i109 >> 2] = f33;
 i84 = i109 + 4 | 0;
 HEAPF32[i84 >> 2] = f32;
 i85 = i109 + 8 | 0;
 HEAPF32[i85 >> 2] = f108;
 HEAPF32[i109 + 12 >> 2] = Math_fround(0.0);
 i74 = i109 + 16 | 0;
 HEAP32[i74 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i74 = i109 + 32 | 0;
 HEAP32[i74 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i74 = i109 + 48 | 0;
 HEAP32[i74 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i74 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i74 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i74 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 HEAP32[i110 >> 2] = HEAP32[i75 >> 2];
 HEAP32[i110 + 4 >> 2] = HEAP32[i75 + 4 >> 2];
 HEAP32[i110 + 8 >> 2] = HEAP32[i75 + 8 >> 2];
 HEAP32[i110 + 12 >> 2] = HEAP32[i75 + 12 >> 2];
 i75 = i110 + 16 | 0;
 HEAP32[i75 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i75 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i75 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i75 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i75 = i110 + 32 | 0;
 HEAP32[i75 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i75 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i75 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i75 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 i75 = i110 + 48 | 0;
 HEAP32[i75 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i75 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i75 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i75 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 f108 = Math_fround(HEAPF32[i118 + 32 >> 2]);
 f32 = Math_fround(HEAPF32[i105 + 32 >> 2]);
 f108 = Math_fround((f108 > f32 ? f32 : f108) * Math_fround(.100000001));
 f32 = Math_fround(f108 + f2);
 f108 = Math_fround(f108 * f108);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f108) {
  i3 = i102 + 4 | 0;
  i34 = i102 + 8 | 0;
  i35 = i102 + 12 | 0;
  i36 = i103 + 4 | 0;
  i37 = i103 + 8 | 0;
  i38 = i78 + 4 | 0;
  i39 = i78 + 8 | 0;
  i40 = i78 + 12 | 0;
  i41 = i77 + 4 | 0;
  i42 = i77 + 8 | 0;
  i43 = i110 + 4 | 0;
  i44 = i110 + 8 | 0;
  i45 = i110 + 12 | 0;
  i46 = i110 + 16 | 0;
  i47 = i110 + 20 | 0;
  i48 = i110 + 24 | 0;
  i49 = i110 + 28 | 0;
  i50 = i110 + 32 | 0;
  i51 = i110 + 36 | 0;
  i52 = i110 + 40 | 0;
  i53 = i110 + 44 | 0;
  i54 = i109 + 16 | 0;
  i55 = i109 + 20 | 0;
  i56 = i109 + 24 | 0;
  i57 = i111 + 16 | 0;
  i58 = i111 + 20 | 0;
  i59 = i111 + 24 | 0;
  i60 = i111 + 28 | 0;
  i61 = i109 + 32 | 0;
  i62 = i109 + 36 | 0;
  i63 = i109 + 40 | 0;
  i64 = i111 + 32 | 0;
  i65 = i111 + 36 | 0;
  i66 = i111 + 40 | 0;
  i67 = i111 + 44 | 0;
  i68 = i90 + 4 | 0;
  i69 = i90 + 8 | 0;
  i70 = i90 + 12 | 0;
  i71 = i89 + 4 | 0;
  i72 = i89 + 8 | 0;
  i73 = i91 + 4 | 0;
  i74 = i91 + 8 | 0;
  i75 = i91 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f123 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f20 = Math_fround(Math_fround(HEAPF32[i104 >> 2]) * f123);
   f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i92 >> 2]) * f13));
   f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i93 >> 2]) * f8));
   f21 = Math_fround(Math_fround(HEAPF32[i94 >> 2]) * f123);
   f21 = Math_fround(f21 + Math_fround(Math_fround(HEAPF32[i95 >> 2]) * f13));
   f21 = Math_fround(f21 + Math_fround(Math_fround(HEAPF32[i97 >> 2]) * f8));
   f22 = Math_fround(Math_fround(HEAPF32[i98 >> 2]) * f123);
   f22 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i99 >> 2]) * f13));
   f22 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i100 >> 2]) * f8));
   HEAPF32[i102 >> 2] = f20;
   HEAPF32[i3 >> 2] = f21;
   HEAPF32[i34 >> 2] = f22;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i103, i118, i102);
   f22 = Math_fround(HEAPF32[i86 >> 2]);
   f21 = Math_fround(HEAPF32[i87 >> 2]);
   f20 = Math_fround(HEAPF32[i88 >> 2]);
   f23 = Math_fround(HEAPF32[i103 >> 2]);
   f16 = Math_fround(HEAPF32[i36 >> 2]);
   f27 = Math_fround(HEAPF32[i37 >> 2]);
   f25 = Math_fround(f23 * Math_fround(HEAPF32[i104 >> 2]));
   f25 = Math_fround(f25 + Math_fround(f16 * Math_fround(HEAPF32[i94 >> 2])));
   f25 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i98 >> 2])));
   f26 = Math_fround(f23 * Math_fround(HEAPF32[i92 >> 2]));
   f26 = Math_fround(f26 + Math_fround(f16 * Math_fround(HEAPF32[i95 >> 2])));
   f26 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i99 >> 2])));
   f23 = Math_fround(f23 * Math_fround(HEAPF32[i93 >> 2]));
   f16 = Math_fround(f23 + Math_fround(f16 * Math_fround(HEAPF32[i97 >> 2])));
   f25 = Math_fround(f22 + f25);
   f26 = Math_fround(f21 + f26);
   f27 = Math_fround(f20 + Math_fround(f16 + Math_fround(f27 * Math_fround(HEAPF32[i100 >> 2]))));
   HEAPF32[i78 >> 2] = f9;
   HEAPF32[i38 >> 2] = f14;
   HEAPF32[i39 >> 2] = f15;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i77, i105, i78);
   f16 = Math_fround(HEAPF32[i77 >> 2]);
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i42 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23)) + Math_fround(f15 * f24)) - f32);
   f17 = Math_fround(HEAPF32[i106 >> 2]);
   f18 = Math_fround(HEAPF32[i96 >> 2]);
   f19 = Math_fround(HEAPF32[i101 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f123) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i112 >> 2] = HEAP32[i76 >> 2];
    HEAP32[i112 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
    HEAP32[i112 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f8 = Math_fround(HEAPF32[i107 >> 2]);
     f123 = Math_fround(HEAPF32[i79 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f8);
     f18 = Math_fround(Math_fround(f13 * f18) + f123);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i83 >> 2]));
     f31 = Math_fround(f17 - f31);
     f123 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i110 >> 2]);
     f4 = Math_fround(HEAPF32[i43 >> 2]);
     f2 = Math_fround(f31 + f2);
     f4 = Math_fround(f123 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i44 >> 2]));
     f22 = Math_fround(HEAPF32[i46 >> 2]);
     f21 = Math_fround(HEAPF32[i47 >> 2]);
     f22 = Math_fround(f31 + f22);
     f21 = Math_fround(f123 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i48 >> 2]));
     f16 = Math_fround(HEAPF32[i50 >> 2]);
     f7 = Math_fround(HEAPF32[i51 >> 2]);
     f16 = Math_fround(f31 + f16);
     f7 = Math_fround(f123 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i52 >> 2]));
     HEAPF32[i110 >> 2] = f2;
     HEAPF32[i43 >> 2] = f4;
     HEAPF32[i44 >> 2] = f5;
     HEAPF32[i45 >> 2] = Math_fround(0.0);
     HEAPF32[i46 >> 2] = f22;
     HEAPF32[i47 >> 2] = f21;
     HEAPF32[i48 >> 2] = f20;
     HEAPF32[i49 >> 2] = Math_fround(0.0);
     HEAPF32[i50 >> 2] = f16;
     HEAPF32[i51 >> 2] = f7;
     HEAPF32[i52 >> 2] = f8;
     HEAPF32[i53 >> 2] = Math_fround(0.0);
     f123 = Math_fround(HEAPF32[i109 >> 2]);
     f31 = Math_fround(HEAPF32[i84 >> 2]);
     f4 = Math_fround(f31 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i85 >> 2]) - f5);
     HEAPF32[i111 >> 2] = Math_fround(f123 - f2);
     HEAPF32[i80 >> 2] = f4;
     HEAPF32[i81 >> 2] = f5;
     HEAPF32[i82 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i54 >> 2]);
     f4 = Math_fround(HEAPF32[i55 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) - f20);
     HEAPF32[i57 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i58 >> 2] = f21;
     HEAPF32[i59 >> 2] = f20;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i61 >> 2]);
     f21 = Math_fround(HEAPF32[i62 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) - f8);
     HEAPF32[i64 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i65 >> 2] = f7;
     HEAPF32[i66 >> 2] = f8;
     HEAPF32[i67 >> 2] = Math_fround(0.0);
     HEAPF32[i90 >> 2] = f9;
     HEAPF32[i68 >> 2] = f14;
     HEAPF32[i69 >> 2] = f15;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i89, i105, i90);
     f9 = Math_fround(HEAPF32[i89 >> 2]);
     f8 = Math_fround(HEAPF32[i71 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i72 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i1 = HEAP32[i116 >> 2] | 0;
   HEAPF32[i109 + (i1 << 4) >> 2] = f25;
   HEAPF32[i109 + (i1 << 4) + 4 >> 2] = f26;
   HEAPF32[i109 + (i1 << 4) + 8 >> 2] = f27;
   HEAPF32[i109 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i110 + (i1 << 4) >> 2] = f16;
   HEAPF32[i110 + (i1 << 4) + 4 >> 2] = f20;
   HEAPF32[i110 + (i1 << 4) + 8 >> 2] = f21;
   HEAPF32[i110 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i116 >> 2] = i1 + 1;
   HEAPF32[i111 + (i1 << 4) >> 2] = f9;
   HEAPF32[i111 + (i1 << 4) + 4 >> 2] = f8;
   HEAPF32[i111 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i111 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i1 | 0) {
   case 0:
    {
     HEAPF32[i91 >> 2] = f9;
     HEAPF32[i73 >> 2] = f8;
     HEAPF32[i74 >> 2] = f7;
     HEAPF32[i75 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i111 >> 2]);
     f7 = Math_fround(HEAPF32[i80 >> 2]);
     f8 = Math_fround(HEAPF32[i81 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i57 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f30 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i1 = f30 > Math_fround(1.0);
      f30 = i1 ? Math_fround(1.0) : f30;
      i1 = f30 > Math_fround(0.0);
      f30 = i1 ? f30 : Math_fround(0.0);
      f31 = Math_fround(f7 + Math_fround(f14 * f30));
      f123 = Math_fround(f8 + Math_fround(f15 * f30));
      HEAPF32[i91 >> 2] = Math_fround(f6 + Math_fround(f9 * f30));
      HEAPF32[i73 >> 2] = f31;
      HEAPF32[i74 >> 2] = f123;
      HEAPF32[i75 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i116 >> 2] = 1;
      HEAP32[i91 >> 2] = HEAP32[i111 >> 2];
      HEAP32[i91 + 4 >> 2] = HEAP32[i111 + 4 >> 2];
      HEAP32[i91 + 8 >> 2] = HEAP32[i111 + 8 >> 2];
      HEAP32[i91 + 12 >> 2] = HEAP32[i111 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i91, i111, i109, i110, i116);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i91, i111, i109, i110, i116);
     break;
    }
   default:
    {
     HEAPF32[i91 >> 2] = f9;
     HEAPF32[i73 >> 2] = f8;
     HEAPF32[i74 >> 2] = f7;
     HEAPF32[i75 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i91 >> 2]);
   f8 = Math_fround(HEAPF32[i73 >> 2]);
   f9 = Math_fround(HEAPF32[i74 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i122;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i105 = HEAP32[i118 + 64 >> 2] | 0;
 i106 = HEAP32[i118 + 68 >> 2] | 0;
 i107 = HEAP32[i118 + 72 >> 2] | 0;
 i104 = f6 > f108 & i1;
 f30 = i104 ? f7 : f2;
 f32 = i104 ? f8 : f4;
 f108 = i104 ? f9 : f5;
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f108 * f108) + Math_fround(Math_fround(f32 * f32) + Math_fround(f30 * f30))))));
 f30 = Math_fround(f30 * f29);
 f32 = Math_fround(f32 * f29);
 f29 = Math_fround(f108 * f29);
 HEAPF32[i121 >> 2] = f30;
 HEAPF32[i121 + 4 >> 2] = f32;
 HEAPF32[i121 + 8 >> 2] = f29;
 HEAPF32[i121 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i120 >> 2] = f13;
 i121 = i120 + 4 | 0;
 HEAP32[i121 >> 2] = HEAP32[i112 >> 2];
 HEAP32[i121 + 4 >> 2] = HEAP32[i112 + 4 >> 2];
 HEAP32[i121 + 8 >> 2] = HEAP32[i112 + 8 >> 2];
 HEAPF32[i115 >> 2] = i1 ? f7 : f10;
 HEAPF32[i115 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i115 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i115 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i113 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i113 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i113 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i113 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 HEAP32[i114 >> 2] = HEAP32[i117 >> 2];
 HEAP32[i114 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
 HEAP32[i114 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
 HEAP32[i114 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i111, i109, i110, i115, i113, i114, HEAP32[i116 >> 2] | 0);
 f108 = Math_fround(HEAPF32[i118 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i113 >> 2]);
 f33 = Math_fround(HEAPF32[i113 + 4 >> 2]);
 f123 = Math_fround(HEAPF32[i113 + 8 >> 2]);
 f30 = Math_fround(f31 - Math_fround(f30 * f108));
 f32 = Math_fround(f33 - Math_fround(f32 * f108));
 f108 = Math_fround(f123 - Math_fround(f29 * f108));
 HEAPF32[i119 >> 2] = i105 | 0 ? f30 : f31;
 HEAPF32[i119 + 4 >> 2] = i106 | 0 ? f32 : f33;
 HEAPF32[i119 + 8 >> 2] = i107 | 0 ? f108 : f123;
 HEAPF32[i119 + 12 >> 2] = Math_fround(0.0);
 i121 = 1;
 STACKTOP = i122;
 return i121 | 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i110, i3, i98, i1, i100, i99, i112, i113, i111, f2) {
 i110 = i110 | 0;
 i3 = i3 | 0;
 i98 = i98 | 0;
 i1 = i1 | 0;
 i100 = i100 | 0;
 i99 = i99 | 0;
 i112 = i112 | 0;
 i113 = i113 | 0;
 i111 = i111 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i114 = 0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0;
 i114 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i109 = i114 + 192 | 0;
 i104 = i114 + 288 | 0;
 i108 = i114 + 284 | 0;
 i103 = i114 + 208 | 0;
 i101 = i114 + 128 | 0;
 i102 = i114 + 64 | 0;
 i70 = i114 + 272 | 0;
 i71 = i114 + 48 | 0;
 i107 = i114 + 32 | 0;
 i105 = i114 + 16 | 0;
 i106 = i114;
 HEAP32[i109 >> 2] = 0;
 HEAP32[i109 + 4 >> 2] = 0;
 HEAP32[i109 + 8 >> 2] = 0;
 HEAP32[i109 + 12 >> 2] = 0;
 f14 = Math_fround(HEAPF32[i99 >> 2]);
 i80 = i99 + 4 | 0;
 f16 = Math_fround(HEAPF32[i80 >> 2]);
 i81 = i99 + 8 | 0;
 f19 = Math_fround(HEAPF32[i81 >> 2]);
 f15 = Math_fround(HEAPF32[i100 >> 2]);
 i90 = i100 + 4 | 0;
 f17 = Math_fround(HEAPF32[i90 >> 2]);
 i97 = i100 + 8 | 0;
 f18 = Math_fround(HEAPF32[i97 >> 2]);
 HEAP32[i108 >> 2] = 1;
 i72 = i98 + 48 | 0;
 f29 = Math_fround(HEAPF32[i72 >> 2]);
 i78 = i98 + 52 | 0;
 f22 = Math_fround(HEAPF32[i78 >> 2]);
 i79 = i98 + 56 | 0;
 f9 = Math_fround(HEAPF32[i79 >> 2]);
 i82 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f22 * f22)) + Math_fround(f9 * f9)) > Math_fround(1.1920929e-07);
 f35 = i82 ? f29 : Math_fround(1.0);
 f36 = i82 ? f22 : Math_fround(0.0);
 f8 = i82 ? f9 : Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36))))));
 f35 = Math_fround(f35 * f6);
 f36 = Math_fround(f36 * f6);
 f6 = Math_fround(f8 * f6);
 f8 = Math_fround(-f35);
 f26 = Math_fround(-f36);
 f25 = Math_fround(-f6);
 f31 = Math_fround(HEAPF32[i98 >> 2]);
 f23 = Math_fround(f31 * f8);
 i82 = i98 + 4 | 0;
 f13 = Math_fround(HEAPF32[i82 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f13 * f26));
 i83 = i98 + 8 | 0;
 f7 = Math_fround(HEAPF32[i83 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f7 * f25));
 i84 = i98 + 16 | 0;
 f32 = Math_fround(HEAPF32[i84 >> 2]);
 f24 = Math_fround(f32 * f8);
 i85 = i98 + 20 | 0;
 f33 = Math_fround(HEAPF32[i85 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f33 * f26));
 i86 = i98 + 24 | 0;
 f4 = Math_fround(HEAPF32[i86 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f4 * f25));
 i87 = i98 + 32 | 0;
 f30 = Math_fround(HEAPF32[i87 >> 2]);
 f8 = Math_fround(f30 * f8);
 i88 = i98 + 36 | 0;
 f21 = Math_fround(HEAPF32[i88 >> 2]);
 f26 = Math_fround(f8 + Math_fround(f21 * f26));
 i89 = i98 + 40 | 0;
 f8 = Math_fround(HEAPF32[i89 >> 2]);
 f25 = Math_fround(f26 + Math_fround(f8 * f25));
 i91 = i110 + 96 | 0;
 f26 = Math_fround(HEAPF32[i91 >> 2]);
 i92 = i110 + 100 | 0;
 f27 = Math_fround(HEAPF32[i92 >> 2]);
 i93 = i110 + 104 | 0;
 f28 = Math_fround(HEAPF32[i93 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f23 * f26) + Math_fround(f24 * f27)) + Math_fround(f25 * f28));
 i94 = i110 + 112 | 0;
 f5 = Math_fround(HEAPF32[i94 >> 2]);
 i95 = i110 + 116 | 0;
 f34 = Math_fround(HEAPF32[i95 >> 2]);
 i96 = i110 + 120 | 0;
 f20 = Math_fround(HEAPF32[i96 >> 2]);
 i73 = f12 > Math_fround(Math_fround(Math_fround(f23 * f5) + Math_fround(f24 * f34)) + Math_fround(f25 * f20));
 f5 = i73 ? f26 : f5;
 f34 = i73 ? f27 : f34;
 f20 = i73 ? f28 : f20;
 f32 = Math_fround(f29 + Math_fround(Math_fround(f30 * f20) + Math_fround(Math_fround(f31 * f5) + Math_fround(f32 * f34))));
 f33 = Math_fround(f22 + Math_fround(Math_fround(f21 * f20) + Math_fround(Math_fround(f13 * f5) + Math_fround(f33 * f34))));
 f34 = Math_fround(f9 + Math_fround(Math_fround(f8 * f20) + Math_fround(Math_fround(f7 * f5) + Math_fround(f4 * f34))));
 i73 = i3 + 96 | 0;
 f4 = Math_fround(HEAPF32[i73 >> 2]);
 i74 = i3 + 100 | 0;
 f5 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i3 + 104 | 0;
 f7 = Math_fround(HEAPF32[i75 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f35 * f4) + Math_fround(f36 * f5)) + Math_fround(f6 * f7));
 i76 = i3 + 112 | 0;
 f8 = Math_fround(HEAPF32[i76 >> 2]);
 i77 = i3 + 116 | 0;
 f9 = Math_fround(HEAPF32[i77 >> 2]);
 i61 = i3 + 120 | 0;
 f13 = Math_fround(HEAPF32[i61 >> 2]);
 i62 = f20 > Math_fround(Math_fround(Math_fround(f35 * f8) + Math_fround(f36 * f9)) + Math_fround(f6 * f13));
 f6 = i62 ? f4 : f8;
 f36 = i62 ? f5 : f9;
 f35 = i62 ? f7 : f13;
 f20 = Math_fround(f32 - f6);
 f21 = Math_fround(f33 - f36);
 f22 = Math_fround(f34 - f35);
 HEAPF32[i103 >> 2] = f20;
 i62 = i103 + 4 | 0;
 HEAPF32[i62 >> 2] = f21;
 i63 = i103 + 8 | 0;
 HEAPF32[i63 >> 2] = f22;
 i64 = i103 + 12 | 0;
 HEAPF32[i64 >> 2] = Math_fround(0.0);
 i65 = i103 + 16 | 0;
 HEAP32[i65 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i65 = i103 + 32 | 0;
 HEAP32[i65 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i65 = i103 + 48 | 0;
 HEAP32[i65 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAPF32[i101 >> 2] = f32;
 i65 = i101 + 4 | 0;
 HEAPF32[i65 >> 2] = f33;
 i66 = i101 + 8 | 0;
 HEAPF32[i66 >> 2] = f34;
 HEAPF32[i101 + 12 >> 2] = Math_fround(0.0);
 i67 = i101 + 16 | 0;
 HEAP32[i67 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i67 = i101 + 32 | 0;
 HEAP32[i67 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i67 = i101 + 48 | 0;
 HEAP32[i67 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAPF32[i102 >> 2] = f6;
 i67 = i102 + 4 | 0;
 HEAPF32[i67 >> 2] = f36;
 i68 = i102 + 8 | 0;
 HEAPF32[i68 >> 2] = f35;
 i69 = i102 + 12 | 0;
 HEAPF32[i69 >> 2] = Math_fround(0.0);
 i60 = i102 + 16 | 0;
 HEAP32[i60 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i60 = i102 + 32 | 0;
 HEAP32[i60 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 i60 = i102 + 48 | 0;
 HEAP32[i60 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 f35 = Math_fround(f2 + Math_fround(0.0));
 f36 = Math_fround(f35 * f35);
 f6 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f22 * f22));
 L1 : do if (f6 > Math_fround(0.0)) {
  i3 = i102 + 16 | 0;
  i37 = i102 + 20 | 0;
  i38 = i102 + 24 | 0;
  i39 = i102 + 28 | 0;
  i40 = i102 + 32 | 0;
  i41 = i102 + 36 | 0;
  i42 = i102 + 40 | 0;
  i43 = i102 + 44 | 0;
  i44 = i101 + 16 | 0;
  i45 = i101 + 20 | 0;
  i46 = i101 + 24 | 0;
  i47 = i103 + 16 | 0;
  i48 = i103 + 20 | 0;
  i49 = i103 + 24 | 0;
  i50 = i103 + 28 | 0;
  i51 = i101 + 32 | 0;
  i52 = i101 + 36 | 0;
  i53 = i101 + 40 | 0;
  i54 = i103 + 32 | 0;
  i55 = i103 + 36 | 0;
  i56 = i103 + 40 | 0;
  i57 = i103 + 44 | 0;
  i58 = i71 + 4 | 0;
  i59 = i71 + 8 | 0;
  i60 = i71 + 12 | 0;
  f10 = f20;
  f11 = f21;
  f12 = f22;
  f26 = f4;
  f27 = f5;
  f25 = f13;
  f34 = Math_fround(Math_fround(f14 * Math_fround(0.0)) + f15);
  f33 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f17);
  f32 = Math_fround(Math_fround(f19 * Math_fround(0.0)) + f18);
  f31 = Math_fround(0.0);
  f2 = f20;
  f4 = f21;
  f5 = f22;
  while (1) {
   f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f22 = Math_fround(f10 * f24);
   f23 = Math_fround(f11 * f24);
   f24 = Math_fround(f12 * f24);
   f116 = Math_fround(-f22);
   f115 = Math_fround(-f23);
   f13 = Math_fround(-f24);
   f117 = Math_fround(HEAPF32[i98 >> 2]);
   f123 = Math_fround(f117 * f116);
   f21 = Math_fround(HEAPF32[i82 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f21 * f115));
   f16 = Math_fround(HEAPF32[i83 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f16 * f13));
   f28 = Math_fround(HEAPF32[i84 >> 2]);
   f122 = Math_fround(f28 * f116);
   f29 = Math_fround(HEAPF32[i85 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f29 * f115));
   f19 = Math_fround(HEAPF32[i86 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f19 * f13));
   f118 = Math_fround(HEAPF32[i87 >> 2]);
   f121 = Math_fround(f118 * f116);
   f14 = Math_fround(HEAPF32[i88 >> 2]);
   f121 = Math_fround(f121 + Math_fround(f14 * f115));
   f20 = Math_fround(HEAPF32[i89 >> 2]);
   f121 = Math_fround(f121 + Math_fround(f20 * f13));
   f120 = Math_fround(HEAPF32[i91 >> 2]);
   f15 = Math_fround(HEAPF32[i92 >> 2]);
   f119 = Math_fround(HEAPF32[i93 >> 2]);
   f124 = Math_fround(Math_fround(Math_fround(f123 * f120) + Math_fround(f122 * f15)) + Math_fround(f121 * f119));
   f17 = Math_fround(HEAPF32[i94 >> 2]);
   f30 = Math_fround(HEAPF32[i95 >> 2]);
   f18 = Math_fround(HEAPF32[i96 >> 2]);
   i1 = f124 > Math_fround(Math_fround(Math_fround(f123 * f17) + Math_fround(f122 * f30)) + Math_fround(f121 * f18));
   f17 = i1 ? f120 : f17;
   f30 = i1 ? f15 : f30;
   f18 = i1 ? f119 : f18;
   f119 = Math_fround(HEAPF32[i72 >> 2]);
   f15 = Math_fround(HEAPF32[i78 >> 2]);
   f28 = Math_fround(f119 + Math_fround(Math_fround(f118 * f18) + Math_fround(Math_fround(f117 * f17) + Math_fround(f28 * f30))));
   f29 = Math_fround(f15 + Math_fround(Math_fround(f14 * f18) + Math_fround(Math_fround(f21 * f17) + Math_fround(f29 * f30))));
   f30 = Math_fround(Math_fround(HEAPF32[i79 >> 2]) + Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f16 * f17) + Math_fround(f19 * f30))));
   i1 = Math_fround(Math_fround(Math_fround(f22 * f26) + Math_fround(f23 * f27)) + Math_fround(f24 * f7)) > Math_fround(Math_fround(Math_fround(f22 * f8) + Math_fround(f23 * f9)) + Math_fround(f24 * f25));
   f19 = Math_fround(f34 + (i1 ? f26 : f8));
   f17 = Math_fround(f33 + (i1 ? f27 : f9));
   f16 = Math_fround(f32 + (i1 ? f7 : f25));
   f18 = Math_fround(f28 - f19);
   f20 = Math_fround(f29 - f17);
   f21 = Math_fround(f30 - f16);
   f7 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(Math_fround(f22 * f18) + Math_fround(f23 * f20))) - f35);
   f9 = Math_fround(HEAPF32[i99 >> 2]);
   f14 = Math_fround(HEAPF32[i80 >> 2]);
   f15 = Math_fround(HEAPF32[i81 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f9 * f116) + Math_fround(f14 * f115)) + Math_fround(f15 * f13));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f31 - Math_fround(f7 / f8));
    HEAP32[i104 >> 2] = HEAP32[i70 >> 2];
    HEAP32[i104 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
    HEAP32[i104 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
    if (f13 > f31) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f20 = Math_fround(HEAPF32[i100 >> 2]);
     f21 = Math_fround(HEAPF32[i90 >> 2]);
     f20 = Math_fround(Math_fround(f13 * f9) + f20);
     f21 = Math_fround(Math_fround(f13 * f14) + f21);
     f5 = Math_fround(Math_fround(f13 * f15) + Math_fround(HEAPF32[i97 >> 2]));
     f123 = Math_fround(f20 - f34);
     f124 = Math_fround(f21 - f33);
     f16 = Math_fround(f5 - f32);
     f2 = Math_fround(HEAPF32[i102 >> 2]);
     f4 = Math_fround(HEAPF32[i67 >> 2]);
     f2 = Math_fround(f123 + f2);
     f4 = Math_fround(f124 + f4);
     f7 = Math_fround(f16 + Math_fround(HEAPF32[i68 >> 2]));
     f8 = Math_fround(HEAPF32[i3 >> 2]);
     f9 = Math_fround(HEAPF32[i37 >> 2]);
     f8 = Math_fround(f123 + f8);
     f9 = Math_fround(f124 + f9);
     f18 = Math_fround(f16 + Math_fround(HEAPF32[i38 >> 2]));
     f19 = Math_fround(HEAPF32[i40 >> 2]);
     f17 = Math_fround(HEAPF32[i41 >> 2]);
     f19 = Math_fround(f123 + f19);
     f17 = Math_fround(f124 + f17);
     f16 = Math_fround(f16 + Math_fround(HEAPF32[i42 >> 2]));
     HEAPF32[i102 >> 2] = f2;
     HEAPF32[i67 >> 2] = f4;
     HEAPF32[i68 >> 2] = f7;
     HEAPF32[i69 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f8;
     HEAPF32[i37 >> 2] = f9;
     HEAPF32[i38 >> 2] = f18;
     HEAPF32[i39 >> 2] = Math_fround(0.0);
     HEAPF32[i40 >> 2] = f19;
     HEAPF32[i41 >> 2] = f17;
     HEAPF32[i42 >> 2] = f16;
     HEAPF32[i43 >> 2] = Math_fround(0.0);
     f124 = Math_fround(HEAPF32[i101 >> 2]);
     f123 = Math_fround(HEAPF32[i65 >> 2]);
     f4 = Math_fround(f123 - f4);
     f7 = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f7);
     HEAPF32[i103 >> 2] = Math_fround(f124 - f2);
     HEAPF32[i62 >> 2] = f4;
     HEAPF32[i63 >> 2] = f7;
     HEAPF32[i64 >> 2] = Math_fround(0.0);
     f7 = Math_fround(HEAPF32[i44 >> 2]);
     f4 = Math_fround(HEAPF32[i45 >> 2]);
     f9 = Math_fround(f4 - f9);
     f18 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f18);
     HEAPF32[i47 >> 2] = Math_fround(f7 - f8);
     HEAPF32[i48 >> 2] = f9;
     HEAPF32[i49 >> 2] = f18;
     HEAPF32[i50 >> 2] = Math_fround(0.0);
     f18 = Math_fround(HEAPF32[i51 >> 2]);
     f9 = Math_fround(HEAPF32[i52 >> 2]);
     f17 = Math_fround(f9 - f17);
     f16 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f16);
     HEAPF32[i54 >> 2] = Math_fround(f18 - f19);
     HEAPF32[i55 >> 2] = f17;
     HEAPF32[i56 >> 2] = f16;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     f16 = Math_fround(HEAPF32[i73 >> 2]);
     f17 = Math_fround(HEAPF32[i74 >> 2]);
     f19 = Math_fround(HEAPF32[i75 >> 2]);
     f18 = Math_fround(Math_fround(Math_fround(f22 * f16) + Math_fround(f23 * f17)) + Math_fround(f24 * f19));
     f9 = Math_fround(HEAPF32[i76 >> 2]);
     f8 = Math_fround(HEAPF32[i77 >> 2]);
     f7 = Math_fround(HEAPF32[i61 >> 2]);
     i1 = f18 > Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f23 * f8)) + Math_fround(f24 * f7));
     f9 = Math_fround(f20 + (i1 ? f16 : f9));
     f8 = Math_fround(f21 + (i1 ? f17 : f8));
     f7 = Math_fround(f5 + (i1 ? f19 : f7));
     f19 = f9;
     f17 = f8;
     f16 = f7;
     f9 = Math_fround(f28 - f9);
     f8 = Math_fround(f29 - f8);
     f7 = Math_fround(f30 - f7);
     f18 = Math_fround(3402823469999999843913219.0e14);
     f22 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f18;
     f8 = f20;
     f7 = f21;
     f18 = f6;
     f22 = f32;
     f21 = f33;
     f20 = f34;
    }
   } else {
    f9 = f18;
    f8 = f20;
    f7 = f21;
    f18 = f6;
    f13 = f31;
    f22 = f32;
    f21 = f33;
    f20 = f34;
   }
   i1 = HEAP32[i108 >> 2] | 0;
   HEAPF32[i101 + (i1 << 4) >> 2] = f28;
   HEAPF32[i101 + (i1 << 4) + 4 >> 2] = f29;
   HEAPF32[i101 + (i1 << 4) + 8 >> 2] = f30;
   HEAPF32[i101 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i102 + (i1 << 4) >> 2] = f19;
   HEAPF32[i102 + (i1 << 4) + 4 >> 2] = f17;
   HEAPF32[i102 + (i1 << 4) + 8 >> 2] = f16;
   HEAPF32[i102 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i108 >> 2] = i1 + 1;
   HEAPF32[i103 + (i1 << 4) >> 2] = f9;
   HEAPF32[i103 + (i1 << 4) + 4 >> 2] = f8;
   HEAPF32[i103 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i103 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i1 | 0) {
   case 0:
    {
     HEAPF32[i71 >> 2] = f9;
     HEAPF32[i58 >> 2] = f8;
     HEAPF32[i59 >> 2] = f7;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i103 >> 2]);
     f7 = Math_fround(HEAPF32[i62 >> 2]);
     f8 = Math_fround(HEAPF32[i63 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f122 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i1 = f122 > Math_fround(1.0);
      f122 = i1 ? Math_fround(1.0) : f122;
      i1 = f122 > Math_fround(0.0);
      f122 = i1 ? f122 : Math_fround(0.0);
      f123 = Math_fround(f7 + Math_fround(f14 * f122));
      f124 = Math_fround(f8 + Math_fround(f15 * f122));
      HEAPF32[i71 >> 2] = Math_fround(f6 + Math_fround(f9 * f122));
      HEAPF32[i58 >> 2] = f123;
      HEAPF32[i59 >> 2] = f124;
      HEAPF32[i60 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i108 >> 2] = 1;
      HEAP32[i71 >> 2] = HEAP32[i103 >> 2];
      HEAP32[i71 + 4 >> 2] = HEAP32[i103 + 4 >> 2];
      HEAP32[i71 + 8 >> 2] = HEAP32[i103 + 8 >> 2];
      HEAP32[i71 + 12 >> 2] = HEAP32[i103 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i71, i103, i101, i102, i108);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i71, i103, i101, i102, i108);
     break;
    }
   default:
    {
     HEAPF32[i71 >> 2] = f9;
     HEAPF32[i58 >> 2] = f8;
     HEAPF32[i59 >> 2] = f7;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i71 >> 2]);
   f8 = Math_fround(HEAPF32[i58 >> 2]);
   f9 = Math_fround(HEAPF32[i59 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f18 > f6;
   if (!(f6 > f36 & i1)) break L1;
   f26 = Math_fround(HEAPF32[i73 >> 2]);
   f27 = Math_fround(HEAPF32[i74 >> 2]);
   f33 = Math_fround(HEAPF32[i75 >> 2]);
   f34 = Math_fround(HEAPF32[i76 >> 2]);
   f25 = Math_fround(HEAPF32[i77 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = f33;
   f8 = f34;
   f9 = f25;
   f25 = Math_fround(HEAPF32[i61 >> 2]);
   f34 = f20;
   f33 = f21;
   f32 = f22;
   f31 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i114;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f22;
  f11 = f21;
  f10 = f20;
  f9 = f22;
  f8 = f21;
  f7 = f20;
  i1 = 1;
  f5 = f22;
  f4 = f21;
  f2 = f20;
 } while (0);
 i98 = HEAP32[i110 + 64 >> 2] | 0;
 i99 = HEAP32[i110 + 68 >> 2] | 0;
 i100 = HEAP32[i110 + 72 >> 2] | 0;
 i97 = f6 > Math_fround(0.0) & i1;
 f119 = i97 ? f7 : f2;
 f121 = i97 ? f8 : f4;
 f123 = i97 ? f9 : f5;
 f118 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f123 * f123) + Math_fround(Math_fround(f121 * f121) + Math_fround(f119 * f119))))));
 f119 = Math_fround(f119 * f118);
 f121 = Math_fround(f121 * f118);
 f118 = Math_fround(f123 * f118);
 HEAPF32[i113 >> 2] = f119;
 HEAPF32[i113 + 4 >> 2] = f121;
 HEAPF32[i113 + 8 >> 2] = f118;
 HEAPF32[i113 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i112 >> 2] = f13;
 i113 = i112 + 4 | 0;
 HEAP32[i113 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i113 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i113 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAPF32[i107 >> 2] = i1 ? f7 : f10;
 HEAPF32[i107 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i107 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i107 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i105 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i105 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i105 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i105 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 HEAP32[i106 >> 2] = HEAP32[i109 >> 2];
 HEAP32[i106 + 4 >> 2] = HEAP32[i109 + 4 >> 2];
 HEAP32[i106 + 8 >> 2] = HEAP32[i109 + 8 >> 2];
 HEAP32[i106 + 12 >> 2] = HEAP32[i109 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i103, i101, i102, i107, i105, i106, HEAP32[i108 >> 2] | 0);
 f123 = Math_fround(HEAPF32[i110 + 16 >> 2]);
 f120 = Math_fround(HEAPF32[i105 >> 2]);
 f122 = Math_fround(HEAPF32[i105 + 4 >> 2]);
 f124 = Math_fround(HEAPF32[i105 + 8 >> 2]);
 f119 = Math_fround(f120 - Math_fround(f119 * f123));
 f121 = Math_fround(f122 - Math_fround(f121 * f123));
 f123 = Math_fround(f124 - Math_fround(f118 * f123));
 HEAPF32[i111 >> 2] = i98 | 0 ? f119 : f120;
 HEAPF32[i111 + 4 >> 2] = i99 | 0 ? f121 : f122;
 HEAPF32[i111 + 8 >> 2] = i100 | 0 ? f123 : f124;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 i113 = 1;
 STACKTOP = i114;
 return i113 | 0;
}

function __ZL17CheckForIntersectP14TESStesselatorP12ActiveRegion(i41, i5) {
 i41 = i41 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, f43 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i42;
 i36 = i5 + 4 | 0;
 i40 = HEAP32[HEAP32[(HEAP32[i36 >> 2] | 0) + 8 >> 2] >> 2] | 0;
 i23 = HEAP32[i5 >> 2] | 0;
 i27 = HEAP32[i40 >> 2] | 0;
 i37 = i23 + 16 | 0;
 i28 = HEAP32[i37 >> 2] | 0;
 i22 = i27 + 16 | 0;
 i29 = HEAP32[i22 >> 2] | 0;
 i12 = i23 + 4 | 0;
 i30 = HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0;
 i27 = i27 + 4 | 0;
 i38 = HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0;
 if ((i28 | 0) == (i29 | 0)) {
  i41 = 0;
  STACKTOP = i42;
  return i41 | 0;
 }
 i31 = i28 + 28 | 0;
 i35 = i30 + 28 | 0;
 f14 = Math_fround(HEAPF32[i35 >> 2]);
 f17 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i29 + 28 | 0;
 i39 = i38 + 28 | 0;
 f18 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(HEAPF32[i39 >> 2]);
 if ((f14 < f17 ? f14 : f17) > (f18 < f15 ? f15 : f18)) {
  i41 = 0;
  STACKTOP = i42;
  return i41 | 0;
 }
 i33 = i28 + 24 | 0;
 f6 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i29 + 24 | 0;
 f16 = Math_fround(HEAPF32[i34 >> 2]);
 if (f6 < f16) i11 = 5; else if (!(f17 <= f18) | f6 != f16) {
  f7 = Math_fround(f16 - Math_fround(HEAPF32[i30 + 24 >> 2]));
  f6 = Math_fround(f6 - f16);
  if (Math_fround(f7 + f6) > Math_fround(0.0)) if (Math_fround(Math_fround(f7 * Math_fround(f18 - f17)) + Math_fround(f6 * Math_fround(f18 - f14))) < Math_fround(0.0)) {
   i41 = 0;
   STACKTOP = i42;
   return i41 | 0;
  }
 } else i11 = 5;
 if ((i11 | 0) == 5) {
  f7 = Math_fround(f6 - Math_fround(HEAPF32[i38 + 24 >> 2]));
  f6 = Math_fround(f16 - f6);
  if (Math_fround(f7 + f6) > Math_fround(0.0)) if (Math_fround(Math_fround(f7 * Math_fround(f17 - f18)) + Math_fround(f6 * Math_fround(f17 - f15))) > Math_fround(0.0)) {
   i41 = 0;
   STACKTOP = i42;
   return i41 | 0;
  }
 }
 __Z16tesedgeIntersectP10TESSvertexS0_S0_S0_S0_(i30, i28, i38, i29, i25);
 i8 = i25 + 24 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = i41 + 72 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 if (f6 < f17) {
  i2 = i25 + 28 | 0;
  i1 = HEAP32[i9 + 28 >> 2] | 0;
  i11 = 14;
 } else if (f6 == f17) {
  i2 = i25 + 28 | 0;
  f18 = Math_fround(HEAPF32[i2 >> 2]);
  f7 = Math_fround(HEAPF32[i9 + 28 >> 2]);
  if (f18 <= f7) {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = 14;
  }
 }
 if ((i11 | 0) == 14) {
  HEAPF32[i8 >> 2] = f17;
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  f6 = f17;
 }
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 f15 = Math_fround(HEAPF32[i34 >> 2]);
 do if (f14 < f15) {
  i3 = i28;
  f7 = f14;
 } else {
  if (f14 == f15) {
   f18 = Math_fround(HEAPF32[i31 >> 2]);
   if (f18 <= Math_fround(HEAPF32[i32 >> 2])) {
    i3 = i28;
    f7 = f14;
    break;
   }
  }
  i3 = i29;
  f7 = f15;
 } while (0);
 i4 = i3 + 24 | 0;
 if (f7 < f6) {
  i2 = i25 + 28 | 0;
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  i11 = 24;
 } else if (f7 == f6) {
  f7 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  i2 = i25 + 28 | 0;
  if (!(f7 <= Math_fround(HEAPF32[i2 >> 2]))) {
   f16 = f6;
   i3 = i1;
  } else {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = 24;
  }
 } else {
  f16 = f6;
  i3 = i1;
 }
 if ((i11 | 0) == 24) {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  f16 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 if (f16 == f14) {
  f18 = Math_fround(HEAPF32[i25 + 28 >> 2]);
  if (!(f18 == Math_fround(HEAPF32[i31 >> 2]))) i11 = 27;
 } else i11 = 27;
 do if ((i11 | 0) == 27) {
  if (f16 == f15) {
   f18 = Math_fround(HEAPF32[i25 + 28 >> 2]);
   if (f18 == Math_fround(HEAPF32[i32 >> 2])) break;
  }
  i20 = i30 + 24 | 0;
  f15 = Math_fround(HEAPF32[i20 >> 2]);
  if (f15 == f17) {
   f18 = Math_fround(HEAPF32[i35 >> 2]);
   f6 = Math_fround(HEAPF32[i9 + 28 >> 2]);
   if (f18 == f6) i11 = 34; else i11 = 32;
  } else i11 = 32;
  if ((i11 | 0) == 32) {
   f7 = Math_fround(f17 - f15);
   f14 = Math_fround(f16 - f17);
   if (Math_fround(f7 + f14) > Math_fround(0.0)) {
    f6 = Math_fround(HEAPF32[i9 + 28 >> 2]);
    f18 = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i25 + 28 >> 2])));
    if (!(Math_fround(f18 + Math_fround(f14 * Math_fround(f6 - Math_fround(HEAPF32[i35 >> 2])))) >= Math_fround(0.0))) i11 = 34;
   }
  }
  do if ((i11 | 0) == 34) {
   i19 = i38 + 24 | 0;
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   if (f7 == f17) {
    if (!(Math_fround(HEAPF32[i39 >> 2]) == f6)) i11 = 36;
   } else i11 = 36;
   if ((i11 | 0) == 36) {
    f7 = Math_fround(f17 - f7);
    f14 = Math_fround(f16 - f17);
    if (!(Math_fround(f7 + f14) > Math_fround(0.0))) break;
    f18 = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i25 + 28 >> 2])));
    if (Math_fround(f18 + Math_fround(f14 * Math_fround(f6 - Math_fround(HEAPF32[i39 >> 2])))) <= Math_fround(0.0)) break;
   }
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
   if (!i2) {
    i24 = i41 + 144 | 0;
    _longjmp(i24 | 0, 1);
   }
   i24 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = HEAP32[i1 + 4 >> 2] | 0;
   i9 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 12 >> 2] | 0;
   i11 = i13 + 8 | 0;
   i22 = HEAP32[i11 >> 2] | 0;
   i12 = i9 + 8 | 0;
   i10 = HEAP32[i12 >> 2] | 0;
   HEAP32[(HEAP32[i22 + 4 >> 2] | 0) + 12 >> 2] = i9;
   HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
   HEAP32[i11 >> 2] = i10;
   HEAP32[i12 >> 2] = i22;
   i12 = HEAP32[i11 >> 2] | 0;
   i22 = i24 + 8 | 0;
   i10 = HEAP32[i22 >> 2] | 0;
   HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i24;
   HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
   HEAP32[i11 >> 2] = i10;
   HEAP32[i22 >> 2] = i12;
   HEAP32[i13 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
   i22 = HEAP32[i24 + 4 >> 2] | 0;
   HEAP32[(HEAP32[i22 + 16 >> 2] | 0) + 8 >> 2] = i22;
   HEAP32[i22 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
   HEAP32[i24 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
   if (!i24) {
    i24 = i41 + 144 | 0;
    _longjmp(i24 | 0, 1);
   }
   i1 = HEAP32[i27 >> 2] | 0;
   i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
   if (!i2) {
    i24 = i41 + 144 | 0;
    _longjmp(i24 | 0, 1);
   }
   i24 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = HEAP32[i1 + 4 >> 2] | 0;
   i9 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 12 >> 2] | 0;
   i11 = i13 + 8 | 0;
   i22 = HEAP32[i11 >> 2] | 0;
   i12 = i9 + 8 | 0;
   i10 = HEAP32[i12 >> 2] | 0;
   HEAP32[(HEAP32[i22 + 4 >> 2] | 0) + 12 >> 2] = i9;
   HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
   HEAP32[i11 >> 2] = i10;
   HEAP32[i12 >> 2] = i22;
   i12 = HEAP32[i11 >> 2] | 0;
   i22 = i24 + 8 | 0;
   i10 = HEAP32[i22 >> 2] | 0;
   HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i24;
   HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
   HEAP32[i11 >> 2] = i10;
   HEAP32[i22 >> 2] = i12;
   HEAP32[i13 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
   i22 = HEAP32[i24 + 4 >> 2] | 0;
   HEAP32[(HEAP32[i22 + 16 >> 2] | 0) + 8 >> 2] = i22;
   HEAP32[i22 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
   HEAP32[i24 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i22 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
   if (!i24) {
    i24 = i41 + 144 | 0;
    _longjmp(i24 | 0, 1);
   }
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i41 >> 2] | 0, HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] | 0, i23) | 0)) _longjmp(i41 + 144 | 0, 1);
   i11 = HEAP32[i37 >> 2] | 0;
   HEAP32[i11 + 24 >> 2] = i3;
   HEAP32[i11 + 28 >> 2] = HEAP32[i25 + 28 >> 2];
   i12 = i41 + 104 | 0;
   i13 = i41 + 68 | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   if (!(HEAP32[i1 + 20 >> 2] | 0)) {
    i2 = i1 + 12 | 0;
    i10 = HEAP32[i2 >> 2] | 0;
    i27 = i10 + 1 | 0;
    HEAP32[i2 >> 2] = i27;
    i2 = i1 + 16 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i27 | 0) < (i3 | 0)) i26 = HEAP32[i1 + 4 >> 2] | 0; else {
     i4 = HEAP32[i41 + 108 >> 2] | 0;
     if (i4 | 0) {
      i8 = i1 + 4 | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      HEAP32[i2 >> 2] = i3 << 1;
      i1 = mftCall_iiii(i4 | 0, HEAP32[i41 + 116 >> 2] | 0, i9 | 0, i3 << 3 | 0) | 0;
      HEAP32[i8 >> 2] = i1;
      if (i1 | 0) {
       i26 = i1;
       break;
      }
      HEAP32[i8 >> 2] = i9;
     }
     HEAP32[(HEAP32[i37 >> 2] | 0) + 32 >> 2] = 268435455;
     i27 = HEAP32[i13 >> 2] | 0;
     __Z17pqDeletePriorityQP9TESSallocP9PriorityQ(i12, i27);
     HEAP32[i13 >> 2] = 0;
     i27 = i41 + 144 | 0;
     _longjmp(i27 | 0, 1);
    } while (0);
    HEAP32[i26 + (i10 << 2) >> 2] = i11;
    i2 = ~i10;
   } else i2 = __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv(i12, HEAP32[i1 >> 2] | 0, i11) | 0;
   i1 = HEAP32[i37 >> 2] | 0;
   HEAP32[i1 + 32 >> 2] = i2;
   if ((i2 | 0) == 268435455) {
    i37 = HEAP32[i13 >> 2] | 0;
    __Z17pqDeletePriorityQP9TESSallocP9PriorityQ(i12, i37);
    HEAP32[i13 >> 2] = 0;
    i41 = i41 + 144 | 0;
    _longjmp(i41 | 0, 1);
   }
   i41 = i1 + 20 | 0;
   HEAPF32[i41 >> 2] = Math_fround(0.0);
   i37 = i1 + 16 | 0;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i27 = i1 + 12 | 0;
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAP32[i1 + 40 >> 2] = -1;
   f43 = Math_fround(HEAPF32[i33 >> 2]);
   f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f43 = Math_fround(f43 - f7);
   i26 = f43 < Math_fround(0.0);
   f21 = Math_fround(-f43);
   f14 = Math_fround(HEAPF32[i31 >> 2]);
   f18 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   f14 = Math_fround(f14 - f18);
   i33 = f14 < Math_fround(0.0);
   f15 = Math_fround(-f14);
   f14 = Math_fround((i26 ? f21 : f43) + (i33 ? f15 : f14));
   f15 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f7);
   i33 = f15 < Math_fround(0.0);
   f43 = Math_fround(-f15);
   f21 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f18);
   i35 = f21 < Math_fround(0.0);
   f17 = Math_fround(-f21);
   f21 = Math_fround((i33 ? f43 : f15) + (i35 ? f17 : f21));
   f17 = Math_fround(f14 + f21);
   f21 = Math_fround(Math_fround(f21 * Math_fround(.5)) / f17);
   f17 = Math_fround(Math_fround(f14 * Math_fround(.5)) / f17);
   f14 = Math_fround(Math_fround(HEAPF32[i28 + 12 >> 2]) * f21);
   f14 = Math_fround(Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i30 + 12 >> 2]) * f17)) + Math_fround(0.0));
   HEAPF32[i27 >> 2] = f14;
   f15 = Math_fround(Math_fround(HEAPF32[i28 + 16 >> 2]) * f21);
   f15 = Math_fround(Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i30 + 16 >> 2]) * f17)) + Math_fround(0.0));
   HEAPF32[i37 >> 2] = f15;
   f21 = Math_fround(f21 * Math_fround(HEAPF32[i28 + 20 >> 2]));
   f17 = Math_fround(Math_fround(f21 + Math_fround(f17 * Math_fround(HEAPF32[i30 + 20 >> 2]))) + Math_fround(0.0));
   HEAPF32[i41 >> 2] = f17;
   f21 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) - f7);
   i34 = f21 < Math_fround(0.0);
   f43 = Math_fround(-f21);
   f16 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f18);
   i35 = f16 < Math_fround(0.0);
   f6 = Math_fround(-f16);
   f16 = Math_fround((i34 ? f43 : f21) + (i35 ? f6 : f16));
   f7 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f7);
   i35 = f7 < Math_fround(0.0);
   f6 = Math_fround(-f7);
   f18 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) - f18);
   i39 = f18 < Math_fround(0.0);
   f21 = Math_fround(-f18);
   f18 = Math_fround((i35 ? f6 : f7) + (i39 ? f21 : f18));
   f21 = Math_fround(f16 + f18);
   f18 = Math_fround(Math_fround(f18 * Math_fround(.5)) / f21);
   f21 = Math_fround(Math_fround(f16 * Math_fround(.5)) / f21);
   f16 = Math_fround(Math_fround(HEAPF32[i29 + 12 >> 2]) * f18);
   HEAPF32[i27 >> 2] = Math_fround(f14 + Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i38 + 12 >> 2]) * f21)));
   f16 = Math_fround(Math_fround(HEAPF32[i29 + 16 >> 2]) * f18);
   HEAPF32[i37 >> 2] = Math_fround(f15 + Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i38 + 16 >> 2]) * f21)));
   f18 = Math_fround(f18 * Math_fround(HEAPF32[i29 + 20 >> 2]));
   HEAPF32[i41 >> 2] = Math_fround(f17 + Math_fround(f18 + Math_fround(f21 * Math_fround(HEAPF32[i38 + 20 >> 2]))));
   HEAP32[i40 + 20 >> 2] = 1;
   HEAP32[i5 + 20 >> 2] = 1;
   HEAP32[(HEAP32[HEAP32[(HEAP32[i36 >> 2] | 0) + 4 >> 2] >> 2] | 0) + 20 >> 2] = 1;
   i41 = 0;
   STACKTOP = i42;
   return i41 | 0;
  } while (0);
  if ((i38 | 0) == (i9 | 0)) {
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
   if (!i2) {
    i39 = i41 + 144 | 0;
    _longjmp(i39 | 0, 1);
   }
   i39 = HEAP32[i2 + 4 >> 2] | 0;
   i37 = HEAP32[i1 + 4 >> 2] | 0;
   i33 = HEAP32[(HEAP32[i37 + 4 >> 2] | 0) + 12 >> 2] | 0;
   i35 = i37 + 8 | 0;
   i38 = HEAP32[i35 >> 2] | 0;
   i36 = i33 + 8 | 0;
   i34 = HEAP32[i36 >> 2] | 0;
   HEAP32[(HEAP32[i38 + 4 >> 2] | 0) + 12 >> 2] = i33;
   HEAP32[(HEAP32[i34 + 4 >> 2] | 0) + 12 >> 2] = i37;
   HEAP32[i35 >> 2] = i34;
   HEAP32[i36 >> 2] = i38;
   i36 = HEAP32[i35 >> 2] | 0;
   i38 = i39 + 8 | 0;
   i34 = HEAP32[i38 >> 2] | 0;
   HEAP32[(HEAP32[i36 + 4 >> 2] | 0) + 12 >> 2] = i39;
   HEAP32[(HEAP32[i34 + 4 >> 2] | 0) + 12 >> 2] = i37;
   HEAP32[i35 >> 2] = i34;
   HEAP32[i38 >> 2] = i36;
   HEAP32[i37 + 16 >> 2] = HEAP32[i39 + 16 >> 2];
   i38 = HEAP32[i39 + 4 >> 2] | 0;
   HEAP32[(HEAP32[i38 + 16 >> 2] | 0) + 8 >> 2] = i38;
   HEAP32[i38 + 20 >> 2] = HEAP32[i37 + 20 >> 2];
   HEAP32[i39 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i38 + 28 >> 2] = HEAP32[i37 + 28 >> 2];
   if (!i39) {
    i39 = i41 + 144 | 0;
    _longjmp(i39 | 0, 1);
   }
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i41 >> 2] | 0, HEAP32[i27 >> 2] | 0, i23) | 0)) _longjmp(i41 + 144 | 0, 1);
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
   do {
    i5 = HEAP32[HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((HEAP32[i2 + 16 >> 2] | 0) == (i1 | 0));
   i3 = i5 + 24 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) i24 = i5; else {
    i4 = i5 + 4 | 0;
    i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i41 >> 2] | 0, HEAP32[(HEAP32[HEAP32[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] >> 2] >> 2] | 0) + 4 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
    if (!i1) {
     i39 = i41 + 144 | 0;
     _longjmp(i39 | 0, 1);
    }
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0)) {
     i39 = i41 + 144 | 0;
     _longjmp(i39 | 0, 1);
    }
    HEAP32[i3 >> 2] = 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i1 + 24 >> 2] = i5;
    i1 = HEAP32[HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
    if (!i1) {
     i39 = i41 + 144 | 0;
     _longjmp(i39 | 0, 1);
    } else i24 = i1;
   }
   i38 = HEAP32[HEAP32[(HEAP32[i24 + 4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
   i39 = HEAP32[i38 >> 2] | 0;
   __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i41, i38, i40) | 0;
   __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i41, i24, HEAP32[(HEAP32[i39 + 4 >> 2] | 0) + 12 >> 2] | 0, i39, i39, 1);
   i41 = 1;
   STACKTOP = i42;
   return i41 | 0;
  }
  if ((i30 | 0) == (i9 | 0)) {
   i1 = HEAP32[i27 >> 2] | 0;
   i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
   if (!i2) {
    i40 = i41 + 144 | 0;
    _longjmp(i40 | 0, 1);
   }
   i40 = HEAP32[i2 + 4 >> 2] | 0;
   i38 = HEAP32[i1 + 4 >> 2] | 0;
   i34 = HEAP32[(HEAP32[i38 + 4 >> 2] | 0) + 12 >> 2] | 0;
   i36 = i38 + 8 | 0;
   i39 = HEAP32[i36 >> 2] | 0;
   i37 = i34 + 8 | 0;
   i35 = HEAP32[i37 >> 2] | 0;
   HEAP32[(HEAP32[i39 + 4 >> 2] | 0) + 12 >> 2] = i34;
   HEAP32[(HEAP32[i35 + 4 >> 2] | 0) + 12 >> 2] = i38;
   HEAP32[i36 >> 2] = i35;
   HEAP32[i37 >> 2] = i39;
   i37 = HEAP32[i36 >> 2] | 0;
   i39 = i40 + 8 | 0;
   i35 = HEAP32[i39 >> 2] | 0;
   HEAP32[(HEAP32[i37 + 4 >> 2] | 0) + 12 >> 2] = i40;
   HEAP32[(HEAP32[i35 + 4 >> 2] | 0) + 12 >> 2] = i38;
   HEAP32[i36 >> 2] = i35;
   HEAP32[i39 >> 2] = i37;
   HEAP32[i38 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
   i39 = HEAP32[i40 + 4 >> 2] | 0;
   HEAP32[(HEAP32[i39 + 16 >> 2] | 0) + 8 >> 2] = i39;
   HEAP32[i39 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
   HEAP32[i40 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i39 + 28 >> 2] = HEAP32[i38 + 28 >> 2];
   if (!i40) {
    i40 = i41 + 144 | 0;
    _longjmp(i40 | 0, 1);
   }
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i41 >> 2] | 0, HEAP32[i23 + 12 >> 2] | 0, HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] | 0) | 0)) _longjmp(i41 + 144 | 0, 1);
   i2 = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] | 0;
   i1 = i5;
   do i1 = HEAP32[HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0; while ((HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] | 0) == (i2 | 0));
   i40 = HEAP32[(HEAP32[(HEAP32[HEAP32[HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] >> 2] >> 2] | 0) + 4 >> 2] | 0) + 8 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2];
   i39 = HEAP32[(__ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i41, i5, 0) | 0) + 8 >> 2] | 0;
   __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i41, i1, i39, HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i40, 1);
   i41 = 1;
   STACKTOP = i42;
   return i41 | 0;
  }
  f6 = Math_fround(f17 - f15);
  f7 = Math_fround(f16 - f17);
  if (Math_fround(f6 + f7) > Math_fround(0.0)) {
   f43 = Math_fround(HEAPF32[i9 + 28 >> 2]);
   f18 = Math_fround(f6 * Math_fround(f43 - Math_fround(HEAPF32[i25 + 28 >> 2])));
   if (!(Math_fround(f18 + Math_fround(f7 * Math_fround(f43 - Math_fround(HEAPF32[i35 >> 2])))) >= Math_fround(0.0))) {
    f21 = f17;
    i13 = i9;
   } else i11 = 63;
  } else i11 = 63;
  do if ((i11 | 0) == 63) {
   HEAP32[i5 + 20 >> 2] = 1;
   HEAP32[(HEAP32[HEAP32[(HEAP32[i36 >> 2] | 0) + 4 >> 2] >> 2] | 0) + 20 >> 2] = 1;
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
   if (!i2) {
    i36 = i41 + 144 | 0;
    _longjmp(i36 | 0, 1);
   }
   i36 = HEAP32[i2 + 4 >> 2] | 0;
   i34 = HEAP32[i1 + 4 >> 2] | 0;
   i30 = HEAP32[(HEAP32[i34 + 4 >> 2] | 0) + 12 >> 2] | 0;
   i32 = i34 + 8 | 0;
   i35 = HEAP32[i32 >> 2] | 0;
   i33 = i30 + 8 | 0;
   i31 = HEAP32[i33 >> 2] | 0;
   HEAP32[(HEAP32[i35 + 4 >> 2] | 0) + 12 >> 2] = i30;
   HEAP32[(HEAP32[i31 + 4 >> 2] | 0) + 12 >> 2] = i34;
   HEAP32[i32 >> 2] = i31;
   HEAP32[i33 >> 2] = i35;
   i33 = HEAP32[i32 >> 2] | 0;
   i35 = i36 + 8 | 0;
   i31 = HEAP32[i35 >> 2] | 0;
   HEAP32[(HEAP32[i33 + 4 >> 2] | 0) + 12 >> 2] = i36;
   HEAP32[(HEAP32[i31 + 4 >> 2] | 0) + 12 >> 2] = i34;
   HEAP32[i32 >> 2] = i31;
   HEAP32[i35 >> 2] = i33;
   HEAP32[i34 + 16 >> 2] = HEAP32[i36 + 16 >> 2];
   i35 = HEAP32[i36 + 4 >> 2] | 0;
   HEAP32[(HEAP32[i35 + 16 >> 2] | 0) + 8 >> 2] = i35;
   HEAP32[i35 + 20 >> 2] = HEAP32[i34 + 20 >> 2];
   HEAP32[i36 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i35 + 28 >> 2] = HEAP32[i34 + 28 >> 2];
   if (!i36) {
    i37 = i41 + 144 | 0;
    _longjmp(i37 | 0, 1);
   } else {
    i13 = HEAP32[i10 >> 2] | 0;
    i36 = i13 + 24 | 0;
    i37 = HEAP32[i37 >> 2] | 0;
    HEAP32[i37 + 24 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i37 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
    f21 = Math_fround(HEAPF32[i36 >> 2]);
    break;
   }
  } while (0);
  f7 = Math_fround(f21 - Math_fround(HEAPF32[i38 + 24 >> 2]));
  f6 = Math_fround(f16 - f21);
  if (Math_fround(f7 + f6) > Math_fround(0.0)) {
   f43 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f21 = Math_fround(f7 * Math_fround(f43 - Math_fround(HEAPF32[i25 + 28 >> 2])));
   if (!(Math_fround(f21 + Math_fround(f6 * Math_fround(f43 - Math_fround(HEAPF32[i39 >> 2])))) <= Math_fround(0.0))) {
    i41 = 0;
    STACKTOP = i42;
    return i41 | 0;
   }
  }
  HEAP32[i40 + 20 >> 2] = 1;
  HEAP32[i5 + 20 >> 2] = 1;
  i1 = HEAP32[i27 >> 2] | 0;
  i2 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i41 >> 2] | 0, i1) | 0;
  if (!i2) {
   i40 = i41 + 144 | 0;
   _longjmp(i40 | 0, 1);
  }
  i40 = HEAP32[i2 + 4 >> 2] | 0;
  i38 = HEAP32[i1 + 4 >> 2] | 0;
  i34 = HEAP32[(HEAP32[i38 + 4 >> 2] | 0) + 12 >> 2] | 0;
  i36 = i38 + 8 | 0;
  i39 = HEAP32[i36 >> 2] | 0;
  i37 = i34 + 8 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  HEAP32[(HEAP32[i39 + 4 >> 2] | 0) + 12 >> 2] = i34;
  HEAP32[(HEAP32[i35 + 4 >> 2] | 0) + 12 >> 2] = i38;
  HEAP32[i36 >> 2] = i35;
  HEAP32[i37 >> 2] = i39;
  i37 = HEAP32[i36 >> 2] | 0;
  i39 = i40 + 8 | 0;
  i35 = HEAP32[i39 >> 2] | 0;
  HEAP32[(HEAP32[i37 + 4 >> 2] | 0) + 12 >> 2] = i40;
  HEAP32[(HEAP32[i35 + 4 >> 2] | 0) + 12 >> 2] = i38;
  HEAP32[i36 >> 2] = i35;
  HEAP32[i39 >> 2] = i37;
  HEAP32[i38 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
  i39 = HEAP32[i40 + 4 >> 2] | 0;
  HEAP32[(HEAP32[i39 + 16 >> 2] | 0) + 8 >> 2] = i39;
  HEAP32[i39 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
  HEAP32[i40 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i39 + 28 >> 2] = HEAP32[i38 + 28 >> 2];
  if (!i40) {
   i41 = i41 + 144 | 0;
   _longjmp(i41 | 0, 1);
  }
  i40 = HEAP32[i10 >> 2] | 0;
  i41 = HEAP32[i22 >> 2] | 0;
  HEAP32[i41 + 24 >> 2] = HEAP32[i40 + 24 >> 2];
  HEAP32[i41 + 28 >> 2] = HEAP32[i40 + 28 >> 2];
  i41 = 0;
  STACKTOP = i42;
  return i41 | 0;
 } while (0);
 __ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion(i41, i5) | 0;
 i41 = 0;
 STACKTOP = i42;
 return i41 | 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i117, i104, i103, i1, i106, i105, i119, i120, i118, f2) {
 i117 = i117 | 0;
 i104 = i104 | 0;
 i103 = i103 | 0;
 i1 = i1 | 0;
 i106 = i106 | 0;
 i105 = i105 | 0;
 i119 = i119 | 0;
 i120 = i120 | 0;
 i118 = i118 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, f107 = f0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i121 = 0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0;
 i121 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i116 = i121 + 288 | 0;
 i111 = i121 + 384 | 0;
 i115 = i121 + 380 | 0;
 i76 = i121 + 144 | 0;
 i70 = i121 + 128 | 0;
 i110 = i121 + 304 | 0;
 i108 = i121 + 224 | 0;
 i109 = i121 + 160 | 0;
 i72 = i121 + 112 | 0;
 i73 = i121 + 96 | 0;
 i71 = i121 + 368 | 0;
 i84 = i121 + 80 | 0;
 i85 = i121 + 64 | 0;
 i86 = i121 + 48 | 0;
 i114 = i121 + 32 | 0;
 i112 = i121 + 16 | 0;
 i113 = i121;
 HEAP32[i116 >> 2] = 0;
 HEAP32[i116 + 4 >> 2] = 0;
 HEAP32[i116 + 8 >> 2] = 0;
 HEAP32[i116 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i105 >> 2]);
 i91 = i105 + 4 | 0;
 f8 = Math_fround(HEAPF32[i91 >> 2]);
 i97 = i105 + 8 | 0;
 f13 = Math_fround(HEAPF32[i97 >> 2]);
 f4 = Math_fround(HEAPF32[i106 >> 2]);
 i74 = i106 + 4 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i106 + 8 | 0;
 f9 = Math_fround(HEAPF32[i75 >> 2]);
 HEAP32[i115 >> 2] = 1;
 i81 = i103 + 48 | 0;
 f24 = Math_fround(HEAPF32[i81 >> 2]);
 i82 = i103 + 52 | 0;
 f27 = Math_fround(HEAPF32[i82 >> 2]);
 i83 = i103 + 56 | 0;
 f30 = Math_fround(HEAPF32[i83 >> 2]);
 i87 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f27 * f27)) + Math_fround(f30 * f30)) > Math_fround(1.1920929e-07);
 f31 = i87 ? f24 : Math_fround(1.0);
 f21 = i87 ? f27 : Math_fround(0.0);
 f26 = i87 ? f30 : Math_fround(0.0);
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f31 * f31) + Math_fround(f21 * f21))))));
 f31 = Math_fround(f31 * f20);
 f21 = Math_fround(f21 * f20);
 f20 = Math_fround(f26 * f20);
 HEAPF32[i76 >> 2] = f31;
 HEAPF32[i76 + 4 >> 2] = f21;
 HEAPF32[i76 + 8 >> 2] = f20;
 HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
 f31 = Math_fround(-f31);
 f21 = Math_fround(-f21);
 f20 = Math_fround(-f20);
 f26 = Math_fround(HEAPF32[i103 >> 2]);
 f18 = Math_fround(f26 * f31);
 i87 = i103 + 4 | 0;
 f29 = Math_fround(HEAPF32[i87 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f29 * f21));
 i88 = i103 + 8 | 0;
 f16 = Math_fround(HEAPF32[i88 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f16 * f20));
 i89 = i103 + 16 | 0;
 f33 = Math_fround(HEAPF32[i89 >> 2]);
 f19 = Math_fround(f33 * f31);
 i90 = i103 + 20 | 0;
 f32 = Math_fround(HEAPF32[i90 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f32 * f21));
 i92 = i103 + 24 | 0;
 f14 = Math_fround(HEAPF32[i92 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f14 * f20));
 i93 = i103 + 32 | 0;
 f25 = Math_fround(HEAPF32[i93 >> 2]);
 f31 = Math_fround(f25 * f31);
 i94 = i103 + 36 | 0;
 f28 = Math_fround(HEAPF32[i94 >> 2]);
 f21 = Math_fround(f31 + Math_fround(f28 * f21));
 i95 = i103 + 40 | 0;
 f31 = Math_fround(HEAPF32[i95 >> 2]);
 f20 = Math_fround(f21 + Math_fround(f31 * f20));
 i96 = i117 + 96 | 0;
 f21 = Math_fround(HEAPF32[i96 >> 2]);
 i98 = i117 + 100 | 0;
 f22 = Math_fround(HEAPF32[i98 >> 2]);
 i99 = i117 + 104 | 0;
 f23 = Math_fround(HEAPF32[i99 >> 2]);
 f17 = Math_fround(Math_fround(Math_fround(f18 * f21) + Math_fround(f19 * f22)) + Math_fround(f20 * f23));
 i100 = i117 + 112 | 0;
 f15 = Math_fround(HEAPF32[i100 >> 2]);
 i101 = i117 + 116 | 0;
 f107 = Math_fround(HEAPF32[i101 >> 2]);
 i102 = i117 + 120 | 0;
 f6 = Math_fround(HEAPF32[i102 >> 2]);
 i77 = f17 > Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f107)) + Math_fround(f20 * f6));
 f15 = i77 ? f21 : f15;
 f107 = i77 ? f22 : f107;
 f6 = i77 ? f23 : f6;
 f33 = Math_fround(f24 + Math_fround(Math_fround(f25 * f6) + Math_fround(Math_fround(f26 * f15) + Math_fround(f33 * f107))));
 f32 = Math_fround(f27 + Math_fround(Math_fround(f28 * f6) + Math_fround(Math_fround(f29 * f15) + Math_fround(f32 * f107))));
 f107 = Math_fround(f30 + Math_fround(Math_fround(f31 * f6) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f107))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i70, i104, i76);
 f14 = Math_fround(HEAPF32[i70 >> 2]);
 f15 = Math_fround(HEAPF32[i70 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f107 - Math_fround(HEAPF32[i70 + 8 >> 2]));
 HEAPF32[i110 >> 2] = f14;
 i76 = i110 + 4 | 0;
 HEAPF32[i76 >> 2] = f15;
 i77 = i110 + 8 | 0;
 HEAPF32[i77 >> 2] = f16;
 i78 = i110 + 12 | 0;
 HEAPF32[i78 >> 2] = Math_fround(0.0);
 i79 = i110 + 16 | 0;
 HEAP32[i79 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i79 = i110 + 32 | 0;
 HEAP32[i79 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i79 = i110 + 48 | 0;
 HEAP32[i79 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 HEAPF32[i108 >> 2] = f33;
 i79 = i108 + 4 | 0;
 HEAPF32[i79 >> 2] = f32;
 i80 = i108 + 8 | 0;
 HEAPF32[i80 >> 2] = f107;
 HEAPF32[i108 + 12 >> 2] = Math_fround(0.0);
 i69 = i108 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i69 = i108 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i69 = i108 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 HEAP32[i109 >> 2] = HEAP32[i70 >> 2];
 HEAP32[i109 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
 HEAP32[i109 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
 HEAP32[i109 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
 i70 = i109 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i70 = i109 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 i70 = i109 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 f107 = Math_fround(HEAPF32[i104 + 32 >> 2]);
 i70 = f107 < Math_fround(0.0);
 f107 = Math_fround(f107 * Math_fround(.100000001));
 f107 = i70 ? f107 : Math_fround(0.0);
 f32 = Math_fround(f107 + f2);
 f107 = Math_fround(f107 * f107);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f107) {
  i3 = i73 + 4 | 0;
  i34 = i73 + 8 | 0;
  i35 = i73 + 12 | 0;
  i36 = i72 + 4 | 0;
  i37 = i72 + 8 | 0;
  i38 = i109 + 4 | 0;
  i39 = i109 + 8 | 0;
  i40 = i109 + 12 | 0;
  i41 = i109 + 16 | 0;
  i42 = i109 + 20 | 0;
  i43 = i109 + 24 | 0;
  i44 = i109 + 28 | 0;
  i45 = i109 + 32 | 0;
  i46 = i109 + 36 | 0;
  i47 = i109 + 40 | 0;
  i48 = i109 + 44 | 0;
  i49 = i108 + 16 | 0;
  i50 = i108 + 20 | 0;
  i51 = i108 + 24 | 0;
  i52 = i110 + 16 | 0;
  i53 = i110 + 20 | 0;
  i54 = i110 + 24 | 0;
  i55 = i110 + 28 | 0;
  i56 = i108 + 32 | 0;
  i57 = i108 + 36 | 0;
  i58 = i108 + 40 | 0;
  i59 = i110 + 32 | 0;
  i60 = i110 + 36 | 0;
  i61 = i110 + 40 | 0;
  i62 = i110 + 44 | 0;
  i63 = i85 + 4 | 0;
  i64 = i85 + 8 | 0;
  i65 = i85 + 12 | 0;
  i66 = i84 + 4 | 0;
  i67 = i84 + 8 | 0;
  i68 = i86 + 4 | 0;
  i69 = i86 + 8 | 0;
  i70 = i86 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f122 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f18 = Math_fround(HEAPF32[i103 >> 2]);
   f127 = Math_fround(f18 * f122);
   f24 = Math_fround(HEAPF32[i87 >> 2]);
   f127 = Math_fround(f127 + Math_fround(f24 * f13));
   f21 = Math_fround(HEAPF32[i88 >> 2]);
   f127 = Math_fround(f127 + Math_fround(f21 * f8));
   f25 = Math_fround(HEAPF32[i89 >> 2]);
   f126 = Math_fround(f25 * f122);
   f26 = Math_fround(HEAPF32[i90 >> 2]);
   f126 = Math_fround(f126 + Math_fround(f26 * f13));
   f16 = Math_fround(HEAPF32[i92 >> 2]);
   f126 = Math_fround(f126 + Math_fround(f16 * f8));
   f19 = Math_fround(HEAPF32[i93 >> 2]);
   f125 = Math_fround(f19 * f122);
   f7 = Math_fround(HEAPF32[i94 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f7 * f13));
   f23 = Math_fround(HEAPF32[i95 >> 2]);
   f125 = Math_fround(f125 + Math_fround(f23 * f8));
   f124 = Math_fround(HEAPF32[i96 >> 2]);
   f17 = Math_fround(HEAPF32[i98 >> 2]);
   f123 = Math_fround(HEAPF32[i99 >> 2]);
   f128 = Math_fround(Math_fround(Math_fround(f127 * f124) + Math_fround(f126 * f17)) + Math_fround(f125 * f123));
   f20 = Math_fround(HEAPF32[i100 >> 2]);
   f27 = Math_fround(HEAPF32[i101 >> 2]);
   f22 = Math_fround(HEAPF32[i102 >> 2]);
   i1 = f128 > Math_fround(Math_fround(Math_fround(f127 * f20) + Math_fround(f126 * f27)) + Math_fround(f125 * f22));
   f20 = i1 ? f124 : f20;
   f27 = i1 ? f17 : f27;
   f22 = i1 ? f123 : f22;
   f123 = Math_fround(HEAPF32[i81 >> 2]);
   f17 = Math_fround(HEAPF32[i82 >> 2]);
   f25 = Math_fround(f123 + Math_fround(Math_fround(f19 * f22) + Math_fround(Math_fround(f18 * f20) + Math_fround(f25 * f27))));
   f26 = Math_fround(f17 + Math_fround(Math_fround(f7 * f22) + Math_fround(Math_fround(f24 * f20) + Math_fround(f26 * f27))));
   f27 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) + Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f21 * f20) + Math_fround(f16 * f27))));
   HEAPF32[i73 >> 2] = f9;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i34 >> 2] = f15;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i72, i104, i73);
   f16 = Math_fround(HEAPF32[i72 >> 2]);
   f20 = Math_fround(HEAPF32[i36 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i37 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23))) - f32);
   f17 = Math_fround(HEAPF32[i105 >> 2]);
   f18 = Math_fround(HEAPF32[i91 >> 2]);
   f19 = Math_fround(HEAPF32[i97 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f122) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i111 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i111 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i111 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f128 = Math_fround(HEAPF32[i106 >> 2]);
     f127 = Math_fround(HEAPF32[i74 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f128);
     f18 = Math_fround(Math_fround(f13 * f18) + f127);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i75 >> 2]));
     f127 = Math_fround(f17 - f31);
     f128 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i109 >> 2]);
     f4 = Math_fround(HEAPF32[i38 >> 2]);
     f2 = Math_fround(f127 + f2);
     f4 = Math_fround(f128 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f22 = Math_fround(HEAPF32[i41 >> 2]);
     f21 = Math_fround(HEAPF32[i42 >> 2]);
     f22 = Math_fround(f127 + f22);
     f21 = Math_fround(f128 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i43 >> 2]));
     f16 = Math_fround(HEAPF32[i45 >> 2]);
     f7 = Math_fround(HEAPF32[i46 >> 2]);
     f16 = Math_fround(f127 + f16);
     f7 = Math_fround(f128 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i47 >> 2]));
     HEAPF32[i109 >> 2] = f2;
     HEAPF32[i38 >> 2] = f4;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     HEAPF32[i41 >> 2] = f22;
     HEAPF32[i42 >> 2] = f21;
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = Math_fround(0.0);
     HEAPF32[i45 >> 2] = f16;
     HEAPF32[i46 >> 2] = f7;
     HEAPF32[i47 >> 2] = f8;
     HEAPF32[i48 >> 2] = Math_fround(0.0);
     f128 = Math_fround(HEAPF32[i108 >> 2]);
     f127 = Math_fround(HEAPF32[i79 >> 2]);
     f4 = Math_fround(f127 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i80 >> 2]) - f5);
     HEAPF32[i110 >> 2] = Math_fround(f128 - f2);
     HEAPF32[i76 >> 2] = f4;
     HEAPF32[i77 >> 2] = f5;
     HEAPF32[i78 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i49 >> 2]);
     f4 = Math_fround(HEAPF32[i50 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f20);
     HEAPF32[i52 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i53 >> 2] = f21;
     HEAPF32[i54 >> 2] = f20;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i56 >> 2]);
     f21 = Math_fround(HEAPF32[i57 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f8);
     HEAPF32[i59 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i60 >> 2] = f7;
     HEAPF32[i61 >> 2] = f8;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i85 >> 2] = f9;
     HEAPF32[i63 >> 2] = f14;
     HEAPF32[i64 >> 2] = f15;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i84, i104, i85);
     f9 = Math_fround(HEAPF32[i84 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i67 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i1 = HEAP32[i115 >> 2] | 0;
   HEAPF32[i108 + (i1 << 4) >> 2] = f25;
   HEAPF32[i108 + (i1 << 4) + 4 >> 2] = f26;
   HEAPF32[i108 + (i1 << 4) + 8 >> 2] = f27;
   HEAPF32[i108 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i109 + (i1 << 4) >> 2] = f16;
   HEAPF32[i109 + (i1 << 4) + 4 >> 2] = f20;
   HEAPF32[i109 + (i1 << 4) + 8 >> 2] = f21;
   HEAPF32[i109 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i115 >> 2] = i1 + 1;
   HEAPF32[i110 + (i1 << 4) >> 2] = f9;
   HEAPF32[i110 + (i1 << 4) + 4 >> 2] = f8;
   HEAPF32[i110 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i110 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i1 | 0) {
   case 0:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i110 >> 2]);
     f7 = Math_fround(HEAPF32[i76 >> 2]);
     f8 = Math_fround(HEAPF32[i77 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f126 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i1 = f126 > Math_fround(1.0);
      f126 = i1 ? Math_fround(1.0) : f126;
      i1 = f126 > Math_fround(0.0);
      f126 = i1 ? f126 : Math_fround(0.0);
      f127 = Math_fround(f7 + Math_fround(f14 * f126));
      f128 = Math_fround(f8 + Math_fround(f15 * f126));
      HEAPF32[i86 >> 2] = Math_fround(f6 + Math_fround(f9 * f126));
      HEAPF32[i68 >> 2] = f127;
      HEAPF32[i69 >> 2] = f128;
      HEAPF32[i70 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i115 >> 2] = 1;
      HEAP32[i86 >> 2] = HEAP32[i110 >> 2];
      HEAP32[i86 + 4 >> 2] = HEAP32[i110 + 4 >> 2];
      HEAP32[i86 + 8 >> 2] = HEAP32[i110 + 8 >> 2];
      HEAP32[i86 + 12 >> 2] = HEAP32[i110 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i110, i108, i109, i115);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i110, i108, i109, i115);
     break;
    }
   default:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i86 >> 2]);
   f8 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i121;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i104 = HEAP32[i117 + 64 >> 2] | 0;
 i105 = HEAP32[i117 + 68 >> 2] | 0;
 i106 = HEAP32[i117 + 72 >> 2] | 0;
 i103 = f6 > f107 & i1;
 f123 = i103 ? f7 : f2;
 f125 = i103 ? f8 : f4;
 f127 = i103 ? f9 : f5;
 f122 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f127 * f127) + Math_fround(Math_fround(f125 * f125) + Math_fround(f123 * f123))))));
 f123 = Math_fround(f123 * f122);
 f125 = Math_fround(f125 * f122);
 f122 = Math_fround(f127 * f122);
 HEAPF32[i120 >> 2] = f123;
 HEAPF32[i120 + 4 >> 2] = f125;
 HEAPF32[i120 + 8 >> 2] = f122;
 HEAPF32[i120 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i119 >> 2] = f13;
 i120 = i119 + 4 | 0;
 HEAP32[i120 >> 2] = HEAP32[i111 >> 2];
 HEAP32[i120 + 4 >> 2] = HEAP32[i111 + 4 >> 2];
 HEAP32[i120 + 8 >> 2] = HEAP32[i111 + 8 >> 2];
 HEAPF32[i114 >> 2] = i1 ? f7 : f10;
 HEAPF32[i114 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i114 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i114 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i112 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i112 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i112 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i112 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 HEAP32[i113 >> 2] = HEAP32[i116 >> 2];
 HEAP32[i113 + 4 >> 2] = HEAP32[i116 + 4 >> 2];
 HEAP32[i113 + 8 >> 2] = HEAP32[i116 + 8 >> 2];
 HEAP32[i113 + 12 >> 2] = HEAP32[i116 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i110, i108, i109, i114, i112, i113, HEAP32[i115 >> 2] | 0);
 f127 = Math_fround(HEAPF32[i117 + 16 >> 2]);
 f124 = Math_fround(HEAPF32[i112 >> 2]);
 f126 = Math_fround(HEAPF32[i112 + 4 >> 2]);
 f128 = Math_fround(HEAPF32[i112 + 8 >> 2]);
 f123 = Math_fround(f124 - Math_fround(f123 * f127));
 f125 = Math_fround(f126 - Math_fround(f125 * f127));
 f127 = Math_fround(f128 - Math_fround(f122 * f127));
 HEAPF32[i118 >> 2] = i104 | 0 ? f123 : f124;
 HEAPF32[i118 + 4 >> 2] = i105 | 0 ? f125 : f126;
 HEAPF32[i118 + 8 >> 2] = i106 | 0 ? f127 : f128;
 HEAPF32[i118 + 12 >> 2] = Math_fround(0.0);
 i120 = 1;
 STACKTOP = i121;
 return i120 | 0;
}

function __ZN15QualitySettings8TransferI14SafeBinaryReadEEvRT_(i9, i14) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 672 | 0;
 i10 = i15 + 24 | 0;
 i4 = i15 + 20 | 0;
 i5 = i15 + 16 | 0;
 i7 = i15;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i9, i14);
 __ZN14SafeBinaryRead10SetVersionEi(i14, 5);
 i6 = i9 + 44 | 0;
 i11 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405365 | 0, i11, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i8 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i13 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i8 = i9 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405382 | 0, HEAP32[gb + 37316 >> 2] | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i14, i8, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 4) | 0) {
  HEAP32[i10 >> 2] = 3;
  HEAP32[i4 >> 2] = 3;
  HEAP32[i5 >> 2] = 2;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405400 | 0, i11, i12, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i14 + 16 | 0;
    i3 = HEAP32[i14 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i13 = 24; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 24; else {
      HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i13 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
    if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405427 | 0, i11, i12, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i14 + 16 | 0;
    i3 = HEAP32[i14 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i13 = 35; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 35; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i13 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405453 | 0, i11, i12, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i14 + 16 | 0;
    i4 = HEAP32[i14 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i13 = 46; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 46; else {
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i13 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
    if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405476 | 0, i11, i12, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i14 + 16 | 0;
    i5 = HEAP32[i14 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i13 = 57; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 57; else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i13 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
    if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1;
  if (((HEAP32[i9 + 32 >> 2] | 0) - i1 | 0) == 648) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i4 = i7 + 11 | 0;
   HEAP8[i4 >> 0] = 7;
   HEAP8[i7 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
   HEAP8[i7 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
   HEAP8[i7 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
   HEAP8[i7 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
   HEAP8[i7 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
   HEAP8[i7 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
   HEAP8[i7 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
   HEAP8[i7 + 7 >> 0] = 0;
   L88 : do if ((i3 | 0) != (i7 | 0)) {
    i5 = i1 + 11 | 0;
    do if ((HEAP8[i5 >> 0] | 0) < 0) {
     i1 = HEAP32[i3 + 8 >> 2] & 2147483647;
     i2 = i1 + -1 | 0;
     if (i2 >>> 0 < 7) {
      i6 = HEAP32[i3 + 4 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i2, 8 - i1 | 0, i6, 0, i6, 7, i7);
      break L88;
     } else {
      i1 = HEAP32[i3 >> 2] | 0;
      break;
     }
    } while (0);
    _memmove(i1 | 0, i7 | 0, 7) | 0;
    HEAP8[i1 + 7 >> 0] = 0;
    if ((HEAP8[i5 >> 0] | 0) < 0) {
     HEAP32[i3 + 4 >> 2] = 7;
     break;
    } else {
     HEAP8[i5 >> 0] = 7;
     break;
    }
   } while (0);
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = i4 + 108 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i5 = i7 + 11 | 0;
   HEAP8[i5 >> 0] = 4;
   HEAP32[i7 >> 2] = 1953718598;
   HEAP8[i7 + 4 >> 0] = 0;
   L104 : do if ((i1 | 0) != (i7 | 0)) {
    i6 = i1 + 11 | 0;
    do if ((HEAP8[i6 >> 0] | 0) < 0) {
     i2 = HEAP32[i4 + 116 >> 2] & 2147483647;
     i3 = i2 + -1 | 0;
     if (i3 >>> 0 < 4) {
      i6 = HEAP32[i4 + 112 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 5 - i2 | 0, i6, 0, i6, 4, i7);
      break L104;
     } else {
      i1 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } while (0);
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP8[i1 >> 0] = i3;
    HEAP8[i1 + 1 >> 0] = i3 >> 8;
    HEAP8[i1 + 2 >> 0] = i3 >> 16;
    HEAP8[i1 + 3 >> 0] = i3 >> 24;
    HEAP8[i1 + 4 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i4 + 112 >> 2] = 4;
     break;
    } else {
     HEAP8[i6 >> 0] = 4;
     break;
    }
   } while (0);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = i4 + 216 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i5 = i7 + 11 | 0;
   HEAP8[i5 >> 0] = 6;
   HEAP8[i7 >> 0] = HEAP8[gb + 405500 >> 0] | 0;
   HEAP8[i7 + 1 >> 0] = HEAP8[gb + 405500 + 1 >> 0] | 0;
   HEAP8[i7 + 2 >> 0] = HEAP8[gb + 405500 + 2 >> 0] | 0;
   HEAP8[i7 + 3 >> 0] = HEAP8[gb + 405500 + 3 >> 0] | 0;
   HEAP8[i7 + 4 >> 0] = HEAP8[gb + 405500 + 4 >> 0] | 0;
   HEAP8[i7 + 5 >> 0] = HEAP8[gb + 405500 + 5 >> 0] | 0;
   HEAP8[i7 + 6 >> 0] = 0;
   L120 : do if ((i1 | 0) != (i7 | 0)) {
    i6 = i1 + 11 | 0;
    do if ((HEAP8[i6 >> 0] | 0) < 0) {
     i2 = HEAP32[i4 + 224 >> 2] & 2147483647;
     i3 = i2 + -1 | 0;
     if (i3 >>> 0 < 6) {
      i6 = HEAP32[i4 + 220 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 7 - i2 | 0, i6, 0, i6, 6, i7);
      break L120;
     } else {
      i1 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } while (0);
    _memmove(i1 | 0, i7 | 0, 6) | 0;
    HEAP8[i1 + 6 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i4 + 220 >> 2] = 6;
     break;
    } else {
     HEAP8[i6 >> 0] = 6;
     break;
    }
   } while (0);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = i4 + 324 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i5 = i7 + 11 | 0;
   HEAP8[i5 >> 0] = 4;
   HEAP32[i7 >> 2] = 1685024583;
   HEAP8[i7 + 4 >> 0] = 0;
   L136 : do if ((i1 | 0) != (i7 | 0)) {
    i6 = i1 + 11 | 0;
    do if ((HEAP8[i6 >> 0] | 0) < 0) {
     i2 = HEAP32[i4 + 332 >> 2] & 2147483647;
     i3 = i2 + -1 | 0;
     if (i3 >>> 0 < 4) {
      i6 = HEAP32[i4 + 328 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 5 - i2 | 0, i6, 0, i6, 4, i7);
      break L136;
     } else {
      i1 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } while (0);
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP8[i1 >> 0] = i3;
    HEAP8[i1 + 1 >> 0] = i3 >> 8;
    HEAP8[i1 + 2 >> 0] = i3 >> 16;
    HEAP8[i1 + 3 >> 0] = i3 >> 24;
    HEAP8[i1 + 4 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i4 + 328 >> 2] = 4;
     break;
    } else {
     HEAP8[i6 >> 0] = 4;
     break;
    }
   } while (0);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
   i5 = HEAP32[i8 >> 2] | 0;
   i1 = i5 + 432 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i6 = i7 + 11 | 0;
   HEAP8[i6 >> 0] = 9;
   i2 = i7;
   i3 = gb + 405507 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i7 + 9 >> 0] = 0;
   L152 : do if ((i1 | 0) != (i7 | 0)) {
    i4 = i1 + 11 | 0;
    do if ((HEAP8[i4 >> 0] | 0) < 0) {
     i2 = HEAP32[i5 + 440 >> 2] & 2147483647;
     i3 = i2 + -1 | 0;
     if (i3 >>> 0 < 9) {
      i5 = HEAP32[i5 + 436 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 10 - i2 | 0, i5, 0, i5, 9, i7);
      break L152;
     } else {
      i1 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } while (0);
    _memmove(i1 | 0, i7 | 0, 9) | 0;
    HEAP8[i1 + 9 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i5 + 436 >> 2] = 9;
     break;
    } else {
     HEAP8[i4 >> 0] = 9;
     break;
    }
   } while (0);
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
   i5 = HEAP32[i8 >> 2] | 0;
   i1 = i5 + 540 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i6 = i7 + 11 | 0;
   HEAP8[i6 >> 0] = 9;
   i2 = i7;
   i3 = gb + 405517 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i7 + 9 >> 0] = 0;
   L168 : do if ((i1 | 0) != (i7 | 0)) {
    i4 = i1 + 11 | 0;
    do if ((HEAP8[i4 >> 0] | 0) < 0) {
     i2 = HEAP32[i5 + 548 >> 2] & 2147483647;
     i3 = i2 + -1 | 0;
     if (i3 >>> 0 < 9) {
      i5 = HEAP32[i5 + 544 >> 2] | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 10 - i2 | 0, i5, 0, i5, 9, i7);
      break L168;
     } else {
      i1 = HEAP32[i1 >> 2] | 0;
      break;
     }
    } while (0);
    _memmove(i1 | 0, i7 | 0, 9) | 0;
    HEAP8[i1 + 9 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i5 + 544 >> 2] = 9;
     break;
    } else {
     HEAP8[i4 >> 0] = 9;
     break;
    }
   } while (0);
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
   }
  }
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 3) | 0) {
  i3 = i10 + 648 | 0;
  i1 = i10;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i1 + 11 >> 0] = 7;
   HEAP8[i1 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
   HEAP8[i1 + 7 >> 0] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 1;
   HEAP32[i1 + 32 >> 2] = 1;
   HEAPF32[i1 + 36 >> 2] = Math_fround(15.0);
   HEAPF32[i1 + 40 >> 2] = Math_fround(3.0);
   HEAPF32[i1 + 44 >> 2] = Math_fround(.333333343);
   HEAPF32[i1 + 48 >> 2] = Math_fround(.0666666701);
   HEAPF32[i1 + 52 >> 2] = Math_fround(.200000003);
   HEAPF32[i1 + 56 >> 2] = Math_fround(.466666669);
   HEAP32[i1 + 60 >> 2] = 1;
   HEAP32[i1 + 64 >> 2] = 1;
   i7 = i1 + 68 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
   HEAP32[i1 + 88 >> 2] = 0;
   HEAP32[i1 + 92 >> 2] = 4;
   HEAPF32[i1 + 96 >> 2] = Math_fround(512.0);
   HEAP32[i1 + 100 >> 2] = 2;
   HEAP32[i1 + 104 >> 2] = 4;
   i1 = i1 + 108 | 0;
  } while ((i1 | 0) != (i3 | 0));
  __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE(i10);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405492 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i10, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i2 = i10 + 108 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405542 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i2 = i10 + 216 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405500 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i2 = i10 + 324 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 585419 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i2 = i10 + 432 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405507 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  i2 = i10 + 540 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405517 | 0, gb + 405527 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 2) | 0) {
   HEAP32[i10 + 28 >> 2] = 0;
   HEAP32[i10 + 136 >> 2] = 0;
   HEAP32[i10 + 244 >> 2] = 0;
   HEAP32[i10 + 352 >> 2] = 0;
   HEAP32[i10 + 460 >> 2] = 0;
   HEAP32[i10 + 568 >> 2] = 0;
  }
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i10, i3);
  i2 = i12 + 4 | 0;
  i1 = i10 + 540 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i10 + 552 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
  i1 = i10 + 432 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i10 + 444 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
  i1 = i10 + 324 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i10 + 336 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
  i1 = i10 + 216 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i10 + 228 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
  i1 = i10 + 108 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i10 + 120 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
  if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i2 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
  }
 }
 i4 = i9 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405547 | 0, i11, i12, 0) | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i14 + 16 | 0;
  i12 = HEAP32[i14 + 20 >> 2] | 0;
  i2 = i12 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i12 >>> 0) i13 = 181; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i13 = 181; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i13 | 0) == 181) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i14);
 STACKTOP = i15;
 return;
}

function __ZN13InitialModule5ResetEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 HEAP8[i11 + 4 >> 0] = 1;
 HEAPF32[i11 + 2540 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 2544 >> 2] = Math_fround(0.0);
 HEAP32[i11 + 2548 >> 2] = 1e3;
 HEAP8[i11 + 2552 >> 0] = 0;
 HEAP8[i11 + 2553 >> 0] = 0;
 i3 = i11 + 2276 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 2280 >> 2] = i2;
 HEAP32[i11 + 2284 >> 2] = i4;
 HEAP32[i11 + 2288 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 i2 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 2292 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 2296 >> 2] = i1;
 HEAP32[i11 + 2300 >> 2] = i4;
 HEAP32[i11 + 2304 >> 2] = i2;
 i2 = i12 + 32 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i11 + 2308 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i4 = HEAP32[i12 + 48 >> 2] | 0;
 i2 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 2316 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 2320 >> 2] = i1;
 HEAP32[i11 + 2324 >> 2] = i4;
 HEAP32[i11 + 2328 >> 2] = i2;
 i2 = HEAP32[i12 + 60 >> 2] | 0;
 i4 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 2332 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 2336 >> 2] = i2;
 HEAP32[i11 + 2340 >> 2] = i4;
 HEAP32[i11 + 2344 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i11 + 2348 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i11 + 2356 | 0;
 i4 = i12 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP16[i2 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[i4 + 6 >> 0] | 0;
 i4 = i11 + 2364 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAP8[i11 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3, i4, Math_fround(0.0), HEAP16[i11 + 2360 >> 1] | 0) | 0) & 1;
 i2 = i11 + 8 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 12 >> 2] = i3;
 HEAP32[i11 + 16 >> 2] = i4;
 HEAP32[i11 + 20 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 24 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 28 >> 2] = i1;
 HEAP32[i11 + 32 >> 2] = i4;
 HEAP32[i11 + 36 >> 2] = i3;
 i3 = i12 + 32 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i4 = HEAP32[i12 + 48 >> 2] | 0;
 i3 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 48 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 52 >> 2] = i1;
 HEAP32[i11 + 56 >> 2] = i4;
 HEAP32[i11 + 60 >> 2] = i3;
 i3 = HEAP32[i12 + 60 >> 2] | 0;
 i4 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 64 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 68 >> 2] = i3;
 HEAP32[i11 + 72 >> 2] = i4;
 HEAP32[i11 + 76 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i11 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i11 + 88 | 0;
 i4 = i12 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP16[i3 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
 HEAP8[i3 + 6 >> 0] = HEAP8[i4 + 6 >> 0] | 0;
 i4 = i11 + 96 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAPF32[i3 >> 2] = Math_fround(5.0);
 HEAP8[i11 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2, i4, Math_fround(5.0), HEAP16[i11 + 92 >> 1] | 0) | 0) & 1;
 i2 = i11 + 272 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 276 >> 2] = i3;
 HEAP32[i11 + 280 >> 2] = i4;
 HEAP32[i11 + 284 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 288 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 292 >> 2] = i1;
 HEAP32[i11 + 296 >> 2] = i4;
 HEAP32[i11 + 300 >> 2] = i3;
 i3 = i12 + 32 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i11 + 304 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i4 = HEAP32[i12 + 48 >> 2] | 0;
 i3 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 312 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 316 >> 2] = i1;
 HEAP32[i11 + 320 >> 2] = i4;
 HEAP32[i11 + 324 >> 2] = i3;
 i3 = HEAP32[i12 + 60 >> 2] | 0;
 i4 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 328 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 332 >> 2] = i3;
 HEAP32[i11 + 336 >> 2] = i4;
 HEAP32[i11 + 340 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i11 + 344 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i11 + 352 | 0;
 i4 = i12 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP16[i3 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
 HEAP8[i3 + 6 >> 0] = HEAP8[i4 + 6 >> 0] | 0;
 i4 = i11 + 360 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAPF32[i3 >> 2] = Math_fround(5.0);
 HEAP8[i11 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2, i4, Math_fround(5.0), HEAP16[i11 + 356 >> 1] | 0) | 0) & 1;
 __ZN14MinMaxGradientC2Ev(i12);
 HEAP32[i11 + 536 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 540 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i11 + 544 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i11 + 548 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i11 + 552 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 556 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i11 + 560 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i11 + 564 >> 2] = HEAP32[i12 + 28 >> 2];
 i1 = i11 + 568 | 0;
 i2 = i12 + 32 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i11 + 608 >> 2] = HEAP32[i12 + 72 >> 2];
 HEAP32[i11 + 612 >> 2] = HEAP32[i12 + 76 >> 2];
 HEAP32[i11 + 616 >> 2] = HEAP32[i12 + 80 >> 2];
 HEAP32[i11 + 620 >> 2] = HEAP32[i12 + 84 >> 2];
 HEAP32[i11 + 624 >> 2] = HEAP32[i12 + 88 >> 2];
 HEAP32[i11 + 628 >> 2] = HEAP32[i12 + 92 >> 2];
 HEAP32[i11 + 632 >> 2] = HEAP32[i12 + 96 >> 2];
 HEAP32[i11 + 636 >> 2] = HEAP32[i12 + 100 >> 2];
 i1 = i11 + 640 | 0;
 i2 = i12 + 104 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i11 + 680 >> 2] = HEAP32[i12 + 144 >> 2];
 HEAP32[i11 + 684 >> 2] = HEAP32[i12 + 148 >> 2];
 HEAP16[i11 + 688 >> 1] = HEAP16[i12 + 152 >> 1] | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 + 692 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 696 >> 2] = i1;
 HEAP32[i11 + 700 >> 2] = i10;
 HEAP32[i11 + 704 >> 2] = i9;
 i9 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = HEAP32[i12 + 24 >> 2] | 0;
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 708 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 712 >> 2] = i9;
 HEAP32[i11 + 716 >> 2] = i10;
 HEAP32[i11 + 720 >> 2] = i1;
 i1 = i12 + 32 | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i11 + 724 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = HEAP32[i12 + 44 >> 2] | 0;
 i10 = HEAP32[i12 + 48 >> 2] | 0;
 i1 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 732 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 736 >> 2] = i9;
 HEAP32[i11 + 740 >> 2] = i10;
 HEAP32[i11 + 744 >> 2] = i1;
 i1 = HEAP32[i12 + 60 >> 2] | 0;
 i10 = HEAP32[i12 + 64 >> 2] | 0;
 i9 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 748 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 752 >> 2] = i1;
 HEAP32[i11 + 756 >> 2] = i10;
 HEAP32[i11 + 760 >> 2] = i9;
 i9 = i12 + 72 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i11 + 764 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i11 + 772 | 0;
 i10 = i12 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP16[i1 + 4 >> 1] = HEAP16[i10 + 4 >> 1] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i10 + 6 >> 0] | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i11 + 780 | 0, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN11MinMaxCurveC2Ev(i12);
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 + 956 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 960 >> 2] = i1;
 HEAP32[i11 + 964 >> 2] = i10;
 HEAP32[i11 + 968 >> 2] = i9;
 i9 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = HEAP32[i12 + 24 >> 2] | 0;
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 972 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 976 >> 2] = i9;
 HEAP32[i11 + 980 >> 2] = i10;
 HEAP32[i11 + 984 >> 2] = i1;
 i1 = i12 + 32 | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i11 + 988 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = HEAP32[i12 + 44 >> 2] | 0;
 i10 = HEAP32[i12 + 48 >> 2] | 0;
 i1 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 996 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 1e3 >> 2] = i9;
 HEAP32[i11 + 1004 >> 2] = i10;
 HEAP32[i11 + 1008 >> 2] = i1;
 i1 = HEAP32[i12 + 60 >> 2] | 0;
 i10 = HEAP32[i12 + 64 >> 2] | 0;
 i9 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 1012 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 1016 >> 2] = i1;
 HEAP32[i11 + 1020 >> 2] = i10;
 HEAP32[i11 + 1024 >> 2] = i9;
 i9 = i12 + 72 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i11 + 1028 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i11 + 1036 | 0;
 i10 = i12 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP16[i1 + 4 >> 1] = HEAP16[i10 + 4 >> 1] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i10 + 6 >> 0] | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i11 + 1044 | 0, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN11MinMaxCurveC2Ev(i12);
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 + 1220 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 1224 >> 2] = i1;
 HEAP32[i11 + 1228 >> 2] = i10;
 HEAP32[i11 + 1232 >> 2] = i9;
 i9 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = HEAP32[i12 + 24 >> 2] | 0;
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 1236 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 1240 >> 2] = i9;
 HEAP32[i11 + 1244 >> 2] = i10;
 HEAP32[i11 + 1248 >> 2] = i1;
 i1 = i12 + 32 | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i11 + 1252 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = HEAP32[i12 + 44 >> 2] | 0;
 i10 = HEAP32[i12 + 48 >> 2] | 0;
 i1 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 1260 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 1264 >> 2] = i9;
 HEAP32[i11 + 1268 >> 2] = i10;
 HEAP32[i11 + 1272 >> 2] = i1;
 i1 = HEAP32[i12 + 60 >> 2] | 0;
 i10 = HEAP32[i12 + 64 >> 2] | 0;
 i9 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 1276 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 1280 >> 2] = i1;
 HEAP32[i11 + 1284 >> 2] = i10;
 HEAP32[i11 + 1288 >> 2] = i9;
 i9 = i12 + 72 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i11 + 1292 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i11 + 1300 | 0;
 i10 = i12 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP16[i1 + 4 >> 1] = HEAP16[i10 + 4 >> 1] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i10 + 6 >> 0] | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i11 + 1308 | 0, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i8 = i11 + 1484 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i9 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 1488 >> 2] = i9;
 HEAP32[i11 + 1492 >> 2] = i10;
 HEAP32[i11 + 1496 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = HEAP32[i12 + 24 >> 2] | 0;
 i9 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 1500 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 1504 >> 2] = i1;
 HEAP32[i11 + 1508 >> 2] = i10;
 HEAP32[i11 + 1512 >> 2] = i9;
 i9 = i12 + 32 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i11 + 1516 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i10 = HEAP32[i12 + 48 >> 2] | 0;
 i9 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 1524 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 1528 >> 2] = i1;
 HEAP32[i11 + 1532 >> 2] = i10;
 HEAP32[i11 + 1536 >> 2] = i9;
 i9 = HEAP32[i12 + 60 >> 2] | 0;
 i10 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 1540 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 1544 >> 2] = i9;
 HEAP32[i11 + 1548 >> 2] = i10;
 HEAP32[i11 + 1552 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i11 + 1556 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i11 + 1564 | 0;
 i10 = i12 + 80 | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP16[i9 + 4 >> 1] = HEAP16[i10 + 4 >> 1] | 0;
 HEAP8[i9 + 6 >> 0] = HEAP8[i10 + 6 >> 0] | 0;
 i10 = i11 + 1572 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i10, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i11 + 1748 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i7 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 1752 >> 2] = i6;
 HEAP32[i11 + 1756 >> 2] = i7;
 HEAP32[i11 + 1760 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i7 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 1764 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 1768 >> 2] = i1;
 HEAP32[i11 + 1772 >> 2] = i7;
 HEAP32[i11 + 1776 >> 2] = i6;
 i6 = i12 + 32 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i11 + 1780 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i7 = HEAP32[i12 + 48 >> 2] | 0;
 i6 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 1788 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 1792 >> 2] = i1;
 HEAP32[i11 + 1796 >> 2] = i7;
 HEAP32[i11 + 1800 >> 2] = i6;
 i6 = HEAP32[i12 + 60 >> 2] | 0;
 i7 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 1804 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 1808 >> 2] = i6;
 HEAP32[i11 + 1812 >> 2] = i7;
 HEAP32[i11 + 1816 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i11 + 1820 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = i11 + 1828 | 0;
 i7 = i12 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP16[i6 + 4 >> 1] = HEAP16[i7 + 4 >> 1] | 0;
 HEAP8[i6 + 6 >> 0] = HEAP8[i7 + 6 >> 0] | 0;
 i7 = i11 + 1836 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i7, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i11 + 2012 | 0;
 __ZN11MinMaxCurveC2Ev(i12);
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i12 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 2016 >> 2] = i3;
 HEAP32[i11 + 2020 >> 2] = i4;
 HEAP32[i11 + 2024 >> 2] = i1;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i11 + 2028 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i11 + 2032 >> 2] = i1;
 HEAP32[i11 + 2036 >> 2] = i4;
 HEAP32[i11 + 2040 >> 2] = i3;
 i3 = i12 + 32 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i11 + 2044 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i12 + 44 >> 2] | 0;
 i4 = HEAP32[i12 + 48 >> 2] | 0;
 i3 = HEAP32[i12 + 52 >> 2] | 0;
 HEAP32[i11 + 2052 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i11 + 2056 >> 2] = i1;
 HEAP32[i11 + 2060 >> 2] = i4;
 HEAP32[i11 + 2064 >> 2] = i3;
 i3 = HEAP32[i12 + 60 >> 2] | 0;
 i4 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i11 + 2068 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i11 + 2072 >> 2] = i3;
 HEAP32[i11 + 2076 >> 2] = i4;
 HEAP32[i11 + 2080 >> 2] = i1;
 i1 = i12 + 72 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i11 + 2084 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i11 + 2092 | 0;
 i4 = i12 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP16[i3 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
 HEAP8[i3 + 6 >> 0] = HEAP8[i4 + 6 >> 0] | 0;
 i4 = i11 + 2100 | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4, i12 + 88 | 0) | 0;
 i1 = i12 + 232 | 0;
 if ((HEAP32[i12 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i12 + 144 | 0;
 if ((HEAP32[i12 + 160 >> 2] | 0) <= -1) {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i12 = i11 + 1568 | 0;
  i12 = HEAP16[i12 >> 1] | 0;
  i12 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i8, i10, Math_fround(0.0), i12) | 0;
  i10 = i11 + 1570 | 0;
  i12 = i12 & 1;
  HEAP8[i10 >> 0] = i12;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i10 = i11 + 1832 | 0;
  i10 = HEAP16[i10 >> 1] | 0;
  i10 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i5, i7, Math_fround(0.0), i10) | 0;
  i12 = i11 + 1834 | 0;
  i10 = i10 & 1;
  HEAP8[i12 >> 0] = i10;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i12 = i11 + 2096 | 0;
  i12 = HEAP16[i12 >> 1] | 0;
  i12 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2, i4, Math_fround(0.0), i12) | 0;
  i10 = i11 + 2098 | 0;
  i12 = i12 & 1;
  HEAP8[i10 >> 0] = i12;
  i10 = i11 + 2620 | 0;
  i12 = i11 + 2624 | 0;
  HEAP32[i10 >> 2] = -1;
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  i12 = i11 + 2628 | 0;
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  i12 = i11 + 2632 | 0;
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  i12 = i11 + 2636 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 148 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i12 = i11 + 1568 | 0;
 i12 = HEAP16[i12 >> 1] | 0;
 i12 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i8, i10, Math_fround(0.0), i12) | 0;
 i10 = i11 + 1570 | 0;
 i12 = i12 & 1;
 HEAP8[i10 >> 0] = i12;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i10 = i11 + 1832 | 0;
 i10 = HEAP16[i10 >> 1] | 0;
 i10 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i5, i7, Math_fround(0.0), i10) | 0;
 i12 = i11 + 1834 | 0;
 i10 = i10 & 1;
 HEAP8[i12 >> 0] = i10;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i12 = i11 + 2096 | 0;
 i12 = HEAP16[i12 >> 1] | 0;
 i12 = __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2, i4, Math_fround(0.0), i12) | 0;
 i10 = i11 + 2098 | 0;
 i12 = i12 & 1;
 HEAP8[i10 >> 0] = i12;
 i10 = i11 + 2620 | 0;
 i12 = i11 + 2624 | 0;
 HEAP32[i10 >> 2] = -1;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i12 = i11 + 2628 | 0;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i12 = i11 + 2632 | 0;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i12 = i11 + 2636 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN15TerrainCollider11CreateTreesEv(i57) {
 i57 = i57 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, i64 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i60 + 112 | 0;
 i58 = i60 + 32 | 0;
 i56 = i60;
 i50 = i60 + 248 | 0;
 i51 = i60 + 184 | 0;
 i52 = i60 + 268 | 0;
 i53 = i60 + 168 | 0;
 i59 = i60 + 152 | 0;
 i54 = i60 + 120 | 0;
 i55 = i60 + 116 | 0;
 i6 = i57 + 60 | 0;
 HEAP32[i56 >> 2] = HEAP32[i6 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i29 = 6; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i58, i2, i56);
   i1 = HEAP32[i58 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i49 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
   i3 = HEAP32[i49 + 28 >> 2] | 0;
   i4 = HEAP32[i49 + 32 >> 2] | 0;
   i2 = i49;
  }
  if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i29 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 8;
  }
 }
 if ((i29 | 0) == 6) i29 = 8;
 if ((i29 | 0) == 8) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
 }
 i49 = i1 + 100 | 0;
 HEAP32[i56 >> 2] = HEAP32[i6 >> 2];
 if (!i2) i29 = 14; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i48 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i48 + (i3 << 3) | 0;
   i2 = i48;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i58, i2, i56);
   i1 = HEAP32[i58 >> 2] | 0;
   i48 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i48 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i48 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 14; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 16;
  }
 }
 if ((i29 | 0) == 14) i29 = 16;
 if ((i29 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i26 = i1 + 88 | 0;
 i4 = __Z18GetITerrainManagerv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i56 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i29 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i58, i1, i56);
   i2 = HEAP32[i58 >> 2] | 0;
   i48 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i48 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i48 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i29 = 24;
  }
 }
 if ((i29 | 0) == 22) i29 = 24;
 if ((i29 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 mftCall_viii(i5 | 0, i53 | 0, i4 | 0, i1 + 248 | 0);
 HEAP32[i59 >> 2] = 0;
 i48 = i59 + 4 | 0;
 HEAP32[i48 >> 2] = 0;
 HEAP32[i59 + 8 >> 2] = 0;
 HEAP32[i59 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i23 = i26 + 4 | 0;
 i1 = (HEAP32[i23 >> 2] | 0) - (HEAP32[i26 >> 2] | 0) >> 3;
 i3 = gb + 64016 | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i56;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i50 >> 2] = 0;
 HEAP32[i50 + 12 >> 2] = 0;
 i5 = i50 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i50 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i58, i56);
 i3 = i58;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = HEAP32[i48 >> 2] | 0;
 i4 = HEAP32[i59 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 20 | 0;
 if (i1 >>> 0 > i3 >>> 0) __ZNSt3__26vectorI13dynamic_arrayI21TreePrototypeColliderLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEjRKS3_(i59, i1 - i3 | 0, i50); else if (i1 >>> 0 < i3 >>> 0) {
  i3 = i4 + (i1 * 20 | 0) | 0;
  if ((i2 | 0) != (i3 | 0)) while (1) {
   i1 = i2 + -20 | 0;
   HEAP32[i48 >> 2] = i1;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i48 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i50 >> 2] | 0, i6);
  HEAP32[i50 >> 2] = 0;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if ((HEAP32[i23 >> 2] | 0) != (i1 | 0)) {
  i16 = i50 + 12 | 0;
  i17 = i50 + 16 | 0;
  i18 = i50 + 4 | 0;
  i19 = i58 + 4 | 0;
  i20 = i58 + 8 | 0;
  i21 = i58 + 72 | 0;
  i22 = i58 + 11 | 0;
  i15 = 0;
  do {
   i5 = HEAP32[i59 >> 2] | 0;
   i14 = i5 + (i15 * 20 | 0) | 0;
   i4 = i1 + (i15 << 3) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i56 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i29 = 44; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i58, i1, i56);
      i2 = HEAP32[i58 >> 2] | 0;
      i47 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i47 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i47 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i29 = 44; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i29 = 46;
     }
    }
    if ((i29 | 0) == 44) i29 = 46;
    if ((i29 | 0) == 46) {
     i29 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i9 = __ZNK10GameObject23QueryComponentTransformEv(i1) | 0;
    i47 = gb + 64016 | 0;
    i46 = HEAP32[i47 + 4 >> 2] | 0;
    i45 = i56;
    HEAP32[i45 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i45 + 4 >> 2] = i46;
    HEAP32[i50 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i58, i56);
    i45 = i58;
    i46 = HEAP32[i45 + 4 >> 2] | 0;
    i47 = i18;
    HEAP32[i47 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i47 + 4 >> 2] = i46;
    __Z27GetComponentsInChildrenImplILb0EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE(i1, 56, i50);
    if (HEAP32[i16 >> 2] | 0) {
     i10 = i5 + (i15 * 20 | 0) + 12 | 0;
     i11 = i5 + (i15 * 20 | 0) + 16 | 0;
     i8 = i5 + (i15 * 20 | 0) + 4 | 0;
     i7 = i1 + 4 | 0;
     i6 = 0;
     do {
      i1 = HEAP32[(HEAP32[i50 >> 2] | 0) + (i6 << 2) >> 2] | 0;
      do if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) {
       i2 = i1 + 28 | 0;
       if (__ZN10GameObject28IsActiveIgnoreImplicitPrefabEv(HEAP32[i2 >> 2] | 0) | 0) {
        i3 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
        if (!((i3 | 0) == (gb + 113668 | 0) | ((i3 | 0) == (gb + 110912 | 0) | (i3 | 0) == (gb + 64328 | 0)))) {
         HEAP32[i28 >> 2] = __ZNK6Object12GetClassNameEv(i1) | 0;
         __Z6FormatPKcz(i58, gb + 1016382 | 0, i28);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i58 >> 2] | 0 : i58, 0, gb + 1016445 | 0, 185, 512, HEAP32[i7 >> 2] | 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i58);
         break;
        }
        HEAP32[i58 >> 2] = i3;
        HEAP32[i19 >> 2] = i1;
        __ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i1, i9, i20) | 0;
        HEAP32[i21 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2];
        i2 = HEAP32[i10 >> 2] | 0;
        i3 = i2 + 1 | 0;
        i4 = HEAP32[i11 >> 2] | 0;
        i5 = i4 & 2147483647;
        do if (i3 >>> 0 > i5 >>> 0) {
         i1 = i4 << 1;
         i1 = (i1 | 0) == 0 ? 1 : i1;
         if (i5 >>> 0 >= i1 >>> 0) break;
         if ((i4 | 0) > -1) {
          HEAP32[i11 >> 2] = i1;
          HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 76 | 0, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i47 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 76 | 0, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i47 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 76 | 0) | 0;
          HEAP32[i11 >> 2] = i1;
          HEAP32[i14 >> 2] = i47;
          break;
         }
        } while (0);
        HEAP32[i10 >> 2] = i3;
        i42 = (HEAP32[i14 >> 2] | 0) + (i2 * 76 | 0) | 0;
        i43 = i58;
        i44 = i42 + 76 | 0;
        do {
         HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
         i42 = i42 + 4 | 0;
         i43 = i43 + 4 | 0;
        } while ((i42 | 0) < (i44 | 0));
       }
      } while (0);
      i6 = i6 + 1 | 0;
     } while (i6 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
    }
    if ((HEAP32[i17 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i50 >> 2] | 0, i18);
     HEAP32[i50 >> 2] = 0;
    }
   } while (0);
   i15 = i15 + 1 | 0;
   i1 = HEAP32[i26 >> 2] | 0;
  } while (i15 >>> 0 < (HEAP32[i23 >> 2] | 0) - i1 >> 3 >>> 0);
 }
 i2 = HEAP32[i48 >> 2] | 0;
 i3 = HEAP32[i59 >> 2] | 0;
 i1 = i3;
 L92 : do if ((i2 | 0) == (i3 | 0)) i29 = 108; else {
  i3 = (i2 - i3 | 0) / 20 | 0;
  i2 = 0;
  while (1) {
   if (HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2] | 0) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break L92;
  }
  i40 = i49 + 4 | 0;
  f27 = Math_fround(Math_sqrt(Math_fround(Math_fround((((HEAP32[i40 >> 2] | 0) - (HEAP32[i49 >> 2] | 0) | 0) / 40 | 0) >>> 0) * Math_fround(.015625))));
  i41 = f27 >= Math_fround(0.0);
  f25 = Math_fround(f27 + Math_fround(.99999994));
  i41 = ~~(i41 ? f25 : f27);
  i45 = i57 + 80 | 0;
  i1 = Math_imul(i41, i41) | 0;
  i46 = i57 + 92 | 0;
  i2 = HEAP32[i46 >> 2] | 0;
  HEAP32[i46 >> 2] = i1;
  i47 = i57 + 96 | 0;
  i3 = HEAP32[i47 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i47 >> 2] = i1;
   HEAP32[i45 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i45 >> 2] | 0, i1 << 2, 4, i57 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i44 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i57 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i44 | 0, HEAP32[i45 >> 2] | 0, HEAP32[i46 >> 2] << 2 | 0) | 0;
   HEAP32[i47 >> 2] = i1;
   HEAP32[i45 >> 2] = i44;
   break;
  } while (0);
  if (i1 >>> 0 > i2 >>> 0) _memset((HEAP32[i45 >> 2] | 0) + (i2 << 2) | 0, 0, i1 - i2 << 2 | 0) | 0;
  __ZNK9Transform11GetPositionEv(i58, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i57 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i42 = HEAP32[i58 >> 2] | 0;
  i43 = HEAP32[i58 + 4 >> 2] | 0;
  i44 = HEAP32[i58 + 8 >> 2] | 0;
  HEAPF32[i54 >> 2] = Math_fround(0.0);
  HEAPF32[i54 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i54 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i54 + 12 >> 2] = Math_fround(1.0);
  HEAP32[i54 + 16 >> 2] = i42;
  HEAP32[i54 + 20 >> 2] = i43;
  HEAP32[i54 + 24 >> 2] = i44;
  i44 = __ZN8Collider13GetPxMaterialEv(i57) | 0;
  HEAP32[i55 >> 2] = i44;
  if (!i44) {
   i44 = __Z14GetDynamicsSDKv() | 0;
   mftCall_iiiii(HEAP32[(HEAP32[i44 >> 2] | 0) + 152 >> 2] | 0, i44 | 0, i55 | 0, 1, 0) | 0;
  }
  i1 = HEAP32[i49 >> 2] | 0;
  L110 : do if ((HEAP32[i40 >> 2] | 0) != (i1 | 0)) {
   f27 = Math_fround(i41 | 0);
   i17 = i53 + 4 | 0;
   i18 = i53 + 8 | 0;
   i19 = i57 + 36 | 0;
   i20 = i50 + 4 | 0;
   i21 = i50 + 8 | 0;
   i22 = i51 + 48 | 0;
   i23 = i51 + 52 | 0;
   i26 = i51 + 56 | 0;
   i28 = i58 + 4 | 0;
   i29 = i58 + 8 | 0;
   i30 = i58 + 4 | 0;
   i31 = i58 + 8 | 0;
   i32 = i58 + 12 | 0;
   i33 = i56 + 4 | 0;
   i34 = i56 + 8 | 0;
   i35 = i56 + 12 | 0;
   i36 = i56 + 16 | 0;
   i37 = i56 + 20 | 0;
   i38 = i56 + 24 | 0;
   i39 = i58 + 4 | 0;
   i16 = 0;
   L112 : while (1) {
    i4 = i1 + (i16 * 40 | 0) | 0;
    f12 = Math_fround(HEAPF32[i4 >> 2]);
    i5 = i1 + (i16 * 40 | 0) + 8 | 0;
    f13 = Math_fround(HEAPF32[i5 >> 2]);
    i3 = (Math_imul(~~Math_fround(f27 * f13), i41) | 0) + ~~Math_fround(f27 * f12) | 0;
    i2 = (HEAP32[i46 >> 2] | 0) + -1 | 0;
    i3 = (HEAP32[i45 >> 2] | 0) + (((i3 | 0) < 0 ? 0 : (i3 | 0) > (i2 | 0) ? i2 : i3) << 2) | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i44 = __Z14GetDynamicsSDKv() | 0;
     i44 = mftCall_iii(HEAP32[(HEAP32[i44 >> 2] | 0) + 104 >> 2] | 0, i44 | 0, i54 | 0) | 0;
     HEAP32[i3 >> 2] = i44;
     if (!i44) {
      i29 = 81;
      break;
     }
     i2 = __Z16GetDynamicsScenev() | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0);
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i29 = 80;
      break;
     }
     f12 = Math_fround(HEAPF32[i4 >> 2]);
     f13 = Math_fround(HEAPF32[i5 >> 2]);
    }
    f24 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) * f12);
    f25 = Math_fround(HEAPF32[i17 >> 2]);
    f25 = Math_fround(f25 * Math_fround(HEAPF32[i1 + (i16 * 40 | 0) + 4 >> 2]));
    f12 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f13);
    i3 = HEAP32[i1 + (i16 * 40 | 0) + 32 >> 2] | 0;
    i4 = HEAP32[i59 >> 2] | 0;
    i11 = HEAP32[i55 >> 2] | 0;
    i14 = HEAP32[i19 >> 2] | 0;
    i15 = i4 + (i3 * 20 | 0) + 12 | 0;
    if (HEAP32[i15 >> 2] | 0) {
     i9 = i4 + (i3 * 20 | 0) | 0;
     i10 = i1 + (i16 * 40 | 0) + 12 | 0;
     i7 = i1 + (i16 * 40 | 0) + 16 | 0;
     i8 = i14 + 8 | 0;
     i6 = 0;
     do {
      i1 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i1 + (i6 * 76 | 0) >> 2] | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i5 = HEAP32[i7 >> 2] | 0;
      HEAP32[i50 >> 2] = i4;
      HEAP32[i20 >> 2] = i5;
      HEAP32[i21 >> 2] = i4;
      i42 = i51;
      i43 = i1 + (i6 * 76 | 0) + 8 | 0;
      i44 = i42 + 64 | 0;
      do {
       HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
       i42 = i42 + 4 | 0;
       i43 = i43 + 4 | 0;
      } while ((i42 | 0) < (i44 | 0));
      f62 = Math_fround(HEAPF32[i22 >> 2]);
      f61 = Math_fround(HEAPF32[i23 >> 2]);
      f13 = Math_fround(HEAPF32[i26 >> 2]);
      f63 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f62 = Math_fround(f63 * f62);
      f61 = Math_fround(f25 + Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f61));
      f13 = Math_fround(f12 + Math_fround(f63 * f13));
      HEAPF32[i22 >> 2] = Math_fround(f24 + f62);
      HEAPF32[i23 >> 2] = f61;
      HEAPF32[i26 >> 2] = f13;
      do if ((i3 | 0) == (gb + 110912 | 0)) {
       __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i58, HEAP32[i1 + (i6 * 76 | 0) + 4 >> 2] | 0, i50);
       i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 64016 | 0, 16, gb + 1016445 | 0, 221) | 0;
       i42 = HEAP32[i58 >> 2] | 0;
       i43 = HEAP32[i28 >> 2] | 0;
       i44 = HEAP32[i29 >> 2] | 0;
       HEAP32[i1 >> 2] = 3;
       HEAP32[i1 + 4 >> 2] = i42;
       HEAP32[i1 + 8 >> 2] = i43;
       HEAP32[i1 + 12 >> 2] = i44;
      } else {
       if ((i3 | 0) == (gb + 64328 | 0)) {
        __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f(i58, HEAP32[i1 + (i6 * 76 | 0) + 4 >> 2] | 0, i50);
        i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 64016 | 0, 16, gb + 1016445 | 0, 226) | 0;
        i44 = HEAP32[i58 >> 2] | 0;
        f63 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) * Math_fround(.5));
        HEAP32[i1 >> 2] = 2;
        HEAP32[i1 + 4 >> 2] = i44;
        HEAPF32[i1 + 8 >> 2] = f63;
        break;
       }
       if ((i3 | 0) != (gb + 113668 | 0)) {
        i1 = 0;
        break;
       }
       f63 = Math_fround(__ZNK14SphereCollider15GetScaledRadiusERK8Vector3f(HEAP32[i1 + (i6 * 76 | 0) + 4 >> 2] | 0, i50));
       i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 64016 | 0, 16, gb + 1016445 | 0, 231) | 0;
       HEAP32[i1 >> 2] = 0;
       HEAPF32[i1 + 4 >> 2] = f63;
      } while (0);
      HEAP32[i58 >> 2] = i11;
      i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0;
      HEAP8[i56 >> 0] = 11;
      i3 = mftCall_iiiiii(i3 | 0, i2 | 0, i1 | 0, i58 | 0, 1, i56 | 0) | 0;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
      if (!i3) {
       i29 = 99;
       break L112;
      }
      i44 = HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0;
      __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i51, i58);
      i5 = HEAP32[i22 >> 2] | 0;
      i42 = HEAP32[i23 >> 2] | 0;
      i43 = HEAP32[i26 >> 2] | 0;
      i64 = HEAP32[i30 >> 2] | 0;
      i1 = HEAP32[i31 >> 2] | 0;
      i4 = HEAP32[i32 >> 2] | 0;
      HEAP32[i56 >> 2] = HEAP32[i58 >> 2];
      HEAP32[i33 >> 2] = i64;
      HEAP32[i34 >> 2] = i1;
      HEAP32[i35 >> 2] = i4;
      HEAP32[i36 >> 2] = i5;
      HEAP32[i37 >> 2] = i42;
      HEAP32[i38 >> 2] = i43;
      mftCall_vii(i44 | 0, i3 | 0, i56 | 0);
      i44 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 * 76 | 0) + 72 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 80 >> 2] | 0, i58 | 0, i14 | 0);
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 92 >> 2] | 0, i56 | 0, i14 | 0);
      i43 = HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0;
      HEAP8[i52 >> 0] = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0) | 0;
      mftCall_vii(i43 | 0, i3 | 0, i52 | 0);
      i43 = HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0;
      mftCall_vif(i43 | 0, i3 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i14 >> 2] | 0) + 116 >> 2] | 0, i14 | 0)));
      i43 = HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0;
      mftCall_vif(i43 | 0, i3 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i14 >> 2] | 0) + 124 >> 2] | 0, i14 | 0)));
      HEAP32[i3 + 8 >> 2] = HEAP32[i8 >> 2];
      i44 = i44 & 255;
      HEAP32[i58 >> 2] = HEAP32[i58 >> 2] & -256 | i44;
      mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0, i3 | 0, i58 | 0);
      HEAP32[i56 >> 2] = HEAP32[i56 >> 2] & -256 | i44;
      mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 88 >> 2] | 0, i3 | 0, i56 | 0);
      i6 = i6 + 1 | 0;
     } while (i6 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
    }
    i16 = i16 + 1 | 0;
    i1 = HEAP32[i49 >> 2] | 0;
    if (i16 >>> 0 >= (((HEAP32[i40 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0) break L110;
   }
   if ((i29 | 0) == 80) if (!i57) i1 = 0; else i29 = 81; else if ((i29 | 0) == 99) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1016611 | 0, 0, gb + 1016445 | 0, 336, 1, 0, 0, 0);
    i1 = HEAP32[i45 >> 2] | 0;
    i64 = HEAP32[i46 >> 2] | 0;
    i3 = i1 + (i64 << 2) | 0;
    if (i64 | 0) do {
     i2 = HEAP32[i1 >> 2] | 0;
     if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i3 | 0));
    if ((HEAP32[i47 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i57 + 84 | 0);
     HEAP32[i45 >> 2] = 0;
    }
    HEAP32[i45 >> 2] = 0;
    HEAP32[i46 >> 2] = 0;
    HEAP32[i47 >> 2] = 0;
    break;
   }
   if ((i29 | 0) == 81) i1 = HEAP32[i57 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1016528 | 0, 0, gb + 1016445 | 0, 327, 1, i1, 0, 0);
   i1 = HEAP32[i45 >> 2] | 0;
   i64 = HEAP32[i46 >> 2] | 0;
   i3 = i1 + (i64 << 2) | 0;
   if (i64 | 0) do {
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i3 | 0));
   if ((HEAP32[i47 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i57 + 84 | 0);
    HEAP32[i45 >> 2] = 0;
   }
   HEAP32[i45 >> 2] = 0;
   HEAP32[i46 >> 2] = 0;
   HEAP32[i47 >> 2] = 0;
  } while (0);
  i1 = HEAP32[i59 >> 2] | 0;
  i29 = 108;
 } while (0);
 if ((i29 | 0) == 108) if (!i1) {
  STACKTOP = i60;
  return;
 }
 i2 = HEAP32[i48 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i48 >> 2] = i3;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i3 >> 2] = 0;
    i2 = HEAP32[i48 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i59 >> 2] | 0;
 }
 i64 = HEAP32[i59 + 12 >> 2] | 0;
 HEAP32[i58 >> 2] = 1;
 HEAP32[i58 + 4 >> 2] = i64;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i58);
 STACKTOP = i60;
 return;
}

function __ZN5physx21PxClothRepXSerializer16objectToFileImplEPKNS_7PxClothEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i42, i43, i45, i44, i1) {
 i2 = i2 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 i45 = i45 | 0;
 i44 = i44 | 0;
 i1 = i1 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i41 + 216 | 0;
 i33 = i41 + 208 | 0;
 i29 = i41 + 200 | 0;
 i25 = i41 + 192 | 0;
 i21 = i41 + 184 | 0;
 i19 = i41 + 176 | 0;
 i17 = i41 + 168 | 0;
 i16 = i41 + 160 | 0;
 i15 = i41 + 152 | 0;
 i13 = i41 + 144 | 0;
 i8 = i41 + 136 | 0;
 i7 = i41 + 128 | 0;
 i37 = i41;
 i38 = i41 + 268 | 0;
 i36 = i41 + 240 | 0;
 i40 = i41 + 224 | 0;
 i39 = i41 + 840 | 0;
 i9 = i41 + 862 | 0;
 i18 = i41 + 861 | 0;
 i20 = i41 + 860 | 0;
 i22 = i41 + 859 | 0;
 i26 = i41 + 858 | 0;
 i30 = i41 + 857 | 0;
 i34 = i41 + 856 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 96 >> 2] | 0, i42 | 0) | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 88 >> 2] | 0, i42 | 0) | 0;
 if ((i3 | 0) != 0 & (i5 | 0) != 0) {
  i6 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i6 | 0) != 0 & (i6 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i3 + (i6 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i3 + (i6 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i7 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i7) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i32 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i32 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i5 | 0));
  HEAP8[i7 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i7 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 773288 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 i3 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 84 >> 2] | 0, i42 | 0) | 0;
 i1 = i3;
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 8 >> 2] | 0, i43 | 0, i3 | 0) | 0)) {
   i32 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i8 >> 2] = gb + 675258;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i32, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i8);
  }
  i31 = mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 52 >> 2] | 0, i43 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i32 = (i31 | 0) == 0 & (i2 | 0) == 0;
  i1 = i32 ? i1 : i31;
  i2 = i32 ? 0 : i2;
 }
 i31 = HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i37 >> 2] = gb + 764826;
 HEAP32[i37 + 4 >> 2] = i3;
 i27 = i37 + 8 | 0;
 HEAP32[i27 >> 2] = i1;
 HEAP32[i27 + 4 >> 2] = i2;
 mftCall_viii(i31 | 0, i45 | 0, gb + 675258 | 0, i37 | 0);
 i31 = i44 + 8 | 0;
 HEAP32[i39 >> 2] = HEAP32[i31 >> 2];
 i27 = i39 + 4 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i39 + 8 | 0;
 HEAP32[i28 >> 2] = 0;
 i32 = i39 + 12 | 0;
 HEAP32[i32 >> 2] = 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 288 >> 2] | 0, i42 | 0) | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 300 >> 2] | 0, i42 | 0) | 0;
 i6 = i14 << 1;
 i8 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 316 >> 2] | 0, i42 | 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 328 >> 2] | 0, i42 | 0) | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 344 >> 2] | 0, i42 | 0) | 0;
 HEAP8[i9 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, (i10 << 2) + (i14 << 3) + (i12 * 36 | 0) + (i8 + i3 << 4) | 0, i9);
 i14 = HEAP32[i27 >> 2] | 0;
 i5 = i14 + (i3 << 4) | 0;
 i7 = i5 + (i6 << 2) | 0;
 i9 = i7 + (i8 << 4) | 0;
 i11 = i9 + (i10 << 2) | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i42 >> 2] | 0) + 348 >> 2] | 0, i42 | 0, i14 | 0, i5 | 0, i7 | 0, i9 | 0, i11 | 0);
 if ((i3 | 0) != 0 & (i14 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i14 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i14 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i13 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i13) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP8[i13 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i13 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675265 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 if ((i6 | 0) != 0 & (i5 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAP32[i15 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 1084495 | 0, i15) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i44 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  HEAP8[i15 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i15 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675282 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 if ((i8 | 0) != 0 & (i7 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i7 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i7 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i16 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i16) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
  HEAP8[i16 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i16 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675303 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 if ((i10 | 0) != 0 & (i9 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i9 + (i2 << 2) >> 2] | 0;
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAP32[i17 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 1084495 | 0, i17) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i44 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  HEAP8[i17 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i17 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675319 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 if ((i12 | 0) != 0 & (i11 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i24 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i11 + (i2 * 36 | 0) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i24 >> 2] >> 2] | 0, i24 | 0, gb + 1086395 | 0, 1) | 0;
   i24 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i24, i11 + (i2 * 36 | 0) + 12 | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i24 >> 2] >> 2] | 0, i24 | 0, gb + 1086395 | 0, 1) | 0;
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i24, i11 + (i2 * 36 | 0) + 24 | 0) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  HEAP8[i37 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i37 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675340 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i5 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 220 >> 2] | 0, i42 | 0) | 0;
 i1 = i5 << 4;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i18 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i18);
  i6 = HEAP32[i27 >> 2] | 0;
  i3 = i6;
 } else {
  i3 = i14;
  i6 = i14;
 }
 mftCall_iii(HEAP32[(HEAP32[i42 >> 2] | 0) + 216 >> 2] | 0, i42 | 0, i3 | 0) | 0;
 if ((i5 | 0) != 0 & (i3 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i3 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i3 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i19 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i19) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  HEAP8[i19 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i19 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675359 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 412 >> 2] | 0, i42 | 0) | 0;
 i1 = i3 << 2;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i20 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i20);
 }
 mftCall_iii(HEAP32[(HEAP32[i42 >> 2] | 0) + 408 >> 2] | 0, i42 | 0, i6 | 0) | 0;
 if ((i6 | 0) != 0 & (i3 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAP32[i21 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 1084495 | 0, i21) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i44 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP8[i21 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i21 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675381 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i3 = HEAP32[i27 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 232 >> 2] | 0, i42 | 0) | 0;
 i1 = i5 << 4;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i22 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i22);
 }
 mftCall_iii(HEAP32[(HEAP32[i42 >> 2] | 0) + 228 >> 2] | 0, i42 | 0, i3 | 0) | 0;
 if ((i3 | 0) != 0 & (i5 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i3 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i3 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i25 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i25) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i24 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i24 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  HEAP8[i25 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i25 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675402 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 252 >> 2] | 0, i42 | 0) | 0;
 i1 = i3 << 4;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i26 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i26);
 }
 i5 = HEAP32[i27 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i42 >> 2] | 0) + 248 >> 2] | 0, i42 | 0, i5 | 0) | 0;
 if ((i3 | 0) != 0 & (i5 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i5 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i5 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i29 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i29) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i26 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i26 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP8[i29 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i29 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675420 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 424 >> 2] | 0, i42 | 0) | 0;
 i1 = i3 << 4;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i30 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i30);
  i7 = HEAP32[i27 >> 2] | 0;
 } else i7 = i5;
 mftCall_iii(HEAP32[(HEAP32[i42 >> 2] | 0) + 420 >> 2] | 0, i42 | 0, i7 | 0) | 0;
 if ((i3 | 0) != 0 & (i7 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 3 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i7 + (i2 << 4) | 0) | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i7 + (i2 << 4) + 12 >> 2]);
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAPF64[i33 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 832323 | 0, i33) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i30 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    mftCall_iiii(i30 | 0, i1 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP8[i33 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i33 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675442 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 i33 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 356 >> 2] | 0, i42 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 364 >> 2] | 0, i42 | 0) | 0;
 i1 = i5 * 12 | 0;
 i8 = i33 << 2;
 i33 = i33 << 4;
 i1 = i1 >>> 0 < i33 >>> 0 ? i33 : i1;
 if ((HEAP32[i28 >> 2] | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i34 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i39, i1, i34);
  i7 = HEAP32[i27 >> 2] | 0;
  i3 = i7;
  i6 = i7;
 } else {
  i3 = i7;
  i6 = i7;
 }
 mftCall_vii(HEAP32[(HEAP32[i42 >> 2] | 0) + 368 >> 2] | 0, i42 | 0, i3 | 0);
 if ((i5 | 0) != 0 & (i3 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i44, i3 + (i2 * 12 | 0) | 0) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  HEAP8[i37 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i37 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675456 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i42 >> 2] | 0) + 360 >> 2] | 0, i42 | 0, i6 | 0);
 if ((i8 | 0) != 0 & (i6 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i44 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i44 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   i23 = i37;
   i24 = i23 + 128 | 0;
   do {
    HEAP8[i23 >> 0] = 0;
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) < (i24 | 0));
   HEAP32[i35 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i37, 128, gb + 1084495 | 0, i35) | 0;
   if (HEAP8[i37 >> 0] | 0) {
    i34 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    mftCall_iiii(i34 | 0, i44 | 0, i37 | 0, _strlen(i37) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
  HEAP8[i35 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i44 >> 2] >> 2] | 0, i44 | 0, i35 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0, i45 | 0, gb + 675479 | 0, HEAP32[i44 + 20 >> 2] | 0);
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
 }
 HEAP32[i40 >> 2] = HEAP32[i31 >> 2];
 i1 = i40 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 i35 = i40 + 12 | 0;
 HEAP32[i35 >> 2] = 0;
 i33 = i40;
 i34 = i45;
 i45 = i43;
 __ZN5physx20PxClothGeneratedInfoC2Ev(i38);
 HEAP32[i37 >> 2] = i33;
 HEAP32[i37 + 4 >> 2] = i34;
 HEAP32[i37 + 8 >> 2] = i42;
 HEAP32[i37 + 12 >> 2] = i44;
 HEAP32[i37 + 16 >> 2] = i45;
 HEAP32[i37 + 20 >> 2] = 0;
 HEAP32[i37 + 24 >> 2] = 0;
 __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j(i38, i37, 0) | 0;
 HEAP32[i36 >> 2] = i33;
 HEAP32[i36 + 4 >> 2] = i34;
 HEAP32[i36 + 8 >> 2] = i42;
 HEAP32[i36 + 12 >> 2] = i44;
 HEAP32[i36 + 16 >> 2] = i45;
 HEAP32[i36 + 20 >> 2] = 0;
 HEAP32[i36 + 24 >> 2] = 0;
 __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j(i38, i36, 0) | 0;
 i45 = HEAP32[i35 >> 2] | 0;
 do if ((i45 | 0) > -1 & (i45 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) break;
  i45 = HEAP32[HEAP32[i40 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i1 | 0);
 } while (0);
 i45 = HEAP32[i32 >> 2] | 0;
 if ((i7 | 0) == 0 | ((i45 | 0) < 0 | (i45 & 2147483647 | 0) == 0)) {
  STACKTOP = i41;
  return;
 }
 i45 = HEAP32[HEAP32[i39 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i7 | 0);
 STACKTOP = i41;
 return;
}

function __ZN7mecanim12statemachine20EvaluateStateMachineERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_21StateMachineWorkspaceE(i38, i42, i43, i55, i37) {
 i38 = i38 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 i55 = i55 | 0;
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i56 + 40 | 0;
 i34 = i56 + 24 | 0;
 i41 = i56 + 16 | 0;
 i35 = i56 + 8 | 0;
 i45 = i56;
 i36 = i43 + 17 | 0;
 HEAP8[i36 >> 0] = 0;
 HEAP8[i43 + 18 >> 0] = 0;
 if (!(HEAP32[i38 >> 2] | 0)) {
  i1 = HEAP32[i38 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i56;
   return;
  }
  i55 = i55 + 4 | 0;
  _memset((HEAP32[i55 >> 2] | 0) + i55 | 0, 0, i1 << 2 | 0) | 0;
  STACKTOP = i56;
  return;
 }
 i53 = i43 + 4 | 0;
 HEAP32[i53 >> 2] = 128;
 i44 = i43 + 8 | 0;
 HEAP32[i44 >> 2] = 128;
 i54 = i43 + 12 | 0;
 i1 = HEAP32[i55 >> 2] | 0;
 L8 : do if (i1 | 0) {
  i5 = 0;
  do {
   i2 = HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0) + 8 >> 2] | 0;
   if (!(HEAP32[i2 + 28 >> 2] | 0)) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 4 >> 2] | 0;
   if (i2) {
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    if (i3) {
     i2 = i2 + 16 | 0;
     i1 = 0;
     do {
      i52 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 124 >> 2] | 0, i52 | 0, 128);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
     i1 = HEAP32[i55 >> 2] | 0;
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0) + 8 >> 2] | 0;
    if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= 1) break L8;
    i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 12 >> 2] | 0;
    if (i2) {
     i2 = HEAP32[i2 + 8 >> 2] | 0;
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     if (i3) {
      i2 = i2 + 16 | 0;
      i1 = 0;
      do {
       i52 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 124 >> 2] | 0, i52 | 0, 128);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
      i1 = HEAP32[i55 >> 2] | 0;
     }
    }
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
  }
 } while (0);
 f7 = Math_fround(HEAPF32[i42 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i42 + 12 >> 2]));
 i52 = i55 + 8 | 0;
 i30 = i38 + 4 | 0;
 i31 = i30;
 i6 = (HEAP32[i30 >> 2] | 0) + i31 + (HEAP32[i52 >> 2] << 2) | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
 i10 = HEAP32[i37 >> 2] | 0;
 i51 = i55 + 85 | 0;
 if (HEAP8[i51 >> 0] | 0) __ZN7mecanim12statemachine13EndTransitionERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS_6memory16MecanimAllocatorE(0, i43, i55, 0);
 i49 = i55 + 80 | 0;
 if (!(HEAP8[i49 >> 0] | 0)) {
  i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[HEAP32[i54 >> 2] >> 2] >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
  if (!i3) i47 = 28; else {
   i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
   if (!i5) i47 = 28; else {
    i1 = 0;
    i2 = 0;
    do {
     i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i5 | 0));
    if (!i1) i47 = 28; else i47 = 27;
   }
  }
 } else i47 = 27;
 if ((i47 | 0) == 27) if (HEAP8[i55 + 86 >> 0] | 0) i47 = 28;
 if ((i47 | 0) == 28) __ZN7mecanim12statemachine10StartStateERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEb(i38, i42, i43, i55, 1);
 HEAP32[i11 >> 2] = i53;
 i1 = HEAP32[i54 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 >> 2];
 i46 = i38 + 28 | 0;
 L45 : do if (!(HEAP32[i46 >> 2] | 0)) i2 = 0; else {
  i2 = 0;
  while (1) {
   __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, 0, Math_fround(1.0));
   __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0, 1, Math_fround(0.0));
   i1 = i2 + 1 | 0;
   i2 = HEAP32[i46 >> 2] | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L45;
   i2 = i1;
   i1 = HEAP32[i54 >> 2] | 0;
  }
 } while (0);
 i50 = i55 + 32 | 0;
 i28 = HEAP32[i50 >> 2] | 0;
 i1 = HEAP16[i49 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i32 = i37 + 4 | 0;
  __ZN7mecanim12statemachine13EvaluateStateERKNS_18ValueArrayConstantERKNS0_13StateConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_11StateOutputERNS0_14StateWorkspaceEbb(HEAP32[i32 >> 2] | 0, i6, i42, i43, i55, i11, i10, 1, 0);
  i12 = i55 + 81 | 0;
  i48 = i12;
  i2 = HEAP32[i46 >> 2] | 0;
  i12 = HEAP8[i12 >> 0] | 0;
 } else {
  i48 = i55 + 81 | 0;
  i32 = i37 + 4 | 0;
  i12 = (i1 & 65535) >>> 8 & 255;
 }
 i26 = i34 + 4 | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 i27 = i34 + 8 | 0;
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 HEAP32[i34 >> 2] = HEAP32[i42 + 16 >> 2];
 HEAP8[i41 >> 0] = 0;
 i29 = i41 + 4 | 0;
 HEAPF32[i29 >> 2] = Math_fround(0.0);
 HEAP8[i35 + 4 >> 0] = 0;
 HEAP32[i35 >> 2] = HEAP32[i32 >> 2];
 if (i2 | 0) {
  i10 = i55 + 4 | 0;
  i11 = i10;
  i6 = 0;
  do {
   if (!(HEAP8[i49 >> 0] | 0)) {
    i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
    if (!i3) i1 = 0; else {
     i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
     if (!i5) i1 = 0; else {
      i1 = 0;
      i2 = 0;
      do {
       i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
      i2 = HEAP32[i46 >> 2] | 0;
     }
    }
   } else i1 = 1;
   f9 = Math_fround((i1 | 0) != 0 & 1);
   HEAPF32[(HEAP32[i10 >> 2] | 0) + i11 + (i6 << 2) >> 2] = f9;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i2 >>> 0);
 }
 i3 = i55 + 83 | 0;
 L67 : do if (!(HEAP8[i3 >> 0] | 0)) i5 = 0; else {
  i5 = HEAP32[i42 + 24 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i10 = HEAP32[i38 >> 2] | 0;
  if (!i10) i5 = 0; else {
   i11 = (HEAP32[i30 >> 2] | 0) + i31 | 0;
   i1 = 0;
   while (1) {
    i40 = i11 + (i1 << 2) | 0;
    i2 = HEAP32[i40 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? 0 : i40 + i2 | 0;
    if ((HEAP32[i2 + 32 >> 2] | 0) == (i6 | 0)) break;
    if ((HEAP32[i2 + 28 >> 2] | 0) == (i6 | 0)) break;
    if ((HEAP32[i2 + 24 >> 2] | 0) == (i6 | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i10 >>> 0) {
     i5 = 0;
     break L67;
    }
   }
   if ((i1 | 0) == -1) i5 = 0; else {
    HEAP8[i3 >> 0] = 0;
    HEAP8[i48 >> 0] = 1;
    HEAP8[i55 + 82 >> 0] = 1;
    HEAP32[i55 + 12 >> 2] = i1;
    HEAP32[i55 + 20 >> 2] = -1;
    HEAP32[i55 + 24 >> 2] = -1;
    HEAP32[i55 + 72 >> 2] = HEAP32[i5 + 8 >> 2];
    i39 = HEAP32[i5 + 4 >> 2] | 0;
    HEAP32[i55 + 76 >> 2] = i39;
    i40 = HEAP32[i5 + 12 >> 2] | 0;
    HEAP32[i55 + 68 >> 2] = i40;
    HEAP32[i55 + 64 >> 2] = HEAP32[i50 >> 2];
    HEAP8[i55 + 84 >> 0] = HEAP8[i5 + 20 >> 0] | 0;
    f9 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    HEAPF32[i55 + 36 >> 2] = Math_fround(f9 + (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAP8[i36 >> 0] = i12;
    HEAP32[i44 >> 2] = 25;
    i5 = 1;
   }
  }
 } while (0);
 i24 = i42 + 32 | 0;
 L78 : do if (HEAP32[i24 >> 2] | 0) {
  i40 = i55 + 20 | 0;
  i1 = HEAP32[i40 >> 2] | 0;
  i39 = i55 + 24 | 0;
  L80 : do if ((i1 | 0) == -1) {
   i25 = 0;
   i21 = 0;
   i22 = 2;
  } else {
   i2 = HEAP32[i39 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i2 = i38 + 12 | 0;
    i1 = (HEAP32[i2 >> 2] | 0) + i2 + (i1 << 2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i25 = 0;
     i21 = 0;
     i22 = 2;
     break;
    } else i2 = i1 + i2 | 0;
   } else {
    i2 = (HEAP32[i30 >> 2] | 0) + i31 + (i2 << 2) | 0;
    i2 = i2 + (HEAP32[i2 >> 2] | 0) + 4 | 0;
    i1 = i2 + (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i25 = 0;
     i21 = 0;
     i22 = 2;
     break;
    } else i2 = i1 + i2 | 0;
   }
   i1 = i2;
   if (!i2) {
    i25 = 0;
    i21 = 0;
    i22 = 2;
   } else switch (HEAP32[i1 + 40 >> 2] | 0) {
   case 3:
   case 4:
    {
     i25 = i1;
     i21 = 1;
     i22 = 3;
     break L80;
    }
   case 2:
   case 1:
    {
     i25 = i1;
     i21 = 1;
     i22 = 2;
     break L80;
    }
   default:
    {
     i25 = i1;
     i21 = 1;
     i22 = 0;
     break L80;
    }
   }
  } while (0);
  i1 = HEAP32[i39 >> 2] | 0;
  L91 : do if ((i1 | 0) == -1) {
   i23 = i21 ^ 1;
   i2 = 0;
   i20 = 0;
  } else {
   i3 = (i1 | 0) == (HEAP32[i52 >> 2] | 0);
   i2 = i3 ? 1 : 2;
   i1 = i21 ^ 1;
   if (i21) switch (HEAP32[i25 + 40 >> 2] | 0) {
   case 1:
    {
     i23 = i1;
     i20 = i3 ? 1 : -1;
     break L91;
    }
   case 2:
    {
     i23 = i1;
     i20 = i3 ? -1 : 1;
     break L91;
    }
   case 3:
    {
     i23 = i1;
     i20 = i3 ? 1 : 2;
     break L91;
    }
   case 4:
    {
     i23 = i1;
     i20 = i3 ? 2 : 1;
     break L91;
    }
   default:
    {
     i23 = i1;
     i20 = -1;
     break L91;
    }
   } else {
    i23 = i1;
    i20 = 0;
   }
  } while (0);
  i33 = i55 + 82 | 0;
  if ((i22 | 0) != 0 & ((i5 | (HEAP8[i33 >> 0] | 0) != 0) ^ 1)) {
   i17 = i25 + 40 | 0;
   i18 = i38 + 12 | 0;
   i19 = i38 + 8 | 0;
   i14 = i12 << 24 >> 24 != 0;
   i16 = i14 & i21;
   i15 = i25 + 44 | 0;
   i10 = (i2 | 0) != 2;
   i11 = i55 + 36 | 0;
   i12 = i55 + 44 | 0;
   i13 = i55 + 12 | 0;
   i6 = 0;
   do {
    L105 : do if (i21) {
     i1 = HEAP32[i17 >> 2] | 0;
     if (!i6) {
      i5 = i18;
      i1 = i19;
      i3 = 0;
     } else switch (i1 | 0) {
     case 2:
     case 1:
     case 0:
      {
       i47 = 79;
       break L105;
      }
     case 3:
      {
       i1 = (i6 | 0) == 1 ? 1 : 2;
       i47 = 79;
       break L105;
      }
     case 4:
      {
       i1 = (i6 | 0) == 1 ? 2 : 1;
       i47 = 79;
       break L105;
      }
     default:
      {
       i5 = i18;
       i1 = i19;
       i3 = 0;
       break L105;
      }
     }
    } else {
     i1 = (i6 | 0) != 0 & 1;
     i47 = 79;
    } while (0);
    L112 : do if ((i47 | 0) == 79) {
     i47 = 0;
     switch (i1 | 0) {
     case 1:
      {
       i1 = (HEAP32[i30 >> 2] | 0) + i31 + (HEAP32[i52 >> 2] << 2) | 0;
       i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
       i5 = i1 + 4 | 0;
       i3 = 1;
       break L112;
      }
     case 2:
      {
       i1 = (HEAP32[i30 >> 2] | 0) + i31 + (HEAP32[i13 >> 2] << 2) | 0;
       i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
       i5 = i1 + 4 | 0;
       i3 = 2;
       break L112;
      }
     default:
      {
       i5 = i18;
       i1 = i19;
       i3 = 0;
       break L112;
      }
     }
    } while (0);
    i1 = HEAP32[i1 >> 2] | 0;
    do if (i16) if (!(HEAP8[i15 >> 0] | 0)) i2 = i1; else if (i6 >>> 0 > i20 >>> 0) i2 = 0; else {
     if (!(i10 & (i20 | 0) == (i6 | 0))) {
      i2 = i1;
      break;
     }
     i2 = HEAP32[i40 >> 2] | 0;
    } else i2 = i1; while (0);
    if ((i3 | 0) == 2) {
     i1 = HEAP32[i11 >> 2] | 0;
     HEAP32[i26 >> 2] = i1;
     f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     HEAPF32[i27 >> 2] = Math_fround(f9 - Math_fround(f7 / Math_fround(HEAPF32[i12 >> 2])));
     i1 = HEAP32[i13 >> 2] | 0;
    } else {
     HEAP32[i26 >> 2] = HEAP32[i50 >> 2];
     HEAP32[i27 >> 2] = i28;
     if ((i3 | 0) == 1) i1 = HEAP32[i52 >> 2] | 0; else i1 = -1;
    }
    i5 = __ZN7mecanim12statemachine19EvaluateTransitionsERK9OffsetPtrIS1_INS0_18TransitionConstantEEEjRNS0_15TransitionInputERNS0_16TransitionOutputERNS0_16TransitionMemoryEPKNS0_20StateMachineConstantEPKNS0_17StateMachineInputEPNS0_18StateMachineOutputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceEi(i5, i2, i34, i41, i35, i38, i42, i43, i55, i37, i1) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    if (i1 | 0) if (!(__ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i1) | 0)) break L78;
    i1 = i14 & i5 & 1;
    HEAP8[i36 >> 0] = i1;
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i22 >>> 0 & ((i5 | (HEAP8[i33 >> 0] | 0) != 0) ^ 1));
  } else i1 = HEAP8[i36 >> 0] | 0;
  if (i1 << 24 >> 24) {
   if (!(HEAP8[i49 >> 0] | 0)) {
    if (HEAP32[i55 >> 2] | 0) {
     i1 = 0;
     do {
      i34 = HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0;
      i35 = HEAP32[(HEAP32[i34 + 8 >> 2] | 0) + 16 >> 2] | 0;
      i36 = HEAP32[i35 + 4 >> 2] | 0;
      i35 = HEAP32[i35 + 20 >> 2] | 0;
      __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(i34, 0);
      __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0, 2);
      __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i35, HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0, -1, 0) | 0;
      __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i36, HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0, -1, 2) | 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i55 >> 2] | 0) >>> 0);
    }
    HEAP8[i49 >> 0] = 1;
   }
   i2 = HEAP32[i55 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[HEAP32[i54 >> 2] >> 2] | 0;
    i1 = 0;
    do {
     HEAP8[(HEAP32[(HEAP32[(HEAP32[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0) + 80 >> 0] = 1;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
  }
  if (HEAP8[i48 >> 0] | 0) {
   i13 = i55 + 12 | 0;
   i3 = (HEAP32[i30 >> 2] | 0) + i31 + (HEAP32[i13 >> 2] << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
   i2 = HEAP32[i37 >> 2] | 0;
   if (i5) i47 = 105; else if (HEAP8[i55 + 86 >> 0] | 0) i47 = 105;
   if ((i47 | 0) == 105) __ZN7mecanim12statemachine10StartStateERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEb(i38, i42, i43, i55, 0);
   i1 = (HEAP8[i55 + 84 >> 0] | 0) != 0;
   if (i1 | i23) if (i1) {
    f4 = Math_fround(1.0);
    i1 = 1;
   } else i47 = 109; else if (!(HEAP8[i25 + 37 >> 0] | 0)) i47 = 109; else {
    f4 = Math_fround(1.0);
    i1 = 1;
   }
   if ((i47 | 0) == 109) {
    f4 = Math_fround(HEAPF32[i55 + 40 >> 2]);
    i1 = 0;
   }
   if (!(HEAP8[i41 >> 0] | 0)) {
    i41 = f4 != Math_fround(0.0);
    f9 = Math_fround(f7 / (i41 ? f4 : Math_fround(1.0)));
   } else f9 = Math_fround(0.0);
   f8 = Math_fround(HEAPF32[i29 >> 2]);
   do if (i1) {
    f4 = Math_fround(HEAPF32[i55 + 40 >> 2]);
    if (!(f4 != Math_fround(inf))) {
     f4 = Math_fround(1.0);
     break;
    }
   } else f4 = Math_fround(1.0); while (0);
   f7 = Math_fround(HEAPF32[i55 + 72 >> 2]);
   if (f7 == Math_fround(0.0)) f4 = Math_fround(1.0); else f4 = Math_fround(Math_fround(f9 + Math_fround(f8 * f4)) / f7);
   i12 = i55 + 68 | 0;
   f8 = Math_fround(f4 + Math_fround(HEAPF32[i12 >> 2]));
   HEAPF32[i12 >> 2] = f8;
   f8 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f8))));
   HEAP32[i45 >> 2] = i44;
   HEAP32[i45 + 4 >> 2] = HEAP32[HEAP32[i54 >> 2] >> 2];
   __ZN7mecanim12statemachine13EvaluateStateERKNS_18ValueArrayConstantERKNS0_13StateConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_11StateOutputERNS0_14StateWorkspaceEbb(HEAP32[i32 >> 2] | 0, i3, i42, i43, i55, i45, i2, 0, i5 & (HEAP8[i33 >> 0] | 0) != 0);
   HEAP8[i43 >> 0] = HEAP8[i43 >> 0] | HEAP8[i3 + 60 >> 0];
   L169 : do if (i5) {
    i1 = HEAP32[i55 >> 2] | 0;
    if (!i1) break; else i5 = 0;
    do {
     i2 = HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0) + 8 >> 2] | 0;
     if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= 1) break L169;
     i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 12 >> 2] | 0;
     do if (i2) {
      i2 = HEAP32[i2 + 8 >> 2] | 0;
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      if (!i3) break;
      i2 = i2 + 16 | 0;
      i1 = 0;
      do {
       i45 = HEAP32[i2 >> 2] | 0;
       i44 = HEAP32[i45 + (i1 << 3) + 4 >> 2] | 0;
       i45 = Math_fround(HEAPF32[i45 + (i1 << 3) >> 2]) > Math_fround(0.0);
       mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 124 >> 2] | 0, i44 | 0, (i45 ? 25 : 128) | 0);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
      i1 = HEAP32[i55 >> 2] | 0;
     } while (0);
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < i1 >>> 0);
   } while (0);
   if (HEAP32[i46 >> 2] | 0) {
    i10 = i55 + 4 | 0;
    i11 = i10;
    f7 = Math_fround(Math_fround(1.0) - f8);
    i6 = 0;
    do {
     L186 : do if (!(HEAP8[i49 >> 0] | 0)) {
      i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0;
      i3 = HEAP32[i1 + 4 >> 2] | 0;
      do if (i3) {
       i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
       if (!i5) break; else {
        i1 = 0;
        i2 = 0;
       }
       do {
        i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
       if (i1 | 0) {
        i47 = 140;
        break L186;
       }
       i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0;
      } while (0);
      i3 = HEAP32[i1 + 12 >> 2] | 0;
      if (!i3) {
       i47 = 140;
       break;
      }
      i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
      if (!i5) {
       i47 = 140;
       break;
      } else {
       i1 = 0;
       i2 = 0;
      }
      do {
       i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
      if (!i1) {
       i47 = 140;
       break;
      }
      HEAPF32[(HEAP32[i10 >> 2] | 0) + i11 + (i6 << 2) >> 2] = f8;
      f4 = Math_fround(1.0);
     } else i47 = 140; while (0);
     L200 : do if ((i47 | 0) == 140) {
      i47 = 0;
      i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + 12 >> 2] | 0;
      do if (i3 | 0) {
       i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
       if (!i5) break; else {
        i1 = 0;
        i2 = 0;
       }
       do {
        i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
       if (i1 | 0) {
        f4 = f8;
        break L200;
       }
      } while (0);
      if (!(HEAP8[i49 >> 0] | 0)) {
       i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
       if (!i3) {
        f4 = f8;
        break;
       }
       i5 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
       if (!i5) {
        f4 = f8;
        break;
       } else {
        i1 = 0;
        i2 = 0;
       }
       do {
        i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
       if (!i1) {
        f4 = f8;
        break;
       }
      }
      HEAPF32[(HEAP32[i10 >> 2] | 0) + i11 + (i6 << 2) >> 2] = f7;
      f4 = Math_fround(0.0);
     } while (0);
     __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, Math_fround(Math_fround(1.0) - f4));
     __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 1, f4);
     i6 = i6 + 1 | 0;
    } while (i6 >>> 0 < (HEAP32[i46 >> 2] | 0) >>> 0);
   }
   if (Math_fround(HEAPF32[i12 >> 2]) >= Math_fround(1.0)) {
    HEAP32[i55 + 16 >> 2] = HEAP32[i52 >> 2];
    i6 = i55 + 40 | 0;
    HEAP32[i55 + 48 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i53 >> 2] = 26;
    i1 = HEAP32[i55 >> 2] | 0;
    L219 : do if (i1 | 0) {
     i5 = 0;
     do {
      i2 = HEAP32[(HEAP32[(HEAP32[HEAP32[i54 >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0) + 8 >> 2] | 0;
      if (!(HEAP32[i2 + 28 >> 2] | 0)) break L219;
      i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 4 >> 2] | 0;
      do if (i2) {
       i2 = HEAP32[i2 + 8 >> 2] | 0;
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       if (!i3) break;
       i2 = i2 + 16 | 0;
       i1 = 0;
       do {
        i53 = HEAP32[i2 >> 2] | 0;
        i49 = HEAP32[i53 + (i1 << 3) + 4 >> 2] | 0;
        i53 = Math_fround(HEAPF32[i53 + (i1 << 3) >> 2]) > Math_fround(0.0);
        mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 124 >> 2] | 0, i49 | 0, (i53 ? 26 : 128) | 0);
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i3 | 0));
       i1 = HEAP32[i55 >> 2] | 0;
      } while (0);
      i5 = i5 + 1 | 0;
     } while (i5 >>> 0 < i1 >>> 0);
    } while (0);
    HEAP8[i48 >> 0] = 0;
    HEAPF32[i12 >> 2] = Math_fround(0.0);
    HEAP32[i39 >> 2] = -1;
    HEAP32[i40 >> 2] = -1;
    HEAPF32[i55 + 76 >> 2] = Math_fround(0.0);
    HEAP8[i33 >> 0] = 0;
    HEAP32[i52 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i50 >> 2] = HEAP32[i55 + 36 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i55 + 44 >> 2];
    HEAP32[i55 + 52 >> 2] = HEAP32[i55 + 56 >> 2];
    HEAP8[i51 >> 0] = 1;
   }
  }
 } while (0);
 STACKTOP = i56;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i3, i9, i1, i2) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i12 = i13;
 i11 = i3 + (i1 >> 1 << 5) | 0;
 if ((i1 | 0) < 65) {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i12;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  }
  if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i9, i11) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  }
  if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  STACKTOP = i13;
  return;
 }
 i4 = i1 >> 3;
 i5 = i4 << 1;
 i8 = i3 + (i4 << 5) | 0;
 i1 = i3 + (i5 << 5) | 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i1, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i3 = 0 - i4 | 0;
 i2 = i11 + (i3 << 5) | 0;
 i1 = i11 + (i4 << 5) | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i7;
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i2 = i9 + (0 - i5 << 5) | 0;
 i1 = i9 + (i3 << 5) | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i9, i1) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 };
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i3, i9, i1, i2) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i12 = i13;
 i11 = i3 + (i1 >> 1 << 5) | 0;
 if ((i1 | 0) < 65) {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i12;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  }
  if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i9, i11) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  }
  if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  STACKTOP = i13;
  return;
 }
 i4 = i1 >> 3;
 i5 = i4 << 1;
 i8 = i3 + (i4 << 5) | 0;
 i1 = i3 + (i5 << 5) | 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i1, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i3 = 0 - i4 | 0;
 i2 = i11 + (i3 << 5) | 0;
 i1 = i11 + (i4 << 5) | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i7;
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i2 = i9 + (0 - i5 << 5) | 0;
 i1 = i9 + (i3 << 5) | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i9, i1) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 };
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN5Unity17ConfigurableJoint8TransferI14SafeBinaryReadEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 32 | 0;
 i5 = i13 + 16 | 0;
 i6 = i13;
 __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_(i11, i12);
 __ZN14SafeBinaryRead10SetVersionEi(i12, 2);
 i2 = i11 + 348 | 0;
 i7 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734938 | 0, i7, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 96 | 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734954 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734964 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734974 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734984 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735001 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735018 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i12, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735035 | 0, gb + 734714 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  HEAP32[i11 + 120 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i11 + 124 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAPF32[i11 + 136 >> 2] = Math_fround(0.0);
  HEAP32[i11 + 128 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 132 >> 2] = HEAP32[i5 + 4 >> 2];
 } else {
  i2 = i11 + 120 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735049 | 0, gb + 734772 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = i11 + 128 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735035 | 0, gb + 734793 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i12, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735069 | 0, gb + 734714 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735088 | 0, gb + 734714 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i6, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i4 = i5 + 8 | 0;
  i3 = i6 + 8 | 0;
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = f14 < Math_fround(HEAPF32[i3 >> 2]);
  HEAP32[i11 + 140 >> 2] = HEAP32[(i2 ? i3 : i4) >> 2];
  i4 = i5 + 12 | 0;
  i3 = i6 + 12 | 0;
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = f14 < Math_fround(HEAPF32[i3 >> 2]);
  HEAP32[i11 + 144 >> 2] = HEAP32[(i2 ? i3 : i4) >> 2];
  HEAPF32[i11 + 156 >> 2] = Math_fround(0.0);
  HEAP32[i11 + 148 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 152 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAPF32[i11 + 168 >> 2] = Math_fround(0.0);
  HEAP32[i11 + 160 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 164 >> 2] = HEAP32[i6 + 4 >> 2];
 } else {
  i2 = i11 + 140 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735108 | 0, gb + 734772 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = i11 + 148 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735069 | 0, gb + 734793 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = i11 + 160 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735088 | 0, gb + 734793 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i12, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735130 | 0, gb + 734714 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735146 | 0, gb + 734714 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i6, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i4 = i5 + 8 | 0;
  i3 = i6 + 8 | 0;
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = f14 < Math_fround(HEAPF32[i3 >> 2]);
  HEAP32[i11 + 172 >> 2] = HEAP32[(i2 ? i3 : i4) >> 2];
  i4 = i5 + 12 | 0;
  i3 = i6 + 12 | 0;
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = f14 < Math_fround(HEAPF32[i3 >> 2]);
  HEAP32[i11 + 176 >> 2] = HEAP32[(i2 ? i3 : i4) >> 2];
  HEAPF32[i11 + 188 >> 2] = Math_fround(0.0);
  HEAP32[i11 + 180 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 184 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAPF32[i11 + 200 >> 2] = Math_fround(0.0);
  HEAP32[i11 + 192 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 196 >> 2] = HEAP32[i6 + 4 >> 2];
 } else {
  i2 = i11 + 172 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735162 | 0, gb + 734772 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = i11 + 180 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735130 | 0, gb + 734793 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = i11 + 192 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735146 | 0, gb + 734793 | 0, i10, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 }
 i2 = i11 + 296 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735185 | 0, i7, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i11 + 324 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735202 | 0, i7, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 204 | 0, gb + 735219 | 0, 0);
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 216 | 0, gb + 735228 | 0, 0);
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 228 | 0, gb + 735237 | 0, 0);
 i2 = i11 + 308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735246 | 0, HEAP32[gb + 37208 >> 2] | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i11 + 336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735263 | 0, i7, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735287 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i9 = 189; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i9 = 189;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 189) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 252 | 0, gb + 735307 | 0, 0);
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 240 | 0, gb + 735323 | 0, 0);
 __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i12, i11 + 264 | 0, gb + 735340 | 0, 0);
 i4 = i11 + 276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735353 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i8 >>> 0) i9 = 200; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i9 = 200;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 200) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 280 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734874 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i8 >>> 0) i9 = 211; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i9 = 211;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 211) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 284 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 734895 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i8 >>> 0) i9 = 222; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i9 = 222;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 222) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i11 + 292 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735370 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  L309 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i9 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i9 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L309;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i11 + 293 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 735395 | 0, i4, i10, 0) | 0;
 if (!i1) {
  __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i11, i12);
  STACKTOP = i13;
  return;
 }
 L322 : do if ((i1 | 0) > 0) {
  i1 = i12 + 16 | 0;
  i10 = HEAP32[i12 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i10 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L322;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i11, i12);
 STACKTOP = i13;
 return;
}

function __ZNK5Umbra14DepthmapReader9visualizeEPKNS_7ImpTomeEPNS_12QueryContextEi(i2, i1, i149, i150) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i149 = i149 | 0;
 i150 = i150 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0, i138 = 0, i139 = 0, i140 = 0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0, i151 = 0, i152 = 0, i153 = 0, i154 = 0, i155 = 0, i156 = 0, i157 = 0, f158 = f0, f159 = f0;
 i157 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i151 = i157 + 136 | 0;
 i152 = i157 + 120 | 0;
 i153 = i157 + 108 | 0;
 i154 = i157 + 96 | 0;
 i155 = i157 + 84 | 0;
 i156 = i157 + 72 | 0;
 i143 = i157 + 56 | 0;
 i144 = i157 + 40 | 0;
 i145 = i157 + 28 | 0;
 i146 = i157 + 16 | 0;
 i147 = i157;
 i148 = HEAP32[i2 >> 2] | 0;
 i31 = i1 + 20 | 0;
 i68 = i1 + 32 | 0;
 i140 = i151 + 12 | 0;
 HEAP32[i151 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i151 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i151 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i140 >> 2] = HEAP32[i68 >> 2];
 HEAP32[i140 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
 HEAP32[i140 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
 HEAP32[i152 >> 2] = HEAP32[i148 + (i150 << 6) + 48 >> 2];
 i68 = i152 + 4 | 0;
 HEAP32[i68 >> 2] = HEAP32[i148 + (i150 << 6) + 52 >> 2];
 i31 = i152 + 8 | 0;
 HEAP32[i31 >> 2] = HEAP32[i148 + (i150 << 6) + 56 >> 2];
 i141 = i2 + 8 | 0;
 i142 = i2 + 12 | 0;
 i69 = i2 + 4 | 0;
 i70 = i153 + 4 | 0;
 i71 = i153 + 8 | 0;
 i72 = i154 + 4 | 0;
 i73 = i154 + 8 | 0;
 i74 = i155 + 4 | 0;
 i75 = i155 + 8 | 0;
 i76 = i156 + 4 | 0;
 i77 = i156 + 8 | 0;
 i78 = i143 + 4 | 0;
 i79 = i143 + 8 | 0;
 i80 = i143 + 12 | 0;
 i81 = i144 + 4 | 0;
 i82 = i144 + 8 | 0;
 i83 = i145 + 4 | 0;
 i84 = i145 + 8 | 0;
 i85 = i146 + 4 | 0;
 i86 = i146 + 8 | 0;
 i87 = i147 + 4 | 0;
 i88 = i147 + 8 | 0;
 i89 = i143 + 4 | 0;
 i90 = i143 + 8 | 0;
 i91 = i144 + 4 | 0;
 i92 = i144 + 8 | 0;
 i93 = i145 + 4 | 0;
 i94 = i145 + 8 | 0;
 i95 = i146 + 4 | 0;
 i96 = i146 + 8 | 0;
 i97 = i147 + 4 | 0;
 i98 = i147 + 8 | 0;
 i99 = i147 + 12 | 0;
 i100 = i143 + 4 | 0;
 i101 = i143 + 8 | 0;
 i102 = i144 + 4 | 0;
 i103 = i144 + 8 | 0;
 i104 = i145 + 4 | 0;
 i105 = i145 + 8 | 0;
 i106 = i146 + 4 | 0;
 i107 = i146 + 8 | 0;
 i108 = i147 + 4 | 0;
 i109 = i147 + 8 | 0;
 i110 = i147 + 12 | 0;
 i111 = i143 + 4 | 0;
 i112 = i143 + 8 | 0;
 i113 = i144 + 4 | 0;
 i114 = i144 + 8 | 0;
 i115 = i145 + 4 | 0;
 i116 = i145 + 8 | 0;
 i117 = i146 + 4 | 0;
 i118 = i146 + 8 | 0;
 i119 = i147 + 4 | 0;
 i120 = i147 + 8 | 0;
 i121 = i147 + 12 | 0;
 i122 = i143 + 4 | 0;
 i123 = i143 + 8 | 0;
 i124 = i144 + 4 | 0;
 i125 = i144 + 8 | 0;
 i126 = i145 + 4 | 0;
 i127 = i145 + 8 | 0;
 i128 = i146 + 4 | 0;
 i129 = i146 + 8 | 0;
 i130 = i147 + 4 | 0;
 i131 = i147 + 8 | 0;
 i132 = i147 + 12 | 0;
 i133 = i143 + 4 | 0;
 i134 = i143 + 8 | 0;
 i135 = i143 + 12 | 0;
 i136 = i144 + 4 | 0;
 i137 = i144 + 8 | 0;
 i138 = i145 + 4 | 0;
 i139 = i145 + 8 | 0;
 i35 = i146 + 4 | 0;
 i36 = i146 + 8 | 0;
 i37 = i147 + 4 | 0;
 i38 = i147 + 8 | 0;
 f39 = Math_fround(HEAPF32[i152 >> 2]);
 f40 = Math_fround(HEAPF32[i68 >> 2]);
 f41 = Math_fround(HEAPF32[i31 >> 2]);
 i31 = 0;
 do {
  i42 = i148 + (i150 << 6) + (i31 << 3) + 4 | 0;
  i43 = i148 + (i150 << 6) + (i31 << 3) | 0;
  i59 = i31 >>> 1 & 3;
  i55 = 1 << i59 & 3;
  i56 = 1 << i55 & 3;
  f44 = Math_fround((i31 << 1 & 2) + -1 | 0);
  i45 = i153 + (i59 << 2) | 0;
  i46 = i153 + (i55 << 2) | 0;
  i47 = i153 + (i56 << 2) | 0;
  i48 = i154 + (i59 << 2) | 0;
  i49 = i154 + (i55 << 2) | 0;
  i50 = i154 + (i56 << 2) | 0;
  i51 = i155 + (i59 << 2) | 0;
  i52 = i155 + (i55 << 2) | 0;
  i53 = i155 + (i56 << 2) | 0;
  i54 = i156 + (i59 << 2) | 0;
  i55 = i156 + (i55 << 2) | 0;
  i56 = i156 + (i56 << 2) | 0;
  i57 = i152 + (i59 << 2) | 0;
  i58 = (i31 & 1 | 0) == 0;
  i59 = (i58 ? i151 : i140) + (i59 << 2) | 0;
  i60 = gb + 80144 + (i31 << 3) | 0;
  i61 = gb + 80144 + (i31 << 3) + 4 | 0;
  i33 = 0;
  do {
   i62 = i33 << 4;
   f63 = Math_fround(Math_fround(Math_fround(Math_fround(i33 | 0) * Math_fround(.0625)) * Math_fround(2.0)) + Math_fround(-1.0));
   i34 = i33;
   i33 = i33 + 1 | 0;
   f64 = Math_fround(Math_fround(Math_fround(Math_fround(i33 | 0) * Math_fround(.0625)) * Math_fround(2.0)) + Math_fround(-1.0));
   i65 = i34 + 240 | 0;
   i66 = (i34 | 0) == 15;
   i67 = (i34 | 0) == 0;
   i68 = i33 << 4;
   i32 = 0;
   do {
    i27 = (Math_imul(HEAP32[i142 >> 2] | 0, i32 + i62 | 0) | 0) + (HEAP32[i43 >> 2] | 0) << 2;
    f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i42 >> 2] << 1) + (((HEAP32[(HEAP32[i69 >> 2] | 0) + (i27 >> 5 << 2) >> 2] | 0) >>> (i27 & 28) & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    HEAPF32[i153 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(0.0);
    HEAPF32[i71 >> 2] = Math_fround(0.0);
    HEAPF32[i45 >> 2] = f44;
    f28 = Math_fround(Math_fround(Math_fround(Math_fround(i32 | 0) * Math_fround(.0625)) * Math_fround(2.0)) + Math_fround(-1.0));
    HEAPF32[i46 >> 2] = f28;
    HEAPF32[i47 >> 2] = f63;
    i27 = i32;
    i32 = i32 + 1 | 0;
    HEAPF32[i154 >> 2] = Math_fround(0.0);
    HEAPF32[i72 >> 2] = Math_fround(0.0);
    HEAPF32[i73 >> 2] = Math_fround(0.0);
    HEAPF32[i48 >> 2] = f44;
    f29 = Math_fround(Math_fround(Math_fround(Math_fround(i32 | 0) * Math_fround(.0625)) * Math_fround(2.0)) + Math_fround(-1.0));
    HEAPF32[i49 >> 2] = f29;
    HEAPF32[i50 >> 2] = f63;
    HEAPF32[i155 >> 2] = Math_fround(0.0);
    HEAPF32[i74 >> 2] = Math_fround(0.0);
    HEAPF32[i75 >> 2] = Math_fround(0.0);
    HEAPF32[i51 >> 2] = f44;
    HEAPF32[i52 >> 2] = f29;
    HEAPF32[i53 >> 2] = f64;
    HEAPF32[i156 >> 2] = Math_fround(0.0);
    HEAPF32[i76 >> 2] = Math_fround(0.0);
    HEAPF32[i77 >> 2] = Math_fround(0.0);
    HEAPF32[i54 >> 2] = f44;
    HEAPF32[i55 >> 2] = f28;
    HEAPF32[i56 >> 2] = f64;
    f28 = Math_fround(HEAPF32[i153 >> 2]);
    f29 = Math_fround(HEAPF32[i70 >> 2]);
    f16 = Math_fround(f28 + Math_fround(f29 * Math_fround(0.0)));
    f30 = Math_fround(HEAPF32[i71 >> 2]);
    f16 = Math_fround(Math_abs(Math_fround(f16 + Math_fround(f30 * Math_fround(0.0)))));
    if (f3 == Math_fround(3389531389999999962504737.0e14)) {
     f3 = Math_fround(HEAPF32[i57 >> 2]);
     f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i59 >> 2]))));
     HEAPF32[i143 >> 2] = Math_fround(1.0);
     HEAPF32[i78 >> 2] = Math_fround(1.0);
     HEAPF32[i79 >> 2] = Math_fround(1.0);
     HEAPF32[i80 >> 2] = Math_fround(1.0);
     f11 = Math_fround(Math_fround(f3 * f29) + f40);
     f4 = Math_fround(Math_fround(f3 * f30) + f41);
     HEAPF32[i144 >> 2] = Math_fround(Math_fround(f3 * f28) + f39);
     HEAPF32[i81 >> 2] = f11;
     HEAPF32[i82 >> 2] = f4;
     f4 = Math_fround(HEAPF32[i154 >> 2]);
     f11 = Math_fround(f3 * f4);
     f6 = Math_fround(HEAPF32[i72 >> 2]);
     f14 = Math_fround(f3 * f6);
     f8 = Math_fround(HEAPF32[i73 >> 2]);
     f14 = Math_fround(f14 + f40);
     f10 = Math_fround(Math_fround(f3 * f8) + f41);
     HEAPF32[i145 >> 2] = Math_fround(f11 + f39);
     HEAPF32[i83 >> 2] = f14;
     HEAPF32[i84 >> 2] = f10;
     f10 = Math_fround(HEAPF32[i155 >> 2]);
     f14 = Math_fround(f3 * f10);
     f11 = Math_fround(HEAPF32[i74 >> 2]);
     f24 = Math_fround(f3 * f11);
     f12 = Math_fround(HEAPF32[i75 >> 2]);
     f24 = Math_fround(f24 + f40);
     f13 = Math_fround(Math_fround(f3 * f12) + f41);
     HEAPF32[i146 >> 2] = Math_fround(f14 + f39);
     HEAPF32[i85 >> 2] = f24;
     HEAPF32[i86 >> 2] = f13;
     f13 = Math_fround(HEAPF32[i156 >> 2]);
     f24 = Math_fround(f3 * f13);
     f14 = Math_fround(HEAPF32[i76 >> 2]);
     f25 = Math_fround(f3 * f14);
     f15 = Math_fround(HEAPF32[i77 >> 2]);
     f25 = Math_fround(f25 + f40);
     f26 = Math_fround(Math_fround(f3 * f15) + f41);
     HEAPF32[i147 >> 2] = Math_fround(f24 + f39);
     HEAPF32[i87 >> 2] = f25;
     HEAPF32[i88 >> 2] = f26;
     i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0, i143 | 0);
     f26 = f3;
    } else {
     f11 = Math_fround(Math_fround(f16 * Math_fround(.25)) + Math_fround(.75));
     HEAPF32[i143 >> 2] = Math_fround(Math_fround(1.0) - f16);
     HEAPF32[i133 >> 2] = Math_fround(0.0);
     HEAPF32[i134 >> 2] = f11;
     HEAPF32[i135 >> 2] = Math_fround(1.0);
     f11 = Math_fround(Math_fround(f3 * f29) + f40);
     f4 = Math_fround(Math_fround(f3 * f30) + f41);
     HEAPF32[i144 >> 2] = Math_fround(Math_fround(f3 * f28) + f39);
     HEAPF32[i136 >> 2] = f11;
     HEAPF32[i137 >> 2] = f4;
     f4 = Math_fround(HEAPF32[i154 >> 2]);
     f11 = Math_fround(f3 * f4);
     f6 = Math_fround(HEAPF32[i72 >> 2]);
     f14 = Math_fround(f3 * f6);
     f8 = Math_fround(HEAPF32[i73 >> 2]);
     f14 = Math_fround(f14 + f40);
     f10 = Math_fround(Math_fround(f3 * f8) + f41);
     HEAPF32[i145 >> 2] = Math_fround(f11 + f39);
     HEAPF32[i138 >> 2] = f14;
     HEAPF32[i139 >> 2] = f10;
     f10 = Math_fround(HEAPF32[i155 >> 2]);
     f14 = Math_fround(f3 * f10);
     f11 = Math_fround(HEAPF32[i74 >> 2]);
     f24 = Math_fround(f3 * f11);
     f12 = Math_fround(HEAPF32[i75 >> 2]);
     f24 = Math_fround(f24 + f40);
     f13 = Math_fround(Math_fround(f3 * f12) + f41);
     HEAPF32[i146 >> 2] = Math_fround(f14 + f39);
     HEAPF32[i35 >> 2] = f24;
     HEAPF32[i36 >> 2] = f13;
     f13 = Math_fround(HEAPF32[i156 >> 2]);
     f24 = Math_fround(f3 * f13);
     f14 = Math_fround(HEAPF32[i76 >> 2]);
     f25 = Math_fround(f3 * f14);
     f15 = Math_fround(HEAPF32[i77 >> 2]);
     f25 = Math_fround(f25 + f40);
     f26 = Math_fround(Math_fround(f3 * f15) + f41);
     HEAPF32[i147 >> 2] = Math_fround(f24 + f39);
     HEAPF32[i37 >> 2] = f25;
     HEAPF32[i38 >> 2] = f26;
     i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0, i143 | 0);
     f26 = f3;
    }
    if ((i27 | 0) == 15) {
     i5 = HEAP32[i60 >> 2] | 0;
     i1 = HEAP32[i148 + (i150 << 6) + (i5 << 3) >> 2] | 0;
     i2 = HEAP32[i142 >> 2] | 0;
     if (i58) {
      i1 = (Math_imul(i2, i34) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     } else {
      i1 = (Math_imul(i2, i65) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     }
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i148 + (i150 << 6) + (i5 << 3) + 4 >> 2] << 1) + ((i1 & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      i9 = i5 >>> 1 & 3;
      f3 = Math_fround(HEAPF32[i152 + (i9 << 2) >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i140 + (i9 << 2) >> 2]))));
     }
    } else {
     i9 = (Math_imul(HEAP32[i142 >> 2] | 0, i32 + i62 | 0) | 0) + (HEAP32[i43 >> 2] | 0) << 2;
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i42 >> 2] << 1) + (((HEAP32[(HEAP32[i69 >> 2] | 0) + (i9 >> 5 << 2) >> 2] | 0) >>> (i9 & 28) & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      f3 = Math_fround(HEAPF32[i57 >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i59 >> 2]))));
     }
    }
    f23 = Math_fround(f26 * f4);
    f24 = Math_fround(f26 * f6);
    f25 = Math_fround(f26 * f8);
    f20 = Math_fround(f24 + f40);
    f19 = Math_fround(f25 + f41);
    HEAPF32[i143 >> 2] = Math_fround(f23 + f39);
    HEAPF32[i89 >> 2] = f20;
    HEAPF32[i90 >> 2] = f19;
    f19 = Math_fround(Math_fround(f3 * f6) + f40);
    f20 = Math_fround(Math_fround(f3 * f8) + f41);
    HEAPF32[i144 >> 2] = Math_fround(Math_fround(f3 * f4) + f39);
    HEAPF32[i91 >> 2] = f19;
    HEAPF32[i92 >> 2] = f20;
    f20 = Math_fround(Math_fround(f3 * f11) + f40);
    f19 = Math_fround(Math_fround(f3 * f12) + f41);
    HEAPF32[i145 >> 2] = Math_fround(Math_fround(f3 * f10) + f39);
    HEAPF32[i93 >> 2] = f20;
    HEAPF32[i94 >> 2] = f19;
    f19 = Math_fround(Math_fround(f26 * f10) + f39);
    f20 = Math_fround(Math_fround(f26 * f11) + f40);
    f21 = Math_fround(Math_fround(f26 * f12) + f41);
    HEAPF32[i146 >> 2] = f19;
    HEAPF32[i95 >> 2] = f20;
    HEAPF32[i96 >> 2] = f21;
    f22 = Math_fround(Math_fround(1.0) - f16);
    HEAPF32[i147 >> 2] = f22;
    HEAPF32[i97 >> 2] = Math_fround(0.0);
    HEAPF32[i98 >> 2] = Math_fround(.5);
    HEAPF32[i99 >> 2] = Math_fround(1.0);
    i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i143 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0);
    if (i66) {
     i7 = HEAP32[i61 >> 2] | 0;
     i1 = HEAP32[i148 + (i150 << 6) + (i7 << 3) >> 2] | 0;
     i2 = HEAP32[i142 >> 2] | 0;
     i5 = i27 << 4;
     if (i58) {
      i1 = (Math_imul(i2, i5) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     } else {
      i1 = (Math_imul(i2, i5 | 15) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     }
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i148 + (i150 << 6) + (i7 << 3) + 4 >> 2] << 1) + ((i1 & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      i9 = i7 >>> 1 & 3;
      f3 = Math_fround(HEAPF32[i152 + (i9 << 2) >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i140 + (i9 << 2) >> 2]))));
     }
    } else {
     i9 = (Math_imul(HEAP32[i142 >> 2] | 0, i27 + i68 | 0) | 0) + (HEAP32[i43 >> 2] | 0) << 2;
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i42 >> 2] << 1) + (((HEAP32[(HEAP32[i69 >> 2] | 0) + (i9 >> 5 << 2) >> 2] | 0) >>> (i9 & 28) & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      f3 = Math_fround(HEAPF32[i57 >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i59 >> 2]))));
     }
    }
    f16 = Math_fround(f26 * f13);
    f17 = Math_fround(f26 * f14);
    f18 = Math_fround(f26 * f15);
    f159 = Math_fround(f17 + f40);
    f158 = Math_fround(f18 + f41);
    HEAPF32[i143 >> 2] = Math_fround(f16 + f39);
    HEAPF32[i100 >> 2] = f159;
    HEAPF32[i101 >> 2] = f158;
    HEAPF32[i144 >> 2] = f19;
    HEAPF32[i102 >> 2] = f20;
    HEAPF32[i103 >> 2] = f21;
    f21 = Math_fround(Math_fround(f3 * f11) + f40);
    f20 = Math_fround(Math_fround(f3 * f12) + f41);
    HEAPF32[i145 >> 2] = Math_fround(Math_fround(f3 * f10) + f39);
    HEAPF32[i104 >> 2] = f21;
    HEAPF32[i105 >> 2] = f20;
    f20 = Math_fround(Math_fround(f3 * f14) + f40);
    f21 = Math_fround(Math_fround(f3 * f15) + f41);
    HEAPF32[i146 >> 2] = Math_fround(Math_fround(f3 * f13) + f39);
    HEAPF32[i106 >> 2] = f20;
    HEAPF32[i107 >> 2] = f21;
    HEAPF32[i147 >> 2] = f22;
    HEAPF32[i108 >> 2] = Math_fround(0.0);
    HEAPF32[i109 >> 2] = Math_fround(.75);
    HEAPF32[i110 >> 2] = Math_fround(1.0);
    i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i143 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0);
    if (!i27) {
     i7 = HEAP32[i60 >> 2] | 0;
     i5 = i7 ^ 1;
     i1 = HEAP32[i148 + (i150 << 6) + (i5 << 3) >> 2] | 0;
     i2 = HEAP32[i142 >> 2] | 0;
     if (i58) {
      i1 = (Math_imul(i2, i34) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     } else {
      i1 = (Math_imul(i2, i65) | 0) + i1 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     }
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i148 + (i150 << 6) + (i5 << 3) + 4 >> 2] << 1) + ((i1 & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      i9 = i7 >>> 1 & 3;
      f3 = Math_fround(HEAPF32[i152 + (i9 << 2) >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i151 + (i9 << 2) >> 2]))));
     }
     f159 = Math_fround(Math_fround(f26 * f29) + f40);
     f158 = Math_fround(Math_fround(f26 * f30) + f41);
     HEAPF32[i143 >> 2] = Math_fround(Math_fround(f26 * f28) + f39);
     HEAPF32[i111 >> 2] = f159;
     HEAPF32[i112 >> 2] = f158;
     f158 = Math_fround(f17 + f40);
     f159 = Math_fround(f18 + f41);
     HEAPF32[i144 >> 2] = Math_fround(f16 + f39);
     HEAPF32[i113 >> 2] = f158;
     HEAPF32[i114 >> 2] = f159;
     f159 = Math_fround(Math_fround(f3 * f14) + f40);
     f158 = Math_fround(Math_fround(f3 * f15) + f41);
     HEAPF32[i145 >> 2] = Math_fround(Math_fround(f3 * f13) + f39);
     HEAPF32[i115 >> 2] = f159;
     HEAPF32[i116 >> 2] = f158;
     f158 = Math_fround(Math_fround(f3 * f29) + f40);
     f159 = Math_fround(Math_fround(f3 * f30) + f41);
     HEAPF32[i146 >> 2] = Math_fround(Math_fround(f3 * f28) + f39);
     HEAPF32[i117 >> 2] = f158;
     HEAPF32[i118 >> 2] = f159;
     HEAPF32[i147 >> 2] = f22;
     HEAPF32[i119 >> 2] = Math_fround(0.0);
     HEAPF32[i120 >> 2] = Math_fround(.5);
     HEAPF32[i121 >> 2] = Math_fround(1.0);
     i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i143 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0);
    }
    if (i67) {
     i9 = HEAP32[i61 >> 2] | 0;
     i7 = i9 ^ 1;
     i2 = HEAP32[i148 + (i150 << 6) + (i7 << 3) >> 2] | 0;
     i5 = HEAP32[i142 >> 2] | 0;
     i1 = i27 << 4;
     if (i58) {
      i1 = (Math_imul(i5, i1) | 0) + i2 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     } else {
      i1 = (Math_imul(i5, i1 | 15) | 0) + i2 << 2;
      i1 = (HEAP32[(HEAP32[i69 >> 2] | 0) + (i1 >> 5 << 2) >> 2] | 0) >>> (i1 & 28);
     }
     f3 = (HEAP32[tempDoublePtr >> 2] = (HEAPU16[(HEAP32[i141 >> 2] | 0) + (HEAP32[i148 + (i150 << 6) + (i7 << 3) + 4 >> 2] << 1) + ((i1 & 15) << 1) >> 1] | 0) << 16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f3 == Math_fround(3389531389999999962504737.0e14)) {
      i27 = i9 >>> 1 & 3;
      f3 = Math_fround(HEAPF32[i152 + (i27 << 2) >> 2]);
      f3 = Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i151 + (i27 << 2) >> 2]))));
     }
     f159 = Math_fround(Math_fround(f26 * f29) + f40);
     f158 = Math_fround(Math_fround(f26 * f30) + f41);
     HEAPF32[i143 >> 2] = Math_fround(Math_fround(f26 * f28) + f39);
     HEAPF32[i122 >> 2] = f159;
     HEAPF32[i123 >> 2] = f158;
     f158 = Math_fround(f24 + f40);
     f159 = Math_fround(f25 + f41);
     HEAPF32[i144 >> 2] = Math_fround(f23 + f39);
     HEAPF32[i124 >> 2] = f158;
     HEAPF32[i125 >> 2] = f159;
     f159 = Math_fround(Math_fround(f3 * f6) + f40);
     f158 = Math_fround(Math_fround(f3 * f8) + f41);
     HEAPF32[i145 >> 2] = Math_fround(Math_fround(f3 * f4) + f39);
     HEAPF32[i126 >> 2] = f159;
     HEAPF32[i127 >> 2] = f158;
     f158 = Math_fround(Math_fround(f3 * f29) + f40);
     f159 = Math_fround(Math_fround(f3 * f30) + f41);
     HEAPF32[i146 >> 2] = Math_fround(Math_fround(f3 * f28) + f39);
     HEAPF32[i128 >> 2] = f158;
     HEAPF32[i129 >> 2] = f159;
     HEAPF32[i147 >> 2] = f22;
     HEAPF32[i130 >> 2] = Math_fround(0.0);
     HEAPF32[i131 >> 2] = Math_fround(.75);
     HEAPF32[i132 >> 2] = Math_fround(1.0);
     i1 = HEAP32[(HEAP32[i149 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i143 | 0, i144 | 0, i145 | 0, i146 | 0, i147 | 0);
    }
   } while ((i32 | 0) != 16);
  } while ((i33 | 0) != 16);
  i31 = i31 + 1 | 0;
 } while ((i31 | 0) != 6);
 STACKTOP = i157;
 return;
}

function __ZN14PhysicsManager11FixedUpdateEv(i75) {
 i75 = i75 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, i76 = 0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i73 = i76 + 96 | 0;
 i74 = i76 + 80 | 0;
 i72 = i76 + 64 | 0;
 i27 = i76 + 48 | 0;
 i38 = i76 + 32 | 0;
 i49 = i76 + 16 | 0;
 i60 = i76;
 f71 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
 i69 = i75 + 716 | 0;
 i70 = i75 + 720 | 0;
 i1 = HEAP32[i70 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i69 | 0)) {
  i11 = i27 + 12 | 0;
  i10 = i27 + 12 | 0;
  i12 = i73 + 4 | 0;
  i13 = i27 + 8 | 0;
  i14 = i27 + 4 | 0;
  i15 = i38 + 12 | 0;
  i16 = i38 + 11 | 0;
  i17 = i38 + 1 | 0;
  i18 = i38 + 12 | 0;
  i19 = i73 + 4 | 0;
  i20 = i27 + 11 | 0;
  i21 = i73 + 4 | 0;
  i22 = i74 + 11 | 0;
  i23 = i74 + 12 | 0;
  i24 = i73 + 4 | 0;
  i25 = i72 + 11 | 0;
  i26 = i72 + 12 | 0;
  i28 = i73 + 4 | 0;
  i29 = i27 + 12 | 0;
  i30 = i27 + 11 | 0;
  i31 = i27 + 2 | 0;
  i32 = i74 + 11 | 0;
  i33 = i74 + 4 | 0;
  i34 = i72 + 8 | 0;
  i35 = i72 + 4 | 0;
  i36 = i74 + 12 | 0;
  i37 = i73 + 4 | 0;
  i39 = i38 + 11 | 0;
  i40 = i38 + 12 | 0;
  i41 = i73 + 4 | 0;
  i42 = i27 + 12 | 0;
  i43 = i73 + 4 | 0;
  i44 = i27 + 12 | 0;
  i45 = i27 + 11 | 0;
  i46 = i27 + 1 | 0;
  i47 = i60 + 12 | 0;
  i48 = i73 + 4 | 0;
  i50 = i60 + 8 | 0;
  i51 = i60 + 4 | 0;
  i52 = i74 + 11 | 0;
  i53 = i74 + 4 | 0;
  i54 = i74 + 12 | 0;
  i55 = i73 + 4 | 0;
  i56 = i38 + 11 | 0;
  i57 = i38 + 12 | 0;
  i58 = i73 + 4 | 0;
  i59 = i49 + 11 | 0;
  i61 = i49 + 12 | 0;
  i62 = i73 + 4 | 0;
  i63 = i60 + 11 | 0;
  i64 = i60 + 12 | 0;
  i65 = i73 + 4 | 0;
  i66 = i27 + 12 | 0;
  i67 = i73 + 4 | 0;
  do {
   i8 = HEAP32[i1 + 8 >> 2] | 0;
   i9 = HEAP32[i8 + 16 >> 2] | 0;
   __Z32GetSceneHierarchyPathDescriptivePK6Object(i72, i9);
   do if (i9 | 0) if ((((HEAP32[i9 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 112968 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 112968 + 28 >> 2] | 0) >>> 0) {
    i5 = __ZNK12MeshCollider13GetSharedMeshEv(i9) | 0;
    if (i5 | 0) {
     HEAP32[i74 >> 2] = i5;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i68 = 14; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i3 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i73, i1, i74);
       i3 = HEAP32[i73 >> 2] | 0;
       i7 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i3 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i68 = 14; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i68 = 16;
      }
     }
     if ((i68 | 0) == 14) i68 = 16;
     if ((i68 | 0) == 16) {
      i68 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
      if (!i1) break;
     };
     HEAP32[i27 >> 2] = 0;
     HEAP32[i27 + 4 >> 2] = 0;
     HEAP32[i27 + 8 >> 2] = 0;
     HEAP32[i29 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i30 >> 0] = 2;
     HEAP16[i27 >> 1] = 8236;
     HEAP8[i31 >> 0] = 0;
     __Z27GetMeshAssetPathDescriptivePK4Mesh(i38, i1);
     __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i74, i72, i27, i38);
     i7 = HEAP8[i32 >> 0] | 0;
     i3 = i7 << 24 >> 24 < 0;
     i6 = i3 ? HEAP32[i74 >> 2] | 0 : i74;
     i7 = i3 ? HEAP32[i33 >> 2] | 0 : i7 & 255;
     i3 = HEAP8[i25 >> 0] | 0;
     i4 = i3 << 24 >> 24 < 0;
     if (i4) i5 = (HEAP32[i34 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     do if (i7 >>> 0 > i5 >>> 0) {
      i4 = i4 ? HEAP32[i35 >> 2] | 0 : i3 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i72, i5, i7 - i5 | 0, i4, 0, i4, i7, i6);
     } else {
      i3 = i4 ? HEAP32[i72 >> 2] | 0 : i72;
      if (i7 | 0) _memmove(i3 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i25 >> 0] | 0) < 0) {
       HEAP32[i35 >> 2] = i7;
       break;
      } else {
       HEAP8[i25 >> 0] = i7;
       break;
      }
     } while (0);
     if ((HEAP8[i32 >> 0] | 0) < 0) {
      i7 = HEAP32[i74 >> 2] | 0;
      i6 = HEAP32[i36 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i37 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i39 >> 0] | 0) < 0) {
      i7 = HEAP32[i38 >> 2] | 0;
      i6 = HEAP32[i40 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i41 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i30 >> 0] | 0) < 0) {
      i7 = HEAP32[i27 >> 2] | 0;
      i6 = HEAP32[i42 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i43 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     };
     HEAP32[i27 >> 2] = 0;
     HEAP32[i27 + 4 >> 2] = 0;
     HEAP32[i27 + 8 >> 2] = 0;
     HEAP32[i44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i45 >> 0] = 1;
     HEAP8[i27 >> 0] = 32;
     HEAP8[i46 >> 0] = 0;
     HEAP32[i60 >> 2] = 0;
     HEAP32[i60 + 4 >> 2] = 0;
     HEAP32[i60 + 8 >> 2] = 0;
     i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i47 >> 2] = i3;
     HEAP32[i73 >> 2] = 1;
     HEAP32[i48 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i73, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i60 >> 2] = i3;
     HEAP32[i50 >> 2] = -2147483632;
     HEAP32[i51 >> 2] = 11;
     i4 = i3;
     i5 = gb + 781672 | 0;
     i6 = i4 + 11 | 0;
     do {
      HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
      i4 = i4 + 1 | 0;
      i5 = i5 + 1 | 0;
     } while ((i4 | 0) < (i6 | 0));
     HEAP8[i3 + 11 >> 0] = 0;
     __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i49, i60, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0);
     __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i38, i49, gb + 1046779 | 0);
     __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i74, i72, i27, i38);
     i6 = HEAP8[i52 >> 0] | 0;
     i1 = i6 << 24 >> 24 < 0;
     i5 = i1 ? HEAP32[i74 >> 2] | 0 : i74;
     i6 = i1 ? HEAP32[i53 >> 2] | 0 : i6 & 255;
     i1 = HEAP8[i25 >> 0] | 0;
     i3 = i1 << 24 >> 24 < 0;
     if (i3) i4 = (HEAP32[i34 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     do if (i6 >>> 0 > i4 >>> 0) {
      i7 = i3 ? HEAP32[i35 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i72, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
     } else {
      i1 = i3 ? HEAP32[i72 >> 2] | 0 : i72;
      if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
      HEAP8[i1 + i6 >> 0] = 0;
      if ((HEAP8[i25 >> 0] | 0) < 0) {
       HEAP32[i35 >> 2] = i6;
       break;
      } else {
       HEAP8[i25 >> 0] = i6;
       break;
      }
     } while (0);
     if ((HEAP8[i52 >> 0] | 0) < 0) {
      i7 = HEAP32[i74 >> 2] | 0;
      i6 = HEAP32[i54 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i55 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i56 >> 0] | 0) < 0) {
      i7 = HEAP32[i38 >> 2] | 0;
      i6 = HEAP32[i57 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i58 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i59 >> 0] | 0) < 0) {
      i7 = HEAP32[i49 >> 2] | 0;
      i6 = HEAP32[i61 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i62 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i63 >> 0] | 0) < 0) {
      i7 = HEAP32[i60 >> 2] | 0;
      i6 = HEAP32[i64 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i65 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
     if ((HEAP8[i45 >> 0] | 0) < 0) {
      i7 = HEAP32[i27 >> 2] | 0;
      i6 = HEAP32[i66 >> 2] | 0;
      HEAP32[i73 >> 2] = 1;
      HEAP32[i67 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
     }
    }
   } while (0);
   i3 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 0;
   HEAP32[i27 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
    i1 = HEAP32[i10 >> 2] | 0;
    i68 = 55;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i20 >> 0] = i4;
    if (!i4) i1 = i27; else {
     i1 = i27;
     i68 = 57;
    }
   } else i68 = 55;
   if ((i68 | 0) == 55) {
    i7 = i4 + 16 & -16;
    HEAP32[i73 >> 2] = 1;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i73, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i13 >> 2] = i7 | -2147483648;
    HEAP32[i14 >> 2] = i4;
    i68 = 57;
   }
   if ((i68 | 0) == 57) {
    i68 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i15 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i16 >> 0] = 1;
   HEAP8[i38 >> 0] = 32;
   HEAP8[i17 >> 0] = 0;
   __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i74, i27, i38, i72);
   if ((HEAP8[i16 >> 0] | 0) < 0) {
    i7 = HEAP32[i38 >> 2] | 0;
    i6 = HEAP32[i18 >> 2] | 0;
    HEAP32[i73 >> 2] = 1;
    HEAP32[i19 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i7 = HEAP32[i27 >> 2] | 0;
    i6 = HEAP32[i10 >> 2] | 0;
    HEAP32[i73 >> 2] = 1;
    HEAP32[i21 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i73);
   }
   if (!(HEAP8[i8 + 20 >> 0] | 0)) {
    i8 = (HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i74 >> 2] | 0 : i74;
    HEAP32[i73 >> 2] = 0;
    HEAP32[i73 + 4 >> 2] = 0;
    HEAP32[i73 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i73, i8, _strlen(i8) | 0);
    __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i73, 256, HEAP32[i9 + 4 >> 2] | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i73);
   } else {
    i8 = (HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i74 >> 2] | 0 : i74;
    HEAP32[i73 >> 2] = 0;
    HEAP32[i73 + 4 >> 2] = 0;
    HEAP32[i73 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i73, i8, _strlen(i8) | 0);
    __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i73, 512, HEAP32[i9 + 4 >> 2] | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i73);
   }
   if ((HEAP8[i22 >> 0] | 0) < 0) {
    i9 = HEAP32[i74 >> 2] | 0;
    i8 = HEAP32[i23 >> 2] | 0;
    HEAP32[i73 >> 2] = 1;
    HEAP32[i24 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i73);
   }
   if ((HEAP8[i25 >> 0] | 0) < 0) {
    i9 = HEAP32[i72 >> 2] | 0;
    i8 = HEAP32[i26 >> 2] | 0;
    HEAP32[i73 >> 2] = 1;
    HEAP32[i28 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i73);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i69 | 0));
  i1 = HEAP32[i70 >> 2] | 0;
  if ((i1 | 0) != (i69 | 0)) do {
   i68 = i1 + 4 | 0;
   i67 = i1;
   i1 = HEAP32[i68 >> 2] | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i68 >> 2] = 0;
  } while ((i1 | 0) != (i69 | 0));
 }
 HEAP32[i70 >> 2] = i69;
 HEAP32[i69 >> 2] = i69;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) {
  STACKTOP = i76;
  return;
 }
 if ((HEAP16[gb + 1452536 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452536 | 0, i73);
  i4 = gb + 1452536 | 0;
 } else i4 = 0;
 i1 = HEAP32[i75 + 200 >> 2] | 0;
 i5 = i75 + 196 | 0;
 i2 = i1;
 if ((i2 | 0) != (i5 | 0)) {
  i6 = i73 + 16 | 0;
  i7 = i73 + 20 | 0;
  i8 = i73 + 24 | 0;
  i9 = i73 + 4 | 0;
  i10 = i73 + 8 | 0;
  i11 = i73 + 12 | 0;
  do {
   i3 = HEAP32[i1 + 36 >> 2] | 0;
   HEAP32[i1 + 40 >> 2] = 0;
   if ((HEAP8[i3 + 102 >> 0] | 0) == 1) {
    i68 = i3 + 52 | 0;
    i70 = HEAP32[i68 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i70 >> 2] | 0) + 84 >> 2] | 0, i73 | 0, i70 | 0);
    i70 = HEAP32[i7 >> 2] | 0;
    i69 = HEAP32[i8 >> 2] | 0;
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 12 >> 2] = i70;
    HEAP32[i1 + 16 >> 2] = i69;
    i68 = HEAP32[i68 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 84 >> 2] | 0, i73 | 0, i68 | 0);
    i68 = HEAP32[i9 >> 2] | 0;
    i69 = HEAP32[i10 >> 2] | 0;
    i70 = HEAP32[i11 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i1 + 24 >> 2] = i68;
    HEAP32[i1 + 28 >> 2] = i69;
    HEAP32[i1 + 32 >> 2] = i70;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i5 | 0));
 }
 if (i4 | 0) __Z12profiler_endP19ProfilerInformation(i4);
 __ZN5physx22PxSimulationStatisticsC2Ev(i73);
 i1 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 312 >> 2] | 0, i1 | 0, i73 | 0);
 i1 = (HEAP32[i73 + 16 >> 2] | 0) != 0;
 if (!(__Z12GetIVehiclesv() | 0)) i2 = 0; else {
  i2 = __Z12GetIVehiclesv() | 0;
  i2 = mftCall_ii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0) | 0;
 }
 if (!(i1 | i2 | (HEAP32[gb + 1457416 >> 2] | 0) != 0)) {
  STACKTOP = i76;
  return;
 }
 if (__Z12GetIVehiclesv() | 0) {
  if ((HEAP16[gb + 1452584 + 6 >> 1] | 0) > -1) {
   HEAP32[i74 >> 2] = 0;
   HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452584 | 0, i73);
   i1 = gb + 1452584 | 0;
  } else i1 = 0;
  i70 = __Z12GetIVehiclesv() | 0;
  mftCall_vif(HEAP32[(HEAP32[i70 >> 2] | 0) + 8 >> 2] | 0, i70 | 0, +f71);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if ((HEAP16[gb + 1452524 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452524 | 0, i73);
  i1 = gb + 1452524 | 0;
 } else i1 = 0;
 __ZN14CompletionTask4InitEPN5physx7PxSceneE(gb + 1452388 | 0, HEAP32[gb + 1457404 >> 2] | 0);
 i70 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vifiiii(HEAP32[(HEAP32[i70 >> 2] | 0) + 220 >> 2] | 0, i70 | 0, +f71, gb + 1452388 | 0, 0, 0, 1);
 mftCall_vi(HEAP32[(HEAP32[gb + 1452388 >> 2] | 0) + 20 >> 2] | 0, gb + 1452388 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if ((HEAP16[gb + 1452512 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452512 | 0, i73);
  i1 = gb + 1452512 | 0;
 } else i1 = 0;
 __ZN14CompletionTask22ProcessAllPhysicsTasksEv(gb + 1452388 | 0) | 0;
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if ((HEAP16[gb + 1452464 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452464 | 0, i73);
  i1 = gb + 1452464 | 0;
 } else i1 = 0;
 i70 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i70 >> 2] | 0) + 236 >> 2] | 0, i70 | 0, 1, 0) | 0;
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if ((HEAP16[gb + 1452572 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452572 | 0, i73);
  i31 = gb + 1452572 | 0;
 } else i31 = 0;
 i32 = i75 + 188 | 0;
 if (HEAP32[i32 >> 2] | 0) {
  i2 = i75 + 176 | 0;
  i1 = 0;
  do {
   i70 = __ZN14MessageHandler3GetEv() | 0;
   i69 = (Math_imul(HEAP32[i70 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i70 = (HEAP32[i70 + 16 >> 2] | 0) + (i69 >>> 5 << 2) | 0;
   HEAP32[i70 >> 2] = HEAP32[i70 >> 2] & ~(1 << (i69 & 31));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i32 >> 2] | 0) >>> 0);
 }
 i30 = i75 + 58 | 0;
 HEAP8[i30 >> 0] = 0;
 i7 = i73 + 16 | 0;
 i8 = i73 + 20 | 0;
 i9 = i73 + 24 | 0;
 i10 = i74 + 4 | 0;
 i11 = i74 + 8 | 0;
 i12 = i73 + 4 | 0;
 i13 = i73 + 8 | 0;
 i14 = i73 + 12 | 0;
 i15 = i72 + 4 | 0;
 i16 = i72 + 8 | 0;
 i17 = i72 + 12 | 0;
 i18 = i72 + 4 | 0;
 i19 = i72 + 8 | 0;
 i20 = i74 + 4 | 0;
 i21 = i74 + 8 | 0;
 i22 = i72 + 8 | 0;
 i23 = i72 + 4 | 0;
 i24 = i74 + 4 | 0;
 i25 = i74 + 8 | 0;
 i26 = i72 + 4 | 0;
 i27 = i72 + 8 | 0;
 i28 = i72 + 12 | 0;
 i6 = 0;
 do {
  i1 = HEAP32[i75 + 204 + (i6 << 3) + 4 >> 2] | 0;
  i29 = i75 + 204 + (i6 << 3) | 0;
  i2 = i1;
  if ((i2 | 0) != (i29 | 0)) do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   i3 = HEAP32[i1 + 52 >> 2] | 0;
   i3 = (HEAP16[i3 + 4 >> 1] | 0) == 5 ? i3 : 0;
   do if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 256 >> 2] | 0, i3 | 0) | 0)) {
    if (HEAP32[i1 + 88 >> 2] | 0) __ZN9Rigidbody16ApplyConstraintsEv(i1);
    if (HEAP32[i1 + 104 >> 2] & 1 | 0) break;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
    mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i73 | 0, i3 | 0);
    if (!(HEAP8[i1 + 102 >> 0] | 0)) {
     i69 = HEAP32[i8 >> 2] | 0;
     i68 = HEAP32[i9 >> 2] | 0;
     HEAP32[i74 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i10 >> 2] = i69;
     HEAP32[i11 >> 2] = i68;
     i68 = HEAP32[i12 >> 2] | 0;
     i69 = HEAP32[i13 >> 2] | 0;
     i70 = HEAP32[i14 >> 2] | 0;
     HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
     HEAP32[i15 >> 2] = i68;
     HEAP32[i16 >> 2] = i69;
     HEAP32[i17 >> 2] = i70;
     __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i5, i74, i72);
    } else {
     i69 = HEAP32[i8 >> 2] | 0;
     i68 = HEAP32[i9 >> 2] | 0;
     HEAP32[i74 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i24 >> 2] = i69;
     HEAP32[i25 >> 2] = i68;
     i68 = HEAP32[i12 >> 2] | 0;
     i69 = HEAP32[i13 >> 2] | 0;
     i70 = HEAP32[i14 >> 2] | 0;
     HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
     HEAP32[i26 >> 2] = i68;
     HEAP32[i27 >> 2] = i69;
     HEAP32[i28 >> 2] = i70;
     __ZN9Transform41SetPositionAndRotationWithoutNotificationERK8Vector3fRK11Quaternionf(i5, i74, i72);
     __ZN9Transform20SendTransformChangedEi(i5, 3);
    }
    if (HEAP32[i4 + 60 >> 2] & 32 | 0) {
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 152 >> 2] | 0, i72 | 0, i3 | 0);
     i69 = HEAP32[i18 >> 2] | 0;
     i70 = HEAP32[i19 >> 2] | 0;
     HEAP32[i74 >> 2] = HEAP32[i72 >> 2];
     HEAP32[i20 >> 2] = i69;
     HEAP32[i21 >> 2] = i70;
     HEAP32[i72 >> 2] = gb + 29392;
     HEAP32[i22 >> 2] = 0;
     HEAP32[i23 >> 2] = i74;
     __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1105856 | 0, i72);
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i29 | 0));
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 64);
 if (HEAP32[i32 >> 2] | 0) {
  i2 = i75 + 176 | 0;
  i1 = 0;
  do {
   i72 = __ZN14MessageHandler3GetEv() | 0;
   i70 = (Math_imul(HEAP32[i72 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i72 = (HEAP32[i72 + 16 >> 2] | 0) + (i70 >>> 5 << 2) | 0;
   HEAP32[i72 >> 2] = 1 << (i70 & 31) | HEAP32[i72 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i32 >> 2] | 0) >>> 0);
 }
 HEAP8[i30 >> 0] = 1;
 if (i31 | 0) __Z12profiler_endP19ProfilerInformation(i31);
 __ZN14PhysicsManager22ProcessRecordedReportsEv(i75);
 if ((HEAP16[gb + 1452452 + 6 >> 1] | 0) > -1) {
  HEAP32[i74 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i74 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452452 | 0, i73);
  i1 = gb + 1452452 | 0;
 } else i1 = 0;
 __ZN17TriggerStayStates20executeDeferredEraseEv(i75 + 104 | 0);
 __ZN17TriggerStayStates20executeDeferredEraseEv(i75 + 136 | 0);
 if (!i1) {
  STACKTOP = i76;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i76;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEvent16CollectExtraInfoEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i12 = i13;
 i1 = i10 + 132 | 0;
 __ZN11UnityEngine15PlatformWrapper24GetRuntimePlatformStringEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i7 = HEAP8[i6 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i8 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 140 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 136 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 136 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 i1 = i10 + 148 | 0;
 __ZN11UnityEngine15PlatformWrapper14GetDeviceModelEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 156 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 152 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 152 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 i1 = i10 + 164 | 0;
 __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 172 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 168 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 168 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 HEAP32[i10 + 180 >> 2] = __ZN11UnityEngine15PlatformWrapper17GetProcessorCountEv() | 0;
 HEAP32[i10 + 184 >> 2] = __ZN11UnityEngine15PlatformWrapper24GetProcessorFrequencyMHzEv() | 0;
 HEAP32[i10 + 188 >> 2] = __ZN11UnityEngine15PlatformWrapper19GetPhysicalMemoryMBEv() | 0;
 HEAP32[i10 + 192 >> 2] = __ZN11UnityEngine15PlatformWrapper16GetVideoMemoryMBEv() | 0;
 i1 = i10 + 196 | 0;
 __ZN11UnityEngine15PlatformWrapper19GetScreenResolutionEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 204 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 200 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 200 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 HEAP32[i10 + 212 >> 2] = __ZN11UnityEngine15PlatformWrapper12GetScreenDPIEv() | 0;
 HEAP32[i10 + 216 >> 2] = __ZN11UnityEngine15PlatformWrapper20GetRuntimePlatformIdEv() | 0;
 i1 = i10 + 220 | 0;
 __ZN11UnityEngine15PlatformWrapper24GetSystemLanguageCultureEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 228 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 224 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 224 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 HEAP32[i10 + 236 >> 2] = __ZN11UnityEngine15PlatformWrapper14GetSensorFlagsEv() | 0;
 HEAP32[i10 + 240 >> 2] = __ZN11UnityEngine15PlatformWrapper12GetInfoFlagsEv() | 0;
 i8 = i10 + 244 | 0;
 i2 = __ZN11UnityEngine15PlatformWrapper25GetDeviceUniqueIdentifierEv() | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i9 = 94;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i9 = 96;
  }
 } else i9 = 94;
 if ((i9 | 0) == 94) {
  i7 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i9 = 96;
 }
 if ((i9 | 0) == 96) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i12 + 11 | 0;
 do if ((i8 | 0) != (i12 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 252 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 248 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 248 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 280 | 0;
 __ZN11UnityEngine15PlatformWrapper19GetBundleIdentifierEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 288 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 284 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 284 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 296 | 0;
 __ZN11UnityEngine15PlatformWrapper25GetApplicationInstallModeEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 304 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 300 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 300 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 312 | 0;
 __ZN11UnityEngine15PlatformWrapper27GetApplicationInstallerNameEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 320 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 316 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 316 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 328 | 0;
 __ZN11UnityEngine15PlatformWrapper15GetBuildVersionEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 336 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 332 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 332 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 360 | 0;
 __ZN11UnityEngine15PlatformWrapper14GetLicenseTypeEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 368 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 364 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 364 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 120 | 0;
 i2 = __ZN11UnityEngine15PlatformWrapper19GetEnabledVRDevicesEv() | 0;
 if ((i1 | 0) != (i2 | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i10 + 392 | 0;
 __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 400 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 396 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 396 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 408 | 0;
 __ZN11UnityEngine15PlatformWrapper17GetGraphicsVendorEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 416 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 412 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 412 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 424 | 0;
 __ZN11UnityEngine15PlatformWrapper28GetCleanGraphicsFixedVersionEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 432 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 428 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 428 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 }
 i1 = i10 + 440 | 0;
 __ZN11UnityEngine15PlatformWrapper30GetGraphicsDriverLibraryStringEv(i12);
 i6 = i12 + 11 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 448 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 444 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 444 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  i11 = __ZN11UnityEngine15PlatformWrapper13GetShaderCapsEv() | 0;
  i12 = i10 + 456 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = __ZN11UnityEngine15PlatformWrapper14GetRendererAPIEv() | 0;
  i11 = i10 + 460 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv() | 0;
  i12 = i10 + 464 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = __ZN11UnityEngine15PlatformWrapper34GetRenderTextureFormatSupportFlagsEv() | 0;
  i11 = i10 + 468 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv() | 0;
  i12 = i10 + 472 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i9 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
 i11 = __ZN11UnityEngine15PlatformWrapper13GetShaderCapsEv() | 0;
 i12 = i10 + 456 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = __ZN11UnityEngine15PlatformWrapper14GetRendererAPIEv() | 0;
 i11 = i10 + 460 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv() | 0;
 i12 = i10 + 464 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = __ZN11UnityEngine15PlatformWrapper34GetRenderTextureFormatSupportFlagsEv() | 0;
 i11 = i10 + 468 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv() | 0;
 i12 = i10 + 472 | 0;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i114, i101, i100, i1, i103, i102, i116, i117, i115, f2) {
 i114 = i114 | 0;
 i101 = i101 | 0;
 i100 = i100 | 0;
 i1 = i1 | 0;
 i103 = i103 | 0;
 i102 = i102 | 0;
 i116 = i116 | 0;
 i117 = i117 | 0;
 i115 = i115 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, f104 = f0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i118 = 0, f119 = f0, f120 = f0, i121 = 0, f122 = f0, i123 = 0;
 i118 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i113 = i118 + 288 | 0;
 i108 = i118 + 384 | 0;
 i112 = i118 + 380 | 0;
 i75 = i118 + 144 | 0;
 i70 = i118 + 128 | 0;
 i107 = i118 + 304 | 0;
 i105 = i118 + 224 | 0;
 i106 = i118 + 160 | 0;
 i72 = i118 + 112 | 0;
 i73 = i118 + 96 | 0;
 i71 = i118 + 368 | 0;
 i84 = i118 + 80 | 0;
 i85 = i118 + 64 | 0;
 i86 = i118 + 48 | 0;
 i111 = i118 + 32 | 0;
 i109 = i118 + 16 | 0;
 i110 = i118;
 HEAP32[i113 >> 2] = 0;
 HEAP32[i113 + 4 >> 2] = 0;
 HEAP32[i113 + 8 >> 2] = 0;
 HEAP32[i113 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i102 >> 2]);
 i91 = i102 + 4 | 0;
 f8 = Math_fround(HEAPF32[i91 >> 2]);
 i96 = i102 + 8 | 0;
 f13 = Math_fround(HEAPF32[i96 >> 2]);
 f4 = Math_fround(HEAPF32[i103 >> 2]);
 i74 = i103 + 4 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 i80 = i103 + 8 | 0;
 f9 = Math_fround(HEAPF32[i80 >> 2]);
 HEAP32[i112 >> 2] = 1;
 i81 = i100 + 48 | 0;
 f24 = Math_fround(HEAPF32[i81 >> 2]);
 i82 = i100 + 52 | 0;
 f27 = Math_fround(HEAPF32[i82 >> 2]);
 i83 = i100 + 56 | 0;
 f30 = Math_fround(HEAPF32[i83 >> 2]);
 i87 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f27 * f27)) + Math_fround(f30 * f30)) > Math_fround(1.1920929e-07);
 f14 = i87 ? f24 : Math_fround(1.0);
 f22 = i87 ? f27 : Math_fround(0.0);
 f25 = i87 ? f30 : Math_fround(0.0);
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f14 * f14) + Math_fround(f22 * f22))))));
 f14 = Math_fround(f14 * f21);
 f22 = Math_fround(f22 * f21);
 f21 = Math_fround(f25 * f21);
 HEAPF32[i75 >> 2] = f14;
 HEAPF32[i75 + 4 >> 2] = f22;
 HEAPF32[i75 + 8 >> 2] = f21;
 HEAPF32[i75 + 12 >> 2] = Math_fround(0.0);
 f14 = Math_fround(-f14);
 f22 = Math_fround(-f22);
 f21 = Math_fround(-f21);
 f25 = Math_fround(HEAPF32[i100 >> 2]);
 f6 = Math_fround(f25 * f14);
 i87 = i100 + 4 | 0;
 f28 = Math_fround(HEAPF32[i87 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f28 * f22));
 i88 = i100 + 8 | 0;
 f31 = Math_fround(HEAPF32[i88 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f31 * f21));
 i89 = i100 + 16 | 0;
 f26 = Math_fround(HEAPF32[i89 >> 2]);
 f23 = Math_fround(f26 * f14);
 i90 = i100 + 20 | 0;
 f29 = Math_fround(HEAPF32[i90 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f29 * f22));
 i92 = i100 + 24 | 0;
 f16 = Math_fround(HEAPF32[i92 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f16 * f21));
 i93 = i100 + 32 | 0;
 f33 = Math_fround(HEAPF32[i93 >> 2]);
 f14 = Math_fround(f33 * f14);
 i94 = i100 + 36 | 0;
 f32 = Math_fround(HEAPF32[i94 >> 2]);
 f22 = Math_fround(f14 + Math_fround(f32 * f22));
 i95 = i100 + 40 | 0;
 f14 = Math_fround(HEAPF32[i95 >> 2]);
 i78 = f6 > Math_fround(0.0);
 i77 = f23 > Math_fround(0.0);
 i76 = Math_fround(f22 + Math_fround(f14 * f21)) > Math_fround(0.0);
 i97 = i114 + 144 | 0;
 f21 = Math_fround(HEAPF32[i97 >> 2]);
 i98 = i114 + 148 | 0;
 f22 = Math_fround(HEAPF32[i98 >> 2]);
 i99 = i114 + 152 | 0;
 f23 = Math_fround(HEAPF32[i99 >> 2]);
 f6 = Math_fround(-f21);
 f15 = Math_fround(-f22);
 f104 = Math_fround(-f23);
 f6 = i78 ? f21 : f6;
 f15 = i77 ? f22 : f15;
 f104 = i76 ? f23 : f104;
 f33 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f25 * f6) + Math_fround(f26 * f15)) + Math_fround(f33 * f104)));
 f32 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f28 * f6) + Math_fround(f29 * f15)) + Math_fround(f32 * f104)));
 f104 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f31 * f6) + Math_fround(f16 * f15)) + Math_fround(f14 * f104)));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i70, i101, i75);
 f14 = Math_fround(HEAPF32[i70 >> 2]);
 f15 = Math_fround(HEAPF32[i70 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f104 - Math_fround(HEAPF32[i70 + 8 >> 2]));
 HEAPF32[i107 >> 2] = f14;
 i75 = i107 + 4 | 0;
 HEAPF32[i75 >> 2] = f15;
 i76 = i107 + 8 | 0;
 HEAPF32[i76 >> 2] = f16;
 i77 = i107 + 12 | 0;
 HEAPF32[i77 >> 2] = Math_fround(0.0);
 i78 = i107 + 16 | 0;
 HEAP32[i78 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i78 = i107 + 32 | 0;
 HEAP32[i78 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i78 = i107 + 48 | 0;
 HEAP32[i78 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 HEAPF32[i105 >> 2] = f33;
 i78 = i105 + 4 | 0;
 HEAPF32[i78 >> 2] = f32;
 i79 = i105 + 8 | 0;
 HEAPF32[i79 >> 2] = f104;
 HEAPF32[i105 + 12 >> 2] = Math_fround(0.0);
 i69 = i105 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i69 = i105 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i69 = i105 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 HEAP32[i106 >> 2] = HEAP32[i70 >> 2];
 HEAP32[i106 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
 HEAP32[i106 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
 HEAP32[i106 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
 i70 = i106 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i70 = i106 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i70 = i106 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 f104 = Math_fround(HEAPF32[i114 + 32 >> 2]);
 f32 = Math_fround(HEAPF32[i101 + 32 >> 2]);
 f104 = Math_fround((f104 > f32 ? f32 : f104) * Math_fround(.100000001));
 f32 = Math_fround(f104 + f2);
 f104 = Math_fround(f104 * f104);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f104) {
  i3 = i73 + 4 | 0;
  i34 = i73 + 8 | 0;
  i35 = i73 + 12 | 0;
  i36 = i72 + 4 | 0;
  i37 = i72 + 8 | 0;
  i38 = i106 + 4 | 0;
  i39 = i106 + 8 | 0;
  i40 = i106 + 12 | 0;
  i41 = i106 + 16 | 0;
  i42 = i106 + 20 | 0;
  i43 = i106 + 24 | 0;
  i44 = i106 + 28 | 0;
  i45 = i106 + 32 | 0;
  i46 = i106 + 36 | 0;
  i47 = i106 + 40 | 0;
  i48 = i106 + 44 | 0;
  i49 = i105 + 16 | 0;
  i50 = i105 + 20 | 0;
  i51 = i105 + 24 | 0;
  i52 = i107 + 16 | 0;
  i53 = i107 + 20 | 0;
  i54 = i107 + 24 | 0;
  i55 = i107 + 28 | 0;
  i56 = i105 + 32 | 0;
  i57 = i105 + 36 | 0;
  i58 = i105 + 40 | 0;
  i59 = i107 + 32 | 0;
  i60 = i107 + 36 | 0;
  i61 = i107 + 40 | 0;
  i62 = i107 + 44 | 0;
  i63 = i85 + 4 | 0;
  i64 = i85 + 8 | 0;
  i65 = i85 + 12 | 0;
  i66 = i84 + 4 | 0;
  i67 = i84 + 8 | 0;
  i68 = i86 + 4 | 0;
  i69 = i86 + 8 | 0;
  i70 = i86 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f119 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f19 = Math_fround(HEAPF32[i100 >> 2]);
   f120 = Math_fround(f19 * f119);
   f7 = Math_fround(HEAPF32[i87 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f7 * f13));
   f23 = Math_fround(HEAPF32[i88 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f23 * f8));
   f18 = Math_fround(HEAPF32[i89 >> 2]);
   f17 = Math_fround(f18 * f119);
   f24 = Math_fround(HEAPF32[i90 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f24 * f13));
   f21 = Math_fround(HEAPF32[i92 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f21 * f8));
   f25 = Math_fround(HEAPF32[i93 >> 2]);
   f122 = Math_fround(f25 * f119);
   f26 = Math_fround(HEAPF32[i94 >> 2]);
   f122 = Math_fround(f122 + Math_fround(f26 * f13));
   f16 = Math_fround(HEAPF32[i95 >> 2]);
   i123 = f120 > Math_fround(0.0);
   i121 = f17 > Math_fround(0.0);
   i1 = Math_fround(f122 + Math_fround(f16 * f8)) > Math_fround(0.0);
   f122 = Math_fround(HEAPF32[i97 >> 2]);
   f17 = Math_fround(HEAPF32[i98 >> 2]);
   f120 = Math_fround(HEAPF32[i99 >> 2]);
   f22 = Math_fround(-f122);
   f20 = Math_fround(-f17);
   f27 = Math_fround(-f120);
   f22 = i123 ? f122 : f22;
   f20 = i121 ? f17 : f20;
   f27 = i1 ? f120 : f27;
   f120 = Math_fround(HEAPF32[i81 >> 2]);
   f17 = Math_fround(HEAPF32[i82 >> 2]);
   f25 = Math_fround(f120 + Math_fround(Math_fround(Math_fround(f19 * f22) + Math_fround(f18 * f20)) + Math_fround(f25 * f27)));
   f26 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f7 * f22) + Math_fround(f24 * f20)) + Math_fround(f26 * f27)));
   f27 = Math_fround(Math_fround(HEAPF32[i83 >> 2]) + Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * f20)) + Math_fround(f16 * f27)));
   HEAPF32[i73 >> 2] = f9;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i34 >> 2] = f15;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i72, i101, i73);
   f16 = Math_fround(HEAPF32[i72 >> 2]);
   f20 = Math_fround(HEAPF32[i36 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i37 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23)) + Math_fround(f15 * f24)) - f32);
   f17 = Math_fround(HEAPF32[i102 >> 2]);
   f18 = Math_fround(HEAPF32[i91 >> 2]);
   f19 = Math_fround(HEAPF32[i96 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f119) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i108 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i108 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i108 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f122 = Math_fround(HEAPF32[i103 >> 2]);
     f120 = Math_fround(HEAPF32[i74 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f122);
     f18 = Math_fround(Math_fround(f13 * f18) + f120);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i80 >> 2]));
     f120 = Math_fround(f17 - f31);
     f122 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i106 >> 2]);
     f4 = Math_fround(HEAPF32[i38 >> 2]);
     f2 = Math_fround(f120 + f2);
     f4 = Math_fround(f122 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f22 = Math_fround(HEAPF32[i41 >> 2]);
     f21 = Math_fround(HEAPF32[i42 >> 2]);
     f22 = Math_fround(f120 + f22);
     f21 = Math_fround(f122 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i43 >> 2]));
     f16 = Math_fround(HEAPF32[i45 >> 2]);
     f7 = Math_fround(HEAPF32[i46 >> 2]);
     f16 = Math_fround(f120 + f16);
     f7 = Math_fround(f122 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i47 >> 2]));
     HEAPF32[i106 >> 2] = f2;
     HEAPF32[i38 >> 2] = f4;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     HEAPF32[i41 >> 2] = f22;
     HEAPF32[i42 >> 2] = f21;
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = Math_fround(0.0);
     HEAPF32[i45 >> 2] = f16;
     HEAPF32[i46 >> 2] = f7;
     HEAPF32[i47 >> 2] = f8;
     HEAPF32[i48 >> 2] = Math_fround(0.0);
     f122 = Math_fround(HEAPF32[i105 >> 2]);
     f120 = Math_fround(HEAPF32[i78 >> 2]);
     f4 = Math_fround(f120 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i79 >> 2]) - f5);
     HEAPF32[i107 >> 2] = Math_fround(f122 - f2);
     HEAPF32[i75 >> 2] = f4;
     HEAPF32[i76 >> 2] = f5;
     HEAPF32[i77 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i49 >> 2]);
     f4 = Math_fround(HEAPF32[i50 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f20);
     HEAPF32[i52 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i53 >> 2] = f21;
     HEAPF32[i54 >> 2] = f20;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i56 >> 2]);
     f21 = Math_fround(HEAPF32[i57 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f8);
     HEAPF32[i59 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i60 >> 2] = f7;
     HEAPF32[i61 >> 2] = f8;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i85 >> 2] = f9;
     HEAPF32[i63 >> 2] = f14;
     HEAPF32[i64 >> 2] = f15;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i84, i101, i85);
     f9 = Math_fround(HEAPF32[i84 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i67 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i123 = HEAP32[i112 >> 2] | 0;
   HEAPF32[i105 + (i123 << 4) >> 2] = f25;
   HEAPF32[i105 + (i123 << 4) + 4 >> 2] = f26;
   HEAPF32[i105 + (i123 << 4) + 8 >> 2] = f27;
   HEAPF32[i105 + (i123 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i106 + (i123 << 4) >> 2] = f16;
   HEAPF32[i106 + (i123 << 4) + 4 >> 2] = f20;
   HEAPF32[i106 + (i123 << 4) + 8 >> 2] = f21;
   HEAPF32[i106 + (i123 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i112 >> 2] = i123 + 1;
   HEAPF32[i107 + (i123 << 4) >> 2] = f9;
   HEAPF32[i107 + (i123 << 4) + 4 >> 2] = f8;
   HEAPF32[i107 + (i123 << 4) + 8 >> 2] = f7;
   HEAPF32[i107 + (i123 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i123 | 0) {
   case 0:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i107 >> 2]);
     f7 = Math_fround(HEAPF32[i75 >> 2]);
     f8 = Math_fround(HEAPF32[i76 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f119 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i123 = f119 > Math_fround(1.0);
      f119 = i123 ? Math_fround(1.0) : f119;
      i123 = f119 > Math_fround(0.0);
      f119 = i123 ? f119 : Math_fround(0.0);
      f120 = Math_fround(f7 + Math_fround(f14 * f119));
      f122 = Math_fround(f8 + Math_fround(f15 * f119));
      HEAPF32[i86 >> 2] = Math_fround(f6 + Math_fround(f9 * f119));
      HEAPF32[i68 >> 2] = f120;
      HEAPF32[i69 >> 2] = f122;
      HEAPF32[i70 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i112 >> 2] = 1;
      HEAP32[i86 >> 2] = HEAP32[i107 >> 2];
      HEAP32[i86 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
      HEAP32[i86 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
      HEAP32[i86 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i107, i105, i106, i112);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i86, i107, i105, i106, i112);
     break;
    }
   default:
    {
     HEAPF32[i86 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i86 >> 2]);
   f8 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i118;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i103 = HEAP32[i114 + 64 >> 2] | 0;
 i121 = HEAP32[i114 + 68 >> 2] | 0;
 i123 = HEAP32[i114 + 72 >> 2] | 0;
 i102 = f6 > f104 & i1;
 f32 = i102 ? f7 : f2;
 f104 = i102 ? f8 : f4;
 f120 = i102 ? f9 : f5;
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f120 * f120) + Math_fround(Math_fround(f104 * f104) + Math_fround(f32 * f32))))));
 f32 = Math_fround(f32 * f31);
 f104 = Math_fround(f104 * f31);
 f31 = Math_fround(f120 * f31);
 HEAPF32[i117 >> 2] = f32;
 HEAPF32[i117 + 4 >> 2] = f104;
 HEAPF32[i117 + 8 >> 2] = f31;
 HEAPF32[i117 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i116 >> 2] = f13;
 i117 = i116 + 4 | 0;
 HEAP32[i117 >> 2] = HEAP32[i108 >> 2];
 HEAP32[i117 + 4 >> 2] = HEAP32[i108 + 4 >> 2];
 HEAP32[i117 + 8 >> 2] = HEAP32[i108 + 8 >> 2];
 HEAPF32[i111 >> 2] = i1 ? f7 : f10;
 HEAPF32[i111 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i111 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i109 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i109 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i109 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i109 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 HEAP32[i110 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i110 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i110 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i110 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i107, i105, i106, i111, i109, i110, HEAP32[i112 >> 2] | 0);
 f120 = Math_fround(HEAPF32[i114 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i109 >> 2]);
 f119 = Math_fround(HEAPF32[i109 + 4 >> 2]);
 f122 = Math_fround(HEAPF32[i109 + 8 >> 2]);
 f32 = Math_fround(f33 - Math_fround(f32 * f120));
 f104 = Math_fround(f119 - Math_fround(f104 * f120));
 f120 = Math_fround(f122 - Math_fround(f31 * f120));
 HEAPF32[i115 >> 2] = i103 | 0 ? f32 : f33;
 HEAPF32[i115 + 4 >> 2] = i121 | 0 ? f104 : f119;
 HEAPF32[i115 + 8 >> 2] = i123 | 0 ? f120 : f122;
 HEAPF32[i115 + 12 >> 2] = Math_fround(0.0);
 i123 = 1;
 STACKTOP = i118;
 return i123 | 0;
}

function __ZN5physx10PxsCCDPair17sweepAdvanceToToiEfb(i23, f28, i26) {
 i23 = i23 | 0;
 f28 = Math_fround(f28);
 i26 = i26 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i24 = 0, i25 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, i35 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i32 + 32 | 0;
 i30 = i32;
 i4 = HEAP32[i23 + 8 >> 2] | 0;
 i29 = HEAP32[i23 >> 2] | 0;
 i10 = HEAP32[i23 + 12 >> 2] | 0;
 i27 = HEAP32[i23 + 4 >> 2] | 0;
 i1 = (i29 | 0) == 0;
 if (i1) i22 = 3; else if (!(HEAP16[(HEAP32[i29 + 60 >> 2] | 0) + 2 >> 1] | 0)) i22 = 6; else i22 = 3;
 do if ((i22 | 0) == 3) {
  if (!i27) {
   i31 = 0;
   STACKTOP = i32;
   return i31 | 0;
  }
  if (!(HEAP16[(HEAP32[i27 + 60 >> 2] | 0) + 2 >> 1] | 0)) if (i1) {
   i22 = 8;
   break;
  } else {
   i22 = 6;
   break;
  } else {
   i31 = 0;
   STACKTOP = i32;
   return i31 | 0;
  }
 } while (0);
 if ((i22 | 0) == 6) if (Math_fround(HEAPF32[(HEAP32[i29 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) if (!i27) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 } else i22 = 8;
 if ((i22 | 0) == 8) if (Math_fround(HEAPF32[(HEAP32[i27 + 64 >> 2] | 0) + 124 >> 2]) == Math_fround(0.0)) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 i3 = i23 + 28 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f2 < Math_fround(1.0))) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 i8 = HEAP32[i23 + 52 >> 2] | 0;
 if (HEAP8[i8 + 34 >> 0] | 0) {
  if (!i1) {
   i1 = HEAP32[i29 + 64 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
    f21 = Math_fround(Math_fround(1.0) - f2);
    i26 = i29 + 48 | 0;
    f17 = Math_fround(f21 * Math_fround(HEAPF32[i26 >> 2]));
    i25 = i29 + 52 | 0;
    f18 = Math_fround(f21 * Math_fround(HEAPF32[i25 >> 2]));
    i24 = i29 + 56 | 0;
    f21 = Math_fround(f21 * Math_fround(HEAPF32[i24 >> 2]));
    f19 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
    f20 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
    f19 = Math_fround(f17 + f19);
    f20 = Math_fround(f18 + f20);
    f21 = Math_fround(f21 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
    HEAPF32[i26 >> 2] = f19;
    HEAPF32[i25 >> 2] = f20;
    HEAPF32[i24 >> 2] = f21;
    HEAP32[i30 >> 2] = HEAP32[i29 + 32 >> 2];
    i24 = i29 + 36 | 0;
    HEAP32[i30 + 4 >> 2] = HEAP32[i24 >> 2];
    i25 = i29 + 40 | 0;
    HEAP32[i30 + 8 >> 2] = HEAP32[i25 >> 2];
    i26 = i29 + 44 | 0;
    HEAP32[i30 + 12 >> 2] = HEAP32[i26 >> 2];
    HEAPF32[i30 + 16 >> 2] = f19;
    HEAPF32[i30 + 20 >> 2] = f20;
    HEAPF32[i30 + 24 >> 2] = f21;
    __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
    HEAP32[i29 + 32 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i24 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i25 >> 2] = HEAP32[i31 + 8 >> 2];
    HEAP32[i26 >> 2] = HEAP32[i31 + 12 >> 2];
    f2 = Math_fround(HEAPF32[i3 >> 2]);
   }
   __ZN5physx12PxsRigidBody12advanceToToiEffb(i29, f2, f28, 0);
  }
  if (!i27) {
   i31 = 1;
   STACKTOP = i32;
   return i31 | 0;
  }
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = HEAP32[i27 + 64 >> 2] | 0;
  if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
   f21 = Math_fround(Math_fround(1.0) - f2);
   i29 = i27 + 48 | 0;
   f17 = Math_fround(f21 * Math_fround(HEAPF32[i29 >> 2]));
   i26 = i27 + 52 | 0;
   f18 = Math_fround(f21 * Math_fround(HEAPF32[i26 >> 2]));
   i25 = i27 + 56 | 0;
   f21 = Math_fround(f21 * Math_fround(HEAPF32[i25 >> 2]));
   f19 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
   f20 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
   f19 = Math_fround(f17 + f19);
   f20 = Math_fround(f18 + f20);
   f21 = Math_fround(f21 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
   HEAPF32[i29 >> 2] = f19;
   HEAPF32[i26 >> 2] = f20;
   HEAPF32[i25 >> 2] = f21;
   HEAP32[i30 >> 2] = HEAP32[i27 + 32 >> 2];
   i25 = i27 + 36 | 0;
   HEAP32[i30 + 4 >> 2] = HEAP32[i25 >> 2];
   i26 = i27 + 40 | 0;
   HEAP32[i30 + 8 >> 2] = HEAP32[i26 >> 2];
   i29 = i27 + 44 | 0;
   HEAP32[i30 + 12 >> 2] = HEAP32[i29 >> 2];
   HEAPF32[i30 + 16 >> 2] = f19;
   HEAPF32[i30 + 20 >> 2] = f20;
   HEAPF32[i30 + 24 >> 2] = f21;
   __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
   HEAP32[i27 + 32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i25 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i31 + 12 >> 2];
   f2 = Math_fround(HEAPF32[i3 >> 2]);
  }
  __ZN5physx12PxsRigidBody12advanceToToiEffb(i27, f2, f28, 0);
  i31 = 1;
  STACKTOP = i32;
  return i31 | 0;
 }
 f13 = Math_fround(Math_fround(HEAPF32[i23 + 48 >> 2]) * Math_fround(10.0));
 i12 = HEAP32[i23 + 16 >> 2] | 0;
 i24 = HEAP32[i23 + 20 >> 2] | 0;
 i25 = HEAP32[i23 + 24 >> 2] | 0;
 f21 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i12 & 2139095040) >>> 0 < 2139095040 & (i24 & 2139095040) >>> 0 < 2139095040 & (i25 & 2139095040) >>> 0 < 2139095040) if (Math_fround(Math_abs(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)) + Math_fround(f18 * f18)))) + Math_fround(-1.0)))) < Math_fround(.0000999999974)) {
  f14 = Math_fround(HEAPF32[i23 + 88 >> 2]);
  f16 = Math_fround(HEAPF32[i23 + 84 >> 2]);
  f17 = Math_fround(HEAPF32[i23 + 80 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 104 >> 2]);
  i25 = (i29 | 0) != 0;
  if (i25) {
   f19 = Math_fround(HEAPF32[i8 + 100 >> 2]);
   i24 = HEAP32[i29 + 64 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i24 + 84 >> 2]);
   f11 = Math_fround(HEAPF32[i3 + 24 >> 2]);
   f9 = Math_fround(f7 * f11);
   f34 = Math_fround(HEAPF32[i24 + 88 >> 2]);
   f33 = Math_fround(HEAPF32[i3 + 20 >> 2]);
   f9 = Math_fround(f9 - Math_fround(f34 * f33));
   f15 = Math_fround(HEAPF32[i3 + 16 >> 2]);
   f34 = Math_fround(f34 * f15);
   f6 = Math_fround(HEAPF32[i24 + 80 >> 2]);
   f11 = Math_fround(f34 - Math_fround(f11 * f6));
   f15 = Math_fround(Math_fround(f33 * f6) - Math_fround(f7 * f15));
   f9 = Math_fround(f9 + Math_fround(HEAPF32[i24 + 64 >> 2]));
   f11 = Math_fround(Math_fround(HEAPF32[i24 + 68 >> 2]) + f11);
   f15 = Math_fround(f15 + Math_fround(HEAPF32[i24 + 72 >> 2]));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   f19 = Math_fround(f19 * Math_fround(HEAPF32[i24 + 124 >> 2]));
  } else {
   i3 = 0;
   i8 = 0;
   i12 = 0;
   f19 = Math_fround(0.0);
  }
  i24 = (i27 | 0) != 0;
  if (i24) {
   i35 = HEAP32[i27 + 64 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i35 + 84 >> 2]);
   f34 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f33 = Math_fround(f11 * f34);
   f6 = Math_fround(HEAPF32[i35 + 88 >> 2]);
   f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   f33 = Math_fround(f33 - Math_fround(f6 * f7));
   f15 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f6 = Math_fround(f6 * f15);
   f9 = Math_fround(HEAPF32[i35 + 80 >> 2]);
   f34 = Math_fround(f6 - Math_fround(f34 * f9));
   f15 = Math_fround(Math_fround(f7 * f9) - Math_fround(f11 * f15));
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i35 + 64 >> 2]));
   f34 = Math_fround(Math_fround(HEAPF32[i35 + 68 >> 2]) + f34);
   f15 = Math_fround(f15 + Math_fround(HEAPF32[i35 + 72 >> 2]));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   f15 = Math_fround(f5 * Math_fround(HEAPF32[i35 + 124 >> 2]));
  } else {
   i1 = 0;
   i4 = 0;
   i10 = 0;
   f15 = Math_fround(0.0);
  }
  f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f6 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f7 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f11 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f20 * f6) + Math_fround(f21 * f9)));
  f5 = Math_fround(f11 - f13);
  L47 : do if (f5 < Math_fround(-9.99999997e-07)) {
   f13 = Math_fround(f19 + f15);
   f14 = Math_fround(Math_fround(Math_fround(f14 + Math_fround(1.0)) * f5) / f13);
   if (!(HEAP8[i23 + 104 >> 0] | 0)) {
    f7 = Math_fround(f14 * f18);
    f6 = Math_fround(f14 * f20);
    f5 = Math_fround(f14 * f21);
   } else {
    f9 = Math_fround(f9 - Math_fround(f21 * f11));
    f6 = Math_fround(f6 - Math_fround(f20 * f11));
    f5 = Math_fround(f7 - Math_fround(f18 * f11));
    f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f9 * f9) + Math_fround(f6 * f6)))));
    if (f7 > Math_fround(0.0)) {
     f34 = Math_fround(Math_fround(1.0) / f7);
     f5 = Math_fround(f5 * f34);
     f6 = Math_fround(f6 * f34);
     f9 = Math_fround(f9 * f34);
    }
    f34 = Math_fround(f7 / f13);
    i35 = !(Math_fround(Math_abs(Math_fround(f16 * f14))) >= f34);
    f7 = Math_fround(-Math_fround(f17 * f14));
    f34 = i35 ? f7 : f34;
    f7 = Math_fround(Math_fround(f5 * f34) + Math_fround(f14 * f18));
    f6 = Math_fround(Math_fround(f14 * f20) + Math_fround(f6 * f34));
    f5 = Math_fround(Math_fround(f14 * f21) + Math_fround(f9 * f34));
   }
   if (f14 < Math_fround(0.0)) {
    HEAPF32[i23 + 96 >> 2] = Math_fround(-f14);
    if (i25) {
     if (!(HEAP16[(HEAP32[i29 + 60 >> 2] | 0) + 2 >> 1] | 0)) i22 = 42;
    } else i22 = 42;
    do if ((i22 | 0) == 42) {
     if (i24) if (HEAP16[(HEAP32[i27 + 60 >> 2] | 0) + 2 >> 1] | 0) break;
     if (i25) {
      i35 = HEAP32[i29 + 64 >> 2] | 0;
      i12 = i35 + 64 | 0;
      HEAP32[i29 >> 2] = HEAP32[i12 >> 2];
      i22 = i35 + 68 | 0;
      HEAP32[i29 + 4 >> 2] = HEAP32[i22 >> 2];
      i35 = i35 + 72 | 0;
      HEAP32[i29 + 8 >> 2] = HEAP32[i35 >> 2];
      f21 = Math_fround(f19 * f5);
      f33 = Math_fround(f19 * f6);
      f34 = Math_fround(f19 * f7);
      f21 = Math_fround(f21 + Math_fround(HEAPF32[i12 >> 2]));
      f33 = Math_fround(f33 + Math_fround(HEAPF32[i22 >> 2]));
      f34 = Math_fround(f34 + Math_fround(HEAPF32[i35 >> 2]));
      HEAPF32[i12 >> 2] = f21;
      HEAPF32[i22 >> 2] = f33;
      HEAPF32[i35 >> 2] = f34;
     }
     if (!i24) break L47;
     i35 = HEAP32[i27 + 64 >> 2] | 0;
     i12 = i35 + 64 | 0;
     HEAP32[i27 >> 2] = HEAP32[i12 >> 2];
     i22 = i35 + 68 | 0;
     HEAP32[i27 + 4 >> 2] = HEAP32[i22 >> 2];
     i35 = i35 + 72 | 0;
     HEAP32[i27 + 8 >> 2] = HEAP32[i35 >> 2];
     f21 = Math_fround(f15 * f5);
     f33 = Math_fround(f15 * f6);
     f34 = Math_fround(f15 * f7);
     f21 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f21);
     f33 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f33);
     f34 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f34);
     HEAPF32[i12 >> 2] = f21;
     HEAPF32[i22 >> 2] = f33;
     HEAPF32[i35 >> 2] = f34;
     break L47;
    } while (0);
    HEAPF32[i23 + 32 >> 2] = Math_fround(0.0);
   }
  } while (0);
  if (i25) {
   i3 = i29 + 60 | 0;
   if (!(HEAP16[(HEAP32[i3 >> 2] | 0) + 2 >> 1] | 0)) {
    i1 = HEAP32[i29 + 64 >> 2] | 0;
    if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
     f34 = Math_fround(Math_fround(1.0) - f2);
     i35 = i29 + 48 | 0;
     f19 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
     i22 = i29 + 52 | 0;
     f20 = Math_fround(f34 * Math_fround(HEAPF32[i22 >> 2]));
     i12 = i29 + 56 | 0;
     f34 = Math_fround(f34 * Math_fround(HEAPF32[i12 >> 2]));
     f21 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
     f33 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
     f21 = Math_fround(f19 + f21);
     f33 = Math_fround(f20 + f33);
     f34 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
     HEAPF32[i35 >> 2] = f21;
     HEAPF32[i22 >> 2] = f33;
     HEAPF32[i12 >> 2] = f34;
     HEAP32[i30 >> 2] = HEAP32[i29 + 32 >> 2];
     i12 = i29 + 36 | 0;
     HEAP32[i30 + 4 >> 2] = HEAP32[i12 >> 2];
     i22 = i29 + 40 | 0;
     HEAP32[i30 + 8 >> 2] = HEAP32[i22 >> 2];
     i35 = i29 + 44 | 0;
     HEAP32[i30 + 12 >> 2] = HEAP32[i35 >> 2];
     HEAPF32[i30 + 16 >> 2] = f21;
     HEAPF32[i30 + 20 >> 2] = f33;
     HEAPF32[i30 + 24 >> 2] = f34;
     __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
     HEAP32[i29 + 32 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i31 + 8 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i31 + 12 >> 2];
    }
    if (i26) i1 = Math_fround(HEAPF32[i23 + 32 >> 2]) == Math_fround(0.0); else i1 = 0;
    __ZN5physx12PxsRigidBody12advanceToToiEffb(i29, f2, f28, i1);
    i35 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
   }
  }
  if (i24) {
   i3 = i27 + 60 | 0;
   if (!(HEAP16[(HEAP32[i3 >> 2] | 0) + 2 >> 1] | 0)) {
    i1 = HEAP32[i27 + 64 >> 2] | 0;
    if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
     f34 = Math_fround(Math_fround(1.0) - f2);
     i35 = i27 + 48 | 0;
     f19 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
     i22 = i27 + 52 | 0;
     f20 = Math_fround(f34 * Math_fround(HEAPF32[i22 >> 2]));
     i12 = i27 + 56 | 0;
     f34 = Math_fround(f34 * Math_fround(HEAPF32[i12 >> 2]));
     f21 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
     f33 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
     f21 = Math_fround(f19 + f21);
     f33 = Math_fround(f20 + f33);
     f34 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
     HEAPF32[i35 >> 2] = f21;
     HEAPF32[i22 >> 2] = f33;
     HEAPF32[i12 >> 2] = f34;
     HEAP32[i30 >> 2] = HEAP32[i27 + 32 >> 2];
     i12 = i27 + 36 | 0;
     HEAP32[i30 + 4 >> 2] = HEAP32[i12 >> 2];
     i22 = i27 + 40 | 0;
     HEAP32[i30 + 8 >> 2] = HEAP32[i22 >> 2];
     i35 = i27 + 44 | 0;
     HEAP32[i30 + 12 >> 2] = HEAP32[i35 >> 2];
     HEAPF32[i30 + 16 >> 2] = f21;
     HEAPF32[i30 + 20 >> 2] = f33;
     HEAPF32[i30 + 24 >> 2] = f34;
     __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
     HEAP32[i27 + 32 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i31 + 8 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i31 + 12 >> 2];
    }
    if (i26) i1 = Math_fround(HEAPF32[i23 + 32 >> 2]) == Math_fround(0.0); else i1 = 0;
    __ZN5physx12PxsRigidBody12advanceToToiEffb(i27, f2, f28, i1);
    i35 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
    HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
   }
  }
  i3 = i23 + 32 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  if (f2 > Math_fround(0.0)) {
   if (i25) if (!(HEAP16[(HEAP32[i29 + 60 >> 2] | 0) + 2 >> 1] | 0)) {
    i1 = HEAP32[i29 + 64 >> 2] | 0;
    if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
     f34 = Math_fround(Math_fround(1.0) - f2);
     i35 = i29 + 48 | 0;
     f19 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
     i23 = i29 + 52 | 0;
     f20 = Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2]));
     i22 = i29 + 56 | 0;
     f34 = Math_fround(f34 * Math_fround(HEAPF32[i22 >> 2]));
     f21 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
     f33 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
     f21 = Math_fround(f19 + f21);
     f33 = Math_fround(f20 + f33);
     f34 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
     HEAPF32[i35 >> 2] = f21;
     HEAPF32[i23 >> 2] = f33;
     HEAPF32[i22 >> 2] = f34;
     HEAP32[i30 >> 2] = HEAP32[i29 + 32 >> 2];
     i22 = i29 + 36 | 0;
     HEAP32[i30 + 4 >> 2] = HEAP32[i22 >> 2];
     i23 = i29 + 40 | 0;
     HEAP32[i30 + 8 >> 2] = HEAP32[i23 >> 2];
     i35 = i29 + 44 | 0;
     HEAP32[i30 + 12 >> 2] = HEAP32[i35 >> 2];
     HEAPF32[i30 + 16 >> 2] = f21;
     HEAPF32[i30 + 20 >> 2] = f33;
     HEAPF32[i30 + 24 >> 2] = f34;
     __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
     HEAP32[i29 + 32 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i23 >> 2] = HEAP32[i31 + 8 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i31 + 12 >> 2];
    }
    if (i26) __ZN5physx12PxsRigidBody12advanceToToiEffb(i29, Math_fround(HEAPF32[i3 >> 2]), f28, 1);
   }
   if (i24) if (!(HEAP16[(HEAP32[i27 + 60 >> 2] | 0) + 2 >> 1] | 0)) {
    f2 = Math_fround(HEAPF32[i3 >> 2]);
    i1 = HEAP32[i27 + 64 >> 2] | 0;
    if (!(Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0))) {
     f34 = Math_fround(Math_fround(1.0) - f2);
     i35 = i27 + 48 | 0;
     f19 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
     i23 = i27 + 52 | 0;
     f20 = Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2]));
     i22 = i27 + 56 | 0;
     f34 = Math_fround(f34 * Math_fround(HEAPF32[i22 >> 2]));
     f21 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2]));
     f33 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2]));
     f21 = Math_fround(f19 + f21);
     f33 = Math_fround(f20 + f33);
     f34 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 24 >> 2])));
     HEAPF32[i35 >> 2] = f21;
     HEAPF32[i23 >> 2] = f33;
     HEAPF32[i22 >> 2] = f34;
     HEAP32[i30 >> 2] = HEAP32[i27 + 32 >> 2];
     i22 = i27 + 36 | 0;
     HEAP32[i30 + 4 >> 2] = HEAP32[i22 >> 2];
     i23 = i27 + 40 | 0;
     HEAP32[i30 + 8 >> 2] = HEAP32[i23 >> 2];
     i35 = i27 + 44 | 0;
     HEAP32[i30 + 12 >> 2] = HEAP32[i35 >> 2];
     HEAPF32[i30 + 16 >> 2] = f21;
     HEAPF32[i30 + 20 >> 2] = f33;
     HEAPF32[i30 + 24 >> 2] = f34;
     __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i1);
     HEAP32[i27 + 32 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i23 >> 2] = HEAP32[i31 + 8 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i31 + 12 >> 2];
    }
    if (i26) __ZN5physx12PxsRigidBody12advanceToToiEffb(i27, Math_fround(HEAPF32[i3 >> 2]), f28, 1);
   }
  }
  if (i25) HEAP16[(HEAP32[i29 + 60 >> 2] | 0) + 2 >> 1] = 1;
  if (!i24) {
   i35 = 1;
   STACKTOP = i32;
   return i35 | 0;
  }
  HEAP16[(HEAP32[i27 + 60 >> 2] | 0) + 2 >> 1] = 1;
  i35 = 1;
  STACKTOP = i32;
  return i35 | 0;
 }
 if (i1) {
  i35 = 1;
  STACKTOP = i32;
  return i35 | 0;
 }
 i4 = i29 + 60 | 0;
 if (HEAP16[(HEAP32[i4 >> 2] | 0) + 2 >> 1] | 0) {
  i35 = 1;
  STACKTOP = i32;
  return i35 | 0;
 }
 i1 = i29 + 64 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(Math_fround(HEAPF32[i3 + 124 >> 2]) == Math_fround(0.0))) {
  f34 = Math_fround(Math_fround(1.0) - f2);
  i35 = i29 + 48 | 0;
  f20 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
  i27 = i29 + 52 | 0;
  f21 = Math_fround(f34 * Math_fround(HEAPF32[i27 >> 2]));
  i26 = i29 + 56 | 0;
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i26 >> 2]));
  f28 = Math_fround(f2 * Math_fround(HEAPF32[i3 + 16 >> 2]));
  f33 = Math_fround(f2 * Math_fround(HEAPF32[i3 + 20 >> 2]));
  f28 = Math_fround(f20 + f28);
  f33 = Math_fround(f21 + f33);
  f34 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i3 + 24 >> 2])));
  HEAPF32[i35 >> 2] = f28;
  HEAPF32[i27 >> 2] = f33;
  HEAPF32[i26 >> 2] = f34;
  HEAP32[i30 >> 2] = HEAP32[i29 + 32 >> 2];
  i26 = i29 + 36 | 0;
  HEAP32[i30 + 4 >> 2] = HEAP32[i26 >> 2];
  i27 = i29 + 40 | 0;
  HEAP32[i30 + 8 >> 2] = HEAP32[i27 >> 2];
  i35 = i29 + 44 | 0;
  HEAP32[i30 + 12 >> 2] = HEAP32[i35 >> 2];
  HEAPF32[i30 + 16 >> 2] = f28;
  HEAPF32[i30 + 20 >> 2] = f33;
  HEAPF32[i30 + 24 >> 2] = f34;
  __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i31, f2, i30, i3);
  HEAP32[i29 + 32 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i26 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i35 >> 2] = HEAP32[i31 + 12 >> 2];
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (Math_fround(HEAPF32[i1 + 124 >> 2]) == Math_fround(0.0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i31 = HEAP32[i29 + 52 >> 2] | 0;
  i30 = HEAP32[i29 + 56 >> 2] | 0;
  HEAP32[i1 + 16 >> 2] = HEAP32[i29 + 48 >> 2];
  HEAP32[i1 + 20 >> 2] = i31;
  HEAP32[i1 + 24 >> 2] = i30;
  i30 = HEAP32[i29 + 36 >> 2] | 0;
  i31 = HEAP32[i29 + 40 >> 2] | 0;
  i35 = HEAP32[i29 + 44 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i29 + 32 >> 2];
  HEAP32[i1 + 4 >> 2] = i30;
  HEAP32[i1 + 8 >> 2] = i31;
  HEAP32[i1 + 12 >> 2] = i35;
  f34 = Math_fround(Math_fround(1.0) - f2);
  i1 = HEAP32[i4 >> 2] | 0;
  i35 = i1 + 4 | 0;
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i35 >> 2]));
  i31 = f34 > Math_fround(.00999999977);
  HEAPF32[i35 >> 2] = i31 ? f34 : Math_fround(.00999999977);
 }
 i35 = i1 + 16 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
 i35 = 1;
 STACKTOP = i32;
 return i35 | 0;
}

function __ZN5physx7NpShape9visualizeERNS_2Cm12RenderOutputERKNS_12PxRigidActorE(i22, i20, i1) {
 i22 = i22 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i29 + 440 | 0;
 i3 = i29 + 368 | 0;
 i4 = i29 + 304 | 0;
 i6 = i29 + 272 | 0;
 i7 = i29 + 248 | 0;
 i8 = i29 + 184 | 0;
 i9 = i29 + 160 | 0;
 i21 = i29 + 472 | 0;
 i23 = i29 + 152 | 0;
 i24 = i29 + 148 | 0;
 i25 = i29 + 136 | 0;
 i26 = i29 + 120 | 0;
 i27 = i29 + 400 | 0;
 i17 = i29 + 72 | 0;
 i18 = i29 + 24 | 0;
 i28 = i29;
 i11 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 f10 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 0));
 if (!(f10 != Math_fround(0.0))) {
  STACKTOP = i29;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = i22 + 36 | 0;
 i5 = i22 + 40 | 0;
 i12 = (HEAP32[i1 >> 2] & 4 | 0) == 0 ? i22 + 80 | 0 : HEAP32[i5 >> 2] | 0;
 f39 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) * Math_fround(2.0));
 f42 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f41 = Math_fround(Math_fround(f42 * f42) + Math_fround(-.5));
 f40 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(f39 * f40);
 f38 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f37 * f38));
 f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f32 * f36));
 f31 = Math_fround(Math_fround(f40 * f2) + Math_fround(Math_fround(f39 * f41) + Math_fround(f42 * Math_fround(Math_fround(f32 * f38) - Math_fround(f37 * f36)))));
 f30 = Math_fround(Math_fround(f38 * f2) + Math_fround(Math_fround(f37 * f41) + Math_fround(f42 * Math_fround(Math_fround(f39 * f36) - Math_fround(f32 * f40)))));
 f2 = Math_fround(Math_fround(Math_fround(f32 * f41) + Math_fround(f42 * Math_fround(Math_fround(f37 * f40) - Math_fround(f39 * f38)))) + Math_fround(f36 * f2));
 f31 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f31);
 f30 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f30);
 f2 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f2);
 f39 = Math_fround(HEAPF32[i12 >> 2]);
 f37 = Math_fround(f42 * f39);
 f41 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f37 = Math_fround(f37 + Math_fround(f40 * f41));
 f32 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f37 = Math_fround(f37 + Math_fround(f38 * f32));
 f35 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f34 = Math_fround(Math_fround(Math_fround(f36 * f39) + Math_fround(Math_fround(f38 * f41) + Math_fround(f42 * f35))) - Math_fround(f40 * f32));
 f33 = Math_fround(Math_fround(Math_fround(f40 * f35) + Math_fround(Math_fround(f36 * f41) + Math_fround(f42 * f32))) - Math_fround(f38 * f39));
 f32 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f41) - Math_fround(f40 * f39)) - Math_fround(f38 * f35)) - Math_fround(f36 * f32));
 HEAPF32[i19 >> 2] = Math_fround(f37 - Math_fround(f36 * f35));
 i12 = i19 + 4 | 0;
 HEAPF32[i12 >> 2] = f34;
 i13 = i19 + 8 | 0;
 HEAPF32[i13 >> 2] = f33;
 i14 = i19 + 12 | 0;
 HEAPF32[i14 >> 2] = f32;
 HEAPF32[i19 + 16 >> 2] = f31;
 i15 = i19 + 20 | 0;
 HEAPF32[i15 >> 2] = f30;
 i16 = i19 + 24 | 0;
 HEAPF32[i16 >> 2] = f2;
 if (Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 12)) != Math_fround(0.0)) {
  i3 = __ZN5physx2Cm12RenderOutputlsEj(i20, -256) | 0;
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  i43 = i4 + 4 | 0;
  HEAP32[i43 >> 2] = 0;
  HEAP32[i43 + 4 >> 2] = 0;
  HEAP32[i43 + 8 >> 2] = 0;
  HEAP32[i43 + 12 >> 2] = 0;
  HEAPF32[i4 + 20 >> 2] = Math_fround(1.0);
  i43 = i4 + 24 | 0;
  HEAP32[i43 >> 2] = 0;
  HEAP32[i43 + 4 >> 2] = 0;
  HEAP32[i43 + 8 >> 2] = 0;
  HEAP32[i43 + 12 >> 2] = 0;
  HEAPF32[i4 + 40 >> 2] = Math_fround(1.0);
  i43 = i4 + 44 | 0;
  HEAP32[i43 >> 2] = 0;
  HEAP32[i43 + 4 >> 2] = 0;
  HEAP32[i43 + 8 >> 2] = 0;
  HEAP32[i43 + 12 >> 2] = 0;
  HEAPF32[i4 + 60 >> 2] = Math_fround(1.0);
  i3 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i3, i4) | 0;
  if (!(HEAP32[i1 >> 2] & 1)) i1 = i22 + 116 | 0; else i1 = (HEAP32[i5 >> 2] | 0) + 56 | 0;
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1, i7, i19, Math_fround(0.0), 0);
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP8[i6 + 24 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i3, i6) | 0;
 }
 f2 = Math_fround(f10 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 14)));
 if (f2 != Math_fround(0.0)) {
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i8, i19);
  i43 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i20, i8) | 0;
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i9 + 4 >> 2] = f2;
  HEAPF32[i9 + 8 >> 2] = f2;
  HEAP32[i9 + 12 >> 2] = 13565952;
  HEAP32[i9 + 16 >> 2] = 52992;
  HEAP32[i9 + 20 >> 2] = 207;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i43, i9) | 0;
 }
 if (!(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 13)) != Math_fround(0.0))) if (!(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 16)) != Math_fround(0.0))) if (!(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 17)) != Math_fround(0.0))) {
  STACKTOP = i29;
  return;
 }
 i6 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 304 >> 2] | 0, i11 | 0) | 0;
 f2 = Math_fround(f10 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 16)));
 i5 = _bitshift64Shl(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 30)) != Math_fround(0.0) | 0, 0, 30) | 0;
 i3 = getTempRet0() | 0;
 i43 = _bitshift64Shl(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 16)) != Math_fround(0.0) | 0, 0, 16) | 0;
 i3 = getTempRet0() | 0 | i3;
 i4 = _bitshift64Shl(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 17)) != Math_fround(0.0) | 0, 0, 17) | 0;
 i3 = i3 | (getTempRet0() | 0);
 i1 = _bitshift64Shl(Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 13)) != Math_fround(0.0) | 0, 0, 13) | 0;
 i1 = i43 | i5 | i4 | i1;
 i3 = i3 | (getTempRet0() | 0);
 f37 = Math_fround(HEAPF32[i19 >> 2]);
 f41 = Math_fround(f37 + f37);
 f39 = Math_fround(HEAPF32[i12 >> 2]);
 f42 = Math_fround(f39 + f39);
 f33 = Math_fround(HEAPF32[i13 >> 2]);
 f36 = Math_fround(f33 + f33);
 f35 = Math_fround(HEAPF32[i14 >> 2]);
 f40 = Math_fround(f41 * f35);
 f38 = Math_fround(f42 * f35);
 f35 = Math_fround(f35 * f36);
 f41 = Math_fround(f37 * f41);
 f34 = Math_fround(f37 * f42);
 f37 = Math_fround(f37 * f36);
 f42 = Math_fround(f39 * f42);
 f39 = Math_fround(f39 * f36);
 f36 = Math_fround(f33 * f36);
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f42) - f36);
 HEAPF32[i21 + 4 >> 2] = Math_fround(f34 + f35);
 HEAPF32[i21 + 8 >> 2] = Math_fround(f37 - f38);
 HEAPF32[i21 + 12 >> 2] = Math_fround(f34 - f35);
 f41 = Math_fround(Math_fround(1.0) - f41);
 HEAPF32[i21 + 16 >> 2] = Math_fround(f41 - f36);
 HEAPF32[i21 + 20 >> 2] = Math_fround(f39 + f40);
 HEAPF32[i21 + 24 >> 2] = Math_fround(f37 + f38);
 HEAPF32[i21 + 28 >> 2] = Math_fround(f39 - f40);
 HEAPF32[i21 + 32 >> 2] = Math_fround(f41 - f42);
 i4 = i19 + 16 | 0;
 HEAP32[i21 + 36 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i21 + 40 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i21 + 44 >> 2] = HEAP32[i16 >> 2];
 i5 = (__ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i22 + 48 | 0) | 0) & 65535;
 switch (mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0) {
 case 0:
  {
   HEAP32[i23 >> 2] = 0;
   HEAPF32[i23 + 4 >> 2] = Math_fround(0.0);
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 40 >> 2] | 0, i22 | 0, i23 | 0) | 0;
   __ZN5physx2Gu5Debug9visualizeERKNS_16PxSphereGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i23, i20, i21, i6, i1, i3, f2, i5);
   break;
  }
 case 1:
  {
   HEAP32[i24 >> 2] = 1;
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 48 >> 2] | 0, i22 | 0, i24 | 0) | 0;
   __ZN5physx2Gu5Debug9visualizeERKNS_15PxPlaneGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i24, i20, i21, i6, i1, i3, f2, i5);
   break;
  }
 case 2:
  {
   HEAP32[i25 >> 2] = 2;
   HEAPF32[i25 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i25 + 8 >> 2] = Math_fround(0.0);
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 44 >> 2] | 0, i22 | 0, i25 | 0) | 0;
   __ZN5physx2Gu5Debug9visualizeERKNS_17PxCapsuleGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i25, i20, i21, i6, i1, i3, f2, i5);
   break;
  }
 case 3:
  {
   HEAP32[i26 >> 2] = 3;
   HEAPF32[i26 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i26 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0, i26 | 0) | 0;
   __ZN5physx2Gu5Debug9visualizeERKNS_13PxBoxGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i26, i20, i21, i6, i1, i3, f2, i5);
   break;
  }
 case 4:
  {
   HEAP32[i27 >> 2] = 4;
   i43 = i27 + 4 | 0;
   HEAPF32[i43 >> 2] = Math_fround(1.0);
   HEAPF32[i27 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i27 + 12 >> 2] = Math_fround(1.0);
   i24 = i27 + 16 | 0;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   i25 = i27 + 20 | 0;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i26 = i27 + 24 | 0;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   i28 = i27 + 28 | 0;
   HEAPF32[i28 >> 2] = Math_fround(1.0);
   HEAP32[i27 + 32 >> 2] = 0;
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 52 >> 2] | 0, i22 | 0, i27 | 0) | 0;
   f44 = Math_fround(HEAPF32[i19 >> 2]);
   f58 = Math_fround(HEAPF32[i12 >> 2]);
   f36 = Math_fround(HEAPF32[i13 >> 2]);
   f33 = Math_fround(HEAPF32[i14 >> 2]);
   f51 = Math_fround(f44 + f44);
   f10 = Math_fround(f58 + f58);
   f31 = Math_fround(f36 + f36);
   f48 = Math_fround(f58 * f10);
   f41 = Math_fround(f36 * f31);
   f58 = Math_fround(f51 * f58);
   f56 = Math_fround(f51 * f36);
   f50 = Math_fround(f51 * f33);
   f36 = Math_fround(f10 * f36);
   f10 = Math_fround(f10 * f33);
   f33 = Math_fround(f31 * f33);
   f31 = Math_fround(Math_fround(Math_fround(1.0) - f48) - f41);
   f49 = Math_fround(f58 + f33);
   f46 = Math_fround(f56 - f10);
   f33 = Math_fround(f58 - f33);
   f51 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f51));
   f41 = Math_fround(f51 - f41);
   f44 = Math_fround(f36 + f50);
   f10 = Math_fround(f56 + f10);
   f50 = Math_fround(f36 - f50);
   f48 = Math_fround(f51 - f48);
   f51 = Math_fround(HEAPF32[i24 >> 2]);
   f36 = Math_fround(HEAPF32[i25 >> 2]);
   f56 = Math_fround(HEAPF32[i26 >> 2]);
   f58 = Math_fround(HEAPF32[i28 >> 2]);
   f38 = Math_fround(f51 + f51);
   f52 = Math_fround(f36 + f36);
   f39 = Math_fround(f56 + f56);
   f35 = Math_fround(f36 * f52);
   f57 = Math_fround(f56 * f39);
   f36 = Math_fround(f38 * f36);
   f54 = Math_fround(f38 * f56);
   f37 = Math_fround(f38 * f58);
   f56 = Math_fround(f52 * f56);
   f52 = Math_fround(f52 * f58);
   f58 = Math_fround(f39 * f58);
   f39 = Math_fround(Math_fround(Math_fround(1.0) - f35) - f57);
   f40 = Math_fround(f36 + f58);
   f30 = Math_fround(f54 - f52);
   f58 = Math_fround(f36 - f58);
   f38 = Math_fround(Math_fround(1.0) - Math_fround(f51 * f38));
   f57 = Math_fround(f38 - f57);
   f51 = Math_fround(f56 + f37);
   f52 = Math_fround(f54 + f52);
   f37 = Math_fround(f56 - f37);
   f35 = Math_fround(f38 - f35);
   f38 = Math_fround(HEAPF32[i43 >> 2]);
   f56 = Math_fround(f38 * f39);
   f54 = Math_fround(f38 * f58);
   f38 = Math_fround(f38 * f52);
   f36 = Math_fround(HEAPF32[i43 + 4 >> 2]);
   f55 = Math_fround(f40 * f36);
   f53 = Math_fround(f57 * f36);
   f36 = Math_fround(f37 * f36);
   f47 = Math_fround(HEAPF32[i43 + 8 >> 2]);
   f45 = Math_fround(f30 * f47);
   f42 = Math_fround(f51 * f47);
   f47 = Math_fround(f35 * f47);
   f32 = Math_fround(Math_fround(Math_fround(f39 * f56) + Math_fround(f40 * f55)) + Math_fround(f30 * f45));
   f34 = Math_fround(Math_fround(Math_fround(f39 * f54) + Math_fround(f40 * f53)) + Math_fround(f30 * f42));
   f30 = Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(f40 * f36)) + Math_fround(f30 * f47));
   f40 = Math_fround(Math_fround(Math_fround(f58 * f56) + Math_fround(f57 * f55)) + Math_fround(f51 * f45));
   f39 = Math_fround(Math_fround(Math_fround(f58 * f54) + Math_fround(f57 * f53)) + Math_fround(f51 * f42));
   f51 = Math_fround(Math_fround(Math_fround(f58 * f38) + Math_fround(f57 * f36)) + Math_fround(f51 * f47));
   f45 = Math_fround(Math_fround(Math_fround(f52 * f56) + Math_fround(f37 * f55)) + Math_fround(f35 * f45));
   f42 = Math_fround(Math_fround(Math_fround(f52 * f54) + Math_fround(f37 * f53)) + Math_fround(f35 * f42));
   f47 = Math_fround(Math_fround(Math_fround(f52 * f38) + Math_fround(f37 * f36)) + Math_fround(f35 * f47));
   f35 = Math_fround(Math_fround(f50 * f30) + Math_fround(Math_fround(f49 * f32) + Math_fround(f41 * f34)));
   f36 = Math_fround(Math_fround(f48 * f30) + Math_fround(Math_fround(f46 * f32) + Math_fround(f44 * f34)));
   f37 = Math_fround(Math_fround(f10 * f51) + Math_fround(Math_fround(f31 * f40) + Math_fround(f33 * f39)));
   f38 = Math_fround(Math_fround(f50 * f51) + Math_fround(Math_fround(f49 * f40) + Math_fround(f41 * f39)));
   f39 = Math_fround(Math_fround(f48 * f51) + Math_fround(Math_fround(f46 * f40) + Math_fround(f44 * f39)));
   f40 = Math_fround(Math_fround(f10 * f47) + Math_fround(Math_fround(f31 * f45) + Math_fround(f33 * f42)));
   f41 = Math_fround(Math_fround(f50 * f47) + Math_fround(Math_fround(f49 * f45) + Math_fround(f41 * f42)));
   f42 = Math_fround(Math_fround(f48 * f47) + Math_fround(Math_fround(f46 * f45) + Math_fround(f44 * f42)));
   HEAPF32[i17 >> 2] = Math_fround(Math_fround(f10 * f30) + Math_fround(Math_fround(f31 * f32) + Math_fround(f33 * f34)));
   HEAPF32[i17 + 4 >> 2] = f35;
   HEAPF32[i17 + 8 >> 2] = f36;
   HEAPF32[i17 + 12 >> 2] = f37;
   HEAPF32[i17 + 16 >> 2] = f38;
   HEAPF32[i17 + 20 >> 2] = f39;
   HEAPF32[i17 + 24 >> 2] = f40;
   HEAPF32[i17 + 28 >> 2] = f41;
   HEAPF32[i17 + 32 >> 2] = f42;
   HEAP32[i17 + 36 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i17 + 40 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 44 >> 2] = HEAP32[i16 >> 2];
   __ZN5physx2Gu5Debug9visualizeERKNS_20PxConvexMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i27, i20, i17, i6, i1, i3, f2, i5);
   break;
  }
 case 5:
  {
   HEAP32[i27 >> 2] = 5;
   i43 = i27 + 4 | 0;
   HEAPF32[i43 >> 2] = Math_fround(1.0);
   HEAPF32[i27 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i27 + 12 >> 2] = Math_fround(1.0);
   i24 = i27 + 16 | 0;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   i25 = i27 + 20 | 0;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i26 = i27 + 24 | 0;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   i28 = i27 + 28 | 0;
   HEAPF32[i28 >> 2] = Math_fround(1.0);
   i23 = i27 + 32 | 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 56 >> 2] | 0, i22 | 0, i27 | 0) | 0;
   f44 = Math_fround(HEAPF32[i19 >> 2]);
   f10 = Math_fround(HEAPF32[i12 >> 2]);
   f52 = Math_fround(HEAPF32[i13 >> 2]);
   f49 = Math_fround(HEAPF32[i14 >> 2]);
   f36 = Math_fround(f44 + f44);
   f45 = Math_fround(f10 + f10);
   f47 = Math_fround(f52 + f52);
   f39 = Math_fround(f10 * f45);
   f57 = Math_fround(f52 * f47);
   f10 = Math_fround(f36 * f10);
   f31 = Math_fround(f36 * f52);
   f37 = Math_fround(f36 * f49);
   f52 = Math_fround(f45 * f52);
   f45 = Math_fround(f45 * f49);
   f49 = Math_fround(f47 * f49);
   f47 = Math_fround(Math_fround(Math_fround(1.0) - f39) - f57);
   f38 = Math_fround(f10 + f49);
   f41 = Math_fround(f31 - f45);
   f49 = Math_fround(f10 - f49);
   f36 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f36));
   f57 = Math_fround(f36 - f57);
   f44 = Math_fround(f52 + f37);
   f45 = Math_fround(f31 + f45);
   f37 = Math_fround(f52 - f37);
   f39 = Math_fround(f36 - f39);
   f36 = Math_fround(HEAPF32[i24 >> 2]);
   f52 = Math_fround(HEAPF32[i25 >> 2]);
   f31 = Math_fround(HEAPF32[i26 >> 2]);
   f10 = Math_fround(HEAPF32[i28 >> 2]);
   f54 = Math_fround(f36 + f36);
   f35 = Math_fround(f52 + f52);
   f55 = Math_fround(f31 + f31);
   f51 = Math_fround(f52 * f35);
   f30 = Math_fround(f31 * f55);
   f52 = Math_fround(f54 * f52);
   f33 = Math_fround(f54 * f31);
   f53 = Math_fround(f54 * f10);
   f31 = Math_fround(f35 * f31);
   f35 = Math_fround(f35 * f10);
   f10 = Math_fround(f55 * f10);
   f55 = Math_fround(Math_fround(Math_fround(1.0) - f51) - f30);
   f56 = Math_fround(f52 + f10);
   f46 = Math_fround(f33 - f35);
   f10 = Math_fround(f52 - f10);
   f54 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f54));
   f30 = Math_fround(f54 - f30);
   f36 = Math_fround(f31 + f53);
   f35 = Math_fround(f33 + f35);
   f53 = Math_fround(f31 - f53);
   f51 = Math_fround(f54 - f51);
   f54 = Math_fround(HEAPF32[i43 >> 2]);
   f31 = Math_fround(f54 * f55);
   f33 = Math_fround(f54 * f10);
   f54 = Math_fround(f54 * f35);
   f52 = Math_fround(HEAPF32[i43 + 4 >> 2]);
   f32 = Math_fround(f56 * f52);
   f34 = Math_fround(f30 * f52);
   f52 = Math_fround(f53 * f52);
   f40 = Math_fround(HEAPF32[i43 + 8 >> 2]);
   f42 = Math_fround(f46 * f40);
   f58 = Math_fround(f36 * f40);
   f40 = Math_fround(f51 * f40);
   f48 = Math_fround(Math_fround(Math_fround(f55 * f31) + Math_fround(f56 * f32)) + Math_fround(f46 * f42));
   f50 = Math_fround(Math_fround(Math_fround(f55 * f33) + Math_fround(f56 * f34)) + Math_fround(f46 * f58));
   f46 = Math_fround(Math_fround(Math_fround(f55 * f54) + Math_fround(f56 * f52)) + Math_fround(f46 * f40));
   f56 = Math_fround(Math_fround(Math_fround(f10 * f31) + Math_fround(f30 * f32)) + Math_fround(f36 * f42));
   f55 = Math_fround(Math_fround(Math_fround(f10 * f33) + Math_fround(f30 * f34)) + Math_fround(f36 * f58));
   f36 = Math_fround(Math_fround(Math_fround(f10 * f54) + Math_fround(f30 * f52)) + Math_fround(f36 * f40));
   f42 = Math_fround(Math_fround(Math_fround(f35 * f31) + Math_fround(f53 * f32)) + Math_fround(f51 * f42));
   f58 = Math_fround(Math_fround(Math_fround(f35 * f33) + Math_fround(f53 * f34)) + Math_fround(f51 * f58));
   f40 = Math_fround(Math_fround(Math_fround(f35 * f54) + Math_fround(f53 * f52)) + Math_fround(f51 * f40));
   f51 = Math_fround(Math_fround(f37 * f46) + Math_fround(Math_fround(f38 * f48) + Math_fround(f57 * f50)));
   f52 = Math_fround(Math_fround(f39 * f46) + Math_fround(Math_fround(f41 * f48) + Math_fround(f44 * f50)));
   f53 = Math_fround(Math_fround(f45 * f36) + Math_fround(Math_fround(f47 * f56) + Math_fround(f49 * f55)));
   f54 = Math_fround(Math_fround(f37 * f36) + Math_fround(Math_fround(f38 * f56) + Math_fround(f57 * f55)));
   f55 = Math_fround(Math_fround(f39 * f36) + Math_fround(Math_fround(f41 * f56) + Math_fround(f44 * f55)));
   f56 = Math_fround(Math_fround(f45 * f40) + Math_fround(Math_fround(f47 * f42) + Math_fround(f49 * f58)));
   f57 = Math_fround(Math_fround(f37 * f40) + Math_fround(Math_fround(f38 * f42) + Math_fround(f57 * f58)));
   f58 = Math_fround(Math_fround(f39 * f40) + Math_fround(Math_fround(f41 * f42) + Math_fround(f44 * f58)));
   HEAPF32[i18 >> 2] = Math_fround(Math_fround(f45 * f46) + Math_fround(Math_fround(f47 * f48) + Math_fround(f49 * f50)));
   HEAPF32[i18 + 4 >> 2] = f51;
   HEAPF32[i18 + 8 >> 2] = f52;
   HEAPF32[i18 + 12 >> 2] = f53;
   HEAPF32[i18 + 16 >> 2] = f54;
   HEAPF32[i18 + 20 >> 2] = f55;
   HEAPF32[i18 + 24 >> 2] = f56;
   HEAPF32[i18 + 28 >> 2] = f57;
   HEAPF32[i18 + 32 >> 2] = f58;
   HEAP32[i18 + 36 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i18 + 40 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i18 + 44 >> 2] = HEAP32[i16 >> 2];
   __ZN5physx2Gu5Debug9visualizeERKNS_22PxTriangleMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i27, i20, i18, i6, i1, i3, f2, i5);
   break;
  }
 case 6:
  {
   HEAP32[i28 >> 2] = 6;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAPF32[i28 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i28 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i28 + 16 >> 2] = Math_fround(1.0);
   HEAP32[i28 + 20 >> 2] = 0;
   mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 60 >> 2] | 0, i22 | 0, i28 | 0) | 0;
   __ZN5physx2Gu5Debug9visualizeERKNS_21PxHeightFieldGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i28, i20, i21, i6, i1, i3, f2, i5);
   break;
  }
 default:
  {}
 }
 STACKTOP = i29;
 return;
}

function __ZN5physx11HullLibrary12calchullpbevEPNS_6float3EiiRNS_12hullLibArray5ArrayINS_5PlaneEEEf(i46, i40, i39, i1, i44, f5) {
 i46 = i46 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i44 = i44 | 0;
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, d37 = 0.0, i38 = 0, i41 = 0, i42 = 0, i43 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i48 + 17 | 0;
 i41 = i48 + 16 | 0;
 i42 = i48;
 i43 = i44 + 4 | 0;
 HEAP32[i43 >> 2] = 0;
 i2 = HEAP32[i46 >> 2] | 0;
 L1 : do if ((HEAP32[i2 + 4 >> 2] | 0) > 0) {
  d37 = +Math_fround(f5 * Math_fround(.0174532924));
  i38 = (i39 | 0) > 1;
  i4 = 0;
  i6 = 0;
  i1 = 0;
  i36 = 0;
  while (1) {
   i35 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i36 << 2) >> 2] | 0;
   if (i35) {
    i7 = HEAP32[i35 >> 2] | 0;
    i33 = HEAP32[i35 + 4 >> 2] | 0;
    i34 = HEAP32[i35 + 8 >> 2] | 0;
    f31 = Math_fround(HEAPF32[i40 + (i7 * 12 | 0) >> 2]);
    f8 = Math_fround(HEAPF32[i40 + (i7 * 12 | 0) + 4 >> 2]);
    f30 = Math_fround(HEAPF32[i40 + (i7 * 12 | 0) + 8 >> 2]);
    f5 = Math_fround(HEAPF32[i40 + (i33 * 12 | 0) >> 2]);
    f32 = Math_fround(HEAPF32[i40 + (i33 * 12 | 0) + 4 >> 2]);
    f9 = Math_fround(HEAPF32[i40 + (i33 * 12 | 0) + 8 >> 2]);
    f29 = Math_fround(HEAPF32[i40 + (i34 * 12 | 0) >> 2]);
    f10 = Math_fround(HEAPF32[i40 + (i34 * 12 | 0) + 4 >> 2]);
    f31 = Math_fround(f5 - f31);
    f8 = Math_fround(f32 - f8);
    f30 = Math_fround(f9 - f30);
    f5 = Math_fround(f29 - f5);
    f32 = Math_fround(f10 - f32);
    f9 = Math_fround(Math_fround(HEAPF32[i40 + (i34 * 12 | 0) + 8 >> 2]) - f9);
    f10 = Math_fround(Math_fround(f8 * f9) - Math_fround(f30 * f32));
    f9 = Math_fround(Math_fround(f30 * f5) - Math_fround(f31 * f9));
    f5 = Math_fround(Math_fround(f31 * f32) - Math_fround(f8 * f5));
    f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)))));
    if (f8 == Math_fround(0.0)) {
     f17 = Math_fround(0.0);
     f16 = Math_fround(0.0);
     f15 = Math_fround(1.0);
    } else {
     f15 = Math_fround(Math_fround(1.0) / f8);
     f17 = Math_fround(f5 * f15);
     f16 = Math_fround(f9 * f15);
     f15 = Math_fround(f10 * f15);
    }
    i33 = i35 + 12 | 0;
    i34 = i35 + 24 | 0;
    i7 = 0;
    do {
     i2 = HEAP32[i33 + (i7 << 2) >> 2] | 0;
     if ((i2 | 0) >= (HEAP32[i34 >> 2] | 0)) {
      i3 = HEAP32[(HEAP32[HEAP32[i46 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
      i49 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = HEAP32[i3 + 8 >> 2] | 0;
      f31 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) >> 2]);
      f8 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 4 >> 2]);
      f30 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) >> 2]);
      f32 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 4 >> 2]);
      f9 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 8 >> 2]);
      f29 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) >> 2]);
      f10 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 4 >> 2]);
      f31 = Math_fround(f5 - f31);
      f8 = Math_fround(f32 - f8);
      f30 = Math_fround(f9 - f30);
      f5 = Math_fround(f29 - f5);
      f32 = Math_fround(f10 - f32);
      f9 = Math_fround(Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 8 >> 2]) - f9);
      f10 = Math_fround(Math_fround(f8 * f9) - Math_fround(f30 * f32));
      f9 = Math_fround(Math_fround(f30 * f5) - Math_fround(f31 * f9));
      f5 = Math_fround(Math_fround(f31 * f32) - Math_fround(f8 * f5));
      f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)))));
      if (f8 == Math_fround(0.0)) {
       f12 = Math_fround(0.0);
       f11 = Math_fround(0.0);
       f8 = Math_fround(1.0);
      } else {
       f8 = Math_fround(Math_fround(1.0) / f8);
       f12 = Math_fround(f5 * f8);
       f11 = Math_fround(f9 * f8);
       f8 = Math_fround(f10 * f8);
      }
      if (!(+Math_fround(Math_fround(Math_fround(f15 * f8) + Math_fround(f16 * f11)) + Math_fround(f17 * f12)) >= +Math_cos(+d37))) {
       i3 = HEAP32[i35 + (((i7 + 2 | 0) % 3 | 0) << 2) >> 2] | 0;
       i49 = i7 + 1 | 0;
       i49 = HEAP32[i35 + (((i49 | 0) == 3 ? 0 : i49) << 2) >> 2] | 0;
       f31 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) >> 2]);
       f32 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 4 >> 2]);
       f5 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 8 >> 2]);
       f9 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) >> 2]);
       f10 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 4 >> 2]);
       f9 = Math_fround(f31 - f9);
       f10 = Math_fround(f32 - f10);
       f5 = Math_fround(f5 - Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 8 >> 2]));
       if (f9 != Math_fround(0.0) | f10 != Math_fround(0.0) | f5 != Math_fround(0.0)) {
        f13 = Math_fround(Math_fround(Math_fround(f11 * f5) - Math_fround(f12 * f10)) + Math_fround(Math_fround(f17 * f10) - Math_fround(f16 * f5)));
        f14 = Math_fround(Math_fround(Math_fround(f12 * f9) - Math_fround(f8 * f5)) + Math_fround(Math_fround(f15 * f5) - Math_fround(f17 * f9)));
        f8 = Math_fround(Math_fround(Math_fround(f8 * f10) - Math_fround(f11 * f9)) + Math_fround(Math_fround(f16 * f9) - Math_fround(f15 * f10)));
       } else {
        f13 = Math_fround(f15 + f8);
        f14 = Math_fround(f16 + f11);
        f8 = Math_fround(f17 + f12);
       }
       if (f8 == Math_fround(0.0) & (f14 == Math_fround(0.0) & f13 == Math_fround(0.0))) {
        i2 = 1;
        break L1;
       }
       f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)))));
       if (f5 == Math_fround(0.0)) {
        _puts(gb + 730491 | 0) | 0;
        f5 = Math_fround(.100000001);
       }
       f32 = Math_fround(Math_fround(1.0) / f5);
       f10 = Math_fround(f13 * f32);
       f9 = Math_fround(f14 * f32);
       f8 = Math_fround(f8 * f32);
       if (i38) {
        i3 = 1;
        i2 = 0;
        do {
         f31 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) >> 2]);
         f30 = Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 4 >> 2]);
         f30 = Math_fround(Math_fround(Math_fround(f10 * f31) + Math_fround(f9 * f30)) + Math_fround(f8 * Math_fround(HEAPF32[i40 + (i3 * 12 | 0) + 8 >> 2])));
         f31 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) >> 2]);
         f32 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 4 >> 2]);
         i49 = f30 > Math_fround(Math_fround(Math_fround(f10 * f31) + Math_fround(f9 * f32)) + Math_fround(f8 * Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 8 >> 2])));
         i2 = i49 ? i3 : i2;
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) != (i39 | 0));
       } else i2 = 0;
       f32 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) >> 2]);
       f5 = Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 4 >> 2]);
       f5 = Math_fround(-Math_fround(Math_fround(Math_fround(f10 * f32) + Math_fround(f9 * f5)) + Math_fround(f8 * Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 8 >> 2]))));
       if ((i4 | 0) == (i6 | 0)) {
        i6 = (i4 | 0) == 0 ? 16 : i4 << 1;
        i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i47, i6 << 4, gb + 730303 | 0, 136) | 0;
        if ((i4 | 0) > 0) {
         HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
         if ((i4 | 0) > 1) {
          i2 = 1;
          do {
           i49 = i3 + (i2 << 4) | 0;
           i45 = i1 + (i2 << 4) | 0;
           HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
           HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
           HEAP32[i49 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
           HEAP32[i49 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
           i2 = i2 + 1 | 0;
          } while ((i2 | 0) != (i4 | 0));
          i45 = 27;
         } else i45 = 27;
        } else if (i1 | 0) i45 = 27;
        if ((i45 | 0) == 27) {
         i45 = 0;
         __ZN5physx6shdfnd9Allocator10deallocateEPv(i41, i1);
        }
        i1 = i3;
       }
       HEAPF32[i1 + (i4 << 4) >> 2] = f10;
       HEAPF32[i1 + (i4 << 4) + 4 >> 2] = f9;
       HEAPF32[i1 + (i4 << 4) + 8 >> 2] = f8;
       HEAPF32[i1 + (i4 << 4) + 12 >> 2] = f5;
       i4 = i4 + 1 | 0;
      }
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < 3);
   }
   i36 = i36 + 1 | 0;
   i2 = HEAP32[i46 >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if ((i36 | 0) >= (i3 | 0)) {
    i35 = i4;
    break;
   }
  }
  if ((i3 | 0) > 0) {
   i34 = 0;
   do {
    i4 = HEAP32[i2 >> 2] | 0;
    i6 = HEAP32[i4 + (i34 << 2) >> 2] | 0;
    i33 = i34;
    i34 = i34 + 1 | 0;
    L49 : do if ((i6 | 0) != 0 & (i34 | 0) < (i3 | 0)) {
     i7 = i34;
     while (1) {
      i2 = i4 + (i33 << 2) | 0;
      do if (i6 | 0) {
       i3 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
       if (i3 | 0) {
        i2 = HEAP32[i2 >> 2] | 0;
        i38 = HEAP32[i2 >> 2] | 0;
        i39 = HEAP32[i2 + 4 >> 2] | 0;
        i49 = HEAP32[i2 + 8 >> 2] | 0;
        f24 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) >> 2]);
        f25 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 4 >> 2]);
        f26 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 8 >> 2]);
        f27 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) >> 2]);
        f28 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 4 >> 2]);
        f29 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 8 >> 2]);
        f30 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) >> 2]);
        f31 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 4 >> 2]);
        f32 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 8 >> 2]);
        f22 = Math_fround(f27 - f24);
        f8 = Math_fround(f28 - f25);
        f21 = Math_fround(f29 - f26);
        f5 = Math_fround(f30 - f27);
        f23 = Math_fround(f31 - f28);
        f9 = Math_fround(f32 - f29);
        f10 = Math_fround(Math_fround(f8 * f9) - Math_fround(f21 * f23));
        f9 = Math_fround(Math_fround(f21 * f5) - Math_fround(f22 * f9));
        f5 = Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f5));
        f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)))));
        if (f8 == Math_fround(0.0)) {
         f23 = Math_fround(0.0);
         f22 = Math_fround(0.0);
         f21 = Math_fround(1.0);
        } else {
         f21 = Math_fround(Math_fround(1.0) / f8);
         f23 = Math_fround(f5 * f21);
         f22 = Math_fround(f9 * f21);
         f21 = Math_fround(f10 * f21);
        }
        i38 = HEAP32[i3 >> 2] | 0;
        i39 = HEAP32[i3 + 4 >> 2] | 0;
        i49 = HEAP32[i3 + 8 >> 2] | 0;
        f12 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) >> 2]);
        f13 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 4 >> 2]);
        f14 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 8 >> 2]);
        f15 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) >> 2]);
        f16 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 4 >> 2]);
        f17 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 8 >> 2]);
        f18 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) >> 2]);
        f19 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 4 >> 2]);
        f20 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 8 >> 2]);
        f50 = Math_fround(f15 - f12);
        f8 = Math_fround(f16 - f13);
        f51 = Math_fround(f17 - f14);
        f5 = Math_fround(f18 - f15);
        f9 = Math_fround(f19 - f16);
        f10 = Math_fround(f20 - f17);
        f11 = Math_fround(Math_fround(f8 * f10) - Math_fround(f51 * f9));
        f10 = Math_fround(Math_fround(f51 * f5) - Math_fround(f50 * f10));
        f5 = Math_fround(Math_fround(f50 * f9) - Math_fround(f8 * f5));
        f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)))));
        if (f8 == Math_fround(0.0)) {
         f9 = Math_fround(0.0);
         f8 = Math_fround(0.0);
         f5 = Math_fround(1.0);
        } else {
         f51 = Math_fround(Math_fround(1.0) / f8);
         f9 = Math_fround(f5 * f51);
         f8 = Math_fround(f10 * f51);
         f5 = Math_fround(f11 * f51);
        }
        if (Math_fround(Math_fround(Math_fround(f21 * f5) + Math_fround(f22 * f8)) + Math_fround(f23 * f9)) > Math_fround(.99862951)) {
         f27 = Math_fround(f24 - f27);
         f28 = Math_fround(f25 - f28);
         f51 = Math_fround(f26 - f29);
         f29 = Math_fround(f30 - f24);
         f25 = Math_fround(f31 - f25);
         f31 = Math_fround(f32 - f26);
         f30 = Math_fround(Math_fround(f28 * f31) - Math_fround(f51 * f25));
         f31 = Math_fround(Math_fround(f51 * f29) - Math_fround(f27 * f31));
         f29 = Math_fround(Math_fround(f27 * f25) - Math_fround(f28 * f29));
         f26 = Math_fround(f12 - f15);
         f28 = Math_fround(f13 - f16);
         f25 = Math_fround(f14 - f17);
         f32 = Math_fround(f18 - f12);
         f27 = Math_fround(f19 - f13);
         f51 = Math_fround(f20 - f14);
         f50 = Math_fround(Math_fround(f28 * f51) - Math_fround(f25 * f27));
         f51 = Math_fround(Math_fround(f25 * f32) - Math_fround(f26 * f51));
         f32 = Math_fround(Math_fround(f26 * f27) - Math_fround(f28 * f32));
         if (!(Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31))) < Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f50 * f50) + Math_fround(f51 * f51))))) {
          HEAP32[i4 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
          __ZN5physx6shdfnd9Allocator10deallocateEPv(i47, i3);
          break;
         }
         HEAP32[i4 + (HEAP32[i2 + 24 >> 2] << 2) >> 2] = 0;
         if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i47, i2);
        }
       }
      } while (0);
      i7 = i7 + 1 | 0;
      i2 = HEAP32[i46 >> 2] | 0;
      i3 = HEAP32[i2 + 4 >> 2] | 0;
      if ((i7 | 0) >= (i3 | 0)) break L49;
      i6 = HEAP32[i2 >> 2] | 0;
      i4 = i6;
      i6 = HEAP32[i6 + (i33 << 2) >> 2] | 0;
     }
    } while (0);
   } while ((i34 | 0) < (i3 | 0));
   if ((i3 | 0) > 0) {
    i7 = i44 + 8 | 0;
    i6 = 0;
    do {
     i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i6 << 2) >> 2] | 0;
     if (i3) {
      i38 = HEAP32[i3 >> 2] | 0;
      i39 = HEAP32[i3 + 4 >> 2] | 0;
      i49 = HEAP32[i3 + 8 >> 2] | 0;
      f11 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) >> 2]);
      f12 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 4 >> 2]);
      f13 = Math_fround(HEAPF32[i40 + (i38 * 12 | 0) + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) >> 2]);
      f51 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 4 >> 2]);
      f9 = Math_fround(HEAPF32[i40 + (i39 * 12 | 0) + 8 >> 2]);
      f31 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) >> 2]);
      f10 = Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 4 >> 2]);
      f50 = Math_fround(f5 - f11);
      f8 = Math_fround(f51 - f12);
      f32 = Math_fround(f9 - f13);
      f5 = Math_fround(f31 - f5);
      f51 = Math_fround(f10 - f51);
      f9 = Math_fround(Math_fround(HEAPF32[i40 + (i49 * 12 | 0) + 8 >> 2]) - f9);
      f10 = Math_fround(Math_fround(f8 * f9) - Math_fround(f32 * f51));
      f9 = Math_fround(Math_fround(f32 * f5) - Math_fround(f50 * f9));
      f5 = Math_fround(Math_fround(f50 * f51) - Math_fround(f8 * f5));
      f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)))));
      if (f8 == Math_fround(0.0)) {
       f14 = Math_fround(0.0);
       f9 = Math_fround(0.0);
       f8 = Math_fround(1.0);
      } else {
       f8 = Math_fround(Math_fround(1.0) / f8);
       f14 = Math_fround(f5 * f8);
       f9 = Math_fround(f9 * f8);
       f8 = Math_fround(f10 * f8);
      }
      f5 = Math_fround(-Math_fround(Math_fround(Math_fround(f8 * f11) + Math_fround(f9 * f12)) + Math_fround(f14 * f13)));
      i2 = HEAP32[i43 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
       i3 = (i2 | 0) == 0 ? 16 : i2 << 1;
       i4 = HEAP32[i44 >> 2] | 0;
       HEAP32[i7 >> 2] = i3;
       i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i47, i3 << 4, gb + 730303 | 0, 136) | 0;
       HEAP32[i44 >> 2] = i3;
       i2 = HEAP32[i43 >> 2] | 0;
       if ((i2 | 0) > 0) {
        HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
        if ((HEAP32[i43 >> 2] | 0) > 1) {
         i2 = 1;
         do {
          i49 = (HEAP32[i44 >> 2] | 0) + (i2 << 4) | 0;
          i45 = i4 + (i2 << 4) | 0;
          HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
          HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
          HEAP32[i49 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
          HEAP32[i49 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) < (HEAP32[i43 >> 2] | 0));
         i2 = i4;
         i45 = 60;
        } else {
         i2 = i4;
         i45 = 60;
        }
       } else if (i4) {
        i2 = i4;
        i45 = 60;
       }
       if ((i45 | 0) == 60) {
        i45 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i41, i2);
        i2 = HEAP32[i43 >> 2] | 0;
       }
      }
      HEAP32[i43 >> 2] = i2 + 1;
      i49 = HEAP32[i44 >> 2] | 0;
      HEAPF32[i49 + (i2 << 4) >> 2] = f8;
      HEAPF32[i49 + (i2 << 4) + 4 >> 2] = f9;
      HEAPF32[i49 + (i2 << 4) + 8 >> 2] = f14;
      HEAPF32[i49 + (i2 << 4) + 12 >> 2] = f5;
      i2 = HEAP32[i46 >> 2] | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) < (HEAP32[i2 + 4 >> 2] | 0));
   }
  }
  if ((i35 | 0) > 0) {
   i6 = i44 + 8 | 0;
   i7 = 0;
   do {
    i2 = HEAP32[i43 >> 2] | 0;
    L95 : do if ((i2 | 0) > 0) {
     i4 = HEAP32[i44 >> 2] | 0;
     f9 = Math_fround(HEAPF32[i1 + (i7 << 4) >> 2]);
     f5 = Math_fround(HEAPF32[i1 + (i7 << 4) + 4 >> 2]);
     f8 = Math_fround(HEAPF32[i1 + (i7 << 4) + 8 >> 2]);
     i3 = 0;
     do {
      f50 = Math_fround(HEAPF32[i4 + (i3 << 4) >> 2]);
      f51 = Math_fround(HEAPF32[i4 + (i3 << 4) + 4 >> 2]);
      if (Math_fround(Math_fround(Math_fround(f9 * f50) + Math_fround(f5 * f51)) + Math_fround(f8 * Math_fround(HEAPF32[i4 + (i3 << 4) + 8 >> 2]))) > Math_fround(.99862951)) break L95;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i2 | 0));
    } else i3 = 0; while (0);
    if ((i3 | 0) == (i2 | 0)) {
     _memmove(i42 | 0, i1 + (i7 << 4) | 0, 16) | 0;
     if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
      i3 = (i2 | 0) == 0 ? 16 : i2 << 1;
      i4 = HEAP32[i44 >> 2] | 0;
      HEAP32[i6 >> 2] = i3;
      i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i47, i3 << 4, gb + 730303 | 0, 136) | 0;
      HEAP32[i44 >> 2] = i3;
      i2 = HEAP32[i43 >> 2] | 0;
      if ((i2 | 0) > 0) {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       if ((HEAP32[i43 >> 2] | 0) > 1) {
        i2 = 1;
        do {
         i49 = (HEAP32[i44 >> 2] | 0) + (i2 << 4) | 0;
         i45 = i4 + (i2 << 4) | 0;
         HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
         HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
         HEAP32[i49 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
         HEAP32[i49 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) < (HEAP32[i43 >> 2] | 0));
        i2 = i4;
        i45 = 78;
       } else {
        i2 = i4;
        i45 = 78;
       }
      } else if (i4) {
       i2 = i4;
       i45 = 78;
      }
      if ((i45 | 0) == 78) {
       i45 = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i41, i2);
       i2 = HEAP32[i43 >> 2] | 0;
      }
     }
     HEAP32[i43 >> 2] = i2 + 1;
     i49 = (HEAP32[i44 >> 2] | 0) + (i2 << 4) | 0;
     HEAP32[i49 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
     HEAP32[i49 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i35 | 0));
   i6 = i1;
   i2 = HEAP32[i46 >> 2] | 0;
   i45 = 67;
  } else {
   i6 = i1;
   i45 = 67;
  }
 } else {
  i6 = 0;
  i45 = 67;
 } while (0);
 if ((i45 | 0) == 67) {
  i1 = i2 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) > 0) {
   i4 = 0;
   do {
    i1 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
    if (i3) {
     HEAP32[i1 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i47, i3);
     i2 = HEAP32[i46 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
    i1 = i2 + 4 | 0;
   } while ((i4 | 0) < (HEAP32[i1 >> 2] | 0));
  }
  HEAP32[i1 >> 2] = 0;
  i2 = 0;
  i1 = i6;
 }
 if (!i1) {
  STACKTOP = i48;
  return i2 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i47, i1);
 STACKTOP = i48;
 return i2 | 0;
}

function __ZN10builtintex21ReinitBuiltinTexturesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27 + 304 | 0;
 i23 = i27 + 288 | 0;
 i22 = i27 + 272 | 0;
 i21 = i27 + 256 | 0;
 i20 = i27 + 240 | 0;
 i19 = i27 + 224 | 0;
 i18 = i27 + 208 | 0;
 i17 = i27 + 192 | 0;
 i16 = i27 + 176 | 0;
 i15 = i27 + 160 | 0;
 i14 = i27 + 144 | 0;
 i13 = i27 + 128 | 0;
 i12 = i27 + 112 | 0;
 i11 = i27 + 96 | 0;
 i10 = i27 + 80 | 0;
 i9 = i27 + 64 | 0;
 i8 = i27 + 48 | 0;
 i7 = i27 + 32 | 0;
 i6 = i27 + 16 | 0;
 i5 = i27;
 i24 = i27 + 320 | 0;
 i25 = i27 + 316 | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158160 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741824;
 HEAP32[i4 + 2980 >> 2] = i2;
 HEAP32[i4 + 2984 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 2988 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i28 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i3 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i5 >> 2] = i28;
   HEAP32[i5 + 4 >> 2] = i2;
   HEAP32[i5 + 8 >> 2] = i3;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 2992 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741823;
 HEAP32[i4 + 3e3 >> 2] = i2;
 HEAP32[i4 + 3004 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3008 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i3 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i5 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i6 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3012 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158164 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741822;
 HEAP32[i4 + 3020 >> 2] = i2;
 HEAP32[i4 + 3024 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3028 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i5 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i6 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i7 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3032 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158168 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741821;
 HEAP32[i4 + 3040 >> 2] = i2;
 HEAP32[i4 + 3044 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3048 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i6 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i7 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i8 + 4 >> 2] = i7;
   HEAP32[i8 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3052 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158168 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741820;
 HEAP32[i4 + 3060 >> 2] = i2;
 HEAP32[i4 + 3064 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3068 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i7 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i8 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i9 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3072 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158172 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741819;
 HEAP32[i4 + 3080 >> 2] = i2;
 HEAP32[i4 + 3084 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3088 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i8 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i9 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i10 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i10);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3092 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158172 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741818;
 HEAP32[i4 + 3100 >> 2] = i2;
 HEAP32[i4 + 3104 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3108 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i9 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i10 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i11 >> 2] = i9;
   HEAP32[i11 + 4 >> 2] = i10;
   HEAP32[i11 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3112 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158176 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741817;
 HEAP32[i4 + 3120 >> 2] = i2;
 HEAP32[i4 + 3124 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3128 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i10 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i11 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i12 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3132 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158180 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741816;
 HEAP32[i4 + 3140 >> 2] = i2;
 HEAP32[i4 + 3144 >> 2] = i3;
 if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3148 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
   i11 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
   i12 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i13 + 8 >> 2] = i28;
   __Z6FormatPKcz(i24, gb + 478736 | 0, i13);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  }
 }
 HEAP32[i4 + 3152 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741815;
 HEAP32[i4 + 3160 >> 2] = i2;
 HEAP32[i4 + 3164 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3168 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i12 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i13 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i14 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i14);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3172 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741814;
 HEAP32[i4 + 3180 >> 2] = i2;
 HEAP32[i4 + 3184 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3188 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i13 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i14 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i15 >> 2] = i13;
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i15 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3192 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741813;
 HEAP32[i4 + 3200 >> 2] = i2;
 HEAP32[i4 + 3204 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3208 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i14 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i15 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i16 >> 2] = i14;
  HEAP32[i16 + 4 >> 2] = i15;
  HEAP32[i16 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i16);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3212 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741812;
 HEAP32[i4 + 3220 >> 2] = i2;
 HEAP32[i4 + 3224 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3228 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i15 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i16 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  HEAP32[i17 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i17);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3232 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741811;
 HEAP32[i4 + 3240 >> 2] = i2;
 HEAP32[i4 + 3244 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3248 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i16 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i17 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i18 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i18);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3252 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1157932 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741810;
 HEAP32[i4 + 3260 >> 2] = i2;
 HEAP32[i4 + 3264 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3268 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i17 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i18 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  HEAP32[i19 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i19);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3272 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158156 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741809;
 HEAP32[i4 + 3280 >> 2] = i2;
 HEAP32[i4 + 3284 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3288 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i18 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i19 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i20 >> 2] = i18;
  HEAP32[i20 + 4 >> 2] = i19;
  HEAP32[i20 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i20);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3292 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158152 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741808;
 HEAP32[i4 + 3300 >> 2] = i2;
 HEAP32[i4 + 3304 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3308 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i19 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i20 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  HEAP32[i21 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i21);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3312 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158184 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741807;
 HEAP32[i4 + 3320 >> 2] = i2;
 HEAP32[i4 + 3324 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3328 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i20 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i21 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  HEAP32[i22 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i22);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3332 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158188 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741806;
 HEAP32[i4 + 3340 >> 2] = i2;
 HEAP32[i4 + 3344 >> 2] = i3;
 do if (i3 | i2 | 0) {
  i1 = HEAP32[i4 + 3348 >> 2] | 0;
  if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) break;
  i21 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
  i22 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
  HEAP32[i23 >> 2] = i21;
  HEAP32[i23 + 4 >> 2] = i22;
  HEAP32[i23 + 8 >> 2] = i28;
  __Z6FormatPKcz(i24, gb + 478736 | 0, i23);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 HEAP32[i4 + 3352 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1158180 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i25 >> 2] = -1073741805;
 HEAP32[i4 + 3360 >> 2] = i2;
 HEAP32[i4 + 3364 >> 2] = i3;
 if (!(i3 | i2)) {
  i28 = i4 + 3372 | 0;
  HEAP32[i28 >> 2] = 0;
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i4 + 3368 >> 2] | 0;
 if ((i1 | 0) == 1 | (i1 | 0) == (i3 | 0)) {
  i28 = i4 + 3372 | 0;
  HEAP32[i28 >> 2] = 0;
  STACKTOP = i27;
  return;
 }
 i22 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
 i23 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
 i28 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i25) | 0;
 HEAP32[i26 >> 2] = i22;
 HEAP32[i26 + 4 >> 2] = i23;
 HEAP32[i26 + 8 >> 2] = i28;
 __Z6FormatPKcz(i24, gb + 478736 | 0, i26);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 i28 = i4 + 3372 | 0;
 HEAP32[i28 >> 2] = 0;
 STACKTOP = i27;
 return;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i105, i3, i92, i1, i94, i93, i107, i108, i106, f2) {
 i105 = i105 | 0;
 i3 = i3 | 0;
 i92 = i92 | 0;
 i1 = i1 | 0;
 i94 = i94 | 0;
 i93 = i93 | 0;
 i107 = i107 | 0;
 i108 = i108 | 0;
 i106 = i106 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f95 = f0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i109 = 0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0;
 i109 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i104 = i109 + 192 | 0;
 i99 = i109 + 288 | 0;
 i103 = i109 + 284 | 0;
 i98 = i109 + 208 | 0;
 i96 = i109 + 128 | 0;
 i97 = i109 + 64 | 0;
 i58 = i109 + 272 | 0;
 i59 = i109 + 48 | 0;
 i102 = i109 + 32 | 0;
 i100 = i109 + 16 | 0;
 i101 = i109;
 HEAP32[i104 >> 2] = 0;
 HEAP32[i104 + 4 >> 2] = 0;
 HEAP32[i104 + 8 >> 2] = 0;
 HEAP32[i104 + 12 >> 2] = 0;
 f8 = Math_fround(HEAPF32[i93 >> 2]);
 i74 = i93 + 4 | 0;
 f13 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i93 + 8 | 0;
 f16 = Math_fround(HEAPF32[i75 >> 2]);
 f9 = Math_fround(HEAPF32[i94 >> 2]);
 i84 = i94 + 4 | 0;
 f14 = Math_fround(HEAPF32[i84 >> 2]);
 i91 = i94 + 8 | 0;
 f15 = Math_fround(HEAPF32[i91 >> 2]);
 HEAP32[i103 >> 2] = 1;
 i60 = i92 + 48 | 0;
 f23 = Math_fround(HEAPF32[i60 >> 2]);
 i64 = i92 + 52 | 0;
 f26 = Math_fround(HEAPF32[i64 >> 2]);
 i73 = i92 + 56 | 0;
 f20 = Math_fround(HEAPF32[i73 >> 2]);
 i76 = Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f26 * f26)) + Math_fround(f20 * f20)) > Math_fround(1.1920929e-07);
 f7 = i76 ? f23 : Math_fround(1.0);
 f5 = i76 ? f26 : Math_fround(0.0);
 f18 = i76 ? f20 : Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f18 * f18) + Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5))))));
 f7 = Math_fround(f7 * f4);
 f5 = Math_fround(f5 * f4);
 f4 = Math_fround(f18 * f4);
 f18 = Math_fround(-f7);
 f12 = Math_fround(-f5);
 f11 = Math_fround(-f4);
 f25 = Math_fround(HEAPF32[i92 >> 2]);
 f110 = Math_fround(f25 * f18);
 i76 = i92 + 4 | 0;
 f28 = Math_fround(HEAPF32[i76 >> 2]);
 f110 = Math_fround(f110 + Math_fround(f28 * f12));
 i77 = i92 + 8 | 0;
 f95 = Math_fround(HEAPF32[i77 >> 2]);
 f110 = Math_fround(f110 + Math_fround(f95 * f11));
 i78 = i92 + 16 | 0;
 f29 = Math_fround(HEAPF32[i78 >> 2]);
 f10 = Math_fround(f29 * f18);
 i79 = i92 + 20 | 0;
 f30 = Math_fround(HEAPF32[i79 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f30 * f12));
 i80 = i92 + 24 | 0;
 f32 = Math_fround(HEAPF32[i80 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f32 * f11));
 i81 = i92 + 32 | 0;
 f24 = Math_fround(HEAPF32[i81 >> 2]);
 f18 = Math_fround(f24 * f18);
 i82 = i92 + 36 | 0;
 f27 = Math_fround(HEAPF32[i82 >> 2]);
 f12 = Math_fround(f18 + Math_fround(f27 * f12));
 i83 = i92 + 40 | 0;
 f18 = Math_fround(HEAPF32[i83 >> 2]);
 f11 = Math_fround(f12 + Math_fround(f18 * f11));
 i85 = i105 + 96 | 0;
 f12 = Math_fround(HEAPF32[i85 >> 2]);
 i86 = i105 + 100 | 0;
 f21 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i105 + 104 | 0;
 f22 = Math_fround(HEAPF32[i87 >> 2]);
 f111 = Math_fround(Math_fround(Math_fround(f110 * f12) + Math_fround(f10 * f21)) + Math_fround(f11 * f22));
 i88 = i105 + 112 | 0;
 f31 = Math_fround(HEAPF32[i88 >> 2]);
 i89 = i105 + 116 | 0;
 f6 = Math_fround(HEAPF32[i89 >> 2]);
 i90 = i105 + 120 | 0;
 f17 = Math_fround(HEAPF32[i90 >> 2]);
 i67 = f111 > Math_fround(Math_fround(Math_fround(f110 * f31) + Math_fround(f10 * f6)) + Math_fround(f11 * f17));
 f31 = i67 ? f12 : f31;
 f6 = i67 ? f21 : f6;
 f17 = i67 ? f22 : f17;
 f29 = Math_fround(f23 + Math_fround(Math_fround(f24 * f17) + Math_fround(Math_fround(f25 * f31) + Math_fround(f29 * f6))));
 f30 = Math_fround(f26 + Math_fround(Math_fround(f27 * f17) + Math_fround(Math_fround(f28 * f31) + Math_fround(f30 * f6))));
 f6 = Math_fround(f20 + Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f95 * f31) + Math_fround(f32 * f6))));
 i67 = f7 > Math_fround(0.0);
 i66 = f5 > Math_fround(0.0);
 i65 = f4 > Math_fround(0.0);
 i61 = i3 + 144 | 0;
 f4 = Math_fround(HEAPF32[i61 >> 2]);
 i62 = i3 + 148 | 0;
 f5 = Math_fround(HEAPF32[i62 >> 2]);
 i63 = i3 + 152 | 0;
 f7 = Math_fround(HEAPF32[i63 >> 2]);
 f32 = Math_fround(-f4);
 f31 = Math_fround(-f5);
 f95 = Math_fround(-f7);
 f32 = i67 ? f4 : f32;
 f31 = i66 ? f5 : f31;
 f95 = i65 ? f7 : f95;
 f17 = Math_fround(f29 - f32);
 f18 = Math_fround(f30 - f31);
 f20 = Math_fround(f6 - f95);
 HEAPF32[i98 >> 2] = f17;
 i65 = i98 + 4 | 0;
 HEAPF32[i65 >> 2] = f18;
 i66 = i98 + 8 | 0;
 HEAPF32[i66 >> 2] = f20;
 i67 = i98 + 12 | 0;
 HEAPF32[i67 >> 2] = Math_fround(0.0);
 i68 = i98 + 16 | 0;
 HEAP32[i68 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i68 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i68 = i98 + 32 | 0;
 HEAP32[i68 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i68 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i68 = i98 + 48 | 0;
 HEAP32[i68 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i68 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i68 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i68 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAPF32[i96 >> 2] = f29;
 i68 = i96 + 4 | 0;
 HEAPF32[i68 >> 2] = f30;
 i69 = i96 + 8 | 0;
 HEAPF32[i69 >> 2] = f6;
 HEAPF32[i96 + 12 >> 2] = Math_fround(0.0);
 i70 = i96 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i70 = i96 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i70 = i96 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAPF32[i97 >> 2] = f32;
 i70 = i97 + 4 | 0;
 HEAPF32[i70 >> 2] = f31;
 i71 = i97 + 8 | 0;
 HEAPF32[i71 >> 2] = f95;
 i72 = i97 + 12 | 0;
 HEAPF32[i72 >> 2] = Math_fround(0.0);
 i57 = i97 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i57 = i97 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i57 = i97 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 f95 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i57 = f95 < Math_fround(0.0);
 f95 = Math_fround(f95 * Math_fround(.100000001));
 f95 = i57 ? f95 : Math_fround(0.0);
 f31 = Math_fround(f95 + f2);
 f95 = Math_fround(f95 * f95);
 f32 = Math_fround(f31 * f31);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f20 * f20));
 L1 : do if (f6 > f95) {
  i33 = i97 + 16 | 0;
  i34 = i97 + 20 | 0;
  i35 = i97 + 24 | 0;
  i36 = i97 + 28 | 0;
  i37 = i97 + 32 | 0;
  i38 = i97 + 36 | 0;
  i39 = i97 + 40 | 0;
  i40 = i97 + 44 | 0;
  i41 = i96 + 16 | 0;
  i42 = i96 + 20 | 0;
  i43 = i96 + 24 | 0;
  i44 = i98 + 16 | 0;
  i45 = i98 + 20 | 0;
  i46 = i98 + 24 | 0;
  i47 = i98 + 28 | 0;
  i48 = i96 + 32 | 0;
  i49 = i96 + 36 | 0;
  i50 = i96 + 40 | 0;
  i51 = i98 + 32 | 0;
  i52 = i98 + 36 | 0;
  i53 = i98 + 40 | 0;
  i54 = i98 + 44 | 0;
  i55 = i59 + 4 | 0;
  i56 = i59 + 8 | 0;
  i57 = i59 + 12 | 0;
  f10 = f17;
  f11 = f18;
  f12 = f20;
  f21 = f4;
  f23 = f5;
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f9);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f14);
  f24 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f15);
  f28 = Math_fround(0.0);
  f2 = f17;
  f4 = f18;
  f5 = f20;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f14 = Math_fround(f10 * f15);
   f9 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f110 = Math_fround(-f14);
   f111 = Math_fround(-f9);
   f8 = Math_fround(-f15);
   f114 = Math_fround(HEAPF32[i92 >> 2]);
   f120 = Math_fround(f114 * f110);
   f13 = Math_fround(HEAPF32[i76 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f13 * f111));
   f18 = Math_fround(HEAPF32[i77 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f18 * f8));
   f25 = Math_fround(HEAPF32[i78 >> 2]);
   f119 = Math_fround(f25 * f110);
   f26 = Math_fround(HEAPF32[i79 >> 2]);
   f119 = Math_fround(f119 + Math_fround(f26 * f111));
   f16 = Math_fround(HEAPF32[i80 >> 2]);
   f119 = Math_fround(f119 + Math_fround(f16 * f8));
   f115 = Math_fround(HEAPF32[i81 >> 2]);
   f118 = Math_fround(f115 * f110);
   f112 = Math_fround(HEAPF32[i82 >> 2]);
   f118 = Math_fround(f118 + Math_fround(f112 * f111));
   f22 = Math_fround(HEAPF32[i83 >> 2]);
   f118 = Math_fround(f118 + Math_fround(f22 * f8));
   f117 = Math_fround(HEAPF32[i85 >> 2]);
   f113 = Math_fround(HEAPF32[i86 >> 2]);
   f116 = Math_fround(HEAPF32[i87 >> 2]);
   f121 = Math_fround(Math_fround(Math_fround(f120 * f117) + Math_fround(f119 * f113)) + Math_fround(f118 * f116));
   f17 = Math_fround(HEAPF32[i88 >> 2]);
   f27 = Math_fround(HEAPF32[i89 >> 2]);
   f20 = Math_fround(HEAPF32[i90 >> 2]);
   i1 = f121 > Math_fround(Math_fround(Math_fround(f120 * f17) + Math_fround(f119 * f27)) + Math_fround(f118 * f20));
   f17 = i1 ? f117 : f17;
   f27 = i1 ? f113 : f27;
   f20 = i1 ? f116 : f20;
   f116 = Math_fround(HEAPF32[i60 >> 2]);
   f113 = Math_fround(HEAPF32[i64 >> 2]);
   f25 = Math_fround(f116 + Math_fround(Math_fround(f115 * f20) + Math_fround(Math_fround(f114 * f17) + Math_fround(f25 * f27))));
   f26 = Math_fround(f113 + Math_fround(Math_fround(f112 * f20) + Math_fround(Math_fround(f13 * f17) + Math_fround(f26 * f27))));
   f27 = Math_fround(Math_fround(HEAPF32[i73 >> 2]) + Math_fround(Math_fround(f22 * f20) + Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f27))));
   i1 = f14 > Math_fround(0.0);
   i3 = f9 > Math_fround(0.0);
   i19 = f15 > Math_fround(0.0);
   f16 = Math_fround(-f21);
   f17 = Math_fround(-f23);
   f18 = Math_fround(-f7);
   f16 = Math_fround(f30 + (i1 ? f21 : f16));
   f17 = Math_fround(f29 + (i3 ? f23 : f17));
   f18 = Math_fround(f24 + (i19 ? f7 : f18));
   f20 = Math_fround(f25 - f16);
   f21 = Math_fround(f26 - f17);
   f22 = Math_fround(f27 - f18);
   f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f14 * f20) + Math_fround(f9 * f21))) - f31);
   f9 = Math_fround(HEAPF32[i93 >> 2]);
   f14 = Math_fround(HEAPF32[i74 >> 2]);
   f15 = Math_fround(HEAPF32[i75 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f9 * f110) + Math_fround(f14 * f111)) + Math_fround(f15 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i99 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i99 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i99 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f20 = Math_fround(HEAPF32[i94 >> 2]);
     f22 = Math_fround(HEAPF32[i84 >> 2]);
     f20 = Math_fround(Math_fround(f13 * f9) + f20);
     f22 = Math_fround(Math_fround(f13 * f14) + f22);
     f5 = Math_fround(Math_fround(f13 * f15) + Math_fround(HEAPF32[i91 >> 2]));
     f121 = Math_fround(f20 - f30);
     f2 = Math_fround(f22 - f29);
     f18 = Math_fround(f5 - f24);
     f4 = Math_fround(HEAPF32[i97 >> 2]);
     f24 = Math_fround(HEAPF32[i70 >> 2]);
     f4 = Math_fround(f121 + f4);
     f24 = Math_fround(f2 + f24);
     f21 = Math_fround(f18 + Math_fround(HEAPF32[i71 >> 2]));
     f7 = Math_fround(HEAPF32[i33 >> 2]);
     f8 = Math_fround(HEAPF32[i34 >> 2]);
     f7 = Math_fround(f121 + f7);
     f8 = Math_fround(f2 + f8);
     f9 = Math_fround(f18 + Math_fround(HEAPF32[i35 >> 2]));
     f16 = Math_fround(HEAPF32[i37 >> 2]);
     f17 = Math_fround(HEAPF32[i38 >> 2]);
     f16 = Math_fround(f121 + f16);
     f17 = Math_fround(f2 + f17);
     f18 = Math_fround(f18 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i97 >> 2] = f4;
     HEAPF32[i70 >> 2] = f24;
     HEAPF32[i71 >> 2] = f21;
     HEAPF32[i72 >> 2] = Math_fround(0.0);
     HEAPF32[i33 >> 2] = f7;
     HEAPF32[i34 >> 2] = f8;
     HEAPF32[i35 >> 2] = f9;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f16;
     HEAPF32[i38 >> 2] = f17;
     HEAPF32[i39 >> 2] = f18;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f2 = Math_fround(HEAPF32[i96 >> 2]);
     f121 = Math_fround(HEAPF32[i68 >> 2]);
     f24 = Math_fround(f121 - f24);
     f21 = Math_fround(Math_fround(HEAPF32[i69 >> 2]) - f21);
     HEAPF32[i98 >> 2] = Math_fround(f2 - f4);
     HEAPF32[i65 >> 2] = f24;
     HEAPF32[i66 >> 2] = f21;
     HEAPF32[i67 >> 2] = Math_fround(0.0);
     f21 = Math_fround(HEAPF32[i41 >> 2]);
     f24 = Math_fround(HEAPF32[i42 >> 2]);
     f8 = Math_fround(f24 - f8);
     f9 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f9);
     HEAPF32[i44 >> 2] = Math_fround(f21 - f7);
     HEAPF32[i45 >> 2] = f8;
     HEAPF32[i46 >> 2] = f9;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f9 = Math_fround(HEAPF32[i48 >> 2]);
     f8 = Math_fround(HEAPF32[i49 >> 2]);
     f17 = Math_fround(f8 - f17);
     f18 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f18);
     HEAPF32[i51 >> 2] = Math_fround(f9 - f16);
     HEAPF32[i52 >> 2] = f17;
     HEAPF32[i53 >> 2] = f18;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f18 = Math_fround(HEAPF32[i61 >> 2]);
     f17 = Math_fround(HEAPF32[i62 >> 2]);
     f16 = Math_fround(HEAPF32[i63 >> 2]);
     f9 = Math_fround(-f18);
     f8 = Math_fround(-f17);
     f7 = Math_fround(-f16);
     f9 = Math_fround(f20 + (i1 ? f18 : f9));
     f8 = Math_fround(f22 + (i3 ? f17 : f8));
     f7 = Math_fround(f5 + (i19 ? f16 : f7));
     f16 = f9;
     f17 = f8;
     f18 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f21 = Math_fround(3402823469999999843913219.0e14);
     f24 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f20;
     f8 = f21;
     f7 = f22;
     f21 = f6;
     f22 = f29;
     f20 = f30;
    }
   } else {
    f9 = f20;
    f8 = f21;
    f7 = f22;
    f21 = f6;
    f13 = f28;
    f22 = f29;
    f20 = f30;
   }
   i19 = HEAP32[i103 >> 2] | 0;
   HEAPF32[i96 + (i19 << 4) >> 2] = f25;
   HEAPF32[i96 + (i19 << 4) + 4 >> 2] = f26;
   HEAPF32[i96 + (i19 << 4) + 8 >> 2] = f27;
   HEAPF32[i96 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i97 + (i19 << 4) >> 2] = f16;
   HEAPF32[i97 + (i19 << 4) + 4 >> 2] = f17;
   HEAPF32[i97 + (i19 << 4) + 8 >> 2] = f18;
   HEAPF32[i97 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i103 >> 2] = i19 + 1;
   HEAPF32[i98 + (i19 << 4) >> 2] = f9;
   HEAPF32[i98 + (i19 << 4) + 4 >> 2] = f8;
   HEAPF32[i98 + (i19 << 4) + 8 >> 2] = f7;
   HEAPF32[i98 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i19 | 0) {
   case 0:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i98 >> 2]);
     f7 = Math_fround(HEAPF32[i65 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f119 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i19 = f119 > Math_fround(1.0);
      f119 = i19 ? Math_fround(1.0) : f119;
      i19 = f119 > Math_fround(0.0);
      f119 = i19 ? f119 : Math_fround(0.0);
      f120 = Math_fround(f7 + Math_fround(f14 * f119));
      f121 = Math_fround(f8 + Math_fround(f15 * f119));
      HEAPF32[i59 >> 2] = Math_fround(f6 + Math_fround(f9 * f119));
      HEAPF32[i55 >> 2] = f120;
      HEAPF32[i56 >> 2] = f121;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i103 >> 2] = 1;
      HEAP32[i59 >> 2] = HEAP32[i98 >> 2];
      HEAP32[i59 + 4 >> 2] = HEAP32[i98 + 4 >> 2];
      HEAP32[i59 + 8 >> 2] = HEAP32[i98 + 8 >> 2];
      HEAP32[i59 + 12 >> 2] = HEAP32[i98 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i98, i96, i97, i103);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i98, i96, i97, i103);
     break;
    }
   default:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f21 > f6;
   if (!(f6 > f32 & i1)) break L1;
   f21 = Math_fround(HEAPF32[i61 >> 2]);
   f23 = Math_fround(HEAPF32[i62 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = Math_fround(HEAPF32[i63 >> 2]);
   f30 = f20;
   f29 = f22;
   f28 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i109;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f20;
  f11 = f18;
  f10 = f17;
  f9 = f20;
  f8 = f18;
  f7 = f17;
  i1 = 1;
  f5 = f20;
  f4 = f18;
  f2 = f17;
 } while (0);
 i92 = HEAP32[i105 + 64 >> 2] | 0;
 i93 = HEAP32[i105 + 68 >> 2] | 0;
 i94 = HEAP32[i105 + 72 >> 2] | 0;
 i91 = f6 > f95 & i1;
 f116 = i91 ? f7 : f2;
 f118 = i91 ? f8 : f4;
 f120 = i91 ? f9 : f5;
 f115 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f120 * f120) + Math_fround(Math_fround(f118 * f118) + Math_fround(f116 * f116))))));
 f116 = Math_fround(f116 * f115);
 f118 = Math_fround(f118 * f115);
 f115 = Math_fround(f120 * f115);
 HEAPF32[i108 >> 2] = f116;
 HEAPF32[i108 + 4 >> 2] = f118;
 HEAPF32[i108 + 8 >> 2] = f115;
 HEAPF32[i108 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i107 >> 2] = f13;
 i108 = i107 + 4 | 0;
 HEAP32[i108 >> 2] = HEAP32[i99 >> 2];
 HEAP32[i108 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
 HEAP32[i108 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
 HEAPF32[i102 >> 2] = i1 ? f7 : f10;
 HEAPF32[i102 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i102 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i102 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i100 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i100 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i100 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i100 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAP32[i101 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i101 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i101 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i101 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i98, i96, i97, i102, i100, i101, HEAP32[i103 >> 2] | 0);
 f120 = Math_fround(HEAPF32[i105 + 16 >> 2]);
 f117 = Math_fround(HEAPF32[i100 >> 2]);
 f119 = Math_fround(HEAPF32[i100 + 4 >> 2]);
 f121 = Math_fround(HEAPF32[i100 + 8 >> 2]);
 f116 = Math_fround(f117 - Math_fround(f116 * f120));
 f118 = Math_fround(f119 - Math_fround(f118 * f120));
 f120 = Math_fround(f121 - Math_fround(f115 * f120));
 HEAPF32[i106 >> 2] = i92 | 0 ? f116 : f117;
 HEAPF32[i106 + 4 >> 2] = i93 | 0 ? f118 : f119;
 HEAPF32[i106 + 8 >> 2] = i94 | 0 ? f120 : f121;
 HEAPF32[i106 + 12 >> 2] = Math_fround(0.0);
 i108 = 1;
 STACKTOP = i109;
 return i108 | 0;
}

function __ZN5physx19PxsConstraintHelper21setupSolverConstraintERKNS_11PxTransformES3_PKNS_13PxcSolverBodyES6_PNS_17PxcSolverBodyDataES8_PFjPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvS3_S3_ESG_jffRNS_23PxcSolverConstraintDescERKNS_13PxsConstraintERNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i6, i7, i86, i87, i88, i89, i8, i5, i1, f84, f85, i14, i21, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i86 = i86 | 0;
 i87 = i87 | 0;
 i88 = i88 | 0;
 i89 = i89 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 f84 = Math_fround(f84);
 f85 = Math_fround(f85);
 i14 = i14 | 0;
 i21 = i21 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i90 = 0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0;
 i90 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i90 + 64 | 0;
 i82 = i90 + 1112 | 0;
 i15 = i90 + 1048 | 0;
 i83 = i90 + 1064 | 0;
 i68 = i90 + 1036 | 0;
 i69 = i90 + 1024 | 0;
 i66 = i90 + 32 | 0;
 i67 = i90;
 i9 = i14 + 26 | 0;
 HEAP16[i9 >> 1] = 0;
 if (!i8) {
  i89 = 0;
  STACKTOP = i90;
  return i89 | 0;
 }
 i2 = 0;
 do {
  HEAP32[i16 + (i2 * 80 | 0) + 48 >> 2] = 0;
  HEAP32[i16 + (i2 * 80 | 0) + 52 >> 2] = 0;
  HEAP32[i16 + (i2 * 80 | 0) + 56 >> 2] = 0;
  HEAPF32[i16 + (i2 * 80 | 0) + 72 >> 2] = Math_fround(0.0);
  i1 = i16 + (i2 * 80 | 0) + 44 | 0;
  i3 = i16 + (i2 * 80 | 0) | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAPF32[i1 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i16 + (i2 * 80 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i16 + (i2 * 80 | 0) + 64 >> 2] = Math_fround(0.0);
  HEAPF32[i16 + (i2 * 80 | 0) + 68 >> 2] = Math_fround(0.0);
  HEAP16[i16 + (i2 * 80 | 0) + 76 >> 1] = 0;
  HEAP16[i16 + (i2 * 80 | 0) + 78 >> 1] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 12);
 HEAP32[i82 >> 2] = HEAP32[gb + 62560 >> 2];
 HEAP32[i82 + 4 >> 2] = HEAP32[gb + 62560 + 4 >> 2];
 HEAP32[i82 + 8 >> 2] = HEAP32[gb + 62560 + 8 >> 2];
 HEAP32[i82 + 12 >> 2] = HEAP32[gb + 62560 + 12 >> 2];
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 i12 = i15 + 4 | 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 i13 = i15 + 8 | 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 i1 = mftCall_iiiiiiii(i8 | 0, i16 | 0, i15 | 0, 12, i82 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 L7 : do if (!i1) i1 = 0; else {
  i64 = i14 + 8 | 0;
  i65 = i14 + 12 | 0;
  i8 = (HEAP16[i65 >> 1] & HEAP16[i64 >> 1]) << 16 >> 16 != -1;
  i79 = i8 ? 176 : 112;
  i80 = Math_imul(i79, i1) | 0;
  i81 = i80 + 48 | 0;
  i3 = i80 + 79 & -16;
  do if (i3 >>> 0 > 16384) i2 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i10 >> 2] | 0, i3) | 0; else {
   i4 = i10 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i2 = i10 + 8 | 0;
   if (i5 | 0) {
    i6 = HEAP32[i2 >> 2] | 0;
    i7 = i6 + i3 | 0;
    if (i7 >>> 0 <= 16384) {
     HEAP32[i2 >> 2] = i7;
     i2 = i5 + i6 | 0;
     break;
    }
   }
   i78 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i10 >> 2] | 0, i11) | 0;
   HEAP32[i4 >> 2] = i78;
   HEAP32[i2 >> 2] = i3;
   i2 = i78;
  } while (0);
  switch (i2 | 0) {
  case -1:
  case 0:
   {
    i1 = 0;
    break L7;
   }
  default:
   {}
  }
  i75 = i14 + 16 | 0;
  HEAP32[i75 >> 2] = i2;
  HEAP16[i9 >> 1] = i81 >>> 4;
  HEAP32[i14 + 20 >> 2] = HEAP32[i21 + 32 >> 2];
  HEAP16[i14 + 24 >> 1] = 8;
  _memset(i2 | 0, 0, i81 | 0) | 0;
  i75 = HEAP32[i75 >> 2] | 0;
  i11 = i75 + 48 | 0;
  HEAP8[i75 >> 0] = i8 ? 4 : 2;
  HEAP8[i75 + 1 >> 0] = i1;
  HEAP8[i75 + 2 >> 0] = 0;
  HEAP32[i75 + 32 >> 2] = HEAP32[i82 >> 2];
  i76 = i82 + 4 | 0;
  HEAP32[i75 + 36 >> 2] = HEAP32[i76 >> 2];
  i77 = i82 + 8 | 0;
  HEAPF32[i75 + 40 >> 2] = Math_fround(-Math_fround(HEAPF32[i77 >> 2]));
  i78 = i82 + 12 | 0;
  HEAPF32[i75 + 44 >> 2] = Math_fround(-Math_fround(HEAPF32[i78 >> 2]));
  HEAP32[i75 + 16 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i75 + 20 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i75 + 24 >> 2] = HEAP32[i13 >> 2];
  HEAPF32[i75 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f84);
  HEAPF32[i75 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i21 + 4 >> 2]) * f84);
  i74 = i21 + 52 | 0;
  i28 = HEAP32[i74 >> 2] | 0;
  __ZN5physx14preprocessRowsEPPNS_14Px1DConstraintES1_jRKNS_17PxcSolverBodyDataES5_RKNS_24PxConstraintInvMassScaleEbb(i83, i16, i1, i88, i89, i82, i8 | (i28 & 512 | 0) != 0, (i28 & 256 | 0) != 0);
  f73 = HEAP32[i74 >> 2] & 128 | 0 ? Math_fround(.699999988) : Math_fround(1.0);
  i28 = i68 + 4 | 0;
  i29 = i68 + 8 | 0;
  i30 = i69 + 4 | 0;
  i31 = i69 + 8 | 0;
  i32 = i66 + 4 | 0;
  i33 = i66 + 8 | 0;
  i34 = i66 + 12 | 0;
  i35 = i66 + 16 | 0;
  i13 = i66 + 20 | 0;
  i14 = i66 + 24 | 0;
  i15 = i66 + 28 | 0;
  i16 = i67 + 4 | 0;
  i22 = i67 + 8 | 0;
  i23 = i67 + 12 | 0;
  i24 = i67 + 16 | 0;
  i25 = i67 + 20 | 0;
  i26 = i67 + 24 | 0;
  i27 = i67 + 28 | 0;
  i70 = i21 + 60 | 0;
  f71 = Math_fround(f84 * f84);
  i36 = i88 + 4 | 0;
  i37 = i88 + 8 | 0;
  i38 = i88 + 12 | 0;
  i39 = i88 + 16 | 0;
  i40 = i88 + 20 | 0;
  i41 = i88 + 24 | 0;
  i42 = i88 + 28 | 0;
  i43 = i88 + 32 | 0;
  i44 = i88 + 48 | 0;
  i45 = i89 + 4 | 0;
  i46 = i89 + 8 | 0;
  i47 = i89 + 12 | 0;
  i48 = i89 + 16 | 0;
  i49 = i89 + 20 | 0;
  i50 = i89 + 24 | 0;
  i51 = i89 + 28 | 0;
  i52 = i89 + 32 | 0;
  i53 = i89 + 48 | 0;
  i54 = i86 + 4 | 0;
  i55 = i86 + 8 | 0;
  i56 = i86 + 16 | 0;
  i57 = i86 + 20 | 0;
  i58 = i86 + 24 | 0;
  i59 = i87 + 4 | 0;
  i60 = i87 + 8 | 0;
  i61 = i87 + 16 | 0;
  i62 = i87 + 20 | 0;
  i63 = i87 + 24 | 0;
  i21 = f84 < Math_fround(1.0);
  f72 = i21 ? f84 : Math_fround(1.0);
  if (i8) {
   i12 = 0;
   while (1) {
    i9 = HEAP32[i83 + (i12 << 2) >> 2] | 0;
    i6 = i9 + 76 | 0;
    if (!(HEAP16[i6 >> 1] & 32)) f17 = Math_fround(1.0); else f17 = (HEAP32[i74 >> 2] & 64 | 0) == 0 ? Math_fround(1.0) : f72;
    f19 = Math_fround(f17 * Math_fround(HEAPF32[i9 + 44 >> 2]));
    f18 = Math_fround(f17 * Math_fround(HEAPF32[i9 + 60 >> 2]));
    i56 = HEAP32[i9 >> 2] | 0;
    HEAP32[i11 >> 2] = i56;
    i57 = HEAP32[i9 + 4 >> 2] | 0;
    HEAP32[i11 + 4 >> 2] = i57;
    i58 = HEAP32[i9 + 8 >> 2] | 0;
    HEAP32[i11 + 8 >> 2] = i58;
    i2 = i11 + 16 | 0;
    HEAP32[i2 >> 2] = HEAP32[i9 + 32 >> 2];
    i61 = i11 + 20 | 0;
    HEAP32[i61 >> 2] = HEAP32[i9 + 36 >> 2];
    i62 = i11 + 24 | 0;
    HEAP32[i62 >> 2] = HEAP32[i9 + 40 >> 2];
    i3 = i11 + 32 | 0;
    HEAP32[i3 >> 2] = HEAP32[i9 + 16 >> 2];
    i59 = i11 + 36 | 0;
    HEAP32[i59 >> 2] = HEAP32[i9 + 20 >> 2];
    i60 = i11 + 40 | 0;
    HEAP32[i60 >> 2] = HEAP32[i9 + 24 >> 2];
    i4 = i11 + 48 | 0;
    HEAP32[i4 >> 2] = HEAP32[i9 + 48 >> 2];
    i63 = i11 + 52 | 0;
    HEAP32[i63 >> 2] = HEAP32[i9 + 52 >> 2];
    i5 = i11 + 56 | 0;
    HEAP32[i5 >> 2] = HEAP32[i9 + 56 >> 2];
    HEAPF32[i11 + 96 >> 2] = f19;
    HEAPF32[i11 + 100 >> 2] = f18;
    i10 = i11 + 108 | 0;
    HEAP32[i10 >> 2] = 0;
    HEAPF32[i11 + 104 >> 2] = Math_fround(0.0);
    i55 = HEAP16[i64 >> 1] | 0;
    HEAP32[i68 >> 2] = i86;
    HEAP32[i28 >> 2] = i88;
    HEAP16[i29 >> 1] = i55;
    i55 = HEAP16[i65 >> 1] | 0;
    HEAP32[i69 >> 2] = i87;
    HEAP32[i30 >> 2] = i89;
    HEAP16[i31 >> 1] = i55;
    HEAP32[i66 >> 2] = i56;
    HEAP32[i32 >> 2] = i57;
    HEAP32[i33 >> 2] = i58;
    HEAPF32[i34 >> 2] = Math_fround(0.0);
    HEAP32[i35 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i60 >> 2];
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    f18 = Math_fround(HEAPF32[i82 >> 2]);
    f19 = Math_fround(HEAPF32[i76 >> 2]);
    f94 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
    f93 = Math_fround(-Math_fround(HEAPF32[i61 >> 2]));
    f92 = Math_fround(-Math_fround(HEAPF32[i62 >> 2]));
    f91 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
    f17 = Math_fround(-Math_fround(HEAPF32[i63 >> 2]));
    f20 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
    HEAPF32[i67 >> 2] = f94;
    HEAPF32[i16 >> 2] = f93;
    HEAPF32[i22 >> 2] = f92;
    HEAPF32[i23 >> 2] = Math_fround(0.0);
    HEAPF32[i24 >> 2] = f91;
    HEAPF32[i25 >> 2] = f17;
    HEAPF32[i26 >> 2] = f20;
    HEAPF32[i27 >> 2] = Math_fround(0.0);
    f20 = Math_fround(HEAPF32[i77 >> 2]);
    f20 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i68, i66, i11 + 112 | 0, f18, f19, i69, i67, i11 + 144 | 0, f20, Math_fround(HEAPF32[i78 >> 2]), 1));
    i5 = HEAP16[i6 >> 1] | 0;
    i63 = i5 & 65535;
    if ((i63 & 4 | 0) != 0 | (i63 & 3 | 0) == 3) {
     f17 = Math_fround(__ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_(i68, i11, i3));
     f17 = Math_fround(f17 - Math_fround(__ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_(i69, i2, i4)));
     i5 = HEAP16[i6 >> 1] | 0;
    } else f17 = Math_fround(0.0);
    i7 = i11 + 12 | 0;
    i8 = i11 + 28 | 0;
    i3 = i11 + 44 | 0;
    i4 = i11 + 60 | 0;
    i2 = f20 <= Math_fround(HEAPF32[i70 >> 2]);
    f19 = Math_fround(Math_fround(1.0) / f20);
    f19 = i2 ? Math_fround(0.0) : f19;
    i2 = i9 + 12 | 0;
    i6 = i5 & 65535;
    do if (!(i6 & 1)) {
     HEAPF32[i3 >> 2] = Math_fround(-f19);
     HEAPF32[i4 >> 2] = Math_fround(1.0);
     if (i5 & 4) {
      f17 = Math_fround(-f17);
      if (Math_fround(HEAPF32[i9 + 68 >> 2]) < f17) {
       f94 = Math_fround(Math_fround(f19 * Math_fround(HEAPF32[i9 + 64 >> 2])) * f17);
       HEAPF32[i7 >> 2] = f94;
       HEAPF32[i8 >> 2] = f94;
       break;
      }
     }
     i63 = i9 + 28 | 0;
     f94 = Math_fround(HEAPF32[i63 >> 2]);
     HEAPF32[i7 >> 2] = Math_fround(f19 * Math_fround(f94 - Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f85)));
     f94 = Math_fround(HEAPF32[i63 >> 2]);
     HEAPF32[i8 >> 2] = Math_fround(f19 * Math_fround(f94 - Math_fround(Math_fround(HEAPF32[i9 + 72 >> 2]) * f85)));
    } else {
     f17 = Math_fround(f73 * Math_fround(HEAPF32[i2 >> 2]));
     f94 = Math_fround(HEAPF32[i9 + 64 >> 2]);
     f18 = Math_fround(f71 * f94);
     f93 = Math_fround(HEAPF32[i9 + 68 >> 2]);
     f18 = Math_fround(f18 + Math_fround(f93 * f84));
     f17 = Math_fround(Math_fround(Math_fround(f93 * Math_fround(HEAPF32[i9 + 28 >> 2])) - Math_fround(f94 * f17)) * f84);
     if (!(i6 & 2)) {
      f94 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f20 * f18) + Math_fround(1.0)));
      f93 = Math_fround(f17 * f94);
      HEAPF32[i8 >> 2] = f93;
      HEAPF32[i7 >> 2] = f93;
      HEAPF32[i3 >> 2] = Math_fround(-Math_fround(f18 * f94));
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) - f94);
      break;
     } else {
      f94 = Math_fround(Math_fround(1.0) / Math_fround(f18 + Math_fround(1.0)));
      f93 = Math_fround(f19 * f94);
      f92 = Math_fround(f17 * f93);
      HEAPF32[i8 >> 2] = f92;
      HEAPF32[i7 >> 2] = f92;
      HEAPF32[i3 >> 2] = Math_fround(-Math_fround(f18 * f93));
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) - f94);
      break;
     }
    } while (0);
    if (i5 & 16) HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i1 | 0)) break; else i11 = i11 + i79 | 0;
   }
  } else {
   i21 = i11;
   i22 = 0;
   while (1) {
    i15 = HEAP32[i83 + (i22 << 2) >> 2] | 0;
    i2 = i15 + 76 | 0;
    if (!(HEAP16[i2 >> 1] & 32)) f17 = Math_fround(1.0); else f17 = (HEAP32[i74 >> 2] & 64 | 0) == 0 ? Math_fround(1.0) : f72;
    i65 = i15 + 32 | 0;
    i34 = i15 + 16 | 0;
    i68 = i15 + 48 | 0;
    f92 = Math_fround(f17 * Math_fround(HEAPF32[i15 + 44 >> 2]));
    f17 = Math_fround(f17 * Math_fround(HEAPF32[i15 + 60 >> 2]));
    HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
    i32 = i15 + 4 | 0;
    i3 = i21 + 4 | 0;
    HEAP32[i3 >> 2] = HEAP32[i32 >> 2];
    i33 = i15 + 8 | 0;
    i4 = i21 + 8 | 0;
    HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
    i5 = i21 + 16 | 0;
    HEAP32[i5 >> 2] = HEAP32[i65 >> 2];
    i66 = i15 + 36 | 0;
    i6 = i21 + 20 | 0;
    HEAP32[i6 >> 2] = HEAP32[i66 >> 2];
    i67 = i15 + 40 | 0;
    i7 = i21 + 24 | 0;
    HEAP32[i7 >> 2] = HEAP32[i67 >> 2];
    i8 = i21 + 32 | 0;
    HEAP32[i8 >> 2] = HEAP32[i34 >> 2];
    i35 = i15 + 20 | 0;
    i9 = i21 + 36 | 0;
    HEAP32[i9 >> 2] = HEAP32[i35 >> 2];
    i64 = i15 + 24 | 0;
    i10 = i21 + 40 | 0;
    HEAP32[i10 >> 2] = HEAP32[i64 >> 2];
    i11 = i21 + 48 | 0;
    HEAP32[i11 >> 2] = HEAP32[i68 >> 2];
    i69 = i15 + 52 | 0;
    i12 = i21 + 52 | 0;
    HEAP32[i12 >> 2] = HEAP32[i69 >> 2];
    i14 = i15 + 56 | 0;
    i13 = i21 + 56 | 0;
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAPF32[i21 + 96 >> 2] = f92;
    HEAPF32[i21 + 100 >> 2] = f17;
    i16 = i21 + 108 | 0;
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i21 + 104 >> 2] = Math_fround(0.0);
    f17 = Math_fround(HEAPF32[i82 >> 2]);
    f92 = Math_fround(HEAPF32[i76 >> 2]);
    f97 = Math_fround(HEAPF32[i34 >> 2]);
    f98 = Math_fround(f97 * Math_fround(HEAPF32[i88 >> 2]));
    f96 = Math_fround(f97 * Math_fround(HEAPF32[i36 >> 2]));
    f97 = Math_fround(f97 * Math_fround(HEAPF32[i37 >> 2]));
    f93 = Math_fround(HEAPF32[i35 >> 2]);
    f20 = Math_fround(f93 * Math_fround(HEAPF32[i38 >> 2]));
    f19 = Math_fround(f93 * Math_fround(HEAPF32[i39 >> 2]));
    f20 = Math_fround(f98 + f20);
    f19 = Math_fround(f96 + f19);
    f93 = Math_fround(f97 + Math_fround(f93 * Math_fround(HEAPF32[i40 >> 2])));
    f97 = Math_fround(HEAPF32[i64 >> 2]);
    f96 = Math_fround(f97 * Math_fround(HEAPF32[i41 >> 2]));
    f98 = Math_fround(f97 * Math_fround(HEAPF32[i42 >> 2]));
    f96 = Math_fround(f92 * Math_fround(f20 + f96));
    f98 = Math_fround(f92 * Math_fround(f19 + f98));
    f97 = Math_fround(f92 * Math_fround(f93 + Math_fround(f97 * Math_fround(HEAPF32[i43 >> 2]))));
    HEAPF32[i21 + 64 >> 2] = f96;
    HEAPF32[i21 + 68 >> 2] = f98;
    HEAPF32[i21 + 72 >> 2] = f97;
    f93 = Math_fround(HEAPF32[i15 >> 2]);
    f93 = Math_fround(f93 * f93);
    f92 = Math_fround(HEAPF32[i32 >> 2]);
    f92 = Math_fround(f93 + Math_fround(f92 * f92));
    f93 = Math_fround(HEAPF32[i33 >> 2]);
    f93 = Math_fround(f92 + Math_fround(f93 * f93));
    f92 = Math_fround(HEAPF32[i44 >> 2]);
    f93 = Math_fround(f17 * Math_fround(f92 * f93));
    f96 = Math_fround(f96 * Math_fround(HEAPF32[i34 >> 2]));
    f98 = Math_fround(f96 + Math_fround(f98 * Math_fround(HEAPF32[i35 >> 2])));
    f97 = Math_fround(f93 + Math_fround(f98 + Math_fround(f97 * Math_fround(HEAPF32[i64 >> 2]))));
    f98 = Math_fround(HEAPF32[i65 >> 2]);
    f93 = Math_fround(HEAPF32[i66 >> 2]);
    f96 = Math_fround(HEAPF32[i67 >> 2]);
    f17 = Math_fround(-Math_fround(HEAPF32[i68 >> 2]));
    f19 = Math_fround(-Math_fround(HEAPF32[i69 >> 2]));
    f20 = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
    f94 = Math_fround(HEAPF32[i77 >> 2]);
    f99 = Math_fround(HEAPF32[i78 >> 2]);
    f18 = Math_fround(Math_fround(HEAPF32[i89 >> 2]) * f17);
    f95 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * f17);
    f91 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f17);
    f101 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f19);
    f100 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) * f19);
    f101 = Math_fround(f18 + f101);
    f100 = Math_fround(f95 + f100);
    f91 = Math_fround(f91 + Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f19));
    f95 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f20);
    f18 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) * f20);
    f95 = Math_fround(f99 * Math_fround(f101 + f95));
    f18 = Math_fround(f99 * Math_fround(f100 + f18));
    f91 = Math_fround(f99 * Math_fround(f91 + Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f20)));
    HEAPF32[i21 + 80 >> 2] = f95;
    HEAPF32[i21 + 84 >> 2] = f18;
    HEAPF32[i21 + 88 >> 2] = f91;
    f96 = Math_fround(Math_fround(Math_fround(f98 * f98) + Math_fround(f93 * f93)) + Math_fround(f96 * f96));
    f93 = Math_fround(HEAPF32[i53 >> 2]);
    f20 = Math_fround(f97 + Math_fround(Math_fround(f94 * Math_fround(f96 * f93)) + Math_fround(Math_fround(Math_fround(f95 * f17) + Math_fround(f18 * f19)) + Math_fround(f91 * f20))));
    HEAPF32[i21 + 76 >> 2] = Math_fround(f92 * Math_fround(HEAPF32[i82 >> 2]));
    HEAPF32[i21 + 92 >> 2] = Math_fround(-Math_fround(f93 * f94));
    i14 = HEAP16[i2 >> 1] | 0;
    i69 = i14 & 65535;
    if ((i69 & 4 | 0) != 0 | (i69 & 3 | 0) == 3) {
     f17 = Math_fround(HEAPF32[i86 >> 2]);
     f17 = Math_fround(f17 * Math_fround(HEAPF32[i21 >> 2]));
     f99 = Math_fround(HEAPF32[i54 >> 2]);
     f99 = Math_fround(f17 + Math_fround(f99 * Math_fround(HEAPF32[i3 >> 2])));
     f17 = Math_fround(HEAPF32[i55 >> 2]);
     f17 = Math_fround(f99 + Math_fround(f17 * Math_fround(HEAPF32[i4 >> 2])));
     f99 = Math_fround(HEAPF32[i56 >> 2]);
     f99 = Math_fround(f99 * Math_fround(HEAPF32[i8 >> 2]));
     f100 = Math_fround(HEAPF32[i57 >> 2]);
     f100 = Math_fround(f99 + Math_fround(f100 * Math_fround(HEAPF32[i9 >> 2])));
     f99 = Math_fround(HEAPF32[i58 >> 2]);
     f99 = Math_fround(f17 + Math_fround(f100 + Math_fround(f99 * Math_fround(HEAPF32[i10 >> 2]))));
     f100 = Math_fround(HEAPF32[i87 >> 2]);
     f100 = Math_fround(f100 * Math_fround(HEAPF32[i5 >> 2]));
     f17 = Math_fround(HEAPF32[i59 >> 2]);
     f17 = Math_fround(f100 + Math_fround(f17 * Math_fround(HEAPF32[i6 >> 2])));
     f100 = Math_fround(HEAPF32[i60 >> 2]);
     f100 = Math_fround(f17 + Math_fround(f100 * Math_fround(HEAPF32[i7 >> 2])));
     f17 = Math_fround(HEAPF32[i61 >> 2]);
     f17 = Math_fround(f17 * Math_fround(HEAPF32[i11 >> 2]));
     f101 = Math_fround(HEAPF32[i62 >> 2]);
     f101 = Math_fround(f17 + Math_fround(f101 * Math_fround(HEAPF32[i12 >> 2])));
     f17 = Math_fround(HEAPF32[i63 >> 2]);
     f17 = Math_fround(f99 - Math_fround(f100 + Math_fround(f101 + Math_fround(f17 * Math_fround(HEAPF32[i13 >> 2])))));
    } else f17 = Math_fround(0.0);
    i6 = i21 + 12 | 0;
    i7 = i21 + 28 | 0;
    i3 = i21 + 44 | 0;
    i4 = i21 + 60 | 0;
    i2 = f20 <= Math_fround(HEAPF32[i70 >> 2]);
    f19 = Math_fround(Math_fround(1.0) / f20);
    f19 = i2 ? Math_fround(0.0) : f19;
    i2 = i15 + 12 | 0;
    i5 = i14 & 65535;
    do if (!(i5 & 1)) {
     HEAPF32[i3 >> 2] = Math_fround(-f19);
     HEAPF32[i4 >> 2] = Math_fround(1.0);
     if (i14 & 4) {
      f17 = Math_fround(-f17);
      if (Math_fround(HEAPF32[i15 + 68 >> 2]) < f17) {
       f101 = Math_fround(Math_fround(f19 * Math_fround(HEAPF32[i15 + 64 >> 2])) * f17);
       HEAPF32[i6 >> 2] = f101;
       HEAPF32[i7 >> 2] = f101;
       break;
      }
     }
     i69 = i15 + 28 | 0;
     f101 = Math_fround(HEAPF32[i69 >> 2]);
     HEAPF32[i6 >> 2] = Math_fround(f19 * Math_fround(f101 - Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f85)));
     f101 = Math_fround(HEAPF32[i69 >> 2]);
     HEAPF32[i7 >> 2] = Math_fround(f19 * Math_fround(f101 - Math_fround(Math_fround(HEAPF32[i15 + 72 >> 2]) * f85)));
    } else {
     f17 = Math_fround(f73 * Math_fround(HEAPF32[i2 >> 2]));
     f101 = Math_fround(HEAPF32[i15 + 64 >> 2]);
     f18 = Math_fround(f71 * f101);
     f100 = Math_fround(HEAPF32[i15 + 68 >> 2]);
     f18 = Math_fround(f18 + Math_fround(f100 * f84));
     f17 = Math_fround(Math_fround(Math_fround(f100 * Math_fround(HEAPF32[i15 + 28 >> 2])) - Math_fround(f101 * f17)) * f84);
     if (!(i5 & 2)) {
      f101 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f20 * f18) + Math_fround(1.0)));
      f100 = Math_fround(f17 * f101);
      HEAPF32[i7 >> 2] = f100;
      HEAPF32[i6 >> 2] = f100;
      HEAPF32[i3 >> 2] = Math_fround(-Math_fround(f18 * f101));
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) - f101);
      break;
     } else {
      f101 = Math_fround(Math_fround(1.0) / Math_fround(f18 + Math_fround(1.0)));
      f100 = Math_fround(f19 * f101);
      f99 = Math_fround(f17 * f100);
      HEAPF32[i7 >> 2] = f99;
      HEAPF32[i6 >> 2] = f99;
      HEAPF32[i3 >> 2] = Math_fround(-Math_fround(f18 * f100));
      HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) - f101);
      break;
     }
    } while (0);
    if (i14 & 16) HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 2;
    i22 = i22 + 1 | 0;
    if ((i22 | 0) == (i1 | 0)) break; else i21 = i21 + i79 | 0;
   }
  }
  HEAP32[i75 + i81 >> 2] = 0;
  HEAP32[i75 + (i80 + 52) >> 2] = 0;
 } while (0);
 i89 = i1;
 STACKTOP = i90;
 return i89 | 0;
}

function __ZN5physx2Gu17SweepBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i77, i80, i95, i2, i9, i98, f13, i94, i97, i96, i93, i10, f75, i1) {
 i77 = i77 | 0;
 i80 = i80 | 0;
 i95 = i95 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i98 = i98 | 0;
 f13 = Math_fround(f13);
 i94 = i94 | 0;
 i97 = i97 | 0;
 i96 = i96 | 0;
 i93 = i93 | 0;
 i10 = i10 | 0;
 f75 = Math_fround(f75);
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i11 = 0, i12 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i76 = 0, i78 = 0, i79 = 0, i81 = 0, i82 = 0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, i90 = 0, i91 = 0, i92 = 0, i99 = 0, f100 = f0, f101 = f0, f102 = f0, f103 = f0;
 i99 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i71 = i99 + 400 | 0;
 i81 = i99 + 384 | 0;
 i82 = i99 + 368 | 0;
 i73 = i99 + 208 | 0;
 i72 = i99 + 48 | 0;
 i79 = i99 + 64 | 0;
 i76 = i99 + 32 | 0;
 i74 = i99 + 16 | 0;
 i78 = i99;
 if (!i77) {
  i98 = 0;
  STACKTOP = i99;
  return i98 | 0;
 }
 i90 = (HEAP16[i1 >> 1] & 128) == 0;
 i51 = i9 + 16 | 0;
 f70 = Math_fround(HEAPF32[i51 >> 2]);
 f67 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f68 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 i55 = HEAP32[i2 + 4 >> 2] | 0;
 i54 = HEAP32[i2 + 8 >> 2] | 0;
 i53 = HEAP32[i2 + 12 >> 2] | 0;
 f61 = Math_fround(HEAPF32[i9 >> 2]);
 f89 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f66 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f59 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f65 = Math_fround(f61 + f61);
 f62 = Math_fround(f89 + f89);
 f56 = Math_fround(f66 + f66);
 f64 = Math_fround(f89 * f62);
 f60 = Math_fround(f66 * f56);
 f89 = Math_fround(f65 * f89);
 f69 = Math_fround(f65 * f66);
 f63 = Math_fround(f65 * f59);
 f66 = Math_fround(f62 * f66);
 f62 = Math_fround(f62 * f59);
 f59 = Math_fround(f56 * f59);
 f56 = Math_fround(Math_fround(Math_fround(1.0) - f64) - f60);
 f57 = Math_fround(f89 + f59);
 f58 = Math_fround(f69 - f62);
 f59 = Math_fround(f89 - f59);
 f65 = Math_fround(Math_fround(1.0) - Math_fround(f61 * f65));
 f60 = Math_fround(f65 - f60);
 f61 = Math_fround(f66 + f63);
 f62 = Math_fround(f69 + f62);
 f63 = Math_fround(f66 - f63);
 f64 = Math_fround(f65 - f64);
 f70 = Math_fround(-f70);
 f67 = Math_fround(-f67);
 f68 = Math_fround(-f68);
 f65 = Math_fround(Math_fround(f58 * f68) + Math_fround(Math_fround(f56 * f70) + Math_fround(f57 * f67)));
 f66 = Math_fround(Math_fround(f61 * f68) + Math_fround(Math_fround(f59 * f70) + Math_fround(f60 * f67)));
 f67 = Math_fround(Math_fround(f64 * f68) + Math_fround(Math_fround(f62 * f70) + Math_fround(f63 * f67)));
 f70 = Math_fround(HEAPF32[i98 >> 2]);
 f68 = Math_fround(f70 * f56);
 f69 = Math_fround(f70 * f59);
 f70 = Math_fround(f70 * f62);
 i91 = i98 + 4 | 0;
 f89 = Math_fround(HEAPF32[i91 >> 2]);
 f68 = Math_fround(f68 + Math_fround(f89 * f57));
 f69 = Math_fround(f69 + Math_fround(f89 * f60));
 f89 = Math_fround(f70 + Math_fround(f89 * f63));
 i92 = i98 + 8 | 0;
 f70 = Math_fround(HEAPF32[i92 >> 2]);
 f68 = Math_fround(f68 + Math_fround(f58 * f70));
 f69 = Math_fround(f69 + Math_fround(f61 * f70));
 f70 = Math_fround(f89 + Math_fround(f64 * f70));
 f89 = Math_fround(f68 * f13);
 f88 = Math_fround(f69 * f13);
 f87 = Math_fround(f70 * f13);
 HEAPF32[i81 >> 2] = Math_fround(0.0);
 HEAP32[i82 >> 2] = 0;
 HEAP32[i82 + 4 >> 2] = 0;
 HEAP32[i82 + 8 >> 2] = 0;
 HEAP32[i82 + 12 >> 2] = 0;
 f83 = Math_fround(-f68);
 f52 = Math_fround(-f69);
 f86 = Math_fround(-f70);
 f85 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f83 = Math_fround(f85 * (f68 > f83 ? f68 : f83));
 f84 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = Math_fround(f83 + Math_fround(f84 * (f69 > f52 ? f69 : f52)));
 f83 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = Math_fround(Math_fround(Math_fround(f83 * (f70 > f86 ? f70 : f86)) + f52) + f75);
 i50 = i73 + 64 | 0;
 HEAP32[i73 >> 2] = HEAP32[i82 >> 2];
 HEAP32[i73 + 4 >> 2] = HEAP32[i82 + 4 >> 2];
 HEAP32[i73 + 8 >> 2] = HEAP32[i82 + 8 >> 2];
 HEAP32[i73 + 12 >> 2] = HEAP32[i82 + 12 >> 2];
 HEAP32[i73 + 80 >> 2] = 3;
 HEAPF32[i73 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i71 >> 2] = 0;
 HEAP32[i71 + 4 >> 2] = 0;
 HEAP32[i71 + 8 >> 2] = 0;
 HEAP32[i71 + 12 >> 2] = 0;
 HEAP32[i50 >> 2] = HEAP32[i71 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
 HEAP32[i73 + 144 >> 2] = i55;
 HEAP32[i73 + 148 >> 2] = i54;
 HEAP32[i73 + 152 >> 2] = i53;
 HEAPF32[i73 + 156 >> 2] = Math_fround(0.0);
 f84 = f85 <= f84 ? f85 : f84;
 f83 = f84 <= f83 ? f84 : f83;
 HEAPF32[i73 + 16 >> 2] = Math_fround(f83 * Math_fround(.150000006));
 HEAPF32[i73 + 32 >> 2] = Math_fround(f83 * Math_fround(.0500000007));
 HEAPF32[i72 >> 2] = f89;
 i53 = i72 + 4 | 0;
 HEAPF32[i53 >> 2] = f88;
 i54 = i72 + 8 | 0;
 HEAPF32[i54 >> 2] = f87;
 i55 = i72 + 12 | 0;
 HEAPF32[i55 >> 2] = Math_fround(0.0);
 f87 = Math_fround(HEAPF32[i9 >> 2]);
 f88 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f89 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f83 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f84 = Math_fround(HEAPF32[i51 >> 2]);
 f85 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 f86 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 if (!i10) i51 = 0; else i51 = HEAP32[i10 >> 2] | 0;
 i27 = i79 + 64 | 0;
 i28 = i79 + 80 | 0;
 i29 = i79 + 16 | 0;
 i30 = i79 + 32 | 0;
 i31 = i79 + 48 | 0;
 i32 = i79 + 4 | 0;
 i33 = i79 + 8 | 0;
 i34 = i79 + 12 | 0;
 i35 = i79 + 96 | 0;
 i36 = i79 + 100 | 0;
 i37 = i79 + 104 | 0;
 i38 = i79 + 108 | 0;
 i39 = i79 + 112 | 0;
 i40 = i79 + 116 | 0;
 i41 = i79 + 120 | 0;
 i42 = i79 + 124 | 0;
 i43 = i79 + 128 | 0;
 i44 = i79 + 132 | 0;
 i45 = i79 + 136 | 0;
 i46 = i79 + 140 | 0;
 i47 = i74 + 4 | 0;
 i48 = i74 + 8 | 0;
 i49 = i78 + 4 | 0;
 i50 = i78 + 8 | 0;
 L7 : do if (i90 & (i95 ^ 1)) {
  i11 = 0;
  i10 = 0;
  i9 = 0;
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  i26 = 0;
  i1 = 0;
  i12 = 0;
  while (1) {
   i2 = (i26 | 0) == 0 ? i51 : (i26 | 0) == (i51 | 0) ? 0 : i26;
   f18 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 8 >> 2]);
   f21 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 12 >> 2]);
   f20 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 16 >> 2]);
   f19 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 20 >> 2]);
   f25 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 24 >> 2]);
   f100 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 28 >> 2]);
   f22 = Math_fround(HEAPF32[i80 + (i2 * 36 | 0) + 32 >> 2]);
   f14 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f18) + Math_fround(f57 * f17)) + Math_fround(f58 * f16)));
   f15 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f18) + Math_fround(f60 * f17)) + Math_fround(f61 * f16)));
   f16 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f18) + Math_fround(f63 * f17)) + Math_fround(f64 * f16)));
   f17 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f21) + Math_fround(f57 * f20)) + Math_fround(f58 * f19)));
   f18 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f21) + Math_fround(f60 * f20)) + Math_fround(f61 * f19)));
   f19 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f21) + Math_fround(f63 * f20)) + Math_fround(f64 * f19)));
   f20 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f25) + Math_fround(f57 * f100)) + Math_fround(f58 * f22)));
   f21 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f25) + Math_fround(f60 * f100)) + Math_fround(f61 * f22)));
   f22 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f25) + Math_fround(f63 * f100)) + Math_fround(f64 * f22)));
   f100 = Math_fround(f20 - f17);
   f25 = Math_fround(f21 - f18);
   f103 = Math_fround(f22 - f19);
   f101 = Math_fround(f14 - f17);
   f102 = Math_fround(f15 - f18);
   f24 = Math_fround(f16 - f19);
   f23 = Math_fround(Math_fround(f24 * f25) - Math_fround(f102 * f103));
   f24 = Math_fround(Math_fround(f101 * f103) - Math_fround(f24 * f100));
   f25 = Math_fround(Math_fround(f102 * f100) - Math_fround(f101 * f25));
   f101 = Math_fround(HEAPF32[i72 >> 2]);
   f100 = Math_fround(HEAPF32[i53 >> 2]);
   f100 = Math_fround(Math_fround(Math_fround(f23 * f101) + Math_fround(f24 * f100)) + Math_fround(f25 * Math_fround(HEAPF32[i54 >> 2])));
   if (!(f100 >= Math_fround(HEAPF32[i81 >> 2]))) {
    f103 = Math_fround(Math_fround(f70 * f16) + Math_fround(Math_fround(f68 * f14) + Math_fround(f69 * f15)));
    f102 = Math_fround(Math_fround(f70 * f19) + Math_fround(Math_fround(f68 * f17) + Math_fround(f69 * f18)));
    f101 = Math_fround(Math_fround(f70 * f22) + Math_fround(Math_fround(f68 * f20) + Math_fround(f69 * f21)));
    f102 = f102 > f101 ? f101 : f102;
    if (!((f103 > f102 ? f102 : f103) > Math_fround(f52 + f13))) {
     HEAP32[i28 >> 2] = 7;
     HEAPF32[i31 >> 2] = Math_fround(0.0);
     HEAP32[i71 >> 2] = 0;
     HEAP32[i71 + 4 >> 2] = 0;
     HEAP32[i71 + 8 >> 2] = 0;
     HEAP32[i71 + 12 >> 2] = 0;
     HEAP32[i27 >> 2] = HEAP32[i71 >> 2];
     HEAP32[i27 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
     HEAP32[i27 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
     HEAP32[i27 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
     f102 = Math_fround(Math_fround(Math_fround(f15 + f18) + f21) * Math_fround(.333332986));
     f103 = Math_fround(Math_fround(Math_fround(f16 + f19) + f22) * Math_fround(.333332986));
     HEAPF32[i79 >> 2] = Math_fround(Math_fround(Math_fround(f14 + f17) + f20) * Math_fround(.333332986));
     HEAPF32[i32 >> 2] = f102;
     HEAPF32[i33 >> 2] = f103;
     HEAPF32[i34 >> 2] = Math_fround(0.0);
     HEAPF32[i35 >> 2] = f14;
     HEAPF32[i36 >> 2] = f15;
     HEAPF32[i37 >> 2] = f16;
     HEAPF32[i38 >> 2] = Math_fround(0.0);
     HEAPF32[i39 >> 2] = f17;
     HEAPF32[i40 >> 2] = f18;
     HEAPF32[i41 >> 2] = f19;
     HEAPF32[i42 >> 2] = Math_fround(0.0);
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = f21;
     HEAPF32[i45 >> 2] = f22;
     HEAPF32[i46 >> 2] = Math_fround(0.0);
     HEAPF32[i29 >> 2] = Math_fround(0.0);
     HEAPF32[i30 >> 2] = Math_fround(3402823469999999843913219.0e14);
     if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i79, i73, i81, i82, i72, i76, i78, i74, f75, 0) | 0) {
      f103 = Math_fround(HEAPF32[i81 >> 2]);
      f3 = Math_fround(HEAPF32[i76 >> 2]);
      if (f103 >= f3) {
       i1 = i2;
       i2 = 17;
       break L7;
      }
      f13 = Math_fround(f13 * f3);
      f4 = Math_fround(f69 * f13);
      f5 = Math_fround(f70 * f13);
      HEAPF32[i72 >> 2] = Math_fround(f68 * f13);
      HEAPF32[i53 >> 2] = f4;
      HEAPF32[i54 >> 2] = f5;
      HEAPF32[i55 >> 2] = Math_fround(0.0);
      f5 = Math_fround(HEAPF32[i74 >> 2]);
      f4 = Math_fround(HEAPF32[i47 >> 2]);
      f3 = Math_fround(HEAPF32[i48 >> 2]);
      f8 = Math_fround(HEAPF32[i78 >> 2]);
      f7 = Math_fround(HEAPF32[i49 >> 2]);
      f6 = Math_fround(HEAPF32[i50 >> 2]);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
      i9 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = i2;
      i12 = 1;
     }
    }
   }
   i26 = i26 + 1 | 0;
   if (i26 >>> 0 >= i77 >>> 0) {
    i2 = 19;
    break;
   }
  }
 } else {
  i11 = 0;
  i10 = 0;
  i9 = 0;
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  i26 = 0;
  i2 = 0;
  i12 = 0;
  while (1) {
   i1 = (i26 | 0) == 0 ? i51 : (i26 | 0) == (i51 | 0) ? 0 : i26;
   f18 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 8 >> 2]);
   f21 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 12 >> 2]);
   f20 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 16 >> 2]);
   f19 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 20 >> 2]);
   f25 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 24 >> 2]);
   f102 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 28 >> 2]);
   f22 = Math_fround(HEAPF32[i80 + (i1 * 36 | 0) + 32 >> 2]);
   f14 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f18) + Math_fround(f57 * f17)) + Math_fround(f58 * f16)));
   f15 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f18) + Math_fround(f60 * f17)) + Math_fround(f61 * f16)));
   f16 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f18) + Math_fround(f63 * f17)) + Math_fround(f64 * f16)));
   f17 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f21) + Math_fround(f57 * f20)) + Math_fround(f58 * f19)));
   f18 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f21) + Math_fround(f60 * f20)) + Math_fround(f61 * f19)));
   f19 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f21) + Math_fround(f63 * f20)) + Math_fround(f64 * f19)));
   f20 = Math_fround(f65 + Math_fround(Math_fround(Math_fround(f56 * f25) + Math_fround(f57 * f102)) + Math_fround(f58 * f22)));
   f21 = Math_fround(f66 + Math_fround(Math_fround(Math_fround(f59 * f25) + Math_fround(f60 * f102)) + Math_fround(f61 * f22)));
   f22 = Math_fround(f67 + Math_fround(Math_fround(Math_fround(f62 * f25) + Math_fround(f63 * f102)) + Math_fround(f64 * f22)));
   f102 = Math_fround(f20 - f17);
   f25 = Math_fround(f21 - f18);
   f100 = Math_fround(f22 - f19);
   f103 = Math_fround(f14 - f17);
   f101 = Math_fround(f15 - f18);
   f24 = Math_fround(f16 - f19);
   f23 = Math_fround(Math_fround(f24 * f25) - Math_fround(f101 * f100));
   f24 = Math_fround(Math_fround(f103 * f100) - Math_fround(f24 * f102));
   f25 = Math_fround(Math_fround(f101 * f102) - Math_fround(f103 * f25));
   f103 = Math_fround(Math_fround(f70 * f16) + Math_fround(Math_fround(f68 * f14) + Math_fround(f69 * f15)));
   f102 = Math_fround(Math_fround(f70 * f19) + Math_fround(Math_fround(f68 * f17) + Math_fround(f69 * f18)));
   f101 = Math_fround(Math_fround(f70 * f22) + Math_fround(Math_fround(f68 * f20) + Math_fround(f69 * f21)));
   f102 = f102 > f101 ? f101 : f102;
   if ((f103 > f102 ? f102 : f103) > Math_fround(f52 + f13)) i1 = i2; else {
    HEAP32[i28 >> 2] = 7;
    HEAPF32[i31 >> 2] = Math_fround(0.0);
    HEAP32[i71 >> 2] = 0;
    HEAP32[i71 + 4 >> 2] = 0;
    HEAP32[i71 + 8 >> 2] = 0;
    HEAP32[i71 + 12 >> 2] = 0;
    HEAP32[i27 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i27 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i27 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    HEAP32[i27 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
    f102 = Math_fround(Math_fround(Math_fround(f15 + f18) + f21) * Math_fround(.333332986));
    f103 = Math_fround(Math_fround(Math_fround(f16 + f19) + f22) * Math_fround(.333332986));
    HEAPF32[i79 >> 2] = Math_fround(Math_fround(Math_fround(f14 + f17) + f20) * Math_fround(.333332986));
    HEAPF32[i32 >> 2] = f102;
    HEAPF32[i33 >> 2] = f103;
    HEAPF32[i34 >> 2] = Math_fround(0.0);
    HEAPF32[i35 >> 2] = f14;
    HEAPF32[i36 >> 2] = f15;
    HEAPF32[i37 >> 2] = f16;
    HEAPF32[i38 >> 2] = Math_fround(0.0);
    HEAPF32[i39 >> 2] = f17;
    HEAPF32[i40 >> 2] = f18;
    HEAPF32[i41 >> 2] = f19;
    HEAPF32[i42 >> 2] = Math_fround(0.0);
    HEAPF32[i43 >> 2] = f20;
    HEAPF32[i44 >> 2] = f21;
    HEAPF32[i45 >> 2] = f22;
    HEAPF32[i46 >> 2] = Math_fround(0.0);
    HEAPF32[i29 >> 2] = Math_fround(0.0);
    HEAPF32[i30 >> 2] = Math_fround(3402823469999999843913219.0e14);
    if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i79, i73, i81, i82, i72, i76, i78, i74, f75, 0) | 0) {
     f103 = Math_fround(HEAPF32[i81 >> 2]);
     f3 = Math_fround(HEAPF32[i76 >> 2]);
     if (f103 >= f3) {
      i2 = 17;
      break L7;
     }
     f13 = Math_fround(f13 * f3);
     f4 = Math_fround(f69 * f13);
     f5 = Math_fround(f70 * f13);
     HEAPF32[i72 >> 2] = Math_fround(f68 * f13);
     HEAPF32[i53 >> 2] = f4;
     HEAPF32[i54 >> 2] = f5;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i74 >> 2]);
     f4 = Math_fround(HEAPF32[i47 >> 2]);
     f3 = Math_fround(HEAPF32[i48 >> 2]);
     f8 = Math_fround(HEAPF32[i78 >> 2]);
     f7 = Math_fround(HEAPF32[i49 >> 2]);
     f6 = Math_fround(HEAPF32[i50 >> 2]);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = 1;
    } else i1 = i2;
   }
   i26 = i26 + 1 | 0;
   if (i26 >>> 0 >= i77 >>> 0) {
    i2 = 19;
    break;
   } else i2 = i1;
  }
 } while (0);
 if ((i2 | 0) == 17) {
  HEAPF32[i96 >> 2] = Math_fround(0.0);
  HEAP32[i93 >> 2] = i1;
  f101 = Math_fround(-Math_fround(HEAPF32[i98 >> 2]));
  f102 = Math_fround(-Math_fround(HEAPF32[i91 >> 2]));
  f103 = Math_fround(-Math_fround(HEAPF32[i92 >> 2]));
  HEAPF32[i97 >> 2] = f101;
  HEAPF32[i97 + 4 >> 2] = f102;
  HEAPF32[i97 + 8 >> 2] = f103;
  i1 = 1;
 } else if ((i2 | 0) == 19) if (i12) {
  HEAP32[i93 >> 2] = i1;
  f68 = Math_fround(Math_fround(f83 * f83) + Math_fround(-.5));
  f100 = Math_fround(Math_fround(f89 * f6) + Math_fround(Math_fround(f88 * f7) + Math_fround(f87 * f8)));
  f69 = Math_fround(Math_fround(Math_fround(Math_fround(f68 * f8) + Math_fround(f83 * Math_fround(Math_fround(f88 * f6) - Math_fround(f89 * f7)))) + Math_fround(f87 * f100)) * Math_fround(2.0));
  f75 = Math_fround(Math_fround(Math_fround(f88 * f100) + Math_fround(Math_fround(f68 * f7) + Math_fround(f83 * Math_fround(Math_fround(f89 * f8) - Math_fround(f87 * f6))))) * Math_fround(2.0));
  f100 = Math_fround(Math_fround(Math_fround(Math_fround(f68 * f6) + Math_fround(f83 * Math_fround(Math_fround(f87 * f7) - Math_fround(f88 * f8)))) + Math_fround(f89 * f100)) * Math_fround(2.0));
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f100 * f100) + Math_fround(Math_fround(f69 * f69) + Math_fround(f75 * f75))))));
  f75 = Math_fround(-Math_fround(f75 * f70));
  f100 = Math_fround(-Math_fround(f100 * f70));
  f103 = Math_fround(Math_fround(f89 * f3) + Math_fround(Math_fround(f88 * f4) + Math_fround(f87 * f5)));
  f101 = Math_fround(f84 + Math_fround(Math_fround(Math_fround(Math_fround(f68 * f5) + Math_fround(f83 * Math_fround(Math_fround(f88 * f3) - Math_fround(f89 * f4)))) + Math_fround(f87 * f103)) * Math_fround(2.0)));
  f102 = Math_fround(f85 + Math_fround(Math_fround(Math_fround(f88 * f103) + Math_fround(Math_fround(f68 * f4) + Math_fround(f83 * Math_fround(Math_fround(f89 * f5) - Math_fround(f87 * f3))))) * Math_fround(2.0)));
  f103 = Math_fround(f86 + Math_fround(Math_fround(Math_fround(Math_fround(f68 * f3) + Math_fround(f83 * Math_fround(Math_fround(f87 * f4) - Math_fround(f88 * f5)))) + Math_fround(f89 * f103)) * Math_fround(2.0)));
  HEAPF32[i97 >> 2] = Math_fround(-Math_fround(f69 * f70));
  i1 = i97 + 4 | 0;
  HEAPF32[i1 >> 2] = f75;
  i2 = i97 + 8 | 0;
  HEAPF32[i2 >> 2] = f100;
  HEAPF32[i94 >> 2] = f101;
  HEAPF32[i94 + 4 >> 2] = f102;
  HEAPF32[i94 + 8 >> 2] = f103;
  HEAPF32[i96 >> 2] = f13;
  if (i90 | i95) i1 = 1; else {
   f103 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f103 = Math_fround(f103 * Math_fround(HEAPF32[i98 >> 2]));
   f102 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f103 + Math_fround(f102 * Math_fround(HEAPF32[i91 >> 2])));
   f103 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (Math_fround(f102 + Math_fround(f103 * Math_fround(HEAPF32[i92 >> 2]))) > Math_fround(0.0)) {
    f101 = Math_fround(-Math_fround(HEAPF32[i97 >> 2]));
    f102 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
    f103 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
    HEAPF32[i97 >> 2] = f101;
    HEAPF32[i1 >> 2] = f102;
    HEAPF32[i2 >> 2] = f103;
    i1 = 1;
   } else i1 = 1;
  }
 } else i1 = 0;
 i98 = i1;
 STACKTOP = i99;
 return i98 | 0;
}

function __ZN5Umbra11TileMatcher10matchTilesEiRKNS_8RectBaseINS_8Vector2iEiEEiS5_(i74, i1, i2, i3, i4) {
 i74 = i74 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, f93 = f0;
 i84 = STACKTOP;
 STACKTOP = STACKTOP + 2688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i84 + 104 | 0;
 i79 = i84;
 i80 = i84 + 88 | 0;
 i81 = i84 + 72 | 0;
 i82 = i84 + 56 | 0;
 i75 = i84 + 40 | 0;
 i76 = i84 + 2676 | 0;
 i77 = i84 + 2664 | 0;
 HEAP32[i78 + 32 >> 2] = i1;
 i34 = i2;
 i35 = HEAP32[i34 + 4 >> 2] | 0;
 i36 = i78;
 HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i36 + 4 >> 2] = i35;
 i36 = i2 + 8 | 0;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 i34 = i78 + 8 | 0;
 HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 HEAP32[i78 + 36 >> 2] = i3;
 i34 = i4;
 i35 = HEAP32[i34 + 4 >> 2] | 0;
 i36 = i78 + 16 | 0;
 HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i36 + 4 >> 2] = i35;
 i36 = i4 + 8 | 0;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 i34 = i78 + 24 | 0;
 HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 i34 = i79 + 4 | 0;
 i35 = i79 + 8 | 0;
 i36 = i79 + 12 | 0;
 i37 = i79 + 16 | 0;
 i38 = i79 + 20 | 0;
 i39 = i79 + 24 | 0;
 i40 = i79 + 28 | 0;
 i41 = i79 + 32 | 0;
 i42 = i74 + 36 | 0;
 i43 = i74 + 52 | 0;
 i44 = i74 + 40 | 0;
 i45 = i74 + 44 | 0;
 i46 = i74 + 56 | 0;
 i47 = i74 + 60 | 0;
 i48 = i74 + 48 | 0;
 i49 = i74 + 68 | 0;
 i50 = i74 + 8 | 0;
 i51 = i74 + 64 | 0;
 i52 = i74 + 4 | 0;
 i53 = i79 + 16 | 0;
 i54 = i79 + 8 | 0;
 i55 = i80 + 8 | 0;
 i56 = i80 + 8 | 0;
 i57 = i81 + 8 | 0;
 i58 = i79 + 24 | 0;
 i59 = i80 + 8 | 0;
 i60 = i80 + 8 | 0;
 i61 = i81 + 8 | 0;
 i62 = i82 + 8 | 0;
 i63 = i82 + 8 | 0;
 i64 = i75 + 8 | 0;
 i65 = i74 + 12 | 0;
 i66 = i74 + 24 | 0;
 i67 = i74 + 28 | 0;
 i68 = i74 + 16 | 0;
 i69 = i74 + 32 | 0;
 i70 = i74 + 20 | 0;
 i71 = i77 + 4 | 0;
 i72 = i77 + 8 | 0;
 i73 = i80 + 8 | 0;
 i19 = i80 + 12 | 0;
 i20 = i81 + 4 | 0;
 i21 = i81 + 8 | 0;
 i22 = i81 + 12 | 0;
 i23 = i80 + 8 | 0;
 i24 = i81 + 8 | 0;
 i25 = i76 + 4 | 0;
 i26 = i76 + 8 | 0;
 i27 = i80 + 8 | 0;
 i28 = i80 + 12 | 0;
 i29 = i81 + 4 | 0;
 i30 = i81 + 8 | 0;
 i31 = i81 + 12 | 0;
 i32 = i80 + 8 | 0;
 i33 = i81 + 8 | 0;
 i1 = 1;
 do {
  i18 = i1 + -1 | 0;
  i10 = i78 + (i18 * 40 | 0) | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  HEAP32[i79 >> 2] = i8;
  i9 = HEAP32[i78 + (i18 * 40 | 0) + 4 >> 2] | 0;
  HEAP32[i34 >> 2] = i9;
  i12 = HEAP32[i78 + (i18 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i35 >> 2] = i12;
  i16 = HEAP32[i78 + (i18 * 40 | 0) + 12 >> 2] | 0;
  HEAP32[i36 >> 2] = i16;
  i2 = HEAP32[i78 + (i18 * 40 | 0) + 16 >> 2] | 0;
  HEAP32[i37 >> 2] = i2;
  i14 = HEAP32[i78 + (i18 * 40 | 0) + 20 >> 2] | 0;
  HEAP32[i38 >> 2] = i14;
  i3 = HEAP32[i78 + (i18 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i39 >> 2] = i3;
  i17 = HEAP32[i78 + (i18 * 40 | 0) + 28 >> 2] | 0;
  HEAP32[i40 >> 2] = i17;
  i11 = i78 + (i18 * 40 | 0) + 32 | 0;
  i15 = i11;
  i13 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = i41;
  HEAP32[i5 >> 2] = i13;
  HEAP32[i5 + 4 >> 2] = i15;
  i5 = HEAP32[i42 >> 2] | 0;
  i6 = i13 << 1;
  i6 = (HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + (i6 >> 5 << 2) >> 2] | 0) >>> (i6 & 30) & 3;
  i7 = HEAP32[i43 >> 2] | 0;
  i85 = _bitshift64Shl(i15 | 0, 0, 1) | 0;
  getTempRet0() | 0;
  i85 = (HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + (i85 >> 5 << 2) >> 2] | 0) >>> (i85 & 30);
  i4 = i85 & 3;
  L3 : do if ((i6 & i85 | 0) == 3) {
   i1 = HEAP32[i44 >> 2] | 0;
   i13 = i13 - (__ZNK5Umbra6KDTree4rankEi(i5, i13) | 0) | 0;
   i11 = HEAP32[i45 >> 2] | 0;
   i13 = Math_imul(i13, i11) | 0;
   i85 = i13 >> 5;
   i13 = i13 & 31;
   i11 = (HEAP32[i1 + (i85 + 1 << 2) >> 2] << 32 - i13 & -1 << (i13 ^ 31) | (HEAP32[i1 + (i85 << 2) >> 2] | 0) >>> i13) & (1 << i11) + -1;
   i13 = HEAP32[i46 >> 2] | 0;
   i85 = i15 - (__ZNK5Umbra6KDTree4rankEi(i7, i15) | 0) | 0;
   i1 = HEAP32[i47 >> 2] | 0;
   i85 = Math_imul(i85, i1) | 0;
   i15 = i85 >> 5;
   i85 = i85 & 31;
   i1 = (HEAP32[i13 + (i15 + 1 << 2) >> 2] << 32 - i85 & -1 << (i85 ^ 31) | (HEAP32[i13 + (i15 << 2) >> 2] | 0) >>> i85) & (1 << i1) + -1;
   if ((i11 | 0) == (HEAP32[i48 >> 2] | 0)) i1 = i18; else if ((i1 | 0) == (HEAP32[i49 >> 2] | 0)) i1 = i18; else {
    i10 = (i8 | 0) >= (i2 | 0) ? i8 : i2;
    i9 = (i9 | 0) >= (i14 | 0) ? i9 : i14;
    i8 = (i12 | 0) <= (i3 | 0) ? i12 : i3;
    i6 = (i16 | 0) <= (i17 | 0) ? i16 : i17;
    f88 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f87 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f86 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (!(f88 > f87) & !(f86 > (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
     i5 = HEAP32[i50 >> 2] | 0;
     i7 = i5 << 29 | HEAP32[i51 >> 2];
     i5 = 0 - (i5 & 1) & 65535 | i1 << 16;
     i3 = HEAP32[(HEAP32[(HEAP32[i52 >> 2] | 0) + 4 >> 2] | 0) + (i11 << 2) >> 2] | 0;
     i4 = HEAP32[i74 >> 2] | 0;
     L8 : do if (i3 | 0) {
      i2 = HEAP32[i4 + 4 >> 2] | 0;
      i1 = i3;
      while (1) {
       i1 = i1 + -1 | 0;
       if ((HEAP32[i2 + (i1 * 28 | 0) >> 2] | 0) == (i7 | 0)) if ((HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] | 0) == (i5 | 0)) break;
       i1 = HEAP32[i2 + (i1 * 28 | 0) + 24 >> 2] | 0;
       if (!i1) break L8;
      }
      i16 = i2 + (i1 * 28 | 0) + 8 | 0;
      i14 = HEAP32[i16 >> 2] | 0;
      i15 = HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] | 0;
      i17 = HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] | 0;
      i85 = HEAP32[i2 + (i1 * 28 | 0) + 20 >> 2] | 0;
      HEAP32[i16 >> 2] = (i10 | 0) <= (i14 | 0) ? i10 : i14;
      HEAP32[i16 + 4 >> 2] = (i9 | 0) <= (i15 | 0) ? i9 : i15;
      i1 = i2 + (i1 * 28 | 0) + 16 | 0;
      HEAP32[i1 >> 2] = (i8 | 0) >= (i17 | 0) ? i8 : i17;
      HEAP32[i1 + 4 >> 2] = (i6 | 0) >= (i85 | 0) ? i6 : i85;
      i1 = i18;
      break L3;
     } while (0);
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if (__ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb(i4, i1 + 1 | 0, 1, 0, 0) | 0) {
      i85 = HEAP32[i4 + 4 >> 2] | 0;
      i17 = i85 + (i1 * 28 | 0) | 0;
      HEAP32[i17 >> 2] = i7;
      HEAP32[i17 + 4 >> 2] = i5;
      i17 = i85 + (i1 * 28 | 0) + 8 | 0;
      HEAP32[i17 >> 2] = i10;
      HEAP32[i17 + 4 >> 2] = i9;
      i17 = i85 + (i1 * 28 | 0) + 16 | 0;
      HEAP32[i17 >> 2] = i8;
      HEAP32[i17 + 4 >> 2] = i6;
      HEAP32[i85 + (i1 * 28 | 0) + 24 >> 2] = i3;
     }
     HEAP32[(HEAP32[(HEAP32[i52 >> 2] | 0) + 4 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[(HEAP32[i74 >> 2] | 0) + 12 >> 2];
     i1 = i18;
    } else i1 = i18;
   }
  } else {
   if ((i8 | 0) == (i2 | 0) & (i9 | 0) == (i14 | 0) & (i12 | 0) == (i3 | 0) & (i16 | 0) == (i17 | 0)) if ((HEAP32[i5 + 24 >> 2] | 0) <= (i13 | 0)) if ((HEAP32[i7 + 24 >> 2] | 0) <= (i15 | 0)) {
    if ((i6 | 0) == (i4 | 0)) {
     i16 = (__ZNK5Umbra6KDTree4rankEi(i5, i13) | 0) << 1;
     i17 = HEAP32[i74 + 76 + (i6 << 2) >> 2] | 0;
     i85 = (__ZNK5Umbra6KDTree4rankEi(i7, i15) | 0) << 1;
     i14 = ((HEAP32[i54 + (i17 << 2) >> 2] | 0) + (HEAP32[i79 + (i17 << 2) >> 2] | 0) | 0) / 2 | 0;
     i13 = i79;
     i12 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i80;
     HEAP32[i9 >> 2] = i12;
     HEAP32[i9 + 4 >> 2] = i13;
     i9 = i54;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     i15 = i56;
     HEAP32[i15 >> 2] = i8;
     HEAP32[i15 + 4 >> 2] = i9;
     HEAP32[i55 + (i17 << 2) >> 2] = i14;
     i15 = i81;
     HEAP32[i15 >> 2] = i12;
     HEAP32[i15 + 4 >> 2] = i13;
     i15 = i57;
     HEAP32[i15 >> 2] = i8;
     HEAP32[i15 + 4 >> 2] = i9;
     HEAP32[i81 + (i17 << 2) >> 2] = i14;
     HEAP32[i11 >> 2] = i16 + -1;
     i17 = i10;
     HEAP32[i17 >> 2] = i12;
     HEAP32[i17 + 4 >> 2] = i13;
     i17 = i56;
     i14 = HEAP32[i17 >> 2] | 0;
     i17 = HEAP32[i17 + 4 >> 2] | 0;
     i15 = i78 + (i18 * 40 | 0) + 8 | 0;
     HEAP32[i15 >> 2] = i14;
     HEAP32[i15 + 4 >> 2] = i17;
     HEAP32[i78 + (i18 * 40 | 0) + 36 >> 2] = i85 + -1;
     i15 = i78 + (i18 * 40 | 0) + 16 | 0;
     HEAP32[i15 >> 2] = i12;
     HEAP32[i15 + 4 >> 2] = i13;
     i15 = i78 + (i18 * 40 | 0) + 24 | 0;
     HEAP32[i15 >> 2] = i14;
     HEAP32[i15 + 4 >> 2] = i17;
     HEAP32[i78 + (i1 * 40 | 0) + 32 >> 2] = i16;
     i16 = i81;
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i18 = i78 + (i1 * 40 | 0) | 0;
     HEAP32[i18 >> 2] = i15;
     HEAP32[i18 + 4 >> 2] = i16;
     i18 = i57;
     i17 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i14 = i78 + (i1 * 40 | 0) + 8 | 0;
     HEAP32[i14 >> 2] = i17;
     HEAP32[i14 + 4 >> 2] = i18;
     HEAP32[i78 + (i1 * 40 | 0) + 36 >> 2] = i85;
     i85 = i78 + (i1 * 40 | 0) + 16 | 0;
     HEAP32[i85 >> 2] = i15;
     HEAP32[i85 + 4 >> 2] = i16;
     i85 = i78 + (i1 * 40 | 0) + 24 | 0;
     HEAP32[i85 >> 2] = i17;
     HEAP32[i85 + 4 >> 2] = i18;
     i1 = i1 + 1 | 0;
     break;
    }
    if ((i6 | 0) != 3 & (i4 | 0) != 3) {
     i8 = (__ZNK5Umbra6KDTree4rankEi(i5, i13) | 0) << 1;
     i2 = i8 + -1 | 0;
     i14 = HEAP32[i74 + 76 + (i6 << 2) >> 2] | 0;
     i5 = (__ZNK5Umbra6KDTree4rankEi(i7, i15) | 0) << 1;
     i13 = i5 + -1 | 0;
     i89 = HEAP32[i74 + 76 + (i4 << 2) >> 2] | 0;
     i15 = ((HEAP32[i54 + (i14 << 2) >> 2] | 0) + (HEAP32[i79 + (i14 << 2) >> 2] | 0) | 0) / 2 | 0;
     i90 = ((HEAP32[i58 + (i89 << 2) >> 2] | 0) + (HEAP32[i53 + (i89 << 2) >> 2] | 0) | 0) / 2 | 0;
     i91 = i79;
     i92 = HEAP32[i91 >> 2] | 0;
     i91 = HEAP32[i91 + 4 >> 2] | 0;
     i9 = i80;
     HEAP32[i9 >> 2] = i92;
     HEAP32[i9 + 4 >> 2] = i91;
     i9 = i54;
     i17 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     i16 = i60;
     HEAP32[i16 >> 2] = i17;
     HEAP32[i16 + 4 >> 2] = i9;
     HEAP32[i59 + (i14 << 2) >> 2] = i15;
     i16 = i81;
     HEAP32[i16 >> 2] = i92;
     HEAP32[i16 + 4 >> 2] = i91;
     i16 = i61;
     HEAP32[i16 >> 2] = i17;
     HEAP32[i16 + 4 >> 2] = i9;
     HEAP32[i81 + (i14 << 2) >> 2] = i15;
     i15 = i53;
     i14 = HEAP32[i15 >> 2] | 0;
     i15 = HEAP32[i15 + 4 >> 2] | 0;
     i16 = i82;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i16 + 4 >> 2] = i15;
     i16 = i58;
     i9 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i17 = i63;
     HEAP32[i17 >> 2] = i9;
     HEAP32[i17 + 4 >> 2] = i16;
     HEAP32[i62 + (i89 << 2) >> 2] = i90;
     i17 = i75;
     HEAP32[i17 >> 2] = i14;
     HEAP32[i17 + 4 >> 2] = i15;
     i17 = i64;
     HEAP32[i17 >> 2] = i9;
     HEAP32[i17 + 4 >> 2] = i16;
     HEAP32[i75 + (i89 << 2) >> 2] = i90;
     HEAP32[i11 >> 2] = i2;
     i89 = i10;
     HEAP32[i89 >> 2] = i92;
     HEAP32[i89 + 4 >> 2] = i91;
     i89 = i60;
     i90 = HEAP32[i89 >> 2] | 0;
     i89 = HEAP32[i89 + 4 >> 2] | 0;
     i17 = i78 + (i18 * 40 | 0) + 8 | 0;
     HEAP32[i17 >> 2] = i90;
     HEAP32[i17 + 4 >> 2] = i89;
     HEAP32[i78 + (i18 * 40 | 0) + 36 >> 2] = i13;
     i17 = i78 + (i18 * 40 | 0) + 16 | 0;
     HEAP32[i17 >> 2] = i14;
     HEAP32[i17 + 4 >> 2] = i15;
     i17 = i63;
     i16 = HEAP32[i17 >> 2] | 0;
     i17 = HEAP32[i17 + 4 >> 2] | 0;
     i18 = i78 + (i18 * 40 | 0) + 24 | 0;
     HEAP32[i18 >> 2] = i16;
     HEAP32[i18 + 4 >> 2] = i17;
     i18 = i1 + 1 | 0;
     HEAP32[i78 + (i1 * 40 | 0) + 32 >> 2] = i8;
     i10 = i81;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i78 + (i1 * 40 | 0) | 0;
     HEAP32[i12 >> 2] = i9;
     HEAP32[i12 + 4 >> 2] = i10;
     i12 = i61;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     i4 = i78 + (i1 * 40 | 0) + 8 | 0;
     HEAP32[i4 >> 2] = i11;
     HEAP32[i4 + 4 >> 2] = i12;
     HEAP32[i78 + (i1 * 40 | 0) + 36 >> 2] = i5;
     i4 = i75;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     i7 = i78 + (i1 * 40 | 0) + 16 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     i7 = i64;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     i85 = i78 + (i1 * 40 | 0) + 24 | 0;
     HEAP32[i85 >> 2] = i6;
     HEAP32[i85 + 4 >> 2] = i7;
     i85 = i1 + 2 | 0;
     HEAP32[i78 + (i18 * 40 | 0) + 32 >> 2] = i2;
     i2 = i78 + (i18 * 40 | 0) | 0;
     HEAP32[i2 >> 2] = i92;
     HEAP32[i2 + 4 >> 2] = i91;
     i2 = i78 + (i18 * 40 | 0) + 8 | 0;
     HEAP32[i2 >> 2] = i90;
     HEAP32[i2 + 4 >> 2] = i89;
     HEAP32[i78 + (i18 * 40 | 0) + 36 >> 2] = i5;
     i5 = i78 + (i18 * 40 | 0) + 16 | 0;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i5 + 4 >> 2] = i4;
     i18 = i78 + (i18 * 40 | 0) + 24 | 0;
     HEAP32[i18 >> 2] = i6;
     HEAP32[i18 + 4 >> 2] = i7;
     HEAP32[i78 + (i85 * 40 | 0) + 32 >> 2] = i8;
     i18 = i78 + (i85 * 40 | 0) | 0;
     HEAP32[i18 >> 2] = i9;
     HEAP32[i18 + 4 >> 2] = i10;
     i18 = i78 + (i85 * 40 | 0) + 8 | 0;
     HEAP32[i18 >> 2] = i11;
     HEAP32[i18 + 4 >> 2] = i12;
     HEAP32[i78 + (i85 * 40 | 0) + 36 >> 2] = i13;
     i18 = i78 + (i85 * 40 | 0) + 16 | 0;
     HEAP32[i18 >> 2] = i14;
     HEAP32[i18 + 4 >> 2] = i15;
     i85 = i78 + (i85 * 40 | 0) + 24 | 0;
     HEAP32[i85 >> 2] = i16;
     HEAP32[i85 + 4 >> 2] = i17;
     i1 = i1 + 3 | 0;
     break;
    }
   }
   if ((i6 | 0) != 3 & (i4 | 0) != 3) {
    i89 = i12 - i8 | 0;
    i90 = i16 - i9 | 0;
    i91 = i3 - i2 | 0;
    i92 = i17 - i14 | 0;
    if ((((i89 | 0) >= (i90 | 0) ? i89 : i90) | 0) < (((i91 | 0) >= (i92 | 0) ? i91 : i92) | 0)) i83 = 34;
   } else if ((i6 | 0) == 3) i83 = 34;
   if ((i83 | 0) == 34) {
    i83 = 0;
    i6 = (__ZNK5Umbra6KDTree4rankEi(i7, i15) | 0) << 1;
    i5 = HEAP32[i74 + 76 + (i4 << 2) >> 2] | 0;
    if ((HEAP32[i7 + 24 >> 2] | 0) > (i15 | 0)) {
     f88 = Math_fround(HEAPF32[(HEAP32[i7 + 12 >> 2] | 0) + (HEAP32[i7 + 16 >> 2] | 0) + (i15 << 2) >> 2]);
     f88 = Math_fround(f88 - Math_fround(HEAPF32[i65 + (i4 << 2) >> 2]));
     f93 = Math_fround(HEAPF32[i66 >> 2]);
     f93 = Math_fround(f93 - Math_fround(HEAPF32[i65 >> 2]));
     f86 = Math_fround(HEAPF32[i67 >> 2]);
     f86 = Math_fround(f86 - Math_fround(HEAPF32[i68 >> 2]));
     f87 = Math_fround(HEAPF32[i69 >> 2]);
     f87 = Math_fround(f87 - Math_fround(HEAPF32[i70 >> 2]));
     HEAPF32[i77 >> 2] = f93;
     HEAPF32[i71 >> 2] = f86;
     HEAPF32[i72 >> 2] = f87;
     i2 = ~~Math_fround(Math_fround(f88 / Math_fround(HEAPF32[i77 + (i4 << 2) >> 2])) * Math_fround(65535.0));
    } else i2 = ((HEAP32[i39 + (i5 << 2) >> 2] | 0) + (HEAP32[i53 + (i5 << 2) >> 2] | 0) | 0) / 2 | 0;
    i4 = i53;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    i91 = i80;
    HEAP32[i91 >> 2] = i3;
    HEAP32[i91 + 4 >> 2] = i4;
    i91 = i58;
    i90 = HEAP32[i91 >> 2] | 0;
    i91 = HEAP32[i91 + 4 >> 2] | 0;
    i92 = i23;
    HEAP32[i92 >> 2] = i90;
    HEAP32[i92 + 4 >> 2] = i91;
    HEAP32[i73 + (i5 << 2) >> 2] = i2;
    i92 = i81;
    HEAP32[i92 >> 2] = i3;
    HEAP32[i92 + 4 >> 2] = i4;
    i92 = i24;
    HEAP32[i92 >> 2] = i90;
    HEAP32[i92 + 4 >> 2] = i91;
    HEAP32[i81 + (i5 << 2) >> 2] = i2;
    if (((i8 | 0) < (HEAP32[i73 >> 2] | 0) ? (i9 | 0) < (HEAP32[i19 >> 2] | 0) : 0) & (i12 | 0) > (i3 | 0) & (i16 | 0) > (i4 | 0)) {
     HEAP32[i11 >> 2] = i13;
     i2 = i79;
     i92 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     i91 = i10;
     HEAP32[i91 >> 2] = i92;
     HEAP32[i91 + 4 >> 2] = i2;
     i91 = i54;
     i2 = HEAP32[i91 >> 2] | 0;
     i91 = HEAP32[i91 + 4 >> 2] | 0;
     i90 = i78 + (i18 * 40 | 0) + 8 | 0;
     HEAP32[i90 >> 2] = i2;
     HEAP32[i90 + 4 >> 2] = i91;
     HEAP32[i78 + (i18 * 40 | 0) + 36 >> 2] = i6 + -1;
     i90 = i78 + (i18 * 40 | 0) + 16 | 0;
     HEAP32[i90 >> 2] = i3;
     HEAP32[i90 + 4 >> 2] = i4;
     i90 = i23;
     i91 = HEAP32[i90 + 4 >> 2] | 0;
     i3 = i78 + (i18 * 40 | 0) + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i90 >> 2];
     HEAP32[i3 + 4 >> 2] = i91;
     i3 = i92;
    } else {
     i1 = i18;
     i3 = i8;
     i2 = i12;
    }
    if (((i3 | 0) < (HEAP32[i21 >> 2] | 0) ? (i9 | 0) < (HEAP32[i22 >> 2] | 0) : 0) & (i2 | 0) > (HEAP32[i81 >> 2] | 0) & (i16 | 0) > (HEAP32[i20 >> 2] | 0)) {
     HEAP32[i78 + (i1 * 40 | 0) + 32 >> 2] = i13;
     i92 = i79;
     i91 = HEAP32[i92 + 4 >> 2] | 0;
     i90 = i78 + (i1 * 40 | 0) | 0;
     HEAP32[i90 >> 2] = HEAP32[i92 >> 2];
     HEAP32[i90 + 4 >> 2] = i91;
     i90 = i54;
     i91 = HEAP32[i90 + 4 >> 2] | 0;
     i92 = i78 + (i1 * 40 | 0) + 8 | 0;
     HEAP32[i92 >> 2] = HEAP32[i90 >> 2];
     HEAP32[i92 + 4 >> 2] = i91;
     HEAP32[i78 + (i1 * 40 | 0) + 36 >> 2] = i6;
     i92 = i81;
     i91 = HEAP32[i92 + 4 >> 2] | 0;
     i90 = i78 + (i1 * 40 | 0) + 16 | 0;
     HEAP32[i90 >> 2] = HEAP32[i92 >> 2];
     HEAP32[i90 + 4 >> 2] = i91;
     i90 = i24;
     i91 = HEAP32[i90 + 4 >> 2] | 0;
     i92 = i78 + (i1 * 40 | 0) + 24 | 0;
     HEAP32[i92 >> 2] = HEAP32[i90 >> 2];
     HEAP32[i92 + 4 >> 2] = i91;
     i1 = i1 + 1 | 0;
    }
    break;
   }
   i9 = (__ZNK5Umbra6KDTree4rankEi(i5, i13) | 0) << 1;
   i7 = i9 + -1 | 0;
   i8 = HEAP32[i74 + 76 + (i6 << 2) >> 2] | 0;
   if ((HEAP32[i5 + 24 >> 2] | 0) > (i13 | 0)) {
    f93 = Math_fround(HEAPF32[(HEAP32[i5 + 12 >> 2] | 0) + (HEAP32[i5 + 16 >> 2] | 0) + (i13 << 2) >> 2]);
    f93 = Math_fround(f93 - Math_fround(HEAPF32[i65 + (i6 << 2) >> 2]));
    f86 = Math_fround(HEAPF32[i66 >> 2]);
    f86 = Math_fround(f86 - Math_fround(HEAPF32[i65 >> 2]));
    f87 = Math_fround(HEAPF32[i67 >> 2]);
    f87 = Math_fround(f87 - Math_fround(HEAPF32[i68 >> 2]));
    f88 = Math_fround(HEAPF32[i69 >> 2]);
    f88 = Math_fround(f88 - Math_fround(HEAPF32[i70 >> 2]));
    HEAPF32[i76 >> 2] = f86;
    HEAPF32[i25 >> 2] = f87;
    HEAPF32[i26 >> 2] = f88;
    i4 = ~~Math_fround(Math_fround(f93 / Math_fround(HEAPF32[i76 + (i6 << 2) >> 2])) * Math_fround(65535.0));
   } else i4 = ((HEAP32[i35 + (i8 << 2) >> 2] | 0) + (HEAP32[i79 + (i8 << 2) >> 2] | 0) | 0) / 2 | 0;
   i6 = i79;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i91 = i80;
   HEAP32[i91 >> 2] = i5;
   HEAP32[i91 + 4 >> 2] = i6;
   i91 = i54;
   i90 = HEAP32[i91 >> 2] | 0;
   i91 = HEAP32[i91 + 4 >> 2] | 0;
   i92 = i32;
   HEAP32[i92 >> 2] = i90;
   HEAP32[i92 + 4 >> 2] = i91;
   HEAP32[i27 + (i8 << 2) >> 2] = i4;
   i92 = i81;
   HEAP32[i92 >> 2] = i5;
   HEAP32[i92 + 4 >> 2] = i6;
   i92 = i33;
   HEAP32[i92 >> 2] = i90;
   HEAP32[i92 + 4 >> 2] = i91;
   HEAP32[i81 + (i8 << 2) >> 2] = i4;
   if ((i5 | 0) < (i3 | 0)) if (((i6 | 0) < (i17 | 0) ? (HEAP32[i27 >> 2] | 0) > (i2 | 0) : 0) & (HEAP32[i28 >> 2] | 0) > (i14 | 0)) {
    HEAP32[i11 >> 2] = i7;
    i91 = i10;
    HEAP32[i91 >> 2] = i5;
    HEAP32[i91 + 4 >> 2] = i6;
    i91 = i32;
    i2 = HEAP32[i91 + 4 >> 2] | 0;
    i3 = i78 + (i18 * 40 | 0) + 8 | 0;
    HEAP32[i3 >> 2] = HEAP32[i91 >> 2];
    HEAP32[i3 + 4 >> 2] = i2;
    HEAP32[i78 + (i18 * 40 | 0) + 36 >> 2] = i15;
    i3 = i53;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i91 = i78 + (i18 * 40 | 0) + 16 | 0;
    HEAP32[i91 >> 2] = i2;
    HEAP32[i91 + 4 >> 2] = i3;
    i91 = i58;
    i3 = HEAP32[i91 >> 2] | 0;
    i91 = HEAP32[i91 + 4 >> 2] | 0;
    i92 = i78 + (i18 * 40 | 0) + 24 | 0;
    HEAP32[i92 >> 2] = i3;
    HEAP32[i92 + 4 >> 2] = i91;
   } else i1 = i18; else i1 = i18;
   if (((HEAP32[i81 >> 2] | 0) < (i3 | 0) ? (HEAP32[i29 >> 2] | 0) < (i17 | 0) : 0) & (HEAP32[i30 >> 2] | 0) > (i2 | 0) & (HEAP32[i31 >> 2] | 0) > (i14 | 0)) {
    HEAP32[i78 + (i1 * 40 | 0) + 32 >> 2] = i9;
    i92 = i81;
    i91 = HEAP32[i92 + 4 >> 2] | 0;
    i90 = i78 + (i1 * 40 | 0) | 0;
    HEAP32[i90 >> 2] = HEAP32[i92 >> 2];
    HEAP32[i90 + 4 >> 2] = i91;
    i90 = i33;
    i91 = HEAP32[i90 + 4 >> 2] | 0;
    i92 = i78 + (i1 * 40 | 0) + 8 | 0;
    HEAP32[i92 >> 2] = HEAP32[i90 >> 2];
    HEAP32[i92 + 4 >> 2] = i91;
    HEAP32[i78 + (i1 * 40 | 0) + 36 >> 2] = i15;
    i92 = i53;
    i91 = HEAP32[i92 + 4 >> 2] | 0;
    i90 = i78 + (i1 * 40 | 0) + 16 | 0;
    HEAP32[i90 >> 2] = HEAP32[i92 >> 2];
    HEAP32[i90 + 4 >> 2] = i91;
    i90 = i58;
    i91 = HEAP32[i90 + 4 >> 2] | 0;
    i92 = i78 + (i1 * 40 | 0) + 24 | 0;
    HEAP32[i92 >> 2] = HEAP32[i90 >> 2];
    HEAP32[i92 + 4 >> 2] = i91;
    i1 = i1 + 1 | 0;
   }
  } while (0);
 } while ((i1 | 0) > 0);
 STACKTOP = i84;
 return;
}

function __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f(i35, i21, f2, f4, f5, f6, f7, i36, i1, f15) {
 i35 = i35 | 0;
 i21 = i21 | 0;
 f2 = Math_fround(f2);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i36 = i36 | 0;
 i1 = i1 | 0;
 f15 = Math_fround(f15);
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i37 + 16 | 0;
 i22 = i37;
 i20 = i35 + 4096 | 0;
 HEAP32[i20 >> 2] = 0;
 f19 = Math_fround(f2 + f15);
 f55 = Math_fround(HEAPF32[i36 >> 2]);
 i31 = i36 + 4 | 0;
 f54 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i36 + 8 | 0;
 f52 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i36 + 12 | 0;
 f71 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i36 + 16 | 0;
 f18 = Math_fround(HEAPF32[i34 >> 2]);
 i24 = i36 + 20 | 0;
 f42 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = i36 + 24 | 0;
 f45 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i36 + 28 | 0;
 f63 = Math_fround(HEAPF32[i26 >> 2]);
 i27 = i36 + 32 | 0;
 f62 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i36 + 36 | 0;
 f66 = Math_fround(-Math_fround(HEAPF32[i28 >> 2]));
 i29 = i36 + 40 | 0;
 f65 = Math_fround(-Math_fround(HEAPF32[i29 >> 2]));
 i30 = i36 + 44 | 0;
 f64 = Math_fround(-Math_fround(HEAPF32[i30 >> 2]));
 f69 = Math_fround(f54 * f65);
 f68 = Math_fround(f52 * f64);
 f70 = Math_fround(Math_fround(Math_fround(f71 * f66) + Math_fround(f18 * f65)) + Math_fround(f42 * f64));
 f65 = Math_fround(f63 * f65);
 f64 = Math_fround(f62 * f64);
 f60 = Math_fround(HEAPF32[i1 >> 2]);
 f48 = Math_fround(f71 * f60);
 f61 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f59 = Math_fround(f63 * f61);
 f48 = Math_fround(f48 + Math_fround(f18 * f61));
 f49 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f43 = Math_fround(f62 * f49);
 f48 = Math_fround(f48 + Math_fround(f42 * f49));
 f57 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f40 = Math_fround(f71 * f57);
 f58 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f56 = Math_fround(f63 * f58);
 f40 = Math_fround(f40 + Math_fround(f18 * f58));
 f41 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f39 = Math_fround(f62 * f41);
 f40 = Math_fround(f40 + Math_fround(f42 * f41));
 f46 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f50 = Math_fround(f71 * f46);
 f53 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f47 = Math_fround(f63 * f53);
 f50 = Math_fround(f50 + Math_fround(f18 * f53));
 f51 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(f62 * f51);
 f50 = Math_fround(f50 + Math_fround(f42 * f51));
 f67 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f71 = Math_fround(f71 * f67);
 f44 = Math_fround(f45 * f67);
 f38 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f18 = Math_fround(f71 + Math_fround(f18 * f38));
 f63 = Math_fround(f44 + Math_fround(f63 * f38));
 f44 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f42 = Math_fround(f70 + Math_fround(f18 + Math_fround(f42 * f44)));
 f18 = Math_fround(f4 + f15);
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f55 * f66) + f69) + f68) + Math_fround(Math_fround(Math_fround(f55 * f67) + Math_fround(f54 * f38)) + Math_fround(f52 * f44)));
 f44 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f66) + f65) + f64) + Math_fround(f63 + Math_fround(f62 * f44)));
 f49 = Math_fround(Math_fround(Math_fround(Math_fround(f55 * f60) + Math_fround(f54 * f61)) + Math_fround(f52 * f49)) * f5);
 f48 = Math_fround(f48 * f5);
 f43 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f60) + f59) + f43) * f5);
 f41 = Math_fround(Math_fround(Math_fround(Math_fround(f55 * f57) + Math_fround(f54 * f58)) + Math_fround(f52 * f41)) * f6);
 f40 = Math_fround(f40 * f6);
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f57) + f56) + f39) * f6);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f55 * f46) + Math_fround(f54 * f53)) + Math_fround(f52 * f51)) * f7);
 f6 = Math_fround(f50 * f7);
 f2 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f46) + f47) + f2) * f7);
 i11 = i23 + 32 | 0;
 i3 = i23 + 64 | 0;
 f47 = Math_fround(f38 - f49);
 f46 = Math_fround(f42 - f48);
 f45 = Math_fround(f44 - f43);
 i8 = i23 + 96 | 0;
 HEAPF32[i8 >> 2] = f47;
 i9 = i23 + 100 | 0;
 HEAPF32[i9 >> 2] = f46;
 i10 = i23 + 104 | 0;
 HEAPF32[i10 >> 2] = f45;
 HEAPF32[i3 >> 2] = f47;
 i17 = i23 + 68 | 0;
 HEAPF32[i17 >> 2] = f46;
 i16 = i23 + 72 | 0;
 HEAPF32[i16 >> 2] = f45;
 HEAPF32[i11 >> 2] = f47;
 i12 = i23 + 36 | 0;
 HEAPF32[i12 >> 2] = f46;
 i14 = i23 + 40 | 0;
 HEAPF32[i14 >> 2] = f45;
 f38 = Math_fround(f49 + f38);
 f5 = Math_fround(f48 + f42);
 f7 = Math_fround(f43 + f44);
 f44 = Math_fround(f41 + f4);
 f43 = Math_fround(f40 + f6);
 f42 = Math_fround(f39 + f2);
 HEAPF32[i23 >> 2] = Math_fround(f47 - f44);
 HEAPF32[i23 + 4 >> 2] = Math_fround(f46 - f43);
 HEAPF32[i23 + 8 >> 2] = Math_fround(f45 - f42);
 HEAPF32[i23 + 16 >> 2] = Math_fround(f38 - f44);
 HEAPF32[i23 + 20 >> 2] = Math_fround(f5 - f43);
 HEAPF32[i23 + 24 >> 2] = Math_fround(f7 - f42);
 HEAPF32[i8 >> 2] = Math_fround(f44 + Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i9 >> 2] = Math_fround(f43 + Math_fround(HEAPF32[i9 >> 2]));
 HEAPF32[i10 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i23 + 112 >> 2] = Math_fround(f44 + f38);
 HEAPF32[i23 + 116 >> 2] = Math_fround(f43 + f5);
 HEAPF32[i23 + 120 >> 2] = Math_fround(f42 + f7);
 f4 = Math_fround(f41 - f4);
 f6 = Math_fround(f40 - f6);
 f2 = Math_fround(f39 - f2);
 HEAPF32[i11 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i11 >> 2]));
 HEAPF32[i12 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i14 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i23 + 48 >> 2] = Math_fround(f4 + f38);
 HEAPF32[i23 + 52 >> 2] = Math_fround(f6 + f5);
 HEAPF32[i23 + 56 >> 2] = Math_fround(f2 + f7);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f4);
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f6);
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f2);
 HEAPF32[i23 + 80 >> 2] = Math_fround(f38 - f4);
 HEAPF32[i23 + 84 >> 2] = Math_fround(f5 - f6);
 HEAPF32[i23 + 88 >> 2] = Math_fround(f7 - f2);
 f2 = Math_fround(-f15);
 i16 = i21 + 4 | 0;
 i17 = i21 + 8 | 0;
 i3 = 0;
 do {
  f4 = Math_fround(HEAPF32[i23 + (i3 << 4) >> 2]);
  do if (f4 < f2) {
   HEAP8[i23 + (i3 << 4) + 13 >> 0] = 0;
   HEAP8[i23 + (i3 << 4) + 12 >> 0] = 0;
  } else {
   HEAP8[i23 + (i3 << 4) + 12 >> 0] = 1;
   f5 = Math_fround(HEAPF32[i23 + (i3 << 4) + 4 >> 2]);
   if (Math_fround(Math_abs(Math_fround(f5))) <= f19) {
    f6 = Math_fround(HEAPF32[i23 + (i3 << 4) + 8 >> 2]);
    if (Math_fround(Math_abs(Math_fround(f6))) <= f18) {
     HEAP8[i23 + (i3 << 4) + 13 >> 0] = 1;
     i1 = HEAP32[i20 >> 2] | 0;
     if (i1 >>> 0 > 63) break;
     f71 = Math_fround(-f4);
     HEAP32[i20 >> 2] = i1 + 1;
     HEAP32[i35 + (i1 << 6) >> 2] = HEAP32[i21 >> 2];
     HEAP32[i35 + (i1 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i35 + (i1 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
     HEAPF32[i35 + (i1 << 6) + 16 >> 2] = f4;
     HEAPF32[i35 + (i1 << 6) + 20 >> 2] = f5;
     HEAPF32[i35 + (i1 << 6) + 24 >> 2] = f6;
     HEAPF32[i35 + (i1 << 6) + 12 >> 2] = f71;
     HEAP32[i35 + (i1 << 6) + 48 >> 2] = -1;
     HEAP32[i35 + (i1 << 6) + 52 >> 2] = -1;
     break;
    }
   }
   HEAP8[i23 + (i3 << 4) + 13 >> 0] = 0;
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 8);
 f6 = Math_fround(-f19);
 f7 = Math_fround(-f18);
 i12 = gb + 105024 | 0;
 do {
  i8 = HEAP32[i12 >> 2] | 0;
  i3 = i23 + (i8 << 4) | 0;
  i9 = HEAP32[i12 + 4 >> 2] | 0;
  i12 = i12 + 8 | 0;
  i1 = i23 + (i9 << 4) | 0;
  if (!(HEAP8[i23 + (i8 << 4) + 12 >> 0] | 0)) {
   if (HEAP8[i23 + (i9 << 4) + 12 >> 0] | 0) i13 = 15;
  } else i13 = 15;
  do if ((i13 | 0) == 15) {
   i13 = 0;
   if (!(HEAP8[i23 + (i8 << 4) + 13 >> 0] | 0)) i13 = 17; else if (!(HEAP8[i23 + (i9 << 4) + 13 >> 0] | 0)) i13 = 17;
   if ((i13 | 0) == 17) {
    i13 = 0;
    f2 = Math_fround(HEAPF32[i23 + (i8 << 4) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i23 + (i9 << 4) + 4 >> 2]);
    if (f2 > f4) {
     i11 = i9;
     f2 = f4;
     i10 = i1;
     i1 = i3;
    } else {
     i11 = i8;
     i8 = i9;
     i10 = i3;
    }
    i9 = i23 + (i11 << 4) | 0;
    if (f2 < f19) {
     f4 = Math_fround(HEAPF32[i23 + (i8 << 4) + 4 >> 2]);
     if (f4 >= f19) {
      f4 = Math_fround(Math_fround(f19 - f2) / Math_fround(f4 - f2));
      f5 = Math_fround(HEAPF32[i23 + (i11 << 4) + 8 >> 2]);
      f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i23 + (i8 << 4) + 8 >> 2]) - f5)));
      if (Math_fround(Math_abs(Math_fround(f5))) <= f18) {
       f71 = Math_fround(HEAPF32[i9 >> 2]);
       f4 = Math_fround(f71 + Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i23 + (i8 << 4) >> 2]) - f71)));
       if (Math_fround(f4 + f15) >= Math_fround(0.0)) {
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f4);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f4;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f19;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f5;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
     }
    }
    if (f2 < f6) {
     f4 = Math_fround(HEAPF32[i23 + (i8 << 4) + 4 >> 2]);
     if (f4 >= f6) {
      f2 = Math_fround(Math_fround(f6 - f2) / Math_fround(f4 - f2));
      f4 = Math_fround(HEAPF32[i23 + (i11 << 4) + 8 >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i23 + (i8 << 4) + 8 >> 2]) - f4)));
      if (Math_fround(Math_abs(Math_fround(f4))) <= f18) {
       f71 = Math_fround(HEAPF32[i9 >> 2]);
       f2 = Math_fround(f71 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i23 + (i8 << 4) >> 2]) - f71)));
       if (Math_fround(f2 + f15) >= Math_fround(0.0)) {
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f6;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f4;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
     }
    }
    f5 = Math_fround(HEAPF32[i23 + (i11 << 4) + 8 >> 2]);
    i3 = f5 > Math_fround(HEAPF32[i23 + (i8 << 4) + 8 >> 2]);
    i8 = i3 ? i10 : i1;
    i3 = i3 ? i1 : i10;
    f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    if (f5 < f18) {
     f2 = Math_fround(HEAPF32[i8 + 8 >> 2]);
     if (f2 >= f18) {
      f2 = Math_fround(Math_fround(f18 - f5) / Math_fround(f2 - f5));
      f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f4)));
      if (Math_fround(Math_abs(Math_fround(f4))) <= f19) {
       f71 = Math_fround(HEAPF32[i3 >> 2]);
       f2 = Math_fround(f71 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f71)));
       if (Math_fround(f2 + f15) >= Math_fround(0.0)) {
        i1 = HEAP32[i20 >> 2] | 0;
        if (i1 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i1 + 1;
         HEAP32[i35 + (i1 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i1 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i1 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i1 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i1 << 6) + 20 >> 2] = f4;
         HEAPF32[i35 + (i1 << 6) + 24 >> 2] = f18;
         HEAPF32[i35 + (i1 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i1 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i1 << 6) + 52 >> 2] = -1;
        }
       }
      }
     }
    }
    if (f5 < f7) {
     f2 = Math_fround(HEAPF32[i8 + 8 >> 2]);
     if (!(f2 >= f7)) i1 = i8; else {
      f2 = Math_fround(Math_fround(f7 - f5) / Math_fround(f2 - f5));
      f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
      f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f4)));
      if (!(Math_fround(Math_abs(Math_fround(f4))) <= f19)) i1 = i8; else {
       f71 = Math_fround(HEAPF32[i3 >> 2]);
       f2 = Math_fround(f71 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f71)));
       if (!(Math_fround(f2 + f15) >= Math_fround(0.0))) i1 = i8; else {
        i1 = HEAP32[i20 >> 2] | 0;
        if (i1 >>> 0 > 63) i1 = i8; else {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i1 + 1;
         HEAP32[i35 + (i1 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i1 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i1 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i1 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i1 << 6) + 20 >> 2] = f4;
         HEAPF32[i35 + (i1 << 6) + 24 >> 2] = f7;
         HEAPF32[i35 + (i1 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i1 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i1 << 6) + 52 >> 2] = -1;
         i1 = i8;
        }
       }
      }
     }
    } else i1 = i8;
   }
   if (!(HEAP8[i3 + 12 >> 0] | 0)) {
    if (HEAP8[i1 + 13 >> 0] | 0) i13 = 45;
   } else i13 = 45;
   if ((i13 | 0) == 45) {
    i13 = 0;
    if (HEAP8[i1 + 12 >> 0] | 0) break;
    if (HEAP8[i3 + 13 >> 0] | 0) break;
   }
   f2 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(-f2);
   f2 = Math_fround(f4 / Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f2));
   f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) - f4)));
   if (Math_fround(Math_abs(Math_fround(f4))) <= f19) {
    f71 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    f2 = Math_fround(f71 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f71)));
    if (Math_fround(Math_abs(Math_fround(f2))) <= f18) {
     i1 = HEAP32[i20 >> 2] | 0;
     if (i1 >>> 0 <= 63) {
      HEAP32[i20 >> 2] = i1 + 1;
      HEAP32[i35 + (i1 << 6) >> 2] = HEAP32[i21 >> 2];
      HEAP32[i35 + (i1 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i35 + (i1 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i35 + (i1 << 6) + 16 >> 2] = 0;
      HEAPF32[i35 + (i1 << 6) + 20 >> 2] = f4;
      HEAPF32[i35 + (i1 << 6) + 24 >> 2] = f2;
      HEAPF32[i35 + (i1 << 6) + 12 >> 2] = Math_fround(0.0);
      HEAP32[i35 + (i1 << 6) + 48 >> 2] = -1;
      HEAP32[i35 + (i1 << 6) + 52 >> 2] = -1;
     }
    }
   }
  } while (0);
 } while ((i12 | 0) != (gb + 105024 + 96 | 0));
 i11 = i22 + 4 | 0;
 i12 = i22 + 8 | 0;
 i13 = i22 + 12 | 0;
 i1 = 0;
 i14 = 0;
 do {
  i3 = HEAP32[gb + 105120 + (i14 << 4) >> 2] | 0;
  HEAP32[i22 >> 2] = i23 + (i3 << 4);
  do if (HEAP8[i23 + (i3 << 4) + 12 >> 0] | 0) {
   i8 = HEAP32[gb + 105120 + (i14 << 4) + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i23 + (i8 << 4);
   if (HEAP8[i23 + (i8 << 4) + 12 >> 0] | 0) {
    i9 = HEAP32[gb + 105120 + (i14 << 4) + 8 >> 2] | 0;
    HEAP32[i12 >> 2] = i23 + (i9 << 4);
    if (HEAP8[i23 + (i9 << 4) + 12 >> 0] | 0) {
     i10 = HEAP32[gb + 105120 + (i14 << 4) + 12 >> 2] | 0;
     HEAP32[i13 >> 2] = i23 + (i10 << 4);
     if (HEAP8[i23 + (i10 << 4) + 12 >> 0] | 0) {
      if (HEAP8[i23 + (i3 << 4) + 13 >> 0] | 0) if (HEAP8[i23 + (i8 << 4) + 13 >> 0] | 0) if (HEAP8[i23 + (i9 << 4) + 13 >> 0] | 0) if (HEAP8[i23 + (i10 << 4) + 13 >> 0] | 0) break;
      if (!(i1 & 1)) {
       f2 = Math_fround(__ZL6IsInYZffPPK10VertexInfo(f6, f7, i22));
       if (f2 >= Math_fround(0.0)) {
        i1 = i1 | 1;
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f6;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f7;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
      if (!(i1 & 2)) {
       f2 = Math_fround(__ZL6IsInYZffPPK10VertexInfo(f19, f7, i22));
       if (f2 >= Math_fround(0.0)) {
        i1 = i1 | 2;
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f19;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f7;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
      if (!(i1 & 4)) {
       f2 = Math_fround(__ZL6IsInYZffPPK10VertexInfo(f6, f18, i22));
       if (f2 >= Math_fround(0.0)) {
        i1 = i1 | 4;
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f6;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f18;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
      if (!(i1 & 8)) {
       f2 = Math_fround(__ZL6IsInYZffPPK10VertexInfo(f19, f18, i22));
       if (f2 >= Math_fround(0.0)) {
        i1 = i1 | 8;
        i3 = HEAP32[i20 >> 2] | 0;
        if (i3 >>> 0 <= 63) {
         f71 = Math_fround(-f2);
         HEAP32[i20 >> 2] = i3 + 1;
         HEAP32[i35 + (i3 << 6) >> 2] = HEAP32[i21 >> 2];
         HEAP32[i35 + (i3 << 6) + 4 >> 2] = HEAP32[i16 >> 2];
         HEAP32[i35 + (i3 << 6) + 8 >> 2] = HEAP32[i17 >> 2];
         HEAPF32[i35 + (i3 << 6) + 16 >> 2] = f2;
         HEAPF32[i35 + (i3 << 6) + 20 >> 2] = f19;
         HEAPF32[i35 + (i3 << 6) + 24 >> 2] = f18;
         HEAPF32[i35 + (i3 << 6) + 12 >> 2] = f71;
         HEAP32[i35 + (i3 << 6) + 48 >> 2] = -1;
         HEAP32[i35 + (i3 << 6) + 52 >> 2] = -1;
        }
       }
      }
     }
    }
   }
  } while (0);
  i14 = i14 + 1 | 0;
 } while ((i1 | 0) != 15 & i14 >>> 0 < 6);
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 } else i3 = 0;
 do {
  i21 = i35 + (i3 << 6) + 16 | 0;
  f71 = Math_fround(HEAPF32[i21 >> 2]);
  f70 = Math_fround(f71 * Math_fround(HEAPF32[i36 >> 2]));
  f69 = Math_fround(f71 * Math_fround(HEAPF32[i31 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i32 >> 2]));
  i22 = i35 + (i3 << 6) + 20 | 0;
  f68 = Math_fround(HEAPF32[i22 >> 2]);
  f66 = Math_fround(f68 * Math_fround(HEAPF32[i33 >> 2]));
  f67 = Math_fround(f68 * Math_fround(HEAPF32[i34 >> 2]));
  f66 = Math_fround(f70 + f66);
  f67 = Math_fround(f69 + f67);
  f68 = Math_fround(f71 + Math_fround(f68 * Math_fround(HEAPF32[i24 >> 2])));
  i23 = i35 + (i3 << 6) + 24 | 0;
  f71 = Math_fround(HEAPF32[i23 >> 2]);
  f69 = Math_fround(f71 * Math_fround(HEAPF32[i25 >> 2]));
  f70 = Math_fround(f71 * Math_fround(HEAPF32[i26 >> 2]));
  f69 = Math_fround(f66 + f69);
  f70 = Math_fround(f67 + f70);
  f71 = Math_fround(f68 + Math_fround(f71 * Math_fround(HEAPF32[i27 >> 2])));
  f69 = Math_fround(f69 + Math_fround(HEAPF32[i28 >> 2]));
  f70 = Math_fround(f70 + Math_fround(HEAPF32[i29 >> 2]));
  f71 = Math_fround(f71 + Math_fround(HEAPF32[i30 >> 2]));
  HEAPF32[i21 >> 2] = f69;
  HEAPF32[i22 >> 2] = f70;
  HEAPF32[i23 >> 2] = f71;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 STACKTOP = i37;
 return i1 | 0;
}

function __ZNSt3__26locale5__impC2ERKS1_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i12, i2, i9, i10) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 HEAP32[i12 + 4 >> 2] = -1;
 HEAP32[i12 >> 2] = gb + 212688 + 8;
 i16 = i12 + 8 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i16 | 0, 28);
 i15 = __THREW__;
 __THREW__ = 0;
 if (i15 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i15 = i12 + 144 | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i15 | 0, gb + 1086428 | 0, 1);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   if ((i12 | 0) == (i2 | 0)) i11 = 5; else {
    __THREW__ = 0;
    invoke_viii(fb + 1050 | 0, i16 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else i11 = 5;
   }
   if ((i11 | 0) == 5) {
    i13 = i12 + 12 | 0;
    i3 = 0;
    while (1) {
     i2 = HEAP32[i16 >> 2] | 0;
     if (i3 >>> 0 >= (HEAP32[i13 >> 2] | 0) - i2 >> 2 >>> 0) break;
     i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i2);
     i3 = i3 + 1 | 0;
    }
    do if (!(i10 & 8)) i11 = 23; else {
     __THREW__ = 0;
     i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) i11 = 20; else {
      __THREW__ = 0;
      invoke_viii(fb + 1051 | 0, i2 | 0, i9 | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4567 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) i11 = 20; else {
       __THREW__ = 0;
       i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
       i8 = __THREW__;
       __THREW__ = 0;
       if (i8 & 1) i11 = 20; else {
        __THREW__ = 0;
        invoke_viii(fb + 1052 | 0, i2 | 0, i9 | 0, 0);
        i8 = __THREW__;
        __THREW__ = 0;
        if (i8 & 1) {
         i12 = ___cxa_find_matching_catch_3(0) | 0;
         getTempRet0() | 0;
         __ZdlPv(i2);
         i2 = i12;
         break;
        } else {
         __THREW__ = 0;
         invoke_vii(fb + 4568 | 0, i12 | 0, i2 | 0);
         i11 = __THREW__;
         __THREW__ = 0;
         if (i11 & 1) {
          i11 = 20;
          break;
         } else {
          i11 = 23;
          break;
         }
        }
       }
      }
     }
    } while (0);
    L30 : do if ((i11 | 0) == 23) {
     if (i10 & 1 | 0) {
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 20) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      invoke_viii(fb + 1053 | 0, i2 | 0, i9 | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4569 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      invoke_viii(fb + 1054 | 0, i2 | 0, i9 | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4570 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 212420 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4571 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      invoke_viii(fb + 1055 | 0, i2 | 0, ((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break;
      }
      HEAP32[i2 >> 2] = gb + 212468 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4572 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 212564 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4573 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 212612 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4574 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break;
      }
     }
     do if (i10 & 16 | 0) {
      __THREW__ = 0;
      i6 = invoke_ii(fb + 1570 | 0, 72) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i6 + 4 >> 2] = -1;
      HEAP32[i6 >> 2] = gb + 211860 + 8;
      i7 = i6 + 12 | 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i7 + 4 >> 2] = 0;
      HEAP32[i7 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i7 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i5 = i6 + 24 | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i5 + 4 >> 2] = 0;
      HEAP32[i5 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i5 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i4 = i6 + 36 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i4 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i3 = i6 + 48 | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i8 = i9 + 11 | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4528 | 0, i6 | 0, ((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0);
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i2 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
       __ZdlPv(i6);
       break L30;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4577 | 0, i12 | 0, i6 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i6 = invoke_ii(fb + 1570 | 0, 72) | 0;
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i6 + 4 >> 2] = -1;
      HEAP32[i6 >> 2] = gb + 211916 + 8;
      i7 = i6 + 12 | 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i7 + 4 >> 2] = 0;
      HEAP32[i7 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i7 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i5 = i6 + 24 | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i5 + 4 >> 2] = 0;
      HEAP32[i5 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i5 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i4 = i6 + 36 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i4 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i3 = i6 + 48 | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4530 | 0, i6 | 0, ((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0);
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i2 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
       __ZdlPv(i6);
       break L30;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4578 | 0, i12 | 0, i6 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i6 = invoke_ii(fb + 1570 | 0, 76) | 0;
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i6 + 4 >> 2] = -1;
      HEAP32[i6 >> 2] = gb + 211972 + 8;
      i7 = i6 + 16 | 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i7 + 4 >> 2] = 0;
      HEAP32[i7 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i7 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i5 = i6 + 28 | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i5 + 4 >> 2] = 0;
      HEAP32[i5 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i5 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i4 = i6 + 40 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i4 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i3 = i6 + 52 | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4531 | 0, i6 | 0, ((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0);
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i2 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
       __ZdlPv(i6);
       break L30;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4579 | 0, i12 | 0, i6 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i6 = invoke_ii(fb + 1570 | 0, 76) | 0;
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i6 + 4 >> 2] = -1;
      HEAP32[i6 >> 2] = gb + 212028 + 8;
      i7 = i6 + 16 | 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i7 + 4 >> 2] = 0;
      HEAP32[i7 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i7 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i5 = i6 + 28 | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i5 + 4 >> 2] = 0;
      HEAP32[i5 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i5 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i4 = i6 + 40 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i4 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      i3 = i6 + 52 | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      i2 = 0;
      while (1) {
       if ((i2 | 0) == 3) break;
       HEAP32[i3 + (i2 << 2) >> 2] = 0;
       i2 = i2 + 1 | 0;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4533 | 0, i6 | 0, ((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i2 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
       __ZdlPv(i6);
       break L30;
      } else {
       __THREW__ = 0;
       invoke_vii(fb + 4580 | 0, i12 | 0, i6 | 0);
       i8 = __THREW__;
       __THREW__ = 0;
       if (i8 & 1) {
        i11 = 20;
        break L30;
       } else break;
      }
     } while (0);
     do if (i10 & 2 | 0) {
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 24) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      invoke_viii(fb + 1056 | 0, i2 | 0, i9 | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4575 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 28) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      invoke_viii(fb + 1057 | 0, i2 | 0, i9 | 0, 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      } else {
       __THREW__ = 0;
       invoke_vii(fb + 4576 | 0, i12 | 0, i2 | 0);
       i8 = __THREW__;
       __THREW__ = 0;
       if (i8 & 1) {
        i11 = 20;
        break L30;
       } else break;
      }
     } while (0);
     do if (i10 & 4 | 0) {
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 544) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      i3 = i2 + 8 | 0;
      HEAP32[i2 >> 2] = gb + 209868 + 8;
      HEAP32[i3 >> 2] = gb + 209868 + 56;
      __THREW__ = 0;
      invoke_vii(fb + 4519 | 0, i2 + 12 | 0, i9 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      }
      HEAP32[i2 >> 2] = gb + 211316 + 8;
      HEAP32[i3 >> 2] = gb + 211316 + 84;
      __THREW__ = 0;
      invoke_vii(fb + 4581 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 544) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      i3 = i2 + 8 | 0;
      HEAP32[i2 >> 2] = gb + 209952 + 8;
      HEAP32[i3 >> 2] = gb + 209952 + 56;
      __THREW__ = 0;
      invoke_vii(fb + 4524 | 0, i2 + 12 | 0, i9 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      }
      HEAP32[i2 >> 2] = gb + 211428 + 8;
      HEAP32[i3 >> 2] = gb + 211428 + 84;
      __THREW__ = 0;
      invoke_vii(fb + 4582 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 213148 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4527 | 0, i2 + 8 | 0, i9 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      }
      HEAP32[i2 >> 2] = gb + 211588 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4583 | 0, i12 | 0, i2 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 12) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i11 = 20;
       break L30;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 213148 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4527 | 0, i2 + 8 | 0, i9 | 0);
      i9 = __THREW__;
      __THREW__ = 0;
      if (i9 & 1) {
       i12 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       __ZdlPv(i2);
       i2 = i12;
       break L30;
      } else {
       HEAP32[i2 >> 2] = gb + 211612 + 8;
       __THREW__ = 0;
       invoke_vii(fb + 4584 | 0, i12 | 0, i2 | 0);
       i11 = __THREW__;
       __THREW__ = 0;
       if (i11 & 1) {
        i11 = 20;
        break L30;
       } else break;
      }
     } while (0);
     if (i10 & 32 | 0) {
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) {
       i11 = 20;
       break;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 212356 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4585 | 0, i12 | 0, i2 | 0);
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) {
       i11 = 20;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_ii(fb + 1570 | 0, 8) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) {
       i11 = 20;
       break;
      }
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 >> 2] = gb + 212388 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4586 | 0, i12 | 0, i2 | 0);
      i12 = __THREW__;
      __THREW__ = 0;
      if (i12 & 1) {
       i11 = 20;
       break;
      }
     }
     return;
    } while (0);
    if ((i11 | 0) == 20) {
     i2 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
    ___cxa_begin_catch(i2 | 0) | 0;
    i3 = 0;
    while (1) {
     i2 = HEAP32[i16 >> 2] | 0;
     if (i3 >>> 0 >= (HEAP32[i13 >> 2] | 0) - i2 >> 2 >>> 0) break;
     i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
     i3 = i3 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_v(fb + 460 | 0);
    __THREW__ = 0;
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __THREW__ = 0;
    invoke_v(fb + 458 | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i14 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i14);
    } else i1 = i2;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  }
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i16);
 }
 ___resumeException(i1 | 0);
}

function __ZNK5physx20PxsSolverCoreGeneral33solveVCoulombParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESI_RNSD_IjNSF_IjEEEESL_PNS_2Cm13SpatialVectorERiSP_j(i4, f5, i29, i38, i32, i6, i1, i36, i31, i35, i44, i2, i52, i3, i46, i54, i55, i34, i37, i61, i56, i58, i43, i51, i45, i53, i33, i60, i59, i50) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i29 = i29 | 0;
 i38 = i38 | 0;
 i32 = i32 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i36 = i36 | 0;
 i31 = i31 | 0;
 i35 = i35 | 0;
 i44 = i44 | 0;
 i2 = i2 | 0;
 i52 = i52 | 0;
 i3 = i3 | 0;
 i46 = i46 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i34 = i34 | 0;
 i37 = i37 | 0;
 i61 = i61 | 0;
 i56 = i56 | 0;
 i58 = i58 | 0;
 i43 = i43 | 0;
 i51 = i51 | 0;
 i45 = i45 | 0;
 i53 = i53 | 0;
 i33 = i33 | 0;
 i60 = i60 | 0;
 i59 = i59 | 0;
 i50 = i50 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i47 = 0, i48 = 0, i49 = 0, i57 = 0, i62 = 0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i57;
 HEAP32[i47 + 16 >> 2] = i6;
 i39 = HEAP32[i43 + 4 >> 2] | 0;
 i42 = HEAP32[i51 + 4 >> 2] | 0;
 i48 = i47 + 4 | 0;
 HEAP32[i48 >> 2] = i57 + 24;
 HEAP32[i47 + 12 >> 2] = 32;
 i49 = i47 + 8 | 0;
 HEAP32[i49 >> 2] = 0;
 i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i46, i50) | 0) - i50 | 0;
 i26 = __ZN5physx6shdfnd9atomicAddEPVii(i55, i50) | 0;
 i22 = i29 + -1 | 0;
 i41 = i45 + 4 | 0;
 i23 = 0;
 i6 = i50;
 i24 = 0;
 i25 = i22;
 i8 = 0;
 i1 = 0;
 i4 = 0;
 while (1) {
  i19 = (i24 | 0) == 0 ? gb + 103460 | 0 : gb + 103400 | 0;
  if (i23 >>> 0 < (i22 + i24 | 0) >>> 0) {
   i21 = i4 + i25 | 0;
   i2 = HEAP32[i41 >> 2] | 0;
   i20 = i23;
   i18 = i4;
   while (1) {
    if (!i2) i2 = 0; else {
     i16 = Math_imul(i18, i39) | 0;
     i17 = 0;
     do {
      if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
       i2 = 3e4;
       do {
        i2 = i2 + -1 | 0;
        if (!i2) {
         __ZN5physx6shdfnd10ThreadImpl5yieldEv();
         i2 = 1e4;
        }
       } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
      }
      i40 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      i8 = i40 + i8 | 0;
      i1 = i40 + i1 | 0;
      if ((i8 | 0) > (i3 | 0)) {
       i2 = 0;
       do {
        i15 = i8 - i3 | 0;
        i15 = (i15 | 0) < (i6 | 0) ? i15 : i6;
        i4 = i3 - i16 | 0;
        i13 = HEAP32[i43 >> 2] | 0;
        i14 = i15 + i4 | 0;
        if ((i15 | 0) > 0) do {
         i12 = HEAP16[i13 + (i4 << 3) + 4 >> 1] | 0;
         i11 = HEAP32[i13 + (i4 << 3) >> 2] | 0;
         i10 = HEAP32[i44 + (i11 << 5) + 16 >> 2] | 0;
         i9 = i10;
         i30 = _bitshift64Lshr(i9 | 0, 0, 6) | 0;
         i40 = getTempRet0() | 0;
         i9 = _i64Add(i9 | 0, 0, 383, 0) | 0;
         i9 = _bitshift64Lshr(i9 | 0, getTempRet0() | 0, 6) | 0;
         i7 = getTempRet0() | 0;
         i40 = _i64Subtract(1, 0, i30 | 0, i40 | 0) | 0;
         i7 = _i64Add(i40 | 0, getTempRet0() | 0, i9 | 0, i7 | 0) | 0;
         i9 = getTempRet0() | 0;
         while (1) {
          i7 = _i64Add(i7 | 0, i9 | 0, -1, -1) | 0;
          i9 = getTempRet0() | 0;
          if ((i7 | 0) == 0 & (i9 | 0) == 0) break; else i10 = i10 + 64 | 0;
         }
         i10 = i12 & 65535;
         i9 = i44 + (i11 << 5) | 0;
         if (i12 << 16 >> 16) {
          i7 = 0;
          do i7 = i7 + 1 | 0; while ((i7 | 0) != (i10 | 0));
         }
         mftCall_viii(HEAP32[i19 + ((HEAPU16[i13 + (i4 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i9 | 0, i10 | 0, i47 | 0);
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) < (i14 | 0));
        i2 = i15 + i2 | 0;
        if ((i6 | 0) == (i15 | 0)) {
         i6 = i50;
         i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i46, i50) | 0) - i50 | 0;
        } else {
         i6 = i6 - i15 | 0;
         i3 = i15 + i3 | 0;
        }
       } while ((i8 | 0) > (i3 | 0));
       if (i2) __ZN5physx6shdfnd9atomicAddEPVii(i54, i2) | 0;
      }
      i17 = i17 + 1 | 0;
      i2 = HEAP32[i41 >> 2] | 0;
     } while (i17 >>> 0 < i2 >>> 0);
    }
    i20 = i20 + 1 | 0;
    if ((i20 | 0) == (i25 | 0)) break; else i18 = i18 + 1 | 0;
   }
   i2 = i25;
   i4 = i21 - i23 | 0;
  } else i2 = i23;
  i24 = i24 + 1 | 0;
  if ((i24 | 0) == 2) {
   i30 = i3;
   i20 = i4;
   break;
  } else {
   i23 = i2;
   i25 = i25 + 1 | 0;
  }
 }
 i28 = (i29 << 1) + -1 | 0;
 i40 = i53 + 4 | 0;
 i27 = i2;
 i2 = i50;
 i3 = i26 - i50 | 0;
 i10 = 0;
 i26 = 0;
 i25 = (i29 << 1) + -1 | 0;
 i4 = 0;
 while (1) {
  i22 = (i26 | 0) == 0 ? gb + 103460 | 0 : gb + 103400 | 0;
  if (i27 >>> 0 < (i28 + i26 | 0) >>> 0) {
   i24 = i10 + i25 | 0;
   i7 = HEAP32[i40 >> 2] | 0;
   i23 = i27;
   i21 = i10;
   while (1) {
    if (!i7) i7 = 0; else {
     i18 = Math_imul(i21, i42) | 0;
     i19 = 0;
     do {
      if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
       i7 = 3e4;
       do {
        i7 = i7 + -1 | 0;
        if (!i7) {
         __ZN5physx6shdfnd10ThreadImpl5yieldEv();
         i7 = 1e4;
        }
       } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
      }
      i29 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i19 << 2) >> 2] | 0;
      i1 = i29 + i1 | 0;
      i4 = i29 + i4 | 0;
      if ((i4 | 0) > (i3 | 0)) {
       i7 = 0;
       do {
        i17 = i4 - i3 | 0;
        i17 = (i17 | 0) < (i2 | 0) ? i17 : i2;
        i9 = i3 - i18 | 0;
        i15 = HEAP32[i51 >> 2] | 0;
        i16 = i17 + i9 | 0;
        if ((i17 | 0) > 0) do {
         i14 = HEAP16[i15 + (i9 << 3) + 4 >> 1] | 0;
         i13 = HEAP32[i15 + (i9 << 3) >> 2] | 0;
         i12 = HEAP32[i52 + (i13 << 5) + 16 >> 2] | 0;
         i11 = i12;
         i62 = _bitshift64Lshr(i11 | 0, 0, 6) | 0;
         i29 = getTempRet0() | 0;
         i11 = _i64Add(i11 | 0, 0, 383, 0) | 0;
         i11 = _bitshift64Lshr(i11 | 0, getTempRet0() | 0, 6) | 0;
         i10 = getTempRet0() | 0;
         i29 = _i64Subtract(1, 0, i62 | 0, i29 | 0) | 0;
         i10 = _i64Add(i29 | 0, getTempRet0() | 0, i11 | 0, i10 | 0) | 0;
         i11 = getTempRet0() | 0;
         while (1) {
          i10 = _i64Add(i10 | 0, i11 | 0, -1, -1) | 0;
          i11 = getTempRet0() | 0;
          if ((i10 | 0) == 0 & (i11 | 0) == 0) break; else i12 = i12 + 64 | 0;
         }
         i12 = i14 & 65535;
         i11 = i52 + (i13 << 5) | 0;
         if (i14 << 16 >> 16) {
          i10 = 0;
          do i10 = i10 + 1 | 0; while ((i10 | 0) != (i12 | 0));
         }
         mftCall_viii(HEAP32[i22 + ((HEAPU16[i15 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i11 | 0, i12 | 0, i47 | 0);
         i9 = i9 + 1 | 0;
        } while ((i9 | 0) < (i16 | 0));
        i7 = i17 + i7 | 0;
        if ((i2 | 0) == (i17 | 0)) {
         i2 = i50;
         i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i55, i50) | 0) - i50 | 0;
        } else {
         i2 = i2 - i17 | 0;
         i3 = i17 + i3 | 0;
        }
       } while ((i4 | 0) > (i3 | 0));
       if (i7) __ZN5physx6shdfnd9atomicAddEPVii(i54, i7) | 0;
      }
      i19 = i19 + 1 | 0;
      i7 = HEAP32[i40 >> 2] | 0;
     } while (i19 >>> 0 < i7 >>> 0);
    }
    i23 = i23 + 1 | 0;
    if ((i23 | 0) == (i25 | 0)) break; else i21 = i21 + 1 | 0;
   }
   i9 = i25;
   i7 = i24 - i27 | 0;
  } else {
   i9 = i27;
   i7 = i10;
  }
  i26 = i26 + 1 | 0;
  if ((i26 | 0) == 2) {
   i18 = i7;
   i21 = i4;
   break;
  } else {
   i27 = i9;
   i10 = i7;
   i25 = i25 + 1 | 0;
  }
 }
 if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
  i4 = 3e4;
  do {
   i4 = i4 + -1 | 0;
   if (!i4) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i4 = 1e4;
   }
  } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
 }
 i7 = (__ZN5physx6shdfnd9atomicAddEPVii(i34, 64) | 0) + -64 | 0;
 if ((i7 | 0) < (i35 | 0)) {
  i17 = ~i35;
  i16 = 64;
  i4 = 0;
  while (1) {
   i15 = i35 - i7 | 0;
   i15 = (i15 | 0) > 64 ? 64 : i15;
   i9 = i16 - i15 | 0;
   if ((i15 | 0) > 0) {
    i14 = i7 + i17 | 0;
    i14 = (i14 | 0) > -65 ? i14 : -65;
    i10 = ~i14;
    i12 = 0;
    i13 = i7;
    while (1) {
     i11 = HEAP32[gb + 1457372 >> 2] | 0;
     if (i11 | 0) mftCall_vi(i11 | 0, i31 + (i13 * 40 | 0) | 0);
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i10 | 0)) break; else i13 = i13 + 1 | 0;
    }
    i7 = i7 + -1 - i14 | 0;
   }
   i4 = i15 + i4 | 0;
   if ((i16 | 0) == (i15 | 0)) {
    i9 = 64;
    i7 = (__ZN5physx6shdfnd9atomicAddEPVii(i34, 64) | 0) + -64 | 0;
   }
   if ((i7 | 0) < (i35 | 0)) i16 = i9; else break;
  }
 } else {
  i9 = 64;
  i4 = 0;
 }
 i7 = i7 - i35 | 0;
 if ((i7 | 0) < (i36 | 0)) {
  i12 = ~i36;
  while (1) {
   i11 = i36 - i7 | 0;
   i11 = (i9 | 0) < (i11 | 0) ? i9 : i11;
   if ((i11 | 0) > 0) {
    i10 = i7 + i12 | 0;
    i9 = ~i9;
    i9 = ~((i10 | 0) > (i9 | 0) ? i10 : i9);
    i10 = 0;
    while (1) {
     HEAP32[i33 + (i7 << 5) >> 2] = HEAP32[i32 + (i7 << 5) >> 2];
     HEAP32[i33 + (i7 << 5) + 4 >> 2] = HEAP32[i32 + (i7 << 5) + 4 >> 2];
     HEAP32[i33 + (i7 << 5) + 8 >> 2] = HEAP32[i32 + (i7 << 5) + 8 >> 2];
     HEAP32[i33 + (i7 << 5) + 16 >> 2] = HEAP32[i32 + (i7 << 5) + 16 >> 2];
     HEAP32[i33 + (i7 << 5) + 20 >> 2] = HEAP32[i32 + (i7 << 5) + 20 >> 2];
     HEAP32[i33 + (i7 << 5) + 24 >> 2] = HEAP32[i32 + (i7 << 5) + 24 >> 2];
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i9 | 0)) break; else i7 = i7 + 1 | 0;
    }
   }
   i4 = i11 + i4 | 0;
   i7 = (__ZN5physx6shdfnd9atomicAddEPVii(i34, 64) | 0) + -64 - i35 | 0;
   if ((i7 | 0) >= (i36 | 0)) break; else i9 = 64;
  }
 }
 if (i4 | 0) __ZN5physx6shdfnd9atomicAddEPVii(i37, i4) | 0;
 i7 = i35 + i36 | 0;
 if ((HEAP32[i37 >> 2] | 0) < (i7 | 0)) if ((HEAP32[i37 >> 2] | 0) < (i7 | 0)) if ((HEAP32[i37 >> 2] | 0) < (i7 | 0)) {
  i4 = 3e4;
  do {
   i4 = i4 + -1 | 0;
   if (!i4) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i4 = 1e4;
   }
  } while ((HEAP32[i37 >> 2] | 0) < (i7 | 0));
 }
 i24 = i38 + -1 | 0;
 if (!i24) {
  i22 = i18;
  i4 = i30;
 } else {
  i25 = i18 + i38 | 0;
  i26 = i20 + i38 | 0;
  i23 = 0;
  i22 = i18;
  i4 = i30;
  i7 = i21;
  while (1) {
   if (!(HEAP32[i41 >> 2] | 0)) i21 = i4; else {
    i19 = Math_imul(i20, i39) | 0;
    i21 = 0;
    i9 = i4;
    while (1) {
     if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
      i4 = 3e4;
      do {
       i4 = i4 + -1 | 0;
       if (!i4) {
        __ZN5physx6shdfnd10ThreadImpl5yieldEv();
        i4 = 1e4;
       }
      } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
     }
     i62 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i21 << 2) >> 2] | 0;
     i8 = i62 + i8 | 0;
     i1 = i62 + i1 | 0;
     if ((i8 | 0) > (i9 | 0)) {
      i4 = i9;
      i9 = 0;
      do {
       i18 = i8 - i4 | 0;
       i18 = (i18 | 0) < (i6 | 0) ? i18 : i6;
       i10 = i4 - i19 | 0;
       i16 = HEAP32[i43 >> 2] | 0;
       i17 = i18 + i10 | 0;
       if ((i18 | 0) > 0) do {
        i15 = HEAP16[i16 + (i10 << 3) + 4 >> 1] | 0;
        i14 = HEAP32[i16 + (i10 << 3) >> 2] | 0;
        i13 = HEAP32[i44 + (i14 << 5) + 16 >> 2] | 0;
        i12 = i13;
        i38 = _bitshift64Lshr(i12 | 0, 0, 6) | 0;
        i62 = getTempRet0() | 0;
        i12 = _i64Add(i12 | 0, 0, 383, 0) | 0;
        i12 = _bitshift64Lshr(i12 | 0, getTempRet0() | 0, 6) | 0;
        i11 = getTempRet0() | 0;
        i62 = _i64Subtract(1, 0, i38 | 0, i62 | 0) | 0;
        i11 = _i64Add(i62 | 0, getTempRet0() | 0, i12 | 0, i11 | 0) | 0;
        i12 = getTempRet0() | 0;
        while (1) {
         i11 = _i64Add(i11 | 0, i12 | 0, -1, -1) | 0;
         i12 = getTempRet0() | 0;
         if ((i11 | 0) == 0 & (i12 | 0) == 0) break; else i13 = i13 + 64 | 0;
        }
        i13 = i15 & 65535;
        i12 = i44 + (i14 << 5) | 0;
        if (i15 << 16 >> 16) {
         i11 = 0;
         do i11 = i11 + 1 | 0; while ((i11 | 0) != (i13 | 0));
        }
        mftCall_viii(HEAP32[gb + 103460 + ((HEAPU16[i16 + (i10 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i12 | 0, i13 | 0, i47 | 0);
        i10 = i10 + 1 | 0;
       } while ((i10 | 0) < (i17 | 0));
       i9 = i18 + i9 | 0;
       if ((i6 | 0) == (i18 | 0)) {
        i6 = i50;
        i4 = (__ZN5physx6shdfnd9atomicAddEPVii(i46, i50) | 0) - i50 | 0;
       } else {
        i6 = i6 - i18 | 0;
        i4 = i18 + i4 | 0;
       }
      } while ((i8 | 0) > (i4 | 0));
      if (i9) __ZN5physx6shdfnd9atomicAddEPVii(i54, i9) | 0;
     } else i4 = i9;
     i21 = i21 + 1 | 0;
     if (i21 >>> 0 >= (HEAP32[i41 >> 2] | 0) >>> 0) {
      i21 = i4;
      break;
     } else i9 = i4;
    }
   }
   i20 = i20 + 1 | 0;
   if (HEAP32[i40 >> 2] | 0) {
    i18 = Math_imul(i22, i42) | 0;
    i19 = 0;
    do {
     if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
      i4 = 3e4;
      do {
       i4 = i4 + -1 | 0;
       if (!i4) {
        __ZN5physx6shdfnd10ThreadImpl5yieldEv();
        i4 = 1e4;
       }
      } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
     }
     i62 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i19 << 2) >> 2] | 0;
     i7 = i62 + i7 | 0;
     i1 = i62 + i1 | 0;
     if ((i7 | 0) > (i3 | 0)) {
      i4 = 0;
      do {
       i17 = i7 - i3 | 0;
       i17 = (i17 | 0) < (i2 | 0) ? i17 : i2;
       i9 = i3 - i18 | 0;
       i15 = HEAP32[i51 >> 2] | 0;
       i16 = i17 + i9 | 0;
       if ((i17 | 0) > 0) do {
        i14 = HEAP16[i15 + (i9 << 3) + 4 >> 1] | 0;
        i13 = HEAP32[i15 + (i9 << 3) >> 2] | 0;
        i12 = HEAP32[i52 + (i13 << 5) + 16 >> 2] | 0;
        i11 = i12;
        i38 = _bitshift64Lshr(i11 | 0, 0, 6) | 0;
        i62 = getTempRet0() | 0;
        i11 = _i64Add(i11 | 0, 0, 383, 0) | 0;
        i11 = _bitshift64Lshr(i11 | 0, getTempRet0() | 0, 6) | 0;
        i10 = getTempRet0() | 0;
        i62 = _i64Subtract(1, 0, i38 | 0, i62 | 0) | 0;
        i10 = _i64Add(i62 | 0, getTempRet0() | 0, i11 | 0, i10 | 0) | 0;
        i11 = getTempRet0() | 0;
        while (1) {
         i10 = _i64Add(i10 | 0, i11 | 0, -1, -1) | 0;
         i11 = getTempRet0() | 0;
         if ((i10 | 0) == 0 & (i11 | 0) == 0) break; else i12 = i12 + 64 | 0;
        }
        i12 = i14 & 65535;
        i11 = i52 + (i13 << 5) | 0;
        if (i14 << 16 >> 16) {
         i10 = 0;
         do i10 = i10 + 1 | 0; while ((i10 | 0) != (i12 | 0));
        }
        mftCall_viii(HEAP32[gb + 103460 + ((HEAPU16[i15 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i11 | 0, i12 | 0, i47 | 0);
        i9 = i9 + 1 | 0;
       } while ((i9 | 0) < (i16 | 0));
       i4 = i17 + i4 | 0;
       if ((i2 | 0) == (i17 | 0)) {
        i2 = i50;
        i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i55, i50) | 0) - i50 | 0;
       } else {
        i2 = i2 - i17 | 0;
        i3 = i17 + i3 | 0;
       }
      } while ((i7 | 0) > (i3 | 0));
      if (i4) __ZN5physx6shdfnd9atomicAddEPVii(i54, i4) | 0;
     }
     i19 = i19 + 1 | 0;
    } while (i19 >>> 0 < (HEAP32[i40 >> 2] | 0) >>> 0);
   }
   i23 = i23 + 1 | 0;
   if ((i23 | 0) == (i24 | 0)) {
    i4 = i21;
    break;
   } else {
    i22 = i22 + 1 | 0;
    i4 = i21;
   }
  }
  i22 = i25 + -1 | 0;
  i21 = i7;
  i20 = i26 + -1 | 0;
 }
 if (HEAP32[i41 >> 2] | 0) {
  i18 = Math_imul(i20, i39) | 0;
  i19 = 0;
  i7 = i4;
  i17 = i8;
  while (1) {
   if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i1 | 0)) {
    i4 = 3e4;
    do {
     i4 = i4 + -1 | 0;
     if (!i4) {
      __ZN5physx6shdfnd10ThreadImpl5yieldEv();
      i4 = 1e4;
     }
    } while ((HEAP32[i54 >> 2] | 0) < (i1 | 0));
   }
   i62 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i19 << 2) >> 2] | 0;
   i17 = i62 + i17 | 0;
   i1 = i62 + i1 | 0;
   if ((i17 | 0) > (i7 | 0)) {
    i4 = i7;
    i7 = 0;
    do {
     i16 = i17 - i4 | 0;
     i16 = (i16 | 0) < (i6 | 0) ? i16 : i6;
     i8 = i4 - i18 | 0;
     i14 = HEAP32[i43 >> 2] | 0;
     i15 = i16 + i8 | 0;
     if ((i16 | 0) > 0) do {
      i13 = HEAP16[i14 + (i8 << 3) + 4 >> 1] | 0;
      i12 = HEAP32[i14 + (i8 << 3) >> 2] | 0;
      i11 = HEAP32[i44 + (i12 << 5) + 16 >> 2] | 0;
      i10 = i11;
      i39 = _bitshift64Lshr(i10 | 0, 0, 6) | 0;
      i62 = getTempRet0() | 0;
      i10 = _i64Add(i10 | 0, 0, 383, 0) | 0;
      i10 = _bitshift64Lshr(i10 | 0, getTempRet0() | 0, 6) | 0;
      i9 = getTempRet0() | 0;
      i62 = _i64Subtract(1, 0, i39 | 0, i62 | 0) | 0;
      i9 = _i64Add(i62 | 0, getTempRet0() | 0, i10 | 0, i9 | 0) | 0;
      i10 = getTempRet0() | 0;
      while (1) {
       i9 = _i64Add(i9 | 0, i10 | 0, -1, -1) | 0;
       i10 = getTempRet0() | 0;
       if ((i9 | 0) == 0 & (i10 | 0) == 0) break; else i11 = i11 + 64 | 0;
      }
      i11 = i13 & 65535;
      i10 = i44 + (i12 << 5) | 0;
      if (i13 << 16 >> 16) {
       i9 = 0;
       do i9 = i9 + 1 | 0; while ((i9 | 0) != (i11 | 0));
      }
      mftCall_viiiiii(HEAP32[gb + 103520 + ((HEAPU16[i14 + (i8 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i10 | 0, i11 | 0, i47 | 0, i61 | 0, i56 | 0, i58 | 0);
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) < (i15 | 0));
     i7 = i16 + i7 | 0;
     if ((i6 | 0) == (i16 | 0)) {
      i6 = i50;
      i4 = (__ZN5physx6shdfnd9atomicAddEPVii(i46, i50) | 0) - i50 | 0;
     } else {
      i6 = i6 - i16 | 0;
      i4 = i16 + i4 | 0;
     }
    } while ((i17 | 0) > (i4 | 0));
    if (i7) __ZN5physx6shdfnd9atomicAddEPVii(i54, i7) | 0;
   } else i4 = i7;
   i19 = i19 + 1 | 0;
   if (i19 >>> 0 >= (HEAP32[i41 >> 2] | 0) >>> 0) break; else i7 = i4;
  }
 }
 i18 = i20 + 1 | 0;
 if (HEAP32[i40 >> 2] | 0) {
  i16 = Math_imul(i22, i42) | 0;
  i17 = 0;
  i15 = i21;
  i14 = i1;
  while (1) {
   if ((HEAP32[i54 >> 2] | 0) < (i14 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i14 | 0)) if ((HEAP32[i54 >> 2] | 0) < (i14 | 0)) {
    i1 = 3e4;
    do {
     i1 = i1 + -1 | 0;
     if (!i1) {
      __ZN5physx6shdfnd10ThreadImpl5yieldEv();
      i1 = 1e4;
     }
    } while ((HEAP32[i54 >> 2] | 0) < (i14 | 0));
   }
   i62 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i17 << 2) >> 2] | 0;
   i15 = i62 + i15 | 0;
   i14 = i62 + i14 | 0;
   if ((i15 | 0) > (i3 | 0)) {
    i1 = i3;
    i3 = 0;
    do {
     i13 = i15 - i1 | 0;
     i13 = (i13 | 0) < (i2 | 0) ? i13 : i2;
     i4 = i1 - i16 | 0;
     i11 = HEAP32[i51 >> 2] | 0;
     i12 = i13 + i4 | 0;
     if ((i13 | 0) > 0) do {
      i10 = HEAP16[i11 + (i4 << 3) + 4 >> 1] | 0;
      i9 = HEAP32[i11 + (i4 << 3) >> 2] | 0;
      i8 = HEAP32[i52 + (i9 << 5) + 16 >> 2] | 0;
      i7 = i8;
      i46 = _bitshift64Lshr(i7 | 0, 0, 6) | 0;
      i62 = getTempRet0() | 0;
      i7 = _i64Add(i7 | 0, 0, 383, 0) | 0;
      i7 = _bitshift64Lshr(i7 | 0, getTempRet0() | 0, 6) | 0;
      i6 = getTempRet0() | 0;
      i62 = _i64Subtract(1, 0, i46 | 0, i62 | 0) | 0;
      i6 = _i64Add(i62 | 0, getTempRet0() | 0, i7 | 0, i6 | 0) | 0;
      i7 = getTempRet0() | 0;
      while (1) {
       i6 = _i64Add(i6 | 0, i7 | 0, -1, -1) | 0;
       i7 = getTempRet0() | 0;
       if ((i6 | 0) == 0 & (i7 | 0) == 0) break; else i8 = i8 + 64 | 0;
      }
      i8 = i10 & 65535;
      i7 = i52 + (i9 << 5) | 0;
      if (i10 << 16 >> 16) {
       i6 = 0;
       do i6 = i6 + 1 | 0; while ((i6 | 0) != (i8 | 0));
      }
      mftCall_viiiiii(HEAP32[gb + 103520 + ((HEAPU16[i11 + (i4 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i7 | 0, i8 | 0, i47 | 0, i61 | 0, i56 | 0, i58 | 0);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i12 | 0));
     i3 = i13 + i3 | 0;
     if ((i2 | 0) == (i13 | 0)) {
      i2 = i50;
      i1 = (__ZN5physx6shdfnd9atomicAddEPVii(i55, i50) | 0) - i50 | 0;
     } else {
      i2 = i2 - i13 | 0;
      i1 = i13 + i1 | 0;
     }
    } while ((i15 | 0) > (i1 | 0));
    if (i3) __ZN5physx6shdfnd9atomicAddEPVii(i54, i3) | 0;
   } else i1 = i3;
   i17 = i17 + 1 | 0;
   if (i17 >>> 0 >= (HEAP32[i40 >> 2] | 0) >>> 0) break; else i3 = i1;
  }
 }
 i1 = HEAP32[i49 >> 2] | 0;
 if (!i1) {
  i62 = i22 + 1 | 0;
  HEAP32[i60 >> 2] = i18;
  HEAP32[i59 >> 2] = i62;
  STACKTOP = i57;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i58, i1) | 0;
 i3 = HEAP32[i49 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i48 >> 2] | 0;
  i2 = 0;
  do {
   i62 = i61 + (i4 + i2 << 4) | 0;
   i58 = i1 + (i2 << 4) | 0;
   HEAP32[i62 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i62 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i62 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   HEAP32[i62 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i49 >> 2] = 0;
 i62 = i22 + 1 | 0;
 HEAP32[i60 >> 2] = i18;
 HEAP32[i59 >> 2] = i62;
 STACKTOP = i57;
 return;
}

function __Z21GenerateSpriteOutline4PPtrI9Texture2DEfRK5RectTIfERK8Vector2ffhbjibPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENS9_9allocatorISC_EEEEPSB_I12SpriteVertexLj4EEPSB_ItLj2EEPS3_P8Vector4f(i1, f37, i6, i7, f5, i21, i22, i23, i24, i30, i26, i38, i36, i39, i9) {
 i1 = i1 | 0;
 f37 = Math_fround(f37);
 i6 = i6 | 0;
 i7 = i7 | 0;
 f5 = Math_fround(f5);
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i30 = i30 | 0;
 i26 = i26 | 0;
 i38 = i38 | 0;
 i36 = i36 | 0;
 i39 = i39 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f8 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i43 + 72 | 0;
 i31 = i43;
 i40 = i43 + 120 | 0;
 i41 = i43 + 100 | 0;
 i42 = i43 + 80 | 0;
 i20 = HEAP32[i1 >> 2] | 0;
 if (!i20) {
  STACKTOP = i43;
  return;
 }
 HEAP32[i31 >> 2] = i20;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i1, i31);
   i2 = HEAP32[i29 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i28 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i28 + 28 >> 2] | 0;
   i4 = HEAP32[i28 + 32 >> 2] | 0;
   i1 = i28;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i13 = 9;
 }
 if ((i13 | 0) == 7) i13 = 9;
 do if ((i13 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i20) | 0)) {
  STACKTOP = i43;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i31 >> 2] = i20;
 if (!i1) i13 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i1, i31);
   i2 = HEAP32[i29 >> 2] | 0;
   i28 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i28 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i28 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 18;
  }
 }
 if ((i13 | 0) == 16) i13 = 18;
 if ((i13 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(i20) | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i31 >> 2] = i20;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 24; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i1, i31);
   i2 = HEAP32[i29 >> 2] | 0;
   i28 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i28 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i28 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 24; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 26;
  }
 }
 if ((i13 | 0) == 24) i13 = 26;
 if ((i13 | 0) == 26) i1 = __Z31ReadObjectFromPersistentManageri(i20) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i12 = ~~Math_fround(Math_floor(Math_fround(f8)));
 f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i14 = ~~Math_fround(Math_floor(Math_fround(f10)));
 i1 = ~~Math_fround(Math_ceil(Math_fround(f8 + Math_fround(HEAPF32[i6 + 8 >> 2]))));
 i2 = ~~Math_fround(Math_ceil(Math_fround(f10 + Math_fround(HEAPF32[i6 + 12 >> 2]))));
 if ((i14 | i12 | 0) < 0 | ((i1 | 0) > (i15 + 1 | 0) | (i2 | 0) > (i3 + 1 | 0))) {
  STACKTOP = i43;
  return;
 }
 i17 = ((i1 | 0) > (i15 | 0) ? i15 : i1) - i12 | 0;
 i16 = ((i2 | 0) > (i3 | 0) ? i3 : i2) - i14 | 0;
 f34 = Math_fround(f8 - Math_fround(i12 | 0));
 f32 = Math_fround(f10 - Math_fround(i14 | 0));
 f33 = Math_fround(i17 | 0);
 f18 = Math_fround(f33 * Math_fround(.5));
 f34 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i7 >> 2])) - f34);
 f35 = Math_fround(i16 | 0);
 f19 = Math_fround(f35 * Math_fround(.5));
 f32 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i7 + 4 >> 2])) - f32);
 if (i9 | 0) {
  HEAPF32[i9 >> 2] = f37;
  HEAPF32[i9 + 4 >> 2] = Math_fround(f34 + f8);
  HEAPF32[i9 + 8 >> 2] = f37;
  HEAPF32[i9 + 12 >> 2] = Math_fround(f32 + f10);
 }
 HEAP32[i40 >> 2] = 0;
 i9 = i40 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 i11 = gb + 63160 | 0;
 i25 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i27 = i40 + 20 | 0;
 HEAP32[i27 >> 2] = i25;
 HEAP32[i27 + 4 >> 2] = i11;
 HEAP32[i40 + 32 >> 2] = 0;
 HEAP32[i40 + 36 >> 2] = 0;
 i27 = i40 + 28 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i40 + 48 | 0;
 HEAP32[i28 >> 2] = i25;
 HEAP32[i28 + 4 >> 2] = i11;
 HEAP32[i40 + 60 >> 2] = 0;
 HEAP32[i40 + 64 >> 2] = 0;
 i28 = i40 + 56 | 0;
 HEAP32[i28 >> 2] = 0;
 i11 = (i26 | 0) != 0;
 if (i11 & i30) {
  i13 = i26 + 4 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i26 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i13 = 42; else {
   __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE6resizeEj(i40, (i1 - i2 | 0) / 20 | 0);
   i1 = HEAP32[i26 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) i13 = 98; else {
    i12 = 0;
    while (1) {
     i7 = HEAP32[i40 >> 2] | 0;
     i11 = i7 + (i12 * 68 | 0) | 0;
     i3 = i1 + 12 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     i7 = i7 + (i12 * 68 | 0) + 4 | 0;
     i9 = HEAP32[i7 >> 2] | 0;
     i6 = HEAP32[i11 >> 2] | 0;
     i4 = i9 - i6 >> 5;
     if (i2 >>> 0 > i4 >>> 0) {
      __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE8__appendEj(i11, i2 - i4 | 0);
      i2 = HEAP32[i3 >> 2] | 0;
     } else if (i2 >>> 0 < i4 >>> 0) {
      i3 = i6 + (i2 << 5) | 0;
      if ((i9 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = i9 + (~((i9 + -32 - i3 | 0) >>> 5) << 5);
     }
     if (i2 | 0) {
      i3 = HEAP32[i1 >> 2] | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      i4 = i3 + (i2 << 3) | 0;
      i2 = 0;
      while (1) {
       f8 = Math_fround(f18 + Math_fround(HEAPF32[i3 >> 2]));
       f10 = Math_fround(f19 + Math_fround(HEAPF32[i3 + 4 >> 2]));
       HEAPF32[i6 + (i2 << 5) >> 2] = f8;
       HEAPF32[i6 + (i2 << 5) + 4 >> 2] = f10;
       i3 = i3 + 8 | 0;
       if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + 1 | 0;
      }
     }
     __ZN19SpriteMeshGenerator4path18SetSizeUnOptimizedEii(i11, i17, i16);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
      i13 = 98;
      break;
     } else i12 = i12 + 1 | 0;
    }
   }
  }
 } else i13 = 42;
 do if ((i13 | 0) == 42) {
  i7 = i17 << 2;
  i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(Math_imul(i7, i16) | 0, 16, gb + 63160 | 0, 0, gb + 412194 | 0, 105) | 0;
  i4 = Math_imul(i3, i15) | 0;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 16, gb + 63160 | 0, 0, gb + 412194 | 0, 108) | 0;
  HEAP32[i31 >> 2] = i20;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 47; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i1, i31);
    i2 = HEAP32[i29 >> 2] | 0;
    i44 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i44 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i44 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 47; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 49;
   }
  }
  if ((i13 | 0) == 47) i13 = 49;
  if ((i13 | 0) == 49) i1 = __Z31ReadObjectFromPersistentManageri(i20) | 0;
  if (!(__ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i(i1, 0, i6, i4) | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 412269 | 0, 0, gb + 412194 | 0, 111, 1, 0, 0, 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63160 | 0);
   break;
  }
  if ((i16 | 0) > 0) {
   i1 = 0;
   do {
    _memcpy(i25 + ((Math_imul(i1, i17) | 0) << 2) | 0, i6 + ((Math_imul(i1 + i14 | 0, i15) | 0) << 2) + (i12 << 2) | 0, i7 | 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i16 | 0));
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63160 | 0);
  if (f5 >= Math_fround(0.0)) {
   i44 = f5 < Math_fround(0.0);
   i20 = f5 > Math_fround(1.0);
   f5 = Math_fround(Math_fround(1.0) - (i20 ? Math_fround(1.0) : f5));
   f5 = i44 ? Math_fround(1.0) : f5;
  }
  __ZN19SpriteMeshGenerator9MakeShapeEP11ColorRGBA32iifhbjfi(i40, i25, i17, i16, f5, i21, i22, (i23 | 0) == 0 ? 1 : i23 >>> 0 > 32 ? 32 : i23, Math_fround(1.0), i24);
  if (i11) {
   i6 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i40 >> 2] | 0) | 0;
   i22 = (i6 | 0) / 68 | 0;
   i7 = i26 + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = (i3 - i2 | 0) / 20 | 0;
   if (i22 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i26, i22 - i1 | 0); else if (i22 >>> 0 < i1 >>> 0) {
    i4 = i2 + (i22 * 20 | 0) | 0;
    if ((i3 | 0) != (i4 | 0)) {
     i2 = i3;
     while (1) {
      i1 = i2 + -20 | 0;
      HEAP32[i7 >> 2] = i1;
      if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
       HEAP32[i1 >> 2] = 0;
       i1 = HEAP32[i7 >> 2] | 0;
      }
      if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
     }
    }
   }
   if ((i6 | 0) > 0) {
    i11 = i41 + 12 | 0;
    i12 = i41 + 16 | 0;
    i13 = i41 + 4 | 0;
    i14 = i31 + 4 | 0;
    i15 = i31 + 56 | 0;
    i16 = i31 + 44 | 0;
    i17 = i31 + 48 | 0;
    i20 = i31 + 60 | 0;
    i21 = i41 + 8 | 0;
    i9 = 0;
    do {
     __ZN19SpriteMeshGenerator16GetOptimizedPathEi(i31, i40, i9);
     HEAP32[i41 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i12 >> 2] = 0;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, gb + 63664 | 0);
     i3 = i29;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i1 = i13;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = i2;
     i1 = (HEAP32[i14 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0;
     i2 = i1 >> 5;
     i3 = HEAP32[i12 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i12 >> 2] = i2;
      HEAP32[i41 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i41 >> 2] | 0, i1 >> 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i44 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 >> 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i44 | 0, HEAP32[i41 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
      HEAP32[i12 >> 2] = i2;
      HEAP32[i41 >> 2] = i44;
      break;
     } while (0);
     i1 = HEAP32[i31 >> 2] | 0;
     if ((i1 | 0) != (HEAP32[i14 >> 2] | 0)) {
      i3 = HEAP32[i11 >> 2] | 0;
      do {
       f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f34);
       f8 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) - f32);
       i4 = i3;
       i3 = i3 + 1 | 0;
       i6 = HEAP32[i12 >> 2] | 0;
       i7 = i6 & 2147483647;
       do if (i3 >>> 0 > i7 >>> 0) {
        i2 = i6 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i7 >>> 0 >= i2 >>> 0) break;
        if ((i6 | 0) > -1) {
         HEAP32[i12 >> 2] = i2;
         HEAP32[i41 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i41 >> 2] | 0, i2 << 3, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i44 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i44 | 0, HEAP32[i41 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
         HEAP32[i12 >> 2] = i2;
         HEAP32[i41 >> 2] = i44;
         break;
        }
       } while (0);
       HEAP32[i11 >> 2] = i3;
       i44 = HEAP32[i41 >> 2] | 0;
       HEAPF32[i44 + (i4 << 3) >> 2] = f5;
       HEAPF32[i44 + (i4 << 3) + 4 >> 2] = f8;
       i1 = i1 + 32 | 0;
      } while ((i1 | 0) != (HEAP32[i14 >> 2] | 0));
     }
     i3 = HEAP32[i26 >> 2] | 0;
     i4 = i3 + (i9 * 20 | 0) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i3 + (i9 * 20 | 0) + 4 | 0, HEAP32[i21 >> 2] | 0);
     i1 = HEAP32[i41 >> 2] | 0;
     if (!i1) i2 = 0; else {
      __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i13, HEAP32[i3 + (i9 * 20 | 0) + 8 >> 2] | 0);
      i2 = HEAP32[i41 >> 2] | 0;
     }
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i2;
     HEAP32[i41 >> 2] = i1;
     i44 = i3 + (i9 * 20 | 0) + 12 | 0;
     i24 = HEAP32[i44 >> 2] | 0;
     HEAP32[i44 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i24;
     i24 = i3 + (i9 * 20 | 0) + 16 | 0;
     i44 = HEAP32[i24 >> 2] | 0;
     HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i12 >> 2] = i44;
     i44 = i3 + (i9 * 20 | 0) + 4 | 0;
     i24 = i44;
     i23 = HEAP32[i24 >> 2] | 0;
     i24 = HEAP32[i24 + 4 >> 2] | 0;
     i6 = i13;
     i7 = HEAP32[i6 + 4 >> 2] | 0;
     HEAP32[i44 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i44 + 4 >> 2] = i7;
     i44 = i13;
     HEAP32[i44 >> 2] = i23;
     HEAP32[i44 + 4 >> 2] = i24;
     if ((HEAP32[i12 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
      HEAP32[i41 >> 2] = 0;
     }
     i1 = HEAP32[i15 >> 2] | 0;
     i2 = i1;
     if (i1 | 0) {
      i3 = HEAP32[i20 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
      __ZdlPv(i1);
     }
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     if (i1 | 0) {
      i3 = HEAP32[i17 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
      __ZdlPv(i1);
     }
     i1 = HEAP32[i31 >> 2] | 0;
     i2 = i1;
     if (i1 | 0) {
      i3 = HEAP32[i14 >> 2] | 0;
      if ((i3 | 0) != (i1 | 0)) HEAP32[i14 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
      __ZdlPv(i1);
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) < (i22 | 0));
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i25, gb + 63160 | 0);
  i13 = 98;
 } while (0);
 if ((i13 | 0) == 98) {
  if (i38 | 0) {
   i15 = gb + 64016 | 0;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i13 = i31;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = i14;
   HEAP32[i41 >> 2] = 0;
   i13 = i41 + 12 | 0;
   HEAP32[i13 >> 2] = 0;
   i14 = i41 + 16 | 0;
   HEAP32[i14 >> 2] = 0;
   i15 = i41 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i31);
   i2 = i29;
   i16 = HEAP32[i2 + 4 >> 2] | 0;
   i17 = i15;
   HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   i17 = gb + 64016 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i2 = i31;
   HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i2 + 4 >> 2] = i16;
   HEAP32[i42 >> 2] = 0;
   i2 = i42 + 12 | 0;
   HEAP32[i2 >> 2] = 0;
   i16 = i42 + 16 | 0;
   HEAP32[i16 >> 2] = 0;
   i17 = i42 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i31);
   i31 = HEAP32[i29 + 4 >> 2] | 0;
   i44 = i17;
   HEAP32[i44 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i44 + 4 >> 2] = i31;
   __ZN19SpriteMeshGenerator9DecomposeEP13dynamic_arrayI8Vector2fLj4EEPS0_ItLj2EEb(i40, i41, i42, i30 ^ 1);
   if (HEAP32[i2 >> 2] | 0) {
    i11 = i38 + 16 | 0;
    if ((HEAP32[i11 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i38 + 4 | 0);
     HEAP32[i38 >> 2] = 0;
    }
    HEAP32[i38 >> 2] = 0;
    i12 = i38 + 12 | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
    i6 = i36 + 16 | 0;
    if ((HEAP32[i6 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i36 + 4 | 0);
     HEAP32[i36 >> 2] = 0;
    }
    HEAP32[i36 >> 2] = 0;
    i7 = i36 + 12 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    i1 = HEAP32[i42 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    do if (!i4) {
     HEAP32[i7 >> 2] = i4;
     i2 = 0;
     i3 = 0;
    } else {
     i2 = i1 + (i4 << 1) + -2 | 0;
     if (i2 >>> 0 > i1 >>> 0) {
      i3 = i1;
      do {
       i44 = HEAP16[i3 >> 1] | 0;
       HEAP16[i3 >> 1] = HEAP16[i2 >> 1] | 0;
       HEAP16[i2 >> 1] = i44;
       i3 = i3 + 2 | 0;
       i2 = i2 + -2 | 0;
      } while (i3 >>> 0 < i2 >>> 0);
      HEAP32[i7 >> 2] = i4;
      if (!i4) {
       i2 = 0;
       i3 = 0;
       break;
      }
     } else HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i4;
     i2 = i4 << 1;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2, 2, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i36 >> 2] = i3;
     i1 = HEAP32[i42 >> 2] | 0;
    } while (0);
    _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
     if ((i2 | 0) > -1) {
      HEAP32[i11 >> 2] = i1;
      HEAP32[i38 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i38 >> 2] | 0, i1 * 20 | 0, 4, i38 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     } else {
      i44 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i38 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i44 | 0, HEAP32[i38 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 20 | 0) | 0;
      HEAP32[i11 >> 2] = i1;
      HEAP32[i38 >> 2] = i44;
     }
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if (i1 | 0) {
     i3 = i38 + 4 | 0;
     i1 = 0;
     i4 = HEAP32[i12 >> 2] | 0;
     do {
      i6 = HEAP32[i41 >> 2] | 0;
      f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i6 + (i1 << 3) >> 2]) - f34) / f37);
      f8 = Math_fround(Math_fround(Math_fround(HEAPF32[i6 + (i1 << 3) + 4 >> 2]) - f32) / f37);
      i6 = i4;
      i4 = i4 + 1 | 0;
      i7 = HEAP32[i11 >> 2] | 0;
      i9 = i7 & 2147483647;
      do if (i4 >>> 0 > i9 >>> 0) {
       i2 = i7 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i9 >>> 0 >= i2 >>> 0) break;
       if ((i7 | 0) > -1) {
        HEAP32[i11 >> 2] = i2;
        HEAP32[i38 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i38 >> 2] | 0, i2 * 20 | 0, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i44 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 20 | 0, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i44 | 0, HEAP32[i38 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 20 | 0) | 0;
        HEAP32[i11 >> 2] = i2;
        HEAP32[i38 >> 2] = i44;
        break;
       }
      } while (0);
      HEAP32[i12 >> 2] = i4;
      i44 = HEAP32[i38 >> 2] | 0;
      HEAPF32[i44 + (i6 * 20 | 0) >> 2] = f5;
      HEAPF32[i44 + (i6 * 20 | 0) + 4 >> 2] = f8;
      HEAP32[i44 + (i6 * 20 | 0) + 8 >> 2] = 0;
      HEAP32[i44 + (i6 * 20 | 0) + 12 >> 2] = 0;
      HEAP32[i44 + (i6 * 20 | 0) + 16 >> 2] = 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
    }
   }
   if ((HEAP32[i16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i17);
    HEAP32[i42 >> 2] = 0;
   }
   if ((HEAP32[i14 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i15);
    HEAP32[i41 >> 2] = 0;
   }
  }
  if (i39 | 0) if (!(__ZN19SpriteMeshGenerator10FindBoundsER5RectTIfE(i40, i39) | 0)) {
   HEAPF32[i39 >> 2] = Math_fround(0.0);
   HEAPF32[i39 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i39 + 8 >> 2] = f33;
   HEAPF32[i39 + 12 >> 2] = f35;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i40 + 48 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i40 + 20 | 0);
 __ZNSt3__213__vector_baseIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEED2Ev(i40);
 STACKTOP = i43;
 return;
}

function __Z20RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i67, i4, i69) {
 i67 = i67 | 0;
 i4 = i4 | 0;
 i69 = i69 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i68 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0;
 i77 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i66 = i77;
 i70 = i77 + 672 | 0;
 i71 = i77 + 148 | 0;
 i72 = i77 + 144 | 0;
 i73 = i77 + 128 | 0;
 i74 = i77 + 124 | 0;
 i75 = i77 + 80 | 0;
 i76 = i77 + 704 | 0;
 i68 = HEAP32[gb + 1157628 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i67 >> 2] | 0) + ((HEAP32[HEAP32[i4 >> 2] >> 2] | 0) * 360 | 0) + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 188 >> 2] | 0, i68 | 0, i1 | 0);
 i65 = HEAP32[i69 >> 2] | 0;
 i3 = i65 & 124;
 i1 = 4;
 while (1) if (i1 >>> 0 <= i3 >>> 0 & (i1 & i3 | 0) == 0) i1 = i1 << 1; else break;
 if (i1 >>> 0 > i3 >>> 0) i2 = i65; else {
  i2 = i65;
  do {
   i2 = i1 | i2;
   i1 = i1 << 1;
  } while (i1 >>> 0 <= i3 >>> 0);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i63 = HEAP32[i4 + 4 >> 2] | 0;
 i64 = i1 + (i63 << 3) | 0;
 if (!i63) {
  STACKTOP = i77;
  return;
 }
 i51 = i4 + 8 | 0;
 i52 = i2 - (i2 >>> 1 & 1431655765) | 0;
 i52 = (i52 >>> 2 & 858993459) + (i52 & 858993459) | 0;
 i52 = (Math_imul((i52 >>> 4) + i52 & 252645135, 16843009) | 0) >>> 24;
 i53 = i68 + 4512 | 0;
 i54 = i68 + 4448 | 0;
 i55 = i73 + 4 | 0;
 i56 = i73 + 8 | 0;
 i57 = i73 + 12 | 0;
 i58 = i66 + 4 | 0;
 i59 = i66 + 8 | 0;
 i60 = i66 + 12 | 0;
 i61 = i66 + 16 | 0;
 i50 = i66 + 32 | 0;
 i62 = i2 & 124;
 i63 = i62 >>> 0 > 3;
 i3 = i1;
 while (1) {
  i45 = HEAP32[i3 >> 2] | 0;
  i46 = HEAP32[i67 >> 2] | 0;
  i49 = i46 + (i45 * 360 | 0) | 0;
  i4 = HEAP32[i46 + (i45 * 360 | 0) + 328 >> 2] | 0;
  i1 = i46 + (i45 * 360 | 0) + 232 | 0;
  i1 = (HEAPU16[i1 >> 1] | HEAPU8[i1 + 2 >> 0] << 16) & 63;
  if ((i1 & 16777215 | 0) == 1) if (!i4) i48 = 17; else {
   i7 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i48 = 18;
  } else if ((i1 & 16777215) >>> 0 > 8) {
   if (!i4) i1 = 0; else i1 = HEAP32[i4 >> 2] | 0;
   i7 = 0;
   i48 = 18;
  } else i48 = 17;
  do if ((i48 | 0) == 17) {
   i32 = i75;
   i33 = i32 + 44 | 0;
   do {
    HEAP32[i32 >> 2] = 0;
    i32 = i32 + 4 | 0;
   } while ((i32 | 0) < (i33 | 0));
   i48 = 20;
  } else if ((i48 | 0) == 18) {
   i48 = 0;
   i32 = i75;
   i33 = i32 + 44 | 0;
   do {
    HEAP32[i32 >> 2] = 0;
    i32 = i32 + 4 | 0;
   } while ((i32 | 0) < (i33 | 0));
   i6 = i1;
   if (!i1) i48 = 20; else if (__ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i4, i65, i75, 0, 0) | 0) {
    i11 = i6 + 128 | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i47 = (((HEAP32[i6 + 132 >> 2] | 0) - i1 | 0) / 52 | 0) + -1 | 0;
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    i4 = (i47 | 0) < (i4 | 0) ? i47 : i4;
    i47 = HEAP32[i1 + (i4 * 52 | 0) + 40 >> 2] | 0;
    i5 = HEAP32[i1 + (i4 * 52 | 0) + 48 >> 2] | 0;
    i14 = (i47 | 0) == 1;
    i4 = (HEAP32[i1 + (i4 * 52 | 0) + 36 >> 2] | 0) + (i14 & 1) | 0;
    i1 = i3 + 8 | 0;
    if (HEAP16[i46 + (i45 * 360 | 0) + 182 >> 1] | 0) {
     i10 = HEAP32[i46 + (i45 * 360 | 0) + 248 >> 2] | 0;
     i9 = HEAP32[i6 + 96 >> 2] | 0;
     L31 : do if ((i1 | 0) == (i64 | 0)) i1 = i64; else L33 : do if (i14) {
      i8 = i4;
      while (1) {
       i4 = HEAP32[i1 >> 2] | 0;
       i5 = HEAP32[i67 >> 2] | 0;
       if ((i10 | 0) != (HEAP32[i5 + (i4 * 360 | 0) + 248 >> 2] | 0)) break L31;
       i5 = HEAP32[i5 + (i4 * 360 | 0) + 328 >> 2] | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       if (!i6) break L31;
       i7 = HEAP32[i6 + 128 >> 2] | 0;
       i47 = (((HEAP32[i6 + 132 >> 2] | 0) - i7 | 0) / 52 | 0) + -1 | 0;
       i4 = HEAP32[i1 + 4 >> 2] | 0;
       i4 = (i47 | 0) < (i4 | 0) ? i47 : i4;
       if ((HEAP32[i7 + (i4 * 52 | 0) + 40 >> 2] | 0) != 1) break L31;
       i32 = i66;
       i33 = i32 + 44 | 0;
       do {
        HEAP32[i32 >> 2] = 0;
        i32 = i32 + 4 | 0;
       } while ((i32 | 0) < (i33 | 0));
       __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i5, i65, i66, 0, 0) | 0;
       if ((HEAP32[i66 >> 2] | 0) != (HEAP32[i75 >> 2] | 0)) break L33;
       if ((HEAP32[i6 + 96 >> 2] ^ i9) & i65 | 0) break L33;
       i8 = (HEAP32[i7 + (i4 * 52 | 0) + 36 >> 2] | 0) + i8 + 3 | 0;
       if (i8 >>> 0 > 64e3) break L33;
       i1 = i1 + 8 | 0;
       if ((i1 | 0) == (i64 | 0)) {
        i1 = i64;
        break L31;
       }
      }
     } else while (1) {
      i5 = HEAP32[i1 >> 2] | 0;
      i6 = HEAP32[i67 >> 2] | 0;
      if ((i10 | 0) != (HEAP32[i6 + (i5 * 360 | 0) + 248 >> 2] | 0)) break L31;
      i6 = HEAP32[i6 + (i5 * 360 | 0) + 328 >> 2] | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      if (!i7) break L31;
      i8 = HEAP32[i7 + 128 >> 2] | 0;
      i46 = (((HEAP32[i7 + 132 >> 2] | 0) - i8 | 0) / 52 | 0) + -1 | 0;
      i5 = HEAP32[i1 + 4 >> 2] | 0;
      i5 = (i46 | 0) < (i5 | 0) ? i46 : i5;
      if ((HEAP32[i8 + (i5 * 52 | 0) + 40 >> 2] | 0) != (i47 | 0)) break L31;
      i32 = i66;
      i33 = i32 + 44 | 0;
      do {
       HEAP32[i32 >> 2] = 0;
       i32 = i32 + 4 | 0;
      } while ((i32 | 0) < (i33 | 0));
      __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i6, i65, i66, 0, 0) | 0;
      if ((HEAP32[i66 >> 2] | 0) != (HEAP32[i75 >> 2] | 0)) break L33;
      if ((HEAP32[i7 + 96 >> 2] ^ i9) & i65 | 0) break L33;
      i4 = (HEAP32[i8 + (i5 * 52 | 0) + 36 >> 2] | 0) + i4 | 0;
      if (i4 >>> 0 > 64e3) break L33;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i64 | 0)) {
       i1 = i64;
       break L31;
      }
     } while (0); while (0);
     i4 = i1 - i3 >> 3;
     i32 = i66;
     i27 = i49;
     i33 = i32 + 64 | 0;
     do {
      HEAP32[i32 >> 2] = HEAP32[i27 >> 2];
      i32 = i32 + 4 | 0;
      i27 = i27 + 4 | 0;
     } while ((i32 | 0) < (i33 | 0));
     __Z17RenderStaticBatchR9GfxDevice10Matrix4x4fRNSt3__26vectorI7SubMesh13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEEERK11MeshBuffersPK17BatchInstanceDatajRK14ChannelAssigns(i68, i66, i11, i75, i3, i4, i69);
     break;
    }
    if (HEAP32[i75 >> 2] | 0) if ((i7 | 0) == 0 & ((i47 | 0) != 4 & (i4 >>> 0 < 32e3 & (HEAP8[i51 >> 0] | 0) != 0))) if (!(HEAP32[i46 + (i45 * 360 | 0) + 176 >> 2] & 4)) if (!(((i5 | 0) > 300 ? 1 : (HEAP32[i6 + 112 >> 2] | 0) == (HEAP32[i6 + 116 >> 2] | 0)) | (Math_imul(i5, i52) | 0) > 900)) if (HEAP8[i6 + 108 >> 0] | 0) {
     i44 = HEAP32[i6 + 96 >> 2] & i2;
     __ZNK14VertexDataInfo17GetChannelsLayoutEv(i76, i6 + 8 | 0);
     L59 : do if ((i1 | 0) == (i64 | 0)) {
      i6 = 1;
      i1 = i64;
     } else {
      i13 = i5;
      i6 = 1;
      L60 : while (1) {
       i5 = HEAP32[i1 >> 2] | 0;
       i7 = HEAP32[i67 >> 2] | 0;
       if (HEAP16[i7 + (i5 * 360 | 0) + 182 >> 1] | 0) {
        i5 = i13;
        break L59;
       }
       i9 = HEAP32[i7 + (i5 * 360 | 0) + 328 >> 2] | 0;
       if (HEAP32[i7 + (i5 * 360 | 0) + 176 >> 2] & 4 | 0) {
        i5 = i13;
        break L59;
       }
       i5 = i7 + (i5 * 360 | 0) + 232 | 0;
       i5 = (HEAPU16[i5 >> 1] | HEAPU8[i5 + 2 >> 0] << 16) & 63;
       if ((i5 & 16777215 | 0) == 1) {
        if (!i9) {
         i5 = i13;
         break L59;
        }
        i7 = HEAP32[i9 + 4 >> 2] | 0;
        i5 = HEAP32[i9 >> 2] | 0;
       } else {
        if ((i5 & 16777215) >>> 0 <= 8) {
         i5 = i13;
         break L59;
        }
        if (!i9) i5 = 0; else i5 = HEAP32[i9 >> 2] | 0;
        i7 = 0;
       }
       i12 = i5;
       if (!((i5 | 0) != 0 & (i7 | 0) == 0)) {
        i5 = i13;
        break L59;
       }
       i8 = HEAP32[i12 + 128 >> 2] | 0;
       i43 = (((HEAP32[i12 + 132 >> 2] | 0) - i8 | 0) / 52 | 0) + -1 | 0;
       i7 = HEAP32[i3 + (i6 << 3) + 4 >> 2] | 0;
       i7 = (i43 | 0) < (i7 | 0) ? i43 : i7;
       if ((HEAP32[i8 + (i7 * 52 | 0) + 40 >> 2] | 0) != (i47 | 0)) {
        i5 = i13;
        break L59;
       }
       i5 = HEAP32[i8 + (i7 * 52 | 0) + 48 >> 2] | 0;
       if (((i5 | 0) > 300 ? 1 : (HEAP32[i12 + 112 >> 2] | 0) == (HEAP32[i12 + 116 >> 2] | 0)) | (Math_imul(i5, i52) | 0) > 900) {
        i5 = i13;
        break L59;
       }
       if (!(HEAP8[i12 + 108 >> 0] | 0)) {
        i5 = i13;
        break L59;
       }
       i5 = i5 + i13 | 0;
       i11 = (HEAP32[i8 + (i7 * 52 | 0) + 36 >> 2] | 0) + i4 | 0;
       i11 = i14 ? i11 + 3 | 0 : i11;
       if (i5 >>> 0 > 65535 | i11 >>> 0 > 32e3) {
        i5 = i13;
        break L59;
       }
       i32 = i66;
       i33 = i32 + 44 | 0;
       do {
        HEAP32[i32 >> 2] = 0;
        i32 = i32 + 4 | 0;
       } while ((i32 | 0) < (i33 | 0));
       __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i9, i65, i66, 0, 0) | 0;
       if (!(HEAP32[i66 >> 2] | 0)) break;
       i9 = i12 + 8 | 0;
       if (i63) {
        i7 = 2;
        i8 = 4;
        do {
         if (i8 & i62 | 0) {
          i10 = HEAP16[i9 + (i7 << 2) + 2 >> 1] | 0;
          if ((i10 & 255) << 24 >> 24 != (HEAP8[i76 + (i7 << 1) >> 0] | 0)) break L60;
          if (((i10 & 65535) >>> 8 & 255) << 24 >> 24 != (HEAP8[i76 + (i7 << 1) + 1 >> 0] | 0)) break L60;
         }
         i7 = i7 + 1 | 0;
         i8 = i8 << 1;
        } while (i8 >>> 0 <= i62 >>> 0 & (i7 | 0) < 8);
       }
       if ((i44 | 0) != (HEAP32[i12 + 96 >> 2] & i2 | 0)) break;
       i4 = i6 + 1 | 0;
       i1 = i3 + (i4 << 3) | 0;
       if ((i1 | 0) == (i64 | 0)) {
        i6 = i4;
        i1 = i64;
        i4 = i11;
        break L59;
       } else {
        i13 = i5;
        i6 = i4;
        i4 = i11;
       }
      }
      i5 = i13;
     } while (0);
     if ((i4 | 0) == 0 | (i5 | 0) == 0) i3 = i1; else if ((i6 | 0) > 1) {
      i43 = i6 << 3 >> 3;
      if ((HEAP16[gb + 1157696 + 6 >> 1] | 0) > -1) {
       HEAP32[i70 >> 2] = 0;
       HEAP32[i66 >> 2] = HEAP32[i70 >> 2];
       __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157696 | 0, i66);
       i42 = gb + 1157696 | 0;
      } else i42 = 0;
      mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 696 >> 2] | 0, i68 | 0, 2);
      i5 = HEAP32[i69 >> 2] | 0;
      i4 = HEAP32[i53 >> 2] | 0;
      if (!i4) {
       if (!(HEAP32[i53 >> 2] | 0)) HEAP32[i53 >> 2] = mftCall_ii(HEAP32[(HEAP32[i68 >> 2] | 0) + 896 >> 2] | 0, i68 | 0) | 0;
       i4 = HEAP32[i53 >> 2] | 0;
      }
      i36 = i5 & ~i44 & HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2];
      i35 = i36 >>> 1 & 7 | i36 >>> 4 & 8;
      HEAP32[i70 >> 2] = 0;
      HEAP32[i70 + 4 >> 2] = 0;
      HEAP32[i70 + 8 >> 2] = 0;
      HEAP32[i70 + 12 >> 2] = 0;
      HEAP32[i70 + 16 >> 2] = 0;
      HEAP32[i70 + 20 >> 2] = 0;
      HEAP32[i70 + 24 >> 2] = 0;
      HEAP32[i70 + 28 >> 2] = 0;
      i36 = __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutjS1_P11ChannelInfo(i44, i76, i36, gb + 1546313 | 0, i70) | 0;
      i37 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i70) | 0;
      i37 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i37, HEAP32[i69 >> 2] | 0, 0) | 0;
      i38 = __Z22GetJobQueueThreadCountv() | 0;
      i38 = 32e3 / (((i38 | 0) == 0 ? 1 : i38) >>> 0) | 0;
      i38 = i38 >>> 0 < 4e3 ? 4e3 : i38;
      i39 = (i47 | 0) == 2;
      i40 = i39 ? 0 : i47;
      i41 = (HEAP32[i67 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 360 | 0) + 188 | 0;
      i34 = i5 & 2;
      i5 = 0;
      do {
       i31 = i43 - i5 | 0;
       i31 = i31 >>> 0 > 88 ? 88 : i31;
       __ZN14BatchAllocatorC2Ev(i71);
       HEAP32[i72 >> 2] = 0;
       __ZN14BatchAllocator16AllocateInternalEPPvijjj(i71, i72, -1, 24, 1, 4);
       HEAP32[i72 >> 2] = 0;
       __ZN14BatchAllocator16AllocateInternalEPPvijjj(i71, 0, 0, 20, i31, 4);
       __ZN14BatchAllocator16AllocateInternalEPPvijjj(i71, (HEAP32[i72 >> 2] | 0) + 4 | 0, 0, 11284, i31, 4);
       __ZN14BatchAllocator6CommitERK10MemLabelId(i71, gb + 64024 | 0);
       i33 = HEAP32[i72 >> 2] | 0;
       __ZN17UniqueIDGenerator8CreateIDEv(i66, i54);
       HEAP32[i33 + 8 >> 2] = HEAP32[i66 >> 2];
       do if (i43 >>> 0 > i5 >>> 0 & (i31 | 0) != 0) {
        i9 = 0;
        i12 = 0;
        i30 = 0;
        i7 = 0;
        i29 = 0;
        i6 = 0;
        i10 = 0;
        i8 = 0;
        L105 : while (1) {
         i23 = HEAP32[i3 >> 2] | 0;
         i24 = HEAP32[i67 >> 2] | 0;
         i25 = i24 + (i23 * 360 | 0) | 0;
         i13 = HEAP32[i24 + (i23 * 360 | 0) + 328 >> 2] | 0;
         i11 = i24 + (i23 * 360 | 0) + 232 | 0;
         i11 = (HEAPU16[i11 >> 1] | HEAPU8[i11 + 2 >> 0] << 16) & 63;
         do if ((i11 & 16777215 | 0) == 1) {
          if (!i13) {
           i11 = i30;
           i13 = i29;
           break;
          }
          i11 = HEAP32[i13 >> 2] | 0;
          i48 = 86;
         } else {
          if ((i11 & 16777215) >>> 0 <= 8) {
           i11 = i30;
           i13 = i29;
           break;
          }
          if (!i13) i11 = 0; else i11 = HEAP32[i13 >> 2] | 0;
          i48 = 86;
         } while (0);
         do if ((i48 | 0) == 86) {
          i48 = 0;
          i14 = i11;
          if (!i11) {
           i11 = i30;
           i13 = i29;
           break;
          }
          i22 = HEAP32[i14 + 128 >> 2] | 0;
          i32 = (((HEAP32[i14 + 132 >> 2] | 0) - i22 | 0) / 52 | 0) + -1 | 0;
          i21 = HEAP32[i3 + 4 >> 2] | 0;
          i21 = (i32 | 0) < (i21 | 0) ? i32 : i21;
          i32 = i66;
          i33 = i32 + 80 | 0;
          do {
           HEAP32[i32 >> 2] = 0;
           i32 = i32 + 4 | 0;
          } while ((i32 | 0) < (i33 | 0));
          i18 = HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0;
          i32 = i14 + 8 | 0;
          HEAP32[i66 >> 2] = HEAP32[i32 >> 2];
          HEAP32[i66 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
          HEAP32[i66 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
          HEAP32[i66 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
          HEAP32[i66 + 16 >> 2] = HEAP32[i32 + 16 >> 2];
          HEAP32[i66 + 20 >> 2] = HEAP32[i32 + 20 >> 2];
          HEAP32[i66 + 24 >> 2] = HEAP32[i32 + 24 >> 2];
          HEAP32[i66 + 28 >> 2] = HEAP32[i32 + 28 >> 2];
          i32 = i50;
          i27 = i14 + 40 | 0;
          i33 = i32 + 48 | 0;
          do {
           HEAP32[i32 >> 2] = HEAP32[i27 >> 2];
           i32 = i32 + 4 | 0;
           i27 = i27 + 4 | 0;
          } while ((i32 | 0) < (i33 | 0));
          i19 = HEAP32[i14 + 92 >> 2] | 0;
          i20 = HEAP32[i14 + 104 >> 2] | 0;
          i15 = HEAP32[i22 + (i21 * 52 | 0) + 32 >> 2] | 0;
          i16 = HEAP32[i14 + 112 >> 2] | 0;
          i26 = (HEAP32[i14 + 116 >> 2] | 0) - i16 | 0;
          i15 = (i26 | 0) != 0 & i26 >>> 0 > i15 >>> 0 ? i16 + i15 | 0 : 0;
          i16 = i22 + (i21 * 52 | 0) + 48 | 0;
          i26 = HEAP32[i16 >> 2] | 0;
          i17 = i22 + (i21 * 52 | 0) + 36 | 0;
          i28 = HEAP32[i17 >> 2] | 0;
          i28 = i39 ? (i28 >>> 2) * 6 | 0 : i28;
          if (!i9) {
           i9 = HEAP32[(HEAP32[i72 >> 2] | 0) + 4 >> 2] | 0;
           HEAP32[i9 + (i6 * 11284 | 0) + 11268 >> 2] = i30;
           HEAP32[i9 + (i6 * 11284 | 0) + 11276 >> 2] = 0;
           i9 = i9 + (i6 * 11284 | 0) | 0;
           i13 = i29 + 1 | 0;
           i10 = 0;
           i8 = 0;
          } else if ((i28 + i7 | 0) >>> 0 > 31999) {
           i48 = 95;
           break L105;
          } else i13 = i29;
          i14 = i9 + 11276 | 0;
          HEAP32[i9 + (HEAP32[i14 >> 2] << 2) >> 2] = i35;
          if (i34 & HEAP32[i24 + (i23 * 360 | 0) + 176 >> 2] | 0) {
           i33 = i9 + (HEAP32[i14 >> 2] << 2) | 0;
           HEAP32[i33 >> 2] = HEAP32[i33 >> 2] | 16;
          }
          i11 = i9 + 4352 + ((HEAP32[i14 >> 2] | 0) * 92 | 0) | 0;
          i32 = i11;
          i27 = i66;
          i33 = i32 + 80 | 0;
          do {
           HEAP32[i32 >> 2] = HEAP32[i27 >> 2];
           i32 = i32 + 4 | 0;
           i27 = i27 + 4 | 0;
          } while ((i32 | 0) < (i33 | 0));
          HEAP32[i11 + 80 >> 2] = i19;
          HEAP32[i11 + 84 >> 2] = i20;
          HEAP32[i11 + 88 >> 2] = i18;
          i32 = i9 + 256 + (HEAP32[i14 >> 2] << 6) | 0;
          i27 = i25;
          i33 = i32 + 64 | 0;
          do {
           HEAP32[i32 >> 2] = HEAP32[i27 >> 2];
           i32 = i32 + 4 | 0;
           i27 = i27 + 4 | 0;
          } while ((i32 | 0) < (i33 | 0));
          HEAP32[i9 + 10752 + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i22 + (i21 * 52 | 0) + 44 >> 2];
          HEAP32[i9 + 11008 + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i16 >> 2];
          HEAP32[i9 + 10240 + (HEAP32[i14 >> 2] << 2) >> 2] = i15;
          HEAP32[i9 + 10496 + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i17 >> 2];
          HEAP32[i9 + 11272 >> 2] = i44;
          HEAP32[i9 + 11280 >> 2] = i36;
          HEAP32[i9 + 11264 >> 2] = i47;
          i33 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
          HEAP32[i14 >> 2] = i33;
          i8 = i8 + i26 | 0;
          i10 = i10 + i28 | 0;
          if (!(i10 >>> 0 < i38 >>> 0 & (i33 | 0) != 64)) {
           i9 = HEAP32[HEAP32[i72 >> 2] >> 2] | 0;
           HEAP32[i9 + (i6 * 20 | 0) + 8 >> 2] = i8;
           HEAP32[i9 + (i6 * 20 | 0) + 12 >> 2] = i10;
           HEAP32[i9 + (i6 * 20 | 0) + 16 >> 2] = i36;
           i6 = i6 + 1 | 0;
           i9 = 0;
          }
          i12 = i12 + 1 | 0;
          i11 = i26 + i30 | 0;
          i7 = i28 + i7 | 0;
         } while (0);
         i5 = i5 + 1 | 0;
         i3 = i3 + 8 | 0;
         if (i5 >>> 0 < i43 >>> 0 & i13 >>> 0 < i31 >>> 0) {
          i30 = i11;
          i29 = i13;
         } else {
          i48 = 97;
          break;
         }
        }
        if ((i48 | 0) == 95) {
         i11 = i30;
         i48 = 98;
        } else if ((i48 | 0) == 97) {
         i48 = 0;
         if (!i9) {
          i9 = i12;
          i8 = i11;
         } else i48 = 98;
        }
        do if ((i48 | 0) == 98) {
         i48 = 0;
         if (!(HEAP32[i9 + 11276 >> 2] | 0)) {
          i9 = i12;
          i8 = i11;
          break;
         }
         i9 = HEAP32[HEAP32[i72 >> 2] >> 2] | 0;
         HEAP32[i9 + (i6 * 20 | 0) + 8 >> 2] = i8;
         HEAP32[i9 + (i6 * 20 | 0) + 12 >> 2] = i10;
         HEAP32[i9 + (i6 * 20 | 0) + 16 >> 2] = i36;
         i9 = i12;
         i8 = i11;
         i6 = i6 + 1 | 0;
        } while (0);
        if (!i6) {
         i48 = 104;
         break;
        }
        HEAP32[i73 >> 2] = 0;
        HEAP32[i55 >> 2] = 0;
        HEAP32[i56 >> 2] = -1;
        HEAP32[i57 >> 2] = 0;
        i32 = HEAP32[i72 >> 2] | 0;
        i33 = HEAP32[i32 + 8 >> 2] | 0;
        mftCall_viiiiiii(HEAP32[(HEAP32[i68 >> 2] | 0) + 252 >> 2] | 0, i68 | 0, fb + 2396 | 0, fb + 3356 | 0, i32 | 0, i6 | 0, i40 | 0, i73 | 0);
        HEAP32[i72 >> 2] = 0;
        i6 = HEAP32[(HEAP32[i68 >> 2] | 0) + 256 >> 2] | 0;
        HEAP32[i74 >> 2] = i33;
        HEAP32[i66 >> 2] = HEAP32[i74 >> 2];
        mftCall_vii(i6 | 0, i68 | 0, i66 | 0);
        i6 = HEAP32[i41 >> 2] | 0;
        if (i6 | 0) mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 188 >> 2] | 0, i68 | 0, i6 | 0);
        mftCall_viii(HEAP32[(HEAP32[i68 >> 2] | 0) + 104 >> 2] | 0, i68 | 0, gb + 1162292 | 0, 0);
        HEAP32[i66 >> 2] = i36;
        HEAP32[i58 >> 2] = 0;
        HEAP32[i59 >> 2] = i8;
        HEAP32[i60 >> 2] = 0;
        HEAP32[i61 >> 2] = i7;
        mftCall_viiiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, i73 | 0, i69 | 0, i44 | 0, i37 | 0, i66 | 0, 1);
        mftCall_viiiiiii(HEAP32[(HEAP32[i68 >> 2] | 0) + 268 >> 2] | 0, i68 | 0, 1, (i7 >>> 0) / 3 | 0 | 0, i8 | 0, i9 | 0, 0, 0);
       } else i48 = 104; while (0);
       if ((i48 | 0) == 104) {
        i48 = 0;
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i72 >> 2] | 0, gb + 64024 | 0);
        HEAP32[i72 >> 2] = 0;
       }
      } while (i5 >>> 0 < i43 >>> 0);
      mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 696 >> 2] | 0, i68 | 0, 0);
      if (i42 | 0) __Z12profiler_endP19ProfilerInformation(i42);
      i3 = i1;
     }
     if ((i1 | 0) == (i3 | 0)) break;
    }
    __Z17SetupObjectMatrixRK10Matrix4x4fi(i49, HEAP32[i46 + (i45 * 360 | 0) + 176 >> 2] | 0);
    mftCall_viiii(HEAP32[i46 + (i45 * 360 | 0) + 332 >> 2] | 0, i67 | 0, HEAP32[i3 >> 2] | 0, i69 | 0, HEAP32[i3 + 4 >> 2] | 0);
   } else i48 = 20;
  } while (0);
  if ((i48 | 0) == 20) i1 = i3 + 8 | 0;
  if ((i1 | 0) == (i64 | 0)) break; else i3 = i1;
 }
 STACKTOP = i77;
 return;
}

function __ZN11ShapeModule17DidModifyMeshDataEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, i50 = 0, i51 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i47;
 i35 = i47 + 52 | 0;
 i45 = i47 + 28 | 0;
 i37 = i47 + 24 | 0;
 i38 = i47 + 72 | 0;
 i39 = i47 + 8 | 0;
 i40 = i47 + 48 | 0;
 i41 = i47 + 44 | 0;
 i42 = i47 + 40 | 0;
 i43 = i9 + 72 | 0;
 i1 = HEAP32[i43 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 + 116 >> 2] = 0;
  HEAPF32[i9 + 68 >> 2] = Math_fround(0.0);
  STACKTOP = i47;
  return;
 }
 i34 = __ZNK4Mesh15GetSubMeshCountEv(i1) | 0;
 HEAP32[i45 >> 2] = 0;
 i36 = i45 + 4 | 0;
 i32 = gb + 63160 | 0;
 i33 = HEAP32[i32 + 4 >> 2] | 0;
 i1 = i36;
 HEAP32[i1 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i1 + 4 >> 2] = i33;
 i1 = i34 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 621269 | 0, 846) | 0;
   i32 = gb + 64016 | 0;
   i31 = HEAP32[i32 >> 2] | 0;
   i32 = HEAP32[i32 + 4 >> 2] | 0;
   HEAP32[i45 >> 2] = i1;
   i33 = i36;
   HEAP32[i33 >> 2] = i31;
   HEAP32[i33 + 4 >> 2] = i32;
   break;
  }
 } while (0);
 i33 = i1 + 3 & -4;
 i7 = (i34 | 0) > 0;
 L11 : do if (i7) {
  i5 = i9 + 213 | 0;
  i6 = i9 + 56 | 0;
  i1 = 0;
  i4 = 0;
  L13 : while (1) {
   if (!(HEAP8[i5 >> 0] | 0)) i46 = 11; else if ((i4 | 0) == (HEAP32[i6 >> 2] | 0)) i46 = 11;
   if ((i46 | 0) == 11) {
    i46 = 0;
    i2 = __ZN4Mesh18GetSubMeshBuffer16Ei(HEAP32[i43 >> 2] | 0, i4) | 0;
    if (!i2) break;
    i3 = HEAP32[(HEAP32[(HEAP32[i43 >> 2] | 0) + 32 >> 2] | 0) + 128 >> 2] | 0;
    switch (HEAP32[i3 + (i4 * 52 | 0) + 40 >> 2] | 0) {
    case 1:
     {
      i2 = __Z21CountTrianglesInStripItEiPKT_i(i2, HEAP32[i3 + (i4 * 52 | 0) + 36 >> 2] | 0) | 0;
      HEAP32[i33 + (i4 << 2) >> 2] = i2;
      break;
     }
    case 0:
     {
      i2 = ((HEAP32[i3 + (i4 * 52 | 0) + 36 >> 2] | 0) >>> 0) / 3 | 0;
      HEAP32[i33 + (i4 << 2) >> 2] = i2;
      break;
     }
    default:
     break L13;
    }
    i1 = i2 + i1 | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i34 | 0)) {
    i2 = i1;
    i46 = 18;
    break L11;
   }
  }
  HEAP32[i43 >> 2] = 0;
  i46 = 19;
 } else {
  i2 = 0;
  i46 = 18;
 } while (0);
 if ((i46 | 0) == 18) {
  i1 = i9 + 104 | 0;
  if (!(HEAP32[i43 >> 2] | 0)) i46 = 19; else {
   i32 = i9 + 116 | 0;
   HEAP32[i32 >> 2] = i2;
   i3 = i9 + 120 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 4, 4, i9 + 108 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i9 + 108 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i31 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i32 >> 2] << 4 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = i31;
    break;
   } while (0);
   i31 = i9 + 68 | 0;
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   i3 = HEAP32[(HEAP32[i43 >> 2] | 0) + 32 >> 2] | 0;
   i4 = i3 + 8 | 0;
   i30 = HEAP16[i3 + 10 >> 1] | 0;
   if ((i30 & 65535) < 768 | (i30 & 255) != 0) {
    i30 = 0;
    i29 = 0;
   } else {
    i2 = HEAP32[i3 + 92 >> 2] | 0;
    if (!i2) {
     i30 = 0;
     i29 = 1;
    } else if (!(HEAP8[i3 + 11 >> 0] | 0)) {
     i30 = 0;
     i29 = 1;
    } else {
     i30 = HEAP16[i4 >> 1] | 0;
     i30 = i2 + (((i30 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i30 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i29 = HEAPU8[i4 + 32 + ((HEAPU8[i4 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   if (i7) {
    i15 = i9 + 213 | 0;
    i16 = i9 + 214 | 0;
    i17 = i35 + 12 | 0;
    i18 = i35 + 16 | 0;
    i19 = i35 + 4 | 0;
    i20 = i9 + 8 | 0;
    i21 = i9 + 48 | 0;
    i22 = i39 + 4 | 0;
    i23 = i39 + 8 | 0;
    i24 = i39 + 12 | 0;
    i25 = i39 + 4 | 0;
    i26 = i39 + 8 | 0;
    i27 = i39 + 12 | 0;
    i28 = i9 + 52 | 0;
    i14 = i9 + 56 | 0;
    i13 = 0;
    i2 = 0;
    do {
     if (!(HEAP8[i15 >> 0] | 0)) i46 = 34; else if ((i13 | 0) == (HEAP32[i14 >> 2] | 0)) i46 = 34;
     L46 : do if ((i46 | 0) == 34) {
      i46 = 0;
      L48 : do if (!(HEAP8[i16 >> 0] | 0)) {
       i12 = -1;
       i4 = -1;
       i5 = -1;
       i6 = -1;
      } else {
       L50 : do switch (HEAP32[i20 >> 2] | 0) {
       case 13:
        {
         HEAP32[i35 >> 2] = HEAP32[i21 >> 2];
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         if (!i3) i46 = 41; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i46 = 41; else {
           i3 = HEAP32[i3 + 4 >> 2] | 0;
           if (!i3) i46 = 43;
          }
         }
         if ((i46 | 0) == 41) i46 = 43;
         if ((i46 | 0) == 43) {
          i46 = 0;
          i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i21 >> 2] | 0) | 0;
         }
         if ((i13 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0)) {
          i12 = -1;
          i4 = -1;
          i5 = -1;
          i6 = -1;
          break L48;
         }
         HEAP32[i35 >> 2] = HEAP32[i21 >> 2];
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i3) i46 = 50; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) {
           i46 = 50;
           break;
          }
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (!i3) i46 = 52;
         } while (0);
         if ((i46 | 0) == 50) i46 = 52;
         if ((i46 | 0) == 52) {
          i46 = 0;
          i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i21 >> 2] | 0) | 0;
         }
         i6 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, i13 | 0) | 0;
         if (!i6) {
          i12 = -1;
          i4 = -1;
          i5 = -1;
          i6 = -1;
          break L48;
         }
         HEAP32[i35 >> 2] = i6;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i3) i46 = 59; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) {
           i46 = 59;
           break;
          }
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (i3 | 0) break L50;
         } while (0);
         i3 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
         i46 = 88;
         break;
        }
       case 14:
        {
         HEAP32[i35 >> 2] = HEAP32[i28 >> 2];
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         if (!i3) i46 = 67; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i46 = 67; else {
           i3 = HEAP32[i3 + 4 >> 2] | 0;
           if (!i3) i46 = 69;
          }
         }
         if ((i46 | 0) == 67) i46 = 69;
         if ((i46 | 0) == 69) {
          i46 = 0;
          i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
         }
         if ((i13 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0)) {
          i12 = -1;
          i4 = -1;
          i5 = -1;
          i6 = -1;
          break L48;
         }
         HEAP32[i35 >> 2] = HEAP32[i28 >> 2];
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i3) i46 = 76; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) {
           i46 = 76;
           break;
          }
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (!i3) i46 = 78;
         } while (0);
         if ((i46 | 0) == 76) i46 = 78;
         if ((i46 | 0) == 78) {
          i46 = 0;
          i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i28 >> 2] | 0) | 0;
         }
         i6 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, i13 | 0) | 0;
         if (!i6) {
          i12 = -1;
          i4 = -1;
          i5 = -1;
          i6 = -1;
          break L48;
         }
         HEAP32[i35 >> 2] = i6;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i3) i46 = 85; else {
          if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
           i4 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[i3 + 32 >> 2] | 0;
           i3 = i4 + (i5 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i44, i3, i35);
           i4 = HEAP32[i44 >> 2] | 0;
           i12 = HEAP32[i3 + 28 >> 2] | 0;
           i5 = HEAP32[gb + 1104264 >> 2] | 0;
           i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
           i4 = HEAP32[i5 + 28 >> 2] | 0;
           i5 = HEAP32[i5 + 32 >> 2] | 0;
          }
          if ((i3 | 0) == (i4 + (i5 << 3) | 0)) {
           i46 = 85;
           break;
          }
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (i3 | 0) break L50;
         } while (0);
         i3 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
         i46 = 88;
         break;
        }
       default:
        {
         i12 = -1;
         i4 = -1;
         i5 = -1;
         i6 = -1;
         break L48;
        }
       } while (0);
       if ((i46 | 0) == 88) {
        i46 = 0;
        if (!i3) {
         i12 = -1;
         i4 = -1;
         i5 = -1;
         i6 = -1;
         break;
        }
       }
       HEAP32[i35 >> 2] = -1;
       __ZN9ShaderLab16FastPropertyName4InitEPKc(i35, gb + 1017536 | 0);
       HEAP32[i37 >> 2] = -1;
       __ZN9ShaderLab16FastPropertyName4InitEPKc(i37, gb + 621356 | 0);
       HEAP32[i38 >> 2] = HEAP32[i35 >> 2];
       HEAP32[i44 >> 2] = HEAP32[i38 >> 2];
       if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i3, i44) | 0) {
        HEAP32[i40 >> 2] = HEAP32[i35 >> 2];
        HEAP32[i44 >> 2] = HEAP32[i40 >> 2];
        __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i39, i3, i44);
        f8 = Math_fround(HEAPF32[i39 >> 2]);
        i3 = f8 < Math_fround(0.0);
        f8 = i3 ? Math_fround(0.0) : f8;
        i3 = f8 > Math_fround(1.0);
        i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
        f8 = Math_fround(HEAPF32[i22 >> 2]);
        i5 = f8 < Math_fround(0.0);
        f8 = i5 ? Math_fround(0.0) : f8;
        i5 = f8 > Math_fround(1.0);
        i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
        f8 = Math_fround(HEAPF32[i23 >> 2]);
        i6 = f8 < Math_fround(0.0);
        f8 = i6 ? Math_fround(0.0) : f8;
        i6 = f8 > Math_fround(1.0);
        i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
        f8 = Math_fround(HEAPF32[i24 >> 2]);
        i4 = f8 < Math_fround(0.0);
        f8 = i4 ? Math_fround(0.0) : f8;
        i4 = f8 > Math_fround(1.0);
        i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
       } else {
        HEAP32[i41 >> 2] = HEAP32[i37 >> 2];
        HEAP32[i44 >> 2] = HEAP32[i41 >> 2];
        if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i3, i44) | 0) {
         HEAP32[i42 >> 2] = HEAP32[i37 >> 2];
         HEAP32[i44 >> 2] = HEAP32[i42 >> 2];
         __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i39, i3, i44);
         f8 = Math_fround(HEAPF32[i39 >> 2]);
         i3 = f8 < Math_fround(0.0);
         f8 = i3 ? Math_fround(0.0) : f8;
         i3 = f8 > Math_fround(1.0);
         i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f8 = Math_fround(HEAPF32[i25 >> 2]);
         i5 = f8 < Math_fround(0.0);
         f8 = i5 ? Math_fround(0.0) : f8;
         i5 = f8 > Math_fround(1.0);
         i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f8 = Math_fround(HEAPF32[i26 >> 2]);
         i6 = f8 < Math_fround(0.0);
         f8 = i6 ? Math_fround(0.0) : f8;
         i6 = f8 > Math_fround(1.0);
         i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f8 = Math_fround(HEAPF32[i27 >> 2]);
         i4 = f8 < Math_fround(0.0);
         f8 = i4 ? Math_fround(0.0) : f8;
         i4 = f8 > Math_fround(1.0);
         i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
        } else {
         i3 = -1;
         i4 = -1;
         i5 = -1;
         i6 = -1;
        }
       }
       i12 = i3;
      } while (0);
      i10 = HEAP32[i43 >> 2] | 0;
      i3 = HEAP32[(HEAP32[i10 + 32 >> 2] | 0) + 128 >> 2] | 0;
      i10 = __ZN4Mesh18GetSubMeshBuffer16Ei(i10, i13) | 0;
      switch (HEAP32[i3 + (i13 * 52 | 0) + 40 >> 2] | 0) {
      case 1:
       break;
      case 0:
       {
        i7 = (HEAP32[i1 >> 2] | 0) + (i2 << 4) | 0;
        i9 = i33 + (i13 << 2) | 0;
        i3 = HEAP32[i9 >> 2] | 0;
        i5 = i12 & 255 | (i5 & 255) << 8 | (i6 & 255) << 16 | (i4 & 255) << 24;
        if ((i3 | 0) > 0) {
         i4 = 0;
         f8 = Math_fround(0.0);
         do {
          i12 = i4 * 3 | 0;
          i6 = HEAP16[i10 + (i12 << 1) >> 1] | 0;
          i11 = HEAP16[i10 + (i12 + 1 << 1) >> 1] | 0;
          i12 = HEAP16[i10 + (i12 + 2 << 1) >> 1] | 0;
          f48 = Math_fround(__Z14TriangleArea3DRK8Vector3fS1_S1_(i30 + (Math_imul(i6 & 65535, i29) | 0) | 0, i30 + (Math_imul(i11 & 65535, i29) | 0) | 0, i30 + (Math_imul(i12 & 65535, i29) | 0) | 0));
          f8 = Math_fround(f8 + f48);
          HEAP16[i7 + (i4 << 4) + 8 >> 1] = i6;
          HEAP16[i7 + (i4 << 4) + 10 >> 1] = i11;
          HEAP16[i7 + (i4 << 4) + 12 >> 1] = i12;
          HEAPF32[i7 + (i4 << 4) + 4 >> 2] = f48;
          HEAP32[i7 + (i4 << 4) >> 2] = i5;
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i3 | 0));
         i3 = HEAP32[i9 >> 2] | 0;
        } else f8 = Math_fround(0.0);
        HEAPF32[i31 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i31 >> 2]));
        i2 = i3 + i2 | 0;
        break L46;
       }
      default:
       break L46;
      }
      i11 = i33 + (i13 << 2) | 0;
      i9 = HEAP32[i11 >> 2] | 0;
      i7 = i9 * 3 | 0;
      HEAP32[i17 >> 2] = i7;
      HEAP32[i18 >> 2] = i7;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i44, gb + 64016 | 0);
      i51 = i44;
      i50 = HEAP32[i51 + 4 >> 2] | 0;
      i49 = i19;
      HEAP32[i49 >> 2] = HEAP32[i51 >> 2];
      HEAP32[i49 + 4 >> 2] = i50;
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 * 6 | 0, 2, i19, 0, gb + 1047584 | 0, 446) | 0;
      HEAP32[i35 >> 2] = i9;
      __Z10DestripifyIttEvPKT_iPT0_i(i10, HEAP32[i3 + (i13 * 52 | 0) + 36 >> 2] | 0, i9, i7);
      i7 = (HEAP32[i1 >> 2] | 0) + (i2 << 4) | 0;
      i9 = HEAP32[i35 >> 2] | 0;
      i3 = HEAP32[i11 >> 2] | 0;
      i5 = i12 & 255 | (i5 & 255) << 8 | (i6 & 255) << 16 | (i4 & 255) << 24;
      if ((i3 | 0) > 0) {
       i4 = 0;
       f8 = Math_fround(0.0);
       do {
        i51 = i4 * 3 | 0;
        i49 = HEAP16[i9 + (i51 << 1) >> 1] | 0;
        i50 = HEAP16[i9 + (i51 + 1 << 1) >> 1] | 0;
        i51 = HEAP16[i9 + (i51 + 2 << 1) >> 1] | 0;
        f48 = Math_fround(__Z14TriangleArea3DRK8Vector3fS1_S1_(i30 + (Math_imul(i49 & 65535, i29) | 0) | 0, i30 + (Math_imul(i50 & 65535, i29) | 0) | 0, i30 + (Math_imul(i51 & 65535, i29) | 0) | 0));
        f8 = Math_fround(f8 + f48);
        HEAP16[i7 + (i4 << 4) + 8 >> 1] = i49;
        HEAP16[i7 + (i4 << 4) + 10 >> 1] = i50;
        HEAP16[i7 + (i4 << 4) + 12 >> 1] = i51;
        HEAPF32[i7 + (i4 << 4) + 4 >> 2] = f48;
        HEAP32[i7 + (i4 << 4) >> 2] = i5;
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i3 | 0));
       i3 = HEAP32[i11 >> 2] | 0;
      } else f8 = Math_fround(0.0);
      HEAPF32[i31 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i31 >> 2]));
      if ((HEAP32[i18 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i19);
       HEAP32[i35 >> 2] = 0;
      }
      i2 = i3 + i2 | 0;
     } while (0);
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != (i34 | 0));
   }
   i50 = HEAP32[i1 >> 2] | 0;
   i51 = i50 + (HEAP32[i32 >> 2] << 4) | 0;
   HEAP32[i44 >> 2] = fb + 807;
   __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i50, i51, i44);
  }
 }
 if ((i46 | 0) == 19) {
  HEAP32[i9 + 116 >> 2] = 0;
  HEAPF32[i9 + 68 >> 2] = Math_fround(0.0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i36);
 STACKTOP = i47;
 return;
}

function __ZNK5physx2Sq16BucketPrunerCore7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE(i44, i20, i21, i45, i43) {
 i44 = i44 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i45 = i45 | 0;
 i43 = i43 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i47;
 f2 = Math_fround(HEAPF32[i45 >> 2]);
 if (f2 == Math_fround(3402823469999999843913219.0e14)) {
  f39 = Math_fround(HEAPF32[i44 + 608 >> 2]);
  f2 = Math_fround(HEAPF32[i44 + 624 >> 2]);
  f5 = Math_fround(f39 - f2);
  f40 = Math_fround(HEAPF32[i44 + 612 >> 2]);
  f3 = Math_fround(HEAPF32[i44 + 628 >> 2]);
  f8 = Math_fround(f40 - f3);
  f41 = Math_fround(HEAPF32[i44 + 616 >> 2]);
  f4 = Math_fround(HEAPF32[i44 + 632 >> 2]);
  f19 = Math_fround(f41 - f4);
  f2 = Math_fround(Math_fround(f39 + f2) + Math_fround(0.0));
  f3 = Math_fround(Math_fround(f40 + f3) + Math_fround(0.0));
  f4 = Math_fround(Math_fround(f41 + f4) + Math_fround(0.0));
  i6 = HEAP32[i44 + 28 >> 2] | 0;
  if (!i6) f10 = f19; else {
   f11 = Math_fround(8507058669999999534545717.0e13);
   i7 = 2122317823;
   i9 = 2122317823;
   i16 = -25165825;
   i17 = -25165825;
   i1 = -25165825;
   i18 = 0;
   while (1) {
    f15 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) >> 2]);
    f15 = f11 < f15 ? f11 : f15;
    f41 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) + 4 >> 2]);
    f14 = f41 < f14 ? f41 : f14;
    f41 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) + 8 >> 2]);
    f13 = f41 < f13 ? f41 : f13;
    i7 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    f41 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) + 12 >> 2]);
    f12 = f41 > f12 ? f41 : f12;
    f41 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) + 16 >> 2]);
    f11 = f41 > f11 ? f41 : f11;
    f41 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = Math_fround(HEAPF32[i44 + 160 + (i18 * 24 | 0) + 20 >> 2]);
    f10 = f41 > f10 ? f41 : f10;
    i16 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i17 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i6 | 0)) break; else {
     f11 = f15;
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    }
   }
   f41 = Math_fround(f12 + Math_fround(0.0));
   f40 = Math_fround(f11 + Math_fround(0.0));
   f39 = Math_fround(f10 + Math_fround(0.0));
   f10 = f19 < f13 ? f19 : f13;
   f8 = f8 < f14 ? f8 : f14;
   f5 = f5 < f15 ? f5 : f15;
   f4 = f4 > f39 ? f4 : f39;
   f3 = f3 > f40 ? f3 : f40;
   f2 = f2 > f41 ? f2 : f41;
  }
  f15 = Math_fround(HEAPF32[i20 >> 2]);
  i6 = i20 + 4 | 0;
  f36 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i20 + 8 | 0;
  f41 = Math_fround(HEAPF32[i7 >> 2]);
  f19 = Math_fround(HEAPF32[i21 >> 2]);
  i16 = i21 + 4 | 0;
  f37 = Math_fround(HEAPF32[i16 >> 2]);
  i17 = i21 + 8 | 0;
  f40 = Math_fround(HEAPF32[i17 >> 2]);
  f38 = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
  f14 = Math_fround(Math_fround(f3 - f8) * Math_fround(.5));
  f13 = Math_fround(Math_fround(f4 - f10) * Math_fround(.5));
  f39 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f5 + f2) * Math_fround(.5)) * f19) + Math_fround(Math_fround(Math_fround(f8 + f3) * Math_fround(.5)) * f37)) + Math_fround(Math_fround(Math_fround(f10 + f4) * Math_fround(.5)) * f40));
  f38 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f14 * f14) + Math_fround(f38 * f38)))));
  f2 = Math_fround(Math_fround(Math_fround(f15 * f19) + Math_fround(f36 * f37)) + Math_fround(f41 * f40));
  f40 = Math_fround(f38 * Math_fround(2.0));
  f41 = Math_fround(Math_abs(Math_fround(Math_fround(f39 - f38) - f2)));
  f2 = Math_fround(Math_abs(Math_fround(Math_fround(f38 + f39) - f2)));
  f2 = Math_fround(Math_fround(f40 * Math_fround(2.0)) + (f41 < f2 ? f41 : f2));
  HEAPF32[i45 >> 2] = f2;
  i1 = i20;
  i9 = i21;
 } else {
  i1 = i20;
  i6 = i20 + 4 | 0;
  i7 = i20 + 8 | 0;
  i9 = i21;
  i16 = i21 + 4 | 0;
  i17 = i21 + 8 | 0;
 }
 f41 = Math_fround(HEAPF32[i1 >> 2]);
 f40 = Math_fround(HEAPF32[i6 >> 2]);
 f39 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(HEAPF32[i9 >> 2]);
 f15 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(HEAPF32[i17 >> 2]);
 f36 = Math_fround(-f14);
 f37 = Math_fround(-f15);
 f38 = Math_fround(-f19);
 f36 = f14 > f36 ? f14 : f36;
 f37 = f15 > f37 ? f15 : f37;
 f38 = f19 > f38 ? f19 : f38;
 if (!(f2 >= Math_fround(3402823469999999843913219.0e14))) {
  f5 = Math_fround(f39 + Math_fround(f2 * f19));
  f4 = Math_fround(f40 + Math_fround(f2 * f15));
  f3 = Math_fround(f41 + Math_fround(f2 * f14));
 } else {
  i35 = f14 == Math_fround(0.0);
  i34 = f14 >= Math_fround(0.0);
  f3 = i34 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f3 = i35 ? f41 : f3;
  i35 = f15 == Math_fround(0.0);
  i34 = f15 >= Math_fround(0.0);
  f2 = i34 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f2 = i35 ? f40 : f2;
  if (f19 == Math_fround(0.0)) {
   f5 = f39;
   f4 = f2;
  } else {
   i35 = f19 >= Math_fround(0.0);
   f5 = i35 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
   f4 = f2;
  }
 }
 f2 = f41 < f3 ? f41 : f3;
 f8 = f40 < f4 ? f40 : f4;
 f10 = f39 < f5 ? f39 : f5;
 f11 = f41 > f3 ? f41 : f3;
 f12 = f40 > f4 ? f40 : f4;
 f13 = f39 > f5 ? f39 : f5;
 i7 = i44 + 28 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L15 : do if (i1 | 0) {
  i6 = 0;
  while (1) {
   f55 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) >> 2]);
   f52 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) + 12 >> 2]);
   f56 = Math_fround(f55 + f52);
   f51 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) + 16 >> 2]);
   f54 = Math_fround(f51 + f4);
   f48 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) + 8 >> 2]);
   f50 = Math_fround(HEAPF32[i44 + 160 + (i6 * 24 | 0) + 20 >> 2]);
   f56 = Math_fround(f56 * Math_fround(.5));
   f54 = Math_fround(f54 * Math_fround(.5));
   f5 = Math_fround(Math_fround(f48 + f50) * Math_fround(.5));
   f55 = Math_fround(Math_fround(f52 - f55) * Math_fround(.5));
   f51 = Math_fround(Math_fround(f4 - f51) * Math_fround(.5));
   f48 = Math_fround(Math_fround(f50 - f48) * Math_fround(.5));
   f50 = Math_fround(f41 - f56);
   f4 = Math_fround(f40 - f54);
   f52 = Math_fround(f39 - f5);
   f49 = Math_fround(Math_fround(f14 * f4) - Math_fround(f15 * f50));
   f4 = Math_fround(Math_fround(f15 * f52) - Math_fround(f19 * f4));
   f52 = Math_fround(Math_fround(f19 * f50) - Math_fround(f14 * f52));
   f50 = Math_fround(Math_fround(f37 * f55) + Math_fround(f36 * f51));
   f3 = Math_fround(Math_fround(f38 * f51) + Math_fround(f37 * f48));
   f53 = Math_fround(Math_fround(f38 * f55) + Math_fround(f36 * f48));
   i32 = Math_fround(f56 + f55) >= f2;
   i34 = Math_fround(f54 + f51) >= f8;
   i30 = Math_fround(f5 + f48) >= f10;
   i33 = f11 >= Math_fround(f56 - f55);
   i35 = f12 >= Math_fround(f54 - f51);
   i31 = f13 >= Math_fround(f5 - f48);
   f48 = Math_fround(-f49);
   f5 = Math_fround(-f4);
   f51 = Math_fround(-f52);
   if (i30 & i31 & f53 >= (f52 > f51 ? f52 : f51) & (i32 & i33 & f50 >= (f49 > f48 ? f49 : f48) & (i34 & i35 & f3 >= (f4 > f5 ? f4 : f5)))) {
    if (!(mftCall_iiiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, i45 | 0, i44 + 32 + (i6 << 3) | 0, 1) | 0)) {
     i1 = 0;
     break;
    }
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i1 >>> 0) break L15;
  }
  STACKTOP = i47;
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i44 + 584 >> 2] | 0)) {
  i46 = 1;
  STACKTOP = i47;
  return i46 | 0;
 }
 f3 = Math_fround(HEAPF32[i44 + 608 >> 2]);
 f5 = Math_fround(HEAPF32[i44 + 612 >> 2]);
 f56 = Math_fround(HEAPF32[i44 + 616 >> 2]);
 f4 = Math_fround(HEAPF32[i44 + 624 >> 2]);
 f50 = Math_fround(HEAPF32[i44 + 628 >> 2]);
 f53 = Math_fround(HEAPF32[i44 + 632 >> 2]);
 f51 = Math_fround(f41 - f3);
 f55 = Math_fround(f40 - f5);
 f49 = Math_fround(f39 - f56);
 f52 = Math_fround(Math_fround(f14 * f55) - Math_fround(f15 * f51));
 f55 = Math_fround(Math_fround(f15 * f49) - Math_fround(f19 * f55));
 f49 = Math_fround(Math_fround(f19 * f51) - Math_fround(f14 * f49));
 f51 = Math_fround(Math_fround(f37 * f4) + Math_fround(f36 * f50));
 f54 = Math_fround(Math_fround(f38 * f50) + Math_fround(f37 * f53));
 f48 = Math_fround(Math_fround(f38 * f4) + Math_fround(f36 * f53));
 i32 = Math_fround(f3 + f4) >= f2;
 i34 = Math_fround(f5 + f50) >= f8;
 i30 = Math_fround(f56 + f53) >= f10;
 i33 = f11 >= Math_fround(f3 - f4);
 i35 = f12 >= Math_fround(f5 - f50);
 i31 = f13 >= Math_fround(f56 - f53);
 f53 = Math_fround(-f52);
 f56 = Math_fround(-f55);
 f50 = Math_fround(-f49);
 if (!(f48 >= (f49 > f50 ? f49 : f50) & (i30 & i31) & (i32 & i33 & f51 >= (f52 > f53 ? f52 : f53) & (i34 & i35 & f54 >= (f55 > f56 ? f55 : f56))))) {
  i46 = 1;
  STACKTOP = i47;
  return i46 | 0;
 }
 i35 = HEAP32[i44 + 592 >> 2] | 0;
 f56 = Math_fround(HEAPF32[i45 >> 2]);
 i34 = i20 + (i35 << 2) | 0;
 f4 = Math_fround(HEAPF32[i34 >> 2]);
 i35 = i21 + (i35 << 2) | 0;
 f3 = Math_fround(f4 + Math_fround(f56 * Math_fround(HEAPF32[i35 >> 2])));
 i7 = (HEAPF32[tempDoublePtr >> 2] = f4 < f3 ? f4 : f3, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f4 > f3 ? f4 : f3, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i42 >> 2] = f56;
 i31 = (HEAP32[i16 >> 2] | 0) >>> 31 << 1 | (HEAP32[i21 >> 2] | 0) >>> 31 << 2 | (HEAP32[i17 >> 2] | 0) >>> 31;
 i32 = i44 + 20 | 0;
 i33 = i44 + 24 | 0;
 i6 = (i6 | 0) < 0 ? ~i6 : i6 | -2147483648;
 i7 = (i7 | 0) < 0 ? ~i7 : i7 | -2147483648;
 f3 = f8;
 f4 = f10;
 f5 = f11;
 f8 = f56;
 i29 = 0;
 i30 = HEAPU16[i44 + 848 + (i31 << 1) >> 1] | 0;
 L31 : do {
  i27 = i30 & 7;
  i30 = i30 >>> 3;
  if (HEAP32[i44 + 640 + (i27 << 2) >> 2] | 0) {
   f57 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) >> 2]);
   f11 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) + 4 >> 2]);
   f56 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) + 8 >> 2]);
   f10 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) + 16 >> 2]);
   f50 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) + 20 >> 2]);
   f53 = Math_fround(HEAPF32[i44 + 688 + (i27 << 5) + 24 >> 2]);
   f51 = Math_fround(f41 - f57);
   f55 = Math_fround(f40 - f11);
   f49 = Math_fround(f39 - f56);
   f52 = Math_fround(Math_fround(f14 * f55) - Math_fround(f15 * f51));
   f55 = Math_fround(Math_fround(f15 * f49) - Math_fround(f19 * f55));
   f49 = Math_fround(Math_fround(f19 * f51) - Math_fround(f14 * f49));
   f51 = Math_fround(Math_fround(f37 * f10) + Math_fround(f36 * f50));
   f54 = Math_fround(Math_fround(f38 * f50) + Math_fround(f37 * f53));
   f48 = Math_fround(Math_fround(f38 * f10) + Math_fround(f36 * f53));
   i24 = Math_fround(f57 + f10) >= f2;
   i26 = Math_fround(f11 + f50) >= f3;
   i22 = Math_fround(f56 + f53) >= f4;
   i25 = f5 >= Math_fround(f57 - f10);
   i28 = f12 >= Math_fround(f11 - f50);
   i23 = f13 >= Math_fround(f56 - f53);
   f53 = Math_fround(-f52);
   f56 = Math_fround(-f55);
   f50 = Math_fround(-f49);
   if (f48 >= (f49 > f50 ? f49 : f50) & (i22 & i23) & (i24 & i25 & f51 >= (f52 > f53 ? f52 : f53) & (i26 & i28 & f54 >= (f55 > f56 ? f55 : f56)))) {
    i28 = i44 + 660 + (i27 << 2) | 0;
    i25 = 0;
    i26 = HEAPU16[i44 + 864 + (i27 * 224 | 0) + 208 + (i31 << 1) >> 1] | 0;
    do {
     i23 = i26 & 7;
     i26 = i26 >>> 3;
     if (HEAP32[i44 + 864 + (i27 * 224 | 0) + (i23 << 2) >> 2] | 0) {
      f10 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) >> 2]);
      f48 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 4 >> 2]);
      f57 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 8 >> 2]);
      f11 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 16 >> 2]);
      f51 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 20 >> 2]);
      f54 = Math_fround(HEAPF32[i44 + 864 + (i27 * 224 | 0) + 48 + (i23 << 5) + 24 >> 2]);
      f52 = Math_fround(f41 - f10);
      f56 = Math_fround(f40 - f48);
      f50 = Math_fround(f39 - f57);
      f53 = Math_fround(Math_fround(f14 * f56) - Math_fround(f15 * f52));
      f56 = Math_fround(Math_fround(f15 * f50) - Math_fround(f19 * f56));
      f50 = Math_fround(Math_fround(f19 * f52) - Math_fround(f14 * f50));
      f52 = Math_fround(Math_fround(f37 * f11) + Math_fround(f36 * f51));
      f55 = Math_fround(Math_fround(f38 * f51) + Math_fround(f37 * f54));
      f49 = Math_fround(Math_fround(f38 * f11) + Math_fround(f36 * f54));
      i20 = Math_fround(f10 + f11) >= f2;
      i22 = Math_fround(f48 + f51) >= f3;
      i17 = Math_fround(f57 + f54) >= f4;
      i21 = f5 >= Math_fround(f10 - f11);
      i24 = f12 >= Math_fround(f48 - f51);
      i18 = f13 >= Math_fround(f57 - f54);
      f54 = Math_fround(-f53);
      f57 = Math_fround(-f56);
      f51 = Math_fround(-f50);
      if (f49 >= (f50 > f51 ? f50 : f51) & (i17 & i18) & (i20 & i21 & f52 >= (f53 > f54 ? f53 : f54) & (i22 & i24 & f55 >= (f56 > f57 ? f56 : f57)))) {
       i24 = (HEAP32[i44 + 864 + (i27 * 224 | 0) + 20 + (i23 << 2) >> 2] | 0) + (HEAP32[i28 >> 2] | 0) | 0;
       i18 = i6;
       i17 = i7;
       i21 = 0;
       i22 = HEAPU16[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 208 + (i31 << 1) >> 1] | 0;
       while (1) {
        i6 = i22 & 7;
        i22 = i22 >>> 3;
        i7 = HEAP32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + (i6 << 2) >> 2] | 0;
        L43 : do if (!i7) {
         i6 = i18;
         i7 = i17;
        } else {
         f10 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) >> 2]);
         f48 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) + 4 >> 2]);
         f57 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) + 8 >> 2]);
         f11 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) + 16 >> 2]);
         f51 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) + 20 >> 2]);
         f54 = Math_fround(HEAPF32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 48 + (i6 << 5) + 24 >> 2]);
         f52 = Math_fround(f41 - f10);
         f56 = Math_fround(f40 - f48);
         f50 = Math_fround(f39 - f57);
         f53 = Math_fround(Math_fround(f14 * f56) - Math_fround(f15 * f52));
         f56 = Math_fround(Math_fround(f15 * f50) - Math_fround(f19 * f56));
         f50 = Math_fround(Math_fround(f19 * f52) - Math_fround(f14 * f50));
         f52 = Math_fround(Math_fround(f37 * f11) + Math_fround(f36 * f51));
         f55 = Math_fround(Math_fround(f38 * f51) + Math_fround(f37 * f54));
         f49 = Math_fround(Math_fround(f38 * f11) + Math_fround(f36 * f54));
         i58 = Math_fround(f10 + f11) >= f2;
         i16 = Math_fround(f48 + f51) >= f3;
         i60 = Math_fround(f57 + f54) >= f4;
         i9 = f5 >= Math_fround(f10 - f11);
         i20 = f12 >= Math_fround(f48 - f51);
         i59 = f13 >= Math_fround(f57 - f54);
         f54 = Math_fround(-f53);
         f57 = Math_fround(-f56);
         f51 = Math_fround(-f50);
         if (f49 >= (f50 > f51 ? f50 : f51) & (i60 & i59) & (i58 & i9 & f52 >= (f53 > f54 ? f53 : f54) & (i16 & i20 & f55 >= (f56 > f57 ? f56 : f57)))) {
          i16 = i24 + (HEAP32[i44 + 1984 + (i27 * 1120 | 0) + (i23 * 224 | 0) + 20 + (i6 << 2) >> 2] | 0) | 0;
          i9 = HEAP32[i32 >> 2] | 0;
          i20 = i9 + (i16 + i7 << 5) | 0;
          i9 = i9 + (i16 << 5) | 0;
          i16 = (HEAP32[i33 >> 2] | 0) + (i16 << 3) | 0;
          while (1) {
           f10 = f8;
           L48 : while (1) {
            i6 = i9;
            i9 = i9 + 32 | 0;
            i7 = i16;
            i16 = i16 + 8 | 0;
            do if ((HEAP32[i6 + 28 >> 2] | 0) >>> 0 < i17 >>> 0) f8 = f10; else {
             if ((HEAP32[i6 + 12 >> 2] | 0) >>> 0 > i18 >>> 0) {
              i6 = i18;
              i7 = i17;
              f8 = f10;
              break L43;
             }
             f8 = Math_fround(HEAPF32[i6 >> 2]);
             f48 = Math_fround(HEAPF32[i6 + 4 >> 2]);
             f57 = Math_fround(HEAPF32[i6 + 8 >> 2]);
             f11 = Math_fround(HEAPF32[i6 + 16 >> 2]);
             f51 = Math_fround(HEAPF32[i6 + 20 >> 2]);
             f54 = Math_fround(HEAPF32[i6 + 24 >> 2]);
             f52 = Math_fround(f41 - f8);
             f56 = Math_fround(f40 - f48);
             f50 = Math_fround(f39 - f57);
             f53 = Math_fround(Math_fround(f14 * f56) - Math_fround(f15 * f52));
             f56 = Math_fround(Math_fround(f15 * f50) - Math_fround(f19 * f56));
             f50 = Math_fround(Math_fround(f19 * f52) - Math_fround(f14 * f50));
             f52 = Math_fround(Math_fround(f37 * f11) + Math_fround(f36 * f51));
             f55 = Math_fround(Math_fround(f38 * f51) + Math_fround(f37 * f54));
             f49 = Math_fround(Math_fround(f38 * f11) + Math_fround(f36 * f54));
             i6 = Math_fround(f8 + f11) >= f2;
             i59 = Math_fround(f48 + f51) >= f3;
             i62 = Math_fround(f57 + f54) >= f4;
             i58 = f5 >= Math_fround(f8 - f11);
             i60 = f12 >= Math_fround(f48 - f51);
             i61 = f13 >= Math_fround(f57 - f54);
             f54 = Math_fround(-f53);
             f57 = Math_fround(-f56);
             f51 = Math_fround(-f50);
             if (!(f49 >= (f50 > f51 ? f50 : f51) & (i62 & i61) & (i6 & i58 & f52 >= (f53 > f54 ? f53 : f54) & (i59 & i60 & f55 >= (f56 > f57 ? f56 : f57))))) {
              f8 = f10;
              break;
             }
             if (!(mftCall_iiiii(HEAP32[HEAP32[i43 >> 2] >> 2] | 0, i43 | 0, i42 | 0, i7 | 0, 1) | 0)) {
              i1 = 0;
              i46 = 41;
              break L31;
             }
             f8 = Math_fround(HEAPF32[i42 >> 2]);
             i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
             if (f8 < f10) break L48;
            } while (0);
            if ((i9 | 0) == (i20 | 0)) {
             i6 = i18;
             i7 = i17;
             break L43;
            } else f10 = f8;
           }
           f12 = Math_fround(HEAPF32[i34 >> 2]);
           f5 = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i35 >> 2])));
           i7 = (HEAPF32[tempDoublePtr >> 2] = f12 < f5 ? f12 : f5, HEAP32[tempDoublePtr >> 2] | 0);
           i6 = (HEAPF32[tempDoublePtr >> 2] = f12 > f5 ? f12 : f5, HEAP32[tempDoublePtr >> 2] | 0);
           f5 = Math_fround(f41 + Math_fround(f14 * f8));
           f12 = Math_fround(f40 + Math_fround(f15 * f8));
           f13 = Math_fround(f39 + Math_fround(f19 * f8));
           f2 = f41 < f5 ? f41 : f5;
           f3 = f40 < f12 ? f40 : f12;
           f4 = f39 < f13 ? f39 : f13;
           f5 = f41 > f5 ? f41 : f5;
           f12 = f40 > f12 ? f40 : f12;
           f13 = f39 > f13 ? f39 : f13;
           i7 = (i7 | 0) < 0 ? ~i7 : i7 | -2147483648;
           i6 = (i6 | 0) < 0 ? ~i6 : i6 | -2147483648;
           if ((i9 | 0) == (i20 | 0)) break; else {
            i18 = i6;
            i17 = i7;
           }
          }
         } else {
          i6 = i18;
          i7 = i17;
         }
        } while (0);
        i21 = i21 + 1 | 0;
        if (i21 >>> 0 >= 5) break; else {
         i18 = i6;
         i17 = i7;
        }
       }
      }
     }
     i25 = i25 + 1 | 0;
    } while (i25 >>> 0 < 5);
   }
  }
  i29 = i29 + 1 | 0;
 } while (i29 >>> 0 < 5);
 if ((i46 | 0) == 41) {
  STACKTOP = i47;
  return i1 | 0;
 }
 HEAP32[i45 >> 2] = i1;
 i62 = 1;
 STACKTOP = i47;
 return i62 | 0;
}

function __ZN8Animator11TargetMatchEv(i46) {
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i50 + 80 | 0;
 i48 = i50 + 40 | 0;
 i20 = i50;
 i49 = i46 + 364 | 0;
 do if (Math_fround(HEAPF32[i49 >> 2]) >= Math_fround(0.0)) {
  if (!(__ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi(HEAP32[i46 + 624 >> 2] | 0, 0) | 0)) if (__ZNK8Animator20IsInMatchTargetStateEv(i46) | 0) break;
  HEAP8[i46 + 416 >> 0] = 1;
 } while (0);
 if (!(HEAP8[i46 + 153 >> 0] | 0)) {
  STACKTOP = i50;
  return;
 }
 if (!(HEAP32[i46 + 168 >> 2] | 0)) {
  STACKTOP = i50;
  return;
 }
 if (!(Math_fround(HEAPF32[i49 >> 2]) >= Math_fround(0.0))) {
  STACKTOP = i50;
  return;
 }
 i1 = HEAP32[i46 + 136 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 i1 = (HEAP32[i46 + 124 >> 2] | 0) + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) f44 = Math_fround(1.0); else {
  i1 = i1 + i2 | 0;
  i43 = i1 + 40 | 0;
  if (!(HEAP32[(HEAP32[i43 >> 2] | 0) + i43 >> 2] | 0)) f44 = Math_fround(1.0); else f44 = Math_fround(HEAPF32[i1 + 360 >> 2]);
 }
 i27 = i46 + 132 | 0;
 __ZN7mecanim9animation29MotionOutputGetDeltaTransformEPKNS0_12MotionOutputE(i47, HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0);
 i28 = i48 + 12 | 0;
 i29 = i48 + 28 | 0;
 f53 = Math_fround(HEAPF32[i47 >> 2]);
 i30 = i47 + 4 | 0;
 f24 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i47 + 8 | 0;
 f21 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i48 + 4 | 0;
 i33 = i48 + 8 | 0;
 i16 = HEAP32[i47 + 12 >> 2] | 0;
 i34 = i47 + 16 | 0;
 i19 = HEAP32[i34 >> 2] | 0;
 i35 = i47 + 20 | 0;
 i1 = HEAP32[i35 >> 2] | 0;
 i36 = i47 + 24 | 0;
 i18 = HEAP32[i36 >> 2] | 0;
 HEAP32[i28 >> 2] = i16;
 i37 = i48 + 16 | 0;
 HEAP32[i37 >> 2] = i19;
 i38 = i48 + 20 | 0;
 HEAP32[i38 >> 2] = i1;
 i39 = i48 + 24 | 0;
 HEAP32[i39 >> 2] = i18;
 i40 = i47 + 32 | 0;
 i43 = HEAP32[i40 >> 2] | 0;
 i41 = i47 + 36 | 0;
 i14 = HEAP32[i41 >> 2] | 0;
 HEAP32[i29 >> 2] = HEAP32[i47 + 28 >> 2];
 i42 = i48 + 32 | 0;
 HEAP32[i42 >> 2] = i43;
 i43 = i48 + 36 | 0;
 HEAP32[i43 >> 2] = i14;
 f53 = Math_fround(f44 * f53);
 f24 = Math_fround(f44 * f24);
 f21 = Math_fround(f44 * f21);
 HEAPF32[i48 >> 2] = f53;
 HEAPF32[i32 >> 2] = f24;
 HEAPF32[i33 >> 2] = f21;
 f53 = Math_fround(f12 * f53);
 f24 = Math_fround(f15 * f24);
 f21 = Math_fround(f17 * f21);
 f25 = Math_fround(f8 * Math_fround(-2.0));
 f22 = Math_fround(f8 * Math_fround(2.0));
 f55 = Math_fround(f25 * f10);
 f52 = Math_fround(f9 * Math_fround(2.0));
 f54 = Math_fround(f9 * Math_fround(-2.0));
 f57 = Math_fround(f10 * f54);
 f23 = Math_fround(f7 * Math_fround(-2.0));
 f56 = Math_fround(f7 * Math_fround(2.0));
 f51 = Math_fround(f23 * f10);
 f26 = Math_fround(f3 + Math_fround(Math_fround(f53 + Math_fround(Math_fround(Math_fround(f8 * f25) - Math_fround(f9 * f52)) * f53)) + Math_fround(Math_fround(Math_fround(f57 - Math_fround(f8 * f23)) * f24) + Math_fround(Math_fround(Math_fround(f56 * f9) - f55) * f21))));
 f25 = Math_fround(f4 + Math_fround(Math_fround(f24 + Math_fround(Math_fround(Math_fround(f7 * f22) - f57) * f53)) + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f54) - Math_fround(f7 * f56)) * f24) + Math_fround(Math_fround(f51 - Math_fround(f25 * f9)) * f21))));
 f21 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(Math_fround(f55 - Math_fround(f7 * f54)) * f53) + f21) + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f52) - f51) * f24) + Math_fround(Math_fround(Math_fround(f7 * f23) - Math_fround(f8 * f22)) * f21))));
 f3 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f8 * f3);
 f6 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(f10 * f6);
 f4 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f9 * f4);
 f51 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f10 * f51)) - Math_fround(f9 * f6)) - Math_fround(f7 * f4));
 f23 = Math_fround(Math_fround(Math_fround(f23 - Math_fround(f7 * f3)) - Math_fround(f9 * f51)) - Math_fround(f8 * f4));
 f24 = Math_fround(Math_fround(Math_fround(f24 - Math_fround(f8 * f51)) - Math_fround(f10 * f3)) - Math_fround(f7 * f6));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f51) - Math_fround(f9 * f3)) - Math_fround(f10 * f4)) - Math_fround(f8 * f6));
 f8 = Math_fround(HEAPF32[i48 + 28 >> 2]);
 f7 = Math_fround(HEAPF32[i42 >> 2]);
 f8 = Math_fround(f12 * f8);
 f7 = Math_fround(f15 * f7);
 f6 = Math_fround(f17 * Math_fround(HEAPF32[i43 >> 2]));
 i1 = HEAP32[i46 + 624 >> 2] | 0;
 if ((i1 | 0) == 0 ? 1 : (HEAP32[HEAP32[i1 + 92 >> 2] >> 2] | 0) == 0) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(1.0);
 } else {
  i2 = i20;
  i5 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i1, 0, 0, i20) | 0;
  f3 = Math_fround(HEAPF32[i20 + 12 >> 2]);
  f4 = Math_fround(HEAPF32[i20 + 16 >> 2]);
 }
 if (f3 >= Math_fround(HEAPF32[i49 >> 2])) {
  i19 = HEAP32[i46 + 128 >> 2] | 0;
  f56 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f57 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) / f4);
  f3 = Math_fround(f56 - Math_fround(f3 - f57));
  i2 = f3 > Math_fround(0.0);
  f3 = i2 ? f3 : Math_fround(0.0);
  i2 = f3 != Math_fround(0.0);
  f3 = Math_fround(f57 / f3);
  f3 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), i2 ? f3 : Math_fround(1.0)))));
  i2 = HEAP32[i27 >> 2] | 0;
  i5 = HEAP32[i2 + 16 >> 2] | 0;
  i16 = HEAP32[i5 + 292 >> 2] | 0;
  i18 = HEAP32[i5 + 296 >> 2] | 0;
  i14 = HEAP32[i5 + 300 >> 2] | 0;
  i13 = HEAP32[i5 + 304 >> 2] | 0;
  i1 = HEAP32[i5 + 308 >> 2] | 0;
  i11 = HEAP32[i5 + 312 >> 2] | 0;
  i5 = HEAP32[i5 + 316 >> 2] | 0;
  i19 = HEAP32[i19 + 4 >> 2] | 0;
  L25 : do if (!(HEAP8[i46 + 416 >> 0] | 0)) i45 = 19; else {
   switch (i19 | 0) {
   case 0:
    {
     f3 = Math_fround(1.0);
     i13 = 0;
     i16 = 0;
     i14 = 0;
     i11 = 0;
     i5 = 1065353216;
     i2 = 0;
     i1 = 0;
     break L25;
    }
   case 1:
    {
     i1 = HEAP32[i2 + 24 >> 2] | 0;
     f3 = Math_fround(1.0);
     i13 = HEAP32[i1 + 12 >> 2] | 0;
     i16 = HEAP32[i1 >> 2] | 0;
     i14 = HEAP32[i1 + 8 >> 2] | 0;
     i11 = HEAP32[i1 + 20 >> 2] | 0;
     i5 = HEAP32[i1 + 24 >> 2] | 0;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     i1 = HEAP32[i1 + 16 >> 2] | 0;
     break L25;
    }
   default:
    {}
   }
   if ((i19 + -1 | 0) >>> 0 < 5) {
    i1 = i19 + -2 | 0;
    i45 = HEAP32[i2 + 24 >> 2] | 0;
    f3 = Math_fround(1.0);
    i13 = HEAP32[i45 + 68 + (i1 << 6) + 12 >> 2] | 0;
    i16 = HEAP32[i45 + 68 + (i1 << 6) >> 2] | 0;
    i14 = HEAP32[i45 + 68 + (i1 << 6) + 8 >> 2] | 0;
    i11 = HEAP32[i45 + 68 + (i1 << 6) + 20 >> 2] | 0;
    i5 = HEAP32[i45 + 68 + (i1 << 6) + 24 >> 2] | 0;
    i18 = HEAP32[i45 + 68 + (i1 << 6) + 4 >> 2] | 0;
    i1 = HEAP32[i45 + 68 + (i1 << 6) + 16 >> 2] | 0;
    i45 = 19;
   } else {
    f3 = Math_fround(1.0);
    i45 = 19;
   }
  } while (0);
  if ((i45 | 0) == 19) {
   i2 = i19 + -2 | 0;
   if (i2 >>> 0 < 4) {
    __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE(i20, i2);
    f53 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = Math_fround(HEAPF32[i20 >> 2]);
    f55 = Math_fround(f53 * f17);
    f51 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f54 = Math_fround(HEAPF32[i20 + 12 >> 2]);
    f57 = Math_fround(f51 * f54);
    f15 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f56 = Math_fround(HEAPF32[i20 + 4 >> 2]);
    f52 = Math_fround(f15 * f56);
    f10 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(HEAPF32[i20 + 8 >> 2]);
    f55 = Math_fround(Math_fround(Math_fround(f55 - Math_fround(f51 * f12)) - Math_fround(f15 * f54)) - Math_fround(f10 * f56));
    f57 = Math_fround(Math_fround(Math_fround(f57 - Math_fround(f10 * f17)) - Math_fround(f15 * f12)) - Math_fround(f53 * f56));
    f52 = Math_fround(Math_fround(Math_fround(f52 - Math_fround(f53 * f12)) - Math_fround(f51 * f17)) - Math_fround(f10 * f54));
    f54 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f12) - Math_fround(f15 * f17)) - Math_fround(f51 * f56)) - Math_fround(f53 * f54));
    i13 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f54 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f52 = Math_fround(f54 * f54);
    f55 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = Math_fround(f55 * f55);
    f56 = (HEAP32[tempDoublePtr >> 2] = i13 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f52 + f53) + Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56))))));
    f54 = Math_fround(f53 * f54);
    f55 = Math_fround(f53 * f55);
    f56 = Math_fround(f53 * f56);
    f57 = Math_fround(f53 * f57);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = i18;
   } else i2 = i18;
  }
  i19 = i46 + 372 | 0;
  f10 = Math_fround(HEAPF32[i19 >> 2]);
  f55 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i46 + 384 >> 2]);
  f17 = Math_fround(HEAPF32[i46 + 388 >> 2]);
  f54 = Math_fround(HEAPF32[i46 + 392 >> 2]);
  f12 = Math_fround(HEAPF32[i46 + 396 >> 2]);
  f10 = Math_fround(f10 - f26);
  f26 = Math_fround(f55 - f25);
  f15 = Math_fround(f15 - f21);
  f55 = Math_fround(f9 * Math_fround(-2.0));
  f25 = Math_fround(f9 * Math_fround(2.0));
  f53 = Math_fround(f23 * f55);
  f58 = Math_fround(f22 * Math_fround(2.0));
  f52 = Math_fround(f22 * Math_fround(-2.0));
  f59 = Math_fround(f23 * f52);
  f57 = Math_fround(f24 * Math_fround(-2.0));
  f51 = Math_fround(f24 * Math_fround(2.0));
  f21 = Math_fround(f23 * f57);
  f56 = Math_fround(Math_fround(f10 + Math_fround(Math_fround(Math_fround(f9 * f55) - Math_fround(f22 * f58)) * f10)) + Math_fround(Math_fround(Math_fround(f59 - Math_fround(f9 * f57)) * f26) + Math_fround(Math_fround(Math_fround(f22 * f51) - f53) * f15)));
  f55 = Math_fround(Math_fround(f26 + Math_fround(Math_fround(Math_fround(f24 * f25) - f59) * f10)) + Math_fround(Math_fround(Math_fround(Math_fround(f22 * f52) - Math_fround(f24 * f51)) * f26) + Math_fround(Math_fround(f21 - Math_fround(f22 * f55)) * f15)));
  f15 = Math_fround(Math_fround(Math_fround(Math_fround(f53 - Math_fround(f24 * f52)) * f10) + f15) + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f58) - f21) * f26) + Math_fround(Math_fround(Math_fround(f24 * f57) - Math_fround(f9 * f25)) * f15)));
  i19 = Math_fround(Math_abs(Math_fround(f8))) < Math_fround(9.99999971e-10);
  i20 = Math_fround(Math_abs(Math_fround(f7))) < Math_fround(9.99999971e-10);
  i18 = Math_fround(Math_abs(Math_fround(f6))) < Math_fround(9.99999971e-10);
  f25 = Math_fround(Math_fround(1.0) / f8);
  f25 = i19 ? Math_fround(1.0) : f25;
  f57 = Math_fround(Math_fround(1.0) / f7);
  f57 = i20 ? Math_fround(1.0) : f57;
  f21 = Math_fround(Math_fround(1.0) / f6);
  f56 = Math_fround(f25 * f56);
  f55 = Math_fround(f57 * f55);
  f15 = Math_fround((i18 ? Math_fround(1.0) : f21) * f15);
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f4) - Math_fround(f23 * f54)) - Math_fround(f22 * f12)) - Math_fround(f24 * f17));
  f57 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f12) - Math_fround(f24 * f4)) - Math_fround(f22 * f54)) - Math_fround(f9 * f17));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f17) - Math_fround(f9 * f54)) - Math_fround(f23 * f4)) - Math_fround(f24 * f12));
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f54) - Math_fround(f22 * f4)) - Math_fround(f23 * f17)) - Math_fround(f9 * f12));
  i18 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f56 - f6);
  f25 = Math_fround(f55 - f25);
  f9 = Math_fround(f15 - (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f15 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = (HEAP32[tempDoublePtr >> 2] = i13 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = Math_fround(f22 * f15);
  f56 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(f56 * f57);
  f12 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = (HEAP32[tempDoublePtr >> 2] = i1 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(f24 * f12);
  f17 = (HEAP32[tempDoublePtr >> 2] = i20 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i11 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = Math_fround(Math_fround(Math_fround(f55 - Math_fround(f4 * f57)) - Math_fround(f56 * f12)) - Math_fround(f24 * f17));
  f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f22 * f17)) - Math_fround(f4 * f12)) - Math_fround(f24 * f15));
  f23 = Math_fround(Math_fround(Math_fround(f23 - Math_fround(f4 * f15)) - Math_fround(f22 * f57)) - Math_fround(f56 * f17));
  f15 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f17) - Math_fround(f22 * f12)) - Math_fround(f24 * f57)) - Math_fround(f56 * f15));
  i20 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = i16 ^ -2147483648;
  i18 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i20 = i20 ^ -2147483648;
  f15 = Math_fround(Math_fround(1.0) / f44);
  f6 = Math_fround(f15 * f6);
  f44 = Math_fround(f15 * f25);
  f9 = Math_fround(f15 * f9);
  f15 = Math_fround(f3 * Math_fround(HEAPF32[i46 + 400 >> 2]));
  f25 = Math_fround(f3 * Math_fround(HEAPF32[i46 + 404 >> 2]));
  f6 = Math_fround(f15 * f6);
  f25 = Math_fround(f44 * f25);
  f9 = Math_fround(f9 * Math_fround(f3 * Math_fround(HEAPF32[i46 + 408 >> 2])));
  f44 = Math_fround(f3 * Math_fround(HEAPF32[i46 + 412 >> 2]));
  f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0));
  f23 = Math_fround(Math_fround(f15 + f23) + Math_fround(f21 + Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(0.0))));
  i19 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  i45 = i19 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = (HEAP32[tempDoublePtr >> 2] = i19 ^ i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = (HEAP32[tempDoublePtr >> 2] = i19 ^ i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = i19 ^ i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(Math_fround(f44 * f21) + Math_fround(0.0));
  f23 = Math_fround(Math_fround(f44 * f23) + Math_fround(0.0));
  f15 = Math_fround(Math_fround(f44 * f15) + Math_fround(0.0));
  f44 = Math_fround(Math_fround(f44 * Math_fround((HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0))) + Math_fround(1.0));
  f55 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(Math_fround(f15 * f15) + Math_fround(f44 * f44))))));
  f21 = Math_fround(f55 * f21);
  f23 = Math_fround(f55 * f23);
  f15 = Math_fround(f55 * f15);
  f44 = Math_fround(f55 * f44);
  f55 = Math_fround(HEAPF32[i47 + 28 >> 2]);
  f56 = Math_fround(HEAPF32[i40 >> 2]);
  f57 = Math_fround(HEAPF32[i41 >> 2]);
  f6 = Math_fround(f6 * f55);
  f25 = Math_fround(f25 * f56);
  f9 = Math_fround(f9 * f57);
  f24 = Math_fround(HEAPF32[i34 >> 2]);
  f12 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  f22 = Math_fround(HEAPF32[i36 >> 2]);
  f17 = Math_fround(HEAPF32[i35 >> 2]);
  f4 = Math_fround(f24 * Math_fround(-2.0));
  f26 = Math_fround(f24 * Math_fround(2.0));
  f7 = Math_fround(f4 * f22);
  f54 = Math_fround(f17 * Math_fround(2.0));
  f8 = Math_fround(f17 * Math_fround(-2.0));
  f58 = Math_fround(f22 * f8);
  f10 = Math_fround(f12 * Math_fround(-2.0));
  f52 = Math_fround(f12 * Math_fround(2.0));
  f53 = Math_fround(f22 * f10);
  f51 = Math_fround(Math_fround(f6 + Math_fround(f6 * Math_fround(Math_fround(f24 * f4) - Math_fround(f17 * f54)))) + Math_fround(Math_fround(f9 * Math_fround(Math_fround(f52 * f17) - f7)) + Math_fround(f25 * Math_fround(f58 - Math_fround(f24 * f10)))));
  f52 = Math_fround(Math_fround(f25 + Math_fround(f6 * Math_fround(Math_fround(f12 * f26) - f58))) + Math_fround(Math_fround(f9 * Math_fround(f53 - Math_fround(f4 * f17))) + Math_fround(f25 * Math_fround(Math_fround(f17 * f8) - Math_fround(f12 * f52)))));
  f53 = Math_fround(Math_fround(f9 + Math_fround(f6 * Math_fround(f7 - Math_fround(f12 * f8)))) + Math_fround(Math_fround(f9 * Math_fround(Math_fround(f12 * f10) - Math_fround(f24 * f26))) + Math_fround(f25 * Math_fround(Math_fround(f24 * f54) - f53))));
  f54 = Math_fround(HEAPF32[i47 >> 2]);
  f25 = Math_fround(HEAPF32[i30 >> 2]);
  f51 = Math_fround(f54 + f51);
  f52 = Math_fround(f25 + f52);
  f53 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f53);
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f21) - Math_fround(f22 * f15)) - Math_fround(f17 * f44)) - Math_fround(f12 * f23));
  f54 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f44) - Math_fround(f12 * f21)) - Math_fround(f17 * f15)) - Math_fround(f24 * f23));
  f26 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f23) - Math_fround(f24 * f15)) - Math_fround(f22 * f21)) - Math_fround(f12 * f44));
  f44 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f15) - Math_fround(f17 * f21)) - Math_fround(f22 * f23)) - Math_fround(f24 * f44));
  i47 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAPF32[i48 >> 2] = f51;
  HEAPF32[i32 >> 2] = f52;
  HEAPF32[i33 >> 2] = f53;
  HEAP32[i28 >> 2] = i41 ^ -2147483648;
  HEAP32[i37 >> 2] = i45;
  HEAP32[i38 >> 2] = i47 ^ -2147483648;
  HEAPF32[i39 >> 2] = f54;
  HEAPF32[i29 >> 2] = f55;
  HEAPF32[i42 >> 2] = f56;
  HEAPF32[i43 >> 2] = f57;
  __ZN7mecanim9animation29MotionOutputSetDeltaTransformEPNS0_12MotionOutputERKN4math4trsXE(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i48);
  if (f3 >= Math_fround(1.0)) {
   HEAPF32[i49 >> 2] = Math_fround(-1.0);
   HEAP32[i46 + 368 >> 2] = -1;
  }
 }
 STACKTOP = i50;
 return;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold24addManifoldContactPointsEPNS0_21MeshPersistentContactEjPPNS0_15PCMContactPatchEjRKNS_6shdfnd3aos6FloatVESB_h(i45, i43, i41, i38, i39, i1, i34, i2) {
 i45 = i45 | 0;
 i43 = i43 | 0;
 i41 = i41 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i34 = i34 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i40 = 0, i42 = 0, i44 = 0, f46 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i44 + 140 | 0;
 i20 = i44 + 48 | 0;
 i33 = i44 + 64 | 0;
 i30 = i44 + 128 | 0;
 i31 = i44 + 32 | 0;
 i32 = i44 + 16 | 0;
 i40 = i44;
 i37 = i45 + 52 | 0;
 if (!(HEAP8[i37 >> 0] | 0)) {
  if (!i39) {
   STACKTOP = i44;
   return;
  }
  i13 = i2 & 255;
  i14 = i20 + 4 | 0;
  i1 = 0;
  i15 = 0;
  while (1) {
   i8 = HEAP32[i38 + (i15 << 2) >> 2] | 0;
   if ((HEAP32[i8 + 24 >> 2] | 0) == (i8 | 0)) {
    if ((i1 & 255) >= 4) {
     i35 = 108;
     break;
    }
    i10 = HEAPU8[(i1 & 255) + (i45 + 48) >> 0] | 0;
    i9 = i45 + 64 + (i10 * 400 | 0) | 0;
    L11 : do switch (i13 | 0) {
    case 1:
     {
      HEAPF32[i20 >> 2] = Math_fround(3402823469999999843913219.0e14);
      f4 = Math_fround(3402823469999999843913219.0e14);
      i7 = i8;
      i1 = -1;
      do {
       i2 = HEAP32[i7 + 48 >> 2] | 0;
       i6 = HEAP32[i7 + 52 >> 2] | 0;
       if (i2 >>> 0 < i6 >>> 0) do {
        i3 = HEAP32[i43 + (i2 << 6) + 44 >> 2] | 0;
        f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        if (f4 > f5) {
         HEAP32[i20 >> 2] = i3;
         HEAP32[i14 >> 2] = HEAP32[i42 >> 2];
         HEAP32[i14 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
         HEAP32[i14 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
         f4 = f5;
         i1 = i2;
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i6 | 0));
       i7 = HEAP32[i7 + 16 >> 2] | 0;
      } while ((i7 | 0) != 0);
      i3 = i43 + (i1 << 6) | 0;
      i21 = i9 + 52 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
       i9 = i9 + 4 | 0;
       i3 = i3 + 4 | 0;
      } while ((i9 | 0) < (i21 | 0));
      HEAP32[i45 + 64 + (i10 * 400 | 0) + 384 >> 2] = 1;
      break;
     }
    case 3:
     {
      if ((HEAP32[i8 + 56 >> 2] | 0) >>> 0 < 4) {
       i7 = i8;
       i1 = 0;
      } else {
       __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i20, i9, i43, i41, i8);
       HEAP32[i45 + 64 + (i10 * 400 | 0) + 384 >> 2] = 3;
       break L11;
      }
      do {
       i2 = HEAP32[i7 + 48 >> 2] | 0;
       i6 = i7 + 52 | 0;
       if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
        i3 = i1;
        while (1) {
         i1 = i3 + 1 | 0;
         i9 = i45 + 64 + (i10 * 400 | 0) + (i3 << 6) | 0;
         i3 = i43 + (i2 << 6) | 0;
         i21 = i9 + 52 | 0;
         do {
          HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
          i9 = i9 + 4 | 0;
          i3 = i3 + 4 | 0;
         } while ((i9 | 0) < (i21 | 0));
         i2 = i2 + 1 | 0;
         if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
        }
       }
       i7 = HEAP32[i7 + 16 >> 2] | 0;
      } while ((i7 | 0) != 0);
      HEAP32[i45 + 64 + (i10 * 400 | 0) + 384 >> 2] = i1;
      i40 = i8 + 32 | 0;
      HEAP32[i20 >> 2] = HEAP32[i40 >> 2];
      HEAP32[i20 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
      HEAP32[i20 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
      HEAP32[i20 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
      break;
     }
    default:
     {
      if ((HEAP32[i8 + 56 >> 2] | 0) >>> 0 < 7) {
       i7 = i8;
       i1 = 0;
      } else {
       __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i20, i9, i43, i41, i8);
       HEAP32[i45 + 64 + (i10 * 400 | 0) + 384 >> 2] = 6;
       break L11;
      }
      do {
       i2 = HEAP32[i7 + 48 >> 2] | 0;
       i6 = i7 + 52 | 0;
       if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
        i3 = i1;
        while (1) {
         i1 = i3 + 1 | 0;
         i9 = i45 + 64 + (i10 * 400 | 0) + (i3 << 6) | 0;
         i3 = i43 + (i2 << 6) | 0;
         i21 = i9 + 52 | 0;
         do {
          HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
          i9 = i9 + 4 | 0;
          i3 = i3 + 4 | 0;
         } while ((i9 | 0) < (i21 | 0));
         i2 = i2 + 1 | 0;
         if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
        }
       }
       i7 = HEAP32[i7 + 16 >> 2] | 0;
      } while ((i7 | 0) != 0);
      HEAP32[i45 + 64 + (i10 * 400 | 0) + 384 >> 2] = i1;
      i40 = i8 + 32 | 0;
      HEAP32[i20 >> 2] = HEAP32[i40 >> 2];
      HEAP32[i20 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
      HEAP32[i20 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
      HEAP32[i20 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
     }
    } while (0);
    HEAP32[i45 + 32 + (HEAPU8[(HEAPU8[i37 >> 0] | 0) + (i45 + 48) >> 0] << 2) >> 2] = HEAP32[i20 >> 2];
    i1 = (HEAP8[i37 >> 0] | 0) + 1 << 24 >> 24;
    HEAP8[i37 >> 0] = i1;
   }
   i15 = i15 + 1 | 0;
   if (i15 >>> 0 >= i39 >>> 0) {
    i35 = 108;
    break;
   }
  }
  if ((i35 | 0) == 108) {
   STACKTOP = i44;
   return;
  }
 }
 i28 = i33 + 16 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i33 + 20 >> 2] = 0;
 i29 = i33 + 24 | 0;
 HEAP32[i29 >> 2] = i33;
 HEAPF32[i33 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (!i39) {
  STACKTOP = i44;
  return;
 }
 i36 = i2 & 255;
 i15 = i32 + 4 | 0;
 i20 = i33 + 48 | 0;
 i22 = i33 + 52 | 0;
 i23 = i33 + 4 | 0;
 i24 = i33 + 8 | 0;
 i25 = i33 + 12 | 0;
 i26 = i31 + 4 | 0;
 i27 = 0;
 L52 : while (1) {
  i10 = HEAP32[i38 + (i27 << 2) >> 2] | 0;
  L54 : do if ((HEAP32[i10 + 24 >> 2] | 0) == (i10 | 0)) {
   i6 = HEAP8[i37 >> 0] | 0;
   i3 = i6 & 255;
   do if (i6 << 24 >> 24) {
    f16 = Math_fround(HEAPF32[i10 >> 2]);
    f17 = Math_fround(HEAPF32[i10 + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i10 + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i34 >> 2]);
    i8 = 0;
    while (1) {
     i7 = i45 + 48 + i8 | 0;
     i9 = HEAPU8[i7 >> 0] | 0;
     f4 = Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + 32 >> 2]);
     f5 = Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + 36 >> 2]);
     f11 = Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + 40 >> 2]);
     i13 = i45 + 64 + (i9 * 400 | 0) + 384 | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     if (i1 >>> 0 > 1) {
      i2 = 1;
      do {
       f46 = Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + (i2 << 6) + 32 >> 2]);
       f12 = Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + (i2 << 6) + 36 >> 2]);
       f4 = Math_fround(f4 + f46);
       f5 = Math_fround(f5 + f12);
       f11 = Math_fround(f11 + Math_fround(HEAPF32[i45 + 64 + (i9 * 400 | 0) + (i2 << 6) + 40 >> 2]));
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i1 | 0));
      f12 = f11;
     } else f12 = f11;
     f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))));
     f11 = Math_fround(f4 * f46);
     f5 = Math_fround(f5 * f46);
     f4 = Math_fround(f12 * f46);
     i8 = i8 + 1 | 0;
     if (Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(f5 * f17)) + Math_fround(f4 * f18)) >= f19) {
      i14 = i7;
      i8 = i9;
      break;
     }
     if (i8 >>> 0 >= i3 >>> 0) {
      i35 = 60;
      break;
     }
    }
    if ((i35 | 0) == 60) {
     i35 = 0;
     if ((i6 & 255) < 4) break; else break L52;
    }
    i7 = i45 + 64 + (i8 * 400 | 0) | 0;
    if (!i1) i1 = 0; else {
     i2 = 0;
     do {
      i9 = i43 + (i2 + i41 << 6) | 0;
      i3 = i45 + 64 + (i8 * 400 | 0) + (i2 << 6) | 0;
      i21 = i9 + 52 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
       i9 = i9 + 4 | 0;
       i3 = i3 + 4 | 0;
      } while ((i9 | 0) < (i21 | 0));
      i2 = i2 + 1 | 0;
      i1 = HEAP32[i13 >> 2] | 0;
     } while (i2 >>> 0 < i1 >>> 0);
    }
    HEAP32[i20 >> 2] = i41;
    HEAP32[i22 >> 2] = i1 + i41;
    HEAPF32[i33 >> 2] = f11;
    HEAPF32[i23 >> 2] = f5;
    HEAPF32[i24 >> 2] = f4;
    HEAPF32[i25 >> 2] = Math_fround(0.0);
    HEAP32[i29 >> 2] = i10;
    HEAP32[i28 >> 2] = 0;
    HEAP32[(HEAP32[i10 + 20 >> 2] | 0) + 16 >> 2] = i33;
    i21 = i10 + 56 | 0;
    i1 = (HEAP32[i21 >> 2] | 0) + i1 | 0;
    HEAP32[i21 >> 2] = i1;
    i21 = i10 + 32 | 0;
    f46 = Math_fround(HEAPF32[i21 >> 2]);
    i2 = i10 + 36 | 0;
    f19 = Math_fround(HEAPF32[i45 + 32 + (HEAPU8[i14 >> 0] << 2) >> 2]);
    HEAPF32[i21 >> 2] = f46 > f19 ? f19 : f46;
    HEAP32[i2 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
    i2 = (HEAP32[i13 >> 2] | 0) + i41 | 0;
    L72 : do switch (i36 | 0) {
    case 1:
     {
      HEAPF32[i31 >> 2] = Math_fround(3402823469999999843913219.0e14);
      f4 = Math_fround(3402823469999999843913219.0e14);
      i1 = -1;
      do {
       i2 = HEAP32[i10 + 48 >> 2] | 0;
       i6 = HEAP32[i10 + 52 >> 2] | 0;
       if (i2 >>> 0 < i6 >>> 0) do {
        i3 = HEAP32[i43 + (i2 << 6) + 44 >> 2] | 0;
        f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        if (f4 > f5) {
         HEAP32[i31 >> 2] = i3;
         HEAP32[i26 >> 2] = HEAP32[i42 >> 2];
         HEAP32[i26 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
         HEAP32[i26 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
         f4 = f5;
         i1 = i2;
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i6 | 0));
       i10 = HEAP32[i10 + 16 >> 2] | 0;
      } while ((i10 | 0) != 0);
      i9 = i7;
      i3 = i43 + (i1 << 6) | 0;
      i21 = i9 + 52 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
       i9 = i9 + 4 | 0;
       i3 = i3 + 4 | 0;
      } while ((i9 | 0) < (i21 | 0));
      HEAP32[i13 >> 2] = 1;
      break;
     }
    case 3:
     {
      if (i1 >>> 0 < 4) {
       i7 = i10;
       i1 = 0;
      } else {
       __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i31, i7, i43, i2, i10);
       HEAP32[i13 >> 2] = 3;
       break L72;
      }
      do {
       i2 = HEAP32[i7 + 48 >> 2] | 0;
       i6 = i7 + 52 | 0;
       if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
        i3 = i1;
        while (1) {
         i1 = i3 + 1 | 0;
         i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
         i3 = i43 + (i2 << 6) | 0;
         i21 = i9 + 52 | 0;
         do {
          HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
          i9 = i9 + 4 | 0;
          i3 = i3 + 4 | 0;
         } while ((i9 | 0) < (i21 | 0));
         i2 = i2 + 1 | 0;
         if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
        }
       }
       i7 = HEAP32[i7 + 16 >> 2] | 0;
      } while ((i7 | 0) != 0);
      HEAP32[i13 >> 2] = i1;
      i21 = i10 + 32 | 0;
      HEAP32[i31 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i31 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
      HEAP32[i31 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
      HEAP32[i31 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
      break;
     }
    default:
     {
      if (i1 >>> 0 < 7) {
       i7 = i10;
       i1 = 0;
      } else {
       __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i31, i7, i43, i2, i10);
       HEAP32[i13 >> 2] = 6;
       break L72;
      }
      do {
       i2 = HEAP32[i7 + 48 >> 2] | 0;
       i6 = i7 + 52 | 0;
       if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
        i3 = i1;
        while (1) {
         i1 = i3 + 1 | 0;
         i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
         i3 = i43 + (i2 << 6) | 0;
         i21 = i9 + 52 | 0;
         do {
          HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
          i9 = i9 + 4 | 0;
          i3 = i3 + 4 | 0;
         } while ((i9 | 0) < (i21 | 0));
         i2 = i2 + 1 | 0;
         if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
        }
       }
       i7 = HEAP32[i7 + 16 >> 2] | 0;
      } while ((i7 | 0) != 0);
      HEAP32[i13 >> 2] = i1;
      i21 = i10 + 32 | 0;
      HEAP32[i31 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i31 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
      HEAP32[i31 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
      HEAP32[i31 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     }
    } while (0);
    HEAP32[i45 + 32 + (HEAPU8[i14 >> 0] << 2) >> 2] = HEAP32[i31 >> 2];
    break L54;
   } while (0);
   i8 = HEAPU8[i45 + 48 + i3 >> 0] | 0;
   i9 = i45 + 64 + (i8 * 400 | 0) | 0;
   L106 : do switch (i36 | 0) {
   case 1:
    {
     HEAPF32[i32 >> 2] = Math_fround(3402823469999999843913219.0e14);
     f4 = Math_fround(3402823469999999843913219.0e14);
     i1 = -1;
     do {
      i2 = HEAP32[i10 + 48 >> 2] | 0;
      i6 = HEAP32[i10 + 52 >> 2] | 0;
      if (i2 >>> 0 < i6 >>> 0) do {
       i3 = HEAP32[i43 + (i2 << 6) + 44 >> 2] | 0;
       f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f4 > f5) {
        HEAP32[i32 >> 2] = i3;
        HEAP32[i15 >> 2] = HEAP32[i42 >> 2];
        HEAP32[i15 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
        HEAP32[i15 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
        f4 = f5;
        i1 = i2;
       }
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i6 | 0));
      i10 = HEAP32[i10 + 16 >> 2] | 0;
     } while ((i10 | 0) != 0);
     i3 = i43 + (i1 << 6) | 0;
     i21 = i9 + 52 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
      i9 = i9 + 4 | 0;
      i3 = i3 + 4 | 0;
     } while ((i9 | 0) < (i21 | 0));
     HEAP32[i45 + 64 + (i8 * 400 | 0) + 384 >> 2] = 1;
     break;
    }
   case 3:
    {
     if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 4) {
      i7 = i10;
      i1 = 0;
     } else {
      __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i32, i9, i43, i41, i10);
      HEAP32[i45 + 64 + (i8 * 400 | 0) + 384 >> 2] = 3;
      break L106;
     }
     do {
      i2 = HEAP32[i7 + 48 >> 2] | 0;
      i6 = i7 + 52 | 0;
      if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
       i3 = i1;
       while (1) {
        i1 = i3 + 1 | 0;
        i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
        i3 = i43 + (i2 << 6) | 0;
        i21 = i9 + 52 | 0;
        do {
         HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
         i9 = i9 + 4 | 0;
         i3 = i3 + 4 | 0;
        } while ((i9 | 0) < (i21 | 0));
        i2 = i2 + 1 | 0;
        if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
       }
      }
      i7 = HEAP32[i7 + 16 >> 2] | 0;
     } while ((i7 | 0) != 0);
     HEAP32[i45 + 64 + (i8 * 400 | 0) + 384 >> 2] = i1;
     i21 = i10 + 32 | 0;
     HEAP32[i32 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i32 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i32 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     break;
    }
   default:
    {
     if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 7) {
      i7 = i10;
      i1 = 0;
     } else {
      __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i32, i9, i43, i41, i10);
      HEAP32[i45 + 64 + (i8 * 400 | 0) + 384 >> 2] = 6;
      break L106;
     }
     do {
      i2 = HEAP32[i7 + 48 >> 2] | 0;
      i6 = i7 + 52 | 0;
      if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
       i3 = i1;
       while (1) {
        i1 = i3 + 1 | 0;
        i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
        i3 = i43 + (i2 << 6) | 0;
        i21 = i9 + 52 | 0;
        do {
         HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
         i9 = i9 + 4 | 0;
         i3 = i3 + 4 | 0;
        } while ((i9 | 0) < (i21 | 0));
        i2 = i2 + 1 | 0;
        if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
       }
      }
      i7 = HEAP32[i7 + 16 >> 2] | 0;
     } while ((i7 | 0) != 0);
     HEAP32[i45 + 64 + (i8 * 400 | 0) + 384 >> 2] = i1;
     i21 = i10 + 32 | 0;
     HEAP32[i32 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i32 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i32 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    }
   } while (0);
   HEAP32[i45 + 32 + (HEAPU8[(HEAPU8[i37 >> 0] | 0) + (i45 + 48) >> 0] << 2) >> 2] = HEAP32[i32 >> 2];
   HEAP8[i37 >> 0] = (HEAP8[i37 >> 0] | 0) + 1 << 24 >> 24;
  } while (0);
  i27 = i27 + 1 | 0;
  if (i27 >>> 0 >= i39 >>> 0) {
   i35 = 107;
   break;
  }
 }
 if ((i35 | 0) == 107) {
  STACKTOP = i44;
  return;
 }
 i1 = 0;
 i2 = 1;
 do {
  f46 = Math_fround(HEAPF32[i45 + 32 + (HEAPU8[i45 + 48 + i2 >> 0] << 2) >> 2]);
  i39 = f46 > Math_fround(HEAPF32[i45 + 32 + (HEAPU8[i45 + 48 + i1 >> 0] << 2) >> 2]);
  i1 = i39 ? i2 : i1;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 i13 = i45 + 48 + i1 | 0;
 i8 = HEAPU8[i13 >> 0] | 0;
 f46 = Math_fround(HEAPF32[i45 + 32 + (i8 << 2) >> 2]);
 if (!(f46 > Math_fround(HEAPF32[i10 + 32 >> 2]))) {
  STACKTOP = i44;
  return;
 }
 i9 = i45 + 64 + (i8 * 400 | 0) | 0;
 i14 = i45 + 64 + (i8 * 400 | 0) + 384 | 0;
 HEAP32[i14 >> 2] = 0;
 L149 : do switch (i36 | 0) {
 case 1:
  {
   HEAPF32[i40 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i8 = i40 + 4 | 0;
   f4 = Math_fround(3402823469999999843913219.0e14);
   i7 = i10;
   i1 = -1;
   do {
    i2 = HEAP32[i7 + 48 >> 2] | 0;
    i6 = HEAP32[i7 + 52 >> 2] | 0;
    if (i2 >>> 0 < i6 >>> 0) do {
     i3 = HEAP32[i43 + (i2 << 6) + 44 >> 2] | 0;
     f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f4 > f5) {
      HEAP32[i40 >> 2] = i3;
      HEAP32[i8 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
      f4 = f5;
      i1 = i2;
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i6 | 0));
    i7 = HEAP32[i7 + 16 >> 2] | 0;
   } while ((i7 | 0) != 0);
   i3 = i43 + (i1 << 6) | 0;
   i21 = i9 + 52 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    i9 = i9 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i9 | 0) < (i21 | 0));
   HEAP32[i14 >> 2] = 1;
   break;
  }
 case 3:
  {
   if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 4) {
    i7 = i10;
    i1 = 0;
   } else {
    __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i40, i9, i43, i41, i10);
    HEAP32[i14 >> 2] = 3;
    break L149;
   }
   do {
    i2 = HEAP32[i7 + 48 >> 2] | 0;
    i6 = i7 + 52 | 0;
    if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
     i3 = i1;
     while (1) {
      i1 = i3 + 1 | 0;
      i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
      i3 = i43 + (i2 << 6) | 0;
      i21 = i9 + 52 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
       i9 = i9 + 4 | 0;
       i3 = i3 + 4 | 0;
      } while ((i9 | 0) < (i21 | 0));
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
     }
    }
    i7 = HEAP32[i7 + 16 >> 2] | 0;
   } while ((i7 | 0) != 0);
   HEAP32[i14 >> 2] = i1;
   i43 = i10 + 32 | 0;
   HEAP32[i40 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   break;
  }
 default:
  {
   if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 7) {
    i7 = i10;
    i1 = 0;
   } else {
    __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i40, i9, i43, i41, i10);
    HEAP32[i14 >> 2] = 6;
    break L149;
   }
   do {
    i2 = HEAP32[i7 + 48 >> 2] | 0;
    i6 = i7 + 52 | 0;
    if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
     i3 = i1;
     while (1) {
      i1 = i3 + 1 | 0;
      i9 = i45 + 64 + (i8 * 400 | 0) + (i3 << 6) | 0;
      i3 = i43 + (i2 << 6) | 0;
      i21 = i9 + 52 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
       i9 = i9 + 4 | 0;
       i3 = i3 + 4 | 0;
      } while ((i9 | 0) < (i21 | 0));
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
     }
    }
    i7 = HEAP32[i7 + 16 >> 2] | 0;
   } while ((i7 | 0) != 0);
   HEAP32[i14 >> 2] = i1;
   i43 = i10 + 32 | 0;
   HEAP32[i40 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
  }
 } while (0);
 HEAP32[i45 + 32 + (HEAPU8[i13 >> 0] << 2) >> 2] = HEAP32[i40 >> 2];
 STACKTOP = i44;
 return;
}

function __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b(i52, i24, i30, i56, i29, i28, i51, i23, i55, i53, i3, i34, i54, i36, i25, i26, i46) {
 i52 = i52 | 0;
 i24 = i24 | 0;
 i30 = i30 | 0;
 i56 = i56 | 0;
 i29 = i29 | 0;
 i28 = i28 | 0;
 i51 = i51 | 0;
 i23 = i23 | 0;
 i55 = i55 | 0;
 i53 = i53 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 i54 = i54 | 0;
 i36 = i36 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i27 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i57 = 0, i58 = 0, i59 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i59 + 96 | 0;
 i31 = i59 + 88 | 0;
 i33 = i59 + 72 | 0;
 i42 = i59 + 64 | 0;
 i40 = i59 + 48 | 0;
 i44 = i59 + 40 | 0;
 i43 = i59 + 24 | 0;
 i41 = i59 + 16 | 0;
 i39 = i59;
 if (!i24) {
  HEAP16[i56 >> 1] = 0;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i51 >> 2] = 0;
  HEAP16[i55 >> 1] = HEAPU16[i55 >> 1] & 65519;
  i58 = 0;
  STACKTOP = i59;
  return i58 | 0;
 }
 i2 = i24 << 1;
 i50 = i2 >>> 0 > 1024;
 i57 = i58 + 4 | 0;
 HEAP8[i57 >> 0] = i50 & 1;
 if (i50) {
  i50 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i59 + 104 | 0, i2, gb + 716261 | 0, 1225) | 0;
  HEAP32[i58 >> 2] = i50;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i58 >> 2] = i1;
  i50 = i1;
 }
 i45 = i52 + 48 | 0;
 if ((HEAP32[i45 >> 2] | 0) == -1) i35 = (HEAP32[i52 + 52 >> 2] | 0) != -1; else i35 = 1;
 i32 = i3 & (i34 ^ 1);
 i37 = i52 + 4 | 0;
 i38 = i52 + 8 | 0;
 i27 = i54 + 2 | 0;
 if (i24 >>> 0 > 1) {
  i17 = HEAP32[i52 >> 2] | 0;
  i14 = HEAP32[i37 >> 2] | 0;
  i13 = HEAP32[i38 >> 2] | 0;
  i20 = 1;
  i18 = HEAP16[i54 >> 1] | 0;
  i7 = HEAP16[i27 >> 1] | 0;
  i8 = 1;
  i21 = 0;
  i1 = i24;
  while (1) {
   f12 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = Math_fround(HEAPF32[i52 + (i20 << 6) >> 2]);
   f12 = Math_fround(f12 * f15);
   f11 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = Math_fround(HEAPF32[i52 + (i20 << 6) + 4 >> 2]);
   f11 = Math_fround(f12 + Math_fround(f11 * f16));
   f12 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = Math_fround(HEAPF32[i52 + (i20 << 6) + 8 >> 2]);
   i49 = Math_fround(f11 + Math_fround(f12 * f19)) < Math_fround(.999000012);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i54 + (i20 << 2) | 0;
   if (i49) i22 = 13; else if ((HEAP16[i5 >> 1] | 0) == i18 << 16 >> 16) if ((HEAP16[i54 + (i20 << 2) + 2 >> 1] | 0) == i7 << 16 >> 16) {
    i3 = i14;
    i4 = i17;
    i5 = i18;
    i2 = i21;
   } else i22 = 13; else i22 = 13;
   if ((i22 | 0) == 13) {
    i22 = 0;
    HEAP16[i50 + (i8 + -1 << 1) >> 1] = i20;
    i13 = i2;
    i5 = HEAP16[i5 >> 1] | 0;
    i7 = HEAP16[i54 + (i20 << 2) + 2 >> 1] | 0;
    i8 = i8 + 1 | 0;
    i2 = i20;
    i1 = ((i20 - i21 | 0) >>> 0 > 1 & i46 & 1) + i1 | 0;
   }
   i20 = i20 + 1 | 0;
   if ((i20 | 0) == (i24 | 0)) {
    i49 = i8;
    break;
   } else {
    i17 = i4;
    i14 = i3;
    i18 = i5;
    i21 = i2;
   }
  }
 } else {
  i49 = 1;
  i2 = 0;
  i1 = 1;
 }
 i14 = ((i24 - i2 | 0) >>> 0 > 1 & i46 & 1) + i1 | 0;
 if ((i23 | 0) != 0 & i46) i23 = (i14 - i24 << 2) + i23 | 0;
 HEAP16[i50 + (i49 + -1 << 1) >> 1] = i24;
 i1 = Math_imul(i14, i32 ? 72 : i35 ? 24 : 16) | 0;
 i1 = (i32 ? 20 : 4) + i36 + (i32 ? 4 : i49 << 5) + i1 | 0;
 i48 = i1 + 15 & -16;
 i2 = i23 + i48 | 0;
 do if (i25) {
  i13 = i30 + 316 | 0;
  i4 = i2 + 15 & -16;
  if (i4 >>> 0 > 16384) {
   i47 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i13 >> 2] | 0, i4) | 0;
   break;
  }
  i5 = i30 + 320 | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i2 = i30 + 324 | 0;
  if (i7 | 0) {
   i8 = HEAP32[i2 >> 2] | 0;
   i3 = i8 + i4 | 0;
   if (i3 >>> 0 <= 16384) {
    HEAP32[i2 >> 2] = i3;
    i47 = i7 + i8 | 0;
    break;
   }
  }
  i47 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i13 >> 2] | 0, i26 + 300 | 0) | 0;
  HEAP32[i5 >> 2] = i47;
  HEAP32[i2 >> 2] = i4;
 } else {
  i13 = i30 + 332 | 0;
  i3 = i2 + 15 & -16;
  if (i3 >>> 0 > 16384) {
   i47 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i13 >> 2] | 0, i3) | 0;
   break;
  }
  i4 = i30 + 336 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = i30 + 340 | 0;
  if (i5 | 0) {
   i7 = HEAP32[i2 >> 2] | 0;
   i8 = i7 + i3 | 0;
   if (i8 >>> 0 <= 16384) {
    HEAP32[i2 >> 2] = i8;
    i47 = i5 + i7 | 0;
    break;
   }
  }
  i47 = __ZN5physx17PxcNpMemBlockPool19acquireContactBlockEv(HEAP32[i13 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = i3;
 } while (0);
 HEAP32[i29 >> 2] = i47;
 if (!i47) {
  HEAP16[i56 >> 1] = 0;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i51 >> 2] = 0;
  HEAP16[i55 >> 1] = HEAPU16[i55 >> 1] & 65519;
  i1 = 0;
 } else {
  i3 = i30 + 8760 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
  HEAP32[i28 >> 2] = i1;
  i3 = HEAP16[i54 >> 1] | 0;
  i4 = HEAP16[i27 >> 1] | 0;
  i7 = HEAP32[i53 >> 2] | 0;
  i28 = i7 + ((i3 & 65535) << 5) | 0;
  i7 = i7 + ((i4 & 65535) << 5) | 0;
  f10 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i28, i7));
  __ZN5physx19PxsMaterialCombinerC2Eff(i31, Math_fround(1.0), Math_fround(1.0));
  __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i33, i31, i28, i7);
  f6 = Math_fround(HEAPF32[i33 >> 2]);
  f9 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  i7 = HEAP32[i33 + 8 >> 2] | 0;
  HEAP16[i47 + (i36 + 2) >> 1] = (i32 ? 2 : 0) | (i34 ? 4 : 0) | i35 & 1;
  i28 = i14 & 65535;
  HEAP16[i47 + i36 >> 1] = i28;
  i14 = i47 + (i36 + 4) | 0;
  L47 : do if (i32) {
   HEAPF32[i14 >> 2] = Math_fround(1.0);
   HEAPF32[i47 + (i36 + 8) >> 2] = Math_fround(1.0);
   HEAPF32[i47 + (i36 + 12) >> 2] = Math_fround(1.0);
   HEAPF32[i47 + (i36 + 16) >> 2] = Math_fround(1.0);
   if (i49 | 0) {
    i21 = i47 + (i36 + 20) | 0;
    i22 = i47 + (i36 + 22) | 0;
    i24 = i52 + 52 | 0;
    i25 = i40 + 4 | 0;
    i26 = i40 + 8 | 0;
    i27 = i3;
    i2 = 0;
    i5 = i4;
    i4 = i47 + (i36 + 24) | 0;
    i17 = 0;
    while (1) {
     i18 = HEAP16[i54 + (i17 << 2) + 2 >> 1] | 0;
     if (i27 << 16 >> 16 == i3 << 16 >> 16 ? i18 << 16 >> 16 == i5 << 16 >> 16 : 0) i20 = i5; else {
      i7 = HEAP32[i53 >> 2] | 0;
      i20 = i7 + ((i27 & 65535) << 5) | 0;
      i7 = i7 + ((i18 & 65535) << 5) | 0;
      f10 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i20, i7));
      __ZN5physx19PxsMaterialCombinerC2Eff(i42, Math_fround(1.0), Math_fround(1.0));
      __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i40, i42, i20, i7);
      f6 = Math_fround(HEAPF32[i40 >> 2]);
      f9 = Math_fround(HEAPF32[i25 >> 2]);
      i7 = HEAP32[i26 >> 2] | 0;
      i20 = i18;
     }
     HEAP16[i21 >> 1] = i28;
     HEAP16[i22 >> 1] = i7;
     i14 = i50 + (i2 << 1) | 0;
     i13 = HEAPU16[i14 >> 1] | 0;
     if (i46) {
      i3 = i13 - i17 | 0;
      if (i3 >>> 0 > 1) {
       f19 = Math_fround(Math_fround(1.0) / Math_fround(i3 >>> 0));
       if (i13 >>> 0 > i17 >>> 0) {
        f12 = Math_fround(0.0);
        f15 = Math_fround(0.0);
        f16 = Math_fround(0.0);
        f11 = Math_fround(0.0);
        i3 = i17;
        do {
         f12 = Math_fround(f12 + Math_fround(HEAPF32[i52 + (i3 << 6) + 16 >> 2]));
         f15 = Math_fround(f15 + Math_fround(HEAPF32[i52 + (i3 << 6) + 20 >> 2]));
         f16 = Math_fround(f16 + Math_fround(HEAPF32[i52 + (i3 << 6) + 24 >> 2]));
         f11 = Math_fround(f11 + Math_fround(HEAPF32[i52 + (i3 << 6) + 12 >> 2]));
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) != (i13 | 0));
       } else {
        f16 = Math_fround(0.0);
        f15 = Math_fround(0.0);
        f12 = Math_fround(0.0);
        f11 = Math_fround(0.0);
       }
       f15 = Math_fround(f19 * f15);
       f16 = Math_fround(f19 * f16);
       HEAPF32[i4 >> 2] = Math_fround(f19 * f12);
       HEAPF32[i4 + 4 >> 2] = f15;
       HEAPF32[i4 + 8 >> 2] = f16;
       HEAPF32[i4 + 12 >> 2] = Math_fround(f19 * f11);
       HEAP32[i4 + 16 >> 2] = HEAP32[i45 >> 2];
       HEAP32[i4 + 20 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i4 + 24 >> 2] = HEAP32[i52 >> 2];
       HEAP32[i4 + 28 >> 2] = HEAP32[i37 >> 2];
       HEAP32[i4 + 32 >> 2] = HEAP32[i38 >> 2];
       HEAPF32[i4 + 48 >> 2] = Math_fround(3402823469999999843913219.0e14);
       HEAP32[i4 + 36 >> 2] = 0;
       HEAP32[i4 + 40 >> 2] = 0;
       HEAP32[i4 + 44 >> 2] = 0;
       HEAPF32[i4 + 52 >> 2] = f6;
       HEAPF32[i4 + 56 >> 2] = f9;
       HEAPF32[i4 + 60 >> 2] = f10;
       HEAP32[i4 + 68 >> 2] = i7;
       HEAP16[i4 + 64 >> 1] = i27;
       HEAP16[i4 + 66 >> 1] = i18;
       i8 = i4 + 72 | 0;
      } else i8 = i4;
     } else i8 = i4;
     if (i13 >>> 0 > i17 >>> 0) {
      i5 = i13 - i17 | 0;
      i3 = i17;
      i4 = i8;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i52 + (i3 << 6) + 16 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i52 + (i3 << 6) + 20 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i52 + (i3 << 6) + 24 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i52 + (i3 << 6) + 12 >> 2];
       HEAP32[i4 + 16 >> 2] = HEAP32[i52 + (i3 << 6) + 48 >> 2];
       HEAP32[i4 + 20 >> 2] = HEAP32[i52 + (i3 << 6) + 52 >> 2];
       HEAP32[i4 + 24 >> 2] = HEAP32[i52 + (i3 << 6) >> 2];
       HEAP32[i4 + 28 >> 2] = HEAP32[i52 + (i3 << 6) + 4 >> 2];
       HEAP32[i4 + 32 >> 2] = HEAP32[i52 + (i3 << 6) + 8 >> 2];
       HEAPF32[i4 + 48 >> 2] = Math_fround(3402823469999999843913219.0e14);
       HEAP32[i4 + 36 >> 2] = 0;
       HEAP32[i4 + 40 >> 2] = 0;
       HEAP32[i4 + 44 >> 2] = 0;
       HEAPF32[i4 + 52 >> 2] = f6;
       HEAPF32[i4 + 56 >> 2] = f9;
       HEAPF32[i4 + 60 >> 2] = f10;
       HEAP32[i4 + 68 >> 2] = i7;
       HEAP16[i4 + 64 >> 1] = i27;
       HEAP16[i4 + 66 >> 1] = i18;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i13 | 0)) break; else i4 = i4 + 72 | 0;
      }
      i4 = i8 + (i5 * 72 | 0) | 0;
     } else i4 = i8;
     i3 = HEAPU16[i14 >> 1] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i49 | 0)) break L47;
     i44 = i27;
     i27 = HEAP16[i54 + (i3 << 2) >> 1] | 0;
     i5 = i20;
     i17 = i3;
     i3 = i44;
    }
   }
  } else {
   i2 = (i49 | 0) == 0;
   if (!i35) {
    if (i2) break;
    i18 = i39 + 4 | 0;
    i20 = i39 + 8 | 0;
    i21 = i3;
    i22 = i4;
    i2 = 0;
    i5 = i3;
    i3 = i4;
    i4 = 0;
    while (1) {
     if (i21 << 16 >> 16 == i5 << 16 >> 16 ? i22 << 16 >> 16 == i3 << 16 >> 16 : 0) {
      f16 = f10;
      f19 = f9;
      i17 = i7;
     } else {
      i17 = HEAP32[i53 >> 2] | 0;
      i45 = i17 + ((i21 & 65535) << 5) | 0;
      i17 = i17 + ((i22 & 65535) << 5) | 0;
      f16 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i45, i17));
      __ZN5physx19PxsMaterialCombinerC2Eff(i41, Math_fround(1.0), Math_fround(1.0));
      __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i39, i41, i45, i17);
      f6 = Math_fround(HEAPF32[i39 >> 2]);
      f19 = Math_fround(HEAPF32[i18 >> 2]);
      i17 = HEAP32[i20 >> 2] | 0;
     }
     i3 = i14 + 32 | 0;
     i13 = i50 + (i2 << 1) | 0;
     i8 = HEAPU16[i13 >> 1] | 0;
     HEAP32[i14 + 4 >> 2] = HEAP32[i52 + (i4 << 6) >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 4 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 8 >> 2];
     i5 = i8 - i4 | 0;
     i7 = i5 & 65535;
     HEAP16[i14 >> 1] = i7;
     HEAPF32[i14 + 16 >> 2] = f6;
     HEAPF32[i14 + 20 >> 2] = f19;
     HEAPF32[i14 + 24 >> 2] = f16;
     HEAP16[i14 + 28 >> 1] = i21;
     HEAP16[i14 + 30 >> 1] = i22;
     HEAP16[i14 + 2 >> 1] = i17;
     if (i5 >>> 0 > 1 & i46) {
      HEAP16[i14 >> 1] = i7 + 1 << 16 >> 16;
      f15 = Math_fround(Math_fround(1.0) / Math_fround(i5 >>> 0));
      if (i8 >>> 0 > i4 >>> 0) {
       f10 = Math_fround(0.0);
       f11 = Math_fround(0.0);
       f12 = Math_fround(0.0);
       f9 = Math_fround(0.0);
       i5 = i4;
       do {
        f10 = Math_fround(f10 + Math_fround(HEAPF32[i52 + (i5 << 6) + 16 >> 2]));
        f11 = Math_fround(f11 + Math_fround(HEAPF32[i52 + (i5 << 6) + 20 >> 2]));
        f12 = Math_fround(f12 + Math_fround(HEAPF32[i52 + (i5 << 6) + 24 >> 2]));
        f9 = Math_fround(f9 + Math_fround(HEAPF32[i52 + (i5 << 6) + 12 >> 2]));
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i8 | 0));
      } else {
       f12 = Math_fround(0.0);
       f11 = Math_fround(0.0);
       f10 = Math_fround(0.0);
       f9 = Math_fround(0.0);
      }
      f11 = Math_fround(f15 * f11);
      f12 = Math_fround(f15 * f12);
      HEAPF32[i3 >> 2] = Math_fround(f15 * f10);
      HEAPF32[i14 + 36 >> 2] = f11;
      HEAPF32[i14 + 40 >> 2] = f12;
      HEAPF32[i14 + 44 >> 2] = Math_fround(f15 * f9);
      i5 = 48;
      i3 = i14 + 48 | 0;
     } else i5 = 32;
     if (i8 >>> 0 > i4 >>> 0) {
      i5 = i14 + (i5 + (i8 - i4 << 4)) | 0;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i52 + (i4 << 6) + 16 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i52 + (i4 << 6) + 20 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 24 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 12 >> 2];
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i8 | 0)) break; else i3 = i3 + 16 | 0;
      }
      i3 = i5;
     }
     i4 = HEAPU16[i13 >> 1] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i49 | 0)) break L47;
     i45 = i22;
     i5 = i21;
     i21 = HEAP16[i54 + (i4 << 2) >> 1] | 0;
     i22 = HEAP16[i54 + (i4 << 2) + 2 >> 1] | 0;
     f10 = f16;
     i14 = i3;
     f9 = f19;
     i7 = i17;
     i3 = i45;
    }
   }
   if (!i2) {
    i21 = i52 + 52 | 0;
    i22 = i43 + 4 | 0;
    i24 = i43 + 8 | 0;
    if (i46) {
     i18 = i3;
     i20 = i4;
     i2 = 0;
     i5 = i3;
     i3 = i4;
     i4 = 0;
    } else {
     i17 = i3;
     i18 = i4;
     i2 = 0;
     i5 = i3;
     i3 = i4;
     i4 = 0;
     while (1) {
      if (i17 << 16 >> 16 == i5 << 16 >> 16 ? i18 << 16 >> 16 == i3 << 16 >> 16 : 0) i13 = i7; else {
       i13 = HEAP32[i53 >> 2] | 0;
       i46 = i13 + ((i17 & 65535) << 5) | 0;
       i13 = i13 + ((i18 & 65535) << 5) | 0;
       f10 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i46, i13));
       __ZN5physx19PxsMaterialCombinerC2Eff(i44, Math_fround(1.0), Math_fround(1.0));
       __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i43, i44, i46, i13);
       f6 = Math_fround(HEAPF32[i43 >> 2]);
       f9 = Math_fround(HEAPF32[i22 >> 2]);
       i13 = HEAP32[i24 >> 2] | 0;
      }
      i3 = i14 + 32 | 0;
      i8 = i50 + (i2 << 1) | 0;
      i7 = HEAPU16[i8 >> 1] | 0;
      HEAP32[i14 + 4 >> 2] = HEAP32[i52 + (i4 << 6) >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 4 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 8 >> 2];
      HEAP16[i14 >> 1] = i7 - i4;
      HEAPF32[i14 + 16 >> 2] = f6;
      HEAPF32[i14 + 20 >> 2] = f9;
      HEAPF32[i14 + 24 >> 2] = f10;
      HEAP16[i14 + 2 >> 1] = i13;
      HEAP16[i14 + 28 >> 1] = i17;
      HEAP16[i14 + 30 >> 1] = i18;
      if (i7 >>> 0 > i4 >>> 0) {
       i5 = i14 + (((i7 - i4 | 0) * 24 | 0) + 32) | 0;
       while (1) {
        HEAP32[i3 >> 2] = HEAP32[i52 + (i4 << 6) + 16 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i52 + (i4 << 6) + 20 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 24 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 12 >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i52 + (i4 << 6) + 48 >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i52 + (i4 << 6) + 52 >> 2];
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (i7 | 0)) break; else i3 = i3 + 24 | 0;
       }
       i3 = i5;
      }
      i4 = HEAPU16[i8 >> 1] | 0;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i49 | 0)) break L47;
      i46 = i18;
      i5 = i17;
      i17 = HEAP16[i54 + (i4 << 2) >> 1] | 0;
      i18 = HEAP16[i54 + (i4 << 2) + 2 >> 1] | 0;
      i14 = i3;
      i7 = i13;
      i3 = i46;
     }
    }
    while (1) {
     if (i18 << 16 >> 16 == i5 << 16 >> 16 ? i20 << 16 >> 16 == i3 << 16 >> 16 : 0) {
      f16 = f10;
      f19 = f9;
      i17 = i7;
     } else {
      i17 = HEAP32[i53 >> 2] | 0;
      i46 = i17 + ((i18 & 65535) << 5) | 0;
      i17 = i17 + ((i20 & 65535) << 5) | 0;
      f16 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i46, i17));
      __ZN5physx19PxsMaterialCombinerC2Eff(i44, Math_fround(1.0), Math_fround(1.0));
      __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i43, i44, i46, i17);
      f6 = Math_fround(HEAPF32[i43 >> 2]);
      f19 = Math_fround(HEAPF32[i22 >> 2]);
      i17 = HEAP32[i24 >> 2] | 0;
     }
     i3 = i14 + 32 | 0;
     i13 = i50 + (i2 << 1) | 0;
     i8 = HEAPU16[i13 >> 1] | 0;
     HEAP32[i14 + 4 >> 2] = HEAP32[i52 + (i4 << 6) >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 4 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 8 >> 2];
     i5 = i8 - i4 | 0;
     i7 = i5 & 65535;
     HEAP16[i14 >> 1] = i7;
     HEAPF32[i14 + 16 >> 2] = f6;
     HEAPF32[i14 + 20 >> 2] = f19;
     HEAPF32[i14 + 24 >> 2] = f16;
     HEAP16[i14 + 2 >> 1] = i17;
     HEAP16[i14 + 28 >> 1] = i18;
     HEAP16[i14 + 30 >> 1] = i20;
     if (i5 >>> 0 > 1) {
      HEAP16[i14 >> 1] = i7 + 1 << 16 >> 16;
      f15 = Math_fround(Math_fround(1.0) / Math_fround(i5 >>> 0));
      if (i8 >>> 0 > i4 >>> 0) {
       f10 = Math_fround(0.0);
       f11 = Math_fround(0.0);
       f12 = Math_fround(0.0);
       f9 = Math_fround(0.0);
       i5 = i4;
       do {
        f10 = Math_fround(f10 + Math_fround(HEAPF32[i52 + (i5 << 6) + 16 >> 2]));
        f11 = Math_fround(f11 + Math_fround(HEAPF32[i52 + (i5 << 6) + 20 >> 2]));
        f12 = Math_fround(f12 + Math_fround(HEAPF32[i52 + (i5 << 6) + 24 >> 2]));
        f9 = Math_fround(f9 + Math_fround(HEAPF32[i52 + (i5 << 6) + 12 >> 2]));
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != (i8 | 0));
      } else {
       f12 = Math_fround(0.0);
       f11 = Math_fround(0.0);
       f10 = Math_fround(0.0);
       f9 = Math_fround(0.0);
      }
      f11 = Math_fround(f15 * f11);
      f12 = Math_fround(f15 * f12);
      HEAPF32[i3 >> 2] = Math_fround(f15 * f10);
      HEAPF32[i14 + 36 >> 2] = f11;
      HEAPF32[i14 + 40 >> 2] = f12;
      HEAPF32[i14 + 44 >> 2] = Math_fround(f15 * f9);
      HEAP32[i14 + 48 >> 2] = HEAP32[i45 >> 2];
      HEAP32[i14 + 52 >> 2] = HEAP32[i21 >> 2];
      i5 = 56;
      i3 = i14 + 56 | 0;
     } else i5 = 32;
     if (i8 >>> 0 > i4 >>> 0) {
      i5 = i14 + (i5 + ((i8 - i4 | 0) * 24 | 0)) | 0;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i52 + (i4 << 6) + 16 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i52 + (i4 << 6) + 20 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i52 + (i4 << 6) + 24 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i52 + (i4 << 6) + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i52 + (i4 << 6) + 48 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i52 + (i4 << 6) + 52 >> 2];
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i8 | 0)) break; else i3 = i3 + 24 | 0;
      }
      i3 = i5;
     }
     i4 = HEAPU16[i13 >> 1] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i49 | 0)) break L47;
     i46 = i20;
     i5 = i18;
     i18 = HEAP16[i54 + (i4 << 2) >> 1] | 0;
     i20 = HEAP16[i54 + (i4 << 2) + 2 >> 1] | 0;
     f10 = f16;
     i14 = i3;
     f9 = f19;
     i7 = i17;
     i3 = i46;
    }
   }
  } while (0);
  if (i23 | 0) {
   i54 = i47 + i48 | 0;
   HEAP16[i55 >> 1] = HEAPU16[i55 >> 1] | 16;
   HEAP32[i51 >> 2] = i54;
   _memset(i54 | 0, 0, i23 | 0) | 0;
  }
  HEAP16[i56 >> 1] = i28;
 }
 if (!(HEAP8[i57 >> 0] | 0)) {
  i58 = i1;
  STACKTOP = i59;
  return i58 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i58, HEAP32[i58 >> 2] | 0);
 i58 = i1;
 STACKTOP = i59;
 return i58 | 0;
}

function _unity_z_deflate(i20, i13) {
 i20 = i20 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 if (!i20) {
  i21 = -2;
  return i21 | 0;
 }
 i18 = i20 + 28 | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 if (i13 >>> 0 > 4 | (i17 | 0) == 0) {
  i21 = -2;
  return i21 | 0;
 }
 i19 = i20 + 12 | 0;
 do if (HEAP32[i19 >> 2] | 0) {
  if (!(HEAP32[i20 >> 2] | 0)) if (HEAP32[i20 + 4 >> 2] | 0) break;
  i14 = i17 + 4 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i15 = (i13 | 0) != 4;
  if (!(i15 & (i1 | 0) == 666)) {
   i21 = i20 + 16 | 0;
   if (!(HEAP32[i21 >> 2] | 0)) {
    HEAP32[i20 + 24 >> 2] = HEAP32[gb + 16328 + 28 >> 2];
    i21 = -5;
    return i21 | 0;
   }
   HEAP32[i17 >> 2] = i20;
   i16 = i17 + 40 | 0;
   i12 = HEAP32[i16 >> 2] | 0;
   HEAP32[i16 >> 2] = i13;
   do if ((i1 | 0) == 42) {
    if ((HEAP32[i17 + 24 >> 2] | 0) != 2) {
     i2 = (HEAP32[i17 + 48 >> 2] << 12) + -30720 | 0;
     if ((HEAP32[i17 + 136 >> 2] | 0) > 1) i1 = 0; else {
      i1 = HEAP32[i17 + 132 >> 2] | 0;
      if ((i1 | 0) < 2) i1 = 0; else if ((i1 | 0) < 6) i1 = 64; else i1 = (i1 | 0) == 6 ? 128 : 192;
     }
     i10 = i1 | i2;
     i11 = i17 + 108 | 0;
     i10 = (HEAP32[i11 >> 2] | 0) == 0 ? i10 : i10 | 32;
     HEAP32[i14 >> 2] = 113;
     i2 = i17 + 20 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     HEAP32[i2 >> 2] = i1 + 1;
     i3 = i17 + 8 | 0;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] = i10 >>> 8;
     i1 = HEAP32[i2 >> 2] | 0;
     HEAP32[i2 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] = ((i10 >>> 0) % 31 | 0 | i10) ^ 31;
     i1 = i20 + 48 | 0;
     if (HEAP32[i11 >> 2] | 0) {
      i11 = HEAP32[i1 >> 2] | 0;
      i10 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 >> 2] = i10 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i11 >>> 24;
      i10 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 >> 2] = i10 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i11 >>> 16;
      i10 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 >> 2] = i11 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i11 >> 0] = i10 >>> 8;
      i11 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 >> 2] = i11 + 1;
      HEAP8[(HEAP32[i3 >> 2] | 0) + i11 >> 0] = i10;
     }
     HEAP32[i1 >> 2] = _unity_z_adler32(0, 0, 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
     i6 = 30;
     break;
    }
    i3 = i20 + 48 | 0;
    HEAP32[i3 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
    i4 = i17 + 20 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i1 + 1;
    i5 = i17 + 8 | 0;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 31;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i1 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = -117;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i1 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 8;
    i1 = i17 + 28 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 0;
     i1 = HEAP32[i17 + 132 >> 2] | 0;
     if ((i1 | 0) == 9) i1 = 2; else i1 = ((i1 | 0) < 2 ? 1 : (HEAP32[i17 + 136 >> 2] | 0) > 1) ? 4 : 0;
     i11 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = i1;
     i11 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = 3;
     HEAP32[i14 >> 2] = 113;
     break;
    }
    i11 = ((HEAP32[i2 + 44 >> 2] | 0 ? 2 : 0) | (HEAP32[i2 >> 2] | 0) != 0 | ((HEAP32[i2 + 16 >> 2] | 0) == 0 ? 0 : 4) | ((HEAP32[i2 + 28 >> 2] | 0) == 0 ? 0 : 8) | ((HEAP32[i2 + 36 >> 2] | 0) == 0 ? 0 : 16)) & 255;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i2 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i2 >> 0] = i11;
    i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] & 255;
    i11 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = i2;
    i11 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0) >>> 8 & 255;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i2 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i2 >> 0] = i11;
    i2 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0) >>> 16 & 255;
    i11 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = i2;
    i11 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0) >>> 24 & 255;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i2 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i2 >> 0] = i11;
    i2 = HEAP32[i17 + 132 >> 2] | 0;
    if ((i2 | 0) == 9) i2 = 2; else i2 = ((i2 | 0) < 2 ? 1 : (HEAP32[i17 + 136 >> 2] | 0) > 1) ? 4 : 0;
    i11 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i11 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = i2;
    i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] & 255;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i2 + 1;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i2 >> 0] = i11;
    i2 = HEAP32[i1 >> 2] | 0;
    if (HEAP32[i2 + 16 >> 2] | 0) {
     i2 = HEAP32[i2 + 20 >> 2] & 255;
     i11 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i11 >> 0] = i2;
     i11 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) >>> 8 & 255;
     i2 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i5 >> 2] | 0) + i2 >> 0] = i11;
     i2 = HEAP32[i1 >> 2] | 0;
    }
    if (HEAP32[i2 + 44 >> 2] | 0) HEAP32[i3 >> 2] = _unity_z_crc32(HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i17 + 32 >> 2] = 0;
    HEAP32[i14 >> 2] = 69;
    i6 = 32;
   } else i6 = 30; while (0);
   if ((i6 | 0) == 30) if ((i1 | 0) == 69) {
    i1 = i17 + 28 | 0;
    i6 = 32;
   } else i6 = 53;
   do if ((i6 | 0) == 32) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!(HEAP32[i2 + 16 >> 2] | 0)) {
     HEAP32[i14 >> 2] = 73;
     i6 = 55;
     break;
    }
    i10 = i17 + 20 | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i11 = i17 + 32 | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    L53 : do if (i5 >>> 0 < (HEAP32[i2 + 20 >> 2] & 65535) >>> 0) {
     i6 = i17 + 12 | 0;
     i7 = i20 + 48 | 0;
     i8 = i17 + 8 | 0;
     i9 = i20 + 20 | 0;
     i4 = i3;
     while (1) {
      if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
       if (i3 >>> 0 > i4 >>> 0 & (HEAP32[i2 + 44 >> 2] | 0) != 0) HEAP32[i7 >> 2] = _unity_z_crc32(HEAP32[i7 >> 2] | 0, (HEAP32[i8 >> 2] | 0) + i4 | 0, i3 - i4 | 0) | 0;
       i2 = HEAP32[i18 >> 2] | 0;
       i4 = HEAP32[i2 + 20 >> 2] | 0;
       i5 = HEAP32[i21 >> 2] | 0;
       i4 = i4 >>> 0 > i5 >>> 0 ? i5 : i4;
       if (i4 | 0) {
        _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i4 | 0) | 0;
        HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i4;
        i2 = HEAP32[i18 >> 2] | 0;
        i3 = i2 + 16 | 0;
        HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
        HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i4;
        HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) - i4;
        i22 = i2 + 20 | 0;
        i5 = (HEAP32[i22 >> 2] | 0) - i4 | 0;
        HEAP32[i22 >> 2] = i5;
        if (!i5) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
       }
       i3 = HEAP32[i10 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) break;
       i4 = i3;
       i2 = HEAP32[i1 >> 2] | 0;
       i5 = HEAP32[i11 >> 2] | 0;
      }
      i5 = HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + i5 >> 0] | 0;
      HEAP32[i10 >> 2] = i3 + 1;
      HEAP8[(HEAP32[i8 >> 2] | 0) + i3 >> 0] = i5;
      i5 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
      HEAP32[i11 >> 2] = i5;
      i2 = HEAP32[i1 >> 2] | 0;
      if (i5 >>> 0 >= (HEAP32[i2 + 20 >> 2] & 65535) >>> 0) break L53;
      i3 = HEAP32[i10 >> 2] | 0;
     }
     i4 = i3;
     i2 = HEAP32[i1 >> 2] | 0;
    } else i4 = i3; while (0);
    if (HEAP32[i2 + 44 >> 2] | 0) {
     i3 = HEAP32[i10 >> 2] | 0;
     if (i3 >>> 0 > i4 >>> 0) {
      i2 = i20 + 48 | 0;
      HEAP32[i2 >> 2] = _unity_z_crc32(HEAP32[i2 >> 2] | 0, (HEAP32[i17 + 8 >> 2] | 0) + i4 | 0, i3 - i4 | 0) | 0;
      i2 = HEAP32[i1 >> 2] | 0;
     }
    }
    if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + 20 >> 2] | 0)) {
     HEAP32[i11 >> 2] = 0;
     HEAP32[i14 >> 2] = 73;
     i6 = 55;
     break;
    } else {
     i1 = HEAP32[i14 >> 2] | 0;
     i6 = 53;
     break;
    }
   } while (0);
   if ((i6 | 0) == 53) if ((i1 | 0) == 73) {
    i2 = i17 + 28 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    i6 = 55;
   } else i6 = 73;
   do if ((i6 | 0) == 55) {
    if (!(HEAP32[i2 + 28 >> 2] | 0)) {
     HEAP32[i14 >> 2] = 91;
     i6 = 75;
     break;
    }
    i7 = i17 + 20 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i5 = i17 + 12 | 0;
    i8 = i20 + 48 | 0;
    i9 = i17 + 8 | 0;
    i6 = i20 + 20 | 0;
    i10 = i17 + 32 | 0;
    i3 = i2;
    while (1) {
     if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
      if (i2 >>> 0 > i3 >>> 0 ? (HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) HEAP32[i8 >> 2] = _unity_z_crc32(HEAP32[i8 >> 2] | 0, (HEAP32[i9 >> 2] | 0) + i3 | 0, i2 - i3 | 0) | 0;
      i2 = HEAP32[i18 >> 2] | 0;
      i4 = HEAP32[i2 + 20 >> 2] | 0;
      i22 = HEAP32[i21 >> 2] | 0;
      i4 = i4 >>> 0 > i22 >>> 0 ? i22 : i4;
      if (i4 | 0) {
       _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i4 | 0) | 0;
       HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i4;
       i2 = HEAP32[i18 >> 2] | 0;
       i3 = i2 + 16 | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
       HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) - i4;
       i11 = i2 + 20 | 0;
       i22 = (HEAP32[i11 >> 2] | 0) - i4 | 0;
       HEAP32[i11 >> 2] = i22;
       if (!i22) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
      }
      i2 = HEAP32[i7 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
       i4 = 1;
       i3 = i2;
       break;
      } else i3 = i2;
     }
     i4 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = i4 + 1;
     i4 = HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0) + i4 >> 0] | 0;
     HEAP32[i7 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i9 >> 2] | 0) + i2 >> 0] = i4;
     if (!(i4 << 24 >> 24)) {
      i4 = i4 & 255;
      break;
     }
     i2 = HEAP32[i7 >> 2] | 0;
    }
    if (HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0) {
     i2 = HEAP32[i7 >> 2] | 0;
     if (i2 >>> 0 > i3 >>> 0) HEAP32[i8 >> 2] = _unity_z_crc32(HEAP32[i8 >> 2] | 0, (HEAP32[i9 >> 2] | 0) + i3 | 0, i2 - i3 | 0) | 0;
    }
    if (!i4) {
     HEAP32[i10 >> 2] = 0;
     HEAP32[i14 >> 2] = 91;
     i6 = 75;
     break;
    } else {
     i1 = HEAP32[i14 >> 2] | 0;
     i6 = 73;
     break;
    }
   } while (0);
   if ((i6 | 0) == 73) if ((i1 | 0) == 91) {
    i1 = i17 + 28 | 0;
    i6 = 75;
   } else i6 = 93;
   do if ((i6 | 0) == 75) {
    if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0)) {
     HEAP32[i14 >> 2] = 103;
     i6 = 95;
     break;
    }
    i8 = i17 + 20 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    i5 = i17 + 12 | 0;
    i9 = i20 + 48 | 0;
    i10 = i17 + 8 | 0;
    i6 = i20 + 20 | 0;
    i7 = i17 + 32 | 0;
    i3 = i2;
    while (1) {
     if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
      if (i2 >>> 0 > i3 >>> 0 ? (HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0) != 0 : 0) HEAP32[i9 >> 2] = _unity_z_crc32(HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) + i3 | 0, i2 - i3 | 0) | 0;
      i2 = HEAP32[i18 >> 2] | 0;
      i4 = HEAP32[i2 + 20 >> 2] | 0;
      i22 = HEAP32[i21 >> 2] | 0;
      i4 = i4 >>> 0 > i22 >>> 0 ? i22 : i4;
      if (i4 | 0) {
       _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i4 | 0) | 0;
       HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i4;
       i2 = HEAP32[i18 >> 2] | 0;
       i3 = i2 + 16 | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
       HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
       HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) - i4;
       i11 = i2 + 20 | 0;
       i22 = (HEAP32[i11 >> 2] | 0) - i4 | 0;
       HEAP32[i11 >> 2] = i22;
       if (!i22) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
      }
      i2 = HEAP32[i8 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
       i4 = 1;
       i3 = i2;
       break;
      } else i3 = i2;
     }
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = i4 + 1;
     i4 = HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0) + i4 >> 0] | 0;
     HEAP32[i8 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i10 >> 2] | 0) + i2 >> 0] = i4;
     if (!(i4 << 24 >> 24)) {
      i4 = i4 & 255;
      break;
     }
     i2 = HEAP32[i8 >> 2] | 0;
    }
    if (HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0) {
     i2 = HEAP32[i8 >> 2] | 0;
     if (i2 >>> 0 > i3 >>> 0) HEAP32[i9 >> 2] = _unity_z_crc32(HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) + i3 | 0, i2 - i3 | 0) | 0;
    }
    if (!i4) {
     HEAP32[i14 >> 2] = 103;
     i6 = 95;
     break;
    } else {
     i1 = HEAP32[i14 >> 2] | 0;
     i6 = 93;
     break;
    }
   } while (0);
   if ((i6 | 0) == 93) if ((i1 | 0) == 103) {
    i1 = i17 + 28 | 0;
    i6 = 95;
   }
   do if ((i6 | 0) == 95) {
    if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0)) {
     HEAP32[i14 >> 2] = 113;
     break;
    }
    i4 = i17 + 20 | 0;
    i5 = i17 + 12 | 0;
    if (((HEAP32[i4 >> 2] | 0) + 2 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
     i1 = HEAP32[i18 >> 2] | 0;
     i3 = HEAP32[i1 + 20 >> 2] | 0;
     i22 = HEAP32[i21 >> 2] | 0;
     i3 = i3 >>> 0 > i22 >>> 0 ? i22 : i3;
     if (i3 | 0) {
      _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0, i3 | 0) | 0;
      HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i3;
      i1 = HEAP32[i18 >> 2] | 0;
      i2 = i1 + 16 | 0;
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
      i11 = i20 + 20 | 0;
      HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i3;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) - i3;
      i11 = i1 + 20 | 0;
      i22 = (HEAP32[i11 >> 2] | 0) - i3 | 0;
      HEAP32[i11 >> 2] = i22;
      if (!i22) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
     }
    }
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 + 2 | 0) >>> 0 <= (HEAP32[i5 >> 2] | 0) >>> 0) {
     i22 = i20 + 48 | 0;
     i9 = HEAP32[i22 >> 2] & 255;
     HEAP32[i4 >> 2] = i1 + 1;
     i10 = i17 + 8 | 0;
     HEAP8[(HEAP32[i10 >> 2] | 0) + i1 >> 0] = i9;
     i9 = (HEAP32[i22 >> 2] | 0) >>> 8 & 255;
     i11 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i11 + 1;
     HEAP8[(HEAP32[i10 >> 2] | 0) + i11 >> 0] = i9;
     HEAP32[i22 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
     HEAP32[i14 >> 2] = 113;
    }
   } while (0);
   i5 = i17 + 20 | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    if (i15 & (i12 | 0) >= (i13 | 0) & (HEAP32[i20 + 4 >> 2] | 0) == 0) {
     HEAP32[i20 + 24 >> 2] = HEAP32[gb + 16328 + 28 >> 2];
     i22 = -5;
     return i22 | 0;
    }
   } else {
    i2 = HEAP32[i18 >> 2] | 0;
    i4 = HEAP32[i2 + 20 >> 2] | 0;
    i1 = HEAP32[i21 >> 2] | 0;
    i4 = i4 >>> 0 > i1 >>> 0 ? i1 : i4;
    if (i4) {
     _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i4 | 0) | 0;
     HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i4;
     i2 = HEAP32[i18 >> 2] | 0;
     i3 = i2 + 16 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
     i1 = i20 + 20 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
     i1 = (HEAP32[i21 >> 2] | 0) - i4 | 0;
     HEAP32[i21 >> 2] = i1;
     i12 = i2 + 20 | 0;
     i22 = (HEAP32[i12 >> 2] | 0) - i4 | 0;
     HEAP32[i12 >> 2] = i22;
     if (!i22) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
    }
    if (!i1) {
     HEAP32[i16 >> 2] = -1;
     i22 = 0;
     return i22 | 0;
    }
   }
   i2 = (HEAP32[i14 >> 2] | 0) == 666;
   i1 = (HEAP32[i20 + 4 >> 2] | 0) == 0;
   if (i2) if (i1) i6 = 115; else {
    HEAP32[i20 + 24 >> 2] = HEAP32[gb + 16328 + 28 >> 2];
    i22 = -5;
    return i22 | 0;
   } else if (i1) i6 = 115; else i6 = 116;
   if ((i6 | 0) == 115) if (!((HEAP32[i17 + 116 >> 2] | 0) == 0 & ((i13 | 0) == 0 | i2))) i6 = 116;
   if ((i6 | 0) == 116) {
    i1 = mftCall_iii(HEAP32[gb + 16368 + ((HEAP32[i17 + 132 >> 2] | 0) * 12 | 0) + 8 >> 2] | 0, i17 | 0, i13 | 0) | 0;
    if ((i1 | 1 | 0) == 3) HEAP32[i14 >> 2] = 666;
    if ((i1 | 2 | 0) == 2) {
     if (HEAP32[i21 >> 2] | 0) {
      i22 = 0;
      return i22 | 0;
     }
     HEAP32[i16 >> 2] = -1;
     i22 = 0;
     return i22 | 0;
    }
    if ((i1 | 0) == 1) {
     if ((i13 | 0) == 1) _unity_z_tr_align(i17); else {
      _unity_z_tr_stored_block(i17, 0, 0, 0);
      if ((i13 | 0) == 3) {
       i22 = HEAP32[i17 + 76 >> 2] | 0;
       i14 = HEAP32[i17 + 68 >> 2] | 0;
       HEAP16[i14 + (i22 + -1 << 1) >> 1] = 0;
       _memset(i14 | 0, 0, (i22 << 1) + -2 | 0) | 0;
      }
     }
     i2 = HEAP32[i18 >> 2] | 0;
     i4 = HEAP32[i2 + 20 >> 2] | 0;
     i1 = HEAP32[i21 >> 2] | 0;
     i4 = i4 >>> 0 > i1 >>> 0 ? i1 : i4;
     if (i4) {
      _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i4 | 0) | 0;
      HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i4;
      i2 = HEAP32[i18 >> 2] | 0;
      i3 = i2 + 16 | 0;
      HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
      i1 = i20 + 20 | 0;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
      i1 = (HEAP32[i21 >> 2] | 0) - i4 | 0;
      HEAP32[i21 >> 2] = i1;
      i14 = i2 + 20 | 0;
      i22 = (HEAP32[i14 >> 2] | 0) - i4 | 0;
      HEAP32[i14 >> 2] = i22;
      if (!i22) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
     }
     if (!i1) {
      HEAP32[i16 >> 2] = -1;
      i22 = 0;
      return i22 | 0;
     }
    }
   }
   if (i15) {
    i22 = 0;
    return i22 | 0;
   }
   i4 = i17 + 24 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) < 1) {
    i22 = 1;
    return i22 | 0;
   }
   i2 = i20 + 48 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == 2) {
    i15 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i15 + 1;
    i17 = i17 + 8 | 0;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i15 >> 0] = i3;
    i15 = (HEAP32[i2 >> 2] | 0) >>> 8 & 255;
    i16 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i16 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = i15;
    i16 = (HEAP32[i2 >> 2] | 0) >>> 16 & 255;
    i15 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i15 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i15 >> 0] = i16;
    i15 = (HEAP32[i2 >> 2] | 0) >>> 24 & 255;
    i16 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i16 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = i15;
    i16 = i20 + 8 | 0;
    i15 = HEAP32[i16 >> 2] & 255;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i22 >> 0] = i15;
    i22 = (HEAP32[i16 >> 2] | 0) >>> 8 & 255;
    i15 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i15 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i15 >> 0] = i22;
    i15 = (HEAP32[i16 >> 2] | 0) >>> 16 & 255;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i22 >> 0] = i15;
    i16 = (HEAP32[i16 >> 2] | 0) >>> 24 & 255;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i22 >> 0] = i16;
   } else {
    i16 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i16 + 1;
    i17 = i17 + 8 | 0;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = i3 >>> 24;
    i16 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i16 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = i3 >>> 16;
    i16 = HEAP32[i2 >> 2] | 0;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i22 >> 0] = i16 >>> 8;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i22 + 1;
    HEAP8[(HEAP32[i17 >> 2] | 0) + i22 >> 0] = i16;
   }
   i1 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   i22 = HEAP32[i21 >> 2] | 0;
   i3 = i3 >>> 0 > i22 >>> 0 ? i22 : i3;
   if (i3 | 0) {
    _memcpy(HEAP32[i19 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0, i3 | 0) | 0;
    HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i3;
    i1 = HEAP32[i18 >> 2] | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
    i22 = i20 + 20 | 0;
    HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i3;
    HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) - i3;
    i21 = i1 + 20 | 0;
    i22 = (HEAP32[i21 >> 2] | 0) - i3 | 0;
    HEAP32[i21 >> 2] = i22;
    if (!i22) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
   }
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) > 0) HEAP32[i4 >> 2] = 0 - i1;
   i22 = (HEAP32[i5 >> 2] | 0) == 0 & 1;
   return i22 | 0;
  }
 } while (0);
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 16328 + 16 >> 2];
 i22 = -2;
 return i22 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI14SafeBinaryReadEEvRT_(i17, i15) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 40 | 0;
 i12 = i23 + 24 | 0;
 i18 = i23 + 20 | 0;
 i19 = i23 + 16 | 0;
 i22 = i23;
 i20 = i17 + 28 | 0;
 i13 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944604 | 0, i13, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 6; else {
     HEAP32[i20 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i20, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i20 >> 2] = _llvm_bswap_i32(HEAP32[i20 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i20 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 16 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944623 | 0, i6, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944634 | 0, i13, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944653 | 0, i13, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944672 | 0, i13, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if ((HEAP32[i4 >> 2] | 0) == -2) {
  HEAP32[i12 >> 2] = 0;
  i4 = i12 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i5 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944686 | 0, i5, i21, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i15, i12, 0); else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i12 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~(((i3 + -60 - i2 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i16 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = 1;
   HEAP32[i21 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
  }
 } else {
  i2 = i17 + 40 | 0;
  i3 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944686 | 0, i3, i21, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i5 = i3;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944703 | 0, HEAP32[gb + 37052 >> 2] | 0, i21, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS2_9allocatorINS3_IS4_fEEEEEEEvRT_17TransferMetaFlags(i15, i17, 0); else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i17 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i11 = i17 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944719 | 0, i6, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 86; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 86; else {
     HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 86) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i17 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944732 | 0, i5, i21, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944743 | 0, i6, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 103; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 103; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 103) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i15, 4) | 0) {
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i17 + 196 >> 2] = Math_fround(f10 - Math_fround(HEAPF32[(HEAP32[i17 + 76 >> 2] | 0) + 32 >> 2]));
 } else {
  i4 = i17 + 196 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944752 | 0, i6, i21, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i16 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i16 >>> 0) i14 = 116; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 116; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i14 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
 }
 i4 = i17 + 188 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944762 | 0, HEAP32[gb + 37304 >> 2] | 0, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i16 >>> 0) i14 = 128; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i14 = 128; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i14 | 0) == 128) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i17 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944777 | 0, i5, i21, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i17 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944789 | 0, i5, i21, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS6_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i17 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944805 | 0, i13, i21, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i16 >>> 0) i14 = 151; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
     i14 = 151;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i14 | 0) == 151) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i15, 3) | 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944825 | 0, HEAP32[gb + 36972 >> 2] | 0, i21, 0) | 0;
 if (i1 | 0) {
  L218 : do if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i16 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i16 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i12 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = i3;
    break L218;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i12, 1);
  } else {
   i1 = HEAP32[i21 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i12 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if (HEAP8[i12 >> 0] | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944836 | 0, i13, i21, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i16 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i16 >>> 0) i14 = 173; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i14 = 173;
      break;
     }
     HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i14 | 0) == 173) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i18, 4);
    if (!(HEAP32[i15 >> 2] & 512)) break;
    HEAP32[i18 >> 2] = _llvm_bswap_i32(HEAP32[i18 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i18 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944849 | 0, i13, i21, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i16 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i16 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i16 >>> 0) i14 = 184; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i14 = 184;
      break;
     }
     HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i14 | 0) == 184) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i19, 4);
    if (!(HEAP32[i15 >> 2] & 512)) break;
    HEAP32[i19 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i19 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  HEAPF32[i11 >> 2] = Math_fround(0 - (HEAP32[i18 >> 2] | 0) | 0);
  HEAP32[i22 >> 2] = 0;
  i16 = i22 + 4 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 944862 | 0, i5, i21, 1) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_4pairIifEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i15, i22, 0); else {
    i1 = HEAP32[i21 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i22 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i2 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  if ((Math_imul(i1, i2) | 0) > 0) {
   i13 = i17 + 40 | 0;
   i14 = i17 + 52 | 0;
   i15 = i17 + 56 | 0;
   i12 = i17 + 44 | 0;
   i11 = 0;
   do {
    f8 = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
    f7 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
    f10 = Math_fround(f8 * Math_fround((((i11 | 0) % (i2 | 0) | 0) & 65535) << 16 >> 16));
    f9 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround((((i11 | 0) / (i2 | 0) | 0) & 65535) << 16 >> 16) * f7));
    f7 = Math_fround(f9 - f7);
    f8 = Math_fround(Math_fround(f8 + f10) - f10);
    f9 = Math_fround(f9 - f7);
    i1 = HEAP32[i22 >> 2] | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) i2 = 1065353216; else {
     i4 = HEAP32[i20 >> 2] | 0;
     i2 = 1065353216;
     do {
      if (((HEAP32[i1 >> 2] | 0) - i4 | 0) == (i11 | 0)) i2 = HEAP32[i1 + 4 >> 2] | 0;
      i1 = i1 + 8 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    i3 = HEAP32[i14 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 >= i1 >>> 0) break;
     if ((i5 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 * 60 | 0, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 60 | 0, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i17 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i14 >> 2] | 0) * 60 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i13 >> 2] = i17;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i4;
    i1 = HEAP32[i13 >> 2] | 0;
    HEAP32[i1 + (i3 * 60 | 0) >> 2] = i11;
    HEAPF32[i1 + (i3 * 60 | 0) + 4 >> 2] = f10;
    HEAPF32[i1 + (i3 * 60 | 0) + 8 >> 2] = f7;
    HEAPF32[i1 + (i3 * 60 | 0) + 12 >> 2] = f8;
    HEAPF32[i1 + (i3 * 60 | 0) + 16 >> 2] = f9;
    HEAPF32[i1 + (i3 * 60 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i3 * 60 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + (i3 * 60 | 0) + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + (i3 * 60 | 0) + 32 >> 2] = Math_fround(-1.0);
    HEAP32[i1 + (i3 * 60 | 0) + 36 >> 2] = i2;
    i2 = i1 + (i3 * 60 | 0) + 40 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAPF32[i1 + (i3 * 60 | 0) + 48 >> 2] = Math_fround(1.0);
    HEAP32[i1 + (i3 * 60 | 0) + 52 >> 2] = 0;
    HEAP8[i1 + (i3 * 60 | 0) + 56 >> 0] = 0;
    i2 = i1 + (i3 * 60 | 0) + 57 | 0;
    HEAP8[i2 >> 0] = HEAP8[i21 >> 0] | 0;
    HEAP8[i2 + 1 >> 0] = HEAP8[i21 + 1 >> 0] | 0;
    HEAP8[i2 + 2 >> 0] = HEAP8[i21 + 2 >> 0] | 0;
    i11 = i11 + 1 | 0;
    i2 = HEAP32[i18 >> 2] | 0;
    i1 = HEAP32[i19 >> 2] | 0;
   } while ((i11 | 0) < (Math_imul(i1, i2) | 0));
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i16 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i16 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
   i22 = HEAP32[i22 + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = 34;
   HEAP32[i21 + 4 >> 2] = i22;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
  }
 }
 STACKTOP = i23;
 return;
}

function __ZN5physx40setupFinalizeExtSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhffRNS_16PxsSolverExtBodyESE_jffff(i5, i105, i106, i68, i69, i1, i81, f55, f15, i103, i104, i107, f4, f7, f6, f8) {
 i5 = i5 | 0;
 i105 = i105 | 0;
 i106 = i106 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i1 = i1 | 0;
 i81 = i81 | 0;
 f55 = Math_fround(f55);
 f15 = Math_fround(f15);
 i103 = i103 | 0;
 i104 = i104 | 0;
 i107 = i107 | 0;
 f4 = Math_fround(f4);
 f7 = Math_fround(f7);
 f6 = Math_fround(f6);
 f8 = Math_fround(f8);
 var f2 = f0, i3 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, f86 = f0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i108 = 0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0;
 i108 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i65 = i108 + 376 | 0;
 i66 = i108 + 364 | 0;
 i67 = i108 + 352 | 0;
 i63 = i108 + 224 | 0;
 i64 = i108 + 192 | 0;
 i61 = i108 + 160 | 0;
 i62 = i108 + 128 | 0;
 i98 = i108 + 340 | 0;
 i99 = i108 + 328 | 0;
 i102 = i108 + 316 | 0;
 i92 = i108 + 304 | 0;
 i93 = i108 + 292 | 0;
 i100 = i108 + 280 | 0;
 i101 = i108 + 256 | 0;
 i96 = i108 + 96 | 0;
 i97 = i108 + 64 | 0;
 i94 = i108 + 32 | 0;
 i95 = i108;
 i3 = HEAP16[i103 + 8 >> 1] | 0;
 if (i3 << 16 >> 16 == -1) i1 = (HEAP32[i103 + 4 >> 2] | 0) + 52 | 0; else {
  i1 = HEAP32[i103 >> 2] | 0;
  i1 = i1 + 128 + ((HEAPU16[i1 + 8 >> 1] | 0) * 80 | 0) + ((i3 & 65535) << 2) | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if ((HEAP16[i104 + 8 >> 1] | 0) == -1) i1 = (HEAP32[i104 + 4 >> 2] | 0) + 52 | 0; else {
  i1 = HEAP32[i104 >> 2] | 0;
  i1 = i1 + 128 + ((HEAPU16[i1 + 8 >> 1] | 0) * 80 | 0) + ((i3 & 65535) << 2) | 0;
 }
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround((f2 > f13 ? f2 : f13) / f55);
 f14 = Math_fround(HEAPF32[i5 + 92 >> 2]);
 i3 = HEAPU16[i5 + 22 >> 1] | 0;
 i1 = (i3 & 24 | 0) != 0;
 i89 = HEAP32[i106 + 1796 >> 2] | 0;
 i3 = i3 >>> 6;
 i90 = i1 ? 112 : 80;
 i91 = i1 ? 128 : 96;
 if (i1) i60 = 3; else i60 = (i3 << 2 & 4 ^ 5) & 255;
 i87 = i1 ? 12 : (i3 & 1 ^ 11) & 255;
 i88 = i5 + 84 | 0;
 f83 = Math_fround(HEAPF32[i88 >> 2]);
 f86 = Math_fround(f83 * f4);
 i85 = i5 + 88 | 0;
 f82 = Math_fround(HEAPF32[i85 >> 2]);
 f84 = Math_fround(f82 * f6);
 f83 = Math_fround(f83 * f7);
 f82 = Math_fround(f82 * f8);
 i54 = (i89 | 0) == 0;
 if (i54) {
  i107 = 0;
  STACKTOP = i108;
  return i107 | 0;
 }
 i22 = i65 + 4 | 0;
 i23 = i65 + 8 | 0;
 i24 = i68 + 16 | 0;
 i25 = i68 + 20 | 0;
 i26 = i68 + 24 | 0;
 i27 = i69 + 16 | 0;
 i28 = i69 + 20 | 0;
 i29 = i69 + 24 | 0;
 i30 = i66 + 4 | 0;
 i31 = i66 + 8 | 0;
 i32 = i67 + 4 | 0;
 i33 = i67 + 8 | 0;
 i34 = i61 + 4 | 0;
 i35 = i61 + 8 | 0;
 i36 = i61 + 12 | 0;
 i37 = i61 + 20 | 0;
 i38 = i61 + 24 | 0;
 i39 = i61 + 28 | 0;
 i40 = i62 + 4 | 0;
 i41 = i62 + 8 | 0;
 i42 = i62 + 12 | 0;
 i43 = i62 + 16 | 0;
 i44 = i62 + 20 | 0;
 i45 = i62 + 24 | 0;
 i46 = i62 + 28 | 0;
 i47 = i63 + 16 | 0;
 i48 = i63 + 20 | 0;
 i49 = i63 + 24 | 0;
 i50 = i63 + 4 | 0;
 i51 = i63 + 8 | 0;
 i52 = i64 + 16 | 0;
 i17 = i64 + 20 | 0;
 i18 = i64 + 24 | 0;
 i19 = i64 + 4 | 0;
 i20 = i64 + 8 | 0;
 i21 = i61 + 16 | 0;
 i53 = 0;
 i5 = i81;
 while (1) {
  i3 = HEAP32[i106 + 1408 + (i53 << 2) >> 2] | 0;
  if (!i3) i1 = i5; else {
   i80 = i106 + 1536 + (i53 << 2) | 0;
   i79 = HEAPU16[i106 + ((HEAP32[i80 >> 2] | 0) * 12 | 0) >> 1] | 0;
   i9 = HEAP32[i106 + 768 + (i53 * 20 | 0) >> 2] | 0;
   i10 = HEAP32[i106 + 768 + (i53 * 20 | 0) + 4 >> 2] | 0;
   i11 = HEAP32[i106 + 768 + (i53 * 20 | 0) + 8 >> 2] | 0;
   HEAP32[i65 >> 2] = i9;
   HEAP32[i22 >> 2] = i10;
   HEAP32[i23 >> 2] = i11;
   i79 = HEAP32[i105 + (i79 << 6) + 60 >> 2] | 0;
   i1 = i5 + 48 | 0;
   HEAP8[i5 + 1 >> 0] = i3;
   HEAP8[i5 >> 0] = i60;
   i16 = i5 + 4 | 0;
   HEAP32[i16 >> 2] = i79;
   HEAPF32[i5 + 8 >> 2] = f86;
   HEAPF32[i5 + 12 >> 2] = f84;
   HEAPF32[i5 + 28 >> 2] = f83;
   HEAPF32[i5 + 32 >> 2] = f82;
   HEAP32[i5 + 16 >> 2] = i9;
   HEAP32[i5 + 20 >> 2] = i10;
   HEAP32[i5 + 24 >> 2] = i11;
   i3 = HEAP32[i80 >> 2] | 0;
   if ((i3 | 0) != 65535) {
    f6 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f2 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i12 = i3;
    while (1) {
     i3 = HEAP16[i106 + (i12 * 12 | 0) + 2 >> 1] | 0;
     i11 = HEAPU16[i106 + (i12 * 12 | 0) >> 1] | 0;
     if (i3 << 16 >> 16) {
      i3 = i3 & 65535;
      i5 = Math_imul(i90, i3) | 0;
      i9 = 0;
      i10 = i1;
      while (1) {
       i78 = i9 + i11 | 0;
       f111 = Math_fround(HEAPF32[i105 + (i78 << 6) + 12 >> 2]);
       f112 = Math_fround(HEAPF32[i105 + (i78 << 6) + 16 >> 2]);
       f59 = Math_fround(f112 - Math_fround(HEAPF32[i24 >> 2]));
       f57 = Math_fround(HEAPF32[i105 + (i78 << 6) + 20 >> 2]);
       f109 = Math_fround(f57 - Math_fround(HEAPF32[i25 >> 2]));
       f56 = Math_fround(HEAPF32[i105 + (i78 << 6) + 24 >> 2]);
       f110 = Math_fround(f56 - Math_fround(HEAPF32[i26 >> 2]));
       f112 = Math_fround(f112 - Math_fround(HEAPF32[i27 >> 2]));
       f57 = Math_fround(f57 - Math_fround(HEAPF32[i28 >> 2]));
       f56 = Math_fround(f56 - Math_fround(HEAPF32[i29 >> 2]));
       f7 = Math_fround(HEAPF32[i105 + (i78 << 6) + 32 >> 2]);
       f8 = Math_fround(HEAPF32[i105 + (i78 << 6) + 36 >> 2]);
       f58 = Math_fround(HEAPF32[i105 + (i78 << 6) + 40 >> 2]);
       i78 = HEAP32[i105 + (i78 << 6) + 28 >> 2] | 0;
       f111 = Math_fround(f111 - f14);
       f58 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f4 * f8)) + Math_fround(f2 * f58));
       i79 = i10 + 32 | 0;
       HEAPF32[i79 >> 2] = f13 > f111 ? f13 : f111;
       i80 = i10 + 36 | 0;
       HEAPF32[i80 >> 2] = f58;
       HEAP32[i10 + 40 >> 2] = i78;
       HEAPF32[i10 + 44 >> 2] = Math_fround(0.0);
       f58 = Math_fround(HEAPF32[i23 >> 2]);
       f111 = Math_fround(f109 * f58);
       f8 = Math_fround(HEAPF32[i22 >> 2]);
       f111 = Math_fround(f111 - Math_fround(f110 * f8));
       f7 = Math_fround(HEAPF32[i65 >> 2]);
       f110 = Math_fround(Math_fround(f110 * f7) - Math_fround(f59 * f58));
       f109 = Math_fround(Math_fround(f59 * f8) - Math_fround(f109 * f7));
       HEAPF32[i66 >> 2] = f111;
       HEAPF32[i30 >> 2] = f110;
       HEAPF32[i31 >> 2] = f109;
       f59 = Math_fround(Math_fround(f57 * f58) - Math_fround(f56 * f8));
       f56 = Math_fround(Math_fround(f56 * f7) - Math_fround(f112 * f58));
       f57 = Math_fround(Math_fround(f112 * f8) - Math_fround(f57 * f7));
       HEAPF32[i67 >> 2] = f59;
       HEAPF32[i32 >> 2] = f56;
       HEAPF32[i33 >> 2] = f57;
       HEAPF32[i61 >> 2] = f7;
       HEAPF32[i34 >> 2] = f8;
       HEAPF32[i35 >> 2] = f58;
       HEAPF32[i36 >> 2] = Math_fround(0.0);
       HEAPF32[i21 >> 2] = f111;
       HEAPF32[i37 >> 2] = f110;
       HEAPF32[i38 >> 2] = f109;
       HEAPF32[i39 >> 2] = Math_fround(0.0);
       f8 = Math_fround(-f8);
       f58 = Math_fround(-f58);
       f59 = Math_fround(-f59);
       f56 = Math_fround(-f56);
       f57 = Math_fround(-f57);
       HEAPF32[i62 >> 2] = Math_fround(-f7);
       HEAPF32[i40 >> 2] = f8;
       HEAPF32[i41 >> 2] = f58;
       HEAPF32[i42 >> 2] = Math_fround(0.0);
       HEAPF32[i43 >> 2] = f59;
       HEAPF32[i44 >> 2] = f56;
       HEAPF32[i45 >> 2] = f57;
       HEAPF32[i46 >> 2] = Math_fround(0.0);
       f57 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i103, i61, i63, f86, f83, i104, i62, i64, f84, f82, 0));
       f56 = Math_fround(__ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_(i103, i65, i66));
       f56 = Math_fround(f56 - Math_fround(__ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_(i104, i65, i67)));
       i78 = HEAP32[i30 >> 2] | 0;
       i77 = HEAP32[i31 >> 2] | 0;
       HEAP32[i10 >> 2] = HEAP32[i66 >> 2];
       HEAP32[i10 + 4 >> 2] = i78;
       HEAP32[i10 + 8 >> 2] = i77;
       i77 = HEAP32[i32 >> 2] | 0;
       i78 = HEAP32[i33 >> 2] | 0;
       HEAP32[i10 + 16 >> 2] = HEAP32[i67 >> 2];
       HEAP32[i10 + 20 >> 2] = i77;
       HEAP32[i10 + 24 >> 2] = i78;
       f59 = Math_fround(HEAPF32[i16 >> 2]);
       i78 = f57 != Math_fround(0.0);
       f57 = Math_fround(Math_fround(1.0) / f57);
       f57 = i78 ? f57 : Math_fround(0.0);
       f58 = Math_fround(Math_fround(Math_fround(HEAPF32[i79 >> 2]) * Math_fround(f57 * Math_fround(.800000011))) * f55);
       i78 = f56 < f15 & f59 > Math_fround(0.0);
       f59 = Math_fround(-Math_fround(f56 * f59));
       f58 = i78 ? Math_fround(0.0) : f58;
       f59 = i78 ? f59 : Math_fround(0.0);
       HEAPF32[i10 + 28 >> 2] = f57;
       HEAPF32[i79 >> 2] = f58;
       HEAPF32[i80 >> 2] = f59;
       HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
       i80 = HEAP32[i47 >> 2] | 0;
       i79 = HEAP32[i48 >> 2] | 0;
       i78 = HEAP32[i49 >> 2] | 0;
       HEAP32[i10 + 80 >> 2] = HEAP32[i63 >> 2];
       HEAP32[i10 + 84 >> 2] = HEAP32[i50 >> 2];
       HEAP32[i10 + 88 >> 2] = HEAP32[i51 >> 2];
       HEAPF32[i10 + 92 >> 2] = Math_fround(0.0);
       HEAP32[i10 + 48 >> 2] = i80;
       HEAP32[i10 + 52 >> 2] = i79;
       HEAP32[i10 + 56 >> 2] = i78;
       HEAPF32[i10 + 60 >> 2] = Math_fround(0.0);
       i78 = HEAP32[i52 >> 2] | 0;
       i79 = HEAP32[i17 >> 2] | 0;
       i80 = HEAP32[i18 >> 2] | 0;
       HEAP32[i10 + 96 >> 2] = HEAP32[i64 >> 2];
       HEAP32[i10 + 100 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i10 + 104 >> 2] = HEAP32[i20 >> 2];
       HEAPF32[i10 + 108 >> 2] = Math_fround(0.0);
       HEAP32[i10 + 64 >> 2] = i78;
       HEAP32[i10 + 68 >> 2] = i79;
       HEAP32[i10 + 72 >> 2] = i80;
       HEAPF32[i10 + 76 >> 2] = Math_fround(0.0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i3 | 0)) break; else i10 = i10 + i90 | 0;
      }
      i1 = i1 + i5 | 0;
     }
     i3 = HEAP16[i106 + (i12 * 12 | 0) + 4 >> 1] | 0;
     if (i3 << 16 >> 16 == -1) break; else i12 = i3 & 65535;
    }
   }
  }
  i53 = i53 + 1 | 0;
  if ((i53 | 0) == (i89 | 0)) {
   i3 = i1;
   break;
  } else i5 = i1;
 }
 if (i54) {
  i107 = 0;
  STACKTOP = i108;
  return i107 | 0;
 }
 i60 = i98 + 4 | 0;
 i61 = i98 + 8 | 0;
 i62 = i99 + 4 | 0;
 i63 = i99 + 8 | 0;
 i64 = i102 + 4 | 0;
 i65 = i102 + 8 | 0;
 i66 = i92 + 4 | 0;
 i67 = i93 + 4 | 0;
 i70 = i92 + 8 | 0;
 i71 = i93 + 8 | 0;
 i72 = i100 + 4 | 0;
 i73 = i100 + 8 | 0;
 i74 = i101 + 4 | 0;
 i75 = i101 + 8 | 0;
 i76 = i101 + 12 | 0;
 i77 = i101 + 16 | 0;
 i78 = i101 + 20 | 0;
 i79 = i68 + 16 | 0;
 i80 = i68 + 20 | 0;
 i52 = i68 + 24 | 0;
 i53 = i69 + 16 | 0;
 i54 = i69 + 20 | 0;
 i24 = i69 + 24 | 0;
 i25 = (i107 | 0) == 0;
 i26 = i94 + 4 | 0;
 i27 = i94 + 8 | 0;
 i28 = i94 + 12 | 0;
 i29 = i94 + 16 | 0;
 i30 = i94 + 20 | 0;
 i31 = i94 + 24 | 0;
 i32 = i94 + 28 | 0;
 i33 = i95 + 4 | 0;
 i34 = i95 + 8 | 0;
 i35 = i95 + 12 | 0;
 i36 = i95 + 16 | 0;
 i37 = i95 + 20 | 0;
 i38 = i95 + 24 | 0;
 i39 = i95 + 28 | 0;
 i40 = i96 + 16 | 0;
 i41 = i96 + 20 | 0;
 i42 = i96 + 24 | 0;
 i43 = i96 + 4 | 0;
 i44 = i96 + 8 | 0;
 i45 = i97 + 16 | 0;
 i46 = i97 + 20 | 0;
 i47 = i97 + 24 | 0;
 i48 = i97 + 4 | 0;
 i49 = i97 + 8 | 0;
 i50 = Math_imul(i91, i107) | 0;
 i1 = 0;
 i51 = 0;
 i16 = i3;
 i3 = i81;
 while (1) {
  i9 = HEAP32[i106 + 1408 + (i51 << 2) >> 2] | 0;
  if (!i9) i5 = i16; else {
   HEAP16[i3 + 2 >> 1] = i16 - i3;
   i3 = i3 + ((Math_imul(HEAPU8[i3 + 1 >> 0] | 0, i90) | 0) + 48) | 0;
   f13 = Math_fround(HEAPF32[i106 + 768 + (i51 * 20 | 0) >> 2]);
   f14 = Math_fround(HEAPF32[i106 + 768 + (i51 * 20 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i106 + 768 + (i51 * 20 | 0) + 8 >> 2]);
   i10 = i106 + 1536 + (i51 << 2) | 0;
   i12 = HEAPU16[i106 + ((HEAP32[i10 >> 2] | 0) * 12 | 0) >> 1] | 0;
   i11 = HEAP32[i105 + (i12 << 6) + 44 >> 2] | 0;
   i12 = (HEAP32[i105 + (i12 << 6) + 52 >> 2] & 1 | 0) == 0;
   HEAP8[i16 + 1 >> 0] = i9;
   if (i12) i5 = HEAPU16[i106 + 768 + (i51 * 20 | 0) + 16 >> 1] | 0; else i5 = 0;
   HEAP8[i16 + 2 >> 0] = i5;
   i5 = i16 + ((i9 << 2) + 44 & -16) | 0;
   f7 = Math_fround(-f15);
   HEAPF32[i98 >> 2] = Math_fround(0.0);
   HEAPF32[i60 >> 2] = f7;
   HEAPF32[i61 >> 2] = f14;
   HEAPF32[i99 >> 2] = Math_fround(-f14);
   HEAPF32[i62 >> 2] = f13;
   HEAPF32[i63 >> 2] = Math_fround(0.0);
   i81 = Math_fround(Math_abs(Math_fround(f13))) < Math_fround(.707106769);
   i81 = i81 ? i98 : i99;
   HEAP32[i102 >> 2] = HEAP32[i81 >> 2];
   HEAP32[i64 >> 2] = HEAP32[i81 + 4 >> 2];
   HEAP32[i65 >> 2] = HEAP32[i81 + 8 >> 2];
   __ZNK5physx16PxsSolverExtBody9getLinVelEv(i92, i103);
   __ZNK5physx16PxsSolverExtBody9getLinVelEv(i93, i104);
   f7 = Math_fround(HEAPF32[i92 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i93 >> 2]));
   f4 = Math_fround(HEAPF32[i66 >> 2]);
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i67 >> 2]));
   f2 = Math_fround(HEAPF32[i70 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i71 >> 2]));
   f8 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f14 * f4)) + Math_fround(f15 * f2));
   f7 = Math_fround(f7 - Math_fround(f13 * f8));
   f4 = Math_fround(f4 - Math_fround(f14 * f8));
   f8 = Math_fround(f2 - Math_fround(f15 * f8));
   HEAPF32[i100 >> 2] = f7;
   HEAPF32[i72 >> 2] = f4;
   HEAPF32[i73 >> 2] = f8;
   i81 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)) + Math_fround(f8 * f8)) > Math_fround(9.99999974e-06);
   i81 = i81 ? i100 : i102;
   f8 = Math_fround(HEAPF32[i81 >> 2]);
   f4 = Math_fround(f8 * f8);
   f7 = Math_fround(HEAPF32[i81 + 4 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f7 * f7));
   f2 = Math_fround(HEAPF32[i81 + 8 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f2 * f2));
   if (f4 > Math_fround(0.0)) {
    f112 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
    f6 = Math_fround(f2 * f112);
    f4 = Math_fround(f7 * f112);
    f2 = Math_fround(f8 * f112);
   } else {
    f6 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f2 = Math_fround(0.0);
   }
   f110 = Math_fround(Math_fround(f15 * f4) - Math_fround(f14 * f6));
   f111 = Math_fround(Math_fround(f13 * f6) - Math_fround(f15 * f2));
   f112 = Math_fround(Math_fround(f14 * f2) - Math_fround(f13 * f4));
   HEAPF32[i101 >> 2] = f2;
   HEAPF32[i74 >> 2] = f4;
   HEAPF32[i75 >> 2] = f6;
   HEAPF32[i76 >> 2] = f110;
   HEAPF32[i77 >> 2] = f111;
   HEAPF32[i78 >> 2] = f112;
   if (i12) {
    HEAP32[i16 + 4 >> 2] = i11;
    HEAP32[i16 + 8 >> 2] = HEAP32[i88 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i85 >> 2];
    HEAPF32[i16 + 16 >> 2] = f83;
    HEAPF32[i16 + 20 >> 2] = f82;
    HEAP8[i16 >> 0] = i87;
    i1 = HEAP32[i10 >> 2] | 0;
    if ((i1 | 0) == 65535) i1 = 1; else {
     i9 = 0;
     i23 = 0;
     while (1) {
      i22 = i106 + (i1 * 12 | 0) + 2 | 0;
      i10 = HEAP16[i22 >> 1] | 0;
      i21 = HEAPU16[i106 + (i1 * 12 | 0) >> 1] | 0;
      if (!(i10 << 16 >> 16 == 0 | i25)) {
       i20 = i10 & 65535;
       i19 = 0;
       do {
        i18 = i19 + i23 | 0;
        i16 = i19 + i21 | 0;
        f59 = Math_fround(HEAPF32[i105 + (i16 << 6) + 16 >> 2]);
        f56 = Math_fround(f59 - Math_fround(HEAPF32[i79 >> 2]));
        f57 = Math_fround(HEAPF32[i105 + (i16 << 6) + 20 >> 2]);
        f15 = Math_fround(f57 - Math_fround(HEAPF32[i80 >> 2]));
        f58 = Math_fround(HEAPF32[i105 + (i16 << 6) + 24 >> 2]);
        f55 = Math_fround(f58 - Math_fround(HEAPF32[i52 >> 2]));
        f59 = Math_fround(f59 - Math_fround(HEAPF32[i53 >> 2]));
        f57 = Math_fround(f57 - Math_fround(HEAPF32[i54 >> 2]));
        f58 = Math_fround(f58 - Math_fround(HEAPF32[i24 >> 2]));
        i16 = 0;
        i17 = i5;
        while (1) {
         HEAP32[i17 + 80 >> 2] = i18;
         i10 = HEAP32[i101 + (i9 * 12 | 0) >> 2] | 0;
         i11 = HEAP32[i101 + (i9 * 12 | 0) + 4 >> 2] | 0;
         i12 = HEAP32[i101 + (i9 * 12 | 0) + 8 >> 2] | 0;
         i9 = 1 - i9 | 0;
         f110 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f2 = Math_fround(f15 * f110);
         f109 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f2 = Math_fround(f2 - Math_fround(f55 * f109));
         f113 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f4 = Math_fround(Math_fround(f55 * f113) - Math_fround(f56 * f110));
         f6 = Math_fround(Math_fround(f56 * f109) - Math_fround(f15 * f113));
         f7 = Math_fround(Math_fround(f57 * f110) - Math_fround(f58 * f109));
         f8 = Math_fround(Math_fround(f58 * f113) - Math_fround(f59 * f110));
         f13 = Math_fround(Math_fround(f59 * f109) - Math_fround(f57 * f113));
         HEAP32[i94 >> 2] = i10;
         HEAP32[i26 >> 2] = i11;
         HEAP32[i27 >> 2] = i12;
         HEAPF32[i28 >> 2] = Math_fround(0.0);
         HEAPF32[i29 >> 2] = f2;
         HEAPF32[i30 >> 2] = f4;
         HEAPF32[i31 >> 2] = f6;
         HEAPF32[i32 >> 2] = Math_fround(0.0);
         f109 = Math_fround(-f109);
         f110 = Math_fround(-f110);
         f111 = Math_fround(-f7);
         f112 = Math_fround(-f8);
         f14 = Math_fround(-f13);
         HEAPF32[i95 >> 2] = Math_fround(-f113);
         HEAPF32[i33 >> 2] = f109;
         HEAPF32[i34 >> 2] = f110;
         HEAPF32[i35 >> 2] = Math_fround(0.0);
         HEAPF32[i36 >> 2] = f111;
         HEAPF32[i37 >> 2] = f112;
         HEAPF32[i38 >> 2] = f14;
         HEAPF32[i39 >> 2] = Math_fround(0.0);
         f14 = Math_fround(__ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i103, i94, i96, f86, f83, i104, i95, i97, f84, f82, 0));
         i81 = f14 > Math_fround(0.0);
         f14 = Math_fround(Math_fround(1.0) / f14);
         HEAP32[i17 + 28 >> 2] = i81 ? (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) : 0;
         HEAPF32[i17 + 16 >> 2] = f2;
         HEAPF32[i17 + 20 >> 2] = f4;
         HEAPF32[i17 + 24 >> 2] = f6;
         HEAPF32[i17 + 32 >> 2] = f7;
         HEAPF32[i17 + 36 >> 2] = f8;
         HEAPF32[i17 + 40 >> 2] = f13;
         HEAP32[i17 >> 2] = i10;
         HEAP32[i17 + 4 >> 2] = i11;
         HEAP32[i17 + 8 >> 2] = i12;
         HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
         i81 = HEAP32[i40 >> 2] | 0;
         i69 = HEAP32[i41 >> 2] | 0;
         i68 = HEAP32[i42 >> 2] | 0;
         HEAP32[i17 + 96 >> 2] = HEAP32[i96 >> 2];
         HEAP32[i17 + 100 >> 2] = HEAP32[i43 >> 2];
         HEAP32[i17 + 104 >> 2] = HEAP32[i44 >> 2];
         HEAPF32[i17 + 108 >> 2] = Math_fround(0.0);
         HEAP32[i17 + 48 >> 2] = i81;
         HEAP32[i17 + 52 >> 2] = i69;
         HEAP32[i17 + 56 >> 2] = i68;
         HEAPF32[i17 + 60 >> 2] = Math_fround(0.0);
         i68 = HEAP32[i45 >> 2] | 0;
         i69 = HEAP32[i46 >> 2] | 0;
         i81 = HEAP32[i47 >> 2] | 0;
         HEAP32[i17 + 112 >> 2] = HEAP32[i97 >> 2];
         HEAP32[i17 + 116 >> 2] = HEAP32[i48 >> 2];
         HEAP32[i17 + 120 >> 2] = HEAP32[i49 >> 2];
         HEAPF32[i17 + 124 >> 2] = Math_fround(0.0);
         HEAP32[i17 + 64 >> 2] = i68;
         HEAP32[i17 + 68 >> 2] = i69;
         HEAP32[i17 + 72 >> 2] = i81;
         HEAPF32[i17 + 76 >> 2] = Math_fround(0.0);
         i16 = i16 + 1 | 0;
         if ((i16 | 0) == (i107 | 0)) break; else i17 = i17 + i91 | 0;
        }
        i5 = i5 + i50 | 0;
        i19 = i19 + 1 | 0;
       } while ((i19 | 0) != (i20 | 0));
       i10 = HEAP16[i22 >> 1] | 0;
      }
      i1 = HEAP16[i106 + (i1 * 12 | 0) + 4 >> 1] | 0;
      if (i1 << 16 >> 16 == -1) {
       i1 = 1;
       break;
      } else {
       i1 = i1 & 65535;
       i23 = (i10 & 65535) + i23 | 0;
      }
     }
    }
   }
  }
  i51 = i51 + 1 | 0;
  if ((i51 | 0) == (i89 | 0)) break; else i16 = i5;
 }
 STACKTOP = i108;
 return i1 | 0;
}

function __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i102, i3, i89, i1, i91, i90, i104, i105, i103, f2) {
 i102 = i102 | 0;
 i3 = i3 | 0;
 i89 = i89 | 0;
 i1 = i1 | 0;
 i91 = i91 | 0;
 i90 = i90 | 0;
 i104 = i104 | 0;
 i105 = i105 | 0;
 i103 = i103 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, f92 = f0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i106 = 0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0;
 i106 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i101 = i106 + 192 | 0;
 i96 = i106 + 288 | 0;
 i100 = i106 + 284 | 0;
 i95 = i106 + 208 | 0;
 i93 = i106 + 128 | 0;
 i94 = i106 + 64 | 0;
 i58 = i106 + 272 | 0;
 i59 = i106 + 48 | 0;
 i99 = i106 + 32 | 0;
 i97 = i106 + 16 | 0;
 i98 = i106;
 HEAP32[i101 >> 2] = 0;
 HEAP32[i101 + 4 >> 2] = 0;
 HEAP32[i101 + 8 >> 2] = 0;
 HEAP32[i101 + 12 >> 2] = 0;
 f8 = Math_fround(HEAPF32[i90 >> 2]);
 i74 = i90 + 4 | 0;
 f13 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i90 + 8 | 0;
 f16 = Math_fround(HEAPF32[i75 >> 2]);
 f9 = Math_fround(HEAPF32[i91 >> 2]);
 i84 = i91 + 4 | 0;
 f14 = Math_fround(HEAPF32[i84 >> 2]);
 i88 = i91 + 8 | 0;
 f15 = Math_fround(HEAPF32[i88 >> 2]);
 HEAP32[i100 >> 2] = 1;
 i62 = i89 + 48 | 0;
 f23 = Math_fround(HEAPF32[i62 >> 2]);
 i69 = i89 + 52 | 0;
 f26 = Math_fround(HEAPF32[i69 >> 2]);
 i73 = i89 + 56 | 0;
 f20 = Math_fround(HEAPF32[i73 >> 2]);
 i76 = Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f26 * f26)) + Math_fround(f20 * f20)) > Math_fround(1.1920929e-07);
 f7 = i76 ? f23 : Math_fround(1.0);
 f5 = i76 ? f26 : Math_fround(0.0);
 f32 = i76 ? f20 : Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5))))));
 f7 = Math_fround(f7 * f4);
 f5 = Math_fround(f5 * f4);
 f4 = Math_fround(f32 * f4);
 f32 = Math_fround(-f7);
 f21 = Math_fround(-f5);
 f12 = Math_fround(-f4);
 f24 = Math_fround(HEAPF32[i89 >> 2]);
 f17 = Math_fround(f24 * f32);
 i76 = i89 + 4 | 0;
 f27 = Math_fround(HEAPF32[i76 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f27 * f21));
 i77 = i89 + 8 | 0;
 f18 = Math_fround(HEAPF32[i77 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f18 * f12));
 i78 = i89 + 16 | 0;
 f25 = Math_fround(HEAPF32[i78 >> 2]);
 f22 = Math_fround(f25 * f32);
 i79 = i89 + 20 | 0;
 f28 = Math_fround(HEAPF32[i79 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f28 * f21));
 i80 = i89 + 24 | 0;
 f92 = Math_fround(HEAPF32[i80 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f92 * f12));
 i81 = i89 + 32 | 0;
 f29 = Math_fround(HEAPF32[i81 >> 2]);
 f32 = Math_fround(f29 * f32);
 i82 = i89 + 36 | 0;
 f30 = Math_fround(HEAPF32[i82 >> 2]);
 f21 = Math_fround(f32 + Math_fround(f30 * f21));
 i83 = i89 + 40 | 0;
 f32 = Math_fround(HEAPF32[i83 >> 2]);
 i64 = f17 > Math_fround(0.0);
 i65 = f22 > Math_fround(0.0);
 i66 = Math_fround(f21 + Math_fround(f32 * f12)) > Math_fround(0.0);
 i85 = i102 + 144 | 0;
 f12 = Math_fround(HEAPF32[i85 >> 2]);
 i86 = i102 + 148 | 0;
 f21 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i102 + 152 | 0;
 f22 = Math_fround(HEAPF32[i87 >> 2]);
 f17 = Math_fround(-f12);
 f31 = Math_fround(-f21);
 f6 = Math_fround(-f22);
 f17 = i64 ? f12 : f17;
 f31 = i65 ? f21 : f31;
 f6 = i66 ? f22 : f6;
 f29 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f24 * f17) + Math_fround(f25 * f31)) + Math_fround(f29 * f6)));
 f30 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f27 * f17) + Math_fround(f28 * f31)) + Math_fround(f30 * f6)));
 f6 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f92 * f31)) + Math_fround(f32 * f6)));
 i66 = f7 > Math_fround(0.0);
 i65 = f5 > Math_fround(0.0);
 i64 = f4 > Math_fround(0.0);
 i60 = i3 + 144 | 0;
 f4 = Math_fround(HEAPF32[i60 >> 2]);
 i61 = i3 + 148 | 0;
 f5 = Math_fround(HEAPF32[i61 >> 2]);
 i63 = i3 + 152 | 0;
 f7 = Math_fround(HEAPF32[i63 >> 2]);
 f32 = Math_fround(-f4);
 f31 = Math_fround(-f5);
 f92 = Math_fround(-f7);
 f32 = i66 ? f4 : f32;
 f31 = i65 ? f5 : f31;
 f92 = i64 ? f7 : f92;
 f17 = Math_fround(f29 - f32);
 f18 = Math_fround(f30 - f31);
 f20 = Math_fround(f6 - f92);
 HEAPF32[i95 >> 2] = f17;
 i64 = i95 + 4 | 0;
 HEAPF32[i64 >> 2] = f18;
 i65 = i95 + 8 | 0;
 HEAPF32[i65 >> 2] = f20;
 i66 = i95 + 12 | 0;
 HEAPF32[i66 >> 2] = Math_fround(0.0);
 i67 = i95 + 16 | 0;
 HEAP32[i67 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i67 = i95 + 32 | 0;
 HEAP32[i67 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i67 = i95 + 48 | 0;
 HEAP32[i67 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 HEAPF32[i93 >> 2] = f29;
 i67 = i93 + 4 | 0;
 HEAPF32[i67 >> 2] = f30;
 i68 = i93 + 8 | 0;
 HEAPF32[i68 >> 2] = f6;
 HEAPF32[i93 + 12 >> 2] = Math_fround(0.0);
 i70 = i93 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i70 = i93 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i70 = i93 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 HEAPF32[i94 >> 2] = f32;
 i70 = i94 + 4 | 0;
 HEAPF32[i70 >> 2] = f31;
 i71 = i94 + 8 | 0;
 HEAPF32[i71 >> 2] = f92;
 i72 = i94 + 12 | 0;
 HEAPF32[i72 >> 2] = Math_fround(0.0);
 i57 = i94 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i57 = i94 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 i57 = i94 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 f92 = Math_fround(HEAPF32[i102 + 32 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f92 = Math_fround((f92 > f31 ? f31 : f92) * Math_fround(.100000001));
 f31 = Math_fround(f92 + f2);
 f92 = Math_fround(f92 * f92);
 f32 = Math_fround(f31 * f31);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f20 * f20));
 L1 : do if (f6 > f92) {
  i33 = i94 + 16 | 0;
  i34 = i94 + 20 | 0;
  i35 = i94 + 24 | 0;
  i36 = i94 + 28 | 0;
  i37 = i94 + 32 | 0;
  i38 = i94 + 36 | 0;
  i39 = i94 + 40 | 0;
  i40 = i94 + 44 | 0;
  i41 = i93 + 16 | 0;
  i42 = i93 + 20 | 0;
  i43 = i93 + 24 | 0;
  i44 = i95 + 16 | 0;
  i45 = i95 + 20 | 0;
  i46 = i95 + 24 | 0;
  i47 = i95 + 28 | 0;
  i48 = i93 + 32 | 0;
  i49 = i93 + 36 | 0;
  i50 = i93 + 40 | 0;
  i51 = i95 + 32 | 0;
  i52 = i95 + 36 | 0;
  i53 = i95 + 40 | 0;
  i54 = i95 + 44 | 0;
  i55 = i59 + 4 | 0;
  i56 = i59 + 8 | 0;
  i57 = i59 + 12 | 0;
  f10 = f17;
  f11 = f18;
  f12 = f20;
  f21 = f4;
  f23 = f5;
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f9);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f14);
  f24 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f15);
  f28 = Math_fround(0.0);
  f2 = f17;
  f4 = f18;
  f5 = f20;
  while (1) {
   f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f15 = Math_fround(f10 * f9);
   f14 = Math_fround(f11 * f9);
   f9 = Math_fround(f12 * f9);
   f107 = Math_fround(-f15);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f9);
   f112 = Math_fround(HEAPF32[i89 >> 2]);
   f113 = Math_fround(f112 * f107);
   f109 = Math_fround(HEAPF32[i76 >> 2]);
   f113 = Math_fround(f113 + Math_fround(f109 * f13));
   f22 = Math_fround(HEAPF32[i77 >> 2]);
   f113 = Math_fround(f113 + Math_fround(f22 * f8));
   f111 = Math_fround(HEAPF32[i78 >> 2]);
   f110 = Math_fround(f111 * f107);
   f108 = Math_fround(HEAPF32[i79 >> 2]);
   f110 = Math_fround(f110 + Math_fround(f108 * f13));
   f18 = Math_fround(HEAPF32[i80 >> 2]);
   f110 = Math_fround(f110 + Math_fround(f18 * f8));
   f25 = Math_fround(HEAPF32[i81 >> 2]);
   f114 = Math_fround(f25 * f107);
   f26 = Math_fround(HEAPF32[i82 >> 2]);
   f114 = Math_fround(f114 + Math_fround(f26 * f13));
   f16 = Math_fround(HEAPF32[i83 >> 2]);
   i19 = f113 > Math_fround(0.0);
   i3 = f110 > Math_fround(0.0);
   i1 = Math_fround(f114 + Math_fround(f16 * f8)) > Math_fround(0.0);
   f114 = Math_fround(HEAPF32[i85 >> 2]);
   f110 = Math_fround(HEAPF32[i86 >> 2]);
   f113 = Math_fround(HEAPF32[i87 >> 2]);
   f20 = Math_fround(-f114);
   f17 = Math_fround(-f110);
   f27 = Math_fround(-f113);
   f20 = i19 ? f114 : f20;
   f17 = i3 ? f110 : f17;
   f27 = i1 ? f113 : f27;
   f113 = Math_fround(HEAPF32[i62 >> 2]);
   f110 = Math_fround(HEAPF32[i69 >> 2]);
   f25 = Math_fround(f113 + Math_fround(Math_fround(Math_fround(f112 * f20) + Math_fround(f111 * f17)) + Math_fround(f25 * f27)));
   f26 = Math_fround(f110 + Math_fround(Math_fround(Math_fround(f109 * f20) + Math_fround(f108 * f17)) + Math_fround(f26 * f27)));
   f27 = Math_fround(Math_fround(HEAPF32[i73 >> 2]) + Math_fround(Math_fround(Math_fround(f22 * f20) + Math_fround(f18 * f17)) + Math_fround(f16 * f27)));
   i1 = f15 > Math_fround(0.0);
   i3 = f14 > Math_fround(0.0);
   i19 = f9 > Math_fround(0.0);
   f16 = Math_fround(-f21);
   f17 = Math_fround(-f23);
   f18 = Math_fround(-f7);
   f16 = Math_fround(f30 + (i1 ? f21 : f16));
   f17 = Math_fround(f29 + (i3 ? f23 : f17));
   f18 = Math_fround(f24 + (i19 ? f7 : f18));
   f20 = Math_fround(f25 - f16);
   f21 = Math_fround(f26 - f17);
   f22 = Math_fround(f27 - f18);
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(f14 * f21)) + Math_fround(f9 * f22)) - f31);
   f9 = Math_fround(HEAPF32[i90 >> 2]);
   f14 = Math_fround(HEAPF32[i74 >> 2]);
   f15 = Math_fround(HEAPF32[i75 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f9 * f107) + Math_fround(f14 * f13)) + Math_fround(f15 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i96 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i96 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i96 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f20 = Math_fround(HEAPF32[i91 >> 2]);
     f22 = Math_fround(HEAPF32[i84 >> 2]);
     f20 = Math_fround(Math_fround(f13 * f9) + f20);
     f22 = Math_fround(Math_fround(f13 * f14) + f22);
     f5 = Math_fround(Math_fround(f13 * f15) + Math_fround(HEAPF32[i88 >> 2]));
     f114 = Math_fround(f20 - f30);
     f2 = Math_fround(f22 - f29);
     f18 = Math_fround(f5 - f24);
     f4 = Math_fround(HEAPF32[i94 >> 2]);
     f24 = Math_fround(HEAPF32[i70 >> 2]);
     f4 = Math_fround(f114 + f4);
     f24 = Math_fround(f2 + f24);
     f21 = Math_fround(f18 + Math_fround(HEAPF32[i71 >> 2]));
     f7 = Math_fround(HEAPF32[i33 >> 2]);
     f8 = Math_fround(HEAPF32[i34 >> 2]);
     f7 = Math_fround(f114 + f7);
     f8 = Math_fround(f2 + f8);
     f9 = Math_fround(f18 + Math_fround(HEAPF32[i35 >> 2]));
     f16 = Math_fround(HEAPF32[i37 >> 2]);
     f17 = Math_fround(HEAPF32[i38 >> 2]);
     f16 = Math_fround(f114 + f16);
     f17 = Math_fround(f2 + f17);
     f18 = Math_fround(f18 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i94 >> 2] = f4;
     HEAPF32[i70 >> 2] = f24;
     HEAPF32[i71 >> 2] = f21;
     HEAPF32[i72 >> 2] = Math_fround(0.0);
     HEAPF32[i33 >> 2] = f7;
     HEAPF32[i34 >> 2] = f8;
     HEAPF32[i35 >> 2] = f9;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f16;
     HEAPF32[i38 >> 2] = f17;
     HEAPF32[i39 >> 2] = f18;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f2 = Math_fround(HEAPF32[i93 >> 2]);
     f114 = Math_fround(HEAPF32[i67 >> 2]);
     f24 = Math_fround(f114 - f24);
     f21 = Math_fround(Math_fround(HEAPF32[i68 >> 2]) - f21);
     HEAPF32[i95 >> 2] = Math_fround(f2 - f4);
     HEAPF32[i64 >> 2] = f24;
     HEAPF32[i65 >> 2] = f21;
     HEAPF32[i66 >> 2] = Math_fround(0.0);
     f21 = Math_fround(HEAPF32[i41 >> 2]);
     f24 = Math_fround(HEAPF32[i42 >> 2]);
     f8 = Math_fround(f24 - f8);
     f9 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f9);
     HEAPF32[i44 >> 2] = Math_fround(f21 - f7);
     HEAPF32[i45 >> 2] = f8;
     HEAPF32[i46 >> 2] = f9;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f9 = Math_fround(HEAPF32[i48 >> 2]);
     f8 = Math_fround(HEAPF32[i49 >> 2]);
     f17 = Math_fround(f8 - f17);
     f18 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f18);
     HEAPF32[i51 >> 2] = Math_fround(f9 - f16);
     HEAPF32[i52 >> 2] = f17;
     HEAPF32[i53 >> 2] = f18;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f18 = Math_fround(HEAPF32[i60 >> 2]);
     f17 = Math_fround(HEAPF32[i61 >> 2]);
     f16 = Math_fround(HEAPF32[i63 >> 2]);
     f9 = Math_fround(-f18);
     f8 = Math_fround(-f17);
     f7 = Math_fround(-f16);
     f9 = Math_fround(f20 + (i1 ? f18 : f9));
     f8 = Math_fround(f22 + (i3 ? f17 : f8));
     f7 = Math_fround(f5 + (i19 ? f16 : f7));
     f16 = f9;
     f17 = f8;
     f18 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f21 = Math_fround(3402823469999999843913219.0e14);
     f24 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f20;
     f8 = f21;
     f7 = f22;
     f21 = f6;
     f22 = f29;
     f20 = f30;
    }
   } else {
    f9 = f20;
    f8 = f21;
    f7 = f22;
    f21 = f6;
    f13 = f28;
    f22 = f29;
    f20 = f30;
   }
   i19 = HEAP32[i100 >> 2] | 0;
   HEAPF32[i93 + (i19 << 4) >> 2] = f25;
   HEAPF32[i93 + (i19 << 4) + 4 >> 2] = f26;
   HEAPF32[i93 + (i19 << 4) + 8 >> 2] = f27;
   HEAPF32[i93 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i94 + (i19 << 4) >> 2] = f16;
   HEAPF32[i94 + (i19 << 4) + 4 >> 2] = f17;
   HEAPF32[i94 + (i19 << 4) + 8 >> 2] = f18;
   HEAPF32[i94 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i100 >> 2] = i19 + 1;
   HEAPF32[i95 + (i19 << 4) >> 2] = f9;
   HEAPF32[i95 + (i19 << 4) + 4 >> 2] = f8;
   HEAPF32[i95 + (i19 << 4) + 8 >> 2] = f7;
   HEAPF32[i95 + (i19 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i19 | 0) {
   case 0:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i95 >> 2]);
     f7 = Math_fround(HEAPF32[i64 >> 2]);
     f8 = Math_fround(HEAPF32[i65 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f112 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i19 = f112 > Math_fround(1.0);
      f112 = i19 ? Math_fround(1.0) : f112;
      i19 = f112 > Math_fround(0.0);
      f112 = i19 ? f112 : Math_fround(0.0);
      f113 = Math_fround(f7 + Math_fround(f14 * f112));
      f114 = Math_fround(f8 + Math_fround(f15 * f112));
      HEAPF32[i59 >> 2] = Math_fround(f6 + Math_fround(f9 * f112));
      HEAPF32[i55 >> 2] = f113;
      HEAPF32[i56 >> 2] = f114;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i100 >> 2] = 1;
      HEAP32[i59 >> 2] = HEAP32[i95 >> 2];
      HEAP32[i59 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
      HEAP32[i59 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
      HEAP32[i59 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i95, i93, i94, i100);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i95, i93, i94, i100);
     break;
    }
   default:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f21 > f6;
   if (!(f6 > f32 & i1)) break L1;
   f21 = Math_fround(HEAPF32[i60 >> 2]);
   f23 = Math_fround(HEAPF32[i61 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = Math_fround(HEAPF32[i63 >> 2]);
   f30 = f20;
   f29 = f22;
   f28 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i106;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f20;
  f11 = f18;
  f10 = f17;
  f9 = f20;
  f8 = f18;
  f7 = f17;
  i1 = 1;
  f5 = f20;
  f4 = f18;
  f2 = f17;
 } while (0);
 i89 = HEAP32[i102 + 64 >> 2] | 0;
 i90 = HEAP32[i102 + 68 >> 2] | 0;
 i91 = HEAP32[i102 + 72 >> 2] | 0;
 i88 = f6 > f92 & i1;
 f109 = i88 ? f7 : f2;
 f111 = i88 ? f8 : f4;
 f113 = i88 ? f9 : f5;
 f108 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f113 * f113) + Math_fround(Math_fround(f111 * f111) + Math_fround(f109 * f109))))));
 f109 = Math_fround(f109 * f108);
 f111 = Math_fround(f111 * f108);
 f108 = Math_fround(f113 * f108);
 HEAPF32[i105 >> 2] = f109;
 HEAPF32[i105 + 4 >> 2] = f111;
 HEAPF32[i105 + 8 >> 2] = f108;
 HEAPF32[i105 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i104 >> 2] = f13;
 i105 = i104 + 4 | 0;
 HEAP32[i105 >> 2] = HEAP32[i96 >> 2];
 HEAP32[i105 + 4 >> 2] = HEAP32[i96 + 4 >> 2];
 HEAP32[i105 + 8 >> 2] = HEAP32[i96 + 8 >> 2];
 HEAPF32[i99 >> 2] = i1 ? f7 : f10;
 HEAPF32[i99 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i99 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i99 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i97 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i97 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i97 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i97 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 HEAP32[i98 >> 2] = HEAP32[i101 >> 2];
 HEAP32[i98 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
 HEAP32[i98 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
 HEAP32[i98 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i95, i93, i94, i99, i97, i98, HEAP32[i100 >> 2] | 0);
 f113 = Math_fround(HEAPF32[i102 + 16 >> 2]);
 f110 = Math_fround(HEAPF32[i97 >> 2]);
 f112 = Math_fround(HEAPF32[i97 + 4 >> 2]);
 f114 = Math_fround(HEAPF32[i97 + 8 >> 2]);
 f109 = Math_fround(f110 - Math_fround(f109 * f113));
 f111 = Math_fround(f112 - Math_fround(f111 * f113));
 f113 = Math_fround(f114 - Math_fround(f108 * f113));
 HEAPF32[i103 >> 2] = i89 | 0 ? f109 : f110;
 HEAPF32[i103 + 4 >> 2] = i90 | 0 ? f111 : f112;
 HEAPF32[i103 + 8 >> 2] = i91 | 0 ? f113 : f114;
 HEAPF32[i103 + 12 >> 2] = Math_fround(0.0);
 i105 = 1;
 STACKTOP = i106;
 return i105 | 0;
}

function __Z21CubemapGPUConvolutionP13RenderTextureS0_bijjb(i33, i30, i14, i31, i18, i16, i15) {
 i33 = i33 | 0;
 i30 = i30 | 0;
 i14 = i14 | 0;
 i31 = i31 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, d44 = 0.0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i42 + 96 | 0;
 i39 = i42;
 i40 = i42 + 288 | 0;
 i37 = i42 + 160 | 0;
 if ((HEAP16[gb + 1110576 + 6 >> 1] | 0) > -1) {
  HEAP32[i39 >> 2] = 0;
  HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110576 | 0, i38);
  i41 = gb + 1110576 | 0;
 } else i41 = 0;
 do if ((i33 | 0) == 0 | (i30 | 0) == 0) i1 = -1; else {
  if (!(HEAP32[gb + 1110936 >> 2] | 0)) {
   i1 = __Z15GetScriptMapperv() | 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i38, gb + 377788 | 0, 15);
   i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i38) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
   i2 = __Z15GetScriptMapperv() | 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i38, gb + 377804 | 0, 15);
   i2 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i38) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
   if ((i1 | 0) == 0 | (i2 | 0) == 0) {
    i1 = -1;
    break;
   }
   i36 = __ZN8Material14CreateMaterialER6Shaderib(i2, 61, 0) | 0;
   HEAP32[gb + 1110936 >> 2] = i36;
   i36 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
   HEAP32[gb + 1110940 >> 2] = i36;
  }
  __ZN7Texture13SetFilterModeEi(i33, 0);
  __ZN7Texture13SetFilterModeEi(i30, 0);
  i29 = __Z12GetGfxDevicev() | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  if (!(HEAP8[i1 + 4192 >> 0] | 0)) {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 496 >> 2] | 0, i1 | 0);
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0;
   i32 = 1;
  } else i32 = 0;
  i1 = __Z12GetGfxDevicev() | 0;
  HEAP32[i40 >> 2] = i1;
  i34 = i40 + 4 | 0;
  i35 = i40 + 68 | 0;
  i36 = i40 + 132 | 0;
  i2 = i35;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i34;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i36;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i24 = __Z12GetGfxDevicev() | 0;
  __ZN10Matrix4x4f8SetOrthoEffffff(i38, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(100.0)) | 0;
  mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 116 >> 2] | 0, i24 | 0, i38 | 0);
  mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 112 >> 2] | 0, i24 | 0, gb + 1162292 | 0);
  i24 = HEAP32[(HEAP32[i29 >> 2] | 0) + 36 >> 2] | 0;
  mftCall_vii(i24 | 0, i29 | 0, __ZNK13RenderTexture32CalculateNeedsInvertedProjectionEv(i30) | 0);
  i24 = i37 + 12 | 0;
  HEAP32[i37 + 16 >> 2] = 1;
  HEAP32[i24 >> 2] = gb + 33952 + 8;
  i25 = gb + 64016 | 0;
  i28 = HEAP32[i25 + 4 >> 2] | 0;
  i27 = i39;
  HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i27 + 4 >> 2] = i28;
  HEAP32[i37 + 44 >> 2] = 0;
  HEAP32[i37 + 56 >> 2] = 0;
  i27 = i37 + 60 | 0;
  HEAP32[i27 >> 2] = 0;
  i28 = i37 + 48 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i39);
  i25 = i38;
  i26 = HEAP32[i25 + 4 >> 2] | 0;
  i21 = i28;
  HEAP32[i21 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i21 + 4 >> 2] = i26;
  i21 = gb + 64016 | 0;
  i26 = HEAP32[i21 + 4 >> 2] | 0;
  i25 = i39;
  HEAP32[i25 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i25 + 4 >> 2] = i26;
  HEAP32[i37 + 64 >> 2] = 0;
  HEAP32[i37 + 76 >> 2] = 0;
  i25 = i37 + 80 | 0;
  HEAP32[i25 >> 2] = 0;
  i26 = i37 + 68 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i39);
  i21 = i38;
  i22 = HEAP32[i21 + 4 >> 2] | 0;
  i23 = i26;
  HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i23 + 4 >> 2] = i22;
  i23 = gb + 64016 | 0;
  i22 = HEAP32[i23 + 4 >> 2] | 0;
  i21 = i39;
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = i22;
  i21 = i37 + 84 | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i37 + 96 >> 2] = 0;
  i22 = i37 + 100 | 0;
  HEAP32[i22 >> 2] = 0;
  i23 = i37 + 88 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i39);
  i19 = i38;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i17 = i23;
  HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i17 + 4 >> 2] = i20;
  HEAP32[i37 + 104 >> 2] = 0;
  HEAP32[i37 + 108 >> 2] = 0;
  i17 = gb + 64016 | 0;
  i20 = HEAP32[i17 + 4 >> 2] | 0;
  i19 = i37 + 112 | 0;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  HEAP8[i37 + 120 >> 0] = 1;
  i19 = i37 + 20 | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  HEAP32[i19 + 16 >> 2] = 0;
  HEAP32[i19 + 20 >> 2] = 0;
  HEAP32[i37 + 124 >> 2] = __Z12GetGfxDevicev() | 0;
  i19 = i37 + 8 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i37 + 4 | 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i37 >> 2] = 0;
  i17 = i33 + 80 | 0;
  i1 = HEAP32[i17 >> 2] >> 1;
  if ((i1 | 0) > 0) {
   i11 = i18 + -1 | 0;
   i12 = (i30 | 0) == (i33 | 0);
   i13 = i37 + 12 | 0;
   i9 = i33 + 48 | 0;
   i10 = i30 + 48 | 0;
   f8 = Math_fround(i11 | 0);
   i3 = i1;
   i4 = 1;
   f7 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
   i1 = 0;
   f5 = Math_fround(.999984741);
   while (1) {
    if (i4 >>> 0 <= i16 >>> 0) {
     if (i4 >>> 0 < i18 >>> 0) {
      if (!(i12 | (i4 | 0) != (i11 | 0) | (i4 & 1 | 0) == 0 | i14)) {
       i2 = 0;
       do {
        if (1 << i2 & i31) {
         i1 = HEAP32[gb + 1110940 >> 2] | 0;
         if ((HEAP32[i37 >> 2] | 0) != (i1 | 0)) {
          HEAP32[i37 >> 2] = i1;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
         }
         HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
         i43 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 148 >> 2] | 0, i33 | 0) | 0;
         i1 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 152 >> 2] | 0, i33 | 0) | 0;
         HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
         __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i13, gb + 1110600 | 0, i38, i43, i1);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110608 | 0, f8, 0);
         __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i30, i11, i2, f5);
         f5 = Math_fround(f5 + Math_fround(-.0000152587891));
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 6);
      }
     } else {
      f6 = Math_fround(Math_fround(i4 | 0) + Math_fround(-1.0));
      if (!(i4 & 1)) {
       i2 = 0;
       do {
        if (1 << i2 & i31) {
         i1 = HEAP32[gb + 1110936 >> 2] | 0;
         if ((HEAP32[i37 >> 2] | 0) != (i1 | 0)) {
          HEAP32[i37 >> 2] = i1;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
         }
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110604 | 0, f7, 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110612 | 0, Math_fround(1.0), 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110616 | 0, Math_fround(3.0), 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110608 | 0, f6, 0);
         HEAP32[i39 >> 2] = HEAP32[i10 >> 2];
         i1 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 148 >> 2] | 0, i30 | 0) | 0;
         i43 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 152 >> 2] | 0, i30 | 0) | 0;
         HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
         __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i13, gb + 1110600 | 0, i38, i1, i43);
         __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i33, i4, i2, f5);
         f5 = Math_fround(f5 + Math_fround(-.0000152587891));
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 6);
      } else {
       i2 = 0;
       do {
        if (1 << i2 & i31) {
         i1 = HEAP32[gb + 1110936 >> 2] | 0;
         if ((HEAP32[i37 >> 2] | 0) != (i1 | 0)) {
          HEAP32[i37 >> 2] = i1;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
         }
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110604 | 0, f7, 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110612 | 0, Math_fround(1.0), 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110616 | 0, Math_fround(3.0), 0);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1110608 | 0, f6, 0);
         HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
         i1 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 148 >> 2] | 0, i33 | 0) | 0;
         i43 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 152 >> 2] | 0, i33 | 0) | 0;
         HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
         __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i13, gb + 1110600 | 0, i38, i1, i43);
         __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i30, i4, i2, f5);
         f5 = Math_fround(f5 + Math_fround(-.0000152587891));
        }
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 6);
      }
     }
     i1 = (i3 | 0) == 1;
    }
    i3 = i3 >> 1;
    f7 = Math_fround(f7 * Math_fround(2.0));
    if ((i3 | 0) <= 0) break; else i4 = i4 + 1 | 0;
   }
   if (i1 & i15) {
    i1 = HEAP32[i17 >> 2] | 0;
    if ((i1 | 0) > 0) {
     i10 = i37 + 12 | 0;
     i9 = i33 + 48 | 0;
     i4 = 0;
     while (1) {
      if (i4 >>> 0 < i18 >>> 0) {
       f6 = Math_fround(i4 | 0);
       i3 = 0;
       do {
        if (1 << i3 & i31) {
         i2 = HEAP32[gb + 1110940 >> 2] | 0;
         if ((HEAP32[i37 >> 2] | 0) != (i2 | 0)) {
          HEAP32[i37 >> 2] = i2;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i2, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
         }
         HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
         i16 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 148 >> 2] | 0, i33 | 0) | 0;
         i43 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 152 >> 2] | 0, i33 | 0) | 0;
         HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
         __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i10, gb + 1110600 | 0, i38, i16, i43);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i10, gb + 1110608 | 0, f6, 0);
         __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i30, i4, i3, f5);
         f5 = Math_fround(f5 + Math_fround(-.0000152587891));
        }
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != 6);
      } else if (!(i4 & 1)) {
       f6 = Math_fround(i4 | 0);
       i3 = 0;
       do {
        if (1 << i3 & i31) {
         i2 = HEAP32[gb + 1110940 >> 2] | 0;
         if ((HEAP32[i37 >> 2] | 0) != (i2 | 0)) {
          HEAP32[i37 >> 2] = i2;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i2, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
         }
         HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
         i16 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 148 >> 2] | 0, i33 | 0) | 0;
         i43 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 152 >> 2] | 0, i33 | 0) | 0;
         HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
         __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i10, gb + 1110600 | 0, i38, i16, i43);
         __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i10, gb + 1110608 | 0, f6, 0);
         __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i30, i4, i3, f5);
         f5 = Math_fround(f5 + Math_fround(-.0000152587891));
        }
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != 6);
      }
      i1 = i1 >> 1;
      if ((i1 | 0) <= 0) break; else i4 = i4 + 1 | 0;
     }
     i1 = HEAP32[i17 >> 2] | 0;
    }
    __ZN7Texture13SetFilterModeEi(i30, 2);
    i1 = i1 >> 1;
    if ((i1 | 0) > 0) {
     i10 = i37 + 12 | 0;
     i9 = i30 + 48 | 0;
     f8 = Math_fround(.166666672);
     i4 = 1;
     while (1) {
      d44 = +Math_fround(+Math_pow(+f8, 1.89999998));
      f6 = Math_fround(d44 * (+(HEAP32[i17 >> 2] | 0) * 2.0));
      if ((i1 | 0) == 1) {
       f6 = Math_fround(0.0);
       i2 = 7;
      } else {
       i2 = 7;
       while (1) {
        f7 = Math_fround(1 << i2 + 1 | 0);
        if (f7 > f6) i2 = i2 + -1 | 0; else break;
       }
       f6 = Math_fround(Math_fround(f6 - f7) / Math_fround(Math_fround(1 << i2 + 2 | 0) - f7));
      }
      f6 = Math_fround(Math_fround(i2 | 0) + f6);
      i3 = 0;
      do {
       if (1 << i3 & i31) {
        i2 = HEAP32[gb + 1110940 >> 2] | 0;
        if ((HEAP32[i37 >> 2] | 0) != (i2 | 0)) {
         HEAP32[i37 >> 2] = i2;
         HEAP32[i20 >> 2] = 0;
         HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i2, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
        }
        HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
        i18 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 148 >> 2] | 0, i30 | 0) | 0;
        i43 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 152 >> 2] | 0, i30 | 0) | 0;
        HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
        __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i10, gb + 1110600 | 0, i38, i18, i43);
        __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i10, gb + 1110608 | 0, f6, 0);
        __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i33, i4, i3, f5);
        f5 = Math_fround(f5 + Math_fround(-.0000152587891));
       }
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 6);
      f8 = Math_fround(f8 + Math_fround(.166666672));
      i1 = i1 >> 1;
      if ((i1 | 0) <= 0) break; else i4 = i4 + 1 | 0;
     }
    }
    i1 = i31 >>> 5 & 1;
    i2 = 77;
   } else i2 = 64;
  } else {
   f5 = Math_fround(.999984741);
   i2 = 64;
  }
  do if ((i2 | 0) == 64) {
   if ((i30 | 0) == (i33 | 0)) {
    __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
    i1 = 0;
    break;
   }
   i3 = HEAP32[i17 >> 2] >> 1;
   if ((i3 | 0) <= 0) {
    __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
    i1 = 0;
    break;
   }
   i11 = i37 + 12 | 0;
   i10 = i30 + 48 | 0;
   i12 = (i31 & 32 | 0) != 0;
   i1 = 0;
   i9 = 1;
   while (1) {
    if (!(i9 >>> 0 < i18 >>> 0 | i9 >>> 0 > i16 >>> 0)) {
     f6 = Math_fround(i9 | 0);
     i4 = i12 & (i3 | 0) == 1 & 1;
     i2 = 0;
     do {
      if (1 << i2 & i31) {
       i1 = HEAP32[gb + 1110940 >> 2] | 0;
       if ((HEAP32[i37 >> 2] | 0) != (i1 | 0)) {
        HEAP32[i37 >> 2] = i1;
        HEAP32[i20 >> 2] = 0;
        HEAP32[i19 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
       }
       __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i11, gb + 1110608 | 0, f6, 0);
       HEAP32[i39 >> 2] = HEAP32[i10 >> 2];
       i43 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 148 >> 2] | 0, i30 | 0) | 0;
       i1 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 152 >> 2] | 0, i30 | 0) | 0;
       HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
       __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i11, gb + 1110600 | 0, i38, i43, i1);
       __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i29, i37, i33, i9, i2, f5);
       f5 = Math_fround(f5 + Math_fround(-.0000152587891));
       i1 = i4;
      }
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 6);
    }
    i3 = i3 >> 2;
    if ((i3 | 0) <= 0) {
     i2 = 77;
     break;
    } else i9 = i9 + 2 | 0;
   }
  } while (0);
  if ((i2 | 0) == 77) {
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
   if (!i1) i1 = 0; else __ZN7Texture13SetFilterModeEi(i33, 2);
  }
  HEAP32[i24 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i22 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i23);
   HEAP32[i21 >> 2] = 0;
  }
  i2 = i37 + 64 | 0;
  if ((HEAP32[i25 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i26);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i37 + 44 | 0;
  if ((HEAP32[i27 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i28);
   HEAP32[i2 >> 2] = 0;
  }
  i43 = HEAP32[i40 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 116 >> 2] | 0, i43 | 0, i36 | 0);
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 112 >> 2] | 0, i43 | 0, i35 | 0);
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 108 >> 2] | 0, i43 | 0, i34 | 0);
  i43 = HEAP32[i40 >> 2] | 0;
  i40 = mftCall_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 132 >> 2] | 0, i43 | 0) | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 140 >> 2] | 0, i43 | 0) | 0, i40, i38);
  __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i38, i39);
  i40 = i43 + 1364 | 0;
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  i40 = i39 + 16 | 0;
  i38 = i43 + 1380 | 0;
  HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i38 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  i38 = i39 + 32 | 0;
  i40 = i43 + 1396 | 0;
  HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
  i40 = i39 + 48 | 0;
  i38 = i43 + 1412 | 0;
  HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i38 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  i38 = i39 + 64 | 0;
  i40 = i43 + 1428 | 0;
  HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
  i40 = i39 + 80 | 0;
  i43 = i43 + 1444 | 0;
  HEAP32[i43 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  if (i32 << 24 >> 24) {
   i43 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i43 >> 2] | 0) + 500 >> 2] | 0, i43 | 0);
  }
 } while (0);
 if (!i41) {
  STACKTOP = i42;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i41);
 STACKTOP = i42;
 return i1 | 0;
}

function __ZN5physxL21generatedPolyContactsERKNS_2Gu13PolygonalDataERKNS0_15HullPolygonDataERKNS0_9TriangleVEjhPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i8, i2, i33, i67, i1, i7, i65, i66, i64, i49) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i33 = i33 | 0;
 i67 = i67 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 i64 = i64 | 0;
 i49 = i49 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, f48 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, f57 = f0, i58 = 0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i63 + 96 | 0;
 i60 = i63 + 48 | 0;
 i62 = i63;
 i61 = i63 + 156 | 0;
 i32 = i63 + 144 | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 i6 = HEAPU16[i2 + 16 >> 1] | 0;
 f3 = Math_fround(HEAPF32[i49 >> 2]);
 i46 = i49 + 4 | 0;
 f59 = Math_fround(HEAPF32[i46 >> 2]);
 i47 = i49 + 8 | 0;
 f4 = Math_fround(HEAPF32[i47 >> 2]);
 f59 = Math_fround(-f59);
 __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE(i31, i49);
 i58 = i2 + 18 | 0;
 i2 = HEAPU8[i58 >> 0] | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((i2 << 4) + 16 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i1 + 15 & -16;
 f57 = Math_fround(-f3);
 f55 = Math_fround(-f4);
 i56 = i38;
 mftCall_viiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, i5 + i6 | 0, i2 | 0, HEAP32[i8 + 28 >> 2] | 0, i56 | 0);
 i39 = i33 + 96 | 0;
 HEAP32[i60 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
 i27 = i60 + 16 | 0;
 i40 = i33 + 112 | 0;
 HEAP32[i27 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 i27 = i60 + 32 | 0;
 i41 = i33 + 128 | 0;
 HEAP32[i27 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
 i27 = i38;
 f28 = Math_fround(HEAPF32[i38 >> 2]);
 f29 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 i27 = i27 + 8 | 0;
 f30 = Math_fround(HEAPF32[i27 >> 2]);
 if (!(HEAP8[i58 >> 0] | 0)) {
  f22 = Math_fround(3402823469999999843913219.0e14);
  f23 = Math_fround(3402823469999999843913219.0e14);
  f24 = Math_fround(-3402823469999999843913219.0e14);
  f25 = Math_fround(-3402823469999999843913219.0e14);
  i2 = i31;
  i5 = i31 + 16 | 0;
  i6 = i31 + 32 | 0;
  i7 = i31 + 4 | 0;
  i8 = i31 + 20 | 0;
  i13 = i31 + 36 | 0;
  i14 = i31 + 8 | 0;
  i15 = i31 + 24 | 0;
  i1 = i31 + 40 | 0;
  i26 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i5 = i31 + 16 | 0;
  i6 = i31 + 32 | 0;
  i7 = i31 + 4 | 0;
  i8 = i31 + 20 | 0;
  i13 = i31 + 36 | 0;
  i14 = i31 + 8 | 0;
  i15 = i31 + 24 | 0;
  i26 = i31 + 40 | 0;
  f10 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  i1 = 0;
  do {
   i36 = i56 + (i1 << 4) | 0;
   f50 = Math_fround(HEAPF32[i36 >> 2]);
   i37 = i56 + (i1 << 4) + 4 | 0;
   f51 = Math_fround(HEAPF32[i37 >> 2]);
   i38 = i56 + (i1 << 4) + 8 | 0;
   f52 = Math_fround(HEAPF32[i38 >> 2]);
   f53 = Math_fround(f50 * Math_fround(HEAPF32[i31 >> 2]));
   f53 = Math_fround(f53 + Math_fround(f51 * Math_fround(HEAPF32[i5 >> 2])));
   f53 = Math_fround(f53 + Math_fround(f52 * Math_fround(HEAPF32[i6 >> 2])));
   f54 = Math_fround(f50 * Math_fround(HEAPF32[i7 >> 2]));
   f54 = Math_fround(f54 + Math_fround(f51 * Math_fround(HEAPF32[i8 >> 2])));
   f54 = Math_fround(f54 + Math_fround(f52 * Math_fround(HEAPF32[i13 >> 2])));
   f50 = Math_fround(f50 * Math_fround(HEAPF32[i14 >> 2]));
   f51 = Math_fround(f50 + Math_fround(f51 * Math_fround(HEAPF32[i15 >> 2])));
   f52 = Math_fround(f51 + Math_fround(f52 * Math_fround(HEAPF32[i26 >> 2])));
   HEAPF32[i36 >> 2] = f53;
   HEAPF32[i37 >> 2] = f54;
   HEAPF32[i38 >> 2] = f52;
   HEAPF32[i56 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f10 = f10 < f53 ? f10 : f53;
   f9 = f9 < f54 ? f9 : f54;
   f4 = f4 > f53 ? f4 : f53;
   f3 = f3 > f54 ? f3 : f54;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAPU8[i58 >> 0] | 0) >>> 0);
  f23 = Math_fround(f10 + Math_fround(-1.1920929e-07));
  f22 = Math_fround(f9 + Math_fround(-1.1920929e-07));
  f25 = Math_fround(f4 + Math_fround(1.1920929e-07));
  f24 = Math_fround(f3 + Math_fround(1.1920929e-07));
  i2 = i31;
  i1 = i26;
  i26 = HEAP32[i27 >> 2] | 0;
 }
 f21 = Math_fround(HEAPF32[i64 >> 2]);
 f54 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(f54 + f21);
 f53 = Math_fround(HEAPF32[i2 >> 2]);
 f52 = Math_fround(HEAPF32[i5 >> 2]);
 f51 = Math_fround(HEAPF32[i6 >> 2]);
 f50 = Math_fround(HEAPF32[i7 >> 2]);
 f48 = Math_fround(HEAPF32[i8 >> 2]);
 f45 = Math_fround(HEAPF32[i13 >> 2]);
 f44 = Math_fround(HEAPF32[i14 >> 2]);
 f43 = Math_fround(HEAPF32[i15 >> 2]);
 f42 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(3402823469999999843913219.0e14);
 f4 = Math_fround(3402823469999999843913219.0e14);
 f9 = Math_fround(-3402823469999999843913219.0e14);
 f10 = Math_fround(-3402823469999999843913219.0e14);
 i13 = 0;
 i1 = 0;
 do {
  i35 = i60 + (i13 << 4) | 0;
  f18 = Math_fround(HEAPF32[i35 >> 2]);
  i36 = i60 + (i13 << 4) + 4 | 0;
  f19 = Math_fround(HEAPF32[i36 >> 2]);
  i37 = i60 + (i13 << 4) + 8 | 0;
  f20 = Math_fround(HEAPF32[i37 >> 2]);
  i38 = i60 + (i13 << 4) + 12 | 0;
  i8 = HEAP32[i38 >> 2] | 0;
  f16 = Math_fround(Math_fround(Math_fround(f18 * f53) + Math_fround(f19 * f52)) + Math_fround(f20 * f51));
  f17 = Math_fround(Math_fround(Math_fround(f18 * f50) + Math_fround(f19 * f48)) + Math_fround(f20 * f45));
  f12 = Math_fround(Math_fround(Math_fround(f18 * f44) + Math_fround(f19 * f43)) + Math_fround(f20 * f42));
  HEAPF32[i62 + (i13 << 4) >> 2] = Math_fround(f12 - f54);
  i34 = i62 + (i13 << 4) + 4 | 0;
  HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAPF32[i35 >> 2] = f16;
  HEAPF32[i36 >> 2] = f17;
  HEAP32[i37 >> 2] = i26;
  HEAPF32[i38 >> 2] = Math_fround(0.0);
  f3 = f3 < f16 ? f3 : f16;
  f4 = f4 < f17 ? f4 : f17;
  f9 = f9 > f16 ? f9 : f16;
  f10 = f10 > f17 ? f10 : f17;
  L10 : do if (f21 > f12) {
   HEAP8[i61 + i13 >> 0] = 1;
   i38 = HEAP8[i58 >> 0] | 0;
   i6 = i38 & 255;
   if (!(i38 << 24 >> 24 == 0 | (f23 > f16 | f16 > f25 | (f22 > f17 | f17 > f24)))) {
    i5 = i6 + -1 | 0;
    f12 = Math_fround(HEAPF32[i56 + (i5 << 4) + 4 >> 2]);
    i7 = 0;
    i2 = 0;
    while (1) {
     f11 = f12;
     f12 = Math_fround(HEAPF32[i56 + (i7 << 4) + 4 >> 2]);
     if (f11 > f17 ^ f12 > f17) {
      f70 = Math_fround(HEAPF32[i56 + (i5 << 4) >> 2]);
      f71 = Math_fround(f12 - f11);
      f69 = Math_fround(f16 * f71);
      i38 = f71 > Math_fround(0.0);
      f11 = Math_fround(Math_fround(f71 * Math_fround(f70 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f17 - f11) * Math_fround(Math_fround(HEAPF32[i56 + (i7 << 4) >> 2]) - f70)));
      if ((i38 ? f11 : f69) >= (i38 ? f69 : f11)) {
       if ((i2 | 0) == 1) break L10;
       i2 = i2 + 1 | 0;
      }
     }
     i5 = i7 + 1 | 0;
     if (i5 >>> 0 >= i6 >>> 0) break; else {
      i38 = i7;
      i7 = i5;
      i5 = i38;
     }
    }
    if (i2) {
     f17 = Math_fround(HEAPF32[i49 >> 2]);
     f69 = Math_fround(HEAPF32[i46 >> 2]);
     f70 = Math_fround(HEAPF32[i47 >> 2]);
     f71 = Math_fround(Math_fround(Math_fround(Math_fround(f18 - f28) * f17) + Math_fround(Math_fround(f19 - f29) * f69)) + Math_fround(Math_fround(f20 - f30) * f70));
     f17 = Math_fround(f18 - Math_fround(f17 * f71));
     f69 = Math_fround(f19 - Math_fround(f69 * f71));
     f70 = Math_fround(f20 - Math_fround(f70 * f71));
     i38 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i38 << 6) >> 2] = f17;
     HEAPF32[i65 + (i38 << 6) + 4 >> 2] = f69;
     HEAPF32[i65 + (i38 << 6) + 8 >> 2] = f70;
     HEAPF32[i65 + (i38 << 6) + 12 >> 2] = Math_fround(0.0);
     i38 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i38 << 6) + 16 >> 2] = f18;
     HEAPF32[i65 + (i38 << 6) + 20 >> 2] = f19;
     HEAPF32[i65 + (i38 << 6) + 24 >> 2] = f20;
     HEAP32[i65 + (i38 << 6) + 28 >> 2] = i8;
     i38 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i38 << 6) + 32 >> 2] = f57;
     HEAPF32[i65 + (i38 << 6) + 36 >> 2] = f59;
     HEAPF32[i65 + (i38 << 6) + 40 >> 2] = f55;
     HEAPF32[i65 + (i38 << 6) + 44 >> 2] = f71;
     i38 = HEAP32[i66 >> 2] | 0;
     HEAP32[i66 >> 2] = i38 + 1;
     HEAP32[i65 + (i38 << 6) + 48 >> 2] = i67;
     i1 = i1 + 1 | 0;
    }
   }
  } while (0);
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 3);
 if ((i1 | 0) == 3) {
  STACKTOP = i63;
  return;
 }
 f24 = Math_fround(f3 + Math_fround(-1.1920929e-07));
 f23 = Math_fround(f4 + Math_fround(-1.1920929e-07));
 f22 = Math_fround(f9 + Math_fround(1.1920929e-07));
 f21 = Math_fround(f10 + Math_fround(1.1920929e-07));
 f29 = Math_fround(HEAPF32[i33 + 112 >> 2]);
 i34 = i33 + 116 | 0;
 f19 = Math_fround(HEAPF32[i34 >> 2]);
 i35 = i33 + 120 | 0;
 f28 = Math_fround(HEAPF32[i35 >> 2]);
 f71 = Math_fround(HEAPF32[i33 + 96 >> 2]);
 i36 = i33 + 100 | 0;
 f20 = Math_fround(HEAPF32[i36 >> 2]);
 i37 = i33 + 104 | 0;
 f70 = Math_fround(HEAPF32[i37 >> 2]);
 f29 = Math_fround(f29 - f71);
 f19 = Math_fround(f19 - f20);
 f28 = Math_fround(f28 - f70);
 f69 = Math_fround(HEAPF32[i33 + 128 >> 2]);
 i38 = i33 + 132 | 0;
 f30 = Math_fround(HEAPF32[i38 >> 2]);
 i14 = i33 + 136 | 0;
 f69 = Math_fround(f69 - f71);
 f30 = Math_fround(f30 - f20);
 f18 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f70);
 f17 = Math_fround(Math_fround(f19 * f18) - Math_fround(f28 * f30));
 f18 = Math_fround(Math_fround(f28 * f69) - Math_fround(f29 * f18));
 f69 = Math_fround(Math_fround(f29 * f30) - Math_fround(f19 * f69));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f69 * f69) + Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18))))));
 f17 = Math_fround(f19 * f17);
 f18 = Math_fround(f19 * f18);
 f19 = Math_fround(f69 * f19);
 f20 = Math_fround(Math_fround(f70 * f19) + Math_fround(Math_fround(f71 * f17) + Math_fround(f20 * f18)));
 i1 = HEAP8[i58 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i63;
  return;
 }
 i13 = i60 + 36 | 0;
 i15 = i60 + 4 | 0;
 i26 = i60 + 32 | 0;
 i27 = i60 + 20 | 0;
 i31 = i60 + 16 | 0;
 i32 = i60 + 16 | 0;
 i33 = i60 + 32 | 0;
 i8 = 0;
 do {
  f10 = Math_fround(HEAPF32[i56 + (i8 << 4) >> 2]);
  f16 = Math_fround(HEAPF32[i56 + (i8 << 4) + 4 >> 2]);
  do if (!(f24 > f10 | f10 > f22 | (f23 > f16 | f16 > f21))) {
   f4 = Math_fround(HEAPF32[i13 >> 2]);
   f3 = Math_fround(HEAPF32[i15 >> 2]);
   i6 = f4 > f16;
   i5 = f3 > f16;
   if (i6 ^ i5) {
    f71 = Math_fround(HEAPF32[i26 >> 2]);
    f69 = Math_fround(f3 - f4);
    f70 = Math_fround(f10 * f69);
    i7 = f69 > Math_fround(0.0);
    f71 = Math_fround(Math_fround(f69 * Math_fround(f71 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f16 - f4) * Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f71)));
    if (!((i7 ? f71 : f70) >= (i7 ? f70 : f71))) i2 = 0; else i2 = 1;
   } else i2 = 0;
   f9 = Math_fround(HEAPF32[i27 >> 2]);
   i7 = f9 > f16;
   if (i5 ^ i7) {
    f71 = Math_fround(HEAPF32[i60 >> 2]);
    f69 = Math_fround(f9 - f3);
    f70 = Math_fround(f10 * f69);
    i5 = f69 > Math_fround(0.0);
    f71 = Math_fround(Math_fround(f69 * Math_fround(f71 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f16 - f3) * Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f71)));
    if ((i5 ? f71 : f70) >= (i5 ? f70 : f71)) if ((i2 | 0) == 1) break; else i2 = 1;
   }
   if (i7 ^ i6) {
    f71 = Math_fround(HEAPF32[i32 >> 2]);
    f69 = Math_fround(f4 - f9);
    f70 = Math_fround(f10 * f69);
    i7 = f69 > Math_fround(0.0);
    f71 = Math_fround(Math_fround(f69 * Math_fround(f71 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f16 - f9) * Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f71)));
    if (!((i7 ? f71 : f70) >= (i7 ? f70 : f71))) i68 = 49; else if ((i2 | 0) == 1) break;
   } else i68 = 49;
   if ((i68 | 0) == 49) {
    i68 = 0;
    if (!i2) break;
   }
   f4 = Math_fround(HEAPF32[i56 + (i8 << 4) + 8 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(f10 * f53) + Math_fround(f16 * f50)) + Math_fround(f4 * f44));
   f12 = Math_fround(Math_fround(Math_fround(f10 * f52) + Math_fround(f16 * f48)) + Math_fround(f4 * f43));
   f4 = Math_fround(Math_fround(Math_fround(f10 * f51) + Math_fround(f16 * f45)) + Math_fround(f4 * f42));
   f3 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f12)) + Math_fround(f19 * f4)) - f20);
   if (!(f3 > Math_fround(HEAPF32[i64 >> 2]))) {
    f9 = Math_fround(f11 - Math_fround(f17 * f3));
    f10 = Math_fround(f12 - Math_fround(f18 * f3));
    f3 = Math_fround(f4 - Math_fround(f19 * f3));
    f75 = Math_fround(HEAPF32[i40 >> 2]);
    f74 = Math_fround(HEAPF32[i34 >> 2]);
    f69 = Math_fround(HEAPF32[i35 >> 2]);
    f73 = Math_fround(HEAPF32[i39 >> 2]);
    f16 = Math_fround(HEAPF32[i36 >> 2]);
    f28 = Math_fround(HEAPF32[i37 >> 2]);
    f75 = Math_fround(f75 - f73);
    f74 = Math_fround(f74 - f16);
    f69 = Math_fround(f69 - f28);
    f72 = Math_fround(HEAPF32[i41 >> 2]);
    f25 = Math_fround(HEAPF32[i38 >> 2]);
    f72 = Math_fround(f72 - f73);
    f25 = Math_fround(f25 - f16);
    f30 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f28);
    f73 = Math_fround(f9 - f73);
    f16 = Math_fround(f10 - f16);
    f28 = Math_fround(f3 - f28);
    f29 = Math_fround(Math_fround(Math_fround(f75 * f75) + Math_fround(f74 * f74)) + Math_fround(f69 * f69));
    f71 = Math_fround(Math_fround(Math_fround(f75 * f72) + Math_fround(f74 * f25)) + Math_fround(f69 * f30));
    f70 = Math_fround(Math_fround(Math_fround(f72 * f72) + Math_fround(f25 * f25)) + Math_fround(f30 * f30));
    f69 = Math_fround(Math_fround(Math_fround(f75 * f73) + Math_fround(f74 * f16)) + Math_fround(f69 * f28));
    f30 = Math_fround(Math_fround(Math_fround(f73 * f72) + Math_fround(f16 * f25)) + Math_fround(f28 * f30));
    f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f29 * f70) - Math_fround(f71 * f71)));
    f70 = Math_fround(f28 * Math_fround(Math_fround(f69 * f70) - Math_fround(f71 * f30)));
    f71 = Math_fround(f28 * Math_fround(Math_fround(f29 * f30) - Math_fround(f69 * f71)));
    if (f70 >= Math_fround(0.0) & (f71 >= Math_fround(0.0) & Math_fround(f70 + f71) <= Math_fround(1.0))) {
     f71 = Math_fround(f9 - f11);
     f73 = Math_fround(f10 - f12);
     f75 = Math_fround(f3 - f4);
     f72 = Math_fround(HEAPF32[i49 >> 2]);
     f74 = Math_fround(HEAPF32[i46 >> 2]);
     f75 = Math_fround(Math_fround(Math_fround(f71 * f72) + Math_fround(f73 * f74)) + Math_fround(f75 * Math_fround(HEAPF32[i47 >> 2])));
     i1 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i1 << 6) >> 2] = f11;
     HEAPF32[i65 + (i1 << 6) + 4 >> 2] = f12;
     HEAPF32[i65 + (i1 << 6) + 8 >> 2] = f4;
     HEAPF32[i65 + (i1 << 6) + 12 >> 2] = Math_fround(0.0);
     i1 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i1 << 6) + 16 >> 2] = f9;
     HEAPF32[i65 + (i1 << 6) + 20 >> 2] = f10;
     HEAPF32[i65 + (i1 << 6) + 24 >> 2] = f3;
     HEAPF32[i65 + (i1 << 6) + 28 >> 2] = Math_fround(0.0);
     i1 = HEAP32[i66 >> 2] | 0;
     HEAPF32[i65 + (i1 << 6) + 32 >> 2] = f57;
     HEAPF32[i65 + (i1 << 6) + 36 >> 2] = f59;
     HEAPF32[i65 + (i1 << 6) + 40 >> 2] = f55;
     HEAPF32[i65 + (i1 << 6) + 44 >> 2] = f75;
     i1 = HEAP32[i66 >> 2] | 0;
     HEAP32[i66 >> 2] = i1 + 1;
     HEAP32[i65 + (i1 << 6) + 48 >> 2] = i67;
     i1 = HEAP8[i58 >> 0] | 0;
    }
   }
  } while (0);
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < (i1 & 255) >>> 0);
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i63;
  return;
 }
 f28 = Math_fround(f54 * f42);
 f29 = Math_fround(f54 * f43);
 f30 = Math_fround(f54 * f44);
 i6 = i1;
 i5 = i1;
 i1 = 2;
 i8 = 0;
 while (1) {
  if (!(HEAP8[i61 + i8 >> 0] | 0)) if (!(HEAP8[i61 + i1 >> 0] | 0)) i1 = i6; else i68 = 34; else i68 = 34;
  if ((i68 | 0) == 34) {
   i68 = 0;
   f18 = Math_fround(HEAPF32[i60 + (i8 << 4) >> 2]);
   f19 = Math_fround(HEAPF32[i60 + (i8 << 4) + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i60 + (i1 << 4) >> 2]);
   f21 = Math_fround(HEAPF32[i60 + (i1 << 4) + 4 >> 2]);
   f22 = f18 < f20 ? f18 : f20;
   f23 = f19 < f21 ? f19 : f21;
   f24 = f18 > f20 ? f18 : f20;
   f25 = f19 > f21 ? f19 : f21;
   if (!(i6 << 24 >> 24)) i1 = 0; else {
    i7 = i62 + (i8 << 4) | 0;
    i6 = i62 + (i1 << 4) | 0;
    f16 = Math_fround(f20 - f18);
    f17 = Math_fround(f21 - f19);
    i2 = i5;
    i1 = (i5 & 255) + -1 | 0;
    i5 = 0;
    while (1) {
     f10 = Math_fround(HEAPF32[i56 + (i5 << 4) >> 2]);
     f11 = Math_fround(HEAPF32[i56 + (i5 << 4) + 4 >> 2]);
     f12 = Math_fround(HEAPF32[i56 + (i1 << 4) >> 2]);
     f3 = Math_fround(HEAPF32[i56 + (i1 << 4) + 4 >> 2]);
     if (!(((f10 < f12 ? f10 : f12) > f24 ? 1 : f22 > (f10 > f12 ? f10 : f12)) | ((f11 < f3 ? f11 : f3) > f25 ? 1 : f23 > (f11 > f3 ? f11 : f3)))) {
      f4 = Math_fround(Math_fround(Math_fround(f10 - f18) * Math_fround(f3 - f19)) - Math_fround(Math_fround(f11 - f19) * Math_fround(f12 - f18)));
      f9 = Math_fround(Math_fround(Math_fround(f10 - f20) * Math_fround(f3 - f21)) - Math_fround(Math_fround(f11 - f21) * Math_fround(f12 - f20)));
      if (Math_fround(f4 * f9) < Math_fround(0.0)) if (Math_fround(Math_fround(Math_fround(Math_fround(f18 - f10) * Math_fround(f21 - f11)) - Math_fround(Math_fround(f20 - f10) * Math_fround(f19 - f11))) * Math_fround(Math_fround(Math_fround(f18 - f12) * Math_fround(f21 - f3)) - Math_fround(Math_fround(f20 - f12) * Math_fround(f19 - f3)))) < Math_fround(0.0)) {
       f10 = Math_fround(f4 * Math_fround(Math_fround(1.0) / Math_fround(f9 - f4)));
       f9 = Math_fround(f54 + Math_fround(HEAPF32[i7 >> 2]));
       f3 = Math_fround(f18 - Math_fround(f10 * f16));
       f4 = Math_fround(f19 - Math_fround(f10 * f17));
       f9 = Math_fround(f9 - Math_fround(f10 * Math_fround(Math_fround(f54 + Math_fround(HEAPF32[i6 >> 2])) - f9)));
       f10 = Math_fround(f9 - f54);
       if (!(f10 > Math_fround(HEAPF32[i64 >> 2]))) {
        f72 = Math_fround(Math_fround(f3 * f51) + Math_fround(f4 * f45));
        f75 = Math_fround(f72 + Math_fround(f9 * f42));
        f71 = Math_fround(Math_fround(f3 * f52) + Math_fround(f4 * f48));
        f74 = Math_fround(f71 + Math_fround(f9 * f43));
        f70 = Math_fround(Math_fround(f53 * f3) + Math_fround(f50 * f4));
        f73 = Math_fround(f70 + Math_fround(f44 * f9));
        f72 = Math_fround(f72 + f28);
        f71 = Math_fround(f71 + f29);
        f70 = Math_fround(f70 + f30);
        i2 = HEAP32[i66 >> 2] | 0;
        HEAPF32[i65 + (i2 << 6) >> 2] = f70;
        HEAPF32[i65 + (i2 << 6) + 4 >> 2] = f71;
        HEAPF32[i65 + (i2 << 6) + 8 >> 2] = f72;
        HEAPF32[i65 + (i2 << 6) + 12 >> 2] = Math_fround(0.0);
        i2 = HEAP32[i66 >> 2] | 0;
        HEAPF32[i65 + (i2 << 6) + 16 >> 2] = f73;
        HEAPF32[i65 + (i2 << 6) + 20 >> 2] = f74;
        HEAPF32[i65 + (i2 << 6) + 24 >> 2] = f75;
        HEAPF32[i65 + (i2 << 6) + 28 >> 2] = Math_fround(0.0);
        i2 = HEAP32[i66 >> 2] | 0;
        HEAPF32[i65 + (i2 << 6) + 32 >> 2] = f57;
        HEAPF32[i65 + (i2 << 6) + 36 >> 2] = f59;
        HEAPF32[i65 + (i2 << 6) + 40 >> 2] = f55;
        HEAPF32[i65 + (i2 << 6) + 44 >> 2] = f10;
        i2 = HEAP32[i66 >> 2] | 0;
        HEAP32[i66 >> 2] = i2 + 1;
        HEAP32[i65 + (i2 << 6) + 48 >> 2] = i67;
        i2 = HEAP8[i58 >> 0] | 0;
       }
      }
     }
     i1 = i5 + 1 | 0;
     if (i1 >>> 0 < (i2 & 255) >>> 0) {
      i49 = i5;
      i5 = i1;
      i1 = i49;
     } else {
      i5 = i2;
      i1 = i2;
      break;
     }
    }
   }
  }
  i2 = i8 + 1 | 0;
  if ((i2 | 0) == 3) break; else {
   i49 = i8;
   i6 = i1;
   i8 = i2;
   i1 = i49;
  }
 }
 STACKTOP = i63;
 return;
}

function __ZN5Umbra18ReceiverMaskCuller4initERKNS_7Vector3ERKNS_9Matrix4x4ES6_S6_PKNS_18ImpOcclusionBufferEf(i18, i1, i2, i103, i104, i3, f105) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i103 = i103 | 0;
 i104 = i104 | 0;
 i3 = i3 | 0;
 f105 = Math_fround(f105);
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, d106 = 0.0, d107 = 0.0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0;
 i102 = STACKTOP;
 STACKTOP = STACKTOP + 1168 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i99 = i102 + 136 | 0;
 i100 = i102 + 124 | 0;
 i101 = i102 + 112 | 0;
 i97 = i102 + 64 | 0;
 i98 = i102 + 16 | 0;
 i94 = i102 + 8 | 0;
 i95 = i102 + 4 | 0;
 i96 = i102;
 i6 = HEAP32[i3 + 1408 >> 2] | 0;
 i5 = 0;
 do {
  i7 = i5 << 4;
  i8 = i5 << 2;
  i9 = i8 | 3;
  i3 = 0;
  do {
   i10 = i3 << 2;
   i11 = i10 | 3;
   i2 = i8;
   f4 = Math_fround(0.0);
   while (1) {
    i12 = i2 >>> 2 << 8;
    i13 = i2 << 2 & 12;
    i1 = i10;
    while (1) {
     f56 = Math_fround(HEAPF32[i6 + ((i1 & 3 | i13 | (i1 >>> 2 << 4) + i12) << 2) >> 2]);
     i93 = f56 != Math_fround(1.0) & f56 > f4;
     f4 = i93 ? f56 : f4;
     if ((i1 | 0) >= (i11 | 0)) break; else i1 = i1 + 1 | 0;
    }
    if ((i2 | 0) < (i9 | 0)) i2 = i2 + 1 | 0; else break;
   }
   HEAPF32[i99 + (i3 + i7 << 2) >> 2] = f4;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != 16);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 16);
 HEAP32[i18 >> 2] = HEAP32[i104 >> 2];
 i91 = i104 + 4 | 0;
 HEAP32[i18 + 4 >> 2] = HEAP32[i91 >> 2];
 i92 = i104 + 8 | 0;
 HEAP32[i18 + 8 >> 2] = HEAP32[i92 >> 2];
 i93 = i104 + 12 | 0;
 HEAP32[i18 + 12 >> 2] = HEAP32[i93 >> 2];
 i50 = i104 + 16 | 0;
 HEAP32[i18 + 16 >> 2] = HEAP32[i50 >> 2];
 i59 = i104 + 20 | 0;
 HEAP32[i18 + 20 >> 2] = HEAP32[i59 >> 2];
 i12 = i104 + 24 | 0;
 HEAP32[i18 + 24 >> 2] = HEAP32[i12 >> 2];
 i10 = i104 + 28 | 0;
 HEAP32[i18 + 28 >> 2] = HEAP32[i10 >> 2];
 i47 = i104 + 32 | 0;
 HEAP32[i18 + 32 >> 2] = HEAP32[i47 >> 2];
 i13 = i104 + 36 | 0;
 HEAP32[i18 + 36 >> 2] = HEAP32[i13 >> 2];
 i58 = i104 + 40 | 0;
 HEAP32[i18 + 40 >> 2] = HEAP32[i58 >> 2];
 i8 = i104 + 44 | 0;
 HEAP32[i18 + 44 >> 2] = HEAP32[i8 >> 2];
 i44 = i104 + 48 | 0;
 HEAP32[i18 + 48 >> 2] = HEAP32[i44 >> 2];
 i11 = i104 + 52 | 0;
 HEAP32[i18 + 52 >> 2] = HEAP32[i11 >> 2];
 i9 = i104 + 56 | 0;
 HEAP32[i18 + 56 >> 2] = HEAP32[i9 >> 2];
 i57 = i104 + 60 | 0;
 HEAP32[i18 + 60 >> 2] = HEAP32[i57 >> 2];
 HEAP32[i18 + 64 >> 2] = HEAP32[i104 >> 2];
 i48 = HEAP32[i91 >> 2] | 0;
 i49 = i18 + 68 | 0;
 HEAP32[i49 >> 2] = i48;
 i45 = HEAP32[i92 >> 2] | 0;
 i46 = i18 + 72 | 0;
 HEAP32[i46 >> 2] = i45;
 i42 = HEAP32[i93 >> 2] | 0;
 i43 = i18 + 76 | 0;
 HEAP32[i43 >> 2] = i42;
 i50 = HEAP32[i50 >> 2] | 0;
 HEAP32[i18 + 80 >> 2] = i50;
 HEAP32[i18 + 84 >> 2] = HEAP32[i59 >> 2];
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i18 + 88 >> 2] = i12;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i18 + 92 >> 2] = i10;
 i47 = HEAP32[i47 >> 2] | 0;
 HEAP32[i18 + 96 >> 2] = i47;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i18 + 100 >> 2] = i13;
 HEAP32[i18 + 104 >> 2] = HEAP32[i58 >> 2];
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 + 108 >> 2] = i8;
 i44 = HEAP32[i44 >> 2] | 0;
 HEAP32[i18 + 112 >> 2] = i44;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i18 + 116 >> 2] = i11;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i18 + 120 >> 2] = i9;
 HEAP32[i18 + 124 >> 2] = HEAP32[i57 >> 2];
 HEAP32[i49 >> 2] = i50;
 HEAP32[i18 + 80 >> 2] = i48;
 HEAP32[i46 >> 2] = i47;
 HEAP32[i18 + 96 >> 2] = i45;
 HEAP32[i43 >> 2] = i44;
 HEAP32[i18 + 112 >> 2] = i42;
 HEAP32[i18 + 88 >> 2] = i13;
 HEAP32[i18 + 100 >> 2] = i12;
 HEAP32[i18 + 92 >> 2] = i11;
 HEAP32[i18 + 116 >> 2] = i10;
 HEAP32[i18 + 108 >> 2] = i9;
 HEAP32[i18 + 120 >> 2] = i8;
 i8 = i103 + 48 | 0;
 f52 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i103 + 52 | 0;
 f53 = Math_fround(HEAPF32[i9 >> 2]);
 f32 = Math_fround(Math_fround(-f53) - f52);
 i10 = i103 + 56 | 0;
 f51 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(0.0));
 f32 = Math_fround(f32 + f51);
 i11 = i103 + 60 | 0;
 f29 = Math_fround(HEAPF32[i11 >> 2]);
 d107 = 1.0 / +Math_fround(f29 + f32);
 f32 = Math_fround(HEAPF32[i103 >> 2]);
 i12 = i103 + 4 | 0;
 f31 = Math_fround(HEAPF32[i12 >> 2]);
 f37 = Math_fround(Math_fround(-f31) - f32);
 i13 = i103 + 8 | 0;
 f54 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(0.0));
 f37 = Math_fround(f37 + f54);
 i42 = i103 + 12 | 0;
 f30 = Math_fround(HEAPF32[i42 >> 2]);
 f37 = Math_fround(d107 * +Math_fround(f30 + f37));
 i43 = i103 + 16 | 0;
 f35 = Math_fround(HEAPF32[i43 >> 2]);
 i44 = i103 + 20 | 0;
 f34 = Math_fround(HEAPF32[i44 >> 2]);
 f39 = Math_fround(Math_fround(-f34) - f35);
 i45 = i103 + 24 | 0;
 f55 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * Math_fround(0.0));
 f39 = Math_fround(f39 + f55);
 i46 = i103 + 28 | 0;
 f33 = Math_fround(HEAPF32[i46 >> 2]);
 f39 = Math_fround(d107 * +Math_fround(f33 + f39));
 i47 = i103 + 32 | 0;
 f41 = Math_fround(HEAPF32[i47 >> 2]);
 i48 = i103 + 36 | 0;
 f40 = Math_fround(HEAPF32[i48 >> 2]);
 f38 = Math_fround(Math_fround(-f40) - f41);
 i49 = i103 + 40 | 0;
 f56 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * Math_fround(0.0));
 f38 = Math_fround(f38 + f56);
 i50 = i103 + 44 | 0;
 f36 = Math_fround(HEAPF32[i50 >> 2]);
 f38 = Math_fround(d107 * +Math_fround(f36 + f38));
 d107 = 1.0 / +Math_fround(f29 + Math_fround(Math_fround(f52 - f53) + f51));
 d106 = 1.0 / +Math_fround(f29 + Math_fround(Math_fround(f53 - f52) + f51));
 f51 = Math_fround(Math_fround(Math_fround(d107 * +Math_fround(f30 + Math_fround(Math_fround(f32 - f31) + f54))) - f37) * Math_fround(.0625));
 f52 = Math_fround(Math_fround(Math_fround(d107 * +Math_fround(f33 + Math_fround(Math_fround(f35 - f34) + f55))) - f39) * Math_fround(.0625));
 f53 = Math_fround(Math_fround(Math_fround(d107 * +Math_fround(f36 + Math_fround(Math_fround(f41 - f40) + f56))) - f38) * Math_fround(.0625));
 f54 = Math_fround(Math_fround(Math_fround(d106 * +Math_fround(f30 + Math_fround(Math_fround(f31 - f32) + f54))) - f37) * Math_fround(.0625));
 f55 = Math_fround(Math_fround(Math_fround(d106 * +Math_fround(f33 + Math_fround(Math_fround(f34 - f35) + f55))) - f39) * Math_fround(.0625));
 f56 = Math_fround(Math_fround(Math_fround(d106 * +Math_fround(f36 + Math_fround(Math_fround(f40 - f41) + f56))) - f38) * Math_fround(.0625));
 HEAPF32[i100 >> 2] = Math_fround(0.0);
 i57 = i100 + 4 | 0;
 HEAPF32[i57 >> 2] = Math_fround(0.0);
 i58 = i100 + 8 | 0;
 HEAPF32[i58 >> 2] = Math_fround(0.0);
 HEAPF32[i101 >> 2] = Math_fround(0.0);
 i59 = i101 + 4 | 0;
 HEAPF32[i59 >> 2] = Math_fround(0.0);
 i60 = i101 + 8 | 0;
 HEAPF32[i60 >> 2] = Math_fround(0.0);
 i61 = i97 + 4 | 0;
 i62 = i97 + 8 | 0;
 i63 = i97 + 12 | 0;
 i64 = i97 + 16 | 0;
 i65 = i97 + 20 | 0;
 i66 = i97 + 24 | 0;
 i67 = i97 + 28 | 0;
 i68 = i97 + 32 | 0;
 i69 = i97 + 36 | 0;
 i70 = i97 + 40 | 0;
 i71 = i97 + 44 | 0;
 i72 = i98 + 4 | 0;
 i73 = i98 + 8 | 0;
 i74 = i98 + 12 | 0;
 i75 = i98 + 16 | 0;
 i76 = i98 + 20 | 0;
 i77 = i98 + 24 | 0;
 i78 = i98 + 28 | 0;
 i79 = i98 + 32 | 0;
 i80 = i98 + 36 | 0;
 i81 = i98 + 40 | 0;
 i82 = i98 + 44 | 0;
 i83 = i104 + 16 | 0;
 i84 = i104 + 20 | 0;
 i85 = i104 + 24 | 0;
 i86 = i104 + 28 | 0;
 i87 = i104 + 32 | 0;
 i88 = i104 + 36 | 0;
 i89 = i104 + 40 | 0;
 i90 = i104 + 44 | 0;
 i6 = i18 + 192 | 0;
 i3 = 0;
 do {
  f14 = f39;
  f39 = Math_fround(f55 + f39);
  f41 = Math_fround(Math_fround(Math_fround(Math_fround(i3 | 0) + Math_fround(.5)) * Math_fround(.125)) + Math_fround(-1.0));
  i7 = i3 << 4;
  f40 = Math_fround(f41 + Math_fround(-.0625));
  f41 = Math_fround(f41 + Math_fround(.0625));
  i5 = 0;
  f15 = f37;
  f4 = f38;
  do {
   f17 = Math_fround(Math_fround(Math_fround(Math_fround(i5 | 0) + Math_fround(.5)) * Math_fround(.125)) + Math_fround(-1.0));
   f16 = Math_fround(HEAPF32[i99 + (i5 + i7 << 2) >> 2]);
   f16 = f16 >= f105 ? f105 : f16;
   if (f16 != Math_fround(0.0)) {
    HEAPF32[i97 >> 2] = f15;
    HEAPF32[i61 >> 2] = f14;
    HEAPF32[i62 >> 2] = f4;
    f36 = Math_fround(f55 + f14);
    f21 = Math_fround(f56 + f4);
    HEAPF32[i63 >> 2] = Math_fround(f54 + f15);
    HEAPF32[i64 >> 2] = f36;
    HEAPF32[i65 >> 2] = f21;
    f15 = Math_fround(f51 + f15);
    f14 = Math_fround(f52 + f14);
    f4 = Math_fround(f53 + f4);
    f21 = Math_fround(f55 + f14);
    f36 = Math_fround(f56 + f4);
    HEAPF32[i66 >> 2] = Math_fround(f54 + f15);
    HEAPF32[i67 >> 2] = f21;
    HEAPF32[i68 >> 2] = f36;
    HEAPF32[i69 >> 2] = f15;
    HEAPF32[i70 >> 2] = f14;
    HEAPF32[i71 >> 2] = f4;
    f36 = Math_fround(f17 + Math_fround(-.0625));
    f21 = Math_fround(HEAPF32[i8 >> 2]);
    f109 = Math_fround(f36 * f21);
    f22 = Math_fround(HEAPF32[i9 >> 2]);
    f25 = Math_fround(f109 + Math_fround(f40 * f22));
    f23 = Math_fround(f16 * Math_fround(HEAPF32[i10 >> 2]));
    f25 = Math_fround(f25 + f23);
    f20 = Math_fround(HEAPF32[i11 >> 2]);
    d107 = 1.0 / +Math_fround(f20 + f25);
    f25 = Math_fround(HEAPF32[i103 >> 2]);
    f108 = Math_fround(f36 * f25);
    f26 = Math_fround(HEAPF32[i12 >> 2]);
    f112 = Math_fround(f108 + Math_fround(f40 * f26));
    f31 = Math_fround(f16 * Math_fround(HEAPF32[i13 >> 2]));
    f112 = Math_fround(f112 + f31);
    f24 = Math_fround(HEAPF32[i42 >> 2]);
    f112 = Math_fround(d107 * +Math_fround(f24 + f112));
    f28 = Math_fround(HEAPF32[i43 >> 2]);
    f19 = Math_fround(f36 * f28);
    f29 = Math_fround(HEAPF32[i44 >> 2]);
    f111 = Math_fround(f19 + Math_fround(f40 * f29));
    f32 = Math_fround(f16 * Math_fround(HEAPF32[i45 >> 2]));
    f111 = Math_fround(f111 + f32);
    f27 = Math_fround(HEAPF32[i46 >> 2]);
    f111 = Math_fround(d107 * +Math_fround(f27 + f111));
    f35 = Math_fround(HEAPF32[i47 >> 2]);
    f36 = Math_fround(f36 * f35);
    f34 = Math_fround(HEAPF32[i48 >> 2]);
    f110 = Math_fround(f36 + Math_fround(f40 * f34));
    f33 = Math_fround(f16 * Math_fround(HEAPF32[i49 >> 2]));
    f110 = Math_fround(f110 + f33);
    f30 = Math_fround(HEAPF32[i50 >> 2]);
    f110 = Math_fround(d107 * +Math_fround(f30 + f110));
    HEAPF32[i98 >> 2] = f112;
    HEAPF32[i72 >> 2] = f111;
    HEAPF32[i73 >> 2] = f110;
    f22 = Math_fround(f41 * f22);
    d107 = 1.0 / +Math_fround(f20 + Math_fround(Math_fround(f109 + f22) + f23));
    f26 = Math_fround(f41 * f26);
    f29 = Math_fround(f41 * f29);
    f19 = Math_fround(d107 * +Math_fround(f27 + Math_fround(Math_fround(f19 + f29) + f32)));
    f34 = Math_fround(f41 * f34);
    f36 = Math_fround(d107 * +Math_fround(f30 + Math_fround(Math_fround(f36 + f34) + f33)));
    HEAPF32[i74 >> 2] = Math_fround(d107 * +Math_fround(f24 + Math_fround(Math_fround(f108 + f26) + f31)));
    HEAPF32[i75 >> 2] = f19;
    HEAPF32[i76 >> 2] = f36;
    f36 = Math_fround(f17 + Math_fround(.0625));
    d107 = 1.0 / +Math_fround(f20 + Math_fround(Math_fround(Math_fround(f36 * f21) + f22) + f23));
    f31 = Math_fround(d107 * +Math_fround(f24 + Math_fround(Math_fround(Math_fround(f36 * f25) + f26) + f31)));
    f32 = Math_fround(d107 * +Math_fround(f27 + Math_fround(Math_fround(Math_fround(f36 * f28) + f29) + f32)));
    f33 = Math_fround(d107 * +Math_fround(f30 + Math_fround(Math_fround(Math_fround(f36 * f35) + f34) + f33)));
    f34 = Math_fround(f36 * Math_fround(HEAPF32[i8 >> 2]));
    f34 = Math_fround(f34 + Math_fround(f40 * Math_fround(HEAPF32[i9 >> 2])));
    f34 = Math_fround(f34 + Math_fround(f16 * Math_fround(HEAPF32[i10 >> 2])));
    d107 = 1.0 / +Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f34);
    f34 = Math_fround(f36 * Math_fround(HEAPF32[i103 >> 2]));
    f34 = Math_fround(f34 + Math_fround(f40 * Math_fround(HEAPF32[i12 >> 2])));
    f34 = Math_fround(f34 + Math_fround(f16 * Math_fround(HEAPF32[i13 >> 2])));
    f34 = Math_fround(d107 * +Math_fround(Math_fround(HEAPF32[i42 >> 2]) + f34));
    f35 = Math_fround(f36 * Math_fround(HEAPF32[i43 >> 2]));
    f35 = Math_fround(f35 + Math_fround(f40 * Math_fround(HEAPF32[i44 >> 2])));
    f35 = Math_fround(f35 + Math_fround(f16 * Math_fround(HEAPF32[i45 >> 2])));
    f35 = Math_fround(d107 * +Math_fround(Math_fround(HEAPF32[i46 >> 2]) + f35));
    f36 = Math_fround(f36 * Math_fround(HEAPF32[i47 >> 2]));
    f36 = Math_fround(f36 + Math_fround(f40 * Math_fround(HEAPF32[i48 >> 2])));
    f36 = Math_fround(f36 + Math_fround(f16 * Math_fround(HEAPF32[i49 >> 2])));
    f36 = Math_fround(d107 * +Math_fround(Math_fround(HEAPF32[i50 >> 2]) + f36));
    f30 = Math_fround(HEAPF32[i97 >> 2]);
    HEAPF32[i98 >> 2] = Math_fround(Math_fround(HEAPF32[i98 >> 2]) - f30);
    f30 = Math_fround(HEAPF32[i61 >> 2]);
    HEAPF32[i72 >> 2] = Math_fround(Math_fround(HEAPF32[i72 >> 2]) - f30);
    f30 = Math_fround(HEAPF32[i62 >> 2]);
    HEAPF32[i73 >> 2] = Math_fround(Math_fround(HEAPF32[i73 >> 2]) - f30);
    f30 = Math_fround(HEAPF32[i63 >> 2]);
    HEAPF32[i74 >> 2] = Math_fround(Math_fround(HEAPF32[i74 >> 2]) - f30);
    f30 = Math_fround(HEAPF32[i64 >> 2]);
    HEAPF32[i75 >> 2] = Math_fround(Math_fround(HEAPF32[i75 >> 2]) - f30);
    f30 = Math_fround(HEAPF32[i65 >> 2]);
    HEAPF32[i76 >> 2] = Math_fround(Math_fround(HEAPF32[i76 >> 2]) - f30);
    HEAPF32[i77 >> 2] = Math_fround(f31 - Math_fround(HEAPF32[i66 >> 2]));
    HEAPF32[i78 >> 2] = Math_fround(f32 - Math_fround(HEAPF32[i67 >> 2]));
    HEAPF32[i79 >> 2] = Math_fround(f33 - Math_fround(HEAPF32[i68 >> 2]));
    HEAPF32[i80 >> 2] = Math_fround(f34 - Math_fround(HEAPF32[i69 >> 2]));
    HEAPF32[i81 >> 2] = Math_fround(f35 - Math_fround(HEAPF32[i70 >> 2]));
    HEAPF32[i82 >> 2] = Math_fround(f36 - Math_fround(HEAPF32[i71 >> 2]));
    i2 = 0;
    do {
     HEAPF32[i94 >> 2] = Math_fround(0.0);
     HEAPF32[i95 >> 2] = Math_fround(0.0);
     HEAPF32[i96 >> 2] = Math_fround(0.0);
     HEAPF32[i100 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i57 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i58 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i101 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     HEAPF32[i59 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     HEAPF32[i60 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     f30 = Math_fround(i2 | 0);
     f16 = Math_fround(f30 * Math_fround(.25));
     f17 = Math_fround(HEAPF32[i104 >> 2]);
     f19 = Math_fround(HEAPF32[i91 >> 2]);
     f20 = Math_fround(HEAPF32[i92 >> 2]);
     f21 = Math_fround(HEAPF32[i93 >> 2]);
     f22 = Math_fround(HEAPF32[i83 >> 2]);
     f23 = Math_fround(HEAPF32[i84 >> 2]);
     f24 = Math_fround(HEAPF32[i85 >> 2]);
     f25 = Math_fround(HEAPF32[i86 >> 2]);
     f26 = Math_fround(HEAPF32[i87 >> 2]);
     f27 = Math_fround(HEAPF32[i88 >> 2]);
     f28 = Math_fround(HEAPF32[i89 >> 2]);
     f29 = Math_fround(HEAPF32[i90 >> 2]);
     f30 = Math_fround(Math_fround(f30 + Math_fround(1.0)) * Math_fround(.25));
     i1 = 0;
     f31 = Math_fround(3402823469999999843913219.0e14);
     f32 = Math_fround(3402823469999999843913219.0e14);
     f33 = Math_fround(3402823469999999843913219.0e14);
     f34 = Math_fround(-3402823469999999843913219.0e14);
     f35 = Math_fround(-3402823469999999843913219.0e14);
     f36 = Math_fround(-3402823469999999843913219.0e14);
     do {
      f118 = Math_fround(HEAPF32[i98 + (i1 * 12 | 0) >> 2]);
      f123 = Math_fround(f16 * f118);
      f111 = Math_fround(HEAPF32[i98 + (i1 * 12 | 0) + 4 >> 2]);
      f122 = Math_fround(f16 * f111);
      f110 = Math_fround(HEAPF32[i98 + (i1 * 12 | 0) + 8 >> 2]);
      f119 = Math_fround(f16 * f110);
      f108 = Math_fround(HEAPF32[i97 + (i1 * 12 | 0) >> 2]);
      f123 = Math_fround(f123 + f108);
      f109 = Math_fround(HEAPF32[i97 + (i1 * 12 | 0) + 4 >> 2]);
      f122 = Math_fround(f122 + f109);
      f112 = Math_fround(HEAPF32[i97 + (i1 * 12 | 0) + 8 >> 2]);
      f119 = Math_fround(f119 + f112);
      f121 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f123 * f17) + Math_fround(f122 * f19)) + Math_fround(f119 * f20)));
      f120 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f123 * f22) + Math_fround(f122 * f23)) + Math_fround(f119 * f24)));
      f119 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f123 * f26) + Math_fround(f122 * f27)) + Math_fround(f119 * f28)));
      HEAPF32[i94 >> 2] = f121;
      HEAPF32[i95 >> 2] = f120;
      HEAPF32[i96 >> 2] = f119;
      i117 = HEAP32[(f121 <= f31 ? i94 : i100) >> 2] | 0;
      i116 = HEAP32[(f120 <= f32 ? i95 : i57) >> 2] | 0;
      i115 = HEAP32[(f119 <= f33 ? i96 : i58) >> 2] | 0;
      HEAP32[i100 >> 2] = i117;
      HEAP32[i57 >> 2] = i116;
      HEAP32[i58 >> 2] = i115;
      i114 = HEAP32[(f121 >= f34 ? i94 : i101) >> 2] | 0;
      i113 = HEAP32[(f120 >= f35 ? i95 : i59) >> 2] | 0;
      i18 = HEAP32[(f119 >= f36 ? i96 : i60) >> 2] | 0;
      HEAP32[i101 >> 2] = i114;
      HEAP32[i59 >> 2] = i113;
      HEAP32[i60 >> 2] = i18;
      f108 = Math_fround(Math_fround(f30 * f118) + f108);
      f109 = Math_fround(Math_fround(f30 * f111) + f109);
      f112 = Math_fround(Math_fround(f30 * f110) + f112);
      f110 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f108 * f17) + Math_fround(f109 * f19)) + Math_fround(f112 * f20)));
      f111 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f108 * f22) + Math_fround(f109 * f23)) + Math_fround(f112 * f24)));
      f112 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f108 * f26) + Math_fround(f109 * f27)) + Math_fround(f112 * f28)));
      HEAPF32[i94 >> 2] = f110;
      HEAPF32[i95 >> 2] = f111;
      HEAPF32[i96 >> 2] = f112;
      i117 = f110 <= (HEAP32[tempDoublePtr >> 2] = i117, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i117 = HEAP32[(i117 ? i94 : i100) >> 2] | 0;
      i116 = f111 <= (HEAP32[tempDoublePtr >> 2] = i116, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i116 = HEAP32[(i116 ? i95 : i57) >> 2] | 0;
      i115 = f112 <= (HEAP32[tempDoublePtr >> 2] = i115, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i115 = HEAP32[(i115 ? i96 : i58) >> 2] | 0;
      HEAP32[i100 >> 2] = i117;
      HEAP32[i57 >> 2] = i116;
      HEAP32[i58 >> 2] = i115;
      i114 = f110 >= (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i114 = HEAP32[(i114 ? i94 : i101) >> 2] | 0;
      i113 = f111 >= (HEAP32[tempDoublePtr >> 2] = i113, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i113 = HEAP32[(i113 ? i95 : i59) >> 2] | 0;
      i18 = f112 >= (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i18 = HEAP32[(i18 ? i96 : i60) >> 2] | 0;
      HEAP32[i101 >> 2] = i114;
      HEAP32[i59 >> 2] = i113;
      HEAP32[i60 >> 2] = i18;
      i1 = i1 + 1 | 0;
      f31 = (HEAP32[tempDoublePtr >> 2] = i117, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f32 = (HEAP32[tempDoublePtr >> 2] = i116, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f33 = (HEAP32[tempDoublePtr >> 2] = i115, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f34 = (HEAP32[tempDoublePtr >> 2] = i114, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f35 = (HEAP32[tempDoublePtr >> 2] = i113, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f36 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     } while ((i1 | 0) != 4);
     __ZN5Umbra12ReceiverMask7addAABBERKNS_7Vector3ES3_(i6, i100, i101) | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 4);
   } else {
    f15 = Math_fround(f51 + f15);
    f14 = Math_fround(f52 + f14);
    f4 = Math_fround(f53 + f4);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 16);
  f37 = Math_fround(f54 + f37);
  f38 = Math_fround(f56 + f38);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 16);
 STACKTOP = i102;
 return;
}

function __ZN7mecanim9animation16EvaluateAvatarDXEPKNS0_25ControllerBindingConstantEPKNS0_11AvatarInputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEPNS0_12AvatarOutputE(i1, i21, i40, i41, i3) {
 i1 = i1 | 0;
 i21 = i21 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, i76 = 0;
 i34 = (HEAP32[i1 + 16 >> 2] | 0) + 20 | 0;
 i1 = HEAP32[i34 >> 2] | 0;
 if (!i1) return;
 i35 = i34;
 i33 = i35 + i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i33 >> 2] | 0) + i33 >> 2] | 0)) return;
 i33 = i3 + 16 | 0;
 i68 = HEAP32[i33 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i68 >> 2]);
 f6 = Math_fround(HEAPF32[i68 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i68 + 8 >> 2]);
 f6 = Math_fround(f2 * f6);
 f5 = Math_fround(f2 * f5);
 f4 = Math_fround(f2 * Math_fround(HEAPF32[i68 + 12 >> 2]));
 f37 = Math_fround(HEAPF32[i68 + 16 >> 2]);
 f36 = Math_fround(HEAPF32[i68 + 20 >> 2]);
 f37 = Math_fround(f2 * f37);
 f36 = Math_fround(f2 * f36);
 f28 = Math_fround(f2 * Math_fround(HEAPF32[i68 + 24 >> 2]));
 f27 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f37 * f37) + Math_fround(f36 * f36)) + Math_fround(Math_fround(f28 * f28) + Math_fround(0.0)))));
 f38 = Math_fround(f27 * Math_fround(.5));
 f39 = Math_fround(+Math_sin(+f38));
 f38 = Math_fround(+Math_cos(+f38));
 f37 = Math_fround(Math_fround(f37 * f39) / f27);
 f36 = Math_fround(Math_fround(f36 * f39) / f27);
 f39 = Math_fround(Math_fround(f28 * f39) / f27);
 i52 = f27 == Math_fround(0.0);
 i53 = HEAP32[i3 + 24 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i53 + 68 >> 2]);
 f28 = Math_fround(HEAPF32[i53 + 72 >> 2]);
 f29 = Math_fround(HEAPF32[i53 + 76 >> 2]);
 f55 = Math_fround(HEAPF32[i53 + 80 >> 2]);
 f45 = Math_fround(HEAPF32[i53 + 84 >> 2]);
 f14 = Math_fround(HEAPF32[i53 + 88 >> 2]);
 f25 = Math_fround(HEAPF32[i53 + 92 >> 2]);
 f73 = Math_fround(HEAPF32[i53 + 96 >> 2]);
 f71 = Math_fround(HEAPF32[i53 + 100 >> 2]);
 f56 = Math_fround(HEAPF32[i53 + 104 >> 2]);
 f30 = Math_fround(HEAPF32[i53 + 132 >> 2]);
 f31 = Math_fround(HEAPF32[i53 + 136 >> 2]);
 f32 = Math_fround(HEAPF32[i53 + 140 >> 2]);
 f46 = Math_fround(HEAPF32[i53 + 144 >> 2]);
 f58 = Math_fround(HEAPF32[i53 + 148 >> 2]);
 f62 = Math_fround(HEAPF32[i53 + 152 >> 2]);
 f43 = Math_fround(HEAPF32[i53 + 156 >> 2]);
 f67 = Math_fround(HEAPF32[i53 + 160 >> 2]);
 f65 = Math_fround(HEAPF32[i53 + 164 >> 2]);
 f59 = Math_fround(HEAPF32[i53 + 168 >> 2]);
 f36 = i52 ? Math_fround(0.0) : f36;
 f37 = i52 ? Math_fround(0.0) : f37;
 f38 = i52 ? Math_fround(1.0) : f38;
 f39 = i52 ? Math_fround(0.0) : f39;
 f20 = Math_fround(f36 * Math_fround(-2.0));
 f24 = Math_fround(f36 * Math_fround(2.0));
 f17 = Math_fround(f38 * f20);
 f23 = Math_fround(f39 * Math_fround(2.0));
 f19 = Math_fround(f39 * Math_fround(-2.0));
 f16 = Math_fround(f38 * f19);
 f15 = Math_fround(Math_fround(f36 * f20) - Math_fround(f39 * f23));
 f18 = Math_fround(Math_fround(f37 * f24) - f16);
 f22 = Math_fround(f17 - Math_fround(f37 * f19));
 f60 = Math_fround(f37 * Math_fround(-2.0));
 f70 = Math_fround(f37 * Math_fround(2.0));
 f13 = Math_fround(f38 * f60);
 f16 = Math_fround(f16 - Math_fround(f36 * f60));
 f19 = Math_fround(Math_fround(f39 * f19) - Math_fround(f37 * f70));
 f23 = Math_fround(Math_fround(f36 * f23) - f13);
 f17 = Math_fround(Math_fround(f39 * f70) - f17);
 f20 = Math_fround(f13 - Math_fround(f39 * f20));
 f24 = Math_fround(Math_fround(f37 * f60) - Math_fround(f36 * f24));
 f60 = Math_fround(f6 + Math_fround(Math_fround(f27 + Math_fround(f27 * f15)) + Math_fround(Math_fround(f29 * f17) + Math_fround(f28 * f16))));
 f13 = Math_fround(f4 + Math_fround(Math_fround(f29 + Math_fround(f27 * f22)) + Math_fround(Math_fround(f29 * f24) + Math_fround(f28 * f23))));
 f70 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f55) - Math_fround(f38 * f14)) - Math_fround(f39 * f25)) - Math_fround(f37 * f45));
 f49 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f25) - Math_fround(f37 * f55)) - Math_fround(f39 * f14)) - Math_fround(f36 * f45));
 f72 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f45) - Math_fround(f36 * f14)) - Math_fround(f38 * f55)) - Math_fround(f37 * f25));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f14) - Math_fround(f39 * f55)) - Math_fround(f38 * f45)) - Math_fround(f36 * f25));
 i52 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
 i53 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
 i54 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f25 = Math_fround(HEAPF32[i68 + 212 >> 2]);
 i11 = Math_fround(Math_abs(Math_fround(f73))) < Math_fround(9.99999971e-10);
 i7 = Math_fround(Math_abs(Math_fround(f71))) < Math_fround(9.99999971e-10);
 i1 = Math_fround(Math_abs(Math_fround(f56))) < Math_fround(9.99999971e-10);
 f72 = Math_fround(Math_fround(1.0) / f73);
 f72 = i11 ? Math_fround(1.0) : f72;
 f70 = Math_fround(Math_fround(1.0) / f71);
 f70 = i7 ? Math_fround(1.0) : f70;
 f45 = Math_fround(Math_fround(1.0) / f56);
 f45 = i1 ? Math_fround(1.0) : f45;
 i1 = i68 + 188 | 0;
 f55 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = i68 + 192 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i11 = i68 + 196 | 0;
 f51 = Math_fround(HEAPF32[i11 >> 2]);
 f61 = Math_fround(-f55);
 f66 = Math_fround(-f14);
 f47 = Math_fround(-f51);
 f8 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 204 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 200 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f63 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 208 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(f8 * Math_fround(-2.0));
 f50 = Math_fround(f8 * Math_fround(2.0));
 f57 = Math_fround(f25 * f42);
 f26 = Math_fround(f63 * Math_fround(2.0));
 f48 = Math_fround(f63 * Math_fround(-2.0));
 f69 = Math_fround(f25 * f48);
 f64 = Math_fround(f44 * Math_fround(-2.0));
 f9 = Math_fround(f44 * Math_fround(2.0));
 f25 = Math_fround(f25 * f64);
 f55 = Math_fround(f73 * Math_fround(f72 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f42) - Math_fround(f63 * f26)) * f61) - f55) + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f63) - f57) * f47) + Math_fround(Math_fround(f69 - Math_fround(f8 * f64)) * f66)))));
 f9 = Math_fround(f71 * Math_fround(f70 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f44 * f50) - f69) * f61) - f14) + Math_fround(Math_fround(Math_fround(f25 - Math_fround(f63 * f42)) * f47) + Math_fround(Math_fround(Math_fround(f63 * f48) - Math_fround(f44 * f9)) * f66)))));
 f66 = Math_fround(f56 * Math_fround(f45 * Math_fround(Math_fround(Math_fround(Math_fround(f57 - Math_fround(f44 * f48)) * f61) - f51) + Math_fround(Math_fround(Math_fround(Math_fround(f44 * f64) - Math_fround(f8 * f50)) * f47) + Math_fround(Math_fround(Math_fround(f8 * f26) - f25) * f66)))));
 f25 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = (HEAP32[tempDoublePtr >> 2] = i53 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i52 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f25 * Math_fround(-2.0));
 f50 = Math_fround(f49 * f47);
 f64 = Math_fround(f8 * Math_fround(2.0));
 f44 = Math_fround(f8 * Math_fround(-2.0));
 f51 = Math_fround(f26 * Math_fround(-2.0));
 f8 = Math_fround(f60 + Math_fround(Math_fround(f55 + Math_fround(Math_fround(Math_fround(f25 * f47) - Math_fround(f8 * f64)) * f55)) + Math_fround(Math_fround(Math_fround(Math_fround(f8 * Math_fround(f26 * Math_fround(2.0))) - f50) * f66) + Math_fround(Math_fround(Math_fround(f49 * f44) - Math_fround(f25 * f51)) * f9))));
 f9 = Math_fround(f13 + Math_fround(Math_fround(f66 + Math_fround(Math_fround(f50 - Math_fround(f26 * f44)) * f55)) + Math_fround(Math_fround(Math_fround(Math_fround(f26 * f51) - Math_fround(f25 * Math_fround(f25 * Math_fround(2.0)))) * f66) + Math_fround(Math_fround(Math_fround(f25 * f64) - Math_fround(f49 * f51)) * f9))));
 f51 = Math_fround(f6 + Math_fround(Math_fround(f30 + Math_fround(f15 * f30)) + Math_fround(Math_fround(f16 * f31) + Math_fround(f17 * f32))));
 f49 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f22 * f30) + f32) + Math_fround(Math_fround(f23 * f31) + Math_fround(f24 * f32))));
 f64 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f46) - Math_fround(f38 * f62)) - Math_fround(f39 * f43)) - Math_fround(f37 * f58));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f43) - Math_fround(f37 * f46)) - Math_fround(f39 * f62)) - Math_fround(f36 * f58));
 f66 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f58) - Math_fround(f36 * f62)) - Math_fround(f38 * f46)) - Math_fround(f37 * f43));
 f43 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f62) - Math_fround(f39 * f46)) - Math_fround(f38 * f58)) - Math_fround(f36 * f43));
 i52 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
 i53 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
 i54 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f43 = Math_fround(HEAPF32[i68 + 252 >> 2]);
 i12 = Math_fround(Math_abs(Math_fround(f67))) < Math_fround(9.99999971e-10);
 i10 = Math_fround(Math_abs(Math_fround(f65))) < Math_fround(9.99999971e-10);
 i3 = Math_fround(Math_abs(Math_fround(f59))) < Math_fround(9.99999971e-10);
 f66 = Math_fround(Math_fround(1.0) / f67);
 f66 = i12 ? Math_fround(1.0) : f66;
 f64 = Math_fround(Math_fround(1.0) / f65);
 f64 = i10 ? Math_fround(1.0) : f64;
 f58 = Math_fround(Math_fround(1.0) / f59);
 f58 = i3 ? Math_fround(1.0) : f58;
 i3 = i68 + 228 | 0;
 f46 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i68 + 232 | 0;
 f62 = Math_fround(HEAPF32[i10 >> 2]);
 i12 = i68 + 236 | 0;
 f26 = Math_fround(HEAPF32[i12 >> 2]);
 f55 = Math_fround(-f46);
 f44 = Math_fround(-f62);
 f50 = Math_fround(-f26);
 f13 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 244 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 240 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f60 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i68 + 248 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f61 = Math_fround(f13 * Math_fround(-2.0));
 f48 = Math_fround(f13 * Math_fround(2.0));
 f57 = Math_fround(f43 * f61);
 f45 = Math_fround(f60 * Math_fround(2.0));
 f56 = Math_fround(f60 * Math_fround(-2.0));
 f63 = Math_fround(f43 * f56);
 f42 = Math_fround(f47 * Math_fround(-2.0));
 f14 = Math_fround(f47 * Math_fround(2.0));
 f43 = Math_fround(f43 * f42);
 f46 = Math_fround(f67 * Math_fround(f66 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f13 * f61) - Math_fround(f60 * f45)) * f55) - f46) + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f60) - f57) * f50) + Math_fround(Math_fround(f63 - Math_fround(f13 * f42)) * f44)))));
 f14 = Math_fround(f65 * Math_fround(f64 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f47 * f48) - f63) * f55) - f62) + Math_fround(Math_fround(Math_fround(f43 - Math_fround(f60 * f61)) * f50) + Math_fround(Math_fround(Math_fround(f60 * f56) - Math_fround(f47 * f14)) * f44)))));
 f44 = Math_fround(f59 * Math_fround(f58 * Math_fround(Math_fround(Math_fround(Math_fround(f57 - Math_fround(f47 * f56)) * f55) - f26) + Math_fround(Math_fround(Math_fround(Math_fround(f47 * f42) - Math_fround(f13 * f48)) * f50) + Math_fround(Math_fround(Math_fround(f13 * f45) - f43) * f44)))));
 f43 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i53 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i52 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = Math_fround(f43 * Math_fround(-2.0));
 f48 = Math_fround(f25 * f50);
 f42 = Math_fround(f13 * Math_fround(2.0));
 f47 = Math_fround(f13 * Math_fround(-2.0));
 f26 = Math_fround(f45 * Math_fround(-2.0));
 f13 = Math_fround(f51 + Math_fround(Math_fround(f46 + Math_fround(Math_fround(Math_fround(f43 * f50) - Math_fround(f13 * f42)) * f46)) + Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(f45 * Math_fround(2.0))) - f48) * f44) + Math_fround(Math_fround(Math_fround(f25 * f47) - Math_fround(f43 * f26)) * f14))));
 f14 = Math_fround(f49 + Math_fround(Math_fround(f44 + Math_fround(Math_fround(f48 - Math_fround(f45 * f47)) * f46)) + Math_fround(Math_fround(Math_fround(Math_fround(f45 * f26) - Math_fround(f43 * Math_fround(f43 * Math_fround(2.0)))) * f44) + Math_fround(Math_fround(Math_fround(f43 * f42) - Math_fround(f25 * f26)) * f14))));
 if (f2 != Math_fround(0.0)) {
  f73 = Math_fround(HEAPF32[i1 >> 2]);
  f72 = Math_fround(HEAPF32[i7 >> 2]);
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  f26 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f73 * f73) + Math_fround(f72 * f72)) + Math_fround(Math_fround(f26 * f26) + Math_fround(0.0))))) / f2);
  f72 = Math_fround(HEAPF32[i3 >> 2]);
  f73 = Math_fround(HEAPF32[i10 >> 2]);
  f25 = Math_fround(HEAPF32[i12 >> 2]);
  f25 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f72 * f72) + Math_fround(f73 * f73)) + Math_fround(Math_fround(f25 * f25) + Math_fround(0.0))))) / f2);
 } else {
  f26 = Math_fround(0.0);
  f25 = Math_fround(0.0);
 }
 if (!(HEAP8[i40 + 136 >> 0] | 0)) {
  f73 = Math_fround(HEAPF32[i40 + 132 >> 2]);
  f2 = Math_fround(f8 + Math_fround(Math_fround(f13 - f8) * f73));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f14 - f9) * f73));
  f73 = Math_fround(HEAPF32[i40 + 120 >> 2]);
  f2 = Math_fround(f73 - f2);
  f9 = Math_fround(Math_fround(HEAPF32[i40 + 128 >> 2]) - f9);
  f73 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  i10 = HEAP32[i33 >> 2] | 0;
  f73 = Math_fround(f73 * Math_fround(HEAPF32[i10 + 288 >> 2]));
  f2 = Math_fround(f2 * f73);
  f73 = Math_fround(f9 * f73);
  f9 = Math_fround(f6 + Math_fround(Math_fround(f2 + Math_fround(f15 * f2)) + Math_fround(Math_fround(f16 * Math_fround(0.0)) + Math_fround(f17 * f73))));
  f8 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f18 * f2) + Math_fround(0.0)) + Math_fround(Math_fround(f19 * Math_fround(0.0)) + Math_fround(f20 * f73))));
  f4 = Math_fround(f4 + Math_fround(Math_fround(f73 + Math_fround(f22 * f2)) + Math_fround(Math_fround(f23 * Math_fround(0.0)) + Math_fround(f24 * f73))));
  f73 = Math_fround(HEAPF32[i10 >> 2]);
  f2 = Math_fround(f9 / f73);
  f5 = Math_fround(f8 / f73);
  f6 = Math_fround(f4 / f73);
  i7 = f73 != Math_fround(0.0);
  i3 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  i1 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  i68 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i10 + 4 >> 2] = i3;
  HEAP32[i10 + 8 >> 2] = i1;
  HEAP32[i10 + 12 >> 2] = i68;
  f6 = f9;
  f5 = f8;
 }
 f2 = Math_fround(f25 + f26);
 if (f2 > Math_fround(0.0)) f2 = Math_fround(Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(f26 / f2))))) + Math_fround(-.5)); else f2 = Math_fround(0.0);
 f71 = Math_fround(Math_fround(f2 * Math_fround(HEAPF32[(HEAP32[i33 >> 2] | 0) + 288 >> 2])) + Math_fround(.5));
 HEAPF32[i40 + 132 >> 2] = f71;
 f72 = Math_fround(f28 + Math_fround(Math_fround(f31 - f28) * f71));
 f73 = Math_fround(f29 + Math_fround(Math_fround(f32 - f29) * f71));
 HEAPF32[i40 + 120 >> 2] = Math_fround(f27 + Math_fround(Math_fround(f30 - f27) * f71));
 HEAPF32[i40 + 124 >> 2] = f72;
 HEAPF32[i40 + 128 >> 2] = f73;
 i1 = HEAP32[i34 >> 2] | 0;
 if (!i1) f2 = Math_fround(1.0); else {
  i1 = i1 + i35 | 0;
  i68 = i1 + 40 | 0;
  if (!(HEAP32[(HEAP32[i68 >> 2] | 0) + i68 >> 2] | 0)) f2 = Math_fround(1.0); else f2 = Math_fround(HEAPF32[i1 + 360 >> 2]);
 }
 i1 = i41 + 12 | 0;
 i7 = HEAP32[i40 + 4 >> 2] | 0;
 i11 = HEAP32[i40 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i40 >> 2];
 i3 = i41 + 16 | 0;
 HEAP32[i3 >> 2] = i7;
 i7 = i41 + 20 | 0;
 HEAP32[i7 >> 2] = i11;
 i11 = i41 + 24 | 0;
 i75 = HEAP32[i40 + 12 >> 2] | 0;
 i76 = HEAP32[i40 + 16 >> 2] | 0;
 i10 = HEAP32[i40 + 20 >> 2] | 0;
 i74 = HEAP32[i40 + 24 >> 2] | 0;
 HEAP32[i11 >> 2] = i75;
 i12 = i41 + 28 | 0;
 HEAP32[i12 >> 2] = i76;
 i21 = i41 + 32 | 0;
 HEAP32[i21 >> 2] = i10;
 i33 = i41 + 36 | 0;
 HEAP32[i33 >> 2] = i74;
 i35 = i41 + 40 | 0;
 i34 = HEAP32[i40 + 28 >> 2] | 0;
 i52 = HEAP32[i40 + 32 >> 2] | 0;
 i54 = HEAP32[i40 + 36 >> 2] | 0;
 HEAP32[i35 >> 2] = i34;
 i53 = i41 + 44 | 0;
 HEAP32[i53 >> 2] = i52;
 i68 = i41 + 48 | 0;
 HEAP32[i68 >> 2] = i54;
 f63 = Math_fround(f6 * f2);
 f69 = Math_fround(f5 * f2);
 f61 = Math_fround(f4 * f2);
 f58 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f66 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f58 = Math_fround(f63 * f58);
 f66 = Math_fround(f69 * f66);
 f61 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f69 = (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f63 = (HEAP32[tempDoublePtr >> 2] = i75, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f65 = (HEAP32[tempDoublePtr >> 2] = i74, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f64 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f57 = Math_fround(f69 * Math_fround(-2.0));
 f67 = Math_fround(f69 * Math_fround(2.0));
 f59 = Math_fround(f57 * f65);
 f73 = Math_fround(f64 * Math_fround(2.0));
 f60 = Math_fround(f64 * Math_fround(-2.0));
 f56 = Math_fround(f65 * f60);
 f62 = Math_fround(f63 * Math_fround(-2.0));
 f71 = Math_fround(f63 * Math_fround(2.0));
 f72 = Math_fround(f65 * f62);
 f70 = Math_fround(Math_fround(f58 + Math_fround(f58 * Math_fround(Math_fround(f69 * f57) - Math_fround(f64 * f73)))) + Math_fround(Math_fround(f61 * Math_fround(Math_fround(f71 * f64) - f59)) + Math_fround(f66 * Math_fround(f56 - Math_fround(f69 * f62)))));
 f71 = Math_fround(Math_fround(f66 + Math_fround(f58 * Math_fround(Math_fround(f63 * f67) - f56))) + Math_fround(Math_fround(f61 * Math_fround(f72 - Math_fround(f57 * f64))) + Math_fround(f66 * Math_fround(Math_fround(f64 * f60) - Math_fround(f63 * f71)))));
 f72 = Math_fround(Math_fround(f61 + Math_fround(f58 * Math_fround(f59 - Math_fround(f63 * f60)))) + Math_fround(Math_fround(f61 * Math_fround(Math_fround(f63 * f62) - Math_fround(f69 * f67))) + Math_fround(f66 * Math_fround(Math_fround(f69 * f73) - f72))));
 f73 = Math_fround(HEAPF32[i1 >> 2]);
 f66 = Math_fround(HEAPF32[i3 >> 2]);
 f70 = Math_fround(f73 + f70);
 f71 = Math_fround(f66 + f71);
 f72 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f72);
 f66 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f69) - Math_fround(f39 * f65)) - Math_fround(f38 * f64)) - Math_fround(f36 * f63));
 f73 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f65) - Math_fround(f37 * f63)) - Math_fround(f39 * f64)) - Math_fround(f36 * f69));
 f67 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f64) - Math_fround(f39 * f69)) - Math_fround(f37 * f65)) - Math_fround(f38 * f63));
 f69 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f63) - Math_fround(f37 * f64)) - Math_fround(f36 * f65)) - Math_fround(f38 * f69));
 i41 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
 i40 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i1 >> 2] = f70;
 HEAPF32[i3 >> 2] = f71;
 HEAPF32[i7 >> 2] = f72;
 HEAP32[i11 >> 2] = i10 ^ -2147483648;
 HEAP32[i12 >> 2] = i40;
 HEAP32[i21 >> 2] = i41 ^ -2147483648;
 HEAPF32[i33 >> 2] = f73;
 HEAP32[i35 >> 2] = i34;
 HEAP32[i53 >> 2] = i52;
 HEAP32[i68 >> 2] = i54;
 return;
}

function __ZN7mecanim9animation18ClipMuscleConstant8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i7 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898434 | 0, gb + 898446 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7mecanim5human9HumanPose8TransferI14SafeBinaryReadEEvRT_(i8, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 888 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898456 | 0, gb + 905989 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 928 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898465 | 0, gb + 905989 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 968 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898473 | 0, gb + 905989 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 1008 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898490 | 0, gb + 905989 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 1048 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898508 | 0, gb + 906560 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 1060 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898523 | 0, gb + 905830 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i10 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
    i3 = i1;
    i4 = i3 + 48 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    i5 = i2;
    i1 = i1 | 0 ? i1 - i5 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i5;
   }
   i3 = i1 + i2 | 0;
   i1 = i3;
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1041891 | 0, gb + 898530 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim9animation4Clip8TransferI14SafeBinaryReadEEvRT_(i1, i10); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1064 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898535 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1068 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898547 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 68; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 68; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1072 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898558 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 79; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 79; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 79) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1076 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898579 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 90; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 90; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 90) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1080 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898587 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 101; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 101; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 101) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1084 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898601 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 112; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 112; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 112) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 HEAP32[i7 >> 2] = 155;
 HEAP32[i7 + 4 >> 2] = i8 + 1088;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898623 | 0, HEAP32[gb + 37256 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi155EEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i10 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i8 + 1712;
 HEAP32[i7 + 4 >> 2] = i8 + 1708;
 HEAP32[i7 + 8 >> 2] = i3;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898636 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i8 + 1720;
 HEAP32[i7 + 4 >> 2] = i8 + 1716;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898654 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1724 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898680 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L185 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L185;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 1725 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898689 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L197 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L197;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1726 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898700 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L209 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L209;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i10, 1) | 0;
 HEAP8[i4 >> 0] = HEAP8[(i1 ? i3 : i4) >> 0] | 0;
 i3 = i8 + 1727 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898712 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L221 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L221;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1728 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898735 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L233 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L233;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1729 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898756 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L245 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L245;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1730 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898778 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L257 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L257;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1731 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898794 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L269 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L269;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1732 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898820 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L281 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L281;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1733 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898844 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  L293 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L293;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 1734 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898869 | 0, i5, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 L306 : do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i9 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L306;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Gu26computeBox_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbRNS_10PxSweepHitE(i118, i117, i3, i4, f2, f1, i116, i12) {
 i118 = i118 | 0;
 i117 = i117 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 i116 = i116 | 0;
 i12 = i12 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, f141 = f0, f142 = f0, f143 = f0, f144 = f0, f145 = f0, f146 = f0, f147 = f0, i148 = 0;
 i130 = STACKTOP;
 STACKTOP = STACKTOP + 6768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i89 = i130 + 4480 | 0;
 i113 = i130 + 6240 | 0;
 i106 = i130 + 6228 | 0;
 i109 = i130 + 384 | 0;
 i112 = i130 + 6224 | 0;
 i129 = i130 + 6208 | 0;
 i102 = i130 + 6144 | 0;
 i108 = i130 + 208 | 0;
 i105 = i130 + 224 | 0;
 i114 = i130 + 6072 | 0;
 i44 = i130 + 5848 | 0;
 i107 = i130 + 160 | 0;
 i64 = i130 + 5800 | 0;
 i104 = i130;
 i111 = i130 + 4508 | 0;
 i103 = i130 + 96 | 0;
 i110 = i130 + 32 | 0;
 i88 = i130 + 4496 | 0;
 i115 = i130 + 4520 | 0;
 i40 = HEAP32[i118 + 36 >> 2] | 0;
 i100 = HEAP32[i40 + 168 >> 2] | 0;
 HEAP32[i112 >> 2] = 0;
 __ZN5physx2Gu9ContainerC2Ev(i129);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i129, 128, i130 + 6256 | 0, 1);
 HEAP32[i102 >> 2] = HEAP32[i3 >> 2];
 i101 = i102 + 4 | 0;
 HEAP32[i101 >> 2] = HEAP32[i3 + 4 >> 2];
 i90 = i102 + 8 | 0;
 HEAP32[i90 >> 2] = HEAP32[i3 + 8 >> 2];
 i91 = i102 + 12 | 0;
 HEAP32[i91 >> 2] = HEAP32[i3 + 12 >> 2];
 i92 = i102 + 16 | 0;
 HEAP32[i92 >> 2] = HEAP32[i3 + 16 >> 2];
 i93 = i102 + 20 | 0;
 HEAP32[i93 >> 2] = HEAP32[i3 + 20 >> 2];
 i94 = i102 + 24 | 0;
 HEAP32[i94 >> 2] = HEAP32[i3 + 24 >> 2];
 i95 = i102 + 28 | 0;
 HEAP32[i95 >> 2] = HEAP32[i3 + 28 >> 2];
 i96 = i102 + 32 | 0;
 HEAP32[i96 >> 2] = HEAP32[i3 + 32 >> 2];
 i97 = i102 + 36 | 0;
 HEAP32[i97 >> 2] = HEAP32[i3 + 36 >> 2];
 i98 = i102 + 40 | 0;
 HEAP32[i98 >> 2] = HEAP32[i3 + 40 >> 2];
 i99 = i102 + 44 | 0;
 HEAP32[i99 >> 2] = HEAP32[i3 + 44 >> 2];
 i45 = i3 + 48 | 0;
 i43 = HEAP32[i45 >> 2] | 0;
 i42 = HEAP32[i3 + 52 >> 2] | 0;
 i41 = HEAP32[i3 + 56 >> 2] | 0;
 i81 = HEAP32[i4 >> 2] | 0;
 i82 = HEAP32[i4 + 4 >> 2] | 0;
 i83 = HEAP32[i4 + 8 >> 2] | 0;
 i84 = HEAP32[i4 + 12 >> 2] | 0;
 i87 = i4 + 16 | 0;
 i85 = HEAP32[i87 >> 2] | 0;
 i86 = HEAP32[i87 + 4 >> 2] | 0;
 i87 = HEAP32[i87 + 8 >> 2] | 0;
 f57 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f56 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f55 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = f57 <= f56 ? f57 : f56;
 f52 = f52 <= f55 ? f52 : f55;
 f53 = Math_fround(f52 * Math_fround(.150000006));
 f54 = Math_fround(f53 + f2);
 HEAPF32[i108 >> 2] = f54;
 HEAPF32[i102 + 48 >> 2] = Math_fround(f57 + f54);
 HEAPF32[i102 + 52 >> 2] = Math_fround(f56 + f54);
 HEAPF32[i102 + 56 >> 2] = Math_fround(f55 + f54);
 i46 = i105 + 64 | 0;
 HEAP32[i105 >> 2] = 0;
 HEAP32[i105 + 4 >> 2] = 0;
 HEAP32[i105 + 8 >> 2] = 0;
 HEAP32[i105 + 12 >> 2] = 0;
 HEAP32[i105 + 80 >> 2] = 3;
 HEAPF32[i105 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i89 >> 2] = 0;
 HEAP32[i89 + 4 >> 2] = 0;
 HEAP32[i89 + 8 >> 2] = 0;
 HEAP32[i89 + 12 >> 2] = 0;
 HEAP32[i46 >> 2] = HEAP32[i89 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i89 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i89 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i89 + 12 >> 2];
 HEAP32[i105 + 144 >> 2] = i43;
 HEAP32[i105 + 148 >> 2] = i42;
 HEAP32[i105 + 152 >> 2] = i41;
 HEAPF32[i105 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i105 + 16 >> 2] = f53;
 HEAPF32[i105 + 32 >> 2] = Math_fround(f52 * Math_fround(.0500000007));
 i41 = HEAP32[i97 >> 2] | 0;
 i42 = HEAP32[i98 >> 2] | 0;
 i43 = HEAP32[i99 >> 2] | 0;
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i44, i45);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i44, i114);
 HEAPF32[i107 >> 2] = Math_fround(1.0);
 i44 = i107 + 4 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAPF32[i107 + 20 >> 2] = Math_fround(1.0);
 i44 = i107 + 24 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAPF32[i107 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i107 + 44 >> 2] = Math_fround(0.0);
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i64, i117, i118 + 4 | 0);
 HEAP32[i104 >> 2] = i81;
 i81 = i104 + 4 | 0;
 HEAP32[i81 >> 2] = i82;
 i82 = i104 + 8 | 0;
 HEAP32[i82 >> 2] = i83;
 i83 = i104 + 12 | 0;
 HEAP32[i83 >> 2] = i84;
 i84 = i104 + 16 | 0;
 HEAP32[i84 >> 2] = i85;
 i85 = i104 + 20 | 0;
 HEAP32[i85 >> 2] = i86;
 i86 = i104 + 24 | 0;
 HEAP32[i86 >> 2] = i87;
 i87 = i104 + 28 | 0;
 HEAPF32[i87 >> 2] = Math_fround(0.0);
 i44 = i129 + 4 | 0;
 i45 = i103 + 32 | 0;
 i46 = i103 + 36 | 0;
 i47 = i103 + 40 | 0;
 i48 = i103 + 44 | 0;
 i49 = i103 + 48 | 0;
 i50 = i103 + 16 | 0;
 i51 = i102 + 36 | 0;
 f52 = Math_fround(HEAPF32[i64 >> 2]);
 f53 = Math_fround(HEAPF32[i64 + 4 >> 2]);
 f54 = Math_fround(HEAPF32[i64 + 8 >> 2]);
 f55 = Math_fround(HEAPF32[i64 + 12 >> 2]);
 f56 = Math_fround(HEAPF32[i64 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i64 + 20 >> 2]);
 f58 = Math_fround(HEAPF32[i64 + 24 >> 2]);
 f59 = Math_fround(HEAPF32[i64 + 28 >> 2]);
 f60 = Math_fround(HEAPF32[i64 + 32 >> 2]);
 f61 = Math_fround(HEAPF32[i64 + 36 >> 2]);
 f62 = Math_fround(HEAPF32[i64 + 40 >> 2]);
 f63 = Math_fround(HEAPF32[i64 + 44 >> 2]);
 i64 = i110 + 48 | 0;
 i65 = i110 + 52 | 0;
 i66 = i110 + 56 | 0;
 i67 = i110 + 60 | 0;
 i68 = i110 + 4 | 0;
 i69 = i110 + 8 | 0;
 i70 = i110 + 12 | 0;
 i71 = i110 + 16 | 0;
 i72 = i110 + 20 | 0;
 i73 = i110 + 24 | 0;
 i74 = i110 + 28 | 0;
 i75 = i110 + 32 | 0;
 i76 = i110 + 36 | 0;
 i77 = i110 + 40 | 0;
 i78 = i110 + 44 | 0;
 i79 = i129 + 8 | 0;
 i80 = i104 + 16 | 0;
 i121 = i12 + 40 | 0;
 i122 = i12 + 16 | 0;
 i123 = i12 + 20 | 0;
 i124 = i12 + 24 | 0;
 i125 = i12 + 28 | 0;
 i126 = i12 + 32 | 0;
 i127 = i12 + 36 | 0;
 i120 = i12 + 8 | 0;
 i37 = i109 + 44 | 0;
 i38 = i40 + 172 | 0;
 i39 = i40 + 28 | 0;
 i40 = i40 + 24 | 0;
 f1 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f11 = Math_fround(0.0);
 i4 = 268435455;
 f9 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 i12 = 0;
 i14 = 0;
 i15 = 0;
 f7 = Math_fround(0.0);
 f8 = Math_fround(0.0);
 f10 = Math_fround(0.0);
 i3 = 0;
 i119 = 0;
 while (1) {
  if (HEAP32[i44 >> 2] | 0) HEAP32[i44 >> 2] = 0;
  __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE(i118, i117, i102, i129);
  i34 = HEAP32[i44 >> 2] | 0;
  if (!i34) {
   f8 = f1;
   f7 = f2;
   break;
  }
  HEAP32[i84 >> 2] = i41;
  HEAP32[i85 >> 2] = i42;
  HEAP32[i86 >> 2] = i43;
  HEAPF32[i87 >> 2] = Math_fround(0.0);
  HEAP32[i45 >> 2] = i104;
  HEAP32[i46 >> 2] = i107;
  HEAP32[i47 >> 2] = i107;
  HEAP8[i48 >> 0] = 1;
  HEAP32[i103 >> 2] = gb + 84376 + 8;
  HEAP32[i49 >> 2] = i105;
  HEAP32[i50 >> 2] = 0;
  HEAP32[i50 + 4 >> 2] = 0;
  HEAP32[i50 + 8 >> 2] = 0;
  HEAP32[i50 + 12 >> 2] = 0;
  f140 = Math_fround(HEAPF32[i102 >> 2]);
  f139 = Math_fround(HEAPF32[i101 >> 2]);
  f138 = Math_fround(HEAPF32[i90 >> 2]);
  f147 = Math_fround(HEAPF32[i91 >> 2]);
  f146 = Math_fround(HEAPF32[i92 >> 2]);
  f137 = Math_fround(HEAPF32[i93 >> 2]);
  f145 = Math_fround(HEAPF32[i94 >> 2]);
  f144 = Math_fround(HEAPF32[i95 >> 2]);
  f136 = Math_fround(HEAPF32[i96 >> 2]);
  f143 = Math_fround(HEAPF32[i51 >> 2]);
  f142 = Math_fround(HEAPF32[i98 >> 2]);
  f143 = Math_fround(-f143);
  f142 = Math_fround(-f142);
  f141 = Math_fround(-Math_fround(HEAPF32[i99 >> 2]));
  f135 = Math_fround(Math_fround(Math_fround(f140 * f52) + Math_fround(f139 * f53)) + Math_fround(f138 * f54));
  f134 = Math_fround(Math_fround(Math_fround(f147 * f52) + Math_fround(f146 * f53)) + Math_fround(f137 * f54));
  f133 = Math_fround(Math_fround(Math_fround(f145 * f52) + Math_fround(f144 * f53)) + Math_fround(f136 * f54));
  f132 = Math_fround(Math_fround(Math_fround(f140 * f55) + Math_fround(f139 * f56)) + Math_fround(f138 * f57));
  f131 = Math_fround(Math_fround(Math_fround(f147 * f55) + Math_fround(f146 * f56)) + Math_fround(f137 * f57));
  f13 = Math_fround(Math_fround(Math_fround(f145 * f55) + Math_fround(f144 * f56)) + Math_fround(f136 * f57));
  f26 = Math_fround(Math_fround(Math_fround(f140 * f58) + Math_fround(f139 * f59)) + Math_fround(f138 * f60));
  f27 = Math_fround(Math_fround(Math_fround(f147 * f58) + Math_fround(f146 * f59)) + Math_fround(f137 * f60));
  f28 = Math_fround(Math_fround(Math_fround(f145 * f58) + Math_fround(f144 * f59)) + Math_fround(f136 * f60));
  f137 = Math_fround(Math_fround(Math_fround(Math_fround(f147 * f143) + Math_fround(f146 * f142)) + Math_fround(f137 * f141)) + Math_fround(Math_fround(Math_fround(f147 * f61) + Math_fround(f146 * f62)) + Math_fround(f137 * f63)));
  f136 = Math_fround(Math_fround(Math_fround(Math_fround(f145 * f143) + Math_fround(f144 * f142)) + Math_fround(f136 * f141)) + Math_fround(Math_fround(Math_fround(f145 * f61) + Math_fround(f144 * f62)) + Math_fround(f136 * f63)));
  HEAPF32[i64 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f140 * f143) + Math_fround(f139 * f142)) + Math_fround(f138 * f141)) + Math_fround(Math_fround(Math_fround(f140 * f61) + Math_fround(f139 * f62)) + Math_fround(f138 * f63)));
  HEAPF32[i65 >> 2] = f137;
  HEAPF32[i66 >> 2] = f136;
  HEAPF32[i67 >> 2] = Math_fround(0.0);
  HEAPF32[i110 >> 2] = f135;
  HEAPF32[i68 >> 2] = f134;
  HEAPF32[i69 >> 2] = f133;
  HEAPF32[i70 >> 2] = Math_fround(0.0);
  HEAPF32[i71 >> 2] = f132;
  HEAPF32[i72 >> 2] = f131;
  HEAPF32[i73 >> 2] = f13;
  HEAPF32[i74 >> 2] = Math_fround(0.0);
  HEAPF32[i75 >> 2] = f26;
  HEAPF32[i76 >> 2] = f27;
  HEAPF32[i77 >> 2] = f28;
  HEAPF32[i78 >> 2] = Math_fround(0.0);
  i35 = HEAP32[i79 >> 2] | 0;
  HEAP32[i111 >> 2] = HEAP32[i88 >> 2];
  HEAP32[i111 + 4 >> 2] = HEAP32[i88 + 4 >> 2];
  HEAP32[i111 + 8 >> 2] = HEAP32[i88 + 8 >> 2];
  i36 = (i34 + 31 | 0) >>> 5;
  if (!i36) {
   f7 = f11;
   i128 = 28;
   break;
  }
  i16 = 2139095039;
  i31 = 0;
  i32 = 0;
  i33 = ~i34;
  while (1) {
   i18 = i33 >>> 0 > 4294967263 ? ~i33 : 32;
   i29 = i31 << 5;
   i30 = i34 - i29 | 0;
   i30 = i30 >>> 0 < 32 ? i30 : 32;
   i19 = (i30 | 0) == 0;
   if (i19) {
    HEAP32[i106 >> 2] = HEAP32[i111 >> 2];
    HEAP32[i106 + 4 >> 2] = HEAP32[i111 + 4 >> 2];
    HEAP32[i106 + 8 >> 2] = HEAP32[i111 + 8 >> 2];
    i17 = i12;
    f26 = f7;
    f27 = f8;
    f28 = f10;
    i12 = 0;
   } else {
    i17 = HEAP32[i39 >> 2] | 0;
    i20 = (HEAP8[i38 >> 0] & 2) == 0;
    i22 = 0;
    do {
     i21 = HEAP32[i35 + (i22 + i29 << 2) >> 2] | 0;
     if (i20) {
      i23 = HEAP32[i17 + (i21 * 12 | 0) >> 2] | 0;
      i24 = HEAP32[i17 + (i21 * 12 | 0) + 4 >> 2] | 0;
      i25 = HEAP32[i17 + (i21 * 12 | 0) + 8 >> 2] | 0;
     } else {
      i23 = HEAPU16[i17 + (i21 * 6 | 0) >> 1] | 0;
      i24 = HEAPU16[i17 + (i21 * 6 | 0) + 2 >> 1] | 0;
      i25 = HEAPU16[i17 + (i21 * 6 | 0) + 4 >> 1] | 0;
     }
     i148 = HEAP32[i40 >> 2] | 0;
     HEAP32[i115 + (i22 * 40 | 0) >> 2] = HEAP32[i148 + (i23 * 12 | 0) >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 4 >> 2] = HEAP32[i148 + (i23 * 12 | 0) + 4 >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 8 >> 2] = HEAP32[i148 + (i23 * 12 | 0) + 8 >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 12 >> 2] = HEAP32[i148 + (i24 * 12 | 0) >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 16 >> 2] = HEAP32[i148 + (i24 * 12 | 0) + 4 >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 20 >> 2] = HEAP32[i148 + (i24 * 12 | 0) + 8 >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 24 >> 2] = HEAP32[i148 + (i25 * 12 | 0) >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 28 >> 2] = HEAP32[i148 + (i25 * 12 | 0) + 4 >> 2];
     HEAP32[i115 + (i22 * 40 | 0) + 32 >> 2] = HEAP32[i148 + (i25 * 12 | 0) + 8 >> 2];
     HEAP8[i115 + (i22 * 40 | 0) + 36 >> 0] = HEAP8[i100 + i21 >> 0] | 0;
     i22 = i22 + 1 | 0;
    } while ((i22 | 0) != (i18 | 0));
    HEAP32[i106 >> 2] = HEAP32[i111 >> 2];
    HEAP32[i106 + 4 >> 2] = HEAP32[i111 + 4 >> 2];
    HEAP32[i106 + 8 >> 2] = HEAP32[i111 + 8 >> 2];
    if (i19) {
     i17 = i12;
     f26 = f7;
     f27 = f8;
     f28 = f10;
     i12 = 0;
    } else {
     i22 = i12;
     i12 = 0;
     i23 = 0;
     while (1) {
      HEAP32[i112 >> 2] = 0;
      i21 = i23 + i29 | 0;
      __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i114, i103, i115 + (i23 * 40 | 0) | 0, i21, HEAP8[i115 + (i23 * 40 | 0) + 36 >> 0] | 0, i108, i116, i104, i110, i109, i112) | 0;
      i20 = HEAP32[i112 >> 2] | 0;
      if (!i20) i17 = i22; else {
       i12 = HEAP32[i37 >> 2] | 0;
       if (i20 >>> 0 > 1) {
        i17 = i12;
        i18 = 0;
        i19 = 1;
        while (1) {
         i12 = HEAP32[i109 + (i19 << 6) + 44 >> 2] | 0;
         f147 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f147 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
          HEAP32[i89 >> 2] = HEAP32[i113 >> 2];
          HEAP32[i89 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
          HEAP32[i89 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
          i18 = i19;
         } else i12 = i17;
         i19 = i19 + 1 | 0;
         if ((i19 | 0) == (i20 | 0)) break; else i17 = i12;
        }
       } else i18 = 0;
       f147 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f147 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
        HEAP32[i106 >> 2] = HEAP32[i89 >> 2];
        HEAP32[i106 + 4 >> 2] = HEAP32[i89 + 4 >> 2];
        HEAP32[i106 + 8 >> 2] = HEAP32[i89 + 8 >> 2];
        f7 = Math_fround(HEAPF32[i109 + (i18 << 6) + 16 >> 2]);
        f8 = Math_fround(HEAPF32[i109 + (i18 << 6) + 20 >> 2]);
        f10 = Math_fround(HEAPF32[i109 + (i18 << 6) + 24 >> 2]);
        i15 = HEAP32[i109 + (i18 << 6) + 40 >> 2] | 0;
        i14 = HEAP32[i109 + (i18 << 6) + 36 >> 2] | 0;
        i17 = HEAP32[i109 + (i18 << 6) + 32 >> 2] | 0;
        i4 = i21;
        i16 = i12;
       } else i17 = i22;
       i12 = 1;
      }
      i23 = i23 + 1 | 0;
      if ((i23 | 0) == (i30 | 0)) {
       f26 = f7;
       f27 = f8;
       f28 = f10;
       break;
      } else i22 = i17;
     }
    }
   };
   HEAP32[i111 >> 2] = HEAP32[i106 >> 2];
   HEAP32[i111 + 4 >> 2] = HEAP32[i106 + 4 >> 2];
   HEAP32[i111 + 8 >> 2] = HEAP32[i106 + 8 >> 2];
   i32 = i32 | i12;
   i31 = i31 + 1 | 0;
   if ((i31 | 0) == (i36 | 0)) break; else {
    i12 = i17;
    f7 = f26;
    f8 = f27;
    f10 = f28;
    i33 = i33 + 32 | 0;
   }
  }
  if (!i32) {
   f7 = f11;
   i128 = 28;
   break;
  }
  i4 = HEAP32[i35 + (i4 << 2) >> 2] | 0;
  f147 = Math_fround(HEAPF32[i104 >> 2]);
  f13 = Math_fround(HEAPF32[i81 >> 2]);
  f144 = Math_fround(HEAPF32[i82 >> 2]);
  f146 = Math_fround(HEAPF32[i83 >> 2]);
  f9 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(Math_fround(f146 * f146) + Math_fround(-.5));
  f145 = Math_fround(Math_fround(Math_fround(f9 * f147) + Math_fround(f6 * f13)) + Math_fround(f7 * f144));
  f10 = Math_fround(Math_fround(Math_fround(f147 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f7 * f13) - Math_fround(f6 * f144))) + Math_fround(f9 * f2))) * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(f13 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f9 * f144) - Math_fround(f7 * f147))) + Math_fround(f6 * f2))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(Math_fround(f144 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f6 * f147) - Math_fround(f9 * f13))) + Math_fround(f7 * f2))) * Math_fround(2.0));
  f9 = Math_fround(HEAPF32[i80 >> 2]);
  f6 = Math_fround(HEAPF32[i85 >> 2]);
  f145 = Math_fround(Math_fround(Math_fround(f26 * f147) + Math_fround(f27 * f13)) + Math_fround(f28 * f144));
  f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f147 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f28 * f13) - Math_fround(f27 * f144))) + Math_fround(f26 * f2))) * Math_fround(2.0)));
  f6 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f13 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f26 * f144) - Math_fround(f28 * f147))) + Math_fround(f27 * f2))) * Math_fround(2.0)));
  f2 = Math_fround(Math_fround(HEAPF32[i86 >> 2]) + Math_fround(Math_fround(Math_fround(f144 * f145) + Math_fround(Math_fround(f146 * Math_fround(Math_fround(f27 * f147) - Math_fround(f26 * f13))) + Math_fround(f28 * f2))) * Math_fround(2.0)));
  f13 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f13 <= Math_fround(0.0))) {
   i3 = i119;
   i128 = 27;
   break;
  }
  f145 = Math_fround(f13 * f10);
  f146 = Math_fround(f13 * f8);
  f147 = Math_fround(f13 * f7);
  f1 = Math_fround(f1 - f145);
  f5 = Math_fround(f5 - f146);
  f11 = Math_fround(f11 - f147);
  f145 = Math_fround((HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f145);
  f146 = Math_fround((HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f146);
  f147 = Math_fround((HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f147);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f145, HEAP32[tempDoublePtr >> 2] | 0);
  i42 = (HEAPF32[tempDoublePtr >> 2] = f146, HEAP32[tempDoublePtr >> 2] | 0);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f147, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i97 >> 2] = f145;
  HEAPF32[i98 >> 2] = f146;
  HEAPF32[i99 >> 2] = f147;
  i119 = i119 + 1 | 0;
  if (i119 >>> 0 >= 4) {
   f8 = f1;
   f7 = f2;
   i3 = 1;
   break;
  } else {
   i12 = i17;
   f7 = f26;
   f8 = f27;
   f10 = f28;
   i3 = 1;
  }
 }
 if ((i128 | 0) == 27) if (!i3) {
  HEAPF32[i121 >> 2] = Math_fround(0.0);
  HEAPF32[i122 >> 2] = f9;
  HEAPF32[i123 >> 2] = f6;
  HEAPF32[i124 >> 2] = f2;
  HEAPF32[i125 >> 2] = f10;
  HEAPF32[i126 >> 2] = f8;
  HEAPF32[i127 >> 2] = f7;
  HEAP32[i120 >> 2] = i4;
  i148 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i129);
  STACKTOP = i130;
  return i148 | 0;
 } else {
  f7 = f11;
  i3 = 1;
  i128 = 28;
 }
 if ((i128 | 0) == 28) {
  f8 = f1;
  f11 = f7;
  f7 = f2;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f5 * f5) + Math_fround(f8 * f8)))));
 f2 = Math_fround(Math_fround(1.0) / f1);
 if (!i3) {
  i148 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i129);
  STACKTOP = i130;
  return i148 | 0;
 }
 f147 = Math_fround(f11 * f2);
 f146 = Math_fround(f5 * f2);
 f145 = Math_fround(f8 * f2);
 HEAPF32[i121 >> 2] = Math_fround(-f1);
 HEAPF32[i122 >> 2] = f9;
 HEAPF32[i123 >> 2] = f6;
 HEAPF32[i124 >> 2] = f7;
 HEAPF32[i125 >> 2] = f145;
 HEAPF32[i126 >> 2] = f146;
 HEAPF32[i127 >> 2] = f147;
 HEAP32[i120 >> 2] = i4;
 i148 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i129);
 STACKTOP = i130;
 return i148 | 0;
}

function __ZN14ParticleSystem16UpdateProceduralERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles(i43, i44, i45, i46) {
 i43 = i43 | 0;
 i44 = i44 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, i82 = 0, f83 = f0, i84 = 0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i50 + 72 | 0;
 i47 = i50 + 60 | 0;
 i39 = i50 + 56 | 0;
 i48 = i50 + 44 | 0;
 i49 = i50 + 32 | 0;
 i40 = i50 + 16 | 0;
 i31 = i50;
 i9 = i45 + 468 | 0;
 i22 = i45 + 480 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 if (!i23) {
  STACKTOP = i50;
  return;
 }
 i38 = i44 + 280 | 0;
 i7 = (HEAP32[i38 >> 2] | 0) != 1 ? gb + 1162292 | 0 : i45 + 116 | 0;
 i41 = i43 + 44 | 0;
 __ZNK13InitialModule10GetGravityERK27ParticleSystemReadOnlyStateRK19ParticleSystemState(i42, HEAP32[i41 >> 2] | 0, i44, i45);
 f4 = Math_fround(HEAPF32[(HEAP32[i41 >> 2] | 0) + 2356 >> 2]);
 f2 = Math_fround(HEAPF32[i42 >> 2]);
 f3 = Math_fround(HEAPF32[i42 + 4 >> 2]);
 f2 = Math_fround(f4 * f2);
 f3 = Math_fround(f4 * f3);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i42 + 8 >> 2]));
 if ((HEAP32[i38 >> 2] | 0) == 1) {
  f34 = f2;
  f35 = f3;
 } else {
  f11 = Math_fround(HEAPF32[i45 + 180 >> 2]);
  f17 = Math_fround(HEAPF32[i45 + 184 >> 2]);
  f20 = Math_fround(HEAPF32[i45 + 188 >> 2]);
  f13 = Math_fround(HEAPF32[i45 + 196 >> 2]);
  f19 = Math_fround(HEAPF32[i45 + 200 >> 2]);
  f21 = Math_fround(HEAPF32[i45 + 204 >> 2]);
  f34 = Math_fround(HEAPF32[i45 + 212 >> 2]);
  f35 = Math_fround(HEAPF32[i45 + 216 >> 2]);
  f34 = Math_fround(Math_fround(Math_fround(f2 * f11) + Math_fround(f3 * f13)) + Math_fround(f4 * f34));
  f35 = Math_fround(Math_fround(Math_fround(f2 * f17) + Math_fround(f3 * f19)) + Math_fround(f4 * f35));
  f4 = Math_fround(Math_fround(Math_fround(f2 * f20) + Math_fround(f3 * f21)) + Math_fround(f4 * Math_fround(HEAPF32[i45 + 220 >> 2])));
 }
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = 0;
 i5 = 0;
 do {
  i1 = (HEAP32[i6 + (i5 * 24 | 0) + 16 >> 2] | 0) + i1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i23 | 0));
 __ZN23ParticleSystemParticles13array_reserveEj(i46, i1 + 34 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i46, i1);
 HEAP32[i47 >> 2] = 0;
 i38 = i47 + 4 | 0;
 i37 = gb + 63160 | 0;
 i5 = HEAP32[i37 + 4 >> 2] | 0;
 i1 = i38;
 HEAP32[i1 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i23 << 2;
 i5 = i1 + 4 | 0;
 do if (!i5) i1 = 0; else {
  i6 = i1 + 7 | 0;
  if (i6 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i6 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 3378) | 0;
   i36 = gb + 64016 | 0;
   i33 = HEAP32[i36 >> 2] | 0;
   i36 = HEAP32[i36 + 4 >> 2] | 0;
   HEAP32[i47 >> 2] = i1;
   i37 = i38;
   HEAP32[i37 >> 2] = i33;
   HEAP32[i37 + 4 >> 2] = i36;
   break;
  }
 } while (0);
 i18 = i1 + 3 & -4;
 HEAP32[i39 >> 2] = 0;
 i5 = i45 + 292 | 0;
 i1 = 0;
 i6 = 0;
 do {
  i37 = (HEAP32[i9 >> 2] | 0) + (i1 * 24 | 0) | 0;
  HEAP32[i18 + (i1 << 2) >> 2] = i6;
  __ZN13InitialModule18GenerateProceduralERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fRK8Vector3fRK24ParticleSystemEmitReplayRj(HEAP32[i41 >> 2] | 0, i44, i46, i7, i5, i37, i39);
  i1 = i1 + 1 | 0;
  i6 = HEAP32[i39 >> 2] | 0;
 } while ((i1 | 0) != (i23 | 0));
 HEAP32[i18 + (i23 << 2) >> 2] = i6;
 __ZN23ParticleSystemParticles12array_resizeEj(i46, HEAP32[i39 >> 2] | 0);
 if (HEAP8[i43 + 52 >> 0] | 0) __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb(i43 + 48 | 0, i44, i45, i46, i7, 0, 1);
 i1 = HEAP32[i43 + 920 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN12LightsModule5StartER23ParticleSystemParticlesjj(i1, i46, 0, HEAP32[i39 >> 2] | 0);
 HEAP32[i48 >> 2] = 0;
 i37 = i48 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i37;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = HEAP32[i39 >> 2] | 0;
 i1 = i8 << 2;
 do if (!i1) {
  i1 = 0;
  i5 = i8;
 } else {
  i5 = i1 + 15 | 0;
  if (i5 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i5 = i8;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 0, gb + 612988 | 0, 3400) | 0;
   i6 = gb + 64016 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i48 >> 2] = i1;
   i7 = i37;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = gb + 63160 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = HEAP32[i39 >> 2] | 0;
   break;
  }
 } while (0);
 i30 = i1 + 15 & -16;
 HEAP32[i49 >> 2] = 0;
 i36 = i49 + 4 | 0;
 i1 = i36;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i5 << 2;
 do if (!i1) i1 = 0; else {
  i5 = i1 + 15 | 0;
  if (i5 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 0, gb + 612988 | 0, 3401) | 0;
   i32 = gb + 64016 | 0;
   i29 = HEAP32[i32 >> 2] | 0;
   i32 = HEAP32[i32 + 4 >> 2] | 0;
   HEAP32[i49 >> 2] = i1;
   i33 = i36;
   HEAP32[i33 >> 2] = i29;
   HEAP32[i33 + 4 >> 2] = i32;
   break;
  }
 } while (0);
 i29 = i1 + 15 & -16;
 f17 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i44 + 264 >> 2]));
 i15 = HEAP32[i9 >> 2] | 0;
 i16 = i46 + 12 | 0;
 i1 = 0;
 i14 = 0;
 while (1) {
  f3 = Math_fround(f17 * Math_fround(HEAPF32[i15 + (i1 * 24 | 0) >> 2]));
  i6 = i15 + (i1 * 24 | 0) + 20 | 0;
  f11 = Math_fround((HEAP32[i6 >> 2] | 0) >>> 0);
  i7 = HEAP32[i18 + (i14 << 2) >> 2] | 0;
  i14 = i14 + 1 | 0;
  i8 = HEAP32[i18 + (i14 << 2) >> 2] | 0;
  if (i7 >>> 0 < i8 >>> 0) {
   i9 = i15 + (i1 * 24 | 0) + 8 | 0;
   i10 = i15 + (i1 * 24 | 0) + 12 | 0;
   i12 = i15 + (i1 * 24 | 0) + 4 | 0;
   i5 = i7;
   f2 = Math_fround(0.0);
   do {
    if (f2 < f11) {
     f13 = Math_fround(f2 + Math_fround(HEAPF32[i9 >> 2]));
     f13 = Math_fround(f13 * Math_fround(HEAPF32[i10 >> 2]));
    } else f13 = Math_fround(0.0);
    HEAPF32[i30 + (i5 << 2) >> 2] = f3;
    HEAPF32[i29 + (i5 << 2) >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i12 >> 2]));
    f2 = Math_fround(f2 + Math_fround(1.0));
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i8 >>> 0);
  }
  if ((i7 | 0) == (HEAP32[i16 >> 2] | 0)) {
   i33 = (HEAP32[i22 >> 2] | 0) + -1 | 0;
   HEAP32[i15 + (i1 * 24 | 0) >> 2] = HEAP32[i15 + (i33 * 24 | 0) >> 2];
   HEAP32[i15 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i15 + (i33 * 24 | 0) + 4 >> 2];
   HEAP32[i15 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i15 + (i33 * 24 | 0) + 8 >> 2];
   HEAP32[i15 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i15 + (i33 * 24 | 0) + 12 >> 2];
   HEAP32[i15 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i15 + (i33 * 24 | 0) + 16 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i15 + (i33 * 24 | 0) + 20 >> 2];
   HEAP32[i22 >> 2] = i33;
   i1 = i1 + -1 | 0;
  }
  if ((i14 | 0) == (i23 | 0)) break; else i1 = i1 + 1 | 0;
 }
 if (!(HEAP32[i39 >> 2] | 0)) i1 = 0; else {
  i8 = i42 + 4 | 0;
  i9 = i42 + 8 | 0;
  i10 = i42 + 12 | 0;
  i12 = i46 + 500 | 0;
  i14 = i31 + 4 | 0;
  i15 = i31 + 8 | 0;
  i16 = i31 + 12 | 0;
  i18 = i46 + 60 | 0;
  i22 = i46 + 80 | 0;
  i23 = i46 + 100 | 0;
  i24 = i40 + 4 | 0;
  i25 = i40 + 8 | 0;
  i26 = i40 + 12 | 0;
  i27 = i46 + 20 | 0;
  i28 = i46 + 40 | 0;
  i7 = 0;
  do {
   i55 = i30 + (i7 << 2) | 0;
   i33 = HEAP32[i55 + 4 >> 2] | 0;
   i5 = HEAP32[i55 + 8 >> 2] | 0;
   i1 = HEAP32[i55 + 12 >> 2] | 0;
   HEAP32[i42 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i8 >> 2] = i33;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i10 >> 2] = i1;
   i1 = i29 + (i7 << 2) | 0;
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   i1 = HEAP32[i41 >> 2] | 0;
   i5 = i1 + 272 | 0;
   i33 = (HEAP32[i12 >> 2] | 0) + (i7 << 2) | 0;
   i55 = (HEAP32[i33 >> 2] | 0) + -1767223837 | 0;
   i53 = (HEAP32[i33 + 4 >> 2] | 0) + -1767223837 | 0;
   i51 = (HEAP32[i33 + 8 >> 2] | 0) + -1767223837 | 0;
   i33 = (HEAP32[i33 + 12 >> 2] | 0) + -1767223837 | 0;
   i54 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
   i52 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
   i32 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
   i6 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
   i55 = i55 << 11 ^ i55;
   i53 = i53 << 11 ^ i53;
   i51 = i51 << 11 ^ i51;
   i33 = i33 << 11 ^ i33;
   f17 = Math_fround(Math_fround((i54 ^ i55 ^ i55 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f19 = Math_fround(Math_fround((i52 ^ i53 ^ i53 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f20 = Math_fround(Math_fround((i32 ^ i51 ^ i51 >>> 8) & 8388607 ^ i32 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f21 = Math_fround(Math_fround((i6 ^ i33 ^ i33 >>> 8) & 8388607 ^ i6 >>> 19 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i31 >> 2] = f17;
   HEAPF32[i14 >> 2] = f19;
   HEAPF32[i15 >> 2] = f20;
   HEAPF32[i16 >> 2] = f21;
   i6 = HEAP32[i1 + 356 >> 2] | 0;
   L55 : do switch ((i6 & 65535) << 16 >> 16) {
   case 0:
    {
     i55 = HEAP32[i1 + 352 >> 2] | 0;
     HEAP32[i26 >> 2] = i55;
     HEAP32[i25 >> 2] = i55;
     HEAP32[i24 >> 2] = i55;
     HEAP32[i40 >> 2] = i55;
     break;
    }
   case 3:
    {
     f57 = Math_fround(HEAPF32[(HEAP32[i1 + 504 >> 2] | 0) + 4 >> 2]);
     f56 = Math_fround(HEAPF32[i1 + 352 >> 2]);
     f57 = Math_fround(f57 * f56);
     f56 = Math_fround(Math_fround(f56 * Math_fround(HEAPF32[(HEAP32[i1 + 416 >> 2] | 0) + 4 >> 2])) - f57);
     f19 = Math_fround(f57 + Math_fround(f56 * f19));
     f20 = Math_fround(f57 + Math_fround(f56 * f20));
     f21 = Math_fround(f57 + Math_fround(f21 * f56));
     HEAPF32[i40 >> 2] = Math_fround(f57 + Math_fround(f17 * f56));
     HEAPF32[i24 >> 2] = f19;
     HEAPF32[i25 >> 2] = f20;
     HEAPF32[i26 >> 2] = f21;
     break;
    }
   default:
    if (!(i6 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i40, i5, i42, i31);
     break L55;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i40, i5, i42, i31);
     break L55;
    }
   } while (0);
   i84 = (HEAP32[i18 >> 2] | 0) + (i7 << 2) | 0;
   f59 = Math_fround(HEAPF32[i84 >> 2]);
   f58 = Math_fround(HEAPF32[i84 + 4 >> 2]);
   f72 = Math_fround(HEAPF32[i84 + 8 >> 2]);
   f70 = Math_fround(HEAPF32[i84 + 12 >> 2]);
   i84 = (HEAP32[i22 >> 2] | 0) + (i7 << 2) | 0;
   f68 = Math_fround(HEAPF32[i84 >> 2]);
   f66 = Math_fround(HEAPF32[i84 + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i84 + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i84 + 12 >> 2]);
   i84 = (HEAP32[i23 >> 2] | 0) + (i7 << 2) | 0;
   f71 = Math_fround(HEAPF32[i84 >> 2]);
   f73 = Math_fround(HEAPF32[i84 + 4 >> 2]);
   f74 = Math_fround(HEAPF32[i84 + 8 >> 2]);
   f75 = Math_fround(HEAPF32[i84 + 12 >> 2]);
   f20 = Math_fround(HEAPF32[i40 >> 2]);
   f59 = Math_fround(f59 * f20);
   f21 = Math_fround(HEAPF32[i24 >> 2]);
   f58 = Math_fround(f58 * f21);
   f56 = Math_fround(HEAPF32[i25 >> 2]);
   f72 = Math_fround(f72 * f56);
   f57 = Math_fround(HEAPF32[i26 >> 2]);
   f70 = Math_fround(f70 * f57);
   f68 = Math_fround(f68 * f20);
   f66 = Math_fround(f66 * f21);
   f17 = Math_fround(f17 * f56);
   f19 = Math_fround(f19 * f57);
   f20 = Math_fround(f71 * f20);
   f21 = Math_fround(f73 * f21);
   f56 = Math_fround(f74 * f56);
   f57 = Math_fround(f75 * f57);
   f75 = Math_fround(f34 * f2);
   f74 = Math_fround(f34 * f3);
   f73 = Math_fround(f34 * f11);
   f71 = Math_fround(f34 * f13);
   f69 = Math_fround(f35 * f2);
   f67 = Math_fround(f35 * f3);
   f65 = Math_fround(f35 * f11);
   f64 = Math_fround(f35 * f13);
   f63 = Math_fround(f4 * f2);
   f62 = Math_fround(f4 * f3);
   f61 = Math_fround(f4 * f11);
   f60 = Math_fround(f4 * f13);
   f89 = Math_fround(f2 * Math_fround(.5));
   f88 = Math_fround(f3 * Math_fround(.5));
   f87 = Math_fround(f11 * Math_fround(.5));
   f85 = Math_fround(f13 * Math_fround(.5));
   f86 = Math_fround(Math_fround(f75 * f89) + Math_fround(f2 * f59));
   f96 = Math_fround(Math_fround(f74 * f88) + Math_fround(f3 * f58));
   f95 = Math_fround(Math_fround(f73 * f87) + Math_fround(f11 * f72));
   f94 = Math_fround(Math_fround(f71 * f85) + Math_fround(f13 * f70));
   f93 = Math_fround(Math_fround(f89 * f69) + Math_fround(f2 * f68));
   f92 = Math_fround(Math_fround(f88 * f67) + Math_fround(f3 * f66));
   f91 = Math_fround(Math_fround(f87 * f65) + Math_fround(f11 * f17));
   f90 = Math_fround(Math_fround(f85 * f64) + Math_fround(f13 * f19));
   f89 = Math_fround(Math_fround(f89 * f63) + Math_fround(f2 * f20));
   f88 = Math_fround(Math_fround(f88 * f62) + Math_fround(f3 * f21));
   f87 = Math_fround(Math_fround(f87 * f61) + Math_fround(f11 * f56));
   f2 = Math_fround(Math_fround(f85 * f60) + Math_fround(f13 * f57));
   i84 = (HEAP32[i46 >> 2] | 0) + (i7 << 2) | 0;
   f85 = Math_fround(HEAPF32[i84 >> 2]);
   i82 = i84 + 4 | 0;
   f83 = Math_fround(HEAPF32[i82 >> 2]);
   i5 = i84 + 8 | 0;
   f81 = Math_fround(HEAPF32[i5 >> 2]);
   i6 = i84 + 12 | 0;
   f80 = Math_fround(HEAPF32[i6 >> 2]);
   i32 = (HEAP32[i27 >> 2] | 0) + (i7 << 2) | 0;
   f79 = Math_fround(HEAPF32[i32 >> 2]);
   i33 = i32 + 4 | 0;
   f78 = Math_fround(HEAPF32[i33 >> 2]);
   i51 = i32 + 8 | 0;
   f77 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i32 + 12 | 0;
   f76 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = (HEAP32[i28 >> 2] | 0) + (i7 << 2) | 0;
   f13 = Math_fround(HEAPF32[i53 >> 2]);
   i54 = i53 + 4 | 0;
   f11 = Math_fround(HEAPF32[i54 >> 2]);
   i55 = i53 + 8 | 0;
   f3 = Math_fround(HEAPF32[i55 >> 2]);
   i1 = i53 + 12 | 0;
   f83 = Math_fround(f96 + f83);
   f81 = Math_fround(f95 + f81);
   f80 = Math_fround(f94 + f80);
   f79 = Math_fround(f93 + f79);
   f78 = Math_fround(f92 + f78);
   f77 = Math_fround(f91 + f77);
   f76 = Math_fround(f90 + f76);
   f13 = Math_fround(f89 + f13);
   f11 = Math_fround(f88 + f11);
   f3 = Math_fround(f87 + f3);
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i84 >> 2] = Math_fround(f86 + f85);
   HEAPF32[i82 >> 2] = f83;
   HEAPF32[i5 >> 2] = f81;
   HEAPF32[i6 >> 2] = f80;
   HEAPF32[i32 >> 2] = f79;
   HEAPF32[i33 >> 2] = f78;
   HEAPF32[i51 >> 2] = f77;
   HEAPF32[i52 >> 2] = f76;
   HEAPF32[i53 >> 2] = f13;
   HEAPF32[i54 >> 2] = f11;
   HEAPF32[i55 >> 2] = f3;
   HEAPF32[i1 >> 2] = f2;
   f59 = Math_fround(f75 + f59);
   f58 = Math_fround(f74 + f58);
   f2 = Math_fround(f73 + f72);
   f3 = Math_fround(f71 + f70);
   f11 = Math_fround(f69 + f68);
   f13 = Math_fround(f67 + f66);
   f17 = Math_fround(f65 + f17);
   f19 = Math_fround(f64 + f19);
   f20 = Math_fround(f63 + f20);
   f21 = Math_fround(f62 + f21);
   f56 = Math_fround(f61 + f56);
   f57 = Math_fround(f60 + f57);
   i1 = (HEAP32[i18 >> 2] | 0) + (i7 << 2) | 0;
   HEAPF32[i1 >> 2] = f59;
   HEAPF32[i1 + 4 >> 2] = f58;
   HEAPF32[i1 + 8 >> 2] = f2;
   HEAPF32[i1 + 12 >> 2] = f3;
   i1 = (HEAP32[i22 >> 2] | 0) + (i7 << 2) | 0;
   HEAPF32[i1 >> 2] = f11;
   HEAPF32[i1 + 4 >> 2] = f13;
   HEAPF32[i1 + 8 >> 2] = f17;
   HEAPF32[i1 + 12 >> 2] = f19;
   i1 = (HEAP32[i23 >> 2] | 0) + (i7 << 2) | 0;
   HEAPF32[i1 >> 2] = f20;
   HEAPF32[i1 + 4 >> 2] = f21;
   HEAPF32[i1 + 8 >> 2] = f56;
   HEAPF32[i1 + 12 >> 2] = f57;
   i7 = i7 + 4 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
  } while (i7 >>> 0 < i1 >>> 0);
  if (!i1) i1 = 0; else {
   i23 = i46 + 520 | 0;
   i24 = i40 + 4 | 0;
   i25 = i40 + 8 | 0;
   i26 = i40 + 12 | 0;
   i27 = i43 + 36 | 0;
   i28 = i43 + 40 | 0;
   i29 = i42 + 4 | 0;
   i30 = i42 + 8 | 0;
   i31 = i42 + 12 | 0;
   i32 = i42 + 16 | 0;
   i33 = i42 + 20 | 0;
   i22 = 0;
   i5 = i1;
   i7 = 0;
   i8 = 2;
   i9 = 3;
   i10 = 1;
   while (1) {
    i84 = (HEAP32[i23 >> 2] | 0) + (i22 << 2) | 0;
    f94 = Math_fround(HEAPF32[i84 >> 2]);
    f95 = Math_fround(HEAPF32[i84 + 4 >> 2]);
    f96 = Math_fround(HEAPF32[i84 + 8 >> 2]);
    i55 = (f94 > Math_fround(100.0)) << 31 >> 31;
    i54 = (f95 > Math_fround(100.0)) << 31 >> 31;
    i82 = (f96 > Math_fround(100.0)) << 31 >> 31;
    i84 = (Math_fround(HEAPF32[i84 + 12 >> 2]) > Math_fround(100.0)) << 31 >> 31;
    i55 = (i7 | 0) < (i5 | 0) ? i55 : 0;
    i54 = (i10 | 0) < (i5 | 0) ? i54 : 0;
    i82 = (i8 | 0) < (i5 | 0) ? i82 : 0;
    i84 = (i9 | 0) < (i5 | 0) ? i84 : 0;
    HEAP32[i40 >> 2] = i55;
    HEAP32[i24 >> 2] = i54;
    HEAP32[i25 >> 2] = i82;
    HEAP32[i26 >> 2] = i84;
    if ((i54 | i55 | i82 | i84 | 0) > -1) {
     i6 = i22 + 4 | 0;
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } else {
     i18 = 3;
     while (1) {
      if (HEAP32[i40 + (i18 << 2) >> 2] | 0) {
       i12 = HEAP32[i27 >> 2] | 0;
       i14 = HEAP32[i28 >> 2] | 0;
       i16 = i18 + i22 | 0;
       i15 = i14 + 428 | 0;
       if (HEAP32[i15 >> 2] | 0) {
        i5 = i14 + 496 | 0;
        i6 = i14 + 424 | 0;
        i1 = 0;
        do {
         i84 = HEAP32[i5 >> 2] | 0;
         HEAPF32[i42 >> 2] = Math_fround(0.0);
         HEAPF32[i29 >> 2] = Math_fround(0.0);
         HEAP32[i30 >> 2] = i84;
         i84 = (Math_imul(i84, 1812433253) | 0) + 1 | 0;
         HEAP32[i31 >> 2] = i84;
         i84 = (Math_imul(i84, 1812433253) | 0) + 1 | 0;
         HEAP32[i32 >> 2] = i84;
         HEAP32[i33 >> 2] = (Math_imul(i84, 1812433253) | 0) + 1;
         __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i42, (HEAP32[i6 >> 2] | 0) + (i1 * 600 | 0) | 0, i12, i14, i46, 2, i1, i16, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
         i1 = i1 + 1 | 0;
        } while (i1 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
        i1 = HEAP32[i39 >> 2] | 0;
       }
       __ZN23ParticleSystemParticles14element_assignEjj(i46, i16, i1 + -1 | 0);
       i1 = (HEAP32[i39 >> 2] | 0) + -1 | 0;
       HEAP32[i39 >> 2] = i1;
      }
      if ((i18 | 0) > 0) i18 = i18 + -1 | 0; else {
       i6 = i22;
       i5 = i1;
       break;
      }
     }
    }
    if (i6 >>> 0 < i1 >>> 0) i22 = i6; else break;
   }
  }
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i46, i1);
 i1 = HEAP32[i43 + 856 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) {
  i84 = HEAP32[(HEAP32[i41 >> 2] | 0) + 2540 >> 2] | 0;
  HEAP32[i42 + 12 >> 2] = i84;
  HEAP32[i42 + 8 >> 2] = i84;
  HEAP32[i42 + 4 >> 2] = i84;
  HEAP32[i42 >> 2] = i84;
  __ZN14RotationModule16UpdateProceduralERK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4E(i1, i45, i46, i42);
 }
 i1 = HEAP32[i43 + 868 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN14VelocityModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles(i1, i44, i45, i46);
 i1 = HEAP32[i43 + 876 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN11ForceModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles(i1, i44, i45, i46);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i49 >> 2] | 0, i36);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i48 >> 2] | 0, i37);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i47 >> 2] | 0, i38);
 STACKTOP = i50;
 return;
}

function __ZN13AudioProfiler19CaptureChannelGroupEPN4FMOD12ChannelGroupERNS_27AudioProfilerCaptureContextEi(i46, i47, i4) {
 i46 = i46 | 0;
 i47 = i47 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i50 + 192 | 0;
 i11 = i50 + 120 | 0;
 i1 = i50 + 188 | 0;
 i3 = i50 + 187 | 0;
 i45 = i50 + 112 | 0;
 i48 = i50 + 48 | 0;
 i49 = i50 + 40 | 0;
 i34 = i50 + 36 | 0;
 i35 = i50 + 32 | 0;
 i36 = i50 + 28 | 0;
 i37 = i50 + 16 | 0;
 i38 = i50 + 186 | 0;
 i39 = i50 + 185 | 0;
 i40 = i50 + 184 | 0;
 i41 = i50 + 12 | 0;
 i42 = i50 + 8 | 0;
 i43 = i50 + 4 | 0;
 i44 = i50;
 if (__ZN4FMOD12ChannelGroup7getNameEPci(i46, i5, 63) | 0) {
  i49 = 0;
  STACKTOP = i50;
  return i49 | 0;
 }
 i6 = i11;
 i7 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 if (!(__ZN4FMOD12ChannelGroup9getVolumeEPf(i46, i11 + 36 | 0) | 0)) if (!(__ZN4FMOD12ChannelGroup8getPitchEPf(i46, i11 + 60 | 0) | 0)) if (!(__ZN4FMOD12ChannelGroup7getMuteEPb(i46, i1) | 0)) if (!(__ZN4FMOD12ChannelGroup9getPausedEPb(i46, i3) | 0)) {
  i2 = i11 + 24 | 0;
  i1 = (HEAP8[i1 >> 0] | 0) == 0 ? 64 : 72;
  HEAP32[i2 >> 2] = i1;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i2 >> 2] = i1 | 4;
  HEAP32[i11 + 16 >> 2] = i4;
  i10 = i11 + 20 | 0;
  HEAP32[i10 >> 2] = i46 & 2147483632 | 1;
  i33 = i47 + 12 | 0;
  i1 = HEAP32[i33 >> 2] | 0;
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  if (!(_strcmp(i5, gb + 874313 | 0) | 0)) {
   i6 = i5;
   i2 = gb + 874331 | 0;
   i7 = i6 + 15 | 0;
   do {
    HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
    i6 = i6 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i6 | 0) < (i7 | 0));
  }
  if (_strcmp(i5, gb + 866962 | 0) | 0) if (_strcmp(i5, gb + 867058 | 0) | 0) if (_strcmp(i5, gb + 874346 | 0) | 0) if (_strcmp(i5, gb + 874359 | 0) | 0) if (_strcmp(i5, gb + 874369 | 0) | 0) if (_strcmp(i5, gb + 874384 | 0) | 0) {
   if (HEAP8[i5 >> 0] | 0) {
    i9 = i5;
    do {
     i3 = i1 + 12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = i1 + 16 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i5 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 >= i2 >>> 0) break;
      if ((i7 | 0) > -1) {
       HEAP32[i6 >> 2] = i2;
       HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i32 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
       HEAP32[i6 >> 2] = i2;
       HEAP32[i1 >> 2] = i32;
       break;
      }
     } while (0);
     HEAP32[i3 >> 2] = i5;
     HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = HEAP8[i9 >> 0] | 0;
     i9 = i9 + 1 | 0;
     i1 = HEAP32[i33 >> 2] | 0;
    } while ((HEAP8[i9 >> 0] | 0) != 0);
   }
   i3 = i1 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i1 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i2 = i7 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i2;
     HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i32 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i2;
     HEAP32[i1 >> 2] = i32;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i47 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 >= i1 >>> 0) break;
    if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 6, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i32 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i32;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   i6 = (HEAP32[i2 >> 2] | 0) + (i4 << 6) | 0;
   i2 = i11;
   i7 = i6 + 64 | 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    i6 = i6 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   i4 = i9;
  }
  HEAP32[i45 >> 2] = 0;
  if (!(__ZN4FMOD12ChannelGroup14getNumChannelsEPi(i46, i45) | 0)) {
   if ((HEAP32[i45 >> 2] | 0) > 0) {
    i6 = i48;
    i7 = i6 + 64 | 0;
    do {
     HEAP32[i6 >> 2] = 0;
     i6 = i6 + 4 | 0;
    } while ((i6 | 0) < (i7 | 0));
    HEAP32[i48 + 16 >> 2] = i4;
    i14 = i48 + 20 | 0;
    i15 = i48 + 24 | 0;
    i16 = i48 + 8 | 0;
    i17 = i48 + 4 | 0;
    i18 = i48 + 12 | 0;
    i19 = i48 + 44 | 0;
    i20 = i48 + 48 | 0;
    i21 = i47 + 16 | 0;
    i22 = i37 + 4 | 0;
    i23 = i47 + 20 | 0;
    i24 = i37 + 8 | 0;
    i25 = i47 + 24 | 0;
    i26 = i48 + 32 | 0;
    i27 = i48 + 36 | 0;
    i28 = i48 + 40 | 0;
    i29 = i48 + 52 | 0;
    i30 = i48 + 60 | 0;
    i31 = i48 + 56 | 0;
    i32 = i48 + 28 | 0;
    i1 = 0;
    i13 = 0;
    do {
     HEAP32[i49 >> 2] = 0;
     if (!(__ZN4FMOD12ChannelGroup10getChannelEiPPNS_7ChannelE(i46, i13, i49) | 0)) if (!(__ZN4FMOD7Channel7getModeEPj(HEAP32[i49 >> 2] | 0, i34) | 0)) {
      i2 = HEAP32[i49 >> 2] | 0;
      HEAP32[i14 >> 2] = i2 & 2147483632 | 2;
      do if (!(HEAP32[i34 >> 2] & 16)) i7 = 0; else {
       if (__ZN4FMOD7Channel13get3DPanLevelEPf(i2, i35) | 0) {
        i7 = 0;
        break;
       }
       i7 = Math_fround(HEAPF32[i35 >> 2]) > Math_fround(0.0);
      } while (0);
      HEAP32[i36 >> 2] = 0;
      i12 = (__ZN4FMOD7Channel11getUserDataEPPv(HEAP32[i49 >> 2] | 0, i36) | 0) != 0;
      i5 = HEAP32[i36 >> 2] | 0;
      L63 : do if (!(i12 | (i5 | 0) == 0)) {
       i6 = HEAP32[i5 >> 2] | 0;
       if (!(HEAP8[gb + 1098888 >> 0] | 0)) {
        i2 = gb + 861196 | 0;
        i3 = -1;
        do {
         i3 = HEAP32[gb + 1111240 + ((HEAPU8[i2 >> 0] ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (gb + 861196 + 87 | 0));
        i2 = ~i3;
        HEAP32[gb + 1459936 >> 2] = i2;
        i12 = gb + 1098888 | 0;
        HEAP32[i12 >> 2] = 1;
        HEAP32[i12 + 4 >> 2] = 0;
       } else i2 = HEAP32[gb + 1459936 >> 2] | 0;
       do if ((i6 | 0) == (i2 | 0)) {
        i2 = HEAP32[i5 + 4 >> 2] | 0;
        if (!i2) {
         i5 = 54;
         break;
        }
        i5 = HEAP32[i2 + 240 >> 2] | 0;
        if (HEAP32[i2 + 244 >> 2] & 1 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 32;
        if (!i5) if (i7) {
         i2 = 0;
         i3 = 0;
         i5 = 56;
         break;
        } else {
         i2 = 0;
         i3 = 0;
         i5 = 60;
         break;
        } else {
         i3 = (HEAP32[i5 + 540 >> 2] | 0) != 0;
         if ((i7 | i3) & Math_fround(HEAPF32[(HEAP32[i5 + 92 >> 2] | 0) + 4 >> 2]) > Math_fround(0.0)) {
          i2 = i5;
          i5 = 56;
          break;
         } else {
          i2 = i5;
          i5 = 60;
          break;
         }
        }
       } else i5 = 54; while (0);
       if ((i5 | 0) == 54) {
        HEAP32[i48 >> 2] = 0;
        HEAP32[i16 >> 2] = 1;
        HEAP32[i17 >> 2] = 0;
        HEAP32[i18 >> 2] = 1;
        if (i7) {
         i2 = 0;
         i3 = 0;
         i5 = 56;
        } else {
         i2 = 0;
         i3 = 0;
         i5 = 60;
        }
       }
       L82 : do if ((i5 | 0) == 56) {
        do if (!(__ZN4FMOD7Channel15get3DAttributesEP11FMOD_VECTORS2_(HEAP32[i49 >> 2] | 0, i37, 0) | 0)) {
         if (__ZN4FMOD7Channel19get3DMinMaxDistanceEPfS1_(HEAP32[i49 >> 2] | 0, i19, i20) | 0) break;
         f53 = Math_fround(HEAPF32[i37 >> 2]);
         f53 = Math_fround(f53 - Math_fround(HEAPF32[i21 >> 2]));
         f52 = Math_fround(HEAPF32[i22 >> 2]);
         f52 = Math_fround(f52 - Math_fround(HEAPF32[i23 >> 2]));
         f51 = Math_fround(HEAPF32[i24 >> 2]);
         f51 = Math_fround(f51 - Math_fround(HEAPF32[i25 >> 2]));
         HEAPF32[i26 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f51 * f51))));
         i12 = i2;
         i2 = i3;
         i3 = 1;
         break L82;
        } while (0);
        break L63;
       } else if ((i5 | 0) == 60) {
        HEAPF32[i26 >> 2] = Math_fround(-1.0);
        HEAPF32[i19 >> 2] = Math_fround(1.0e6);
        HEAPF32[i20 >> 2] = Math_fround(1.0e6);
        i12 = i2;
        i2 = i3;
        i3 = 0;
       } while (0);
       if (__ZN4FMOD7Channel9getVolumeEPf(HEAP32[i49 >> 2] | 0, i27) | 0) break;
       if (__ZN4FMOD7Channel13getAudibilityEPf(HEAP32[i49 >> 2] | 0, i28) | 0) break;
       do if (!(__ZN4FMOD7Channel9isPlayingEPb(HEAP32[i49 >> 2] | 0, i37) | 0)) {
        if (__ZN4FMOD7Channel9getPausedEPb(HEAP32[i49 >> 2] | 0, i38) | 0) break;
        if (__ZN4FMOD7Channel9isVirtualEPb(HEAP32[i49 >> 2] | 0, i39) | 0) break;
        if (__ZN4FMOD7Channel7getMuteEPb(HEAP32[i49 >> 2] | 0, i40) | 0) break;
        if (i3) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 1;
        if (i2) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
        if (HEAP8[i38 >> 0] | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4;
        if (HEAP8[i40 >> 0] | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 8;
        if (HEAP8[i39 >> 0] | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 16;
        i2 = HEAP32[i34 >> 2] | 0;
        if (i2 & 128 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 128;
        if (i2 & 512 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 256;
        if (i2 & 2048 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 1024;
        if (i2 & 268435456 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2048;
        if (i2 & 1024 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4096;
        if (i2 & 65536 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 8192;
        if (i2 & 6 | 0) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 512;
        HEAP32[i41 >> 2] = 0;
        do if (!(__ZN4FMOD7Channel11getPositionEPjj(HEAP32[i49 >> 2] | 0, i41, 1) | 0)) {
         HEAPF32[i29 >> 2] = Math_fround(Math_fround((HEAP32[i41 >> 2] | 0) >>> 0) * Math_fround(.00100000005));
         if (__ZN4FMOD7Channel12getFrequencyEPf(HEAP32[i49 >> 2] | 0, i30) | 0) break;
         HEAP32[i42 >> 2] = 0;
         L136 : do if (!(__ZN4FMOD7Channel15getCurrentSoundEPPNS_5SoundE(HEAP32[i49 >> 2] | 0, i42) | 0)) {
          i2 = HEAP32[i42 >> 2] | 0;
          L138 : do if (i2 | 0) {
           HEAP32[i43 >> 2] = 0;
           HEAP32[i44 >> 2] = 0;
           do if (!(__ZN4FMOD5Sound11getUserDataEPPv(i2, i44) | 0)) {
            i5 = HEAP32[i44 >> 2] | 0;
            if (!i5) {
             HEAP32[i48 >> 2] = 0;
             HEAP32[i16 >> 2] = 1;
             HEAP32[i17 >> 2] = 0;
             HEAP32[i18 >> 2] = 1;
             break;
            }
            i6 = HEAP32[i5 >> 2] | 0;
            if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
             i2 = gb + 874396 | 0;
             i3 = -1;
             do {
              i3 = HEAP32[gb + 1111240 + ((HEAPU8[i2 >> 0] ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
              i2 = i2 + 1 | 0;
             } while ((i2 | 0) != (gb + 874396 + 88 | 0));
             i2 = ~i3;
             HEAP32[gb + 1459916 >> 2] = i2;
             i11 = gb + 1098880 | 0;
             HEAP32[i11 >> 2] = 1;
             HEAP32[i11 + 4 >> 2] = 0;
            } else i2 = HEAP32[gb + 1459916 >> 2] | 0;
            if ((i6 | 0) != (i2 | 0)) break;
            i2 = HEAP32[i5 + 4 >> 2] | 0;
            if (!i2) break;
            if (__ZN4FMOD5Sound9getLengthEPjj(HEAP32[i42 >> 2] | 0, i43, 1) | 0) break;
            HEAPF32[i31 >> 2] = Math_fround(Math_fround((HEAP32[i43 >> 2] | 0) >>> 0) * Math_fround(.00100000005));
            i2 = __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE(i2) | 0;
            if (i2 | 0) {
             HEAP32[i32 >> 2] = HEAP32[i2 + 120 >> 2];
             HEAP32[i48 >> 2] = HEAP32[i2 + 4 >> 2];
             HEAP32[i16 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2];
             i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
             i3 = HEAP32[i33 >> 2] | 0;
             if (HEAP8[i2 >> 0] | 0) do {
              i6 = i3 + 12 | 0;
              i7 = HEAP32[i6 >> 2] | 0;
              i8 = i7 + 1 | 0;
              i9 = i3 + 16 | 0;
              i10 = HEAP32[i9 >> 2] | 0;
              i11 = i10 & 2147483647;
              do if (i8 >>> 0 > i11 >>> 0) {
               i5 = i10 << 1;
               i5 = (i5 | 0) == 0 ? 1 : i5;
               if (i11 >>> 0 >= i5 >>> 0) break;
               if ((i10 | 0) > -1) {
                HEAP32[i9 >> 2] = i5;
                HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i5, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
                break;
               } else {
                i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
                _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
                HEAP32[i9 >> 2] = i5;
                HEAP32[i3 >> 2] = i11;
                break;
               }
              } while (0);
              HEAP32[i6 >> 2] = i8;
              HEAP8[(HEAP32[i3 >> 2] | 0) + i7 >> 0] = HEAP8[i2 >> 0] | 0;
              i2 = i2 + 1 | 0;
              i3 = HEAP32[i33 >> 2] | 0;
             } while ((HEAP8[i2 >> 0] | 0) != 0);
             i5 = i3 + 12 | 0;
             i6 = HEAP32[i5 >> 2] | 0;
             i7 = i6 + 1 | 0;
             i8 = i3 + 16 | 0;
             i9 = HEAP32[i8 >> 2] | 0;
             i10 = i9 & 2147483647;
             do if (i7 >>> 0 > i10 >>> 0) {
              i2 = i9 << 1;
              i2 = (i2 | 0) == 0 ? 1 : i2;
              if (i10 >>> 0 >= i2 >>> 0) break;
              if ((i9 | 0) > -1) {
               HEAP32[i8 >> 2] = i2;
               HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
               break;
              } else {
               i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
               _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
               HEAP32[i8 >> 2] = i2;
               HEAP32[i3 >> 2] = i11;
               break;
              }
             } while (0);
             HEAP32[i5 >> 2] = i7;
             HEAP8[(HEAP32[i3 >> 2] | 0) + i6 >> 0] = 0;
            }
            break L138;
           } while (0);
           break L136;
          } while (0);
          if (i12 | 0) {
           HEAP32[i17 >> 2] = HEAP32[(HEAP32[i12 + 28 >> 2] | 0) + 4 >> 2];
           HEAP32[i18 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2];
           i2 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0) | 0;
           i3 = HEAP32[i33 >> 2] | 0;
           if (HEAP8[i2 >> 0] | 0) do {
            i6 = i3 + 12 | 0;
            i7 = HEAP32[i6 >> 2] | 0;
            i8 = i7 + 1 | 0;
            i9 = i3 + 16 | 0;
            i10 = HEAP32[i9 >> 2] | 0;
            i11 = i10 & 2147483647;
            do if (i8 >>> 0 > i11 >>> 0) {
             i5 = i10 << 1;
             i5 = (i5 | 0) == 0 ? 1 : i5;
             if (i11 >>> 0 >= i5 >>> 0) break;
             if ((i10 | 0) > -1) {
              HEAP32[i9 >> 2] = i5;
              HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i5, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
              break;
             } else {
              i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
              _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
              HEAP32[i9 >> 2] = i5;
              HEAP32[i3 >> 2] = i12;
              break;
             }
            } while (0);
            HEAP32[i6 >> 2] = i8;
            HEAP8[(HEAP32[i3 >> 2] | 0) + i7 >> 0] = HEAP8[i2 >> 0] | 0;
            i2 = i2 + 1 | 0;
            i3 = HEAP32[i33 >> 2] | 0;
           } while ((HEAP8[i2 >> 0] | 0) != 0);
           i5 = i3 + 12 | 0;
           i6 = HEAP32[i5 >> 2] | 0;
           i7 = i6 + 1 | 0;
           i8 = i3 + 16 | 0;
           i9 = HEAP32[i8 >> 2] | 0;
           i10 = i9 & 2147483647;
           do if (i7 >>> 0 > i10 >>> 0) {
            i2 = i9 << 1;
            i2 = (i2 | 0) == 0 ? 1 : i2;
            if (i10 >>> 0 >= i2 >>> 0) break;
            if ((i9 | 0) > -1) {
             HEAP32[i8 >> 2] = i2;
             HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
             break;
            } else {
             i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
             _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
             HEAP32[i8 >> 2] = i2;
             HEAP32[i3 >> 2] = i12;
             break;
            }
           } while (0);
           HEAP32[i5 >> 2] = i7;
           HEAP8[(HEAP32[i3 >> 2] | 0) + i6 >> 0] = 0;
          }
          i3 = HEAP32[i47 >> 2] | 0;
          i5 = i3 + 12 | 0;
          i6 = HEAP32[i5 >> 2] | 0;
          i7 = i6 + 1 | 0;
          i8 = i3 + 16 | 0;
          i9 = HEAP32[i8 >> 2] | 0;
          i10 = i9 & 2147483647;
          do if (i7 >>> 0 > i10 >>> 0) {
           i2 = i9 << 1;
           i2 = (i2 | 0) == 0 ? 1 : i2;
           if (i10 >>> 0 >= i2 >>> 0) break;
           if ((i9 | 0) > -1) {
            HEAP32[i8 >> 2] = i2;
            HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 6, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
            break;
           } else {
            i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
            _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] << 6 | 0) | 0;
            HEAP32[i8 >> 2] = i2;
            HEAP32[i3 >> 2] = i12;
            break;
           }
          } while (0);
          HEAP32[i5 >> 2] = i7;
          i6 = (HEAP32[i3 >> 2] | 0) + (i6 << 6) | 0;
          i2 = i48;
          i7 = i6 + 64 | 0;
          do {
           HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
           i6 = i6 + 4 | 0;
           i2 = i2 + 4 | 0;
          } while ((i6 | 0) < (i7 | 0));
          i1 = i1 + 1 | 0;
         } while (0);
        } while (0);
       } while (0);
      } while (0);
     }
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) < (HEAP32[i45 >> 2] | 0));
   } else i1 = 0;
   HEAP32[i48 >> 2] = 0;
   i45 = (__ZN4FMOD12ChannelGroup12getNumGroupsEPi(i46, i48) | 0) == 0;
   if (i45 & (HEAP32[i48 >> 2] | 0) > 0) {
    i2 = 0;
    do {
     if (!(__ZN4FMOD12ChannelGroup8getGroupEiPPS0_(i46, i2, i49) | 0)) i1 = (__ZN13AudioProfiler19CaptureChannelGroupEPN4FMOD12ChannelGroupERNS_27AudioProfilerCaptureContextEi(HEAP32[i49 >> 2] | 0, i47, i4) | 0) + i1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i48 >> 2] | 0));
   }
  } else i1 = 0;
 } else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0;
 i49 = i1;
 STACKTOP = i50;
 return i49 | 0;
}

function _UNITY_FT_Stroker_ConicTo(i55, i1, i58) {
 i55 = i55 | 0;
 i1 = i1 | 0;
 i58 = i58 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i65 + 304 | 0;
 i60 = i65 + 288 | 0;
 i61 = i65 + 16 | 0;
 i62 = i65 + 8 | 0;
 i63 = i65 + 296 | 0;
 i64 = i65;
 if (!((i55 | 0) != 0 & (i1 | 0) != 0 & (i58 | 0) != 0)) {
  i64 = 6;
  STACKTOP = i65;
  return i64 | 0;
 }
 i56 = i55 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i57 = i55 + 12 | 0;
 if (((HEAP32[i56 >> 2] | 0) + 1 - i2 | 0) >>> 0 < 3) {
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  if (((HEAP32[i57 >> 2] | 0) + 1 - i3 | 0) >>> 0 < 3) if ((i2 + 1 - (HEAP32[i58 >> 2] | 0) | 0) >>> 0 < 3) if ((i3 + 1 - (HEAP32[i58 + 4 >> 2] | 0) | 0) >>> 0 < 3) {
   i62 = i58;
   i63 = HEAP32[i62 + 4 >> 2] | 0;
   i64 = i56;
   HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i64 + 4 >> 2] = i63;
   i64 = 0;
   STACKTOP = i65;
   return i64 | 0;
  }
 }
 i30 = i58;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i61;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i1;
 i29 = HEAP32[i28 + 4 >> 2] | 0;
 i30 = i61 + 8 | 0;
 HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i30 + 4 >> 2] = i29;
 i30 = i56;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i61 + 16 | 0;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i55 + 20 | 0;
 i29 = i55 + 4 | 0;
 i30 = i55 + 48 | 0;
 i31 = i55 + 52 | 0;
 i32 = i55 + 60 | 0;
 i33 = i55 + 40 | 0;
 i34 = i55 + 64 | 0;
 i35 = i60 + 4 | 0;
 i36 = i62 + 4 | 0;
 i37 = i63 + 4 | 0;
 i38 = i64 + 4 | 0;
 i39 = i55 + 8 | 0;
 i40 = i60 + 4 | 0;
 i41 = i55 + 84 | 0;
 i42 = i55 + 64 | 0;
 i43 = i55 + 72 | 0;
 i27 = i55 + 76 | 0;
 i44 = i55 + 80 | 0;
 i45 = i55 + 68 | 0;
 i46 = i55 + 88 | 0;
 i47 = i55 + 116 | 0;
 i48 = i55 + 96 | 0;
 i49 = i55 + 104 | 0;
 i26 = i55 + 108 | 0;
 i50 = i55 + 112 | 0;
 i51 = i55 + 100 | 0;
 i52 = i55 + 120 | 0;
 i53 = i55 + 24 | 0;
 i54 = i55 + 36 | 0;
 i2 = 0;
 i1 = i61;
 i13 = 1;
 L11 : while (1) {
  i14 = i1;
  while (1) {
   i7 = HEAP32[i55 >> 2] | 0;
   if ((i2 | 0) >= 30) {
    i25 = i7;
    i9 = i7;
    break;
   }
   i8 = i14 + 8 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i9 = i14 + 16 | 0;
   i1 = i4 - (HEAP32[i9 >> 2] | 0) | 0;
   i10 = i14 + 12 | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i11 = i14 + 20 | 0;
   i3 = i5 - (HEAP32[i11 >> 2] | 0) | 0;
   i4 = (HEAP32[i14 >> 2] | 0) - i4 | 0;
   i12 = i61 + (i2 << 3) + 4 | 0;
   i5 = (HEAP32[i12 >> 2] | 0) - i5 | 0;
   i6 = (i4 + 1 | 0) >>> 0 < 3 & (i5 + 1 | 0) >>> 0 < 3;
   if ((i1 + 1 | 0) >>> 0 < 3 & (i3 + 1 | 0) >>> 0 < 3) if (i6) {
    i3 = i7;
    i1 = i7;
   } else {
    i1 = _UNITY_FT_Atan2(i4, i5) | 0;
    i3 = i1;
   } else {
    i1 = _UNITY_FT_Atan2(i1, i3) | 0;
    if (i6) i3 = i1; else i3 = _UNITY_FT_Atan2(i4, i5) | 0;
   }
   i25 = _UNITY_FT_Angle_Diff(i1, i3) | 0;
   if ((((i25 | 0) > -1 ? i25 : 0 - i25 | 0) | 0) < 1966080) {
    i25 = i3;
    i9 = i1;
    break;
   }
   if (HEAP8[i28 >> 0] | 0) HEAP32[i55 >> 2] = i1;
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i14 + 32 >> 2] = i1;
   i25 = HEAP32[i8 >> 2] | 0;
   i1 = (i25 + i1 | 0) / 2 | 0;
   HEAP32[i14 + 24 >> 2] = i1;
   i25 = ((HEAP32[i14 >> 2] | 0) + i25 | 0) / 2 | 0;
   HEAP32[i8 >> 2] = i25;
   HEAP32[i9 >> 2] = (i25 + i1 | 0) / 2 | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i14 + 36 >> 2] = i1;
   i25 = HEAP32[i10 >> 2] | 0;
   i1 = (i25 + i1 | 0) / 2 | 0;
   HEAP32[i14 + 28 >> 2] = i1;
   i25 = ((HEAP32[i12 >> 2] | 0) + i25 | 0) / 2 | 0;
   HEAP32[i10 >> 2] = i25;
   HEAP32[i11 >> 2] = (i25 + i1 | 0) / 2 | 0;
   i1 = i2 + 2 | 0;
   if ((i1 | 0) > -1) {
    i2 = i1;
    i14 = i61 + (i1 << 3) | 0;
   } else {
    i24 = 130;
    break L11;
   }
  }
  do if (!(i13 << 24 >> 24)) {
   i23 = _UNITY_FT_Angle_Diff(HEAP32[i55 >> 2] | 0, i9) | 0;
   if ((((i23 | 0) > -1 ? i23 : 0 - i23 | 0) | 0) > 491520) {
    i23 = i14 + 16 | 0;
    i24 = HEAP32[i23 + 4 >> 2] | 0;
    i1 = i56;
    HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i1 + 4 >> 2] = i24;
    HEAP32[i29 >> 2] = i9;
    HEAP32[i30 >> 2] = 0;
    i1 = _UNITY_FT_Angle_Diff(HEAP32[i55 >> 2] | 0, i9) | 0;
    if (!i1) i1 = 0; else {
     i3 = i1 >>> 31;
     i1 = _ft_stroker_inside(i55, i3, 0) | 0;
     if (!i1) i1 = _ft_stroker_outside(i55, i3 ^ 1, 0) | 0;
    }
    HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
    i24 = 66;
   }
  } else {
   if (!(HEAP8[i28 >> 0] | 0)) {
    HEAP32[i29 >> 2] = i9;
    i1 = _UNITY_FT_Angle_Diff(HEAP32[i55 >> 2] | 0, i9) | 0;
    if (!i1) break;
    i3 = i1 >>> 31;
    i1 = _ft_stroker_inside(i55, i3, 0) | 0;
    if (i1 | 0) {
     i24 = 131;
     break L11;
    }
    i1 = _ft_stroker_outside(i55, i3 ^ 1, 0) | 0;
    i24 = 66;
    break;
   }
   _UNITY_FT_Vector_From_Polar(i60, HEAP32[i32 >> 2] | 0, i9 + 5898240 | 0);
   i7 = (HEAP32[i60 >> 2] | 0) + (HEAP32[i39 >> 2] | 0) | 0;
   i8 = (HEAP32[i40 >> 2] | 0) + (HEAP32[i57 >> 2] | 0) | 0;
   i1 = HEAP32[i41 >> 2] | 0;
   if ((i1 | 0) > -1) {
    i3 = HEAP32[i42 >> 2] | 0;
    if (i3 >>> 0 > (i1 + 1 | 0) >>> 0) {
     i22 = i3 + -1 | 0;
     HEAP32[i42 >> 2] = i22;
     i24 = HEAP32[i43 >> 2] | 0;
     i22 = i24 + (i22 << 3) | 0;
     i23 = HEAP32[i22 + 4 >> 2] | 0;
     i24 = i24 + (i1 << 3) | 0;
     HEAP32[i24 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i24 + 4 >> 2] = i23;
     i24 = (HEAP32[i27 >> 2] | 0) + i1 | 0;
     HEAP8[i24 >> 0] = HEAPU8[i24 >> 0] | 4;
     i24 = (HEAP32[i27 >> 2] | 0) + (i3 + -2) | 0;
     HEAP8[i24 >> 0] = HEAPU8[i24 >> 0] | 8;
    } else HEAP32[i42 >> 2] = i1;
    HEAP32[i41 >> 2] = -1;
    HEAP8[i44 >> 0] = 0;
   }
   i4 = HEAP32[i42 >> 2] | 0;
   HEAP32[i41 >> 2] = i4;
   HEAP8[i44 >> 0] = 0;
   if (!i4) i24 = 29; else {
    i1 = i4 + -1 | 0;
    i3 = HEAP32[i43 >> 2] | 0;
    if ((1 - i7 + (HEAP32[i3 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i8 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) i24 = 38; else i24 = 29; else i24 = 29;
   }
   L50 : do if ((i24 | 0) == 29) {
    i24 = 0;
    i5 = HEAP32[i45 >> 2] | 0;
    i1 = i4 + 1 | 0;
    HEAP32[i59 >> 2] = 0;
    do if (i1 >>> 0 > i5 >>> 0) {
     i3 = HEAP32[i46 >> 2] | 0;
     i6 = i5;
     do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
     HEAP32[i43 >> 2] = _UNITY_ft_mem_realloc(i3, 8, i5, i6, HEAP32[i43 >> 2] | 0, i59) | 0;
     i1 = HEAP32[i59 >> 2] | 0;
     if (!i1) {
      i4 = _UNITY_ft_mem_realloc(i3, 1, i5, i6, HEAP32[i27 >> 2] | 0, i59) | 0;
      HEAP32[i27 >> 2] = i4;
      i1 = HEAP32[i59 >> 2] | 0;
      if (!i1) {
       HEAP32[i45 >> 2] = i6;
       i3 = HEAP32[i42 >> 2] | 0;
       i1 = i4;
       break;
      }
     }
     HEAP8[i44 >> 0] = 0;
     break L50;
    } else {
     i3 = i4;
     i1 = HEAP32[i27 >> 2] | 0;
    } while (0);
    i24 = (HEAP32[i43 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i24 >> 2] = i7;
    HEAP32[i24 + 4 >> 2] = i8;
    HEAP8[i1 + i3 >> 0] = 1;
    HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 1;
    HEAP8[i44 >> 0] = 0;
    i24 = 38;
   } while (0);
   if ((i24 | 0) == 38) {
    i24 = 0;
    i7 = (HEAP32[i39 >> 2] | 0) - (HEAP32[i60 >> 2] | 0) | 0;
    i8 = (HEAP32[i57 >> 2] | 0) - (HEAP32[i40 >> 2] | 0) | 0;
    i1 = HEAP32[i47 >> 2] | 0;
    if ((i1 | 0) > -1) {
     i3 = HEAP32[i48 >> 2] | 0;
     if (i3 >>> 0 > (i1 + 1 | 0) >>> 0) {
      i21 = i3 + -1 | 0;
      HEAP32[i48 >> 2] = i21;
      i23 = HEAP32[i49 >> 2] | 0;
      i21 = i23 + (i21 << 3) | 0;
      i22 = HEAP32[i21 + 4 >> 2] | 0;
      i23 = i23 + (i1 << 3) | 0;
      HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i23 + 4 >> 2] = i22;
      i23 = (HEAP32[i26 >> 2] | 0) + i1 | 0;
      HEAP8[i23 >> 0] = HEAPU8[i23 >> 0] | 4;
      i23 = (HEAP32[i26 >> 2] | 0) + (i3 + -2) | 0;
      HEAP8[i23 >> 0] = HEAPU8[i23 >> 0] | 8;
     } else HEAP32[i48 >> 2] = i1;
     HEAP32[i47 >> 2] = -1;
     HEAP8[i50 >> 0] = 0;
    }
    i4 = HEAP32[i48 >> 2] | 0;
    HEAP32[i47 >> 2] = i4;
    HEAP8[i50 >> 0] = 0;
    if (!i4) i24 = 46; else {
     i1 = i4 + -1 | 0;
     i3 = HEAP32[i49 >> 2] | 0;
     if ((1 - i7 + (HEAP32[i3 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i8 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) i1 = 0; else i24 = 46; else i24 = 46;
    }
    if ((i24 | 0) == 46) {
     i24 = 0;
     i5 = HEAP32[i51 >> 2] | 0;
     i1 = i4 + 1 | 0;
     HEAP32[i59 >> 2] = 0;
     do if (i1 >>> 0 > i5 >>> 0) {
      i3 = HEAP32[i52 >> 2] | 0;
      i6 = i5;
      do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
      HEAP32[i49 >> 2] = _UNITY_ft_mem_realloc(i3, 8, i5, i6, HEAP32[i49 >> 2] | 0, i59) | 0;
      i1 = HEAP32[i59 >> 2] | 0;
      if (!i1) {
       i4 = _UNITY_ft_mem_realloc(i3, 1, i5, i6, HEAP32[i26 >> 2] | 0, i59) | 0;
       HEAP32[i26 >> 2] = i4;
       i1 = HEAP32[i59 >> 2] | 0;
       if (!i1) {
        HEAP32[i51 >> 2] = i6;
        i3 = HEAP32[i48 >> 2] | 0;
        i1 = i4;
        i24 = 54;
        break;
       }
      }
     } else {
      i3 = i4;
      i1 = HEAP32[i26 >> 2] | 0;
      i24 = 54;
     } while (0);
     if ((i24 | 0) == 54) {
      i24 = (HEAP32[i49 >> 2] | 0) + (i3 << 3) | 0;
      HEAP32[i24 >> 2] = i7;
      HEAP32[i24 + 4 >> 2] = i8;
      HEAP8[i1 + i3 >> 0] = 1;
      HEAP32[i48 >> 2] = (HEAP32[i48 >> 2] | 0) + 1;
      i1 = 0;
     }
     HEAP8[i50 >> 0] = 0;
    }
    HEAP32[i53 >> 2] = i9;
    HEAP8[i28 >> 0] = 0;
    HEAP32[i54 >> 2] = 0;
   }
   i24 = 66;
  } while (0);
  if ((i24 | 0) == 66) if (i1 | 0) {
   i24 = 131;
   break;
  }
  i22 = (_UNITY_FT_Angle_Diff(i9, i25) | 0) / 2 | 0;
  i21 = i22 + i9 | 0;
  i24 = HEAP32[i32 >> 2] | 0;
  i22 = _UNITY_FT_DivFix(i24, _UNITY_FT_Cos(i22) | 0) | 0;
  if (!(HEAP8[i33 >> 0] | 0)) {
   i15 = 0;
   i17 = i14 + 16 | 0;
   i18 = i14 + 20 | 0;
   i19 = i14;
   i20 = HEAP32[i61 + (i2 << 3) + 4 >> 2] | 0;
  } else {
   i17 = i14 + 16 | 0;
   i20 = HEAP32[i61 + (i2 << 3) + 4 >> 2] | 0;
   i18 = i14 + 20 | 0;
   i15 = _UNITY_FT_Atan2((HEAP32[i14 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0, i20 - (HEAP32[i18 >> 2] | 0) | 0) | 0;
   i19 = i14;
  }
  i23 = i14 + 8 | 0;
  i14 = i14 + 12 | 0;
  i16 = i34;
  i13 = 0;
  while (1) {
   i1 = (Math_imul(i13, -11796480) | 0) + 5898240 | 0;
   _UNITY_FT_Vector_From_Polar(i60, i22, i21 + i1 | 0);
   HEAP32[i60 >> 2] = (HEAP32[i60 >> 2] | 0) + (HEAP32[i23 >> 2] | 0);
   HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + (HEAP32[i14 >> 2] | 0);
   _UNITY_FT_Vector_From_Polar(i62, HEAP32[i32 >> 2] | 0, i1 + i25 | 0);
   i1 = (HEAP32[i62 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
   HEAP32[i62 >> 2] = i1;
   i3 = (HEAP32[i36 >> 2] | 0) + i20 | 0;
   HEAP32[i36 >> 2] = i3;
   do if (!(HEAP8[i33 >> 0] | 0)) i24 = 118; else {
    i11 = i16 + 8 | 0;
    i10 = (HEAP32[i11 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) + -1 << 3) | 0;
    i9 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i1 = _UNITY_FT_Atan2(i1 - i9 | 0, i3 - i10 | 0) | 0;
    i24 = _UNITY_FT_Angle_Diff(i15, i1) | 0;
    if ((((i24 | 0) > -1 ? i24 : 0 - i24 | 0) | 0) > 5898240) {
     i3 = _UNITY_FT_Atan2((HEAP32[i17 >> 2] | 0) - i9 | 0, (HEAP32[i18 >> 2] | 0) - i10 | 0) | 0;
     i4 = _UNITY_FT_Atan2((HEAP32[i19 >> 2] | 0) - (HEAP32[i62 >> 2] | 0) | 0, i20 - (HEAP32[i36 >> 2] | 0) | 0) | 0;
     HEAP32[i63 >> 2] = (HEAP32[i62 >> 2] | 0) - i9;
     HEAP32[i37 >> 2] = (HEAP32[i36 >> 2] | 0) - i10;
     i24 = _UNITY_FT_Vector_Length(i63) | 0;
     i12 = _UNITY_FT_Sin(i1 - i4 | 0) | 0;
     i4 = _UNITY_FT_Sin(i3 - i4 | 0) | 0;
     _UNITY_FT_Vector_From_Polar(i64, _UNITY_FT_MulDiv(i24, (i12 | 0) > -1 ? i12 : 0 - i12 | 0, (i4 | 0) > -1 ? i4 : 0 - i4 | 0) | 0, i3);
     i3 = (HEAP32[i64 >> 2] | 0) + i9 | 0;
     HEAP32[i64 >> 2] = i3;
     i4 = (HEAP32[i38 >> 2] | 0) + i10 | 0;
     HEAP32[i38 >> 2] = i4;
     i12 = i16 + 16 | 0;
     HEAP8[i12 >> 0] = 0;
     i1 = HEAP32[i16 >> 2] | 0;
     if (!i1) i24 = 76; else {
      i5 = i1 + -1 | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      if (((HEAP32[i6 + (i5 << 3) >> 2] | 0) + 1 - i3 | 0) >>> 0 < 3) if (((HEAP32[i6 + (i5 << 3) + 4 >> 2] | 0) + 1 - i4 | 0) >>> 0 < 3) i24 = 85; else i24 = 76; else i24 = 76;
     }
     if ((i24 | 0) == 76) {
      i7 = i16 + 4 | 0;
      i5 = HEAP32[i7 >> 2] | 0;
      i3 = i1 + 1 | 0;
      HEAP32[i59 >> 2] = 0;
      if (i3 >>> 0 > i5 >>> 0) {
       i4 = HEAP32[i16 + 24 >> 2] | 0;
       i6 = i5;
       do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i3 >>> 0);
       HEAP32[i11 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i5, i6, HEAP32[i11 >> 2] | 0, i59) | 0;
       i1 = HEAP32[i59 >> 2] | 0;
       if (i1 | 0) {
        i24 = 83;
        break L11;
       }
       i1 = i16 + 12 | 0;
       i3 = _UNITY_ft_mem_realloc(i4, 1, i5, i6, HEAP32[i1 >> 2] | 0, i59) | 0;
       HEAP32[i1 >> 2] = i3;
       i1 = HEAP32[i59 >> 2] | 0;
       if (i1 | 0) {
        i24 = 83;
        break L11;
       }
       HEAP32[i7 >> 2] = i6;
       i1 = HEAP32[i16 >> 2] | 0;
      } else i3 = HEAP32[i16 + 12 >> 2] | 0;
      i7 = i64;
      i8 = HEAP32[i7 + 4 >> 2] | 0;
      i24 = (HEAP32[i11 >> 2] | 0) + (i1 << 3) | 0;
      HEAP32[i24 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i24 + 4 >> 2] = i8;
      HEAP8[i3 + i1 >> 0] = 1;
      i1 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP8[i12 >> 0] = 0;
      if (!i1) {
       i1 = 0;
       i24 = 87;
      } else i24 = 85;
     }
     if ((i24 | 0) == 85) {
      i24 = 0;
      i3 = i1 + -1 | 0;
      i4 = HEAP32[i11 >> 2] | 0;
      if (((HEAP32[i4 + (i3 << 3) >> 2] | 0) + 1 - (HEAP32[i62 >> 2] | 0) | 0) >>> 0 < 3) {
       if (((HEAP32[i4 + (i3 << 3) + 4 >> 2] | 0) + 1 - (HEAP32[i36 >> 2] | 0) | 0) >>> 0 >= 3) i24 = 87;
      } else i24 = 87;
     }
     if ((i24 | 0) == 87) {
      i24 = 0;
      i7 = i16 + 4 | 0;
      i5 = HEAP32[i7 >> 2] | 0;
      i3 = i1 + 1 | 0;
      HEAP32[i59 >> 2] = 0;
      if (i3 >>> 0 > i5 >>> 0) {
       i4 = HEAP32[i16 + 24 >> 2] | 0;
       i6 = i5;
       do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i3 >>> 0);
       HEAP32[i11 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i5, i6, HEAP32[i11 >> 2] | 0, i59) | 0;
       i1 = HEAP32[i59 >> 2] | 0;
       if (i1 | 0) {
        i24 = 95;
        break L11;
       }
       i1 = i16 + 12 | 0;
       i3 = _UNITY_ft_mem_realloc(i4, 1, i5, i6, HEAP32[i1 >> 2] | 0, i59) | 0;
       HEAP32[i1 >> 2] = i3;
       i1 = HEAP32[i59 >> 2] | 0;
       if (i1 | 0) {
        i24 = 95;
        break L11;
       }
       HEAP32[i7 >> 2] = i6;
       i1 = HEAP32[i16 >> 2] | 0;
      } else i3 = HEAP32[i16 + 12 >> 2] | 0;
      i6 = i62;
      i7 = HEAP32[i6 + 4 >> 2] | 0;
      i8 = (HEAP32[i11 >> 2] | 0) + (i1 << 3) | 0;
      HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i8 + 4 >> 2] = i7;
      HEAP8[i3 + i1 >> 0] = 1;
      i1 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP8[i12 >> 0] = 0;
     }
     i8 = i16 + 4 | 0;
     i6 = HEAP32[i8 >> 2] | 0;
     i3 = i1 + 2 | 0;
     HEAP32[i59 >> 2] = 0;
     if (i3 >>> 0 > i6 >>> 0) {
      i4 = HEAP32[i16 + 24 >> 2] | 0;
      i7 = i6;
      do i7 = i7 + 16 + (i7 >>> 1) | 0; while (i7 >>> 0 < i3 >>> 0);
      HEAP32[i11 >> 2] = _UNITY_ft_mem_realloc(i4, 8, i6, i7, HEAP32[i11 >> 2] | 0, i59) | 0;
      i1 = HEAP32[i59 >> 2] | 0;
      if (i1 | 0) {
       i24 = 103;
       break L11;
      }
      i5 = i16 + 12 | 0;
      i3 = _UNITY_ft_mem_realloc(i4, 1, i6, i7, HEAP32[i5 >> 2] | 0, i59) | 0;
      HEAP32[i5 >> 2] = i3;
      i1 = HEAP32[i59 >> 2] | 0;
      if (i1 | 0) {
       i24 = 103;
       break L11;
      }
      HEAP32[i8 >> 2] = i7;
      i6 = i5;
      i1 = HEAP32[i16 >> 2] | 0;
     } else {
      i3 = i16 + 12 | 0;
      i6 = i3;
      i3 = HEAP32[i3 >> 2] | 0;
     }
     i7 = (HEAP32[i11 >> 2] | 0) + (i1 << 3) | 0;
     i5 = i3 + i1 | 0;
     i1 = i60;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i3 = i7;
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = i4;
     i3 = i7 + 8 | 0;
     HEAP32[i3 >> 2] = i9;
     HEAP32[i3 + 4 >> 2] = i10;
     HEAP8[i5 >> 0] = 0;
     HEAP8[i5 + 1 >> 0] = 1;
     i5 = HEAP32[i16 >> 2] | 0;
     i3 = i5 + 2 | 0;
     HEAP32[i16 >> 2] = i3;
     HEAP8[i12 >> 0] = 0;
     if (i3 | 0) {
      i1 = i5 + 1 | 0;
      i4 = HEAP32[i11 >> 2] | 0;
      if (((HEAP32[i4 + (i1 << 3) >> 2] | 0) + 1 - (HEAP32[i62 >> 2] | 0) | 0) >>> 0 < 3) if (((HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0) + 1 - (HEAP32[i36 >> 2] | 0) | 0) >>> 0 < 3) break;
     }
     i4 = HEAP32[i8 >> 2] | 0;
     i1 = i5 + 3 | 0;
     HEAP32[i59 >> 2] = 0;
     if (i1 >>> 0 > i4 >>> 0) {
      i3 = HEAP32[i16 + 24 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      HEAP32[i11 >> 2] = _UNITY_ft_mem_realloc(i3, 8, i4, i5, HEAP32[i11 >> 2] | 0, i59) | 0;
      i1 = HEAP32[i59 >> 2] | 0;
      if (i1 | 0) {
       i24 = 115;
       break L11;
      }
      i4 = _UNITY_ft_mem_realloc(i3, 1, i4, i5, HEAP32[i6 >> 2] | 0, i59) | 0;
      HEAP32[i6 >> 2] = i4;
      i1 = HEAP32[i59 >> 2] | 0;
      if (i1 | 0) {
       i24 = 115;
       break L11;
      }
      HEAP32[i8 >> 2] = i5;
      i3 = HEAP32[i16 >> 2] | 0;
      i1 = i4;
     } else i1 = HEAP32[i6 >> 2] | 0;
     i9 = i62;
     i10 = HEAP32[i9 + 4 >> 2] | 0;
     i11 = (HEAP32[i11 >> 2] | 0) + (i3 << 3) | 0;
     HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i11 + 4 >> 2] = i10;
     HEAP8[i1 + i3 >> 0] = 1;
     HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
     HEAP8[i12 >> 0] = 0;
    } else i24 = 118;
   } while (0);
   if ((i24 | 0) == 118) {
    i24 = 0;
    i7 = i16 + 4 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    i1 = i3 + 2 | 0;
    HEAP32[i59 >> 2] = 0;
    if (i1 >>> 0 > i5 >>> 0) {
     i3 = HEAP32[i16 + 24 >> 2] | 0;
     i6 = i5;
     do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
     i4 = i16 + 8 | 0;
     HEAP32[i4 >> 2] = _UNITY_ft_mem_realloc(i3, 8, i5, i6, HEAP32[i4 >> 2] | 0, i59) | 0;
     i1 = HEAP32[i59 >> 2] | 0;
     if (i1 | 0) {
      i24 = 126;
      break L11;
     }
     i1 = i16 + 12 | 0;
     i5 = _UNITY_ft_mem_realloc(i3, 1, i5, i6, HEAP32[i1 >> 2] | 0, i59) | 0;
     HEAP32[i1 >> 2] = i5;
     i1 = HEAP32[i59 >> 2] | 0;
     if (i1 | 0) {
      i24 = 126;
      break L11;
     }
     HEAP32[i7 >> 2] = i6;
     i3 = HEAP32[i16 >> 2] | 0;
     i1 = i5;
    } else {
     i4 = i16 + 8 | 0;
     i1 = HEAP32[i16 + 12 >> 2] | 0;
    }
    i11 = (HEAP32[i4 >> 2] | 0) + (i3 << 3) | 0;
    i12 = i1 + i3 | 0;
    i8 = i60;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i9 = i11;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    i9 = i62;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i11 = i11 + 8 | 0;
    HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i11 + 4 >> 2] = i10;
    HEAP8[i12 >> 0] = 0;
    HEAP8[i12 + 1 >> 0] = 1;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 2;
    HEAP8[i16 + 16 >> 0] = 0;
   }
   i13 = i13 + 1 | 0;
   if ((i13 | 0) >= 2) break; else i16 = i16 + 32 | 0;
  }
  i1 = i2 + -2 | 0;
  HEAP32[i55 >> 2] = i25;
  if ((i1 | 0) > -1) {
   i2 = i1;
   i1 = i61 + (i1 << 3) | 0;
   i13 = 0;
  } else {
   i24 = 130;
   break;
  }
 }
 if ((i24 | 0) == 83) {
  HEAP8[i12 >> 0] = 0;
  i24 = 116;
 } else if ((i24 | 0) == 95) {
  HEAP8[i12 >> 0] = 0;
  i24 = 116;
 } else if ((i24 | 0) == 103) {
  HEAP8[i12 >> 0] = 0;
  i24 = 116;
 } else if ((i24 | 0) == 115) {
  HEAP8[i12 >> 0] = 0;
  i64 = i1;
  STACKTOP = i65;
  return i64 | 0;
 } else if ((i24 | 0) == 126) HEAP8[i16 + 16 >> 0] = 0; else if ((i24 | 0) == 130) {
  i62 = i58;
  i63 = HEAP32[i62 + 4 >> 2] | 0;
  i64 = i56;
  HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i64 + 4 >> 2] = i63;
  i64 = 0;
  STACKTOP = i65;
  return i64 | 0;
 } else if ((i24 | 0) == 131) {
  STACKTOP = i65;
  return i1 | 0;
 }
 i64 = i1;
 STACKTOP = i65;
 return i64 | 0;
}

function __ZNK5physx5cloth21IterationStateFactory6createI8Scalar4fNS0_7SwClothEEENS0_14IterationStateIT_EERKT0_(i48, i42, i40) {
 i48 = i48 | 0;
 i42 = i42 | 0;
 i40 = i40 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, i41 = 0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i54 + 120 | 0;
 i51 = i54 + 136 | 0;
 i53 = i54 + 56 | 0;
 i49 = i54;
 i50 = i54 + 16 | 0;
 HEAP32[i48 + 192 >> 2] = HEAP32[i42 >> 2];
 i41 = i42 + 4 | 0;
 HEAP32[i48 + 196 >> 2] = HEAP32[i41 >> 2];
 i46 = HEAP32[i42 + 8 >> 2] | 0;
 HEAP32[i48 + 200 >> 2] = i46;
 i47 = i40 + 204 | 0;
 f12 = Math_fround(HEAPF32[i47 >> 2]);
 f2 = Math_fround(HEAPF32[i47 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i47 + 8 >> 2]);
 i47 = i42 + 36 | 0;
 f57 = Math_fround(HEAPF32[i47 >> 2]);
 f16 = Math_fround(HEAPF32[i47 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i47 + 8 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f17 * Math_fround(HEAPF32[i40 + 144 >> 2]));
 i46 = i40 + 56 | 0;
 f56 = Math_fround(HEAPF32[i46 >> 2]);
 f3 = Math_fround(HEAPF32[i46 + 4 >> 2]);
 f43 = Math_fround(HEAPF32[i46 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i42 + 16 >> 2]);
 f4 = Math_fround(f4 * f4);
 f56 = Math_fround(f56 * f4);
 f3 = Math_fround(f3 * f4);
 f4 = Math_fround(f43 * f4);
 i46 = i40 + 68 | 0;
 f43 = Math_fround(HEAPF32[i46 >> 2]);
 f44 = Math_fround(HEAPF32[i46 + 4 >> 2]);
 f45 = Math_fround(HEAPF32[i46 + 8 >> 2]);
 f43 = Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f43) * Math_fround(.693147182))));
 f44 = Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f44) * Math_fround(.693147182))));
 f45 = Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f45) * Math_fround(.693147182))));
 f55 = Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * Math_fround(HEAPF32[i46 + 12 >> 2])) * Math_fround(.693147182))));
 f14 = Math_fround(HEAPF32[i42 + 12 >> 2]);
 f39 = Math_fround(f44 * f14);
 f32 = Math_fround(f45 * f14);
 f29 = Math_fround(f55 * f14);
 HEAPF32[i52 >> 2] = Math_fround(f43 * f14);
 i46 = i52 + 4 | 0;
 HEAPF32[i46 >> 2] = f39;
 i47 = i52 + 8 | 0;
 HEAPF32[i47 >> 2] = f32;
 HEAPF32[i52 + 12 >> 2] = f29;
 i1 = i40 + 80 | 0;
 f29 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f55 = Math_fround(f12 * Math_fround(f17 * Math_fround(Math_fround(1.0) - f55)));
 f29 = Math_fround(f2 * Math_fround(f17 * Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f29) * Math_fround(.693147182)))))));
 f32 = Math_fround(f38 * Math_fround(f17 * Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * Math_fround(HEAPF32[i1 + 8 >> 2])) * Math_fround(.693147182)))))));
 i1 = i40 + 104 | 0;
 f39 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f39 = Math_fround(Math_fround(f57 - f12) * Math_fround(f17 * f39));
 f14 = Math_fround(Math_fround(f16 - f2) * Math_fround(f17 * f14));
 f38 = Math_fround(Math_fround(f15 - f38) * Math_fround(f17 * Math_fround(HEAPF32[i1 + 8 >> 2])));
 f15 = Math_fround(Math_fround((HEAP32[i42 >> 2] | 0) + 1 | 0) * Math_fround(.5));
 f15 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f15);
 f2 = Math_fround(f39 * f15);
 f16 = Math_fround(f14 * f15);
 f15 = Math_fround(f38 * f15);
 f12 = Math_fround(HEAPF32[i42 + 20 >> 2]);
 f57 = Math_fround(-f12);
 f7 = Math_fround(HEAPF32[i42 + 24 >> 2]);
 f60 = Math_fround(-f7);
 f5 = Math_fround(HEAPF32[i42 + 28 >> 2]);
 f58 = Math_fround(-f5);
 f6 = Math_fround(HEAPF32[i42 + 32 >> 2]);
 f12 = Math_fround(f57 - f12);
 f7 = Math_fround(f60 - f7);
 f5 = Math_fround(f58 - f5);
 f13 = Math_fround(f7 * f60);
 f9 = Math_fround(f5 * f58);
 f60 = Math_fround(f12 * f60);
 f59 = Math_fround(f12 * f58);
 f10 = Math_fround(f12 * f6);
 f58 = Math_fround(f7 * f58);
 f7 = Math_fround(f7 * f6);
 f6 = Math_fround(f5 * f6);
 f5 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f9);
 f8 = Math_fround(f60 + f6);
 f11 = Math_fround(f59 - f7);
 f6 = Math_fround(f60 - f6);
 f57 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f57));
 f9 = Math_fround(f57 - f9);
 f12 = Math_fround(f58 + f10);
 f7 = Math_fround(f59 + f7);
 f10 = Math_fround(f58 - f10);
 f13 = Math_fround(f57 - f13);
 HEAPF32[i48 >> 2] = f5;
 i1 = i48 + 4 | 0;
 HEAPF32[i1 >> 2] = f8;
 i18 = i48 + 8 | 0;
 HEAPF32[i18 >> 2] = f11;
 i19 = i48 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i48 + 16 | 0;
 HEAPF32[i20 >> 2] = f6;
 i21 = i48 + 20 | 0;
 HEAPF32[i21 >> 2] = f9;
 i30 = i48 + 24 | 0;
 HEAPF32[i30 >> 2] = f12;
 i31 = i48 + 28 | 0;
 HEAP32[i31 >> 2] = 0;
 i33 = i48 + 32 | 0;
 HEAPF32[i33 >> 2] = f7;
 i34 = i48 + 36 | 0;
 HEAPF32[i34 >> 2] = f10;
 i35 = i48 + 40 | 0;
 HEAPF32[i35 >> 2] = f13;
 i36 = i48 + 44 | 0;
 HEAP32[i36 >> 2] = 0;
 f55 = Math_fround(Math_fround(f56 - f55) + f2);
 f29 = Math_fround(Math_fround(f3 - f29) + f16);
 f32 = Math_fround(Math_fround(f4 - f32) + f15);
 f4 = Math_fround(Math_fround(Math_fround(f55 * f8) + Math_fround(f29 * f9)) + Math_fround(f32 * f10));
 f3 = Math_fround(Math_fround(Math_fround(f55 * f11) + Math_fround(f29 * f12)) + Math_fround(f32 * f13));
 HEAPF32[i48 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f55 * f5) + Math_fround(f29 * f6)) + Math_fround(f32 * f7));
 HEAPF32[i48 + 52 >> 2] = f4;
 HEAPF32[i48 + 56 >> 2] = f3;
 HEAP32[i48 + 60 >> 2] = 0;
 f2 = Math_fround(f39 - f2);
 f16 = Math_fround(f14 - f16);
 f15 = Math_fround(f38 - f15);
 f38 = Math_fround(Math_fround(Math_fround(f2 * f8) + Math_fround(f16 * f9)) + Math_fround(f15 * f10));
 f14 = Math_fround(Math_fround(Math_fround(f2 * f11) + Math_fround(f16 * f12)) + Math_fround(f15 * f13));
 HEAPF32[i48 + 64 >> 2] = Math_fround(Math_fround(Math_fround(f2 * f5) + Math_fround(f16 * f6)) + Math_fround(f15 * f7));
 HEAPF32[i48 + 68 >> 2] = f38;
 HEAPF32[i48 + 72 >> 2] = f14;
 HEAP32[i48 + 76 >> 2] = 0;
 f14 = Math_fround(HEAPF32[i42 + 48 >> 2]);
 f38 = Math_fround(f14 * f14);
 f15 = Math_fround(HEAPF32[i42 + 52 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f15 * f15));
 f16 = Math_fround(HEAPF32[i42 + 56 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f16 * f16));
 f2 = Math_fround(HEAPF32[i40 + 216 >> 2]);
 f39 = Math_fround(f2 * f2);
 f3 = Math_fround(HEAPF32[i40 + 220 >> 2]);
 f39 = Math_fround(f39 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i40 + 224 >> 2]);
 i28 = Math_fround(f38 + Math_fround(f39 + Math_fround(f4 * f4))) > Math_fround(0.0);
 HEAP8[i48 + 204 >> 0] = i28 & 1;
 if (!i28) {
  HEAP32[i48 >> 2] = -1082130432;
  HEAP32[i1 >> 2] = -1082130432;
  HEAP32[i18 >> 2] = -1082130432;
  HEAP32[i19 >> 2] = -1082130432;
  i51 = HEAP32[i52 >> 2] | 0;
  i52 = HEAP32[i46 >> 2] | 0;
  i53 = HEAP32[i47 >> 2] | 0;
  HEAP32[i48 + 80 >> 2] = i51;
  HEAP32[i48 + 84 >> 2] = i52;
  HEAP32[i48 + 88 >> 2] = i53;
  HEAP32[i48 + 92 >> 2] = -1082130432;
  f58 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f43 - f58);
  f59 = Math_fround(f44 - f59);
  f60 = Math_fround(f45 - f60);
  i53 = i48 + 176 | 0;
  HEAPF32[i53 >> 2] = f58;
  i53 = i48 + 180 | 0;
  HEAPF32[i53 >> 2] = f59;
  i53 = i48 + 184 | 0;
  HEAPF32[i53 >> 2] = f60;
  i53 = i48 + 188 | 0;
  HEAP32[i53 >> 2] = 0;
  STACKTOP = i54;
  return;
 }
 f38 = Math_fround(Math_fround(Math_fround(f5 * f2) + Math_fround(f6 * f3)) + Math_fround(f7 * f4));
 f39 = Math_fround(Math_fround(Math_fround(f8 * f2) + Math_fround(f9 * f3)) + Math_fround(f10 * f4));
 f32 = Math_fround(Math_fround(Math_fround(f11 * f2) + Math_fround(f12 * f3)) + Math_fround(f13 * f4));
 f29 = Math_fround(Math_fround(Math_fround(f5 * f14) + Math_fround(f6 * f15)) + Math_fround(f7 * f16));
 f9 = Math_fround(Math_fround(Math_fround(f8 * f14) + Math_fround(f9 * f15)) + Math_fround(f10 * f16));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f15)) + Math_fround(f13 * f16));
 f16 = Math_fround(-f17);
 f11 = Math_fround(f38 * f16);
 f13 = Math_fround(f39 * f16);
 f15 = Math_fround(f32 * f16);
 f17 = Math_fround(f16 * Math_fround(0.0));
 f12 = Math_fround(f29 * f16);
 f14 = Math_fround(f9 * f16);
 f16 = Math_fround(f8 * f16);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
 if (f3 > Math_fround(1.1920929e-07)) f2 = Math_fround(Math_fround(+Math_sin(+f3)) / f3); else f2 = Math_fround(1.0);
 f6 = Math_fround(f11 * f2);
 f7 = Math_fround(f13 * f2);
 f5 = Math_fround(f15 * f2);
 f2 = Math_fround(+Math_cos(+(+f3)));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
 if (f3 > Math_fround(1.1920929e-07)) f4 = Math_fround(Math_fround(+Math_sin(+f3)) / f3); else f4 = Math_fround(1.0);
 f60 = Math_fround(f12 * f4);
 f57 = Math_fround(f14 * f4);
 f10 = Math_fround(f16 * f4);
 f3 = Math_fround(+Math_cos(+(+f3)));
 f4 = Math_fround(f6 + f6);
 f56 = Math_fround(f7 + f7);
 f64 = Math_fround(f5 + f5);
 f55 = Math_fround(f6 * f4);
 f59 = Math_fround(f7 * f56);
 f63 = Math_fround(f5 * f64);
 f65 = Math_fround(f7 * f4);
 f58 = Math_fround(f5 * f4);
 f4 = Math_fround(f4 * f2);
 f61 = Math_fround(f5 * f56);
 f56 = Math_fround(f56 * f2);
 f64 = Math_fround(f64 * f2);
 f66 = Math_fround(f65 + f64);
 f62 = Math_fround(f58 - f56);
 HEAPF32[i51 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f59) - f63);
 HEAPF32[i51 + 4 >> 2] = f66;
 HEAPF32[i51 + 8 >> 2] = f62;
 HEAP32[i51 + 12 >> 2] = 0;
 f55 = Math_fround(Math_fround(1.0) - f55);
 f63 = Math_fround(f55 - f63);
 f62 = Math_fround(f61 + f4);
 HEAPF32[i51 + 16 >> 2] = Math_fround(f65 - f64);
 HEAPF32[i51 + 20 >> 2] = f63;
 HEAPF32[i51 + 24 >> 2] = f62;
 HEAP32[i51 + 28 >> 2] = 0;
 f4 = Math_fround(f61 - f4);
 f59 = Math_fround(f55 - f59);
 HEAPF32[i51 + 32 >> 2] = Math_fround(f58 + f56);
 HEAPF32[i51 + 36 >> 2] = f4;
 HEAPF32[i51 + 40 >> 2] = f59;
 i26 = i51 + 44 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i51 + 60 >> 2] = 1065353216;
 f59 = Math_fround(Math_fround(Math_fround(f5 * f57) + Math_fround(Math_fround(f2 * f60) + Math_fround(f6 * f3))) - Math_fround(f7 * f10));
 f4 = Math_fround(Math_fround(Math_fround(f6 * f10) + Math_fround(Math_fround(f2 * f57) + Math_fround(f7 * f3))) - Math_fround(f5 * f60));
 f56 = Math_fround(Math_fround(Math_fround(f7 * f60) + Math_fround(Math_fround(f2 * f10) + Math_fround(f5 * f3))) - Math_fround(f6 * f57));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f3) - Math_fround(f6 * f60)) - Math_fround(f7 * f57)) - Math_fround(f5 * f10));
 f3 = Math_fround(f59 + f59);
 f10 = Math_fround(f4 + f4);
 f57 = Math_fround(f56 + f56);
 f5 = Math_fround(f59 * f3);
 f59 = Math_fround(f4 * f10);
 f60 = Math_fround(f56 * f57);
 f4 = Math_fround(f4 * f3);
 f58 = Math_fround(f56 * f3);
 f3 = Math_fround(f6 * f3);
 f7 = Math_fround(f56 * f10);
 f10 = Math_fround(f6 * f10);
 f57 = Math_fround(f6 * f57);
 f6 = Math_fround(f4 + f57);
 f2 = Math_fround(f58 - f10);
 HEAPF32[i53 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f59) - f60);
 HEAPF32[i53 + 4 >> 2] = f6;
 HEAPF32[i53 + 8 >> 2] = f2;
 HEAP32[i53 + 12 >> 2] = 0;
 f5 = Math_fround(Math_fround(1.0) - f5);
 f60 = Math_fround(f5 - f60);
 f2 = Math_fround(f7 + f3);
 HEAPF32[i53 + 16 >> 2] = Math_fround(f4 - f57);
 HEAPF32[i53 + 20 >> 2] = f60;
 HEAPF32[i53 + 24 >> 2] = f2;
 HEAP32[i53 + 28 >> 2] = 0;
 f3 = Math_fround(f7 - f3);
 f59 = Math_fround(f5 - f59);
 HEAPF32[i53 + 32 >> 2] = Math_fround(f58 + f10);
 HEAPF32[i53 + 36 >> 2] = f3;
 HEAPF32[i53 + 40 >> 2] = f59;
 i26 = i53 + 44 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i53 + 60 >> 2] = 1065353216;
 i26 = i51 + 4 | 0;
 i24 = HEAP32[i26 >> 2] | 0;
 i27 = i51 + 8 | 0;
 i23 = HEAP32[i27 >> 2] | 0;
 i28 = i51 + 12 | 0;
 i22 = HEAP32[i28 >> 2] | 0;
 HEAP32[i48 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i1 >> 2] = i24;
 HEAP32[i18 >> 2] = i23;
 HEAP32[i19 >> 2] = i22;
 i22 = i51 + 16 | 0;
 i23 = i22 + 4 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i24 = i22 + 8 | 0;
 i19 = HEAP32[i24 >> 2] | 0;
 i25 = i22 + 12 | 0;
 i18 = HEAP32[i25 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 >> 2] = i1;
 HEAP32[i30 >> 2] = i19;
 HEAP32[i31 >> 2] = i18;
 i18 = i51 + 32 | 0;
 i19 = i18 + 4 | 0;
 i30 = HEAP32[i19 >> 2] | 0;
 i20 = i18 + 8 | 0;
 i31 = HEAP32[i20 >> 2] | 0;
 i21 = i18 + 12 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i34 >> 2] = i30;
 HEAP32[i35 >> 2] = i31;
 HEAP32[i36 >> 2] = i1;
 i1 = i40 + 92 | 0;
 f59 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f59 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f59) * Math_fround(.693147182)))));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * f3) * Math_fround(.693147182)))));
 f10 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(Math_fround(f37 * Math_fround(HEAPF32[i1 + 8 >> 2])) * Math_fround(.693147182)))));
 i1 = i40 + 128 | 0;
 f58 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = i40 + 116 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f60 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f57 = Math_fround(f38 - f29);
 f4 = Math_fround(f39 - f9);
 f9 = Math_fround(f32 - f8);
 f6 = Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39))) + Math_fround(1.08420217e-19));
 f59 = Math_fround(f38 * f59);
 f8 = Math_fround(f39 * f3);
 f10 = Math_fround(f32 * f10);
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f8 * f8)) + Math_fround(f10 * f10)) + Math_fround(1.08420217e-19));
 f8 = Math_fround(f38 * f58);
 f5 = Math_fround(f39 * f5);
 f7 = Math_fround(f32 * f7);
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f5 * f5)) + Math_fround(f7 * f7)) + Math_fround(1.08420217e-19));
 f5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f57 * f57) + Math_fround(f4 * f4))) + Math_fround(1.08420217e-19));
 f2 = Math_fround(f57 * f2);
 f8 = Math_fround(f4 * f60);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f8 * f8)) + Math_fround(f9 * f9)) + Math_fround(1.08420217e-19));
 f10 = Math_fround(f10 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6 * f10)))));
 f8 = Math_fround(HEAPF32[i41 >> 2]);
 f9 = Math_fround(f8 * Math_fround(f9 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5 * f9))))));
 f8 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6 * f7))))) * Math_fround(f8 * Math_fround((HEAP32[i42 >> 2] << 1) + -1 | 0))) - f9);
 f7 = Math_fround(Math_fround(f11 + f12) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f15 + f16) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f17 + f17) * Math_fround(.5));
 HEAPF32[i49 >> 2] = f7;
 HEAPF32[i49 + 4 >> 2] = f6;
 HEAPF32[i49 + 8 >> 2] = f5;
 HEAPF32[i49 + 12 >> 2] = f2;
 f2 = Math_fround(f8 * Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)));
 f60 = Math_fround(f7 * f8);
 f4 = Math_fround(f6 * f8);
 f57 = Math_fround(f5 * f8);
 f58 = Math_fround(-f4);
 f59 = Math_fround(-f57);
 f3 = Math_fround(-f60);
 HEAP32[i50 >> 2] = 0;
 HEAPF32[i50 + 4 >> 2] = f57;
 HEAPF32[i50 + 8 >> 2] = f58;
 HEAPF32[i50 + 12 >> 2] = f59;
 HEAP32[i50 + 16 >> 2] = 0;
 HEAPF32[i50 + 20 >> 2] = f60;
 HEAPF32[i50 + 24 >> 2] = f4;
 HEAPF32[i50 + 28 >> 2] = f3;
 HEAP32[i50 + 32 >> 2] = 0;
 f3 = Math_fround(Math_fround(f2 - f9) - f10);
 f4 = f7;
 i1 = 0;
 while (1) {
  f64 = Math_fround(f8 * f4);
  f65 = Math_fround(HEAPF32[i52 + (i1 << 2) >> 2]);
  i40 = i50 + (i1 * 12 | 0) | 0;
  i41 = i51 + (i1 << 4) | 0;
  f62 = Math_fround(f9 - f65);
  i42 = i53 + (i1 << 4) | 0;
  f65 = Math_fround(f10 + Math_fround(f9 + f65));
  f60 = Math_fround(HEAPF32[i40 >> 2]);
  f61 = Math_fround(f64 * f7);
  f63 = Math_fround(Math_fround(-f61) - f60);
  f66 = Math_fround(HEAPF32[i41 >> 2]);
  f63 = Math_fround(f63 + Math_fround(f62 * f66));
  HEAPF32[i42 >> 2] = Math_fround(f63 - Math_fround(f9 * Math_fround(HEAPF32[i42 >> 2])));
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(f60 - f61) + Math_fround(f65 * f66));
  f66 = Math_fround(HEAPF32[i40 + 4 >> 2]);
  f61 = Math_fround(f64 * f6);
  f60 = Math_fround(Math_fround(-f61) - f66);
  i36 = i41 + 4 | 0;
  f63 = Math_fround(HEAPF32[i36 >> 2]);
  f60 = Math_fround(f60 + Math_fround(f62 * f63));
  i35 = i42 + 4 | 0;
  HEAPF32[i35 >> 2] = Math_fround(f60 - Math_fround(f9 * Math_fround(HEAPF32[i35 >> 2])));
  HEAPF32[i36 >> 2] = Math_fround(Math_fround(f66 - f61) + Math_fround(f65 * f63));
  f63 = Math_fround(HEAPF32[i40 + 8 >> 2]);
  f64 = Math_fround(f64 * f5);
  f61 = Math_fround(Math_fround(-f64) - f63);
  i40 = i41 + 8 | 0;
  f66 = Math_fround(HEAPF32[i40 >> 2]);
  f62 = Math_fround(f61 + Math_fround(f62 * f66));
  i36 = i42 + 8 | 0;
  HEAPF32[i36 >> 2] = Math_fround(f62 - Math_fround(f9 * Math_fround(HEAPF32[i36 >> 2])));
  HEAPF32[i40 >> 2] = Math_fround(Math_fround(f63 - f64) + Math_fround(f65 * f66));
  i41 = i41 + (i1 << 2) | 0;
  HEAPF32[i41 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i41 >> 2]));
  i42 = i42 + (i1 << 2) | 0;
  HEAPF32[i42 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i42 >> 2]));
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 3) break;
  f4 = Math_fround(HEAPF32[i49 + (i1 << 2) >> 2]);
 }
 i50 = HEAP32[i53 + 4 >> 2] | 0;
 i49 = HEAP32[i53 + 8 >> 2] | 0;
 i41 = HEAP32[i53 + 12 >> 2] | 0;
 HEAP32[i48 + 80 >> 2] = HEAP32[i53 >> 2];
 HEAP32[i48 + 84 >> 2] = i50;
 HEAP32[i48 + 88 >> 2] = i49;
 HEAP32[i48 + 92 >> 2] = i41;
 i41 = i53 + 16 | 0;
 i49 = HEAP32[i41 + 4 >> 2] | 0;
 i50 = HEAP32[i41 + 8 >> 2] | 0;
 i42 = HEAP32[i41 + 12 >> 2] | 0;
 HEAP32[i48 + 96 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i48 + 100 >> 2] = i49;
 HEAP32[i48 + 104 >> 2] = i50;
 HEAP32[i48 + 108 >> 2] = i42;
 i42 = i53 + 32 | 0;
 i53 = HEAP32[i42 + 4 >> 2] | 0;
 i50 = HEAP32[i42 + 8 >> 2] | 0;
 i49 = HEAP32[i42 + 12 >> 2] | 0;
 HEAP32[i48 + 112 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i48 + 116 >> 2] = i53;
 HEAP32[i48 + 120 >> 2] = i50;
 HEAP32[i48 + 124 >> 2] = i49;
 i49 = HEAP32[i26 >> 2] | 0;
 i50 = HEAP32[i27 >> 2] | 0;
 i53 = HEAP32[i28 >> 2] | 0;
 HEAP32[i48 + 128 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i48 + 132 >> 2] = i49;
 HEAP32[i48 + 136 >> 2] = i50;
 HEAP32[i48 + 140 >> 2] = i53;
 i53 = HEAP32[i23 >> 2] | 0;
 i51 = HEAP32[i24 >> 2] | 0;
 i50 = HEAP32[i25 >> 2] | 0;
 HEAP32[i48 + 144 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i48 + 148 >> 2] = i53;
 HEAP32[i48 + 152 >> 2] = i51;
 HEAP32[i48 + 156 >> 2] = i50;
 i50 = HEAP32[i19 >> 2] | 0;
 i51 = HEAP32[i20 >> 2] | 0;
 i53 = HEAP32[i21 >> 2] | 0;
 HEAP32[i48 + 160 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i48 + 164 >> 2] = i50;
 HEAP32[i48 + 168 >> 2] = i51;
 HEAP32[i48 + 172 >> 2] = i53;
 f64 = Math_fround(HEAPF32[i52 >> 2]);
 f65 = Math_fround(HEAPF32[i46 >> 2]);
 f66 = Math_fround(HEAPF32[i47 >> 2]);
 f64 = Math_fround(f43 - f64);
 f65 = Math_fround(f44 - f65);
 f66 = Math_fround(f45 - f66);
 i53 = i48 + 176 | 0;
 HEAPF32[i53 >> 2] = f64;
 i53 = i48 + 180 | 0;
 HEAPF32[i53 >> 2] = f65;
 i53 = i48 + 184 | 0;
 HEAPF32[i53 >> 2] = f66;
 i53 = i48 + 188 | 0;
 HEAP32[i53 >> 2] = 0;
 STACKTOP = i54;
 return;
}

function __ZN5physx2Gu16sweepBoxTriangleERKNS_10PxTriangleERKNS_9PxBounds3ERKNS_6PxVec3ES9_RS7_SA_Rf(i66, i47, i63, i37, i57, i64, i62) {
 i66 = i66 | 0;
 i47 = i47 | 0;
 i63 = i63 | 0;
 i37 = i37 | 0;
 i57 = i57 | 0;
 i64 = i64 | 0;
 i62 = i62 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i65 = 0, i67 = 0, i68 = 0, i69 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i69 + 72 | 0;
 i65 = i69 + 60 | 0;
 i67 = i69 + 48 | 0;
 i59 = i69 + 36 | 0;
 i60 = i69 + 24 | 0;
 i58 = i69 + 12 | 0;
 i61 = i69;
 i1 = i66 + 12 | 0;
 f32 = Math_fround(HEAPF32[i1 >> 2]);
 f36 = Math_fround(HEAPF32[i66 >> 2]);
 f32 = Math_fround(f32 - f36);
 i10 = i66 + 16 | 0;
 f46 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i66 + 4 | 0;
 f33 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(f46 - f33);
 i2 = i66 + 20 | 0;
 f31 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i66 + 8 | 0;
 f35 = Math_fround(HEAPF32[i4 >> 2]);
 f31 = Math_fround(f31 - f35);
 i7 = i66 + 24 | 0;
 f36 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f36);
 i8 = i66 + 28 | 0;
 f33 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f33);
 i9 = i66 + 32 | 0;
 f35 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f35);
 f34 = Math_fround(Math_fround(f46 * f35) - Math_fround(f31 * f33));
 f35 = Math_fround(Math_fround(f31 * f36) - Math_fround(f32 * f35));
 f36 = Math_fround(Math_fround(f32 * f33) - Math_fround(f46 * f36));
 f46 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) * f34);
 i54 = i63 + 4 | 0;
 f46 = Math_fround(f46 + Math_fround(Math_fround(HEAPF32[i54 >> 2]) * f35));
 i55 = i63 + 8 | 0;
 if (Math_fround(Math_fround(f36 * Math_fround(HEAPF32[i55 >> 2])) + f46) >= Math_fround(0.0)) {
  i68 = 0;
  STACKTOP = i69;
  return i68 | 0;
 }
 __ZN5physx2Gu16computeBoxPointsERKNS_9PxBounds3EPNS_6PxVec3E(i47, i56);
 f25 = Math_fround(HEAPF32[i66 >> 2]);
 f26 = Math_fround(HEAPF32[i11 >> 2]);
 f27 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f29 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(Math_fround(Math_fround(f25 + f28) + f20) * Math_fround(.333333343));
 f32 = Math_fround(Math_fround(Math_fround(f26 + f29) + f5) * Math_fround(.333333343));
 f33 = Math_fround(Math_fround(Math_fround(f27 + f30) + f12) * Math_fround(.333333343));
 f25 = Math_fround(f25 + Math_fround(Math_fround(f25 - f31) * Math_fround(.0199999996)));
 f26 = Math_fround(f26 + Math_fround(Math_fround(f26 - f32) * Math_fround(.0199999996)));
 f27 = Math_fround(f27 + Math_fround(Math_fround(f27 - f33) * Math_fround(.0199999996)));
 f28 = Math_fround(f28 + Math_fround(Math_fround(f28 - f31) * Math_fround(.0199999996)));
 f29 = Math_fround(f29 + Math_fround(Math_fround(f29 - f32) * Math_fround(.0199999996)));
 f30 = Math_fround(f30 + Math_fround(Math_fround(f30 - f33) * Math_fround(.0199999996)));
 f31 = Math_fround(f20 + Math_fround(Math_fround(f20 - f31) * Math_fround(.0199999996)));
 f32 = Math_fround(f5 + Math_fround(Math_fround(f5 - f32) * Math_fround(.0199999996)));
 f33 = Math_fround(f12 + Math_fround(Math_fround(f12 - f33) * Math_fround(.0199999996)));
 f12 = Math_fround(HEAPF32[i62 >> 2]);
 f28 = Math_fround(f28 - f25);
 f29 = Math_fround(f29 - f26);
 f30 = Math_fround(f30 - f27);
 f31 = Math_fround(f31 - f25);
 f32 = Math_fround(f32 - f26);
 f33 = Math_fround(f33 - f27);
 f5 = Math_fround(HEAPF32[i54 >> 2]);
 f20 = Math_fround(f5 * f33);
 f3 = Math_fround(HEAPF32[i55 >> 2]);
 f20 = Math_fround(f20 - Math_fround(f3 * f32));
 f21 = Math_fround(f3 * f31);
 f6 = Math_fround(HEAPF32[i63 >> 2]);
 f21 = Math_fround(f21 - Math_fround(f6 * f33));
 f22 = Math_fround(Math_fround(f6 * f32) - Math_fround(f5 * f31));
 f23 = Math_fround(Math_fround(f30 * f22) + Math_fround(Math_fround(f28 * f20) + Math_fround(f29 * f21)));
 i53 = f23 != Math_fround(0.0);
 f24 = Math_fround(Math_fround(1.0) / f23);
 f24 = i53 ? f24 : Math_fround(0.0);
 if (!(f23 >= Math_fround(9.99999974e-06))) i4 = -1; else {
  f13 = Math_fround(0.0);
  i4 = -1;
  i1 = 0;
  i7 = 0;
  while (1) {
   f46 = Math_fround(f34 * Math_fround(HEAPF32[gb + 84880 + (i7 * 12 | 0) >> 2]));
   f46 = Math_fround(f46 + Math_fround(f35 * Math_fround(HEAPF32[gb + 84880 + (i7 * 12 | 0) + 4 >> 2])));
   if (!(Math_fround(f46 + Math_fround(f36 * Math_fround(HEAPF32[gb + 84880 + (i7 * 12 | 0) + 8 >> 2]))) >= Math_fround(0.0))) {
    f15 = Math_fround(HEAPF32[i56 + (i7 * 12 | 0) >> 2]);
    f16 = Math_fround(HEAPF32[i56 + (i7 * 12 | 0) + 4 >> 2]);
    f15 = Math_fround(f15 - f25);
    f16 = Math_fround(f16 - f26);
    f14 = Math_fround(Math_fround(HEAPF32[i56 + (i7 * 12 | 0) + 8 >> 2]) - f27);
    f17 = Math_fround(Math_fround(Math_fround(f20 * f15) + Math_fround(f21 * f16)) + Math_fround(f22 * f14));
    if (f17 < Math_fround(0.0) | f17 > f23) i2 = 1; else {
     f19 = Math_fround(Math_fround(f30 * f16) - Math_fround(f29 * f14));
     f18 = Math_fround(Math_fround(f28 * f14) - Math_fround(f30 * f15));
     f14 = Math_fround(Math_fround(f29 * f15) - Math_fround(f28 * f16));
     f46 = Math_fround(Math_fround(f14 * f3) + Math_fround(Math_fround(f18 * f5) + Math_fround(f19 * f6)));
     if (f46 < Math_fround(0.0) | Math_fround(f17 + f46) > f23) i2 = 1; else {
      i2 = 0;
      f13 = Math_fround(f24 * Math_fround(Math_fround(f33 * f14) + Math_fround(Math_fround(f31 * f19) + Math_fround(f32 * f18))));
     }
    }
    i53 = f13 > f12 | (i2 | f13 < Math_fround(0.0));
    f14 = f13;
    i4 = i53 ? i4 : 0;
    i1 = i53 ? i1 : i7;
    f12 = i53 ? f12 : f13;
   } else f14 = f13;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == 8) break; else f13 = f14;
  }
  if (!i4) {
   f46 = Math_fround(f12 * f6);
   f5 = Math_fround(f12 * f5);
   f6 = Math_fround(f12 * f3);
   f3 = Math_fround(f46 + Math_fround(HEAPF32[i56 + (i1 * 12 | 0) >> 2]));
   f5 = Math_fround(f5 + Math_fround(HEAPF32[i56 + (i1 * 12 | 0) + 4 >> 2]));
   f6 = Math_fround(f6 + Math_fround(HEAPF32[i56 + (i1 * 12 | 0) + 8 >> 2]));
   HEAPF32[i57 >> 2] = f3;
   HEAPF32[i57 + 4 >> 2] = f5;
   HEAPF32[i57 + 8 >> 2] = f6;
   HEAPF32[i64 >> 2] = f34;
   HEAPF32[i64 + 4 >> 2] = f35;
   HEAPF32[i64 + 8 >> 2] = f36;
   f6 = Math_fround(HEAPF32[i63 >> 2]);
   f5 = Math_fround(HEAPF32[i54 >> 2]);
   f3 = Math_fround(HEAPF32[i55 >> 2]);
   i4 = 0;
  }
 }
 f46 = Math_fround(-f6);
 f35 = Math_fround(-f5);
 f36 = Math_fround(-f3);
 f17 = Math_fround(-Math_fround(HEAPF32[i37 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[i37 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i37 + 8 >> 2]));
 i42 = Math_fround(Math_abs(Math_fround(f35))) < Math_fround(1.1920929e-07);
 i43 = Math_fround(Math_abs(Math_fround(f36))) < Math_fround(1.1920929e-07);
 i37 = i47 + 4 | 0;
 i38 = i47 + 8 | 0;
 i39 = i47 + 12 | 0;
 i40 = i47 + 16 | 0;
 i41 = i47 + 20 | 0;
 i44 = i64 + 4 | 0;
 i45 = i64 + 8 | 0;
 i52 = i57 + 4 | 0;
 i53 = i57 + 8 | 0;
 if (Math_fround(Math_abs(Math_fround(f46))) < Math_fround(1.1920929e-07)) {
  i10 = 0;
  while (1) {
   i7 = i66 + (i10 * 12 | 0) | 0;
   f3 = Math_fround(HEAPF32[i37 >> 2]);
   f5 = Math_fround(HEAPF32[i38 >> 2]);
   f6 = Math_fround(HEAPF32[i40 >> 2]);
   f13 = Math_fround(HEAPF32[i41 >> 2]);
   f46 = Math_fround(HEAPF32[i39 >> 2]);
   f35 = Math_fround(HEAPF32[i47 >> 2]);
   f36 = Math_fround(HEAPF32[i7 >> 2]);
   do if (f36 < f35 | f36 > f46) f3 = f12; else {
    if (i42) {
     f46 = Math_fround(HEAPF32[i66 + (i10 * 12 | 0) + 4 >> 2]);
     if (f46 < f3 | f46 > f6) {
      f3 = f12;
      break;
     }
    }
    i8 = i66 + (i10 * 12 | 0) + 8 | 0;
    f14 = Math_fround(HEAPF32[i8 >> 2]);
    if (i43) if (f14 < f5 | f14 > f13) {
     f3 = f12;
     break;
    }
    i9 = i66 + (i10 * 12 | 0) + 4 | 0;
    f46 = Math_fround(HEAPF32[i9 >> 2]);
    f36 = Math_fround(Math_fround(f3 - f46) * f19);
    f6 = Math_fround(Math_fround(f6 - f46) * f19);
    f46 = Math_fround(Math_fround(f5 - f14) * f18);
    f13 = Math_fround(Math_fround(f13 - f14) * f18);
    i1 = f36 > f6;
    f3 = i1 ? f6 : f36;
    f5 = i1 ? f36 : f6;
    i2 = f46 > f13;
    f6 = i2 ? f13 : f46;
    f13 = i2 ? f46 : f13;
    if (i42) {
     f3 = Math_fround(-3402823469999999843913219.0e14);
     f5 = Math_fround(3402823469999999843913219.0e14);
     i1 = -1;
    } else {
     i51 = f3 > Math_fround(-3402823469999999843913219.0e14);
     f3 = i51 ? f3 : Math_fround(-3402823469999999843913219.0e14);
     i50 = f5 > Math_fround(3402823469999999843913219.0e14);
     f5 = i50 ? Math_fround(3402823469999999843913219.0e14) : f5;
     i1 = i51 ? (i1 ? 4 : 1) : -1;
    }
    if (!i43) {
     i51 = f6 > f3;
     f3 = i51 ? f6 : f3;
     f5 = f5 < f13 ? f5 : f13;
     i1 = i51 ? (i2 ? 5 : 2) : i1;
    }
    i51 = f3 > f5 | f5 < Math_fround(1.1920929e-07);
    i1 = i51 ? -1 : i1;
    if (!(f3 <= f12) | (f3 < Math_fround(0.0) | (i1 | 0) == -1)) f3 = f12; else {
     HEAP32[i64 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) >> 2];
     HEAP32[i44 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) + 4 >> 2];
     HEAP32[i45 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) + 8 >> 2];
     HEAP32[i57 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i52 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i53 >> 2] = HEAP32[i8 >> 2];
     i4 = 1;
    }
   } while (0);
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == 3) break; else f12 = f3;
  }
 } else {
  i11 = 0;
  while (1) {
   i9 = i66 + (i11 * 12 | 0) | 0;
   f3 = Math_fround(HEAPF32[i47 >> 2]);
   f6 = Math_fround(HEAPF32[i37 >> 2]);
   f13 = Math_fround(HEAPF32[i38 >> 2]);
   f5 = Math_fround(HEAPF32[i39 >> 2]);
   f14 = Math_fround(HEAPF32[i40 >> 2]);
   f15 = Math_fround(HEAPF32[i41 >> 2]);
   if (i42) {
    f46 = Math_fround(HEAPF32[i66 + (i11 * 12 | 0) + 4 >> 2]);
    if (f46 < f6 | f46 > f14) f3 = f12; else i68 = 26;
   } else i68 = 26;
   do if ((i68 | 0) == 26) {
    i68 = 0;
    i10 = i66 + (i11 * 12 | 0) + 8 | 0;
    f16 = Math_fround(HEAPF32[i10 >> 2]);
    if (i43) if (f16 < f13 | f16 > f15) {
     f3 = f12;
     break;
    }
    f35 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(Math_fround(f3 - f35) * f17);
    f35 = Math_fround(Math_fround(f5 - f35) * f17);
    i8 = i66 + (i11 * 12 | 0) + 4 | 0;
    f46 = Math_fround(HEAPF32[i8 >> 2]);
    f36 = Math_fround(Math_fround(f6 - f46) * f19);
    f14 = Math_fround(Math_fround(f14 - f46) * f19);
    f46 = Math_fround(Math_fround(f13 - f16) * f18);
    f15 = Math_fround(Math_fround(f15 - f16) * f18);
    i2 = f3 > f35;
    i1 = i2 ? 3 : 0;
    f5 = i2 ? f3 : f35;
    f3 = i2 ? f35 : f3;
    i2 = f36 > f14;
    f6 = i2 ? f14 : f36;
    f13 = i2 ? f36 : f14;
    i7 = f46 > f15;
    f14 = i7 ? f15 : f46;
    f15 = i7 ? f46 : f15;
    if (!i42) {
     i51 = f6 > f3;
     f3 = i51 ? f6 : f3;
     f5 = f5 < f13 ? f5 : f13;
     i1 = i51 ? (i2 ? 4 : 1) : i1;
    }
    if (!i43) {
     i51 = f14 > f3;
     f3 = i51 ? f14 : f3;
     f5 = f5 < f15 ? f5 : f15;
     i1 = i51 ? (i7 ? 5 : 2) : i1;
    }
    i51 = f3 > f5 | f5 < Math_fround(1.1920929e-07);
    i1 = i51 ? -1 : i1;
    if (!(f3 <= f12) | (f3 < Math_fround(0.0) | (i1 | 0) == -1)) f3 = f12; else {
     HEAP32[i64 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) >> 2];
     HEAP32[i44 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) + 4 >> 2];
     HEAP32[i45 >> 2] = HEAP32[gb + 85248 + (i1 * 12 | 0) + 8 >> 2];
     HEAP32[i57 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i52 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i53 >> 2] = HEAP32[i10 >> 2];
     i4 = 1;
    }
   } while (0);
   i11 = i11 + 1 | 0;
   if ((i11 | 0) == 3) break; else f12 = f3;
  }
 }
 i41 = i59 + 4 | 0;
 i42 = i59 + 8 | 0;
 i43 = i60 + 4 | 0;
 i44 = i60 + 8 | 0;
 i45 = i58 + 4 | 0;
 i47 = i58 + 8 | 0;
 i48 = i65 + 4 | 0;
 i49 = i65 + 8 | 0;
 i50 = i67 + 4 | 0;
 i51 = i67 + 8 | 0;
 i39 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
 i40 = 0;
 i2 = -1;
 i1 = -1;
 do {
  i38 = HEAPU8[i39 >> 0] | 0;
  i11 = HEAP32[i56 + (i38 * 12 | 0) >> 2] | 0;
  HEAP32[i59 >> 2] = i11;
  i37 = HEAP32[i56 + (i38 * 12 | 0) + 4 >> 2] | 0;
  HEAP32[i41 >> 2] = i37;
  i38 = HEAP32[i56 + (i38 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i42 >> 2] = i38;
  i9 = HEAPU8[i39 + 1 >> 0] | 0;
  i39 = i39 + 2 | 0;
  i7 = HEAP32[i56 + (i9 * 12 | 0) >> 2] | 0;
  i8 = HEAP32[i56 + (i9 * 12 | 0) + 4 >> 2] | 0;
  i9 = HEAP32[i56 + (i9 * 12 | 0) + 8 >> 2] | 0;
  f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f5 - f17);
  f12 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f12 - f18);
  f14 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f14 - f19);
  f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f13 * f13)) + Math_fround(f15 * f15))));
  if (f16 > Math_fround(0.0)) {
   f46 = Math_fround(Math_fround(.00999999977) / f16);
   f35 = Math_fround(f6 * f46);
   f36 = Math_fround(f13 * f46);
   f46 = Math_fround(f15 * f46);
   f17 = Math_fround(f17 - f35);
   HEAPF32[i59 >> 2] = f17;
   f18 = Math_fround(f18 - f36);
   HEAPF32[i41 >> 2] = f18;
   f19 = Math_fround(f19 - f46);
   HEAPF32[i42 >> 2] = f19;
   f35 = Math_fround(f5 + f35);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
   f36 = Math_fround(f12 + f36);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
   f46 = Math_fround(f14 + f46);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f46 = Math_fround(HEAPF32[gb + 84976 + (i40 * 12 | 0) >> 2]);
  f5 = Math_fround(HEAPF32[i63 >> 2]);
  f46 = Math_fround(f46 * f5);
  f36 = Math_fround(HEAPF32[gb + 84976 + (i40 * 12 | 0) + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i54 >> 2]);
  f36 = Math_fround(f46 + Math_fround(f36 * f12));
  f46 = Math_fround(HEAPF32[gb + 84976 + (i40 * 12 | 0) + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i55 >> 2]);
  L59 : do if (!(Math_fround(f36 + Math_fround(f46 * f13)) < Math_fround(0.0))) {
   f36 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f46 = Math_fround(f36 - f17);
   f34 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f35 = Math_fround(f34 - f18);
   f30 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = Math_fround(f30 - f19);
   HEAPF32[i60 >> 2] = f46;
   HEAPF32[i43 >> 2] = f35;
   HEAPF32[i44 >> 2] = f31;
   f32 = Math_fround(Math_fround(f35 * f13) - Math_fround(f31 * f12));
   f33 = Math_fround(Math_fround(f31 * f5) - Math_fround(f13 * f46));
   f28 = Math_fround(Math_fround(f12 * f46) - Math_fround(f35 * f5));
   f29 = Math_fround(Math_fround(Math_fround(f32 * f17) + Math_fround(f33 * f18)) + Math_fround(f28 * f19));
   f5 = Math_fround(Math_abs(Math_fround(f32)));
   f27 = Math_fround(Math_abs(Math_fround(f33)));
   f6 = Math_fround(Math_abs(Math_fround(f28)));
   if (f27 > f5 & f27 > f6) {
    i8 = 2;
    i7 = 0;
   } else if (f6 > f5) {
    i8 = 0;
    i7 = 1;
   } else {
    i8 = 1;
    i7 = 2;
   }
   f25 = Math_fround(HEAPF32[i60 + (i8 << 2) >> 2]);
   f27 = Math_fround(f25 * Math_fround(HEAPF32[i63 + (i7 << 2) >> 2]));
   f26 = Math_fround(HEAPF32[i60 + (i7 << 2) >> 2]);
   f27 = Math_fround(Math_fround(1.0) / Math_fround(f27 - Math_fround(f26 * Math_fround(HEAPF32[i63 + (i8 << 2) >> 2]))));
   i38 = i58 + (i7 << 2) | 0;
   i11 = i59 + (i7 << 2) | 0;
   i37 = i58 + (i8 << 2) | 0;
   i10 = i59 + (i8 << 2) | 0;
   f24 = f12;
   f23 = f13;
   i7 = 0;
   f22 = f3;
   i8 = i1;
   while (1) {
    f21 = Math_fround(HEAPF32[i63 >> 2]);
    while (1) {
     i9 = i7;
     i7 = i7 + 1 | 0;
     i1 = i7 + (i9 >>> 1) & 3;
     f13 = Math_fround(HEAPF32[i66 + (i9 * 12 | 0) >> 2]);
     f15 = Math_fround(HEAPF32[i66 + (i9 * 12 | 0) + 4 >> 2]);
     f20 = Math_fround(HEAPF32[i66 + (i9 * 12 | 0) + 8 >> 2]);
     f3 = Math_fround(HEAPF32[i66 + (i1 * 12 | 0) >> 2]);
     f5 = Math_fround(HEAPF32[i66 + (i1 * 12 | 0) + 4 >> 2]);
     f6 = Math_fround(HEAPF32[i66 + (i1 * 12 | 0) + 8 >> 2]);
     f14 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f13) + Math_fround(f33 * f15)) + Math_fround(f28 * f20)) - f29);
     if (!(Math_fround(f14 * Math_fround(Math_fround(Math_fround(Math_fround(f32 * f3) + Math_fround(f33 * f5)) + Math_fround(f28 * f6)) - f29)) > Math_fround(0.0))) {
      f12 = Math_fround(f3 - f13);
      f5 = Math_fround(f5 - f15);
      f6 = Math_fround(f6 - f20);
      f3 = Math_fround(Math_fround(Math_fround(f32 * f12) + Math_fround(f33 * f5)) + Math_fround(f28 * f6));
      if (!(f3 == Math_fround(0.0))) {
       f3 = Math_fround(f14 / f3);
       f12 = Math_fround(f13 - Math_fround(f12 * f3));
       f16 = Math_fround(f15 - Math_fround(f5 * f3));
       f5 = Math_fround(f20 - Math_fround(f6 * f3));
       HEAPF32[i58 >> 2] = f12;
       HEAPF32[i45 >> 2] = f16;
       HEAPF32[i47 >> 2] = f5;
       f20 = Math_fround(HEAPF32[i38 >> 2]);
       f20 = Math_fround(f25 * Math_fround(f20 - Math_fround(HEAPF32[i11 >> 2])));
       f3 = Math_fround(HEAPF32[i37 >> 2]);
       f3 = Math_fround(f27 * Math_fround(f20 - Math_fround(f26 * Math_fround(f3 - Math_fround(HEAPF32[i10 >> 2])))));
       if (!(f3 < Math_fround(0.0))) {
        f15 = Math_fround(f3 * f21);
        f14 = Math_fround(f3 * f24);
        f13 = Math_fround(f3 * f23);
        f12 = Math_fround(f12 - f15);
        HEAPF32[i58 >> 2] = f12;
        f6 = Math_fround(f16 - f14);
        HEAPF32[i45 >> 2] = f6;
        f5 = Math_fround(f5 - f13);
        HEAPF32[i47 >> 2] = f5;
        if (!(f3 <= f22 ? !(Math_fround(Math_fround(Math_fround(Math_fround(f36 - f12) * Math_fround(f17 - f12)) + Math_fround(Math_fround(f34 - f6) * Math_fround(f18 - f6))) + Math_fround(Math_fround(f30 - f5) * Math_fround(f19 - f5))) < Math_fround(0.0)) : 1)) {
         i2 = i9;
         break;
        }
       }
       if (i7 >>> 0 < 3) continue; else {
        f3 = f22;
        i1 = i8;
        break L59;
       }
      }
     }
     if (i7 >>> 0 >= 3) {
      f3 = f22;
      i1 = i8;
      break L59;
     }
    }
    HEAPF32[i65 >> 2] = f17;
    HEAPF32[i48 >> 2] = f18;
    HEAPF32[i49 >> 2] = f19;
    HEAPF32[i67 >> 2] = f46;
    HEAPF32[i50 >> 2] = f35;
    HEAPF32[i51 >> 2] = f31;
    f23 = Math_fround(f14 + f6);
    f24 = Math_fround(f13 + f5);
    HEAPF32[i57 >> 2] = Math_fround(f15 + f12);
    HEAPF32[i52 >> 2] = f23;
    HEAPF32[i53 >> 2] = f24;
    if (i7 >>> 0 >= 3) {
     i4 = 2;
     i2 = 2;
     break L59;
    }
    f24 = Math_fround(HEAPF32[i54 >> 2]);
    f23 = Math_fround(HEAPF32[i55 >> 2]);
    i4 = 2;
    f22 = f3;
    i8 = i1;
   }
  } while (0);
  i40 = i40 + 1 | 0;
 } while ((i40 | 0) != 12);
 switch (i4 | 0) {
 case -1:
  {
   i1 = 0;
   break;
  }
 case 2:
  {
   i68 = i66 + (i2 * 12 | 0) | 0;
   f35 = Math_fround(Math_fround(HEAPF32[i66 + (i1 * 12 | 0) >> 2]) - Math_fround(HEAPF32[i68 >> 2]));
   f36 = Math_fround(Math_fround(HEAPF32[i66 + (i1 * 12 | 0) + 4 >> 2]) - Math_fround(HEAPF32[i66 + (i2 * 12 | 0) + 4 >> 2]));
   f46 = Math_fround(Math_fround(HEAPF32[i66 + (i1 * 12 | 0) + 8 >> 2]) - Math_fround(HEAPF32[i66 + (i2 * 12 | 0) + 8 >> 2]));
   HEAPF32[i61 >> 2] = f35;
   HEAPF32[i61 + 4 >> 2] = f36;
   HEAPF32[i61 + 8 >> 2] = f46;
   __ZN5physx2Gu21computeEdgeEdgeNormalERNS_6PxVec3ERKS1_S4_S4_S4_S4_f(i64, i65, i67, i68, i61, i63, f3);
   i68 = 55;
   break;
  }
 default:
  i68 = 55;
 }
 if ((i68 | 0) == 55) {
  HEAPF32[i62 >> 2] = f3;
  i1 = 1;
 }
 i68 = i1;
 STACKTOP = i69;
 return i68 | 0;
}

function __ZN16b2CapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i2, i37, i38, i39) {
 i2 = i2 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i40 = 0, f41 = f0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i46 + 304 | 0;
 i40 = i46 + 152 | 0;
 i23 = i46;
 i15 = HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i30 = HEAP32[i15 + 176 >> 2] | 0;
 i32 = (i30 | 0) == 0;
 i31 = HEAP32[i2 + 176 >> 2] | 0;
 i35 = (i31 | 0) == 0;
 i29 = i15 + 12 | 0;
 i33 = i15 + 20 | 0;
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i33 >> 2]));
 i24 = i15 + 16 | 0;
 f4 = Math_fround(HEAPF32[i24 >> 2]);
 i26 = i33 + 4 | 0;
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i26 >> 2]));
 i34 = i2 + 12 | 0;
 i36 = i2 + 20 | 0;
 f5 = Math_fround(HEAPF32[i34 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i36 >> 2]));
 i27 = i2 + 16 | 0;
 f6 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i36 + 4 | 0;
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i28 >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4))));
 if (f3 < Math_fround(1.1920929e-07)) {
  f45 = f1;
  f44 = f4;
 } else {
  f44 = Math_fround(Math_fround(1.0) / f3);
  f45 = Math_fround(f1 * f44);
  f44 = Math_fround(f4 * f44);
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6))));
 if (f1 < Math_fround(1.1920929e-07)) {
  f43 = f5;
  f41 = f6;
 } else {
  f41 = Math_fround(Math_fround(1.0) / f1);
  f43 = Math_fround(f5 * f41);
  f41 = Math_fround(f6 * f41);
 }
 HEAP32[i42 >> 2] = gb + 151824 + 8;
 i20 = i42 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 i20 = i2 + 8 | 0;
 HEAP32[i42 + 8 >> 2] = HEAP32[i20 >> 2];
 L7 : do if (i32) i2 = i15 + 8 | 0; else {
  if (i35) i12 = i37 + 60 | 0; else {
   __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i37, i15 + 28 | 0, i38, i2 + 28 | 0, i39);
   i12 = i37 + 60 | 0;
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i7 = HEAP32[i37 + 40 >> 2] | 0;
    i2 = HEAP32[i37 + 44 >> 2] | 0;
    f1 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(f21 * f1);
    f4 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f22 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(f3 - Math_fround(f22 * f4));
    f4 = Math_fround(Math_fround(f1 * f22) + Math_fround(f21 * f4));
    f21 = Math_fround(HEAPF32[i39 + 12 >> 2]);
    f22 = Math_fround(f21 * f3);
    f1 = Math_fround(HEAPF32[i39 + 8 >> 2]);
    f22 = Math_fround(f22 + Math_fround(f1 * f4));
    f1 = Math_fround(Math_fround(f21 * f4) - Math_fround(f3 * f1));
    f3 = Math_fround(-f22);
    f4 = Math_fround(-f1);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f22 * f22) + Math_fround(f1 * f1))));
    i8 = f1 < Math_fround(1.1920929e-07);
    if ((HEAP32[i37 + 56 >> 2] | 0) == 1) if (i8) {
     i9 = i10;
     i8 = i11;
    } else {
     f22 = Math_fround(Math_fround(1.0) / f1);
     f21 = Math_fround(f22 * f3);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(f22 * f4);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    } else if (i8) {
     i9 = i7;
     i7 = i10;
     i8 = i2;
     i2 = i11;
    } else {
     f22 = Math_fround(Math_fround(1.0) / f1);
     f21 = Math_fround(f22 * f3);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(f22 * f4);
     i9 = i7;
     i7 = i8;
     i8 = i2;
     i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    }
    f22 = Math_fround(f44 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f22 = Math_fround(Math_fround(f45 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f22);
    f1 = Math_fround(f41 * (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f1 = Math_fround(Math_fround(f43 * (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f1);
    if (f22 >= Math_fround(.99999988) | f22 <= Math_fround(-.99999988)) if (f1 >= Math_fround(.99999988) | f1 <= Math_fround(-.99999988)) {
     i42 = HEAP32[gb + 151644 >> 2] | 0;
     HEAP32[i37 + 64 >> 2] = i42;
     HEAP32[i37 + 68 >> 2] = i42;
     STACKTOP = i46;
     return;
    }
    HEAP32[i12 >> 2] = 0;
   }
  }
  HEAP32[i40 >> 2] = gb + 151728 + 8;
  HEAP32[i40 + 4 >> 2] = 2;
  i7 = i40 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[gb + 151644 >> 2];
  HEAP32[i40 + 148 >> 2] = 0;
  HEAPF32[i40 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i40 + 16 >> 2] = Math_fround(0.0);
  i2 = i15 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i40, i29, i33);
  i7 = i42 + 12 | 0;
  i10 = i34;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i15 = i7;
  HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i15 + 4 >> 2] = i11;
  __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i37, i40, i38, i42, i39, 0);
  if ((HEAP32[i12 >> 2] | 0) > 0) {
   f5 = Math_fround(HEAPF32[i37 + 40 >> 2]);
   f6 = Math_fround(HEAPF32[i37 + 44 >> 2]);
   f21 = Math_fround(HEAPF32[i38 + 12 >> 2]);
   f3 = Math_fround(f5 * f21);
   f1 = Math_fround(HEAPF32[i38 + 8 >> 2]);
   f3 = Math_fround(f3 - Math_fround(f6 * f1));
   f1 = Math_fround(Math_fround(f6 * f21) + Math_fround(f5 * f1));
   f21 = Math_fround(HEAPF32[i39 + 12 >> 2]);
   f22 = Math_fround(f21 * f3);
   f4 = Math_fround(HEAPF32[i39 + 8 >> 2]);
   f22 = Math_fround(f22 + Math_fround(f4 * f1));
   f4 = Math_fround(Math_fround(f21 * f1) - Math_fround(f3 * f4));
   f3 = Math_fround(-f22);
   f1 = Math_fround(-f4);
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f22 * f22) + Math_fround(f4 * f4))));
   if (!(f4 < Math_fround(1.1920929e-07))) {
    f22 = Math_fround(Math_fround(1.0) / f4);
    f3 = Math_fround(f22 * f3);
    f1 = Math_fround(f22 * f1);
   }
   f22 = Math_fround(Math_fround(f45 * f6) - Math_fround(f44 * f5));
   if (!((f22 >= Math_fround(.99999988) | f22 <= Math_fround(-.99999988)) & (i35 | Math_fround(Math_fround(f43 * f3) + Math_fround(f41 * f1)) >= Math_fround(0.0)))) {
    HEAP32[i12 >> 2] = 0;
    i25 = 24;
   }
  } else i25 = 24;
  do if ((i25 | 0) == 24) {
   if (!i35) {
    i10 = i36;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i15 = i7;
    HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i15 + 4 >> 2] = i11;
    __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i37, i40, i38, i42, i39, 0);
    if ((HEAP32[i12 >> 2] | 0) > 0) {
     f5 = Math_fround(HEAPF32[i37 + 40 >> 2]);
     f6 = Math_fround(HEAPF32[i37 + 44 >> 2]);
     f21 = Math_fround(HEAPF32[i38 + 12 >> 2]);
     f3 = Math_fround(f5 * f21);
     f1 = Math_fround(HEAPF32[i38 + 8 >> 2]);
     f3 = Math_fround(f3 - Math_fround(f6 * f1));
     f1 = Math_fround(Math_fround(f6 * f21) + Math_fround(f5 * f1));
     f21 = Math_fround(HEAPF32[i39 + 12 >> 2]);
     f22 = Math_fround(f21 * f3);
     f4 = Math_fround(HEAPF32[i39 + 8 >> 2]);
     f22 = Math_fround(f22 + Math_fround(f4 * f1));
     f4 = Math_fround(Math_fround(f21 * f1) - Math_fround(f3 * f4));
     f3 = Math_fround(-f22);
     f1 = Math_fround(-f4);
     f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f22 * f22) + Math_fround(f4 * f4))));
     if (!(f4 < Math_fround(1.1920929e-07))) {
      f22 = Math_fround(Math_fround(1.0) / f4);
      f3 = Math_fround(f22 * f3);
      f1 = Math_fround(f22 * f1);
     }
     f22 = Math_fround(Math_fround(f45 * f6) - Math_fround(f44 * f5));
     if ((f22 >= Math_fround(.99999988) | f22 <= Math_fround(-.99999988)) & Math_fround(Math_fround(-Math_fround(f41 * f1)) - Math_fround(f43 * f3)) >= Math_fround(0.0)) break;
     HEAP32[i12 >> 2] = 0;
    }
   }
   break L7;
  } while (0);
  STACKTOP = i46;
  return;
 } while (0);
 HEAP32[i40 >> 2] = gb + 151824 + 8;
 i8 = i40 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = HEAP32[i2 >> 2];
 i8 = i40 + 12 | 0;
 i11 = i29;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i15 = i8;
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = i12;
 L45 : do if (i35) {
  i2 = i37 + 60 | 0;
  i25 = 50;
 } else {
  HEAP32[i23 >> 2] = gb + 151728 + 8;
  HEAP32[i23 + 4 >> 2] = 2;
  i2 = i23 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 151644 >> 2];
  HEAP32[i23 + 148 >> 2] = 0;
  HEAPF32[i23 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i23 + 16 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
  __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i23, i34, i36);
  __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i37, i23, i39, i40, i38, 0);
  i2 = i37 + 60 | 0;
  do if ((HEAP32[i2 >> 2] | 0) > 0) {
   f5 = Math_fround(HEAPF32[i37 + 40 >> 2]);
   f6 = Math_fround(HEAPF32[i37 + 44 >> 2]);
   f21 = Math_fround(HEAPF32[i39 + 12 >> 2]);
   f1 = Math_fround(f5 * f21);
   f3 = Math_fround(HEAPF32[i39 + 8 >> 2]);
   f1 = Math_fround(f1 - Math_fround(f6 * f3));
   f3 = Math_fround(Math_fround(f6 * f21) + Math_fround(f5 * f3));
   f21 = Math_fround(HEAPF32[i38 + 12 >> 2]);
   f22 = Math_fround(f21 * f1);
   f4 = Math_fround(HEAPF32[i38 + 8 >> 2]);
   f22 = Math_fround(f22 + Math_fround(f4 * f3));
   f4 = Math_fround(Math_fround(f21 * f3) - Math_fround(f1 * f4));
   f1 = Math_fround(-f22);
   f3 = Math_fround(-f4);
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f22 * f22) + Math_fround(f4 * f4))));
   if (f4 < Math_fround(1.1920929e-07)) f4 = f1; else {
    f22 = Math_fround(Math_fround(1.0) / f4);
    f4 = Math_fround(f22 * f1);
    f3 = Math_fround(f22 * f3);
   }
   f1 = Math_fround(Math_fround(f43 * f6) - Math_fround(f41 * f5));
   if (i32 | Math_fround(Math_fround(f45 * f4) + Math_fround(f44 * f3)) >= Math_fround(0.0)) if (f1 >= Math_fround(.99999988) | f1 <= Math_fround(-.99999988)) {
    HEAP32[i37 + 56 >> 2] = 2;
    break;
   }
   HEAP32[i2 >> 2] = 0;
   i25 = 41;
  } else i25 = 41; while (0);
  do if ((i25 | 0) == 41) {
   i12 = i33;
   i15 = HEAP32[i12 + 4 >> 2] | 0;
   i20 = i8;
   HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i20 + 4 >> 2] = i15;
   __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i37, i23, i39, i40, i38, 0);
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    f5 = Math_fround(HEAPF32[i37 + 40 >> 2]);
    f6 = Math_fround(HEAPF32[i37 + 44 >> 2]);
    f21 = Math_fround(HEAPF32[i39 + 12 >> 2]);
    f1 = Math_fround(f5 * f21);
    f3 = Math_fround(HEAPF32[i39 + 8 >> 2]);
    f1 = Math_fround(f1 - Math_fround(f6 * f3));
    f3 = Math_fround(Math_fround(f6 * f21) + Math_fround(f5 * f3));
    f21 = Math_fround(HEAPF32[i38 + 12 >> 2]);
    f22 = Math_fround(f21 * f1);
    f4 = Math_fround(HEAPF32[i38 + 8 >> 2]);
    f22 = Math_fround(f22 + Math_fround(f4 * f3));
    f4 = Math_fround(Math_fround(f21 * f3) - Math_fround(f1 * f4));
    f1 = Math_fround(-f22);
    f3 = Math_fround(-f4);
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f22 * f22) + Math_fround(f4 * f4))));
    if (f4 < Math_fround(1.1920929e-07)) f4 = f1; else {
     f22 = Math_fround(Math_fround(1.0) / f4);
     f4 = Math_fround(f22 * f1);
     f3 = Math_fround(f22 * f3);
    }
    f1 = Math_fround(Math_fround(f43 * f6) - Math_fround(f41 * f5));
    if (Math_fround(Math_fround(-Math_fround(f44 * f3)) - Math_fround(f45 * f4)) >= Math_fround(0.0)) if (f1 >= Math_fround(.99999988) | f1 <= Math_fround(-.99999988)) {
     HEAP32[i37 + 56 >> 2] = 2;
     break;
    }
    HEAP32[i2 >> 2] = 0;
   }
   i25 = 50;
   break L45;
  } while (0);
 } while (0);
 do if ((i25 | 0) == 50) {
  f4 = Math_fround(HEAPF32[i38 + 12 >> 2]);
  f5 = Math_fround(HEAPF32[i29 >> 2]);
  f14 = Math_fround(f4 * f5);
  f6 = Math_fround(HEAPF32[i38 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i24 >> 2]);
  f14 = Math_fround(f14 - Math_fround(f6 * f21));
  f19 = Math_fround(HEAPF32[i38 >> 2]);
  f14 = Math_fround(f19 + f14);
  f21 = Math_fround(Math_fround(f5 * f6) + Math_fround(f4 * f21));
  f5 = Math_fround(HEAPF32[i38 + 4 >> 2]);
  f21 = Math_fround(f21 + f5);
  f50 = Math_fround(HEAPF32[i39 >> 2]);
  f14 = Math_fround(f14 - f50);
  f48 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f21 = Math_fround(f21 - f48);
  f3 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  f13 = Math_fround(f14 * f3);
  f47 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f21 * f47));
  f14 = Math_fround(Math_fround(f3 * f21) - Math_fround(f14 * f47));
  f21 = Math_fround(HEAPF32[i33 >> 2]);
  f22 = Math_fround(f4 * f21);
  f16 = Math_fround(HEAPF32[i26 >> 2]);
  f22 = Math_fround(Math_fround(f19 + Math_fround(f22 - Math_fround(f6 * f16))) - f50);
  f16 = Math_fround(Math_fround(f5 + Math_fround(Math_fround(f6 * f21) + Math_fround(f4 * f16))) - f48);
  f21 = Math_fround(Math_fround(f3 * f22) + Math_fround(f47 * f16));
  f22 = Math_fround(Math_fround(f3 * f16) - Math_fround(f47 * f22));
  f16 = Math_fround(HEAPF32[i34 >> 2]);
  f17 = Math_fround(f3 * f16);
  f1 = Math_fround(HEAPF32[i27 >> 2]);
  f17 = Math_fround(Math_fround(f50 + Math_fround(f17 - Math_fround(f47 * f1))) - f19);
  f1 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(f47 * f16) + Math_fround(f3 * f1))) - f5);
  f16 = Math_fround(Math_fround(f4 * f17) + Math_fround(f6 * f1));
  f17 = Math_fround(Math_fround(f4 * f1) - Math_fround(f6 * f17));
  f1 = Math_fround(HEAPF32[i36 >> 2]);
  f49 = Math_fround(f3 * f1);
  f18 = Math_fround(HEAPF32[i28 >> 2]);
  f19 = Math_fround(Math_fround(f50 + Math_fround(f49 - Math_fround(f47 * f18))) - f19);
  f5 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(f47 * f1) + Math_fround(f3 * f18))) - f5);
  f18 = Math_fround(Math_fround(f4 * f19) + Math_fround(f6 * f5));
  f19 = Math_fround(Math_fround(f4 * f5) - Math_fround(f6 * f19));
  i28 = i29;
  i27 = HEAP32[i28 + 4 >> 2] | 0;
  i7 = i8;
  HEAP32[i7 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i7 + 4 >> 2] = i27;
  i7 = i42 + 12 | 0;
  i27 = i34;
  i28 = HEAP32[i27 + 4 >> 2] | 0;
  i29 = i7;
  HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i29 + 4 >> 2] = i28;
  __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i37, i40, i38, i42, i39);
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   if (!(i31 | i30)) break;
   f4 = Math_fround(f16 - Math_fround(HEAPF32[i8 >> 2]));
   f6 = Math_fround(f17 - Math_fround(HEAPF32[i40 + 16 >> 2]));
   f3 = Math_fround(f13 - Math_fround(HEAPF32[i7 >> 2]));
   f1 = Math_fround(f14 - Math_fround(HEAPF32[i42 + 16 >> 2]));
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6))));
   if (!(f5 < Math_fround(1.1920929e-07))) {
    f50 = Math_fround(Math_fround(1.0) / f5);
    f4 = Math_fround(f4 * f50);
    f6 = Math_fround(f6 * f50);
   }
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))));
   if (!(f5 < Math_fround(1.1920929e-07))) {
    f50 = Math_fround(Math_fround(1.0) / f5);
    f3 = Math_fround(f3 * f50);
    f1 = Math_fround(f1 * f50);
   }
   if ((i32 | Math_fround(Math_fround(f44 * f6) + Math_fround(f45 * f4)) >= Math_fround(0.0)) & (i35 | Math_fround(Math_fround(f41 * f1) + Math_fround(f43 * f3)) >= Math_fround(0.0))) break;
   HEAP32[i2 >> 2] = 0;
  }
  if (!i35) {
   i29 = i36;
   i30 = HEAP32[i29 + 4 >> 2] | 0;
   i31 = i7;
   HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i31 + 4 >> 2] = i30;
   __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i37, i40, i38, i42, i39);
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    f6 = Math_fround(f18 - Math_fround(HEAPF32[i8 >> 2]));
    f5 = Math_fround(f19 - Math_fround(HEAPF32[i40 + 16 >> 2]));
    f3 = Math_fround(f13 - Math_fround(HEAPF32[i7 >> 2]));
    f1 = Math_fround(f14 - Math_fround(HEAPF32[i42 + 16 >> 2]));
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))));
    if (!(f4 < Math_fround(1.1920929e-07))) {
     f50 = Math_fround(Math_fround(1.0) / f4);
     f6 = Math_fround(f6 * f50);
     f5 = Math_fround(f5 * f50);
    }
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))));
    if (!(f4 < Math_fround(1.1920929e-07))) {
     f50 = Math_fround(Math_fround(1.0) / f4);
     f3 = Math_fround(f3 * f50);
     f1 = Math_fround(f1 * f50);
    }
    if ((i32 | Math_fround(Math_fround(f44 * f5) + Math_fround(f45 * f6)) >= Math_fround(0.0)) & Math_fround(Math_fround(-Math_fround(f41 * f1)) - Math_fround(f43 * f3)) >= Math_fround(0.0)) break;
    HEAP32[i2 >> 2] = 0;
   }
  }
  if (!i32) {
   i31 = i33;
   i33 = HEAP32[i31 + 4 >> 2] | 0;
   i32 = i8;
   HEAP32[i32 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + 4 >> 2] = i33;
   i32 = i34;
   i33 = HEAP32[i32 + 4 >> 2] | 0;
   i34 = i7;
   HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i34 + 4 >> 2] = i33;
   __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i37, i40, i38, i42, i39);
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    f5 = Math_fround(f16 - Math_fround(HEAPF32[i8 >> 2]));
    f6 = Math_fround(f17 - Math_fround(HEAPF32[i40 + 16 >> 2]));
    f3 = Math_fround(f21 - Math_fround(HEAPF32[i7 >> 2]));
    f1 = Math_fround(f22 - Math_fround(HEAPF32[i42 + 16 >> 2]));
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6))));
    if (!(f4 < Math_fround(1.1920929e-07))) {
     f50 = Math_fround(Math_fround(1.0) / f4);
     f5 = Math_fround(f5 * f50);
     f6 = Math_fround(f6 * f50);
    }
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))));
    if (!(f4 < Math_fround(1.1920929e-07))) {
     f50 = Math_fround(Math_fround(1.0) / f4);
     f3 = Math_fround(f3 * f50);
     f1 = Math_fround(f1 * f50);
    }
    if (Math_fround(Math_fround(-Math_fround(f44 * f6)) - Math_fround(f45 * f5)) >= Math_fround(0.0) & (i35 | Math_fround(Math_fround(f41 * f1) + Math_fround(f43 * f3)) >= Math_fround(0.0))) break;
    HEAP32[i2 >> 2] = 0;
   }
   if (!i35) {
    i34 = i36;
    i35 = HEAP32[i34 + 4 >> 2] | 0;
    i36 = i7;
    HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i36 + 4 >> 2] = i35;
    __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i37, i40, i38, i42, i39);
    if ((HEAP32[i2 >> 2] | 0) > 0) {
     f6 = Math_fround(f18 - Math_fround(HEAPF32[i8 >> 2]));
     f5 = Math_fround(f19 - Math_fround(HEAPF32[i40 + 16 >> 2]));
     f3 = Math_fround(f21 - Math_fround(HEAPF32[i7 >> 2]));
     f1 = Math_fround(f22 - Math_fround(HEAPF32[i42 + 16 >> 2]));
     f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5))));
     if (!(f4 < Math_fround(1.1920929e-07))) {
      f50 = Math_fround(Math_fround(1.0) / f4);
      f6 = Math_fround(f6 * f50);
      f5 = Math_fround(f5 * f50);
     }
     f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))));
     if (!(f4 < Math_fround(1.1920929e-07))) {
      f50 = Math_fround(Math_fround(1.0) / f4);
      f3 = Math_fround(f3 * f50);
      f1 = Math_fround(f1 * f50);
     }
     if (!(Math_fround(Math_fround(-Math_fround(f44 * f5)) - Math_fround(f45 * f6)) >= Math_fround(0.0) ? Math_fround(Math_fround(-Math_fround(f41 * f1)) - Math_fround(f43 * f3)) >= Math_fround(0.0) : 0)) HEAP32[i2 >> 2] = 0;
    }
   }
  }
 } while (0);
 STACKTOP = i46;
 return;
}

function __ZN5Umbra12RegionFinder7executeEPNS_8UserListIiEEPNS1_IfEES5_S3_(i80, i81, i84, i85, i86) {
 i80 = i80 | 0;
 i81 = i81 | 0;
 i84 = i84 | 0;
 i85 = i85 | 0;
 i86 = i86 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i82 = 0, i83 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, f94 = f0;
 i93 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i91 = i93 + 48 | 0;
 i1 = i93 + 40 | 0;
 i87 = i93 + 24 | 0;
 i88 = i93 + 8 | 0;
 i89 = i93;
 i90 = i80 + 24168 | 0;
 if ((HEAP32[i90 >> 2] | 0) == -1) {
  HEAP32[(HEAP32[i80 + 144 >> 2] | 0) + 28 >> 2] = 5;
  STACKTOP = i93;
  return;
 }
 i82 = i80 + 148 | 0;
 i83 = i80 + 24184 | 0;
 HEAP32[i1 >> 2] = HEAP32[i83 >> 2];
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAP32[i91 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i91 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i82, i91, Math_fround(0.0)) | 0;
 i46 = i80 + 144 | 0;
 i1 = HEAP32[HEAP32[i46 >> 2] >> 2] | 0;
 i47 = i80 + 164 | 0;
 i2 = HEAP32[i47 >> 2] | 0;
 if (!i2) {
  STACKTOP = i93;
  return;
 }
 i48 = i80 + 168 | 0;
 i49 = i80 + 8168 | 0;
 i50 = i80 + 156 | 0;
 i38 = i80 + 24172 | 0;
 i39 = i80 + 24176 | 0;
 i42 = i80 + 24180 | 0;
 i51 = i80 + 4 | 0;
 i52 = i80 + 20 | 0;
 i53 = i80 + 68 | 0;
 i54 = (i81 | 0) == 0;
 i55 = i80 + 24192 | 0;
 i56 = i81 + 8 | 0;
 i57 = i81 + 4 | 0;
 i58 = (i84 | 0) == 0;
 i59 = (i85 | 0) == 0;
 i60 = (i86 | 0) == 0;
 i61 = i86 + 8 | 0;
 i62 = i86 + 4 | 0;
 i63 = i85 + 8 | 0;
 i64 = i85 + 4 | 0;
 i65 = i84 + 8 | 0;
 i66 = i84 + 4 | 0;
 i67 = i80 + 76 | 0;
 i68 = i80 + 92 | 0;
 i69 = i80 + 24196 | 0;
 i40 = i88 + 4 | 0;
 i43 = i88 + 8 | 0;
 i70 = i80 + 24188 | 0;
 i45 = i89 + 4 | 0;
 i71 = i87 + 8 | 0;
 i72 = i80 + 112 | 0;
 i73 = i80 + 128 | 0;
 i74 = i80 + 40 | 0;
 i75 = i80 + 56 | 0;
 i41 = i87 + 4 | 0;
 i44 = i87 + 8 | 0;
 i76 = i80 + 32 | 0;
 i77 = i91 + 4 | 0;
 i78 = i80 + 104 | 0;
 i79 = i80 + 140 | 0;
 i18 = HEAP32[i1 + 92 >> 2] | 0;
 i14 = HEAP32[i1 + 96 >> 2] | 0;
 i11 = HEAP32[i1 + 100 >> 2] | 0;
 i12 = HEAP32[i1 + 104 >> 2] | 0;
 i13 = HEAP32[i1 + 108 >> 2] | 0;
 i7 = HEAP32[i1 + 112 >> 2] | 0;
 L8 : while (1) {
  i20 = HEAP32[i48 >> 2] | 0;
  i37 = i49;
  i36 = HEAP32[i37 >> 2] | 0;
  i37 = HEAP32[i37 + 4 >> 2] | 0;
  i4 = i2 + -1 | 0;
  HEAP32[i47 >> 2] = i4;
  if (i4 | 0) {
   f10 = Math_fround(HEAPF32[i80 + 168 + (i4 << 2) >> 2]);
   i6 = i80 + 8168 + (i4 << 3) | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   L12 : do if ((i4 | 0) > 1) {
    i3 = 0;
    i2 = 1;
    while (1) {
     i1 = i2 + 1 | 0;
     if ((i1 | 0) < (i4 | 0)) {
      f23 = Math_fround(HEAPF32[i80 + 168 + (i1 << 2) >> 2]);
      if (!(f23 <= Math_fround(HEAPF32[i80 + 168 + (i2 << 2) >> 2]))) i1 = i2;
     } else i1 = i2;
     f8 = Math_fround(HEAPF32[i80 + 168 + (i1 << 2) >> 2]);
     if (f10 <= f8) {
      i1 = i3;
      break L12;
     }
     HEAPF32[i80 + 168 + (i3 << 2) >> 2] = f8;
     i34 = i80 + 8168 + (i1 << 3) | 0;
     i35 = HEAP32[i34 + 4 >> 2] | 0;
     i2 = i80 + 8168 + (i3 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i34 >> 2];
     HEAP32[i2 + 4 >> 2] = i35;
     i2 = i1 << 1 | 1;
     if ((i2 | 0) >= (i4 | 0)) break; else i3 = i1;
    }
   } else i1 = 0; while (0);
   HEAPF32[i80 + 168 + (i1 << 2) >> 2] = f10;
   i35 = i80 + 8168 + (i1 << 3) | 0;
   HEAP32[i35 >> 2] = i5;
   HEAP32[i35 + 4 >> 2] = i6;
  }
  i35 = (HEAP32[i50 >> 2] | 0) + (i36 >> 5 << 2) | 0;
  HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | 1 << (i36 & 31);
  if ((i36 | 0) == (HEAP32[i83 >> 2] | 0)) {
   f16 = Math_fround(HEAPF32[i38 >> 2]);
   f10 = Math_fround(HEAPF32[i39 >> 2]);
   f8 = Math_fround(HEAPF32[i42 >> 2]);
   i9 = HEAP32[i90 >> 2] | 0;
   i6 = -1;
   i3 = i18;
   i1 = i14;
  } else {
   HEAP32[i91 >> 2] = 0;
   HEAP32[i91 + 4 >> 2] = 0;
   HEAP32[i91 + 8 >> 2] = 0;
   HEAP32[i91 + 12 >> 2] = 0;
   i3 = __ZN5Umbra10QueryState23findTomeByClusterPortalEi(HEAP32[HEAP32[i46 >> 2] >> 2] | 0, i36) | 0;
   if ((i3 | 0) == (i18 | 0)) {
    i3 = i18;
    i1 = i14;
   } else {
    i2 = HEAP32[HEAP32[i46 >> 2] >> 2] | 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if ((i3 | 0) != -1 & (i1 | 0) != 0) {
     i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i3 << 5)) | 0;
     if (!i1) i92 = 20; else {
      i11 = HEAP32[i1 >> 2] | 0;
      i12 = HEAP32[i2 >> 2] | 0;
      i13 = HEAP32[i12 + (HEAP32[i12 + 180 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      i9 = i12 + (HEAP32[i12 + 184 >> 2] | 0) | 0;
      i14 = HEAP32[i9 + (i3 << 2) >> 2] | 0;
      i9 = (HEAP32[i9 + (i3 + 1 << 2) >> 2] | 0) - i14 | 0;
      HEAP32[i2 + 92 >> 2] = i3;
      HEAP32[i2 + 96 >> 2] = i1;
      HEAP32[i2 + 100 >> 2] = i11;
      HEAP32[i2 + 104 >> 2] = i12;
      HEAP32[i2 + 108 >> 2] = i13;
      HEAP32[i2 + 112 >> 2] = i14;
      HEAP32[i2 + 116 >> 2] = i9;
     }
    } else i92 = 20;
    if ((i92 | 0) == 20) {
     i92 = 0;
     i12 = HEAP32[i2 >> 2] | 0;
     HEAP32[i2 + 92 >> 2] = 0;
     HEAP32[i2 + 96 >> 2] = 0;
     HEAP32[i2 + 100 >> 2] = i12;
     HEAP32[i2 + 104 >> 2] = i12;
     HEAP32[i2 + 108 >> 2] = 0;
     HEAP32[i2 + 112 >> 2] = 0;
     HEAP32[i2 + 116 >> 2] = 0;
     i3 = 0;
     i1 = 0;
     i11 = i12;
     i13 = 0;
     i14 = 0;
     i9 = 0;
    }
    i4 = i11;
    i5 = i11;
    i6 = HEAP32[i4 + 132 >> 2] | 0;
    i7 = i4 + 180 | 0;
    if (!(HEAP32[i7 >> 2] | 0)) {
     i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
     i35 = i5 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
     i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
    } else i2 = HEAP32[i5 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
    HEAP32[i78 >> 2] = i2;
    HEAP32[i67 >> 2] = (i6 | 0) == 0 ? 0 : i5 + i6 | 0;
    if (!i1) {
     i4 = 0;
     i5 = 0;
     i2 = 0;
    } else {
     if (!(HEAP32[i7 >> 2] | 0)) {
      i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
      i35 = i5 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
      i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i5 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
     i4 = i12;
     i5 = HEAP32[i1 + 24 >> 2] | 0;
     i2 = i9 - i2 | 0;
    }
    HEAP32[i79 >> 2] = i2;
    HEAP32[i72 >> 2] = (i5 | 0) == 0 ? 0 : i4 + i5 | 0;
    i7 = i14;
   }
   i6 = i36 - ((i1 | 0) == 0 ? 0 : i7) | 0;
   i4 = i11;
   i5 = (HEAP32[i4 + 180 >> 2] | 0) == 0;
   if (i5) {
    i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
    i35 = i11 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
    i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
   } else i2 = HEAP32[i11 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
   if ((i6 | 0) < (i2 | 0)) {
    i15 = (HEAP32[i67 >> 2] | 0) + (Math_imul(HEAP32[i68 >> 2] | 0, i6) | 0) | 0;
    HEAP32[i91 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i91 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i91 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i91 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    i15 = i7;
    i9 = HEAP32[i91 >> 2] & 67108863;
   } else {
    if (i5) {
     i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
     i35 = i11 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
     i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
    } else i2 = HEAP32[i11 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
    i4 = (HEAP32[i72 >> 2] | 0) + (Math_imul(HEAP32[i73 >> 2] | 0, i6 - i2 | 0) | 0) | 0;
    HEAP32[i91 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i91 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i91 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i91 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i4 = (HEAP32[i77 >> 2] | 0) >>> 16;
    i9 = HEAP32[i91 >> 2] & 67108863;
    if ((i4 | 0) == (i3 | 0)) i15 = i7; else {
     i2 = HEAP32[HEAP32[i46 >> 2] >> 2] | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) i92 = 42; else {
      i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i4 << 5)) | 0;
      if (!i1) i92 = 42; else {
       i12 = HEAP32[i1 >> 2] | 0;
       i14 = HEAP32[i2 >> 2] | 0;
       i13 = HEAP32[i14 + (HEAP32[i14 + 180 >> 2] | 0) + (i4 << 2) >> 2] | 0;
       i11 = i14 + (HEAP32[i14 + 184 >> 2] | 0) | 0;
       i15 = HEAP32[i11 + (i4 << 2) >> 2] | 0;
       i11 = (HEAP32[i11 + (i4 + 1 << 2) >> 2] | 0) - i15 | 0;
       HEAP32[i2 + 92 >> 2] = i4;
       HEAP32[i2 + 96 >> 2] = i1;
       HEAP32[i2 + 100 >> 2] = i12;
       HEAP32[i2 + 104 >> 2] = i14;
       HEAP32[i2 + 108 >> 2] = i13;
       HEAP32[i2 + 112 >> 2] = i15;
       HEAP32[i2 + 116 >> 2] = i11;
       i3 = i4;
      }
     }
     if ((i92 | 0) == 42) {
      i92 = 0;
      i14 = HEAP32[i2 >> 2] | 0;
      HEAP32[i2 + 92 >> 2] = 0;
      HEAP32[i2 + 96 >> 2] = 0;
      HEAP32[i2 + 100 >> 2] = i14;
      HEAP32[i2 + 104 >> 2] = i14;
      HEAP32[i2 + 108 >> 2] = 0;
      HEAP32[i2 + 112 >> 2] = 0;
      HEAP32[i2 + 116 >> 2] = 0;
      i3 = 0;
      i1 = 0;
      i12 = i14;
      i13 = 0;
      i15 = 0;
      i11 = 0;
     }
     i4 = i12;
     i5 = i12;
     i6 = HEAP32[i4 + 132 >> 2] | 0;
     i7 = i4 + 180 | 0;
     if (!(HEAP32[i7 >> 2] | 0)) {
      i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
      i35 = i5 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
      i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i5 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
     HEAP32[i78 >> 2] = i2;
     HEAP32[i67 >> 2] = (i6 | 0) == 0 ? 0 : i5 + i6 | 0;
     if (!i1) {
      i4 = 0;
      i5 = 0;
      i2 = 0;
     } else {
      if (!(HEAP32[i7 >> 2] | 0)) {
       i2 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
       i35 = i5 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
       i2 = (HEAP32[i35 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i35 + (i2 * 20 | 0) >> 2] | 0) | 0;
      } else i2 = HEAP32[i5 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
      i4 = i14;
      i5 = HEAP32[i1 + 24 >> 2] | 0;
      i2 = i11 - i2 | 0;
     }
     HEAP32[i79 >> 2] = i2;
     HEAP32[i72 >> 2] = (i5 | 0) == 0 ? 0 : i4 + i5 | 0;
     i11 = i12;
     i12 = i14;
    }
   }
   i7 = i11;
   if ((i3 | 0) != (i18 | 0)) {
    i35 = HEAP32[i7 + 128 >> 2] | 0;
    i5 = i7 + 124 | 0;
    HEAP32[i76 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i51 >> 2] = (i35 | 0) == 0 ? 0 : i11 + i35 | 0;
    if (!i1) {
     i6 = 0;
     i4 = 0;
     i2 = 0;
    } else {
     i2 = HEAP32[i1 + 20 >> 2] | 0;
     if (!i2) {
      i6 = 0;
      i4 = 0;
      i2 = 0;
     } else {
      i6 = i12;
      i4 = i2;
      i2 = HEAP32[i5 >> 2] | 0;
     }
    }
    HEAP32[i53 >> 2] = i2;
    HEAP32[i74 >> 2] = (i4 | 0) == 0 ? 0 : i6 + i4 | 0;
   }
   __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i87, i7, i91);
   f16 = Math_fround(HEAPF32[i87 >> 2]);
   f10 = Math_fround(HEAPF32[i41 >> 2]);
   i6 = i36;
   i7 = i15;
   f8 = Math_fround(HEAPF32[i44 >> 2]);
  }
  i35 = (HEAP32[i51 >> 2] | 0) + (Math_imul(HEAP32[i52 >> 2] | 0, i9) | 0) | 0;
  i34 = HEAP32[i35 >> 2] | 0;
  i35 = HEAP32[i35 + 4 >> 2] | 0;
  if (!(HEAP32[i53 >> 2] | 0)) {
   i33 = 0;
   i5 = 0;
  } else {
   i5 = (HEAP32[i74 >> 2] | 0) + (Math_imul(HEAP32[i75 >> 2] | 0, i9) | 0) | 0;
   i33 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
  }
  i2 = ((i1 | 0) != 0 & (i9 | 0) != -1 ? i13 : 0) + i9 | 0;
  if (!i54) {
   i30 = (HEAP32[i55 >> 2] | 0) + (i2 >> 5 << 2) | 0;
   i32 = 1 << (i2 & 31);
   i31 = HEAP32[i30 >> 2] | 0;
   HEAP32[i30 >> 2] = i31 | i32;
   if (!(i31 & i32)) {
    i4 = HEAP32[i56 >> 2] | 0;
    if ((i4 | 0) >= (HEAP32[i57 >> 2] | 0)) {
     i92 = 65;
     break;
    }
    HEAP32[(HEAP32[i81 >> 2] | 0) + (i4 << 2) >> 2] = i2;
    HEAP32[i56 >> 2] = (HEAP32[i56 >> 2] | 0) + 1;
    if (!i58) {
     i2 = HEAP32[i65 >> 2] | 0;
     if ((i2 | 0) >= (HEAP32[i66 >> 2] | 0)) {
      i92 = 69;
      break;
     }
     HEAP32[(HEAP32[i84 >> 2] | 0) + (i2 << 2) >> 2] = i20;
     HEAP32[i65 >> 2] = i2 + 1;
    }
    if (!i59) {
     i2 = HEAP32[i63 >> 2] | 0;
     if ((i2 | 0) >= (HEAP32[i64 >> 2] | 0)) {
      i92 = 73;
      break;
     }
     HEAP32[(HEAP32[i85 >> 2] | 0) + (i2 << 2) >> 2] = i37;
     HEAP32[i63 >> 2] = i2 + 1;
    }
    if (!i60) {
     i2 = HEAP32[i61 >> 2] | 0;
     if ((i2 | 0) >= (HEAP32[i62 >> 2] | 0)) {
      i92 = 77;
      break;
     }
     HEAP32[(HEAP32[i86 >> 2] | 0) + (i2 << 2) >> 2] = i6;
     HEAP32[i61 >> 2] = (HEAP32[i61 >> 2] | 0) + 1;
    }
   }
  }
  i30 = i5 + i35 | 0;
  if ((i30 | 0) > 0) {
   i31 = (i1 | 0) == 0 ? 0 : i7;
   i32 = i11;
   f22 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i24 = i32 + 180 | 0;
   i25 = i32 + 128 | 0;
   i26 = i32 + 124 | 0;
   i27 = i11;
   i28 = i32 + 184 | 0;
   i29 = i32 + 176 | 0;
   i21 = 0;
   do {
    HEAP32[i87 >> 2] = 0;
    HEAP32[i87 + 4 >> 2] = 0;
    HEAP32[i87 + 8 >> 2] = 0;
    HEAP32[i87 + 12 >> 2] = 0;
    if ((i21 | 0) < (i35 | 0)) {
     i20 = i21 + i34 | 0;
     i18 = (HEAP32[i67 >> 2] | 0) + (Math_imul(HEAP32[i68 >> 2] | 0, i20) | 0) | 0;
     HEAP32[i87 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i87 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i87 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i87 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     i20 = i20 + i31 | 0;
    } else {
     i4 = i21 - i35 + i33 | 0;
     i20 = (HEAP32[i72 >> 2] | 0) + (Math_imul(HEAP32[i73 >> 2] | 0, i4) | 0) | 0;
     HEAP32[i87 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i87 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i87 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i87 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     if (!(HEAP32[i24 >> 2] | 0)) {
      i2 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
      i20 = i27 + (HEAP32[i25 >> 2] | 0) | 0;
      i2 = (HEAP32[i20 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i20 + (i2 * 20 | 0) >> 2] | 0) | 0;
     } else i2 = HEAP32[i27 + (HEAP32[i28 >> 2] | 0) + (HEAP32[i29 >> 2] << 2) >> 2] | 0;
     i20 = i4 + i31 + i2 | 0;
    }
    L113 : do if (!(1 << (i20 & 31) & HEAP32[(HEAP32[i50 >> 2] | 0) + (i20 >> 5 << 2) >> 2])) {
     i4 = HEAP32[i46 >> 2] | 0;
     i2 = HEAP32[i87 >> 2] | 0;
     if (!(i2 & 268435456)) {
      L116 : do if (i2 & 134217728 | 0) {
       i2 = HEAP32[i71 >> 2] | 0;
       i15 = i2 & 4095;
       if (i15 | 0) {
        i4 = HEAP32[i4 >> 2] | 0;
        i9 = HEAP32[i4 + 100 >> 2] | 0;
        i6 = i2 >>> 12;
        i9 = i9 + (HEAP32[i9 + 120 >> 2] | 0) | 0;
        i18 = HEAP32[i4 + 96 >> 2] | 0;
        i14 = HEAP32[i4 + 12 >> 2] | 0;
        i2 = (i14 | 0) == 0;
        i4 = i4 + 104 | 0;
        i5 = i18 + 16 | 0;
        if (!i18) {
         if (i2) break; else i2 = 0;
         while (1) {
          i4 = HEAP32[i9 + (i2 + i6 << 2) >> 2] | 0;
          if ((i4 | 0) >= 0) if (!(HEAP32[i14 + (i4 >> 5 << 2) >> 2] & 1 << (i4 & 31))) {
           i92 = 118;
           break L113;
          }
          i2 = i2 + 1 | 0;
          if ((i2 | 0) >= (i15 | 0)) break L116;
         }
        }
        if (!i2) {
         i4 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0;
         i2 = 0;
         do {
          i5 = HEAP32[i4 + (HEAP32[i9 + (i2 + i6 << 2) >> 2] << 2) >> 2] | 0;
          if ((i5 | 0) >= 0) if (!(HEAP32[i14 + (i5 >> 5 << 2) >> 2] & 1 << (i5 & 31))) {
           i92 = 118;
           break L113;
          }
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) < (i15 | 0));
        }
       }
      } while (0);
      __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i88, i32, i87);
      if ((i36 | 0) == (HEAP32[i83 >> 2] | 0)) if (!(HEAP8[i69 >> 0] | 0)) f19 = f10; else {
       f16 = Math_fround(HEAPF32[i88 >> 2]);
       f19 = Math_fround(HEAPF32[i40 >> 2]);
       f8 = Math_fround(HEAPF32[i43 >> 2]);
      } else f19 = f10;
      f94 = Math_fround(Math_fround(HEAPF32[i88 >> 2]) - f16);
      f17 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f19);
      f10 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f8);
      f10 = Math_fround(f22 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f94 * f94) + Math_fround(f17 * f17)) + Math_fround(f10 * f10))))));
      i15 = HEAP32[i46 >> 2] | 0;
      do if (!(HEAP32[i87 >> 2] & 134217728)) i2 = i37; else {
       i18 = HEAP32[i15 >> 2] | 0;
       i9 = HEAP32[i18 + 16 >> 2] | 0;
       if (!i9) i2 = i37; else {
        i2 = HEAP32[i71 >> 2] | 0;
        i14 = i2 & 4095;
        L141 : do if (!i14) f17 = Math_fround(0.0); else {
         i6 = HEAP32[i18 + 100 >> 2] | 0;
         i5 = i2 >>> 12;
         i6 = i6 + (HEAP32[i6 + 120 >> 2] | 0) | 0;
         i2 = HEAP32[i18 + 96 >> 2] | 0;
         if (!i2) {
          f17 = Math_fround(0.0);
          i2 = 0;
          while (1) {
           f17 = Math_fround(f17 + Math_fround(HEAPF32[i9 + (HEAP32[i6 + (i2 + i5 << 2) >> 2] << 2) >> 2]));
           i2 = i2 + 1 | 0;
           if ((i2 | 0) == (i14 | 0)) break L141;
          }
         }
         i4 = (HEAP32[i18 + 104 >> 2] | 0) + (HEAP32[i2 + 16 >> 2] | 0) | 0;
         f17 = Math_fround(0.0);
         i2 = 0;
         do {
          f17 = Math_fround(f17 + Math_fround(HEAPF32[i9 + (HEAP32[i4 + (HEAP32[i6 + (i2 + i5 << 2) >> 2] << 2) >> 2] << 2) >> 2]));
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) != (i14 | 0));
        } while (0);
        if (!(HEAP8[i18 + 20 >> 0] | 0)) {
         if (f17 < Math_fround(1.0)) {
          i92 = 110;
          break L8;
         }
         f94 = Math_fround(f23 * f17);
         f10 = Math_fround(f10 * f17);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f94, HEAP32[tempDoublePtr >> 2] | 0);
         break;
        } else {
         if (f17 < Math_fround(0.0)) {
          i92 = 113;
          break L8;
         }
         f10 = Math_fround(f10 + f17);
         i2 = i37;
         break;
        }
       }
      } while (0);
      if (!(f10 > Math_fround(HEAPF32[i70 >> 2]))) {
       HEAP32[i89 >> 2] = i20;
       HEAP32[i45 >> 2] = i2;
       HEAP32[i91 >> 2] = HEAP32[i89 >> 2];
       HEAP32[i91 + 4 >> 2] = HEAP32[i89 + 4 >> 2];
       __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i82, i91, f10) | 0;
       if ((HEAP32[i47 >> 2] | 0) > 1999) {
        i92 = 117;
        break L8;
       }
      }
      f10 = f19;
     } else i92 = 118;
    } else i92 = 118; while (0);
    if ((i92 | 0) == 118) i92 = 0;
    i21 = i21 + 1 | 0;
   } while ((i21 | 0) < (i30 | 0));
  }
  i2 = HEAP32[i47 >> 2] | 0;
  if (!i2) {
   i92 = 122;
   break;
  } else {
   i18 = i3;
   i14 = i1;
  }
 }
 if ((i92 | 0) == 65) {
  HEAP32[i56 >> 2] = i4 + 1;
  HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] = 2;
  STACKTOP = i93;
  return;
 } else if ((i92 | 0) == 69) {
  HEAP32[i65 >> 2] = i2 + 1;
  HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] = 2;
  STACKTOP = i93;
  return;
 } else if ((i92 | 0) == 73) {
  HEAP32[i63 >> 2] = i2 + 1;
  HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] = 2;
  STACKTOP = i93;
  return;
 } else if ((i92 | 0) == 77) {
  HEAP32[i61 >> 2] = i2 + 1;
  HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] = 2;
  STACKTOP = i93;
  return;
 } else if ((i92 | 0) == 110) HEAP32[i15 + 28 >> 2] = 3; else if ((i92 | 0) == 113) HEAP32[i15 + 28 >> 2] = 3; else if ((i92 | 0) == 117) HEAP32[(HEAP32[i46 >> 2] | 0) + 28 >> 2] = 2; else if ((i92 | 0) == 122) {
  STACKTOP = i93;
  return;
 }
 STACKTOP = i93;
 return;
}

function __ZL19RenderLightDeferredRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionP13RenderTextureS9_iiPK18DeviceStencilStateRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(i25, i14, i16, i23, i1, i29, i20, i28, i61, i34, i26, i53) {
 i25 = i25 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 i20 = i20 | 0;
 i28 = i28 | 0;
 i61 = i61 | 0;
 i34 = i34 | 0;
 i26 = i26 | 0;
 i53 = i53 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f21 = f0, f22 = f0, i24 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, f63 = f0, f64 = f0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i62 + 752 | 0;
 i30 = i62 + 748 | 0;
 i54 = i62 + 736 | 0;
 i12 = i62 + 720 | 0;
 i5 = i62 + 648 | 0;
 i6 = i62 + 576 | 0;
 i7 = i62 + 512 | 0;
 i31 = i62 + 160 | 0;
 i13 = i62 + 712 | 0;
 i27 = i62 + 640 | 0;
 i32 = i62 + 508 | 0;
 i55 = i62;
 i56 = i62 + 20 | 0;
 i57 = i62 + 156 | 0;
 i58 = i62 + 152 | 0;
 i59 = i62 + 8 | 0;
 i60 = i62 + 948 | 0;
 HEAP32[i30 >> 2] = i1;
 i48 = HEAP32[i14 >> 2] | 0;
 i42 = HEAP32[i48 >> 2] | 0;
 if ((HEAP16[gb + 1114624 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1114624 | 0, HEAP32[i42 + 16 >> 2] | 0);
  i47 = gb + 1114624 | 0;
 } else i47 = 0;
 i49 = HEAP32[gb + 1114624 >> 2] | 0;
 i51 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i51 >> 2] | 0) + 648 >> 2] | 0, i51 | 0, i49 | 0);
 i49 = i42 + 40 | 0;
 if ((HEAP32[i49 >> 2] | 0) == 3) i43 = 2; else if ((HEAP32[i42 + 88 >> 2] | 0) > -1) i43 = (HEAP32[i42 + 80 >> 2] | 0) == 1 ? 1 : 2; else i43 = 0;
 i50 = i42 + 216 | 0;
 i17 = i42 + 264 | 0;
 i18 = i42 + 268 | 0;
 i9 = HEAP32[i18 >> 2] | 0;
 i19 = i42 + 272 | 0;
 i33 = HEAP32[i19 >> 2] | 0;
 HEAP32[i54 >> 2] = HEAP32[i17 >> 2];
 i8 = i54 + 4 | 0;
 HEAP32[i8 >> 2] = i9;
 i9 = i54 + 8 | 0;
 HEAP32[i9 >> 2] = i33;
 i33 = i25 + 8 | 0;
 i51 = HEAP32[i33 >> 2] | 0;
 i24 = __ZNK6Camera16GetStereoEnabledEv(i51) | 0;
 i15 = i42 + 96 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i49 >> 2] | 0) != 1) {
  i46 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 118 >> 0] | 0) == 0;
  i1 = i46 ? 0 : i1;
 }
 i2 = __Z16GetBuildSettingsv() | 0;
 i4 = __Z18GetQualitySettingsv() | 0;
 i3 = HEAP32[i4 + 44 >> 2] | 0;
 i4 = HEAP32[i4 + 28 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i46 = HEAP16[i2 + 116 >> 1] | 0;
  __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf((i46 & 255) << 24 >> 24 != 0, (i46 & 65535) > 255, HEAP32[i4 + (i3 * 108 | 0) + 20 >> 2] | 0, Math_fround(HEAPF32[i4 + (i3 * 108 | 0) + 36 >> 2])) | 0;
 }
 i46 = __Z12GetGfxDevicev() | 0;
 __Z23SetupLightShaderKeywordRK15SharedLightDataR17ShaderPassContext(i42, i53);
 i1 = HEAP32[i42 + 248 >> 2] | 0;
 i2 = HEAP32[i42 + 252 >> 2] | 0;
 i4 = HEAP32[i42 + 256 >> 2] | 0;
 i45 = i42 + 156 | 0;
 HEAP32[i12 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 switch (HEAP32[i49 >> 2] | 0) {
 case 0:
  {
   i11 = i52;
   i3 = i42 + 280 | 0;
   i10 = i11 + 64 | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
    i11 = i11 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i11 | 0) < (i10 | 0));
   HEAPF32[i31 >> 2] = Math_fround(-.5);
   HEAPF32[i31 + 4 >> 2] = Math_fround(-.5);
   HEAPF32[i31 + 8 >> 2] = Math_fround(1.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i5, i31) | 0;
   HEAPF32[i31 >> 2] = Math_fround(.5);
   HEAPF32[i31 + 4 >> 2] = Math_fround(.5);
   HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i6, i31) | 0;
   __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i7, Math_fround(HEAPF32[i42 + 68 >> 2]), Math_fround(0.0), Math_fround(HEAPF32[((HEAP32[i49 >> 2] | 0) == 3 ? i42 + 204 | 0 : i42 + 48 | 0) >> 2])) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i6, i7, i31);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i31, i5, i6);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i6, i52, i46 + 2724 | 0);
   break;
  }
 case 2:
  {
   i11 = i46 + 2724 | 0;
   i3 = i42 + 280 | 0;
   i10 = i11 + 64 | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
    i11 = i11 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i11 | 0) < (i10 | 0));
   break;
  }
 case 1:
  {
   f22 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i42 + 64 >> 2]));
   HEAPF32[i52 >> 2] = f22;
   HEAPF32[i52 + 4 >> 2] = f22;
   HEAPF32[i52 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i5, i52) | 0;
   HEAPF32[i52 >> 2] = Math_fround(.5);
   HEAPF32[i52 + 4 >> 2] = Math_fround(.5);
   HEAPF32[i52 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i6, i52) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i6, i5, i7);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i7, i42 + 280 | 0, i46 + 2724 | 0);
   break;
  }
 default:
  {}
 }
 __Z22AssignCookieToMaterialRK15SharedLightDataP8Material(i42, HEAP32[gb + 1115120 >> 2] | 0) | 0;
 i44 = i48 + 20 | 0;
 i45 = HEAP16[i44 >> 1] | 0;
 if ((i45 & 255) << 24 >> 24 == 0 | (i45 & 65535) < 256) i45 = (HEAP32[i49 >> 2] | 0) == 1; else i45 = 1;
 i41 = i53 + 36 | 0;
 f22 = i45 ? Math_fround(1.0) : Math_fround(0.0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i41, gb + 1114740 | 0, f22, 0);
 i39 = HEAP32[i8 >> 2] | 0;
 i40 = HEAP32[i9 >> 2] | 0;
 i3 = i42 + 48 | 0;
 f22 = Math_fround(HEAPF32[((HEAP32[i49 >> 2] | 0) == 3 ? i42 + 204 | 0 : i3) >> 2]);
 f22 = Math_fround(Math_fround(1.0) / Math_fround(f22 * f22));
 HEAP32[i52 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i52 + 4 >> 2] = i39;
 HEAP32[i52 + 8 >> 2] = i40;
 HEAPF32[i52 + 12 >> 2] = f22;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i41, gb + 1114720 | 0, i52, 0);
 HEAP32[i52 >> 2] = i1;
 HEAP32[i52 + 4 >> 2] = i2;
 HEAP32[i52 + 8 >> 2] = i4;
 HEAPF32[i52 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i41, gb + 1114724 | 0, i52, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i41, gb + 1114728 | 0, i12, 0);
 i41 = HEAP32[gb + 1115120 >> 2] | 0;
 HEAP32[i13 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i13, gb + 387690 | 0);
 i2 = __ZN10builtintex21GetAttenuationTextureEv() | 0;
 HEAP32[i52 >> 2] = HEAP32[i13 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i41, i52, i2);
 i2 = i14 + 4 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i1 = i14 + 8 | 0;
  if ((i16 | 0) != 0 & (HEAP32[i1 >> 2] | 0) != 0) {
   i5 = i1;
   i6 = 21;
  } else i6 = 47;
 } else if (!i16) i6 = 47; else {
  i5 = i14 + 8 | 0;
  i6 = 21;
 }
 if ((i6 | 0) == 21) {
  i4 = HEAP32[i15 >> 2] | 0;
  i4 = (i16 | 0) == 1 & (i4 | 0) != 0 ? 1 : i4;
  __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i53, HEAP32[i49 >> 2] | 0, i4, i23, 0, 1);
  mftCall_vii(HEAP32[(HEAP32[i46 >> 2] | 0) + 112 >> 2] | 0, i46 | 0, i25 + 1732 | 0);
  mftCall_viii(HEAP32[(HEAP32[i46 >> 2] | 0) + 72 >> 2] | 0, i46 | 0, i20 | 0, 0);
  HEAP32[i31 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   if (i24) {
    __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE(HEAP32[i33 >> 2] | 0, i52);
    __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f(HEAP32[i33 >> 2] | 0, i25 + 1664 | 0);
    __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(HEAP32[i33 >> 2] | 0, i25 + 1600 | 0);
   }
   mftCall_vi(HEAP32[(HEAP32[i46 >> 2] | 0) + 340 >> 2] | 0, i46 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i31 >> 2] = __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext(i1, i53) | 0;
   HEAP32[i31 + 344 >> 2] = HEAP32[i1 + 35884 >> 2];
   if (i24) __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE(HEAP32[i33 >> 2] | 0, i52);
   _memcpy(i31 + 4 | 0, i1 + 34040 | 0, 256) | 0;
   i11 = i31 + 260 | 0;
   i3 = i1 + 35824 | 0;
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i11 = i31 + 280 | 0;
   i3 = i1 + 35760 | 0;
   i10 = i11 + 64 | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
    i11 = i11 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i11 | 0) < (i10 | 0));
  } else {
   _memcpy(i31 | 0, i1 | 0, 348) | 0;
   if ((HEAP32[i49 >> 2] | 0) == 2) {
    f22 = Math_fround(HEAPF32[i3 >> 2]);
    i40 = HEAP32[i18 >> 2] | 0;
    i41 = HEAP32[i19 >> 2] | 0;
    f22 = Math_fround(Math_fround(1.0) / f22);
    HEAP32[i46 + 676 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i46 + 680 >> 2] = i40;
    HEAP32[i46 + 684 >> 2] = i41;
    HEAPF32[i46 + 688 >> 2] = f22;
   }
  }
  i1 = HEAP32[i31 >> 2] | 0;
  do if (!i1) {
   __Z20SetNoShadowsKeywordsR17ShaderPassContext(i53);
   i1 = 0;
   i2 = 0;
  } else {
   HEAPF32[i46 + 788 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i42 + 108 >> 2]));
   HEAPF32[i46 + 792 >> 2] = Math_fround(0.0);
   HEAPF32[i46 + 796 >> 2] = Math_fround(0.0);
   HEAPF32[i46 + 800 >> 2] = Math_fround(0.0);
   switch (HEAP32[i49 >> 2] | 0) {
   case 1:
    {
     i2 = i31 + 4 | 0;
     i11 = i46 + 2148 | 0;
     i3 = i2;
     i10 = i11 + 64 | 0;
     do {
      HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
      i11 = i11 + 4 | 0;
      i3 = i3 + 4 | 0;
     } while ((i11 | 0) < (i10 | 0));
     i3 = HEAP32[i31 + 344 >> 2] | 0;
     f21 = Math_fround(HEAP32[i1 + 80 >> 2] | 0);
     f22 = Math_fround(HEAP32[i1 + 84 >> 2] | 0);
     HEAPF32[i52 >> 2] = f21;
     HEAPF32[i52 + 4 >> 2] = f22;
     __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext(i2, i3, i31 + 260 | 0, i31 + 280 | 0, i52, i53);
     i3 = HEAP32[i5 >> 2] | 0;
     if (i24 | (i3 | 0) == 0) {
      i1 = __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext(HEAP32[i33 >> 2] | 0, i42, i1, i4, i23, i53) | 0;
      if (!i24) HEAP32[i31 >> 2] = i1;
      i2 = i24 & 1;
      i6 = 37;
     } else i2 = 0;
     break;
    }
   case 0:
    {
     i11 = i46 + 2148 | 0;
     i3 = i31 + 4 | 0;
     i10 = i11 + 64 | 0;
     do {
      HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
      i11 = i11 + 4 | 0;
      i3 = i3 + 4 | 0;
     } while ((i11 | 0) < (i10 | 0));
     i2 = 0;
     i6 = 37;
     break;
    }
   default:
    {
     i2 = 0;
     i6 = 37;
    }
   }
   if ((i6 | 0) == 37) i3 = HEAP32[i5 >> 2] | 0;
   if (!i3) {
    i41 = __Z19GetGraphicsSettingsv() | 0;
    if (!(HEAP8[i41 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0)) i3 = (HEAP32[i49 >> 2] | 0) == 1; else i3 = 0;
    if ((i3 | i26 ^ 1) & (i24 ^ 1)) i2 = 1; else __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai(HEAP32[i25 + 1728 >> 2] | 0, i31, HEAP32[(HEAP32[i48 >> 2] | 0) + 16 >> 2] | 0);
   }
   if (!i1) {
    __Z20SetNoShadowsKeywordsR17ShaderPassContext(i53);
    i1 = 0;
    break;
   } else {
    f21 = Math_fround(Math_fround(.5) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0));
    f22 = Math_fround(Math_fround(.5) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0));
    f63 = Math_fround(-f21);
    f64 = Math_fround(-f22);
    HEAPF32[i46 + 724 >> 2] = f63;
    HEAPF32[i46 + 728 >> 2] = f64;
    HEAPF32[i46 + 732 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 736 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 740 >> 2] = f21;
    HEAPF32[i46 + 744 >> 2] = f64;
    HEAPF32[i46 + 748 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 752 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 756 >> 2] = f63;
    HEAPF32[i46 + 760 >> 2] = f22;
    HEAPF32[i46 + 764 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 768 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 772 >> 2] = f21;
    HEAPF32[i46 + 776 >> 2] = f22;
    HEAPF32[i46 + 780 >> 2] = Math_fround(0.0);
    HEAPF32[i46 + 784 >> 2] = Math_fround(0.0);
    i41 = HEAP32[gb + 1115120 >> 2] | 0;
    HEAP32[i27 >> 2] = HEAP32[gb + 1114748 >> 2];
    HEAP32[i52 >> 2] = HEAP32[i27 >> 2];
    __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i41, i52, i1);
    break;
   }
  } while (0);
  mftCall_vii(HEAP32[(HEAP32[i46 >> 2] | 0) + 116 >> 2] | 0, i46 | 0, i28 + 132 | 0);
  mftCall_vii(HEAP32[(HEAP32[i46 >> 2] | 0) + 112 >> 2] | 0, i46 | 0, i28 + 68 | 0);
  __Z27SetClippingPlaneShaderPropsR9GfxDevice(__Z12GetGfxDevicev() | 0);
  mftCall_vii(HEAP32[(HEAP32[i46 >> 2] | 0) + 148 >> 2] | 0, i46 | 0, 0);
  i41 = i1;
  i40 = (i2 & 1) == 0;
 } else if ((i6 | 0) == 47) {
  __Z20SetNoShadowsKeywordsR17ShaderPassContext(i53);
  i41 = 0;
  i40 = 1;
 }
 HEAP32[i31 >> 2] = HEAP32[(HEAP32[i30 >> 2] | 0) + 128 >> 2];
 i1 = HEAP32[i29 + 136 >> 2] | 0;
 if (!(HEAP8[i53 + 149 >> 0] | 0)) {
  i39 = mftCall_iii(HEAP32[(HEAP32[i46 >> 2] | 0) + 348 >> 2] | 0, i46 | 0, 0) | 0;
  if ((i39 | 0) == (HEAP32[i31 >> 2] | 0)) {
   if ((mftCall_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 352 >> 2] | 0, i46 | 0) | 0) != (i1 | 0)) i6 = 51;
  } else i6 = 51;
 } else i6 = 51;
 if ((i6 | 0) == 51) {
  HEAP32[i32 >> 2] = i1;
  HEAP32[i52 >> 2] = HEAP32[i32 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i31, i52, i30, 0, -1, 0, 0) | 0;
 }
 i38 = i55;
 HEAP32[i38 >> 2] = 64;
 HEAP32[i38 + 4 >> 2] = 0;
 i38 = (i43 | 0) == 0;
 if (i38) {
  HEAP32[i55 >> 2] = 0;
  i37 = 1;
 } else if ((i43 | 0) == 1) {
  HEAP32[i55 >> 2] = 64;
  i37 = 1;
 } else i37 = 2;
 i39 = HEAP16[i44 >> 1] | 0;
 if ((i39 & 255) << 24 >> 24 == 0 & (i38 & (i39 & 65535) < 256)) i39 = (HEAP32[i49 >> 2] | 2 | 0) == 2; else i39 = 0;
 i1 = HEAP32[i48 + 16 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = 0; else {
  i3 = 0;
  i2 = ~i1;
  i1 = 0;
  while (1) {
   if (i2 & 1) {
    i36 = HEAP32[i34 + 4 + (i3 << 2) >> 2] | 0;
    i1 = ((i36 | 0) == -1 ? 0 : 1 << i36) | i1;
   }
   i2 = i2 >>> 1;
   if (!i2) break; else i3 = i3 + 1 | 0;
  }
 }
 __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i56, __Z12GetGfxDevicev() | 0);
 if (i45) __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i51)), i46);
 if (i39) {
  __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns(i46, i51, i48, i54, i50, i45, __ZL31SetRenderStateForStencilMarkingR9GfxDeviceR17ShaderPassContextjj(i46, i53, i1, 192) | 0);
  HEAP8[i52 + 1 >> 0] = 1;
  HEAP8[i52 + 2 >> 0] = 0;
  HEAP8[i52 + 3 >> 0] = 1;
  HEAP32[i52 + 4 >> 2] = 0;
  HEAP8[i52 + 8 >> 0] = 15;
  HEAP8[i52 + 9 >> 0] = 1;
  HEAP8[i52 + 10 >> 0] = 0;
  HEAP8[i52 + 11 >> 0] = 1;
  HEAP32[i52 + 12 >> 2] = 0;
  HEAP8[i52 + 16 >> 0] = 15;
  HEAP8[i52 + 17 >> 0] = 1;
  HEAP8[i52 + 18 >> 0] = 0;
  HEAP8[i52 + 19 >> 0] = 1;
  HEAP32[i52 + 20 >> 2] = 0;
  HEAP8[i52 + 24 >> 0] = 15;
  HEAP8[i52 + 25 >> 0] = 1;
  HEAP8[i52 + 26 >> 0] = 0;
  HEAP8[i52 + 27 >> 0] = 1;
  HEAP32[i52 + 28 >> 2] = 0;
  HEAP8[i52 + 32 >> 0] = 15;
  HEAP8[i52 + 33 >> 0] = 1;
  HEAP8[i52 + 34 >> 0] = 0;
  HEAP8[i52 + 35 >> 0] = 1;
  HEAP32[i52 + 36 >> 2] = 0;
  HEAP8[i52 + 40 >> 0] = 15;
  HEAP8[i52 + 41 >> 0] = 1;
  HEAP8[i52 + 42 >> 0] = 0;
  HEAP8[i52 + 43 >> 0] = 1;
  HEAP32[i52 + 44 >> 2] = 0;
  HEAP8[i52 + 48 >> 0] = 15;
  HEAP8[i52 + 49 >> 0] = 1;
  HEAP8[i52 + 50 >> 0] = 0;
  HEAP8[i52 + 51 >> 0] = 1;
  HEAP32[i52 + 52 >> 2] = 0;
  HEAP8[i52 + 56 >> 0] = 15;
  HEAP8[i52 + 57 >> 0] = 1;
  HEAP8[i52 + 58 >> 0] = 0;
  HEAP8[i52 + 59 >> 0] = 1;
  HEAP32[i52 + 60 >> 2] = 0;
  HEAP32[i52 + 64 >> 2] = 0;
  HEAP8[i52 >> 0] = 15;
  i36 = HEAP32[i46 >> 2] | 0;
  i35 = HEAP32[i36 + 60 >> 2] | 0;
  mftCall_vii(i35 | 0, i46 | 0, mftCall_iii(HEAP32[i36 + 44 >> 2] | 0, i46 | 0, i52 | 0) | 0);
 }
 i23 = (HEAP8[(HEAP32[i33 >> 2] | 0) + 1092 >> 0] | 0) != 0;
 i34 = i61 + 4 | 0;
 i35 = i61 + 8 | 0;
 i36 = i61 + 12 | 0;
 i19 = i42 + 108 | 0;
 i12 = i46 + 708 | 0;
 i13 = i46 + 712 | 0;
 i15 = i46 + 716 | 0;
 i17 = i46 + 720 | 0;
 i20 = i46 + 788 | 0;
 i14 = i46 + 792 | 0;
 i16 = i46 + 796 | 0;
 i18 = i46 + 800 | 0;
 f21 = i23 ? Math_fround(1.0) : Math_fround(2.0);
 f22 = Math_fround(i23 & 1);
 i23 = i52 + 1 | 0;
 i24 = i52 + 2 | 0;
 i25 = i52 + 3 | 0;
 i26 = i52 + 4 | 0;
 i27 = i52 + 5 | 0;
 i28 = i52 + 6 | 0;
 i29 = i52 + 7 | 0;
 i30 = i52 + 8 | 0;
 i31 = i52 + 9 | 0;
 i32 = i52 + 10 | 0;
 i33 = i52 + 11 | 0;
 i6 = (i43 | 0) == 1;
 i5 = i6 ? -64 : -128;
 i7 = (i5 & 255 | 32) & 255;
 i8 = i59 + 4 | 0;
 i9 = i59 + 8 | 0;
 i10 = i60 + 1 | 0;
 i4 = 0;
 do {
  i43 = HEAP32[i34 >> 2] | 0;
  i2 = HEAP32[i35 >> 2] | 0;
  i11 = HEAP32[i36 >> 2] | 0;
  f64 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i19 >> 2]));
  i3 = i38 | (i4 | 0) == 0;
  HEAP32[i12 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i13 >> 2] = i43;
  HEAP32[i15 >> 2] = i3 ? 0 : i2;
  HEAP32[i17 >> 2] = i3 ? 0 : i11;
  HEAPF32[i20 >> 2] = f64;
  HEAP32[i14 >> 2] = i43;
  HEAP32[i16 >> 2] = i3 ? i2 : 0;
  HEAP32[i18 >> 2] = i3 ? i11 : 0;
  i11 = HEAP32[gb + 1115120 >> 2] | 0;
  HEAP32[i57 >> 2] = HEAP32[gb + 1114788 >> 2];
  HEAP32[i52 >> 2] = HEAP32[i57 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i11, i52, f21);
  i11 = HEAP32[gb + 1115120 >> 2] | 0;
  HEAP32[i58 >> 2] = HEAP32[gb + 1114792 >> 2];
  HEAP32[i52 >> 2] = HEAP32[i58 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i11, i52, f22);
  i11 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115120 >> 2] | 0, 0, i53, 0, 1) | 0;
  HEAP8[i24 >> 0] = -1;
  HEAP8[i25 >> 0] = 0;
  HEAP8[i27 >> 0] = 0;
  HEAP8[i28 >> 0] = 0;
  HEAP8[i29 >> 0] = 0;
  HEAP8[i31 >> 0] = 0;
  HEAP8[i32 >> 0] = 0;
  HEAP8[i33 >> 0] = 0;
  HEAP8[i52 >> 0] = 1;
  HEAP8[i30 >> 0] = 3;
  HEAP8[i26 >> 0] = 3;
  i3 = (i6 & (i4 | 0) != 0 ? i7 : i5) & 255 | i1;
  HEAP8[i23 >> 0] = i3;
  i2 = (HEAP32[i55 + (i4 << 2) >> 2] | 0) + 128 | 0;
  if (i39) {
   HEAP8[i24 >> 0] = 16;
   HEAP8[i33 >> 0] = 1;
   HEAP8[i29 >> 0] = 1;
   HEAP8[i31 >> 0] = 1;
   HEAP8[i27 >> 0] = 1;
   HEAP8[i32 >> 0] = 1;
   HEAP8[i28 >> 0] = 1;
   HEAP8[i23 >> 0] = i3 | 16;
   i2 = i2 | 16;
  }
  i43 = mftCall_iii(HEAP32[(HEAP32[i46 >> 2] | 0) + 52 >> 2] | 0, i46 | 0, i52 | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i46 >> 2] | 0) + 72 >> 2] | 0, i46 | 0, i43 | 0, i2 | 0);
  HEAP32[i59 >> 2] = 2;
  HEAP32[i8 >> 2] = 0;
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAP8[i10 >> 0] = 2;
  HEAP8[i60 >> 0] = 0;
  i43 = HEAP16[i44 >> 1] | 0;
  L99 : do if ((i43 & 255) << 24 >> 24 != 0 & (i43 & 65535) < 256) {
   switch (HEAP32[i49 >> 2] | 0) {
   case 2:
   case 0:
    break;
   default:
    {
     i2 = 4;
     break L99;
    }
   }
   HEAP32[i59 >> 2] = 1;
   i2 = 5;
  } else i2 = 4; while (0);
  HEAP8[i10 >> 0] = i2;
  i43 = HEAP32[i46 >> 2] | 0;
  i42 = HEAP32[i43 + 64 >> 2] | 0;
  mftCall_vii(i42 | 0, i46 | 0, mftCall_iii(HEAP32[i43 + 56 >> 2] | 0, i46 | 0, i59 | 0) | 0);
  i43 = HEAP32[i46 >> 2] | 0;
  i42 = HEAP32[i43 + 68 >> 2] | 0;
  mftCall_vii(i42 | 0, i46 | 0, mftCall_iii(HEAP32[i43 + 48 >> 2] | 0, i46 | 0, i60 | 0) | 0);
  __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns(i46, i51, i48, i54, i50, i45, i11);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i37 | 0));
 if (!(i40 | (i41 | 0) == 0)) __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i41);
 __ZN27DeviceViewProjMatricesStateD2Ev(i56);
 i61 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i61 >> 2] | 0) + 652 >> 2] | 0, i61 | 0);
 if (!i47) {
  STACKTOP = i62;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i47);
 STACKTOP = i62;
 return;
}

function __ZN5physx3Ext7D6Joint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1216 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i2 + 1184 | 0;
 i39 = i2 + 1152 | 0;
 i38 = i2 + 1120 | 0;
 i37 = i2 + 1088 | 0;
 i36 = i2 + 1056 | 0;
 i35 = i2 + 1024 | 0;
 i34 = i2 + 992 | 0;
 i33 = i2 + 960 | 0;
 i32 = i2 + 928 | 0;
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i40 >> 2] = HEAP32[gb + 117360 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[gb + 117360 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[gb + 117360 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[gb + 117360 + 12 >> 2];
 HEAP32[i40 + 16 >> 2] = HEAP32[gb + 117360 + 16 >> 2];
 HEAP32[i40 + 20 >> 2] = HEAP32[gb + 117360 + 20 >> 2];
 HEAP32[i40 + 24 >> 2] = HEAP32[gb + 117360 + 24 >> 2];
 HEAP32[i40 + 28 >> 2] = HEAP32[gb + 117360 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i40 | 0, 32) | 0;
 HEAP32[i39 >> 2] = HEAP32[gb + 117392 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[gb + 117392 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[gb + 117392 + 8 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[gb + 117392 + 12 >> 2];
 HEAP32[i39 + 16 >> 2] = HEAP32[gb + 117392 + 16 >> 2];
 HEAP32[i39 + 20 >> 2] = HEAP32[gb + 117392 + 20 >> 2];
 HEAP32[i39 + 24 >> 2] = HEAP32[gb + 117392 + 24 >> 2];
 HEAP32[i39 + 28 >> 2] = HEAP32[gb + 117392 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i39 | 0, 32) | 0;
 HEAP32[i38 >> 2] = gb + 744333;
 HEAP32[i38 + 4 >> 2] = gb + 743927;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 384;
 HEAP32[i38 + 16 >> 2] = 0;
 HEAP32[i38 + 20 >> 2] = 0;
 HEAP32[i38 + 24 >> 2] = 1;
 HEAP32[i38 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i38 | 0, 32) | 0;
 HEAP32[i37 >> 2] = HEAP32[gb + 117424 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[gb + 117424 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[gb + 117424 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[gb + 117424 + 12 >> 2];
 HEAP32[i37 + 16 >> 2] = HEAP32[gb + 117424 + 16 >> 2];
 HEAP32[i37 + 20 >> 2] = HEAP32[gb + 117424 + 20 >> 2];
 HEAP32[i37 + 24 >> 2] = HEAP32[gb + 117424 + 24 >> 2];
 HEAP32[i37 + 28 >> 2] = HEAP32[gb + 117424 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i37 | 0, 32) | 0;
 HEAP32[i36 >> 2] = HEAP32[gb + 117456 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[gb + 117456 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[gb + 117456 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[gb + 117456 + 12 >> 2];
 HEAP32[i36 + 16 >> 2] = HEAP32[gb + 117456 + 16 >> 2];
 HEAP32[i36 + 20 >> 2] = HEAP32[gb + 117456 + 20 >> 2];
 HEAP32[i36 + 24 >> 2] = HEAP32[gb + 117456 + 24 >> 2];
 HEAP32[i36 + 28 >> 2] = HEAP32[gb + 117456 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i36 | 0, 32) | 0;
 HEAP32[i35 >> 2] = HEAP32[gb + 117488 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[gb + 117488 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[gb + 117488 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[gb + 117488 + 12 >> 2];
 HEAP32[i35 + 16 >> 2] = HEAP32[gb + 117488 + 16 >> 2];
 HEAP32[i35 + 20 >> 2] = HEAP32[gb + 117488 + 20 >> 2];
 HEAP32[i35 + 24 >> 2] = HEAP32[gb + 117488 + 24 >> 2];
 HEAP32[i35 + 28 >> 2] = HEAP32[gb + 117488 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i35 | 0, 32) | 0;
 HEAP32[i34 >> 2] = HEAP32[gb + 117520 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[gb + 117520 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[gb + 117520 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[gb + 117520 + 12 >> 2];
 HEAP32[i34 + 16 >> 2] = HEAP32[gb + 117520 + 16 >> 2];
 HEAP32[i34 + 20 >> 2] = HEAP32[gb + 117520 + 20 >> 2];
 HEAP32[i34 + 24 >> 2] = HEAP32[gb + 117520 + 24 >> 2];
 HEAP32[i34 + 28 >> 2] = HEAP32[gb + 117520 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i34 | 0, 32) | 0;
 HEAP32[i33 >> 2] = HEAP32[gb + 117552 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[gb + 117552 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[gb + 117552 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[gb + 117552 + 12 >> 2];
 HEAP32[i33 + 16 >> 2] = HEAP32[gb + 117552 + 16 >> 2];
 HEAP32[i33 + 20 >> 2] = HEAP32[gb + 117552 + 20 >> 2];
 HEAP32[i33 + 24 >> 2] = HEAP32[gb + 117552 + 24 >> 2];
 HEAP32[i33 + 28 >> 2] = HEAP32[gb + 117552 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i33 | 0, 32) | 0;
 HEAP32[i32 >> 2] = HEAP32[gb + 117584 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[gb + 117584 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[gb + 117584 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[gb + 117584 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[gb + 117584 + 16 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[gb + 117584 + 20 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[gb + 117584 + 24 >> 2];
 HEAP32[i32 + 28 >> 2] = HEAP32[gb + 117584 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i32 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 117616 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 117616 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 117616 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 117616 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 117616 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 117616 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 117616 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 117616 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 117648 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 117648 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 117648 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 117648 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 117648 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 117648 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 117648 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 117648 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 117680 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 117680 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 117680 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 117680 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 117680 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 117680 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 117680 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 117680 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 117712 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 117712 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 117712 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 117712 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 117712 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 117712 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 117712 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 117712 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 117744 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 117744 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 117744 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 117744 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 117744 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 117744 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 117744 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 117744 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 117776 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 117776 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 117776 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 117776 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 117776 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 117776 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 117776 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 117776 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 117808 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 117808 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 117808 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 117808 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 117808 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 117808 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 117808 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 117808 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 117840 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 117840 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 117840 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 117840 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 117840 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 117840 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 117840 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 117840 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 117872 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 117872 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 117872 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 117872 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 117872 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 117872 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 117872 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 117872 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 117904 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 117904 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 117904 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 117904 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 117904 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 117904 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 117904 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 117904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 117936 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 117936 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 117936 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 117936 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 117936 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 117936 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 117936 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 117936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 117968 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 117968 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 117968 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 117968 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 117968 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 117968 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 117968 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 117968 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 118e3 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 118e3 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 118e3 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 118e3 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 118e3 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 118e3 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 118e3 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 118e3 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 118032 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 118032 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 118032 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 118032 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 118032 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 118032 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 118032 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 118032 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 118064 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 118064 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 118064 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 118064 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 118064 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 118064 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 118064 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 118064 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 118096 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 118096 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 118096 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 118096 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 118096 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 118096 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 118096 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 118096 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 118128 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 118128 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 118128 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 118128 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 118128 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 118128 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 118128 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 118128 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 118160 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 118160 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 118160 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 118160 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 118160 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 118160 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 118160 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 118160 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = gb + 744345;
 HEAP32[i13 + 4 >> 2] = gb + 743901;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 88;
 HEAP32[i13 + 16 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 1;
 HEAP32[i13 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = gb + 744345;
 HEAP32[i12 + 4 >> 2] = gb + 829211;
 HEAP32[i12 + 8 >> 2] = 12;
 HEAP32[i12 + 12 >> 2] = 88;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 1;
 HEAP32[i12 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 118192 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 118192 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 118192 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 118192 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 118192 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 118192 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 118192 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 118192 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 118224 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 118224 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 118224 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 118224 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 118224 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 118224 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 118224 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 118224 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 118256 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 118256 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 118256 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 118256 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 118256 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 118256 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 118256 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 118256 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 118288 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 118288 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 118288 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 118288 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 118288 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 118288 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 118288 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 118288 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z19ExtractDataFromMeshR4MeshR13dynamic_arrayI8Vector3fLj4EERS1_ItLj2EES6_(i21, i11, i13, i14) {
 i21 = i21 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, d29 = 0.0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 48 | 0;
 i19 = i26 + 40 | 0;
 i18 = i26 + 32 | 0;
 i8 = i26;
 i22 = i26 + 128 | 0;
 i23 = i26 + 112 | 0;
 i24 = i26 + 96 | 0;
 i25 = i26 + 80 | 0;
 i2 = i26 + 64 | 0;
 i7 = i26 + 180 | 0;
 i15 = i26 + 168 | 0;
 i16 = i26 + 156 | 0;
 i17 = i26 + 144 | 0;
 i12 = i21 + 32 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i3) {
  i25 = 0;
  STACKTOP = i26;
  return i25 | 0;
 }
 if (!(HEAP32[i1 + 92 >> 2] | 0)) {
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i23 + 12 >> 2] = i1;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i23 >> 2] = i1;
  HEAP32[i23 + 8 >> 2] = -2147483552;
  HEAP32[i23 + 4 >> 2] = 89;
  i3 = i1;
  i4 = gb + 779860 | 0;
  i5 = i3 + 89 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP8[i1 + 89 >> 0] = 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = i25 + 11 | 0;
  HEAP8[i1 >> 0] = 1;
  HEAP8[i25 >> 0] = 32;
  HEAP8[i25 + 1 >> 0] = 0;
  __ZL21GetMeshLocationDetailR4Mesh(i2, i21);
  __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i24, i23, i25, i2);
  i20 = i24 + 11 | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 779950 | 0, 56, 1, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
  if ((HEAP8[i20 >> 0] | 0) < 0) {
   i21 = HEAP32[i24 >> 2] | 0;
   i24 = HEAP32[i24 + 12 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i24;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i22);
  }
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i24 = HEAP32[i2 >> 2] | 0;
   i21 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
  }
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i24 = HEAP32[i25 >> 2] | 0;
   i25 = HEAP32[i25 + 12 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i25;
   __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
  }
  if ((HEAP8[i23 + 11 >> 0] | 0) < 0) {
   i25 = HEAP32[i23 >> 2] | 0;
   i24 = HEAP32[i23 + 12 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i24;
   __Z19free_alloc_internalPvRK10MemLabelId(i25, i22);
  }
  i25 = 0;
  STACKTOP = i26;
  return i25 | 0;
 }
 i4 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = i11 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i3 * 12 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i11 >> 2] = i10;
  i1 = i10;
  break;
 } else i1 = HEAP32[i11 >> 2] | 0; while (0);
 __ZNK4Mesh18ExtractVertexArrayEP8Vector3f(i21, i1);
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + (i10 * 12 | 0) | 0;
 i6 = i1;
 L27 : do if (i10 | 0) {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   if (!((i2 & 2139095040 | 0) != 2139095040 & (i3 & 2139095040 | 0) != 2139095040 & (i4 & 2139095040 | 0) != 2139095040)) break;
   i1 = i1 + 12 | 0;
   if ((i1 | 0) == (i5 | 0)) break L27;
  }
  f27 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  d29 = +(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAP32[i8 >> 2] = (i1 - i6 | 0) / 12 | 0;
  HEAPF64[i8 + 8 >> 3] = d29;
  HEAPF64[i8 + 16 >> 3] = +f28;
  HEAPF64[i8 + 24 >> 3] = +f27;
  __Z6FormatPKcz(i7, gb + 780031 | 0, i8);
  i2 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i23 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
   i1 = HEAP32[i23 + 12 >> 2] | 0;
   i9 = 22;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i23 + 11 >> 0] = i3;
   if (!i3) i1 = i23; else {
    i1 = i23;
    i9 = 24;
   }
  } else i9 = 22;
  if ((i9 | 0) == 22) {
   i20 = i3 + 16 & -16;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 8 >> 2] = i20 | -2147483648;
   HEAP32[i23 + 4 >> 2] = i3;
   i9 = 24;
  }
  if ((i9 | 0) == 24) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = i24 + 11 | 0;
  HEAP8[i1 >> 0] = 1;
  HEAP8[i24 >> 0] = 32;
  HEAP8[i24 + 1 >> 0] = 0;
  __ZL21GetMeshLocationDetailR4Mesh(i25, i21);
  __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i22, i23, i24, i25);
  i20 = i22 + 11 | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 779950 | 0, 69, 1, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
  if ((HEAP8[i20 >> 0] | 0) < 0) {
   i21 = HEAP32[i22 >> 2] | 0;
   i22 = HEAP32[i22 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i22;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i8);
  }
  if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
   i22 = HEAP32[i25 >> 2] | 0;
   i25 = HEAP32[i25 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i25;
   __Z19free_alloc_internalPvRK10MemLabelId(i22, i8);
  }
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i25 = HEAP32[i24 >> 2] | 0;
   i24 = HEAP32[i24 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i24;
   __Z19free_alloc_internalPvRK10MemLabelId(i25, i8);
  }
  if ((HEAP8[i23 + 11 >> 0] | 0) < 0) {
   i25 = HEAP32[i23 >> 2] | 0;
   i24 = HEAP32[i23 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i24;
   __Z19free_alloc_internalPvRK10MemLabelId(i25, i8);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i25 = 0;
  STACKTOP = i26;
  return i25 | 0;
 } while (0);
 i7 = i13 + 16 | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i13 + 4 | 0);
  HEAP32[i13 >> 2] = 0;
 }
 HEAP32[i13 >> 2] = 0;
 i8 = i13 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 L58 : do if (__ZNK4Mesh15GetSubMeshCountEv(i21) | 0) {
  i9 = i13 + 4 | 0;
  i10 = 0;
  L60 : while (1) {
   if (i10 >>> 0 >= (__ZNK4Mesh15GetSubMeshCountEv(i21) | 0) >>> 0) {
    i9 = 40;
    break;
   }
   i6 = __ZN4Mesh18GetSubMeshBuffer16Ei(i21, i10) | 0;
   if (!i6) {
    i9 = 56;
    break;
   }
   i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + 128 >> 2] | 0;
   i4 = i1 + (i10 * 52 | 0) + 40 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   switch (i2 | 0) {
   case 1:
    {
     i5 = HEAP32[i8 >> 2] | 0;
     i3 = i1 + (i10 * 52 | 0) + 36 | 0;
     i4 = __Z21CountTrianglesInStripItEiPKT_i(i6, HEAP32[i3 >> 2] | 0) | 0;
     i1 = (i4 * 3 | 0) + i5 | 0;
     HEAP32[i8 >> 2] = i1;
     i2 = HEAP32[i7 >> 2] | 0;
     do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i7 >> 2] = i1;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 1, 2, i9, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i13 >> 2] = i1;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i8 >> 2] << 1 | 0) | 0;
      HEAP32[i7 >> 2] = i1;
      HEAP32[i13 >> 2] = i2;
      i1 = i2;
      break;
     } else i1 = HEAP32[i13 >> 2] | 0; while (0);
     __Z10DestripifyIttEvPKT_iPT0_i(i6, HEAP32[i3 >> 2] | 0, i1 + (i5 << 1) | 0, i4);
     break;
    }
   case 0:
    {
     __ZN13dynamic_arrayItLj2EE6insertEPtPKtS3_(i13, (HEAP32[i13 >> 2] | 0) + (HEAP32[i8 >> 2] << 1) | 0, i6, i6 + (HEAP32[i1 + (i10 * 52 | 0) + 36 >> 2] << 1) | 0) | 0;
     break;
    }
   default:
    {
     i9 = 79;
     break L60;
    }
   }
   i1 = i10 + 1 | 0;
   if (i1 >>> 0 < (__ZNK4Mesh15GetSubMeshCountEv(i21) | 0) >>> 0) i10 = i1; else break L58;
  }
  if ((i9 | 0) == 40) {
   HEAP32[i18 >> 2] = i10;
   __Z6FormatPKcz(i15, gb + 780133 | 0, i18);
   i2 = (HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i22 + 12 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
    i1 = HEAP32[i22 + 12 >> 2] | 0;
    i9 = 43;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 + 11 >> 0] = i3;
    if (!i3) i1 = i22; else {
     i1 = i22;
     i9 = 45;
    }
   } else i9 = 43;
   if ((i9 | 0) == 43) {
    i20 = i3 + 16 & -16;
    HEAP32[i18 >> 2] = 1;
    HEAP32[i18 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i22 >> 2] = i1;
    HEAP32[i22 + 8 >> 2] = i20 | -2147483648;
    HEAP32[i22 + 4 >> 2] = i3;
    i9 = 45;
   }
   if ((i9 | 0) == 45) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = i24 + 11 | 0;
   HEAP8[i1 >> 0] = 1;
   HEAP8[i24 >> 0] = 32;
   HEAP8[i24 + 1 >> 0] = 0;
   __ZL21GetMeshLocationDetailR4Mesh(i25, i21);
   __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i23, i22, i24, i25);
   i20 = i23 + 11 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 779950 | 0, 80, 1, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i21 = HEAP32[i23 >> 2] | 0;
    i23 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 1;
    HEAP32[i18 + 4 >> 2] = i23;
    __Z19free_alloc_internalPvRK10MemLabelId(i21, i18);
   }
   if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
    i23 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 1;
    HEAP32[i18 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i23, i18);
   }
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    i25 = HEAP32[i24 >> 2] | 0;
    i24 = HEAP32[i24 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 1;
    HEAP32[i18 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i18);
   }
   if ((HEAP8[i22 + 11 >> 0] | 0) < 0) {
    i25 = HEAP32[i22 >> 2] | 0;
    i24 = HEAP32[i22 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 1;
    HEAP32[i18 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i18);
   }
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  } else if ((i9 | 0) == 56) {
   HEAP32[i19 >> 2] = i10;
   __Z6FormatPKcz(i16, gb + 780194 | 0, i19);
   i2 = (HEAP8[i16 + 11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i22 + 12 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
    i1 = HEAP32[i22 + 12 >> 2] | 0;
    i9 = 59;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 + 11 >> 0] = i3;
    if (!i3) i1 = i22; else {
     i1 = i22;
     i9 = 61;
    }
   } else i9 = 59;
   if ((i9 | 0) == 59) {
    i20 = i3 + 16 & -16;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i19 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i22 >> 2] = i1;
    HEAP32[i22 + 8 >> 2] = i20 | -2147483648;
    HEAP32[i22 + 4 >> 2] = i3;
    i9 = 61;
   }
   if ((i9 | 0) == 61) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = i24 + 11 | 0;
   HEAP8[i1 >> 0] = 1;
   HEAP8[i24 >> 0] = 32;
   HEAP8[i24 + 1 >> 0] = 0;
   __ZL21GetMeshLocationDetailR4Mesh(i25, i21);
   __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i23, i22, i24, i25);
   i20 = i23 + 11 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 779950 | 0, 88, 1, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i21 = HEAP32[i23 >> 2] | 0;
    i23 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i19 + 4 >> 2] = i23;
    __Z19free_alloc_internalPvRK10MemLabelId(i21, i19);
   }
   if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
    i23 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 12 >> 2] | 0;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i19 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i23, i19);
   }
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    i25 = HEAP32[i24 >> 2] | 0;
    i24 = HEAP32[i24 + 12 >> 2] | 0;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i19 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i19);
   }
   if ((HEAP8[i22 + 11 >> 0] | 0) < 0) {
    i25 = HEAP32[i22 >> 2] | 0;
    i24 = HEAP32[i22 + 12 >> 2] | 0;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i19 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i19);
   }
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  } else if ((i9 | 0) == 79) {
   switch (i2 | 0) {
   case 4:
    {
     i1 = gb + 780263 + 10 | 0;
     break;
    }
   case 5:
    {
     i1 = gb + 780283 + 10 | 0;
     break;
    }
   case 2:
    {
     i1 = gb + 780313 + 10 | 0;
     break;
    }
   case 3:
    {
     i1 = gb + 780247 + 10 | 0;
     break;
    }
   default:
    i1 = gb + 780300 | 0;
   }
   HEAP32[i20 >> 2] = i10;
   HEAP32[i20 + 4 >> 2] = i1;
   HEAP32[i20 + 8 >> 2] = gb + 780444 + 10;
   HEAP32[i20 + 12 >> 2] = gb + 780468 + 10;
   __Z6FormatPKcz(i17, gb + 780329 | 0, i20);
   i2 = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i22 + 12 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
    i1 = HEAP32[i22 + 12 >> 2] | 0;
    i9 = 87;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 + 11 >> 0] = i3;
    if (!i3) i1 = i22; else {
     i1 = i22;
     i9 = 89;
    }
   } else i9 = 87;
   if ((i9 | 0) == 87) {
    i19 = i3 + 16 & -16;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i22 >> 2] = i1;
    HEAP32[i22 + 8 >> 2] = i19 | -2147483648;
    HEAP32[i22 + 4 >> 2] = i3;
    i9 = 89;
   }
   if ((i9 | 0) == 89) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   if ((HEAP32[i4 >> 2] | 0) == 2) {
    i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i6;
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
    i3 = i7;
    i4 = gb + 780488 | 0;
    i5 = i3 + 82 | 0;
    do {
     HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while ((i3 | 0) < (i5 | 0));
    HEAP8[i7 + 82 >> 0] = 0;
    i8 = i22 + 11 | 0;
    i1 = HEAP8[i8 >> 0] | 0;
    i9 = i1 << 24 >> 24 < 0;
    if (i9) {
     i2 = (HEAP32[i22 + 8 >> 2] & 2147483647) + -1 | 0;
     i1 = HEAP32[i22 + 4 >> 2] | 0;
    } else {
     i2 = 10;
     i1 = i1 & 255;
    }
    if ((i2 - i1 | 0) >>> 0 < 82) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i22, i2, 82 - i2 + i1 | 0, i1, i1, 0, 82, i7); else {
     i2 = i9 ? HEAP32[i22 >> 2] | 0 : i22;
     i3 = i2 + i1 | 0;
     i4 = i7;
     i5 = i3 + 82 | 0;
     do {
      HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     } while ((i3 | 0) < (i5 | 0));
     i1 = i1 + 82 | 0;
     if (i9) HEAP32[i22 + 4 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
     HEAP8[i2 + i1 >> 0] = 0;
    }
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i20);
   };
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = i24 + 11 | 0;
   HEAP8[i1 >> 0] = 1;
   HEAP8[i24 >> 0] = 32;
   HEAP8[i24 + 1 >> 0] = 0;
   __ZL21GetMeshLocationDetailR4Mesh(i25, i21);
   __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i23, i22, i24, i25);
   i19 = i23 + 11 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 779950 | 0, 118, 1, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
   if ((HEAP8[i19 >> 0] | 0) < 0) {
    i21 = HEAP32[i23 >> 2] | 0;
    i23 = HEAP32[i23 + 12 >> 2] | 0;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i23;
    __Z19free_alloc_internalPvRK10MemLabelId(i21, i20);
   }
   if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
    i23 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 12 >> 2] | 0;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i23, i20);
   }
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    i25 = HEAP32[i24 >> 2] | 0;
    i24 = HEAP32[i24 + 12 >> 2] | 0;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i20);
   }
   if ((HEAP8[i22 + 11 >> 0] | 0) < 0) {
    i25 = HEAP32[i22 >> 2] | 0;
    i24 = HEAP32[i22 + 12 >> 2] | 0;
    HEAP32[i20 >> 2] = 1;
    HEAP32[i20 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i25, i20);
   }
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  }
 } while (0);
 __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_ItLj2EES4_(i11, i13, i14) | 0;
 i25 = 1;
 STACKTOP = i26;
 return i25 | 0;
}

function _emscripten_GetProcAddress(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 12 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = i6;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i4 >> 2] = _malloc((_strlen(HEAP32[i3 >> 2] | 0) | 0) + 1 | 0) | 0;
 _strcpy(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = _strstr(HEAP32[i4 >> 2] | 0, gb + 1053506 | 0) | 0;
 if (HEAP32[i5 >> 2] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
 HEAP32[i5 >> 2] = _strstr(HEAP32[i4 >> 2] | 0, gb + 1053510 | 0) | 0;
 if (HEAP32[i5 >> 2] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
 HEAP32[i5 >> 2] = _strstr(HEAP32[i4 >> 2] | 0, gb + 1053514 | 0) | 0;
 if (HEAP32[i5 >> 2] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
 HEAP32[i5 >> 2] = _strstr(HEAP32[i4 >> 2] | 0, gb + 1053518 | 0) | 0;
 if (HEAP32[i5 >> 2] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
 do if (_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053524 | 0) | 0) {
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053562 | 0) | 0)) {
   HEAP32[i4 >> 2] = gb + 1053581;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053594 | 0) | 0)) {
   HEAP32[i4 >> 2] = gb + 1053615;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053630 | 0) | 0)) {
   HEAP32[i4 >> 2] = gb + 1053645;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053660 | 0) | 0)) HEAP32[i4 >> 2] = gb + 1053675;
 } else HEAP32[i4 >> 2] = gb + 1053546; while (0);
 do if (_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053690 | 0) | 0) {
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053704 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2782;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053716 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4464;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053730 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4465;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053742 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4466;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053756 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4467;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053770 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4468;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053787 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 23;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053810 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 17;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053836 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 18;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053849 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 19;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053865 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 38;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053878 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4469;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053892 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1006;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053912 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1007;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053932 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1008;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053949 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1009;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053966 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2783;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053978 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4470;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053991 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4471;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054007 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1010;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054030 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 332;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054043 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 333;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054059 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2784;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054070 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4472;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054089 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4473;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054111 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4474;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054130 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1011;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054159 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2785;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054176 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1012;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054191 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1013;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054206 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1137;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054227 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1014;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054247 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1015;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054267 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1016;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054293 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 39;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054312 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 716;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054324 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 20;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054336 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 8;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054348 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 7;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054360 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4475;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054372 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1017;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054384 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 334;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054396 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 169;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054408 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1018;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054421 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1019;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054434 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1020;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054447 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1021;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054460 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1022;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054473 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1023;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054486 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1024;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054499 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1025;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054512 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 335;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054531 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 336;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054550 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 337;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054569 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4476;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054582 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4477;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054600 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4478;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054618 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4479;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054636 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4480;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054654 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1138;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054674 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 40;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053615 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2786;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054692 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3964;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054707 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 338;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054728 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 339;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054743 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 340;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054761 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3965;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054777 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 341;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054796 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1026;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054810 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1027;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054825 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2787;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053546 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 311;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054836 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3966;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053645 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4481;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053675 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4482;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054852 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 342;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054879 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3967;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054893 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 343;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1053581 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3968;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054913 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3969;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054931 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2788;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054943 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1028;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054964 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4483;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1054982 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4484;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055e3 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4485;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055021 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 344;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055047 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 170;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055070 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 345;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055108 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2789;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055124 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3970;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055139 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1029;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055162 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 346;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055175 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4486;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055189 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4487;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055203 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 201;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055223 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3971;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055243 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 347;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055259 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 348;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055277 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1030;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055293 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 349;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055308 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3972;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055330 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4488;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055348 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4489;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055369 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3973;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055387 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3974;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055400 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 451;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055415 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3975;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055429 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055439 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055449 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 202;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055471 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3976;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055497 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3977;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055524 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1031;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055537 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 350;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055552 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 171;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055567 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 452;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055591 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 312;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055602 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4490;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055624 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 351;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055646 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 172;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055670 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 453;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055679 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 454;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055687 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055700 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 45;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055714 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3978;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055726 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3979;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055735 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3980;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055745 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3981;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055757 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3982;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055768 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3983;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055776 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 46;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055788 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3984;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055803 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3985;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055815 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3986;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055829 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2790;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055854 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3987;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055871 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3988;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055887 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3989;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055903 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 2791;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055915 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4491;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055927 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4492;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055951 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055964 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 3;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1055978 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4493;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056e3 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4494;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056007 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056023 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 717;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056040 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056057 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1032;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056073 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 80;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056089 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 21;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056106 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1033;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056120 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 1034;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056132 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 352;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056143 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 4;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056156 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 353;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056166 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 9;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056183 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 354;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056195 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 355;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056217 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 356;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056237 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 5;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056250 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 357;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056272 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 358;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056292 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 8;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056309 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 24;
   break;
  }
  if (!(_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056326 | 0) | 0)) {
   HEAP32[i2 >> 2] = fb + 25;
   break;
  }
  if (_strcmp(HEAP32[i4 >> 2] | 0, gb + 1056346 | 0) | 0) {
   _emscripten_asm_const_iii(0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i2 >> 2] = 0;
   break;
  } else {
   HEAP32[i2 >> 2] = fb + 4495;
   break;
  }
 } else HEAP32[i2 >> 2] = fb + 4463; while (0);
 STACKTOP = i6;
 return HEAP32[i2 >> 2] | 0;
}

function __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 L1 : while (1) {
  i14 = i2;
  i15 = i2 + -16 | 0;
  i18 = i2 + -12 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i3 = i14 - i13 | 0;
    i4 = i3 >> 4;
    switch (i4 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 7;
      break L1;
     }
    case 4:
     {
      i16 = 15;
      break L1;
     }
    case 5:
     {
      i16 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 69;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 112) {
     i16 = 22;
     break L1;
    }
    i10 = (i4 | 0) / 2 | 0;
    i12 = i1 + (i10 << 4) | 0;
    do if ((i3 | 0) > 15984) {
     i9 = (i4 | 0) / 4 | 0;
     i11 = i1 + (i9 << 4) | 0;
     i7 = i12 + (i9 << 4) | 0;
     i3 = __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i1, i11, i12, i7, i17) | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     if ((i4 | 0) >= (i5 | 0)) {
      i4 = i12;
      break;
     }
     HEAP32[i7 >> 2] = i4;
     HEAP32[i15 >> 2] = i5;
     i8 = i7 + 4 | 0;
     HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     i6 = HEAP32[i12 >> 2] | 0;
     if ((i5 | 0) < (i6 | 0)) {
      HEAP32[i12 >> 2] = i5;
      HEAP32[i7 >> 2] = i6;
      i7 = i1 + (i10 << 4) + 4 | 0;
      HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      i4 = i3 + 2 | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      if ((i5 | 0) < (i6 | 0)) {
       HEAP32[i11 >> 2] = i5;
       HEAP32[i12 >> 2] = i6;
       i6 = i1 + (i9 << 4) + 4 | 0;
       HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
       HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
       HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
       i4 = HEAP32[i11 >> 2] | 0;
       i5 = HEAP32[i1 >> 2] | 0;
       if ((i4 | 0) < (i5 | 0)) {
        HEAP32[i1 >> 2] = i4;
        HEAP32[i11 >> 2] = i5;
        i4 = i1 + 4 | 0;
        HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
        HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
        HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
        HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
        HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
        HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
        i3 = i3 + 4 | 0;
        i4 = i12;
       } else {
        i3 = i3 + 3 | 0;
        i4 = i12;
       }
      } else {
       i3 = i4;
       i4 = i12;
      }
     } else {
      i3 = i4;
      i4 = i12;
     }
    } else {
     i3 = HEAP32[i12 >> 2] | 0;
     i4 = HEAP32[i1 >> 2] | 0;
     i5 = HEAP32[i15 >> 2] | 0;
     i6 = (i5 | 0) < (i3 | 0);
     if ((i3 | 0) >= (i4 | 0)) {
      if (!i6) {
       i3 = 0;
       i4 = i12;
       break;
      }
      HEAP32[i12 >> 2] = i5;
      HEAP32[i15 >> 2] = i3;
      i3 = i1 + (i10 << 4) + 4 | 0;
      HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
      HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      i4 = HEAP32[i12 >> 2] | 0;
      i5 = HEAP32[i1 >> 2] | 0;
      if ((i4 | 0) >= (i5 | 0)) {
       i3 = 1;
       i4 = i12;
       break;
      }
      HEAP32[i1 >> 2] = i4;
      HEAP32[i12 >> 2] = i5;
      i4 = i1 + 4 | 0;
      HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      i3 = 2;
      i4 = i12;
      break;
     }
     if (i6) {
      HEAP32[i1 >> 2] = i5;
      HEAP32[i15 >> 2] = i4;
      i3 = i1 + 4 | 0;
      HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
      HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      i3 = 1;
      i4 = i12;
      break;
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i12 >> 2] = i4;
     i4 = i1 + 4 | 0;
     i3 = i1 + (i10 << 4) + 4 | 0;
     HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i4 = HEAP32[i15 >> 2] | 0;
     i5 = HEAP32[i12 >> 2] | 0;
     if ((i4 | 0) < (i5 | 0)) {
      HEAP32[i12 >> 2] = i4;
      HEAP32[i15 >> 2] = i5;
      HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
      HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      i3 = 2;
      i4 = i12;
     } else {
      i3 = 1;
      i4 = i12;
     }
    } while (0);
    i8 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i4 >> 2] | 0;
    if ((i8 | 0) < (i7 | 0)) {
     i4 = i15;
     break;
    } else i5 = i15;
    while (1) {
     i4 = i5 + -16 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if ((i6 | 0) < (i7 | 0)) {
      i16 = 52;
      break L5;
     } else i5 = i4;
    }
    i3 = i1 + 16 | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    if ((i8 | 0) >= (i5 | 0)) {
     if ((i3 | 0) == (i15 | 0)) {
      i16 = 69;
      break L1;
     }
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i8 | 0) < (i4 | 0)) break;
      i3 = i3 + 16 | 0;
      if ((i3 | 0) == (i15 | 0)) {
       i16 = 69;
       break L1;
      }
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i15 >> 2] = i4;
     i13 = i3 + 4 | 0;
     HEAP32[i19 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i3 = i3 + 16 | 0;
    }
    if ((i3 | 0) == (i15 | 0)) {
     i16 = 69;
     break L1;
    } else i4 = i15;
    while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i3 >> 2] | 0;
      i8 = i3 + 16 | 0;
      if ((i9 | 0) < (i7 | 0)) break; else i3 = i8;
     }
     while (1) {
      i5 = i4 + -16 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i9 | 0) < (i6 | 0)) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i6;
     HEAP32[i5 >> 2] = i7;
     i3 = i3 + 4 | 0;
     i4 = i4 + -12 | 0;
     HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i4 = i5;
     i3 = i8;
    }
   }
   if ((i16 | 0) == 52) {
    i16 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i8;
    i10 = i1 + 4 | 0;
    i11 = i5 + -12 | 0;
    HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 16 | 0;
   L50 : do if (i5 >>> 0 < i4 >>> 0) {
    i6 = i12;
    while (1) {
     i11 = HEAP32[i6 >> 2] | 0;
     while (1) {
      i9 = HEAP32[i5 >> 2] | 0;
      i10 = i5 + 16 | 0;
      if ((i9 | 0) < (i11 | 0)) i5 = i10; else break;
     }
     while (1) {
      i7 = i4 + -16 | 0;
      i8 = HEAP32[i7 >> 2] | 0;
      if ((i8 | 0) < (i11 | 0)) break; else i4 = i7;
     }
     if (i5 >>> 0 > i7 >>> 0) {
      i7 = i5;
      break L50;
     }
     HEAP32[i5 >> 2] = i8;
     HEAP32[i7 >> 2] = i9;
     i12 = i5 + 4 | 0;
     i4 = i4 + -12 | 0;
     HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i6 = (i6 | 0) == (i5 | 0) ? i7 : i6;
     i4 = i7;
     i5 = i10;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i12;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) < (i5 | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i11 = i7 + 4 | 0;
     i12 = i6 + 4 | 0;
     HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEbT0_SD_T_(i1, i7, i17) | 0;
    i4 = i7 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEbT0_SD_T_(i4, i2, i17) | 0) {
     i16 = 68;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i12 = i7;
   if ((i12 - i13 | 0) >= (i14 - i12 | 0)) {
    i16 = 67;
    break;
   }
   __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i1, i7, i17);
   i1 = i7 + 16 | 0;
  }
  if ((i16 | 0) == 67) {
   i16 = 0;
   __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i7 + 16 | 0, i2, i17);
   i2 = i7;
   continue;
  } else if ((i16 | 0) == 68) {
   i16 = 0;
   if (i3) {
    i16 = 69;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  i2 = i2 + -16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) >= (i4 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i17 = i1 + 4 | 0;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 7) {
  i7 = i1 + 16 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = i2 + -16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = (i2 | 0) < (i4 | 0);
  if ((i4 | 0) >= (i6 | 0)) {
   if (!i3) {
    STACKTOP = i20;
    return;
   }
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i4 = i1 + 20 | 0;
   HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    STACKTOP = i20;
    return;
   }
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   i18 = i1 + 4 | 0;
   HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   STACKTOP = i20;
   return;
  }
  if (i3) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i5 >> 2] = i6;
   i17 = i1 + 4 | 0;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   STACKTOP = i20;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i6;
  i2 = i1 + 4 | 0;
  i1 = i1 + 20 | 0;
  HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) >= (i6 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 15) {
  __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i15, i17) | 0;
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 16) {
  i8 = i1 + 16 | 0;
  i7 = i1 + 32 | 0;
  i6 = i1 + 48 | 0;
  __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i1, i8, i7, i6, i17) | 0;
  i2 = i2 + -16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) >= (i4 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i6 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i3 = i1 + 52 | 0;
  HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i7 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  i4 = i1 + 36 | 0;
  HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i8 >> 2] = i5;
  HEAP32[i7 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   STACKTOP = i20;
   return;
  }
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i18 = i1 + 4 | 0;
  HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i1, i2, i17);
  STACKTOP = i20;
  return;
 } else if ((i16 | 0) == 69) {
  STACKTOP = i20;
  return;
 }
}

function __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 L1 : while (1) {
  i15 = i2;
  i20 = i2 + -40 | 0;
  i16 = i2 + -80 | 0;
  i19 = i2 + -24 | 0;
  i21 = i2 + -16 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    switch ((i3 | 0) / 40 | 0 | 0) {
    case 2:
     {
      i18 = 5;
      break L1;
     }
    case 3:
     {
      i18 = 9;
      break L1;
     }
    case 4:
     {
      i18 = 27;
      break L1;
     }
    case 5:
     {
      i18 = 28;
      break L1;
     }
    case 1:
    case 0:
     {
      i18 = 107;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 1240) {
     i18 = 30;
     break L1;
    }
    i11 = (i3 >>> 0) / 80 | 0;
    i10 = i1 + (i11 * 40 | 0) | 0;
    do if ((i3 | 0) > 39960) {
     i3 = (i3 >>> 0) / 160 | 0;
     i3 = __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 * 40 | 0) | 0, i10, i10 + (i3 * 40 | 0) | 0, i20, i17) | 0;
     i4 = i1 + (i11 * 40 | 0) + 16 | 0;
     i13 = i1 + 16 | 0;
    } else {
     i6 = i1 + (i11 * 40 | 0) + 16 | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i7 = i1 + 16 | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     if (i5 >>> 0 < i3 >>> 0) i4 = 1; else if ((i5 | 0) == (i3 | 0)) i4 = (HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0) >>> 0 < (HEAP32[i1 + 24 >> 2] | 0) >>> 0; else i4 = 0;
     i3 = HEAP32[i19 >> 2] | 0;
     if (i3 >>> 0 < i5 >>> 0) i3 = 1; else if ((i3 | 0) == (i5 | 0)) i3 = (HEAP32[i21 >> 2] | 0) >>> 0 < (HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0) >>> 0; else i3 = 0;
     if (!i4) {
      if (!i3) {
       i3 = 0;
       i4 = i6;
       i13 = i7;
       break;
      }
      i8 = i22;
      i9 = i10;
      i12 = i8 + 40 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      i8 = i10;
      i9 = i20;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i10 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
      i8 = i20;
      i9 = i22;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
      i3 = HEAP32[i6 >> 2] | 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if (i3 >>> 0 >= i4 >>> 0) {
       if ((i3 | 0) != (i4 | 0)) {
        i3 = 1;
        i4 = i6;
        i13 = i7;
        break;
       }
       if ((HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
        i3 = 1;
        i4 = i6;
        i13 = i7;
        break;
       }
      }
      i8 = i22;
      i9 = i1;
      i12 = i8 + 40 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      i8 = i1;
      i9 = i10;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i1 + 36 >> 0] = HEAP8[i10 + 36 >> 0] | 0;
      i8 = i10;
      i9 = i22;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i10 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
      i3 = 2;
      i4 = i6;
      i13 = i7;
      break;
     }
     i8 = i22;
     i9 = i1;
     i12 = i8 + 40 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     if (i3) {
      i8 = i1;
      i9 = i20;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i1 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
      i8 = i20;
      i9 = i22;
      i12 = i8 + 36 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i12 | 0));
      HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
      i3 = 1;
      i4 = i6;
      i13 = i7;
      break;
     }
     i8 = i1;
     i9 = i10;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i1 + 36 >> 0] = HEAP8[i10 + 36 >> 0] | 0;
     i8 = i10;
     i9 = i22;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i10 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
     i3 = HEAP32[i19 >> 2] | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     if (i3 >>> 0 >= i4 >>> 0) {
      if ((i3 | 0) != (i4 | 0)) {
       i3 = 1;
       i4 = i6;
       i13 = i7;
       break;
      }
      if ((HEAP32[i21 >> 2] | 0) >>> 0 >= (HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0) >>> 0) {
       i3 = 1;
       i4 = i6;
       i13 = i7;
       break;
      }
     }
     i8 = i22;
     i9 = i10;
     i12 = i8 + 40 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     i8 = i10;
     i9 = i20;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i10 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
     i8 = i20;
     i9 = i22;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
     i3 = 2;
     i4 = i6;
     i13 = i7;
    } while (0);
    i9 = HEAP32[i13 >> 2] | 0;
    i8 = HEAP32[i4 >> 2] | 0;
    if (i9 >>> 0 < i8 >>> 0) {
     i4 = i20;
     break;
    }
    if ((i9 | 0) == (i8 | 0)) if ((HEAP32[i1 + 24 >> 2] | 0) >>> 0 < (HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0) >>> 0) {
     i4 = i20;
     break;
    }
    if ((i1 | 0) != (i16 | 0)) {
     i7 = i1 + (i11 * 40 | 0) + 24 | 0;
     i5 = i20;
     i4 = i16;
     while (1) {
      i6 = HEAP32[i5 + -24 >> 2] | 0;
      if (i6 >>> 0 < i8 >>> 0) {
       i18 = 82;
       break L5;
      }
      if ((i6 | 0) == (i8 | 0)) if ((HEAP32[i5 + -16 >> 2] | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
       i18 = 82;
       break L5;
      }
      i5 = i4 + -40 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i12 = i4;
       i4 = i5;
       i5 = i12;
      }
     }
    }
    i3 = i1 + 40 | 0;
    i4 = HEAP32[i19 >> 2] | 0;
    do if (i9 >>> 0 >= i4 >>> 0) {
     if ((i9 | 0) == (i4 | 0)) if ((HEAP32[i1 + 24 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0) break;
     if ((i3 | 0) == (i20 | 0)) {
      i18 = 107;
      break L1;
     }
     i5 = i1 + 24 | 0;
     while (1) {
      i4 = HEAP32[i3 + 16 >> 2] | 0;
      if (i9 >>> 0 < i4 >>> 0) break;
      if ((i9 | 0) == (i4 | 0)) if ((HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i3 + 24 >> 2] | 0) >>> 0) break;
      i3 = i3 + 40 | 0;
      if ((i3 | 0) == (i20 | 0)) {
       i18 = 107;
       break L1;
      }
     }
     i8 = i22;
     i9 = i3;
     i12 = i8 + 40 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     i8 = i3;
     i9 = i20;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i3 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
     i8 = i20;
     i9 = i22;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
     i3 = i3 + 40 | 0;
    } while (0);
    if ((i3 | 0) == (i20 | 0)) {
     i18 = 107;
     break L1;
    }
    i7 = i1 + 24 | 0;
    i5 = i20;
    i1 = i3;
    while (1) {
     i6 = HEAP32[i13 >> 2] | 0;
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     L66 : do if (i6 >>> 0 >= i3 >>> 0) while (1) {
      if ((i6 | 0) == (i3 | 0)) if ((HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i1 + 24 >> 2] | 0) >>> 0) break L66;
      i4 = i1 + 40 | 0;
      i3 = HEAP32[i1 + 56 >> 2] | 0;
      if (i6 >>> 0 < i3 >>> 0) {
       i1 = i4;
       break;
      } else i1 = i4;
     } while (0);
     while (1) {
      i3 = i5;
      i5 = i5 + -40 | 0;
      i4 = HEAP32[i3 + -24 >> 2] | 0;
      if (i6 >>> 0 < i4 >>> 0) continue;
      if ((i6 | 0) != (i4 | 0)) break;
      if ((HEAP32[i7 >> 2] | 0) >>> 0 >= (HEAP32[i3 + -16 >> 2] | 0) >>> 0) break;
     }
     if (i1 >>> 0 >= i5 >>> 0) continue L5;
     i8 = i22;
     i9 = i1;
     i12 = i8 + 40 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     i8 = i1;
     i9 = i5;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i1 + 36 >> 0] = HEAP8[i5 + 36 >> 0] | 0;
     i8 = i5;
     i9 = i22;
     i12 = i8 + 36 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i12 | 0));
     HEAP8[i5 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
     i1 = i1 + 40 | 0;
    }
   }
   if ((i18 | 0) == 82) {
    i18 = 0;
    i8 = i22;
    i9 = i1;
    i12 = i8 + 40 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    i8 = i1;
    i9 = i4;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i1 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
    i8 = i4;
    i9 = i22;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i4 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 40 | 0;
   L82 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i8 = HEAP32[i10 + 16 >> 2] | 0;
    i9 = i10 + 24 | 0;
    while (1) {
     i6 = HEAP32[i5 + 16 >> 2] | 0;
     if (i6 >>> 0 >= i8 >>> 0) {
      if ((i6 | 0) != (i8 | 0)) break;
      if ((HEAP32[i5 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break;
     }
     i5 = i5 + 40 | 0;
    }
    i7 = i4 + -40 | 0;
    i6 = HEAP32[i4 + -24 >> 2] | 0;
    L92 : do if (i6 >>> 0 < i8 >>> 0) i4 = i7; else while (1) {
     if ((i6 | 0) == (i8 | 0)) if ((HEAP32[i4 + -16 >> 2] | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
      i4 = i7;
      break L92;
     }
     i4 = i7 + -40 | 0;
     i6 = HEAP32[i7 + -24 >> 2] | 0;
     if (i6 >>> 0 < i8 >>> 0) break; else {
      i13 = i7;
      i7 = i4;
      i4 = i13;
     }
    } while (0);
    if (i5 >>> 0 > i4 >>> 0) {
     i6 = i10;
     i7 = i5;
     break L82;
    }
    i8 = i22;
    i9 = i5;
    i12 = i8 + 40 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    i8 = i5;
    i9 = i4;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i5 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
    i8 = i4;
    i9 = i22;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i4 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
    i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
    i5 = i5 + 40 | 0;
    i3 = i3 + 1 | 0;
   } else {
    i6 = i10;
    i7 = i5;
   } while (0);
   do if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 + 16 >> 2] | 0;
    i5 = HEAP32[i7 + 16 >> 2] | 0;
    if (i4 >>> 0 >= i5 >>> 0) {
     if ((i4 | 0) != (i5 | 0)) break;
     if ((HEAP32[i6 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) break;
    }
    i8 = i22;
    i9 = i7;
    i12 = i8 + 40 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    i8 = i7;
    i9 = i6;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i6 + 36 >> 0] | 0;
    i8 = i6;
    i9 = i22;
    i12 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i12 | 0));
    HEAP8[i6 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEbT0_S6_T_(i1, i7, i17) | 0;
    i4 = i7 + 40 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEbT0_S6_T_(i4, i2, i17) | 0) {
     i18 = 106;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i7;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i18 = 105;
    break;
   }
   __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i1, i7, i17);
   i1 = i7 + 40 | 0;
  }
  if ((i18 | 0) == 105) {
   i18 = 0;
   __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i7 + 40 | 0, i2, i17);
   i2 = i7;
   continue;
  } else if ((i18 | 0) == 106) {
   i18 = 0;
   if (i3) {
    i18 = 107;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i18 | 0) == 5) {
  i2 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  if (i2 >>> 0 >= i3 >>> 0) {
   if ((i2 | 0) != (i3 | 0)) {
    STACKTOP = i23;
    return;
   }
   if ((HEAP32[i21 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
    STACKTOP = i23;
    return;
   }
  }
  i8 = i22;
  i9 = i1;
  i12 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  i8 = i1;
  i9 = i20;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i1 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
  i8 = i20;
  i9 = i22;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
  STACKTOP = i23;
  return;
 } else if ((i18 | 0) == 9) {
  i7 = i1 + 40 | 0;
  i5 = i1 + 56 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i6 = i1 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) i4 = 1; else if ((i3 | 0) == (i2 | 0)) i4 = (HEAP32[i1 + 64 >> 2] | 0) >>> 0 < (HEAP32[i1 + 24 >> 2] | 0) >>> 0; else i4 = 0;
  i2 = HEAP32[i19 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) i2 = 1; else if ((i2 | 0) == (i3 | 0)) i2 = (HEAP32[i21 >> 2] | 0) >>> 0 < (HEAP32[i1 + 64 >> 2] | 0) >>> 0; else i2 = 0;
  if (!i4) {
   if (!i2) {
    STACKTOP = i23;
    return;
   }
   i8 = i22;
   i9 = i7;
   i12 = i8 + 40 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   i8 = i7;
   i9 = i20;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i7 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
   i8 = i20;
   i9 = i22;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i3 >>> 0 >= i2 >>> 0) {
    if ((i3 | 0) != (i2 | 0)) {
     STACKTOP = i23;
     return;
    }
    if ((HEAP32[i1 + 64 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
     STACKTOP = i23;
     return;
    }
   }
   i8 = i22;
   i9 = i1;
   i12 = i8 + 40 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   i8 = i1;
   i9 = i7;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i1 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
   i8 = i7;
   i9 = i22;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i7 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
   STACKTOP = i23;
   return;
  }
  i8 = i22;
  i9 = i1;
  i12 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  if (i2) {
   i8 = i1;
   i9 = i20;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i1 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
   i8 = i20;
   i9 = i22;
   i12 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i12 | 0));
   HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
   STACKTOP = i23;
   return;
  }
  i8 = i1;
  i9 = i7;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i1 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
  i8 = i7;
  i9 = i22;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 >= i2 >>> 0) {
   if ((i3 | 0) != (i2 | 0)) {
    STACKTOP = i23;
    return;
   }
   if ((HEAP32[i21 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 64 >> 2] | 0) >>> 0) {
    STACKTOP = i23;
    return;
   }
  }
  i8 = i22;
  i9 = i7;
  i12 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  i8 = i7;
  i9 = i20;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i20 + 36 >> 0] | 0;
  i8 = i20;
  i9 = i22;
  i12 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i12 | 0));
  HEAP8[i20 + 36 >> 0] = HEAP8[i22 + 36 >> 0] | 0;
  STACKTOP = i23;
  return;
 } else if ((i18 | 0) == 27) {
  __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i20, i17) | 0;
  STACKTOP = i23;
  return;
 } else if ((i18 | 0) == 28) {
  __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i1 + 120 | 0, i20, i17) | 0;
  STACKTOP = i23;
  return;
 } else if ((i18 | 0) == 30) {
  __ZNSt3__218__insertion_sort_3IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i1, i2, i17);
  STACKTOP = i23;
  return;
 } else if ((i18 | 0) == 107) {
  STACKTOP = i23;
  return;
 }
}

function _cff_font_load(i8, i19, i6, i25, i3) {
 i8 = i8 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28 + 72 | 0;
 i22 = i28 + 40 | 0;
 i24 = i28 + 36 | 0;
 i26 = i28 + 32 | 0;
 i27 = i28;
 i18 = i19 + 28 | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 _memset(i25 + 4 + 4 | 0, 0, 2972) | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = 0;
 HEAP32[i27 + 20 >> 2] = 0;
 HEAP32[i27 + 24 >> 2] = 0;
 HEAP32[i27 + 28 >> 2] = 0;
 HEAP32[i25 >> 2] = i19;
 HEAP32[i25 + 4 >> 2] = i7;
 i5 = i25 + 1324 | 0;
 i17 = _UNITY_FT_Stream_Pos(i19) | 0;
 i21 = _UNITY_FT_Stream_ReadFields(i19, gb + 226294 | 0, i25) | 0;
 HEAP32[i26 >> 2] = i21;
 L1 : do if (!i21) {
  i1 = HEAP32[i25 + 16 >> 2] | 0;
  i2 = i1 >>> 16;
  if ((i1 & 255) << 24 >> 24 == 1) if (!((i2 & 255) < 4 | (i1 >>> 24 & 255) > 4)) {
   i21 = _UNITY_FT_Stream_Skip(i19, (i2 & 255) + -4 | 0) | 0;
   HEAP32[i26 >> 2] = i21;
   if (i21 | 0) break;
   i21 = i25 + 20 | 0;
   i20 = _cff_index_init(i21, i19, 0) | 0;
   HEAP32[i26 >> 2] = i20;
   if (i20 | 0) break;
   i4 = i25 + 1208 | 0;
   i20 = _cff_index_init(i4, i19, 0) | 0;
   HEAP32[i26 >> 2] = i20;
   if (i20 | 0) break;
   i20 = _cff_index_init(i27, i19, 1) | 0;
   HEAP32[i26 >> 2] = i20;
   if (i20 | 0) break;
   i9 = i25 + 84 | 0;
   i20 = _cff_index_init(i9, i19, 1) | 0;
   HEAP32[i26 >> 2] = i20;
   if (i20 | 0) break;
   i20 = _cff_index_get_pointers(i27, i25 + 1316 | 0, i25 + 1320 | 0) | 0;
   HEAP32[i26 >> 2] = i20;
   if (i20 | 0) break;
   HEAP32[i25 + 1312 >> 2] = HEAP32[i27 + 8 >> 2];
   i14 = i3 << 24 >> 24 == 0;
   do if (i14) if ((HEAP32[i25 + 28 >> 2] | 0) >>> 0 > 1) {
    HEAP32[i26 >> 2] = 3;
    break L1;
   } else i20 = 0; else {
    i1 = i6 & 65535;
    i2 = HEAP32[i25 + 28 >> 2] | 0;
    if ((i6 | 0) < 1 | i1 >>> 0 < i2 >>> 0) {
     HEAP32[i25 + 8 >> 2] = i2;
     i20 = i1;
     break;
    } else {
     HEAP32[i26 >> 2] = 6;
     break L1;
    }
   } while (0);
   if ((i6 | 0) < 0) break;
   i16 = _cff_subfont_load(i5, i4, i20, i19, i17, i8) | 0;
   HEAP32[i26 >> 2] = i16;
   if (i16 | 0) break;
   i6 = i25 + 1436 | 0;
   i16 = _UNITY_FT_Stream_Seek(i19, (HEAP32[i6 >> 2] | 0) + i17 | 0) | 0;
   HEAP32[i26 >> 2] = i16;
   if (i16 | 0) break;
   i16 = _cff_index_init(i25 + 1176 | 0, i19, 0) | 0;
   HEAP32[i26 >> 2] = i16;
   if (i16 | 0) break;
   i15 = i25 + 1456 | 0;
   L24 : do if ((HEAP32[i15 >> 2] | 0) == 65535) HEAP32[i25 + 1896 >> 2] = 0; else {
    i16 = _UNITY_FT_Stream_Seek(i19, (HEAP32[i25 + 1488 >> 2] | 0) + i17 | 0) | 0;
    HEAP32[i26 >> 2] = i16;
    do if (!i16) {
     i16 = _cff_index_init(i22, i19, 0) | 0;
     HEAP32[i26 >> 2] = i16;
     if (i16 | 0) break;
     i5 = i22 + 8 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     L30 : do if (i1 >>> 0 > 256) i1 = 0; else {
      HEAP32[i25 + 1896 >> 2] = i1;
      i4 = _UNITY_ft_mem_realloc(i7, 572, 0, i1, 0, i26) | 0;
      i1 = HEAP32[i26 >> 2] | 0;
      if (i1 | 0) break;
      i2 = HEAP32[i5 >> 2] | 0;
      i3 = (i2 | 0) == 0;
      do if (!i3) {
       i1 = 0;
       do {
        HEAP32[i25 + 1900 + (i1 << 2) >> 2] = i4 + (i1 * 572 | 0);
        i1 = i1 + 1 | 0;
       } while (i1 >>> 0 < i2 >>> 0);
       if (i3) break; else i2 = 0;
       do {
        i1 = _cff_subfont_load(HEAP32[i25 + 1900 + (i2 << 2) >> 2] | 0, i22, i2, i19, i17, i8) | 0;
        HEAP32[i26 >> 2] = i1;
        i2 = i2 + 1 | 0;
        if (i1 | 0) break L30;
       } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
      } while (0);
      i1 = HEAP32[i25 + 1184 >> 2] | 0;
      i2 = _UNITY_FT_Stream_Seek(i19, (HEAP32[i25 + 1492 >> 2] | 0) + i17 | 0) | 0;
      HEAP32[i23 >> 2] = i2;
      L41 : do if (!i2) {
       i2 = _UNITY_FT_Stream_ReadChar(i19, i23) | 0;
       i3 = HEAP32[i23 >> 2] | 0;
       if (i3 | 0) {
        i1 = i3;
        break;
       }
       HEAP8[i25 + 2924 >> 0] = i2;
       HEAP32[i25 + 2944 >> 2] = 0;
       L44 : do switch (i2 << 24 >> 24) {
       case 0:
        {
         HEAP32[i25 + 2936 >> 2] = i1;
         break;
        }
       case 3:
        {
         i2 = _UNITY_FT_Stream_ReadUShort(i19, i23) | 0;
         i1 = HEAP32[i23 >> 2] | 0;
         if (i1 | 0) break L41;
         if (!(i2 << 16 >> 16)) {
          HEAP32[i23 >> 2] = 3;
          i1 = 3;
          break L41;
         } else {
          i1 = ((i2 & 65535) * 3 | 0) + 2 | 0;
          HEAP32[i25 + 2936 >> 2] = i1;
          break L44;
         }
        }
       default:
        {
         HEAP32[i23 >> 2] = 3;
         i1 = 3;
         break L41;
        }
       } while (0);
       i1 = _UNITY_FT_Stream_ExtractFrame(i19, i1, i25 + 2932 | 0) | 0;
       HEAP32[i23 >> 2] = i1;
      } else i1 = i2; while (0);
      HEAP32[i26 >> 2] = i1;
     } while (0);
     i3 = HEAP32[i22 >> 2] | 0;
     if (i3) {
      i1 = HEAP32[i3 + 28 >> 2] | 0;
      i2 = i22 + 28 | 0;
      if (HEAP32[i2 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i3, i2);
      _UNITY_ft_mem_free(i1, HEAP32[i22 + 24 >> 2] | 0);
      HEAP32[i22 >> 2] = 0;
      HEAP32[i22 + 4 >> 2] = 0;
      HEAP32[i22 + 8 >> 2] = 0;
      HEAP32[i22 + 12 >> 2] = 0;
      HEAP32[i22 + 16 >> 2] = 0;
      HEAP32[i22 + 20 >> 2] = 0;
      HEAP32[i22 + 24 >> 2] = 0;
      HEAP32[i22 + 28 >> 2] = 0;
      i1 = HEAP32[i26 >> 2] | 0;
     }
     if (i1 | 0) break;
     break L24;
    } while (0);
    break L1;
   } while (0);
   if (!(HEAP32[i6 >> 2] | 0)) {
    HEAP32[i26 >> 2] = 3;
    break;
   }
   i13 = i25 + 12 | 0;
   HEAP32[i13 >> 2] = HEAP32[i25 + 1184 >> 2];
   i16 = _cff_index_get_pointers(i9, i25 + 1308 | 0, 0) | 0;
   HEAP32[i26 >> 2] = i16;
   if (i16 | 0) break;
   i10 = HEAP32[i13 >> 2] | 0;
   L68 : do if (i10 | 0) {
    i9 = (HEAP32[i15 >> 2] | 0) == 65535;
    i11 = i25 + 1152 | 0;
    i2 = HEAP32[i25 + 1428 >> 2] | 0;
    i12 = HEAP32[i18 >> 2] | 0;
    HEAP32[i22 >> 2] = 0;
    L70 : do if (i2 >>> 0 > 2) {
     i16 = i2 + i17 | 0;
     i1 = i25 + 1156 | 0;
     HEAP32[i1 >> 2] = i16;
     i16 = _UNITY_FT_Stream_Seek(i19, i16) | 0;
     HEAP32[i22 >> 2] = i16;
     if (i16 | 0) {
      i16 = 101;
      break;
     }
     HEAP32[i11 >> 2] = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
     if (HEAP32[i22 >> 2] | 0) {
      i16 = 101;
      break;
     }
     i2 = _UNITY_ft_mem_realloc(i12, 2, 0, i10, 0, i22) | 0;
     i8 = i25 + 1160 | 0;
     HEAP32[i8 >> 2] = i2;
     if (HEAP32[i22 >> 2] | 0) {
      i16 = 101;
      break;
     }
     HEAP16[i2 >> 1] = 0;
     switch (HEAP32[i11 >> 2] | 0) {
     case 0:
      {
       i16 = _UNITY_FT_Stream_EnterFrame(i19, (i10 << 1) + -2 | 0) | 0;
       HEAP32[i22 >> 2] = i16;
       if (i16 | 0) {
        i16 = 101;
        break L70;
       }
       if (i10 >>> 0 > 1) {
        i1 = 1;
        do {
         i16 = _UNITY_FT_Stream_GetUShort(i19) | 0;
         HEAP16[(HEAP32[i8 >> 2] | 0) + (i1 << 1) >> 1] = i16;
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != (i10 | 0));
       }
       _UNITY_FT_Stream_ExitFrame(i19);
       i16 = 87;
       break L70;
      }
     case 2:
     case 1:
      {
       if (i10 >>> 0 > 1) i2 = 1; else {
        i16 = 87;
        break L70;
       }
       while (1) {
        i6 = _UNITY_FT_Stream_ReadUShort(i19, i22) | 0;
        if (HEAP32[i22 >> 2] | 0) {
         i16 = 101;
         break L70;
        }
        if ((HEAP32[i11 >> 2] | 0) == 2) {
         i3 = (_UNITY_FT_Stream_ReadUShort(i19, i22) | 0) & 65535;
         if (HEAP32[i22 >> 2] | 0) {
          i16 = 101;
          break L70;
         }
        } else {
         i3 = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
         if (HEAP32[i22 >> 2] | 0) {
          i16 = 101;
          break L70;
         }
        }
        i4 = i6 & 65535;
        i4 = i4 >>> 0 > (i3 ^ 65535) >>> 0 ? i4 ^ 65535 : i3;
        if (i2 >>> 0 < i10 >>> 0) {
         i7 = HEAP32[i8 >> 2] | 0;
         i5 = 0;
         i3 = i6;
         while (1) {
          HEAP16[i7 + (i2 << 1) >> 1] = i3;
          i5 = i5 + 1 | 0;
          i2 = i2 + 1 | 0;
          if (i5 >>> 0 > i4 >>> 0 | i2 >>> 0 >= i10 >>> 0) break; else i3 = i3 + 1 << 16 >> 16;
         }
        }
        if (i2 >>> 0 >= i10 >>> 0) {
         i16 = 87;
         break;
        }
       }
       break;
      }
     default:
      {
       HEAP32[i22 >> 2] = 3;
       i16 = 101;
       break L70;
      }
     }
    } else {
     i1 = i25 + 1156 | 0;
     HEAP32[i1 >> 2] = i2;
     switch (i2 | 0) {
     case 0:
      {
       if (i10 >>> 0 > 229) {
        HEAP32[i22 >> 2] = 3;
        i16 = 101;
        break L70;
       }
       i2 = _UNITY_ft_mem_realloc(i12, 2, 0, i10, 0, i22) | 0;
       HEAP32[i25 + 1160 >> 2] = i2;
       if (HEAP32[i22 >> 2] | 0) {
        i16 = 101;
        break L70;
       }
       _memcpy(i2 | 0, gb + 226318 | 0, i10 << 1 | 0) | 0;
       i16 = 87;
       break L70;
      }
     case 1:
      {
       if (i10 >>> 0 > 166) {
        HEAP32[i22 >> 2] = 3;
        i16 = 101;
        break L70;
       }
       i2 = _UNITY_ft_mem_realloc(i12, 2, 0, i10, 0, i22) | 0;
       HEAP32[i25 + 1160 >> 2] = i2;
       if (HEAP32[i22 >> 2] | 0) {
        i16 = 101;
        break L70;
       }
       _memcpy(i2 | 0, gb + 226776 | 0, i10 << 1 | 0) | 0;
       i16 = 87;
       break L70;
      }
     case 2:
      {
       if (i10 >>> 0 > 87) {
        HEAP32[i22 >> 2] = 3;
        i16 = 101;
        break L70;
       }
       i2 = _UNITY_ft_mem_realloc(i12, 2, 0, i10, 0, i22) | 0;
       HEAP32[i25 + 1160 >> 2] = i2;
       if (HEAP32[i22 >> 2] | 0) {
        i16 = 101;
        break L70;
       }
       _memcpy(i2 | 0, gb + 227108 | 0, i10 << 1 | 0) | 0;
       i16 = 87;
       break L70;
      }
     default:
      {
       HEAP32[i22 >> 2] = 3;
       i16 = 101;
       break L70;
      }
     }
    } while (0);
    do if ((i16 | 0) == 87) {
     if (i14 | i9) i1 = HEAP32[i22 >> 2] | 0; else {
      HEAP32[i23 >> 2] = 0;
      i6 = i25 + 1168 | 0;
      do if (!(HEAP32[i6 >> 2] | 0)) {
       i5 = i25 + 1160 | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       i1 = 0;
       i2 = 0;
       do {
        i14 = HEAP16[i3 + (i1 << 1) >> 1] | 0;
        i2 = (i14 & 65535) > (i2 & 65535) ? i14 : i2;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i10 | 0));
       i3 = i2 & 65535;
       i4 = _UNITY_ft_mem_realloc(i12, 2, 0, i3 + 1 | 0, 0, i23) | 0;
       HEAP32[i25 + 1164 >> 2] = i4;
       i1 = HEAP32[i23 >> 2] | 0;
       if (i1 | 0) break;
       if ((i10 | 0) > 0) {
        i2 = HEAP32[i5 >> 2] | 0;
        i1 = i10;
        do {
         i14 = i1;
         i1 = i1 + -1 | 0;
         HEAP16[i4 + (HEAPU16[i2 + (i1 << 1) >> 1] << 1) >> 1] = i1;
        } while ((i14 | 0) > 1);
       }
       HEAP32[i6 >> 2] = i3;
       HEAP32[i25 + 1172 >> 2] = i10;
       i1 = 0;
      } else i1 = 0; while (0);
      HEAP32[i22 >> 2] = i1;
     }
     if (!i1) {
      HEAP32[i26 >> 2] = 0;
      break;
     } else {
      i1 = i25 + 1156 | 0;
      i16 = 101;
      break;
     }
    } while (0);
    if ((i16 | 0) == 101) {
     i14 = i25 + 1160 | 0;
     _UNITY_ft_mem_free(i12, HEAP32[i14 >> 2] | 0);
     HEAP32[i14 >> 2] = 0;
     i10 = i25 + 1164 | 0;
     _UNITY_ft_mem_free(i12, HEAP32[i10 >> 2] | 0);
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     i14 = HEAP32[i22 >> 2] | 0;
     HEAP32[i26 >> 2] = i14;
     if (i14 | 0) break L1;
    }
    if ((HEAP32[i15 >> 2] | 0) != 65535) break;
    i10 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i25 + 1432 >> 2] | 0;
    HEAP32[i22 >> 2] = 0;
    i9 = i25 + 1160 | 0;
    L139 : do if (!(HEAP32[i9 >> 2] | 0)) {
     HEAP32[i22 >> 2] = 3;
     i1 = 3;
    } else {
     i1 = 0;
     do {
      HEAP16[i25 + 128 + (i1 << 1) >> 1] = 0;
      HEAP16[i25 + 640 + (i1 << 1) >> 1] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 256);
     L144 : do if (i2 >>> 0 > 1) {
      i1 = i2 + i17 | 0;
      HEAP32[i25 + 120 >> 2] = i1;
      i1 = _UNITY_FT_Stream_Seek(i19, i1) | 0;
      HEAP32[i22 >> 2] = i1;
      if (i1 | 0) break L139;
      i8 = i25 + 116 | 0;
      HEAP32[i8 >> 2] = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
      i1 = HEAP32[i22 >> 2] | 0;
      if (i1 | 0) break L139;
      i2 = _UNITY_FT_Stream_ReadChar(i19, i22) | 0;
      i7 = i2 & 255;
      i1 = HEAP32[i22 >> 2] | 0;
      if (i1 | 0) break L139;
      L149 : do switch (HEAP32[i8 >> 2] & 127) {
      case 0:
       {
        HEAP32[i25 + 124 >> 2] = i7 + 1;
        i1 = _UNITY_FT_Stream_EnterFrame(i19, i7) | 0;
        HEAP32[i22 >> 2] = i1;
        if (i1 | 0) break L139;
        if (i2 << 24 >> 24) {
         i1 = HEAP32[i19 + 32 >> 2] | 0;
         i2 = 1;
         while (1) {
          i3 = HEAPU8[i1 >> 0] | 0;
          if (i2 >>> 0 < i10 >>> 0) {
           HEAP16[i25 + 640 + (i3 << 1) >> 1] = i2;
           HEAP16[i25 + 128 + (i3 << 1) >> 1] = HEAP16[(HEAP32[i9 >> 2] | 0) + (i2 << 1) >> 1] | 0;
          }
          i2 = i2 + 1 | 0;
          if (i2 >>> 0 > i7 >>> 0) break; else i1 = i1 + 1 | 0;
         }
        }
        _UNITY_FT_Stream_ExitFrame(i19);
        break;
       }
      case 1:
       {
        i6 = i25 + 124 | 0;
        HEAP32[i6 >> 2] = 0;
        if (!(i2 << 24 >> 24)) break L149; else {
         i4 = 1;
         i5 = 0;
        }
        do {
         i3 = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
         i1 = HEAP32[i22 >> 2] | 0;
         if (i1 | 0) break L139;
         i2 = _UNITY_FT_Stream_ReadChar(i19, i22) | 0;
         i1 = HEAP32[i22 >> 2] | 0;
         if (i1 | 0) break L139;
         i1 = (i2 & 255) + 1 | 0;
         if (i1 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) HEAP32[i6 >> 2] = i1;
         i2 = i4;
         i4 = i1 + i4 | 0;
         if (i2 >>> 0 < i4 >>> 0) {
          i1 = i3;
          while (1) {
           if (i2 >>> 0 < i10 >>> 0 & i1 >>> 0 < 256) {
            HEAP16[i25 + 640 + (i1 << 1) >> 1] = i2;
            HEAP16[i25 + 128 + (i1 << 1) >> 1] = HEAP16[(HEAP32[i9 >> 2] | 0) + (i2 << 1) >> 1] | 0;
           }
           i2 = i2 + 1 | 0;
           if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 1 | 0;
          }
         }
         i5 = i5 + 1 | 0;
        } while (i5 >>> 0 < i7 >>> 0);
        if ((HEAP32[i6 >> 2] | 0) >>> 0 <= 256) break L149;
        HEAP32[i6 >> 2] = 256;
        break;
       }
      default:
       {
        HEAP32[i22 >> 2] = 3;
        i1 = 3;
        break L139;
       }
      } while (0);
      do if (!(HEAP32[i8 >> 2] & 128)) i1 = HEAP32[i22 >> 2] | 0; else {
       i18 = _UNITY_FT_Stream_ReadChar(i19, i22) | 0;
       i6 = i18 & 255;
       i1 = HEAP32[i22 >> 2] | 0;
       if (!(i18 << 24 >> 24 != 0 & (i1 | 0) == 0)) break;
       if (!i10) {
        i3 = 0;
        while (1) {
         i4 = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
         i1 = HEAP32[i22 >> 2] | 0;
         if (i1 | 0) break L139;
         i2 = _UNITY_FT_Stream_ReadUShort(i19, i22) | 0;
         i1 = HEAP32[i22 >> 2] | 0;
         if (i1 | 0) break L139;
         HEAP16[i25 + 128 + (i4 << 1) >> 1] = i2;
         i3 = i3 + 1 | 0;
         if (i3 >>> 0 >= i6 >>> 0) break L144;
        }
       } else i4 = 0;
       while (1) {
        i5 = (_UNITY_FT_Stream_ReadChar(i19, i22) | 0) & 255;
        i1 = HEAP32[i22 >> 2] | 0;
        if (i1 | 0) break L139;
        i3 = _UNITY_FT_Stream_ReadUShort(i19, i22) | 0;
        i1 = HEAP32[i22 >> 2] | 0;
        if (i1 | 0) break L139;
        HEAP16[i25 + 128 + (i5 << 1) >> 1] = i3;
        i2 = HEAP32[i9 >> 2] | 0;
        i1 = 0;
        do {
         if ((HEAP16[i2 + (i1 << 1) >> 1] | 0) == i3 << 16 >> 16) {
          i16 = 140;
          break;
         }
         i1 = i1 + 1 | 0;
        } while (i1 >>> 0 < i10 >>> 0);
        if ((i16 | 0) == 140) {
         i16 = 0;
         HEAP16[i25 + 640 + (i5 << 1) >> 1] = i1;
        }
        i4 = i4 + 1 | 0;
        if (i4 >>> 0 >= i6 >>> 0) break L144;
       }
      } while (0);
      HEAP32[i26 >> 2] = i1;
      if (!i1) break L68; else break L1;
     } else {
      switch (i2 | 0) {
      case 0:
       {
        _memcpy(i25 + 128 | 0, gb + 225782 | 0, 512) | 0;
        break;
       }
      case 1:
       {
        _memcpy(i25 + 128 | 0, gb + 227282 | 0, 512) | 0;
        break;
       }
      default:
       {
        HEAP32[i22 >> 2] = 3;
        i1 = 3;
        break L139;
       }
      }
      i7 = i25 + 124 | 0;
      HEAP32[i7 >> 2] = 0;
      i5 = HEAP32[i18 >> 2] | 0;
      HEAP32[i23 >> 2] = 0;
      i6 = i25 + 1168 | 0;
      i1 = HEAP32[i6 >> 2] | 0;
      if (!i1) {
       if (!i10) i1 = 0; else {
        i3 = HEAP32[i9 >> 2] | 0;
        i2 = 0;
        i1 = 0;
        do {
         i19 = HEAP16[i3 + (i2 << 1) >> 1] | 0;
         i1 = (i19 & 65535) > (i1 & 65535) ? i19 : i1;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i10 | 0));
       }
       i4 = i1 & 65535;
       i3 = _UNITY_ft_mem_realloc(i5, 2, 0, i4 + 1 | 0, 0, i23) | 0;
       i5 = i25 + 1164 | 0;
       HEAP32[i5 >> 2] = i3;
       i1 = HEAP32[i23 >> 2] | 0;
       if (i1 | 0) {
        HEAP32[i22 >> 2] = i1;
        break L139;
       }
       if ((i10 | 0) > 0) {
        i2 = HEAP32[i9 >> 2] | 0;
        i1 = i10;
        do {
         i19 = i1;
         i1 = i1 + -1 | 0;
         HEAP16[i3 + (HEAPU16[i2 + (i1 << 1) >> 1] << 1) >> 1] = i1;
        } while ((i19 | 0) > 1);
       }
       HEAP32[i6 >> 2] = i4;
       HEAP32[i25 + 1172 >> 2] = i10;
      } else {
       i5 = i25 + 1164 | 0;
       i4 = i1;
      }
      HEAP32[i22 >> 2] = 0;
      i1 = 0;
      do {
       i3 = i25 + 128 + (i1 << 1) | 0;
       i2 = HEAP16[i3 >> 1] | 0;
       do if (!(i2 << 16 >> 16)) i16 = 164; else {
        i2 = i2 & 65535;
        if (i4 >>> 0 < i2 >>> 0) {
         i16 = 164;
         break;
        }
        i2 = HEAP16[(HEAP32[i5 >> 2] | 0) + (i2 << 1) >> 1] | 0;
        if (!(i2 << 16 >> 16)) {
         i16 = 164;
         break;
        }
        HEAP16[i25 + 640 + (i1 << 1) >> 1] = i2;
        i1 = i1 + 1 | 0;
        HEAP32[i7 >> 2] = i1;
       } while (0);
       if ((i16 | 0) == 164) {
        i16 = 0;
        HEAP16[i25 + 640 + (i1 << 1) >> 1] = 0;
        HEAP16[i3 >> 1] = 0;
        i1 = i1 + 1 | 0;
       }
      } while ((i1 | 0) != 256);
     } while (0);
     HEAP32[i26 >> 2] = 0;
     break L68;
    } while (0);
    HEAP32[i26 >> 2] = i1;
    break L1;
   } while (0);
   i1 = HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0;
   i20 = _cff_index_access_element(i21, i20, i23, i22) | 0;
   HEAP32[i24 >> 2] = i20;
   do if (!i20) {
    i2 = HEAP32[i22 >> 2] | 0;
    i1 = _UNITY_ft_mem_alloc(i1, i2 + 1 | 0, i24) | 0;
    if (!(HEAP32[i24 >> 2] | 0)) {
     _memcpy(i1 | 0, HEAP32[i23 >> 2] | 0, i2 | 0) | 0;
     HEAP8[i1 + i2 >> 0] = 0;
    }
    if (HEAP32[i25 + 48 >> 2] | 0) break;
    _UNITY_FT_Stream_ReleaseFrame(HEAP32[i21 >> 2] | 0, i23);
   } else i1 = 0; while (0);
   HEAP32[i25 + 1304 >> 2] = i1;
   break;
  }
  HEAP32[i26 >> 2] = 2;
 } while (0);
 i1 = HEAP32[i27 >> 2] | 0;
 if (!i1) {
  i27 = HEAP32[i26 >> 2] | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = i27 + 28 | 0;
 if (HEAP32[i3 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i1, i3);
 _UNITY_ft_mem_free(i2, HEAP32[i27 + 24 >> 2] | 0);
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = 0;
 HEAP32[i27 + 20 >> 2] = 0;
 HEAP32[i27 + 24 >> 2] = 0;
 HEAP32[i27 + 28 >> 2] = 0;
 i27 = HEAP32[i26 >> 2] | 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i101, i3, i1, i91, i90, i103, i104, i102, f2) {
 i101 = i101 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i91 = i91 | 0;
 i90 = i90 | 0;
 i103 = i103 | 0;
 i104 = i104 | 0;
 i102 = i102 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i105 = 0, f106 = f0, f107 = f0, i108 = 0, f109 = f0;
 i105 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i100 = i105 + 192 | 0;
 i95 = i105 + 288 | 0;
 i99 = i105 + 284 | 0;
 i94 = i105 + 208 | 0;
 i92 = i105 + 128 | 0;
 i93 = i105 + 64 | 0;
 i70 = i105 + 272 | 0;
 i71 = i105 + 48 | 0;
 i98 = i105 + 32 | 0;
 i96 = i105 + 16 | 0;
 i97 = i105;
 HEAP32[i100 >> 2] = 0;
 HEAP32[i100 + 4 >> 2] = 0;
 HEAP32[i100 + 8 >> 2] = 0;
 HEAP32[i100 + 12 >> 2] = 0;
 f14 = Math_fround(HEAPF32[i90 >> 2]);
 i74 = i90 + 4 | 0;
 f16 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i90 + 8 | 0;
 f19 = Math_fround(HEAPF32[i75 >> 2]);
 f15 = Math_fround(HEAPF32[i91 >> 2]);
 i85 = i91 + 4 | 0;
 f17 = Math_fround(HEAPF32[i85 >> 2]);
 i87 = i91 + 8 | 0;
 f18 = Math_fround(HEAPF32[i87 >> 2]);
 HEAP32[i99 >> 2] = 1;
 f31 = Math_fround(HEAPF32[i101 >> 2]);
 f30 = Math_fround(HEAPF32[i101 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i101 + 8 >> 2]);
 f35 = Math_fround(HEAPF32[i3 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f35 = Math_fround(f31 - f35);
 f36 = Math_fround(f30 - f36);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 i76 = Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36)) + Math_fround(f6 * f6)) > Math_fround(1.1920929e-07);
 f35 = i76 ? f35 : Math_fround(1.0);
 f36 = i76 ? f36 : Math_fround(0.0);
 f6 = i76 ? f6 : Math_fround(0.0);
 f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36))))));
 f35 = Math_fround(f30 * f35);
 f36 = Math_fround(f30 * f36);
 f6 = Math_fround(f30 * f6);
 f30 = Math_fround(-f35);
 f31 = Math_fround(-f36);
 f13 = Math_fround(-f6);
 i76 = i101 + 96 | 0;
 f9 = Math_fround(HEAPF32[i76 >> 2]);
 i77 = i101 + 100 | 0;
 f20 = Math_fround(HEAPF32[i77 >> 2]);
 i78 = i101 + 104 | 0;
 f5 = Math_fround(HEAPF32[i78 >> 2]);
 i79 = i101 + 112 | 0;
 f8 = Math_fround(HEAPF32[i79 >> 2]);
 i80 = i101 + 116 | 0;
 f7 = Math_fround(HEAPF32[i80 >> 2]);
 i81 = i101 + 120 | 0;
 f4 = Math_fround(HEAPF32[i81 >> 2]);
 i82 = i101 + 128 | 0;
 f32 = Math_fround(HEAPF32[i82 >> 2]);
 i83 = i101 + 132 | 0;
 f33 = Math_fround(HEAPF32[i83 >> 2]);
 i84 = i101 + 136 | 0;
 f34 = Math_fround(HEAPF32[i84 >> 2]);
 f22 = Math_fround(Math_fround(f5 * f13) + Math_fround(Math_fround(f9 * f30) + Math_fround(f20 * f31)));
 f21 = Math_fround(Math_fround(Math_fround(f8 * f30) + Math_fround(f7 * f31)) + Math_fround(f4 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f32 * f30) + Math_fround(f33 * f31)) + Math_fround(f34 * f13));
 i88 = f22 > f21 & f22 > f13;
 i86 = f21 > f13;
 f32 = i88 ? f9 : i86 ? f8 : f32;
 f33 = i88 ? f20 : i86 ? f7 : f33;
 f34 = i88 ? f5 : i86 ? f4 : f34;
 i86 = i3 + 96 | 0;
 f4 = Math_fround(HEAPF32[i86 >> 2]);
 i88 = i3 + 100 | 0;
 f5 = Math_fround(HEAPF32[i88 >> 2]);
 i89 = i3 + 104 | 0;
 f7 = Math_fround(HEAPF32[i89 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f35 * f4) + Math_fround(f36 * f5)) + Math_fround(f6 * f7));
 i72 = i3 + 112 | 0;
 f8 = Math_fround(HEAPF32[i72 >> 2]);
 i73 = i3 + 116 | 0;
 f9 = Math_fround(HEAPF32[i73 >> 2]);
 i61 = i3 + 120 | 0;
 f13 = Math_fround(HEAPF32[i61 >> 2]);
 i62 = f20 > Math_fround(Math_fround(Math_fround(f35 * f8) + Math_fround(f36 * f9)) + Math_fround(f6 * f13));
 f6 = i62 ? f4 : f8;
 f36 = i62 ? f5 : f9;
 f35 = i62 ? f7 : f13;
 f20 = Math_fround(f32 - f6);
 f21 = Math_fround(f33 - f36);
 f22 = Math_fround(f34 - f35);
 HEAPF32[i94 >> 2] = f20;
 i62 = i94 + 4 | 0;
 HEAPF32[i62 >> 2] = f21;
 i63 = i94 + 8 | 0;
 HEAPF32[i63 >> 2] = f22;
 i64 = i94 + 12 | 0;
 HEAPF32[i64 >> 2] = Math_fround(0.0);
 i65 = i94 + 16 | 0;
 HEAP32[i65 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i65 = i94 + 32 | 0;
 HEAP32[i65 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i65 = i94 + 48 | 0;
 HEAP32[i65 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 HEAPF32[i92 >> 2] = f32;
 i65 = i92 + 4 | 0;
 HEAPF32[i65 >> 2] = f33;
 i66 = i92 + 8 | 0;
 HEAPF32[i66 >> 2] = f34;
 HEAPF32[i92 + 12 >> 2] = Math_fround(0.0);
 i67 = i92 + 16 | 0;
 HEAP32[i67 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i67 = i92 + 32 | 0;
 HEAP32[i67 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i67 = i92 + 48 | 0;
 HEAP32[i67 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i67 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i67 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i67 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 HEAPF32[i93 >> 2] = f6;
 i67 = i93 + 4 | 0;
 HEAPF32[i67 >> 2] = f36;
 i68 = i93 + 8 | 0;
 HEAPF32[i68 >> 2] = f35;
 i69 = i93 + 12 | 0;
 HEAPF32[i69 >> 2] = Math_fround(0.0);
 i60 = i93 + 16 | 0;
 HEAP32[i60 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i60 = i93 + 32 | 0;
 HEAP32[i60 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 i60 = i93 + 48 | 0;
 HEAP32[i60 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 f35 = Math_fround(f2 + Math_fround(0.0));
 f36 = Math_fround(f35 * f35);
 f6 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f22 * f22));
 L1 : do if (f6 > Math_fround(0.0)) {
  i3 = i93 + 16 | 0;
  i37 = i93 + 20 | 0;
  i38 = i93 + 24 | 0;
  i39 = i93 + 28 | 0;
  i40 = i93 + 32 | 0;
  i41 = i93 + 36 | 0;
  i42 = i93 + 40 | 0;
  i43 = i93 + 44 | 0;
  i44 = i92 + 16 | 0;
  i45 = i92 + 20 | 0;
  i46 = i92 + 24 | 0;
  i47 = i94 + 16 | 0;
  i48 = i94 + 20 | 0;
  i49 = i94 + 24 | 0;
  i50 = i94 + 28 | 0;
  i51 = i92 + 32 | 0;
  i52 = i92 + 36 | 0;
  i53 = i92 + 40 | 0;
  i54 = i94 + 32 | 0;
  i55 = i94 + 36 | 0;
  i56 = i94 + 40 | 0;
  i57 = i94 + 44 | 0;
  i58 = i71 + 4 | 0;
  i59 = i71 + 8 | 0;
  i60 = i71 + 12 | 0;
  f10 = f20;
  f11 = f21;
  f12 = f22;
  f26 = f4;
  f27 = f5;
  f25 = f13;
  f34 = Math_fround(Math_fround(f14 * Math_fround(0.0)) + f15);
  f33 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f17);
  f32 = Math_fround(Math_fround(f19 * Math_fround(0.0)) + f18);
  f31 = Math_fround(0.0);
  f2 = f20;
  f4 = f21;
  f5 = f22;
  while (1) {
   f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f22 = Math_fround(f10 * f24);
   f23 = Math_fround(f11 * f24);
   f24 = Math_fround(f12 * f24);
   f107 = Math_fround(-f22);
   f106 = Math_fround(-f23);
   f13 = Math_fround(-f24);
   f21 = Math_fround(HEAPF32[i76 >> 2]);
   f18 = Math_fround(HEAPF32[i77 >> 2]);
   f17 = Math_fround(HEAPF32[i78 >> 2]);
   f20 = Math_fround(HEAPF32[i79 >> 2]);
   f16 = Math_fround(HEAPF32[i80 >> 2]);
   f19 = Math_fround(HEAPF32[i81 >> 2]);
   f28 = Math_fround(HEAPF32[i82 >> 2]);
   f29 = Math_fround(HEAPF32[i83 >> 2]);
   f30 = Math_fround(HEAPF32[i84 >> 2]);
   f109 = Math_fround(Math_fround(Math_fround(f21 * f107) + Math_fround(f18 * f106)) + Math_fround(f17 * f13));
   f15 = Math_fround(Math_fround(Math_fround(f20 * f107) + Math_fround(f16 * f106)) + Math_fround(f19 * f13));
   f14 = Math_fround(Math_fround(Math_fround(f28 * f107) + Math_fround(f29 * f106)) + Math_fround(f30 * f13));
   i108 = f109 > f15 & f109 > f14;
   i1 = f15 > f14;
   f28 = i108 ? f21 : i1 ? f20 : f28;
   f29 = i108 ? f18 : i1 ? f16 : f29;
   f30 = i108 ? f17 : i1 ? f19 : f30;
   i1 = Math_fround(Math_fround(Math_fround(f22 * f26) + Math_fround(f23 * f27)) + Math_fround(f24 * f7)) > Math_fround(Math_fround(Math_fround(f22 * f8) + Math_fround(f23 * f9)) + Math_fround(f24 * f25));
   f19 = Math_fround(f34 + (i1 ? f26 : f8));
   f17 = Math_fround(f33 + (i1 ? f27 : f9));
   f16 = Math_fround(f32 + (i1 ? f7 : f25));
   f18 = Math_fround(f28 - f19);
   f20 = Math_fround(f29 - f17);
   f21 = Math_fround(f30 - f16);
   f7 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(Math_fround(f22 * f18) + Math_fround(f23 * f20))) - f35);
   f9 = Math_fround(HEAPF32[i90 >> 2]);
   f14 = Math_fround(HEAPF32[i74 >> 2]);
   f15 = Math_fround(HEAPF32[i75 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f9 * f107) + Math_fround(f14 * f106)) + Math_fround(f15 * f13));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f31 - Math_fround(f7 / f8));
    HEAP32[i95 >> 2] = HEAP32[i70 >> 2];
    HEAP32[i95 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
    HEAP32[i95 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
    if (f13 > f31) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f20 = Math_fround(HEAPF32[i91 >> 2]);
     f21 = Math_fround(HEAPF32[i85 >> 2]);
     f20 = Math_fround(Math_fround(f13 * f9) + f20);
     f21 = Math_fround(Math_fround(f13 * f14) + f21);
     f5 = Math_fround(Math_fround(f13 * f15) + Math_fround(HEAPF32[i87 >> 2]));
     f107 = Math_fround(f20 - f34);
     f109 = Math_fround(f21 - f33);
     f16 = Math_fround(f5 - f32);
     f2 = Math_fround(HEAPF32[i93 >> 2]);
     f4 = Math_fround(HEAPF32[i67 >> 2]);
     f2 = Math_fround(f107 + f2);
     f4 = Math_fround(f109 + f4);
     f7 = Math_fround(f16 + Math_fround(HEAPF32[i68 >> 2]));
     f8 = Math_fround(HEAPF32[i3 >> 2]);
     f9 = Math_fround(HEAPF32[i37 >> 2]);
     f8 = Math_fround(f107 + f8);
     f9 = Math_fround(f109 + f9);
     f18 = Math_fround(f16 + Math_fround(HEAPF32[i38 >> 2]));
     f19 = Math_fround(HEAPF32[i40 >> 2]);
     f17 = Math_fround(HEAPF32[i41 >> 2]);
     f19 = Math_fround(f107 + f19);
     f17 = Math_fround(f109 + f17);
     f16 = Math_fround(f16 + Math_fround(HEAPF32[i42 >> 2]));
     HEAPF32[i93 >> 2] = f2;
     HEAPF32[i67 >> 2] = f4;
     HEAPF32[i68 >> 2] = f7;
     HEAPF32[i69 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f8;
     HEAPF32[i37 >> 2] = f9;
     HEAPF32[i38 >> 2] = f18;
     HEAPF32[i39 >> 2] = Math_fround(0.0);
     HEAPF32[i40 >> 2] = f19;
     HEAPF32[i41 >> 2] = f17;
     HEAPF32[i42 >> 2] = f16;
     HEAPF32[i43 >> 2] = Math_fround(0.0);
     f109 = Math_fround(HEAPF32[i92 >> 2]);
     f107 = Math_fround(HEAPF32[i65 >> 2]);
     f4 = Math_fround(f107 - f4);
     f7 = Math_fround(Math_fround(HEAPF32[i66 >> 2]) - f7);
     HEAPF32[i94 >> 2] = Math_fround(f109 - f2);
     HEAPF32[i62 >> 2] = f4;
     HEAPF32[i63 >> 2] = f7;
     HEAPF32[i64 >> 2] = Math_fround(0.0);
     f7 = Math_fround(HEAPF32[i44 >> 2]);
     f4 = Math_fround(HEAPF32[i45 >> 2]);
     f9 = Math_fround(f4 - f9);
     f18 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f18);
     HEAPF32[i47 >> 2] = Math_fround(f7 - f8);
     HEAPF32[i48 >> 2] = f9;
     HEAPF32[i49 >> 2] = f18;
     HEAPF32[i50 >> 2] = Math_fround(0.0);
     f18 = Math_fround(HEAPF32[i51 >> 2]);
     f9 = Math_fround(HEAPF32[i52 >> 2]);
     f17 = Math_fround(f9 - f17);
     f16 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f16);
     HEAPF32[i54 >> 2] = Math_fround(f18 - f19);
     HEAPF32[i55 >> 2] = f17;
     HEAPF32[i56 >> 2] = f16;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     f16 = Math_fround(HEAPF32[i86 >> 2]);
     f17 = Math_fround(HEAPF32[i88 >> 2]);
     f19 = Math_fround(HEAPF32[i89 >> 2]);
     f18 = Math_fround(Math_fround(Math_fround(f22 * f16) + Math_fround(f23 * f17)) + Math_fround(f24 * f19));
     f9 = Math_fround(HEAPF32[i72 >> 2]);
     f8 = Math_fround(HEAPF32[i73 >> 2]);
     f7 = Math_fround(HEAPF32[i61 >> 2]);
     i108 = f18 > Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f23 * f8)) + Math_fround(f24 * f7));
     f9 = Math_fround(f20 + (i108 ? f16 : f9));
     f8 = Math_fround(f21 + (i108 ? f17 : f8));
     f7 = Math_fround(f5 + (i108 ? f19 : f7));
     f19 = f9;
     f17 = f8;
     f16 = f7;
     f9 = Math_fround(f28 - f9);
     f8 = Math_fround(f29 - f8);
     f7 = Math_fround(f30 - f7);
     f18 = Math_fround(3402823469999999843913219.0e14);
     f22 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f18;
     f8 = f20;
     f7 = f21;
     f18 = f6;
     f22 = f32;
     f21 = f33;
     f20 = f34;
    }
   } else {
    f9 = f18;
    f8 = f20;
    f7 = f21;
    f18 = f6;
    f13 = f31;
    f22 = f32;
    f21 = f33;
    f20 = f34;
   }
   i108 = HEAP32[i99 >> 2] | 0;
   HEAPF32[i92 + (i108 << 4) >> 2] = f28;
   HEAPF32[i92 + (i108 << 4) + 4 >> 2] = f29;
   HEAPF32[i92 + (i108 << 4) + 8 >> 2] = f30;
   HEAPF32[i92 + (i108 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i93 + (i108 << 4) >> 2] = f19;
   HEAPF32[i93 + (i108 << 4) + 4 >> 2] = f17;
   HEAPF32[i93 + (i108 << 4) + 8 >> 2] = f16;
   HEAPF32[i93 + (i108 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i99 >> 2] = i108 + 1;
   HEAPF32[i94 + (i108 << 4) >> 2] = f9;
   HEAPF32[i94 + (i108 << 4) + 4 >> 2] = f8;
   HEAPF32[i94 + (i108 << 4) + 8 >> 2] = f7;
   HEAPF32[i94 + (i108 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i108 | 0) {
   case 0:
    {
     HEAPF32[i71 >> 2] = f9;
     HEAPF32[i58 >> 2] = f8;
     HEAPF32[i59 >> 2] = f7;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i94 >> 2]);
     f7 = Math_fround(HEAPF32[i62 >> 2]);
     f8 = Math_fround(HEAPF32[i63 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f106 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i108 = f106 > Math_fround(1.0);
      f106 = i108 ? Math_fround(1.0) : f106;
      i108 = f106 > Math_fround(0.0);
      f106 = i108 ? f106 : Math_fround(0.0);
      f107 = Math_fround(f7 + Math_fround(f14 * f106));
      f109 = Math_fround(f8 + Math_fround(f15 * f106));
      HEAPF32[i71 >> 2] = Math_fround(f6 + Math_fround(f9 * f106));
      HEAPF32[i58 >> 2] = f107;
      HEAPF32[i59 >> 2] = f109;
      HEAPF32[i60 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i99 >> 2] = 1;
      HEAP32[i71 >> 2] = HEAP32[i94 >> 2];
      HEAP32[i71 + 4 >> 2] = HEAP32[i94 + 4 >> 2];
      HEAP32[i71 + 8 >> 2] = HEAP32[i94 + 8 >> 2];
      HEAP32[i71 + 12 >> 2] = HEAP32[i94 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i71, i94, i92, i93, i99);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i71, i94, i92, i93, i99);
     break;
    }
   default:
    {
     HEAPF32[i71 >> 2] = f9;
     HEAPF32[i58 >> 2] = f8;
     HEAPF32[i59 >> 2] = f7;
     HEAPF32[i60 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i71 >> 2]);
   f8 = Math_fround(HEAPF32[i58 >> 2]);
   f9 = Math_fround(HEAPF32[i59 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f18 > f6;
   if (!(f6 > f36 & i1)) break L1;
   f26 = Math_fround(HEAPF32[i86 >> 2]);
   f27 = Math_fround(HEAPF32[i88 >> 2]);
   f33 = Math_fround(HEAPF32[i89 >> 2]);
   f34 = Math_fround(HEAPF32[i72 >> 2]);
   f25 = Math_fround(HEAPF32[i73 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = f33;
   f8 = f34;
   f9 = f25;
   f25 = Math_fround(HEAPF32[i61 >> 2]);
   f34 = f20;
   f33 = f21;
   f32 = f22;
   f31 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i105;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f22;
  f11 = f21;
  f10 = f20;
  f9 = f22;
  f8 = f21;
  f7 = f20;
  i1 = 1;
  f5 = f22;
  f4 = f21;
  f2 = f20;
 } while (0);
 i90 = HEAP32[i101 + 64 >> 2] | 0;
 i91 = HEAP32[i101 + 68 >> 2] | 0;
 i108 = HEAP32[i101 + 72 >> 2] | 0;
 i89 = f6 > Math_fround(0.0) & i1;
 f34 = i89 ? f7 : f2;
 f36 = i89 ? f8 : f4;
 f107 = i89 ? f9 : f5;
 f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f107 * f107) + Math_fround(Math_fround(f36 * f36) + Math_fround(f34 * f34))))));
 f34 = Math_fround(f34 * f33);
 f36 = Math_fround(f36 * f33);
 f33 = Math_fround(f107 * f33);
 HEAPF32[i104 >> 2] = f34;
 HEAPF32[i104 + 4 >> 2] = f36;
 HEAPF32[i104 + 8 >> 2] = f33;
 HEAPF32[i104 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i103 >> 2] = f13;
 i104 = i103 + 4 | 0;
 HEAP32[i104 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i104 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i104 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAPF32[i98 >> 2] = i1 ? f7 : f10;
 HEAPF32[i98 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i98 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i98 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i96 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i96 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i96 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i96 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 HEAP32[i97 >> 2] = HEAP32[i100 >> 2];
 HEAP32[i97 + 4 >> 2] = HEAP32[i100 + 4 >> 2];
 HEAP32[i97 + 8 >> 2] = HEAP32[i100 + 8 >> 2];
 HEAP32[i97 + 12 >> 2] = HEAP32[i100 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i94, i92, i93, i98, i96, i97, HEAP32[i99 >> 2] | 0);
 f107 = Math_fround(HEAPF32[i101 + 16 >> 2]);
 f35 = Math_fround(HEAPF32[i96 >> 2]);
 f106 = Math_fround(HEAPF32[i96 + 4 >> 2]);
 f109 = Math_fround(HEAPF32[i96 + 8 >> 2]);
 f34 = Math_fround(f35 - Math_fround(f34 * f107));
 f36 = Math_fround(f106 - Math_fround(f36 * f107));
 f107 = Math_fround(f109 - Math_fround(f33 * f107));
 HEAPF32[i102 >> 2] = i90 | 0 ? f34 : f35;
 HEAPF32[i102 + 4 >> 2] = i91 | 0 ? f36 : f106;
 HEAPF32[i102 + 8 >> 2] = i108 | 0 ? f107 : f109;
 HEAPF32[i102 + 12 >> 2] = Math_fround(0.0);
 i108 = 1;
 STACKTOP = i105;
 return i108 | 0;
}

function __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i108, i95, i1, i97, i96, i110, i111, i109, f2) {
 i108 = i108 | 0;
 i95 = i95 | 0;
 i1 = i1 | 0;
 i97 = i97 | 0;
 i96 = i96 | 0;
 i110 = i110 | 0;
 i111 = i111 | 0;
 i109 = i109 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, f98 = f0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i112 = 0, f113 = f0, i114 = 0;
 i112 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i107 = i112 + 288 | 0;
 i102 = i112 + 384 | 0;
 i106 = i112 + 380 | 0;
 i74 = i112 + 144 | 0;
 i70 = i112 + 128 | 0;
 i101 = i112 + 304 | 0;
 i99 = i112 + 224 | 0;
 i100 = i112 + 160 | 0;
 i72 = i112 + 112 | 0;
 i73 = i112 + 96 | 0;
 i71 = i112 + 368 | 0;
 i81 = i112 + 80 | 0;
 i82 = i112 + 64 | 0;
 i83 = i112 + 48 | 0;
 i105 = i112 + 32 | 0;
 i103 = i112 + 16 | 0;
 i104 = i112;
 HEAP32[i107 >> 2] = 0;
 HEAP32[i107 + 4 >> 2] = 0;
 HEAP32[i107 + 8 >> 2] = 0;
 HEAP32[i107 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i96 >> 2]);
 i88 = i96 + 4 | 0;
 f8 = Math_fround(HEAPF32[i88 >> 2]);
 i94 = i96 + 8 | 0;
 f13 = Math_fround(HEAPF32[i94 >> 2]);
 f4 = Math_fround(HEAPF32[i97 >> 2]);
 i77 = i97 + 4 | 0;
 f7 = Math_fround(HEAPF32[i77 >> 2]);
 i80 = i97 + 8 | 0;
 f9 = Math_fround(HEAPF32[i80 >> 2]);
 HEAP32[i106 >> 2] = 1;
 f6 = Math_fround(HEAPF32[i108 >> 2]);
 f30 = Math_fround(HEAPF32[i108 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i108 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i95 >> 2]);
 f26 = Math_fround(HEAPF32[i95 + 4 >> 2]);
 f25 = Math_fround(f6 - f25);
 f26 = Math_fround(f30 - f26);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i95 + 8 >> 2]));
 i84 = Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26)) + Math_fround(f29 * f29)) > Math_fround(1.1920929e-07);
 f25 = i84 ? f25 : Math_fround(1.0);
 f26 = i84 ? f26 : Math_fround(0.0);
 f29 = i84 ? f29 : Math_fround(0.0);
 f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
 f25 = Math_fround(f30 * f25);
 f26 = Math_fround(f30 * f26);
 f29 = Math_fround(f30 * f29);
 HEAPF32[i74 >> 2] = f25;
 HEAPF32[i74 + 4 >> 2] = f26;
 HEAPF32[i74 + 8 >> 2] = f29;
 HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
 f25 = Math_fround(-f25);
 f26 = Math_fround(-f26);
 f29 = Math_fround(-f29);
 i84 = i108 + 96 | 0;
 f30 = Math_fround(HEAPF32[i84 >> 2]);
 i85 = i108 + 100 | 0;
 f6 = Math_fround(HEAPF32[i85 >> 2]);
 i86 = i108 + 104 | 0;
 f15 = Math_fround(HEAPF32[i86 >> 2]);
 i87 = i108 + 112 | 0;
 f31 = Math_fround(HEAPF32[i87 >> 2]);
 i89 = i108 + 116 | 0;
 f16 = Math_fround(HEAPF32[i89 >> 2]);
 i90 = i108 + 120 | 0;
 f14 = Math_fround(HEAPF32[i90 >> 2]);
 i91 = i108 + 128 | 0;
 f33 = Math_fround(HEAPF32[i91 >> 2]);
 i92 = i108 + 132 | 0;
 f32 = Math_fround(HEAPF32[i92 >> 2]);
 i93 = i108 + 136 | 0;
 f98 = Math_fround(HEAPF32[i93 >> 2]);
 f27 = Math_fround(Math_fround(Math_fround(f30 * f25) + Math_fround(f6 * f26)) + Math_fround(f15 * f29));
 f28 = Math_fround(Math_fround(Math_fround(f31 * f25) + Math_fround(f16 * f26)) + Math_fround(f14 * f29));
 f29 = Math_fround(Math_fround(Math_fround(f33 * f25) + Math_fround(f32 * f26)) + Math_fround(f98 * f29));
 i76 = f27 > f28 & f27 > f29;
 i75 = f28 > f29;
 f33 = i76 ? f30 : i75 ? f31 : f33;
 f32 = i76 ? f6 : i75 ? f16 : f32;
 f98 = i76 ? f15 : i75 ? f14 : f98;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i70, i95, i74);
 f14 = Math_fround(HEAPF32[i70 >> 2]);
 f15 = Math_fround(HEAPF32[i70 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f98 - Math_fround(HEAPF32[i70 + 8 >> 2]));
 HEAPF32[i101 >> 2] = f14;
 i74 = i101 + 4 | 0;
 HEAPF32[i74 >> 2] = f15;
 i75 = i101 + 8 | 0;
 HEAPF32[i75 >> 2] = f16;
 i76 = i101 + 12 | 0;
 HEAPF32[i76 >> 2] = Math_fround(0.0);
 i78 = i101 + 16 | 0;
 HEAP32[i78 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i78 = i101 + 32 | 0;
 HEAP32[i78 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i78 = i101 + 48 | 0;
 HEAP32[i78 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i78 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i78 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i78 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAPF32[i99 >> 2] = f33;
 i78 = i99 + 4 | 0;
 HEAPF32[i78 >> 2] = f32;
 i79 = i99 + 8 | 0;
 HEAPF32[i79 >> 2] = f98;
 HEAPF32[i99 + 12 >> 2] = Math_fround(0.0);
 i69 = i99 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i69 = i99 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i69 = i99 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAP32[i100 >> 2] = HEAP32[i70 >> 2];
 HEAP32[i100 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
 HEAP32[i100 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
 HEAP32[i100 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
 i70 = i100 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i70 = i100 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 i70 = i100 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 f98 = Math_fround(HEAPF32[i95 + 32 >> 2]);
 i70 = f98 < Math_fround(3402823469999999843913219.0e14);
 f98 = Math_fround(f98 * Math_fround(.100000001));
 f98 = i70 ? f98 : Math_fround(3402823469999999938360549.0e13);
 f32 = Math_fround(f98 + f2);
 f98 = Math_fround(f98 * f98);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f98) {
  i3 = i73 + 4 | 0;
  i34 = i73 + 8 | 0;
  i35 = i73 + 12 | 0;
  i36 = i72 + 4 | 0;
  i37 = i72 + 8 | 0;
  i38 = i100 + 4 | 0;
  i39 = i100 + 8 | 0;
  i40 = i100 + 12 | 0;
  i41 = i100 + 16 | 0;
  i42 = i100 + 20 | 0;
  i43 = i100 + 24 | 0;
  i44 = i100 + 28 | 0;
  i45 = i100 + 32 | 0;
  i46 = i100 + 36 | 0;
  i47 = i100 + 40 | 0;
  i48 = i100 + 44 | 0;
  i49 = i99 + 16 | 0;
  i50 = i99 + 20 | 0;
  i51 = i99 + 24 | 0;
  i52 = i101 + 16 | 0;
  i53 = i101 + 20 | 0;
  i54 = i101 + 24 | 0;
  i55 = i101 + 28 | 0;
  i56 = i99 + 32 | 0;
  i57 = i99 + 36 | 0;
  i58 = i99 + 40 | 0;
  i59 = i101 + 32 | 0;
  i60 = i101 + 36 | 0;
  i61 = i101 + 40 | 0;
  i62 = i101 + 44 | 0;
  i63 = i82 + 4 | 0;
  i64 = i82 + 8 | 0;
  i65 = i82 + 12 | 0;
  i66 = i81 + 4 | 0;
  i67 = i81 + 8 | 0;
  i68 = i83 + 4 | 0;
  i69 = i83 + 8 | 0;
  i70 = i83 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f113 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f24 = Math_fround(HEAPF32[i84 >> 2]);
   f22 = Math_fround(HEAPF32[i85 >> 2]);
   f20 = Math_fround(HEAPF32[i86 >> 2]);
   f23 = Math_fround(HEAPF32[i87 >> 2]);
   f21 = Math_fround(HEAPF32[i89 >> 2]);
   f16 = Math_fround(HEAPF32[i90 >> 2]);
   f25 = Math_fround(HEAPF32[i91 >> 2]);
   f26 = Math_fround(HEAPF32[i92 >> 2]);
   f27 = Math_fround(HEAPF32[i93 >> 2]);
   f18 = Math_fround(Math_fround(Math_fround(f24 * f113) + Math_fround(f22 * f13)) + Math_fround(f20 * f8));
   f17 = Math_fround(Math_fround(Math_fround(f23 * f113) + Math_fround(f21 * f13)) + Math_fround(f16 * f8));
   f7 = Math_fround(Math_fround(Math_fround(f25 * f113) + Math_fround(f26 * f13)) + Math_fround(f27 * f8));
   i114 = f18 > f17 & f18 > f7;
   i1 = f17 > f7;
   f25 = i114 ? f24 : i1 ? f23 : f25;
   f26 = i114 ? f22 : i1 ? f21 : f26;
   f27 = i114 ? f20 : i1 ? f16 : f27;
   HEAPF32[i73 >> 2] = f9;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i34 >> 2] = f15;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i72, i95, i73);
   f16 = Math_fround(HEAPF32[i72 >> 2]);
   f20 = Math_fround(HEAPF32[i36 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i37 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23))) - f32);
   f17 = Math_fround(HEAPF32[i96 >> 2]);
   f18 = Math_fround(HEAPF32[i88 >> 2]);
   f19 = Math_fround(HEAPF32[i94 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f113) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i102 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i102 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i102 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f8 = Math_fround(HEAPF32[i97 >> 2]);
     f113 = Math_fround(HEAPF32[i77 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f8);
     f18 = Math_fround(Math_fround(f13 * f18) + f113);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i80 >> 2]));
     f31 = Math_fround(f17 - f31);
     f113 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i100 >> 2]);
     f4 = Math_fround(HEAPF32[i38 >> 2]);
     f2 = Math_fround(f31 + f2);
     f4 = Math_fround(f113 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f22 = Math_fround(HEAPF32[i41 >> 2]);
     f21 = Math_fround(HEAPF32[i42 >> 2]);
     f22 = Math_fround(f31 + f22);
     f21 = Math_fround(f113 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i43 >> 2]));
     f16 = Math_fround(HEAPF32[i45 >> 2]);
     f7 = Math_fround(HEAPF32[i46 >> 2]);
     f16 = Math_fround(f31 + f16);
     f7 = Math_fround(f113 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i47 >> 2]));
     HEAPF32[i100 >> 2] = f2;
     HEAPF32[i38 >> 2] = f4;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     HEAPF32[i41 >> 2] = f22;
     HEAPF32[i42 >> 2] = f21;
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = Math_fround(0.0);
     HEAPF32[i45 >> 2] = f16;
     HEAPF32[i46 >> 2] = f7;
     HEAPF32[i47 >> 2] = f8;
     HEAPF32[i48 >> 2] = Math_fround(0.0);
     f113 = Math_fround(HEAPF32[i99 >> 2]);
     f31 = Math_fround(HEAPF32[i78 >> 2]);
     f4 = Math_fround(f31 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i79 >> 2]) - f5);
     HEAPF32[i101 >> 2] = Math_fround(f113 - f2);
     HEAPF32[i74 >> 2] = f4;
     HEAPF32[i75 >> 2] = f5;
     HEAPF32[i76 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i49 >> 2]);
     f4 = Math_fround(HEAPF32[i50 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f20);
     HEAPF32[i52 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i53 >> 2] = f21;
     HEAPF32[i54 >> 2] = f20;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i56 >> 2]);
     f21 = Math_fround(HEAPF32[i57 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f8);
     HEAPF32[i59 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i60 >> 2] = f7;
     HEAPF32[i61 >> 2] = f8;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i82 >> 2] = f9;
     HEAPF32[i63 >> 2] = f14;
     HEAPF32[i64 >> 2] = f15;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i81, i95, i82);
     f9 = Math_fround(HEAPF32[i81 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i67 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i114 = HEAP32[i106 >> 2] | 0;
   HEAPF32[i99 + (i114 << 4) >> 2] = f25;
   HEAPF32[i99 + (i114 << 4) + 4 >> 2] = f26;
   HEAPF32[i99 + (i114 << 4) + 8 >> 2] = f27;
   HEAPF32[i99 + (i114 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i100 + (i114 << 4) >> 2] = f16;
   HEAPF32[i100 + (i114 << 4) + 4 >> 2] = f20;
   HEAPF32[i100 + (i114 << 4) + 8 >> 2] = f21;
   HEAPF32[i100 + (i114 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i106 >> 2] = i114 + 1;
   HEAPF32[i101 + (i114 << 4) >> 2] = f9;
   HEAPF32[i101 + (i114 << 4) + 4 >> 2] = f8;
   HEAPF32[i101 + (i114 << 4) + 8 >> 2] = f7;
   HEAPF32[i101 + (i114 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i114 | 0) {
   case 0:
    {
     HEAPF32[i83 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i101 >> 2]);
     f7 = Math_fround(HEAPF32[i74 >> 2]);
     f8 = Math_fround(HEAPF32[i75 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f30 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i114 = f30 > Math_fround(1.0);
      f30 = i114 ? Math_fround(1.0) : f30;
      i114 = f30 > Math_fround(0.0);
      f30 = i114 ? f30 : Math_fround(0.0);
      f31 = Math_fround(f7 + Math_fround(f14 * f30));
      f113 = Math_fround(f8 + Math_fround(f15 * f30));
      HEAPF32[i83 >> 2] = Math_fround(f6 + Math_fround(f9 * f30));
      HEAPF32[i68 >> 2] = f31;
      HEAPF32[i69 >> 2] = f113;
      HEAPF32[i70 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i106 >> 2] = 1;
      HEAP32[i83 >> 2] = HEAP32[i101 >> 2];
      HEAP32[i83 + 4 >> 2] = HEAP32[i101 + 4 >> 2];
      HEAP32[i83 + 8 >> 2] = HEAP32[i101 + 8 >> 2];
      HEAP32[i83 + 12 >> 2] = HEAP32[i101 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i83, i101, i99, i100, i106);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i83, i101, i99, i100, i106);
     break;
    }
   default:
    {
     HEAPF32[i83 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i83 >> 2]);
   f8 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i112;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i96 = HEAP32[i108 + 64 >> 2] | 0;
 i97 = HEAP32[i108 + 68 >> 2] | 0;
 i114 = HEAP32[i108 + 72 >> 2] | 0;
 i95 = f6 > f98 & i1;
 f30 = i95 ? f7 : f2;
 f32 = i95 ? f8 : f4;
 f98 = i95 ? f9 : f5;
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f98 * f98) + Math_fround(Math_fround(f32 * f32) + Math_fround(f30 * f30))))));
 f30 = Math_fround(f30 * f29);
 f32 = Math_fround(f32 * f29);
 f29 = Math_fround(f98 * f29);
 HEAPF32[i111 >> 2] = f30;
 HEAPF32[i111 + 4 >> 2] = f32;
 HEAPF32[i111 + 8 >> 2] = f29;
 HEAPF32[i111 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i110 >> 2] = f13;
 i111 = i110 + 4 | 0;
 HEAP32[i111 >> 2] = HEAP32[i102 >> 2];
 HEAP32[i111 + 4 >> 2] = HEAP32[i102 + 4 >> 2];
 HEAP32[i111 + 8 >> 2] = HEAP32[i102 + 8 >> 2];
 HEAPF32[i105 >> 2] = i1 ? f7 : f10;
 HEAPF32[i105 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i105 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i105 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i103 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i103 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i103 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i103 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 HEAP32[i104 >> 2] = HEAP32[i107 >> 2];
 HEAP32[i104 + 4 >> 2] = HEAP32[i107 + 4 >> 2];
 HEAP32[i104 + 8 >> 2] = HEAP32[i107 + 8 >> 2];
 HEAP32[i104 + 12 >> 2] = HEAP32[i107 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i101, i99, i100, i105, i103, i104, HEAP32[i106 >> 2] | 0);
 f98 = Math_fround(HEAPF32[i108 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i103 >> 2]);
 f33 = Math_fround(HEAPF32[i103 + 4 >> 2]);
 f113 = Math_fround(HEAPF32[i103 + 8 >> 2]);
 f30 = Math_fround(f31 - Math_fround(f30 * f98));
 f32 = Math_fround(f33 - Math_fround(f32 * f98));
 f98 = Math_fround(f113 - Math_fround(f29 * f98));
 HEAPF32[i109 >> 2] = i96 | 0 ? f30 : f31;
 HEAPF32[i109 + 4 >> 2] = i97 | 0 ? f32 : f33;
 HEAPF32[i109 + 8 >> 2] = i114 | 0 ? f98 : f113;
 HEAPF32[i109 + 12 >> 2] = Math_fround(0.0);
 i114 = 1;
 STACKTOP = i112;
 return i114 | 0;
}

function _PxBuildSmoothNormals(i22, i27, i23, i19, i20, i28, i2) {
 i22 = i22 | 0;
 i27 = i27 | 0;
 i23 = i23 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i29 + 14 | 0;
 i21 = i29;
 i24 = i29 + 13 | 0;
 i25 = i29 + 12 | 0;
 if (!((i27 | 0) != 0 & ((i22 | 0) != 0 & ((i23 | 0) != 0 & (i28 | 0) != 0)))) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i26 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i29 + 15 | 0, i22 * 12 | 0, gb + 745592 | 0, 59) | 0;
 if (!i26) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i12 = i2 ? 2 : 1;
 i10 = (i2 << 31 >> 31) + 2 | 0;
 i8 = (i20 | 0) == 0;
 if (!i19) {
  i9 = 0;
  do {
   i2 = i9 * 3 | 0;
   if (i8) {
    i6 = 2;
    i7 = 0;
    i2 = 1;
   } else {
    i6 = HEAPU16[i20 + (i10 + i2 << 1) >> 1] | 0;
    i7 = HEAPU16[i20 + (i2 << 1) >> 1] | 0;
    i2 = HEAPU16[i20 + (i12 + i2 << 1) >> 1] | 0;
   }
   f31 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) >> 2]);
   f31 = Math_fround(f31 - f4);
   f5 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 4 >> 2]);
   f5 = Math_fround(f5 - f30);
   f32 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 8 >> 2]);
   f3 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 8 >> 2]);
   f32 = Math_fround(f32 - f3);
   f4 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]) - f4);
   f30 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]) - f30);
   f3 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]) - f3);
   f1 = Math_fround(Math_fround(f5 * f3) - Math_fround(f32 * f30));
   f3 = Math_fround(Math_fround(f32 * f4) - Math_fround(f31 * f3));
   f4 = Math_fround(Math_fround(f31 * f30) - Math_fround(f5 * f4));
   i2 = i26 + (i9 * 12 | 0) | 0;
   HEAPF32[i2 >> 2] = f1;
   i6 = i26 + (i9 * 12 | 0) + 4 | 0;
   HEAPF32[i6 >> 2] = f3;
   i7 = i26 + (i9 * 12 | 0) + 8 | 0;
   HEAPF32[i7 >> 2] = f4;
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3)) + Math_fround(f4 * f4))));
   if (f5 > Math_fround(0.0)) {
    f32 = Math_fround(Math_fround(1.0) / f5);
    HEAPF32[i2 >> 2] = Math_fround(f1 * f32);
    HEAPF32[i6 >> 2] = Math_fround(f3 * f32);
    HEAPF32[i7 >> 2] = Math_fround(f4 * f32);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i22 | 0));
 } else {
  i8 = 0;
  do {
   i7 = i8 * 3 | 0;
   i6 = HEAP32[i19 + (i7 << 2) >> 2] | 0;
   i2 = HEAP32[i19 + (i12 + i7 << 2) >> 2] | 0;
   i7 = HEAP32[i19 + (i10 + i7 << 2) >> 2] | 0;
   f31 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) >> 2]);
   f1 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) >> 2]);
   f3 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 4 >> 2]);
   f32 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 8 >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f31 = Math_fround(f31 - f1);
   f3 = Math_fround(f3 - f32);
   f30 = Math_fround(f30 - f5);
   f1 = Math_fround(f33 - f1);
   f32 = Math_fround(f4 - f32);
   f5 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]) - f5);
   f4 = Math_fround(Math_fround(f3 * f5) - Math_fround(f30 * f32));
   f5 = Math_fround(Math_fround(f30 * f1) - Math_fround(f31 * f5));
   f1 = Math_fround(Math_fround(f31 * f32) - Math_fround(f3 * f1));
   i2 = i26 + (i8 * 12 | 0) | 0;
   HEAPF32[i2 >> 2] = f4;
   i6 = i26 + (i8 * 12 | 0) + 4 | 0;
   HEAPF32[i6 >> 2] = f5;
   i7 = i26 + (i8 * 12 | 0) + 8 | 0;
   HEAPF32[i7 >> 2] = f1;
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f1 * f1))));
   if (f3 > Math_fround(0.0)) {
    f33 = Math_fround(Math_fround(1.0) / f3);
    HEAPF32[i2 >> 2] = Math_fround(f4 * f33);
    HEAPF32[i6 >> 2] = Math_fround(f5 * f33);
    HEAPF32[i7 >> 2] = Math_fround(f1 * f33);
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i22 | 0));
 }
 i9 = i27 * 12 | 0;
 _memset(i28 | 0, 0, i9 | 0) | 0;
 i18 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11, i9, gb + 745592 | 0, 85) | 0;
 _memset(i18 | 0, 0, i9 | 0) | 0;
 i9 = (i19 | 0) == 0;
 i10 = (i20 | 0) == 0;
 i15 = 0;
 do {
  if (i9) if (i10) {
   i2 = 0;
   i8 = 1;
   i14 = 2;
  } else {
   i14 = i15 * 3 | 0;
   i2 = HEAPU16[i20 + (i14 << 1) >> 1] | 0;
   i8 = HEAPU16[i20 + (i14 + 1 << 1) >> 1] | 0;
   i14 = HEAPU16[i20 + (i14 + 2 << 1) >> 1] | 0;
  } else {
   i14 = i15 * 3 | 0;
   i2 = HEAP32[i19 + (i14 << 2) >> 2] | 0;
   i8 = HEAP32[i19 + (i14 + 1 << 2) >> 2] | 0;
   i14 = HEAP32[i19 + (i14 + 2 << 2) >> 2] | 0;
  }
  i11 = i26 + (i15 * 12 | 0) | 0;
  i12 = i26 + (i15 * 12 | 0) + 4 | 0;
  i13 = i26 + (i15 * 12 | 0) + 8 | 0;
  if (Math_fround(HEAPF32[i18 + (i2 * 12 | 0) >> 2]) == Math_fround(0.0)) {
   i6 = i18 + (i2 * 12 | 0) + 4 | 0;
   if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0)) {
    i7 = i18 + (i2 * 12 | 0) + 8 | 0;
    if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(0.0)) {
     HEAP32[i18 + (i2 * 12 | 0) >> 2] = HEAP32[i11 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
    }
   }
  }
  if (Math_fround(HEAPF32[i18 + (i8 * 12 | 0) >> 2]) == Math_fround(0.0)) {
   i2 = i18 + (i8 * 12 | 0) + 4 | 0;
   if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) {
    i6 = i18 + (i8 * 12 | 0) + 8 | 0;
    if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0)) {
     HEAP32[i18 + (i8 * 12 | 0) >> 2] = HEAP32[i11 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
    }
   }
  }
  if (Math_fround(HEAPF32[i18 + (i14 * 12 | 0) >> 2]) == Math_fround(0.0)) {
   i2 = i18 + (i14 * 12 | 0) + 4 | 0;
   if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) {
    i6 = i18 + (i14 * 12 | 0) + 8 | 0;
    if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0)) {
     HEAP32[i18 + (i14 * 12 | 0) >> 2] = HEAP32[i11 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
    }
   }
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != (i22 | 0));
 i15 = (i20 | 0) == 0;
 i16 = i21 + 4 | 0;
 i17 = i21 + 8 | 0;
 if (!i19) {
  i14 = 0;
  do {
   if (i15) {
    HEAP32[i21 >> 2] = 0;
    HEAP32[i16 >> 2] = 1;
    i7 = 2;
    i2 = 0;
    i6 = 1;
   } else {
    i7 = i14 * 3 | 0;
    i2 = HEAPU16[i20 + (i7 << 1) >> 1] | 0;
    HEAP32[i21 >> 2] = i2;
    i6 = HEAPU16[i20 + (i7 + 1 << 1) >> 1] | 0;
    HEAP32[i16 >> 2] = i6;
    i7 = HEAPU16[i20 + (i7 + 2 << 1) >> 1] | 0;
   }
   HEAP32[i17 >> 2] = i7;
   i8 = i23 + (i7 * 12 | 0) | 0;
   f33 = Math_fround(HEAPF32[i8 >> 2]);
   f31 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f33 = Math_fround(f33 - f31);
   i9 = i23 + (i7 * 12 | 0) + 4 | 0;
   f32 = Math_fround(HEAPF32[i9 >> 2]);
   f5 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f32 = Math_fround(f32 - f5);
   i10 = i23 + (i7 * 12 | 0) + 8 | 0;
   f30 = Math_fround(HEAPF32[i10 >> 2]);
   f4 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]);
   f30 = Math_fround(f30 - f4);
   i37 = i23 + (i6 * 12 | 0) | 0;
   f31 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) - f31);
   i36 = i23 + (i6 * 12 | 0) + 4 | 0;
   f5 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f5);
   i35 = i23 + (i6 * 12 | 0) + 8 | 0;
   f4 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f4);
   f3 = Math_fround(Math_fround(f32 * f4) - Math_fround(f30 * f5));
   f1 = Math_fround(Math_fround(f30 * f31) - Math_fround(f33 * f4));
   f34 = Math_fround(Math_fround(f33 * f5) - Math_fround(f32 * f31));
   f4 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))))), +Math_fround(Math_fround(Math_fround(f33 * f31) + Math_fround(f32 * f5)) + Math_fround(f30 * f4))));
   i11 = i26 + (i14 * 12 | 0) | 0;
   f30 = Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2]));
   i12 = i26 + (i14 * 12 | 0) + 4 | 0;
   f5 = Math_fround(f4 * Math_fround(HEAPF32[i12 >> 2]));
   i13 = i26 + (i14 * 12 | 0) + 8 | 0;
   f4 = Math_fround(f4 * Math_fround(HEAPF32[i13 >> 2]));
   i19 = i28 + (i2 * 12 | 0) | 0;
   HEAPF32[i19 >> 2] = Math_fround(f30 + Math_fround(HEAPF32[i19 >> 2]));
   i19 = i28 + (i2 * 12 | 0) + 4 | 0;
   HEAPF32[i19 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i19 >> 2]));
   i19 = i28 + (i2 * 12 | 0) + 8 | 0;
   HEAPF32[i19 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i19 >> 2]));
   i2 = (i2 | 0) == (i6 | 0);
   i19 = i2 ? i6 : HEAP32[i21 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i37 >> 2]);
   f4 = Math_fround(f4 - f5);
   f30 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 4 >> 2]);
   f32 = Math_fround(HEAPF32[i36 >> 2]);
   f30 = Math_fround(f30 - f32);
   f31 = Math_fround(HEAPF32[i23 + (i7 * 12 | 0) + 8 >> 2]);
   f33 = Math_fround(HEAPF32[i35 >> 2]);
   f31 = Math_fround(f31 - f33);
   i2 = HEAP32[i21 + ((i2 & 1) << 2) >> 2] | 0;
   f5 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]) - f5);
   f32 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]) - f32);
   f33 = Math_fround(Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]) - f33);
   f1 = Math_fround(Math_fround(f30 * f33) - Math_fround(f31 * f32));
   f3 = Math_fround(Math_fround(f31 * f5) - Math_fround(f4 * f33));
   f34 = Math_fround(Math_fround(f4 * f32) - Math_fround(f30 * f5));
   f33 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3))))), +Math_fround(Math_fround(Math_fround(f4 * f5) + Math_fround(f30 * f32)) + Math_fround(f31 * f33))));
   f31 = Math_fround(f33 * Math_fround(HEAPF32[i11 >> 2]));
   f32 = Math_fround(f33 * Math_fround(HEAPF32[i12 >> 2]));
   f33 = Math_fround(f33 * Math_fround(HEAPF32[i13 >> 2]));
   i2 = i28 + (i6 * 12 | 0) | 0;
   HEAPF32[i2 >> 2] = Math_fround(f31 + Math_fround(HEAPF32[i2 >> 2]));
   i2 = i28 + (i6 * 12 | 0) + 4 | 0;
   HEAPF32[i2 >> 2] = Math_fround(f32 + Math_fround(HEAPF32[i2 >> 2]));
   i6 = i28 + (i6 * 12 | 0) + 8 | 0;
   HEAPF32[i6 >> 2] = Math_fround(f33 + Math_fround(HEAPF32[i6 >> 2]));
   if ((i19 | 0) == (i7 | 0)) {
    i2 = i7;
    i6 = 1;
   } else {
    i6 = (HEAP32[i16 >> 2] | 0) == (i7 | 0);
    i2 = i6 ? i7 : HEAP32[i21 >> 2] | 0;
    i6 = i6 & 1 ^ 1;
   }
   f5 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f30 = Math_fround(HEAPF32[i8 >> 2]);
   f5 = Math_fround(f5 - f30);
   f31 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i9 >> 2]);
   f31 = Math_fround(f31 - f33);
   f32 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]);
   f34 = Math_fround(HEAPF32[i10 >> 2]);
   f32 = Math_fround(f32 - f34);
   i37 = HEAP32[i21 + (i6 << 2) >> 2] | 0;
   f30 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) >> 2]) - f30);
   f33 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 4 >> 2]) - f33);
   f34 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 8 >> 2]) - f34);
   f3 = Math_fround(Math_fround(f31 * f34) - Math_fround(f32 * f33));
   f4 = Math_fround(Math_fround(f32 * f30) - Math_fround(f5 * f34));
   f1 = Math_fround(Math_fround(f5 * f33) - Math_fround(f31 * f30));
   f34 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))), +Math_fround(Math_fround(Math_fround(f5 * f30) + Math_fround(f31 * f33)) + Math_fround(f32 * f34))));
   f32 = Math_fround(f34 * Math_fround(HEAPF32[i11 >> 2]));
   f33 = Math_fround(f34 * Math_fround(HEAPF32[i12 >> 2]));
   f34 = Math_fround(f34 * Math_fround(HEAPF32[i13 >> 2]));
   i37 = i28 + (i7 * 12 | 0) | 0;
   HEAPF32[i37 >> 2] = Math_fround(f32 + Math_fround(HEAPF32[i37 >> 2]));
   i37 = i28 + (i7 * 12 | 0) + 4 | 0;
   HEAPF32[i37 >> 2] = Math_fround(f33 + Math_fround(HEAPF32[i37 >> 2]));
   i37 = i28 + (i7 * 12 | 0) + 8 | 0;
   HEAPF32[i37 >> 2] = Math_fround(f34 + Math_fround(HEAPF32[i37 >> 2]));
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i22 | 0));
  i8 = 0;
 } else {
  i11 = 0;
  do {
   i2 = i11 * 3 | 0;
   i37 = HEAP32[i19 + (i2 << 2) >> 2] | 0;
   HEAP32[i21 >> 2] = i37;
   i36 = HEAP32[i19 + (i2 + 1 << 2) >> 2] | 0;
   HEAP32[i16 >> 2] = i36;
   i2 = HEAP32[i19 + (i2 + 2 << 2) >> 2] | 0;
   f1 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i23 + (i37 * 12 | 0) >> 2]);
   f3 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 4 >> 2]);
   f34 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]);
   f30 = Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 8 >> 2]);
   f40 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) >> 2]);
   f38 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) + 8 >> 2]);
   f32 = Math_fround(HEAPF32[i28 + (i37 * 12 | 0) >> 2]);
   f31 = Math_fround(HEAPF32[i28 + (i37 * 12 | 0) + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i28 + (i37 * 12 | 0) + 8 >> 2]);
   HEAP32[i17 >> 2] = i2;
   f1 = Math_fround(f1 - f4);
   f3 = Math_fround(f3 - f33);
   f34 = Math_fround(f34 - f30);
   f4 = Math_fround(f40 - f4);
   f33 = Math_fround(f38 - f33);
   f30 = Math_fround(f39 - f30);
   f39 = Math_fround(Math_fround(f3 * f30) - Math_fround(f34 * f33));
   f38 = Math_fround(Math_fround(f34 * f4) - Math_fround(f1 * f30));
   f40 = Math_fround(Math_fround(f1 * f33) - Math_fround(f3 * f4));
   f30 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f40 * f40) + Math_fround(Math_fround(f39 * f39) + Math_fround(f38 * f38))))), +Math_fround(Math_fround(Math_fround(f1 * f4) + Math_fround(f3 * f33)) + Math_fround(f34 * f30))));
   i6 = i26 + (i11 * 12 | 0) | 0;
   f34 = Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]));
   i7 = i26 + (i11 * 12 | 0) + 4 | 0;
   f33 = Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2]));
   i8 = i26 + (i11 * 12 | 0) + 8 | 0;
   f30 = Math_fround(f30 * Math_fround(HEAPF32[i8 >> 2]));
   HEAPF32[i28 + (i37 * 12 | 0) >> 2] = Math_fround(f34 + f32);
   HEAPF32[i28 + (i37 * 12 | 0) + 4 >> 2] = Math_fround(f33 + f31);
   HEAPF32[i28 + (i37 * 12 | 0) + 8 >> 2] = Math_fround(f30 + f5);
   f5 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f30 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) >> 2]);
   f5 = Math_fround(f5 - f30);
   f31 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) + 4 >> 2]);
   f31 = Math_fround(f31 - f33);
   f32 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]);
   f34 = Math_fround(HEAPF32[i23 + (i36 * 12 | 0) + 8 >> 2]);
   f32 = Math_fround(f32 - f34);
   i35 = HEAP32[i21 + (((i37 | 0) == (i36 | 0) & 1) << 2) >> 2] | 0;
   f30 = Math_fround(Math_fround(HEAPF32[i23 + (i35 * 12 | 0) >> 2]) - f30);
   f33 = Math_fround(Math_fround(HEAPF32[i23 + (i35 * 12 | 0) + 4 >> 2]) - f33);
   f34 = Math_fround(Math_fround(HEAPF32[i23 + (i35 * 12 | 0) + 8 >> 2]) - f34);
   f3 = Math_fround(Math_fround(f31 * f34) - Math_fround(f32 * f33));
   f4 = Math_fround(Math_fround(f32 * f30) - Math_fround(f5 * f34));
   f1 = Math_fround(Math_fround(f5 * f33) - Math_fround(f31 * f30));
   f34 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))), +Math_fround(Math_fround(Math_fround(f5 * f30) + Math_fround(f31 * f33)) + Math_fround(f32 * f34))));
   f32 = Math_fround(f34 * Math_fround(HEAPF32[i6 >> 2]));
   f33 = Math_fround(f34 * Math_fround(HEAPF32[i7 >> 2]));
   f34 = Math_fround(f34 * Math_fround(HEAPF32[i8 >> 2]));
   i35 = i28 + (i36 * 12 | 0) | 0;
   HEAPF32[i35 >> 2] = Math_fround(f32 + Math_fround(HEAPF32[i35 >> 2]));
   i35 = i28 + (i36 * 12 | 0) + 4 | 0;
   HEAPF32[i35 >> 2] = Math_fround(f33 + Math_fround(HEAPF32[i35 >> 2]));
   i36 = i28 + (i36 * 12 | 0) + 8 | 0;
   HEAPF32[i36 >> 2] = Math_fround(f34 + Math_fround(HEAPF32[i36 >> 2]));
   if ((i37 | 0) == (i2 | 0)) {
    i9 = i2;
    i10 = 1;
   } else {
    i10 = (HEAP32[i16 >> 2] | 0) == (i2 | 0);
    i9 = i10 ? i2 : HEAP32[i21 >> 2] | 0;
    i10 = i10 & 1 ^ 1;
   }
   f32 = Math_fround(HEAPF32[i23 + (i9 * 12 | 0) >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]);
   f32 = Math_fround(f32 - f33);
   f34 = Math_fround(HEAPF32[i23 + (i9 * 12 | 0) + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]);
   f34 = Math_fround(f34 - f39);
   f38 = Math_fround(HEAPF32[i23 + (i9 * 12 | 0) + 8 >> 2]);
   f40 = Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2]);
   f38 = Math_fround(f38 - f40);
   i37 = HEAP32[i21 + (i10 << 2) >> 2] | 0;
   f33 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) >> 2]) - f33);
   f39 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 4 >> 2]) - f39);
   f40 = Math_fround(Math_fround(HEAPF32[i23 + (i37 * 12 | 0) + 8 >> 2]) - f40);
   f30 = Math_fround(Math_fround(f34 * f40) - Math_fround(f38 * f39));
   f31 = Math_fround(Math_fround(f38 * f33) - Math_fround(f32 * f40));
   f5 = Math_fround(Math_fround(f32 * f39) - Math_fround(f34 * f33));
   f40 = Math_fround(+Math_atan2(+Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31))))), +Math_fround(Math_fround(Math_fround(f32 * f33) + Math_fround(f34 * f39)) + Math_fround(f38 * f40))));
   f38 = Math_fround(f40 * Math_fround(HEAPF32[i6 >> 2]));
   f39 = Math_fround(f40 * Math_fround(HEAPF32[i7 >> 2]));
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i8 >> 2]));
   i37 = i28 + (i2 * 12 | 0) | 0;
   HEAPF32[i37 >> 2] = Math_fround(f38 + Math_fround(HEAPF32[i37 >> 2]));
   i37 = i28 + (i2 * 12 | 0) + 4 | 0;
   HEAPF32[i37 >> 2] = Math_fround(f39 + Math_fround(HEAPF32[i37 >> 2]));
   i37 = i28 + (i2 * 12 | 0) + 8 | 0;
   HEAPF32[i37 >> 2] = Math_fround(f40 + Math_fround(HEAPF32[i37 >> 2]));
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i22 | 0));
  i8 = 0;
 }
 do {
  i6 = i28 + (i8 * 12 | 0) | 0;
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  i37 = f1 == Math_fround(0.0);
  i7 = i28 + (i8 * 12 | 0) + 4 | 0;
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  if (i37 & f3 == Math_fround(0.0)) {
   i2 = i28 + (i8 * 12 | 0) + 8 | 0;
   if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) {
    i36 = HEAP32[i18 + (i8 * 12 | 0) >> 2] | 0;
    HEAP32[i6 >> 2] = i36;
    i37 = HEAP32[i18 + (i8 * 12 | 0) + 4 >> 2] | 0;
    HEAP32[i7 >> 2] = i37;
    HEAP32[i2 >> 2] = HEAP32[i18 + (i8 * 12 | 0) + 8 >> 2];
    f1 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
  }
  f5 = Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3));
  i2 = i28 + (i8 * 12 | 0) + 8 | 0;
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f4 * f4))));
  if (f5 > Math_fround(0.0)) {
   f40 = Math_fround(Math_fround(1.0) / f5);
   HEAPF32[i6 >> 2] = Math_fround(f1 * f40);
   HEAPF32[i7 >> 2] = Math_fround(f3 * f40);
   HEAPF32[i2 >> 2] = Math_fround(f4 * f40);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i27 | 0));
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i18);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i26);
 i37 = 1;
 STACKTOP = i29;
 return i37 | 0;
}

function __ZNK18AssetBundleManager37GetAssetBundleAndScenePathBySceneNameERK8UnityStrRP11AssetBundleRS0_(i5, i22, i30, i27) {
 i5 = i5 | 0;
 i22 = i22 | 0;
 i30 = i30 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31 + 48 | 0;
 i29 = i31 + 32 | 0;
 i25 = i31 + 16 | 0;
 i24 = i31;
 i23 = i22 + 11 | 0;
 i2 = HEAP8[i23 >> 0] | 0;
 i21 = i2 << 24 >> 24 < 0;
 i1 = i22 + 4 | 0;
 i3 = i21 ? HEAP32[i22 >> 2] | 0 : i22;
 i2 = i21 ? HEAP32[i1 >> 2] | 0 : i2 & 255;
 if (i2 | 0) {
  i21 = _memchr(i3, 47, i2) | 0;
  if (!((i21 | 0) == 0 | (i21 - i3 | 0) == -1)) {
   if (i2 >>> 0 < 7) i26 = 21; else {
    i20 = HEAP8[i3 >> 0] | 0;
    i21 = i20 << 24 >> 24;
    if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 97) {
     i20 = HEAP8[i3 + 1 >> 0] | 0;
     i21 = i20 << 24 >> 24;
     if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 115) {
      i20 = HEAP8[i3 + 2 >> 0] | 0;
      i21 = i20 << 24 >> 24;
      if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 115) {
       i20 = HEAP8[i3 + 3 >> 0] | 0;
       i21 = i20 << 24 >> 24;
       if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 101) {
        i20 = HEAP8[i3 + 4 >> 0] | 0;
        i21 = i20 << 24 >> 24;
        if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 116) {
         i20 = HEAP8[i3 + 5 >> 0] | 0;
         i21 = i20 << 24 >> 24;
         if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 115) {
          i20 = HEAP8[i3 + 6 >> 0] | 0;
          i21 = i20 << 24 >> 24;
          if ((((i20 + -65 & 255) < 26 ? i21 + 32 | 0 : i21) & 255) << 24 >> 24 == 47) if (__Z23EndsWithCaseInsensitivePKcjS0_j(i3, i2, gb + 443940 | 0, 6) | 0) {
           i2 = (HEAP8[i23 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
           HEAP32[i25 >> 2] = 0;
           HEAP32[i25 + 4 >> 2] = 0;
           HEAP32[i25 + 8 >> 2] = 0;
           i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
           HEAP32[i25 + 12 >> 2] = i1;
           i3 = _strlen(i2) | 0;
           if (i3 >>> 0 > 2147483631) {
            __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i25);
            i1 = HEAP32[i25 + 12 >> 2] | 0;
            i26 = 9;
           } else if (i3 >>> 0 < 11) {
            HEAP8[i25 + 11 >> 0] = i3;
            if (!i3) i1 = i25; else {
             i1 = i25;
             i26 = 11;
            }
           } else i26 = 9;
           if ((i26 | 0) == 9) {
            i24 = i3 + 16 & -16;
            HEAP32[i28 >> 2] = 54;
            HEAP32[i28 + 4 >> 2] = i1;
            i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
            HEAP32[i25 >> 2] = i1;
            HEAP32[i25 + 8 >> 2] = i24 | -2147483648;
            HEAP32[i25 + 4 >> 2] = i3;
            i26 = 11;
           }
           if ((i26 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
           HEAP8[i1 + i3 >> 0] = 0;
           i4 = i5 + 68 | 0;
           if ((HEAP32[i5 + 128 >> 2] | 0) == (HEAP32[i5 + 72 >> 2] | 0)) {
            i24 = (HEAP32[i5 + 120 >> 2] | 0) + ((HEAP32[i5 + 124 >> 2] | 0) * 20 | 0) | 0;
            HEAP32[i29 >> 2] = i4;
            i1 = i29 + 4 | 0;
            HEAP32[i1 >> 2] = i24;
            HEAP32[i29 + 8 >> 2] = i24;
            __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i29);
           } else {
            __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i28, i4, i25);
            i1 = HEAP32[i28 >> 2] | 0;
            i2 = HEAP32[i5 + 120 >> 2] | 0;
            i3 = HEAP32[i5 + 124 >> 2] | 0;
            if ((i1 | 0) == -1) {
             i24 = i2 + (i3 * 20 | 0) | 0;
             HEAP32[i29 >> 2] = i4;
             i1 = i29 + 4 | 0;
             HEAP32[i1 >> 2] = i24;
             HEAP32[i29 + 8 >> 2] = i24;
             __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i29);
            } else {
             HEAP32[i29 >> 2] = i4;
             i24 = i29 + 4 | 0;
             HEAP32[i24 >> 2] = i2 + (i1 * 20 | 0);
             HEAP32[i29 + 8 >> 2] = i2 + (i3 * 20 | 0);
             i1 = i24;
            }
           }
           i2 = HEAP32[i1 >> 2] | 0;
           if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
            i24 = HEAP32[i25 >> 2] | 0;
            i25 = HEAP32[i25 + 12 >> 2] | 0;
            HEAP32[i28 >> 2] = 54;
            HEAP32[i28 + 4 >> 2] = i25;
            __Z19free_alloc_internalPvRK10MemLabelId(i24, i28);
           }
           i1 = i4;
          } else i26 = 21; else i26 = 21;
         } else i26 = 21;
        } else i26 = 21;
       } else i26 = 21;
      } else i26 = 21;
     } else i26 = 21;
    } else i26 = 21;
   }
   if ((i26 | 0) == 21) {
    i2 = __Z16GetBuildSettingsv() | 0;
    i23 = HEAP8[i23 >> 0] | 0;
    i21 = i23 << 24 >> 24 < 0;
    i3 = i21 ? HEAP32[i22 >> 2] | 0 : i22;
    i1 = i21 ? HEAP32[i1 >> 2] | 0 : i23 & 255;
    HEAP32[i28 >> 2] = 0;
    HEAP32[i28 + 4 >> 2] = 0;
    HEAP32[i28 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i28, i3, i1);
    __ZN13BuildSettings34ConvertDisplayScenePathToScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i29, i2, i28);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
    i2 = (HEAP8[i29 + 11 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i24 + 12 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
     i1 = HEAP32[i24 + 12 >> 2] | 0;
     i26 = 24;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i24 + 11 >> 0] = i3;
     if (!i3) i1 = i24; else {
      i1 = i24;
      i26 = 26;
     }
    } else i26 = 24;
    if ((i26 | 0) == 24) {
     i23 = i3 + 16 & -16;
     HEAP32[i28 >> 2] = 54;
     HEAP32[i28 + 4 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i23, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i24 >> 2] = i1;
     HEAP32[i24 + 8 >> 2] = i23 | -2147483648;
     HEAP32[i24 + 4 >> 2] = i3;
     i26 = 26;
    }
    if ((i26 | 0) == 26) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    HEAP8[i1 + i3 >> 0] = 0;
    i4 = i5 + 68 | 0;
    if ((HEAP32[i5 + 128 >> 2] | 0) == (HEAP32[i5 + 72 >> 2] | 0)) {
     i23 = (HEAP32[i5 + 120 >> 2] | 0) + ((HEAP32[i5 + 124 >> 2] | 0) * 20 | 0) | 0;
     HEAP32[i25 >> 2] = i4;
     i1 = i25 + 4 | 0;
     HEAP32[i1 >> 2] = i23;
     HEAP32[i25 + 8 >> 2] = i23;
     __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i25);
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i28, i4, i24);
     i1 = HEAP32[i28 >> 2] | 0;
     i2 = HEAP32[i5 + 120 >> 2] | 0;
     i3 = HEAP32[i5 + 124 >> 2] | 0;
     if ((i1 | 0) == -1) {
      i23 = i2 + (i3 * 20 | 0) | 0;
      HEAP32[i25 >> 2] = i4;
      i1 = i25 + 4 | 0;
      HEAP32[i1 >> 2] = i23;
      HEAP32[i25 + 8 >> 2] = i23;
      __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i25);
     } else {
      HEAP32[i25 >> 2] = i4;
      i23 = i25 + 4 | 0;
      HEAP32[i23 >> 2] = i2 + (i1 * 20 | 0);
      HEAP32[i25 + 8 >> 2] = i2 + (i3 * 20 | 0);
      i1 = i23;
     }
    }
    i2 = HEAP32[i1 >> 2] | 0;
    if ((HEAP8[i24 + 11 >> 0] | 0) < 0) {
     i25 = HEAP32[i24 >> 2] | 0;
     i24 = HEAP32[i24 + 12 >> 2] | 0;
     HEAP32[i28 >> 2] = 54;
     HEAP32[i28 + 4 >> 2] = i24;
     __Z19free_alloc_internalPvRK10MemLabelId(i25, i28);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
    i1 = i4;
   }
   i24 = (HEAP32[i5 + 120 >> 2] | 0) + ((HEAP32[i5 + 124 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i28 >> 2] = i1;
   i25 = i28 + 4 | 0;
   HEAP32[i25 >> 2] = i24;
   HEAP32[i28 + 8 >> 2] = i24;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i28);
   if ((i2 | 0) == (HEAP32[i25 >> 2] | 0)) {
    STACKTOP = i31;
    return;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i3 = HEAP32[i2 >> 2] | 0; else i3 = i2;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i29 + 12 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i29);
    i1 = HEAP32[i29 + 12 >> 2] | 0;
    i26 = 43;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i29 + 11 >> 0] = i4;
    if (!i4) i1 = i29; else {
     i1 = i29;
     i26 = 45;
    }
   } else i26 = 43;
   if ((i26 | 0) == 43) {
    i25 = i4 + 16 & -16;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i28 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i25, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i29 >> 2] = i1;
    HEAP32[i29 + 8 >> 2] = i25 | -2147483648;
    HEAP32[i29 + 4 >> 2] = i4;
    i26 = 45;
   }
   if ((i26 | 0) == 45) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   i5 = i29 + 11 | 0;
   do if ((i29 | 0) != (i27 | 0)) {
    i7 = HEAP8[i5 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i6 = i8 ? HEAP32[i29 >> 2] | 0 : i29;
    i7 = i8 ? HEAP32[i29 + 4 >> 2] | 0 : i7 & 255;
    i8 = i27 + 11 | 0;
    i1 = HEAP8[i8 >> 0] | 0;
    i3 = i1 << 24 >> 24 < 0;
    if (i3) i4 = (HEAP32[i27 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i7 >>> 0 > i4 >>> 0) {
     i26 = i3 ? HEAP32[i27 + 4 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i27, i4, i7 - i4 | 0, i26, 0, i26, i7, i6);
     break;
    }
    i1 = i3 ? HEAP32[i27 >> 2] | 0 : i27;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i8 >> 0] | 0) < 0) {
     HEAP32[i27 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i8 >> 0] = i7;
     break;
    }
   } while (0);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i27 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 12 >> 2] | 0;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i28 + 4 >> 2] = i29;
    __Z19free_alloc_internalPvRK10MemLabelId(i27, i28);
   }
   HEAP32[i30 >> 2] = HEAP32[i2 + 16 >> 2];
   STACKTOP = i31;
   return;
  }
 };
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i25 + 12 >> 2] = i1;
 i2 = _strlen(i3) | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i25);
  i1 = HEAP32[i25 + 12 >> 2] | 0;
  i26 = 62;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i25 + 11 >> 0] = i2;
  if (!i2) i1 = i25; else {
   i1 = i25;
   i26 = 64;
  }
 } else i26 = 62;
 if ((i26 | 0) == 62) {
  i21 = i2 + 16 & -16;
  HEAP32[i28 >> 2] = 54;
  HEAP32[i28 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i25 >> 2] = i1;
  HEAP32[i25 + 8 >> 2] = i21 | -2147483648;
  HEAP32[i25 + 4 >> 2] = i2;
  i26 = 64;
 }
 if ((i26 | 0) == 64) _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 i4 = i5 + 144 | 0;
 if ((HEAP32[i5 + 204 >> 2] | 0) == (HEAP32[i5 + 148 >> 2] | 0)) {
  i21 = (HEAP32[i5 + 196 >> 2] | 0) + ((HEAP32[i5 + 200 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i29 >> 2] = i4;
  i1 = i29 + 4 | 0;
  HEAP32[i1 >> 2] = i21;
  HEAP32[i29 + 8 >> 2] = i21;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i29);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i28, i4, i25);
  i1 = HEAP32[i28 >> 2] | 0;
  i2 = HEAP32[i5 + 196 >> 2] | 0;
  i3 = HEAP32[i5 + 200 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i21 = i2 + (i3 * 20 | 0) | 0;
   HEAP32[i29 >> 2] = i4;
   i1 = i29 + 4 | 0;
   HEAP32[i1 >> 2] = i21;
   HEAP32[i29 + 8 >> 2] = i21;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i29);
  } else {
   HEAP32[i29 >> 2] = i4;
   i21 = i29 + 4 | 0;
   HEAP32[i21 >> 2] = i2 + (i1 * 20 | 0);
   HEAP32[i29 + 8 >> 2] = i2 + (i3 * 20 | 0);
   i1 = i21;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP8[i25 + 11 >> 0] | 0) < 0) {
  i21 = HEAP32[i25 >> 2] | 0;
  i20 = HEAP32[i25 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 54;
  HEAP32[i28 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i28);
 }
 i20 = (HEAP32[i5 + 196 >> 2] | 0) + ((HEAP32[i5 + 200 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i28 >> 2] = i4;
 i21 = i28 + 4 | 0;
 HEAP32[i21 >> 2] = i20;
 HEAP32[i28 + 8 >> 2] = i20;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i28);
 if ((i1 | 0) == (HEAP32[i21 >> 2] | 0)) {
  STACKTOP = i31;
  return;
 }
 i20 = i1 + 16 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i21 = i1 + 72 | 0;
 i3 = i2;
 if ((i3 | 0) != (i21 | 0)) {
  i9 = i25 + 11 | 0;
  i10 = i25 + 4 | 0;
  i11 = i29 + 12 | 0;
  i8 = i29 + 12 | 0;
  i12 = i28 + 4 | 0;
  i13 = i29 + 8 | 0;
  i14 = i29 + 4 | 0;
  i15 = i29 + 11 | 0;
  i16 = i27 + 11 | 0;
  i17 = i27 + 8 | 0;
  i18 = i27 + 4 | 0;
  i19 = i28 + 4 | 0;
  while (1) {
   i6 = i3 + 16 | 0;
   i7 = i6 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) {
    i4 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i3 + 20 >> 2] | 0;
   } else {
    i4 = i6;
    i1 = i1 & 255;
   };
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, i4, i1);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i28, i24);
   __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i25, i28);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   i5 = HEAP8[i9 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i25 >> 2] | 0 : i25;
   i5 = i1 ? HEAP32[i10 >> 2] | 0 : i5 & 255;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i1;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i29);
    i1 = HEAP32[i8 >> 2] | 0;
    i26 = 83;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i5;
    if (!i5) i1 = i29; else {
     i1 = i29;
     i26 = 85;
    }
   } else i26 = 83;
   if ((i26 | 0) == 83) {
    i32 = i5 + 16 & -16;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i32, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i29 >> 2] = i1;
    HEAP32[i13 >> 2] = i32 | -2147483648;
    HEAP32[i14 >> 2] = i5;
    i26 = 85;
   }
   if ((i26 | 0) == 85) {
    i26 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   do if (!(__Z7StrICmpPKcS0_((HEAP8[i23 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, (HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29) | 0)) if ((i6 | 0) == (i27 | 0)) i1 = 1; else {
    i5 = HEAP8[i7 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i6 = i1 ? HEAP32[i6 >> 2] | 0 : i6;
    i5 = i1 ? HEAP32[i3 + 20 >> 2] | 0 : i5 & 255;
    i1 = HEAP8[i16 >> 0] | 0;
    i3 = i1 << 24 >> 24 < 0;
    if (i3) i4 = (HEAP32[i17 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i5 >>> 0 > i4 >>> 0) {
     i1 = i3 ? HEAP32[i18 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i27, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
     i1 = 1;
     break;
    }
    i1 = i3 ? HEAP32[i27 >> 2] | 0 : i27;
    if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i16 >> 0] | 0) < 0) {
     HEAP32[i18 >> 2] = i5;
     i1 = 1;
     break;
    } else {
     HEAP8[i16 >> 0] = i5;
     i1 = 1;
     break;
    }
   } else i1 = 0; while (0);
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i32 = HEAP32[i29 >> 2] | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i19 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i28);
   }
   if (i1 | 0) break;
   i1 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i21 | 0)) break; else {
    i2 = i1;
    i3 = i1;
   }
  }
  i1 = HEAP32[i20 >> 2] | 0;
 }
 HEAP32[i30 >> 2] = i1;
 STACKTOP = i31;
 return;
}

function __ZN17PrePassRenderLoop14RenderBasePassEP13RenderTextureRK14LightingLayersR13dynamic_arrayI16RenderObjectDataLj4EERbR10MinMaxAABB(i81, i2, i70, i71, i76, i77) {
 i81 = i81 | 0;
 i2 = i2 | 0;
 i70 = i70 | 0;
 i71 = i71 | 0;
 i76 = i76 | 0;
 i77 = i77 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, f72 = f0, i73 = 0, i74 = 0, i75 = 0, i78 = 0, i79 = 0, i80 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0;
 i87 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i65 = i87 + 648 | 0;
 i78 = i87 + 640 | 0;
 i79 = i87 + 632 | 0;
 i1 = i87 + 616 | 0;
 i83 = i87 + 612 | 0;
 i3 = i87 + 608 | 0;
 i4 = i87 + 628 | 0;
 i5 = i87 + 592 | 0;
 i66 = i87 + 464 | 0;
 i6 = i87 + 672 | 0;
 i85 = i87 + 268 | 0;
 i67 = i87 + 256 | 0;
 i68 = i87 + 124 | 0;
 i69 = i87;
 if ((HEAP16[gb + 1115012 + 6 >> 1] | 0) > -1) {
  HEAP32[i78 >> 2] = HEAP32[(HEAP32[i81 >> 2] | 0) + 8 >> 2];
  HEAP32[i65 >> 2] = HEAP32[i78 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115012 | 0, i65);
  i84 = gb + 1115012 | 0;
 } else i84 = 0;
 i86 = HEAP32[gb + 1115012 >> 2] | 0;
 i74 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i74 >> 2] | 0) + 648 >> 2] | 0, i74 | 0, i86 | 0);
 i86 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 4;
 i74 = HEAP32[i81 >> 2] | 0;
 f72 = Math_fround(HEAPF32[i74 + 792 >> 2]);
 i82 = HEAP32[gb + 1166248 >> 2] | 0;
 i73 = HEAP32[i74 + 1832 >> 2] | 0;
 i74 = (HEAP32[i74 + 1828 >> 2] | 0) + 65728 | 0;
 i75 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i75 >> 2] | 0) + 148 >> 2] | 0, i75 | 0, 0);
 HEAP8[i1 + 1 >> 0] = -1;
 HEAP8[i1 + 3 >> 0] = 0;
 HEAP8[i1 + 4 >> 0] = 8;
 HEAP8[i1 + 6 >> 0] = 0;
 HEAP8[i1 + 7 >> 0] = 0;
 HEAP8[i1 + 8 >> 0] = 8;
 HEAP8[i1 + 10 >> 0] = 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 + 2 >> 0] = -17;
 HEAP8[i1 >> 0] = 1;
 HEAP8[i1 + 9 >> 0] = 2;
 HEAP8[i1 + 5 >> 0] = 2;
 i64 = mftCall_iii(HEAP32[(HEAP32[i75 >> 2] | 0) + 52 >> 2] | 0, i75 | 0, i1 | 0) | 0;
 i1 = __Z22GetRenderBufferManagerv() | 0;
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i1, -1, -1, 0, 0, 0, 1, 0, HEAP32[i2 + 88 >> 2] | 0) | 0;
 HEAP32[i83 >> 2] = i1;
 if (i1) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 388180 | 0);
  i1 = HEAP32[i83 >> 2] | 0;
 }
 __ZN7Texture13SetFilterModeEi(i1, 0);
 __ZN13RenderTexture6CreateEv(HEAP32[i83 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[(HEAP32[i83 >> 2] | 0) + 128 >> 2];
 i63 = (HEAP32[(HEAP32[(HEAP32[i81 >> 2] | 0) + 8 >> 2] | 0) + 844 >> 2] | 0) == 4;
 HEAP32[i4 >> 2] = HEAP32[i2 + 136 >> 2];
 HEAP32[i65 >> 2] = HEAP32[i4 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i3, i65, i83, 0, -1, 0, i63 ? 4 : 12) | 0;
 __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[(HEAP32[i81 >> 2] | 0) + 1888 >> 2] | 0, 7, HEAP32[i83 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i63 ? 1 : 7, i5, Math_fround(1.0), 0, i82);
 __Z15gpu_time_samplev();
 mftCall_vii(HEAP32[(HEAP32[i75 >> 2] | 0) + 112 >> 2] | 0, i75 | 0, (HEAP32[i81 >> 2] | 0) + 1732 | 0);
 if (__Z12GetIVRDevicev() | 0) {
  i63 = __Z12GetIVRDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i63 >> 2] | 0) + 56 >> 2] | 0, i63 | 0);
 }
 i61 = HEAP32[i81 >> 2] | 0;
 i62 = HEAP32[i61 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i62 + 1136 | 0, 4, i82, HEAP32[i61 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i62 + 4 >> 2] | 0);
 i62 = HEAP32[i81 >> 2] | 0;
 i61 = HEAP32[i62 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i61 + 1136 | 0, 4, i82, HEAP32[i62 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i61 + 4 >> 2] | 0);
 i61 = __Z19GetReflectionProbesv() | 0;
 HEAP32[i66 >> 2] = HEAP32[i61 + 192 >> 2];
 HEAP32[i66 + 4 >> 2] = HEAP32[i61 + 196 >> 2];
 HEAP32[i66 + 8 >> 2] = HEAP32[i61 + 200 >> 2];
 HEAP32[i66 + 12 >> 2] = HEAP32[i61 + 204 >> 2];
 HEAP32[i66 + 16 >> 2] = HEAP32[i61 + 208 >> 2];
 HEAP32[i66 + 20 >> 2] = HEAP32[i61 + 212 >> 2];
 HEAP32[i66 + 24 >> 2] = HEAP32[i61 + 216 >> 2];
 HEAP32[i66 + 28 >> 2] = HEAP32[i61 + 220 >> 2];
 HEAP32[i66 + 32 >> 2] = HEAP32[i61 + 224 >> 2];
 HEAP32[i66 + 36 >> 2] = HEAP32[i61 + 228 >> 2];
 HEAP32[i66 + 40 >> 2] = HEAP32[i61 + 232 >> 2];
 HEAP32[i66 + 44 >> 2] = HEAP32[i61 + 236 >> 2];
 HEAP32[i66 + 48 >> 2] = HEAP32[i61 + 240 >> 2];
 HEAP32[i66 + 52 >> 2] = HEAP32[i61 + 244 >> 2];
 HEAP32[i66 + 56 >> 2] = HEAP32[i61 + 248 >> 2];
 HEAP32[i66 + 60 >> 2] = HEAP32[i61 + 252 >> 2];
 HEAP32[i66 + 64 >> 2] = HEAP32[i61 + 256 >> 2];
 HEAP32[i66 + 68 >> 2] = HEAP32[i61 + 260 >> 2];
 HEAP32[i66 + 72 >> 2] = HEAP32[i61 + 264 >> 2];
 HEAP32[i66 + 76 >> 2] = HEAP32[i61 + 268 >> 2];
 HEAP32[i66 + 80 >> 2] = HEAP32[i61 + 272 >> 2];
 HEAP32[i66 + 84 >> 2] = HEAP32[i61 + 276 >> 2];
 HEAP32[i66 + 88 >> 2] = HEAP32[i61 + 280 >> 2];
 HEAP32[i66 + 92 >> 2] = HEAP32[i61 + 284 >> 2];
 HEAP32[i66 + 96 >> 2] = HEAP32[i61 + 288 >> 2];
 HEAP32[i66 + 100 >> 2] = HEAP32[i61 + 292 >> 2];
 HEAP32[i66 + 104 >> 2] = HEAP32[i61 + 296 >> 2];
 HEAP32[i66 + 108 >> 2] = HEAP32[i61 + 300 >> 2];
 HEAP32[i66 + 112 >> 2] = HEAP32[i61 + 304 >> 2];
 HEAP32[i66 + 116 >> 2] = HEAP32[i61 + 308 >> 2];
 HEAP32[i66 + 120 >> 2] = HEAP32[i61 + 312 >> 2];
 i61 = i81 + 4 | 0;
 i62 = HEAP32[(HEAP32[i61 >> 2] | 0) + 12 >> 2] | 0;
 i1 = i62 >>> 4;
 i63 = i71 + 16 | 0;
 i2 = HEAP32[i63 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i63 >> 2] = i1;
  HEAP32[i71 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i71 >> 2] | 0, i1 << 5, 4, i71 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i60 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i71 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i60 | 0, HEAP32[i71 >> 2] | 0, HEAP32[i71 + 12 >> 2] << 5 | 0) | 0;
  HEAP32[i63 >> 2] = i1;
  HEAP32[i71 >> 2] = i60;
  break;
 } while (0);
 HEAP8[i76 >> 0] = 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i85, i6, i73, 0, 1);
 HEAP32[i67 >> 2] = i85;
 i60 = __Z12GetGfxDevicev() | 0;
 HEAP32[i67 + 4 >> 2] = i60 + 4;
 HEAPF32[i67 + 8 >> 2] = Math_fround(0.0);
 i60 = i60 + 964 | 0;
 HEAP32[i60 >> 2] = 0;
 HEAP32[i60 + 4 >> 2] = 0;
 HEAP32[i60 + 8 >> 2] = 0;
 HEAP32[i60 + 12 >> 2] = 0;
 __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats(i68, i85, i6);
 if (!i62) i1 = i82 + 4 | 0; else {
  i43 = i81 + 140 | 0;
  i44 = i77 + 4 | 0;
  i45 = i77 + 8 | 0;
  i46 = i77 + 12 | 0;
  i47 = i77 + 16 | 0;
  i48 = i77 + 20 | 0;
  i49 = i71 + 12 | 0;
  i50 = i71 + 4 | 0;
  i51 = i81 + 136 | 0;
  i52 = i78 + 4 | 0;
  i53 = i85 + 192 | 0;
  i1 = i82 + 4 | 0;
  i54 = i75 + 608 | 0;
  i55 = i85 + 184 | 0;
  i56 = i85 + 188 | 0;
  i57 = i75 + 4376 | 0;
  i58 = i68 + 128 | 0;
  i59 = i69 + 24 | 0;
  i60 = i69 + 84 | 0;
  i42 = 0;
  i9 = 0;
  i31 = -1;
  i32 = -1;
  i33 = -1;
  i34 = 0;
  i37 = 0;
  i2 = 0;
  while (1) {
   i7 = HEAP32[(HEAP32[i43 >> 2] | 0) + (i42 << 2) >> 2] | 0;
   i11 = HEAP32[HEAP32[i61 >> 2] >> 2] | 0;
   i10 = i11 + (i7 << 5) | 0;
   i40 = HEAP32[i10 >> 2] | 0;
   i12 = i11 + (i7 << 5) + 8 | 0;
   i14 = HEAP32[i12 >> 2] | 0;
   i15 = HEAP32[i73 >> 2] | 0;
   i6 = i15 + (i14 * 360 | 0) | 0;
   f8 = Math_fround(HEAPF32[i11 + (i7 << 5) + 24 >> 2]);
   i41 = i40;
   if (f8 > f72) {
    i13 = HEAP32[i81 >> 2] | 0;
    f89 = Math_fround(HEAPF32[i13 + 1740 >> 2]);
    i39 = f89 < Math_fround(0.0);
    f90 = Math_fround(-f89);
    f89 = Math_fround(Math_fround(HEAPF32[i15 + (i14 * 360 | 0) + 140 >> 2]) * (i39 ? f90 : f89));
    f90 = Math_fround(HEAPF32[i13 + 1756 >> 2]);
    i39 = f90 < Math_fround(0.0);
    f88 = Math_fround(-f90);
    f90 = Math_fround(f89 + Math_fround(Math_fround(HEAPF32[i15 + (i14 * 360 | 0) + 144 >> 2]) * (i39 ? f88 : f90)));
    f88 = Math_fround(HEAPF32[i13 + 1772 >> 2]);
    i13 = f88 < Math_fround(0.0);
    f89 = Math_fround(-f88);
    i13 = !(Math_fround(f8 - Math_fround(f90 + Math_fround(Math_fround(HEAPF32[i15 + (i14 * 360 | 0) + 148 >> 2]) * (i13 ? f89 : f88)))) > f72);
   } else i13 = 1;
   i38 = HEAP32[(HEAP32[i15 + (i14 * 360 | 0) + 324 >> 2] | 0) + (HEAPU16[i11 + (i7 << 5) + 18 >> 1] << 3) >> 2] | 0;
   i3 = HEAPU16[i11 + (i7 << 5) + 16 >> 1] & 32767;
   i4 = HEAP32[i15 + (i14 * 360 | 0) + 176 >> 2] << 13 & 32768;
   i36 = HEAP32[i15 + (i14 * 360 | 0) + 252 >> 2] | 0;
   i5 = (i36 & 2147483647 | 0) == 0 ? 0 : i36 >> 15 & 131072 | 65536;
   i39 = HEAP32[i15 + (i14 * 360 | 0) + 224 >> 2] | 0;
   f8 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i3 | 0) == 32767) i35 = i5 | i4 | HEAP32[(HEAP32[i40 + 32 >> 2] | 0) + 36 >> 2] & 32767; else i35 = i4 | i3 | i5;
   if (i13) {
    i36 = i15 + (i14 * 360 | 0) + 232 | 0;
    i36 = ((HEAPU16[i36 >> 1] | HEAPU8[i36 + 2 >> 0] << 16) & 256 | 0) != 0;
   } else i36 = 0;
   if ((i35 & 32767 | 0) == 32767) {
    if (i36) {
     i35 = i15 + (i14 * 360 | 0) + 128 | 0;
     f90 = Math_fround(HEAPF32[i35 >> 2]);
     i36 = i15 + (i14 * 360 | 0) + 140 | 0;
     f90 = Math_fround(f90 - Math_fround(HEAPF32[i36 >> 2]));
     i38 = i15 + (i14 * 360 | 0) + 132 | 0;
     f91 = Math_fround(HEAPF32[i38 >> 2]);
     i39 = i15 + (i14 * 360 | 0) + 144 | 0;
     f91 = Math_fround(f91 - Math_fround(HEAPF32[i39 >> 2]));
     i40 = i15 + (i14 * 360 | 0) + 136 | 0;
     f8 = Math_fround(HEAPF32[i40 >> 2]);
     i41 = i15 + (i14 * 360 | 0) + 148 | 0;
     f8 = Math_fround(f8 - Math_fround(HEAPF32[i41 >> 2]));
     f88 = Math_fround(HEAPF32[i77 >> 2]);
     f89 = Math_fround(HEAPF32[i44 >> 2]);
     f92 = Math_fround(HEAPF32[i45 >> 2]);
     HEAPF32[i77 >> 2] = f90 < f88 ? f90 : f88;
     HEAPF32[i44 >> 2] = f91 < f89 ? f91 : f89;
     HEAPF32[i45 >> 2] = f8 < f92 ? f8 : f92;
     f92 = Math_fround(HEAPF32[i35 >> 2]);
     f92 = Math_fround(f92 + Math_fround(HEAPF32[i36 >> 2]));
     f8 = Math_fround(HEAPF32[i38 >> 2]);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f89 = Math_fround(HEAPF32[i40 >> 2]);
     f89 = Math_fround(f89 + Math_fround(HEAPF32[i41 >> 2]));
     f91 = Math_fround(HEAPF32[i46 >> 2]);
     f88 = Math_fround(HEAPF32[i47 >> 2]);
     f90 = Math_fround(HEAPF32[i48 >> 2]);
     HEAPF32[i46 >> 2] = f91 < f92 ? f92 : f91;
     HEAPF32[i47 >> 2] = f88 < f8 ? f8 : f88;
     HEAPF32[i48 >> 2] = f90 < f89 ? f89 : f90;
     HEAP8[i76 >> 0] = 1;
    }
    i4 = HEAP32[i49 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i63 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i3 = i6 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i63 >> 2] = i3;
      HEAP32[i71 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i71 >> 2] | 0, i3 << 5, 4, i50, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 5, 4, i50, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i41 | 0, HEAP32[i71 >> 2] | 0, HEAP32[i49 >> 2] << 5 | 0) | 0;
      HEAP32[i63 >> 2] = i3;
      HEAP32[i71 >> 2] = i41;
      break;
     }
    } while (0);
    HEAP32[i49 >> 2] = i5;
    i7 = (HEAP32[i71 >> 2] | 0) + (i4 << 5) | 0;
    HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
    HEAP32[i7 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
    i7 = i31;
    i6 = i32;
    i5 = i33;
    i4 = i34;
    i3 = i37;
   } else {
    __ZN12LODFadeCache14ApplyValueOnlyEf(i67, f8);
    __ZN16ReflectionSampleC2Ev(i69);
    __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_(i74, i6, i66, i69);
    if (_memcmp(i68, i69, 124) | 0) {
     i3 = i68;
     i4 = i69;
     i5 = i3 + 124 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
      i3 = i3 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i3 | 0) < (i5 | 0));
     i3 = HEAP32[i58 >> 2] | 0;
     if (HEAP32[i3 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i3);
     __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i3, i69);
     HEAP32[i78 >> 2] = HEAP32[i59 >> 2];
     HEAP32[i65 >> 2] = HEAP32[i78 >> 2];
     __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i3, 19, 4, 0, i65);
     HEAP32[i79 >> 2] = HEAP32[i60 >> 2];
     HEAP32[i65 >> 2] = HEAP32[i79 >> 2];
     __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i3, 20, 4, 0, i65);
    }
    i4 = HEAP16[i15 + (i14 * 360 | 0) + 224 >> 1] | 0;
    i3 = HEAP8[i51 >> 0] | 0;
    i3 = __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i6, (i3 & 2) != 0, (i3 & 1) != 0) | 0;
    HEAP32[i78 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i52 >> 2] = HEAPU16[i11 + (i7 << 5) + 14 >> 1];
    i28 = HEAP32[(HEAP32[HEAP32[i40 + 32 >> 2] >> 2] | 0) + (i35 << 17 >> 17 << 2) >> 2] | 0;
    i29 = HEAP32[i28 + 20 >> 2] | 0;
    if ((i29 | 0) > 0) {
     i30 = i15 + (i14 * 360 | 0) + 240 | 0;
     i16 = (i4 & 65535) > 65533 & (i3 ^ 1) ? 192 : 128;
     i16 = i13 ? i16 : i16 | 32;
     i19 = i38;
     i20 = i15 + (i14 * 360 | 0) + 260 | 0;
     i17 = i39 & 65535;
     i18 = i39 >>> 16 & 65535;
     i21 = i35 << 14 >> 30;
     f8 = i35 & 32768 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
     i22 = i40 + 32 | 0;
     i23 = i15 + (i14 * 360 | 0) + 128 | 0;
     i24 = i15 + (i14 * 360 | 0) + 140 | 0;
     i25 = i15 + (i14 * 360 | 0) + 132 | 0;
     i26 = i15 + (i14 * 360 | 0) + 144 | 0;
     i27 = i15 + (i14 * 360 | 0) + 136 | 0;
     i13 = i15 + (i14 * 360 | 0) + 148 | 0;
     i12 = 0;
     i7 = i31;
     i6 = i32;
     i5 = i33;
     i4 = i34;
     i3 = i37;
     do {
      i11 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i12 << 2) >> 2] | 0;
      if ((HEAP32[i11 + 696 >> 2] | 0) == 6) {
       i10 = HEAP32[i70 + 4 + (HEAP32[i30 >> 2] << 2) >> 2] | 0;
       i10 = ((i10 | 0) == -1 ? 0 : 1 << i10) | i16;
       do if ((i19 | 0) == (i9 | 0)) {
        if (!((i35 | 0) == (i7 | 0) & ((i40 | 0) == (i3 | 0) & (i11 | 0) == (i2 | 0)))) {
         i80 = 45;
         break;
        }
        if ((i10 | 0) != (i4 | 0) ? 1 : (i39 | 0) != ((i5 & 65535) << 16 | i6 & 65535 | 0)) {
         i80 = 45;
         break;
        }
        if ((HEAP32[i20 >> 2] | 0) != (HEAP32[i53 >> 2] | 0)) i80 = 45;
       } else i80 = 45; while (0);
       if ((i80 | 0) == 45) {
        i80 = 0;
        __ZN13BatchRenderer5FlushEv(i85);
        switch (i21 | 0) {
        case 1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 8388608;
          break;
         }
        case -1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 4194304;
          break;
         }
        default:
         HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913;
        }
        HEAPF32[i54 >> 2] = f8;
        HEAP32[i65 >> 2] = 0;
        HEAP32[i65 + 4 >> 2] = 0;
        HEAP32[i65 + 8 >> 2] = 0;
        HEAP32[i65 + 12 >> 2] = 0;
        HEAP32[i65 + 16 >> 2] = 0;
        HEAP32[i65 + 20 >> 2] = 0;
        i2 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i19, i82, i40, i11, i12, (HEAP32[i11 + 744 >> 2] | 0) == 0, 0, i65) | 0;
        HEAP32[i55 >> 2] = i2;
        if (!i2) i2 = 0; else i2 = HEAP32[i2 >> 2] & 1;
        i9 = HEAP8[i56 >> 0] & -4 | i2;
        HEAP8[i56 >> 0] = i9;
        HEAP8[i56 >> 0] = (HEAP32[(HEAP32[i22 >> 2] | 0) + 64 >> 2] & 255) << 2 & 12 | i9 & -13;
        mftCall_viii(HEAP32[(HEAP32[i75 >> 2] | 0) + 72 >> 2] | 0, i75 | 0, i64 | 0, HEAP32[i57 >> 2] | i10 | 0);
        i9 = i38;
        i6 = i17;
        i5 = i18;
        i4 = i10;
        i3 = i41;
        i2 = i11;
       }
       if (i36) {
        f92 = Math_fround(HEAPF32[i23 >> 2]);
        f92 = Math_fround(f92 - Math_fround(HEAPF32[i24 >> 2]));
        f88 = Math_fround(HEAPF32[i25 >> 2]);
        f88 = Math_fround(f88 - Math_fround(HEAPF32[i26 >> 2]));
        f89 = Math_fround(HEAPF32[i27 >> 2]);
        f89 = Math_fround(f89 - Math_fround(HEAPF32[i13 >> 2]));
        f90 = Math_fround(HEAPF32[i77 >> 2]);
        f91 = Math_fround(HEAPF32[i44 >> 2]);
        f93 = Math_fround(HEAPF32[i45 >> 2]);
        HEAPF32[i77 >> 2] = f92 < f90 ? f92 : f90;
        HEAPF32[i44 >> 2] = f88 < f91 ? f88 : f91;
        HEAPF32[i45 >> 2] = f89 < f93 ? f89 : f93;
        f93 = Math_fround(HEAPF32[i23 >> 2]);
        f93 = Math_fround(f93 + Math_fround(HEAPF32[i24 >> 2]));
        f89 = Math_fround(HEAPF32[i25 >> 2]);
        f89 = Math_fround(f89 + Math_fround(HEAPF32[i26 >> 2]));
        f91 = Math_fround(HEAPF32[i27 >> 2]);
        f91 = Math_fround(f91 + Math_fround(HEAPF32[i13 >> 2]));
        f88 = Math_fround(HEAPF32[i46 >> 2]);
        f90 = Math_fround(HEAPF32[i47 >> 2]);
        f92 = Math_fround(HEAPF32[i48 >> 2]);
        HEAPF32[i46 >> 2] = f88 < f93 ? f93 : f88;
        HEAPF32[i47 >> 2] = f90 < f89 ? f89 : f90;
        HEAPF32[i48 >> 2] = f92 < f91 ? f91 : f92;
       }
       __ZN13BatchRenderer3AddERK17BatchInstanceData(i85, i78);
       i7 = i35;
      }
      i12 = i12 + 1 | 0;
     } while ((i12 | 0) != (i29 | 0));
    } else {
     i7 = i31;
     i6 = i32;
     i5 = i33;
     i4 = i34;
     i3 = i37;
    }
   }
   i42 = i42 + 1 | 0;
   if ((i42 | 0) == (i62 | 0)) break; else {
    i31 = i7;
    i32 = i6;
    i33 = i5;
    i34 = i4;
    i37 = i3;
   }
  }
 }
 __ZN13BatchRenderer5FlushEv(i85);
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 i80 = HEAP32[i81 >> 2] | 0;
 i1 = HEAP32[i80 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i1 + 1136 | 0, 5, i82, HEAP32[i80 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i1 + 4 >> 2] | 0);
 i81 = HEAP32[i81 >> 2] | 0;
 i1 = HEAP32[i81 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i1 + 1136 | 0, 5, i82, HEAP32[i81 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i1 + 4 >> 2] | 0);
 i1 = HEAP32[i83 >> 2] | 0;
 __ZN13BatchRendererD2Ev(i85);
 HEAP32[gb + 1163232 >> 2] = i86;
 i86 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i86 >> 2] | 0) + 652 >> 2] | 0, i86 | 0);
 if (!i84) {
  STACKTOP = i87;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i84);
 STACKTOP = i87;
 return i1 | 0;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i4, i12, i2, i1) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i4 + ((i2 >> 1) * 24 | 0) | 0;
 if ((i2 | 0) < 65) {
  i1 = i10;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0 : 0)) {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   i2 = i10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  i8 = i12;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i7 >>> 0 < i1 >>> 0 | ((i7 | 0) == (i1 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
   HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   i2 = i10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (!(i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0 : 0))) {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   STACKTOP = i11;
   return;
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  STACKTOP = i11;
  return;
 }
 i6 = i2 >> 3;
 i7 = i6 << 1;
 i8 = i4 + (i6 * 24 | 0) | 0;
 i3 = i4 + (i7 * 24 | 0) | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 if (i2 >>> 0 < i13 >>> 0 | ((i2 | 0) == (i13 | 0) ? i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i8;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i3;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 if (i5 >>> 0 < i2 >>> 0 | ((i5 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i8;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i5 >>> 0 | ((i2 | 0) == (i5 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 }
 i5 = 0 - i6 | 0;
 i4 = i10 + (i5 * 24 | 0) | 0;
 i3 = i10 + (i6 * 24 | 0) | 0;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i4;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0 | ((i2 | 0) == (i6 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i3;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i6 >>> 0 < i2 >>> 0 | ((i6 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0 | ((i2 | 0) == (i6 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 }
 i3 = i12 + ((0 - i7 | 0) * 24 | 0) | 0;
 i4 = i12 + (i5 * 24 | 0) | 0;
 i1 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = i3;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i2 = i4;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i13 = i12;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i7 >>> 0 < i1 >>> 0 | ((i7 | 0) == (i1 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i2 = i4;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i13 = i3;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 }
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i8;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i7 >>> 0 | ((i2 | 0) == (i7 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i7 >>> 0 < i2 >>> 0 | ((i7 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i8;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (!(i2 >>> 0 < i7 >>> 0 | ((i2 | 0) == (i7 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  STACKTOP = i11;
  return;
 };
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i58, i52) {
 i58 = i58 | 0;
 i52 = i52 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, i92 = 0, i93 = 0, f94 = f0, f95 = f0, f96 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i63 + 144 | 0;
 i59 = i63 + 128 | 0;
 i2 = i63 + 96 | 0;
 i8 = i63 + 64 | 0;
 i56 = i63 + 48 | 0;
 i57 = i63 + 32 | 0;
 i61 = i63 + 16 | 0;
 i62 = i63;
 i55 = i58 + 8 | 0;
 i1 = HEAP16[i55 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i58 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i6 = i1 + 4 | 0;
  i5 = i1;
  i4 = i1 + 24 | 0;
  i3 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i2, HEAP32[i58 >> 2] | 0, i1 & 65535);
  i7 = i2 + 8 | 0;
  i6 = i2 + 4 | 0;
  i5 = i2;
  i4 = i2 + 24 | 0;
  i3 = i2 + 20 | 0;
  i1 = i2 + 16 | 0;
 }
 i28 = HEAP32[i1 >> 2] | 0;
 i25 = HEAP32[i3 >> 2] | 0;
 i27 = HEAP32[i4 >> 2] | 0;
 i22 = HEAP32[i5 >> 2] | 0;
 i26 = HEAP32[i6 >> 2] | 0;
 i24 = HEAP32[i7 >> 2] | 0;
 i53 = i58 + 12 | 0;
 i1 = HEAP16[i53 >> 1] | 0;
 i54 = i58 + 4 | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i54 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i5 = i1 + 4 | 0;
  i4 = i1;
  i3 = i1 + 24 | 0;
  i2 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i8, HEAP32[i54 >> 2] | 0, i1 & 65535);
  i6 = i8 + 8 | 0;
  i5 = i8 + 4 | 0;
  i4 = i8;
  i3 = i8 + 24 | 0;
  i2 = i8 + 20 | 0;
  i1 = i8 + 16 | 0;
 }
 i23 = HEAP32[i1 >> 2] | 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i58 + 16 >> 2] | 0;
 i50 = HEAP16[i58 + 26 >> 1] | 0;
 i51 = i5 + ((i50 & 65535) << 4) | 0;
 if (!(i50 << 16 >> 16)) {
  i3 = i24;
  i6 = i26;
  i24 = i28;
  i26 = i1;
  i5 = i21;
  i2 = i23;
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  f17 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  i2 = i23;
  i23 = i27;
  i6 = i26;
  i3 = i24;
  while (1) {
   i27 = i5 + 32 | 0;
   i26 = HEAP8[i5 + 5 >> 0] | 0;
   i42 = i26 & 255;
   i47 = HEAP8[i5 + 6 >> 0] | 0;
   i50 = i47 & 255;
   i49 = (i42 * 112 | 0) + 32 | 0;
   i48 = i5 + i49 | 0;
   if (!(i26 << 24 >> 24)) {
    i24 = i28;
    f29 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f30 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    f38 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f31 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f33 = Math_fround(0.0);
    f40 = Math_fround(0.0);
   } else {
    f30 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f31 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f38 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f33 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    i24 = i28;
    i26 = 0;
    do {
     i74 = i26;
     i26 = i26 + 1 | 0;
     f67 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) >> 2]);
     f66 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 4 >> 2]);
     f65 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 8 >> 2]);
     f89 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 12 >> 2]);
     f70 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 16 >> 2]);
     f69 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 20 >> 2]);
     f68 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 24 >> 2]);
     i28 = i27 + (i74 * 112 | 0) + 28 | 0;
     f45 = Math_fround(HEAPF32[i28 >> 2]);
     f64 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 32 >> 2]);
     f43 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 36 >> 2]);
     f44 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 40 >> 2]);
     f91 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 60 >> 2]);
     f90 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 44 >> 2]);
     f82 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f88 = Math_fround(f82 * f70);
     f81 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f86 = Math_fround(f81 * f69);
     f77 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f46 = Math_fround(f77 * f68);
     f85 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f88 = Math_fround(Math_fround(f85 * f67) + f88);
     f86 = Math_fround(Math_fround(f84 * f66) + f86);
     f46 = Math_fround(Math_fround(f80 * f65) + f46);
     f76 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f87 = Math_fround(f76 * f64);
     f75 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f72 = Math_fround(f75 * f43);
     f71 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f71 * f44);
     f79 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f78 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f73 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(Math_fround(Math_fround(f89 * f91) - f90) - Math_fround(f89 * Math_fround(Math_fround(Math_fround(f88 - Math_fround(Math_fround(f79 * f67) + f87)) + Math_fround(f86 - Math_fround(Math_fround(f78 * f66) + f72))) + Math_fround(f46 - Math_fround(Math_fround(f73 * f65) + f83)))));
     f46 = Math_fround(-f45);
     f46 = f83 > f46 ? f83 : f46;
     f83 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 80 >> 2]);
     f72 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 84 >> 2]);
     f83 = Math_fround(f85 + Math_fround(f83 * f46));
     f72 = Math_fround(f84 + Math_fround(f72 * f46));
     f80 = Math_fround(f80 + Math_fround(Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 88 >> 2]) * f46));
     i22 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
     f80 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 48 >> 2]);
     f72 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 52 >> 2]);
     f80 = Math_fround(f82 + Math_fround(f80 * f46));
     f72 = Math_fround(f81 + Math_fround(f72 * f46));
     f77 = Math_fround(f77 + Math_fround(Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 56 >> 2]) * f46));
     i24 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
     i25 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i23 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     f77 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 96 >> 2]);
     f72 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 100 >> 2]);
     f77 = Math_fround(f79 + Math_fround(f46 * f77));
     f72 = Math_fround(f78 + Math_fround(f46 * f72));
     f73 = Math_fround(f73 + Math_fround(f46 * Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 104 >> 2])));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
     f73 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 64 >> 2]);
     f72 = Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 68 >> 2]);
     f73 = Math_fround(f76 + Math_fround(f46 * f73));
     f72 = Math_fround(f75 + Math_fround(f46 * f72));
     f71 = Math_fround(f71 + Math_fround(f46 * Math_fround(HEAPF32[i27 + (i74 * 112 | 0) + 72 >> 2])));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
     f67 = Math_fround(f67 * f46);
     f66 = Math_fround(f66 * f46);
     f65 = Math_fround(f65 * f46);
     f30 = Math_fround(f30 + f67);
     f32 = Math_fround(f32 + f66);
     f35 = Math_fround(f35 + f65);
     f31 = Math_fround(f31 + Math_fround(f70 * f46));
     f34 = Math_fround(f34 + Math_fround(f69 * f46));
     f36 = Math_fround(f36 + Math_fround(f68 * f46));
     f37 = Math_fround(f37 + f67);
     f38 = Math_fround(f38 + f66);
     f39 = Math_fround(f39 + f65);
     f40 = Math_fround(f40 + Math_fround(f64 * f46));
     f33 = Math_fround(f33 + Math_fround(f43 * f46));
     f41 = Math_fround(f41 + Math_fround(f44 * f46));
     HEAPF32[i28 >> 2] = Math_fround(f45 + f46);
     f29 = Math_fround(Math_fround(f29 + f45) + f46);
    } while ((i26 | 0) != (i42 | 0));
   }
   if (i47 << 24 >> 24 != 0 & (HEAP8[i52 >> 0] | 0) != 0) {
    f46 = Math_fround(f29 * Math_fround(HEAPF32[i5 + 16 >> 2]));
    f43 = Math_fround(f29 * Math_fround(HEAPF32[i5 + 20 >> 2]));
    f44 = Math_fround(-f43);
    f45 = Math_fround(-f46);
    f29 = f41;
    i26 = 0;
    do {
     i93 = i26;
     i26 = i26 + 1 | 0;
     f83 = Math_fround(HEAPF32[i48 + (i93 << 7) >> 2]);
     f84 = Math_fround(HEAPF32[i48 + (i93 << 7) + 4 >> 2]);
     f85 = Math_fround(HEAPF32[i48 + (i93 << 7) + 8 >> 2]);
     i92 = i48 + (i93 << 7) + 12 | 0;
     f89 = Math_fround(HEAPF32[i92 >> 2]);
     f80 = Math_fround(HEAPF32[i48 + (i93 << 7) + 16 >> 2]);
     f81 = Math_fround(HEAPF32[i48 + (i93 << 7) + 20 >> 2]);
     f82 = Math_fround(HEAPF32[i48 + (i93 << 7) + 24 >> 2]);
     f68 = Math_fround(HEAPF32[i48 + (i93 << 7) + 28 >> 2]);
     f86 = Math_fround(HEAPF32[i48 + (i93 << 7) + 32 >> 2]);
     f87 = Math_fround(HEAPF32[i48 + (i93 << 7) + 36 >> 2]);
     f88 = Math_fround(HEAPF32[i48 + (i93 << 7) + 40 >> 2]);
     f65 = Math_fround(HEAPF32[i48 + (i93 << 7) + 44 >> 2]);
     f78 = Math_fround(HEAPF32[i48 + (i93 << 7) + 76 >> 2]);
     f70 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f96 = Math_fround(f70 * f80);
     f69 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f94 = Math_fround(f69 * f81);
     f73 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f64 = Math_fround(f73 * f82);
     f66 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f91 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f96 = Math_fround(Math_fround(f66 * f83) + f96);
     f94 = Math_fround(Math_fround(f67 * f84) + f94);
     f64 = Math_fround(Math_fround(f91 * f85) + f64);
     f75 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f95 = Math_fround(f75 * f86);
     f76 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f41 = Math_fround(f76 * f87);
     f79 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f90 = Math_fround(f79 * f88);
     f71 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f72 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f77 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f90 = Math_fround(Math_fround(Math_fround(f96 - Math_fround(Math_fround(f71 * f83) + f95)) + Math_fround(f94 - Math_fround(Math_fround(f72 * f84) + f41))) + Math_fround(f64 - Math_fround(Math_fround(f77 * f85) + f90)));
     f78 = Math_fround(f89 - Math_fround(f68 * Math_fround(f65 - f78)));
     i27 = i48 + (i93 << 7) + 48 | 0;
     i74 = i48 + (i93 << 7) + 60 | 0;
     i47 = HEAP32[i74 >> 2] | 0;
     f90 = Math_fround(f78 - Math_fround(f68 * f90));
     i28 = f90 < f45;
     i42 = f90 > f46;
     f90 = i28 ? (f90 < f44 ? f44 : f90) : i42 ? (f43 > f90 ? f90 : f43) : f90;
     f89 = Math_fround(f90 - f89);
     f68 = Math_fround(HEAPF32[i48 + (i93 << 7) + 96 >> 2]);
     f78 = Math_fround(HEAPF32[i48 + (i93 << 7) + 100 >> 2]);
     f68 = Math_fround(f66 + Math_fround(f68 * f89));
     f78 = Math_fround(f67 + Math_fround(f78 * f89));
     f91 = Math_fround(f91 + Math_fround(Math_fround(HEAPF32[i48 + (i93 << 7) + 104 >> 2]) * f89));
     i22 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f91, HEAP32[tempDoublePtr >> 2] | 0);
     f91 = Math_fround(HEAPF32[i27 >> 2]);
     f78 = Math_fround(HEAPF32[i48 + (i93 << 7) + 52 >> 2]);
     f70 = Math_fround(f70 + Math_fround(f91 * f89));
     f78 = Math_fround(f69 + Math_fround(f78 * f89));
     f73 = Math_fround(f73 + Math_fround(Math_fround(HEAPF32[i48 + (i93 << 7) + 56 >> 2]) * f89));
     i24 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     i25 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
     i23 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
     f73 = Math_fround(HEAPF32[i48 + (i93 << 7) + 112 >> 2]);
     f78 = Math_fround(HEAPF32[i48 + (i93 << 7) + 116 >> 2]);
     f73 = Math_fround(f71 + Math_fround(f73 * f89));
     f78 = Math_fround(f72 + Math_fround(f78 * f89));
     f77 = Math_fround(f77 + Math_fround(f89 * Math_fround(HEAPF32[i48 + (i93 << 7) + 120 >> 2])));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     f77 = Math_fround(HEAPF32[i48 + (i93 << 7) + 64 >> 2]);
     f78 = Math_fround(HEAPF32[i48 + (i93 << 7) + 68 >> 2]);
     f77 = Math_fround(f75 + Math_fround(f89 * f77));
     f78 = Math_fround(f76 + Math_fround(f89 * f78));
     f79 = Math_fround(f79 + Math_fround(f89 * Math_fround(HEAPF32[i48 + (i93 << 7) + 72 >> 2])));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
     f83 = Math_fround(f83 * f89);
     f84 = Math_fround(f84 * f89);
     f85 = Math_fround(f85 * f89);
     f30 = Math_fround(f30 + f83);
     f32 = Math_fround(f32 + f84);
     f35 = Math_fround(f35 + f85);
     f31 = Math_fround(f31 + Math_fround(f80 * f89));
     f34 = Math_fround(f34 + Math_fround(f81 * f89));
     f36 = Math_fround(f36 + Math_fround(f82 * f89));
     f37 = Math_fround(f37 + f83);
     f38 = Math_fround(f38 + f84);
     f39 = Math_fround(f39 + f85);
     f40 = Math_fround(f40 + Math_fround(f86 * f89));
     f33 = Math_fround(f33 + Math_fround(f87 * f89));
     f29 = Math_fround(f29 + Math_fround(f88 * f89));
     HEAPF32[i92 >> 2] = f90;
     HEAPF32[i27 >> 2] = f91;
     HEAP32[i74 >> 2] = i28 | i42 ? 1065353216 : i47;
    } while ((i26 | 0) != (i50 | 0));
   } else f29 = f41;
   f96 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f30 * f96));
   f19 = Math_fround(f19 + Math_fround(f32 * f96));
   f20 = Math_fround(f20 + Math_fround(f35 * f96));
   f96 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f31 * f96));
   f13 = Math_fround(f13 + Math_fround(f34 * f96));
   f14 = Math_fround(f14 + Math_fround(f36 * f96));
   f96 = Math_fround(HEAPF32[i5 + 28 >> 2]);
   f15 = Math_fround(f15 - Math_fround(f37 * f96));
   f16 = Math_fround(f16 - Math_fround(f38 * f96));
   f18 = Math_fround(f18 - Math_fround(f39 * f96));
   f96 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   i5 = i5 + (i49 + (i50 << 7)) | 0;
   f9 = Math_fround(f9 - Math_fround(f40 * f96));
   f10 = Math_fround(f10 - Math_fround(f33 * f96));
   f12 = Math_fround(f12 - Math_fround(f29 * f96));
   if (i5 >>> 0 >= i51 >>> 0) {
    i27 = i23;
    i26 = i1;
    i5 = i21;
    break;
   } else i28 = i24;
  }
 }
 i1 = HEAP16[i55 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i93 = HEAP32[i58 >> 2] | 0;
  HEAP32[i93 >> 2] = i22;
  HEAP32[i93 + 4 >> 2] = i6;
  HEAP32[i93 + 8 >> 2] = i3;
  HEAP32[i93 + 16 >> 2] = i24;
  HEAP32[i93 + 20 >> 2] = i25;
  HEAP32[i93 + 24 >> 2] = i27;
 } else {
  i93 = HEAP32[i58 >> 2] | 0;
  HEAPF32[i56 >> 2] = f17;
  HEAPF32[i56 + 4 >> 2] = f19;
  HEAPF32[i56 + 8 >> 2] = f20;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i57 >> 2] = f11;
  HEAPF32[i57 + 4 >> 2] = f13;
  HEAPF32[i57 + 8 >> 2] = f14;
  HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i59 >> 2] = HEAP32[i56 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
  HEAP32[i59 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
  HEAP32[i60 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAP32[i60 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i93, i1 & 65535, i59, i60);
 }
 i1 = HEAP16[i53 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i93 = HEAP32[i54 >> 2] | 0;
  HEAP32[i93 >> 2] = i7;
  HEAP32[i93 + 4 >> 2] = i4;
  HEAP32[i93 + 8 >> 2] = i26;
  HEAP32[i93 + 16 >> 2] = i2;
  HEAP32[i93 + 20 >> 2] = i5;
  HEAP32[i93 + 24 >> 2] = i8;
  STACKTOP = i63;
  return;
 } else {
  i93 = HEAP32[i54 >> 2] | 0;
  HEAPF32[i61 >> 2] = f15;
  HEAPF32[i61 + 4 >> 2] = f16;
  HEAPF32[i61 + 8 >> 2] = f18;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i62 >> 2] = f9;
  HEAPF32[i62 + 4 >> 2] = f10;
  HEAPF32[i62 + 8 >> 2] = f12;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i59 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i59 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  HEAP32[i60 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
  HEAP32[i60 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i93, i1 & 65535, i59, i60);
  STACKTOP = i63;
  return;
 }
}

function __ZL51RenameMotionCurvesToRootCurvesBackwardCompatibilityRNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i68 + 16 | 0;
 i18 = i68;
 i29 = i6 + 4 | 0;
 if ((HEAP32[i29 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i68;
  return;
 }
 i65 = i7 + 12 | 0;
 i66 = i7 + 11 | 0;
 i67 = i7 + 9 | 0;
 i8 = i18 + 12 | 0;
 i9 = i18 + 11 | 0;
 i10 = i18 + 7 | 0;
 i11 = i18 + 12 | 0;
 i12 = i7 + 4 | 0;
 i13 = i7 + 12 | 0;
 i14 = i7 + 11 | 0;
 i15 = i7 + 9 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18 + 11 | 0;
 i19 = i18 + 7 | 0;
 i20 = i18 + 12 | 0;
 i21 = i7 + 4 | 0;
 i22 = i7 + 12 | 0;
 i23 = i7 + 11 | 0;
 i24 = i7 + 9 | 0;
 i25 = i18 + 12 | 0;
 i26 = i18 + 11 | 0;
 i27 = i18 + 7 | 0;
 i28 = i18 + 12 | 0;
 i30 = i7 + 4 | 0;
 i31 = i7 + 12 | 0;
 i32 = i7 + 11 | 0;
 i33 = i7 + 9 | 0;
 i34 = i18 + 12 | 0;
 i35 = i18 + 11 | 0;
 i36 = i18 + 7 | 0;
 i37 = i18 + 12 | 0;
 i38 = i7 + 4 | 0;
 i39 = i7 + 12 | 0;
 i40 = i7 + 11 | 0;
 i41 = i7 + 9 | 0;
 i42 = i18 + 12 | 0;
 i43 = i18 + 11 | 0;
 i44 = i18 + 7 | 0;
 i45 = i18 + 12 | 0;
 i46 = i7 + 4 | 0;
 i47 = i7 + 12 | 0;
 i48 = i7 + 11 | 0;
 i49 = i7 + 9 | 0;
 i50 = i18 + 12 | 0;
 i51 = i18 + 11 | 0;
 i52 = i18 + 7 | 0;
 i53 = i18 + 12 | 0;
 i54 = i7 + 4 | 0;
 i55 = i7 + 12 | 0;
 i56 = i7 + 11 | 0;
 i57 = i7 + 9 | 0;
 i58 = i18 + 12 | 0;
 i59 = i18 + 11 | 0;
 i60 = i18 + 7 | 0;
 i61 = i18 + 12 | 0;
 i62 = i7 + 4 | 0;
 i5 = 0;
 i63 = HEAP32[i6 >> 2] | 0;
 do {
  do if ((HEAP32[i63 + (i5 * 132 | 0) + 32 >> 2] | 0) == 95) {
   i1 = i63 + (i5 * 132 | 0) + 16 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i65 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i66 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909862 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i67 >> 0] = 0;
   i64 = i1 + 11 | 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i9 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909932 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909932 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909932 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909932 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909932 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909932 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909932 + 6 >> 0] | 0;
     HEAP8[i10 >> 0] = 0;
     L19 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L19;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i9 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i11 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i12 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i13 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i14 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909872 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i15 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i17 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909940 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909940 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909940 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909940 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909940 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909940 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909940 + 6 >> 0] | 0;
     HEAP8[i19 >> 0] = 0;
     L48 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L48;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i17 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i20 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i21 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i22 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i23 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909882 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i24 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i25 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i26 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909948 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909948 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909948 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909948 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909948 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909948 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909948 + 6 >> 0] | 0;
     HEAP8[i27 >> 0] = 0;
     L77 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L77;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i26 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i28 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i30 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i31 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i32 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909892 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i33 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i34 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i35 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909956 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909956 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909956 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909956 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909956 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909956 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909956 + 6 >> 0] | 0;
     HEAP8[i36 >> 0] = 0;
     L106 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L106;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i35 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i37 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i38 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i39 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i40 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909902 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i41 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i42 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i43 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909964 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909964 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909964 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909964 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909964 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909964 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909964 + 6 >> 0] | 0;
     HEAP8[i44 >> 0] = 0;
     L135 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L135;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i43 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i45 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i46 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i47 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i48 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909912 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i49 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == 9) {
    if (i2) {
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
    } else {
     i3 = i1;
     i2 = i4 & 255;
    }
    if (!(_strncmp(i3, i7, i2) | 0)) {
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     HEAP32[i50 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP8[i51 >> 0] = 7;
     HEAP8[i18 >> 0] = HEAP8[gb + 909972 >> 0] | 0;
     HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909972 + 1 >> 0] | 0;
     HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909972 + 2 >> 0] | 0;
     HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909972 + 3 >> 0] | 0;
     HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909972 + 4 >> 0] | 0;
     HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909972 + 5 >> 0] | 0;
     HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909972 + 6 >> 0] | 0;
     HEAP8[i52 >> 0] = 0;
     L164 : do if ((i1 | 0) != (i18 | 0)) {
      do if ((HEAP8[i64 >> 0] | 0) < 0) {
       i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
       i3 = i2 + -1 | 0;
       if (i3 >>> 0 < 7) {
        i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
        break L164;
       } else {
        i1 = HEAP32[i1 >> 2] | 0;
        break;
       }
      } while (0);
      _memmove(i1 | 0, i18 | 0, 7) | 0;
      HEAP8[i1 + 7 >> 0] = 0;
      if ((HEAP8[i64 >> 0] | 0) < 0) {
       HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
       break;
      } else {
       HEAP8[i64 >> 0] = 7;
       break;
      }
     } while (0);
     if ((HEAP8[i51 >> 0] | 0) < 0) {
      i64 = HEAP32[i18 >> 2] | 0;
      i63 = HEAP32[i53 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i54 >> 2] = i63;
      __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
     }
     break;
    }
   };
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i55 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i56 >> 0] = 9;
   i2 = i7;
   i3 = gb + 909922 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i57 >> 0] = 0;
   i4 = HEAP8[i64 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   if (i2) i3 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) != 9) break;
   if (i2) {
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
   } else {
    i3 = i1;
    i2 = i4 & 255;
   }
   if (!(_strncmp(i3, i7, i2) | 0)) {
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i58 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP8[i59 >> 0] = 7;
    HEAP8[i18 >> 0] = HEAP8[gb + 909980 >> 0] | 0;
    HEAP8[i18 + 1 >> 0] = HEAP8[gb + 909980 + 1 >> 0] | 0;
    HEAP8[i18 + 2 >> 0] = HEAP8[gb + 909980 + 2 >> 0] | 0;
    HEAP8[i18 + 3 >> 0] = HEAP8[gb + 909980 + 3 >> 0] | 0;
    HEAP8[i18 + 4 >> 0] = HEAP8[gb + 909980 + 4 >> 0] | 0;
    HEAP8[i18 + 5 >> 0] = HEAP8[gb + 909980 + 5 >> 0] | 0;
    HEAP8[i18 + 6 >> 0] = HEAP8[gb + 909980 + 6 >> 0] | 0;
    HEAP8[i60 >> 0] = 0;
    L194 : do if ((i1 | 0) != (i18 | 0)) {
     do if ((HEAP8[i64 >> 0] | 0) < 0) {
      i2 = HEAP32[i63 + (i5 * 132 | 0) + 24 >> 2] & 2147483647;
      i3 = i2 + -1 | 0;
      if (i3 >>> 0 < 7) {
       i64 = HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i64, 0, i64, 7, i18);
       break L194;
      } else {
       i1 = HEAP32[i1 >> 2] | 0;
       break;
      }
     } while (0);
     _memmove(i1 | 0, i18 | 0, 7) | 0;
     HEAP8[i1 + 7 >> 0] = 0;
     if ((HEAP8[i64 >> 0] | 0) < 0) {
      HEAP32[i63 + (i5 * 132 | 0) + 20 >> 2] = 7;
      break;
     } else {
      HEAP8[i64 >> 0] = 7;
      break;
     }
    } while (0);
    if ((HEAP8[i59 >> 0] | 0) < 0) {
     i64 = HEAP32[i18 >> 2] | 0;
     i63 = HEAP32[i61 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i62 >> 2] = i63;
     __Z19free_alloc_internalPvRK10MemLabelId(i64, i7);
    }
   }
  } while (0);
  i5 = i5 + 1 | 0;
  i63 = HEAP32[i6 >> 2] | 0;
 } while (i5 >>> 0 < (((HEAP32[i29 >> 2] | 0) - i63 | 0) / 132 | 0) >>> 0);
 STACKTOP = i68;
 return;
}

function __ZN5physx23PxsSolverSetupSolveTask11runInternalEv(i40) {
 i40 = i40 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, f60 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i46 + 4 | 0;
 i38 = i46;
 i44 = HEAP32[HEAP32[i40 + 24 >> 2] >> 2] | 0;
 i27 = i44 + 8928 | 0;
 i25 = HEAP32[i27 >> 2] | 0;
 i45 = i40 + 20 | 0;
 i43 = HEAP32[i45 >> 2] | 0;
 i41 = i40 + 64 | 0;
 i42 = (HEAP32[i43 + 100 >> 2] | 0) + (HEAP32[i41 >> 2] << 5) | 0;
 i43 = HEAP32[i43 + 112 >> 2] | 0;
 i26 = i44 + 8800 | 0;
 i3 = HEAP32[i26 >> 2] | 0;
 i39 = i44 + 8820 | 0;
 i24 = i44 + 8824 | 0;
 if (!(HEAP32[i24 >> 2] | 0)) {
  i1 = i25;
  i2 = 0;
  i5 = 0;
  i4 = 0;
 } else {
  i16 = i44 + 8940 | 0;
  i5 = HEAP32[i39 >> 2] | 0;
  i17 = 0;
  i1 = i25;
  i18 = 0;
  i2 = 0;
  i6 = 0;
  i4 = 0;
  while (1) {
   i14 = (HEAP32[i5 + (i17 << 2) >> 2] | 0) + i18 | 0;
   if (i18 >>> 0 < i14 >>> 0) {
    i15 = i18;
    i7 = i2;
    i2 = 0;
    do {
     i11 = HEAP16[(HEAP32[i16 >> 2] | 0) + (i15 << 3) + 4 >> 1] | 0;
     if (i11 << 16 >> 16) {
      i13 = i11 + -1 & 65535;
      i12 = 0;
      i10 = i7;
      i9 = i6;
      i8 = i11;
      while (1) {
       i5 = i25 + (i10 << 5) | 0;
       if (!(HEAP16[i25 + (i10 << 5) + 26 >> 1] | 0)) i8 = i8 + -1 << 16 >> 16; else {
        if ((i10 | 0) != (i9 | 0)) {
         i37 = i25 + (i9 << 5) | 0;
         HEAP32[i37 >> 2] = HEAP32[i5 >> 2];
         HEAP32[i37 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
         HEAP32[i37 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
         HEAP32[i37 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
         HEAP32[i37 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
         HEAP32[i37 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
         HEAP32[i37 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
         HEAP32[i37 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
        }
        i1 = i1 + 32 | 0;
        i9 = i9 + 1 | 0;
       }
       i12 = i12 + 1 << 16 >> 16;
       if ((i12 & 65535) >= (i11 & 65535)) {
        i11 = i9;
        break;
       } else i10 = i10 + 1 | 0;
      }
      i10 = i7 + 1 + i13 | 0;
      if (!(i8 << 16 >> 16)) {
       i7 = i10;
       i6 = i11;
      } else {
       i9 = HEAP32[i16 >> 2] | 0;
       HEAP32[i9 + (i4 << 3) >> 2] = i6;
       HEAP16[i9 + (i4 << 3) + 4 >> 1] = i8;
       i5 = HEAP8[HEAP32[i25 + (i6 << 5) + 16 >> 2] >> 0] | 0;
       if (i5 << 24 >> 24 == 5) if ((i8 & 65535) > 1) {
        i7 = i8 & 65535;
        i8 = 1;
        i5 = 5;
        do {
         i5 = (HEAP8[HEAP32[i25 + (i8 + i6 << 5) + 16 >> 2] >> 0] | 0) == 1 ? 1 : i5;
         i8 = i8 + 1 | 0;
        } while ((i8 | 0) != (i7 | 0));
       } else i5 = 5;
       HEAP16[i9 + (i4 << 3) + 6 >> 1] = i5 & 255;
       i7 = i10;
       i6 = i11;
       i4 = i4 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
     i15 = i15 + 1 | 0;
    } while ((i15 | 0) != (i14 | 0));
   } else {
    i7 = i2;
    i2 = 0;
   }
   i5 = HEAP32[i39 >> 2] | 0;
   i37 = i5 + (i17 << 2) | 0;
   i18 = (HEAP32[i37 >> 2] | 0) + i18 | 0;
   HEAP32[i37 >> 2] = i2;
   i17 = i17 + 1 | 0;
   if (i17 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) {
    i2 = i7;
    i5 = i6;
    break;
   } else i2 = i7;
  }
 }
 i14 = i1 - i25 >> 5;
 HEAP32[i44 + 8796 >> 2] = i14;
 i10 = HEAP32[i44 + 8812 >> 2] | 0;
 if (!i10) {
  i1 = i4;
  i37 = i5;
 } else {
  i11 = i44 + 9036 | 0;
  i12 = i44 + 8940 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i13 = 0;
  i1 = i4;
  while (1) {
   i9 = HEAP32[i6 + (i13 << 4) + 4 >> 2] | 0;
   if (!i9) i4 = i5; else {
    i7 = 0;
    i8 = i2;
    i6 = i5;
    while (1) {
     i4 = i25 + (i8 << 5) | 0;
     if (!(HEAP16[i25 + (i8 << 5) + 26 >> 1] | 0)) i4 = i6; else {
      i37 = HEAP32[i12 >> 2] | 0;
      HEAP16[i37 + (i1 << 3) + 4 >> 1] = 1;
      HEAP32[i37 + (i1 << 3) >> 2] = i6;
      HEAP16[i37 + (i1 << 3) + 6 >> 1] = HEAPU8[HEAP32[i25 + (i8 << 5) + 16 >> 2] >> 0] | 0;
      if ((i8 | 0) != (i6 | 0)) {
       i37 = i25 + (i6 << 5) | 0;
       HEAP32[i37 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i37 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i37 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i37 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i37 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
       HEAP32[i37 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
       HEAP32[i37 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
       HEAP32[i37 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
      }
      i4 = i6 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i9 | 0)) break; else {
      i8 = i8 + 1 | 0;
      i6 = i4;
     }
    }
    i6 = HEAP32[i11 >> 2] | 0;
    i2 = i2 + i9 | 0;
   }
   HEAP32[i6 + (i13 << 4) >> 2] = i5;
   HEAP32[i6 + (i13 << 4) + 4 >> 2] = i4 - i5;
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i10 | 0)) {
    i37 = i4;
    break;
   } else i5 = i4;
  }
 }
 i36 = i44 + 8940 | 0;
 i22 = i44 + 8944 | 0;
 HEAP32[i22 >> 2] = i1;
 HEAP32[i44 + 8804 >> 2] = i37 - i14;
 HEAP32[i44 + 9020 >> 2] = i37;
 i35 = i44 + 8764 | 0;
 i21 = i44 + 8916 | 0;
 if (HEAP32[i35 >> 2] | 0) {
  i18 = HEAP32[i21 >> 2] | 0;
  i19 = i44 + 8952 | 0;
  i20 = i44 + 8956 | 0;
  HEAP32[i20 >> 2] = 0;
  if ((HEAP32[i44 + 8960 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i19, i1);
  i1 = HEAP32[i19 >> 2] | 0;
  i15 = i44 + 8832 | 0;
  i16 = i44 + 8836 | 0;
  HEAP32[i16 >> 2] = 0;
  i2 = HEAP32[i44 + 8828 >> 2] & 2147483647;
  i17 = i44 + 8840 | 0;
  if ((HEAP32[i17 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i15, i2);
  if (!(HEAP32[i24 >> 2] | 0)) {
   i3 = 0;
   i2 = i18;
  } else {
   i12 = 0;
   i3 = 0;
   i2 = i18;
   i13 = 0;
   i14 = 0;
   while (1) {
    i4 = i14;
    i14 = (HEAP32[(HEAP32[i39 >> 2] | 0) + (i13 << 2) >> 2] | 0) + i14 | 0;
    do if (i4 >>> 0 < i14 >>> 0) {
     i6 = i12;
     do {
      i34 = HEAP32[i36 >> 2] | 0;
      i5 = i34 + (i4 << 3) | 0;
      i11 = HEAP16[i34 + (i4 << 3) + 4 >> 1] | 0;
      switch (HEAP16[i34 + (i4 << 3) + 6 >> 1] | 0) {
      case 5:
      case 3:
      case 1:
       {
        if (!(i11 << 16 >> 16)) i5 = 0; else {
         i10 = i11 + -1 & 65535;
         i7 = HEAP32[i5 >> 2] | 0;
         i8 = i2;
         i9 = 0;
         while (1) {
          i34 = i7 + i9 | 0;
          i5 = HEAP32[i25 + (i34 << 5) + 16 >> 2] | 0;
          i33 = HEAPU16[i5 + 2 >> 1] | 0;
          i5 = i5 + i33 | 0;
          HEAP16[i8 + 26 >> 1] = ((HEAPU16[i25 + (i34 << 5) + 26 >> 1] << 4) - i33 | 0) >>> 4;
          HEAP32[i8 + 16 >> 2] = i5;
          HEAP32[i8 >> 2] = HEAP32[i25 + (i34 << 5) >> 2];
          HEAP32[i8 + 4 >> 2] = HEAP32[i25 + (i34 << 5) + 4 >> 2];
          HEAP16[i8 + 10 >> 1] = HEAP16[i25 + (i34 << 5) + 10 >> 1] | 0;
          HEAP16[i8 + 14 >> 1] = HEAP16[i25 + (i34 << 5) + 14 >> 1] | 0;
          HEAP16[i8 + 8 >> 1] = HEAP16[i25 + (i34 << 5) + 8 >> 1] | 0;
          HEAP16[i8 + 12 >> 1] = HEAP16[i25 + (i34 << 5) + 12 >> 1] | 0;
          HEAP32[i8 + 20 >> 2] = 0;
          HEAP16[i8 + 24 >> 1] = 0;
          i9 = i9 + 1 | 0;
          if ((i9 & 65535) << 16 >> 16 == i11 << 16 >> 16) break; else i8 = i8 + 32 | 0;
         }
         i2 = i2 + (i10 + 1 << 5) | 0;
         i5 = HEAP8[i5 >> 0] | 0;
        }
        HEAP32[i1 >> 2] = i3;
        HEAP16[i1 + 4 >> 1] = i11;
        HEAP16[i1 + 6 >> 1] = i5 & 255;
        i6 = i6 + 1 | 0;
        i3 = (i11 & 65535) + i3 | 0;
        i1 = i1 + 8 | 0;
        break;
       }
      case 8:
      case 7:
       {
        i33 = HEAP32[i5 >> 2] | 0;
        i32 = HEAP32[i25 + (i33 << 5) + 16 >> 2] | 0;
        i31 = HEAPU16[i32 + 2 >> 1] | 0;
        i32 = i32 + i31 | 0;
        i34 = HEAP8[i32 >> 0] | 0;
        i31 = ((HEAPU16[i25 + (i33 << 5) + 26 >> 1] << 4) - i31 | 0) >>> 4 & 65535;
        HEAP16[i2 + 26 >> 1] = i31;
        HEAP32[i2 + 16 >> 2] = i32;
        HEAP32[i2 >> 2] = HEAP32[i25 + (i33 << 5) >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i25 + (i33 << 5) + 4 >> 2];
        HEAP16[i2 + 10 >> 1] = HEAP16[i25 + (i33 << 5) + 10 >> 1] | 0;
        HEAP16[i2 + 14 >> 1] = HEAP16[i25 + (i33 << 5) + 14 >> 1] | 0;
        HEAP16[i2 + 8 >> 1] = HEAP16[i25 + (i33 << 5) + 8 >> 1] | 0;
        HEAP16[i2 + 12 >> 1] = HEAP16[i25 + (i33 << 5) + 12 >> 1] | 0;
        HEAP32[i2 + 20 >> 2] = 0;
        HEAP16[i2 + 24 >> 1] = 0;
        i30 = i33 + 1 | 0;
        HEAP16[i2 + 58 >> 1] = i31;
        HEAP32[i2 + 48 >> 2] = i32;
        HEAP32[i2 + 32 >> 2] = HEAP32[i25 + (i30 << 5) >> 2];
        HEAP32[i2 + 36 >> 2] = HEAP32[i25 + (i30 << 5) + 4 >> 2];
        HEAP16[i2 + 42 >> 1] = HEAP16[i25 + (i30 << 5) + 10 >> 1] | 0;
        HEAP16[i2 + 46 >> 1] = HEAP16[i25 + (i30 << 5) + 14 >> 1] | 0;
        HEAP16[i2 + 40 >> 1] = HEAP16[i25 + (i30 << 5) + 8 >> 1] | 0;
        HEAP16[i2 + 44 >> 1] = HEAP16[i25 + (i30 << 5) + 12 >> 1] | 0;
        HEAP32[i2 + 52 >> 2] = 0;
        HEAP16[i2 + 56 >> 1] = 0;
        i30 = i33 + 2 | 0;
        HEAP16[i2 + 90 >> 1] = i31;
        HEAP32[i2 + 80 >> 2] = i32;
        HEAP32[i2 + 64 >> 2] = HEAP32[i25 + (i30 << 5) >> 2];
        HEAP32[i2 + 68 >> 2] = HEAP32[i25 + (i30 << 5) + 4 >> 2];
        HEAP16[i2 + 74 >> 1] = HEAP16[i25 + (i30 << 5) + 10 >> 1] | 0;
        HEAP16[i2 + 78 >> 1] = HEAP16[i25 + (i30 << 5) + 14 >> 1] | 0;
        HEAP16[i2 + 72 >> 1] = HEAP16[i25 + (i30 << 5) + 8 >> 1] | 0;
        HEAP16[i2 + 76 >> 1] = HEAP16[i25 + (i30 << 5) + 12 >> 1] | 0;
        HEAP32[i2 + 84 >> 2] = 0;
        HEAP16[i2 + 88 >> 1] = 0;
        i33 = i33 + 3 | 0;
        HEAP16[i2 + 122 >> 1] = i31;
        HEAP32[i2 + 112 >> 2] = i32;
        HEAP32[i2 + 96 >> 2] = HEAP32[i25 + (i33 << 5) >> 2];
        HEAP32[i2 + 100 >> 2] = HEAP32[i25 + (i33 << 5) + 4 >> 2];
        HEAP16[i2 + 106 >> 1] = HEAP16[i25 + (i33 << 5) + 10 >> 1] | 0;
        HEAP16[i2 + 110 >> 1] = HEAP16[i25 + (i33 << 5) + 14 >> 1] | 0;
        HEAP16[i2 + 104 >> 1] = HEAP16[i25 + (i33 << 5) + 8 >> 1] | 0;
        HEAP16[i2 + 108 >> 1] = HEAP16[i25 + (i33 << 5) + 12 >> 1] | 0;
        HEAP32[i2 + 116 >> 2] = 0;
        HEAP16[i2 + 120 >> 1] = 0;
        HEAP32[i1 >> 2] = i3;
        HEAP16[i1 + 4 >> 1] = i11;
        HEAP16[i1 + 6 >> 1] = i34 & 255;
        i6 = i6 + 1 | 0;
        i3 = (i11 & 65535) + i3 | 0;
        i2 = i2 + 128 | 0;
        i1 = i1 + 8 | 0;
        break;
       }
      default:
       {}
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i14 | 0));
     if (i6 >>> 0 > i12 >>> 0) {
      i4 = i6 - i12 | 0;
      HEAP32[i23 >> 2] = i4;
      i5 = HEAP32[i16 >> 2] | 0;
      if ((HEAP32[i17 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
       HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] = i4;
       HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
       i4 = i6;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i15, i23) | 0;
       i4 = i6;
       break;
      }
     } else i4 = i6;
    } else i4 = i12; while (0);
    i13 = i13 + 1 | 0;
    if (i13 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) break; else i12 = i4;
   }
  }
  i34 = i2 - i18 >> 5;
  HEAP32[i20 >> 2] = i1 - (HEAP32[i19 >> 2] | 0) >> 3;
  HEAP32[i44 + 8808 >> 2] = i3 - i34;
  HEAP32[i26 >> 2] = i34;
  HEAP32[i44 + 9024 >> 2] = i3;
 }
 i32 = HEAP32[i27 >> 2] | 0;
 i31 = HEAP32[i21 >> 2] | 0;
 i30 = i44 + 9080 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = 0;
 HEAP32[i30 + 20 >> 2] = 0;
 HEAP32[i30 + 24 >> 2] = 0;
 HEAP32[i30 + 28 >> 2] = 0;
 i25 = i44 + 9084 | 0;
 i33 = i44 + 9088 | 0;
 i26 = i44 + 9092 | 0;
 i34 = i44 + 9096 | 0;
 i27 = i44 + 9100 | 0;
 i28 = i44 + 9104 | 0;
 i29 = i44 + 9108 | 0;
 i5 = HEAP32[i44 + 9044 >> 2] | 0;
 i1 = i5 << 3;
 i6 = HEAP32[i40 + 8 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0) | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i1 = (i4 >>> 0) / ((i1 >>> 0 > 1 ? i1 : 1) >>> 0) | 0;
 i2 = i1 >>> 0 < i6 >>> 0 ? i1 : i6;
 if (i2 >>> 0 > 1) {
  i9 = (i1 << 3 >>> 0) / (i2 << 1 >>> 0) | 0;
  i9 = i9 >>> 0 > 8 ? i9 : 8;
  i10 = i44 + 9052 | 0;
  i11 = i44 + 9056 | 0;
  i12 = i40 + 48 | 0;
  i13 = i44 + 9124 | 0;
  i14 = i44 + 9128 | 0;
  i15 = i44 + 9112 | 0;
  i16 = i40 + 56 | 0;
  i17 = i44 + 8880 | 0;
  i18 = i44 + 8856 | 0;
  i19 = i44 + 9156 | 0;
  i20 = i40 + 32 | 0;
  i21 = i40 + 52 | 0;
  i22 = i44 + 8952 | 0;
  i23 = i40 + 28 | 0;
  i24 = i44 + 8832 | 0;
  i8 = i40 + 12 | 0;
  i1 = i5 << 3;
  i1 = (i4 >>> 0) / ((i1 >>> 0 > 1 ? i1 : 1) >>> 0) | 0;
  i1 = i1 >>> 0 > i6 >>> 0 ? i6 : i1;
  i7 = 1;
  do {
   i59 = HEAP32[(HEAP32[(HEAP32[i45 >> 2] | 0) + 96 >> 2] | 0) + 6960 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i59 >> 2] | 0);
   i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i59, 160, 16) | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i59 >> 2] | 0);
   i59 = HEAP32[i45 >> 2] | 0;
   i38 = HEAP32[i35 >> 2] | 0;
   i58 = HEAP32[i10 >> 2] | 0;
   i57 = HEAP32[i11 >> 2] | 0;
   i56 = HEAP32[i41 >> 2] | 0;
   i55 = HEAP32[i12 >> 2] | 0;
   i54 = HEAP32[i13 >> 2] | 0;
   i49 = HEAP32[i14 >> 2] | 0;
   i48 = HEAP32[i15 >> 2] | 0;
   i47 = HEAP32[i16 >> 2] | 0;
   i53 = HEAP32[i17 >> 2] | 0;
   i52 = HEAP32[i18 >> 2] | 0;
   i51 = HEAP32[i20 >> 2] | 0;
   i50 = HEAP32[i21 >> 2] & 2147483647;
   i6 = HEAP32[i23 >> 2] | 0;
   HEAP16[i2 + 4 >> 1] = -1;
   HEAP16[i2 + 6 >> 1] = 0;
   i4 = i2 + 8 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 87404 + 8;
   i5 = i2 + 12 | 0;
   HEAP32[i5 >> 2] = 0;
   i40 = i2 + 16 | 0;
   HEAP32[i40 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 106156 + 8;
   HEAP32[i2 + 20 >> 2] = i36;
   HEAP32[i2 + 24 >> 2] = i22;
   HEAP32[i2 + 28 >> 2] = i39;
   HEAP32[i2 + 32 >> 2] = i24;
   HEAP32[i2 + 36 >> 2] = i59;
   HEAP32[i2 + 40 >> 2] = i58;
   HEAP32[i2 + 44 >> 2] = i57;
   HEAP32[i2 + 48 >> 2] = i42;
   HEAP32[i2 + 52 >> 2] = i43;
   HEAP32[i2 + 56 >> 2] = i56;
   HEAP32[i2 + 60 >> 2] = i55;
   HEAP32[i2 + 64 >> 2] = i32;
   HEAP32[i2 + 68 >> 2] = i31;
   HEAP32[i2 + 72 >> 2] = i54;
   HEAP32[i2 + 76 >> 2] = i53;
   HEAP32[i2 + 80 >> 2] = i52;
   HEAP32[i2 + 84 >> 2] = i51;
   HEAP32[i2 + 88 >> 2] = i50;
   HEAP32[i2 + 92 >> 2] = i37;
   HEAP32[i2 + 96 >> 2] = i3;
   HEAP32[i2 + 100 >> 2] = i49;
   HEAP32[i2 + 104 >> 2] = i19;
   HEAP32[i2 + 108 >> 2] = i30;
   HEAP32[i2 + 112 >> 2] = i28;
   HEAP32[i2 + 116 >> 2] = i27;
   HEAP32[i2 + 120 >> 2] = i25;
   HEAP32[i2 + 124 >> 2] = i29;
   HEAP32[i2 + 128 >> 2] = i33;
   HEAP32[i2 + 132 >> 2] = i26;
   HEAP32[i2 + 136 >> 2] = i34;
   HEAP32[i2 + 140 >> 2] = i48;
   HEAP32[i2 + 144 >> 2] = i47;
   HEAP32[i2 + 148 >> 2] = i38;
   HEAP32[i2 + 152 >> 2] = i6;
   HEAP32[i2 + 156 >> 2] = i9;
   i6 = HEAP32[i8 >> 2] | 0;
   HEAP32[i40 >> 2] = 1;
   HEAP32[i5 >> 2] = i6;
   if (i6 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
    HEAP32[i4 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
  mftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii(HEAP32[gb + 106200 + (HEAP32[i35 >> 2] << 2) >> 2] | 0, HEAP32[i45 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, i42 | 0, i43 | 0, HEAP32[i41 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i44 + 9124 >> 2] | 0, HEAP32[i14 >> 2] | 0, i32 | 0, i37 | 0, i31 | 0, i3 | 0, i30 | 0, i28 | 0, i27 | 0, i25 | 0, i29 | 0, i26 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] | 0, i33 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] | 0, i19 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] & 2147483647 | 0, i34 | 0, i36 | 0, i22 | 0, i39 | 0, i24 | 0, HEAP32[i23 >> 2] | 0, i9 | 0);
  i2 = (HEAP32[i21 >> 2] & 2147483647) + (HEAP32[i12 >> 2] | 0) | 0;
  if ((HEAP32[i34 >> 2] | 0) < (i2 | 0)) if ((HEAP32[i34 >> 2] | 0) < (i2 | 0)) if ((HEAP32[i34 >> 2] | 0) < (i2 | 0)) {
   i1 = 3e4;
   do {
    i1 = i1 + -1 | 0;
    if (!i1) {
     __ZN5physx6shdfnd10ThreadImpl5yieldEv();
     i1 = 1e4;
    }
   } while ((HEAP32[i34 >> 2] | 0) < (i2 | 0));
  }
  HEAP32[i44 + 9060 >> 2] = HEAP32[i33 >> 2];
  STACKTOP = i46;
  return;
 }
 HEAP32[i38 >> 2] = 0;
 i59 = HEAP32[i45 >> 2] | 0;
 f60 = Math_fround(HEAPF32[i59 + 124 >> 2]);
 i4 = i40 + 48 | 0;
 i14 = i44 + 9124 | 0;
 i5 = i44 + 8880 | 0;
 mftCall_vifiiiiiiiiiiiiiiiiii(HEAP32[gb + 106212 + (HEAP32[i35 >> 2] << 2) >> 2] | 0, HEAP32[i59 + 136 >> 2] | 0, +f60, HEAP32[i44 + 9052 >> 2] | 0, HEAP32[i44 + 9056 >> 2] | 0, i42 | 0, i43 | 0, HEAP32[i41 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i44 + 9128 >> 2] | 0, i32 | 0, i37 | 0, i31 | 0, i3 | 0, i36 | 0, i44 + 8952 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i44 + 9112 >> 2] | 0, HEAP32[i40 + 56 >> 2] | 0, i38 | 0);
 HEAP32[i44 + 9060 >> 2] = HEAP32[i38 >> 2];
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i44 + 8856 | 0;
  i3 = i40 + 28 | 0;
  i1 = 0;
  do {
   __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, (HEAP32[i5 >> 2] | 0) + (i1 << 5) | 0, Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 124 >> 2]));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i11 = i40 + 52 | 0;
 if (!(HEAP32[i11 >> 2] & 2147483647)) {
  STACKTOP = i46;
  return;
 }
 i12 = i44 + 9156 | 0;
 i13 = i44 + 9160 | 0;
 i9 = i44 + 9164 | 0;
 i10 = 0;
 do {
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[gb + 1457376 >> 2] | 0;
  if (i1 | 0) mftCall_vif(i1 | 0, i2 + (i10 * 40 | 0) | 0, +Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + 124 >> 2]));
  i8 = i2 + (i10 * 40 | 0) + 36 | 0;
  i1 = HEAP16[i8 >> 1] | 0;
  if (i1 << 16 >> 16) {
   i7 = i2 + (i10 * 40 | 0) + 4 | 0;
   i6 = 0;
   do {
    i5 = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 5) + 16 >> 2] | 0) + 68 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if ((i5 | 0) != 1073741823) {
     i3 = (i5 + 32 | 0) >>> 5;
     if (i3 >>> 0 > (HEAP32[i13 >> 2] & 2147483647) >>> 0) {
      i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i3 << 2, gb + 769739 | 0, 329) | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      if (i1 | 0) {
       _memcpy(i2 | 0, i1 | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
       if ((HEAP32[i13 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i12 >> 2] | 0);
      }
      i1 = HEAP32[i13 >> 2] | 0;
      _memset(i2 + ((i1 & 2147483647) << 2) | 0, 0, i3 - i1 << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i2;
      HEAP32[i13 >> 2] = i3;
      i1 = HEAP16[i8 >> 1] | 0;
     } else i2 = HEAP32[i12 >> 2] | 0;
     i59 = _bitshift64Lshr(i4 | 0, i5 | 0, 37) | 0;
     getTempRet0() | 0;
     i59 = i2 + (i59 << 2) | 0;
     HEAP32[i59 >> 2] = HEAP32[i59 >> 2] | 1 << (i5 & 31);
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < (i1 & 65535) >>> 0);
  }
  i10 = i10 + 1 | 0;
 } while (i10 >>> 0 < (HEAP32[i11 >> 2] & 2147483647) >>> 0);
 STACKTOP = i46;
 return;
}

function _tre_add_tags(i21, i22, i3, i29) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i30 + 4 | 0;
 i23 = i30;
 i24 = i22 + 12 | 0;
 i25 = HEAP32[i24 >> 2] | 0;
 i26 = (i21 | 0) == 0 | (i29 | 0) == 0;
 if (!i26) {
  HEAP32[i29 + 48 >> 2] = 0;
  HEAP32[HEAP32[i29 + 36 >> 2] >> 2] = -1;
 }
 i2 = HEAP32[i29 + 28 >> 2] | 0;
 i27 = _malloc((i2 << 3) + 8 | 0) | 0;
 do if (!i27) i1 = 12; else {
  HEAP32[i27 >> 2] = -1;
  i28 = _malloc((i2 << 2) + 4 | 0) | 0;
  if (!i28) {
   _free(i27);
   i1 = 12;
   break;
  }
  HEAP32[i28 >> 2] = -1;
  i1 = 0;
  while (1) if (i1 >>> 0 > i2 >>> 0) break; else i1 = i1 + 1 | 0;
  HEAP32[i23 >> 2] = i3;
  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
  _tre_stack_push(i22, i20) | 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
  i1 = _tre_stack_push(i22, i20) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  L12 : do if ((i1 | 0) != 0 | (i4 | 0) <= (i25 | 0)) {
   i3 = i27;
   i9 = 0;
   i2 = 0;
   i8 = 0;
   i7 = -1;
  } else {
   i16 = i22 + 16 | 0;
   i17 = i29 + 32 | 0;
   i18 = i29 + 36 | 0;
   i19 = i29 + 16 | 0;
   i3 = i27;
   i9 = 0;
   i2 = 0;
   i8 = 0;
   i15 = 1;
   i7 = -1;
   i14 = 0;
   while (1) {
    i13 = i4 + -1 | 0;
    HEAP32[i24 >> 2] = i13;
    i12 = HEAP32[i16 >> 2] | 0;
    switch (HEAP32[i12 + (i13 << 2) >> 2] | 0) {
    case 6:
     {
      i4 = i4 + -2 | 0;
      HEAP32[i24 >> 2] = i4;
      i4 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
      i1 = 0;
      do {
       i5 = i3 + (i1 << 2) | 0;
       i1 = i1 + 1 | 0;
      } while ((HEAP32[i5 >> 2] | 0) > -1);
      HEAP32[i5 >> 2] = i4 << 1 | 1;
      HEAP32[i3 + (i1 << 2) >> 2] = -1;
      i1 = 0;
      while (1) if ((HEAP32[i28 + (i1 << 2) >> 2] | 0) > -1) i1 = i1 + 1 | 0; else break;
      HEAP32[i28 + (i1 + -1 << 2) >> 2] = -1;
      i1 = 0;
      i6 = i15;
      i5 = i14;
      break;
     }
    case 0:
     {
      i13 = i4 + -2 | 0;
      HEAP32[i24 >> 2] = i13;
      i12 = HEAP32[i12 + (i13 << 2) >> 2] | 0;
      i13 = i12 + 12 | 0;
      i5 = HEAP32[i13 >> 2] | 0;
      if ((i5 | 0) > -1) {
       i1 = 0;
       do {
        i4 = i3 + (i1 << 2) | 0;
        i1 = i1 + 1 | 0;
       } while ((HEAP32[i4 >> 2] | 0) > -1);
       HEAP32[i4 >> 2] = i5 << 1;
       HEAP32[i3 + (i1 << 2) >> 2] = -1;
       if (!i26) {
        i1 = 0;
        while (1) if ((HEAP32[i28 + (i1 << 2) >> 2] | 0) > -1) i1 = i1 + 1 | 0; else break;
        i4 = (HEAP32[i19 >> 2] | 0) + (i5 * 12 | 0) + 8 | 0;
        HEAP32[i4 >> 2] = 0;
        if ((i1 | 0) > 0) {
         i1 = _malloc((i1 << 2) + 4 | 0) | 0;
         if (!i1) {
          i1 = 12;
          break L12;
         }
         HEAP32[i4 >> 2] = i1;
         i4 = HEAP32[i28 >> 2] | 0;
         if ((i4 | 0) > -1) {
          i6 = 0;
          i5 = i1;
          do {
           HEAP32[i5 >> 2] = i4;
           i6 = i6 + 1 | 0;
           i4 = HEAP32[i28 + (i6 << 2) >> 2] | 0;
           i5 = i1 + (i6 << 2) | 0;
          } while ((i4 | 0) > -1);
          i1 = i5;
         }
         HEAP32[i1 >> 2] = -1;
        }
       }
       HEAP32[i23 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
       i1 = _tre_stack_push(i22, i20) | 0;
       if (i1 | 0) break L12;
       HEAP32[i23 >> 2] = 6;
       HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
       i1 = _tre_stack_push(i22, i20) | 0;
       if (i1 | 0) break L12;
      }
      L42 : do switch (HEAP32[i12 >> 2] | 0) {
      case 0:
       {
        i11 = HEAP32[HEAP32[i12 + 4 >> 2] >> 2] | 0;
        if ((i11 | 0) > -1 | (i11 | 0) == -4) if ((HEAP32[i3 >> 2] | 0) > -1) {
         if (i26) {
          HEAP32[i12 + 20 >> 2] = 1;
          i1 = 0;
         } else {
          i1 = _tre_add_tag_left(i21, i12, i8) | 0;
          HEAP32[(HEAP32[i17 >> 2] | 0) + (i8 << 2) >> 2] = i14;
          if ((i7 | 0) > -1) {
           i5 = HEAP32[i18 >> 2] | 0;
           i4 = 0;
           while (1) {
            i6 = i5 + (i4 << 2) | 0;
            i10 = i4 + 1 | 0;
            if ((HEAP32[i6 >> 2] | 0) > -1) i4 = i10; else break;
           }
           HEAP32[i6 >> 2] = i8;
           HEAP32[i5 + (i10 << 2) >> 2] = i7;
           HEAP32[i5 + (i4 + 2 << 2) >> 2] = -1;
           i2 = i2 + 1 | 0;
           i7 = -1;
          }
          _tre_purge_regset(i3, i29, i8);
         }
         HEAP32[i3 >> 2] = -1;
         i11 = i15 + 1 | 0;
         i10 = i14;
         i9 = i9 + 1 | 0;
         i8 = i15;
        } else {
         i11 = i15;
         i1 = 0;
         i10 = i14;
        } else {
         i11 = i15;
         i1 = 0;
         i10 = i14;
        }
        break;
       }
      case 1:
       {
        i5 = HEAP32[i12 + 4 >> 2] | 0;
        i6 = HEAP32[i5 >> 2] | 0;
        i5 = HEAP32[i5 + 4 >> 2] | 0;
        HEAP32[i23 >> 2] = i12;
        HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
        i1 = _tre_stack_push(i22, i20) | 0;
        if (!i1) {
         HEAP32[i23 >> 2] = 5;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (!i1) {
          HEAP32[i23 >> 2] = i5;
          HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
          i1 = _tre_stack_push(i22, i20) | 0;
          if (!i1) {
           HEAP32[i23 >> 2] = 0;
           HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
           i1 = _tre_stack_push(i22, i20) | 0;
           if (!i1) {
            i4 = i6 + 20 | 0;
            HEAP32[i23 >> 2] = (HEAP32[i4 >> 2] | 0) + i15;
            HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
            i1 = _tre_stack_push(i22, i20) | 0;
            if (!i1) {
             if ((HEAP32[i4 >> 2] | 0) > 0) {
              i4 = (HEAP32[i5 + 20 >> 2] | 0) > 0;
              i1 = i4 ? i15 : -1;
              i4 = (i4 & 1) + i15 | 0;
             } else {
              i1 = -1;
              i4 = i15;
             }
             HEAP32[i23 >> 2] = i1;
             HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
             i1 = _tre_stack_push(i22, i20) | 0;
             if (!i1) {
              HEAP32[i23 >> 2] = 4;
              HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
              i1 = _tre_stack_push(i22, i20) | 0;
              if (!i1) {
               HEAP32[i23 >> 2] = i6;
               HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
               i1 = _tre_stack_push(i22, i20) | 0;
               if (!i1) {
                HEAP32[i23 >> 2] = 0;
                HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                i11 = i4;
                i1 = _tre_stack_push(i22, i20) | 0;
                i10 = i14;
               } else {
                i11 = i4;
                i10 = i14;
               }
              } else {
               i11 = i4;
               i10 = i14;
              }
             } else {
              i11 = i4;
              i10 = i14;
             }
            } else {
             i11 = i15;
             i10 = i14;
            }
           } else {
            i11 = i15;
            i10 = i14;
           }
          } else {
           i11 = i15;
           i10 = i14;
          }
         } else {
          i11 = i15;
          i10 = i14;
         }
        } else {
         i11 = i15;
         i10 = i14;
        }
        break;
       }
      case 2:
       {
        i4 = HEAP32[i12 + 4 >> 2] | 0;
        if (i26) {
         if ((HEAP32[i3 >> 2] | 0) > -1) i1 = 1; else i1 = (HEAP8[i4 + 12 >> 0] & 1) != 0;
         HEAP32[i23 >> 2] = i1 & 1;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (i1 | 0) {
          i11 = i15;
          i10 = i14;
          break L42;
         }
        } else {
         HEAP32[i23 >> 2] = i8;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (i1 | 0) {
          i11 = i15;
          i10 = i14;
          break L42;
         }
         HEAP32[i23 >> 2] = HEAP8[i4 + 12 >> 0] & 1;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (i1 | 0) {
          i11 = i15;
          i10 = i14;
          break L42;
         }
        }
        HEAP32[i23 >> 2] = i12;
        HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
        i1 = _tre_stack_push(i22, i20) | 0;
        if (!i1) {
         HEAP32[i23 >> 2] = 1;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (!i1) {
          HEAP32[i23 >> 2] = HEAP32[i4 >> 2];
          HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
          i1 = _tre_stack_push(i22, i20) | 0;
          if (!i1) {
           HEAP32[i23 >> 2] = 0;
           HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
           i1 = _tre_stack_push(i22, i20) | 0;
           if (!i1) {
            if ((HEAP32[i3 >> 2] | 0) <= -1) if (!(HEAP8[i4 + 12 >> 0] & 1)) {
             i11 = i15;
             i1 = 0;
             i10 = 0;
             break L42;
            }
            if (i26) i1 = 0; else {
             i1 = _tre_add_tag_left(i21, i12, i8) | 0;
             HEAP32[(HEAP32[i17 >> 2] | 0) + (i8 << 2) >> 2] = (HEAP8[i4 + 12 >> 0] & 1) == 0 ? i14 : 1;
             if ((i7 | 0) > -1) {
              i5 = HEAP32[i18 >> 2] | 0;
              i4 = 0;
              while (1) {
               i6 = i5 + (i4 << 2) | 0;
               i10 = i4 + 1 | 0;
               if ((HEAP32[i6 >> 2] | 0) > -1) i4 = i10; else break;
              }
              HEAP32[i6 >> 2] = i8;
              HEAP32[i5 + (i10 << 2) >> 2] = i7;
              HEAP32[i5 + (i4 + 2 << 2) >> 2] = -1;
              i2 = i2 + 1 | 0;
              i7 = -1;
             }
             _tre_purge_regset(i3, i29, i8);
            }
            HEAP32[i3 >> 2] = -1;
            i11 = i15 + 1 | 0;
            i10 = 0;
            i9 = i9 + 1 | 0;
            i8 = i15;
           } else {
            i11 = i15;
            i10 = i14;
           }
          } else {
           i11 = i15;
           i10 = i14;
          }
         } else {
          i11 = i15;
          i10 = i14;
         }
        } else {
         i11 = i15;
         i10 = i14;
        }
        break;
       }
      case 3:
       {
        i5 = HEAP32[i12 + 4 >> 2] | 0;
        i6 = HEAP32[i5 >> 2] | 0;
        i5 = HEAP32[i5 + 4 >> 2] | 0;
        i4 = (HEAP32[i3 >> 2] | 0) > -1;
        i11 = i15 + 1 | 0;
        HEAP32[i23 >> 2] = i4 ? i11 : i15;
        HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
        i1 = _tre_stack_push(i22, i20) | 0;
        if (!i1) {
         HEAP32[i23 >> 2] = i4 ? i15 : i8;
         HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
         i1 = _tre_stack_push(i22, i20) | 0;
         if (!i1) {
          HEAP32[i23 >> 2] = i3;
          HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
          i1 = _tre_stack_push(i22, i20) | 0;
          if (!i1) {
           HEAP32[i23 >> 2] = (HEAP32[i3 >> 2] | 0) >>> 31 ^ 1;
           HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
           i1 = _tre_stack_push(i22, i20) | 0;
           if (!i1) {
            HEAP32[i23 >> 2] = i12;
            HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
            i1 = _tre_stack_push(i22, i20) | 0;
            if (!i1) {
             HEAP32[i23 >> 2] = i5;
             HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
             i1 = _tre_stack_push(i22, i20) | 0;
             if (!i1) {
              HEAP32[i23 >> 2] = i6;
              HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
              i1 = _tre_stack_push(i22, i20) | 0;
              if (!i1) {
               HEAP32[i23 >> 2] = 3;
               HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
               i1 = _tre_stack_push(i22, i20) | 0;
               if (!i1) {
                HEAP32[i23 >> 2] = i5;
                HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                i1 = _tre_stack_push(i22, i20) | 0;
                if (!i1) {
                 HEAP32[i23 >> 2] = 0;
                 HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                 i1 = _tre_stack_push(i22, i20) | 0;
                 if (!i1) {
                  HEAP32[i23 >> 2] = 2;
                  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                  i1 = _tre_stack_push(i22, i20) | 0;
                  if (i1 | 0) {
                   i11 = i15;
                   i10 = i14;
                   break L42;
                  }
                  HEAP32[i23 >> 2] = i6;
                  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                  i1 = _tre_stack_push(i22, i20) | 0;
                  if (i1 | 0) {
                   i11 = i15;
                   i10 = i14;
                   break L42;
                  }
                  HEAP32[i23 >> 2] = 0;
                  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
                  i1 = _tre_stack_push(i22, i20) | 0;
                  if (i1 | 0) {
                   i11 = i15;
                   i10 = i14;
                   break L42;
                  }
                  if ((HEAP32[i3 >> 2] | 0) > -1) {
                   if (i26) i1 = 0; else {
                    i1 = _tre_add_tag_left(i21, i12, i8) | 0;
                    HEAP32[(HEAP32[i17 >> 2] | 0) + (i8 << 2) >> 2] = i14;
                    if ((i7 | 0) > -1) {
                     i5 = HEAP32[i18 >> 2] | 0;
                     i4 = 0;
                     while (1) {
                      i6 = i5 + (i4 << 2) | 0;
                      i10 = i4 + 1 | 0;
                      if ((HEAP32[i6 >> 2] | 0) > -1) i4 = i10; else break;
                     }
                     HEAP32[i6 >> 2] = i8;
                     HEAP32[i5 + (i10 << 2) >> 2] = i7;
                     HEAP32[i5 + (i4 + 2 << 2) >> 2] = -1;
                     i2 = i2 + 1 | 0;
                     i7 = -1;
                    }
                    _tre_purge_regset(i3, i29, i8);
                   }
                   HEAP32[i3 >> 2] = -1;
                   i9 = i9 + 1 | 0;
                   i8 = i15;
                   i4 = i11;
                  } else {
                   i1 = 0;
                   i4 = i15;
                  }
                  i15 = (HEAP32[i12 + 16 >> 2] | 0) > 0;
                  i11 = i15 ? i4 + 2 | 0 : i4;
                  i10 = i14;
                  i8 = i15 ? i4 + 1 | 0 : i8;
                 } else {
                  i11 = i15;
                  i10 = i14;
                 }
                } else {
                 i11 = i15;
                 i10 = i14;
                }
               } else {
                i11 = i15;
                i10 = i14;
               }
              } else {
               i11 = i15;
               i10 = i14;
              }
             } else {
              i11 = i15;
              i10 = i14;
             }
            } else {
             i11 = i15;
             i10 = i14;
            }
           } else {
            i11 = i15;
            i10 = i14;
           }
          } else {
           i11 = i15;
           i10 = i14;
          }
         } else {
          i11 = i15;
          i10 = i14;
         }
        } else {
         i11 = i15;
         i10 = i14;
        }
        break;
       }
      default:
       {
        i11 = i15;
        i1 = 0;
        i10 = i14;
       }
      } while (0);
      i5 = HEAP32[i13 >> 2] | 0;
      if ((i5 | 0) > -1) {
       i4 = 0;
       do {
        i6 = i28 + (i4 << 2) | 0;
        i4 = i4 + 1 | 0;
       } while ((HEAP32[i6 >> 2] | 0) > -1);
       HEAP32[i6 >> 2] = i5;
       HEAP32[i28 + (i4 << 2) >> 2] = -1;
       i6 = i11;
       i5 = i10;
      } else {
       i6 = i11;
       i5 = i10;
      }
      break;
     }
    case 1:
     {
      i1 = i4 + -2 | 0;
      HEAP32[i24 >> 2] = i1;
      i1 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
      if (i26) {
       i7 = HEAP32[(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0) + 20 >> 2] | 0;
       i4 = i4 + -3 | 0;
       HEAP32[i24 >> 2] = i4;
       HEAP32[i1 + 20 >> 2] = (HEAP32[i12 + (i4 << 2) >> 2] | 0) + i7;
       i4 = 0;
       i7 = -1;
      } else {
       i11 = i4 + -3 | 0;
       HEAP32[i24 >> 2] = i11;
       i11 = HEAP32[i12 + (i11 << 2) >> 2] | 0;
       i13 = i4 + -4 | 0;
       HEAP32[i24 >> 2] = i13;
       i4 = i11;
       i7 = (i11 | 0) == 0 ? i7 : HEAP32[i12 + (i13 << 2) >> 2] | 0;
      }
      i1 = 0;
      i6 = i15;
      i5 = i26 ? i14 : (i4 | 0) == 0 & 1;
      break;
     }
    case 4:
     {
      i5 = i4 + -2 | 0;
      HEAP32[i24 >> 2] = i5;
      i5 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
      i6 = i4 + -3 | 0;
      HEAP32[i24 >> 2] = i6;
      i1 = 0;
      i8 = (i5 | 0) > -1 ? i5 : i8;
      i6 = HEAP32[i12 + (i6 << 2) >> 2] | 0;
      i5 = i14;
      break;
     }
    case 5:
     {
      i1 = i4 + -2 | 0;
      HEAP32[i24 >> 2] = i1;
      i1 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
      if (i26) {
       i6 = HEAP32[i1 + 4 >> 2] | 0;
       HEAP32[i1 + 20 >> 2] = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 20 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0);
       i1 = 0;
       i6 = i15;
       i5 = i14;
      } else {
       i1 = 0;
       i6 = i15;
       i5 = i14;
      }
      break;
     }
    case 2:
     {
      while (1) if ((HEAP32[i3 >> 2] | 0) > -1) i3 = i3 + 4 | 0; else {
       i1 = 0;
       i6 = i15;
       i5 = i14;
       break;
      }
      break;
     }
    case 3:
     {
      i10 = HEAP32[i12 + (i4 + -2 << 2) >> 2] | 0;
      i11 = HEAP32[i12 + (i4 + -3 << 2) >> 2] | 0;
      i1 = HEAP32[i12 + (i4 + -4 << 2) >> 2] | 0;
      i3 = i4 + -5 | 0;
      HEAP32[i24 >> 2] = i3;
      if (i26) {
       i14 = HEAP32[i1 + 4 >> 2] | 0;
       i6 = HEAP32[i1 + 16 >> 2] | 0;
       HEAP32[i1 + 20 >> 2] = (HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0) + (HEAP32[i12 + (i3 << 2) >> 2] | 0) + (HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 20 >> 2] | 0) + ((i6 | 0) > 0 ? 2 : 0);
      } else i6 = HEAP32[i1 + 16 >> 2] | 0;
      i3 = HEAP32[i12 + (i4 + -6 << 2) >> 2] | 0;
      i5 = i4 + -7 | 0;
      HEAP32[i24 >> 2] = i5;
      i5 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
      i1 = i4 + -8 | 0;
      HEAP32[i24 >> 2] = i1;
      i1 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
      if ((i6 | 0) > 0) {
       if (i26) i1 = 0; else {
        _tre_add_tag_right(i21, i10, i5) | 0;
        HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] = 1;
        i14 = _tre_add_tag_right(i21, i11, i1) | 0;
        HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] = 1;
        i1 = i14;
       }
       i9 = i9 + 2 | 0;
       i6 = i15;
       i5 = 1;
      } else {
       i1 = 0;
       i6 = i15;
       i5 = 1;
      }
      break;
     }
    default:
     {
      i1 = 0;
      i6 = i15;
      i5 = i14;
     }
    }
    i4 = HEAP32[i24 >> 2] | 0;
    if ((i1 | 0) != 0 | (i4 | 0) <= (i25 | 0)) break L12; else {
     i15 = i6;
     i14 = i5;
    }
   }
  } while (0);
  if (!i26) {
   _tre_purge_regset(i3, i29, i8);
   if ((i7 | 0) > -1) {
    i4 = HEAP32[i29 + 36 >> 2] | 0;
    i3 = 0;
    while (1) {
     i5 = i4 + (i3 << 2) | 0;
     i6 = i3 + 1 | 0;
     if ((HEAP32[i5 >> 2] | 0) > -1) i3 = i6; else break;
    }
    HEAP32[i5 >> 2] = i8;
    HEAP32[i4 + (i6 << 2) >> 2] = i7;
    HEAP32[i4 + (i3 + 2 << 2) >> 2] = -1;
    i2 = i2 + 1 | 0;
   }
  }
  HEAP32[i29 + 48 >> 2] = i9;
  HEAP32[i29 + 40 >> 2] = i9;
  HEAP32[i29 + 44 >> 2] = i2;
  _free(i27);
  _free(i28);
 } while (0);
 STACKTOP = i30;
 return i1 | 0;
}

function __ZN19MeshParticleEmitter18SetupParticleStripER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti(i30, i31, i28, i25, i32, i27, f29, i24, i26, i23, i22) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i28 = i28 | 0;
 i25 = i25 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 f29 = Math_fround(f29);
 i24 = i24 | 0;
 i26 = i26 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 f13 = Math_fround(HEAPF32[i30 + 124 >> 2]);
 f14 = Math_fround(HEAPF32[i30 + 128 >> 2]);
 i1 = HEAP32[gb + 1477044 >> 2] | 0;
 i1 = i1 << 11 ^ i1;
 i4 = HEAP32[gb + 1477048 >> 2] | 0;
 HEAP32[gb + 1477044 >> 2] = i4;
 i5 = HEAP32[gb + 1477052 >> 2] | 0;
 HEAP32[gb + 1477048 >> 2] = i5;
 i3 = HEAP32[gb + 1477056 >> 2] | 0;
 HEAP32[gb + 1477052 >> 2] = i3;
 i1 = i1 >>> 8 ^ i1 ^ i3;
 i2 = i1 ^ i3 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i2;
 f15 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(Math_fround(f13 * f15) + Math_fround(f14 * Math_fround(Math_fround(1.0) - f15)));
 i17 = f15 < Math_fround(0.0);
 i21 = f15 > Math_fround(100000001999999991808.0);
 f15 = i21 ? Math_fround(100000001999999991808.0) : f15;
 f15 = i17 ? Math_fround(0.0) : f15;
 HEAPF32[i31 + 40 >> 2] = f15;
 HEAPF32[i31 + 36 >> 2] = Math_fround(Math_fround(f15 + f29) + Math_fround(.00100000005));
 i17 = (i22 | 0) > 2;
 if (i17) {
  i12 = i4 << 11 ^ i4;
  HEAP32[gb + 1477044 >> 2] = i5;
  HEAP32[gb + 1477048 >> 2] = i3;
  HEAP32[gb + 1477052 >> 2] = i2;
  i12 = i12 >>> 8 ^ i12 ^ i2 ^ i1 >>> 19;
  HEAP32[gb + 1477056 >> 2] = i12;
  i11 = ((i12 >>> 0) % ((i22 + -2 | 0) >>> 0) | 0) + 2 | 0;
  i1 = i2;
  i4 = i5;
 } else if ((i22 | 0) == 2) {
  i11 = 2;
  i12 = i2;
  i1 = i3;
  i3 = i5;
 } else {
  i12 = i4 << 11 ^ i4;
  HEAP32[gb + 1477044 >> 2] = i5;
  HEAP32[gb + 1477048 >> 2] = i3;
  HEAP32[gb + 1477052 >> 2] = i2;
  i12 = i12 >>> 8 ^ i12 ^ i2 ^ i1 >>> 19;
  HEAP32[gb + 1477056 >> 2] = i12;
  i11 = 2 - ((i12 >>> 0) % ((2 - i22 | 0) >>> 0) | 0) | 0;
  i1 = i2;
  i4 = i5;
 }
 i16 = HEAP16[i23 + (i11 + -2 << 1) >> 1] | 0;
 i5 = HEAP16[i23 + (i11 + -1 << 1) >> 1] | 0;
 i2 = HEAP16[i23 + (i11 << 1) >> 1] | 0;
 i19 = i22 + -2 | 0;
 i20 = (i22 | 0) == 2;
 i21 = 2 - i22 | 0;
 L6 : do if (i17) {
  i11 = i16;
  i18 = i12;
  L7 : while (1) {
   if (i11 << 16 >> 16 != i5 << 16 >> 16) if (!(i11 << 16 >> 16 == i2 << 16 >> 16 ? 1 : i5 << 16 >> 16 == i2 << 16 >> 16)) {
    i16 = i5;
    i5 = i18;
    break L6;
   }
   i17 = i4 << 11 ^ i4;
   HEAP32[gb + 1477044 >> 2] = i3;
   HEAP32[gb + 1477048 >> 2] = i1;
   HEAP32[gb + 1477052 >> 2] = i18;
   i17 = i17 >>> 8 ^ i17 ^ i18 ^ i18 >>> 19;
   HEAP32[gb + 1477056 >> 2] = i17;
   i11 = (i17 >>> 0) % (i19 >>> 0) | 0;
   i5 = i11 + 2 | 0;
   i2 = HEAP16[i23 + (i5 << 1) >> 1] | 0;
   i4 = HEAP16[i23 + (i11 + 1 << 1) >> 1] | 0;
   i11 = HEAP16[i23 + (i11 << 1) >> 1] | 0;
   if (i4 << 16 >> 16 == i2 << 16 >> 16 | (i11 << 16 >> 16 == i4 << 16 >> 16 ? 1 : i11 << 16 >> 16 == i2 << 16 >> 16)) {
    i16 = i2;
    i12 = i11;
   } else {
    i16 = i18;
    i20 = i1;
    i21 = i3;
    i5 = i4;
    i18 = i17;
    i1 = i16;
    i3 = i20;
    i4 = i21;
    continue;
   }
   while (1) {
    i11 = i5 + 1 | 0;
    if ((i11 | 0) >= (i22 | 0)) {
     i33 = i18;
     i20 = i1;
     i21 = i3;
     i2 = i16;
     i5 = i4;
     i11 = i12;
     i18 = i17;
     i1 = i33;
     i3 = i20;
     i4 = i21;
     continue L7;
    }
    i2 = HEAP16[i23 + (i11 << 1) >> 1] | 0;
    i4 = HEAP16[i23 + (i5 + -1 << 1) >> 1] | 0;
    if (i16 << 16 >> 16 == i2 << 16 >> 16 | (i4 << 16 >> 16 == i16 << 16 >> 16 ? 1 : i4 << 16 >> 16 == i2 << 16 >> 16)) {
     i33 = i16;
     i16 = i2;
     i12 = i4;
     i5 = i11;
     i4 = i33;
    } else {
     i20 = i18;
     i21 = i1;
     i33 = i3;
     i5 = i16;
     i11 = i4;
     i18 = i17;
     i1 = i20;
     i3 = i21;
     i4 = i33;
     continue L7;
    }
   }
  }
 } else {
  i11 = i16;
  L15 : while (1) {
   if (i11 << 16 >> 16 != i5 << 16 >> 16) if (!(i11 << 16 >> 16 == i2 << 16 >> 16 ? 1 : i5 << 16 >> 16 == i2 << 16 >> 16)) {
    i16 = i5;
    i5 = i12;
    break L6;
   }
   if (i20) {
    i5 = 2;
    i18 = i12;
    i17 = i1;
    i1 = i3;
    i3 = i4;
   } else {
    i18 = i4 << 11 ^ i4;
    HEAP32[gb + 1477044 >> 2] = i3;
    HEAP32[gb + 1477048 >> 2] = i1;
    HEAP32[gb + 1477052 >> 2] = i12;
    i18 = i18 >>> 8 ^ i18 ^ i12 ^ i12 >>> 19;
    HEAP32[gb + 1477056 >> 2] = i18;
    i5 = 2 - ((i18 >>> 0) % (i21 >>> 0) | 0) | 0;
    i17 = i12;
   }
   i2 = HEAP16[i23 + (i5 << 1) >> 1] | 0;
   i4 = HEAP16[i23 + (i5 + -1 << 1) >> 1] | 0;
   i11 = HEAP16[i23 + (i5 + -2 << 1) >> 1] | 0;
   if (i4 << 16 >> 16 == i2 << 16 >> 16 | (i11 << 16 >> 16 == i4 << 16 >> 16 ? 1 : i11 << 16 >> 16 == i2 << 16 >> 16)) i16 = i2; else {
    i5 = i4;
    i4 = i3;
    i3 = i1;
    i1 = i17;
    i12 = i18;
    continue;
   }
   while (1) {
    i12 = i5 + 1 | 0;
    if ((i12 | 0) >= (i22 | 0)) {
     i2 = i16;
     i5 = i4;
     i4 = i3;
     i3 = i1;
     i1 = i17;
     i12 = i18;
     continue L15;
    }
    i2 = HEAP16[i23 + (i12 << 1) >> 1] | 0;
    i4 = HEAP16[i23 + (i5 + -1 << 1) >> 1] | 0;
    if (i16 << 16 >> 16 == i2 << 16 >> 16 | (i4 << 16 >> 16 == i16 << 16 >> 16 ? 1 : i4 << 16 >> 16 == i2 << 16 >> 16)) {
     i33 = i16;
     i16 = i2;
     i11 = i4;
     i5 = i12;
     i4 = i33;
    } else {
     i5 = i16;
     i11 = i4;
     i4 = i3;
     i3 = i1;
     i1 = i17;
     i12 = i18;
     continue L15;
    }
   }
  }
 } while (0);
 i12 = i11 & 65535;
 i11 = i16 & 65535;
 i2 = i2 & 65535;
 i33 = i4 << 11 ^ i4;
 i33 = i33 >>> 8 ^ i33 ^ i5;
 i23 = i33 ^ i5 >>> 19;
 f6 = Math_fround(Math_fround((i23 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i22 = i3 << 11 ^ i3;
 HEAP32[gb + 1477044 >> 2] = i1;
 HEAP32[gb + 1477048 >> 2] = i5;
 HEAP32[gb + 1477052 >> 2] = i23;
 i33 = i22 >>> 8 ^ i22 ^ i23 ^ i33 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i33;
 f7 = Math_fround(Math_fround((i33 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i33 = Math_fround(f6 + f7) > Math_fround(1.0);
 f8 = Math_fround(Math_fround(1.0) - f6);
 f10 = Math_fround(Math_fround(1.0) - f7);
 f7 = i33 ? f10 : f7;
 f6 = i33 ? f8 : f6;
 f8 = Math_fround(Math_fround(Math_fround(1.0) - f6) - f7);
 i33 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i24 = i33 + (Math_imul(i1, i12) | 0) | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f6);
 f9 = Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) * f6);
 f13 = Math_fround(Math_fround(HEAPF32[i24 + 8 >> 2]) * f6);
 i24 = i33 + (Math_imul(i1, i11) | 0) | 0;
 f15 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f7);
 f14 = Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) * f7);
 f15 = Math_fround(f10 + f15);
 f14 = Math_fround(f9 + f14);
 f13 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i24 + 8 >> 2])));
 i1 = i33 + (Math_imul(i1, i2) | 0) | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f8);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f9 = Math_fround(f15 + f9);
 f10 = Math_fround(f14 + f10);
 f13 = Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 8 >> 2])));
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i25 + 16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i25 + 32 >> 2])));
 f14 = Math_fround(Math_fround(HEAPF32[i25 + 48 >> 2]) + f14);
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i25 + 4 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f10 * Math_fround(HEAPF32[i25 + 20 >> 2])));
 f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i25 + 36 >> 2])));
 f15 = Math_fround(Math_fround(HEAPF32[i25 + 52 >> 2]) + f15);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i25 + 8 >> 2]));
 f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i25 + 24 >> 2])));
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i25 + 40 >> 2])));
 f13 = Math_fround(Math_fround(HEAPF32[i25 + 56 >> 2]) + f13);
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 } else {
  i33 = HEAP32[i26 + 4 >> 2] | 0;
  i26 = i1 + (Math_imul(i33, i12) | 0) | 0;
  f39 = Math_fround(HEAPF32[i26 >> 2]);
  f37 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f10 = Math_fround(HEAPF32[i26 + 8 >> 2]);
  i26 = i1 + (Math_imul(i33, i11) | 0) | 0;
  f38 = Math_fround(HEAPF32[i26 >> 2]);
  f36 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i26 + 8 >> 2]);
  i33 = i1 + (Math_imul(i33, i2) | 0) | 0;
  f35 = Math_fround(HEAPF32[i33 >> 2]);
  f34 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f35 = Math_fround(Math_fround(Math_fround(f6 * f39) + Math_fround(f7 * f38)) + Math_fround(f8 * f35));
  f34 = Math_fround(Math_fround(Math_fround(f6 * f37) + Math_fround(f7 * f36)) + Math_fround(f8 * f34));
  f9 = Math_fround(Math_fround(Math_fround(f6 * f10) + Math_fround(f7 * f9)) + Math_fround(f8 * Math_fround(HEAPF32[i33 + 8 >> 2])));
  f7 = Math_fround(f35 * Math_fround(HEAPF32[i27 >> 2]));
  f7 = Math_fround(f7 + Math_fround(f34 * Math_fround(HEAPF32[i27 + 12 >> 2])));
  f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i27 + 24 >> 2])));
  f10 = Math_fround(f35 * Math_fround(HEAPF32[i27 + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f34 * Math_fround(HEAPF32[i27 + 16 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i27 + 28 >> 2])));
  f6 = Math_fround(f35 * Math_fround(HEAPF32[i27 + 8 >> 2]));
  f6 = Math_fround(f6 + Math_fround(f34 * Math_fround(HEAPF32[i27 + 20 >> 2])));
  f9 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i27 + 32 >> 2])));
  f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f10 * f10)) + Math_fround(f9 * f9));
  if (!(f6 == Math_fround(0.0))) f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
  f8 = Math_fround(f7 * f6);
  f7 = Math_fround(f9 * f6);
  f6 = Math_fround(f10 * f6);
 }
 i19 = i30 + 44 | 0;
 HEAP32[i31 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 i4 = HEAP32[gb + 1477044 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 i1 = HEAP32[gb + 1477048 >> 2] | 0;
 i2 = HEAP32[gb + 1477052 >> 2] | 0;
 i3 = HEAP32[gb + 1477056 >> 2] | 0;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i3 >>> 19;
 f37 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f37 = Math_fround(Math_fround(f37 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f37) * f29));
 f36 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f37);
 i33 = i28 + 4 | 0;
 f38 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f37);
 i27 = i28 + 8 | 0;
 f37 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f37);
 f36 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f36);
 HEAPF32[i31 >> 2] = f36;
 i17 = i31 + 4 | 0;
 f38 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f38);
 HEAPF32[i17 >> 2] = f38;
 i18 = i31 + 8 | 0;
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i18 >> 2]));
 HEAPF32[i18 >> 2] = f37;
 f35 = Math_fround(HEAPF32[i30 + 32 >> 2]);
 f35 = Math_fround(f35 - Math_fround(HEAPF32[i19 >> 2]));
 f39 = Math_fround(HEAPF32[i30 + 36 >> 2]);
 f39 = Math_fround(f39 - Math_fround(HEAPF32[i30 + 48 >> 2]));
 f34 = Math_fround(HEAPF32[i30 + 40 >> 2]);
 i1 = i1 << 11 ^ i1;
 i1 = i1 >>> 8 ^ i1 ^ i5;
 i4 = i1 ^ i4 >>> 19;
 f29 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f39 = Math_fround(f39 * f29);
 f34 = Math_fround(Math_fround(f34 - Math_fround(HEAPF32[i30 + 52 >> 2])) * f29);
 f29 = Math_fround(f36 + Math_fround(f35 * f29));
 HEAPF32[i31 >> 2] = f29;
 f39 = Math_fround(f38 + f39);
 HEAPF32[i17 >> 2] = f39;
 f37 = Math_fround(f34 + f37);
 HEAPF32[i18 >> 2] = f37;
 f34 = Math_fround(f14 * Math_fround(HEAPF32[i32 >> 2]));
 i19 = i32 + 12 | 0;
 f34 = Math_fround(f34 + Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2])));
 i20 = i32 + 24 | 0;
 f34 = Math_fround(f34 + Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2])));
 i21 = i32 + 4 | 0;
 f38 = Math_fround(f14 * Math_fround(HEAPF32[i21 >> 2]));
 i22 = i32 + 16 | 0;
 f38 = Math_fround(f38 + Math_fround(f15 * Math_fround(HEAPF32[i22 >> 2])));
 i23 = i32 + 28 | 0;
 f38 = Math_fround(f38 + Math_fround(f13 * Math_fround(HEAPF32[i23 >> 2])));
 i24 = i32 + 8 | 0;
 f35 = Math_fround(f14 * Math_fround(HEAPF32[i24 >> 2]));
 i25 = i32 + 20 | 0;
 f35 = Math_fround(f35 + Math_fround(f15 * Math_fround(HEAPF32[i25 >> 2])));
 i26 = i32 + 32 | 0;
 f35 = Math_fround(f35 + Math_fround(f13 * Math_fround(HEAPF32[i26 >> 2])));
 HEAPF32[i31 >> 2] = Math_fround(f34 + f29);
 HEAPF32[i17 >> 2] = Math_fround(f38 + f39);
 HEAPF32[i18 >> 2] = Math_fround(f35 + f37);
 f37 = Math_fround(HEAPF32[i30 + 224 >> 2]);
 f35 = Math_fround(HEAPF32[i30 + 228 >> 2]);
 i2 = i2 << 11 ^ i2;
 i1 = i2 >>> 8 ^ i2 ^ i4 ^ i1 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i1;
 f39 = Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f39 = Math_fround(Math_fround(f37 * f39) + Math_fround(f35 * Math_fround(Math_fround(1.0) - f39)));
 f35 = Math_fround(f8 * f39);
 f37 = Math_fround(f6 * f39);
 f39 = Math_fround(f7 * f39);
 f35 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f35);
 f37 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) + f37);
 f39 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f39);
 i27 = i31 + 12 | 0;
 HEAPF32[i27 >> 2] = f35;
 i28 = i31 + 16 | 0;
 HEAPF32[i28 >> 2] = f37;
 i33 = i31 + 20 | 0;
 HEAPF32[i33 >> 2] = f39;
 i3 = i3 << 11 ^ i3;
 i1 = HEAP32[gb + 1477056 >> 2] | 0;
 i3 = i3 >>> 8 ^ i3 ^ i1;
 i2 = i3 ^ i1 >>> 19;
 f38 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f38 = Math_fround(Math_fround(Math_fround(1.0) - f38) - f38);
 i5 = i5 << 11 ^ i5;
 i5 = i5 >>> 8 ^ i5 ^ i2;
 i3 = i5 ^ i3 >>> 19;
 f29 = Math_fround(Math_fround((i3 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f29 = Math_fround(Math_fround(f29 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f29) * Math_fround(6.28318548)));
 f34 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f38 * f38))));
 f15 = Math_fround(f34 * Math_fround(+Math_cos(+f29)));
 f29 = Math_fround(f34 * Math_fround(+Math_sin(+f29)));
 i4 = i4 << 11 ^ i4;
 HEAP32[gb + 1477044 >> 2] = i1;
 HEAP32[gb + 1477048 >> 2] = i2;
 HEAP32[gb + 1477052 >> 2] = i3;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i5 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i5;
 f34 = Math_fround(+Math_pow(+Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07)), .333333343));
 f15 = Math_fround(f15 * f34);
 f29 = Math_fround(f29 * f34);
 f38 = Math_fround(f34 * f38);
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i30 + 180 >> 2]));
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i30 + 184 >> 2]));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i30 + 188 >> 2]));
 f34 = Math_fround(f15 * Math_fround(HEAPF32[i32 >> 2]));
 f34 = Math_fround(f34 + Math_fround(f29 * Math_fround(HEAPF32[i19 >> 2])));
 f34 = Math_fround(f34 + Math_fround(f38 * Math_fround(HEAPF32[i20 >> 2])));
 f36 = Math_fround(f15 * Math_fround(HEAPF32[i21 >> 2]));
 f36 = Math_fround(f36 + Math_fround(f29 * Math_fround(HEAPF32[i22 >> 2])));
 f36 = Math_fround(f36 + Math_fround(f38 * Math_fround(HEAPF32[i23 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i24 >> 2]));
 f29 = Math_fround(f15 + Math_fround(f29 * Math_fround(HEAPF32[i25 >> 2])));
 f38 = Math_fround(f29 + Math_fround(f38 * Math_fround(HEAPF32[i26 >> 2])));
 HEAPF32[i27 >> 2] = Math_fround(f34 + f35);
 HEAPF32[i28 >> 2] = Math_fround(f36 + f37);
 HEAPF32[i33 >> 2] = Math_fround(f38 + f39);
 if (!(HEAP8[i30 + 193 >> 0] | 0)) {
  f37 = Math_fround(0.0);
  i33 = i1;
  i28 = i5;
  i26 = i2;
  i27 = i3;
  i32 = i31 + 28 | 0;
  HEAPF32[i32 >> 2] = f37;
  i32 = i30 + 200 | 0;
  f37 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i30 + 196 | 0;
  f36 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i33 << 11;
  i33 = i32 ^ i33;
  i32 = i28 >>> 19;
  i25 = i33 >>> 8;
  i33 = i25 ^ i33;
  i33 = i33 ^ i28;
  i32 = i33 ^ i32;
  i25 = i32 & 8388607;
  f39 = Math_fround(i25 >>> 0);
  f39 = Math_fround(f39 * Math_fround(1.19209304e-07));
  f38 = Math_fround(f36 * f39);
  f39 = Math_fround(Math_fround(1.0) - f39);
  f39 = Math_fround(f36 * f39);
  f38 = Math_fround(f39 - f38);
  f38 = Math_fround(f37 + f38);
  f38 = Math_fround(f38 / Math_fround(360.0));
  f38 = Math_fround(f38 * Math_fround(2.0));
  f38 = Math_fround(f38 * Math_fround(3.14159274));
  i25 = i31 + 32 | 0;
  HEAPF32[i25 >> 2] = f38;
  i25 = i31 + 44 | 0;
  HEAP32[i25 >> 2] = -1;
  i25 = i30 + 116 | 0;
  f38 = Math_fround(HEAPF32[i25 >> 2]);
  i30 = i30 + 120 | 0;
  f37 = Math_fround(HEAPF32[i30 >> 2]);
  i30 = i26 << 11;
  i30 = i30 ^ i26;
  HEAP32[gb + 1477044 >> 2] = i27;
  HEAP32[gb + 1477048 >> 2] = i28;
  HEAP32[gb + 1477052 >> 2] = i32;
  i33 = i33 >>> 19;
  i28 = i30 >>> 8;
  i30 = i28 ^ i30;
  i32 = i30 ^ i32;
  i33 = i32 ^ i33;
  HEAP32[gb + 1477056 >> 2] = i33;
  i33 = i33 & 8388607;
  f39 = Math_fround(i33 >>> 0);
  f39 = Math_fround(f39 * Math_fround(1.19209304e-07));
  f38 = Math_fround(f38 * f39);
  f39 = Math_fround(Math_fround(1.0) - f39);
  f39 = Math_fround(f37 * f39);
  f39 = Math_fround(f38 + f39);
  i33 = i31 + 24 | 0;
  HEAPF32[i33 >> 2] = f39;
  return;
 }
 i28 = i1 << 11 ^ i1;
 HEAP32[gb + 1477044 >> 2] = i2;
 HEAP32[gb + 1477048 >> 2] = i3;
 HEAP32[gb + 1477052 >> 2] = i5;
 i28 = i28 >>> 8 ^ i28 ^ i5 ^ i4 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i28;
 f37 = Math_fround(Math_fround((i28 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f37 = Math_fround(Math_fround(f37 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f37) * Math_fround(6.28318548)));
 i33 = i2;
 i26 = i3;
 i27 = i5;
 i32 = i31 + 28 | 0;
 HEAPF32[i32 >> 2] = f37;
 i32 = i30 + 200 | 0;
 f37 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = i30 + 196 | 0;
 f36 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = i33 << 11;
 i33 = i32 ^ i33;
 i32 = i28 >>> 19;
 i25 = i33 >>> 8;
 i33 = i25 ^ i33;
 i33 = i33 ^ i28;
 i32 = i33 ^ i32;
 i25 = i32 & 8388607;
 f39 = Math_fround(i25 >>> 0);
 f39 = Math_fround(f39 * Math_fround(1.19209304e-07));
 f38 = Math_fround(f36 * f39);
 f39 = Math_fround(Math_fround(1.0) - f39);
 f39 = Math_fround(f36 * f39);
 f38 = Math_fround(f39 - f38);
 f38 = Math_fround(f37 + f38);
 f38 = Math_fround(f38 / Math_fround(360.0));
 f38 = Math_fround(f38 * Math_fround(2.0));
 f38 = Math_fround(f38 * Math_fround(3.14159274));
 i25 = i31 + 32 | 0;
 HEAPF32[i25 >> 2] = f38;
 i25 = i31 + 44 | 0;
 HEAP32[i25 >> 2] = -1;
 i25 = i30 + 116 | 0;
 f38 = Math_fround(HEAPF32[i25 >> 2]);
 i30 = i30 + 120 | 0;
 f37 = Math_fround(HEAPF32[i30 >> 2]);
 i30 = i26 << 11;
 i30 = i30 ^ i26;
 HEAP32[gb + 1477044 >> 2] = i27;
 HEAP32[gb + 1477048 >> 2] = i28;
 HEAP32[gb + 1477052 >> 2] = i32;
 i33 = i33 >>> 19;
 i28 = i30 >>> 8;
 i30 = i28 ^ i30;
 i32 = i30 ^ i32;
 i33 = i32 ^ i33;
 HEAP32[gb + 1477056 >> 2] = i33;
 i33 = i33 & 8388607;
 f39 = Math_fround(i33 >>> 0);
 f39 = Math_fround(f39 * Math_fround(1.19209304e-07));
 f38 = Math_fround(f38 * f39);
 f39 = Math_fround(Math_fround(1.0) - f39);
 f39 = Math_fround(f37 * f39);
 f39 = Math_fround(f38 + f39);
 i33 = i31 + 24 | 0;
 HEAPF32[i33 >> 2] = f39;
 return;
}

function __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i1, i2, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 L1 : while (1) {
  i16 = i2;
  i17 = i2 + -40 | 0;
  i18 = i2 + -80 | 0;
  i21 = i2 + -32 | 0;
  i22 = i2 + -24 | 0;
  i23 = i2 + -16 | 0;
  i24 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i15 = i1;
    i3 = i16 - i15 | 0;
    switch ((i3 | 0) / 40 | 0 | 0) {
    case 2:
     {
      i20 = 5;
      break L1;
     }
    case 3:
     {
      i20 = 10;
      break L1;
     }
    case 4:
     {
      i20 = 11;
      break L1;
     }
    case 5:
     {
      i20 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i20 = 76;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 280) {
     i20 = 14;
     break L1;
    }
    i4 = (i3 >>> 0) / 80 | 0;
    i14 = i1 + (i4 * 40 | 0) | 0;
    if ((i3 | 0) > 39960) {
     i3 = (i3 >>> 0) / 160 | 0;
     i3 = __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_(i1, i1 + (i3 * 40 | 0) | 0, i14, i14 + (i3 * 40 | 0) | 0, i17, i19) | 0;
    } else i3 = __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i1, i14, i17, i19) | 0;
    i13 = i1;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i11 = i14;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i12 | 0) == (i10 | 0) & (i13 | 0) == (i11 | 0)) {
     i8 = i1 + 8 | 0;
     i6 = HEAP32[i8 + 4 >> 2] | 0;
     i9 = i1 + (i4 * 40 | 0) + 8 | 0;
     i7 = HEAP32[i9 + 4 >> 2] | 0;
     if (i6 >>> 0 < i7 >>> 0 | ((i6 | 0) == (i7 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0 : 0)) {
      i4 = i17;
      break;
     }
    } else if (i13 >>> 0 < i11 >>> 0 | (i13 | 0) == (i11 | 0) & i12 >>> 0 < i10 >>> 0) {
     i4 = i17;
     break;
    }
    if ((i1 | 0) != (i18 | 0)) {
     i7 = i1 + (i4 * 40 | 0) + 8 | 0;
     i6 = i17;
     i4 = i18;
     while (1) {
      i9 = i4;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      if ((i8 | 0) == (i10 | 0) & (i9 | 0) == (i11 | 0)) {
       i5 = i6 + -32 | 0;
       i26 = i5;
       i28 = HEAP32[i26 + 4 >> 2] | 0;
       i25 = i7;
       i27 = HEAP32[i25 + 4 >> 2] | 0;
       if (i28 >>> 0 < i27 >>> 0 | ((i28 | 0) == (i27 | 0) ? (HEAP32[i26 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0)) {
        i20 = 51;
        break L5;
       }
      } else if (i9 >>> 0 < i11 >>> 0 | (i9 | 0) == (i11 | 0) & i8 >>> 0 < i10 >>> 0) {
       i20 = 48;
       break L5;
      }
      i5 = i4 + -40 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i6 = i4;
       i4 = i5;
      }
     }
    }
    i3 = i1 + 40 | 0;
    i11 = i17;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i12 | 0) == (i10 | 0) & (i13 | 0) == (i11 | 0)) {
     i27 = i1 + 8 | 0;
     i25 = HEAP32[i27 + 4 >> 2] | 0;
     i28 = i21;
     i26 = HEAP32[i28 + 4 >> 2] | 0;
     if (!(i25 >>> 0 < i26 >>> 0 | ((i25 | 0) == (i26 | 0) ? (HEAP32[i27 >> 2] | 0) >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0 : 0))) i20 = 26;
    } else if (!(i13 >>> 0 < i11 >>> 0 | (i13 | 0) == (i11 | 0) & i12 >>> 0 < i10 >>> 0)) i20 = 26;
    if ((i20 | 0) == 26) {
     i20 = 0;
     if ((i3 | 0) == (i17 | 0)) {
      i20 = 76;
      break L1;
     }
     i7 = i1 + 8 | 0;
     while (1) {
      i9 = i3;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      if ((i12 | 0) == (i8 | 0) & (i13 | 0) == (i9 | 0)) {
       i28 = i7;
       i27 = HEAP32[i28 + 4 >> 2] | 0;
       i6 = i3 + 8 | 0;
       i4 = i6;
       i5 = HEAP32[i4 >> 2] | 0;
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       if (i27 >>> 0 < i4 >>> 0 | ((i27 | 0) == (i4 | 0) ? (HEAP32[i28 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) break;
      } else if (i13 >>> 0 < i9 >>> 0 | (i13 | 0) == (i9 | 0) & i12 >>> 0 < i8 >>> 0) {
       i20 = 30;
       break;
      }
      i3 = i3 + 40 | 0;
      if ((i3 | 0) == (i17 | 0)) {
       i20 = 76;
       break L1;
      }
     }
     if ((i20 | 0) == 30) {
      i20 = 0;
      i6 = i3 + 8 | 0;
      i4 = i6;
      i5 = HEAP32[i4 >> 2] | 0;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
     }
     i13 = i3;
     HEAP32[i13 >> 2] = i10;
     HEAP32[i13 + 4 >> 2] = i11;
     i13 = i21;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i10 = i6;
     HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i10 + 4 >> 2] = i14;
     i10 = i17;
     HEAP32[i10 >> 2] = i8;
     HEAP32[i10 + 4 >> 2] = i9;
     i10 = i21;
     HEAP32[i10 >> 2] = i5;
     HEAP32[i10 + 4 >> 2] = i4;
     i10 = i3 + 16 | 0;
     i14 = i10;
     i13 = HEAP32[i14 >> 2] | 0;
     i14 = HEAP32[i14 + 4 >> 2] | 0;
     i11 = i3 + 24 | 0;
     i25 = i11;
     i15 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     i28 = i3 + 32 | 0;
     i27 = i28;
     i26 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i27 + 4 >> 2] | 0;
     i9 = i22;
     i12 = HEAP32[i9 + 4 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = i12;
     i10 = i23;
     i12 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = i12;
     i11 = i24;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     HEAP32[i28 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i28 + 4 >> 2] = i12;
     i28 = i22;
     HEAP32[i28 >> 2] = i13;
     HEAP32[i28 + 4 >> 2] = i14;
     i28 = i23;
     HEAP32[i28 >> 2] = i15;
     HEAP32[i28 + 4 >> 2] = i25;
     i28 = i24;
     HEAP32[i28 >> 2] = i26;
     HEAP32[i28 + 4 >> 2] = i27;
     i3 = i3 + 40 | 0;
    }
    if ((i3 | 0) == (i17 | 0)) {
     i20 = 76;
     break L1;
    }
    i12 = i1 + 8 | 0;
    i4 = i17;
    while (1) {
     i11 = i1;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     while (1) {
      i9 = i3;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      if ((i10 | 0) == (i8 | 0) & (i11 | 0) == (i9 | 0)) {
       i27 = i12;
       i25 = HEAP32[i27 + 4 >> 2] | 0;
       i28 = i3 + 8 | 0;
       i26 = HEAP32[i28 + 4 >> 2] | 0;
       if (i25 >>> 0 < i26 >>> 0 | ((i25 | 0) == (i26 | 0) ? (HEAP32[i27 >> 2] | 0) >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0 : 0)) break;
      } else if (i11 >>> 0 < i9 >>> 0 | (i11 | 0) == (i9 | 0) & i10 >>> 0 < i8 >>> 0) break;
      i3 = i3 + 40 | 0;
     }
     while (1) {
      i5 = i4 + -40 | 0;
      i7 = i5;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      if ((i10 | 0) == (i6 | 0) & (i11 | 0) == (i7 | 0)) {
       i27 = i12;
       i25 = HEAP32[i27 + 4 >> 2] | 0;
       i28 = i4 + -32 | 0;
       i26 = HEAP32[i28 + 4 >> 2] | 0;
       if (i25 >>> 0 < i26 >>> 0 | ((i25 | 0) == (i26 | 0) ? (HEAP32[i27 >> 2] | 0) >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0 : 0)) {
        i4 = i5;
        continue;
       } else break;
      } else if (i11 >>> 0 < i7 >>> 0 | (i11 | 0) == (i7 | 0) & i10 >>> 0 < i6 >>> 0) {
       i4 = i5;
       continue;
      } else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i25 = i3 + 8 | 0;
     i13 = i25;
     i11 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i26 = i3;
     HEAP32[i26 >> 2] = i6;
     HEAP32[i26 + 4 >> 2] = i7;
     i26 = i4 + -32 | 0;
     i10 = i26;
     i15 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i25 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i25 + 4 >> 2] = i15;
     i25 = i5;
     HEAP32[i25 >> 2] = i8;
     HEAP32[i25 + 4 >> 2] = i9;
     HEAP32[i26 >> 2] = i11;
     HEAP32[i26 + 4 >> 2] = i13;
     i26 = i3 + 16 | 0;
     i13 = i26;
     i11 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i3 + 24 | 0;
     i25 = i8;
     i15 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     i10 = i3 + 32 | 0;
     i28 = i10;
     i27 = HEAP32[i28 >> 2] | 0;
     i28 = HEAP32[i28 + 4 >> 2] | 0;
     i14 = i4 + -24 | 0;
     i9 = i14;
     i7 = HEAP32[i9 + 4 >> 2] | 0;
     HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i26 + 4 >> 2] = i7;
     i26 = i4 + -16 | 0;
     i7 = i26;
     i9 = HEAP32[i7 + 4 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + 4 >> 2] = i9;
     i4 = i4 + -8 | 0;
     i8 = i4;
     i9 = HEAP32[i8 + 4 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i10 + 4 >> 2] = i9;
     HEAP32[i14 >> 2] = i11;
     HEAP32[i14 + 4 >> 2] = i13;
     HEAP32[i26 >> 2] = i15;
     HEAP32[i26 + 4 >> 2] = i25;
     HEAP32[i4 >> 2] = i27;
     HEAP32[i4 + 4 >> 2] = i28;
     i4 = i5;
     i3 = i3 + 40 | 0;
    }
   }
   if ((i20 | 0) == 48) {
    i5 = i6 + -32 | 0;
    i20 = 51;
   }
   if ((i20 | 0) == 51) {
    i20 = 0;
    i25 = i1 + 8 | 0;
    i10 = i25;
    i28 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i27 = i1;
    HEAP32[i27 >> 2] = i8;
    HEAP32[i27 + 4 >> 2] = i9;
    i8 = i5;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    HEAP32[i25 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i25 + 4 >> 2] = i9;
    i25 = i4;
    HEAP32[i25 >> 2] = i12;
    HEAP32[i25 + 4 >> 2] = i13;
    i25 = i5;
    HEAP32[i25 >> 2] = i28;
    HEAP32[i25 + 4 >> 2] = i10;
    i25 = i1 + 16 | 0;
    i10 = i25;
    i9 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i28 = i1 + 24 | 0;
    i13 = i28;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i8 = i1 + 32 | 0;
    i27 = i8;
    i26 = HEAP32[i27 >> 2] | 0;
    i27 = HEAP32[i27 + 4 >> 2] | 0;
    i11 = i6 + -24 | 0;
    i7 = i11;
    i5 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i25 + 4 >> 2] = i5;
    i25 = i6 + -16 | 0;
    i5 = i25;
    i7 = HEAP32[i5 + 4 >> 2] | 0;
    HEAP32[i28 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i28 + 4 >> 2] = i7;
    i28 = i6 + -8 | 0;
    i6 = i28;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = i7;
    HEAP32[i11 >> 2] = i9;
    HEAP32[i11 + 4 >> 2] = i10;
    HEAP32[i25 >> 2] = i12;
    HEAP32[i25 + 4 >> 2] = i13;
    HEAP32[i28 >> 2] = i26;
    HEAP32[i28 + 4 >> 2] = i27;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 40 | 0;
   L63 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i12 = i14;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i14 + 8 | 0;
    while (1) {
     i10 = i5;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     if ((i9 | 0) == (i11 | 0) & (i10 | 0) == (i12 | 0)) {
      i27 = i5 + 8 | 0;
      i25 = HEAP32[i27 + 4 >> 2] | 0;
      i28 = i13;
      i26 = HEAP32[i28 + 4 >> 2] | 0;
      if (!(i25 >>> 0 < i26 >>> 0 | ((i25 | 0) == (i26 | 0) ? (HEAP32[i27 >> 2] | 0) >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0 : 0))) break;
     } else if (!(i10 >>> 0 < i12 >>> 0 | (i10 | 0) == (i12 | 0) & i9 >>> 0 < i11 >>> 0)) break;
     i5 = i5 + 40 | 0;
    }
    while (1) {
     i6 = i4 + -40 | 0;
     i8 = i6;
     i7 = HEAP32[i8 >> 2] | 0;
     i8 = HEAP32[i8 + 4 >> 2] | 0;
     if ((i7 | 0) == (i11 | 0) & (i8 | 0) == (i12 | 0)) {
      i27 = i4 + -32 | 0;
      i25 = HEAP32[i27 + 4 >> 2] | 0;
      i28 = i13;
      i26 = HEAP32[i28 + 4 >> 2] | 0;
      if (i25 >>> 0 < i26 >>> 0 | ((i25 | 0) == (i26 | 0) ? (HEAP32[i27 >> 2] | 0) >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0 : 0)) break; else {
       i4 = i6;
       continue;
      }
     } else if (i8 >>> 0 < i12 >>> 0 | (i8 | 0) == (i12 | 0) & i7 >>> 0 < i11 >>> 0) break; else {
      i4 = i6;
      continue;
     }
    }
    if (i5 >>> 0 > i6 >>> 0) {
     i11 = i14;
     break L63;
    }
    i27 = i5 + 8 | 0;
    i11 = i27;
    i25 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i26 = i5;
    HEAP32[i26 >> 2] = i7;
    HEAP32[i26 + 4 >> 2] = i8;
    i26 = i4 + -32 | 0;
    i28 = i26;
    i13 = HEAP32[i28 + 4 >> 2] | 0;
    i7 = i27;
    HEAP32[i7 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i7 + 4 >> 2] = i13;
    i7 = i6;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i7 + 4 >> 2] = i10;
    HEAP32[i26 >> 2] = i25;
    HEAP32[i26 + 4 >> 2] = i11;
    i26 = i5 + 16 | 0;
    i11 = i26;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i7 = i5 + 24 | 0;
    i25 = i7;
    i13 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 4 >> 2] | 0;
    i9 = i5 + 32 | 0;
    i28 = i9;
    i27 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i12 = i4 + -24 | 0;
    i8 = i12;
    i29 = HEAP32[i8 + 4 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i26 + 4 >> 2] = i29;
    i26 = i4 + -16 | 0;
    i29 = i26;
    i8 = HEAP32[i29 + 4 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i7 + 4 >> 2] = i8;
    i4 = i4 + -8 | 0;
    i7 = i4;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i26 >> 2] = i13;
    HEAP32[i26 + 4 >> 2] = i25;
    HEAP32[i4 >> 2] = i27;
    HEAP32[i4 + 4 >> 2] = i28;
    i14 = (i14 | 0) == (i5 | 0) ? i6 : i14;
    i4 = i6;
    i5 = i5 + 40 | 0;
    i3 = i3 + 1 | 0;
   } else i11 = i14; while (0);
   do if ((i5 | 0) != (i11 | 0)) {
    i8 = i11;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i10 = i5;
    i9 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    if ((i7 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
     i6 = i11 + 8 | 0;
     i28 = i6;
     i26 = HEAP32[i28 + 4 >> 2] | 0;
     i4 = i5 + 8 | 0;
     i29 = i4;
     i27 = HEAP32[i29 + 4 >> 2] | 0;
     if (!(i26 >>> 0 < i27 >>> 0 | ((i26 | 0) == (i27 | 0) ? (HEAP32[i28 >> 2] | 0) >>> 0 < (HEAP32[i29 >> 2] | 0) >>> 0 : 0))) break;
    } else {
     if (!(i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i7 >>> 0 < i9 >>> 0)) break;
     i6 = i11 + 8 | 0;
     i4 = i5 + 8 | 0;
    }
    i12 = i4;
    i29 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i14 = i5;
    HEAP32[i14 >> 2] = i7;
    HEAP32[i14 + 4 >> 2] = i8;
    i14 = i6;
    i25 = HEAP32[i14 + 4 >> 2] | 0;
    i26 = i4;
    HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i26 + 4 >> 2] = i25;
    i26 = i11;
    HEAP32[i26 >> 2] = i9;
    HEAP32[i26 + 4 >> 2] = i10;
    i26 = i6;
    HEAP32[i26 >> 2] = i29;
    HEAP32[i26 + 4 >> 2] = i12;
    i26 = i5 + 16 | 0;
    i12 = i26;
    i10 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i29 = i5 + 24 | 0;
    i25 = i29;
    i14 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = i5 + 32 | 0;
    i28 = i7;
    i27 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    i13 = i11 + 16 | 0;
    i8 = i13;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i26 + 4 >> 2] = i9;
    i26 = i11 + 24 | 0;
    i9 = i26;
    i8 = HEAP32[i9 + 4 >> 2] | 0;
    HEAP32[i29 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i29 + 4 >> 2] = i8;
    i29 = i11 + 32 | 0;
    i8 = i29;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i11 = i7;
    HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i11 + 4 >> 2] = i9;
    HEAP32[i13 >> 2] = i10;
    HEAP32[i13 + 4 >> 2] = i12;
    HEAP32[i26 >> 2] = i14;
    HEAP32[i26 + 4 >> 2] = i25;
    HEAP32[i29 >> 2] = i27;
    HEAP32[i29 + 4 >> 2] = i28;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEbT0_SE_T_(i1, i5, i19) | 0;
    i4 = i5 + 40 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEbT0_SE_T_(i4, i2, i19) | 0) {
     i20 = 75;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i29 = i5;
   if ((i29 - i15 | 0) >= (i16 - i29 | 0)) {
    i20 = 74;
    break;
   }
   __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i1, i5, i19);
   i1 = i5 + 40 | 0;
  }
  if ((i20 | 0) == 74) {
   i20 = 0;
   __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i5 + 40 | 0, i2, i19);
   i2 = i5;
   continue;
  } else if ((i20 | 0) == 75) {
   i20 = 0;
   if (i3) {
    i20 = 76;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i20 | 0) == 5) {
  i5 = i2 + -40 | 0;
  i7 = i5;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  do if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
   i29 = i21;
   i28 = HEAP32[i29 + 4 >> 2] | 0;
   i2 = i1 + 8 | 0;
   i3 = i2;
   i4 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (!(i28 >>> 0 < i3 >>> 0 | ((i28 | 0) == (i3 | 0) ? (HEAP32[i29 >> 2] | 0) >>> 0 < i4 >>> 0 : 0))) return;
  } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
   i2 = i1 + 8 | 0;
   i3 = i2;
   i4 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   break;
  } else return; while (0);
  i18 = i1;
  HEAP32[i18 >> 2] = i6;
  HEAP32[i18 + 4 >> 2] = i7;
  i18 = i21;
  i20 = HEAP32[i18 + 4 >> 2] | 0;
  i17 = i2;
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = i20;
  i17 = i5;
  HEAP32[i17 >> 2] = i8;
  HEAP32[i17 + 4 >> 2] = i9;
  i17 = i21;
  HEAP32[i17 >> 2] = i4;
  HEAP32[i17 + 4 >> 2] = i3;
  i17 = i1 + 16 | 0;
  i21 = i17;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i18 = i1 + 24 | 0;
  i26 = i18;
  i25 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 4 >> 2] | 0;
  i29 = i1 + 32 | 0;
  i28 = i29;
  i27 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i16 = i22;
  i19 = HEAP32[i16 + 4 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i17 + 4 >> 2] = i19;
  i17 = i23;
  i19 = HEAP32[i17 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  i18 = i24;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  HEAP32[i29 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i29 + 4 >> 2] = i19;
  i29 = i22;
  HEAP32[i29 >> 2] = i20;
  HEAP32[i29 + 4 >> 2] = i21;
  i29 = i23;
  HEAP32[i29 >> 2] = i25;
  HEAP32[i29 + 4 >> 2] = i26;
  i29 = i24;
  HEAP32[i29 >> 2] = i27;
  HEAP32[i29 + 4 >> 2] = i28;
  return;
 } else if ((i20 | 0) == 10) {
  __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i1, i1 + 40 | 0, i17, i19) | 0;
  return;
 } else if ((i20 | 0) == 11) {
  __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i17, i19) | 0;
  return;
 } else if ((i20 | 0) == 12) {
  __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i1 + 120 | 0, i17, i19) | 0;
  return;
 } else if ((i20 | 0) == 14) {
  __ZNSt3__218__insertion_sort_3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i1, i2, i19);
  return;
 } else if ((i20 | 0) == 76) return;
}

function __ZN5physx14preprocessRowsEPPNS_14Px1DConstraintES1_jRKNS_17PxcSolverBodyDataES5_RKNS_24PxConstraintInvMassScaleEbb(i59, i8, i58, i9, i10, i13, i6, i52) {
 i59 = i59 | 0;
 i8 = i8 | 0;
 i58 = i58 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i52 = i52 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i11 = 0, f12 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i60 + 800 | 0;
 i51 = i60 + 704 | 0;
 i55 = i60 + 608 | 0;
 i50 = i60 + 512 | 0;
 i54 = i60 + 416 | 0;
 i49 = i60 + 320 | 0;
 i53 = i60 + 224 | 0;
 i48 = i60 + 128 | 0;
 i57 = i60;
 i11 = (i58 | 0) == 0;
 if (!i11) {
  i7 = 0;
  do {
   i5 = i8 + (i7 * 80 | 0) | 0;
   L4 : do if (!i7) i1 = 0; else {
    i2 = HEAP16[i8 + (i7 * 80 | 0) + 78 >> 1] | 0;
    i4 = i7;
    while (1) {
     i1 = i4;
     i4 = i4 + -1 | 0;
     i3 = HEAP32[i59 + (i4 << 2) >> 2] | 0;
     if ((i2 & 65535) >= (HEAPU16[i3 + 78 >> 1] | 0)) break L4;
     HEAP32[i59 + (i1 << 2) >> 2] = i3;
     if (!i4) {
      i1 = 0;
      break;
     }
    }
   } while (0);
   HEAP32[i59 + (i1 << 2) >> 2] = i5;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i58 | 0));
 }
 if (i6) {
  STACKTOP = i60;
  return;
 }
 f68 = Math_fround(HEAPF32[i9 >> 2]);
 f61 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f62 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f63 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f64 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f65 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f66 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f67 = Math_fround(HEAPF32[i9 + 28 >> 2]);
 f69 = Math_fround(HEAPF32[i9 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f61 = Math_fround(f61 * f12);
 f62 = Math_fround(f62 * f12);
 f63 = Math_fround(f63 * f12);
 f64 = Math_fround(f64 * f12);
 f65 = Math_fround(f65 * f12);
 f66 = Math_fround(f66 * f12);
 f67 = Math_fround(f67 * f12);
 f69 = Math_fround(f69 * f12);
 HEAPF32[i57 >> 2] = Math_fround(f68 * f12);
 i31 = i57 + 4 | 0;
 HEAPF32[i31 >> 2] = f61;
 i32 = i57 + 8 | 0;
 HEAPF32[i32 >> 2] = f62;
 HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
 i33 = i57 + 16 | 0;
 HEAPF32[i33 >> 2] = f63;
 i34 = i57 + 20 | 0;
 HEAPF32[i34 >> 2] = f64;
 i35 = i57 + 24 | 0;
 HEAPF32[i35 >> 2] = f65;
 HEAPF32[i57 + 28 >> 2] = Math_fround(0.0);
 i36 = i57 + 32 | 0;
 HEAPF32[i36 >> 2] = f66;
 i37 = i57 + 36 | 0;
 HEAPF32[i37 >> 2] = f67;
 i38 = i57 + 40 | 0;
 HEAPF32[i38 >> 2] = f69;
 HEAPF32[i57 + 44 >> 2] = Math_fround(0.0);
 f69 = Math_fround(HEAPF32[i10 >> 2]);
 f67 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f66 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f65 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f64 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f63 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f62 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f61 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 32 >> 2]);
 f68 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f67 = Math_fround(f67 * f68);
 f66 = Math_fround(f66 * f68);
 f65 = Math_fround(f65 * f68);
 f64 = Math_fround(f64 * f68);
 f63 = Math_fround(f63 * f68);
 f62 = Math_fround(f62 * f68);
 f61 = Math_fround(f61 * f68);
 f12 = Math_fround(f12 * f68);
 i39 = i57 + 48 | 0;
 HEAPF32[i39 >> 2] = Math_fround(f69 * f68);
 i40 = i57 + 52 | 0;
 HEAPF32[i40 >> 2] = f67;
 i41 = i57 + 56 | 0;
 HEAPF32[i41 >> 2] = f66;
 HEAPF32[i57 + 60 >> 2] = Math_fround(0.0);
 i42 = i57 + 64 | 0;
 HEAPF32[i42 >> 2] = f65;
 i43 = i57 + 68 | 0;
 HEAPF32[i43 >> 2] = f64;
 i44 = i57 + 72 | 0;
 HEAPF32[i44 >> 2] = f63;
 HEAPF32[i57 + 76 >> 2] = Math_fround(0.0);
 i45 = i57 + 80 | 0;
 HEAPF32[i45 >> 2] = f62;
 i46 = i57 + 84 | 0;
 HEAPF32[i46 >> 2] = f61;
 i47 = i57 + 88 | 0;
 HEAPF32[i47 >> 2] = f12;
 HEAPF32[i57 + 92 >> 2] = Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i9 + 48 >> 2]);
 i30 = i57 + 96 | 0;
 HEAPF32[i30 >> 2] = Math_fround(f12 * Math_fround(HEAPF32[i13 >> 2]));
 f12 = Math_fround(HEAPF32[i10 + 48 >> 2]);
 i29 = i57 + 112 | 0;
 HEAPF32[i29 >> 2] = Math_fround(f12 * Math_fround(HEAPF32[i13 + 8 >> 2]));
 L14 : do if (!i11) {
  i27 = 0;
  while (1) {
   i6 = i59 + (i27 << 2) | 0;
   i4 = HEAP16[(HEAP32[i6 >> 2] | 0) + 78 >> 1] | 0;
   i5 = (i4 & 65535) >>> 8;
   i2 = i27;
   while (1) {
    i3 = i2 + 1 | 0;
    i1 = i3 >>> 0 < i58 >>> 0;
    if (!i1) {
     i28 = i1;
     break;
    }
    if (((HEAPU16[(HEAP32[i59 + (i3 << 2) >> 2] | 0) + 78 >> 1] | 0) >>> 8 | 0) == (i5 | 0)) i2 = i3; else {
     i28 = i1;
     break;
    }
   }
   switch (i5 | 0) {
   case 4:
    {
     L24 : do if (i3 >>> 0 > i27 >>> 0 & (i4 & 255) == 0) {
      i1 = i27;
      do {
       i1 = i1 + 1 | 0;
       if (i1 >>> 0 >= i3 >>> 0) break L24;
      } while ((HEAP16[(HEAP32[i59 + (i1 << 2) >> 2] | 0) + 78 >> 1] & 255) == 0);
     } else i1 = i27; while (0);
     i26 = i3 - i27 | 0;
     i21 = i1 - i27 | 0;
     if ((i3 | 0) != (i27 | 0)) {
      i22 = ~i21;
      i24 = 0;
      i25 = -1;
      while (1) {
       i19 = ~(i25 >>> 0 > i22 >>> 0 ? i25 : i22);
       i23 = i59 + (i24 + i27 << 2) | 0;
       i1 = HEAP32[i23 >> 2] | 0;
       if (!(HEAP16[i1 + 76 >> 1] & 8)) {
        f12 = Math_fround(0.0);
        i9 = HEAP32[i1 + 12 >> 2] | 0;
       } else {
        f69 = Math_fround(HEAPF32[i1 + 12 >> 2]);
        f12 = f69;
        i9 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
       }
       HEAPF32[i1 + 72 >> 2] = f12;
       i4 = HEAP32[i1 >> 2] | 0;
       i6 = HEAP32[i1 + 4 >> 2] | 0;
       i7 = HEAP32[i1 + 8 >> 2] | 0;
       i11 = i1 + 16 | 0;
       i17 = HEAP32[i11 >> 2] | 0;
       i16 = HEAP32[i11 + 4 >> 2] | 0;
       i14 = HEAP32[i11 + 8 >> 2] | 0;
       i11 = HEAP32[i11 + 12 >> 2] | 0;
       i15 = i1 + 32 | 0;
       i10 = HEAP32[i15 >> 2] | 0;
       i13 = HEAP32[i15 + 4 >> 2] | 0;
       i15 = HEAP32[i15 + 8 >> 2] | 0;
       i8 = i1 + 48 | 0;
       i2 = HEAP32[i8 >> 2] | 0;
       i5 = HEAP32[i8 + 4 >> 2] | 0;
       i8 = HEAP32[i8 + 8 >> 2] | 0;
       i20 = i24 >>> 0 < i21 >>> 0;
       if ((i20 ? i24 : i21) | 0) {
        i1 = i8;
        i18 = 0;
        while (1) {
         f74 = Math_fround(HEAPF32[i56 + (i18 << 4) >> 2]);
         f78 = Math_fround(HEAPF32[i56 + (i18 << 4) + 4 >> 2]);
         f81 = Math_fround(HEAPF32[i56 + (i18 << 4) + 8 >> 2]);
         f82 = Math_fround(HEAPF32[i54 + (i18 << 4) >> 2]);
         f79 = Math_fround(HEAPF32[i54 + (i18 << 4) + 4 >> 2]);
         f68 = Math_fround(HEAPF32[i54 + (i18 << 4) + 8 >> 2]);
         f77 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f82 = Math_fround(f77 * f82);
         f76 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f79 = Math_fround(f76 * f79);
         f75 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f68 = Math_fround(f75 * f68);
         f70 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f61 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f62 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f67 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f82 = Math_fround(Math_fround(f61 * f74) + f82);
         f79 = Math_fround(Math_fround(f62 * f78) + f79);
         f68 = Math_fround(Math_fround(f67 * f81) + f68);
         f81 = Math_fround(HEAPF32[i51 + (i18 << 4) >> 2]);
         f78 = Math_fround(HEAPF32[i51 + (i18 << 4) + 4 >> 2]);
         f74 = Math_fround(HEAPF32[i51 + (i18 << 4) + 8 >> 2]);
         f80 = Math_fround(HEAPF32[i49 + (i18 << 4) >> 2]);
         f12 = Math_fround(HEAPF32[i49 + (i18 << 4) + 4 >> 2]);
         f69 = Math_fround(HEAPF32[i49 + (i18 << 4) + 8 >> 2]);
         f73 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f80 = Math_fround(f73 * f80);
         f72 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f12 = Math_fround(f72 * f12);
         f71 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f69 = Math_fround(f71 * f69);
         f63 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f64 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f65 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f66 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f69 = Math_fround(Math_fround(Math_fround(f82 + Math_fround(Math_fround(f64 * f81) + f80)) + Math_fround(f79 + Math_fround(Math_fround(f65 * f78) + f12))) + Math_fround(f68 + Math_fround(Math_fround(f66 * f74) + f69)));
         f74 = Math_fround(HEAPF32[i53 + (i18 << 4) >> 2]);
         f68 = Math_fround(HEAPF32[i53 + (i18 << 4) + 4 >> 2]);
         f12 = Math_fround(HEAPF32[i53 + (i18 << 4) + 8 >> 2]);
         f74 = Math_fround(f77 - Math_fround(f74 * f69));
         f68 = Math_fround(f76 - Math_fround(f68 * f69));
         f12 = Math_fround(f75 - Math_fround(f12 * f69));
         f70 = Math_fround(f70 - Math_fround(Math_fround(HEAPF32[i53 + (i18 << 4) + 12 >> 2]) * f69));
         i4 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
         i6 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
         i7 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
         i9 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
         f70 = Math_fround(HEAPF32[i48 + (i18 << 4) >> 2]);
         f12 = Math_fround(HEAPF32[i48 + (i18 << 4) + 4 >> 2]);
         f68 = Math_fround(HEAPF32[i48 + (i18 << 4) + 8 >> 2]);
         f70 = Math_fround(f73 - Math_fround(f69 * f70));
         f12 = Math_fround(f72 - Math_fround(f69 * f12));
         f68 = Math_fround(f71 - Math_fround(f69 * f68));
         f63 = Math_fround(f63 - Math_fround(f69 * Math_fround(HEAPF32[i48 + (i18 << 4) + 12 >> 2])));
         i17 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
         i16 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
         i14 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
         i11 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
         f63 = Math_fround(HEAPF32[i55 + (i18 << 4) >> 2]);
         f68 = Math_fround(HEAPF32[i55 + (i18 << 4) + 4 >> 2]);
         f63 = Math_fround(f61 - Math_fround(f69 * f63));
         f68 = Math_fround(f62 - Math_fround(f69 * f68));
         f67 = Math_fround(f67 - Math_fround(f69 * Math_fround(HEAPF32[i55 + (i18 << 4) + 8 >> 2])));
         i10 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
         i13 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
         i8 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
         f67 = Math_fround(HEAPF32[i50 + (i18 << 4) >> 2]);
         f68 = Math_fround(HEAPF32[i50 + (i18 << 4) + 4 >> 2]);
         f67 = Math_fround(f64 - Math_fround(f69 * f67));
         f68 = Math_fround(f65 - Math_fround(f69 * f68));
         f69 = Math_fround(f66 - Math_fround(f69 * Math_fround(HEAPF32[i50 + (i18 << 4) + 8 >> 2])));
         i2 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
         i5 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
         i1 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
         i18 = i18 + 1 | 0;
         if ((i18 | 0) == (i19 | 0)) break; else i15 = i8;
        }
        i15 = i8;
        i8 = i1;
        i1 = HEAP32[i23 >> 2] | 0;
       }
       HEAP32[i1 >> 2] = i4;
       HEAP32[i1 + 4 >> 2] = i6;
       HEAP32[i1 + 8 >> 2] = i7;
       HEAP32[i1 + 12 >> 2] = i9;
       i19 = HEAP32[i23 >> 2] | 0;
       HEAP32[i19 + 16 >> 2] = i17;
       HEAP32[i19 + 20 >> 2] = i16;
       HEAP32[i19 + 24 >> 2] = i14;
       HEAP32[i19 + 28 >> 2] = i11;
       i23 = HEAP32[i23 >> 2] | 0;
       HEAP32[i23 + 32 >> 2] = i10;
       HEAP32[i23 + 36 >> 2] = i13;
       HEAP32[i23 + 40 >> 2] = i15;
       HEAP32[i23 + 48 >> 2] = i2;
       HEAP32[i23 + 52 >> 2] = i5;
       HEAP32[i23 + 56 >> 2] = i8;
       if (i20) {
        HEAP32[i53 + (i24 << 4) >> 2] = i4;
        HEAP32[i53 + (i24 << 4) + 4 >> 2] = i6;
        HEAP32[i53 + (i24 << 4) + 8 >> 2] = i7;
        HEAP32[i53 + (i24 << 4) + 12 >> 2] = i9;
        HEAP32[i48 + (i24 << 4) >> 2] = i17;
        HEAP32[i48 + (i24 << 4) + 4 >> 2] = i16;
        HEAP32[i48 + (i24 << 4) + 8 >> 2] = i14;
        HEAP32[i48 + (i24 << 4) + 12 >> 2] = i11;
        HEAP32[i55 + (i24 << 4) >> 2] = i10;
        HEAP32[i55 + (i24 << 4) + 4 >> 2] = i13;
        HEAP32[i55 + (i24 << 4) + 8 >> 2] = i15;
        HEAPF32[i55 + (i24 << 4) + 12 >> 2] = Math_fround(0.0);
        HEAP32[i50 + (i24 << 4) >> 2] = i2;
        HEAP32[i50 + (i24 << 4) + 4 >> 2] = i5;
        HEAP32[i50 + (i24 << 4) + 8 >> 2] = i8;
        HEAPF32[i50 + (i24 << 4) + 12 >> 2] = Math_fround(0.0);
        f71 = Math_fround(HEAPF32[i30 >> 2]);
        f83 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f69 = Math_fround(f83 * f71);
        f63 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f70 = Math_fround(f63 * f71);
        f67 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f71 = Math_fround(f67 * f71);
        f78 = Math_fround(HEAPF32[i29 >> 2]);
        f12 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f76 = Math_fround(f12 * f78);
        f64 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f77 = Math_fround(f64 * f78);
        f68 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f78 = Math_fround(f68 * f78);
        f72 = Math_fround(HEAPF32[i57 >> 2]);
        f61 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f72 = Math_fround(f61 * f72);
        f73 = Math_fround(HEAPF32[i33 >> 2]);
        f65 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f73 = Math_fround(f72 + Math_fround(f65 * f73));
        f72 = Math_fround(HEAPF32[i36 >> 2]);
        f75 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f72 = Math_fround(f73 + Math_fround(f75 * f72));
        f73 = Math_fround(f61 * Math_fround(HEAPF32[i31 >> 2]));
        f73 = Math_fround(f73 + Math_fround(f65 * Math_fround(HEAPF32[i34 >> 2])));
        f73 = Math_fround(f73 + Math_fround(f75 * Math_fround(HEAPF32[i37 >> 2])));
        f74 = Math_fround(f61 * Math_fround(HEAPF32[i32 >> 2]));
        f74 = Math_fround(f74 + Math_fround(f65 * Math_fround(HEAPF32[i35 >> 2])));
        f74 = Math_fround(f74 + Math_fround(f75 * Math_fround(HEAPF32[i38 >> 2])));
        f79 = Math_fround(HEAPF32[i39 >> 2]);
        f62 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f79 = Math_fround(f62 * f79);
        f81 = Math_fround(HEAPF32[i42 >> 2]);
        f66 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f81 = Math_fround(f79 + Math_fround(f66 * f81));
        f79 = Math_fround(HEAPF32[i45 >> 2]);
        f80 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f79 = Math_fround(f81 + Math_fround(f80 * f79));
        f81 = Math_fround(f62 * Math_fround(HEAPF32[i40 >> 2]));
        f81 = Math_fround(f81 + Math_fround(f66 * Math_fround(HEAPF32[i43 >> 2])));
        f81 = Math_fround(f81 + Math_fround(f80 * Math_fround(HEAPF32[i46 >> 2])));
        f82 = Math_fround(f62 * Math_fround(HEAPF32[i41 >> 2]));
        f82 = Math_fround(f82 + Math_fround(f66 * Math_fround(HEAPF32[i44 >> 2])));
        f82 = Math_fround(f82 + Math_fround(f80 * Math_fround(HEAPF32[i47 >> 2])));
        f80 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f83 * f69) + Math_fround(f12 * f76)) + Math_fround(Math_fround(f61 * f72) + Math_fround(f62 * f79))) + Math_fround(Math_fround(Math_fround(f63 * f70) + Math_fround(f64 * f77)) + Math_fround(Math_fround(f65 * f73) + Math_fround(f66 * f81)))) + Math_fround(Math_fround(Math_fround(f67 * f71) + Math_fround(f68 * f78)) + Math_fround(Math_fround(f75 * f74) + Math_fround(f80 * f82))));
        i23 = f80 > Math_fround(0.0);
        f80 = Math_fround(Math_fround(1.0) / f80);
        f80 = i23 ? f80 : Math_fround(0.0);
        f70 = Math_fround(f70 * f80);
        f71 = Math_fround(f71 * f80);
        f75 = Math_fround(f80 * Math_fround(0.0));
        HEAPF32[i54 + (i24 << 4) >> 2] = Math_fround(f69 * f80);
        HEAPF32[i54 + (i24 << 4) + 4 >> 2] = f70;
        HEAPF32[i54 + (i24 << 4) + 8 >> 2] = f71;
        HEAPF32[i54 + (i24 << 4) + 12 >> 2] = f75;
        f73 = Math_fround(f73 * f80);
        f74 = Math_fround(f74 * f80);
        HEAPF32[i49 + (i24 << 4) >> 2] = Math_fround(f72 * f80);
        HEAPF32[i49 + (i24 << 4) + 4 >> 2] = f73;
        HEAPF32[i49 + (i24 << 4) + 8 >> 2] = f74;
        HEAPF32[i49 + (i24 << 4) + 12 >> 2] = f75;
        f77 = Math_fround(f77 * f80);
        f78 = Math_fround(f78 * f80);
        HEAPF32[i56 + (i24 << 4) >> 2] = Math_fround(f76 * f80);
        HEAPF32[i56 + (i24 << 4) + 4 >> 2] = f77;
        HEAPF32[i56 + (i24 << 4) + 8 >> 2] = f78;
        HEAPF32[i56 + (i24 << 4) + 12 >> 2] = Math_fround(0.0);
        f81 = Math_fround(f81 * f80);
        f82 = Math_fround(f82 * f80);
        HEAPF32[i51 + (i24 << 4) >> 2] = Math_fround(f79 * f80);
        HEAPF32[i51 + (i24 << 4) + 4 >> 2] = f81;
        HEAPF32[i51 + (i24 << 4) + 8 >> 2] = f82;
        HEAPF32[i51 + (i24 << 4) + 12 >> 2] = Math_fround(0.0);
       }
       i24 = i24 + 1 | 0;
       if ((i24 | 0) == (i26 | 0)) break; else i25 = i25 + -1 | 0;
      }
     }
     break;
    }
   case 1:
    {
     if (i52) {
      L48 : do if (i3 >>> 0 > i27 >>> 0) {
       i1 = i27;
       do {
        if ((HEAP16[(HEAP32[i59 + (i1 << 2) >> 2] | 0) + 78 >> 1] & 255) == 2) break L48;
        i1 = i1 + 1 | 0;
       } while (i1 >>> 0 < i3 >>> 0);
      } else i1 = i27; while (0);
      if ((i1 + 2 | 0) == (i2 | 0)) __ZN5physx12_GLOBAL__N_111diagonalizeEPPNS_14Px1DConstraintERKNS0_9MassPropsE(i59 + (i1 << 2) | 0, i57);
      __ZN5physx12_GLOBAL__N_111diagonalizeEPPNS_14Px1DConstraintERKNS0_9MassPropsE(i6, i57);
     }
     break;
    }
   default:
    {}
   }
   if (i28) i27 = i3; else break L14;
  }
 } while (0);
 STACKTOP = i60;
 return;
}

function __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_(i31, i1, i36, i28, i37, i38, i39) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 i36 = i36 | 0;
 i28 = i28 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, f66 = f0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i45;
 i43 = HEAP32[i31 + 72 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i31 + 360 >> 2]);
 __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i37, i1, 0);
 f53 = Math_fround(f23 * Math_fround(HEAPF32[i37 >> 2]));
 i34 = i37 + 4 | 0;
 f49 = Math_fround(f23 * Math_fround(HEAPF32[i34 >> 2]));
 i35 = i37 + 8 | 0;
 f47 = Math_fround(f23 * Math_fround(HEAPF32[i35 >> 2]));
 HEAPF32[i37 >> 2] = f53;
 HEAPF32[i34 >> 2] = f49;
 HEAPF32[i35 >> 2] = f47;
 i18 = i28 + 28 | 0;
 f4 = Math_fround(HEAPF32[i18 >> 2]);
 i19 = i28 + 32 | 0;
 f5 = Math_fround(HEAPF32[i19 >> 2]);
 i20 = i28 + 36 | 0;
 f17 = Math_fround(HEAPF32[i20 >> 2]);
 f53 = Math_fround(f53 * f4);
 f49 = Math_fround(f49 * f5);
 f47 = Math_fround(f47 * f17);
 i24 = i28 + 16 | 0;
 f46 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = i28 + 12 | 0;
 f52 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i28 + 24 | 0;
 f48 = Math_fround(HEAPF32[i26 >> 2]);
 i27 = i28 + 20 | 0;
 f50 = Math_fround(HEAPF32[i27 >> 2]);
 f54 = Math_fround(f46 * Math_fround(-2.0));
 f15 = Math_fround(f46 * Math_fround(2.0));
 f51 = Math_fround(f54 * f48);
 f3 = Math_fround(f50 * Math_fround(2.0));
 f16 = Math_fround(f50 * Math_fround(-2.0));
 f55 = Math_fround(f48 * f16);
 f14 = Math_fround(f52 * Math_fround(-2.0));
 f12 = Math_fround(f52 * Math_fround(2.0));
 f13 = Math_fround(f48 * f14);
 f6 = Math_fround(Math_fround(f53 + Math_fround(f53 * Math_fround(Math_fround(f46 * f54) - Math_fround(f50 * f3)))) + Math_fround(Math_fround(f47 * Math_fround(Math_fround(f12 * f50) - f51)) + Math_fround(f49 * Math_fround(f55 - Math_fround(f46 * f14)))));
 f12 = Math_fround(Math_fround(f49 + Math_fround(f53 * Math_fround(Math_fround(f52 * f15) - f55))) + Math_fround(Math_fround(f47 * Math_fround(f13 - Math_fround(f54 * f50))) + Math_fround(f49 * Math_fround(Math_fround(f50 * f16) - Math_fround(f52 * f12)))));
 f13 = Math_fround(Math_fround(f47 + Math_fround(f53 * Math_fround(f51 - Math_fround(f52 * f16)))) + Math_fround(Math_fround(f47 * Math_fround(Math_fround(f52 * f14) - Math_fround(f46 * f15))) + Math_fround(f49 * Math_fround(Math_fround(f46 * f3) - f13))));
 f3 = Math_fround(HEAPF32[i28 >> 2]);
 i21 = i28 + 4 | 0;
 f49 = Math_fround(HEAPF32[i21 >> 2]);
 i22 = i28 + 8 | 0;
 f6 = Math_fround(f3 + f6);
 f12 = Math_fround(f49 + f12);
 f13 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f13);
 f49 = Math_fround(HEAPF32[i37 + 12 >> 2]);
 f3 = Math_fround(f46 * f49);
 i41 = i37 + 24 | 0;
 f15 = Math_fround(HEAPF32[i41 >> 2]);
 f14 = Math_fround(f48 * f15);
 i42 = i37 + 16 | 0;
 f47 = Math_fround(HEAPF32[i42 >> 2]);
 f16 = Math_fround(f50 * f47);
 i44 = i37 + 20 | 0;
 f51 = Math_fround(HEAPF32[i44 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f48 * f51)) - Math_fround(f50 * f15)) - Math_fround(f52 * f47));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f52 * f49)) - Math_fround(f50 * f51)) - Math_fround(f46 * f47));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f46 * f51)) - Math_fround(f48 * f49)) - Math_fround(f52 * f15));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * f49)) - Math_fround(f48 * f47)) - Math_fround(f46 * f15));
 i33 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f15 = Math_fround(HEAPF32[i37 + 28 >> 2]);
 i30 = i37 + 32 | 0;
 f16 = Math_fround(HEAPF32[i30 >> 2]);
 i29 = i37 + 36 | 0;
 f15 = Math_fround(f4 * f15);
 f16 = Math_fround(f5 * f16);
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i29 >> 2]));
 HEAPF32[i37 >> 2] = f6;
 HEAPF32[i34 >> 2] = f12;
 HEAPF32[i35 >> 2] = f13;
 i32 = i37 + 12 | 0;
 HEAP32[i32 >> 2] = i7 ^ -2147483648;
 HEAP32[i42 >> 2] = i2;
 HEAP32[i44 >> 2] = i33 ^ -2147483648;
 HEAPF32[i41 >> 2] = f14;
 i33 = i37 + 28 | 0;
 HEAPF32[i33 >> 2] = f15;
 HEAPF32[i30 >> 2] = f16;
 HEAPF32[i29 >> 2] = f17;
 i2 = i36 | 0 ? i36 : i1;
 i7 = i31 + 40 | 0;
 i8 = i7;
 i1 = 0;
 do {
  f48 = Math_fround(HEAPF32[i2 + 68 + (i1 << 6) >> 2]);
  f52 = Math_fround(HEAPF32[i2 + 68 + (i1 << 6) + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i2 + 68 + (i1 << 6) + 8 >> 2]);
  i9 = i37 + 68 + (i1 << 6) + 4 | 0;
  i10 = i37 + 68 + (i1 << 6) + 8 | 0;
  i65 = i37 + 68 + (i1 << 6) + 12 | 0;
  i63 = HEAP32[i2 + 68 + (i1 << 6) + 16 >> 2] | 0;
  i62 = HEAP32[i2 + 68 + (i1 << 6) + 20 >> 2] | 0;
  i56 = HEAP32[i2 + 68 + (i1 << 6) + 24 >> 2] | 0;
  HEAP32[i65 >> 2] = HEAP32[i2 + 68 + (i1 << 6) + 12 >> 2];
  i64 = i37 + 68 + (i1 << 6) + 16 | 0;
  HEAP32[i64 >> 2] = i63;
  i63 = i37 + 68 + (i1 << 6) + 20 | 0;
  HEAP32[i63 >> 2] = i62;
  i62 = i37 + 68 + (i1 << 6) + 24 | 0;
  HEAP32[i62 >> 2] = i56;
  i61 = i37 + 68 + (i1 << 6) + 28 | 0;
  i59 = HEAP32[i2 + 68 + (i1 << 6) + 32 >> 2] | 0;
  i11 = HEAP32[i2 + 68 + (i1 << 6) + 36 >> 2] | 0;
  HEAP32[i61 >> 2] = HEAP32[i2 + 68 + (i1 << 6) + 28 >> 2];
  i60 = i37 + 68 + (i1 << 6) + 32 | 0;
  HEAP32[i60 >> 2] = i59;
  i59 = i37 + 68 + (i1 << 6) + 36 | 0;
  HEAP32[i59 >> 2] = i11;
  i11 = i37 + 68 + (i1 << 6) | 0;
  f48 = Math_fround(f23 * f48);
  f52 = Math_fround(f23 * f52);
  f54 = Math_fround(f23 * f54);
  HEAPF32[i11 >> 2] = f48;
  HEAPF32[i9 >> 2] = f52;
  HEAPF32[i10 >> 2] = f54;
  f16 = Math_fround(HEAPF32[i18 >> 2]);
  f15 = Math_fround(HEAPF32[i19 >> 2]);
  f14 = Math_fround(HEAPF32[i20 >> 2]);
  f48 = Math_fround(f48 * f16);
  f52 = Math_fround(f52 * f15);
  f54 = Math_fround(f54 * f14);
  f55 = Math_fround(HEAPF32[i24 >> 2]);
  f49 = Math_fround(HEAPF32[i25 >> 2]);
  f53 = Math_fround(HEAPF32[i26 >> 2]);
  f51 = Math_fround(HEAPF32[i27 >> 2]);
  f47 = Math_fround(f55 * Math_fround(-2.0));
  f12 = Math_fround(f55 * Math_fround(2.0));
  f50 = Math_fround(f47 * f53);
  f17 = Math_fround(f51 * Math_fround(2.0));
  f13 = Math_fround(f51 * Math_fround(-2.0));
  f46 = Math_fround(f53 * f13);
  f6 = Math_fround(f49 * Math_fround(-2.0));
  f4 = Math_fround(f49 * Math_fround(2.0));
  f5 = Math_fround(f53 * f6);
  f3 = Math_fround(Math_fround(f48 + Math_fround(f48 * Math_fround(Math_fround(f55 * f47) - Math_fround(f51 * f17)))) + Math_fround(Math_fround(f54 * Math_fround(Math_fround(f4 * f51) - f50)) + Math_fround(f52 * Math_fround(f46 - Math_fround(f55 * f6)))));
  f4 = Math_fround(Math_fround(f52 + Math_fround(f48 * Math_fround(Math_fround(f49 * f12) - f46))) + Math_fround(Math_fround(f54 * Math_fround(f5 - Math_fround(f47 * f51))) + Math_fround(f52 * Math_fround(Math_fround(f51 * f13) - Math_fround(f49 * f4)))));
  f5 = Math_fround(Math_fround(f54 + Math_fround(f48 * Math_fround(f50 - Math_fround(f49 * f13)))) + Math_fround(Math_fround(f54 * Math_fround(Math_fround(f49 * f6) - Math_fround(f55 * f12))) + Math_fround(f52 * Math_fround(Math_fround(f55 * f17) - f5))));
  f17 = Math_fround(HEAPF32[i28 >> 2]);
  f52 = Math_fround(HEAPF32[i21 >> 2]);
  f3 = Math_fround(f17 + f3);
  f4 = Math_fround(f52 + f4);
  f5 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f5);
  f52 = Math_fround(HEAPF32[i37 + 68 + (i1 << 6) + 12 >> 2]);
  f17 = Math_fround(f55 * f52);
  f12 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f53 * f12);
  f54 = Math_fround(HEAPF32[i64 >> 2]);
  f13 = Math_fround(f51 * f54);
  f50 = Math_fround(HEAPF32[i63 >> 2]);
  f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f53 * f50)) - Math_fround(f51 * f12)) - Math_fround(f49 * f54));
  f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f49 * f52)) - Math_fround(f51 * f50)) - Math_fround(f55 * f54));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f55 * f50)) - Math_fround(f53 * f52)) - Math_fround(f49 * f12));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f49 * f50) - Math_fround(f51 * f52)) - Math_fround(f53 * f54)) - Math_fround(f55 * f12));
  i56 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i57 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i57 = i57 ^ -2147483648;
  i58 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i56 = i56 ^ -2147483648;
  f12 = Math_fround(HEAPF32[i37 + 68 + (i1 << 6) + 28 >> 2]);
  f13 = Math_fround(HEAPF32[i60 >> 2]);
  f12 = Math_fround(f16 * f12);
  f13 = Math_fround(f15 * f13);
  f14 = Math_fround(f14 * Math_fround(HEAPF32[i59 >> 2]));
  HEAPF32[i11 >> 2] = f3;
  HEAPF32[i9 >> 2] = f4;
  HEAPF32[i10 >> 2] = f5;
  HEAP32[i65 >> 2] = i57;
  HEAP32[i64 >> 2] = i58;
  HEAP32[i63 >> 2] = i56;
  HEAPF32[i62 >> 2] = f6;
  HEAPF32[i61 >> 2] = f12;
  HEAPF32[i60 >> 2] = f13;
  HEAPF32[i59 >> 2] = f14;
  f15 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if ((i1 | 0) < 2) {
   i65 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
   i64 = i65 + 16 | 0;
   i65 = i65 + 4 | 0;
   f47 = Math_fround(Math_fround(HEAPF32[(HEAP32[i64 >> 2] | 0) + i64 + ((HEAP32[i65 + (HEAP32[i65 >> 2] | 0) + (HEAP32[i31 + 72 + (((i1 | 0) == 0 ? 5 : 6) << 2) >> 2] << 3) + 4 >> 2] | 0) * 76 | 0) + 68 >> 2]) * f12);
   f46 = Math_fround(-f47);
   f51 = Math_fround(f13 * Math_fround(-0.0));
   f48 = Math_fround(f14 * Math_fround(-0.0));
   f13 = Math_fround(f15 * Math_fround(-2.0));
   f12 = Math_fround(f15 * Math_fround(2.0));
   f50 = Math_fround(f13 * f6);
   f14 = Math_fround(f17 * Math_fround(2.0));
   f66 = Math_fround(f17 * Math_fround(-2.0));
   f52 = Math_fround(f6 * f66);
   f53 = Math_fround(f16 * Math_fround(-2.0));
   f49 = Math_fround(f16 * Math_fround(2.0));
   f55 = Math_fround(f6 * f53);
   f54 = Math_fround(f4 + Math_fround(Math_fround(f51 + Math_fround(Math_fround(Math_fround(f16 * f12) - f52) * f46)) + Math_fround(Math_fround(f48 * Math_fround(f55 - Math_fround(f13 * f17))) + Math_fround(f51 * Math_fround(Math_fround(f17 * f66) - Math_fround(f16 * f49))))));
   f55 = Math_fround(f5 + Math_fround(Math_fround(f48 + Math_fround(Math_fround(f50 - Math_fround(f16 * f66)) * f46)) + Math_fround(Math_fround(f48 * Math_fround(Math_fround(f16 * f53) - Math_fround(f15 * f12))) + Math_fround(f51 * Math_fround(Math_fround(f15 * f14) - f55)))));
   HEAPF32[i11 >> 2] = Math_fround(f3 + Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f17 * f14)) * f46) - f47) + Math_fround(Math_fround(f48 * Math_fround(Math_fround(f49 * f17) - f50)) + Math_fround(f51 * Math_fround(f52 - Math_fround(f15 * f53))))));
   HEAPF32[i9 >> 2] = f54;
   HEAPF32[i10 >> 2] = f55;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i2 = i31 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i1 | 0) == 0 ? 0 : i1 + i2 | 0, i38);
 __ZN7mecanim5human30HumanPoseAdjustForMissingBonesEPKNS0_5HumanEPNS0_9HumanPoseE(i31, i37);
 __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i31, i37, i38);
 i2 = HEAP32[i7 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i2 | 0) == 0 ? 0 : i2 + i8 | 0, i38, i39);
 i2 = i40 + 4 | 0;
 i7 = i40 + 8 | 0;
 f3 = Math_fround(0.0);
 i1 = 0;
 f4 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 do {
  if ((HEAP32[i31 + 72 + (i1 << 2) >> 2] | 0) > -1) {
   f55 = Math_fround(HEAPF32[i31 + 168 + (i1 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i40, i31, i39, i1);
   f54 = Math_fround(HEAPF32[i40 >> 2]);
   f66 = Math_fround(HEAPF32[i2 >> 2]);
   f3 = Math_fround(f3 + f55);
   f4 = Math_fround(f4 + Math_fround(f55 * f54));
   f5 = Math_fround(f5 + Math_fround(f55 * Math_fround(HEAPF32[i7 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f55 * f66));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 f51 = Math_fround(f4 / f3);
 f52 = Math_fround(f6 / f3);
 f55 = Math_fround(f5 / f3);
 __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i40, i31, i39);
 f47 = Math_fround(HEAPF32[i40 + 12 >> 2]);
 i1 = i38 + 4 | 0;
 i2 = i1;
 i65 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
 i63 = i39 + 4 | 0;
 i62 = i63;
 i64 = (HEAP32[i63 >> 2] | 0) + i62 | 0;
 f16 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) >> 2]);
 f49 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 4 >> 2]);
 f51 = Math_fround(f16 - f51);
 f52 = Math_fround(f49 - f52);
 f55 = Math_fround(Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 8 >> 2]) - f55);
 f49 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i40 + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i40 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i40 + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = Math_fround(f49 * Math_fround(-2.0));
 f46 = Math_fround(f49 * Math_fround(2.0));
 f15 = Math_fround(f47 * f54);
 f48 = Math_fround(f23 * Math_fround(2.0));
 f17 = Math_fround(f23 * Math_fround(-2.0));
 f13 = Math_fround(f47 * f17);
 f50 = Math_fround(f16 * Math_fround(-2.0));
 f14 = Math_fround(f16 * Math_fround(2.0));
 f66 = Math_fround(f47 * f50);
 f53 = Math_fround(Math_fround(f51 + Math_fround(Math_fround(Math_fround(f49 * f54) - Math_fround(f23 * f48)) * f51)) + Math_fround(Math_fround(Math_fround(f13 - Math_fround(f49 * f50)) * f52) + Math_fround(Math_fround(Math_fround(f14 * f23) - f15) * f55)));
 f54 = Math_fround(Math_fround(f52 + Math_fround(Math_fround(Math_fround(f16 * f46) - f13) * f51)) + Math_fround(Math_fround(Math_fround(Math_fround(f23 * f17) - Math_fround(f16 * f14)) * f52) + Math_fround(Math_fround(f66 - Math_fround(f23 * f54)) * f55)));
 f55 = Math_fround(Math_fround(Math_fround(Math_fround(f15 - Math_fround(f16 * f17)) * f51) + f55) + Math_fround(Math_fround(Math_fround(Math_fround(f49 * f48) - f66) * f52) + Math_fround(Math_fround(Math_fround(f16 * f50) - Math_fround(f49 * f46)) * f55)));
 f46 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 12 >> 2]);
 f50 = Math_fround(f49 * f46);
 f52 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 24 >> 2]);
 f66 = Math_fround(f47 * f52);
 f48 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 16 >> 2]);
 f51 = Math_fround(f23 * f48);
 f17 = Math_fround(HEAPF32[i64 + (i43 * 40 | 0) + 20 >> 2]);
 f50 = Math_fround(Math_fround(Math_fround(f50 - Math_fround(f47 * f17)) - Math_fround(f23 * f52)) - Math_fround(f16 * f48));
 f66 = Math_fround(Math_fround(Math_fround(f66 - Math_fround(f16 * f46)) - Math_fround(f23 * f17)) - Math_fround(f49 * f48));
 f51 = Math_fround(Math_fround(Math_fround(f51 - Math_fround(f49 * f17)) - Math_fround(f47 * f46)) - Math_fround(f16 * f52));
 f52 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f17) - Math_fround(f23 * f46)) - Math_fround(f47 * f48)) - Math_fround(f49 * f52));
 i64 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
 i60 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
 i61 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i65 + (i43 * 40 | 0) >> 2] = f53;
 HEAPF32[i65 + (i43 * 40 | 0) + 4 >> 2] = f54;
 HEAPF32[i65 + (i43 * 40 | 0) + 8 >> 2] = f55;
 HEAP32[i65 + (i43 * 40 | 0) + 12 >> 2] = i60 ^ -2147483648;
 HEAP32[i65 + (i43 * 40 | 0) + 16 >> 2] = i61;
 HEAP32[i65 + (i43 * 40 | 0) + 20 >> 2] = i64 ^ -2147483648;
 HEAPF32[i65 + (i43 * 40 | 0) + 24 >> 2] = f66;
 HEAP32[i65 + (i43 * 40 | 0) + 28 >> 2] = 1065353216;
 HEAP32[i65 + (i43 * 40 | 0) + 32 >> 2] = 1065353216;
 HEAP32[i65 + (i43 * 40 | 0) + 36 >> 2] = 1065353216;
 i65 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
 i62 = (HEAP32[i63 >> 2] | 0) + i62 | 0;
 i63 = HEAP32[i62 + (i43 * 40 | 0) + 32 >> 2] | 0;
 i64 = HEAP32[i62 + (i43 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i65 + (i43 * 40 | 0) + 28 >> 2] = HEAP32[i62 + (i43 * 40 | 0) + 28 >> 2];
 HEAP32[i65 + (i43 * 40 | 0) + 32 >> 2] = i63;
 HEAP32[i65 + (i43 * 40 | 0) + 36 >> 2] = i64;
 if (i36 | 0) {
  __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i37, i36, 1);
  __ZN7mecanim5human30HumanPoseAdjustForMissingBonesEPKNS0_5HumanEPNS0_9HumanPoseE(i31, i37);
  __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i31, i37, i38);
 }
 if (!(HEAP8[i31 + 394 >> 0] | 0)) {
  i63 = HEAP32[i1 >> 2] | 0;
  i63 = i63 + i2 | 0;
  i65 = i63;
  i62 = HEAP32[i37 >> 2] | 0;
  i64 = HEAP32[i34 >> 2] | 0;
  i60 = HEAP32[i35 >> 2] | 0;
  HEAP32[i63 >> 2] = i62;
  i63 = i65 + 4 | 0;
  HEAP32[i63 >> 2] = i64;
  i63 = i65 + 8 | 0;
  HEAP32[i63 >> 2] = i60;
  i63 = i65 + 12 | 0;
  i60 = HEAP32[i32 >> 2] | 0;
  i64 = HEAP32[i42 >> 2] | 0;
  i62 = HEAP32[i44 >> 2] | 0;
  i61 = HEAP32[i41 >> 2] | 0;
  HEAP32[i63 >> 2] = i60;
  i63 = i65 + 16 | 0;
  HEAP32[i63 >> 2] = i64;
  i63 = i65 + 20 | 0;
  HEAP32[i63 >> 2] = i62;
  i63 = i65 + 24 | 0;
  HEAP32[i63 >> 2] = i61;
  i63 = i65 + 28 | 0;
  i61 = HEAP32[i33 >> 2] | 0;
  i62 = HEAP32[i30 >> 2] | 0;
  i64 = HEAP32[i29 >> 2] | 0;
  HEAP32[i63 >> 2] = i61;
  i63 = i65 + 32 | 0;
  HEAP32[i63 >> 2] = i62;
  i65 = i65 + 36 | 0;
  HEAP32[i65 >> 2] = i64;
  STACKTOP = i45;
  return;
 }
 __ZN7mecanim5human14RetargetToTDoFEPKNS0_5HumanEPNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESB_(i31, i37, i38, i39);
 i63 = HEAP32[i1 >> 2] | 0;
 i63 = i63 + i2 | 0;
 i65 = i63;
 i62 = HEAP32[i37 >> 2] | 0;
 i64 = HEAP32[i34 >> 2] | 0;
 i60 = HEAP32[i35 >> 2] | 0;
 HEAP32[i63 >> 2] = i62;
 i63 = i65 + 4 | 0;
 HEAP32[i63 >> 2] = i64;
 i63 = i65 + 8 | 0;
 HEAP32[i63 >> 2] = i60;
 i63 = i65 + 12 | 0;
 i60 = HEAP32[i32 >> 2] | 0;
 i64 = HEAP32[i42 >> 2] | 0;
 i62 = HEAP32[i44 >> 2] | 0;
 i61 = HEAP32[i41 >> 2] | 0;
 HEAP32[i63 >> 2] = i60;
 i63 = i65 + 16 | 0;
 HEAP32[i63 >> 2] = i64;
 i63 = i65 + 20 | 0;
 HEAP32[i63 >> 2] = i62;
 i63 = i65 + 24 | 0;
 HEAP32[i63 >> 2] = i61;
 i63 = i65 + 28 | 0;
 i61 = HEAP32[i33 >> 2] | 0;
 i62 = HEAP32[i30 >> 2] | 0;
 i64 = HEAP32[i29 >> 2] | 0;
 HEAP32[i63 >> 2] = i61;
 i63 = i65 + 32 | 0;
 HEAP32[i63 >> 2] = i62;
 i65 = i65 + 36 | 0;
 HEAP32[i65 >> 2] = i64;
 STACKTOP = i45;
 return;
}

function __ZN5physx2Gu15sweepCapsuleBoxERKNS0_7CapsuleERKNS_11PxTransformERKNS_6PxVec3ES9_fRS7_RfSA_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i54, i21, i11, i55, f1, i57, i64, i60, i2) {
 i54 = i54 | 0;
 i21 = i21 | 0;
 i11 = i11 | 0;
 i55 = i55 | 0;
 f1 = Math_fround(f1);
 i57 = i57 | 0;
 i64 = i64 | 0;
 i60 = i60 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i56 = 0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i65 = 0, i66 = 0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i66 + 552 | 0;
 i22 = i66 + 456 | 0;
 i56 = i66 + 120 | 0;
 i3 = i66 + 80 | 0;
 i17 = i66 + 56 | 0;
 i65 = i66 + 48 | 0;
 i12 = i66 + 986 | 0;
 i59 = i66 + 32 | 0;
 i61 = i66 + 20 | 0;
 i58 = i66 + 16 | 0;
 i62 = i66 + 12 | 0;
 i63 = i66 + 984 | 0;
 i53 = i66;
 if (!(HEAP16[i2 >> 1] & 16)) {
  f40 = Math_fround(HEAPF32[i21 >> 2]);
  i4 = i21 + 4 | 0;
  f35 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i21 + 8 | 0;
  f39 = Math_fround(HEAPF32[i5 >> 2]);
  i2 = i21 + 12 | 0;
  f36 = Math_fround(HEAPF32[i2 >> 2]);
  f45 = Math_fround(f40 + f40);
  f42 = Math_fround(f35 + f35);
  f34 = Math_fround(f39 + f39);
  f40 = Math_fround(f40 * f45);
  f44 = Math_fround(f35 * f42);
  f37 = Math_fround(f39 * f34);
  f35 = Math_fround(f45 * f35);
  f41 = Math_fround(f45 * f39);
  f45 = Math_fround(f45 * f36);
  f39 = Math_fround(f42 * f39);
  f42 = Math_fround(f42 * f36);
  f36 = Math_fround(f34 * f36);
  f34 = Math_fround(f35 + f36);
  f38 = Math_fround(f41 - f42);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f44) - f37);
  HEAPF32[i3 + 4 >> 2] = f34;
  HEAPF32[i3 + 8 >> 2] = f38;
  f40 = Math_fround(Math_fround(1.0) - f40);
  f37 = Math_fround(f40 - f37);
  f38 = Math_fround(f39 + f45);
  HEAPF32[i3 + 12 >> 2] = Math_fround(f35 - f36);
  HEAPF32[i3 + 16 >> 2] = f37;
  HEAPF32[i3 + 20 >> 2] = f38;
  f45 = Math_fround(f39 - f45);
  f44 = Math_fround(f40 - f44);
  HEAPF32[i3 + 24 >> 2] = Math_fround(f41 + f42);
  HEAPF32[i3 + 28 >> 2] = f45;
  HEAPF32[i3 + 32 >> 2] = f44;
  f44 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i54, i54 + 12 | 0, i21 + 16 | 0, i11, i3, 0, 0));
  f45 = Math_fround(HEAPF32[i54 + 24 >> 2]);
  if (f44 < Math_fround(f45 * f45)) {
   HEAPF32[i64 >> 2] = Math_fround(0.0);
   f42 = Math_fround(-Math_fround(HEAPF32[i55 >> 2]));
   f44 = Math_fround(-Math_fround(HEAPF32[i55 + 4 >> 2]));
   f45 = Math_fround(-Math_fround(HEAPF32[i55 + 8 >> 2]));
   HEAPF32[i60 >> 2] = f42;
   HEAPF32[i60 + 4 >> 2] = f44;
   HEAPF32[i60 + 8 >> 2] = f45;
   i65 = 1;
   STACKTOP = i66;
   return i65 | 0;
  } else i14 = i21;
 } else {
  i14 = i21;
  i2 = i21 + 12 | 0;
  i4 = i21 + 4 | 0;
  i5 = i21 + 8 | 0;
 }
 i46 = i54 + 12 | 0;
 f18 = Math_fround(HEAPF32[i46 >> 2]);
 f19 = Math_fround(HEAPF32[i54 >> 2]);
 i47 = i54 + 16 | 0;
 f45 = Math_fround(HEAPF32[i47 >> 2]);
 i48 = i54 + 4 | 0;
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i48 >> 2]));
 i49 = i54 + 20 | 0;
 f20 = Math_fround(HEAPF32[i49 >> 2]);
 i50 = i54 + 8 | 0;
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i50 >> 2]));
 f45 = Math_fround(f45 * Math_fround(.5));
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 f9 = Math_fround(-f13);
 f16 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(-f16);
 f15 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f10 = Math_fround(-f15);
 HEAPF32[i17 >> 2] = f9;
 HEAPF32[i17 + 4 >> 2] = f8;
 HEAPF32[i17 + 8 >> 2] = f10;
 HEAPF32[i17 + 12 >> 2] = f13;
 HEAPF32[i17 + 16 >> 2] = f16;
 HEAPF32[i17 + 20 >> 2] = f15;
 i51 = i65 + 4 | 0;
 HEAP8[i51 >> 0] = 1;
 i3 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i12, 3024, gb + 656187 | 0, 213) | 0;
 HEAP32[i65 >> 2] = i3;
 __ZN5physx2Gu16computeBoxPointsERKNS_9PxBounds3EPNS_6PxVec3E(i17, i22);
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f13 = Math_fround(HEAPF32[i14 >> 2]);
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 i2 = 0;
 do {
  i17 = i2 * 3 | 0;
  i43 = HEAPU8[gb + 656276 + i17 >> 0] | 0;
  i21 = HEAPU8[i17 + 1 + (gb + 656276) >> 0] | 0;
  i17 = HEAPU8[i17 + 2 + (gb + 656276) >> 0] | 0;
  f29 = Math_fround(HEAPF32[i22 + (i17 * 12 | 0) + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i22 + (i17 * 12 | 0) + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i22 + (i17 * 12 | 0) >> 2]);
  f42 = Math_fround(HEAPF32[i22 + (i21 * 12 | 0) + 8 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + (i21 * 12 | 0) + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i22 + (i21 * 12 | 0) >> 2]);
  f33 = Math_fround(HEAPF32[i22 + (i43 * 12 | 0) + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i22 + (i43 * 12 | 0) + 4 >> 2]);
  f32 = Math_fround(Math_fround(HEAPF32[i22 + (i43 * 12 | 0) >> 2]) * Math_fround(2.0));
  f34 = Math_fround(f34 * Math_fround(2.0));
  f33 = Math_fround(f33 * Math_fround(2.0));
  f35 = Math_fround(Math_fround(f8 * f33) + Math_fround(Math_fround(f10 * f34) + Math_fround(f13 * f32)));
  f36 = Math_fround(f7 + Math_fround(Math_fround(f10 * f35) + Math_fround(Math_fround(f16 * f34) + Math_fround(f15 * Math_fround(Math_fround(f8 * f32) - Math_fround(f13 * f33))))));
  f37 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f16 * f33) + Math_fround(f15 * Math_fround(Math_fround(f13 * f34) - Math_fround(f10 * f32)))) + Math_fround(f8 * f35)));
  f44 = Math_fround(f44 * Math_fround(2.0));
  f41 = Math_fround(f41 * Math_fround(2.0));
  f42 = Math_fround(f42 * Math_fround(2.0));
  f40 = Math_fround(Math_fround(f8 * f42) + Math_fround(Math_fround(f10 * f41) + Math_fround(f13 * f44)));
  f38 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f16 * f44) + Math_fround(f15 * Math_fround(Math_fround(f10 * f42) - Math_fround(f8 * f41)))) + Math_fround(f13 * f40)));
  f39 = Math_fround(f7 + Math_fround(Math_fround(f10 * f40) + Math_fround(Math_fround(f16 * f41) + Math_fround(f15 * Math_fround(Math_fround(f8 * f44) - Math_fround(f13 * f42))))));
  f40 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f16 * f42) + Math_fround(f15 * Math_fround(Math_fround(f13 * f41) - Math_fround(f10 * f44)))) + Math_fround(f8 * f40)));
  f31 = Math_fround(f31 * Math_fround(2.0));
  f30 = Math_fround(f30 * Math_fround(2.0));
  f29 = Math_fround(f29 * Math_fround(2.0));
  f44 = Math_fround(Math_fround(f8 * f29) + Math_fround(Math_fround(f10 * f30) + Math_fround(f13 * f31)));
  f41 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f16 * f31) + Math_fround(f15 * Math_fround(Math_fround(f10 * f29) - Math_fround(f8 * f30)))) + Math_fround(f13 * f44)));
  f42 = Math_fround(f7 + Math_fround(Math_fround(f10 * f44) + Math_fround(Math_fround(f16 * f30) + Math_fround(f15 * Math_fround(Math_fround(f8 * f31) - Math_fround(f13 * f29))))));
  f44 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f16 * f29) + Math_fround(f15 * Math_fround(Math_fround(f13 * f30) - Math_fround(f10 * f31)))) + Math_fround(f8 * f44)));
  HEAPF32[i52 + (i2 * 36 | 0) >> 2] = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f16 * f32) + Math_fround(f15 * Math_fround(Math_fround(f10 * f33) - Math_fround(f8 * f34)))) + Math_fround(f13 * f35)));
  HEAPF32[i52 + (i2 * 36 | 0) + 4 >> 2] = f36;
  HEAPF32[i52 + (i2 * 36 | 0) + 8 >> 2] = f37;
  HEAPF32[i52 + (i2 * 36 | 0) + 12 >> 2] = f38;
  HEAPF32[i52 + (i2 * 36 | 0) + 16 >> 2] = f39;
  HEAPF32[i52 + (i2 * 36 | 0) + 20 >> 2] = f40;
  HEAPF32[i52 + (i2 * 36 | 0) + 24 >> 2] = f41;
  HEAPF32[i52 + (i2 * 36 | 0) + 28 >> 2] = f42;
  HEAPF32[i52 + (i2 * 36 | 0) + 32 >> 2] = f44;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 12);
 f44 = Math_fround(Math_fround(f18 - f19) * Math_fround(.5));
 f42 = Math_fround(f20 * Math_fround(.5));
 i22 = i55 + 4 | 0;
 i43 = i55 + 8 | 0;
 i2 = i56;
 i21 = 0;
 do {
  f9 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) >> 2]);
  f39 = Math_fround(f9 - f6);
  f10 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 16 >> 2]);
  f7 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 4 >> 2]);
  f41 = Math_fround(f10 - f7);
  f13 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 20 >> 2]);
  f8 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 8 >> 2]);
  f38 = Math_fround(f13 - f8);
  f15 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 24 >> 2]);
  f23 = Math_fround(f15 - f6);
  f16 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 28 >> 2]);
  f40 = Math_fround(f16 - f7);
  f18 = Math_fround(HEAPF32[i52 + (i21 * 36 | 0) + 32 >> 2]);
  f20 = Math_fround(f18 - f8);
  f19 = Math_fround(Math_fround(f41 * f20) - Math_fround(f38 * f40));
  f20 = Math_fround(Math_fround(f38 * f23) - Math_fround(f39 * f20));
  f23 = Math_fround(Math_fround(f39 * f40) - Math_fround(f41 * f23));
  f41 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * f19);
  f41 = Math_fround(f41 + Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f20));
  if (!(Math_fround(Math_fround(f23 * Math_fround(HEAPF32[i43 >> 2])) + f41) > Math_fround(0.0))) {
   f39 = Math_fround(f44 + f6);
   f40 = Math_fround(f45 + f7);
   f41 = Math_fround(f42 + f8);
   f30 = Math_fround(f44 + f9);
   f31 = Math_fround(f45 + f10);
   f32 = Math_fround(f42 + f13);
   f27 = Math_fround(f44 + f15);
   f28 = Math_fround(f45 + f16);
   f29 = Math_fround(f42 + f18);
   f38 = Math_fround(f6 - f44);
   f37 = Math_fround(f7 - f45);
   f36 = Math_fround(f8 - f42);
   f35 = Math_fround(f9 - f44);
   f34 = Math_fround(f10 - f45);
   f33 = Math_fround(f13 - f42);
   f26 = Math_fround(f15 - f44);
   f25 = Math_fround(f16 - f45);
   f24 = Math_fround(f18 - f42);
   if (!(Math_fround(Math_fround(f42 * f23) + Math_fround(Math_fround(f44 * f19) + Math_fround(f45 * f20))) >= Math_fround(0.0))) {
    f6 = f24;
    f7 = f36;
    f8 = f37;
    f9 = f25;
    f10 = f26;
    f13 = f33;
    f15 = f34;
    f16 = f35;
    f18 = f38;
   } else {
    f6 = f29;
    f7 = f41;
    f8 = f40;
    f9 = f28;
    f10 = f27;
    f13 = f32;
    f15 = f31;
    f16 = f30;
    f18 = f39;
   }
   HEAPF32[i3 >> 2] = f18;
   HEAPF32[i3 + 4 >> 2] = f8;
   HEAPF32[i3 + 8 >> 2] = f7;
   HEAPF32[i3 + 12 >> 2] = f16;
   HEAPF32[i3 + 16 >> 2] = f15;
   HEAPF32[i3 + 20 >> 2] = f13;
   HEAPF32[i3 + 24 >> 2] = f10;
   HEAPF32[i3 + 28 >> 2] = f9;
   HEAPF32[i3 + 32 >> 2] = f6;
   HEAP32[i2 >> 2] = i21;
   HEAPF32[i3 + 36 >> 2] = f35;
   HEAPF32[i3 + 40 >> 2] = f34;
   HEAPF32[i3 + 44 >> 2] = f33;
   i4 = i3 + 48 | 0;
   HEAPF32[i4 >> 2] = f30;
   i5 = i3 + 52 | 0;
   HEAPF32[i5 >> 2] = f31;
   i11 = i3 + 56 | 0;
   HEAPF32[i11 >> 2] = f32;
   i12 = i3 + 60 | 0;
   HEAPF32[i12 >> 2] = f27;
   i14 = i3 + 64 | 0;
   HEAPF32[i14 >> 2] = f28;
   i17 = i3 + 68 | 0;
   HEAPF32[i17 >> 2] = f29;
   f18 = Math_fround(f30 - f35);
   f20 = Math_fround(f31 - f34);
   f23 = Math_fround(f32 - f33);
   f6 = Math_fround(f27 - f35);
   f7 = Math_fround(f28 - f34);
   f8 = Math_fround(f29 - f33);
   f19 = Math_fround(Math_fround(f20 * f8) - Math_fround(f23 * f7));
   f23 = Math_fround(Math_fround(f23 * f6) - Math_fround(f18 * f8));
   f20 = Math_fround(Math_fround(f18 * f7) - Math_fround(f20 * f6));
   f19 = Math_fround(f19 * Math_fround(HEAPF32[i55 >> 2]));
   f23 = Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i43 >> 2])) + f23) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f27;
    HEAPF32[i5 >> 2] = f28;
    HEAPF32[i11 >> 2] = f29;
    HEAPF32[i12 >> 2] = f30;
    HEAPF32[i14 >> 2] = f31;
    HEAPF32[i17 >> 2] = f32;
   }
   HEAP32[i2 + 4 >> 2] = i21;
   HEAPF32[i3 + 72 >> 2] = f35;
   HEAPF32[i3 + 76 >> 2] = f34;
   HEAPF32[i3 + 80 >> 2] = f33;
   i4 = i3 + 84 | 0;
   HEAPF32[i4 >> 2] = f27;
   i5 = i3 + 88 | 0;
   HEAPF32[i5 >> 2] = f28;
   i11 = i3 + 92 | 0;
   HEAPF32[i11 >> 2] = f29;
   i12 = i3 + 96 | 0;
   HEAPF32[i12 >> 2] = f26;
   i14 = i3 + 100 | 0;
   HEAPF32[i14 >> 2] = f25;
   i17 = i3 + 104 | 0;
   HEAPF32[i17 >> 2] = f24;
   f20 = Math_fround(f26 - f35);
   f18 = Math_fround(f25 - f34);
   f23 = Math_fround(f24 - f33);
   f19 = Math_fround(Math_fround(f7 * f23) - Math_fround(f18 * f8));
   f23 = Math_fround(Math_fround(f20 * f8) - Math_fround(f6 * f23));
   f20 = Math_fround(Math_fround(f6 * f18) - Math_fround(f20 * f7));
   f19 = Math_fround(f19 * Math_fround(HEAPF32[i55 >> 2]));
   f23 = Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i43 >> 2])) + f23) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f26;
    HEAPF32[i5 >> 2] = f25;
    HEAPF32[i11 >> 2] = f24;
    HEAPF32[i12 >> 2] = f27;
    HEAPF32[i14 >> 2] = f28;
    HEAPF32[i17 >> 2] = f29;
   }
   HEAP32[i2 + 8 >> 2] = i21;
   HEAPF32[i3 + 108 >> 2] = f38;
   HEAPF32[i3 + 112 >> 2] = f37;
   HEAPF32[i3 + 116 >> 2] = f36;
   i4 = i3 + 120 | 0;
   HEAPF32[i4 >> 2] = f26;
   i5 = i3 + 124 | 0;
   HEAPF32[i5 >> 2] = f25;
   i11 = i3 + 128 | 0;
   HEAPF32[i11 >> 2] = f24;
   i12 = i3 + 132 | 0;
   HEAPF32[i12 >> 2] = f27;
   i14 = i3 + 136 | 0;
   HEAPF32[i14 >> 2] = f28;
   i17 = i3 + 140 | 0;
   HEAPF32[i17 >> 2] = f29;
   f18 = Math_fround(f26 - f38);
   f20 = Math_fround(f25 - f37);
   f23 = Math_fround(f24 - f36);
   f6 = Math_fround(f27 - f38);
   f7 = Math_fround(f28 - f37);
   f8 = Math_fround(f29 - f36);
   f19 = Math_fround(Math_fround(f20 * f8) - Math_fround(f7 * f23));
   f23 = Math_fround(Math_fround(f6 * f23) - Math_fround(f18 * f8));
   f20 = Math_fround(Math_fround(f18 * f7) - Math_fround(f6 * f20));
   f19 = Math_fround(f19 * Math_fround(HEAPF32[i55 >> 2]));
   f23 = Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i43 >> 2])) + f23) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f27;
    HEAPF32[i5 >> 2] = f28;
    HEAPF32[i11 >> 2] = f29;
    HEAPF32[i12 >> 2] = f26;
    HEAPF32[i14 >> 2] = f25;
    HEAPF32[i17 >> 2] = f24;
   }
   HEAP32[i2 + 12 >> 2] = i21;
   HEAPF32[i3 + 144 >> 2] = f38;
   HEAPF32[i3 + 148 >> 2] = f37;
   HEAPF32[i3 + 152 >> 2] = f36;
   i4 = i3 + 156 | 0;
   HEAPF32[i4 >> 2] = f27;
   i5 = i3 + 160 | 0;
   HEAPF32[i5 >> 2] = f28;
   i11 = i3 + 164 | 0;
   HEAPF32[i11 >> 2] = f29;
   i12 = i3 + 168 | 0;
   HEAPF32[i12 >> 2] = f39;
   i14 = i3 + 172 | 0;
   HEAPF32[i14 >> 2] = f40;
   i17 = i3 + 176 | 0;
   HEAPF32[i17 >> 2] = f41;
   f25 = Math_fround(f39 - f38);
   f23 = Math_fround(f40 - f37);
   f26 = Math_fround(f41 - f36);
   f24 = Math_fround(Math_fround(f26 * f7) - Math_fround(f23 * f8));
   f26 = Math_fround(Math_fround(f25 * f8) - Math_fround(f26 * f6));
   f25 = Math_fround(Math_fround(f23 * f6) - Math_fround(f25 * f7));
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i55 >> 2]));
   f26 = Math_fround(f24 + Math_fround(f26 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f25 * Math_fround(HEAPF32[i43 >> 2])) + f26) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f39;
    HEAPF32[i5 >> 2] = f40;
    HEAPF32[i11 >> 2] = f41;
    HEAPF32[i12 >> 2] = f27;
    HEAPF32[i14 >> 2] = f28;
    HEAPF32[i17 >> 2] = f29;
   }
   HEAP32[i2 + 16 >> 2] = i21;
   HEAPF32[i3 + 180 >> 2] = f39;
   HEAPF32[i3 + 184 >> 2] = f40;
   HEAPF32[i3 + 188 >> 2] = f41;
   i4 = i3 + 192 | 0;
   HEAPF32[i4 >> 2] = f30;
   i5 = i3 + 196 | 0;
   HEAPF32[i5 >> 2] = f31;
   i11 = i3 + 200 | 0;
   HEAPF32[i11 >> 2] = f32;
   i12 = i3 + 204 | 0;
   HEAPF32[i12 >> 2] = f35;
   i14 = i3 + 208 | 0;
   HEAPF32[i14 >> 2] = f34;
   i17 = i3 + 212 | 0;
   HEAPF32[i17 >> 2] = f33;
   f26 = Math_fround(f30 - f39);
   f28 = Math_fround(f31 - f40);
   f29 = Math_fround(f32 - f41);
   f6 = Math_fround(f35 - f39);
   f7 = Math_fround(f34 - f40);
   f8 = Math_fround(f33 - f41);
   f27 = Math_fround(Math_fround(f28 * f8) - Math_fround(f7 * f29));
   f29 = Math_fround(Math_fround(f6 * f29) - Math_fround(f26 * f8));
   f28 = Math_fround(Math_fround(f26 * f7) - Math_fround(f6 * f28));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i55 >> 2]));
   f29 = Math_fround(f27 + Math_fround(f29 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f28 * Math_fround(HEAPF32[i43 >> 2])) + f29) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f35;
    HEAPF32[i5 >> 2] = f34;
    HEAPF32[i11 >> 2] = f33;
    HEAPF32[i12 >> 2] = f30;
    HEAPF32[i14 >> 2] = f31;
    HEAPF32[i17 >> 2] = f32;
   }
   HEAP32[i2 + 20 >> 2] = i21;
   HEAPF32[i3 + 216 >> 2] = f39;
   HEAPF32[i3 + 220 >> 2] = f40;
   HEAPF32[i3 + 224 >> 2] = f41;
   i4 = i3 + 228 | 0;
   HEAPF32[i4 >> 2] = f35;
   i5 = i3 + 232 | 0;
   HEAPF32[i5 >> 2] = f34;
   i11 = i3 + 236 | 0;
   HEAPF32[i11 >> 2] = f33;
   i12 = i3 + 240 | 0;
   HEAPF32[i12 >> 2] = f38;
   i14 = i3 + 244 | 0;
   HEAPF32[i14 >> 2] = f37;
   i17 = i3 + 248 | 0;
   HEAPF32[i17 >> 2] = f36;
   f32 = Math_fround(f38 - f39);
   f40 = Math_fround(f37 - f40);
   f41 = Math_fround(f36 - f41);
   f39 = Math_fround(Math_fround(f7 * f41) - Math_fround(f40 * f8));
   f41 = Math_fround(Math_fround(f32 * f8) - Math_fround(f6 * f41));
   f40 = Math_fround(Math_fround(f6 * f40) - Math_fround(f32 * f7));
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i55 >> 2]));
   f41 = Math_fround(f39 + Math_fround(f41 * Math_fround(HEAPF32[i22 >> 2])));
   if (Math_fround(Math_fround(f40 * Math_fround(HEAPF32[i43 >> 2])) + f41) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = f38;
    HEAPF32[i5 >> 2] = f37;
    HEAPF32[i11 >> 2] = f36;
    HEAPF32[i12 >> 2] = f35;
    HEAPF32[i14 >> 2] = f34;
    HEAPF32[i17 >> 2] = f33;
   }
   HEAP32[i2 + 24 >> 2] = i21;
   i2 = i2 + 28 | 0;
   i3 = i3 + 252 | 0;
  }
  i21 = i21 + 1 | 0;
 } while ((i21 | 0) != 12);
 HEAP16[i63 >> 1] = 0;
 i3 = HEAP32[i65 >> 2] | 0;
 f42 = Math_fround(HEAPF32[i54 >> 2]);
 f42 = Math_fround(f42 + Math_fround(HEAPF32[i46 >> 2]));
 f44 = Math_fround(HEAPF32[i48 >> 2]);
 f44 = Math_fround(f44 + Math_fround(HEAPF32[i47 >> 2]));
 f45 = Math_fround(HEAPF32[i50 >> 2]);
 f44 = Math_fround(f44 * Math_fround(.5));
 f45 = Math_fround(Math_fround(f45 + Math_fround(HEAPF32[i49 >> 2])) * Math_fround(.5));
 HEAPF32[i53 >> 2] = Math_fround(f42 * Math_fround(.5));
 HEAPF32[i53 + 4 >> 2] = f44;
 HEAPF32[i53 + 8 >> 2] = f45;
 if (__ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb(i2 - i56 >> 2, i3, i53, Math_fround(HEAPF32[i54 + 24 >> 2]), i55, f1, 0, i57, i59, i58, i62, i63, i61, 0, 0) | 0) {
  f1 = Math_fround(HEAPF32[i58 >> 2]);
  HEAP32[i60 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
  i2 = 1;
 } else i2 = 0;
 if (HEAP8[i51 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i65, i3);
 HEAPF32[i64 >> 2] = f1;
 i65 = i2;
 STACKTOP = i66;
 return i65 | 0;
}

function __ZN30ParticleSystemTrailGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, f81 = f0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0;
 i123 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i120 = i123 + 720 | 0;
 i121 = i123 + 8 | 0;
 i113 = i123 + 712 | 0;
 i114 = i123 + 708 | 0;
 i115 = i123 + 704 | 0;
 i116 = i123 + 688 | 0;
 i117 = i123 + 672 | 0;
 i5 = i123 + 148 | 0;
 i118 = i123 + 144 | 0;
 i119 = i123 + 24 | 0;
 i112 = i123;
 if ((HEAP16[gb + 1452224 + 6 >> 1] | 0) > -1) {
  HEAP32[i121 >> 2] = 0;
  HEAP32[i120 >> 2] = HEAP32[i121 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452224 | 0, i120);
  i111 = gb + 1452224 | 0;
 } else i111 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i107 = HEAP32[i8 + (i9 * 268 | 0) + 20 >> 2] | 0;
 i108 = i107 + 824 | 0;
 i109 = HEAP32[i108 >> 2] | 0;
 i4 = i109 + 1 | 0;
 HEAP32[i117 >> 2] = 0;
 i110 = i117 + 4 | 0;
 i105 = gb + 63160 | 0;
 i106 = HEAP32[i105 + 4 >> 2] | 0;
 i1 = i110;
 HEAP32[i1 >> 2] = HEAP32[i105 >> 2];
 HEAP32[i1 + 4 >> 2] = i106;
 i1 = i4 * 12 | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 621865 | 0, 1419) | 0;
   i105 = gb + 64016 | 0;
   i104 = HEAP32[i105 >> 2] | 0;
   i105 = HEAP32[i105 + 4 >> 2] | 0;
   HEAP32[i117 >> 2] = i1;
   i106 = i110;
   HEAP32[i106 >> 2] = i104;
   HEAP32[i106 + 4 >> 2] = i105;
   break;
  }
 } while (0);
 i7 = i1 + 3 & -4;
 i106 = i7;
 i3 = HEAP32[i3 + (i9 * 20 | 0) >> 2] | 0;
 i102 = i8 + (i9 * 268 | 0) + 24 | 0;
 i103 = i8 + (i9 * 268 | 0) + 52 | 0;
 i2 = HEAP32[i103 >> 2] | 0;
 i104 = i2 + 448 | 0;
 i105 = i2 + 712 | 0;
 i1 = HEAP32[i2 + 280 >> 2] | 0;
 __ZN14BatchAllocatorC2Ev(i5);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i5, i118, -1, 28, 1, 4);
 HEAP32[i118 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i5, 0, 0, 16, i4, 16);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i5, (HEAP32[i118 >> 2] | 0) + 4 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i5, (HEAP32[i118 >> 2] | 0) + 8 | 0, 0, 8, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i5, (HEAP32[i118 >> 2] | 0) + 12 | 0, 0, 8, i109 + -1 | 0, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i5, gb + 64016 | 0);
 f81 = Math_fround(HEAPF32[i8 + (i9 * 268 | 0) + 252 >> 2]);
 f81 = Math_fround(f81 * Math_fround(HEAPF32[i8 + (i9 * 268 | 0) + 256 >> 2]));
 f81 = Math_fround(+Math_pow(+Math_fround(Math_abs(Math_fround(f81 * Math_fround(HEAPF32[i8 + (i9 * 268 | 0) + 260 >> 2])))), .333333343));
 i82 = HEAP32[i107 + 12 >> 2] | 0;
 if (i82 | 0) {
  i83 = i107 + 800 | 0;
  i84 = i107 + 740 | 0;
  i85 = i107 + 780 | 0;
  i86 = i8 + (i9 * 268 | 0) + 267 | 0;
  i87 = i107 + 20 | 0;
  i88 = i107 + 40 | 0;
  i89 = i7;
  i90 = i106 + 4 | 0;
  i91 = i106 + 8 | 0;
  i92 = i8 + (i9 * 268 | 0) + 204 | 0;
  i93 = i8 + (i9 * 268 | 0) + 208 | 0;
  i94 = i8 + (i9 * 268 | 0) + 212 | 0;
  i95 = i8 + (i9 * 268 | 0) + 188 | 0;
  i96 = i8 + (i9 * 268 | 0) + 192 | 0;
  i97 = i8 + (i9 * 268 | 0) + 196 | 0;
  i98 = i8 + (i9 * 268 | 0) + 236 | 0;
  i99 = i8 + (i9 * 268 | 0) + 240 | 0;
  i100 = i8 + (i9 * 268 | 0) + 244 | 0;
  i101 = i8 + (i9 * 268 | 0) + 220 | 0;
  i71 = i8 + (i9 * 268 | 0) + 224 | 0;
  i72 = i8 + (i9 * 268 | 0) + 228 | 0;
  i73 = i8 + (i9 * 268 | 0) + 264 | 0;
  i74 = i119 + 100 | 0;
  i75 = i8 + (i9 * 268 | 0) + 265 | 0;
  i76 = i119 + 96 | 0;
  i77 = i119 + 108 | 0;
  i78 = i119 + 104 | 0;
  i79 = i8 + (i9 * 268 | 0) + 60 | 0;
  i80 = i8 + (i9 * 268 | 0) + 124 | 0;
  i44 = (i1 | 0) == 1;
  i45 = i120 + 12 | 0;
  i46 = i120 + 8 | 0;
  i47 = i120 + 4 | 0;
  i48 = i121 + 12 | 0;
  i49 = i121 + 8 | 0;
  i50 = i121 + 4 | 0;
  i51 = i120 + 4 | 0;
  i52 = i120 + 8 | 0;
  i53 = i120 + 4 | 0;
  i54 = i120 + 8 | 0;
  i55 = i120 + 4 | 0;
  i56 = i120 + 8 | 0;
  i57 = i120 + 4 | 0;
  i58 = i120 + 8 | 0;
  i59 = i120 + 4 | 0;
  i60 = i120 + 8 | 0;
  i61 = i120 + 4 | 0;
  i62 = i120 + 8 | 0;
  i63 = i121 + 2 | 0;
  i64 = i121 + 1 | 0;
  i65 = i116 + 12 | 0;
  i66 = i116 + 8 | 0;
  i67 = i116 + 4 | 0;
  i68 = i2 + 532 | 0;
  i69 = i2 + 528 | 0;
  i70 = i2 + 680 | 0;
  i34 = i2 + 592 | 0;
  i35 = i8 + (i9 * 268 | 0) + 28 | 0;
  i36 = i119 + 84 | 0;
  i37 = i120 + 4 | 0;
  i38 = i119 + 88 | 0;
  i39 = i120 + 8 | 0;
  i40 = i119 + 92 | 0;
  i41 = i8 + (i9 * 268 | 0) + 44 | 0;
  i42 = i8 + (i9 * 268 | 0) + 48 | 0;
  i43 = i107 + 871 | 0;
  i31 = i8 + (i9 * 268 | 0) + 266 | 0;
  i32 = i107 + 520 | 0;
  i33 = i106 + 12 | 0;
  i30 = i7;
  i1 = i3;
  i29 = 0;
  do {
   i4 = HEAP32[(HEAP32[i83 >> 2] | 0) + (i29 << 2) >> 2] | 0;
   i28 = i4 + 1 | 0;
   if (i28 >>> 0 > 1) {
    i7 = Math_imul(HEAP32[i108 >> 2] | 0, i29) | 0;
    i7 = (HEAP32[i84 >> 2] | 0) + (i7 << 4) | 0;
    i3 = HEAP32[(HEAP32[i85 >> 2] | 0) + (i29 << 2) >> 2] | 0;
    i2 = i4 + -1 | 0;
    if ((i2 | 0) > -1 & i3 >>> 0 < i109 >>> 0) {
     i5 = i2;
     while (1) {
      i25 = HEAP32[i7 + (i3 << 4) + 4 >> 2] | 0;
      i2 = HEAP32[i7 + (i3 << 4) + 8 >> 2] | 0;
      HEAP32[i106 + (i4 * 12 | 0) >> 2] = HEAP32[i7 + (i3 << 4) >> 2];
      i3 = i3 + 1 | 0;
      HEAP32[i106 + (i4 * 12 | 0) + 4 >> 2] = i25;
      HEAP32[i106 + (i4 * 12 | 0) + 8 >> 2] = i2;
      i2 = i5 + -1 | 0;
      if (!((i2 | 0) > -1 & i3 >>> 0 < i109 >>> 0)) break; else {
       i4 = i5;
       i5 = i2;
      }
     }
    }
    if ((i2 | 0) > -1) {
     i3 = 0;
     while (1) {
      i25 = i2 + 1 | 0;
      i23 = HEAP32[i7 + (i3 << 4) + 4 >> 2] | 0;
      i24 = HEAP32[i7 + (i3 << 4) + 8 >> 2] | 0;
      HEAP32[i106 + (i25 * 12 | 0) >> 2] = HEAP32[i7 + (i3 << 4) >> 2];
      HEAP32[i106 + (i25 * 12 | 0) + 4 >> 2] = i23;
      HEAP32[i106 + (i25 * 12 | 0) + 8 >> 2] = i24;
      if ((i2 | 0) > 0) {
       i3 = i3 + 1 | 0;
       i2 = i2 + -1 | 0;
      } else break;
     }
    }
    i4 = (HEAP8[i86 >> 0] | 0) == 0;
    if (i4) i122 = 18; else if (Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + (i29 << 2) >> 2]) > Math_fround(100.0)) {
     HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
     HEAP32[i30 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
    } else i122 = 18;
    if ((i122 | 0) == 18) {
     i122 = 0;
     i5 = HEAP32[(HEAP32[i107 >> 2] | 0) + (i29 << 2) >> 2] | 0;
     i2 = HEAP32[(HEAP32[i87 >> 2] | 0) + (i29 << 2) >> 2] | 0;
     i3 = HEAP32[(HEAP32[i88 >> 2] | 0) + (i29 << 2) >> 2] | 0;
     if (!i4) {
      f18 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f15 = Math_fround(f27 * Math_fround(HEAPF32[i92 >> 2]));
      f13 = Math_fround(f27 * Math_fround(HEAPF32[i93 >> 2]));
      f27 = Math_fround(f27 * Math_fround(HEAPF32[i94 >> 2]));
      f12 = Math_fround(f18 * Math_fround(HEAPF32[i95 >> 2]));
      f14 = Math_fround(f18 * Math_fround(HEAPF32[i96 >> 2]));
      f12 = Math_fround(f15 + f12);
      f14 = Math_fround(f13 + f14);
      f18 = Math_fround(f27 + Math_fround(f18 * Math_fround(HEAPF32[i97 >> 2])));
      f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f13 = Math_fround(HEAPF32[i98 >> 2]);
      f15 = Math_fround(HEAPF32[i99 >> 2]);
      f21 = Math_fround(HEAPF32[i100 >> 2]);
      f22 = Math_fround(f27 * Math_fround(HEAPF32[i101 >> 2]));
      f26 = Math_fround(f27 * Math_fround(HEAPF32[i71 >> 2]));
      f22 = Math_fround(f12 + Math_fround(f13 + f22));
      f26 = Math_fround(f14 + Math_fround(f15 + f26));
      f27 = Math_fround(f18 + Math_fround(f21 + Math_fround(f27 * Math_fround(HEAPF32[i72 >> 2]))));
      i5 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
     }
     HEAP32[i89 >> 2] = i5;
     HEAP32[i90 >> 2] = i2;
     HEAP32[i91 >> 2] = i3;
    }
    __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i107, i119, 1, i29);
    if (!(HEAP8[i73 >> 0] | 0)) f6 = Math_fround(1.0); else {
     HEAP32[i120 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i39 >> 2] = HEAP32[i40 >> 2];
     i2 = HEAP32[i41 >> 2] | 0;
     if (HEAP8[i2 + 4 >> 0] | 0) __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i2, i119, (HEAP8[i43 >> 0] | 0) != 0, i120);
     i2 = HEAP32[i42 >> 2] | 0;
     if (HEAP8[i2 + 4 >> 0] | 0) __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i2, i119, (HEAP8[i43 >> 0] | 0) != 0, i120);
     do if (!(HEAP8[i43 >> 0] | 0)) f6 = Math_fround(HEAPF32[i120 >> 2]); else {
      f6 = Math_fround(HEAPF32[i120 >> 2]);
      f6 = Math_fround(f6 * Math_fround(HEAPF32[i37 >> 2]));
      if (!(HEAP8[i31 >> 0] | 0)) {
       f6 = Math_fround(Math_sqrt(Math_fround(f6)));
       break;
      } else {
       f6 = Math_fround(+Math_pow(+Math_fround(f6 * Math_fround(HEAPF32[i39 >> 2])), .333333343));
       break;
      }
     } while (0);
    }
    f26 = Math_fround(f81 * f6);
    i24 = (HEAP32[i74 >> 2] | 0) + -19123109 | 0;
    i25 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
    i24 = i24 << 11 ^ i24;
    f27 = Math_fround(Math_fround(((i25 ^ i24 ^ i24 >>> 8) & 8388607 ^ i25 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    if (!(HEAP8[i75 >> 0] | 0)) HEAP32[i76 >> 2] = -1; else {
     i2 = HEAP32[i102 >> 2] | 0;
     if (HEAP8[i2 + 4 >> 0] | 0) __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i2, i119, i76);
     i2 = HEAP32[i35 >> 2] | 0;
     if (HEAP8[i2 + 4 >> 0] | 0) __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i2, i119, i76);
    }
    f6 = Math_fround(HEAPF32[i77 >> 2]);
    if (f6 != Math_fround(0.0)) f6 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i78 >> 2])) / f6); else f6 = Math_fround(0.0);
    i20 = (HEAP32[i74 >> 2] | 0) + 1494990940 | 0;
    i4 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
    i20 = i20 << 11 ^ i20;
    f18 = Math_fround(Math_fround(((i4 ^ i20 ^ i20 >>> 8) & 8388607 ^ i4 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    __Z8EvaluateRK14MinMaxGradientff(i120, (HEAP32[i103 >> 2] | 0) + 292 | 0, f6, f18);
    i4 = HEAP32[i76 >> 2] | 0;
    i20 = HEAP32[i120 >> 2] | 0;
    i2 = (Math_imul((i20 & 255) + 1 | 0, i4 & 255) | 0) >>> 8 & 255;
    i5 = i4 >>> 8;
    i3 = Math_imul((i20 >>> 8 & 255) + 1 | 0, i5 & 255) | 0;
    i4 = Math_imul((i20 >>> 16 & 255) + 1 | 0, i4 & 16711680) | 0;
    i5 = Math_imul((i20 >>> 24) + 1 | 0, i5 & 16711680) | 0;
    HEAP32[i76 >> 2] = i3 & 65280 | i5 & -16777216 | i2 | i4 >>> 8 & 16711680;
    i20 = (HEAP32[i74 >> 2] | 0) + 1827843104 | 0;
    i19 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
    i20 = i20 << 11 ^ i20;
    f18 = Math_fround(Math_fround(((i19 ^ i20 ^ i20 >>> 8) & 8388607 ^ i19 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    i19 = HEAP32[i118 >> 2] | 0;
    HEAP32[i113 >> 2] = i1;
    i20 = i19 + 24 | 0;
    HEAP32[i20 >> 2] = i28;
    __Z13StoreLineDataP15LineBuilderDataRfRKN4math8float4x4EPKNS2_14float3_storageE(i19, i114, i79, i106);
    f22 = Math_fround(HEAPF32[i114 >> 2]);
    f21 = Math_fround(Math_fround(1.0) / f22);
    f22 = i44 ? f22 : Math_fround(1.0);
    L60 : do if (i28 | 0) {
     i23 = i19 + 4 | 0;
     i24 = i19 + 8 | 0;
     i25 = i19 + 12 | 0;
     i17 = i2 + 1 | 0;
     i16 = (i3 >>> 8 & 255) + 1 | 0;
     i9 = (i4 >>> 24) + 1 | 0;
     i8 = (i5 >>> 24) + 1 | 0;
     f15 = Math_fround(0.0);
     i2 = 0;
     while (1) {
      f15 = Math_fround(f15 + Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + (i2 << 2) >> 2]));
      f14 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(f21 * f15)))));
      HEAPF32[i115 >> 2] = f14;
      __Z8EvaluateRK14MinMaxGradientff(i120, i105, f14, f18);
      i4 = HEAP32[i120 >> 2] | 0;
      i3 = i4 >>> 8;
      i4 = (Math_imul(i3 & 255, i16) | 0) & 65280 | (Math_imul(i3 & 16711680, i8) | 0) & -16777216 | (Math_imul(i4 & 255, i17) | 0) >>> 8 & 255 | (Math_imul(i4 & 16711680, i9) | 0) >>> 8 & 16711680;
      i3 = HEAP32[i115 >> 2] | 0;
      HEAP32[i45 >> 2] = i3;
      HEAP32[i46 >> 2] = i3;
      HEAP32[i47 >> 2] = i3;
      HEAP32[i120 >> 2] = i3;
      HEAPF32[i48 >> 2] = f27;
      HEAPF32[i49 >> 2] = f27;
      HEAPF32[i50 >> 2] = f27;
      HEAPF32[i121 >> 2] = f27;
      i3 = HEAP32[i68 >> 2] | 0;
      L64 : do switch ((i3 & 65535) << 16 >> 16) {
      case 0:
       {
        i7 = HEAP32[i69 >> 2] | 0;
        HEAP32[i65 >> 2] = i7;
        HEAP32[i66 >> 2] = i7;
        HEAP32[i67 >> 2] = i7;
        HEAP32[i116 >> 2] = i7;
        break;
       }
      case 3:
       {
        f14 = Math_fround(HEAPF32[(HEAP32[i70 >> 2] | 0) + 4 >> 2]);
        f13 = Math_fround(HEAPF32[i69 >> 2]);
        f14 = Math_fround(f14 * f13);
        f14 = Math_fround(f14 + Math_fround(f27 * Math_fround(Math_fround(f13 * Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + 4 >> 2])) - f14)));
        HEAPF32[i116 >> 2] = f14;
        HEAPF32[i67 >> 2] = f14;
        HEAPF32[i66 >> 2] = f14;
        HEAPF32[i65 >> 2] = f14;
        break;
       }
      default:
       if (!(i3 & 16711680)) {
        __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i116, i104, i120, i121);
        break L64;
       } else {
        __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i116, i104, i120, i121);
        break L64;
       }
      } while (0);
      f6 = Math_fround(f26 * Math_fround(HEAPF32[i116 >> 2]));
      HEAPF32[i115 >> 2] = Math_fround(f22 * Math_fround(HEAPF32[i115 >> 2]));
      HEAP32[i121 >> 2] = i4;
      if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
       i7 = HEAP32[i121 >> 2] | 0;
       i3 = i7 >>> 16;
       i4 = i7;
       i5 = i7 & 255;
       i7 = i7 >>> 8 & 255;
      } else {
       i4 = HEAP32[i121 >> 2] | 0;
       i3 = i4;
       i5 = HEAP8[i63 >> 0] | 0;
       i7 = HEAP8[i64 >> 0] | 0;
      }
      HEAP32[i121 >> 2] = i4 & -16777216 | i3 << 16 & 16711680 | i5 & 255 | (i7 & 255) << 8;
      f6 = Math_fround(f6 * Math_fround(.5));
      i4 = (i2 | 0) == 0;
      i3 = (HEAP32[i20 >> 2] | 0) + -1 | 0;
      i7 = (i3 | 0) == (i2 | 0);
      i5 = HEAP32[i19 >> 2] | 0;
      f13 = Math_fround(HEAPF32[i5 + (i2 << 4) >> 2]);
      f14 = Math_fround(HEAPF32[i5 + (i2 << 4) + 4 >> 2]);
      i5 = HEAP32[i5 + (i2 << 4) + 8 >> 2] | 0;
      do if (i4 | i7) {
       i2 = i2 + 1 | 0;
       i3 = (HEAP32[i24 >> 2] | 0) + ((i3 >>> 0 < i2 >>> 0 ? i3 : i2) << 3) | 0;
       f11 = Math_fround(HEAPF32[i3 >> 2]);
       f11 = Math_fround(f6 * f11);
       f12 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 4 >> 2]));
       f6 = Math_fround(f13 + f11);
       f10 = Math_fround(f14 + f12);
       HEAPF32[i120 >> 2] = f6;
       HEAPF32[i51 >> 2] = f10;
       HEAP32[i52 >> 2] = i5;
       __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(1.0));
       if (i4) {
        HEAPF32[i120 >> 2] = f6;
        HEAPF32[i53 >> 2] = f10;
        HEAP32[i54 >> 2] = i5;
        __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(1.0));
       }
       f10 = Math_fround(f13 - f11);
       f6 = Math_fround(f14 - f12);
       HEAPF32[i120 >> 2] = f10;
       HEAPF32[i55 >> 2] = f6;
       HEAP32[i56 >> 2] = i5;
       __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(0.0));
       if (!i7) break;
       HEAPF32[i120 >> 2] = f10;
       HEAPF32[i57 >> 2] = f6;
       HEAP32[i58 >> 2] = i5;
       __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(0.0));
      } else {
       i7 = (HEAP32[i25 >> 2] | 0) + (i2 + -1 << 3) | 0;
       f12 = Math_fround(HEAPF32[i7 >> 2]);
       f12 = Math_fround(f6 * f12);
       f11 = Math_fround(f6 * Math_fround(HEAPF32[i7 + 4 >> 2]));
       f10 = Math_fround(f14 - f11);
       HEAPF32[i120 >> 2] = Math_fround(f13 - f12);
       HEAPF32[i59 >> 2] = f10;
       HEAP32[i60 >> 2] = i5;
       __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(1.0));
       f14 = Math_fround(f14 + f11);
       HEAPF32[i120 >> 2] = Math_fround(f13 + f12);
       HEAPF32[i61 >> 2] = f14;
       HEAP32[i62 >> 2] = i5;
       __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i113, i80, i120, i121, i115, Math_fround(0.0));
       i2 = i2 + 1 | 0;
      } while (0);
      if ((i2 | 0) == (i28 | 0)) break L60;
     }
    } while (0);
    i1 = i1 + ((i28 << 1) * 24 | 0) + 48 | 0;
   }
   i29 = i29 + 1 | 0;
  } while ((i29 | 0) != (i82 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i118 >> 2] | 0, gb + 64016 | 0);
 i122 = i107 + 884 | 0;
 HEAP32[i122 >> 2] = (HEAP32[i122 >> 2] | 0) + -1;
 if (!(HEAP32[i122 >> 2] | 0)) {
  i119 = gb + 63264 | 0;
  i121 = HEAP32[i119 + 4 >> 2] | 0;
  i122 = i112;
  HEAP32[i122 >> 2] = HEAP32[i119 >> 2];
  HEAP32[i122 + 4 >> 2] = i121;
  HEAP32[i120 >> 2] = HEAP32[i112 >> 2];
  HEAP32[i120 + 4 >> 2] = HEAP32[i112 + 4 >> 2];
  __ZN32ParticleSystemGeometryJobModules7ReleaseE10MemLabelId(i102, i120);
  __ZN23ParticleSystemParticlesD2Ev(i107);
  __Z19free_alloc_internalPvRK10MemLabelId(i107, gb + 63264 | 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i117 >> 2] | 0, i110);
 if (!i111) {
  STACKTOP = i123;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i111);
 STACKTOP = i123;
 return;
}

function __ZN5physx21PxVehicleDriveSimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i2 + 1088 | 0;
 i36 = i2 + 1056 | 0;
 i35 = i2 + 1024 | 0;
 i34 = i2 + 992 | 0;
 i33 = i2 + 960 | 0;
 i32 = i2 + 928 | 0;
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i37 >> 2] = HEAP32[gb + 159376 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[gb + 159376 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[gb + 159376 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[gb + 159376 + 12 >> 2];
 HEAP32[i37 + 16 >> 2] = HEAP32[gb + 159376 + 16 >> 2];
 HEAP32[i37 + 20 >> 2] = HEAP32[gb + 159376 + 20 >> 2];
 HEAP32[i37 + 24 >> 2] = HEAP32[gb + 159376 + 24 >> 2];
 HEAP32[i37 + 28 >> 2] = HEAP32[gb + 159376 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i37 | 0, 32) | 0;
 HEAP32[i36 >> 2] = HEAP32[gb + 159408 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[gb + 159408 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[gb + 159408 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[gb + 159408 + 12 >> 2];
 HEAP32[i36 + 16 >> 2] = HEAP32[gb + 159408 + 16 >> 2];
 HEAP32[i36 + 20 >> 2] = HEAP32[gb + 159408 + 20 >> 2];
 HEAP32[i36 + 24 >> 2] = HEAP32[gb + 159408 + 24 >> 2];
 HEAP32[i36 + 28 >> 2] = HEAP32[gb + 159408 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i36 | 0, 32) | 0;
 HEAP32[i35 >> 2] = HEAP32[gb + 159440 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[gb + 159440 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[gb + 159440 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[gb + 159440 + 12 >> 2];
 HEAP32[i35 + 16 >> 2] = HEAP32[gb + 159440 + 16 >> 2];
 HEAP32[i35 + 20 >> 2] = HEAP32[gb + 159440 + 20 >> 2];
 HEAP32[i35 + 24 >> 2] = HEAP32[gb + 159440 + 24 >> 2];
 HEAP32[i35 + 28 >> 2] = HEAP32[gb + 159440 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i35 | 0, 32) | 0;
 HEAP32[i34 >> 2] = HEAP32[gb + 159472 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[gb + 159472 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[gb + 159472 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[gb + 159472 + 12 >> 2];
 HEAP32[i34 + 16 >> 2] = HEAP32[gb + 159472 + 16 >> 2];
 HEAP32[i34 + 20 >> 2] = HEAP32[gb + 159472 + 20 >> 2];
 HEAP32[i34 + 24 >> 2] = HEAP32[gb + 159472 + 24 >> 2];
 HEAP32[i34 + 28 >> 2] = HEAP32[gb + 159472 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i34 | 0, 32) | 0;
 HEAP32[i33 >> 2] = HEAP32[gb + 159504 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[gb + 159504 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[gb + 159504 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[gb + 159504 + 12 >> 2];
 HEAP32[i33 + 16 >> 2] = HEAP32[gb + 159504 + 16 >> 2];
 HEAP32[i33 + 20 >> 2] = HEAP32[gb + 159504 + 20 >> 2];
 HEAP32[i33 + 24 >> 2] = HEAP32[gb + 159504 + 24 >> 2];
 HEAP32[i33 + 28 >> 2] = HEAP32[gb + 159504 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i33 | 0, 32) | 0;
 HEAP32[i32 >> 2] = HEAP32[gb + 159536 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[gb + 159536 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[gb + 159536 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[gb + 159536 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[gb + 159536 + 16 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[gb + 159536 + 20 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[gb + 159536 + 24 >> 2];
 HEAP32[i32 + 28 >> 2] = HEAP32[gb + 159536 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i32 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 159568 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 159568 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 159568 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 159568 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 159568 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 159568 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 159568 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 159568 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 159600 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 159600 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 159600 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 159600 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 159600 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 159600 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 159600 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 159600 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 159632 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 159632 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 159632 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 159632 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 159632 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 159632 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 159632 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 159632 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 159664 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 159664 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 159664 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 159664 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 159664 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 159664 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 159664 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 159664 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 159696 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 159696 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 159696 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 159696 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 159696 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 159696 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 159696 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 159696 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 159728 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 159728 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 159728 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 159728 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 159728 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 159728 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 159728 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 159728 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 159760 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 159760 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 159760 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 159760 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 159760 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 159760 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 159760 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 159760 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 159792 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 159792 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 159792 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 159792 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 159792 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 159792 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 159792 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 159792 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 159824 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 159824 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 159824 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 159824 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 159824 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 159824 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 159824 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 159824 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 159856 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 159856 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 159856 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 159856 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 159856 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 159856 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 159856 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 159856 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 159888 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 159888 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 159888 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 159888 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 159888 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 159888 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 159888 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 159888 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 159920 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 159920 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 159920 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 159920 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 159920 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 159920 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 159920 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 159920 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 159952 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 159952 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 159952 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 159952 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 159952 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 159952 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 159952 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 159952 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 159984 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 159984 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 159984 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 159984 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 159984 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 159984 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 159984 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 159984 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 160016 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 160016 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 160016 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 160016 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 160016 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 160016 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 160016 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 160016 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 160048 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 160048 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 160048 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 160048 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 160048 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 160048 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 160048 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 160048 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 160080 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 160080 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 160080 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 160080 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 160080 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 160080 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 160080 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 160080 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 160112 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 160112 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 160112 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 160112 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 160112 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 160112 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 160112 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 160112 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 160144 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 160144 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 160144 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 160144 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 160144 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 160144 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 160144 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 160144 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 160176 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 160176 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 160176 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 160176 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 160176 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 160176 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 160176 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 160176 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 160208 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 160208 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 160208 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 160208 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 160208 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 160208 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 160208 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 160208 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 160240 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 160240 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 160240 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 160240 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 160240 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 160240 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 160240 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 160240 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 160272 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 160272 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 160272 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 160272 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 160272 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 160272 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 160272 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 160272 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 160304 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 160304 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 160304 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 160304 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 160304 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 160304 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 160304 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 160304 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 160336 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 160336 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 160336 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 160336 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 160336 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 160336 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 160336 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 160336 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 160368 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 160368 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 160368 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 160368 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 160368 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 160368 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 160368 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 160368 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 160400 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 160400 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 160400 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 160400 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 160400 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 160400 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 160400 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 160400 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 160432 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 160432 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 160432 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 160432 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 160432 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 160432 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 160432 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 160432 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 160464 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 160464 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 160464 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 160464 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 160464 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 160464 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 160464 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 160464 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_116D6JointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i36, i35, i2, i3, i1) {
 i36 = i36 | 0;
 i35 = i35 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, f39 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i34 + 140 | 0;
 i33 = i34 + 112 | 0;
 i29 = i34 + 84 | 0;
 i30 = i34 + 56 | 0;
 i31 = i34 + 28 | 0;
 i32 = i34;
 f4 = Math_fround(Math_fround(HEAPF32[i35 + 16 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i35 + 20 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(HEAPF32[i35 + 24 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f14 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(f4 * f6);
 f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f15 * f22));
 f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f17 * f21));
 f16 = Math_fround(Math_fround(f6 * f20) + Math_fround(Math_fround(f4 * f14) + Math_fround(f7 * Math_fround(Math_fround(f17 * f22) - Math_fround(f15 * f21)))));
 f5 = Math_fround(Math_fround(f22 * f20) + Math_fround(Math_fround(f15 * f14) + Math_fround(f7 * Math_fround(Math_fround(f4 * f21) - Math_fround(f17 * f6)))));
 f20 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f7 * Math_fround(Math_fround(f15 * f6) - Math_fround(f4 * f22)))) + Math_fround(f21 * f20));
 f16 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f16);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f5);
 f20 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f20);
 f4 = Math_fround(HEAPF32[i35 >> 2]);
 f15 = Math_fround(f7 * f4);
 f14 = Math_fround(HEAPF32[i35 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f6 * f14));
 f17 = Math_fround(HEAPF32[i35 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f22 * f17));
 f13 = Math_fround(HEAPF32[i35 + 4 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f21 * f4) + Math_fround(Math_fround(f22 * f14) + Math_fround(f7 * f13))) - Math_fround(f6 * f17));
 f18 = Math_fround(Math_fround(Math_fround(f6 * f13) + Math_fround(Math_fround(f21 * f14) + Math_fround(f7 * f17))) - Math_fround(f22 * f4));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f14) - Math_fround(f6 * f4)) - Math_fround(f22 * f13)) - Math_fround(f21 * f17));
 HEAPF32[i38 >> 2] = Math_fround(f15 - Math_fround(f21 * f13));
 i37 = i38 + 4 | 0;
 HEAPF32[i37 >> 2] = f19;
 i1 = i38 + 8 | 0;
 HEAPF32[i1 >> 2] = f18;
 i2 = i38 + 12 | 0;
 HEAPF32[i2 >> 2] = f17;
 HEAPF32[i38 + 16 >> 2] = f16;
 HEAPF32[i38 + 20 >> 2] = f5;
 HEAPF32[i38 + 24 >> 2] = f20;
 f20 = Math_fround(Math_fround(HEAPF32[i35 + 44 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i35 + 48 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i35 + 52 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f20 * f19);
 f21 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f5 * f21));
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f16 * f15));
 f22 = Math_fround(Math_fround(f19 * f13) + Math_fround(Math_fround(f20 * f18) + Math_fround(f17 * Math_fround(Math_fround(f16 * f21) - Math_fround(f5 * f15)))));
 f4 = Math_fround(Math_fround(f21 * f13) + Math_fround(Math_fround(f5 * f18) + Math_fround(f17 * Math_fround(Math_fround(f20 * f15) - Math_fround(f16 * f19)))));
 f13 = Math_fround(Math_fround(Math_fround(f16 * f18) + Math_fround(f17 * Math_fround(Math_fround(f5 * f19) - Math_fround(f20 * f21)))) + Math_fround(f15 * f13));
 f22 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f22);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f4);
 f13 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f13);
 f20 = Math_fround(HEAPF32[i35 + 28 >> 2]);
 f5 = Math_fround(f17 * f20);
 f18 = Math_fround(HEAPF32[i35 + 40 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f19 * f18));
 f16 = Math_fround(HEAPF32[i35 + 36 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f21 * f16));
 f6 = Math_fround(HEAPF32[i35 + 32 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f21 * f18) + Math_fround(f17 * f6))) - Math_fround(f19 * f16));
 f7 = Math_fround(Math_fround(Math_fround(f19 * f6) + Math_fround(Math_fround(f15 * f18) + Math_fround(f17 * f16))) - Math_fround(f21 * f20));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f18) - Math_fround(f19 * f20)) - Math_fround(f21 * f6)) - Math_fround(f15 * f16));
 HEAPF32[i33 >> 2] = Math_fround(f5 - Math_fround(f15 * f6));
 i23 = i33 + 4 | 0;
 HEAPF32[i23 >> 2] = f14;
 i24 = i33 + 8 | 0;
 HEAPF32[i24 >> 2] = f7;
 i25 = i33 + 12 | 0;
 HEAPF32[i25 >> 2] = f16;
 i26 = i33 + 16 | 0;
 HEAPF32[i26 >> 2] = f22;
 i27 = i33 + 20 | 0;
 HEAPF32[i27 >> 2] = f4;
 i28 = i33 + 24 | 0;
 HEAPF32[i28 >> 2] = f13;
 mftCall_viii(HEAP32[(HEAP32[i36 >> 2] | 0) + 8 >> 2] | 0, i36 | 0, i38 | 0, i33 | 0);
 f13 = Math_fround(HEAPF32[i38 >> 2]);
 f4 = Math_fround(HEAPF32[i33 >> 2]);
 f22 = Math_fround(f13 * f4);
 f16 = Math_fround(HEAPF32[i37 >> 2]);
 f7 = Math_fround(HEAPF32[i23 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f16 * f7));
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i24 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f14 * f6));
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i25 >> 2]);
 if (Math_fround(f22 + Math_fround(f15 * f5)) < Math_fround(0.0)) {
  f4 = Math_fround(-f4);
  f7 = Math_fround(-f7);
  f6 = Math_fround(-f6);
  f5 = Math_fround(-f5);
  HEAPF32[i33 >> 2] = f4;
  HEAPF32[i23 >> 2] = f7;
  HEAPF32[i24 >> 2] = f6;
  HEAPF32[i25 >> 2] = f5;
 }
 f21 = Math_fround(-f13);
 f22 = Math_fround(-f16);
 f12 = Math_fround(-f14);
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(f5 * f21)) + Math_fround(f6 * f22)) - Math_fround(f7 * f12));
 f10 = Math_fround(Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f5 * f22) + Math_fround(f15 * f7))) - Math_fround(f6 * f21));
 f11 = Math_fround(Math_fround(Math_fround(f7 * f21) + Math_fround(Math_fround(f5 * f12) + Math_fround(f15 * f6))) - Math_fround(f4 * f22));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f5) - Math_fround(f4 * f21)) - Math_fround(f7 * f22)) - Math_fround(f6 * f12));
 if (f9 != Math_fround(0.0)) {
  f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(0.0)) + Math_fround(f12 * f12)))));
  f17 = Math_fround(f9 * f18);
  f8 = Math_fround(f18 * Math_fround(0.0));
  f18 = Math_fround(f12 * f18);
 } else {
  f17 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f18 = Math_fround(1.0);
 }
 f39 = Math_fround(-f17);
 f19 = Math_fround(-f8);
 f22 = Math_fround(f12 * f19);
 f20 = Math_fround(f9 * f19);
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f18) + f22) + Math_fround(f11 * f39)) - f20);
 f22 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(f11 * f18) + f22)) - Math_fround(f10 * f39));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f18) - Math_fround(f9 * f39)) - Math_fround(f10 * f19)) - Math_fround(f11 * f19));
 f10 = Math_fround(f13 + f13);
 f9 = Math_fround(f16 + f16);
 f12 = Math_fround(f14 + f14);
 f11 = Math_fround(f10 * f15);
 f39 = Math_fround(f9 * f14);
 f20 = Math_fround(Math_fround(f10 * f16) - Math_fround(f12 * f15));
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f10));
 f12 = Math_fround(f8 - Math_fround(f14 * f12));
 f13 = Math_fround(f39 + f11);
 f10 = Math_fround(Math_fround(f10 * f14) + Math_fround(f9 * f15));
 f11 = Math_fround(f39 - f11);
 f9 = Math_fround(f8 - Math_fround(f16 * f9));
 f16 = Math_fround(f4 + f4);
 f4 = Math_fround(f7 + f7);
 f15 = Math_fround(f6 + f6);
 f8 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f7 * f4)) - Math_fround(f6 * f15));
 f7 = Math_fround(Math_fround(f16 * f7) + Math_fround(f15 * f5));
 f4 = Math_fround(Math_fround(f16 * f6) - Math_fround(f4 * f5));
 i2 = i35 + 328 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 8) {
  f18 = Math_fround(f17 / Math_fround(f18 + Math_fround(1.0)));
  f16 = Math_fround(HEAPF32[i35 + 144 >> 2]);
  f17 = Math_fround(HEAPF32[i35 + 140 >> 2]);
  f18 = Math_fround(Math_abs(Math_fround(f18)));
  f39 = Math_fround(HEAPF32[i35 + 364 >> 2]);
  mftCall_viiffi(HEAP32[(HEAP32[i36 >> 2] | 0) + 16 >> 2] | 0, i36 | 0, i33 | 0, +f16, +f17, f18 > Math_fround(f39 + Math_fround(HEAPF32[i35 + 356 >> 2])) | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i2 = i1 & 16;
 i3 = (i2 | 0) != 0;
 i1 = i1 >>> 5 & 1;
 if (!((i1 | 0) == 0 | i3 ^ 1)) {
  f39 = Math_fround(f19 + Math_fround(1.0));
  f22 = Math_fround(f22 / f39);
  f39 = Math_fround(-Math_fround(f21 / f39));
  f20 = Math_fround(HEAPF32[i35 + 352 >> 2]);
  f21 = Math_fround(HEAPF32[i35 + 348 >> 2]);
  f19 = Math_fround(HEAPF32[i35 + 356 >> 2]);
  f22 = Math_fround(Math_abs(Math_fround(f22)));
  f39 = Math_fround(Math_abs(Math_fround(f39)));
  f22 = Math_fround(Math_fround(Math_fround(f19 + f22) / Math_fround(Math_fround(1.0) - Math_fround(f19 * f22))) / f20);
  f39 = Math_fround(Math_fround(Math_fround(f19 + f39) / Math_fround(Math_fround(1.0) - Math_fround(f19 * f39))) / f21);
  mftCall_viiffi(HEAP32[(HEAP32[i36 >> 2] | 0) + 20 >> 2] | 0, i36 | 0, i33 | 0, +f20, +f21, !(Math_fround(Math_fround(f22 * f22) + Math_fround(f39 * f39)) <= Math_fround(1.0)) | 0);
  STACKTOP = i34;
  return;
 }
 if ((i2 >>> 4 | 0) == (i1 | 0)) {
  STACKTOP = i34;
  return;
 }
 i1 = HEAP32[i35 + 324 >> 2] | 0;
 if (i3) if (!(i1 & 32)) {
  i38 = HEAP32[(HEAP32[i36 >> 2] | 0) + 24 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i25 >> 2]);
  f14 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
  f15 = Math_fround(HEAPF32[i33 >> 2]);
  f12 = Math_fround(f15 * Math_fround(0.0));
  f13 = Math_fround(HEAPF32[i23 >> 2]);
  f16 = Math_fround(f13 * Math_fround(0.0));
  f21 = Math_fround(f12 + f16);
  f17 = Math_fround(HEAPF32[i24 >> 2]);
  f20 = Math_fround(f17 * Math_fround(0.0));
  f21 = Math_fround(f21 + f20);
  f14 = Math_fround(f14 * Math_fround(0.0));
  f39 = Math_fround(Math_fround(f15 * f21) + Math_fround(f14 + Math_fround(f6 * Math_fround(f16 - f20))));
  f22 = Math_fround(Math_fround(f13 * f21) + Math_fround(f14 + Math_fround(f6 * Math_fround(f20 - f12))));
  f21 = Math_fround(Math_fround(f14 + Math_fround(f6 * Math_fround(f12 - f16))) + Math_fround(f17 * f21));
  f39 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f39);
  f22 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f22);
  f21 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f21);
  f14 = Math_fround(f6 * Math_fround(0.0));
  f15 = Math_fround(f15 * Math_fround(.707106769));
  f17 = Math_fround(f17 * Math_fround(.707106769));
  f6 = Math_fround(f6 * Math_fround(.707106769));
  f13 = Math_fround(f13 * Math_fround(.707106769));
  f18 = Math_fround(Math_fround(f20 + Math_fround(f6 + f13)) - f12);
  f19 = Math_fround(Math_fround(f15 + Math_fround(f14 + f17)) - f16);
  f20 = Math_fround(Math_fround(Math_fround(f6 - f12) - f13) - f20);
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(f14 + f15) + f16) - f17);
  HEAPF32[i30 + 4 >> 2] = f18;
  HEAPF32[i30 + 8 >> 2] = f19;
  HEAPF32[i30 + 12 >> 2] = f20;
  HEAPF32[i30 + 16 >> 2] = f39;
  HEAPF32[i30 + 20 >> 2] = f22;
  HEAPF32[i30 + 24 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i35 + 168 >> 2]);
  f22 = Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f10 * f8) + Math_fround(f11 * f7)));
  f22 = Math_fround(Math_abs(Math_fround(f22 / Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f22 * f22)) + Math_fround(1.0)))));
  f39 = Math_fround(HEAPF32[i35 + 336 >> 2]);
  mftCall_viifi(i38 | 0, i36 | 0, i30 | 0, +f21, f22 > Math_fround(f39 - Math_fround(HEAPF32[i35 + 344 >> 2])) | 0);
  STACKTOP = i34;
  return;
 } else {
  i38 = HEAP32[(HEAP32[i36 >> 2] | 0) + 16 >> 2] | 0;
  f9 = Math_fround(HEAPF32[i25 >> 2]);
  f14 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
  f10 = Math_fround(HEAPF32[i33 >> 2]);
  f13 = Math_fround(f10 * Math_fround(0.0));
  f11 = Math_fround(HEAPF32[i23 >> 2]);
  f12 = Math_fround(f11 * Math_fround(0.0));
  f20 = Math_fround(f13 + f12);
  f39 = Math_fround(HEAPF32[i24 >> 2]);
  f18 = Math_fround(f39 * Math_fround(0.0));
  f20 = Math_fround(f20 + f18);
  f14 = Math_fround(f14 * Math_fround(0.0));
  f22 = Math_fround(Math_fround(f10 * f20) + Math_fround(f14 + Math_fround(f9 * Math_fround(f12 - f18))));
  f18 = Math_fround(Math_fround(f11 * f20) + Math_fround(f14 + Math_fround(f9 * Math_fround(f18 - f13))));
  f20 = Math_fround(Math_fround(f14 + Math_fround(f9 * Math_fround(f13 - f12))) + Math_fround(f39 * f20));
  f22 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f22);
  f18 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f18);
  f20 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f20);
  f12 = Math_fround(f9 * Math_fround(-0.0));
  f13 = Math_fround(f10 * Math_fround(.707106769));
  f14 = Math_fround(f11 * Math_fround(.707106769));
  f15 = Math_fround(f39 * Math_fround(-0.0));
  f16 = Math_fround(f13 + Math_fround(f15 + Math_fround(f12 + f14)));
  f9 = Math_fround(f9 * Math_fround(.707106769));
  f39 = Math_fround(f39 * Math_fround(.707106769));
  f10 = Math_fround(f10 * Math_fround(-0.0));
  f11 = Math_fround(f11 * Math_fround(-0.0));
  f17 = Math_fround(Math_fround(f10 + Math_fround(f39 - f9)) - f11);
  f39 = Math_fround(Math_fround(Math_fround(f9 - f10) - f11) + f39);
  HEAPF32[i29 >> 2] = Math_fround(Math_fround(Math_fround(f12 + f13) - f14) - f15);
  HEAPF32[i29 + 4 >> 2] = f16;
  HEAPF32[i29 + 8 >> 2] = f17;
  HEAPF32[i29 + 12 >> 2] = f39;
  HEAPF32[i29 + 16 >> 2] = f22;
  HEAPF32[i29 + 20 >> 2] = f18;
  HEAPF32[i29 + 24 >> 2] = f20;
  f20 = Math_fround(HEAPF32[i35 + 168 >> 2]);
  f18 = Math_fround(-f20);
  f22 = Math_fround(Math_abs(Math_fround(f21 / Math_fround(f19 + Math_fround(1.0)))));
  f39 = Math_fround(HEAPF32[i35 + 348 >> 2]);
  mftCall_viiffi(i38 | 0, i36 | 0, i29 | 0, +f18, +f20, f22 > Math_fround(f39 - Math_fround(HEAPF32[i35 + 356 >> 2])) | 0);
  STACKTOP = i34;
  return;
 } else if (!(i1 & 16)) {
  i38 = HEAP32[(HEAP32[i36 >> 2] | 0) + 24 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i25 >> 2]);
  f15 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
  f9 = Math_fround(HEAPF32[i33 >> 2]);
  f14 = Math_fround(f9 * Math_fround(0.0));
  f10 = Math_fround(HEAPF32[i23 >> 2]);
  f11 = Math_fround(f10 * Math_fround(0.0));
  f21 = Math_fround(f14 + f11);
  f19 = Math_fround(HEAPF32[i24 >> 2]);
  f22 = Math_fround(f19 * Math_fround(0.0));
  f21 = Math_fround(f21 + f22);
  f15 = Math_fround(f15 * Math_fround(0.0));
  f39 = Math_fround(Math_fround(f9 * f21) + Math_fround(f15 + Math_fround(f6 * Math_fround(f11 - f22))));
  f22 = Math_fround(Math_fround(f10 * f21) + Math_fround(f15 + Math_fround(f6 * Math_fround(f22 - f14))));
  f21 = Math_fround(Math_fround(f15 + Math_fround(f6 * Math_fround(f14 - f11))) + Math_fround(f19 * f21));
  f39 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f39);
  f22 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f22);
  f21 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f21);
  f11 = Math_fround(f6 * Math_fround(-0.0));
  f14 = Math_fround(f9 * Math_fround(.707106769));
  f15 = Math_fround(f10 * Math_fround(.707106769));
  f16 = Math_fround(f19 * Math_fround(-0.0));
  f17 = Math_fround(f14 + Math_fround(f16 + Math_fround(f11 + f15)));
  f6 = Math_fround(f6 * Math_fround(.707106769));
  f19 = Math_fround(f19 * Math_fround(.707106769));
  f9 = Math_fround(f9 * Math_fround(-0.0));
  f10 = Math_fround(f10 * Math_fround(-0.0));
  f18 = Math_fround(Math_fround(f9 + Math_fround(f19 - f6)) - f10);
  f19 = Math_fround(Math_fround(Math_fround(f6 - f9) - f10) + f19);
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(Math_fround(f11 + f14) - f15) - f16);
  HEAPF32[i32 + 4 >> 2] = f17;
  HEAPF32[i32 + 8 >> 2] = f18;
  HEAPF32[i32 + 12 >> 2] = f19;
  HEAPF32[i32 + 16 >> 2] = f39;
  HEAPF32[i32 + 20 >> 2] = f22;
  HEAPF32[i32 + 24 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i35 + 172 >> 2]);
  f22 = Math_fround(Math_fround(f13 * f4) + Math_fround(Math_fround(f20 * f8) + Math_fround(f12 * f7)));
  f22 = Math_fround(Math_abs(Math_fround(f22 / Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f22 * f22)) + Math_fround(1.0)))));
  f39 = Math_fround(HEAPF32[i35 + 340 >> 2]);
  mftCall_viifi(i38 | 0, i36 | 0, i32 | 0, +f21, f22 > Math_fround(f39 - Math_fround(HEAPF32[i35 + 344 >> 2])) | 0);
  STACKTOP = i34;
  return;
 } else {
  i38 = HEAP32[(HEAP32[i36 >> 2] | 0) + 16 >> 2] | 0;
  f9 = Math_fround(HEAPF32[i25 >> 2]);
  f12 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
  f13 = Math_fround(HEAPF32[i33 >> 2]);
  f10 = Math_fround(f13 * Math_fround(0.0));
  f11 = Math_fround(HEAPF32[i23 >> 2]);
  f14 = Math_fround(f11 * Math_fround(0.0));
  f21 = Math_fround(f10 + f14);
  f15 = Math_fround(HEAPF32[i24 >> 2]);
  f18 = Math_fround(f15 * Math_fround(0.0));
  f21 = Math_fround(f21 + f18);
  f12 = Math_fround(f12 * Math_fround(0.0));
  f39 = Math_fround(Math_fround(f13 * f21) + Math_fround(f12 + Math_fround(f9 * Math_fround(f14 - f18))));
  f20 = Math_fround(Math_fround(f11 * f21) + Math_fround(f12 + Math_fround(f9 * Math_fround(f18 - f10))));
  f21 = Math_fround(Math_fround(f12 + Math_fround(f9 * Math_fround(f10 - f14))) + Math_fround(f15 * f21));
  f39 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f39);
  f20 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f20);
  f21 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f21);
  f12 = Math_fround(f9 * Math_fround(0.0));
  f13 = Math_fround(f13 * Math_fround(.707106769));
  f15 = Math_fround(f15 * Math_fround(.707106769));
  f9 = Math_fround(f9 * Math_fround(.707106769));
  f11 = Math_fround(f11 * Math_fround(.707106769));
  f16 = Math_fround(Math_fround(f18 + Math_fround(f9 + f11)) - f10);
  f17 = Math_fround(Math_fround(f13 + Math_fround(f12 + f15)) - f14);
  f18 = Math_fround(Math_fround(Math_fround(f9 - f10) - f11) - f18);
  HEAPF32[i31 >> 2] = Math_fround(Math_fround(Math_fround(f12 + f13) + f14) - f15);
  HEAPF32[i31 + 4 >> 2] = f16;
  HEAPF32[i31 + 8 >> 2] = f17;
  HEAPF32[i31 + 12 >> 2] = f18;
  HEAPF32[i31 + 16 >> 2] = f39;
  HEAPF32[i31 + 20 >> 2] = f20;
  HEAPF32[i31 + 24 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i35 + 172 >> 2]);
  f20 = Math_fround(-f21);
  f22 = Math_fround(Math_abs(Math_fround(f22 / Math_fround(f19 + Math_fround(1.0)))));
  f39 = Math_fround(HEAPF32[i35 + 352 >> 2]);
  mftCall_viiffi(i38 | 0, i36 | 0, i31 | 0, +f20, +f21, f22 > Math_fround(f39 - Math_fround(HEAPF32[i35 + 356 >> 2])) | 0);
  STACKTOP = i34;
  return;
 }
}

function __ZN5physx2Gu10ConvexMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i30 >> 2] = HEAP32[gb + 135780 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 135780 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 135780 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 135780 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 135780 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 135780 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 135780 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 135780 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 164592 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 164592 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 164592 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 164592 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 164592 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 164592 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 164592 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 164592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 135812 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 135812 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 135812 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 135812 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 135812 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 135812 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 135812 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 135812 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 135844 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 135844 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 135844 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 135844 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 135844 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 135844 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 135844 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 135844 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 135876 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 135876 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 135876 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 135876 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 135876 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 135876 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 135876 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 135876 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 135908 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 135908 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 135908 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 135908 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 135908 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 135908 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 135908 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 135908 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 135940 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 135940 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 135940 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 135940 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 135940 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 135940 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 135940 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 135940 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 135972 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 135972 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 135972 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 135972 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 135972 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 135972 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 135972 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 135972 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 136004 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 136004 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 136004 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 136004 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 136004 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 136004 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 136004 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 136004 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 136036 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 136036 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 136036 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 136036 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 136036 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 136036 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 136036 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 136036 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 136068 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 136068 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 136068 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 136068 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 136068 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 136068 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 136068 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 136068 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 136100 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 136100 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 136100 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 136100 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 136100 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 136100 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 136100 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 136100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 136132 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 136132 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 136132 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 136132 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 136132 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 136132 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 136132 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 136132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 136164 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 136164 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 136164 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 136164 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 136164 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 136164 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 136164 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 136164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 136196 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 136196 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 136196 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 136196 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 136196 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 136196 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 136196 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 136196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 136228 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 136228 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 136228 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 136228 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 136228 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 136228 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 136228 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 136228 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 136260 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 136260 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 136260 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 136260 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 136260 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 136260 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 136260 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 136260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 __ZN5physx13BigConvexData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i21 >> 2] = HEAP32[gb + 136292 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 136292 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 136292 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 136292 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 136292 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 136292 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 136292 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 136292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = gb + 754608;
 HEAP32[i20 + 4 >> 2] = gb + 827530;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 132;
 HEAP32[i20 + 16 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 24 >> 2] = 1;
 HEAP32[i20 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = gb + 754608;
 HEAP32[i19 + 4 >> 2] = gb + 752142;
 HEAP32[i19 + 8 >> 2] = 8;
 HEAP32[i19 + 12 >> 2] = 132;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 1;
 HEAP32[i19 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 136324 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 136324 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 136324 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 136324 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 136324 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 136324 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 136324 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 136324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 136356 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 136356 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 136356 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 136356 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 136356 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 136356 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 136356 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 136356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 136388 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 136388 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 136388 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 136388 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 136388 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 136388 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 136388 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 136388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 136420 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 136420 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 136420 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 136420 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 136420 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 136420 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 136420 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 136420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 136452 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 136452 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 136452 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 136452 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 136452 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 136452 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 136452 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 136452 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 136484 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 136484 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 136484 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 136484 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 136484 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 136484 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 136484 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 136484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 136516 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 136516 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 136516 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 136516 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 136516 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 136516 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 136516 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 136516 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 136548 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 136548 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 136548 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 136548 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 136548 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 136548 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 136548 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 136548 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 136580 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 136580 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 136580 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 136580 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 136580 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 136580 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 136580 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 136580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 136580 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 136580 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 136580 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 136580 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 136580 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 136580 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 136580 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 136580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 136612 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 136612 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 136612 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 136612 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 136612 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 136612 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 136612 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 136612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 136612 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 136612 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 136612 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 136612 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 136612 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 136612 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 136612 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 136612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 136612 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 136612 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 136612 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 136612 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 136612 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 136612 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 136612 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 136612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 136644 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 136644 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 136644 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 136644 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 136644 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 136644 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 136644 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 136644 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 136676 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 136676 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 136676 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 136676 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 136676 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 136676 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 136676 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 136676 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 136708 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 136708 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 136708 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 136708 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 136708 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 136708 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 136708 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 136708 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN10GUIManager10DoGUIEventER10InputEventb(i37, i29, i11) {
 i37 = i37 | 0;
 i29 = i29 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i40 + 280 | 0;
 i28 = i40 + 24 | 0;
 i12 = i40 + 16 | 0;
 i13 = i40 + 276 | 0;
 i14 = i40;
 i34 = i40 + 264 | 0;
 i35 = i40 + 8 | 0;
 i1 = (HEAP32[i29 >> 2] | 0) == 7 ? gb + 1468264 | 0 : gb + 1468276 | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i36 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i36);
  i39 = i1;
 } else i39 = 0;
 i20 = HEAP32[i1 >> 2] | 0;
 i10 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 648 >> 2] | 0, i10 | 0, i20 | 0);
 i20 = HEAP32[i29 + 40 >> 2] | 0;
 i10 = 1 << i20;
 i16 = gb + 1468832 + (i20 << 2) | 0;
 i26 = HEAP32[i16 >> 2] | 0;
 i23 = __Z24GetIMGUIScriptingClassesv() | 0;
 i27 = HEAP32[i23 + 4 >> 2] | 0;
 i18 = i12;
 HEAP32[i18 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i18 + 4 >> 2] = i27;
 HEAP32[i36 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i28, i36);
 __ZN18ScriptingArguments6AddIntEi(i28, i20);
 HEAP32[i36 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i28, i36, 0) | 0;
 i18 = i26 + 280 | 0;
 __ZN10InputEventaSERKS_(HEAP32[i18 >> 2] | 0, i29);
 i27 = HEAP32[i18 >> 2] | 0;
 i23 = (HEAP32[gb + 187256 >> 2] | 0) + 1 | 0;
 HEAP32[gb + 187256 >> 2] = i23;
 HEAP32[gb + 1468320 + (i23 << 2) >> 2] = i20;
 i23 = i37 + 488 + (i20 * 20 | 0) | 0;
 HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
 i24 = i37 + 488 + (i20 * 20 | 0) + 12 | 0;
 i25 = i26 + 4 | 0;
 HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
 i30 = i37 + 488 + (i20 * 20 | 0) + 8 | 0;
 i31 = i26 + 8 | 0;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 i32 = i37 + 488 + (i20 * 20 | 0) + 4 | 0;
 i33 = i26 + 72 | 0;
 HEAP32[i33 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i30 >> 2] = 0;
 HEAPF32[i26 + 344 >> 2] = Math_fround(1.0);
 i2 = __ZN24UserAuthorizationManager22GetAuthorizationDialogEv(__Z27GetUserAuthorizationManagerv() | 0) | 0;
 i6 = i37 + 4 | 0;
 i3 = (i2 | 0) == 0;
 do if (i3 & (HEAP32[i6 >> 2] | 0) == (i37 | 0)) {
  i1 = HEAP32[gb + 1468316 >> 2] | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   if (HEAP32[i1 + 12 >> 2] | 0) {
    i21 = 10;
    break;
   }
   if (HEAP32[i1 + 24 >> 2] | 0) {
    i21 = 10;
    break;
   }
  }
  HEAP32[i23 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i25 >> 2] = 0;
  i1 = HEAP32[i31 >> 2] | 0;
  HEAP32[i30 >> 2] = i1;
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i31 >> 2] = 0;
  if (i1 | 0) __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i1);
  HEAP8[i37 + 8 >> 0] = 0;
 } else i21 = 10; while (0);
 if ((i21 | 0) == 10) {
  i38 = __Z16GetScreenManagerv() | 0;
  if ((mftCall_ii(HEAP32[(HEAP32[i38 >> 2] | 0) + 40 >> 2] | 0, i38 | 0) | 0) == 1) {
   HEAP32[i27 + 4 >> 2] = -971227136;
   HEAP32[i27 + 8 >> 2] = -971227136;
  }
  i15 = HEAP32[i27 >> 2] | 0;
  L18 : do if ((i15 | 0) == 4) {
   switch (HEAP16[i27 + 36 >> 1] | 0) {
   case 25:
   case 9:
    break;
   default:
    {
     i22 = 0;
     break L18;
    }
   }
   i22 = (HEAP32[i27 + 24 >> 2] << 1 & 2 ^ 2) + -1 | 0;
  } else i22 = 0; while (0);
  HEAP32[i34 >> 2] = 0;
  i38 = i34 + 4 | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i34 + 8 >> 2] = 0;
  if (i3) {
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i4;
   if ((i4 | 0) == (i37 | 0)) i2 = i34 + 8 | 0; else {
    i1 = i4;
    i3 = 0;
    do {
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    } while ((i1 | 0) != (i37 | 0));
    i2 = i34 + 8 | 0;
    if (i3) {
     i19 = __Znwj(i3 * 12 | 0) | 0;
     i17 = i19;
     HEAP32[i34 >> 2] = i17;
     HEAP32[i38 >> 2] = i17;
     HEAP32[i2 >> 2] = i19 + (i3 * 12 | 0);
    }
   }
   i7 = i36 + 4 | 0;
   i8 = i36 + 8 | 0;
   HEAP32[i8 >> 2] = i37;
   i9 = i36 + 12 | 0;
   HEAP32[i9 >> 2] = 0;
   i19 = HEAP32[i37 >> 2] | 0;
   HEAP32[i36 >> 2] = i19;
   HEAP32[i6 >> 2] = i36;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i37 >> 2] = i37;
   if ((i19 | 0) == (i37 | 0)) HEAP32[i36 >> 2] = i36;
   HEAP32[i6 >> 2] = i37;
   if ((i4 | 0) == (i37 | 0)) HEAP32[i7 >> 2] = i36;
   HEAP32[i37 + 4 >> 2] = i37;
   HEAP32[i37 >> 2] = i37;
   HEAP32[(HEAP32[i36 >> 2] | 0) + 4 >> 2] = i36;
   i3 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 >> 2] = i36;
   L37 : do if ((i3 | 0) == (i36 | 0)) {
    i1 = 0;
    i21 = 33;
   } else {
    i5 = i28 + 4 | 0;
    i6 = i28 + 8 | 0;
    i1 = 0;
    while (1) {
     while (1) {
      HEAP32[i9 >> 2] = i3;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i4 | 0) {
       i19 = i3 + 4 | 0;
       HEAP32[i4 + 4 >> 2] = HEAP32[i19 >> 2];
       HEAP32[HEAP32[i19 >> 2] >> 2] = i4;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i19 >> 2] = 0;
      }
      i4 = HEAP32[i8 >> 2] | 0;
      if ((i3 | 0) == (i4 | 0)) {
       if (!i3) break L37;
      } else {
       i19 = i3 + 4 | 0;
       i17 = HEAP32[i4 >> 2] | 0;
       HEAP32[i3 >> 2] = i17;
       HEAP32[i19 >> 2] = i4;
       HEAP32[i17 + 4 >> 2] = i3;
       HEAP32[HEAP32[i19 >> 2] >> 2] = i3;
      }
      i3 = HEAP32[i3 + 8 >> 2] | 0;
      if (HEAP32[i3 + 136 >> 2] & i10 | 0) {
       if (!(__ZN13MonoBehaviour15GetUseGUILayoutEv(i3) | 0)) break;
       HEAP32[i28 >> 2] = i3;
       HEAP32[i5 >> 2] = fb + 195;
       HEAP32[i6 >> 2] = fb + 2706;
       i4 = HEAP32[i38 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i34, i28); else {
        HEAP32[i4 >> 2] = i3;
        HEAP32[i4 + 4 >> 2] = fb + 195;
        HEAP32[i4 + 8 >> 2] = fb + 2706;
        HEAP32[i38 >> 2] = i4 + 12;
       }
      }
      i3 = HEAP32[i7 >> 2] | 0;
      if ((i3 | 0) == (i36 | 0)) {
       i21 = 33;
       break L37;
      }
     }
     if (i1) i1 = 1; else i1 = mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, 0, 0, i20 | 0) | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     if ((i3 | 0) == (i36 | 0)) {
      i21 = 33;
      break;
     }
    }
   } while (0);
   if ((i21 | 0) == 33) HEAP32[i9 >> 2] = 0;
  } else {
   HEAP32[i36 >> 2] = i2;
   HEAP32[i36 + 4 >> 2] = fb + 195;
   HEAP32[i36 + 8 >> 2] = fb + 2706;
   __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i34, i36);
   i1 = 0;
   i2 = i34 + 8 | 0;
  }
  i3 = HEAP32[gb + 1468316 >> 2] | 0;
  HEAP32[i36 >> 2] = i3;
  HEAP32[i36 + 4 >> 2] = fb + 196;
  HEAP32[i36 + 8 >> 2] = fb + 2707;
  i4 = HEAP32[i38 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i34, i36); else {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = fb + 196;
   HEAP32[i4 + 8 >> 2] = fb + 2707;
   HEAP32[i38 >> 2] = i4 + 12;
  }
  i2 = HEAP32[i31 >> 2] | 0;
  if (!i2) i17 = 0; else i17 = (HEAP32[i2 + 24 >> 2] | 0) != 0;
  i19 = i37 + 28 | 0;
  __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv(i19);
  if ((HEAP32[i34 >> 2] | 0) != (HEAP32[i38 >> 2] | 0)) {
   HEAP32[i27 >> 2] = 8;
   i6 = i17 ^ 1;
   __ZN5IMGUI12BeginWindowsER8GUIStatebb(i26, 1, i6);
   i2 = HEAP32[i34 >> 2] | 0;
   i3 = HEAP32[i38 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) {
    i7 = i36 + 4 | 0;
    i8 = i36 + 8 | 0;
    i9 = i36 + 12 | 0;
    do {
     i4 = HEAP32[i2 >> 2] | 0;
     i5 = HEAP32[i2 + 4 >> 2] | 0;
     if (i4) {
      i3 = HEAP32[i2 + 8 >> 2] | 0;
      mftCall_iiiii(i5 | 0, i4 | 0, 1, 0, i20 | 0) | 0;
      HEAP32[i36 >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + 68 >> 2];
      HEAP32[i7 >> 2] = i4;
      HEAP32[i8 >> 2] = i5;
      HEAP32[i9 >> 2] = i3;
      __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE9push_backERKS2_(i19, i36);
      i3 = HEAP32[i38 >> 2] | 0;
     }
     i2 = i2 + 12 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   i3 = i26 + 96 | 0;
   __ZN12GUIClipState10BeginOnGUIER10InputEvent(i3, HEAP32[i18 >> 2] | 0);
   __ZN5IMGUI10EndWindowsER8GUIStateb(i26, i6);
   i4 = HEAP32[i18 >> 2] | 0;
   i5 = i26 + 100 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = i2 - (HEAP32[i3 >> 2] | 0) | 0;
   do if ((i3 | 0) != 56 ? ((HEAP32[i4 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) if (((i3 | 0) / 56 | 0) >>> 0 > 1) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
    i2 = HEAP32[i5 >> 2] | 0;
    i21 = 58;
    break;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
    break;
   } else i21 = 58; while (0);
   if ((i21 | 0) == 58) {
    HEAP32[i5 >> 2] = i2 + -56;
    i8 = i26 + 236 | 0;
    f42 = Math_fround(HEAPF32[i8 >> 2]);
    f42 = Math_fround(f42 - Math_fround(HEAPF32[i26 + 244 >> 2]));
    f41 = Math_fround(HEAPF32[i26 + 240 >> 2]);
    f41 = Math_fround(f41 - Math_fround(HEAPF32[i26 + 248 >> 2]));
    HEAPF32[i4 + 12 >> 2] = f42;
    HEAPF32[i4 + 16 >> 2] = f41;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i10 = i4 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
   }
   HEAP32[i12 >> 2] = HEAP32[i37 + 32 >> 2];
   HEAP32[i13 >> 2] = i19;
   i10 = HEAP32[i37 + 36 >> 2] | 0;
   HEAP32[i28 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i36 >> 2] = HEAP32[i13 >> 2];
   __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_(i28, i36, i10, i14) | 0;
   HEAP32[i27 >> 2] = i15;
  }
  L93 : do if (i11) {
   i9 = i26 + 272 | 0;
   HEAP32[i9 >> 2] = HEAPU8[i37 + 8 >> 0];
   i4 = HEAP32[i37 + 32 >> 2] | 0;
   i3 = i4;
   L95 : do if (!(i1 | (i3 | 0) == (i19 | 0))) {
    i8 = i17 ^ 1;
    i7 = i37 + 36 | 0;
    if (i17) {
     i1 = 0;
     while (1) {
      if (i1) i2 = 0; else {
       __ZN5IMGUI12BeginWindowsER8GUIStatebb(i26, 1, i8);
       i2 = 1;
      }
      i1 = i4;
      i1 = mftCall_iiiii(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, 1, 0, i20 | 0) | 0;
      if (i2) __ZN5IMGUI10EndWindowsER8GUIStateb(i26, i8);
      i4 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = i4;
      if (i1 | (i3 | 0) == (i19 | 0)) break L95; else i1 = 1;
     }
    } else {
     i2 = 0;
     i6 = 1;
    }
    while (1) {
     if ((i6 | 0) == (HEAP32[i7 >> 2] | 0)) if (i2) {
      i5 = 0;
      i2 = 1;
     } else i21 = 74; else if (i2 | (HEAP32[i4 + 8 >> 2] | 0) < 1) i5 = 0; else i21 = 74;
     if ((i21 | 0) == 74) {
      i21 = 0;
      __ZN5IMGUI12BeginWindowsER8GUIStatebb(i26, 1, i8);
      i5 = 1;
      i2 = 1;
     }
     i1 = i4;
     i1 = mftCall_iiiii(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, 1, 0, i20 | 0) | 0;
     if (i5) __ZN5IMGUI10EndWindowsER8GUIStateb(i26, i8);
     i4 = HEAP32[i3 + 4 >> 2] | 0;
     i3 = i4;
     if (i1 | (i3 | 0) == (i19 | 0)) break; else i6 = i6 + 1 | 0;
    }
   } while (0);
   if (!((i15 | 0) != 0 | i1)) HEAP32[HEAP32[i16 >> 2] >> 2] = 0;
   if ((i15 | 1 | 0) == 1) HEAP32[i9 >> 2] = (i1 | (HEAP32[i9 >> 2] | 0) != 0) & 1;
  } else {
   i16 = i26 + 96 | 0;
   HEAP32[i26 + 272 >> 2] = 0;
   HEAP8[i37 + 8 >> 0] = 0;
   i8 = i17 ^ 1;
   __ZN5IMGUI12BeginWindowsER8GUIStatebb(i26, 1, i8);
   i9 = i37 + 32 | 0;
   if ((i19 | 0) != (HEAP32[i9 >> 2] | 0)) {
    i10 = i26 + 100 | 0;
    i11 = i26 + 236 | 0;
    i12 = i26 + 244 | 0;
    i13 = i26 + 240 | 0;
    i14 = i26 + 248 | 0;
    i15 = i37 + 36 | 0;
    i2 = 0;
    i6 = 1;
    i7 = i19;
    while (1) {
     i7 = HEAP32[i7 >> 2] | 0;
     if (i2) {
      i3 = 0;
      i2 = 1;
     } else if ((i6 | 0) == (HEAP32[i15 >> 2] | 0)) {
      i3 = 1;
      i2 = 1;
     } else {
      i2 = (HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0) < 1;
      i3 = i2;
     }
     i5 = i7;
     mftCall_iiiii(HEAP32[i5 + 16 >> 2] | 0, HEAP32[i5 + 12 >> 2] | 0, 1, 0, i20 | 0) | 0;
     L131 : do if (i3) {
      __ZN12GUIClipState10BeginOnGUIER10InputEvent(i16, HEAP32[i18 >> 2] | 0);
      __ZN5IMGUI10EndWindowsER8GUIStateb(i26, i8);
      i5 = HEAP32[i18 >> 2] | 0;
      i3 = HEAP32[i10 >> 2] | 0;
      i4 = i3 - (HEAP32[i16 >> 2] | 0) | 0;
      do if ((i4 | 0) != 56 ? ((HEAP32[i5 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) if (((i4 | 0) / 56 | 0) >>> 0 > 1) {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
       i3 = HEAP32[i10 >> 2] | 0;
       break;
      } else {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
       break L131;
      } while (0);
      HEAP32[i10 >> 2] = i3 + -56;
      f41 = Math_fround(HEAPF32[i11 >> 2]);
      f41 = Math_fround(f41 - Math_fround(HEAPF32[i12 >> 2]));
      f42 = Math_fround(HEAPF32[i13 >> 2]);
      f42 = Math_fround(f42 - Math_fround(HEAPF32[i14 >> 2]));
      HEAPF32[i5 + 12 >> 2] = f41;
      HEAPF32[i5 + 16 >> 2] = f42;
      i3 = i11;
      i4 = HEAP32[i3 + 4 >> 2] | 0;
      i5 = i5 + 4 | 0;
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
     } while (0);
     if ((i7 | 0) == (HEAP32[i9 >> 2] | 0)) break; else i6 = i6 + 1 | 0;
    }
   }
   if (i17) {
    __ZN12GUIClipState10BeginOnGUIER10InputEvent(i16, HEAP32[i18 >> 2] | 0);
    i4 = HEAP32[i31 >> 2] | 0;
    do if (i4 | 0) {
     i3 = HEAP32[i18 >> 2] | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == 7) {
      HEAP8[(HEAP32[i26 + 276 >> 2] | 0) + 8 >> 0] = 1;
      i2 = HEAP32[i4 + 24 >> 2] | 0;
      if (i2 | 0) {
       __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i2, i26);
       i2 = HEAP32[i3 >> 2] | 0;
       i21 = 99;
      }
     } else i21 = 99;
     if ((i21 | 0) == 99) if ((i2 | 0) == 8) break;
     __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i4);
    } while (0);
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = i26 + 100 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i2 - (HEAP32[i16 >> 2] | 0) | 0;
    do if ((i3 | 0) != 56 ? ((HEAP32[i4 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) if (((i3 | 0) / 56 | 0) >>> 0 > 1) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
     i2 = HEAP32[i5 >> 2] | 0;
     break;
    } else {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
     break L93;
    } while (0);
    HEAP32[i5 >> 2] = i2 + -56;
    i18 = i26 + 236 | 0;
    f41 = Math_fround(HEAPF32[i18 >> 2]);
    f41 = Math_fround(f41 - Math_fround(HEAPF32[i26 + 244 >> 2]));
    f42 = Math_fround(HEAPF32[i26 + 240 >> 2]);
    f42 = Math_fround(f42 - Math_fround(HEAPF32[i26 + 248 >> 2]));
    HEAPF32[i4 + 12 >> 2] = f41;
    HEAPF32[i4 + 16 >> 2] = f42;
    i20 = HEAP32[i18 + 4 >> 2] | 0;
    i21 = i4 + 4 | 0;
    HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i21 + 4 >> 2] = i20;
   }
  } while (0);
  if (!((i22 | 0) == 0 | i1)) {
   i6 = HEAP32[i37 + 36 >> 2] | 0;
   if (i6 | 0) {
    HEAP32[i36 >> 2] = 0;
    i7 = i36 + 4 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i36 + 8 >> 2] = 0;
    i4 = HEAP32[i31 >> 2] | 0;
    do if (!i4) {
     i1 = i36 + 8 | 0;
     i21 = 118;
    } else {
     i5 = HEAP32[i4 + 12 >> 2] | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
     L164 : do if ((i1 | 0) == (i3 | 0)) i21 = 113; else {
      i2 = i1;
      while (1) {
       i1 = HEAP32[i2 >> 2] | 0;
       i2 = i2 + 4 | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
       if ((i2 | 0) == (i3 | 0)) {
        i21 = 113;
        break L164;
       }
      }
      if (!i1) i21 = 117; else i21 = 116;
     } while (0);
     if ((i21 | 0) == 113) {
      i1 = HEAP32[i4 + 24 >> 2] | 0;
      if (!i1) i21 = 117; else if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) i21 = 116; else i21 = 117;
     }
     if ((i21 | 0) == 116) {
      HEAP32[i28 >> 2] = i1 + 4;
      __ZNSt3__26vectorIP6IDListNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i36, i28);
      break;
     } else if ((i21 | 0) == 117) {
      i1 = i36 + 8 | 0;
      if (!i6) {
       i21 = 119;
       break;
      } else {
       i21 = 118;
       break;
      }
     }
    } while (0);
    if ((i21 | 0) == 118) {
     i20 = __Znwj(i6 << 2) | 0;
     i18 = i20;
     HEAP32[i36 >> 2] = i18;
     HEAP32[i7 >> 2] = i18;
     HEAP32[i1 >> 2] = i20 + (i6 << 2);
     i21 = 119;
    }
    if ((i21 | 0) == 119) {
     i2 = HEAP32[i37 + 32 >> 2] | 0;
     i3 = i2;
     if ((i3 | 0) != (i19 | 0)) do {
      i2 = mftCall_ii(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
      HEAP32[i28 >> 2] = i2;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i1 >> 2] | 0)) __ZNSt3__26vectorIP6IDListNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i36, i28); else {
       HEAP32[i4 >> 2] = i2;
       HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
      }
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = i2;
     } while ((i3 | 0) != (i19 | 0));
    }
    HEAP32[i26 >> 2] = __ZN8GUIState24GetNextKeyboardControlIDERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb(0, i36, (i22 | 0) == 1) | 0;
    i1 = HEAP32[i36 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = HEAP32[i7 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
     __ZdlPv(i1);
    }
   }
  }
  HEAP32[i23 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i25 >> 2] = 0;
  i1 = HEAP32[i31 >> 2] | 0;
  HEAP32[i30 >> 2] = i1;
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i31 >> 2] = 0;
  if (i1 | 0) __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i1);
  i33 = (HEAP32[i26 + 272 >> 2] | 0) != 0;
  HEAP8[i37 + 8 >> 0] = i33 & 1;
  if (i33) {
   i32 = (__Z23GetCoreScriptingClassesv() | 0) + 368 | 0;
   i33 = HEAP32[i32 + 4 >> 2] | 0;
   i37 = i35;
   HEAP32[i37 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i37 + 4 >> 2] = i33;
   HEAP32[i36 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i28, i36);
   HEAP32[i36 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i28, i36, 0) | 0;
  }
  HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
  i1 = HEAP32[i34 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i38 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i38 >> 2] = i3 + (~(((i3 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
   __ZdlPv(i1);
  }
 }
 HEAP32[gb + 187256 >> 2] = (HEAP32[gb + 187256 >> 2] | 0) + -1;
 i38 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i38 >> 2] | 0) + 652 >> 2] | 0, i38 | 0);
 if (!i39) {
  STACKTOP = i40;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i39);
 STACKTOP = i40;
 return;
}

function __ZN27TrailModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = HEAP32[gb + 1111240 + 684 >> 2] ^ 16777215;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 114) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 97) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 105) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 108) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 77) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 100) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 117) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 108) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 101) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 46) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 114) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 97) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 116) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 105) << 2) >> 2] ^ i6 >>> 8;
 HEAP32[i5 >> 2] = ~(HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8);
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i4 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617920 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617920 + 27 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 1;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617948 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617948 + 29 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 2;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617978 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617978 + 28 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 3;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618007 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618007 + 28 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 4;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618036 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618036 + 31 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 5;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618068 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618068 + 32 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 6;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618101 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618101 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 7;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618142 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618142 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 8;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618183 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618183 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 9;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618224 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618224 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 10;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618265 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618265 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 11;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618306 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618306 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 12;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618347 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618347 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 13;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618388 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618388 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 14;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618429 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618429 + 33 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 15;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618463 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618463 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 16;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618501 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618501 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 17;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618539 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618539 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 18;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618577 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618577 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 19;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618615 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618615 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 20;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618653 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618653 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 21;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618691 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618691 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 22;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 618729 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618729 + 37 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 23;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i44, i45, i2, i46, i43, i1, i50, i49) {
 i44 = i44 | 0;
 i45 = i45 | 0;
 i2 = i2 | 0;
 i46 = i46 | 0;
 i43 = i43 | 0;
 i1 = i1 | 0;
 i50 = i50 | 0;
 i49 = i49 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i47 = 0, i48 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i48 + 32 | 0;
 i42 = i48;
 i24 = i48 + 60 | 0;
 i40 = i48 + 64 | 0;
 if (i2 >>> 0 >= i46 >>> 0) {
  i47 = 0;
  i46 = 0;
  i45 = HEAP32[i50 >> 2] | 0;
  i46 = i45 + i46 | 0;
  HEAP32[i50 >> 2] = i46;
  i50 = HEAP32[i49 >> 2] | 0;
  i50 = i50 + i47 | 0;
  HEAP32[i49 >> 2] = i50;
  STACKTOP = i48;
  return;
 }
 i32 = i41 + 4 | 0;
 i33 = i41 + 8 | 0;
 i34 = i41 + 12 | 0;
 i35 = i41 + 16 | 0;
 i36 = i41 + 20 | 0;
 i37 = i41 + 24 | 0;
 i38 = i42 + 4 | 0;
 i39 = i42 + 8 | 0;
 i25 = i42 + 12 | 0;
 i26 = i42 + 16 | 0;
 i27 = i42 + 20 | 0;
 i28 = i42 + 24 | 0;
 i29 = i44 + 4480 | 0;
 i30 = i44 + 8757 | 0;
 i31 = i44 + 384 | 0;
 i23 = i2;
 i2 = 0;
 i1 = 0;
 do {
  i22 = HEAP32[i45 + (i23 * 12 | 0) >> 2] | 0;
  i5 = HEAP32[i22 + 72 >> 2] | 0;
  i6 = HEAP32[i22 + 76 >> 2] | 0;
  i21 = HEAP32[i5 + 36 >> 2] | 0;
  i19 = HEAP32[i6 + 36 >> 2] | 0;
  i13 = HEAP32[i22 + 64 >> 2] | 0;
  i14 = HEAP32[i22 + 68 >> 2] | 0;
  i17 = HEAPU16[i22 + 22 >> 1] | 0;
  i16 = i17 & 32;
  i17 = i17 & 64;
  i20 = (i19 | 0) < (i21 | 0);
  i18 = i20 ? i19 : i21;
  i19 = i20 ? i21 : i19;
  i21 = i44 + 104 + (i18 * 28 | 0) + (i19 << 2) | 0;
  HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
  i21 = i20 ? i6 : i5;
  i3 = i20 ? i14 : i13;
  f4 = Math_fround(HEAPF32[i21 + 16 >> 2]);
  if (!((i20 ? i17 : i16) | 0)) {
   f57 = Math_fround(f4 * Math_fround(2.0));
   f52 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
   f54 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f55 = Math_fround(Math_fround(f54 * f54) + Math_fround(-.5));
   f53 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(f57 * f53);
   f56 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f52 * f56));
   f51 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f11 * f51));
   f8 = Math_fround(Math_fround(f53 * f4) + Math_fround(Math_fround(f57 * f55) + Math_fround(f54 * Math_fround(Math_fround(f11 * f56) - Math_fround(f52 * f51)))));
   f7 = Math_fround(Math_fround(f56 * f4) + Math_fround(Math_fround(f52 * f55) + Math_fround(f54 * Math_fround(Math_fround(f57 * f51) - Math_fround(f11 * f53)))));
   f4 = Math_fround(Math_fround(Math_fround(f11 * f55) + Math_fround(f54 * Math_fround(Math_fround(f52 * f53) - Math_fround(f57 * f56)))) + Math_fround(f51 * f4));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
   f7 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f7);
   f4 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f4);
   f57 = Math_fround(HEAPF32[i21 >> 2]);
   f52 = Math_fround(f54 * f57);
   f55 = Math_fround(HEAPF32[i21 + 12 >> 2]);
   f52 = Math_fround(f52 + Math_fround(f53 * f55));
   f11 = Math_fround(HEAPF32[i21 + 8 >> 2]);
   f52 = Math_fround(f52 + Math_fround(f56 * f11));
   f12 = Math_fround(HEAPF32[i21 + 4 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f55) - Math_fround(f53 * f57)) - Math_fround(f56 * f12)) - Math_fround(f51 * f11));
   f10 = Math_fround(Math_fround(Math_fround(f53 * f12) + Math_fround(Math_fround(f51 * f55) + Math_fround(f54 * f11))) - Math_fround(f56 * f57));
   f11 = Math_fround(Math_fround(Math_fround(f51 * f57) + Math_fround(Math_fround(f56 * f55) + Math_fround(f54 * f12))) - Math_fround(f53 * f11));
   f12 = Math_fround(f52 - Math_fround(f51 * f12));
  } else {
   f9 = Math_fround(HEAPF32[i3 + 48 >> 2]);
   f53 = Math_fround(HEAPF32[i3 + 52 >> 2]);
   f9 = Math_fround(f9 * Math_fround(-2.0));
   f53 = Math_fround(f53 * Math_fround(-2.0));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) * Math_fround(-2.0));
   f58 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f51 = Math_fround(Math_fround(f58 * f58) + Math_fround(-.5));
   f12 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f57 = Math_fround(f9 * f12);
   f59 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f57 = Math_fround(f57 + Math_fround(f53 * f59));
   f10 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f57 = Math_fround(f57 + Math_fround(f8 * f10));
   f11 = Math_fround(-f12);
   f56 = Math_fround(-f59);
   f54 = Math_fround(-f10);
   f55 = Math_fround(Math_fround(Math_fround(f12 * f57) + Math_fround(Math_fround(f9 * f51) - Math_fround(f58 * Math_fround(Math_fround(f8 * f59) - Math_fround(f53 * f10))))) * Math_fround(2.0));
   f52 = Math_fround(Math_fround(Math_fround(f59 * f57) + Math_fround(Math_fround(f53 * f51) - Math_fround(f58 * Math_fround(Math_fround(f9 * f10) - Math_fround(f8 * f12))))) * Math_fround(2.0));
   f57 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f51) - Math_fround(f58 * Math_fround(Math_fround(f53 * f12) - Math_fround(f9 * f59)))) + Math_fround(f10 * f57)) * Math_fround(2.0));
   f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f59 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   f12 = Math_fround(f9 * f55);
   f53 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f53 * f52));
   f51 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f12 = Math_fround(Math_fround(f51 * f57) + f12);
   f8 = Math_fround(Math_fround(f9 * f12) + Math_fround(Math_fround(f59 * f55) + Math_fround(f10 * Math_fround(Math_fround(f53 * f57) - Math_fround(f51 * f52)))));
   f7 = Math_fround(Math_fround(f53 * f12) + Math_fround(Math_fround(f59 * f52) + Math_fround(f10 * Math_fround(Math_fround(f51 * f55) - Math_fround(f9 * f57)))));
   f12 = Math_fround(Math_fround(Math_fround(f59 * f57) + Math_fround(f10 * Math_fround(Math_fround(f9 * f52) - Math_fround(f53 * f55)))) + Math_fround(f51 * f12));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
   f7 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f7);
   f12 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f12);
   f55 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) + Math_fround(f58 * f9)) + Math_fround(f53 * f54)) - Math_fround(f51 * f56));
   f52 = Math_fround(Math_fround(Math_fround(f51 * f11) + Math_fround(Math_fround(f10 * f56) + Math_fround(f58 * f53))) - Math_fround(f9 * f54));
   f57 = Math_fround(Math_fround(Math_fround(f9 * f56) + Math_fround(Math_fround(f10 * f54) + Math_fround(f58 * f51))) - Math_fround(f53 * f11));
   f54 = Math_fround(Math_fround(Math_fround(Math_fround(f58 * f10) - Math_fround(f9 * f11)) - Math_fround(f53 * f56)) - Math_fround(f51 * f54));
   f51 = Math_fround(f4 * Math_fround(2.0));
   f56 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
   f53 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(f54 * f54) + Math_fround(-.5));
   f4 = Math_fround(Math_fround(Math_fround(f55 * f51) + Math_fround(f52 * f56)) + Math_fround(f57 * f53));
   f8 = Math_fround(f8 + Math_fround(Math_fround(f55 * f4) + Math_fround(Math_fround(f11 * f51) + Math_fround(f54 * Math_fround(Math_fround(f52 * f53) - Math_fround(f57 * f56))))));
   f7 = Math_fround(f7 + Math_fround(Math_fround(f52 * f4) + Math_fround(Math_fround(f11 * f56) + Math_fround(f54 * Math_fround(Math_fround(f57 * f51) - Math_fround(f55 * f53))))));
   f4 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f11 * f53) + Math_fround(f54 * Math_fround(Math_fround(f55 * f56) - Math_fround(f52 * f51)))) + Math_fround(f57 * f4)));
   f51 = Math_fround(HEAPF32[i21 >> 2]);
   f56 = Math_fround(f54 * f51);
   f53 = Math_fround(HEAPF32[i21 + 12 >> 2]);
   f56 = Math_fround(f56 + Math_fround(f55 * f53));
   f11 = Math_fround(HEAPF32[i21 + 8 >> 2]);
   f56 = Math_fround(f56 + Math_fround(f52 * f11));
   f12 = Math_fround(HEAPF32[i21 + 4 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f53) - Math_fround(f55 * f51)) - Math_fround(f52 * f12)) - Math_fround(f57 * f11));
   f10 = Math_fround(Math_fround(Math_fround(f55 * f12) + Math_fround(Math_fround(f57 * f53) + Math_fround(f54 * f11))) - Math_fround(f52 * f51));
   f11 = Math_fround(Math_fround(Math_fround(f57 * f51) + Math_fround(Math_fround(f52 * f53) + Math_fround(f54 * f12))) - Math_fround(f55 * f11));
   f12 = Math_fround(f56 - Math_fround(f57 * f12));
  }
  HEAPF32[i41 >> 2] = f12;
  HEAPF32[i32 >> 2] = f11;
  HEAPF32[i33 >> 2] = f10;
  HEAPF32[i34 >> 2] = f9;
  HEAPF32[i35 >> 2] = f8;
  HEAPF32[i36 >> 2] = f7;
  HEAPF32[i37 >> 2] = f4;
  i15 = i20 ? i5 : i6;
  i3 = i20 ? i13 : i14;
  f4 = Math_fround(HEAPF32[i15 + 16 >> 2]);
  if (!((i20 ? i16 : i17) | 0)) {
   f53 = Math_fround(f4 * Math_fround(2.0));
   f58 = Math_fround(Math_fround(HEAPF32[i15 + 20 >> 2]) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(HEAPF32[i15 + 24 >> 2]) * Math_fround(2.0));
   f56 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f55 = Math_fround(Math_fround(f56 * f56) + Math_fround(-.5));
   f57 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(f53 * f57);
   f54 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f58 * f54));
   f59 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f11 * f59));
   f8 = Math_fround(Math_fround(f57 * f4) + Math_fround(Math_fround(f53 * f55) + Math_fround(f56 * Math_fround(Math_fround(f11 * f54) - Math_fround(f58 * f59)))));
   f7 = Math_fround(Math_fround(f54 * f4) + Math_fround(Math_fround(f58 * f55) + Math_fround(f56 * Math_fround(Math_fround(f53 * f59) - Math_fround(f11 * f57)))));
   f4 = Math_fround(Math_fround(Math_fround(f11 * f55) + Math_fround(f56 * Math_fround(Math_fround(f58 * f57) - Math_fround(f53 * f54)))) + Math_fround(f59 * f4));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
   f7 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f7);
   f4 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f4);
   f53 = Math_fround(HEAPF32[i15 >> 2]);
   f58 = Math_fround(f56 * f53);
   f55 = Math_fround(HEAPF32[i15 + 12 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f57 * f55));
   f11 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f54 * f11));
   f12 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(f56 * f55) - Math_fround(f57 * f53)) - Math_fround(f54 * f12)) - Math_fround(f59 * f11));
   f10 = Math_fround(Math_fround(Math_fround(f57 * f12) + Math_fround(Math_fround(f59 * f55) + Math_fround(f56 * f11))) - Math_fround(f54 * f53));
   f11 = Math_fround(Math_fround(Math_fround(f59 * f53) + Math_fround(Math_fround(f54 * f55) + Math_fround(f56 * f12))) - Math_fround(f57 * f11));
   f12 = Math_fround(f58 - Math_fround(f59 * f12));
  } else {
   f9 = Math_fround(HEAPF32[i3 + 48 >> 2]);
   f55 = Math_fround(HEAPF32[i3 + 52 >> 2]);
   f9 = Math_fround(f9 * Math_fround(-2.0));
   f55 = Math_fround(f55 * Math_fround(-2.0));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) * Math_fround(-2.0));
   f52 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f53 = Math_fround(Math_fround(f52 * f52) + Math_fround(-.5));
   f12 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f59 = Math_fround(f9 * f12);
   f51 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f59 = Math_fround(f59 + Math_fround(f55 * f51));
   f10 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f59 = Math_fround(f59 + Math_fround(f8 * f10));
   f11 = Math_fround(-f12);
   f58 = Math_fround(-f51);
   f56 = Math_fround(-f10);
   f57 = Math_fround(Math_fround(Math_fround(f12 * f59) + Math_fround(Math_fround(f9 * f53) - Math_fround(f52 * Math_fround(Math_fround(f8 * f51) - Math_fround(f55 * f10))))) * Math_fround(2.0));
   f54 = Math_fround(Math_fround(Math_fround(f51 * f59) + Math_fround(Math_fround(f55 * f53) - Math_fround(f52 * Math_fround(Math_fround(f9 * f10) - Math_fround(f8 * f12))))) * Math_fround(2.0));
   f59 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f53) - Math_fround(f52 * Math_fround(Math_fround(f55 * f12) - Math_fround(f9 * f51)))) + Math_fround(f10 * f59)) * Math_fround(2.0));
   f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f51 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   f12 = Math_fround(f9 * f57);
   f55 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f55 * f54));
   f53 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f12 = Math_fround(Math_fround(f53 * f59) + f12);
   f8 = Math_fround(Math_fround(f9 * f12) + Math_fround(Math_fround(f51 * f57) + Math_fround(f10 * Math_fround(Math_fround(f55 * f59) - Math_fround(f53 * f54)))));
   f7 = Math_fround(Math_fround(f55 * f12) + Math_fround(Math_fround(f51 * f54) + Math_fround(f10 * Math_fround(Math_fround(f53 * f57) - Math_fround(f9 * f59)))));
   f12 = Math_fround(Math_fround(Math_fround(f51 * f59) + Math_fround(f10 * Math_fround(Math_fround(f9 * f54) - Math_fround(f55 * f57)))) + Math_fround(f53 * f12));
   f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
   f7 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f7);
   f12 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f12);
   f57 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) + Math_fround(f52 * f9)) + Math_fround(f55 * f56)) - Math_fround(f53 * f58));
   f54 = Math_fround(Math_fround(Math_fround(f53 * f11) + Math_fround(Math_fround(f10 * f58) + Math_fround(f52 * f55))) - Math_fround(f9 * f56));
   f59 = Math_fround(Math_fround(Math_fround(f9 * f58) + Math_fround(Math_fround(f10 * f56) + Math_fround(f52 * f53))) - Math_fround(f55 * f11));
   f56 = Math_fround(Math_fround(Math_fround(Math_fround(f52 * f10) - Math_fround(f9 * f11)) - Math_fround(f55 * f58)) - Math_fround(f53 * f56));
   f53 = Math_fround(f4 * Math_fround(2.0));
   f58 = Math_fround(Math_fround(HEAPF32[i15 + 20 >> 2]) * Math_fround(2.0));
   f55 = Math_fround(Math_fround(HEAPF32[i15 + 24 >> 2]) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(f56 * f56) + Math_fround(-.5));
   f4 = Math_fround(Math_fround(Math_fround(f57 * f53) + Math_fround(f54 * f58)) + Math_fround(f59 * f55));
   f8 = Math_fround(f8 + Math_fround(Math_fround(f57 * f4) + Math_fround(Math_fround(f11 * f53) + Math_fround(f56 * Math_fround(Math_fround(f54 * f55) - Math_fround(f59 * f58))))));
   f7 = Math_fround(f7 + Math_fround(Math_fround(f54 * f4) + Math_fround(Math_fround(f11 * f58) + Math_fround(f56 * Math_fround(Math_fround(f59 * f53) - Math_fround(f57 * f55))))));
   f4 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f11 * f55) + Math_fround(f56 * Math_fround(Math_fround(f57 * f58) - Math_fround(f54 * f53)))) + Math_fround(f59 * f4)));
   f53 = Math_fround(HEAPF32[i15 >> 2]);
   f58 = Math_fround(f56 * f53);
   f55 = Math_fround(HEAPF32[i15 + 12 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f57 * f55));
   f11 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f58 = Math_fround(f58 + Math_fround(f54 * f11));
   f12 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(f56 * f55) - Math_fround(f57 * f53)) - Math_fround(f54 * f12)) - Math_fround(f59 * f11));
   f10 = Math_fround(Math_fround(Math_fround(f57 * f12) + Math_fround(Math_fround(f59 * f55) + Math_fround(f56 * f11))) - Math_fround(f54 * f53));
   f11 = Math_fround(Math_fround(Math_fround(f59 * f53) + Math_fround(Math_fround(f54 * f55) + Math_fround(f56 * f12))) - Math_fround(f57 * f11));
   f12 = Math_fround(f58 - Math_fround(f59 * f12));
  }
  HEAPF32[i42 >> 2] = f12;
  HEAPF32[i38 >> 2] = f11;
  HEAPF32[i39 >> 2] = f10;
  HEAPF32[i25 >> 2] = f9;
  HEAPF32[i26 >> 2] = f8;
  HEAPF32[i27 >> 2] = f7;
  HEAPF32[i28 >> 2] = f4;
  i5 = i22 + 98 | 0;
  i6 = HEAPU16[i5 >> 1] & 2;
  HEAP32[i29 >> 2] = 0;
  HEAP16[i5 >> 1] = 0;
  HEAP16[i22 + 20 >> 1] = 0;
  HEAP32[i22 + 24 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  HEAP16[i22 + 16 >> 1] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 28 >> 2] = 0;
  HEAP32[i22 + 32 >> 2] = 0;
  i3 = HEAP32[gb + 104632 + (i18 * 28 | 0) + (i19 << 2) >> 2] | 0;
  if (!(HEAP8[i30 >> 0] | 0)) i47 = 12; else if (!(HEAP8[gb + 718441 + (i18 * 7 | 0) + i19 >> 0] | 0)) i47 = 12; else {
   f59 = Math_fround(HEAPF32[i21 + 28 >> 2]);
   __ZN5physx21PxcCacheLocalContactsENS_14PxGeometryType4EnumES1_RNS_18PxcNpThreadContextERNS_10PxcNpCacheERKNS_11PxTransformES8_fPFbRKNS_2Gu13GeometryUnionESC_S8_S8_RKfS5_RNS9_13ContactBufferEESC_SC_(i18, i19, i44, i22 + 44 | 0, i41, i42, Math_fround(f59 + Math_fround(HEAPF32[i15 + 28 >> 2])), i3, i21 + 36 | 0, i15 + 36 | 0);
  }
  if ((i47 | 0) == 12) {
   i47 = 0;
   f59 = Math_fround(HEAPF32[i21 + 28 >> 2]);
   HEAPF32[i24 >> 2] = Math_fround(f59 + Math_fround(HEAPF32[i15 + 28 >> 2]));
   mftCall_iiiiiiii(i3 | 0, i21 + 36 | 0, i15 + 36 | 0, i41 | 0, i42 | 0, i24 | 0, i22 + 44 | 0, i31 | 0) | 0;
  }
  mftCall_iiiii(HEAP32[gb + 104828 + (i18 * 28 | 0) + (i19 << 2) >> 2] | 0, i21 | 0, i15 | 0, i44 | 0, i40 | 0) | 0;
  if (i20) if (HEAP32[i29 >> 2] | 0) {
   i3 = 0;
   do {
    i21 = i44 + 384 + (i3 << 6) | 0;
    f57 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
    i19 = i44 + 384 + (i3 << 6) + 4 | 0;
    f58 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
    i20 = i44 + 384 + (i3 << 6) + 8 | 0;
    f59 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
    HEAPF32[i21 >> 2] = f57;
    HEAPF32[i19 >> 2] = f58;
    HEAPF32[i20 >> 2] = f59;
    i20 = i44 + 384 + (i3 << 6) + 48 | 0;
    i19 = i44 + 384 + (i3 << 6) + 52 | 0;
    i21 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i19 >> 2] = i21;
    i19 = i40 + (i3 << 2) | 0;
    i21 = i40 + (i3 << 2) + 2 | 0;
    i20 = HEAP16[i19 >> 1] | 0;
    HEAP16[i19 >> 1] = HEAP16[i21 >> 1] | 0;
    HEAP16[i21 >> 1] = i20;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i29 >> 2] | 0) >>> 0);
  }
  __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i22, i44, i40) | 0;
  do if ((i6 | 0) != (HEAPU16[i5 >> 1] & 2 | 0)) {
   i21 = HEAP32[i45 + (i23 * 12 | 0) + 4 >> 2] | 0;
   i22 = i43 + (i21 >>> 5 << 2) | 0;
   HEAP32[i22 >> 2] = 1 << (i21 & 31) | HEAP32[i22 >> 2];
   if (!i6) {
    i2 = i2 + 1 | 0;
    break;
   } else {
    i1 = i1 + 1 | 0;
    break;
   }
  } while (0);
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) != (i46 | 0));
 i47 = HEAP32[i50 >> 2] | 0;
 i47 = i47 + i1 | 0;
 HEAP32[i50 >> 2] = i47;
 i50 = HEAP32[i49 >> 2] | 0;
 i50 = i50 + i2 | 0;
 HEAP32[i49 >> 2] = i50;
 STACKTOP = i48;
 return;
}

function __ZN7Terrain8TransferI14SafeBinaryReadEEvRT_(i11, i13) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 4 | 0;
 i9 = i14;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i11, i13);
 __ZN14SafeBinaryRead10SetVersionEi(i13, 3);
 HEAP32[i9 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 1016773 | 0, gb + 1016787 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI11TerrainDataE8TransferI14SafeBinaryReadEEvRT_(i9, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i8 = i13 + 128 | 0;
 if (HEAP8[i8 >> 0] | 0) __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i11, i9);
 i4 = i11 + 64 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931579 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 14; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 14; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 14) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931594 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 25; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 25; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931618 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 36; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 36; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 76 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931640 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 47; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 47; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931666 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 58; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 58; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931689 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 69; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 69; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 69) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931711 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 80; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 80; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 80) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931733 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 91; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 91; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 91) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931752 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 102; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i10 = 102; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 102) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i11 + 88 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931774 | 0, i6, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i5 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i11 + 89 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931788 | 0, i6, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i5 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i11 + 90 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931804 | 0, i6, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i5 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ReflectionProbeUsageEvRT_RT0_PKc17TransferMetaFlags(i13, i11 + 92 | 0, gb + 931826 | 0, 0);
 i5 = i11 + 96 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7Terrain12MaterialTypeEEvRT_RT0_PKc17TransferMetaFlags(i13, i5, gb + 931849 | 0, 0);
 i2 = i11 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931864 | 0, HEAP32[gb + 36980 >> 2] | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i11 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931881 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 146; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i10 = 146;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 146) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i13 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 HEAP32[i9 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931899 | 0, gb + 946436 | 0, i12, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i9, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i9 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 do if (HEAP8[i8 >> 0] | 0) {
  i1 = i11 + 108 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
   HEAP32[i1 >> 2] = i2;
   i1 = HEAP32[i11 + 112 >> 2] | 0;
   if (!i1) break;
   i9 = HEAP32[i5 >> 2] | 0;
   HEAP32[i12 >> 2] = (i9 | 0) == 3 ? i2 : 0;
   __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i1, i12, (i9 | 0) == 0 ? gb + 184364 | 0 : (i9 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0);
  }
 } while (0);
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i13, 2) | 0) HEAP32[i5 >> 2] = (HEAP32[i11 + 108 >> 2] | 0) == 0 ? 1 : 3;
 i4 = i11 + 152 | 0;
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931918 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i9 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i9 >>> 0) i10 = 169; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i10 = 169;
     break;
    }
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 169) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (!(HEAP32[i13 >> 2] & 512)) break;
   HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931934 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i9 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i9 >>> 0) i10 = 180; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
     i10 = 180;
     break;
    }
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 180) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (!(HEAP32[i13 >> 2] & 512)) break;
   HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i11 + 120 | 0;
 i4 = HEAP32[gb + 37328 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931957 | 0, i4, i12, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i11 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 931980 | 0, i4, i12, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i11 + 188 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932010 | 0, i6, i12, 0) | 0;
 if (i1 | 0) {
  L270 : do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i10 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i10 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L270;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i11 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932036 | 0, i4, i12, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i11 + 172 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932050 | 0, i4, i12, 1) | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 do if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i13); else {
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i13);
 STACKTOP = i14;
 return;
}

function __ZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_(i48, i49, i1, i51, i50) {
 i48 = i48 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i51 = i51 | 0;
 i50 = i50 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i52 = 0, i53 = 0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i52;
 i35 = i52 + 96 | 0;
 i38 = i52 + 92 | 0;
 i39 = i52 + 88 | 0;
 i40 = i52 + 64 | 0;
 i44 = i52 + 68 | 0;
 i47 = i52 + 56 | 0;
 i36 = i52 + 40 | 0;
 i34 = i52 + 24 | 0;
 i37 = i52 + 8 | 0;
 i32 = HEAP32[i1 + 32 >> 2] | 0;
 i43 = HEAP32[i1 >> 2] | 0;
 i33 = HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 38 >> 0] | 0;
 i46 = i33 & 255;
 i45 = i1 + 36 | 0;
 i31 = HEAP32[i45 >> 2] | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 >> 2] = i32;
 HEAP32[i44 + 4 >> 2] = i31;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = i43;
 HEAPF32[i44 + 16 >> 2] = Math_fround(.00499999989);
 __ZN5physx18AdjacenciesBuilderC2Ev(i47);
 if (!(__ZN5physx18AdjacenciesBuilder4InitERKNS_17ADJACENCIESCREATEE(i47, i44) | 0)) {
  i51 = 0;
  __ZN5physx11AdjacenciesD2Ev(i47);
  STACKTOP = i52;
  return i51 | 0;
 }
 if (__ZNK5physx11Adjacencies22ComputeNbBoundaryEdgesEv(i47) | 0) {
  i51 = 0;
  __ZN5physx11AdjacenciesD2Ev(i47);
  STACKTOP = i52;
  return i51 | 0;
 }
 i15 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i32 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i15 | 0, 0, i32 | 0) | 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i46 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i42 | 0, 0, i46 | 0) | 0;
 HEAP32[i48 >> 2] = 0;
 i16 = i47 + 4 | 0;
 i17 = i36 + 4 | 0;
 i18 = i36 + 8 | 0;
 i19 = (i31 | 0) == 0;
 i20 = i35 + 8 | 0;
 i21 = i35 + 4 | 0;
 i22 = i37 + 4 | 0;
 i23 = i37 + 8 | 0;
 i24 = i49 + 4 | 0;
 i25 = i49 + 8 | 0;
 i26 = (i51 | 0) == 0;
 i27 = i51 + 4 | 0;
 i28 = i51 + 8 | 0;
 i43 = i50 + 4 | 0;
 i44 = i50 + 8 | 0;
 i29 = i34 + 4 | 0;
 i30 = i34 + 8 | 0;
 i13 = 0;
 L7 : while (1) {
  if (i13 >>> 0 < i32 >>> 0) if (HEAP8[i15 + i13 >> 0] | 0) {
   i13 = i13 + 1 | 0;
   continue;
  }
  if ((i13 | 0) == (i32 | 0)) {
   i14 = 127;
   break;
  }
  __ZN5physx2Gu9ContainerC2Ev(i36);
  L14 : while (1) {
   __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb(i36, HEAP32[i16 >> 2] | 0, i13, i15);
   i12 = HEAP32[i16 >> 2] | 0;
   i11 = 0;
   do {
    i4 = HEAP32[i17 >> 2] | 0;
    if (i11 >>> 0 >= i4 >>> 0) break L14;
    i5 = HEAP32[i18 >> 2] | 0;
    i10 = HEAP32[i5 + (i11 << 2) >> 2] | 0;
    i11 = i11 + 1 | 0;
    L19 : do if (i11 >>> 0 < i4 >>> 0) {
     i6 = i11;
     while (1) {
      i3 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
      i2 = HEAP32[i12 + (i3 * 12 | 0) >> 2] | 0;
      i2 = (i2 & 536870912 | 0) == 0 | (i2 & 536870911 | 0) != (i10 | 0);
      i1 = HEAP32[i12 + (i3 * 12 | 0) + 4 >> 2] | 0;
      if ((i1 & 536870911 | 0) == (i10 | 0)) i2 = i2 & (i1 & 536870912 | 0) == 0;
      i1 = HEAP32[i12 + (i3 * 12 | 0) + 8 >> 2] | 0;
      if ((i1 & 536870911 | 0) == (i10 | 0)) {
       if (!(i2 & (i1 & 536870912 | 0) == 0)) {
        i9 = 0;
        break L19;
       }
      } else if (!i2) {
       i9 = 0;
       break L19;
      }
      i6 = i6 + 1 | 0;
      if (i6 >>> 0 >= i4 >>> 0) {
       i9 = 1;
       break;
      }
     }
    } else i9 = 1; while (0);
    L30 : do if (i19) i1 = 1; else {
     i3 = i10 * 3 | 0;
     i1 = HEAP32[i31 + (i3 << 2) >> 2] | 0;
     i2 = HEAP32[i31 + (i3 + 1 << 2) >> 2] | 0;
     i3 = HEAP32[i31 + (i3 + 2 << 2) >> 2] | 0;
     i4 = 0;
     while (1) {
      if (!(HEAP32[i12 + (i10 * 12 | 0) + (i4 << 2) >> 2] & 536870912)) {
       if (!i4) {
        i5 = 1;
        i6 = 2;
        i7 = i1;
        i8 = i2;
       } else {
        i7 = (i4 | 0) == 1;
        i5 = 0;
        i6 = i7 ? 2 : 1;
        i7 = i7 ? i1 : i2;
        i8 = i3;
       }
       i5 = HEAP32[i12 + (i10 * 12 | 0) + (i5 << 2) >> 2] & 536870911;
       i53 = __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_(i10, i7, i12, i31, i35, i38) | 0;
       if (i53 & (__ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_(i5, i7, i12, i31, i39, i40) | 0)) if ((HEAP32[i35 >> 2] | 0) == (HEAP32[i40 >> 2] | 0)) if ((HEAP32[i38 >> 2] | 0) == (HEAP32[i39 >> 2] | 0)) {
        i1 = 0;
        break L30;
       }
       i53 = HEAP32[i12 + (i10 * 12 | 0) + (i6 << 2) >> 2] & 536870911;
       i7 = __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_(i10, i8, i12, i31, i35, i38) | 0;
       if (i7 & (__ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_(i53, i8, i12, i31, i39, i40) | 0)) if ((HEAP32[i35 >> 2] | 0) == (HEAP32[i40 >> 2] | 0)) if ((HEAP32[i38 >> 2] | 0) == (HEAP32[i39 >> 2] | 0)) {
        i1 = 0;
        break L30;
       }
      }
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= 3) {
       i1 = 1;
       break;
      }
     }
    } while (0);
   } while (i9 & i1);
   if (!(HEAP32[i17 >> 2] | 0)) continue;
   i2 = HEAP32[i18 >> 2] | 0;
   i3 = 0;
   do {
    i1 = i2 + (i3 << 2) | 0;
    i53 = HEAP32[i1 >> 2] | 0;
    i11 = i12 + (i53 * 12 | 0) | 0;
    HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 536870912;
    i11 = i12 + (i53 * 12 | 0) + 4 | 0;
    HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 536870912;
    i53 = i12 + (i53 * 12 | 0) + 8 | 0;
    HEAP32[i53 >> 2] = HEAP32[i53 >> 2] | 536870912;
    HEAP8[i15 + (HEAP32[i1 >> 2] | 0) >> 0] = 0;
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i17 >> 2] | 0;
   } while (i3 >>> 0 < i1 >>> 0);
   if (!i1) continue;
   HEAP32[i17 >> 2] = 0;
  }
  __ZN5physx2Gu9ContainerC2Ev(i34);
  if (HEAP32[i17 >> 2] | 0) {
   i7 = 0;
   do {
    i4 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = i4 * 3 | 0;
    if (i19) {
     i14 = 39;
     break L7;
    }
    i3 = HEAP32[i31 + (i1 << 2) >> 2] | 0;
    i5 = HEAP32[i31 + (i1 + 1 << 2) >> 2] | 0;
    i6 = HEAP32[i31 + (i1 + 2 << 2) >> 2] | 0;
    i1 = HEAP32[i16 >> 2] | 0;
    if (HEAP32[i1 + (i4 * 12 | 0) >> 2] & 536870912) {
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     i2 = HEAP32[i30 >> 2] | 0;
     HEAP32[i2 + (i1 << 2) >> 2] = i3;
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
      i2 = HEAP32[i30 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     HEAP32[i2 + (i1 << 2) >> 2] = i5;
     i1 = HEAP32[i16 >> 2] | 0;
    }
    if (HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] & 536870912) {
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     i2 = HEAP32[i30 >> 2] | 0;
     HEAP32[i2 + (i1 << 2) >> 2] = i3;
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
      i2 = HEAP32[i30 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     HEAP32[i2 + (i1 << 2) >> 2] = i6;
     i1 = HEAP32[i16 >> 2] | 0;
    }
    if (HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2] & 536870912 | 0) {
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     i2 = HEAP32[i30 >> 2] | 0;
     HEAP32[i2 + (i1 << 2) >> 2] = i5;
     i1 = HEAP32[i29 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i34 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i34, 1) | 0;
      i1 = HEAP32[i29 >> 2] | 0;
      i2 = HEAP32[i30 >> 2] | 0;
     }
     HEAP32[i29 >> 2] = i1 + 1;
     HEAP32[i2 + (i1 << 2) >> 2] = i6;
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
  }
  __ZN5physx2Gu9ContainerC2Ev(i37);
  __ZN5physx2Gu9ContainerC2ERKS1_(i35, i34);
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = i1 >>> 1;
  L86 : do if (i2) {
   i12 = HEAP32[i20 >> 2] | 0;
   i13 = i12 + 4 | 0;
   do {
    if (i2 >>> 0 > 1) {
     i4 = i13;
     i5 = i12;
     i10 = 1;
     i11 = 0;
    } else break L86;
    L90 : while (1) {
     i9 = HEAP32[i5 >> 2] | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i3 = i10;
     do {
      i4 = i12 + (i3 << 3) | 0;
      i7 = HEAP32[i4 >> 2] | 0;
      i8 = HEAP32[i12 + (i3 << 3) + 4 >> 2] | 0;
      if ((i7 | 0) == (i9 | 0) & (i8 | 0) == (i6 | 0)) {
       i2 = i11;
       break L90;
      }
      if ((i7 | 0) == (i6 | 0) & (i8 | 0) == (i9 | 0)) {
       i2 = i11;
       break L90;
      }
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
     i3 = i10 + 1 | 0;
     if (i3 >>> 0 < i2 >>> 0) {
      i11 = i10;
      i4 = i12 + (i10 << 3) + 4 | 0;
      i5 = i12 + (i10 << 3) | 0;
      i10 = i3;
     } else break L86;
    }
    i1 = i1 + -1 | 0;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i12 + ((i3 << 1 | 1) << 2) >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
    i1 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i4 >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
    i1 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i12 + ((i2 << 1 | 1) << 2) >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
    i1 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i5 >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
    i1 = HEAP32[i21 >> 2] | 0;
    i2 = i1 >>> 1;
   } while ((i2 | 0) != 0);
  } while (0);
  if (i1 >>> 0 > 1) {
   i2 = HEAP32[i20 >> 2] | 0;
   if (!i2) i2 = -1; else {
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i37 >> 2] | 0)) {
     __ZN5physx2Gu9Container6ResizeEj(i37, 1) | 0;
     i1 = HEAP32[i22 >> 2] | 0;
    }
    HEAP32[i22 >> 2] = i1 + 1;
    i2 = HEAP32[i23 >> 2] | 0;
    HEAP32[i2 + (i1 << 2) >> 2] = i3;
    i1 = HEAP32[i22 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i37 >> 2] | 0)) {
     __ZN5physx2Gu9Container6ResizeEj(i37, 1) | 0;
     i1 = HEAP32[i22 >> 2] | 0;
     i2 = HEAP32[i23 >> 2] | 0;
    }
    HEAP32[i22 >> 2] = i1 + 1;
    HEAP32[i2 + (i1 << 2) >> 2] = i4;
    i2 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
    HEAP32[i21 >> 2] = i2;
    i1 = HEAP32[i20 >> 2] | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
    i2 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i1 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
    i1 = HEAP32[i21 >> 2] | 0;
    i2 = i4;
   }
  } else i2 = -1;
  i1 = i1 >>> 1;
  if (i1 | 0) {
   i3 = HEAP32[i20 >> 2] | 0;
   i6 = i2;
   while (1) {
    if (!i1) {
     i14 = 125;
     break L7;
    } else i7 = 0;
    while (1) {
     i5 = i7 << 1;
     i2 = HEAP32[i3 + (i5 << 2) >> 2] | 0;
     i4 = i5 | 1;
     i8 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
     if ((i2 | 0) == (i6 | 0)) {
      i2 = i8;
      i14 = 79;
      break;
     }
     i7 = i7 + 1 | 0;
     if ((i8 | 0) == (i6 | 0)) {
      i14 = 84;
      break;
     }
     if (i7 >>> 0 >= i1 >>> 0) {
      i14 = 125;
      break L7;
     }
    }
    if ((i14 | 0) == 79) {
     i14 = 0;
     i1 = HEAP32[i22 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i37 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i37, 1) | 0;
      i1 = HEAP32[i22 >> 2] | 0;
      i3 = HEAP32[i20 >> 2] | 0;
     }
     HEAP32[i22 >> 2] = i1 + 1;
     HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] = i2;
     i53 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
     HEAP32[i21 >> 2] = i53;
     HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i3 + (i53 << 2) >> 2];
     i53 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
     HEAP32[i21 >> 2] = i53;
     HEAP32[i3 + (i5 << 2) >> 2] = HEAP32[i3 + (i53 << 2) >> 2];
    } else if ((i14 | 0) == 84) {
     i14 = 0;
     i1 = HEAP32[i22 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i37 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i37, 1) | 0;
      i1 = HEAP32[i22 >> 2] | 0;
      i3 = HEAP32[i20 >> 2] | 0;
     }
     HEAP32[i22 >> 2] = i1 + 1;
     HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] = i2;
     i53 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
     HEAP32[i21 >> 2] = i53;
     HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i3 + (i53 << 2) >> 2];
     i53 = (HEAP32[i21 >> 2] | 0) + -1 | 0;
     HEAP32[i21 >> 2] = i53;
     HEAP32[i3 + (i5 << 2) >> 2] = HEAP32[i3 + (i53 << 2) >> 2];
    }
    i1 = (HEAP32[i21 >> 2] | 0) >>> 1;
    if (!i1) break; else i6 = i2;
   }
  }
  __ZN5physx2Gu9ContainerD2Ev(i35);
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) {
   i11 = HEAP32[i23 >> 2] | 0;
   i9 = i1 + -1 | 0;
   i10 = (i9 | 0) == 0;
   if (!i10) {
    i1 = 0;
    do {
     i53 = i42 + (HEAP32[i11 + (i1 << 2) >> 2] | 0) | 0;
     HEAP8[i53 >> 0] = (HEAP8[i53 >> 0] | 0) + 1 << 24 >> 24;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   }
   i1 = HEAP32[i24 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i49 >> 2] | 0)) {
    __ZN5physx2Gu9Container6ResizeEj(i49, 1) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
   }
   HEAP32[i24 >> 2] = i1 + 1;
   i2 = HEAP32[i25 >> 2] | 0;
   HEAP32[i2 + (i1 << 2) >> 2] = i9;
   if ((i9 | 0) != 0 & (i11 | 0) != 0) {
    i1 = HEAP32[i24 >> 2] | 0;
    if ((i1 + i9 | 0) >>> 0 > (HEAP32[i49 >> 2] | 0) >>> 0) {
     __ZN5physx2Gu9Container6ResizeEj(i49, i9) | 0;
     i2 = HEAP32[i25 >> 2] | 0;
     i1 = HEAP32[i24 >> 2] | 0;
    }
    _memcpy(i2 + (i1 << 2) | 0, i11 | 0, i9 << 2 | 0) | 0;
    HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + i9;
   }
   HEAP32[i48 >> 2] = (HEAP32[i48 >> 2] | 0) + 1;
   if (!(HEAP32[i17 >> 2] | 0)) i2 = 0; else {
    i8 = 0;
    do {
     i1 = (HEAP32[(HEAP32[i18 >> 2] | 0) + (i8 << 2) >> 2] | 0) * 3 | 0;
     if (i19) {
      i14 = 99;
      break L7;
     }
     i5 = HEAP32[i31 + (i1 << 2) >> 2] | 0;
     i6 = HEAP32[i31 + (i1 + 1 << 2) >> 2] | 0;
     i7 = HEAP32[i31 + (i1 + 2 << 2) >> 2] | 0;
     L147 : do if (i10) {
      i3 = 0;
      i1 = 0;
      i14 = 103;
     } else {
      i3 = 0;
      i2 = 0;
      i1 = 0;
      i4 = 0;
      do {
       i53 = HEAP32[i11 + (i4 << 2) >> 2] | 0;
       i3 = i3 | (i5 | 0) == (i53 | 0);
       i2 = i2 | (i6 | 0) == (i53 | 0);
       i1 = i1 | (i7 | 0) == (i53 | 0);
       i4 = i4 + 1 | 0;
       if (i1 & (i3 & i2)) break L147;
      } while (i4 >>> 0 < i9 >>> 0);
      if (i3) i14 = 107; else {
       i3 = i2;
       i14 = 103;
      }
     } while (0);
     do if ((i14 | 0) == 103) {
      if (__ZNK5physx2Gu9Container8ContainsEjPj(i50, i5, 0) | 0) {
       i2 = i3;
       i14 = 107;
       break;
      }
      i2 = HEAP32[i43 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i50 >> 2] | 0)) {
       __ZN5physx2Gu9Container6ResizeEj(i50, 1) | 0;
       i2 = HEAP32[i43 >> 2] | 0;
      }
      HEAP32[i43 >> 2] = i2 + 1;
      HEAP32[(HEAP32[i44 >> 2] | 0) + (i2 << 2) >> 2] = i5;
      if (i3) i14 = 112; else i14 = 108;
     } while (0);
     if ((i14 | 0) == 107) if (i2) i14 = 112; else i14 = 108;
     do if ((i14 | 0) == 108) {
      i14 = 0;
      if (__ZNK5physx2Gu9Container8ContainsEjPj(i50, i6, 0) | 0) {
       i14 = 112;
       break;
      }
      i2 = HEAP32[i43 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i50 >> 2] | 0)) {
       __ZN5physx2Gu9Container6ResizeEj(i50, 1) | 0;
       i2 = HEAP32[i43 >> 2] | 0;
      }
      HEAP32[i43 >> 2] = i2 + 1;
      HEAP32[(HEAP32[i44 >> 2] | 0) + (i2 << 2) >> 2] = i6;
      if (!i1) i14 = 113;
     } while (0);
     if ((i14 | 0) == 112) {
      i14 = 0;
      if (!i1) i14 = 113;
     }
     do if ((i14 | 0) == 113) {
      i14 = 0;
      if (__ZNK5physx2Gu9Container8ContainsEjPj(i50, i7, 0) | 0) break;
      i1 = HEAP32[i43 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i50 >> 2] | 0)) {
       __ZN5physx2Gu9Container6ResizeEj(i50, 1) | 0;
       i1 = HEAP32[i43 >> 2] | 0;
      }
      HEAP32[i43 >> 2] = i1 + 1;
      HEAP32[(HEAP32[i44 >> 2] | 0) + (i1 << 2) >> 2] = i7;
     } while (0);
     i8 = i8 + 1 | 0;
     i2 = HEAP32[i17 >> 2] | 0;
    } while (i8 >>> 0 < i2 >>> 0);
   }
   if (!i26) {
    i1 = HEAP32[i27 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i51 >> 2] | 0)) {
     __ZN5physx2Gu9Container6ResizeEj(i51, 1) | 0;
     i1 = HEAP32[i27 >> 2] | 0;
    }
    HEAP32[i27 >> 2] = i1 + 1;
    i3 = HEAP32[i28 >> 2] | 0;
    HEAP32[i3 + (i1 << 2) >> 2] = i2;
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = HEAP32[i17 >> 2] | 0;
    if ((i4 | 0) != 0 & (i5 | 0) != 0) {
     i1 = HEAP32[i27 >> 2] | 0;
     if ((i1 + i5 | 0) >>> 0 > (HEAP32[i51 >> 2] | 0) >>> 0) {
      __ZN5physx2Gu9Container6ResizeEj(i51, i5) | 0;
      i2 = HEAP32[i28 >> 2] | 0;
      i1 = HEAP32[i27 >> 2] | 0;
     } else i2 = i3;
     _memcpy(i2 + (i1 << 2) | 0, i4 | 0, i5 << 2 | 0) | 0;
     HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + i5;
    }
   }
  }
  __ZN5physx2Gu9ContainerD2Ev(i37);
  __ZN5physx2Gu9ContainerD2Ev(i34);
  __ZN5physx2Gu9ContainerD2Ev(i36);
  i13 = 0;
 }
 if ((i14 | 0) == 39) _llvm_trap(); else if ((i14 | 0) == 99) _llvm_trap(); else if ((i14 | 0) == 125) {
  __ZN5physx2Gu9ContainerD2Ev(i35);
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 726825 | 0, 742, gb + 727545 | 0, i41);
  __ZN5physx2Gu9ContainerD2Ev(i37);
  __ZN5physx2Gu9ContainerD2Ev(i34);
  __ZN5physx2Gu9ContainerD2Ev(i36);
  i53 = 0;
  __ZN5physx11AdjacenciesD2Ev(i47);
  STACKTOP = i52;
  return i53 | 0;
 } else if ((i14 | 0) == 127) {
  if (i33 << 24 >> 24) {
   i2 = 0;
   do {
    if ((HEAPU8[i42 + i2 >> 0] | 0) < 3) if (!(__ZNK5physx2Gu9Container8ContainsEjPj(i50, i2, 0) | 0)) {
     i1 = HEAP32[i43 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i50 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i50, 1) | 0;
      i1 = HEAP32[i43 >> 2] | 0;
     }
     HEAP32[i43 >> 2] = i1 + 1;
     HEAP32[(HEAP32[i44 >> 2] | 0) + (i1 << 2) >> 2] = i2;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i46 | 0));
  }
  if (!((i51 | 0) != 0 & (HEAP32[i43 >> 2] | 0) != 0)) {
   i53 = 1;
   __ZN5physx11AdjacenciesD2Ev(i47);
   STACKTOP = i52;
   return i53 | 0;
  }
  __ZL22CheckRedundantVerticesRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderES3_S3_(i48, i49, HEAP32[i45 >> 2] | 0, i51, i50);
  i53 = 1;
  __ZN5physx11AdjacenciesD2Ev(i47);
  STACKTOP = i52;
  return i53 | 0;
 }
 return 0;
}

function __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i96, i3, i1, i85, i84, i98, i99, i97, f2) {
 i96 = i96 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i85 = i85 | 0;
 i84 = i84 | 0;
 i98 = i98 | 0;
 i99 = i99 | 0;
 i97 = i97 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, f86 = f0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i100 = 0, f101 = f0, i102 = 0, i103 = 0, f104 = f0, f105 = f0;
 i100 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i95 = i100 + 192 | 0;
 i90 = i100 + 288 | 0;
 i94 = i100 + 284 | 0;
 i89 = i100 + 208 | 0;
 i87 = i100 + 128 | 0;
 i88 = i100 + 64 | 0;
 i58 = i100 + 272 | 0;
 i59 = i100 + 48 | 0;
 i93 = i100 + 32 | 0;
 i91 = i100 + 16 | 0;
 i92 = i100;
 HEAP32[i95 >> 2] = 0;
 HEAP32[i95 + 4 >> 2] = 0;
 HEAP32[i95 + 8 >> 2] = 0;
 HEAP32[i95 + 12 >> 2] = 0;
 f8 = Math_fround(HEAPF32[i84 >> 2]);
 i68 = i84 + 4 | 0;
 f13 = Math_fround(HEAPF32[i68 >> 2]);
 i69 = i84 + 8 | 0;
 f16 = Math_fround(HEAPF32[i69 >> 2]);
 f9 = Math_fround(HEAPF32[i85 >> 2]);
 i79 = i85 + 4 | 0;
 f14 = Math_fround(HEAPF32[i79 >> 2]);
 i80 = i85 + 8 | 0;
 f15 = Math_fround(HEAPF32[i80 >> 2]);
 HEAP32[i94 >> 2] = 1;
 f26 = Math_fround(HEAPF32[i96 >> 2]);
 f25 = Math_fround(HEAPF32[i96 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i96 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f26 - f7);
 f5 = Math_fround(f25 - f5);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 i70 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5)) + Math_fround(f4 * f4)) > Math_fround(1.1920929e-07);
 f7 = i70 ? f7 : Math_fround(1.0);
 f5 = i70 ? f5 : Math_fround(0.0);
 f4 = i70 ? f4 : Math_fround(0.0);
 f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5))))));
 f7 = Math_fround(f25 * f7);
 f5 = Math_fround(f25 * f5);
 f4 = Math_fround(f25 * f4);
 f25 = Math_fround(-f7);
 f26 = Math_fround(-f5);
 f29 = Math_fround(-f4);
 i70 = i96 + 96 | 0;
 f19 = Math_fround(HEAPF32[i70 >> 2]);
 i71 = i96 + 100 | 0;
 f17 = Math_fround(HEAPF32[i71 >> 2]);
 i72 = i96 + 104 | 0;
 f32 = Math_fround(HEAPF32[i72 >> 2]);
 i73 = i96 + 112 | 0;
 f18 = Math_fround(HEAPF32[i73 >> 2]);
 i74 = i96 + 116 | 0;
 f86 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i96 + 120 | 0;
 f33 = Math_fround(HEAPF32[i75 >> 2]);
 i76 = i96 + 128 | 0;
 f30 = Math_fround(HEAPF32[i76 >> 2]);
 i77 = i96 + 132 | 0;
 f31 = Math_fround(HEAPF32[i77 >> 2]);
 i78 = i96 + 136 | 0;
 f6 = Math_fround(HEAPF32[i78 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f29) + Math_fround(Math_fround(f19 * f25) + Math_fround(f17 * f26)));
 f28 = Math_fround(Math_fround(Math_fround(f18 * f25) + Math_fround(f86 * f26)) + Math_fround(f33 * f29));
 f29 = Math_fround(Math_fround(Math_fround(f30 * f25) + Math_fround(f31 * f26)) + Math_fround(f6 * f29));
 i61 = f27 > f28 & f27 > f29;
 i62 = f28 > f29;
 f30 = i61 ? f19 : i62 ? f18 : f30;
 f31 = i61 ? f17 : i62 ? f86 : f31;
 f6 = i61 ? f32 : i62 ? f33 : f6;
 i62 = f7 > Math_fround(0.0);
 i61 = f5 > Math_fround(0.0);
 i60 = f4 > Math_fround(0.0);
 i81 = i3 + 144 | 0;
 f4 = Math_fround(HEAPF32[i81 >> 2]);
 i82 = i3 + 148 | 0;
 f5 = Math_fround(HEAPF32[i82 >> 2]);
 i83 = i3 + 152 | 0;
 f7 = Math_fround(HEAPF32[i83 >> 2]);
 f33 = Math_fround(-f4);
 f32 = Math_fround(-f5);
 f86 = Math_fround(-f7);
 f33 = i62 ? f4 : f33;
 f32 = i61 ? f5 : f32;
 f86 = i60 ? f7 : f86;
 f17 = Math_fround(f30 - f33);
 f18 = Math_fround(f31 - f32);
 f19 = Math_fround(f6 - f86);
 HEAPF32[i89 >> 2] = f17;
 i60 = i89 + 4 | 0;
 HEAPF32[i60 >> 2] = f18;
 i61 = i89 + 8 | 0;
 HEAPF32[i61 >> 2] = f19;
 i62 = i89 + 12 | 0;
 HEAPF32[i62 >> 2] = Math_fround(0.0);
 i63 = i89 + 16 | 0;
 HEAP32[i63 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i63 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i63 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i63 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i63 = i89 + 32 | 0;
 HEAP32[i63 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i63 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i63 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i63 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i63 = i89 + 48 | 0;
 HEAP32[i63 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i63 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i63 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i63 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 HEAPF32[i87 >> 2] = f30;
 i63 = i87 + 4 | 0;
 HEAPF32[i63 >> 2] = f31;
 i64 = i87 + 8 | 0;
 HEAPF32[i64 >> 2] = f6;
 HEAPF32[i87 + 12 >> 2] = Math_fround(0.0);
 i65 = i87 + 16 | 0;
 HEAP32[i65 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i65 = i87 + 32 | 0;
 HEAP32[i65 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i65 = i87 + 48 | 0;
 HEAP32[i65 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i65 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i65 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i65 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 HEAPF32[i88 >> 2] = f33;
 i65 = i88 + 4 | 0;
 HEAPF32[i65 >> 2] = f32;
 i66 = i88 + 8 | 0;
 HEAPF32[i66 >> 2] = f86;
 i67 = i88 + 12 | 0;
 HEAPF32[i67 >> 2] = Math_fround(0.0);
 i57 = i88 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i57 = i88 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 i57 = i88 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 f86 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i57 = f86 < Math_fround(3402823469999999843913219.0e14);
 f86 = Math_fround(f86 * Math_fround(.100000001));
 f86 = i57 ? f86 : Math_fround(3402823469999999938360549.0e13);
 f32 = Math_fround(f86 + f2);
 f86 = Math_fround(f86 * f86);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19));
 L1 : do if (f6 > f86) {
  i3 = i88 + 16 | 0;
  i34 = i88 + 20 | 0;
  i35 = i88 + 24 | 0;
  i36 = i88 + 28 | 0;
  i37 = i88 + 32 | 0;
  i38 = i88 + 36 | 0;
  i39 = i88 + 40 | 0;
  i40 = i88 + 44 | 0;
  i41 = i87 + 16 | 0;
  i42 = i87 + 20 | 0;
  i43 = i87 + 24 | 0;
  i44 = i89 + 16 | 0;
  i45 = i89 + 20 | 0;
  i46 = i89 + 24 | 0;
  i47 = i89 + 28 | 0;
  i48 = i87 + 32 | 0;
  i49 = i87 + 36 | 0;
  i50 = i87 + 40 | 0;
  i51 = i89 + 32 | 0;
  i52 = i89 + 36 | 0;
  i53 = i89 + 40 | 0;
  i54 = i89 + 44 | 0;
  i55 = i59 + 4 | 0;
  i56 = i59 + 8 | 0;
  i57 = i59 + 12 | 0;
  f10 = f17;
  f11 = f18;
  f12 = f19;
  f20 = f4;
  f21 = f5;
  f31 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f9);
  f30 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f14);
  f29 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f15);
  f28 = Math_fround(0.0);
  f2 = f17;
  f4 = f18;
  f5 = f19;
  while (1) {
   f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f16 = Math_fround(f10 * f17);
   f15 = Math_fround(f11 * f17);
   f17 = Math_fround(f12 * f17);
   f101 = Math_fround(-f16);
   f13 = Math_fround(-f15);
   f8 = Math_fround(-f17);
   f23 = Math_fround(HEAPF32[i70 >> 2]);
   f19 = Math_fround(HEAPF32[i71 >> 2]);
   f18 = Math_fround(HEAPF32[i72 >> 2]);
   f22 = Math_fround(HEAPF32[i73 >> 2]);
   f9 = Math_fround(HEAPF32[i74 >> 2]);
   f14 = Math_fround(HEAPF32[i75 >> 2]);
   f25 = Math_fround(HEAPF32[i76 >> 2]);
   f26 = Math_fround(HEAPF32[i77 >> 2]);
   f27 = Math_fround(HEAPF32[i78 >> 2]);
   f105 = Math_fround(Math_fround(Math_fround(f23 * f101) + Math_fround(f19 * f13)) + Math_fround(f18 * f8));
   f104 = Math_fround(Math_fround(Math_fround(f22 * f101) + Math_fround(f9 * f13)) + Math_fround(f14 * f8));
   f24 = Math_fround(Math_fround(Math_fround(f25 * f101) + Math_fround(f26 * f13)) + Math_fround(f27 * f8));
   i102 = f105 > f104 & f105 > f24;
   i103 = f104 > f24;
   f25 = i102 ? f23 : i103 ? f22 : f25;
   f26 = i102 ? f19 : i103 ? f9 : f26;
   f27 = i102 ? f18 : i103 ? f14 : f27;
   i103 = f16 > Math_fround(0.0);
   i102 = f15 > Math_fround(0.0);
   i1 = f17 > Math_fround(0.0);
   f14 = Math_fround(-f20);
   f18 = Math_fround(-f21);
   f9 = Math_fround(-f7);
   f20 = i103 ? f20 : f14;
   f18 = i102 ? f21 : f18;
   f9 = i1 ? f7 : f9;
   f14 = Math_fround(f31 + f20);
   f19 = Math_fround(f30 + f18);
   f21 = Math_fround(f29 + f9);
   f22 = Math_fround(f25 - f14);
   f23 = Math_fround(f26 - f19);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(f17 * f24) + Math_fround(Math_fround(f16 * f22) + Math_fround(f15 * f23))) - f32);
   f15 = Math_fround(HEAPF32[i84 >> 2]);
   f16 = Math_fround(HEAPF32[i68 >> 2]);
   f17 = Math_fround(HEAPF32[i69 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f15 * f101) + Math_fround(f16 * f13)) + Math_fround(f17 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i90 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i90 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i90 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f5 = Math_fround(HEAPF32[i85 >> 2]);
     f22 = Math_fround(HEAPF32[i79 >> 2]);
     f5 = Math_fround(Math_fround(f13 * f15) + f5);
     f22 = Math_fround(Math_fround(f13 * f16) + f22);
     f23 = Math_fround(Math_fround(f13 * f17) + Math_fround(HEAPF32[i80 >> 2]));
     f101 = Math_fround(f5 - f31);
     f104 = Math_fround(f22 - f30);
     f17 = Math_fround(f23 - f29);
     f105 = Math_fround(HEAPF32[i88 >> 2]);
     f2 = Math_fround(HEAPF32[i65 >> 2]);
     f105 = Math_fround(f101 + f105);
     f2 = Math_fround(f104 + f2);
     f4 = Math_fround(f17 + Math_fround(HEAPF32[i66 >> 2]));
     f21 = Math_fround(HEAPF32[i3 >> 2]);
     f19 = Math_fround(HEAPF32[i34 >> 2]);
     f21 = Math_fround(f101 + f21);
     f19 = Math_fround(f104 + f19);
     f14 = Math_fround(f17 + Math_fround(HEAPF32[i35 >> 2]));
     f7 = Math_fround(HEAPF32[i37 >> 2]);
     f8 = Math_fround(HEAPF32[i38 >> 2]);
     f7 = Math_fround(f101 + f7);
     f8 = Math_fround(f104 + f8);
     f17 = Math_fround(f17 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i88 >> 2] = f105;
     HEAPF32[i65 >> 2] = f2;
     HEAPF32[i66 >> 2] = f4;
     HEAPF32[i67 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f21;
     HEAPF32[i34 >> 2] = f19;
     HEAPF32[i35 >> 2] = f14;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f7;
     HEAPF32[i38 >> 2] = f8;
     HEAPF32[i39 >> 2] = f17;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f104 = Math_fround(HEAPF32[i87 >> 2]);
     f101 = Math_fround(HEAPF32[i63 >> 2]);
     f2 = Math_fround(f101 - f2);
     f4 = Math_fround(Math_fround(HEAPF32[i64 >> 2]) - f4);
     HEAPF32[i89 >> 2] = Math_fround(f104 - f105);
     HEAPF32[i60 >> 2] = f2;
     HEAPF32[i61 >> 2] = f4;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     f4 = Math_fround(HEAPF32[i41 >> 2]);
     f2 = Math_fround(HEAPF32[i42 >> 2]);
     f19 = Math_fround(f2 - f19);
     f14 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f14);
     HEAPF32[i44 >> 2] = Math_fround(f4 - f21);
     HEAPF32[i45 >> 2] = f19;
     HEAPF32[i46 >> 2] = f14;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f14 = Math_fround(HEAPF32[i48 >> 2]);
     f19 = Math_fround(HEAPF32[i49 >> 2]);
     f8 = Math_fround(f19 - f8);
     f17 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f17);
     HEAPF32[i51 >> 2] = Math_fround(f14 - f7);
     HEAPF32[i52 >> 2] = f8;
     HEAPF32[i53 >> 2] = f17;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f17 = Math_fround(f5 + f20);
     f8 = Math_fround(f22 + f18);
     f7 = Math_fround(f23 + f9);
     f14 = f17;
     f19 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f17);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f18 = Math_fround(3402823469999999843913219.0e14);
     f17 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f18 = f6;
     f23 = f29;
     f22 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f18 = f6;
    f13 = f28;
    f23 = f29;
    f22 = f30;
    f17 = f31;
   }
   i103 = HEAP32[i94 >> 2] | 0;
   HEAPF32[i87 + (i103 << 4) >> 2] = f25;
   HEAPF32[i87 + (i103 << 4) + 4 >> 2] = f26;
   HEAPF32[i87 + (i103 << 4) + 8 >> 2] = f27;
   HEAPF32[i87 + (i103 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i88 + (i103 << 4) >> 2] = f14;
   HEAPF32[i88 + (i103 << 4) + 4 >> 2] = f19;
   HEAPF32[i88 + (i103 << 4) + 8 >> 2] = f21;
   HEAPF32[i88 + (i103 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i94 >> 2] = i103 + 1;
   HEAPF32[i89 + (i103 << 4) >> 2] = f9;
   HEAPF32[i89 + (i103 << 4) + 4 >> 2] = f8;
   HEAPF32[i89 + (i103 << 4) + 8 >> 2] = f7;
   HEAPF32[i89 + (i103 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i103 | 0) {
   case 0:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i89 >> 2]);
     f7 = Math_fround(HEAPF32[i60 >> 2]);
     f8 = Math_fround(HEAPF32[i61 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f101 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i103 = f101 > Math_fround(1.0);
      f101 = i103 ? Math_fround(1.0) : f101;
      i103 = f101 > Math_fround(0.0);
      f101 = i103 ? f101 : Math_fround(0.0);
      f104 = Math_fround(f7 + Math_fround(f14 * f101));
      f105 = Math_fround(f8 + Math_fround(f15 * f101));
      HEAPF32[i59 >> 2] = Math_fround(f6 + Math_fround(f9 * f101));
      HEAPF32[i55 >> 2] = f104;
      HEAPF32[i56 >> 2] = f105;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i94 >> 2] = 1;
      HEAP32[i59 >> 2] = HEAP32[i89 >> 2];
      HEAP32[i59 + 4 >> 2] = HEAP32[i89 + 4 >> 2];
      HEAP32[i59 + 8 >> 2] = HEAP32[i89 + 8 >> 2];
      HEAP32[i59 + 12 >> 2] = HEAP32[i89 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i89, i87, i88, i94);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i89, i87, i88, i94);
     break;
    }
   default:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f18 > f6;
   if (!(f6 > f33 & i1)) break L1;
   f20 = Math_fround(HEAPF32[i81 >> 2]);
   f21 = Math_fround(HEAPF32[i82 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = Math_fround(HEAPF32[i83 >> 2]);
   f31 = f17;
   f30 = f22;
   f29 = f23;
   f28 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i100;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f19;
  f11 = f18;
  f10 = f17;
  f9 = f19;
  f8 = f18;
  f7 = f17;
  i1 = 1;
  f5 = f19;
  f4 = f18;
  f2 = f17;
 } while (0);
 i85 = HEAP32[i96 + 64 >> 2] | 0;
 i102 = HEAP32[i96 + 68 >> 2] | 0;
 i103 = HEAP32[i96 + 72 >> 2] | 0;
 i84 = f6 > f86 & i1;
 f32 = i84 ? f7 : f2;
 f86 = i84 ? f8 : f4;
 f104 = i84 ? f9 : f5;
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f104 * f104) + Math_fround(Math_fround(f86 * f86) + Math_fround(f32 * f32))))));
 f32 = Math_fround(f32 * f31);
 f86 = Math_fround(f86 * f31);
 f31 = Math_fround(f104 * f31);
 HEAPF32[i99 >> 2] = f32;
 HEAPF32[i99 + 4 >> 2] = f86;
 HEAPF32[i99 + 8 >> 2] = f31;
 HEAPF32[i99 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i98 >> 2] = f13;
 i99 = i98 + 4 | 0;
 HEAP32[i99 >> 2] = HEAP32[i90 >> 2];
 HEAP32[i99 + 4 >> 2] = HEAP32[i90 + 4 >> 2];
 HEAP32[i99 + 8 >> 2] = HEAP32[i90 + 8 >> 2];
 HEAPF32[i93 >> 2] = i1 ? f7 : f10;
 HEAPF32[i93 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i93 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i93 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i91 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i91 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i91 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i91 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 HEAP32[i92 >> 2] = HEAP32[i95 >> 2];
 HEAP32[i92 + 4 >> 2] = HEAP32[i95 + 4 >> 2];
 HEAP32[i92 + 8 >> 2] = HEAP32[i95 + 8 >> 2];
 HEAP32[i92 + 12 >> 2] = HEAP32[i95 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i89, i87, i88, i93, i91, i92, HEAP32[i94 >> 2] | 0);
 f104 = Math_fround(HEAPF32[i96 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i91 >> 2]);
 f101 = Math_fround(HEAPF32[i91 + 4 >> 2]);
 f105 = Math_fround(HEAPF32[i91 + 8 >> 2]);
 f32 = Math_fround(f33 - Math_fround(f32 * f104));
 f86 = Math_fround(f101 - Math_fround(f86 * f104));
 f104 = Math_fround(f105 - Math_fround(f31 * f104));
 HEAPF32[i97 >> 2] = i85 | 0 ? f32 : f33;
 HEAPF32[i97 + 4 >> 2] = i102 | 0 ? f86 : f101;
 HEAPF32[i97 + 8 >> 2] = i103 | 0 ? f104 : f105;
 HEAPF32[i97 + 12 >> 2] = Math_fround(0.0);
 i103 = 1;
 STACKTOP = i100;
 return i103 | 0;
}

function __ZN5Umbra16TileTraverseTree4initINS_15StartCellFinderEEEbRKNS_11TransformerERKNS_15IntersectFilterET_f(i91, i10, i84, i85, f86) {
 i91 = i91 | 0;
 i10 = i10 | 0;
 i84 = i84 | 0;
 i85 = i85 | 0;
 f86 = Math_fround(f86);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, f101 = f0;
 i93 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i87 = i93;
 i92 = i91 + 60 | 0;
 HEAP32[i92 >> 2] = 1;
 i89 = i91 + 64 | 0;
 i90 = i91 + 24 | 0;
 i7 = HEAP32[i91 >> 2] | 0;
 i6 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i5 = HEAP32[i6 + 36 >> 2] | 0;
 i6 = HEAP32[i6 + 40 >> 2] | 0;
 i88 = i91 + 92 | 0;
 HEAP32[i88 >> 2] = -1;
 HEAP32[i89 >> 2] = HEAP32[i90 >> 2];
 HEAP32[i89 + 4 >> 2] = HEAP32[i90 + 4 >> 2];
 HEAP32[i89 + 8 >> 2] = HEAP32[i90 + 8 >> 2];
 HEAP32[i89 + 12 >> 2] = HEAP32[i90 + 12 >> 2];
 HEAP32[i89 + 16 >> 2] = HEAP32[i90 + 16 >> 2];
 HEAP32[i89 + 20 >> 2] = HEAP32[i90 + 20 >> 2];
 HEAP32[i89 + 24 >> 2] = HEAP32[i90 + 24 >> 2];
 if (!(HEAP32[i90 >> 2] | 0)) i1 = -1; else {
  i83 = HEAP32[HEAP32[i91 + 28 >> 2] >> 2] & 3;
  HEAP32[i91 + 96 >> 2] = i1;
  HEAP32[i91 + 100 >> 2] = i2;
  HEAP32[i91 + 104 >> 2] = i3;
  HEAP32[i91 + 108 >> 2] = 0;
  HEAP32[i91 + 112 >> 2] = i4;
  HEAP32[i91 + 116 >> 2] = i5;
  HEAP32[i91 + 120 >> 2] = i6;
  HEAP8[i91 + 124 >> 0] = 0;
  HEAP8[i91 + 125 >> 0] = i83;
  HEAP8[i91 + 126 >> 0] = 63;
  HEAP8[i91 + 127 >> 0] = 0;
  HEAP32[i88 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[i92 >> 2] = 2;
 i81 = i91 + 52 | 0;
 HEAP16[(HEAP32[i81 >> 2] | 0) + 2 >> 1] = 0;
 HEAP32[i91 + 96 + (i1 * 40 | 0) + 36 >> 2] = 1;
 i80 = i91 + 1856 | 0;
 HEAP32[i80 >> 2] = 0;
 HEAP32[i91 + 1860 >> 2] = -1;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i18 = HEAP32[i1 + 156 >> 2] | 0;
 i82 = i7 + 48 | 0;
 i83 = HEAP32[i82 >> 2] | 0;
 HEAP32[i82 >> 2] = i83 + 1;
 i18 = (i18 | 0) == 0 ? 0 : i1 + i18 | 0;
 i1 = HEAP32[i88 >> 2] | 0;
 L4 : do if ((i1 | 0) != -1) {
  i19 = i91 + 56 | 0;
  i20 = i87 + 12 | 0;
  i21 = f86 > Math_fround(0.0);
  i22 = i10 + 1184 | 0;
  i23 = i22 + 4 | 0;
  i24 = i22 + 8 | 0;
  i25 = i91 + 20 | 0;
  i26 = i91 + 48 | 0;
  i27 = i91 + 36 | 0;
  i28 = i91 + 40 | 0;
  i29 = i10 + 1208 | 0;
  i30 = i10 + 1212 | 0;
  i31 = i10 + 1216 | 0;
  i32 = i10 + 1220 | 0;
  i33 = i10 + 832 | 0;
  i34 = i10 + 836 | 0;
  i35 = i10 + 840 | 0;
  i36 = i10 + 844 | 0;
  i37 = i10 + 1348 | 0;
  i38 = i10 + 1352 | 0;
  i39 = i10 + 1356 | 0;
  i40 = i10 + 1360 | 0;
  i41 = i10 + 848 | 0;
  i42 = i10 + 852 | 0;
  i43 = i10 + 856 | 0;
  i44 = i10 + 860 | 0;
  i45 = i10 + 496 | 0;
  i46 = i10 + 500 | 0;
  i47 = i10 + 504 | 0;
  i48 = i10 + 508 | 0;
  i49 = i10 + 864 | 0;
  i50 = i10 + 868 | 0;
  i51 = i10 + 872 | 0;
  i52 = i10 + 876 | 0;
  i53 = i10 + 512 | 0;
  i54 = i10 + 516 | 0;
  i55 = i10 + 520 | 0;
  i56 = i10 + 524 | 0;
  i57 = i10 + 880 | 0;
  i58 = i10 + 884 | 0;
  i59 = i10 + 888 | 0;
  i60 = i10 + 892 | 0;
  i61 = i10 + 528 | 0;
  i62 = i10 + 532 | 0;
  i63 = i10 + 536 | 0;
  i64 = i10 + 540 | 0;
  i65 = i10 + 896 | 0;
  i66 = i10 + 900 | 0;
  i67 = i10 + 904 | 0;
  i68 = i10 + 908 | 0;
  i69 = i10 + 544 | 0;
  i70 = i10 + 548 | 0;
  i71 = i10 + 552 | 0;
  i72 = i10 + 556 | 0;
  i73 = i10 + 912 | 0;
  i74 = i10 + 916 | 0;
  i75 = i10 + 920 | 0;
  i76 = i10 + 924 | 0;
  i77 = i10 + 560 | 0;
  i78 = i10 + 564 | 0;
  i79 = i10 + 568 | 0;
  i17 = i10 + 572 | 0;
  do {
   if ((HEAP32[i92 >> 2] | 0) >= (HEAP32[i19 >> 2] | 0)) break L4;
   i10 = HEAP32[i91 + 96 + (i1 * 40 | 0) + 36 >> 2] | 0;
   i7 = (HEAP8[i91 + 96 + (i1 * 40 | 0) + 29 >> 0] | 0) == 3;
   i6 = i91 + 96 + (i1 * 40 | 0) | 0;
   i4 = i91 + 96 + (i1 * 40 | 0) + 16 | 0;
   HEAP32[i87 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i87 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i87 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i4 = __ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE(i84, i87) | 0;
   if (i7) if (i4) if (__ZN5Umbra15StartCellFinder16processStartTileEii(i85, HEAP32[i91 + 96 + ((HEAP32[i88 >> 2] | 0) * 40 | 0) + 12 >> 2] | 0, i10) | 0) {
    i1 = HEAP32[i80 >> 2] | 0;
    L13 : do if (i1 | 0) {
     i4 = HEAP32[i81 >> 2] | 0;
     do {
      i1 = i1 + -1 | 0;
      i2 = i4 + (HEAPU16[i91 + 1696 + (i1 << 2) >> 1] << 1) | 0;
      i3 = HEAP16[i2 >> 1] | 0;
      if (i3 & 32767) break L13;
      HEAP16[i2 >> 1] = i3 & 65535 | 16384;
     } while ((i1 | 0) != 0);
    } while (0);
    i1 = i7 & 1 ^ 1;
    i16 = 39;
   } else {
    i4 = 0;
    i6 = 1;
    i16 = 19;
   } else {
    i4 = 0;
    i6 = 1;
    i16 = 19;
   } else {
    i1 = HEAP32[i91 + 96 + ((HEAP32[i88 >> 2] | 0) * 40 | 0) + 12 >> 2] | 0;
    i2 = HEAP32[HEAP32[i91 >> 2] >> 2] | 0;
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) i16 = 10; else if (!(HEAP8[i3 + 24 >> 0] | 0)) i16 = 10; else {
     i6 = HEAP32[i2 + 8 >> 2] | 0;
     i1 = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (Math_imul(HEAP32[i6 + 20 >> 2] | 0, i1) | 0) >> 2] | 0) == 0;
    }
    if ((i16 | 0) == 10) {
     i16 = HEAP32[i2 + 8 >> 2] | 0;
     i1 = (HEAP32[(HEAP32[i16 + 4 >> 2] | 0) + (Math_imul(HEAP32[i16 + 20 >> 2] | 0, i1) | 0) >> 2] | 0) == 0;
    }
    i6 = i1 ^ 1;
    i16 = 19;
   }
   do if ((i16 | 0) == 19) {
    i16 = 0;
    if (!(i4 | i6 ^ 1)) {
     i5 = HEAP32[i88 >> 2] | 0;
     i1 = HEAP32[i91 + 96 + (i5 * 40 | 0) + 12 >> 2] | 0;
     i2 = HEAP32[HEAP32[i91 >> 2] >> 2] | 0;
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i3) i16 = 23; else if (!(HEAP8[i3 + 24 >> 0] | 0)) i16 = 23; else {
      i3 = HEAP32[i2 + 8 >> 2] | 0;
      i1 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (Math_imul(HEAP32[i3 + 20 >> 2] | 0, i1) | 0) >> 2] | 0;
     }
     if ((i16 | 0) == 23) {
      i16 = HEAP32[i2 + 8 >> 2] | 0;
      i1 = HEAP32[(HEAP32[i16 + 4 >> 2] | 0) + (Math_imul(HEAP32[i16 + 20 >> 2] | 0, i1) | 0) >> 2] | 0;
      i1 = (i1 | 0) == 0 ? 0 : (HEAP32[i2 >> 2] | 0) + i1 | 0;
     }
     f15 = Math_fround(HEAPF32[i1 + 48 >> 2]);
     f9 = Math_fround(HEAPF32[i29 >> 2]);
     f11 = Math_fround(HEAPF32[i30 >> 2]);
     f13 = Math_fround(HEAPF32[i31 >> 2]);
     f9 = Math_fround(f15 + f9);
     f11 = Math_fround(f15 + f11);
     f13 = Math_fround(f15 + f13);
     f15 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + Math_fround(0.0));
     f101 = Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) >> 2]);
     f8 = Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) + 4 >> 2]);
     f101 = Math_fround(f101 - f9);
     f8 = Math_fround(f8 - f11);
     f14 = Math_fround(Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) + 8 >> 2]) - f13);
     f12 = Math_fround(Math_fround(1.0) - f15);
     i100 = (HEAPF32[tempDoublePtr >> 2] = f101, HEAP32[tempDoublePtr >> 2] | 0);
     i97 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     i94 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     f12 = Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) + 16 >> 2]);
     f14 = Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) + 20 >> 2]);
     f12 = Math_fround(f9 + f12);
     f14 = Math_fround(f11 + f14);
     f13 = Math_fround(f13 + Math_fround(HEAPF32[i91 + 96 + (i5 * 40 | 0) + 24 >> 2]));
     f15 = Math_fround(f15 + Math_fround(1.0));
     i98 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i95 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i16 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = HEAP32[i33 >> 2] | 0;
     i1 = HEAP32[i34 >> 2] | 0;
     i96 = HEAP32[i35 >> 2] | 0;
     i99 = HEAP32[i36 >> 2] | 0;
     f15 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i5 | i5 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i37 >> 2]));
     f13 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i1 | i1 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(f13 * Math_fround(HEAPF32[i38 >> 2]));
     f14 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i96 | i96 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f14 * Math_fround(HEAPF32[i39 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i99 | i99 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(Math_fround(f12 * Math_fround(HEAPF32[i40 >> 2])) + Math_fround(f14 + Math_fround(f15 + f13)));
     i99 = HEAP32[i41 >> 2] | 0;
     i96 = HEAP32[i42 >> 2] | 0;
     i1 = HEAP32[i43 >> 2] | 0;
     i5 = HEAP32[i44 >> 2] | 0;
     f15 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i99 | i99 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i45 >> 2]));
     f14 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i96 | i96 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f14 * Math_fround(HEAPF32[i46 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i1 | i1 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 * Math_fround(HEAPF32[i47 >> 2]));
     f11 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i5 | i5 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i48 >> 2])) + Math_fround(f12 + Math_fround(f15 + f14)));
     f14 = f13 <= f14 ? f13 : f14;
     i5 = HEAP32[i49 >> 2] | 0;
     i1 = HEAP32[i50 >> 2] | 0;
     i96 = HEAP32[i51 >> 2] | 0;
     i99 = HEAP32[i52 >> 2] | 0;
     f13 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i5 | i5 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(f13 * Math_fround(HEAPF32[i53 >> 2]));
     f15 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i1 | i1 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i54 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i96 | i96 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 * Math_fround(HEAPF32[i55 >> 2]));
     f11 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i99 | i99 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i56 >> 2])) + Math_fround(f12 + Math_fround(f13 + f15)));
     f15 = f14 <= f15 ? f14 : f15;
     i99 = HEAP32[i57 >> 2] | 0;
     i96 = HEAP32[i58 >> 2] | 0;
     i1 = HEAP32[i59 >> 2] | 0;
     i5 = HEAP32[i60 >> 2] | 0;
     f14 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i99 | i99 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f14 * Math_fround(HEAPF32[i61 >> 2]));
     f13 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i96 | i96 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(f13 * Math_fround(HEAPF32[i62 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i1 | i1 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 * Math_fround(HEAPF32[i63 >> 2]));
     f11 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i5 | i5 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i64 >> 2])) + Math_fround(f12 + Math_fround(f14 + f13)));
     f13 = f15 <= f13 ? f15 : f13;
     i5 = HEAP32[i65 >> 2] | 0;
     i1 = HEAP32[i66 >> 2] | 0;
     i96 = HEAP32[i67 >> 2] | 0;
     i99 = HEAP32[i68 >> 2] | 0;
     f15 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i5 | i5 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i69 >> 2]));
     f14 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i1 | i1 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f14 * Math_fround(HEAPF32[i70 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i96 | i96 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 * Math_fround(HEAPF32[i71 >> 2]));
     f11 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i99 | i99 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i72 >> 2])) + Math_fround(f12 + Math_fround(f15 + f14)));
     f14 = f13 <= f14 ? f13 : f14;
     i99 = HEAP32[i73 >> 2] | 0;
     i96 = HEAP32[i74 >> 2] | 0;
     i1 = HEAP32[i75 >> 2] | 0;
     i5 = HEAP32[i76 >> 2] | 0;
     f13 = (HEAP32[tempDoublePtr >> 2] = i100 & ~i99 | i99 & i98, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = Math_fround(f13 * Math_fround(HEAPF32[i77 >> 2]));
     f15 = (HEAP32[tempDoublePtr >> 2] = i97 & ~i96 | i96 & i95, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i78 >> 2]));
     f12 = (HEAP32[tempDoublePtr >> 2] = i94 & ~i1 | i1 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 * Math_fround(HEAPF32[i79 >> 2]));
     f11 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i5 | i5 & i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i17 >> 2])) + Math_fround(f12 + Math_fround(f13 + f15)));
     if ((f14 <= f15 ? f14 : f15) < Math_fround(0.0)) {
      i16 = 47;
      break;
     }
    }
    i1 = i7 & 1 ^ 1;
    if (i21 & i6 & ((i7 | i4) ^ 1)) {
     i2 = HEAP32[i88 >> 2] | 0;
     f8 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) >> 2]);
     f12 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) + 8 >> 2]);
     f9 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) + 16 >> 2]);
     f13 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) + 20 >> 2]);
     f15 = Math_fround(HEAPF32[i91 + 96 + (i2 * 40 | 0) + 24 >> 2]);
     f11 = Math_fround(HEAPF32[i22 >> 2]);
     if (f9 < f11) f8 = Math_fround(f11 - f9); else if (f8 > f11) f8 = Math_fround(f8 - f11); else f8 = Math_fround(0.0);
     f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(0.0));
     f8 = Math_fround(HEAPF32[i23 >> 2]);
     if (f13 < f8) f8 = Math_fround(f8 - f13); else if (f12 > f8) f8 = Math_fround(f12 - f8); else f8 = Math_fround(0.0);
     f9 = Math_fround(f9 + Math_fround(f8 * f8));
     f8 = Math_fround(HEAPF32[i24 >> 2]);
     if (f15 < f8) f8 = Math_fround(f8 - f15); else if (f14 > f8) f8 = Math_fround(f14 - f8); else f8 = Math_fround(0.0);
     f101 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f8 * f8))));
     i16 = f101 > Math_fround(Math_fround(HEAPF32[i18 + (HEAP32[i91 + 96 + (i2 * 40 | 0) + 12 >> 2] << 2) >> 2]) * f86);
     i1 = i16 ? 0 : i1;
     i16 = 39;
    } else i16 = 39;
   } while (0);
   do if ((i16 | 0) == 39) {
    if (!(i1 & 1)) {
     i100 = HEAP32[i91 + 96 + ((HEAP32[i88 >> 2] | 0) * 40 | 0) + 12 >> 2] | 0;
     i16 = (HEAP32[i25 >> 2] | 0) + (i100 >> 5 << 2) | 0;
     HEAP32[i16 >> 2] = 1 << (i100 & 31) | HEAP32[i16 >> 2];
     i16 = 47;
     break;
    }
    i3 = HEAP32[i92 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i1 = HEAP32[i81 >> 2] | 0;
    HEAP16[i1 + (i3 << 1) >> 1] = 0;
    HEAP32[i92 >> 2] = i3 + 2;
    HEAP16[i1 + (i4 << 1) >> 1] = 0;
    HEAP16[i1 + (i10 << 1) >> 1] = i3 | 32768;
    i1 = HEAP32[i88 >> 2] | 0;
    i2 = HEAP32[i91 + 96 + (i1 * 40 | 0) + 12 >> 2] | 0;
    if ((HEAP32[i26 >> 2] | 0) > (i2 | 0)) f8 = Math_fround(HEAPF32[(HEAP32[i27 >> 2] | 0) + (HEAP32[i28 >> 2] | 0) + (i2 << 2) >> 2]); else {
     i100 = HEAPU8[i91 + 96 + (i1 * 40 | 0) + 29 >> 0] | 0;
     f8 = Math_fround(HEAPF32[i91 + 96 + (i1 * 40 | 0) + (i100 << 2) >> 2]);
     f8 = Math_fround(Math_fround(f8 + Math_fround(HEAPF32[i91 + 96 + (i1 * 40 | 0) + 16 + (i100 << 2) >> 2])) * Math_fround(.5));
    }
    __ZN5Umbra15KDTraverseStackIiE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbii(i89, 3, f8, 1, i3, i4);
    i16 = HEAP32[i80 >> 2] | 0;
    HEAP32[i80 >> 2] = i16 + 1;
    i16 = i91 + 1696 + (i16 << 2) | 0;
    i100 = i10 & 65535 | 131072;
    HEAP16[i16 >> 1] = i100;
    HEAP16[i16 + 2 >> 1] = i100 >>> 16;
    i16 = 45;
   } while (0);
   L62 : do if ((i16 | 0) == 47) {
    i16 = 0;
    i2 = (HEAP32[i88 >> 2] | 0) + -1 | 0;
    HEAP32[i88 >> 2] = i2;
    i1 = HEAP32[i80 >> 2] | 0;
    if (!i1) i1 = i2; else while (1) {
     i99 = i91 + 1696 + (i1 + -1 << 2) + 2 | 0;
     i100 = (HEAP16[i99 >> 1] | 0) + -1 << 16 >> 16;
     HEAP16[i99 >> 1] = i100;
     if (i100 << 16 >> 16) {
      i16 = 45;
      break L62;
     }
     i1 = (HEAP32[i80 >> 2] | 0) + -1 | 0;
     HEAP32[i80 >> 2] = i1;
     if (!i1) {
      i16 = 45;
      break;
     }
    }
   } while (0);
   if ((i16 | 0) == 45) {
    i16 = 0;
    i1 = HEAP32[i88 >> 2] | 0;
   }
  } while ((i1 | 0) != -1);
 } while (0);
 if (!(HEAP16[(HEAP32[i81 >> 2] | 0) + 2 >> 1] & 32767)) {
  i99 = HEAP32[i92 >> 2] | 0;
  i100 = i91 + 56 | 0;
  i100 = HEAP32[i100 >> 2] | 0;
  i100 = (i99 | 0) < (i100 | 0);
  HEAP32[i82 >> 2] = i83;
  STACKTOP = i93;
  return i100 | 0;
 }
 i6 = HEAP32[HEAP32[HEAP32[i91 >> 2] >> 2] >> 2] | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i5 = HEAP32[i6 + 36 >> 2] | 0;
 i6 = HEAP32[i6 + 40 >> 2] | 0;
 HEAP32[i88 >> 2] = -1;
 HEAP32[i89 >> 2] = HEAP32[i90 >> 2];
 HEAP32[i89 + 4 >> 2] = HEAP32[i90 + 4 >> 2];
 HEAP32[i89 + 8 >> 2] = HEAP32[i90 + 8 >> 2];
 HEAP32[i89 + 12 >> 2] = HEAP32[i90 + 12 >> 2];
 HEAP32[i89 + 16 >> 2] = HEAP32[i90 + 16 >> 2];
 HEAP32[i89 + 20 >> 2] = HEAP32[i90 + 20 >> 2];
 HEAP32[i89 + 24 >> 2] = HEAP32[i90 + 24 >> 2];
 if (!(HEAP32[i90 >> 2] | 0)) i1 = -1; else {
  i100 = HEAP32[HEAP32[i91 + 28 >> 2] >> 2] & 3;
  HEAP32[i91 + 96 >> 2] = i1;
  HEAP32[i91 + 100 >> 2] = i2;
  HEAP32[i91 + 104 >> 2] = i3;
  HEAP32[i91 + 108 >> 2] = 0;
  HEAP32[i91 + 112 >> 2] = i4;
  HEAP32[i91 + 116 >> 2] = i5;
  HEAP32[i91 + 120 >> 2] = i6;
  HEAP8[i91 + 124 >> 0] = 0;
  HEAP8[i91 + 125 >> 0] = i100;
  HEAP8[i91 + 126 >> 0] = 63;
  HEAP8[i91 + 127 >> 0] = 0;
  HEAP32[i88 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[i91 + 96 + (i1 * 40 | 0) + 36 >> 2] = 1;
 i99 = HEAP32[i92 >> 2] | 0;
 i100 = i91 + 56 | 0;
 i100 = HEAP32[i100 >> 2] | 0;
 i100 = (i99 | 0) < (i100 | 0);
 HEAP32[i82 >> 2] = i83;
 STACKTOP = i93;
 return i100 | 0;
}

function __ZN10SpookyHash6UpdateEPKvj(i33, i9, i6) {
 i33 = i33 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i34 = i33 + 292 | 0;
 i7 = HEAP8[i34 >> 0] | 0;
 i8 = i7 & 255;
 i1 = i8 + i6 | 0;
 if (i1 >>> 0 < 192) {
  _memcpy(i33 + i8 | 0, i9 | 0, i6 | 0) | 0;
  i33 = i33 + 288 | 0;
  HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i6;
  HEAP8[i34 >> 0] = i1;
  return;
 }
 i4 = i33 + 288 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i31 = i33 + 192 | 0;
 i14 = i31;
 i2 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i32 = i33 + 200 | 0;
 i16 = i32;
 i15 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 if (i5 >>> 0 < 192) {
  i12 = i15;
  i17 = -559038737;
  i13 = i16;
  i18 = -559038737;
  i3 = -559038737;
  i1 = -559038737;
  i19 = i2;
  i22 = i14;
  i23 = i15;
  i25 = i16;
  i24 = -559038737;
  i20 = -559038737;
  i21 = i2;
  i26 = i14;
  i27 = i15;
  i28 = i16;
  i29 = -559038737;
  i30 = -559038737;
  i10 = i2;
  i11 = i14;
 } else {
  i18 = i33 + 208 | 0;
  i22 = i33 + 216 | 0;
  i25 = i33 + 224 | 0;
  i20 = i33 + 232 | 0;
  i26 = i33 + 240 | 0;
  i28 = i33 + 248 | 0;
  i30 = i33 + 256 | 0;
  i11 = i33 + 264 | 0;
  i13 = i33 + 272 | 0;
  i1 = i33 + 280 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i17 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i19 = HEAP32[i22 >> 2] | 0;
  i22 = HEAP32[i22 + 4 >> 2] | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i25 = HEAP32[i25 + 4 >> 2] | 0;
  i24 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i21 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 4 >> 2] | 0;
  i27 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i29 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i30 + 4 >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i5 + i6;
 if (!(i7 << 24 >> 24)) {
  i5 = i13;
  i4 = i14;
  i8 = i15;
  i14 = i16;
  i15 = i26;
  i16 = i27;
  i13 = i29;
  i7 = i30;
 } else {
  i5 = 192 - i8 & 255;
  _memcpy(i33 + i8 | 0, i9 | 0, i5 | 0) | 0;
  i36 = i33;
  i36 = _i64Add(HEAP32[i36 >> 2] | 0, HEAP32[i36 + 4 >> 2] | 0, i2 | 0, i14 | 0) | 0;
  i35 = getTempRet0() | 0;
  i2 = i12 ^ i17;
  i18 = i13 ^ i18;
  i8 = _bitshift64Shl(i36 | 0, i35 | 0, 11) | 0;
  i4 = getTempRet0() | 0;
  i37 = _bitshift64Lshr(i36 | 0, i35 | 0, 53) | 0;
  i4 = getTempRet0() | 0 | i4;
  i35 = _i64Add(i36 ^ i3 | 0, i35 ^ i1 | 0, i15 | 0, i16 | 0) | 0;
  i36 = getTempRet0() | 0;
  i14 = i33 + 8 | 0;
  i14 = _i64Add(HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i15 | 0, i16 | 0) | 0;
  i17 = getTempRet0() | 0;
  i15 = i35 ^ i19;
  i7 = i36 ^ i22;
  i4 = _i64Add((i37 | i8) ^ i14 | 0, i4 ^ i17 | 0, i2 | 0, i18 | 0) | 0;
  i3 = getTempRet0() | 0;
  i22 = i33 + 16 | 0;
  i22 = _i64Add(HEAP32[i22 >> 2] | 0, HEAP32[i22 + 4 >> 2] | 0, i2 | 0, i18 | 0) | 0;
  i18 = getTempRet0() | 0;
  i2 = i4 ^ i23;
  i1 = i3 ^ i25;
  i19 = _bitshift64Shl(i22 | 0, i18 | 0, 43) | 0;
  i8 = getTempRet0() | 0;
  i37 = _bitshift64Lshr(i22 | 0, i18 | 0, 21) | 0;
  i8 = getTempRet0() | 0 | i8;
  i18 = _i64Add(i17 ^ i22 | 0, i14 ^ i18 | 0, i15 | 0, i7 | 0) | 0;
  i22 = getTempRet0() | 0;
  i14 = i33 + 24 | 0;
  i14 = _i64Add(i15 | 0, i7 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i25 = getTempRet0() | 0;
  i7 = i18 ^ i24;
  i15 = i22 ^ i20;
  i23 = _bitshift64Shl(i14 | 0, i25 | 0, 31) | 0;
  i17 = getTempRet0() | 0;
  i16 = _bitshift64Lshr(i14 | 0, i25 | 0, 33) | 0;
  i17 = getTempRet0() | 0 | i17;
  i25 = _i64Add((i37 | i19) ^ i14 | 0, i8 ^ i25 | 0, i2 | 0, i1 | 0) | 0;
  i8 = getTempRet0() | 0;
  i14 = i33 + 32 | 0;
  i14 = _i64Add(i2 | 0, i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i20 = getTempRet0() | 0;
  i1 = i25 ^ i21;
  i2 = i8 ^ i26;
  i24 = _bitshift64Shl(i14 | 0, i20 | 0, 17) | 0;
  i19 = getTempRet0() | 0;
  i37 = _bitshift64Lshr(i14 | 0, i20 | 0, 47) | 0;
  i19 = getTempRet0() | 0 | i19;
  i20 = _i64Add((i16 | i23) ^ i14 | 0, i17 ^ i20 | 0, i7 | 0, i15 | 0) | 0;
  i17 = getTempRet0() | 0;
  i14 = i33 + 40 | 0;
  i14 = _i64Add(i7 | 0, i15 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i15 = getTempRet0() | 0;
  i26 = i20 ^ i27;
  i7 = i17 ^ i28;
  i27 = _bitshift64Shl(i14 | 0, i15 | 0, 28) | 0;
  i23 = getTempRet0() | 0;
  i21 = _bitshift64Lshr(i14 | 0, i15 | 0, 36) | 0;
  i23 = getTempRet0() | 0 | i23;
  i15 = _i64Add((i37 | i24) ^ i14 | 0, i19 ^ i15 | 0, i1 | 0, i2 | 0) | 0;
  i19 = getTempRet0() | 0;
  i14 = i33 + 48 | 0;
  i14 = _i64Add(i1 | 0, i2 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i28 = getTempRet0() | 0;
  i2 = i15 ^ i29;
  i30 = i19 ^ i30;
  i1 = _bitshift64Shl(i14 | 0, i28 | 0, 39) | 0;
  i24 = getTempRet0() | 0;
  i29 = _bitshift64Lshr(i14 | 0, i28 | 0, 25) | 0;
  i24 = getTempRet0() | 0 | i24;
  i28 = _i64Add((i21 | i27) ^ i14 | 0, i23 ^ i28 | 0, i26 | 0, i7 | 0) | 0;
  i23 = getTempRet0() | 0;
  i14 = i33 + 56 | 0;
  i14 = _i64Add(i26 | 0, i7 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i7 = getTempRet0() | 0;
  i26 = i28 ^ i10;
  i10 = i23 ^ i11;
  i27 = _bitshift64Shl(i14 | 0, i7 | 0, 57) | 0;
  i21 = getTempRet0() | 0;
  i37 = _bitshift64Lshr(i14 | 0, i7 | 0, 7) | 0;
  i21 = getTempRet0() | 0 | i21;
  i7 = _i64Add((i29 | i1) ^ i14 | 0, i24 ^ i7 | 0, i2 | 0, i30 | 0) | 0;
  i24 = getTempRet0() | 0;
  i14 = i33 + 64 | 0;
  i14 = _i64Add(i2 | 0, i30 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i30 = getTempRet0() | 0;
  i2 = i7 ^ i12;
  i1 = i24 ^ i13;
  i29 = _bitshift64Shl(i14 | 0, i30 | 0, 55) | 0;
  i16 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i14 | 0, i30 | 0, 9) | 0;
  i16 = getTempRet0() | 0 | i16;
  i30 = _i64Add((i37 | i27) ^ i14 | 0, i21 ^ i30 | 0, i26 | 0, i10 | 0) | 0;
  i21 = getTempRet0() | 0;
  i14 = i33 + 72 | 0;
  i14 = _i64Add(i26 | 0, i10 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i10 = getTempRet0() | 0;
  i35 = i30 ^ i35;
  i26 = i21 ^ i36;
  i12 = _bitshift64Shl(i14 | 0, i10 | 0, 54) | 0;
  i13 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i14 | 0, i10 | 0, 10) | 0;
  i13 = getTempRet0() | 0 | i13;
  i10 = _i64Add((i11 | i29) ^ i14 | 0, i16 ^ i10 | 0, i2 | 0, i1 | 0) | 0;
  i16 = getTempRet0() | 0;
  i14 = i33 + 80 | 0;
  i14 = _i64Add(i2 | 0, i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i1 = getTempRet0() | 0;
  i4 = i10 ^ i4;
  i3 = i16 ^ i3;
  i2 = _bitshift64Shl(i14 | 0, i1 | 0, 22) | 0;
  i29 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i14 | 0, i1 | 0, 42) | 0;
  i29 = getTempRet0() | 0 | i29;
  i1 = _i64Add((i27 | i12) ^ i14 | 0, i13 ^ i1 | 0, i35 | 0, i26 | 0) | 0;
  i13 = getTempRet0() | 0;
  i14 = i33 + 88 | 0;
  i14 = _i64Add(i35 | 0, i26 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i26 = getTempRet0() | 0;
  i18 = i1 ^ i18;
  i22 = i13 ^ i22;
  i35 = _bitshift64Shl(i14 | 0, i26 | 0, 46) | 0;
  i12 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i14 | 0, i26 | 0, 18) | 0;
  i12 = getTempRet0() | 0 | i12;
  i26 = _i64Add((i11 | i2) ^ i14 | 0, i29 ^ i26 | 0, i4 | 0, i3 | 0) | 0;
  i29 = getTempRet0() | 0;
  i14 = i33 + 96 | 0;
  i14 = _i64Add(i4 | 0, i3 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i3 = getTempRet0() | 0;
  i25 = i26 ^ i25;
  i8 = i29 ^ i8;
  i4 = _bitshift64Shl(i14 | 0, i3 | 0, 11) | 0;
  i2 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i14 | 0, i3 | 0, 53) | 0;
  i2 = getTempRet0() | 0 | i2;
  i3 = _i64Add((i27 | i35) ^ i14 | 0, i12 ^ i3 | 0, i18 | 0, i22 | 0) | 0;
  i12 = getTempRet0() | 0;
  i14 = i33 + 104 | 0;
  i14 = _i64Add(i18 | 0, i22 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  i22 = getTempRet0() | 0;
  i20 = i3 ^ i20;
  i17 = i12 ^ i17;
  i2 = _i64Add((i11 | i4) ^ i14 | 0, i2 ^ i22 | 0, i25 | 0, i8 | 0) | 0;
  i4 = getTempRet0() | 0;
  i11 = i33 + 112 | 0;
  i11 = _i64Add(i25 | 0, i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i8 = getTempRet0() | 0;
  i15 = i2 ^ i15;
  i19 = i4 ^ i19;
  i25 = _bitshift64Shl(i11 | 0, i8 | 0, 43) | 0;
  i18 = getTempRet0() | 0;
  i35 = _bitshift64Lshr(i11 | 0, i8 | 0, 21) | 0;
  i18 = getTempRet0() | 0 | i18;
  i8 = _i64Add(i22 ^ i11 | 0, i14 ^ i8 | 0, i20 | 0, i17 | 0) | 0;
  i14 = getTempRet0() | 0;
  i11 = i33 + 120 | 0;
  i11 = _i64Add(i20 | 0, i17 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i17 = getTempRet0() | 0;
  i28 = i8 ^ i28;
  i23 = i14 ^ i23;
  i20 = _bitshift64Shl(i11 | 0, i17 | 0, 31) | 0;
  i22 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i11 | 0, i17 | 0, 33) | 0;
  i22 = getTempRet0() | 0 | i22;
  i17 = _i64Add((i35 | i25) ^ i11 | 0, i18 ^ i17 | 0, i15 | 0, i19 | 0) | 0;
  i18 = getTempRet0() | 0;
  i11 = i33 + 128 | 0;
  i11 = _i64Add(i15 | 0, i19 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i19 = getTempRet0() | 0;
  i7 = i17 ^ i7;
  i24 = i18 ^ i24;
  i15 = _bitshift64Shl(i11 | 0, i19 | 0, 17) | 0;
  i25 = getTempRet0() | 0;
  i35 = _bitshift64Lshr(i11 | 0, i19 | 0, 47) | 0;
  i25 = getTempRet0() | 0 | i25;
  i19 = _i64Add((i27 | i20) ^ i11 | 0, i22 ^ i19 | 0, i28 | 0, i23 | 0) | 0;
  i22 = getTempRet0() | 0;
  i11 = i33 + 136 | 0;
  i11 = _i64Add(i28 | 0, i23 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i23 = getTempRet0() | 0;
  i30 = i19 ^ i30;
  i21 = i22 ^ i21;
  i28 = _bitshift64Shl(i11 | 0, i23 | 0, 28) | 0;
  i20 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i11 | 0, i23 | 0, 36) | 0;
  i20 = getTempRet0() | 0 | i20;
  i23 = _i64Add((i35 | i15) ^ i11 | 0, i25 ^ i23 | 0, i7 | 0, i24 | 0) | 0;
  i25 = getTempRet0() | 0;
  i11 = i33 + 144 | 0;
  i11 = _i64Add(i7 | 0, i24 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i24 = getTempRet0() | 0;
  i10 = i23 ^ i10;
  i16 = i25 ^ i16;
  i7 = _bitshift64Shl(i11 | 0, i24 | 0, 39) | 0;
  i15 = getTempRet0() | 0;
  i35 = _bitshift64Lshr(i11 | 0, i24 | 0, 25) | 0;
  i15 = getTempRet0() | 0 | i15;
  i24 = _i64Add((i27 | i28) ^ i11 | 0, i20 ^ i24 | 0, i30 | 0, i21 | 0) | 0;
  i20 = getTempRet0() | 0;
  i11 = i33 + 152 | 0;
  i11 = _i64Add(i30 | 0, i21 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i21 = getTempRet0() | 0;
  i1 = i24 ^ i1;
  i13 = i20 ^ i13;
  i30 = _bitshift64Shl(i11 | 0, i21 | 0, 57) | 0;
  i28 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i11 | 0, i21 | 0, 7) | 0;
  i28 = getTempRet0() | 0 | i28;
  i21 = _i64Add((i35 | i7) ^ i11 | 0, i15 ^ i21 | 0, i10 | 0, i16 | 0) | 0;
  i15 = getTempRet0() | 0;
  i11 = i33 + 160 | 0;
  i11 = _i64Add(i10 | 0, i16 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i16 = getTempRet0() | 0;
  i26 = i21 ^ i26;
  i29 = i15 ^ i29;
  i10 = _bitshift64Shl(i11 | 0, i16 | 0, 55) | 0;
  i7 = getTempRet0() | 0;
  i35 = _bitshift64Lshr(i11 | 0, i16 | 0, 9) | 0;
  i7 = getTempRet0() | 0 | i7;
  i16 = _i64Add((i27 | i30) ^ i11 | 0, i28 ^ i16 | 0, i1 | 0, i13 | 0) | 0;
  i28 = getTempRet0() | 0;
  i11 = i33 + 168 | 0;
  i11 = _i64Add(i1 | 0, i13 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i13 = getTempRet0() | 0;
  i3 = i16 ^ i3;
  i12 = i28 ^ i12;
  i1 = _bitshift64Shl(i11 | 0, i13 | 0, 54) | 0;
  i30 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i11 | 0, i13 | 0, 10) | 0;
  i30 = getTempRet0() | 0 | i30;
  i13 = _i64Add((i35 | i10) ^ i11 | 0, i7 ^ i13 | 0, i26 | 0, i29 | 0) | 0;
  i7 = getTempRet0() | 0;
  i11 = i33 + 176 | 0;
  i11 = _i64Add(i26 | 0, i29 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i29 = getTempRet0() | 0;
  i2 = i13 ^ i2;
  i4 = i7 ^ i4;
  i26 = _bitshift64Shl(i11 | 0, i29 | 0, 22) | 0;
  i10 = getTempRet0() | 0;
  i35 = _bitshift64Lshr(i11 | 0, i29 | 0, 42) | 0;
  i10 = getTempRet0() | 0 | i10;
  i29 = _i64Add((i27 | i1) ^ i11 | 0, i30 ^ i29 | 0, i3 | 0, i12 | 0) | 0;
  i30 = getTempRet0() | 0;
  i11 = i33 + 184 | 0;
  i11 = _i64Add(i3 | 0, i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
  i12 = getTempRet0() | 0;
  i3 = _bitshift64Shl(i11 | 0, i12 | 0, 46) | 0;
  i1 = getTempRet0() | 0;
  i27 = _bitshift64Lshr(i11 | 0, i12 | 0, 18) | 0;
  i1 = getTempRet0() | 0 | i1;
  i12 = _i64Add((i35 | i26) ^ i11 | 0, i10 ^ i12 | 0, i2 | 0, i4 | 0) | 0;
  i6 = i6 - i5 | 0;
  i9 = i9 + i5 | 0;
  i10 = i29;
  i11 = i30;
  i5 = getTempRet0() | 0;
  i3 = i27 | i3;
  i8 = i29 ^ i8;
  i14 = i30 ^ i14;
 }
 i29 = i9 + (((i6 >>> 0) / 96 | 0) * 12 << 3) | 0;
 i26 = i9 - i29 + i6 | 0;
 i27 = i26 & 255;
 if (i9 >>> 0 < i29 >>> 0) {
  i6 = i12;
  i12 = i28;
  do {
   i30 = i9;
   i30 = _i64Add(HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0, i2 | 0, i4 | 0) | 0;
   i28 = getTempRet0() | 0;
   i36 = i6 ^ i17;
   i37 = i5 ^ i18;
   i4 = _bitshift64Shl(i30 | 0, i28 | 0, 11) | 0;
   i2 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i30 | 0, i28 | 0, 53) | 0;
   i2 = getTempRet0() | 0 | i2;
   i3 = _i64Add(i30 ^ i3 | 0, i28 ^ i1 | 0, i8 | 0, i14 | 0) | 0;
   i1 = getTempRet0() | 0;
   i28 = i9 + 8 | 0;
   i14 = _i64Add(HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0, i8 | 0, i14 | 0) | 0;
   i28 = getTempRet0() | 0;
   i30 = i3 ^ i19;
   i17 = i1 ^ i22;
   i2 = _i64Add((i18 | i4) ^ i14 | 0, i2 ^ i28 | 0, i36 | 0, i37 | 0) | 0;
   i4 = getTempRet0() | 0;
   i8 = i9 + 16 | 0;
   i37 = _i64Add(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i36 | 0, i37 | 0) | 0;
   i8 = getTempRet0() | 0;
   i36 = i2 ^ i23;
   i19 = i4 ^ i25;
   i25 = _bitshift64Shl(i37 | 0, i8 | 0, 43) | 0;
   i18 = getTempRet0() | 0;
   i35 = _bitshift64Lshr(i37 | 0, i8 | 0, 21) | 0;
   i18 = getTempRet0() | 0 | i18;
   i8 = _i64Add(i28 ^ i37 | 0, i14 ^ i8 | 0, i30 | 0, i17 | 0) | 0;
   i14 = getTempRet0() | 0;
   i37 = i9 + 24 | 0;
   i37 = _i64Add(i30 | 0, i17 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i17 = getTempRet0() | 0;
   i30 = i8 ^ i24;
   i23 = i14 ^ i20;
   i20 = _bitshift64Shl(i37 | 0, i17 | 0, 31) | 0;
   i22 = getTempRet0() | 0;
   i28 = _bitshift64Lshr(i37 | 0, i17 | 0, 33) | 0;
   i22 = getTempRet0() | 0 | i22;
   i17 = _i64Add((i35 | i25) ^ i37 | 0, i18 ^ i17 | 0, i36 | 0, i19 | 0) | 0;
   i18 = getTempRet0() | 0;
   i37 = i9 + 32 | 0;
   i37 = _i64Add(i36 | 0, i19 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i19 = getTempRet0() | 0;
   i36 = i17 ^ i21;
   i24 = i18 ^ i15;
   i15 = _bitshift64Shl(i37 | 0, i19 | 0, 17) | 0;
   i25 = getTempRet0() | 0;
   i35 = _bitshift64Lshr(i37 | 0, i19 | 0, 47) | 0;
   i25 = getTempRet0() | 0 | i25;
   i19 = _i64Add((i28 | i20) ^ i37 | 0, i22 ^ i19 | 0, i30 | 0, i23 | 0) | 0;
   i22 = getTempRet0() | 0;
   i37 = i9 + 40 | 0;
   i37 = _i64Add(i30 | 0, i23 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i23 = getTempRet0() | 0;
   i30 = i19 ^ i16;
   i21 = i22 ^ i12;
   i12 = _bitshift64Shl(i37 | 0, i23 | 0, 28) | 0;
   i20 = getTempRet0() | 0;
   i28 = _bitshift64Lshr(i37 | 0, i23 | 0, 36) | 0;
   i20 = getTempRet0() | 0 | i20;
   i23 = _i64Add((i35 | i15) ^ i37 | 0, i25 ^ i23 | 0, i36 | 0, i24 | 0) | 0;
   i25 = getTempRet0() | 0;
   i37 = i9 + 48 | 0;
   i37 = _i64Add(i36 | 0, i24 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i24 = getTempRet0() | 0;
   i36 = i23 ^ i13;
   i16 = i25 ^ i7;
   i7 = _bitshift64Shl(i37 | 0, i24 | 0, 39) | 0;
   i15 = getTempRet0() | 0;
   i35 = _bitshift64Lshr(i37 | 0, i24 | 0, 25) | 0;
   i15 = getTempRet0() | 0 | i15;
   i24 = _i64Add((i28 | i12) ^ i37 | 0, i20 ^ i24 | 0, i30 | 0, i21 | 0) | 0;
   i20 = getTempRet0() | 0;
   i37 = i9 + 56 | 0;
   i37 = _i64Add(i30 | 0, i21 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i21 = getTempRet0() | 0;
   i30 = i24 ^ i10;
   i13 = i20 ^ i11;
   i11 = _bitshift64Shl(i37 | 0, i21 | 0, 57) | 0;
   i12 = getTempRet0() | 0;
   i28 = _bitshift64Lshr(i37 | 0, i21 | 0, 7) | 0;
   i12 = getTempRet0() | 0 | i12;
   i21 = _i64Add((i35 | i7) ^ i37 | 0, i15 ^ i21 | 0, i36 | 0, i16 | 0) | 0;
   i15 = getTempRet0() | 0;
   i37 = i9 + 64 | 0;
   i37 = _i64Add(i36 | 0, i16 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i16 = getTempRet0() | 0;
   i36 = i21 ^ i6;
   i10 = i15 ^ i5;
   i5 = _bitshift64Shl(i37 | 0, i16 | 0, 55) | 0;
   i7 = getTempRet0() | 0;
   i35 = _bitshift64Lshr(i37 | 0, i16 | 0, 9) | 0;
   i7 = getTempRet0() | 0 | i7;
   i16 = _i64Add((i28 | i11) ^ i37 | 0, i12 ^ i16 | 0, i30 | 0, i13 | 0) | 0;
   i12 = getTempRet0() | 0;
   i37 = i9 + 72 | 0;
   i37 = _i64Add(i30 | 0, i13 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i13 = getTempRet0() | 0;
   i3 = i16 ^ i3;
   i6 = i12 ^ i1;
   i1 = _bitshift64Shl(i37 | 0, i13 | 0, 54) | 0;
   i11 = getTempRet0() | 0;
   i30 = _bitshift64Lshr(i37 | 0, i13 | 0, 10) | 0;
   i11 = getTempRet0() | 0 | i11;
   i13 = _i64Add((i35 | i5) ^ i37 | 0, i7 ^ i13 | 0, i36 | 0, i10 | 0) | 0;
   i7 = getTempRet0() | 0;
   i37 = i9 + 80 | 0;
   i37 = _i64Add(i36 | 0, i10 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i10 = getTempRet0() | 0;
   i2 = i13 ^ i2;
   i4 = i7 ^ i4;
   i36 = _bitshift64Shl(i37 | 0, i10 | 0, 22) | 0;
   i5 = getTempRet0() | 0;
   i35 = _bitshift64Lshr(i37 | 0, i10 | 0, 42) | 0;
   i5 = getTempRet0() | 0 | i5;
   i10 = _i64Add((i30 | i1) ^ i37 | 0, i11 ^ i10 | 0, i3 | 0, i6 | 0) | 0;
   i11 = getTempRet0() | 0;
   i37 = i9 + 88 | 0;
   i37 = _i64Add(i3 | 0, i6 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0) | 0;
   i6 = getTempRet0() | 0;
   i8 = i10 ^ i8;
   i14 = i11 ^ i14;
   i3 = _bitshift64Shl(i37 | 0, i6 | 0, 46) | 0;
   i1 = getTempRet0() | 0;
   i30 = _bitshift64Lshr(i37 | 0, i6 | 0, 18) | 0;
   i3 = i30 | i3;
   i1 = getTempRet0() | 0 | i1;
   i6 = _i64Add((i35 | i36) ^ i37 | 0, i5 ^ i6 | 0, i2 | 0, i4 | 0) | 0;
   i5 = getTempRet0() | 0;
   i9 = i9 + 96 | 0;
  } while (i9 >>> 0 < i29 >>> 0);
  i9 = i12;
 } else {
  i9 = i28;
  i6 = i12;
 }
 HEAP8[i34 >> 0] = i27;
 _memcpy(i33 | 0, i29 | 0, i26 & 255 | 0) | 0;
 i37 = i31;
 HEAP32[i37 >> 2] = i2;
 HEAP32[i37 + 4 >> 2] = i4;
 i37 = i32;
 HEAP32[i37 >> 2] = i8;
 HEAP32[i37 + 4 >> 2] = i14;
 i37 = i33 + 208 | 0;
 HEAP32[i37 >> 2] = i17;
 HEAP32[i37 + 4 >> 2] = i18;
 i37 = i33 + 216 | 0;
 HEAP32[i37 >> 2] = i19;
 HEAP32[i37 + 4 >> 2] = i22;
 i37 = i33 + 224 | 0;
 HEAP32[i37 >> 2] = i23;
 HEAP32[i37 + 4 >> 2] = i25;
 i37 = i33 + 232 | 0;
 HEAP32[i37 >> 2] = i24;
 HEAP32[i37 + 4 >> 2] = i20;
 i37 = i33 + 240 | 0;
 HEAP32[i37 >> 2] = i21;
 HEAP32[i37 + 4 >> 2] = i15;
 i37 = i33 + 248 | 0;
 HEAP32[i37 >> 2] = i16;
 HEAP32[i37 + 4 >> 2] = i9;
 i37 = i33 + 256 | 0;
 HEAP32[i37 >> 2] = i13;
 HEAP32[i37 + 4 >> 2] = i7;
 i37 = i33 + 264 | 0;
 HEAP32[i37 >> 2] = i10;
 HEAP32[i37 + 4 >> 2] = i11;
 i37 = i33 + 272 | 0;
 HEAP32[i37 >> 2] = i6;
 HEAP32[i37 + 4 >> 2] = i5;
 i37 = i33 + 280 | 0;
 HEAP32[i37 >> 2] = i3;
 HEAP32[i37 + 4 >> 2] = i1;
 return;
}

function __ZN8UVModule6UpdateERK23ParticleSystemParticlesPf(i9, i5, i48) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i48 = i48 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i49 + 48 | 0;
 i42 = i49 + 32 | 0;
 i43 = i49 + 16 | 0;
 i44 = i49;
 if ((HEAP16[gb + 1452292 + 6 >> 1] | 0) > -1) {
  HEAP32[i42 >> 2] = 0;
  HEAP32[i41 >> 2] = HEAP32[i42 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452292 | 0, i41);
  i47 = gb + 1452292 | 0;
 } else i47 = 0;
 f46 = Math_fround(HEAPF32[i9 + 552 >> 2]);
 f2 = Math_fround(HEAP32[i9 + 548 >> 2] | 0);
 L4 : do if ((HEAP32[i9 + 544 >> 2] | 0) == 1) {
  i45 = HEAP32[i5 + 12 >> 2] | 0;
  f40 = Math_fround(HEAP32[i9 + 536 >> 2] | 0);
  f13 = Math_fround(HEAP32[i9 + 540 >> 2] | 0);
  f40 = Math_fround(f40 * Math_fround(Math_fround(1.0) / Math_fround(f40 * f13)));
  if (HEAP8[i9 + 556 >> 0] | 0) {
   if (!i45) break;
   i32 = i5 + 500 | 0;
   i33 = i9 + 272 | 0;
   i34 = i43 + 4 | 0;
   i35 = i43 + 8 | 0;
   i36 = i43 + 12 | 0;
   i37 = i9 + 356 | 0;
   i38 = i9 + 8 | 0;
   i12 = i5 + 520 | 0;
   i14 = i43 + 4 | 0;
   i15 = i43 + 8 | 0;
   i16 = i43 + 12 | 0;
   i17 = i44 + 4 | 0;
   i18 = i44 + 8 | 0;
   i19 = i44 + 12 | 0;
   i20 = i9 + 92 | 0;
   i21 = i42 + 4 | 0;
   i22 = i42 + 8 | 0;
   i23 = i42 + 12 | 0;
   i24 = i41 + 4 | 0;
   i25 = i41 + 8 | 0;
   i26 = i41 + 12 | 0;
   i27 = i9 + 88 | 0;
   i28 = i9 + 240 | 0;
   i29 = i9 + 152 | 0;
   i30 = i9 + 352 | 0;
   i31 = i9 + 504 | 0;
   i4 = i9 + 416 | 0;
   i3 = 0;
   while (1) {
    i11 = (HEAP32[i32 >> 2] | 0) + (i3 << 2) | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i9 = HEAP32[i11 + 4 >> 2] | 0;
    i10 = HEAP32[i11 + 8 >> 2] | 0;
    i11 = HEAP32[i11 + 12 >> 2] | 0;
    HEAP32[i42 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 0;
    HEAP32[i42 + 8 >> 2] = 0;
    HEAP32[i42 + 12 >> 2] = 0;
    i56 = i5 + 1454627760 | 0;
    i54 = i9 + 1454627760 | 0;
    i52 = i10 + 1454627760 | 0;
    i50 = i11 + 1454627760 | 0;
    i55 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i51 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i1 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i56 = i56 << 11 ^ i56;
    i54 = i54 << 11 ^ i54;
    i52 = i52 << 11 ^ i52;
    i50 = i50 << 11 ^ i50;
    f2 = Math_fround(Math_fround((i55 ^ i56 ^ i56 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f6 = Math_fround(Math_fround((i53 ^ i54 ^ i54 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f7 = Math_fround(Math_fround((i51 ^ i52 ^ i52 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f8 = Math_fround(Math_fround((i1 ^ i50 ^ i50 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i43 >> 2] = f2;
    HEAPF32[i34 >> 2] = f6;
    HEAPF32[i35 >> 2] = f7;
    HEAPF32[i36 >> 2] = f8;
    i1 = HEAP32[i37 >> 2] | 0;
    L11 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i56 = HEAP32[i30 >> 2] | 0;
      HEAP32[i26 >> 2] = i56;
      HEAP32[i25 >> 2] = i56;
      HEAP32[i24 >> 2] = i56;
      HEAP32[i41 >> 2] = i56;
      break;
     }
    case 3:
     {
      f58 = Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + 4 >> 2]);
      f57 = Math_fround(HEAPF32[i30 >> 2]);
      f58 = Math_fround(f58 * f57);
      f57 = Math_fround(Math_fround(f57 * Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + 4 >> 2])) - f58);
      f6 = Math_fround(f58 + Math_fround(f57 * f6));
      f7 = Math_fround(f58 + Math_fround(f57 * f7));
      f39 = Math_fround(f58 + Math_fround(f8 * f57));
      HEAPF32[i41 >> 2] = Math_fround(f58 + Math_fround(f2 * f57));
      HEAPF32[i24 >> 2] = f6;
      HEAPF32[i25 >> 2] = f7;
      HEAPF32[i26 >> 2] = f39;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i41, i33, i42, i43);
      break L11;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i41, i33, i42, i43);
      break L11;
     }
    } while (0);
    i50 = (HEAP32[i12 >> 2] | 0) + (i3 << 2) | 0;
    f8 = Math_fround(HEAPF32[i50 >> 2]);
    f7 = Math_fround(HEAPF32[i50 + 4 >> 2]);
    f6 = Math_fround(HEAPF32[i50 + 8 >> 2]);
    f7 = Math_fround(f7 * Math_fround(.00999999977));
    f6 = Math_fround(f6 * Math_fround(.00999999977));
    f2 = Math_fround(Math_fround(HEAPF32[i50 + 12 >> 2]) * Math_fround(.00999999977));
    HEAPF32[i43 >> 2] = Math_fround(f8 * Math_fround(.00999999977));
    HEAPF32[i14 >> 2] = f7;
    HEAPF32[i15 >> 2] = f6;
    HEAPF32[i16 >> 2] = f2;
    i50 = i5 + 326370691 | 0;
    i52 = i9 + 326370691 | 0;
    i54 = i10 + 326370691 | 0;
    i56 = i11 + 326370691 | 0;
    i51 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i55 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i1 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i50 = i50 << 11 ^ i50;
    i52 = i52 << 11 ^ i52;
    i54 = i54 << 11 ^ i54;
    i56 = i56 << 11 ^ i56;
    f2 = Math_fround(Math_fround((i51 ^ i50 ^ i50 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f6 = Math_fround(Math_fround((i53 ^ i52 ^ i52 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f7 = Math_fround(Math_fround((i55 ^ i54 ^ i54 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f8 = Math_fround(Math_fround((i1 ^ i56 ^ i56 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i44 >> 2] = f2;
    HEAPF32[i17 >> 2] = f6;
    HEAPF32[i18 >> 2] = f7;
    HEAPF32[i19 >> 2] = f8;
    i1 = HEAP32[i20 >> 2] | 0;
    L19 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i56 = HEAP32[i27 >> 2] | 0;
      HEAP32[i23 >> 2] = i56;
      HEAP32[i22 >> 2] = i56;
      HEAP32[i21 >> 2] = i56;
      HEAP32[i42 >> 2] = i56;
      break;
     }
    case 3:
     {
      f60 = Math_fround(HEAPF32[(HEAP32[i28 >> 2] | 0) + 4 >> 2]);
      f59 = Math_fround(HEAPF32[i27 >> 2]);
      f60 = Math_fround(f60 * f59);
      f59 = Math_fround(Math_fround(f59 * Math_fround(HEAPF32[(HEAP32[i29 >> 2] | 0) + 4 >> 2])) - f60);
      f39 = Math_fround(f60 + Math_fround(f59 * f6));
      f57 = Math_fround(f60 + Math_fround(f59 * f7));
      f58 = Math_fround(f60 + Math_fround(f8 * f59));
      HEAPF32[i42 >> 2] = Math_fround(f60 + Math_fround(f2 * f59));
      HEAPF32[i21 >> 2] = f39;
      HEAPF32[i22 >> 2] = f57;
      HEAPF32[i23 >> 2] = f58;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i42, i38, i43, i44);
      break L19;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i42, i38, i43, i44);
      break L19;
     }
    } while (0);
    f39 = Math_fround(f46 * Math_fround(HEAPF32[i42 >> 2]));
    f6 = Math_fround(f46 * Math_fround(HEAPF32[i21 >> 2]));
    f7 = Math_fround(f46 * Math_fround(HEAPF32[i22 >> 2]));
    f8 = Math_fround(f46 * Math_fround(HEAPF32[i23 >> 2]));
    f39 = Math_fround(f39 + Math_fround(HEAPF32[i41 >> 2]));
    f6 = Math_fround(f6 + Math_fround(HEAPF32[i24 >> 2]));
    f7 = Math_fround(f7 + Math_fround(HEAPF32[i25 >> 2]));
    f8 = Math_fround(f8 + Math_fround(HEAPF32[i26 >> 2]));
    i5 = i5 + -1353703356 | 0;
    i51 = i9 + -1353703356 | 0;
    i53 = i10 + -1353703356 | 0;
    i55 = i11 + -1353703356 | 0;
    i50 = (Math_imul(i5, 1790253981) | 0) + 1900727103 | 0;
    i52 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
    i54 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
    i56 = (Math_imul(i55, 1790253981) | 0) + 1900727103 | 0;
    i11 = i5 << 11 ^ i5;
    i51 = i51 << 11 ^ i51;
    i53 = i53 << 11 ^ i53;
    i55 = i55 << 11 ^ i55;
    f57 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(Math_fround((i50 ^ i11 ^ i11 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07))))));
    f58 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(Math_fround((i52 ^ i51 ^ i51 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07))))));
    f59 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(Math_fround((i54 ^ i53 ^ i53 >>> 8) & 8388607 ^ i54 >>> 19 | 0) * Math_fround(1.19209304e-07))))));
    f60 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(Math_fround((i56 ^ i55 ^ i55 >>> 8) & 8388607 ^ i56 >>> 19 | 0) * Math_fround(1.19209304e-07))))));
    i56 = i48 + (i3 << 2) | 0;
    f58 = Math_fround(f58 + Math_fround(Math_fround(f6 - Math_fround(Math_floor(Math_fround(f6)))) * Math_fround(Math_fround(f40 + f58) - f58)));
    f59 = Math_fround(f59 + Math_fround(Math_fround(f7 - Math_fround(Math_floor(Math_fround(f7)))) * Math_fround(Math_fround(f40 + f59) - f59)));
    f60 = Math_fround(f60 + Math_fround(Math_fround(f8 - Math_fround(Math_floor(Math_fround(f8)))) * Math_fround(Math_fround(f40 + f60) - f60)));
    HEAPF32[i56 >> 2] = Math_fround(f57 + Math_fround(Math_fround(f39 - Math_fround(Math_floor(Math_fround(f39)))) * Math_fround(Math_fround(f40 + f57) - f57)));
    HEAPF32[i56 + 4 >> 2] = f58;
    HEAPF32[i56 + 8 >> 2] = f59;
    HEAPF32[i56 + 12 >> 2] = f60;
    i3 = i3 + 4 | 0;
    if (i3 >>> 0 >= i45 >>> 0) break L4;
   }
  }
  i37 = i9 + 8 | 0;
  i38 = i9 + 92 | 0;
  if (!(HEAP16[i38 >> 1] | 0)) if (!(HEAP16[i9 + 356 >> 1] | 0)) {
   f60 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(f2 * f40)))));
   f59 = Math_fround(f40 + f60);
   f2 = Math_fround(HEAPF32[i9 + 352 >> 2]);
   f2 = Math_fround(f2 + Math_fround(f46 * Math_fround(HEAPF32[i9 + 88 >> 2])));
   f2 = Math_fround(f60 + Math_fround(Math_fround(f59 - f60) * Math_fround(f2 - Math_fround(Math_floor(Math_fround(f2))))));
   if (!i45) break; else i1 = 0;
   while (1) {
    i56 = i48 + (i1 << 2) | 0;
    HEAPF32[i56 >> 2] = f2;
    HEAPF32[i56 + 4 >> 2] = f2;
    HEAPF32[i56 + 8 >> 2] = f2;
    HEAPF32[i56 + 12 >> 2] = f2;
    i1 = i1 + 4 | 0;
    if (i1 >>> 0 >= i45 >>> 0) break L4;
   }
  }
  f39 = Math_fround(f40 * Math_fround(Math_floor(Math_fround(f13 * Math_fround(f2 * f40)))));
  if (i45 | 0) {
   i31 = i5 + 500 | 0;
   i32 = i9 + 272 | 0;
   i33 = i43 + 4 | 0;
   i34 = i43 + 8 | 0;
   i35 = i43 + 12 | 0;
   i36 = i9 + 356 | 0;
   i18 = i5 + 520 | 0;
   i19 = i43 + 4 | 0;
   i20 = i43 + 8 | 0;
   i21 = i43 + 12 | 0;
   i22 = i44 + 4 | 0;
   i23 = i44 + 8 | 0;
   i24 = i44 + 12 | 0;
   i25 = i42 + 4 | 0;
   i26 = i42 + 8 | 0;
   i27 = i42 + 12 | 0;
   i28 = i41 + 4 | 0;
   i29 = i41 + 8 | 0;
   i30 = i41 + 12 | 0;
   f13 = Math_fround(Math_fround(f40 + f39) - f39);
   i12 = i9 + 88 | 0;
   i14 = i9 + 240 | 0;
   i15 = i9 + 152 | 0;
   i16 = i9 + 352 | 0;
   i17 = i9 + 504 | 0;
   i11 = i9 + 416 | 0;
   i10 = 0;
   while (1) {
    i5 = (HEAP32[i31 >> 2] | 0) + (i10 << 2) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    i4 = HEAP32[i5 + 8 >> 2] | 0;
    i5 = HEAP32[i5 + 12 >> 2] | 0;
    HEAP32[i42 >> 2] = 0;
    HEAP32[i42 + 4 >> 2] = 0;
    HEAP32[i42 + 8 >> 2] = 0;
    HEAP32[i42 + 12 >> 2] = 0;
    i50 = i1 + 1454627760 | 0;
    i52 = i3 + 1454627760 | 0;
    i54 = i4 + 1454627760 | 0;
    i56 = i5 + 1454627760 | 0;
    i51 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i55 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i9 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i50 = i50 << 11 ^ i50;
    i52 = i52 << 11 ^ i52;
    i54 = i54 << 11 ^ i54;
    i56 = i56 << 11 ^ i56;
    f2 = Math_fround(Math_fround((i51 ^ i50 ^ i50 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f6 = Math_fround(Math_fround((i53 ^ i52 ^ i52 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f7 = Math_fround(Math_fround((i55 ^ i54 ^ i54 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f8 = Math_fround(Math_fround((i9 ^ i56 ^ i56 >>> 8) & 8388607 ^ i9 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i43 >> 2] = f2;
    HEAPF32[i33 >> 2] = f6;
    HEAPF32[i34 >> 2] = f7;
    HEAPF32[i35 >> 2] = f8;
    i9 = HEAP32[i36 >> 2] | 0;
    L37 : do switch ((i9 & 65535) << 16 >> 16) {
    case 0:
     {
      i56 = HEAP32[i16 >> 2] | 0;
      HEAP32[i30 >> 2] = i56;
      HEAP32[i29 >> 2] = i56;
      HEAP32[i28 >> 2] = i56;
      HEAP32[i41 >> 2] = i56;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + 4 >> 2]);
      f57 = Math_fround(HEAPF32[i16 >> 2]);
      f40 = Math_fround(f40 * f57);
      f57 = Math_fround(Math_fround(f57 * Math_fround(HEAPF32[(HEAP32[i11 >> 2] | 0) + 4 >> 2])) - f40);
      f58 = Math_fround(f40 + Math_fround(f57 * f6));
      f59 = Math_fround(f40 + Math_fround(f57 * f7));
      f60 = Math_fround(f40 + Math_fround(f8 * f57));
      HEAPF32[i41 >> 2] = Math_fround(f40 + Math_fround(f2 * f57));
      HEAPF32[i28 >> 2] = f58;
      HEAPF32[i29 >> 2] = f59;
      HEAPF32[i30 >> 2] = f60;
      break;
     }
    default:
     if (!(i9 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i41, i32, i42, i43);
      break L37;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i41, i32, i42, i43);
      break L37;
     }
    } while (0);
    i50 = (HEAP32[i18 >> 2] | 0) + (i10 << 2) | 0;
    f8 = Math_fround(HEAPF32[i50 >> 2]);
    f7 = Math_fround(HEAPF32[i50 + 4 >> 2]);
    f6 = Math_fround(HEAPF32[i50 + 8 >> 2]);
    f7 = Math_fround(f7 * Math_fround(.00999999977));
    f6 = Math_fround(f6 * Math_fround(.00999999977));
    f2 = Math_fround(Math_fround(HEAPF32[i50 + 12 >> 2]) * Math_fround(.00999999977));
    HEAPF32[i43 >> 2] = Math_fround(f8 * Math_fround(.00999999977));
    HEAPF32[i19 >> 2] = f7;
    HEAPF32[i20 >> 2] = f6;
    HEAPF32[i21 >> 2] = f2;
    i50 = i1 + 326370691 | 0;
    i52 = i3 + 326370691 | 0;
    i54 = i4 + 326370691 | 0;
    i56 = i5 + 326370691 | 0;
    i51 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
    i53 = (Math_imul(i52, 1790253981) | 0) + 1900727103 | 0;
    i55 = (Math_imul(i54, 1790253981) | 0) + 1900727103 | 0;
    i1 = (Math_imul(i56, 1790253981) | 0) + 1900727103 | 0;
    i50 = i50 << 11 ^ i50;
    i52 = i52 << 11 ^ i52;
    i54 = i54 << 11 ^ i54;
    i56 = i56 << 11 ^ i56;
    f2 = Math_fround(Math_fround((i51 ^ i50 ^ i50 >>> 8) & 8388607 ^ i51 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f6 = Math_fround(Math_fround((i53 ^ i52 ^ i52 >>> 8) & 8388607 ^ i53 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f7 = Math_fround(Math_fround((i55 ^ i54 ^ i54 >>> 8) & 8388607 ^ i55 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f8 = Math_fround(Math_fround((i1 ^ i56 ^ i56 >>> 8) & 8388607 ^ i1 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i44 >> 2] = f2;
    HEAPF32[i22 >> 2] = f6;
    HEAPF32[i23 >> 2] = f7;
    HEAPF32[i24 >> 2] = f8;
    i1 = HEAP32[i38 >> 2] | 0;
    L45 : do switch ((i1 & 65535) << 16 >> 16) {
    case 0:
     {
      i56 = HEAP32[i12 >> 2] | 0;
      HEAP32[i27 >> 2] = i56;
      HEAP32[i26 >> 2] = i56;
      HEAP32[i25 >> 2] = i56;
      HEAP32[i42 >> 2] = i56;
      break;
     }
    case 3:
     {
      f40 = Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 4 >> 2]);
      f57 = Math_fround(HEAPF32[i12 >> 2]);
      f40 = Math_fround(f40 * f57);
      f57 = Math_fround(Math_fround(f57 * Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2])) - f40);
      f58 = Math_fround(f40 + Math_fround(f57 * f6));
      f59 = Math_fround(f40 + Math_fround(f57 * f7));
      f60 = Math_fround(f40 + Math_fround(f8 * f57));
      HEAPF32[i42 >> 2] = Math_fround(f40 + Math_fround(f2 * f57));
      HEAPF32[i25 >> 2] = f58;
      HEAPF32[i26 >> 2] = f59;
      HEAPF32[i27 >> 2] = f60;
      break;
     }
    default:
     if (!(i1 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i42, i37, i43, i44);
      break L45;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i42, i37, i43, i44);
      break L45;
     }
    } while (0);
    f57 = Math_fround(f46 * Math_fround(HEAPF32[i42 >> 2]));
    f58 = Math_fround(f46 * Math_fround(HEAPF32[i25 >> 2]));
    f59 = Math_fround(f46 * Math_fround(HEAPF32[i26 >> 2]));
    f60 = Math_fround(f46 * Math_fround(HEAPF32[i27 >> 2]));
    f57 = Math_fround(f57 + Math_fround(HEAPF32[i41 >> 2]));
    f58 = Math_fround(f58 + Math_fround(HEAPF32[i28 >> 2]));
    f59 = Math_fround(f59 + Math_fround(HEAPF32[i29 >> 2]));
    f60 = Math_fround(f60 + Math_fround(HEAPF32[i30 >> 2]));
    i56 = i48 + (i10 << 2) | 0;
    f58 = Math_fround(f39 + Math_fround(f13 * Math_fround(f58 - Math_fround(Math_floor(Math_fround(f58))))));
    f59 = Math_fround(f39 + Math_fround(f13 * Math_fround(f59 - Math_fround(Math_floor(Math_fround(f59))))));
    f60 = Math_fround(f39 + Math_fround(f13 * Math_fround(f60 - Math_fround(Math_floor(Math_fround(f60))))));
    HEAPF32[i56 >> 2] = Math_fround(f39 + Math_fround(f13 * Math_fround(f57 - Math_fround(Math_floor(Math_fround(f57))))));
    HEAPF32[i56 + 4 >> 2] = f58;
    HEAPF32[i56 + 8 >> 2] = f59;
    HEAPF32[i56 + 12 >> 2] = f60;
    i10 = i10 + 4 | 0;
    if (i10 >>> 0 >= i45 >>> 0) break L4;
   }
  }
 } else {
  i3 = i9 + 8 | 0;
  i1 = HEAP32[i9 + 92 >> 2] | 0;
  i4 = i1 & 65535;
  if (!(i4 << 16 >> 16)) {
   __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode0EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f46, i3, i9 + 272 | 0, i5, i48);
   break;
  }
  if (!(i1 & 16711680)) {
   __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode3EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f46, i3, i9 + 272 | 0, i5, i48);
   break;
  }
  i1 = i9 + 272 | 0;
  if ((i4 | 1) << 16 >> 16 == 3) {
   __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode2EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f46, i3, i1, i5, i48);
   break;
  } else {
   __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode1EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f46, i3, i1, i5, i48);
   break;
  }
 } while (0);
 if (!i47) {
  STACKTOP = i49;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i47);
 STACKTOP = i49;
 return;
}

function _cf2_interpT2CharString(i35, i3, i38, i40, i30, i1, i2, i31) {
 i35 = i35 | 0;
 i3 = i3 | 0;
 i38 = i38 | 0;
 i40 = i40 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 15824 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i46 + 15780 | 0;
 i34 = i46 + 15776 | 0;
 i42 = i46 + 15784 | 0;
 i29 = i46 + 15816 | 0;
 i43 = i46 + 15744 | 0;
 i44 = i46 + 15712 | 0;
 i26 = i46 + 15680 | 0;
 i45 = i46 + 3896 | 0;
 i36 = i46 + 28 | 0;
 i37 = i46;
 HEAP32[i33 >> 2] = i1;
 HEAP32[i34 >> 2] = i2;
 i27 = i35 + 132 | 0;
 i32 = HEAP32[i27 >> 2] | 0;
 i41 = i35 + 4 | 0;
 i39 = HEAP32[i35 >> 2] | 0;
 i24 = HEAP32[i35 + 48 >> 2] | 0;
 i28 = _cf2_getNominalWidthX(i32) | 0;
 _cf2_arrstack_init(i42, i39, i41, 16);
 _cf2_arrstack_init(i43, i39, i41, 20);
 _cf2_arrstack_init(i44, i39, i41, 20);
 i25 = i26 + 4 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAP32[i25 + 16 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP32[i26 >> 2] = i41;
 _cf2_glyphpath_init(i45, i35, i38, i24, i43, i44, i26, i2, i35 + 196 | 0, i40);
 HEAP8[i29 >> 0] = 0;
 HEAP32[i31 >> 2] = _cf2_getDefaultWidthX(i32) | 0;
 i39 = _cf2_stack_init(i39, i41) | 0;
 if (!i39) {
  i40 = 64;
  _cf2_setError(i41, i40);
  _cf2_glyphpath_finalize(i45);
  _cf2_arrstack_finalize(i44);
  _cf2_arrstack_finalize(i43);
  _cf2_arrstack_finalize(i42);
  _cf2_stack_free(i39);
  STACKTOP = i46;
  return;
 }
 _cf2_arrstack_setCount(i42, 17);
 i1 = _cf2_arrstack_getBuffer(i42) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (HEAP32[i41 >> 2] | 0) {
  i40 = 0;
  _cf2_setError(i41, i40);
  _cf2_glyphpath_finalize(i45);
  _cf2_arrstack_finalize(i44);
  _cf2_arrstack_finalize(i43);
  _cf2_arrstack_finalize(i42);
  _cf2_stack_free(i39);
  STACKTOP = i46;
  return;
 }
 i15 = i26 + 8 | 0;
 i16 = i26 + 12 | 0;
 i17 = i26 + 5 | 0;
 i18 = i45 + 7744 | 0;
 i19 = i45 + 11612 | 0;
 i20 = i37 + 4 | 0;
 i21 = i37 + 8 | 0;
 i22 = i37 + 12 | 0;
 i23 = i37 + 5 | 0;
 i3 = 2e7;
 i4 = 0;
 L7 : while (1) {
  if (!((_cf2_buf_isEnd(i1) | 0) << 24 >> 24)) i2 = _cf2_buf_readByte(i1) | 0; else i2 = (i4 | 0) == 0 ? 14 : 11;
  if (HEAP32[i41 >> 2] | 0) {
   i1 = 0;
   i2 = 110;
   break;
  }
  i14 = i3 + -1 | 0;
  if (!i14) {
   i1 = 18;
   i2 = 110;
   break;
  }
  i8 = i2 & 255;
  L15 : do switch ((i2 & 255) << 24 >> 24) {
  case 14:
   {
    i2 = 44;
    break L7;
   }
  case 17:
  case 16:
  case 15:
  case 13:
  case 9:
  case 2:
  case 0:
   break;
  case 1:
  case 18:
   {
    if (!(HEAP8[i25 >> 0] | 0)) {
     _cf2_doStems(i35, i39, i43, i31, i29);
     if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
      i1 = 0;
      i2 = 110;
      break L7;
     }
    }
    break;
   }
  case 3:
  case 23:
   {
    if (!(HEAP8[i25 >> 0] | 0)) {
     _cf2_doStems(i35, i39, i44, i31, i29);
     if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
      i1 = 0;
      i2 = 110;
      break L7;
     }
    }
    break;
   }
  case 4:
   {
    if (!((_cf2_stack_count(i39) | 0) >>> 0 < 2 | (HEAP8[i29 >> 0] | 0) != 0)) HEAP32[i31 >> 2] = (_cf2_stack_getReal(i39, 0) | 0) + i28;
    HEAP8[i29 >> 0] = 1;
    if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
     i1 = 0;
     i2 = 110;
     break L7;
    }
    i13 = (_cf2_stack_popFixed(i39) | 0) + (HEAP32[i34 >> 2] | 0) | 0;
    HEAP32[i34 >> 2] = i13;
    _cf2_glyphpath_moveTo(i45, HEAP32[i33 >> 2] | 0, i13);
    break;
   }
  case 5:
   {
    i3 = _cf2_stack_count(i39) | 0;
    if (i3 | 0) {
     i2 = 0;
     do {
      i13 = _cf2_stack_getReal(i39, i2) | 0;
      HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i13;
      i13 = _cf2_stack_getReal(i39, i2 | 1) | 0;
      i13 = (HEAP32[i34 >> 2] | 0) + i13 | 0;
      HEAP32[i34 >> 2] = i13;
      _cf2_glyphpath_lineTo(i45, HEAP32[i33 >> 2] | 0, i13);
      i2 = i2 + 2 | 0;
     } while (i2 >>> 0 < i3 >>> 0);
    }
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 7:
  case 6:
   {
    i7 = _cf2_stack_count(i39) | 0;
    if (i7 | 0) {
     i6 = 0;
     i5 = (i8 | 0) == 6;
     while (1) {
      i2 = _cf2_stack_getReal(i39, i6) | 0;
      if (i5) {
       i2 = (HEAP32[i33 >> 2] | 0) + i2 | 0;
       HEAP32[i33 >> 2] = i2;
       i3 = HEAP32[i34 >> 2] | 0;
      } else {
       i3 = (HEAP32[i34 >> 2] | 0) + i2 | 0;
       HEAP32[i34 >> 2] = i3;
       i2 = HEAP32[i33 >> 2] | 0;
      }
      _cf2_glyphpath_lineTo(i45, i2, i3);
      i6 = i6 + 1 | 0;
      if ((i6 | 0) == (i7 | 0)) break; else i5 = i5 ^ 1;
     }
    }
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 8:
  case 24:
   {
    i5 = _cf2_stack_count(i39) | 0;
    if (i5 >>> 0 < 6) i2 = 0; else {
     i3 = 0;
     i2 = 6;
     while (1) {
      i9 = _cf2_stack_getReal(i39, i3) | 0;
      i9 = (HEAP32[i33 >> 2] | 0) + i9 | 0;
      i10 = _cf2_stack_getReal(i39, i3 | 1) | 0;
      i10 = (HEAP32[i34 >> 2] | 0) + i10 | 0;
      i11 = (_cf2_stack_getReal(i39, i3 + 2 | 0) | 0) + i9 | 0;
      i12 = (_cf2_stack_getReal(i39, i3 + 3 | 0) | 0) + i10 | 0;
      i13 = (_cf2_stack_getReal(i39, i3 + 4 | 0) | 0) + i11 | 0;
      i3 = (_cf2_stack_getReal(i39, i3 + 5 | 0) | 0) + i12 | 0;
      _cf2_glyphpath_curveTo(i45, i9, i10, i11, i12, i13, i3);
      HEAP32[i33 >> 2] = i13;
      HEAP32[i34 >> 2] = i3;
      i3 = i2 + 6 | 0;
      if (i3 >>> 0 > i5 >>> 0) break; else {
       i13 = i2;
       i2 = i3;
       i3 = i13;
      }
     }
    }
    if ((i8 | 0) == 24) {
     i13 = _cf2_stack_getReal(i39, i2) | 0;
     HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i13;
     i13 = _cf2_stack_getReal(i39, i2 | 1) | 0;
     i13 = (HEAP32[i34 >> 2] | 0) + i13 | 0;
     HEAP32[i34 >> 2] = i13;
     _cf2_glyphpath_lineTo(i45, HEAP32[i33 >> 2] | 0, i13);
    }
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 10:
  case 29:
   {
    if ((i4 | 0) > 16) {
     i1 = 18;
     i2 = 110;
     break L7;
    }
    i4 = i4 + 1 | 0;
    i1 = _cf2_arrstack_getPointer(i42, i4) | 0;
    i2 = _cf2_stack_popInt(i39) | 0;
    if ((i8 | 0) == 29) if (!(_cf2_initGlobalRegionBuffer(i32, i2, i1) | 0)) {
     i3 = i14;
     continue L7;
    } else {
     i1 = 18;
     i2 = 110;
     break L7;
    } else if (!(_cf2_initLocalRegionBuffer(i32, i2, i1) | 0)) {
     i3 = i14;
     continue L7;
    } else {
     i1 = 18;
     i2 = 110;
     break L7;
    }
   }
  case 11:
   {
    if ((i4 | 0) < 1) {
     i1 = 18;
     i2 = 110;
     break L7;
    }
    i13 = i4 + -1 | 0;
    i3 = i14;
    i1 = _cf2_arrstack_getPointer(i42, i13) | 0;
    i4 = i13;
    continue L7;
   }
  case 12:
   switch (((_cf2_buf_readByte(i1) | 0) & 255) << 24 >> 24) {
   case 37:
    {
     _cf2_doFlex(i39, i33, i34, i45, gb + 1006949 | 0, 1);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
   case 36:
    {
     _cf2_doFlex(i39, i33, i34, i45, gb + 1006937 | 0, 0);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
   case 35:
    {
     _cf2_doFlex(i39, i33, i34, i45, gb + 1006925 | 0, 0);
     break L15;
    }
   case 34:
    {
     _cf2_doFlex(i39, i33, i34, i45, gb + 1006913 | 0, 0);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
   default:
    break L15;
   }
  case 19:
  case 20:
   {
    i13 = (_cf2_stack_count(i39) | 0) >>> 0 < 2;
    if (i13 | (HEAP8[i25 >> 0] | 0) == 0) {
     _cf2_doStems(i35, i39, i44, i31, i29);
     if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
      i1 = 0;
      i2 = 110;
      break L7;
     }
     if ((i8 | 0) == 19) {
      i2 = _cf2_arrstack_size(i43) | 0;
      i2 = (_cf2_arrstack_size(i44) | 0) + i2 | 0;
      if (i2 >>> 0 > 96) {
       _cf2_setError(HEAP32[i26 >> 2] | 0, 18);
       break L15;
      }
      HEAP32[i15 >> 2] = i2;
      i13 = (i2 + 7 | 0) >>> 3;
      HEAP32[i16 >> 2] = i13;
      HEAP8[i25 >> 0] = 1;
      HEAP8[i17 >> 0] = 1;
      if ((i2 | 0) == 0 | (i13 | 0) == 0) break L15; else i2 = 0;
      while (1) {
       HEAP8[i26 + 16 + i2 >> 0] = _cf2_buf_readByte(i1) | 0;
       i2 = i2 + 1 | 0;
       if (i2 >>> 0 >= (HEAP32[i16 >> 2] | 0) >>> 0) break L15;
      }
     }
     _cf2_hintmap_init(i36, i35, i18, i19, i24);
     HEAP32[i20 >> 2] = 0;
     HEAP32[i20 + 4 >> 2] = 0;
     HEAP32[i20 + 8 >> 2] = 0;
     HEAP32[i20 + 12 >> 2] = 0;
     HEAP32[i20 + 16 >> 2] = 0;
     HEAP32[i20 + 20 >> 2] = 0;
     HEAP32[i37 >> 2] = i41;
     i2 = _cf2_arrstack_size(i43) | 0;
     i2 = (_cf2_arrstack_size(i44) | 0) + i2 | 0;
     if (i2 >>> 0 > 96) _cf2_setError(HEAP32[i37 >> 2] | 0, 18); else {
      HEAP32[i21 >> 2] = i2;
      i13 = (i2 + 7 | 0) >>> 3;
      HEAP32[i22 >> 2] = i13;
      HEAP8[i20 >> 0] = 1;
      HEAP8[i23 >> 0] = 1;
      if (!((i2 | 0) == 0 | (i13 | 0) == 0)) {
       i2 = 0;
       do {
        HEAP8[i37 + 16 + i2 >> 0] = _cf2_buf_readByte(i1) | 0;
        i2 = i2 + 1 | 0;
       } while (i2 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
      }
     }
     _cf2_hintmap_build(i36, i43, i44, i37, 0, 0);
    }
    break;
   }
  case 21:
   {
    i13 = (_cf2_stack_count(i39) | 0) >>> 0 < 3;
    if (!(i13 | (HEAP8[i29 >> 0] | 0) != 0)) HEAP32[i31 >> 2] = (_cf2_stack_getReal(i39, 0) | 0) + i28;
    HEAP8[i29 >> 0] = 1;
    if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
     i1 = 0;
     i2 = 110;
     break L7;
    }
    i13 = _cf2_stack_popFixed(i39) | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i13;
    i13 = _cf2_stack_popFixed(i39) | 0;
    i13 = (HEAP32[i33 >> 2] | 0) + i13 | 0;
    HEAP32[i33 >> 2] = i13;
    _cf2_glyphpath_moveTo(i45, i13, HEAP32[i34 >> 2] | 0);
    break;
   }
  case 22:
   {
    i13 = (_cf2_stack_count(i39) | 0) >>> 0 < 2;
    if (!(i13 | (HEAP8[i29 >> 0] | 0) != 0)) HEAP32[i31 >> 2] = (_cf2_stack_getReal(i39, 0) | 0) + i28;
    HEAP8[i29 >> 0] = 1;
    if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
     i1 = 0;
     i2 = 110;
     break L7;
    }
    i13 = _cf2_stack_popFixed(i39) | 0;
    i13 = (HEAP32[i33 >> 2] | 0) + i13 | 0;
    HEAP32[i33 >> 2] = i13;
    _cf2_glyphpath_moveTo(i45, i13, HEAP32[i34 >> 2] | 0);
    break;
   }
  case 25:
   {
    i5 = _cf2_stack_count(i39) | 0;
    if (i5 >>> 0 > 6) {
     i3 = 0;
     while (1) {
      i2 = _cf2_stack_getReal(i39, i3) | 0;
      HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + i2;
      i2 = _cf2_stack_getReal(i39, i3 | 1) | 0;
      i2 = (HEAP32[i34 >> 2] | 0) + i2 | 0;
      HEAP32[i34 >> 2] = i2;
      _cf2_glyphpath_lineTo(i45, HEAP32[i33 >> 2] | 0, i2);
      i2 = i3 + 2 | 0;
      if ((i3 + 8 | 0) >>> 0 < i5 >>> 0) i3 = i2; else break;
     }
    } else i2 = 0;
    if (i2 >>> 0 < i5 >>> 0) do {
     i8 = _cf2_stack_getReal(i39, i2) | 0;
     i8 = (HEAP32[i33 >> 2] | 0) + i8 | 0;
     i9 = _cf2_stack_getReal(i39, i2 | 1) | 0;
     i9 = (HEAP32[i34 >> 2] | 0) + i9 | 0;
     i10 = (_cf2_stack_getReal(i39, i2 + 2 | 0) | 0) + i8 | 0;
     i11 = (_cf2_stack_getReal(i39, i2 + 3 | 0) | 0) + i9 | 0;
     i12 = (_cf2_stack_getReal(i39, i2 + 4 | 0) | 0) + i10 | 0;
     i13 = (_cf2_stack_getReal(i39, i2 + 5 | 0) | 0) + i11 | 0;
     _cf2_glyphpath_curveTo(i45, i8, i9, i10, i11, i12, i13);
     HEAP32[i33 >> 2] = i12;
     HEAP32[i34 >> 2] = i13;
     i2 = i2 + 6 | 0;
    } while (i2 >>> 0 < i5 >>> 0);
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 26:
   {
    i5 = _cf2_stack_count(i39) | 0;
    i6 = i5 & -3;
    i2 = i5 - i6 | 0;
    if (i6 >>> 0 > i2 >>> 0) do {
     if (!(i5 - i2 & 1)) i3 = HEAP32[i33 >> 2] | 0; else {
      i3 = _cf2_stack_getReal(i39, i2) | 0;
      i3 = (HEAP32[i33 >> 2] | 0) + i3 | 0;
      i2 = i2 + 1 | 0;
     }
     i10 = _cf2_stack_getReal(i39, i2) | 0;
     i10 = (HEAP32[i34 >> 2] | 0) + i10 | 0;
     i12 = (_cf2_stack_getReal(i39, i2 + 1 | 0) | 0) + i3 | 0;
     i11 = (_cf2_stack_getReal(i39, i2 + 2 | 0) | 0) + i10 | 0;
     i13 = (_cf2_stack_getReal(i39, i2 + 3 | 0) | 0) + i11 | 0;
     _cf2_glyphpath_curveTo(i45, i3, i10, i12, i11, i12, i13);
     HEAP32[i33 >> 2] = i12;
     HEAP32[i34 >> 2] = i13;
     i2 = i2 + 4 | 0;
    } while (i6 >>> 0 > i2 >>> 0);
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 27:
   {
    i5 = _cf2_stack_count(i39) | 0;
    i6 = i5 & -3;
    i2 = i5 - i6 | 0;
    if (i6 >>> 0 > i2 >>> 0) do {
     if (!(i5 - i2 & 1)) i3 = HEAP32[i34 >> 2] | 0; else {
      i3 = _cf2_stack_getReal(i39, i2) | 0;
      i3 = (HEAP32[i34 >> 2] | 0) + i3 | 0;
      i2 = i2 + 1 | 0;
     }
     i10 = _cf2_stack_getReal(i39, i2) | 0;
     i10 = (HEAP32[i33 >> 2] | 0) + i10 | 0;
     i11 = (_cf2_stack_getReal(i39, i2 + 1 | 0) | 0) + i10 | 0;
     i13 = (_cf2_stack_getReal(i39, i2 + 2 | 0) | 0) + i3 | 0;
     i12 = (_cf2_stack_getReal(i39, i2 + 3 | 0) | 0) + i11 | 0;
     _cf2_glyphpath_curveTo(i45, i10, i3, i11, i13, i12, i13);
     HEAP32[i33 >> 2] = i12;
     HEAP32[i34 >> 2] = i13;
     i2 = i2 + 4 | 0;
    } while (i6 >>> 0 > i2 >>> 0);
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 31:
  case 30:
   {
    i3 = _cf2_stack_count(i39) | 0;
    i13 = i3 & -3;
    i3 = i3 - i13 | 0;
    if (i13 >>> 0 > i3 >>> 0) {
     i2 = (i8 | 0) == 31 & 1;
     do {
      if (!(i2 << 24 >> 24)) {
       i6 = HEAP32[i33 >> 2] | 0;
       i5 = _cf2_stack_getReal(i39, i3) | 0;
       i5 = (HEAP32[i34 >> 2] | 0) + i5 | 0;
       i10 = i3 + 1 | 0;
       i2 = (_cf2_stack_getReal(i39, i10) | 0) + i6 | 0;
       i8 = (_cf2_stack_getReal(i39, i3 + 2 | 0) | 0) + i5 | 0;
       i7 = (_cf2_stack_getReal(i39, i3 + 3 | 0) | 0) + i2 | 0;
       if ((i13 - i3 | 0) == 5) {
        i12 = i8;
        i11 = i2;
        i9 = (_cf2_stack_getReal(i39, i3 + 4 | 0) | 0) + i8 | 0;
        i2 = 1;
        i3 = i10;
       } else {
        i12 = i8;
        i11 = i2;
        i9 = i8;
        i2 = 1;
       }
      } else {
       i6 = _cf2_stack_getReal(i39, i3) | 0;
       i6 = (HEAP32[i33 >> 2] | 0) + i6 | 0;
       i5 = HEAP32[i34 >> 2] | 0;
       i10 = i3 + 1 | 0;
       i8 = (_cf2_stack_getReal(i39, i10) | 0) + i6 | 0;
       i2 = (_cf2_stack_getReal(i39, i3 + 2 | 0) | 0) + i5 | 0;
       i7 = (_cf2_stack_getReal(i39, i3 + 3 | 0) | 0) + i2 | 0;
       if ((i13 - i3 | 0) == 5) {
        i12 = i2;
        i11 = i8;
        i9 = i7;
        i7 = (_cf2_stack_getReal(i39, i3 + 4 | 0) | 0) + i8 | 0;
        i2 = 0;
        i3 = i10;
       } else {
        i12 = i2;
        i11 = i8;
        i9 = i7;
        i7 = i8;
        i2 = 0;
       }
      }
      _cf2_glyphpath_curveTo(i45, i6, i5, i11, i12, i7, i9);
      HEAP32[i33 >> 2] = i7;
      HEAP32[i34 >> 2] = i9;
      i3 = i3 + 4 | 0;
     } while (i13 >>> 0 > i3 >>> 0);
    }
    _cf2_stack_clear(i39);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  case 28:
   {
    i12 = _cf2_buf_readByte(i1) | 0;
    _cf2_stack_pushInt(i39, (i12 << 8 | (_cf2_buf_readByte(i1) | 0)) << 16 >> 16);
    i12 = i4;
    i13 = i1;
    i3 = i14;
    i4 = i12;
    i1 = i13;
    continue L7;
   }
  default:
   {
    if (i8 >>> 0 < 247) {
     _cf2_stack_pushInt(i39, i8 + -139 | 0);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
    if (i8 >>> 0 < 251) {
     _cf2_stack_pushInt(i39, (i8 << 8) + -63124 + (_cf2_buf_readByte(i1) | 0) | 0);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
    i2 = _cf2_buf_readByte(i1) | 0;
    if ((i8 | 0) == 255) {
     i13 = _cf2_buf_readByte(i1) | 0;
     i12 = _cf2_buf_readByte(i1) | 0;
     _cf2_stack_pushFixed(i39, i13 << 16 | i2 << 24 | i12 << 8 | (_cf2_buf_readByte(i1) | 0));
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    } else {
     _cf2_stack_pushInt(i39, (Math_imul(i8, -256) | 0) + 64148 - i2 | 0);
     i12 = i4;
     i13 = i1;
     i3 = i14;
     i4 = i12;
     i1 = i13;
     continue L7;
    }
   }
  } while (0);
  _cf2_stack_clear(i39);
  i12 = i4;
  i13 = i1;
  i3 = i14;
  i4 = i12;
  i1 = i13;
 }
 if ((i2 | 0) == 44) {
  if ((_cf2_stack_count(i39) | 0) == 1) {
   if (!(HEAP8[i29 >> 0] | 0)) i2 = 47;
  } else {
   i26 = (_cf2_stack_count(i39) | 0) != 5;
   if (!(i26 | (HEAP8[i29 >> 0] | 0) != 0)) i2 = 47;
  }
  if ((i2 | 0) == 47) HEAP32[i31 >> 2] = (_cf2_stack_getReal(i39, 0) | 0) + i28;
  HEAP8[i29 >> 0] = 1;
  if (HEAP8[(HEAP32[i27 >> 2] | 0) + 561 >> 0] | 0) {
   i40 = 0;
   _cf2_setError(i41, i40);
   _cf2_glyphpath_finalize(i45);
   _cf2_arrstack_finalize(i44);
   _cf2_arrstack_finalize(i43);
   _cf2_arrstack_finalize(i42);
   _cf2_stack_free(i39);
   STACKTOP = i46;
   return;
  }
  _cf2_glyphpath_closeOpenPath(i45);
  if ((_cf2_stack_count(i39) | 0) >>> 0 <= 1) {
   i40 = 0;
   _cf2_setError(i41, i40);
   _cf2_glyphpath_finalize(i45);
   _cf2_arrstack_finalize(i44);
   _cf2_arrstack_finalize(i43);
   _cf2_arrstack_finalize(i42);
   _cf2_stack_free(i39);
   STACKTOP = i46;
   return;
  }
  if (!(i30 << 24 >> 24)) {
   i1 = _cf2_stack_popInt(i39) | 0;
   i2 = _cf2_stack_popInt(i39) | 0;
   HEAP32[i34 >> 2] = _cf2_stack_popFixed(i39) | 0;
   HEAP32[i33 >> 2] = _cf2_stack_popFixed(i39) | 0;
   i1 = _cf2_getSeacComponent(i32, i1, i36) | 0;
   if (!i1) {
    _cf2_interpT2CharString(i35, i36, i38, i40, 1, HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0, i37);
    _cf2_freeSeacComponent(i32, i36);
    i1 = _cf2_getSeacComponent(i32, i2, i36) | 0;
    if (!i1) {
     _cf2_interpT2CharString(i35, i36, i38, i40, 1, 0, 0, i37);
     _cf2_freeSeacComponent(i32, i36);
     i1 = 0;
    }
   }
  } else i1 = 18;
  i40 = i1;
  _cf2_setError(i41, i40);
  _cf2_glyphpath_finalize(i45);
  _cf2_arrstack_finalize(i44);
  _cf2_arrstack_finalize(i43);
  _cf2_arrstack_finalize(i42);
  _cf2_stack_free(i39);
  STACKTOP = i46;
  return;
 } else if ((i2 | 0) == 110) {
  _cf2_setError(i41, i1);
  _cf2_glyphpath_finalize(i45);
  _cf2_arrstack_finalize(i44);
  _cf2_arrstack_finalize(i43);
  _cf2_arrstack_finalize(i42);
  _cf2_stack_free(i39);
  STACKTOP = i46;
  return;
 }
}

function __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 116 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 124 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 128 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 132 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 148 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 152 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 156 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 164 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 168 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 172 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 176 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 180 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 184 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 188 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 192 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 196 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 200 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 204 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 208 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 212 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 216 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 220 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i105, i92, i1, i94, i93, i107, i108, i106, f2) {
 i105 = i105 | 0;
 i92 = i92 | 0;
 i1 = i1 | 0;
 i94 = i94 | 0;
 i93 = i93 | 0;
 i107 = i107 | 0;
 i108 = i108 | 0;
 i106 = i106 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f95 = f0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i109 = 0, f110 = f0;
 i109 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i104 = i109 + 288 | 0;
 i99 = i109 + 384 | 0;
 i103 = i109 + 380 | 0;
 i87 = i109 + 144 | 0;
 i70 = i109 + 128 | 0;
 i98 = i109 + 304 | 0;
 i96 = i109 + 224 | 0;
 i97 = i109 + 160 | 0;
 i72 = i109 + 112 | 0;
 i73 = i109 + 96 | 0;
 i71 = i109 + 368 | 0;
 i76 = i109 + 80 | 0;
 i77 = i109 + 64 | 0;
 i78 = i109 + 48 | 0;
 i102 = i109 + 32 | 0;
 i100 = i109 + 16 | 0;
 i101 = i109;
 HEAP32[i104 >> 2] = 0;
 HEAP32[i104 + 4 >> 2] = 0;
 HEAP32[i104 + 8 >> 2] = 0;
 HEAP32[i104 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i93 >> 2]);
 i82 = i93 + 4 | 0;
 f8 = Math_fround(HEAPF32[i82 >> 2]);
 i86 = i93 + 8 | 0;
 f13 = Math_fround(HEAPF32[i86 >> 2]);
 f4 = Math_fround(HEAPF32[i94 >> 2]);
 i74 = i94 + 4 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 i75 = i94 + 8 | 0;
 f9 = Math_fround(HEAPF32[i75 >> 2]);
 HEAP32[i103 >> 2] = 1;
 f15 = Math_fround(HEAPF32[i105 >> 2]);
 f16 = Math_fround(HEAPF32[i105 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i105 + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i92 >> 2]);
 f31 = Math_fround(HEAPF32[i92 + 4 >> 2]);
 f30 = Math_fround(f15 - f30);
 f31 = Math_fround(f16 - f31);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i92 + 8 >> 2]));
 i79 = Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) + Math_fround(f6 * f6)) > Math_fround(1.1920929e-07);
 f30 = i79 ? f30 : Math_fround(1.0);
 f31 = i79 ? f31 : Math_fround(0.0);
 f6 = i79 ? f6 : Math_fround(0.0);
 f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31))))));
 f30 = Math_fround(f16 * f30);
 f31 = Math_fround(f16 * f31);
 f6 = Math_fround(f16 * f6);
 HEAPF32[i87 >> 2] = f30;
 HEAPF32[i87 + 4 >> 2] = f31;
 HEAPF32[i87 + 8 >> 2] = f6;
 HEAPF32[i87 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(-f30);
 f31 = Math_fround(-f31);
 f6 = Math_fround(-f6);
 i79 = i105 + 96 | 0;
 f16 = Math_fround(HEAPF32[i79 >> 2]);
 i80 = i105 + 100 | 0;
 f15 = Math_fround(HEAPF32[i80 >> 2]);
 i81 = i105 + 104 | 0;
 f14 = Math_fround(HEAPF32[i81 >> 2]);
 f29 = Math_fround(Math_fround(Math_fround(f16 * f30) + Math_fround(f15 * f31)) + Math_fround(f14 * f6));
 i83 = i105 + 112 | 0;
 f33 = Math_fround(HEAPF32[i83 >> 2]);
 i84 = i105 + 116 | 0;
 f32 = Math_fround(HEAPF32[i84 >> 2]);
 i85 = i105 + 120 | 0;
 f95 = Math_fround(HEAPF32[i85 >> 2]);
 i88 = f29 > Math_fround(Math_fround(Math_fround(f33 * f30) + Math_fround(f32 * f31)) + Math_fround(f95 * f6));
 f33 = i88 ? f16 : f33;
 f32 = i88 ? f15 : f32;
 f95 = i88 ? f14 : f95;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i70, i92, i87);
 f14 = Math_fround(HEAPF32[i70 >> 2]);
 f15 = Math_fround(HEAPF32[i70 + 4 >> 2]);
 f14 = Math_fround(f33 - f14);
 f15 = Math_fround(f32 - f15);
 f16 = Math_fround(f95 - Math_fround(HEAPF32[i70 + 8 >> 2]));
 HEAPF32[i98 >> 2] = f14;
 i87 = i98 + 4 | 0;
 HEAPF32[i87 >> 2] = f15;
 i88 = i98 + 8 | 0;
 HEAPF32[i88 >> 2] = f16;
 i89 = i98 + 12 | 0;
 HEAPF32[i89 >> 2] = Math_fround(0.0);
 i90 = i98 + 16 | 0;
 HEAP32[i90 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i90 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i90 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i90 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i90 = i98 + 32 | 0;
 HEAP32[i90 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i90 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i90 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i90 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i90 = i98 + 48 | 0;
 HEAP32[i90 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i90 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i90 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i90 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAPF32[i96 >> 2] = f33;
 i90 = i96 + 4 | 0;
 HEAPF32[i90 >> 2] = f32;
 i91 = i96 + 8 | 0;
 HEAPF32[i91 >> 2] = f95;
 HEAPF32[i96 + 12 >> 2] = Math_fround(0.0);
 i69 = i96 + 16 | 0;
 HEAP32[i69 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i69 = i96 + 32 | 0;
 HEAP32[i69 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i69 = i96 + 48 | 0;
 HEAP32[i69 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i69 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i69 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i69 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAP32[i97 >> 2] = HEAP32[i70 >> 2];
 HEAP32[i97 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
 HEAP32[i97 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
 HEAP32[i97 + 12 >> 2] = HEAP32[i70 + 12 >> 2];
 i70 = i97 + 16 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i70 = i97 + 32 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 i70 = i97 + 48 | 0;
 HEAP32[i70 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i70 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i70 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i70 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 f95 = Math_fround(HEAPF32[i92 + 32 >> 2]);
 i70 = f95 < Math_fround(0.0);
 f95 = Math_fround(f95 * Math_fround(.100000001));
 f95 = i70 ? f95 : Math_fround(0.0);
 f32 = Math_fround(f95 + f2);
 f95 = Math_fround(f95 * f95);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
 L1 : do if (f6 > f95) {
  i3 = i73 + 4 | 0;
  i34 = i73 + 8 | 0;
  i35 = i73 + 12 | 0;
  i36 = i72 + 4 | 0;
  i37 = i72 + 8 | 0;
  i38 = i97 + 4 | 0;
  i39 = i97 + 8 | 0;
  i40 = i97 + 12 | 0;
  i41 = i97 + 16 | 0;
  i42 = i97 + 20 | 0;
  i43 = i97 + 24 | 0;
  i44 = i97 + 28 | 0;
  i45 = i97 + 32 | 0;
  i46 = i97 + 36 | 0;
  i47 = i97 + 40 | 0;
  i48 = i97 + 44 | 0;
  i49 = i96 + 16 | 0;
  i50 = i96 + 20 | 0;
  i51 = i96 + 24 | 0;
  i52 = i98 + 16 | 0;
  i53 = i98 + 20 | 0;
  i54 = i98 + 24 | 0;
  i55 = i98 + 28 | 0;
  i56 = i96 + 32 | 0;
  i57 = i96 + 36 | 0;
  i58 = i96 + 40 | 0;
  i59 = i98 + 32 | 0;
  i60 = i98 + 36 | 0;
  i61 = i98 + 40 | 0;
  i62 = i98 + 44 | 0;
  i63 = i77 + 4 | 0;
  i64 = i77 + 8 | 0;
  i65 = i77 + 12 | 0;
  i66 = i76 + 4 | 0;
  i67 = i76 + 8 | 0;
  i68 = i78 + 4 | 0;
  i69 = i78 + 8 | 0;
  i70 = i78 + 12 | 0;
  f10 = f14;
  f11 = f15;
  f12 = f16;
  f31 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + f4);
  f30 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7);
  f29 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f9);
  f28 = Math_fround(0.0);
  f2 = f14;
  f4 = f15;
  f5 = f16;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f10 * f15);
   f14 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f110 = Math_fround(-f9);
   f13 = Math_fround(-f14);
   f8 = Math_fround(-f15);
   f21 = Math_fround(HEAPF32[i79 >> 2]);
   f20 = Math_fround(HEAPF32[i80 >> 2]);
   f16 = Math_fround(HEAPF32[i81 >> 2]);
   f22 = Math_fround(Math_fround(Math_fround(f21 * f110) + Math_fround(f20 * f13)) + Math_fround(f16 * f8));
   f25 = Math_fround(HEAPF32[i83 >> 2]);
   f26 = Math_fround(HEAPF32[i84 >> 2]);
   f27 = Math_fround(HEAPF32[i85 >> 2]);
   i1 = f22 > Math_fround(Math_fround(Math_fround(f25 * f110) + Math_fround(f26 * f13)) + Math_fround(f27 * f8));
   f25 = i1 ? f21 : f25;
   f26 = i1 ? f20 : f26;
   f27 = i1 ? f16 : f27;
   HEAPF32[i73 >> 2] = f9;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i34 >> 2] = f15;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i72, i92, i73);
   f16 = Math_fround(HEAPF32[i72 >> 2]);
   f20 = Math_fround(HEAPF32[i36 >> 2]);
   f16 = Math_fround(f31 + f16);
   f20 = Math_fround(f30 + f20);
   f21 = Math_fround(f29 + Math_fround(HEAPF32[i37 >> 2]));
   f22 = Math_fround(f25 - f16);
   f23 = Math_fround(f26 - f20);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f23)) + Math_fround(f15 * f24)) - f32);
   f17 = Math_fround(HEAPF32[i93 >> 2]);
   f18 = Math_fround(HEAPF32[i82 >> 2]);
   f19 = Math_fround(HEAPF32[i86 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f17 * f110) + Math_fround(f18 * f13)) + Math_fround(f19 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 18;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i99 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i99 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
    HEAP32[i99 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 18;
      break;
     }
     f8 = Math_fround(HEAPF32[i94 >> 2]);
     f110 = Math_fround(HEAPF32[i74 >> 2]);
     f17 = Math_fround(Math_fround(f13 * f17) + f8);
     f18 = Math_fround(Math_fround(f13 * f18) + f110);
     f19 = Math_fround(Math_fround(f13 * f19) + Math_fround(HEAPF32[i75 >> 2]));
     f31 = Math_fround(f17 - f31);
     f110 = Math_fround(f18 - f30);
     f8 = Math_fround(f19 - f29);
     f2 = Math_fround(HEAPF32[i97 >> 2]);
     f4 = Math_fround(HEAPF32[i38 >> 2]);
     f2 = Math_fround(f31 + f2);
     f4 = Math_fround(f110 + f4);
     f5 = Math_fround(f8 + Math_fround(HEAPF32[i39 >> 2]));
     f22 = Math_fround(HEAPF32[i41 >> 2]);
     f21 = Math_fround(HEAPF32[i42 >> 2]);
     f22 = Math_fround(f31 + f22);
     f21 = Math_fround(f110 + f21);
     f20 = Math_fround(f8 + Math_fround(HEAPF32[i43 >> 2]));
     f16 = Math_fround(HEAPF32[i45 >> 2]);
     f7 = Math_fround(HEAPF32[i46 >> 2]);
     f16 = Math_fround(f31 + f16);
     f7 = Math_fround(f110 + f7);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i47 >> 2]));
     HEAPF32[i97 >> 2] = f2;
     HEAPF32[i38 >> 2] = f4;
     HEAPF32[i39 >> 2] = f5;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     HEAPF32[i41 >> 2] = f22;
     HEAPF32[i42 >> 2] = f21;
     HEAPF32[i43 >> 2] = f20;
     HEAPF32[i44 >> 2] = Math_fround(0.0);
     HEAPF32[i45 >> 2] = f16;
     HEAPF32[i46 >> 2] = f7;
     HEAPF32[i47 >> 2] = f8;
     HEAPF32[i48 >> 2] = Math_fround(0.0);
     f110 = Math_fround(HEAPF32[i96 >> 2]);
     f31 = Math_fround(HEAPF32[i90 >> 2]);
     f4 = Math_fround(f31 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i91 >> 2]) - f5);
     HEAPF32[i98 >> 2] = Math_fround(f110 - f2);
     HEAPF32[i87 >> 2] = f4;
     HEAPF32[i88 >> 2] = f5;
     HEAPF32[i89 >> 2] = Math_fround(0.0);
     f5 = Math_fround(HEAPF32[i49 >> 2]);
     f4 = Math_fround(HEAPF32[i50 >> 2]);
     f21 = Math_fround(f4 - f21);
     f20 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f20);
     HEAPF32[i52 >> 2] = Math_fround(f5 - f22);
     HEAPF32[i53 >> 2] = f21;
     HEAPF32[i54 >> 2] = f20;
     HEAPF32[i55 >> 2] = Math_fround(0.0);
     f20 = Math_fround(HEAPF32[i56 >> 2]);
     f21 = Math_fround(HEAPF32[i57 >> 2]);
     f7 = Math_fround(f21 - f7);
     f8 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f8);
     HEAPF32[i59 >> 2] = Math_fround(f20 - f16);
     HEAPF32[i60 >> 2] = f7;
     HEAPF32[i61 >> 2] = f8;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i77 >> 2] = f9;
     HEAPF32[i63 >> 2] = f14;
     HEAPF32[i64 >> 2] = f15;
     HEAPF32[i65 >> 2] = Math_fround(0.0);
     __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i76, i92, i77);
     f9 = Math_fround(HEAPF32[i76 >> 2]);
     f8 = Math_fround(HEAPF32[i66 >> 2]);
     f9 = Math_fround(f17 + f9);
     f8 = Math_fround(f18 + f8);
     f7 = Math_fround(f19 + Math_fround(HEAPF32[i67 >> 2]));
     f16 = f9;
     f20 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f9);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f22 = Math_fround(3402823469999999843913219.0e14);
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f22 = f6;
     f19 = f29;
     f18 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f22 = f6;
    f13 = f28;
    f19 = f29;
    f18 = f30;
    f17 = f31;
   }
   i1 = HEAP32[i103 >> 2] | 0;
   HEAPF32[i96 + (i1 << 4) >> 2] = f25;
   HEAPF32[i96 + (i1 << 4) + 4 >> 2] = f26;
   HEAPF32[i96 + (i1 << 4) + 8 >> 2] = f27;
   HEAPF32[i96 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i97 + (i1 << 4) >> 2] = f16;
   HEAPF32[i97 + (i1 << 4) + 4 >> 2] = f20;
   HEAPF32[i97 + (i1 << 4) + 8 >> 2] = f21;
   HEAPF32[i97 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i103 >> 2] = i1 + 1;
   HEAPF32[i98 + (i1 << 4) >> 2] = f9;
   HEAPF32[i98 + (i1 << 4) + 4 >> 2] = f8;
   HEAPF32[i98 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i98 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i1 | 0) {
   case 0:
    {
     HEAPF32[i78 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i98 >> 2]);
     f7 = Math_fround(HEAPF32[i87 >> 2]);
     f8 = Math_fround(HEAPF32[i88 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f30 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i1 = f30 > Math_fround(1.0);
      f30 = i1 ? Math_fround(1.0) : f30;
      i1 = f30 > Math_fround(0.0);
      f30 = i1 ? f30 : Math_fround(0.0);
      f31 = Math_fround(f7 + Math_fround(f14 * f30));
      f110 = Math_fround(f8 + Math_fround(f15 * f30));
      HEAPF32[i78 >> 2] = Math_fround(f6 + Math_fround(f9 * f30));
      HEAPF32[i68 >> 2] = f31;
      HEAPF32[i69 >> 2] = f110;
      HEAPF32[i70 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i103 >> 2] = 1;
      HEAP32[i78 >> 2] = HEAP32[i98 >> 2];
      HEAP32[i78 + 4 >> 2] = HEAP32[i98 + 4 >> 2];
      HEAP32[i78 + 8 >> 2] = HEAP32[i98 + 8 >> 2];
      HEAP32[i78 + 12 >> 2] = HEAP32[i98 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i78, i98, i96, i97, i103);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i78, i98, i96, i97, i103);
     break;
    }
   default:
    {
     HEAPF32[i78 >> 2] = f9;
     HEAPF32[i68 >> 2] = f8;
     HEAPF32[i69 >> 2] = f7;
     HEAPF32[i70 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i78 >> 2]);
   f8 = Math_fround(HEAPF32[i68 >> 2]);
   f9 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f22 > f6;
   if (f6 > f33 & i1) {
    f10 = f7;
    f11 = f8;
    f12 = f9;
    f31 = f17;
    f30 = f18;
    f29 = f19;
    f28 = f13;
   } else break L1;
  }
  if ((i3 | 0) == 18) {
   STACKTOP = i109;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f16;
  f11 = f15;
  f10 = f14;
  f9 = f16;
  f8 = f15;
  f7 = f14;
  i1 = 1;
  f5 = f16;
  f4 = f15;
  f2 = f14;
 } while (0);
 i92 = HEAP32[i105 + 64 >> 2] | 0;
 i93 = HEAP32[i105 + 68 >> 2] | 0;
 i94 = HEAP32[i105 + 72 >> 2] | 0;
 i91 = f6 > f95 & i1;
 f30 = i91 ? f7 : f2;
 f32 = i91 ? f8 : f4;
 f95 = i91 ? f9 : f5;
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f95 * f95) + Math_fround(Math_fround(f32 * f32) + Math_fround(f30 * f30))))));
 f30 = Math_fround(f30 * f29);
 f32 = Math_fround(f32 * f29);
 f29 = Math_fround(f95 * f29);
 HEAPF32[i108 >> 2] = f30;
 HEAPF32[i108 + 4 >> 2] = f32;
 HEAPF32[i108 + 8 >> 2] = f29;
 HEAPF32[i108 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i107 >> 2] = f13;
 i108 = i107 + 4 | 0;
 HEAP32[i108 >> 2] = HEAP32[i99 >> 2];
 HEAP32[i108 + 4 >> 2] = HEAP32[i99 + 4 >> 2];
 HEAP32[i108 + 8 >> 2] = HEAP32[i99 + 8 >> 2];
 HEAPF32[i102 >> 2] = i1 ? f7 : f10;
 HEAPF32[i102 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i102 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i102 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i100 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i100 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i100 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i100 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 HEAP32[i101 >> 2] = HEAP32[i104 >> 2];
 HEAP32[i101 + 4 >> 2] = HEAP32[i104 + 4 >> 2];
 HEAP32[i101 + 8 >> 2] = HEAP32[i104 + 8 >> 2];
 HEAP32[i101 + 12 >> 2] = HEAP32[i104 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i98, i96, i97, i102, i100, i101, HEAP32[i103 >> 2] | 0);
 f95 = Math_fround(HEAPF32[i105 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i100 >> 2]);
 f33 = Math_fround(HEAPF32[i100 + 4 >> 2]);
 f110 = Math_fround(HEAPF32[i100 + 8 >> 2]);
 f30 = Math_fround(f31 - Math_fround(f30 * f95));
 f32 = Math_fround(f33 - Math_fround(f32 * f95));
 f95 = Math_fround(f110 - Math_fround(f29 * f95));
 HEAPF32[i106 >> 2] = i92 | 0 ? f30 : f31;
 HEAPF32[i106 + 4 >> 2] = i93 | 0 ? f32 : f33;
 HEAPF32[i106 + 8 >> 2] = i94 | 0 ? f95 : f110;
 HEAPF32[i106 + 12 >> 2] = Math_fround(0.0);
 i108 = 1;
 STACKTOP = i109;
 return i108 | 0;
}

function __ZN15ReflectionProbe8TransferI14SafeBinaryReadEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i9, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i5 = i9 + 36 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 913271 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i4 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 40 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034151 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 17; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 44 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 380944 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 28; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 48 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 380958 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 39; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 52 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 380976 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 50; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 56 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 380989 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 61; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 64 | 0;
 i4 = HEAP32[gb + 37324 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381007 | 0, i4, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 76 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381017 | 0, i4, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 88 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381029 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 84; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 84; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 92 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381040 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 95; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 95; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 96 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381050 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 106; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 106; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 106) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 104 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381067 | 0, HEAP32[gb + 37304 >> 2] | 0, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i8 = 117; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 117; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 117) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 108 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381080 | 0, HEAP32[gb + 36980 >> 2] | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i11); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i11, i9 + 100 | 0, gb + 381098 | 0, 0);
 i7 = i9 + 132 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381112 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i5 >>> 0) i8 = 134; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 134; else {
     HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 134) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i7, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i7 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 136 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381134 | 0, i6, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i6 >>> 0) i8 = 145; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i8 = 145;
     break;
    }
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i8 | 0) == 145) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 140 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381150 | 0, i5, i10, 0) | 0;
 if (i2 | 0) {
  L207 : do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L207;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 141 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381156 | 0, i5, i10, 0) | 0;
 if (i2 | 0) {
  L219 : do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L219;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 142 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381172 | 0, i5, i10, 0) | 0;
 if (i2 | 0) {
  L231 : do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L231;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 143 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381195 | 0, i5, i10, 0) | 0;
 if (i2 | 0) {
  L243 : do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L243;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i9 + 60 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381217 | 0, HEAP32[gb + 37240 >> 2] | 0, i10, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i6 >>> 0) i8 = 192; else {
    i4 = i3 + 2 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i8 = 192;
     break;
    }
    HEAP16[i5 >> 1] = HEAP16[i3 >> 1] | 0;
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i8 | 0) == 192) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 2);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP16[i5 >> 1] = _llvm_bswap_i16(HEAP16[i5 >> 1] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 128 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381230 | 0, gb + 944590 | 0, i10, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 124 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381251 | 0, gb + 944590 | 0, i10, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0)) {
  STACKTOP = i12;
  return;
 }
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) {
   f1 = Math_fround(1.0);
   break;
  }
  f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 HEAPF32[i7 >> 2] = f1;
 STACKTOP = i12;
 return;
}

function __ZN12FlareManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, f67 = f0, i68 = 0, i69 = 0, i70 = 0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i66 + 32 | 0;
 i62 = i66 + 24 | 0;
 i63 = i66;
 i64 = i66 + 20 | 0;
 i65 = i66 + 8 | 0;
 if ((HEAP16[gb + 1110812 + 6 >> 1] | 0) > -1) {
  HEAP32[i62 >> 2] = 0;
  HEAP32[i60 >> 2] = HEAP32[i62 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110812 | 0, i60);
  i61 = gb + 1110812 | 0;
 } else i61 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i5 + (HEAP32[i5 + (i2 << 2) >> 2] | 0) | 0;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 20 | 0) >> 2] | 0;
 L4 : do if (i6 | 0) {
  i57 = i5 + 132 | 0;
  i58 = HEAP32[i5 + 148 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i5 + 152 >> 2]);
  i59 = i5 + 176 | 0;
  i2 = HEAP16[i5 + 160 >> 1] | 0;
  i1 = i5 + 164 | 0;
  if (!((i2 & 255) << 24 >> 24)) {
   f54 = Math_fround(HEAPF32[i5 >> 2]);
   f52 = Math_fround(HEAPF32[i1 >> 2]);
   f54 = Math_fround(f54 * f52);
   f56 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f53 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f56 = Math_fround(f54 + Math_fround(f56 * f53));
   f54 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f55 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f54 = Math_fround(f56 + Math_fround(f54 * f55));
   f54 = Math_fround(Math_fround(HEAPF32[i5 + 48 >> 2]) + f54);
   f56 = Math_fround(f52 * Math_fround(HEAPF32[i5 + 4 >> 2]));
   f56 = Math_fround(f56 + Math_fround(f53 * Math_fround(HEAPF32[i5 + 20 >> 2])));
   f56 = Math_fround(f56 + Math_fround(f55 * Math_fround(HEAPF32[i5 + 36 >> 2])));
   f56 = Math_fround(Math_fround(HEAPF32[i5 + 52 >> 2]) + f56);
   f52 = Math_fround(f52 * Math_fround(HEAPF32[i5 + 8 >> 2]));
   f53 = Math_fround(f52 + Math_fround(f53 * Math_fround(HEAPF32[i5 + 24 >> 2])));
   f55 = Math_fround(f53 + Math_fround(f55 * Math_fround(HEAPF32[i5 + 40 >> 2])));
   f55 = Math_fround(Math_fround(HEAPF32[i5 + 56 >> 2]) + f55);
  } else {
   f52 = Math_fround(HEAPF32[i1 >> 2]);
   f53 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f54 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f55 = Math_fround(HEAPF32[i5 + 156 >> 2]);
   f52 = Math_fround(-Math_fround(f52 * f55));
   f53 = Math_fround(-Math_fround(f53 * f55));
   f55 = Math_fround(-Math_fround(f54 * f55));
   f54 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f52);
   f54 = Math_fround(f54 + Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) * f53));
   f54 = Math_fround(f54 + Math_fround(Math_fround(HEAPF32[i5 + 32 >> 2]) * f55));
   f56 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f52);
   f56 = Math_fround(f56 + Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * f53));
   f56 = Math_fround(f56 + Math_fround(Math_fround(HEAPF32[i5 + 36 >> 2]) * f55));
   f52 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f52);
   f53 = Math_fround(f52 + Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * f53));
   f55 = Math_fround(f53 + Math_fround(Math_fround(HEAPF32[i5 + 40 >> 2]) * f55));
  }
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f54 * f54) + Math_fround(f56 * f56))));
  if (f3 > Math_fround(HEAPF32[gb + 62456 >> 2])) {
   f53 = Math_fround(f54 / f3);
   f52 = Math_fround(f56 / f3);
  } else {
   f53 = Math_fround(1.0);
   f52 = Math_fround(0.0);
  }
  f3 = Math_fround(HEAPF32[i5 + 128 >> 2]);
  if ((i2 & 65535) >= 256) f3 = Math_fround(f3 * Math_fround(Math_fround(1.0) - Math_fround(__ZN14RenderSettings13CalcFogFactorEff(f4, f55))));
  i39 = i5 + 184 | 0;
  if ((HEAP32[i39 >> 2] | 0) > 0) {
   i40 = i5 + 192 | 0;
   i41 = i58 + -1 | 0;
   f42 = Math_fround(Math_fround(1.0) / Math_fround(i41 | 0));
   i43 = i59 + 4 | 0;
   i38 = i60 + 4 | 0;
   i37 = i62 + 4 | 0;
   f44 = Math_fround(f3 * Math_fround(.00999999977));
   i45 = i63 + 4 | 0;
   i46 = f3 < Math_fround(1.0);
   i47 = f3 == Math_fround(1.0);
   f17 = Math_fround(f3 * Math_fround(12.9200001));
   i48 = i64 + 1 | 0;
   i49 = i64 + 2 | 0;
   i50 = i64 + 3 | 0;
   i51 = i5 + 188 | 0;
   i19 = i5 + 64 | 0;
   i20 = i19 + 16 | 0;
   i21 = i19 + 32 | 0;
   i22 = i19 + 48 | 0;
   i23 = i19 + 4 | 0;
   i24 = i19 + 20 | 0;
   i25 = i19 + 36 | 0;
   i26 = i19 + 52 | 0;
   i27 = i65 + 4 | 0;
   i28 = i19 + 8 | 0;
   i29 = i19 + 24 | 0;
   i30 = i19 + 40 | 0;
   i31 = i19 + 56 | 0;
   i32 = i65 + 8 | 0;
   i33 = i57 + 4 | 0;
   i34 = i57 + 8 | 0;
   i35 = i57 + 12 | 0;
   i18 = i63 + 4 | 0;
   i16 = f3 <= Math_fround(0.0);
   i36 = i16 | f3 <= Math_fround(.00313080009);
   f17 = i16 ? Math_fround(0.0) : f17;
   i16 = 0;
   while (1) {
    i1 = HEAP32[i40 + (i16 << 5) >> 2] | 0;
    L19 : do switch (i58 | 0) {
    case 0:
     if (!i1) {
      f15 = Math_fround(HEAPF32[i59 >> 2]);
      f14 = Math_fround(f15 + Math_fround(0.0));
      f7 = Math_fround(HEAPF32[i43 >> 2]);
      f4 = Math_fround(f7 + Math_fround(0.0));
      HEAPF32[i60 >> 2] = f14;
      HEAPF32[i38 >> 2] = f4;
      f15 = Math_fround(Math_fround(1.0) - f15);
      f7 = Math_fround(Math_fround(.5) - f7);
      HEAPF32[i62 >> 2] = f15;
      HEAPF32[i37 >> 2] = f7;
      i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
      break L19;
     } else {
      i5 = i1 + -1 | 0;
      i2 = i5 & 1;
      i5 = i5 >> 1;
      f14 = Math_fround(Math_fround(i2 | 0) * Math_fround(.5));
      f4 = Math_fround(Math_fround(Math_fround(Math_fround(i5 | 0) * Math_fround(.5)) * Math_fround(.5)) + Math_fround(.5));
      f15 = Math_fround(HEAPF32[i59 >> 2]);
      f14 = Math_fround(f14 + f15);
      f7 = Math_fround(HEAPF32[i43 >> 2]);
      f4 = Math_fround(f4 + f7);
      HEAPF32[i60 >> 2] = f14;
      HEAPF32[i38 >> 2] = f4;
      f15 = Math_fround(Math_fround(Math_fround(i2 + 1 | 0) * Math_fround(.5)) - f15);
      f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i5 + 1 | 0) * Math_fround(.5)) * Math_fround(.5)) + Math_fround(.5)) - f7);
      HEAPF32[i62 >> 2] = f15;
      HEAPF32[i37 >> 2] = f7;
      i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
      break L19;
     }
    case 1:
     switch (i1 | 0) {
     case 0:
      {
       HEAP32[i60 >> 2] = 0;
       HEAP32[i38 >> 2] = 0;
       f15 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i59 >> 2]));
       f7 = Math_fround(Math_fround(.5) - Math_fround(HEAPF32[i43 >> 2]));
       HEAPF32[i62 >> 2] = f15;
       HEAPF32[i37 >> 2] = f7;
       f4 = Math_fround(0.0);
       i5 = 0;
       break L19;
      }
     case 1:
      {
       HEAP32[i60 >> 2] = 0;
       HEAP32[i38 >> 2] = 1056964608;
       f15 = Math_fround(Math_fround(.5) - Math_fround(HEAPF32[i59 >> 2]));
       f7 = Math_fround(Math_fround(.75) - Math_fround(HEAPF32[i43 >> 2]));
       HEAPF32[i62 >> 2] = f15;
       HEAPF32[i37 >> 2] = f7;
       f4 = Math_fround(.5);
       i5 = 0;
       break L19;
      }
     case 2:
      {
       HEAP32[i60 >> 2] = 0;
       HEAP32[i38 >> 2] = 1061158912;
       f15 = Math_fround(Math_fround(.5) - Math_fround(HEAPF32[i59 >> 2]));
       f7 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i43 >> 2]));
       HEAPF32[i62 >> 2] = f15;
       HEAPF32[i37 >> 2] = f7;
       f4 = Math_fround(.75);
       i5 = 0;
       break L19;
      }
     default:
      {
       i5 = i1 + -3 | 0;
       i2 = i5 & 1;
       i5 = i5 >> 1;
       f14 = Math_fround(Math_fround(Math_fround(i2 | 0) * Math_fround(.25)) + Math_fround(.5));
       f4 = Math_fround(Math_fround(Math_fround(Math_fround(i5 | 0) * Math_fround(.25)) * Math_fround(.5)) + Math_fround(.5));
       f15 = Math_fround(HEAPF32[i59 >> 2]);
       f14 = Math_fround(f14 + f15);
       f7 = Math_fround(HEAPF32[i43 >> 2]);
       f4 = Math_fround(f4 + f7);
       HEAPF32[i60 >> 2] = f14;
       HEAPF32[i38 >> 2] = f4;
       f15 = Math_fround(Math_fround(Math_fround(Math_fround(i2 + 1 | 0) * Math_fround(.25)) + Math_fround(.5)) - f15);
       f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i5 + 1 | 0) * Math_fround(.25)) * Math_fround(.5)) + Math_fround(.5)) - f7);
       HEAPF32[i62 >> 2] = f15;
       HEAPF32[i37 >> 2] = f7;
       i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
       break L19;
      }
     }
    default:
     {
      i2 = (i1 | 0) % (i41 | 0) | 0;
      i5 = (i1 | 0) / (i41 | 0) | 0;
      f14 = Math_fround(f42 * Math_fround(i2 | 0));
      f4 = Math_fround(f42 * Math_fround(i5 | 0));
      f15 = Math_fround(HEAPF32[i59 >> 2]);
      f14 = Math_fround(f14 + f15);
      f7 = Math_fround(HEAPF32[i43 >> 2]);
      f4 = Math_fround(f4 + f7);
      HEAPF32[i60 >> 2] = f14;
      HEAPF32[i38 >> 2] = f4;
      f15 = Math_fround(Math_fround(f42 * Math_fround(i2 + 1 | 0)) - f15);
      f7 = Math_fround(Math_fround(f42 * Math_fround(i5 + 1 | 0)) - f7);
      HEAPF32[i62 >> 2] = f15;
      HEAPF32[i37 >> 2] = f7;
      i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     }
    } while (0);
    f14 = Math_fround(Math_fround(1.0) - f4);
    HEAPF32[i38 >> 2] = f14;
    f12 = Math_fround(Math_fround(1.0) - f7);
    HEAPF32[i37 >> 2] = f12;
    f4 = Math_fround(f55 * Math_fround(HEAPF32[i40 + (i16 << 5) + 8 >> 2]));
    f4 = Math_fround(f4 * (HEAP8[i40 + (i16 << 5) + 30 >> 0] | 0 ? f44 : Math_fround(.00999999977)));
    i2 = i40 + (i16 << 5) + 29 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) {
     HEAPF32[i45 >> 2] = f4;
     HEAPF32[i63 >> 2] = f4;
     f13 = f4;
     f11 = f4;
    } else {
     f11 = Math_fround(f4 * Math_fround(1.39999998));
     f13 = Math_fround(f53 * f11);
     f11 = Math_fround(f52 * f11);
     HEAPF32[i63 >> 2] = f13;
     HEAPF32[i18 >> 2] = f11;
    }
    do if (i36) f10 = f17; else {
     if (i46) {
      f10 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (i47) f10 = Math_fround(1.0); else f10 = Math_fround(+Math_pow(+f3, .454545468));
    } while (0);
    f4 = Math_fround(HEAPF32[i40 + (i16 << 5) + 12 >> 2]);
    if (!(HEAP8[i40 + (i16 << 5) + 28 >> 0] | 0)) {
     f7 = Math_fround(f10 * f4);
     f8 = Math_fround(f10 * Math_fround(HEAPF32[i40 + (i16 << 5) + 16 >> 2]));
     f9 = Math_fround(f10 * Math_fround(HEAPF32[i40 + (i16 << 5) + 20 >> 2]));
     f4 = Math_fround(f10 * Math_fround(HEAPF32[i40 + (i16 << 5) + 24 >> 2]));
     i1 = f7 < Math_fround(0.0);
     f10 = i1 ? Math_fround(0.0) : f7;
     i1 = f10 > Math_fround(1.0);
     HEAP8[i64 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f8 < Math_fround(0.0);
     f10 = i1 ? Math_fround(0.0) : f8;
     i1 = f10 > Math_fround(1.0);
     HEAP8[i48 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f9 < Math_fround(0.0);
     f10 = i1 ? Math_fround(0.0) : f9;
     i1 = f10 > Math_fround(1.0);
     HEAP8[i49 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f4 < Math_fround(0.0);
     f4 = i1 ? Math_fround(0.0) : f4;
     i1 = f4 > Math_fround(1.0);
     f4 = i1 ? Math_fround(1.0) : f4;
    } else {
     f67 = Math_fround(HEAPF32[i40 + (i16 << 5) + 16 >> 2]);
     f9 = Math_fround(HEAPF32[i40 + (i16 << 5) + 20 >> 2]);
     f8 = Math_fround(HEAPF32[i40 + (i16 << 5) + 24 >> 2]);
     f7 = Math_fround(f4 * Math_fround(HEAPF32[i57 >> 2]));
     f4 = Math_fround(f67 * Math_fround(HEAPF32[i33 >> 2]));
     f9 = Math_fround(f9 * Math_fround(HEAPF32[i34 >> 2]));
     f8 = Math_fround(f8 * Math_fround(HEAPF32[i35 >> 2]));
     if (HEAP8[i40 + (i16 << 5) + 31 >> 0] | 0) {
      f7 = Math_fround(f10 * f7);
      f9 = Math_fround(f10 * f9);
      f8 = Math_fround(f10 * f8);
      f4 = Math_fround(f10 * f4);
     }
     i1 = f7 < Math_fround(0.0);
     f67 = i1 ? Math_fround(0.0) : f7;
     i1 = f67 > Math_fround(1.0);
     HEAP8[i64 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f67) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f4 < Math_fround(0.0);
     f4 = i1 ? Math_fround(0.0) : f4;
     i1 = f4 > Math_fround(1.0);
     HEAP8[i48 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f9 < Math_fround(0.0);
     f4 = i1 ? Math_fround(0.0) : f9;
     i1 = f4 > Math_fround(1.0);
     HEAP8[i49 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
     i1 = f8 < Math_fround(0.0);
     f4 = i1 ? Math_fround(0.0) : f8;
     i1 = f4 > Math_fround(1.0);
     f4 = i1 ? Math_fround(1.0) : f4;
    }
    HEAP8[i50 >> 0] = ~~Math_fround(Math_fround(f4 * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i1 = HEAP32[i64 >> 2] | 0;
    f7 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
    f8 = Math_fround(Math_fround((i1 & 65535) >>> 8 & 255) / Math_fround(255.0));
    f4 = Math_fround(Math_fround(i1 >>> 16 & 255) / Math_fround(255.0));
    f9 = Math_fround(Math_fround(i1 >>> 24 & 255) / Math_fround(255.0));
    do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
     do if (!(f7 <= Math_fround(.0404499993))) {
      if (f7 < Math_fround(1.0)) {
       f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
     } else f7 = Math_fround(f7 / Math_fround(12.9200001)); while (0);
     do if (!(f8 <= Math_fround(.0404499993))) {
      if (f8 < Math_fround(1.0)) {
       f8 = Math_fround(+Math_pow(+Math_fround(Math_fround(f8 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f8 == Math_fround(1.0)) f8 = Math_fround(1.0); else f8 = Math_fround(+Math_pow(+f8, 2.20000005));
     } else f8 = Math_fround(f8 / Math_fround(12.9200001)); while (0);
     if (f4 <= Math_fround(.0404499993)) {
      f4 = Math_fround(f4 / Math_fround(12.9200001));
      break;
     }
     if (f4 < Math_fround(1.0)) {
      f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
    } while (0);
    i70 = f7 < Math_fround(0.0);
    f67 = i70 ? Math_fround(0.0) : f7;
    i70 = f67 > Math_fround(1.0);
    HEAP8[i64 >> 0] = ~~Math_fround(Math_fround((i70 ? Math_fround(1.0) : f67) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i70 = f8 < Math_fround(0.0);
    f67 = i70 ? Math_fround(0.0) : f8;
    i70 = f67 > Math_fround(1.0);
    i70 = ~~Math_fround(Math_fround((i70 ? Math_fround(1.0) : f67) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    HEAP8[i48 >> 0] = i70;
    i1 = f4 < Math_fround(0.0);
    f67 = i1 ? Math_fround(0.0) : f4;
    i1 = f67 > Math_fround(1.0);
    i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f67) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    HEAP8[i49 >> 0] = i1;
    i69 = f9 > Math_fround(1.0);
    HEAP8[i50 >> 0] = ~~Math_fround(Math_fround((i69 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i69 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0) == 0;
    i68 = HEAP32[i64 >> 2] | 0;
    i1 = i68 & -16777216 | (i69 ? i68 >>> 16 : i68) << 16 & 16711680 | (i69 ? i68 >>> 8 : i70) << 8 & 65280 | (i69 ? i68 : i1) & 255;
    HEAP32[i64 >> 2] = i1;
    f67 = Math_fround(HEAPF32[i40 + (i16 << 5) + 4 >> 2]);
    f7 = Math_fround(f67 * Math_fround(0.0));
    f8 = Math_fround(Math_fround(1.0) - f67);
    f4 = Math_fround(f7 + Math_fround(f54 * f8));
    f7 = Math_fround(f7 + Math_fround(f56 * f8));
    f8 = Math_fround(Math_fround(f55 * f67) + Math_fround(f55 * f8));
    if (!(HEAP8[i51 >> 0] | 0)) {
     f67 = Math_fround(f7 - f11);
     HEAPF32[i6 >> 2] = Math_fround(f4 - f13);
     HEAPF32[i6 + 4 >> 2] = f67;
     HEAPF32[i6 + 8 >> 2] = f8;
     HEAPF32[i6 + 16 >> 2] = f15;
     HEAPF32[i6 + 20 >> 2] = f14;
     HEAP32[i6 + 12 >> 2] = i1;
     f67 = Math_fround(f7 - f13);
     HEAPF32[i6 + 24 >> 2] = Math_fround(f4 + f11);
     HEAPF32[i6 + 28 >> 2] = f67;
     HEAPF32[i6 + 32 >> 2] = f8;
     HEAP32[i6 + 40 >> 2] = i5;
     HEAPF32[i6 + 44 >> 2] = f14;
     HEAP32[i6 + 36 >> 2] = i1;
     f67 = Math_fround(f7 + f11);
     HEAPF32[i6 + 48 >> 2] = Math_fround(f4 + f13);
     HEAPF32[i6 + 52 >> 2] = f67;
     HEAPF32[i6 + 56 >> 2] = f8;
     HEAP32[i6 + 64 >> 2] = i5;
     HEAPF32[i6 + 68 >> 2] = f12;
     HEAP32[i6 + 60 >> 2] = i1;
     f67 = Math_fround(f7 + f13);
     HEAPF32[i6 + 72 >> 2] = Math_fround(f4 - f11);
     HEAPF32[i6 + 76 >> 2] = f67;
     HEAPF32[i6 + 80 >> 2] = f8;
     HEAPF32[i6 + 88 >> 2] = f15;
     HEAPF32[i6 + 92 >> 2] = f12;
     HEAP32[i6 + 84 >> 2] = i1;
    } else {
     f67 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
     f67 = Math_fround(f67 + Math_fround(f7 * Math_fround(HEAPF32[i20 >> 2])));
     f67 = Math_fround(f67 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
     HEAPF32[i65 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f67);
     f67 = Math_fround(f4 * Math_fround(HEAPF32[i23 >> 2]));
     f67 = Math_fround(f67 + Math_fround(f7 * Math_fround(HEAPF32[i24 >> 2])));
     f67 = Math_fround(f67 + Math_fround(f8 * Math_fround(HEAPF32[i25 >> 2])));
     HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f67);
     f67 = Math_fround(f4 * Math_fround(HEAPF32[i28 >> 2]));
     f67 = Math_fround(f67 + Math_fround(f7 * Math_fround(HEAPF32[i29 >> 2])));
     f67 = Math_fround(f67 + Math_fround(f8 * Math_fround(HEAPF32[i30 >> 2])));
     HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f67);
     __Z23SetupStereoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK10Matrix4x4fRK8Vector3fb(i6, i63, i60, i62, i64, i19, i65, (HEAP8[i2 >> 0] | 0) != 0);
    }
    i16 = i16 + 1 | 0;
    if ((i16 | 0) >= (HEAP32[i39 >> 2] | 0)) break L4; else i6 = i6 + 96 | 0;
   }
  }
 } while (0);
 if (!i61) {
  STACKTOP = i66;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i61);
 STACKTOP = i66;
 return;
}

function __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i26, i3, i1, i2) {
 i26 = i26 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0;
 i27 = i3 + 4 | 0;
 i27 = HEAP32[(HEAP32[i27 >> 2] | 0) + i27 + (i2 << 3) + 4 >> 2] | 0;
 i15 = i1 + 4 | 0;
 i15 = (HEAP32[i15 >> 2] | 0) + i15 | 0;
 f6 = Math_fround(HEAPF32[i15 + (i2 * 40 | 0) + 24 >> 2]);
 f29 = Math_fround(HEAPF32[i15 + (i2 * 40 | 0) + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + (i2 * 40 | 0) + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i15 + (i2 * 40 | 0) + 20 >> 2]);
 f23 = Math_fround(f29 / f6);
 f24 = Math_fround(f7 / f6);
 f25 = Math_fround(f28 / f6);
 i15 = i3 + 16 | 0;
 i15 = (HEAP32[i15 >> 2] | 0) + i15 | 0;
 f11 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 16 >> 2]);
 f5 = Math_fround(f7 * f12);
 f22 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 28 >> 2]);
 f4 = Math_fround(f6 * f22);
 f9 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 20 >> 2]);
 f10 = Math_fround(f28 * f9);
 f8 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 24 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f6 * f8)) - Math_fround(f28 * f22)) - Math_fround(f29 * f9));
 f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f29 * f12)) - Math_fround(f28 * f8)) - Math_fround(f7 * f9));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f7 * f8)) - Math_fround(f6 * f12)) - Math_fround(f29 * f22));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f29 * f8) - Math_fround(f28 * f12)) - Math_fround(f6 * f9)) - Math_fround(f7 * f22));
 i21 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f22 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 76 | 0) + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i20 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f22 * f10);
 f7 = Math_fround(f11 * f4);
 f9 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 76 | 0) + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f9 * f6);
 f28 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 76 | 0) >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i21 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f11 * f8)) - Math_fround(f9 * f4)) - Math_fround(f28 * f6));
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f28 * f10)) - Math_fround(f9 * f8)) - Math_fround(f22 * f6));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f22 * f8)) - Math_fround(f11 * f10)) - Math_fround(f28 * f4));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f8) - Math_fround(f9 * f10)) - Math_fround(f11 * f6)) - Math_fround(f22 * f4));
 i21 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f4 = (HEAP32[tempDoublePtr >> 2] = i19 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f4 * f4);
 f5 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f5 * f5);
 f6 = (HEAP32[tempDoublePtr >> 2] = i21 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f22) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6))))));
 f4 = Math_fround(f22 * f4);
 f5 = Math_fround(f22 * f5);
 f6 = Math_fround(f22 * f6);
 f7 = Math_fround(f22 * f7);
 switch (HEAP32[i15 + (i27 * 76 | 0) + 72 >> 2] | 0) {
 case 3:
  {
   f9 = Math_fround(Math_fround(f7 * f5) * Math_fround(2.0));
   f10 = Math_fround(Math_fround(f7 * f6) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(f4 * f5) * Math_fround(2.0));
   f12 = Math_fround(Math_fround(f6 * f4) * Math_fround(2.0));
   f8 = Math_fround(f12 - f9);
   if (Math_fround(f8 * f8) < Math_fround(.999995946)) {
    f30 = Math_fround(f7 * f7);
    f29 = Math_fround(f6 * f6);
    f12 = Math_fround(f5 * f5);
    f9 = Math_fround(f4 * f4);
    f28 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f7 * f4) * Math_fround(2.0)) + Math_fround(Math_fround(f5 * f6) * Math_fround(2.0))), +Math_fround(Math_fround(Math_fround(f30 + f29) - f12) - f9)));
    f22 = Math_fround(+Math_asin(+f8));
    f29 = Math_fround(+Math_atan2(+Math_fround(f10 + f11), +Math_fround(Math_fround(Math_fround(f30 + f9) - f12) - f29)));
    f8 = f28;
    i21 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f22 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f8, Math_fround(-1.0))), Math_fround(1.0)))));
    f8 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f9 * f11) + Math_fround(f10 * f12)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f10 * f10) - Math_fround(f11 * f11)) + Math_fround(Math_fround(f9 * f9) - Math_fround(f12 * f12)))));
    i21 = 0;
   }
   f7 = Math_fround(-f22);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 44 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 48 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 52 >> 2]);
   i1 = f28 > Math_fround(0.0);
   i2 = f29 > Math_fround(0.0);
   i13 = f30 > Math_fround(0.0);
   f9 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(Math_fround(-f8) / f28);
   f5 = Math_fround(f22 / f29);
   f6 = Math_fround(Math_fround(-f9) / f30);
   i20 = f28 < Math_fround(0.0);
   i3 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   i20 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i17 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i16 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i13 ? i21 : 0;
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 56 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 60 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 64 >> 2]);
   i1 = f28 < Math_fround(0.0);
   i13 = f29 < Math_fround(0.0);
   i15 = f30 < Math_fround(0.0);
   f4 = Math_fround(f8 / f28);
   f5 = Math_fround(f7 / f29);
   f6 = Math_fround(f9 / f30);
   i3 = f28 > Math_fround(0.0);
   i2 = f29 > Math_fround(0.0);
   i14 = f30 > Math_fround(0.0);
   i3 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i2 = i2 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i13 ? i19 : 0;
   i18 = f8 < Math_fround(0.0);
   i1 = f22 > Math_fround(-0.0);
   i19 = f9 < Math_fround(0.0);
   i3 = i18 ? i20 : i3;
   i19 = i19 ? i16 : i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i15 ? i21 : 0;
   i21 = i1 ? i17 : i2;
   i18 = (i27 | 0) != -1;
   i27 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = i18 ? i3 : i27;
   i20 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = i18 ? i21 : i20;
   i21 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = i18 ? i19 : i21;
   HEAP32[i26 >> 2] = i27;
   i27 = i26 + 4 | 0;
   HEAP32[i27 >> 2] = i20;
   i27 = i26 + 8 | 0;
   HEAP32[i27 >> 2] = i21;
   return;
  }
 case 1:
  {
   f9 = Math_fround(f4 / f7);
   f28 = Math_fround(f5 / f7);
   f29 = Math_fround(f6 / f7);
   f7 = Math_fround(Math_fround(f9 * f9) + Math_fround(1.0));
   f8 = Math_fround(Math_fround(f28 - Math_fround(f9 * f29)) / f7);
   f7 = Math_fround(Math_fround(f29 + Math_fround(f9 * f28)) / f7);
   i21 = HEAP32[i15 + (i27 * 76 | 0) + 32 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = HEAP32[i15 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = HEAP32[i15 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f9 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i18 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 44 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 48 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 52 >> 2]);
   i1 = f28 > Math_fround(0.0);
   i2 = f29 > Math_fround(0.0);
   i13 = f30 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f28);
   f5 = Math_fround(Math_fround(-f8) / f29);
   f6 = Math_fround(Math_fround(-f9) / f30);
   i20 = f28 < Math_fround(0.0);
   i3 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   i20 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i17 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i16 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i13 ? i21 : 0;
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 56 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 60 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 64 >> 2]);
   i1 = f28 < Math_fround(0.0);
   i2 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   f4 = Math_fround(f7 / f28);
   f5 = Math_fround(f8 / f29);
   f6 = Math_fround(f9 / f30);
   i3 = f28 > Math_fround(0.0);
   i13 = f29 > Math_fround(0.0);
   i15 = f30 > Math_fround(0.0);
   i3 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i2 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i18 = f7 < Math_fround(0.0);
   i1 = f8 < Math_fround(0.0);
   i19 = f9 < Math_fround(0.0);
   i3 = i18 ? i20 : i3;
   i19 = i19 ? i16 : i15 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i14 ? i21 : 0;
   i21 = i1 ? i17 : i2;
   i18 = (i27 | 0) != -1;
   i27 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = i18 ? i3 : i27;
   i20 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = i18 ? i21 : i20;
   i21 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = i18 ? i19 : i21;
   HEAP32[i26 >> 2] = i27;
   i27 = i26 + 4 | 0;
   HEAP32[i27 >> 2] = i20;
   i27 = i26 + 8 | 0;
   HEAP32[i27 >> 2] = i21;
   return;
  }
 case 2:
  {
   f9 = Math_fround(f4 / f7);
   f28 = Math_fround(f5 / f7);
   f29 = Math_fround(f6 / f7);
   f7 = Math_fround(Math_fround(f9 * f9) + Math_fround(1.0));
   f8 = Math_fround(Math_fround(f28 + Math_fround(f9 * f29)) / f7);
   f7 = Math_fround(Math_fround(f29 - Math_fround(f9 * f28)) / f7);
   i21 = HEAP32[i15 + (i27 * 76 | 0) + 32 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = HEAP32[i15 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = HEAP32[i15 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f9 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i18 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 44 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 48 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 52 >> 2]);
   i1 = f28 > Math_fround(0.0);
   i2 = f29 > Math_fround(0.0);
   i13 = f30 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f28);
   f5 = Math_fround(Math_fround(-f8) / f29);
   f6 = Math_fround(Math_fround(-f9) / f30);
   i20 = f28 < Math_fround(0.0);
   i3 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   i20 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i17 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i16 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i13 ? i21 : 0;
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 56 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 60 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 64 >> 2]);
   i1 = f28 < Math_fround(0.0);
   i2 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   f4 = Math_fround(f7 / f28);
   f5 = Math_fround(f8 / f29);
   f6 = Math_fround(f9 / f30);
   i3 = f28 > Math_fround(0.0);
   i13 = f29 > Math_fround(0.0);
   i15 = f30 > Math_fround(0.0);
   i3 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i2 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i18 = f7 < Math_fround(0.0);
   i1 = f8 < Math_fround(0.0);
   i19 = f9 < Math_fround(0.0);
   i3 = i18 ? i20 : i3;
   i19 = i19 ? i16 : i15 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i14 ? i21 : 0;
   i21 = i1 ? i17 : i2;
   i18 = (i27 | 0) != -1;
   i27 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = i18 ? i3 : i27;
   i20 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = i18 ? i21 : i20;
   i21 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = i18 ? i19 : i21;
   HEAP32[i26 >> 2] = i27;
   i27 = i26 + 4 | 0;
   HEAP32[i27 >> 2] = i20;
   i27 = i26 + 8 | 0;
   HEAP32[i27 >> 2] = i21;
   return;
  }
 default:
  {
   f9 = Math_fround(f4 / f7);
   f8 = Math_fround(f5 / f7);
   f7 = Math_fround(f6 / f7);
   i21 = HEAP32[i15 + (i27 * 76 | 0) + 32 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = HEAP32[i15 + (i27 * 76 | 0) + 36 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = HEAP32[i15 + (i27 * 76 | 0) + 40 >> 2] & -2147483648 ^ (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = Math_fround(Math_fround(+Math_atan(+f7)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   f9 = Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0));
   i18 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 44 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 48 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 52 >> 2]);
   i1 = f28 > Math_fround(0.0);
   i2 = f29 > Math_fround(0.0);
   i13 = f30 > Math_fround(0.0);
   f4 = Math_fround(Math_fround(-f7) / f28);
   f5 = Math_fround(Math_fround(-f8) / f29);
   f6 = Math_fround(Math_fround(-f9) / f30);
   i20 = f28 < Math_fround(0.0);
   i3 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   i20 = i20 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i17 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i16 = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i13 ? i21 : 0;
   f28 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 56 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 60 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i27 * 76 | 0) + 64 >> 2]);
   i1 = f28 < Math_fround(0.0);
   i2 = f29 < Math_fround(0.0);
   i14 = f30 < Math_fround(0.0);
   f4 = Math_fround(f7 / f28);
   f5 = Math_fround(f8 / f29);
   f6 = Math_fround(f9 / f30);
   i3 = f28 > Math_fround(0.0);
   i13 = f29 > Math_fround(0.0);
   i15 = f30 > Math_fround(0.0);
   i3 = i3 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1 ? i18 : 0;
   i2 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2 ? i19 : 0;
   i18 = f7 < Math_fround(0.0);
   i1 = f8 < Math_fround(0.0);
   i19 = f9 < Math_fround(0.0);
   i3 = i18 ? i20 : i3;
   i19 = i19 ? i16 : i15 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i14 ? i21 : 0;
   i21 = i1 ? i17 : i2;
   i18 = (i27 | 0) != -1;
   i27 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i27 = i18 ? i3 : i27;
   i20 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = i18 ? i21 : i20;
   i21 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i21 = i18 ? i19 : i21;
   HEAP32[i26 >> 2] = i27;
   i27 = i26 + 4 | 0;
   HEAP32[i27 >> 2] = i20;
   i27 = i26 + 8 | 0;
   HEAP32[i27 >> 2] = i21;
   return;
  }
 }
}

function __ZN5physx2Sn5ConvX17convertCollectionEPKvii(i64, i2, i1, i63) {
 i64 = i64 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i63 = i63 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i65 = 0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i61 = i62 + 32 | 0;
 i60 = i62 + 24 | 0;
 i59 = i62 + 16 | 0;
 i58 = i62 + 8 | 0;
 i57 = i62;
 i54 = i62 + 56 | 0;
 i52 = i62 + 88 | 0;
 i49 = i62 + 98 | 0;
 i55 = i62 + 48 | 0;
 i53 = i62 + 40 | 0;
 i50 = i62 + 97 | 0;
 i56 = i62 + 36 | 0;
 i51 = i62 + 96 | 0;
 i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, 16) | 0;
 i47 = HEAP32[i64 + 316 >> 2] | 0;
 i48 = HEAP32[i64 + 320 >> 2] | 0;
 i1 = i63 >>> 0 > 536870911 ? -1 : i63 << 3;
 if (!i1) i46 = 0; else {
  i45 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i44 = HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0;
  i46 = _PxGetFoundation() | 0;
  i46 = mftCall_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 24 >> 2] | 0, i46 | 0) | 0;
  i46 = mftCall_iiiiii(i44 | 0, i45 | 0, i1 | 0, (i46 ? gb + 668838 | 0 : gb + 837976 | 0) | 0, gb + 668920 | 0, 851) | 0;
 }
 if (!i63) {
  __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i64, 2) | 0;
  i7 = 113;
 } else {
  f4 = Math_fround(i63 | 0);
  i5 = i54 + 12 | 0;
  i6 = i54 + 8 | 0;
  i3 = 0;
  do {
   HEAP32[i57 >> 2] = ~~Math_fround(Math_fround(Math_fround(i3 >>> 0) / f4) * Math_fround(100.0));
   __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i64, 1, gb + 669028 | 0, i57);
   i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, 16) | 0;
   i45 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, gb + 827530 | 0, 1) | 0;
   HEAP32[i54 >> 2] = 0;
   HEAP32[i54 + 4 >> 2] = 0;
   HEAP32[i54 + 8 >> 2] = 0;
   HEAP32[i54 + 12 >> 2] = 0;
   HEAP32[i54 + 16 >> 2] = 0;
   HEAP32[i54 + 20 >> 2] = 0;
   HEAP32[i54 + 24 >> 2] = 0;
   HEAP32[i54 + 28 >> 2] = 0;
   if (__ZNK5physx2Sn9MetaClass14getFieldByTypeEPKcRNS0_15PxMetaDataEntryE(i45, gb + 754342 | 0, i54) | 0) {
    i1 = __ZN5physx2Sn4peekEiPKci(HEAP32[i5 >> 2] | 0, i2 + (HEAP32[i6 >> 2] | 0) | 0, 0) | 0;
    getTempRet0() | 0;
   } else i1 = -1;
   i1 = __ZN5physx2Sn5ConvX12getMetaClassENS_14PxConcreteType4EnumENS0_12MetaDataTypeE(i64, i1, 1) | 0;
   if (!i1) {
    i7 = 9;
    break;
   }
   HEAP32[i46 + (i3 << 3) >> 2] = i1;
   HEAP32[i46 + (i3 << 3) + 4 >> 2] = i2;
   __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i1, 0) | 0;
   i2 = i2 + (HEAP32[i1 + 16 >> 2] | 0) | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i63 >>> 0);
  if ((i7 | 0) == 9) {
   if (!i46) {
    i64 = 0;
    STACKTOP = i62;
    return i64 | 0;
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i57, i46);
   i64 = 0;
   STACKTOP = i62;
   return i64 | 0;
  }
  i1 = __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i64, 2) | 0;
  if ((i63 | 0) > 0) {
   f4 = Math_fround(i63 | 0);
   i45 = i52 + 4 | 0;
   i41 = (HEAP32[i1 + 56 >> 2] | 0) == 0;
   i42 = i64 + 24 | 0;
   i43 = i64 + 12 | 0;
   i44 = i53 + 4 | 0;
   i40 = 0;
   i3 = 0;
   i1 = 0;
   while (1) {
    HEAP32[i58 >> 2] = ~~Math_fround(Math_fround(Math_fround(i40 | 0) / f4) * Math_fround(100.0));
    __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i64, 1, gb + 669052 | 0, i58);
    i37 = HEAP32[i46 + (i40 << 3) >> 2] | 0;
    i39 = HEAP32[i46 + (i40 << 3) + 4 >> 2] | 0;
    HEAP8[i45 >> 0] = 1;
    i38 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i49, 9216, gb + 668920 | 0, 918) | 0;
    HEAP32[i52 >> 2] = i38;
    HEAP32[i55 >> 2] = 0;
    __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE(i64, i39, i37, i38, i55, 0, 1);
    i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, 16) | 0;
    i38 = HEAP32[i55 >> 2] | 0;
    if ((i38 | 0) > 0) {
     i37 = 0;
     do {
      i16 = HEAP32[i52 >> 2] | 0;
      i15 = i16 + (i37 * 36 | 0) | 0;
      i14 = i16 + (i37 * 36 | 0) + 24 | 0;
      i5 = HEAP32[i14 >> 2] | 0;
      L26 : do if (!(i5 & 32)) {
       if (i5 & 64 | 0) {
        i8 = HEAP32[i16 + (i37 * 36 | 0) + 32 >> 2] | 0;
        i5 = i8 - (HEAP32[i16 + (i37 * 36 | 0) + 8 >> 2] | 0) | 0;
        i6 = HEAP32[i16 + (i37 * 36 | 0) + 16 >> 2] | 0;
        i7 = HEAP32[i16 + (i37 * 36 | 0) + 20 >> 2] | 0;
        i8 = __ZN5physx2Sn4peekEiPKci(HEAP32[i16 + (i37 * 36 | 0) + 12 >> 2] | 0, i39 + i8 | 0, 0) | 0;
        i9 = getTempRet0() | 0;
        i10 = HEAP32[i14 >> 2] | 0;
        if (!(i10 & 16384)) {
         i11 = 0;
         i12 = 0;
        } else {
         i11 = _bitshift64Lshr(i10 & 16711680 | 0, 0, 16) | 0;
         i12 = getTempRet0() | 0;
        }
        i13 = (i11 | 0) != 0 | (i12 | 0) != 0;
        do if (!(i10 & 8192)) if (i13) if ((i11 & i8 | 0) == 0 & (i12 & i9 | 0) == 0) break L26; else break; else if ((i8 | 0) == 0 & (i9 | 0) == 0) break L26; else break; else if (i13) if ((i11 & i8 | 0) == 0 & (i12 & i9 | 0) == 0) break; else break L26; else if ((i8 | 0) == 0 & (i9 | 0) == 0) break; else break L26; while (0);
        i8 = __ZN5physx2Sn4peekEiPKci(i7, i39 + (i5 + i6) | 0, i10) | 0;
        getTempRet0() | 0;
        i5 = HEAP32[i16 + (i37 * 36 | 0) + 28 >> 2] | 0;
        if (i5) i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
        if (HEAP32[i14 >> 2] & 8 | 0) {
         i2 = __ZN5physx2Sn5ConvX20convertExtraData_PtrEPKcS3_RKNS0_15PxMetaDataEntryEiii(i64, i2, 0, i15, i8, i47, i48) | 0;
         break;
        }
        i6 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, HEAP32[i15 >> 2] | 0, 1) | 0;
        if (!i8) break;
        i7 = i6 + 16 | 0;
        i5 = i8;
        while (1) {
         i5 = i5 + -1 | 0;
         __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i6, 0) | 0;
         i2 = i2 + (HEAP32[i7 >> 2] | 0) | 0;
         if (!i5) break L26;
        }
       }
       if (i5 & 1024 | 0) {
        i5 = i16 + (i37 * 36 | 0) + 28 | 0;
        i6 = HEAP32[i5 >> 2] | 0;
        if (!i6) break;
        HEAP32[i59 >> 2] = i6;
        __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i64, 1, gb + 669080 | 0, i59);
        __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i64, 1, gb + 669100 | 0, i60);
        i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, HEAP32[i5 >> 2] | 0) | 0;
        break;
       }
       if (i5 & 128 | 0) {
        i5 = HEAP32[i16 + (i37 * 36 | 0) + 28 >> 2] | 0;
        if (i5) i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
        i36 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, gb + 827882 | 0, 1) | 0;
        i6 = i36 + 16 | 0;
        i8 = __ZN5physx2Sn4peekEiPKci(HEAP32[i6 >> 2] | 0, i2, 0) | 0;
        getTempRet0() | 0;
        HEAP32[i61 >> 2] = i8;
        __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i64, 1, gb + 669147 | 0, i61);
        __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i36, 0) | 0;
        i2 = i2 + (HEAP32[i6 >> 2] | 0) | 0;
        i6 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, HEAP32[i15 >> 2] | 0, 1) | 0;
        if ((i8 | 0) <= 0) break;
        i7 = i6 + 16 | 0;
        i5 = 0;
        while (1) {
         __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i6, 0) | 0;
         i2 = i2 + (HEAP32[i7 >> 2] | 0) | 0;
         i5 = i5 + 1 | 0;
         if ((i5 | 0) == (i8 | 0)) break L26;
        }
       }
       i5 = HEAP32[i15 >> 2] | 0;
       if (!i41) if (!(_strcmp(i5, gb + 752155 | 0) | 0)) {
        i36 = i1 + 1 | 0;
        i7 = HEAP32[i42 >> 2] | 0;
        i35 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, i5, 1) | 0;
        i6 = __ZN5physx2Sn4peekEiPKci(HEAP32[i16 + (i37 * 36 | 0) + 12 >> 2] | 0, i39 + (HEAP32[i16 + (i37 * 36 | 0) + 32 >> 2] | 0) | 0, HEAP32[i14 >> 2] | 0) | 0;
        getTempRet0() | 0;
        i5 = HEAP32[i16 + (i37 * 36 | 0) + 16 >> 2] | 0;
        if (!i5) i34 = i2; else i34 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
        i2 = i34 + (Math_imul(HEAP32[i35 + 16 >> 2] | 0, i6) | 0) | 0;
        i29 = HEAP32[i7 + (i1 * 28 | 0) + 4 >> 2] | 0;
        i5 = HEAP32[i7 + (i1 * 28 | 0) + 8 >> 2] | 0;
        i30 = i7 + (i1 * 28 | 0) + 12 | 0;
        i8 = HEAP32[i30 >> 2] | 0;
        i31 = i7 + (i1 * 28 | 0) + 16 | 0;
        i6 = HEAP32[i31 >> 2] | 0;
        i32 = HEAP32[i7 + (i1 * 28 | 0) + 20 >> 2] | 0;
        i25 = HEAP32[i7 + (i1 * 28 | 0) + 24 >> 2] | 0;
        i33 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i57, Math_imul(i8 << 2, i6) | 0, gb + 668920 | 0, 33) | 0;
        if ((i25 | 0) > 0) {
         i26 = (i32 | 0) > 0;
         i27 = i32 + -1 | 0;
         i28 = i25 + -1 | 0;
         i24 = i5 + 4 - i6 | 0;
         i9 = i29 + 4 - i8 | 0;
         i6 = (i9 | 0) > 3;
         i7 = (i9 | 0) > 2;
         i8 = (i9 | 0) > 1;
         i9 = (i9 | 0) > 0;
         i21 = 0;
         do {
          if (i26) {
           i10 = Math_imul(i21, i32) | 0;
           i11 = (i21 | 0) < (i28 | 0);
           i12 = i21 << 2;
           i22 = 0;
           do {
            i13 = i22 + i10 << 4;
            i20 = (i22 | 0) < (i27 | 0);
            i14 = i22 << 2;
            i16 = i9 | i20;
            i18 = i8 | i20;
            i19 = i7 | i20;
            i20 = i6 | i20;
            i23 = 0;
            do {
             i15 = (Math_imul(i23 + i12 | 0, i29) | 0) + i14 | 0;
             i17 = i11 | (i23 | 0) < (i24 | 0);
             i5 = (i23 << 2) + i13 << 2;
             i1 = i33 + i5 | 0;
             if (i16 & i17) {
              i65 = i34 + (i15 << 2) | 0;
              i65 = HEAPU8[i65 >> 0] | HEAPU8[i65 + 1 >> 0] << 8 | HEAPU8[i65 + 2 >> 0] << 16 | HEAPU8[i65 + 3 >> 0] << 24;
              HEAP8[i1 >> 0] = i65;
              HEAP8[i1 + 1 >> 0] = i65 >> 8;
              HEAP8[i1 + 2 >> 0] = i65 >> 16;
              HEAP8[i1 + 3 >> 0] = i65 >> 24;
             } else {
              HEAP8[i1 >> 0] = 0;
              HEAP8[i1 + 1 >> 0] = 0;
              HEAP8[i1 + 2 >> 0] = 0;
              HEAP8[i1 + 3 >> 0] = 0;
             }
             i1 = i33 + (i5 | 4) | 0;
             if (i18 & i17) {
              i65 = i34 + ((i15 << 2) + 4) | 0;
              i65 = HEAPU8[i65 >> 0] | HEAPU8[i65 + 1 >> 0] << 8 | HEAPU8[i65 + 2 >> 0] << 16 | HEAPU8[i65 + 3 >> 0] << 24;
              HEAP8[i1 >> 0] = i65;
              HEAP8[i1 + 1 >> 0] = i65 >> 8;
              HEAP8[i1 + 2 >> 0] = i65 >> 16;
              HEAP8[i1 + 3 >> 0] = i65 >> 24;
             } else {
              HEAP8[i1 >> 0] = 0;
              HEAP8[i1 + 1 >> 0] = 0;
              HEAP8[i1 + 2 >> 0] = 0;
              HEAP8[i1 + 3 >> 0] = 0;
             }
             i1 = i33 + (i5 | 8) | 0;
             if (i19 & i17) {
              i65 = i34 + ((i15 << 2) + 8) | 0;
              i65 = HEAPU8[i65 >> 0] | HEAPU8[i65 + 1 >> 0] << 8 | HEAPU8[i65 + 2 >> 0] << 16 | HEAPU8[i65 + 3 >> 0] << 24;
              HEAP8[i1 >> 0] = i65;
              HEAP8[i1 + 1 >> 0] = i65 >> 8;
              HEAP8[i1 + 2 >> 0] = i65 >> 16;
              HEAP8[i1 + 3 >> 0] = i65 >> 24;
             } else {
              HEAP8[i1 >> 0] = 0;
              HEAP8[i1 + 1 >> 0] = 0;
              HEAP8[i1 + 2 >> 0] = 0;
              HEAP8[i1 + 3 >> 0] = 0;
             }
             i1 = i33 + (i5 | 12) | 0;
             if (i20 & i17) {
              i65 = i34 + ((i15 << 2) + 12) | 0;
              i65 = HEAPU8[i65 >> 0] | HEAPU8[i65 + 1 >> 0] << 8 | HEAPU8[i65 + 2 >> 0] << 16 | HEAPU8[i65 + 3 >> 0] << 24;
              HEAP8[i1 >> 0] = i65;
              HEAP8[i1 + 1 >> 0] = i65 >> 8;
              HEAP8[i1 + 2 >> 0] = i65 >> 16;
              HEAP8[i1 + 3 >> 0] = i65 >> 24;
             } else {
              HEAP8[i1 >> 0] = 0;
              HEAP8[i1 + 1 >> 0] = 0;
              HEAP8[i1 + 2 >> 0] = 0;
              HEAP8[i1 + 3 >> 0] = 0;
             }
             i23 = i23 + 1 | 0;
            } while ((i23 | 0) != 4);
            i22 = i22 + 1 | 0;
           } while ((i22 | 0) != (i32 | 0));
          }
          i21 = i21 + 1 | 0;
         } while ((i21 | 0) != (i25 | 0));
        }
        __ZN5physx2Sn5ConvX11alignTargetEi(i64, 16);
        i1 = Math_imul(HEAP32[i31 >> 2] | 0, HEAP32[i30 >> 2] | 0) | 0;
        if (i1 | 0) {
         i5 = i33;
         while (1) {
          i1 = i1 + -1 | 0;
          __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i5, i35, 0) | 0;
          if (!i1) break; else i5 = i5 + 4 | 0;
         }
        }
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i51, i33);
        i1 = i36;
        break;
       }
       i8 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, i5, 1) | 0;
       i7 = __ZN5physx2Sn4peekEiPKci(HEAP32[i16 + (i37 * 36 | 0) + 12 >> 2] | 0, i39 + (HEAP32[i16 + (i37 * 36 | 0) + 32 >> 2] | 0) | 0, HEAP32[i14 >> 2] | 0) | 0;
       getTempRet0() | 0;
       i5 = HEAP32[i16 + (i37 * 36 | 0) + 28 >> 2] | 0;
       if (i5) i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
       if ((i7 | 0) > 0) {
        i6 = i8 + 16 | 0;
        i5 = 0;
        do {
         __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i8, 0) | 0;
         i2 = i2 + (HEAP32[i6 >> 2] | 0) | 0;
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i7 | 0));
       }
      } else {
       i5 = HEAP32[i15 >> 2] | 0;
       if (!(_strcmp(i5, gb + 753033 | 0) | 0)) {
        i6 = i3 + 1 | 0;
        if (!(HEAP8[(HEAP32[i43 >> 2] | 0) + i3 >> 0] | 0)) i3 = i6; else {
         __ZN5physx2Sn5ConvX11setNoOutputEb(i64, 1);
         i5 = HEAP32[i15 >> 2] | 0;
         i3 = i6;
        }
       }
       i6 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, i5, 1) | 0;
       i65 = __ZN5physx2Sn4peekEiPKci(HEAP32[i16 + (i37 * 36 | 0) + 20 >> 2] | 0, i39 + (HEAP32[i16 + (i37 * 36 | 0) + 32 >> 2] | 0) | 0, 0) | 0;
       if (!((i65 | 0) == 0 & (getTempRet0() | 0) == 0)) {
        i5 = HEAP32[i16 + (i37 * 36 | 0) + 28 >> 2] | 0;
        if (!i5) i18 = i2; else i18 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
        __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i18, i6, 0) | 0;
        i2 = i18 + (HEAP32[i6 + 16 >> 2] | 0) | 0;
        HEAP8[i44 >> 0] = 1;
        i17 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i50, 9216, gb + 668920 | 0, 972) | 0;
        HEAP32[i53 >> 2] = i17;
        HEAP32[i56 >> 2] = 0;
        __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE(i64, i39, i6, i17, i56, 0, 1);
        i17 = HEAP32[i56 >> 2] | 0;
        if ((i17 | 0) > 0) {
         i16 = 0;
         do {
          i13 = HEAP32[i53 >> 2] | 0;
          i14 = i13 + (i16 * 36 | 0) | 0;
          i15 = i13 + (i16 * 36 | 0) + 24 | 0;
          i5 = HEAP32[i15 >> 2] | 0;
          L125 : do if (!(i5 & 64)) {
           i6 = i13 + (i16 * 36 | 0) + 28 | 0;
           do if (i5 & 1024 | 0) {
            i5 = HEAP32[i6 >> 2] | 0;
            if (!i5) break;
            i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
            break L125;
           } while (0);
           i8 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, HEAP32[i14 >> 2] | 0, 1) | 0;
           i7 = __ZN5physx2Sn4peekEiPKci(HEAP32[i13 + (i16 * 36 | 0) + 12 >> 2] | 0, i18 + (HEAP32[i13 + (i16 * 36 | 0) + 32 >> 2] | 0) | 0, HEAP32[i15 >> 2] | 0) | 0;
           getTempRet0() | 0;
           i5 = HEAP32[i6 >> 2] | 0;
           if (i5) i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
           if ((i7 | 0) <= 0) break;
           i6 = i8 + 16 | 0;
           i5 = 0;
           do {
            __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i8, 0) | 0;
            i2 = i2 + (HEAP32[i6 >> 2] | 0) | 0;
            i5 = i5 + 1 | 0;
           } while ((i5 | 0) != (i7 | 0));
          } else {
           i5 = HEAP32[i13 + (i16 * 36 | 0) + 16 >> 2] | 0;
           i6 = HEAP32[i13 + (i16 * 36 | 0) + 20 >> 2] | 0;
           i7 = __ZN5physx2Sn4peekEiPKci(HEAP32[i13 + (i16 * 36 | 0) + 12 >> 2] | 0, i18 + (HEAP32[i13 + (i16 * 36 | 0) + 8 >> 2] | 0) | 0, 0) | 0;
           i8 = getTempRet0() | 0;
           i9 = HEAP32[i15 >> 2] | 0;
           if (!(i9 & 16384)) {
            i10 = 0;
            i11 = 0;
           } else {
            i10 = _bitshift64Lshr(i9 & 16711680 | 0, 0, 16) | 0;
            i11 = getTempRet0() | 0;
           }
           i12 = (i10 | 0) != 0 | (i11 | 0) != 0;
           do if (!(i9 & 8192)) if (i12) if ((i10 & i7 | 0) == 0 & (i11 & i8 | 0) == 0) break L125; else break; else if ((i7 | 0) == 0 & (i8 | 0) == 0) break L125; else break; else if (i12) if ((i10 & i7 | 0) == 0 & (i11 & i8 | 0) == 0) break; else break L125; else if ((i7 | 0) == 0 & (i8 | 0) == 0) break; else break L125; while (0);
           i8 = __ZN5physx2Sn4peekEiPKci(i6, i18 + i5 | 0, i9) | 0;
           getTempRet0() | 0;
           i5 = HEAP32[i13 + (i16 * 36 | 0) + 28 >> 2] | 0;
           if (i5) i2 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i64, i2, i5) | 0;
           if (HEAP32[i15 >> 2] & 8 | 0) break;
           i6 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i64, HEAP32[i14 >> 2] | 0, 1) | 0;
           if (!i8) break;
           i7 = i6 + 16 | 0;
           i5 = i8;
           do {
            i5 = i5 + -1 | 0;
            __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i64, i2, i6, 0) | 0;
            i2 = i2 + (HEAP32[i7 >> 2] | 0) | 0;
           } while ((i5 | 0) != 0);
          } while (0);
          i16 = i16 + 1 | 0;
         } while ((i16 | 0) < (i17 | 0));
        }
        if (HEAP8[i44 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i53, HEAP32[i53 >> 2] | 0);
       }
       __ZN5physx2Sn5ConvX11setNoOutputEb(i64, 0);
      } while (0);
      i37 = i37 + 1 | 0;
     } while ((i37 | 0) < (i38 | 0));
    }
    if (HEAP8[i45 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i52, HEAP32[i52 >> 2] | 0);
    i40 = i40 + 1 | 0;
    if ((i40 | 0) == (i63 | 0)) {
     i7 = 113;
     break;
    }
   }
  }
 }
 if ((i7 | 0) == 113) if (!i46) {
  i65 = 1;
  STACKTOP = i62;
  return i65 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i54, i46);
 i65 = 1;
 STACKTOP = i62;
 return i65 | 0;
}

function __ZN5physx22getImpulseResponseSlowERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_(i22, i12, i3, i32, i20, i5, i25) {
 i22 = i22 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i32 = i32 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i4 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i21 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 1408 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34 + 1152 | 0;
 i31 = i34 + 128 | 0;
 i26 = i34 + 96 | 0;
 i23 = i34 + 64 | 0;
 i24 = i34 + 32 | 0;
 i29 = i34;
 i21 = i22 + 26 | 0;
 i30 = i22 + ((HEAPU16[i21 >> 1] | 0) + 144) | 0;
 i27 = i22 + (((HEAPU16[i22 + 8 >> 1] | 0) * 432 | 0) + (HEAPU16[i22 + 24 >> 1] | 0)) | 0;
 i28 = i22 + (HEAPU16[i22 + 10 >> 1] | 0) | 0;
 L1 : do if ((i12 | 0) == (i20 | 0)) i4 = i12; else {
  i2 = i12;
  i1 = i20;
  while (1) {
   while (1) {
    if (i2 >>> 0 >= i1 >>> 0) break;
    i1 = HEAPU8[i22 + 64 + i1 >> 0] | 0;
    if ((i2 | 0) == (i1 | 0)) {
     i4 = i2;
     break L1;
    }
   }
   i2 = HEAPU8[i22 + 64 + i2 >> 0] | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i4 = i1;
    break;
   }
  }
 } while (0);
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(-f17);
 f15 = Math_fround(-f15);
 f16 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f10 = Math_fround(-f10);
 f11 = Math_fround(-f11);
 f9 = Math_fround(-Math_fround(HEAPF32[i3 + 24 >> 2]));
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(-f6);
 f7 = Math_fround(-f7);
 f18 = Math_fround(-Math_fround(HEAPF32[i5 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f14 = Math_fround(-f14);
 f13 = Math_fround(-f13);
 f8 = Math_fround(-Math_fround(HEAPF32[i5 + 24 >> 2]));
 if ((i4 | 0) == (i12 | 0)) i1 = 0; else {
  i2 = 0;
  while (1) {
   f35 = Math_fround(HEAPF32[i28 + (i12 << 5) + 16 >> 2]);
   f40 = Math_fround(HEAPF32[i28 + (i12 << 5) + 20 >> 2]);
   f37 = Math_fround(HEAPF32[i28 + (i12 << 5) + 24 >> 2]);
   f39 = Math_fround(f10 + Math_fround(Math_fround(f15 * f37) - Math_fround(f16 * f40)));
   f37 = Math_fround(f11 + Math_fround(Math_fround(f16 * f35) - Math_fround(f17 * f37)));
   f35 = Math_fround(f9 + Math_fround(Math_fround(f17 * f40) - Math_fround(f15 * f35)));
   HEAPF32[i31 + (i12 << 4) >> 2] = f39;
   HEAPF32[i31 + (i12 << 4) + 4 >> 2] = f37;
   HEAPF32[i31 + (i12 << 4) + 8 >> 2] = f35;
   HEAPF32[i31 + (i12 << 4) + 12 >> 2] = Math_fround(0.0);
   f40 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 4 >> 2]);
   f44 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 8 >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 32 >> 2]);
   f41 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 36 >> 2]);
   f45 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 40 >> 2]);
   f47 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 64 >> 2]);
   f46 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 68 >> 2]);
   f47 = Math_fround(Math_fround(f40 * f39) + Math_fround(Math_fround(f37 * f43) + Math_fround(f35 * f47)));
   f46 = Math_fround(Math_fround(f38 * f39) + Math_fround(Math_fround(f37 * f41) + Math_fround(f35 * f46)));
   f45 = Math_fround(Math_fround(f39 * f44) + Math_fround(Math_fround(f37 * f45) + Math_fround(f35 * Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 72 >> 2]))));
   f44 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 16 >> 2]);
   f41 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 20 >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 24 >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 48 >> 2]);
   f40 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 52 >> 2]);
   f19 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 56 >> 2]);
   f42 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 80 >> 2]);
   f36 = Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 84 >> 2]);
   f17 = Math_fround(f17 - f47);
   f15 = Math_fround(f15 - f46);
   f16 = Math_fround(f16 - f45);
   f10 = Math_fround(f10 - Math_fround(Math_fround(f39 * f44) + Math_fround(Math_fround(f37 * f43) + Math_fround(f35 * f42))));
   f36 = Math_fround(f11 - Math_fround(Math_fround(f39 * f41) + Math_fround(Math_fround(f37 * f40) + Math_fround(f35 * f36))));
   f35 = Math_fround(f9 - Math_fround(Math_fround(f39 * f38) + Math_fround(Math_fround(f37 * f19) + Math_fround(f35 * Math_fround(HEAPF32[i30 + (i12 * 160 | 0) + 88 >> 2])))));
   f19 = Math_fround(HEAPF32[i28 + (i12 << 5) >> 2]);
   f9 = Math_fround(HEAPF32[i28 + (i12 << 5) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i28 + (i12 << 5) + 8 >> 2]);
   f10 = Math_fround(f10 + Math_fround(Math_fround(f16 * f9) - Math_fround(f15 * f11)));
   f11 = Math_fround(f36 + Math_fround(Math_fround(f17 * f11) - Math_fround(f16 * f19)));
   f9 = Math_fround(f35 + Math_fround(Math_fround(f15 * f19) - Math_fround(f17 * f9)));
   i1 = i2 + 1 | 0;
   HEAP32[i33 + (i2 << 2) >> 2] = i12;
   i12 = HEAPU8[i22 + 64 + i12 >> 0] | 0;
   if ((i12 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 if ((i4 | 0) == (i20 | 0)) {
  f19 = f8;
  f8 = f18;
  i2 = i1;
 } else {
  i5 = i20;
  i3 = i1;
  while (1) {
   f46 = Math_fround(HEAPF32[i28 + (i5 << 5) + 16 >> 2]);
   f41 = Math_fround(HEAPF32[i28 + (i5 << 5) + 20 >> 2]);
   f44 = Math_fround(HEAPF32[i28 + (i5 << 5) + 24 >> 2]);
   f42 = Math_fround(f14 + Math_fround(Math_fround(f7 * f44) - Math_fround(f18 * f41)));
   f44 = Math_fround(f13 + Math_fround(Math_fround(f18 * f46) - Math_fround(f6 * f44)));
   f46 = Math_fround(f8 + Math_fround(Math_fround(f6 * f41) - Math_fround(f7 * f46)));
   HEAPF32[i31 + (i5 << 4) >> 2] = f42;
   HEAPF32[i31 + (i5 << 4) + 4 >> 2] = f44;
   HEAPF32[i31 + (i5 << 4) + 8 >> 2] = f46;
   HEAPF32[i31 + (i5 << 4) + 12 >> 2] = Math_fround(0.0);
   f41 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 8 >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 32 >> 2]);
   f40 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 36 >> 2]);
   f36 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 40 >> 2]);
   f19 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 64 >> 2]);
   f35 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 68 >> 2]);
   f19 = Math_fround(Math_fround(f41 * f42) + Math_fround(Math_fround(f44 * f38) + Math_fround(f46 * f19)));
   f35 = Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f44 * f40) + Math_fround(f46 * f35)));
   f36 = Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f44 * f36) + Math_fround(f46 * Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 72 >> 2]))));
   f37 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 16 >> 2]);
   f40 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 20 >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 24 >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 48 >> 2]);
   f41 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 52 >> 2]);
   f47 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 56 >> 2]);
   f39 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 80 >> 2]);
   f45 = Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 84 >> 2]);
   f6 = Math_fround(f6 - f19);
   f7 = Math_fround(f7 - f35);
   f18 = Math_fround(f18 - f36);
   f14 = Math_fround(f14 - Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f44 * f38) + Math_fround(f46 * f39))));
   f45 = Math_fround(f13 - Math_fround(Math_fround(f42 * f40) + Math_fround(Math_fround(f44 * f41) + Math_fround(f46 * f45))));
   f46 = Math_fround(f8 - Math_fround(Math_fround(f42 * f43) + Math_fround(Math_fround(f44 * f47) + Math_fround(f46 * Math_fround(HEAPF32[i30 + (i5 * 160 | 0) + 88 >> 2])))));
   f47 = Math_fround(HEAPF32[i28 + (i5 << 5) >> 2]);
   f8 = Math_fround(HEAPF32[i28 + (i5 << 5) + 4 >> 2]);
   f13 = Math_fround(HEAPF32[i28 + (i5 << 5) + 8 >> 2]);
   f14 = Math_fround(f14 + Math_fround(Math_fround(f18 * f8) - Math_fround(f7 * f13)));
   f13 = Math_fround(f45 + Math_fround(Math_fround(f6 * f13) - Math_fround(f18 * f47)));
   f8 = Math_fround(f46 + Math_fround(Math_fround(f7 * f47) - Math_fround(f6 * f8)));
   i2 = i3 + 1 | 0;
   HEAP32[i33 + (i3 << 2) >> 2] = i5;
   i5 = HEAPU8[i22 + 64 + i5 >> 0] | 0;
   if ((i5 | 0) == (i4 | 0)) {
    f19 = f8;
    f8 = f18;
    break;
   } else i3 = i2;
  }
 }
 f6 = Math_fround(f17 + f6);
 f7 = Math_fround(f15 + f7);
 f8 = Math_fround(f16 + f8);
 f10 = Math_fround(f10 + f14);
 f11 = Math_fround(f11 + f13);
 f9 = Math_fround(f9 + f19);
 if (!i4) i3 = i2; else {
  i5 = i2;
  while (1) {
   f46 = Math_fround(HEAPF32[i28 + (i4 << 5) + 16 >> 2]);
   f41 = Math_fround(HEAPF32[i28 + (i4 << 5) + 20 >> 2]);
   f44 = Math_fround(HEAPF32[i28 + (i4 << 5) + 24 >> 2]);
   f42 = Math_fround(f10 + Math_fround(Math_fround(f7 * f44) - Math_fround(f8 * f41)));
   f44 = Math_fround(f11 + Math_fround(Math_fround(f8 * f46) - Math_fround(f6 * f44)));
   f46 = Math_fround(f9 + Math_fround(Math_fround(f6 * f41) - Math_fround(f7 * f46)));
   HEAPF32[i31 + (i4 << 4) >> 2] = f42;
   HEAPF32[i31 + (i4 << 4) + 4 >> 2] = f44;
   HEAPF32[i31 + (i4 << 4) + 8 >> 2] = f46;
   HEAPF32[i31 + (i4 << 4) + 12 >> 2] = Math_fround(0.0);
   f41 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 8 >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 32 >> 2]);
   f40 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 36 >> 2]);
   f36 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 40 >> 2]);
   f19 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 64 >> 2]);
   f35 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 68 >> 2]);
   f19 = Math_fround(Math_fround(f41 * f42) + Math_fround(Math_fround(f44 * f38) + Math_fround(f46 * f19)));
   f35 = Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f44 * f40) + Math_fround(f46 * f35)));
   f36 = Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f44 * f36) + Math_fround(f46 * Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 72 >> 2]))));
   f37 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 16 >> 2]);
   f40 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 20 >> 2]);
   f43 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 24 >> 2]);
   f38 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 48 >> 2]);
   f41 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 52 >> 2]);
   f47 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 56 >> 2]);
   f39 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 80 >> 2]);
   f45 = Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 84 >> 2]);
   f6 = Math_fround(f6 - f19);
   f7 = Math_fround(f7 - f35);
   f8 = Math_fround(f8 - f36);
   f10 = Math_fround(f10 - Math_fround(Math_fround(f42 * f37) + Math_fround(Math_fround(f44 * f38) + Math_fround(f46 * f39))));
   f45 = Math_fround(f11 - Math_fround(Math_fround(f42 * f40) + Math_fround(Math_fround(f44 * f41) + Math_fround(f46 * f45))));
   f46 = Math_fround(f9 - Math_fround(Math_fround(f42 * f43) + Math_fround(Math_fround(f44 * f47) + Math_fround(f46 * Math_fround(HEAPF32[i30 + (i4 * 160 | 0) + 88 >> 2])))));
   f47 = Math_fround(HEAPF32[i28 + (i4 << 5) >> 2]);
   f9 = Math_fround(HEAPF32[i28 + (i4 << 5) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i28 + (i4 << 5) + 8 >> 2]);
   f10 = Math_fround(f10 + Math_fround(Math_fround(f8 * f9) - Math_fround(f7 * f11)));
   f11 = Math_fround(f45 + Math_fround(Math_fround(f6 * f11) - Math_fround(f8 * f47)));
   f9 = Math_fround(f46 + Math_fround(Math_fround(f7 * f47) - Math_fround(f6 * f9)));
   i3 = i5 + 1 | 0;
   HEAP32[i33 + (i5 << 2) >> 2] = i4;
   i4 = HEAP8[i22 + 64 + i4 >> 0] | 0;
   if (!(i4 << 24 >> 24)) break; else {
    i4 = i4 & 255;
    i5 = i3;
   }
  }
 }
 i21 = HEAPU16[i21 >> 1] | 0;
 f35 = Math_fround(-f6);
 f46 = Math_fround(-f7);
 f40 = Math_fround(-f8);
 f37 = Math_fround(-f10);
 f41 = Math_fround(-f11);
 f47 = Math_fround(-f9);
 f11 = Math_fround(Math_fround(HEAPF32[i22 + i21 >> 2]) * f35);
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 16) >> 2]) * f46));
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 32) >> 2]) * f40));
 f13 = Math_fround(Math_fround(HEAPF32[i22 + (i21 + 4) >> 2]) * f35);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 20) >> 2]) * f46));
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 36) >> 2]) * f40));
 f14 = Math_fround(Math_fround(HEAPF32[i22 + (i21 + 8) >> 2]) * f35);
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 24) >> 2]) * f46));
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 40) >> 2]) * f40));
 f15 = Math_fround(HEAPF32[i22 + (i21 + 48) >> 2]);
 f42 = Math_fround(f15 * f37);
 f17 = Math_fround(HEAPF32[i22 + (i21 + 64) >> 2]);
 f42 = Math_fround(f42 + Math_fround(f17 * f41));
 f19 = Math_fround(HEAPF32[i22 + (i21 + 80) >> 2]);
 f42 = Math_fround(f42 + Math_fround(f19 * f47));
 f16 = Math_fround(HEAPF32[i22 + (i21 + 52) >> 2]);
 f43 = Math_fround(f16 * f37);
 f18 = Math_fround(HEAPF32[i22 + (i21 + 68) >> 2]);
 f43 = Math_fround(f43 + Math_fround(f18 * f41));
 f36 = Math_fround(HEAPF32[i22 + (i21 + 84) >> 2]);
 f43 = Math_fround(f43 + Math_fround(f36 * f47));
 f38 = Math_fround(HEAPF32[i22 + (i21 + 56) >> 2]);
 f44 = Math_fround(f38 * f37);
 f39 = Math_fround(HEAPF32[i22 + (i21 + 72) >> 2]);
 f44 = Math_fround(f44 + Math_fround(f39 * f41));
 f45 = Math_fround(HEAPF32[i22 + (i21 + 88) >> 2]);
 f42 = Math_fround(f11 + f42);
 f43 = Math_fround(f13 + f43);
 f44 = Math_fround(f14 + Math_fround(f44 + Math_fround(f45 * f47)));
 f38 = Math_fround(Math_fround(Math_fround(f15 * f35) + Math_fround(f16 * f46)) + Math_fround(f38 * f40));
 f39 = Math_fround(Math_fround(Math_fround(f17 * f35) + Math_fround(f18 * f46)) + Math_fround(f39 * f40));
 f40 = Math_fround(Math_fround(Math_fround(f19 * f35) + Math_fround(f36 * f46)) + Math_fround(f45 * f40));
 f45 = Math_fround(Math_fround(HEAPF32[i22 + (i21 + 96) >> 2]) * f37);
 f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 112) >> 2]) * f41));
 f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 128) >> 2]) * f47));
 f46 = Math_fround(Math_fround(HEAPF32[i22 + (i21 + 100) >> 2]) * f37);
 f46 = Math_fround(f46 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 116) >> 2]) * f41));
 f46 = Math_fround(f46 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 132) >> 2]) * f47));
 f37 = Math_fround(Math_fround(HEAPF32[i22 + (i21 + 104) >> 2]) * f37);
 f41 = Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 120) >> 2]) * f41));
 f45 = Math_fround(f38 + f45);
 f46 = Math_fround(f39 + f46);
 f47 = Math_fround(f40 + Math_fround(f41 + Math_fround(Math_fround(HEAPF32[i22 + (i21 + 136) >> 2]) * f47)));
 HEAPF32[i26 >> 2] = f42;
 HEAPF32[i26 + 4 >> 2] = f43;
 HEAPF32[i26 + 8 >> 2] = f44;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 16 >> 2] = f45;
 HEAPF32[i26 + 20 >> 2] = f46;
 HEAPF32[i26 + 24 >> 2] = f47;
 HEAPF32[i26 + 28 >> 2] = Math_fround(0.0);
 if (i3 >>> 0 > i2 >>> 0) {
  i5 = i26 + 16 | 0;
  i4 = i23 + 16 | 0;
  do {
   i3 = i3 + -1 | 0;
   i22 = HEAP32[i33 + (i3 << 2) >> 2] | 0;
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i23, i30 + (i22 * 160 | 0) | 0, i28 + (i22 << 5) | 0, i31 + (i22 << 4) | 0, i26, i27 + (i22 * 96 | 0) | 0);
   HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i26 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i26 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  } while (i3 >>> 0 > i2 >>> 0);
 } else i5 = i26 + 16 | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 i3 = i25 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 if (i2 >>> 0 > i1 >>> 0) {
  i4 = i24 + 16 | 0;
  do {
   i2 = i2 + -1 | 0;
   i23 = HEAP32[i33 + (i2 << 2) >> 2] | 0;
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i24, i30 + (i23 * 160 | 0) | 0, i28 + (i23 << 5) | 0, i31 + (i23 << 4) | 0, i25, i27 + (i23 * 96 | 0) | 0);
   HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  } while (i2 >>> 0 > i1 >>> 0);
 };
 HEAP32[i32 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 i3 = i32 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 if (!i1) {
  STACKTOP = i34;
  return;
 }
 i2 = i29 + 16 | 0;
 do {
  i1 = i1 + -1 | 0;
  i26 = HEAP32[i33 + (i1 << 2) >> 2] | 0;
  __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i29, i30 + (i26 * 160 | 0) | 0, i28 + (i26 << 5) | 0, i31 + (i26 << 4) | 0, i32, i27 + (i26 * 96 | 0) | 0);
  HEAP32[i32 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 } while ((i1 | 0) != 0);
 STACKTOP = i34;
 return;
}

function __ZNK13InitialModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4Eb(i39, i4, i5, i48, i1, i49, i3, i47) {
 i39 = i39 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i48 = i48 | 0;
 i1 = i1 | 0;
 i49 = i49 | 0;
 i3 = i3 | 0;
 i47 = i47 | 0;
 var i2 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i50 + 32 | 0;
 i46 = i50 + 16 | 0;
 i42 = i50;
 f40 = Math_fround(HEAPF32[i5 + 396 >> 2]);
 f40 = Math_fround(f40 / Math_fround(HEAPF32[i4 + 264 >> 2]));
 i43 = i39 + 2276 | 0;
 i41 = i39 + 2360 | 0;
 i44 = i39 + 2356 | 0;
 i2 = Math_fround(HEAPF32[i44 >> 2]) == Math_fround(0.0);
 L1 : do if ((HEAPU16[i41 >> 1] | 0) < 2) {
  do if (i2) {
   f8 = Math_fround(0.0);
   f15 = Math_fround(0.0);
   f9 = Math_fround(0.0);
  } else {
   i2 = __Z11GetIPhysicsv() | 0;
   if (i2 | 0) {
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i45 | 0, i2 | 0);
    f8 = Math_fround(HEAPF32[i45 >> 2]);
    f9 = Math_fround(HEAPF32[i45 + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i45 + 8 >> 2]);
    break;
   }
   i37 = Math_fround(HEAPF32[i44 >> 2]) != Math_fround(0.0);
   if (i37 & (HEAP8[gb + 1548983 >> 0] | 0) == 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 613558 | 0, 0, gb + 613743 | 0, 59, 512, 0, 0, 0);
    HEAP8[gb + 1548983 >> 0] = 1;
    f8 = Math_fround(0.0);
    f15 = Math_fround(0.0);
    f9 = Math_fround(-9.81000041);
   } else {
    f8 = Math_fround(0.0);
    f15 = Math_fround(0.0);
    f9 = Math_fround(-9.81000041);
   }
  } while (0);
  f24 = Math_fround(Math_fround(0.0) - f8);
  f25 = Math_fround(Math_fround(0.0) - f9);
  f38 = Math_fround(Math_fround(0.0) - f15);
  if (!(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(Math_fround(f38 * f38) + Math_fround(0.0))) <= Math_fround(9.99999905e-09))) {
   HEAPF32[i46 + 12 >> 2] = f40;
   HEAPF32[i46 + 8 >> 2] = f40;
   HEAPF32[i46 + 4 >> 2] = f40;
   HEAPF32[i46 >> 2] = f40;
   HEAPF32[i42 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i42 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i42 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i42 >> 2] = Math_fround(1.0);
   i2 = HEAP32[i41 >> 2] | 0;
   L11 : do switch ((i2 & 65535) << 16 >> 16) {
   case 0:
    {
     i46 = HEAP32[i44 >> 2] | 0;
     HEAP32[i45 + 12 >> 2] = i46;
     HEAP32[i45 + 8 >> 2] = i46;
     HEAP32[i45 + 4 >> 2] = i46;
     HEAP32[i45 >> 2] = i46;
     break;
    }
   case 3:
    {
     f40 = Math_fround(HEAPF32[(HEAP32[i39 + 2508 >> 2] | 0) + 4 >> 2]);
     f38 = Math_fround(HEAPF32[i44 >> 2]);
     f40 = Math_fround(f40 * f38);
     f40 = Math_fround(f40 + Math_fround(Math_fround(f38 * Math_fround(HEAPF32[(HEAP32[i39 + 2420 >> 2] | 0) + 4 >> 2])) - f40));
     HEAPF32[i45 >> 2] = f40;
     HEAPF32[i45 + 4 >> 2] = f40;
     HEAPF32[i45 + 8 >> 2] = f40;
     HEAPF32[i45 + 12 >> 2] = f40;
     break;
    }
   default:
    if (!(i2 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i45, i43, i46, i42);
     break L11;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i45, i43, i46, i42);
     break L11;
    }
   } while (0);
   f10 = Math_fround(HEAPF32[i45 >> 2]);
   f10 = Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2]));
   f16 = Math_fround(HEAPF32[i45 + 4 >> 2]);
   f16 = Math_fround(f16 * Math_fround(HEAPF32[i3 + 4 >> 2]));
   f38 = Math_fround(HEAPF32[i45 + 8 >> 2]);
   f38 = Math_fround(f38 * Math_fround(HEAPF32[i3 + 8 >> 2]));
   f40 = Math_fround(HEAPF32[i45 + 12 >> 2]);
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i3 + 12 >> 2]));
   f12 = Math_fround(f8 * f10);
   f7 = Math_fround(f8 * f16);
   f17 = Math_fround(f8 * f38);
   f18 = Math_fround(f8 * f40);
   f11 = Math_fround(f9 * f10);
   f19 = Math_fround(f9 * f16);
   f13 = Math_fround(f9 * f38);
   f14 = Math_fround(f9 * f40);
   f10 = Math_fround(f15 * f10);
   f16 = Math_fround(f15 * f16);
   f9 = Math_fround(f15 * f38);
   f8 = Math_fround(f15 * f40);
   if ((HEAP32[i4 + 280 >> 2] | 0) == 1) {
    f15 = f12;
    f20 = f17;
    f21 = f18;
    f22 = f11;
    f23 = f19;
    f24 = f13;
    f25 = f14;
    f11 = f16;
   } else {
    f51 = Math_fround(HEAPF32[i5 + 180 >> 2]);
    f56 = Math_fround(HEAPF32[i5 + 184 >> 2]);
    f54 = Math_fround(HEAPF32[i5 + 188 >> 2]);
    f38 = Math_fround(HEAPF32[i5 + 196 >> 2]);
    f55 = Math_fround(HEAPF32[i5 + 200 >> 2]);
    f53 = Math_fround(HEAPF32[i5 + 204 >> 2]);
    f40 = Math_fround(HEAPF32[i5 + 212 >> 2]);
    f25 = Math_fround(HEAPF32[i5 + 216 >> 2]);
    f52 = Math_fround(HEAPF32[i5 + 220 >> 2]);
    f15 = Math_fround(Math_fround(Math_fround(f12 * f51) + Math_fround(f11 * f38)) + Math_fround(f10 * f40));
    f20 = Math_fround(Math_fround(Math_fround(f17 * f51) + Math_fround(f13 * f38)) + Math_fround(f9 * f40));
    f21 = Math_fround(Math_fround(Math_fround(f18 * f51) + Math_fround(f14 * f38)) + Math_fround(f8 * f40));
    f22 = Math_fround(Math_fround(Math_fround(f12 * f56) + Math_fround(f11 * f55)) + Math_fround(f10 * f25));
    f23 = Math_fround(Math_fround(Math_fround(f7 * f56) + Math_fround(f19 * f55)) + Math_fround(f16 * f25));
    f24 = Math_fround(Math_fround(Math_fround(f17 * f56) + Math_fround(f13 * f55)) + Math_fround(f9 * f25));
    f25 = Math_fround(Math_fround(Math_fround(f18 * f56) + Math_fround(f14 * f55)) + Math_fround(f8 * f25));
    f10 = Math_fround(Math_fround(Math_fround(f12 * f54) + Math_fround(f11 * f53)) + Math_fround(f10 * f52));
    f11 = Math_fround(Math_fround(Math_fround(f7 * f54) + Math_fround(f19 * f53)) + Math_fround(f16 * f52));
    f9 = Math_fround(Math_fround(Math_fround(f17 * f54) + Math_fround(f13 * f53)) + Math_fround(f9 * f52));
    f8 = Math_fround(Math_fround(Math_fround(f18 * f54) + Math_fround(f14 * f53)) + Math_fround(f8 * f52));
    f7 = Math_fround(Math_fround(Math_fround(f7 * f51) + Math_fround(f19 * f38)) + Math_fround(f16 * f40));
   }
   if (i1 >>> 0 < i49 >>> 0) {
    i3 = HEAP32[i48 + 60 >> 2] | 0;
    i4 = HEAP32[i48 + 80 >> 2] | 0;
    i5 = HEAP32[i48 + 100 >> 2] | 0;
    i2 = i1;
    do {
     i33 = i3 + (i2 << 2) | 0;
     f16 = Math_fround(HEAPF32[i33 >> 2]);
     i34 = i33 + 4 | 0;
     f17 = Math_fround(HEAPF32[i34 >> 2]);
     i35 = i33 + 8 | 0;
     f18 = Math_fround(HEAPF32[i35 >> 2]);
     i36 = i33 + 12 | 0;
     f19 = Math_fround(HEAPF32[i36 >> 2]);
     i37 = i4 + (i2 << 2) | 0;
     f38 = Math_fround(HEAPF32[i37 >> 2]);
     i39 = i37 + 4 | 0;
     f40 = Math_fround(HEAPF32[i39 >> 2]);
     i41 = i37 + 8 | 0;
     f51 = Math_fround(HEAPF32[i41 >> 2]);
     i42 = i37 + 12 | 0;
     f52 = Math_fround(HEAPF32[i42 >> 2]);
     i43 = i5 + (i2 << 2) | 0;
     f53 = Math_fround(HEAPF32[i43 >> 2]);
     i44 = i43 + 4 | 0;
     f54 = Math_fround(HEAPF32[i44 >> 2]);
     i45 = i43 + 8 | 0;
     f55 = Math_fround(HEAPF32[i45 >> 2]);
     i46 = i43 + 12 | 0;
     f17 = Math_fround(f7 + f17);
     f18 = Math_fround(f20 + f18);
     f19 = Math_fround(f21 + f19);
     f38 = Math_fround(f22 + f38);
     f40 = Math_fround(f23 + f40);
     f51 = Math_fround(f24 + f51);
     f52 = Math_fround(f25 + f52);
     f53 = Math_fround(f10 + f53);
     f54 = Math_fround(f11 + f54);
     f55 = Math_fround(f9 + f55);
     f56 = Math_fround(f8 + Math_fround(HEAPF32[i46 >> 2]));
     HEAPF32[i33 >> 2] = Math_fround(f15 + f16);
     HEAPF32[i34 >> 2] = f17;
     HEAPF32[i35 >> 2] = f18;
     HEAPF32[i36 >> 2] = f19;
     HEAPF32[i37 >> 2] = f38;
     HEAPF32[i39 >> 2] = f40;
     HEAPF32[i41 >> 2] = f51;
     HEAPF32[i42 >> 2] = f52;
     HEAPF32[i43 >> 2] = f53;
     HEAPF32[i44 >> 2] = f54;
     HEAPF32[i45 >> 2] = f55;
     HEAPF32[i46 >> 2] = f56;
     i2 = i2 + 4 | 0;
    } while (i2 >>> 0 < i49 >>> 0);
   }
  }
 } else {
  do if (i2) {
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   f9 = Math_fround(0.0);
  } else {
   i2 = __Z11GetIPhysicsv() | 0;
   if (i2 | 0) {
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i45 | 0, i2 | 0);
    f7 = Math_fround(HEAPF32[i45 >> 2]);
    f8 = Math_fround(HEAPF32[i45 + 4 >> 2]);
    f9 = Math_fround(HEAPF32[i45 + 8 >> 2]);
    break;
   }
   i37 = Math_fround(HEAPF32[i44 >> 2]) != Math_fround(0.0);
   if (i37 & (HEAP8[gb + 1548983 >> 0] | 0) == 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 613558 | 0, 0, gb + 613743 | 0, 59, 512, 0, 0, 0);
    HEAP8[gb + 1548983 >> 0] = 1;
    f7 = Math_fround(0.0);
    f8 = Math_fround(-9.81000041);
    f9 = Math_fround(0.0);
   } else {
    f7 = Math_fround(0.0);
    f8 = Math_fround(-9.81000041);
    f9 = Math_fround(0.0);
   }
  } while (0);
  f54 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(f7 * f54);
  f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f18 = Math_fround(f7 * f15);
  f55 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f16 = Math_fround(f7 * f55);
  f56 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f14 = Math_fround(f7 * f56);
  f10 = Math_fround(f8 * f54);
  f17 = Math_fround(f8 * f15);
  f12 = Math_fround(f8 * f55);
  f13 = Math_fround(f8 * f56);
  f7 = Math_fround(f9 * f54);
  f15 = Math_fround(f9 * f15);
  f8 = Math_fround(f9 * f55);
  f9 = Math_fround(f9 * f56);
  if ((HEAP32[i4 + 280 >> 2] | 0) == 1) {
   f20 = f11;
   f21 = f16;
   f22 = f14;
   f23 = f10;
   f24 = f17;
   f25 = f12;
   f38 = f13;
   f19 = f15;
  } else {
   f54 = Math_fround(HEAPF32[i5 + 180 >> 2]);
   f57 = Math_fround(HEAPF32[i5 + 184 >> 2]);
   f51 = Math_fround(HEAPF32[i5 + 188 >> 2]);
   f55 = Math_fround(HEAPF32[i5 + 196 >> 2]);
   f19 = Math_fround(HEAPF32[i5 + 200 >> 2]);
   f52 = Math_fround(HEAPF32[i5 + 204 >> 2]);
   f56 = Math_fround(HEAPF32[i5 + 212 >> 2]);
   f38 = Math_fround(HEAPF32[i5 + 216 >> 2]);
   f53 = Math_fround(HEAPF32[i5 + 220 >> 2]);
   f20 = Math_fround(Math_fround(Math_fround(f11 * f54) + Math_fround(f10 * f55)) + Math_fround(f7 * f56));
   f21 = Math_fround(Math_fround(Math_fround(f16 * f54) + Math_fround(f12 * f55)) + Math_fround(f8 * f56));
   f22 = Math_fround(Math_fround(Math_fround(f14 * f54) + Math_fround(f13 * f55)) + Math_fround(f9 * f56));
   f23 = Math_fround(Math_fround(Math_fround(f11 * f57) + Math_fround(f10 * f19)) + Math_fround(f7 * f38));
   f24 = Math_fround(Math_fround(Math_fround(f18 * f57) + Math_fround(f17 * f19)) + Math_fround(f15 * f38));
   f25 = Math_fround(Math_fround(Math_fround(f16 * f57) + Math_fround(f12 * f19)) + Math_fround(f8 * f38));
   f38 = Math_fround(Math_fround(Math_fround(f14 * f57) + Math_fround(f13 * f19)) + Math_fround(f9 * f38));
   f7 = Math_fround(Math_fround(Math_fround(f11 * f51) + Math_fround(f10 * f52)) + Math_fround(f7 * f53));
   f19 = Math_fround(Math_fround(Math_fround(f18 * f51) + Math_fround(f17 * f52)) + Math_fround(f15 * f53));
   f8 = Math_fround(Math_fround(Math_fround(f16 * f51) + Math_fround(f12 * f52)) + Math_fround(f8 * f53));
   f9 = Math_fround(Math_fround(Math_fround(f14 * f51) + Math_fround(f13 * f52)) + Math_fround(f9 * f53));
   f18 = Math_fround(Math_fround(Math_fround(f18 * f54) + Math_fround(f17 * f55)) + Math_fround(f15 * f56));
  }
  if (i1 >>> 0 < i49 >>> 0) {
   i5 = i46 + 12 | 0;
   i6 = i46 + 8 | 0;
   i26 = i46 + 4 | 0;
   i27 = i48 + 500 | 0;
   i28 = i42 + 4 | 0;
   i29 = i42 + 8 | 0;
   i30 = i42 + 12 | 0;
   i31 = i45 + 4 | 0;
   i32 = i45 + 8 | 0;
   i33 = i45 + 12 | 0;
   i34 = i48 + 60 | 0;
   i35 = i48 + 80 | 0;
   i36 = i48 + 100 | 0;
   i37 = i39 + 2508 | 0;
   i3 = i39 + 2420 | 0;
   i2 = i1;
   while (1) {
    HEAPF32[i5 >> 2] = f40;
    HEAPF32[i6 >> 2] = f40;
    HEAPF32[i26 >> 2] = f40;
    HEAPF32[i46 >> 2] = f40;
    i39 = (HEAP32[i27 >> 2] | 0) + (i2 << 2) | 0;
    i63 = (HEAP32[i39 >> 2] | 0) + -491273277 | 0;
    i61 = (HEAP32[i39 + 4 >> 2] | 0) + -491273277 | 0;
    i59 = (HEAP32[i39 + 8 >> 2] | 0) + -491273277 | 0;
    i39 = (HEAP32[i39 + 12 >> 2] | 0) + -491273277 | 0;
    i62 = (Math_imul(i63, 1790253981) | 0) + 1900727103 | 0;
    i60 = (Math_imul(i61, 1790253981) | 0) + 1900727103 | 0;
    i58 = (Math_imul(i59, 1790253981) | 0) + 1900727103 | 0;
    i4 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
    i63 = i63 << 11 ^ i63;
    i61 = i61 << 11 ^ i61;
    i59 = i59 << 11 ^ i59;
    i39 = i39 << 11 ^ i39;
    f10 = Math_fround(Math_fround((i62 ^ i63 ^ i63 >>> 8) & 8388607 ^ i62 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f11 = Math_fround(Math_fround((i60 ^ i61 ^ i61 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f12 = Math_fround(Math_fround((i58 ^ i59 ^ i59 >>> 8) & 8388607 ^ i58 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f13 = Math_fround(Math_fround((i4 ^ i39 ^ i39 >>> 8) & 8388607 ^ i4 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i42 >> 2] = f10;
    HEAPF32[i28 >> 2] = f11;
    HEAPF32[i29 >> 2] = f12;
    HEAPF32[i30 >> 2] = f13;
    i4 = HEAP32[i41 >> 2] | 0;
    L39 : do switch ((i4 & 65535) << 16 >> 16) {
    case 0:
     {
      i63 = HEAP32[i44 >> 2] | 0;
      HEAP32[i33 >> 2] = i63;
      HEAP32[i32 >> 2] = i63;
      HEAP32[i31 >> 2] = i63;
      HEAP32[i45 >> 2] = i63;
      break;
     }
    case 3:
     {
      f53 = Math_fround(HEAPF32[(HEAP32[i37 >> 2] | 0) + 4 >> 2]);
      f54 = Math_fround(HEAPF32[i44 >> 2]);
      f53 = Math_fround(f53 * f54);
      f54 = Math_fround(Math_fround(f54 * Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + 4 >> 2])) - f53);
      f55 = Math_fround(f53 + Math_fround(f54 * f11));
      f56 = Math_fround(f53 + Math_fround(f54 * f12));
      f57 = Math_fround(f53 + Math_fround(f13 * f54));
      HEAPF32[i45 >> 2] = Math_fround(f53 + Math_fround(f10 * f54));
      HEAPF32[i31 >> 2] = f55;
      HEAPF32[i32 >> 2] = f56;
      HEAPF32[i33 >> 2] = f57;
      break;
     }
    default:
     if (!(i4 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i45, i43, i46, i42);
      break L39;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i45, i43, i46, i42);
      break L39;
     }
    } while (0);
    f68 = Math_fround(HEAPF32[i45 >> 2]);
    f12 = Math_fround(f20 * f68);
    f10 = Math_fround(HEAPF32[i31 >> 2]);
    f75 = Math_fround(f18 * f10);
    f11 = Math_fround(HEAPF32[i32 >> 2]);
    f74 = Math_fround(f21 * f11);
    f57 = Math_fround(HEAPF32[i33 >> 2]);
    f73 = Math_fround(f22 * f57);
    f72 = Math_fround(f23 * f68);
    f71 = Math_fround(f24 * f10);
    f70 = Math_fround(f25 * f11);
    f69 = Math_fround(f38 * f57);
    f68 = Math_fround(f7 * f68);
    f10 = Math_fround(f19 * f10);
    f11 = Math_fround(f8 * f11);
    f57 = Math_fround(f9 * f57);
    i67 = (HEAP32[i34 >> 2] | 0) + (i2 << 2) | 0;
    f13 = Math_fround(HEAPF32[i67 >> 2]);
    i66 = i67 + 4 | 0;
    f14 = Math_fround(HEAPF32[i66 >> 2]);
    i65 = i67 + 8 | 0;
    f15 = Math_fround(HEAPF32[i65 >> 2]);
    i64 = i67 + 12 | 0;
    f16 = Math_fround(HEAPF32[i64 >> 2]);
    i4 = (HEAP32[i35 >> 2] | 0) + (i2 << 2) | 0;
    f17 = Math_fround(HEAPF32[i4 >> 2]);
    i39 = i4 + 4 | 0;
    f51 = Math_fround(HEAPF32[i39 >> 2]);
    i58 = i4 + 8 | 0;
    f52 = Math_fround(HEAPF32[i58 >> 2]);
    i59 = i4 + 12 | 0;
    f53 = Math_fround(HEAPF32[i59 >> 2]);
    i60 = (HEAP32[i36 >> 2] | 0) + (i2 << 2) | 0;
    f54 = Math_fround(HEAPF32[i60 >> 2]);
    i61 = i60 + 4 | 0;
    f55 = Math_fround(HEAPF32[i61 >> 2]);
    i62 = i60 + 8 | 0;
    f56 = Math_fround(HEAPF32[i62 >> 2]);
    i63 = i60 + 12 | 0;
    f14 = Math_fround(f75 + f14);
    f15 = Math_fround(f74 + f15);
    f16 = Math_fround(f73 + f16);
    f17 = Math_fround(f72 + f17);
    f51 = Math_fround(f71 + f51);
    f52 = Math_fround(f70 + f52);
    f53 = Math_fround(f69 + f53);
    f54 = Math_fround(f68 + f54);
    f55 = Math_fround(f10 + f55);
    f56 = Math_fround(f11 + f56);
    f57 = Math_fround(f57 + Math_fround(HEAPF32[i63 >> 2]));
    HEAPF32[i67 >> 2] = Math_fround(f12 + f13);
    HEAPF32[i66 >> 2] = f14;
    HEAPF32[i65 >> 2] = f15;
    HEAPF32[i64 >> 2] = f16;
    HEAPF32[i4 >> 2] = f17;
    HEAPF32[i39 >> 2] = f51;
    HEAPF32[i58 >> 2] = f52;
    HEAPF32[i59 >> 2] = f53;
    HEAPF32[i60 >> 2] = f54;
    HEAPF32[i61 >> 2] = f55;
    HEAPF32[i62 >> 2] = f56;
    HEAPF32[i63 >> 2] = f57;
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i49 >>> 0) break L1;
   }
  }
 } while (0);
 i3 = i1 >>> 0 < i49 >>> 0;
 if (i3) {
  i4 = HEAP32[i48 + 120 >> 2] | 0;
  i5 = HEAP32[i48 + 140 >> 2] | 0;
  i6 = HEAP32[i48 + 160 >> 2] | 0;
  i2 = i1;
  do {
   i67 = i4 + (i2 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i67 = i5 + (i2 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i67 = i6 + (i2 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while (i2 >>> 0 < i49 >>> 0);
 }
 if ((HEAP8[i48 + 869 >> 0] | 0) == 0 | i47 ^ 1) {
  STACKTOP = i50;
  return;
 }
 if (!(HEAP8[i48 + 870 >> 0] | 0)) {
  if (!i3) {
   STACKTOP = i50;
   return;
  }
  i2 = HEAP32[i48 + 400 >> 2] | 0;
  do {
   i67 = i2 + (i1 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i49 >>> 0);
  STACKTOP = i50;
  return;
 } else {
  if (!i3) {
   STACKTOP = i50;
   return;
  }
  i3 = HEAP32[i48 + 360 >> 2] | 0;
  i4 = HEAP32[i48 + 380 >> 2] | 0;
  i2 = HEAP32[i48 + 400 >> 2] | 0;
  do {
   i67 = i3 + (i1 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i67 = i4 + (i1 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i67 = i2 + (i1 << 2) | 0;
   HEAP32[i67 >> 2] = 0;
   HEAP32[i67 + 4 >> 2] = 0;
   HEAP32[i67 + 8 >> 2] = 0;
   HEAP32[i67 + 12 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i49 >>> 0);
  STACKTOP = i50;
  return;
 }
}

function __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE(i19, i16, i54, i58, i60, i61, i62) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i54 = i54 | 0;
 i58 = i58 | 0;
 i60 = i60 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i64 + 160 | 0;
 i63 = i64 + 152 | 0;
 i1 = i64;
 i53 = i64 + 8 | 0;
 i57 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = i58 ? 1 : 2;
 i11 = __Z18GetQualitySettingsv() | 0;
 i10 = HEAP32[i11 + 44 >> 2] | 0;
 i11 = HEAP32[i11 + 28 >> 2] | 0;
 f12 = Math_fround(__ZN15QualitySettings29GetShadowDistanceForRenderingEv());
 if (i58) if (__ZNK6Camera21CalculateCanDoShadowsEv(HEAP32[i19 + 8 >> 2] | 0) | 0) {
  i13 = 1;
  i14 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 118 >> 0] | 0) != 0;
 } else {
  i13 = 0;
  i14 = 0;
 } else {
  i13 = 0;
  i14 = 0;
 }
 i21 = __Z15GetGraphicsCapsv() | 0;
 i20 = (HEAP32[i21 + 120 >> 2] | 0) > 2;
 i21 = (HEAP8[i21 + 510 >> 0] | 0) != 0;
 i51 = i20 & i21;
 i8 = __Z17GetRenderSettingsv() | 0;
 i9 = __Z19GetLightmapSettingsv() | 0;
 i52 = HEAP32[i19 + 1832 >> 2] | 0;
 i15 = i19 + 1828 | 0;
 i18 = HEAP32[i15 >> 2] | 0;
 i59 = __ZnwjRK10MemLabelIdiPKci(528, gb + 64024 | 0, 16, gb + 387960 | 0, 1425) | 0;
 i17 = gb + 64024 | 0;
 i6 = HEAP32[i17 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i56 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i56 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN23ForwardShaderRenderLoopC2E10MemLabelId(i59, i56);
 HEAP32[i59 + 8 >> 2] = i19;
 HEAP32[i59 + 12 >> 2] = __ZNK16LightmapSettings17AcquireSharedDataEv(i9) | 0;
 i2 = i59 + 108 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i17 = i16 + 12 | 0;
 i7 = i59 + 120 | 0;
 i1 = HEAP32[i17 >> 2] << 5;
 i3 = i1 >> 5;
 HEAP32[i7 >> 2] = i3;
 i4 = i59 + 124 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i59 + 112 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i59 + 112 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
 i49 = i59 + 128 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i50 = i59 + 144 | 0;
 i2 = HEAP32[i50 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i50 >> 2] = i1;
  HEAP32[i49 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i49 >> 2] | 0, i1 << 2, 4, i59 + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i48 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i59 + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i48 | 0, HEAP32[i49 >> 2] | 0, HEAP32[i59 + 140 >> 2] << 2 | 0) | 0;
  HEAP32[i50 >> 2] = i1;
  HEAP32[i49 >> 2] = i48;
  break;
 } while (0);
 i48 = i59 + 148 | 0;
 i1 = (HEAP32[i17 >> 2] | 0) * 144 | 0;
 i2 = i59 + 164 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i48 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i48 >> 2] | 0, i1, 1, i59 + 152 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i47 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i59 + 152 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i47 | 0, HEAP32[i48 >> 2] | 0, HEAP32[i59 + 160 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i48 >> 2] = i47;
  break;
 } while (0);
 HEAP32[i59 + 368 >> 2] = HEAP32[i11 + (i10 * 108 | 0) + 28 >> 2];
 i4 = i59 + 392 | 0;
 i3 = i4;
 i1 = i8 + 192 | 0;
 i2 = i3 + 108 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i59 + 500 >> 2] = HEAP32[i9 + 80 >> 2];
 i1 = __ZNK16LightmapSettings14GetLightProbesEv(i9) | 0;
 if (!i1) i55 = 20; else {
  i2 = i1 + 32 | 0;
  if (!(__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2) | 0)) i55 = 20; else {
   HEAP32[i59 + 504 >> 2] = i2;
   HEAP32[i59 + 508 >> 2] = i1 + 148;
   HEAP32[i59 + 512 >> 2] = i1 + 168;
   HEAP32[i59 + 516 >> 2] = HEAP32[i1 + 188 >> 2];
  }
 }
 if ((i55 | 0) == 20) {
  i47 = i59 + 504 | 0;
  HEAP32[i47 >> 2] = 0;
  HEAP32[i47 + 4 >> 2] = 0;
  HEAP32[i47 + 8 >> 2] = 0;
  HEAP32[i47 + 12 >> 2] = 0;
 }
 i45 = (__ZNK16LightmapSettings19AreLightProbesBakedEv(i9) | 0) & 1;
 i46 = i59 + 520 | 0;
 HEAP8[i46 >> 0] = HEAP8[i46 >> 0] & -2 | i45;
 i45 = __ZNK16LightmapSettings23HasLightProbeTetrahedraEv(i9) | 0;
 i47 = HEAP8[i46 >> 0] | 0;
 HEAP8[i46 >> 0] = (i45 ? i47 << 1 & 2 : 0) | i47 & -3;
 i46 = i59 + 524 | 0;
 HEAP8[i46 >> 0] = HEAP8[i46 >> 0] & -17;
 i47 = __Z23GetCurrentRenderOptionsv() | 0;
 i45 = HEAP32[i54 + 1204 >> 2] | 0;
 _memset(i53 | 0, 0, 140) | 0;
 i1 = i53 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i11 + (i10 * 108 | 0) + 16 >> 2];
 _memcpy(i53 + 8 | 0, i4 | 0, 132) | 0;
 if (!i45) {
  HEAP32[i1 >> 2] = 0;
  f12 = Math_fround(0.0);
  i13 = 0;
  i14 = 0;
  i43 = 1;
 } else i43 = 0;
 i1 = i58 ? gb + 1114812 | 0 : gb + 1114860 | 0;
 i45 = i19 + 8 | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i63 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i56 >> 2] = HEAP32[i63 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i56);
  i44 = i1;
 } else i44 = 0;
 i1 = HEAP32[i15 >> 2] | 0;
 __Z16SyncFenceNoClearRK8JobFence(i1 + 65680 | 0);
 i2 = HEAP32[i16 >> 2] | 0;
 i42 = HEAP32[i17 >> 2] | 0;
 i37 = i2 + (i42 << 5) | 0;
 if (!i42) i1 = 0; else {
  i38 = i53 + 136 | 0;
  i39 = i59 + 140 | 0;
  i40 = i59 + 132 | 0;
  i41 = i59 + 160 | 0;
  i42 = i1 + 65720 | 0;
  i35 = i18 + 65632 | 0;
  i36 = i19 + 12 | 0;
  i27 = i19 + 1732 | 0;
  i28 = i59 + 340 | 0;
  i29 = i59 + 304 | 0;
  i30 = i59 + 308 | 0;
  i31 = i59 + 312 | 0;
  i32 = i59 + 316 | 0;
  i33 = i59 + 320 | 0;
  i34 = i59 + 324 | 0;
  i20 = i20 & i21 ^ 1;
  i21 = i59 + 372 | 0;
  i22 = i59 + 168 | 0;
  i23 = i59 + 180 | 0;
  i24 = i59 + 184 | 0;
  i25 = i59 + 172 | 0;
  i26 = i1 + 65708 | 0;
  i19 = i1 + 65688 | 0;
  i1 = 0;
  i18 = 0;
  i17 = i2;
  while (1) {
   i8 = i17 + 8 | 0;
   i11 = HEAP32[i8 >> 2] | 0;
   i15 = HEAP32[i52 >> 2] | 0;
   i10 = i15 + (i11 * 360 | 0) | 0;
   HEAP8[i53 >> 0] = HEAP8[i53 >> 0] & -2 | (HEAPU16[i15 + (i11 * 360 | 0) + 224 >> 1] | 0) < 65534;
   i7 = HEAP8[i38 >> 0] | 0;
   i7 = (__Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i10, (i7 & 2) != 0, (i7 & 1) != 0) | 0) & 1;
   HEAP8[i53 >> 0] = HEAP8[i53 >> 0] & -5 | i7 << 2 & 255;
   i7 = HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0;
   i9 = HEAP32[i39 >> 2] | 0;
   i3 = i9 + 1 | 0;
   i4 = HEAP32[i50 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i2 = i4 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i50 >> 2] = i2;
     HEAP32[i49 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i49 >> 2] | 0, i2 << 2, 4, i40, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i40, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i16 | 0, HEAP32[i49 >> 2] | 0, HEAP32[i39 >> 2] << 2 | 0) | 0;
     HEAP32[i50 >> 2] = i2;
     HEAP32[i49 >> 2] = i16;
     break;
    }
   } while (0);
   HEAP32[i39 >> 2] = i3;
   i6 = HEAP32[i49 >> 2] | 0;
   i4 = HEAP8[i53 >> 0] | 0;
   i3 = i4 & -3;
   HEAP8[i53 >> 0] = i3;
   i5 = i17 + 16 | 0;
   i2 = HEAP16[i5 >> 1] | 0;
   do if (i2 << 16 >> 16 == -1) {
    if (i43) i55 = 42; else {
     i2 = HEAP32[i7 + 32 >> 2] | 0;
     if ((i2 | 0) == -1) i55 = 42;
    }
    if ((i55 | 0) == 42) {
     i55 = 0;
     i2 = HEAP32[i7 + 24 + ((i4 & 1) << 2) >> 2] | 0;
     i3 = i4 | 2;
     HEAP8[i53 >> 0] = i3;
     if ((i2 | 0) == -1) break;
    }
    i2 = i2 & 65535;
    HEAP16[i5 >> 1] = i2;
    i55 = 44;
   } else i55 = 44; while (0);
   L54 : do if ((i55 | 0) == 44) {
    i55 = 0;
    i16 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 16 >> 16 << 2) >> 2] | 0;
    i2 = i3 & -25;
    HEAP8[i53 >> 0] = i2;
    if (!(i3 & 2)) HEAP8[i53 >> 0] = (HEAP8[i16 + 44 >> 0] << 3 & 255 | (HEAP8[i16 + 45 >> 0] << 4 & 255 | i2)) ^ 8;
    i5 = HEAP32[i41 >> 2] | 0;
    HEAP32[i6 + (i9 << 2) >> 2] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    if (!(HEAP32[i42 >> 2] | 0)) {
     i3 = 0;
     i4 = 0;
     i2 = 0;
    } else {
     i8 = HEAP32[i26 >> 2] | 0;
     i3 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
     i9 = i3 & 2147483647;
     i3 = i3 >>> 31 & 255;
     i4 = (HEAP32[i19 >> 2] | 0) + (i9 << 3) | 0;
     i2 = (HEAP32[i8 + (i2 + 1 << 2) >> 2] & 2147483647) - i9 | 0;
    }
    __Z26FindForwardLightsForObjectR13dynamic_arrayIhLj1EEPK11CulledLightjRK12ActiveLightsRK10RenderNodebRK23FindForwardLightsParams(i48, i4, i2, i35, i10, i3 << 24 >> 24 != 0, i53);
    i4 = (HEAP32[i48 >> 2] | 0) + i5 | 0;
    i3 = i4 + 112 | 0;
    i8 = (HEAP32[i3 >> 2] | 0) != 0;
    do if (i13) {
     i10 = i15 + (i11 * 360 | 0) + 232 | 0;
     if ((HEAPU16[i10 >> 1] | HEAPU8[i10 + 2 >> 0] << 16) & 256) {
      i6 = i15 + (i11 * 360 | 0) + 128 | 0;
      if (__Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB(i36, i6) | 0) {
       i2 = HEAP32[i4 + 108 >> 2] | 0;
       do if (i2) {
        if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0)) break;
        i1 = (i1 | 0) == 0 ? i2 : i1;
        if ((i1 | 0) == (i2 | 0)) {
         f65 = Math_fround(HEAPF32[i6 >> 2]);
         i5 = i15 + (i11 * 360 | 0) + 140 | 0;
         f65 = Math_fround(f65 - Math_fround(HEAPF32[i5 >> 2]));
         i7 = i15 + (i11 * 360 | 0) + 132 | 0;
         f69 = Math_fround(HEAPF32[i7 >> 2]);
         i9 = i15 + (i11 * 360 | 0) + 144 | 0;
         f69 = Math_fround(f69 - Math_fround(HEAPF32[i9 >> 2]));
         i10 = i15 + (i11 * 360 | 0) + 136 | 0;
         f68 = Math_fround(HEAPF32[i10 >> 2]);
         i1 = i15 + (i11 * 360 | 0) + 148 | 0;
         f68 = Math_fround(f68 - Math_fround(HEAPF32[i1 >> 2]));
         f67 = Math_fround(HEAPF32[i29 >> 2]);
         f66 = Math_fround(HEAPF32[i30 >> 2]);
         f70 = Math_fround(HEAPF32[i31 >> 2]);
         HEAPF32[i29 >> 2] = f65 < f67 ? f65 : f67;
         HEAPF32[i30 >> 2] = f69 < f66 ? f69 : f66;
         HEAPF32[i31 >> 2] = f68 < f70 ? f68 : f70;
         f70 = Math_fround(HEAPF32[i6 >> 2]);
         f70 = Math_fround(f70 + Math_fround(HEAPF32[i5 >> 2]));
         f68 = Math_fround(HEAPF32[i7 >> 2]);
         f68 = Math_fround(f68 + Math_fround(HEAPF32[i9 >> 2]));
         f66 = Math_fround(HEAPF32[i10 >> 2]);
         f66 = Math_fround(f66 + Math_fround(HEAPF32[i1 >> 2]));
         f69 = Math_fround(HEAPF32[i32 >> 2]);
         f67 = Math_fround(HEAPF32[i33 >> 2]);
         f65 = Math_fround(HEAPF32[i34 >> 2]);
         HEAPF32[i32 >> 2] = f69 < f70 ? f70 : f69;
         HEAPF32[i33 >> 2] = f67 < f68 ? f68 : f67;
         HEAPF32[i34 >> 2] = f65 < f66 ? f66 : f65;
         i1 = i2;
         break;
        } else {
         __ZL24PutAdditionalShadowLightRK4AABBRK11ActiveLightRK10Matrix4x4ffR13dynamic_arrayI16ForwardShadowMapLj4EE(i6, i2, i27, f12, i28);
         break;
        }
       } while (0);
       if (!i14) break;
       if (!(HEAP8[i16 + 46 >> 0] | 0)) break;
       i5 = HEAP32[i3 >> 2] | 0;
       i3 = i4 + 132 | 0;
       if ((i5 | 0) > 0) i2 = 0; else break;
       do {
        i4 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
        do if (HEAP32[(HEAP32[i4 >> 2] | 0) + 96 >> 2] | 0) {
         if ((i4 | 0) == (i1 | 0) | (HEAP8[i4 + 8 >> 0] | 0) == 0) break;
         __ZL24PutAdditionalShadowLightRK4AABBRK11ActiveLightRK10Matrix4x4ffR13dynamic_arrayI16ForwardShadowMapLj4EE(i6, i4, i27, f12, i28);
        } while (0);
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i5 | 0));
      }
     }
    } while (0);
    i15 = HEAP32[i16 + 20 >> 2] | 0;
    i7 = (i15 | 0) > 0;
    if (i7) {
     i6 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP8[i53 >> 0] | 0;
     i5 = i8 ^ 1;
     if (!(i2 & 2)) {
      i4 = 0;
      i2 = 0;
      do {
       i11 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i11 + 696 >> 2] | 0;
       i11 = HEAP32[i11 + 752 >> 2] & 1;
       L86 : do if ((i11 & i47 | 0) == (i11 | 0)) {
        switch (i3 | 0) {
        case 0:
        case 4:
        case 5:
         break;
        default:
         break L86;
        }
        i2 = i2 + ((i3 | 0) == 5 & i5 & 1 ^ 1) | 0;
       } while (0);
       i4 = i4 + 1 | 0;
      } while ((i2 | 0) < 2 & (i4 | 0) < (i15 | 0));
     } else if (!(i2 & 1)) {
      i4 = 0;
      i2 = 0;
      do {
       i11 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i11 + 696 >> 2] | 0;
       i11 = HEAP32[i11 + 752 >> 2] & 1;
       if (!((i11 & i47 | 0) != (i11 | 0) | i3 >>> 0 > 3 | (i3 | 1 | 0) == 3)) i2 = i2 + (((i3 | 0) != 2 | i20) & (i51 | (i3 | 0) != 3) & 1) | 0;
       i4 = i4 + 1 | 0;
      } while ((i2 | 0) < 2 & (i4 | 0) < (i15 | 0));
     } else {
      i4 = 0;
      i2 = 0;
      do {
       i11 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i11 + 696 >> 2] | 0;
       i11 = HEAP32[i11 + 752 >> 2] & 1;
       if (i3 >>> 0 < 4 & (i11 & i47 | 0) == (i11 | 0) & (i3 | 0) != 1) i2 = i2 + (((i3 | 0) != 2 | i20) & (i51 | (i3 | 0) != 3) & 1) | 0;
       i4 = i4 + 1 | 0;
      } while ((i2 | 0) < 2 & (i4 | 0) < (i15 | 0));
     }
     if (i7) {
      i4 = HEAP8[i53 >> 0] | 0;
      i11 = i8 ^ 1;
      i10 = (i4 & 5 ? 134217728 : 0) | ((i2 | 0) > 1 ? 33554432 : 0);
      i2 = 0;
      i3 = 16777216;
      while (1) {
       i9 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i2 << 2) >> 2] | 0;
       i6 = HEAP32[i9 + 696 >> 2] | 0;
       i5 = (i4 & 1) != 0;
       i8 = HEAP32[i9 + 752 >> 2] & 1;
       L106 : do if ((i8 & i47 | 0) == (i8 | 0)) {
        if (!(i4 & 2)) {
         switch (i6 | 0) {
         case 0:
         case 4:
         case 5:
          break;
         default:
          break L106;
         }
         if ((i6 | 0) == 5 & i11) break;
        } else {
         if (i6 >>> 0 > 3) break;
         if (!((i6 | 0) != 1 | i5 ^ 1)) break;
         if (!((i6 | 1 | 0) != 3 | i5)) break;
         if (!(((i6 | 0) != 2 | i20) & (i51 | (i6 | 0) != 3))) break;
        }
        do if ((HEAP32[i9 + 744 >> 2] | 0) == 2) {
         if (!(__ZN9ShaderLab10GrabPasses3AddEPNS_4PassEPK6Camera(i21, i9, HEAP32[i45 >> 2] | 0) | 0)) {
          i4 = 0;
          break;
         }
         HEAP8[i46 >> 0] = HEAP8[i46 >> 0] | 16;
         i4 = 67108864;
        } else i4 = 0; while (0);
        i4 = i10 | i3 | i2 & 255 | i6 << 8 | i4;
        i5 = HEAP32[i23 >> 2] | 0;
        i6 = i5 + 1 | 0;
        i7 = HEAP32[i24 >> 2] | 0;
        i8 = i7 & 2147483647;
        do if (i6 >>> 0 > i8 >>> 0) {
         i3 = i7 << 1;
         i3 = (i3 | 0) == 0 ? 1 : i3;
         if (i8 >>> 0 >= i3 >>> 0) break;
         if ((i7 | 0) > -1) {
          HEAP32[i24 >> 2] = i3;
          HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i3 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i8 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i23 >> 2] | 0) * 12 | 0) | 0;
          HEAP32[i24 >> 2] = i3;
          HEAP32[i22 >> 2] = i8;
          break;
         }
        } while (0);
        HEAP32[i23 >> 2] = i6;
        i3 = HEAP32[i22 >> 2] | 0;
        HEAP32[i3 + (i5 * 12 | 0) >> 2] = i9;
        HEAP32[i3 + (i5 * 12 | 0) + 4 >> 2] = i18;
        HEAP32[i3 + (i5 * 12 | 0) + 8 >> 2] = i4;
        i3 = 0;
       } while (0);
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i15 | 0)) break L54;
       i4 = HEAP8[i53 >> 0] | 0;
      }
     }
    }
   } while (0);
   i17 = i17 + 32 | 0;
   if ((i17 | 0) == (i37 | 0)) break; else i18 = i18 + 1 | 0;
  }
 }
 if (i44 | 0) __Z12profiler_endP19ProfilerInformation(i44);
 i5 = __ZN23ForwardShaderRenderLoop17PrepareShadowMapsEPK11ActiveLightRK11CullResults(i59, i1, i54) | 0;
 HEAP32[i63 >> 2] = 0;
 HEAP32[i63 + 4 >> 2] = 0;
 i6 = i58 ? gb + 1114824 | 0 : gb + 1114872 | 0;
 i2 = (HEAP32[i45 >> 2] | 0) + 1064 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 509 >> 0] | 0)) i4 = 1; else {
  i1 = HEAP32[i2 >> 2] | 0;
  i55 = 32;
 } else i55 = 32;
 if ((i55 | 0) == 32) i4 = (i1 | 0) == 1 & 1;
 i1 = HEAP32[i59 + 168 >> 2] | 0;
 i2 = HEAP32[i59 + 180 >> 2] | 0;
 i3 = i1 + (i2 * 12 | 0) | 0;
 if (i58) {
  HEAP32[i56 >> 2] = 0;
  HEAP32[i56 + 4 >> 2] = 0;
  i55 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
  HEAP32[i55 >> 2] = i1;
  HEAP32[i55 + 4 >> 2] = i3;
  HEAP32[i55 + 8 >> 2] = (i2 * 12 | 0) / 12 | 0;
  HEAP32[i55 + 12 >> 2] = i59;
  HEAP8[i55 + 16 >> 0] = i4;
  HEAP32[i55 + 20 >> 2] = i6;
  __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i63, fb + 3348 | 0, i55, i56, 0);
  __ZN23ForwardShaderRenderLoop16PerformRenderingER8JobFencePK11ActiveLightRK13ShadowJobDatabbbN6Camera10RenderFlagE(i59, i63, i5, 0, i60, i61, i58, i62);
  HEAP32[gb + 1163232 >> 2] = i57;
  STACKTOP = i64;
  return;
 } else {
  HEAP32[i56 >> 2] = 0;
  HEAP32[i56 + 4 >> 2] = 0;
  i55 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
  HEAP32[i55 >> 2] = i1;
  HEAP32[i55 + 4 >> 2] = i3;
  HEAP32[i55 + 8 >> 2] = (i2 * 12 | 0) / 12 | 0;
  HEAP32[i55 + 12 >> 2] = i59;
  HEAP8[i55 + 16 >> 0] = i4;
  HEAP32[i55 + 20 >> 2] = i6;
  __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i63, fb + 3349 | 0, i55, i56, 0);
  __ZN23ForwardShaderRenderLoop16PerformRenderingER8JobFencePK11ActiveLightRK13ShadowJobDatabbbN6Camera10RenderFlagE(i59, i63, i5, 0, i60, i61, i58, i62);
  HEAP32[gb + 1163232 >> 2] = i57;
  STACKTOP = i64;
  return;
 }
}

function __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i1, i2, i32) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i65 = i66 + 24 | 0;
 i64 = i66;
 i53 = i64 + 4 | 0;
 i54 = i64 + 8 | 0;
 i55 = i64 + 12 | 0;
 i56 = i64 + 16 | 0;
 i18 = i64 + 4 | 0;
 i57 = i65 + 4 | 0;
 i22 = i65 + 4 | 0;
 i23 = i64 + 12 | 0;
 i24 = i64 + 4 | 0;
 i25 = i64 + 8 | 0;
 i26 = i64 + 12 | 0;
 i27 = i64 + 16 | 0;
 i17 = i64 + 4 | 0;
 i28 = i65 + 4 | 0;
 i29 = i65 + 4 | 0;
 i30 = i64 + 12 | 0;
 i31 = i64 + 4 | 0;
 i33 = i64 + 8 | 0;
 i34 = i64 + 12 | 0;
 i35 = i64 + 16 | 0;
 i21 = i64 + 4 | 0;
 i36 = i65 + 4 | 0;
 i37 = i65 + 4 | 0;
 i38 = i64 + 12 | 0;
 i39 = i64 + 4 | 0;
 i40 = i64 + 8 | 0;
 i41 = i64 + 12 | 0;
 i42 = i64 + 16 | 0;
 i20 = i64 + 4 | 0;
 i43 = i65 + 4 | 0;
 i44 = i65 + 4 | 0;
 i45 = i64 + 12 | 0;
 i46 = i64 + 4 | 0;
 i47 = i64 + 8 | 0;
 i48 = i64 + 12 | 0;
 i49 = i64 + 16 | 0;
 i19 = i64 + 4 | 0;
 i50 = i65 + 4 | 0;
 i51 = i65 + 4 | 0;
 i52 = i64 + 12 | 0;
 L1 : while (1) {
  i15 = i2;
  i62 = i2 + -20 | 0;
  i60 = i2 + -16 | 0;
  i61 = i2 + -12 | 0;
  i16 = (i64 | 0) == (i62 | 0);
  i63 = i2 + -16 | 0;
  while (1) {
   i59 = i1;
   L5 : while (1) {
    i14 = i59;
    i1 = i15 - i14 | 0;
    switch ((i1 | 0) / 20 | 0 | 0) {
    case 2:
     {
      i58 = 5;
      break L1;
     }
    case 3:
     {
      i58 = 20;
      break L1;
     }
    case 4:
     {
      i58 = 21;
      break L1;
     }
    case 5:
     {
      i58 = 22;
      break L1;
     }
    case 1:
    case 0:
     {
      i58 = 118;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 140) {
     i58 = 24;
     break L1;
    }
    i11 = i59 + (((i1 >>> 0) / 40 | 0) * 20 | 0) | 0;
    if ((i1 | 0) > 19980) {
     i1 = (i1 >>> 0) / 80 | 0;
     i1 = __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_(i59, i59 + (i1 * 20 | 0) | 0, i11, i11 + (i1 * 20 | 0) | 0, i62, i32) | 0;
    } else i1 = __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i59, i11, i62, i32) | 0;
    i5 = HEAP32[i59 >> 2] | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i62;
     break;
    } else i10 = i62;
    while (1) {
     i3 = i10 + -20 | 0;
     if ((i59 | 0) == (i3 | 0)) break;
     if ((HEAP32[i3 >> 2] | 0) < (i4 | 0)) {
      i58 = 66;
      break L5;
     } else i10 = i3;
    }
    i1 = i59 + 20 | 0;
    if ((i5 | 0) >= (HEAP32[i62 >> 2] | 0)) {
     if ((i1 | 0) == (i62 | 0)) {
      i58 = 118;
      break L1;
     }
     while (1) {
      i3 = HEAP32[i1 >> 2] | 0;
      if ((i5 | 0) < (i3 | 0)) break;
      i1 = i1 + 20 | 0;
      if ((i1 | 0) == (i62 | 0)) {
       i58 = 118;
       break L1;
      }
     }
     HEAP32[i64 >> 2] = i3;
     i8 = i1 + 4 | 0;
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     HEAP32[i24 >> 2] = 0;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i27 >> 2] = i3;
     i7 = i1 + 8 | 0;
     i4 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
     i6 = i4 >> 2;
     if (i6 | 0) {
      if ((i4 | 0) < 0) {
       __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i24);
       i3 = HEAP32[i27 >> 2] | 0;
      }
      HEAP32[i65 >> 2] = 51;
      HEAP32[i29 >> 2] = i3;
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i25 >> 2] = i5;
      HEAP32[i24 >> 2] = i5;
      HEAP32[i30 >> 2] = i5 + (i6 << 2);
      i4 = HEAP32[i8 >> 2] | 0;
      i3 = (HEAP32[i7 >> 2] | 0) - i4 | 0;
      if ((i3 | 0) > 0) {
       _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
       HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + (i3 >> 2 << 2);
      }
     }
     HEAP32[i1 >> 2] = HEAP32[i62 >> 2];
     __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, HEAP32[i60 >> 2] | 0, HEAP32[i61 >> 2] | 0);
     HEAP32[i62 >> 2] = HEAP32[i64 >> 2];
     if (!i16) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i63, HEAP32[i17 >> 2] | 0, HEAP32[i25 >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     if (i3 | 0) {
      i5 = HEAP32[i25 >> 2] | 0;
      if ((i5 | 0) != (i3 | 0)) HEAP32[i25 >> 2] = i5 + (~((i5 + -4 - i4 | 0) >>> 2) << 2);
      i14 = HEAP32[i27 >> 2] | 0;
      HEAP32[i65 >> 2] = 51;
      HEAP32[i28 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i65);
     }
     i1 = i1 + 20 | 0;
    }
    if ((i1 | 0) == (i62 | 0)) {
     i58 = 118;
     break L1;
    } else i3 = i62;
    while (1) {
     i5 = HEAP32[i59 >> 2] | 0;
     while (1) {
      i4 = HEAP32[i1 >> 2] | 0;
      i11 = i1 + 20 | 0;
      if ((i5 | 0) < (i4 | 0)) break; else i1 = i11;
     }
     while (1) {
      i10 = i3 + -20 | 0;
      if ((i5 | 0) < (HEAP32[i10 >> 2] | 0)) i3 = i10; else break;
     }
     if (i1 >>> 0 >= i10 >>> 0) {
      i59 = i1;
      continue L5;
     }
     HEAP32[i64 >> 2] = i4;
     i9 = i1 + 4 | 0;
     i4 = HEAP32[i1 + 16 >> 2] | 0;
     HEAP32[i53 >> 2] = 0;
     HEAP32[i54 >> 2] = 0;
     HEAP32[i55 >> 2] = 0;
     HEAP32[i56 >> 2] = i4;
     i8 = i1 + 8 | 0;
     i5 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
     i7 = i5 >> 2;
     if (i7 | 0) {
      if ((i5 | 0) < 0) {
       __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i53);
       i4 = HEAP32[i56 >> 2] | 0;
      }
      HEAP32[i65 >> 2] = 51;
      HEAP32[i22 >> 2] = i4;
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i54 >> 2] = i6;
      HEAP32[i53 >> 2] = i6;
      HEAP32[i23 >> 2] = i6 + (i7 << 2);
      i5 = HEAP32[i9 >> 2] | 0;
      i4 = (HEAP32[i8 >> 2] | 0) - i5 | 0;
      if ((i4 | 0) > 0) {
       _memcpy(i6 | 0, i5 | 0, i4 | 0) | 0;
       HEAP32[i54 >> 2] = (HEAP32[i54 >> 2] | 0) + (i4 >> 2 << 2);
      }
     }
     HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
     if ((i1 | 0) != (i10 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, HEAP32[i3 + -16 >> 2] | 0, HEAP32[i3 + -12 >> 2] | 0);
     HEAP32[i10 >> 2] = HEAP32[i64 >> 2];
     if ((i64 | 0) != (i10 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i3 + -16 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i54 >> 2] | 0);
     i1 = HEAP32[i18 >> 2] | 0;
     i3 = i1;
     if (i1 | 0) {
      i4 = HEAP32[i54 >> 2] | 0;
      if ((i4 | 0) != (i1 | 0)) HEAP32[i54 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
      i14 = HEAP32[i56 >> 2] | 0;
      HEAP32[i65 >> 2] = 51;
      HEAP32[i57 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i65);
     }
     i3 = i10;
     i1 = i11;
    }
   }
   if ((i58 | 0) == 66) {
    i58 = 0;
    HEAP32[i64 >> 2] = i5;
    i9 = i59 + 4 | 0;
    i4 = HEAP32[i59 + 16 >> 2] | 0;
    HEAP32[i46 >> 2] = 0;
    HEAP32[i47 >> 2] = 0;
    HEAP32[i48 >> 2] = 0;
    HEAP32[i49 >> 2] = i4;
    i8 = i59 + 8 | 0;
    i5 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
    i7 = i5 >> 2;
    if (i7 | 0) {
     if ((i5 | 0) < 0) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i46);
      i4 = HEAP32[i49 >> 2] | 0;
     }
     HEAP32[i65 >> 2] = 51;
     HEAP32[i51 >> 2] = i4;
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i47 >> 2] = i6;
     HEAP32[i46 >> 2] = i6;
     HEAP32[i52 >> 2] = i6 + (i7 << 2);
     i5 = HEAP32[i9 >> 2] | 0;
     i4 = (HEAP32[i8 >> 2] | 0) - i5 | 0;
     if ((i4 | 0) > 0) {
      _memcpy(i6 | 0, i5 | 0, i4 | 0) | 0;
      HEAP32[i47 >> 2] = (HEAP32[i47 >> 2] | 0) + (i4 >> 2 << 2);
     }
    }
    HEAP32[i59 >> 2] = HEAP32[i3 >> 2];
    __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, HEAP32[i10 + -16 >> 2] | 0, HEAP32[i10 + -12 >> 2] | 0);
    HEAP32[i3 >> 2] = HEAP32[i64 >> 2];
    if ((i64 | 0) != (i3 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10 + -16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i47 >> 2] | 0);
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = i4;
    if (i4 | 0) {
     i6 = HEAP32[i47 >> 2] | 0;
     if ((i6 | 0) != (i4 | 0)) HEAP32[i47 >> 2] = i6 + (~((i6 + -4 - i5 | 0) >>> 2) << 2);
     i13 = HEAP32[i49 >> 2] | 0;
     HEAP32[i65 >> 2] = 51;
     HEAP32[i50 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i65);
    }
    i1 = i1 + 1 | 0;
   }
   i4 = i59 + 20 | 0;
   L86 : do if (i4 >>> 0 < i3 >>> 0) {
    i13 = i11;
    while (1) {
     i6 = HEAP32[i13 >> 2] | 0;
     while (1) {
      i5 = HEAP32[i4 >> 2] | 0;
      i12 = i4 + 20 | 0;
      if ((i5 | 0) < (i6 | 0)) i4 = i12; else break;
     }
     while (1) {
      i11 = i3 + -20 | 0;
      if ((HEAP32[i11 >> 2] | 0) < (i6 | 0)) break; else i3 = i11;
     }
     if (i4 >>> 0 > i11 >>> 0) {
      i9 = i13;
      i10 = i4;
      break L86;
     }
     HEAP32[i64 >> 2] = i5;
     i10 = i4 + 4 | 0;
     i5 = HEAP32[i4 + 16 >> 2] | 0;
     HEAP32[i39 >> 2] = 0;
     HEAP32[i40 >> 2] = 0;
     HEAP32[i41 >> 2] = 0;
     HEAP32[i42 >> 2] = i5;
     i9 = i4 + 8 | 0;
     i6 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
     i8 = i6 >> 2;
     if (i8 | 0) {
      if ((i6 | 0) < 0) {
       __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i39);
       i5 = HEAP32[i42 >> 2] | 0;
      }
      HEAP32[i65 >> 2] = 51;
      HEAP32[i44 >> 2] = i5;
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i40 >> 2] = i7;
      HEAP32[i39 >> 2] = i7;
      HEAP32[i45 >> 2] = i7 + (i8 << 2);
      i6 = HEAP32[i10 >> 2] | 0;
      i5 = (HEAP32[i9 >> 2] | 0) - i6 | 0;
      if ((i5 | 0) > 0) {
       _memcpy(i7 | 0, i6 | 0, i5 | 0) | 0;
       HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + (i5 >> 2 << 2);
      }
     }
     HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
     if ((i4 | 0) != (i11 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, HEAP32[i3 + -16 >> 2] | 0, HEAP32[i3 + -12 >> 2] | 0);
     HEAP32[i11 >> 2] = HEAP32[i64 >> 2];
     if ((i64 | 0) != (i11 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i3 + -16 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i40 >> 2] | 0);
     i3 = HEAP32[i20 >> 2] | 0;
     i5 = i3;
     if (i3 | 0) {
      i6 = HEAP32[i40 >> 2] | 0;
      if ((i6 | 0) != (i3 | 0)) HEAP32[i40 >> 2] = i6 + (~((i6 + -4 - i5 | 0) >>> 2) << 2);
      i10 = HEAP32[i42 >> 2] | 0;
      HEAP32[i65 >> 2] = 51;
      HEAP32[i43 >> 2] = i10;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i65);
     }
     i13 = (i13 | 0) == (i4 | 0) ? i11 : i13;
     i3 = i11;
     i4 = i12;
     i1 = i1 + 1 | 0;
    }
   } else {
    i9 = i11;
    i10 = i4;
   } while (0);
   if ((i10 | 0) != (i9 | 0)) {
    i3 = HEAP32[i10 >> 2] | 0;
    if ((HEAP32[i9 >> 2] | 0) < (i3 | 0)) {
     HEAP32[i64 >> 2] = i3;
     i8 = i10 + 4 | 0;
     i3 = HEAP32[i10 + 16 >> 2] | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i33 >> 2] = 0;
     HEAP32[i34 >> 2] = 0;
     HEAP32[i35 >> 2] = i3;
     i7 = i10 + 8 | 0;
     i4 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
     i6 = i4 >> 2;
     if (i6 | 0) {
      if ((i4 | 0) < 0) {
       __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i31);
       i3 = HEAP32[i35 >> 2] | 0;
      }
      HEAP32[i65 >> 2] = 51;
      HEAP32[i37 >> 2] = i3;
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i33 >> 2] = i5;
      HEAP32[i31 >> 2] = i5;
      HEAP32[i38 >> 2] = i5 + (i6 << 2);
      i4 = HEAP32[i8 >> 2] | 0;
      i3 = (HEAP32[i7 >> 2] | 0) - i4 | 0;
      if ((i3 | 0) > 0) {
       _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
       HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + (i3 >> 2 << 2);
      }
     }
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0);
     HEAP32[i9 >> 2] = HEAP32[i64 >> 2];
     if ((i64 | 0) != (i9 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9 + 4 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i33 >> 2] | 0);
     i3 = HEAP32[i21 >> 2] | 0;
     i4 = i3;
     if (i3 | 0) {
      i5 = HEAP32[i33 >> 2] | 0;
      if ((i5 | 0) != (i3 | 0)) HEAP32[i33 >> 2] = i5 + (~((i5 + -4 - i4 | 0) >>> 2) << 2);
      i13 = HEAP32[i35 >> 2] | 0;
      HEAP32[i65 >> 2] = 51;
      HEAP32[i36 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i65);
     }
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN15ResourceManager10Dependency6SorterEPS2_EEbT0_S6_T_(i59, i10, i32) | 0;
    i1 = i10 + 20 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN15ResourceManager10Dependency6SorterEPS2_EEbT0_S6_T_(i1, i2, i32) | 0) {
     i58 = 117;
     break;
    }
    if (i3) continue;
   }
   i13 = i10;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i58 = 116;
    break;
   }
   __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i59, i10, i32);
   i1 = i10 + 20 | 0;
  }
  if ((i58 | 0) == 116) {
   i58 = 0;
   __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i10 + 20 | 0, i2, i32);
   i1 = i59;
   i2 = i10;
   continue;
  } else if ((i58 | 0) == 117) {
   i58 = 0;
   if (i3) {
    i58 = 118;
    break;
   } else {
    i1 = i59;
    i2 = i10;
    continue;
   }
  }
 }
 if ((i58 | 0) == 5) {
  i1 = HEAP32[i59 >> 2] | 0;
  if ((HEAP32[i62 >> 2] | 0) >= (i1 | 0)) {
   STACKTOP = i66;
   return;
  }
  HEAP32[i64 >> 2] = i1;
  i4 = i64 + 4 | 0;
  i7 = i59 + 4 | 0;
  i1 = HEAP32[i59 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  i8 = i64 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i64 + 12 >> 2] = 0;
  i9 = i64 + 16 | 0;
  HEAP32[i9 >> 2] = i1;
  i6 = i59 + 8 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i65 >> 2] = 51;
   HEAP32[i65 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i65, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i64 + 12 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  HEAP32[i59 >> 2] = HEAP32[i62 >> 2];
  if ((i59 | 0) != (i62 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i60 >> 2] | 0, HEAP32[i61 >> 2] | 0);
  HEAP32[i62 >> 2] = HEAP32[i64 >> 2];
  i1 = i64 + 4 | 0;
  if ((i64 | 0) != (i62 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i63, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i64 = HEAP32[i9 >> 2] | 0;
   HEAP32[i65 >> 2] = 51;
   HEAP32[i65 + 4 >> 2] = i64;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i65);
  }
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 20) {
  __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i59, i59 + 20 | 0, i62, i32) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 21) {
  __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_(i59, i59 + 20 | 0, i59 + 40 | 0, i62, i32) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 22) {
  __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_(i59, i59 + 20 | 0, i59 + 40 | 0, i59 + 60 | 0, i62, i32) | 0;
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 24) {
  __ZNSt3__218__insertion_sort_3IRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i59, i2, i32);
  STACKTOP = i66;
  return;
 } else if ((i58 | 0) == 118) {
  STACKTOP = i66;
  return;
 }
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i43, i49, i48, i1, i70, i71, i72, i73, i75, i77, i63) {
 i43 = i43 | 0;
 i49 = i49 | 0;
 i48 = i48 | 0;
 i1 = i1 | 0;
 i70 = i70 | 0;
 i71 = i71 | 0;
 i72 = i72 | 0;
 i73 = i73 | 0;
 i75 = i75 | 0;
 i77 = i77 | 0;
 i63 = i63 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f64 = f0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i74 = 0, i76 = 0, i78 = 0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0;
 i78 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i78 + 320 | 0;
 i57 = i78 + 500 | 0;
 i56 = i78 + 488 | 0;
 i68 = i78 + 336 | 0;
 i66 = i78 + 256 | 0;
 i67 = i78 + 192 | 0;
 i74 = i78 + 472 | 0;
 i76 = i78 + 456 | 0;
 i50 = i78 + 448 | 0;
 i69 = i78 + 176 | 0;
 i27 = i78 + 160 | 0;
 i28 = i78 + 144 | 0;
 i26 = i78 + 128 | 0;
 i29 = i78 + 436 | 0;
 i31 = i78 + 112 | 0;
 i52 = i78 + 96 | 0;
 i51 = i78 + 80 | 0;
 i59 = i78 + 64 | 0;
 i60 = i78 + 48 | 0;
 i58 = i78 + 424 | 0;
 i46 = i78 + 32 | 0;
 i45 = i78 + 412 | 0;
 i54 = i78 + 16 | 0;
 i55 = i78;
 i53 = i78 + 400 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i47 = i43 + 16 | 0;
 f64 = Math_fround(HEAPF32[i47 >> 2]);
 f65 = Math_fround(HEAPF32[i49 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f44 = Math_fround(HEAPF32[i43 + 32 >> 2]);
 f62 = Math_fround(HEAPF32[i49 + 32 >> 2]);
 f44 = Math_fround((f44 > f62 ? f62 : f44) * Math_fround(.100000001));
 f44 = Math_fround(f44 * f44);
 f62 = Math_fround(f64 + f65);
 HEAP32[i50 >> 2] = 0;
 if (!(HEAP8[i63 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i48 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i48 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i48 + 56 >> 2]);
  i42 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i42 ? f5 : Math_fround(1.0);
  f6 = i42 ? f6 : Math_fround(0.0);
  f7 = i42 ? f7 : Math_fround(0.0);
  HEAPF32[i69 >> 2] = f5;
  HEAPF32[i69 + 4 >> 2] = f6;
  HEAPF32[i69 + 8 >> 2] = f7;
  HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i31 >> 2] = HEAP32[i69 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i69 + 12 >> 2];
  i42 = i69;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i61 = 8;
 } else {
  HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = i43 + 144 | 0;
  i3 = i43 + 148 | 0;
  i8 = i43 + 152 | 0;
  i9 = i48 + 48 | 0;
  i10 = i48 + 52 | 0;
  i11 = i48 + 56 | 0;
  i12 = i48 + 16 | 0;
  i13 = i48 + 32 | 0;
  i14 = i48 + 4 | 0;
  i15 = i48 + 20 | 0;
  i16 = i48 + 36 | 0;
  i17 = i48 + 8 | 0;
  i18 = i48 + 24 | 0;
  i19 = i48 + 40 | 0;
  i20 = i49 + 16 | 0;
  i21 = i28 + 4 | 0;
  i22 = i28 + 8 | 0;
  i23 = i27 + 4 | 0;
  i24 = i27 + 8 | 0;
  i25 = i27 + 12 | 0;
  f4 = f64;
  i1 = 0;
  while (1) {
   i41 = HEAPU8[i75 + i1 >> 0] | 0;
   HEAP32[i74 + (i1 << 2) >> 2] = i41;
   i42 = HEAPU8[i77 + i1 >> 0] | 0;
   HEAP32[i76 + (i1 << 2) >> 2] = i42;
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(f6 - f4);
   f7 = Math_fround(f7 - f4);
   f4 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f4);
   f79 = Math_fround(-f6);
   f5 = Math_fround(-f7);
   f33 = Math_fround(-f4);
   f79 = HEAP32[gb + 48 + (i41 << 4) >> 2] | 0 ? f6 : f79;
   f5 = HEAP32[gb + 48 + (i41 << 4) + 4 >> 2] | 0 ? f7 : f5;
   f33 = HEAP32[gb + 48 + (i41 << 4) + 8 >> 2] | 0 ? f4 : f33;
   f4 = Math_fround(HEAPF32[i9 >> 2]);
   f7 = Math_fround(HEAPF32[i10 >> 2]);
   f6 = Math_fround(HEAPF32[i11 >> 2]);
   f30 = Math_fround(f79 * Math_fround(HEAPF32[i48 >> 2]));
   f30 = Math_fround(f30 + Math_fround(f5 * Math_fround(HEAPF32[i12 >> 2])));
   f30 = Math_fround(f30 + Math_fround(f33 * Math_fround(HEAPF32[i13 >> 2])));
   f32 = Math_fround(f79 * Math_fround(HEAPF32[i14 >> 2]));
   f32 = Math_fround(f32 + Math_fround(f5 * Math_fround(HEAPF32[i15 >> 2])));
   f32 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i16 >> 2])));
   f79 = Math_fround(f79 * Math_fround(HEAPF32[i17 >> 2]));
   f5 = Math_fround(f79 + Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2])));
   f30 = Math_fround(f4 + f30);
   f32 = Math_fround(f7 + f32);
   f33 = Math_fround(f6 + Math_fround(f5 + Math_fround(f33 * Math_fround(HEAPF32[i19 >> 2]))));
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i28, i49, i42, i20);
   f5 = Math_fround(HEAPF32[i28 >> 2]);
   f6 = Math_fround(HEAPF32[i21 >> 2]);
   f6 = Math_fround(f32 - f6);
   f7 = Math_fround(f33 - Math_fround(HEAPF32[i22 >> 2]));
   HEAPF32[i27 >> 2] = Math_fround(f30 - f5);
   HEAPF32[i23 >> 2] = f6;
   HEAPF32[i24 >> 2] = f7;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i42 = HEAP32[i50 >> 2] | 0;
   HEAPF32[i66 + (i42 << 4) >> 2] = f30;
   HEAPF32[i66 + (i42 << 4) + 4 >> 2] = f32;
   HEAPF32[i66 + (i42 << 4) + 8 >> 2] = f33;
   HEAPF32[i66 + (i42 << 4) + 12 >> 2] = Math_fround(0.0);
   i41 = i67 + (i42 << 4) | 0;
   HEAP32[i41 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i41 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i41 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i41 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   HEAP32[i50 >> 2] = i42 + 1;
   i42 = i68 + (i42 << 4) | 0;
   HEAP32[i42 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i42 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAPU8[i63 >> 0] | 0) >>> 0) break;
   f4 = Math_fround(HEAPF32[i47 >> 2]);
  }
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i26, i68, i66, i67, i74, i76, i27, i50);
  HEAP32[i69 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i69 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i69 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i69 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i69 >> 2]);
  f6 = Math_fround(HEAPF32[i69 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i69 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i57 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i56 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i56 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i56 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i31 >> 2] = HEAP32[i69 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i69 + 12 >> 2];
  if (f4 > f44) {
   i42 = i69;
   i61 = 8;
  } else i2 = HEAP32[i50 >> 2] | 0;
 }
 do if ((i61 | 0) == 8) {
  i40 = i69 + 4 | 0;
  i41 = i69 + 8 | 0;
  i12 = i43 + 144 | 0;
  i13 = i43 + 148 | 0;
  i14 = i43 + 152 | 0;
  i15 = i48 + 4 | 0;
  i16 = i48 + 8 | 0;
  i17 = i48 + 16 | 0;
  i18 = i48 + 20 | 0;
  i19 = i48 + 24 | 0;
  i20 = i48 + 32 | 0;
  i21 = i48 + 36 | 0;
  i22 = i48 + 40 | 0;
  i23 = i48 + 48 | 0;
  i24 = i48 + 52 | 0;
  i25 = i48 + 56 | 0;
  i26 = i49 + 196 | 0;
  i27 = i49 + 200 | 0;
  i28 = i49 + 204 | 0;
  i29 = i49 + 16 | 0;
  i35 = i52 + 4 | 0;
  i36 = i52 + 8 | 0;
  i37 = i51 + 4 | 0;
  i38 = i51 + 8 | 0;
  i39 = i51 + 12 | 0;
  i10 = i43 + 48 | 0;
  i11 = i49 + 48 | 0;
  while (1) {
   HEAP32[i56 >> 2] = HEAP32[i57 >> 2];
   HEAP32[i56 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
   HEAP32[i56 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
   HEAP32[i31 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f79 = Math_fround(-f5);
   f80 = Math_fround(-f6);
   f82 = Math_fround(-f7);
   i9 = HEAP32[i50 >> 2] | 0;
   f90 = Math_fround(HEAPF32[i12 >> 2]);
   f86 = Math_fround(HEAPF32[i13 >> 2]);
   f88 = Math_fround(HEAPF32[i14 >> 2]);
   f89 = Math_fround(HEAPF32[i47 >> 2]);
   f90 = Math_fround(f90 - f89);
   f86 = Math_fround(f86 - f89);
   f89 = Math_fround(f88 - f89);
   f88 = Math_fround(HEAPF32[i48 >> 2]);
   f91 = Math_fround(f88 * f79);
   f85 = Math_fround(HEAPF32[i15 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f85 * f80));
   f83 = Math_fround(HEAPF32[i16 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f83 * f82));
   f87 = Math_fround(HEAPF32[i17 >> 2]);
   f33 = Math_fround(f87 * f79);
   f84 = Math_fround(HEAPF32[i18 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f84 * f80));
   f81 = Math_fround(HEAPF32[i19 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f81 * f82));
   f30 = Math_fround(HEAPF32[i20 >> 2]);
   f79 = Math_fround(f30 * f79);
   f32 = Math_fround(HEAPF32[i21 >> 2]);
   f80 = Math_fround(f79 + Math_fround(f32 * f80));
   f79 = Math_fround(HEAPF32[i22 >> 2]);
   i3 = f91 > Math_fround(0.0);
   i43 = f33 > Math_fround(0.0);
   i8 = Math_fround(f80 + Math_fround(f79 * f82)) > Math_fround(0.0);
   HEAP32[i74 + (i9 << 2) >> 2] = i43 << 31 >> 31 << 1 & 2 | i3 & 1 | i8 << 31 >> 31 << 2 & 4;
   f82 = Math_fround(-f90);
   f80 = Math_fround(-f86);
   f33 = Math_fround(-f89);
   f82 = i3 ? f90 : f82;
   f80 = i43 ? f86 : f80;
   f33 = i8 ? f89 : f33;
   f89 = Math_fround(HEAPF32[i23 >> 2]);
   f86 = Math_fround(HEAPF32[i24 >> 2]);
   f30 = Math_fround(f89 + Math_fround(Math_fround(Math_fround(f88 * f82) + Math_fround(f87 * f80)) + Math_fround(f30 * f33)));
   f32 = Math_fround(f86 + Math_fround(Math_fround(Math_fround(f85 * f82) + Math_fround(f84 * f80)) + Math_fround(f32 * f33)));
   f33 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + Math_fround(Math_fround(Math_fround(f83 * f82) + Math_fround(f81 * f80)) + Math_fround(f79 * f33)));
   HEAPF32[i66 + (i9 << 4) >> 2] = f30;
   HEAPF32[i66 + (i9 << 4) + 4 >> 2] = f32;
   HEAPF32[i66 + (i9 << 4) + 8 >> 2] = f33;
   HEAPF32[i66 + (i9 << 4) + 12 >> 2] = Math_fround(0.0);
   i8 = i67 + (i9 << 4) | 0;
   i9 = i76 + (i9 << 2) | 0;
   if (!(HEAP32[i26 >> 2] | 0)) {
    i1 = HEAP32[i27 >> 2] | 0;
    if ((HEAPU8[i28 >> 0] | 0) > 1) {
     f91 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f5);
     f6 = Math_fround(f91 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f6));
     f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f7));
     i2 = 1;
     i1 = 0;
     while (1) {
      i3 = HEAP32[i27 >> 2] | 0;
      f88 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) >> 2]);
      f90 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2]);
      f89 = Math_fround(HEAPF32[i69 >> 2]);
      f91 = Math_fround(HEAPF32[i40 >> 2]);
      f5 = Math_fround(Math_fround(Math_fround(f88 * f89) + Math_fround(f90 * f91)) + Math_fround(f5 * Math_fround(HEAPF32[i41 >> 2])));
      i3 = f5 > f6;
      i1 = i3 ? i2 : i1;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i28 >> 0] | 0) >>> 0) f6 = i3 ? f5 : f6; else break;
     }
    } else i1 = 0;
   } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i49, i69) | 0;
   HEAP32[i9 >> 2] = i1;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i52, i49, i1, i29);
   HEAP32[i8 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
   f87 = Math_fround(HEAPF32[i52 >> 2]);
   f89 = Math_fround(HEAPF32[i35 >> 2]);
   f87 = Math_fround(f30 - f87);
   f89 = Math_fround(f32 - f89);
   f91 = Math_fround(f33 - Math_fround(HEAPF32[i36 >> 2]));
   HEAPF32[i51 >> 2] = f87;
   HEAPF32[i37 >> 2] = f89;
   HEAPF32[i38 >> 2] = f91;
   HEAPF32[i39 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i50 >> 2] | 0;
   i2 = i68 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
   f86 = Math_fround(HEAPF32[i10 >> 2]);
   f90 = Math_fround(HEAPF32[i11 >> 2]);
   f90 = f86 > f90 ? f86 : f90;
   f34 = f34 > f90 ? f34 : f90;
   f90 = Math_fround(f62 + f34);
   f90 = Math_fround(f4 * Math_fround(f90 * f90));
   f86 = Math_fround(HEAPF32[i69 >> 2]);
   f88 = Math_fround(HEAPF32[i40 >> 2]);
   f91 = Math_fround(Math_fround(Math_fround(f86 * f87) + Math_fround(f88 * f89)) + Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f91));
   i2 = f91 > Math_fround(0.0) & Math_fround(f91 * f91) > f90;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f91) | i2) {
    i61 = 15;
    break;
   }
   HEAP32[i50 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i46, i68, i66, i67, i74, i76, i51, i50);
   HEAP32[i42 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i42 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i69 >> 2]);
   f6 = Math_fround(HEAPF32[i40 >> 2]);
   f7 = Math_fround(HEAPF32[i41 >> 2]);
   f30 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i57 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i57 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i57 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
   i1 = f4 > f30;
   if (!(f30 > f44 & i1)) break; else f4 = f30;
  }
  if ((i61 | 0) == 15) {
   if (i75 | 0) {
    HEAP8[i63 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i75 + i1 >> 0] = HEAP32[i74 + (i1 << 2) >> 2];
      HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i77 = 0;
    STACKTOP = i78;
    return i77 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i68, i66, i67, i69, i59, i60, i3);
   f88 = Math_fround(Math_sqrt(Math_fround(f4)));
   f89 = Math_fround(HEAPF32[i69 >> 2]);
   f90 = Math_fround(HEAPF32[i40 >> 2]);
   f91 = Math_fround(Math_fround(1.0) / f88);
   f89 = Math_fround(f89 * f91);
   f90 = Math_fround(f90 * f91);
   f91 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f91);
   f87 = Math_fround(HEAPF32[i59 >> 2]);
   f86 = Math_fround(HEAPF32[i59 + 4 >> 2]);
   f86 = Math_fround(f86 - Math_fround(f64 * f90));
   f85 = Math_fround(Math_fround(HEAPF32[i59 + 8 >> 2]) - Math_fround(f64 * f91));
   HEAPF32[i70 >> 2] = Math_fround(f87 - Math_fround(f64 * f89));
   HEAPF32[i70 + 4 >> 2] = f86;
   HEAPF32[i70 + 8 >> 2] = f85;
   HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
   f85 = Math_fround(HEAPF32[i60 >> 2]);
   f86 = Math_fround(HEAPF32[i60 + 4 >> 2]);
   f86 = Math_fround(Math_fround(f65 * f90) + f86);
   f87 = Math_fround(Math_fround(f65 * f91) + Math_fround(HEAPF32[i60 + 8 >> 2]));
   HEAPF32[i71 >> 2] = Math_fround(Math_fround(f65 * f89) + f85);
   HEAPF32[i71 + 4 >> 2] = f86;
   HEAPF32[i71 + 8 >> 2] = f87;
   HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i73 >> 2] = Math_fround(f88 - f62);
   i77 = i73 + 4 | 0;
   HEAP32[i77 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i77 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i77 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   HEAPF32[i72 >> 2] = f89;
   HEAPF32[i72 + 4 >> 2] = f90;
   HEAPF32[i72 + 8 >> 2] = f91;
   HEAPF32[i72 + 12 >> 2] = Math_fround(0.0);
   i77 = 1;
   STACKTOP = i78;
   return i77 | 0;
  }
  i2 = HEAP32[i50 >> 2] | 0;
  if (i1) {
   if (!i75) i1 = 6; else break;
   STACKTOP = i78;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i75 | 0) {
   HEAP8[i63 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i75 + i1 >> 0] = HEAP32[i74 + (i1 << 2) >> 2];
     HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i42 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i68, i66, i67, i69, i54, i55, i2);
  HEAP32[i57 >> 2] = HEAP32[i56 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
  f88 = Math_fround(Math_sqrt(Math_fround(f4)));
  f89 = Math_fround(HEAPF32[i69 >> 2]);
  f90 = Math_fround(HEAPF32[i69 + 4 >> 2]);
  f91 = Math_fround(Math_fround(1.0) / f88);
  f89 = Math_fround(f89 * f91);
  f90 = Math_fround(f90 * f91);
  f91 = Math_fround(Math_fround(HEAPF32[i69 + 8 >> 2]) * f91);
  f87 = Math_fround(HEAPF32[i54 >> 2]);
  f86 = Math_fround(HEAPF32[i54 + 4 >> 2]);
  f86 = Math_fround(f86 - Math_fround(f64 * f90));
  f85 = Math_fround(Math_fround(HEAPF32[i54 + 8 >> 2]) - Math_fround(f64 * f91));
  HEAPF32[i70 >> 2] = Math_fround(f87 - Math_fround(f64 * f89));
  HEAPF32[i70 + 4 >> 2] = f86;
  HEAPF32[i70 + 8 >> 2] = f85;
  HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
  f85 = Math_fround(HEAPF32[i55 >> 2]);
  f86 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f86 = Math_fround(Math_fround(f65 * f90) + f86);
  f87 = Math_fround(Math_fround(f65 * f91) + Math_fround(HEAPF32[i55 + 8 >> 2]));
  HEAPF32[i71 >> 2] = Math_fround(Math_fround(f65 * f89) + f85);
  HEAPF32[i71 + 4 >> 2] = f86;
  HEAPF32[i71 + 8 >> 2] = f87;
  HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i73 >> 2] = Math_fround(f88 - f62);
  i77 = i73 + 4 | 0;
  HEAP32[i77 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i77 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i77 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAPF32[i72 >> 2] = f89;
  HEAPF32[i72 + 4 >> 2] = f90;
  HEAPF32[i72 + 8 >> 2] = f91;
  HEAPF32[i72 + 12 >> 2] = Math_fround(0.0);
  i77 = 3;
  STACKTOP = i78;
  return i77 | 0;
 } while (0);
 HEAP8[i63 >> 0] = i2;
 if (!i2) {
  i77 = 6;
  STACKTOP = i78;
  return i77 | 0;
 } else i1 = 0;
 do {
  HEAP8[i75 + i1 >> 0] = HEAP32[i74 + (i1 << 2) >> 2];
  HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i78;
 return i1 | 0;
}

function __ZN5Umbra15ShadowCullerExtaSERKS0_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = (i6 | 0) == 0 ? 0 : i6 + 15 & -16;
 i2 = i1 + 15 & -16;
 i1 = i2;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i5 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i5 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i5 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i5 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i5 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i5 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i5 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i5 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i5 + 84 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i5 + 88 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i5 + 92 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i5 + 96 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i5 + 100 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i5 + 104 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i5 + 108 >> 2] = HEAP32[i1 + 108 >> 2];
 HEAP32[i5 + 112 >> 2] = HEAP32[i1 + 112 >> 2];
 HEAP32[i5 + 116 >> 2] = HEAP32[i1 + 116 >> 2];
 HEAP32[i5 + 120 >> 2] = HEAP32[i1 + 120 >> 2];
 HEAP32[i5 + 124 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i5 + 128 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i5 + 132 >> 2] = HEAP32[i1 + 132 >> 2];
 HEAP32[i5 + 136 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i5 + 140 >> 2] = HEAP32[i1 + 140 >> 2];
 HEAP32[i5 + 144 >> 2] = HEAP32[i1 + 144 >> 2];
 HEAP32[i5 + 148 >> 2] = HEAP32[i1 + 148 >> 2];
 HEAP32[i5 + 152 >> 2] = HEAP32[i1 + 152 >> 2];
 HEAP32[i5 + 156 >> 2] = HEAP32[i1 + 156 >> 2];
 HEAP32[i5 + 160 >> 2] = HEAP32[i1 + 160 >> 2];
 HEAP32[i5 + 164 >> 2] = HEAP32[i1 + 164 >> 2];
 HEAP32[i5 + 168 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP32[i5 + 172 >> 2] = HEAP32[i1 + 172 >> 2];
 HEAP32[i5 + 176 >> 2] = HEAP32[i1 + 176 >> 2];
 HEAP32[i5 + 180 >> 2] = HEAP32[i1 + 180 >> 2];
 HEAP32[i5 + 184 >> 2] = HEAP32[i1 + 184 >> 2];
 HEAP32[i5 + 188 >> 2] = HEAP32[i1 + 188 >> 2];
 _memcpy(i5 + 192 | 0, i1 + 192 | 0, 32816) | 0;
 i2 = i5 + 33008 | 0;
 i3 = i1 + 33008 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i5 + 33040 >> 2] = HEAP32[i1 + 33040 >> 2];
 HEAP32[i5 + 33044 >> 2] = HEAP32[i1 + 33044 >> 2];
 HEAP32[i5 + 33048 >> 2] = HEAP32[i1 + 33048 >> 2];
 HEAP32[i5 + 33052 >> 2] = HEAP32[i1 + 33052 >> 2];
 HEAP32[i5 + 33056 >> 2] = HEAP32[i1 + 33056 >> 2];
 HEAP32[i5 + 33060 >> 2] = HEAP32[i1 + 33060 >> 2];
 HEAP32[i5 + 33064 >> 2] = HEAP32[i1 + 33064 >> 2];
 HEAP32[i5 + 33068 >> 2] = HEAP32[i1 + 33068 >> 2];
 HEAP32[i5 + 33072 >> 2] = HEAP32[i1 + 33072 >> 2];
 HEAP32[i5 + 33076 >> 2] = HEAP32[i1 + 33076 >> 2];
 HEAP32[i5 + 33080 >> 2] = HEAP32[i1 + 33080 >> 2];
 HEAP32[i5 + 33084 >> 2] = HEAP32[i1 + 33084 >> 2];
 HEAP32[i5 + 33088 >> 2] = HEAP32[i1 + 33088 >> 2];
 HEAP32[i5 + 33092 >> 2] = HEAP32[i1 + 33092 >> 2];
 HEAP32[i5 + 33096 >> 2] = HEAP32[i1 + 33096 >> 2];
 HEAP32[i5 + 33100 >> 2] = HEAP32[i1 + 33100 >> 2];
 HEAP32[i5 + 33104 >> 2] = HEAP32[i1 + 33104 >> 2];
 HEAP32[i5 + 33108 >> 2] = HEAP32[i1 + 33108 >> 2];
 HEAP32[i5 + 33112 >> 2] = HEAP32[i1 + 33112 >> 2];
 HEAP32[i5 + 33116 >> 2] = HEAP32[i1 + 33116 >> 2];
 HEAP32[i5 + 33120 >> 2] = HEAP32[i1 + 33120 >> 2];
 HEAP32[i5 + 33124 >> 2] = HEAP32[i1 + 33124 >> 2];
 HEAP32[i5 + 33128 >> 2] = HEAP32[i1 + 33128 >> 2];
 HEAP32[i5 + 33132 >> 2] = HEAP32[i1 + 33132 >> 2];
 HEAP32[i5 + 33136 >> 2] = HEAP32[i1 + 33136 >> 2];
 HEAP32[i5 + 33140 >> 2] = HEAP32[i1 + 33140 >> 2];
 HEAP32[i5 + 33144 >> 2] = HEAP32[i1 + 33144 >> 2];
 HEAP32[i5 + 33148 >> 2] = HEAP32[i1 + 33148 >> 2];
 HEAP32[i5 + 33152 >> 2] = HEAP32[i1 + 33152 >> 2];
 HEAP32[i5 + 33156 >> 2] = HEAP32[i1 + 33156 >> 2];
 HEAP32[i5 + 33160 >> 2] = HEAP32[i1 + 33160 >> 2];
 HEAP32[i5 + 33164 >> 2] = HEAP32[i1 + 33164 >> 2];
 _memcpy(i5 + 33168 | 0, i1 + 33168 | 0, 1276) | 0;
 i2 = i5 + 34448 | 0;
 i3 = i1 + 34448 | 0;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i5 + 34496 >> 2] = HEAP32[i1 + 34496 >> 2];
 HEAP32[i5 + 34500 >> 2] = HEAP32[i1 + 34500 >> 2];
 HEAP32[i5 + 34504 >> 2] = HEAP32[i1 + 34504 >> 2];
 HEAP32[i5 + 34508 >> 2] = HEAP32[i1 + 34508 >> 2];
 HEAP32[i5 + 34512 >> 2] = HEAP32[i1 + 34512 >> 2];
 HEAP32[i5 + 34516 >> 2] = HEAP32[i1 + 34516 >> 2];
 HEAP32[i5 + 34520 >> 2] = HEAP32[i1 + 34520 >> 2];
 HEAP32[i5 + 34524 >> 2] = HEAP32[i1 + 34524 >> 2];
 HEAP32[i5 + 34528 >> 2] = HEAP32[i1 + 34528 >> 2];
 HEAP32[i5 + 34532 >> 2] = HEAP32[i1 + 34532 >> 2];
 HEAP32[i5 + 34536 >> 2] = HEAP32[i1 + 34536 >> 2];
 HEAP32[i5 + 34540 >> 2] = HEAP32[i1 + 34540 >> 2];
 HEAP32[i5 + 34544 >> 2] = HEAP32[i1 + 34544 >> 2];
 HEAP32[i5 + 34548 >> 2] = HEAP32[i1 + 34548 >> 2];
 HEAP32[i5 + 34552 >> 2] = HEAP32[i1 + 34552 >> 2];
 HEAP32[i5 + 34556 >> 2] = HEAP32[i1 + 34556 >> 2];
 HEAP32[i5 + 34560 >> 2] = HEAP32[i1 + 34560 >> 2];
 HEAP32[i5 + 34564 >> 2] = HEAP32[i1 + 34564 >> 2];
 HEAP32[i5 + 34568 >> 2] = HEAP32[i1 + 34568 >> 2];
 HEAP32[i5 + 34572 >> 2] = HEAP32[i1 + 34572 >> 2];
 HEAP32[i5 + 34576 >> 2] = HEAP32[i1 + 34576 >> 2];
 HEAP32[i5 + 34580 >> 2] = HEAP32[i1 + 34580 >> 2];
 HEAP32[i5 + 34584 >> 2] = HEAP32[i1 + 34584 >> 2];
 HEAP32[i5 + 34588 >> 2] = HEAP32[i1 + 34588 >> 2];
 HEAP32[i5 + 34592 >> 2] = HEAP32[i1 + 34592 >> 2];
 HEAP32[i5 + 34596 >> 2] = HEAP32[i1 + 34596 >> 2];
 HEAP32[i5 + 34600 >> 2] = HEAP32[i1 + 34600 >> 2];
 HEAP32[i5 + 34604 >> 2] = HEAP32[i1 + 34604 >> 2];
 HEAP32[i5 + 34608 >> 2] = HEAP32[i1 + 34608 >> 2];
 HEAP32[i5 + 34612 >> 2] = HEAP32[i1 + 34612 >> 2];
 HEAP32[i5 + 34616 >> 2] = HEAP32[i1 + 34616 >> 2];
 HEAP32[i5 + 34620 >> 2] = HEAP32[i1 + 34620 >> 2];
 _memcpy(i5 + 34624 | 0, i1 + 34624 | 0, 1276) | 0;
 HEAP32[i5 + 35904 >> 2] = HEAP32[i1 + 35904 >> 2];
 HEAP32[i5 + 35908 >> 2] = HEAP32[i1 + 35908 >> 2];
 HEAP32[i5 + 35912 >> 2] = HEAP32[i1 + 35912 >> 2];
 HEAP32[i5 + 35916 >> 2] = HEAP32[i1 + 35916 >> 2];
 HEAP32[i5 + 35920 >> 2] = HEAP32[i1 + 35920 >> 2];
 HEAP32[i5 + 35924 >> 2] = HEAP32[i1 + 35924 >> 2];
 HEAP32[i5 + 35928 >> 2] = HEAP32[i1 + 35928 >> 2];
 HEAP32[i5 + 35932 >> 2] = HEAP32[i1 + 35932 >> 2];
 HEAP32[i5 + 35936 >> 2] = HEAP32[i1 + 35936 >> 2];
 HEAP32[i5 + 35940 >> 2] = HEAP32[i1 + 35940 >> 2];
 HEAP32[i5 + 35944 >> 2] = HEAP32[i1 + 35944 >> 2];
 HEAP32[i5 + 35948 >> 2] = HEAP32[i1 + 35948 >> 2];
 HEAP32[i5 + 35952 >> 2] = HEAP32[i1 + 35952 >> 2];
 HEAP32[i5 + 35956 >> 2] = HEAP32[i1 + 35956 >> 2];
 HEAP32[i5 + 35960 >> 2] = HEAP32[i1 + 35960 >> 2];
 HEAP32[i5 + 35964 >> 2] = HEAP32[i1 + 35964 >> 2];
 HEAP32[i5 + 35968 >> 2] = HEAP32[i1 + 35968 >> 2];
 HEAP32[i5 + 35972 >> 2] = HEAP32[i1 + 35972 >> 2];
 HEAP32[i5 + 35976 >> 2] = HEAP32[i1 + 35976 >> 2];
 HEAP32[i5 + 35980 >> 2] = HEAP32[i1 + 35980 >> 2];
 HEAP32[i5 + 35984 >> 2] = HEAP32[i1 + 35984 >> 2];
 HEAP32[i5 + 35988 >> 2] = HEAP32[i1 + 35988 >> 2];
 HEAP32[i5 + 35992 >> 2] = HEAP32[i1 + 35992 >> 2];
 HEAP32[i5 + 35996 >> 2] = HEAP32[i1 + 35996 >> 2];
 HEAP32[i5 + 36e3 >> 2] = HEAP32[i1 + 36e3 >> 2];
 HEAP32[i5 + 36004 >> 2] = HEAP32[i1 + 36004 >> 2];
 HEAP32[i5 + 36008 >> 2] = HEAP32[i1 + 36008 >> 2];
 HEAP32[i5 + 36012 >> 2] = HEAP32[i1 + 36012 >> 2];
 HEAP32[i5 + 36016 >> 2] = HEAP32[i1 + 36016 >> 2];
 HEAP32[i5 + 36020 >> 2] = HEAP32[i1 + 36020 >> 2];
 HEAP32[i5 + 36024 >> 2] = HEAP32[i1 + 36024 >> 2];
 HEAP32[i5 + 36028 >> 2] = HEAP32[i1 + 36028 >> 2];
 _memcpy(i5 + 36032 | 0, i1 + 36032 | 0, 1276) | 0;
 HEAP32[i5 + 37312 >> 2] = HEAP32[i1 + 37312 >> 2];
 HEAP32[i5 + 37316 >> 2] = HEAP32[i1 + 37316 >> 2];
 HEAP32[i5 + 37320 >> 2] = HEAP32[i1 + 37320 >> 2];
 HEAP32[i5 + 37324 >> 2] = HEAP32[i1 + 37324 >> 2];
 HEAP32[i5 + 37328 >> 2] = HEAP32[i1 + 37328 >> 2];
 HEAP32[i5 + 37332 >> 2] = HEAP32[i1 + 37332 >> 2];
 HEAP32[i5 + 37336 >> 2] = HEAP32[i1 + 37336 >> 2];
 HEAP32[i5 + 37340 >> 2] = HEAP32[i1 + 37340 >> 2];
 HEAP32[i5 + 37344 >> 2] = HEAP32[i1 + 37344 >> 2];
 HEAP32[i5 + 37348 >> 2] = HEAP32[i1 + 37348 >> 2];
 HEAP32[i5 + 37352 >> 2] = HEAP32[i1 + 37352 >> 2];
 HEAP32[i5 + 37356 >> 2] = HEAP32[i1 + 37356 >> 2];
 HEAP32[i5 + 37360 >> 2] = HEAP32[i1 + 37360 >> 2];
 HEAP32[i5 + 37364 >> 2] = HEAP32[i1 + 37364 >> 2];
 HEAP32[i5 + 37368 >> 2] = HEAP32[i1 + 37368 >> 2];
 HEAP32[i5 + 37372 >> 2] = HEAP32[i1 + 37372 >> 2];
 HEAP32[i5 + 37376 >> 2] = HEAP32[i1 + 37376 >> 2];
 HEAP32[i5 + 37380 >> 2] = HEAP32[i1 + 37380 >> 2];
 HEAP32[i5 + 37384 >> 2] = HEAP32[i1 + 37384 >> 2];
 HEAP32[i5 + 37388 >> 2] = HEAP32[i1 + 37388 >> 2];
 HEAP32[i5 + 37392 >> 2] = HEAP32[i1 + 37392 >> 2];
 HEAP32[i5 + 37396 >> 2] = HEAP32[i1 + 37396 >> 2];
 HEAP32[i5 + 37400 >> 2] = HEAP32[i1 + 37400 >> 2];
 HEAP32[i5 + 37404 >> 2] = HEAP32[i1 + 37404 >> 2];
 HEAP32[i5 + 37408 >> 2] = HEAP32[i1 + 37408 >> 2];
 HEAP32[i5 + 37412 >> 2] = HEAP32[i1 + 37412 >> 2];
 HEAP32[i5 + 37416 >> 2] = HEAP32[i1 + 37416 >> 2];
 HEAP32[i5 + 37420 >> 2] = HEAP32[i1 + 37420 >> 2];
 HEAP32[i5 + 37424 >> 2] = HEAP32[i1 + 37424 >> 2];
 HEAP32[i5 + 37428 >> 2] = HEAP32[i1 + 37428 >> 2];
 HEAP32[i5 + 37432 >> 2] = HEAP32[i1 + 37432 >> 2];
 HEAP32[i5 + 37436 >> 2] = HEAP32[i1 + 37436 >> 2];
 _memcpy(i5 + 37440 | 0, i1 + 37440 | 0, 1276) | 0;
 HEAP32[i5 + 38720 >> 2] = HEAP32[i1 + 38720 >> 2];
 HEAP32[i5 + 38724 >> 2] = HEAP32[i1 + 38724 >> 2];
 HEAP32[i5 + 38728 >> 2] = HEAP32[i1 + 38728 >> 2];
 HEAP32[i5 + 38732 >> 2] = HEAP32[i1 + 38732 >> 2];
 HEAP32[i5 + 38736 >> 2] = HEAP32[i1 + 38736 >> 2];
 HEAP32[i5 + 38740 >> 2] = HEAP32[i1 + 38740 >> 2];
 HEAP32[i5 + 38744 >> 2] = HEAP32[i1 + 38744 >> 2];
 HEAP32[i5 + 38748 >> 2] = HEAP32[i1 + 38748 >> 2];
 HEAP32[i5 + 38752 >> 2] = HEAP32[i1 + 38752 >> 2];
 HEAP32[i5 + 38756 >> 2] = HEAP32[i1 + 38756 >> 2];
 HEAP32[i5 + 38760 >> 2] = HEAP32[i1 + 38760 >> 2];
 HEAP32[i5 + 38764 >> 2] = HEAP32[i1 + 38764 >> 2];
 HEAP32[i5 + 38768 >> 2] = HEAP32[i1 + 38768 >> 2];
 HEAP32[i5 + 38772 >> 2] = HEAP32[i1 + 38772 >> 2];
 HEAP32[i5 + 38776 >> 2] = HEAP32[i1 + 38776 >> 2];
 HEAP32[i5 + 38780 >> 2] = HEAP32[i1 + 38780 >> 2];
 HEAP32[i5 + 38784 >> 2] = HEAP32[i1 + 38784 >> 2];
 HEAP32[i5 + 38788 >> 2] = HEAP32[i1 + 38788 >> 2];
 HEAP32[i5 + 38792 >> 2] = HEAP32[i1 + 38792 >> 2];
 HEAP32[i5 + 38796 >> 2] = HEAP32[i1 + 38796 >> 2];
 HEAP32[i5 + 38800 >> 2] = HEAP32[i1 + 38800 >> 2];
 HEAP32[i5 + 38804 >> 2] = HEAP32[i1 + 38804 >> 2];
 HEAP32[i5 + 38808 >> 2] = HEAP32[i1 + 38808 >> 2];
 HEAP32[i5 + 38812 >> 2] = HEAP32[i1 + 38812 >> 2];
 HEAP32[i5 + 38816 >> 2] = HEAP32[i1 + 38816 >> 2];
 HEAP32[i5 + 38820 >> 2] = HEAP32[i1 + 38820 >> 2];
 HEAP32[i5 + 38824 >> 2] = HEAP32[i1 + 38824 >> 2];
 HEAP32[i5 + 38828 >> 2] = HEAP32[i1 + 38828 >> 2];
 HEAP32[i5 + 38832 >> 2] = HEAP32[i1 + 38832 >> 2];
 HEAP32[i5 + 38836 >> 2] = HEAP32[i1 + 38836 >> 2];
 HEAP32[i5 + 38840 >> 2] = HEAP32[i1 + 38840 >> 2];
 HEAP32[i5 + 38844 >> 2] = HEAP32[i1 + 38844 >> 2];
 _memcpy(i5 + 38848 | 0, i1 + 38848 | 0, 1276) | 0;
 HEAP32[i5 + 40128 >> 2] = HEAP32[i1 + 40128 >> 2];
 HEAP32[i5 + 40132 >> 2] = HEAP32[i1 + 40132 >> 2];
 HEAP32[i5 + 40136 >> 2] = HEAP32[i1 + 40136 >> 2];
 HEAP32[i5 + 40140 >> 2] = HEAP32[i1 + 40140 >> 2];
 HEAP32[i5 + 40144 >> 2] = HEAP32[i1 + 40144 >> 2];
 HEAP32[i5 + 40148 >> 2] = HEAP32[i1 + 40148 >> 2];
 HEAP32[i5 + 40152 >> 2] = HEAP32[i1 + 40152 >> 2];
 HEAP32[i5 + 40156 >> 2] = HEAP32[i1 + 40156 >> 2];
 HEAP32[i5 + 40160 >> 2] = HEAP32[i1 + 40160 >> 2];
 HEAP32[i5 + 40164 >> 2] = HEAP32[i1 + 40164 >> 2];
 HEAP32[i5 + 40168 >> 2] = HEAP32[i1 + 40168 >> 2];
 HEAP32[i5 + 40172 >> 2] = HEAP32[i1 + 40172 >> 2];
 HEAP32[i5 + 40176 >> 2] = HEAP32[i1 + 40176 >> 2];
 HEAP32[i5 + 40180 >> 2] = HEAP32[i1 + 40180 >> 2];
 HEAP32[i5 + 40184 >> 2] = HEAP32[i1 + 40184 >> 2];
 HEAP32[i5 + 40188 >> 2] = HEAP32[i1 + 40188 >> 2];
 HEAP32[i5 + 40192 >> 2] = HEAP32[i1 + 40192 >> 2];
 HEAP32[i5 + 40196 >> 2] = HEAP32[i1 + 40196 >> 2];
 HEAP32[i5 + 40200 >> 2] = HEAP32[i1 + 40200 >> 2];
 HEAP32[i5 + 40204 >> 2] = HEAP32[i1 + 40204 >> 2];
 HEAP32[i5 + 40208 >> 2] = HEAP32[i1 + 40208 >> 2];
 HEAP32[i5 + 40212 >> 2] = HEAP32[i1 + 40212 >> 2];
 HEAP32[i5 + 40216 >> 2] = HEAP32[i1 + 40216 >> 2];
 HEAP32[i5 + 40220 >> 2] = HEAP32[i1 + 40220 >> 2];
 HEAP32[i5 + 40224 >> 2] = HEAP32[i1 + 40224 >> 2];
 HEAP32[i5 + 40228 >> 2] = HEAP32[i1 + 40228 >> 2];
 HEAP32[i5 + 40232 >> 2] = HEAP32[i1 + 40232 >> 2];
 HEAP32[i5 + 40236 >> 2] = HEAP32[i1 + 40236 >> 2];
 HEAP32[i5 + 40240 >> 2] = HEAP32[i1 + 40240 >> 2];
 HEAP32[i5 + 40244 >> 2] = HEAP32[i1 + 40244 >> 2];
 HEAP32[i5 + 40248 >> 2] = HEAP32[i1 + 40248 >> 2];
 HEAP32[i5 + 40252 >> 2] = HEAP32[i1 + 40252 >> 2];
 _memcpy(i5 + 40256 | 0, i1 + 40256 | 0, 1276) | 0;
 HEAP32[i5 + 41536 >> 2] = HEAP32[i1 + 41536 >> 2];
 HEAP32[i5 + 41540 >> 2] = HEAP32[i1 + 41540 >> 2];
 HEAP32[i5 + 41544 >> 2] = HEAP32[i1 + 41544 >> 2];
 HEAP32[i5 + 41548 >> 2] = HEAP32[i1 + 41548 >> 2];
 HEAP32[i5 + 41552 >> 2] = HEAP32[i1 + 41552 >> 2];
 HEAP32[i5 + 41556 >> 2] = HEAP32[i1 + 41556 >> 2];
 HEAP32[i5 + 41560 >> 2] = HEAP32[i1 + 41560 >> 2];
 HEAP32[i5 + 41564 >> 2] = HEAP32[i1 + 41564 >> 2];
 HEAP32[i5 + 41568 >> 2] = HEAP32[i1 + 41568 >> 2];
 HEAP32[i5 + 41572 >> 2] = HEAP32[i1 + 41572 >> 2];
 HEAP32[i5 + 41576 >> 2] = HEAP32[i1 + 41576 >> 2];
 HEAP32[i5 + 41580 >> 2] = HEAP32[i1 + 41580 >> 2];
 HEAP32[i5 + 41584 >> 2] = HEAP32[i1 + 41584 >> 2];
 HEAP32[i5 + 41588 >> 2] = HEAP32[i1 + 41588 >> 2];
 HEAP32[i5 + 41592 >> 2] = HEAP32[i1 + 41592 >> 2];
 HEAP32[i5 + 41596 >> 2] = HEAP32[i1 + 41596 >> 2];
 HEAP32[i5 + 41600 >> 2] = HEAP32[i1 + 41600 >> 2];
 HEAP32[i5 + 41604 >> 2] = HEAP32[i1 + 41604 >> 2];
 HEAP32[i5 + 41608 >> 2] = HEAP32[i1 + 41608 >> 2];
 HEAP32[i5 + 41612 >> 2] = HEAP32[i1 + 41612 >> 2];
 HEAP32[i5 + 41616 >> 2] = HEAP32[i1 + 41616 >> 2];
 HEAP32[i5 + 41620 >> 2] = HEAP32[i1 + 41620 >> 2];
 HEAP32[i5 + 41624 >> 2] = HEAP32[i1 + 41624 >> 2];
 HEAP32[i5 + 41628 >> 2] = HEAP32[i1 + 41628 >> 2];
 HEAP32[i5 + 41632 >> 2] = HEAP32[i1 + 41632 >> 2];
 HEAP32[i5 + 41636 >> 2] = HEAP32[i1 + 41636 >> 2];
 HEAP32[i5 + 41640 >> 2] = HEAP32[i1 + 41640 >> 2];
 HEAP32[i5 + 41644 >> 2] = HEAP32[i1 + 41644 >> 2];
 HEAP32[i5 + 41648 >> 2] = HEAP32[i1 + 41648 >> 2];
 HEAP32[i5 + 41652 >> 2] = HEAP32[i1 + 41652 >> 2];
 HEAP32[i5 + 41656 >> 2] = HEAP32[i1 + 41656 >> 2];
 HEAP32[i5 + 41660 >> 2] = HEAP32[i1 + 41660 >> 2];
 _memcpy(i5 + 41664 | 0, i1 + 41664 | 0, 1276) | 0;
 HEAP32[i5 + 42944 >> 2] = HEAP32[i1 + 42944 >> 2];
 HEAP32[i5 + 42948 >> 2] = HEAP32[i1 + 42948 >> 2];
 HEAP32[i5 + 42952 >> 2] = HEAP32[i1 + 42952 >> 2];
 HEAP32[i5 + 42956 >> 2] = HEAP32[i1 + 42956 >> 2];
 HEAP32[i5 + 42960 >> 2] = HEAP32[i1 + 42960 >> 2];
 HEAP32[i5 + 42964 >> 2] = HEAP32[i1 + 42964 >> 2];
 HEAP32[i5 + 42968 >> 2] = HEAP32[i1 + 42968 >> 2];
 HEAP32[i5 + 42972 >> 2] = HEAP32[i1 + 42972 >> 2];
 HEAP32[i5 + 42976 >> 2] = HEAP32[i1 + 42976 >> 2];
 HEAP32[i5 + 42980 >> 2] = HEAP32[i1 + 42980 >> 2];
 HEAP32[i5 + 42984 >> 2] = HEAP32[i1 + 42984 >> 2];
 HEAP32[i5 + 42988 >> 2] = HEAP32[i1 + 42988 >> 2];
 HEAP32[i5 + 42992 >> 2] = HEAP32[i1 + 42992 >> 2];
 HEAP32[i5 + 42996 >> 2] = HEAP32[i1 + 42996 >> 2];
 HEAP32[i5 + 43e3 >> 2] = HEAP32[i1 + 43e3 >> 2];
 HEAP32[i5 + 43004 >> 2] = HEAP32[i1 + 43004 >> 2];
 HEAP32[i5 + 43008 >> 2] = HEAP32[i1 + 43008 >> 2];
 HEAP32[i5 + 43012 >> 2] = HEAP32[i1 + 43012 >> 2];
 HEAP32[i5 + 43016 >> 2] = HEAP32[i1 + 43016 >> 2];
 HEAP32[i5 + 43020 >> 2] = HEAP32[i1 + 43020 >> 2];
 HEAP32[i5 + 43024 >> 2] = HEAP32[i1 + 43024 >> 2];
 HEAP32[i5 + 43028 >> 2] = HEAP32[i1 + 43028 >> 2];
 HEAP32[i5 + 43032 >> 2] = HEAP32[i1 + 43032 >> 2];
 HEAP32[i5 + 43036 >> 2] = HEAP32[i1 + 43036 >> 2];
 HEAP32[i5 + 43040 >> 2] = HEAP32[i1 + 43040 >> 2];
 HEAP32[i5 + 43044 >> 2] = HEAP32[i1 + 43044 >> 2];
 HEAP32[i5 + 43048 >> 2] = HEAP32[i1 + 43048 >> 2];
 HEAP32[i5 + 43052 >> 2] = HEAP32[i1 + 43052 >> 2];
 HEAP32[i5 + 43056 >> 2] = HEAP32[i1 + 43056 >> 2];
 HEAP32[i5 + 43060 >> 2] = HEAP32[i1 + 43060 >> 2];
 HEAP32[i5 + 43064 >> 2] = HEAP32[i1 + 43064 >> 2];
 HEAP32[i5 + 43068 >> 2] = HEAP32[i1 + 43068 >> 2];
 _memcpy(i5 + 43072 | 0, i1 + 43072 | 0, 1276) | 0;
 HEAP32[i5 + 44352 >> 2] = HEAP32[i1 + 44352 >> 2];
 HEAP32[i5 + 44356 >> 2] = HEAP32[i1 + 44356 >> 2];
 HEAP32[i5 + 44360 >> 2] = HEAP32[i1 + 44360 >> 2];
 HEAP32[i5 + 44364 >> 2] = HEAP32[i1 + 44364 >> 2];
 HEAP32[i5 + 44368 >> 2] = HEAP32[i1 + 44368 >> 2];
 HEAP32[i5 + 44372 >> 2] = HEAP32[i1 + 44372 >> 2];
 HEAP32[i5 + 44376 >> 2] = HEAP32[i1 + 44376 >> 2];
 HEAP32[i5 + 44380 >> 2] = HEAP32[i1 + 44380 >> 2];
 HEAP32[i5 + 44384 >> 2] = HEAP32[i1 + 44384 >> 2];
 HEAP32[i5 + 44388 >> 2] = HEAP32[i1 + 44388 >> 2];
 HEAP32[i5 + 44392 >> 2] = HEAP32[i1 + 44392 >> 2];
 HEAP32[i5 + 44396 >> 2] = HEAP32[i1 + 44396 >> 2];
 HEAP32[i5 + 44400 >> 2] = HEAP32[i1 + 44400 >> 2];
 HEAP32[i5 + 44404 >> 2] = HEAP32[i1 + 44404 >> 2];
 HEAP32[i5 + 44408 >> 2] = HEAP32[i1 + 44408 >> 2];
 HEAP32[i5 + 44412 >> 2] = HEAP32[i1 + 44412 >> 2];
 HEAP32[i5 + 44416 >> 2] = HEAP32[i1 + 44416 >> 2];
 HEAP32[i5 + 44420 >> 2] = HEAP32[i1 + 44420 >> 2];
 HEAP32[i5 + 44424 >> 2] = HEAP32[i1 + 44424 >> 2];
 HEAP32[i5 + 44428 >> 2] = HEAP32[i1 + 44428 >> 2];
 HEAP32[i5 + 44432 >> 2] = HEAP32[i1 + 44432 >> 2];
 HEAP32[i5 + 44436 >> 2] = HEAP32[i1 + 44436 >> 2];
 HEAP32[i5 + 44440 >> 2] = HEAP32[i1 + 44440 >> 2];
 HEAP32[i5 + 44444 >> 2] = HEAP32[i1 + 44444 >> 2];
 HEAP32[i5 + 44448 >> 2] = HEAP32[i1 + 44448 >> 2];
 HEAP32[i5 + 44452 >> 2] = HEAP32[i1 + 44452 >> 2];
 HEAP32[i5 + 44456 >> 2] = HEAP32[i1 + 44456 >> 2];
 HEAP32[i5 + 44460 >> 2] = HEAP32[i1 + 44460 >> 2];
 HEAP32[i5 + 44464 >> 2] = HEAP32[i1 + 44464 >> 2];
 HEAP32[i5 + 44468 >> 2] = HEAP32[i1 + 44468 >> 2];
 HEAP32[i5 + 44472 >> 2] = HEAP32[i1 + 44472 >> 2];
 HEAP32[i5 + 44476 >> 2] = HEAP32[i1 + 44476 >> 2];
 _memcpy(i5 + 44480 | 0, i1 + 44480 | 0, 1276) | 0;
 HEAP32[i5 + 45760 >> 2] = HEAP32[i1 + 45760 >> 2];
 return i6 | 0;
}

function __ZL28PxcBruteForceOverlapBackfaceRKN5physx9PxBounds3ES2_RKNS_2Gu13PolygonalDataES6_RKNS_2Cm8Matrix34ESA_RKNS7_23FastVertex2ShapeScalingESD_SA_SA_RKNS_6PxVec3ERjSH_RfRSE_RNS3_14PxcSepAxisTypeEf(i17, i18, i58, i59, i63, i64, i60, i61, i21, i22, i51, i19, i20, i65, i66, i49, f50) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i60 = i60 | 0;
 i61 = i61 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i51 = i51 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 i49 = i49 | 0;
 f50 = Math_fround(f50);
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i62 = 0, i67 = 0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 6320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i68 + 6312 | 0;
 i55 = i68 + 6308 | 0;
 i56 = i68 + 6304 | 0;
 i54 = i68 + 6300 | 0;
 i23 = i68 + 3220 | 0;
 i3 = i68 + 3216 | 0;
 i4 = i68 + 128 | 0;
 i1 = i68 + 116 | 0;
 i24 = i68 + 112 | 0;
 i11 = i68 + 108 | 0;
 i13 = i68 + 96 | 0;
 i52 = i68 + 3224 | 0;
 i53 = i68 + 140 | 0;
 i25 = i68 + 80 | 0;
 i26 = i68 + 64 | 0;
 i15 = i68 + 40 | 0;
 i16 = i68 + 16 | 0;
 i62 = i68;
 f5 = Math_fround(HEAPF32[i63 >> 2]);
 f6 = Math_fround(HEAPF32[i51 >> 2]);
 f5 = Math_fround(f5 * f6);
 i47 = i63 + 4 | 0;
 f7 = Math_fround(HEAPF32[i47 >> 2]);
 i48 = i51 + 4 | 0;
 f9 = Math_fround(HEAPF32[i48 >> 2]);
 f7 = Math_fround(f5 + Math_fround(f7 * f9));
 i39 = i63 + 8 | 0;
 f5 = Math_fround(HEAPF32[i39 >> 2]);
 i40 = i51 + 8 | 0;
 f2 = Math_fround(HEAPF32[i40 >> 2]);
 f5 = Math_fround(f7 + Math_fround(f5 * f2));
 i41 = i63 + 12 | 0;
 f7 = Math_fround(f6 * Math_fround(HEAPF32[i41 >> 2]));
 i42 = i63 + 16 | 0;
 f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i42 >> 2])));
 i43 = i63 + 20 | 0;
 f7 = Math_fround(f7 + Math_fround(f2 * Math_fround(HEAPF32[i43 >> 2])));
 i44 = i63 + 24 | 0;
 f8 = Math_fround(f6 * Math_fround(HEAPF32[i44 >> 2]));
 i45 = i63 + 28 | 0;
 f8 = Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[i45 >> 2])));
 i46 = i63 + 32 | 0;
 f8 = Math_fround(f8 + Math_fround(f2 * Math_fround(HEAPF32[i46 >> 2])));
 i14 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (HEAP32[i58 + 16 >> 2] << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
 f9 = Math_fround(-f9);
 f12 = Math_fround(-f2);
 HEAPF32[i1 >> 2] = Math_fround(-f6);
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f12;
 if (!(__ZL27PxcTestFacesSepAxesBackfaceRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ERfRSB_RjPjSG_fSD_(i58, i59, i63, i64, i60, i61, i22, f5, f7, f8, i3, i4, i19, i14, i23, f50, i1) | 0)) {
  i67 = 0;
  STACKTOP = i68;
  return i67 | 0;
 }
 f2 = Math_fround(HEAPF32[i64 >> 2]);
 f9 = Math_fround(HEAPF32[i51 >> 2]);
 f2 = Math_fround(f2 * f9);
 i31 = i64 + 4 | 0;
 f5 = Math_fround(HEAPF32[i31 >> 2]);
 f12 = Math_fround(HEAPF32[i48 >> 2]);
 f5 = Math_fround(f2 + Math_fround(f5 * f12));
 i32 = i64 + 8 | 0;
 f2 = Math_fround(HEAPF32[i32 >> 2]);
 f6 = Math_fround(HEAPF32[i40 >> 2]);
 f2 = Math_fround(f5 + Math_fround(f2 * f6));
 i33 = i64 + 12 | 0;
 f5 = Math_fround(f9 * Math_fround(HEAPF32[i33 >> 2]));
 i34 = i64 + 16 | 0;
 f5 = Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[i34 >> 2])));
 i35 = i64 + 20 | 0;
 f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i35 >> 2])));
 i36 = i64 + 24 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i36 >> 2]));
 i37 = i64 + 28 | 0;
 f12 = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i37 >> 2])));
 i38 = i64 + 32 | 0;
 f6 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i38 >> 2])));
 i10 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (HEAP32[i59 + 16 >> 2] << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAPF32[i11 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (!(__ZL27PxcTestFacesSepAxesBackfaceRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ERfRSB_RjPjSG_fSD_(i59, i58, i64, i63, i61, i60, i21, Math_fround(-f2), Math_fround(-f5), Math_fround(-f6), i11, i13, i20, i10, i24, f50, i51) | 0)) {
  i67 = 0;
  STACKTOP = i68;
  return i67 | 0;
 }
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i49 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 if (f5 < f2) {
  i11 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
  i4 = HEAP32[i13 + 8 >> 2] | 0;
  HEAP32[i49 >> 2] = 1;
  f2 = f5;
 } else i11 = i1;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i53 >> 2] = 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i29 = i58 + 24 | 0;
 i1 = HEAP32[i29 >> 2] | 0;
 i28 = HEAP32[i20 >> 2] | 0;
 i30 = i59 + 24 | 0;
 i13 = HEAP32[i30 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 + (i19 * 20 | 0) + 12 >> 2]);
 i27 = i25 + 12 | 0;
 f7 = Math_fround(HEAPF32[i60 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + (i19 * 20 | 0) >> 2]);
 f7 = Math_fround(f7 * f5);
 f70 = Math_fround(HEAPF32[i60 + 40 >> 2]);
 f69 = Math_fround(HEAPF32[i1 + (i19 * 20 | 0) + 4 >> 2]);
 f70 = Math_fround(f7 + Math_fround(f70 * f69));
 f7 = Math_fround(HEAPF32[i60 + 44 >> 2]);
 f72 = Math_fround(HEAPF32[i1 + (i19 * 20 | 0) + 8 >> 2]);
 f7 = Math_fround(f70 + Math_fround(f7 * f72));
 f70 = Math_fround(f5 * Math_fround(HEAPF32[i60 + 48 >> 2]));
 f70 = Math_fround(f70 + Math_fround(f69 * Math_fround(HEAPF32[i60 + 52 >> 2])));
 f70 = Math_fround(f70 + Math_fround(f72 * Math_fround(HEAPF32[i60 + 56 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i60 + 60 >> 2]));
 f69 = Math_fround(f5 + Math_fround(f69 * Math_fround(HEAPF32[i60 + 64 >> 2])));
 f72 = Math_fround(f69 + Math_fround(f72 * Math_fround(HEAPF32[i60 + 68 >> 2])));
 f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f70 * f70)) + Math_fround(f72 * f72)))));
 f7 = Math_fround(f7 * f69);
 f70 = Math_fround(f70 * f69);
 f72 = Math_fround(f72 * f69);
 HEAPF32[i25 >> 2] = f7;
 i19 = i25 + 4 | 0;
 HEAPF32[i19 >> 2] = f70;
 i20 = i25 + 8 | 0;
 HEAPF32[i20 >> 2] = f72;
 f69 = Math_fround(f12 * f69);
 HEAPF32[i27 >> 2] = f69;
 f12 = Math_fround(HEAPF32[i13 + (i28 * 20 | 0) + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i61 + 36 >> 2]);
 f71 = Math_fround(HEAPF32[i13 + (i28 * 20 | 0) >> 2]);
 f5 = Math_fround(f5 * f71);
 f74 = Math_fround(HEAPF32[i61 + 40 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + (i28 * 20 | 0) + 4 >> 2]);
 f74 = Math_fround(f5 + Math_fround(f74 * f6));
 f5 = Math_fround(HEAPF32[i61 + 44 >> 2]);
 f73 = Math_fround(HEAPF32[i13 + (i28 * 20 | 0) + 8 >> 2]);
 f5 = Math_fround(f74 + Math_fround(f5 * f73));
 f74 = Math_fround(f71 * Math_fround(HEAPF32[i61 + 48 >> 2]));
 f74 = Math_fround(f74 + Math_fround(f6 * Math_fround(HEAPF32[i61 + 52 >> 2])));
 f74 = Math_fround(f74 + Math_fround(f73 * Math_fround(HEAPF32[i61 + 56 >> 2])));
 f71 = Math_fround(f71 * Math_fround(HEAPF32[i61 + 60 >> 2]));
 f6 = Math_fround(f71 + Math_fround(f6 * Math_fround(HEAPF32[i61 + 64 >> 2])));
 f73 = Math_fround(f6 + Math_fround(f73 * Math_fround(HEAPF32[i61 + 68 >> 2])));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f74 * f74)) + Math_fround(f73 * f73)))));
 f5 = Math_fround(f5 * f6);
 f74 = Math_fround(f74 * f6);
 f73 = Math_fround(f73 * f6);
 HEAPF32[i26 >> 2] = f5;
 i28 = i26 + 4 | 0;
 HEAPF32[i28 >> 2] = f74;
 f6 = Math_fround(f12 * f6);
 f12 = Math_fround(f7 * Math_fround(HEAPF32[i21 >> 2]));
 f71 = Math_fround(f7 * Math_fround(HEAPF32[i21 + 4 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i21 + 8 >> 2]));
 f9 = Math_fround(f70 * Math_fround(HEAPF32[i21 + 12 >> 2]));
 f8 = Math_fround(f70 * Math_fround(HEAPF32[i21 + 16 >> 2]));
 f9 = Math_fround(f12 + f9);
 f8 = Math_fround(f71 + f8);
 f70 = Math_fround(f7 + Math_fround(f70 * Math_fround(HEAPF32[i21 + 20 >> 2])));
 f7 = Math_fround(f72 * Math_fround(HEAPF32[i21 + 24 >> 2]));
 f71 = Math_fround(f72 * Math_fround(HEAPF32[i21 + 28 >> 2]));
 f7 = Math_fround(f9 + f7);
 f71 = Math_fround(f8 + f71);
 f72 = Math_fround(f70 + Math_fround(f72 * Math_fround(HEAPF32[i21 + 32 >> 2])));
 f70 = Math_fround(f7 * Math_fround(HEAPF32[i21 + 36 >> 2]));
 f70 = Math_fround(f70 + Math_fround(f71 * Math_fround(HEAPF32[i21 + 40 >> 2])));
 f70 = Math_fround(f69 - Math_fround(f70 + Math_fround(f72 * Math_fround(HEAPF32[i21 + 44 >> 2]))));
 HEAPF32[i25 >> 2] = f7;
 HEAPF32[i19 >> 2] = f71;
 HEAPF32[i20 >> 2] = f72;
 HEAPF32[i27 >> 2] = f70;
 f70 = Math_fround(f5 * Math_fround(HEAPF32[i22 >> 2]));
 f72 = Math_fround(f5 * Math_fround(HEAPF32[i22 + 4 >> 2]));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i22 + 8 >> 2]));
 f71 = Math_fround(f74 * Math_fround(HEAPF32[i22 + 12 >> 2]));
 f7 = Math_fround(f74 * Math_fround(HEAPF32[i22 + 16 >> 2]));
 f71 = Math_fround(f70 + f71);
 f7 = Math_fround(f72 + f7);
 f74 = Math_fround(f5 + Math_fround(f74 * Math_fround(HEAPF32[i22 + 20 >> 2])));
 f5 = Math_fround(f73 * Math_fround(HEAPF32[i22 + 24 >> 2]));
 f72 = Math_fround(f73 * Math_fround(HEAPF32[i22 + 28 >> 2]));
 f5 = Math_fround(f71 + f5);
 f72 = Math_fround(f7 + f72);
 f73 = Math_fround(f74 + Math_fround(f73 * Math_fround(HEAPF32[i22 + 32 >> 2])));
 f74 = Math_fround(f5 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f74 = Math_fround(f74 + Math_fround(f72 * Math_fround(HEAPF32[i22 + 40 >> 2])));
 f74 = Math_fround(f6 - Math_fround(f74 + Math_fround(f73 * Math_fround(HEAPF32[i22 + 44 >> 2]))));
 HEAPF32[i26 >> 2] = f5;
 HEAPF32[i28 >> 2] = f72;
 HEAPF32[i26 + 8 >> 2] = f73;
 HEAPF32[i26 + 12 >> 2] = f74;
 f74 = Math_fround(HEAPF32[i17 >> 2]);
 f73 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f72 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f71 = Math_fround(HEAPF32[i18 >> 2]);
 f70 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f69 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i18 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i18 + 20 >> 2]);
 HEAPF32[i15 >> 2] = Math_fround(f74 - f50);
 HEAPF32[i15 + 4 >> 2] = Math_fround(f73 - f50);
 HEAPF32[i15 + 8 >> 2] = Math_fround(f72 - f50);
 HEAPF32[i16 >> 2] = Math_fround(f71 - f50);
 HEAPF32[i16 + 4 >> 2] = Math_fround(f70 - f50);
 HEAPF32[i16 + 8 >> 2] = Math_fround(f69 - f50);
 HEAPF32[i15 + 12 >> 2] = Math_fround(f5 + f50);
 HEAPF32[i15 + 16 >> 2] = Math_fround(f6 + f50);
 HEAPF32[i15 + 20 >> 2] = Math_fround(f7 + f50);
 HEAPF32[i16 + 12 >> 2] = Math_fround(f8 + f50);
 HEAPF32[i16 + 16 >> 2] = Math_fround(f9 + f50);
 HEAPF32[i16 + 20 >> 2] = Math_fround(f12 + f50);
 __ZL21PxcFindSeparatingAxesRN5physx2Gu14SeparatingAxesEPKjjRKNS0_13PolygonalDataERKNS_2Cm8Matrix34ERKNS_7PxPlaneESB_RKNS_9PxBounds3EfRKNS8_23FastVertex2ShapeScalingE(i52, i14, HEAP32[i23 >> 2] | 0, HEAP32[i29 >> 2] | 0, HEAP32[i58 + 28 >> 2] | 0, HEAP32[i58 + 32 >> 2] | 0, i63, i26, i21, i16, f50, i60);
 __ZL21PxcFindSeparatingAxesRN5physx2Gu14SeparatingAxesEPKjjRKNS0_13PolygonalDataERKNS_2Cm8Matrix34ERKNS_7PxPlaneESB_RKNS_9PxBounds3EfRKNS8_23FastVertex2ShapeScalingE(i53, i10, HEAP32[i24 >> 2] | 0, HEAP32[i30 >> 2] | 0, HEAP32[i59 + 28 >> 2] | 0, HEAP32[i59 + 32 >> 2] | 0, i64, i25, i22, i15, f50, i61);
 i30 = HEAP32[i52 >> 2] | 0;
 i17 = HEAP32[i53 >> 2] | 0;
 L10 : do if (!i30) {
  i1 = i11;
  i67 = 23;
 } else {
  i18 = i62 + 4 | 0;
  i19 = i62 + 8 | 0;
  i20 = i58 + 44 | 0;
  i21 = i58 + 48 | 0;
  i22 = i58 + 52 | 0;
  i23 = i59 + 44 | 0;
  i24 = i59 + 48 | 0;
  i25 = i59 + 52 | 0;
  i26 = i58 + 40 | 0;
  i27 = i59 + 40 | 0;
  i28 = i58 + 64 | 0;
  i29 = i59 + 64 | 0;
  if (!i17) {
   i1 = 0;
   while (1) {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i30 >>> 0) {
     i1 = i11;
     i67 = 23;
     break L10;
    }
   }
  } else {
   f5 = Math_fround(0.0);
   i1 = i11;
   i10 = 0;
  }
  while (1) {
   i14 = i52 + 4 + (i10 * 12 | 0) + 4 | 0;
   i15 = i52 + 4 + (i10 * 12 | 0) + 8 | 0;
   i16 = i52 + 4 + (i10 * 12 | 0) | 0;
   i13 = 0;
   while (1) {
    f74 = Math_fround(HEAPF32[i14 >> 2]);
    f9 = Math_fround(HEAPF32[i53 + 4 + (i13 * 12 | 0) + 8 >> 2]);
    f12 = Math_fround(f74 * f9);
    f71 = Math_fround(HEAPF32[i15 >> 2]);
    f72 = Math_fround(HEAPF32[i53 + 4 + (i13 * 12 | 0) + 4 >> 2]);
    f12 = Math_fround(f12 - Math_fround(f71 * f72));
    f6 = Math_fround(HEAPF32[i53 + 4 + (i13 * 12 | 0) >> 2]);
    f71 = Math_fround(f71 * f6);
    f73 = Math_fround(HEAPF32[i16 >> 2]);
    f9 = Math_fround(f71 - Math_fround(f9 * f73));
    f6 = Math_fround(Math_fround(f72 * f73) - Math_fround(f74 * f6));
    HEAPF32[i62 >> 2] = f12;
    HEAPF32[i18 >> 2] = f9;
    HEAPF32[i19 >> 2] = f6;
    if (+Math_fround(Math_abs(Math_fround(f12))) > 1.0e-06) i67 = 11; else if (+Math_fround(Math_abs(Math_fround(f9))) > 1.0e-06) i67 = 11; else if (+Math_fround(Math_abs(Math_fround(f6))) > 1.0e-06) i67 = 11; else f6 = f5;
    if ((i67 | 0) == 11) {
     i67 = 0;
     f7 = Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f9 * f9)) + Math_fround(f6 * f6));
     if (f7 > Math_fround(0.0)) {
      f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
      f8 = Math_fround(f6 * f74);
      f7 = Math_fround(f9 * f74);
      f6 = Math_fround(f12 * f74);
     } else {
      f8 = Math_fround(0.0);
      f7 = Math_fround(0.0);
      f6 = Math_fround(0.0);
     }
     HEAPF32[i62 >> 2] = f6;
     HEAPF32[i18 >> 2] = f7;
     HEAPF32[i19 >> 2] = f8;
     f9 = Math_fround(HEAPF32[i51 >> 2]);
     f80 = Math_fround(HEAPF32[i48 >> 2]);
     f74 = Math_fround(HEAPF32[i40 >> 2]);
     f12 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) * f6);
     f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f7));
     f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i39 >> 2]) * f8));
     f69 = Math_fround(f6 * Math_fround(HEAPF32[i41 >> 2]));
     f69 = Math_fround(f69 + Math_fround(f7 * Math_fround(HEAPF32[i42 >> 2])));
     f69 = Math_fround(f69 + Math_fround(f8 * Math_fround(HEAPF32[i43 >> 2])));
     f70 = Math_fround(f6 * Math_fround(HEAPF32[i44 >> 2]));
     f70 = Math_fround(f70 + Math_fround(f7 * Math_fround(HEAPF32[i45 >> 2])));
     f70 = Math_fround(f70 + Math_fround(f8 * Math_fround(HEAPF32[i46 >> 2])));
     i79 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
     i78 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
     i77 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     f72 = Math_fround(f6 * Math_fround(HEAPF32[i64 >> 2]));
     f72 = Math_fround(f72 + Math_fround(f7 * Math_fround(HEAPF32[i31 >> 2])));
     f72 = Math_fround(f72 + Math_fround(f8 * Math_fround(HEAPF32[i32 >> 2])));
     f71 = Math_fround(f6 * Math_fround(HEAPF32[i33 >> 2]));
     f71 = Math_fround(f71 + Math_fround(f7 * Math_fround(HEAPF32[i34 >> 2])));
     f71 = Math_fround(f71 + Math_fround(f8 * Math_fround(HEAPF32[i35 >> 2])));
     f73 = Math_fround(f6 * Math_fround(HEAPF32[i36 >> 2]));
     f73 = Math_fround(f73 + Math_fround(f7 * Math_fround(HEAPF32[i37 >> 2])));
     f73 = Math_fround(f73 + Math_fround(f8 * Math_fround(HEAPF32[i38 >> 2])));
     i76 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
     i75 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
     f74 = Math_fround(Math_fround(Math_fround(-Math_fround(f80 * f7)) - Math_fround(f9 * f6)) - Math_fround(f74 * f8));
     i11 = HEAP32[i25 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
     f12 = Math_fround(f12 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i20 >> 2] | i79 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f69 = Math_fround(f12 + Math_fround(f69 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 >> 2] | i78 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
     f70 = Math_fround(f69 + Math_fround(f70 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i22 >> 2] | i77 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
     f72 = Math_fround(f72 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i23 >> 2] | i76 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f71 = Math_fround(f72 + Math_fround(f71 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i24 >> 2] | i75 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
     f73 = Math_fround(f71 + Math_fround(f73 * (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
     f71 = Math_fround(HEAPF32[i26 >> 2]);
     f72 = Math_fround(HEAPF32[i27 >> 2]);
     f72 = Math_fround((f70 > f71 ? f70 : f71) + (f73 > f72 ? f73 : f72));
     f73 = Math_fround(f74 + f72);
     f74 = Math_fround(f72 - f74);
     if (!((f73 < f74 ? f73 : f74) > f2)) {
      mftCall_viiiiii(HEAP32[i28 >> 2] | 0, i58 | 0, i62 | 0, i63 | 0, i60 | 0, i56 | 0, i54 | 0);
      f6 = Math_fround(HEAPF32[i56 >> 2]);
      f7 = Math_fround(HEAPF32[i54 >> 2]);
      mftCall_viiiiii(HEAP32[i29 >> 2] | 0, i59 | 0, i62 | 0, i64 | 0, i61 | 0, i57 | 0, i55 | 0);
      f80 = Math_fround(f7 + f50);
      f8 = Math_fround(HEAPF32[i57 >> 2]);
      if (f80 < f8) i11 = 0; else {
       f9 = Math_fround(HEAPF32[i55 >> 2]);
       if (Math_fround(f9 + f50) < f6) i11 = 0; else {
        f80 = Math_fround(f7 - f8);
        f5 = Math_fround(f9 - f6);
        i11 = 1;
        f5 = f80 < f5 ? f80 : f5;
       }
      }
      if (!i11) {
       i1 = 0;
       break L10;
      }
      if (f5 < f2) {
       i1 = HEAP32[i62 >> 2] | 0;
       i3 = HEAP32[i18 >> 2] | 0;
       i4 = HEAP32[i19 >> 2] | 0;
       HEAP32[i49 >> 2] = 2;
       f6 = f5;
       f2 = f5;
      } else f6 = f5;
     } else f6 = f5;
    }
    i13 = i13 + 1 | 0;
    if (i13 >>> 0 >= i17 >>> 0) {
     f5 = f6;
     break;
    } else f5 = f6;
   }
   i10 = i10 + 1 | 0;
   if (i10 >>> 0 >= i30 >>> 0) {
    i67 = 23;
    break;
   }
  }
 } while (0);
 if ((i67 | 0) == 23) {
  HEAPF32[i65 >> 2] = f2;
  HEAP32[i66 >> 2] = i1;
  HEAP32[i66 + 4 >> 2] = i3;
  HEAP32[i66 + 8 >> 2] = i4;
  i1 = 1;
 }
 i79 = i1;
 STACKTOP = i68;
 return i79 | 0;
}

function __ZN10SpookyHash7Hash128EPKvjPyS2_(i30, i31, i32, i34) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i36;
 if (i31 >>> 0 < 192) {
  __ZN10SpookyHash5ShortEPKvjPyS2_(i30, i31, i32, i34);
  STACKTOP = i36;
  return;
 }
 i26 = i32;
 i25 = HEAP32[i26 >> 2] | 0;
 i26 = HEAP32[i26 + 4 >> 2] | 0;
 i28 = i34;
 i27 = HEAP32[i28 >> 2] | 0;
 i28 = HEAP32[i28 + 4 >> 2] | 0;
 i33 = i30 + (((i31 >>> 0) / 96 | 0) * 12 << 3) | 0;
 if (i30 >>> 0 < i33 >>> 0) {
  i21 = -559038737;
  i24 = -559038737;
  i23 = i25;
  i20 = i26;
  i19 = i27;
  i16 = i28;
  i15 = -559038737;
  i12 = -559038737;
  i10 = i25;
  i8 = i26;
  i29 = i30;
  i14 = i25;
  i17 = i26;
  i6 = i27;
  i22 = -559038737;
  i4 = i28;
  i18 = -559038737;
  i2 = -559038737;
  i1 = -559038737;
  i13 = i27;
  i11 = i28;
  i9 = i25;
  i7 = i26;
  i5 = i27;
  i3 = i28;
  do {
   i25 = i29;
   i25 = _i64Add(HEAP32[i25 >> 2] | 0, HEAP32[i25 + 4 >> 2] | 0, i14 | 0, i17 | 0) | 0;
   i37 = getTempRet0() | 0;
   i27 = i6 ^ i22;
   i28 = i4 ^ i18;
   i17 = _bitshift64Shl(i25 | 0, i37 | 0, 11) | 0;
   i14 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i25 | 0, i37 | 0, 53) | 0;
   i14 = getTempRet0() | 0 | i14;
   i2 = _i64Add(i25 ^ i2 | 0, i37 ^ i1 | 0, i13 | 0, i11 | 0) | 0;
   i1 = getTempRet0() | 0;
   i37 = i29 + 8 | 0;
   i11 = _i64Add(HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0, i13 | 0, i11 | 0) | 0;
   i37 = getTempRet0() | 0;
   i25 = i2 ^ i9;
   i22 = i1 ^ i7;
   i14 = _i64Add((i18 | i17) ^ i11 | 0, i14 ^ i37 | 0, i27 | 0, i28 | 0) | 0;
   i17 = getTempRet0() | 0;
   i13 = i29 + 16 | 0;
   i28 = _i64Add(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, i27 | 0, i28 | 0) | 0;
   i13 = getTempRet0() | 0;
   i27 = i14 ^ i5;
   i9 = i17 ^ i3;
   i3 = _bitshift64Shl(i28 | 0, i13 | 0, 43) | 0;
   i18 = getTempRet0() | 0;
   i26 = _bitshift64Lshr(i28 | 0, i13 | 0, 21) | 0;
   i18 = getTempRet0() | 0 | i18;
   i13 = _i64Add(i37 ^ i28 | 0, i11 ^ i13 | 0, i25 | 0, i22 | 0) | 0;
   i11 = getTempRet0() | 0;
   i28 = i29 + 24 | 0;
   i28 = _i64Add(i25 | 0, i22 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i22 = getTempRet0() | 0;
   i25 = i13 ^ i21;
   i5 = i11 ^ i24;
   i24 = _bitshift64Shl(i28 | 0, i22 | 0, 31) | 0;
   i7 = getTempRet0() | 0;
   i37 = _bitshift64Lshr(i28 | 0, i22 | 0, 33) | 0;
   i7 = getTempRet0() | 0 | i7;
   i22 = _i64Add((i26 | i3) ^ i28 | 0, i18 ^ i22 | 0, i27 | 0, i9 | 0) | 0;
   i18 = getTempRet0() | 0;
   i28 = i29 + 32 | 0;
   i28 = _i64Add(i27 | 0, i9 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i9 = getTempRet0() | 0;
   i27 = i22 ^ i23;
   i21 = i18 ^ i20;
   i20 = _bitshift64Shl(i28 | 0, i9 | 0, 17) | 0;
   i3 = getTempRet0() | 0;
   i26 = _bitshift64Lshr(i28 | 0, i9 | 0, 47) | 0;
   i3 = getTempRet0() | 0 | i3;
   i9 = _i64Add((i37 | i24) ^ i28 | 0, i7 ^ i9 | 0, i25 | 0, i5 | 0) | 0;
   i7 = getTempRet0() | 0;
   i28 = i29 + 40 | 0;
   i28 = _i64Add(i25 | 0, i5 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i5 = getTempRet0() | 0;
   i25 = i9 ^ i19;
   i23 = i7 ^ i16;
   i16 = _bitshift64Shl(i28 | 0, i5 | 0, 28) | 0;
   i24 = getTempRet0() | 0;
   i37 = _bitshift64Lshr(i28 | 0, i5 | 0, 36) | 0;
   i24 = getTempRet0() | 0 | i24;
   i5 = _i64Add((i26 | i20) ^ i28 | 0, i3 ^ i5 | 0, i27 | 0, i21 | 0) | 0;
   i3 = getTempRet0() | 0;
   i28 = i29 + 48 | 0;
   i28 = _i64Add(i27 | 0, i21 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i21 = getTempRet0() | 0;
   i27 = i5 ^ i15;
   i19 = i3 ^ i12;
   i12 = _bitshift64Shl(i28 | 0, i21 | 0, 39) | 0;
   i20 = getTempRet0() | 0;
   i26 = _bitshift64Lshr(i28 | 0, i21 | 0, 25) | 0;
   i20 = getTempRet0() | 0 | i20;
   i21 = _i64Add((i37 | i16) ^ i28 | 0, i24 ^ i21 | 0, i25 | 0, i23 | 0) | 0;
   i24 = getTempRet0() | 0;
   i28 = i29 + 56 | 0;
   i28 = _i64Add(i25 | 0, i23 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i23 = getTempRet0() | 0;
   i25 = i21 ^ i10;
   i15 = i24 ^ i8;
   i8 = _bitshift64Shl(i28 | 0, i23 | 0, 57) | 0;
   i16 = getTempRet0() | 0;
   i37 = _bitshift64Lshr(i28 | 0, i23 | 0, 7) | 0;
   i16 = getTempRet0() | 0 | i16;
   i23 = _i64Add((i26 | i12) ^ i28 | 0, i20 ^ i23 | 0, i27 | 0, i19 | 0) | 0;
   i20 = getTempRet0() | 0;
   i28 = i29 + 64 | 0;
   i28 = _i64Add(i27 | 0, i19 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i19 = getTempRet0() | 0;
   i27 = i23 ^ i6;
   i10 = i20 ^ i4;
   i4 = _bitshift64Shl(i28 | 0, i19 | 0, 55) | 0;
   i12 = getTempRet0() | 0;
   i26 = _bitshift64Lshr(i28 | 0, i19 | 0, 9) | 0;
   i12 = getTempRet0() | 0 | i12;
   i19 = _i64Add((i37 | i8) ^ i28 | 0, i16 ^ i19 | 0, i25 | 0, i15 | 0) | 0;
   i16 = getTempRet0() | 0;
   i28 = i29 + 72 | 0;
   i28 = _i64Add(i25 | 0, i15 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i15 = getTempRet0() | 0;
   i2 = i19 ^ i2;
   i6 = i16 ^ i1;
   i1 = _bitshift64Shl(i28 | 0, i15 | 0, 54) | 0;
   i8 = getTempRet0() | 0;
   i25 = _bitshift64Lshr(i28 | 0, i15 | 0, 10) | 0;
   i8 = getTempRet0() | 0 | i8;
   i15 = _i64Add((i26 | i4) ^ i28 | 0, i12 ^ i15 | 0, i27 | 0, i10 | 0) | 0;
   i12 = getTempRet0() | 0;
   i28 = i29 + 80 | 0;
   i28 = _i64Add(i27 | 0, i10 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i10 = getTempRet0() | 0;
   i14 = i15 ^ i14;
   i17 = i12 ^ i17;
   i27 = _bitshift64Shl(i28 | 0, i10 | 0, 22) | 0;
   i4 = getTempRet0() | 0;
   i26 = _bitshift64Lshr(i28 | 0, i10 | 0, 42) | 0;
   i4 = getTempRet0() | 0 | i4;
   i10 = _i64Add((i25 | i1) ^ i28 | 0, i8 ^ i10 | 0, i2 | 0, i6 | 0) | 0;
   i8 = getTempRet0() | 0;
   i28 = i29 + 88 | 0;
   i28 = _i64Add(i2 | 0, i6 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i28 + 4 >> 2] | 0) | 0;
   i6 = getTempRet0() | 0;
   i13 = i10 ^ i13;
   i11 = i8 ^ i11;
   i2 = _bitshift64Shl(i28 | 0, i6 | 0, 46) | 0;
   i1 = getTempRet0() | 0;
   i25 = _bitshift64Lshr(i28 | 0, i6 | 0, 18) | 0;
   i2 = i25 | i2;
   i1 = getTempRet0() | 0 | i1;
   i6 = _i64Add((i26 | i27) ^ i28 | 0, i4 ^ i6 | 0, i14 | 0, i17 | 0) | 0;
   i4 = getTempRet0() | 0;
   i29 = i29 + 96 | 0;
  } while (i29 >>> 0 < i33 >>> 0);
 } else {
  i14 = i25;
  i17 = i26;
  i13 = i27;
  i11 = i28;
  i22 = -559038737;
  i18 = -559038737;
  i9 = i25;
  i7 = i26;
  i5 = i27;
  i3 = i28;
  i21 = -559038737;
  i24 = -559038737;
  i23 = i25;
  i20 = i26;
  i19 = i27;
  i16 = i28;
  i15 = -559038737;
  i12 = -559038737;
  i10 = i25;
  i8 = i26;
  i6 = i27;
  i4 = i28;
  i2 = -559038737;
  i1 = -559038737;
 }
 i39 = i30 - i33 + i31 | 0;
 _memcpy(i35 | 0, i33 | 0, i39 | 0) | 0;
 _memset(i35 + i39 | 0, 0, 96 - i39 | 0) | 0;
 HEAP8[i35 + 95 >> 0] = i39;
 i39 = i35;
 i39 = _i64Add(HEAP32[i39 >> 2] | 0, HEAP32[i39 + 4 >> 2] | 0, i14 | 0, i17 | 0) | 0;
 i29 = getTempRet0() | 0;
 i41 = i35 + 8 | 0;
 i41 = _i64Add(HEAP32[i41 >> 2] | 0, HEAP32[i41 + 4 >> 2] | 0, i13 | 0, i11 | 0) | 0;
 i40 = getTempRet0() | 0;
 i26 = i35 + 16 | 0;
 i26 = _i64Add(HEAP32[i26 >> 2] | 0, HEAP32[i26 + 4 >> 2] | 0, i22 | 0, i18 | 0) | 0;
 i11 = getTempRet0() | 0;
 i38 = i35 + 24 | 0;
 i38 = _i64Add(HEAP32[i38 >> 2] | 0, HEAP32[i38 + 4 >> 2] | 0, i9 | 0, i7 | 0) | 0;
 i13 = getTempRet0() | 0;
 i7 = i35 + 32 | 0;
 i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, i5 | 0, i3 | 0) | 0;
 i31 = getTempRet0() | 0;
 i17 = i35 + 40 | 0;
 i17 = _i64Add(HEAP32[i17 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i21 | 0, i24 | 0) | 0;
 i25 = getTempRet0() | 0;
 i18 = i35 + 48 | 0;
 i18 = _i64Add(HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, i23 | 0, i20 | 0) | 0;
 i14 = getTempRet0() | 0;
 i20 = i35 + 56 | 0;
 i20 = _i64Add(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, i19 | 0, i16 | 0) | 0;
 i24 = getTempRet0() | 0;
 i21 = i35 + 64 | 0;
 i21 = _i64Add(HEAP32[i21 >> 2] | 0, HEAP32[i21 + 4 >> 2] | 0, i15 | 0, i12 | 0) | 0;
 i28 = getTempRet0() | 0;
 i23 = i35 + 72 | 0;
 i23 = _i64Add(HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0, i10 | 0, i8 | 0) | 0;
 i30 = getTempRet0() | 0;
 i37 = i35 + 80 | 0;
 i37 = _i64Add(HEAP32[i37 >> 2] | 0, HEAP32[i37 + 4 >> 2] | 0, i6 | 0, i4 | 0) | 0;
 i22 = getTempRet0() | 0;
 i33 = i35 + 88 | 0;
 i27 = HEAP32[i33 >> 2] | 0;
 i33 = HEAP32[i33 + 4 >> 2] | 0;
 i15 = _i64Add(i41 | 0, i40 | 0, i2 | 0, i1 | 0) | 0;
 i33 = _i64Add(i15 | 0, getTempRet0() | 0, i27 | 0, i33 | 0) | 0;
 i27 = getTempRet0() | 0;
 i15 = i33 ^ i26;
 i16 = i27 ^ i11;
 i11 = _bitshift64Shl(i41 | 0, i40 | 0, 44) | 0;
 i26 = getTempRet0() | 0;
 i19 = _bitshift64Lshr(i41 | 0, i40 | 0, 20) | 0;
 i26 = getTempRet0() | 0 | i26;
 i29 = _i64Add(i39 | 0, i29 | 0, i15 | 0, i16 | 0) | 0;
 i9 = getTempRet0() | 0;
 i12 = i29 ^ i38;
 i35 = i9 ^ i13;
 i13 = _bitshift64Shl(i15 | 0, i16 | 0, 15) | 0;
 i8 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i15 | 0, i16 | 0, 49) | 0;
 i8 = getTempRet0() | 0 | i8;
 i26 = _i64Add(i12 | 0, i35 | 0, i19 | i11 | 0, i26 | 0) | 0;
 i11 = getTempRet0() | 0;
 i19 = i26 ^ i7;
 i31 = i11 ^ i31;
 i15 = _bitshift64Shl(i12 | 0, i35 | 0, 34) | 0;
 i10 = getTempRet0() | 0;
 i35 = _bitshift64Lshr(i12 | 0, i35 | 0, 30) | 0;
 i10 = getTempRet0() | 0 | i10;
 i8 = _i64Add(i19 | 0, i31 | 0, i16 | i13 | 0, i8 | 0) | 0;
 i13 = getTempRet0() | 0;
 i16 = i8 ^ i17;
 i25 = i13 ^ i25;
 i17 = _bitshift64Shl(i19 | 0, i31 | 0, 21) | 0;
 i12 = getTempRet0() | 0;
 i31 = _bitshift64Lshr(i19 | 0, i31 | 0, 43) | 0;
 i12 = getTempRet0() | 0 | i12;
 i10 = _i64Add(i16 | 0, i25 | 0, i35 | i15 | 0, i10 | 0) | 0;
 i15 = getTempRet0() | 0;
 i18 = i10 ^ i18;
 i35 = i15 ^ i14;
 i19 = _bitshift64Shl(i16 | 0, i25 | 0, 38) | 0;
 i14 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i16 | 0, i25 | 0, 26) | 0;
 i14 = getTempRet0() | 0 | i14;
 i12 = _i64Add(i18 | 0, i35 | 0, i31 | i17 | 0, i12 | 0) | 0;
 i17 = getTempRet0() | 0;
 i20 = i12 ^ i20;
 i24 = i17 ^ i24;
 i31 = _bitshift64Shl(i18 | 0, i35 | 0, 33) | 0;
 i16 = getTempRet0() | 0;
 i35 = _bitshift64Lshr(i18 | 0, i35 | 0, 31) | 0;
 i16 = getTempRet0() | 0 | i16;
 i14 = _i64Add(i20 | 0, i24 | 0, i25 | i19 | 0, i14 | 0) | 0;
 i19 = getTempRet0() | 0;
 i21 = i14 ^ i21;
 i28 = i19 ^ i28;
 i25 = _bitshift64Shl(i20 | 0, i24 | 0, 10) | 0;
 i18 = getTempRet0() | 0;
 i24 = _bitshift64Lshr(i20 | 0, i24 | 0, 54) | 0;
 i18 = getTempRet0() | 0 | i18;
 i16 = _i64Add(i21 | 0, i28 | 0, i35 | i31 | 0, i16 | 0) | 0;
 i31 = getTempRet0() | 0;
 i23 = i16 ^ i23;
 i35 = i31 ^ i30;
 i30 = _bitshift64Shl(i21 | 0, i28 | 0, 13) | 0;
 i20 = getTempRet0() | 0;
 i28 = _bitshift64Lshr(i21 | 0, i28 | 0, 51) | 0;
 i20 = getTempRet0() | 0 | i20;
 i18 = _i64Add(i23 | 0, i35 | 0, i24 | i25 | 0, i18 | 0) | 0;
 i25 = getTempRet0() | 0;
 i37 = i18 ^ i37;
 i22 = i25 ^ i22;
 i24 = _bitshift64Shl(i23 | 0, i35 | 0, 38) | 0;
 i21 = getTempRet0() | 0;
 i35 = _bitshift64Lshr(i23 | 0, i35 | 0, 26) | 0;
 i21 = getTempRet0() | 0 | i21;
 i20 = _i64Add(i37 | 0, i22 | 0, i28 | i30 | 0, i20 | 0) | 0;
 i30 = getTempRet0() | 0;
 i33 = i20 ^ i33;
 i27 = i30 ^ i27;
 i28 = _bitshift64Shl(i37 | 0, i22 | 0, 53) | 0;
 i23 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i37 | 0, i22 | 0, 11) | 0;
 i23 = getTempRet0() | 0 | i23;
 i21 = _i64Add(i33 | 0, i27 | 0, i35 | i24 | 0, i21 | 0) | 0;
 i24 = getTempRet0() | 0;
 i29 = i21 ^ i29;
 i9 = i24 ^ i9;
 i35 = _bitshift64Shl(i33 | 0, i27 | 0, 42) | 0;
 i37 = getTempRet0() | 0;
 i27 = _bitshift64Lshr(i33 | 0, i27 | 0, 22) | 0;
 i37 = getTempRet0() | 0 | i37;
 i23 = _i64Add(i29 | 0, i9 | 0, i22 | i28 | 0, i23 | 0) | 0;
 i28 = getTempRet0() | 0;
 i26 = i23 ^ i26;
 i11 = i28 ^ i11;
 i22 = _bitshift64Shl(i29 | 0, i9 | 0, 54) | 0;
 i33 = getTempRet0() | 0;
 i9 = _bitshift64Lshr(i29 | 0, i9 | 0, 10) | 0;
 i33 = getTempRet0() | 0 | i33;
 i37 = _i64Add(i26 | 0, i11 | 0, i27 | i35 | 0, i37 | 0) | 0;
 i35 = getTempRet0() | 0;
 i8 = i37 ^ i8;
 i13 = i35 ^ i13;
 i27 = _bitshift64Shl(i26 | 0, i11 | 0, 44) | 0;
 i29 = getTempRet0() | 0;
 i11 = _bitshift64Lshr(i26 | 0, i11 | 0, 20) | 0;
 i29 = getTempRet0() | 0 | i29;
 i33 = _i64Add(i8 | 0, i13 | 0, i9 | i22 | 0, i33 | 0) | 0;
 i22 = getTempRet0() | 0;
 i10 = i33 ^ i10;
 i15 = i22 ^ i15;
 i9 = _bitshift64Shl(i8 | 0, i13 | 0, 15) | 0;
 i26 = getTempRet0() | 0;
 i13 = _bitshift64Lshr(i8 | 0, i13 | 0, 49) | 0;
 i26 = getTempRet0() | 0 | i26;
 i29 = _i64Add(i10 | 0, i15 | 0, i11 | i27 | 0, i29 | 0) | 0;
 i27 = getTempRet0() | 0;
 i12 = i29 ^ i12;
 i17 = i27 ^ i17;
 i11 = _bitshift64Shl(i10 | 0, i15 | 0, 34) | 0;
 i8 = getTempRet0() | 0;
 i15 = _bitshift64Lshr(i10 | 0, i15 | 0, 30) | 0;
 i8 = getTempRet0() | 0 | i8;
 i26 = _i64Add(i12 | 0, i17 | 0, i13 | i9 | 0, i26 | 0) | 0;
 i9 = getTempRet0() | 0;
 i14 = i26 ^ i14;
 i19 = i9 ^ i19;
 i13 = _bitshift64Shl(i12 | 0, i17 | 0, 21) | 0;
 i10 = getTempRet0() | 0;
 i17 = _bitshift64Lshr(i12 | 0, i17 | 0, 43) | 0;
 i10 = getTempRet0() | 0 | i10;
 i8 = _i64Add(i14 | 0, i19 | 0, i15 | i11 | 0, i8 | 0) | 0;
 i11 = getTempRet0() | 0;
 i16 = i8 ^ i16;
 i31 = i11 ^ i31;
 i15 = _bitshift64Shl(i14 | 0, i19 | 0, 38) | 0;
 i12 = getTempRet0() | 0;
 i19 = _bitshift64Lshr(i14 | 0, i19 | 0, 26) | 0;
 i12 = getTempRet0() | 0 | i12;
 i10 = _i64Add(i16 | 0, i31 | 0, i17 | i13 | 0, i10 | 0) | 0;
 i13 = getTempRet0() | 0;
 i18 = i10 ^ i18;
 i25 = i13 ^ i25;
 i17 = _bitshift64Shl(i16 | 0, i31 | 0, 33) | 0;
 i14 = getTempRet0() | 0;
 i31 = _bitshift64Lshr(i16 | 0, i31 | 0, 31) | 0;
 i14 = getTempRet0() | 0 | i14;
 i12 = _i64Add(i18 | 0, i25 | 0, i19 | i15 | 0, i12 | 0) | 0;
 i15 = getTempRet0() | 0;
 i20 = i12 ^ i20;
 i30 = i15 ^ i30;
 i19 = _bitshift64Shl(i18 | 0, i25 | 0, 10) | 0;
 i16 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i18 | 0, i25 | 0, 54) | 0;
 i16 = getTempRet0() | 0 | i16;
 i14 = _i64Add(i20 | 0, i30 | 0, i31 | i17 | 0, i14 | 0) | 0;
 i17 = getTempRet0() | 0;
 i21 = i14 ^ i21;
 i24 = i17 ^ i24;
 i31 = _bitshift64Shl(i20 | 0, i30 | 0, 13) | 0;
 i18 = getTempRet0() | 0;
 i30 = _bitshift64Lshr(i20 | 0, i30 | 0, 51) | 0;
 i18 = getTempRet0() | 0 | i18;
 i16 = _i64Add(i21 | 0, i24 | 0, i25 | i19 | 0, i16 | 0) | 0;
 i19 = getTempRet0() | 0;
 i23 = i16 ^ i23;
 i28 = i19 ^ i28;
 i25 = _bitshift64Shl(i21 | 0, i24 | 0, 38) | 0;
 i20 = getTempRet0() | 0;
 i24 = _bitshift64Lshr(i21 | 0, i24 | 0, 26) | 0;
 i20 = getTempRet0() | 0 | i20;
 i18 = _i64Add(i23 | 0, i28 | 0, i30 | i31 | 0, i18 | 0) | 0;
 i31 = getTempRet0() | 0;
 i37 = i18 ^ i37;
 i35 = i31 ^ i35;
 i30 = _bitshift64Shl(i23 | 0, i28 | 0, 53) | 0;
 i21 = getTempRet0() | 0;
 i28 = _bitshift64Lshr(i23 | 0, i28 | 0, 11) | 0;
 i21 = getTempRet0() | 0 | i21;
 i20 = _i64Add(i37 | 0, i35 | 0, i24 | i25 | 0, i20 | 0) | 0;
 i25 = getTempRet0() | 0;
 i33 = i20 ^ i33;
 i22 = i25 ^ i22;
 i24 = _bitshift64Shl(i37 | 0, i35 | 0, 42) | 0;
 i23 = getTempRet0() | 0;
 i35 = _bitshift64Lshr(i37 | 0, i35 | 0, 22) | 0;
 i23 = getTempRet0() | 0 | i23;
 i21 = _i64Add(i33 | 0, i22 | 0, i28 | i30 | 0, i21 | 0) | 0;
 i30 = getTempRet0() | 0;
 i29 = i21 ^ i29;
 i27 = i30 ^ i27;
 i28 = _bitshift64Shl(i33 | 0, i22 | 0, 54) | 0;
 i37 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i33 | 0, i22 | 0, 10) | 0;
 i37 = getTempRet0() | 0 | i37;
 i23 = _i64Add(i29 | 0, i27 | 0, i35 | i24 | 0, i23 | 0) | 0;
 i24 = getTempRet0() | 0;
 i26 = i23 ^ i26;
 i9 = i24 ^ i9;
 i35 = _bitshift64Shl(i29 | 0, i27 | 0, 44) | 0;
 i33 = getTempRet0() | 0;
 i27 = _bitshift64Lshr(i29 | 0, i27 | 0, 20) | 0;
 i33 = getTempRet0() | 0 | i33;
 i37 = _i64Add(i26 | 0, i9 | 0, i22 | i28 | 0, i37 | 0) | 0;
 i28 = getTempRet0() | 0;
 i8 = i37 ^ i8;
 i11 = i28 ^ i11;
 i22 = _bitshift64Shl(i26 | 0, i9 | 0, 15) | 0;
 i29 = getTempRet0() | 0;
 i9 = _bitshift64Lshr(i26 | 0, i9 | 0, 49) | 0;
 i29 = getTempRet0() | 0 | i29;
 i33 = _i64Add(i8 | 0, i11 | 0, i27 | i35 | 0, i33 | 0) | 0;
 i35 = getTempRet0() | 0;
 i10 = i33 ^ i10;
 i13 = i35 ^ i13;
 i27 = _bitshift64Shl(i8 | 0, i11 | 0, 34) | 0;
 i26 = getTempRet0() | 0;
 i11 = _bitshift64Lshr(i8 | 0, i11 | 0, 30) | 0;
 i26 = getTempRet0() | 0 | i26;
 i29 = _i64Add(i10 | 0, i13 | 0, i9 | i22 | 0, i29 | 0) | 0;
 i12 = i29 ^ i12;
 i15 = (getTempRet0() | 0) ^ i15;
 i29 = _bitshift64Shl(i10 | 0, i13 | 0, 21) | 0;
 i22 = getTempRet0() | 0;
 i13 = _bitshift64Lshr(i10 | 0, i13 | 0, 43) | 0;
 i22 = getTempRet0() | 0 | i22;
 i26 = _i64Add(i12 | 0, i15 | 0, i11 | i27 | 0, i26 | 0) | 0;
 i14 = i26 ^ i14;
 i17 = (getTempRet0() | 0) ^ i17;
 i26 = _bitshift64Shl(i12 | 0, i15 | 0, 38) | 0;
 i27 = getTempRet0() | 0;
 i15 = _bitshift64Lshr(i12 | 0, i15 | 0, 26) | 0;
 i27 = getTempRet0() | 0 | i27;
 i22 = _i64Add(i14 | 0, i17 | 0, i13 | i29 | 0, i22 | 0) | 0;
 i16 = i22 ^ i16;
 i19 = (getTempRet0() | 0) ^ i19;
 i22 = _bitshift64Shl(i14 | 0, i17 | 0, 33) | 0;
 i29 = getTempRet0() | 0;
 i17 = _bitshift64Lshr(i14 | 0, i17 | 0, 31) | 0;
 i29 = getTempRet0() | 0 | i29;
 i27 = _i64Add(i16 | 0, i19 | 0, i15 | i26 | 0, i27 | 0) | 0;
 i18 = i27 ^ i18;
 i31 = (getTempRet0() | 0) ^ i31;
 i27 = _bitshift64Shl(i16 | 0, i19 | 0, 10) | 0;
 i26 = getTempRet0() | 0;
 i19 = _bitshift64Lshr(i16 | 0, i19 | 0, 54) | 0;
 i26 = getTempRet0() | 0 | i26;
 i29 = _i64Add(i18 | 0, i31 | 0, i17 | i22 | 0, i29 | 0) | 0;
 i20 = i29 ^ i20;
 i25 = (getTempRet0() | 0) ^ i25;
 i29 = _bitshift64Shl(i18 | 0, i31 | 0, 13) | 0;
 i22 = getTempRet0() | 0;
 i31 = _bitshift64Lshr(i18 | 0, i31 | 0, 51) | 0;
 i22 = getTempRet0() | 0 | i22;
 i26 = _i64Add(i20 | 0, i25 | 0, i19 | i27 | 0, i26 | 0) | 0;
 i21 = i26 ^ i21;
 i30 = (getTempRet0() | 0) ^ i30;
 i26 = _bitshift64Shl(i20 | 0, i25 | 0, 38) | 0;
 i27 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i20 | 0, i25 | 0, 26) | 0;
 i27 = getTempRet0() | 0 | i27;
 i22 = _i64Add(i21 | 0, i30 | 0, i31 | i29 | 0, i22 | 0) | 0;
 i24 = (getTempRet0() | 0) ^ i24;
 i29 = _bitshift64Shl(i21 | 0, i30 | 0, 53) | 0;
 i31 = getTempRet0() | 0;
 i30 = _bitshift64Lshr(i21 | 0, i30 | 0, 11) | 0;
 i31 = getTempRet0() | 0 | i31;
 i27 = _i64Add(i22 ^ i23 | 0, i24 | 0, i25 | i26 | 0, i27 | 0) | 0;
 i37 = i27 ^ i37;
 i28 = (getTempRet0() | 0) ^ i28;
 i31 = _i64Add(i37 | 0, i28 | 0, i30 | i29 | 0, i31 | 0) | 0;
 i35 = (getTempRet0() | 0) ^ i35;
 i29 = _bitshift64Shl(i37 | 0, i28 | 0, 54) | 0;
 i30 = getTempRet0() | 0;
 i28 = _bitshift64Lshr(i37 | 0, i28 | 0, 10) | 0;
 i30 = getTempRet0() | 0 | i30;
 i37 = i32;
 HEAP32[i37 >> 2] = i28 | i29;
 HEAP32[i37 + 4 >> 2] = i30;
 i37 = i34;
 HEAP32[i37 >> 2] = i31 ^ i33;
 HEAP32[i37 + 4 >> 2] = i35;
 STACKTOP = i36;
 return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i68, i69, i1, i70, i71, i65, i73, i54, i56, i48, i72) {
 i68 = i68 | 0;
 i69 = i69 | 0;
 i1 = i1 | 0;
 i70 = i70 | 0;
 i71 = i71 | 0;
 i65 = i65 | 0;
 i73 = i73 | 0;
 i54 = i54 | 0;
 i56 = i56 | 0;
 i48 = i48 | 0;
 i72 = i72 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f66 = f0, f67 = f0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i74 + 460 | 0;
 i45 = i74 + 448 | 0;
 i64 = i74 + 128 | 0;
 i63 = i74 + 272 | 0;
 i61 = i74 + 208 | 0;
 i62 = i74 + 144 | 0;
 i53 = i74 + 432 | 0;
 i55 = i74 + 416 | 0;
 i44 = i74 + 112 | 0;
 i43 = i74 + 408 | 0;
 i15 = i74 + 96 | 0;
 i16 = i74 + 396 | 0;
 i17 = i74 + 80 | 0;
 i57 = i74 + 64 | 0;
 i60 = i74 + 48 | 0;
 i58 = i74 + 384 | 0;
 i59 = i74 + 372 | 0;
 i42 = i74 + 32 | 0;
 i41 = i74 + 360 | 0;
 i49 = i74 + 16 | 0;
 i52 = i74;
 i51 = i74 + 348 | 0;
 i50 = i74 + 336 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f66 = Math_fround(HEAPF32[i68 + 16 >> 2]);
 f67 = Math_fround(HEAPF32[i69 + 16 >> 2]);
 f37 = Math_fround(HEAPF32[i68 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i69 + 32 >> 2]);
 f37 = Math_fround((f37 > f3 ? f3 : f37) * Math_fround(.100000001));
 f37 = Math_fround(f37 * f37);
 f3 = Math_fround(f66 + f67);
 i38 = i44 + 4 | 0;
 i39 = i44 + 8 | 0;
 i40 = i44 + 12 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i43 >> 2] = 0;
 i1 = HEAP8[i48 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f35 = Math_fround(HEAPF32[i68 >> 2]);
  f5 = Math_fround(HEAPF32[i68 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i68 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i69 >> 2]);
  f6 = Math_fround(HEAPF32[i69 + 4 >> 2]);
  f4 = Math_fround(f35 - f4);
  f6 = Math_fround(f5 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i69 + 8 >> 2]));
  i36 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f4 = i36 ? f4 : Math_fround(1.0);
  f6 = i36 ? f6 : Math_fround(0.0);
  f7 = i36 ? f7 : Math_fround(0.0);
  HEAPF32[i64 >> 2] = f4;
  HEAPF32[i64 + 4 >> 2] = f6;
  HEAPF32[i64 + 8 >> 2] = f7;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i17 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  i36 = i64;
  f5 = Math_fround(3402823469999999843913219.0e14);
  i47 = 6;
 } else {
  i14 = HEAP32[i69 + 200 >> 2] | 0;
  i2 = i1 & 255;
  i11 = 0;
  i13 = 0;
  while (1) {
   i33 = HEAPU8[i54 + i13 >> 0] | 0;
   HEAP32[i53 + (i13 << 2) >> 2] = i33;
   i1 = HEAPU8[i56 + i13 >> 0] | 0;
   HEAP32[i55 + (i13 << 2) >> 2] = i1;
   f12 = Math_fround(HEAPF32[i68 + 96 + (i33 << 4) >> 2]);
   f18 = Math_fround(HEAPF32[i68 + 96 + (i33 << 4) + 4 >> 2]);
   f35 = Math_fround(HEAPF32[i68 + 96 + (i33 << 4) + 8 >> 2]);
   i33 = HEAP32[i68 + 96 + (i33 << 4) + 12 >> 2] | 0;
   i34 = HEAP32[i14 + (i1 * 12 | 0) >> 2] | 0;
   i36 = HEAP32[i14 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i1 = HEAP32[i14 + (i1 * 12 | 0) + 8 >> 2] | 0;
   f7 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f9 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f10 = Math_fround(f35 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i44 >> 2] = f7;
   HEAPF32[i38 >> 2] = f9;
   HEAPF32[i39 >> 2] = f10;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   HEAPF32[i61 + (i11 << 4) >> 2] = f12;
   HEAPF32[i61 + (i11 << 4) + 4 >> 2] = f18;
   HEAPF32[i61 + (i11 << 4) + 8 >> 2] = f35;
   HEAP32[i61 + (i11 << 4) + 12 >> 2] = i33;
   HEAP32[i62 + (i11 << 4) >> 2] = i34;
   HEAP32[i62 + (i11 << 4) + 4 >> 2] = i36;
   HEAP32[i62 + (i11 << 4) + 8 >> 2] = i1;
   HEAPF32[i62 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i11 + 1 | 0;
   i36 = i63 + (i11 << 4) | 0;
   HEAP32[i36 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   i13 = i13 + 1 | 0;
   if (i13 >>> 0 >= i2 >>> 0) break; else i11 = i1;
  }
  HEAP32[i43 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i15, i63, i61, i62, i53, i55, i44, i43);
  HEAP32[i64 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i64 >> 2]);
  f6 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i46 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i45 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i45 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i45 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  if (f5 > f37) {
   i36 = i64;
   i47 = 6;
  }
 }
 do if ((i47 | 0) == 6) {
  i34 = i64 + 4 | 0;
  i19 = i64 + 8 | 0;
  i20 = i68 + 96 | 0;
  i21 = i68 + 100 | 0;
  i22 = i68 + 104 | 0;
  i23 = i68 + 112 | 0;
  i24 = i68 + 116 | 0;
  i25 = i68 + 120 | 0;
  i26 = i68 + 128 | 0;
  i27 = i68 + 132 | 0;
  i28 = i68 + 136 | 0;
  i29 = i69 + 196 | 0;
  i30 = i69 + 200 | 0;
  i31 = i69 + 204 | 0;
  i32 = i68 + 48 | 0;
  i33 = i69 + 48 | 0;
  f35 = f5;
  while (1) {
   HEAP32[i45 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i45 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i45 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   f83 = Math_fround(-f4);
   f82 = Math_fround(-f6);
   f79 = Math_fround(-f7);
   i14 = HEAP32[i43 >> 2] | 0;
   f78 = Math_fround(HEAPF32[i20 >> 2]);
   f76 = Math_fround(HEAPF32[i21 >> 2]);
   f5 = Math_fround(HEAPF32[i22 >> 2]);
   f77 = Math_fround(HEAPF32[i23 >> 2]);
   f75 = Math_fround(HEAPF32[i24 >> 2]);
   f9 = Math_fround(HEAPF32[i25 >> 2]);
   f10 = Math_fround(HEAPF32[i26 >> 2]);
   f12 = Math_fround(HEAPF32[i27 >> 2]);
   f18 = Math_fround(HEAPF32[i28 >> 2]);
   f81 = Math_fround(Math_fround(Math_fround(f78 * f83) + Math_fround(f76 * f82)) + Math_fround(f5 * f79));
   f80 = Math_fround(Math_fround(Math_fround(f77 * f83) + Math_fround(f75 * f82)) + Math_fround(f9 * f79));
   f79 = Math_fround(Math_fround(Math_fround(f10 * f83) + Math_fround(f12 * f82)) + Math_fround(f18 * f79));
   i16 = f81 > f80 & f81 > f79;
   i15 = f80 > f79;
   HEAP32[i53 + (i14 << 2) >> 2] = i16 ? 0 : i15 ? 1 : 2;
   f10 = i16 ? f78 : i15 ? f77 : f10;
   f12 = i16 ? f76 : i15 ? f75 : f12;
   f18 = i16 ? f5 : i15 ? f9 : f18;
   HEAPF32[i61 + (i14 << 4) >> 2] = f10;
   HEAPF32[i61 + (i14 << 4) + 4 >> 2] = f12;
   HEAPF32[i61 + (i14 << 4) + 8 >> 2] = f18;
   HEAPF32[i61 + (i14 << 4) + 12 >> 2] = Math_fround(0.0);
   i15 = i62 + (i14 << 4) | 0;
   i16 = i55 + (i14 << 2) | 0;
   if (!(HEAP32[i29 >> 2] | 0)) {
    i1 = HEAP32[i30 >> 2] | 0;
    if ((HEAPU8[i31 >> 0] | 0) > 1) {
     f9 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f4);
     f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f6));
     f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f7));
     i2 = 1;
     i11 = 0;
     while (1) {
      i1 = HEAP32[i30 >> 2] | 0;
      f82 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
      f83 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
      f4 = Math_fround(HEAPF32[i64 >> 2]);
      f6 = Math_fround(HEAPF32[i34 >> 2]);
      f7 = Math_fround(HEAPF32[i19 >> 2]);
      f5 = Math_fround(Math_fround(Math_fround(f82 * f4) + Math_fround(f83 * f6)) + Math_fround(f5 * f7));
      i13 = f5 > f9;
      i11 = i13 ? i2 : i11;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i31 >> 0] | 0) >>> 0) f9 = i13 ? f5 : f9; else break;
     }
    } else i11 = 0;
   } else {
    i11 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i69, i64) | 0;
    f4 = Math_fround(HEAPF32[i64 >> 2]);
    f6 = Math_fround(HEAPF32[i34 >> 2]);
    i1 = HEAP32[i30 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i19 >> 2]);
   }
   HEAP32[i16 >> 2] = i11;
   i2 = HEAP32[i1 + (i11 * 12 | 0) >> 2] | 0;
   i16 = HEAP32[i1 + (i11 * 12 | 0) + 4 >> 2] | 0;
   i13 = HEAP32[i1 + (i11 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i15 >> 2] = i2;
   HEAP32[i62 + (i14 << 4) + 4 >> 2] = i16;
   HEAP32[i62 + (i14 << 4) + 8 >> 2] = i13;
   HEAPF32[i62 + (i14 << 4) + 12 >> 2] = Math_fround(0.0);
   f80 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f81 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f83 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i44 >> 2] = f80;
   HEAPF32[i38 >> 2] = f81;
   HEAPF32[i39 >> 2] = f83;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i43 >> 2] | 0;
   i11 = i63 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   f79 = Math_fround(HEAPF32[i32 >> 2]);
   f82 = Math_fround(HEAPF32[i33 >> 2]);
   f82 = f79 > f82 ? f79 : f82;
   f8 = f8 > f82 ? f8 : f82;
   f82 = Math_fround(f3 + f8);
   f83 = Math_fround(Math_fround(Math_fround(f4 * f80) + Math_fround(f6 * f81)) + Math_fround(f7 * f83));
   i11 = f83 > Math_fround(0.0) ? Math_fround(f83 * f83) > Math_fround(f35 * Math_fround(f82 * f82)) : 0;
   if (Math_fround(f35 * Math_fround(.00039999999)) >= Math_fround(f35 - f83) | i11) {
    f5 = f35;
    i47 = 13;
    break;
   }
   HEAP32[i43 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i42, i63, i61, i62, i53, i55, i44, i43);
   HEAP32[i36 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i64 >> 2]);
   f6 = Math_fround(HEAPF32[i34 >> 2]);
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   f5 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i46 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i46 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i46 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   i1 = f35 > f5;
   if (!(f5 > f37 & i1)) break; else f35 = f5;
  }
  if ((i47 | 0) == 13) {
   i2 = i13 + -1 | 0;
   if (i54 | 0) {
    HEAP8[i48 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
      HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i73 = 0;
    STACKTOP = i74;
    return i73 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f5)));
   f5 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f5);
   f8 = Math_fround(f6 * f5);
   f7 = Math_fround(f7 * f5);
   HEAPF32[i65 >> 2] = f9;
   HEAPF32[i65 + 4 >> 2] = f8;
   HEAPF32[i65 + 8 >> 2] = f7;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i57, i60, i13);
   f5 = Math_fround(HEAPF32[i57 >> 2]);
   f6 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   if (i72) {
    f82 = HEAP32[i68 + 64 >> 2] | 0 ? Math_fround(0.0) : f66;
    f79 = HEAP32[i69 + 64 >> 2] | 0 ? Math_fround(0.0) : f67;
    f83 = Math_fround(f82 + f79);
    f81 = Math_fround(f6 - Math_fround(f8 * f82));
    f80 = Math_fround(f4 - Math_fround(f7 * f82));
    HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f9 * f82));
    HEAPF32[i70 + 4 >> 2] = f81;
    HEAPF32[i70 + 8 >> 2] = f80;
    HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
    f80 = Math_fround(HEAPF32[i60 >> 2]);
    f81 = Math_fround(HEAPF32[i60 + 4 >> 2]);
    f81 = Math_fround(Math_fround(f8 * f79) + f81);
    f82 = Math_fround(Math_fround(f7 * f79) + Math_fround(HEAPF32[i60 + 8 >> 2]));
    HEAPF32[i71 >> 2] = Math_fround(Math_fround(f9 * f79) + f80);
    HEAPF32[i71 + 4 >> 2] = f81;
    HEAPF32[i71 + 8 >> 2] = f82;
    HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i73 >> 2] = Math_fround(f10 - f83);
    i73 = i73 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    i73 = 1;
    STACKTOP = i74;
    return i73 | 0;
   } else {
    f82 = Math_fround(f6 - Math_fround(f66 * f8));
    f81 = Math_fround(f4 - Math_fround(f66 * f7));
    HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f66 * f9));
    HEAPF32[i70 + 4 >> 2] = f82;
    HEAPF32[i70 + 8 >> 2] = f81;
    HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
    f81 = Math_fround(HEAPF32[i60 >> 2]);
    f82 = Math_fround(HEAPF32[i60 + 4 >> 2]);
    f82 = Math_fround(Math_fround(f67 * f8) + f82);
    f83 = Math_fround(Math_fround(f67 * f7) + Math_fround(HEAPF32[i60 + 8 >> 2]));
    HEAPF32[i71 >> 2] = Math_fround(Math_fround(f67 * f9) + f81);
    HEAPF32[i71 + 4 >> 2] = f82;
    HEAPF32[i71 + 8 >> 2] = f83;
    HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i73 >> 2] = Math_fround(f10 - f3);
    i73 = i73 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
    i73 = 1;
    STACKTOP = i74;
    return i73 | 0;
   }
  }
  if (i1) {
   if (!i54) i1 = 6; else break;
   STACKTOP = i74;
   return i1 | 0;
  };
  HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  i11 = HEAP32[i43 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i54 | 0) {
   HEAP8[i48 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
     HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i36 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i49, i52, i11);
  HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f35)));
  f9 = Math_fround(HEAPF32[i64 >> 2]);
  f10 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i49 >> 2]);
  f6 = Math_fround(HEAPF32[i49 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i49 + 8 >> 2]);
  if (i72) {
   f83 = HEAP32[i68 + 64 >> 2] | 0 ? Math_fround(0.0) : f66;
   f80 = HEAP32[i69 + 64 >> 2] | 0 ? Math_fround(0.0) : f67;
   f3 = Math_fround(f83 + f80);
   f82 = Math_fround(f6 - Math_fround(f10 * f83));
   f81 = Math_fround(f4 - Math_fround(f7 * f83));
   HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f9 * f83));
   HEAPF32[i70 + 4 >> 2] = f82;
   HEAPF32[i70 + 8 >> 2] = f81;
   HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
   f81 = Math_fround(HEAPF32[i52 >> 2]);
   f82 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f82 = Math_fround(Math_fround(f10 * f80) + f82);
   f83 = Math_fround(Math_fround(f7 * f80) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i71 >> 2] = Math_fround(Math_fround(f9 * f80) + f81);
   HEAPF32[i71 + 4 >> 2] = f82;
   HEAPF32[i71 + 8 >> 2] = f83;
   HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
   i72 = i73 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  } else {
   f82 = Math_fround(f6 - Math_fround(f66 * f10));
   f81 = Math_fround(f4 - Math_fround(f66 * f7));
   HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f66 * f9));
   HEAPF32[i70 + 4 >> 2] = f82;
   HEAPF32[i70 + 8 >> 2] = f81;
   HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
   f81 = Math_fround(HEAPF32[i52 >> 2]);
   f82 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f82 = Math_fround(Math_fround(f67 * f10) + f82);
   f83 = Math_fround(Math_fround(f67 * f7) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i71 >> 2] = Math_fround(Math_fround(f67 * f9) + f81);
   HEAPF32[i71 + 4 >> 2] = f82;
   HEAPF32[i71 + 8 >> 2] = f83;
   HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
   i72 = i73 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  }
  HEAPF32[i73 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i65 >> 2] = f9;
  HEAPF32[i65 + 4 >> 2] = f10;
  HEAPF32[i65 + 8 >> 2] = f7;
  HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
  i73 = f12 >= f35 ? 1 : 3;
  STACKTOP = i74;
  return i73 | 0;
 } while (0);
 i2 = HEAP32[i43 >> 2] | 0;
 HEAP8[i48 >> 0] = i2;
 if (!i2) {
  i73 = 6;
  STACKTOP = i74;
  return i73 | 0;
 } else i1 = 0;
 do {
  HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
  HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i74;
 return i1 | 0;
}

function __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb(i1, i2, i91, i102, i113) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i91 = i91 | 0;
 i102 = i102 | 0;
 i113 = i113 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0;
 i123 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i119 = i123 + 80 | 0;
 i120 = i123 + 64 | 0;
 i121 = i123 + 16 | 0;
 i122 = i123;
 i82 = HEAP32[i91 + 12 >> 2] | 0;
 if (!i82) {
  STACKTOP = i123;
  return;
 }
 i83 = i91 + 500 | 0;
 i84 = i119 + 4 | 0;
 i85 = i119 + 8 | 0;
 i86 = i119 + 12 | 0;
 i87 = i91 + 520 | 0;
 i88 = i122 + 4 | 0;
 i89 = i122 + 8 | 0;
 i90 = i122 + 12 | 0;
 i92 = i91 + 540 | 0;
 i93 = i1 + 468 | 0;
 i94 = i1 + 240 | 0;
 i95 = i120 + 4 | 0;
 i96 = i119 + 4 | 0;
 i97 = i120 + 8 | 0;
 i98 = i119 + 8 | 0;
 i99 = i120 + 12 | 0;
 i100 = i119 + 12 | 0;
 i101 = i121 + 4 | 0;
 i103 = i121 + 8 | 0;
 i104 = i121 + 12 | 0;
 i105 = i1 + 924 | 0;
 i106 = i1 + 696 | 0;
 i107 = i120 + 4 | 0;
 i108 = i119 + 4 | 0;
 i109 = i120 + 8 | 0;
 i110 = i119 + 8 | 0;
 i111 = i120 + 12 | 0;
 i112 = i119 + 12 | 0;
 i114 = i121 + 16 | 0;
 i115 = i121 + 20 | 0;
 i116 = i121 + 24 | 0;
 i117 = i121 + 28 | 0;
 i118 = i1 + 1380 | 0;
 i54 = i1 + 1152 | 0;
 i55 = i120 + 4 | 0;
 i56 = i119 + 4 | 0;
 i57 = i120 + 8 | 0;
 i58 = i119 + 8 | 0;
 i59 = i120 + 12 | 0;
 i60 = i119 + 12 | 0;
 i61 = i121 + 32 | 0;
 i62 = i121 + 36 | 0;
 i63 = i121 + 40 | 0;
 i64 = i121 + 44 | 0;
 i65 = i2 + 468 | 0;
 i66 = i2 + 240 | 0;
 i67 = i120 + 4 | 0;
 i68 = i119 + 4 | 0;
 i69 = i120 + 8 | 0;
 i70 = i119 + 8 | 0;
 i71 = i120 + 12 | 0;
 i72 = i119 + 12 | 0;
 i73 = i2 + 924 | 0;
 i74 = i2 + 696 | 0;
 i75 = i120 + 4 | 0;
 i76 = i119 + 4 | 0;
 i77 = i120 + 8 | 0;
 i78 = i119 + 8 | 0;
 i79 = i120 + 12 | 0;
 i80 = i119 + 12 | 0;
 i81 = i2 + 1380 | 0;
 i2 = i2 + 1152 | 0;
 i35 = i120 + 4 | 0;
 i36 = i119 + 4 | 0;
 i37 = i120 + 8 | 0;
 i38 = i119 + 8 | 0;
 i39 = i120 + 12 | 0;
 i40 = i119 + 12 | 0;
 i41 = i102 + 12 | 0;
 i42 = i102 + 24 | 0;
 i43 = i102 + 4 | 0;
 i44 = i102 + 16 | 0;
 i45 = i102 + 28 | 0;
 i46 = i102 + 8 | 0;
 i47 = i102 + 20 | 0;
 i48 = i102 + 32 | 0;
 i49 = i91 + 20 | 0;
 i50 = i91 + 40 | 0;
 i51 = i91 + 60 | 0;
 i52 = i91 + 80 | 0;
 i53 = i91 + 100 | 0;
 i1 = 0;
 do {
  i131 = (HEAP32[i83 >> 2] | 0) + (i1 << 2) | 0;
  i130 = (HEAP32[i131 + 4 >> 2] | 0) + 306581307 | 0;
  i129 = (HEAP32[i131 + 8 >> 2] | 0) + 306581307 | 0;
  i128 = (HEAP32[i131 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i119 >> 2] = (HEAP32[i131 >> 2] | 0) + 306581307;
  HEAP32[i84 >> 2] = i130;
  HEAP32[i85 >> 2] = i129;
  HEAP32[i86 >> 2] = i128;
  __Z17GenerateRandomNx3RKN4math5_int4E(i121, i119);
  i128 = (HEAP32[i87 >> 2] | 0) + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i128 >> 2]);
  f29 = Math_fround(HEAPF32[i128 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i128 + 8 >> 2]);
  f29 = Math_fround(f29 * Math_fround(.00999999977));
  f25 = Math_fround(f25 * Math_fround(.00999999977));
  f21 = Math_fround(Math_fround(HEAPF32[i128 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i122 >> 2] = Math_fround(f33 * Math_fround(.00999999977));
  HEAPF32[i88 >> 2] = f29;
  HEAPF32[i89 >> 2] = f25;
  HEAPF32[i90 >> 2] = f21;
  i128 = (HEAP32[i92 >> 2] | 0) + (i1 << 2) | 0;
  f21 = Math_fround(HEAPF32[i128 >> 2]);
  f25 = Math_fround(HEAPF32[i128 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i128 + 8 >> 2]);
  f21 = Math_fround(Math_fround(1.0) / f21);
  f25 = Math_fround(Math_fround(1.0) / f25);
  f29 = Math_fround(Math_fround(1.0) / f29);
  f33 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i128 + 12 >> 2]));
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i119, i93, i122);
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i120, i94, i122);
  f5 = Math_fround(HEAPF32[i120 >> 2]);
  f15 = Math_fround(HEAPF32[i119 >> 2]);
  f5 = Math_fround(f5 - f15);
  f3 = Math_fround(HEAPF32[i95 >> 2]);
  f13 = Math_fround(HEAPF32[i96 >> 2]);
  f3 = Math_fround(f3 - f13);
  f6 = Math_fround(HEAPF32[i97 >> 2]);
  f4 = Math_fround(HEAPF32[i98 >> 2]);
  f6 = Math_fround(f6 - f4);
  f9 = Math_fround(HEAPF32[i99 >> 2]);
  f10 = Math_fround(HEAPF32[i100 >> 2]);
  f9 = Math_fround(f9 - f10);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i121 >> 2]));
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i101 >> 2]));
  f6 = Math_fround(f6 * Math_fround(HEAPF32[i103 >> 2]));
  f5 = Math_fround(f15 + f5);
  f3 = Math_fround(f13 + f3);
  f6 = Math_fround(f4 + f6);
  f9 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i104 >> 2])));
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i119, i105, i122);
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i120, i106, i122);
  f10 = Math_fround(HEAPF32[i120 >> 2]);
  f4 = Math_fround(HEAPF32[i119 >> 2]);
  f10 = Math_fround(f10 - f4);
  f13 = Math_fround(HEAPF32[i107 >> 2]);
  f15 = Math_fround(HEAPF32[i108 >> 2]);
  f13 = Math_fround(f13 - f15);
  f14 = Math_fround(HEAPF32[i109 >> 2]);
  f31 = Math_fround(HEAPF32[i110 >> 2]);
  f14 = Math_fround(f14 - f31);
  f17 = Math_fround(HEAPF32[i111 >> 2]);
  f16 = Math_fround(HEAPF32[i112 >> 2]);
  f17 = Math_fround(f17 - f16);
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i114 >> 2]));
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i115 >> 2]));
  f14 = Math_fround(f14 * Math_fround(HEAPF32[i116 >> 2]));
  f10 = Math_fround(f4 + f10);
  f13 = Math_fround(f15 + f13);
  f14 = Math_fround(f31 + f14);
  f17 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i117 >> 2])));
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i119, i118, i122);
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i120, i54, i122);
  f16 = Math_fround(HEAPF32[i120 >> 2]);
  f31 = Math_fround(HEAPF32[i119 >> 2]);
  f16 = Math_fround(f16 - f31);
  f15 = Math_fround(HEAPF32[i55 >> 2]);
  f4 = Math_fround(HEAPF32[i56 >> 2]);
  f15 = Math_fround(f15 - f4);
  f11 = Math_fround(HEAPF32[i57 >> 2]);
  f32 = Math_fround(HEAPF32[i58 >> 2]);
  f11 = Math_fround(f11 - f32);
  f7 = Math_fround(HEAPF32[i59 >> 2]);
  f19 = Math_fround(HEAPF32[i60 >> 2]);
  f7 = Math_fround(f7 - f19);
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i61 >> 2]));
  f15 = Math_fround(f15 * Math_fround(HEAPF32[i62 >> 2]));
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i63 >> 2]));
  f16 = Math_fround(f31 + f16);
  f15 = Math_fround(f4 + f15);
  f11 = Math_fround(f32 + f11);
  f7 = Math_fround(f19 + Math_fround(f7 * Math_fround(HEAPF32[i64 >> 2])));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i119, i65, i122);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i120, i66, i122);
  f19 = Math_fround(HEAPF32[i120 >> 2]);
  f32 = Math_fround(HEAPF32[i119 >> 2]);
  f19 = Math_fround(f19 - f32);
  f4 = Math_fround(HEAPF32[i67 >> 2]);
  f31 = Math_fround(HEAPF32[i68 >> 2]);
  f4 = Math_fround(f4 - f31);
  f23 = Math_fround(HEAPF32[i69 >> 2]);
  f26 = Math_fround(HEAPF32[i70 >> 2]);
  f23 = Math_fround(f23 - f26);
  f27 = Math_fround(HEAPF32[i71 >> 2]);
  f20 = Math_fround(HEAPF32[i72 >> 2]);
  f27 = Math_fround(f27 - f20);
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i121 >> 2]));
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i101 >> 2]));
  f23 = Math_fround(f23 * Math_fround(HEAPF32[i103 >> 2]));
  f19 = Math_fround(f32 + f19);
  f4 = Math_fround(f31 + f4);
  f23 = Math_fround(f26 + f23);
  f27 = Math_fround(f20 + Math_fround(f27 * Math_fround(HEAPF32[i104 >> 2])));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i119, i73, i122);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i120, i74, i122);
  f20 = Math_fround(HEAPF32[i120 >> 2]);
  f26 = Math_fround(HEAPF32[i119 >> 2]);
  f20 = Math_fround(f20 - f26);
  f31 = Math_fround(HEAPF32[i75 >> 2]);
  f32 = Math_fround(HEAPF32[i76 >> 2]);
  f31 = Math_fround(f31 - f32);
  f24 = Math_fround(HEAPF32[i77 >> 2]);
  f22 = Math_fround(HEAPF32[i78 >> 2]);
  f24 = Math_fround(f24 - f22);
  f28 = Math_fround(HEAPF32[i79 >> 2]);
  f18 = Math_fround(HEAPF32[i80 >> 2]);
  f28 = Math_fround(f28 - f18);
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i114 >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i115 >> 2]));
  f24 = Math_fround(f24 * Math_fround(HEAPF32[i116 >> 2]));
  f20 = Math_fround(f26 + f20);
  f31 = Math_fround(f32 + f31);
  f24 = Math_fround(f22 + f24);
  f28 = Math_fround(f18 + Math_fround(f28 * Math_fround(HEAPF32[i117 >> 2])));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i119, i81, i122);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i120, i2, i122);
  f18 = Math_fround(HEAPF32[i120 >> 2]);
  f22 = Math_fround(HEAPF32[i119 >> 2]);
  f18 = Math_fround(f18 - f22);
  f32 = Math_fround(HEAPF32[i35 >> 2]);
  f26 = Math_fround(HEAPF32[i36 >> 2]);
  f32 = Math_fround(f32 - f26);
  f12 = Math_fround(HEAPF32[i37 >> 2]);
  f30 = Math_fround(HEAPF32[i38 >> 2]);
  f12 = Math_fround(f12 - f30);
  f8 = Math_fround(HEAPF32[i39 >> 2]);
  f34 = Math_fround(HEAPF32[i40 >> 2]);
  f8 = Math_fround(f8 - f34);
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i61 >> 2]));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i62 >> 2]));
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i63 >> 2]));
  f127 = Math_fround(f21 * f21);
  f126 = Math_fround(f25 * f25);
  f125 = Math_fround(f29 * f29);
  f124 = Math_fround(f33 * f33);
  f5 = Math_fround(f127 * f5);
  f3 = Math_fround(f126 * f3);
  f6 = Math_fround(f125 * f6);
  f9 = Math_fround(f124 * f9);
  f10 = Math_fround(f127 * f10);
  f13 = Math_fround(f126 * f13);
  f14 = Math_fround(f125 * f14);
  f17 = Math_fround(f124 * f17);
  f16 = Math_fround(f127 * f16);
  f15 = Math_fround(f126 * f15);
  f11 = Math_fround(f125 * f11);
  f7 = Math_fround(f124 * f7);
  f19 = Math_fround(f21 * f19);
  f4 = Math_fround(f25 * f4);
  f23 = Math_fround(f29 * f23);
  f27 = Math_fround(f33 * f27);
  f20 = Math_fround(f21 * f20);
  f31 = Math_fround(f25 * f31);
  f24 = Math_fround(f29 * f24);
  f28 = Math_fround(f33 * f28);
  f18 = Math_fround(f21 * Math_fround(f22 + f18));
  f32 = Math_fround(f25 * Math_fround(f26 + f32));
  f12 = Math_fround(f29 * Math_fround(f30 + f12));
  f8 = Math_fround(f33 * Math_fround(f34 + Math_fround(f8 * Math_fround(HEAPF32[i64 >> 2]))));
  if (i113) {
   f124 = Math_fround(HEAPF32[i102 >> 2]);
   f33 = Math_fround(f5 * f124);
   f127 = Math_fround(f3 * f124);
   f30 = Math_fround(f6 * f124);
   f29 = Math_fround(f9 * f124);
   f125 = Math_fround(HEAPF32[i41 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f10 * f125));
   f127 = Math_fround(f127 + Math_fround(f13 * f125));
   f30 = Math_fround(f30 + Math_fround(f14 * f125));
   f29 = Math_fround(f29 + Math_fround(f17 * f125));
   f126 = Math_fround(HEAPF32[i42 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f16 * f126));
   f127 = Math_fround(f127 + Math_fround(f15 * f126));
   f30 = Math_fround(f30 + Math_fround(f11 * f126));
   f29 = Math_fround(f29 + Math_fround(f7 * f126));
   f139 = Math_fround(HEAPF32[i43 >> 2]);
   f26 = Math_fround(f5 * f139);
   f25 = Math_fround(f3 * f139);
   f140 = Math_fround(f6 * f139);
   f21 = Math_fround(f9 * f139);
   f138 = Math_fround(HEAPF32[i44 >> 2]);
   f26 = Math_fround(f26 + Math_fround(f10 * f138));
   f25 = Math_fround(f25 + Math_fround(f13 * f138));
   f140 = Math_fround(f140 + Math_fround(f14 * f138));
   f21 = Math_fround(f21 + Math_fround(f17 * f138));
   f22 = Math_fround(HEAPF32[i45 >> 2]);
   f26 = Math_fround(f26 + Math_fround(f16 * f22));
   f25 = Math_fround(f25 + Math_fround(f15 * f22));
   f140 = Math_fround(f140 + Math_fround(f11 * f22));
   f21 = Math_fround(f21 + Math_fround(f7 * f22));
   f134 = Math_fround(HEAPF32[i46 >> 2]);
   f137 = Math_fround(f5 * f134);
   f136 = Math_fround(f3 * f134);
   f135 = Math_fround(f6 * f134);
   f132 = Math_fround(f9 * f134);
   f133 = Math_fround(HEAPF32[i47 >> 2]);
   f137 = Math_fround(f137 + Math_fround(f10 * f133));
   f136 = Math_fround(f136 + Math_fround(f13 * f133));
   f135 = Math_fround(f135 + Math_fround(f14 * f133));
   f132 = Math_fround(f132 + Math_fround(f17 * f133));
   f3 = Math_fround(HEAPF32[i48 >> 2]);
   f34 = Math_fround(Math_fround(Math_fround(f19 * f124) + Math_fround(f20 * f125)) + Math_fround(f18 * f126));
   f5 = f33;
   f33 = Math_fround(Math_fround(Math_fround(f23 * f124) + Math_fround(f24 * f125)) + Math_fround(f12 * f126));
   f6 = f30;
   f30 = Math_fround(Math_fround(Math_fround(f27 * f124) + Math_fround(f28 * f125)) + Math_fround(f8 * f126));
   f9 = f29;
   f29 = Math_fround(Math_fround(Math_fround(f19 * f139) + Math_fround(f20 * f138)) + Math_fround(f18 * f22));
   f10 = f26;
   f26 = Math_fround(Math_fround(Math_fround(f4 * f139) + Math_fround(f31 * f138)) + Math_fround(f32 * f22));
   f13 = f25;
   f25 = Math_fround(Math_fround(Math_fround(f23 * f139) + Math_fround(f24 * f138)) + Math_fround(f12 * f22));
   f14 = f140;
   f22 = Math_fround(Math_fround(Math_fround(f27 * f139) + Math_fround(f28 * f138)) + Math_fround(f8 * f22));
   f18 = Math_fround(Math_fround(Math_fround(f19 * f134) + Math_fround(f20 * f133)) + Math_fround(f18 * f3));
   f16 = Math_fround(f137 + Math_fround(f16 * f3));
   f17 = Math_fround(Math_fround(Math_fround(f4 * f134) + Math_fround(f31 * f133)) + Math_fround(f32 * f3));
   f15 = Math_fround(f136 + Math_fround(f15 * f3));
   f12 = Math_fround(Math_fround(Math_fround(f23 * f134) + Math_fround(f24 * f133)) + Math_fround(f12 * f3));
   f11 = Math_fround(f135 + Math_fround(f11 * f3));
   f8 = Math_fround(Math_fround(Math_fround(f27 * f134) + Math_fround(f28 * f133)) + Math_fround(f8 * f3));
   f7 = Math_fround(f132 + Math_fround(f7 * f3));
   f4 = Math_fround(Math_fround(Math_fround(f4 * f124) + Math_fround(f31 * f125)) + Math_fround(f32 * f126));
   f3 = f127;
  } else {
   f34 = f19;
   f33 = f23;
   f30 = f27;
   f29 = f20;
   f26 = f31;
   f25 = f24;
   f22 = f28;
   f21 = f17;
   f17 = f32;
  }
  i131 = (HEAP32[i91 >> 2] | 0) + (i1 << 2) | 0;
  f140 = Math_fround(HEAPF32[i131 >> 2]);
  i130 = i131 + 4 | 0;
  f139 = Math_fround(HEAPF32[i130 >> 2]);
  i129 = i131 + 8 | 0;
  f138 = Math_fround(HEAPF32[i129 >> 2]);
  i128 = i131 + 12 | 0;
  f137 = Math_fround(HEAPF32[i128 >> 2]);
  i141 = (HEAP32[i49 >> 2] | 0) + (i1 << 2) | 0;
  f136 = Math_fround(HEAPF32[i141 >> 2]);
  i142 = i141 + 4 | 0;
  f135 = Math_fround(HEAPF32[i142 >> 2]);
  i143 = i141 + 8 | 0;
  f134 = Math_fround(HEAPF32[i143 >> 2]);
  i144 = i141 + 12 | 0;
  f133 = Math_fround(HEAPF32[i144 >> 2]);
  i145 = (HEAP32[i50 >> 2] | 0) + (i1 << 2) | 0;
  f132 = Math_fround(HEAPF32[i145 >> 2]);
  i146 = i145 + 4 | 0;
  f127 = Math_fround(HEAPF32[i146 >> 2]);
  i147 = i145 + 8 | 0;
  f126 = Math_fround(HEAPF32[i147 >> 2]);
  i148 = i145 + 12 | 0;
  f139 = Math_fround(f3 + f139);
  f138 = Math_fround(f6 + f138);
  f137 = Math_fround(f9 + f137);
  f136 = Math_fround(f10 + f136);
  f135 = Math_fround(f13 + f135);
  f134 = Math_fround(f14 + f134);
  f133 = Math_fround(f21 + f133);
  f132 = Math_fround(f16 + f132);
  f127 = Math_fround(f15 + f127);
  f126 = Math_fround(f11 + f126);
  f125 = Math_fround(f7 + Math_fround(HEAPF32[i148 >> 2]));
  HEAPF32[i131 >> 2] = Math_fround(f5 + f140);
  HEAPF32[i130 >> 2] = f139;
  HEAPF32[i129 >> 2] = f138;
  HEAPF32[i128 >> 2] = f137;
  HEAPF32[i141 >> 2] = f136;
  HEAPF32[i142 >> 2] = f135;
  HEAPF32[i143 >> 2] = f134;
  HEAPF32[i144 >> 2] = f133;
  HEAPF32[i145 >> 2] = f132;
  HEAPF32[i146 >> 2] = f127;
  HEAPF32[i147 >> 2] = f126;
  HEAPF32[i148 >> 2] = f125;
  i148 = (HEAP32[i51 >> 2] | 0) + (i1 << 2) | 0;
  f125 = Math_fround(HEAPF32[i148 >> 2]);
  i147 = i148 + 4 | 0;
  f126 = Math_fround(HEAPF32[i147 >> 2]);
  i146 = i148 + 8 | 0;
  f127 = Math_fround(HEAPF32[i146 >> 2]);
  i145 = i148 + 12 | 0;
  f132 = Math_fround(HEAPF32[i145 >> 2]);
  i144 = (HEAP32[i52 >> 2] | 0) + (i1 << 2) | 0;
  f133 = Math_fround(HEAPF32[i144 >> 2]);
  i143 = i144 + 4 | 0;
  f134 = Math_fround(HEAPF32[i143 >> 2]);
  i142 = i144 + 8 | 0;
  f135 = Math_fround(HEAPF32[i142 >> 2]);
  i141 = i144 + 12 | 0;
  f136 = Math_fround(HEAPF32[i141 >> 2]);
  i128 = (HEAP32[i53 >> 2] | 0) + (i1 << 2) | 0;
  f137 = Math_fround(HEAPF32[i128 >> 2]);
  i129 = i128 + 4 | 0;
  f138 = Math_fround(HEAPF32[i129 >> 2]);
  i130 = i128 + 8 | 0;
  f139 = Math_fround(HEAPF32[i130 >> 2]);
  i131 = i128 + 12 | 0;
  f126 = Math_fround(f4 + f126);
  f127 = Math_fround(f33 + f127);
  f132 = Math_fround(f30 + f132);
  f133 = Math_fround(f29 + f133);
  f134 = Math_fround(f26 + f134);
  f135 = Math_fround(f25 + f135);
  f136 = Math_fround(f22 + f136);
  f137 = Math_fround(f18 + f137);
  f138 = Math_fround(f17 + f138);
  f139 = Math_fround(f12 + f139);
  f140 = Math_fround(f8 + Math_fround(HEAPF32[i131 >> 2]));
  HEAPF32[i148 >> 2] = Math_fround(f34 + f125);
  HEAPF32[i147 >> 2] = f126;
  HEAPF32[i146 >> 2] = f127;
  HEAPF32[i145 >> 2] = f132;
  HEAPF32[i144 >> 2] = f133;
  HEAPF32[i143 >> 2] = f134;
  HEAPF32[i142 >> 2] = f135;
  HEAPF32[i141 >> 2] = f136;
  HEAPF32[i128 >> 2] = f137;
  HEAPF32[i129 >> 2] = f138;
  HEAPF32[i130 >> 2] = f139;
  HEAPF32[i131 >> 2] = f140;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i82 >>> 0);
 STACKTOP = i123;
 return;
}

function __ZN6Camera8TransferI14SafeBinaryReadEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 4 | 0;
 i5 = i12;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i9, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i4 = i9 + 844 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381067 | 0, HEAP32[gb + 37304 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i7 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 848 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381080 | 0, HEAP32[gb + 36980 >> 2] | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 864 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373323 | 0, HEAP32[gb + 37212 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1085989 | 0, i5, i10, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i11 + 16 | 0;
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 25; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 25; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i4 = i9 + 868 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1085998 | 0, i5, i10, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i2 = i11 + 16 | 0;
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     i3 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i2 >> 2] = i3;
     if (i3 >>> 0 < i7 >>> 0) i8 = 36; else {
      i1 = i3 + 4 | 0;
      if (i1 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 36; else {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i2 >> 2] = i1;
      }
     }
     if ((i8 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
     if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i4 = i9 + 872 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034504 | 0, i5, i10, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i11 + 16 | 0;
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 47; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 47; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i4 = i9 + 876 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034510 | 0, i5, i10, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i11 + 16 | 0;
     i7 = HEAP32[i11 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 58; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 58; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 920 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373348 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 73; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 73; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 73) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 924 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373364 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 84; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 84; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373379 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 95; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 95; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 1088 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373393 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 916 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373406 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 115; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 115; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 115) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 888 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 853473 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 126; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 126; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 126) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i11, i9 + 880 | 0, gb + 381098 | 0, 0);
 i4 = i9 + 928 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373424 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 137; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 137; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 137) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 744 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373440 | 0, gb + 373456 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI13RenderTextureE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 820 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1011529 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 154; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 154; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 154) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TargetEyeMaskEvRT_RT0_PKc17TransferMetaFlags(i11, i9 + 824 | 0, gb + 373476 | 0, 0);
 i3 = i9 + 1091 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381150 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 1089 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373488 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 1100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373507 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i8 = 183; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i8 = 183;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 183) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 1096 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373527 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i8 = 194; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i8 = 194;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 194) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 1112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 373546 | 0, i6, i10, 0) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 L274 : do if ((i1 | 0) > 0) {
  i1 = i11 + 16 | 0;
  i10 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i10 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L274;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb(i34, i35, i45, i56, i67) {
 i34 = i34 | 0;
 i35 = i35 | 0;
 i45 = i45 | 0;
 i56 = i56 | 0;
 i67 = i67 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0, f137 = f0, f138 = f0, f139 = f0, f140 = f0, i141 = 0, i142 = 0, i143 = 0, i144 = 0, i145 = 0, i146 = 0, i147 = 0, i148 = 0;
 i123 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i123 + 80 | 0;
 i89 = i123 + 64 | 0;
 i100 = i123 + 16 | 0;
 i111 = i123;
 i36 = HEAP32[i45 + 12 >> 2] | 0;
 if (!i36) {
  STACKTOP = i123;
  return;
 }
 i37 = i45 + 500 | 0;
 i38 = i78 + 4 | 0;
 i39 = i78 + 8 | 0;
 i40 = i78 + 12 | 0;
 i41 = i45 + 520 | 0;
 i42 = i111 + 4 | 0;
 i43 = i111 + 8 | 0;
 i44 = i111 + 12 | 0;
 i46 = i45 + 540 | 0;
 i47 = i34 + 40 | 0;
 i48 = i89 + 4 | 0;
 i49 = i78 + 4 | 0;
 i50 = i89 + 8 | 0;
 i51 = i78 + 8 | 0;
 i52 = i89 + 12 | 0;
 i53 = i78 + 12 | 0;
 i54 = i100 + 4 | 0;
 i55 = i100 + 8 | 0;
 i57 = i100 + 12 | 0;
 i58 = i34 + 120 | 0;
 i59 = i34 + 80 | 0;
 i60 = i89 + 4 | 0;
 i61 = i78 + 4 | 0;
 i62 = i89 + 8 | 0;
 i63 = i78 + 8 | 0;
 i64 = i89 + 12 | 0;
 i65 = i78 + 12 | 0;
 i66 = i100 + 16 | 0;
 i68 = i100 + 20 | 0;
 i69 = i100 + 24 | 0;
 i70 = i100 + 28 | 0;
 i71 = i34 + 200 | 0;
 i72 = i34 + 160 | 0;
 i73 = i89 + 4 | 0;
 i74 = i78 + 4 | 0;
 i75 = i89 + 8 | 0;
 i76 = i78 + 8 | 0;
 i77 = i89 + 12 | 0;
 i79 = i78 + 12 | 0;
 i80 = i100 + 32 | 0;
 i81 = i100 + 36 | 0;
 i82 = i100 + 40 | 0;
 i83 = i100 + 44 | 0;
 i84 = i35 + 40 | 0;
 i85 = i89 + 4 | 0;
 i86 = i78 + 4 | 0;
 i87 = i89 + 8 | 0;
 i88 = i78 + 8 | 0;
 i90 = i89 + 12 | 0;
 i91 = i78 + 12 | 0;
 i92 = i35 + 120 | 0;
 i93 = i35 + 80 | 0;
 i94 = i89 + 4 | 0;
 i95 = i78 + 4 | 0;
 i96 = i89 + 8 | 0;
 i97 = i78 + 8 | 0;
 i98 = i89 + 12 | 0;
 i99 = i78 + 12 | 0;
 i101 = i35 + 200 | 0;
 i102 = i35 + 160 | 0;
 i103 = i89 + 4 | 0;
 i104 = i78 + 4 | 0;
 i105 = i89 + 8 | 0;
 i106 = i78 + 8 | 0;
 i107 = i89 + 12 | 0;
 i108 = i78 + 12 | 0;
 i109 = i56 + 12 | 0;
 i110 = i56 + 24 | 0;
 i112 = i56 + 4 | 0;
 i113 = i56 + 16 | 0;
 i114 = i56 + 28 | 0;
 i115 = i56 + 8 | 0;
 i116 = i56 + 20 | 0;
 i117 = i56 + 32 | 0;
 i118 = i45 + 20 | 0;
 i119 = i45 + 40 | 0;
 i120 = i45 + 60 | 0;
 i121 = i45 + 80 | 0;
 i122 = i45 + 100 | 0;
 i32 = 0;
 do {
  i131 = (HEAP32[i37 >> 2] | 0) + (i32 << 2) | 0;
  i130 = (HEAP32[i131 + 4 >> 2] | 0) + 306581307 | 0;
  i129 = (HEAP32[i131 + 8 >> 2] | 0) + 306581307 | 0;
  i128 = (HEAP32[i131 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i78 >> 2] = (HEAP32[i131 >> 2] | 0) + 306581307;
  HEAP32[i38 >> 2] = i130;
  HEAP32[i39 >> 2] = i129;
  HEAP32[i40 >> 2] = i128;
  __Z17GenerateRandomNx3RKN4math5_int4E(i100, i78);
  i128 = (HEAP32[i41 >> 2] | 0) + (i32 << 2) | 0;
  f31 = Math_fround(HEAPF32[i128 >> 2]);
  f27 = Math_fround(HEAPF32[i128 + 4 >> 2]);
  f23 = Math_fround(HEAPF32[i128 + 8 >> 2]);
  f27 = Math_fround(f27 * Math_fround(.00999999977));
  f23 = Math_fround(f23 * Math_fround(.00999999977));
  f19 = Math_fround(Math_fround(HEAPF32[i128 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i111 >> 2] = Math_fround(f31 * Math_fround(.00999999977));
  HEAPF32[i42 >> 2] = f27;
  HEAPF32[i43 >> 2] = f23;
  HEAPF32[i44 >> 2] = f19;
  i128 = (HEAP32[i46 >> 2] | 0) + (i32 << 2) | 0;
  f19 = Math_fround(HEAPF32[i128 >> 2]);
  f23 = Math_fround(HEAPF32[i128 + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i128 + 8 >> 2]);
  f19 = Math_fround(Math_fround(1.0) / f19);
  f23 = Math_fround(Math_fround(1.0) / f23);
  f27 = Math_fround(Math_fround(1.0) / f27);
  f31 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i128 + 12 >> 2]));
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i78, i47, i111);
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i89, i34, i111);
  f3 = Math_fround(HEAPF32[i89 >> 2]);
  f13 = Math_fround(HEAPF32[i78 >> 2]);
  f3 = Math_fround(f3 - f13);
  f1 = Math_fround(HEAPF32[i48 >> 2]);
  f11 = Math_fround(HEAPF32[i49 >> 2]);
  f1 = Math_fround(f1 - f11);
  f4 = Math_fround(HEAPF32[i50 >> 2]);
  f2 = Math_fround(HEAPF32[i51 >> 2]);
  f4 = Math_fround(f4 - f2);
  f7 = Math_fround(HEAPF32[i52 >> 2]);
  f8 = Math_fround(HEAPF32[i53 >> 2]);
  f7 = Math_fround(f7 - f8);
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i100 >> 2]));
  f1 = Math_fround(f1 * Math_fround(HEAPF32[i54 >> 2]));
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i55 >> 2]));
  f3 = Math_fround(f13 + f3);
  f1 = Math_fround(f11 + f1);
  f4 = Math_fround(f2 + f4);
  f7 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i57 >> 2])));
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i78, i58, i111);
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i89, i59, i111);
  f8 = Math_fround(HEAPF32[i89 >> 2]);
  f2 = Math_fround(HEAPF32[i78 >> 2]);
  f8 = Math_fround(f8 - f2);
  f11 = Math_fround(HEAPF32[i60 >> 2]);
  f13 = Math_fround(HEAPF32[i61 >> 2]);
  f11 = Math_fround(f11 - f13);
  f12 = Math_fround(HEAPF32[i62 >> 2]);
  f29 = Math_fround(HEAPF32[i63 >> 2]);
  f12 = Math_fround(f12 - f29);
  f15 = Math_fround(HEAPF32[i64 >> 2]);
  f14 = Math_fround(HEAPF32[i65 >> 2]);
  f15 = Math_fround(f15 - f14);
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i66 >> 2]));
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i68 >> 2]));
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i69 >> 2]));
  f8 = Math_fround(f2 + f8);
  f11 = Math_fround(f13 + f11);
  f12 = Math_fround(f29 + f12);
  f15 = Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i70 >> 2])));
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i78, i71, i111);
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i89, i72, i111);
  f14 = Math_fround(HEAPF32[i89 >> 2]);
  f29 = Math_fround(HEAPF32[i78 >> 2]);
  f14 = Math_fround(f14 - f29);
  f13 = Math_fround(HEAPF32[i73 >> 2]);
  f2 = Math_fround(HEAPF32[i74 >> 2]);
  f13 = Math_fround(f13 - f2);
  f9 = Math_fround(HEAPF32[i75 >> 2]);
  f30 = Math_fround(HEAPF32[i76 >> 2]);
  f9 = Math_fround(f9 - f30);
  f5 = Math_fround(HEAPF32[i77 >> 2]);
  f17 = Math_fround(HEAPF32[i79 >> 2]);
  f5 = Math_fround(f5 - f17);
  f14 = Math_fround(f14 * Math_fround(HEAPF32[i80 >> 2]));
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i81 >> 2]));
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i82 >> 2]));
  f14 = Math_fround(f29 + f14);
  f13 = Math_fround(f2 + f13);
  f9 = Math_fround(f30 + f9);
  f5 = Math_fround(f17 + Math_fround(f5 * Math_fround(HEAPF32[i83 >> 2])));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i78, i84, i111);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i89, i35, i111);
  f17 = Math_fround(HEAPF32[i89 >> 2]);
  f30 = Math_fround(HEAPF32[i78 >> 2]);
  f17 = Math_fround(f17 - f30);
  f2 = Math_fround(HEAPF32[i85 >> 2]);
  f29 = Math_fround(HEAPF32[i86 >> 2]);
  f2 = Math_fround(f2 - f29);
  f21 = Math_fround(HEAPF32[i87 >> 2]);
  f24 = Math_fround(HEAPF32[i88 >> 2]);
  f21 = Math_fround(f21 - f24);
  f25 = Math_fround(HEAPF32[i90 >> 2]);
  f18 = Math_fround(HEAPF32[i91 >> 2]);
  f25 = Math_fround(f25 - f18);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i100 >> 2]));
  f2 = Math_fround(f2 * Math_fround(HEAPF32[i54 >> 2]));
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i55 >> 2]));
  f17 = Math_fround(f30 + f17);
  f2 = Math_fround(f29 + f2);
  f21 = Math_fround(f24 + f21);
  f25 = Math_fround(f18 + Math_fround(f25 * Math_fround(HEAPF32[i57 >> 2])));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i78, i92, i111);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i89, i93, i111);
  f18 = Math_fround(HEAPF32[i89 >> 2]);
  f24 = Math_fround(HEAPF32[i78 >> 2]);
  f18 = Math_fround(f18 - f24);
  f29 = Math_fround(HEAPF32[i94 >> 2]);
  f30 = Math_fround(HEAPF32[i95 >> 2]);
  f29 = Math_fround(f29 - f30);
  f22 = Math_fround(HEAPF32[i96 >> 2]);
  f20 = Math_fround(HEAPF32[i97 >> 2]);
  f22 = Math_fround(f22 - f20);
  f26 = Math_fround(HEAPF32[i98 >> 2]);
  f16 = Math_fround(HEAPF32[i99 >> 2]);
  f26 = Math_fround(f26 - f16);
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i66 >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i68 >> 2]));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i69 >> 2]));
  f18 = Math_fround(f24 + f18);
  f29 = Math_fround(f30 + f29);
  f22 = Math_fround(f20 + f22);
  f26 = Math_fround(f16 + Math_fround(f26 * Math_fround(HEAPF32[i70 >> 2])));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i78, i101, i111);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i89, i102, i111);
  f16 = Math_fround(HEAPF32[i89 >> 2]);
  f20 = Math_fround(HEAPF32[i78 >> 2]);
  f16 = Math_fround(f16 - f20);
  f30 = Math_fround(HEAPF32[i103 >> 2]);
  f24 = Math_fround(HEAPF32[i104 >> 2]);
  f30 = Math_fround(f30 - f24);
  f10 = Math_fround(HEAPF32[i105 >> 2]);
  f28 = Math_fround(HEAPF32[i106 >> 2]);
  f10 = Math_fround(f10 - f28);
  f6 = Math_fround(HEAPF32[i107 >> 2]);
  f33 = Math_fround(HEAPF32[i108 >> 2]);
  f6 = Math_fround(f6 - f33);
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i80 >> 2]));
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i81 >> 2]));
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i82 >> 2]));
  f127 = Math_fround(f19 * f19);
  f126 = Math_fround(f23 * f23);
  f125 = Math_fround(f27 * f27);
  f124 = Math_fround(f31 * f31);
  f3 = Math_fround(f127 * f3);
  f1 = Math_fround(f126 * f1);
  f4 = Math_fround(f125 * f4);
  f7 = Math_fround(f124 * f7);
  f8 = Math_fround(f127 * f8);
  f11 = Math_fround(f126 * f11);
  f12 = Math_fround(f125 * f12);
  f15 = Math_fround(f124 * f15);
  f14 = Math_fround(f127 * f14);
  f13 = Math_fround(f126 * f13);
  f9 = Math_fround(f125 * f9);
  f5 = Math_fround(f124 * f5);
  f17 = Math_fround(f19 * f17);
  f2 = Math_fround(f23 * f2);
  f21 = Math_fround(f27 * f21);
  f25 = Math_fround(f31 * f25);
  f18 = Math_fround(f19 * f18);
  f29 = Math_fround(f23 * f29);
  f22 = Math_fround(f27 * f22);
  f26 = Math_fround(f31 * f26);
  f16 = Math_fround(f19 * Math_fround(f20 + f16));
  f30 = Math_fround(f23 * Math_fround(f24 + f30));
  f10 = Math_fround(f27 * Math_fround(f28 + f10));
  f6 = Math_fround(f31 * Math_fround(f33 + Math_fround(f6 * Math_fround(HEAPF32[i83 >> 2]))));
  if (i67) {
   f124 = Math_fround(HEAPF32[i56 >> 2]);
   f31 = Math_fround(f3 * f124);
   f127 = Math_fround(f1 * f124);
   f28 = Math_fround(f4 * f124);
   f27 = Math_fround(f7 * f124);
   f125 = Math_fround(HEAPF32[i109 >> 2]);
   f31 = Math_fround(f31 + Math_fround(f8 * f125));
   f127 = Math_fround(f127 + Math_fround(f11 * f125));
   f28 = Math_fround(f28 + Math_fround(f12 * f125));
   f27 = Math_fround(f27 + Math_fround(f15 * f125));
   f126 = Math_fround(HEAPF32[i110 >> 2]);
   f31 = Math_fround(f31 + Math_fround(f14 * f126));
   f127 = Math_fround(f127 + Math_fround(f13 * f126));
   f28 = Math_fround(f28 + Math_fround(f9 * f126));
   f27 = Math_fround(f27 + Math_fround(f5 * f126));
   f139 = Math_fround(HEAPF32[i112 >> 2]);
   f24 = Math_fround(f3 * f139);
   f23 = Math_fround(f1 * f139);
   f140 = Math_fround(f4 * f139);
   f19 = Math_fround(f7 * f139);
   f138 = Math_fround(HEAPF32[i113 >> 2]);
   f24 = Math_fround(f24 + Math_fround(f8 * f138));
   f23 = Math_fround(f23 + Math_fround(f11 * f138));
   f140 = Math_fround(f140 + Math_fround(f12 * f138));
   f19 = Math_fround(f19 + Math_fround(f15 * f138));
   f20 = Math_fround(HEAPF32[i114 >> 2]);
   f24 = Math_fround(f24 + Math_fround(f14 * f20));
   f23 = Math_fround(f23 + Math_fround(f13 * f20));
   f140 = Math_fround(f140 + Math_fround(f9 * f20));
   f19 = Math_fround(f19 + Math_fround(f5 * f20));
   f134 = Math_fround(HEAPF32[i115 >> 2]);
   f137 = Math_fround(f3 * f134);
   f136 = Math_fround(f1 * f134);
   f135 = Math_fround(f4 * f134);
   f132 = Math_fround(f7 * f134);
   f133 = Math_fround(HEAPF32[i116 >> 2]);
   f137 = Math_fround(f137 + Math_fround(f8 * f133));
   f136 = Math_fround(f136 + Math_fround(f11 * f133));
   f135 = Math_fround(f135 + Math_fround(f12 * f133));
   f132 = Math_fround(f132 + Math_fround(f15 * f133));
   f1 = Math_fround(HEAPF32[i117 >> 2]);
   f33 = Math_fround(Math_fround(Math_fround(f17 * f124) + Math_fround(f18 * f125)) + Math_fround(f16 * f126));
   f3 = f31;
   f31 = Math_fround(Math_fround(Math_fround(f21 * f124) + Math_fround(f22 * f125)) + Math_fround(f10 * f126));
   f4 = f28;
   f28 = Math_fround(Math_fround(Math_fround(f25 * f124) + Math_fround(f26 * f125)) + Math_fround(f6 * f126));
   f7 = f27;
   f27 = Math_fround(Math_fround(Math_fround(f17 * f139) + Math_fround(f18 * f138)) + Math_fround(f16 * f20));
   f8 = f24;
   f24 = Math_fround(Math_fround(Math_fround(f2 * f139) + Math_fround(f29 * f138)) + Math_fround(f30 * f20));
   f11 = f23;
   f23 = Math_fround(Math_fround(Math_fround(f21 * f139) + Math_fround(f22 * f138)) + Math_fround(f10 * f20));
   f12 = f140;
   f20 = Math_fround(Math_fround(Math_fround(f25 * f139) + Math_fround(f26 * f138)) + Math_fround(f6 * f20));
   f16 = Math_fround(Math_fround(Math_fround(f17 * f134) + Math_fround(f18 * f133)) + Math_fround(f16 * f1));
   f14 = Math_fround(f137 + Math_fround(f14 * f1));
   f15 = Math_fround(Math_fround(Math_fround(f2 * f134) + Math_fround(f29 * f133)) + Math_fround(f30 * f1));
   f13 = Math_fround(f136 + Math_fround(f13 * f1));
   f10 = Math_fround(Math_fround(Math_fround(f21 * f134) + Math_fround(f22 * f133)) + Math_fround(f10 * f1));
   f9 = Math_fround(f135 + Math_fround(f9 * f1));
   f6 = Math_fround(Math_fround(Math_fround(f25 * f134) + Math_fround(f26 * f133)) + Math_fround(f6 * f1));
   f5 = Math_fround(f132 + Math_fround(f5 * f1));
   f2 = Math_fround(Math_fround(Math_fround(f2 * f124) + Math_fround(f29 * f125)) + Math_fround(f30 * f126));
   f1 = f127;
  } else {
   f33 = f17;
   f31 = f21;
   f28 = f25;
   f27 = f18;
   f24 = f29;
   f23 = f22;
   f20 = f26;
   f19 = f15;
   f15 = f30;
  }
  i131 = (HEAP32[i45 >> 2] | 0) + (i32 << 2) | 0;
  f140 = Math_fround(HEAPF32[i131 >> 2]);
  i130 = i131 + 4 | 0;
  f139 = Math_fround(HEAPF32[i130 >> 2]);
  i129 = i131 + 8 | 0;
  f138 = Math_fround(HEAPF32[i129 >> 2]);
  i128 = i131 + 12 | 0;
  f137 = Math_fround(HEAPF32[i128 >> 2]);
  i141 = (HEAP32[i118 >> 2] | 0) + (i32 << 2) | 0;
  f136 = Math_fround(HEAPF32[i141 >> 2]);
  i142 = i141 + 4 | 0;
  f135 = Math_fround(HEAPF32[i142 >> 2]);
  i143 = i141 + 8 | 0;
  f134 = Math_fround(HEAPF32[i143 >> 2]);
  i144 = i141 + 12 | 0;
  f133 = Math_fround(HEAPF32[i144 >> 2]);
  i145 = (HEAP32[i119 >> 2] | 0) + (i32 << 2) | 0;
  f132 = Math_fround(HEAPF32[i145 >> 2]);
  i146 = i145 + 4 | 0;
  f127 = Math_fround(HEAPF32[i146 >> 2]);
  i147 = i145 + 8 | 0;
  f126 = Math_fround(HEAPF32[i147 >> 2]);
  i148 = i145 + 12 | 0;
  f139 = Math_fround(f1 + f139);
  f138 = Math_fround(f4 + f138);
  f137 = Math_fround(f7 + f137);
  f136 = Math_fround(f8 + f136);
  f135 = Math_fround(f11 + f135);
  f134 = Math_fround(f12 + f134);
  f133 = Math_fround(f19 + f133);
  f132 = Math_fround(f14 + f132);
  f127 = Math_fround(f13 + f127);
  f126 = Math_fround(f9 + f126);
  f125 = Math_fround(f5 + Math_fround(HEAPF32[i148 >> 2]));
  HEAPF32[i131 >> 2] = Math_fround(f3 + f140);
  HEAPF32[i130 >> 2] = f139;
  HEAPF32[i129 >> 2] = f138;
  HEAPF32[i128 >> 2] = f137;
  HEAPF32[i141 >> 2] = f136;
  HEAPF32[i142 >> 2] = f135;
  HEAPF32[i143 >> 2] = f134;
  HEAPF32[i144 >> 2] = f133;
  HEAPF32[i145 >> 2] = f132;
  HEAPF32[i146 >> 2] = f127;
  HEAPF32[i147 >> 2] = f126;
  HEAPF32[i148 >> 2] = f125;
  i148 = (HEAP32[i120 >> 2] | 0) + (i32 << 2) | 0;
  f125 = Math_fround(HEAPF32[i148 >> 2]);
  i147 = i148 + 4 | 0;
  f126 = Math_fround(HEAPF32[i147 >> 2]);
  i146 = i148 + 8 | 0;
  f127 = Math_fround(HEAPF32[i146 >> 2]);
  i145 = i148 + 12 | 0;
  f132 = Math_fround(HEAPF32[i145 >> 2]);
  i144 = (HEAP32[i121 >> 2] | 0) + (i32 << 2) | 0;
  f133 = Math_fround(HEAPF32[i144 >> 2]);
  i143 = i144 + 4 | 0;
  f134 = Math_fround(HEAPF32[i143 >> 2]);
  i142 = i144 + 8 | 0;
  f135 = Math_fround(HEAPF32[i142 >> 2]);
  i141 = i144 + 12 | 0;
  f136 = Math_fround(HEAPF32[i141 >> 2]);
  i128 = (HEAP32[i122 >> 2] | 0) + (i32 << 2) | 0;
  f137 = Math_fround(HEAPF32[i128 >> 2]);
  i129 = i128 + 4 | 0;
  f138 = Math_fround(HEAPF32[i129 >> 2]);
  i130 = i128 + 8 | 0;
  f139 = Math_fround(HEAPF32[i130 >> 2]);
  i131 = i128 + 12 | 0;
  f126 = Math_fround(f2 + f126);
  f127 = Math_fround(f31 + f127);
  f132 = Math_fround(f28 + f132);
  f133 = Math_fround(f27 + f133);
  f134 = Math_fround(f24 + f134);
  f135 = Math_fround(f23 + f135);
  f136 = Math_fround(f20 + f136);
  f137 = Math_fround(f16 + f137);
  f138 = Math_fround(f15 + f138);
  f139 = Math_fround(f10 + f139);
  f140 = Math_fround(f6 + Math_fround(HEAPF32[i131 >> 2]));
  HEAPF32[i148 >> 2] = Math_fround(f33 + f125);
  HEAPF32[i147 >> 2] = f126;
  HEAPF32[i146 >> 2] = f127;
  HEAPF32[i145 >> 2] = f132;
  HEAPF32[i144 >> 2] = f133;
  HEAPF32[i143 >> 2] = f134;
  HEAPF32[i142 >> 2] = f135;
  HEAPF32[i141 >> 2] = f136;
  HEAPF32[i128 >> 2] = f137;
  HEAPF32[i129 >> 2] = f138;
  HEAPF32[i130 >> 2] = f139;
  HEAPF32[i131 >> 2] = f140;
  i32 = i32 + 4 | 0;
 } while (i32 >>> 0 < i36 >>> 0);
 STACKTOP = i123;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i48, i50, i49, i1, i72, i73, i74, i75, i77, i79, i65) {
 i48 = i48 | 0;
 i50 = i50 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i72 = i72 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i77 = i77 | 0;
 i79 = i79 | 0;
 i65 = i65 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, f64 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i76 = 0, i78 = 0, i80 = 0, f81 = f0, f82 = f0, f83 = f0, f84 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i80 + 432 | 0;
 i51 = i80 + 416 | 0;
 i2 = i80 + 336 | 0;
 i59 = i80 + 548 | 0;
 i58 = i80 + 536 | 0;
 i70 = i80 + 352 | 0;
 i68 = i80 + 272 | 0;
 i69 = i80 + 208 | 0;
 i76 = i80 + 520 | 0;
 i78 = i80 + 504 | 0;
 i52 = i80 + 496 | 0;
 i71 = i80 + 192 | 0;
 i28 = i80 + 176 | 0;
 i26 = i80 + 160 | 0;
 i29 = i80 + 144 | 0;
 i27 = i80 + 128 | 0;
 i30 = i80 + 484 | 0;
 i31 = i80 + 112 | 0;
 i54 = i80 + 96 | 0;
 i53 = i80 + 80 | 0;
 i61 = i80 + 64 | 0;
 i62 = i80 + 48 | 0;
 i60 = i80 + 472 | 0;
 i46 = i80 + 32 | 0;
 i45 = i80 + 460 | 0;
 i56 = i80 + 16 | 0;
 i57 = i80;
 i55 = i80 + 448 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f66 = Math_fround(HEAPF32[i48 + 16 >> 2]);
 f67 = Math_fround(HEAPF32[i50 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f44 = Math_fround(HEAPF32[i48 + 32 >> 2]);
 f64 = Math_fround(HEAPF32[i50 + 32 >> 2]);
 f44 = Math_fround((f44 > f64 ? f64 : f44) * Math_fround(.100000001));
 f44 = Math_fround(f44 * f44);
 f64 = Math_fround(f66 + f67);
 HEAP32[i52 >> 2] = 0;
 if (!(HEAP8[i65 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i49 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i49 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i49 + 56 >> 2]);
  i43 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i43 ? f5 : Math_fround(1.0);
  f6 = i43 ? f6 : Math_fround(0.0);
  f7 = i43 ? f7 : Math_fround(0.0);
  HEAPF32[i71 >> 2] = f5;
  HEAPF32[i71 + 4 >> 2] = f6;
  HEAPF32[i71 + 8 >> 2] = f7;
  HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i31 >> 2] = HEAP32[i71 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
  i43 = i71;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i63 = 7;
 } else {
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i48 + 16 | 0;
  i2 = i49 + 48 | 0;
  i3 = i49 + 52 | 0;
  i8 = i49 + 56 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 8 | 0;
  i11 = i49 + 16 | 0;
  i12 = i49 + 32 | 0;
  i13 = i49 + 4 | 0;
  i14 = i49 + 20 | 0;
  i15 = i49 + 36 | 0;
  i16 = i49 + 8 | 0;
  i17 = i49 + 24 | 0;
  i18 = i49 + 40 | 0;
  i19 = i50 + 16 | 0;
  i20 = i29 + 4 | 0;
  i21 = i29 + 8 | 0;
  i22 = i28 + 4 | 0;
  i23 = i28 + 8 | 0;
  i24 = i28 + 12 | 0;
  i25 = 0;
  do {
   i42 = HEAPU8[i77 + i25 >> 0] | 0;
   HEAP32[i76 + (i25 << 2) >> 2] = i42;
   i43 = HEAPU8[i79 + i25 >> 0] | 0;
   HEAP32[i78 + (i25 << 2) >> 2] = i43;
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i26, i48, i42, i1);
   f81 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i3 >> 2]);
   f5 = Math_fround(HEAPF32[i8 >> 2]);
   f82 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(HEAPF32[i9 >> 2]);
   f33 = Math_fround(HEAPF32[i10 >> 2]);
   f7 = Math_fround(f82 * Math_fround(HEAPF32[i49 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f33 * Math_fround(HEAPF32[i12 >> 2])));
   f32 = Math_fround(f82 * Math_fround(HEAPF32[i13 >> 2]));
   f32 = Math_fround(f32 + Math_fround(f4 * Math_fround(HEAPF32[i14 >> 2])));
   f32 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i15 >> 2])));
   f82 = Math_fround(f82 * Math_fround(HEAPF32[i16 >> 2]));
   f4 = Math_fround(f82 + Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2])));
   f7 = Math_fround(f81 + f7);
   f32 = Math_fround(f6 + f32);
   f33 = Math_fround(f5 + Math_fround(f4 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2]))));
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i29, i50, i43, i19);
   f4 = Math_fround(HEAPF32[i29 >> 2]);
   f5 = Math_fround(HEAPF32[i20 >> 2]);
   f5 = Math_fround(f32 - f5);
   f6 = Math_fround(f33 - Math_fround(HEAPF32[i21 >> 2]));
   HEAPF32[i28 >> 2] = Math_fround(f7 - f4);
   HEAPF32[i22 >> 2] = f5;
   HEAPF32[i23 >> 2] = f6;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   i43 = HEAP32[i52 >> 2] | 0;
   HEAPF32[i68 + (i43 << 4) >> 2] = f7;
   HEAPF32[i68 + (i43 << 4) + 4 >> 2] = f32;
   HEAPF32[i68 + (i43 << 4) + 8 >> 2] = f33;
   HEAPF32[i68 + (i43 << 4) + 12 >> 2] = Math_fround(0.0);
   i42 = i69 + (i43 << 4) | 0;
   HEAP32[i42 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i42 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   HEAP32[i52 >> 2] = i43 + 1;
   i43 = i70 + (i43 << 4) | 0;
   HEAP32[i43 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i25 = i25 + 1 | 0;
  } while (i25 >>> 0 < (HEAPU8[i65 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i27, i70, i68, i69, i76, i78, i28, i52);
  HEAP32[i71 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i71 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i71 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i71 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i71 >> 2]);
  f6 = Math_fround(HEAPF32[i71 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i71 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i59 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i58 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i31 >> 2] = HEAP32[i71 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
  if (f4 > f44) {
   i43 = i71;
   i63 = 7;
  } else i2 = HEAP32[i52 >> 2] | 0;
 }
 do if ((i63 | 0) == 7) {
  i41 = i71 + 4 | 0;
  i42 = i71 + 8 | 0;
  i10 = i49 + 4 | 0;
  i11 = i49 + 8 | 0;
  i12 = i49 + 16 | 0;
  i13 = i49 + 20 | 0;
  i14 = i49 + 24 | 0;
  i15 = i49 + 32 | 0;
  i16 = i49 + 36 | 0;
  i17 = i49 + 40 | 0;
  i18 = i47 + 4 | 0;
  i19 = i47 + 8 | 0;
  i20 = i47 + 12 | 0;
  i21 = i49 + 48 | 0;
  i22 = i49 + 52 | 0;
  i23 = i49 + 56 | 0;
  i24 = i51 + 4 | 0;
  i25 = i51 + 8 | 0;
  i26 = i50 + 196 | 0;
  i27 = i50 + 200 | 0;
  i28 = i50 + 204 | 0;
  i29 = i50 + 16 | 0;
  i30 = i54 + 4 | 0;
  i35 = i54 + 8 | 0;
  i36 = i53 + 4 | 0;
  i37 = i53 + 8 | 0;
  i38 = i53 + 12 | 0;
  i39 = i48 + 48 | 0;
  i40 = i50 + 48 | 0;
  while (1) {
   HEAP32[i58 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i58 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i58 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i31 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   f82 = Math_fround(-f5);
   f83 = Math_fround(-f6);
   f5 = Math_fround(-f7);
   i9 = HEAP32[i52 >> 2] | 0;
   i8 = i68 + (i9 << 4) | 0;
   f81 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f82);
   f81 = Math_fround(f81 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f83));
   f81 = Math_fround(f81 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f5));
   f6 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f82);
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f83));
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f5));
   f82 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f82);
   f83 = Math_fround(f82 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f83));
   f5 = Math_fround(f83 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f5));
   HEAPF32[i47 >> 2] = f81;
   HEAPF32[i18 >> 2] = f6;
   HEAPF32[i19 >> 2] = f5;
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i51, i48, i47, i8, i76 + (i9 << 2) | 0);
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   f6 = Math_fround(HEAPF32[i22 >> 2]);
   f81 = Math_fround(HEAPF32[i23 >> 2]);
   f83 = Math_fround(HEAPF32[i51 >> 2]);
   f82 = Math_fround(HEAPF32[i24 >> 2]);
   f33 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(f83 * Math_fround(HEAPF32[i49 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f82 * Math_fround(HEAPF32[i12 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f33 * Math_fround(HEAPF32[i15 >> 2])));
   f32 = Math_fround(f83 * Math_fround(HEAPF32[i10 >> 2]));
   f32 = Math_fround(f32 + Math_fround(f82 * Math_fround(HEAPF32[i13 >> 2])));
   f32 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i16 >> 2])));
   f83 = Math_fround(f83 * Math_fround(HEAPF32[i11 >> 2]));
   f82 = Math_fround(f83 + Math_fround(f82 * Math_fround(HEAPF32[i14 >> 2])));
   f7 = Math_fround(f5 + f7);
   f32 = Math_fround(f6 + f32);
   f33 = Math_fround(f81 + Math_fround(f82 + Math_fround(f33 * Math_fround(HEAPF32[i17 >> 2]))));
   HEAPF32[i8 >> 2] = f7;
   HEAPF32[i68 + (i9 << 4) + 4 >> 2] = f32;
   HEAPF32[i68 + (i9 << 4) + 8 >> 2] = f33;
   HEAPF32[i68 + (i9 << 4) + 12 >> 2] = Math_fround(0.0);
   i9 = HEAP32[i52 >> 2] | 0;
   i8 = i69 + (i9 << 4) | 0;
   i9 = i78 + (i9 << 2) | 0;
   if (!(HEAP32[i26 >> 2] | 0)) {
    i1 = HEAP32[i27 >> 2] | 0;
    if ((HEAPU8[i28 >> 0] | 0) > 1) {
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i71 >> 2]));
     f83 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f83 = Math_fround(f6 + Math_fround(f83 * Math_fround(HEAPF32[i41 >> 2])));
     f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f6 = Math_fround(f83 + Math_fround(f6 * Math_fround(HEAPF32[i42 >> 2])));
     i2 = 1;
     i1 = 0;
     while (1) {
      i3 = HEAP32[i27 >> 2] | 0;
      f84 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) >> 2]);
      f82 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2]);
      f81 = Math_fround(HEAPF32[i71 >> 2]);
      f83 = Math_fround(HEAPF32[i41 >> 2]);
      f5 = Math_fround(Math_fround(Math_fround(f84 * f81) + Math_fround(f82 * f83)) + Math_fround(f5 * Math_fround(HEAPF32[i42 >> 2])));
      i3 = f5 > f6;
      i1 = i3 ? i2 : i1;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i28 >> 0] | 0) >>> 0) f6 = i3 ? f5 : f6; else break;
     }
    } else i1 = 0;
   } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i50, i71) | 0;
   HEAP32[i9 >> 2] = i1;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i54, i50, i1, i29);
   HEAP32[i8 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
   f84 = Math_fround(HEAPF32[i54 >> 2]);
   f82 = Math_fround(HEAPF32[i30 >> 2]);
   f7 = Math_fround(f7 - f84);
   f82 = Math_fround(f32 - f82);
   f84 = Math_fround(f33 - Math_fround(HEAPF32[i35 >> 2]));
   HEAPF32[i53 >> 2] = f7;
   HEAPF32[i36 >> 2] = f82;
   HEAPF32[i37 >> 2] = f84;
   HEAPF32[i38 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i52 >> 2] | 0;
   i2 = i70 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
   f33 = Math_fround(HEAPF32[i39 >> 2]);
   f83 = Math_fround(HEAPF32[i40 >> 2]);
   f83 = f33 > f83 ? f33 : f83;
   f34 = f34 > f83 ? f34 : f83;
   f83 = Math_fround(f64 + f34);
   f83 = Math_fround(f4 * Math_fround(f83 * f83));
   f33 = Math_fround(HEAPF32[i71 >> 2]);
   f81 = Math_fround(HEAPF32[i41 >> 2]);
   f84 = Math_fround(Math_fround(Math_fround(f33 * f7) + Math_fround(f81 * f82)) + Math_fround(Math_fround(HEAPF32[i42 >> 2]) * f84));
   i2 = f84 > Math_fround(0.0) & Math_fround(f84 * f84) > f83;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f84) | i2) {
    i63 = 14;
    break;
   }
   HEAP32[i52 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i46, i70, i68, i69, i76, i78, i53, i52);
   HEAP32[i43 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i71 >> 2]);
   f6 = Math_fround(HEAPF32[i41 >> 2]);
   f7 = Math_fround(HEAPF32[i42 >> 2]);
   f32 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i59 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i59 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i59 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
   i1 = f4 > f32;
   if (!(f32 > f44 & i1)) break; else f4 = f32;
  }
  if ((i63 | 0) == 14) {
   if (i77 | 0) {
    HEAP8[i65 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
      HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i79 = 0;
    STACKTOP = i80;
    return i79 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i70, i68, i69, i71, i61, i62, i3);
   f81 = Math_fround(Math_sqrt(Math_fround(f4)));
   f82 = Math_fround(HEAPF32[i71 >> 2]);
   f83 = Math_fround(HEAPF32[i41 >> 2]);
   f84 = Math_fround(Math_fround(1.0) / f81);
   f82 = Math_fround(f82 * f84);
   f83 = Math_fround(f83 * f84);
   f84 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) * f84);
   f33 = Math_fround(HEAPF32[i61 >> 2]);
   f44 = Math_fround(HEAPF32[i61 + 4 >> 2]);
   f44 = Math_fround(f44 - Math_fround(f66 * f83));
   f34 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) - Math_fround(f66 * f84));
   HEAPF32[i72 >> 2] = Math_fround(f33 - Math_fround(f66 * f82));
   HEAPF32[i72 + 4 >> 2] = f44;
   HEAPF32[i72 + 8 >> 2] = f34;
   HEAPF32[i72 + 12 >> 2] = Math_fround(0.0);
   f34 = Math_fround(HEAPF32[i62 >> 2]);
   f44 = Math_fround(HEAPF32[i62 + 4 >> 2]);
   f44 = Math_fround(Math_fround(f67 * f83) + f44);
   f66 = Math_fround(Math_fround(f67 * f84) + Math_fround(HEAPF32[i62 + 8 >> 2]));
   HEAPF32[i73 >> 2] = Math_fround(Math_fround(f67 * f82) + f34);
   HEAPF32[i73 + 4 >> 2] = f44;
   HEAPF32[i73 + 8 >> 2] = f66;
   HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i75 >> 2] = Math_fround(f81 - f64);
   i79 = i75 + 4 | 0;
   HEAP32[i79 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i79 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
   HEAP32[i79 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
   HEAPF32[i74 >> 2] = f82;
   HEAPF32[i74 + 4 >> 2] = f83;
   HEAPF32[i74 + 8 >> 2] = f84;
   HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
   i79 = 1;
   STACKTOP = i80;
   return i79 | 0;
  }
  i2 = HEAP32[i52 >> 2] | 0;
  if (i1) {
   if (!i77) i1 = 6; else break;
   STACKTOP = i80;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i77 | 0) {
   HEAP8[i65 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
     HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i43 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i70, i68, i69, i71, i56, i57, i2);
  HEAP32[i59 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  f81 = Math_fround(Math_sqrt(Math_fround(f4)));
  f82 = Math_fround(HEAPF32[i71 >> 2]);
  f83 = Math_fround(HEAPF32[i71 + 4 >> 2]);
  f84 = Math_fround(Math_fround(1.0) / f81);
  f82 = Math_fround(f82 * f84);
  f83 = Math_fround(f83 * f84);
  f84 = Math_fround(Math_fround(HEAPF32[i71 + 8 >> 2]) * f84);
  f33 = Math_fround(HEAPF32[i56 >> 2]);
  f44 = Math_fround(HEAPF32[i56 + 4 >> 2]);
  f44 = Math_fround(f44 - Math_fround(f66 * f83));
  f34 = Math_fround(Math_fround(HEAPF32[i56 + 8 >> 2]) - Math_fround(f66 * f84));
  HEAPF32[i72 >> 2] = Math_fround(f33 - Math_fround(f66 * f82));
  HEAPF32[i72 + 4 >> 2] = f44;
  HEAPF32[i72 + 8 >> 2] = f34;
  HEAPF32[i72 + 12 >> 2] = Math_fround(0.0);
  f34 = Math_fround(HEAPF32[i57 >> 2]);
  f44 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f44 = Math_fround(Math_fround(f67 * f83) + f44);
  f66 = Math_fround(Math_fround(f67 * f84) + Math_fround(HEAPF32[i57 + 8 >> 2]));
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(f67 * f82) + f34);
  HEAPF32[i73 + 4 >> 2] = f44;
  HEAPF32[i73 + 8 >> 2] = f66;
  HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i75 >> 2] = Math_fround(f81 - f64);
  i79 = i75 + 4 | 0;
  HEAP32[i79 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i79 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i79 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAPF32[i74 >> 2] = f82;
  HEAPF32[i74 + 4 >> 2] = f83;
  HEAPF32[i74 + 8 >> 2] = f84;
  HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
  i79 = 3;
  STACKTOP = i80;
  return i79 | 0;
 } while (0);
 HEAP8[i65 >> 0] = i2;
 if (!i2) {
  i79 = 6;
  STACKTOP = i80;
  return i79 | 0;
 } else i1 = 0;
 do {
  HEAP8[i77 + i1 >> 0] = HEAP32[i76 + (i1 << 2) >> 2];
  HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i80;
 return i1 | 0;
}

function __ZN10SpookyHash5FinalEPyS0_(i4, i27, i28) {
 i4 = i4 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (i1 >>> 0 < 192) {
  i26 = i4 + 192 | 0;
  i25 = HEAP32[i26 + 4 >> 2] | 0;
  i24 = i27;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i24 + 4 >> 2] = i25;
  i24 = i4 + 200 | 0;
  i25 = HEAP32[i24 + 4 >> 2] | 0;
  i26 = i28;
  HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i26 + 4 >> 2] = i25;
  __ZN10SpookyHash5ShortEPKvjPyS2_(i4, i1, i27, i28);
  return;
 }
 i1 = HEAP8[i4 + 292 >> 0] | 0;
 i7 = i4 + 192 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i4 + 200 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i16 = i4 + 208 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = i4 + 216 | 0;
 i18 = HEAP32[i20 >> 2] | 0;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 i24 = i4 + 224 | 0;
 i22 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 i25 = i4 + 232 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i25 = HEAP32[i25 + 4 >> 2] | 0;
 i21 = i4 + 240 | 0;
 i23 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 i17 = i4 + 248 | 0;
 i19 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i13 = i4 + 256 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i4 + 264 | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i4 + 272 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + 280 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 & 255) > 95) {
  i29 = i4;
  i29 = _i64Add(HEAP32[i29 >> 2] | 0, HEAP32[i29 + 4 >> 2] | 0, i5 | 0, i7 | 0) | 0;
  i33 = getTempRet0() | 0;
  i31 = i8 ^ i14;
  i30 = i6 ^ i16;
  i7 = _bitshift64Shl(i29 | 0, i33 | 0, 11) | 0;
  i5 = getTempRet0() | 0;
  i16 = _bitshift64Lshr(i29 | 0, i33 | 0, 53) | 0;
  i5 = getTempRet0() | 0 | i5;
  i3 = _i64Add(i29 ^ i3 | 0, i33 ^ i2 | 0, i9 | 0, i11 | 0) | 0;
  i2 = getTempRet0() | 0;
  i33 = i4 + 8 | 0;
  i11 = _i64Add(HEAP32[i33 >> 2] | 0, HEAP32[i33 + 4 >> 2] | 0, i9 | 0, i11 | 0) | 0;
  i33 = getTempRet0() | 0;
  i29 = i3 ^ i18;
  i14 = i2 ^ i20;
  i5 = _i64Add((i16 | i7) ^ i11 | 0, i5 ^ i33 | 0, i31 | 0, i30 | 0) | 0;
  i7 = getTempRet0() | 0;
  i9 = i4 + 16 | 0;
  i30 = _i64Add(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, i31 | 0, i30 | 0) | 0;
  i9 = getTempRet0() | 0;
  i31 = i5 ^ i22;
  i18 = i7 ^ i24;
  i24 = _bitshift64Shl(i30 | 0, i9 | 0, 43) | 0;
  i16 = getTempRet0() | 0;
  i32 = _bitshift64Lshr(i30 | 0, i9 | 0, 21) | 0;
  i16 = getTempRet0() | 0 | i16;
  i9 = _i64Add(i33 ^ i30 | 0, i11 ^ i9 | 0, i29 | 0, i14 | 0) | 0;
  i11 = getTempRet0() | 0;
  i30 = i4 + 24 | 0;
  i30 = _i64Add(i29 | 0, i14 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i14 = getTempRet0() | 0;
  i29 = i9 ^ i26;
  i22 = i11 ^ i25;
  i25 = _bitshift64Shl(i30 | 0, i14 | 0, 31) | 0;
  i20 = getTempRet0() | 0;
  i33 = _bitshift64Lshr(i30 | 0, i14 | 0, 33) | 0;
  i20 = getTempRet0() | 0 | i20;
  i14 = _i64Add((i32 | i24) ^ i30 | 0, i16 ^ i14 | 0, i31 | 0, i18 | 0) | 0;
  i16 = getTempRet0() | 0;
  i30 = i4 + 32 | 0;
  i30 = _i64Add(i31 | 0, i18 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i18 = getTempRet0() | 0;
  i31 = i14 ^ i23;
  i26 = i16 ^ i21;
  i21 = _bitshift64Shl(i30 | 0, i18 | 0, 17) | 0;
  i24 = getTempRet0() | 0;
  i32 = _bitshift64Lshr(i30 | 0, i18 | 0, 47) | 0;
  i24 = getTempRet0() | 0 | i24;
  i18 = _i64Add((i33 | i25) ^ i30 | 0, i20 ^ i18 | 0, i29 | 0, i22 | 0) | 0;
  i20 = getTempRet0() | 0;
  i30 = i4 + 40 | 0;
  i30 = _i64Add(i29 | 0, i22 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i22 = getTempRet0() | 0;
  i29 = i18 ^ i19;
  i23 = i20 ^ i17;
  i17 = _bitshift64Shl(i30 | 0, i22 | 0, 28) | 0;
  i25 = getTempRet0() | 0;
  i33 = _bitshift64Lshr(i30 | 0, i22 | 0, 36) | 0;
  i25 = getTempRet0() | 0 | i25;
  i22 = _i64Add((i32 | i21) ^ i30 | 0, i24 ^ i22 | 0, i31 | 0, i26 | 0) | 0;
  i24 = getTempRet0() | 0;
  i30 = i4 + 48 | 0;
  i30 = _i64Add(i31 | 0, i26 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i26 = getTempRet0() | 0;
  i31 = i22 ^ i15;
  i19 = i24 ^ i13;
  i13 = _bitshift64Shl(i30 | 0, i26 | 0, 39) | 0;
  i21 = getTempRet0() | 0;
  i32 = _bitshift64Lshr(i30 | 0, i26 | 0, 25) | 0;
  i21 = getTempRet0() | 0 | i21;
  i26 = _i64Add((i33 | i17) ^ i30 | 0, i25 ^ i26 | 0, i29 | 0, i23 | 0) | 0;
  i25 = getTempRet0() | 0;
  i30 = i4 + 56 | 0;
  i30 = _i64Add(i29 | 0, i23 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i23 = getTempRet0() | 0;
  i29 = i26 ^ i12;
  i15 = i25 ^ i10;
  i10 = _bitshift64Shl(i30 | 0, i23 | 0, 57) | 0;
  i17 = getTempRet0() | 0;
  i33 = _bitshift64Lshr(i30 | 0, i23 | 0, 7) | 0;
  i17 = getTempRet0() | 0 | i17;
  i23 = _i64Add((i32 | i13) ^ i30 | 0, i21 ^ i23 | 0, i31 | 0, i19 | 0) | 0;
  i21 = getTempRet0() | 0;
  i30 = i4 + 64 | 0;
  i30 = _i64Add(i31 | 0, i19 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i19 = getTempRet0() | 0;
  i31 = i23 ^ i8;
  i12 = i21 ^ i6;
  i6 = _bitshift64Shl(i30 | 0, i19 | 0, 55) | 0;
  i13 = getTempRet0() | 0;
  i32 = _bitshift64Lshr(i30 | 0, i19 | 0, 9) | 0;
  i13 = getTempRet0() | 0 | i13;
  i19 = _i64Add((i33 | i10) ^ i30 | 0, i17 ^ i19 | 0, i29 | 0, i15 | 0) | 0;
  i17 = getTempRet0() | 0;
  i30 = i4 + 72 | 0;
  i30 = _i64Add(i29 | 0, i15 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i15 = getTempRet0() | 0;
  i3 = i19 ^ i3;
  i8 = i17 ^ i2;
  i2 = _bitshift64Shl(i30 | 0, i15 | 0, 54) | 0;
  i10 = getTempRet0() | 0;
  i29 = _bitshift64Lshr(i30 | 0, i15 | 0, 10) | 0;
  i10 = getTempRet0() | 0 | i10;
  i15 = _i64Add((i32 | i6) ^ i30 | 0, i13 ^ i15 | 0, i31 | 0, i12 | 0) | 0;
  i13 = getTempRet0() | 0;
  i30 = i4 + 80 | 0;
  i30 = _i64Add(i31 | 0, i12 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i12 = getTempRet0() | 0;
  i5 = i15 ^ i5;
  i7 = i13 ^ i7;
  i31 = _bitshift64Shl(i30 | 0, i12 | 0, 22) | 0;
  i6 = getTempRet0() | 0;
  i32 = _bitshift64Lshr(i30 | 0, i12 | 0, 42) | 0;
  i6 = getTempRet0() | 0 | i6;
  i12 = _i64Add((i29 | i2) ^ i30 | 0, i10 ^ i12 | 0, i3 | 0, i8 | 0) | 0;
  i10 = getTempRet0() | 0;
  i30 = i4 + 88 | 0;
  i30 = _i64Add(i3 | 0, i8 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
  i8 = getTempRet0() | 0;
  i3 = _bitshift64Shl(i30 | 0, i8 | 0, 46) | 0;
  i2 = getTempRet0() | 0;
  i29 = _bitshift64Lshr(i30 | 0, i8 | 0, 18) | 0;
  i2 = getTempRet0() | 0 | i2;
  i8 = _i64Add((i32 | i31) ^ i30 | 0, i6 ^ i8 | 0, i5 | 0, i7 | 0) | 0;
  i1 = (i1 & 255) + 160 & 255;
  i4 = i4 + 96 | 0;
  i9 = i12 ^ i9;
  i11 = i10 ^ i11;
  i6 = getTempRet0() | 0;
  i3 = i29 | i3;
 }
 i34 = i1 & 255;
 _memset(i4 + i34 | 0, 0, 96 - i34 | 0) | 0;
 HEAP8[i4 + 95 >> 0] = i1;
 i34 = i4;
 i34 = _i64Add(HEAP32[i34 >> 2] | 0, HEAP32[i34 + 4 >> 2] | 0, i5 | 0, i7 | 0) | 0;
 i1 = getTempRet0() | 0;
 i36 = i4 + 8 | 0;
 i36 = _i64Add(HEAP32[i36 >> 2] | 0, HEAP32[i36 + 4 >> 2] | 0, i9 | 0, i11 | 0) | 0;
 i35 = getTempRet0() | 0;
 i7 = i4 + 16 | 0;
 i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, i14 | 0, i16 | 0) | 0;
 i37 = getTempRet0() | 0;
 i9 = i4 + 24 | 0;
 i9 = _i64Add(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, i18 | 0, i20 | 0) | 0;
 i5 = getTempRet0() | 0;
 i11 = i4 + 32 | 0;
 i11 = _i64Add(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i22 | 0, i24 | 0) | 0;
 i30 = getTempRet0() | 0;
 i14 = i4 + 40 | 0;
 i14 = _i64Add(HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i26 | 0, i25 | 0) | 0;
 i22 = getTempRet0() | 0;
 i16 = i4 + 48 | 0;
 i16 = _i64Add(HEAP32[i16 >> 2] | 0, HEAP32[i16 + 4 >> 2] | 0, i23 | 0, i21 | 0) | 0;
 i29 = getTempRet0() | 0;
 i21 = i4 + 56 | 0;
 i17 = _i64Add(HEAP32[i21 >> 2] | 0, HEAP32[i21 + 4 >> 2] | 0, i19 | 0, i17 | 0) | 0;
 i21 = getTempRet0() | 0;
 i18 = i4 + 64 | 0;
 i18 = _i64Add(HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, i15 | 0, i13 | 0) | 0;
 i25 = getTempRet0() | 0;
 i20 = i4 + 72 | 0;
 i20 = _i64Add(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, i12 | 0, i10 | 0) | 0;
 i32 = getTempRet0() | 0;
 i33 = i4 + 80 | 0;
 i33 = _i64Add(HEAP32[i33 >> 2] | 0, HEAP32[i33 + 4 >> 2] | 0, i8 | 0, i6 | 0) | 0;
 i19 = getTempRet0() | 0;
 i31 = i4 + 88 | 0;
 i24 = HEAP32[i31 >> 2] | 0;
 i31 = HEAP32[i31 + 4 >> 2] | 0;
 i13 = _i64Add(i36 | 0, i35 | 0, i3 | 0, i2 | 0) | 0;
 i31 = _i64Add(i13 | 0, getTempRet0() | 0, i24 | 0, i31 | 0) | 0;
 i24 = getTempRet0() | 0;
 i7 = i31 ^ i7;
 i13 = i24 ^ i37;
 i8 = _bitshift64Shl(i36 | 0, i35 | 0, 44) | 0;
 i23 = getTempRet0() | 0;
 i12 = _bitshift64Lshr(i36 | 0, i35 | 0, 20) | 0;
 i23 = getTempRet0() | 0 | i23;
 i26 = _i64Add(i34 | 0, i1 | 0, i7 | 0, i13 | 0) | 0;
 i6 = getTempRet0() | 0;
 i9 = i26 ^ i9;
 i15 = i6 ^ i5;
 i10 = _bitshift64Shl(i7 | 0, i13 | 0, 15) | 0;
 i5 = getTempRet0() | 0;
 i13 = _bitshift64Lshr(i7 | 0, i13 | 0, 49) | 0;
 i5 = getTempRet0() | 0 | i5;
 i23 = _i64Add(i9 | 0, i15 | 0, i12 | i8 | 0, i23 | 0) | 0;
 i8 = getTempRet0() | 0;
 i11 = i23 ^ i11;
 i30 = i8 ^ i30;
 i12 = _bitshift64Shl(i9 | 0, i15 | 0, 34) | 0;
 i7 = getTempRet0() | 0;
 i15 = _bitshift64Lshr(i9 | 0, i15 | 0, 30) | 0;
 i7 = getTempRet0() | 0 | i7;
 i5 = _i64Add(i11 | 0, i30 | 0, i13 | i10 | 0, i5 | 0) | 0;
 i10 = getTempRet0() | 0;
 i13 = i5 ^ i14;
 i22 = i10 ^ i22;
 i14 = _bitshift64Shl(i11 | 0, i30 | 0, 21) | 0;
 i9 = getTempRet0() | 0;
 i30 = _bitshift64Lshr(i11 | 0, i30 | 0, 43) | 0;
 i9 = getTempRet0() | 0 | i9;
 i7 = _i64Add(i13 | 0, i22 | 0, i15 | i12 | 0, i7 | 0) | 0;
 i12 = getTempRet0() | 0;
 i15 = i7 ^ i16;
 i29 = i12 ^ i29;
 i16 = _bitshift64Shl(i13 | 0, i22 | 0, 38) | 0;
 i11 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i13 | 0, i22 | 0, 26) | 0;
 i11 = getTempRet0() | 0 | i11;
 i9 = _i64Add(i15 | 0, i29 | 0, i30 | i14 | 0, i9 | 0) | 0;
 i14 = getTempRet0() | 0;
 i17 = i9 ^ i17;
 i21 = i14 ^ i21;
 i30 = _bitshift64Shl(i15 | 0, i29 | 0, 33) | 0;
 i13 = getTempRet0() | 0;
 i29 = _bitshift64Lshr(i15 | 0, i29 | 0, 31) | 0;
 i13 = getTempRet0() | 0 | i13;
 i11 = _i64Add(i17 | 0, i21 | 0, i22 | i16 | 0, i11 | 0) | 0;
 i16 = getTempRet0() | 0;
 i18 = i11 ^ i18;
 i25 = i16 ^ i25;
 i22 = _bitshift64Shl(i17 | 0, i21 | 0, 10) | 0;
 i15 = getTempRet0() | 0;
 i21 = _bitshift64Lshr(i17 | 0, i21 | 0, 54) | 0;
 i15 = getTempRet0() | 0 | i15;
 i13 = _i64Add(i18 | 0, i25 | 0, i29 | i30 | 0, i13 | 0) | 0;
 i30 = getTempRet0() | 0;
 i20 = i13 ^ i20;
 i32 = i30 ^ i32;
 i29 = _bitshift64Shl(i18 | 0, i25 | 0, 13) | 0;
 i17 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i18 | 0, i25 | 0, 51) | 0;
 i17 = getTempRet0() | 0 | i17;
 i15 = _i64Add(i20 | 0, i32 | 0, i21 | i22 | 0, i15 | 0) | 0;
 i22 = getTempRet0() | 0;
 i33 = i15 ^ i33;
 i19 = i22 ^ i19;
 i21 = _bitshift64Shl(i20 | 0, i32 | 0, 38) | 0;
 i18 = getTempRet0() | 0;
 i32 = _bitshift64Lshr(i20 | 0, i32 | 0, 26) | 0;
 i18 = getTempRet0() | 0 | i18;
 i17 = _i64Add(i33 | 0, i19 | 0, i25 | i29 | 0, i17 | 0) | 0;
 i29 = getTempRet0() | 0;
 i31 = i17 ^ i31;
 i24 = i29 ^ i24;
 i25 = _bitshift64Shl(i33 | 0, i19 | 0, 53) | 0;
 i20 = getTempRet0() | 0;
 i19 = _bitshift64Lshr(i33 | 0, i19 | 0, 11) | 0;
 i20 = getTempRet0() | 0 | i20;
 i18 = _i64Add(i31 | 0, i24 | 0, i32 | i21 | 0, i18 | 0) | 0;
 i21 = getTempRet0() | 0;
 i26 = i18 ^ i26;
 i6 = i21 ^ i6;
 i32 = _bitshift64Shl(i31 | 0, i24 | 0, 42) | 0;
 i33 = getTempRet0() | 0;
 i24 = _bitshift64Lshr(i31 | 0, i24 | 0, 22) | 0;
 i33 = getTempRet0() | 0 | i33;
 i20 = _i64Add(i26 | 0, i6 | 0, i19 | i25 | 0, i20 | 0) | 0;
 i25 = getTempRet0() | 0;
 i23 = i20 ^ i23;
 i8 = i25 ^ i8;
 i19 = _bitshift64Shl(i26 | 0, i6 | 0, 54) | 0;
 i31 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i26 | 0, i6 | 0, 10) | 0;
 i31 = getTempRet0() | 0 | i31;
 i33 = _i64Add(i23 | 0, i8 | 0, i24 | i32 | 0, i33 | 0) | 0;
 i32 = getTempRet0() | 0;
 i5 = i33 ^ i5;
 i10 = i32 ^ i10;
 i24 = _bitshift64Shl(i23 | 0, i8 | 0, 44) | 0;
 i26 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i23 | 0, i8 | 0, 20) | 0;
 i26 = getTempRet0() | 0 | i26;
 i31 = _i64Add(i5 | 0, i10 | 0, i6 | i19 | 0, i31 | 0) | 0;
 i19 = getTempRet0() | 0;
 i7 = i31 ^ i7;
 i12 = i19 ^ i12;
 i6 = _bitshift64Shl(i5 | 0, i10 | 0, 15) | 0;
 i23 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i5 | 0, i10 | 0, 49) | 0;
 i23 = getTempRet0() | 0 | i23;
 i26 = _i64Add(i7 | 0, i12 | 0, i8 | i24 | 0, i26 | 0) | 0;
 i24 = getTempRet0() | 0;
 i9 = i26 ^ i9;
 i14 = i24 ^ i14;
 i8 = _bitshift64Shl(i7 | 0, i12 | 0, 34) | 0;
 i5 = getTempRet0() | 0;
 i12 = _bitshift64Lshr(i7 | 0, i12 | 0, 30) | 0;
 i5 = getTempRet0() | 0 | i5;
 i23 = _i64Add(i9 | 0, i14 | 0, i10 | i6 | 0, i23 | 0) | 0;
 i6 = getTempRet0() | 0;
 i11 = i23 ^ i11;
 i16 = i6 ^ i16;
 i10 = _bitshift64Shl(i9 | 0, i14 | 0, 21) | 0;
 i7 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i9 | 0, i14 | 0, 43) | 0;
 i7 = getTempRet0() | 0 | i7;
 i5 = _i64Add(i11 | 0, i16 | 0, i12 | i8 | 0, i5 | 0) | 0;
 i8 = getTempRet0() | 0;
 i13 = i5 ^ i13;
 i30 = i8 ^ i30;
 i12 = _bitshift64Shl(i11 | 0, i16 | 0, 38) | 0;
 i9 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i11 | 0, i16 | 0, 26) | 0;
 i9 = getTempRet0() | 0 | i9;
 i7 = _i64Add(i13 | 0, i30 | 0, i14 | i10 | 0, i7 | 0) | 0;
 i10 = getTempRet0() | 0;
 i15 = i7 ^ i15;
 i22 = i10 ^ i22;
 i14 = _bitshift64Shl(i13 | 0, i30 | 0, 33) | 0;
 i11 = getTempRet0() | 0;
 i30 = _bitshift64Lshr(i13 | 0, i30 | 0, 31) | 0;
 i11 = getTempRet0() | 0 | i11;
 i9 = _i64Add(i15 | 0, i22 | 0, i16 | i12 | 0, i9 | 0) | 0;
 i12 = getTempRet0() | 0;
 i17 = i9 ^ i17;
 i29 = i12 ^ i29;
 i16 = _bitshift64Shl(i15 | 0, i22 | 0, 10) | 0;
 i13 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i15 | 0, i22 | 0, 54) | 0;
 i13 = getTempRet0() | 0 | i13;
 i11 = _i64Add(i17 | 0, i29 | 0, i30 | i14 | 0, i11 | 0) | 0;
 i14 = getTempRet0() | 0;
 i18 = i11 ^ i18;
 i21 = i14 ^ i21;
 i30 = _bitshift64Shl(i17 | 0, i29 | 0, 13) | 0;
 i15 = getTempRet0() | 0;
 i29 = _bitshift64Lshr(i17 | 0, i29 | 0, 51) | 0;
 i15 = getTempRet0() | 0 | i15;
 i13 = _i64Add(i18 | 0, i21 | 0, i22 | i16 | 0, i13 | 0) | 0;
 i16 = getTempRet0() | 0;
 i20 = i13 ^ i20;
 i25 = i16 ^ i25;
 i22 = _bitshift64Shl(i18 | 0, i21 | 0, 38) | 0;
 i17 = getTempRet0() | 0;
 i21 = _bitshift64Lshr(i18 | 0, i21 | 0, 26) | 0;
 i17 = getTempRet0() | 0 | i17;
 i15 = _i64Add(i20 | 0, i25 | 0, i29 | i30 | 0, i15 | 0) | 0;
 i30 = getTempRet0() | 0;
 i33 = i15 ^ i33;
 i32 = i30 ^ i32;
 i29 = _bitshift64Shl(i20 | 0, i25 | 0, 53) | 0;
 i18 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i20 | 0, i25 | 0, 11) | 0;
 i18 = getTempRet0() | 0 | i18;
 i17 = _i64Add(i33 | 0, i32 | 0, i21 | i22 | 0, i17 | 0) | 0;
 i22 = getTempRet0() | 0;
 i31 = i17 ^ i31;
 i19 = i22 ^ i19;
 i21 = _bitshift64Shl(i33 | 0, i32 | 0, 42) | 0;
 i20 = getTempRet0() | 0;
 i32 = _bitshift64Lshr(i33 | 0, i32 | 0, 22) | 0;
 i20 = getTempRet0() | 0 | i20;
 i18 = _i64Add(i31 | 0, i19 | 0, i25 | i29 | 0, i18 | 0) | 0;
 i29 = getTempRet0() | 0;
 i26 = i18 ^ i26;
 i24 = i29 ^ i24;
 i25 = _bitshift64Shl(i31 | 0, i19 | 0, 54) | 0;
 i33 = getTempRet0() | 0;
 i19 = _bitshift64Lshr(i31 | 0, i19 | 0, 10) | 0;
 i33 = getTempRet0() | 0 | i33;
 i20 = _i64Add(i26 | 0, i24 | 0, i32 | i21 | 0, i20 | 0) | 0;
 i21 = getTempRet0() | 0;
 i23 = i20 ^ i23;
 i6 = i21 ^ i6;
 i32 = _bitshift64Shl(i26 | 0, i24 | 0, 44) | 0;
 i31 = getTempRet0() | 0;
 i24 = _bitshift64Lshr(i26 | 0, i24 | 0, 20) | 0;
 i31 = getTempRet0() | 0 | i31;
 i33 = _i64Add(i23 | 0, i6 | 0, i19 | i25 | 0, i33 | 0) | 0;
 i25 = getTempRet0() | 0;
 i5 = i33 ^ i5;
 i8 = i25 ^ i8;
 i19 = _bitshift64Shl(i23 | 0, i6 | 0, 15) | 0;
 i26 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i23 | 0, i6 | 0, 49) | 0;
 i26 = getTempRet0() | 0 | i26;
 i31 = _i64Add(i5 | 0, i8 | 0, i24 | i32 | 0, i31 | 0) | 0;
 i32 = getTempRet0() | 0;
 i7 = i31 ^ i7;
 i10 = i32 ^ i10;
 i24 = _bitshift64Shl(i5 | 0, i8 | 0, 34) | 0;
 i23 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i5 | 0, i8 | 0, 30) | 0;
 i23 = getTempRet0() | 0 | i23;
 i26 = _i64Add(i7 | 0, i10 | 0, i6 | i19 | 0, i26 | 0) | 0;
 i9 = i26 ^ i9;
 i12 = (getTempRet0() | 0) ^ i12;
 i26 = _bitshift64Shl(i7 | 0, i10 | 0, 21) | 0;
 i19 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i7 | 0, i10 | 0, 43) | 0;
 i19 = getTempRet0() | 0 | i19;
 i23 = _i64Add(i9 | 0, i12 | 0, i8 | i24 | 0, i23 | 0) | 0;
 i11 = i23 ^ i11;
 i14 = (getTempRet0() | 0) ^ i14;
 i23 = _bitshift64Shl(i9 | 0, i12 | 0, 38) | 0;
 i24 = getTempRet0() | 0;
 i12 = _bitshift64Lshr(i9 | 0, i12 | 0, 26) | 0;
 i24 = getTempRet0() | 0 | i24;
 i19 = _i64Add(i11 | 0, i14 | 0, i10 | i26 | 0, i19 | 0) | 0;
 i13 = i19 ^ i13;
 i16 = (getTempRet0() | 0) ^ i16;
 i19 = _bitshift64Shl(i11 | 0, i14 | 0, 33) | 0;
 i26 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i11 | 0, i14 | 0, 31) | 0;
 i26 = getTempRet0() | 0 | i26;
 i24 = _i64Add(i13 | 0, i16 | 0, i12 | i23 | 0, i24 | 0) | 0;
 i15 = i24 ^ i15;
 i30 = (getTempRet0() | 0) ^ i30;
 i24 = _bitshift64Shl(i13 | 0, i16 | 0, 10) | 0;
 i23 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i13 | 0, i16 | 0, 54) | 0;
 i23 = getTempRet0() | 0 | i23;
 i26 = _i64Add(i15 | 0, i30 | 0, i14 | i19 | 0, i26 | 0) | 0;
 i17 = i26 ^ i17;
 i22 = (getTempRet0() | 0) ^ i22;
 i26 = _bitshift64Shl(i15 | 0, i30 | 0, 13) | 0;
 i19 = getTempRet0() | 0;
 i30 = _bitshift64Lshr(i15 | 0, i30 | 0, 51) | 0;
 i19 = getTempRet0() | 0 | i19;
 i23 = _i64Add(i17 | 0, i22 | 0, i16 | i24 | 0, i23 | 0) | 0;
 i18 = i23 ^ i18;
 i29 = (getTempRet0() | 0) ^ i29;
 i23 = _bitshift64Shl(i17 | 0, i22 | 0, 38) | 0;
 i24 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i17 | 0, i22 | 0, 26) | 0;
 i24 = getTempRet0() | 0 | i24;
 i19 = _i64Add(i18 | 0, i29 | 0, i30 | i26 | 0, i19 | 0) | 0;
 i21 = (getTempRet0() | 0) ^ i21;
 i26 = _bitshift64Shl(i18 | 0, i29 | 0, 53) | 0;
 i30 = getTempRet0() | 0;
 i29 = _bitshift64Lshr(i18 | 0, i29 | 0, 11) | 0;
 i30 = getTempRet0() | 0 | i30;
 i24 = _i64Add(i19 ^ i20 | 0, i21 | 0, i22 | i23 | 0, i24 | 0) | 0;
 i33 = i24 ^ i33;
 i25 = (getTempRet0() | 0) ^ i25;
 i30 = _i64Add(i33 | 0, i25 | 0, i29 | i26 | 0, i30 | 0) | 0;
 i32 = (getTempRet0() | 0) ^ i32;
 i26 = _bitshift64Shl(i33 | 0, i25 | 0, 54) | 0;
 i29 = getTempRet0() | 0;
 i25 = _bitshift64Lshr(i33 | 0, i25 | 0, 10) | 0;
 i29 = getTempRet0() | 0 | i29;
 i33 = i27;
 HEAP32[i33 >> 2] = i25 | i26;
 HEAP32[i33 + 4 >> 2] = i29;
 i33 = i28;
 HEAP32[i33 >> 2] = i30 ^ i31;
 HEAP32[i33 + 4 >> 2] = i32;
 return;
}

function __ZN14RenderSettings8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_(i10, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 7);
 i3 = i10 + 312 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381350 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i8 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i8 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 320 | 0;
 i8 = HEAP32[gb + 36980 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381356 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 316 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381367 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 21; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 21; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 21) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 344 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381377 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 32; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 32; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 32) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381390 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 43; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 43; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 43) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 340 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381407 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 54; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 54; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 54) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381422 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381440 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381462 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 184 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381483 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 188 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381502 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 360 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381516 | 0, gb + 946436 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 300 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381533 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 111; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 111; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 111) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 304 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381548 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 122; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 122; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 122) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381564 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 133; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 133;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 133) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381581 | 0, gb + 1034905 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 348 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381595 | 0, gb + 1034905 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381608 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 156; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 156;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 156) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381632 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 167; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 167;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 167) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 376 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381662 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 178; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 178;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 178) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 364 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381682 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 189; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 189;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 189) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 380 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381704 | 0, gb + 381723 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN4PPtrI7CubemapE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381737 | 0, gb + 590318 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 384 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381752 | 0, gb + 381723 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN4PPtrI7CubemapE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 388 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381780 | 0, gb + 619515 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN4PPtrI5LightE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 392 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 381786 | 0, i8, i9, 1) | 0;
 if (!i1) {
  __ZN14RenderSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i10, i11);
  STACKTOP = i12;
  return;
 }
 do if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 __ZN14RenderSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i10, i11);
 STACKTOP = i12;
 return;
}

function __ZN5physx11PxcLtbSolveERKNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPNS_14PxcSIMDSpatialE(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i2 = HEAPU16[i6 + 24 >> 1] | 0;
 i3 = i6 + i2 | 0;
 i4 = i6 + 8 | 0;
 _memset(i7 | 0, 0, (HEAPU16[i4 >> 1] | 0) << 5 | 0) | 0;
 i1 = HEAP16[i4 >> 1] | 0;
 if ((i1 & 65535) > 1) {
  i1 = i1 & 65535;
  do {
   i1 = i1 + -1 | 0;
   i8 = HEAPU8[i6 + 64 + i1 >> 0] | 0;
   i15 = i5 + (i1 << 4) | 0;
   f18 = Math_fround(HEAPF32[i15 >> 2]);
   i17 = i5 + (i1 << 4) + 4 | 0;
   f20 = Math_fround(HEAPF32[i17 >> 2]);
   i19 = i5 + (i1 << 4) + 8 | 0;
   f16 = Math_fround(HEAPF32[i19 >> 2]);
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 240 >> 2]);
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 244 >> 2]);
   f22 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 248 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i1 << 5) >> 2]);
   f25 = Math_fround(HEAPF32[i7 + (i1 << 5) + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i7 + (i1 << 5) + 8 >> 2]);
   f22 = Math_fround(Math_fround(Math_fround(f21 * f14) + Math_fround(f28 * f25)) + Math_fround(f22 * f26));
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 256 >> 2]);
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 260 >> 2]);
   f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 264 >> 2]);
   f27 = Math_fround(HEAPF32[i7 + (i1 << 5) + 16 >> 2]);
   f23 = Math_fround(HEAPF32[i7 + (i1 << 5) + 20 >> 2]);
   f10 = Math_fround(HEAPF32[i7 + (i1 << 5) + 24 >> 2]);
   f24 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f21 * f23)) + Math_fround(f24 * f10)));
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 272 >> 2]);
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 276 >> 2]);
   f28 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f25 * f28)) + Math_fround(f26 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 280 >> 2])));
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 288 >> 2]);
   f22 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 292 >> 2]);
   f22 = Math_fround(f28 + Math_fround(Math_fround(Math_fround(f27 * f21) + Math_fround(f23 * f22)) + Math_fround(f10 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 296 >> 2]))));
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 304 >> 2]);
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 308 >> 2]);
   f26 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f25 * f28)) + Math_fround(f26 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 312 >> 2])));
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 320 >> 2]);
   f25 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 324 >> 2]);
   f24 = Math_fround(f18 - f24);
   f22 = Math_fround(f20 - f22);
   f10 = Math_fround(f16 - Math_fround(f26 + Math_fround(Math_fround(Math_fround(f27 * f28) + Math_fround(f23 * f25)) + Math_fround(f10 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 328 >> 2])))));
   HEAPF32[i15 >> 2] = f24;
   HEAPF32[i17 >> 2] = f22;
   HEAPF32[i19 >> 2] = f10;
   HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f25 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 144 >> 2]);
   f23 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 148 >> 2]);
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 152 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 176 >> 2]);
   f26 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 180 >> 2]);
   f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 184 >> 2]);
   f20 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 208 >> 2]);
   f18 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 212 >> 2]);
   f20 = Math_fround(Math_fround(f24 * f25) + Math_fround(Math_fround(f22 * f27) + Math_fround(f10 * f20)));
   f18 = Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f22 * f26) + Math_fround(f10 * f18)));
   f16 = Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f22 * f16) + Math_fround(f10 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 216 >> 2]))));
   f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 160 >> 2]);
   f26 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 164 >> 2]);
   f23 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 168 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 192 >> 2]);
   f25 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 196 >> 2]);
   f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 200 >> 2]);
   f14 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 224 >> 2]);
   f12 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 228 >> 2]);
   f14 = Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f22 * f27) + Math_fround(f10 * f14)));
   f12 = Math_fround(Math_fround(f24 * f26) + Math_fround(Math_fround(f22 * f25) + Math_fround(f10 * f12)));
   f10 = Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f22 * f21) + Math_fround(f10 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 232 >> 2]))));
   i19 = i7 + (i8 << 5) | 0;
   f21 = Math_fround(HEAPF32[i19 >> 2]);
   i17 = i7 + (i8 << 5) + 4 | 0;
   f22 = Math_fround(HEAPF32[i17 >> 2]);
   i15 = i7 + (i8 << 5) + 8 | 0;
   f20 = Math_fround(f21 - f20);
   f18 = Math_fround(f22 - f18);
   f16 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f16);
   i13 = i7 + (i8 << 5) + 16 | 0;
   f22 = Math_fround(HEAPF32[i13 >> 2]);
   i11 = i7 + (i8 << 5) + 20 | 0;
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   i9 = i7 + (i8 << 5) + 24 | 0;
   f14 = Math_fround(f22 - f14);
   f12 = Math_fround(f21 - f12);
   f10 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f10);
   HEAPF32[i19 >> 2] = f20;
   HEAPF32[i17 >> 2] = f18;
   HEAPF32[i15 >> 2] = f16;
   HEAPF32[i7 + (i8 << 5) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i13 >> 2] = f14;
   HEAPF32[i11 >> 2] = f12;
   HEAPF32[i9 >> 2] = f10;
   HEAPF32[i7 + (i8 << 5) + 28 >> 2] = Math_fround(0.0);
  } while (i1 >>> 0 > 1);
 }
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i11 = i7 + 4 | 0;
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = i7 + 8 | 0;
 f26 = Math_fround(HEAPF32[i13 >> 2]);
 f35 = Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2]));
 f35 = Math_fround(f35 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 + 16) >> 2])));
 f35 = Math_fround(f35 + Math_fround(f26 * Math_fround(HEAPF32[i6 + (i2 + 32) >> 2])));
 f34 = Math_fround(f10 * Math_fround(HEAPF32[i6 + (i2 + 4) >> 2]));
 f34 = Math_fround(f34 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 + 20) >> 2])));
 f34 = Math_fround(f34 + Math_fround(f26 * Math_fround(HEAPF32[i6 + (i2 + 36) >> 2])));
 f33 = Math_fround(f10 * Math_fround(HEAPF32[i6 + (i2 + 8) >> 2]));
 f33 = Math_fround(f33 + Math_fround(f14 * Math_fround(HEAPF32[i6 + (i2 + 24) >> 2])));
 f33 = Math_fround(f33 + Math_fround(f26 * Math_fround(HEAPF32[i6 + (i2 + 40) >> 2])));
 i15 = i7 + 16 | 0;
 f16 = Math_fround(HEAPF32[i15 >> 2]);
 i17 = i7 + 20 | 0;
 f22 = Math_fround(HEAPF32[i17 >> 2]);
 i19 = i7 + 24 | 0;
 f28 = Math_fround(HEAPF32[i19 >> 2]);
 f32 = Math_fround(HEAPF32[i6 + (i2 + 48) >> 2]);
 f23 = Math_fround(f16 * f32);
 f30 = Math_fround(HEAPF32[i6 + (i2 + 64) >> 2]);
 f23 = Math_fround(f23 + Math_fround(f22 * f30));
 f12 = Math_fround(HEAPF32[i6 + (i2 + 80) >> 2]);
 f23 = Math_fround(f23 + Math_fround(f28 * f12));
 f31 = Math_fround(HEAPF32[i6 + (i2 + 52) >> 2]);
 f24 = Math_fround(f16 * f31);
 f29 = Math_fround(HEAPF32[i6 + (i2 + 68) >> 2]);
 f24 = Math_fround(f24 + Math_fround(f22 * f29));
 f27 = Math_fround(HEAPF32[i6 + (i2 + 84) >> 2]);
 f24 = Math_fround(f24 + Math_fround(f28 * f27));
 f18 = Math_fround(HEAPF32[i6 + (i2 + 56) >> 2]);
 f25 = Math_fround(f16 * f18);
 f20 = Math_fround(HEAPF32[i6 + (i2 + 72) >> 2]);
 f25 = Math_fround(f25 + Math_fround(f22 * f20));
 f21 = Math_fround(HEAPF32[i6 + (i2 + 88) >> 2]);
 f23 = Math_fround(f35 + f23);
 f24 = Math_fround(f34 + f24);
 f25 = Math_fround(f33 + Math_fround(f25 + Math_fround(f28 * f21)));
 f18 = Math_fround(Math_fround(Math_fround(f10 * f32) + Math_fround(f14 * f31)) + Math_fround(f26 * f18));
 f20 = Math_fround(Math_fround(Math_fround(f10 * f30) + Math_fround(f14 * f29)) + Math_fround(f26 * f20));
 f21 = Math_fround(Math_fround(Math_fround(f10 * f12) + Math_fround(f14 * f27)) + Math_fround(f26 * f21));
 f26 = Math_fround(f16 * Math_fround(HEAPF32[i6 + (i2 + 96) >> 2]));
 f26 = Math_fround(f26 + Math_fround(f22 * Math_fround(HEAPF32[i6 + (i2 + 112) >> 2])));
 f26 = Math_fround(f26 + Math_fround(f28 * Math_fround(HEAPF32[i6 + (i2 + 128) >> 2])));
 f27 = Math_fround(f16 * Math_fround(HEAPF32[i6 + (i2 + 100) >> 2]));
 f27 = Math_fround(f27 + Math_fround(f22 * Math_fround(HEAPF32[i6 + (i2 + 116) >> 2])));
 f27 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i6 + (i2 + 132) >> 2])));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i6 + (i2 + 104) >> 2]));
 f22 = Math_fround(f16 + Math_fround(f22 * Math_fround(HEAPF32[i6 + (i2 + 120) >> 2])));
 f26 = Math_fround(f18 + f26);
 f27 = Math_fround(f20 + f27);
 f28 = Math_fround(f21 + Math_fround(f22 + Math_fround(f28 * Math_fround(HEAPF32[i6 + (i2 + 136) >> 2]))));
 HEAPF32[i7 >> 2] = f23;
 HEAPF32[i11 >> 2] = f24;
 HEAPF32[i13 >> 2] = f25;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i15 >> 2] = f26;
 HEAPF32[i17 >> 2] = f27;
 HEAPF32[i19 >> 2] = f28;
 HEAPF32[i7 + 28 >> 2] = Math_fround(0.0);
 if ((HEAPU16[i4 >> 1] | 0) > 1) i1 = 1; else return;
 do {
  i9 = HEAPU8[i6 + 64 + i1 >> 0] | 0;
  f16 = Math_fround(HEAPF32[i5 + (i1 << 4) >> 2]);
  f24 = Math_fround(HEAPF32[i5 + (i1 << 4) + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i5 + (i1 << 4) + 8 >> 2]);
  f23 = Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 336 >> 2]));
  f23 = Math_fround(f23 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 352 >> 2])));
  f23 = Math_fround(f23 + Math_fround(f36 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 368 >> 2])));
  f22 = Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 340 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 356 >> 2])));
  f22 = Math_fround(f22 + Math_fround(f36 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 372 >> 2])));
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 344 >> 2]));
  f24 = Math_fround(f16 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 360 >> 2])));
  f36 = Math_fround(f24 + Math_fround(f36 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 376 >> 2])));
  f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 144 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 148 >> 2]);
  f27 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 152 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i9 << 5) >> 2]);
  f31 = Math_fround(HEAPF32[i7 + (i9 << 5) + 4 >> 2]);
  f37 = Math_fround(HEAPF32[i7 + (i9 << 5) + 8 >> 2]);
  f27 = Math_fround(Math_fround(Math_fround(f24 * f10) + Math_fround(f16 * f31)) + Math_fround(f27 * f37));
  f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 160 >> 2]);
  f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 164 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 168 >> 2]);
  f38 = Math_fround(HEAPF32[i7 + (i9 << 5) + 16 >> 2]);
  f32 = Math_fround(HEAPF32[i7 + (i9 << 5) + 20 >> 2]);
  f35 = Math_fround(HEAPF32[i7 + (i9 << 5) + 24 >> 2]);
  f25 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f16 * f38) + Math_fround(f24 * f32)) + Math_fround(f25 * f35)));
  f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 176 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 180 >> 2]);
  f16 = Math_fround(Math_fround(Math_fround(f10 * f24) + Math_fround(f31 * f16)) + Math_fround(f37 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 184 >> 2])));
  f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 192 >> 2]);
  f27 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 196 >> 2]);
  f27 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f38 * f24) + Math_fround(f32 * f27)) + Math_fround(f35 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 200 >> 2]))));
  f24 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 208 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 212 >> 2]);
  f37 = Math_fround(Math_fround(Math_fround(f10 * f24) + Math_fround(f31 * f16)) + Math_fround(f37 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 216 >> 2])));
  f16 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 224 >> 2]);
  f31 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 228 >> 2]);
  f25 = Math_fround(f23 - f25);
  f27 = Math_fround(f22 - f27);
  f35 = Math_fround(f36 - Math_fround(f37 + Math_fround(Math_fround(Math_fround(f38 * f16) + Math_fround(f32 * f31)) + Math_fround(f35 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 232 >> 2])))));
  i9 = i7 + (i1 << 5) | 0;
  f31 = Math_fround(HEAPF32[i9 >> 2]);
  i11 = i7 + (i1 << 5) + 4 | 0;
  f32 = Math_fround(HEAPF32[i11 >> 2]);
  i13 = i7 + (i1 << 5) + 8 | 0;
  f16 = Math_fround(HEAPF32[i13 >> 2]);
  f38 = Math_fround(f31 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) >> 2]));
  f38 = Math_fround(f38 + Math_fround(f32 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 16 >> 2])));
  f38 = Math_fround(f38 + Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 32 >> 2])));
  f37 = Math_fround(f31 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 4 >> 2]));
  f37 = Math_fround(f37 + Math_fround(f32 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 20 >> 2])));
  f37 = Math_fround(f37 + Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 36 >> 2])));
  f36 = Math_fround(f31 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 8 >> 2]));
  f36 = Math_fround(f36 + Math_fround(f32 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 24 >> 2])));
  f36 = Math_fround(f36 + Math_fround(f16 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 40 >> 2])));
  i15 = i7 + (i1 << 5) + 16 | 0;
  f22 = Math_fround(HEAPF32[i15 >> 2]);
  i17 = i7 + (i1 << 5) + 20 | 0;
  f23 = Math_fround(HEAPF32[i17 >> 2]);
  i19 = i7 + (i1 << 5) + 24 | 0;
  f24 = Math_fround(HEAPF32[i19 >> 2]);
  f10 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 48 >> 2]);
  f29 = Math_fround(f22 * f10);
  f33 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 64 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f23 * f33));
  f30 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 80 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f24 * f30));
  f34 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 52 >> 2]);
  f12 = Math_fround(f22 * f34);
  f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 68 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f23 * f28));
  f21 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 84 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f24 * f21));
  f20 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 56 >> 2]);
  f14 = Math_fround(f22 * f20);
  f18 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 72 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f23 * f18));
  f26 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 88 >> 2]);
  f29 = Math_fround(f38 + f29);
  f12 = Math_fround(f37 + f12);
  f14 = Math_fround(f36 + Math_fround(f14 + Math_fround(f24 * f26)));
  f20 = Math_fround(Math_fround(Math_fround(f31 * f10) + Math_fround(f32 * f34)) + Math_fround(f16 * f20));
  f18 = Math_fround(Math_fround(Math_fround(f31 * f33) + Math_fround(f32 * f28)) + Math_fround(f16 * f18));
  f26 = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f32 * f21)) + Math_fround(f16 * f26));
  f16 = Math_fround(f22 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 96 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f23 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 112 >> 2])));
  f16 = Math_fround(f16 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 128 >> 2])));
  f21 = Math_fround(f22 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 100 >> 2]));
  f21 = Math_fround(f21 + Math_fround(f23 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 116 >> 2])));
  f21 = Math_fround(f21 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 132 >> 2])));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 104 >> 2]));
  f23 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 120 >> 2])));
  f16 = Math_fround(f20 + f16);
  f21 = Math_fround(f18 + f21);
  f24 = Math_fround(f26 + Math_fround(f23 + Math_fround(f24 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 136 >> 2]))));
  f23 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 240 >> 2]);
  f26 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 244 >> 2]);
  f18 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 248 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 272 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 276 >> 2]);
  f32 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 280 >> 2]);
  f30 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 304 >> 2]);
  f31 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 308 >> 2]);
  f30 = Math_fround(Math_fround(f25 * f23) + Math_fround(Math_fround(f27 * f20) + Math_fround(f35 * f30)));
  f31 = Math_fround(Math_fround(f25 * f26) + Math_fround(Math_fround(f27 * f22) + Math_fround(f35 * f31)));
  f32 = Math_fround(Math_fround(f25 * f18) + Math_fround(Math_fround(f27 * f32) + Math_fround(f35 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 312 >> 2]))));
  f18 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 256 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 260 >> 2]);
  f26 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 264 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 288 >> 2]);
  f23 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 292 >> 2]);
  f28 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 296 >> 2]);
  f33 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 320 >> 2]);
  f34 = Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 324 >> 2]);
  f31 = Math_fround(f12 - f31);
  f32 = Math_fround(f14 - f32);
  f33 = Math_fround(f16 - Math_fround(Math_fround(f25 * f18) + Math_fround(Math_fround(f27 * f20) + Math_fround(f35 * f33))));
  f34 = Math_fround(f21 - Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f27 * f23) + Math_fround(f35 * f34))));
  f35 = Math_fround(f24 - Math_fround(Math_fround(f25 * f26) + Math_fround(Math_fround(f27 * f28) + Math_fround(f35 * Math_fround(HEAPF32[i3 + (i1 * 400 | 0) + 328 >> 2])))));
  HEAPF32[i9 >> 2] = Math_fround(f29 - f30);
  HEAPF32[i11 >> 2] = f31;
  HEAPF32[i13 >> 2] = f32;
  HEAPF32[i7 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i15 >> 2] = f33;
  HEAPF32[i17 >> 2] = f34;
  HEAPF32[i19 >> 2] = f35;
  HEAPF32[i7 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAPU16[i4 >> 1] | 0) >>> 0);
 return;
}

function __ZN5physx29createFinalizeSolverContacts4EPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE(i77, i81, i68, i55, i56, i57, i58, i51, i52, f80, f79, f54, f53, i62, i1) {
 i77 = i77 | 0;
 i81 = i81 | 0;
 i68 = i68 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 f80 = Math_fround(f80);
 f79 = Math_fround(f79);
 f54 = Math_fround(f54);
 f53 = Math_fround(f53);
 i62 = i62 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, i59 = 0, i60 = 0, i61 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i78 = 0;
 i78 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i67 = i78 + 280 | 0;
 i39 = i78 + 252 | 0;
 i75 = i78 + 112 | 0;
 i76 = i78 + 96 | 0;
 i73 = i78 + 80 | 0;
 i74 = i78 + 64 | 0;
 i40 = i78 + 184 | 0;
 i64 = i78 + 168 | 0;
 i65 = i78 + 152 | 0;
 i66 = i78 + 144 | 0;
 i63 = i78 + 128 | 0;
 i71 = i78 + 48 | 0;
 i69 = i78 + 32 | 0;
 i72 = i78 + 16 | 0;
 i70 = i78;
 HEAP16[(HEAP32[i68 >> 2] | 0) + 26 >> 1] = 0;
 HEAP16[(HEAP32[i68 + 4 >> 2] | 0) + 26 >> 1] = 0;
 HEAP16[(HEAP32[i68 + 8 >> 2] | 0) + 26 >> 1] = 0;
 HEAP16[(HEAP32[i68 + 12 >> 2] | 0) + 26 >> 1] = 0;
 i18 = i81 + 384 | 0;
 i19 = i81 + 4480 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAPF32[i39 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i39 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 24 >> 2] = Math_fround(0.0);
 i20 = i81 + 4496 | 0;
 i21 = i81 + 8728 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i81 + 8724 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i40 + 4 | 0;
 i24 = i40 + 8 | 0;
 i25 = i40 + 36 | 0;
 i26 = i40 + 40 | 0;
 i27 = i40 + 44 | 0;
 i28 = i40 + 12 | 0;
 i29 = i40 + 60 | 0;
 i30 = i40 + 56 | 0;
 i31 = i40 + 64 | 0;
 i32 = i40 + 48 | 0;
 i33 = i40 + 52 | 0;
 i34 = i40 + 24 | 0;
 i35 = i40 + 28 | 0;
 i36 = i40 + 16 | 0;
 i37 = i40 + 32 | 0;
 i38 = 0;
 i9 = 0;
 while (1) {
  i16 = i77 + (i38 << 2) | 0;
  i1 = HEAP32[i16 >> 2] | 0;
  if (!(HEAP16[i1 + 22 >> 1] & 32)) i2 = i39; else {
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i51 + (i38 << 2) >> 2] | 0;
  }
  i17 = i67 + (i38 * 56 | 0) + 28 | 0;
  HEAP32[i17 >> 2] = i2;
  if (!(HEAP16[i1 + 22 >> 1] & 64)) i2 = i39; else {
   i2 = HEAP32[i52 + (i38 << 2) >> 2] | 0;
   i1 = HEAP32[i16 >> 2] | 0;
  }
  i15 = i67 + (i38 * 56 | 0) + 32 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i67 + (i38 * 56 | 0) >> 2] = i1;
  i14 = i67 + (i38 * 56 | 0) + 12 | 0;
  HEAP32[i14 >> 2] = i9;
  HEAP32[i67 + (i38 * 56 | 0) + 36 >> 2] = HEAP32[i55 + (i38 << 2) >> 2];
  HEAP32[i67 + (i38 * 56 | 0) + 40 >> 2] = HEAP32[i56 + (i38 << 2) >> 2];
  HEAP32[i67 + (i38 * 56 | 0) + 44 >> 2] = HEAP32[i57 + (i38 << 2) >> 2];
  HEAP32[i67 + (i38 * 56 | 0) + 48 >> 2] = HEAP32[i58 + (i38 << 2) >> 2];
  i1 = HEAP32[i16 >> 2] | 0;
  if (((HEAPU16[i1 + 20 >> 1] | 0) + i9 | 0) >>> 0 > 64) {
   i59 = 1;
   i11 = 85;
   break;
  }
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i8 = HEAP32[i1 + 32 >> 2] | 0;
  HEAPF32[i40 >> 2] = Math_fround(0.0);
  HEAPF32[i23 >> 2] = Math_fround(0.0);
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  HEAP32[i25 >> 2] = i8;
  HEAP32[i26 >> 2] = 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i28 >> 2] = i7;
  if (!i8) {
   i6 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i4 = 0;
   i5 = 1;
  } else {
   i5 = HEAP16[i7 + 2 >> 1] | 0;
   i4 = i5 & 65535;
   i6 = i4 & 2;
   i13 = (i6 | 0) != 0;
   i4 = i4 & 1;
   i6 = i7 + (i6 << 3 | 4) | 0;
   i1 = (i4 | 0) != 0;
   i2 = i13;
   i3 = i13 ? 4 : 32;
   i4 = i13 ? 72 : i4 << 3 | 16;
   i5 = (i5 & 4) != 0;
  }
  HEAP32[i29 >> 2] = i2 & 1;
  HEAP32[i30 >> 2] = i1 & 1;
  HEAP32[i31 >> 2] = i5 & 1;
  HEAP32[i32 >> 2] = i3;
  HEAP32[i33 >> 2] = i4;
  HEAP32[i34 >> 2] = i6;
  HEAP32[i35 >> 2] = i6;
  HEAP32[i36 >> 2] = i6;
  if (i5) {
   i4 = 0;
   i2 = 0;
   i5 = i9;
   i3 = 0;
  } else {
   if (i2) {
    HEAP32[i75 + (i38 << 2) >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i76 + (i38 << 2) >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i73 + (i38 << 2) >> 2] = HEAP32[i7 + 12 >> 2];
    f10 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   } else {
    HEAPF32[i75 + (i38 << 2) >> 2] = Math_fround(1.0);
    HEAPF32[i76 + (i38 << 2) >> 2] = Math_fround(1.0);
    HEAPF32[i73 + (i38 << 2) >> 2] = Math_fround(1.0);
    f10 = Math_fround(1.0);
   }
   HEAPF32[i74 + (i38 << 2) >> 2] = f10;
   i12 = HEAPU16[i7 + 2 >> 1] | 0;
   i1 = i6;
   i13 = (i12 & 16 | 0) != 0;
   i12 = (i12 & 32 | 0) != 0;
   if ((i1 - i7 | 0) >>> 0 < i8 >>> 0) {
    i4 = i8;
    i2 = i9;
    i3 = 0;
    while (1) {
     HEAP32[i34 >> 2] = i6;
     if ((i1 - i7 | 0) >>> 0 < i4 >>> 0) {
      i11 = HEAPU16[i6 >> 1] | 0;
      HEAP32[i26 >> 2] = i11;
      i5 = HEAP32[i32 >> 2] | 0;
      HEAP32[i35 >> 2] = i6 + ((Math_imul(HEAP32[i33 >> 2] | 0, i11) | 0) + i5);
      HEAP32[i36 >> 2] = i6 + i5;
      HEAP32[i27 >> 2] = 0;
      i5 = i2;
     } else {
      HEAP32[i35 >> 2] = i6;
      i5 = i2;
     }
     L25 : while (1) {
      while (1) {
       i1 = HEAP32[i27 >> 2] | 0;
       if (i1 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) break L25;
       HEAP32[i27 >> 2] = i1 + 1;
       i1 = HEAP32[i36 >> 2] | 0;
       HEAP32[i37 >> 2] = i1;
       HEAP32[i36 >> 2] = i1 + (HEAP32[i33 >> 2] | 0);
       i1 = (HEAP32[i29 >> 2] | 0) == 0;
       if (i1) {
        i41 = i1;
        i11 = 25;
        break;
       }
       i2 = HEAP32[i37 >> 2] | 0;
       f10 = Math_fround(HEAPF32[i2 + 48 >> 2]);
       if (f10 != Math_fround(0.0)) {
        i42 = i1;
        i43 = i2;
        f44 = f10;
        i11 = 24;
        break;
       }
      }
      if ((i11 | 0) == 24) {
       i45 = i43 + 24 | 0;
       i46 = i43;
       i47 = i43;
       i48 = HEAP32[i34 >> 2] | 0;
       i49 = i42;
       f50 = f44;
      } else if ((i11 | 0) == 25) {
       i47 = HEAP32[i37 >> 2] | 0;
       i48 = HEAP32[i34 >> 2] | 0;
       i45 = i48 + 4 | 0;
       i46 = i47;
       i49 = i41;
       f50 = Math_fround(3402823469999999843913219.0e14);
      }
      HEAP32[i81 + 384 + (i5 << 6) >> 2] = HEAP32[i45 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 4 >> 2] = HEAP32[i45 + 4 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 8 >> 2] = HEAP32[i45 + 8 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 16 >> 2] = HEAP32[i46 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 20 >> 2] = HEAP32[i46 + 4 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 24 >> 2] = HEAP32[i46 + 8 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 12 >> 2] = HEAP32[i46 + 12 >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 48 >> 2] = (HEAPU16[(i49 ? i48 + 30 | 0 : i47 + 66 | 0) >> 1] | 0) << 16 | (HEAPU16[(i49 ? i48 + 28 | 0 : i47 + 64 | 0) >> 1] | 0);
      if (i49) i1 = HEAPU16[i48 + 2 >> 1] | 0; else i1 = HEAP32[i47 + 68 >> 2] | 0;
      HEAP32[i81 + 384 + (i5 << 6) + 52 >> 2] = i1;
      HEAPF32[i81 + 384 + (i5 << 6) + 28 >> 2] = f50;
      HEAP32[i81 + 384 + (i5 << 6) + 44 >> 2] = HEAP32[(i49 ? i48 + 16 | 0 : i47 + 52 | 0) >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 56 >> 2] = HEAP32[(i49 ? i48 + 20 | 0 : i47 + 56 | 0) >> 2];
      HEAP32[i81 + 384 + (i5 << 6) + 60 >> 2] = HEAP32[(i49 ? i48 + 24 | 0 : i47 + 60 | 0) >> 2];
      i1 = i49 ? i40 : i47 + 36 | 0;
      HEAP32[i81 + 384 + (i5 << 6) + 32 >> 2] = HEAP32[i1 >> 2];
      i2 = i1 + 4 | 0;
      HEAP32[i81 + 384 + (i5 << 6) + 36 >> 2] = HEAP32[i2 >> 2];
      i4 = i1 + 8 | 0;
      HEAP32[i81 + 384 + (i5 << 6) + 40 >> 2] = HEAP32[i4 >> 2];
      if (i49) i1 = 0; else {
       if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0); else i1 = 0; else i1 = 0;
       i1 = i1 ^ 1;
      }
      i5 = i5 + 1 | 0;
      i3 = i3 | i1;
     }
     i6 = HEAP32[i35 >> 2] | 0;
     i7 = HEAP32[i28 >> 2] | 0;
     i1 = i6;
     i4 = HEAP32[i25 >> 2] | 0;
     if ((i1 - i7 | 0) >>> 0 >= i4 >>> 0) {
      i4 = i12;
      i2 = i13;
      break;
     } else i2 = i5;
    }
   } else {
    i4 = i12;
    i2 = i13;
    i5 = i9;
    i3 = 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i19 >> 2] = i5;
  if ((i5 | 0) == (i1 | 0)) {
   i11 = 48;
   break;
  }
  HEAP32[i67 + (i38 * 56 | 0) + 16 >> 2] = i5 - i1;
  HEAP8[i67 + (i38 * 56 | 0) + 52 >> 0] = i3 & 1;
  HEAP8[i67 + (i38 * 56 | 0) + 53 >> 0] = i4 & 1;
  HEAP8[i67 + (i38 * 56 | 0) + 54 >> 0] = i2 & 1;
  i2 = i67 + (i38 * 56 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
  if (!i3) {
   i1 = HEAP32[i16 >> 2] | 0;
   if (!(HEAP16[i1 + 22 >> 1] & 4)) if (!(__ZL18getFrictionPatchesRN5physx26PxcFrictionPatchStreamPairERNS_20PxcCorrelationBufferEPKhjRKNS_11PxTransformES8_f(i20, HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, f53) | 0)) {
    i11 = 48;
    break;
   }
  }
  i1 = i67 + (i38 * 56 | 0) + 20 | 0;
  HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
  if (!(__ZN5physx20createContactPatchesERNS_18PxcNpThreadContextEjf(i81, HEAP32[i14 >> 2] | 0, Math_fround(.999000012)) | 0)) {
   i11 = 48;
   break;
  }
  i16 = HEAP32[i1 >> 2] | 0;
  HEAP32[i67 + (i38 * 56 | 0) + 24 >> 2] = (HEAP32[i22 >> 2] | 0) - i16;
  if (__ZN5physx16correlatePatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjj(i20, i18, HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, Math_fround(.999000012), i16, HEAP32[i2 >> 2] | 0) | 0) {
   i11 = 48;
   break;
  }
  __ZN5physx11growPatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjf(i20, i18, HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, f53, HEAP32[i2 >> 2] | 0, f54);
  i1 = HEAP32[i21 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 > i4 >>> 0) {
   i2 = i1;
   i3 = i1;
   while (1) {
    i1 = i3;
    i3 = i3 + -1 | 0;
    if ((HEAP32[i81 + 8464 + (i3 << 2) >> 2] | 0) == 65535) {
     if (i1 >>> 0 < i2 >>> 0) {
      i2 = i1;
      do {
       i1 = i2 + -1 | 0;
       HEAP32[i81 + 8464 + (i1 << 2) >> 2] = HEAP32[i81 + 8464 + (i2 << 2) >> 2];
       HEAP32[i81 + 8336 + (i1 << 2) >> 2] = HEAP32[i81 + 8336 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i21 >> 2] | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     } else i1 = i2;
     i1 = i1 + -1 | 0;
     HEAP32[i21 >> 2] = i1;
    } else i1 = i2;
    if (i3 >>> 0 <= i4 >>> 0) break; else i2 = i1;
   }
  }
  HEAP32[i67 + (i38 * 56 | 0) + 8 >> 2] = i1 - i4;
  i38 = i38 + 1 | 0;
  if (i38 >>> 0 >= 4) {
   i11 = 2;
   break;
  } else i9 = i5;
 }
 if ((i11 | 0) == 2) {
  i7 = i81 + 348 | 0;
  i5 = i81 + 352 | 0;
  i8 = i81 + 344 | 0;
  i9 = 0;
  do {
   i1 = HEAP32[i67 + (i9 * 56 | 0) + 4 >> 2] | 0;
   i3 = (HEAP32[i67 + (i9 * 56 | 0) + 8 >> 2] | 0) + i1 | 0;
   i6 = i64 + (i9 << 2) | 0;
   i4 = i65 + (i9 << 2) | 0;
   if (i1 >>> 0 < i3 >>> 0) {
    i2 = 0;
    do {
     i2 = ((HEAP32[i81 + 8464 + (i1 << 2) >> 2] | 0) != 65535 & 1) + i2 | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = i2;
    i3 = i1 * 96 | 0;
    HEAP32[i4 >> 2] = i1;
    if (!i3) i11 = 58; else {
     do if (i3 >>> 0 > 16384) i1 = -1; else {
      i1 = HEAP32[i7 >> 2] | 0;
      if (!i1) i11 = 56; else {
       i2 = HEAP32[i5 >> 2] | 0;
       if ((i2 + i3 | 0) >>> 0 > 16384) i11 = 56; else {
        i60 = i1;
        i61 = i2;
       }
      }
      if ((i11 | 0) == 56) {
       i11 = 0;
       i1 = __ZN5physx17PxcNpMemBlockPool20acquireFrictionBlockEv(HEAP32[i8 >> 2] | 0) | 0;
       HEAP32[i7 >> 2] = i1;
       HEAP32[i5 >> 2] = 0;
       if (!i1) {
        i1 = 0;
        break;
       } else {
        i60 = i1;
        i61 = 0;
       }
      }
      HEAP32[i5 >> 2] = i61 + i3;
      i1 = i60 + i61 | 0;
     } while (0);
     i58 = (i1 | 0) == 0 | (i1 | 0) != (-1 | 0) ? i1 : 0;
     HEAP32[i6 >> 2] = i58;
     if (!i58) {
      i59 = 0;
      i11 = 85;
      break;
     }
    }
   } else {
    HEAP32[i4 >> 2] = 0;
    i11 = 58;
   }
   if ((i11 | 0) == 58) {
    i11 = 0;
    HEAP32[i6 >> 2] = 0;
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < 4);
  if ((i11 | 0) == 85) {
   STACKTOP = i78;
   return i59 | 0;
  }
  HEAP32[i66 >> 2] = 0;
  i2 = i81 + 316 | 0;
  __Z28computeBlockStreamByteSizes4PN5physx21PxcSolverContact4DescERjPjRNS_18PxcNpThreadContextE(i67, i66, i63, i81);
  i8 = HEAP32[i66 >> 2] | 0;
  do if (!i8) i9 = 0; else {
   if ((i8 + 16 | 0) >>> 0 > 16384) {
    i81 = 1;
    STACKTOP = i78;
    return i81 | 0;
   }
   i3 = i8 + 31 & -16;
   do if (i3 >>> 0 > 16384) i1 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i2 >> 2] | 0, i3) | 0; else {
    i4 = i81 + 320 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i1 = i81 + 324 | 0;
    if (i5 | 0) {
     i6 = HEAP32[i1 >> 2] | 0;
     i7 = i6 + i3 | 0;
     if (i7 >>> 0 <= 16384) {
      HEAP32[i1 >> 2] = i7;
      i1 = i5 + i6 | 0;
      break;
     }
    }
    i62 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i2 >> 2] | 0, i62) | 0;
    HEAP32[i4 >> 2] = i62;
    HEAP32[i1 >> 2] = i3;
    i1 = i62;
   } while (0);
   if (!((i1 | 0) == 0 | (i1 | 0) == (-1 | 0) & (i1 | 0) != 0)) {
    i9 = i81 + 8764 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i8;
    i9 = i1;
    break;
   }
   i81 = i81 + 8764 | 0;
   HEAP32[i81 >> 2] = (HEAP32[i81 >> 2] | 0) + i8;
   i81 = 0;
   STACKTOP = i78;
   return i81 | 0;
  } while (0);
  i8 = 0;
  do {
   i2 = HEAP32[i64 + (i8 << 2) >> 2] | 0;
   i7 = i77 + (i8 << 2) | 0;
   HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] = i2;
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = HEAP32[i65 + (i8 << 2) >> 2];
   if (i2) {
    i5 = i67 + (i8 * 56 | 0) + 8 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) {
     i6 = i67 + (i8 * 56 | 0) + 4 | 0;
     i4 = 0;
     do {
      i3 = (HEAP32[i6 >> 2] | 0) + i4 | 0;
      if ((HEAP32[i81 + 8464 + (i3 << 2) >> 2] | 0) != 65535) {
       HEAP8[i2 >> 0] = HEAP8[i81 + 5264 + (i3 * 96 | 0) >> 0] | 0;
       HEAP16[i2 + 16 >> 1] = HEAP16[i81 + 5264 + (i3 * 96 | 0) + 16 >> 1] | 0;
       HEAP32[i2 + 24 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 24 >> 2];
       HEAP32[i2 + 28 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 28 >> 2];
       HEAP32[i2 + 32 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 32 >> 2];
       HEAP32[i2 + 36 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 36 >> 2];
       HEAP32[i2 + 40 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 40 >> 2];
       HEAP32[i2 + 44 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 44 >> 2];
       HEAP32[i2 + 48 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 48 >> 2];
       HEAP32[i2 + 52 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 52 >> 2];
       HEAP32[i2 + 56 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 56 >> 2];
       HEAP32[i2 + 60 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 60 >> 2];
       HEAP32[i2 + 64 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 64 >> 2];
       HEAP32[i2 + 68 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 68 >> 2];
       HEAP32[i2 + 72 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 72 >> 2];
       HEAP32[i2 + 76 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 76 >> 2];
       HEAP32[i2 + 80 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 80 >> 2];
       HEAP32[i2 + 84 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 84 >> 2];
       HEAP32[i2 + 88 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 88 >> 2];
       HEAP32[i2 + 92 >> 2] = HEAP32[i81 + 5264 + (i3 * 96 | 0) + 92 >> 2];
       HEAP16[i2 + 20 >> 1] = HEAP16[i81 + 5264 + (i3 * 96 | 0) + 20 >> 1] | 0;
       HEAP16[i2 + 18 >> 1] = HEAP16[i81 + 5264 + (i3 * 96 | 0) + 18 >> 1] | 0;
       HEAP16[i2 + 22 >> 1] = HEAP16[i81 + 5264 + (i3 * 96 | 0) + 22 >> 1] | 0;
       i1 = HEAP32[i5 >> 2] | 0;
       i2 = i2 + 96 | 0;
      }
      i4 = i4 + 1 | 0;
     } while (i4 >>> 0 < i1 >>> 0);
    }
    i1 = HEAP32[i7 >> 2] | 0;
   }
   HEAP32[i1 >> 2] = i9;
   i1 = HEAP32[i66 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 + 4 >> 2] = i1;
   i4 = i4 + 16 | 0;
   HEAP16[i4 >> 1] = (HEAPU16[i4 >> 1] | 0) + (HEAP32[i63 + (i8 << 2) >> 2] | 0);
   i4 = i68 + (i8 << 2) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] = i9;
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP16[i5 + 26 >> 1] = i1 >>> 4;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!(HEAP16[i2 + 98 >> 1] & 16)) {
    i3 = 0;
    i2 = 0;
   } else {
    i3 = (HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 32 >> 2] | 0) + 15 & -16) | 0;
    i2 = HEAPU16[i2 + 20 >> 1] | 0;
   }
   HEAP32[i5 + 20 >> 2] = i3;
   HEAP16[(HEAP32[i4 >> 2] | 0) + 24 >> 1] = i2;
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != 4);
  i66 = HEAP32[i75 + 4 >> 2] | 0;
  i77 = HEAP32[i75 + 8 >> 2] | 0;
  i68 = HEAP32[i75 + 12 >> 2] | 0;
  HEAP32[i71 >> 2] = HEAP32[i75 >> 2];
  HEAP32[i71 + 4 >> 2] = i66;
  HEAP32[i71 + 8 >> 2] = i77;
  HEAP32[i71 + 12 >> 2] = i68;
  i68 = HEAP32[i73 + 4 >> 2] | 0;
  i75 = HEAP32[i73 + 8 >> 2] | 0;
  i77 = HEAP32[i73 + 12 >> 2] | 0;
  HEAP32[i69 >> 2] = HEAP32[i73 >> 2];
  HEAP32[i69 + 4 >> 2] = i68;
  HEAP32[i69 + 8 >> 2] = i75;
  HEAP32[i69 + 12 >> 2] = i77;
  i73 = HEAP32[i76 + 4 >> 2] | 0;
  i77 = HEAP32[i76 + 8 >> 2] | 0;
  i75 = HEAP32[i76 + 12 >> 2] | 0;
  HEAP32[i72 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i72 + 4 >> 2] = i73;
  HEAP32[i72 + 8 >> 2] = i77;
  HEAP32[i72 + 12 >> 2] = i75;
  i75 = HEAP32[i74 + 4 >> 2] | 0;
  i76 = HEAP32[i74 + 8 >> 2] | 0;
  i77 = HEAP32[i74 + 12 >> 2] | 0;
  HEAP32[i70 >> 2] = HEAP32[i74 >> 2];
  HEAP32[i70 + 4 >> 2] = i75;
  HEAP32[i70 + 8 >> 2] = i76;
  HEAP32[i70 + 12 >> 2] = i77;
  i77 = i9;
  __ZN5physx31setupFinalizeSolverConstraints4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRKNS_6shdfnd3aos5Vec4VES9_S9_S9_(i67, i81, i77, f80, f79, i71, i69, i72, i70);
  HEAP32[i77 + i1 >> 2] = 0;
  i81 = 2;
  STACKTOP = i78;
  return i81 | 0;
 } else if ((i11 | 0) == 48) {
  i81 = 1;
  STACKTOP = i78;
  return i81 | 0;
 } else if ((i11 | 0) == 85) {
  STACKTOP = i78;
  return i59 | 0;
 }
 return 0;
}

function __ZN11ShapeModule8TransferI14SafeBinaryReadEEvRT_(i9, i12) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i13 = i14 + 4 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i12, 3);
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i9, i12);
 i5 = i9 + 8 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1047471 | 0, i6, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i4 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i10 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 12 | 0;
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 753604 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 17; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 16 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620620 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 28; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 28; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 20 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620626 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 39; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 39; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 24 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620633 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 50; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 50; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 28 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620638 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 61; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 61; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 32 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620643 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 72; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 72; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 36 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620648 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 83; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 83; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 40 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620652 | 0, i6, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 94; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 94; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 44 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1048075 | 0, gb + 1048082 | 0, i11, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 48 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620666 | 0, gb + 620681 | 0, i11, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4PPtrI12MeshRendererE8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i9 + 52 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620700 | 0, gb + 620722 | 0, i11, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4PPtrI19SkinnedMeshRendererE8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 56 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620748 | 0, i6, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 123; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 123; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 123) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 60 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620768 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i10 = 134; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i10 = 134; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i10 | 0) == 134) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 64 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620787 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i7 >>> 0) i10 = 145; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 145;
     break;
    }
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i10 | 0) == 145) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 213 | 0;
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620799 | 0, i7, i11, 0) | 0;
 if (i2 | 0) {
  L207 : do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L207;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 214 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620822 | 0, i7, i11, 0) | 0;
 if (i2 | 0) {
  L219 : do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L219;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i9 + 212 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620838 | 0, i7, i11, 0) | 0;
 if (i2 | 0) {
  L231 : do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i6 >>> 0) {
    if ((i3 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break L231;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i6 = i9 + 204 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620855 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i5 >>> 0) i10 = 183; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 183;
     break;
    }
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i10 | 0) == 183) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i6 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 208 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620877 | 0, i8, i11, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i9 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i9 >>> 0) i10 = 194; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i10 = 194;
     break;
    }
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i10 | 0) == 194) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (!(HEAP32[i12 >> 2] & 512)) break;
   HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 2) | 0)) {
  STACKTOP = i14;
  return;
 }
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 620902 | 0, i7, i11, 0) | 0;
 if (!i2) f1 = Math_fround(1.0); else {
  L276 : do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i11 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i11 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 >= i11 >>> 0) {
    i4 = i3 + 1 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i13 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = i4;
    break L276;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i13, 1);
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i13 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  f1 = HEAP8[i13 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
 }
 HEAPF32[i6 >> 2] = f1;
 STACKTOP = i14;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator15InsertCharacterEiPj(i30, i31, i2) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i32 = 0, f33 = f0, f34 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i32 + 40 | 0;
 i21 = i32 + 32 | 0;
 i3 = i32 + 16 | 0;
 i24 = i32;
 i25 = i32 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 i19 = i30 + 184 | 0;
 i26 = i30 + 344 | 0;
 i17 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
 i27 = i30 + 332 | 0;
 i28 = HEAP32[i27 >> 2] | 0;
 i18 = i30 + 248 | 0;
 __ZNK20TextRenderingPrivate8FontImpl22GetCharacterRenderInfoEjijfR5RectTIfES3_RbPj(HEAP32[i19 >> 2] | 0, i31, HEAP32[i28 + (i17 << 5) + 8 >> 2] | 0, HEAP32[i28 + (i17 << 5) >> 2] | 0, Math_fround(HEAPF32[i18 >> 2]), i3, i24, i25, i2);
 i17 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
 i28 = HEAP32[i27 >> 2] | 0;
 f1 = Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(HEAP32[i19 >> 2] | 0, i31, HEAP32[i28 + (i17 << 5) + 8 >> 2] | 0, HEAP32[i28 + (i17 << 5) >> 2] | 0, Math_fround(HEAPF32[i18 >> 2]), 0));
 i17 = (HEAP8[i30 + 229 >> 0] | 0) == 0;
 if (i17) f29 = f1; else {
  f29 = Math_fround(HEAPF32[i18 >> 2]);
  f29 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f29) + Math_fround(.5)))) / f29);
 }
 i28 = i30 + 260 | 0;
 HEAPF32[(HEAP32[i30 + 376 >> 2] | 0) + (HEAP32[i28 >> 2] << 2) >> 2] = f29;
 i2 = i3 + 8 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if (f1 == Math_fround(0.0)) {
  HEAPF32[i2 >> 2] = f29;
  HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
  f1 = f29;
 }
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(-f6);
 if (i17) {
  f6 = Math_fround(-Math_fround(f6 + Math_fround(HEAPF32[i3 + 12 >> 2])));
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f13 = f7;
  f7 = f6;
  f6 = f11;
  f1 = Math_fround(f11 + f1);
 } else {
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f13 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f9 * f7) + Math_fround(.5)))) / f9);
  f7 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(.5) - Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i3 + 12 >> 2])) * f9)))) / f9);
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(HEAPF32[i18 >> 2]);
  f6 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f9 * f11) + Math_fround(.5)))) / f11);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(f9 + f1) * f11) + Math_fround(.5)))) / f11);
 }
 i16 = HEAP32[i19 >> 2] | 0;
 i5 = HEAP32[i16 + 4 >> 2] | 0;
 i15 = HEAP32[i16 + 8 >> 2] | 0;
 i3 = i5;
 i4 = i15;
 do if ((i5 | 0) != (i15 | 0)) {
  i2 = HEAP32[i30 + 264 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i12 = i2 & 65535;
   i14 = i31 & 65535;
   i2 = i4 - i3 >> 3;
   if (!i2) i2 = i5; else {
    i3 = i2;
    i2 = i5;
    i4 = i5;
    do {
     i8 = (i3 | 0) / 2 | 0;
     i10 = i4 + (i8 << 3) | 0;
     i5 = HEAP16[i10 >> 1] | 0;
     if (i5 << 16 >> 16 == i12 << 16 >> 16) if ((HEAPU16[i4 + (i8 << 3) + 2 >> 1] | 0) < (i14 & 65535)) i22 = 15; else i3 = i8; else if ((i5 & 65535) < (i12 & 65535)) i22 = 15; else i3 = i8;
     if ((i22 | 0) == 15) {
      i22 = 0;
      i4 = i10 + 8 | 0;
      i3 = i3 + -1 - i8 | 0;
      i2 = i4;
     }
    } while ((i3 | 0) != 0);
   }
   if ((i2 | 0) != (i15 | 0)) {
    i3 = HEAP16[i2 >> 1] | 0;
    if (i12 << 16 >> 16 == i3 << 16 >> 16) {
     if ((i2 | 0) == (i15 | 0) ? 1 : (i14 & 65535) < (HEAPU16[i2 + 2 >> 1] | 0)) break;
    } else if ((i12 & 65535) < (i3 & 65535) | (i2 | 0) == (i15 | 0)) break;
    f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    if (HEAP32[i30 + 188 >> 2] | 0) {
     i23 = HEAP32[(HEAP32[i27 >> 2] | 0) + ((HEAP32[i26 >> 2] | 0) + -1 << 5) + 8 >> 2] | 0;
     f11 = Math_fround(i23 | 0);
     if (!i23) f11 = Math_fround(1.0); else {
      i2 = HEAP32[(HEAP32[i16 + 76 >> 2] | 0) + 36 >> 2] | 0;
      if (!i2) f11 = Math_fround(1.0); else f11 = Math_fround(f11 / Math_fround(i2 | 0));
     }
     f9 = Math_fround(f9 * f11);
    }
    if (!i17) {
     f11 = Math_fround(HEAPF32[i18 >> 2]);
     f9 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f9 * f11) + Math_fround(.5)))) / f11);
    }
    i23 = i30 + 320 | 0;
    HEAPF32[i23 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i23 >> 2]));
    i23 = i30 + 300 | 0;
    HEAPF32[i23 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i23 >> 2]));
    i23 = i30 + 304 | 0;
    HEAPF32[i23 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i23 >> 2]));
   }
  }
 } while (0);
 do if (!(HEAP32[i16 + 24 >> 2] | 0)) {
  i5 = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[i16 + 76 >> 2] | 0) | 0;
  if (!i5) f9 = f13; else {
   HEAP32[i21 >> 2] = i5;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i22 = 35; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
     i3 = HEAP32[i20 >> 2] | 0;
     i23 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i23 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i22 = 35; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i22 = 37;
   }
   if ((i22 | 0) == 35) i22 = 37;
   if ((i22 | 0) == 37) if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) {
    f9 = f13;
    break;
   }
   f11 = Math_fround(Math_fround(.5) / Math_fround(HEAPF32[i18 >> 2]));
   f6 = Math_fround(f6 - f11);
   f1 = Math_fround(f1 + f11);
   f9 = Math_fround(f13 - f11);
   f7 = Math_fround(f7 + f11);
   i10 = i24 + 8 | 0;
   i5 = Math_fround(HEAPF32[i10 >> 2]) >= Math_fround(0.0);
   f11 = i5 ? Math_fround(1.0) : Math_fround(-1.0);
   i5 = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[(HEAP32[i19 >> 2] | 0) + 76 >> 2] | 0) | 0;
   HEAP32[i21 >> 2] = i5;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i22 = 43; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
     i3 = HEAP32[i20 >> 2] | 0;
     i23 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i23 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i22 = 43; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i22 = 45;
    }
   }
   if ((i22 | 0) == 43) i22 = 45;
   if ((i22 | 0) == 45) i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   f11 = Math_fround(f11 / Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0));
   i8 = i24 + 12 | 0;
   i5 = Math_fround(HEAPF32[i8 >> 2]) >= Math_fround(0.0);
   f13 = i5 ? Math_fround(1.0) : Math_fround(-1.0);
   i5 = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[(HEAP32[i19 >> 2] | 0) + 76 >> 2] | 0) | 0;
   HEAP32[i21 >> 2] = i5;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i22 = 51; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
     i3 = HEAP32[i20 >> 2] | 0;
     i23 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i23 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i22 = 51; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i22 = 53;
    }
   }
   if ((i22 | 0) == 51) i22 = 53;
   if ((i22 | 0) == 53) i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   f13 = Math_fround(f13 / Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0));
   f33 = Math_fround(f11 * Math_fround(.5));
   HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f33);
   HEAPF32[i10 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i10 >> 2]));
   f11 = Math_fround(f13 * Math_fround(.5));
   i23 = i24 + 4 | 0;
   HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
   HEAPF32[i8 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
  }
 } else f9 = f13; while (0);
 i8 = i30 + 436 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i23 = i30 + 320 | 0;
 f34 = Math_fround(f6 + Math_fround(HEAPF32[i23 >> 2]));
 i22 = i30 + 324 | 0;
 f13 = Math_fround(f9 + Math_fround(HEAPF32[i22 >> 2]));
 i2 = i30 + 328 | 0;
 f33 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 HEAPF32[i3 >> 2] = f34;
 HEAPF32[i3 + 4 >> 2] = f13;
 HEAPF32[i3 + 8 >> 2] = f33;
 i3 = (HEAP8[i25 >> 0] | 0) != 0;
 i25 = i3 ? 2 : 0;
 i21 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f13 = Math_fround(f33 + Math_fround(HEAPF32[i24 + 12 >> 2]));
 HEAP32[i21 + (i25 * 60 | 0) + 28 >> 2] = i4;
 HEAPF32[i21 + (i25 * 60 | 0) + 32 >> 2] = f13;
 i25 = HEAP32[i8 >> 2] | 0;
 f34 = Math_fround(f1 + Math_fround(HEAPF32[i23 >> 2]));
 f11 = Math_fround(f9 + Math_fround(HEAPF32[i22 >> 2]));
 f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 HEAPF32[i25 + 60 >> 2] = f34;
 HEAPF32[i25 + 64 >> 2] = f11;
 HEAPF32[i25 + 68 >> 2] = f9;
 i25 = HEAP32[i8 >> 2] | 0;
 f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i24 + 8 >> 2]));
 HEAPF32[i25 + 88 >> 2] = f9;
 HEAPF32[i25 + 92 >> 2] = f13;
 i25 = HEAP32[i8 >> 2] | 0;
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i23 >> 2]));
 f13 = Math_fround(f7 + Math_fround(HEAPF32[i22 >> 2]));
 f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 HEAPF32[i25 + 120 >> 2] = f1;
 HEAPF32[i25 + 124 >> 2] = f13;
 HEAPF32[i25 + 128 >> 2] = f11;
 i3 = i3 ? 0 : 2;
 i25 = HEAP32[i8 >> 2] | 0;
 HEAPF32[i25 + (i3 * 60 | 0) + 28 >> 2] = f9;
 HEAPF32[i25 + (i3 * 60 | 0) + 32 >> 2] = f33;
 i3 = HEAP32[i8 >> 2] | 0;
 f9 = Math_fround(f6 + Math_fround(HEAPF32[i23 >> 2]));
 f11 = Math_fround(f7 + Math_fround(HEAPF32[i22 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 HEAPF32[i3 + 180 >> 2] = f9;
 HEAPF32[i3 + 184 >> 2] = f11;
 HEAPF32[i3 + 188 >> 2] = f13;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 + 208 >> 2] = i4;
 HEAPF32[i3 + 212 >> 2] = f33;
 i3 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i2 = i4 + (i3 << 5) + 4 | 0;
 do if (!(HEAP8[i30 + 252 >> 0] | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4 & 255;
  i2 = i4 >>> 8 & 255;
  i3 = i4 >>> 16;
 } else if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4 & 255;
  i2 = i4 >>> 8 & 255;
  i3 = i4 >>> 16;
  break;
 } else {
  i25 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP8[i4 + (i3 << 5) + 6 >> 0] | 0;
  i2 = HEAP8[i4 + (i3 << 5) + 5 >> 0] | 0;
  i3 = i25;
  i4 = i25;
  break;
 } while (0);
 i16 = HEAP32[i8 >> 2] | 0;
 i19 = (i2 & 255) << 8 | i5 & 255 | i3 << 16 & 16711680 | i4 & -16777216;
 HEAP32[i16 + 204 >> 2] = i19;
 HEAP32[i16 + 144 >> 2] = i19;
 HEAP32[i16 + 84 >> 2] = i19;
 HEAP32[i16 + 24 >> 2] = i19;
 HEAP32[i8 >> 2] = i16 + 240;
 i16 = HEAP32[i28 >> 2] << 2;
 i19 = HEAP32[(HEAP32[i27 >> 2] | 0) + ((HEAP32[i26 >> 2] | 0) + -1 << 5) + 12 >> 2] | 0;
 i20 = i30 + 20 + (i19 * 20 | 0) | 0;
 i5 = (i16 | 1) & 65535;
 i22 = i30 + 20 + (i19 * 20 | 0) + 12 | 0;
 i18 = HEAP32[i22 >> 2] | 0;
 i12 = i18 + 1 | 0;
 i21 = i30 + 20 + (i19 * 20 | 0) + 16 | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i12 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i2;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i3 = HEAP32[i21 >> 2] | 0;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i3 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i2;
   HEAP32[i20 >> 2] = i3;
   i3 = i2;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i12;
 i8 = HEAP32[i20 >> 2] | 0;
 HEAP16[i8 + (i18 << 1) >> 1] = i5;
 i15 = (i16 | 2) & 65535;
 i14 = i18 + 2 | 0;
 i2 = i3 & 2147483647;
 do if (i14 >>> 0 > i2 >>> 0) {
  i4 = i3 << 1;
  i4 = (i4 | 0) == 0 ? 1 : i4;
  if (i2 >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i4;
   i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i4 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = HEAP32[i21 >> 2] | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i4;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = i4;
   break;
  } else {
   i2 = i8;
   i10 = i8;
  }
 } else {
  i2 = i8;
  i10 = i8;
 } while (0);
 HEAP32[i22 >> 2] = i14;
 HEAP16[i2 + (i12 << 1) >> 1] = i15;
 i17 = i16 & 65535;
 i8 = i18 + 3 | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i5 = i3 << 1;
  i5 = (i5 | 0) == 0 ? 1 : i5;
  if (i4 >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i5;
   i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = HEAP32[i21 >> 2] | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i5;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = i5;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i8;
 HEAP16[i2 + (i14 << 1) >> 1] = i17;
 i14 = i18 + 4 | 0;
 i4 = i3 & 2147483647;
 do if (i14 >>> 0 > i4 >>> 0) {
  i5 = i3 << 1;
  i5 = (i5 | 0) == 0 ? 1 : i5;
  if (i4 >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i5;
   i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = HEAP32[i21 >> 2] | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i5;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = i5;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i14;
 HEAP16[i2 + (i8 << 1) >> 1] = i15;
 i8 = (i16 | 3) & 65535;
 i12 = i18 + 5 | 0;
 i4 = i3 & 2147483647;
 do if (i12 >>> 0 > i4 >>> 0) {
  i5 = i3 << 1;
  i5 = (i5 | 0) == 0 ? 1 : i5;
  if (i4 >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i5;
   i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = HEAP32[i21 >> 2] | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i5;
   HEAP32[i20 >> 2] = i10;
   i2 = i10;
   i3 = i5;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i12;
 HEAP16[i2 + (i14 << 1) >> 1] = i8;
 i8 = i18 + 6 | 0;
 i5 = i3 & 2147483647;
 do if (i8 >>> 0 > i5 >>> 0) {
  i4 = i3 << 1;
  i4 = (i4 | 0) == 0 ? 1 : i4;
  if (i5 >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i21 >> 2] = i4;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i4 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i20 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 1, 2, i30 + 20 + (i19 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] << 1 | 0) | 0;
   HEAP32[i21 >> 2] = i4;
   HEAP32[i20 >> 2] = i2;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i8;
 HEAP16[i2 + (i12 << 1) >> 1] = i17;
 i2 = i30 + 312 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i30 + 268 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i30 + 308 >> 2] = HEAP32[i23 >> 2];
 }
 f1 = Math_fround(HEAPF32[i30 + 220 >> 2]);
 if (f1 > Math_fround(0.0)) if (Math_fround(f29 + Math_fround(HEAPF32[i23 >> 2])) > f1) if (!(__ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv(i30) | 0)) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 i28 = i30 + 304 | 0;
 HEAPF32[i28 >> 2] = Math_fround(f29 + Math_fround(HEAPF32[i28 >> 2]));
 HEAPF32[i23 >> 2] = Math_fround(f29 + Math_fround(HEAPF32[i23 >> 2]));
 i28 = i30 + 300 | 0;
 HEAPF32[i28 >> 2] = Math_fround(f29 + Math_fround(HEAPF32[i28 >> 2]));
 HEAP32[i30 + 264 >> 2] = i31;
 i31 = 1;
 STACKTOP = i32;
 return i31 | 0;
}

function _XXH64(i3, i19, i2, i4) {
 i3 = i3 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i3 + i19 | 0;
 i1 = i19 >>> 0 > 31;
 if (!(i3 & 7)) {
  if (i1) {
   i18 = i20 + -32 | 0;
   i14 = _i64Add(i2 | 0, i4 | 0, -1379879466, 1625958382) | 0;
   i15 = getTempRet0() | 0;
   i16 = _i64Add(i2 | 0, i4 | 0, 668265295, -1028477379) | 0;
   i17 = getTempRet0() | 0;
   i10 = _i64Add(i2 | 0, i4 | 0, 2048144761, 1640531534) | 0;
   i11 = getTempRet0() | 0;
   do {
    i6 = i3;
    i1 = i6;
    i6 = i6 + 4 | 0;
    i6 = ___muldi3(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0, HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i6 = _i64Add(i6 | 0, getTempRet0() | 0, i14 | 0, i15 | 0) | 0;
    i1 = getTempRet0() | 0;
    i8 = _bitshift64Shl(i6 | 0, i1 | 0, 31) | 0;
    i5 = getTempRet0() | 0;
    i1 = _bitshift64Lshr(i6 | 0, i1 | 0, 33) | 0;
    i1 = i8 | i1;
    i5 = i5 | (getTempRet0() | 0);
    i14 = ___muldi3(i1 | 0, i5 | 0, -2048144761, -1640531535) | 0;
    i15 = getTempRet0() | 0;
    i8 = i3 + 8 | 0;
    i6 = i8;
    i8 = i8 + 4 | 0;
    i8 = ___muldi3(HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0, HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i8 = _i64Add(i8 | 0, getTempRet0() | 0, i16 | 0, i17 | 0) | 0;
    i6 = getTempRet0() | 0;
    i12 = _bitshift64Shl(i8 | 0, i6 | 0, 31) | 0;
    i7 = getTempRet0() | 0;
    i6 = _bitshift64Lshr(i8 | 0, i6 | 0, 33) | 0;
    i6 = i12 | i6;
    i7 = i7 | (getTempRet0() | 0);
    i16 = ___muldi3(i6 | 0, i7 | 0, -2048144761, -1640531535) | 0;
    i17 = getTempRet0() | 0;
    i12 = i3 + 16 | 0;
    i8 = i12;
    i12 = i12 + 4 | 0;
    i12 = ___muldi3(HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24 | 0, HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i12 = _i64Add(i12 | 0, getTempRet0() | 0, i2 | 0, i4 | 0) | 0;
    i8 = getTempRet0() | 0;
    i22 = _bitshift64Shl(i12 | 0, i8 | 0, 31) | 0;
    i9 = getTempRet0() | 0;
    i8 = _bitshift64Lshr(i12 | 0, i8 | 0, 33) | 0;
    i8 = i22 | i8;
    i9 = i9 | (getTempRet0() | 0);
    i2 = ___muldi3(i8 | 0, i9 | 0, -2048144761, -1640531535) | 0;
    i4 = getTempRet0() | 0;
    i22 = i3 + 24 | 0;
    i12 = i22;
    i22 = i22 + 4 | 0;
    i22 = ___muldi3(HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i22 = _i64Add(i22 | 0, getTempRet0() | 0, i10 | 0, i11 | 0) | 0;
    i12 = getTempRet0() | 0;
    i21 = _bitshift64Shl(i22 | 0, i12 | 0, 31) | 0;
    i13 = getTempRet0() | 0;
    i12 = _bitshift64Lshr(i22 | 0, i12 | 0, 33) | 0;
    i12 = i21 | i12;
    i13 = i13 | (getTempRet0() | 0);
    i10 = ___muldi3(i12 | 0, i13 | 0, -2048144761, -1640531535) | 0;
    i11 = getTempRet0() | 0;
    i3 = i3 + 32 | 0;
   } while (i3 >>> 0 <= i18 >>> 0);
   i18 = ___muldi3(i1 | 0, i5 | 0, 198677774, 1013904227) | 0;
   i22 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i14 | 0, i15 | 0, 63) | 0;
   i22 = getTempRet0() | 0 | i22;
   i14 = ___muldi3(i6 | 0, i7 | 0, -169524352, 465361090) | 0;
   i15 = getTempRet0() | 0;
   i17 = _bitshift64Lshr(i16 | 0, i17 | 0, 57) | 0;
   i22 = _i64Add(i17 | i14 | 0, getTempRet0() | 0 | i15 | 0, i21 | i18 | 0, i22 | 0) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i8 | 0, i9 | 0, -1129811968, 2006653022) | 0;
   i17 = getTempRet0() | 0;
   i2 = _bitshift64Lshr(i2 | 0, i4 | 0, 52) | 0;
   i17 = _i64Add(i22 | 0, i18 | 0, i2 | i21 | 0, getTempRet0() | 0 | i17 | 0) | 0;
   i21 = getTempRet0() | 0;
   i2 = ___muldi3(i12 | 0, i13 | 0, 706478080, -423225425) | 0;
   i18 = getTempRet0() | 0;
   i22 = _bitshift64Lshr(i10 | 0, i11 | 0, 46) | 0;
   i18 = _i64Add(i17 | 0, i21 | 0, i22 | i2 | 0, getTempRet0() | 0 | i18 | 0) | 0;
   i2 = getTempRet0() | 0;
   i22 = ___muldi3(i1 | 0, i5 | 0, 259615913, -554476799) | 0;
   i21 = getTempRet0() | 0;
   i1 = ___muldi3(i1 | 0, i5 | 0, -2147483648, -2017675692) | 0;
   i17 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i22 | 0, i21 | 0, 33) | 0;
   i17 = ___muldi3(i21 | i1 | 0, getTempRet0() | 0 | i17 | 0, -2048144761, -1640531535) | 0;
   i2 = ___muldi3(i18 ^ i17 | 0, i2 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i17 = getTempRet0() | 0;
   i1 = ___muldi3(i6 | 0, i7 | 0, 259615913, -554476799) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i6 | 0, i7 | 0, -2147483648, -2017675692) | 0;
   i22 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i1 | 0, i18 | 0, 33) | 0;
   i22 = ___muldi3(i18 | i21 | 0, getTempRet0() | 0 | i22 | 0, -2048144761, -1640531535) | 0;
   i17 = ___muldi3(i2 ^ i22 | 0, i17 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i17 = _i64Add(i17 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i22 = getTempRet0() | 0;
   i2 = ___muldi3(i8 | 0, i9 | 0, 259615913, -554476799) | 0;
   i21 = getTempRet0() | 0;
   i18 = ___muldi3(i8 | 0, i9 | 0, -2147483648, -2017675692) | 0;
   i1 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i2 | 0, i21 | 0, 33) | 0;
   i1 = ___muldi3(i21 | i18 | 0, getTempRet0() | 0 | i1 | 0, -2048144761, -1640531535) | 0;
   i22 = ___muldi3(i17 ^ i1 | 0, i22 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i22 = _i64Add(i22 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i1 = getTempRet0() | 0;
   i17 = ___muldi3(i12 | 0, i13 | 0, 259615913, -554476799) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i12 | 0, i13 | 0, -2147483648, -2017675692) | 0;
   i2 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i17 | 0, i18 | 0, 33) | 0;
   i2 = ___muldi3(i18 | i21 | 0, getTempRet0() | 0 | i2 | 0, -2048144761, -1640531535) | 0;
   i1 = ___muldi3(i22 ^ i2 | 0, i1 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i1 = _i64Add(i1 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i2 = getTempRet0() | 0;
  } else {
   i1 = _i64Add(i2 | 0, i4 | 0, 374761413, 668265263) | 0;
   i2 = getTempRet0() | 0;
  }
  i2 = _i64Add(i1 | 0, i2 | 0, i19 | 0, 0) | 0;
  i1 = getTempRet0() | 0;
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > i20 >>> 0) i4 = i3; else while (1) {
   i22 = i3;
   i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
   i3 = i3 + 4 | 0;
   i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   i19 = ___muldi3(i22 | 0, i3 | 0, 668265295, -1028477379) | 0;
   i21 = getTempRet0() | 0;
   i3 = ___muldi3(i22 | 0, i3 | 0, -2147483648, -1813351001) | 0;
   i22 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i19 | 0, i21 | 0, 33) | 0;
   i22 = ___muldi3(i21 | i3 | 0, getTempRet0() | 0 | i22 | 0, -2048144761, -1640531535) | 0;
   i22 = i22 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i3 = _bitshift64Shl(i22 | 0, i1 | 0, 27) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i22 | 0, i1 | 0, 37) | 0;
   i2 = ___muldi3(i3 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i1 = getTempRet0() | 0;
   i3 = i4 + 8 | 0;
   if (i3 >>> 0 > i20 >>> 0) break; else {
    i22 = i4;
    i4 = i3;
    i3 = i22;
   }
  }
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i20 >>> 0) i3 = i4; else {
   i21 = ___muldi3(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24 | 0, 0, -2048144761, -1640531535) | 0;
   i21 = i21 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i22 = _bitshift64Shl(i21 | 0, i1 | 0, 23) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i21 | 0, i1 | 0, 41) | 0;
   i2 = ___muldi3(i22 | i1 | 0, i2 | (getTempRet0() | 0) | 0, 668265295, -1028477379) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1640531463, 374761393) | 0;
   i1 = getTempRet0() | 0;
  }
  if (i3 >>> 0 < i20 >>> 0) do {
   i21 = ___muldi3(HEAPU8[i3 >> 0] | 0 | 0, 0, 374761413, 668265263) | 0;
   i21 = i21 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i22 = _bitshift64Shl(i21 | 0, i1 | 0, 11) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i21 | 0, i1 | 0, 53) | 0;
   i2 = ___muldi3(i22 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i1 = getTempRet0() | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i20 | 0));
  i20 = _bitshift64Lshr(i2 | 0, i1 | 0, 33) | 0;
  i20 = ___muldi3(i20 ^ i2 | 0, (getTempRet0() | 0) ^ i1 | 0, 668265295, -1028477379) | 0;
  i22 = getTempRet0() | 0;
  i21 = _bitshift64Lshr(i20 | 0, i22 | 0, 29) | 0;
  i22 = ___muldi3(i21 ^ i20 | 0, (getTempRet0() | 0) ^ i22 | 0, -1640531463, 374761393) | 0;
  i20 = getTempRet0() | 0;
  i21 = i20;
  i22 = i20 ^ i22;
  setTempRet0(i21 | 0);
  return i22 | 0;
 } else {
  if (i1) {
   i18 = i20 + -32 | 0;
   i14 = _i64Add(i2 | 0, i4 | 0, -1379879466, 1625958382) | 0;
   i15 = getTempRet0() | 0;
   i16 = _i64Add(i2 | 0, i4 | 0, 668265295, -1028477379) | 0;
   i17 = getTempRet0() | 0;
   i10 = _i64Add(i2 | 0, i4 | 0, 2048144761, 1640531534) | 0;
   i11 = getTempRet0() | 0;
   do {
    i6 = i3;
    i1 = i6;
    i6 = i6 + 4 | 0;
    i6 = ___muldi3(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0, HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i6 = _i64Add(i6 | 0, getTempRet0() | 0, i14 | 0, i15 | 0) | 0;
    i1 = getTempRet0() | 0;
    i8 = _bitshift64Shl(i6 | 0, i1 | 0, 31) | 0;
    i5 = getTempRet0() | 0;
    i1 = _bitshift64Lshr(i6 | 0, i1 | 0, 33) | 0;
    i1 = i8 | i1;
    i5 = i5 | (getTempRet0() | 0);
    i14 = ___muldi3(i1 | 0, i5 | 0, -2048144761, -1640531535) | 0;
    i15 = getTempRet0() | 0;
    i8 = i3 + 8 | 0;
    i6 = i8;
    i8 = i8 + 4 | 0;
    i8 = ___muldi3(HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0, HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i8 = _i64Add(i8 | 0, getTempRet0() | 0, i16 | 0, i17 | 0) | 0;
    i6 = getTempRet0() | 0;
    i12 = _bitshift64Shl(i8 | 0, i6 | 0, 31) | 0;
    i7 = getTempRet0() | 0;
    i6 = _bitshift64Lshr(i8 | 0, i6 | 0, 33) | 0;
    i6 = i12 | i6;
    i7 = i7 | (getTempRet0() | 0);
    i16 = ___muldi3(i6 | 0, i7 | 0, -2048144761, -1640531535) | 0;
    i17 = getTempRet0() | 0;
    i12 = i3 + 16 | 0;
    i8 = i12;
    i12 = i12 + 4 | 0;
    i12 = ___muldi3(HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24 | 0, HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i12 = _i64Add(i12 | 0, getTempRet0() | 0, i2 | 0, i4 | 0) | 0;
    i8 = getTempRet0() | 0;
    i21 = _bitshift64Shl(i12 | 0, i8 | 0, 31) | 0;
    i9 = getTempRet0() | 0;
    i8 = _bitshift64Lshr(i12 | 0, i8 | 0, 33) | 0;
    i8 = i21 | i8;
    i9 = i9 | (getTempRet0() | 0);
    i2 = ___muldi3(i8 | 0, i9 | 0, -2048144761, -1640531535) | 0;
    i4 = getTempRet0() | 0;
    i21 = i3 + 24 | 0;
    i12 = i21;
    i21 = i21 + 4 | 0;
    i21 = ___muldi3(HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
    i21 = _i64Add(i21 | 0, getTempRet0() | 0, i10 | 0, i11 | 0) | 0;
    i12 = getTempRet0() | 0;
    i22 = _bitshift64Shl(i21 | 0, i12 | 0, 31) | 0;
    i13 = getTempRet0() | 0;
    i12 = _bitshift64Lshr(i21 | 0, i12 | 0, 33) | 0;
    i12 = i22 | i12;
    i13 = i13 | (getTempRet0() | 0);
    i10 = ___muldi3(i12 | 0, i13 | 0, -2048144761, -1640531535) | 0;
    i11 = getTempRet0() | 0;
    i3 = i3 + 32 | 0;
   } while (i3 >>> 0 <= i18 >>> 0);
   i18 = ___muldi3(i1 | 0, i5 | 0, 198677774, 1013904227) | 0;
   i22 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i14 | 0, i15 | 0, 63) | 0;
   i22 = getTempRet0() | 0 | i22;
   i14 = ___muldi3(i6 | 0, i7 | 0, -169524352, 465361090) | 0;
   i15 = getTempRet0() | 0;
   i17 = _bitshift64Lshr(i16 | 0, i17 | 0, 57) | 0;
   i22 = _i64Add(i17 | i14 | 0, getTempRet0() | 0 | i15 | 0, i21 | i18 | 0, i22 | 0) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i8 | 0, i9 | 0, -1129811968, 2006653022) | 0;
   i17 = getTempRet0() | 0;
   i2 = _bitshift64Lshr(i2 | 0, i4 | 0, 52) | 0;
   i17 = _i64Add(i22 | 0, i18 | 0, i2 | i21 | 0, getTempRet0() | 0 | i17 | 0) | 0;
   i21 = getTempRet0() | 0;
   i2 = ___muldi3(i12 | 0, i13 | 0, 706478080, -423225425) | 0;
   i18 = getTempRet0() | 0;
   i22 = _bitshift64Lshr(i10 | 0, i11 | 0, 46) | 0;
   i18 = _i64Add(i17 | 0, i21 | 0, i22 | i2 | 0, getTempRet0() | 0 | i18 | 0) | 0;
   i2 = getTempRet0() | 0;
   i22 = ___muldi3(i1 | 0, i5 | 0, 259615913, -554476799) | 0;
   i21 = getTempRet0() | 0;
   i1 = ___muldi3(i1 | 0, i5 | 0, -2147483648, -2017675692) | 0;
   i17 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i22 | 0, i21 | 0, 33) | 0;
   i17 = ___muldi3(i21 | i1 | 0, getTempRet0() | 0 | i17 | 0, -2048144761, -1640531535) | 0;
   i2 = ___muldi3(i18 ^ i17 | 0, i2 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i17 = getTempRet0() | 0;
   i1 = ___muldi3(i6 | 0, i7 | 0, 259615913, -554476799) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i6 | 0, i7 | 0, -2147483648, -2017675692) | 0;
   i22 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i1 | 0, i18 | 0, 33) | 0;
   i22 = ___muldi3(i18 | i21 | 0, getTempRet0() | 0 | i22 | 0, -2048144761, -1640531535) | 0;
   i17 = ___muldi3(i2 ^ i22 | 0, i17 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i17 = _i64Add(i17 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i22 = getTempRet0() | 0;
   i2 = ___muldi3(i8 | 0, i9 | 0, 259615913, -554476799) | 0;
   i21 = getTempRet0() | 0;
   i18 = ___muldi3(i8 | 0, i9 | 0, -2147483648, -2017675692) | 0;
   i1 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i2 | 0, i21 | 0, 33) | 0;
   i1 = ___muldi3(i21 | i18 | 0, getTempRet0() | 0 | i1 | 0, -2048144761, -1640531535) | 0;
   i22 = ___muldi3(i17 ^ i1 | 0, i22 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i22 = _i64Add(i22 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i1 = getTempRet0() | 0;
   i17 = ___muldi3(i12 | 0, i13 | 0, 259615913, -554476799) | 0;
   i18 = getTempRet0() | 0;
   i21 = ___muldi3(i12 | 0, i13 | 0, -2147483648, -2017675692) | 0;
   i2 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i17 | 0, i18 | 0, 33) | 0;
   i2 = ___muldi3(i18 | i21 | 0, getTempRet0() | 0 | i2 | 0, -2048144761, -1640531535) | 0;
   i1 = ___muldi3(i22 ^ i2 | 0, i1 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i1 = _i64Add(i1 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i2 = getTempRet0() | 0;
  } else {
   i1 = _i64Add(i2 | 0, i4 | 0, 374761413, 668265263) | 0;
   i2 = getTempRet0() | 0;
  }
  i2 = _i64Add(i1 | 0, i2 | 0, i19 | 0, 0) | 0;
  i1 = getTempRet0() | 0;
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > i20 >>> 0) i4 = i3; else while (1) {
   i22 = i3;
   i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
   i3 = i3 + 4 | 0;
   i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   i19 = ___muldi3(i22 | 0, i3 | 0, 668265295, -1028477379) | 0;
   i21 = getTempRet0() | 0;
   i3 = ___muldi3(i22 | 0, i3 | 0, -2147483648, -1813351001) | 0;
   i22 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i19 | 0, i21 | 0, 33) | 0;
   i22 = ___muldi3(i21 | i3 | 0, getTempRet0() | 0 | i22 | 0, -2048144761, -1640531535) | 0;
   i22 = i22 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i3 = _bitshift64Shl(i22 | 0, i1 | 0, 27) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i22 | 0, i1 | 0, 37) | 0;
   i2 = ___muldi3(i3 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i1 = getTempRet0() | 0;
   i3 = i4 + 8 | 0;
   if (i3 >>> 0 > i20 >>> 0) break; else {
    i22 = i4;
    i4 = i3;
    i3 = i22;
   }
  }
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i20 >>> 0) i3 = i4; else {
   i21 = ___muldi3(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24 | 0, 0, -2048144761, -1640531535) | 0;
   i21 = i21 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i22 = _bitshift64Shl(i21 | 0, i1 | 0, 23) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i21 | 0, i1 | 0, 41) | 0;
   i2 = ___muldi3(i22 | i1 | 0, i2 | (getTempRet0() | 0) | 0, 668265295, -1028477379) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1640531463, 374761393) | 0;
   i1 = getTempRet0() | 0;
  }
  if (i3 >>> 0 < i20 >>> 0) do {
   i21 = ___muldi3(HEAPU8[i3 >> 0] | 0 | 0, 0, 374761413, 668265263) | 0;
   i21 = i21 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i22 = _bitshift64Shl(i21 | 0, i1 | 0, 11) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i21 | 0, i1 | 0, 53) | 0;
   i2 = ___muldi3(i22 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i1 = getTempRet0() | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i20 | 0));
  i20 = _bitshift64Lshr(i2 | 0, i1 | 0, 33) | 0;
  i20 = ___muldi3(i20 ^ i2 | 0, (getTempRet0() | 0) ^ i1 | 0, 668265295, -1028477379) | 0;
  i22 = getTempRet0() | 0;
  i21 = _bitshift64Lshr(i20 | 0, i22 | 0, 29) | 0;
  i22 = ___muldi3(i21 ^ i20 | 0, (getTempRet0() | 0) ^ i22 | 0, -1640531463, 374761393) | 0;
  i20 = getTempRet0() | 0;
  i21 = i20;
  i22 = i20 ^ i22;
  setTempRet0(i21 | 0);
  return i22 | 0;
 }
 return 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i57, i59, i58, i1, i81, i82, i83, i84, i86, i88, i74) {
 i57 = i57 | 0;
 i59 = i59 | 0;
 i58 = i58 | 0;
 i1 = i1 | 0;
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 i86 = i86 | 0;
 i88 = i88 | 0;
 i74 = i74 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f75 = f0, f76 = f0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i85 = 0, i87 = 0, i89 = 0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i89 + 400 | 0;
 i60 = i89 + 384 | 0;
 i2 = i89 + 304 | 0;
 i68 = i89 + 516 | 0;
 i67 = i89 + 504 | 0;
 i79 = i89 + 320 | 0;
 i77 = i89 + 240 | 0;
 i78 = i89 + 176 | 0;
 i85 = i89 + 488 | 0;
 i87 = i89 + 472 | 0;
 i61 = i89 + 464 | 0;
 i80 = i89 + 160 | 0;
 i25 = i89 + 144 | 0;
 i24 = i89 + 128 | 0;
 i26 = i89 + 452 | 0;
 i51 = i89 + 112 | 0;
 i63 = i89 + 96 | 0;
 i62 = i89 + 80 | 0;
 i70 = i89 + 64 | 0;
 i71 = i89 + 48 | 0;
 i69 = i89 + 440 | 0;
 i55 = i89 + 32 | 0;
 i54 = i89 + 428 | 0;
 i65 = i89 + 16 | 0;
 i66 = i89;
 i64 = i89 + 416 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f75 = Math_fround(HEAPF32[i57 + 16 >> 2]);
 f76 = Math_fround(HEAPF32[i59 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f53 = Math_fround(HEAPF32[i57 + 32 >> 2]);
 f73 = Math_fround(HEAPF32[i59 + 32 >> 2]);
 f53 = Math_fround((f53 > f73 ? f73 : f53) * Math_fround(.100000001));
 f53 = Math_fround(f53 * f53);
 f73 = Math_fround(f75 + f76);
 HEAP32[i61 >> 2] = 0;
 if (!(HEAP8[i74 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  i52 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i52 ? f5 : Math_fround(1.0);
  f6 = i52 ? f6 : Math_fround(0.0);
  f7 = i52 ? f7 : Math_fround(0.0);
  HEAPF32[i80 >> 2] = f5;
  HEAPF32[i80 + 4 >> 2] = f6;
  HEAPF32[i80 + 8 >> 2] = f7;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i51 >> 2] = HEAP32[i80 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i80 + 12 >> 2];
  i52 = i80;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i72 = 7;
 } else {
  HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i10 = i57 + 200 | 0;
  i11 = i57 + 96 | 0;
  i12 = i57 + 112 | 0;
  i13 = i57 + 128 | 0;
  i14 = i57 + 100 | 0;
  i15 = i57 + 116 | 0;
  i16 = i57 + 132 | 0;
  i17 = i57 + 104 | 0;
  i18 = i57 + 120 | 0;
  i19 = i59 + 136 | 0;
  i20 = i25 + 4 | 0;
  i21 = i25 + 8 | 0;
  i22 = i25 + 12 | 0;
  f4 = Math_fround(HEAPF32[i57 + 136 >> 2]);
  f5 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  f8 = Math_fround(HEAPF32[i58 >> 2]);
  f33 = Math_fround(HEAPF32[i58 + 16 >> 2]);
  f34 = Math_fround(HEAPF32[i58 + 32 >> 2]);
  f35 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i58 + 20 >> 2]);
  f37 = Math_fround(HEAPF32[i58 + 36 >> 2]);
  f38 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i58 + 24 >> 2]);
  f40 = Math_fround(HEAPF32[i58 + 40 >> 2]);
  i2 = HEAP32[i59 + 200 >> 2] | 0;
  f41 = Math_fround(HEAPF32[i59 + 96 >> 2]);
  f42 = Math_fround(HEAPF32[i59 + 112 >> 2]);
  f43 = Math_fround(HEAPF32[i59 + 128 >> 2]);
  f44 = Math_fround(HEAPF32[i59 + 100 >> 2]);
  f45 = Math_fround(HEAPF32[i59 + 116 >> 2]);
  f46 = Math_fround(HEAPF32[i59 + 132 >> 2]);
  f47 = Math_fround(HEAPF32[i59 + 104 >> 2]);
  f48 = Math_fround(HEAPF32[i59 + 120 >> 2]);
  i3 = 0;
  i23 = 0;
  while (1) {
   i52 = HEAPU8[i86 + i23 >> 0] | 0;
   HEAP32[i85 + (i23 << 2) >> 2] = i52;
   i1 = HEAPU8[i88 + i23 >> 0] | 0;
   HEAP32[i87 + (i23 << 2) >> 2] = i1;
   i50 = HEAP32[i10 >> 2] | 0;
   f94 = Math_fround(HEAPF32[i50 + (i52 * 12 | 0) >> 2]);
   f95 = Math_fround(HEAPF32[i50 + (i52 * 12 | 0) + 4 >> 2]);
   f93 = Math_fround(HEAPF32[i50 + (i52 * 12 | 0) + 8 >> 2]);
   f97 = Math_fround(f94 * Math_fround(HEAPF32[i11 >> 2]));
   f97 = Math_fround(f97 + Math_fround(f95 * Math_fround(HEAPF32[i12 >> 2])));
   f97 = Math_fround(f97 + Math_fround(f93 * Math_fround(HEAPF32[i13 >> 2])));
   f96 = Math_fround(f94 * Math_fround(HEAPF32[i14 >> 2]));
   f96 = Math_fround(f96 + Math_fround(f95 * Math_fround(HEAPF32[i15 >> 2])));
   f96 = Math_fround(f96 + Math_fround(f93 * Math_fround(HEAPF32[i16 >> 2])));
   f94 = Math_fround(f94 * Math_fround(HEAPF32[i17 >> 2]));
   f93 = Math_fround(Math_fround(f94 + Math_fround(f95 * Math_fround(HEAPF32[i18 >> 2]))) + Math_fround(f93 * f4));
   f95 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f97 * f8) + Math_fround(f96 * f33)) + Math_fround(f93 * f34)));
   f94 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f97 * f35) + Math_fround(f96 * f36)) + Math_fround(f93 * f37)));
   f93 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f97 * f38) + Math_fround(f96 * f39)) + Math_fround(f93 * f40)));
   f96 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) >> 2]);
   f97 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]);
   f90 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 8 >> 2]);
   f92 = Math_fround(Math_fround(Math_fround(f96 * f41) + Math_fround(f97 * f42)) + Math_fround(f90 * f43));
   f91 = Math_fround(Math_fround(Math_fround(f96 * f44) + Math_fround(f97 * f45)) + Math_fround(f90 * f46));
   f97 = Math_fround(Math_fround(f96 * f47) + Math_fround(f97 * f48));
   f90 = Math_fround(f97 + Math_fround(f90 * Math_fround(HEAPF32[i19 >> 2])));
   f97 = Math_fround(f94 - f91);
   f96 = Math_fround(f93 - f90);
   HEAPF32[i25 >> 2] = Math_fround(f95 - f92);
   HEAPF32[i20 >> 2] = f97;
   HEAPF32[i21 >> 2] = f96;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   HEAPF32[i77 + (i3 << 4) >> 2] = f95;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f94;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f93;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i78 + (i3 << 4) >> 2] = f92;
   HEAPF32[i78 + (i3 << 4) + 4 >> 2] = f91;
   HEAPF32[i78 + (i3 << 4) + 8 >> 2] = f90;
   HEAPF32[i78 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i3 + 1 | 0;
   i52 = i79 + (i3 << 4) | 0;
   HEAP32[i52 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   HEAP32[i52 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
   HEAP32[i52 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
   i23 = i23 + 1 | 0;
   if (i23 >>> 0 >= (HEAPU8[i74 >> 0] | 0) >>> 0) break; else i3 = i1;
  }
  HEAP32[i61 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i24, i79, i77, i78, i85, i87, i25, i61);
  HEAP32[i80 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i80 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i80 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i80 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i80 >> 2]);
  f6 = Math_fround(HEAPF32[i80 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i80 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i68 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i67 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i51 >> 2] = HEAP32[i80 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i80 + 12 >> 2];
  if (f4 > f53) {
   i52 = i80;
   i72 = 7;
  } else i2 = HEAP32[i61 >> 2] | 0;
 }
 do if ((i72 | 0) == 7) {
  i49 = i80 + 4 | 0;
  i50 = i80 + 8 | 0;
  i10 = i58 + 4 | 0;
  i11 = i58 + 8 | 0;
  i12 = i58 + 16 | 0;
  i13 = i58 + 20 | 0;
  i14 = i58 + 24 | 0;
  i15 = i58 + 32 | 0;
  i16 = i58 + 36 | 0;
  i17 = i58 + 40 | 0;
  i18 = i56 + 4 | 0;
  i19 = i56 + 8 | 0;
  i20 = i56 + 12 | 0;
  i21 = i58 + 48 | 0;
  i22 = i58 + 52 | 0;
  i23 = i58 + 56 | 0;
  i24 = i60 + 4 | 0;
  i25 = i60 + 8 | 0;
  i26 = i63 + 4 | 0;
  i27 = i63 + 8 | 0;
  i28 = i62 + 4 | 0;
  i29 = i62 + 8 | 0;
  i30 = i62 + 12 | 0;
  i31 = i57 + 48 | 0;
  i32 = i59 + 48 | 0;
  while (1) {
   HEAP32[i67 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i51 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i51 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i51 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
   f93 = Math_fround(-f5);
   f90 = Math_fround(-f6);
   f91 = Math_fround(-f7);
   i3 = HEAP32[i61 >> 2] | 0;
   i2 = i77 + (i3 << 4) | 0;
   f95 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f93);
   f95 = Math_fround(f95 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f90));
   f95 = Math_fround(f95 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f91));
   f94 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f93);
   f94 = Math_fround(f94 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f90));
   f94 = Math_fround(f94 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f91));
   f93 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f93);
   f90 = Math_fround(f93 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f90));
   f91 = Math_fround(f90 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f91));
   HEAPF32[i56 >> 2] = f95;
   HEAPF32[i18 >> 2] = f94;
   HEAPF32[i19 >> 2] = f91;
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i60, i57, i56, i2, i85 + (i3 << 2) | 0);
   f91 = Math_fround(HEAPF32[i21 >> 2]);
   f94 = Math_fround(HEAPF32[i22 >> 2]);
   f95 = Math_fround(HEAPF32[i23 >> 2]);
   f90 = Math_fround(HEAPF32[i60 >> 2]);
   f93 = Math_fround(HEAPF32[i24 >> 2]);
   f97 = Math_fround(HEAPF32[i25 >> 2]);
   f96 = Math_fround(f90 * Math_fround(HEAPF32[i58 >> 2]));
   f96 = Math_fround(f96 + Math_fround(f93 * Math_fround(HEAPF32[i12 >> 2])));
   f96 = Math_fround(f96 + Math_fround(f97 * Math_fround(HEAPF32[i15 >> 2])));
   f92 = Math_fround(f90 * Math_fround(HEAPF32[i10 >> 2]));
   f92 = Math_fround(f92 + Math_fround(f93 * Math_fround(HEAPF32[i13 >> 2])));
   f92 = Math_fround(f92 + Math_fround(f97 * Math_fround(HEAPF32[i16 >> 2])));
   f90 = Math_fround(f90 * Math_fround(HEAPF32[i11 >> 2]));
   f93 = Math_fround(f90 + Math_fround(f93 * Math_fround(HEAPF32[i14 >> 2])));
   f96 = Math_fround(f91 + f96);
   f92 = Math_fround(f94 + f92);
   f97 = Math_fround(f95 + Math_fround(f93 + Math_fround(f97 * Math_fround(HEAPF32[i17 >> 2]))));
   HEAPF32[i2 >> 2] = f96;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f92;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f97;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i61 >> 2] | 0;
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i63, i59, i80, i78 + (i3 << 4) | 0, i87 + (i3 << 2) | 0);
   f93 = Math_fround(HEAPF32[i63 >> 2]);
   f95 = Math_fround(HEAPF32[i26 >> 2]);
   f93 = Math_fround(f96 - f93);
   f95 = Math_fround(f92 - f95);
   f97 = Math_fround(f97 - Math_fround(HEAPF32[i27 >> 2]));
   HEAPF32[i62 >> 2] = f93;
   HEAPF32[i28 >> 2] = f95;
   HEAPF32[i29 >> 2] = f97;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i61 >> 2] | 0;
   i2 = i79 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
   f92 = Math_fround(HEAPF32[i31 >> 2]);
   f96 = Math_fround(HEAPF32[i32 >> 2]);
   f96 = f92 > f96 ? f92 : f96;
   f9 = f9 > f96 ? f9 : f96;
   f96 = Math_fround(f73 + f9);
   f96 = Math_fround(f4 * Math_fround(f96 * f96));
   f92 = Math_fround(HEAPF32[i80 >> 2]);
   f94 = Math_fround(HEAPF32[i49 >> 2]);
   f97 = Math_fround(Math_fround(Math_fround(f92 * f93) + Math_fround(f94 * f95)) + Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f97));
   i2 = f97 > Math_fround(0.0) & Math_fround(f97 * f97) > f96;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f97) | i2) {
    i72 = 9;
    break;
   }
   HEAP32[i61 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i55, i79, i77, i78, i85, i87, i62, i61);
   HEAP32[i52 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i52 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   HEAP32[i52 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i80 >> 2]);
   f6 = Math_fround(HEAPF32[i49 >> 2]);
   f7 = Math_fround(HEAPF32[i50 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i68 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i68 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i68 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f53 & i1)) break; else f4 = f8;
  }
  if ((i72 | 0) == 9) {
   if (i86 | 0) {
    HEAP8[i74 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
      HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i88 = 0;
    STACKTOP = i89;
    return i88 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i79, i77, i78, i80, i70, i71, i3);
   f94 = Math_fround(Math_sqrt(Math_fround(f4)));
   f95 = Math_fround(HEAPF32[i80 >> 2]);
   f96 = Math_fround(HEAPF32[i49 >> 2]);
   f97 = Math_fround(Math_fround(1.0) / f94);
   f95 = Math_fround(f95 * f97);
   f96 = Math_fround(f96 * f97);
   f97 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f97);
   f93 = Math_fround(HEAPF32[i70 >> 2]);
   f92 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f92 = Math_fround(f92 - Math_fround(f75 * f96));
   f91 = Math_fround(Math_fround(HEAPF32[i70 + 8 >> 2]) - Math_fround(f75 * f97));
   HEAPF32[i81 >> 2] = Math_fround(f93 - Math_fround(f75 * f95));
   HEAPF32[i81 + 4 >> 2] = f92;
   HEAPF32[i81 + 8 >> 2] = f91;
   HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
   f91 = Math_fround(HEAPF32[i71 >> 2]);
   f92 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f92 = Math_fround(Math_fround(f76 * f96) + f92);
   f93 = Math_fround(Math_fround(f76 * f97) + Math_fround(HEAPF32[i71 + 8 >> 2]));
   HEAPF32[i82 >> 2] = Math_fround(Math_fround(f76 * f95) + f91);
   HEAPF32[i82 + 4 >> 2] = f92;
   HEAPF32[i82 + 8 >> 2] = f93;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i84 >> 2] = Math_fround(f94 - f73);
   i88 = i84 + 4 | 0;
   HEAP32[i88 >> 2] = HEAP32[i69 >> 2];
   HEAP32[i88 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
   HEAP32[i88 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
   HEAPF32[i83 >> 2] = f95;
   HEAPF32[i83 + 4 >> 2] = f96;
   HEAPF32[i83 + 8 >> 2] = f97;
   HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
   i88 = 1;
   STACKTOP = i89;
   return i88 | 0;
  }
  i2 = HEAP32[i61 >> 2] | 0;
  if (i1) {
   if (!i86) i1 = 6; else break;
   STACKTOP = i89;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i86 | 0) {
   HEAP8[i74 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
     HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i79, i77, i78, i80, i65, i66, i2);
  HEAP32[i68 >> 2] = HEAP32[i67 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
  f94 = Math_fround(Math_sqrt(Math_fround(f4)));
  f95 = Math_fround(HEAPF32[i80 >> 2]);
  f96 = Math_fround(HEAPF32[i80 + 4 >> 2]);
  f97 = Math_fround(Math_fround(1.0) / f94);
  f95 = Math_fround(f95 * f97);
  f96 = Math_fround(f96 * f97);
  f97 = Math_fround(Math_fround(HEAPF32[i80 + 8 >> 2]) * f97);
  f93 = Math_fround(HEAPF32[i65 >> 2]);
  f92 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f92 = Math_fround(f92 - Math_fround(f75 * f96));
  f91 = Math_fround(Math_fround(HEAPF32[i65 + 8 >> 2]) - Math_fround(f75 * f97));
  HEAPF32[i81 >> 2] = Math_fround(f93 - Math_fround(f75 * f95));
  HEAPF32[i81 + 4 >> 2] = f92;
  HEAPF32[i81 + 8 >> 2] = f91;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  f91 = Math_fround(HEAPF32[i66 >> 2]);
  f92 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f92 = Math_fround(Math_fround(f76 * f96) + f92);
  f93 = Math_fround(Math_fround(f76 * f97) + Math_fround(HEAPF32[i66 + 8 >> 2]));
  HEAPF32[i82 >> 2] = Math_fround(Math_fround(f76 * f95) + f91);
  HEAPF32[i82 + 4 >> 2] = f92;
  HEAPF32[i82 + 8 >> 2] = f93;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i84 >> 2] = Math_fround(f94 - f73);
  i88 = i84 + 4 | 0;
  HEAP32[i88 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i88 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i88 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAPF32[i83 >> 2] = f95;
  HEAPF32[i83 + 4 >> 2] = f96;
  HEAPF32[i83 + 8 >> 2] = f97;
  HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
  i88 = 3;
  STACKTOP = i89;
  return i88 | 0;
 } while (0);
 HEAP8[i74 >> 0] = i2;
 if (!i2) {
  i88 = 6;
  STACKTOP = i89;
  return i88 | 0;
 } else i1 = 0;
 do {
  HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
  HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i89;
 return i1 | 0;
}

function __ZN29AssetBundleLoadAssetOperation20PreparePreloadAssetsEb(i56, i50) {
 i56 = i56 | 0;
 i50 = i50 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i59 + 32 | 0;
 i57 = i59 + 16 | 0;
 i51 = i59;
 i6 = i59 + 96 | 0;
 i52 = i59 + 64 | 0;
 i53 = i59 + 36 | 0;
 i54 = i59 + 104 | 0;
 i55 = i56 + 160 | 0;
 i1 = HEAP32[i55 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i51 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i1 = 0; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i51);
    i2 = HEAP32[i57 >> 2] | 0;
    i49 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i49 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i49 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  if (i1 | 0) {
   i5 = i56 + 168 | 0;
   i1 = HEAP8[i5 + 11 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) i1 = HEAP32[i56 + 172 >> 2] | 0; else i1 = i1 & 255;
   i4 = (i1 | 0) == 0;
   HEAP32[i51 >> 2] = HEAP32[i55 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i58 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i1, i51);
     i2 = HEAP32[i57 >> 2] | 0;
     i49 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i49 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i49 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i58 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i58 = 20;
    }
   }
   if ((i58 | 0) == 18) i58 = 20;
   if ((i58 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i55 >> 2] | 0) | 0;
   if (i4) {
    i2 = HEAP32[i1 + 68 >> 2] | 0;
    i1 = i1 + 72 | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i6 + 4 >> 2] = i1;
    i49 = i6 + 4 | 0;
   } else {
    __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i1, i5);
    i1 = i6 + 4 | 0;
    i49 = i1;
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i1 >> 2] | 0;
   }
   i47 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(HEAP32[i56 + 180 >> 2] | 0) | 0;
   i48 = __Z20GetPersistentManagerv() | 0;
   i3 = i2;
   L32 : do if ((i3 | 0) == (i1 | 0)) i6 = i56 + 208 | 0; else {
    i44 = i56 + 184 | 0;
    i45 = i54 + 12 | 0;
    i15 = i54 + 12 | 0;
    i46 = i57 + 4 | 0;
    i16 = i54 + 8 | 0;
    i17 = i54 + 4 | 0;
    i18 = i54 + 11 | 0;
    i19 = i53 + 12 | 0;
    i13 = i53 + 12 | 0;
    i20 = i57 + 4 | 0;
    i21 = i53 + 8 | 0;
    i22 = i53 + 4 | 0;
    i23 = i53 + 16 | 0;
    i24 = i53 + 11 | 0;
    i25 = i52 + 12 | 0;
    i14 = i52 + 12 | 0;
    i26 = i57 + 4 | 0;
    i27 = i52 + 8 | 0;
    i28 = i52 + 4 | 0;
    i29 = i52 + 16 | 0;
    i30 = i56 + 188 | 0;
    i31 = i56 + 188 | 0;
    i32 = i56 + 192 | 0;
    i33 = i52 + 11 | 0;
    i34 = i57 + 4 | 0;
    i35 = i57 + 4 | 0;
    i36 = i57 + 4 | 0;
    i37 = i56 + 196 | 0;
    i6 = i56 + 208 | 0;
    i38 = i56 + 212 | 0;
    i39 = i56 + 200 | 0;
    i40 = i56 + 216 | 0;
    i41 = i56 + 228 | 0;
    i42 = i56 + 232 | 0;
    i43 = i56 + 220 | 0;
    i1 = i2;
    while (1) {
     i2 = i3 + 16 | 0;
     i11 = HEAP32[i3 + 40 >> 2] | 0;
     i4 = __ZN17PersistentManager17GetSerializedTypeEi(i48, i11) | 0;
     if (i4 | 0) {
      i12 = __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE(i4) | 0, i47) | 0;
      if ((i4 | 0) == (gb + 27592 | 0) | i12) {
       i5 = HEAP8[i2 + 11 >> 0] | 0;
       i10 = i5 << 24 >> 24 < 0;
       i4 = i10 ? HEAP32[i2 >> 2] | 0 : i2;
       i5 = i10 ? HEAP32[i3 + 20 >> 2] | 0 : i5 & 255;
       HEAP32[i54 >> 2] = 0;
       HEAP32[i54 + 4 >> 2] = 0;
       HEAP32[i54 + 8 >> 2] = 0;
       i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i45 >> 2] = i2;
       if (i5 >>> 0 > 2147483631) {
        __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i54);
        i2 = HEAP32[i15 >> 2] | 0;
        i58 = 32;
       } else if (i5 >>> 0 < 11) {
        HEAP8[i18 >> 0] = i5;
        if (!i5) i2 = i54; else {
         i2 = i54;
         i58 = 34;
        }
       } else i58 = 32;
       if ((i58 | 0) == 32) {
        i10 = i5 + 16 & -16;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i46 >> 2] = i2;
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i57, 0, gb + 1049224 | 0, 75) | 0;
        HEAP32[i54 >> 2] = i2;
        HEAP32[i16 >> 2] = i10 | -2147483648;
        HEAP32[i17 >> 2] = i5;
        i58 = 34;
       }
       if ((i58 | 0) == 34) {
        i58 = 0;
        _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
       }
       HEAP8[i2 + i5 >> 0] = 0;
       i5 = i3 + 32 | 0;
       HEAP32[i51 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i51 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i51 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       i5 = HEAP8[i18 >> 0] | 0;
       i2 = i5 << 24 >> 24 < 0;
       i4 = i2 ? HEAP32[i54 >> 2] | 0 : i54;
       i5 = i2 ? HEAP32[i17 >> 2] | 0 : i5 & 255;
       HEAP32[i53 >> 2] = 0;
       HEAP32[i53 + 4 >> 2] = 0;
       HEAP32[i53 + 8 >> 2] = 0;
       i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i19 >> 2] = i2;
       if (i5 >>> 0 > 2147483631) {
        __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i53);
        i2 = HEAP32[i13 >> 2] | 0;
        i58 = 38;
       } else if (i5 >>> 0 < 11) {
        HEAP8[i24 >> 0] = i5;
        if (!i5) i2 = i53; else {
         i2 = i53;
         i58 = 40;
        }
       } else i58 = 38;
       if ((i58 | 0) == 38) {
        i10 = i5 + 16 & -16;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i20 >> 2] = i2;
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i57, 0, gb + 1049224 | 0, 75) | 0;
        HEAP32[i53 >> 2] = i2;
        HEAP32[i21 >> 2] = i10 | -2147483648;
        HEAP32[i22 >> 2] = i5;
        i58 = 40;
       }
       if ((i58 | 0) == 40) {
        i58 = 0;
        _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
       }
       HEAP8[i2 + i5 >> 0] = 0;
       HEAP32[i23 >> 2] = HEAP32[i51 >> 2];
       HEAP32[i23 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
       HEAP32[i23 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
       i5 = HEAP8[i24 >> 0] | 0;
       i2 = i5 << 24 >> 24 < 0;
       i4 = i2 ? HEAP32[i53 >> 2] | 0 : i53;
       i5 = i2 ? HEAP32[i22 >> 2] | 0 : i5 & 255;
       HEAP32[i52 >> 2] = 0;
       HEAP32[i52 + 4 >> 2] = 0;
       HEAP32[i52 + 8 >> 2] = 0;
       i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i25 >> 2] = i2;
       if (i5 >>> 0 > 2147483631) {
        __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i52);
        i2 = HEAP32[i14 >> 2] | 0;
        i58 = 44;
       } else if (i5 >>> 0 < 11) {
        HEAP8[i33 >> 0] = i5;
        if (!i5) i2 = i52; else {
         i2 = i52;
         i58 = 46;
        }
       } else i58 = 44;
       if ((i58 | 0) == 44) {
        i10 = i5 + 16 & -16;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i26 >> 2] = i2;
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i57, 0, gb + 1049224 | 0, 75) | 0;
        HEAP32[i52 >> 2] = i2;
        HEAP32[i27 >> 2] = i10 | -2147483648;
        HEAP32[i28 >> 2] = i5;
        i58 = 46;
       }
       if ((i58 | 0) == 46) {
        i58 = 0;
        _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
       }
       HEAP8[i2 + i5 >> 0] = 0;
       HEAP32[i29 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
       i2 = HEAP32[i30 >> 2] | 0;
       do if (!i2) {
        i4 = i30;
        i5 = i30;
       } else {
        i9 = HEAP8[i33 >> 0] | 0;
        i10 = i9 << 24 >> 24 < 0;
        i9 = i10 ? HEAP32[i28 >> 2] | 0 : i9 & 255;
        i10 = i10 ? HEAP32[i52 >> 2] | 0 : i52;
        while (1) {
         i5 = i2 + 16 | 0;
         i8 = HEAP8[i5 + 11 >> 0] | 0;
         i7 = i8 << 24 >> 24 < 0;
         i8 = i7 ? HEAP32[i2 + 20 >> 2] | 0 : i8 & 255;
         i4 = i8 >>> 0 < i9 >>> 0 ? i8 : i9;
         do if (!i4) i58 = 51; else {
          i4 = _memcmp(i10, i7 ? HEAP32[i5 >> 2] | 0 : i5, i4) | 0;
          if (!i4) {
           i58 = 51;
           break;
          }
          if ((i4 | 0) < 0) i58 = 53; else i58 = 55;
         } while (0);
         if ((i58 | 0) == 51) if (i9 >>> 0 < i8 >>> 0) i58 = 53; else i58 = 55;
         if ((i58 | 0) == 53) {
          i4 = HEAP32[i2 >> 2] | 0;
          if (!i4) {
           i58 = 54;
           break;
          } else i2 = i4;
         } else if ((i58 | 0) == 55) {
          i5 = i2 + 4 | 0;
          i4 = HEAP32[i5 >> 2] | 0;
          if (!i4) {
           i58 = 57;
           break;
          } else i2 = i4;
         }
        }
        if ((i58 | 0) == 54) {
         i58 = 0;
         i4 = i2;
         i5 = i2;
         break;
        } else if ((i58 | 0) == 57) {
         i58 = 0;
         i4 = i2;
         break;
        }
       } while (0);
       __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i57, i44, i52);
       i2 = HEAP32[i57 >> 2] | 0;
       HEAP32[i57 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i4;
       HEAP32[i5 >> 2] = i2;
       i4 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
       if (i4) {
        HEAP32[i44 >> 2] = i4;
        i2 = HEAP32[i5 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i31 >> 2] | 0, i2);
       HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
       if ((HEAP8[i33 >> 0] | 0) < 0) {
        i10 = HEAP32[i52 >> 2] | 0;
        i9 = HEAP32[i14 >> 2] | 0;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i34 >> 2] = i9;
        __Z19free_alloc_internalPvRK10MemLabelId(i10, i57);
       }
       if ((HEAP8[i24 >> 0] | 0) < 0) {
        i10 = HEAP32[i53 >> 2] | 0;
        i9 = HEAP32[i13 >> 2] | 0;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i35 >> 2] = i9;
        __Z19free_alloc_internalPvRK10MemLabelId(i10, i57);
       }
       if ((HEAP8[i18 >> 0] | 0) < 0) {
        i10 = HEAP32[i54 >> 2] | 0;
        i9 = HEAP32[i15 >> 2] | 0;
        HEAP32[i57 >> 2] = 66;
        HEAP32[i36 >> 2] = i9;
        __Z19free_alloc_internalPvRK10MemLabelId(i10, i57);
       }
       HEAP32[i51 >> 2] = i11;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       do if (!i4) {
        i2 = 0;
        i4 = 0;
       } else {
        if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
         i5 = HEAP32[i4 + 28 >> 2] | 0;
         i7 = HEAP32[i4 + 32 >> 2] | 0;
         i2 = i5 + (i7 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i4, i51);
         i2 = HEAP32[i57 >> 2] | 0;
         i5 = HEAP32[i4 + 28 >> 2] | 0;
         i11 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i2 | 0) == -1 ? i5 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
         i5 = HEAP32[i11 + 28 >> 2] | 0;
         i7 = HEAP32[i11 + 32 >> 2] | 0;
         i4 = i11;
        }
        if ((i2 | 0) == (i5 + (i7 << 3) | 0)) {
         i2 = 0;
         break;
        }
        i2 = HEAP32[i2 + 4 >> 2] | 0;
       } while (0);
       i7 = (i2 | 0) == 0;
       HEAP32[i51 >> 2] = HEAP32[i55 >> 2];
       do if (!i4) i58 = 77; else {
        if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
         i11 = HEAP32[i4 + 28 >> 2] | 0;
         i5 = HEAP32[i4 + 32 >> 2] | 0;
         i2 = i11 + (i5 << 3) | 0;
         i4 = i11;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i57, i4, i51);
         i2 = HEAP32[i57 >> 2] | 0;
         i11 = HEAP32[i4 + 28 >> 2] | 0;
         i5 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i2 | 0) == -1 ? i11 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
         i4 = HEAP32[i5 + 28 >> 2] | 0;
         i5 = HEAP32[i5 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i4 + (i5 << 3) | 0)) {
         i58 = 77;
         break;
        }
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if (!i2) i58 = 79;
       } while (0);
       if ((i58 | 0) == 77) i58 = 79;
       if ((i58 | 0) == 79) {
        i58 = 0;
        i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i55 >> 2] | 0) | 0;
       }
       i11 = HEAP32[i3 + 36 >> 2] | 0;
       i10 = (HEAP32[i2 + 48 >> 2] | 0) + (HEAP32[i3 + 32 >> 2] << 2) | 0;
       i2 = (i11 | 0) > 0;
       do if (i7) {
        if (i2) i2 = 0; else break;
        do {
         i4 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
         i5 = HEAP32[i6 >> 2] | 0;
         i7 = i5 + 1 | 0;
         i8 = HEAP32[i38 >> 2] | 0;
         i9 = i8 & 2147483647;
         do if (i7 >>> 0 > i9 >>> 0) {
          i3 = i8 << 1;
          i3 = (i3 | 0) == 0 ? 1 : i3;
          if (i9 >>> 0 >= i3 >>> 0) break;
          if ((i8 | 0) > -1) {
           HEAP32[i38 >> 2] = i3;
           HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i3 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
           break;
          } else {
           i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
           _memcpy(i9 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
           HEAP32[i38 >> 2] = i3;
           HEAP32[i37 >> 2] = i9;
           break;
          }
         } while (0);
         HEAP32[i6 >> 2] = i7;
         HEAP32[(HEAP32[i37 >> 2] | 0) + (i5 << 2) >> 2] = i4;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i11 | 0));
       } else {
        if (i2) i2 = 0; else break;
        do {
         i4 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
         i5 = HEAP32[i41 >> 2] | 0;
         i7 = i5 + 1 | 0;
         i8 = HEAP32[i42 >> 2] | 0;
         i9 = i8 & 2147483647;
         do if (i7 >>> 0 > i9 >>> 0) {
          i3 = i8 << 1;
          i3 = (i3 | 0) == 0 ? 1 : i3;
          if (i9 >>> 0 >= i3 >>> 0) break;
          if ((i8 | 0) > -1) {
           HEAP32[i42 >> 2] = i3;
           HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i40 >> 2] | 0, i3 << 2, 4, i43, 0, gb + 1047584 | 0, 464) | 0;
           break;
          } else {
           i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i43, 0, gb + 1047584 | 0, 446) | 0;
           _memcpy(i9 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] << 2 | 0) | 0;
           HEAP32[i42 >> 2] = i3;
           HEAP32[i40 >> 2] = i9;
           break;
          }
         } while (0);
         HEAP32[i41 >> 2] = i7;
         HEAP32[(HEAP32[i40 >> 2] | 0) + (i5 << 2) >> 2] = i4;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i11 | 0));
       } while (0);
       if (!(i50 | i12 ^ 1)) break L32;
      }
     }
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (HEAP32[i49 >> 2] | 0)) break; else {
      i1 = i2;
      i3 = i2;
     }
    }
   } while (0);
   i5 = i56 + 196 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i1, i1 + (HEAP32[i6 >> 2] << 2) | 0, i57);
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i5 + (i1 << 2) | 0;
   L146 : do if (!i1) {
    i4 = i5;
    i58 = 103;
   } else {
    i4 = i5;
    while (1) {
     i3 = i4 + 4 | 0;
     if ((i3 | 0) == (i2 | 0)) break L146;
     if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) {
      i58 = 103;
      break;
     } else i4 = i3;
    }
   } while (0);
   if ((i58 | 0) == 103) if ((i4 | 0) != (i2 | 0)) {
    i1 = i4 + 4 | 0;
    L153 : while (1) {
     do {
      i1 = i1 + 4 | 0;
      if ((i1 | 0) == (i2 | 0)) break L153;
      i3 = HEAP32[i1 >> 2] | 0;
     } while ((HEAP32[i4 >> 2] | 0) == (i3 | 0));
     i58 = i4 + 4 | 0;
     HEAP32[i58 >> 2] = i3;
     i4 = i58;
    }
    i2 = i4 + 4 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i6 >> 2] = i1 - (i5 + (i1 << 2) - i2 >> 2);
   STACKTOP = i59;
   return;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i56 + 164 >> 2];
 __Z6FormatPKcz(i57, gb + 367767 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i57 + 11 >> 0] | 0) < 0 ? HEAP32[i57 >> 2] | 0 : i57, 0, gb + 367840 | 0, 97, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i57);
 STACKTOP = i59;
 return;
}

function __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i43) {
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i46 + 88 | 0;
 i17 = i46 + 72 | 0;
 i44 = i46 + 40 | 0;
 i38 = i46 + 20 | 0;
 i39 = i46;
 i40 = i46 + 56 | 0;
 i41 = i44 + 4 | 0;
 HEAP32[i41 >> 2] = 0;
 i42 = i44 + 8 | 0;
 HEAP32[i42 >> 2] = 0;
 i45 = i44 + 4 | 0;
 HEAP32[i44 >> 2] = i45;
 i2 = HEAP32[i43 + 860 >> 2] | 0;
 i11 = i43 + 864 | 0;
 i1 = i2;
 if ((i1 | 0) == (i11 | 0)) i16 = i45; else {
  i12 = i40 + 12 | 0;
  i7 = i40 + 12 | 0;
  i13 = i10 + 4 | 0;
  i14 = i40 + 8 | 0;
  i15 = i40 + 4 | 0;
  i16 = i39 + 4 | 0;
  i18 = i40 + 11 | 0;
  i19 = i39 + 16 | 0;
  i9 = i39 + 16 | 0;
  i20 = i10 + 4 | 0;
  i21 = i39 + 12 | 0;
  i22 = i39 + 8 | 0;
  i23 = i38 + 4 | 0;
  i24 = i16 + 11 | 0;
  i25 = i38 + 16 | 0;
  i8 = i38 + 16 | 0;
  i26 = i10 + 4 | 0;
  i27 = i38 + 12 | 0;
  i28 = i38 + 8 | 0;
  i29 = i45;
  i30 = i38 + 4 | 0;
  i31 = i30 + 11 | 0;
  i32 = i10 + 4 | 0;
  i33 = i39 + 4 | 0;
  i34 = i33 + 11 | 0;
  i35 = i10 + 4 | 0;
  i36 = i10 + 4 | 0;
  i37 = i23 + 11 | 0;
  while (1) {
   i5 = HEAP32[i1 + 32 >> 2] | 0;
   i3 = i1 + 16 | 0;
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i47 = i4 << 24 >> 24 < 0;
   i3 = i47 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i47 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255;
   HEAP32[i40 >> 2] = 0;
   HEAP32[i40 + 4 >> 2] = 0;
   HEAP32[i40 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
    i1 = HEAP32[i7 >> 2] | 0;
    i6 = 8;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i18 >> 0] = i4;
    if (!i4) i1 = i40; else {
     i1 = i40;
     i6 = 10;
    }
   } else i6 = 8;
   if ((i6 | 0) == 8) {
    i47 = i4 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i13 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i47, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i40 >> 2] = i1;
    HEAP32[i14 >> 2] = i47 | -2147483648;
    HEAP32[i15 >> 2] = i4;
    i6 = 10;
   }
   if ((i6 | 0) == 10) {
    i6 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i39 >> 2] = i5;
   i4 = HEAP8[i18 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i40 >> 2] | 0 : i40;
   i4 = i1 ? HEAP32[i15 >> 2] | 0 : i4 & 255;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i19 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
    i1 = HEAP32[i9 >> 2] | 0;
    i6 = 14;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i24 >> 0] = i4;
    if (!i4) i1 = i16; else {
     i1 = i16;
     i6 = 16;
    }
   } else i6 = 14;
   if ((i6 | 0) == 14) {
    i47 = i4 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i20 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i47, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i21 >> 2] = i47 | -2147483648;
    HEAP32[i22 >> 2] = i4;
    i6 = 16;
   }
   if ((i6 | 0) == 16) {
    i6 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
   i4 = HEAP8[i24 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
   i4 = i1 ? HEAP32[i22 >> 2] | 0 : i4 & 255;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i25 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
    i1 = HEAP32[i8 >> 2] | 0;
    i6 = 20;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i37 >> 0] = i4;
    if (!i4) i1 = i23; else {
     i1 = i23;
     i6 = 22;
    }
   } else i6 = 20;
   if ((i6 | 0) == 20) {
    i47 = i4 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i26 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i47, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i27 >> 2] = i47 | -2147483648;
    HEAP32[i28 >> 2] = i4;
    i6 = 22;
   }
   if ((i6 | 0) == 22) {
    i6 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i1 = HEAP32[i45 >> 2] | 0;
   do if (!i1) {
    HEAP32[i10 >> 2] = i45;
    i3 = i29;
    i4 = i45;
   } else {
    i5 = HEAP32[i38 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i3 | 0)) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) {
       i6 = 27;
       break;
      } else i1 = i3;
     } else {
      if ((i3 | 0) >= (i5 | 0)) {
       i6 = 32;
       break;
      }
      i4 = i1 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i6 = 31;
       break;
      } else i1 = i3;
     }
    }
    if ((i6 | 0) == 27) {
     i6 = 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i1;
     i4 = i1;
     break;
    } else if ((i6 | 0) == 31) {
     i6 = 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i1;
     break;
    } else if ((i6 | 0) == 32) {
     i6 = 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i1;
     i4 = i10;
     break;
    }
   } while (0);
   if (!(HEAP32[i4 >> 2] | 0)) {
    __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKiS2_EE(i17, i44, i38);
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i44 >> 2] = i3;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i41 >> 2] | 0, i1);
    HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + 1;
   }
   if ((HEAP8[i31 >> 0] | 0) < 0) {
    i47 = HEAP32[i30 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i32 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i47, i10);
   }
   if ((HEAP8[i34 >> 0] | 0) < 0) {
    i47 = HEAP32[i33 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i35 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i47, i10);
   }
   if ((HEAP8[i18 >> 0] | 0) < 0) {
    i47 = HEAP32[i40 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i36 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i47, i10);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i11 | 0)) {
    i16 = i45;
    break;
   } else i2 = i1;
  }
 }
 i19 = i43 + 724 | 0;
 i15 = 0;
 do {
  L72 : do if (HEAP32[i19 >> 2] & 1 << i15 | 0) {
   i17 = i43 + 728 + (i15 * 12 | 0) | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   i47 = (HEAP32[i43 + 728 + (i15 * 12 | 0) + 4 >> 2] | 0) - i2 | 0;
   i18 = (i47 | 0) / 192 | 0;
   if (i47 | 0) {
    i1 = 0;
    while (1) {
     __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, i2 + (i1 * 192 | 0) + 108 | 0);
     __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, i2 + (i1 * 192 | 0) + 120 | 0);
     i12 = i2 + (i1 * 192 | 0) + 132 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 136 >> 2] | 0) - i4 >> 5;
     L77 : do if (i13 | 0) {
      i3 = 0;
      while (1) {
       i8 = HEAP32[i4 + (i3 << 5) + 16 >> 2] | 0;
       do if ((i8 | 0) != -1) {
        i5 = HEAP32[i16 >> 2] | 0;
        if (i5 | 0) {
         i7 = i45;
         L83 : while (1) {
          i6 = i5;
          while (1) {
           if ((HEAP32[i6 + 16 >> 2] | 0) >= (i8 | 0)) break;
           i5 = HEAP32[i6 + 4 >> 2] | 0;
           if (!i5) {
            i6 = i7;
            break L83;
           } else i6 = i5;
          }
          i5 = HEAP32[i6 >> 2] | 0;
          if (!i5) break; else i7 = i6;
         }
         if ((i6 | 0) != (i45 | 0)) if ((i8 | 0) >= (HEAP32[i6 + 16 >> 2] | 0)) {
          i10 = i4 + (i3 << 5) | 0;
          i5 = i6 + 20 | 0;
          if ((i10 | 0) != (i5 | 0)) {
           i9 = HEAP8[i5 + 11 >> 0] | 0;
           i7 = i9 << 24 >> 24 < 0;
           i11 = i7 ? HEAP32[i5 >> 2] | 0 : i5;
           i9 = i7 ? HEAP32[i6 + 24 >> 2] | 0 : i9 & 255;
           i7 = i10 + 11 | 0;
           i5 = HEAP8[i7 >> 0] | 0;
           i6 = i5 << 24 >> 24 < 0;
           if (i6) i8 = (HEAP32[i4 + (i3 << 5) + 8 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
           if (i9 >>> 0 > i8 >>> 0) {
            if (i6) i4 = HEAP32[i4 + (i3 << 5) + 4 >> 2] | 0; else i4 = i5 & 255;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i8, i9 - i8 | 0, i4, 0, i4, i9, i11);
            break;
           }
           if (i6) i5 = HEAP32[i10 >> 2] | 0; else i5 = i10;
           if (i9 | 0) _memmove(i5 | 0, i11 | 0, i9 | 0) | 0;
           HEAP8[i5 + i9 >> 0] = 0;
           if ((HEAP8[i7 >> 0] | 0) < 0) {
            HEAP32[i4 + (i3 << 5) + 4 >> 2] = i9;
            break;
           } else {
            HEAP8[i7 >> 0] = i9;
            break;
           }
          }
         }
        }
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i13 | 0)) break L77;
       i4 = HEAP32[i12 >> 2] | 0;
      }
     } while (0);
     i12 = i2 + (i1 * 192 | 0) + 144 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i47 = (HEAP32[i2 + (i1 * 192 | 0) + 148 >> 2] | 0) - i4 | 0;
     i13 = (i47 | 0) / 28 | 0;
     L116 : do if (i47 | 0) {
      i3 = 0;
      while (1) {
       i8 = HEAP32[i4 + (i3 * 28 | 0) + 16 >> 2] | 0;
       do if ((i8 | 0) != -1) {
        i5 = HEAP32[i16 >> 2] | 0;
        if (i5 | 0) {
         i7 = i45;
         L122 : while (1) {
          i6 = i5;
          while (1) {
           if ((HEAP32[i6 + 16 >> 2] | 0) >= (i8 | 0)) break;
           i5 = HEAP32[i6 + 4 >> 2] | 0;
           if (!i5) {
            i6 = i7;
            break L122;
           } else i6 = i5;
          }
          i5 = HEAP32[i6 >> 2] | 0;
          if (!i5) break; else i7 = i6;
         }
         if ((i6 | 0) != (i45 | 0)) if ((i8 | 0) >= (HEAP32[i6 + 16 >> 2] | 0)) {
          i10 = i4 + (i3 * 28 | 0) | 0;
          i5 = i6 + 20 | 0;
          if ((i10 | 0) != (i5 | 0)) {
           i9 = HEAP8[i5 + 11 >> 0] | 0;
           i7 = i9 << 24 >> 24 < 0;
           i11 = i7 ? HEAP32[i5 >> 2] | 0 : i5;
           i9 = i7 ? HEAP32[i6 + 24 >> 2] | 0 : i9 & 255;
           i7 = i10 + 11 | 0;
           i5 = HEAP8[i7 >> 0] | 0;
           i6 = i5 << 24 >> 24 < 0;
           if (i6) i8 = (HEAP32[i4 + (i3 * 28 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
           if (i9 >>> 0 > i8 >>> 0) {
            if (i6) i4 = HEAP32[i4 + (i3 * 28 | 0) + 4 >> 2] | 0; else i4 = i5 & 255;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i8, i9 - i8 | 0, i4, 0, i4, i9, i11);
            break;
           }
           if (i6) i5 = HEAP32[i10 >> 2] | 0; else i5 = i10;
           if (i9 | 0) _memmove(i5 | 0, i11 | 0, i9 | 0) | 0;
           HEAP8[i5 + i9 >> 0] = 0;
           if ((HEAP8[i7 >> 0] | 0) < 0) {
            HEAP32[i4 + (i3 * 28 | 0) + 4 >> 2] = i9;
            break;
           } else {
            HEAP8[i7 >> 0] = i9;
            break;
           }
          }
         }
        }
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i13 | 0)) break L116;
       i4 = HEAP32[i12 >> 2] | 0;
      }
     } while (0);
     i14 = i2 + (i1 * 192 | 0) + 168 | 0;
     i12 = i2 + (i1 * 192 | 0) + 172 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i3 = HEAP32[i14 >> 2] | 0;
     i47 = i4 - i3 | 0;
     i13 = (i47 | 0) / 48 | 0;
     i5 = i3;
     if (i47) {
      i3 = 0;
      while (1) {
       i8 = HEAP32[i5 + (i3 * 48 | 0) + 16 >> 2] | 0;
       do if ((i8 | 0) != -1) {
        i4 = HEAP32[i16 >> 2] | 0;
        if (i4 | 0) {
         i7 = i45;
         L161 : while (1) {
          i6 = i4;
          while (1) {
           if ((HEAP32[i6 + 16 >> 2] | 0) >= (i8 | 0)) break;
           i4 = HEAP32[i6 + 4 >> 2] | 0;
           if (!i4) {
            i6 = i7;
            break L161;
           } else i6 = i4;
          }
          i4 = HEAP32[i6 >> 2] | 0;
          if (!i4) break; else i7 = i6;
         }
         if ((i6 | 0) != (i45 | 0)) if ((i8 | 0) >= (HEAP32[i6 + 16 >> 2] | 0)) {
          i10 = i5 + (i3 * 48 | 0) | 0;
          i4 = i6 + 20 | 0;
          if ((i10 | 0) != (i4 | 0)) {
           i9 = HEAP8[i4 + 11 >> 0] | 0;
           i7 = i9 << 24 >> 24 < 0;
           i11 = i7 ? HEAP32[i4 >> 2] | 0 : i4;
           i9 = i7 ? HEAP32[i6 + 24 >> 2] | 0 : i9 & 255;
           i7 = i10 + 11 | 0;
           i4 = HEAP8[i7 >> 0] | 0;
           i6 = i4 << 24 >> 24 < 0;
           if (i6) i8 = (HEAP32[i5 + (i3 * 48 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
           if (i9 >>> 0 > i8 >>> 0) {
            if (i6) i4 = HEAP32[i5 + (i3 * 48 | 0) + 4 >> 2] | 0; else i4 = i4 & 255;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i8, i9 - i8 | 0, i4, 0, i4, i9, i11);
            break;
           }
           if (i6) i4 = HEAP32[i10 >> 2] | 0; else i4 = i10;
           if (i9 | 0) _memmove(i4 | 0, i11 | 0, i9 | 0) | 0;
           HEAP8[i4 + i9 >> 0] = 0;
           if ((HEAP8[i7 >> 0] | 0) < 0) {
            HEAP32[i5 + (i3 * 48 | 0) + 4 >> 2] = i9;
            break;
           } else {
            HEAP8[i7 >> 0] = i9;
            break;
           }
          }
         }
        }
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i13 | 0)) break;
       i5 = HEAP32[i14 >> 2] | 0;
      }
      i5 = HEAP32[i14 >> 2] | 0;
      i4 = HEAP32[i12 >> 2] | 0;
      i3 = i5;
     }
     i3 = i4 - i3 | 0;
     i4 = (i3 | 0) / 48 | 0;
     if (i3 | 0) {
      __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, i5 + 32 | 0);
      __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, (HEAP32[i14 >> 2] | 0) + 20 | 0);
      if ((i3 | 0) != 48) {
       i3 = 1;
       do {
        __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, (HEAP32[i14 >> 2] | 0) + (i3 * 48 | 0) + 32 | 0);
        __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, (HEAP32[i14 >> 2] | 0) + (i3 * 48 | 0) + 20 | 0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i4 | 0));
      }
     }
     __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram13BufferBindingEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, i2 + (i1 * 192 | 0) + 180 | 0);
     __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram13BufferBindingEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i44, i2 + (i1 * 192 | 0) + 156 | 0);
     i8 = i2 + (i1 * 192 | 0) + 76 | 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     HEAP32[i8 + 12 >> 2] = 0;
     HEAP32[i8 + 16 >> 2] = 0;
     HEAP32[i8 + 20 >> 2] = 0;
     HEAP32[i8 + 24 >> 2] = 0;
     HEAP32[i8 + 28 >> 2] = 0;
     i8 = HEAP32[i2 + (i1 * 192 | 0) + 68 >> 2] | 0;
     if (i8 | 0) {
      i9 = i2 + (i1 * 192 | 0) + 56 | 0;
      i7 = 0;
      do {
       i6 = HEAPU16[(HEAP32[i9 >> 2] | 0) + (i7 << 1) >> 1] | 0;
       i4 = HEAP32[i16 >> 2] | 0;
       if (i4 | 0) {
        i3 = i45;
        L205 : while (1) {
         i5 = i4;
         while (1) {
          if ((HEAP32[i5 + 16 >> 2] | 0) >= (i6 | 0)) break;
          i4 = HEAP32[i5 + 4 >> 2] | 0;
          if (!i4) break L205; else i5 = i4;
         }
         i4 = HEAP32[i5 >> 2] | 0;
         if (!i4) {
          i3 = i5;
          break;
         } else i3 = i5;
        }
        if ((i3 | 0) != (i45 | 0)) if (!((i3 | 0) == (i45 | 0) ? 1 : (i6 | 0) < (HEAP32[i3 + 16 >> 2] | 0))) {
         i3 = i3 + 20 | 0;
         if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
         i42 = __ZN8keywords6CreateEPKc(i3) | 0;
         i47 = i2 + (i1 * 192 | 0) + 76 + (i42 >>> 5 << 2) | 0;
         HEAP32[i47 >> 2] = 1 << (i42 & 31) | HEAP32[i47 >> 2];
        }
       }
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i8 | 0));
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i18 | 0)) break L72;
     i2 = HEAP32[i17 >> 2] | 0;
    }
   }
  } while (0);
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != 6);
 __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i44, HEAP32[i16 >> 2] | 0);
 STACKTOP = i46;
 return;
}

function __Z15UpdateLightsTplILb1EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem(i115, i116, i3, i126, i127, i128, i129, i130, i131, i132, i2) {
 i115 = i115 | 0;
 i116 = i116 | 0;
 i3 = i3 | 0;
 i126 = i126 | 0;
 i127 = i127 | 0;
 i128 = i128 | 0;
 i129 = i129 | 0;
 i130 = i130 | 0;
 i131 = i131 | 0;
 i132 = i132 | 0;
 i2 = i2 | 0;
 var i1 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i133 = 0, f134 = f0;
 i133 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i117 = i133 + 312 | 0;
 i118 = i133 + 248 | 0;
 i119 = i133 + 184 | 0;
 i120 = i133 + 64 | 0;
 i121 = i133 + 48 | 0;
 i122 = i133;
 i123 = i133 + 32 | 0;
 i124 = i133 + 16 | 0;
 i125 = i132 + 871 | 0;
 if (!(HEAP8[i125 >> 0] | 0)) i39 = 0; else {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
  if (!i1) i39 = 0; else i39 = (HEAP16[i1 + 340 >> 1] | 0) == 4;
 }
 i59 = HEAP32[i2 + 40 >> 2] | 0;
 f40 = Math_fround(HEAPF32[i59 + 316 >> 2]);
 f40 = Math_fround(f40 * Math_fround(HEAPF32[i59 + 320 >> 2]));
 f40 = Math_fround(+Math_pow(+Math_fround(Math_abs(Math_fround(f40 * Math_fround(HEAPF32[i59 + 324 >> 2])))), .333333343));
 f58 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 f40 = f58 < f40 ? f40 : f58;
 i59 = HEAP32[i132 + 12 >> 2] | 0;
 if (!i59) {
  STACKTOP = i133;
  return;
 }
 i60 = i132 + 608 | 0;
 i61 = i116 + 4 | 0;
 i62 = i3 + 8 | 0;
 i63 = i3 + 52 | 0;
 i64 = i3 + 56 | 0;
 i65 = i3 + 60 | 0;
 i66 = i3 + 124 | 0;
 i67 = i3 + 128 | 0;
 i68 = i3 + 132 | 0;
 i69 = i3 + 136 | 0;
 i70 = i3 + 140 | 0;
 i71 = i3 + 144 | 0;
 i72 = i3 + 148 | 0;
 i73 = i3 + 152 | 0;
 i74 = i3 + 156 | 0;
 i75 = i3 + 188 | 0;
 i76 = i3 + 204 | 0;
 i77 = i3 + 208 | 0;
 i78 = i3 + 216 | 0;
 i79 = i132 + 20 | 0;
 i80 = i132 + 40 | 0;
 i81 = i131 + 16 | 0;
 i82 = i131 + 32 | 0;
 i83 = i131 + 48 | 0;
 i84 = i131 + 4 | 0;
 i85 = i131 + 20 | 0;
 i86 = i131 + 36 | 0;
 i87 = i131 + 52 | 0;
 i88 = i117 + 4 | 0;
 i89 = i131 + 8 | 0;
 i90 = i131 + 24 | 0;
 i91 = i131 + 40 | 0;
 i92 = i131 + 56 | 0;
 i93 = i117 + 8 | 0;
 i94 = i132 + 60 | 0;
 i95 = i132 + 80 | 0;
 i96 = i132 + 100 | 0;
 i97 = i132 + 120 | 0;
 i98 = i132 + 140 | 0;
 i99 = i132 + 160 | 0;
 i100 = i120 + 4 | 0;
 i101 = i120 + 8 | 0;
 i102 = i120 + 108 | 0;
 i103 = i120 + 104 | 0;
 i104 = i121 + 12 | 0;
 i105 = i121 + 8 | 0;
 i106 = i121 + 4 | 0;
 i107 = i132 + 500 | 0;
 i108 = i122 + 12 | 0;
 i109 = i122 + 8 | 0;
 i110 = i122 + 4 | 0;
 i111 = i129 + 84 | 0;
 i112 = i122 + 12 | 0;
 i113 = i122 + 8 | 0;
 i41 = i122 + 4 | 0;
 i42 = i130 + 84 | 0;
 i114 = i126 | i128;
 i43 = i120 + 96 | 0;
 i44 = i2 + 860 | 0;
 i45 = i2 + 900 | 0;
 i46 = i3 + 44 | 0;
 i47 = i122 + 3 | 0;
 i48 = i3 + 20 | 0;
 i49 = i3 + 24 | 0;
 i50 = i3 + 28 | 0;
 i51 = i3 + 32 | 0;
 i52 = i120 + 84 | 0;
 i53 = i122 + 4 | 0;
 i54 = i120 + 88 | 0;
 i55 = i122 + 8 | 0;
 i56 = i120 + 92 | 0;
 i57 = i2 + 852 | 0;
 i34 = i2 + 892 | 0;
 i35 = i3 + 40 | 0;
 i36 = i3 + 48 | 0;
 i37 = i3 + 36 | 0;
 i38 = i3 + 96 | 0;
 i33 = i3 + 92 | 0;
 i20 = i3 + 85 | 0;
 i21 = i130 + 80 | 0;
 i22 = i124 + 12 | 0;
 i23 = i124 + 8 | 0;
 i24 = i124 + 4 | 0;
 i25 = i130 + 232 | 0;
 i26 = i130 + 144 | 0;
 i27 = i129 + 80 | 0;
 i28 = i123 + 12 | 0;
 i29 = i123 + 8 | 0;
 i30 = i123 + 4 | 0;
 i31 = i129 + 232 | 0;
 i32 = i129 + 144 | 0;
 i19 = 0;
 do {
  if (HEAP32[(HEAP32[i60 >> 2] | 0) + (i19 >>> 5 << 2) >> 2] & 1 << (i19 & 31) | 0) {
   if ((HEAP32[i61 >> 2] | 0) == (i116 | 0)) {
    i6 = __ZnwjRK10MemLabelIdiPKci(352, gb + 63264 | 0, 16, gb + 613235 | 0, 50) | 0;
    HEAP32[i6 + 4 >> 2] = 1;
    HEAP32[i6 >> 2] = gb + 33936 + 8;
    i1 = i6 + 8 | 0;
    i2 = i62;
    i5 = i1 + 44 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    HEAP32[i6 + 52 >> 2] = HEAP32[i63 >> 2];
    HEAP32[i6 + 56 >> 2] = HEAP32[i64 >> 2];
    i1 = i6 + 60 | 0;
    i2 = i65;
    i5 = i1 + 64 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    HEAP32[i6 + 124 >> 2] = HEAP32[i66 >> 2];
    HEAP32[i6 + 128 >> 2] = HEAP32[i67 >> 2];
    HEAP32[i6 + 132 >> 2] = HEAP32[i68 >> 2];
    HEAP32[i6 + 136 >> 2] = HEAP32[i69 >> 2];
    HEAP32[i6 + 140 >> 2] = HEAP32[i70 >> 2];
    HEAP32[i6 + 144 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i6 + 148 >> 2] = HEAP32[i72 >> 2];
    HEAP32[i6 + 152 >> 2] = HEAP32[i73 >> 2];
    i1 = i6 + 156 | 0;
    HEAP32[i1 >> 2] = HEAP32[i74 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i74 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i74 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i74 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i74 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i74 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i74 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i74 + 28 >> 2];
    i1 = i6 + 188 | 0;
    HEAP32[i1 >> 2] = HEAP32[i75 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i75 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i75 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i75 + 12 >> 2];
    HEAP32[i6 + 204 >> 2] = HEAP32[i76 >> 2];
    __ZN19RenderEventsContextC2ERKS_(i6 + 208 | 0, i77);
    i1 = i6 + 216 | 0;
    i2 = i78;
    i5 = i1 + 128 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    i1 = i6 + 344 | 0;
    HEAP32[i1 >> 2] = 0;
    i2 = i6 + 348 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i6 >> 2] = gb + 80340 + 8;
    HEAP32[i6 + 16 >> 2] = __Z28AllocateNextLowestInstanceIDv() | 0;
    if ((i1 | 0) == (i115 | 0)) i3 = i6; else {
     i3 = HEAP32[i1 >> 2] | 0;
     if (i3 | 0) {
      HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i2 >> 2] = 0;
     }
     i3 = HEAP32[i115 >> 2] | 0;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i2 >> 2] = i115;
     HEAP32[i3 + 4 >> 2] = i1;
     HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
     i3 = i6;
    }
   } else {
    i2 = HEAP32[i116 >> 2] | 0;
    i3 = i2 + -344 | 0;
    if ((i2 | 0) != (i115 | 0)) {
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) i1 = i2 + 4 | 0; else {
      i6 = i2 + 4 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i6 >> 2] = 0;
      i1 = i6;
     }
     i6 = HEAP32[i115 >> 2] | 0;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i1 >> 2] = i115;
     HEAP32[i6 + 4 >> 2] = i2;
     HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
    }
   }
   f18 = Math_fround(HEAPF32[(HEAP32[i132 >> 2] | 0) + (i19 << 2) >> 2]);
   f9 = Math_fround(HEAPF32[(HEAP32[i79 >> 2] | 0) + (i19 << 2) >> 2]);
   f134 = Math_fround(HEAPF32[(HEAP32[i80 >> 2] | 0) + (i19 << 2) >> 2]);
   f10 = Math_fround(HEAPF32[i131 >> 2]);
   f13 = Math_fround(f18 * f10);
   f11 = Math_fround(HEAPF32[i81 >> 2]);
   f13 = Math_fround(f13 + Math_fround(f9 * f11));
   f12 = Math_fround(HEAPF32[i82 >> 2]);
   f13 = Math_fround(f13 + Math_fround(f134 * f12));
   HEAPF32[i117 >> 2] = Math_fround(Math_fround(HEAPF32[i83 >> 2]) + f13);
   f13 = Math_fround(HEAPF32[i84 >> 2]);
   f16 = Math_fround(f18 * f13);
   f14 = Math_fround(HEAPF32[i85 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f9 * f14));
   f15 = Math_fround(HEAPF32[i86 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f134 * f15));
   HEAPF32[i88 >> 2] = Math_fround(Math_fround(HEAPF32[i87 >> 2]) + f16);
   f16 = Math_fround(HEAPF32[i89 >> 2]);
   f18 = Math_fround(f18 * f16);
   f17 = Math_fround(HEAPF32[i90 >> 2]);
   f9 = Math_fround(f18 + Math_fround(f9 * f17));
   f18 = Math_fround(HEAPF32[i91 >> 2]);
   f134 = Math_fround(f9 + Math_fround(f134 * f18));
   HEAPF32[i93 >> 2] = Math_fround(Math_fround(HEAPF32[i92 >> 2]) + f134);
   f134 = Math_fround(HEAPF32[(HEAP32[i94 >> 2] | 0) + (i19 << 2) >> 2]);
   f9 = Math_fround(HEAPF32[(HEAP32[i95 >> 2] | 0) + (i19 << 2) >> 2]);
   f8 = Math_fround(HEAPF32[(HEAP32[i96 >> 2] | 0) + (i19 << 2) >> 2]);
   f4 = Math_fround(HEAPF32[(HEAP32[i97 >> 2] | 0) + (i19 << 2) >> 2]);
   f7 = Math_fround(HEAPF32[(HEAP32[i98 >> 2] | 0) + (i19 << 2) >> 2]);
   f4 = Math_fround(f134 + f4);
   f7 = Math_fround(f9 + f7);
   f8 = Math_fround(f8 + Math_fround(HEAPF32[(HEAP32[i99 >> 2] | 0) + (i19 << 2) >> 2]));
   f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)) + Math_fround(f8 * f8))));
   if (f9 > f58) {
    f134 = Math_fround(f4 / f9);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
    f134 = Math_fround(f7 / f9);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
    f134 = Math_fround(f8 / f9);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f134, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i1 = HEAP32[gb + 62524 >> 2] | 0;
    i2 = HEAP32[gb + 62524 + 4 >> 2] | 0;
    i5 = HEAP32[gb + 62524 + 8 >> 2] | 0;
   }
   f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f134 = Math_fround(f9 * f10);
   f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f134 + Math_fround(f10 * f11));
   f134 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAPF32[i120 >> 2] = Math_fround(f11 + Math_fround(f134 * f12));
   HEAPF32[i100 >> 2] = Math_fround(Math_fround(Math_fround(f9 * f13) + Math_fround(f10 * f14)) + Math_fround(f134 * f15));
   HEAPF32[i101 >> 2] = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(f10 * f17)) + Math_fround(f134 * f18));
   if (!(__Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i120, gb + 62536 | 0, i121) | 0)) __Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i120, gb + 62524 | 0, i121) | 0;
   __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i118, i117, i121);
   __Z25InvertMatrix4x4_General3DPKfPf(i118, i119) | 0;
   i1 = i3 + 216 | 0;
   i2 = i118;
   i5 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i5 | 0));
   i1 = i3 + 280 | 0;
   i2 = i119;
   i5 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i5 | 0));
   __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i132, i120, 1, i19);
   f4 = Math_fround(HEAPF32[i102 >> 2]);
   if (f4 != Math_fround(0.0)) f4 = Math_fround(Math_fround(f4 - Math_fround(HEAPF32[i103 >> 2])) / f4); else f4 = Math_fround(0.0);
   HEAPF32[i104 >> 2] = f4;
   HEAPF32[i105 >> 2] = f4;
   HEAPF32[i106 >> 2] = f4;
   HEAPF32[i121 >> 2] = f4;
   i6 = (HEAP32[(HEAP32[i107 >> 2] | 0) + (i19 << 2) >> 2] | 0) + -1432315862 | 0;
   i1 = (Math_imul(i6, 1790253981) | 0) + 1900727103 | 0;
   i6 = i6 << 11 ^ i6;
   f4 = Math_fround(Math_fround(((i1 ^ i6 ^ i6 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i108 >> 2] = f4;
   HEAPF32[i109 >> 2] = f4;
   HEAPF32[i110 >> 2] = f4;
   HEAPF32[i122 >> 2] = f4;
   i1 = HEAP32[i111 >> 2] | 0;
   L35 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i6 = HEAP32[i27 >> 2] | 0;
     HEAP32[i28 >> 2] = i6;
     HEAP32[i29 >> 2] = i6;
     HEAP32[i30 >> 2] = i6;
     HEAP32[i123 >> 2] = i6;
     break;
    }
   case 3:
    {
     f134 = Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + 4 >> 2]);
     f18 = Math_fround(HEAPF32[i27 >> 2]);
     f134 = Math_fround(f134 * f18);
     f134 = Math_fround(f134 + Math_fround(f4 * Math_fround(Math_fround(f18 * Math_fround(HEAPF32[(HEAP32[i32 >> 2] | 0) + 4 >> 2])) - f134)));
     HEAPF32[i123 >> 2] = f134;
     HEAPF32[i30 >> 2] = f134;
     HEAPF32[i29 >> 2] = f134;
     HEAPF32[i28 >> 2] = f134;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i123, i129, i121, i122);
     break L35;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i123, i129, i121, i122);
     break L35;
    }
   } while (0);
   f7 = Math_fround(f40 * Math_fround(HEAPF32[i123 >> 2]));
   i6 = (HEAP32[(HEAP32[i107 >> 2] | 0) + (i19 << 2) >> 2] | 0) + 1532700938 | 0;
   i1 = (Math_imul(i6, 1790253981) | 0) + 1900727103 | 0;
   i6 = i6 << 11 ^ i6;
   f4 = Math_fround(Math_fround(((i1 ^ i6 ^ i6 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i112 >> 2] = f4;
   HEAPF32[i113 >> 2] = f4;
   HEAPF32[i41 >> 2] = f4;
   HEAPF32[i122 >> 2] = f4;
   i1 = HEAP32[i42 >> 2] | 0;
   L43 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i6 = HEAP32[i21 >> 2] | 0;
     HEAP32[i22 >> 2] = i6;
     HEAP32[i23 >> 2] = i6;
     HEAP32[i24 >> 2] = i6;
     HEAP32[i124 >> 2] = i6;
     break;
    }
   case 3:
    {
     f134 = Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + 4 >> 2]);
     f18 = Math_fround(HEAPF32[i21 >> 2]);
     f134 = Math_fround(f134 * f18);
     f134 = Math_fround(f134 + Math_fround(f4 * Math_fround(Math_fround(f18 * Math_fround(HEAPF32[(HEAP32[i26 >> 2] | 0) + 4 >> 2])) - f134)));
     HEAPF32[i124 >> 2] = f134;
     HEAPF32[i24 >> 2] = f134;
     HEAPF32[i23 >> 2] = f134;
     HEAPF32[i22 >> 2] = f134;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i124, i130, i121, i122);
     break L43;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i124, i130, i121, i122);
     break L43;
    }
   } while (0);
   f4 = Math_fround(HEAPF32[i124 >> 2]);
   if (i114) {
    HEAP32[i122 >> 2] = HEAP32[i43 >> 2];
    i1 = HEAP32[i44 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i1, i120, i122);
    i1 = HEAP32[i45 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i1, i120, i122);
    if (i126) {
     i6 = HEAP32[i122 >> 2] | 0;
     f17 = Math_fround(Math_fround((i6 & 65535) >>> 8 & 255) / Math_fround(255.0));
     f18 = Math_fround(Math_fround(i6 >>> 16 & 255) / Math_fround(255.0));
     f134 = Math_fround(Math_fround(i6 >>> 24 & 255) / Math_fround(255.0));
     HEAPF32[i3 + 20 >> 2] = Math_fround(Math_fround(i6 & 255) / Math_fround(255.0));
     HEAPF32[i3 + 24 >> 2] = f17;
     HEAPF32[i3 + 28 >> 2] = f18;
     HEAPF32[i3 + 32 >> 2] = f134;
    } else {
     i2 = HEAP32[i49 >> 2] | 0;
     i5 = HEAP32[i50 >> 2] | 0;
     i6 = HEAP32[i51 >> 2] | 0;
     HEAP32[i3 + 20 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i3 + 24 >> 2] = i2;
     HEAP32[i3 + 28 >> 2] = i5;
     HEAP32[i3 + 32 >> 2] = i6;
    }
    f4 = Math_fround(f4 * Math_fround(HEAPF32[i46 >> 2]));
    if (i128) f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPU8[i47 >> 0] | 0)) / Math_fround(255.0));
    HEAPF32[i3 + 44 >> 2] = f4;
   } else {
    i2 = HEAP32[i49 >> 2] | 0;
    i5 = HEAP32[i50 >> 2] | 0;
    i6 = HEAP32[i51 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i3 + 24 >> 2] = i2;
    HEAP32[i3 + 28 >> 2] = i5;
    HEAP32[i3 + 32 >> 2] = i6;
    HEAPF32[i3 + 44 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i46 >> 2]));
   }
   if (i127) {
    HEAP32[i122 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i53 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i55 >> 2] = HEAP32[i56 >> 2];
    i1 = HEAP32[i57 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i1, i120, (HEAP8[i125 >> 0] | 0) != 0, i122);
    i1 = HEAP32[i34 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i1, i120, (HEAP8[i125 >> 0] | 0) != 0, i122);
    f4 = Math_fround(HEAPF32[i122 >> 2]);
    do if (HEAP8[i125 >> 0] | 0) {
     f4 = Math_fround(f4 * Math_fround(HEAPF32[i53 >> 2]));
     if (i39) {
      f4 = Math_fround(+Math_pow(+Math_fround(f4 * Math_fround(HEAPF32[i55 >> 2])), .333333343));
      HEAPF32[i122 >> 2] = f4;
      break;
     } else {
      f4 = Math_fround(Math_sqrt(Math_fround(f4)));
      HEAPF32[i122 >> 2] = f4;
      break;
     }
    } while (0);
    i1 = HEAP32[i35 >> 2] | 0;
    HEAPF32[i3 + 48 >> 2] = Math_fround(f7 * Math_fround(f4 * Math_fround(HEAPF32[((i1 | 0) == 3 ? i76 : i36) >> 2])));
   } else {
    i1 = HEAP32[i35 >> 2] | 0;
    HEAPF32[i3 + 48 >> 2] = Math_fround(f7 * Math_fround(HEAPF32[((i1 | 0) == 3 ? i76 : i36) >> 2]));
   }
   HEAP32[i3 + 40 >> 2] = i1;
   HEAP32[i3 + 36 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i3 + 60 >> 2] = HEAP32[i65 >> 2];
   i6 = i3 + 96 | 0;
   HEAP32[i6 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i38 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
   HEAP32[i6 + 24 >> 2] = HEAP32[i38 + 24 >> 2];
   HEAP32[i3 + 92 >> 2] = HEAP32[i33 >> 2];
   HEAP8[i3 + 85 >> 0] = HEAP8[i20 >> 0] | 0;
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != (i59 | 0));
 STACKTOP = i133;
 return;
}

function __ZN7mecanim9animation21MotionOutputBlendNodeEPNS0_12MotionOutputES2_fbbRKNS_6bitsetILj66EEE(i3, i4, f5, i1, i2, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 do if (i1) i7 = 4; else if (i2) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!(i1 & 1)) break; else {
   i7 = 4;
   break;
  }
 } else return; while (0);
 do if ((i7 | 0) == 4) {
  f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f11 = Math_fround(f11 * f5);
  f20 = Math_fround(f20 * f5);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * f5);
  i18 = i3 + 4 | 0;
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i18 >> 2]));
  i1 = i3 + 8 | 0;
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2]));
  i10 = i3 + 12 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i18 >> 2] = f11;
  HEAPF32[i1 >> 2] = f20;
  HEAPF32[i10 >> 2] = f8;
  f8 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f8 = Math_fround(f8 * f5);
  f20 = Math_fround(f20 * f5);
  f11 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * f5);
  i10 = i3 + 16 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i10 >> 2]));
  i1 = i3 + 20 | 0;
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2]));
  i18 = i3 + 24 | 0;
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i18 >> 2]));
  HEAPF32[i10 >> 2] = f8;
  HEAPF32[i1 >> 2] = f20;
  HEAPF32[i18 >> 2] = f11;
  f11 = Math_fround(Math_fround(HEAPF32[i4 + 284 >> 2]) * f5);
  i18 = i3 + 284 | 0;
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f11);
  f11 = Math_fround(HEAPF32[i4 + 40 >> 2]);
  f20 = Math_fround(f11 * f5);
  f8 = Math_fround(HEAPF32[i4 + 44 >> 2]);
  f19 = Math_fround(f8 * f5);
  f13 = Math_fround(HEAPF32[i4 + 48 >> 2]);
  f9 = Math_fround(f13 * f5);
  f22 = Math_fround(HEAPF32[i4 + 52 >> 2]);
  f21 = Math_fround(f22 * f5);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = i3 + 40 | 0;
  f21 = Math_fround(HEAPF32[i14 >> 2]);
  f11 = Math_fround(f21 * f11);
  i7 = i3 + 44 | 0;
  f9 = Math_fround(HEAPF32[i7 >> 2]);
  f8 = Math_fround(f9 * f8);
  i16 = i3 + 48 | 0;
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  f13 = Math_fround(f19 * f13);
  i17 = i3 + 52 | 0;
  f20 = Math_fround(HEAPF32[i17 >> 2]);
  f22 = Math_fround(Math_fround(f11 + f8) + Math_fround(f13 + Math_fround(f20 * f22)));
  i15 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f9 = Math_fround(f9 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i7 >> 2] = f9;
  HEAPF32[i16 >> 2] = f19;
  HEAPF32[i17 >> 2] = f20;
  f20 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f20 = Math_fround(f20 * f5);
  f19 = Math_fround(f19 * f5);
  f9 = Math_fround(Math_fround(HEAPF32[i4 + 36 >> 2]) * f5);
  i17 = i3 + 28 | 0;
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i17 >> 2]));
  i16 = i3 + 32 | 0;
  f19 = Math_fround(f19 + Math_fround(HEAPF32[i16 >> 2]));
  i7 = i3 + 36 | 0;
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i17 >> 2] = f20;
  HEAPF32[i16 >> 2] = f19;
  HEAPF32[i7 >> 2] = f9;
  f9 = Math_fround(HEAPF32[i4 + 80 >> 2]);
  f19 = Math_fround(f9 * f5);
  f20 = Math_fround(HEAPF32[i4 + 84 >> 2]);
  f21 = Math_fround(f20 * f5);
  f22 = Math_fround(HEAPF32[i4 + 88 >> 2]);
  f13 = Math_fround(f22 * f5);
  f8 = Math_fround(HEAPF32[i4 + 92 >> 2]);
  f11 = Math_fround(f8 * f5);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = i3 + 80 | 0;
  f11 = Math_fround(HEAPF32[i12 >> 2]);
  f9 = Math_fround(f11 * f9);
  i15 = i3 + 84 | 0;
  f13 = Math_fround(HEAPF32[i15 >> 2]);
  f20 = Math_fround(f13 * f20);
  i10 = i3 + 88 | 0;
  f21 = Math_fround(HEAPF32[i10 >> 2]);
  f22 = Math_fround(f21 * f22);
  i1 = i3 + 92 | 0;
  f19 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(Math_fround(f9 + f20) + Math_fround(f22 + Math_fround(f19 * f8)));
  i18 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f11 = Math_fround(f11 + (HEAP32[tempDoublePtr >> 2] = i18 ^ i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f13 = Math_fround(f13 + (HEAP32[tempDoublePtr >> 2] = i18 ^ i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i18 ^ i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i18 ^ i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i12 >> 2] = f11;
  HEAPF32[i15 >> 2] = f13;
  HEAPF32[i10 >> 2] = f21;
  HEAPF32[i1 >> 2] = f19;
  f19 = Math_fround(HEAPF32[i4 + 68 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 72 >> 2]);
  f19 = Math_fround(f19 * f5);
  f21 = Math_fround(f21 * f5);
  f13 = Math_fround(Math_fround(HEAPF32[i4 + 76 >> 2]) * f5);
  i1 = i3 + 68 | 0;
  f19 = Math_fround(f19 + Math_fround(HEAPF32[i1 >> 2]));
  i10 = i3 + 72 | 0;
  f21 = Math_fround(f21 + Math_fround(HEAPF32[i10 >> 2]));
  i15 = i3 + 76 | 0;
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i15 >> 2]));
  HEAPF32[i1 >> 2] = f19;
  HEAPF32[i10 >> 2] = f21;
  HEAPF32[i15 >> 2] = f13;
  f13 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f21 = Math_fround(f13 * f5);
  f19 = Math_fround(HEAPF32[i4 + 124 >> 2]);
  f11 = Math_fround(f19 * f5);
  f8 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  f22 = Math_fround(f8 * f5);
  f20 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f9 = Math_fround(f20 * f5);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = i3 + 120 | 0;
  f9 = Math_fround(HEAPF32[i14 >> 2]);
  f13 = Math_fround(f9 * f13);
  i18 = i3 + 124 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f19 = Math_fround(f22 * f19);
  i17 = i3 + 128 | 0;
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f8 = Math_fround(f11 * f8);
  i16 = i3 + 132 | 0;
  f21 = Math_fround(HEAPF32[i16 >> 2]);
  f20 = Math_fround(Math_fround(f13 + f19) + Math_fround(f8 + Math_fround(f21 * f20)));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f9 = Math_fround(f9 + (HEAP32[tempDoublePtr >> 2] = i7 ^ i15, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f22 = Math_fround(f22 + (HEAP32[tempDoublePtr >> 2] = i7 ^ i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f11 = Math_fround(f11 + (HEAP32[tempDoublePtr >> 2] = i7 ^ i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i7 ^ i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i14 >> 2] = f9;
  HEAPF32[i18 >> 2] = f22;
  HEAPF32[i17 >> 2] = f11;
  HEAPF32[i16 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i4 + 108 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 112 >> 2]);
  f21 = Math_fround(f21 * f5);
  f11 = Math_fround(f11 * f5);
  f22 = Math_fround(Math_fround(HEAPF32[i4 + 116 >> 2]) * f5);
  i16 = i3 + 108 | 0;
  f21 = Math_fround(f21 + Math_fround(HEAPF32[i16 >> 2]));
  i17 = i3 + 112 | 0;
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i17 >> 2]));
  i18 = i3 + 116 | 0;
  f22 = Math_fround(f22 + Math_fround(HEAPF32[i18 >> 2]));
  HEAPF32[i16 >> 2] = f21;
  HEAPF32[i17 >> 2] = f11;
  HEAPF32[i18 >> 2] = f22;
  f22 = Math_fround(HEAPF32[i4 + 160 >> 2]);
  f11 = Math_fround(f22 * f5);
  f21 = Math_fround(HEAPF32[i4 + 164 >> 2]);
  f9 = Math_fround(f21 * f5);
  f20 = Math_fround(HEAPF32[i4 + 168 >> 2]);
  f8 = Math_fround(f20 * f5);
  f19 = Math_fround(HEAPF32[i4 + 172 >> 2]);
  f13 = Math_fround(f19 * f5);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = i3 + 160 | 0;
  f13 = Math_fround(HEAPF32[i12 >> 2]);
  f22 = Math_fround(f13 * f22);
  i7 = i3 + 164 | 0;
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  f21 = Math_fround(f8 * f21);
  i1 = i3 + 168 | 0;
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f20 = Math_fround(f9 * f20);
  i10 = i3 + 172 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  f19 = Math_fround(Math_fround(f22 + f21) + Math_fround(f20 + Math_fround(f11 * f19)));
  i15 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f13 = Math_fround(f13 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f8 = Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f9 = Math_fround(f9 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f11 = Math_fround(f11 + (HEAP32[tempDoublePtr >> 2] = i15 ^ i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i12 >> 2] = f13;
  HEAPF32[i7 >> 2] = f8;
  HEAPF32[i1 >> 2] = f9;
  HEAPF32[i10 >> 2] = f11;
  f11 = Math_fround(HEAPF32[i4 + 148 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 152 >> 2]);
  f11 = Math_fround(f11 * f5);
  f9 = Math_fround(f9 * f5);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 156 >> 2]) * f5);
  i10 = i3 + 148 | 0;
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i10 >> 2]));
  i1 = i3 + 152 | 0;
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i1 >> 2]));
  i7 = i3 + 156 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i10 >> 2] = f11;
  HEAPF32[i1 >> 2] = f9;
  HEAPF32[i7 >> 2] = f8;
  if (i2) {
   i1 = HEAP32[i6 >> 2] | 0;
   break;
  } else return;
 } while (0);
 if (i1 & 1 | 0) {
  f9 = Math_fround(HEAPF32[i4 + 292 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 296 >> 2]);
  f9 = Math_fround(f9 * f5);
  f22 = Math_fround(f22 * f5);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 300 >> 2]) * f5);
  i10 = i3 + 292 | 0;
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i10 >> 2]));
  i7 = i3 + 296 | 0;
  f22 = Math_fround(f22 + Math_fround(HEAPF32[i7 >> 2]));
  i2 = i3 + 300 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i10 >> 2] = f9;
  HEAPF32[i7 >> 2] = f22;
  HEAPF32[i2 >> 2] = f8;
  f8 = Math_fround(HEAPF32[i4 + 304 >> 2]);
  f22 = Math_fround(f8 * f5);
  f9 = Math_fround(HEAPF32[i4 + 308 >> 2]);
  f21 = Math_fround(f9 * f5);
  f11 = Math_fround(HEAPF32[i4 + 312 >> 2]);
  f20 = Math_fround(f11 * f5);
  f13 = Math_fround(HEAPF32[i4 + 316 >> 2]);
  f19 = Math_fround(f13 * f5);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = i3 + 304 | 0;
  f19 = Math_fround(HEAPF32[i15 >> 2]);
  f8 = Math_fround(f19 * f8);
  i16 = i3 + 308 | 0;
  f20 = Math_fround(HEAPF32[i16 >> 2]);
  f9 = Math_fround(f20 * f9);
  i17 = i3 + 312 | 0;
  f21 = Math_fround(HEAPF32[i17 >> 2]);
  f11 = Math_fround(f21 * f11);
  i18 = i3 + 316 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f13 = Math_fround(Math_fround(f8 + f9) + Math_fround(f11 + Math_fround(f22 * f13)));
  i12 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f22 = Math_fround(f22 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i15 >> 2] = f19;
  HEAPF32[i16 >> 2] = f20;
  HEAPF32[i17 >> 2] = f21;
  HEAPF32[i18 >> 2] = f22;
 }
 if (__ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE(i6) | 0) {
  f9 = Math_fround(HEAPF32[i4 + 188 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 192 >> 2]);
  f9 = Math_fround(f9 * f5);
  f22 = Math_fround(f22 * f5);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 196 >> 2]) * f5);
  i10 = i3 + 188 | 0;
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i10 >> 2]));
  i7 = i3 + 192 | 0;
  f22 = Math_fround(f22 + Math_fround(HEAPF32[i7 >> 2]));
  i2 = i3 + 196 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i10 >> 2] = f9;
  HEAPF32[i7 >> 2] = f22;
  HEAPF32[i2 >> 2] = f8;
  f8 = Math_fround(HEAPF32[i4 + 200 >> 2]);
  f22 = Math_fround(f8 * f5);
  f9 = Math_fround(HEAPF32[i4 + 204 >> 2]);
  f21 = Math_fround(f9 * f5);
  f11 = Math_fround(HEAPF32[i4 + 208 >> 2]);
  f20 = Math_fround(f11 * f5);
  f13 = Math_fround(HEAPF32[i4 + 212 >> 2]);
  f19 = Math_fround(f13 * f5);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = i3 + 200 | 0;
  f19 = Math_fround(HEAPF32[i15 >> 2]);
  f8 = Math_fround(f19 * f8);
  i16 = i3 + 204 | 0;
  f20 = Math_fround(HEAPF32[i16 >> 2]);
  f9 = Math_fround(f20 * f9);
  i17 = i3 + 208 | 0;
  f21 = Math_fround(HEAPF32[i17 >> 2]);
  f11 = Math_fround(f21 * f11);
  i18 = i3 + 212 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f13 = Math_fround(Math_fround(f8 + f9) + Math_fround(f11 + Math_fround(f22 * f13)));
  i12 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f22 = Math_fround(f22 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i15 >> 2] = f19;
  HEAPF32[i16 >> 2] = f20;
  HEAPF32[i17 >> 2] = f21;
  HEAPF32[i18 >> 2] = f22;
  i18 = i3 + 268 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 268 >> 2]);
  HEAPF32[i18 >> 2] = f22 < f21 ? f21 : f22;
  i18 = i3 + 272 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 272 >> 2]);
  HEAPF32[i18 >> 2] = f22 < f21 ? f21 : f22;
 }
 if (__ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE(i6) | 0) {
  f9 = Math_fround(HEAPF32[i4 + 228 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 232 >> 2]);
  f9 = Math_fround(f9 * f5);
  f22 = Math_fround(f22 * f5);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 236 >> 2]) * f5);
  i10 = i3 + 228 | 0;
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i10 >> 2]));
  i7 = i3 + 232 | 0;
  f22 = Math_fround(f22 + Math_fround(HEAPF32[i7 >> 2]));
  i6 = i3 + 236 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i10 >> 2] = f9;
  HEAPF32[i7 >> 2] = f22;
  HEAPF32[i6 >> 2] = f8;
  f8 = Math_fround(HEAPF32[i4 + 240 >> 2]);
  f22 = Math_fround(f8 * f5);
  f9 = Math_fround(HEAPF32[i4 + 244 >> 2]);
  f21 = Math_fround(f9 * f5);
  f11 = Math_fround(HEAPF32[i4 + 248 >> 2]);
  f20 = Math_fround(f11 * f5);
  f13 = Math_fround(HEAPF32[i4 + 252 >> 2]);
  f19 = Math_fround(f13 * f5);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = i3 + 240 | 0;
  f19 = Math_fround(HEAPF32[i15 >> 2]);
  f8 = Math_fround(f19 * f8);
  i16 = i3 + 244 | 0;
  f20 = Math_fround(HEAPF32[i16 >> 2]);
  f9 = Math_fround(f20 * f9);
  i17 = i3 + 248 | 0;
  f21 = Math_fround(HEAPF32[i17 >> 2]);
  f11 = Math_fround(f21 * f11);
  i18 = i3 + 252 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f13 = Math_fround(Math_fround(f8 + f9) + Math_fround(f11 + Math_fround(f22 * f13)));
  i12 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f22 = Math_fround(f22 + (HEAP32[tempDoublePtr >> 2] = i12 ^ i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i15 >> 2] = f19;
  HEAPF32[i16 >> 2] = f20;
  HEAPF32[i17 >> 2] = f21;
  HEAPF32[i18 >> 2] = f22;
  i18 = i3 + 276 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 276 >> 2]);
  HEAPF32[i18 >> 2] = f22 < f21 ? f21 : f22;
  i18 = i3 + 280 | 0;
  f22 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 280 >> 2]);
  HEAPF32[i18 >> 2] = f22 < f21 ? f21 : f22;
 }
 f22 = Math_fround(Math_fround(HEAPF32[i4 + 288 >> 2]) * f5);
 i18 = i3 + 288 | 0;
 HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f22);
 return;
}

function __ZN5physx18PxsDynamicsContext22createFinalizeContactsENS_14PxFrictionType4EnumEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEjPNS_10PxBaseTaskERNS_16PxsThreadContextE(i74, i82, i1, i87, i2, i3, i83) {
 i74 = i74 | 0;
 i82 = i82 | 0;
 i1 = i1 | 0;
 i87 = i87 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i83 = i83 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, f79 = f0, i80 = 0, f81 = f0, i84 = 0, i85 = 0, i86 = 0, f88 = f0, f89 = f0, f90 = f0;
 i86 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i86 + 496 | 0;
 i75 = i86 + 288 | 0;
 i59 = i86 + 272 | 0;
 i57 = i86 + 256 | 0;
 i60 = i86 + 240 | 0;
 i61 = i86 + 224 | 0;
 i62 = i86 + 208 | 0;
 i63 = i86 + 192 | 0;
 i55 = i86 + 176 | 0;
 i56 = i86 + 160 | 0;
 i76 = i86 + 128 | 0;
 i69 = i86 + 112 | 0;
 i68 = i86 + 96 | 0;
 i70 = i86 + 80 | 0;
 i71 = i86 + 64 | 0;
 i72 = i86 + 48 | 0;
 i73 = i86 + 32 | 0;
 i66 = i86 + 16 | 0;
 i67 = i86;
 i84 = HEAP32[i83 + 8928 >> 2] | 0;
 i65 = HEAP32[i83 + 8940 >> 2] | 0;
 i64 = HEAP32[i83 + 8944 >> 2] | 0;
 i85 = i83 + 9028 | 0;
 i1 = HEAP32[i85 >> 2] | 0;
 f79 = Math_fround(HEAPF32[i74 + 124 >> 2]);
 i77 = i74 + 128 | 0;
 f81 = Math_fround(HEAPF32[i77 >> 2]);
 i78 = i83 + 16 | 0;
 i80 = i83 + 332 | 0;
 HEAP32[i83 + 336 >> 2] = 0;
 HEAP32[i83 + 340 >> 2] = 0;
 L1 : do if (i64 >>> 0 > 1) {
  i17 = i64 + -1 | 0;
  i18 = i58 + 4 | 0;
  i19 = i58 + 8 | 0;
  i20 = i58 + 12 | 0;
  i21 = i58 + 16 | 0;
  i22 = i58 + 20 | 0;
  i23 = i58 + 24 | 0;
  i24 = i83 + 316 | 0;
  i25 = i59 + 4 | 0;
  i26 = i59 + 8 | 0;
  i27 = i59 + 12 | 0;
  i28 = i57 + 4 | 0;
  i29 = i57 + 8 | 0;
  i30 = i57 + 12 | 0;
  i31 = i60 + 4 | 0;
  i32 = i60 + 8 | 0;
  i33 = i60 + 12 | 0;
  i34 = i61 + 4 | 0;
  i35 = i61 + 8 | 0;
  i36 = i61 + 12 | 0;
  i37 = i62 + 4 | 0;
  i38 = i62 + 8 | 0;
  i39 = i62 + 12 | 0;
  i40 = i63 + 4 | 0;
  i41 = i63 + 8 | 0;
  i42 = i63 + 12 | 0;
  i43 = i55 + 4 | 0;
  i44 = i55 + 8 | 0;
  i45 = i55 + 12 | 0;
  i46 = i56 + 4 | 0;
  i47 = i56 + 8 | 0;
  i48 = i56 + 12 | 0;
  i49 = gb + 106268 + (i82 << 2) | 0;
  i50 = i74 + 140 | 0;
  i51 = i74 + 144 | 0;
  i52 = i83 + 8788 | 0;
  i53 = gb + 106280 + (i82 << 2) | 0;
  i54 = 1;
  while (1) {
   i5 = i54 + -1 | 0;
   switch (HEAP16[i84 + (HEAP32[i65 + (i54 << 3) >> 2] << 5) + 26 >> 1] | 0) {
   case 1:
    {
     i3 = i65 + (i54 << 3) + 4 | 0;
     if (HEAP16[i3 >> 1] | 0) if ((HEAPU16[i3 >> 1] | 0) > 1) {
      i2 = 1;
      do i2 = i2 + 1 | 0; while (i2 >>> 0 < (HEAPU16[i3 >> 1] | 0) >>> 0);
     }
     break;
    }
   case 2:
    {
     i3 = i65 + (i54 << 3) + 4 | 0;
     if (HEAP16[i3 >> 1] | 0) if ((HEAPU16[i3 >> 1] | 0) > 1) {
      i2 = 1;
      do i2 = i2 + 1 | 0; while (i2 >>> 0 < (HEAPU16[i3 >> 1] | 0) >>> 0);
     }
     break;
    }
   default:
    {}
   }
   i4 = i54 + 2 | 0;
   i4 = i4 >>> 0 < i17 >>> 0 ? i4 : i17;
   i3 = i65 + (i4 << 3) + 4 | 0;
   i16 = HEAP16[i3 >> 1] | 0;
   i4 = i65 + (i4 << 3) | 0;
   if (i16 << 16 >> 16) {
    i2 = 0;
    do {
     i2 = i2 + 1 | 0;
     i16 = HEAPU16[i3 >> 1] | 0;
    } while (i2 >>> 0 < i16 >>> 0);
   }
   i16 = i65 + (i5 << 3) | 0;
   i14 = HEAP32[i16 >> 2] | 0;
   i3 = i84 + (i14 << 5) | 0;
   L19 : do switch (HEAP16[i84 + (i14 << 5) + 26 >> 1] | 0) {
   case 2:
    {
     i15 = i65 + (i5 << 3) + 4 | 0;
     i2 = HEAP16[i15 >> 1] | 0;
     if (i2 << 16 >> 16 == 4) {
      HEAPF32[i58 >> 2] = Math_fround(0.0);
      HEAPF32[i18 >> 2] = Math_fround(0.0);
      HEAPF32[i19 >> 2] = Math_fround(0.0);
      HEAPF32[i20 >> 2] = Math_fround(1.0);
      HEAPF32[i21 >> 2] = Math_fround(0.0);
      HEAPF32[i22 >> 2] = Math_fround(0.0);
      HEAPF32[i23 >> 2] = Math_fround(0.0);
      i13 = 0;
      do {
       i7 = i14 + i13 | 0;
       i9 = i84 + (i7 << 5) | 0;
       i10 = HEAP32[i84 + (i7 << 5) + 16 >> 2] | 0;
       i11 = HEAP32[i10 + 16 >> 2] | 0;
       i12 = HEAP32[i10 + 12 >> 2] | 0;
       i2 = HEAP32[i10 + 36 >> 2] | 0;
       if (!i2) i8 = i58; else i8 = HEAP32[i2 + 64 >> 2] | 0;
       i2 = HEAP32[i10 + 40 >> 2] | 0;
       if (!i2) i6 = i58; else i6 = HEAP32[i2 + 64 >> 2] | 0;
       i3 = HEAP32[i9 >> 2] | 0;
       i4 = HEAP32[i84 + (i7 << 5) + 4 >> 2] | 0;
       if ((HEAP16[i84 + (i7 << 5) + 8 >> 1] | 0) == -1) i5 = HEAPU16[i84 + (i7 << 5) + 10 >> 1] | 0; else i5 = 0;
       if ((HEAP16[i84 + (i7 << 5) + 12 >> 1] | 0) == -1) i2 = HEAPU16[i84 + (i7 << 5) + 14 >> 1] | 0; else i2 = 0;
       HEAP32[i75 + (i13 * 52 | 0) + 32 >> 2] = HEAP32[i10 + 28 >> 2];
       HEAP32[i75 + (i13 * 52 | 0) + 36 >> 2] = i12;
       HEAP32[i75 + (i13 * 52 | 0) >> 2] = i10;
       HEAP32[i75 + (i13 * 52 | 0) + 40 >> 2] = i9;
       HEAP32[i75 + (i13 * 52 | 0) + 4 >> 2] = i8;
       HEAP32[i75 + (i13 * 52 | 0) + 8 >> 2] = i6;
       HEAP32[i75 + (i13 * 52 | 0) + 20 >> 2] = i87 + (i5 << 6);
       HEAP32[i75 + (i13 * 52 | 0) + 24 >> 2] = i87 + (i2 << 6);
       HEAP32[i75 + (i13 * 52 | 0) + 12 >> 2] = i3;
       HEAP32[i75 + (i13 * 52 | 0) + 16 >> 2] = i4;
       HEAP32[i75 + (i13 * 52 | 0) + 28 >> 2] = i11;
       i13 = i13 + 1 | 0;
      } while ((i13 | 0) != 4);
      if ((__ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i75, f79, f81, i80, i24) | 0) != 1) break L19;
      i2 = HEAP16[i15 >> 1] | 0;
     }
     if (i2 << 16 >> 16) {
      i2 = 0;
      do {
       i14 = (HEAP32[i16 >> 2] | 0) + i2 | 0;
       i1 = (__ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(HEAP32[i84 + (i14 << 5) + 16 >> 2] | 0, i87, i80, f79, f81, i84 + (i14 << 5) | 0, i24) | 0) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < (HEAPU16[i15 >> 1] | 0) >>> 0);
     }
     break;
    }
   case 1:
    {
     i10 = i65 + (i5 << 3) + 4 | 0;
     i2 = HEAP16[i10 >> 1] | 0;
     if (i2 << 16 >> 16 == 4) {
      i7 = i14 + 1 | 0;
      i4 = i84 + (i7 << 5) | 0;
      i8 = i14 + 2 | 0;
      i5 = i84 + (i8 << 5) | 0;
      i9 = i14 + 3 | 0;
      i6 = i84 + (i9 << 5) | 0;
      i12 = HEAP32[i84 + (i14 << 5) + 16 >> 2] | 0;
      i13 = HEAP32[i84 + (i7 << 5) + 16 >> 2] | 0;
      i15 = HEAP32[i84 + (i8 << 5) + 16 >> 2] | 0;
      i11 = HEAP32[i84 + (i9 << 5) + 16 >> 2] | 0;
      HEAP32[i59 >> 2] = i12 + 16;
      HEAP32[i25 >> 2] = i13 + 16;
      HEAP32[i26 >> 2] = i15 + 16;
      HEAP32[i27 >> 2] = i11 + 16;
      HEAP32[i57 >> 2] = i3;
      HEAP32[i28 >> 2] = i4;
      HEAP32[i29 >> 2] = i5;
      HEAP32[i30 >> 2] = i6;
      HEAP32[i60 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i31 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i32 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i33 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i61 >> 2] = HEAP32[i84 + (i14 << 5) + 4 >> 2];
      HEAP32[i34 >> 2] = HEAP32[i84 + (i7 << 5) + 4 >> 2];
      HEAP32[i35 >> 2] = HEAP32[i84 + (i8 << 5) + 4 >> 2];
      HEAP32[i36 >> 2] = HEAP32[i84 + (i9 << 5) + 4 >> 2];
      HEAP32[i62 >> 2] = i87 + (HEAPU16[i84 + (i14 << 5) + 10 >> 1] << 6);
      HEAP32[i37 >> 2] = i87 + (HEAPU16[i84 + (i7 << 5) + 10 >> 1] << 6);
      HEAP32[i38 >> 2] = i87 + (HEAPU16[i84 + (i8 << 5) + 10 >> 1] << 6);
      HEAP32[i39 >> 2] = i87 + (HEAPU16[i84 + (i9 << 5) + 10 >> 1] << 6);
      HEAP32[i63 >> 2] = i87 + (HEAPU16[i84 + (i14 << 5) + 14 >> 1] << 6);
      HEAP32[i40 >> 2] = i87 + (HEAPU16[i84 + (i7 << 5) + 14 >> 1] << 6);
      HEAP32[i41 >> 2] = i87 + (HEAPU16[i84 + (i8 << 5) + 14 >> 1] << 6);
      HEAP32[i42 >> 2] = i87 + (HEAPU16[i84 + (i9 << 5) + 14 >> 1] << 6);
      HEAP32[i55 >> 2] = HEAP32[i12 + 80 >> 2];
      HEAP32[i43 >> 2] = HEAP32[i13 + 80 >> 2];
      HEAP32[i44 >> 2] = HEAP32[i15 + 80 >> 2];
      HEAP32[i45 >> 2] = HEAP32[i11 + 80 >> 2];
      HEAP32[i56 >> 2] = HEAP32[i12 + 84 >> 2];
      HEAP32[i46 >> 2] = HEAP32[i13 + 84 >> 2];
      HEAP32[i47 >> 2] = HEAP32[i15 + 84 >> 2];
      HEAP32[i48 >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + 68 >> 2];
      f89 = Math_fround(HEAPF32[i50 >> 2]);
      f88 = Math_fround(HEAPF32[i51 >> 2]);
      if ((mftCall_iiiiiiiiiiffffii(HEAP32[i49 >> 2] | 0, i59 | 0, i78 | 0, i57 | 0, i60 | 0, i61 | 0, i62 | 0, i63 | 0, i55 | 0, i56 | 0, +f81, +f89, +f88, +Math_fround(HEAPF32[i52 >> 2]), i24 | 0, i82 | 0) | 0) != 1) break L19;
      i2 = HEAP16[i10 >> 1] | 0;
     }
     if (i2 << 16 >> 16) {
      i9 = 0;
      do {
       i7 = (HEAP32[i16 >> 2] | 0) + i9 | 0;
       i2 = i84 + (i7 << 5) | 0;
       i3 = i84 + (i7 << 5) + 16 | 0;
       i8 = HEAP32[i3 >> 2] | 0;
       i4 = i8 + 16 | 0;
       if ((HEAP16[i84 + (i7 << 5) + 8 >> 1] | 0) == -1) i5 = i87 + (HEAPU16[i84 + (i7 << 5) + 10 >> 1] << 6) | 0; else i5 = i87;
       if ((HEAP16[i84 + (i7 << 5) + 12 >> 1] | 0) == -1) i6 = i87 + (HEAPU16[i84 + (i7 << 5) + 14 >> 1] << 6) | 0; else i6 = i87;
       f90 = Math_fround(HEAPF32[i77 >> 2]);
       f88 = Math_fround(HEAPF32[i50 >> 2]);
       f89 = Math_fround(HEAPF32[i51 >> 2]);
       mftCall_iiiiiiiiiiiiffffii(HEAP32[i53 >> 2] | 0, i4 | 0, i78 | 0, 0, 0, i2 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i84 + (i7 << 5) + 4 >> 2] | 0, i5 | 0, i6 | 0, HEAP32[i8 + 80 >> 2] | 0, HEAP32[i8 + 84 >> 2] | 0, +f90, +f88, +f89, +Math_fround(HEAPF32[i52 >> 2]), i24 | 0, i82 | 0) | 0;
       HEAP16[i84 + (i7 << 5) + 26 >> 1] = (HEAP32[i8 + 20 >> 2] | 0) >>> 4;
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       if (!(HEAP16[i8 + 114 >> 1] & 16)) {
        i2 = 0;
        i3 = 0;
       } else {
        i2 = (HEAP32[i8 + 44 >> 2] | 0) + ((HEAP32[i8 + 48 >> 2] | 0) + 15 & -16) | 0;
        i3 = HEAP16[i8 + 36 >> 1] | 0;
       }
       HEAP32[i84 + (i7 << 5) + 20 >> 2] = i2;
       HEAP16[i84 + (i7 << 5) + 24 >> 1] = i3;
       i1 = (HEAPU16[i8 + 32 >> 1] | 0) + i1 | 0;
       i9 = i9 + 1 | 0;
      } while (i9 >>> 0 < (HEAPU16[i10 >> 1] | 0) >>> 0);
     }
     break;
    }
   default:
    {}
   } while (0);
   i54 = i54 + 1 | 0;
   if ((i54 | 0) == (i64 | 0)) break L1;
  }
 } while (0);
 if (!i64) {
  i87 = i1;
  HEAP32[i85 >> 2] = i87;
  STACKTOP = i86;
  return;
 }
 i2 = i64 + -1 | 0;
 i17 = i65 + (i2 << 3) | 0;
 i16 = HEAP32[i17 >> 2] | 0;
 i3 = i84 + (i16 << 5) | 0;
 switch (HEAP16[i84 + (i16 << 5) + 26 >> 1] | 0) {
 case 2:
  {
   i14 = i65 + (i2 << 3) + 4 | 0;
   i2 = HEAP16[i14 >> 1] | 0;
   do if (i2 << 16 >> 16 == 4) {
    HEAPF32[i76 >> 2] = Math_fround(0.0);
    HEAPF32[i76 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i76 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i76 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i76 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i76 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i76 + 24 >> 2] = Math_fround(0.0);
    i13 = 0;
    do {
     i7 = i16 + i13 | 0;
     i9 = i84 + (i7 << 5) | 0;
     i10 = HEAP32[i84 + (i7 << 5) + 16 >> 2] | 0;
     i11 = HEAP32[i10 + 16 >> 2] | 0;
     i12 = HEAP32[i10 + 12 >> 2] | 0;
     i2 = HEAP32[i10 + 36 >> 2] | 0;
     if (!i2) i8 = i76; else i8 = HEAP32[i2 + 64 >> 2] | 0;
     i2 = HEAP32[i10 + 40 >> 2] | 0;
     if (!i2) i6 = i76; else i6 = HEAP32[i2 + 64 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i84 + (i7 << 5) + 4 >> 2] | 0;
     if ((HEAP16[i84 + (i7 << 5) + 8 >> 1] | 0) == -1) i5 = HEAPU16[i84 + (i7 << 5) + 10 >> 1] | 0; else i5 = 0;
     if ((HEAP16[i84 + (i7 << 5) + 12 >> 1] | 0) == -1) i2 = HEAPU16[i84 + (i7 << 5) + 14 >> 1] | 0; else i2 = 0;
     HEAP32[i75 + (i13 * 52 | 0) + 32 >> 2] = HEAP32[i10 + 28 >> 2];
     HEAP32[i75 + (i13 * 52 | 0) + 36 >> 2] = i12;
     HEAP32[i75 + (i13 * 52 | 0) >> 2] = i10;
     HEAP32[i75 + (i13 * 52 | 0) + 40 >> 2] = i9;
     HEAP32[i75 + (i13 * 52 | 0) + 4 >> 2] = i8;
     HEAP32[i75 + (i13 * 52 | 0) + 8 >> 2] = i6;
     HEAP32[i75 + (i13 * 52 | 0) + 20 >> 2] = i87 + (i5 << 6);
     HEAP32[i75 + (i13 * 52 | 0) + 24 >> 2] = i87 + (i2 << 6);
     HEAP32[i75 + (i13 * 52 | 0) + 12 >> 2] = i3;
     HEAP32[i75 + (i13 * 52 | 0) + 16 >> 2] = i4;
     HEAP32[i75 + (i13 * 52 | 0) + 28 >> 2] = i11;
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != 4);
    if ((__ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i75, f79, f81, i80, i83 + 316 | 0) | 0) == 1) {
     i2 = HEAP16[i14 >> 1] | 0;
     break;
    } else {
     i87 = i1;
     HEAP32[i85 >> 2] = i87;
     STACKTOP = i86;
     return;
    }
   } while (0);
   if (!(i2 << 16 >> 16)) {
    i87 = i1;
    HEAP32[i85 >> 2] = i87;
    STACKTOP = i86;
    return;
   }
   i3 = i83 + 316 | 0;
   i2 = 0;
   do {
    i83 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
    i1 = (__ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(HEAP32[i84 + (i83 << 5) + 16 >> 2] | 0, i87, i80, f79, f81, i84 + (i83 << 5) | 0, i3) | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAPU16[i14 >> 1] | 0) >>> 0);
   HEAP32[i85 >> 2] = i1;
   STACKTOP = i86;
   return;
  }
 case 1:
  {
   i15 = i65 + (i2 << 3) + 4 | 0;
   i2 = HEAP16[i15 >> 1] | 0;
   do if (i2 << 16 >> 16 == 4) {
    i63 = i16 + 1 | 0;
    i60 = i84 + (i63 << 5) | 0;
    i64 = i16 + 2 | 0;
    i61 = i84 + (i64 << 5) | 0;
    i65 = i16 + 3 | 0;
    i62 = i84 + (i65 << 5) | 0;
    i76 = HEAP32[i84 + (i63 << 5) + 16 >> 2] | 0;
    i80 = HEAP32[i84 + (i64 << 5) + 16 >> 2] | 0;
    i59 = HEAP32[i84 + (i65 << 5) + 16 >> 2] | 0;
    HEAP32[i69 >> 2] = (HEAP32[i84 + (i16 << 5) + 16 >> 2] | 0) + 16;
    i75 = i69 + 4 | 0;
    HEAP32[i75 >> 2] = i76 + 16;
    i76 = i69 + 8 | 0;
    HEAP32[i76 >> 2] = i80 + 16;
    i80 = i69 + 12 | 0;
    HEAP32[i80 >> 2] = i59 + 16;
    HEAP32[i68 >> 2] = i3;
    HEAP32[i68 + 4 >> 2] = i60;
    HEAP32[i68 + 8 >> 2] = i61;
    HEAP32[i68 + 12 >> 2] = i62;
    HEAP32[i70 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i70 + 4 >> 2] = HEAP32[i60 >> 2];
    HEAP32[i70 + 8 >> 2] = HEAP32[i61 >> 2];
    HEAP32[i70 + 12 >> 2] = HEAP32[i62 >> 2];
    HEAP32[i71 >> 2] = HEAP32[i84 + (i16 << 5) + 4 >> 2];
    HEAP32[i71 + 4 >> 2] = HEAP32[i84 + (i63 << 5) + 4 >> 2];
    HEAP32[i71 + 8 >> 2] = HEAP32[i84 + (i64 << 5) + 4 >> 2];
    HEAP32[i71 + 12 >> 2] = HEAP32[i84 + (i65 << 5) + 4 >> 2];
    HEAP32[i72 >> 2] = i87 + (HEAPU16[i84 + (i16 << 5) + 10 >> 1] << 6);
    HEAP32[i72 + 4 >> 2] = i87 + (HEAPU16[i84 + (i63 << 5) + 10 >> 1] << 6);
    HEAP32[i72 + 8 >> 2] = i87 + (HEAPU16[i84 + (i64 << 5) + 10 >> 1] << 6);
    HEAP32[i72 + 12 >> 2] = i87 + (HEAPU16[i84 + (i65 << 5) + 10 >> 1] << 6);
    HEAP32[i73 >> 2] = i87 + (HEAPU16[i84 + (i16 << 5) + 14 >> 1] << 6);
    HEAP32[i73 + 4 >> 2] = i87 + (HEAPU16[i84 + (i63 << 5) + 14 >> 1] << 6);
    HEAP32[i73 + 8 >> 2] = i87 + (HEAPU16[i84 + (i64 << 5) + 14 >> 1] << 6);
    HEAP32[i73 + 12 >> 2] = i87 + (HEAPU16[i84 + (i65 << 5) + 14 >> 1] << 6);
    i65 = HEAP32[i69 >> 2] | 0;
    HEAP32[i66 >> 2] = HEAP32[i65 + 64 >> 2];
    i75 = HEAP32[i75 >> 2] | 0;
    HEAP32[i66 + 4 >> 2] = HEAP32[i75 + 64 >> 2];
    i76 = HEAP32[i76 >> 2] | 0;
    HEAP32[i66 + 8 >> 2] = HEAP32[i76 + 64 >> 2];
    i80 = HEAP32[i80 >> 2] | 0;
    HEAP32[i66 + 12 >> 2] = HEAP32[i80 + 64 >> 2];
    HEAP32[i67 >> 2] = HEAP32[i65 + 68 >> 2];
    HEAP32[i67 + 4 >> 2] = HEAP32[i75 + 68 >> 2];
    HEAP32[i67 + 8 >> 2] = HEAP32[i76 + 68 >> 2];
    HEAP32[i67 + 12 >> 2] = HEAP32[i80 + 68 >> 2];
    f89 = Math_fround(HEAPF32[i74 + 140 >> 2]);
    f90 = Math_fround(HEAPF32[i74 + 144 >> 2]);
    if ((mftCall_iiiiiiiiiiffffii(HEAP32[gb + 106268 + (i82 << 2) >> 2] | 0, i69 | 0, i78 | 0, i68 | 0, i70 | 0, i71 | 0, i72 | 0, i73 | 0, i66 | 0, i67 | 0, +f81, +f89, +f90, +Math_fround(HEAPF32[i83 + 8788 >> 2]), i83 + 316 | 0, i82 | 0) | 0) == 1) {
     i2 = HEAP16[i15 >> 1] | 0;
     break;
    } else {
     i87 = i1;
     HEAP32[i85 >> 2] = i87;
     STACKTOP = i86;
     return;
    }
   } while (0);
   if (!(i2 << 16 >> 16)) {
    i87 = i1;
    HEAP32[i85 >> 2] = i87;
    STACKTOP = i86;
    return;
   }
   i13 = gb + 106280 + (i82 << 2) | 0;
   i14 = i74 + 140 | 0;
   i11 = i74 + 144 | 0;
   i12 = i83 + 8788 | 0;
   i10 = i83 + 316 | 0;
   i9 = 0;
   do {
    i7 = (HEAP32[i17 >> 2] | 0) + i9 | 0;
    i2 = i84 + (i7 << 5) | 0;
    i3 = i84 + (i7 << 5) + 16 | 0;
    i8 = HEAP32[i3 >> 2] | 0;
    i4 = i8 + 16 | 0;
    if ((HEAP16[i84 + (i7 << 5) + 8 >> 1] | 0) == -1) i5 = i87 + (HEAPU16[i84 + (i7 << 5) + 10 >> 1] << 6) | 0; else i5 = i87;
    if ((HEAP16[i84 + (i7 << 5) + 12 >> 1] | 0) == -1) i6 = i87 + (HEAPU16[i84 + (i7 << 5) + 14 >> 1] << 6) | 0; else i6 = i87;
    f88 = Math_fround(HEAPF32[i77 >> 2]);
    f89 = Math_fround(HEAPF32[i14 >> 2]);
    f90 = Math_fround(HEAPF32[i11 >> 2]);
    mftCall_iiiiiiiiiiiiffffii(HEAP32[i13 >> 2] | 0, i4 | 0, i78 | 0, 0, 0, i2 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i84 + (i7 << 5) + 4 >> 2] | 0, i5 | 0, i6 | 0, HEAP32[i8 + 80 >> 2] | 0, HEAP32[i8 + 84 >> 2] | 0, +f88, +f89, +f90, +Math_fround(HEAPF32[i12 >> 2]), i10 | 0, i82 | 0) | 0;
    HEAP16[i84 + (i7 << 5) + 26 >> 1] = (HEAP32[i8 + 20 >> 2] | 0) >>> 4;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    if (!(HEAP16[i8 + 114 >> 1] & 16)) {
     i2 = 0;
     i3 = 0;
    } else {
     i2 = (HEAP32[i8 + 44 >> 2] | 0) + ((HEAP32[i8 + 48 >> 2] | 0) + 15 & -16) | 0;
     i3 = HEAP16[i8 + 36 >> 1] | 0;
    }
    HEAP32[i84 + (i7 << 5) + 20 >> 2] = i2;
    HEAP16[i84 + (i7 << 5) + 24 >> 1] = i3;
    i1 = (HEAPU16[i8 + 32 >> 1] | 0) + i1 | 0;
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < (HEAPU16[i15 >> 1] | 0) >>> 0);
   HEAP32[i85 >> 2] = i1;
   STACKTOP = i86;
   return;
  }
 default:
  {
   i87 = i1;
   HEAP32[i85 >> 2] = i87;
   STACKTOP = i86;
   return;
  }
 }
}

function __ZN5physx18PxsDynamicsContext6updateEfPNS_10PxBaseTaskE(i34, f1, i23) {
 i34 = i34 | 0;
 f1 = Math_fround(f1);
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i35 + 32 | 0;
 i5 = i35;
 i8 = i35 + 48 | 0;
 HEAPF32[i34 + 124 >> 2] = f1;
 i33 = f1 == Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 HEAPF32[i34 + 128 >> 2] = i33 ? Math_fround(0.0) : f1;
 i33 = i34 + 96 | 0;
 i10 = HEAP32[i33 >> 2] | 0;
 i9 = HEAP32[i10 + 6764 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 if (!i9) {
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 6700 >> 2];
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE(i10, i2);
  STACKTOP = i35;
  return;
 }
 i11 = i10 + 6760 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i31 = i10 + 6700 | 0;
 HEAP32[i2 + 8 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + (i9 << 4) >> 2];
 HEAP32[i2 >> 2] = HEAP32[i6 + (i9 << 4) + 12 >> 2];
 __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE(i10, i2);
 HEAP32[i34 + 16 >> 2] = 0;
 HEAP32[i34 + 20 >> 2] = 0;
 HEAP32[i34 + 24 >> 2] = 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 i31 = HEAP32[i31 >> 2] | 0;
 HEAP32[i34 + 152 >> 2] = i31;
 i6 = HEAP32[i10 + 6696 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i32 = i11 + (i9 << 4) | 0;
 if (i11 | 0) {
  i2 = HEAP32[i32 >> 2] | 0;
  i3 = i2 + i31 | 0;
  i7 = i34 + 100 | 0;
  i4 = HEAP32[i34 + 108 >> 2] & 2147483647;
  if (i3 >>> 0 > i4 >>> 0) {
   i3 = i3 + 31 & -32;
   if (i4 >>> 0 < i3 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i7, i3);
    i2 = HEAP32[i32 >> 2] | 0;
   }
   i3 = i31 + 32 + i2 & -32;
   if ((HEAP32[i34 + 120 >> 2] & 2147483647) >>> 0 < i3 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i34 + 112 | 0, i3);
    i2 = HEAP32[i32 >> 2] | 0;
   }
  };
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  HEAP32[i5 + 28 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i7, i2 + i31 | 0, i5);
  i2 = i8;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i4 = i34 + 112 | 0;
  __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i4, i31 + 1 + (HEAP32[i32 >> 2] | 0) | 0, i8);
  i30 = HEAP32[i4 >> 2] | 0;
  HEAP32[i30 >> 2] = HEAP32[i34 + 32 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i34 + 36 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i34 + 40 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i34 + 44 >> 2];
  HEAP32[i30 + 16 >> 2] = HEAP32[i34 + 48 >> 2];
  HEAP32[i30 + 20 >> 2] = HEAP32[i34 + 52 >> 2];
  HEAP32[i30 + 24 >> 2] = HEAP32[i34 + 56 >> 2];
  HEAP32[i30 + 28 >> 2] = HEAP32[i34 + 60 >> 2];
  HEAP32[i30 + 32 >> 2] = HEAP32[i34 + 64 >> 2];
  i30 = i30 + 36 | 0;
  i29 = i34 + 68 | 0;
  HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  HEAP32[i30 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
  HEAP32[i30 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
  HEAP32[i30 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
  if (i31 | 0) {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = 0;
   do {
    i29 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    i30 = i3;
    i3 = i3 + 1 | 0;
    __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i2 + (i30 << 5) | 0, (HEAP32[i4 >> 2] | 0) + (i3 << 6) | 0, HEAP32[i29 + 64 >> 2] | 0, i29);
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i2 + (i30 << 5) + 28 >> 2] = 65535;
    HEAP16[i2 + (i30 << 5) + 12 >> 1] = -1;
    HEAP16[i2 + (i30 << 5) + 14 >> 1] = -1;
   } while ((i3 | 0) != (i31 | 0));
  }
 }
 i30 = HEAP32[i34 + 148 >> 2] | 0;
 if ((i9 | 0) <= 0) {
  STACKTOP = i35;
  return;
 }
 i27 = i10 + 6780 | 0;
 i28 = i10 + 6776 | 0;
 i29 = i10 + 6792 | 0;
 i26 = i10 + 6788 | 0;
 if (!i23) {
  i25 = 0;
  i2 = i11;
 } else {
  i22 = 0;
  i2 = i11;
  while (1) {
   i7 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = i7 & 2147483647;
   i18 = (HEAP32[i27 >> 2] | 0) + (i5 << 2) | 0;
   i10 = HEAP32[i2 >> 2] | 0;
   i19 = (HEAP32[i28 >> 2] | 0) + (i10 << 2) | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i20 = (HEAP32[i29 >> 2] | 0) + (i8 << 4) | 0;
   i9 = HEAP32[i2 + 8 >> 2] | 0;
   i21 = (HEAP32[i26 >> 2] | 0) + (i9 << 4) | 0;
   i3 = i2 + 16 | 0;
   L24 : do if (i3 >>> 0 < i32 >>> 0) {
    i6 = i2;
    i2 = (HEAP32[i2 + 28 >> 2] | 0) - (i9 + i8) + (HEAP32[i2 + 24 >> 2] | 0) | 0;
    i4 = i3;
    while (1) {
     if (!((i2 | 0) == 0 ? 1 : ((HEAP32[i6 + 16 >> 2] | 0) - i10 | 0) >>> 0 < i30 >>> 0)) {
      i2 = i6;
      i3 = i4;
      break L24;
     }
     if (((HEAP32[i6 + 20 >> 2] & 2147483647) - i5 | 0) >>> 0 >= 2) {
      i2 = i6;
      i3 = i4;
      break L24;
     }
     i3 = i4 + 16 | 0;
     if (i3 >>> 0 < i32 >>> 0) {
      i25 = i4;
      i2 = (HEAP32[i6 + 44 >> 2] | 0) - i8 + (HEAP32[i6 + 40 >> 2] | 0) - i9 | 0;
      i4 = i3;
      i6 = i25;
     } else {
      i2 = i4;
      break;
     }
    }
   } while (0);
   i25 = (HEAP32[i2 + 20 >> 2] | 0) - i7 & 2147483647;
   i22 = i25 | i22 & -2147483648;
   i17 = (HEAP32[i2 + 16 >> 2] | 0) - i10 | 0;
   i16 = (HEAP32[i2 + 28 >> 2] | 0) - i8 | 0;
   i15 = (HEAP32[i2 + 24 >> 2] | 0) - i9 | 0;
   if ((i25 | 0) != (0 - i17 | 0)) {
    i42 = i10 + i31 | 0;
    i41 = HEAP32[(HEAP32[i33 >> 2] | 0) + 6960 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i41 >> 2] | 0);
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i41 >> 2] | 0);
    i43 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 4, 16) | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i41 >> 2] | 0);
    HEAP32[i43 >> 2] = 0;
    i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 68, 16) | 0;
    HEAP16[i2 + 4 >> 1] = -1;
    HEAP16[i2 + 6 >> 1] = 0;
    i4 = i2 + 8 | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i2 >> 2] = gb + 87404 + 8;
    i5 = i2 + 12 | 0;
    HEAP32[i5 >> 2] = 0;
    i6 = i2 + 16 | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i2 >> 2] = gb + 105808 + 8;
    HEAP32[i2 + 20 >> 2] = i34;
    HEAP32[i2 + 24 >> 2] = i43;
    HEAP32[i2 + 28 >> 2] = i19;
    HEAP32[i2 + 32 >> 2] = i18;
    HEAP32[i2 + 36 >> 2] = 0;
    HEAP32[i2 + 40 >> 2] = i21;
    HEAP32[i2 + 44 >> 2] = i20;
    HEAP32[i2 + 48 >> 2] = i17;
    HEAP32[i2 + 52 >> 2] = i22;
    HEAP32[i2 + 56 >> 2] = i15;
    HEAP32[i2 + 60 >> 2] = i16;
    HEAP32[i2 + 64 >> 2] = i42;
    i24 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 68, 16) | 0;
    HEAP16[i24 + 4 >> 1] = -1;
    HEAP16[i24 + 6 >> 1] = 0;
    i38 = i24 + 8 | 0;
    HEAP32[i38 >> 2] = 0;
    HEAP32[i24 >> 2] = gb + 87404 + 8;
    i39 = i24 + 12 | 0;
    HEAP32[i39 >> 2] = 0;
    i40 = i24 + 16 | 0;
    HEAP32[i40 >> 2] = 0;
    HEAP32[i24 >> 2] = gb + 105852 + 8;
    HEAP32[i24 + 20 >> 2] = i34;
    HEAP32[i24 + 24 >> 2] = i43;
    HEAP32[i24 + 28 >> 2] = i19;
    HEAP32[i24 + 32 >> 2] = i18;
    HEAP32[i24 + 36 >> 2] = 0;
    HEAP32[i24 + 40 >> 2] = i21;
    HEAP32[i24 + 44 >> 2] = i20;
    HEAP32[i24 + 48 >> 2] = i17;
    HEAP32[i24 + 52 >> 2] = i22;
    HEAP32[i24 + 56 >> 2] = i15;
    HEAP32[i24 + 60 >> 2] = i16;
    HEAP32[i24 + 64 >> 2] = i42;
    i7 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 48, 16) | 0;
    HEAP16[i7 + 4 >> 1] = -1;
    HEAP16[i7 + 6 >> 1] = 0;
    i8 = i7 + 8 | 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i7 >> 2] = gb + 87404 + 8;
    i9 = i7 + 12 | 0;
    HEAP32[i9 >> 2] = 0;
    i25 = i7 + 16 | 0;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i7 >> 2] = gb + 105896 + 8;
    HEAP32[i7 + 20 >> 2] = i34;
    HEAP32[i7 + 24 >> 2] = i43;
    HEAP32[i7 + 28 >> 2] = i42;
    HEAP32[i7 + 32 >> 2] = i17;
    HEAP32[i7 + 36 >> 2] = i22;
    HEAP32[i7 + 40 >> 2] = i15;
    HEAP32[i7 + 44 >> 2] = i16;
    i10 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 68, 16) | 0;
    HEAP16[i10 + 4 >> 1] = -1;
    HEAP16[i10 + 6 >> 1] = 0;
    HEAP32[i10 + 8 >> 2] = 0;
    HEAP32[i10 >> 2] = gb + 87404 + 8;
    i36 = i10 + 12 | 0;
    HEAP32[i36 >> 2] = 0;
    i37 = i10 + 16 | 0;
    HEAP32[i37 >> 2] = 0;
    HEAP32[i10 >> 2] = gb + 105940 + 8;
    HEAP32[i10 + 20 >> 2] = i34;
    HEAP32[i10 + 24 >> 2] = i43;
    HEAP32[i10 + 28 >> 2] = i19;
    HEAP32[i10 + 32 >> 2] = i18;
    HEAP32[i10 + 36 >> 2] = 0;
    HEAP32[i10 + 40 >> 2] = i21;
    HEAP32[i10 + 44 >> 2] = i20;
    HEAP32[i10 + 48 >> 2] = i17;
    HEAP32[i10 + 52 >> 2] = i22;
    HEAP32[i10 + 56 >> 2] = i15;
    HEAP32[i10 + 60 >> 2] = i16;
    HEAP32[i10 + 64 >> 2] = i42;
    i11 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i41, 68, 16) | 0;
    HEAP16[i11 + 4 >> 1] = -1;
    HEAP16[i11 + 6 >> 1] = 0;
    i12 = i11 + 8 | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i11 >> 2] = gb + 87404 + 8;
    i13 = i11 + 12 | 0;
    HEAP32[i13 >> 2] = 0;
    i14 = i11 + 16 | 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i11 >> 2] = gb + 105984 + 8;
    HEAP32[i11 + 20 >> 2] = i34;
    HEAP32[i11 + 24 >> 2] = i43;
    HEAP32[i11 + 28 >> 2] = i19;
    HEAP32[i11 + 32 >> 2] = i18;
    HEAP32[i11 + 36 >> 2] = 0;
    HEAP32[i11 + 40 >> 2] = i21;
    HEAP32[i11 + 44 >> 2] = i20;
    HEAP32[i11 + 48 >> 2] = i17;
    HEAP32[i11 + 52 >> 2] = i22;
    HEAP32[i11 + 56 >> 2] = i15;
    HEAP32[i11 + 60 >> 2] = i16;
    HEAP32[i11 + 64 >> 2] = i42;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i41 >> 2] | 0);
    HEAP32[i40 >> 2] = 1;
    HEAP32[i39 >> 2] = i23;
    mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0, i23 | 0);
    HEAP32[i38 >> 2] = HEAP32[(HEAP32[i39 >> 2] | 0) + 8 >> 2];
    HEAP32[i37 >> 2] = 1;
    HEAP32[i36 >> 2] = i24;
    mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 16 >> 2] | 0, i24 | 0);
    HEAP32[i10 + 8 >> 2] = HEAP32[(HEAP32[i36 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] | 0, i24 | 0);
    HEAP32[i25 >> 2] = 1;
    HEAP32[i9 >> 2] = i10;
    if (i10 | 0) {
     mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
     HEAP32[i8 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2];
    }
    mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0);
    HEAP32[i14 >> 2] = 1;
    HEAP32[i13 >> 2] = i7;
    mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
    HEAP32[i12 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
    HEAP32[i6 >> 2] = 1;
    HEAP32[i5 >> 2] = i11;
    if (i11 | 0) {
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0);
     HEAP32[i4 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
    }
    mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0);
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   }
   if (i3 >>> 0 >= i32 >>> 0) break; else i2 = i3;
  }
  STACKTOP = i35;
  return;
 }
 while (1) {
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i7 & 2147483647;
  i21 = (HEAP32[i27 >> 2] | 0) + (i5 << 2) | 0;
  i10 = HEAP32[i2 >> 2] | 0;
  i22 = (HEAP32[i28 >> 2] | 0) + (i10 << 2) | 0;
  i8 = HEAP32[i2 + 12 >> 2] | 0;
  i23 = (HEAP32[i29 >> 2] | 0) + (i8 << 4) | 0;
  i9 = HEAP32[i2 + 8 >> 2] | 0;
  i24 = (HEAP32[i26 >> 2] | 0) + (i9 << 4) | 0;
  i3 = i2 + 16 | 0;
  L43 : do if (i3 >>> 0 < i32 >>> 0) {
   i6 = i2;
   i2 = (HEAP32[i2 + 28 >> 2] | 0) - (i9 + i8) + (HEAP32[i2 + 24 >> 2] | 0) | 0;
   i4 = i3;
   while (1) {
    if (!((i2 | 0) == 0 ? 1 : ((HEAP32[i6 + 16 >> 2] | 0) - i10 | 0) >>> 0 < i30 >>> 0)) {
     i2 = i6;
     i3 = i4;
     break L43;
    }
    if (((HEAP32[i6 + 20 >> 2] & 2147483647) - i5 | 0) >>> 0 >= 2) {
     i2 = i6;
     i3 = i4;
     break L43;
    }
    i3 = i4 + 16 | 0;
    if (i3 >>> 0 < i32 >>> 0) {
     i43 = i4;
     i2 = (HEAP32[i6 + 44 >> 2] | 0) - i8 + (HEAP32[i6 + 40 >> 2] | 0) - i9 | 0;
     i4 = i3;
     i6 = i43;
    } else {
     i2 = i4;
     break;
    }
   }
  } while (0);
  i43 = (HEAP32[i2 + 20 >> 2] | 0) - i7 & 2147483647;
  i25 = i43 | i25 & -2147483648;
  i20 = (HEAP32[i2 + 16 >> 2] | 0) - i10 | 0;
  i19 = (HEAP32[i2 + 28 >> 2] | 0) - i8 | 0;
  i18 = (HEAP32[i2 + 24 >> 2] | 0) - i9 | 0;
  if ((i43 | 0) != (0 - i20 | 0)) {
   i39 = i10 + i31 | 0;
   i40 = HEAP32[(HEAP32[i33 >> 2] | 0) + 6960 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i40 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i40 >> 2] | 0);
   i38 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 4, 16) | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i40 >> 2] | 0);
   HEAP32[i38 >> 2] = 0;
   i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 68, 16) | 0;
   HEAP16[i2 + 4 >> 1] = -1;
   HEAP16[i2 + 6 >> 1] = 0;
   i4 = i2 + 8 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 87404 + 8;
   i5 = i2 + 12 | 0;
   HEAP32[i5 >> 2] = 0;
   i6 = i2 + 16 | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 105808 + 8;
   HEAP32[i2 + 20 >> 2] = i34;
   HEAP32[i2 + 24 >> 2] = i38;
   HEAP32[i2 + 28 >> 2] = i22;
   HEAP32[i2 + 32 >> 2] = i21;
   HEAP32[i2 + 36 >> 2] = 0;
   HEAP32[i2 + 40 >> 2] = i24;
   HEAP32[i2 + 44 >> 2] = i23;
   HEAP32[i2 + 48 >> 2] = i20;
   HEAP32[i2 + 52 >> 2] = i25;
   HEAP32[i2 + 56 >> 2] = i18;
   HEAP32[i2 + 60 >> 2] = i19;
   HEAP32[i2 + 64 >> 2] = i39;
   i7 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 68, 16) | 0;
   HEAP16[i7 + 4 >> 1] = -1;
   HEAP16[i7 + 6 >> 1] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 >> 2] = gb + 87404 + 8;
   i42 = i7 + 12 | 0;
   HEAP32[i42 >> 2] = 0;
   i41 = i7 + 16 | 0;
   HEAP32[i41 >> 2] = 0;
   HEAP32[i7 >> 2] = gb + 105852 + 8;
   HEAP32[i7 + 20 >> 2] = i34;
   HEAP32[i7 + 24 >> 2] = i38;
   HEAP32[i7 + 28 >> 2] = i22;
   HEAP32[i7 + 32 >> 2] = i21;
   HEAP32[i7 + 36 >> 2] = 0;
   HEAP32[i7 + 40 >> 2] = i24;
   HEAP32[i7 + 44 >> 2] = i23;
   HEAP32[i7 + 48 >> 2] = i20;
   HEAP32[i7 + 52 >> 2] = i25;
   HEAP32[i7 + 56 >> 2] = i18;
   HEAP32[i7 + 60 >> 2] = i19;
   HEAP32[i7 + 64 >> 2] = i39;
   i8 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 48, 16) | 0;
   HEAP16[i8 + 4 >> 1] = -1;
   HEAP16[i8 + 6 >> 1] = 0;
   i9 = i8 + 8 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i8 >> 2] = gb + 87404 + 8;
   i10 = i8 + 12 | 0;
   HEAP32[i10 >> 2] = 0;
   i11 = i8 + 16 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i8 >> 2] = gb + 105896 + 8;
   HEAP32[i8 + 20 >> 2] = i34;
   HEAP32[i8 + 24 >> 2] = i38;
   HEAP32[i8 + 28 >> 2] = i39;
   HEAP32[i8 + 32 >> 2] = i20;
   HEAP32[i8 + 36 >> 2] = i25;
   HEAP32[i8 + 40 >> 2] = i18;
   HEAP32[i8 + 44 >> 2] = i19;
   i12 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 68, 16) | 0;
   HEAP16[i12 + 4 >> 1] = -1;
   HEAP16[i12 + 6 >> 1] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 >> 2] = gb + 87404 + 8;
   i13 = i12 + 12 | 0;
   HEAP32[i13 >> 2] = 0;
   i43 = i12 + 16 | 0;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i12 >> 2] = gb + 105940 + 8;
   HEAP32[i12 + 20 >> 2] = i34;
   HEAP32[i12 + 24 >> 2] = i38;
   HEAP32[i12 + 28 >> 2] = i22;
   HEAP32[i12 + 32 >> 2] = i21;
   HEAP32[i12 + 36 >> 2] = 0;
   HEAP32[i12 + 40 >> 2] = i24;
   HEAP32[i12 + 44 >> 2] = i23;
   HEAP32[i12 + 48 >> 2] = i20;
   HEAP32[i12 + 52 >> 2] = i25;
   HEAP32[i12 + 56 >> 2] = i18;
   HEAP32[i12 + 60 >> 2] = i19;
   HEAP32[i12 + 64 >> 2] = i39;
   i14 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i40, 68, 16) | 0;
   HEAP16[i14 + 4 >> 1] = -1;
   HEAP16[i14 + 6 >> 1] = 0;
   i15 = i14 + 8 | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i14 >> 2] = gb + 87404 + 8;
   i16 = i14 + 12 | 0;
   HEAP32[i16 >> 2] = 0;
   i17 = i14 + 16 | 0;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i14 >> 2] = gb + 105984 + 8;
   HEAP32[i14 + 20 >> 2] = i34;
   HEAP32[i14 + 24 >> 2] = i38;
   HEAP32[i14 + 28 >> 2] = i22;
   HEAP32[i14 + 32 >> 2] = i21;
   HEAP32[i14 + 36 >> 2] = 0;
   HEAP32[i14 + 40 >> 2] = i24;
   HEAP32[i14 + 44 >> 2] = i23;
   HEAP32[i14 + 48 >> 2] = i20;
   HEAP32[i14 + 52 >> 2] = i25;
   HEAP32[i14 + 56 >> 2] = i18;
   HEAP32[i14 + 60 >> 2] = i19;
   HEAP32[i14 + 64 >> 2] = i39;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i40 >> 2] | 0);
   HEAP32[i41 >> 2] = 1;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i43 >> 2] = 1;
   HEAP32[i13 >> 2] = i7;
   if (i7 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
    HEAP32[i12 + 8 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
   HEAP32[i11 >> 2] = 1;
   HEAP32[i10 >> 2] = i12;
   if (i12 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0);
    HEAP32[i9 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0);
   HEAP32[i17 >> 2] = 1;
   HEAP32[i16 >> 2] = i8;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
   HEAP32[i15 >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2];
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
   HEAP32[i6 >> 2] = 1;
   HEAP32[i5 >> 2] = i14;
   if (i14 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0);
    HEAP32[i4 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0);
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  }
  if (i3 >>> 0 >= i32 >>> 0) break; else i2 = i3;
 }
 STACKTOP = i35;
 return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i65, i66, i1, i67, i68, i62, i70, i51, i53, i45, i69) {
 i65 = i65 | 0;
 i66 = i66 | 0;
 i1 = i1 | 0;
 i67 = i67 | 0;
 i68 = i68 | 0;
 i62 = i62 | 0;
 i70 = i70 | 0;
 i51 = i51 | 0;
 i53 = i53 | 0;
 i45 = i45 | 0;
 i69 = i69 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f63 = f0, f64 = f0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i71 + 460 | 0;
 i42 = i71 + 448 | 0;
 i61 = i71 + 128 | 0;
 i60 = i71 + 272 | 0;
 i58 = i71 + 208 | 0;
 i59 = i71 + 144 | 0;
 i50 = i71 + 432 | 0;
 i52 = i71 + 416 | 0;
 i41 = i71 + 112 | 0;
 i40 = i71 + 408 | 0;
 i16 = i71 + 96 | 0;
 i17 = i71 + 396 | 0;
 i18 = i71 + 80 | 0;
 i54 = i71 + 64 | 0;
 i57 = i71 + 48 | 0;
 i55 = i71 + 384 | 0;
 i56 = i71 + 372 | 0;
 i39 = i71 + 32 | 0;
 i38 = i71 + 360 | 0;
 i46 = i71 + 16 | 0;
 i49 = i71;
 i48 = i71 + 348 | 0;
 i47 = i71 + 336 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f63 = Math_fround(HEAPF32[i65 + 16 >> 2]);
 f64 = Math_fround(HEAPF32[i66 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i65 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i66 + 32 >> 2]);
 f34 = Math_fround((f34 > f3 ? f3 : f34) * Math_fround(.100000001));
 f34 = Math_fround(f34 * f34);
 f3 = Math_fround(f63 + f64);
 i35 = i41 + 4 | 0;
 i36 = i41 + 8 | 0;
 i37 = i41 + 12 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 i1 = HEAP8[i45 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f32 = Math_fround(HEAPF32[i65 >> 2]);
  f5 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i65 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i66 >> 2]);
  f6 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f4 = Math_fround(f32 - f4);
  f6 = Math_fround(f5 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i66 + 8 >> 2]));
  i33 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f4 = i33 ? f4 : Math_fround(1.0);
  f6 = i33 ? f6 : Math_fround(0.0);
  f7 = i33 ? f7 : Math_fround(0.0);
  HEAPF32[i61 >> 2] = f4;
  HEAPF32[i61 + 4 >> 2] = f6;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i18 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  i33 = i61;
  f5 = Math_fround(3402823469999999843913219.0e14);
  i44 = 6;
 } else {
  i15 = i65 + 96 | 0;
  i14 = HEAP32[i66 + 200 >> 2] | 0;
  i2 = i1 & 255;
  i11 = 0;
  i13 = 0;
  while (1) {
   i29 = HEAPU8[i51 + i13 >> 0] | 0;
   HEAP32[i50 + (i13 << 2) >> 2] = i29;
   i1 = HEAPU8[i53 + i13 >> 0] | 0;
   HEAP32[i52 + (i13 << 2) >> 2] = i1;
   i29 = 1 - i29 | 0;
   f12 = Math_fround(HEAPF32[i15 + (i29 << 4) >> 2]);
   f31 = Math_fround(HEAPF32[i15 + (i29 << 4) + 4 >> 2]);
   f32 = Math_fround(HEAPF32[i15 + (i29 << 4) + 8 >> 2]);
   i29 = HEAP32[i15 + (i29 << 4) + 12 >> 2] | 0;
   i30 = HEAP32[i14 + (i1 * 12 | 0) >> 2] | 0;
   i33 = HEAP32[i14 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i1 = HEAP32[i14 + (i1 * 12 | 0) + 8 >> 2] | 0;
   f7 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f9 = Math_fround(f31 - (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f10 = Math_fround(f32 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i41 >> 2] = f7;
   HEAPF32[i35 >> 2] = f9;
   HEAPF32[i36 >> 2] = f10;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   HEAPF32[i58 + (i11 << 4) >> 2] = f12;
   HEAPF32[i58 + (i11 << 4) + 4 >> 2] = f31;
   HEAPF32[i58 + (i11 << 4) + 8 >> 2] = f32;
   HEAP32[i58 + (i11 << 4) + 12 >> 2] = i29;
   HEAP32[i59 + (i11 << 4) >> 2] = i30;
   HEAP32[i59 + (i11 << 4) + 4 >> 2] = i33;
   HEAP32[i59 + (i11 << 4) + 8 >> 2] = i1;
   HEAPF32[i59 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i11 + 1 | 0;
   i33 = i60 + (i11 << 4) | 0;
   HEAP32[i33 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   i13 = i13 + 1 | 0;
   if (i13 >>> 0 >= i2 >>> 0) break; else i11 = i1;
  }
  HEAP32[i40 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i16, i60, i58, i59, i50, i52, i41, i40);
  HEAP32[i61 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i61 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i43 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i42 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  if (f5 > f34) {
   i33 = i61;
   i44 = 6;
  }
 }
 do if ((i44 | 0) == 6) {
  i17 = i61 + 4 | 0;
  i19 = i61 + 8 | 0;
  i20 = i65 + 96 | 0;
  i21 = i65 + 100 | 0;
  i22 = i65 + 104 | 0;
  i23 = i65 + 112 | 0;
  i24 = i65 + 116 | 0;
  i25 = i65 + 120 | 0;
  i26 = i66 + 196 | 0;
  i27 = i66 + 200 | 0;
  i28 = i66 + 204 | 0;
  i29 = i65 + 48 | 0;
  i30 = i66 + 48 | 0;
  f31 = f8;
  f32 = f5;
  while (1) {
   HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f75 = Math_fround(-f4);
   f74 = Math_fround(-f6);
   f73 = Math_fround(-f7);
   i14 = HEAP32[i40 >> 2] | 0;
   f72 = Math_fround(HEAPF32[i20 >> 2]);
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   f8 = Math_fround(HEAPF32[i22 >> 2]);
   f76 = Math_fround(Math_fround(Math_fround(f72 * f75) + Math_fround(f5 * f74)) + Math_fround(f8 * f73));
   f9 = Math_fround(HEAPF32[i23 >> 2]);
   f10 = Math_fround(HEAPF32[i24 >> 2]);
   f12 = Math_fround(HEAPF32[i25 >> 2]);
   i15 = f76 > Math_fround(Math_fround(Math_fround(f9 * f75) + Math_fround(f10 * f74)) + Math_fround(f12 * f73));
   HEAP32[i50 + (i14 << 2) >> 2] = i15 & 1;
   f9 = i15 ? f72 : f9;
   f10 = i15 ? f5 : f10;
   f12 = i15 ? f8 : f12;
   HEAPF32[i58 + (i14 << 4) >> 2] = f9;
   HEAPF32[i58 + (i14 << 4) + 4 >> 2] = f10;
   HEAPF32[i58 + (i14 << 4) + 8 >> 2] = f12;
   HEAPF32[i58 + (i14 << 4) + 12 >> 2] = Math_fround(0.0);
   i15 = i59 + (i14 << 4) | 0;
   i16 = i52 + (i14 << 2) | 0;
   if (!(HEAP32[i26 >> 2] | 0)) {
    i1 = HEAP32[i27 >> 2] | 0;
    if ((HEAPU8[i28 >> 0] | 0) > 1) {
     f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f4);
     f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f6));
     f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f7));
     i2 = 1;
     i11 = 0;
     while (1) {
      i1 = HEAP32[i27 >> 2] | 0;
      f75 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
      f76 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
      f4 = Math_fround(HEAPF32[i61 >> 2]);
      f6 = Math_fround(HEAPF32[i17 >> 2]);
      f7 = Math_fround(HEAPF32[i19 >> 2]);
      f5 = Math_fround(Math_fround(Math_fround(f75 * f4) + Math_fround(f76 * f6)) + Math_fround(f5 * f7));
      i13 = f5 > f8;
      i11 = i13 ? i2 : i11;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i28 >> 0] | 0) >>> 0) f8 = i13 ? f5 : f8; else break;
     }
    } else i11 = 0;
   } else {
    i11 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i66, i61) | 0;
    f4 = Math_fround(HEAPF32[i61 >> 2]);
    f6 = Math_fround(HEAPF32[i17 >> 2]);
    i1 = HEAP32[i27 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i19 >> 2]);
   }
   HEAP32[i16 >> 2] = i11;
   i2 = HEAP32[i1 + (i11 * 12 | 0) >> 2] | 0;
   i16 = HEAP32[i1 + (i11 * 12 | 0) + 4 >> 2] | 0;
   i13 = HEAP32[i1 + (i11 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i15 >> 2] = i2;
   HEAP32[i59 + (i14 << 4) + 4 >> 2] = i16;
   HEAP32[i59 + (i14 << 4) + 8 >> 2] = i13;
   HEAPF32[i59 + (i14 << 4) + 12 >> 2] = Math_fround(0.0);
   f73 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f74 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f76 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i41 >> 2] = f73;
   HEAPF32[i35 >> 2] = f74;
   HEAPF32[i36 >> 2] = f76;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i40 >> 2] | 0;
   i11 = i60 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   f72 = Math_fround(HEAPF32[i29 >> 2]);
   f75 = Math_fround(HEAPF32[i30 >> 2]);
   f75 = f72 > f75 ? f72 : f75;
   f31 = f31 > f75 ? f31 : f75;
   f75 = Math_fround(f3 + f31);
   f76 = Math_fround(Math_fround(Math_fround(f4 * f73) + Math_fround(f6 * f74)) + Math_fround(f7 * f76));
   i11 = f76 > Math_fround(0.0) ? Math_fround(f76 * f76) > Math_fround(f32 * Math_fround(f75 * f75)) : 0;
   if (Math_fround(f32 * Math_fround(.00039999999)) >= Math_fround(f32 - f76) | i11) {
    f5 = f32;
    i44 = 13;
    break;
   }
   HEAP32[i40 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i39, i60, i58, i59, i50, i52, i41, i40);
   HEAP32[i33 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i17 >> 2]);
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   f5 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i43 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   i1 = f32 > f5;
   if (!(f5 > f34 & i1)) break; else f32 = f5;
  }
  if ((i44 | 0) == 13) {
   i2 = i13 + -1 | 0;
   if (i51 | 0) {
    HEAP8[i45 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
      HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i70 = 0;
    STACKTOP = i71;
    return i70 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f5)));
   f5 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f5);
   f8 = Math_fround(f6 * f5);
   f7 = Math_fround(f7 * f5);
   HEAPF32[i62 >> 2] = f9;
   HEAPF32[i62 + 4 >> 2] = f8;
   HEAPF32[i62 + 8 >> 2] = f7;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i54, i57, i13);
   f5 = Math_fround(HEAPF32[i54 >> 2]);
   f6 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i54 + 8 >> 2]);
   if (i69) {
    f75 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
    f72 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
    f76 = Math_fround(f75 + f72);
    f74 = Math_fround(f6 - Math_fround(f8 * f75));
    f73 = Math_fround(f4 - Math_fround(f7 * f75));
    HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f9 * f75));
    HEAPF32[i67 + 4 >> 2] = f74;
    HEAPF32[i67 + 8 >> 2] = f73;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    f73 = Math_fround(HEAPF32[i57 >> 2]);
    f74 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f74 = Math_fround(Math_fround(f8 * f72) + f74);
    f75 = Math_fround(Math_fround(f7 * f72) + Math_fround(HEAPF32[i57 + 8 >> 2]));
    HEAPF32[i68 >> 2] = Math_fround(Math_fround(f9 * f72) + f73);
    HEAPF32[i68 + 4 >> 2] = f74;
    HEAPF32[i68 + 8 >> 2] = f75;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(f10 - f76);
    i70 = i70 + 4 | 0;
    HEAP32[i70 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i70 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i70 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    i70 = 1;
    STACKTOP = i71;
    return i70 | 0;
   } else {
    f75 = Math_fround(f6 - Math_fround(f63 * f8));
    f74 = Math_fround(f4 - Math_fround(f63 * f7));
    HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f63 * f9));
    HEAPF32[i67 + 4 >> 2] = f75;
    HEAPF32[i67 + 8 >> 2] = f74;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    f74 = Math_fround(HEAPF32[i57 >> 2]);
    f75 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f75 = Math_fround(Math_fround(f64 * f8) + f75);
    f76 = Math_fround(Math_fround(f64 * f7) + Math_fround(HEAPF32[i57 + 8 >> 2]));
    HEAPF32[i68 >> 2] = Math_fround(Math_fround(f64 * f9) + f74);
    HEAPF32[i68 + 4 >> 2] = f75;
    HEAPF32[i68 + 8 >> 2] = f76;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(f10 - f3);
    i70 = i70 + 4 | 0;
    HEAP32[i70 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i70 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
    HEAP32[i70 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
    i70 = 1;
    STACKTOP = i71;
    return i70 | 0;
   }
  }
  if (i1) {
   if (!i51) i1 = 6; else break;
   STACKTOP = i71;
   return i1 | 0;
  };
  HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  i11 = HEAP32[i40 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i51 | 0) {
   HEAP8[i45 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
     HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f31);
  f12 = Math_fround(f12 * f12);
  HEAP32[i33 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i46, i49, i11);
  HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f32)));
  f9 = Math_fround(HEAPF32[i61 >> 2]);
  f10 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i46 >> 2]);
  f6 = Math_fround(HEAPF32[i46 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i46 + 8 >> 2]);
  if (i69) {
   f76 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
   f73 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
   f3 = Math_fround(f76 + f73);
   f75 = Math_fround(f6 - Math_fround(f10 * f76));
   f74 = Math_fround(f4 - Math_fround(f7 * f76));
   HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f9 * f76));
   HEAPF32[i67 + 4 >> 2] = f75;
   HEAPF32[i67 + 8 >> 2] = f74;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   f74 = Math_fround(HEAPF32[i49 >> 2]);
   f75 = Math_fround(HEAPF32[i49 + 4 >> 2]);
   f75 = Math_fround(Math_fround(f10 * f73) + f75);
   f76 = Math_fround(Math_fround(f7 * f73) + Math_fround(HEAPF32[i49 + 8 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(f9 * f73) + f74);
   HEAPF32[i68 + 4 >> 2] = f75;
   HEAPF32[i68 + 8 >> 2] = f76;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   i69 = i70 + 4 | 0;
   HEAP32[i69 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  } else {
   f75 = Math_fround(f6 - Math_fround(f63 * f10));
   f74 = Math_fround(f4 - Math_fround(f63 * f7));
   HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f63 * f9));
   HEAPF32[i67 + 4 >> 2] = f75;
   HEAPF32[i67 + 8 >> 2] = f74;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   f74 = Math_fround(HEAPF32[i49 >> 2]);
   f75 = Math_fround(HEAPF32[i49 + 4 >> 2]);
   f75 = Math_fround(Math_fround(f64 * f10) + f75);
   f76 = Math_fround(Math_fround(f64 * f7) + Math_fround(HEAPF32[i49 + 8 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(f64 * f9) + f74);
   HEAPF32[i68 + 4 >> 2] = f75;
   HEAPF32[i68 + 8 >> 2] = f76;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   i69 = i70 + 4 | 0;
   HEAP32[i69 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  }
  HEAPF32[i70 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i62 >> 2] = f9;
  HEAPF32[i62 + 4 >> 2] = f10;
  HEAPF32[i62 + 8 >> 2] = f7;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  i70 = f12 >= f32 ? 1 : 3;
  STACKTOP = i71;
  return i70 | 0;
 } while (0);
 i2 = HEAP32[i40 >> 2] | 0;
 HEAP8[i45 >> 0] = i2;
 if (!i2) {
  i70 = 6;
  STACKTOP = i71;
  return i70 | 0;
 } else i1 = 0;
 do {
  HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
  HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i71;
 return i1 | 0;
}

function __ZN18LoadSceneOperation7PerformEv(i28) {
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i38 + 8 | 0;
 i27 = i38;
 i25 = i38 + 132 | 0;
 i31 = i38 + 112 | 0;
 i32 = i38 + 92 | 0;
 i33 = i38 + 80 | 0;
 i34 = i38 + 60 | 0;
 i35 = i38 + 40 | 0;
 i36 = i38 + 20 | 0;
 i37 = __Z20GetPersistentManagerv() | 0;
 i30 = gb + 63416 | 0;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i23 = i27;
 HEAP32[i23 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i23 + 4 >> 2] = i29;
 HEAP32[i32 >> 2] = 0;
 i23 = i32 + 12 | 0;
 HEAP32[i23 >> 2] = 0;
 i29 = i32 + 16 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i32 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i4 = i26;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i24 = i30;
 HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i24 + 4 >> 2] = i3;
 i24 = i28 + 160 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i4 = HEAP8[i3 + 44 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 if (i2) i1 = HEAP32[i3 + 48 >> 2] | 0; else i1 = i4 & 255;
 do if (i1 | 0) {
  i1 = i3 + 44 | 0;
  if (i2) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i3 + 48 >> 2] | 0;
  } else {
   i2 = i1;
   i1 = i4 & 255;
  };
  HEAP32[i26 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i2, i1);
  i4 = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i37, i26, 1, 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
  HEAP32[i27 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i1 = 0; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i1, i27);
    i2 = HEAP32[i26 >> 2] | 0;
    i22 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  if (!i1) {
   i1 = __ZN17PersistentManager18ReadObjectThreadedEi(i37, i4) | 0;
   if (!i1) break;
  }
  if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31112 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31112 + 28 >> 2] | 0) >>> 0)) {
   i5 = HEAP32[i1 + 44 >> 2] | 0;
   HEAP32[i23 >> 2] = i5;
   i2 = HEAP32[i29 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i29 >> 2] = i5;
    i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i5 << 2, 4, i30, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i32 >> 2] = i4;
    break;
   } else {
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i30, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i4 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i23 >> 2] << 2 | 0) | 0;
    HEAP32[i29 >> 2] = i5;
    HEAP32[i32 >> 2] = i4;
    break;
   } else i4 = HEAP32[i32 >> 2] | 0; while (0);
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   if (i5 | 0) {
    i2 = 0;
    do {
     HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i5 | 0));
   }
   __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE(__Z21GetAssetBundleManagerv() | 0, 0, i1 + 52 | 0, 0, i32);
  }
 } while (0);
 i2 = __Z20GetPersistentManagerv() | 0;
 i17 = i28 + 164 | 0;
 i16 = i17 + 11 | 0;
 i1 = HEAP8[i16 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i28 + 168 >> 2] | 0;
 } else {
  i3 = i17;
  i1 = i1 & 255;
 };
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i3, i1);
 __ZN17PersistentManager27GetLoadErrorMessageFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i33, i2, i26);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 i22 = HEAP8[i33 + 11 >> 0] | 0;
 i1 = i22 << 24 >> 24 < 0;
 if ((i1 ? HEAP32[i33 + 4 >> 2] | 0 : i22 & 255) | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i1 ? HEAP32[i33 >> 2] | 0 : i33, 0, gb + 461006 | 0, 110, 1, 0, 0, 0);
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i15 = i27;
 HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i15 + 4 >> 2] = i19;
 HEAP32[i34 >> 2] = 0;
 i15 = i34 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i19 = i34 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i34 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i18 = i26;
 i21 = HEAP32[i18 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 i22 = gb + 64016 | 0;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i18 = i27;
 HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 HEAP32[i35 >> 2] = 0;
 i18 = i35 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i21 = i35 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i13 = i26;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i22;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 i1 = HEAP8[i16 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i28 + 168 >> 2] | 0;
 } else {
  i2 = i17;
  i1 = i1 & 255;
 };
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 4 >> 2] = 0;
 HEAP32[i36 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i36, i2, i1);
 __ZN17PersistentManager4LockEv(__Z20GetPersistentManagerv() | 0);
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i27;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i25 >> 2] = 0;
 i10 = i25 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i25 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i13 = i26;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i14;
 i9 = gb + 64016 | 0;
 i14 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i27;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 i13 = i31 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i31 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i9 = i26;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 __ZN17PersistentManager29GetAllFileIDsAndTypesFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EERS9_IPKN5Unity4TypeELj4EE(__Z20GetPersistentManagerv() | 0, i36, i25, i31);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i1 << 3, 8, i20, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i20, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i15 >> 2] << 3 | 0) | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i34 >> 2] = i9;
  break;
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i21 >> 2] = i1;
   HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i35 >> 2] = i9;
  }
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (i1 | 0) {
  i9 = 0;
  do {
   i8 = (HEAP32[i25 >> 2] | 0) + (i9 << 3) | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i31 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   if (!i2) i6 = 61; else {
    i2 = HEAP32[i2 + 24 >> 2] | 0;
    if ((i2 - (HEAP32[gb + 28760 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28760 + 28 >> 2] | 0) >>> 0) if ((i2 - (HEAP32[gb + 30792 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30792 + 28 >> 2] | 0) >>> 0) i6 = 61; else if ((i2 - (HEAP32[gb + 31832 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31832 + 28 >> 2] | 0) >>> 0) i6 = 61; else if ((i2 - (HEAP32[gb + 65780 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 65780 + 28 >> 2] | 0) >>> 0) i6 = 61; else if ((i2 - (HEAP32[gb + 26572 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 26572 + 28 >> 2] | 0) >>> 0) i6 = 61; else if ((i2 - (HEAP32[gb + 30832 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30832 + 28 >> 2] | 0) >>> 0) i6 = 61; else {
     i2 = HEAP32[i15 >> 2] | 0;
     i3 = HEAP32[i18 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i21 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 >= i1 >>> 0) break;
      if ((i5 | 0) > -1) {
       HEAP32[i21 >> 2] = i1;
       HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
       HEAP32[i21 >> 2] = i1;
       HEAP32[i35 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i18 >> 2] = i4;
     HEAP32[(HEAP32[i35 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     i6 = 61;
    }
   }
   if ((i6 | 0) == 61) {
    i6 = 0;
    i2 = HEAP32[i15 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i19 >> 2] = i1;
      HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i1 << 3, 8, i20, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i20, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i15 >> 2] << 3 | 0) | 0;
      HEAP32[i19 >> 2] = i1;
      HEAP32[i34 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i3;
    i1 = (HEAP32[i34 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < i1 >>> 0);
 }
 __ZN17PersistentManager6UnlockEv(__Z20GetPersistentManagerv() | 0);
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i14);
  HEAP32[i31 >> 2] = 0;
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i12);
  HEAP32[i25 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
 i12 = (HEAP32[i23 >> 2] | 0) + (HEAP32[i15 >> 2] | 0) | 0;
 i10 = i28 + 60 | 0;
 HEAP32[i25 >> 2] = i10;
 HEAPF32[i25 + 4 >> 2] = Math_fround(.899999976);
 HEAPF32[i25 + 8 >> 2] = Math_fround(i12 >>> 0);
 HEAPF32[i25 + 12 >> 2] = Math_fround(0.0);
 i12 = gb + 63416 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i27;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 HEAP32[i25 + 16 >> 2] = 0;
 i2 = i25 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 i11 = i25 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i25 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i3 = i26;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i28 + 84 | 0;
 i14 = i25 + 16 | 0;
 i3 = i13;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i5 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 3, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i14 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i5;
 i9 = HEAP32[i14 >> 2] | 0;
 HEAP32[i9 + (i4 << 3) >> 2] = fb + 2755;
 HEAP32[i9 + (i4 << 3) + 4 >> 2] = i3;
 i9 = __Z20GetPersistentManagerv() | 0;
 __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress(i9, HEAP32[i32 >> 2] | 0, HEAP32[i23 >> 2] | 0, i25);
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i30);
  HEAP32[i32 >> 2] = 0;
 }
 HEAP32[i32 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i29 >> 2] = 0;
 i2 = HEAP32[i24 >> 2] | 0;
 i1 = i2 + 44 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i4, i1);
 __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress(i37, i26, 0, 0, -1, 0, i25) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue(i37, i13);
 i23 = gb + 64016 | 0;
 i9 = HEAP32[i23 + 4 >> 2] | 0;
 i8 = i27;
 HEAP32[i8 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i31 >> 2] = 0;
 i8 = i31 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i31 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i23 = i26;
 i24 = HEAP32[i23 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i1 + 4 >> 2] = i24;
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i31 + 12 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
 }
 __ZN17PersistentManager4LockEv(i37);
 i3 = i37 + 115 | 0;
 HEAP8[i3 >> 0] = 0;
 i1 = HEAP8[i16 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i28 + 168 >> 2] | 0;
 } else {
  i2 = i17;
  i1 = i1 & 255;
 };
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i2, i1);
 __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress(i37, i26, HEAP32[i34 >> 2] | 0, HEAP32[i31 >> 2] | 0, HEAP32[i15 >> 2] | 0, 1, i25) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 HEAP8[i3 >> 0] = 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i27;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i36 >> 2] = 0;
 i5 = i36 + 12 | 0;
 i6 = i36 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i36 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i27);
 i27 = HEAP32[i26 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i1 + 4 >> 2] = i27;
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i36 >> 2] = i1;
  if (HEAP32[i18 >> 2] | 0) {
   i3 = HEAP32[i35 >> 2] | 0;
   i4 = HEAP32[i31 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 + (i2 << 2) >> 2] << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
  }
 }
 __ZN17PersistentManager25ExtractAwakeFromLoadQueueEPKijR18AwakeFromLoadQueue(i37, i1, HEAP32[i5 >> 2] | 0, i28 + 180 | 0);
 __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue(i37, i13);
 __ZN18LoadSceneOperation13UnloadStreamsEb(i28, 0);
 __ZN17PersistentManager6UnlockEv(i37);
 HEAPF32[i10 >> 2] = Math_fround(.899999976);
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i7);
  HEAP32[i36 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i9);
  HEAP32[i31 >> 2] = 0;
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i12);
  HEAP32[i14 >> 2] = 0;
 }
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i22);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, i20);
  HEAP32[i34 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
 if ((HEAP32[i29 >> 2] | 0) <= -1) {
  STACKTOP = i38;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i30);
 HEAP32[i32 >> 2] = 0;
 STACKTOP = i38;
 return;
}

function __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i93, i3, i1, i82, i81, i95, i96, i94, f2) {
 i93 = i93 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i82 = i82 | 0;
 i81 = i81 | 0;
 i95 = i95 | 0;
 i96 = i96 | 0;
 i94 = i94 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, f83 = f0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i97 = 0, f98 = f0, i99 = 0, i100 = 0;
 i97 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i92 = i97 + 192 | 0;
 i87 = i97 + 288 | 0;
 i91 = i97 + 284 | 0;
 i86 = i97 + 208 | 0;
 i84 = i97 + 128 | 0;
 i85 = i97 + 64 | 0;
 i58 = i97 + 272 | 0;
 i59 = i97 + 48 | 0;
 i90 = i97 + 32 | 0;
 i88 = i97 + 16 | 0;
 i89 = i97;
 HEAP32[i92 >> 2] = 0;
 HEAP32[i92 + 4 >> 2] = 0;
 HEAP32[i92 + 8 >> 2] = 0;
 HEAP32[i92 + 12 >> 2] = 0;
 f8 = Math_fround(HEAPF32[i81 >> 2]);
 i63 = i81 + 4 | 0;
 f13 = Math_fround(HEAPF32[i63 >> 2]);
 i64 = i81 + 8 | 0;
 f16 = Math_fround(HEAPF32[i64 >> 2]);
 f9 = Math_fround(HEAPF32[i82 >> 2]);
 i71 = i82 + 4 | 0;
 f14 = Math_fround(HEAPF32[i71 >> 2]);
 i75 = i82 + 8 | 0;
 f15 = Math_fround(HEAPF32[i75 >> 2]);
 HEAP32[i91 >> 2] = 1;
 f18 = Math_fround(HEAPF32[i93 >> 2]);
 f19 = Math_fround(HEAPF32[i93 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i93 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f18 - f7);
 f5 = Math_fround(f19 - f5);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 i65 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5)) + Math_fround(f4 * f4)) > Math_fround(1.1920929e-07);
 f7 = i65 ? f7 : Math_fround(1.0);
 f5 = i65 ? f5 : Math_fround(0.0);
 f4 = i65 ? f4 : Math_fround(0.0);
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5))))));
 f7 = Math_fround(f19 * f7);
 f5 = Math_fround(f19 * f5);
 f4 = Math_fround(f19 * f4);
 f19 = Math_fround(-f7);
 f18 = Math_fround(-f5);
 f17 = Math_fround(-f4);
 i65 = i93 + 96 | 0;
 f83 = Math_fround(HEAPF32[i65 >> 2]);
 i66 = i93 + 100 | 0;
 f32 = Math_fround(HEAPF32[i66 >> 2]);
 i67 = i93 + 104 | 0;
 f33 = Math_fround(HEAPF32[i67 >> 2]);
 f29 = Math_fround(Math_fround(f33 * f17) + Math_fround(Math_fround(f83 * f19) + Math_fround(f32 * f18)));
 i68 = i93 + 112 | 0;
 f30 = Math_fround(HEAPF32[i68 >> 2]);
 i69 = i93 + 116 | 0;
 f31 = Math_fround(HEAPF32[i69 >> 2]);
 i70 = i93 + 120 | 0;
 f6 = Math_fround(HEAPF32[i70 >> 2]);
 i78 = f29 > Math_fround(Math_fround(Math_fround(f30 * f19) + Math_fround(f31 * f18)) + Math_fround(f6 * f17));
 f30 = i78 ? f83 : f30;
 f31 = i78 ? f32 : f31;
 f6 = i78 ? f33 : f6;
 i78 = f7 > Math_fround(0.0);
 i77 = f5 > Math_fround(0.0);
 i76 = f4 > Math_fround(0.0);
 i72 = i3 + 144 | 0;
 f4 = Math_fround(HEAPF32[i72 >> 2]);
 i73 = i3 + 148 | 0;
 f5 = Math_fround(HEAPF32[i73 >> 2]);
 i74 = i3 + 152 | 0;
 f7 = Math_fround(HEAPF32[i74 >> 2]);
 f33 = Math_fround(-f4);
 f32 = Math_fround(-f5);
 f83 = Math_fround(-f7);
 f33 = i78 ? f4 : f33;
 f32 = i77 ? f5 : f32;
 f83 = i76 ? f7 : f83;
 f17 = Math_fround(f30 - f33);
 f18 = Math_fround(f31 - f32);
 f19 = Math_fround(f6 - f83);
 HEAPF32[i86 >> 2] = f17;
 i76 = i86 + 4 | 0;
 HEAPF32[i76 >> 2] = f18;
 i77 = i86 + 8 | 0;
 HEAPF32[i77 >> 2] = f19;
 i78 = i86 + 12 | 0;
 HEAPF32[i78 >> 2] = Math_fround(0.0);
 i79 = i86 + 16 | 0;
 HEAP32[i79 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i79 = i86 + 32 | 0;
 HEAP32[i79 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i79 = i86 + 48 | 0;
 HEAP32[i79 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i79 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i79 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i79 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 HEAPF32[i84 >> 2] = f30;
 i79 = i84 + 4 | 0;
 HEAPF32[i79 >> 2] = f31;
 i80 = i84 + 8 | 0;
 HEAPF32[i80 >> 2] = f6;
 HEAPF32[i84 + 12 >> 2] = Math_fround(0.0);
 i60 = i84 + 16 | 0;
 HEAP32[i60 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i60 = i84 + 32 | 0;
 HEAP32[i60 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i60 = i84 + 48 | 0;
 HEAP32[i60 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i60 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i60 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i60 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 HEAPF32[i85 >> 2] = f33;
 i60 = i85 + 4 | 0;
 HEAPF32[i60 >> 2] = f32;
 i61 = i85 + 8 | 0;
 HEAPF32[i61 >> 2] = f83;
 i62 = i85 + 12 | 0;
 HEAPF32[i62 >> 2] = Math_fround(0.0);
 i57 = i85 + 16 | 0;
 HEAP32[i57 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i57 = i85 + 32 | 0;
 HEAP32[i57 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 i57 = i85 + 48 | 0;
 HEAP32[i57 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 f83 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i57 = f83 < Math_fround(0.0);
 f83 = Math_fround(f83 * Math_fround(.100000001));
 f83 = i57 ? f83 : Math_fround(0.0);
 f32 = Math_fround(f83 + f2);
 f83 = Math_fround(f83 * f83);
 f33 = Math_fround(f32 * f32);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19));
 L1 : do if (f6 > f83) {
  i3 = i85 + 16 | 0;
  i34 = i85 + 20 | 0;
  i35 = i85 + 24 | 0;
  i36 = i85 + 28 | 0;
  i37 = i85 + 32 | 0;
  i38 = i85 + 36 | 0;
  i39 = i85 + 40 | 0;
  i40 = i85 + 44 | 0;
  i41 = i84 + 16 | 0;
  i42 = i84 + 20 | 0;
  i43 = i84 + 24 | 0;
  i44 = i86 + 16 | 0;
  i45 = i86 + 20 | 0;
  i46 = i86 + 24 | 0;
  i47 = i86 + 28 | 0;
  i48 = i84 + 32 | 0;
  i49 = i84 + 36 | 0;
  i50 = i84 + 40 | 0;
  i51 = i86 + 32 | 0;
  i52 = i86 + 36 | 0;
  i53 = i86 + 40 | 0;
  i54 = i86 + 44 | 0;
  i55 = i59 + 4 | 0;
  i56 = i59 + 8 | 0;
  i57 = i59 + 12 | 0;
  f10 = f17;
  f11 = f18;
  f12 = f19;
  f20 = f4;
  f21 = f5;
  f31 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f9);
  f30 = Math_fround(Math_fround(f13 * Math_fround(0.0)) + f14);
  f29 = Math_fround(Math_fround(f16 * Math_fround(0.0)) + f15);
  f28 = Math_fround(0.0);
  f2 = f17;
  f4 = f18;
  f5 = f19;
  while (1) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10))))));
   f17 = Math_fround(f10 * f15);
   f16 = Math_fround(f11 * f15);
   f15 = Math_fround(f12 * f15);
   f98 = Math_fround(-f17);
   f13 = Math_fround(-f16);
   f8 = Math_fround(-f15);
   f9 = Math_fround(HEAPF32[i65 >> 2]);
   f18 = Math_fround(HEAPF32[i66 >> 2]);
   f14 = Math_fround(HEAPF32[i67 >> 2]);
   f19 = Math_fround(Math_fround(Math_fround(f9 * f98) + Math_fround(f18 * f13)) + Math_fround(f14 * f8));
   f25 = Math_fround(HEAPF32[i68 >> 2]);
   f26 = Math_fround(HEAPF32[i69 >> 2]);
   f27 = Math_fround(HEAPF32[i70 >> 2]);
   i100 = f19 > Math_fround(Math_fround(Math_fround(f25 * f98) + Math_fround(f26 * f13)) + Math_fround(f27 * f8));
   f25 = i100 ? f9 : f25;
   f26 = i100 ? f18 : f26;
   f27 = i100 ? f14 : f27;
   i100 = f17 > Math_fround(0.0);
   i99 = f16 > Math_fround(0.0);
   i1 = f15 > Math_fround(0.0);
   f14 = Math_fround(-f20);
   f18 = Math_fround(-f21);
   f9 = Math_fround(-f7);
   f20 = i100 ? f20 : f14;
   f18 = i99 ? f21 : f18;
   f9 = i1 ? f7 : f9;
   f14 = Math_fround(f31 + f20);
   f19 = Math_fround(f30 + f18);
   f21 = Math_fround(f29 + f9);
   f22 = Math_fround(f25 - f14);
   f23 = Math_fround(f26 - f19);
   f24 = Math_fround(f27 - f21);
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f22) + Math_fround(f16 * f23)) + Math_fround(f15 * f24)) - f32);
   f15 = Math_fround(HEAPF32[i81 >> 2]);
   f16 = Math_fround(HEAPF32[i63 >> 2]);
   f17 = Math_fround(HEAPF32[i64 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f15 * f98) + Math_fround(f16 * f13)) + Math_fround(f17 * f8));
   if (f7 > Math_fround(0.0)) {
    if (f8 >= Math_fround(0.0)) {
     i1 = 0;
     i3 = 19;
     break;
    }
    f13 = Math_fround(f28 - Math_fround(f7 / f8));
    HEAP32[i87 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i87 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i87 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    if (f13 > f28) {
     if (f13 > Math_fround(1.0)) {
      i1 = 0;
      i3 = 19;
      break;
     }
     f5 = Math_fround(HEAPF32[i82 >> 2]);
     f22 = Math_fround(HEAPF32[i71 >> 2]);
     f5 = Math_fround(Math_fround(f13 * f15) + f5);
     f22 = Math_fround(Math_fround(f13 * f16) + f22);
     f23 = Math_fround(Math_fround(f13 * f17) + Math_fround(HEAPF32[i75 >> 2]));
     f28 = Math_fround(f5 - f31);
     f31 = Math_fround(f22 - f30);
     f17 = Math_fround(f23 - f29);
     f98 = Math_fround(HEAPF32[i85 >> 2]);
     f2 = Math_fround(HEAPF32[i60 >> 2]);
     f98 = Math_fround(f28 + f98);
     f2 = Math_fround(f31 + f2);
     f4 = Math_fround(f17 + Math_fround(HEAPF32[i61 >> 2]));
     f21 = Math_fround(HEAPF32[i3 >> 2]);
     f19 = Math_fround(HEAPF32[i34 >> 2]);
     f21 = Math_fround(f28 + f21);
     f19 = Math_fround(f31 + f19);
     f14 = Math_fround(f17 + Math_fround(HEAPF32[i35 >> 2]));
     f7 = Math_fround(HEAPF32[i37 >> 2]);
     f8 = Math_fround(HEAPF32[i38 >> 2]);
     f7 = Math_fround(f28 + f7);
     f8 = Math_fround(f31 + f8);
     f17 = Math_fround(f17 + Math_fround(HEAPF32[i39 >> 2]));
     HEAPF32[i85 >> 2] = f98;
     HEAPF32[i60 >> 2] = f2;
     HEAPF32[i61 >> 2] = f4;
     HEAPF32[i62 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = f21;
     HEAPF32[i34 >> 2] = f19;
     HEAPF32[i35 >> 2] = f14;
     HEAPF32[i36 >> 2] = Math_fround(0.0);
     HEAPF32[i37 >> 2] = f7;
     HEAPF32[i38 >> 2] = f8;
     HEAPF32[i39 >> 2] = f17;
     HEAPF32[i40 >> 2] = Math_fround(0.0);
     f31 = Math_fround(HEAPF32[i84 >> 2]);
     f30 = Math_fround(HEAPF32[i79 >> 2]);
     f2 = Math_fround(f30 - f2);
     f4 = Math_fround(Math_fround(HEAPF32[i80 >> 2]) - f4);
     HEAPF32[i86 >> 2] = Math_fround(f31 - f98);
     HEAPF32[i76 >> 2] = f2;
     HEAPF32[i77 >> 2] = f4;
     HEAPF32[i78 >> 2] = Math_fround(0.0);
     f4 = Math_fround(HEAPF32[i41 >> 2]);
     f2 = Math_fround(HEAPF32[i42 >> 2]);
     f19 = Math_fround(f2 - f19);
     f14 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) - f14);
     HEAPF32[i44 >> 2] = Math_fround(f4 - f21);
     HEAPF32[i45 >> 2] = f19;
     HEAPF32[i46 >> 2] = f14;
     HEAPF32[i47 >> 2] = Math_fround(0.0);
     f14 = Math_fround(HEAPF32[i48 >> 2]);
     f19 = Math_fround(HEAPF32[i49 >> 2]);
     f8 = Math_fround(f19 - f8);
     f17 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) - f17);
     HEAPF32[i51 >> 2] = Math_fround(f14 - f7);
     HEAPF32[i52 >> 2] = f8;
     HEAPF32[i53 >> 2] = f17;
     HEAPF32[i54 >> 2] = Math_fround(0.0);
     f17 = Math_fround(f5 + f20);
     f8 = Math_fround(f22 + f18);
     f7 = Math_fround(f23 + f9);
     f14 = f17;
     f19 = f8;
     f21 = f7;
     f9 = Math_fround(f25 - f17);
     f8 = Math_fround(f26 - f8);
     f7 = Math_fround(f27 - f7);
     f18 = Math_fround(3402823469999999843913219.0e14);
     f17 = f5;
     f5 = f12;
     f4 = f11;
     f2 = f10;
    } else {
     f9 = f22;
     f8 = f23;
     f7 = f24;
     f18 = f6;
     f23 = f29;
     f22 = f30;
     f17 = f31;
    }
   } else {
    f9 = f22;
    f8 = f23;
    f7 = f24;
    f18 = f6;
    f13 = f28;
    f23 = f29;
    f22 = f30;
    f17 = f31;
   }
   i100 = HEAP32[i91 >> 2] | 0;
   HEAPF32[i84 + (i100 << 4) >> 2] = f25;
   HEAPF32[i84 + (i100 << 4) + 4 >> 2] = f26;
   HEAPF32[i84 + (i100 << 4) + 8 >> 2] = f27;
   HEAPF32[i84 + (i100 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i85 + (i100 << 4) >> 2] = f14;
   HEAPF32[i85 + (i100 << 4) + 4 >> 2] = f19;
   HEAPF32[i85 + (i100 << 4) + 8 >> 2] = f21;
   HEAPF32[i85 + (i100 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i91 >> 2] = i100 + 1;
   HEAPF32[i86 + (i100 << 4) >> 2] = f9;
   HEAPF32[i86 + (i100 << 4) + 4 >> 2] = f8;
   HEAPF32[i86 + (i100 << 4) + 8 >> 2] = f7;
   HEAPF32[i86 + (i100 << 4) + 12 >> 2] = Math_fround(0.0);
   L11 : do switch (i100 | 0) {
   case 0:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
     break;
    }
   case 1:
    {
     f6 = Math_fround(HEAPF32[i86 >> 2]);
     f7 = Math_fround(HEAPF32[i76 >> 2]);
     f8 = Math_fround(HEAPF32[i77 >> 2]);
     f9 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f6);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f7);
     f15 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f8);
     f16 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
     if (!(f16 <= Math_fround(1.1920929e-07))) {
      f30 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f14)) - Math_fround(f6 * f9)) - Math_fround(f8 * f15)) / f16);
      i100 = f30 > Math_fround(1.0);
      f30 = i100 ? Math_fround(1.0) : f30;
      i100 = f30 > Math_fround(0.0);
      f30 = i100 ? f30 : Math_fround(0.0);
      f31 = Math_fround(f7 + Math_fround(f14 * f30));
      f98 = Math_fround(f8 + Math_fround(f15 * f30));
      HEAPF32[i59 >> 2] = Math_fround(f6 + Math_fround(f9 * f30));
      HEAPF32[i55 >> 2] = f31;
      HEAPF32[i56 >> 2] = f98;
      HEAPF32[i57 >> 2] = Math_fround(0.0);
      break L11;
     } else {
      HEAP32[i91 >> 2] = 1;
      HEAP32[i59 >> 2] = HEAP32[i86 >> 2];
      HEAP32[i59 + 4 >> 2] = HEAP32[i86 + 4 >> 2];
      HEAP32[i59 + 8 >> 2] = HEAP32[i86 + 8 >> 2];
      HEAP32[i59 + 12 >> 2] = HEAP32[i86 + 12 >> 2];
      break L11;
     }
    }
   case 2:
    {
     __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i86, i84, i85, i91);
     break;
    }
   case 3:
    {
     __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i59, i86, i84, i85, i91);
     break;
    }
   default:
    {
     HEAPF32[i59 >> 2] = f9;
     HEAPF32[i55 >> 2] = f8;
     HEAPF32[i56 >> 2] = f7;
     HEAPF32[i57 >> 2] = Math_fround(0.0);
    }
   } while (0);
   f7 = Math_fround(HEAPF32[i59 >> 2]);
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i56 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   i1 = f18 > f6;
   if (!(f6 > f33 & i1)) break L1;
   f20 = Math_fround(HEAPF32[i72 >> 2]);
   f21 = Math_fround(HEAPF32[i73 >> 2]);
   f10 = f7;
   f11 = f8;
   f12 = f9;
   f7 = Math_fround(HEAPF32[i74 >> 2]);
   f31 = f17;
   f30 = f22;
   f29 = f23;
   f28 = f13;
  }
  if ((i3 | 0) == 19) {
   STACKTOP = i97;
   return i1 | 0;
  }
 } else {
  f13 = Math_fround(0.0);
  f12 = f19;
  f11 = f18;
  f10 = f17;
  f9 = f19;
  f8 = f18;
  f7 = f17;
  i1 = 1;
  f5 = f19;
  f4 = f18;
  f2 = f17;
 } while (0);
 i82 = HEAP32[i93 + 64 >> 2] | 0;
 i99 = HEAP32[i93 + 68 >> 2] | 0;
 i100 = HEAP32[i93 + 72 >> 2] | 0;
 i81 = f6 > f83 & i1;
 f30 = i81 ? f7 : f2;
 f32 = i81 ? f8 : f4;
 f83 = i81 ? f9 : f5;
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f83 * f83) + Math_fround(Math_fround(f32 * f32) + Math_fround(f30 * f30))))));
 f30 = Math_fround(f30 * f29);
 f32 = Math_fround(f32 * f29);
 f29 = Math_fround(f83 * f29);
 HEAPF32[i96 >> 2] = f30;
 HEAPF32[i96 + 4 >> 2] = f32;
 HEAPF32[i96 + 8 >> 2] = f29;
 HEAPF32[i96 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i95 >> 2] = f13;
 i96 = i95 + 4 | 0;
 HEAP32[i96 >> 2] = HEAP32[i87 >> 2];
 HEAP32[i96 + 4 >> 2] = HEAP32[i87 + 4 >> 2];
 HEAP32[i96 + 8 >> 2] = HEAP32[i87 + 8 >> 2];
 HEAPF32[i90 >> 2] = i1 ? f7 : f10;
 HEAPF32[i90 + 4 >> 2] = i1 ? f8 : f11;
 HEAPF32[i90 + 8 >> 2] = i1 ? f9 : f12;
 HEAPF32[i90 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i88 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i88 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i88 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i88 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 HEAP32[i89 >> 2] = HEAP32[i92 >> 2];
 HEAP32[i89 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
 HEAP32[i89 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
 HEAP32[i89 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
 __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i86, i84, i85, i90, i88, i89, HEAP32[i91 >> 2] | 0);
 f83 = Math_fround(HEAPF32[i93 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i88 >> 2]);
 f33 = Math_fround(HEAPF32[i88 + 4 >> 2]);
 f98 = Math_fround(HEAPF32[i88 + 8 >> 2]);
 f30 = Math_fround(f31 - Math_fround(f30 * f83));
 f32 = Math_fround(f33 - Math_fround(f32 * f83));
 f83 = Math_fround(f98 - Math_fround(f29 * f83));
 HEAPF32[i94 >> 2] = i82 | 0 ? f30 : f31;
 HEAPF32[i94 + 4 >> 2] = i99 | 0 ? f32 : f33;
 HEAPF32[i94 + 8 >> 2] = i100 | 0 ? f83 : f98;
 HEAPF32[i94 + 12 >> 2] = Math_fround(0.0);
 i100 = 1;
 STACKTOP = i97;
 return i100 | 0;
}

function __ZN23ParticleSystemParticles12array_resizeEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = i7 + 12 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) {
  STACKTOP = i11;
  return;
 }
 i10 = i8 << 2;
 HEAP32[i1 >> 2] = i8;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i10, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i7 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 20 | 0;
 i2 = i7 + 32 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 40 | 0;
 i2 = i7 + 52 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i3 = i7 + 60 | 0;
 i4 = i7 + 72 | 0;
 HEAP32[i4 >> 2] = i8;
 i2 = i7 + 76 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i7 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 80 | 0;
 i2 = i7 + 92 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 96 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 100 | 0;
 i2 = i7 + 112 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 116 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i3 = i7 + 120 | 0;
 i4 = i7 + 132 | 0;
 HEAP32[i4 >> 2] = i8;
 i2 = i7 + 136 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i7 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 140 | 0;
 i2 = i7 + 152 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 156 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 144 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 144 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 160 | 0;
 i2 = i7 + 172 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 176 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 164 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 164 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = HEAP8[i7 + 870 >> 0] | 0 ? 0 : 2;
 i2 = i1;
 do {
  i3 = i7 + 300 + (i2 * 20 | 0) | 0;
  i4 = i7 + 300 + (i2 * 20 | 0) + 12 | 0;
  HEAP32[i4 >> 2] = i8;
  i5 = i7 + 300 + (i2 * 20 | 0) + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i8 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i8;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i7 + 300 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 300 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i3 >> 2] = i6;
   break;
  } while (0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 3);
 if (HEAP8[i7 + 869 >> 0] | 0) do {
  i2 = i7 + 360 + (i1 * 20 | 0) | 0;
  i3 = i7 + 360 + (i1 * 20 | 0) + 12 | 0;
  HEAP32[i3 >> 2] = i8;
  i4 = i7 + 360 + (i1 * 20 | 0) + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i8;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i10, 4, i7 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i2 >> 2] = i6;
   break;
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 do if (HEAP8[i7 + 872 >> 0] | 0) {
  i1 = i7 + 180 | 0;
  i2 = i7 + 192 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 196 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 184 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 184 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  } while (0);
  i1 = i7 + 200 | 0;
  i2 = i7 + 212 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 216 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 204 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 204 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  } while (0);
  i1 = i7 + 220 | 0;
  i2 = i7 + 232 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 236 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 224 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 224 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  }
 } while (0);
 i1 = i7 + 420 | 0;
 i2 = i7 + 432 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 436 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 424 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 424 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 do if (HEAP8[i7 + 871 >> 0] | 0) {
  i1 = i7 + 440 | 0;
  i2 = i7 + 452 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 456 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 444 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 444 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  } while (0);
  i1 = i7 + 460 | 0;
  i2 = i7 + 472 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 476 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 464 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 464 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  }
 } while (0);
 i1 = i7 + 480 | 0;
 i2 = i7 + 492 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 496 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 484 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 484 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 500 | 0;
 i2 = i7 + 512 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 516 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 504 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 504 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 520 | 0;
 i2 = i7 + 532 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 536 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 524 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 524 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 540 | 0;
 i2 = i7 + 552 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 556 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 544 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 544 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 do if (HEAP8[i7 + 868 >> 0] | 0) {
  i1 = i7 + 240 | 0;
  i2 = i7 + 252 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 256 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 244 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 244 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  } while (0);
  i1 = i7 + 260 | 0;
  i2 = i7 + 272 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 276 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 264 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 264 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  } while (0);
  i1 = i7 + 280 | 0;
  i2 = i7 + 292 | 0;
  HEAP32[i2 >> 2] = i8;
  i3 = i7 + 296 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 >= i8 >>> 0) break;
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i7 + 284 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 284 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i6;
   break;
  }
 } while (0);
 i2 = i7 + 880 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i3 = i7 + 560 + (i1 * 20 | 0) | 0;
   i4 = i7 + 560 + (i1 * 20 | 0) + 12 | 0;
   HEAP32[i4 >> 2] = i8;
   i5 = i7 + 560 + (i1 * 20 | 0) + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   do if ((i6 & 2147483647) >>> 0 < i8 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i8;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i7 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i7 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i8;
    HEAP32[i3 >> 2] = i6;
    break;
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 do if (HEAP8[i7 + 873 >> 0] | 0) {
  if ((HEAP32[i7 + 612 >> 2] | 0) >>> 0 >= i8 >>> 0) break;
  __ZN14dynamic_bitset6resizeEjb(i7 + 600 | 0, i8, 0);
 } while (0);
 do if (HEAP8[i7 + 876 >> 0] | 0) {
  if ((HEAP32[i7 + 732 >> 2] | 0) >>> 0 >= i8 >>> 0) break;
  __ZN14dynamic_bitset6resizeEjb(i7 + 720 | 0, i8, 0);
 } while (0);
 if (HEAP32[i7 + 844 >> 2] & 2147483647 | 0) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy(i7 + 828 | 0, i8, i9, 1);
 }
 if (!(HEAP32[i7 + 864 >> 2] & 2147483647)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy(i7 + 848 | 0, i8, i9, 1);
 STACKTOP = i11;
 return;
}

function __ZN5physx11HullLibrary10expandhullEPNS_6float3EiRS2_Rif(i55, i26, i27, i54, i53, f32) {
 i55 = i55 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i54 = i54 | 0;
 i53 = i53 | 0;
 f32 = Math_fround(f32);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i58 + 5 | 0;
 i52 = i58 + 4 | 0;
 i57 = i58;
 i1 = HEAP32[i55 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i6 = 0;
  i24 = 0;
  i25 = 0;
  while (1) {
   i23 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i23 + (i25 << 2) >> 2] | 0;
   if (!i1) {
    f12 = Math_fround(0.0);
    i17 = -1;
    f11 = Math_fround(0.0);
    f10 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    i16 = -1;
    i9 = -1;
    i8 = -1;
   } else {
    i21 = HEAP32[i1 >> 2] | 0;
    i22 = HEAP32[i1 + 4 >> 2] | 0;
    i20 = HEAP32[i1 + 8 >> 2] | 0;
    f13 = Math_fround(HEAPF32[i26 + (i21 * 12 | 0) >> 2]);
    f14 = Math_fround(HEAPF32[i26 + (i21 * 12 | 0) + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i26 + (i21 * 12 | 0) + 8 >> 2]);
    f5 = Math_fround(HEAPF32[i26 + (i22 * 12 | 0) >> 2]);
    f41 = Math_fround(HEAPF32[i26 + (i22 * 12 | 0) + 4 >> 2]);
    f11 = Math_fround(HEAPF32[i26 + (i22 * 12 | 0) + 8 >> 2]);
    f38 = Math_fround(HEAPF32[i26 + (i20 * 12 | 0) >> 2]);
    f12 = Math_fround(HEAPF32[i26 + (i20 * 12 | 0) + 4 >> 2]);
    f40 = Math_fround(f5 - f13);
    f10 = Math_fround(f41 - f14);
    f39 = Math_fround(f11 - f15);
    f5 = Math_fround(f38 - f5);
    f41 = Math_fround(f12 - f41);
    f11 = Math_fround(Math_fround(HEAPF32[i26 + (i20 * 12 | 0) + 8 >> 2]) - f11);
    f12 = Math_fround(Math_fround(f10 * f11) - Math_fround(f39 * f41));
    f11 = Math_fround(Math_fround(f39 * f5) - Math_fround(f40 * f11));
    f5 = Math_fround(Math_fround(f40 * f41) - Math_fround(f10 * f5));
    f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)))));
    if (f10 == Math_fround(0.0)) {
     f10 = Math_fround(0.0);
     f11 = Math_fround(0.0);
     f12 = Math_fround(1.0);
    } else {
     f41 = Math_fround(Math_fround(1.0) / f10);
     f10 = Math_fround(f5 * f41);
     f11 = Math_fround(f11 * f41);
     f12 = Math_fround(f12 * f41);
    }
    f5 = Math_fround(-Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f11 * f14)) + Math_fround(f10 * f15)));
    if ((i2 | 0) > 0) {
     i18 = -1;
     i9 = -1;
     i8 = -1;
     i19 = 0;
     while (1) {
      i17 = HEAP32[i23 + (i19 << 2) >> 2] | 0;
      if ((i25 | 0) == (i19 | 0) | (i17 | 0) == 0) i1 = i18; else {
       i4 = HEAP32[i17 >> 2] | 0;
       if ((i4 | 0) == (i21 | 0)) {
        i1 = 1;
        i51 = 12;
       } else {
        i1 = (i4 | 0) == (i22 | 0) & 1;
        if ((i4 | 0) == (i20 | 0)) i51 = 12; else i3 = 0;
       }
       if ((i51 | 0) == 12) {
        i51 = 0;
        i3 = 1;
       }
       i16 = (i4 | 0) == (i20 | 0) | (i4 | 0) == (i22 | 0);
       i7 = i16 & 1;
       i4 = HEAP32[i17 + 4 >> 2] | 0;
       if ((i4 | 0) == (i21 | 0)) {
        i1 = i1 + 1 | 0;
        i51 = 95;
       } else {
        i1 = i1 + ((i4 | 0) == (i22 | 0) & 1) | 0;
        if ((i4 | 0) == (i20 | 0)) i51 = 95;
       }
       if ((i51 | 0) == 95) {
        i51 = 0;
        i3 = i3 + 1 | 0;
       }
       i7 = (i4 | 0) == (i20 | 0) | (i4 | 0) == (i22 | 0) ? (i16 ? 2 : 1) : i7;
       i4 = HEAP32[i17 + 8 >> 2] | 0;
       if ((i4 | 0) == (i21 | 0)) {
        i1 = i1 + 1 | 0;
        i51 = 99;
       } else {
        i1 = i1 + ((i4 | 0) == (i22 | 0) & 1) | 0;
        if ((i4 | 0) == (i20 | 0)) i51 = 99;
       }
       if ((i51 | 0) == 99) {
        i51 = 0;
        i3 = i3 + 1 | 0;
       }
       i8 = (i7 + (((i4 | 0) == (i20 | 0) | (i4 | 0) == (i22 | 0)) & 1) | 0) == 2 ? i19 : i8;
       i9 = (i3 | 0) == 2 ? i19 : i9;
       i1 = (i1 | 0) == 2 ? i19 : i18;
      }
      i19 = i19 + 1 | 0;
      if ((i19 | 0) >= (i2 | 0)) {
       i17 = i25;
       i16 = i1;
       break;
      } else i18 = i1;
     }
    } else {
     i17 = i25;
     i16 = -1;
     i9 = -1;
     i8 = -1;
    }
   }
   if ((i25 | 0) == (i6 | 0)) {
    i6 = (i25 | 0) == 0 ? 16 : i25 << 1;
    i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i56, i6 * 52 | 0, gb + 730303 | 0, 136) | 0;
    if ((i25 | 0) > 0) {
     i2 = i7;
     i3 = i24;
     i4 = i2 + 52 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i2 = i2 + 4 | 0;
      i3 = i3 + 4 | 0;
     } while ((i2 | 0) < (i4 | 0));
     if ((i25 | 0) > 1) {
      i1 = 1;
      do {
       i2 = i7 + (i1 * 52 | 0) | 0;
       i3 = i24 + (i1 * 52 | 0) | 0;
       i4 = i2 + 52 | 0;
       do {
        HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
        i2 = i2 + 4 | 0;
        i3 = i3 + 4 | 0;
       } while ((i2 | 0) < (i4 | 0));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i25 | 0));
      i1 = i24;
      i51 = 22;
     } else {
      i1 = i24;
      i51 = 22;
     }
    } else if (i24 | 0) {
     i1 = i24;
     i51 = 22;
    }
    if ((i51 | 0) == 22) {
     i51 = 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i52, i1);
    }
    i3 = i7;
   } else i3 = i24;
   i4 = i25 + 1 | 0;
   HEAPF32[i3 + (i25 * 52 | 0) >> 2] = f12;
   HEAPF32[i3 + (i25 * 52 | 0) + 4 >> 2] = f11;
   HEAPF32[i3 + (i25 * 52 | 0) + 8 >> 2] = f10;
   HEAPF32[i3 + (i25 * 52 | 0) + 12 >> 2] = f5;
   HEAP32[i3 + (i25 * 52 | 0) + 16 >> 2] = i16;
   HEAP32[i3 + (i25 * 52 | 0) + 20 >> 2] = i9;
   HEAP32[i3 + (i25 * 52 | 0) + 24 >> 2] = i8;
   HEAP32[i3 + (i25 * 52 | 0) + 28 >> 2] = -1;
   HEAPF32[i3 + (i25 * 52 | 0) + 32 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAP32[i3 + (i25 * 52 | 0) + 36 >> 2] = -1;
   HEAP32[i3 + (i25 * 52 | 0) + 40 >> 2] = -1;
   HEAP32[i3 + (i25 * 52 | 0) + 44 >> 2] = -1;
   HEAP32[i3 + (i25 * 52 | 0) + 48 >> 2] = i17;
   i1 = HEAP32[i55 >> 2] | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i4 | 0) >= (i2 | 0)) {
    i50 = i3;
    i49 = i4;
    break;
   } else {
    i24 = i3;
    i25 = i4;
   }
  }
 } else {
  i50 = 0;
  i49 = 0;
 }
 if ((i27 | 0) > 0) {
  i7 = (i2 | 0) > 0;
  i8 = 0;
  do {
   if (i7) {
    i1 = i26 + (i8 * 12 | 0) | 0;
    i3 = i26 + (i8 * 12 | 0) + 4 | 0;
    i4 = i26 + (i8 * 12 | 0) + 8 | 0;
    i9 = 0;
    do {
     if ((HEAP32[i50 + (i9 * 52 | 0) + 48 >> 2] | 0) != -1) {
      f5 = Math_fround(HEAPF32[i1 >> 2]);
      f5 = Math_fround(f5 * Math_fround(HEAPF32[i50 + (i9 * 52 | 0) >> 2]));
      f41 = Math_fround(HEAPF32[i3 >> 2]);
      f41 = Math_fround(f5 + Math_fround(f41 * Math_fround(HEAPF32[i50 + (i9 * 52 | 0) + 4 >> 2])));
      f5 = Math_fround(HEAPF32[i4 >> 2]);
      f5 = Math_fround(f41 + Math_fround(f5 * Math_fround(HEAPF32[i50 + (i9 * 52 | 0) + 8 >> 2])));
      f5 = Math_fround(Math_fround(HEAPF32[i50 + (i9 * 52 | 0) + 12 >> 2]) + f5);
      if (f5 > Math_fround(0.0)) {
       i6 = i50 + (i9 * 52 | 0) + 32 | 0;
       if (f5 > Math_fround(HEAPF32[i6 >> 2])) {
        HEAPF32[i6 >> 2] = f5;
        HEAP32[i50 + (i9 * 52 | 0) + 28 >> 2] = i8;
       }
      }
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) < (i2 | 0));
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i27 | 0));
 }
 i1 = (i49 | 0) > 0;
 if (i1) {
  i2 = 0;
  do {
   if ((HEAP32[i50 + (i2 * 52 | 0) + 48 >> 2] | 0) != -1) if ((HEAP32[i50 + (i2 * 52 | 0) + 28 >> 2] | 0) > -1) {
    f41 = Math_fround(Math_fround(HEAPF32[i50 + (i2 * 52 | 0) + 32 >> 2]) + f32);
    i48 = i50 + (i2 * 52 | 0) + 12 | 0;
    HEAPF32[i48 >> 2] = Math_fround(Math_fround(HEAPF32[i48 >> 2]) - f41);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i49 | 0));
  HEAP32[i57 >> 2] = 0;
  if (i1) {
   i8 = 0;
   i4 = 0;
   i7 = 0;
   i6 = 0;
   i1 = 0;
   i48 = 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i50 + (i48 * 52 | 0) + 48 >> 2] | 0;
    L72 : do if ((i2 | 0) == -1) i2 = i8; else {
     i43 = HEAP32[(HEAP32[HEAP32[i55 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i44 = i50 + (i48 * 52 | 0) | 0;
     i45 = i50 + (i48 * 52 | 0) + 4 | 0;
     i46 = i50 + (i48 * 52 | 0) + 8 | 0;
     i47 = i50 + (i48 * 52 | 0) + 12 | 0;
     i2 = i8;
     i8 = 0;
     while (1) {
      i42 = (i7 | 0) > 0;
      while (1) {
       i18 = HEAP32[i50 + (i48 * 52 | 0) + 16 + (i8 << 2) >> 2] | 0;
       i8 = i8 + 1 | 0;
       i17 = HEAP32[i50 + (i48 * 52 | 0) + 16 + (((i8 | 0) % 3 | 0) << 2) >> 2] | 0;
       i22 = HEAP32[HEAP32[i55 >> 2] >> 2] | 0;
       i28 = HEAP32[i22 + (i18 << 2) >> 2] | 0;
       i22 = HEAP32[i22 + (i17 << 2) >> 2] | 0;
       i21 = HEAP32[i28 >> 2] | 0;
       i23 = i22 + 4 | 0;
       i24 = i22 + 8 | 0;
       i25 = HEAP32[i28 + 4 >> 2] | 0;
       i26 = i22 + 4 | 0;
       i27 = i22 + 8 | 0;
       i28 = HEAP32[i28 + 8 >> 2] | 0;
       i29 = i22 + 4 | 0;
       i30 = i22 + 8 | 0;
       i9 = -1;
       i16 = -1;
       i19 = -1;
       i31 = 0;
       do {
        i20 = HEAP32[i43 + (i31 << 2) >> 2] | 0;
        if ((i20 | 0) == (i21 | 0)) {
         i59 = (i21 | 0) == (HEAP32[i22 >> 2] | 0);
         i60 = (i21 | 0) == (HEAP32[i23 >> 2] | 0);
         i61 = (i21 | 0) == (HEAP32[i24 >> 2] | 0);
         i9 = i61 | (i60 | i59) ? 0 : i9;
         i16 = i61 ? 2 : i60 ? 1 : i59 ? 0 : i16;
         i19 = i61 | (i60 | i59) ? i31 : i19;
        }
        if ((i20 | 0) == (i25 | 0)) {
         i61 = (i20 | 0) == (HEAP32[i22 >> 2] | 0);
         i60 = (i20 | 0) == (HEAP32[i26 >> 2] | 0);
         i59 = (i20 | 0) == (HEAP32[i27 >> 2] | 0);
         i9 = i59 | (i60 | i61) ? 1 : i9;
         i16 = i59 ? 2 : i60 ? 1 : i61 ? 0 : i16;
         i19 = i59 | (i60 | i61) ? i31 : i19;
        }
        if ((i20 | 0) == (i28 | 0)) {
         i61 = (i20 | 0) == (HEAP32[i22 >> 2] | 0);
         i60 = (i20 | 0) == (HEAP32[i29 >> 2] | 0);
         i59 = (i20 | 0) == (HEAP32[i30 >> 2] | 0);
         i9 = i59 | (i60 | i61) ? 2 : i9;
         i16 = i59 ? 2 : i60 ? 1 : i61 ? 0 : i16;
         i19 = i59 | (i60 | i61) ? i31 : i19;
        }
        i31 = i31 + 1 | 0;
       } while ((i31 | 0) != 3);
       i22 = i9;
       i23 = i16;
       L90 : do if (i42) {
        i9 = HEAP32[i43 + (i19 << 2) >> 2] | 0;
        i16 = 0;
        while (1) {
         if ((HEAP32[i1 + (i16 << 2) >> 2] | 0) == (i9 | 0)) break L90;
         i16 = i16 + 1 | 0;
         if ((i16 | 0) >= (i7 | 0)) {
          i16 = -1;
          break;
         }
        }
       } else i16 = -1; while (0);
       f12 = Math_fround(HEAPF32[i44 >> 2]);
       f13 = Math_fround(HEAPF32[i45 >> 2]);
       f15 = Math_fround(HEAPF32[i46 >> 2]);
       f32 = Math_fround(HEAPF32[i50 + (i18 * 52 | 0) >> 2]);
       f33 = Math_fround(HEAPF32[i50 + (i18 * 52 | 0) + 4 >> 2]);
       f34 = Math_fround(HEAPF32[i50 + (i18 * 52 | 0) + 8 >> 2]);
       f35 = Math_fround(HEAPF32[i50 + (i17 * 52 | 0) >> 2]);
       f36 = Math_fround(HEAPF32[i50 + (i17 * 52 | 0) + 4 >> 2]);
       f37 = Math_fround(HEAPF32[i50 + (i17 * 52 | 0) + 8 >> 2]);
       f39 = Math_fround(f12 * f33);
       f66 = Math_fround(f13 * f34);
       f64 = Math_fround(f15 * f32);
       f10 = Math_fround(f12 * f34);
       f38 = Math_fround(f13 * f32);
       f11 = Math_fround(f15 * f33);
       f41 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f64 * f36) + Math_fround(Math_fround(f66 * f35) + Math_fround(f39 * f37))) - Math_fround(f10 * f36)) - Math_fround(f38 * f37)) - Math_fround(f11 * f35));
       f68 = Math_fround(Math_fround(Math_fround(f33 * f37) - Math_fround(f34 * f36)) / f41);
       f67 = Math_fround(Math_fround(Math_fround(f15 * f36) - Math_fround(f13 * f37)) / f41);
       f11 = Math_fround(Math_fround(f66 - f11) / f41);
       f66 = Math_fround(Math_fround(Math_fround(f34 * f35) - Math_fround(f32 * f37)) / f41);
       f65 = Math_fround(Math_fround(Math_fround(f12 * f37) - Math_fround(f15 * f35)) / f41);
       f10 = Math_fround(Math_fround(f64 - f10) / f41);
       f64 = Math_fround(Math_fround(Math_fround(f32 * f36) - Math_fround(f33 * f35)) / f41);
       f62 = Math_fround(Math_fround(Math_fround(f13 * f35) - Math_fround(f12 * f36)) / f41);
       f41 = Math_fround(Math_fround(f39 - f38) / f41);
       f38 = Math_fround(HEAPF32[i47 >> 2]);
       f39 = Math_fround(HEAPF32[i50 + (i18 * 52 | 0) + 12 >> 2]);
       f40 = Math_fround(HEAPF32[i50 + (i17 * 52 | 0) + 12 >> 2]);
       f63 = Math_fround(-f38);
       f14 = Math_fround(-f39);
       f5 = Math_fround(-f40);
       f11 = Math_fround(Math_fround(Math_fround(f68 * f63) + Math_fround(f67 * f14)) + Math_fround(f11 * f5));
       f10 = Math_fround(Math_fround(Math_fround(f66 * f63) + Math_fround(f65 * f14)) + Math_fround(f10 * f5));
       f5 = Math_fround(Math_fround(Math_fround(f64 * f63) + Math_fround(f62 * f14)) + Math_fround(f41 * f5));
       if ((i16 | 0) == -1) {
        i16 = i22;
        i9 = i23;
        break;
       }
       i9 = HEAP32[i57 >> 2] | 0;
       i21 = i9 + (i16 * 12 | 0) | 0;
       f41 = Math_fround(HEAPF32[i21 >> 2]);
       f68 = Math_fround(f12 * f41);
       i20 = i9 + (i16 * 12 | 0) + 4 | 0;
       f14 = Math_fround(HEAPF32[i20 >> 2]);
       f68 = Math_fround(f68 + Math_fround(f13 * f14));
       i9 = i9 + (i16 * 12 | 0) + 8 | 0;
       f12 = Math_fround(HEAPF32[i9 >> 2]);
       if (Math_fround(f38 + Math_fround(f68 + Math_fround(f15 * f12))) < Math_fround(-.0199999996)) i51 = 71; else if (Math_fround(f39 + Math_fround(Math_fround(Math_fround(f32 * f41) + Math_fround(f33 * f14)) + Math_fround(f34 * f12))) < Math_fround(-.0199999996)) i51 = 71; else if (Math_fround(f40 + Math_fround(Math_fround(Math_fround(f35 * f41) + Math_fround(f36 * f14)) + Math_fround(f37 * f12))) < Math_fround(-.0199999996)) i51 = 71;
       if ((i51 | 0) == 71) {
        i51 = 0;
        HEAPF32[i21 >> 2] = f11;
        HEAPF32[i20 >> 2] = f10;
        HEAPF32[i9 >> 2] = f5;
       }
       HEAP32[i50 + (i48 * 52 | 0) + 36 + (i19 << 2) >> 2] = i16;
       HEAP32[i50 + (i18 * 52 | 0) + 36 + (i22 << 2) >> 2] = i16;
       HEAP32[i50 + (i17 * 52 | 0) + 36 + (i23 << 2) >> 2] = i16;
       if ((i8 | 0) >= 3) break L72;
      }
      HEAP32[i50 + (i48 * 52 | 0) + 36 + (i19 << 2) >> 2] = i3;
      HEAP32[i50 + (i18 * 52 | 0) + 36 + (i16 << 2) >> 2] = i3;
      HEAP32[i50 + (i17 * 52 | 0) + 36 + (i9 << 2) >> 2] = i3;
      if ((i2 | 0) == (i4 | 0)) {
       i4 = (i2 | 0) == 0 ? 16 : i2 << 1;
       i9 = HEAP32[i57 >> 2] | 0;
       i17 = i9;
       i18 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i56, i4 * 12 | 0, gb + 730303 | 0, 136) | 0;
       HEAP32[i57 >> 2] = i18;
       if ((i2 | 0) > 0) {
        HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
        HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
        HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
        if ((i2 | 0) > 1) {
         i16 = 1;
         do {
          i61 = i18 + (i16 * 12 | 0) | 0;
          i60 = i17 + (i16 * 12 | 0) | 0;
          HEAP32[i61 >> 2] = HEAP32[i60 >> 2];
          HEAP32[i61 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
          HEAP32[i61 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
          i16 = i16 + 1 | 0;
         } while ((i16 | 0) != (i2 | 0));
         i51 = 59;
        } else i51 = 59;
       } else if (i9 | 0) i51 = 59;
       if ((i51 | 0) == 59) {
        i51 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i52, i9);
       }
       i9 = i18;
      } else i9 = HEAP32[i57 >> 2] | 0;
      i17 = i2 + 1 | 0;
      HEAPF32[i9 + (i2 * 12 | 0) >> 2] = f11;
      HEAPF32[i9 + (i2 * 12 | 0) + 4 >> 2] = f10;
      HEAPF32[i9 + (i2 * 12 | 0) + 8 >> 2] = f5;
      i16 = HEAP32[i43 + (i19 << 2) >> 2] | 0;
      if ((i7 | 0) == (i6 | 0)) {
       i6 = (i7 | 0) == 0 ? 16 : i7 << 1;
       i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i56, i6 << 2, gb + 730303 | 0, 136) | 0;
       if (i42) {
        i2 = 0;
        do {
         HEAP32[i9 + (i2 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i7 | 0));
        i51 = 65;
       } else if (i1 | 0) i51 = 65;
       if ((i51 | 0) == 65) {
        i51 = 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i52, i1);
       }
       i1 = i9;
      }
      i9 = i7 + 1 | 0;
      HEAP32[i1 + (i7 << 2) >> 2] = i16;
      i3 = i3 + 1 | 0;
      if ((i8 | 0) < 3) {
       i2 = i17;
       i7 = i9;
      } else {
       i7 = i9;
       i2 = i17;
       break;
      }
     }
    } while (0);
    i48 = i48 + 1 | 0;
    if ((i48 | 0) == (i49 | 0)) break; else i8 = i2;
   }
   i6 = i1;
   i2 = HEAP32[i57 >> 2] | 0;
   i1 = i3;
  } else {
   i6 = 0;
   i2 = 0;
   i1 = 0;
  }
 } else {
  HEAP32[i57 >> 2] = 0;
  i6 = 0;
  i2 = 0;
  i1 = 0;
 }
 HEAP32[i53 >> 2] = i1;
 HEAP32[i54 >> 2] = i2;
 HEAP32[i57 >> 2] = 0;
 i2 = HEAP32[i55 >> 2] | 0;
 i1 = i2 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) > 0) {
  i4 = 0;
  do {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    HEAP32[i1 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i3);
    i2 = HEAP32[i55 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   i1 = i2 + 4 | 0;
  } while ((i4 | 0) < (HEAP32[i1 >> 2] | 0));
 }
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i3);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i57 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i1);
  HEAP32[i57 >> 2] = 0;
 }
 HEAP32[i57 >> 2] = 0;
 if (i6 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i6);
 if (!i50) {
  STACKTOP = i58;
  return 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i56, i50);
 STACKTOP = i58;
 return 0;
}

function __ZN7ApiGLES4LoadE16GfxDeviceLevelGL(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i5 + 808 >> 2] = fb + 3677;
 HEAP32[i5 + 524 >> 2] = fb + 3196;
 HEAP32[i5 >> 2] = fb + 723;
 HEAP32[i5 + 644 >> 2] = fb + 3197;
 HEAP32[i5 + 544 >> 2] = fb + 3198;
 HEAP32[i5 + 624 >> 2] = fb + 3199;
 HEAP32[i5 + 812 >> 2] = fb + 3200;
 HEAP32[i5 + 4 >> 2] = fb + 3678;
 HEAP32[i5 + 12 >> 2] = fb + 3201;
 HEAP32[i5 + 20 >> 2] = fb + 264;
 HEAP32[i5 + 656 >> 2] = fb + 265;
 HEAP32[i5 + 660 >> 2] = fb + 266;
 HEAP32[i5 + 552 >> 2] = fb + 1967;
 HEAP32[i5 + 452 >> 2] = fb + 3679;
 HEAP32[i5 + 456 >> 2] = fb + 2;
 HEAP32[i5 + 460 >> 2] = fb + 20;
 HEAP32[i5 + 464 >> 2] = fb + 3680;
 HEAP32[i5 + 28 >> 2] = fb + 267;
 HEAP32[i5 + 484 >> 2] = fb + 3681;
 HEAP32[i5 + 184 >> 2] = fb + 18;
 HEAP32[i5 + 596 >> 2] = fb + 14;
 HEAP32[i5 + 188 >> 2] = fb + 19;
 HEAP32[i5 + 192 >> 2] = fb + 20;
 HEAP32[i5 + 504 >> 2] = fb + 226;
 HEAP32[i5 + 476 >> 2] = fb + 1968;
 HEAP32[i5 + 744 >> 2] = fb + 3682;
 HEAP32[i5 + 640 >> 2] = fb + 3202;
 HEAP32[i5 + 540 >> 2] = fb + 3203;
 HEAP32[i5 + 508 >> 2] = fb + 3683;
 HEAP32[i5 + 620 >> 2] = fb + 3204;
 HEAP32[i5 + 488 >> 2] = fb + 3684;
 HEAP32[i5 + 816 >> 2] = fb + 3205;
 HEAP32[i5 + 36 >> 2] = fb + 3685;
 HEAP32[i5 + 40 >> 2] = fb + 3686;
 HEAP32[i5 + 772 >> 2] = fb + 3687;
 HEAP32[i5 + 708 >> 2] = fb + 3688;
 HEAP32[i5 + 420 >> 2] = fb + 724;
 HEAP32[i5 + 436 >> 2] = fb + 268;
 HEAP32[i5 + 768 >> 2] = fb + 3689;
 HEAP32[i5 + 712 >> 2] = fb + 3690;
 HEAP32[i5 + 44 >> 2] = fb + 188;
 HEAP32[i5 + 48 >> 2] = fb + 189;
 HEAP32[i5 + 52 >> 2] = fb + 269;
 HEAP32[i5 + 56 >> 2] = fb + 142;
 HEAP32[i5 + 68 >> 2] = fb + 3691;
 HEAP32[i5 + 636 >> 2] = fb + 3206;
 HEAP32[i5 + 612 >> 2] = fb + 3692;
 HEAP32[i5 + 536 >> 2] = fb + 3207;
 HEAP32[i5 + 616 >> 2] = fb + 3208;
 HEAP32[i5 + 804 >> 2] = fb + 3209;
 HEAP32[i5 + 72 >> 2] = fb + 32;
 HEAP32[i5 + 76 >> 2] = fb + 33;
 HEAP32[i5 + 80 >> 2] = fb + 801;
 HEAP32[i5 + 84 >> 2] = fb + 227;
 HEAP32[i5 + 556 >> 2] = fb + 270;
 HEAP32[i5 + 88 >> 2] = fb + 3210;
 HEAP32[i5 + 92 >> 2] = fb + 725;
 HEAP32[i5 + 528 >> 2] = fb + 271;
 HEAP32[i5 + 532 >> 2] = fb + 3693;
 HEAP32[i5 + 492 >> 2] = fb + 726;
 HEAP32[i5 + 500 >> 2] = fb + 272;
 HEAP32[i5 + 496 >> 2] = fb + 273;
 HEAP32[i5 + 356 >> 2] = fb + 274;
 HEAP32[i5 + 844 >> 2] = fb + 1969;
 HEAP32[i5 + 96 >> 2] = fb + 727;
 HEAP32[i5 + 100 >> 2] = fb + 728;
 HEAP32[i5 + 104 >> 2] = fb + 802;
 HEAP32[i5 + 108 >> 2] = fb + 729;
 HEAP32[i5 + 764 >> 2] = fb + 1970;
 HEAP32[i5 + 520 >> 2] = fb + 3694;
 HEAP32[i5 + 776 >> 2] = fb + 3211;
 HEAP32[i5 + 112 >> 2] = fb + 2;
 HEAP32[i5 + 116 >> 2] = fb + 34;
 HEAP32[i5 + 628 >> 2] = fb + 275;
 HEAP32[i5 + 120 >> 2] = fb + 276;
 HEAP32[i5 + 480 >> 2] = fb + 277;
 HEAP32[i5 + 756 >> 2] = fb + 278;
 HEAP32[i5 + 752 >> 2] = fb + 3695;
 HEAP32[i5 + 760 >> 2] = fb + 279;
 HEAP32[i5 + 176 >> 2] = fb + 15;
 HEAP32[i5 + 608 >> 2] = fb + 54;
 HEAP32[i5 + 180 >> 2] = fb + 730;
 HEAP32[i5 + 604 >> 2] = fb + 731;
 HEAP32[i5 + 576 >> 2] = fb + 16;
 HEAP32[i5 + 124 >> 2] = fb + 732;
 HEAP32[i5 + 128 >> 2] = fb + 3212;
 HEAP32[i5 + 132 >> 2] = fb + 733;
 HEAP32[i5 + 136 >> 2] = fb + 734;
 HEAP32[i5 + 140 >> 2] = fb + 735;
 HEAP32[i5 + 144 >> 2] = fb + 736;
 HEAP32[i5 + 148 >> 2] = fb + 737;
 HEAP32[i5 + 152 >> 2] = fb + 738;
 HEAP32[i5 + 156 >> 2] = fb + 739;
 HEAP32[i5 + 160 >> 2] = fb + 280;
 HEAP32[i5 + 164 >> 2] = fb + 281;
 HEAP32[i5 + 516 >> 2] = fb + 3696;
 HEAP32[i5 + 168 >> 2] = fb + 6;
 HEAP32[i5 + 696 >> 2] = fb + 177;
 HEAP32[i5 + 172 >> 2] = fb + 282;
 if ((i4 + -2 | 0) >>> 0 < 3) {
  HEAP32[i5 + 792 >> 2] = fb + 3213;
  HEAP32[i5 + 796 >> 2] = fb + 3214;
  HEAP32[i5 + 784 >> 2] = fb + 3215;
  HEAP32[i5 + 788 >> 2] = fb + 3697;
  HEAP32[i5 + 688 >> 2] = fb + 3698;
  HEAP32[i5 + 692 >> 2] = fb + 1971;
  HEAP32[i5 + 716 >> 2] = fb + 3216;
  HEAP32[i5 + 720 >> 2] = fb + 3217;
  HEAP32[i5 + 736 >> 2] = fb + 3699;
  HEAP32[i5 + 740 >> 2] = fb + 190;
  HEAP32[i5 + 200 >> 2] = fb + 283;
  HEAP32[i5 + 724 >> 2] = fb + 3218;
  HEAP32[i5 + 728 >> 2] = fb + 3219;
  HEAP32[i5 + 732 >> 2] = fb + 3220;
  HEAP32[i5 + 572 >> 2] = fb + 9;
  HEAP32[i5 + 580 >> 2] = fb + 5;
  HEAP32[i5 + 600 >> 2] = fb + 6;
  HEAP32[i5 + 584 >> 2] = fb + 143;
  HEAP32[i5 + 588 >> 2] = fb + 178;
  HEAP32[i5 + 548 >> 2] = fb + 10;
  HEAP32[i5 + 632 >> 2] = fb + 144;
  HEAP32[i5 + 840 >> 2] = fb + 803;
  HEAP32[i5 + 680 >> 2] = fb + 740;
  HEAP32[i5 + 668 >> 2] = fb + 158;
  HEAP32[i5 + 672 >> 2] = fb + 1972;
  HEAP32[i5 + 676 >> 2] = fb + 741;
  HEAP32[i5 + 236 >> 2] = fb + 742;
  HEAP32[i5 + 424 >> 2] = fb + 284;
  HEAP32[i5 + 444 >> 2] = fb + 145;
  HEAP32[i5 + 684 >> 2] = fb + 146;
  HEAP32[i5 + 564 >> 2] = fb + 3221;
  HEAP32[i5 + 196 >> 2] = fb + 3700;
  HEAP32[i5 + 60 >> 2] = fb + 147;
  HEAP32[i5 + 652 >> 2] = fb + 743;
  HEAP32[i5 + 204 >> 2] = fb + 148;
  HEAP32[i5 + 208 >> 2] = fb + 804;
  HEAP32[i5 + 212 >> 2] = fb + 285;
  HEAP32[i5 + 216 >> 2] = fb + 149;
  HEAP32[i5 + 220 >> 2] = fb + 744;
  HEAP32[i5 + 700 >> 2] = fb + 150;
  HEAP32[i5 + 224 >> 2] = fb + 151;
  HEAP32[i5 + 228 >> 2] = fb + 286;
  HEAP32[i5 + 232 >> 2] = fb + 745;
  HEAP32[i5 + 824 >> 2] = fb + 3222;
  HEAP32[i5 + 828 >> 2] = fb + 3223;
  HEAP32[i5 + 832 >> 2] = fb + 3224;
  HEAP32[i5 + 836 >> 2] = fb + 746;
  HEAP32[i5 + 848 >> 2] = fb + 152;
  HEAP32[i5 + 344 >> 2] = fb + 805;
  HEAP32[i5 + 348 >> 2] = fb + 159;
  HEAP32[i5 + 352 >> 2] = fb + 3701;
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606728 | 0) | 0) {
  i1 = __ZN4gles14GetProcAddressEPKc(gb + 598204 | 0) | 0;
  if (i1 | 0) HEAP32[i5 + 632 >> 2] = i1;
  i1 = i5 + 360 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598240 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606766 | 0) | 0) {
  i1 = i5 + 632 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598277 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 360 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598313 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606830 | 0) | 0) {
  i1 = i5 + 632 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598350 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 364 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598388 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 i3 = (i4 | 0) == 1;
 if (i3) if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606863 | 0) | 0) if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606893 | 0) | 0) {
  i1 = i5 + 632 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598425 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606311 | 0) | 0) {
  if ((i4 + -1 | 0) >>> 0 < 4) {
   i1 = i5 + 404 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598460 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 408 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598485 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 412 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598511 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 372 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598535 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 376 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598552 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 380 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598572 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 384 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598592 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if ((i4 + -5 | 0) >>> 0 < 8) {
   i1 = i5 + 404 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598611 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 408 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598633 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 412 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598656 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 372 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598677 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 376 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598691 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 380 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598708 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 384 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598725 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606324 | 0) | 0) {
  i1 = i5 + 396 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598741 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 400 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598762 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606344 | 0) | 0) {
  i1 = i5 + 388 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598782 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 392 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598799 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 608488 | 0) | 0) {
  i1 = i5 + 792 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598819 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 796 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598835 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 784 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598854 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 788 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598870 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 800 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 598884 | 0) | 0;
   if (i2 | 0) HEAP32[i1 >> 2] = i2;
  }
 }
 do if (i3) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607162 | 0) | 0) {
   i1 = i5 + 572 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598908 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 580 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598924 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 598943 | 0) | 0) {
   i1 = i5 + 688 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598970 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 716 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 598991 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 720 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599015 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 599036 | 0) | 0) {
   i1 = i5 + 564 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599056 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607850 | 0) | 0) {
   i1 = i5 + 564 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599073 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607721 | 0) | 0) {
   i1 = i5 + 196 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599089 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606893 | 0) | 0) {
   i1 = i5 + 548 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599104 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607694 | 0) | 0) {
   i1 = i5 + 236 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599124 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  do if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 599148 | 0) | 0) {
   i1 = i5 + 668 | 0;
   do if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599172 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   } while (0);
   i1 = i5 + 676 | 0;
   do if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599192 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   } while (0);
   i2 = i5 + 672 | 0;
   if (HEAP32[i2 >> 2] | 0) break;
   i1 = __ZN4gles14GetProcAddressEPKc(gb + 599220 | 0) | 0;
   if (!i1) i1 = HEAP32[i2 >> 2] | 0; else HEAP32[i2 >> 2] = i1;
   if (i1 | 0) break;
   i1 = __ZN4gles14GetProcAddressEPKc(gb + 599237 | 0) | 0;
   if (!i1) break;
   HEAP32[i2 >> 2] = i1;
  } while (0);
  do if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 599254 | 0) | 0) {
   i1 = i5 + 664 | 0;
   do if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599272 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   } while (0);
   i1 = i5 + 672 | 0;
   if (HEAP32[i1 >> 2] | 0) break;
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 599220 | 0) | 0;
   if (!i2) break;
   HEAP32[i1 >> 2] = i2;
  } while (0);
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 599287 | 0) | 0) {
   i1 = i5 + 224 | 0;
   do if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599313 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   } while (0);
   i1 = i5 + 228 | 0;
   if (HEAP32[i1 >> 2] | 0) break;
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 599335 | 0) | 0;
   if (!i2) break;
   HEAP32[i1 >> 2] = i2;
  }
 } while (0);
 do if ((i4 + -1 | 0) >>> 0 < 4) {
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607228 | 0) | 0) {
   i1 = i5 + 416 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599354 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607246 | 0) | 0) {
   i1 = i5 + 416 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599376 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 608112 | 0) | 0) {
   i1 = i5 + 748 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599398 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 608139 | 0) | 0) {
   i1 = i5 + 748 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599419 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606550 | 0) | 0) {
   i1 = i5 + 440 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599440 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 448 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599468 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 606517 | 0) | 0) {
   i1 = i5 + 440 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599505 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
   i1 = i5 + 448 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599533 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607118 | 0) | 0) {
   i1 = i5 + 820 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599570 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  } else if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607140 | 0) | 0) {
   i1 = i5 + 820 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599593 | 0) | 0;
    if (i2 | 0) HEAP32[i1 >> 2] = i2;
   }
  }
  do if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607095 | 0) | 0) {
   i1 = i5 + 584 | 0;
   do if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599616 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   } while (0);
   i1 = i5 + 588 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599634 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   }
  } while (0);
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 608329 | 0) | 0) {
   i1 = i5 + 368 | 0;
   if (HEAP32[i1 >> 2] | 0) break;
   i2 = __ZN4gles14GetProcAddressEPKc(gb + 599652 | 0) | 0;
   if (!i2) break;
   HEAP32[i1 >> 2] = i2;
   break;
  }
  if (__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 608360 | 0) | 0) {
   i1 = i5 + 368 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __ZN4gles14GetProcAddressEPKc(gb + 599670 | 0) | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
   }
  }
 } while (0);
 if (!(__ZNK7ApiGLES14QueryExtensionEPKc(i5, gb + 607831 | 0) | 0)) return;
 i1 = i5 + 564 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = __ZN4gles14GetProcAddressEPKc(gb + 1056346 | 0) | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN17Physics2DSettings8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i2 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801749 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 944562 | 0, gb + 801759 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 40 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801783 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801804 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 48 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801825 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 40; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801845 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 51; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 51; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801867 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 62; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 62; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 62) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801890 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 73; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 73; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 73) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801912 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 84; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 84; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801931 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 95; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 95; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801958 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 106; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 106; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 106) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801975 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 117; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 117; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 117) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802004 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 128; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 128; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 128) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802018 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 139; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 139; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 139) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802041 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i6 = 150; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i6 = 150;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i6 | 0) == 150) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i6 = __ZN14SafeBinaryRead12IsOldVersionEi(i9, 1) | 0;
 i3 = i7 + 92 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 if (i6) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802065 | 0, i4, i8, 0) | 0;
  if (i1 | 0) {
   L216 : do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i6 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i6 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L216;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i3 = i7 + 93 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802087 | 0, i4, i8, 0) | 0;
  if (i1 | 0) {
   L228 : do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i6 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i6 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L228;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802114 | 0, i4, i8, 0) | 0;
  if (i1 | 0) {
   L241 : do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i6 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i6 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L241;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i3 = i7 + 93 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802135 | 0, i4, i8, 0) | 0;
  if (i1 | 0) {
   L253 : do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i6 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i6 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L253;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
 }
 i3 = i7 + 94 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802161 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L266 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L266;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802184 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf(i23, i29, f2, i15, f28) {
 i23 = i23 | 0;
 i29 = i29 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 f28 = Math_fround(f28);
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i32 + 80 | 0;
 i25 = i32 + 64 | 0;
 i24 = i32 + 48 | 0;
 i17 = i32 + 32 | 0;
 i18 = i32 + 16 | 0;
 i16 = i32;
 i30 = i32 + 96 | 0;
 i31 = i32 + 100 | 0;
 i8 = i29 + 20 | 0;
 f3 = Math_fround(HEAPF32[i29 + 48 >> 2]);
 if (!(f3 <= Math_fround(0.0))) {
  f2 = Math_fround(f2 / f3);
  i1 = i29 + 44 | 0;
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i1 >> 2] = f2;
 } else {
  i1 = i29 + 44 | 0;
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  f2 = Math_fround(1.0);
 }
 HEAPF32[i1 >> 2] = Math_fround(_fminf(Math_fround(1.0), f2));
 if (!(HEAP8[i29 + 56 >> 0] | 0)) {
  i6 = HEAP32[i29 + 60 >> 2] | 0;
  i12 = i23 + 36 | 0;
  i12 = (HEAP32[i12 >> 2] | 0) + i12 | 0;
  i1 = HEAP32[i12 + (i6 * 28 | 0) + 12 >> 2] | 0;
  i14 = HEAP32[i29 + 24 >> 2] | 0;
  i21 = i12 + (i6 * 28 | 0) + 8 | 0;
  i13 = HEAP32[i21 >> 2] | 0;
  i13 = (i13 | 0) == 0 ? 0 : i21 + i13 | 0;
  i21 = HEAP32[i29 + 28 >> 2] | 0;
  f22 = Math_fround(HEAPF32[i29 + 44 >> 2]);
  i8 = HEAP32[i8 >> 2] | 0;
  if (i8 | 0) {
   i4 = f22 < Math_fround(0.0);
   i5 = f22 > Math_fround(1.0);
   f7 = i5 ? Math_fround(1.0) : f22;
   f7 = i4 ? Math_fround(0.0) : f7;
   f7 = Math_fround(Math_fround(f7 * Math_fround(f7 * Math_fround(3.0))) + Math_fround(f7 * Math_fround(f7 * Math_fround(f7 * Math_fround(-2.0)))));
   f7 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(0.0)));
   f11 = Math_fround(f22 * f22);
   i4 = f22 > Math_fround(9.99999971e-10);
   i5 = f22 < Math_fround(1.0);
   switch (i1 | 0) {
   case 0:
    {
     if (i5) {
      i1 = 0;
      do {
       f3 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
       f2 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
       if (!(f3 == f2)) f2 = Math_fround(f3 + Math_fround(f22 * Math_fround(f2 - f3)));
       HEAPF32[i21 + (i1 << 2) >> 2] = f2;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i8 | 0));
     } else {
      i1 = 0;
      do {
       f3 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
       f2 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
       if (!(f3 == f2)) f2 = Math_fround(f3 + Math_fround(f22 * Math_fround(f2 - f3)));
       HEAPF32[i21 + (i1 << 2) >> 2] = f2;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i8 | 0));
     }
     break;
    }
   case 1:
    {
     i1 = 0;
     do {
      f3 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
      f2 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
      if (!(f3 == f2)) f2 = Math_fround(f3 + Math_fround(f7 * Math_fround(f2 - f3)));
      HEAPF32[i21 + (i1 << 2) >> 2] = f2;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
     break;
    }
   case 5:
    {
     if (i4) {
      i1 = 0;
      do {
       f7 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
       f11 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
       HEAPF32[i21 + (i1 << 2) >> 2] = f7 == f11 ? f11 : i5 ? f7 : f11;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i8 | 0));
     } else {
      i1 = 0;
      do {
       f7 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
       f11 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
       HEAPF32[i21 + (i1 << 2) >> 2] = f7 == f11 ? f11 : i5 ? f7 : f11;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i8 | 0));
     }
     break;
    }
   case 4:
    {
     i1 = 0;
     do {
      f11 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
      f7 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
      HEAPF32[i21 + (i1 << 2) >> 2] = f11 == f7 | i4 ? f7 : f11;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
     break;
    }
   case 2:
    {
     i1 = 0;
     do {
      f3 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
      f2 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
      if (!(f3 == f2)) f2 = Math_fround(f3 + Math_fround(f11 * Math_fround(f2 - f3)));
      HEAPF32[i21 + (i1 << 2) >> 2] = f2;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
     break;
    }
   default:
    {
     i4 = (i1 | 0) != 3;
     i1 = 0;
     do {
      f3 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
      f7 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
      i20 = f3 == f7;
      f2 = i20 ? f7 : Math_fround(0.0);
      if (!(i20 | i4)) f2 = Math_fround(f3 + Math_fround(Math_fround(f7 - f3) * Math_fround(Math_sqrt(Math_fround(f22)))));
      HEAPF32[i21 + (i1 << 2) >> 2] = f2;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
    }
   }
  }
  i9 = HEAP32[i12 + (i6 * 28 | 0) + 16 >> 2] | 0;
  if (i9) {
   i10 = i12 + (i6 * 28 | 0) + 24 | 0;
   i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
   i5 = i12 + (i6 * 28 | 0) + 20 | 0;
   i6 = i5;
   i1 = f22 < Math_fround(0.0);
   i20 = f22 > Math_fround(1.0);
   f7 = i20 ? Math_fround(1.0) : f22;
   f7 = i1 ? Math_fround(0.0) : f7;
   f7 = Math_fround(Math_fround(f7 * Math_fround(f7 * Math_fround(3.0))) + Math_fround(f7 * Math_fround(f7 * Math_fround(f7 * Math_fround(-2.0)))));
   f7 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(0.0)));
   f11 = Math_fround(f22 * f22);
   i1 = f22 > Math_fround(9.99999971e-10);
   if (f22 < Math_fround(1.0)) if (i1) {
    i1 = 0;
    do {
     i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
     f2 = Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]);
     f3 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
     L53 : do if (f2 == f3) f2 = f3; else switch (HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) {
     case 0:
      {
       f2 = Math_fround(f2 + Math_fround(f22 * Math_fround(f3 - f2)));
       break L53;
      }
     case 1:
      {
       f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(f3 - f2)));
       break L53;
      }
     case 2:
      {
       f2 = Math_fround(f2 + Math_fround(f11 * Math_fround(f3 - f2)));
       break L53;
      }
     case 3:
      {
       f2 = Math_fround(f2 + Math_fround(Math_fround(f3 - f2) * Math_fround(Math_sqrt(Math_fround(f22)))));
       break L53;
      }
     case 4:
      {
       f2 = f3;
       break L53;
      }
     case 5:
      break L53;
     default:
      {
       f2 = Math_fround(0.0);
       break L53;
      }
     } while (0);
     HEAPF32[i21 + (i4 << 2) >> 2] = f2;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   } else {
    i1 = 0;
    do {
     i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
     f2 = Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]);
     f3 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
     L65 : do if (f2 == f3) f2 = f3; else switch (HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) {
     case 0:
      {
       f2 = Math_fround(f2 + Math_fround(f22 * Math_fround(f3 - f2)));
       break L65;
      }
     case 1:
      {
       f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(f3 - f2)));
       break L65;
      }
     case 2:
      {
       f2 = Math_fround(f2 + Math_fround(f11 * Math_fround(f3 - f2)));
       break L65;
      }
     case 3:
      {
       f2 = Math_fround(f2 + Math_fround(Math_fround(f3 - f2) * Math_fround(Math_sqrt(Math_fround(f22)))));
       break L65;
      }
     case 4:
      break L65;
     case 5:
      break L65;
     default:
      {
       f2 = Math_fround(0.0);
       break L65;
      }
     } while (0);
     HEAPF32[i21 + (i4 << 2) >> 2] = f2;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   } else if (i1) {
    i1 = 0;
    do {
     i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
     f3 = Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]);
     f2 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
     L79 : do if (!(f3 == f2)) switch (HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) {
     case 0:
      {
       f2 = Math_fround(f3 + Math_fround(f22 * Math_fround(f2 - f3)));
       break L79;
      }
     case 1:
      {
       f2 = Math_fround(f3 + Math_fround(f7 * Math_fround(f2 - f3)));
       break L79;
      }
     case 2:
      {
       f2 = Math_fround(f3 + Math_fround(f11 * Math_fround(f2 - f3)));
       break L79;
      }
     case 3:
      {
       f2 = Math_fround(f3 + Math_fround(Math_fround(f2 - f3) * Math_fround(Math_sqrt(Math_fround(f22)))));
       break L79;
      }
     case 4:
      break L79;
     case 5:
      break L79;
     default:
      {
       f2 = Math_fround(0.0);
       break L79;
      }
     } while (0);
     HEAPF32[i21 + (i4 << 2) >> 2] = f2;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   } else {
    i1 = 0;
    do {
     i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
     f2 = Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]);
     f3 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
     L91 : do if (f2 == f3) f2 = f3; else switch (HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) {
     case 0:
      {
       f2 = Math_fround(f2 + Math_fround(f22 * Math_fround(f3 - f2)));
       break L91;
      }
     case 1:
      {
       f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(f3 - f2)));
       break L91;
      }
     case 2:
      {
       f2 = Math_fround(f2 + Math_fround(f11 * Math_fround(f3 - f2)));
       break L91;
      }
     case 3:
      {
       f2 = Math_fround(f2 + Math_fround(Math_fround(f3 - f2) * Math_fround(Math_sqrt(Math_fround(f22)))));
       break L91;
      }
     case 4:
      break L91;
     case 5:
      {
       f2 = f3;
       break L91;
      }
     default:
      {
       f2 = Math_fround(0.0);
       break L91;
      }
     } while (0);
     HEAPF32[i21 + (i4 << 2) >> 2] = f2;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   }
  }
 } else {
  i4 = HEAP32[i29 + 24 >> 2] | 0;
  i5 = HEAP32[i29 + 52 >> 2] | 0;
  i6 = HEAP32[i29 + 28 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i29 + 44 >> 2]);
  i8 = HEAP32[i8 >> 2] | 0;
  if (!i8) {
   i21 = i6;
   i8 = 0;
  } else {
   i1 = 0;
   do {
    f3 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
    f2 = Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]);
    if (!(f3 == f2)) f2 = Math_fround(f3 + Math_fround(f7 * Math_fround(f2 - f3)));
    HEAPF32[i6 + (i1 << 2) >> 2] = f2;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   i21 = i6;
  }
 }
 i4 = HEAP32[i29 + 40 >> 2] | 0;
 i5 = HEAP32[i23 + 68 >> 2] | 0;
 if (i5 | 0) {
  i6 = i23 + 76 | 0;
  i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
  i1 = 0;
  do {
   f2 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
   if (!(f2 == Math_fround(-inf))) HEAPF32[i21 + (HEAP32[i6 + (i1 << 2) >> 2] << 2) >> 2] = f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i19 = HEAP32[i29 + 32 >> 2] | 0;
 i20 = HEAP32[i29 + 36 >> 2] | 0;
 if (i8 | 0) {
  i1 = 0;
  do {
   f22 = Math_fround(HEAPF32[i21 + (i1 << 2) >> 2]);
   HEAP8[i20 + i1 >> 0] = Math_fround(HEAPF32[i19 + (i1 << 2) >> 2]) != f22 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 HEAP32[i30 >> 2] = 48e3;
 i1 = __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i15, i30, 0, 0, 0, 0, 0) | 0;
 if (i1 | 0) {
  i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i16 >> 2] = gb + 859765;
  HEAP32[i16 + 4 >> 2] = 671;
  HEAP32[i16 + 8 >> 2] = i15;
  HEAP32[i16 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i16);
 }
 if (HEAP32[i23 >> 2] | 0) {
  i6 = i23 + 4 | 0;
  i8 = i6;
  i9 = i29 + 12 | 0;
  i10 = i29 + 8 | 0;
  i5 = 0;
  do {
   i4 = (HEAP32[i6 >> 2] | 0) + i8 | 0;
   i1 = HEAP32[i4 + (i5 << 4) + 4 >> 2] | 0;
   if (HEAP8[i20 + i1 >> 0] | 0) {
    f2 = Math_fround(HEAPF32[i21 + (i1 << 2) >> 2]);
    if (!(f2 <= Math_fround(-80.0))) {
     f2 = Math_fround(f2 * Math_fround(.0500000007));
     f2 = Math_fround(_exp2f(Math_fround(f2 * Math_fround(_log2f(Math_fround(10.0))))));
    } else f2 = Math_fround(0.0);
    i1 = HEAP32[i9 >> 2] | 0;
    if (HEAP32[i1 + (i5 << 8) + 28 >> 2] & 1 | 0) {
     HEAPF32[i1 + (i5 << 8) >> 2] = f2;
     i1 = __ZN4FMOD12ChannelGroup19setAudibilityFactorEf(HEAP32[(HEAP32[i29 >> 2] | 0) + (i5 << 2) >> 2] | 0, f2) | 0;
     if (i1 | 0) {
      i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
      HEAP32[i18 >> 2] = gb + 859765;
      HEAP32[i18 + 4 >> 2] = 685;
      HEAP32[i18 + 8 >> 2] = i16;
      HEAP32[i18 + 12 >> 2] = i1;
      _printf_console(gb + 859725 | 0, i18);
     }
    }
    i1 = HEAP32[i10 >> 2] | 0;
    if (HEAP32[i1 + (i5 << 8) + 28 >> 2] & 1 | 0) {
     HEAPF32[i1 + (i5 << 8) >> 2] = f2;
     i1 = __ZN4FMOD12ChannelGroup19setAudibilityFactorEf(HEAP32[(HEAP32[i29 >> 2] | 0) + (i5 << 2) >> 2] | 0, f2) | 0;
     if (i1 | 0) {
      i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
      HEAP32[i17 >> 2] = gb + 859765;
      HEAP32[i17 + 4 >> 2] = 692;
      HEAP32[i17 + 8 >> 2] = i16;
      HEAP32[i17 + 12 >> 2] = i1;
      _printf_console(gb + 859725 | 0, i17);
     }
    }
   }
   i1 = HEAP32[i4 + (i5 << 4) + 8 >> 2] | 0;
   if (HEAP8[i20 + i1 >> 0] | 0) __ZN4FMOD12ChannelGroup8setPitchEf(HEAP32[(HEAP32[i29 >> 2] | 0) + (i5 << 2) >> 2] | 0, Math_fround(HEAPF32[i21 + (i1 << 2) >> 2])) | 0;
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i23 >> 2] | 0) >>> 0);
 }
 i15 = i23 + 12 | 0;
 if (HEAP32[i15 >> 2] | 0) {
  i16 = i23 + 16 | 0;
  i17 = i16;
  i18 = i29 + 16 | 0;
  i12 = i23 + 4 | 0;
  i13 = i12;
  i10 = 0;
  do {
   i6 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
   i4 = HEAP32[i18 >> 2] | 0;
   i14 = i4 + (i10 << 5) | 0;
   i1 = HEAP32[i6 + (i10 << 5) + 12 >> 2] | 0;
   if ((i1 | 0) != -1) if (HEAP8[i20 + i1 >> 0] | 0) if (HEAP32[i14 >> 2] | 0) {
    f2 = Math_fround(HEAPF32[i21 + (i1 << 2) >> 2]);
    if (!(f2 <= Math_fround(-80.0))) {
     f3 = Math_fround(f2 * Math_fround(.0500000007));
     f3 = Math_fround(_exp2f(Math_fround(f3 * Math_fround(_log2f(Math_fround(10.0))))));
    } else f3 = Math_fround(0.0);
    HEAPF32[i4 + (i10 << 5) + 12 >> 2] = f3;
    i1 = HEAP32[i4 + (i10 << 5) + 4 >> 2] | 0;
    if (i1 | 0) {
     __ZN4FMOD13DSPConnection6setMixEf(i1 | 0, +f3) | 0;
     i5 = HEAP32[i4 + (i10 << 5) + 8 >> 2] | 0;
     if (i5 | 0) {
      i1 = HEAP32[i6 + (i10 << 5) + 16 >> 2] | 0;
      if ((i1 | 0) == -1) {
       f2 = Math_fround(0.0);
       i27 = 107;
      } else {
       i4 = HEAP32[i18 >> 2] | 0;
       if (!(HEAP32[i4 + (i1 << 5) + 8 >> 2] | 0)) {
        f2 = Math_fround(0.0);
        i27 = 107;
       } else {
        f2 = Math_fround(HEAPF32[i4 + (i1 << 5) + 12 >> 2]);
        if (!(f2 <= Math_fround(-80.0))) i27 = 107; else f2 = Math_fround(0.0);
       }
      }
      if ((i27 | 0) == 107) {
       i27 = 0;
       f2 = Math_fround(f2 * Math_fround(.0500000007));
       f2 = Math_fround(_exp2f(Math_fround(f2 * Math_fround(_log2f(Math_fround(10.0))))));
      }
      __ZN4FMOD13DSPConnection6setMixEf(i5 | 0, +Math_fround(Math_fround(Math_fround(1.0) - f3) * f2)) | 0;
     }
    }
    i1 = f3 == Math_fround(0.0);
    if (i1) i4 = 1; else if (!(HEAP8[(HEAP32[i12 >> 2] | 0) + i13 + (HEAP32[i6 + (i10 << 5) + 4 >> 2] << 4) + 14 >> 0] | 0)) i4 = (HEAP8[i6 + (i10 << 5) + 20 >> 0] | 0) != 0; else i4 = 1;
    i23 = HEAP32[i6 + (i10 << 5) >> 2] | 0;
    i9 = (i23 | 0) > -1;
    i1 = i4 & (i9 | i1 ^ 1 ? i9 : (i23 | 0) == -3);
    i4 = __ZN4FMOD3DSP9getBypassEPb(HEAP32[i14 >> 2] | 0, i31) | 0;
    if (i4 | 0) {
     i23 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i4) | 0;
     HEAP32[i24 >> 2] = gb + 859765;
     HEAP32[i24 + 4 >> 2] = 751;
     HEAP32[i24 + 8 >> 2] = i23;
     HEAP32[i24 + 12 >> 2] = i4;
     _printf_console(gb + 859725 | 0, i24);
    }
    if ((i1 & 1 | 0) != (HEAPU8[i31 >> 0] | 0)) {
     i1 = __ZN4FMOD3DSP9setBypassEb(HEAP32[i14 >> 2] | 0, i1) | 0;
     if (i1 | 0) {
      i23 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
      HEAP32[i25 >> 2] = gb + 859765;
      HEAP32[i25 + 4 >> 2] = 753;
      HEAP32[i25 + 8 >> 2] = i23;
      HEAP32[i25 + 12 >> 2] = i1;
      _printf_console(gb + 859725 | 0, i25);
     }
    }
   }
   i9 = i6 + (i10 << 5) + 24 | 0;
   if (HEAP32[i9 >> 2] | 0) {
    i6 = i6 + (i10 << 5) + 28 | 0;
    i8 = i6;
    i5 = 0;
    do {
     i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + i8 + (i5 << 2) >> 2] | 0;
     L180 : do if (HEAP8[i20 + i1 >> 0] | 0) {
      i4 = HEAP32[i14 >> 2] | 0;
      if (i4 | 0) {
       i1 = __ZN4FMOD3DSP12setParameterEif(i4, i5, Math_fround(HEAPF32[i21 + (i1 << 2) >> 2])) | 0;
       switch (i1 | 0) {
       case 0:
       case 35:
        break L180;
       default:
        {}
       }
       i23 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
       HEAP32[i26 >> 2] = gb + 859765;
       HEAP32[i26 + 4 >> 2] = 763;
       HEAP32[i26 + 8 >> 2] = i23;
       HEAP32[i26 + 12 >> 2] = i1;
       _printf_console(gb + 859725 | 0, i26);
      }
     } while (0);
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   }
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 _memcpy(i19 | 0, i21 | 0, HEAP32[i29 + 20 >> 2] << 2 | 0) | 0;
 if (__ZN5audio5mixerL19IsAnyChannelPlayingEPN4FMOD12ChannelGroupE(HEAP32[HEAP32[i29 >> 2] >> 2] | 0) | 0) {
  __ZN5audio5mixer12SetSuspendedERNS0_16AudioMixerMemoryEb(i29, 0);
  STACKTOP = i32;
  return;
 }
 i1 = HEAP32[i29 + 12 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] & 4)) {
  STACKTOP = i32;
  return;
 }
 if (!(Math_fround(HEAPF32[i1 + 20 >> 2]) < f28)) {
  STACKTOP = i32;
  return;
 }
 i1 = i1 + 32 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i32;
  return;
 }
 HEAP32[i1 >> 2] = -1;
 HEAP32[i30 >> 2] = 0;
 __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(HEAP32[HEAP32[i29 >> 2] >> 2] | 0, i30) | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 if (i1 | 0) {
  HEAP8[i31 >> 0] = 0;
  __ZN4FMOD3DSP9getActiveEPb(i1, i31) | 0;
  __ZN4FMOD3DSP9setActiveEb(HEAP32[i30 >> 2] | 0, 0) | 0;
 }
 STACKTOP = i32;
 return;
}

function __ZN5physx2Gu11HeightField17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i31 >> 2] = HEAP32[gb + 132708 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 132708 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 132708 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 132708 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 132708 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 132708 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 132708 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 132708 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 132740 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 132740 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 132740 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 132740 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 132740 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 132740 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 132740 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 132740 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 132772 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 132772 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 132772 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 132772 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 132772 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 132772 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 132772 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 132772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 132804 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 132804 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 132804 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 132804 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 132804 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 132804 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 132804 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 132804 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 132836 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 132836 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 132836 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 132836 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 132836 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 132836 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 132836 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 132836 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 132868 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 132868 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 132868 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 132868 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 132868 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 132868 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 132868 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 132868 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 132900 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 132900 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 132900 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 132900 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 132900 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 132900 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 132900 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 132900 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 132932 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 132932 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 132932 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 132932 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 132932 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 132932 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 132932 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 132932 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 132964 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 132964 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 132964 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 132964 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 132964 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 132964 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 132964 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 132964 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 132996 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 132996 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 132996 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 132996 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 132996 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 132996 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 132996 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 132996 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 133028 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 133028 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 133028 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 133028 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 133028 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 133028 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 133028 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 133028 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 133060 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 133060 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 133060 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 133060 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 133060 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 133060 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 133060 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 133060 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 133092 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 133092 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 133092 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 133092 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 133092 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 133092 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 133092 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 133092 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 133124 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 133124 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 133124 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 133124 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 133124 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 133124 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 133124 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 133124 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 133156 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 133156 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 133156 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 133156 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 133156 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 133156 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 133156 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 133156 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 133188 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 133188 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 133188 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 133188 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 133188 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 133188 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 133188 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 133188 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 133220 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 133220 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 133220 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 133220 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 133220 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 133220 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 133220 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 133220 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 133252 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 133252 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 133252 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 133252 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 133252 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 133252 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 133252 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 133252 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 133284 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 133284 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 133284 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 133284 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 133284 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 133284 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 133284 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 133284 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 133316 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 133316 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 133316 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 133316 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 133316 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 133316 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 133316 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 133316 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 133348 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 133348 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 133348 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 133348 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 133348 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 133348 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 133348 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 133348 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 133380 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 133380 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 133380 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 133380 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 133380 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 133380 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 133380 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 133380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 133412 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 133412 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 133412 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 133412 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 133412 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 133412 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 133412 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 133412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 133444 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 133444 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 133444 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 133444 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 133444 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 133444 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 133444 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 133444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 133476 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 133476 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 133476 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 133476 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 133476 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 133476 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 133476 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 133476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = gb + 754632;
 HEAP32[i11 + 4 >> 2] = gb + 827530;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 116;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 1;
 HEAP32[i11 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 754632;
 HEAP32[i10 + 4 >> 2] = gb + 752142;
 HEAP32[i10 + 8 >> 2] = 8;
 HEAP32[i10 + 12 >> 2] = 116;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 133508 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 133508 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 133508 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 133508 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 133508 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 133508 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 133508 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 133508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 133540 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 133540 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 133540 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 133540 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 133540 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 133540 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 133540 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 133540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 133572 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 133572 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 133572 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 133572 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 133572 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 133572 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 133572 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 133572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 133604 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 133604 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 133604 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 133604 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 133604 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 133604 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 133604 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 133604 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 133636 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 133636 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 133636 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 133636 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 133636 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 133636 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 133636 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 133636 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 133668 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 133668 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 133668 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 133668 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 133668 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 133668 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 133668 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 133668 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 133700 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 133700 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 133700 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 133700 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 133700 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 133700 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 133700 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 133700 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_Rj(i1, i2, i3, i30) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i33 + 48 | 0;
 i29 = i33 + 32 | 0;
 i31 = i33 + 16 | 0;
 i32 = i33;
 i25 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 HEAP32[i30 >> 2] = 0;
 i20 = (HEAP32[i25 + 34476 >> 2] & 16 | 0) == 0;
 i26 = HEAP32[i2 >> 2] | 0;
 i27 = HEAP32[i2 + 4 >> 2] | 0;
 i22 = HEAP32[i2 + 8 >> 2] | 0;
 i23 = HEAP32[i3 >> 2] | 0;
 i24 = HEAP32[i3 + 4 >> 2] | 0;
 i21 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i25 + 34236 >> 2] | 0;
 if (i1 | 0) {
  i2 = i25 + 34268 | 0;
  f11 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i17 = f11 > Math_fround(HEAPF32[i25 + 34372 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i18 = f11 > Math_fround(HEAPF32[i25 + 34376 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i19 = f11 > Math_fround(HEAPF32[i25 + 34380 >> 2]);
  i7 = Math_fround(HEAPF32[i25 + 34384 >> 2]) < Math_fround(1.0);
  f11 = Math_fround(HEAPF32[i25 + 34356 >> 2]);
  i4 = f11 > (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(HEAPF32[i25 + 34360 >> 2]);
  i5 = f11 > (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(HEAPF32[i25 + 34364 >> 2]);
  i6 = f11 > (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = i17 | i4;
  i5 = i18 | i5;
  i6 = i19 | i6;
  i7 = i7 | Math_fround(HEAPF32[i25 + 34368 >> 2]) > Math_fround(1.0);
  if ((i1 | 0) > 3) {
   i3 = i1 + -4 | 0;
   f11 = Math_fround(0.0);
   f10 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   while (1) {
    i14 = HEAP32[i2 >> 2] | 0;
    i15 = HEAP32[i2 + 4 >> 2] | 0;
    i16 = HEAP32[i2 + 8 >> 2] | 0;
    i19 = HEAP32[i2 + 12 >> 2] | 0;
    i13 = HEAP32[i25 + 33872 + (i14 << 4) >> 2] | 0;
    i18 = HEAP32[i25 + 33872 + (i14 << 4) + 4 >> 2] | 0;
    i17 = HEAP32[i25 + 33872 + (i14 << 4) + 8 >> 2] | 0;
    f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i13 | i13 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i14 << 4) >> 2]));
    f37 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i18 | i18 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f37 * Math_fround(HEAPF32[i25 + 33520 + (i14 << 4) + 4 >> 2]));
    f35 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i17 | i17 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f35 = Math_fround(f35 * Math_fround(HEAPF32[i25 + 33520 + (i14 << 4) + 8 >> 2]));
    f37 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i14 << 4) + 12 >> 2]) + Math_fround(f35 + Math_fround(f38 + f37)));
    i14 = HEAP32[i25 + 33872 + (i15 << 4) >> 2] | 0;
    i17 = HEAP32[i25 + 33872 + (i15 << 4) + 4 >> 2] | 0;
    i18 = HEAP32[i25 + 33872 + (i15 << 4) + 8 >> 2] | 0;
    f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i14 | i14 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i15 << 4) >> 2]));
    f35 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i17 | i17 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f35 = Math_fround(f35 * Math_fround(HEAPF32[i25 + 33520 + (i15 << 4) + 4 >> 2]));
    f36 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i18 | i18 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f36 = Math_fround(f36 * Math_fround(HEAPF32[i25 + 33520 + (i15 << 4) + 8 >> 2]));
    f35 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i15 << 4) + 12 >> 2]) + Math_fround(f36 + Math_fround(f38 + f35)));
    i15 = HEAP32[i25 + 33872 + (i16 << 4) >> 2] | 0;
    i18 = HEAP32[i25 + 33872 + (i16 << 4) + 4 >> 2] | 0;
    i17 = HEAP32[i25 + 33872 + (i16 << 4) + 8 >> 2] | 0;
    f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i15 | i15 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i16 << 4) >> 2]));
    f36 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i18 | i18 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f36 = Math_fround(f36 * Math_fround(HEAPF32[i25 + 33520 + (i16 << 4) + 4 >> 2]));
    f34 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i17 | i17 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f34 = Math_fround(f34 * Math_fround(HEAPF32[i25 + 33520 + (i16 << 4) + 8 >> 2]));
    f36 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i16 << 4) + 12 >> 2]) + Math_fround(f34 + Math_fround(f38 + f36)));
    i16 = HEAP32[i25 + 33872 + (i19 << 4) >> 2] | 0;
    i17 = HEAP32[i25 + 33872 + (i19 << 4) + 4 >> 2] | 0;
    i18 = HEAP32[i25 + 33872 + (i19 << 4) + 8 >> 2] | 0;
    f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i16 | i16 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) >> 2]));
    f34 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i17 | i17 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f34 = Math_fround(f34 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 4 >> 2]));
    f39 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i18 | i18 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f39 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 8 >> 2]));
    f34 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 12 >> 2]) + Math_fround(f39 + Math_fround(f38 + f34)));
    f35 = f37 <= f35 ? f37 : f35;
    f34 = f36 <= f34 ? f36 : f34;
    f34 = f35 <= f34 ? f35 : f34;
    f11 = f11 <= f34 ? f11 : f34;
    f10 = f10 <= f34 ? f10 : f34;
    f9 = f9 <= f34 ? f9 : f34;
    f8 = f8 <= f34 ? f8 : f34;
    i1 = i1 + -4 | 0;
    if ((i1 | 0) <= 3) break; else i2 = i2 + 16 | 0;
   }
   i2 = i3 & -4;
   i1 = i3 - i2 | 0;
   i2 = i25 + 34268 + (i2 + 4 << 2) | 0;
  } else {
   f11 = Math_fround(0.0);
   f10 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  }
  switch (i1 | 0) {
  case 3:
   {
    i12 = HEAP32[i2 >> 2] | 0;
    i17 = HEAP32[i25 + 33872 + (i12 << 4) >> 2] | 0;
    i18 = HEAP32[i25 + 33872 + (i12 << 4) + 4 >> 2] | 0;
    i19 = HEAP32[i25 + 33872 + (i12 << 4) + 8 >> 2] | 0;
    f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26 & ~i17 | i17 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i25 + 33520 + (i12 << 4) >> 2]));
    f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27 & ~i18 | i18 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i25 + 33520 + (i12 << 4) + 4 >> 2]));
    f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22 & ~i19 | i19 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i25 + 33520 + (i12 << 4) + 8 >> 2]));
    f39 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i12 << 4) + 12 >> 2]) + Math_fround(f37 + Math_fround(f38 + f39)));
    i2 = i2 + 4 | 0;
    f11 = f11 <= f39 ? f11 : f39;
    f10 = f10 <= f39 ? f10 : f39;
    f9 = f9 <= f39 ? f9 : f39;
    f8 = f8 <= f39 ? f8 : f39;
    i12 = 8;
    break;
   }
  case 2:
   {
    i12 = 8;
    break;
   }
  case 1:
   {
    i12 = 9;
    break;
   }
  default:
   {}
  }
  if ((i12 | 0) == 8) {
   i19 = HEAP32[i2 >> 2] | 0;
   i16 = HEAP32[i25 + 33872 + (i19 << 4) >> 2] | 0;
   i17 = HEAP32[i25 + 33872 + (i19 << 4) + 4 >> 2] | 0;
   i18 = HEAP32[i25 + 33872 + (i19 << 4) + 8 >> 2] | 0;
   f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i16 | i16 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) >> 2]));
   f39 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i17 | i17 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 4 >> 2]));
   f37 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i18 | i18 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround(f37 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 8 >> 2]));
   f39 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 12 >> 2]) + Math_fround(f37 + Math_fround(f38 + f39)));
   i2 = i2 + 4 | 0;
   f11 = f11 <= f39 ? f11 : f39;
   f10 = f10 <= f39 ? f10 : f39;
   f9 = f9 <= f39 ? f9 : f39;
   f8 = f8 <= f39 ? f8 : f39;
   i12 = 9;
  }
  if ((i12 | 0) == 9) {
   i19 = HEAP32[i2 >> 2] | 0;
   i16 = HEAP32[i25 + 33872 + (i19 << 4) >> 2] | 0;
   i17 = HEAP32[i25 + 33872 + (i19 << 4) + 4 >> 2] | 0;
   i18 = HEAP32[i25 + 33872 + (i19 << 4) + 8 >> 2] | 0;
   f38 = (HEAP32[tempDoublePtr >> 2] = i26 & ~i16 | i16 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) >> 2]));
   f39 = (HEAP32[tempDoublePtr >> 2] = i27 & ~i17 | i17 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 4 >> 2]));
   f37 = (HEAP32[tempDoublePtr >> 2] = i22 & ~i18 | i18 & i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround(f37 * Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 8 >> 2]));
   f39 = Math_fround(Math_fround(HEAPF32[i25 + 33520 + (i19 << 4) + 12 >> 2]) + Math_fround(f37 + Math_fround(f38 + f39)));
   f11 = f11 <= f39 ? f11 : f39;
   f10 = f10 <= f39 ? f10 : f39;
   f9 = f9 <= f39 ? f9 : f39;
   f8 = f8 <= f39 ? f8 : f39;
  }
  if (i4 | f11 < Math_fround(0.0) | (i5 | f10 < Math_fround(0.0)) | (i6 | f9 < Math_fround(0.0)) | (i7 | f8 < Math_fround(0.0))) {
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  }
 }
 L18 : do if (HEAP8[i25 + 34472 >> 0] | 0) {
  f54 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f52 = Math_fround(HEAPF32[i25 + 64 >> 2]);
  f50 = Math_fround(HEAPF32[i25 + 68 >> 2]);
  f43 = Math_fround(HEAPF32[i25 + 72 >> 2]);
  f48 = Math_fround(HEAPF32[i25 + 80 >> 2]);
  f46 = Math_fround(HEAPF32[i25 + 84 >> 2]);
  f38 = Math_fround(HEAPF32[i25 + 88 >> 2]);
  f44 = Math_fround(HEAPF32[i25 + 96 >> 2]);
  f10 = Math_fround(HEAPF32[i25 + 100 >> 2]);
  f35 = Math_fround(HEAPF32[i25 + 104 >> 2]);
  f36 = Math_fround(HEAPF32[i25 + 112 >> 2]);
  f9 = Math_fround(HEAPF32[i25 + 116 >> 2]);
  f39 = Math_fround(HEAPF32[i25 + 120 >> 2]);
  f53 = Math_fround(f8 * f52);
  f51 = Math_fround(f8 * f50);
  f8 = Math_fround(f8 * f43);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  f49 = Math_fround(f11 * f48);
  f47 = Math_fround(f11 * f46);
  f11 = Math_fround(f11 * f38);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  f45 = Math_fround(f37 * f44);
  f34 = Math_fround(f37 * f10);
  f37 = Math_fround(f37 * f35);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  f52 = Math_fround(f56 * f52);
  f50 = Math_fround(f56 * f50);
  f43 = Math_fround(f56 * f43);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
  f48 = Math_fround(f55 * f48);
  f46 = Math_fround(f55 * f46);
  f38 = Math_fround(f55 * f38);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
  f44 = Math_fround(f54 * f44);
  f10 = Math_fround(f54 * f10);
  f35 = Math_fround(f54 * f35);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i42 = f53 > f52;
  i2 = f51 > f50;
  i13 = f49 > f48;
  i16 = f47 > f46;
  i19 = f45 > f44;
  i5 = f34 > f10;
  f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i42 ? i40 : i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f36);
  f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i12 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
  f39 = Math_fround((f8 > f43 ? f43 : f8) + f39);
  f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 ? i15 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f10);
  f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i18 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
  f39 = Math_fround((f11 > f38 ? f38 : f11) + f39);
  f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19 ? i6 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f10);
  f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5 ? i4 : i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
  f39 = Math_fround((f37 > f35 ? f35 : f37) + f39);
  f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i42 ? i41 : i40, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f36);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ? i3 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
  f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 ? i14 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f36);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i17 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
  f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19 ? i7 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f36);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5 ? i1 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
  f37 = Math_fround(HEAPF32[i25 + 192 >> 2]);
  f10 = Math_fround(f37 * f10);
  f35 = Math_fround(HEAPF32[i25 + 196 >> 2]);
  f34 = Math_fround(f35 * f34);
  f11 = Math_fround(HEAPF32[i25 + 200 >> 2]);
  f36 = Math_fround(f36 * f11);
  f38 = Math_fround(HEAPF32[i25 + 204 >> 2]);
  f10 = Math_fround(Math_fround(f37 + Math_fround(0.0)) + f10);
  f34 = Math_fround(Math_fround(f35 + Math_fround(0.0)) + f34);
  f36 = Math_fround(Math_fround(f11 + Math_fround(1.0)) + f36);
  f38 = Math_fround(Math_fround(f38 + Math_fround(1.0)) + Math_fround(f9 * f38));
  i4 = f10 <= Math_fround(0.0);
  f10 = i4 ? Math_fround(0.0) : f10;
  i4 = f34 <= Math_fround(0.0);
  f34 = i4 ? Math_fround(0.0) : f34;
  i4 = f36 <= Math_fround(0.0);
  f36 = i4 ? Math_fround(0.0) : f36;
  i4 = f38 <= Math_fround(0.0);
  f38 = i4 ? Math_fround(0.0) : f38;
  f9 = Math_fround(HEAPF32[i25 + 208 >> 2]);
  f11 = Math_fround(HEAPF32[i25 + 212 >> 2]);
  f35 = Math_fround(HEAPF32[i25 + 216 >> 2]);
  f37 = Math_fround(HEAPF32[i25 + 220 >> 2]);
  i4 = ~~(f9 <= f10 ? f9 : f10);
  i1 = ~~(f11 <= f34 ? f11 : f34);
  i5 = ~~(f35 <= f36 ? f35 : f36);
  i6 = ~~(f37 <= f38 ? f37 : f38);
  f38 = Math_fround(HEAPF32[i25 + 224 >> 2]);
  f39 = Math_fround(f39 * f38);
  i7 = f39 <= Math_fround(0.0);
  f39 = i7 ? Math_fround(0.0) : f39;
  i7 = ~~(f38 <= f39 ? f38 : f39);
  if (!((i4 | 0) < (i5 | 0) & (i1 | 0) < (i6 | 0))) {
   i42 = 0;
   STACKTOP = i33;
   return i42 | 0;
  }
  while (1) {
   i3 = i1 << 7;
   i2 = i4;
   do {
    if ((i7 | 0) < (HEAPU16[i25 + 240 + (i2 + i3 << 1) >> 1] | 0)) break L18;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i5 | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) {
    i1 = 0;
    break;
   }
  }
  STACKTOP = i33;
  return i1 | 0;
 } while (0);
 i19 = i25 + 34480 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) {
  i42 = 1;
  STACKTOP = i33;
  return i42 | 0;
 }
 L33 : do if ((i1 | 0) > 0) {
  i13 = i31 + 4 | 0;
  i14 = i31 + 8 | 0;
  i15 = i31 + 12 | 0;
  i16 = i32 + 4 | 0;
  i17 = i32 + 8 | 0;
  i18 = i32 + 12 | 0;
  i3 = i28 + 4 | 0;
  i4 = i28 + 8 | 0;
  i5 = i28 + 12 | 0;
  i6 = i29 + 4 | 0;
  i7 = i29 + 8 | 0;
  i12 = i29 + 12 | 0;
  if (i20) {
   i1 = 0;
   do {
    HEAP32[i31 >> 2] = i26;
    HEAP32[i13 >> 2] = i27;
    HEAP32[i14 >> 2] = i22;
    HEAP32[i15 >> 2] = 1065353216;
    HEAP32[i32 >> 2] = i23;
    HEAP32[i16 >> 2] = i24;
    HEAP32[i17 >> 2] = i21;
    HEAP32[i18 >> 2] = 1065353216;
    if (__ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i25 + 34496 + (i1 * 1408 | 0) | 0, i31, i32) | 0) HEAP32[i30 >> 2] = HEAP32[i30 >> 2] | 1 << i1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i19 >> 2] | 0));
  } else {
   i1 = 0;
   do {
    i2 = i25 + 34496 + (i1 * 1408 | 0) | 0;
    HEAP32[i31 >> 2] = i26;
    HEAP32[i13 >> 2] = i27;
    HEAP32[i14 >> 2] = i22;
    HEAP32[i15 >> 2] = 1065353216;
    HEAP32[i32 >> 2] = i23;
    HEAP32[i16 >> 2] = i24;
    HEAP32[i17 >> 2] = i21;
    HEAP32[i18 >> 2] = 1065353216;
    if (__ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i2, i31, i32) | 0) {
     HEAP32[i30 >> 2] = HEAP32[i30 >> 2] | 1 << i1;
     HEAP32[i28 >> 2] = i26;
     HEAP32[i3 >> 2] = i27;
     HEAP32[i4 >> 2] = i22;
     HEAP32[i5 >> 2] = 1065353216;
     HEAP32[i29 >> 2] = i23;
     HEAP32[i6 >> 2] = i24;
     HEAP32[i7 >> 2] = i21;
     HEAP32[i12 >> 2] = 1065353216;
     if (__ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_(i2, 0, i28, i29) | 0) break L33;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i19 >> 2] | 0));
  }
 } while (0);
 i42 = (HEAP32[i30 >> 2] | 0) != 0;
 STACKTOP = i33;
 return i42 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i54, i56, i61, i1, i81, i82, i83, i84, i86, i88, i74) {
 i54 = i54 | 0;
 i56 = i56 | 0;
 i61 = i61 | 0;
 i1 = i1 | 0;
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 i86 = i86 | 0;
 i88 = i88 | 0;
 i74 = i74 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f55 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f75 = f0, f76 = f0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i85 = 0, i87 = 0, i89 = 0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i89 + 288 | 0;
 i68 = i89 + 468 | 0;
 i67 = i89 + 456 | 0;
 i79 = i89 + 304 | 0;
 i77 = i89 + 224 | 0;
 i78 = i89 + 160 | 0;
 i85 = i89 + 440 | 0;
 i87 = i89 + 424 | 0;
 i62 = i89 + 416 | 0;
 i80 = i89 + 144 | 0;
 i27 = i89 + 128 | 0;
 i26 = i89 + 112 | 0;
 i28 = i89 + 404 | 0;
 i29 = i89 + 96 | 0;
 i63 = i89 + 80 | 0;
 i70 = i89 + 64 | 0;
 i71 = i89 + 48 | 0;
 i69 = i89 + 392 | 0;
 i59 = i89 + 32 | 0;
 i58 = i89 + 380 | 0;
 i65 = i89 + 16 | 0;
 i66 = i89;
 i64 = i89 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f75 = Math_fround(HEAPF32[i54 + 16 >> 2]);
 i60 = i56 + 16 | 0;
 f76 = Math_fround(HEAPF32[i60 >> 2]);
 f55 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i54 + 32 >> 2]);
 f73 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f57 = Math_fround((f57 > f73 ? f73 : f57) * Math_fround(.100000001));
 f57 = Math_fround(f57 * f57);
 f73 = Math_fround(f75 + f76);
 HEAP32[i62 >> 2] = 0;
 i1 = HEAP8[i74 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i61 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 56 >> 2]);
  i53 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i53 ? f5 : Math_fround(1.0);
  f6 = i53 ? f6 : Math_fround(0.0);
  f7 = i53 ? f7 : Math_fround(0.0);
  HEAPF32[i80 >> 2] = f5;
  HEAPF32[i80 + 4 >> 2] = f6;
  HEAPF32[i80 + 8 >> 2] = f7;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i29 >> 2] = HEAP32[i80 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i80 + 12 >> 2];
  i53 = i80;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i72 = 7;
 } else {
  HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i61 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i61 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i61 >> 2]);
  f9 = Math_fround(HEAPF32[i61 + 16 >> 2]);
  f10 = Math_fround(HEAPF32[i61 + 32 >> 2]);
  f11 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i61 + 20 >> 2]);
  f13 = Math_fround(HEAPF32[i61 + 36 >> 2]);
  f14 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i61 + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i61 + 40 >> 2]);
  f17 = Math_fround(HEAPF32[i56 + 144 >> 2]);
  f18 = Math_fround(HEAPF32[i56 + 148 >> 2]);
  f17 = Math_fround(f17 - f76);
  f18 = Math_fround(f18 - f76);
  f19 = Math_fround(Math_fround(HEAPF32[i56 + 152 >> 2]) - f76);
  f20 = Math_fround(-f17);
  f21 = Math_fround(-f18);
  f22 = Math_fround(-f19);
  i23 = i27 + 4 | 0;
  i24 = i27 + 8 | 0;
  i25 = i27 + 12 | 0;
  i2 = i1 & 255;
  i8 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i52 = HEAPU8[i86 + i3 >> 0] | 0;
   HEAP32[i85 + (i3 << 2) >> 2] = i52;
   i53 = HEAPU8[i88 + i3 >> 0] | 0;
   HEAP32[i87 + (i3 << 2) >> 2] = i53;
   f91 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) >> 2]);
   f92 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) + 4 >> 2]);
   f93 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) + 8 >> 2]);
   f95 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f91 * f7) + Math_fround(f92 * f9)) + Math_fround(f93 * f10)));
   f94 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f91 * f11) + Math_fround(f92 * f12)) + Math_fround(f93 * f13)));
   f93 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f91 * f14) + Math_fround(f92 * f15)) + Math_fround(f93 * f16)));
   f92 = HEAP32[gb + 48 + (i53 << 4) >> 2] | 0 ? f17 : f20;
   f91 = HEAP32[gb + 48 + (i53 << 4) + 4 >> 2] | 0 ? f18 : f21;
   f90 = HEAP32[gb + 48 + (i53 << 4) + 8 >> 2] | 0 ? f19 : f22;
   f97 = Math_fround(f94 - f91);
   f96 = Math_fround(f93 - f90);
   HEAPF32[i27 >> 2] = Math_fround(f95 - f92);
   HEAPF32[i23 >> 2] = f97;
   HEAPF32[i24 >> 2] = f96;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   HEAPF32[i77 + (i1 << 4) >> 2] = f95;
   HEAPF32[i77 + (i1 << 4) + 4 >> 2] = f94;
   HEAPF32[i77 + (i1 << 4) + 8 >> 2] = f93;
   HEAPF32[i77 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i78 + (i1 << 4) >> 2] = f92;
   HEAPF32[i78 + (i1 << 4) + 4 >> 2] = f91;
   HEAPF32[i78 + (i1 << 4) + 8 >> 2] = f90;
   HEAPF32[i78 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i53 = i79 + (i1 << 4) | 0;
   HEAP32[i53 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i62 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i26, i79, i77, i78, i85, i87, i27, i62);
  HEAP32[i80 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i80 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i80 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i80 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i80 >> 2]);
  f6 = Math_fround(HEAPF32[i80 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i80 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i68 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i67 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i80 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i80 + 12 >> 2];
  if (f4 > f57) {
   i53 = i80;
   i72 = 7;
  } else i2 = HEAP32[i62 >> 2] | 0;
 }
 do if ((i72 | 0) == 7) {
  i51 = i80 + 4 | 0;
  i52 = i80 + 8 | 0;
  i24 = i61 + 4 | 0;
  i25 = i61 + 8 | 0;
  i26 = i61 + 16 | 0;
  i27 = i61 + 20 | 0;
  i28 = i61 + 24 | 0;
  i30 = i61 + 32 | 0;
  i31 = i61 + 36 | 0;
  i32 = i61 + 40 | 0;
  i33 = i54 + 96 | 0;
  i34 = i54 + 100 | 0;
  i35 = i54 + 104 | 0;
  i36 = i54 + 112 | 0;
  i37 = i54 + 116 | 0;
  i38 = i54 + 120 | 0;
  i39 = i54 + 128 | 0;
  i40 = i54 + 132 | 0;
  i41 = i54 + 136 | 0;
  i42 = i61 + 48 | 0;
  i43 = i61 + 52 | 0;
  i44 = i61 + 56 | 0;
  i45 = i56 + 144 | 0;
  i46 = i56 + 148 | 0;
  i47 = i56 + 152 | 0;
  i48 = i63 + 4 | 0;
  i49 = i63 + 8 | 0;
  i50 = i63 + 12 | 0;
  i23 = i54 + 48 | 0;
  i8 = i56 + 48 | 0;
  f10 = f55;
  while (1) {
   HEAP32[i67 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i29 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i29 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   HEAP32[i29 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
   f90 = Math_fround(-f5);
   f14 = Math_fround(-f6);
   f13 = Math_fround(-f7);
   i3 = HEAP32[i62 >> 2] | 0;
   f97 = Math_fround(HEAPF32[i61 >> 2]);
   f7 = Math_fround(f97 * f90);
   f95 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f95 * f14));
   f22 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f22 * f13));
   f55 = Math_fround(HEAPF32[i26 >> 2]);
   f9 = Math_fround(f55 * f90);
   f96 = Math_fround(HEAPF32[i27 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f96 * f14));
   f21 = Math_fround(HEAPF32[i28 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f21 * f13));
   f19 = Math_fround(HEAPF32[i30 >> 2]);
   f90 = Math_fround(f19 * f90);
   f92 = Math_fround(HEAPF32[i31 >> 2]);
   f14 = Math_fround(f90 + Math_fround(f92 * f14));
   f90 = Math_fround(HEAPF32[i32 >> 2]);
   f13 = Math_fround(f14 + Math_fround(f90 * f13));
   f14 = Math_fround(HEAPF32[i33 >> 2]);
   f16 = Math_fround(HEAPF32[i34 >> 2]);
   f94 = Math_fround(HEAPF32[i35 >> 2]);
   f15 = Math_fround(HEAPF32[i36 >> 2]);
   f17 = Math_fround(HEAPF32[i37 >> 2]);
   f18 = Math_fround(HEAPF32[i38 >> 2]);
   f93 = Math_fround(HEAPF32[i39 >> 2]);
   f91 = Math_fround(HEAPF32[i40 >> 2]);
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(f7 * f14) + Math_fround(f9 * f16)) + Math_fround(f13 * f94));
   f12 = Math_fround(Math_fround(Math_fround(f7 * f15) + Math_fround(f9 * f17)) + Math_fround(f13 * f18));
   f13 = Math_fround(Math_fround(Math_fround(f7 * f93) + Math_fround(f9 * f91)) + Math_fround(f13 * f20));
   i56 = f11 > f12 & f11 > f13;
   i54 = f12 > f13;
   HEAP32[i85 + (i3 << 2) >> 2] = i56 ? 0 : i54 ? 1 : 2;
   f93 = i56 ? f14 : i54 ? f15 : f93;
   f91 = i56 ? f16 : i54 ? f17 : f91;
   f20 = i56 ? f94 : i54 ? f18 : f20;
   f18 = Math_fround(HEAPF32[i42 >> 2]);
   f94 = Math_fround(HEAPF32[i43 >> 2]);
   f55 = Math_fround(f18 + Math_fround(Math_fround(f19 * f20) + Math_fround(Math_fround(f93 * f97) + Math_fround(f91 * f55))));
   f96 = Math_fround(f94 + Math_fround(Math_fround(f92 * f20) + Math_fround(Math_fround(f93 * f95) + Math_fround(f91 * f96))));
   f90 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) + Math_fround(Math_fround(Math_fround(f93 * f22) + Math_fround(f91 * f21)) + Math_fround(f20 * f90)));
   HEAPF32[i77 + (i3 << 4) >> 2] = f55;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f96;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f90;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f20 = Math_fround(HEAPF32[i45 >> 2]);
   f21 = Math_fround(HEAPF32[i46 >> 2]);
   f91 = Math_fround(HEAPF32[i47 >> 2]);
   f22 = Math_fround(HEAPF32[i60 >> 2]);
   f20 = Math_fround(f20 - f22);
   f21 = Math_fround(f21 - f22);
   f22 = Math_fround(f91 - f22);
   f91 = Math_fround(HEAPF32[i80 >> 2]);
   f93 = Math_fround(HEAPF32[i51 >> 2]);
   f95 = Math_fround(HEAPF32[i52 >> 2]);
   i54 = f91 > Math_fround(0.0);
   i56 = f93 > Math_fround(0.0);
   i2 = f95 > Math_fround(0.0);
   HEAP32[i87 + (i3 << 2) >> 2] = i56 << 31 >> 31 << 1 & 2 | i54 & 1 | i2 << 31 >> 31 << 2 & 4;
   f92 = Math_fround(-f20);
   f94 = Math_fround(-f21);
   f97 = Math_fround(-f22);
   f92 = i54 ? f20 : f92;
   f94 = i56 ? f21 : f94;
   f97 = i2 ? f22 : f97;
   HEAPF32[i78 + (i3 << 4) >> 2] = f92;
   HEAPF32[i78 + (i3 << 4) + 4 >> 2] = f94;
   HEAPF32[i78 + (i3 << 4) + 8 >> 2] = f97;
   HEAPF32[i78 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f92 = Math_fround(f55 - f92);
   f94 = Math_fround(f96 - f94);
   f97 = Math_fround(f90 - f97);
   HEAPF32[i63 >> 2] = f92;
   HEAPF32[i48 >> 2] = f94;
   HEAPF32[i49 >> 2] = f97;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i62 >> 2] | 0;
   i2 = i79 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i63 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
   f90 = Math_fround(HEAPF32[i23 >> 2]);
   f96 = Math_fround(HEAPF32[i8 >> 2]);
   f96 = f90 > f96 ? f90 : f96;
   f10 = f10 > f96 ? f10 : f96;
   f96 = Math_fround(f73 + f10);
   f97 = Math_fround(Math_fround(Math_fround(f91 * f92) + Math_fround(f93 * f94)) + Math_fround(f95 * f97));
   i2 = f97 > Math_fround(0.0) ? Math_fround(f97 * f97) > Math_fround(f4 * Math_fround(f96 * f96)) : 0;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f97) | i2) {
    i72 = 9;
    break;
   }
   HEAP32[i62 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i59, i79, i77, i78, i85, i87, i63, i62);
   HEAP32[i53 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i80 >> 2]);
   f6 = Math_fround(HEAPF32[i51 >> 2]);
   f7 = Math_fround(HEAPF32[i52 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i68 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i68 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i68 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   i1 = f4 > f9;
   if (!(f9 > f57 & i1)) break; else f4 = f9;
  }
  if ((i72 | 0) == 9) {
   if (i86 | 0) {
    HEAP8[i74 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
      HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i88 = 0;
    STACKTOP = i89;
    return i88 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i79, i77, i78, i80, i70, i71, i3);
   f94 = Math_fround(Math_sqrt(Math_fround(f4)));
   f95 = Math_fround(HEAPF32[i80 >> 2]);
   f96 = Math_fround(HEAPF32[i51 >> 2]);
   f97 = Math_fround(Math_fround(1.0) / f94);
   f95 = Math_fround(f95 * f97);
   f96 = Math_fround(f96 * f97);
   f97 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f97);
   f93 = Math_fround(HEAPF32[i70 >> 2]);
   f92 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f92 = Math_fround(f92 - Math_fround(f75 * f96));
   f91 = Math_fround(Math_fround(HEAPF32[i70 + 8 >> 2]) - Math_fround(f75 * f97));
   HEAPF32[i81 >> 2] = Math_fround(f93 - Math_fround(f75 * f95));
   HEAPF32[i81 + 4 >> 2] = f92;
   HEAPF32[i81 + 8 >> 2] = f91;
   HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
   f91 = Math_fround(HEAPF32[i71 >> 2]);
   f92 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f92 = Math_fround(Math_fround(f76 * f96) + f92);
   f93 = Math_fround(Math_fround(f76 * f97) + Math_fround(HEAPF32[i71 + 8 >> 2]));
   HEAPF32[i82 >> 2] = Math_fround(Math_fround(f76 * f95) + f91);
   HEAPF32[i82 + 4 >> 2] = f92;
   HEAPF32[i82 + 8 >> 2] = f93;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i84 >> 2] = Math_fround(f94 - f73);
   i88 = i84 + 4 | 0;
   HEAP32[i88 >> 2] = HEAP32[i69 >> 2];
   HEAP32[i88 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
   HEAP32[i88 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
   HEAPF32[i83 >> 2] = f95;
   HEAPF32[i83 + 4 >> 2] = f96;
   HEAPF32[i83 + 8 >> 2] = f97;
   HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
   i88 = 1;
   STACKTOP = i89;
   return i88 | 0;
  }
  i2 = HEAP32[i62 >> 2] | 0;
  if (i1) {
   if (!i86) i1 = 6; else break;
   STACKTOP = i89;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i86 | 0) {
   HEAP8[i74 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
     HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i53 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i79, i77, i78, i80, i65, i66, i2);
  HEAP32[i68 >> 2] = HEAP32[i67 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
  f94 = Math_fround(Math_sqrt(Math_fround(f4)));
  f95 = Math_fround(HEAPF32[i80 >> 2]);
  f96 = Math_fround(HEAPF32[i80 + 4 >> 2]);
  f97 = Math_fround(Math_fround(1.0) / f94);
  f95 = Math_fround(f95 * f97);
  f96 = Math_fround(f96 * f97);
  f97 = Math_fround(Math_fround(HEAPF32[i80 + 8 >> 2]) * f97);
  f93 = Math_fround(HEAPF32[i65 >> 2]);
  f92 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f92 = Math_fround(f92 - Math_fround(f75 * f96));
  f91 = Math_fround(Math_fround(HEAPF32[i65 + 8 >> 2]) - Math_fround(f75 * f97));
  HEAPF32[i81 >> 2] = Math_fround(f93 - Math_fround(f75 * f95));
  HEAPF32[i81 + 4 >> 2] = f92;
  HEAPF32[i81 + 8 >> 2] = f91;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  f91 = Math_fround(HEAPF32[i66 >> 2]);
  f92 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f92 = Math_fround(Math_fround(f76 * f96) + f92);
  f93 = Math_fround(Math_fround(f76 * f97) + Math_fround(HEAPF32[i66 + 8 >> 2]));
  HEAPF32[i82 >> 2] = Math_fround(Math_fround(f76 * f95) + f91);
  HEAPF32[i82 + 4 >> 2] = f92;
  HEAPF32[i82 + 8 >> 2] = f93;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i84 >> 2] = Math_fround(f94 - f73);
  i88 = i84 + 4 | 0;
  HEAP32[i88 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i88 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i88 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAPF32[i83 >> 2] = f95;
  HEAPF32[i83 + 4 >> 2] = f96;
  HEAPF32[i83 + 8 >> 2] = f97;
  HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
  i88 = 3;
  STACKTOP = i89;
  return i88 | 0;
 } while (0);
 HEAP8[i74 >> 0] = i2;
 if (!i2) {
  i88 = 6;
  STACKTOP = i89;
  return i88 | 0;
 } else i1 = 0;
 do {
  HEAP8[i86 + i1 >> 0] = HEAP32[i85 + (i1 << 2) >> 2];
  HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i89;
 return i1 | 0;
}

function __ZN5Unity17ConfigurableJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 348 | 0, gb + 734938 | 0, 0);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734954 | 0, i5, i1 + 96 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734964 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734974 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734984 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735001 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735018 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 120 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735049 | 0, gb + 734772 | 0, i5, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i6, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735035 | 0, gb + 734793 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i6, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 140 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735108 | 0, gb + 734772 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i6, i1 + 144 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 148 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735069 | 0, gb + 734793 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i6, i1 + 152 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i6, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 160 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735088 | 0, gb + 734793 | 0, i6, 0);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 168 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 172 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735162 | 0, gb + 734772 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i5, i1 + 176 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 180 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735130 | 0, gb + 734793 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 188 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 192 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735146 | 0, gb + 734793 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 196 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 296 | 0, gb + 735185 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 324 | 0, gb + 735202 | 0, 0);
 i5 = i1 + 204 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735219 | 0, gb + 735408 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i6, i1 + 208 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i6, i1 + 212 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 216 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735228 | 0, gb + 735408 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i6, i1 + 220 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i6, i1 + 224 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 228 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735237 | 0, gb + 735408 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i6, i1 + 232 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i6, i1 + 236 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 308 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735246 | 0, HEAP32[gb + 37208 >> 2] | 0, i6, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 336 | 0, gb + 735263 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735287 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 252 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735307 | 0, gb + 735408 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i5, i1 + 256 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i5, i1 + 260 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 240 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735323 | 0, gb + 735408 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i5, i1 + 244 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i5, i1 + 248 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 264 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735340 | 0, gb + 735408 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735419 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735434 | 0, i5, i1 + 268 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735449 | 0, i5, i1 + 272 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735353 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734874 | 0, i5, i1 + 280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734895 | 0, i5, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735370 | 0, i5, i1 + 292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 735395 | 0, i5, i1 + 293 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i66, i67, i1, i68, i69, i63, i71, i52, i54, i46, i70) {
 i66 = i66 | 0;
 i67 = i67 | 0;
 i1 = i1 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i63 = i63 | 0;
 i71 = i71 | 0;
 i52 = i52 | 0;
 i54 = i54 | 0;
 i46 = i46 | 0;
 i70 = i70 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f64 = f0, f65 = f0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i72 + 492 | 0;
 i43 = i72 + 480 | 0;
 i62 = i72 + 160 | 0;
 i61 = i72 + 304 | 0;
 i59 = i72 + 240 | 0;
 i60 = i72 + 176 | 0;
 i51 = i72 + 464 | 0;
 i53 = i72 + 448 | 0;
 i42 = i72 + 144 | 0;
 i41 = i72 + 440 | 0;
 i16 = i72 + 128 | 0;
 i17 = i72 + 112 | 0;
 i18 = i72 + 428 | 0;
 i19 = i72 + 96 | 0;
 i39 = i72 + 80 | 0;
 i55 = i72 + 64 | 0;
 i58 = i72 + 48 | 0;
 i56 = i72 + 416 | 0;
 i57 = i72 + 404 | 0;
 i40 = i72 + 32 | 0;
 i38 = i72 + 392 | 0;
 i47 = i72 + 16 | 0;
 i50 = i72;
 i49 = i72 + 380 | 0;
 i48 = i72 + 368 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f64 = Math_fround(HEAPF32[i66 + 16 >> 2]);
 f65 = Math_fround(HEAPF32[i67 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i66 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i67 + 32 >> 2]);
 f34 = Math_fround((f34 > f3 ? f3 : f34) * Math_fround(.100000001));
 f34 = Math_fround(f34 * f34);
 f3 = Math_fround(f64 + f65);
 i35 = i42 + 4 | 0;
 i36 = i42 + 8 | 0;
 i37 = i42 + 12 | 0;
 HEAP32[i42 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 HEAP32[i42 + 12 >> 2] = 0;
 HEAP32[i41 >> 2] = 0;
 if (!(HEAP8[i46 >> 0] | 0)) {
  f32 = Math_fround(HEAPF32[i66 >> 2]);
  f4 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i66 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i67 >> 2]);
  f6 = Math_fround(HEAPF32[i67 + 4 >> 2]);
  f5 = Math_fround(f32 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i67 + 8 >> 2]));
  i33 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i33 ? f5 : Math_fround(1.0);
  f6 = i33 ? f6 : Math_fround(0.0);
  f7 = i33 ? f7 : Math_fround(0.0);
  HEAPF32[i62 >> 2] = f5;
  HEAPF32[i62 + 4 >> 2] = f6;
  HEAPF32[i62 + 8 >> 2] = f7;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i19 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
  i33 = i62;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i45 = 6;
 } else {
  i1 = i66 + 96 | 0;
  i2 = i67 + 16 | 0;
  i11 = i16 + 4 | 0;
  i13 = i16 + 8 | 0;
  i14 = i16 + 12 | 0;
  i15 = 0;
  do {
   i30 = HEAPU8[i52 + i15 >> 0] | 0;
   HEAP32[i51 + (i15 << 2) >> 2] = i30;
   i31 = HEAPU8[i54 + i15 >> 0] | 0;
   HEAP32[i53 + (i15 << 2) >> 2] = i31;
   i30 = 1 - i30 | 0;
   f6 = Math_fround(HEAPF32[i1 + (i30 << 4) >> 2]);
   f7 = Math_fround(HEAPF32[i1 + (i30 << 4) + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i1 + (i30 << 4) + 8 >> 2]);
   i30 = HEAP32[i1 + (i30 << 4) + 12 >> 2] | 0;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i16, i67, i31, i2);
   f10 = Math_fround(HEAPF32[i16 >> 2]);
   f12 = Math_fround(HEAPF32[i11 >> 2]);
   f32 = Math_fround(HEAPF32[i13 >> 2]);
   i31 = HEAP32[i14 >> 2] | 0;
   f4 = Math_fround(f7 - f12);
   f5 = Math_fround(f9 - f32);
   HEAPF32[i42 >> 2] = Math_fround(f6 - f10);
   HEAPF32[i35 >> 2] = f4;
   HEAPF32[i36 >> 2] = f5;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i33 = HEAP32[i41 >> 2] | 0;
   HEAPF32[i59 + (i33 << 4) >> 2] = f6;
   HEAPF32[i59 + (i33 << 4) + 4 >> 2] = f7;
   HEAPF32[i59 + (i33 << 4) + 8 >> 2] = f9;
   HEAP32[i59 + (i33 << 4) + 12 >> 2] = i30;
   HEAPF32[i60 + (i33 << 4) >> 2] = f10;
   HEAPF32[i60 + (i33 << 4) + 4 >> 2] = f12;
   HEAPF32[i60 + (i33 << 4) + 8 >> 2] = f32;
   HEAP32[i60 + (i33 << 4) + 12 >> 2] = i31;
   HEAP32[i41 >> 2] = i33 + 1;
   i33 = i61 + (i33 << 4) | 0;
   HEAP32[i33 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < (HEAPU8[i46 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i17, i61, i59, i60, i51, i53, i42, i41);
  HEAP32[i62 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i62 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i62 >> 2]);
  f6 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i62 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i44 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i43 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
  if (f4 > f34) {
   i33 = i62;
   i45 = 6;
  }
 }
 do if ((i45 | 0) == 6) {
  i15 = i62 + 4 | 0;
  i16 = i62 + 8 | 0;
  i17 = i66 + 96 | 0;
  i18 = i66 + 100 | 0;
  i20 = i66 + 104 | 0;
  i21 = i66 + 112 | 0;
  i22 = i66 + 116 | 0;
  i23 = i66 + 120 | 0;
  i24 = i67 + 196 | 0;
  i25 = i67 + 200 | 0;
  i26 = i67 + 204 | 0;
  i27 = i67 + 16 | 0;
  i28 = i39 + 4 | 0;
  i29 = i39 + 8 | 0;
  i30 = i66 + 48 | 0;
  i31 = i67 + 48 | 0;
  f12 = f8;
  f32 = f4;
  while (1) {
   HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f77 = Math_fround(-f5);
   f76 = Math_fround(-f6);
   f75 = Math_fround(-f7);
   i14 = HEAP32[i41 >> 2] | 0;
   f74 = Math_fround(HEAPF32[i17 >> 2]);
   f73 = Math_fround(HEAPF32[i18 >> 2]);
   f4 = Math_fround(HEAPF32[i20 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f74 * f77) + Math_fround(f73 * f76)) + Math_fround(f4 * f75));
   f8 = Math_fround(HEAPF32[i21 >> 2]);
   f9 = Math_fround(HEAPF32[i22 >> 2]);
   f10 = Math_fround(HEAPF32[i23 >> 2]);
   i13 = f78 > Math_fround(Math_fround(Math_fround(f8 * f77) + Math_fround(f9 * f76)) + Math_fround(f10 * f75));
   HEAP32[i51 + (i14 << 2) >> 2] = i13 & 1;
   f8 = i13 ? f74 : f8;
   f9 = i13 ? f73 : f9;
   f10 = i13 ? f4 : f10;
   HEAPF32[i59 + (i14 << 4) >> 2] = f8;
   HEAPF32[i59 + (i14 << 4) + 4 >> 2] = f9;
   HEAPF32[i59 + (i14 << 4) + 8 >> 2] = f10;
   HEAPF32[i59 + (i14 << 4) + 12 >> 2] = Math_fround(0.0);
   i13 = i60 + (i14 << 4) | 0;
   i14 = i53 + (i14 << 2) | 0;
   if (!(HEAP32[i24 >> 2] | 0)) {
    i1 = HEAP32[i25 >> 2] | 0;
    if ((HEAPU8[i26 >> 0] | 0) > 1) {
     f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f5);
     f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f6));
     f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f7));
     i2 = 1;
     i1 = 0;
     while (1) {
      i11 = HEAP32[i25 >> 2] | 0;
      f75 = Math_fround(HEAPF32[i11 + (i2 * 12 | 0) >> 2]);
      f77 = Math_fround(HEAPF32[i11 + (i2 * 12 | 0) + 4 >> 2]);
      f4 = Math_fround(HEAPF32[i11 + (i2 * 12 | 0) + 8 >> 2]);
      f76 = Math_fround(HEAPF32[i62 >> 2]);
      f78 = Math_fround(HEAPF32[i15 >> 2]);
      f4 = Math_fround(Math_fround(Math_fround(f75 * f76) + Math_fround(f77 * f78)) + Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2])));
      i11 = f4 > f5;
      i1 = i11 ? i2 : i1;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i26 >> 0] | 0) >>> 0) f5 = i11 ? f4 : f5; else break;
     }
    } else i1 = 0;
   } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i67, i62) | 0;
   HEAP32[i14 >> 2] = i1;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i39, i67, i1, i27);
   HEAP32[i13 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   f75 = Math_fround(HEAPF32[i39 >> 2]);
   f76 = Math_fround(HEAPF32[i28 >> 2]);
   f75 = Math_fround(f8 - f75);
   f76 = Math_fround(f9 - f76);
   f78 = Math_fround(f10 - Math_fround(HEAPF32[i29 >> 2]));
   HEAPF32[i42 >> 2] = f75;
   HEAPF32[i35 >> 2] = f76;
   HEAPF32[i36 >> 2] = f78;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i41 >> 2] | 0;
   i11 = i61 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i30 >> 2]);
   f77 = Math_fround(HEAPF32[i31 >> 2]);
   f77 = f4 > f77 ? f4 : f77;
   f12 = f12 > f77 ? f12 : f77;
   f77 = Math_fround(f3 + f12);
   f77 = Math_fround(f32 * Math_fround(f77 * f77));
   f4 = Math_fround(HEAPF32[i62 >> 2]);
   f5 = Math_fround(HEAPF32[i15 >> 2]);
   f6 = Math_fround(HEAPF32[i16 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f4 * f75) + Math_fround(f5 * f76)) + Math_fround(f6 * f78));
   i11 = f78 > Math_fround(0.0) & Math_fround(f78 * f78) > f77;
   if (Math_fround(f32 * Math_fround(.00039999999)) >= Math_fround(f32 - f78) | i11) {
    f7 = f32;
    i45 = 13;
    break;
   }
   HEAP32[i41 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i40, i61, i59, i60, i51, i53, i42, i41);
   HEAP32[i33 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i62 >> 2]);
   f6 = Math_fround(HEAPF32[i15 >> 2]);
   f7 = Math_fround(HEAPF32[i16 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i44 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i44 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i44 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   i1 = f32 > f4;
   if (!(f4 > f34 & i1)) break; else f32 = f4;
  }
  if ((i45 | 0) == 13) {
   i2 = i13 + -1 | 0;
   if (i52 | 0) {
    HEAP8[i46 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
      HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i71 = 0;
    STACKTOP = i72;
    return i71 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i63 >> 2] = f9;
   HEAPF32[i63 + 4 >> 2] = f8;
   HEAPF32[i63 + 8 >> 2] = f7;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i61, i59, i60, i62, i55, i58, i13);
   f5 = Math_fround(HEAPF32[i55 >> 2]);
   f6 = Math_fround(HEAPF32[i55 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i55 + 8 >> 2]);
   if (i70) {
    f77 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
    f74 = HEAP32[i67 + 64 >> 2] | 0 ? Math_fround(0.0) : f65;
    f78 = Math_fround(f77 + f74);
    f76 = Math_fround(f6 - Math_fround(f8 * f77));
    f75 = Math_fround(f4 - Math_fround(f7 * f77));
    HEAPF32[i68 >> 2] = Math_fround(f5 - Math_fround(f9 * f77));
    HEAPF32[i68 + 4 >> 2] = f76;
    HEAPF32[i68 + 8 >> 2] = f75;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    f75 = Math_fround(HEAPF32[i58 >> 2]);
    f76 = Math_fround(HEAPF32[i58 + 4 >> 2]);
    f76 = Math_fround(Math_fround(f8 * f74) + f76);
    f77 = Math_fround(Math_fround(f7 * f74) + Math_fround(HEAPF32[i58 + 8 >> 2]));
    HEAPF32[i69 >> 2] = Math_fround(Math_fround(f9 * f74) + f75);
    HEAPF32[i69 + 4 >> 2] = f76;
    HEAPF32[i69 + 8 >> 2] = f77;
    HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i71 >> 2] = Math_fround(f10 - f78);
    i71 = i71 + 4 | 0;
    HEAP32[i71 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i71 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
    HEAP32[i71 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
    i71 = 1;
    STACKTOP = i72;
    return i71 | 0;
   } else {
    f77 = Math_fround(f6 - Math_fround(f64 * f8));
    f76 = Math_fround(f4 - Math_fround(f64 * f7));
    HEAPF32[i68 >> 2] = Math_fround(f5 - Math_fround(f64 * f9));
    HEAPF32[i68 + 4 >> 2] = f77;
    HEAPF32[i68 + 8 >> 2] = f76;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    f76 = Math_fround(HEAPF32[i58 >> 2]);
    f77 = Math_fround(HEAPF32[i58 + 4 >> 2]);
    f77 = Math_fround(Math_fround(f65 * f8) + f77);
    f78 = Math_fround(Math_fround(f65 * f7) + Math_fround(HEAPF32[i58 + 8 >> 2]));
    HEAPF32[i69 >> 2] = Math_fround(Math_fround(f65 * f9) + f76);
    HEAPF32[i69 + 4 >> 2] = f77;
    HEAPF32[i69 + 8 >> 2] = f78;
    HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i71 >> 2] = Math_fround(f10 - f3);
    i71 = i71 + 4 | 0;
    HEAP32[i71 >> 2] = HEAP32[i57 >> 2];
    HEAP32[i71 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
    HEAP32[i71 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
    i71 = 1;
    STACKTOP = i72;
    return i71 | 0;
   }
  }
  if (i1) {
   if (!i52) i1 = 6; else break;
   STACKTOP = i72;
   return i1 | 0;
  };
  HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  i11 = HEAP32[i41 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i52 | 0) {
   HEAP8[i46 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
     HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f12);
  f12 = Math_fround(f12 * f12);
  HEAP32[i33 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i61, i59, i60, i62, i47, i50, i11);
  HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f32)));
  f9 = Math_fround(HEAPF32[i62 >> 2]);
  f10 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i62 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i47 >> 2]);
  f6 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  if (i70) {
   f78 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
   f75 = HEAP32[i67 + 64 >> 2] | 0 ? Math_fround(0.0) : f65;
   f3 = Math_fround(f78 + f75);
   f77 = Math_fround(f6 - Math_fround(f10 * f78));
   f76 = Math_fround(f4 - Math_fround(f7 * f78));
   HEAPF32[i68 >> 2] = Math_fround(f5 - Math_fround(f9 * f78));
   HEAPF32[i68 + 4 >> 2] = f77;
   HEAPF32[i68 + 8 >> 2] = f76;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   f76 = Math_fround(HEAPF32[i50 >> 2]);
   f77 = Math_fround(HEAPF32[i50 + 4 >> 2]);
   f77 = Math_fround(Math_fround(f10 * f75) + f77);
   f78 = Math_fround(Math_fround(f7 * f75) + Math_fround(HEAPF32[i50 + 8 >> 2]));
   HEAPF32[i69 >> 2] = Math_fround(Math_fround(f9 * f75) + f76);
   HEAPF32[i69 + 4 >> 2] = f77;
   HEAPF32[i69 + 8 >> 2] = f78;
   HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
   i70 = i71 + 4 | 0;
   HEAP32[i70 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i70 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i70 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  } else {
   f77 = Math_fround(f6 - Math_fround(f64 * f10));
   f76 = Math_fround(f4 - Math_fround(f64 * f7));
   HEAPF32[i68 >> 2] = Math_fround(f5 - Math_fround(f64 * f9));
   HEAPF32[i68 + 4 >> 2] = f77;
   HEAPF32[i68 + 8 >> 2] = f76;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   f76 = Math_fround(HEAPF32[i50 >> 2]);
   f77 = Math_fround(HEAPF32[i50 + 4 >> 2]);
   f77 = Math_fround(Math_fround(f65 * f10) + f77);
   f78 = Math_fround(Math_fround(f65 * f7) + Math_fround(HEAPF32[i50 + 8 >> 2]));
   HEAPF32[i69 >> 2] = Math_fround(Math_fround(f65 * f9) + f76);
   HEAPF32[i69 + 4 >> 2] = f77;
   HEAPF32[i69 + 8 >> 2] = f78;
   HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
   i70 = i71 + 4 | 0;
   HEAP32[i70 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i70 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i70 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  }
  HEAPF32[i71 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i63 >> 2] = f9;
  HEAPF32[i63 + 4 >> 2] = f10;
  HEAPF32[i63 + 8 >> 2] = f7;
  HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
  i71 = f12 >= f32 ? 1 : 3;
  STACKTOP = i72;
  return i71 | 0;
 } while (0);
 i2 = HEAP32[i41 >> 2] | 0;
 HEAP8[i46 >> 0] = i2;
 if (!i2) {
  i71 = 6;
  STACKTOP = i72;
  return i71 | 0;
 } else i1 = 0;
 do {
  HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
  HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i72;
 return i1 | 0;
}

function __ZN5physx2Gu21pcmContactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i22, i23, i24, i25, i21, i1, i38) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i38 = i38 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 3792 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i40 + 352 | 0;
 i36 = i40 + 336 | 0;
 i28 = i40 + 320 | 0;
 i37 = i40 + 224 | 0;
 i39 = i40 + 48 | 0;
 i7 = i40 + 256 | 0;
 i33 = i40 + 32 | 0;
 i8 = i40 + 16 | 0;
 i9 = i40;
 i30 = i40 + 3720 | 0;
 i27 = i40 + 80 | 0;
 i32 = i40 + 3628 | 0;
 i31 = i40 + 3656 | 0;
 i29 = i40 + 3616 | 0;
 i34 = HEAP32[i1 >> 2] & -16;
 i11 = i22 + 4 | 0;
 HEAP32[i36 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i28 >> 2] = HEAP32[i21 >> 2];
 i6 = HEAP32[i24 + 4 >> 2] | 0;
 i5 = HEAP32[i24 + 8 >> 2] | 0;
 i58 = HEAP32[i24 + 12 >> 2] | 0;
 i10 = i24 + 16 | 0;
 i54 = HEAP32[i10 >> 2] | 0;
 i53 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i37 >> 2] = HEAP32[i24 >> 2];
 i17 = i37 + 4 | 0;
 HEAP32[i17 >> 2] = i6;
 i6 = i37 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i37 + 12 | 0;
 HEAP32[i5 >> 2] = i58;
 HEAP32[i37 + 16 >> 2] = i54;
 HEAP32[i37 + 20 >> 2] = i53;
 HEAP32[i37 + 24 >> 2] = i1;
 HEAPF32[i37 + 28 >> 2] = Math_fround(0.0);
 i58 = HEAP32[i25 >> 2] | 0;
 i57 = HEAP32[i25 + 4 >> 2] | 0;
 i56 = HEAP32[i25 + 8 >> 2] | 0;
 i55 = HEAP32[i25 + 12 >> 2] | 0;
 i12 = i25 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i12 + 8 >> 2] | 0;
 HEAP32[i39 >> 2] = i58;
 HEAP32[i39 + 4 >> 2] = i57;
 HEAP32[i39 + 8 >> 2] = i56;
 HEAP32[i39 + 12 >> 2] = i55;
 HEAP32[i39 + 16 >> 2] = i2;
 HEAP32[i39 + 20 >> 2] = i3;
 HEAP32[i39 + 24 >> 2] = i4;
 HEAPF32[i39 + 28 >> 2] = Math_fround(0.0);
 f45 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = Math_fround(-f45);
 f50 = Math_fround(-f50);
 f16 = Math_fround(-f16);
 f20 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = Math_fround(f20 - f49);
 f52 = Math_fround(f41 - f52);
 f43 = Math_fround(f43 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f41 = Math_fround(Math_fround(f46 * f46) + Math_fround(-.5));
 f20 = Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(f52 * f50)) + Math_fround(f43 * f16));
 f18 = Math_fround(Math_fround(Math_fround(f20 * f45) + Math_fround(Math_fround(f41 * f49) + Math_fround(f46 * Math_fround(Math_fround(f43 * f50) - Math_fround(f52 * f16))))) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(Math_fround(f20 * f50) + Math_fround(Math_fround(f41 * f52) + Math_fround(f46 * Math_fround(Math_fround(f49 * f16) - Math_fround(f43 * f45))))) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f43) + Math_fround(f46 * Math_fround(Math_fround(f52 * f45) - Math_fround(f49 * f50)))) + Math_fround(f20 * f16)) * Math_fround(2.0));
 f49 = Math_fround(HEAPF32[i37 >> 2]);
 f52 = Math_fround(HEAPF32[i17 >> 2]);
 f43 = Math_fround(HEAPF32[i6 >> 2]);
 f41 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(Math_fround(f46 * f41) - Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(f52 * f50)) + Math_fround(f43 * f16)));
 f14 = Math_fround(Math_fround(Math_fround(f43 * f50) - Math_fround(f52 * f16)) + Math_fround(Math_fround(f46 * f49) + Math_fround(f41 * f45)));
 f15 = Math_fround(Math_fround(Math_fround(f49 * f16) - Math_fround(f43 * f45)) + Math_fround(Math_fround(f46 * f52) + Math_fround(f41 * f50)));
 f16 = Math_fround(Math_fround(Math_fround(f52 * f45) - Math_fround(f49 * f50)) + Math_fround(Math_fround(f46 * f43) + Math_fround(f41 * f16)));
 HEAPF32[i7 + 48 >> 2] = f18;
 HEAPF32[i7 + 52 >> 2] = f19;
 HEAPF32[i7 + 56 >> 2] = f20;
 HEAPF32[i7 + 60 >> 2] = Math_fround(0.0);
 f41 = Math_fround(f14 + f14);
 f43 = Math_fround(f15 + f15);
 f46 = Math_fround(f16 + f16);
 f50 = Math_fround(f15 * f43);
 f49 = Math_fround(f16 * f46);
 f45 = Math_fround(f15 * f41);
 f52 = Math_fround(f16 * f41);
 f42 = Math_fround(f13 * f41);
 f51 = Math_fround(f16 * f43);
 f43 = Math_fround(f13 * f43);
 f46 = Math_fround(f13 * f46);
 f41 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f41));
 f48 = Math_fround(f45 + f46);
 f47 = Math_fround(f52 - f43);
 f46 = Math_fround(f45 - f46);
 f45 = Math_fround(f41 - f49);
 f44 = Math_fround(f51 + f42);
 f43 = Math_fround(f52 + f43);
 f42 = Math_fround(f51 - f42);
 f41 = Math_fround(f41 - f50);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f50) - f49);
 HEAPF32[i7 + 4 >> 2] = f48;
 HEAPF32[i7 + 8 >> 2] = f47;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 16 >> 2] = f46;
 HEAPF32[i7 + 20 >> 2] = f45;
 HEAPF32[i7 + 24 >> 2] = f44;
 HEAPF32[i7 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 32 >> 2] = f43;
 HEAPF32[i7 + 36 >> 2] = f42;
 HEAPF32[i7 + 40 >> 2] = f41;
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 f41 = Math_fround(HEAPF32[i36 >> 2]);
 HEAPF32[i33 >> 2] = Math_fround(f41 * Math_fround(.00100000005));
 HEAPF32[i8 >> 2] = Math_fround(f41 * Math_fround(.0500000007));
 i5 = i34 + 53 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 HEAPF32[i9 >> 2] = Math_fround(f41 + Math_fround(HEAPF32[i28 >> 2]));
 i17 = i34 + 52 | 0;
 i4 = HEAP8[i17 >> 0] | 0;
 if (i4 << 24 >> 24) {
  i1 = 0;
  do {
   i2 = i34 + 48 + i1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = i3 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i35, i34 + 64 + (i4 * 400 | 0) | 0, i7, i8, i9);
   if (!(HEAP32[i34 + 64 + (i4 * 400 | 0) + 384 >> 2] | 0)) {
    i57 = (HEAP8[i17 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i17 >> 0] = i57;
    i57 = (i57 & 255) + (i34 + 48) | 0;
    i58 = HEAP8[i57 >> 0] | 0;
    HEAP8[i57 >> 0] = i3;
    HEAP8[i2 >> 0] = i58;
    i1 = i1 + -1 | 0;
   } else HEAP32[i34 + 32 + (i4 << 2) >> 2] = HEAP32[i35 >> 2];
   i1 = i1 + 1 | 0;
   i58 = HEAPU8[i17 >> 0] | 0;
  } while (i1 >>> 0 < i58 >>> 0);
 }
 if ((HEAP8[i5 >> 0] | 0) == i6 << 24 >> 24) {
  f49 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(.0199999996));
  f46 = Math_fround(HEAPF32[i34 + 16 >> 2]);
  f52 = Math_fround(HEAPF32[i34 + 20 >> 2]);
  f46 = Math_fround(f18 - f46);
  f52 = Math_fround(f19 - f52);
  f51 = Math_fround(f20 - Math_fround(HEAPF32[i34 + 24 >> 2]));
  f48 = Math_fround(-f46);
  f47 = Math_fround(-f52);
  f50 = Math_fround(-f51);
  f48 = f46 > f48 ? f46 : f48;
  f47 = f52 > f47 ? f52 : f47;
  f47 = f48 >= f47 ? f48 : f47;
  i58 = (f51 > f50 ? f51 : f50) >= Math_fround(0.0);
  f48 = i58 ? f48 : Math_fround(0.0);
  f50 = Math_fround(HEAPF32[i34 >> 2]);
  f51 = Math_fround(HEAPF32[i34 + 4 >> 2]);
  f52 = Math_fround(HEAPF32[i34 + 8 >> 2]);
  if (!((f47 >= f48 ? f47 : f48) > f49 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f14 * f50) + Math_fround(f15 * f51)) + Math_fround(f16 * f52)) + Math_fround(f13 * Math_fround(HEAPF32[i34 + 12 >> 2]))) < Math_fround(.999800026))) {
   i58 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i34, i38, i37, i39, i36) | 0;
   STACKTOP = i40;
   return i58 | 0;
  }
 }
 HEAP32[i30 >> 2] = 1065353216;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = 1065353216;
 HEAP32[i30 + 20 >> 2] = 0;
 HEAP32[i30 + 24 >> 2] = 0;
 HEAP32[i30 + 28 >> 2] = 0;
 HEAP32[i30 + 32 >> 2] = 1065353216;
 HEAP32[i30 + 36 >> 2] = 1065353216;
 HEAP32[i30 + 40 >> 2] = 0;
 HEAP32[i30 + 44 >> 2] = 0;
 HEAP32[i30 + 48 >> 2] = 0;
 HEAP32[i30 + 52 >> 2] = 1065353216;
 HEAP32[i30 + 56 >> 2] = 0;
 HEAP32[i30 + 60 >> 2] = 0;
 HEAP32[i30 + 64 >> 2] = 0;
 HEAP32[i30 + 68 >> 2] = 1065353216;
 i1 = i23 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i23 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i23 + 12 >> 2]) == Math_fround(1.0)) i2 = 1; else i26 = 12; else i26 = 12; else i26 = 12;
 if ((i26 | 0) == 12) {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i30, i1, i23 + 16 | 0);
  i2 = 0;
 }
 f51 = Math_fround(HEAPF32[i24 >> 2]);
 f42 = Math_fround(f51 * Math_fround(2.0));
 f62 = Math_fround(HEAPF32[i24 + 12 >> 2]);
 f59 = Math_fround(f62 * Math_fround(2.0));
 f62 = Math_fround(Math_fround(f51 * f42) + Math_fround(Math_fround(f62 * f59) + Math_fround(-1.0)));
 f51 = Math_fround(HEAPF32[i24 + 8 >> 2]);
 f64 = Math_fround(f51 * f59);
 f67 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f64 = Math_fround(f64 + Math_fround(f42 * f67));
 f67 = Math_fround(Math_fround(f42 * f51) - Math_fround(f59 * f67));
 f59 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f62 = Math_fround(f59 * f62);
 f64 = Math_fround(f59 * f64);
 f67 = Math_fround(f59 * f67);
 f59 = Math_fround(HEAPF32[i10 >> 2]);
 f51 = Math_fround(f59 + f62);
 f42 = Math_fround(HEAPF32[i24 + 20 >> 2]);
 f49 = Math_fround(f42 + f64);
 f41 = Math_fround(HEAPF32[i24 + 24 >> 2]);
 f50 = Math_fround(f67 + f41);
 f52 = Math_fround(f59 - f62);
 f68 = Math_fround(f42 - f64);
 f69 = Math_fround(f41 - f67);
 f45 = Math_fround(HEAPF32[i12 >> 2]);
 f51 = Math_fround(f51 - f45);
 f43 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 f49 = Math_fround(f49 - f43);
 f44 = Math_fround(HEAPF32[i25 + 24 >> 2]);
 f51 = Math_fround(f51 * Math_fround(2.0));
 f49 = Math_fround(f49 * Math_fround(2.0));
 f50 = Math_fround(Math_fround(f50 - f44) * Math_fround(2.0));
 f65 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f66 = Math_fround(Math_fround(f65 * f65) + Math_fround(-.5));
 f63 = Math_fround(HEAPF32[i25 >> 2]);
 f48 = Math_fround(f51 * f63);
 f60 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f48 = Math_fround(f48 + Math_fround(f49 * f60));
 f61 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f48 = Math_fround(f48 + Math_fround(f50 * f61));
 f46 = Math_fround(Math_fround(f63 * f48) + Math_fround(Math_fround(f51 * f66) - Math_fround(f65 * Math_fround(Math_fround(f50 * f60) - Math_fround(f49 * f61)))));
 f47 = Math_fround(Math_fround(f60 * f48) + Math_fround(Math_fround(f49 * f66) - Math_fround(f65 * Math_fround(Math_fround(f51 * f61) - Math_fround(f50 * f63)))));
 f48 = Math_fround(Math_fround(Math_fround(f50 * f66) - Math_fround(f65 * Math_fround(Math_fround(f49 * f63) - Math_fround(f51 * f60)))) + Math_fround(f61 * f48));
 f52 = Math_fround(Math_fround(f52 - f45) * Math_fround(2.0));
 f68 = Math_fround(Math_fround(f68 - f43) * Math_fround(2.0));
 f69 = Math_fround(Math_fround(f69 - f44) * Math_fround(2.0));
 f51 = Math_fround(Math_fround(Math_fround(f52 * f63) + Math_fround(f68 * f60)) + Math_fround(f69 * f61));
 f49 = Math_fround(Math_fround(f63 * f51) + Math_fround(Math_fround(f52 * f66) - Math_fround(f65 * Math_fround(Math_fround(f69 * f60) - Math_fround(f68 * f61)))));
 f50 = Math_fround(Math_fround(f60 * f51) + Math_fround(Math_fround(f68 * f66) - Math_fround(f65 * Math_fround(Math_fround(f52 * f61) - Math_fround(f69 * f63)))));
 f51 = Math_fround(Math_fround(Math_fround(f69 * f66) - Math_fround(f65 * Math_fround(Math_fround(f68 * f63) - Math_fround(f52 * f60)))) + Math_fround(f61 * f51));
 f52 = Math_fround(HEAPF32[i11 >> 2]);
 f52 = Math_fround(f52 + Math_fround(HEAPF32[i21 >> 2]));
 f45 = Math_fround(Math_fround(f59 - f45) * Math_fround(2.0));
 f43 = Math_fround(Math_fround(f42 - f43) * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f41 - f44) * Math_fround(2.0));
 f41 = Math_fround(Math_fround(Math_fround(f45 * f63) + Math_fround(f43 * f60)) + Math_fround(f44 * f61));
 f42 = Math_fround(Math_fround(f63 * f41) + Math_fround(Math_fround(f45 * f66) - Math_fround(f65 * Math_fround(Math_fround(f44 * f60) - Math_fround(f43 * f61)))));
 f59 = Math_fround(Math_fround(f60 * f41) + Math_fround(Math_fround(f43 * f66) - Math_fround(f65 * Math_fround(Math_fround(f45 * f61) - Math_fround(f44 * f63)))));
 f41 = Math_fround(Math_fround(Math_fround(f44 * f66) - Math_fround(f65 * Math_fround(Math_fround(f43 * f63) - Math_fround(f45 * f60)))) + Math_fround(f61 * f41));
 f62 = Math_fround(f62 * Math_fround(2.0));
 f64 = Math_fround(f64 * Math_fround(2.0));
 f67 = Math_fround(f67 * Math_fround(2.0));
 f45 = Math_fround(Math_fround(Math_fround(f62 * f63) + Math_fround(f64 * f60)) + Math_fround(f67 * f61));
 f43 = Math_fround(Math_fround(f63 * f45) + Math_fround(Math_fround(f62 * f66) - Math_fround(f65 * Math_fround(Math_fround(f67 * f60) - Math_fround(f64 * f61)))));
 f44 = Math_fround(Math_fround(f60 * f45) + Math_fround(Math_fround(f64 * f66) - Math_fround(f65 * Math_fround(Math_fround(f62 * f61) - Math_fround(f67 * f63)))));
 f45 = Math_fround(Math_fround(Math_fround(f67 * f66) - Math_fround(f65 * Math_fround(Math_fround(f64 * f63) - Math_fround(f62 * f60)))) + Math_fround(f61 * f45));
 i1 = i27 + 64 | 0;
 HEAPF32[i27 >> 2] = f42;
 HEAPF32[i27 + 4 >> 2] = f59;
 HEAPF32[i27 + 8 >> 2] = f41;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 80 >> 2] = 4;
 HEAPF32[i27 + 48 >> 2] = Math_fround(0.0);
 i7 = i27 + 128 | 0;
 HEAP32[i7 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 f61 = Math_fround(f59 + f44);
 f60 = Math_fround(f41 + f45);
 HEAPF32[i27 + 96 >> 2] = Math_fround(f42 + f43);
 HEAPF32[i27 + 100 >> 2] = f61;
 HEAPF32[i27 + 104 >> 2] = f60;
 HEAPF32[i27 + 108 >> 2] = Math_fround(0.0);
 f44 = Math_fround(f59 - f44);
 f45 = Math_fround(f41 - f45);
 HEAPF32[i27 + 112 >> 2] = Math_fround(f42 - f43);
 HEAPF32[i27 + 116 >> 2] = f44;
 HEAPF32[i27 + 120 >> 2] = f45;
 HEAPF32[i27 + 124 >> 2] = Math_fround(0.0);
 i7 = i27 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 i7 = i27 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 HEAP32[i35 >> 2] = -1;
 HEAP32[i35 + 4 >> 2] = -1;
 HEAP32[i35 + 8 >> 2] = -1;
 HEAP32[i35 + 12 >> 2] = -1;
 HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
 HEAPF32[i32 >> 2] = f46;
 HEAPF32[i32 + 4 >> 2] = f47;
 HEAPF32[i32 + 8 >> 2] = f48;
 HEAPF32[i32 + 12 >> 2] = f49;
 HEAPF32[i32 + 16 >> 2] = f50;
 HEAPF32[i32 + 20 >> 2] = f51;
 HEAPF32[i32 + 24 >> 2] = f52;
 i1 = HEAP32[i23 + 40 >> 2] | 0;
 HEAP8[i17 >> 0] = 0;
 HEAPF32[i34 >> 2] = f14;
 HEAPF32[i34 + 4 >> 2] = f15;
 HEAPF32[i34 + 8 >> 2] = f16;
 HEAPF32[i34 + 12 >> 2] = f13;
 HEAPF32[i34 + 16 >> 2] = f18;
 HEAPF32[i34 + 20 >> 2] = f19;
 HEAPF32[i34 + 24 >> 2] = f20;
 HEAPF32[i34 + 28 >> 2] = Math_fround(0.0);
 i7 = HEAP32[i1 + 152 >> 2] | 0;
 HEAP32[i35 + 4 >> 2] = 2;
 HEAP32[i35 + 8 >> 2] = i30;
 HEAP32[i35 + 12 >> 2] = i7;
 HEAP8[i35 + 16 >> 0] = i2 & 1;
 i7 = i35 + 868 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i35 >> 2] = gb + 105472 + 8;
 i8 = i35 + 880 | 0;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i8, i28, i33, i37, i39, i34, i38);
 HEAP32[i35 + 3248 >> 2] = i27;
 f52 = Math_fround(HEAPF32[i27 + 128 >> 2]);
 f52 = Math_fround(f52 + Math_fround(HEAPF32[i28 >> 2]));
 HEAPF32[i35 + 3216 >> 2] = f52;
 HEAPF32[i35 + 3232 >> 2] = Math_fround(f52 * f52);
 __ZN5physx2Gu3Box6createERKNS0_7CapsuleE(i31, i32);
 if (!i2) __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i30, i31 + 36 | 0, i31 + 48 | 0, i31);
 HEAP32[i29 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i29 + 4 >> 2] = i1 + 32;
 HEAP32[i29 + 8 >> 2] = HEAP32[i1 + 20 >> 2];
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i31, 1, i29, i35, 1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i6 = i35 + 880 | 0;
  i3 = i35 + 852 | 0;
  i4 = i35 + 788 | 0;
  i5 = i35 + 596 | 0;
  i2 = i35 + 20 | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i6, i2, HEAP32[i4 >> 2] | 0, HEAP8[i3 >> 0] | 0, i5) | 0;
   if (!i1) break; else {
    i3 = i3 + 1 | 0;
    i4 = i4 + 4 | 0;
    i5 = i5 + 12 | 0;
    i2 = i2 + 36 | 0;
   }
  }
  HEAP32[i7 >> 2] = 0;
 }
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i8, 3, 0);
 i58 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i34, i38, i37, i39, i36) | 0;
 STACKTOP = i40;
 return i58 | 0;
}

function __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb(i1, i63, i72, i83, i94, i103, i104) {
 i1 = i1 | 0;
 i63 = i63 | 0;
 i72 = i72 | 0;
 i83 = i83 | 0;
 i94 = i94 | 0;
 i103 = i103 | 0;
 i104 = i104 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, i113 = 0, i114 = 0, i115 = 0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0;
 i108 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i105 = i108 + 96 | 0;
 i106 = i108 + 80 | 0;
 i107 = i108 + 32 | 0;
 i64 = i108 + 16 | 0;
 i65 = i108;
 i66 = HEAP32[i94 + 12 >> 2] | 0;
 if (!i66) {
  STACKTOP = i108;
  return;
 }
 i67 = i94 + 500 | 0;
 i68 = i105 + 4 | 0;
 i69 = i105 + 8 | 0;
 i70 = i105 + 12 | 0;
 i71 = i94 + 520 | 0;
 i73 = i64 + 4 | 0;
 i74 = i64 + 8 | 0;
 i75 = i64 + 12 | 0;
 i76 = i1 + 468 | 0;
 i77 = i1 + 240 | 0;
 i78 = i106 + 4 | 0;
 i79 = i105 + 4 | 0;
 i80 = i106 + 8 | 0;
 i81 = i105 + 8 | 0;
 i82 = i106 + 12 | 0;
 i84 = i105 + 12 | 0;
 i85 = i107 + 4 | 0;
 i86 = i107 + 8 | 0;
 i87 = i107 + 12 | 0;
 i88 = i107 + 16 | 0;
 i89 = i1 + 924 | 0;
 i90 = i1 + 696 | 0;
 i91 = i106 + 4 | 0;
 i92 = i105 + 4 | 0;
 i93 = i106 + 8 | 0;
 i95 = i105 + 8 | 0;
 i96 = i106 + 12 | 0;
 i97 = i105 + 12 | 0;
 i98 = i107 + 20 | 0;
 i99 = i107 + 24 | 0;
 i100 = i107 + 28 | 0;
 i101 = i107 + 32 | 0;
 i102 = i1 + 1380 | 0;
 i15 = i1 + 1152 | 0;
 i16 = i106 + 4 | 0;
 i17 = i105 + 4 | 0;
 i18 = i106 + 8 | 0;
 i19 = i105 + 8 | 0;
 i20 = i106 + 12 | 0;
 i21 = i105 + 12 | 0;
 i22 = i107 + 36 | 0;
 i23 = i107 + 40 | 0;
 i24 = i107 + 44 | 0;
 i25 = i94 + 540 | 0;
 i26 = i63 + 84 | 0;
 i27 = i72 + 84 | 0;
 i28 = i83 + 84 | 0;
 i29 = i103 + 12 | 0;
 i30 = i103 + 24 | 0;
 i31 = i103 + 4 | 0;
 i32 = i103 + 16 | 0;
 i33 = i103 + 28 | 0;
 i34 = i103 + 8 | 0;
 i35 = i103 + 20 | 0;
 i36 = i103 + 32 | 0;
 i37 = i94 + 20 | 0;
 i38 = i94 + 40 | 0;
 i39 = i94 + 120 | 0;
 i40 = i94 + 140 | 0;
 i41 = i94 + 160 | 0;
 i42 = i94 + 60 | 0;
 i43 = i94 + 80 | 0;
 i44 = i94 + 100 | 0;
 i45 = i83 + 80 | 0;
 i46 = i65 + 12 | 0;
 i47 = i65 + 8 | 0;
 i48 = i65 + 4 | 0;
 i49 = i83 + 232 | 0;
 i50 = i83 + 144 | 0;
 i51 = i72 + 80 | 0;
 i52 = i106 + 12 | 0;
 i53 = i106 + 8 | 0;
 i54 = i106 + 4 | 0;
 i55 = i72 + 232 | 0;
 i56 = i72 + 144 | 0;
 i57 = i63 + 80 | 0;
 i58 = i105 + 12 | 0;
 i59 = i105 + 8 | 0;
 i60 = i105 + 4 | 0;
 i61 = i63 + 232 | 0;
 i62 = i63 + 144 | 0;
 i14 = 0;
 do {
  i115 = (HEAP32[i67 >> 2] | 0) + (i14 << 2) | 0;
  i114 = (HEAP32[i115 + 4 >> 2] | 0) + -520366028 | 0;
  i113 = (HEAP32[i115 + 8 >> 2] | 0) + -520366028 | 0;
  i1 = (HEAP32[i115 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i105 >> 2] = (HEAP32[i115 >> 2] | 0) + -520366028;
  HEAP32[i68 >> 2] = i114;
  HEAP32[i69 >> 2] = i113;
  HEAP32[i70 >> 2] = i1;
  __Z17GenerateRandomNx3RKN4math5_int4E(i107, i105);
  i1 = (HEAP32[i71 >> 2] | 0) + (i14 << 2) | 0;
  f13 = Math_fround(HEAPF32[i1 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f2 = Math_fround(f2 * Math_fround(.00999999977));
  f111 = Math_fround(f111 * Math_fround(.00999999977));
  f6 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i64 >> 2] = Math_fround(f13 * Math_fround(.00999999977));
  HEAPF32[i73 >> 2] = f2;
  HEAPF32[i74 >> 2] = f111;
  HEAPF32[i75 >> 2] = f6;
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i105, i76, i64);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i106, i77, i64);
  f6 = Math_fround(HEAPF32[i106 >> 2]);
  f111 = Math_fround(HEAPF32[i105 >> 2]);
  f6 = Math_fround(f6 - f111);
  f2 = Math_fround(HEAPF32[i78 >> 2]);
  f13 = Math_fround(HEAPF32[i79 >> 2]);
  f2 = Math_fround(f2 - f13);
  f8 = Math_fround(HEAPF32[i80 >> 2]);
  f4 = Math_fround(HEAPF32[i81 >> 2]);
  f8 = Math_fround(f8 - f4);
  f10 = Math_fround(HEAPF32[i82 >> 2]);
  f12 = Math_fround(HEAPF32[i84 >> 2]);
  f10 = Math_fround(f10 - f12);
  f6 = Math_fround(f6 * Math_fround(HEAPF32[i107 >> 2]));
  f2 = Math_fround(f2 * Math_fround(HEAPF32[i85 >> 2]));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i86 >> 2]));
  f6 = Math_fround(f111 + f6);
  f2 = Math_fround(f13 + f2);
  f8 = Math_fround(f4 + f8);
  f10 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i87 >> 2])));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i105, i89, i64);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i106, i90, i64);
  f12 = Math_fround(HEAPF32[i106 >> 2]);
  f4 = Math_fround(HEAPF32[i105 >> 2]);
  f12 = Math_fround(f12 - f4);
  f13 = Math_fround(HEAPF32[i91 >> 2]);
  f111 = Math_fround(HEAPF32[i92 >> 2]);
  f13 = Math_fround(f13 - f111);
  f11 = Math_fround(HEAPF32[i93 >> 2]);
  f3 = Math_fround(HEAPF32[i95 >> 2]);
  f11 = Math_fround(f11 - f3);
  f9 = Math_fround(HEAPF32[i96 >> 2]);
  f112 = Math_fround(HEAPF32[i97 >> 2]);
  f9 = Math_fround(f9 - f112);
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i88 >> 2]));
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i98 >> 2]));
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i99 >> 2]));
  f12 = Math_fround(f4 + f12);
  f13 = Math_fround(f111 + f13);
  f11 = Math_fround(f3 + f11);
  f9 = Math_fround(f112 + Math_fround(f9 * Math_fround(HEAPF32[i100 >> 2])));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i105, i102, i64);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i106, i15, i64);
  f112 = Math_fround(HEAPF32[i106 >> 2]);
  f3 = Math_fround(HEAPF32[i105 >> 2]);
  f112 = Math_fround(f112 - f3);
  f111 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i17 >> 2]);
  f111 = Math_fround(f111 - f4);
  f110 = Math_fround(HEAPF32[i18 >> 2]);
  f5 = Math_fround(HEAPF32[i19 >> 2]);
  f110 = Math_fround(f110 - f5);
  f109 = Math_fround(HEAPF32[i20 >> 2]);
  f7 = Math_fround(HEAPF32[i21 >> 2]);
  f109 = Math_fround(f109 - f7);
  f112 = Math_fround(f112 * Math_fround(HEAPF32[i101 >> 2]));
  f111 = Math_fround(f111 * Math_fround(HEAPF32[i22 >> 2]));
  f110 = Math_fround(f110 * Math_fround(HEAPF32[i23 >> 2]));
  f112 = Math_fround(f3 + f112);
  f111 = Math_fround(f4 + f111);
  f110 = Math_fround(f5 + f110);
  f109 = Math_fround(f7 + Math_fround(f109 * Math_fround(HEAPF32[i24 >> 2])));
  i1 = (HEAP32[i25 >> 2] | 0) + (i14 << 2) | 0;
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f6 = Math_fround(f6 / f7);
  f2 = Math_fround(f2 / f5);
  f8 = Math_fround(f8 / f4);
  f10 = Math_fround(f10 / f3);
  f12 = Math_fround(f12 / f7);
  f13 = Math_fround(f13 / f5);
  f11 = Math_fround(f11 / f4);
  f9 = Math_fround(f9 / f3);
  f7 = Math_fround(f112 / f7);
  f5 = Math_fround(f111 / f5);
  f4 = Math_fround(f110 / f4);
  f3 = Math_fround(f109 / f3);
  i1 = HEAP32[i26 >> 2] | 0;
  L6 : do switch ((i1 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i57 >> 2] | 0;
    HEAP32[i58 >> 2] = i115;
    HEAP32[i59 >> 2] = i115;
    HEAP32[i60 >> 2] = i115;
    HEAP32[i105 >> 2] = i115;
    break;
   }
  case 3:
   {
    f116 = Math_fround(HEAPF32[(HEAP32[i61 >> 2] | 0) + 4 >> 2]);
    f112 = Math_fround(HEAPF32[i57 >> 2]);
    f116 = Math_fround(f116 * f112);
    f112 = Math_fround(Math_fround(f112 * Math_fround(HEAPF32[(HEAP32[i62 >> 2] | 0) + 4 >> 2])) - f116);
    f109 = Math_fround(Math_fround(HEAPF32[i107 >> 2]) * f112);
    f110 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i85 >> 2])));
    f111 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i86 >> 2])));
    f112 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i87 >> 2])));
    HEAPF32[i105 >> 2] = Math_fround(f116 + f109);
    HEAPF32[i60 >> 2] = f110;
    HEAPF32[i59 >> 2] = f111;
    HEAPF32[i58 >> 2] = f112;
    break;
   }
  default:
   if (!(i1 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i105, i63, i64, i107);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i105, i63, i64, i107);
    break L6;
   }
  } while (0);
  i1 = HEAP32[i27 >> 2] | 0;
  L14 : do switch ((i1 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i51 >> 2] | 0;
    HEAP32[i52 >> 2] = i115;
    HEAP32[i53 >> 2] = i115;
    HEAP32[i54 >> 2] = i115;
    HEAP32[i106 >> 2] = i115;
    break;
   }
  case 3:
   {
    f109 = Math_fround(HEAPF32[(HEAP32[i55 >> 2] | 0) + 4 >> 2]);
    f116 = Math_fround(HEAPF32[i51 >> 2]);
    f109 = Math_fround(f109 * f116);
    f116 = Math_fround(Math_fround(f116 * Math_fround(HEAPF32[(HEAP32[i56 >> 2] | 0) + 4 >> 2])) - f109);
    f110 = Math_fround(Math_fround(HEAPF32[i88 >> 2]) * f116);
    f111 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i98 >> 2])));
    f112 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i99 >> 2])));
    f116 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i100 >> 2])));
    HEAPF32[i106 >> 2] = Math_fround(f109 + f110);
    HEAPF32[i54 >> 2] = f111;
    HEAPF32[i53 >> 2] = f112;
    HEAPF32[i52 >> 2] = f116;
    break;
   }
  default:
   if (!(i1 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i106, i72, i64, i88);
    break L14;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i106, i72, i64, i88);
    break L14;
   }
  } while (0);
  i1 = HEAP32[i28 >> 2] | 0;
  L22 : do switch ((i1 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i45 >> 2] | 0;
    HEAP32[i46 >> 2] = i115;
    HEAP32[i47 >> 2] = i115;
    HEAP32[i48 >> 2] = i115;
    HEAP32[i65 >> 2] = i115;
    break;
   }
  case 3:
   {
    f109 = Math_fround(HEAPF32[(HEAP32[i49 >> 2] | 0) + 4 >> 2]);
    f116 = Math_fround(HEAPF32[i45 >> 2]);
    f109 = Math_fround(f109 * f116);
    f116 = Math_fround(Math_fround(f116 * Math_fround(HEAPF32[(HEAP32[i50 >> 2] | 0) + 4 >> 2])) - f109);
    f110 = Math_fround(Math_fround(HEAPF32[i101 >> 2]) * f116);
    f111 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i22 >> 2])));
    f112 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i23 >> 2])));
    f116 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i24 >> 2])));
    HEAPF32[i65 >> 2] = Math_fround(f109 + f110);
    HEAPF32[i48 >> 2] = f111;
    HEAPF32[i47 >> 2] = f112;
    HEAPF32[i46 >> 2] = f116;
    break;
   }
  default:
   if (!(i1 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i65, i83, i64, i101);
    break L22;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i65, i83, i64, i101);
    break L22;
   }
  } while (0);
  if (i104) {
   f121 = Math_fround(HEAPF32[i103 >> 2]);
   f123 = Math_fround(f6 * f121);
   f116 = Math_fround(f2 * f121);
   f122 = Math_fround(f8 * f121);
   f121 = Math_fround(f10 * f121);
   f117 = Math_fround(HEAPF32[i29 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f12 * f117));
   f116 = Math_fround(f116 + Math_fround(f13 * f117));
   f122 = Math_fround(f122 + Math_fround(f11 * f117));
   f117 = Math_fround(f121 + Math_fround(f9 * f117));
   f121 = Math_fround(HEAPF32[i30 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f7 * f121));
   f116 = Math_fround(f116 + Math_fround(f5 * f121));
   f122 = Math_fround(f122 + Math_fround(f4 * f121));
   f121 = Math_fround(f117 + Math_fround(f3 * f121));
   f117 = Math_fround(HEAPF32[i31 >> 2]);
   f120 = Math_fround(f6 * f117);
   f119 = Math_fround(f2 * f117);
   f118 = Math_fround(f8 * f117);
   f117 = Math_fround(f10 * f117);
   f112 = Math_fround(HEAPF32[i32 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f12 * f112));
   f119 = Math_fround(f119 + Math_fround(f13 * f112));
   f118 = Math_fround(f118 + Math_fround(f11 * f112));
   f112 = Math_fround(f117 + Math_fround(f9 * f112));
   f117 = Math_fround(HEAPF32[i33 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f7 * f117));
   f119 = Math_fround(f119 + Math_fround(f5 * f117));
   f118 = Math_fround(f118 + Math_fround(f4 * f117));
   f117 = Math_fround(f112 + Math_fround(f3 * f117));
   f112 = Math_fround(HEAPF32[i34 >> 2]);
   f109 = Math_fround(f6 * f112);
   f110 = Math_fround(f2 * f112);
   f111 = Math_fround(f8 * f112);
   f2 = Math_fround(f10 * f112);
   f112 = Math_fround(HEAPF32[i35 >> 2]);
   f109 = Math_fround(f109 + Math_fround(f12 * f112));
   f110 = Math_fround(f110 + Math_fround(f13 * f112));
   f111 = Math_fround(f111 + Math_fround(f11 * f112));
   f112 = Math_fround(f2 + Math_fround(f9 * f112));
   f2 = Math_fround(HEAPF32[i36 >> 2]);
   f6 = f123;
   f8 = f122;
   f10 = f121;
   f12 = f120;
   f13 = f119;
   f11 = f118;
   f9 = f117;
   f7 = Math_fround(f109 + Math_fround(f7 * f2));
   f5 = Math_fround(f110 + Math_fround(f5 * f2));
   f4 = Math_fround(f111 + Math_fround(f4 * f2));
   f3 = Math_fround(f112 + Math_fround(f3 * f2));
   f2 = f116;
  }
  i115 = (HEAP32[i94 >> 2] | 0) + (i14 << 2) | 0;
  f112 = Math_fround(HEAPF32[i115 >> 2]);
  i114 = i115 + 4 | 0;
  f111 = Math_fround(HEAPF32[i114 >> 2]);
  i113 = i115 + 8 | 0;
  f110 = Math_fround(HEAPF32[i113 >> 2]);
  i1 = i115 + 12 | 0;
  f109 = Math_fround(HEAPF32[i1 >> 2]);
  i124 = (HEAP32[i37 >> 2] | 0) + (i14 << 2) | 0;
  f123 = Math_fround(HEAPF32[i124 >> 2]);
  i125 = i124 + 4 | 0;
  f121 = Math_fround(HEAPF32[i125 >> 2]);
  i126 = i124 + 8 | 0;
  f120 = Math_fround(HEAPF32[i126 >> 2]);
  i127 = i124 + 12 | 0;
  f119 = Math_fround(HEAPF32[i127 >> 2]);
  i128 = (HEAP32[i38 >> 2] | 0) + (i14 << 2) | 0;
  f118 = Math_fround(HEAPF32[i128 >> 2]);
  i129 = i128 + 4 | 0;
  f117 = Math_fround(HEAPF32[i129 >> 2]);
  i130 = i128 + 8 | 0;
  f116 = Math_fround(HEAPF32[i130 >> 2]);
  i131 = i128 + 12 | 0;
  f111 = Math_fround(f2 + f111);
  f110 = Math_fround(f8 + f110);
  f109 = Math_fround(f10 + f109);
  f123 = Math_fround(f12 + f123);
  f12 = Math_fround(f13 + f121);
  f10 = Math_fround(f11 + f120);
  f8 = Math_fround(f9 + f119);
  f7 = Math_fround(f7 + f118);
  f5 = Math_fround(f5 + f117);
  f4 = Math_fround(f4 + f116);
  f13 = Math_fround(f3 + Math_fround(HEAPF32[i131 >> 2]));
  HEAPF32[i115 >> 2] = Math_fround(f6 + f112);
  HEAPF32[i114 >> 2] = f111;
  HEAPF32[i113 >> 2] = f110;
  HEAPF32[i1 >> 2] = f109;
  HEAPF32[i124 >> 2] = f123;
  HEAPF32[i125 >> 2] = f12;
  HEAPF32[i126 >> 2] = f10;
  HEAPF32[i127 >> 2] = f8;
  HEAPF32[i128 >> 2] = f7;
  HEAPF32[i129 >> 2] = f5;
  HEAPF32[i130 >> 2] = f4;
  HEAPF32[i131 >> 2] = f13;
  i131 = (HEAP32[i39 >> 2] | 0) + (i14 << 2) | 0;
  f13 = Math_fround(HEAPF32[i131 >> 2]);
  i130 = i131 + 4 | 0;
  f3 = Math_fround(HEAPF32[i130 >> 2]);
  i129 = i131 + 8 | 0;
  f4 = Math_fround(HEAPF32[i129 >> 2]);
  i128 = i131 + 12 | 0;
  f5 = Math_fround(HEAPF32[i128 >> 2]);
  i127 = (HEAP32[i40 >> 2] | 0) + (i14 << 2) | 0;
  f6 = Math_fround(HEAPF32[i127 >> 2]);
  i126 = i127 + 4 | 0;
  f7 = Math_fround(HEAPF32[i126 >> 2]);
  i125 = i127 + 8 | 0;
  f8 = Math_fround(HEAPF32[i125 >> 2]);
  i124 = i127 + 12 | 0;
  f9 = Math_fround(HEAPF32[i124 >> 2]);
  i1 = (HEAP32[i41 >> 2] | 0) + (i14 << 2) | 0;
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  i113 = i1 + 4 | 0;
  f11 = Math_fround(HEAPF32[i113 >> 2]);
  i114 = i1 + 8 | 0;
  f12 = Math_fround(HEAPF32[i114 >> 2]);
  i115 = i1 + 12 | 0;
  f123 = Math_fround(HEAPF32[i115 >> 2]);
  i132 = (HEAP32[i42 >> 2] | 0) + (i14 << 2) | 0;
  f109 = Math_fround(HEAPF32[i132 >> 2]);
  f110 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f112 = Math_fround(HEAPF32[i132 + 12 >> 2]);
  i132 = (HEAP32[i43 >> 2] | 0) + (i14 << 2) | 0;
  f116 = Math_fround(HEAPF32[i132 >> 2]);
  f117 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f118 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f119 = Math_fround(HEAPF32[i132 + 12 >> 2]);
  i132 = (HEAP32[i44 >> 2] | 0) + (i14 << 2) | 0;
  f120 = Math_fround(HEAPF32[i132 >> 2]);
  f121 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f122 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f110 = Math_fround(f3 + f110);
  f111 = Math_fround(f4 + f111);
  f112 = Math_fround(f5 + f112);
  f116 = Math_fround(f6 + f116);
  f117 = Math_fround(f7 + f117);
  f118 = Math_fround(f8 + f118);
  f119 = Math_fround(f9 + f119);
  f120 = Math_fround(f10 + f120);
  f121 = Math_fround(f11 + f121);
  f122 = Math_fround(f12 + f122);
  f123 = Math_fround(f123 + Math_fround(HEAPF32[i132 + 12 >> 2]));
  HEAPF32[i131 >> 2] = Math_fround(f13 + f109);
  HEAPF32[i130 >> 2] = f110;
  HEAPF32[i129 >> 2] = f111;
  HEAPF32[i128 >> 2] = f112;
  HEAPF32[i127 >> 2] = f116;
  HEAPF32[i126 >> 2] = f117;
  HEAPF32[i125 >> 2] = f118;
  HEAPF32[i124 >> 2] = f119;
  HEAPF32[i1 >> 2] = f120;
  HEAPF32[i113 >> 2] = f121;
  HEAPF32[i114 >> 2] = f122;
  HEAPF32[i115 >> 2] = f123;
  i14 = i14 + 4 | 0;
 } while (i14 >>> 0 < i66 >>> 0);
 STACKTOP = i108;
 return;
}

function __ZN2UI14PrepareBatchesERNS_7BatchesEPKNS_23RenderableUIInstructionEPNS_28TransformGeometryInstructionEi10ColorRGBAf(i78, i13, i74, i8, i7) {
 i78 = i78 | 0;
 i13 = i13 | 0;
 i74 = i74 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, i79 = 0;
 i79 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i73 = i79 + 8 | 0;
 i75 = i79 + 4 | 0;
 i76 = i79;
 if ((HEAP16[gb + 1467952 + 6 >> 1] | 0) > -1) {
  HEAP32[i75 >> 2] = 0;
  HEAP32[i73 >> 2] = HEAP32[i75 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467952 | 0, i73);
  i77 = gb + 1467952 | 0;
 } else i77 = 0;
 f6 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f3 = Math_fround(-f6);
 f2 = Math_fround(-f5);
 f1 = Math_fround(-f4);
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 i71 = (__Z19GetActiveColorSpacev() | 0) == 1;
 i72 = i13 + (i8 * 252 | 0) | 0;
 if (i8) {
  i57 = i78 + 12 | 0;
  i58 = i78 + 16 | 0;
  i59 = i78 + 4 | 0;
  i60 = i78 + 60 | 0;
  i61 = i78 + 20 | 0;
  i62 = i78 + 32 | 0;
  i63 = i78 + 36 | 0;
  i64 = i78 + 24 | 0;
  i65 = i73 + 4 | 0;
  i66 = i73 + 8 | 0;
  i67 = i73 + 12 | 0;
  i68 = i73 + 4 | 0;
  i69 = i73 + 8 | 0;
  i70 = i73 + 12 | 0;
  i46 = f10 < Math_fround(0.0);
  f41 = i46 ? Math_fround(0.0) : f10;
  i46 = f41 > Math_fround(1.0);
  i46 = ~~Math_fround(Math_fround((i46 ? Math_fround(1.0) : f41) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i45 = f11 < Math_fround(0.0);
  f41 = i45 ? Math_fround(0.0) : f11;
  i45 = f41 > Math_fround(1.0);
  i45 = ~~Math_fround(Math_fround((i45 ? Math_fround(1.0) : f41) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i43 = f12 < Math_fround(0.0);
  f41 = i43 ? Math_fround(0.0) : f12;
  i43 = f41 > Math_fround(1.0);
  i43 = ~~Math_fround(Math_fround((i43 ? Math_fround(1.0) : f41) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i42 = f9 < Math_fround(0.0);
  f41 = i42 ? Math_fround(0.0) : f9;
  i42 = f41 > Math_fround(1.0);
  f38 = Math_fround(Math_fround(i46 & 255) / Math_fround(255.0));
  f39 = Math_fround(Math_fround(i45 & 255) / Math_fround(255.0));
  f40 = Math_fround(Math_fround(i43 & 255) / Math_fround(255.0));
  f41 = Math_fround(Math_fround(~~Math_fround(Math_fround((i42 ? Math_fround(1.0) : f41) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255) / Math_fround(255.0));
  i42 = !(f38 <= Math_fround(.0404499993));
  i43 = f38 < Math_fround(1.0);
  f44 = Math_fround(Math_fround(f38 + Math_fround(.0549999997)) / Math_fround(1.05499995));
  i45 = f38 == Math_fround(1.0);
  i46 = !(f39 <= Math_fround(.0404499993));
  i47 = f39 < Math_fround(1.0);
  f48 = Math_fround(Math_fround(f39 + Math_fround(.0549999997)) / Math_fround(1.05499995));
  i49 = f39 == Math_fround(1.0);
  i50 = !(f40 <= Math_fround(.0404499993));
  i51 = f40 < Math_fround(1.0);
  f52 = Math_fround(Math_fround(f40 + Math_fround(.0549999997)) / Math_fround(1.05499995));
  i53 = f40 == Math_fround(1.0);
  f54 = Math_fround(f40 / Math_fround(12.9200001));
  f55 = Math_fround(f39 / Math_fround(12.9200001));
  f56 = Math_fround(f38 / Math_fround(12.9200001));
  i17 = 0;
  i18 = 0;
  i19 = 0;
  while (1) {
   i16 = HEAP32[i57 >> 2] | 0;
   i8 = i16 + 1 | 0;
   i14 = HEAP32[i58 >> 2] | 0;
   i15 = i14 & 2147483647;
   do if (i8 >>> 0 > i15 >>> 0) {
    i7 = i14 << 1;
    i7 = (i7 | 0) == 0 ? 1 : i7;
    if (i15 >>> 0 < i7 >>> 0) if ((i14 | 0) > -1) {
     HEAP32[i58 >> 2] = i7;
     HEAP32[i78 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i78 >> 2] | 0, i7 << 4, 4, i59, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i37 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i59, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i37 | 0, HEAP32[i78 >> 2] | 0, HEAP32[i57 >> 2] << 4 | 0) | 0;
     HEAP32[i58 >> 2] = i7;
     HEAP32[i78 >> 2] = i37;
     break;
    }
   } while (0);
   HEAP32[i57 >> 2] = i8;
   i37 = HEAP32[i78 >> 2] | 0;
   i7 = i37 + (i16 << 4) | 0;
   HEAP8[i7 >> 0] = 0;
   i8 = i37 + (i16 << 4) + 4 | 0;
   HEAP32[i8 >> 2] = 0;
   i14 = i37 + (i16 << 4) + 8 | 0;
   HEAP32[i14 >> 2] = 0;
   i37 = i37 + (i16 << 4) + 12 | 0;
   HEAP32[i37 >> 2] = 0;
   if (!(HEAP8[i13 + 246 >> 0] | 0)) {
    HEAP32[i14 >> 2] = HEAP32[i60 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
    i7 = 0;
    i36 = i13;
    i23 = i17;
    while (1) {
     if ((i36 | 0) != (i13 | 0)) {
      if (HEAP8[i36 + 246 >> 0] | 0) {
       i16 = i36;
       i15 = i23;
       i14 = i18;
       i8 = i19;
       break;
      }
      if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i36 >> 2] | 0)) {
       i16 = i36;
       i15 = i23;
       i14 = i18;
       i8 = i19;
       break;
      }
     }
     i14 = HEAP32[i60 >> 2] | 0;
     if ((i14 | 0) == (HEAP32[i62 >> 2] | 0)) {
      i15 = i14 + 1 | 0;
      i16 = HEAP32[i63 >> 2] | 0;
      i17 = i16 & 2147483647;
      do if (i15 >>> 0 > i17 >>> 0) {
       i8 = i16 << 1;
       i8 = (i8 | 0) == 0 ? 1 : i8;
       if (i17 >>> 0 < i8 >>> 0) if ((i16 | 0) > -1) {
        HEAP32[i63 >> 2] = i8;
        HEAP32[i61 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i61 >> 2] | 0, i8 * 36 | 0, 4, i64, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 36 | 0, 4, i64, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i35 | 0, HEAP32[i61 >> 2] | 0, (HEAP32[i62 >> 2] | 0) * 36 | 0) | 0;
        HEAP32[i63 >> 2] = i8;
        HEAP32[i61 >> 2] = i35;
        break;
       }
      } while (0);
      HEAP32[i62 >> 2] = i15;
      i35 = HEAP32[i61 >> 2] | 0;
      HEAP32[i35 + (i14 * 36 | 0) >> 2] = 0;
      HEAP32[i35 + (i14 * 36 | 0) + 4 >> 2] = -1;
      i14 = i35 + (i14 * 36 | 0) + 8 | 0;
      HEAP32[i14 >> 2] = 0;
      HEAP32[i14 + 4 >> 2] = 0;
      HEAP32[i14 + 8 >> 2] = 0;
      HEAP32[i14 + 12 >> 2] = 0;
      HEAP32[i14 + 16 >> 2] = 0;
      HEAP32[i14 + 20 >> 2] = 0;
      HEAP32[i14 + 24 >> 2] = 0;
      i14 = HEAP32[i60 >> 2] | 0;
     }
     i35 = HEAP32[i61 >> 2] | 0;
     HEAP32[i60 >> 2] = i14 + 1;
     i8 = __ZN2UI26GetAvaliableShaderPropertyERNS_7BatchesE(i78) | 0;
     i30 = i8 + 4 | 0;
     HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
     HEAP32[i35 + (i14 * 36 | 0) >> 2] = i8;
     __ZN19ShaderPropertySheet5ClearEb(i8, 1);
     __ZN19ShaderPropertySheet20ReservePropertyCountEj(i8, 6);
     i30 = i36 + 4 | 0;
     HEAP32[i75 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i73 >> 2] = HEAP32[i75 >> 2];
     __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i8, gb + 1467964 | 0, i73, 2, 0);
     __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i8, gb + 1467972 | 0, i36 + 12 | 0, 0);
     HEAP32[i76 >> 2] = HEAP32[i36 + 8 >> 2];
     HEAP32[i73 >> 2] = HEAP32[i76 >> 2];
     __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i8, gb + 1467968 | 0, i73, 2, 0);
     i31 = i36 + 244 | 0;
     f21 = (HEAP8[i31 >> 0] | 0) == 0 ? Math_fround(0.0) : Math_fround(1.0);
     HEAPF32[i73 >> 2] = f21;
     HEAPF32[i65 >> 2] = f21;
     HEAPF32[i66 >> 2] = f21;
     HEAPF32[i67 >> 2] = Math_fround(0.0);
     __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i8, gb + 1467976 | 0, i73, 0);
     i32 = i36 + 245 | 0;
     f21 = Math_fround((HEAP8[i32 >> 0] | 0) != 0 & 1);
     __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i8, gb + 1467980 | 0, f21, 0);
     i29 = i36 + 228 | 0;
     if (!(HEAP8[i32 >> 0] | 0)) {
      i26 = i36 + 232 | 0;
      i27 = i36 + 236 | 0;
      i28 = i36 + 240 | 0;
      f9 = Math_fround(inf);
      f10 = Math_fround(inf);
      f11 = Math_fround(-inf);
      f12 = Math_fround(-inf);
     } else {
      f12 = Math_fround(HEAPF32[i29 >> 2]);
      i26 = i36 + 232 | 0;
      f11 = Math_fround(HEAPF32[i26 >> 2]);
      i27 = i36 + 236 | 0;
      f10 = Math_fround(f12 + Math_fround(HEAPF32[i27 >> 2]));
      i34 = i36 + 240 | 0;
      i28 = i34;
      f9 = Math_fround(f11 + Math_fround(HEAPF32[i34 >> 2]));
     }
     HEAPF32[i73 >> 2] = f12;
     HEAPF32[i68 >> 2] = f11;
     HEAPF32[i69 >> 2] = f10;
     HEAPF32[i70 >> 2] = f9;
     __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i8, gb + 1467984 | 0, i73, 0);
     HEAP32[i35 + (i14 * 36 | 0) + 4 >> 2] = 0;
     i33 = i35 + (i14 * 36 | 0) + 8 | 0;
     HEAP32[i33 >> 2] = i19 << 1;
     HEAP32[i35 + (i14 * 36 | 0) + 20 >> 2] = 0;
     i34 = i35 + (i14 * 36 | 0) + 16 | 0;
     HEAP32[i34 >> 2] = i23;
     i22 = 0;
     i25 = i36;
     i24 = 0;
     i15 = i23;
     i23 = i18;
     i8 = i19;
     while (1) {
      if ((i25 | 0) != (i36 | 0)) {
       if (HEAP8[i25 + 246 >> 0] | 0) {
        i16 = i24;
        i17 = i23;
        break;
       }
       if ((HEAP32[i36 >> 2] | 0) != (HEAP32[i25 >> 2] | 0)) {
        i16 = i24;
        i17 = i23;
        break;
       }
       i16 = HEAP8[i32 >> 0] | 0;
       if (i16 << 24 >> 24 != (HEAP8[i25 + 245 >> 0] | 0)) {
        i16 = i24;
        i17 = i23;
        break;
       }
       if ((HEAP32[i30 >> 2] | 0) != (HEAP32[i25 + 4 >> 2] | 0)) {
        i16 = i24;
        i17 = i23;
        break;
       }
       if ((HEAP8[i31 >> 0] | 0) != (HEAP8[i25 + 244 >> 0] | 0)) {
        i16 = i24;
        i17 = i23;
        break;
       }
       if (i16 << 24 >> 24) {
        f21 = Math_fround(HEAPF32[i29 >> 2]);
        f21 = Math_fround(f21 - Math_fround(HEAPF32[i25 + 228 >> 2]));
        i19 = f21 < Math_fround(0.0);
        f20 = Math_fround(-f21);
        if (!((i19 ? f20 : f21) <= Math_fround(9.99999997e-07))) {
         i16 = i24;
         i17 = i23;
         break;
        }
        f21 = Math_fround(HEAPF32[i26 >> 2]);
        f21 = Math_fround(f21 - Math_fround(HEAPF32[i25 + 232 >> 2]));
        i19 = f21 < Math_fround(0.0);
        f20 = Math_fround(-f21);
        if (!((i19 ? f20 : f21) <= Math_fround(9.99999997e-07))) {
         i16 = i24;
         i17 = i23;
         break;
        }
        f21 = Math_fround(HEAPF32[i27 >> 2]);
        f21 = Math_fround(f21 - Math_fround(HEAPF32[i25 + 236 >> 2]));
        i19 = f21 < Math_fround(0.0);
        f20 = Math_fround(-f21);
        if (!((i19 ? f20 : f21) <= Math_fround(9.99999997e-07))) {
         i16 = i24;
         i17 = i23;
         break;
        }
        f21 = Math_fround(HEAPF32[i28 >> 2]);
        f21 = Math_fround(f21 - Math_fround(HEAPF32[i25 + 240 >> 2]));
        i19 = f21 < Math_fround(0.0);
        f20 = Math_fround(-f21);
        if (!((i19 ? f20 : f21) <= Math_fround(9.99999997e-07))) {
         i16 = i24;
         i17 = i23;
         break;
        }
       }
      }
      if (!(HEAP8[i25 + 249 >> 0] | 0)) {
       HEAP8[i74 + (i23 * 108 | 0) + 104 >> 0] = 0;
       i18 = i22;
      } else {
       i16 = HEAP32[i25 + 80 >> 2] | 0;
       i22 = i16 + i22 | 0;
       if (i22 >>> 0 > 65535) {
        i16 = i24;
        i17 = i23;
        break;
       }
       i19 = HEAP32[i34 >> 2] | 0;
       HEAP32[i74 + (i23 * 108 | 0) >> 2] = HEAP32[i25 + 28 >> 2];
       HEAP32[i74 + (i23 * 108 | 0) + 4 >> 2] = HEAP32[i25 + 76 >> 2];
       HEAP32[i74 + (i23 * 108 | 0) + 8 >> 2] = i16;
       i15 = i16 + i15 | 0;
       HEAP32[i74 + (i23 * 108 | 0) + 12 >> 2] = HEAP32[i25 + 64 >> 2];
       i16 = HEAP32[i25 + 68 >> 2] | 0;
       HEAP32[i74 + (i23 * 108 | 0) + 16 >> 2] = i16;
       i8 = i16 + i8 | 0;
       i16 = i74 + (i23 * 108 | 0) + 20 | 0;
       i17 = i25 + 88 | 0;
       i18 = i16 + 64 | 0;
       do {
        HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
        i16 = i16 + 4 | 0;
        i17 = i17 + 4 | 0;
       } while ((i16 | 0) < (i18 | 0));
       HEAP32[i74 + (i23 * 108 | 0) + 100 >> 2] = i19;
       if (i71) {
        do if (i42) {
         if (i43) {
          f11 = Math_fround(+Math_pow(+f44, 2.4000001));
          break;
         }
         if (i45) {
          f11 = Math_fround(1.0);
          break;
         }
         f11 = Math_fround(+Math_pow(+f38, 2.20000005));
        } else f11 = f56; while (0);
        do if (i46) {
         if (i47) {
          f21 = Math_fround(+Math_pow(+f48, 2.4000001));
          break;
         }
         if (i49) {
          f21 = Math_fround(1.0);
          break;
         }
         f21 = Math_fround(+Math_pow(+f39, 2.20000005));
        } else f21 = f55; while (0);
        do if (i50) {
         if (i51) {
          f20 = Math_fround(+Math_pow(+f52, 2.4000001));
          break;
         }
         if (i53) {
          f20 = Math_fround(1.0);
          break;
         }
         f20 = Math_fround(+Math_pow(+f40, 2.20000005));
        } else f20 = f54; while (0);
        f9 = Math_fround(HEAPF32[i25 + 208 >> 2]);
        do if (!(f9 <= Math_fround(.0404499993))) {
         if (f9 < Math_fround(1.0)) {
          f10 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f9 == Math_fround(1.0)) {
          f10 = Math_fround(1.0);
          break;
         }
         f10 = Math_fround(+Math_pow(+f9, 2.20000005));
        } else f10 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
        f9 = Math_fround(HEAPF32[i25 + 212 >> 2]);
        do if (!(f9 <= Math_fround(.0404499993))) {
         if (f9 < Math_fround(1.0)) {
          f12 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f9 == Math_fround(1.0)) {
          f12 = Math_fround(1.0);
          break;
         }
         f12 = Math_fround(+Math_pow(+f9, 2.20000005));
        } else f12 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
        f9 = Math_fround(HEAPF32[i25 + 216 >> 2]);
        do if (!(f9 <= Math_fround(.0404499993))) {
         if (f9 < Math_fround(1.0)) {
          f9 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
          break;
         }
         if (f9 == Math_fround(1.0)) {
          f9 = Math_fround(1.0);
          break;
         }
         f9 = Math_fround(+Math_pow(+f9, 2.20000005));
        } else f9 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
        f11 = Math_fround(f11 * f10);
        f10 = Math_fround(f20 * f9);
        f9 = Math_fround(f21 * f12);
       } else {
        f11 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 208 >> 2]));
        f9 = Math_fround(f39 * Math_fround(HEAPF32[i25 + 212 >> 2]));
        f10 = Math_fround(f40 * Math_fround(HEAPF32[i25 + 216 >> 2]));
       }
       f12 = Math_fround(f41 * Math_fround(HEAPF32[i25 + 220 >> 2]));
       f12 = Math_fround(Math_fround(HEAPF32[i25 + 224 >> 2]) * f12);
       HEAPF32[i74 + (i23 * 108 | 0) + 84 >> 2] = f11;
       HEAPF32[i74 + (i23 * 108 | 0) + 88 >> 2] = f9;
       HEAPF32[i74 + (i23 * 108 | 0) + 92 >> 2] = f10;
       HEAPF32[i74 + (i23 * 108 | 0) + 96 >> 2] = f12;
       HEAP8[i74 + (i23 * 108 | 0) + 104 >> 0] = 1;
       f9 = Math_fround(HEAPF32[i25 + 184 >> 2]);
       f10 = Math_fround(HEAPF32[i25 + 188 >> 2]);
       f11 = Math_fround(HEAPF32[i25 + 192 >> 2]);
       f12 = Math_fround(HEAPF32[i25 + 196 >> 2]);
       f20 = Math_fround(HEAPF32[i25 + 200 >> 2]);
       f21 = Math_fround(HEAPF32[i25 + 204 >> 2]);
       i18 = i22;
       f6 = f9 < f6 ? f9 : f6;
       f5 = f10 < f5 ? f10 : f5;
       f4 = f11 < f4 ? f11 : f4;
       f3 = f3 < f12 ? f12 : f3;
       f2 = f2 < f20 ? f20 : f2;
       f1 = f1 < f21 ? f21 : f1;
      }
      i17 = i23 + 1 | 0;
      i16 = i24 + 1 | 0;
      i25 = i25 + 252 | 0;
      if ((i25 | 0) == (i72 | 0)) break; else {
       i22 = i18;
       i24 = i16;
       i23 = i17;
      }
     }
     i33 = HEAP32[i33 >> 2] | 0;
     HEAP32[i35 + (i14 * 36 | 0) + 24 >> 2] = i15 - (HEAP32[i34 >> 2] | 0);
     HEAP32[i35 + (i14 * 36 | 0) + 12 >> 2] = i8 - (i33 >>> 1);
     i36 = i36 + (i16 * 252 | 0) | 0;
     i7 = i7 + 1 | 0;
     if ((i36 | 0) == (i72 | 0)) {
      i16 = i72;
      i14 = i17;
      break;
     } else {
      i23 = i15;
      i18 = i17;
      i19 = i8;
     }
    }
    HEAP32[i37 >> 2] = i7;
    i16 = (i16 - i13 | 0) / 252 | 0;
    i7 = i8;
   } else {
    HEAP8[i7 >> 0] = 1;
    HEAP8[i74 + (i18 * 108 | 0) + 104 >> 0] = 0;
    i16 = 1;
    i15 = i17;
    i14 = i18 + 1 | 0;
    i7 = i19;
   }
   i13 = i13 + (i16 * 252 | 0) | 0;
   if ((i13 | 0) == (i72 | 0)) break; else {
    i17 = i15;
    i18 = i14;
    i19 = i7;
   }
  }
 }
 HEAPF32[i78 + 64 >> 2] = f6;
 HEAPF32[i78 + 68 >> 2] = f5;
 HEAPF32[i78 + 72 >> 2] = f4;
 HEAPF32[i78 + 76 >> 2] = f3;
 HEAPF32[i78 + 80 >> 2] = f2;
 HEAPF32[i78 + 84 >> 2] = f1;
 if (!i77) {
  STACKTOP = i79;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i77);
 STACKTOP = i79;
 return;
}

function __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb(i15, i16, i25, i36, i47, i58, i69) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i25 = i25 | 0;
 i36 = i36 | 0;
 i47 = i47 | 0;
 i58 = i58 | 0;
 i69 = i69 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, i113 = 0, i114 = 0, i115 = 0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0;
 i108 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i80 = i108 + 96 | 0;
 i91 = i108 + 80 | 0;
 i102 = i108 + 32 | 0;
 i17 = i108 + 16 | 0;
 i18 = i108;
 i19 = HEAP32[i47 + 12 >> 2] | 0;
 if (!i19) {
  STACKTOP = i108;
  return;
 }
 i20 = i47 + 500 | 0;
 i21 = i80 + 4 | 0;
 i22 = i80 + 8 | 0;
 i23 = i80 + 12 | 0;
 i24 = i47 + 520 | 0;
 i26 = i17 + 4 | 0;
 i27 = i17 + 8 | 0;
 i28 = i17 + 12 | 0;
 i29 = i15 + 40 | 0;
 i30 = i91 + 4 | 0;
 i31 = i80 + 4 | 0;
 i32 = i91 + 8 | 0;
 i33 = i80 + 8 | 0;
 i34 = i91 + 12 | 0;
 i35 = i80 + 12 | 0;
 i37 = i102 + 4 | 0;
 i38 = i102 + 8 | 0;
 i39 = i102 + 12 | 0;
 i40 = i102 + 16 | 0;
 i41 = i15 + 120 | 0;
 i42 = i15 + 80 | 0;
 i43 = i91 + 4 | 0;
 i44 = i80 + 4 | 0;
 i45 = i91 + 8 | 0;
 i46 = i80 + 8 | 0;
 i48 = i91 + 12 | 0;
 i49 = i80 + 12 | 0;
 i50 = i102 + 20 | 0;
 i51 = i102 + 24 | 0;
 i52 = i102 + 28 | 0;
 i53 = i102 + 32 | 0;
 i54 = i15 + 200 | 0;
 i55 = i15 + 160 | 0;
 i56 = i91 + 4 | 0;
 i57 = i80 + 4 | 0;
 i59 = i91 + 8 | 0;
 i60 = i80 + 8 | 0;
 i61 = i91 + 12 | 0;
 i62 = i80 + 12 | 0;
 i63 = i102 + 36 | 0;
 i64 = i102 + 40 | 0;
 i65 = i102 + 44 | 0;
 i66 = i47 + 540 | 0;
 i67 = i16 + 84 | 0;
 i68 = i25 + 84 | 0;
 i70 = i36 + 84 | 0;
 i71 = i58 + 12 | 0;
 i72 = i58 + 24 | 0;
 i73 = i58 + 4 | 0;
 i74 = i58 + 16 | 0;
 i75 = i58 + 28 | 0;
 i76 = i58 + 8 | 0;
 i77 = i58 + 20 | 0;
 i78 = i58 + 32 | 0;
 i79 = i47 + 20 | 0;
 i81 = i47 + 40 | 0;
 i82 = i47 + 120 | 0;
 i83 = i47 + 140 | 0;
 i84 = i47 + 160 | 0;
 i85 = i47 + 60 | 0;
 i86 = i47 + 80 | 0;
 i87 = i47 + 100 | 0;
 i88 = i36 + 80 | 0;
 i89 = i18 + 12 | 0;
 i90 = i18 + 8 | 0;
 i92 = i18 + 4 | 0;
 i93 = i36 + 232 | 0;
 i94 = i36 + 144 | 0;
 i95 = i25 + 80 | 0;
 i96 = i91 + 12 | 0;
 i97 = i91 + 8 | 0;
 i98 = i91 + 4 | 0;
 i99 = i25 + 232 | 0;
 i100 = i25 + 144 | 0;
 i101 = i16 + 80 | 0;
 i103 = i80 + 12 | 0;
 i104 = i80 + 8 | 0;
 i105 = i80 + 4 | 0;
 i106 = i16 + 232 | 0;
 i107 = i16 + 144 | 0;
 i14 = 0;
 do {
  i115 = (HEAP32[i20 >> 2] | 0) + (i14 << 2) | 0;
  i114 = (HEAP32[i115 + 4 >> 2] | 0) + -520366028 | 0;
  i113 = (HEAP32[i115 + 8 >> 2] | 0) + -520366028 | 0;
  i3 = (HEAP32[i115 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i80 >> 2] = (HEAP32[i115 >> 2] | 0) + -520366028;
  HEAP32[i21 >> 2] = i114;
  HEAP32[i22 >> 2] = i113;
  HEAP32[i23 >> 2] = i3;
  __Z17GenerateRandomNx3RKN4math5_int4E(i102, i80);
  i3 = (HEAP32[i24 >> 2] | 0) + (i14 << 2) | 0;
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f1 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f1 = Math_fround(f1 * Math_fround(.00999999977));
  f111 = Math_fround(f111 * Math_fround(.00999999977));
  f6 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i17 >> 2] = Math_fround(f13 * Math_fround(.00999999977));
  HEAPF32[i26 >> 2] = f1;
  HEAPF32[i27 >> 2] = f111;
  HEAPF32[i28 >> 2] = f6;
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i80, i29, i17);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i91, i15, i17);
  f6 = Math_fround(HEAPF32[i91 >> 2]);
  f111 = Math_fround(HEAPF32[i80 >> 2]);
  f6 = Math_fround(f6 - f111);
  f1 = Math_fround(HEAPF32[i30 >> 2]);
  f13 = Math_fround(HEAPF32[i31 >> 2]);
  f1 = Math_fround(f1 - f13);
  f8 = Math_fround(HEAPF32[i32 >> 2]);
  f4 = Math_fround(HEAPF32[i33 >> 2]);
  f8 = Math_fround(f8 - f4);
  f10 = Math_fround(HEAPF32[i34 >> 2]);
  f12 = Math_fround(HEAPF32[i35 >> 2]);
  f10 = Math_fround(f10 - f12);
  f6 = Math_fround(f6 * Math_fround(HEAPF32[i102 >> 2]));
  f1 = Math_fround(f1 * Math_fround(HEAPF32[i37 >> 2]));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i38 >> 2]));
  f6 = Math_fround(f111 + f6);
  f1 = Math_fround(f13 + f1);
  f8 = Math_fround(f4 + f8);
  f10 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i39 >> 2])));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i80, i41, i17);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i91, i42, i17);
  f12 = Math_fround(HEAPF32[i91 >> 2]);
  f4 = Math_fround(HEAPF32[i80 >> 2]);
  f12 = Math_fround(f12 - f4);
  f13 = Math_fround(HEAPF32[i43 >> 2]);
  f111 = Math_fround(HEAPF32[i44 >> 2]);
  f13 = Math_fround(f13 - f111);
  f11 = Math_fround(HEAPF32[i45 >> 2]);
  f2 = Math_fround(HEAPF32[i46 >> 2]);
  f11 = Math_fround(f11 - f2);
  f9 = Math_fround(HEAPF32[i48 >> 2]);
  f112 = Math_fround(HEAPF32[i49 >> 2]);
  f9 = Math_fround(f9 - f112);
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i40 >> 2]));
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i50 >> 2]));
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i51 >> 2]));
  f12 = Math_fround(f4 + f12);
  f13 = Math_fround(f111 + f13);
  f11 = Math_fround(f2 + f11);
  f9 = Math_fround(f112 + Math_fround(f9 * Math_fround(HEAPF32[i52 >> 2])));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i80, i54, i17);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i91, i55, i17);
  f112 = Math_fround(HEAPF32[i91 >> 2]);
  f2 = Math_fround(HEAPF32[i80 >> 2]);
  f112 = Math_fround(f112 - f2);
  f111 = Math_fround(HEAPF32[i56 >> 2]);
  f4 = Math_fround(HEAPF32[i57 >> 2]);
  f111 = Math_fround(f111 - f4);
  f110 = Math_fround(HEAPF32[i59 >> 2]);
  f5 = Math_fround(HEAPF32[i60 >> 2]);
  f110 = Math_fround(f110 - f5);
  f109 = Math_fround(HEAPF32[i61 >> 2]);
  f7 = Math_fround(HEAPF32[i62 >> 2]);
  f109 = Math_fround(f109 - f7);
  f112 = Math_fround(f112 * Math_fround(HEAPF32[i53 >> 2]));
  f111 = Math_fround(f111 * Math_fround(HEAPF32[i63 >> 2]));
  f110 = Math_fround(f110 * Math_fround(HEAPF32[i64 >> 2]));
  f112 = Math_fround(f2 + f112);
  f111 = Math_fround(f4 + f111);
  f110 = Math_fround(f5 + f110);
  f109 = Math_fround(f7 + Math_fround(f109 * Math_fround(HEAPF32[i65 >> 2])));
  i3 = (HEAP32[i66 >> 2] | 0) + (i14 << 2) | 0;
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f2 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f6 = Math_fround(f6 / f7);
  f1 = Math_fround(f1 / f5);
  f8 = Math_fround(f8 / f4);
  f10 = Math_fround(f10 / f2);
  f12 = Math_fround(f12 / f7);
  f13 = Math_fround(f13 / f5);
  f11 = Math_fround(f11 / f4);
  f9 = Math_fround(f9 / f2);
  f7 = Math_fround(f112 / f7);
  f5 = Math_fround(f111 / f5);
  f4 = Math_fround(f110 / f4);
  f2 = Math_fround(f109 / f2);
  i3 = HEAP32[i67 >> 2] | 0;
  L6 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i101 >> 2] | 0;
    HEAP32[i103 >> 2] = i115;
    HEAP32[i104 >> 2] = i115;
    HEAP32[i105 >> 2] = i115;
    HEAP32[i80 >> 2] = i115;
    break;
   }
  case 3:
   {
    f116 = Math_fround(HEAPF32[(HEAP32[i106 >> 2] | 0) + 4 >> 2]);
    f112 = Math_fround(HEAPF32[i101 >> 2]);
    f116 = Math_fround(f116 * f112);
    f112 = Math_fround(Math_fround(f112 * Math_fround(HEAPF32[(HEAP32[i107 >> 2] | 0) + 4 >> 2])) - f116);
    f109 = Math_fround(Math_fround(HEAPF32[i102 >> 2]) * f112);
    f110 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i37 >> 2])));
    f111 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i38 >> 2])));
    f112 = Math_fround(f116 + Math_fround(f112 * Math_fround(HEAPF32[i39 >> 2])));
    HEAPF32[i80 >> 2] = Math_fround(f116 + f109);
    HEAPF32[i105 >> 2] = f110;
    HEAPF32[i104 >> 2] = f111;
    HEAPF32[i103 >> 2] = f112;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i80, i16, i17, i102);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i80, i16, i17, i102);
    break L6;
   }
  } while (0);
  i3 = HEAP32[i68 >> 2] | 0;
  L14 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i95 >> 2] | 0;
    HEAP32[i96 >> 2] = i115;
    HEAP32[i97 >> 2] = i115;
    HEAP32[i98 >> 2] = i115;
    HEAP32[i91 >> 2] = i115;
    break;
   }
  case 3:
   {
    f109 = Math_fround(HEAPF32[(HEAP32[i99 >> 2] | 0) + 4 >> 2]);
    f116 = Math_fround(HEAPF32[i95 >> 2]);
    f109 = Math_fround(f109 * f116);
    f116 = Math_fround(Math_fround(f116 * Math_fround(HEAPF32[(HEAP32[i100 >> 2] | 0) + 4 >> 2])) - f109);
    f110 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) * f116);
    f111 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i50 >> 2])));
    f112 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i51 >> 2])));
    f116 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i52 >> 2])));
    HEAPF32[i91 >> 2] = Math_fround(f109 + f110);
    HEAPF32[i98 >> 2] = f111;
    HEAPF32[i97 >> 2] = f112;
    HEAPF32[i96 >> 2] = f116;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i91, i25, i17, i40);
    break L14;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i91, i25, i17, i40);
    break L14;
   }
  } while (0);
  i3 = HEAP32[i70 >> 2] | 0;
  L22 : do switch ((i3 & 65535) << 16 >> 16) {
  case 0:
   {
    i115 = HEAP32[i88 >> 2] | 0;
    HEAP32[i89 >> 2] = i115;
    HEAP32[i90 >> 2] = i115;
    HEAP32[i92 >> 2] = i115;
    HEAP32[i18 >> 2] = i115;
    break;
   }
  case 3:
   {
    f109 = Math_fround(HEAPF32[(HEAP32[i93 >> 2] | 0) + 4 >> 2]);
    f116 = Math_fround(HEAPF32[i88 >> 2]);
    f109 = Math_fround(f109 * f116);
    f116 = Math_fround(Math_fround(f116 * Math_fround(HEAPF32[(HEAP32[i94 >> 2] | 0) + 4 >> 2])) - f109);
    f110 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) * f116);
    f111 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i63 >> 2])));
    f112 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i64 >> 2])));
    f116 = Math_fround(f109 + Math_fround(f116 * Math_fround(HEAPF32[i65 >> 2])));
    HEAPF32[i18 >> 2] = Math_fround(f109 + f110);
    HEAPF32[i92 >> 2] = f111;
    HEAPF32[i90 >> 2] = f112;
    HEAPF32[i89 >> 2] = f116;
    break;
   }
  default:
   if (!(i3 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i18, i36, i17, i53);
    break L22;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i18, i36, i17, i53);
    break L22;
   }
  } while (0);
  if (i69) {
   f121 = Math_fround(HEAPF32[i58 >> 2]);
   f123 = Math_fround(f6 * f121);
   f116 = Math_fround(f1 * f121);
   f122 = Math_fround(f8 * f121);
   f121 = Math_fround(f10 * f121);
   f117 = Math_fround(HEAPF32[i71 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f12 * f117));
   f116 = Math_fround(f116 + Math_fround(f13 * f117));
   f122 = Math_fround(f122 + Math_fround(f11 * f117));
   f117 = Math_fround(f121 + Math_fround(f9 * f117));
   f121 = Math_fround(HEAPF32[i72 >> 2]);
   f123 = Math_fround(f123 + Math_fround(f7 * f121));
   f116 = Math_fround(f116 + Math_fround(f5 * f121));
   f122 = Math_fround(f122 + Math_fround(f4 * f121));
   f121 = Math_fround(f117 + Math_fround(f2 * f121));
   f117 = Math_fround(HEAPF32[i73 >> 2]);
   f120 = Math_fround(f6 * f117);
   f119 = Math_fround(f1 * f117);
   f118 = Math_fround(f8 * f117);
   f117 = Math_fround(f10 * f117);
   f112 = Math_fround(HEAPF32[i74 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f12 * f112));
   f119 = Math_fround(f119 + Math_fround(f13 * f112));
   f118 = Math_fround(f118 + Math_fround(f11 * f112));
   f112 = Math_fround(f117 + Math_fround(f9 * f112));
   f117 = Math_fround(HEAPF32[i75 >> 2]);
   f120 = Math_fround(f120 + Math_fround(f7 * f117));
   f119 = Math_fround(f119 + Math_fround(f5 * f117));
   f118 = Math_fround(f118 + Math_fround(f4 * f117));
   f117 = Math_fround(f112 + Math_fround(f2 * f117));
   f112 = Math_fround(HEAPF32[i76 >> 2]);
   f109 = Math_fround(f6 * f112);
   f110 = Math_fround(f1 * f112);
   f111 = Math_fround(f8 * f112);
   f1 = Math_fround(f10 * f112);
   f112 = Math_fround(HEAPF32[i77 >> 2]);
   f109 = Math_fround(f109 + Math_fround(f12 * f112));
   f110 = Math_fround(f110 + Math_fround(f13 * f112));
   f111 = Math_fround(f111 + Math_fround(f11 * f112));
   f112 = Math_fround(f1 + Math_fround(f9 * f112));
   f1 = Math_fround(HEAPF32[i78 >> 2]);
   f6 = f123;
   f8 = f122;
   f10 = f121;
   f12 = f120;
   f13 = f119;
   f11 = f118;
   f9 = f117;
   f7 = Math_fround(f109 + Math_fround(f7 * f1));
   f5 = Math_fround(f110 + Math_fround(f5 * f1));
   f4 = Math_fround(f111 + Math_fround(f4 * f1));
   f2 = Math_fround(f112 + Math_fround(f2 * f1));
   f1 = f116;
  }
  i115 = (HEAP32[i47 >> 2] | 0) + (i14 << 2) | 0;
  f112 = Math_fround(HEAPF32[i115 >> 2]);
  i114 = i115 + 4 | 0;
  f111 = Math_fround(HEAPF32[i114 >> 2]);
  i113 = i115 + 8 | 0;
  f110 = Math_fround(HEAPF32[i113 >> 2]);
  i3 = i115 + 12 | 0;
  f109 = Math_fround(HEAPF32[i3 >> 2]);
  i124 = (HEAP32[i79 >> 2] | 0) + (i14 << 2) | 0;
  f123 = Math_fround(HEAPF32[i124 >> 2]);
  i125 = i124 + 4 | 0;
  f121 = Math_fround(HEAPF32[i125 >> 2]);
  i126 = i124 + 8 | 0;
  f120 = Math_fround(HEAPF32[i126 >> 2]);
  i127 = i124 + 12 | 0;
  f119 = Math_fround(HEAPF32[i127 >> 2]);
  i128 = (HEAP32[i81 >> 2] | 0) + (i14 << 2) | 0;
  f118 = Math_fround(HEAPF32[i128 >> 2]);
  i129 = i128 + 4 | 0;
  f117 = Math_fround(HEAPF32[i129 >> 2]);
  i130 = i128 + 8 | 0;
  f116 = Math_fround(HEAPF32[i130 >> 2]);
  i131 = i128 + 12 | 0;
  f111 = Math_fround(f1 + f111);
  f110 = Math_fround(f8 + f110);
  f109 = Math_fround(f10 + f109);
  f123 = Math_fround(f12 + f123);
  f12 = Math_fround(f13 + f121);
  f10 = Math_fround(f11 + f120);
  f8 = Math_fround(f9 + f119);
  f7 = Math_fround(f7 + f118);
  f5 = Math_fround(f5 + f117);
  f4 = Math_fround(f4 + f116);
  f13 = Math_fround(f2 + Math_fround(HEAPF32[i131 >> 2]));
  HEAPF32[i115 >> 2] = Math_fround(f6 + f112);
  HEAPF32[i114 >> 2] = f111;
  HEAPF32[i113 >> 2] = f110;
  HEAPF32[i3 >> 2] = f109;
  HEAPF32[i124 >> 2] = f123;
  HEAPF32[i125 >> 2] = f12;
  HEAPF32[i126 >> 2] = f10;
  HEAPF32[i127 >> 2] = f8;
  HEAPF32[i128 >> 2] = f7;
  HEAPF32[i129 >> 2] = f5;
  HEAPF32[i130 >> 2] = f4;
  HEAPF32[i131 >> 2] = f13;
  i131 = (HEAP32[i82 >> 2] | 0) + (i14 << 2) | 0;
  f13 = Math_fround(HEAPF32[i131 >> 2]);
  i130 = i131 + 4 | 0;
  f2 = Math_fround(HEAPF32[i130 >> 2]);
  i129 = i131 + 8 | 0;
  f4 = Math_fround(HEAPF32[i129 >> 2]);
  i128 = i131 + 12 | 0;
  f5 = Math_fround(HEAPF32[i128 >> 2]);
  i127 = (HEAP32[i83 >> 2] | 0) + (i14 << 2) | 0;
  f6 = Math_fround(HEAPF32[i127 >> 2]);
  i126 = i127 + 4 | 0;
  f7 = Math_fround(HEAPF32[i126 >> 2]);
  i125 = i127 + 8 | 0;
  f8 = Math_fround(HEAPF32[i125 >> 2]);
  i124 = i127 + 12 | 0;
  f9 = Math_fround(HEAPF32[i124 >> 2]);
  i3 = (HEAP32[i84 >> 2] | 0) + (i14 << 2) | 0;
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  i113 = i3 + 4 | 0;
  f11 = Math_fround(HEAPF32[i113 >> 2]);
  i114 = i3 + 8 | 0;
  f12 = Math_fround(HEAPF32[i114 >> 2]);
  i115 = i3 + 12 | 0;
  f123 = Math_fround(HEAPF32[i115 >> 2]);
  i132 = (HEAP32[i85 >> 2] | 0) + (i14 << 2) | 0;
  f109 = Math_fround(HEAPF32[i132 >> 2]);
  f110 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f111 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f112 = Math_fround(HEAPF32[i132 + 12 >> 2]);
  i132 = (HEAP32[i86 >> 2] | 0) + (i14 << 2) | 0;
  f116 = Math_fround(HEAPF32[i132 >> 2]);
  f117 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f118 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f119 = Math_fround(HEAPF32[i132 + 12 >> 2]);
  i132 = (HEAP32[i87 >> 2] | 0) + (i14 << 2) | 0;
  f120 = Math_fround(HEAPF32[i132 >> 2]);
  f121 = Math_fround(HEAPF32[i132 + 4 >> 2]);
  f122 = Math_fround(HEAPF32[i132 + 8 >> 2]);
  f110 = Math_fround(f2 + f110);
  f111 = Math_fround(f4 + f111);
  f112 = Math_fround(f5 + f112);
  f116 = Math_fround(f6 + f116);
  f117 = Math_fround(f7 + f117);
  f118 = Math_fround(f8 + f118);
  f119 = Math_fround(f9 + f119);
  f120 = Math_fround(f10 + f120);
  f121 = Math_fround(f11 + f121);
  f122 = Math_fround(f12 + f122);
  f123 = Math_fround(f123 + Math_fround(HEAPF32[i132 + 12 >> 2]));
  HEAPF32[i131 >> 2] = Math_fround(f13 + f109);
  HEAPF32[i130 >> 2] = f110;
  HEAPF32[i129 >> 2] = f111;
  HEAPF32[i128 >> 2] = f112;
  HEAPF32[i127 >> 2] = f116;
  HEAPF32[i126 >> 2] = f117;
  HEAPF32[i125 >> 2] = f118;
  HEAPF32[i124 >> 2] = f119;
  HEAPF32[i3 >> 2] = f120;
  HEAPF32[i113 >> 2] = f121;
  HEAPF32[i114 >> 2] = f122;
  HEAPF32[i115 >> 2] = f123;
  i14 = i14 + 4 | 0;
 } while (i14 >>> 0 < i19 >>> 0);
 STACKTOP = i108;
 return;
}

function _unzlocal_GetCurrentFileInfoInternal(i25, i38, i39, i27, i28, i30, i31, i36, i37) {
 i25 = i25 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i40;
 if (!i25) {
  i39 = -102;
  STACKTOP = i40;
  return i39 | 0;
 }
 i33 = i25 + 16 | 0;
 i34 = i25 + 28 | 0;
 i35 = i25 + 32 | 0;
 i29 = (mftCall_iiiii(HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, (HEAP32[i25 + 44 >> 2] | 0) + (HEAP32[i25 + 52 >> 2] | 0) | 0, 0) | 0) == 0;
 i4 = (i29 ^ 1) << 31 >> 31;
 do if (i29) {
  i3 = HEAP32[i35 >> 2] | 0;
  i5 = i25 + 4 | 0;
  if ((mftCall_iiiii(HEAP32[i5 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) i2 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0)) i2 = 0; else {
   i3 = -1;
   i29 = i5;
   break;
  }
  if ((mftCall_iiiii(HEAP32[i5 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) i1 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0)) i1 = i2; else {
   i3 = -1;
   i29 = i5;
   break;
  }
  i2 = i1 << 8 | i2;
  if ((mftCall_iiiii(HEAP32[i5 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) i1 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0) {
   i3 = -1;
   i29 = i5;
   break;
  }
  i2 = (i1 << 16) + i2 | 0;
  if ((mftCall_iiiii(HEAP32[i5 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) i1 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0) {
   i3 = -1;
   i29 = i5;
   break;
  }
  i3 = (i2 + (i1 << 24) | 0) == 33639248 ? i4 : -103;
  i29 = i5;
 } else {
  i3 = -1;
  i29 = i25 + 4 | 0;
 } while (0);
 i2 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i2 | 0, i26 | 0, 1) | 0) == 1) {
  i1 = HEAPU8[i26 >> 0] | 0;
  i32 = 20;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i2 | 0) | 0)) {
  i1 = 0;
  i32 = 20;
 } else {
  i4 = -1;
  i1 = 0;
 }
 do if ((i32 | 0) == 20) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i2 | 0, i26 | 0, 1) | 0) == 1) i1 = (HEAPU8[i26 >> 0] | 0) << 8 | i1; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i2 | 0) | 0)) i1 = i1 * 257 | 0; else {
   i4 = -1;
   i1 = 0;
   break;
  }
  i4 = i3;
 } while (0);
 i3 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) {
  i2 = HEAPU8[i26 >> 0] | 0;
  i32 = 27;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0)) {
  i2 = 0;
  i32 = 27;
 } else {
  i5 = -1;
  i2 = 0;
 }
 do if ((i32 | 0) == 27) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0, i26 | 0, 1) | 0) == 1) i2 = (HEAPU8[i26 >> 0] | 0) << 8 | i2; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i3 | 0) | 0)) i2 = i2 * 257 | 0; else {
   i5 = -1;
   i2 = 0;
   break;
  }
  i5 = i4;
 } while (0);
 i4 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i4 | 0, i26 | 0, 1) | 0) == 1) {
  i3 = HEAPU8[i26 >> 0] | 0;
  i32 = 34;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i4 | 0) | 0)) {
  i3 = 0;
  i32 = 34;
 } else {
  i6 = -1;
  i3 = 0;
 }
 do if ((i32 | 0) == 34) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i4 | 0, i26 | 0, 1) | 0) == 1) i3 = (HEAPU8[i26 >> 0] | 0) << 8 | i3; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i4 | 0) | 0)) i3 = i3 * 257 | 0; else {
   i6 = -1;
   i3 = 0;
   break;
  }
  i6 = i5;
 } while (0);
 i5 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i5 | 0, i26 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i26 >> 0] | 0;
  i32 = 41;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i5 | 0) | 0)) {
  i4 = 0;
  i32 = 41;
 } else {
  i6 = -1;
  i4 = 0;
 }
 do if ((i32 | 0) == 41) if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i5 | 0, i26 | 0, 1) | 0) == 1) i4 = (HEAPU8[i26 >> 0] | 0) << 8 | i4; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i5 | 0) | 0)) i4 = i4 * 257 | 0; else {
  i6 = -1;
  i4 = 0;
  break;
 } while (0);
 i9 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 48;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) {
  i5 = 0;
  i32 = 48;
 } else {
  i6 = -1;
  i24 = 0;
 }
 do if ((i32 | 0) == 48) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i7 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i7 = i5; else {
   i6 = -1;
   i24 = 0;
   break;
  }
  i8 = i7 << 8 | i5;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i5 = i7; else {
   i6 = -1;
   i24 = 0;
   break;
  }
  i7 = (i5 << 16) + i8 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0) {
   i6 = -1;
   i24 = 0;
   break;
  }
  i24 = i7 + (i5 << 24) | 0;
 } while (0);
 i18 = i24 >>> 16 & 31;
 i19 = (i24 >>> 21 & 15) + -1 | 0;
 i20 = (i24 >>> 25) + 1980 | 0;
 i21 = i24 >>> 11 & 31;
 i22 = i24 >>> 5 & 63;
 i23 = i24 << 1 & 62;
 i9 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 61;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) {
  i5 = 0;
  i32 = 61;
 } else {
  i6 = -1;
  i17 = 0;
 }
 do if ((i32 | 0) == 61) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i7 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i7 = i5; else {
   i6 = -1;
   i17 = 0;
   break;
  }
  i8 = i7 << 8 | i5;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i5 = i7; else {
   i6 = -1;
   i17 = 0;
   break;
  }
  i7 = (i5 << 16) + i8 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0) {
   i6 = -1;
   i17 = 0;
   break;
  }
  i17 = i7 + (i5 << 24) | 0;
 } while (0);
 i9 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 74;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) {
  i5 = 0;
  i32 = 74;
 } else {
  i6 = -1;
  i16 = 0;
 }
 do if ((i32 | 0) == 74) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i7 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i7 = i5; else {
   i6 = -1;
   i16 = 0;
   break;
  }
  i8 = i7 << 8 | i5;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i5 = i7; else {
   i6 = -1;
   i16 = 0;
   break;
  }
  i7 = (i5 << 16) + i8 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0) {
   i6 = -1;
   i16 = 0;
   break;
  }
  i16 = i7 + (i5 << 24) | 0;
 } while (0);
 i9 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 87;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) {
  i5 = 0;
  i32 = 87;
 } else {
  i6 = -1;
  i15 = 0;
 }
 do if ((i32 | 0) == 87) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i7 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i7 = i5; else {
   i6 = -1;
   i15 = 0;
   break;
  }
  i8 = i7 << 8 | i5;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0)) i5 = i7; else {
   i6 = -1;
   i15 = 0;
   break;
  }
  i7 = (i5 << 16) + i8 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i9 | 0) | 0) {
   i6 = -1;
   i15 = 0;
   break;
  }
  i15 = i7 + (i5 << 24) | 0;
 } while (0);
 i7 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 100;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) {
  i5 = 0;
  i32 = 100;
 } else {
  i6 = -1;
  i14 = 0;
 }
 do if ((i32 | 0) == 100) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) i5 = (HEAPU8[i26 >> 0] | 0) << 8 | i5; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i6 = -1;
   i14 = 0;
   break;
  }
  i14 = i5;
 } while (0);
 i7 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 107;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) {
  i5 = 0;
  i32 = 107;
 } else {
  i6 = -1;
  i13 = 0;
 }
 do if ((i32 | 0) == 107) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) i5 = (HEAPU8[i26 >> 0] | 0) << 8 | i5; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i6 = -1;
   i13 = 0;
   break;
  }
  i13 = i5;
 } while (0);
 i7 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 114;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) {
  i5 = 0;
  i32 = 114;
 } else {
  i6 = -1;
  i12 = 0;
 }
 do if ((i32 | 0) == 114) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) i5 = (HEAPU8[i26 >> 0] | 0) << 8 | i5; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i6 = -1;
   i12 = 0;
   break;
  }
  i12 = i5;
 } while (0);
 i7 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 121;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) {
  i5 = 0;
  i32 = 121;
 } else {
  i6 = -1;
  i11 = 0;
 }
 do if ((i32 | 0) == 121) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) i5 = (HEAPU8[i26 >> 0] | 0) << 8 | i5; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i6 = -1;
   i11 = 0;
   break;
  }
  i11 = i5;
 } while (0);
 i7 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) {
  i5 = HEAPU8[i26 >> 0] | 0;
  i32 = 128;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) {
  i5 = 0;
  i32 = 128;
 } else {
  i6 = -1;
  i10 = 0;
 }
 do if ((i32 | 0) == 128) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0, i26 | 0, 1) | 0) == 1) i5 = (HEAPU8[i26 >> 0] | 0) << 8 | i5; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i7 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i6 = -1;
   i10 = 0;
   break;
  }
  i10 = i5;
 } while (0);
 i8 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) {
  i7 = HEAPU8[i26 >> 0] | 0;
  i32 = 135;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0)) {
  i7 = 0;
  i32 = 135;
 } else {
  i6 = -1;
  i9 = 0;
 }
 do if ((i32 | 0) == 135) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0)) i5 = i7; else {
   i6 = -1;
   i9 = 0;
   break;
  }
  i7 = i5 << 8 | i7;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0) {
   i6 = -1;
   i9 = 0;
   break;
  }
  i7 = (i5 << 16) + i7 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0) {
   i6 = -1;
   i9 = 0;
   break;
  }
  i9 = i7 + (i5 << 24) | 0;
 } while (0);
 i8 = HEAP32[i35 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) {
  i7 = HEAPU8[i26 >> 0] | 0;
  i32 = 148;
 } else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0)) {
  i7 = 0;
  i32 = 148;
 } else {
  i5 = i14;
  i6 = -1;
  i7 = 0;
  i32 = 169;
 }
 do if ((i32 | 0) == 148) {
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0)) i5 = i7; else {
   i5 = i14;
   i6 = -1;
   i7 = 0;
   i32 = 169;
   break;
  }
  i7 = i5 << 8 | i7;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0) {
   i5 = i14;
   i6 = -1;
   i7 = 0;
   i32 = 169;
   break;
  }
  i7 = (i5 << 16) + i7 | 0;
  if ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0, i26 | 0, 1) | 0) == 1) i5 = HEAPU8[i26 >> 0] | 0; else if (mftCall_iii(HEAP32[i25 + 24 >> 2] | 0, HEAP32[i34 >> 2] | 0, i8 | 0) | 0) {
   i5 = i14;
   i6 = -1;
   i7 = 0;
   i32 = 169;
   break;
  }
  i7 = i7 + (i5 << 24) | 0;
  if ((i27 | 0) != 0 & (i6 | 0) == 0) {
   if (i14 >>> 0 < i28 >>> 0) {
    HEAP8[i27 + i14 >> 0] = 0;
    i5 = i14;
   } else i5 = i28;
   if ((i28 | 0) != 0 & (i14 | 0) != 0) i6 = ((mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i27 | 0, i5 | 0) | 0) != (i5 | 0)) << 31 >> 31; else i6 = 0;
   i5 = i14 - i5 | 0;
  } else i5 = i14;
  if (!((i30 | 0) != 0 & (i6 | 0) == 0)) {
   i32 = 169;
   break;
  }
  i8 = i13 >>> 0 < i31 >>> 0 ? i13 : i31;
  if (!i5) {
   i5 = 0;
   i6 = 0;
  } else {
   i6 = (mftCall_iiiii(HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i5 | 0, 1) | 0) == 0;
   i5 = i6 ? 0 : i5;
   i6 = (i6 ^ 1) << 31 >> 31;
  }
  if ((i31 | 0) != 0 & (i13 | 0) != 0) {
   i31 = (mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i30 | 0, i8 | 0) | 0) == (i8 | 0);
   i6 = i31 ? i6 : -1;
  }
  i8 = i13 - i8 + i5 | 0;
 } while (0);
 if ((i32 | 0) == 169) i8 = i5 + i13 | 0;
 do if ((i36 | 0) != 0 & (i6 | 0) == 0) {
  if (i12 >>> 0 < i37 >>> 0) {
   HEAP8[i36 + i12 >> 0] = 0;
   i5 = i12;
  } else i5 = i37;
  if (!i8) i6 = 0; else i6 = ((mftCall_iiiii(HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i8 | 0, 1) | 0) != 0) << 31 >> 31;
  if (!((i37 | 0) != 0 & (i12 | 0) != 0)) break;
  i37 = (mftCall_iiiii(HEAP32[i29 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i36 | 0, i5 | 0) | 0) == (i5 | 0);
  i6 = i37 ? i6 : -1;
 } while (0);
 i5 = (i6 | 0) == 0;
 if ((i38 | 0) != 0 & i5) {
  HEAP32[i38 >> 2] = i1;
  HEAP32[i38 + 4 >> 2] = i2;
  HEAP32[i38 + 8 >> 2] = i3;
  HEAP32[i38 + 12 >> 2] = i4;
  HEAP32[i38 + 16 >> 2] = i24;
  HEAP32[i38 + 20 >> 2] = i17;
  HEAP32[i38 + 24 >> 2] = i16;
  HEAP32[i38 + 28 >> 2] = i15;
  HEAP32[i38 + 32 >> 2] = i14;
  HEAP32[i38 + 36 >> 2] = i13;
  HEAP32[i38 + 40 >> 2] = i12;
  HEAP32[i38 + 44 >> 2] = i11;
  HEAP32[i38 + 48 >> 2] = i10;
  HEAP32[i38 + 52 >> 2] = i9;
  HEAP32[i38 + 56 >> 2] = i23;
  HEAP32[i38 + 60 >> 2] = i22;
  HEAP32[i38 + 64 >> 2] = i21;
  HEAP32[i38 + 68 >> 2] = i18;
  HEAP32[i38 + 72 >> 2] = i19;
  HEAP32[i38 + 76 >> 2] = i20;
 }
 if (!((i39 | 0) != 0 & i5)) {
  i39 = i6;
  STACKTOP = i40;
  return i39 | 0;
 }
 HEAP32[i39 >> 2] = i7;
 i39 = 0;
 STACKTOP = i40;
 return i39 | 0;
}

function __ZNK5physx13NpVolumeCache10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i67, i65, i73, i63, i60, i59, f64) {
 i67 = i67 | 0;
 i65 = i65 | 0;
 i73 = i73 | 0;
 i63 = i63 | 0;
 i60 = i60 | 0;
 i59 = i59 | 0;
 f64 = Math_fround(f64);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i61 = 0, i62 = 0, i66 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i75;
 i74 = i75 + 48 | 0;
 i61 = i75 + 134 | 0;
 i58 = i75 + 40 | 0;
 i6 = i75 + 136 | 0;
 i66 = i75 + 32 | 0;
 i62 = i75 + 4 | 0;
 i55 = i75 + 132 | 0;
 i72 = i73 + 68 | 0;
 HEAP8[i72 >> 0] = 0;
 i71 = i73 + 80 | 0;
 HEAP32[i71 >> 2] = 0;
 i56 = i60 + 16 | 0;
 i8 = HEAP16[i56 >> 1] | 0;
 HEAP16[i61 >> 1] = i8;
 i4 = i67 + 80 | 0;
 i2 = i67 + 112 | 0;
 i57 = i8 & 65535;
 i1 = i67 + 4 | 0;
 if (!(HEAP8[i67 + 116 >> 0] | 0)) if ((i57 & 1 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0) == (HEAP32[i67 + 108 >> 2] | 0)) i69 = 9; else i69 = 4; else if (!(i57 & 1)) i69 = 9; else i69 = 4;
 if ((i69 | 0) == 4) if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i67, 0, 0, 0) | 0) == 1) i69 = 6; else if ((HEAP32[i1 >> 2] | 0) == -1) i69 = 7; else i69 = 9;
 do if ((i69 | 0) == 9) {
  if (!(HEAP8[i67 + 117 >> 0] | 0)) {
   if (!((i57 & 2 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0) == (HEAP32[i2 >> 2] | 0))) i69 = 78;
  } else if (i57 & 2 | 0) i69 = 78;
  if ((i69 | 0) == 78) {
   if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i67, 1, 0, 0) | 0) == 1) {
    i69 = 6;
    break;
   }
   if ((HEAP32[i1 >> 2] | 0) == -1) {
    i69 = 7;
    break;
   }
  }
  i7 = HEAP32[i67 + 88 >> 2] | 0;
  HEAP32[i58 >> 2] = i7;
  i70 = HEAP32[i67 + 100 >> 2] | 0;
  HEAP32[i58 + 4 >> 2] = i70;
  if (!(i7 | i70)) {
   i74 = 0;
   STACKTOP = i75;
   return i74 | 0;
  }
  i3 = HEAP32[i65 + 8 >> 2] | 0;
  i42 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
  i43 = HEAP32[i67 + 72 >> 2] | 0;
  i1 = HEAP32[i67 + 76 >> 2] | 0;
  i43 = i43 >>> 0 < i1 >>> 0 ? i1 : i43;
  i1 = i43 << 6;
  if (i43 >>> 0 < 128) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i70 = 0;
   i54 = i2;
  } else {
   i54 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i6, i1, gb + 704671 | 0, 615) | 0;
   i70 = i54;
  }
  i20 = (HEAP16[i56 >> 1] & 32) != 0;
  i21 = i73 + 76 | 0;
  i22 = i65 + 4 | 0;
  i23 = i74 + 4 | 0;
  i24 = i74 + 8 | 0;
  i25 = i74 + 12 | 0;
  i26 = i74 + 16 | 0;
  i27 = i74 + 20 | 0;
  i28 = i74 + 44 | 0;
  i29 = i74 + 48 | 0;
  i30 = i74 + 52 | 0;
  i31 = i74 + 68 | 0;
  i32 = i74 + 72 | 0;
  i33 = i74 + 76 | 0;
  i34 = i74 + 80 | 0;
  i44 = i73 + 4 | 0;
  i35 = i74 + 4 | 0;
  i45 = i73 + 16 | 0;
  i46 = i73 + 20 | 0;
  i36 = i74 + 20 | 0;
  i37 = i74 + 24 | 0;
  i47 = i73 + 24 | 0;
  i38 = i74 + 28 | 0;
  i48 = i73 + 28 | 0;
  i49 = i73 + 32 | 0;
  i39 = i74 + 32 | 0;
  i40 = i74 + 36 | 0;
  i50 = i73 + 36 | 0;
  i41 = i74 + 40 | 0;
  i51 = i73 + 40 | 0;
  i52 = i73 + 44 | 0;
  i53 = i73 + 48 | 0;
  i68 = i73 + 72 | 0;
  i19 = (i59 | 0) == 0 | (i8 & 8) == 0;
  i1 = i3;
  i18 = 0;
  L23 : while (1) {
   if (i7) {
    i17 = i67 + 84 + (i18 * 12 | 0) | 0;
    i16 = 0;
    do {
     i2 = (HEAP32[i17 >> 2] | 0) + (i16 << 3) | 0;
     i15 = HEAP32[i2 >> 2] | 0;
     L29 : do if (((i15 | 0 ? (HEAP16[i15 + 4 >> 1] | 0) == 5 : 0) ? 2 : 1) & i57) {
      HEAP32[i66 >> 2] = HEAP32[i21 >> 2] | 0 ? 1 : 2;
      i4 = HEAP16[i63 >> 1] | 0;
      i13 = __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE(i2, i66, i61, i60, i59, i42, i63) | 0;
      i14 = HEAP32[i66 >> 2] | 0;
      if (!((i13 | 0) == 0 | (i14 | 0) == 0)) {
       i15 = i13 + 4 | 0;
       i2 = HEAP32[i15 >> 2] | 0;
       __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE(i62, i2, HEAP32[i13 >> 2] | 0);
       if (!(HEAP32[i2 + 36 >> 2] & 1)) i2 = i2 + 116 | 0; else i2 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
       if ((HEAP32[i2 >> 2] | 0) == 5) if (!(HEAP16[i63 >> 1] & 32)) i3 = 1; else i69 = 23; else i69 = 23;
       if ((i69 | 0) == 23) {
        i69 = 0;
        i3 = i43;
       }
       i11 = HEAP32[i65 >> 2] | 0;
       i12 = HEAP32[i22 >> 2] | 0;
       f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       HEAP16[i74 >> 1] = i4;
       i12 = __ZN5physx15PxGeometryQuery7raycastERKNS_6PxVec3ES3_RKNS_10PxGeometryERKNS_11PxTransformEfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEb(i11, i12, i2, i62, f5, i74, i3, i54, 0) | 0;
       if (i12) {
        i11 = i1;
        i1 = 0;
        while (1) {
         i3 = i54 + (i1 << 6) | 0;
         HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
         HEAP32[i54 + (i1 << 6) + 4 >> 2] = HEAP32[i15 >> 2];
         i2 = i54 + (i1 << 6) + 12 | 0;
         i4 = HEAP16[i2 >> 1] | 0;
         if (!(i4 & 4)) HEAPF32[i54 + (i1 << 6) + 40 >> 2] = Math_fround(0.0);
         if (!(i4 & 1)) {
          HEAP32[i54 + (i1 << 6) + 16 >> 2] = 0;
          HEAP32[i54 + (i1 << 6) + 20 >> 2] = 0;
          HEAP32[i54 + (i1 << 6) + 24 >> 2] = 0;
         }
         if (!(i4 & 2)) {
          HEAP32[i54 + (i1 << 6) + 28 >> 2] = 0;
          HEAP32[i54 + (i1 << 6) + 32 >> 2] = 0;
          HEAP32[i54 + (i1 << 6) + 36 >> 2] = 0;
         }
         if (!(i4 & 8)) {
          HEAPF32[i54 + (i1 << 6) + 44 >> 2] = Math_fround(0.0);
          HEAPF32[i54 + (i1 << 6) + 48 >> 2] = Math_fround(0.0);
         }
         if (i19) i4 = i14; else i4 = mftCall_iiii(HEAP32[(HEAP32[i59 >> 2] | 0) + 4 >> 2] | 0, i59 | 0, i60 | 0, i3 | 0) | 0;
         if ((i4 | 0) != 0 & (HEAP16[i56 >> 1] & 16) != 0) {
          i69 = 37;
          break L23;
         }
         L60 : do switch ((i20 ? 1 : i4) | 0) {
         case 1:
          {
           i6 = HEAP32[i21 >> 2] | 0;
           if (!i6) {
            i2 = i11;
            break L60;
           }
           if (!(Math_fround(HEAPF32[i3 + 40 >> 2]) <= (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
            i2 = i11;
            break L60;
           }
           i4 = HEAP32[i71 >> 2] | 0;
           if ((i4 | 0) == (i6 | 0)) {
            HEAP32[i23 >> 2] = 0;
            HEAP32[i24 >> 2] = 0;
            HEAP32[i25 >> 2] = -1;
            HEAP16[i26 >> 1] = 0;
            HEAP32[i27 >> 2] = 0;
            HEAP32[i27 + 4 >> 2] = 0;
            HEAP32[i27 + 8 >> 2] = 0;
            HEAP32[i27 + 12 >> 2] = 0;
            HEAP32[i27 + 16 >> 2] = 0;
            HEAP32[i27 + 20 >> 2] = 0;
            HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
            HEAPF32[i29 >> 2] = Math_fround(0.0);
            HEAPF32[i30 >> 2] = Math_fround(0.0);
            HEAP8[i31 >> 0] = 0;
            HEAP32[i32 >> 2] = 0;
            HEAP32[i33 >> 2] = 0;
            HEAP32[i34 >> 2] = 0;
            HEAP32[i74 >> 2] = gb + 85940 + 8;
            HEAP16[i55 >> 1] = HEAP16[i63 >> 1] | 0;
            if (__ZNK5physx13NpVolumeCache10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i67, i65, i74, i55, i60, i59, f64) | 0) {
             HEAP32[i44 >> 2] = HEAP32[i35 >> 2];
             HEAP32[i44 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
             HEAP32[i44 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
             HEAP16[i45 >> 1] = HEAP16[i26 >> 1] | 0;
             HEAP32[i46 >> 2] = HEAP32[i36 >> 2];
             HEAP32[i47 >> 2] = HEAP32[i37 >> 2];
             HEAP32[i48 >> 2] = HEAP32[i38 >> 2];
             HEAP32[i49 >> 2] = HEAP32[i39 >> 2];
             HEAP32[i50 >> 2] = HEAP32[i40 >> 2];
             HEAP32[i51 >> 2] = HEAP32[i41 >> 2];
             i10 = HEAP32[i28 >> 2] | 0;
             HEAP32[i52 >> 2] = i10;
             HEAP32[i53 >> 2] = HEAP32[i29 >> 2];
             HEAP32[i53 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
             HEAP32[i53 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
             HEAP32[i53 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
             HEAP32[i53 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
             HEAP8[i72 >> 0] = 1;
             i8 = HEAP32[i68 >> 2] | 0;
             i9 = HEAP32[i71 >> 2] | 0;
             f5 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
             if (!i9) i4 = 0; else {
              i10 = 0;
              i4 = i9;
              do {
               i6 = i8 + (i10 << 6) + 40 | 0;
               if (Math_fround(HEAPF32[i6 >> 2]) > f5) {
                i4 = i4 + -1 | 0;
                i83 = HEAP16[i8 + (i4 << 6) + 12 >> 1] | 0;
                i82 = HEAP32[i8 + (i4 << 6) + 16 >> 2] | 0;
                i81 = HEAP32[i8 + (i4 << 6) + 20 >> 2] | 0;
                i80 = HEAP32[i8 + (i4 << 6) + 24 >> 2] | 0;
                i79 = HEAP32[i8 + (i4 << 6) + 28 >> 2] | 0;
                i78 = HEAP32[i8 + (i4 << 6) + 32 >> 2] | 0;
                i77 = HEAP32[i8 + (i4 << 6) + 36 >> 2] | 0;
                i76 = HEAP32[i8 + (i4 << 6) + 40 >> 2] | 0;
                _memmove(i8 + (i10 << 6) | 0, i8 + (i4 << 6) | 0, 12) | 0;
                HEAP16[i8 + (i10 << 6) + 12 >> 1] = i83;
                HEAP32[i8 + (i10 << 6) + 16 >> 2] = i82;
                HEAP32[i8 + (i10 << 6) + 20 >> 2] = i81;
                HEAP32[i8 + (i10 << 6) + 24 >> 2] = i80;
                HEAP32[i8 + (i10 << 6) + 28 >> 2] = i79;
                HEAP32[i8 + (i10 << 6) + 32 >> 2] = i78;
                HEAP32[i8 + (i10 << 6) + 36 >> 2] = i77;
                HEAP32[i6 >> 2] = i76;
                _memmove(i8 + (i10 << 6) + 44 | 0, i8 + (i4 << 6) + 44 | 0, 20) | 0;
               }
               i10 = i10 + 1 | 0;
              } while ((i10 | 0) != (i9 | 0));
             }
             HEAP32[i71 >> 2] = i4;
            } else i4 = HEAP32[i71 >> 2] | 0;
            if ((i4 | 0) == (HEAP32[i21 >> 2] | 0)) {
             if (!(mftCall_iiii(HEAP32[HEAP32[i73 >> 2] >> 2] | 0, i73 | 0, HEAP32[i68 >> 2] | 0, i4 | 0) | 0)) {
              i69 = 53;
              break L23;
             }
             HEAP32[i71 >> 2] = 0;
             i4 = 0;
            }
           }
           HEAP32[i71 >> 2] = i4 + 1;
           i83 = HEAP32[i68 >> 2] | 0;
           i82 = i83 + (i4 << 6) | 0;
           HEAP32[i82 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i82 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i82 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           HEAP16[i83 + (i4 << 6) + 12 >> 1] = HEAP16[i2 >> 1] | 0;
           HEAP32[i83 + (i4 << 6) + 16 >> 2] = HEAP32[i54 + (i1 << 6) + 16 >> 2];
           HEAP32[i83 + (i4 << 6) + 20 >> 2] = HEAP32[i54 + (i1 << 6) + 20 >> 2];
           HEAP32[i83 + (i4 << 6) + 24 >> 2] = HEAP32[i54 + (i1 << 6) + 24 >> 2];
           HEAP32[i83 + (i4 << 6) + 28 >> 2] = HEAP32[i54 + (i1 << 6) + 28 >> 2];
           HEAP32[i83 + (i4 << 6) + 32 >> 2] = HEAP32[i54 + (i1 << 6) + 32 >> 2];
           HEAP32[i83 + (i4 << 6) + 36 >> 2] = HEAP32[i54 + (i1 << 6) + 36 >> 2];
           HEAP32[i83 + (i4 << 6) + 40 >> 2] = HEAP32[i54 + (i1 << 6) + 40 >> 2];
           i2 = i83 + (i4 << 6) + 44 | 0;
           i83 = i54 + (i1 << 6) + 44 | 0;
           HEAP32[i2 >> 2] = HEAP32[i83 >> 2];
           HEAP32[i2 + 4 >> 2] = HEAP32[i83 + 4 >> 2];
           HEAP32[i2 + 8 >> 2] = HEAP32[i83 + 8 >> 2];
           HEAP32[i2 + 12 >> 2] = HEAP32[i83 + 12 >> 2];
           HEAP32[i2 + 16 >> 2] = HEAP32[i83 + 16 >> 2];
           i2 = i11;
           break;
          }
         case 2:
          {
           f5 = Math_fround(HEAPF32[i3 + 40 >> 2]);
           if (!(f5 <= (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
            i2 = i11;
            break L60;
           }
           i83 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
           HEAP32[i44 >> 2] = HEAP32[i3 >> 2];
           HEAP32[i44 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
           HEAP32[i44 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
           HEAP16[i45 >> 1] = HEAP16[i2 >> 1] | 0;
           HEAP32[i46 >> 2] = HEAP32[i54 + (i1 << 6) + 16 >> 2];
           HEAP32[i47 >> 2] = HEAP32[i54 + (i1 << 6) + 20 >> 2];
           HEAP32[i48 >> 2] = HEAP32[i54 + (i1 << 6) + 24 >> 2];
           HEAP32[i49 >> 2] = HEAP32[i54 + (i1 << 6) + 28 >> 2];
           HEAP32[i50 >> 2] = HEAP32[i54 + (i1 << 6) + 32 >> 2];
           HEAP32[i51 >> 2] = HEAP32[i54 + (i1 << 6) + 36 >> 2];
           HEAP32[i52 >> 2] = HEAP32[i54 + (i1 << 6) + 40 >> 2];
           i2 = i54 + (i1 << 6) + 44 | 0;
           HEAP32[i53 >> 2] = HEAP32[i2 >> 2];
           HEAP32[i53 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
           HEAP32[i53 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
           HEAP32[i53 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
           HEAP32[i53 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
           HEAP8[i72 >> 0] = 1;
           i2 = i83;
           break;
          }
         default:
          i2 = i11;
         } while (0);
         i1 = i1 + 1 | 0;
         if (i1 >>> 0 >= i12 >>> 0) {
          i1 = i2;
          break L29;
         } else i11 = i2;
        }
       }
      }
     } while (0);
     i16 = i16 + 1 | 0;
    } while (i16 >>> 0 < i7 >>> 0);
   }
   i2 = i18 + 1 | 0;
   if (i2 >>> 0 >= 2) {
    i69 = 61;
    break;
   }
   i7 = HEAP32[i58 + (i2 << 2) >> 2] | 0;
   i18 = i2;
  }
  if ((i69 | 0) == 37) {
   HEAP32[i44 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i44 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i44 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP16[i45 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP32[i46 >> 2] = HEAP32[i54 + (i1 << 6) + 16 >> 2];
   HEAP32[i47 >> 2] = HEAP32[i54 + (i1 << 6) + 20 >> 2];
   HEAP32[i48 >> 2] = HEAP32[i54 + (i1 << 6) + 24 >> 2];
   HEAP32[i49 >> 2] = HEAP32[i54 + (i1 << 6) + 28 >> 2];
   HEAP32[i50 >> 2] = HEAP32[i54 + (i1 << 6) + 32 >> 2];
   HEAP32[i51 >> 2] = HEAP32[i54 + (i1 << 6) + 36 >> 2];
   HEAP32[i52 >> 2] = HEAP32[i54 + (i1 << 6) + 40 >> 2];
   i1 = i54 + (i1 << 6) + 44 | 0;
   HEAP32[i53 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i53 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   mftCall_vi(HEAP32[(HEAP32[i73 >> 2] | 0) + 4 >> 2] | 0, i73 | 0);
   HEAP8[i72 >> 0] = 1;
   i1 = 1;
  } else if ((i69 | 0) == 53) {
   mftCall_vi(HEAP32[(HEAP32[i73 >> 2] | 0) + 4 >> 2] | 0, i73 | 0);
   i1 = (HEAP8[i72 >> 0] | 0) != 0;
  } else if ((i69 | 0) == 61) {
   i1 = HEAP32[i71 >> 2] | 0;
   if (!(HEAP8[i72 >> 0] | 0)) i69 = 68; else if (i1 | 0) {
    i4 = HEAP32[i68 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i73 + 4 + 40 >> 2]);
    i6 = 0;
    i2 = i1;
    do {
     i3 = i4 + (i6 << 6) + 40 | 0;
     if (Math_fround(HEAPF32[i3 >> 2]) > f5) {
      i2 = i2 + -1 | 0;
      i76 = HEAP16[i4 + (i2 << 6) + 12 >> 1] | 0;
      i77 = HEAP32[i4 + (i2 << 6) + 16 >> 2] | 0;
      i78 = HEAP32[i4 + (i2 << 6) + 20 >> 2] | 0;
      i79 = HEAP32[i4 + (i2 << 6) + 24 >> 2] | 0;
      i80 = HEAP32[i4 + (i2 << 6) + 28 >> 2] | 0;
      i81 = HEAP32[i4 + (i2 << 6) + 32 >> 2] | 0;
      i82 = HEAP32[i4 + (i2 << 6) + 36 >> 2] | 0;
      i83 = HEAP32[i4 + (i2 << 6) + 40 >> 2] | 0;
      _memmove(i4 + (i6 << 6) | 0, i4 + (i2 << 6) | 0, 12) | 0;
      HEAP16[i4 + (i6 << 6) + 12 >> 1] = i76;
      HEAP32[i4 + (i6 << 6) + 16 >> 2] = i77;
      HEAP32[i4 + (i6 << 6) + 20 >> 2] = i78;
      HEAP32[i4 + (i6 << 6) + 24 >> 2] = i79;
      HEAP32[i4 + (i6 << 6) + 28 >> 2] = i80;
      HEAP32[i4 + (i6 << 6) + 32 >> 2] = i81;
      HEAP32[i4 + (i6 << 6) + 36 >> 2] = i82;
      HEAP32[i3 >> 2] = i83;
      _memmove(i4 + (i6 << 6) + 44 | 0, i4 + (i2 << 6) + 44 | 0, 20) | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    i1 = i2;
    HEAP32[i71 >> 2] = i1;
    i69 = 68;
   }
   if ((i69 | 0) == 68) if (i1 | 0) if (mftCall_iiii(HEAP32[HEAP32[i73 >> 2] >> 2] | 0, i73 | 0, HEAP32[i68 >> 2] | 0, i1 | 0) | 0) HEAP32[i71 >> 2] = 0;
   mftCall_vi(HEAP32[(HEAP32[i73 >> 2] | 0) + 4 >> 2] | 0, i73 | 0);
   i1 = (HEAP8[i72 >> 0] | 0) != 0;
  }
  if (i70 | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i74, i70);
  i83 = i1;
  STACKTOP = i75;
  return i83 | 0;
 } while (0);
 if ((i69 | 0) == 6) if ((HEAP32[i1 >> 2] | 0) == -1) i69 = 7;
 if ((i69 | 0) == 7) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 128, gb + 704671 | 0, 582, gb + 704746 | 0, i3);
 i81 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
 i80 = HEAP32[(HEAP32[i81 >> 2] | 0) + 348 >> 2] | 0;
 i82 = HEAP32[i65 >> 2] | 0;
 i83 = HEAP32[i65 + 4 >> 2] | 0;
 f64 = Math_fround(HEAPF32[i65 + 8 >> 2]);
 HEAP16[i74 >> 1] = HEAP16[i63 >> 1] | 0;
 mftCall_iiiifiiiii(i80 | 0, i81 | 0, i82 | 0, i83 | 0, +f64, i73 | 0, i74 | 0, i60 | 0, i59 | 0, 0) | 0;
 i83 = (HEAP8[i72 >> 0] | 0) != 0 | (HEAP32[i71 >> 2] | 0) != 0;
 STACKTOP = i75;
 return i83 | 0;
}

function __ZN7mecanim5human15HumanPoseMirrorERNS0_9HumanPoseERKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, i61 = 0, f62 = f0, i63 = 0;
 i41 = i1 + 600 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 604 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 612 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 616 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 624 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 628 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 636 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 640 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 648 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 656 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 664 | 0;
 HEAPF32[i41 >> 2] = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i41 = i1 + 732 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 768 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 736 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 772 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 740 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 776 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 744 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 780 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 748 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 784 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 752 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 788 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 756 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 792 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 760 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 796 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 764 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 800 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 668 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 700 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 672 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 704 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 676 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 708 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 680 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 712 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 684 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 716 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 688 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 720 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 692 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 724 | 0;
 HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i41 >> 2] = i34;
 i41 = i1 + 696 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i63 = i1 + 728 | 0;
 HEAP32[i41 >> 2] = HEAP32[i63 >> 2];
 HEAP32[i63 >> 2] = i34;
 i63 = i1 + 68 | 0;
 i34 = HEAP32[i63 >> 2] | 0;
 i41 = i1 + 72 | 0;
 i46 = HEAP32[i41 >> 2] | 0;
 i21 = i1 + 76 | 0;
 i48 = HEAP32[i21 >> 2] | 0;
 i17 = i1 + 80 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i19 = i1 + 84 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i14 = i1 + 88 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i16 = i1 + 92 | 0;
 i38 = HEAP32[i16 >> 2] | 0;
 i57 = i1 + 96 | 0;
 i11 = HEAP32[i57 >> 2] | 0;
 i43 = i1 + 100 | 0;
 i54 = HEAP32[i43 >> 2] | 0;
 i44 = i1 + 104 | 0;
 i56 = HEAP32[i44 >> 2] | 0;
 i61 = i1 + 132 | 0;
 i36 = i1 + 136 | 0;
 i23 = HEAP32[i36 >> 2] | 0;
 i37 = i1 + 140 | 0;
 i9 = HEAP32[i37 >> 2] | 0;
 HEAP32[i63 >> 2] = HEAP32[i61 >> 2];
 HEAP32[i41 >> 2] = i23;
 HEAP32[i21 >> 2] = i9;
 i21 = i1 + 144 | 0;
 i9 = i1 + 148 | 0;
 i41 = HEAP32[i9 >> 2] | 0;
 i23 = i1 + 152 | 0;
 i42 = HEAP32[i23 >> 2] | 0;
 i2 = i1 + 156 | 0;
 i40 = HEAP32[i2 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 >> 2] = i41;
 HEAP32[i14 >> 2] = i42;
 HEAP32[i16 >> 2] = i40;
 i40 = i1 + 160 | 0;
 i42 = i1 + 164 | 0;
 i41 = HEAP32[i42 >> 2] | 0;
 i58 = i1 + 168 | 0;
 i20 = HEAP32[i58 >> 2] | 0;
 HEAP32[i57 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i43 >> 2] = i41;
 HEAP32[i44 >> 2] = i20;
 HEAP32[i61 >> 2] = i34;
 HEAP32[i36 >> 2] = i46;
 HEAP32[i37 >> 2] = i48;
 HEAP32[i21 >> 2] = i3;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i23 >> 2] = i6;
 HEAP32[i2 >> 2] = i38;
 HEAP32[i40 >> 2] = i11;
 HEAP32[i42 >> 2] = i54;
 HEAP32[i58 >> 2] = i56;
 i58 = i1 + 196 | 0;
 f32 = Math_fround(HEAPF32[i58 >> 2]);
 i56 = i1 + 200 | 0;
 i42 = HEAP32[i56 >> 2] | 0;
 i54 = i1 + 204 | 0;
 i40 = HEAP32[i54 >> 2] | 0;
 i11 = i1 + 208 | 0;
 i38 = HEAP32[i11 >> 2] | 0;
 i6 = i1 + 212 | 0;
 f31 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i1 + 216 | 0;
 f29 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i1 + 220 | 0;
 i37 = HEAP32[i3 >> 2] | 0;
 i48 = i1 + 224 | 0;
 i36 = HEAP32[i48 >> 2] | 0;
 i46 = i1 + 228 | 0;
 i34 = HEAP32[i46 >> 2] | 0;
 i44 = i1 + 232 | 0;
 i20 = HEAP32[i44 >> 2] | 0;
 i43 = i1 + 260 | 0;
 f59 = Math_fround(HEAPF32[i43 >> 2]);
 i41 = i1 + 264 | 0;
 i57 = HEAP32[i41 >> 2] | 0;
 i39 = i1 + 268 | 0;
 i55 = HEAP32[i39 >> 2] | 0;
 i8 = i1 + 272 | 0;
 i53 = HEAP32[i8 >> 2] | 0;
 i5 = i1 + 276 | 0;
 f52 = Math_fround(HEAPF32[i5 >> 2]);
 i12 = i1 + 280 | 0;
 f51 = Math_fround(HEAPF32[i12 >> 2]);
 i10 = i1 + 284 | 0;
 i50 = HEAP32[i10 >> 2] | 0;
 i35 = i1 + 288 | 0;
 i49 = HEAP32[i35 >> 2] | 0;
 i22 = i1 + 292 | 0;
 i47 = HEAP32[i22 >> 2] | 0;
 i15 = i1 + 296 | 0;
 i45 = HEAP32[i15 >> 2] | 0;
 f62 = Math_fround(HEAPF32[i63 >> 2]);
 f27 = Math_fround(HEAPF32[i17 >> 2]);
 f18 = Math_fround(HEAPF32[i19 >> 2]);
 f24 = Math_fround(HEAPF32[i14 >> 2]);
 f30 = Math_fround(HEAPF32[i16 >> 2]);
 f33 = Math_fround(-f24);
 HEAPF32[i63 >> 2] = Math_fround(-f62);
 f62 = Math_fround(HEAPF32[i61 >> 2]);
 f7 = Math_fround(HEAPF32[i21 >> 2]);
 f26 = Math_fround(HEAPF32[i9 >> 2]);
 f25 = Math_fround(HEAPF32[i23 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 f60 = Math_fround(-f26);
 f13 = Math_fround(-f25);
 HEAPF32[i61 >> 2] = Math_fround(-f62);
 HEAPF32[i9 >> 2] = f60;
 HEAPF32[i23 >> 2] = f13;
 f52 = Math_fround(-f52);
 f51 = Math_fround(-f51);
 HEAPF32[i58 >> 2] = Math_fround(-f59);
 HEAP32[i56 >> 2] = i57;
 HEAP32[i54 >> 2] = i55;
 HEAP32[i11 >> 2] = i53;
 HEAPF32[i6 >> 2] = f52;
 HEAPF32[i4 >> 2] = f51;
 HEAP32[i3 >> 2] = i50;
 HEAP32[i48 >> 2] = i49;
 HEAP32[i46 >> 2] = i47;
 HEAP32[i44 >> 2] = i45;
 f31 = Math_fround(-f31);
 f29 = Math_fround(-f29);
 HEAPF32[i43 >> 2] = Math_fround(-f32);
 HEAP32[i41 >> 2] = i42;
 HEAP32[i39 >> 2] = i40;
 HEAP32[i8 >> 2] = i38;
 HEAPF32[i5 >> 2] = f31;
 HEAPF32[i12 >> 2] = f29;
 HEAP32[i10 >> 2] = i37;
 HEAP32[i35 >> 2] = i36;
 HEAP32[i22 >> 2] = i34;
 HEAP32[i15 >> 2] = i20;
 f29 = Math_fround(f18 * Math_fround(-0.0));
 f31 = Math_fround(f30 * Math_fround(0.0));
 f32 = Math_fround(f27 * Math_fround(0.0));
 f24 = Math_fround(f24 * Math_fround(-0.0));
 f27 = Math_fround(Math_fround(Math_fround(f29 - f31) - f24) - f27);
 f18 = Math_fround(Math_fround(Math_fround(f31 - f32) - f24) + f18);
 f31 = Math_fround(Math_fround(Math_fround(f33 - f29) - f31) - f32);
 f29 = Math_fround(Math_fround(Math_fround(f32 - f24) - f30) - f29);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f29 = (HEAP32[tempDoublePtr >> 2] = i20 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f29 * f29);
 f27 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f27 * f27);
 f24 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f24 * f24)) + Math_fround(f31 + f30)))));
 f27 = Math_fround(f30 * f27);
 f24 = Math_fround(f30 * f24);
 f18 = Math_fround(f30 * f18);
 HEAPF32[i17 >> 2] = Math_fround(f30 * f29);
 HEAPF32[i19 >> 2] = f27;
 HEAPF32[i14 >> 2] = f24;
 HEAPF32[i16 >> 2] = f18;
 f18 = Math_fround(f26 * Math_fround(-0.0));
 f24 = Math_fround(f28 * Math_fround(0.0));
 f27 = Math_fround(f7 * Math_fround(0.0));
 f25 = Math_fround(f25 * Math_fround(-0.0));
 f7 = Math_fround(Math_fround(Math_fround(f18 - f24) - f25) - f7);
 f26 = Math_fround(Math_fround(Math_fround(f24 - f27) - f25) + f26);
 f24 = Math_fround(Math_fround(Math_fround(f13 - f18) - f24) - f27);
 f18 = Math_fround(Math_fround(Math_fround(f27 - f25) - f28) - f18);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f18 = (HEAP32[tempDoublePtr >> 2] = i14 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f18 * f18);
 f7 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f7 * f7);
 f25 = (HEAP32[tempDoublePtr >> 2] = i16 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25)) + Math_fround(f24 + f28)))));
 f7 = Math_fround(f28 * f7);
 f25 = Math_fround(f28 * f25);
 f26 = Math_fround(f28 * f26);
 HEAPF32[i21 >> 2] = Math_fround(f28 * f18);
 HEAPF32[i9 >> 2] = f7;
 HEAPF32[i23 >> 2] = f25;
 HEAPF32[i2 >> 2] = f26;
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f25 = Math_fround(f26 * Math_fround(0.0));
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(f7 * Math_fround(0.0));
 f28 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(f28 * Math_fround(0.0));
 f27 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f27 * Math_fround(0.0));
 f7 = Math_fround(Math_fround(Math_fround(f25 - f7) - f24) - f13);
 f28 = Math_fround(Math_fround(Math_fround(f18 - f13) - f28) - f25);
 f13 = Math_fround(Math_fround(Math_fround(f24 - f26) - f18) - f13);
 f25 = Math_fround(Math_fround(Math_fround(f27 - f24) - f18) - f25);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i23 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f25 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f25 * f25);
 f7 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(f7 * f7);
 f24 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f24 * f24)) + Math_fround(f13 + f18)))));
 f7 = Math_fround(f18 * f7);
 f24 = Math_fround(f18 * f24);
 f28 = Math_fround(f18 * f28);
 HEAPF32[i11 >> 2] = Math_fround(f18 * f25);
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i4 >> 2] = f24;
 HEAPF32[i3 >> 2] = f28;
 f28 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(f28 * Math_fround(0.0));
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f25 = Math_fround(f7 * Math_fround(0.0));
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 f13 = Math_fround(f18 * Math_fround(0.0));
 f27 = Math_fround(HEAPF32[i8 >> 2]);
 f26 = Math_fround(f27 * Math_fround(0.0));
 f7 = Math_fround(Math_fround(Math_fround(f24 - f7) - f13) - f26);
 f18 = Math_fround(Math_fround(Math_fround(f25 - f26) - f18) - f24);
 f26 = Math_fround(Math_fround(Math_fround(f13 - f28) - f25) - f26);
 f24 = Math_fround(Math_fround(Math_fround(f27 - f13) - f25) - f24);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f24 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f24 * f24);
 f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f7 * f7);
 f13 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f13 * f13)) + Math_fround(f26 + f25)))));
 f7 = Math_fround(f25 * f7);
 f13 = Math_fround(f25 * f13);
 f18 = Math_fround(f25 * f18);
 HEAPF32[i8 >> 2] = Math_fround(f25 * f24);
 HEAPF32[i5 >> 2] = f7;
 HEAPF32[i12 >> 2] = f13;
 HEAPF32[i10 >> 2] = f18;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 i10 = i1 + 16 | 0;
 f13 = Math_fround(HEAPF32[i10 >> 2]);
 i12 = i1 + 20 | 0;
 f13 = Math_fround(-f13);
 f7 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(-f18);
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i12 >> 2] = f7;
 i12 = i1 + 364 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 500 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 368 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 504 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 372 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 508 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 376 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 512 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 380 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 516 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 384 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 520 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 388 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 524 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 392 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 528 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 396 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 532 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 400 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 536 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 404 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 540 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 408 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 544 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 412 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 548 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 416 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 552 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 420 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 556 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 424 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 560 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 428 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 564 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 432 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 568 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 436 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i5 = i1 + 572 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i5 = i1 + 440 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = i1 + 576 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 i12 = i1 + 804 | 0;
 HEAPF32[i12 >> 2] = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 i12 = i1 + 816 | 0;
 HEAPF32[i12 >> 2] = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 i12 = i1 + 828 | 0;
 HEAPF32[i12 >> 2] = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 i12 = i1 + 840 | 0;
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 i10 = i1 + 844 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i8 = i1 + 848 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 f7 = Math_fround(-f7);
 i6 = i1 + 852 | 0;
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i1 + 856 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 860 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 f13 = Math_fround(-f13);
 i23 = i1 + 864 | 0;
 f18 = Math_fround(HEAPF32[i23 >> 2]);
 i21 = i1 + 868 | 0;
 i16 = HEAP32[i21 >> 2] | 0;
 i19 = i1 + 872 | 0;
 i14 = HEAP32[i19 >> 2] | 0;
 f18 = Math_fround(-f18);
 i17 = i1 + 876 | 0;
 f24 = Math_fround(HEAPF32[i17 >> 2]);
 i15 = i1 + 880 | 0;
 i22 = HEAP32[i15 >> 2] | 0;
 i1 = i1 + 884 | 0;
 i20 = HEAP32[i1 >> 2] | 0;
 HEAPF32[i23 >> 2] = Math_fround(-f24);
 HEAP32[i21 >> 2] = i22;
 HEAP32[i19 >> 2] = i20;
 HEAPF32[i17 >> 2] = f18;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i1 >> 2] = i14;
 HEAPF32[i12 >> 2] = f13;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i8 >> 2] = i9;
 HEAPF32[i6 >> 2] = f7;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i55, i56, i62, i1, i82, i83, i84, i85, i87, i89, i75) {
 i55 = i55 | 0;
 i56 = i56 | 0;
 i62 = i62 | 0;
 i1 = i1 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 i85 = i85 | 0;
 i87 = i87 | 0;
 i89 = i89 | 0;
 i75 = i75 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, f74 = f0, f76 = f0, f77 = f0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i86 = 0, i88 = 0, i90 = 0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0;
 i90 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i90 + 288 | 0;
 i69 = i90 + 468 | 0;
 i68 = i90 + 456 | 0;
 i80 = i90 + 304 | 0;
 i78 = i90 + 224 | 0;
 i79 = i90 + 160 | 0;
 i86 = i90 + 440 | 0;
 i88 = i90 + 424 | 0;
 i63 = i90 + 416 | 0;
 i81 = i90 + 144 | 0;
 i34 = i90 + 128 | 0;
 i33 = i90 + 112 | 0;
 i35 = i90 + 404 | 0;
 i36 = i90 + 96 | 0;
 i64 = i90 + 80 | 0;
 i71 = i90 + 64 | 0;
 i72 = i90 + 48 | 0;
 i70 = i90 + 392 | 0;
 i59 = i90 + 32 | 0;
 i58 = i90 + 380 | 0;
 i66 = i90 + 16 | 0;
 i67 = i90;
 i65 = i90 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i60 = i55 + 16 | 0;
 f76 = Math_fround(HEAPF32[i60 >> 2]);
 i61 = i56 + 16 | 0;
 f77 = Math_fround(HEAPF32[i61 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i55 + 32 >> 2]);
 f74 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f57 = Math_fround((f57 > f74 ? f74 : f57) * Math_fround(.100000001));
 f57 = Math_fround(f57 * f57);
 f74 = Math_fround(f76 + f77);
 HEAP32[i63 >> 2] = 0;
 i1 = HEAP8[i75 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i62 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i62 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i62 + 56 >> 2]);
  i54 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i54 ? f5 : Math_fround(1.0);
  f6 = i54 ? f6 : Math_fround(0.0);
  f7 = i54 ? f7 : Math_fround(0.0);
  HEAPF32[i81 >> 2] = f5;
  HEAPF32[i81 + 4 >> 2] = f6;
  HEAPF32[i81 + 8 >> 2] = f7;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i36 >> 2] = HEAP32[i81 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i81 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i81 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i81 + 12 >> 2];
  i54 = i81;
  i53 = i36;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i73 = 7;
 } else {
  HEAP32[i34 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i55 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i55 + 148 >> 2]);
  f4 = Math_fround(f4 - f76);
  f5 = Math_fround(f5 - f76);
  f6 = Math_fround(Math_fround(HEAPF32[i55 + 152 >> 2]) - f76);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f11 = Math_fround(-f6);
  f12 = Math_fround(HEAPF32[i62 + 48 >> 2]);
  f13 = Math_fround(HEAPF32[i62 + 52 >> 2]);
  f14 = Math_fround(HEAPF32[i62 + 56 >> 2]);
  f15 = Math_fround(HEAPF32[i62 >> 2]);
  f16 = Math_fround(HEAPF32[i62 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i62 + 32 >> 2]);
  f18 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i62 + 20 >> 2]);
  f20 = Math_fround(HEAPF32[i62 + 36 >> 2]);
  f21 = Math_fround(HEAPF32[i62 + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i62 + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i62 + 40 >> 2]);
  f24 = Math_fround(HEAPF32[i56 + 144 >> 2]);
  f25 = Math_fround(HEAPF32[i56 + 148 >> 2]);
  f24 = Math_fround(f24 - f77);
  f25 = Math_fround(f25 - f77);
  f26 = Math_fround(Math_fround(HEAPF32[i56 + 152 >> 2]) - f77);
  f27 = Math_fround(-f24);
  f28 = Math_fround(-f25);
  f29 = Math_fround(-f26);
  i30 = i34 + 4 | 0;
  i31 = i34 + 8 | 0;
  i32 = i34 + 12 | 0;
  i2 = i1 & 255;
  i9 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i53 = HEAPU8[i87 + i3 >> 0] | 0;
   HEAP32[i86 + (i3 << 2) >> 2] = i53;
   i54 = HEAPU8[i89 + i3 >> 0] | 0;
   HEAP32[i88 + (i3 << 2) >> 2] = i54;
   f92 = HEAP32[gb + 48 + (i53 << 4) >> 2] | 0 ? f4 : f7;
   f93 = HEAP32[gb + 48 + (i53 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f94 = HEAP32[gb + 48 + (i53 << 4) + 8 >> 2] | 0 ? f6 : f11;
   f96 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f92 * f15) + Math_fround(f93 * f16)) + Math_fround(f94 * f17)));
   f95 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f92 * f18) + Math_fround(f93 * f19)) + Math_fround(f94 * f20)));
   f94 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f92 * f21) + Math_fround(f93 * f22)) + Math_fround(f94 * f23)));
   f93 = HEAP32[gb + 48 + (i54 << 4) >> 2] | 0 ? f24 : f27;
   f92 = HEAP32[gb + 48 + (i54 << 4) + 4 >> 2] | 0 ? f25 : f28;
   f91 = HEAP32[gb + 48 + (i54 << 4) + 8 >> 2] | 0 ? f26 : f29;
   f98 = Math_fround(f95 - f92);
   f97 = Math_fround(f94 - f91);
   HEAPF32[i34 >> 2] = Math_fround(f96 - f93);
   HEAPF32[i30 >> 2] = f98;
   HEAPF32[i31 >> 2] = f97;
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   HEAPF32[i78 + (i1 << 4) >> 2] = f96;
   HEAPF32[i78 + (i1 << 4) + 4 >> 2] = f95;
   HEAPF32[i78 + (i1 << 4) + 8 >> 2] = f94;
   HEAPF32[i78 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i79 + (i1 << 4) >> 2] = f93;
   HEAPF32[i79 + (i1 << 4) + 4 >> 2] = f92;
   HEAPF32[i79 + (i1 << 4) + 8 >> 2] = f91;
   HEAPF32[i79 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i54 = i80 + (i1 << 4) | 0;
   HEAP32[i54 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i54 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i63 >> 2] = i9;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i33, i80, i78, i79, i86, i88, i34, i63);
  HEAP32[i81 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i81 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i81 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i81 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i81 >> 2]);
  f6 = Math_fround(HEAPF32[i81 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i81 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i69 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i69 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i69 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i68 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i36 >> 2] = HEAP32[i81 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i81 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i81 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i81 + 12 >> 2];
  if (f4 > f57) {
   i54 = i81;
   i53 = i36;
   i73 = 7;
  } else i2 = HEAP32[i63 >> 2] | 0;
 }
 do if ((i73 | 0) == 7) {
  i51 = i81 + 4 | 0;
  i52 = i81 + 8 | 0;
  i31 = i55 + 144 | 0;
  i32 = i55 + 148 | 0;
  i33 = i55 + 152 | 0;
  i34 = i62 + 4 | 0;
  i35 = i62 + 8 | 0;
  i36 = i62 + 16 | 0;
  i37 = i62 + 20 | 0;
  i38 = i62 + 24 | 0;
  i39 = i62 + 32 | 0;
  i40 = i62 + 36 | 0;
  i41 = i62 + 40 | 0;
  i42 = i62 + 48 | 0;
  i43 = i62 + 52 | 0;
  i44 = i62 + 56 | 0;
  i45 = i56 + 144 | 0;
  i46 = i56 + 148 | 0;
  i47 = i56 + 152 | 0;
  i48 = i64 + 4 | 0;
  i49 = i64 + 8 | 0;
  i50 = i64 + 12 | 0;
  i30 = i55 + 48 | 0;
  i9 = i56 + 48 | 0;
  while (1) {
   HEAP32[i68 >> 2] = HEAP32[i69 >> 2];
   HEAP32[i68 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
   HEAP32[i68 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
   HEAP32[i53 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
   f29 = Math_fround(-f5);
   f91 = Math_fround(-f6);
   f92 = Math_fround(-f7);
   i3 = HEAP32[i63 >> 2] | 0;
   f23 = Math_fround(HEAPF32[i31 >> 2]);
   f27 = Math_fround(HEAPF32[i32 >> 2]);
   f25 = Math_fround(HEAPF32[i33 >> 2]);
   f24 = Math_fround(HEAPF32[i60 >> 2]);
   f23 = Math_fround(f23 - f24);
   f27 = Math_fround(f27 - f24);
   f24 = Math_fround(f25 - f24);
   f25 = Math_fround(HEAPF32[i62 >> 2]);
   f22 = Math_fround(f25 * f29);
   f28 = Math_fround(HEAPF32[i34 >> 2]);
   f22 = Math_fround(f22 + Math_fround(f28 * f91));
   f96 = Math_fround(HEAPF32[i35 >> 2]);
   f22 = Math_fround(f22 + Math_fround(f96 * f92));
   f26 = Math_fround(HEAPF32[i36 >> 2]);
   f93 = Math_fround(f26 * f29);
   f98 = Math_fround(HEAPF32[i37 >> 2]);
   f93 = Math_fround(f93 + Math_fround(f98 * f91));
   f94 = Math_fround(HEAPF32[i38 >> 2]);
   f93 = Math_fround(f93 + Math_fround(f94 * f92));
   f95 = Math_fround(HEAPF32[i39 >> 2]);
   f29 = Math_fround(f95 * f29);
   f97 = Math_fround(HEAPF32[i40 >> 2]);
   f91 = Math_fround(f29 + Math_fround(f97 * f91));
   f29 = Math_fround(HEAPF32[i41 >> 2]);
   i2 = f22 > Math_fround(0.0);
   i56 = f93 > Math_fround(0.0);
   i55 = Math_fround(f91 + Math_fround(f29 * f92)) > Math_fround(0.0);
   HEAP32[i86 + (i3 << 2) >> 2] = i56 << 31 >> 31 << 1 & 2 | i2 & 1 | i55 << 31 >> 31 << 2 & 4;
   f92 = Math_fround(-f23);
   f91 = Math_fround(-f27);
   f93 = Math_fround(-f24);
   f92 = i2 ? f23 : f92;
   f91 = i56 ? f27 : f91;
   f93 = i55 ? f24 : f93;
   f24 = Math_fround(HEAPF32[i42 >> 2]);
   f27 = Math_fround(HEAPF32[i43 >> 2]);
   f95 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f25 * f92) + Math_fround(f26 * f91)) + Math_fround(f95 * f93)));
   f97 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f28 * f92) + Math_fround(f98 * f91)) + Math_fround(f97 * f93)));
   f93 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) + Math_fround(Math_fround(Math_fround(f96 * f92) + Math_fround(f94 * f91)) + Math_fround(f29 * f93)));
   HEAPF32[i78 + (i3 << 4) >> 2] = f95;
   HEAPF32[i78 + (i3 << 4) + 4 >> 2] = f97;
   HEAPF32[i78 + (i3 << 4) + 8 >> 2] = f93;
   HEAPF32[i78 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f29 = Math_fround(HEAPF32[i45 >> 2]);
   f91 = Math_fround(HEAPF32[i46 >> 2]);
   f94 = Math_fround(HEAPF32[i47 >> 2]);
   f92 = Math_fround(HEAPF32[i61 >> 2]);
   f29 = Math_fround(f29 - f92);
   f91 = Math_fround(f91 - f92);
   f92 = Math_fround(f94 - f92);
   i55 = f5 > Math_fround(0.0);
   i56 = f6 > Math_fround(0.0);
   i2 = f7 > Math_fround(0.0);
   HEAP32[i88 + (i3 << 2) >> 2] = i56 << 31 >> 31 << 1 & 2 | i55 & 1 | i2 << 31 >> 31 << 2 & 4;
   f94 = Math_fround(-f29);
   f96 = Math_fround(-f91);
   f98 = Math_fround(-f92);
   f94 = i55 ? f29 : f94;
   f96 = i56 ? f91 : f96;
   f98 = i2 ? f92 : f98;
   HEAPF32[i79 + (i3 << 4) >> 2] = f94;
   HEAPF32[i79 + (i3 << 4) + 4 >> 2] = f96;
   HEAPF32[i79 + (i3 << 4) + 8 >> 2] = f98;
   HEAPF32[i79 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f94 = Math_fround(f95 - f94);
   f96 = Math_fround(f97 - f96);
   f98 = Math_fround(f93 - f98);
   HEAPF32[i64 >> 2] = f94;
   HEAPF32[i48 >> 2] = f96;
   HEAPF32[i49 >> 2] = f98;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i63 >> 2] | 0;
   i2 = i80 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
   f93 = Math_fround(HEAPF32[i30 >> 2]);
   f97 = Math_fround(HEAPF32[i9 >> 2]);
   f97 = f93 > f97 ? f93 : f97;
   f10 = f10 > f97 ? f10 : f97;
   f97 = Math_fround(f74 + f10);
   f97 = Math_fround(f4 * Math_fround(f97 * f97));
   f93 = Math_fround(HEAPF32[i81 >> 2]);
   f95 = Math_fround(HEAPF32[i51 >> 2]);
   f98 = Math_fround(Math_fround(Math_fround(f93 * f94) + Math_fround(f95 * f96)) + Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f98));
   i2 = f98 > Math_fround(0.0) & Math_fround(f98 * f98) > f97;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f98) | i2) {
    i73 = 9;
    break;
   }
   HEAP32[i63 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i59, i80, i78, i79, i86, i88, i64, i63);
   HEAP32[i54 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i54 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i81 >> 2]);
   f6 = Math_fround(HEAPF32[i51 >> 2]);
   f7 = Math_fround(HEAPF32[i52 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i69 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f57 & i1)) break; else f4 = f8;
  }
  if ((i73 | 0) == 9) {
   if (i87 | 0) {
    HEAP8[i75 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
      HEAP8[i89 + i1 >> 0] = HEAP32[i88 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i89 = 0;
    STACKTOP = i90;
    return i89 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i80, i78, i79, i81, i71, i72, i3);
   f95 = Math_fround(Math_sqrt(Math_fround(f4)));
   f96 = Math_fround(HEAPF32[i81 >> 2]);
   f97 = Math_fround(HEAPF32[i51 >> 2]);
   f98 = Math_fround(Math_fround(1.0) / f95);
   f96 = Math_fround(f96 * f98);
   f97 = Math_fround(f97 * f98);
   f98 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f98);
   f94 = Math_fround(HEAPF32[i71 >> 2]);
   f93 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f93 = Math_fround(f93 - Math_fround(f76 * f97));
   f92 = Math_fround(Math_fround(HEAPF32[i71 + 8 >> 2]) - Math_fround(f76 * f98));
   HEAPF32[i82 >> 2] = Math_fround(f94 - Math_fround(f76 * f96));
   HEAPF32[i82 + 4 >> 2] = f93;
   HEAPF32[i82 + 8 >> 2] = f92;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   f92 = Math_fround(HEAPF32[i72 >> 2]);
   f93 = Math_fround(HEAPF32[i72 + 4 >> 2]);
   f93 = Math_fround(Math_fround(f77 * f97) + f93);
   f94 = Math_fround(Math_fround(f77 * f98) + Math_fround(HEAPF32[i72 + 8 >> 2]));
   HEAPF32[i83 >> 2] = Math_fround(Math_fround(f77 * f96) + f92);
   HEAPF32[i83 + 4 >> 2] = f93;
   HEAPF32[i83 + 8 >> 2] = f94;
   HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i85 >> 2] = Math_fround(f95 - f74);
   i89 = i85 + 4 | 0;
   HEAP32[i89 >> 2] = HEAP32[i70 >> 2];
   HEAP32[i89 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
   HEAP32[i89 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
   HEAPF32[i84 >> 2] = f96;
   HEAPF32[i84 + 4 >> 2] = f97;
   HEAPF32[i84 + 8 >> 2] = f98;
   HEAPF32[i84 + 12 >> 2] = Math_fround(0.0);
   i89 = 1;
   STACKTOP = i90;
   return i89 | 0;
  }
  i2 = HEAP32[i63 >> 2] | 0;
  if (i1) {
   if (!i87) i1 = 6; else break;
   STACKTOP = i90;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i87 | 0) {
   HEAP8[i75 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
     HEAP8[i89 + i1 >> 0] = HEAP32[i88 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i54 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i80, i78, i79, i81, i66, i67, i2);
  HEAP32[i69 >> 2] = HEAP32[i68 >> 2];
  HEAP32[i69 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
  HEAP32[i69 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
  f95 = Math_fround(Math_sqrt(Math_fround(f4)));
  f96 = Math_fround(HEAPF32[i81 >> 2]);
  f97 = Math_fround(HEAPF32[i81 + 4 >> 2]);
  f98 = Math_fround(Math_fround(1.0) / f95);
  f96 = Math_fround(f96 * f98);
  f97 = Math_fround(f97 * f98);
  f98 = Math_fround(Math_fround(HEAPF32[i81 + 8 >> 2]) * f98);
  f94 = Math_fround(HEAPF32[i66 >> 2]);
  f93 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f93 = Math_fround(f93 - Math_fround(f76 * f97));
  f92 = Math_fround(Math_fround(HEAPF32[i66 + 8 >> 2]) - Math_fround(f76 * f98));
  HEAPF32[i82 >> 2] = Math_fround(f94 - Math_fround(f76 * f96));
  HEAPF32[i82 + 4 >> 2] = f93;
  HEAPF32[i82 + 8 >> 2] = f92;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  f92 = Math_fround(HEAPF32[i67 >> 2]);
  f93 = Math_fround(HEAPF32[i67 + 4 >> 2]);
  f93 = Math_fround(Math_fround(f77 * f97) + f93);
  f94 = Math_fround(Math_fround(f77 * f98) + Math_fround(HEAPF32[i67 + 8 >> 2]));
  HEAPF32[i83 >> 2] = Math_fround(Math_fround(f77 * f96) + f92);
  HEAPF32[i83 + 4 >> 2] = f93;
  HEAPF32[i83 + 8 >> 2] = f94;
  HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i85 >> 2] = Math_fround(f95 - f74);
  i89 = i85 + 4 | 0;
  HEAP32[i89 >> 2] = HEAP32[i65 >> 2];
  HEAP32[i89 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
  HEAP32[i89 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
  HEAPF32[i84 >> 2] = f96;
  HEAPF32[i84 + 4 >> 2] = f97;
  HEAPF32[i84 + 8 >> 2] = f98;
  HEAPF32[i84 + 12 >> 2] = Math_fround(0.0);
  i89 = 3;
  STACKTOP = i90;
  return i89 | 0;
 } while (0);
 HEAP8[i75 >> 0] = i2;
 if (!i2) {
  i89 = 6;
  STACKTOP = i90;
  return i89 | 0;
 } else i1 = 0;
 do {
  HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
  HEAP8[i89 + i1 >> 0] = HEAP32[i88 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i90;
 return i1 | 0;
}

function __ZN16MemoryFileSystem10AtomicMoveER13FileEntryDataS1_(i38, i1, i6) {
 i38 = i38 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i49;
 i40 = i49 + 96 | 0;
 i48 = i49 + 80 | 0;
 i42 = i49 + 60 | 0;
 i43 = i49 + 48 | 0;
 i44 = i49 + 36 | 0;
 i41 = i49 + 24 | 0;
 i39 = i49 + 12 | 0;
 HEAP32[i48 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i48 >> 2] = 0;
 HEAP32[i48 + 4 >> 2] = 0;
 HEAP32[i48 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i38, i1, i48);
 i46 = i48 + 11 | 0;
 i2 = HEAP8[i46 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i48 + 4 >> 2] | 0 : i2 & 255) | 0)) i1 = 0; else {
  do if (mftCall_iii(HEAP32[(HEAP32[i38 >> 2] | 0) + 80 >> 2] | 0, i38 | 0, i6 | 0) | 0) i1 = 0; else {
   i37 = i38 + 4 | 0;
   i3 = (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i48 >> 2] | 0 : i48;
   HEAP32[i40 >> 2] = 0;
   HEAP32[i40 + 4 >> 2] = 0;
   HEAP32[i40 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i40 + 12 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
    i1 = HEAP32[i40 + 12 >> 2] | 0;
    i45 = 6;
   } else if (i4 >>> 0 < 11) {
    i2 = i40 + 11 | 0;
    HEAP8[i2 >> 0] = i4;
    if (!i4) i1 = i40; else {
     i1 = i40;
     i45 = 8;
    }
   } else i45 = 6;
   if ((i45 | 0) == 6) {
    i2 = i4 + 16 & -16;
    HEAP32[i47 >> 2] = 54;
    HEAP32[i47 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i47, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i40 >> 2] = i1;
    HEAP32[i40 + 8 >> 2] = i2 | -2147483648;
    HEAP32[i40 + 4 >> 2] = i4;
    i2 = i40 + 11 | 0;
    i45 = 8;
   }
   if ((i45 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i37, i40) | 0;
   if ((HEAP8[i2 >> 0] | 0) < 0) {
    i36 = HEAP32[i40 >> 2] | 0;
    i35 = HEAP32[i40 + 12 >> 2] | 0;
    HEAP32[i47 >> 2] = 54;
    HEAP32[i47 + 4 >> 2] = i35;
    __Z19free_alloc_internalPvRK10MemLabelId(i36, i47);
   }
   i36 = i38 + 8 | 0;
   if ((i1 | 0) == (i36 | 0)) i1 = 0; else {
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    HEAP32[i40 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i40 >> 2] = 0;
    HEAP32[i40 + 4 >> 2] = 0;
    HEAP32[i40 + 8 >> 2] = 0;
    __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i38, i6, i40);
    i35 = i38 + 4 | 0;
    i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i35, i40) | 0;
    if ((i1 | 0) == (i36 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
    if ((HEAP8[i40 + 11 >> 0] | 0) < 0) {
     i34 = HEAP32[i40 >> 2] | 0;
     i33 = HEAP32[i40 + 12 >> 2] | 0;
     HEAP32[i47 >> 2] = 54;
     HEAP32[i47 + 4 >> 2] = i33;
     __Z19free_alloc_internalPvRK10MemLabelId(i34, i47);
    }
    if (i1 | 0) {
     if (!(HEAP32[i1 >> 2] | 0)) i2 = 0; else i2 = (HEAP32[i1 + 12 >> 2] | 0) == 2;
     if ((i1 | 0) == (i5 | 0) | i2) {
      i1 = 0;
      break;
     }
    }
    HEAP32[i42 >> 2] = 0;
    i32 = i42 + 12 | 0;
    HEAP32[i32 >> 2] = 0;
    i33 = i42 + 16 | 0;
    HEAP32[i33 >> 2] = 0;
    i34 = i42 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i47, gb + 63664 | 0);
    i4 = i47;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    i2 = i34;
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i2 + 4 >> 2] = i3;
    i2 = (HEAP32[i32 >> 2] | 0) + 1 | 0;
    i3 = HEAP32[i33 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i2 >>> 0 > i4 >>> 0) {
     i1 = i3 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i33 >> 2] = i1;
      HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i1 * 1088 | 0, 8, i34, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 1088 | 0, 8, i34, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i31 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i32 >> 2] | 0) * 1088 | 0) | 0;
      HEAP32[i33 >> 2] = i1;
      HEAP32[i42 >> 2] = i31;
      break;
     }
    } while (0);
    HEAP32[i32 >> 2] = i2;
    i1 = HEAP32[i42 >> 2] | 0;
    _strncpy(i1, (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i48 >> 2] | 0 : i48, 1040) | 0;
    HEAP8[i1 + 1039 >> 0] = 0;
    i1 = i5 + 24 | 0;
    i2 = HEAP8[i1 + 11 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i2 = HEAP32[i5 + 28 >> 2] | 0; else i2 = i2 & 255;
    do if (!i2) i1 = (HEAP8[i46 >> 0] | 0) < 0 ? HEAP32[i48 >> 2] | 0 : i48; else if (i3) {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    } else break; while (0);
    HEAP32[i43 >> 2] = 0;
    HEAP32[i43 + 4 >> 2] = 0;
    HEAP32[i43 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i43, i1, _strlen(i1) | 0);
    HEAP32[i44 >> 2] = 0;
    HEAP32[i44 + 4 >> 2] = 0;
    HEAP32[i44 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i44, i6, _strlen(i6) | 0);
    L47 : do if (!(HEAP32[i5 >> 2] | 0)) {
     mftCall_iiiiiii(HEAP32[(HEAP32[i38 >> 2] | 0) + 148 >> 2] | 0, i38 | 0, ((HEAP8[i43 + 11 >> 0] | 0) < 0 ? HEAP32[i43 >> 2] | 0 : i43) | 0, i42 | 0, 1, 0, 0) | 0;
     if (!(HEAP32[i32 >> 2] | 0)) i1 = 1; else {
      i3 = i40 + 12 | 0;
      i4 = i40 + 11 | 0;
      i5 = i40 + 12 | 0;
      i6 = i47 + 4 | 0;
      i2 = 0;
      while (1) {
       i1 = (HEAP32[i42 >> 2] | 0) + (i2 * 1088 | 0) | 0;
       HEAP32[i3 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i40 >> 2] = 0;
       HEAP32[i40 + 4 >> 2] = 0;
       HEAP32[i40 + 8 >> 2] = 0;
       __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i38, i1, i40);
       i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i35, i40) | 0;
       if ((i1 | 0) == (i36 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
       if ((HEAP8[i4 >> 0] | 0) < 0) {
        i31 = HEAP32[i40 >> 2] | 0;
        i30 = HEAP32[i5 >> 2] | 0;
        HEAP32[i47 >> 2] = 54;
        HEAP32[i6 >> 2] = i30;
        __Z19free_alloc_internalPvRK10MemLabelId(i31, i47);
       }
       if (HEAP32[i1 >> 2] | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == 2) {
        i1 = 0;
        break L47;
       }
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i32 >> 2] | 0;
       if (i2 >>> 0 >= i1 >>> 0) {
        i45 = 36;
        break;
       }
      }
     }
    } else {
     i1 = HEAP32[i32 >> 2] | 0;
     i45 = 36;
    } while (0);
    L62 : do if ((i45 | 0) == 36) if (!i1) i1 = 1; else {
     i7 = i41 + 11 | 0;
     i8 = i41 + 4 | 0;
     i9 = i40 + 12 | 0;
     i5 = i40 + 12 | 0;
     i10 = i47 + 4 | 0;
     i11 = i40 + 8 | 0;
     i12 = i40 + 4 | 0;
     i13 = i40 + 11 | 0;
     i14 = i47 + 4 | 0;
     i15 = i39 + 11 | 0;
     i16 = i40 + 12 | 0;
     i17 = i40 + 11 | 0;
     i18 = i40 + 12 | 0;
     i19 = i47 + 4 | 0;
     i20 = i40 + 12 | 0;
     i6 = i40 + 12 | 0;
     i21 = i47 + 4 | 0;
     i22 = i40 + 8 | 0;
     i23 = i40 + 4 | 0;
     i24 = i40 + 11 | 0;
     i25 = i47 + 4 | 0;
     i26 = i38 + 16 | 0;
     i27 = i38 + 12 | 0;
     i28 = i38 + 8 | 0;
     i29 = i47 + 4 | 0;
     i30 = i47 + 4 | 0;
     i31 = i47 + 4 | 0;
     i4 = 0;
     L65 : while (1) {
      i2 = (HEAP32[i42 >> 2] | 0) + (i4 * 1088 | 0) | 0;
      HEAP32[i41 >> 2] = 0;
      HEAP32[i41 + 4 >> 2] = 0;
      HEAP32[i41 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i41, i2, _strlen(i2) | 0);
      i3 = HEAP8[i7 >> 0] | 0;
      i1 = i3 << 24 >> 24 < 0;
      if ((i1 ? HEAP32[i8 >> 2] | 0 : i3 & 255) | 0) {
       i1 = i1 ? HEAP32[i41 >> 2] | 0 : i41;
       do {
        i50 = HEAP8[i1 >> 0] | 0;
        i3 = i50 << 24 >> 24;
        HEAP8[i1 >> 0] = (i50 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
        i1 = i1 + 1 | 0;
        i3 = HEAP8[i7 >> 0] | 0;
        i50 = i3 << 24 >> 24 < 0;
       } while ((i1 | 0) != ((i50 ? HEAP32[i41 >> 2] | 0 : i41) + (i50 ? HEAP32[i8 >> 2] | 0 : i3 & 255) | 0));
      };
      HEAP32[i47 >> 2] = 0;
      HEAP32[i47 + 4 >> 2] = 0;
      HEAP32[i47 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i47, i2, _strlen(i2) | 0);
      __Z22ReplaceDirectoryInPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_(i39, i47, i43, i44);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i47);
      i2 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i41 >> 2] | 0 : i41;
      HEAP32[i40 >> 2] = 0;
      HEAP32[i40 + 4 >> 2] = 0;
      HEAP32[i40 + 8 >> 2] = 0;
      i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
      HEAP32[i9 >> 2] = i1;
      i3 = _strlen(i2) | 0;
      do if (i3 >>> 0 > 2147483631) {
       __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
       i1 = HEAP32[i5 >> 2] | 0;
       i45 = 51;
      } else {
       if (i3 >>> 0 >= 11) {
        i45 = 51;
        break;
       }
       HEAP8[i13 >> 0] = i3;
       if (!i3) i1 = i40; else {
        i1 = i40;
        i45 = 53;
       }
      } while (0);
      if ((i45 | 0) == 51) {
       i50 = i3 + 16 & -16;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i10 >> 2] = i1;
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i50, 16, i47, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i40 >> 2] = i1;
       HEAP32[i11 >> 2] = i50 | -2147483648;
       HEAP32[i12 >> 2] = i3;
       i45 = 53;
      }
      if ((i45 | 0) == 53) {
       i45 = 0;
       _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
      }
      HEAP8[i1 + i3 >> 0] = 0;
      i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i37, i40) | 0;
      if ((HEAP8[i13 >> 0] | 0) < 0) {
       i50 = HEAP32[i40 >> 2] | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i14 >> 2] = i3;
       __Z19free_alloc_internalPvRK10MemLabelId(i50, i47);
      }
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = (HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i39 >> 2] | 0 : i39;
      HEAP32[i16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
      HEAP32[i40 >> 2] = 0;
      HEAP32[i40 + 4 >> 2] = 0;
      HEAP32[i40 + 8 >> 2] = 0;
      __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i38, i1, i40);
      i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i35, i40) | 0;
      if ((i1 | 0) == (i36 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
      if ((HEAP8[i17 >> 0] | 0) < 0) {
       i50 = HEAP32[i40 >> 2] | 0;
       i2 = HEAP32[i18 >> 2] | 0;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i19 >> 2] = i2;
       __Z19free_alloc_internalPvRK10MemLabelId(i50, i47);
      }
      do if (!i1) {
       i1 = __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i38, (HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i39 >> 2] | 0 : i39, 1) | 0;
       if (!i1) break L65;
      } else {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break;
       i50 = i2 + 4 | 0;
       HEAP32[i50 >> 2] = (HEAP32[i50 >> 2] | 0) + -1;
       if (!(HEAP32[i50 >> 2] | 0)) {
        mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
        __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
       }
       HEAP8[i1 + 20 >> 0] = 0;
      } while (0);
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      i51 = i3 + 4 | 0;
      i2 = HEAP32[i51 + 4 >> 2] | 0;
      i50 = i1 + 4 | 0;
      HEAP32[i50 >> 2] = HEAP32[i51 >> 2];
      HEAP32[i50 + 4 >> 2] = i2;
      HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
      HEAP8[i1 + 20 >> 0] = HEAP8[i3 + 20 >> 0] | 0;
      do if (i3 | 0) {
       i1 = i3 + 24 | 0;
       if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) break;
       i51 = HEAP32[i1 >> 2] | 0;
       i50 = HEAP32[i3 + 36 >> 2] | 0;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i31 >> 2] = i50;
       __Z19free_alloc_internalPvRK10MemLabelId(i51, i47);
      } while (0);
      __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
      i2 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i41 >> 2] | 0 : i41;
      HEAP32[i40 >> 2] = 0;
      HEAP32[i40 + 4 >> 2] = 0;
      HEAP32[i40 + 8 >> 2] = 0;
      i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
      HEAP32[i20 >> 2] = i1;
      i3 = _strlen(i2) | 0;
      do if (i3 >>> 0 > 2147483631) {
       __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
       i1 = HEAP32[i6 >> 2] | 0;
       i45 = 72;
      } else {
       if (i3 >>> 0 >= 11) {
        i45 = 72;
        break;
       }
       HEAP8[i24 >> 0] = i3;
       if (!i3) i1 = i40; else {
        i1 = i40;
        i45 = 74;
       }
      } while (0);
      if ((i45 | 0) == 72) {
       i51 = i3 + 16 & -16;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i21 >> 2] = i1;
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i51, 16, i47, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i40 >> 2] = i1;
       HEAP32[i22 >> 2] = i51 | -2147483648;
       HEAP32[i23 >> 2] = i3;
       i45 = 74;
      }
      if ((i45 | 0) == 74) {
       i45 = 0;
       _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
      }
      HEAP8[i1 + i3 >> 0] = 0;
      i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i37, i40) | 0;
      if ((HEAP8[i24 >> 0] | 0) < 0) {
       i51 = HEAP32[i40 >> 2] | 0;
       i50 = HEAP32[i6 >> 2] | 0;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i25 >> 2] = i50;
       __Z19free_alloc_internalPvRK10MemLabelId(i51, i47);
      }
      i1 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i1) {
       i2 = i3;
       while (1) {
        i1 = HEAP32[i2 + 8 >> 2] | 0;
        if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
       }
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((HEAP32[i37 >> 2] | 0) == (i3 | 0)) HEAP32[i37 >> 2] = i1;
      HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + -1;
      __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i28 >> 2] | 0, i3);
      i1 = i3 + 16 | 0;
      if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
       i51 = HEAP32[i1 >> 2] | 0;
       i50 = HEAP32[i3 + 28 >> 2] | 0;
       HEAP32[i47 >> 2] = 54;
       HEAP32[i29 >> 2] = i50;
       __Z19free_alloc_internalPvRK10MemLabelId(i51, i47);
      }
      i51 = HEAP32[i27 >> 2] | 0;
      HEAP32[i47 >> 2] = 54;
      HEAP32[i30 >> 2] = i51;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i47);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i32 >> 2] | 0) >>> 0) {
       i1 = 1;
       break L62;
      }
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
     i1 = 0;
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
    if ((HEAP32[i33 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i34);
     HEAP32[i42 >> 2] = 0;
    }
   }
  } while (0);
  i2 = HEAP8[i46 >> 0] | 0;
 }
 if (i2 << 24 >> 24 >= 0) {
  STACKTOP = i49;
  return i1 | 0;
 }
 i51 = HEAP32[i48 >> 2] | 0;
 i50 = HEAP32[i48 + 12 >> 2] | 0;
 HEAP32[i47 >> 2] = 54;
 HEAP32[i47 + 4 >> 2] = i50;
 __Z19free_alloc_internalPvRK10MemLabelId(i51, i47);
 STACKTOP = i49;
 return i1 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i56, i62, i61, i1, i83, i84, i85, i86, i88, i90, i76) {
 i56 = i56 | 0;
 i62 = i62 | 0;
 i61 = i61 | 0;
 i1 = i1 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 i85 = i85 | 0;
 i86 = i86 | 0;
 i88 = i88 | 0;
 i90 = i90 | 0;
 i76 = i76 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f57 = f0, f58 = f0, i59 = 0, i60 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f77 = f0, f78 = f0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i87 = 0, i89 = 0, i91 = 0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0;
 i91 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i91 + 304 | 0;
 i70 = i91 + 484 | 0;
 i69 = i91 + 472 | 0;
 i81 = i91 + 320 | 0;
 i79 = i91 + 240 | 0;
 i80 = i91 + 176 | 0;
 i87 = i91 + 456 | 0;
 i89 = i91 + 440 | 0;
 i63 = i91 + 432 | 0;
 i82 = i91 + 160 | 0;
 i30 = i91 + 144 | 0;
 i29 = i91 + 128 | 0;
 i31 = i91 + 420 | 0;
 i32 = i91 + 112 | 0;
 i65 = i91 + 96 | 0;
 i64 = i91 + 80 | 0;
 i72 = i91 + 64 | 0;
 i73 = i91 + 48 | 0;
 i71 = i91 + 408 | 0;
 i60 = i91 + 32 | 0;
 i59 = i91 + 396 | 0;
 i67 = i91 + 16 | 0;
 i68 = i91;
 i66 = i91 + 384 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f77 = Math_fround(HEAPF32[i56 + 16 >> 2]);
 f78 = Math_fround(HEAPF32[i62 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i1 >> 2]);
 f58 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f75 = Math_fround(HEAPF32[i62 + 32 >> 2]);
 f58 = Math_fround((f58 > f75 ? f75 : f58) * Math_fround(.100000001));
 f58 = Math_fround(f58 * f58);
 f75 = Math_fround(f77 + f78);
 HEAP32[i63 >> 2] = 0;
 if (!(HEAP8[i76 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i61 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 56 >> 2]);
  i55 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i55 ? f5 : Math_fround(1.0);
  f6 = i55 ? f6 : Math_fround(0.0);
  f7 = i55 ? f7 : Math_fround(0.0);
  HEAPF32[i82 >> 2] = f5;
  HEAPF32[i82 + 4 >> 2] = f6;
  HEAPF32[i82 + 8 >> 2] = f7;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i32 >> 2] = HEAP32[i82 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i82 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i82 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i82 + 12 >> 2];
  i55 = i82;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i74 = 7;
 } else {
  HEAP32[i30 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i3 = i30 + 4 | 0;
  i25 = i30 + 8 | 0;
  i26 = i30 + 12 | 0;
  f4 = Math_fround(HEAPF32[i61 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i61 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i61 >> 2]);
  f8 = Math_fround(HEAPF32[i61 + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i61 + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i61 + 20 >> 2]);
  f12 = Math_fround(HEAPF32[i61 + 36 >> 2]);
  f13 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i61 + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i61 + 40 >> 2]);
  i2 = HEAP32[i62 + 200 >> 2] | 0;
  f16 = Math_fround(HEAPF32[i62 + 96 >> 2]);
  f17 = Math_fround(HEAPF32[i62 + 112 >> 2]);
  f18 = Math_fround(HEAPF32[i62 + 128 >> 2]);
  f19 = Math_fround(HEAPF32[i62 + 100 >> 2]);
  f20 = Math_fround(HEAPF32[i62 + 116 >> 2]);
  f21 = Math_fround(HEAPF32[i62 + 132 >> 2]);
  f22 = Math_fround(HEAPF32[i62 + 104 >> 2]);
  f23 = Math_fround(HEAPF32[i62 + 120 >> 2]);
  f24 = Math_fround(HEAPF32[i62 + 136 >> 2]);
  i27 = 0;
  i28 = 0;
  while (1) {
   i55 = HEAPU8[i88 + i28 >> 0] | 0;
   HEAP32[i87 + (i28 << 2) >> 2] = i55;
   i1 = HEAPU8[i90 + i28 >> 0] | 0;
   HEAP32[i89 + (i28 << 2) >> 2] = i1;
   f99 = Math_fround(HEAPF32[i56 + 96 + (i55 << 4) >> 2]);
   f98 = Math_fround(HEAPF32[i56 + 96 + (i55 << 4) + 4 >> 2]);
   f95 = Math_fround(HEAPF32[i56 + 96 + (i55 << 4) + 8 >> 2]);
   f97 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f99 * f7) + Math_fround(f98 * f8)) + Math_fround(f95 * f9)));
   f96 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f99 * f10) + Math_fround(f98 * f11)) + Math_fround(f95 * f12)));
   f95 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f99 * f13) + Math_fround(f98 * f14)) + Math_fround(f95 * f15)));
   f98 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) >> 2]);
   f99 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]);
   f92 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 8 >> 2]);
   f94 = Math_fround(Math_fround(Math_fround(f98 * f16) + Math_fround(f99 * f17)) + Math_fround(f92 * f18));
   f93 = Math_fround(Math_fround(Math_fround(f98 * f19) + Math_fround(f99 * f20)) + Math_fround(f92 * f21));
   f92 = Math_fround(Math_fround(Math_fround(f98 * f22) + Math_fround(f99 * f23)) + Math_fround(f92 * f24));
   f99 = Math_fround(f96 - f93);
   f98 = Math_fround(f95 - f92);
   HEAPF32[i30 >> 2] = Math_fround(f97 - f94);
   HEAPF32[i3 >> 2] = f99;
   HEAPF32[i25 >> 2] = f98;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i79 + (i27 << 4) >> 2] = f97;
   HEAPF32[i79 + (i27 << 4) + 4 >> 2] = f96;
   HEAPF32[i79 + (i27 << 4) + 8 >> 2] = f95;
   HEAPF32[i79 + (i27 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i80 + (i27 << 4) >> 2] = f94;
   HEAPF32[i80 + (i27 << 4) + 4 >> 2] = f93;
   HEAPF32[i80 + (i27 << 4) + 8 >> 2] = f92;
   HEAPF32[i80 + (i27 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i27 + 1 | 0;
   i55 = i81 + (i27 << 4) | 0;
   HEAP32[i55 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i55 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i55 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i55 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   i28 = i28 + 1 | 0;
   if (i28 >>> 0 >= (HEAPU8[i76 >> 0] | 0) >>> 0) break; else i27 = i1;
  }
  HEAP32[i63 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i29, i81, i79, i80, i87, i89, i30, i63);
  HEAP32[i82 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i82 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i82 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i82 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i82 >> 2]);
  f6 = Math_fround(HEAPF32[i82 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i82 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i70 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i70 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i70 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i69 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i69 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i69 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i32 >> 2] = HEAP32[i82 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i82 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i82 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i82 + 12 >> 2];
  if (f4 > f58) {
   i55 = i82;
   i74 = 7;
  } else i2 = HEAP32[i63 >> 2] | 0;
 }
 do if ((i74 | 0) == 7) {
  i53 = i82 + 4 | 0;
  i54 = i82 + 8 | 0;
  i27 = i61 + 4 | 0;
  i28 = i61 + 8 | 0;
  i29 = i61 + 16 | 0;
  i30 = i61 + 20 | 0;
  i31 = i61 + 24 | 0;
  i33 = i61 + 32 | 0;
  i34 = i61 + 36 | 0;
  i35 = i61 + 40 | 0;
  i36 = i56 + 96 | 0;
  i37 = i56 + 100 | 0;
  i38 = i56 + 104 | 0;
  i39 = i56 + 112 | 0;
  i40 = i56 + 116 | 0;
  i41 = i56 + 120 | 0;
  i42 = i56 + 128 | 0;
  i43 = i56 + 132 | 0;
  i44 = i56 + 136 | 0;
  i45 = i61 + 48 | 0;
  i46 = i61 + 52 | 0;
  i47 = i61 + 56 | 0;
  i48 = i65 + 4 | 0;
  i49 = i65 + 8 | 0;
  i50 = i64 + 4 | 0;
  i51 = i64 + 8 | 0;
  i52 = i64 + 12 | 0;
  i25 = i56 + 48 | 0;
  i26 = i62 + 48 | 0;
  f9 = f57;
  while (1) {
   HEAP32[i69 >> 2] = HEAP32[i70 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i70 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i70 + 8 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   HEAP32[i32 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
   f99 = Math_fround(-f5);
   f16 = Math_fround(-f6);
   f15 = Math_fround(-f7);
   i3 = HEAP32[i63 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i61 >> 2]);
   f11 = Math_fround(f22 * f99);
   f57 = Math_fround(HEAPF32[i27 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f57 * f16));
   f93 = Math_fround(HEAPF32[i28 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f93 * f15));
   f98 = Math_fround(HEAPF32[i29 >> 2]);
   f12 = Math_fround(f98 * f99);
   f94 = Math_fround(HEAPF32[i30 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f94 * f16));
   f97 = Math_fround(HEAPF32[i31 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f97 * f15));
   f21 = Math_fround(HEAPF32[i33 >> 2]);
   f99 = Math_fround(f21 * f99);
   f24 = Math_fround(HEAPF32[i34 >> 2]);
   f16 = Math_fround(f99 + Math_fround(f24 * f16));
   f99 = Math_fround(HEAPF32[i35 >> 2]);
   f15 = Math_fround(f16 + Math_fround(f99 * f15));
   f16 = Math_fround(HEAPF32[i36 >> 2]);
   f18 = Math_fround(HEAPF32[i37 >> 2]);
   f23 = Math_fround(HEAPF32[i38 >> 2]);
   f17 = Math_fround(HEAPF32[i39 >> 2]);
   f19 = Math_fround(HEAPF32[i40 >> 2]);
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f92 = Math_fround(HEAPF32[i42 >> 2]);
   f96 = Math_fround(HEAPF32[i43 >> 2]);
   f95 = Math_fround(HEAPF32[i44 >> 2]);
   f13 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f12 * f18)) + Math_fround(f15 * f23));
   f14 = Math_fround(Math_fround(Math_fround(f11 * f17) + Math_fround(f12 * f19)) + Math_fround(f15 * f20));
   f15 = Math_fround(Math_fround(Math_fround(f11 * f92) + Math_fround(f12 * f96)) + Math_fround(f15 * f95));
   i56 = f13 > f14 & f13 > f15;
   i2 = f14 > f15;
   HEAP32[i87 + (i3 << 2) >> 2] = i56 ? 0 : i2 ? 1 : 2;
   f92 = i56 ? f16 : i2 ? f17 : f92;
   f96 = i56 ? f18 : i2 ? f19 : f96;
   f95 = i56 ? f23 : i2 ? f20 : f95;
   f20 = Math_fround(HEAPF32[i45 >> 2]);
   f23 = Math_fround(HEAPF32[i46 >> 2]);
   f98 = Math_fround(f20 + Math_fround(Math_fround(f21 * f95) + Math_fround(Math_fround(f92 * f22) + Math_fround(f96 * f98))));
   f94 = Math_fround(f23 + Math_fround(Math_fround(f24 * f95) + Math_fround(Math_fround(f92 * f57) + Math_fround(f96 * f94))));
   f99 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + Math_fround(Math_fround(Math_fround(f92 * f93) + Math_fround(f96 * f97)) + Math_fround(f95 * f99)));
   HEAPF32[i79 + (i3 << 4) >> 2] = f98;
   HEAPF32[i79 + (i3 << 4) + 4 >> 2] = f94;
   HEAPF32[i79 + (i3 << 4) + 8 >> 2] = f99;
   HEAPF32[i79 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i65, i62, i82, i80 + (i3 << 4) | 0, i89 + (i3 << 2) | 0);
   f95 = Math_fround(HEAPF32[i65 >> 2]);
   f97 = Math_fround(HEAPF32[i48 >> 2]);
   f95 = Math_fround(f98 - f95);
   f97 = Math_fround(f94 - f97);
   f99 = Math_fround(f99 - Math_fround(HEAPF32[i49 >> 2]));
   HEAPF32[i64 >> 2] = f95;
   HEAPF32[i50 >> 2] = f97;
   HEAPF32[i51 >> 2] = f99;
   HEAPF32[i52 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i63 >> 2] | 0;
   i2 = i81 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
   f94 = Math_fround(HEAPF32[i25 >> 2]);
   f98 = Math_fround(HEAPF32[i26 >> 2]);
   f98 = f94 > f98 ? f94 : f98;
   f9 = f9 > f98 ? f9 : f98;
   f98 = Math_fround(f75 + f9);
   f98 = Math_fround(f4 * Math_fround(f98 * f98));
   f94 = Math_fround(HEAPF32[i82 >> 2]);
   f96 = Math_fround(HEAPF32[i53 >> 2]);
   f99 = Math_fround(Math_fround(Math_fround(f94 * f95) + Math_fround(f96 * f97)) + Math_fround(Math_fround(HEAPF32[i54 >> 2]) * f99));
   i2 = f99 > Math_fround(0.0) & Math_fround(f99 * f99) > f98;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f99) | i2) {
    i74 = 9;
    break;
   }
   HEAP32[i63 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i60, i81, i79, i80, i87, i89, i64, i63);
   HEAP32[i55 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i55 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
   HEAP32[i55 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
   HEAP32[i55 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i82 >> 2]);
   f6 = Math_fround(HEAPF32[i53 >> 2]);
   f7 = Math_fround(HEAPF32[i54 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i70 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i70 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i70 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f58 & i1)) break; else f4 = f8;
  }
  if ((i74 | 0) == 9) {
   if (i88 | 0) {
    HEAP8[i76 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
      HEAP8[i90 + i1 >> 0] = HEAP32[i89 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i90 = 0;
    STACKTOP = i91;
    return i90 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i81, i79, i80, i82, i72, i73, i3);
   f96 = Math_fround(Math_sqrt(Math_fround(f4)));
   f97 = Math_fround(HEAPF32[i82 >> 2]);
   f98 = Math_fround(HEAPF32[i53 >> 2]);
   f99 = Math_fround(Math_fround(1.0) / f96);
   f97 = Math_fround(f97 * f99);
   f98 = Math_fround(f98 * f99);
   f99 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) * f99);
   f95 = Math_fround(HEAPF32[i72 >> 2]);
   f94 = Math_fround(HEAPF32[i72 + 4 >> 2]);
   f94 = Math_fround(f94 - Math_fround(f77 * f98));
   f93 = Math_fround(Math_fround(HEAPF32[i72 + 8 >> 2]) - Math_fround(f77 * f99));
   HEAPF32[i83 >> 2] = Math_fround(f95 - Math_fround(f77 * f97));
   HEAPF32[i83 + 4 >> 2] = f94;
   HEAPF32[i83 + 8 >> 2] = f93;
   HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
   f93 = Math_fround(HEAPF32[i73 >> 2]);
   f94 = Math_fround(HEAPF32[i73 + 4 >> 2]);
   f94 = Math_fround(Math_fround(f78 * f98) + f94);
   f95 = Math_fround(Math_fround(f78 * f99) + Math_fround(HEAPF32[i73 + 8 >> 2]));
   HEAPF32[i84 >> 2] = Math_fround(Math_fround(f78 * f97) + f93);
   HEAPF32[i84 + 4 >> 2] = f94;
   HEAPF32[i84 + 8 >> 2] = f95;
   HEAPF32[i84 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i86 >> 2] = Math_fround(f96 - f75);
   i90 = i86 + 4 | 0;
   HEAP32[i90 >> 2] = HEAP32[i71 >> 2];
   HEAP32[i90 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
   HEAP32[i90 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
   HEAPF32[i85 >> 2] = f97;
   HEAPF32[i85 + 4 >> 2] = f98;
   HEAPF32[i85 + 8 >> 2] = f99;
   HEAPF32[i85 + 12 >> 2] = Math_fround(0.0);
   i90 = 1;
   STACKTOP = i91;
   return i90 | 0;
  }
  i2 = HEAP32[i63 >> 2] | 0;
  if (i1) {
   if (!i88) i1 = 6; else break;
   STACKTOP = i91;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i88 | 0) {
   HEAP8[i76 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
     HEAP8[i90 + i1 >> 0] = HEAP32[i89 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i55 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i81, i79, i80, i82, i67, i68, i2);
  HEAP32[i70 >> 2] = HEAP32[i69 >> 2];
  HEAP32[i70 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
  HEAP32[i70 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
  f96 = Math_fround(Math_sqrt(Math_fround(f4)));
  f97 = Math_fround(HEAPF32[i82 >> 2]);
  f98 = Math_fround(HEAPF32[i82 + 4 >> 2]);
  f99 = Math_fround(Math_fround(1.0) / f96);
  f97 = Math_fround(f97 * f99);
  f98 = Math_fround(f98 * f99);
  f99 = Math_fround(Math_fround(HEAPF32[i82 + 8 >> 2]) * f99);
  f95 = Math_fround(HEAPF32[i67 >> 2]);
  f94 = Math_fround(HEAPF32[i67 + 4 >> 2]);
  f94 = Math_fround(f94 - Math_fround(f77 * f98));
  f93 = Math_fround(Math_fround(HEAPF32[i67 + 8 >> 2]) - Math_fround(f77 * f99));
  HEAPF32[i83 >> 2] = Math_fround(f95 - Math_fround(f77 * f97));
  HEAPF32[i83 + 4 >> 2] = f94;
  HEAPF32[i83 + 8 >> 2] = f93;
  HEAPF32[i83 + 12 >> 2] = Math_fround(0.0);
  f93 = Math_fround(HEAPF32[i68 >> 2]);
  f94 = Math_fround(HEAPF32[i68 + 4 >> 2]);
  f94 = Math_fround(Math_fround(f78 * f98) + f94);
  f95 = Math_fround(Math_fround(f78 * f99) + Math_fround(HEAPF32[i68 + 8 >> 2]));
  HEAPF32[i84 >> 2] = Math_fround(Math_fround(f78 * f97) + f93);
  HEAPF32[i84 + 4 >> 2] = f94;
  HEAPF32[i84 + 8 >> 2] = f95;
  HEAPF32[i84 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i86 >> 2] = Math_fround(f96 - f75);
  i90 = i86 + 4 | 0;
  HEAP32[i90 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i90 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i90 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  HEAPF32[i85 >> 2] = f97;
  HEAPF32[i85 + 4 >> 2] = f98;
  HEAPF32[i85 + 8 >> 2] = f99;
  HEAPF32[i85 + 12 >> 2] = Math_fround(0.0);
  i90 = 3;
  STACKTOP = i91;
  return i90 | 0;
 } while (0);
 HEAP8[i76 >> 0] = i2;
 if (!i2) {
  i90 = 6;
  STACKTOP = i91;
  return i90 | 0;
 } else i1 = 0;
 do {
  HEAP8[i88 + i1 >> 0] = HEAP32[i87 + (i1 << 2) >> 2];
  HEAP8[i90 + i1 >> 0] = HEAP32[i89 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i91;
 return i1 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSA_5Vec3VESF_SF_RSB_PhSH_Rhb(i68, i69, i1, i70, i71, i65, i73, i54, i56, i48, i72) {
 i68 = i68 | 0;
 i69 = i69 | 0;
 i1 = i1 | 0;
 i70 = i70 | 0;
 i71 = i71 | 0;
 i65 = i65 | 0;
 i73 = i73 | 0;
 i54 = i54 | 0;
 i56 = i56 | 0;
 i48 = i48 | 0;
 i72 = i72 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f66 = f0, f67 = f0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i74 + 460 | 0;
 i45 = i74 + 448 | 0;
 i64 = i74 + 128 | 0;
 i63 = i74 + 272 | 0;
 i61 = i74 + 208 | 0;
 i62 = i74 + 144 | 0;
 i53 = i74 + 432 | 0;
 i55 = i74 + 416 | 0;
 i44 = i74 + 112 | 0;
 i43 = i74 + 408 | 0;
 i14 = i74 + 96 | 0;
 i15 = i74 + 396 | 0;
 i16 = i74 + 80 | 0;
 i57 = i74 + 64 | 0;
 i60 = i74 + 48 | 0;
 i58 = i74 + 384 | 0;
 i59 = i74 + 372 | 0;
 i42 = i74 + 32 | 0;
 i41 = i74 + 360 | 0;
 i49 = i74 + 16 | 0;
 i52 = i74;
 i51 = i74 + 348 | 0;
 i50 = i74 + 336 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f66 = Math_fround(HEAPF32[i68 + 16 >> 2]);
 f67 = Math_fround(HEAPF32[i69 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i68 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i69 + 32 >> 2]);
 f9 = Math_fround((f9 > f3 ? f3 : f9) * Math_fround(.100000001));
 f9 = Math_fround(f9 * f9);
 f3 = Math_fround(f66 + f67);
 i38 = i44 + 4 | 0;
 i39 = i44 + 8 | 0;
 i40 = i44 + 12 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i43 >> 2] = 0;
 i1 = HEAP8[i48 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f36 = Math_fround(HEAPF32[i68 >> 2]);
  f4 = Math_fround(HEAPF32[i68 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i68 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i69 >> 2]);
  f6 = Math_fround(HEAPF32[i69 + 4 >> 2]);
  f5 = Math_fround(f36 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i69 + 8 >> 2]));
  i37 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i37 ? f5 : Math_fround(1.0);
  f6 = i37 ? f6 : Math_fround(0.0);
  f7 = i37 ? f7 : Math_fround(0.0);
  HEAPF32[i64 >> 2] = f5;
  HEAPF32[i64 + 4 >> 2] = f6;
  HEAPF32[i64 + 8 >> 2] = f7;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i16 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  i37 = i64;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i47 = 6;
 } else {
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i35 = HEAPU8[i54 + i11 >> 0] | 0;
   HEAP32[i53 + (i11 << 2) >> 2] = i35;
   i37 = HEAPU8[i56 + i11 >> 0] | 0;
   HEAP32[i55 + (i11 << 2) >> 2] = i37;
   f5 = Math_fround(HEAPF32[i68 + 96 + (i35 << 4) >> 2]);
   f6 = Math_fround(HEAPF32[i68 + 96 + (i35 << 4) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i68 + 96 + (i35 << 4) + 8 >> 2]);
   i35 = HEAP32[i68 + 96 + (i35 << 4) + 12 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i69 + 96 + (i37 << 4) >> 2]);
   f12 = Math_fround(HEAPF32[i69 + 96 + (i37 << 4) + 4 >> 2]);
   f36 = Math_fround(HEAPF32[i69 + 96 + (i37 << 4) + 8 >> 2]);
   i37 = HEAP32[i69 + 96 + (i37 << 4) + 12 >> 2] | 0;
   f75 = Math_fround(f6 - f12);
   f4 = Math_fround(f7 - f36);
   HEAPF32[i44 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i38 >> 2] = f75;
   HEAPF32[i39 >> 2] = f4;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   HEAPF32[i61 + (i2 << 4) >> 2] = f5;
   HEAPF32[i61 + (i2 << 4) + 4 >> 2] = f6;
   HEAPF32[i61 + (i2 << 4) + 8 >> 2] = f7;
   HEAP32[i61 + (i2 << 4) + 12 >> 2] = i35;
   HEAPF32[i62 + (i2 << 4) >> 2] = f10;
   HEAPF32[i62 + (i2 << 4) + 4 >> 2] = f12;
   HEAPF32[i62 + (i2 << 4) + 8 >> 2] = f36;
   HEAP32[i62 + (i2 << 4) + 12 >> 2] = i37;
   i37 = i63 + (i2 << 4) | 0;
   HEAP32[i37 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i37 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i43 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i14, i63, i61, i62, i53, i55, i44, i43);
  HEAP32[i64 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i64 >> 2]);
  f6 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i46 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i45 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i45 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i45 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  if (f4 > f9) {
   i37 = i64;
   i47 = 6;
  }
 }
 do if ((i47 | 0) == 6) {
  i34 = i64 + 4 | 0;
  i35 = i64 + 8 | 0;
  i2 = i68 + 96 | 0;
  i14 = i68 + 100 | 0;
  i15 = i68 + 104 | 0;
  i17 = i68 + 112 | 0;
  i18 = i68 + 116 | 0;
  i19 = i68 + 120 | 0;
  i20 = i68 + 128 | 0;
  i21 = i68 + 132 | 0;
  i22 = i68 + 136 | 0;
  i23 = i69 + 96 | 0;
  i24 = i69 + 100 | 0;
  i25 = i69 + 104 | 0;
  i26 = i69 + 112 | 0;
  i27 = i69 + 116 | 0;
  i28 = i69 + 120 | 0;
  i29 = i69 + 128 | 0;
  i30 = i69 + 132 | 0;
  i31 = i69 + 136 | 0;
  i32 = i68 + 48 | 0;
  i33 = i69 + 48 | 0;
  f36 = f4;
  while (1) {
   HEAP32[i45 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i45 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i45 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f84 = Math_fround(-f5);
   f85 = Math_fround(-f6);
   f81 = Math_fround(-f7);
   i13 = HEAP32[i43 >> 2] | 0;
   f77 = Math_fround(HEAPF32[i2 >> 2]);
   f82 = Math_fround(HEAPF32[i14 >> 2]);
   f80 = Math_fround(HEAPF32[i15 >> 2]);
   f79 = Math_fround(HEAPF32[i17 >> 2]);
   f78 = Math_fround(HEAPF32[i18 >> 2]);
   f83 = Math_fround(HEAPF32[i19 >> 2]);
   f76 = Math_fround(HEAPF32[i20 >> 2]);
   f12 = Math_fround(HEAPF32[i21 >> 2]);
   f4 = Math_fround(HEAPF32[i22 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f77 * f84) + Math_fround(f82 * f85)) + Math_fround(f80 * f81));
   f10 = Math_fround(Math_fround(Math_fround(f79 * f84) + Math_fround(f78 * f85)) + Math_fround(f83 * f81));
   f81 = Math_fround(Math_fround(Math_fround(f76 * f84) + Math_fround(f12 * f85)) + Math_fround(f4 * f81));
   i11 = f75 > f10 & f75 > f81;
   i1 = f10 > f81;
   HEAP32[i53 + (i13 << 2) >> 2] = i11 ? 0 : i1 ? 1 : 2;
   f76 = i11 ? f77 : i1 ? f79 : f76;
   f12 = i11 ? f82 : i1 ? f78 : f12;
   f4 = i11 ? f80 : i1 ? f83 : f4;
   HEAPF32[i61 + (i13 << 4) >> 2] = f76;
   HEAPF32[i61 + (i13 << 4) + 4 >> 2] = f12;
   HEAPF32[i61 + (i13 << 4) + 8 >> 2] = f4;
   HEAPF32[i61 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   f83 = Math_fround(HEAPF32[i23 >> 2]);
   f80 = Math_fround(HEAPF32[i24 >> 2]);
   f78 = Math_fround(HEAPF32[i25 >> 2]);
   f82 = Math_fround(HEAPF32[i26 >> 2]);
   f79 = Math_fround(HEAPF32[i27 >> 2]);
   f77 = Math_fround(HEAPF32[i28 >> 2]);
   f81 = Math_fround(HEAPF32[i29 >> 2]);
   f10 = Math_fround(HEAPF32[i30 >> 2]);
   f75 = Math_fround(HEAPF32[i31 >> 2]);
   f85 = Math_fround(Math_fround(Math_fround(f83 * f5) + Math_fround(f80 * f6)) + Math_fround(f78 * f7));
   f84 = Math_fround(Math_fround(Math_fround(f82 * f5) + Math_fround(f79 * f6)) + Math_fround(f77 * f7));
   f7 = Math_fround(Math_fround(Math_fround(f81 * f5) + Math_fround(f10 * f6)) + Math_fround(f75 * f7));
   i1 = f85 > f84 & f85 > f7;
   i11 = f84 > f7;
   HEAP32[i55 + (i13 << 2) >> 2] = i1 ? 0 : i11 ? 1 : 2;
   f7 = i1 ? f83 : i11 ? f82 : f81;
   f10 = i1 ? f80 : i11 ? f79 : f10;
   f75 = i1 ? f78 : i11 ? f77 : f75;
   HEAPF32[i62 + (i13 << 4) >> 2] = f7;
   HEAPF32[i62 + (i13 << 4) + 4 >> 2] = f10;
   HEAPF32[i62 + (i13 << 4) + 8 >> 2] = f75;
   HEAPF32[i62 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   f7 = Math_fround(f76 - f7);
   f10 = Math_fround(f12 - f10);
   f75 = Math_fround(f4 - f75);
   HEAPF32[i44 >> 2] = f7;
   HEAPF32[i38 >> 2] = f10;
   HEAPF32[i39 >> 2] = f75;
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i43 >> 2] | 0;
   i11 = i63 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i32 >> 2]);
   f12 = Math_fround(HEAPF32[i33 >> 2]);
   f12 = f4 > f12 ? f4 : f12;
   f8 = f8 > f12 ? f8 : f12;
   f12 = Math_fround(f3 + f8);
   f12 = Math_fround(f36 * Math_fround(f12 * f12));
   f4 = Math_fround(HEAPF32[i64 >> 2]);
   f5 = Math_fround(HEAPF32[i34 >> 2]);
   f6 = Math_fround(HEAPF32[i35 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f4 * f7) + Math_fround(f5 * f10)) + Math_fround(f6 * f75));
   i11 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f12;
   if (Math_fround(f36 * Math_fround(.00039999999)) >= Math_fround(f36 - f75) | i11) {
    f7 = f36;
    i47 = 8;
    break;
   }
   HEAP32[i43 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i42, i63, i61, i62, i53, i55, i44, i43);
   HEAP32[i37 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i37 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i64 >> 2]);
   f6 = Math_fround(HEAPF32[i34 >> 2]);
   f7 = Math_fround(HEAPF32[i35 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i46 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i46 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i46 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   i1 = f36 > f4;
   if (!(f4 > f9 & i1)) break; else f36 = f4;
  }
  if ((i47 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i54 | 0) {
    HEAP8[i48 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
      HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i73 = 0;
    STACKTOP = i74;
    return i73 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i65 >> 2] = f9;
   HEAPF32[i65 + 4 >> 2] = f8;
   HEAPF32[i65 + 8 >> 2] = f7;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i57, i60, i13);
   f5 = Math_fround(HEAPF32[i57 >> 2]);
   f6 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i57 + 8 >> 2]);
   if (i72) {
    f84 = HEAP32[i68 + 64 >> 2] | 0 ? Math_fround(0.0) : f66;
    f81 = HEAP32[i69 + 64 >> 2] | 0 ? Math_fround(0.0) : f67;
    f85 = Math_fround(f84 + f81);
    f83 = Math_fround(f6 - Math_fround(f8 * f84));
    f82 = Math_fround(f4 - Math_fround(f7 * f84));
    HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f9 * f84));
    HEAPF32[i70 + 4 >> 2] = f83;
    HEAPF32[i70 + 8 >> 2] = f82;
    HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
    f82 = Math_fround(HEAPF32[i60 >> 2]);
    f83 = Math_fround(HEAPF32[i60 + 4 >> 2]);
    f83 = Math_fround(Math_fround(f8 * f81) + f83);
    f84 = Math_fround(Math_fround(f7 * f81) + Math_fround(HEAPF32[i60 + 8 >> 2]));
    HEAPF32[i71 >> 2] = Math_fround(Math_fround(f9 * f81) + f82);
    HEAPF32[i71 + 4 >> 2] = f83;
    HEAPF32[i71 + 8 >> 2] = f84;
    HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i73 >> 2] = Math_fround(f10 - f85);
    i73 = i73 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    i73 = 1;
    STACKTOP = i74;
    return i73 | 0;
   } else {
    f84 = Math_fround(f6 - Math_fround(f66 * f8));
    f83 = Math_fround(f4 - Math_fround(f66 * f7));
    HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f66 * f9));
    HEAPF32[i70 + 4 >> 2] = f84;
    HEAPF32[i70 + 8 >> 2] = f83;
    HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
    f83 = Math_fround(HEAPF32[i60 >> 2]);
    f84 = Math_fround(HEAPF32[i60 + 4 >> 2]);
    f84 = Math_fround(Math_fround(f67 * f8) + f84);
    f85 = Math_fround(Math_fround(f67 * f7) + Math_fround(HEAPF32[i60 + 8 >> 2]));
    HEAPF32[i71 >> 2] = Math_fround(Math_fround(f67 * f9) + f83);
    HEAPF32[i71 + 4 >> 2] = f84;
    HEAPF32[i71 + 8 >> 2] = f85;
    HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i73 >> 2] = Math_fround(f10 - f3);
    i73 = i73 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
    i73 = 1;
    STACKTOP = i74;
    return i73 | 0;
   }
  }
  if (i1) {
   if (!i54) i1 = 6; else break;
   STACKTOP = i74;
   return i1 | 0;
  };
  HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  i11 = HEAP32[i43 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i54 | 0) {
   HEAP8[i48 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
     HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i37 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i37 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i49, i52, i11);
  HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f36)));
  f9 = Math_fround(HEAPF32[i64 >> 2]);
  f10 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i49 >> 2]);
  f6 = Math_fround(HEAPF32[i49 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i49 + 8 >> 2]);
  if (i72) {
   f85 = HEAP32[i68 + 64 >> 2] | 0 ? Math_fround(0.0) : f66;
   f82 = HEAP32[i69 + 64 >> 2] | 0 ? Math_fround(0.0) : f67;
   f3 = Math_fround(f85 + f82);
   f84 = Math_fround(f6 - Math_fround(f10 * f85));
   f83 = Math_fround(f4 - Math_fround(f7 * f85));
   HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f9 * f85));
   HEAPF32[i70 + 4 >> 2] = f84;
   HEAPF32[i70 + 8 >> 2] = f83;
   HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
   f83 = Math_fround(HEAPF32[i52 >> 2]);
   f84 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f84 = Math_fround(Math_fround(f10 * f82) + f84);
   f85 = Math_fround(Math_fround(f7 * f82) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i71 >> 2] = Math_fround(Math_fround(f9 * f82) + f83);
   HEAPF32[i71 + 4 >> 2] = f84;
   HEAPF32[i71 + 8 >> 2] = f85;
   HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
   i72 = i73 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  } else {
   f84 = Math_fround(f6 - Math_fround(f66 * f10));
   f83 = Math_fround(f4 - Math_fround(f66 * f7));
   HEAPF32[i70 >> 2] = Math_fround(f5 - Math_fround(f66 * f9));
   HEAPF32[i70 + 4 >> 2] = f84;
   HEAPF32[i70 + 8 >> 2] = f83;
   HEAPF32[i70 + 12 >> 2] = Math_fround(0.0);
   f83 = Math_fround(HEAPF32[i52 >> 2]);
   f84 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f84 = Math_fround(Math_fround(f67 * f10) + f84);
   f85 = Math_fround(Math_fround(f67 * f7) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i71 >> 2] = Math_fround(Math_fround(f67 * f9) + f83);
   HEAPF32[i71 + 4 >> 2] = f84;
   HEAPF32[i71 + 8 >> 2] = f85;
   HEAPF32[i71 + 12 >> 2] = Math_fround(0.0);
   i72 = i73 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  }
  HEAPF32[i73 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i65 >> 2] = f9;
  HEAPF32[i65 + 4 >> 2] = f10;
  HEAPF32[i65 + 8 >> 2] = f7;
  HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
  i73 = f12 >= f36 ? 1 : 3;
  STACKTOP = i74;
  return i73 | 0;
 } while (0);
 i2 = HEAP32[i43 >> 2] | 0;
 HEAP8[i48 >> 0] = i2;
 if (!i2) {
  i73 = 6;
  STACKTOP = i74;
  return i73 | 0;
 } else i1 = 0;
 do {
  HEAP8[i54 + i1 >> 0] = HEAP32[i53 + (i1 << 2) >> 2];
  HEAP8[i56 + i1 >> 0] = HEAP32[i55 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i74;
 return i1 | 0;
}

function __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb(i39, i42, i43, i38, i1, i2, i8, i9, i45, i46, i44, i47, i48) {
 i39 = i39 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 i44 = i44 | 0;
 i47 = i47 | 0;
 i48 = i48 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i40 = 0, i41 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, i61 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i49 + 144 | 0;
 i37 = i49 + 112 | 0;
 i31 = i49 + 96 | 0;
 i32 = i49 + 184 | 0;
 i5 = i49 + 80 | 0;
 i6 = i49 + 64 | 0;
 i35 = i49 + 48 | 0;
 i36 = i49 + 32 | 0;
 i34 = i49 + 16 | 0;
 i33 = i49 + 172 | 0;
 i29 = i49;
 i28 = i49 + 160 | 0;
 HEAPF32[i37 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i30 = i37 + 4 | 0;
 HEAPF32[i31 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i41 = i39 + 272 | 0;
 HEAP32[i41 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i41 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i41 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i41 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i3 = i39 + 288 | 0;
 i4 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i4 = i39 + 304 | 0;
 i40 = i2 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 i40 = i39 + 320 | 0;
 i1 = i2 + 48 | 0;
 HEAP32[i40 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i40 = i39 + 1296 | 0;
 HEAP32[i40 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i1 = i39 + 1312 | 0;
 i2 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = i39 + 1328 | 0;
 i27 = i8 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 i27 = i39 + 1344 | 0;
 i26 = i8 + 48 | 0;
 HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 HEAP32[i32 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 L1 : do switch (i9 | 0) {
 case 1:
  {
   HEAPF32[i7 >> 2] = Math_fround(1.0);
   HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
   mftCall_viiiii(HEAP32[(HEAP32[i38 >> 2] | 0) + 12 >> 2] | 0, i38 | 0, i7 | 0, i3 | 0, i1 | 0, i49 + 128 | 0);
   if (!(__ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_(i39, i38, i32, i31, i37) | 0)) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   }
   break;
  }
 case 2:
  {
   if (!(__ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_(i39, i38, i32, i31, i37) | 0)) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   }
   break;
  }
 case 3:
  {
   HEAP32[i32 >> 2] = 3;
   i1 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 0, 1, 2, i31, i37) | 0;
   i2 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 1, 0, 2, i31, i37) | 0;
   if ((i1 | 0) == 0 | (i2 | 0) == 0) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   }
   if (!(HEAP32[i39 >> 2] | 0)) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   } else {
    HEAP32[i1 + 20 >> 2] = i2;
    HEAP8[i1 + 32 >> 0] = 0;
    HEAP32[i2 + 20 >> 2] = i1;
    HEAP8[i2 + 32 >> 0] = 0;
    HEAP32[i1 + 24 >> 2] = i2;
    HEAP8[i1 + 33 >> 0] = 2;
    HEAP32[i2 + 28 >> 2] = i1;
    HEAP8[i2 + 34 >> 0] = 1;
    HEAP32[i1 + 28 >> 2] = i2;
    HEAP8[i1 + 34 >> 0] = 1;
    HEAP32[i2 + 24 >> 2] = i1;
    HEAP8[i2 + 33 >> 0] = 2;
    break L1;
   }
  }
 case 4:
  {
   f10 = Math_fround(HEAPF32[i41 >> 2]);
   f56 = Math_fround(HEAPF32[i39 + 276 >> 2]);
   f57 = Math_fround(HEAPF32[i39 + 280 >> 2]);
   f55 = Math_fround(HEAPF32[i39 + 288 >> 2]);
   f51 = Math_fround(HEAPF32[i39 + 292 >> 2]);
   f53 = Math_fround(HEAPF32[i39 + 296 >> 2]);
   f60 = Math_fround(HEAPF32[i39 + 304 >> 2]);
   f59 = Math_fround(HEAPF32[i39 + 308 >> 2]);
   f58 = Math_fround(HEAPF32[i39 + 312 >> 2]);
   f50 = Math_fround(HEAPF32[i40 >> 2]);
   f11 = Math_fround(HEAPF32[i39 + 1300 >> 2]);
   f52 = Math_fround(HEAPF32[i39 + 1304 >> 2]);
   f12 = Math_fround(HEAPF32[i39 + 1312 >> 2]);
   f54 = Math_fround(HEAPF32[i39 + 1316 >> 2]);
   f14 = Math_fround(HEAPF32[i39 + 1320 >> 2]);
   f50 = Math_fround(f10 - f50);
   f11 = Math_fround(f56 - f11);
   f52 = Math_fround(f57 - f52);
   f12 = Math_fround(f55 - f12);
   f54 = Math_fround(f51 - f54);
   f14 = Math_fround(f53 - f14);
   f60 = Math_fround(f60 - Math_fround(HEAPF32[i39 + 1328 >> 2]));
   f59 = Math_fround(f59 - Math_fround(HEAPF32[i39 + 1332 >> 2]));
   f58 = Math_fround(f58 - Math_fround(HEAPF32[i39 + 1336 >> 2]));
   f53 = Math_fround(f12 - f50);
   f51 = Math_fround(f54 - f11);
   f55 = Math_fround(f14 - f52);
   f57 = Math_fround(f60 - f50);
   f56 = Math_fround(f59 - f11);
   f10 = Math_fround(f58 - f52);
   f12 = Math_fround(f60 - f12);
   f54 = Math_fround(f59 - f54);
   f14 = Math_fround(f58 - f14);
   i27 = Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f51 * f51)) + Math_fround(f55 * f55)) > Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f10 * f10));
   f53 = i27 ? f57 : f53;
   f51 = i27 ? f56 : f51;
   f55 = i27 ? f10 : f55;
   f10 = Math_fround(Math_fround(f14 * f51) - Math_fround(f54 * f55));
   f14 = Math_fround(Math_fround(f12 * f55) - Math_fround(f14 * f53));
   f51 = Math_fround(Math_fround(f54 * f53) - Math_fround(f12 * f51));
   f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f10 * f10) + Math_fround(f14 * f14))))));
   if (Math_fround(Math_fround(f52 * Math_fround(f12 * f51)) + Math_fround(Math_fround(f50 * Math_fround(f12 * f10)) + Math_fround(f11 * Math_fround(f12 * f14)))) < Math_fround(0.0)) {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   }
   i1 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 0, 1, 2, i31, i37) | 0;
   i2 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 0, 3, 1, i31, i37) | 0;
   i3 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 0, 2, 3, i31, i37) | 0;
   i4 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, 1, 3, 2, i31, i37) | 0;
   if ((i1 | 0) == 0 | (i2 | 0) == 0 | (i3 | 0) == 0 | (i4 | 0) == 0) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   }
   if (!(HEAP32[i39 >> 2] | 0)) {
    i48 = 4;
    STACKTOP = i49;
    return i48 | 0;
   } else {
    HEAP32[i1 + 20 >> 2] = i2;
    HEAP8[i1 + 32 >> 0] = 2;
    HEAP32[i2 + 28 >> 2] = i1;
    HEAP8[i2 + 34 >> 0] = 0;
    HEAP32[i1 + 24 >> 2] = i4;
    HEAP8[i1 + 33 >> 0] = 2;
    HEAP32[i4 + 28 >> 2] = i1;
    HEAP8[i4 + 34 >> 0] = 1;
    HEAP32[i1 + 28 >> 2] = i3;
    HEAP8[i1 + 34 >> 0] = 0;
    HEAP32[i3 + 20 >> 2] = i1;
    HEAP8[i3 + 32 >> 0] = 2;
    HEAP32[i2 + 20 >> 2] = i3;
    HEAP8[i2 + 32 >> 0] = 2;
    HEAP32[i3 + 28 >> 2] = i2;
    HEAP8[i3 + 34 >> 0] = 0;
    HEAP32[i2 + 24 >> 2] = i4;
    HEAP8[i2 + 33 >> 0] = 0;
    HEAP32[i4 + 20 >> 2] = i2;
    HEAP8[i4 + 32 >> 0] = 1;
    HEAP32[i3 + 24 >> 2] = i4;
    HEAP8[i3 + 33 >> 0] = 1;
    HEAP32[i4 + 24 >> 2] = i3;
    HEAP8[i4 + 33 >> 0] = 1;
    HEAP32[i32 >> 2] = 4;
    break L1;
   }
  }
 default:
  {}
 } while (0);
 f14 = Math_fround(HEAPF32[i42 + 32 >> 2]);
 f10 = Math_fround(HEAPF32[i43 + 32 >> 2]);
 f14 = Math_fround((f14 > f10 ? f10 : f14) * Math_fround(.100000001));
 i15 = i39 + 5652 | 0;
 i16 = i39 + 6172 | 0;
 i17 = i39 + 4 | 0;
 i18 = i39 + 5392 | 0;
 i19 = i39 + 5648 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29 + 8 | 0;
 i22 = i29 + 12 | 0;
 i23 = i34 + 4 | 0;
 i24 = i34 + 8 | 0;
 i25 = i31 + 4 | 0;
 i26 = i39 + 5912 | 0;
 i27 = i39 + 5396 | 0;
 f10 = Math_fround(3402823469999999843913219.0e14);
 i3 = 0;
 L24 : while (1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) {
   i2 = 0;
   do {
    i9 = HEAP32[i39 + 5916 + (i2 << 2) >> 2] | 0;
    i13 = HEAP32[i26 >> 2] | 0;
    HEAP32[i26 >> 2] = i13 + 1;
    HEAP32[i39 + 5656 + (i13 << 2) >> 2] = i9;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  HEAP32[i16 >> 2] = 0;
  i5 = (HEAP32[i39 >> 2] | 0) + -1 | 0;
  HEAP32[i39 >> 2] = i5;
  i1 = HEAP32[i17 >> 2] | 0;
  i7 = HEAP32[i39 + 4 + (i5 << 2) >> 2] | 0;
  L30 : do if (i5 >>> 0 > 1) {
   f11 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   i4 = 1;
   i6 = 0;
   while (1) {
    i2 = i4 + 1 | 0;
    f60 = Math_fround(HEAPF32[(HEAP32[i39 + 4 + (i2 << 2) >> 2] | 0) + 16 >> 2]);
    i2 = ((i2 >>> 0 < i5 >>> 0 ? f60 < Math_fround(HEAPF32[(HEAP32[i39 + 4 + (i4 << 2) >> 2] | 0) + 16 >> 2]) : 0) & 1) + i4 | 0;
    i4 = HEAP32[i39 + 4 + (i2 << 2) >> 2] | 0;
    if (f11 < Math_fround(HEAPF32[i4 + 16 >> 2])) {
     i2 = i6;
     break L30;
    }
    HEAP32[i39 + 4 + (i6 << 2) >> 2] = i4;
    i4 = i2 << 1 | 1;
    if (i4 >>> 0 >= i5 >>> 0) break; else i6 = i2;
   }
  } else i2 = 0; while (0);
  HEAP32[i39 + 4 + (i2 << 2) >> 2] = i7;
  HEAP8[i1 + 39 >> 0] = 0;
  i2 = i1 + 38 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   f58 = Math_fround(HEAPF32[i1 >> 2]);
   f60 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i9 = HEAP32[i1 + 16 >> 2] | 0;
   i13 = HEAP32[(HEAP32[i38 >> 2] | 0) + 12 >> 2] | 0;
   f11 = Math_fround(-f60);
   f59 = Math_fround(-f12);
   HEAPF32[i29 >> 2] = Math_fround(-f58);
   HEAPF32[i20 >> 2] = f11;
   HEAPF32[i21 >> 2] = f59;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   mftCall_viiiii(i13 | 0, i38 | 0, i29 | 0, i35 | 0, i36 | 0, i34 | 0);
   i13 = HEAP32[i32 >> 2] | 0;
   f59 = Math_fround(HEAPF32[i34 >> 2]);
   f11 = Math_fround(HEAPF32[i23 >> 2]);
   f12 = Math_fround(Math_fround(Math_fround(f58 * f59) + Math_fround(f60 * f11)) + Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2])));
   i8 = f12 >= Math_fround(0.0) & f10 > f12;
   f10 = i8 ? f12 : f10;
   HEAPF32[i37 >> 2] = f10;
   HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i31 >> 2] = i9;
   HEAP32[i25 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   f11 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f14 >= Math_fround(Math_abs(Math_fround(f10 - f11)))) {
    i2 = 21;
    break;
   }
   if (Math_fround(f12 - f11) < Math_fround(1.1920929e-07)) {
    i2 = 23;
    break;
   }
   i7 = i39 + 272 + (i13 << 4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   i7 = i39 + 1296 + (i13 << 4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   HEAP32[i32 >> 2] = i13 + 1;
   HEAP32[i19 >> 2] = 0;
   HEAP8[i2 >> 0] = 1;
   __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i1 + 20 >> 2] | 0, HEAP8[i1 + 32 >> 0] | 0, i34, i41, i40, i18, i15);
   __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i1 + 24 >> 2] | 0, HEAP8[i1 + 33 >> 0] | 0, i34, i41, i40, i18, i15);
   __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i1 + 28 >> 2] | 0, HEAP8[i1 + 34 >> 0] | 0, i34, i41, i40, i18, i15);
   i7 = HEAP32[i19 >> 2] | 0;
   if (!i7) {
    i1 = 5;
    i2 = 43;
    break;
   }
   if (i7 >>> 0 > (64 - (HEAP32[i15 >> 2] | 0) + (HEAP32[i26 >> 2] | 0) | 0) >>> 0) {
    i2 = 26;
    break;
   }
   i6 = HEAP32[i18 >> 2] | 0;
   i9 = HEAP32[i27 >> 2] | 0;
   i9 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, HEAP8[(HEAP32[gb + 84752 + (i9 << 2) >> 2] | 0) + (i6 + 35) >> 0] | 0, HEAP8[i6 + 35 + i9 >> 0] | 0, i13, i31, i37) | 0;
   i6 = HEAP32[i18 >> 2] | 0;
   i8 = HEAP32[i27 >> 2] | 0;
   HEAP32[i9 + 20 >> 2] = i6;
   HEAP8[i9 + 32 >> 0] = i8;
   HEAP32[i6 + 20 + (i8 << 2) >> 2] = i9;
   HEAP8[i6 + 32 + i8 >> 0] = 0;
   if (i7 >>> 0 < 2) i2 = i9; else {
    i8 = 1;
    i2 = i9;
    do {
     i3 = i39 + 5392 + (i8 << 3) | 0;
     i61 = HEAP32[i3 >> 2] | 0;
     i4 = i39 + 5392 + (i8 << 3) + 4 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i2;
     i2 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i39, HEAP8[(HEAP32[gb + 84752 + (i5 << 2) >> 2] | 0) + (i61 + 35) >> 0] | 0, HEAP8[i61 + 35 + i5 >> 0] | 0, i13, i31, i37) | 0;
     i3 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i4 >> 2] | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     HEAP8[i2 + 32 >> 0] = i4;
     HEAP32[i3 + 20 + (i4 << 2) >> 2] = i2;
     HEAP8[i3 + 32 + i4 >> 0] = 0;
     i5 = HEAP8[i2 + 35 >> 0] | 0;
     if (i5 << 24 >> 24 == (HEAP8[(HEAP32[gb + 84752 + (i4 << 2) >> 2] | 0) + (i3 + 35) >> 0] | 0)) i3 = (HEAP8[i2 + 36 >> 0] | 0) == (HEAP8[i3 + 35 + i4 >> 0] | 0); else i3 = 0;
     HEAP32[i2 + 28 >> 2] = i6;
     HEAP8[i2 + 34 >> 0] = 1;
     HEAP32[i6 + 24 >> 2] = i2;
     HEAP8[i6 + 33 >> 0] = 2;
     if ((HEAP8[i2 + 37 >> 0] | 0) != (HEAP8[i6 + 37 >> 0] | 0)) {
      i2 = 33;
      break L24;
     }
     i3 = i3 & i5 << 24 >> 24 == (HEAP8[i6 + 36 >> 0] | 0);
     i8 = i8 + 1 | 0;
    } while (!(i8 >>> 0 >= i7 >>> 0 | i3 ^ 1));
    if (!i3) {
     i2 = 33;
     break;
    }
   }
   HEAP32[i9 + 28 >> 2] = i2;
   HEAP8[i9 + 34 >> 0] = 1;
   HEAP32[i2 + 24 >> 2] = i9;
   HEAP8[i2 + 33 >> 0] = 2;
   i3 = i1;
  }
  i2 = HEAPU8[i1 + 40 >> 0] | 0;
  if (((HEAP32[i15 >> 2] | 0) + -1 | 0) == (i2 | 0)) HEAP32[i15 >> 2] = i2; else {
   i61 = HEAP32[i26 >> 2] | 0;
   HEAP32[i26 >> 2] = i61 + 1;
   HEAP32[i39 + 5656 + (i61 << 2) >> 2] = i2;
  }
  if (!(HEAP32[i39 >> 2] | 0)) {
   i2 = 42;
   break;
  }
  if (Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + 16 >> 2]) > f10) {
   i1 = i3;
   i2 = 40;
   break;
  }
  if ((HEAP32[i32 >> 2] | 0) == 64) {
   i2 = 42;
   break;
  }
 }
 if ((i2 | 0) == 21) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 6;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 23) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 5;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 26) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 5;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 33) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 5;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 40) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 6;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 42) {
  __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i41, i40, i1, i42, i43, i45, i46, i44, i47, i48);
  i61 = 5;
  STACKTOP = i49;
  return i61 | 0;
 } else if ((i2 | 0) == 43) {
  STACKTOP = i49;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx12_GLOBAL__N_111diagonalizeEPPNS_14Px1DConstraintERKNS0_9MassPropsE(i37, i4) {
 i37 = i37 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i38 + 32 | 0;
 i27 = i38 + 16 | 0;
 i28 = i38;
 i35 = HEAP32[i37 >> 2] | 0;
 f32 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(i35, i35, i4));
 i35 = i37 + 4 | 0;
 f33 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(HEAP32[i37 >> 2] | 0, HEAP32[i35 >> 2] | 0, i4));
 i36 = i37 + 8 | 0;
 f29 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(HEAP32[i37 >> 2] | 0, HEAP32[i36 >> 2] | 0, i4));
 i12 = HEAP32[i35 >> 2] | 0;
 f30 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(i12, i12, i4));
 f31 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(HEAP32[i35 >> 2] | 0, HEAP32[i36 >> 2] | 0, i4));
 i12 = HEAP32[i36 >> 2] | 0;
 f11 = Math_fround(__ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(i12, i12, i4));
 i12 = i34 + 4 | 0;
 i13 = i34 + 8 | 0;
 i14 = i34 + 12 | 0;
 i15 = i34 + 16 | 0;
 i16 = i34 + 20 | 0;
 i17 = i34 + 24 | 0;
 i18 = i34 + 28 | 0;
 i19 = i34 + 32 | 0;
 i20 = i27 + 4 | 0;
 i21 = i27 + 8 | 0;
 i22 = i27 + 12 | 0;
 i23 = i28 + 4 | 0;
 i24 = i28 + 8 | 0;
 i25 = i28 + 12 | 0;
 f5 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 f1 = Math_fround(1.0);
 i26 = 0;
 do {
  f47 = Math_fround(f5 + f5);
  f52 = Math_fround(f3 + f3);
  f42 = Math_fround(f2 + f2);
  f55 = Math_fround(f3 * f52);
  f39 = Math_fround(f2 * f42);
  f58 = Math_fround(f3 * f47);
  f53 = Math_fround(f2 * f47);
  f51 = Math_fround(f1 * f47);
  f56 = Math_fround(f2 * f52);
  f52 = Math_fround(f1 * f52);
  f42 = Math_fround(f1 * f42);
  f48 = Math_fround(Math_fround(Math_fround(1.0) - f55) - f39);
  f46 = Math_fround(f42 + f58);
  f50 = Math_fround(f53 - f52);
  f42 = Math_fround(f58 - f42);
  f47 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f47));
  f39 = Math_fround(f47 - f39);
  f58 = Math_fround(f56 + f51);
  f53 = Math_fround(f52 + f53);
  f51 = Math_fround(f56 - f51);
  f55 = Math_fround(f47 - f55);
  f47 = Math_fround(Math_fround(f29 * f50) + Math_fround(Math_fround(f32 * f48) + Math_fround(f33 * f46)));
  f56 = Math_fround(Math_fround(f29 * f58) + Math_fround(Math_fround(f32 * f42) + Math_fround(f33 * f39)));
  f52 = Math_fround(Math_fround(Math_fround(f32 * f53) + Math_fround(f33 * f51)) + Math_fround(f29 * f55));
  f45 = Math_fround(Math_fround(f31 * f50) + Math_fround(Math_fround(f33 * f48) + Math_fround(f30 * f46)));
  f41 = Math_fround(Math_fround(f31 * f58) + Math_fround(Math_fround(f33 * f42) + Math_fround(f30 * f39)));
  f40 = Math_fround(Math_fround(Math_fround(f33 * f53) + Math_fround(f30 * f51)) + Math_fround(f31 * f55));
  f49 = Math_fround(Math_fround(f11 * f50) + Math_fround(Math_fround(f29 * f48) + Math_fround(f31 * f46)));
  f57 = Math_fround(Math_fround(f11 * f58) + Math_fround(Math_fround(f29 * f42) + Math_fround(f31 * f39)));
  f54 = Math_fround(Math_fround(Math_fround(f29 * f53) + Math_fround(f31 * f51)) + Math_fround(f11 * f55));
  f6 = Math_fround(Math_fround(f50 * f57) + Math_fround(Math_fround(f48 * f56) + Math_fround(f46 * f41)));
  f7 = Math_fround(Math_fround(f50 * f54) + Math_fround(Math_fround(f48 * f52) + Math_fround(f46 * f40)));
  f44 = Math_fround(Math_fround(f58 * f49) + Math_fround(Math_fround(f42 * f47) + Math_fround(f39 * f45)));
  f43 = Math_fround(Math_fround(f58 * f57) + Math_fround(Math_fround(f42 * f56) + Math_fround(f39 * f41)));
  f39 = Math_fround(Math_fround(f58 * f54) + Math_fround(Math_fround(f42 * f52) + Math_fround(f39 * f40)));
  f42 = Math_fround(Math_fround(f55 * f49) + Math_fround(Math_fround(f53 * f47) + Math_fround(f51 * f45)));
  f41 = Math_fround(Math_fround(f55 * f57) + Math_fround(Math_fround(f53 * f56) + Math_fround(f51 * f41)));
  f40 = Math_fround(Math_fround(f55 * f54) + Math_fround(Math_fround(f53 * f52) + Math_fround(f51 * f40)));
  HEAPF32[i34 >> 2] = Math_fround(Math_fround(f50 * f49) + Math_fround(Math_fround(f48 * f47) + Math_fround(f46 * f45)));
  HEAPF32[i12 >> 2] = f6;
  HEAPF32[i13 >> 2] = f7;
  HEAPF32[i14 >> 2] = f44;
  HEAPF32[i15 >> 2] = f43;
  HEAPF32[i16 >> 2] = f39;
  HEAPF32[i17 >> 2] = f42;
  HEAPF32[i18 >> 2] = f41;
  HEAPF32[i19 >> 2] = f40;
  f39 = Math_fround(Math_abs(Math_fround(f39)));
  f7 = Math_fround(Math_abs(Math_fround(f7)));
  f6 = Math_fround(Math_abs(Math_fround(f6)));
  i10 = f39 > f7 & f39 > f6 ? 0 : f7 > f6 ? 1 : 2;
  i8 = i10 + 1 + (i10 >>> 1) | 0;
  i4 = i8 & 3;
  i8 = i8 + 1 + (i4 >>> 1) & 3;
  i9 = i34 + (i4 * 12 | 0) | 0;
  f6 = Math_fround(HEAPF32[i9 + (i8 << 2) >> 2]);
  if (f6 == Math_fround(0.0)) break;
  f7 = Math_fround(HEAPF32[i9 + (i4 << 2) >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i34 + (i8 * 12 | 0) + (i8 << 2) >> 2]));
  f6 = Math_fround(f6 * Math_fround(2.0));
  if (+Math_fround(Math_abs(Math_fround(f7))) > +Math_fround(Math_abs(Math_fround(f6))) * 2.0e6) break;
  f6 = Math_fround(f7 / f6);
  f7 = Math_fround(Math_abs(Math_fround(f6)));
  if (f7 > Math_fround(1.0e3)) {
   f58 = Math_fround(Math_fround(1.0) / Math_fround(f6 * Math_fround(4.0)));
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   HEAPF32[i21 >> 2] = Math_fround(0.0);
   HEAPF32[i22 >> 2] = Math_fround(1.0);
   HEAPF32[i27 + (i10 << 2) >> 2] = f58;
   i4 = i22;
   i8 = i21;
   i9 = i20;
   i10 = i27;
  } else {
   f57 = Math_fround(Math_fround(1.0) / Math_fround(f7 + Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(1.0))))));
   f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f57 * f57) + Math_fround(1.0)))));
   f58 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(1.0) - f57) * Math_fround(.5))));
   i4 = f6 >= Math_fround(0.0);
   f58 = Math_fround((i4 ? Math_fround(1.0) : Math_fround(-1.0)) * f58);
   f57 = Math_fround(Math_sqrt(Math_fround(Math_fround(f57 + Math_fround(1.0)) * Math_fround(.5))));
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   HEAPF32[i23 >> 2] = Math_fround(0.0);
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   HEAPF32[i25 >> 2] = f57;
   HEAPF32[i28 + (i10 << 2) >> 2] = f58;
   i4 = i25;
   i8 = i24;
   i9 = i23;
   i10 = i28;
  }
  f53 = Math_fround(HEAPF32[i10 >> 2]);
  f54 = Math_fround(HEAPF32[i9 >> 2]);
  f58 = Math_fround(HEAPF32[i8 >> 2]);
  f52 = Math_fround(HEAPF32[i4 >> 2]);
  f55 = Math_fround(Math_fround(Math_fround(f3 * f58) + Math_fround(Math_fround(f1 * f53) + Math_fround(f5 * f52))) - Math_fround(f2 * f54));
  f56 = Math_fround(Math_fround(Math_fround(f2 * f53) + Math_fround(Math_fround(f1 * f54) + Math_fround(f3 * f52))) - Math_fround(f5 * f58));
  f57 = Math_fround(Math_fround(Math_fround(f5 * f54) + Math_fround(Math_fround(f1 * f58) + Math_fround(f2 * f52))) - Math_fround(f3 * f53));
  f1 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f52) - Math_fround(f5 * f53)) - Math_fround(f3 * f54)) - Math_fround(f2 * f58));
  f58 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f57 * f57) + Math_fround(Math_fround(f55 * f55) + Math_fround(f56 * f56)))))));
  f5 = Math_fround(f58 * f55);
  f3 = Math_fround(f58 * f56);
  f2 = Math_fround(f58 * f57);
  f1 = Math_fround(f58 * f1);
  i26 = i26 + 1 | 0;
 } while (i26 >>> 0 < 5);
 f31 = Math_fround(-f5);
 f29 = Math_fround(-f3);
 f40 = Math_fround(-f2);
 f48 = Math_fround(-f1);
 f57 = Math_fround(f31 - f5);
 f47 = Math_fround(f29 - f3);
 f56 = Math_fround(f40 - f2);
 f58 = Math_fround(f47 * f29);
 f49 = Math_fround(f56 * f40);
 f29 = Math_fround(f57 * f29);
 f50 = Math_fround(f57 * f40);
 f52 = Math_fround(f57 * f48);
 f40 = Math_fround(f47 * f40);
 f47 = Math_fround(f47 * f48);
 f48 = Math_fround(f56 * f48);
 f56 = Math_fround(Math_fround(Math_fround(1.0) - f58) - f49);
 f54 = Math_fround(f48 + f29);
 f55 = Math_fround(f50 - f47);
 f48 = Math_fround(f29 - f48);
 f31 = Math_fround(Math_fround(1.0) - Math_fround(f57 * f31));
 f49 = Math_fround(f31 - f49);
 f57 = Math_fround(f40 + f52);
 f50 = Math_fround(f47 + f50);
 f52 = Math_fround(f40 - f52);
 f58 = Math_fround(f31 - f58);
 i26 = HEAP32[i37 >> 2] | 0;
 i18 = HEAP32[i35 >> 2] | 0;
 i23 = HEAP32[i36 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i26 >> 2]);
 f40 = Math_fround(f56 * f31);
 i27 = i26 + 4 | 0;
 f47 = Math_fround(HEAPF32[i27 >> 2]);
 f29 = Math_fround(f56 * f47);
 i28 = i26 + 8 | 0;
 f32 = Math_fround(HEAPF32[i28 >> 2]);
 f33 = Math_fround(f56 * f32);
 f46 = Math_fround(HEAPF32[i18 >> 2]);
 f30 = Math_fround(f54 * f46);
 i19 = i18 + 4 | 0;
 f44 = Math_fround(HEAPF32[i19 >> 2]);
 f53 = Math_fround(f54 * f44);
 i20 = i18 + 8 | 0;
 f39 = Math_fround(HEAPF32[i20 >> 2]);
 f30 = Math_fround(f40 + f30);
 f53 = Math_fround(f29 + f53);
 f33 = Math_fround(f33 + Math_fround(f54 * f39));
 f29 = Math_fround(HEAPF32[i23 >> 2]);
 f40 = Math_fround(f55 * f29);
 i34 = i23 + 4 | 0;
 f42 = Math_fround(HEAPF32[i34 >> 2]);
 f43 = Math_fround(f55 * f42);
 i25 = i23 + 8 | 0;
 f51 = Math_fround(HEAPF32[i25 >> 2]);
 f43 = Math_fround(f53 + f43);
 f33 = Math_fround(f33 + Math_fround(f55 * f51));
 f53 = Math_fround(Math_fround(Math_fround(f48 * f31) + Math_fround(f49 * f46)) + Math_fround(f57 * f29));
 f41 = Math_fround(Math_fround(Math_fround(f48 * f47) + Math_fround(f49 * f44)) + Math_fround(f57 * f42));
 f45 = Math_fround(Math_fround(Math_fround(f48 * f32) + Math_fround(f49 * f39)) + Math_fround(f57 * f51));
 f29 = Math_fround(Math_fround(Math_fround(f50 * f31) + Math_fround(f52 * f46)) + Math_fround(f58 * f29));
 f42 = Math_fround(Math_fround(Math_fround(f50 * f47) + Math_fround(f52 * f44)) + Math_fround(f58 * f42));
 f51 = Math_fround(Math_fround(Math_fround(f50 * f32) + Math_fround(f52 * f39)) + Math_fround(f58 * f51));
 HEAPF32[i26 >> 2] = Math_fround(f30 + f40);
 HEAPF32[i27 >> 2] = f43;
 HEAPF32[i28 >> 2] = f33;
 HEAPF32[i18 >> 2] = f53;
 HEAPF32[i19 >> 2] = f41;
 HEAPF32[i20 >> 2] = f45;
 HEAPF32[i23 >> 2] = f29;
 HEAPF32[i34 >> 2] = f42;
 HEAPF32[i25 >> 2] = f51;
 i25 = i26 + 32 | 0;
 f51 = Math_fround(HEAPF32[i25 >> 2]);
 f42 = Math_fround(f56 * f51);
 i34 = i26 + 36 | 0;
 f29 = Math_fround(HEAPF32[i34 >> 2]);
 f45 = Math_fround(f56 * f29);
 i26 = i26 + 40 | 0;
 f41 = Math_fround(HEAPF32[i26 >> 2]);
 f53 = Math_fround(f56 * f41);
 i20 = i18 + 32 | 0;
 f33 = Math_fround(HEAPF32[i20 >> 2]);
 f43 = Math_fround(f54 * f33);
 i19 = i18 + 36 | 0;
 f40 = Math_fround(HEAPF32[i19 >> 2]);
 f30 = Math_fround(f54 * f40);
 i18 = i18 + 40 | 0;
 f39 = Math_fround(HEAPF32[i18 >> 2]);
 f43 = Math_fround(f42 + f43);
 f30 = Math_fround(f45 + f30);
 f53 = Math_fround(f53 + Math_fround(f54 * f39));
 i28 = i23 + 32 | 0;
 f45 = Math_fround(HEAPF32[i28 >> 2]);
 f42 = Math_fround(f55 * f45);
 i27 = i23 + 36 | 0;
 f32 = Math_fround(HEAPF32[i27 >> 2]);
 f44 = Math_fround(f55 * f32);
 i23 = i23 + 40 | 0;
 f47 = Math_fround(HEAPF32[i23 >> 2]);
 f44 = Math_fround(f30 + f44);
 f53 = Math_fround(f53 + Math_fround(f55 * f47));
 f30 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(f49 * f33)) + Math_fround(f57 * f45));
 f46 = Math_fround(Math_fround(Math_fround(f48 * f29) + Math_fround(f49 * f40)) + Math_fround(f57 * f32));
 f31 = Math_fround(Math_fround(Math_fround(f48 * f41) + Math_fround(f49 * f39)) + Math_fround(f57 * f47));
 f45 = Math_fround(Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f33)) + Math_fround(f58 * f45));
 f32 = Math_fround(Math_fround(Math_fround(f50 * f29) + Math_fround(f52 * f40)) + Math_fround(f58 * f32));
 f47 = Math_fround(Math_fround(Math_fround(f50 * f41) + Math_fround(f52 * f39)) + Math_fround(f58 * f47));
 HEAPF32[i25 >> 2] = Math_fround(f43 + f42);
 HEAPF32[i34 >> 2] = f44;
 HEAPF32[i26 >> 2] = f53;
 HEAPF32[i20 >> 2] = f30;
 HEAPF32[i19 >> 2] = f46;
 HEAPF32[i18 >> 2] = f31;
 HEAPF32[i28 >> 2] = f45;
 HEAPF32[i27 >> 2] = f32;
 HEAPF32[i23 >> 2] = f47;
 i23 = HEAP32[i37 >> 2] | 0;
 i27 = HEAP32[i35 >> 2] | 0;
 i28 = HEAP32[i36 >> 2] | 0;
 i18 = i23 + 16 | 0;
 f47 = Math_fround(HEAPF32[i18 >> 2]);
 f32 = Math_fround(f56 * f47);
 i19 = i23 + 20 | 0;
 f45 = Math_fround(HEAPF32[i19 >> 2]);
 f31 = Math_fround(f56 * f45);
 i20 = i23 + 24 | 0;
 f46 = Math_fround(HEAPF32[i20 >> 2]);
 f30 = Math_fround(f56 * f46);
 i26 = i27 + 16 | 0;
 f53 = Math_fround(HEAPF32[i26 >> 2]);
 f44 = Math_fround(f54 * f53);
 i34 = i27 + 20 | 0;
 f42 = Math_fround(HEAPF32[i34 >> 2]);
 f43 = Math_fround(f54 * f42);
 i25 = i27 + 24 | 0;
 f39 = Math_fround(HEAPF32[i25 >> 2]);
 f44 = Math_fround(f32 + f44);
 f43 = Math_fround(f31 + f43);
 f30 = Math_fround(f30 + Math_fround(f54 * f39));
 i24 = i28 + 16 | 0;
 f31 = Math_fround(HEAPF32[i24 >> 2]);
 f32 = Math_fround(f55 * f31);
 i22 = i28 + 20 | 0;
 f41 = Math_fround(HEAPF32[i22 >> 2]);
 f40 = Math_fround(f55 * f41);
 i21 = i28 + 24 | 0;
 f29 = Math_fround(HEAPF32[i21 >> 2]);
 f40 = Math_fround(f43 + f40);
 f30 = Math_fround(f30 + Math_fround(f55 * f29));
 f43 = Math_fround(Math_fround(Math_fround(f48 * f47) + Math_fround(f49 * f53)) + Math_fround(f57 * f31));
 f33 = Math_fround(Math_fround(Math_fround(f48 * f45) + Math_fround(f49 * f42)) + Math_fround(f57 * f41));
 f51 = Math_fround(Math_fround(Math_fround(f48 * f46) + Math_fround(f49 * f39)) + Math_fround(f57 * f29));
 f31 = Math_fround(Math_fround(Math_fround(f50 * f47) + Math_fround(f52 * f53)) + Math_fround(f58 * f31));
 f41 = Math_fround(Math_fround(Math_fround(f50 * f45) + Math_fround(f52 * f42)) + Math_fround(f58 * f41));
 f29 = Math_fround(Math_fround(Math_fround(f50 * f46) + Math_fround(f52 * f39)) + Math_fround(f58 * f29));
 HEAPF32[i18 >> 2] = Math_fround(f44 + f32);
 HEAPF32[i19 >> 2] = f40;
 HEAPF32[i20 >> 2] = f30;
 HEAPF32[i26 >> 2] = f43;
 HEAPF32[i34 >> 2] = f33;
 HEAPF32[i25 >> 2] = f51;
 HEAPF32[i24 >> 2] = f31;
 HEAPF32[i22 >> 2] = f41;
 HEAPF32[i21 >> 2] = f29;
 i21 = i23 + 48 | 0;
 f29 = Math_fround(HEAPF32[i21 >> 2]);
 f41 = Math_fround(f56 * f29);
 i22 = i23 + 52 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f51 = Math_fround(f56 * f31);
 i23 = i23 + 56 | 0;
 f33 = Math_fround(HEAPF32[i23 >> 2]);
 f43 = Math_fround(f56 * f33);
 i24 = i27 + 48 | 0;
 f30 = Math_fround(HEAPF32[i24 >> 2]);
 f40 = Math_fround(f54 * f30);
 i25 = i27 + 52 | 0;
 f32 = Math_fround(HEAPF32[i25 >> 2]);
 f44 = Math_fround(f54 * f32);
 i27 = i27 + 56 | 0;
 f39 = Math_fround(HEAPF32[i27 >> 2]);
 f40 = Math_fround(f41 + f40);
 f44 = Math_fround(f51 + f44);
 f43 = Math_fround(f43 + Math_fround(f54 * f39));
 i34 = i28 + 48 | 0;
 f51 = Math_fround(HEAPF32[i34 >> 2]);
 f41 = Math_fround(f55 * f51);
 i26 = i28 + 52 | 0;
 f46 = Math_fround(HEAPF32[i26 >> 2]);
 f42 = Math_fround(f55 * f46);
 i28 = i28 + 56 | 0;
 f45 = Math_fround(HEAPF32[i28 >> 2]);
 f42 = Math_fround(f44 + f42);
 f43 = Math_fround(f43 + Math_fround(f55 * f45));
 f44 = Math_fround(Math_fround(Math_fround(f48 * f29) + Math_fround(f49 * f30)) + Math_fround(f57 * f51));
 f53 = Math_fround(Math_fround(Math_fround(f48 * f31) + Math_fround(f49 * f32)) + Math_fround(f57 * f46));
 f47 = Math_fround(Math_fround(Math_fround(f48 * f33) + Math_fround(f49 * f39)) + Math_fround(f57 * f45));
 f51 = Math_fround(Math_fround(Math_fround(f50 * f29) + Math_fround(f52 * f30)) + Math_fround(f58 * f51));
 f46 = Math_fround(Math_fround(Math_fround(f50 * f31) + Math_fround(f52 * f32)) + Math_fround(f58 * f46));
 f45 = Math_fround(Math_fround(Math_fround(f50 * f33) + Math_fround(f52 * f39)) + Math_fround(f58 * f45));
 HEAPF32[i21 >> 2] = Math_fround(f40 + f41);
 HEAPF32[i22 >> 2] = f42;
 HEAPF32[i23 >> 2] = f43;
 HEAPF32[i24 >> 2] = f44;
 HEAPF32[i25 >> 2] = f53;
 HEAPF32[i27 >> 2] = f47;
 HEAPF32[i34 >> 2] = f51;
 HEAPF32[i26 >> 2] = f46;
 HEAPF32[i28 >> 2] = f45;
 i28 = HEAP32[i37 >> 2] | 0;
 i26 = i28 + 28 | 0;
 i34 = HEAP32[i35 >> 2] | 0;
 i27 = i34 + 28 | 0;
 i37 = HEAP32[i36 >> 2] | 0;
 i35 = i37 + 28 | 0;
 f45 = Math_fround(HEAPF32[i26 >> 2]);
 f46 = Math_fround(f56 * f45);
 f51 = Math_fround(HEAPF32[i27 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f54 * f51));
 f47 = Math_fround(HEAPF32[i35 >> 2]);
 f53 = Math_fround(Math_fround(Math_fround(f48 * f45) + Math_fround(f49 * f51)) + Math_fround(f57 * f47));
 f51 = Math_fround(Math_fround(Math_fround(f50 * f45) + Math_fround(f52 * f51)) + Math_fround(f58 * f47));
 HEAPF32[i26 >> 2] = Math_fround(f46 + Math_fround(f55 * f47));
 HEAPF32[i27 >> 2] = f53;
 HEAPF32[i35 >> 2] = f51;
 i35 = i28 + 12 | 0;
 i36 = i34 + 12 | 0;
 i37 = i37 + 12 | 0;
 f51 = Math_fround(HEAPF32[i35 >> 2]);
 f56 = Math_fround(f56 * f51);
 f53 = Math_fround(HEAPF32[i36 >> 2]);
 f54 = Math_fround(f56 + Math_fround(f54 * f53));
 f56 = Math_fround(HEAPF32[i37 >> 2]);
 f57 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(f49 * f53)) + Math_fround(f57 * f56));
 f58 = Math_fround(Math_fround(Math_fround(f50 * f51) + Math_fround(f52 * f53)) + Math_fround(f58 * f56));
 HEAPF32[i35 >> 2] = Math_fround(f54 + Math_fround(f55 * f56));
 HEAPF32[i36 >> 2] = f57;
 HEAPF32[i37 >> 2] = f58;
 STACKTOP = i38;
 return;
}

function __ZN5Unity17ConfigurableJoint16CheckConsistencyEv(i13) {
 i13 = i13 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i14 = 0, i15 = 0, i16 = 0;
 __ZN5Unity5Joint16CheckConsistencyEv(i13);
 i2 = i13 + 132 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0);
 f6 = i4 ? Math_fround(1.0) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 136 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i10 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i10 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = i13 + 128 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(0.0); else {
  i10 = f1 < Math_fround(.00100000005);
  i9 = f1 > Math_fround(340282326000000008404918.0e15);
  f1 = i9 ? Math_fround(340282326000000008404918.0e15) : f1;
  f1 = i10 ? Math_fround(.00100000005) : f1;
 }
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i3 >> 2] = f5;
 i4 = i13 + 148 | 0;
 i10 = i13 + 160 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i13 + 152 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i13 + 156 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 i8 = i13 + 164 | 0;
 i9 = i13 + 168 | 0;
 i7 = f1 < Math_fround(-177.0);
 i14 = f1 > Math_fround(177.0);
 f1 = i14 ? Math_fround(177.0) : f1;
 i14 = i7 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = f5 < Math_fround(-177.0);
 i15 = f5 > Math_fround(177.0);
 f12 = i15 ? Math_fround(177.0) : f5;
 f12 = i7 ? Math_fround(-177.0) : f12;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = f12 < (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i14 = i15 ? i7 : i14;
 i15 = f11 < Math_fround(0.0);
 i16 = f11 > Math_fround(340282326000000008404918.0e15);
 f1 = i16 ? Math_fround(340282326000000008404918.0e15) : f11;
 f1 = i15 ? Math_fround(0.0) : f1;
 i15 = f6 < Math_fround(0.0);
 i16 = f6 > Math_fround(1.0);
 f5 = i16 ? Math_fround(1.0) : f6;
 f5 = i15 ? Math_fround(0.0) : f5;
 HEAP32[i4 >> 2] = i14;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = f1;
 f1 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 i14 = f1 < Math_fround(-177.0);
 i4 = f1 > Math_fround(177.0);
 f1 = i4 ? Math_fround(177.0) : f1;
 i2 = i14 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = f12 < (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = f6 < Math_fround(0.0);
 i16 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i16 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i4 ? Math_fround(0.0) : f6;
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(1.0);
 f5 = i16 ? Math_fround(1.0) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 HEAP32[i10 >> 2] = i3 ? i2 : i7;
 HEAPF32[i8 >> 2] = f5;
 HEAPF32[i9 >> 2] = f6;
 i2 = i13 + 184 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0);
 f6 = i4 ? Math_fround(1.0) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 188 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i16 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = i13 + 180 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(0.0); else {
  i16 = f1 < Math_fround(3.0);
  i15 = f1 > Math_fround(177.0);
  f1 = i15 ? Math_fround(177.0) : f1;
  f1 = i16 ? Math_fround(3.0) : f1;
 }
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i3 >> 2] = f5;
 i2 = i13 + 196 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0);
 f6 = i4 ? Math_fround(1.0) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 200 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i16 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = i13 + 192 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(0.0); else {
  i16 = f1 < Math_fround(3.0);
  i15 = f1 > Math_fround(177.0);
  f1 = i15 ? Math_fround(177.0) : f1;
  f1 = i16 ? Math_fround(3.0) : f1;
 }
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i3 >> 2] = f5;
 i4 = i13 + 120 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i13 + 124 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i16 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i16;
 i4 = i13 + 140 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i13 + 144 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i16 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i16;
 i4 = i13 + 172 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i13 + 176 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i7 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i7;
 i4 = i13 + 204 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i2 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i2 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 208 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i2 ? Math_fround(0.0) : f11;
 i2 = i13 + 212 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f12 < Math_fround(0.0);
 i8 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i8 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i7 ? Math_fround(0.0) : f12;
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i2 >> 2] = f12;
 i2 = i13 + 216 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 i4 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i4 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i3 ? Math_fround(0.0) : f12;
 i3 = i13 + 220 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i4 ? Math_fround(0.0) : f11;
 i4 = i13 + 224 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = f6 < Math_fround(0.0);
 i8 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i8 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i7 ? Math_fround(0.0) : f6;
 HEAPF32[i2 >> 2] = f12;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i4 >> 2] = f6;
 i4 = i13 + 228 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i2 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i2 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 232 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i2 ? Math_fround(0.0) : f11;
 i2 = i13 + 236 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f12 < Math_fround(0.0);
 i8 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i8 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i7 ? Math_fround(0.0) : f12;
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i2 >> 2] = f12;
 i2 = i13 + 252 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 i4 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i4 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i3 ? Math_fround(0.0) : f12;
 i3 = i13 + 256 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i4 ? Math_fround(0.0) : f11;
 i4 = i13 + 260 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = f6 < Math_fround(0.0);
 i8 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i8 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i7 ? Math_fround(0.0) : f6;
 HEAPF32[i2 >> 2] = f12;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i4 >> 2] = f6;
 i4 = i13 + 240 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i2 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i2 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 244 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i2 ? Math_fround(0.0) : f11;
 i2 = i13 + 248 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f12 < Math_fround(0.0);
 i8 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i8 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i7 ? Math_fround(0.0) : f12;
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i2 >> 2] = f12;
 i2 = i13 + 264 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 i4 = f12 > Math_fround(340282326000000008404918.0e15);
 f12 = i4 ? Math_fround(340282326000000008404918.0e15) : f12;
 f12 = i3 ? Math_fround(0.0) : f12;
 i3 = i13 + 268 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f11 < Math_fround(0.0);
 i7 = f11 > Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? Math_fround(340282326000000008404918.0e15) : f11;
 f11 = i4 ? Math_fround(0.0) : f11;
 i4 = i13 + 272 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = f6 < Math_fround(0.0);
 i8 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i8 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i7 ? Math_fround(0.0) : f6;
 HEAPF32[i2 >> 2] = f12;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i4 >> 2] = f6;
 i4 = i13 + 280 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i2 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i2 ? Math_fround(340282326000000008404918.0e15) : f6;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f6;
 i4 = i13 + 284 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i2 = f6 > Math_fround(180.0);
 f6 = i2 ? Math_fround(180.0) : f6;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f6;
 i4 = i13 + 296 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i13 + 300 | 0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i13 + 304 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f6 < Math_fround(340282326000000008404918.0e15);
 f6 = i7 ? f6 : Math_fround(340282326000000008404918.0e15);
 i7 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i7 ? f11 : Math_fround(340282326000000008404918.0e15);
 i7 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i7 ? f12 : Math_fround(340282326000000008404918.0e15);
 i7 = f6 > Math_fround(-340282326000000008404918.0e15);
 f6 = i7 ? f6 : Math_fround(-340282326000000008404918.0e15);
 i7 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i7 ? f11 : Math_fround(-340282326000000008404918.0e15);
 i7 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i7 ? f12 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i2 >> 2] = f12;
 i2 = HEAP32[i13 + 308 >> 2] | 0;
 i3 = i13 + 312 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i13 + 316 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i13 + 320 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (!((i2 & 2139095040 | 0) != 2139095040 & (i4 & 2139095040 | 0) != 2139095040 & (i8 & 2139095040 | 0) != 2139095040 & (i10 & 2139095040 | 0) != 2139095040)) {
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(1.0);
  i16 = i13 + 308 | 0;
  HEAPF32[i16 >> 2] = f5;
  HEAPF32[i3 >> 2] = f6;
  HEAPF32[i7 >> 2] = f11;
  HEAPF32[i9 >> 2] = f12;
  i16 = i13 + 324 | 0;
  f12 = Math_fround(HEAPF32[i16 >> 2]);
  i15 = i13 + 328 | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  i14 = i13 + 332 | 0;
  f6 = Math_fround(HEAPF32[i14 >> 2]);
  i10 = f12 < Math_fround(340282326000000008404918.0e15);
  f12 = i10 ? f12 : Math_fround(340282326000000008404918.0e15);
  i10 = f11 < Math_fround(340282326000000008404918.0e15);
  f11 = i10 ? f11 : Math_fround(340282326000000008404918.0e15);
  i10 = f6 < Math_fround(340282326000000008404918.0e15);
  f6 = i10 ? f6 : Math_fround(340282326000000008404918.0e15);
  i10 = f12 > Math_fround(-340282326000000008404918.0e15);
  f12 = i10 ? f12 : Math_fround(-340282326000000008404918.0e15);
  i10 = f11 > Math_fround(-340282326000000008404918.0e15);
  f11 = i10 ? f11 : Math_fround(-340282326000000008404918.0e15);
  i10 = f6 > Math_fround(-340282326000000008404918.0e15);
  f6 = i10 ? f6 : Math_fround(-340282326000000008404918.0e15);
  HEAPF32[i16 >> 2] = f12;
  HEAPF32[i15 >> 2] = f11;
  HEAPF32[i14 >> 2] = f6;
  i14 = i13 + 336 | 0;
  f6 = Math_fround(HEAPF32[i14 >> 2]);
  i15 = i13 + 340 | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  i16 = i13 + 344 | 0;
  f12 = Math_fround(HEAPF32[i16 >> 2]);
  i13 = f6 < Math_fround(340282326000000008404918.0e15);
  f6 = i13 ? f6 : Math_fround(340282326000000008404918.0e15);
  i13 = f11 < Math_fround(340282326000000008404918.0e15);
  f11 = i13 ? f11 : Math_fround(340282326000000008404918.0e15);
  i13 = f12 < Math_fround(340282326000000008404918.0e15);
  f12 = i13 ? f12 : Math_fround(340282326000000008404918.0e15);
  i13 = f6 > Math_fround(-340282326000000008404918.0e15);
  f6 = i13 ? f6 : Math_fround(-340282326000000008404918.0e15);
  i13 = f11 > Math_fround(-340282326000000008404918.0e15);
  f11 = i13 ? f11 : Math_fround(-340282326000000008404918.0e15);
  i13 = f12 > Math_fround(-340282326000000008404918.0e15);
  f12 = i13 ? f12 : Math_fround(-340282326000000008404918.0e15);
  HEAPF32[i14 >> 2] = f6;
  HEAPF32[i15 >> 2] = f11;
  HEAPF32[i16 >> 2] = f12;
  return;
 }
 f12 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i16 = i13 + 308 | 0;
 HEAPF32[i16 >> 2] = f5;
 HEAPF32[i3 >> 2] = f6;
 HEAPF32[i7 >> 2] = f11;
 HEAPF32[i9 >> 2] = f12;
 i16 = i13 + 324 | 0;
 f12 = Math_fround(HEAPF32[i16 >> 2]);
 i15 = i13 + 328 | 0;
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 i14 = i13 + 332 | 0;
 f6 = Math_fround(HEAPF32[i14 >> 2]);
 i10 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i10 ? f12 : Math_fround(340282326000000008404918.0e15);
 i10 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i10 ? f11 : Math_fround(340282326000000008404918.0e15);
 i10 = f6 < Math_fround(340282326000000008404918.0e15);
 f6 = i10 ? f6 : Math_fround(340282326000000008404918.0e15);
 i10 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i10 ? f12 : Math_fround(-340282326000000008404918.0e15);
 i10 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i10 ? f11 : Math_fround(-340282326000000008404918.0e15);
 i10 = f6 > Math_fround(-340282326000000008404918.0e15);
 f6 = i10 ? f6 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i16 >> 2] = f12;
 HEAPF32[i15 >> 2] = f11;
 HEAPF32[i14 >> 2] = f6;
 i14 = i13 + 336 | 0;
 f6 = Math_fround(HEAPF32[i14 >> 2]);
 i15 = i13 + 340 | 0;
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i13 + 344 | 0;
 f12 = Math_fround(HEAPF32[i16 >> 2]);
 i13 = f6 < Math_fround(340282326000000008404918.0e15);
 f6 = i13 ? f6 : Math_fround(340282326000000008404918.0e15);
 i13 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i13 ? f11 : Math_fround(340282326000000008404918.0e15);
 i13 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i13 ? f12 : Math_fround(340282326000000008404918.0e15);
 i13 = f6 > Math_fround(-340282326000000008404918.0e15);
 f6 = i13 ? f6 : Math_fround(-340282326000000008404918.0e15);
 i13 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i13 ? f11 : Math_fround(-340282326000000008404918.0e15);
 i13 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i13 ? f12 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i14 >> 2] = f6;
 HEAPF32[i15 >> 2] = f11;
 HEAPF32[i16 >> 2] = f12;
 return;
}

function __ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb(i54, i55, i48, i49, i47, i53, i45, i4, i3) {
 i54 = i54 | 0;
 i55 = i55 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 i47 = i47 | 0;
 i53 = i53 | 0;
 i45 = i45 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i50 = 0, i51 = 0, i52 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, i72 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i60 + 208 | 0;
 i57 = i60 + 144 | 0;
 i56 = i60 + 280 | 0;
 i51 = i60 + 128 | 0;
 i50 = i60 + 112 | 0;
 i5 = i60 + 276 | 0;
 i6 = i60 + 272 | 0;
 i52 = i60 + 96 | 0;
 i46 = i60 + 80 | 0;
 i25 = i60 + 64 | 0;
 i26 = i60 + 48 | 0;
 i35 = i60 + 32 | 0;
 i1 = i60 + 16 | 0;
 i2 = i60;
 i36 = i48 + 32 | 0;
 i28 = HEAP32[i36 >> 2] | 0;
 i37 = i49 + 32 | 0;
 i27 = HEAP32[i37 >> 2] | 0;
 f64 = Math_fround(HEAPF32[i28 >> 2]);
 f9 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f63 = Math_fround(HEAPF32[i28 + 12 >> 2]);
 f64 = Math_fround(-f64);
 f9 = Math_fround(-f9);
 f8 = Math_fround(-f8);
 f69 = Math_fround(HEAPF32[i27 + 16 >> 2]);
 f62 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f70 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f68 = Math_fround(HEAPF32[i28 + 16 >> 2]);
 f61 = Math_fround(HEAPF32[i28 + 20 >> 2]);
 f68 = Math_fround(f69 - f68);
 f61 = Math_fround(f62 - f61);
 f70 = Math_fround(f70 - Math_fround(HEAPF32[i28 + 24 >> 2]));
 f62 = Math_fround(Math_fround(f63 * f63) + Math_fround(-.5));
 f69 = Math_fround(Math_fround(Math_fround(f68 * f64) + Math_fround(f61 * f9)) + Math_fround(f70 * f8));
 f66 = Math_fround(Math_fround(Math_fround(f69 * f64) + Math_fround(Math_fround(f62 * f68) + Math_fround(f63 * Math_fround(Math_fround(f70 * f9) - Math_fround(f61 * f8))))) * Math_fround(2.0));
 f67 = Math_fround(Math_fround(Math_fround(f69 * f9) + Math_fround(Math_fround(f62 * f61) + Math_fround(f63 * Math_fround(Math_fround(f68 * f8) - Math_fround(f70 * f64))))) * Math_fround(2.0));
 f69 = Math_fround(Math_fround(Math_fround(Math_fround(f62 * f70) + Math_fround(f63 * Math_fround(Math_fround(f61 * f64) - Math_fround(f68 * f9)))) + Math_fround(f69 * f8)) * Math_fround(2.0));
 f68 = Math_fround(HEAPF32[i27 >> 2]);
 f61 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f70 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f62 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f65 = Math_fround(Math_fround(f63 * f62) - Math_fround(Math_fround(Math_fround(f68 * f64) + Math_fround(f61 * f9)) + Math_fround(f70 * f8)));
 f7 = Math_fround(Math_fround(Math_fround(f70 * f9) - Math_fround(f61 * f8)) + Math_fround(Math_fround(f63 * f68) + Math_fround(f62 * f64)));
 f10 = Math_fround(Math_fround(Math_fround(f68 * f8) - Math_fround(f70 * f64)) + Math_fround(Math_fround(f63 * f61) + Math_fround(f62 * f9)));
 f8 = Math_fround(Math_fround(Math_fround(f61 * f64) - Math_fround(f68 * f9)) + Math_fround(Math_fround(f63 * f70) + Math_fround(f62 * f8)));
 HEAPF32[i58 + 48 >> 2] = f66;
 HEAPF32[i58 + 52 >> 2] = f67;
 HEAPF32[i58 + 56 >> 2] = f69;
 HEAPF32[i58 + 60 >> 2] = Math_fround(0.0);
 f69 = Math_fround(f7 + f7);
 f67 = Math_fround(f10 + f10);
 f66 = Math_fround(f8 + f8);
 f62 = Math_fround(f10 * f67);
 f70 = Math_fround(f8 * f66);
 f10 = Math_fround(f10 * f69);
 f63 = Math_fround(f8 * f69);
 f9 = Math_fround(f65 * f69);
 f8 = Math_fround(f8 * f67);
 f67 = Math_fround(f65 * f67);
 f66 = Math_fround(f65 * f66);
 f69 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f69));
 f7 = Math_fround(f10 + f66);
 f65 = Math_fround(f63 - f67);
 f66 = Math_fround(f10 - f66);
 f10 = Math_fround(f69 - f70);
 f68 = Math_fround(f8 + f9);
 f67 = Math_fround(f63 + f67);
 f9 = Math_fround(f8 - f9);
 f69 = Math_fround(f69 - f62);
 HEAPF32[i58 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f62) - f70);
 i27 = i58 + 4 | 0;
 HEAPF32[i27 >> 2] = f7;
 i28 = i58 + 8 | 0;
 HEAPF32[i28 >> 2] = f65;
 HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
 i29 = i58 + 16 | 0;
 HEAPF32[i29 >> 2] = f66;
 i30 = i58 + 20 | 0;
 HEAPF32[i30 >> 2] = f10;
 i31 = i58 + 24 | 0;
 HEAPF32[i31 >> 2] = f68;
 HEAPF32[i58 + 28 >> 2] = Math_fround(0.0);
 i32 = i58 + 32 | 0;
 HEAPF32[i32 >> 2] = f67;
 i33 = i58 + 36 | 0;
 HEAPF32[i33 >> 2] = f9;
 i34 = i58 + 40 | 0;
 HEAPF32[i34 >> 2] = f69;
 HEAPF32[i58 + 44 >> 2] = Math_fround(0.0);
 i37 = HEAP32[i37 >> 2] | 0;
 i36 = HEAP32[i36 >> 2] | 0;
 f69 = Math_fround(HEAPF32[i37 >> 2]);
 f9 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f67 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f68 = Math_fround(HEAPF32[i37 + 12 >> 2]);
 f69 = Math_fround(-f69);
 f9 = Math_fround(-f9);
 f67 = Math_fround(-f67);
 f10 = Math_fround(HEAPF32[i36 + 16 >> 2]);
 f66 = Math_fround(HEAPF32[i36 + 20 >> 2]);
 f65 = Math_fround(HEAPF32[i36 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i37 + 16 >> 2]);
 f70 = Math_fround(HEAPF32[i37 + 20 >> 2]);
 f7 = Math_fround(f10 - f7);
 f70 = Math_fround(f66 - f70);
 f65 = Math_fround(f65 - Math_fround(HEAPF32[i37 + 24 >> 2]));
 f66 = Math_fround(Math_fround(f68 * f68) + Math_fround(-.5));
 f10 = Math_fround(Math_fround(Math_fround(f7 * f69) + Math_fround(f70 * f9)) + Math_fround(f65 * f67));
 f62 = Math_fround(Math_fround(Math_fround(f10 * f69) + Math_fround(Math_fround(f66 * f7) + Math_fround(f68 * Math_fround(Math_fround(f65 * f9) - Math_fround(f70 * f67))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(f10 * f9) + Math_fround(Math_fround(f66 * f70) + Math_fround(f68 * Math_fround(Math_fround(f7 * f67) - Math_fround(f65 * f69))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f66 * f65) + Math_fround(f68 * Math_fround(Math_fround(f70 * f69) - Math_fround(f7 * f9)))) + Math_fround(f10 * f67)) * Math_fround(2.0));
 f7 = Math_fround(HEAPF32[i36 >> 2]);
 f70 = Math_fround(HEAPF32[i36 + 4 >> 2]);
 f65 = Math_fround(HEAPF32[i36 + 8 >> 2]);
 f66 = Math_fround(HEAPF32[i36 + 12 >> 2]);
 f63 = Math_fround(Math_fround(f68 * f66) - Math_fround(Math_fround(Math_fround(f7 * f69) + Math_fround(f70 * f9)) + Math_fround(f65 * f67)));
 f64 = Math_fround(Math_fround(Math_fround(f65 * f9) - Math_fround(f70 * f67)) + Math_fround(Math_fround(f68 * f7) + Math_fround(f66 * f69)));
 f61 = Math_fround(Math_fround(Math_fround(f7 * f67) - Math_fround(f65 * f69)) + Math_fround(Math_fround(f68 * f70) + Math_fround(f66 * f9)));
 f67 = Math_fround(Math_fround(Math_fround(f70 * f69) - Math_fround(f7 * f9)) + Math_fround(Math_fround(f68 * f65) + Math_fround(f66 * f67)));
 HEAPF32[i57 + 48 >> 2] = f62;
 HEAPF32[i57 + 52 >> 2] = f8;
 HEAPF32[i57 + 56 >> 2] = f10;
 HEAPF32[i57 + 60 >> 2] = Math_fround(0.0);
 f10 = Math_fround(f64 + f64);
 f8 = Math_fround(f61 + f61);
 f62 = Math_fround(f67 + f67);
 f66 = Math_fround(f61 * f8);
 f65 = Math_fround(f67 * f62);
 f61 = Math_fround(f61 * f10);
 f68 = Math_fround(f67 * f10);
 f9 = Math_fround(f63 * f10);
 f67 = Math_fround(f67 * f8);
 f8 = Math_fround(f63 * f8);
 f62 = Math_fround(f63 * f62);
 f10 = Math_fround(Math_fround(1.0) - Math_fround(f64 * f10));
 f64 = Math_fround(f61 + f62);
 f63 = Math_fround(f68 - f8);
 f62 = Math_fround(f61 - f62);
 f61 = Math_fround(f10 - f65);
 f7 = Math_fround(f67 + f9);
 f8 = Math_fround(f68 + f8);
 f9 = Math_fround(f67 - f9);
 f10 = Math_fround(f10 - f66);
 HEAPF32[i57 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f66) - f65);
 i36 = i57 + 4 | 0;
 HEAPF32[i36 >> 2] = f64;
 i37 = i57 + 8 | 0;
 HEAPF32[i37 >> 2] = f63;
 HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
 i38 = i57 + 16 | 0;
 HEAPF32[i38 >> 2] = f62;
 i39 = i57 + 20 | 0;
 HEAPF32[i39 >> 2] = f61;
 i40 = i57 + 24 | 0;
 HEAPF32[i40 >> 2] = f7;
 HEAPF32[i57 + 28 >> 2] = Math_fround(0.0);
 i41 = i57 + 32 | 0;
 HEAPF32[i41 >> 2] = f8;
 i42 = i57 + 36 | 0;
 HEAPF32[i42 >> 2] = f9;
 i43 = i57 + 40 | 0;
 HEAPF32[i43 >> 2] = f10;
 HEAPF32[i57 + 44 >> 2] = Math_fround(0.0);
 i44 = HEAP32[i53 >> 2] | 0;
 if (!i3) {
  f70 = Math_fround(HEAPF32[i4 >> 2]);
  i52 = i4 + 4 | 0;
  f67 = Math_fround(HEAPF32[i52 >> 2]);
  i59 = i4 + 8 | 0;
  f67 = Math_fround(-f67);
  f66 = Math_fround(-Math_fround(HEAPF32[i59 >> 2]));
  HEAPF32[i1 >> 2] = Math_fround(-f70);
  HEAPF32[i1 + 4 >> 2] = f67;
  HEAPF32[i1 + 8 >> 2] = f66;
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  i56 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i55, i49, i1) | 0;
  f66 = Math_fround(HEAPF32[i4 >> 2]);
  f67 = Math_fround(HEAPF32[i52 >> 2]);
  f70 = Math_fround(HEAPF32[i59 >> 2]);
  f68 = Math_fround(f66 * Math_fround(HEAPF32[i57 >> 2]));
  f68 = Math_fround(f68 + Math_fround(f67 * Math_fround(HEAPF32[i36 >> 2])));
  f68 = Math_fround(f68 + Math_fround(f70 * Math_fround(HEAPF32[i37 >> 2])));
  f69 = Math_fround(f66 * Math_fround(HEAPF32[i38 >> 2]));
  f69 = Math_fround(f69 + Math_fround(f67 * Math_fround(HEAPF32[i39 >> 2])));
  f69 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i40 >> 2])));
  f66 = Math_fround(f66 * Math_fround(HEAPF32[i41 >> 2]));
  f67 = Math_fround(f66 + Math_fround(f67 * Math_fround(HEAPF32[i42 >> 2])));
  f70 = Math_fround(f67 + Math_fround(f70 * Math_fround(HEAPF32[i43 >> 2])));
  HEAPF32[i2 >> 2] = f68;
  HEAPF32[i2 + 4 >> 2] = f69;
  HEAPF32[i2 + 8 >> 2] = f70;
  HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
  i59 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i54, i48, i2) | 0;
  __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE(i55, i54, (HEAP32[i55 + 24 >> 2] | 0) + (i56 * 20 | 0) | 0, (HEAP32[i54 + 24 >> 2] | 0) + (i59 * 20 | 0) | 0, i49, i48, i58, i47, i53, i45);
  i59 = 1;
  STACKTOP = i60;
  return i59 | 0;
 }
 HEAP32[i56 >> 2] = 0;
 HEAPF32[i51 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i50 >> 2] = 0;
 HEAP32[i50 + 4 >> 2] = 0;
 HEAP32[i50 + 8 >> 2] = 0;
 HEAP32[i50 + 12 >> 2] = 0;
 if (!(__ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_(i54, i55, i48, i49, i57, i58, i45, i51, i5, i50, 0, i56) | 0)) {
  i59 = 0;
  STACKTOP = i60;
  return i59 | 0;
 }
 if (!(__ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_(i55, i54, i49, i48, i58, i57, i45, i51, i6, i50, 1, i56) | 0)) {
  i59 = 0;
  STACKTOP = i60;
  return i59 | 0;
 }
 i15 = i50 + 4 | 0;
 i16 = i50 + 8 | 0;
 i17 = i26 + 4 | 0;
 i18 = i26 + 8 | 0;
 i19 = i26 + 12 | 0;
 i20 = i54 + 24 | 0;
 i21 = i35 + 4 | 0;
 i22 = i35 + 8 | 0;
 i23 = i35 + 12 | 0;
 i24 = i55 + 24 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i12 = i52 + 4 | 0;
 i13 = i52 + 8 | 0;
 i14 = i52 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i25 + 4 | 0;
 i4 = i25 + 8 | 0;
 i5 = i25 + 12 | 0;
 i6 = 0;
 L11 : while (1) {
  L13 : do if (i6) {
   if (!(__ZN5physx2GuL14testEdgeNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RNS7_5Vec3VENS0_13FeatureStatusERSH_(i54, i55, i48, i49, i57, i58, i45, i51, i50, i56) | 0)) {
    i1 = 0;
    i59 = 16;
    break L11;
   }
   if ((HEAP32[i56 >> 2] | 0) == 2) i59 = 13; else {
    i1 = 1;
    i59 = 16;
    break L11;
   }
  } else {
   switch (HEAP32[i56 >> 2] | 0) {
   case 0:
    break;
   case 1:
    {
     i71 = (HEAP32[i24 >> 2] | 0) + (i2 * 20 | 0) | 0;
     f66 = Math_fround(HEAPF32[i50 >> 2]);
     f67 = Math_fround(HEAPF32[i15 >> 2]);
     f70 = Math_fround(HEAPF32[i16 >> 2]);
     f68 = Math_fround(Math_fround(Math_fround(f66 * Math_fround(HEAPF32[i58 >> 2])) + Math_fround(f67 * Math_fround(HEAPF32[i29 >> 2]))) + Math_fround(f70 * Math_fround(HEAPF32[i32 >> 2])));
     f69 = Math_fround(Math_fround(Math_fround(f66 * Math_fround(HEAPF32[i27 >> 2])) + Math_fround(f67 * Math_fround(HEAPF32[i30 >> 2]))) + Math_fround(f70 * Math_fround(HEAPF32[i33 >> 2])));
     f70 = Math_fround(Math_fround(Math_fround(f66 * Math_fround(HEAPF32[i28 >> 2])) + Math_fround(f67 * Math_fround(HEAPF32[i31 >> 2]))) + Math_fround(f70 * Math_fround(HEAPF32[i34 >> 2])));
     HEAPF32[i25 >> 2] = f68;
     HEAPF32[i3 >> 2] = f69;
     HEAPF32[i4 >> 2] = f70;
     HEAPF32[i5 >> 2] = Math_fround(0.0);
     i1 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i54, i48, i25) | 0;
     __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE(i55, i54, i71, (HEAP32[i20 >> 2] | 0) + (i1 * 20 | 0) | 0, i49, i48, i58, i47, i53, i45);
     break L13;
    }
   default:
    {
     i59 = 13;
     break L13;
    }
   }
   i71 = (HEAP32[i20 >> 2] | 0) + (i11 * 20 | 0) | 0;
   f69 = Math_fround(HEAPF32[i50 >> 2]);
   f70 = Math_fround(HEAPF32[i15 >> 2]);
   f9 = Math_fround(HEAPF32[i16 >> 2]);
   f7 = Math_fround(f69 * Math_fround(HEAPF32[i57 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f70 * Math_fround(HEAPF32[i38 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i41 >> 2])));
   f8 = Math_fround(f69 * Math_fround(HEAPF32[i36 >> 2]));
   f8 = Math_fround(f8 + Math_fround(f70 * Math_fround(HEAPF32[i39 >> 2])));
   f8 = Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[i42 >> 2])));
   f69 = Math_fround(f69 * Math_fround(HEAPF32[i37 >> 2]));
   f70 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i40 >> 2])));
   f9 = Math_fround(f70 + Math_fround(f9 * Math_fround(HEAPF32[i43 >> 2])));
   HEAPF32[i52 >> 2] = f7;
   HEAPF32[i12 >> 2] = f8;
   HEAPF32[i13 >> 2] = f9;
   HEAPF32[i14 >> 2] = Math_fround(0.0);
   i1 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i55, i49, i52) | 0;
   __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE(i54, i55, i71, (HEAP32[i24 >> 2] | 0) + (i1 * 20 | 0) | 0, i48, i49, i57, i47, i53, i45);
   i1 = HEAP32[i53 >> 2] | 0;
   if ((i1 | 0) != (i44 | 0)) {
    f10 = Math_fround(-f7);
    f8 = Math_fround(-f8);
    f7 = Math_fround(-f9);
    if (i44 >>> 0 < i1 >>> 0) {
     i1 = i44;
     do {
      i71 = i47 + (i1 * 48 | 0) | 0;
      i72 = i47 + (i1 * 48 | 0) + 16 | 0;
      HEAP32[i46 >> 2] = HEAP32[i72 >> 2];
      HEAP32[i46 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
      HEAP32[i46 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
      HEAP32[i46 + 12 >> 2] = HEAP32[i72 + 12 >> 2];
      HEAP32[i72 >> 2] = HEAP32[i71 >> 2];
      HEAP32[i72 + 4 >> 2] = HEAP32[i71 + 4 >> 2];
      HEAP32[i72 + 8 >> 2] = HEAP32[i71 + 8 >> 2];
      HEAP32[i72 + 12 >> 2] = HEAP32[i71 + 12 >> 2];
      HEAP32[i71 >> 2] = HEAP32[i46 >> 2];
      HEAP32[i71 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
      HEAP32[i71 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
      HEAP32[i71 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
      HEAPF32[i47 + (i1 * 48 | 0) + 32 >> 2] = f10;
      HEAPF32[i47 + (i1 * 48 | 0) + 36 >> 2] = f8;
      HEAPF32[i47 + (i1 * 48 | 0) + 40 >> 2] = f7;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i53 >> 2] | 0) >>> 0);
    }
   }
  } while (0);
  if ((i59 | 0) == 13) {
   i59 = 0;
   f66 = Math_fround(HEAPF32[i50 >> 2]);
   f67 = Math_fround(HEAPF32[i15 >> 2]);
   f70 = Math_fround(HEAPF32[i16 >> 2]);
   f69 = Math_fround(-f67);
   f68 = Math_fround(-f70);
   HEAPF32[i26 >> 2] = Math_fround(-f66);
   HEAPF32[i17 >> 2] = f69;
   HEAPF32[i18 >> 2] = f68;
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   i72 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i54, i48, i26) | 0;
   i72 = (HEAP32[i20 >> 2] | 0) + (i72 * 20 | 0) | 0;
   f68 = Math_fround(f66 * Math_fround(HEAPF32[i57 >> 2]));
   f68 = Math_fround(f68 + Math_fround(f67 * Math_fround(HEAPF32[i38 >> 2])));
   f68 = Math_fround(f68 + Math_fround(f70 * Math_fround(HEAPF32[i41 >> 2])));
   f69 = Math_fround(f66 * Math_fround(HEAPF32[i36 >> 2]));
   f69 = Math_fround(f69 + Math_fround(f67 * Math_fround(HEAPF32[i39 >> 2])));
   f69 = Math_fround(f69 + Math_fround(f70 * Math_fround(HEAPF32[i42 >> 2])));
   f66 = Math_fround(f66 * Math_fround(HEAPF32[i37 >> 2]));
   f67 = Math_fround(f66 + Math_fround(f67 * Math_fround(HEAPF32[i40 >> 2])));
   f70 = Math_fround(f67 + Math_fround(f70 * Math_fround(HEAPF32[i43 >> 2])));
   HEAPF32[i35 >> 2] = f68;
   HEAPF32[i21 >> 2] = f69;
   HEAPF32[i22 >> 2] = f70;
   HEAPF32[i23 >> 2] = Math_fround(0.0);
   i71 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i55, i49, i35) | 0;
   __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE(i55, i54, (HEAP32[i24 >> 2] | 0) + (i71 * 20 | 0) | 0, i72, i49, i48, i58, i47, i53, i45);
  }
  if (i6 | (HEAP32[i53 >> 2] | 0) != (i44 | 0)) {
   i1 = 1;
   i59 = 16;
   break;
  } else i6 = 1;
 }
 if ((i59 | 0) == 16) {
  STACKTOP = i60;
  return i1 | 0;
 }
 return 0;
}

function __Z32tri_tri_intersect_with_isectlinePfS_S_S_S_S_PiS_S_(i31, i30, i44, i33, i38, i41, i1, i39, i40) {
 i31 = i31 | 0;
 i30 = i30 | 0;
 i44 = i44 | 0;
 i33 = i33 | 0;
 i38 = i38 | 0;
 i41 = i41 | 0;
 i1 = i1 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f42 = f0, f43 = f0, i45 = 0, i46 = 0, f47 = f0, i48 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i46 + 56 | 0;
 i32 = i46;
 i34 = i46 + 44 | 0;
 i35 = i46 + 32 | 0;
 i36 = i46 + 20 | 0;
 i37 = i46 + 8 | 0;
 i5 = i32;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 4 >> 2] = 0;
 HEAP32[i36 + 8 >> 2] = 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 f10 = Math_fround(HEAPF32[i30 >> 2]);
 f11 = Math_fround(HEAPF32[i31 >> 2]);
 f25 = Math_fround(f10 - f11);
 f12 = Math_fround(HEAPF32[i30 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i31 + 4 >> 2]);
 f27 = Math_fround(f12 - f13);
 f14 = Math_fround(HEAPF32[i30 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i31 + 8 >> 2]);
 f20 = Math_fround(f14 - f15);
 f16 = Math_fround(HEAPF32[i44 >> 2]);
 f24 = Math_fround(f16 - f11);
 f17 = Math_fround(HEAPF32[i44 + 4 >> 2]);
 f19 = Math_fround(f17 - f13);
 f18 = Math_fround(HEAPF32[i44 + 8 >> 2]);
 f23 = Math_fround(f18 - f15);
 f22 = Math_fround(Math_fround(f27 * f23) - Math_fround(f20 * f19));
 f23 = Math_fround(Math_fround(f20 * f24) - Math_fround(f25 * f23));
 f24 = Math_fround(Math_fround(f25 * f19) - Math_fround(f27 * f24));
 f27 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f11 * f22) + Math_fround(f13 * f23)));
 f19 = Math_fround(HEAPF32[i33 >> 2]);
 f25 = Math_fround(f19 * f22);
 f20 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f20 * f23));
 f21 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f24 * f21) + f25) - f27);
 f2 = Math_fround(HEAPF32[i38 >> 2]);
 f26 = Math_fround(f22 * f2);
 f3 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f23 * f3));
 f4 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f26 = Math_fround(Math_fround(f26 + Math_fround(f24 * f4)) - f27);
 f6 = Math_fround(HEAPF32[i41 >> 2]);
 f28 = Math_fround(f22 * f6);
 f8 = Math_fround(HEAPF32[i41 + 4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f23 * f8));
 f9 = Math_fround(HEAPF32[i41 + 8 >> 2]);
 f27 = Math_fround(Math_fround(f28 + Math_fround(f24 * f9)) - f27);
 i5 = +Math_fround(Math_abs(Math_fround(f25))) < 1.0e-06;
 f25 = i5 ? Math_fround(0.0) : f25;
 i5 = +Math_fround(Math_abs(Math_fround(f26))) < 1.0e-06;
 f26 = i5 ? Math_fround(0.0) : f26;
 i5 = +Math_fround(Math_abs(Math_fround(f27))) < 1.0e-06;
 f27 = i5 ? Math_fround(0.0) : f27;
 f28 = Math_fround(f25 * f26);
 f29 = Math_fround(f25 * f27);
 if (f28 > Math_fround(0.0) & f29 > Math_fround(0.0)) {
  i45 = 0;
  STACKTOP = i46;
  return i45 | 0;
 }
 f42 = Math_fround(f2 - f19);
 f43 = Math_fround(f3 - f20);
 f47 = Math_fround(f4 - f21);
 f4 = Math_fround(f6 - f19);
 f6 = Math_fround(f8 - f20);
 f3 = Math_fround(f9 - f21);
 f2 = Math_fround(Math_fround(f43 * f3) - Math_fround(f47 * f6));
 f3 = Math_fround(Math_fround(f47 * f4) - Math_fround(f42 * f3));
 f4 = Math_fround(Math_fround(f42 * f6) - Math_fround(f43 * f4));
 f9 = Math_fround(Math_fround(f21 * f4) + Math_fround(Math_fround(f19 * f2) + Math_fround(f20 * f3)));
 f6 = Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(Math_fround(f11 * f2) + Math_fround(f13 * f3))) - f9);
 f8 = Math_fround(Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f10 * f2) + Math_fround(f12 * f3))) - f9);
 f9 = Math_fround(Math_fround(Math_fround(f18 * f4) + Math_fround(Math_fround(f16 * f2) + Math_fround(f17 * f3))) - f9);
 i5 = +Math_fround(Math_abs(Math_fround(f6))) < 1.0e-06;
 f6 = i5 ? Math_fround(0.0) : f6;
 i5 = +Math_fround(Math_abs(Math_fround(f8))) < 1.0e-06;
 f8 = i5 ? Math_fround(0.0) : f8;
 i5 = +Math_fround(Math_abs(Math_fround(f9))) < 1.0e-06;
 f9 = i5 ? Math_fround(0.0) : f9;
 f10 = Math_fround(f6 * f8);
 f11 = Math_fround(f6 * f9);
 if (f10 > Math_fround(0.0) & f11 > Math_fround(0.0)) {
  i45 = 0;
  STACKTOP = i46;
  return i45 | 0;
 }
 f42 = Math_fround(Math_abs(Math_fround(Math_fround(f23 * f4) - Math_fround(f24 * f3))));
 f43 = Math_fround(Math_abs(Math_fround(Math_fround(f24 * f2) - Math_fround(f22 * f4))));
 f47 = Math_fround(Math_abs(Math_fround(Math_fround(f22 * f3) - Math_fround(f23 * f2))));
 i5 = f43 > f42;
 i5 = f47 > (i5 ? f43 : f42) ? 2 : i5 & 1;
 f42 = Math_fround(HEAPF32[i31 + (i5 << 2) >> 2]);
 f43 = Math_fround(HEAPF32[i30 + (i5 << 2) >> 2]);
 f47 = Math_fround(HEAPF32[i44 + (i5 << 2) >> 2]);
 f2 = Math_fround(HEAPF32[i33 + (i5 << 2) >> 2]);
 f3 = Math_fround(HEAPF32[i38 + (i5 << 2) >> 2]);
 f4 = Math_fround(HEAPF32[i41 + (i5 << 2) >> 2]);
 i5 = i7 + 4 | 0;
 i48 = __Z27compute_intervals_isectlinePfS_S_ffffffffS_S_S_S_(i31, i30, i44, f42, f43, f47, f6, f8, f9, f10, f11, i7, i5, i34, i35) | 0;
 HEAP32[i1 >> 2] = i48;
 if (!i48) {
  i1 = i32 + 4 | 0;
  __Z27compute_intervals_isectlinePfS_S_ffffffffS_S_S_S_(i33, i38, i41, f2, f3, f4, f25, f26, f27, f28, f29, i32, i1, i36, i37) | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  if (f2 > f3) {
   HEAPF32[i7 >> 2] = f3;
   HEAPF32[i5 >> 2] = f2;
   i7 = 1;
   f8 = f2;
   f2 = f3;
  } else {
   i7 = 0;
   f8 = f3;
  }
  f4 = Math_fround(HEAPF32[i32 >> 2]);
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  if (f4 > f6) {
   HEAPF32[i32 >> 2] = f6;
   HEAPF32[i1 >> 2] = f4;
   i5 = 1;
   f3 = f6;
  } else {
   i5 = 0;
   f3 = f4;
   f4 = f6;
  }
  if (f8 < f3 | f4 < f2) {
   i48 = 0;
   STACKTOP = i46;
   return i48 | 0;
  }
  if (f3 < f2) {
   i1 = (i7 | 0) == 0;
   if (i1) {
    HEAP32[i39 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
    HEAP32[i39 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   } else {
    HEAP32[i39 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i39 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   }
   if (f4 < f8) if (!i5) {
    HEAP32[i40 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else {
    HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else if (i1) {
    HEAP32[i40 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else {
    HEAP32[i40 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   }
  } else {
   i1 = (i5 | 0) == 0;
   if (i1) {
    HEAP32[i39 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i39 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   } else {
    HEAP32[i39 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i39 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   }
   if (f4 > f8) if (!i7) {
    HEAP32[i40 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else {
    HEAP32[i40 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else if (i1) {
    HEAP32[i40 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   } else {
    HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    i48 = 1;
    STACKTOP = i46;
    return i48 | 0;
   }
  }
 }
 f28 = Math_fround(Math_abs(Math_fround(f22)));
 f43 = Math_fround(Math_abs(Math_fround(f23)));
 f27 = Math_fround(Math_abs(Math_fround(f24)));
 i1 = f28 > f43;
 i5 = f28 > f27;
 i7 = i1 ? (i5 ? 2 : 1) : f27 > f43 ? 1 : 2;
 i5 = i1 ? i5 & 1 : 0;
 f43 = Math_fround(HEAPF32[i30 + (i5 << 2) >> 2]);
 f27 = Math_fround(HEAPF32[i31 + (i5 << 2) >> 2]);
 f28 = Math_fround(f43 - f27);
 f42 = Math_fround(HEAPF32[i30 + (i7 << 2) >> 2]);
 f23 = Math_fround(HEAPF32[i31 + (i7 << 2) >> 2]);
 f24 = Math_fround(f42 - f23);
 f29 = Math_fround(HEAPF32[i33 + (i5 << 2) >> 2]);
 f25 = Math_fround(HEAPF32[i38 + (i5 << 2) >> 2]);
 f19 = Math_fround(f29 - f25);
 f26 = Math_fround(HEAPF32[i33 + (i7 << 2) >> 2]);
 f22 = Math_fround(HEAPF32[i38 + (i7 << 2) >> 2]);
 f16 = Math_fround(f26 - f22);
 f2 = Math_fround(f27 - f29);
 f3 = Math_fround(f23 - f26);
 f6 = Math_fround(Math_fround(f24 * f19) - Math_fround(f28 * f16));
 f4 = Math_fround(Math_fround(f2 * f16) - Math_fround(f19 * f3));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | i1 & f4 >= Math_fround(0.0) ^ 1) {
  if (!(!(f4 >= f6) | (!(f4 <= Math_fround(0.0)) | !(f6 < Math_fround(0.0))))) i45 = 6;
 } else i45 = 6;
 do if ((i45 | 0) == 6) {
  f2 = Math_fround(Math_fround(f28 * f3) - Math_fround(f24 * f2));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f21 = Math_fround(HEAPF32[i41 + (i5 << 2) >> 2]);
 f17 = Math_fround(f25 - f21);
 f20 = Math_fround(HEAPF32[i41 + (i7 << 2) >> 2]);
 f12 = Math_fround(f22 - f20);
 f2 = Math_fround(f27 - f25);
 f3 = Math_fround(f23 - f22);
 f6 = Math_fround(Math_fround(f24 * f17) - Math_fround(f28 * f12));
 f4 = Math_fround(Math_fround(f2 * f12) - Math_fround(f3 * f17));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | i1 & f4 >= Math_fround(0.0) ^ 1) {
  if (!(!(f4 >= f6) | (!(f6 < Math_fround(0.0)) | !(f4 <= Math_fround(0.0))))) i45 = 11;
 } else i45 = 11;
 do if ((i45 | 0) == 11) {
  f2 = Math_fround(Math_fround(f28 * f3) - Math_fround(f24 * f2));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f13 = Math_fround(f21 - f29);
 f14 = Math_fround(f20 - f26);
 f2 = Math_fround(f27 - f21);
 f3 = Math_fround(f23 - f20);
 f6 = Math_fround(Math_fround(f24 * f13) - Math_fround(f28 * f14));
 f4 = Math_fround(Math_fround(f2 * f14) - Math_fround(f13 * f3));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | i1 & f4 >= Math_fround(0.0) ^ 1) {
  if (!(!(f4 >= f6) | (!(f6 < Math_fround(0.0)) | !(f4 <= Math_fround(0.0))))) i45 = 16;
 } else i45 = 16;
 do if ((i45 | 0) == 16) {
  f2 = Math_fround(Math_fround(f28 * f3) - Math_fround(f24 * f2));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f18 = Math_fround(HEAPF32[i44 + (i5 << 2) >> 2]);
 f15 = Math_fround(f18 - f43);
 f10 = Math_fround(HEAPF32[i44 + (i7 << 2) >> 2]);
 f11 = Math_fround(f10 - f42);
 f2 = Math_fround(f43 - f29);
 f3 = Math_fround(f42 - f26);
 f6 = Math_fround(Math_fround(f19 * f11) - Math_fround(f16 * f15));
 f4 = Math_fround(Math_fround(f2 * f16) - Math_fround(f19 * f3));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | f4 >= Math_fround(0.0) & i1 ^ 1) {
  if (!(!(f4 >= f6) | (!(f4 <= Math_fround(0.0)) | !(f6 < Math_fround(0.0))))) i45 = 21;
 } else i45 = 21;
 do if ((i45 | 0) == 21) {
  f2 = Math_fround(Math_fround(f3 * f15) - Math_fround(f2 * f11));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f2 = Math_fround(f43 - f25);
 f3 = Math_fround(f42 - f22);
 f6 = Math_fround(Math_fround(f17 * f11) - Math_fround(f12 * f15));
 f4 = Math_fround(Math_fround(f2 * f12) - Math_fround(f3 * f17));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | f4 >= Math_fround(0.0) & i1 ^ 1) {
  if (!(!(f4 >= f6) | (!(f4 <= Math_fround(0.0)) | !(f6 < Math_fround(0.0))))) i45 = 26;
 } else i45 = 26;
 do if ((i45 | 0) == 26) {
  f2 = Math_fround(Math_fround(f3 * f15) - Math_fround(f2 * f11));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f2 = Math_fround(f43 - f21);
 f3 = Math_fround(f42 - f20);
 f6 = Math_fround(Math_fround(f13 * f11) - Math_fround(f14 * f15));
 f4 = Math_fround(Math_fround(f2 * f14) - Math_fround(f13 * f3));
 i1 = f6 > Math_fround(0.0);
 if (!(f4 <= f6) | f4 >= Math_fround(0.0) & i1 ^ 1) {
  if (!(!(f4 >= f6) | (!(f4 <= Math_fround(0.0)) | !(f6 < Math_fround(0.0))))) i45 = 31;
 } else i45 = 31;
 do if ((i45 | 0) == 31) {
  f2 = Math_fround(Math_fround(f3 * f15) - Math_fround(f2 * f11));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f8 = Math_fround(f27 - f18);
 f9 = Math_fround(f23 - f10);
 f3 = Math_fround(f18 - f29);
 f4 = Math_fround(f10 - f26);
 f6 = Math_fround(Math_fround(f19 * f9) - Math_fround(f16 * f8));
 f2 = Math_fround(Math_fround(f16 * f3) - Math_fround(f19 * f4));
 i1 = f6 > Math_fround(0.0);
 if (!(f2 <= f6) | i1 & f2 >= Math_fround(0.0) ^ 1) {
  if (!(!(f2 >= f6) | (!(f2 <= Math_fround(0.0)) | !(f6 < Math_fround(0.0))))) i45 = 36;
 } else i45 = 36;
 do if ((i45 | 0) == 36) {
  f2 = Math_fround(Math_fround(f8 * f4) - Math_fround(f3 * f9));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f3 = Math_fround(f18 - f25);
 f4 = Math_fround(f10 - f22);
 f6 = Math_fround(Math_fround(f17 * f9) - Math_fround(f12 * f8));
 f2 = Math_fround(Math_fround(f12 * f3) - Math_fround(f17 * f4));
 i1 = f6 > Math_fround(0.0);
 if (!(f2 <= f6) | i1 & f2 >= Math_fround(0.0) ^ 1) {
  if (!(!(f2 >= f6) | (!(f6 < Math_fround(0.0)) | !(f2 <= Math_fround(0.0))))) i45 = 41;
 } else i45 = 41;
 do if ((i45 | 0) == 41) {
  f2 = Math_fround(Math_fround(f8 * f4) - Math_fround(f3 * f9));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f3 = Math_fround(f18 - f21);
 f4 = Math_fround(f10 - f20);
 f6 = Math_fround(Math_fround(f13 * f9) - Math_fround(f14 * f8));
 f2 = Math_fround(Math_fround(f14 * f3) - Math_fround(f13 * f4));
 i1 = f6 > Math_fround(0.0);
 if (!(f2 <= f6) | i1 & f2 >= Math_fround(0.0) ^ 1) {
  if (!(!(f2 >= f6) | (!(f6 < Math_fround(0.0)) | !(f2 <= Math_fround(0.0))))) i45 = 46;
 } else i45 = 46;
 do if ((i45 | 0) == 46) {
  f2 = Math_fround(Math_fround(f8 * f4) - Math_fround(f3 * f9));
  if (i1) {
   if (!(f2 >= Math_fround(0.0)) | !(f2 <= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  } else {
   if (!(f2 <= Math_fround(0.0)) | !(f2 >= f6)) break; else i1 = 1;
   STACKTOP = i46;
   return i1 | 0;
  }
 } while (0);
 f2 = Math_fround(f22 - f26);
 f19 = Math_fround(-Math_fround(f25 - f29));
 f2 = Math_fround(Math_fround(Math_fround(-Math_fround(f29 * f2)) - Math_fround(f26 * f19)) + Math_fround(Math_fround(f23 * f19) + Math_fround(f27 * f2)));
 f19 = Math_fround(f20 - f22);
 f47 = Math_fround(-Math_fround(f21 - f25));
 f3 = Math_fround(f26 - f20);
 f4 = Math_fround(-Math_fround(f29 - f21));
 if (Math_fround(f2 * Math_fround(Math_fround(Math_fround(f23 * f47) + Math_fround(f27 * f19)) + Math_fround(Math_fround(-Math_fround(f25 * f19)) - Math_fround(f22 * f47)))) > Math_fround(0.0)) if (Math_fround(f2 * Math_fround(Math_fround(Math_fround(f23 * f4) + Math_fround(f27 * f3)) + Math_fround(Math_fround(-Math_fround(f21 * f3)) - Math_fround(f20 * f4)))) > Math_fround(0.0)) {
  i48 = 1;
  STACKTOP = i46;
  return i48 | 0;
 }
 f3 = Math_fround(-f28);
 f3 = Math_fround(Math_fround(Math_fround(-Math_fround(f27 * f24)) - Math_fround(f23 * f3)) + Math_fround(Math_fround(f24 * f29) + Math_fround(f26 * f3)));
 f47 = Math_fround(-f15);
 f2 = Math_fround(-f8);
 if (Math_fround(f3 * Math_fround(Math_fround(Math_fround(f26 * f47) + Math_fround(f29 * f11)) + Math_fround(Math_fround(-Math_fround(f43 * f11)) - Math_fround(f42 * f47)))) > Math_fround(0.0)) if (Math_fround(f3 * Math_fround(Math_fround(Math_fround(f26 * f2) + Math_fround(f29 * f9)) + Math_fround(Math_fround(-Math_fround(f18 * f9)) - Math_fround(f10 * f2)))) > Math_fround(0.0)) {
  i48 = 1;
  STACKTOP = i46;
  return i48 | 0;
 }
 i48 = 0;
 STACKTOP = i46;
 return i48 | 0;
}

function __Z17UpdateSteeringJobP9CrowdInfoj(i33, i30) {
 i33 = i33 | 0;
 i30 = i30 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, f31 = f0, f32 = f0, f34 = f0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, i39 = 0, f40 = f0, f41 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i39;
 i26 = i39 + 32 | 0;
 i38 = i33 + (i30 << 4) | 0;
 i23 = HEAP32[i33 + 256 + (i30 << 2) >> 2] | 0;
 if ((HEAP16[gb + 1459320 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459320 | 0, i25);
  i19 = gb + 1459320 | 0;
 } else i19 = 0;
 i29 = i33 + (i30 << 4) + 12 | 0;
 i24 = HEAP32[i29 >> 2] | 0;
 if ((i24 | 0) > 0) {
  i20 = i33 + (i30 << 4) + 8 | 0;
  i21 = i33 + 332 | 0;
  i22 = i25 + 12 | 0;
  i18 = 0;
  do {
   i9 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i18 << 2) >> 2] | 0;
   i10 = HEAP32[i38 >> 2] | 0;
   L8 : do if ((HEAP8[i10 + (i9 * 608 | 0) + 601 >> 0] | 0) == 1) {
    i15 = (HEAP32[i21 >> 2] | 0) + (i9 * 132 | 0) | 0;
    i16 = i10 + (i9 * 608 | 0) | 0;
    i12 = i10 + (i9 * 608 | 0) + 424 | 0;
    i14 = i10 + (i9 * 608 | 0) + 392 | 0;
    i7 = i10 + (i9 * 608 | 0) + 476 | 0;
    i6 = __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i16, i12, i10 + (i9 * 608 | 0) + 472 | 0, i14, i7, 4, i23) | 0;
    i2 = i10 + (i9 * 608 | 0) + 480 | 0;
    i7 = HEAP32[i7 >> 2] | 0;
    if (!i7) {
     if ((HEAP32[i10 + (i9 * 608 | 0) + 32 >> 2] | 0) == 1) {
      f34 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 12 >> 2]);
      f34 = Math_fround(f34 - Math_fround(HEAPF32[i2 >> 2]));
      f37 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 16 >> 2]);
      f37 = Math_fround(f37 - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 484 >> 2]));
      f1 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 20 >> 2]);
      f1 = Math_fround(f1 - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 488 >> 2]));
      f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f37 * f37)) + Math_fround(f1 * f1))));
     } else f1 = Math_fround(inf);
     HEAPF32[i10 + (i9 * 608 | 0) + 552 >> 2] = f1;
     break;
    }
    if (!(HEAP8[i7 + -1 + (i10 + (i9 * 608 | 0) + 472) >> 0] & 2)) f1 = Math_fround(inf); else if ((i7 | 0) > 0) {
     f3 = Math_fround(HEAPF32[i2 >> 2]);
     f4 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 484 >> 2]);
     f1 = Math_fround(0.0);
     i2 = 0;
     f5 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 488 >> 2]);
     do {
      i36 = i10 + (i9 * 608 | 0) + 424 + (i2 * 3 << 2) | 0;
      f32 = f3;
      f3 = Math_fround(HEAPF32[i36 >> 2]);
      f32 = Math_fround(f32 - f3);
      f34 = f4;
      f4 = Math_fround(HEAPF32[i36 + 4 >> 2]);
      f34 = Math_fround(f34 - f4);
      f37 = f5;
      f5 = Math_fround(HEAPF32[i36 + 8 >> 2]);
      f37 = Math_fround(f37 - f5);
      f1 = Math_fround(f1 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f34 * f34)) + Math_fround(f37 * f37)))));
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i7 | 0));
    } else f1 = Math_fround(0.0);
    HEAPF32[i10 + (i9 * 608 | 0) + 552 >> 2] = f1;
    L22 : do switch (i7 | 0) {
    case 0:
     break L8;
    case 1:
     if (!(i6 & 64)) {
      f34 = Math_fround(HEAPF32[i16 >> 2]);
      f34 = Math_fround(f34 - Math_fround(HEAPF32[i12 >> 2]));
      f37 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 8 >> 2]);
      f37 = Math_fround(f37 - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 432 >> 2]));
      if (Math_fround(Math_fround(f34 * f34) + Math_fround(f37 * f37)) < Math_fround(.0000999999974)) break L8; else {
       i2 = i12;
       break L22;
      }
     } else {
      i36 = i10 + (i9 * 608 | 0) + 44 | 0;
      HEAP8[i36 >> 0] = HEAPU8[i36 >> 0] & 254;
      break L8;
     }
    default:
     {
      i2 = i10 + (i9 * 608 | 0) + 436 | 0;
      f34 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - Math_fround(HEAPF32[i2 >> 2]));
      f37 = Math_fround(Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 8 >> 2]) - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 444 >> 2]));
      if (Math_fround(Math_fround(f34 * f34) + Math_fround(f37 * f37)) < Math_fround(.0000999999974)) break L8;
      if (!(HEAP32[i10 + (i9 * 608 | 0) + 32 >> 2] | 0)) {
       i6 = 0;
       i7 = 0;
      } else {
       i7 = HEAP32[i10 + (i9 * 608 | 0) + 28 >> 2] | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
      }
      __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i23, i6, i7, i16, i2, i15, i25, 0, 0, 0) | 0;
      f1 = Math_fround(HEAPF32[i22 >> 2]);
      if (!(f1 < Math_fround(1.0))) {
       __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i23, i6, i7, i16, i12, i15, i25, 0, 0, 0) | 0;
       f37 = Math_fround(HEAPF32[i22 >> 2]);
       i36 = i14;
       __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i23, HEAP32[i36 >> 2] | 0, HEAP32[i36 + 4 >> 2] | 0, i12, i2, i15, i25, 0, 0, 0) | 0;
       if (!(f1 >= Math_fround(f37 + Math_fround(HEAPF32[i22 >> 2])))) break L22;
      }
      break L8;
     }
    } while (0);
    __ZN14dtPathCorridor28optimizePathVisibilitySimpleEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i16, i2, i23, i15);
   } while (0);
   i18 = i18 + 1 | 0;
  } while ((i18 | 0) != (i24 | 0));
 }
 if (i19 | 0) __Z12profiler_endP19ProfilerInformation(i19);
 f37 = Math_fround(HEAPF32[i33 + 368 >> 2]);
 if ((HEAP16[gb + 1459404 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459404 | 0, i25);
  i36 = gb + 1459404 | 0;
 } else i36 = 0;
 i35 = HEAP32[i29 >> 2] | 0;
 if ((i35 | 0) > 0) {
  i25 = i33 + (i30 << 4) + 8 | 0;
  i26 = i33 + 352 | 0;
  i29 = i33 + 344 | 0;
  i22 = i33 + 336 | 0;
  i21 = 0;
  do {
   i23 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i21 << 2) >> 2] | 0;
   i24 = HEAP32[i38 >> 2] | 0;
   i18 = i24 + (i23 * 608 | 0) | 0;
   i19 = i24 + (i23 * 608 | 0) + 602 | 0;
   i20 = HEAP8[i19 >> 0] | 0;
   HEAP8[i19 >> 0] = i20 & -3;
   if ((HEAP8[i24 + (i23 * 608 | 0) + 601 >> 0] | 0) == 1) {
    i15 = HEAP32[i24 + (i23 * 608 | 0) + 476 >> 2] | 0;
    i16 = (i15 | 0) == 0;
    if (i16) if ((HEAP32[i24 + (i23 * 608 | 0) + 32 >> 2] | 0) > 0) {
     f1 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 12 >> 2]);
     f1 = Math_fround(f1 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
     f4 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 20 >> 2]);
     f4 = Math_fround(f4 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
     f3 = Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(0.0)) + Math_fround(f4 * f4));
     if (f3 == Math_fround(0.0)) i14 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0); else {
      f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
      f32 = Math_fround(f1 * f34);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
      f34 = Math_fround(f4 * f34);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
     }
    } else {
     i2 = 0;
     i14 = 0;
    } else {
     f1 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 424 >> 2]);
     f1 = Math_fround(f1 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
     f4 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 432 >> 2]);
     f4 = Math_fround(f4 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
     f3 = Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(0.0)) + Math_fround(f4 * f4));
     if (f3 == Math_fround(0.0)) i14 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0); else {
      f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
      f32 = Math_fround(f1 * f34);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
      f34 = Math_fround(f4 * f34);
      i14 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
     }
    }
    if (!(i20 & 8)) {
     i33 = HEAP32[i24 + (i23 * 608 | 0) + 304 >> 2] | 0;
     HEAP32[i24 + (i23 * 608 | 0) + 560 >> 2] = i33;
     f1 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    } else {
     HEAPF32[i24 + (i23 * 608 | 0) + 560 >> 2] = Math_fround(0.0);
     f1 = Math_fround(0.0);
    }
    f34 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 552 >> 2]);
    do if (f34 < Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 308 >> 2])) {
     if ((i15 | 0) <= 0) if ((HEAP32[i24 + (i23 * 608 | 0) + 32 >> 2] | 0) <= 1) break;
     HEAPF32[i24 + (i23 * 608 | 0) + 560 >> 2] = Math_fround(0.0);
     f1 = Math_fround(0.0);
    } while (0);
    f17 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 292 >> 2]);
    L68 : do if (!(HEAP8[i24 + (i23 * 608 | 0) + 317 >> 0] & 4)) f34 = f1; else {
     f13 = Math_fround(f17 * Math_fround(2.0));
     if (i16) {
      f34 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 12 >> 2]);
      f34 = Math_fround(f34 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
      f4 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 20 >> 2]);
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
      f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(f4 * f4))));
      f4 = f4 < f13 ? f4 : f13;
     } else {
      i6 = i15 + -1 | 0;
      if (!(HEAP8[i24 + (i23 * 608 | 0) + 472 + i6 >> 0] & 2)) f4 = f13; else {
       i33 = i24 + (i23 * 608 | 0) + 424 + (i6 * 3 << 2) | 0;
       f34 = Math_fround(HEAPF32[i33 >> 2]);
       f34 = Math_fround(f34 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
       f4 = Math_fround(HEAPF32[i33 + 8 >> 2]);
       f4 = Math_fround(f4 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
       f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(f4 * f4))));
       f4 = f4 < f13 ? f4 : f13;
      }
     }
     i7 = i24 + (i23 * 608 | 0) + 516 | 0;
     f5 = Math_fround(HEAPF32[i7 >> 2]);
     f5 = Math_fround(f5 * f5);
     i9 = i24 + (i23 * 608 | 0) + 520 | 0;
     f8 = Math_fround(HEAPF32[i9 >> 2]);
     f8 = Math_fround(f5 + Math_fround(f8 * f8));
     i10 = i24 + (i23 * 608 | 0) + 524 | 0;
     f5 = Math_fround(HEAPF32[i10 >> 2]);
     f5 = Math_fround(f8 + Math_fround(f5 * f5));
     f8 = Math_fround(Math_sqrt(Math_fround(f5)));
     f11 = Math_fround(f37 * f8);
     i12 = f4 < f13;
     L75 : do if (!(i12 & f4 < Math_fround(f11 + Math_fround(.0000999999974)))) {
      do if (f13 < f11) {
       if (i16) {
        f34 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 12 >> 2]);
        f34 = Math_fround(f34 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
        f3 = Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 20 >> 2]);
        f3 = Math_fround(f3 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
        f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(f3 * f3))));
        f3 = f3 < f11 ? f3 : f11;
       } else {
        i6 = i15 + -1 | 0;
        if (!(HEAP8[i24 + (i23 * 608 | 0) + 472 + i6 >> 0] & 2)) break;
        i33 = i24 + (i23 * 608 | 0) + 424 + (i6 * 3 << 2) | 0;
        f34 = Math_fround(HEAPF32[i33 >> 2]);
        f34 = Math_fround(f34 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 480 >> 2]));
        f3 = Math_fround(HEAPF32[i33 + 8 >> 2]);
        f3 = Math_fround(f3 - Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 488 >> 2]));
        f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f34 * f34) + Math_fround(f3 * f3))));
        f3 = f3 < f11 ? f3 : f11;
       }
       if (f3 < f11) break L75;
      } while (0);
      if (!i12) {
       f34 = f1;
       break L68;
      }
      if (!(Math_fround(f4 * Math_fround(HEAPF32[i24 + (i23 * 608 | 0) + 304 >> 2])) < Math_fround(f13 * f8))) {
       f34 = f1;
       break L68;
      }
      f34 = Math_fround(f8 - Math_fround(Math_fround(f37 * f5) / Math_fround(f4 * Math_fround(2.0))));
      HEAPF32[i24 + (i23 * 608 | 0) + 560 >> 2] = f34;
      HEAPF32[i24 + (i23 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAPF32[i24 + (i23 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAPF32[i24 + (i23 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAP32[i24 + (i23 * 608 | 0) + 288 >> 2] = 0;
      HEAP8[i19 >> 0] = i20 | 2;
      break L68;
     } while (0);
     HEAPF32[i24 + (i23 * 608 | 0) + 560 >> 2] = Math_fround(0.0);
     i20 = HEAP32[i24 + (i23 * 608 | 0) + 12 >> 2] | 0;
     HEAP32[i18 >> 2] = i20;
     i30 = HEAP32[i24 + (i23 * 608 | 0) + 16 >> 2] | 0;
     HEAP32[i24 + (i23 * 608 | 0) + 4 >> 2] = i30;
     i33 = HEAP32[i24 + (i23 * 608 | 0) + 20 >> 2] | 0;
     HEAP32[i24 + (i23 * 608 | 0) + 8 >> 2] = i33;
     i18 = i24 + (i23 * 608 | 0) + 32 | 0;
     i16 = HEAP32[i24 + (i23 * 608 | 0) + 28 >> 2] | 0;
     i12 = i16 + ((HEAP32[i18 >> 2] | 0) + -1 << 3) | 0;
     i15 = HEAP32[i12 + 4 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     HEAP32[i18 >> 2] = 1;
     HEAP32[i24 + (i23 * 608 | 0) + 480 >> 2] = i20;
     HEAP32[i24 + (i23 * 608 | 0) + 484 >> 2] = i30;
     HEAP32[i24 + (i23 * 608 | 0) + 488 >> 2] = i33;
     HEAPF32[i7 >> 2] = Math_fround(0.0);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
     HEAPF32[i10 >> 2] = Math_fround(0.0);
     HEAPF32[i24 + (i23 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i24 + (i23 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i24 + (i23 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP32[i24 + (i23 * 608 | 0) + 288 >> 2] = 0;
     HEAP8[i19 >> 0] = HEAP8[i19 >> 0] | 2;
     f34 = Math_fround(0.0);
    } while (0);
    f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f34);
    f3 = Math_fround(f34 * Math_fround(0.0));
    f1 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f34);
    f5 = Math_fround(f17 * Math_fround(2.5));
    f32 = Math_fround(Math_fround(1.0) / f5);
    i9 = HEAP32[i24 + (i23 * 608 | 0) + 384 >> 2] | 0;
    if ((i9 | 0) > 0) {
     i10 = HEAP32[i26 >> 2] | 0;
     i12 = HEAP32[i29 >> 2] | 0;
     i14 = HEAP32[i22 >> 2] | 0;
     i15 = i24 + (i23 * 608 | 0) + 480 | 0;
     i16 = i24 + (i23 * 608 | 0) + 488 | 0;
     f31 = Math_fround(f5 * f5);
     i7 = i24 + (i23 * 608 | 0) + 316 | 0;
     f28 = Math_fround(0.0);
     i6 = 0;
     f5 = Math_fround(0.0);
     f11 = Math_fround(0.0);
     f13 = Math_fround(0.0);
     while (1) {
      i2 = HEAP32[i24 + (i23 * 608 | 0) + 320 + (i6 << 3) >> 2] | 0;
      if ((i2 | 0) < (i10 | 0)) {
       i2 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
       f17 = Math_fround(HEAPF32[i15 >> 2]);
       f17 = Math_fround(f17 - Math_fround(HEAPF32[i14 + (i2 * 608 | 0) + 480 >> 2]));
       f27 = Math_fround(HEAPF32[i16 >> 2]);
       f27 = Math_fround(f27 - Math_fround(HEAPF32[i14 + (i2 * 608 | 0) + 488 >> 2]));
       f8 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(0.0)) + Math_fround(f27 * f27));
       if (f8 < Math_fround(9.99999974e-06) | f8 > f31) f8 = f28; else {
        f40 = Math_fround(Math_sqrt(Math_fround(f8)));
        f41 = Math_fround(f32 * f40);
        f41 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f41 * f41)) * Math_fround(.699999988));
        i30 = HEAP8[i7 >> 0] | 0;
        i33 = HEAP8[i14 + (i2 * 608 | 0) + 316 >> 0] | 0;
        f8 = (i33 & 255) > (i30 & 255) ? Math_fround(2.0) : Math_fround(0.0);
        f40 = Math_fround(Math_fround(f41 * (i30 << 24 >> 24 == i33 << 24 >> 24 ? Math_fround(1.0) : f8)) / f40);
        f8 = Math_fround(f28 + Math_fround(1.0));
        f5 = Math_fround(f5 + Math_fround(f17 * f40));
        f11 = Math_fround(f11 + Math_fround(f40 * Math_fround(0.0)));
        f13 = Math_fround(f13 + Math_fround(f27 * f40));
       }
      } else f8 = f28;
      i6 = i6 + 1 | 0;
      if ((i6 | 0) == (i9 | 0)) break; else f28 = f8;
     }
     if (f8 > Math_fround(.0000999999974)) {
      f41 = Math_fround(Math_fround(1.0) / f8);
      f8 = Math_fround(f4 + Math_fround(f5 * f41));
      f3 = Math_fround(f3 + Math_fround(f11 * f41));
      f1 = Math_fround(f1 + Math_fround(f13 * f41));
      f5 = Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f8 * f8) + Math_fround(f3 * f3)));
      f4 = Math_fround(f34 * f34);
      if (f5 > f4) {
       f41 = Math_fround(f4 / f5);
       f4 = Math_fround(f8 * f41);
       f3 = Math_fround(f3 * f41);
       f1 = Math_fround(f1 * f41);
      } else f4 = f8;
     }
    }
    HEAPF32[i24 + (i23 * 608 | 0) + 504 >> 2] = f4;
    HEAPF32[i24 + (i23 * 608 | 0) + 508 >> 2] = f3;
    HEAPF32[i24 + (i23 * 608 | 0) + 512 >> 2] = f1;
   } else {
    HEAPF32[i24 + (i23 * 608 | 0) + 560 >> 2] = Math_fround(0.0);
    HEAPF32[i24 + (i23 * 608 | 0) + 504 >> 2] = Math_fround(0.0);
    HEAPF32[i24 + (i23 * 608 | 0) + 508 >> 2] = Math_fround(0.0);
    HEAPF32[i24 + (i23 * 608 | 0) + 512 >> 2] = Math_fround(0.0);
   }
   i21 = i21 + 1 | 0;
  } while ((i21 | 0) != (i35 | 0));
 }
 if (!i36) {
  STACKTOP = i39;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i36);
 STACKTOP = i39;
 return;
}

function __ZN15CollisionModule8TransferI14SafeBinaryReadEEvRT_(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 4 | 0;
 i16 = i18;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i14, i15);
 __ZN14SafeBinaryRead10SetVersionEi(i15, 3);
 i17 = i14 + 136 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1047471 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i15 + 16 | 0;
   i11 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = i11 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i11 >>> 0) i13 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 6; else {
     HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i13 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i17, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i17 >> 2] = _llvm_bswap_i32(HEAP32[i17 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i17 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i11 = i14 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619893 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i10 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i10 >>> 0) i13 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 17; else {
     HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = 0;
 do {
  i3 = i14 + 972 + (i2 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, HEAP32[gb + 82944 + (i2 << 2) >> 2] | 0, gb + 842702 | 0, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i3, i15); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 i8 = i14 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619907 | 0, gb + 620173 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i8, i15); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i9 = i14 + 408 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619916 | 0, gb + 620173 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i9, i15); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i10 = i14 + 672 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619925 | 0, gb + 620173 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i10, i15); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 936 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619949 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i15 + 16 | 0;
   i6 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i6 >>> 0) i13 = 47; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 47; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i13 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 940 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619962 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i6 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i13 = 58; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 58; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i6 = i14 + 944 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619975 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i4 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i13 = 69; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 69; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 69) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 956 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 619987 | 0, gb + 1048681 | 0, i16, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   __ZN14SafeBinaryRead10SetVersionEi(i15, 2);
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i12, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i15 + 16 | 0;
     i3 = HEAP32[i15 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i13 = 82; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 82; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i13 | 0) == 82) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i12 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i15);
   }
   if (__ZN14SafeBinaryRead12IsOldVersionEi(i15, 1) | 0) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 32 | 0) HEAP32[i4 >> 2] = i1 | -65536;
   }
  } else {
   i1 = HEAP32[i16 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 952 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 62e4 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i3 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i13 = 99; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 99; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 99) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 960 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620267 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i5 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i13 = 110; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 110; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 110) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i14 + 964 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620019 | 0, i7, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i5 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i13 = 121; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i13 = 121; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i13 | 0) == 121) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i3 = i14 + 968 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620029 | 0, i4, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i5 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i3 = i14 + 948 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620047 | 0, i4, i12, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i5 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i3 = i14 + 949 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620067 | 0, i4, i12, 0) | 0;
 if (i1 | 0) {
  L207 : do if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i5 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i5 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L207;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i15, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620086 | 0, i7, i12, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i5 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i5 >>> 0) i13 = 167; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i13 = 167;
      break;
     }
     HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i13 | 0) == 167) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i16, 4);
    if (!(HEAP32[i15 >> 2] & 512)) break;
    HEAP32[i16 >> 2] = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i16 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i14 + 224 >> 2] = f19;
  HEAP8[i14 + 230 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i8, i14 + 232 | 0, f19, HEAP16[i14 + 228 >> 1] | 0) | 0) & 1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620093 | 0, i7, i12, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i8 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i8 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i8 >>> 0) i13 = 178; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i13 = 178;
      break;
     }
     HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i13 | 0) == 178) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i16, 4);
    if (!(HEAP32[i15 >> 2] & 512)) break;
    HEAP32[i16 >> 2] = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i16 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i14 + 488 >> 2] = f19;
  HEAP8[i14 + 494 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i9, i14 + 496 | 0, f19, HEAP16[i14 + 492 >> 1] | 0) | 0) & 1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 620100 | 0, i7, i12, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i12 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i12 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i12 >>> 0) i13 = 189; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i13 = 189;
      break;
     }
     HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i13 | 0) == 189) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i16, 4);
    if (!(HEAP32[i15 >> 2] & 512)) break;
    HEAP32[i16 >> 2] = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (!i1) break;
    mftCall_iii(i1 | 0, i16 | 0, i15 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i14 + 752 >> 2] = f19;
  HEAP8[i14 + 758 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i10, i14 + 760 | 0, f19, HEAP16[i14 + 756 >> 1] | 0) | 0) & 1;
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i15, 2) | 0)) {
  STACKTOP = i18;
  return;
 }
 if ((HEAP32[i17 >> 2] | 0) != 1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP32[i11 >> 2] | 0) {
  STACKTOP = i18;
  return;
 }
 HEAPF32[i6 >> 2] = Math_fround(.00999999977);
 STACKTOP = i18;
 return;
}

function __ZN5physx2Sq12AABBTreeNode9subdivideERKNS_9PxBounds3EPNS0_15AABBTreeBuilderEPj(i1, i22, i28, i23) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i28 = i28 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i29 + 48 | 0;
 i9 = i29 + 36 | 0;
 i18 = i29 + 24 | 0;
 i11 = i29 + 12 | 0;
 i21 = i29;
 i26 = i1 + 16 | 0;
 i3 = i26;
 i24 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = _bitshift64Lshr(i24 | 0, i3 | 0, 2) | 0;
 i2 = getTempRet0() | 0;
 i25 = i8 & 524287;
 if ((i25 | 0) == 1) {
  i27 = _bitshift64Shl(i8 | 0, i2 | 0, 1) | 0;
  getTempRet0() | 0;
  i28 = i26;
  HEAP32[i28 >> 2] = i27 & 2 | i24 & -3;
  HEAP32[i28 + 4 >> 2] = i3;
  i28 = 1;
  STACKTOP = i29;
  return i28 | 0;
 }
 if ((HEAP32[i28 >> 2] | 0) >>> 0 >= i25 >>> 0) {
  i27 = _bitshift64Shl(i8 | 0, i2 | 0, 1) | 0;
  getTempRet0() | 0;
  i28 = i26;
  HEAP32[i28 >> 2] = i27 & 2 | i24 & -3;
  HEAP32[i28 + 4 >> 2] = i3;
  i28 = 1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = HEAP32[i28 + 4 >> 2] | 0;
 L9 : do if (!(i1 & 1)) {
  if (i1 & 2 | 0) {
   f16 = Math_fround(i25 >>> 0);
   i11 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
   getTempRet0() | 0;
   i11 = i11 & 524287;
   i6 = i23 + (i11 + i25 << 2) | 0;
   if (!i25) {
    f7 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    f4 = Math_fround(0.0);
   } else {
    i1 = HEAP32[i28 + 20 >> 2] | 0;
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    f7 = Math_fround(0.0);
    i2 = i23 + (i11 << 2) | 0;
    do {
     i21 = HEAP32[i2 >> 2] | 0;
     i2 = i2 + 4 | 0;
     f31 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) >> 2]);
     f12 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 8 >> 2]);
     f30 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 12 >> 2]);
     f13 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 16 >> 2]);
     f4 = Math_fround(f4 + Math_fround(Math_fround(f31 + f30) * Math_fround(.5)));
     f5 = Math_fround(f5 + Math_fround(Math_fround(f12 + f13) * Math_fround(.5)));
     f7 = Math_fround(f7 + Math_fround(Math_fround(f14 + Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 20 >> 2])) * Math_fround(.5)));
    } while (i2 >>> 0 < i6 >>> 0);
    f12 = Math_fround(Math_fround(1.0) / f16);
    f14 = Math_fround(f4 * f12);
    f13 = Math_fround(f5 * f12);
    f12 = Math_fround(f7 * f12);
    if (!i25) {
     f7 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     f4 = Math_fround(0.0);
    } else {
     i1 = HEAP32[i28 + 20 >> 2] | 0;
     f4 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     f7 = Math_fround(0.0);
     i2 = i23 + (i11 << 2) | 0;
     do {
      i21 = HEAP32[i2 >> 2] | 0;
      i2 = i2 + 4 | 0;
      f34 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) >> 2]);
      f33 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 4 >> 2]);
      f31 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 8 >> 2]);
      f32 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 12 >> 2]);
      f30 = Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 16 >> 2]);
      f32 = Math_fround(Math_fround(Math_fround(f34 + f32) * Math_fround(.5)) - f14);
      f30 = Math_fround(Math_fround(Math_fround(f33 + f30) * Math_fround(.5)) - f13);
      f31 = Math_fround(Math_fround(Math_fround(f31 + Math_fround(HEAPF32[i1 + (i21 * 24 | 0) + 20 >> 2])) * Math_fround(.5)) - f12);
      f4 = Math_fround(f4 + Math_fround(f32 * f32));
      f5 = Math_fround(f5 + Math_fround(f30 * f30));
      f7 = Math_fround(f7 + Math_fround(f31 * f31));
     } while ((i2 | 0) != (i6 | 0));
    }
   }
   f32 = Math_fround(Math_fround(1.0) / Math_fround(f16 + Math_fround(-1.0)));
   f34 = Math_fround(f4 * f32);
   f33 = Math_fround(f5 * f32);
   f4 = Math_fround(f7 * f32);
   HEAPF32[i9 >> 2] = f34;
   HEAPF32[i9 + 4 >> 2] = f33;
   HEAPF32[i9 + 8 >> 2] = f4;
   i10 = f33 > f34 & 1;
   i21 = f4 > Math_fround(HEAPF32[i9 + (i10 << 2) >> 2]);
   i10 = i21 ? 2 : i10;
   f4 = Math_fround(HEAPF32[i22 + (i10 << 2) >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i22 + 12 + (i10 << 2) >> 2])) * Math_fround(.5));
   if ((i24 & 2097148 | 0) == 0 & 0 == 0) {
    i27 = 63;
    break;
   }
   i8 = HEAP32[i28 + 20 >> 2] | 0;
   i2 = 0;
   i9 = 0;
   do {
    i1 = i23 + (i9 + i11 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i10 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i10 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i22 = i23 + (i2 + i11 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i22 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i25 >>> 0);
   if ((i2 | 0) != (i25 | 0) & (i2 | 0) != 0) {
    i1 = i24;
    break;
   } else {
    i27 = 63;
    break;
   }
  }
  if (i1 & 8 | 0) {
   f4 = Math_fround(HEAPF32[i22 >> 2]);
   i15 = i22 + 12 | 0;
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i15 >> 2])) * Math_fround(.5));
   i17 = (i24 & 2097148 | 0) == 0 & 0 == 0;
   if (i17) i1 = 0; else {
    i10 = HEAP32[i28 + 20 >> 2] | 0;
    i11 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    i11 = i11 & 524287;
    i8 = i8 & 524287;
    i1 = 0;
    i9 = 0;
    do {
     i2 = i23 + (i9 + i11 << 2) | 0;
     i6 = HEAP32[i2 >> 2] | 0;
     f34 = Math_fround(HEAPF32[i10 + (i6 * 24 | 0) >> 2]);
     if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i10 + (i6 * 24 | 0) + 12 >> 2])) * Math_fround(.5)) > f4) {
      i21 = i23 + (i1 + i11 << 2) | 0;
      HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i21 >> 2] = i6;
      i1 = i1 + 1 | 0;
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i8 | 0));
   }
   f12 = Math_fround(i25 >>> 0);
   f7 = Math_fround(Math_fround(i1 >>> 0) / f12);
   HEAPF32[i18 >> 2] = f7;
   f4 = Math_fround(HEAPF32[i22 + 4 >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i15 + 4 >> 2])) * Math_fround(.5));
   if (i17) i1 = 0; else {
    i8 = HEAP32[i28 + 20 >> 2] | 0;
    i9 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    i9 = i9 & 524287;
    i1 = 0;
    i10 = 0;
    do {
     i2 = i23 + (i10 + i9 << 2) | 0;
     i6 = HEAP32[i2 >> 2] | 0;
     f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 4 >> 2]);
     if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + 4 >> 2])) * Math_fround(.5)) > f4) {
      i21 = i23 + (i1 + i9 << 2) | 0;
      HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i21 >> 2] = i6;
      i1 = i1 + 1 | 0;
     }
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < i25 >>> 0);
   }
   f5 = Math_fround(Math_fround(i1 >>> 0) / f12);
   i11 = i18 + 4 | 0;
   HEAPF32[i11 >> 2] = f5;
   f4 = Math_fround(HEAPF32[i22 + 8 >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i15 + 8 >> 2])) * Math_fround(.5));
   if (i17) i1 = 0; else {
    i8 = HEAP32[i28 + 20 >> 2] | 0;
    i9 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    i9 = i9 & 524287;
    i1 = 0;
    i10 = 0;
    do {
     i2 = i23 + (i10 + i9 << 2) | 0;
     i6 = HEAP32[i2 >> 2] | 0;
     f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 8 >> 2]);
     if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + 8 >> 2])) * Math_fround(.5)) > f4) {
      i21 = i23 + (i1 + i9 << 2) | 0;
      HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i21 >> 2] = i6;
      i1 = i1 + 1 | 0;
     }
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < i25 >>> 0);
   }
   f4 = Math_fround(Math_fround(i1 >>> 0) / f12);
   f34 = Math_fround(f7 + Math_fround(-.5));
   f34 = Math_fround(f34 * f34);
   HEAPF32[i18 >> 2] = f34;
   f33 = Math_fround(f5 + Math_fround(-.5));
   f33 = Math_fround(f33 * f33);
   HEAPF32[i11 >> 2] = f33;
   f4 = Math_fround(f4 + Math_fround(-.5));
   f4 = Math_fround(f4 * f4);
   HEAPF32[i18 + 8 >> 2] = f4;
   i11 = f33 < f34 & 1;
   i21 = f4 < Math_fround(HEAPF32[i18 + (i11 << 2) >> 2]);
   i11 = i21 ? 2 : i11;
   f4 = Math_fround(HEAPF32[i22 + (i11 << 2) >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i15 + (i11 << 2) >> 2])) * Math_fround(.5));
   if (i17) {
    i27 = 63;
    break;
   }
   i8 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
   getTempRet0() | 0;
   i9 = i9 & 524287;
   i2 = 0;
   i10 = 0;
   do {
    i1 = i23 + (i10 + i9 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i11 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i11 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i22 = i23 + (i2 + i9 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i22 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i10 = i10 + 1 | 0;
   } while (i10 >>> 0 < i25 >>> 0);
   if ((i2 | 0) == 0 | (i2 | 0) == (i25 | 0)) {
    i27 = 63;
    break;
   } else {
    i1 = i24;
    break;
   }
  }
  if (!(i1 & 4)) {
   if (i1 & 16 | 0) {
    i1 = i24;
    i2 = i25 >>> 1;
    break;
   }
   i27 = _bitshift64Shl(i8 | 0, i2 | 0, 1) | 0;
   getTempRet0() | 0;
   i28 = i26;
   HEAP32[i28 >> 2] = i27 & 2 | i24 & -3;
   HEAP32[i28 + 4 >> 2] = i3;
   i28 = 0;
   STACKTOP = i29;
   return i28 | 0;
  }
  i20 = i22 + 12 | 0;
  f4 = Math_fround(HEAPF32[i20 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i22 >> 2]));
  f5 = Math_fround(HEAPF32[i22 + 16 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i22 + 4 >> 2]));
  f7 = Math_fround(HEAPF32[i22 + 20 >> 2]);
  f4 = Math_fround(f4 * Math_fround(.5));
  f5 = Math_fround(f5 * Math_fround(.5));
  f7 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i22 + 8 >> 2])) * Math_fround(.5));
  HEAPF32[i11 >> 2] = f4;
  HEAPF32[i11 + 4 >> 2] = f5;
  HEAPF32[i11 + 8 >> 2] = f7;
  HEAP32[i21 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  i10 = i21 + 4 | 0;
  if (f4 < f5) {
   HEAP32[i21 >> 2] = 1;
   HEAP32[i10 >> 2] = 0;
   i2 = 0;
   i1 = 1;
  } else {
   f4 = f5;
   i2 = 1;
   i1 = 0;
  }
  i9 = i21 + 8 | 0;
  if (f4 < f7) {
   HEAP32[i10 >> 2] = 2;
   HEAP32[i9 >> 2] = i2;
   f4 = f7;
   i6 = 2;
  } else {
   i6 = i2;
   i2 = 2;
  }
  f5 = Math_fround(HEAPF32[i11 + (i1 << 2) >> 2]);
  if (f5 < f4) {
   HEAP32[i21 >> 2] = i6;
   HEAP32[i10 >> 2] = i1;
   f4 = f5;
   i8 = i1;
   i1 = i6;
  } else i8 = i6;
  f5 = Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]);
  if (f4 < f5) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   f4 = f5;
   i6 = i2;
   i2 = i8;
  } else i6 = i8;
  f5 = Math_fround(HEAPF32[i11 + (i1 << 2) >> 2]);
  if (f5 < f4) {
   HEAP32[i21 >> 2] = i6;
   HEAP32[i10 >> 2] = i1;
   f4 = f5;
  } else i1 = i6;
  if (f4 < Math_fround(HEAPF32[i11 + (i2 << 2) >> 2])) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i9 >> 2] = i1;
  }
  i17 = i28 + 20 | 0;
  i19 = (i24 & 2097148 | 0) == 0 & 0 == 0;
  i18 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
  getTempRet0() | 0;
  i18 = i18 & 524287;
  i15 = HEAP32[i21 >> 2] | 0;
  i10 = i22 + (i15 << 2) | 0;
  i11 = i20 + (i15 << 2) | 0;
  i2 = 0;
  i1 = 1;
  while (1) {
   if (!i1) {
    i1 = i24;
    break L9;
   }
   f4 = Math_fround(HEAPF32[i10 >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5));
   if (i19) {
    i2 = 0;
    break;
   }
   i8 = HEAP32[i17 >> 2] | 0;
   i2 = 0;
   i9 = 0;
   do {
    i1 = i23 + (i9 + i18 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i15 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i15 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i35 = i23 + (i2 + i18 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i35 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i25 >>> 0);
   if (!i2) {
    i2 = 0;
    break;
   }
   if ((i2 | 0) == (i25 | 0)) {
    i2 = i25;
    break;
   } else i1 = 0;
  }
  i10 = HEAP32[i21 + 4 >> 2] | 0;
  i11 = i22 + (i10 << 2) | 0;
  i15 = i20 + (i10 << 2) | 0;
  i1 = 1;
  while (1) {
   if (!i1) {
    i1 = i24;
    break L9;
   }
   f4 = Math_fround(HEAPF32[i11 >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i15 >> 2])) * Math_fround(.5));
   if (i19) {
    i2 = 0;
    break;
   }
   i8 = HEAP32[i17 >> 2] | 0;
   i2 = 0;
   i9 = 0;
   do {
    i1 = i23 + (i9 + i18 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i10 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i10 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i35 = i23 + (i2 + i18 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i35 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i25 >>> 0);
   if (!i2) {
    i2 = 0;
    break;
   }
   if ((i2 | 0) == (i25 | 0)) {
    i2 = i25;
    break;
   } else i1 = 0;
  }
  i15 = HEAP32[i21 + 8 >> 2] | 0;
  i11 = i22 + (i15 << 2) | 0;
  i10 = i20 + (i15 << 2) | 0;
  i1 = 1;
  while (1) {
   if (!i1) {
    i1 = i24;
    break L9;
   }
   f4 = Math_fround(HEAPF32[i11 >> 2]);
   f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
   if (i19) {
    i27 = 63;
    break L9;
   }
   i8 = HEAP32[i17 >> 2] | 0;
   i2 = 0;
   i9 = 0;
   do {
    i1 = i23 + (i9 + i18 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i15 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i15 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i35 = i23 + (i2 + i18 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i35 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i25 >>> 0);
   if ((i2 | 0) == 0 | (i2 | 0) == (i25 | 0)) {
    i27 = 63;
    break;
   } else i1 = 0;
  }
 } else {
  i35 = i22 + 12 | 0;
  f34 = Math_fround(HEAPF32[i35 >> 2]);
  f34 = Math_fround(f34 - Math_fround(HEAPF32[i22 >> 2]));
  f33 = Math_fround(HEAPF32[i22 + 16 >> 2]);
  f33 = Math_fround(f33 - Math_fround(HEAPF32[i22 + 4 >> 2]));
  f4 = Math_fround(HEAPF32[i22 + 20 >> 2]);
  f34 = Math_fround(f34 * Math_fround(.5));
  f33 = Math_fround(f33 * Math_fround(.5));
  f4 = Math_fround(Math_fround(f4 - Math_fround(HEAPF32[i22 + 8 >> 2])) * Math_fround(.5));
  HEAPF32[i6 >> 2] = f34;
  HEAPF32[i6 + 4 >> 2] = f33;
  HEAPF32[i6 + 8 >> 2] = f4;
  i11 = f33 > f34 & 1;
  i21 = f4 > Math_fround(HEAPF32[i6 + (i11 << 2) >> 2]);
  i11 = i21 ? 2 : i11;
  f4 = Math_fround(HEAPF32[i22 + (i11 << 2) >> 2]);
  f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i35 + (i11 << 2) >> 2])) * Math_fround(.5));
  if ((i24 & 2097148 | 0) == 0 & 0 == 0) i27 = 63; else {
   i8 = HEAP32[i28 + 20 >> 2] | 0;
   i9 = _bitshift64Lshr(i24 | 0, i3 | 0, 21) | 0;
   getTempRet0() | 0;
   i9 = i9 & 524287;
   i2 = 0;
   i10 = 0;
   do {
    i1 = i23 + (i10 + i9 << 2) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    f34 = Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + (i11 << 2) >> 2]);
    if (Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i8 + (i6 * 24 | 0) + 12 + (i11 << 2) >> 2])) * Math_fround(.5)) > f4) {
     i35 = i23 + (i2 + i9 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i35 >> 2] = i6;
     i2 = i2 + 1 | 0;
    }
    i10 = i10 + 1 | 0;
   } while (i10 >>> 0 < i25 >>> 0);
   if ((i2 | 0) == 0 | (i2 | 0) == (i25 | 0)) i27 = 63; else i1 = i24;
  }
 } while (0);
 do if ((i27 | 0) == 63) {
  i1 = _bitshift64Lshr(i24 | 0, i3 | 0, 1) | 0;
  getTempRet0() | 0;
  i1 = i1 & 2 | i24 & -3;
  i35 = i26;
  HEAP32[i35 >> 2] = i1;
  HEAP32[i35 + 4 >> 2] = i3;
  if (i25 >>> 0 > (HEAP32[i28 >> 2] | 0) >>> 0) {
   i2 = i28 + 28 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = _bitshift64Lshr(i24 | 0, i3 | 0, 3) | 0;
   getTempRet0() | 0;
   i2 = i2 & 262143;
   break;
  } else {
   i35 = 1;
   STACKTOP = i29;
   return i35 | 0;
  }
 } while (0);
 i35 = HEAP32[i28 + 12 >> 2] | 0;
 i24 = _bitshift64Lshr(i1 | 0, i3 | 0, 21) | 0;
 getTempRet0() | 0;
 i24 = i24 & 524287;
 i25 = i28 + 24 | 0;
 i27 = HEAP32[i25 >> 2] | 0;
 i23 = _bitshift64Shl(i27 | 0, 0, 21) | 0;
 i21 = getTempRet0() | 0 | i3 & -256;
 i28 = i26;
 HEAP32[i28 >> 2] = i23 | i1 & 2097150;
 HEAP32[i28 + 4 >> 2] = i21;
 HEAP32[i25 >> 2] = i27 + 2;
 i27 = i27 & 524287;
 i25 = i35 + (i27 * 24 | 0) + 16 | 0;
 i28 = HEAP32[i25 + 4 >> 2] & -256;
 i21 = _bitshift64Shl(i24 | 0, 0, 21) | 0;
 i23 = getTempRet0() | 0;
 i19 = _bitshift64Shl(i2 | 0, 0, 2) | 0;
 i22 = getTempRet0() | 0;
 i20 = _bitshift64Shl(i2 | 0, 0, 1) | 0;
 getTempRet0() | 0;
 HEAP32[i25 >> 2] = i19 | i20 & 2 | i21 | 1;
 HEAP32[i25 + 4 >> 2] = i22 | i23 | i28;
 i35 = (i27 | 0 ? i35 + ((i27 + 1 | 0) * 24 | 0) | 0 : i35) + 16 | 0;
 i27 = i35;
 i25 = HEAP32[i27 >> 2] & 2097151;
 i27 = HEAP32[i27 + 4 >> 2] & -256;
 i24 = _bitshift64Shl(i24 + i2 | 0, 0, 21) | 0;
 i24 = i25 | i24;
 i27 = i27 | (getTempRet0() | 0);
 i25 = i35;
 HEAP32[i25 >> 2] = i24;
 HEAP32[i25 + 4 >> 2] = i27;
 i26 = _bitshift64Lshr(HEAP32[i26 >> 2] | 0, HEAP32[i26 + 4 >> 2] | 0, 2) | 0;
 getTempRet0() | 0;
 i26 = (i26 & 524287) - i2 | 0;
 i25 = _bitshift64Shl(i26 | 0, 0, 2) | 0;
 i28 = getTempRet0() | 0;
 i26 = _bitshift64Shl(i26 | 0, 0, 1) | 0;
 getTempRet0() | 0;
 HEAP32[i35 >> 2] = i24 & -2097152 | i25 | i26 & 2 | 1;
 HEAP32[i35 + 4 >> 2] = i27 | i28;
 i35 = 1;
 STACKTOP = i29;
 return i35 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i51, i53, i57, i1, i77, i78, i79, i80, i82, i84, i70) {
 i51 = i51 | 0;
 i53 = i53 | 0;
 i57 = i57 | 0;
 i1 = i1 | 0;
 i77 = i77 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 i80 = i80 | 0;
 i82 = i82 | 0;
 i84 = i84 | 0;
 i70 = i70 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f52 = f0, f54 = f0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f71 = f0, f72 = f0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i81 = 0, i83 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i85 + 288 | 0;
 i64 = i85 + 468 | 0;
 i63 = i85 + 456 | 0;
 i75 = i85 + 304 | 0;
 i73 = i85 + 224 | 0;
 i74 = i85 + 160 | 0;
 i81 = i85 + 440 | 0;
 i83 = i85 + 424 | 0;
 i58 = i85 + 416 | 0;
 i76 = i85 + 144 | 0;
 i22 = i85 + 128 | 0;
 i21 = i85 + 112 | 0;
 i23 = i85 + 404 | 0;
 i24 = i85 + 96 | 0;
 i59 = i85 + 80 | 0;
 i66 = i85 + 64 | 0;
 i67 = i85 + 48 | 0;
 i65 = i85 + 392 | 0;
 i56 = i85 + 32 | 0;
 i55 = i85 + 380 | 0;
 i61 = i85 + 16 | 0;
 i62 = i85;
 i60 = i85 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f71 = Math_fround(HEAPF32[i51 + 16 >> 2]);
 f72 = Math_fround(HEAPF32[i53 + 16 >> 2]);
 f52 = Math_fround(HEAPF32[i1 >> 2]);
 f54 = Math_fround(HEAPF32[i51 + 32 >> 2]);
 f69 = Math_fround(HEAPF32[i53 + 32 >> 2]);
 f54 = Math_fround((f54 > f69 ? f69 : f54) * Math_fround(.100000001));
 f54 = Math_fround(f54 * f54);
 f69 = Math_fround(f71 + f72);
 HEAP32[i58 >> 2] = 0;
 i1 = HEAP8[i70 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i57 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i57 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i57 + 56 >> 2]);
  i50 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i50 ? f5 : Math_fround(1.0);
  f6 = i50 ? f6 : Math_fround(0.0);
  f7 = i50 ? f7 : Math_fround(0.0);
  HEAPF32[i76 >> 2] = f5;
  HEAPF32[i76 + 4 >> 2] = f6;
  HEAPF32[i76 + 8 >> 2] = f7;
  HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i24 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  i50 = i76;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i68 = 7;
 } else {
  HEAP32[i22 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i57 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i57 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i57 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i57 >> 2]);
  f9 = Math_fround(HEAPF32[i57 + 16 >> 2]);
  f10 = Math_fround(HEAPF32[i57 + 32 >> 2]);
  f11 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i57 + 20 >> 2]);
  f13 = Math_fround(HEAPF32[i57 + 36 >> 2]);
  f14 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i57 + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i57 + 40 >> 2]);
  i17 = i53 + 96 | 0;
  i18 = i22 + 4 | 0;
  i19 = i22 + 8 | 0;
  i20 = i22 + 12 | 0;
  i1 = i1 & 255;
  i8 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i3 = 0;
  while (1) {
   i49 = HEAPU8[i82 + i3 >> 0] | 0;
   HEAP32[i81 + (i3 << 2) >> 2] = i49;
   i50 = HEAPU8[i84 + i3 >> 0] | 0;
   HEAP32[i83 + (i3 << 2) >> 2] = i50;
   f87 = Math_fround(HEAPF32[i51 + 96 + (i49 << 4) >> 2]);
   f88 = Math_fround(HEAPF32[i51 + 96 + (i49 << 4) + 4 >> 2]);
   f89 = Math_fround(HEAPF32[i51 + 96 + (i49 << 4) + 8 >> 2]);
   f91 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f87 * f7) + Math_fround(f88 * f9)) + Math_fround(f89 * f10)));
   f90 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f87 * f11) + Math_fround(f88 * f12)) + Math_fround(f89 * f13)));
   f89 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f87 * f14) + Math_fround(f88 * f15)) + Math_fround(f89 * f16)));
   i50 = 1 - i50 | 0;
   f88 = Math_fround(HEAPF32[i17 + (i50 << 4) >> 2]);
   f87 = Math_fround(HEAPF32[i17 + (i50 << 4) + 4 >> 2]);
   f86 = Math_fround(HEAPF32[i17 + (i50 << 4) + 8 >> 2]);
   i50 = HEAP32[i17 + (i50 << 4) + 12 >> 2] | 0;
   f93 = Math_fround(f90 - f87);
   f92 = Math_fround(f89 - f86);
   HEAPF32[i22 >> 2] = Math_fround(f91 - f88);
   HEAPF32[i18 >> 2] = f93;
   HEAPF32[i19 >> 2] = f92;
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   HEAPF32[i73 + (i2 << 4) >> 2] = f91;
   HEAPF32[i73 + (i2 << 4) + 4 >> 2] = f90;
   HEAPF32[i73 + (i2 << 4) + 8 >> 2] = f89;
   HEAPF32[i73 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i74 + (i2 << 4) >> 2] = f88;
   HEAPF32[i74 + (i2 << 4) + 4 >> 2] = f87;
   HEAPF32[i74 + (i2 << 4) + 8 >> 2] = f86;
   HEAP32[i74 + (i2 << 4) + 12 >> 2] = i50;
   i50 = i75 + (i2 << 4) | 0;
   HEAP32[i50 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i58 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i21, i75, i73, i74, i81, i83, i22, i58);
  HEAP32[i76 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i76 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i76 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i76 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i76 >> 2]);
  f6 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i76 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i64 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i63 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  if (f4 > f54) {
   i50 = i76;
   i68 = 7;
  } else i2 = HEAP32[i58 >> 2] | 0;
 }
 do if ((i68 | 0) == 7) {
  i48 = i76 + 4 | 0;
  i49 = i76 + 8 | 0;
  i18 = i57 + 4 | 0;
  i19 = i57 + 8 | 0;
  i20 = i57 + 16 | 0;
  i21 = i57 + 20 | 0;
  i22 = i57 + 24 | 0;
  i23 = i57 + 32 | 0;
  i25 = i57 + 36 | 0;
  i26 = i57 + 40 | 0;
  i27 = i51 + 96 | 0;
  i28 = i51 + 100 | 0;
  i29 = i51 + 104 | 0;
  i30 = i51 + 112 | 0;
  i31 = i51 + 116 | 0;
  i32 = i51 + 120 | 0;
  i33 = i51 + 128 | 0;
  i34 = i51 + 132 | 0;
  i35 = i51 + 136 | 0;
  i36 = i57 + 48 | 0;
  i37 = i57 + 52 | 0;
  i38 = i57 + 56 | 0;
  i39 = i53 + 96 | 0;
  i40 = i53 + 100 | 0;
  i41 = i53 + 104 | 0;
  i42 = i53 + 112 | 0;
  i43 = i53 + 116 | 0;
  i44 = i53 + 120 | 0;
  i45 = i59 + 4 | 0;
  i46 = i59 + 8 | 0;
  i47 = i59 + 12 | 0;
  i17 = i51 + 48 | 0;
  i8 = i53 + 48 | 0;
  f10 = f52;
  while (1) {
   HEAP32[i63 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i24 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAP32[i24 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
   f86 = Math_fround(-f5);
   f6 = Math_fround(-f6);
   f5 = Math_fround(-f7);
   i3 = HEAP32[i58 >> 2] | 0;
   f90 = Math_fround(HEAPF32[i57 >> 2]);
   f97 = Math_fround(f90 * f86);
   f91 = Math_fround(HEAPF32[i18 >> 2]);
   f97 = Math_fround(f97 + Math_fround(f91 * f6));
   f87 = Math_fround(HEAPF32[i19 >> 2]);
   f97 = Math_fround(f97 + Math_fround(f87 * f5));
   f52 = Math_fround(HEAPF32[i20 >> 2]);
   f96 = Math_fround(f52 * f86);
   f92 = Math_fround(HEAPF32[i21 >> 2]);
   f96 = Math_fround(f96 + Math_fround(f92 * f6));
   f15 = Math_fround(HEAPF32[i22 >> 2]);
   f96 = Math_fround(f96 + Math_fround(f15 * f5));
   f93 = Math_fround(HEAPF32[i23 >> 2]);
   f86 = Math_fround(f93 * f86);
   f13 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(f86 + Math_fround(f13 * f6));
   f86 = Math_fround(HEAPF32[i26 >> 2]);
   f5 = Math_fround(f6 + Math_fround(f86 * f5));
   f6 = Math_fround(HEAPF32[i27 >> 2]);
   f9 = Math_fround(HEAPF32[i28 >> 2]);
   f88 = Math_fround(HEAPF32[i29 >> 2]);
   f7 = Math_fround(HEAPF32[i30 >> 2]);
   f11 = Math_fround(HEAPF32[i31 >> 2]);
   f12 = Math_fround(HEAPF32[i32 >> 2]);
   f89 = Math_fround(HEAPF32[i33 >> 2]);
   f16 = Math_fround(HEAPF32[i34 >> 2]);
   f14 = Math_fround(HEAPF32[i35 >> 2]);
   f95 = Math_fround(Math_fround(Math_fround(f97 * f6) + Math_fround(f96 * f9)) + Math_fround(f5 * f88));
   f94 = Math_fround(Math_fround(Math_fround(f97 * f7) + Math_fround(f96 * f11)) + Math_fround(f5 * f12));
   f5 = Math_fround(Math_fround(Math_fround(f97 * f89) + Math_fround(f96 * f16)) + Math_fround(f5 * f14));
   i53 = f95 > f94 & f95 > f5;
   i2 = f94 > f5;
   HEAP32[i81 + (i3 << 2) >> 2] = i53 ? 0 : i2 ? 1 : 2;
   f89 = i53 ? f6 : i2 ? f7 : f89;
   f16 = i53 ? f9 : i2 ? f11 : f16;
   f14 = i53 ? f88 : i2 ? f12 : f14;
   f12 = Math_fround(HEAPF32[i36 >> 2]);
   f88 = Math_fround(HEAPF32[i37 >> 2]);
   f52 = Math_fround(f12 + Math_fround(Math_fround(f93 * f14) + Math_fround(Math_fround(f89 * f90) + Math_fround(f16 * f52))));
   f92 = Math_fround(f88 + Math_fround(Math_fround(f13 * f14) + Math_fround(Math_fround(f89 * f91) + Math_fround(f16 * f92))));
   f86 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) + Math_fround(Math_fround(Math_fround(f89 * f87) + Math_fround(f16 * f15)) + Math_fround(f14 * f86)));
   HEAPF32[i73 + (i3 << 4) >> 2] = f52;
   HEAPF32[i73 + (i3 << 4) + 4 >> 2] = f92;
   HEAPF32[i73 + (i3 << 4) + 8 >> 2] = f86;
   HEAPF32[i73 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f14 = Math_fround(HEAPF32[i39 >> 2]);
   f15 = Math_fround(HEAPF32[i40 >> 2]);
   f16 = Math_fround(HEAPF32[i41 >> 2]);
   f87 = Math_fround(HEAPF32[i76 >> 2]);
   f89 = Math_fround(HEAPF32[i48 >> 2]);
   f91 = Math_fround(HEAPF32[i49 >> 2]);
   f13 = Math_fround(Math_fround(Math_fround(f14 * f87) + Math_fround(f15 * f89)) + Math_fround(f16 * f91));
   f88 = Math_fround(HEAPF32[i42 >> 2]);
   f90 = Math_fround(HEAPF32[i43 >> 2]);
   f93 = Math_fround(HEAPF32[i44 >> 2]);
   i2 = f13 > Math_fround(Math_fround(Math_fround(f87 * f88) + Math_fround(f89 * f90)) + Math_fround(f91 * f93));
   HEAP32[i83 + (i3 << 2) >> 2] = i2 & 1;
   f88 = i2 ? f14 : f88;
   f90 = i2 ? f15 : f90;
   f93 = i2 ? f16 : f93;
   HEAPF32[i74 + (i3 << 4) >> 2] = f88;
   HEAPF32[i74 + (i3 << 4) + 4 >> 2] = f90;
   HEAPF32[i74 + (i3 << 4) + 8 >> 2] = f93;
   HEAPF32[i74 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f88 = Math_fround(f52 - f88);
   f90 = Math_fround(f92 - f90);
   f93 = Math_fround(f86 - f93);
   HEAPF32[i59 >> 2] = f88;
   HEAPF32[i45 >> 2] = f90;
   HEAPF32[i46 >> 2] = f93;
   HEAPF32[i47 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i58 >> 2] | 0;
   i2 = i75 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f86 = Math_fround(HEAPF32[i17 >> 2]);
   f92 = Math_fround(HEAPF32[i8 >> 2]);
   f92 = f86 > f92 ? f86 : f92;
   f10 = f10 > f92 ? f10 : f92;
   f92 = Math_fround(f69 + f10);
   f93 = Math_fround(Math_fround(Math_fround(f87 * f88) + Math_fround(f89 * f90)) + Math_fround(f91 * f93));
   i2 = f93 > Math_fround(0.0) ? Math_fround(f93 * f93) > Math_fround(f4 * Math_fround(f92 * f92)) : 0;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f93) | i2) {
    i68 = 9;
    break;
   }
   HEAP32[i58 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i56, i75, i73, i74, i81, i83, i59, i58);
   HEAP32[i50 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i76 >> 2]);
   f6 = Math_fround(HEAPF32[i48 >> 2]);
   f7 = Math_fround(HEAPF32[i49 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i64 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i64 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i64 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   i1 = f4 > f9;
   if (!(f9 > f54 & i1)) break; else f4 = f9;
  }
  if ((i68 | 0) == 9) {
   if (i82 | 0) {
    HEAP8[i70 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
      HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i84 = 0;
    STACKTOP = i85;
    return i84 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i66, i67, i3);
   f94 = Math_fround(Math_sqrt(Math_fround(f4)));
   f95 = Math_fround(HEAPF32[i76 >> 2]);
   f96 = Math_fround(HEAPF32[i48 >> 2]);
   f97 = Math_fround(Math_fround(1.0) / f94);
   f95 = Math_fround(f95 * f97);
   f96 = Math_fround(f96 * f97);
   f97 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f97);
   f93 = Math_fround(HEAPF32[i66 >> 2]);
   f92 = Math_fround(HEAPF32[i66 + 4 >> 2]);
   f92 = Math_fround(f92 - Math_fround(f71 * f96));
   f91 = Math_fround(Math_fround(HEAPF32[i66 + 8 >> 2]) - Math_fround(f71 * f97));
   HEAPF32[i77 >> 2] = Math_fround(f93 - Math_fround(f71 * f95));
   HEAPF32[i77 + 4 >> 2] = f92;
   HEAPF32[i77 + 8 >> 2] = f91;
   HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
   f91 = Math_fround(HEAPF32[i67 >> 2]);
   f92 = Math_fround(HEAPF32[i67 + 4 >> 2]);
   f92 = Math_fround(Math_fround(f72 * f96) + f92);
   f93 = Math_fround(Math_fround(f72 * f97) + Math_fround(HEAPF32[i67 + 8 >> 2]));
   HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f95) + f91);
   HEAPF32[i78 + 4 >> 2] = f92;
   HEAPF32[i78 + 8 >> 2] = f93;
   HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i80 >> 2] = Math_fround(f94 - f69);
   i84 = i80 + 4 | 0;
   HEAP32[i84 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i84 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
   HEAP32[i84 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
   HEAPF32[i79 >> 2] = f95;
   HEAPF32[i79 + 4 >> 2] = f96;
   HEAPF32[i79 + 8 >> 2] = f97;
   HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
   i84 = 1;
   STACKTOP = i85;
   return i84 | 0;
  }
  i2 = HEAP32[i58 >> 2] | 0;
  if (i1) {
   if (!i82) i1 = 6; else break;
   STACKTOP = i85;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i82 | 0) {
   HEAP8[i70 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
     HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i50 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i50 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i61, i62, i2);
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  f94 = Math_fround(Math_sqrt(Math_fround(f4)));
  f95 = Math_fround(HEAPF32[i76 >> 2]);
  f96 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f97 = Math_fround(Math_fround(1.0) / f94);
  f95 = Math_fround(f95 * f97);
  f96 = Math_fround(f96 * f97);
  f97 = Math_fround(Math_fround(HEAPF32[i76 + 8 >> 2]) * f97);
  f93 = Math_fround(HEAPF32[i61 >> 2]);
  f92 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f92 = Math_fround(f92 - Math_fround(f71 * f96));
  f91 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) - Math_fround(f71 * f97));
  HEAPF32[i77 >> 2] = Math_fround(f93 - Math_fround(f71 * f95));
  HEAPF32[i77 + 4 >> 2] = f92;
  HEAPF32[i77 + 8 >> 2] = f91;
  HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
  f91 = Math_fround(HEAPF32[i62 >> 2]);
  f92 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f92 = Math_fround(Math_fround(f72 * f96) + f92);
  f93 = Math_fround(Math_fround(f72 * f97) + Math_fround(HEAPF32[i62 + 8 >> 2]));
  HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f95) + f91);
  HEAPF32[i78 + 4 >> 2] = f92;
  HEAPF32[i78 + 8 >> 2] = f93;
  HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i80 >> 2] = Math_fround(f94 - f69);
  i84 = i80 + 4 | 0;
  HEAP32[i84 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i84 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i84 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  HEAPF32[i79 >> 2] = f95;
  HEAPF32[i79 + 4 >> 2] = f96;
  HEAPF32[i79 + 8 >> 2] = f97;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  i84 = 3;
  STACKTOP = i85;
  return i84 | 0;
 } while (0);
 HEAP8[i70 >> 0] = i2;
 if (!i2) {
  i84 = 6;
  STACKTOP = i85;
  return i84 | 0;
 } else i1 = 0;
 do {
  HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
  HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i85;
 return i1 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i54, i56, i60, i1, i80, i81, i82, i83, i85, i87, i73) {
 i54 = i54 | 0;
 i56 = i56 | 0;
 i60 = i60 | 0;
 i1 = i1 | 0;
 i80 = i80 | 0;
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i85 = i85 | 0;
 i87 = i87 | 0;
 i73 = i73 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f55 = f0, f57 = f0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i84 = 0, i86 = 0, i88 = 0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0;
 i88 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i88 + 288 | 0;
 i67 = i88 + 468 | 0;
 i66 = i88 + 456 | 0;
 i78 = i88 + 304 | 0;
 i76 = i88 + 224 | 0;
 i77 = i88 + 160 | 0;
 i84 = i88 + 440 | 0;
 i86 = i88 + 424 | 0;
 i61 = i88 + 416 | 0;
 i79 = i88 + 144 | 0;
 i27 = i88 + 128 | 0;
 i26 = i88 + 112 | 0;
 i28 = i88 + 404 | 0;
 i29 = i88 + 96 | 0;
 i62 = i88 + 80 | 0;
 i69 = i88 + 64 | 0;
 i70 = i88 + 48 | 0;
 i68 = i88 + 392 | 0;
 i59 = i88 + 32 | 0;
 i58 = i88 + 380 | 0;
 i64 = i88 + 16 | 0;
 i65 = i88;
 i63 = i88 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f74 = Math_fround(HEAPF32[i54 + 16 >> 2]);
 f75 = Math_fround(HEAPF32[i56 + 16 >> 2]);
 f55 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i54 + 32 >> 2]);
 f72 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f57 = Math_fround((f57 > f72 ? f72 : f57) * Math_fround(.100000001));
 f57 = Math_fround(f57 * f57);
 f72 = Math_fround(f74 + f75);
 HEAP32[i61 >> 2] = 0;
 i1 = HEAP8[i73 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i60 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i60 + 56 >> 2]);
  i53 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i53 ? f5 : Math_fround(1.0);
  f6 = i53 ? f6 : Math_fround(0.0);
  f7 = i53 ? f7 : Math_fround(0.0);
  HEAPF32[i79 >> 2] = f5;
  HEAPF32[i79 + 4 >> 2] = f6;
  HEAPF32[i79 + 8 >> 2] = f7;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i29 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  i53 = i79;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i71 = 7;
 } else {
  HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i60 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i60 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i60 >> 2]);
  f9 = Math_fround(HEAPF32[i60 + 16 >> 2]);
  f10 = Math_fround(HEAPF32[i60 + 32 >> 2]);
  f11 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i60 + 20 >> 2]);
  f13 = Math_fround(HEAPF32[i60 + 36 >> 2]);
  f14 = Math_fround(HEAPF32[i60 + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i60 + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i60 + 40 >> 2]);
  f17 = Math_fround(HEAPF32[i56 + 144 >> 2]);
  f18 = Math_fround(HEAPF32[i56 + 148 >> 2]);
  f19 = Math_fround(HEAPF32[i56 + 152 >> 2]);
  f20 = Math_fround(-f17);
  f21 = Math_fround(-f18);
  f22 = Math_fround(-f19);
  i23 = i27 + 4 | 0;
  i24 = i27 + 8 | 0;
  i25 = i27 + 12 | 0;
  i2 = i1 & 255;
  i8 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i52 = HEAPU8[i85 + i3 >> 0] | 0;
   HEAP32[i84 + (i3 << 2) >> 2] = i52;
   i53 = HEAPU8[i87 + i3 >> 0] | 0;
   HEAP32[i86 + (i3 << 2) >> 2] = i53;
   f90 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) >> 2]);
   f91 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) + 4 >> 2]);
   f92 = Math_fround(HEAPF32[i54 + 96 + (i52 << 4) + 8 >> 2]);
   f94 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f90 * f7) + Math_fround(f91 * f9)) + Math_fround(f92 * f10)));
   f93 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f90 * f11) + Math_fround(f91 * f12)) + Math_fround(f92 * f13)));
   f92 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f90 * f14) + Math_fround(f91 * f15)) + Math_fround(f92 * f16)));
   f91 = HEAP32[gb + 48 + (i53 << 4) >> 2] | 0 ? f17 : f20;
   f90 = HEAP32[gb + 48 + (i53 << 4) + 4 >> 2] | 0 ? f18 : f21;
   f89 = HEAP32[gb + 48 + (i53 << 4) + 8 >> 2] | 0 ? f19 : f22;
   f96 = Math_fround(f93 - f90);
   f95 = Math_fround(f92 - f89);
   HEAPF32[i27 >> 2] = Math_fround(f94 - f91);
   HEAPF32[i23 >> 2] = f96;
   HEAPF32[i24 >> 2] = f95;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   HEAPF32[i76 + (i1 << 4) >> 2] = f94;
   HEAPF32[i76 + (i1 << 4) + 4 >> 2] = f93;
   HEAPF32[i76 + (i1 << 4) + 8 >> 2] = f92;
   HEAPF32[i76 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i77 + (i1 << 4) >> 2] = f91;
   HEAPF32[i77 + (i1 << 4) + 4 >> 2] = f90;
   HEAPF32[i77 + (i1 << 4) + 8 >> 2] = f89;
   HEAPF32[i77 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i53 = i78 + (i1 << 4) | 0;
   HEAP32[i53 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i61 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i26, i78, i76, i77, i84, i86, i27, i61);
  HEAP32[i79 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i79 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i79 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i79 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i79 >> 2]);
  f6 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i79 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i67 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i66 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  if (f4 > f57) {
   i53 = i79;
   i71 = 7;
  } else i2 = HEAP32[i61 >> 2] | 0;
 }
 do if ((i71 | 0) == 7) {
  i51 = i79 + 4 | 0;
  i52 = i79 + 8 | 0;
  i24 = i60 + 4 | 0;
  i25 = i60 + 8 | 0;
  i26 = i60 + 16 | 0;
  i27 = i60 + 20 | 0;
  i28 = i60 + 24 | 0;
  i30 = i60 + 32 | 0;
  i31 = i60 + 36 | 0;
  i32 = i60 + 40 | 0;
  i33 = i54 + 96 | 0;
  i34 = i54 + 100 | 0;
  i35 = i54 + 104 | 0;
  i36 = i54 + 112 | 0;
  i37 = i54 + 116 | 0;
  i38 = i54 + 120 | 0;
  i39 = i54 + 128 | 0;
  i40 = i54 + 132 | 0;
  i41 = i54 + 136 | 0;
  i42 = i60 + 48 | 0;
  i43 = i60 + 52 | 0;
  i44 = i60 + 56 | 0;
  i45 = i56 + 144 | 0;
  i46 = i56 + 148 | 0;
  i47 = i56 + 152 | 0;
  i48 = i62 + 4 | 0;
  i49 = i62 + 8 | 0;
  i50 = i62 + 12 | 0;
  i23 = i54 + 48 | 0;
  i8 = i56 + 48 | 0;
  f10 = f55;
  while (1) {
   HEAP32[i66 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i29 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i29 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   HEAP32[i29 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
   f89 = Math_fround(-f5);
   f14 = Math_fround(-f6);
   f13 = Math_fround(-f7);
   i3 = HEAP32[i61 >> 2] | 0;
   f96 = Math_fround(HEAPF32[i60 >> 2]);
   f7 = Math_fround(f96 * f89);
   f22 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f22 * f14));
   f20 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f20 * f13));
   f55 = Math_fround(HEAPF32[i26 >> 2]);
   f9 = Math_fround(f55 * f89);
   f95 = Math_fround(HEAPF32[i27 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f95 * f14));
   f92 = Math_fround(HEAPF32[i28 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f92 * f13));
   f19 = Math_fround(HEAPF32[i30 >> 2]);
   f89 = Math_fround(f19 * f89);
   f91 = Math_fround(HEAPF32[i31 >> 2]);
   f14 = Math_fround(f89 + Math_fround(f91 * f14));
   f89 = Math_fround(HEAPF32[i32 >> 2]);
   f13 = Math_fround(f14 + Math_fround(f89 * f13));
   f14 = Math_fround(HEAPF32[i33 >> 2]);
   f16 = Math_fround(HEAPF32[i34 >> 2]);
   f93 = Math_fround(HEAPF32[i35 >> 2]);
   f15 = Math_fround(HEAPF32[i36 >> 2]);
   f17 = Math_fround(HEAPF32[i37 >> 2]);
   f18 = Math_fround(HEAPF32[i38 >> 2]);
   f21 = Math_fround(HEAPF32[i39 >> 2]);
   f94 = Math_fround(HEAPF32[i40 >> 2]);
   f90 = Math_fround(HEAPF32[i41 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(f7 * f14) + Math_fround(f9 * f16)) + Math_fround(f13 * f93));
   f12 = Math_fround(Math_fround(Math_fround(f7 * f15) + Math_fround(f9 * f17)) + Math_fround(f13 * f18));
   f13 = Math_fround(Math_fround(Math_fround(f7 * f21) + Math_fround(f9 * f94)) + Math_fround(f13 * f90));
   i56 = f11 > f12 & f11 > f13;
   i54 = f12 > f13;
   HEAP32[i84 + (i3 << 2) >> 2] = i56 ? 0 : i54 ? 1 : 2;
   f21 = i56 ? f14 : i54 ? f15 : f21;
   f94 = i56 ? f16 : i54 ? f17 : f94;
   f90 = i56 ? f93 : i54 ? f18 : f90;
   f18 = Math_fround(HEAPF32[i42 >> 2]);
   f93 = Math_fround(HEAPF32[i43 >> 2]);
   f55 = Math_fround(f18 + Math_fround(Math_fround(f19 * f90) + Math_fround(Math_fround(f21 * f96) + Math_fround(f94 * f55))));
   f95 = Math_fround(f93 + Math_fround(Math_fround(f91 * f90) + Math_fround(Math_fround(f21 * f22) + Math_fround(f94 * f95))));
   f89 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) + Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f94 * f92)) + Math_fround(f90 * f89)));
   HEAPF32[i76 + (i3 << 4) >> 2] = f55;
   HEAPF32[i76 + (i3 << 4) + 4 >> 2] = f95;
   HEAPF32[i76 + (i3 << 4) + 8 >> 2] = f89;
   HEAPF32[i76 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f90 = Math_fround(HEAPF32[i79 >> 2]);
   f92 = Math_fround(HEAPF32[i51 >> 2]);
   f94 = Math_fround(HEAPF32[i52 >> 2]);
   i54 = f90 > Math_fround(0.0);
   i56 = f92 > Math_fround(0.0);
   i2 = f94 > Math_fround(0.0);
   HEAP32[i86 + (i3 << 2) >> 2] = i56 << 31 >> 31 << 1 & 2 | i54 & 1 | i2 << 31 >> 31 << 2 & 4;
   f20 = Math_fround(HEAPF32[i45 >> 2]);
   f21 = Math_fround(HEAPF32[i46 >> 2]);
   f22 = Math_fround(HEAPF32[i47 >> 2]);
   f91 = Math_fround(-f20);
   f93 = Math_fround(-f21);
   f96 = Math_fround(-f22);
   f91 = i54 ? f20 : f91;
   f93 = i56 ? f21 : f93;
   f96 = i2 ? f22 : f96;
   HEAPF32[i77 + (i3 << 4) >> 2] = f91;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f93;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f96;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f91 = Math_fround(f55 - f91);
   f93 = Math_fround(f95 - f93);
   f96 = Math_fround(f89 - f96);
   HEAPF32[i62 >> 2] = f91;
   HEAPF32[i48 >> 2] = f93;
   HEAPF32[i49 >> 2] = f96;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i61 >> 2] | 0;
   i2 = i78 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
   f89 = Math_fround(HEAPF32[i23 >> 2]);
   f95 = Math_fround(HEAPF32[i8 >> 2]);
   f95 = f89 > f95 ? f89 : f95;
   f10 = f10 > f95 ? f10 : f95;
   f95 = Math_fround(f72 + f10);
   f96 = Math_fround(Math_fround(Math_fround(f90 * f91) + Math_fround(f92 * f93)) + Math_fround(f94 * f96));
   i2 = f96 > Math_fround(0.0) ? Math_fround(f96 * f96) > Math_fround(f4 * Math_fround(f95 * f95)) : 0;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f96) | i2) {
    i71 = 9;
    break;
   }
   HEAP32[i61 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i59, i78, i76, i77, i84, i86, i62, i61);
   HEAP32[i53 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i79 >> 2]);
   f6 = Math_fround(HEAPF32[i51 >> 2]);
   f7 = Math_fround(HEAPF32[i52 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i67 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   i1 = f4 > f9;
   if (!(f9 > f57 & i1)) break; else f4 = f9;
  }
  if ((i71 | 0) == 9) {
   if (i85 | 0) {
    HEAP8[i73 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
      HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i87 = 0;
    STACKTOP = i88;
    return i87 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i69, i70, i3);
   f93 = Math_fround(Math_sqrt(Math_fround(f4)));
   f94 = Math_fround(HEAPF32[i79 >> 2]);
   f95 = Math_fround(HEAPF32[i51 >> 2]);
   f96 = Math_fround(Math_fround(1.0) / f93);
   f94 = Math_fround(f94 * f96);
   f95 = Math_fround(f95 * f96);
   f96 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f96);
   f92 = Math_fround(HEAPF32[i69 >> 2]);
   f91 = Math_fround(HEAPF32[i69 + 4 >> 2]);
   f91 = Math_fround(f91 - Math_fround(f74 * f95));
   f90 = Math_fround(Math_fround(HEAPF32[i69 + 8 >> 2]) - Math_fround(f74 * f96));
   HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
   HEAPF32[i80 + 4 >> 2] = f91;
   HEAPF32[i80 + 8 >> 2] = f90;
   HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
   f90 = Math_fround(HEAPF32[i70 >> 2]);
   f91 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f91 = Math_fround(Math_fround(f75 * f95) + f91);
   f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i70 + 8 >> 2]));
   HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
   HEAPF32[i81 + 4 >> 2] = f91;
   HEAPF32[i81 + 8 >> 2] = f92;
   HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
   i87 = i83 + 4 | 0;
   HEAP32[i87 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i87 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i87 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAPF32[i82 >> 2] = f94;
   HEAPF32[i82 + 4 >> 2] = f95;
   HEAPF32[i82 + 8 >> 2] = f96;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   i87 = 1;
   STACKTOP = i88;
   return i87 | 0;
  }
  i2 = HEAP32[i61 >> 2] | 0;
  if (i1) {
   if (!i85) i1 = 6; else break;
   STACKTOP = i88;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i85 | 0) {
   HEAP8[i73 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
     HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i53 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i64, i65, i2);
  HEAP32[i67 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  f93 = Math_fround(Math_sqrt(Math_fround(f4)));
  f94 = Math_fround(HEAPF32[i79 >> 2]);
  f95 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f96 = Math_fround(Math_fround(1.0) / f93);
  f94 = Math_fround(f94 * f96);
  f95 = Math_fround(f95 * f96);
  f96 = Math_fround(Math_fround(HEAPF32[i79 + 8 >> 2]) * f96);
  f92 = Math_fround(HEAPF32[i64 >> 2]);
  f91 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f91 = Math_fround(f91 - Math_fround(f74 * f95));
  f90 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) - Math_fround(f74 * f96));
  HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
  HEAPF32[i80 + 4 >> 2] = f91;
  HEAPF32[i80 + 8 >> 2] = f90;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  f90 = Math_fround(HEAPF32[i65 >> 2]);
  f91 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f91 = Math_fround(Math_fround(f75 * f95) + f91);
  f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i65 + 8 >> 2]));
  HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
  HEAPF32[i81 + 4 >> 2] = f91;
  HEAPF32[i81 + 8 >> 2] = f92;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
  i87 = i83 + 4 | 0;
  HEAP32[i87 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAPF32[i82 >> 2] = f94;
  HEAPF32[i82 + 4 >> 2] = f95;
  HEAPF32[i82 + 8 >> 2] = f96;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  i87 = 3;
  STACKTOP = i88;
  return i87 | 0;
 } while (0);
 HEAP8[i73 >> 0] = i2;
 if (!i2) {
  i87 = 6;
  STACKTOP = i88;
  return i87 | 0;
 } else i1 = 0;
 do {
  HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
  HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i88;
 return i1 | 0;
}

function __ZN12FlareManager12RenderFlaresERK10Matrix4x4f(i2, i27) {
 i2 = i2 | 0;
 i27 = i27 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, i48 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i45 + 752 | 0;
 i12 = i45 + 224 | 0;
 i29 = i45 + 160 | 0;
 i40 = i45 + 148 | 0;
 i41 = i45 + 136 | 0;
 i42 = i45 + 120 | 0;
 i43 = i45 + 108 | 0;
 i31 = i45 + 104 | 0;
 i44 = i45 + 88 | 0;
 i30 = i45 + 132 | 0;
 i37 = i45 + 24 | 0;
 i38 = i45;
 i39 = i2 + 24 | 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali((__Z21GetManagerFromContexti(6) | 0) + 84 | 0, i39, 1);
 i1 = HEAP32[i39 >> 2] | 0;
 if (!i1) {
  STACKTOP = i45;
  return;
 }
 i1 = __ZN8Material9GetShaderEv(i1) | 0;
 if (!i1) {
  STACKTOP = i45;
  return;
 }
 i34 = __ZNK6Shader23GetActiveSubShaderIndexEv(i1) | 0;
 if (!(__ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0)) {
  STACKTOP = i45;
  return;
 }
 if ((HEAP16[gb + 1110788 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i36 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110788 | 0, i36);
  i33 = gb + 1110788 | 0;
 } else i33 = 0;
 i7 = __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
 __Z20InvertMatrix4x4_FullPKfPf(i27, i29) | 0;
 if (!(HEAP8[(__Z17GetRenderSettingsv() | 0) + 312 >> 0] | 0)) f26 = Math_fround(0.0); else f26 = Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 344 >> 2]);
 f25 = Math_fround(Math_fround(HEAPF32[i7 + 920 >> 2]) * Math_fround(2.0));
 __ZN12FlareManager6UpdateEv(i2);
 i8 = i2 + 12 | 0;
 i10 = i2 + 16 | 0;
 if ((HEAP32[i10 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) {
  i35 = __Z12GetGfxDevicev() | 0;
  i4 = i2 + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i11 = 16; else {
   i1 = i4;
   L19 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i7 >>> 0) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L19; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) == (i4 | 0)) i11 = 16; else if (i7 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i11 = 16;
  }
  if ((i11 | 0) == 16) i1 = i4;
  i9 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP32[i40 >> 2] = 0;
  i32 = i40 + 4 | 0;
  i4 = gb + 63160 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i32;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i4;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i28 = i5 - i6 | 0;
  i1 = ((i28 | 0) / 52 | 0) << 2;
  do if (!i28) i1 = 0; else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 376088 | 0, 432) | 0;
    i3 = gb + 64016 | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i40 >> 2] = i1;
    i4 = i32;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i4 + 4 >> 2] = i3;
    i4 = gb + 63160 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = HEAP32[i8 >> 2] | 0;
    break;
   }
  } while (0);
  i19 = i1 + 3 & -4;
  HEAP32[i41 >> 2] = 0;
  i28 = i41 + 4 | 0;
  i24 = i28;
  HEAP32[i24 >> 2] = i3;
  HEAP32[i24 + 4 >> 2] = i4;
  i24 = i5 - i6 | 0;
  i1 = ((i24 | 0) / 52 | 0) << 2;
  do if (!i24) {
   i1 = 0;
   i2 = i6;
  } else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    i2 = i6;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 376088 | 0, 435) | 0;
    i3 = gb + 64016 | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i41 >> 2] = i1;
    i4 = i28;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i4 + 4 >> 2] = i3;
    i4 = gb + 63160 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    break;
   }
  } while (0);
  i23 = i1 + 3 & -4;
  HEAP32[i42 >> 2] = 0;
  i24 = i42 + 4 | 0;
  i22 = i24;
  HEAP32[i22 >> 2] = i3;
  HEAP32[i22 + 4 >> 2] = i4;
  i22 = i5 - i2 | 0;
  i1 = ((i22 | 0) / 52 | 0) << 2;
  do if (!i22) i1 = 0; else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 376088 | 0, 438) | 0;
    i21 = gb + 64016 | 0;
    i20 = HEAP32[i21 >> 2] | 0;
    i21 = HEAP32[i21 + 4 >> 2] | 0;
    HEAP32[i42 >> 2] = i1;
    i22 = i24;
    HEAP32[i22 >> 2] = i20;
    HEAP32[i22 + 4 >> 2] = i21;
    break;
   }
  } while (0);
  i22 = i1 + 3 & -4;
  i20 = __ZNK6Camera16GetStereoEnabledEv(i7) | 0;
  HEAP32[i43 >> 2] = 0;
  i21 = i43 + 4 | 0;
  i18 = gb + 63160 | 0;
  i4 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = i21;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i18 = i2 - i4 | 0;
  i1 = ((i18 | 0) / 52 | 0) << 2;
  do if (!i18) i1 = 0; else {
   i3 = i1 | 3;
   if (i3 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 376088 | 0, 441) | 0;
    i2 = gb + 64016 | 0;
    i18 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    HEAP32[i43 >> 2] = i1;
    i4 = i21;
    HEAP32[i4 >> 2] = i18;
    HEAP32[i4 + 4 >> 2] = i2;
    i4 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    break;
   }
  } while (0);
  i18 = i1 + 3 & -4;
  if ((i4 | 0) != (i2 | 0)) {
   i7 = 0;
   i8 = 0;
   while (1) {
    do if (!(HEAP8[i4 + 49 >> 0] | 0)) {
     i17 = i7;
     i1 = i8;
    } else if (!(Math_fround(HEAPF32[i9 >> 2]) <= Math_fround(0.0))) {
     i5 = i4 + 28 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (!i1) {
      i17 = i7;
      i1 = i8;
     } else {
      HEAP32[i12 >> 2] = i1;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      do if (!i1) i11 = 44; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i36, i1, i12);
        i2 = HEAP32[i36 >> 2] | 0;
        i17 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
        i11 = 44;
        break;
       }
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i11 = 46;
      } while (0);
      if ((i11 | 0) == 44) i11 = 46;
      if ((i11 | 0) == 46) {
       i11 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
       if (!i1) {
        i17 = i7;
        i1 = i8;
        break;
       }
      }
      i6 = i1 + 44 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      if (!i2) {
       i17 = i7;
       i1 = i8;
       break;
      }
      HEAP32[i12 >> 2] = i2;
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
      do if (!i2) i11 = 53; else {
       if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = HEAP32[i2 + 28 >> 2] | 0;
        i5 = HEAP32[i2 + 32 >> 2] | 0;
        i2 = i3 + (i5 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i36, i2, i12);
        i3 = HEAP32[i36 >> 2] | 0;
        i17 = HEAP32[i2 + 28 >> 2] | 0;
        i5 = HEAP32[gb + 1104264 >> 2] | 0;
        i2 = (i3 | 0) == -1 ? i17 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i17 + (i3 << 3) | 0;
        i3 = HEAP32[i5 + 28 >> 2] | 0;
        i5 = HEAP32[i5 + 32 >> 2] | 0;
       }
       if ((i2 | 0) == (i3 + (i5 << 3) | 0)) {
        i11 = 53;
        break;
       }
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i11 = 55;
      } while (0);
      if ((i11 | 0) == 53) i11 = 55;
      if ((i11 | 0) == 55) {
       i11 = 0;
       i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
       if (!i2) {
        i17 = i7;
        i1 = i8;
        break;
       }
      }
      HEAP32[i19 + (i7 << 2) >> 2] = i4;
      HEAP32[i23 + (i7 << 2) >> 2] = i1;
      HEAP32[i22 + (i7 << 2) >> 2] = i2;
      HEAP32[i18 + (i7 << 2) >> 2] = HEAP32[i9 >> 2];
      i1 = i1 + 32 | 0;
      i17 = i7 + 1 | 0;
      i1 = ((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 5) + i8 | 0;
     }
    } else {
     i17 = i7;
     i1 = i8;
    } while (0);
    i4 = i4 + 52 | 0;
    if ((i4 | 0) == (HEAP32[i10 >> 2] | 0)) break; else {
     i7 = i17;
     i8 = i1;
     i9 = i9 + 4 | 0;
    }
   }
   if (i17 | 0) {
    __ZN14BatchAllocatorC2Ev(i12);
    HEAP32[i31 >> 2] = 0;
    __ZN14BatchAllocator16AllocateInternalEPPvijjj(i12, i31, -1, 24, 1, 4);
    HEAP32[i31 >> 2] = 0;
    __ZN14BatchAllocator16AllocateInternalEPPvijjj(i12, 0, 0, 20, i17, 4);
    i15 = i17 << 2;
    __ZN14BatchAllocator16AllocateInternalEPPvijjj(i12, (HEAP32[i31 >> 2] | 0) + 4 | 0, 0, 4, ((i17 * 228 | 0) + (i1 << 5) | 0) >>> 2, 4);
    __ZN14BatchAllocator6CommitERK10MemLabelId(i12, gb + 64024 | 0);
    i16 = HEAP32[i31 >> 2] | 0;
    __ZN17UniqueIDGenerator8CreateIDEv(i36, (__Z12GetGfxDevicev() | 0) + 4448 | 0);
    HEAP32[i16 + 8 >> 2] = HEAP32[i36 >> 2];
    i16 = (i17 | 0) > 0;
    if (i16) {
     i13 = i20 & 1;
     i1 = HEAP32[i31 >> 2] | 0;
     i14 = i1 + 4 | 0;
     i11 = 0;
     i12 = 0;
     while (1) {
      i2 = HEAP32[i19 + (i12 << 2) >> 2] | 0;
      i3 = HEAP32[i23 + (i12 << 2) >> 2] | 0;
      i4 = HEAP32[i22 + (i12 << 2) >> 2] | 0;
      i8 = HEAP32[i1 >> 2] | 0;
      i10 = i3 + 32 | 0;
      i9 = i3 + 36 | 0;
      HEAP32[i8 + (i12 * 20 | 0) + 8 >> 2] = (HEAP32[i9 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) >> 3;
      HEAP32[i8 + (i12 * 20 | 0) + 12 >> 2] = 0;
      HEAP32[i8 + (i12 * 20 | 0) + 16 >> 2] = 24;
      i8 = (i12 * 224 | 0) + i15 + (i11 << 5) | 0;
      i5 = HEAP32[i14 >> 2] | 0;
      HEAP32[i5 + (i12 << 2) >> 2] = i8;
      i8 = i5 + i8 | 0;
      HEAP32[i8 + 184 >> 2] = (HEAP32[i9 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) >> 5;
      i5 = i8;
      i6 = i27;
      i7 = i5 + 64 | 0;
      do {
       HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
       i5 = i5 + 4 | 0;
       i6 = i6 + 4 | 0;
      } while ((i5 | 0) < (i7 | 0));
      i5 = i8 + 64 | 0;
      i6 = i29;
      i7 = i5 + 64 | 0;
      do {
       HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
       i5 = i5 + 4 | 0;
       i6 = i6 + 4 | 0;
      } while ((i5 | 0) < (i7 | 0));
      f47 = Math_fround(HEAPF32[i2 + 40 >> 2]);
      HEAPF32[i8 + 128 >> 2] = Math_fround(f47 * Math_fround(HEAPF32[i18 + (i12 << 2) >> 2]));
      i7 = i8 + 132 | 0;
      i48 = HEAP32[i2 + 4 >> 2] | 0;
      i5 = HEAP32[i2 + 8 >> 2] | 0;
      i6 = HEAP32[i2 + 12 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i7 + 4 >> 2] = i48;
      HEAP32[i7 + 8 >> 2] = i5;
      HEAP32[i7 + 12 >> 2] = i6;
      HEAP32[i8 + 148 >> 2] = HEAP32[i3 + 48 >> 2];
      HEAPF32[i8 + 152 >> 2] = f26;
      HEAPF32[i8 + 156 >> 2] = f25;
      HEAP8[i8 + 160 >> 0] = HEAP8[i2 + 48 >> 0] | 0;
      HEAP8[i8 + 161 >> 0] = HEAP8[i3 + 52 >> 0] | 0;
      i3 = i8 + 164 | 0;
      i2 = i2 + 16 | 0;
      HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      HEAP8[i8 + 188 >> 0] = i13;
      i3 = i8 + 176 | 0;
      f47 = Math_fround(Math_fround(HEAPF32[i4 + 68 >> 2]) * Math_fround(.5));
      f46 = Math_fround(Math_fround(HEAPF32[i4 + 72 >> 2]) * Math_fround(.5));
      HEAPF32[i3 >> 2] = f47;
      HEAPF32[i3 + 4 >> 2] = f46;
      i3 = HEAP32[i9 >> 2] | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) {
       i5 = i8 + 192 | 0;
       i4 = 0;
       while (1) {
        i7 = i5 + (i4 << 5) | 0;
        HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        i7 = HEAP32[i2 + 16 >> 2] | 0;
        i8 = HEAP32[i2 + 20 >> 2] | 0;
        i48 = HEAP32[i2 + 24 >> 2] | 0;
        HEAP32[i5 + (i4 << 5) + 12 >> 2] = HEAP32[i2 + 12 >> 2];
        HEAP32[i5 + (i4 << 5) + 16 >> 2] = i7;
        HEAP32[i5 + (i4 << 5) + 20 >> 2] = i8;
        HEAP32[i5 + (i4 << 5) + 24 >> 2] = i48;
        HEAP32[i5 + (i4 << 5) + 28 >> 2] = HEAP32[i2 + 28 >> 2];
        i2 = i2 + 32 | 0;
        if ((i2 | 0) == (i3 | 0)) break; else i4 = i4 + 1 | 0;
       }
       i3 = HEAP32[i9 >> 2] | 0;
       i2 = HEAP32[i10 >> 2] | 0;
      }
      i12 = i12 + 1 | 0;
      if ((i12 | 0) == (i17 | 0)) break; else i11 = (i3 - i2 >> 5) + i11 | 0;
     }
    } else i1 = HEAP32[i31 >> 2] | 0;
    HEAP32[i44 >> 2] = 0;
    HEAP32[i44 + 4 >> 2] = 0;
    HEAP32[i44 + 8 >> 2] = -1;
    HEAP32[i44 + 12 >> 2] = 0;
    i6 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i35 >> 2] | 0) + 252 >> 2] | 0, i35 | 0, fb + 2376 | 0, fb + 3324 | 0, i1 | 0, i17 | 0, 2, i44 | 0);
    HEAP32[i31 >> 2] = 0;
    i5 = HEAP32[(HEAP32[i35 >> 2] | 0) + 256 >> 2] | 0;
    HEAP32[i30 >> 2] = i6;
    HEAP32[i36 >> 2] = HEAP32[i30 >> 2];
    mftCall_vii(i5 | 0, i35 | 0, i36 | 0);
    i5 = i36;
    i6 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 132 >> 2] | 0, i35 | 0) | 0;
    i7 = i5 + 64 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
     i5 = i5 + 4 | 0;
     i6 = i6 + 4 | 0;
    } while ((i5 | 0) < (i7 | 0));
    i5 = i37;
    i6 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 128 >> 2] | 0, i35 | 0) | 0;
    i7 = i5 + 64 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
     i5 = i5 + 4 | 0;
     i6 = i6 + 4 | 0;
    } while ((i5 | 0) < (i7 | 0));
    if (!i20) mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 112 >> 2] | 0, i35 | 0, gb + 1162292 | 0);
    mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 108 >> 2] | 0, i35 | 0, gb + 1162292 | 0);
    i13 = HEAP32[gb + 1166248 >> 2] | 0;
    if (i16) {
     i7 = i13 + 36 | 0;
     i8 = i38 + 4 | 0;
     i9 = i38 + 8 | 0;
     i10 = i38 + 12 | 0;
     i11 = i38 + 16 | 0;
     i6 = 0;
     i4 = 0;
     i1 = 0;
     i2 = 0;
     i3 = 0;
     do {
      i12 = HEAP32[i23 + (i6 << 2) >> 2] | 0;
      i5 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
      i12 = (HEAP32[i12 + 36 >> 2] | 0) - (HEAP32[i12 + 32 >> 2] | 0) >> 3;
      if ((i3 | 0) != (i5 | 0)) {
       if (i4) {
        HEAP32[i38 >> 2] = 24;
        HEAP32[i8 >> 2] = i1;
        HEAP32[i9 >> 2] = i4;
        HEAP32[i10 >> 2] = 0;
        HEAP32[i11 >> 2] = (i4 >>> 2) * 6;
        i30 = __ZN9GfxDevice13GetDynamicVBOEv(i35) | 0;
        i29 = HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] | 0;
        i48 = HEAP32[gb + 1110828 + 4 >> 2] | 0;
        i31 = HEAP32[i48 + 4 >> 2] | 0;
        mftCall_viiiiiii(i29 | 0, i30 | 0, i44 | 0, i2 | 0, i31 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i48, HEAP32[i2 >> 2] | 0, 0) | 0, i38 | 0, 1);
        __Z15gpu_time_samplev();
        i1 = (i4 * 24 | 0) + i1 | 0;
       }
       __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i7, gb + 1110824 | 0, i5);
       i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[i39 >> 2] | 0, 0, i13, i34, 1) | 0;
       i3 = i5;
       i4 = 0;
      }
      i4 = i4 + i12 | 0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i17 | 0));
     if (i4 | 0) {
      HEAP32[i38 >> 2] = 24;
      HEAP32[i38 + 4 >> 2] = i1;
      HEAP32[i38 + 8 >> 2] = i4;
      HEAP32[i38 + 12 >> 2] = 0;
      HEAP32[i38 + 16 >> 2] = (i4 >>> 2) * 6;
      i34 = __ZN9GfxDevice13GetDynamicVBOEv(i35) | 0;
      i31 = HEAP32[(HEAP32[i34 >> 2] | 0) + 16 >> 2] | 0;
      i48 = HEAP32[gb + 1110828 + 4 >> 2] | 0;
      i39 = HEAP32[i48 + 4 >> 2] | 0;
      mftCall_viiiiiii(i31 | 0, i34 | 0, i44 | 0, i2 | 0, i39 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i48, HEAP32[i2 >> 2] | 0, 0) | 0, i38 | 0, 1);
      __Z15gpu_time_samplev();
     }
    }
    if (!i20) mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 112 >> 2] | 0, i35 | 0, i36 | 0);
    mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 108 >> 2] | 0, i35 | 0, i37 | 0);
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 >> 2] | 0, i21);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i24);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i28);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i40 >> 2] | 0, i32);
 }
 if (!i33) {
  STACKTOP = i45;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i33);
 STACKTOP = i45;
 return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i63, i64, i1, i65, i66, i60, i68, i49, i51, i43, i67) {
 i63 = i63 | 0;
 i64 = i64 | 0;
 i1 = i1 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 i60 = i60 | 0;
 i68 = i68 | 0;
 i49 = i49 | 0;
 i51 = i51 | 0;
 i43 = i43 | 0;
 i67 = i67 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, f61 = f0, f62 = f0, i69 = 0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i69 + 460 | 0;
 i40 = i69 + 448 | 0;
 i59 = i69 + 128 | 0;
 i58 = i69 + 272 | 0;
 i56 = i69 + 208 | 0;
 i57 = i69 + 144 | 0;
 i48 = i69 + 432 | 0;
 i50 = i69 + 416 | 0;
 i39 = i69 + 112 | 0;
 i38 = i69 + 408 | 0;
 i14 = i69 + 96 | 0;
 i15 = i69 + 396 | 0;
 i16 = i69 + 80 | 0;
 i52 = i69 + 64 | 0;
 i55 = i69 + 48 | 0;
 i53 = i69 + 384 | 0;
 i54 = i69 + 372 | 0;
 i37 = i69 + 32 | 0;
 i36 = i69 + 360 | 0;
 i44 = i69 + 16 | 0;
 i47 = i69;
 i46 = i69 + 348 | 0;
 i45 = i69 + 336 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f61 = Math_fround(HEAPF32[i63 + 16 >> 2]);
 i35 = i64 + 16 | 0;
 f62 = Math_fround(HEAPF32[i35 >> 2]);
 f12 = Math_fround(HEAPF32[i63 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i64 + 32 >> 2]);
 f12 = Math_fround((f12 > f3 ? f3 : f12) * Math_fround(.100000001));
 f12 = Math_fround(f12 * f12);
 f3 = Math_fround(f61 + f62);
 i32 = i39 + 4 | 0;
 i33 = i39 + 8 | 0;
 i34 = i39 + 12 | 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 HEAP32[i39 + 12 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 i1 = HEAP8[i43 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f30 = Math_fround(HEAPF32[i63 >> 2]);
  f4 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i63 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i64 >> 2]);
  f6 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f5 = Math_fround(f30 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i64 + 8 >> 2]));
  i31 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i31 ? f5 : Math_fround(1.0);
  f6 = i31 ? f6 : Math_fround(0.0);
  f7 = i31 ? f7 : Math_fround(0.0);
  HEAPF32[i59 >> 2] = f5;
  HEAPF32[i59 + 4 >> 2] = f6;
  HEAPF32[i59 + 8 >> 2] = f7;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i16 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
  i31 = i59;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i42 = 6;
 } else {
  f4 = Math_fround(HEAPF32[i64 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i64 + 148 >> 2]);
  f4 = Math_fround(f4 - f62);
  f5 = Math_fround(f5 - f62);
  f6 = Math_fround(Math_fround(HEAPF32[i64 + 152 >> 2]) - f62);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f9 = Math_fround(-f6);
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i31 = HEAPU8[i49 + i11 >> 0] | 0;
   HEAP32[i48 + (i11 << 2) >> 2] = i31;
   i29 = HEAPU8[i51 + i11 >> 0] | 0;
   HEAP32[i50 + (i11 << 2) >> 2] = i29;
   f74 = Math_fround(HEAPF32[i63 + 96 + (i31 << 4) >> 2]);
   f73 = Math_fround(HEAPF32[i63 + 96 + (i31 << 4) + 4 >> 2]);
   f72 = Math_fround(HEAPF32[i63 + 96 + (i31 << 4) + 8 >> 2]);
   i31 = HEAP32[i63 + 96 + (i31 << 4) + 12 >> 2] | 0;
   f71 = HEAP32[gb + 48 + (i29 << 4) >> 2] | 0 ? f4 : f7;
   f70 = HEAP32[gb + 48 + (i29 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f30 = HEAP32[gb + 48 + (i29 << 4) + 8 >> 2] | 0 ? f6 : f9;
   f76 = Math_fround(f73 - f70);
   f75 = Math_fround(f72 - f30);
   HEAPF32[i39 >> 2] = Math_fround(f74 - f71);
   HEAPF32[i32 >> 2] = f76;
   HEAPF32[i33 >> 2] = f75;
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   HEAPF32[i56 + (i2 << 4) >> 2] = f74;
   HEAPF32[i56 + (i2 << 4) + 4 >> 2] = f73;
   HEAPF32[i56 + (i2 << 4) + 8 >> 2] = f72;
   HEAP32[i56 + (i2 << 4) + 12 >> 2] = i31;
   HEAPF32[i57 + (i2 << 4) >> 2] = f71;
   HEAPF32[i57 + (i2 << 4) + 4 >> 2] = f70;
   HEAPF32[i57 + (i2 << 4) + 8 >> 2] = f30;
   HEAPF32[i57 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   i31 = i58 + (i2 << 4) | 0;
   HEAP32[i31 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i38 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i14, i58, i56, i57, i48, i50, i39, i38);
  HEAP32[i59 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i59 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i59 >> 2]);
  f6 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i59 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i41 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
  if (f4 > f12) {
   i31 = i59;
   i42 = 6;
  }
 }
 do if ((i42 | 0) == 6) {
  i2 = i59 + 4 | 0;
  i14 = i59 + 8 | 0;
  i15 = i63 + 96 | 0;
  i17 = i63 + 100 | 0;
  i18 = i63 + 104 | 0;
  i19 = i63 + 112 | 0;
  i20 = i63 + 116 | 0;
  i21 = i63 + 120 | 0;
  i22 = i63 + 128 | 0;
  i23 = i63 + 132 | 0;
  i24 = i63 + 136 | 0;
  i25 = i64 + 144 | 0;
  i26 = i64 + 148 | 0;
  i27 = i64 + 152 | 0;
  i28 = i63 + 48 | 0;
  i29 = i64 + 48 | 0;
  f8 = f10;
  f30 = f4;
  while (1) {
   HEAP32[i40 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
   f81 = Math_fround(-f5);
   f80 = Math_fround(-f6);
   f4 = Math_fround(-f7);
   i11 = HEAP32[i38 >> 2] | 0;
   f76 = Math_fround(HEAPF32[i15 >> 2]);
   f70 = Math_fround(HEAPF32[i17 >> 2]);
   f10 = Math_fround(HEAPF32[i18 >> 2]);
   f74 = Math_fround(HEAPF32[i19 >> 2]);
   f73 = Math_fround(HEAPF32[i20 >> 2]);
   f9 = Math_fround(HEAPF32[i21 >> 2]);
   f71 = Math_fround(HEAPF32[i22 >> 2]);
   f72 = Math_fround(HEAPF32[i23 >> 2]);
   f75 = Math_fround(HEAPF32[i24 >> 2]);
   f79 = Math_fround(Math_fround(Math_fround(f76 * f81) + Math_fround(f70 * f80)) + Math_fround(f10 * f4));
   f78 = Math_fround(Math_fround(Math_fround(f74 * f81) + Math_fround(f73 * f80)) + Math_fround(f9 * f4));
   f4 = Math_fround(Math_fround(Math_fround(f71 * f81) + Math_fround(f72 * f80)) + Math_fround(f75 * f4));
   i13 = f79 > f78 & f79 > f4;
   i77 = f78 > f4;
   HEAP32[i48 + (i11 << 2) >> 2] = i13 ? 0 : i77 ? 1 : 2;
   f71 = i13 ? f76 : i77 ? f74 : f71;
   f72 = i13 ? f70 : i77 ? f73 : f72;
   f75 = i13 ? f10 : i77 ? f9 : f75;
   HEAPF32[i56 + (i11 << 4) >> 2] = f71;
   HEAPF32[i56 + (i11 << 4) + 4 >> 2] = f72;
   HEAPF32[i56 + (i11 << 4) + 8 >> 2] = f75;
   HEAPF32[i56 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   f9 = Math_fround(HEAPF32[i25 >> 2]);
   f10 = Math_fround(HEAPF32[i26 >> 2]);
   f73 = Math_fround(HEAPF32[i27 >> 2]);
   f70 = Math_fround(HEAPF32[i35 >> 2]);
   f9 = Math_fround(f9 - f70);
   f10 = Math_fround(f10 - f70);
   f70 = Math_fround(f73 - f70);
   i77 = f5 > Math_fround(0.0);
   i13 = f6 > Math_fround(0.0);
   i1 = f7 > Math_fround(0.0);
   HEAP32[i50 + (i11 << 2) >> 2] = i13 << 31 >> 31 << 1 & 2 | i77 & 1 | i1 << 31 >> 31 << 2 & 4;
   f73 = Math_fround(-f9);
   f74 = Math_fround(-f10);
   f76 = Math_fround(-f70);
   f73 = i77 ? f9 : f73;
   f74 = i13 ? f10 : f74;
   f76 = i1 ? f70 : f76;
   HEAPF32[i57 + (i11 << 4) >> 2] = f73;
   HEAPF32[i57 + (i11 << 4) + 4 >> 2] = f74;
   HEAPF32[i57 + (i11 << 4) + 8 >> 2] = f76;
   HEAPF32[i57 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   f73 = Math_fround(f71 - f73);
   f74 = Math_fround(f72 - f74);
   f76 = Math_fround(f75 - f76);
   HEAPF32[i39 >> 2] = f73;
   HEAPF32[i32 >> 2] = f74;
   HEAPF32[i33 >> 2] = f76;
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   i11 = i58 + (i11 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i28 >> 2]);
   f75 = Math_fround(HEAPF32[i29 >> 2]);
   f75 = f5 > f75 ? f5 : f75;
   f8 = f8 > f75 ? f8 : f75;
   f75 = Math_fround(f3 + f8);
   f75 = Math_fround(f30 * Math_fround(f75 * f75));
   f5 = Math_fround(HEAPF32[i59 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f76 = Math_fround(Math_fround(Math_fround(f5 * f73) + Math_fround(f6 * f74)) + Math_fround(f7 * f76));
   i11 = f76 > Math_fround(0.0) & Math_fround(f76 * f76) > f75;
   i1 = Math_fround(f30 * Math_fround(.00039999999)) >= Math_fround(f30 - f76) | i11;
   i13 = HEAP32[i38 >> 2] | 0;
   if (i1) {
    f4 = f30;
    i42 = 8;
    break;
   }
   HEAP32[i38 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i37, i58, i56, i57, i48, i50, i39, i38);
   HEAP32[i31 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i59 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i41 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i41 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i41 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   i1 = f30 > f4;
   if (!(f4 > f12 & i1)) break; else f30 = f4;
  }
  if ((i42 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i49 | 0) {
    HEAP8[i43 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
      HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i77 = 0;
    STACKTOP = i69;
    return i77 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f4)));
   f4 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f5 * f4);
   f8 = Math_fround(f6 * f4);
   f7 = Math_fround(f7 * f4);
   HEAPF32[i60 >> 2] = f9;
   HEAPF32[i60 + 4 >> 2] = f8;
   HEAPF32[i60 + 8 >> 2] = f7;
   HEAPF32[i60 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i58, i56, i57, i59, i52, i55, i13);
   f5 = Math_fround(HEAPF32[i52 >> 2]);
   f6 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i52 + 8 >> 2]);
   if (i67) {
    f80 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
    f76 = HEAP32[i64 + 64 >> 2] | 0 ? Math_fround(0.0) : f62;
    f81 = Math_fround(f80 + f76);
    f79 = Math_fround(f6 - Math_fround(f8 * f80));
    f78 = Math_fround(f4 - Math_fround(f7 * f80));
    HEAPF32[i65 >> 2] = Math_fround(f5 - Math_fround(f9 * f80));
    HEAPF32[i65 + 4 >> 2] = f79;
    HEAPF32[i65 + 8 >> 2] = f78;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    f78 = Math_fround(HEAPF32[i55 >> 2]);
    f79 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f79 = Math_fround(Math_fround(f8 * f76) + f79);
    f80 = Math_fround(Math_fround(f7 * f76) + Math_fround(HEAPF32[i55 + 8 >> 2]));
    HEAPF32[i66 >> 2] = Math_fround(Math_fround(f9 * f76) + f78);
    HEAPF32[i66 + 4 >> 2] = f79;
    HEAPF32[i66 + 8 >> 2] = f80;
    HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i68 >> 2] = Math_fround(f10 - f81);
    i77 = i68 + 4 | 0;
    HEAP32[i77 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i77 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
    HEAP32[i77 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
    i77 = 1;
    STACKTOP = i69;
    return i77 | 0;
   } else {
    f80 = Math_fround(f6 - Math_fround(f61 * f8));
    f79 = Math_fround(f4 - Math_fround(f61 * f7));
    HEAPF32[i65 >> 2] = Math_fround(f5 - Math_fround(f61 * f9));
    HEAPF32[i65 + 4 >> 2] = f80;
    HEAPF32[i65 + 8 >> 2] = f79;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    f79 = Math_fround(HEAPF32[i55 >> 2]);
    f80 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f80 = Math_fround(Math_fround(f62 * f8) + f80);
    f81 = Math_fround(Math_fround(f62 * f7) + Math_fround(HEAPF32[i55 + 8 >> 2]));
    HEAPF32[i66 >> 2] = Math_fround(Math_fround(f62 * f9) + f79);
    HEAPF32[i66 + 4 >> 2] = f80;
    HEAPF32[i66 + 8 >> 2] = f81;
    HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i68 >> 2] = Math_fround(f10 - f3);
    i77 = i68 + 4 | 0;
    HEAP32[i77 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i77 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
    HEAP32[i77 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
    i77 = 1;
    STACKTOP = i69;
    return i77 | 0;
   }
  }
  if (i1) {
   if (!i49) i1 = 6; else break;
   STACKTOP = i69;
   return i1 | 0;
  };
  HEAP32[i41 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  i11 = HEAP32[i38 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i49 | 0) {
   HEAP8[i43 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
     HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i31 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i58, i56, i57, i59, i44, i47, i11);
  HEAP32[i41 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f30)));
  f9 = Math_fround(HEAPF32[i59 >> 2]);
  f10 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i59 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i44 >> 2]);
  f6 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  if (i67) {
   f81 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
   f78 = HEAP32[i64 + 64 >> 2] | 0 ? Math_fround(0.0) : f62;
   f3 = Math_fround(f81 + f78);
   f80 = Math_fround(f6 - Math_fround(f10 * f81));
   f79 = Math_fround(f4 - Math_fround(f7 * f81));
   HEAPF32[i65 >> 2] = Math_fround(f5 - Math_fround(f9 * f81));
   HEAPF32[i65 + 4 >> 2] = f80;
   HEAPF32[i65 + 8 >> 2] = f79;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   f79 = Math_fround(HEAPF32[i47 >> 2]);
   f80 = Math_fround(HEAPF32[i47 + 4 >> 2]);
   f80 = Math_fround(Math_fround(f10 * f78) + f80);
   f81 = Math_fround(Math_fround(f7 * f78) + Math_fround(HEAPF32[i47 + 8 >> 2]));
   HEAPF32[i66 >> 2] = Math_fround(Math_fround(f9 * f78) + f79);
   HEAPF32[i66 + 4 >> 2] = f80;
   HEAPF32[i66 + 8 >> 2] = f81;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   i77 = i68 + 4 | 0;
   HEAP32[i77 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i77 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i77 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  } else {
   f80 = Math_fround(f6 - Math_fround(f61 * f10));
   f79 = Math_fround(f4 - Math_fround(f61 * f7));
   HEAPF32[i65 >> 2] = Math_fround(f5 - Math_fround(f61 * f9));
   HEAPF32[i65 + 4 >> 2] = f80;
   HEAPF32[i65 + 8 >> 2] = f79;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   f79 = Math_fround(HEAPF32[i47 >> 2]);
   f80 = Math_fround(HEAPF32[i47 + 4 >> 2]);
   f80 = Math_fround(Math_fround(f62 * f10) + f80);
   f81 = Math_fround(Math_fround(f62 * f7) + Math_fround(HEAPF32[i47 + 8 >> 2]));
   HEAPF32[i66 >> 2] = Math_fround(Math_fround(f62 * f9) + f79);
   HEAPF32[i66 + 4 >> 2] = f80;
   HEAPF32[i66 + 8 >> 2] = f81;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   i77 = i68 + 4 | 0;
   HEAP32[i77 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i77 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i77 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  }
  HEAPF32[i68 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i60 >> 2] = f9;
  HEAPF32[i60 + 4 >> 2] = f10;
  HEAPF32[i60 + 8 >> 2] = f7;
  HEAPF32[i60 + 12 >> 2] = Math_fround(0.0);
  i77 = f12 >= f30 ? 1 : 3;
  STACKTOP = i69;
  return i77 | 0;
 } while (0);
 i2 = HEAP32[i38 >> 2] | 0;
 HEAP8[i43 >> 0] = i2;
 if (!i2) {
  i77 = 6;
  STACKTOP = i69;
  return i77 | 0;
 } else i1 = 0;
 do {
  HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
  HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i69;
 return i1 | 0;
}

function __ZN20TextRenderingPrivate12GetFallbacksEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i10 = i11;
 i2 = HEAP32[gb + 1467880 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
  i10 = i2;
  STACKTOP = i11;
  return i10 | 0;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 11 | 0;
 HEAP8[i4 >> 0] = 5;
 HEAP8[i10 >> 0] = HEAP8[gb + 945483 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[gb + 945483 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[gb + 945483 + 2 >> 0] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[gb + 945483 + 3 >> 0] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[gb + 945483 + 4 >> 0] | 0;
 HEAP8[i10 + 5 >> 0] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i2, i10); else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i1 + 11 >> 0] = 5;
  HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[i10 + 3 >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[i10 + 4 >> 0] | 0;
  HEAP8[i1 + 5 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i3 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = -2147483616;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 16;
 i5 = i1;
 i6 = gb + 945489 | 0;
 i7 = i5 + 16 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 16 >> 0] = 0;
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i10);
  i1 = i10 + 11 | 0;
 } else {
  i1 = i10 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
  i4 = i7 ? HEAP32[i4 >> 2] | 0 : i3 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i8 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i4;
   if (i4) i8 = 13;
  } else i8 = 11;
  if ((i8 | 0) == 11) {
   i12 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i3;
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i2 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i7;
   i8 = 13;
  }
  if ((i8 | 0) == 13) _memcpy(i2 | 0, i5 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i3 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = -2147483632;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 14;
 i5 = i1;
 i6 = gb + 945506 | 0;
 i7 = i5 + 14 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 14 >> 0] = 0;
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i10);
  i1 = i10 + 11 | 0;
 } else {
  i1 = i10 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i12 = i3 << 24 >> 24 < 0;
  i5 = i12 ? HEAP32[i10 >> 2] | 0 : i10;
  i4 = i12 ? HEAP32[i4 >> 2] | 0 : i3 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i8 = 22;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i4;
   if (i4) i8 = 24;
  } else i8 = 22;
  if ((i8 | 0) == 22) {
   i7 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i3;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i2 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i12;
   i8 = 24;
  }
  if ((i8 | 0) == 24) _memcpy(i2 | 0, i5 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i2 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i3;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i3;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 8 >> 2] = -2147483616;
 HEAP32[i10 + 4 >> 2] = 20;
 i5 = i3;
 i6 = gb + 945521 | 0;
 i7 = i5 + 20 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i3 + 20 >> 0] = 0;
 i4 = i2 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i2, i10); else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = -2147483616;
  HEAP32[i1 + 4 >> 2] = 20;
  i5 = i2;
  i6 = i3;
  i7 = i5 + 20 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP8[i2 + 20 >> 0] = 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 16;
 }
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i3 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = -2147483632;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 15;
 i5 = i1;
 i6 = gb + 945542 | 0;
 i7 = i5 + 15 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 15 >> 0] = 0;
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i10);
  i1 = i10 + 11 | 0;
 } else {
  i1 = i10 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i12 = i3 << 24 >> 24 < 0;
  i5 = i12 ? HEAP32[i10 >> 2] | 0 : i10;
  i4 = i12 ? HEAP32[i4 >> 2] | 0 : i3 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i8 = 38;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i4;
   if (i4) i8 = 40;
  } else i8 = 38;
  if ((i8 | 0) == 38) {
   i7 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i3;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i2 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i12;
   i8 = 40;
  }
  if ((i8 | 0) == 40) _memcpy(i2 | 0, i5 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i10 + 11 | 0;
 HEAP8[i2 >> 0] = 5;
 HEAP8[i10 >> 0] = HEAP8[gb + 945558 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[gb + 945558 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[gb + 945558 + 2 >> 0] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[gb + 945558 + 3 >> 0] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[gb + 945558 + 4 >> 0] | 0;
 HEAP8[i10 + 5 >> 0] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i10); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i4 + 11 >> 0] = 5;
  HEAP8[i4 >> 0] = HEAP8[i10 >> 0] | 0;
  HEAP8[i4 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
  HEAP8[i4 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
  HEAP8[i4 + 3 >> 0] = HEAP8[i10 + 3 >> 0] | 0;
  HEAP8[i4 + 4 >> 0] = HEAP8[i10 + 4 >> 0] | 0;
  HEAP8[i4 + 5 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i3 = HEAP32[gb + 1467880 >> 2] | 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = -2147483632;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 13;
 i5 = i1;
 i6 = gb + 945564 | 0;
 i7 = i5 + 13 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 13 >> 0] = 0;
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i10);
  i1 = i10 + 11 | 0;
 } else {
  i1 = i10 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i12 = i3 << 24 >> 24 < 0;
  i5 = i12 ? HEAP32[i10 >> 2] | 0 : i10;
  i4 = i12 ? HEAP32[i4 >> 2] | 0 : i3 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i8 = 54;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i4;
   if (i4) i8 = 56;
  } else i8 = 54;
  if ((i8 | 0) == 54) {
   i7 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i3;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i2 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i12;
   i8 = 56;
  }
  if ((i8 | 0) == 56) _memcpy(i2 | 0, i5 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i10 + 11 | 0;
 HEAP8[i2 >> 0] = 9;
 i5 = i10;
 i6 = gb + 945578 | 0;
 i7 = i5 + 9 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i10 + 9 >> 0] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i10); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i4 + 11 >> 0] = 9;
  i5 = i4;
  i6 = i10;
  i7 = i5 + 9 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP8[i4 + 9 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i10 + 11 | 0;
 HEAP8[i2 >> 0] = 10;
 i5 = i10;
 i6 = gb + 945588 | 0;
 i7 = i5 + 10 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i10 + 10 >> 0] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i10); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i4 + 11 >> 0] = 10;
  i5 = i4;
  i6 = i10;
  i7 = i5 + 10 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP8[i4 + 10 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = HEAP32[gb + 1467880 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i10 + 11 | 0;
 HEAP8[i2 >> 0] = 10;
 i5 = i10;
 i6 = gb + 945599 | 0;
 i7 = i5 + 10 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i6 = i6 + 1 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i10 + 10 >> 0] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i10); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i4 + 11 >> 0] = 10;
  i5 = i4;
  i6 = i10;
  i7 = i5 + 10 | 0;
  do {
   HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAP8[i4 + 10 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i12 = HEAP32[gb + 1467880 >> 2] | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj(i2, i15, i16, i19, i1, i20, i17) {
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i18 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, i39 = 0, f40 = f0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, f56 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21;
 i11 = HEAP32[i19 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = i11;
 f14 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(100.0));
 i2 = HEAP32[i2 + 908 >> 2] | 0;
 if (!(HEAP8[i2 + 4 >> 0] | 0)) i13 = 2; else if (!(HEAP8[i2 + 285 >> 0] | 0)) {
  i10 = i11 >>> 0 > i1 >>> 0;
  if (i10) {
   i3 = HEAP32[i19 + 540 >> 2] | 0;
   i4 = HEAP32[i19 + 520 >> 2] | 0;
   i2 = i1;
   do {
    i8 = i3 + (i2 << 2) | 0;
    f28 = Math_fround(HEAPF32[i8 >> 2]);
    f27 = Math_fround(HEAPF32[i8 + 4 >> 2]);
    f26 = Math_fround(HEAPF32[i8 + 8 >> 2]);
    f22 = Math_fround(HEAPF32[i8 + 12 >> 2]);
    i8 = i4 + (i2 << 2) | 0;
    f25 = Math_fround(HEAPF32[i8 >> 2]);
    i9 = i8 + 4 | 0;
    f24 = Math_fround(HEAPF32[i9 >> 2]);
    i12 = i8 + 8 | 0;
    f23 = Math_fround(HEAPF32[i12 >> 2]);
    i13 = i8 + 12 | 0;
    f25 = Math_fround(Math_fround(f14 * f28) + f25);
    f24 = Math_fround(Math_fround(f14 * f27) + f24);
    f23 = Math_fround(Math_fround(f14 * f26) + f23);
    f22 = Math_fround(Math_fround(f14 * f22) + Math_fround(HEAPF32[i13 >> 2]));
    i7 = f25 < Math_fround(100.000008);
    f25 = i7 ? f25 : Math_fround(100.000008);
    i7 = f24 < Math_fround(100.000008);
    f24 = i7 ? f24 : Math_fround(100.000008);
    i7 = f23 < Math_fround(100.000008);
    f23 = i7 ? f23 : Math_fround(100.000008);
    i7 = f22 < Math_fround(100.000008);
    f22 = i7 ? f22 : Math_fround(100.000008);
    HEAPF32[i8 >> 2] = f25;
    HEAPF32[i9 >> 2] = f24;
    HEAPF32[i12 >> 2] = f23;
    HEAPF32[i13 >> 2] = f22;
    i2 = i2 + 4 | 0;
   } while (i2 >>> 0 < i11 >>> 0);
   if (i10) {
    i3 = HEAP32[i19 + 520 >> 2] | 0;
    i4 = HEAP32[i19 + 60 >> 2] | 0;
    i5 = HEAP32[i19 + 80 >> 2] | 0;
    i6 = HEAP32[i19 + 100 >> 2] | 0;
    i7 = HEAP32[i19 + 120 >> 2] | 0;
    i8 = HEAP32[i19 + 140 >> 2] | 0;
    i9 = HEAP32[i19 + 160 >> 2] | 0;
    i2 = i1;
    do {
     if (Math_fround(HEAPF32[i3 + (i2 << 2) >> 2]) > Math_fround(100.0)) {
      HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 >> 2];
      HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
      HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
      HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 >> 2];
      HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
      HEAP32[i9 + (i2 << 2) >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i11 >>> 0);
    if (i10) {
     i4 = HEAP32[i19 + 60 >> 2] | 0;
     i5 = HEAP32[i19 + 80 >> 2] | 0;
     i6 = HEAP32[i19 + 100 >> 2] | 0;
     i7 = HEAP32[i19 + 120 >> 2] | 0;
     i8 = HEAP32[i19 + 140 >> 2] | 0;
     i9 = HEAP32[i19 + 160 >> 2] | 0;
     i10 = HEAP32[i19 >> 2] | 0;
     i11 = HEAP32[i19 + 20 >> 2] | 0;
     i3 = HEAP32[i19 + 40 >> 2] | 0;
     i2 = i1;
     do {
      i41 = i4 + (i2 << 2) | 0;
      f27 = Math_fround(HEAPF32[i41 >> 2]);
      f26 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f25 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f24 = Math_fround(HEAPF32[i41 + 12 >> 2]);
      i41 = i5 + (i2 << 2) | 0;
      f23 = Math_fround(HEAPF32[i41 >> 2]);
      f22 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f14 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f36 = Math_fround(HEAPF32[i41 + 12 >> 2]);
      i41 = i6 + (i2 << 2) | 0;
      f38 = Math_fround(HEAPF32[i41 >> 2]);
      f40 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f42 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f28 = Math_fround(HEAPF32[i41 + 12 >> 2]);
      i41 = i7 + (i2 << 2) | 0;
      f43 = Math_fround(HEAPF32[i41 >> 2]);
      f53 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f52 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f51 = Math_fround(HEAPF32[i41 + 12 >> 2]);
      i41 = i8 + (i2 << 2) | 0;
      f50 = Math_fround(HEAPF32[i41 >> 2]);
      f49 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f48 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f47 = Math_fround(HEAPF32[i41 + 12 >> 2]);
      i41 = i9 + (i2 << 2) | 0;
      f46 = Math_fround(HEAPF32[i41 >> 2]);
      f45 = Math_fround(HEAPF32[i41 + 4 >> 2]);
      f44 = Math_fround(HEAPF32[i41 + 8 >> 2]);
      f43 = Math_fround(f27 + f43);
      f53 = Math_fround(f26 + f53);
      f52 = Math_fround(f25 + f52);
      f51 = Math_fround(f24 + f51);
      f50 = Math_fround(f23 + f50);
      f49 = Math_fround(f22 + f49);
      f48 = Math_fround(f14 + f48);
      f47 = Math_fround(f36 + f47);
      f46 = Math_fround(f38 + f46);
      f45 = Math_fround(f40 + f45);
      f44 = Math_fround(f42 + f44);
      f28 = Math_fround(f28 + Math_fround(HEAPF32[i41 + 12 >> 2]));
      f42 = Math_fround(HEAPF32[i20 >> 2]);
      f43 = Math_fround(f43 * f42);
      f53 = Math_fround(f53 * f42);
      f52 = Math_fround(f52 * f42);
      f51 = Math_fround(f51 * f42);
      f50 = Math_fround(f50 * f42);
      f49 = Math_fround(f49 * f42);
      f48 = Math_fround(f48 * f42);
      f47 = Math_fround(f47 * f42);
      f46 = Math_fround(f46 * f42);
      f45 = Math_fround(f45 * f42);
      f44 = Math_fround(f44 * f42);
      f28 = Math_fround(f42 * f28);
      i41 = i10 + (i2 << 2) | 0;
      f42 = Math_fround(HEAPF32[i41 >> 2]);
      i39 = i41 + 4 | 0;
      f40 = Math_fround(HEAPF32[i39 >> 2]);
      i37 = i41 + 8 | 0;
      f38 = Math_fround(HEAPF32[i37 >> 2]);
      i35 = i41 + 12 | 0;
      f36 = Math_fround(HEAPF32[i35 >> 2]);
      i34 = i11 + (i2 << 2) | 0;
      f14 = Math_fround(HEAPF32[i34 >> 2]);
      i33 = i34 + 4 | 0;
      f22 = Math_fround(HEAPF32[i33 >> 2]);
      i32 = i34 + 8 | 0;
      f23 = Math_fround(HEAPF32[i32 >> 2]);
      i31 = i34 + 12 | 0;
      f24 = Math_fround(HEAPF32[i31 >> 2]);
      i30 = i3 + (i2 << 2) | 0;
      f25 = Math_fround(HEAPF32[i30 >> 2]);
      i29 = i30 + 4 | 0;
      f26 = Math_fround(HEAPF32[i29 >> 2]);
      i12 = i30 + 8 | 0;
      f27 = Math_fround(HEAPF32[i12 >> 2]);
      i13 = i30 + 12 | 0;
      f40 = Math_fround(f53 + f40);
      f38 = Math_fround(f52 + f38);
      f36 = Math_fround(f51 + f36);
      f14 = Math_fround(f50 + f14);
      f22 = Math_fround(f49 + f22);
      f23 = Math_fround(f48 + f23);
      f24 = Math_fround(f47 + f24);
      f25 = Math_fround(f46 + f25);
      f26 = Math_fround(f45 + f26);
      f27 = Math_fround(f44 + f27);
      f28 = Math_fround(f28 + Math_fround(HEAPF32[i13 >> 2]));
      HEAPF32[i41 >> 2] = Math_fround(f43 + f42);
      HEAPF32[i39 >> 2] = f40;
      HEAPF32[i37 >> 2] = f38;
      HEAPF32[i35 >> 2] = f36;
      HEAPF32[i34 >> 2] = f14;
      HEAPF32[i33 >> 2] = f22;
      HEAPF32[i32 >> 2] = f23;
      HEAPF32[i31 >> 2] = f24;
      HEAPF32[i30 >> 2] = f25;
      HEAPF32[i29 >> 2] = f26;
      HEAPF32[i12 >> 2] = f27;
      HEAPF32[i13 >> 2] = f28;
      i2 = i2 + 4 | 0;
     } while (i2 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
     i2 = 1;
     i13 = 18;
    } else {
     i2 = 1;
     i13 = 18;
    }
   } else {
    i2 = 1;
    i13 = 18;
   }
  } else {
   i2 = 1;
   i13 = 18;
  }
 } else i13 = 2;
 if ((i13 | 0) == 2) {
  if (i11 >>> 0 > i1 >>> 0) {
   i5 = HEAP32[i19 + 540 >> 2] | 0;
   i6 = HEAP32[i19 + 520 >> 2] | 0;
   i7 = i19 + 60 | 0;
   i8 = i19 + 80 | 0;
   i9 = i19 + 100 | 0;
   i10 = i19 + 120 | 0;
   i11 = i19 + 20 | 0;
   i12 = i19 + 40 | 0;
   i3 = HEAP32[i19 + 140 >> 2] | 0;
   i4 = HEAP32[i19 + 160 >> 2] | 0;
   i2 = i1;
   do {
    i30 = i5 + (i2 << 2) | 0;
    f46 = Math_fround(HEAPF32[i30 >> 2]);
    f47 = Math_fround(HEAPF32[i30 + 4 >> 2]);
    f48 = Math_fround(HEAPF32[i30 + 8 >> 2]);
    f52 = Math_fround(HEAPF32[i30 + 12 >> 2]);
    i30 = i6 + (i2 << 2) | 0;
    f49 = Math_fround(HEAPF32[i30 >> 2]);
    i29 = i30 + 4 | 0;
    f50 = Math_fround(HEAPF32[i29 >> 2]);
    i54 = i30 + 8 | 0;
    f51 = Math_fround(HEAPF32[i54 >> 2]);
    i55 = i30 + 12 | 0;
    f49 = Math_fround(Math_fround(f14 * f46) + f49);
    f50 = Math_fround(Math_fround(f14 * f47) + f50);
    f51 = Math_fround(Math_fround(f14 * f48) + f51);
    f52 = Math_fround(Math_fround(f14 * f52) + Math_fround(HEAPF32[i55 >> 2]));
    i31 = f49 < Math_fround(100.000008);
    f49 = i31 ? f49 : Math_fround(100.000008);
    i31 = f50 < Math_fround(100.000008);
    f50 = i31 ? f50 : Math_fround(100.000008);
    i31 = f51 < Math_fround(100.000008);
    f51 = i31 ? f51 : Math_fround(100.000008);
    i31 = f52 < Math_fround(100.000008);
    f52 = i31 ? f52 : Math_fround(100.000008);
    HEAPF32[i30 >> 2] = f49;
    HEAPF32[i29 >> 2] = f50;
    HEAPF32[i54 >> 2] = f51;
    HEAPF32[i55 >> 2] = f52;
    i55 = (HEAP32[i7 >> 2] | 0) + (i2 << 2) | 0;
    f52 = Math_fround(HEAPF32[i55 >> 2]);
    f51 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f50 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f49 = Math_fround(HEAPF32[i55 + 12 >> 2]);
    i55 = (HEAP32[i8 >> 2] | 0) + (i2 << 2) | 0;
    f48 = Math_fround(HEAPF32[i55 >> 2]);
    f47 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f46 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f45 = Math_fround(HEAPF32[i55 + 12 >> 2]);
    i55 = (HEAP32[i9 >> 2] | 0) + (i2 << 2) | 0;
    f44 = Math_fround(HEAPF32[i55 >> 2]);
    f43 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f53 = Math_fround(HEAPF32[i55 + 12 >> 2]);
    i55 = (HEAP32[i10 >> 2] | 0) + (i2 << 2) | 0;
    f40 = Math_fround(HEAPF32[i55 >> 2]);
    f56 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f22 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f23 = Math_fround(HEAPF32[i55 + 12 >> 2]);
    i55 = i3 + (i2 << 2) | 0;
    f24 = Math_fround(HEAPF32[i55 >> 2]);
    f25 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f26 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f27 = Math_fround(HEAPF32[i55 + 12 >> 2]);
    i55 = i4 + (i2 << 2) | 0;
    f28 = Math_fround(HEAPF32[i55 >> 2]);
    f36 = Math_fround(HEAPF32[i55 + 4 >> 2]);
    f38 = Math_fround(HEAPF32[i55 + 8 >> 2]);
    f40 = Math_fround(f52 + f40);
    f56 = Math_fround(f51 + f56);
    f22 = Math_fround(f50 + f22);
    f23 = Math_fround(f49 + f23);
    f24 = Math_fround(f48 + f24);
    f25 = Math_fround(f47 + f25);
    f26 = Math_fround(f46 + f26);
    f27 = Math_fround(f45 + f27);
    f28 = Math_fround(f44 + f28);
    f36 = Math_fround(f43 + f36);
    f38 = Math_fround(f42 + f38);
    f53 = Math_fround(f53 + Math_fround(HEAPF32[i55 + 12 >> 2]));
    f42 = Math_fround(HEAPF32[i20 >> 2]);
    f40 = Math_fround(f40 * f42);
    f56 = Math_fround(f56 * f42);
    f22 = Math_fround(f22 * f42);
    f23 = Math_fround(f23 * f42);
    f24 = Math_fround(f24 * f42);
    f25 = Math_fround(f25 * f42);
    f26 = Math_fround(f26 * f42);
    f27 = Math_fround(f27 * f42);
    f28 = Math_fround(f28 * f42);
    f36 = Math_fround(f36 * f42);
    f38 = Math_fround(f38 * f42);
    f53 = Math_fround(f42 * f53);
    i55 = (HEAP32[i19 >> 2] | 0) + (i2 << 2) | 0;
    f42 = Math_fround(HEAPF32[i55 >> 2]);
    i54 = i55 + 4 | 0;
    f43 = Math_fround(HEAPF32[i54 >> 2]);
    i29 = i55 + 8 | 0;
    f44 = Math_fround(HEAPF32[i29 >> 2]);
    i30 = i55 + 12 | 0;
    f45 = Math_fround(HEAPF32[i30 >> 2]);
    i31 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
    f46 = Math_fround(HEAPF32[i31 >> 2]);
    i32 = i31 + 4 | 0;
    f47 = Math_fround(HEAPF32[i32 >> 2]);
    i33 = i31 + 8 | 0;
    f48 = Math_fround(HEAPF32[i33 >> 2]);
    i34 = i31 + 12 | 0;
    f49 = Math_fround(HEAPF32[i34 >> 2]);
    i35 = (HEAP32[i12 >> 2] | 0) + (i2 << 2) | 0;
    f50 = Math_fround(HEAPF32[i35 >> 2]);
    i37 = i35 + 4 | 0;
    f51 = Math_fround(HEAPF32[i37 >> 2]);
    i39 = i35 + 8 | 0;
    f52 = Math_fround(HEAPF32[i39 >> 2]);
    i41 = i35 + 12 | 0;
    f43 = Math_fround(f56 + f43);
    f44 = Math_fround(f22 + f44);
    f45 = Math_fround(f23 + f45);
    f46 = Math_fround(f24 + f46);
    f47 = Math_fround(f25 + f47);
    f48 = Math_fround(f26 + f48);
    f49 = Math_fround(f27 + f49);
    f50 = Math_fround(f28 + f50);
    f51 = Math_fround(f36 + f51);
    f52 = Math_fround(f38 + f52);
    f53 = Math_fround(f53 + Math_fround(HEAPF32[i41 >> 2]));
    HEAPF32[i55 >> 2] = Math_fround(f40 + f42);
    HEAPF32[i54 >> 2] = f43;
    HEAPF32[i29 >> 2] = f44;
    HEAPF32[i30 >> 2] = f45;
    HEAPF32[i31 >> 2] = f46;
    HEAPF32[i32 >> 2] = f47;
    HEAPF32[i33 >> 2] = f48;
    HEAPF32[i34 >> 2] = f49;
    HEAPF32[i35 >> 2] = f50;
    HEAPF32[i37 >> 2] = f51;
    HEAPF32[i39 >> 2] = f52;
    HEAPF32[i41 >> 2] = f53;
    i2 = i2 + 4 | 0;
   } while (i2 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
  }
  if (!i17) __ZN14ParticleSystem13KillParticlesILb1EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj(i18, 0, i15, i16, i19, i1, 0); else {
   i2 = 0;
   i13 = 18;
  }
 }
 if ((i13 | 0) == 18) __ZN14ParticleSystem13KillParticlesILb0EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj(i18, i2, i15, i16, i19, i1, i17);
 if (!(HEAP8[i19 + 869 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 i8 = HEAP32[i18 >> 2] | 0;
 i2 = i8 >>> 0 > i1 >>> 0;
 if (!(HEAP8[i19 + 870 >> 0] | 0)) {
  if (!i2) {
   STACKTOP = i21;
   return;
  }
  i3 = HEAP32[i19 + 400 >> 2] | 0;
  i2 = HEAP32[i19 + 340 >> 2] | 0;
  do {
   i39 = i3 + (i1 << 2) | 0;
   f50 = Math_fround(HEAPF32[i39 >> 2]);
   f48 = Math_fround(HEAPF32[i39 + 4 >> 2]);
   f49 = Math_fround(HEAPF32[i39 + 8 >> 2]);
   f51 = Math_fround(HEAPF32[i39 + 12 >> 2]);
   f56 = Math_fround(HEAPF32[i20 >> 2]);
   f50 = Math_fround(f50 * f56);
   f48 = Math_fround(f48 * f56);
   f49 = Math_fround(f49 * f56);
   f56 = Math_fround(f51 * f56);
   i39 = i2 + (i1 << 2) | 0;
   f51 = Math_fround(HEAPF32[i39 >> 2]);
   i41 = i39 + 4 | 0;
   f52 = Math_fround(HEAPF32[i41 >> 2]);
   i54 = i39 + 8 | 0;
   f53 = Math_fround(HEAPF32[i54 >> 2]);
   i55 = i39 + 12 | 0;
   f52 = Math_fround(f48 + f52);
   f53 = Math_fround(f49 + f53);
   f56 = Math_fround(f56 + Math_fround(HEAPF32[i55 >> 2]));
   HEAPF32[i39 >> 2] = Math_fround(f50 + f51);
   HEAPF32[i41 >> 2] = f52;
   HEAPF32[i54 >> 2] = f53;
   HEAPF32[i55 >> 2] = f56;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i8 >>> 0);
  STACKTOP = i21;
  return;
 } else {
  if (!i2) {
   STACKTOP = i21;
   return;
  }
  i3 = HEAP32[i19 + 360 >> 2] | 0;
  i4 = HEAP32[i19 + 380 >> 2] | 0;
  i5 = HEAP32[i19 + 400 >> 2] | 0;
  i6 = HEAP32[i19 + 300 >> 2] | 0;
  i7 = HEAP32[i19 + 320 >> 2] | 0;
  i2 = HEAP32[i19 + 340 >> 2] | 0;
  do {
   i29 = i3 + (i1 << 2) | 0;
   f42 = Math_fround(HEAPF32[i29 >> 2]);
   f22 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i29 + 12 >> 2]);
   i29 = i4 + (i1 << 2) | 0;
   f25 = Math_fround(HEAPF32[i29 >> 2]);
   f26 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f28 = Math_fround(HEAPF32[i29 + 12 >> 2]);
   i29 = i5 + (i1 << 2) | 0;
   f36 = Math_fround(HEAPF32[i29 >> 2]);
   f38 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f40 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f43 = Math_fround(HEAPF32[i29 + 12 >> 2]);
   f56 = Math_fround(HEAPF32[i20 >> 2]);
   f42 = Math_fround(f42 * f56);
   f22 = Math_fround(f22 * f56);
   f23 = Math_fround(f23 * f56);
   f24 = Math_fround(f24 * f56);
   f25 = Math_fround(f25 * f56);
   f26 = Math_fround(f26 * f56);
   f27 = Math_fround(f27 * f56);
   f28 = Math_fround(f28 * f56);
   f36 = Math_fround(f36 * f56);
   f38 = Math_fround(f38 * f56);
   f40 = Math_fround(f40 * f56);
   f56 = Math_fround(f43 * f56);
   i29 = i6 + (i1 << 2) | 0;
   f43 = Math_fround(HEAPF32[i29 >> 2]);
   i30 = i29 + 4 | 0;
   f44 = Math_fround(HEAPF32[i30 >> 2]);
   i31 = i29 + 8 | 0;
   f45 = Math_fround(HEAPF32[i31 >> 2]);
   i32 = i29 + 12 | 0;
   f46 = Math_fround(HEAPF32[i32 >> 2]);
   i33 = i7 + (i1 << 2) | 0;
   f47 = Math_fround(HEAPF32[i33 >> 2]);
   i34 = i33 + 4 | 0;
   f48 = Math_fround(HEAPF32[i34 >> 2]);
   i35 = i33 + 8 | 0;
   f49 = Math_fround(HEAPF32[i35 >> 2]);
   i37 = i33 + 12 | 0;
   f50 = Math_fround(HEAPF32[i37 >> 2]);
   i39 = i2 + (i1 << 2) | 0;
   f51 = Math_fround(HEAPF32[i39 >> 2]);
   i41 = i39 + 4 | 0;
   f52 = Math_fround(HEAPF32[i41 >> 2]);
   i54 = i39 + 8 | 0;
   f53 = Math_fround(HEAPF32[i54 >> 2]);
   i55 = i39 + 12 | 0;
   f44 = Math_fround(f22 + f44);
   f45 = Math_fround(f23 + f45);
   f46 = Math_fround(f24 + f46);
   f47 = Math_fround(f25 + f47);
   f48 = Math_fround(f26 + f48);
   f49 = Math_fround(f27 + f49);
   f50 = Math_fround(f28 + f50);
   f51 = Math_fround(f36 + f51);
   f52 = Math_fround(f38 + f52);
   f53 = Math_fround(f40 + f53);
   f56 = Math_fround(f56 + Math_fround(HEAPF32[i55 >> 2]));
   HEAPF32[i29 >> 2] = Math_fround(f42 + f43);
   HEAPF32[i30 >> 2] = f44;
   HEAPF32[i31 >> 2] = f45;
   HEAPF32[i32 >> 2] = f46;
   HEAPF32[i33 >> 2] = f47;
   HEAPF32[i34 >> 2] = f48;
   HEAPF32[i35 >> 2] = f49;
   HEAPF32[i37 >> 2] = f50;
   HEAPF32[i39 >> 2] = f51;
   HEAPF32[i41 >> 2] = f52;
   HEAPF32[i54 >> 2] = f53;
   HEAPF32[i55 >> 2] = f56;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i8 >>> 0);
  STACKTOP = i21;
  return;
 }
}

function __ZN5physx14PxsAABBManager16processBPResultsERKNS_20PxsComputeAABBParamsE(i31, i1) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i30 + 1060 | 0;
 i28 = i30 + 528 | 0;
 i14 = i30 + 1056 | 0;
 i29 = i30;
 i15 = i31 + 49828 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0;
 if (i1 | 0) {
  i5 = i31 + 24 | 0;
  i6 = i31 + 16 | 0;
  i7 = i31 + 51600 | 0;
  i8 = i31 + 51608 | 0;
  i9 = i31 + 51604 | 0;
  i10 = i31 + 180 | 0;
  i11 = i31 + 51612 | 0;
  i12 = i31 + 51620 | 0;
  i13 = i31 + 51616 | 0;
  do {
   i1 = i1 + -1 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   do if ((i4 | 0) != 1073741823) if (!(i4 & 1)) {
    i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    HEAP32[i14 >> 2] = i3;
    i4 = HEAP32[i9 >> 2] | 0;
    if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = i3;
     HEAP32[i9 >> 2] = i4 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i7, i14) | 0;
     break;
    }
   } else {
    i3 = (HEAP32[i10 >> 2] | 0) + ((i4 >>> 1) * 1048 | 0) + 1044 | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    if ((HEAP32[i12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 >> 2] = i4 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11, i3) | 0;
     break;
    }
   } while (0);
  } while ((i1 | 0) != 0);
 }
 i13 = i31 + 49836 | 0;
 HEAP32[i13 >> 2] = 0;
 i16 = i31 + 49848 | 0;
 HEAP32[i16 >> 2] = 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] | 0, i14 | 0) | 0;
 i17 = HEAP32[i15 >> 2] | 0;
 i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] | 0, i17 | 0) | 0;
 i18 = HEAP32[i15 >> 2] | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 52 >> 2] | 0, i18 | 0) | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0) | 0;
 if (!i14) i13 = 0; else {
  i8 = i31 + 24 | 0;
  i9 = i31 + 16 | 0;
  i10 = i31 + 49840 | 0;
  i11 = i31 + 49832 | 0;
  i12 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i18 + (i12 << 3) >> 2] | 0;
   i3 = HEAP32[i18 + (i12 << 3) + 4 >> 2] | 0;
   i27 = HEAP32[i8 >> 2] | 0;
   if (!((HEAP32[i27 + (i3 << 2) >> 2] | HEAP32[i27 + (i2 << 2) >> 2]) & 1)) {
    i6 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    i6 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i10 >> 2] | 0)) {
     i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
     i5 = HEAP32[i11 >> 2] | 0;
     i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i4 << 3, gb + 717789 | 0, 59) | 0;
     if (i5 | 0) _memcpy(i2 | 0, i5 | 0, i3 << 3 | 0) | 0;
     _memset(i2 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, i5);
     HEAP32[i11 >> 2] = i2;
     HEAP32[i10 >> 2] = i4;
     i3 = HEAP32[i13 >> 2] | 0;
    } else i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i3 + 1;
    HEAP32[i2 + (i3 << 3) >> 2] = i7;
    HEAP32[i2 + (i3 << 3) + 4 >> 2] = i6;
   } else {
    HEAP32[i18 + (i1 << 3) >> 2] = i2;
    HEAP32[i18 + (i1 << 3) + 4 >> 2] = i3;
    i1 = i1 + 1 | 0;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i14 | 0));
  i13 = i1;
 }
 if (i17 | 0) {
  i8 = i31 + 24 | 0;
  i9 = i31 + 16 | 0;
  i10 = i31 + 49852 | 0;
  i11 = i31 + 49844 | 0;
  i12 = 0;
  i2 = 0;
  do {
   i1 = HEAP32[i15 + (i12 << 3) >> 2] | 0;
   i3 = HEAP32[i15 + (i12 << 3) + 4 >> 2] | 0;
   i27 = HEAP32[i8 >> 2] | 0;
   if (!((HEAP32[i27 + (i3 << 2) >> 2] | HEAP32[i27 + (i1 << 2) >> 2]) & 1)) {
    i6 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    i6 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i10 >> 2] | 0)) {
     i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
     i5 = HEAP32[i11 >> 2] | 0;
     i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i4 << 3, gb + 717789 | 0, 59) | 0;
     if (i5 | 0) _memcpy(i1 | 0, i5 | 0, i3 << 3 | 0) | 0;
     _memset(i1 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, i5);
     HEAP32[i11 >> 2] = i1;
     HEAP32[i10 >> 2] = i4;
     i3 = HEAP32[i16 >> 2] | 0;
    } else i1 = HEAP32[i11 >> 2] | 0;
    HEAP32[i16 >> 2] = i3 + 1;
    HEAP32[i1 + (i3 << 3) >> 2] = i7;
    HEAP32[i1 + (i3 << 3) + 4 >> 2] = i6;
   } else {
    HEAP32[i15 + (i2 << 3) >> 2] = i1;
    HEAP32[i15 + (i2 << 3) + 4 >> 2] = i3;
    i2 = i2 + 1 | 0;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i17 | 0));
  if (i2 | 0) {
   i1 = 0;
   do {
    __ZN5physx14PxsAABBManager19removeAggregatePairEjj(i31, HEAP32[i15 + (i1 << 3) >> 2] | 0, HEAP32[i15 + (i1 << 3) + 4 >> 2] | 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 if (i13 | 0) {
  i7 = i31 + 49860 | 0;
  i8 = i31 + 49864 | 0;
  i9 = i31 + 49856 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i12 = 0;
  while (1) {
   i10 = HEAP32[i18 + (i12 << 3) >> 2] | 0;
   i11 = HEAP32[i18 + (i12 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == (i5 | 0)) {
    i3 = (i5 | 0) == 0 ? 32 : i5 << 1;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i3 * 12 | 0, gb + 717789 | 0, 59) | 0;
    if (i1 | 0) _memcpy(i2 | 0, i1 | 0, i5 * 12 | 0) | 0;
    _memset(i2 + (i5 * 12 | 0) | 0, 0, (i3 - i5 | 0) * 12 | 0) | 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, i1);
    HEAP32[i9 >> 2] = i2;
    HEAP32[i8 >> 2] = i3;
    i6 = HEAP32[i7 >> 2] | 0;
    i4 = i2;
    i1 = i3;
   } else {
    i6 = i2;
    i4 = HEAP32[i9 >> 2] | 0;
    i1 = i5;
   }
   i2 = i6 + 1 | 0;
   HEAP32[i7 >> 2] = i2;
   i27 = i10 >>> 0 < i11 >>> 0;
   HEAP32[i4 + (i6 * 12 | 0) >> 2] = i27 ? i10 : i11;
   HEAP32[i4 + (i6 * 12 | 0) + 4 >> 2] = i27 ? i11 : i10;
   HEAP32[i4 + (i6 * 12 | 0) + 8 >> 2] = 0;
   i12 = i12 + 1 | 0;
   if ((i12 | 0) == (i13 | 0)) break; else i5 = i1;
  }
 }
 i4 = i31 + 196 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i2 = HEAP32[i31 >> 2] | 0;
 HEAP32[i28 + 512 >> 2] = i2;
 i26 = i28 + 516 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i28 + 520 | 0;
 HEAP32[i27 >> 2] = 0;
 i3 = (i1 + 31 | 0) >>> 5;
 do if (i1 >>> 0 > 4096) {
  i1 = (i3 << 2) + 15 & 1073741808;
  if (!i2) {
   i23 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i1, gb + 717789 | 0, 1998) | 0;
   HEAP32[i26 >> 2] = i23;
   i2 = i3 | -2147483648;
   HEAP32[i27 >> 2] = i2;
   i1 = i26;
   i3 = i23;
   break;
  } else {
   i23 = __ZN5physx19PxcScratchAllocator5allocEjb(i2, i1, 1) | 0;
   HEAP32[i26 >> 2] = i23;
   i2 = i3 | -2147483648;
   HEAP32[i27 >> 2] = i2;
   i1 = i26;
   i3 = i23;
   break;
  }
 } else {
  HEAP32[i26 >> 2] = i28;
  i2 = i3 | -2147483648;
  HEAP32[i27 >> 2] = i2;
  i1 = i26;
  i3 = i28;
 } while (0);
 _memset(i3 | 0, 0, i2 << 2 | 0) | 0;
 _memset(HEAP32[i1 >> 2] | 0, 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i31 >> 2] | 0;
 HEAP32[i29 + 512 >> 2] = i2;
 i21 = i29 + 516 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i29 + 520 | 0;
 HEAP32[i22 >> 2] = 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = (i1 + 31 | 0) >>> 5;
  do if (i1 >>> 0 > 4096) {
   i1 = (i3 << 2) + 15 & 1073741808;
   if (!i2) {
    i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i1, gb + 717789 | 0, 1998) | 0;
    HEAP32[i21 >> 2] = i2;
    i1 = i3 | -2147483648;
    HEAP32[i22 >> 2] = i1;
    i3 = i21;
    break;
   } else {
    i2 = __ZN5physx19PxcScratchAllocator5allocEjb(i2, i1, 1) | 0;
    HEAP32[i21 >> 2] = i2;
    i1 = i3 | -2147483648;
    HEAP32[i22 >> 2] = i1;
    i3 = i21;
    break;
   }
  } else {
   HEAP32[i21 >> 2] = i29;
   i1 = i3 | -2147483648;
   HEAP32[i22 >> 2] = i1;
   i3 = i21;
   i2 = i29;
  } while (0);
  _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 _memset(i1 | 0, 0, i2 << 2 | 0) | 0;
 i1 = i31 + 45712 | 0;
 i12 = i31 + 49860 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i4 | 0) {
  do if (i4 >>> 0 > 1024) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i31 + 49808 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i1, gb + 717789 | 0, 1930) | 0;
    HEAP32[i31 + 49812 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    HEAP32[i31 + 49812 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i31 + 49812 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i31 + 49816 >> 2] = i4;
 }
 i20 = HEAP32[i31 + 49812 >> 2] | 0;
 i23 = i31 + 356 | 0;
 i5 = HEAP32[i31 + 372 >> 2] | 0;
 i6 = HEAP32[i31 + 368 >> 2] | 0;
 if (!i5) i4 = 0; else {
  i7 = HEAP32[i31 + 180 >> 2] | 0;
  i8 = i31 + 232 | 0;
  i9 = i31 + 220 | 0;
  i10 = HEAP32[i29 + 516 >> 2] | 0;
  i4 = 0;
  i11 = 0;
  do {
   i1 = HEAP32[i6 + (i11 << 2) >> 2] | 0;
   if (!(HEAP8[i7 + (i1 * 1048 | 0) + 1024 >> 0] | 0)) i24 = 69; else if (!(HEAP8[i7 + (i1 * 1048 | 0) + 1026 >> 0] | 0)) i24 = 69; else {
    i19 = i10 + (i1 >>> 5 << 2) | 0;
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 1 << (i1 & 31);
    i4 = i4 + 1 | 0;
   }
   if ((i24 | 0) == 69) {
    i24 = 0;
    i2 = i1 >>> 5;
    i3 = 1 << (i1 & 31);
    if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] & i3)) if (HEAP8[i7 + (i1 * 1048 | 0) + 1026 >> 0] | 0) {
     i19 = (HEAP32[i9 >> 2] | 0) + (i2 << 2) | 0;
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i3;
    }
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i5 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if (!i12) i1 = 0; else {
  i13 = HEAP32[i31 + 49856 >> 2] | 0;
  i14 = HEAP32[i31 + 24 >> 2] | 0;
  i15 = i31 + 68 | 0;
  i16 = i31 + 96 | 0;
  i17 = HEAP32[i29 + 516 >> 2] | 0;
  i18 = HEAP32[i28 + 516 >> 2] | 0;
  i19 = i31 + 220 | 0;
  i1 = 0;
  i11 = 0;
  do {
   i2 = HEAP32[i13 + (i11 * 12 | 0) >> 2] | 0;
   i7 = HEAP32[i13 + (i11 * 12 | 0) + 4 >> 2] | 0;
   i9 = HEAP32[i14 + (i2 << 2) >> 2] | 0;
   i8 = (i9 & 1 | 0) == 0;
   do if (i8) {
    i3 = i2 >>> 5;
    i2 = 1 << (i2 & 31);
    if (!(HEAP32[(HEAP32[i15 >> 2] | 0) + (i3 << 2) >> 2] & i2)) i6 = (HEAP32[(HEAP32[i16 >> 2] | 0) + (i3 << 2) >> 2] & i2 | 0) != 0; else i6 = 1;
   } else {
    if (!(HEAP32[(HEAP32[i23 >> 2] | 0) + (i9 >>> 6 << 2) >> 2] & 1 << (i9 >>> 1 & 31))) if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31))) {
     i6 = 0;
     break;
    }
    i6 = 1;
   } while (0);
   i10 = i14 + (i7 << 2) | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if (!(i2 & 1)) {
    i5 = i7 >>> 5;
    i3 = 1 << (i7 & 31);
    if (!(HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] & i3)) {
     if ((HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] & i3 | 0) != 0 | i6) i24 = 86;
    } else i24 = 86;
   } else if (!(HEAP32[(HEAP32[i23 >> 2] | 0) + (i2 >>> 6 << 2) >> 2] & 1 << (i2 >>> 1 & 31))) {
    if (i6 | (HEAP32[(HEAP32[i16 >> 2] | 0) + (i7 >>> 5 << 2) >> 2] & 1 << (i7 & 31) | 0) != 0) i24 = 86;
   } else i24 = 86;
   if ((i24 | 0) == 86) {
    i24 = 0;
    if (i8) i8 = 1073741823; else {
     i8 = i9 >>> 1;
     i3 = i9 >>> 6;
     i6 = i18 + (i3 << 2) | 0;
     i7 = 1 << (i8 & 31);
     if (!(HEAP32[i6 >> 2] & i7)) {
      i3 = (HEAP32[i19 >> 2] | 0) + (i3 << 2) | 0;
      i5 = HEAP32[i3 >> 2] | 0;
      if (i5 & i7) {
       HEAP32[i3 >> 2] = i5 & ~i7;
       HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i7;
       i2 = HEAP32[i10 >> 2] | 0;
      }
     }
    }
    if (!(i2 & 1)) i7 = 1073741823; else {
     i7 = i2 >>> 1;
     i2 = i2 >>> 6;
     i5 = i18 + (i2 << 2) | 0;
     i6 = 1 << (i7 & 31);
     if (!(HEAP32[i5 >> 2] & i6)) {
      i2 = (HEAP32[i19 >> 2] | 0) + (i2 << 2) | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if (i3 & i6) {
       HEAP32[i2 >> 2] = i3 & ~i6;
       HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i6;
      }
     }
    }
    if ((i8 | 0) != 1073741823) {
     i3 = i17 + (i8 >>> 5 << 2) | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     i2 = 1 << (i8 & 31);
     if (!(i5 & i2)) {
      HEAP32[i3 >> 2] = i5 | i2;
      i4 = i4 + 1 | 0;
     }
    }
    do if ((i7 | 0) != 1073741823) {
     i3 = i17 + (i7 >>> 5 << 2) | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     i2 = 1 << (i7 & 31);
     if (i5 & i2 | 0) break;
     HEAP32[i3 >> 2] = i5 | i2;
     i4 = i4 + 1 | 0;
    } while (0);
    HEAP32[i20 + (i1 << 2) >> 2] = i11;
    i1 = i1 + 1 | 0;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i12 | 0));
 }
 HEAP32[i31 + 49824 >> 2] = i1;
 i1 = i31 + 41584 | 0;
 L147 : do if (!i4) i1 = 0; else {
  do if (i4 >>> 0 > 1024) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i31 + 45680 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i1, gb + 717789 | 0, 1930) | 0;
    i3 = i31 + 45684 | 0;
    HEAP32[i3 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    i3 = i31 + 45684 | 0;
    HEAP32[i3 >> 2] = i1;
    break;
   }
  } else {
   i3 = i31 + 45684 | 0;
   HEAP32[i3 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i31 + 45688 >> 2] = i4;
  i7 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i22 >> 2] & 2147483647;
  if (!i6) i1 = 0; else {
   i5 = HEAP32[i21 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
    if (i2 | 0) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = 0;
     break L147;
    }
   }
   i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i1 << 5;
   i3 = i2 + -1 & i2;
   L162 : do if (!i3) do {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i3 = 0;
     break L162;
    }
    i3 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   } while ((i3 | 0) == 0); while (0);
   if ((i4 | 0) == -1) i1 = 0; else {
    i6 = HEAP32[i21 >> 2] | 0;
    i2 = i1;
    i1 = 0;
    while (1) {
     i5 = i2 << 5;
     while (1) {
      HEAP32[i7 + (i1 << 2) >> 2] = i4;
      i1 = i1 + 1 | 0;
      if (!i3) break L147;
      i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i5;
      i3 = i3 + -1 & i3;
      if (!i3) {
       i5 = i4;
       break;
      }
      if ((i4 | 0) == -1) break L147;
     }
     i4 = HEAP32[i22 >> 2] & 2147483647;
     do {
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i4 >>> 0) {
       i3 = 0;
       break;
      }
      i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
     } while ((i3 | 0) == 0);
     if ((i5 | 0) == -1) break; else i4 = i5;
    }
   }
  }
 } while (0);
 HEAP32[i31 + 45696 >> 2] = i1;
 i13 = HEAP32[i31 + 33316 >> 2] | 0;
 i4 = HEAP32[i27 >> 2] & 2147483647;
 L180 : do if (!i4) i1 = 0; else {
  i3 = HEAP32[i26 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i1 = 0;
    break L180;
   }
  }
  i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L186 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i2 = 0;
    break L186;
   }
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i5 | 0) == -1) i1 = 0; else {
   i8 = i31 + 180 | 0;
   i9 = i31 + 308 | 0;
   i10 = i31 + 316 | 0;
   i11 = i31 + 312 | 0;
   i12 = i31 + 252 | 0;
   i3 = i1;
   i1 = 0;
   i4 = i5;
   do {
    i7 = i3 << 5;
    i6 = i4;
    while (1) {
     i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 * 1048 | 0) + 1032 >> 2] | 0;
     i5 = (i4 | 0) == 1073741823;
     if (!(HEAP32[(HEAP32[i23 >> 2] | 0) + (i6 >>> 5 << 2) >> 2] & 1 << (i6 & 31))) {
      if (!i5) {
       i5 = HEAP32[i9 >> 2] | 0;
       i6 = HEAP32[i10 >> 2] | 0;
       do {
        if ((HEAP32[i5 + (i4 << 2) >> 2] | 0) != 1073741823) {
         HEAP32[i13 + (i1 << 2) >> 2] = i4;
         i1 = i1 + 1 | 0;
        }
        i4 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       } while ((i4 | 0) != 1073741823);
      }
     } else if (!i5) do {
      do if ((HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] | 0) != 1073741823) {
       if ((HEAPU8[(HEAP32[i12 >> 2] | 0) + ((HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] | 0) >>> 1) >> 0] | 0) <= 1) break;
       HEAP32[i13 + (i1 << 2) >> 2] = i4;
       i1 = i1 + 1 | 0;
      } while (0);
      i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != 1073741823);
     if (!i2) break L180;
     i6 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i7;
     i2 = i2 + -1 & i2;
     if (!i2) {
      i4 = i6;
      break;
     }
     if ((i6 | 0) == -1) break L180;
    }
    i5 = HEAP32[i27 >> 2] & 2147483647;
    i6 = HEAP32[i26 >> 2] | 0;
    do {
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 >= i5 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i4 | 0) != -1);
  }
 } while (0);
 HEAP32[i31 + 33328 >> 2] = i1;
 __ZN5physx12InlineBitmapILj4096EED2Ev(i29);
 __ZN5physx12InlineBitmapILj4096EED2Ev(i28);
 STACKTOP = i30;
 return;
}

function __ZNK14dtNavMeshQuery18findDistanceToWallEyPKfPK13dtQueryFilterPfS5_S5_Pj(i46, i9, i10, i48, i12, i53, i49, i54, i50) {
 i46 = i46 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i48 = i48 | 0;
 i12 = i12 | 0;
 i53 = i53 | 0;
 i49 = i49 | 0;
 i54 = i54 | 0;
 i50 = i50 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i11 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i51 = 0, i52 = 0, i55 = 0, f56 = f0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i55 + 192 | 0;
 i47 = i55;
 if ((i9 | 0) == 0 & (i10 | 0) == 0) {
  i54 = -2147483640;
  STACKTOP = i55;
  return i54 | 0;
 }
 i1 = HEAP32[i46 >> 2] | 0;
 i2 = _bitshift64Lshr(i9 | 0, i10 | 0, 48) | 0;
 getTempRet0() | 0;
 i3 = _bitshift64Lshr(i9 | 0, i10 | 0, 20) | 0;
 getTempRet0() | 0;
 i3 = i3 & 268435455;
 i8 = i9 & 65535;
 if ((i9 & 983040 | 0) == 65536 & 0 == 0) {
  if (i8 >>> 0 >= (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
  if ((HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + (i8 * 104 | 0) + 92 >> 2] | 0) != (i2 | 0)) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
 } else {
  if (i3 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
  i1 = HEAP32[i1 + 20 >> 2] | 0;
  if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) != (i2 | 0)) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
  i1 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
  if (i8 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i54 = -2147483640;
   STACKTOP = i55;
   return i54 | 0;
  }
 }
 i43 = i46 + 76 | 0;
 i44 = HEAP32[i43 >> 2] | 0;
 _memset(HEAP32[i44 + 4 >> 2] | 0, -1, HEAP32[i44 + 16 >> 2] << 1 | 0) | 0;
 HEAP32[i44 + 20 >> 2] = 0;
 i44 = i46 + 80 | 0;
 HEAP32[(HEAP32[i44 >> 2] | 0) + 8 >> 2] = 0;
 i11 = __ZN10dtNodePool7getNodeEy(HEAP32[i43 >> 2] | 0, i9, i10) | 0;
 HEAP32[i11 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
 i45 = i48 + 8 | 0;
 HEAP32[i11 + 8 >> 2] = HEAP32[i45 >> 2];
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 16 >> 2] = Math_fround(0.0);
 i42 = i11 + 24 | 0;
 HEAP32[i42 >> 2] = i9;
 HEAP32[i42 + 4 >> 2] = i10;
 HEAP32[i11 + 20 >> 2] = 1073741824;
 i10 = HEAP32[i44 >> 2] | 0;
 i42 = i10 + 8 | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 HEAP32[i42 >> 2] = i1 + 1;
 L22 : do if ((i1 | 0) > 0) {
  i3 = i1;
  while (1) {
   i2 = i3 + -1 | 0;
   i1 = (i2 | 0) / 2 | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i9 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   if (!(Math_fround(HEAPF32[i9 + 16 >> 2]) > Math_fround(0.0))) {
    i1 = i3;
    break L22;
   }
   HEAP32[i8 + (i3 << 2) >> 2] = i9;
   if ((i2 | 0) > 1) i3 = i1; else break;
  }
 } while (0);
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i11;
 i39 = i12 + 128 | 0;
 i40 = (i50 | 0) == 0;
 i41 = i49 + 4 | 0;
 i42 = i49 + 8 | 0;
 f4 = Math_fround(3402823469999999843913219.0e14);
 i29 = 1073741824;
 i3 = 0;
 i1 = 0;
 L27 : while (1) {
  f21 = f4;
  while (1) {
   do {
    do {
     i13 = HEAP32[i44 >> 2] | 0;
     i8 = i13 + 8 | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if (!i2) break L27;
     i9 = HEAP32[i13 >> 2] | 0;
     i38 = HEAP32[i9 >> 2] | 0;
     i11 = i2 + -1 | 0;
     HEAP32[i8 >> 2] = i11;
     i12 = HEAP32[i9 + (i11 << 2) >> 2] | 0;
     L36 : do if ((i11 | 0) > 1) {
      i10 = 0;
      i2 = 1;
      while (1) {
       i8 = i2 + 1 | 0;
       if ((i8 | 0) < (i11 | 0)) {
        f20 = Math_fround(HEAPF32[(HEAP32[i9 + (i2 << 2) >> 2] | 0) + 16 >> 2]);
        if (f20 > Math_fround(HEAPF32[(HEAP32[i9 + (i8 << 2) >> 2] | 0) + 16 >> 2])) i2 = i8;
       }
       HEAP32[i9 + (i10 << 2) >> 2] = HEAP32[i9 + (i2 << 2) >> 2];
       i8 = i2 << 1 | 1;
       if ((i8 | 0) >= (i11 | 0)) break;
       i10 = i2;
       i2 = i8;
       i9 = HEAP32[i13 >> 2] | 0;
      }
      if ((i2 | 0) > 0) {
       f4 = Math_fround(HEAPF32[i12 + 16 >> 2]);
       i9 = i2;
       while (1) {
        i8 = i9 + -1 | 0;
        i2 = (i8 | 0) / 2 | 0;
        i10 = HEAP32[i13 >> 2] | 0;
        i11 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
        if (!(Math_fround(HEAPF32[i11 + 16 >> 2]) > f4)) {
         i2 = i9;
         break L36;
        }
        HEAP32[i10 + (i9 << 2) >> 2] = i11;
        if ((i8 | 0) > 1) i9 = i2; else break;
       }
      }
     } else i2 = 0; while (0);
     HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = i12;
     i9 = i38 + 20 | 0;
     i2 = HEAP32[i9 >> 2] & 1073741823;
     HEAP32[i9 >> 2] = i2 | -2147483648;
     i9 = i38 + 24 | 0;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     if (!i2) {
      i36 = 0;
      i37 = 0;
     } else {
      i37 = (HEAP32[HEAP32[i43 >> 2] >> 2] | 0) + (i2 + -1 << 5) + 24 | 0;
      i36 = HEAP32[i37 >> 2] | 0;
      i37 = HEAP32[i37 + 4 >> 2] | 0;
     }
     i35 = __ZNK9dtNavMesh15getPolyGeometryEyPfPyi(HEAP32[i46 >> 2] | 0, i8, i9, i51, i47, 4) | 0;
    } while (!(i35 | 0));
    i24 = (i35 | 0) > 0;
   } while (!i24);
   i2 = i35 + -1 | 0;
   i25 = (i8 & 983040 | 0) == 65536 & 0 == 0;
   i26 = i8 & 65535;
   i27 = _bitshift64Lshr(i8 | 0, i9 | 0, 48) | 0;
   getTempRet0() | 0;
   i28 = (i8 | 0) == 0 & (i9 | 0) == 0;
   i23 = _bitshift64Lshr(i8 | 0, i9 | 0, 20) | 0;
   getTempRet0() | 0;
   i23 = i23 & 268435455;
   i22 = 0;
   i18 = i2;
   while (1) {
    i17 = i47 + (i18 << 2 << 3) | 0;
    i16 = 0;
    while (1) {
     i10 = i17 + (i16 << 3) | 0;
     i8 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     if ((i8 | 0) == 0 & (i10 | 0) == 0) {
      i52 = 47;
      break;
     }
     i11 = HEAP32[i46 >> 2] | 0;
     if ((i8 & 983040 | 0) == 65536 & 0 == 0) {
      i9 = i8 & 65535;
      if (i9 >>> 0 > (HEAP32[i11 + 44 >> 2] | 0) >>> 0) i8 = 0; else {
       i34 = _bitshift64Lshr(i8 | 0, i10 | 0, 48) | 0;
       getTempRet0() | 0;
       i8 = HEAP32[i11 + 48 >> 2] | 0;
       if ((i8 + (i9 * 104 | 0) | 0) == 0 ? 1 : (i34 | 0) != (HEAP32[i8 + (i9 * 104 | 0) + 92 >> 2] | 0)) i8 = 0; else i8 = HEAP32[i8 + (i9 * 104 | 0) + 76 >> 2] | 0;
      }
     } else {
      i12 = _bitshift64Lshr(i8 | 0, i10 | 0, 20) | 0;
      getTempRet0() | 0;
      i12 = i12 & 268435455;
      i13 = i8 & 65535;
      if (i12 >>> 0 < (HEAP32[i11 + 16 >> 2] | 0) >>> 0) {
       i34 = _bitshift64Lshr(i8 | 0, i10 | 0, 48) | 0;
       getTempRet0() | 0;
       i8 = HEAP32[i11 + 20 >> 2] | 0;
       if ((HEAP32[i8 + (i12 * 56 | 0) + 4 >> 2] | 0) == (i34 | 0)) {
        i9 = HEAP32[i8 + (i12 * 56 | 0) + 8 >> 2] | 0;
        if (!i9) i8 = 0; else if (i13 >>> 0 < (HEAP32[i9 + 20 >> 2] | 0) >>> 0) i8 = HEAP32[(HEAP32[i8 + (i12 * 56 | 0) + 16 >> 2] | 0) + (i13 << 5) + 24 >> 2] | 0; else i8 = 0;
       } else i8 = 0;
      } else i8 = 0;
     }
     i16 = i16 + 1 | 0;
     if (HEAP32[i39 >> 2] & i8 | 0) {
      f4 = f21;
      break;
     }
     if ((i16 | 0) >= 4) {
      i52 = 47;
      break;
     }
    }
    if ((i52 | 0) == 47) {
     i52 = 0;
     i8 = i51 + (i18 * 3 << 2) | 0;
     i9 = i51 + (i22 * 3 << 2) | 0;
     f7 = Math_fround(HEAPF32[i9 >> 2]);
     f14 = Math_fround(HEAPF32[i8 >> 2]);
     f15 = Math_fround(f7 - f14);
     f20 = Math_fround(HEAPF32[i9 + 8 >> 2]);
     f19 = Math_fround(HEAPF32[i8 + 8 >> 2]);
     f20 = Math_fround(f20 - f19);
     f4 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) - f14);
     f5 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f19);
     f6 = Math_fround(Math_fround(f15 * f15) + Math_fround(f20 * f20));
     if (f6 == Math_fround(0.0)) {
      f4 = Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5));
      f5 = Math_fround(0.0);
     } else {
      f6 = Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(f20 * f5)) / f6);
      i34 = f6 < Math_fround(0.0);
      i33 = f6 > Math_fround(1.0);
      f6 = i33 ? Math_fround(1.0) : f6;
      f6 = i34 ? Math_fround(0.0) : f6;
      f56 = Math_fround(Math_fround(f15 * f6) - f4);
      f4 = Math_fround(Math_fround(f20 * f6) - f5);
      f4 = Math_fround(Math_fround(f56 * f56) + Math_fround(f4 * f4));
      f5 = f6;
     }
     if (f4 > f21) f4 = f21; else {
      if (!i40) {
       i1 = HEAP32[i46 >> 2] | 0;
       if (i25) if (i26 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
        i1 = HEAP32[i1 + 48 >> 2] | 0;
        if ((i1 + (i26 * 104 | 0) | 0) == 0 ? 1 : (i27 | 0) != (HEAP32[i1 + (i26 * 104 | 0) + 92 >> 2] | 0)) i1 = 0; else i1 = HEAP32[i1 + (i26 * 104 | 0) + 76 >> 2] | 0;
       } else if (i28) i1 = 0; else if (i23 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
        i1 = HEAP32[i1 + 20 >> 2] | 0;
        if ((HEAP32[i1 + (i23 * 56 | 0) + 4 >> 2] | 0) == (i27 | 0)) {
         i3 = HEAP32[i1 + (i23 * 56 | 0) + 8 >> 2] | 0;
         if (!i3) i1 = 0; else if (i26 >>> 0 < (HEAP32[i3 + 20 >> 2] | 0) >>> 0) i1 = HEAP32[(HEAP32[i1 + (i23 * 56 | 0) + 16 >> 2] | 0) + (i26 << 5) + 24 >> 2] | 0; else i1 = 0;
        } else i1 = 0;
       } else i1 = 0;
       HEAP32[i50 >> 2] = i1;
      }
      HEAPF32[i49 >> 2] = Math_fround(f14 + Math_fround(f5 * f15));
      f56 = Math_fround(HEAPF32[i8 + 4 >> 2]);
      HEAPF32[i41 >> 2] = Math_fround(f56 + Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) - f56)));
      HEAPF32[i42 >> 2] = Math_fround(f19 + Math_fround(f5 * f20));
      i3 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
      f56 = Math_fround(f14 - f7);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
     }
    }
    i8 = i22 + 1 | 0;
    if ((i8 | 0) == (i35 | 0)) break; else {
     i18 = i22;
     i22 = i8;
     f21 = f4;
    }
   }
   if (i24) break; else f21 = f4;
  }
  i31 = i38 + 16 | 0;
  i32 = i38 + 4 | 0;
  i33 = i38 + 8 | 0;
  i34 = i38;
  i30 = 0;
  i8 = i29;
  while (1) {
   i29 = i47 + (i2 << 2 << 3) | 0;
   i23 = i51 + (i2 * 3 << 2) | 0;
   i24 = i51 + (i30 * 3 << 2) | 0;
   i25 = i24 + 8 | 0;
   i26 = i23 + 8 | 0;
   i27 = i23 + 4 | 0;
   i28 = i24 + 4 | 0;
   i22 = 0;
   do {
    i17 = i29 + (i22 << 3) | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i17 = HEAP32[i17 + 4 >> 2] | 0;
    if ((i16 | 0) == 0 & (i17 | 0) == 0) break;
    L100 : do if (!((i16 | 0) == (i36 | 0) & (i17 | 0) == (i37 | 0) | (i16 & 983040 | 0) == 65536 & 0 == 0)) {
     f5 = Math_fround(HEAPF32[i24 >> 2]);
     f7 = Math_fround(HEAPF32[i23 >> 2]);
     f5 = Math_fround(f5 - f7);
     f6 = Math_fround(HEAPF32[i25 >> 2]);
     f14 = Math_fround(HEAPF32[i26 >> 2]);
     f6 = Math_fround(f6 - f14);
     f7 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) - f7);
     f14 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f14);
     f15 = Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6));
     if (f15 == Math_fround(0.0)) f5 = Math_fround(Math_fround(f7 * f7) + Math_fround(f14 * f14)); else {
      f21 = Math_fround(Math_fround(Math_fround(f5 * f7) + Math_fround(f6 * f14)) / f15);
      i18 = f21 < Math_fround(0.0);
      i13 = f21 > Math_fround(1.0);
      f21 = i13 ? Math_fround(1.0) : f21;
      f21 = i18 ? Math_fround(0.0) : f21;
      f56 = Math_fround(Math_fround(f5 * f21) - f7);
      f5 = Math_fround(Math_fround(f6 * f21) - f14);
      f5 = Math_fround(Math_fround(f56 * f56) + Math_fround(f5 * f5));
     }
     if (!(f5 > f4)) {
      i2 = HEAP32[i46 >> 2] | 0;
      i10 = _bitshift64Lshr(i16 | 0, i17 | 0, 20) | 0;
      getTempRet0() | 0;
      i10 = i10 & 268435455;
      i11 = i16 & 65535;
      if (i10 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
       i18 = _bitshift64Lshr(i16 | 0, i17 | 0, 48) | 0;
       getTempRet0() | 0;
       i2 = HEAP32[i2 + 20 >> 2] | 0;
       if ((HEAP32[i2 + (i10 * 56 | 0) + 4 >> 2] | 0) == (i18 | 0)) {
        i9 = HEAP32[i2 + (i10 * 56 | 0) + 8 >> 2] | 0;
        if (!i9) i2 = 0; else if (i11 >>> 0 < (HEAP32[i9 + 20 >> 2] | 0) >>> 0) i2 = HEAP32[(HEAP32[i2 + (i10 * 56 | 0) + 16 >> 2] | 0) + (i11 << 5) + 24 >> 2] | 0; else i2 = 0;
       } else i2 = 0;
      } else i2 = 0;
      if (HEAP32[i39 >> 2] & i2) {
       i18 = __ZN10dtNodePool7getNodeEy(HEAP32[i43 >> 2] | 0, i16, i17) | 0;
       if (!i18) {
        i8 = i8 | 32;
        break;
       }
       i13 = i18 + 20 | 0;
       i12 = HEAP32[i13 >> 2] | 0;
       i2 = i12 >>> 30;
       if (!(i2 & 2)) {
        if (!i2) {
         f5 = Math_fround(HEAPF32[i23 >> 2]);
         f5 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f5) * Math_fround(.5)));
         HEAPF32[i18 >> 2] = f5;
         f6 = Math_fround(HEAPF32[i27 >> 2]);
         f6 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f6) * Math_fround(.5)));
         HEAPF32[i18 + 4 >> 2] = f6;
         f7 = Math_fround(HEAPF32[i26 >> 2]);
         f7 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f7) * Math_fround(.5)));
         HEAPF32[i18 + 8 >> 2] = f7;
        } else {
         f5 = Math_fround(HEAPF32[i18 >> 2]);
         f6 = Math_fround(HEAPF32[i18 + 4 >> 2]);
         f7 = Math_fround(HEAPF32[i18 + 8 >> 2]);
        }
        f20 = Math_fround(HEAPF32[i31 >> 2]);
        f21 = Math_fround(f5 - Math_fround(HEAPF32[i38 >> 2]));
        f56 = Math_fround(f6 - Math_fround(HEAPF32[i32 >> 2]));
        f5 = Math_fround(f7 - Math_fround(HEAPF32[i33 >> 2]));
        f5 = Math_fround(f20 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f56 * f56)) + Math_fround(f5 * f5)))));
        i10 = i12 & 1073741824;
        i11 = (i10 | 0) == 0;
        i9 = i18 + 16 | 0;
        if (!i11) if (f5 >= Math_fround(HEAPF32[i9 >> 2])) break;
        i2 = i18 + 24 | 0;
        HEAP32[i2 >> 2] = i16;
        HEAP32[i2 + 4 >> 2] = i17;
        HEAP32[i13 >> 2] = i12 & 2147483647;
        i2 = (i34 - (HEAP32[HEAP32[i43 >> 2] >> 2] | 0) >> 5) + 1 & 1073741823;
        HEAP32[i13 >> 2] = i2 | i10;
        HEAPF32[i9 >> 2] = f5;
        if (i11) {
         HEAP32[i13 >> 2] = i2 | 1073741824;
         i13 = HEAP32[i44 >> 2] | 0;
         i17 = i13 + 8 | 0;
         i2 = HEAP32[i17 >> 2] | 0;
         HEAP32[i17 >> 2] = i2 + 1;
         L127 : do if ((i2 | 0) > 0) {
          i10 = i2;
          while (1) {
           i9 = i10 + -1 | 0;
           i2 = (i9 | 0) / 2 | 0;
           i11 = HEAP32[i13 >> 2] | 0;
           i12 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
           if (!(Math_fround(HEAPF32[i12 + 16 >> 2]) > f5)) {
            i2 = i10;
            break L127;
           }
           HEAP32[i11 + (i10 << 2) >> 2] = i12;
           if ((i9 | 0) > 1) i10 = i2; else break;
          }
         } while (0);
         HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = i18;
         break;
        }
        i13 = HEAP32[i44 >> 2] | 0;
        i10 = HEAP32[i13 + 8 >> 2] | 0;
        if ((i10 | 0) > 0) {
         i2 = HEAP32[i13 >> 2] | 0;
         i9 = 0;
         while (1) {
          if ((HEAP32[i2 + (i9 << 2) >> 2] | 0) == (i18 | 0)) break;
          i9 = i9 + 1 | 0;
          if ((i9 | 0) >= (i10 | 0)) break L100;
         }
         L138 : do if ((i9 | 0) > 0) {
          i12 = i9;
          while (1) {
           i11 = i12 + -1 | 0;
           i9 = (i11 | 0) / 2 | 0;
           i10 = HEAP32[i2 + (i9 << 2) >> 2] | 0;
           if (!(Math_fround(HEAPF32[i10 + 16 >> 2]) > f5)) {
            i9 = i12;
            break L138;
           }
           HEAP32[i2 + (i12 << 2) >> 2] = i10;
           i2 = HEAP32[i13 >> 2] | 0;
           if ((i11 | 0) > 1) i12 = i9; else break;
          }
         } while (0);
         HEAP32[i2 + (i9 << 2) >> 2] = i18;
        }
       }
      }
     }
    } while (0);
    i22 = i22 + 1 | 0;
   } while ((i22 | 0) < 4);
   i2 = i30 + 1 | 0;
   if ((i2 | 0) < (i35 | 0)) {
    i29 = i30;
    i30 = i2;
    i2 = i29;
   } else {
    i29 = i8;
    continue L27;
   }
  }
 }
 f7 = Math_fround(HEAPF32[i48 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i49 >> 2]));
 f4 = Math_fround(HEAPF32[i45 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i42 >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f56 = Math_fround(f5 * f7);
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (Math_fround(f56 + Math_fround(f6 * f4)) > Math_fround(.0000999999974)) {
  f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(0.0)) + Math_fround(f4 * f4)))));
  f20 = Math_fround(f19 * Math_fround(0.0));
  f56 = Math_fround(f4 * f19);
  HEAPF32[i54 >> 2] = Math_fround(f7 * f19);
  HEAPF32[i54 + 4 >> 2] = f20;
  HEAPF32[i54 + 8 >> 2] = f56;
 } else {
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)))));
  if (f4 > Math_fround(0.0)) {
   f56 = Math_fround(Math_fround(1.0) / f4);
   f20 = Math_fround(f5 * f56);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   f20 = Math_fround(f56 * Math_fround(0.0));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   f56 = Math_fround(f6 * f56);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  } else i2 = 0;
  HEAP32[i54 >> 2] = i3;
  HEAP32[i54 + 4 >> 2] = i2;
  HEAP32[i54 + 8 >> 2] = i1;
 }
 HEAPF32[i53 >> 2] = Math_fround(Math_sqrt(Math_fround(f21)));
 i54 = i29;
 STACKTOP = i55;
 return i54 | 0;
}

function __ZN5physx2Gu28pcmContactCapsuleHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i35, i36, i37, i38, i31, i1, i29) {
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 2864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i39 + 352 | 0;
 i27 = i39 + 336 | 0;
 i30 = i39 + 320 | 0;
 i28 = i39 + 224 | 0;
 i32 = i39 + 48 | 0;
 i7 = i39 + 256 | 0;
 i34 = i39 + 32 | 0;
 i8 = i39 + 16 | 0;
 i9 = i39;
 i33 = i39 + 2832 | 0;
 i26 = i39 + 80 | 0;
 i25 = i39 + 2808 | 0;
 i22 = i39 + 2784 | 0;
 i23 = i39 + 2752 | 0;
 i17 = HEAP32[i1 >> 2] & -16;
 i18 = i35 + 4 | 0;
 HEAP32[i27 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
 i6 = HEAP32[i37 + 4 >> 2] | 0;
 i5 = HEAP32[i37 + 8 >> 2] | 0;
 i57 = HEAP32[i37 + 12 >> 2] | 0;
 i14 = i37 + 16 | 0;
 i53 = HEAP32[i14 >> 2] | 0;
 i52 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = HEAP32[i14 + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = HEAP32[i37 >> 2];
 i15 = i28 + 4 | 0;
 HEAP32[i15 >> 2] = i6;
 i6 = i28 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i5 = i28 + 12 | 0;
 HEAP32[i5 >> 2] = i57;
 HEAP32[i28 + 16 >> 2] = i53;
 HEAP32[i28 + 20 >> 2] = i52;
 HEAP32[i28 + 24 >> 2] = i1;
 HEAPF32[i28 + 28 >> 2] = Math_fround(0.0);
 i57 = HEAP32[i38 >> 2] | 0;
 i56 = HEAP32[i38 + 4 >> 2] | 0;
 i55 = HEAP32[i38 + 8 >> 2] | 0;
 i54 = HEAP32[i38 + 12 >> 2] | 0;
 i16 = i38 + 16 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = HEAP32[i16 + 8 >> 2] | 0;
 HEAP32[i32 >> 2] = i57;
 HEAP32[i32 + 4 >> 2] = i56;
 HEAP32[i32 + 8 >> 2] = i55;
 HEAP32[i32 + 12 >> 2] = i54;
 HEAP32[i32 + 16 >> 2] = i2;
 HEAP32[i32 + 20 >> 2] = i3;
 HEAP32[i32 + 24 >> 2] = i4;
 HEAPF32[i32 + 28 >> 2] = Math_fround(0.0);
 f44 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = Math_fround(-f44);
 f49 = Math_fround(-f49);
 f13 = Math_fround(-f13);
 f21 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = Math_fround(f21 - f48);
 f51 = Math_fround(f40 - f51);
 f42 = Math_fround(f42 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f40 = Math_fround(Math_fround(f45 * f45) + Math_fround(-.5));
 f21 = Math_fround(Math_fround(Math_fround(f48 * f44) + Math_fround(f51 * f49)) + Math_fround(f42 * f13));
 f19 = Math_fround(Math_fround(Math_fround(f21 * f44) + Math_fround(Math_fround(f40 * f48) + Math_fround(f45 * Math_fround(Math_fround(f42 * f49) - Math_fround(f51 * f13))))) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(Math_fround(f21 * f49) + Math_fround(Math_fround(f40 * f51) + Math_fround(f45 * Math_fround(Math_fround(f48 * f13) - Math_fround(f42 * f44))))) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f42) + Math_fround(f45 * Math_fround(Math_fround(f51 * f44) - Math_fround(f48 * f49)))) + Math_fround(f21 * f13)) * Math_fround(2.0));
 f48 = Math_fround(HEAPF32[i28 >> 2]);
 f51 = Math_fround(HEAPF32[i15 >> 2]);
 f42 = Math_fround(HEAPF32[i6 >> 2]);
 f40 = Math_fround(HEAPF32[i5 >> 2]);
 f10 = Math_fround(Math_fround(f45 * f40) - Math_fround(Math_fround(Math_fround(f48 * f44) + Math_fround(f51 * f49)) + Math_fround(f42 * f13)));
 f11 = Math_fround(Math_fround(Math_fround(f42 * f49) - Math_fround(f51 * f13)) + Math_fround(Math_fround(f45 * f48) + Math_fround(f40 * f44)));
 f12 = Math_fround(Math_fround(Math_fround(f48 * f13) - Math_fround(f42 * f44)) + Math_fround(Math_fround(f45 * f51) + Math_fround(f40 * f49)));
 f13 = Math_fround(Math_fround(Math_fround(f51 * f44) - Math_fround(f48 * f49)) + Math_fround(Math_fround(f45 * f42) + Math_fround(f40 * f13)));
 HEAPF32[i7 + 48 >> 2] = f19;
 HEAPF32[i7 + 52 >> 2] = f20;
 HEAPF32[i7 + 56 >> 2] = f21;
 HEAPF32[i7 + 60 >> 2] = Math_fround(0.0);
 f40 = Math_fround(f11 + f11);
 f42 = Math_fround(f12 + f12);
 f45 = Math_fround(f13 + f13);
 f49 = Math_fround(f12 * f42);
 f48 = Math_fround(f13 * f45);
 f44 = Math_fround(f12 * f40);
 f51 = Math_fround(f13 * f40);
 f41 = Math_fround(f10 * f40);
 f50 = Math_fround(f13 * f42);
 f42 = Math_fround(f10 * f42);
 f45 = Math_fround(f10 * f45);
 f40 = Math_fround(Math_fround(1.0) - Math_fround(f11 * f40));
 f47 = Math_fround(f44 + f45);
 f46 = Math_fround(f51 - f42);
 f45 = Math_fround(f44 - f45);
 f44 = Math_fround(f40 - f48);
 f43 = Math_fround(f50 + f41);
 f42 = Math_fround(f51 + f42);
 f41 = Math_fround(f50 - f41);
 f40 = Math_fround(f40 - f49);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f49) - f48);
 HEAPF32[i7 + 4 >> 2] = f47;
 HEAPF32[i7 + 8 >> 2] = f46;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 16 >> 2] = f45;
 HEAPF32[i7 + 20 >> 2] = f44;
 HEAPF32[i7 + 24 >> 2] = f43;
 HEAPF32[i7 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 32 >> 2] = f42;
 HEAPF32[i7 + 36 >> 2] = f41;
 HEAPF32[i7 + 40 >> 2] = f40;
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 f40 = Math_fround(HEAPF32[i27 >> 2]);
 HEAPF32[i34 >> 2] = Math_fround(f40 * Math_fround(.00100000005));
 HEAPF32[i8 >> 2] = Math_fround(f40 * Math_fround(.0500000007));
 i5 = i17 + 53 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 HEAPF32[i9 >> 2] = Math_fround(f40 + Math_fround(HEAPF32[i30 >> 2]));
 i15 = i17 + 52 | 0;
 i4 = HEAP8[i15 >> 0] | 0;
 if (i4 << 24 >> 24) {
  i1 = 0;
  do {
   i2 = i17 + 48 + i1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = i3 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i24, i17 + 64 + (i4 * 400 | 0) | 0, i7, i8, i9);
   if (!(HEAP32[i17 + 64 + (i4 * 400 | 0) + 384 >> 2] | 0)) {
    i56 = (HEAP8[i15 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i15 >> 0] = i56;
    i56 = (i56 & 255) + (i17 + 48) | 0;
    i57 = HEAP8[i56 >> 0] | 0;
    HEAP8[i56 >> 0] = i3;
    HEAP8[i2 >> 0] = i57;
    i1 = i1 + -1 | 0;
   } else HEAP32[i17 + 32 + (i4 << 2) >> 2] = HEAP32[i24 >> 2];
   i1 = i1 + 1 | 0;
   i57 = HEAPU8[i15 >> 0] | 0;
  } while (i1 >>> 0 < i57 >>> 0);
 }
 if ((HEAP8[i5 >> 0] | 0) == i6 << 24 >> 24) {
  f48 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(.0199999996));
  i6 = i17 + 16 | 0;
  f45 = Math_fround(HEAPF32[i6 >> 2]);
  i4 = i17 + 20 | 0;
  f51 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = i17 + 24 | 0;
  f45 = Math_fround(f19 - f45);
  f51 = Math_fround(f20 - f51);
  f50 = Math_fround(f21 - Math_fround(HEAPF32[i2 >> 2]));
  f47 = Math_fround(-f45);
  f46 = Math_fround(-f51);
  f49 = Math_fround(-f50);
  f47 = f45 > f47 ? f45 : f47;
  f46 = f51 > f46 ? f51 : f46;
  f46 = f47 >= f46 ? f47 : f46;
  i1 = (f50 > f49 ? f50 : f49) >= Math_fround(0.0);
  f47 = i1 ? f47 : Math_fround(0.0);
  f49 = Math_fround(HEAPF32[i17 >> 2]);
  i1 = i17 + 4 | 0;
  f50 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = i17 + 8 | 0;
  f51 = Math_fround(HEAPF32[i3 >> 2]);
  i5 = i17 + 12 | 0;
  if ((f46 >= f47 ? f46 : f47) > f48 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f11 * f49) + Math_fround(f12 * f50)) + Math_fround(f13 * f51)) + Math_fround(f10 * Math_fround(HEAPF32[i5 >> 2]))) < Math_fround(.999800026)) {
   i7 = i3;
   i3 = i17;
  } else {
   i57 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i17, i29, i28, i32, i27) | 0;
   STACKTOP = i39;
   return i57 | 0;
  }
 } else {
  i1 = i17 + 4 | 0;
  i7 = i17 + 8 | 0;
  i5 = i17 + 12 | 0;
  i6 = i17 + 16 | 0;
  i4 = i17 + 20 | 0;
  i2 = i17 + 24 | 0;
  i3 = i17;
 }
 HEAP8[i15 >> 0] = 0;
 HEAPF32[i3 >> 2] = f11;
 HEAPF32[i1 >> 2] = f12;
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i5 >> 2] = f10;
 HEAPF32[i6 >> 2] = f19;
 HEAPF32[i4 >> 2] = f20;
 HEAPF32[i2 >> 2] = f21;
 HEAPF32[i17 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i33 + 12 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i33 + 16 >> 2] = i36;
 HEAPF32[i33 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i36 + 8 >> 2]));
 HEAPF32[i33 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i36 + 12 >> 2]));
 HEAPF32[i33 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i36 + 16 >> 2]));
 f42 = Math_fround(HEAPF32[i37 >> 2]);
 f20 = Math_fround(f42 * Math_fround(2.0));
 i9 = i37 + 12 | 0;
 f49 = Math_fround(HEAPF32[i9 >> 2]);
 f41 = Math_fround(f49 * Math_fround(2.0));
 f49 = Math_fround(Math_fround(f42 * f20) + Math_fround(Math_fround(f49 * f41) + Math_fround(-1.0)));
 i15 = i37 + 8 | 0;
 f42 = Math_fround(HEAPF32[i15 >> 2]);
 f44 = Math_fround(f42 * f41);
 i36 = i37 + 4 | 0;
 f19 = Math_fround(HEAPF32[i36 >> 2]);
 f44 = Math_fround(f44 + Math_fround(f20 * f19));
 f19 = Math_fround(Math_fround(f20 * f42) - Math_fround(f41 * f19));
 i55 = i35 + 8 | 0;
 f41 = Math_fround(HEAPF32[i55 >> 2]);
 f49 = Math_fround(f41 * f49);
 f44 = Math_fround(f41 * f44);
 f19 = Math_fround(f41 * f19);
 f41 = Math_fround(HEAPF32[i18 >> 2]);
 f41 = Math_fround(f41 + Math_fround(HEAPF32[i31 >> 2]));
 f42 = Math_fround(HEAPF32[i14 >> 2]);
 f42 = Math_fround(f42 - Math_fround(HEAPF32[i16 >> 2]));
 i8 = i37 + 20 | 0;
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 i18 = i38 + 20 | 0;
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i18 >> 2]));
 i31 = i37 + 24 | 0;
 f45 = Math_fround(HEAPF32[i31 >> 2]);
 i35 = i38 + 24 | 0;
 f42 = Math_fround(f42 * Math_fround(2.0));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f45 - Math_fround(HEAPF32[i35 >> 2])) * Math_fround(2.0));
 i7 = i38 + 12 | 0;
 f46 = Math_fround(HEAPF32[i7 >> 2]);
 f47 = Math_fround(Math_fround(f46 * f46) + Math_fround(-.5));
 f50 = Math_fround(HEAPF32[i38 >> 2]);
 f43 = Math_fround(f42 * f50);
 i5 = i38 + 4 | 0;
 f48 = Math_fround(HEAPF32[i5 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f20 * f48));
 i6 = i38 + 8 | 0;
 f51 = Math_fround(HEAPF32[i6 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f45 * f51));
 f40 = Math_fround(Math_fround(f50 * f43) + Math_fround(Math_fround(f42 * f47) - Math_fround(f46 * Math_fround(Math_fround(f45 * f48) - Math_fround(f20 * f51)))));
 f21 = Math_fround(Math_fround(f48 * f43) + Math_fround(Math_fround(f20 * f47) - Math_fround(f46 * Math_fround(Math_fround(f42 * f51) - Math_fround(f45 * f50)))));
 f43 = Math_fround(Math_fround(Math_fround(f45 * f47) - Math_fround(f46 * Math_fround(Math_fround(f20 * f50) - Math_fround(f42 * f48)))) + Math_fround(f51 * f43));
 f49 = Math_fround(f49 * Math_fround(2.0));
 f44 = Math_fround(f44 * Math_fround(2.0));
 f19 = Math_fround(f19 * Math_fround(2.0));
 f42 = Math_fround(Math_fround(Math_fround(f49 * f50) + Math_fround(f44 * f48)) + Math_fround(f19 * f51));
 f20 = Math_fround(Math_fround(f50 * f42) + Math_fround(Math_fround(f49 * f47) - Math_fround(f46 * Math_fround(Math_fround(f19 * f48) - Math_fround(f44 * f51)))));
 f45 = Math_fround(Math_fround(f48 * f42) + Math_fround(Math_fround(f44 * f47) - Math_fround(f46 * Math_fround(Math_fround(f49 * f51) - Math_fround(f19 * f50)))));
 f42 = Math_fround(Math_fround(Math_fround(f19 * f47) - Math_fround(f46 * Math_fround(Math_fround(f44 * f50) - Math_fround(f49 * f48)))) + Math_fround(f51 * f42));
 i57 = i26 + 64 | 0;
 HEAPF32[i26 >> 2] = f40;
 HEAPF32[i26 + 4 >> 2] = f21;
 HEAPF32[i26 + 8 >> 2] = f43;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i26 + 80 >> 2] = 4;
 HEAPF32[i26 + 48 >> 2] = Math_fround(0.0);
 i54 = i26 + 128 | 0;
 HEAP32[i54 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 f51 = Math_fround(f21 + f45);
 f48 = Math_fround(f43 + f42);
 HEAPF32[i26 + 96 >> 2] = Math_fround(f40 + f20);
 HEAPF32[i26 + 100 >> 2] = f51;
 HEAPF32[i26 + 104 >> 2] = f48;
 HEAPF32[i26 + 108 >> 2] = Math_fround(0.0);
 f45 = Math_fround(f21 - f45);
 f42 = Math_fround(f43 - f42);
 HEAPF32[i26 + 112 >> 2] = Math_fround(f40 - f20);
 HEAPF32[i26 + 116 >> 2] = f45;
 HEAPF32[i26 + 120 >> 2] = f42;
 HEAPF32[i26 + 124 >> 2] = Math_fround(0.0);
 i54 = i26 + 16 | 0;
 HEAP32[i54 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 i54 = i26 + 32 | 0;
 HEAP32[i54 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i24 >> 2] = -1;
 HEAP32[i24 + 4 >> 2] = -1;
 HEAP32[i24 + 8 >> 2] = -1;
 HEAP32[i24 + 12 >> 2] = -1;
 HEAP32[i57 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i57 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i57 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i57 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
 HEAP32[i24 + 4 >> 2] = i33;
 HEAP32[i24 + 8 >> 2] = i38;
 HEAP32[i24 >> 2] = gb + 147032 + 8;
 i57 = i24 + 16 | 0;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i57, i30, i34, i28, i32, i17, i29);
 HEAP32[i24 + 2384 >> 2] = i26;
 f42 = Math_fround(HEAPF32[i26 + 128 >> 2]);
 f42 = Math_fround(f42 + Math_fround(HEAPF32[i30 >> 2]));
 HEAPF32[i24 + 2352 >> 2] = f42;
 HEAPF32[i24 + 2368 >> 2] = Math_fround(f42 * f42);
 i54 = i25 + 12 | 0;
 f42 = Math_fround(f41 + Math_fround(HEAPF32[i55 >> 2]));
 HEAPF32[i54 >> 2] = f42;
 i55 = i25 + 16 | 0;
 HEAPF32[i55 >> 2] = f41;
 i56 = i25 + 20 | 0;
 HEAPF32[i56 >> 2] = f41;
 f41 = Math_fround(-f41);
 HEAPF32[i25 >> 2] = Math_fround(-f42);
 i52 = i25 + 4 | 0;
 HEAPF32[i52 >> 2] = f41;
 i53 = i25 + 8 | 0;
 HEAPF32[i53 >> 2] = f41;
 f41 = Math_fround(-Math_fround(HEAPF32[i38 >> 2]));
 f42 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
 f45 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f20 = Math_fround(HEAPF32[i7 >> 2]);
 f40 = Math_fround(HEAPF32[i14 >> 2]);
 f40 = Math_fround(f40 - Math_fround(HEAPF32[i16 >> 2]));
 f43 = Math_fround(HEAPF32[i8 >> 2]);
 f43 = Math_fround(f43 - Math_fround(HEAPF32[i18 >> 2]));
 f21 = Math_fround(HEAPF32[i31 >> 2]);
 f40 = Math_fround(f40 * Math_fround(2.0));
 f43 = Math_fround(f43 * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f21 - Math_fround(HEAPF32[i35 >> 2])) * Math_fround(2.0));
 f48 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f51 = Math_fround(Math_fround(Math_fround(f40 * f41) + Math_fround(f43 * f42)) + Math_fround(f21 * f45));
 f49 = Math_fround(Math_fround(f51 * f41) + Math_fround(Math_fround(f48 * f40) + Math_fround(f20 * Math_fround(Math_fround(f21 * f42) - Math_fround(f43 * f45)))));
 f50 = Math_fround(Math_fround(f51 * f42) + Math_fround(Math_fround(f48 * f43) + Math_fround(f20 * Math_fround(Math_fround(f40 * f45) - Math_fround(f21 * f41)))));
 f51 = Math_fround(Math_fround(Math_fround(f48 * f21) + Math_fround(f20 * Math_fround(Math_fround(f43 * f41) - Math_fround(f40 * f42)))) + Math_fround(f51 * f45));
 f40 = Math_fround(HEAPF32[i37 >> 2]);
 f43 = Math_fround(f20 * f40);
 f21 = Math_fround(HEAPF32[i9 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f21 * f41));
 f48 = Math_fround(HEAPF32[i15 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f48 * f42));
 f44 = Math_fround(HEAPF32[i36 >> 2]);
 f46 = Math_fround(Math_fround(Math_fround(f40 * f45) + Math_fround(Math_fround(f21 * f42) + Math_fround(f20 * f44))) - Math_fround(f48 * f41));
 f47 = Math_fround(Math_fround(Math_fround(f44 * f41) + Math_fround(Math_fround(f21 * f45) + Math_fround(f20 * f48))) - Math_fround(f40 * f42));
 f48 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f21) - Math_fround(f40 * f41)) - Math_fround(f44 * f42)) - Math_fround(f48 * f45));
 HEAPF32[i23 >> 2] = Math_fround(f43 - Math_fround(f44 * f45));
 HEAPF32[i23 + 4 >> 2] = f46;
 HEAPF32[i23 + 8 >> 2] = f47;
 HEAPF32[i23 + 12 >> 2] = f48;
 HEAPF32[i23 + 16 >> 2] = f49;
 HEAPF32[i23 + 20 >> 2] = f50;
 HEAPF32[i23 + 24 >> 2] = f51;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i22, i23, i25);
 HEAP32[i25 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i52 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i53 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i54 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i55 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i56 >> 2] = HEAP32[i22 + 20 >> 2];
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i33, i38, i25, 0, i24) | 0;
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i57, 3, 0);
 i57 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i17, i29, i28, i32, i27) | 0;
 STACKTOP = i39;
 return i57 | 0;
}

function __ZN23ParticleSystemParticles13array_reserveEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 >= i8 >>> 0) return;
 i6 = i8 << 2;
 if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i6, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i7 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i7 >> 2] = i5;
 }
 i1 = i7 + 20 | 0;
 i2 = i7 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 32 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 40 | 0;
 i2 = i7 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 52 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i3 = i7 + 60 | 0;
 i2 = i7 + 76 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i6, 4, i7 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 72 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 80 | 0;
 i2 = i7 + 96 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 92 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 100 | 0;
 i2 = i7 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 112 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i3 = i7 + 120 | 0;
 i2 = i7 + 136 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i8 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i6, 4, i7 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 132 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i3 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 140 | 0;
 i2 = i7 + 156 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 144 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 144 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 152 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 160 | 0;
 i2 = i7 + 176 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 164 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 164 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 172 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = HEAP8[i7 + 870 >> 0] | 0 ? 0 : 2;
 i2 = i1;
 do {
  i3 = i7 + 300 + (i2 * 20 | 0) | 0;
  i4 = i7 + 300 + (i2 * 20 | 0) + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i8;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i6, 4, i7 + 300 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 300 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 300 + (i2 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i3 >> 2] = i5;
   break;
  } while (0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 3);
 if (HEAP8[i7 + 869 >> 0] | 0) do {
  i2 = i7 + 360 + (i1 * 20 | 0) | 0;
  i3 = i7 + 360 + (i1 * 20 | 0) + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i8;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i7 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 + 360 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i2 >> 2] = i5;
   break;
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 do if (HEAP8[i7 + 872 >> 0] | 0) {
  i1 = i7 + 180 | 0;
  i2 = i7 + 196 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 184 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 184 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 192 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  } while (0);
  i1 = i7 + 200 | 0;
  i2 = i7 + 216 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 204 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 204 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 212 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  } while (0);
  i1 = i7 + 220 | 0;
  i2 = i7 + 236 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 224 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 224 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 232 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  }
 } while (0);
 i1 = i7 + 420 | 0;
 i2 = i7 + 436 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 424 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 424 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 432 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 do if (HEAP8[i7 + 871 >> 0] | 0) {
  i1 = i7 + 440 | 0;
  i2 = i7 + 456 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 444 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 444 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 452 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  } while (0);
  i1 = i7 + 460 | 0;
  i2 = i7 + 476 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 464 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 464 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 472 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  }
 } while (0);
 i1 = i7 + 480 | 0;
 i2 = i7 + 496 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 484 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 484 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 492 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 500 | 0;
 i2 = i7 + 516 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 504 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 504 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 512 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 520 | 0;
 i2 = i7 + 536 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 524 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 524 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 532 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i1 = i7 + 540 | 0;
 i2 = i7 + 556 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 544 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 544 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 552 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 do if (HEAP8[i7 + 868 >> 0] | 0) {
  i1 = i7 + 240 | 0;
  i2 = i7 + 256 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 244 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 244 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 252 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  } while (0);
  i1 = i7 + 260 | 0;
  i2 = i7 + 276 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 264 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 264 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 272 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  } while (0);
  i1 = i7 + 280 | 0;
  i2 = i7 + 296 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & 2147483647) >>> 0 >= i8 >>> 0) break;
  if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 4, i7 + 284 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 284 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 292 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = i5;
   break;
  }
 } while (0);
 i2 = i7 + 880 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i3 = i7 + 560 + (i1 * 20 | 0) | 0;
   i4 = i7 + 560 + (i1 * 20 | 0) + 16 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i8;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i6, 4, i7 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 560 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i8;
    HEAP32[i3 >> 2] = i5;
    break;
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 do if (HEAP8[i7 + 873 >> 0] | 0) {
  if ((HEAP32[i7 + 612 >> 2] | 0) >>> 0 >= i8 >>> 0) break;
  __ZN14dynamic_bitset6resizeEjb(i7 + 600 | 0, i8, 0);
 } while (0);
 do if (HEAP8[i7 + 876 >> 0] | 0) {
  if ((HEAP32[i7 + 732 >> 2] | 0) >>> 0 >= i8 >>> 0) break;
  __ZN14dynamic_bitset6resizeEjb(i7 + 720 | 0, i8, 0);
 } while (0);
 if (HEAP8[i7 + 874 >> 0] | 0) __ZN14ParticleTrails10ReallocateEjj(i7 + 740 | 0, i8, -1);
 i4 = i8 << 4;
 i1 = i7 + 828 | 0;
 i2 = i7 + 844 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = i3 & 2147483647;
 do if ((i6 | 0) != 0 & i6 >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i4, 4, i7 + 832 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i7 + 832 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 840 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 i1 = i7 + 848 | 0;
 i2 = i7 + 864 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = i3 & 2147483647;
 if (!((i6 | 0) != 0 & i6 >>> 0 < i8 >>> 0)) return;
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i4, 4, i7 + 852 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i7 + 852 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 + 860 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i6;
  return;
 }
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i51, i53, i58, i1, i78, i79, i80, i81, i83, i85, i71) {
 i51 = i51 | 0;
 i53 = i53 | 0;
 i58 = i58 | 0;
 i1 = i1 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 i80 = i80 | 0;
 i81 = i81 | 0;
 i83 = i83 | 0;
 i85 = i85 | 0;
 i71 = i71 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f52 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, f70 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i82 = 0, i84 = 0, i86 = 0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0;
 i86 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i86 + 288 | 0;
 i65 = i86 + 468 | 0;
 i64 = i86 + 456 | 0;
 i76 = i86 + 304 | 0;
 i74 = i86 + 224 | 0;
 i75 = i86 + 160 | 0;
 i82 = i86 + 440 | 0;
 i84 = i86 + 424 | 0;
 i59 = i86 + 416 | 0;
 i77 = i86 + 144 | 0;
 i28 = i86 + 128 | 0;
 i27 = i86 + 112 | 0;
 i29 = i86 + 404 | 0;
 i30 = i86 + 96 | 0;
 i60 = i86 + 80 | 0;
 i67 = i86 + 64 | 0;
 i68 = i86 + 48 | 0;
 i66 = i86 + 392 | 0;
 i56 = i86 + 32 | 0;
 i55 = i86 + 380 | 0;
 i62 = i86 + 16 | 0;
 i63 = i86;
 i61 = i86 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f72 = Math_fround(HEAPF32[i51 + 16 >> 2]);
 i57 = i53 + 16 | 0;
 f73 = Math_fround(HEAPF32[i57 >> 2]);
 f52 = Math_fround(HEAPF32[i1 >> 2]);
 f54 = Math_fround(HEAPF32[i51 + 32 >> 2]);
 f70 = Math_fround(HEAPF32[i53 + 32 >> 2]);
 f54 = Math_fround((f54 > f70 ? f70 : f54) * Math_fround(.100000001));
 f54 = Math_fround(f54 * f54);
 f70 = Math_fround(f72 + f73);
 HEAP32[i59 >> 2] = 0;
 i1 = HEAP8[i71 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  i50 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i50 ? f5 : Math_fround(1.0);
  f6 = i50 ? f6 : Math_fround(0.0);
  f7 = i50 ? f7 : Math_fround(0.0);
  HEAPF32[i77 >> 2] = f5;
  HEAPF32[i77 + 4 >> 2] = f6;
  HEAPF32[i77 + 8 >> 2] = f7;
  HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i30 >> 2] = HEAP32[i77 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
  i50 = i77;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i69 = 7;
 } else {
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i9 = i51 + 96 | 0;
  f4 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i58 >> 2]);
  f10 = Math_fround(HEAPF32[i58 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i58 + 32 >> 2]);
  f12 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i58 + 20 >> 2]);
  f14 = Math_fround(HEAPF32[i58 + 36 >> 2]);
  f15 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i58 + 24 >> 2]);
  f17 = Math_fround(HEAPF32[i58 + 40 >> 2]);
  f18 = Math_fround(HEAPF32[i53 + 144 >> 2]);
  f19 = Math_fround(HEAPF32[i53 + 148 >> 2]);
  f18 = Math_fround(f18 - f73);
  f19 = Math_fround(f19 - f73);
  f20 = Math_fround(Math_fround(HEAPF32[i53 + 152 >> 2]) - f73);
  f21 = Math_fround(-f18);
  f22 = Math_fround(-f19);
  f23 = Math_fround(-f20);
  i24 = i28 + 4 | 0;
  i25 = i28 + 8 | 0;
  i26 = i28 + 12 | 0;
  i2 = i1 & 255;
  i8 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i49 = HEAPU8[i83 + i3 >> 0] | 0;
   HEAP32[i82 + (i3 << 2) >> 2] = i49;
   i50 = HEAPU8[i85 + i3 >> 0] | 0;
   HEAP32[i84 + (i3 << 2) >> 2] = i50;
   i49 = 1 - i49 | 0;
   f88 = Math_fround(HEAPF32[i9 + (i49 << 4) >> 2]);
   f89 = Math_fround(HEAPF32[i9 + (i49 << 4) + 4 >> 2]);
   f90 = Math_fround(HEAPF32[i9 + (i49 << 4) + 8 >> 2]);
   f92 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f88 * f7) + Math_fround(f89 * f10)) + Math_fround(f90 * f11)));
   f91 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f88 * f12) + Math_fround(f89 * f13)) + Math_fround(f90 * f14)));
   f90 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f88 * f15) + Math_fround(f89 * f16)) + Math_fround(f90 * f17)));
   f89 = HEAP32[gb + 48 + (i50 << 4) >> 2] | 0 ? f18 : f21;
   f88 = HEAP32[gb + 48 + (i50 << 4) + 4 >> 2] | 0 ? f19 : f22;
   f87 = HEAP32[gb + 48 + (i50 << 4) + 8 >> 2] | 0 ? f20 : f23;
   f94 = Math_fround(f91 - f88);
   f93 = Math_fround(f90 - f87);
   HEAPF32[i28 >> 2] = Math_fround(f92 - f89);
   HEAPF32[i24 >> 2] = f94;
   HEAPF32[i25 >> 2] = f93;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i74 + (i1 << 4) >> 2] = f92;
   HEAPF32[i74 + (i1 << 4) + 4 >> 2] = f91;
   HEAPF32[i74 + (i1 << 4) + 8 >> 2] = f90;
   HEAPF32[i74 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i75 + (i1 << 4) >> 2] = f89;
   HEAPF32[i75 + (i1 << 4) + 4 >> 2] = f88;
   HEAPF32[i75 + (i1 << 4) + 8 >> 2] = f87;
   HEAPF32[i75 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i50 = i76 + (i1 << 4) | 0;
   HEAP32[i50 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i59 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i27, i76, i74, i75, i82, i84, i28, i59);
  HEAP32[i77 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i77 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i77 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i77 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i77 >> 2]);
  f6 = Math_fround(HEAPF32[i77 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i77 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i65 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i64 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i30 >> 2] = HEAP32[i77 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
  if (f4 > f54) {
   i50 = i77;
   i69 = 7;
  } else i2 = HEAP32[i59 >> 2] | 0;
 }
 do if ((i69 | 0) == 7) {
  i48 = i77 + 4 | 0;
  i49 = i77 + 8 | 0;
  i24 = i58 + 4 | 0;
  i25 = i58 + 8 | 0;
  i26 = i58 + 16 | 0;
  i27 = i58 + 20 | 0;
  i28 = i58 + 24 | 0;
  i29 = i58 + 32 | 0;
  i31 = i58 + 36 | 0;
  i32 = i58 + 40 | 0;
  i33 = i51 + 96 | 0;
  i34 = i51 + 100 | 0;
  i35 = i51 + 104 | 0;
  i36 = i51 + 112 | 0;
  i37 = i51 + 116 | 0;
  i38 = i51 + 120 | 0;
  i39 = i58 + 48 | 0;
  i40 = i58 + 52 | 0;
  i41 = i58 + 56 | 0;
  i42 = i53 + 144 | 0;
  i43 = i53 + 148 | 0;
  i44 = i53 + 152 | 0;
  i45 = i60 + 4 | 0;
  i46 = i60 + 8 | 0;
  i47 = i60 + 12 | 0;
  i9 = i51 + 48 | 0;
  i8 = i53 + 48 | 0;
  f11 = f52;
  while (1) {
   HEAP32[i64 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i64 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
   HEAP32[i64 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
   HEAP32[i30 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
   f52 = Math_fround(-f5);
   f18 = Math_fround(-f6);
   f17 = Math_fround(-f7);
   i3 = HEAP32[i59 >> 2] | 0;
   f20 = Math_fround(HEAPF32[i58 >> 2]);
   f15 = Math_fround(f20 * f52);
   f23 = Math_fround(HEAPF32[i24 >> 2]);
   f15 = Math_fround(f15 + Math_fround(f23 * f18));
   f92 = Math_fround(HEAPF32[i25 >> 2]);
   f15 = Math_fround(f15 + Math_fround(f92 * f17));
   f21 = Math_fround(HEAPF32[i26 >> 2]);
   f16 = Math_fround(f21 * f52);
   f94 = Math_fround(HEAPF32[i27 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f94 * f18));
   f90 = Math_fround(HEAPF32[i28 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f90 * f17));
   f91 = Math_fround(HEAPF32[i29 >> 2]);
   f52 = Math_fround(f91 * f52);
   f93 = Math_fround(HEAPF32[i31 >> 2]);
   f18 = Math_fround(f52 + Math_fround(f93 * f18));
   f52 = Math_fround(HEAPF32[i32 >> 2]);
   f17 = Math_fround(f18 + Math_fround(f52 * f17));
   f18 = Math_fround(HEAPF32[i33 >> 2]);
   f22 = Math_fround(HEAPF32[i34 >> 2]);
   f19 = Math_fround(HEAPF32[i35 >> 2]);
   f14 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(f16 * f22)) + Math_fround(f17 * f19));
   f88 = Math_fround(HEAPF32[i36 >> 2]);
   f87 = Math_fround(HEAPF32[i37 >> 2]);
   f89 = Math_fround(HEAPF32[i38 >> 2]);
   i51 = f14 > Math_fround(Math_fround(Math_fround(f15 * f88) + Math_fround(f16 * f87)) + Math_fround(f17 * f89));
   HEAP32[i82 + (i3 << 2) >> 2] = i51 & 1;
   f88 = i51 ? f18 : f88;
   f87 = i51 ? f22 : f87;
   f89 = i51 ? f19 : f89;
   f19 = Math_fround(HEAPF32[i39 >> 2]);
   f22 = Math_fround(HEAPF32[i40 >> 2]);
   f91 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f20 * f88) + Math_fround(f21 * f87)) + Math_fround(f91 * f89)));
   f93 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f23 * f88) + Math_fround(f94 * f87)) + Math_fround(f93 * f89)));
   f89 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + Math_fround(Math_fround(Math_fround(f92 * f88) + Math_fround(f90 * f87)) + Math_fround(f52 * f89)));
   HEAPF32[i74 + (i3 << 4) >> 2] = f91;
   HEAPF32[i74 + (i3 << 4) + 4 >> 2] = f93;
   HEAPF32[i74 + (i3 << 4) + 8 >> 2] = f89;
   HEAPF32[i74 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f52 = Math_fround(HEAPF32[i42 >> 2]);
   f87 = Math_fround(HEAPF32[i43 >> 2]);
   f90 = Math_fround(HEAPF32[i44 >> 2]);
   f88 = Math_fround(HEAPF32[i57 >> 2]);
   f52 = Math_fround(f52 - f88);
   f87 = Math_fround(f87 - f88);
   f88 = Math_fround(f90 - f88);
   i51 = f5 > Math_fround(0.0);
   i53 = f6 > Math_fround(0.0);
   i2 = f7 > Math_fround(0.0);
   HEAP32[i84 + (i3 << 2) >> 2] = i53 << 31 >> 31 << 1 & 2 | i51 & 1 | i2 << 31 >> 31 << 2 & 4;
   f90 = Math_fround(-f52);
   f92 = Math_fround(-f87);
   f94 = Math_fround(-f88);
   f90 = i51 ? f52 : f90;
   f92 = i53 ? f87 : f92;
   f94 = i2 ? f88 : f94;
   HEAPF32[i75 + (i3 << 4) >> 2] = f90;
   HEAPF32[i75 + (i3 << 4) + 4 >> 2] = f92;
   HEAPF32[i75 + (i3 << 4) + 8 >> 2] = f94;
   HEAPF32[i75 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f90 = Math_fround(f91 - f90);
   f92 = Math_fround(f93 - f92);
   f94 = Math_fround(f89 - f94);
   HEAPF32[i60 >> 2] = f90;
   HEAPF32[i45 >> 2] = f92;
   HEAPF32[i46 >> 2] = f94;
   HEAPF32[i47 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i59 >> 2] | 0;
   i2 = i76 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
   f89 = Math_fround(HEAPF32[i9 >> 2]);
   f93 = Math_fround(HEAPF32[i8 >> 2]);
   f93 = f89 > f93 ? f89 : f93;
   f11 = f11 > f93 ? f11 : f93;
   f93 = Math_fround(f70 + f11);
   f93 = Math_fround(f4 * Math_fround(f93 * f93));
   f89 = Math_fround(HEAPF32[i77 >> 2]);
   f91 = Math_fround(HEAPF32[i48 >> 2]);
   f94 = Math_fround(Math_fround(Math_fround(f89 * f90) + Math_fround(f91 * f92)) + Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f94));
   i2 = f94 > Math_fround(0.0) & Math_fround(f94 * f94) > f93;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f94) | i2) {
    i69 = 9;
    break;
   }
   HEAP32[i59 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i56, i76, i74, i75, i82, i84, i60, i59);
   HEAP32[i50 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i77 >> 2]);
   f6 = Math_fround(HEAPF32[i48 >> 2]);
   f7 = Math_fround(HEAPF32[i49 >> 2]);
   f10 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i65 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i65 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i65 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   i1 = f4 > f10;
   if (!(f10 > f54 & i1)) break; else f4 = f10;
  }
  if ((i69 | 0) == 9) {
   if (i83 | 0) {
    HEAP8[i71 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i83 + i1 >> 0] = HEAP32[i82 + (i1 << 2) >> 2];
      HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i85 = 0;
    STACKTOP = i86;
    return i85 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i76, i74, i75, i77, i67, i68, i3);
   f91 = Math_fround(Math_sqrt(Math_fround(f4)));
   f92 = Math_fround(HEAPF32[i77 >> 2]);
   f93 = Math_fround(HEAPF32[i48 >> 2]);
   f94 = Math_fround(Math_fround(1.0) / f91);
   f92 = Math_fround(f92 * f94);
   f93 = Math_fround(f93 * f94);
   f94 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f94);
   f90 = Math_fround(HEAPF32[i67 >> 2]);
   f89 = Math_fround(HEAPF32[i67 + 4 >> 2]);
   f89 = Math_fround(f89 - Math_fround(f72 * f93));
   f88 = Math_fround(Math_fround(HEAPF32[i67 + 8 >> 2]) - Math_fround(f72 * f94));
   HEAPF32[i78 >> 2] = Math_fround(f90 - Math_fround(f72 * f92));
   HEAPF32[i78 + 4 >> 2] = f89;
   HEAPF32[i78 + 8 >> 2] = f88;
   HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
   f88 = Math_fround(HEAPF32[i68 >> 2]);
   f89 = Math_fround(HEAPF32[i68 + 4 >> 2]);
   f89 = Math_fround(Math_fround(f73 * f93) + f89);
   f90 = Math_fround(Math_fround(f73 * f94) + Math_fround(HEAPF32[i68 + 8 >> 2]));
   HEAPF32[i79 >> 2] = Math_fround(Math_fround(f73 * f92) + f88);
   HEAPF32[i79 + 4 >> 2] = f89;
   HEAPF32[i79 + 8 >> 2] = f90;
   HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i81 >> 2] = Math_fround(f91 - f70);
   i85 = i81 + 4 | 0;
   HEAP32[i85 >> 2] = HEAP32[i66 >> 2];
   HEAP32[i85 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
   HEAP32[i85 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
   HEAPF32[i80 >> 2] = f92;
   HEAPF32[i80 + 4 >> 2] = f93;
   HEAPF32[i80 + 8 >> 2] = f94;
   HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
   i85 = 1;
   STACKTOP = i86;
   return i85 | 0;
  }
  i2 = HEAP32[i59 >> 2] | 0;
  if (i1) {
   if (!i83) i1 = 6; else break;
   STACKTOP = i86;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i83 | 0) {
   HEAP8[i71 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i83 + i1 >> 0] = HEAP32[i82 + (i1 << 2) >> 2];
     HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i50 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i50 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i76, i74, i75, i77, i62, i63, i2);
  HEAP32[i65 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  f91 = Math_fround(Math_sqrt(Math_fround(f4)));
  f92 = Math_fround(HEAPF32[i77 >> 2]);
  f93 = Math_fround(HEAPF32[i77 + 4 >> 2]);
  f94 = Math_fround(Math_fround(1.0) / f91);
  f92 = Math_fround(f92 * f94);
  f93 = Math_fround(f93 * f94);
  f94 = Math_fround(Math_fround(HEAPF32[i77 + 8 >> 2]) * f94);
  f90 = Math_fround(HEAPF32[i62 >> 2]);
  f89 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f89 = Math_fround(f89 - Math_fround(f72 * f93));
  f88 = Math_fround(Math_fround(HEAPF32[i62 + 8 >> 2]) - Math_fround(f72 * f94));
  HEAPF32[i78 >> 2] = Math_fround(f90 - Math_fround(f72 * f92));
  HEAPF32[i78 + 4 >> 2] = f89;
  HEAPF32[i78 + 8 >> 2] = f88;
  HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
  f88 = Math_fround(HEAPF32[i63 >> 2]);
  f89 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f89 = Math_fround(Math_fround(f73 * f93) + f89);
  f90 = Math_fround(Math_fround(f73 * f94) + Math_fround(HEAPF32[i63 + 8 >> 2]));
  HEAPF32[i79 >> 2] = Math_fround(Math_fround(f73 * f92) + f88);
  HEAPF32[i79 + 4 >> 2] = f89;
  HEAPF32[i79 + 8 >> 2] = f90;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i81 >> 2] = Math_fround(f91 - f70);
  i85 = i81 + 4 | 0;
  HEAP32[i85 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i85 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i85 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAPF32[i80 >> 2] = f92;
  HEAPF32[i80 + 4 >> 2] = f93;
  HEAPF32[i80 + 8 >> 2] = f94;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  i85 = 3;
  STACKTOP = i86;
  return i85 | 0;
 } while (0);
 HEAP8[i71 >> 0] = i2;
 if (!i2) {
  i85 = 6;
  STACKTOP = i86;
  return i85 | 0;
 } else i1 = 0;
 do {
  HEAP8[i83 + i1 >> 0] = HEAP32[i82 + (i1 << 2) >> 2];
  HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i86;
 return i1 | 0;
}

function __ZN5physx2Gu18pcmContactPlaneBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i1, i6, i3, i4, i5, i2, i53) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i53 = i53 | 0;
 var f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, f55 = f0, f56 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i52 + 112 | 0;
 i50 = i52 + 96 | 0;
 i33 = i52 + 80 | 0;
 i1 = i52 + 64 | 0;
 i54 = i52;
 i49 = HEAP32[i2 >> 2] | 0;
 f44 = Math_fround(HEAPF32[i4 >> 2]);
 f41 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i2 = i4 + 16 | 0;
 f48 = Math_fround(HEAPF32[i2 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 i45 = HEAP32[i3 + 12 >> 2] | 0;
 i32 = i3 + 16 | 0;
 i35 = HEAP32[i32 >> 2] | 0;
 i34 = HEAP32[i32 + 4 >> 2] | 0;
 i32 = HEAP32[i32 + 8 >> 2] | 0;
 HEAP32[i51 >> 2] = i2;
 HEAP32[i51 + 4 >> 2] = i4;
 HEAP32[i51 + 8 >> 2] = i8;
 HEAP32[i51 + 12 >> 2] = i45;
 HEAP32[i51 + 16 >> 2] = i35;
 HEAP32[i51 + 20 >> 2] = i34;
 HEAP32[i51 + 24 >> 2] = i32;
 HEAPF32[i51 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(-f42);
 f14 = Math_fround(-f13);
 f31 = Math_fround(-f39);
 f12 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f48 - f12);
 f9 = Math_fround(f29 - f9);
 f10 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f29 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f48 = Math_fround(Math_fround(Math_fround(f12 * f40) + Math_fround(f9 * f14)) + Math_fround(f10 * f31));
 f46 = Math_fround(Math_fround(Math_fround(f48 * f40) + Math_fround(Math_fround(f29 * f12) + Math_fround(f15 * Math_fround(Math_fround(f10 * f14) - Math_fround(f9 * f31))))) * Math_fround(2.0));
 f47 = Math_fround(Math_fround(Math_fround(f48 * f14) + Math_fround(Math_fround(f29 * f9) + Math_fround(f15 * Math_fround(Math_fround(f12 * f31) - Math_fround(f10 * f40))))) * Math_fround(2.0));
 f48 = Math_fround(Math_fround(Math_fround(Math_fround(f29 * f10) + Math_fround(f15 * Math_fround(Math_fround(f9 * f40) - Math_fround(f12 * f14)))) + Math_fround(f48 * f31)) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f7 * f15) - Math_fround(Math_fround(Math_fround(f44 * f40) + Math_fround(f41 * f14)) + Math_fround(f11 * f31)));
 f9 = Math_fround(Math_fround(Math_fround(f11 * f14) - Math_fround(f41 * f31)) + Math_fround(Math_fround(f7 * f40) + Math_fround(f44 * f15)));
 f10 = Math_fround(Math_fround(Math_fround(f44 * f31) - Math_fround(f11 * f40)) + Math_fround(Math_fround(f7 * f14) + Math_fround(f41 * f15)));
 f11 = Math_fround(Math_fround(Math_fround(f41 * f40) - Math_fround(f44 * f14)) + Math_fround(Math_fround(f7 * f31) + Math_fround(f11 * f15)));
 f31 = Math_fround(f42 * Math_fround(2.0));
 f7 = Math_fround(f15 * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f31 * f13) + Math_fround(f39 * f7));
 f13 = Math_fround(Math_fround(f31 * f39) - Math_fround(f13 * f7));
 f7 = Math_fround(Math_fround(Math_fround(f42 * f31) + Math_fround(f15 * f7)) + Math_fround(-1.0));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f14 * f14) + Math_fround(f7 * f7))))));
 f14 = Math_fround(-Math_fround(f14 * f15));
 f13 = Math_fround(-Math_fround(f13 * f15));
 HEAPF32[i50 >> 2] = Math_fround(-Math_fround(f7 * f15));
 HEAPF32[i50 + 4 >> 2] = f14;
 HEAPF32[i50 + 8 >> 2] = f13;
 HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i33 >> 2] = HEAP32[i5 >> 2];
 i32 = HEAP32[i6 + 4 >> 2] | 0;
 i34 = HEAP32[i6 + 8 >> 2] | 0;
 i35 = HEAP32[i6 + 12 >> 2] | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = f13 <= f14 ? f13 : f14;
 f7 = Math_fround(Math_fround((f7 <= f15 ? f7 : f15) * Math_fround(.150000006)) * Math_fround(.200000003));
 HEAPF32[i1 >> 2] = f7;
 i45 = i49 + 32 | 0;
 i8 = HEAP8[i45 >> 0] | 0;
 HEAPF32[i54 + 48 >> 2] = f46;
 HEAPF32[i54 + 52 >> 2] = f47;
 HEAPF32[i54 + 56 >> 2] = f48;
 HEAPF32[i54 + 60 >> 2] = Math_fround(0.0);
 f31 = Math_fround(f9 + f9);
 f42 = Math_fround(f10 + f10);
 f39 = Math_fround(f11 + f11);
 f44 = Math_fround(f10 * f42);
 f40 = Math_fround(f11 * f39);
 f41 = Math_fround(f10 * f31);
 f29 = Math_fround(f11 * f31);
 f43 = Math_fround(f12 * f31);
 f30 = Math_fround(f11 * f42);
 f42 = Math_fround(f12 * f42);
 f39 = Math_fround(f12 * f39);
 f31 = Math_fround(Math_fround(1.0) - Math_fround(f9 * f31));
 f36 = Math_fround(Math_fround(Math_fround(1.0) - f44) - f40);
 f37 = Math_fround(f41 + f39);
 f38 = Math_fround(f29 - f42);
 f39 = Math_fround(f41 - f39);
 f40 = Math_fround(f31 - f40);
 f41 = Math_fround(f30 + f43);
 f42 = Math_fround(f29 + f42);
 f43 = Math_fround(f30 - f43);
 f44 = Math_fround(f31 - f44);
 HEAPF32[i54 >> 2] = f36;
 HEAPF32[i54 + 4 >> 2] = f37;
 HEAPF32[i54 + 8 >> 2] = f38;
 HEAPF32[i54 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i54 + 16 >> 2] = f39;
 HEAPF32[i54 + 20 >> 2] = f40;
 HEAPF32[i54 + 24 >> 2] = f41;
 HEAPF32[i54 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i54 + 32 >> 2] = f42;
 HEAPF32[i54 + 36 >> 2] = f43;
 HEAPF32[i54 + 40 >> 2] = f44;
 HEAPF32[i54 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i49, i54, i1, i33);
 if ((HEAP8[i45 >> 0] | 0) == i8 << 24 >> 24) {
  i5 = i49 + 16 | 0;
  f26 = Math_fround(HEAPF32[i5 >> 2]);
  i3 = i49 + 20 | 0;
  f31 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = i49 + 24 | 0;
  f26 = Math_fround(f46 - f26);
  f31 = Math_fround(f47 - f31);
  f30 = Math_fround(f48 - Math_fround(HEAPF32[i1 >> 2]));
  f28 = Math_fround(-f26);
  f27 = Math_fround(-f31);
  f29 = Math_fround(-f30);
  f28 = f26 > f28 ? f26 : f28;
  f27 = f31 > f27 ? f31 : f27;
  f27 = f28 >= f27 ? f28 : f27;
  i2 = (f30 > f29 ? f30 : f29) >= Math_fround(0.0);
  f28 = i2 ? f28 : Math_fround(0.0);
  f29 = Math_fround(HEAPF32[i49 >> 2]);
  i2 = i49 + 4 | 0;
  f30 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i49 + 8 | 0;
  f31 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i49 + 12 | 0;
  if ((f27 >= f28 ? f27 : f28) > f7 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f9 * f29) + Math_fround(f10 * f30)) + Math_fround(f11 * f31)) + Math_fround(f12 * Math_fround(HEAPF32[i6 >> 2]))) < Math_fround(.999800026)) {
   i8 = i2;
   i2 = i49;
  } else {
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i49, i53, i50, i51);
   i54 = HEAP8[i45 >> 0] | 0;
   i54 = i54 << 24 >> 24 != 0;
   STACKTOP = i52;
   return i54 | 0;
  }
 } else {
  i8 = i49 + 4 | 0;
  i4 = i49 + 8 | 0;
  i6 = i49 + 12 | 0;
  i5 = i49 + 16 | 0;
  i3 = i49 + 20 | 0;
  i1 = i49 + 24 | 0;
  i2 = i49;
 }
 HEAP8[i45 >> 0] = 0;
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i8 >> 2] = f10;
 HEAPF32[i4 >> 2] = f11;
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i5 >> 2] = f46;
 HEAPF32[i3 >> 2] = f47;
 HEAPF32[i1 >> 2] = f48;
 HEAPF32[i49 + 28 >> 2] = Math_fround(0.0);
 f29 = Math_fround(-f13);
 f30 = Math_fround(-f14);
 f31 = Math_fround(-f15);
 f18 = Math_fround(f36 * f13);
 f19 = Math_fround(f37 * f13);
 f16 = Math_fround(f38 * f13);
 f24 = Math_fround(f39 * f14);
 f25 = Math_fround(f40 * f14);
 f20 = Math_fround(f41 * f14);
 f26 = Math_fround(f42 * f15);
 f27 = Math_fround(f43 * f15);
 f21 = Math_fround(f44 * f15);
 f28 = Math_fround(-f26);
 f9 = Math_fround(f18 + f24);
 f10 = Math_fround(f19 + f25);
 f11 = Math_fround(f16 + f20);
 f17 = Math_fround(f18 - f24);
 f7 = Math_fround(f26 + f9);
 f12 = Math_fround(f9 - f26);
 f13 = Math_fround(f26 + f17);
 f14 = Math_fround(f17 - f26);
 f15 = Math_fround(f26 - f17);
 f17 = Math_fround(f28 - f17);
 f22 = Math_fround(f26 - f9);
 f28 = Math_fround(f28 - f9);
 f23 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f46);
 if (f23 > f7) {
  f7 = Math_fround(f46 + f7);
  HEAP32[i53 >> 2] = i32;
  HEAP32[i53 + 4 >> 2] = i34;
  HEAP32[i53 + 8 >> 2] = i35;
  HEAPF32[i53 + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f7 * Math_fround(0.0));
  f56 = Math_fround(Math_fround(f47 + Math_fround(f10 + f27)) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(f11 + f21)) - f55);
  HEAPF32[i53 + 16 >> 2] = Math_fround(f7 - f7);
  HEAPF32[i53 + 20 >> 2] = f56;
  HEAPF32[i53 + 24 >> 2] = f55;
  HEAPF32[i53 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + 32 >> 2] = 1065353216;
  HEAP32[i53 + 36 >> 2] = 0;
  HEAP32[i53 + 40 >> 2] = 0;
  HEAPF32[i53 + 44 >> 2] = f7;
  i1 = 1;
 } else i1 = 0;
 if (f23 > f12) {
  f56 = Math_fround(f46 + f12);
  HEAP32[i53 + (i1 * 48 | 0) >> 2] = i32;
  HEAP32[i53 + (i1 * 48 | 0) + 4 >> 2] = i34;
  HEAPF32[i53 + (i1 * 48 | 0) + 8 >> 2] = f31;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f12 = Math_fround(Math_fround(f47 + Math_fround(f10 + Math_fround(f43 * f31))) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(f11 + Math_fround(f44 * f31))) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(f9 + Math_fround(f42 * f31))) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f12;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f13) {
  f56 = Math_fround(f46 + f13);
  HEAP32[i53 + (i1 * 48 | 0) >> 2] = i32;
  HEAPF32[i53 + (i1 * 48 | 0) + 4 >> 2] = f30;
  HEAP32[i53 + (i1 * 48 | 0) + 8 >> 2] = i35;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f13 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(f19 + Math_fround(f40 * f30)) + f27)) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(f16 + Math_fround(f41 * f30)) + f21)) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(f18 + Math_fround(f39 * f30)) + f26)) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f13;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f14) {
  f56 = Math_fround(f46 + f14);
  HEAP32[i53 + (i1 * 48 | 0) >> 2] = i32;
  HEAPF32[i53 + (i1 * 48 | 0) + 4 >> 2] = f30;
  HEAPF32[i53 + (i1 * 48 | 0) + 8 >> 2] = f31;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f19 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(f19 + Math_fround(f40 * f30)) + Math_fround(f43 * f31))) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(f16 + Math_fround(f41 * f30)) + Math_fround(f44 * f31))) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(f18 + Math_fround(f39 * f30)) + Math_fround(f42 * f31))) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f19;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f15) {
  f56 = Math_fround(f46 + f15);
  HEAPF32[i53 + (i1 * 48 | 0) >> 2] = f29;
  HEAP32[i53 + (i1 * 48 | 0) + 4 >> 2] = i34;
  HEAP32[i53 + (i1 * 48 | 0) + 8 >> 2] = i35;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f19 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(Math_fround(f37 * f29) + f25) + f27)) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(Math_fround(f38 * f29) + f20) + f21)) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(Math_fround(f36 * f29) + f24) + f26)) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f19;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f17) {
  f56 = Math_fround(f46 + f17);
  HEAPF32[i53 + (i1 * 48 | 0) >> 2] = f29;
  HEAP32[i53 + (i1 * 48 | 0) + 4 >> 2] = i34;
  HEAPF32[i53 + (i1 * 48 | 0) + 8 >> 2] = f31;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f25 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(Math_fround(f37 * f29) + f25) + Math_fround(f43 * f31))) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(Math_fround(f38 * f29) + f20) + Math_fround(f44 * f31))) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(Math_fround(f36 * f29) + f24) + Math_fround(f42 * f31))) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f25;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f22) {
  f56 = Math_fround(f46 + f22);
  HEAPF32[i53 + (i1 * 48 | 0) >> 2] = f29;
  HEAPF32[i53 + (i1 * 48 | 0) + 4 >> 2] = f30;
  HEAP32[i53 + (i1 * 48 | 0) + 8 >> 2] = i35;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f27 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(Math_fround(f37 * f29) + Math_fround(f40 * f30)) + f27)) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(Math_fround(f38 * f29) + Math_fround(f41 * f30)) + f21)) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(Math_fround(f36 * f29) + Math_fround(f39 * f30)) + f26)) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f27;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 if (f23 > f28) {
  f56 = Math_fround(f46 + f28);
  HEAPF32[i53 + (i1 * 48 | 0) >> 2] = f29;
  HEAPF32[i53 + (i1 * 48 | 0) + 4 >> 2] = f30;
  HEAPF32[i53 + (i1 * 48 | 0) + 8 >> 2] = f31;
  HEAPF32[i53 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  f55 = Math_fround(f56 * Math_fround(0.0));
  f47 = Math_fround(Math_fround(f47 + Math_fround(Math_fround(Math_fround(f37 * f29) + Math_fround(f40 * f30)) + Math_fround(f43 * f31))) - f55);
  f55 = Math_fround(Math_fround(f48 + Math_fround(Math_fround(Math_fround(f38 * f29) + Math_fround(f41 * f30)) + Math_fround(f44 * f31))) - f55);
  HEAPF32[i53 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(Math_fround(f36 * f29) + Math_fround(f39 * f30)) + Math_fround(f42 * f31))) - f56);
  HEAPF32[i53 + (i1 * 48 | 0) + 20 >> 2] = f47;
  HEAPF32[i53 + (i1 * 48 | 0) + 24 >> 2] = f55;
  HEAPF32[i53 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i53 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
  HEAP32[i53 + (i1 * 48 | 0) + 36 >> 2] = 0;
  HEAP32[i53 + (i1 * 48 | 0) + 40 >> 2] = 0;
  HEAPF32[i53 + (i1 * 48 | 0) + 44 >> 2] = f56;
  i1 = i1 + 1 | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold31addBatchManifoldContactsClusterEPKNS0_17PersistentContactEj(i49, i53, i1);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i49, i53, i50, i51);
 i54 = HEAP8[i45 >> 0] | 0;
 i54 = i54 << 24 >> 24 != 0;
 STACKTOP = i52;
 return i54 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i64, i65, i1, i66, i67, i61, i69, i50, i52, i44, i68) {
 i64 = i64 | 0;
 i65 = i65 | 0;
 i1 = i1 | 0;
 i66 = i66 | 0;
 i67 = i67 | 0;
 i61 = i61 | 0;
 i69 = i69 | 0;
 i50 = i50 | 0;
 i52 = i52 | 0;
 i44 = i44 | 0;
 i68 = i68 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, f62 = f0, f63 = f0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i70 + 476 | 0;
 i41 = i70 + 464 | 0;
 i60 = i70 + 208 | 0;
 i59 = i70 + 288 | 0;
 i57 = i70 + 224 | 0;
 i58 = i70 + 144 | 0;
 i49 = i70 + 448 | 0;
 i51 = i70 + 432 | 0;
 i40 = i70 + 128 | 0;
 i39 = i70 + 424 | 0;
 i16 = i70 + 112 | 0;
 i17 = i70 + 412 | 0;
 i18 = i70 + 96 | 0;
 i37 = i70 + 80 | 0;
 i53 = i70 + 64 | 0;
 i56 = i70 + 48 | 0;
 i54 = i70 + 400 | 0;
 i55 = i70 + 388 | 0;
 i38 = i70 + 32 | 0;
 i36 = i70 + 376 | 0;
 i45 = i70 + 16 | 0;
 i48 = i70;
 i47 = i70 + 364 | 0;
 i46 = i70 + 352 | 0;
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 f62 = Math_fround(HEAPF32[i64 + 16 >> 2]);
 f63 = Math_fround(HEAPF32[i65 + 16 >> 2]);
 f32 = Math_fround(HEAPF32[i64 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i65 + 32 >> 2]);
 f32 = Math_fround((f32 > f3 ? f3 : f32) * Math_fround(.100000001));
 f32 = Math_fround(f32 * f32);
 f3 = Math_fround(f62 + f63);
 i33 = i40 + 4 | 0;
 i34 = i40 + 8 | 0;
 i35 = i40 + 12 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 i1 = HEAP8[i44 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f15 = Math_fround(HEAPF32[i64 >> 2]);
  f4 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i65 >> 2]);
  f6 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f5 = Math_fround(f15 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i65 + 8 >> 2]));
  i30 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i30 ? f5 : Math_fround(1.0);
  f6 = i30 ? f6 : Math_fround(0.0);
  f7 = i30 ? f7 : Math_fround(0.0);
  HEAPF32[i60 >> 2] = f5;
  HEAPF32[i60 + 4 >> 2] = f6;
  HEAPF32[i60 + 8 >> 2] = f7;
  HEAPF32[i60 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i18 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
  i30 = i60;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i43 = 6;
 } else {
  i14 = HEAP32[i65 + 200 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i65 + 96 >> 2]);
  f5 = Math_fround(HEAPF32[i65 + 112 >> 2]);
  f6 = Math_fround(HEAPF32[i65 + 128 >> 2]);
  f7 = Math_fround(HEAPF32[i65 + 100 >> 2]);
  f8 = Math_fround(HEAPF32[i65 + 116 >> 2]);
  f9 = Math_fround(HEAPF32[i65 + 132 >> 2]);
  f10 = Math_fround(HEAPF32[i65 + 104 >> 2]);
  f12 = Math_fround(HEAPF32[i65 + 120 >> 2]);
  f15 = Math_fround(HEAPF32[i65 + 136 >> 2]);
  i2 = i1 & 255;
  i11 = 0;
  i13 = 0;
  while (1) {
   i1 = HEAPU8[i50 + i13 >> 0] | 0;
   HEAP32[i49 + (i13 << 2) >> 2] = i1;
   i30 = HEAPU8[i52 + i13 >> 0] | 0;
   HEAP32[i51 + (i13 << 2) >> 2] = i30;
   f76 = Math_fround(HEAPF32[i64 + 96 + (i1 << 4) >> 2]);
   f75 = Math_fround(HEAPF32[i64 + 96 + (i1 << 4) + 4 >> 2]);
   f74 = Math_fround(HEAPF32[i64 + 96 + (i1 << 4) + 8 >> 2]);
   i1 = HEAP32[i64 + 96 + (i1 << 4) + 12 >> 2] | 0;
   f77 = Math_fround(HEAPF32[i14 + (i30 * 12 | 0) >> 2]);
   f78 = Math_fround(HEAPF32[i14 + (i30 * 12 | 0) + 4 >> 2]);
   f71 = Math_fround(HEAPF32[i14 + (i30 * 12 | 0) + 8 >> 2]);
   f73 = Math_fround(Math_fround(Math_fround(f77 * f4) + Math_fround(f78 * f5)) + Math_fround(f71 * f6));
   f72 = Math_fround(Math_fround(Math_fround(f77 * f7) + Math_fround(f78 * f8)) + Math_fround(f71 * f9));
   f71 = Math_fround(Math_fround(Math_fround(f77 * f10) + Math_fround(f78 * f12)) + Math_fround(f71 * f15));
   f78 = Math_fround(f75 - f72);
   f77 = Math_fround(f74 - f71);
   HEAPF32[i40 >> 2] = Math_fround(f76 - f73);
   HEAPF32[i33 >> 2] = f78;
   HEAPF32[i34 >> 2] = f77;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   HEAPF32[i57 + (i11 << 4) >> 2] = f76;
   HEAPF32[i57 + (i11 << 4) + 4 >> 2] = f75;
   HEAPF32[i57 + (i11 << 4) + 8 >> 2] = f74;
   HEAP32[i57 + (i11 << 4) + 12 >> 2] = i1;
   HEAPF32[i58 + (i11 << 4) >> 2] = f73;
   HEAPF32[i58 + (i11 << 4) + 4 >> 2] = f72;
   HEAPF32[i58 + (i11 << 4) + 8 >> 2] = f71;
   HEAPF32[i58 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i11 + 1 | 0;
   i30 = i59 + (i11 << 4) | 0;
   HEAP32[i30 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   i13 = i13 + 1 | 0;
   if (i13 >>> 0 >= i2 >>> 0) break; else i11 = i1;
  }
  HEAP32[i39 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i16, i59, i57, i58, i49, i51, i40, i39);
  HEAP32[i60 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i60 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i60 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i60 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i42 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i41 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i60 + 12 >> 2];
  if (f4 > f32) {
   i30 = i60;
   i43 = 6;
  }
 }
 do if ((i43 | 0) == 6) {
  i2 = i60 + 4 | 0;
  i14 = i60 + 8 | 0;
  i16 = i64 + 96 | 0;
  i17 = i64 + 100 | 0;
  i19 = i64 + 104 | 0;
  i20 = i64 + 112 | 0;
  i21 = i64 + 116 | 0;
  i22 = i64 + 120 | 0;
  i23 = i64 + 128 | 0;
  i24 = i64 + 132 | 0;
  i25 = i64 + 136 | 0;
  i26 = i37 + 4 | 0;
  i27 = i37 + 8 | 0;
  i28 = i64 + 48 | 0;
  i29 = i65 + 48 | 0;
  f8 = f31;
  f15 = f4;
  while (1) {
   HEAP32[i41 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i41 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i41 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   f10 = Math_fround(-f5);
   f12 = Math_fround(-f6);
   f72 = Math_fround(-f7);
   i13 = HEAP32[i39 >> 2] | 0;
   f73 = Math_fround(HEAPF32[i16 >> 2]);
   f6 = Math_fround(HEAPF32[i17 >> 2]);
   f76 = Math_fround(HEAPF32[i19 >> 2]);
   f74 = Math_fround(HEAPF32[i20 >> 2]);
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   f75 = Math_fround(HEAPF32[i22 >> 2]);
   f77 = Math_fround(HEAPF32[i23 >> 2]);
   f4 = Math_fround(HEAPF32[i24 >> 2]);
   f78 = Math_fround(HEAPF32[i25 >> 2]);
   f31 = Math_fround(Math_fround(Math_fround(f73 * f10) + Math_fround(f6 * f12)) + Math_fround(f76 * f72));
   f71 = Math_fround(Math_fround(Math_fround(f74 * f10) + Math_fround(f5 * f12)) + Math_fround(f75 * f72));
   f72 = Math_fround(Math_fround(Math_fround(f77 * f10) + Math_fround(f4 * f12)) + Math_fround(f78 * f72));
   i1 = f31 > f71 & f31 > f72;
   i11 = f71 > f72;
   HEAP32[i49 + (i13 << 2) >> 2] = i1 ? 0 : i11 ? 1 : 2;
   f77 = i1 ? f73 : i11 ? f74 : f77;
   f4 = i1 ? f6 : i11 ? f5 : f4;
   f78 = i1 ? f76 : i11 ? f75 : f78;
   HEAPF32[i57 + (i13 << 4) >> 2] = f77;
   HEAPF32[i57 + (i13 << 4) + 4 >> 2] = f4;
   HEAPF32[i57 + (i13 << 4) + 8 >> 2] = f78;
   HEAPF32[i57 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i37, i65, i60, i58 + (i13 << 4) | 0, i51 + (i13 << 2) | 0);
   f75 = Math_fround(HEAPF32[i37 >> 2]);
   f76 = Math_fround(HEAPF32[i26 >> 2]);
   f75 = Math_fround(f77 - f75);
   f76 = Math_fround(f4 - f76);
   f78 = Math_fround(f78 - Math_fround(HEAPF32[i27 >> 2]));
   HEAPF32[i40 >> 2] = f75;
   HEAPF32[i33 >> 2] = f76;
   HEAPF32[i34 >> 2] = f78;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i39 >> 2] | 0;
   i11 = i59 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i28 >> 2]);
   f77 = Math_fround(HEAPF32[i29 >> 2]);
   f77 = f4 > f77 ? f4 : f77;
   f8 = f8 > f77 ? f8 : f77;
   f77 = Math_fround(f3 + f8);
   f77 = Math_fround(f15 * Math_fround(f77 * f77));
   f4 = Math_fround(HEAPF32[i60 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f4 * f75) + Math_fround(f5 * f76)) + Math_fround(f6 * f78));
   i11 = f78 > Math_fround(0.0) & Math_fround(f78 * f78) > f77;
   if (Math_fround(f15 * Math_fround(.00039999999)) >= Math_fround(f15 - f78) | i11) {
    f7 = f15;
    i43 = 8;
    break;
   }
   HEAP32[i39 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i38, i59, i57, i58, i49, i51, i40, i39);
   HEAP32[i30 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i60 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i42 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   i1 = f15 > f4;
   if (!(f4 > f32 & i1)) break; else f15 = f4;
  }
  if ((i43 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i50 | 0) {
    HEAP8[i44 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
      HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i69 = 0;
    STACKTOP = i70;
    return i69 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i61 >> 2] = f9;
   HEAPF32[i61 + 4 >> 2] = f8;
   HEAPF32[i61 + 8 >> 2] = f7;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i59, i57, i58, i60, i53, i56, i13);
   f5 = Math_fround(HEAPF32[i53 >> 2]);
   f6 = Math_fround(HEAPF32[i53 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i53 + 8 >> 2]);
   if (i68) {
    f77 = HEAP32[i64 + 64 >> 2] | 0 ? Math_fround(0.0) : f62;
    f74 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
    f78 = Math_fround(f77 + f74);
    f76 = Math_fround(f6 - Math_fround(f8 * f77));
    f75 = Math_fround(f4 - Math_fround(f7 * f77));
    HEAPF32[i66 >> 2] = Math_fround(f5 - Math_fround(f9 * f77));
    HEAPF32[i66 + 4 >> 2] = f76;
    HEAPF32[i66 + 8 >> 2] = f75;
    HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
    f75 = Math_fround(HEAPF32[i56 >> 2]);
    f76 = Math_fround(HEAPF32[i56 + 4 >> 2]);
    f76 = Math_fround(Math_fround(f8 * f74) + f76);
    f77 = Math_fround(Math_fround(f7 * f74) + Math_fround(HEAPF32[i56 + 8 >> 2]));
    HEAPF32[i67 >> 2] = Math_fround(Math_fround(f9 * f74) + f75);
    HEAPF32[i67 + 4 >> 2] = f76;
    HEAPF32[i67 + 8 >> 2] = f77;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i69 >> 2] = Math_fround(f10 - f78);
    i69 = i69 + 4 | 0;
    HEAP32[i69 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i69 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
    HEAP32[i69 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
    i69 = 1;
    STACKTOP = i70;
    return i69 | 0;
   } else {
    f77 = Math_fround(f6 - Math_fround(f62 * f8));
    f76 = Math_fround(f4 - Math_fround(f62 * f7));
    HEAPF32[i66 >> 2] = Math_fround(f5 - Math_fround(f62 * f9));
    HEAPF32[i66 + 4 >> 2] = f77;
    HEAPF32[i66 + 8 >> 2] = f76;
    HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
    f76 = Math_fround(HEAPF32[i56 >> 2]);
    f77 = Math_fround(HEAPF32[i56 + 4 >> 2]);
    f77 = Math_fround(Math_fround(f63 * f8) + f77);
    f78 = Math_fround(Math_fround(f63 * f7) + Math_fround(HEAPF32[i56 + 8 >> 2]));
    HEAPF32[i67 >> 2] = Math_fround(Math_fround(f63 * f9) + f76);
    HEAPF32[i67 + 4 >> 2] = f77;
    HEAPF32[i67 + 8 >> 2] = f78;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i69 >> 2] = Math_fround(f10 - f3);
    i69 = i69 + 4 | 0;
    HEAP32[i69 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i69 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i69 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    i69 = 1;
    STACKTOP = i70;
    return i69 | 0;
   }
  }
  if (i1) {
   if (!i50) i1 = 6; else break;
   STACKTOP = i70;
   return i1 | 0;
  };
  HEAP32[i42 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  i11 = HEAP32[i39 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i50 | 0) {
   HEAP8[i44 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
     HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i30 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i59, i57, i58, i60, i45, i48, i11);
  HEAP32[i42 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f15)));
  f9 = Math_fround(HEAPF32[i60 >> 2]);
  f10 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i60 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i45 >> 2]);
  f6 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  if (i68) {
   f78 = HEAP32[i64 + 64 >> 2] | 0 ? Math_fround(0.0) : f62;
   f75 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
   f3 = Math_fround(f78 + f75);
   f77 = Math_fround(f6 - Math_fround(f10 * f78));
   f76 = Math_fround(f4 - Math_fround(f7 * f78));
   HEAPF32[i66 >> 2] = Math_fround(f5 - Math_fround(f9 * f78));
   HEAPF32[i66 + 4 >> 2] = f77;
   HEAPF32[i66 + 8 >> 2] = f76;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   f76 = Math_fround(HEAPF32[i48 >> 2]);
   f77 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f77 = Math_fround(Math_fround(f10 * f75) + f77);
   f78 = Math_fround(Math_fround(f7 * f75) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i67 >> 2] = Math_fround(Math_fround(f9 * f75) + f76);
   HEAPF32[i67 + 4 >> 2] = f77;
   HEAPF32[i67 + 8 >> 2] = f78;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   i68 = i69 + 4 | 0;
   HEAP32[i68 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i68 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
   HEAP32[i68 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  } else {
   f77 = Math_fround(f6 - Math_fround(f62 * f10));
   f76 = Math_fround(f4 - Math_fround(f62 * f7));
   HEAPF32[i66 >> 2] = Math_fround(f5 - Math_fround(f62 * f9));
   HEAPF32[i66 + 4 >> 2] = f77;
   HEAPF32[i66 + 8 >> 2] = f76;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   f76 = Math_fround(HEAPF32[i48 >> 2]);
   f77 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f77 = Math_fround(Math_fround(f63 * f10) + f77);
   f78 = Math_fround(Math_fround(f63 * f7) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i67 >> 2] = Math_fround(Math_fround(f63 * f9) + f76);
   HEAPF32[i67 + 4 >> 2] = f77;
   HEAPF32[i67 + 8 >> 2] = f78;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   i68 = i69 + 4 | 0;
   HEAP32[i68 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i68 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i68 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  }
  HEAPF32[i69 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i61 >> 2] = f9;
  HEAPF32[i61 + 4 >> 2] = f10;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  i69 = f12 >= f15 ? 1 : 3;
  STACKTOP = i70;
  return i69 | 0;
 } while (0);
 i2 = HEAP32[i39 >> 2] | 0;
 HEAP8[i44 >> 0] = i2;
 if (!i2) {
  i69 = 6;
  STACKTOP = i70;
  return i69 | 0;
 } else i1 = 0;
 do {
  HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
  HEAP8[i52 + i1 >> 0] = HEAP32[i51 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i70;
 return i1 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i50, i56, i55, i1, i77, i78, i79, i80, i82, i84, i70) {
 i50 = i50 | 0;
 i56 = i56 | 0;
 i55 = i55 | 0;
 i1 = i1 | 0;
 i77 = i77 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 i80 = i80 | 0;
 i82 = i82 | 0;
 i84 = i84 | 0;
 i70 = i70 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f71 = f0, f72 = f0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i81 = 0, i83 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i85 + 304 | 0;
 i64 = i85 + 484 | 0;
 i63 = i85 + 472 | 0;
 i75 = i85 + 320 | 0;
 i73 = i85 + 240 | 0;
 i74 = i85 + 176 | 0;
 i81 = i85 + 456 | 0;
 i83 = i85 + 440 | 0;
 i57 = i85 + 432 | 0;
 i76 = i85 + 160 | 0;
 i33 = i85 + 144 | 0;
 i32 = i85 + 128 | 0;
 i34 = i85 + 420 | 0;
 i35 = i85 + 112 | 0;
 i59 = i85 + 96 | 0;
 i58 = i85 + 80 | 0;
 i66 = i85 + 64 | 0;
 i67 = i85 + 48 | 0;
 i65 = i85 + 408 | 0;
 i54 = i85 + 32 | 0;
 i53 = i85 + 396 | 0;
 i61 = i85 + 16 | 0;
 i62 = i85;
 i60 = i85 + 384 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f71 = Math_fround(HEAPF32[i50 + 16 >> 2]);
 f72 = Math_fround(HEAPF32[i56 + 16 >> 2]);
 f51 = Math_fround(HEAPF32[i1 >> 2]);
 f52 = Math_fround(HEAPF32[i50 + 32 >> 2]);
 f69 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f52 = Math_fround((f52 > f69 ? f69 : f52) * Math_fround(.100000001));
 f52 = Math_fround(f52 * f52);
 f69 = Math_fround(f71 + f72);
 HEAP32[i57 >> 2] = 0;
 if (!(HEAP8[i70 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i55 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 56 >> 2]);
  i49 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i49 ? f5 : Math_fround(1.0);
  f6 = i49 ? f6 : Math_fround(0.0);
  f7 = i49 ? f7 : Math_fround(0.0);
  HEAPF32[i76 >> 2] = f5;
  HEAPF32[i76 + 4 >> 2] = f6;
  HEAPF32[i76 + 8 >> 2] = f7;
  HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i35 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  i49 = i76;
  i48 = i35;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i68 = 7;
 } else {
  HEAP32[i33 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i25 = i50 + 144 | 0;
  i26 = i50 + 148 | 0;
  i27 = i50 + 152 | 0;
  i28 = i33 + 4 | 0;
  i29 = i33 + 8 | 0;
  i30 = i33 + 12 | 0;
  f4 = Math_fround(HEAPF32[i55 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i55 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i55 >> 2]);
  f8 = Math_fround(HEAPF32[i55 + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i55 + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i55 + 20 >> 2]);
  f12 = Math_fround(HEAPF32[i55 + 36 >> 2]);
  f13 = Math_fround(HEAPF32[i55 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i55 + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i55 + 40 >> 2]);
  i2 = HEAP32[i56 + 200 >> 2] | 0;
  f16 = Math_fround(HEAPF32[i56 + 96 >> 2]);
  f17 = Math_fround(HEAPF32[i56 + 112 >> 2]);
  f18 = Math_fround(HEAPF32[i56 + 128 >> 2]);
  f19 = Math_fround(HEAPF32[i56 + 100 >> 2]);
  f20 = Math_fround(HEAPF32[i56 + 116 >> 2]);
  f21 = Math_fround(HEAPF32[i56 + 132 >> 2]);
  f22 = Math_fround(HEAPF32[i56 + 104 >> 2]);
  f23 = Math_fround(HEAPF32[i56 + 120 >> 2]);
  f24 = Math_fround(HEAPF32[i56 + 136 >> 2]);
  i3 = 0;
  i31 = 0;
  while (1) {
   i49 = HEAPU8[i82 + i31 >> 0] | 0;
   HEAP32[i81 + (i31 << 2) >> 2] = i49;
   i1 = HEAPU8[i84 + i31 >> 0] | 0;
   HEAP32[i83 + (i31 << 2) >> 2] = i1;
   f86 = Math_fround(HEAPF32[i25 >> 2]);
   f90 = Math_fround(HEAPF32[i26 >> 2]);
   f91 = Math_fround(HEAPF32[i27 >> 2]);
   f93 = Math_fround(-f86);
   f92 = Math_fround(-f90);
   f89 = Math_fround(-f91);
   f93 = HEAP32[gb + 48 + (i49 << 4) >> 2] | 0 ? f86 : f93;
   f92 = HEAP32[gb + 48 + (i49 << 4) + 4 >> 2] | 0 ? f90 : f92;
   f89 = HEAP32[gb + 48 + (i49 << 4) + 8 >> 2] | 0 ? f91 : f89;
   f91 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f93 * f7) + Math_fround(f92 * f8)) + Math_fround(f89 * f9)));
   f90 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f93 * f10) + Math_fround(f92 * f11)) + Math_fround(f89 * f12)));
   f89 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f93 * f13) + Math_fround(f92 * f14)) + Math_fround(f89 * f15)));
   f92 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) >> 2]);
   f93 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]);
   f86 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 8 >> 2]);
   f88 = Math_fround(Math_fround(Math_fround(f92 * f16) + Math_fround(f93 * f17)) + Math_fround(f86 * f18));
   f87 = Math_fround(Math_fround(Math_fround(f92 * f19) + Math_fround(f93 * f20)) + Math_fround(f86 * f21));
   f86 = Math_fround(Math_fround(Math_fround(f92 * f22) + Math_fround(f93 * f23)) + Math_fround(f86 * f24));
   f93 = Math_fround(f90 - f87);
   f92 = Math_fround(f89 - f86);
   HEAPF32[i33 >> 2] = Math_fround(f91 - f88);
   HEAPF32[i28 >> 2] = f93;
   HEAPF32[i29 >> 2] = f92;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   HEAPF32[i73 + (i3 << 4) >> 2] = f91;
   HEAPF32[i73 + (i3 << 4) + 4 >> 2] = f90;
   HEAPF32[i73 + (i3 << 4) + 8 >> 2] = f89;
   HEAPF32[i73 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i74 + (i3 << 4) >> 2] = f88;
   HEAPF32[i74 + (i3 << 4) + 4 >> 2] = f87;
   HEAPF32[i74 + (i3 << 4) + 8 >> 2] = f86;
   HEAPF32[i74 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i3 + 1 | 0;
   i49 = i75 + (i3 << 4) | 0;
   HEAP32[i49 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i49 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   i31 = i31 + 1 | 0;
   if (i31 >>> 0 >= (HEAPU8[i70 >> 0] | 0) >>> 0) break; else i3 = i1;
  }
  HEAP32[i57 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i32, i75, i73, i74, i81, i83, i33, i57);
  HEAP32[i76 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i76 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i76 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i76 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i76 >> 2]);
  f6 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i76 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i64 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i63 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i35 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  if (f4 > f52) {
   i49 = i76;
   i48 = i35;
   i68 = 7;
  } else i2 = HEAP32[i57 >> 2] | 0;
 }
 do if ((i68 | 0) == 7) {
  i46 = i76 + 4 | 0;
  i47 = i76 + 8 | 0;
  i27 = i55 + 4 | 0;
  i28 = i55 + 8 | 0;
  i29 = i55 + 16 | 0;
  i30 = i55 + 20 | 0;
  i31 = i55 + 24 | 0;
  i32 = i55 + 32 | 0;
  i33 = i55 + 36 | 0;
  i34 = i55 + 40 | 0;
  i35 = i50 + 144 | 0;
  i36 = i50 + 148 | 0;
  i37 = i50 + 152 | 0;
  i38 = i55 + 48 | 0;
  i39 = i55 + 52 | 0;
  i40 = i55 + 56 | 0;
  i41 = i59 + 4 | 0;
  i42 = i59 + 8 | 0;
  i43 = i58 + 4 | 0;
  i44 = i58 + 8 | 0;
  i45 = i58 + 12 | 0;
  i25 = i50 + 48 | 0;
  i26 = i56 + 48 | 0;
  f9 = f51;
  while (1) {
   HEAP32[i63 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i48 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
   f89 = Math_fround(-f5);
   f23 = Math_fround(-f6);
   f19 = Math_fround(-f7);
   i3 = HEAP32[i57 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i55 >> 2]);
   f87 = Math_fround(f21 * f89);
   f24 = Math_fround(HEAPF32[i27 >> 2]);
   f87 = Math_fround(f87 + Math_fround(f24 * f23));
   f86 = Math_fround(HEAPF32[i28 >> 2]);
   f87 = Math_fround(f87 + Math_fround(f86 * f19));
   f22 = Math_fround(HEAPF32[i29 >> 2]);
   f20 = Math_fround(f22 * f89);
   f51 = Math_fround(HEAPF32[i30 >> 2]);
   f20 = Math_fround(f20 + Math_fround(f51 * f23));
   f90 = Math_fround(HEAPF32[i31 >> 2]);
   f20 = Math_fround(f20 + Math_fround(f90 * f19));
   f92 = Math_fround(HEAPF32[i32 >> 2]);
   f89 = Math_fround(f92 * f89);
   f88 = Math_fround(HEAPF32[i33 >> 2]);
   f23 = Math_fround(f89 + Math_fround(f88 * f23));
   f89 = Math_fround(HEAPF32[i34 >> 2]);
   i50 = f87 > Math_fround(0.0);
   i1 = f20 > Math_fround(0.0);
   i2 = Math_fround(f23 + Math_fround(f89 * f19)) > Math_fround(0.0);
   f19 = Math_fround(HEAPF32[i35 >> 2]);
   f23 = Math_fround(HEAPF32[i36 >> 2]);
   f20 = Math_fround(HEAPF32[i37 >> 2]);
   f87 = Math_fround(-f19);
   f91 = Math_fround(-f23);
   f93 = Math_fround(-f20);
   f87 = i50 ? f19 : f87;
   f91 = i1 ? f23 : f91;
   f93 = i2 ? f20 : f93;
   HEAP32[i81 + (i3 << 2) >> 2] = i1 << 31 >> 31 << 1 & 2 | i50 & 1 | i2 << 31 >> 31 << 2 & 4;
   f20 = Math_fround(HEAPF32[i38 >> 2]);
   f23 = Math_fround(HEAPF32[i39 >> 2]);
   f92 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f21 * f87) + Math_fround(f22 * f91)) + Math_fround(f92 * f93)));
   f88 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f24 * f87) + Math_fround(f51 * f91)) + Math_fround(f88 * f93)));
   f93 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + Math_fround(Math_fround(Math_fround(f86 * f87) + Math_fround(f90 * f91)) + Math_fround(f89 * f93)));
   HEAPF32[i73 + (i3 << 4) >> 2] = f92;
   HEAPF32[i73 + (i3 << 4) + 4 >> 2] = f88;
   HEAPF32[i73 + (i3 << 4) + 8 >> 2] = f93;
   HEAPF32[i73 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i59, i56, i76, i74 + (i3 << 4) | 0, i83 + (i3 << 2) | 0);
   f89 = Math_fround(HEAPF32[i59 >> 2]);
   f91 = Math_fround(HEAPF32[i41 >> 2]);
   f89 = Math_fround(f92 - f89);
   f91 = Math_fround(f88 - f91);
   f93 = Math_fround(f93 - Math_fround(HEAPF32[i42 >> 2]));
   HEAPF32[i58 >> 2] = f89;
   HEAPF32[i43 >> 2] = f91;
   HEAPF32[i44 >> 2] = f93;
   HEAPF32[i45 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i57 >> 2] | 0;
   i2 = i75 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
   f88 = Math_fround(HEAPF32[i25 >> 2]);
   f92 = Math_fround(HEAPF32[i26 >> 2]);
   f92 = f88 > f92 ? f88 : f92;
   f9 = f9 > f92 ? f9 : f92;
   f92 = Math_fround(f69 + f9);
   f92 = Math_fround(f4 * Math_fround(f92 * f92));
   f88 = Math_fround(HEAPF32[i76 >> 2]);
   f90 = Math_fround(HEAPF32[i46 >> 2]);
   f93 = Math_fround(Math_fround(Math_fround(f88 * f89) + Math_fround(f90 * f91)) + Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f93));
   i2 = f93 > Math_fround(0.0) & Math_fround(f93 * f93) > f92;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f93) | i2) {
    i68 = 9;
    break;
   }
   HEAP32[i57 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i54, i75, i73, i74, i81, i83, i58, i57);
   HEAP32[i49 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   HEAP32[i49 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i76 >> 2]);
   f6 = Math_fround(HEAPF32[i46 >> 2]);
   f7 = Math_fround(HEAPF32[i47 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i64 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i64 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i64 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f52 & i1)) break; else f4 = f8;
  }
  if ((i68 | 0) == 9) {
   if (i82 | 0) {
    HEAP8[i70 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
      HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i84 = 0;
    STACKTOP = i85;
    return i84 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i66, i67, i3);
   f90 = Math_fround(Math_sqrt(Math_fround(f4)));
   f91 = Math_fround(HEAPF32[i76 >> 2]);
   f92 = Math_fround(HEAPF32[i46 >> 2]);
   f93 = Math_fround(Math_fround(1.0) / f90);
   f91 = Math_fround(f91 * f93);
   f92 = Math_fround(f92 * f93);
   f93 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f93);
   f89 = Math_fround(HEAPF32[i66 >> 2]);
   f88 = Math_fround(HEAPF32[i66 + 4 >> 2]);
   f88 = Math_fround(f88 - Math_fround(f71 * f92));
   f87 = Math_fround(Math_fround(HEAPF32[i66 + 8 >> 2]) - Math_fround(f71 * f93));
   HEAPF32[i77 >> 2] = Math_fround(f89 - Math_fround(f71 * f91));
   HEAPF32[i77 + 4 >> 2] = f88;
   HEAPF32[i77 + 8 >> 2] = f87;
   HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
   f87 = Math_fround(HEAPF32[i67 >> 2]);
   f88 = Math_fround(HEAPF32[i67 + 4 >> 2]);
   f88 = Math_fround(Math_fround(f72 * f92) + f88);
   f89 = Math_fround(Math_fround(f72 * f93) + Math_fround(HEAPF32[i67 + 8 >> 2]));
   HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f91) + f87);
   HEAPF32[i78 + 4 >> 2] = f88;
   HEAPF32[i78 + 8 >> 2] = f89;
   HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i80 >> 2] = Math_fround(f90 - f69);
   i84 = i80 + 4 | 0;
   HEAP32[i84 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i84 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
   HEAP32[i84 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
   HEAPF32[i79 >> 2] = f91;
   HEAPF32[i79 + 4 >> 2] = f92;
   HEAPF32[i79 + 8 >> 2] = f93;
   HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
   i84 = 1;
   STACKTOP = i85;
   return i84 | 0;
  }
  i2 = HEAP32[i57 >> 2] | 0;
  if (i1) {
   if (!i82) i1 = 6; else break;
   STACKTOP = i85;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i82 | 0) {
   HEAP8[i70 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
     HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAP32[i49 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i61, i62, i2);
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  f90 = Math_fround(Math_sqrt(Math_fround(f4)));
  f91 = Math_fround(HEAPF32[i76 >> 2]);
  f92 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f93 = Math_fround(Math_fround(1.0) / f90);
  f91 = Math_fround(f91 * f93);
  f92 = Math_fround(f92 * f93);
  f93 = Math_fround(Math_fround(HEAPF32[i76 + 8 >> 2]) * f93);
  f89 = Math_fround(HEAPF32[i61 >> 2]);
  f88 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f88 = Math_fround(f88 - Math_fround(f71 * f92));
  f87 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) - Math_fround(f71 * f93));
  HEAPF32[i77 >> 2] = Math_fround(f89 - Math_fround(f71 * f91));
  HEAPF32[i77 + 4 >> 2] = f88;
  HEAPF32[i77 + 8 >> 2] = f87;
  HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
  f87 = Math_fround(HEAPF32[i62 >> 2]);
  f88 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f88 = Math_fround(Math_fround(f72 * f92) + f88);
  f89 = Math_fround(Math_fround(f72 * f93) + Math_fround(HEAPF32[i62 + 8 >> 2]));
  HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f91) + f87);
  HEAPF32[i78 + 4 >> 2] = f88;
  HEAPF32[i78 + 8 >> 2] = f89;
  HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i80 >> 2] = Math_fround(f90 - f69);
  i84 = i80 + 4 | 0;
  HEAP32[i84 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i84 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i84 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  HEAPF32[i79 >> 2] = f91;
  HEAPF32[i79 + 4 >> 2] = f92;
  HEAPF32[i79 + 8 >> 2] = f93;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  i84 = 3;
  STACKTOP = i85;
  return i84 | 0;
 } while (0);
 HEAP8[i70 >> 0] = i2;
 if (!i2) {
  i84 = 6;
  STACKTOP = i85;
  return i84 | 0;
 } else i1 = 0;
 do {
  HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
  HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i85;
 return i1 | 0;
}

function __ZNK14dtNavMeshQuery16findStraightPathEPKfS1_PKyiPfPhPyPii(i47, i1, i51, i52, i53, i62, i63, i64, i65, i66) {
 i47 = i47 | 0;
 i1 = i1 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i67 = 0, i68 = 0, f69 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i68 + 24 | 0;
 i49 = i68 + 12 | 0;
 i50 = i68;
 HEAP32[i65 >> 2] = 0;
 i61 = i52;
 if ((HEAP32[i61 >> 2] | 0) == 0 & (HEAP32[i61 + 4 >> 2] | 0) == 0) {
  i67 = -2147483640;
  STACKTOP = i68;
  return i67 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i62 >> 2] = i2;
 HEAP32[i62 + 4 >> 2] = i3;
 HEAP32[i62 + 8 >> 2] = i4;
 i57 = (i63 | 0) != 0;
 if (i57) HEAP8[i63 >> 0] = 1;
 i58 = (i64 | 0) != 0;
 if (i58) {
  i59 = i52;
  i60 = HEAP32[i59 + 4 >> 2] | 0;
  i61 = i64;
  HEAP32[i61 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i61 + 4 >> 2] = i60;
 }
 i59 = HEAP32[i51 >> 2] | 0;
 HEAP32[i48 >> 2] = i59;
 i60 = HEAP32[i51 + 4 >> 2] | 0;
 i41 = i48 + 4 | 0;
 HEAP32[i41 >> 2] = i60;
 i61 = HEAP32[i51 + 8 >> 2] | 0;
 i42 = i48 + 8 | 0;
 HEAP32[i42 >> 2] = i61;
 f54 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f55 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f56 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if ((i53 | 0) > 1) {
  i32 = i52;
  i34 = HEAP32[i32 >> 2] | 0;
  i32 = HEAP32[i32 + 4 >> 2] | 0;
  i43 = i50 + 8 | 0;
  i44 = i49 + 8 | 0;
  i45 = i49 + 4 | 0;
  i46 = i50 + 4 | 0;
  i1 = 1;
  i36 = 0;
  i28 = 0;
  i40 = 0;
  i27 = 0;
  i24 = 0;
  i25 = i2;
  i39 = i2;
  i21 = i2;
  i22 = i3;
  i37 = i3;
  i19 = i4;
  i38 = i4;
  i35 = i3;
  i15 = i4;
  i16 = i34;
  i17 = i32;
  L12 : while (1) {
   i23 = i36 + 1 | 0;
   i33 = (i23 | 0) < (i53 | 0);
   do if (i33) {
    i2 = i52 + (i36 << 3) | 0;
    i29 = i2;
    i26 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    i18 = i52 + (i23 << 3) | 0;
    i31 = i18;
    i30 = HEAP32[i31 >> 2] | 0;
    i31 = HEAP32[i31 + 4 >> 2] | 0;
    i4 = _bitshift64Lshr(i30 | 0, i31 | 0, 16) | 0;
    getTempRet0() | 0;
    i4 = i4 & 15;
    i11 = i4 & 255;
    if ((__ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_(i47, i26, i29, i30, i31, i49, i50) | 0) < 0) {
     i67 = 10;
     break L12;
    }
    f10 = Math_fround(HEAPF32[i50 >> 2]);
    if (i36 | 0) {
     f14 = Math_fround(HEAPF32[i43 >> 2]);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     f9 = f10;
     f8 = f14;
     i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i67 = 36;
     break;
    }
    f12 = Math_fround(HEAPF32[i49 >> 2]);
    f5 = Math_fround(f10 - f12);
    f13 = Math_fround(HEAPF32[i43 >> 2]);
    f14 = Math_fround(HEAPF32[i44 >> 2]);
    f6 = Math_fround(f13 - f14);
    f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f12);
    f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
    f9 = Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6));
    i31 = f9 == Math_fround(0.0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    if (i31) f5 = Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)); else {
     f69 = Math_fround(Math_fround(Math_fround(f5 * f7) + Math_fround(f6 * f8)) / f9);
     i31 = f69 < Math_fround(0.0);
     i30 = f69 > Math_fround(1.0);
     f69 = i30 ? Math_fround(1.0) : f69;
     f69 = i31 ? Math_fround(0.0) : f69;
     f9 = Math_fround(Math_fround(f5 * f69) - f7);
     f5 = Math_fround(Math_fround(f6 * f69) - f8);
     f5 = Math_fround(Math_fround(f9 * f9) + Math_fround(f5 * f5));
    }
    if (f5 < Math_fround(1.00000011e-06)) if ((i4 | 0) == 1) {
     if ((i1 | 0) > 0) {
      i2 = i62 + ((i1 * 3 | 0) + -3 << 2) | 0;
      if (!(HEAP8[gb + 1098872 >> 0] | 0)) {
       HEAPF32[gb + 1459456 >> 2] = Math_fround(3.7252903e-09);
       i36 = gb + 1098872 | 0;
       HEAP32[i36 >> 2] = 1;
       HEAP32[i36 + 4 >> 2] = 0;
      }
      f10 = Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2]));
      f13 = Math_fround(HEAPF32[i45 >> 2]);
      f13 = Math_fround(f13 - Math_fround(HEAPF32[i2 + 4 >> 2]));
      f69 = Math_fround(f14 - Math_fround(HEAPF32[i2 + 8 >> 2]));
      f69 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f13 * f13)) + Math_fround(f69 * f69));
      i1 = ((f69 < Math_fround(HEAPF32[gb + 1459456 >> 2])) << 31 >> 31) + i1 | 0;
     }
     if ((i1 | 0) < (i66 | 0)) {
      i36 = i62 + (i1 * 3 << 2) | 0;
      HEAPF32[i36 >> 2] = f12;
      HEAP32[i36 + 4 >> 2] = HEAP32[i45 >> 2];
      HEAPF32[i36 + 8 >> 2] = f14;
      if (i57) HEAP8[i63 + i1 >> 0] = 4;
      if (i58) {
       i31 = i18;
       i33 = HEAP32[i31 + 4 >> 2] | 0;
       i36 = i64 + (i1 << 3) | 0;
       HEAP32[i36 >> 2] = HEAP32[i31 >> 2];
       HEAP32[i36 + 4 >> 2] = i33;
      }
      i1 = i1 + 1 | 0;
      i11 = i40;
      i23 = 0;
      i26 = i39;
      i2 = i37;
      i20 = i38;
      i18 = i35;
      i4 = i34;
      i3 = i32;
     } else {
      i11 = i40;
      i23 = 0;
      i26 = i39;
      i2 = i37;
      i20 = i38;
      i18 = i35;
      i4 = i34;
      i3 = i32;
     }
    } else {
     i11 = i40;
     i23 = 0;
     i26 = i39;
     i2 = i37;
     i20 = i38;
     i18 = i35;
     i4 = i34;
     i3 = i32;
    } else {
     f9 = f10;
     f8 = f13;
     i4 = i2;
     i67 = 36;
    }
   } else {
    HEAP32[i49 >> 2] = i59;
    HEAP32[i45 >> 2] = i60;
    HEAP32[i44 >> 2] = i61;
    HEAP32[i50 >> 2] = i59;
    HEAP32[i46 >> 2] = i60;
    HEAP32[i43 >> 2] = i61;
    i11 = 0;
    f9 = f54;
    f8 = f56;
    i4 = i61;
    i3 = i59;
    i67 = 36;
   } while (0);
   do if ((i67 | 0) == 36) {
    i67 = 0;
    f5 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = Math_fround(f5 - f10);
    f6 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = Math_fround(f6 - f12);
    if (!(Math_fround(Math_fround(f6 * Math_fround(f9 - f10)) - Math_fround(f5 * Math_fround(f8 - f12))) <= Math_fround(0.0))) {
     i18 = i28;
     i26 = i27;
     i29 = i25;
     i31 = i22;
     i30 = i19;
     i4 = i34;
    } else {
     if (!(HEAP8[gb + 1098872 >> 0] | 0)) {
      HEAPF32[gb + 1459456 >> 2] = Math_fround(3.7252903e-09);
      i31 = gb + 1098872 | 0;
      HEAP32[i31 >> 2] = 1;
      HEAP32[i31 + 4 >> 2] = 0;
     }
     f69 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f69 = Math_fround(f69 - (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f69 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f69 * f69) + Math_fround(f5 * f5)));
     f5 = Math_fround(HEAPF32[gb + 1459456 >> 2]);
     if (!(f69 < f5)) {
      f6 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f69 = Math_fround(f6 - f10);
      f7 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (!(Math_fround(Math_fround(Math_fround(f7 - f12) * Math_fround(f9 - f10)) - Math_fround(f69 * Math_fround(f8 - f12))) > Math_fround(0.0))) {
       i3 = (i16 | 0) == 0 & (i17 | 0) == 0 ? 2 : i40 << 24 >> 24 == 1 ? 4 : 0;
       i2 = i1 + -1 | 0;
       i36 = i62 + (i2 * 3 << 2) | 0;
       f13 = Math_fround(f6 - Math_fround(HEAPF32[i36 >> 2]));
       f14 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f14 = Math_fround(f14 - Math_fround(HEAPF32[i36 + 4 >> 2]));
       f69 = Math_fround(f7 - Math_fround(HEAPF32[i36 + 8 >> 2]));
       if (Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f69 * f69)) < f5) {
        if (i57) HEAP8[i63 + i2 >> 0] = i3;
        if (!i58) {
         i11 = i40;
         i23 = i24;
         i27 = i24;
         i25 = i39;
         i26 = i39;
         i21 = i39;
         i22 = i37;
         i2 = i37;
         i19 = i38;
         i20 = i38;
         i18 = i37;
         i15 = i38;
         i4 = i34;
         i3 = i32;
         break;
        }
        i11 = i64 + (i2 << 3) | 0;
        HEAP32[i11 >> 2] = i16;
        HEAP32[i11 + 4 >> 2] = i17;
        i11 = i40;
        i23 = i24;
        i27 = i24;
        i25 = i39;
        i26 = i39;
        i21 = i39;
        i22 = i37;
        i2 = i37;
        i19 = i38;
        i20 = i38;
        i18 = i37;
        i15 = i38;
        i4 = i34;
        i3 = i32;
        break;
       }
       i36 = i62 + (i1 * 3 << 2) | 0;
       HEAP32[i36 >> 2] = i39;
       HEAP32[i36 + 4 >> 2] = i37;
       HEAP32[i36 + 8 >> 2] = i38;
       if (i57) HEAP8[i63 + i1 >> 0] = i3;
       if (i58) {
        i36 = i64 + (i1 << 3) | 0;
        HEAP32[i36 >> 2] = i16;
        HEAP32[i36 + 4 >> 2] = i17;
       }
       i1 = i1 + 1 | 0;
       if (i3 << 24 >> 24 != 2 & (i1 | 0) < (i66 | 0)) {
        i11 = i40;
        i23 = i24;
        i27 = i24;
        i25 = i39;
        i26 = i39;
        i21 = i39;
        i22 = i37;
        i2 = i37;
        i19 = i38;
        i20 = i38;
        i18 = i37;
        i15 = i38;
        i4 = i34;
        i3 = i32;
        break;
       } else {
        i67 = 49;
        break L12;
       }
      }
     }
     i2 = HEAP32[i46 >> 2] | 0;
     if (i33) {
      i32 = i52 + (i23 << 3) | 0;
      i18 = i11;
      i26 = i36;
      i29 = i3;
      i31 = i2;
      i30 = i4;
      i4 = HEAP32[i32 >> 2] | 0;
      i32 = HEAP32[i32 + 4 >> 2] | 0;
     } else {
      i18 = i11;
      i26 = i36;
      i29 = i3;
      i31 = i2;
      i30 = i4;
      i4 = 0;
      i32 = 0;
     }
    }
    f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f10);
    f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f12);
    f14 = Math_fround(HEAPF32[i49 >> 2]);
    f8 = Math_fround(f14 - f10);
    f69 = Math_fround(HEAPF32[i44 >> 2]);
    f9 = Math_fround(f69 - f12);
    i34 = !(Math_fround(Math_fround(f6 * f8) - Math_fround(f5 * f9)) >= Math_fround(0.0));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
    if (i34) {
     i28 = i18;
     i11 = i40;
     i23 = i36;
     i27 = i26;
     i25 = i29;
     i26 = i39;
     i22 = i31;
     i2 = i37;
     i19 = i30;
     i20 = i38;
     i18 = i35;
     i3 = i32;
    } else {
     if (!(HEAP8[gb + 1098872 >> 0] | 0)) {
      HEAPF32[gb + 1459456 >> 2] = Math_fround(3.7252903e-09);
      i39 = gb + 1098872 | 0;
      HEAP32[i39 >> 2] = 1;
      HEAP32[i39 + 4 >> 2] = 0;
     }
     f69 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f69 = Math_fround(f69 - (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f69 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f69 * f69) + Math_fround(f5 * f5)));
     f6 = Math_fround(HEAPF32[gb + 1459456 >> 2]);
     if (!(f69 < f6)) {
      f7 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f69 = Math_fround(f7 - f10);
      f5 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (!(Math_fround(Math_fround(Math_fround(f5 - f12) * f8) - Math_fround(f69 * f9)) < Math_fround(0.0))) {
       i3 = (i4 | 0) == 0 & (i32 | 0) == 0 ? 2 : i18 << 24 >> 24 == 1 ? 4 : 0;
       i2 = i1 + -1 | 0;
       i39 = i62 + (i2 * 3 << 2) | 0;
       f13 = Math_fround(f7 - Math_fround(HEAPF32[i39 >> 2]));
       f14 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f14 = Math_fround(f14 - Math_fround(HEAPF32[i39 + 4 >> 2]));
       f69 = Math_fround(f5 - Math_fround(HEAPF32[i39 + 8 >> 2]));
       if (Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f69 * f69)) < f6) {
        if (i57) HEAP8[i63 + i2 >> 0] = i3;
        if (!i58) {
         i28 = i18;
         i11 = i40;
         i23 = i26;
         i27 = i26;
         i24 = i26;
         i25 = i29;
         i26 = i29;
         i21 = i29;
         i22 = i31;
         i2 = i31;
         i19 = i30;
         i20 = i30;
         i18 = i31;
         i15 = i30;
         i3 = i32;
         break;
        }
        i28 = i64 + (i2 << 3) | 0;
        HEAP32[i28 >> 2] = i4;
        HEAP32[i28 + 4 >> 2] = i32;
        i28 = i18;
        i11 = i40;
        i23 = i26;
        i27 = i26;
        i24 = i26;
        i25 = i29;
        i26 = i29;
        i21 = i29;
        i22 = i31;
        i2 = i31;
        i19 = i30;
        i20 = i30;
        i18 = i31;
        i15 = i30;
        i3 = i32;
        break;
       }
       i39 = i62 + (i1 * 3 << 2) | 0;
       HEAP32[i39 >> 2] = i29;
       HEAP32[i39 + 4 >> 2] = i31;
       HEAP32[i39 + 8 >> 2] = i30;
       if (i57) HEAP8[i63 + i1 >> 0] = i3;
       if (i58) {
        i39 = i64 + (i1 << 3) | 0;
        HEAP32[i39 >> 2] = i4;
        HEAP32[i39 + 4 >> 2] = i32;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) < (i66 | 0) & i3 << 24 >> 24 != 2) {
        i28 = i18;
        i11 = i40;
        i23 = i26;
        i27 = i26;
        i24 = i26;
        i25 = i29;
        i26 = i29;
        i21 = i29;
        i22 = i31;
        i2 = i31;
        i19 = i30;
        i20 = i30;
        i18 = i31;
        i15 = i30;
        i3 = i32;
        break;
       } else {
        i67 = 67;
        break L12;
       }
      }
     }
     i2 = HEAP32[i45 >> 2] | 0;
     if (i33) {
      i17 = i52 + (i23 << 3) | 0;
      i28 = i18;
      i23 = i36;
      i27 = i26;
      i24 = i36;
      i25 = i29;
      i26 = i3;
      i22 = i31;
      i19 = i30;
      i18 = i35;
      i16 = HEAP32[i17 >> 2] | 0;
      i17 = HEAP32[i17 + 4 >> 2] | 0;
      i3 = i32;
     } else {
      i28 = i18;
      i23 = i36;
      i27 = i26;
      i24 = i36;
      i25 = i29;
      i26 = i3;
      i22 = i31;
      i19 = i30;
      i18 = i35;
      i16 = 0;
      i17 = 0;
      i3 = i32;
     }
    }
   } while (0);
   i36 = i23 + 1 | 0;
   if ((i36 | 0) >= (i53 | 0)) {
    i67 = 74;
    break;
   } else {
    i40 = i11;
    i39 = i26;
    i37 = i2;
    i38 = i20;
    i35 = i18;
    i34 = i4;
    i32 = i3;
   }
  }
  if ((i67 | 0) == 10) {
   i61 = i2;
   if ((__ZNK14dtNavMeshQuery26closestPointOnPolyBoundaryEyPKfPf(i47, HEAP32[i61 >> 2] | 0, HEAP32[i61 + 4 >> 2] | 0, i51, i48) | 0) < 0) i1 = -2147483640; else {
    if ((i1 | 0) < (i66 | 0)) {
     i62 = i62 + (i1 * 3 << 2) | 0;
     HEAP32[i62 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i62 + 4 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i62 + 8 >> 2] = HEAP32[i42 >> 2];
     if (i57) HEAP8[i63 + i1 >> 0] = 0;
     if (i58) {
      i62 = i2;
      i63 = HEAP32[i62 + 4 >> 2] | 0;
      i64 = i64 + (i1 << 3) | 0;
      HEAP32[i64 >> 2] = HEAP32[i62 >> 2];
      HEAP32[i64 + 4 >> 2] = i63;
     }
     i1 = i1 + 1 | 0;
    }
    HEAP32[i65 >> 2] = i1;
    i1 = (i1 | 0) >= (i66 | 0) ? 1073741904 : 1073741888;
   }
  } else if ((i67 | 0) == 49) {
   HEAP32[i65 >> 2] = i1;
   i1 = (i1 | 0) >= (i66 | 0) ? 1073741840 : 1073741824;
  } else if ((i67 | 0) == 67) {
   HEAP32[i65 >> 2] = i1;
   i1 = (i1 | 0) >= (i66 | 0) ? 1073741840 : 1073741824;
  } else if ((i67 | 0) == 74) if ((i1 | 0) > 0) {
   i67 = 75;
   break;
  } else {
   i67 = 78;
   break;
  }
 } else {
  i1 = 1;
  i67 = 75;
 } while (0);
 if ((i67 | 0) == 75) {
  i2 = i62 + ((i1 * 3 | 0) + -3 << 2) | 0;
  if (!(HEAP8[gb + 1098872 >> 0] | 0)) {
   HEAPF32[gb + 1459456 >> 2] = Math_fround(3.7252903e-09);
   i67 = gb + 1098872 | 0;
   HEAP32[i67 >> 2] = 1;
   HEAP32[i67 + 4 >> 2] = 0;
  }
  f54 = Math_fround(f54 - Math_fround(HEAPF32[i2 >> 2]));
  f55 = Math_fround(f55 - Math_fround(HEAPF32[i2 + 4 >> 2]));
  f69 = Math_fround(f56 - Math_fround(HEAPF32[i2 + 8 >> 2]));
  f69 = Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f55 * f55)) + Math_fround(f69 * f69));
  i1 = ((f69 < Math_fround(HEAPF32[gb + 1459456 >> 2])) << 31 >> 31) + i1 | 0;
  i67 = 78;
 }
 if ((i67 | 0) == 78) {
  if ((i1 | 0) < (i66 | 0)) {
   i67 = i62 + (i1 * 3 << 2) | 0;
   HEAP32[i67 >> 2] = i59;
   HEAP32[i67 + 4 >> 2] = i60;
   HEAP32[i67 + 8 >> 2] = i61;
   if (i57) HEAP8[i63 + i1 >> 0] = 2;
   if (i58) {
    i67 = i64 + (i1 << 3) | 0;
    HEAP32[i67 >> 2] = 0;
    HEAP32[i67 + 4 >> 2] = 0;
   }
   i1 = i1 + 1 | 0;
  }
  HEAP32[i65 >> 2] = i1;
  i1 = (i1 | 0) >= (i66 | 0) ? 1073741840 : 1073741824;
 }
 i67 = i1;
 STACKTOP = i68;
 return i67 | 0;
}

function __ZN29InitialModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = HEAP32[gb + 1111240 + 588 >> 2] ^ 16777215;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 112) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 105) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 110) << 2) >> 2] ^ i6 >>> 8;
 HEAP32[i5 >> 2] = ~(HEAP32[gb + 1111240 + ((i6 & 255 ^ 103) << 2) >> 2] ^ i6 >>> 8);
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 0;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i4 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
 }
 i2 = HEAP32[gb + 1111240 + 560 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 109) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 117) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 108) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 111) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 83) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 112) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[i5 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 100) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 1;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
 }
 i2 = HEAP32[gb + 1111240 + 560 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 114) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 68) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 108) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 97) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[i5 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 121) << 2) >> 2] ^ i2 >>> 8);
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 2;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616337 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616337 + 34 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 3;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616372 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616372 + 31 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 4;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616404 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616404 + 30 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 5;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616435 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616435 + 31 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 6;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616467 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616467 + 31 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 7;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616499 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616499 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 8;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616535 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616535 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 9;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616571 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616571 + 34 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 10;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616606 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616606 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 11;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616642 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616642 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 12;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616678 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616678 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 13;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616714 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616714 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 14;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616750 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616750 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 15;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616786 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616786 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 16;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616822 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616822 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 17;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616858 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616858 + 35 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 18;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616894 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616894 + 40 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 19;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616935 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616935 + 36 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 20;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i53, i59, i58, i1, i80, i81, i82, i83, i85, i87, i73) {
 i53 = i53 | 0;
 i59 = i59 | 0;
 i58 = i58 | 0;
 i1 = i1 | 0;
 i80 = i80 | 0;
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i85 = i85 | 0;
 i87 = i87 | 0;
 i73 = i73 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f54 = f0, f55 = f0, i56 = 0, i57 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i84 = 0, i86 = 0, i88 = 0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0;
 i88 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i88 + 304 | 0;
 i67 = i88 + 484 | 0;
 i66 = i88 + 472 | 0;
 i78 = i88 + 320 | 0;
 i76 = i88 + 240 | 0;
 i77 = i88 + 176 | 0;
 i84 = i88 + 456 | 0;
 i86 = i88 + 440 | 0;
 i60 = i88 + 432 | 0;
 i79 = i88 + 160 | 0;
 i31 = i88 + 144 | 0;
 i30 = i88 + 128 | 0;
 i32 = i88 + 420 | 0;
 i33 = i88 + 112 | 0;
 i62 = i88 + 96 | 0;
 i61 = i88 + 80 | 0;
 i69 = i88 + 64 | 0;
 i70 = i88 + 48 | 0;
 i68 = i88 + 408 | 0;
 i57 = i88 + 32 | 0;
 i56 = i88 + 396 | 0;
 i64 = i88 + 16 | 0;
 i65 = i88;
 i63 = i88 + 384 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f74 = Math_fround(HEAPF32[i53 + 16 >> 2]);
 f75 = Math_fround(HEAPF32[i59 + 16 >> 2]);
 f54 = Math_fround(HEAPF32[i1 >> 2]);
 f55 = Math_fround(HEAPF32[i53 + 32 >> 2]);
 f72 = Math_fround(HEAPF32[i59 + 32 >> 2]);
 f55 = Math_fround((f55 > f72 ? f72 : f55) * Math_fround(.100000001));
 f55 = Math_fround(f55 * f55);
 f72 = Math_fround(f74 + f75);
 HEAP32[i60 >> 2] = 0;
 if (!(HEAP8[i73 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  i52 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i52 ? f5 : Math_fround(1.0);
  f6 = i52 ? f6 : Math_fround(0.0);
  f7 = i52 ? f7 : Math_fround(0.0);
  HEAPF32[i79 >> 2] = f5;
  HEAPF32[i79 + 4 >> 2] = f6;
  HEAPF32[i79 + 8 >> 2] = f7;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i33 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  i52 = i79;
  i51 = i33;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i71 = 7;
 } else {
  HEAP32[i31 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i25 = i53 + 96 | 0;
  i26 = i31 + 4 | 0;
  i27 = i31 + 8 | 0;
  i28 = i31 + 12 | 0;
  f4 = Math_fround(HEAPF32[i58 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i58 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i58 >> 2]);
  f8 = Math_fround(HEAPF32[i58 + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i58 + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i58 + 20 >> 2]);
  f12 = Math_fround(HEAPF32[i58 + 36 >> 2]);
  f13 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i58 + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i58 + 40 >> 2]);
  i2 = HEAP32[i59 + 200 >> 2] | 0;
  f16 = Math_fround(HEAPF32[i59 + 96 >> 2]);
  f17 = Math_fround(HEAPF32[i59 + 112 >> 2]);
  f18 = Math_fround(HEAPF32[i59 + 128 >> 2]);
  f19 = Math_fround(HEAPF32[i59 + 100 >> 2]);
  f20 = Math_fround(HEAPF32[i59 + 116 >> 2]);
  f21 = Math_fround(HEAPF32[i59 + 132 >> 2]);
  f22 = Math_fround(HEAPF32[i59 + 104 >> 2]);
  f23 = Math_fround(HEAPF32[i59 + 120 >> 2]);
  f24 = Math_fround(HEAPF32[i59 + 136 >> 2]);
  i3 = 0;
  i29 = 0;
  while (1) {
   i52 = HEAPU8[i85 + i29 >> 0] | 0;
   HEAP32[i84 + (i29 << 2) >> 2] = i52;
   i1 = HEAPU8[i87 + i29 >> 0] | 0;
   HEAP32[i86 + (i29 << 2) >> 2] = i1;
   i52 = 1 - i52 | 0;
   f96 = Math_fround(HEAPF32[i25 + (i52 << 4) >> 2]);
   f95 = Math_fround(HEAPF32[i25 + (i52 << 4) + 4 >> 2]);
   f92 = Math_fround(HEAPF32[i25 + (i52 << 4) + 8 >> 2]);
   f94 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f96 * f7) + Math_fround(f95 * f8)) + Math_fround(f92 * f9)));
   f93 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f96 * f10) + Math_fround(f95 * f11)) + Math_fround(f92 * f12)));
   f92 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f96 * f13) + Math_fround(f95 * f14)) + Math_fround(f92 * f15)));
   f95 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) >> 2]);
   f96 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2]);
   f89 = Math_fround(HEAPF32[i2 + (i1 * 12 | 0) + 8 >> 2]);
   f91 = Math_fround(Math_fround(Math_fround(f95 * f16) + Math_fround(f96 * f17)) + Math_fround(f89 * f18));
   f90 = Math_fround(Math_fround(Math_fround(f95 * f19) + Math_fround(f96 * f20)) + Math_fround(f89 * f21));
   f89 = Math_fround(Math_fround(Math_fround(f95 * f22) + Math_fround(f96 * f23)) + Math_fround(f89 * f24));
   f96 = Math_fround(f93 - f90);
   f95 = Math_fround(f92 - f89);
   HEAPF32[i31 >> 2] = Math_fround(f94 - f91);
   HEAPF32[i26 >> 2] = f96;
   HEAPF32[i27 >> 2] = f95;
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   HEAPF32[i76 + (i3 << 4) >> 2] = f94;
   HEAPF32[i76 + (i3 << 4) + 4 >> 2] = f93;
   HEAPF32[i76 + (i3 << 4) + 8 >> 2] = f92;
   HEAPF32[i76 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i77 + (i3 << 4) >> 2] = f91;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f90;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f89;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i3 + 1 | 0;
   i52 = i78 + (i3 << 4) | 0;
   HEAP32[i52 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i52 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i52 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
   i29 = i29 + 1 | 0;
   if (i29 >>> 0 >= (HEAPU8[i73 >> 0] | 0) >>> 0) break; else i3 = i1;
  }
  HEAP32[i60 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i30, i78, i76, i77, i84, i86, i31, i60);
  HEAP32[i79 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i79 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i79 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i79 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i79 >> 2]);
  f6 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i79 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i67 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i66 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i33 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  if (f4 > f55) {
   i52 = i79;
   i51 = i33;
   i71 = 7;
  } else i2 = HEAP32[i60 >> 2] | 0;
 }
 do if ((i71 | 0) == 7) {
  i49 = i79 + 4 | 0;
  i50 = i79 + 8 | 0;
  i27 = i58 + 4 | 0;
  i28 = i58 + 8 | 0;
  i29 = i58 + 16 | 0;
  i30 = i58 + 20 | 0;
  i31 = i58 + 24 | 0;
  i32 = i58 + 32 | 0;
  i33 = i58 + 36 | 0;
  i34 = i58 + 40 | 0;
  i35 = i53 + 96 | 0;
  i36 = i53 + 100 | 0;
  i37 = i53 + 104 | 0;
  i38 = i53 + 112 | 0;
  i39 = i53 + 116 | 0;
  i40 = i53 + 120 | 0;
  i41 = i58 + 48 | 0;
  i42 = i58 + 52 | 0;
  i43 = i58 + 56 | 0;
  i44 = i62 + 4 | 0;
  i45 = i62 + 8 | 0;
  i46 = i61 + 4 | 0;
  i47 = i61 + 8 | 0;
  i48 = i61 + 12 | 0;
  i25 = i53 + 48 | 0;
  i26 = i59 + 48 | 0;
  f9 = f54;
  while (1) {
   HEAP32[i66 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
   HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i51 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i51 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i51 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
   f92 = Math_fround(-f5);
   f19 = Math_fround(-f6);
   f18 = Math_fround(-f7);
   i3 = HEAP32[i60 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i58 >> 2]);
   f16 = Math_fround(f21 * f92);
   f24 = Math_fround(HEAPF32[i27 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f24 * f19));
   f89 = Math_fround(HEAPF32[i28 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f89 * f18));
   f22 = Math_fround(HEAPF32[i29 >> 2]);
   f17 = Math_fround(f22 * f92);
   f54 = Math_fround(HEAPF32[i30 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f54 * f19));
   f93 = Math_fround(HEAPF32[i31 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f93 * f18));
   f95 = Math_fround(HEAPF32[i32 >> 2]);
   f92 = Math_fround(f95 * f92);
   f91 = Math_fround(HEAPF32[i33 >> 2]);
   f19 = Math_fround(f92 + Math_fround(f91 * f19));
   f92 = Math_fround(HEAPF32[i34 >> 2]);
   f18 = Math_fround(f19 + Math_fround(f92 * f18));
   f19 = Math_fround(HEAPF32[i35 >> 2]);
   f23 = Math_fround(HEAPF32[i36 >> 2]);
   f20 = Math_fround(HEAPF32[i37 >> 2]);
   f15 = Math_fround(Math_fround(Math_fround(f16 * f19) + Math_fround(f17 * f23)) + Math_fround(f18 * f20));
   f90 = Math_fround(HEAPF32[i38 >> 2]);
   f94 = Math_fround(HEAPF32[i39 >> 2]);
   f96 = Math_fround(HEAPF32[i40 >> 2]);
   i2 = f15 > Math_fround(Math_fround(Math_fround(f16 * f90) + Math_fround(f17 * f94)) + Math_fround(f18 * f96));
   HEAP32[i84 + (i3 << 2) >> 2] = i2 & 1;
   f90 = i2 ? f19 : f90;
   f94 = i2 ? f23 : f94;
   f96 = i2 ? f20 : f96;
   f20 = Math_fround(HEAPF32[i41 >> 2]);
   f23 = Math_fround(HEAPF32[i42 >> 2]);
   f95 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f21 * f90) + Math_fround(f22 * f94)) + Math_fround(f95 * f96)));
   f91 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f24 * f90) + Math_fround(f54 * f94)) + Math_fround(f91 * f96)));
   f96 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + Math_fround(Math_fround(Math_fround(f89 * f90) + Math_fround(f93 * f94)) + Math_fround(f92 * f96)));
   HEAPF32[i76 + (i3 << 4) >> 2] = f95;
   HEAPF32[i76 + (i3 << 4) + 4 >> 2] = f91;
   HEAPF32[i76 + (i3 << 4) + 8 >> 2] = f96;
   HEAPF32[i76 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i62, i59, i79, i77 + (i3 << 4) | 0, i86 + (i3 << 2) | 0);
   f92 = Math_fround(HEAPF32[i62 >> 2]);
   f94 = Math_fround(HEAPF32[i44 >> 2]);
   f92 = Math_fround(f95 - f92);
   f94 = Math_fround(f91 - f94);
   f96 = Math_fround(f96 - Math_fround(HEAPF32[i45 >> 2]));
   HEAPF32[i61 >> 2] = f92;
   HEAPF32[i46 >> 2] = f94;
   HEAPF32[i47 >> 2] = f96;
   HEAPF32[i48 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i60 >> 2] | 0;
   i2 = i78 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
   f91 = Math_fround(HEAPF32[i25 >> 2]);
   f95 = Math_fround(HEAPF32[i26 >> 2]);
   f95 = f91 > f95 ? f91 : f95;
   f9 = f9 > f95 ? f9 : f95;
   f95 = Math_fround(f72 + f9);
   f95 = Math_fround(f4 * Math_fround(f95 * f95));
   f91 = Math_fround(HEAPF32[i79 >> 2]);
   f93 = Math_fround(HEAPF32[i49 >> 2]);
   f96 = Math_fround(Math_fround(Math_fround(f91 * f92) + Math_fround(f93 * f94)) + Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f96));
   i2 = f96 > Math_fround(0.0) & Math_fround(f96 * f96) > f95;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f96) | i2) {
    i71 = 9;
    break;
   }
   HEAP32[i60 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i57, i78, i76, i77, i84, i86, i61, i60);
   HEAP32[i52 >> 2] = HEAP32[i57 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
   HEAP32[i52 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
   HEAP32[i52 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i79 >> 2]);
   f6 = Math_fround(HEAPF32[i49 >> 2]);
   f7 = Math_fround(HEAPF32[i50 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i67 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f55 & i1)) break; else f4 = f8;
  }
  if ((i71 | 0) == 9) {
   if (i85 | 0) {
    HEAP8[i73 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
      HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i87 = 0;
    STACKTOP = i88;
    return i87 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i69, i70, i3);
   f93 = Math_fround(Math_sqrt(Math_fround(f4)));
   f94 = Math_fround(HEAPF32[i79 >> 2]);
   f95 = Math_fround(HEAPF32[i49 >> 2]);
   f96 = Math_fround(Math_fround(1.0) / f93);
   f94 = Math_fround(f94 * f96);
   f95 = Math_fround(f95 * f96);
   f96 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f96);
   f92 = Math_fround(HEAPF32[i69 >> 2]);
   f91 = Math_fround(HEAPF32[i69 + 4 >> 2]);
   f91 = Math_fround(f91 - Math_fround(f74 * f95));
   f90 = Math_fround(Math_fround(HEAPF32[i69 + 8 >> 2]) - Math_fround(f74 * f96));
   HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
   HEAPF32[i80 + 4 >> 2] = f91;
   HEAPF32[i80 + 8 >> 2] = f90;
   HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
   f90 = Math_fround(HEAPF32[i70 >> 2]);
   f91 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f91 = Math_fround(Math_fround(f75 * f95) + f91);
   f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i70 + 8 >> 2]));
   HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
   HEAPF32[i81 + 4 >> 2] = f91;
   HEAPF32[i81 + 8 >> 2] = f92;
   HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
   i87 = i83 + 4 | 0;
   HEAP32[i87 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i87 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i87 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAPF32[i82 >> 2] = f94;
   HEAPF32[i82 + 4 >> 2] = f95;
   HEAPF32[i82 + 8 >> 2] = f96;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   i87 = 1;
   STACKTOP = i88;
   return i87 | 0;
  }
  i2 = HEAP32[i60 >> 2] | 0;
  if (i1) {
   if (!i85) i1 = 6; else break;
   STACKTOP = i88;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i85 | 0) {
   HEAP8[i73 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
     HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i64, i65, i2);
  HEAP32[i67 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  f93 = Math_fround(Math_sqrt(Math_fround(f4)));
  f94 = Math_fround(HEAPF32[i79 >> 2]);
  f95 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f96 = Math_fround(Math_fround(1.0) / f93);
  f94 = Math_fround(f94 * f96);
  f95 = Math_fround(f95 * f96);
  f96 = Math_fround(Math_fround(HEAPF32[i79 + 8 >> 2]) * f96);
  f92 = Math_fround(HEAPF32[i64 >> 2]);
  f91 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f91 = Math_fround(f91 - Math_fround(f74 * f95));
  f90 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) - Math_fround(f74 * f96));
  HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
  HEAPF32[i80 + 4 >> 2] = f91;
  HEAPF32[i80 + 8 >> 2] = f90;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  f90 = Math_fround(HEAPF32[i65 >> 2]);
  f91 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f91 = Math_fround(Math_fround(f75 * f95) + f91);
  f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i65 + 8 >> 2]));
  HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
  HEAPF32[i81 + 4 >> 2] = f91;
  HEAPF32[i81 + 8 >> 2] = f92;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
  i87 = i83 + 4 | 0;
  HEAP32[i87 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAPF32[i82 >> 2] = f94;
  HEAPF32[i82 + 4 >> 2] = f95;
  HEAPF32[i82 + 8 >> 2] = f96;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  i87 = 3;
  STACKTOP = i88;
  return i87 | 0;
 } while (0);
 HEAP8[i73 >> 0] = i2;
 if (!i2) {
  i87 = 6;
  STACKTOP = i88;
  return i87 | 0;
 } else i1 = 0;
 do {
  HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
  HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i88;
 return i1 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i65, i66, i1, i67, i68, i62, i70, i51, i53, i45, i69) {
 i65 = i65 | 0;
 i66 = i66 | 0;
 i1 = i1 | 0;
 i67 = i67 | 0;
 i68 = i68 | 0;
 i62 = i62 | 0;
 i70 = i70 | 0;
 i51 = i51 | 0;
 i53 = i53 | 0;
 i45 = i45 | 0;
 i69 = i69 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f63 = f0, f64 = f0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i71 + 460 | 0;
 i42 = i71 + 448 | 0;
 i61 = i71 + 128 | 0;
 i60 = i71 + 272 | 0;
 i58 = i71 + 208 | 0;
 i59 = i71 + 144 | 0;
 i50 = i71 + 432 | 0;
 i52 = i71 + 416 | 0;
 i41 = i71 + 112 | 0;
 i40 = i71 + 408 | 0;
 i15 = i71 + 96 | 0;
 i16 = i71 + 396 | 0;
 i17 = i71 + 80 | 0;
 i54 = i71 + 64 | 0;
 i57 = i71 + 48 | 0;
 i55 = i71 + 384 | 0;
 i56 = i71 + 372 | 0;
 i39 = i71 + 32 | 0;
 i38 = i71 + 360 | 0;
 i46 = i71 + 16 | 0;
 i49 = i71;
 i48 = i71 + 348 | 0;
 i47 = i71 + 336 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f63 = Math_fround(HEAPF32[i65 + 16 >> 2]);
 f64 = Math_fround(HEAPF32[i66 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i65 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i66 + 32 >> 2]);
 f9 = Math_fround((f9 > f3 ? f3 : f9) * Math_fround(.100000001));
 f9 = Math_fround(f9 * f9);
 f3 = Math_fround(f63 + f64);
 i35 = i41 + 4 | 0;
 i36 = i41 + 8 | 0;
 i37 = i41 + 12 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 i1 = HEAP8[i45 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f33 = Math_fround(HEAPF32[i65 >> 2]);
  f4 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i65 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i66 >> 2]);
  f6 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f5 = Math_fround(f33 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i66 + 8 >> 2]));
  i34 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i34 ? f5 : Math_fround(1.0);
  f6 = i34 ? f6 : Math_fround(0.0);
  f7 = i34 ? f7 : Math_fround(0.0);
  HEAPF32[i61 >> 2] = f5;
  HEAPF32[i61 + 4 >> 2] = f6;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i17 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  i34 = i61;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i44 = 6;
 } else {
  i14 = i66 + 96 | 0;
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i32 = HEAPU8[i51 + i11 >> 0] | 0;
   HEAP32[i50 + (i11 << 2) >> 2] = i32;
   i34 = HEAPU8[i53 + i11 >> 0] | 0;
   HEAP32[i52 + (i11 << 2) >> 2] = i34;
   f5 = Math_fround(HEAPF32[i65 + 96 + (i32 << 4) >> 2]);
   f6 = Math_fround(HEAPF32[i65 + 96 + (i32 << 4) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i65 + 96 + (i32 << 4) + 8 >> 2]);
   i32 = HEAP32[i65 + 96 + (i32 << 4) + 12 >> 2] | 0;
   i34 = 1 - i34 | 0;
   f10 = Math_fround(HEAPF32[i14 + (i34 << 4) >> 2]);
   f12 = Math_fround(HEAPF32[i14 + (i34 << 4) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i14 + (i34 << 4) + 8 >> 2]);
   i34 = HEAP32[i14 + (i34 << 4) + 12 >> 2] | 0;
   f72 = Math_fround(f6 - f12);
   f4 = Math_fround(f7 - f33);
   HEAPF32[i41 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i35 >> 2] = f72;
   HEAPF32[i36 >> 2] = f4;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   HEAPF32[i58 + (i2 << 4) >> 2] = f5;
   HEAPF32[i58 + (i2 << 4) + 4 >> 2] = f6;
   HEAPF32[i58 + (i2 << 4) + 8 >> 2] = f7;
   HEAP32[i58 + (i2 << 4) + 12 >> 2] = i32;
   HEAPF32[i59 + (i2 << 4) >> 2] = f10;
   HEAPF32[i59 + (i2 << 4) + 4 >> 2] = f12;
   HEAPF32[i59 + (i2 << 4) + 8 >> 2] = f33;
   HEAP32[i59 + (i2 << 4) + 12 >> 2] = i34;
   i34 = i60 + (i2 << 4) | 0;
   HEAP32[i34 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i34 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i40 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i15, i60, i58, i59, i50, i52, i41, i40);
  HEAP32[i61 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i61 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i43 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i42 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  if (f4 > f9) {
   i34 = i61;
   i44 = 6;
  }
 }
 do if ((i44 | 0) == 6) {
  i2 = i61 + 4 | 0;
  i14 = i61 + 8 | 0;
  i15 = i65 + 96 | 0;
  i16 = i65 + 100 | 0;
  i18 = i65 + 104 | 0;
  i19 = i65 + 112 | 0;
  i20 = i65 + 116 | 0;
  i21 = i65 + 120 | 0;
  i22 = i65 + 128 | 0;
  i23 = i65 + 132 | 0;
  i24 = i65 + 136 | 0;
  i25 = i66 + 96 | 0;
  i26 = i66 + 100 | 0;
  i27 = i66 + 104 | 0;
  i28 = i66 + 112 | 0;
  i29 = i66 + 116 | 0;
  i30 = i66 + 120 | 0;
  i31 = i65 + 48 | 0;
  i32 = i66 + 48 | 0;
  f33 = f4;
  while (1) {
   HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i42 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i42 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   f82 = Math_fround(-f5);
   f81 = Math_fround(-f6);
   f72 = Math_fround(-f7);
   i11 = HEAP32[i40 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i15 >> 2]);
   f78 = Math_fround(HEAPF32[i16 >> 2]);
   f76 = Math_fround(HEAPF32[i18 >> 2]);
   f4 = Math_fround(HEAPF32[i19 >> 2]);
   f75 = Math_fround(HEAPF32[i20 >> 2]);
   f77 = Math_fround(HEAPF32[i21 >> 2]);
   f74 = Math_fround(HEAPF32[i22 >> 2]);
   f73 = Math_fround(HEAPF32[i23 >> 2]);
   f12 = Math_fround(HEAPF32[i24 >> 2]);
   f80 = Math_fround(Math_fround(Math_fround(f10 * f82) + Math_fround(f78 * f81)) + Math_fround(f76 * f72));
   f79 = Math_fround(Math_fround(Math_fround(f4 * f82) + Math_fround(f75 * f81)) + Math_fround(f77 * f72));
   f72 = Math_fround(Math_fround(Math_fround(f74 * f82) + Math_fround(f73 * f81)) + Math_fround(f12 * f72));
   i13 = f80 > f79 & f80 > f72;
   i1 = f79 > f72;
   HEAP32[i50 + (i11 << 2) >> 2] = i13 ? 0 : i1 ? 1 : 2;
   f74 = i13 ? f10 : i1 ? f4 : f74;
   f73 = i13 ? f78 : i1 ? f75 : f73;
   f12 = i13 ? f76 : i1 ? f77 : f12;
   HEAPF32[i58 + (i11 << 4) >> 2] = f74;
   HEAPF32[i58 + (i11 << 4) + 4 >> 2] = f73;
   HEAPF32[i58 + (i11 << 4) + 8 >> 2] = f12;
   HEAPF32[i58 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   f77 = Math_fround(HEAPF32[i25 >> 2]);
   f76 = Math_fround(HEAPF32[i26 >> 2]);
   f75 = Math_fround(HEAPF32[i27 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f77 * f5) + Math_fround(f76 * f6)) + Math_fround(f75 * f7));
   f4 = Math_fround(HEAPF32[i28 >> 2]);
   f10 = Math_fround(HEAPF32[i29 >> 2]);
   f72 = Math_fround(HEAPF32[i30 >> 2]);
   i1 = f78 > Math_fround(Math_fround(Math_fround(f5 * f4) + Math_fround(f6 * f10)) + Math_fround(f7 * f72));
   HEAP32[i52 + (i11 << 2) >> 2] = i1 & 1;
   f4 = i1 ? f77 : f4;
   f10 = i1 ? f76 : f10;
   f72 = i1 ? f75 : f72;
   HEAPF32[i59 + (i11 << 4) >> 2] = f4;
   HEAPF32[i59 + (i11 << 4) + 4 >> 2] = f10;
   HEAPF32[i59 + (i11 << 4) + 8 >> 2] = f72;
   HEAPF32[i59 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   f4 = Math_fround(f74 - f4);
   f10 = Math_fround(f73 - f10);
   f72 = Math_fround(f12 - f72);
   HEAPF32[i41 >> 2] = f4;
   HEAPF32[i35 >> 2] = f10;
   HEAPF32[i36 >> 2] = f72;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i11 = i60 + (i11 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i31 >> 2]);
   f12 = Math_fround(HEAPF32[i32 >> 2]);
   f12 = f5 > f12 ? f5 : f12;
   f8 = f8 > f12 ? f8 : f12;
   f12 = Math_fround(f3 + f8);
   f12 = Math_fround(f33 * Math_fround(f12 * f12));
   f5 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f72 = Math_fround(Math_fround(Math_fround(f5 * f4) + Math_fround(f6 * f10)) + Math_fround(f7 * f72));
   i11 = f72 > Math_fround(0.0) & Math_fround(f72 * f72) > f12;
   i1 = Math_fround(f33 * Math_fround(.00039999999)) >= Math_fround(f33 - f72) | i11;
   i13 = HEAP32[i40 >> 2] | 0;
   if (i1) {
    f4 = f33;
    i44 = 8;
    break;
   }
   HEAP32[i40 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i39, i60, i58, i59, i50, i52, i41, i40);
   HEAP32[i34 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i34 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i43 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   i1 = f33 > f4;
   if (!(f4 > f9 & i1)) break; else f33 = f4;
  }
  if ((i44 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i51 | 0) {
    HEAP8[i45 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
      HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i70 = 0;
    STACKTOP = i71;
    return i70 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f4)));
   f4 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f5 * f4);
   f8 = Math_fround(f6 * f4);
   f7 = Math_fround(f7 * f4);
   HEAPF32[i62 >> 2] = f9;
   HEAPF32[i62 + 4 >> 2] = f8;
   HEAPF32[i62 + 8 >> 2] = f7;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i54, i57, i13);
   f5 = Math_fround(HEAPF32[i54 >> 2]);
   f6 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i54 + 8 >> 2]);
   if (i69) {
    f81 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
    f78 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
    f82 = Math_fround(f81 + f78);
    f80 = Math_fround(f6 - Math_fround(f8 * f81));
    f79 = Math_fround(f4 - Math_fround(f7 * f81));
    HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f9 * f81));
    HEAPF32[i67 + 4 >> 2] = f80;
    HEAPF32[i67 + 8 >> 2] = f79;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    f79 = Math_fround(HEAPF32[i57 >> 2]);
    f80 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f80 = Math_fround(Math_fround(f8 * f78) + f80);
    f81 = Math_fround(Math_fround(f7 * f78) + Math_fround(HEAPF32[i57 + 8 >> 2]));
    HEAPF32[i68 >> 2] = Math_fround(Math_fround(f9 * f78) + f79);
    HEAPF32[i68 + 4 >> 2] = f80;
    HEAPF32[i68 + 8 >> 2] = f81;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(f10 - f82);
    i70 = i70 + 4 | 0;
    HEAP32[i70 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i70 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i70 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    i70 = 1;
    STACKTOP = i71;
    return i70 | 0;
   } else {
    f81 = Math_fround(f6 - Math_fround(f63 * f8));
    f80 = Math_fround(f4 - Math_fround(f63 * f7));
    HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f63 * f9));
    HEAPF32[i67 + 4 >> 2] = f81;
    HEAPF32[i67 + 8 >> 2] = f80;
    HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
    f80 = Math_fround(HEAPF32[i57 >> 2]);
    f81 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f81 = Math_fround(Math_fround(f64 * f8) + f81);
    f82 = Math_fround(Math_fround(f64 * f7) + Math_fround(HEAPF32[i57 + 8 >> 2]));
    HEAPF32[i68 >> 2] = Math_fround(Math_fround(f64 * f9) + f80);
    HEAPF32[i68 + 4 >> 2] = f81;
    HEAPF32[i68 + 8 >> 2] = f82;
    HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(f10 - f3);
    i70 = i70 + 4 | 0;
    HEAP32[i70 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i70 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
    HEAP32[i70 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
    i70 = 1;
    STACKTOP = i71;
    return i70 | 0;
   }
  }
  if (i1) {
   if (!i51) i1 = 6; else break;
   STACKTOP = i71;
   return i1 | 0;
  };
  HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  i11 = HEAP32[i40 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i51 | 0) {
   HEAP8[i45 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
     HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i34 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i46, i49, i11);
  HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f33)));
  f9 = Math_fround(HEAPF32[i61 >> 2]);
  f10 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i46 >> 2]);
  f6 = Math_fround(HEAPF32[i46 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i46 + 8 >> 2]);
  if (i69) {
   f82 = HEAP32[i65 + 64 >> 2] | 0 ? Math_fround(0.0) : f63;
   f79 = HEAP32[i66 + 64 >> 2] | 0 ? Math_fround(0.0) : f64;
   f3 = Math_fround(f82 + f79);
   f81 = Math_fround(f6 - Math_fround(f10 * f82));
   f80 = Math_fround(f4 - Math_fround(f7 * f82));
   HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f9 * f82));
   HEAPF32[i67 + 4 >> 2] = f81;
   HEAPF32[i67 + 8 >> 2] = f80;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   f80 = Math_fround(HEAPF32[i49 >> 2]);
   f81 = Math_fround(HEAPF32[i49 + 4 >> 2]);
   f81 = Math_fround(Math_fround(f10 * f79) + f81);
   f82 = Math_fround(Math_fround(f7 * f79) + Math_fround(HEAPF32[i49 + 8 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(f9 * f79) + f80);
   HEAPF32[i68 + 4 >> 2] = f81;
   HEAPF32[i68 + 8 >> 2] = f82;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   i69 = i70 + 4 | 0;
   HEAP32[i69 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  } else {
   f81 = Math_fround(f6 - Math_fround(f63 * f10));
   f80 = Math_fround(f4 - Math_fround(f63 * f7));
   HEAPF32[i67 >> 2] = Math_fround(f5 - Math_fround(f63 * f9));
   HEAPF32[i67 + 4 >> 2] = f81;
   HEAPF32[i67 + 8 >> 2] = f80;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   f80 = Math_fround(HEAPF32[i49 >> 2]);
   f81 = Math_fround(HEAPF32[i49 + 4 >> 2]);
   f81 = Math_fround(Math_fround(f64 * f10) + f81);
   f82 = Math_fround(Math_fround(f64 * f7) + Math_fround(HEAPF32[i49 + 8 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(f64 * f9) + f80);
   HEAPF32[i68 + 4 >> 2] = f81;
   HEAPF32[i68 + 8 >> 2] = f82;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   i69 = i70 + 4 | 0;
   HEAP32[i69 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  }
  HEAPF32[i70 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i62 >> 2] = f9;
  HEAPF32[i62 + 4 >> 2] = f10;
  HEAPF32[i62 + 8 >> 2] = f7;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  i70 = f12 >= f33 ? 1 : 3;
  STACKTOP = i71;
  return i70 | 0;
 } while (0);
 i2 = HEAP32[i40 >> 2] | 0;
 HEAP8[i45 >> 0] = i2;
 if (!i2) {
  i70 = 6;
  STACKTOP = i71;
  return i70 | 0;
 } else i1 = 0;
 do {
  HEAP8[i51 + i1 >> 0] = HEAP32[i50 + (i1 << 2) >> 2];
  HEAP8[i53 + i1 >> 0] = HEAP32[i52 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i71;
 return i1 | 0;
}

function __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0;
 i74 = HEAP32[i3 >> 2] | 0;
 i76 = HEAP32[i3 + 32 >> 2] | 0;
 i79 = HEAP32[i3 + 64 >> 2] | 0;
 i81 = HEAP32[i3 + 96 >> 2] | 0;
 i30 = HEAP32[i74 >> 2] | 0;
 i13 = HEAP32[i74 + 4 >> 2] | 0;
 i20 = HEAP32[i74 + 8 >> 2] | 0;
 i75 = i74 + 16 | 0;
 i26 = HEAP32[i75 >> 2] | 0;
 i5 = HEAP32[i75 + 4 >> 2] | 0;
 i1 = HEAP32[i75 + 8 >> 2] | 0;
 i6 = HEAP32[i76 >> 2] | 0;
 i14 = HEAP32[i76 + 4 >> 2] | 0;
 i21 = HEAP32[i76 + 8 >> 2] | 0;
 i77 = i76 + 16 | 0;
 i15 = HEAP32[i77 >> 2] | 0;
 i7 = HEAP32[i77 + 4 >> 2] | 0;
 i2 = HEAP32[i77 + 8 >> 2] | 0;
 i8 = HEAP32[i79 >> 2] | 0;
 i16 = HEAP32[i79 + 4 >> 2] | 0;
 i22 = HEAP32[i79 + 8 >> 2] | 0;
 i78 = i79 + 16 | 0;
 i17 = HEAP32[i78 >> 2] | 0;
 i9 = HEAP32[i78 + 4 >> 2] | 0;
 i24 = HEAP32[i78 + 8 >> 2] | 0;
 i10 = HEAP32[i81 >> 2] | 0;
 i18 = HEAP32[i81 + 4 >> 2] | 0;
 i23 = HEAP32[i81 + 8 >> 2] | 0;
 i80 = i81 + 16 | 0;
 i19 = HEAP32[i80 >> 2] | 0;
 i11 = HEAP32[i80 + 4 >> 2] | 0;
 i4 = HEAP32[i80 + 8 >> 2] | 0;
 i25 = HEAP32[i3 + 16 >> 2] | 0;
 i12 = HEAP16[i25 + 2 >> 1] | 0;
 i73 = i25 + (i12 & 65535) | 0;
 if (!(i12 << 16 >> 16)) {
  i3 = i8;
  i82 = i6;
  i84 = i30;
  i12 = i18;
  i8 = i16;
  i6 = i14;
  i83 = i13;
  i18 = i23;
  i16 = i22;
  i14 = i21;
  i13 = i20;
  i43 = i19;
  i25 = i17;
  i22 = i15;
  i20 = i26;
  i72 = i11;
  i30 = i9;
  i23 = i7;
  i21 = i5;
  i73 = i4;
  i42 = i24;
  i26 = i2;
  i24 = i1;
  HEAP32[i74 >> 2] = i84;
  i19 = i74 + 4 | 0;
  HEAP32[i19 >> 2] = i83;
  i19 = i74 + 8 | 0;
  HEAP32[i19 >> 2] = i13;
  HEAP32[i76 >> 2] = i82;
  i19 = i76 + 4 | 0;
  HEAP32[i19 >> 2] = i6;
  i19 = i76 + 8 | 0;
  HEAP32[i19 >> 2] = i14;
  HEAP32[i79 >> 2] = i3;
  i19 = i79 + 4 | 0;
  HEAP32[i19 >> 2] = i8;
  i19 = i79 + 8 | 0;
  HEAP32[i19 >> 2] = i16;
  HEAP32[i81 >> 2] = i10;
  i19 = i81 + 4 | 0;
  HEAP32[i19 >> 2] = i12;
  i19 = i81 + 8 | 0;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i75 >> 2] = i20;
  i75 = i74 + 20 | 0;
  HEAP32[i75 >> 2] = i21;
  i75 = i74 + 24 | 0;
  HEAP32[i75 >> 2] = i24;
  HEAP32[i77 >> 2] = i22;
  i77 = i76 + 20 | 0;
  HEAP32[i77 >> 2] = i23;
  i77 = i76 + 24 | 0;
  HEAP32[i77 >> 2] = i26;
  HEAP32[i78 >> 2] = i25;
  i78 = i79 + 20 | 0;
  HEAP32[i78 >> 2] = i30;
  i79 = i79 + 24 | 0;
  HEAP32[i79 >> 2] = i42;
  HEAP32[i80 >> 2] = i43;
  i80 = i81 + 20 | 0;
  HEAP32[i80 >> 2] = i72;
  i81 = i81 + 24 | 0;
  HEAP32[i81 >> 2] = i73;
  return;
 } else {
  i3 = i24;
  i24 = i30;
 }
 while (1) {
  i30 = i25 + ((i12 & 65535) + 64) | 0;
  i42 = i25 + 112 | 0;
  i84 = HEAP8[i25 + 1 >> 0] | 0;
  i43 = i84 & 255;
  i72 = i42 + (i43 * 176 | 0) | 0;
  f44 = Math_fround(HEAPF32[i25 + 80 >> 2]);
  f45 = Math_fround(HEAPF32[i25 + 84 >> 2]);
  f46 = Math_fround(HEAPF32[i25 + 88 >> 2]);
  f47 = Math_fround(HEAPF32[i25 + 92 >> 2]);
  f27 = Math_fround(HEAPF32[i25 + 32 >> 2]);
  f31 = Math_fround(HEAPF32[i25 + 36 >> 2]);
  f36 = Math_fround(HEAPF32[i25 + 40 >> 2]);
  f40 = Math_fround(HEAPF32[i25 + 44 >> 2]);
  f28 = Math_fround(HEAPF32[i25 + 48 >> 2]);
  f32 = Math_fround(HEAPF32[i25 + 52 >> 2]);
  f37 = Math_fround(HEAPF32[i25 + 56 >> 2]);
  f41 = Math_fround(HEAPF32[i25 + 60 >> 2]);
  f29 = Math_fround(HEAPF32[i25 + 64 >> 2]);
  f33 = Math_fround(HEAPF32[i25 + 68 >> 2]);
  f38 = Math_fround(HEAPF32[i25 + 72 >> 2]);
  f39 = Math_fround(HEAPF32[i25 + 76 >> 2]);
  f67 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f62 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f52 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f60 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f53 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f48 = Math_fround(f44 * f27);
  f49 = Math_fround(f45 * f31);
  f50 = Math_fround(f46 * f36);
  f51 = Math_fround(f47 * f40);
  f54 = Math_fround(f44 * f28);
  f55 = Math_fround(f45 * f32);
  f56 = Math_fround(f46 * f37);
  f57 = Math_fround(f47 * f41);
  f68 = Math_fround(f44 * f29);
  f69 = Math_fround(f45 * f33);
  f70 = Math_fround(f46 * f38);
  f71 = Math_fround(f47 * f39);
  f66 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(i84 << 24 >> 24)) {
   i12 = i26;
   f31 = Math_fround(0.0);
   f29 = Math_fround(0.0);
   f28 = Math_fround(0.0);
   f27 = Math_fround(0.0);
  } else {
   i12 = i26;
   f35 = Math_fround(Math_fround(Math_fround(f67 * f27) + Math_fround(f65 * f28)) + Math_fround(f66 * f29));
   f34 = Math_fround(Math_fround(Math_fround(f62 * f31) + Math_fround(f63 * f32)) + Math_fround(f64 * f33));
   f33 = Math_fround(Math_fround(Math_fround(f59 * f36) + Math_fround(f60 * f37)) + Math_fround(f61 * f38));
   f32 = Math_fround(Math_fround(Math_fround(f52 * f40) + Math_fround(f53 * f41)) + Math_fround(f58 * f39));
   f27 = Math_fround(0.0);
   f28 = Math_fround(0.0);
   f29 = Math_fround(0.0);
   f31 = Math_fround(0.0);
   i8 = 0;
   while (1) {
    i6 = i8 + 1 | 0;
    f106 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 48 >> 2]);
    f105 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 52 >> 2]);
    f104 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 56 >> 2]);
    f103 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 60 >> 2]);
    f98 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 64 >> 2]);
    f97 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 68 >> 2]);
    f96 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 72 >> 2]);
    f95 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 76 >> 2]);
    f93 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 80 >> 2]);
    f91 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 84 >> 2]);
    f89 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 88 >> 2]);
    f87 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 92 >> 2]);
    i26 = i42 + (i8 * 176 | 0) + 96 | 0;
    f86 = Math_fround(HEAPF32[i26 >> 2]);
    i82 = i42 + (i8 * 176 | 0) + 100 | 0;
    f85 = Math_fround(HEAPF32[i82 >> 2]);
    i83 = i42 + (i8 * 176 | 0) + 104 | 0;
    f36 = Math_fround(HEAPF32[i83 >> 2]);
    i84 = i42 + (i8 * 176 | 0) + 108 | 0;
    f37 = Math_fround(HEAPF32[i84 >> 2]);
    f128 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 112 >> 2]);
    f124 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 116 >> 2]);
    f120 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 120 >> 2]);
    f113 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 124 >> 2]);
    f130 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 128 >> 2]);
    f126 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 132 >> 2]);
    f122 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 136 >> 2]);
    f111 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 140 >> 2]);
    f129 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 144 >> 2]);
    f125 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 148 >> 2]);
    f121 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 152 >> 2]);
    f112 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 156 >> 2]);
    f38 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 160 >> 2]);
    f39 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 164 >> 2]);
    f40 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 168 >> 2]);
    f41 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 172 >> 2]);
    f88 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) >> 2]);
    f90 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 4 >> 2]);
    f92 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 8 >> 2]);
    f94 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 12 >> 2]);
    f127 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 16 >> 2]);
    f123 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 20 >> 2]);
    f119 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 24 >> 2]);
    f114 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 28 >> 2]);
    f118 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 32 >> 2]);
    f117 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 36 >> 2]);
    f116 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 40 >> 2]);
    f115 = Math_fround(HEAPF32[i42 + (i8 * 176 | 0) + 44 >> 2]);
    f110 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f88 = Math_fround(f110 * f88);
    f109 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f90 = Math_fround(f109 * f90);
    f108 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f92 = Math_fround(f108 * f92);
    f107 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f94 = Math_fround(f107 * f94);
    f102 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f101 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f100 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f99 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f127 = Math_fround(f88 + Math_fround(f102 * f127));
    f123 = Math_fround(f90 + Math_fround(f101 * f123));
    f119 = Math_fround(f92 + Math_fround(f100 * f119));
    f114 = Math_fround(f94 + Math_fround(f99 * f114));
    f94 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f92 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f90 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f88 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f118 = Math_fround(Math_fround(Math_fround(f128 * f130) - f129) - Math_fround(f128 * Math_fround(f35 + Math_fround(f127 + Math_fround(f94 * f118)))));
    f117 = Math_fround(Math_fround(Math_fround(f124 * f126) - f125) - Math_fround(f124 * Math_fround(f34 + Math_fround(f123 + Math_fround(f92 * f117)))));
    f116 = Math_fround(Math_fround(Math_fround(f120 * f122) - f121) - Math_fround(f120 * Math_fround(f33 + Math_fround(f119 + Math_fround(f90 * f116)))));
    f115 = Math_fround(Math_fround(Math_fround(f113 * f111) - f112) - Math_fround(f113 * Math_fround(f32 + Math_fround(f114 + Math_fround(f88 * f115)))));
    f114 = Math_fround(-f86);
    f113 = Math_fround(-f85);
    f112 = Math_fround(-f36);
    f111 = Math_fround(-f37);
    f114 = Math_fround(f86 + (f118 > f114 ? f118 : f114));
    f113 = Math_fround(f85 + (f117 > f113 ? f117 : f113));
    f112 = Math_fround(f36 + (f116 > f112 ? f116 : f112));
    f111 = Math_fround(f37 + (f115 > f111 ? f115 : f111));
    f38 = f114 < f38 ? f114 : f38;
    f39 = f113 < f39 ? f113 : f39;
    f40 = f112 < f40 ? f112 : f40;
    f41 = f111 < f41 ? f111 : f41;
    f86 = Math_fround(f38 - f86);
    f85 = Math_fround(f39 - f85);
    f36 = Math_fround(f40 - f36);
    f37 = Math_fround(f41 - f37);
    f35 = Math_fround(f35 + Math_fround(f44 * f86));
    f34 = Math_fround(f34 + Math_fround(f45 * f85));
    f33 = Math_fround(f33 + Math_fround(f46 * f36));
    f32 = Math_fround(f32 + Math_fround(f47 * f37));
    f27 = Math_fround(f27 + f86);
    f28 = Math_fround(f28 + f85);
    f29 = Math_fround(f29 + f36);
    f31 = Math_fround(f31 + f37);
    f106 = Math_fround(f110 + Math_fround(f106 * f86));
    f105 = Math_fround(f109 + Math_fround(f105 * f85));
    f104 = Math_fround(f108 + Math_fround(f104 * f36));
    f103 = Math_fround(f107 + Math_fround(f103 * f37));
    i12 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i17 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i19 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    f98 = Math_fround(f102 + Math_fround(f98 * f86));
    f97 = Math_fround(f101 + Math_fround(f97 * f85));
    f96 = Math_fround(f100 + Math_fround(f96 * f36));
    f95 = Math_fround(f99 + Math_fround(f95 * f37));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    f86 = Math_fround(f94 + Math_fround(f93 * f86));
    f85 = Math_fround(f92 + Math_fround(f91 * f85));
    f36 = Math_fround(f90 + Math_fround(f89 * f36));
    f37 = Math_fround(f88 + Math_fround(f87 * f37));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f86, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f85, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i26 >> 2] = f38;
    HEAPF32[i82 >> 2] = f39;
    HEAPF32[i83 >> 2] = f40;
    HEAPF32[i84 >> 2] = f41;
    HEAPF32[i30 + (i8 << 4) >> 2] = f38;
    HEAPF32[i30 + (i8 << 4) + 4 >> 2] = f39;
    HEAPF32[i30 + (i8 << 4) + 8 >> 2] = f40;
    HEAPF32[i30 + (i8 << 4) + 12 >> 2] = f41;
    if ((i6 | 0) == (i43 | 0)) break; else i8 = i6;
   }
  }
  f127 = Math_fround(f67 + Math_fround(f48 * f27));
  f128 = Math_fround(f62 + Math_fround(f49 * f28));
  f129 = Math_fround(f59 + Math_fround(f50 * f29));
  f130 = Math_fround(f52 + Math_fround(f51 * f31));
  i24 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f130, HEAP32[tempDoublePtr >> 2] | 0);
  f130 = Math_fround(f65 + Math_fround(f54 * f27));
  f129 = Math_fround(f63 + Math_fround(f55 * f28));
  f128 = Math_fround(f60 + Math_fround(f56 * f29));
  f127 = Math_fround(f53 + Math_fround(f57 * f31));
  i13 = (HEAPF32[tempDoublePtr >> 2] = f130, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  f127 = Math_fround(f66 + Math_fround(f68 * f27));
  f128 = Math_fround(f64 + Math_fround(f69 * f28));
  f129 = Math_fround(f61 + Math_fround(f70 * f29));
  f130 = Math_fround(f58 + Math_fround(f71 * f31));
  i20 = (HEAPF32[tempDoublePtr >> 2] = f127, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f128, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f129, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f130, HEAP32[tempDoublePtr >> 2] | 0);
  if (i72 >>> 0 >= i73 >>> 0) break;
  i26 = i12;
  i12 = HEAP16[i72 + 2 >> 1] | 0;
  i25 = i72;
 }
 HEAP32[i74 >> 2] = i24;
 i84 = i74 + 4 | 0;
 HEAP32[i84 >> 2] = i13;
 i84 = i74 + 8 | 0;
 HEAP32[i84 >> 2] = i20;
 HEAP32[i76 >> 2] = i6;
 i84 = i76 + 4 | 0;
 HEAP32[i84 >> 2] = i14;
 i84 = i76 + 8 | 0;
 HEAP32[i84 >> 2] = i21;
 HEAP32[i79 >> 2] = i8;
 i84 = i79 + 4 | 0;
 HEAP32[i84 >> 2] = i16;
 i84 = i79 + 8 | 0;
 HEAP32[i84 >> 2] = i22;
 HEAP32[i81 >> 2] = i10;
 i84 = i81 + 4 | 0;
 HEAP32[i84 >> 2] = i18;
 i84 = i81 + 8 | 0;
 HEAP32[i84 >> 2] = i23;
 HEAP32[i75 >> 2] = i12;
 i84 = i74 + 20 | 0;
 HEAP32[i84 >> 2] = i5;
 i84 = i74 + 24 | 0;
 HEAP32[i84 >> 2] = i1;
 HEAP32[i77 >> 2] = i15;
 i84 = i76 + 20 | 0;
 HEAP32[i84 >> 2] = i7;
 i84 = i76 + 24 | 0;
 HEAP32[i84 >> 2] = i2;
 HEAP32[i78 >> 2] = i17;
 i84 = i79 + 20 | 0;
 HEAP32[i84 >> 2] = i9;
 i84 = i79 + 24 | 0;
 HEAP32[i84 >> 2] = i3;
 HEAP32[i80 >> 2] = i19;
 i84 = i81 + 20 | 0;
 HEAP32[i84 >> 2] = i11;
 i84 = i81 + 24 | 0;
 HEAP32[i84 >> 2] = i4;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(i1, i2, i20) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 L1 : while (1) {
  i18 = i2;
  i22 = i2 + -24 | 0;
  i19 = i2 + -48 | 0;
  i23 = i2 + -16 | 0;
  i24 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i17 = i1;
    i3 = i18 - i17 | 0;
    switch ((i3 | 0) / 24 | 0 | 0) {
    case 2:
     {
      i21 = 5;
      break L1;
     }
    case 3:
     {
      i21 = 12;
      break L1;
     }
    case 4:
     {
      i21 = 13;
      break L1;
     }
    case 5:
     {
      i21 = 14;
      break L1;
     }
    case 1:
    case 0:
     {
      i21 = 97;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 168) {
     i21 = 16;
     break L1;
    }
    i8 = (i3 >>> 0) / 48 | 0;
    i15 = i1 + (i8 * 24 | 0) | 0;
    if ((i3 | 0) > 23976) {
     i3 = (i3 >>> 0) / 96 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_(i1, i1 + (i3 * 24 | 0) | 0, i15, i15 + (i3 * 24 | 0) | 0, i22, i20) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i1, i15, i22, i20) | 0;
    i16 = HEAP32[i1 >> 2] | 0;
    i14 = HEAP32[i15 >> 2] | 0;
    if (i16 >>> 0 < i14 >>> 0) {
     i4 = i22;
     break;
    }
    do if (i14 >>> 0 >= i16 >>> 0) {
     i5 = i1 + 8 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     i7 = i1 + (i8 * 24 | 0) + 8 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
      i12 = i1 + 16 | 0;
      i10 = HEAP32[i12 + 4 >> 2] | 0;
      i13 = i1 + (i8 * 24 | 0) + 16 | 0;
      i11 = HEAP32[i13 + 4 >> 2] | 0;
      if (i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
       i4 = i22;
       break L5;
      } else break;
     } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) {
      i4 = i22;
      break L5;
     } else break;
    } while (0);
    if ((i1 | 0) != (i19 | 0)) {
     i11 = i1 + (i8 * 24 | 0) + 8 | 0;
     i10 = i1 + (i8 * 24 | 0) + 16 | 0;
     i12 = i22;
     i4 = i19;
     while (1) {
      i13 = HEAP32[i4 >> 2] | 0;
      if (i13 >>> 0 < i14 >>> 0) {
       i21 = 59;
       break L5;
      }
      do if (i14 >>> 0 >= i13 >>> 0) {
       i7 = i12 + -16 | 0;
       i5 = i7;
       i6 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i9 = i11;
       i8 = HEAP32[i9 >> 2] | 0;
       i9 = HEAP32[i9 + 4 >> 2] | 0;
       if ((i6 | 0) == (i8 | 0) & (i5 | 0) == (i9 | 0)) {
        i8 = i12 + -8 | 0;
        i26 = HEAP32[i8 + 4 >> 2] | 0;
        i9 = i10;
        i25 = HEAP32[i9 + 4 >> 2] | 0;
        if (i26 >>> 0 < i25 >>> 0 | ((i26 | 0) == (i25 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0 : 0)) {
         i21 = 65;
         break L5;
        } else break;
       } else if (i5 >>> 0 < i9 >>> 0 | (i5 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
        i21 = 65;
        break L5;
       } else break;
      } while (0);
      i5 = i4 + -24 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i12 = i4;
       i4 = i5;
      }
     }
    }
    i3 = i1 + 24 | 0;
    i4 = HEAP32[i22 >> 2] | 0;
    i12 = i4;
    L32 : do if (i16 >>> 0 >= i4 >>> 0) {
     do if (i4 >>> 0 >= i16 >>> 0) {
      i5 = i1 + 8 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      i7 = i23;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
       i25 = i1 + 16 | 0;
       i15 = HEAP32[i25 + 4 >> 2] | 0;
       i26 = i24;
       i17 = HEAP32[i26 + 4 >> 2] | 0;
       if (i15 >>> 0 < i17 >>> 0 | ((i15 | 0) == (i17 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break L32; else break;
      } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) break L32; else break;
     } while (0);
     if ((i3 | 0) == (i22 | 0)) {
      i21 = 97;
      break L1;
     }
     i10 = i1 + 8 | 0;
     i11 = i1 + 16 | 0;
     L41 : while (1) {
      i9 = HEAP32[i3 >> 2] | 0;
      if (i16 >>> 0 < i9 >>> 0) {
       i21 = 35;
       break;
      }
      do if (i9 >>> 0 >= i16 >>> 0) {
       i6 = i10;
       i5 = HEAP32[i6 >> 2] | 0;
       i6 = HEAP32[i6 + 4 >> 2] | 0;
       i4 = i3 + 8 | 0;
       i8 = i4;
       i7 = HEAP32[i8 >> 2] | 0;
       i8 = HEAP32[i8 + 4 >> 2] | 0;
       if ((i5 | 0) == (i7 | 0) & (i6 | 0) == (i8 | 0)) {
        i25 = i11;
        i15 = HEAP32[i25 + 4 >> 2] | 0;
        i26 = i3 + 16 | 0;
        i17 = HEAP32[i26 + 4 >> 2] | 0;
        if (i15 >>> 0 < i17 >>> 0 | ((i15 | 0) == (i17 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break L41; else break;
       } else if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) break L41; else break;
      } while (0);
      i3 = i3 + 24 | 0;
      if ((i3 | 0) == (i22 | 0)) {
       i21 = 97;
       break L1;
      }
     }
     if ((i21 | 0) == 35) {
      i21 = 0;
      i4 = i3 + 8 | 0;
     }
     HEAP32[i3 >> 2] = i12;
     HEAP32[i22 >> 2] = i9;
     i16 = i4;
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i26 = i3 + 16 | 0;
     i25 = i26;
     i17 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     i12 = i23;
     i14 = HEAP32[i12 + 4 >> 2] | 0;
     i13 = i4;
     HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i13 + 4 >> 2] = i14;
     i13 = i24;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     HEAP32[i26 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i26 + 4 >> 2] = i14;
     i26 = i23;
     HEAP32[i26 >> 2] = i15;
     HEAP32[i26 + 4 >> 2] = i16;
     i26 = i24;
     HEAP32[i26 >> 2] = i17;
     HEAP32[i26 + 4 >> 2] = i25;
     i3 = i3 + 24 | 0;
    } while (0);
    if ((i3 | 0) == (i22 | 0)) {
     i21 = 97;
     break L1;
    }
    i12 = i1 + 16 | 0;
    i13 = i1 + 8 | 0;
    i8 = i22;
    while (1) {
     i11 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     L57 : do if (i11 >>> 0 >= i4 >>> 0) do {
      do if (i4 >>> 0 >= i11 >>> 0) {
       i5 = i13;
       i4 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i7 = i3 + 8 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
        i25 = i12;
        i16 = HEAP32[i25 + 4 >> 2] | 0;
        i26 = i3 + 16 | 0;
        i17 = HEAP32[i26 + 4 >> 2] | 0;
        if (i16 >>> 0 < i17 >>> 0 | ((i16 | 0) == (i17 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break L57; else break;
       } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) break L57; else break;
      } while (0);
      i3 = i3 + 24 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
     } while (i11 >>> 0 >= i4 >>> 0); while (0);
     i4 = i8;
     while (1) {
      i5 = i4 + -24 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if (i11 >>> 0 < i6 >>> 0) {
       i4 = i5;
       continue;
      }
      if (i6 >>> 0 < i11 >>> 0) break;
      i8 = i13;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i10 = i4 + -16 | 0;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      if ((i7 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
       i25 = i12;
       i16 = HEAP32[i25 + 4 >> 2] | 0;
       i26 = i4 + -8 | 0;
       i17 = HEAP32[i26 + 4 >> 2] | 0;
       if (i16 >>> 0 < i17 >>> 0 | ((i16 | 0) == (i17 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) {
        i4 = i5;
        continue;
       } else break;
      } else if (i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i7 >>> 0 < i9 >>> 0) {
       i4 = i5;
       continue;
      } else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i5 >> 2] = i8;
     i8 = i3 + 8 | 0;
     i16 = i8;
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i14 = i3 + 16 | 0;
     i26 = i14;
     i25 = HEAP32[i26 >> 2] | 0;
     i26 = HEAP32[i26 + 4 >> 2] | 0;
     i17 = i4 + -16 | 0;
     i11 = i17;
     i10 = HEAP32[i11 + 4 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i8 + 4 >> 2] = i10;
     i8 = i4 + -8 | 0;
     i10 = i8;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i14 + 4 >> 2] = i11;
     HEAP32[i17 >> 2] = i15;
     HEAP32[i17 + 4 >> 2] = i16;
     HEAP32[i8 >> 2] = i25;
     HEAP32[i8 + 4 >> 2] = i26;
     i8 = i5;
     i3 = i3 + 24 | 0;
    }
   }
   if ((i21 | 0) == 59) {
    i7 = i12 + -16 | 0;
    i5 = i7;
    i6 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i21 = 65;
   }
   if ((i21 | 0) == 65) {
    i21 = 0;
    HEAP32[i1 >> 2] = i13;
    HEAP32[i4 >> 2] = i16;
    i26 = i1 + 8 | 0;
    i13 = i26;
    i11 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i14 = i1 + 16 | 0;
    i25 = i14;
    i16 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 4 >> 2] | 0;
    HEAP32[i26 >> 2] = i6;
    HEAP32[i26 + 4 >> 2] = i5;
    i26 = i12 + -8 | 0;
    i10 = i26;
    i12 = HEAP32[i10 + 4 >> 2] | 0;
    HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i14 + 4 >> 2] = i12;
    i14 = i7;
    HEAP32[i14 >> 2] = i11;
    HEAP32[i14 + 4 >> 2] = i13;
    HEAP32[i26 >> 2] = i16;
    HEAP32[i26 + 4 >> 2] = i25;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 24 | 0;
   L81 : do if (i5 >>> 0 < i4 >>> 0) {
    i12 = i15;
    while (1) {
     i11 = HEAP32[i12 >> 2] | 0;
     i14 = i12 + 8 | 0;
     i15 = i12 + 16 | 0;
     i13 = i5;
     L84 : while (1) {
      i5 = HEAP32[i13 >> 2] | 0;
      do if (i5 >>> 0 >= i11 >>> 0) {
       if (i11 >>> 0 < i5 >>> 0) break L84;
       i7 = i13 + 8 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       i9 = i14;
       i8 = HEAP32[i9 >> 2] | 0;
       i9 = HEAP32[i9 + 4 >> 2] | 0;
       if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
        i25 = i13 + 16 | 0;
        i10 = HEAP32[i25 + 4 >> 2] | 0;
        i26 = i15;
        i16 = HEAP32[i26 + 4 >> 2] | 0;
        if (i10 >>> 0 < i16 >>> 0 | ((i10 | 0) == (i16 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break; else break L84;
       } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) break; else break L84;
      } while (0);
      i13 = i13 + 24 | 0;
     }
     i10 = i5;
     i5 = i4 + -24 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     L94 : do if (i6 >>> 0 >= i11 >>> 0) while (1) {
      do if (i11 >>> 0 >= i6 >>> 0) {
       i7 = i4 + -16 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       i9 = i14;
       i8 = HEAP32[i9 >> 2] | 0;
       i9 = HEAP32[i9 + 4 >> 2] | 0;
       if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
        i25 = i4 + -8 | 0;
        i9 = HEAP32[i25 + 4 >> 2] | 0;
        i26 = i15;
        i16 = HEAP32[i26 + 4 >> 2] | 0;
        if (i9 >>> 0 < i16 >>> 0 | ((i9 | 0) == (i16 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break L94; else break;
       } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) break L94; else break;
      } while (0);
      i7 = i5 + -24 | 0;
      i6 = HEAP32[i7 >> 2] | 0;
      if (i6 >>> 0 < i11 >>> 0) {
       i4 = i5;
       i5 = i7;
       break;
      } else {
       i4 = i5;
       i5 = i7;
      }
     } while (0);
     if (i13 >>> 0 > i5 >>> 0) break L81;
     HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i10;
     i9 = i13 + 8 | 0;
     i15 = i9;
     i14 = HEAP32[i15 >> 2] | 0;
     i15 = HEAP32[i15 + 4 >> 2] | 0;
     i11 = i13 + 16 | 0;
     i26 = i11;
     i25 = HEAP32[i26 >> 2] | 0;
     i26 = HEAP32[i26 + 4 >> 2] | 0;
     i16 = i4 + -16 | 0;
     i8 = i16;
     i10 = HEAP32[i8 + 4 >> 2] | 0;
     HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i9 + 4 >> 2] = i10;
     i4 = i4 + -8 | 0;
     i9 = i4;
     i10 = HEAP32[i9 + 4 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i11 + 4 >> 2] = i10;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i16 + 4 >> 2] = i15;
     HEAP32[i4 >> 2] = i25;
     HEAP32[i4 + 4 >> 2] = i26;
     i12 = (i12 | 0) == (i13 | 0) ? i5 : i12;
     i4 = i5;
     i5 = i13 + 24 | 0;
     i3 = i3 + 1 | 0;
    }
   } else {
    i12 = i15;
    i13 = i5;
   } while (0);
   L106 : do if ((i13 | 0) != (i12 | 0)) {
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    i10 = i5;
    i11 = i4;
    do if (i4 >>> 0 < i5 >>> 0) {
     i7 = i12 + 8 | 0;
     i4 = i7;
     i6 = i13 + 8 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
    } else {
     if (i5 >>> 0 < i4 >>> 0) break L106;
     i7 = i12 + 8 | 0;
     i4 = i7;
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     i6 = i13 + 8 | 0;
     i9 = i6;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     if ((i5 | 0) == (i8 | 0) & (i4 | 0) == (i9 | 0)) {
      i25 = i12 + 16 | 0;
      i15 = HEAP32[i25 + 4 >> 2] | 0;
      i26 = i13 + 16 | 0;
      i16 = HEAP32[i26 + 4 >> 2] | 0;
      if (i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break; else break L106;
     } else if (i4 >>> 0 < i9 >>> 0 | (i4 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0) break; else break L106;
    } while (0);
    HEAP32[i13 >> 2] = i11;
    HEAP32[i12 >> 2] = i10;
    i14 = i6;
    i11 = HEAP32[i14 >> 2] | 0;
    i14 = HEAP32[i14 + 4 >> 2] | 0;
    i15 = i13 + 16 | 0;
    i25 = i15;
    i16 = HEAP32[i25 >> 2] | 0;
    i25 = HEAP32[i25 + 4 >> 2] | 0;
    i26 = i6;
    HEAP32[i26 >> 2] = i5;
    HEAP32[i26 + 4 >> 2] = i4;
    i26 = i12 + 16 | 0;
    i10 = i26;
    i12 = HEAP32[i10 + 4 >> 2] | 0;
    HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i15 + 4 >> 2] = i12;
    i15 = i7;
    HEAP32[i15 >> 2] = i11;
    HEAP32[i15 + 4 >> 2] = i14;
    HEAP32[i26 >> 2] = i16;
    HEAP32[i26 + 4 >> 2] = i25;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEbT0_SC_T_(i1, i13, i20) | 0;
    i4 = i13 + 24 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEbT0_SC_T_(i4, i2, i20) | 0) {
     i21 = 96;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i26 = i13;
   if ((i26 - i17 | 0) >= (i18 - i26 | 0)) {
    i21 = 95;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(i1, i13, i20);
   i1 = i13 + 24 | 0;
  }
  if ((i21 | 0) == 95) {
   i21 = 0;
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(i13 + 24 | 0, i2, i20);
   i2 = i13;
   continue;
  } else if ((i21 | 0) == 96) {
   i21 = 0;
   if (i3) {
    i21 = 97;
    break;
   } else {
    i2 = i13;
    continue;
   }
  }
 }
 if ((i21 | 0) == 5) {
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i7 = i3;
  i8 = i2;
  do if (i2 >>> 0 < i3 >>> 0) {
   i2 = i23;
   i4 = i1 + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  } else {
   if (i3 >>> 0 < i2 >>> 0) return;
   i2 = i23;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i1 + 8 | 0;
   i6 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i3 | 0) == (i5 | 0) & (i2 | 0) == (i6 | 0)) {
    i25 = i24;
    i20 = HEAP32[i25 + 4 >> 2] | 0;
    i26 = i1 + 16 | 0;
    i21 = HEAP32[i26 + 4 >> 2] | 0;
    if (i20 >>> 0 < i21 >>> 0 | ((i20 | 0) == (i21 | 0) ? (HEAP32[i25 >> 2] | 0) >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0 : 0)) break;
    return;
   } else {
    if (i2 >>> 0 < i6 >>> 0 | (i2 | 0) == (i6 | 0) & i3 >>> 0 < i5 >>> 0) break;
    return;
   }
  } while (0);
  HEAP32[i1 >> 2] = i8;
  HEAP32[i22 >> 2] = i7;
  i21 = i4;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i26 = i1 + 16 | 0;
  i25 = i26;
  i22 = HEAP32[i25 >> 2] | 0;
  i25 = HEAP32[i25 + 4 >> 2] | 0;
  i18 = i4;
  HEAP32[i18 >> 2] = i3;
  HEAP32[i18 + 4 >> 2] = i2;
  i18 = i24;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i26 + 4 >> 2] = i19;
  i26 = i23;
  HEAP32[i26 >> 2] = i20;
  HEAP32[i26 + 4 >> 2] = i21;
  i26 = i24;
  HEAP32[i26 >> 2] = i22;
  HEAP32[i26 + 4 >> 2] = i25;
  return;
 } else if ((i21 | 0) == 12) {
  __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i1, i1 + 24 | 0, i22, i20) | 0;
  return;
 } else if ((i21 | 0) == 13) {
  __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i22, i20) | 0;
  return;
 } else if ((i21 | 0) == 14) {
  __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i1 + 72 | 0, i22, i20) | 0;
  return;
 } else if ((i21 | 0) == 16) {
  __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(i1, i2, i20);
  return;
 } else if ((i21 | 0) == 97) return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i62, i63, i1, i64, i65, i59, i67, i48, i50, i42, i66) {
 i62 = i62 | 0;
 i63 = i63 | 0;
 i1 = i1 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i59 = i59 | 0;
 i67 = i67 | 0;
 i48 = i48 | 0;
 i50 = i50 | 0;
 i42 = i42 | 0;
 i66 = i66 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f60 = f0, f61 = f0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i68 + 460 | 0;
 i39 = i68 + 448 | 0;
 i58 = i68 + 128 | 0;
 i57 = i68 + 272 | 0;
 i55 = i68 + 208 | 0;
 i56 = i68 + 144 | 0;
 i47 = i68 + 432 | 0;
 i49 = i68 + 416 | 0;
 i38 = i68 + 112 | 0;
 i37 = i68 + 408 | 0;
 i14 = i68 + 96 | 0;
 i15 = i68 + 396 | 0;
 i16 = i68 + 80 | 0;
 i51 = i68 + 64 | 0;
 i54 = i68 + 48 | 0;
 i52 = i68 + 384 | 0;
 i53 = i68 + 372 | 0;
 i36 = i68 + 32 | 0;
 i35 = i68 + 360 | 0;
 i43 = i68 + 16 | 0;
 i46 = i68;
 i45 = i68 + 348 | 0;
 i44 = i68 + 336 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f60 = Math_fround(HEAPF32[i62 + 16 >> 2]);
 f61 = Math_fround(HEAPF32[i63 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i62 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i63 + 32 >> 2]);
 f12 = Math_fround((f12 > f3 ? f3 : f12) * Math_fround(.100000001));
 f12 = Math_fround(f12 * f12);
 f3 = Math_fround(f60 + f61);
 i32 = i38 + 4 | 0;
 i33 = i38 + 8 | 0;
 i34 = i38 + 12 | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 HEAP32[i37 >> 2] = 0;
 i1 = HEAP8[i42 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f30 = Math_fround(HEAPF32[i62 >> 2]);
  f4 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i62 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i63 >> 2]);
  f6 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f5 = Math_fround(f30 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i63 + 8 >> 2]));
  i31 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i31 ? f5 : Math_fround(1.0);
  f6 = i31 ? f6 : Math_fround(0.0);
  f7 = i31 ? f7 : Math_fround(0.0);
  HEAPF32[i58 >> 2] = f5;
  HEAPF32[i58 + 4 >> 2] = f6;
  HEAPF32[i58 + 8 >> 2] = f7;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i16 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  i31 = i58;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i41 = 6;
 } else {
  f4 = Math_fround(HEAPF32[i63 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i63 + 148 >> 2]);
  f6 = Math_fround(HEAPF32[i63 + 152 >> 2]);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f9 = Math_fround(-f6);
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i31 = HEAPU8[i48 + i11 >> 0] | 0;
   HEAP32[i47 + (i11 << 2) >> 2] = i31;
   i29 = HEAPU8[i50 + i11 >> 0] | 0;
   HEAP32[i49 + (i11 << 2) >> 2] = i29;
   f73 = Math_fround(HEAPF32[i62 + 96 + (i31 << 4) >> 2]);
   f72 = Math_fround(HEAPF32[i62 + 96 + (i31 << 4) + 4 >> 2]);
   f71 = Math_fround(HEAPF32[i62 + 96 + (i31 << 4) + 8 >> 2]);
   i31 = HEAP32[i62 + 96 + (i31 << 4) + 12 >> 2] | 0;
   f70 = HEAP32[gb + 48 + (i29 << 4) >> 2] | 0 ? f4 : f7;
   f69 = HEAP32[gb + 48 + (i29 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f30 = HEAP32[gb + 48 + (i29 << 4) + 8 >> 2] | 0 ? f6 : f9;
   f75 = Math_fround(f72 - f69);
   f74 = Math_fround(f71 - f30);
   HEAPF32[i38 >> 2] = Math_fround(f73 - f70);
   HEAPF32[i32 >> 2] = f75;
   HEAPF32[i33 >> 2] = f74;
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   HEAPF32[i55 + (i2 << 4) >> 2] = f73;
   HEAPF32[i55 + (i2 << 4) + 4 >> 2] = f72;
   HEAPF32[i55 + (i2 << 4) + 8 >> 2] = f71;
   HEAP32[i55 + (i2 << 4) + 12 >> 2] = i31;
   HEAPF32[i56 + (i2 << 4) >> 2] = f70;
   HEAPF32[i56 + (i2 << 4) + 4 >> 2] = f69;
   HEAPF32[i56 + (i2 << 4) + 8 >> 2] = f30;
   HEAPF32[i56 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   i31 = i57 + (i2 << 4) | 0;
   HEAP32[i31 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i37 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i14, i57, i55, i56, i47, i49, i38, i37);
  HEAP32[i58 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i58 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i58 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i40 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i39 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  if (f4 > f12) {
   i31 = i58;
   i41 = 6;
  }
 }
 do if ((i41 | 0) == 6) {
  i2 = i58 + 4 | 0;
  i14 = i58 + 8 | 0;
  i15 = i62 + 96 | 0;
  i17 = i62 + 100 | 0;
  i18 = i62 + 104 | 0;
  i19 = i62 + 112 | 0;
  i20 = i62 + 116 | 0;
  i21 = i62 + 120 | 0;
  i22 = i62 + 128 | 0;
  i23 = i62 + 132 | 0;
  i24 = i62 + 136 | 0;
  i25 = i63 + 144 | 0;
  i26 = i63 + 148 | 0;
  i27 = i63 + 152 | 0;
  i28 = i62 + 48 | 0;
  i29 = i63 + 48 | 0;
  f8 = f10;
  f30 = f4;
  while (1) {
   HEAP32[i39 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
   f80 = Math_fround(-f5);
   f79 = Math_fround(-f6);
   f4 = Math_fround(-f7);
   i11 = HEAP32[i37 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i15 >> 2]);
   f69 = Math_fround(HEAPF32[i17 >> 2]);
   f73 = Math_fround(HEAPF32[i18 >> 2]);
   f10 = Math_fround(HEAPF32[i19 >> 2]);
   f75 = Math_fround(HEAPF32[i20 >> 2]);
   f72 = Math_fround(HEAPF32[i21 >> 2]);
   f70 = Math_fround(HEAPF32[i22 >> 2]);
   f71 = Math_fround(HEAPF32[i23 >> 2]);
   f74 = Math_fround(HEAPF32[i24 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f9 * f80) + Math_fround(f69 * f79)) + Math_fround(f73 * f4));
   f77 = Math_fround(Math_fround(Math_fround(f10 * f80) + Math_fround(f75 * f79)) + Math_fround(f72 * f4));
   f4 = Math_fround(Math_fround(Math_fround(f70 * f80) + Math_fround(f71 * f79)) + Math_fround(f74 * f4));
   i13 = f78 > f77 & f78 > f4;
   i76 = f77 > f4;
   HEAP32[i47 + (i11 << 2) >> 2] = i13 ? 0 : i76 ? 1 : 2;
   f70 = i13 ? f9 : i76 ? f10 : f70;
   f71 = i13 ? f69 : i76 ? f75 : f71;
   f74 = i13 ? f73 : i76 ? f72 : f74;
   HEAPF32[i55 + (i11 << 4) >> 2] = f70;
   HEAPF32[i55 + (i11 << 4) + 4 >> 2] = f71;
   HEAPF32[i55 + (i11 << 4) + 8 >> 2] = f74;
   HEAPF32[i55 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   i76 = f5 > Math_fround(0.0);
   i13 = f6 > Math_fround(0.0);
   i1 = f7 > Math_fround(0.0);
   HEAP32[i49 + (i11 << 2) >> 2] = i13 << 31 >> 31 << 1 & 2 | i76 & 1 | i1 << 31 >> 31 << 2 & 4;
   f7 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(HEAPF32[i26 >> 2]);
   f5 = Math_fround(HEAPF32[i27 >> 2]);
   f72 = Math_fround(-f7);
   f73 = Math_fround(-f6);
   f75 = Math_fround(-f5);
   f72 = i76 ? f7 : f72;
   f73 = i13 ? f6 : f73;
   f75 = i1 ? f5 : f75;
   HEAPF32[i56 + (i11 << 4) >> 2] = f72;
   HEAPF32[i56 + (i11 << 4) + 4 >> 2] = f73;
   HEAPF32[i56 + (i11 << 4) + 8 >> 2] = f75;
   HEAPF32[i56 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   f72 = Math_fround(f70 - f72);
   f73 = Math_fround(f71 - f73);
   f75 = Math_fround(f74 - f75);
   HEAPF32[i38 >> 2] = f72;
   HEAPF32[i32 >> 2] = f73;
   HEAPF32[i33 >> 2] = f75;
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   i11 = i57 + (i11 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i28 >> 2]);
   f74 = Math_fround(HEAPF32[i29 >> 2]);
   f74 = f5 > f74 ? f5 : f74;
   f8 = f8 > f74 ? f8 : f74;
   f74 = Math_fround(f3 + f8);
   f74 = Math_fround(f30 * Math_fround(f74 * f74));
   f5 = Math_fround(HEAPF32[i58 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f5 * f72) + Math_fround(f6 * f73)) + Math_fround(f7 * f75));
   i11 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f74;
   i1 = Math_fround(f30 * Math_fround(.00039999999)) >= Math_fround(f30 - f75) | i11;
   i13 = HEAP32[i37 >> 2] | 0;
   if (i1) {
    f4 = f30;
    i41 = 8;
    break;
   }
   HEAP32[i37 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i36, i57, i55, i56, i47, i49, i38, i37);
   HEAP32[i31 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i58 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i40 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   i1 = f30 > f4;
   if (!(f4 > f12 & i1)) break; else f30 = f4;
  }
  if ((i41 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i48 | 0) {
    HEAP8[i42 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
      HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i76 = 0;
    STACKTOP = i68;
    return i76 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f4)));
   f4 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f5 * f4);
   f8 = Math_fround(f6 * f4);
   f7 = Math_fround(f7 * f4);
   HEAPF32[i59 >> 2] = f9;
   HEAPF32[i59 + 4 >> 2] = f8;
   HEAPF32[i59 + 8 >> 2] = f7;
   HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i57, i55, i56, i58, i51, i54, i13);
   f5 = Math_fround(HEAPF32[i51 >> 2]);
   f6 = Math_fround(HEAPF32[i51 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i51 + 8 >> 2]);
   if (i66) {
    f79 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
    f75 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
    f80 = Math_fround(f79 + f75);
    f78 = Math_fround(f6 - Math_fround(f8 * f79));
    f77 = Math_fround(f4 - Math_fround(f7 * f79));
    HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f9 * f79));
    HEAPF32[i64 + 4 >> 2] = f78;
    HEAPF32[i64 + 8 >> 2] = f77;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    f77 = Math_fround(HEAPF32[i54 >> 2]);
    f78 = Math_fround(HEAPF32[i54 + 4 >> 2]);
    f78 = Math_fround(Math_fround(f8 * f75) + f78);
    f79 = Math_fround(Math_fround(f7 * f75) + Math_fround(HEAPF32[i54 + 8 >> 2]));
    HEAPF32[i65 >> 2] = Math_fround(Math_fround(f9 * f75) + f77);
    HEAPF32[i65 + 4 >> 2] = f78;
    HEAPF32[i65 + 8 >> 2] = f79;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i67 >> 2] = Math_fround(f10 - f80);
    i76 = i67 + 4 | 0;
    HEAP32[i76 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i76 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i76 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    i76 = 1;
    STACKTOP = i68;
    return i76 | 0;
   } else {
    f79 = Math_fround(f6 - Math_fround(f60 * f8));
    f78 = Math_fround(f4 - Math_fround(f60 * f7));
    HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f60 * f9));
    HEAPF32[i64 + 4 >> 2] = f79;
    HEAPF32[i64 + 8 >> 2] = f78;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    f78 = Math_fround(HEAPF32[i54 >> 2]);
    f79 = Math_fround(HEAPF32[i54 + 4 >> 2]);
    f79 = Math_fround(Math_fround(f61 * f8) + f79);
    f80 = Math_fround(Math_fround(f61 * f7) + Math_fround(HEAPF32[i54 + 8 >> 2]));
    HEAPF32[i65 >> 2] = Math_fround(Math_fround(f61 * f9) + f78);
    HEAPF32[i65 + 4 >> 2] = f79;
    HEAPF32[i65 + 8 >> 2] = f80;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i67 >> 2] = Math_fround(f10 - f3);
    i76 = i67 + 4 | 0;
    HEAP32[i76 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i76 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
    HEAP32[i76 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
    i76 = 1;
    STACKTOP = i68;
    return i76 | 0;
   }
  }
  if (i1) {
   if (!i48) i1 = 6; else break;
   STACKTOP = i68;
   return i1 | 0;
  };
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  i11 = HEAP32[i37 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i48 | 0) {
   HEAP8[i42 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
     HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i31 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i57, i55, i56, i58, i43, i46, i11);
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f30)));
  f9 = Math_fround(HEAPF32[i58 >> 2]);
  f10 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i58 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i43 >> 2]);
  f6 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  if (i66) {
   f80 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
   f77 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
   f3 = Math_fround(f80 + f77);
   f79 = Math_fround(f6 - Math_fround(f10 * f80));
   f78 = Math_fround(f4 - Math_fround(f7 * f80));
   HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f9 * f80));
   HEAPF32[i64 + 4 >> 2] = f79;
   HEAPF32[i64 + 8 >> 2] = f78;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   f78 = Math_fround(HEAPF32[i46 >> 2]);
   f79 = Math_fround(HEAPF32[i46 + 4 >> 2]);
   f79 = Math_fround(Math_fround(f10 * f77) + f79);
   f80 = Math_fround(Math_fround(f7 * f77) + Math_fround(HEAPF32[i46 + 8 >> 2]));
   HEAPF32[i65 >> 2] = Math_fround(Math_fround(f9 * f77) + f78);
   HEAPF32[i65 + 4 >> 2] = f79;
   HEAPF32[i65 + 8 >> 2] = f80;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   i76 = i67 + 4 | 0;
   HEAP32[i76 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i76 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i76 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  } else {
   f79 = Math_fround(f6 - Math_fround(f60 * f10));
   f78 = Math_fround(f4 - Math_fround(f60 * f7));
   HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f60 * f9));
   HEAPF32[i64 + 4 >> 2] = f79;
   HEAPF32[i64 + 8 >> 2] = f78;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   f78 = Math_fround(HEAPF32[i46 >> 2]);
   f79 = Math_fround(HEAPF32[i46 + 4 >> 2]);
   f79 = Math_fround(Math_fround(f61 * f10) + f79);
   f80 = Math_fround(Math_fround(f61 * f7) + Math_fround(HEAPF32[i46 + 8 >> 2]));
   HEAPF32[i65 >> 2] = Math_fround(Math_fround(f61 * f9) + f78);
   HEAPF32[i65 + 4 >> 2] = f79;
   HEAPF32[i65 + 8 >> 2] = f80;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   i76 = i67 + 4 | 0;
   HEAP32[i76 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i76 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i76 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  }
  HEAPF32[i67 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i59 >> 2] = f9;
  HEAPF32[i59 + 4 >> 2] = f10;
  HEAPF32[i59 + 8 >> 2] = f7;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  i76 = f12 >= f30 ? 1 : 3;
  STACKTOP = i68;
  return i76 | 0;
 } while (0);
 i2 = HEAP32[i37 >> 2] | 0;
 HEAP8[i42 >> 0] = i2;
 if (!i2) {
  i76 = 6;
  STACKTOP = i68;
  return i76 | 0;
 } else i1 = 0;
 do {
  HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
  HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i68;
 return i1 | 0;
}

function __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i32 + 128 | 0;
 i29 = i32 + 16 | 0;
 i30 = i32;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i31 = i29 + 11 | 0;
 HEAP8[i31 >> 0] = 7;
 HEAP8[i29 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
 HEAP8[i29 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
 HEAP8[i29 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
 HEAP8[i29 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
 HEAP8[i29 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
 HEAP8[i29 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
 HEAP8[i29 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
 HEAP8[i29 + 7 >> 0] = 0;
 i4 = i29 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i29 + 20 >> 2] = 0;
 HEAP32[i29 + 24 >> 2] = 0;
 HEAP32[i29 + 28 >> 2] = 1;
 HEAP32[i29 + 32 >> 2] = 1;
 HEAPF32[i29 + 36 >> 2] = Math_fround(15.0);
 HEAPF32[i29 + 40 >> 2] = Math_fround(3.0);
 HEAPF32[i29 + 44 >> 2] = Math_fround(.333333343);
 HEAPF32[i29 + 48 >> 2] = Math_fround(.0666666701);
 HEAPF32[i29 + 52 >> 2] = Math_fround(.200000003);
 HEAPF32[i29 + 56 >> 2] = Math_fround(.466666669);
 HEAP32[i29 + 60 >> 2] = 1;
 HEAP32[i29 + 64 >> 2] = 1;
 i17 = i29 + 68 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAPF32[i29 + 84 >> 2] = Math_fround(.300000012);
 HEAP32[i29 + 88 >> 2] = 0;
 HEAP32[i29 + 92 >> 2] = 4;
 HEAPF32[i29 + 96 >> 2] = Math_fround(512.0);
 HEAP32[i29 + 100 >> 2] = 2;
 HEAP32[i29 + 104 >> 2] = 4;
 i17 = i27 + 108 | 0;
 i20 = i27 + 216 | 0;
 i21 = i27 + 324 | 0;
 i23 = i27 + 432 | 0;
 i1 = i27 + 540 | 0;
 i26 = i1 + 11 | 0;
 L1 : do if ((i1 | 0) != (i29 | 0)) {
  do if ((HEAP8[i26 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 548 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 7) {
    i25 = HEAP32[i27 + 544 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 8 - i2 | 0, i25, 0, i25, 7, i29);
    break L1;
   } else {
    i2 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } else i2 = i1; while (0);
  _memmove(i2 | 0, i29 | 0, 7) | 0;
  HEAP8[i2 + 7 >> 0] = 0;
  if ((HEAP8[i26 >> 0] | 0) < 0) {
   HEAP32[i27 + 544 >> 2] = 7;
   break;
  } else {
   HEAP8[i26 >> 0] = 7;
   break;
  }
 } while (0);
 i25 = i27 + 556 | 0;
 i6 = i25;
 i3 = i4;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 i6 = HEAP8[i26 >> 0] | 0;
 i22 = i6 << 24 >> 24 < 0;
 i5 = i22 ? HEAP32[i1 >> 2] | 0 : i1;
 i24 = i27 + 544 | 0;
 i6 = i22 ? HEAP32[i24 >> 2] | 0 : i6 & 255;
 i22 = i23 + 11 | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i27 + 440 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i27 + 436 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i23, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
  i2 = HEAP8[i22 >> 0] | 0;
 } else {
  if (i3) i2 = HEAP32[i23 >> 2] | 0; else i2 = i23;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  i2 = HEAP8[i22 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   HEAP32[i27 + 436 >> 2] = i6;
   break;
  } else {
   i2 = i6 & 255;
   HEAP8[i22 >> 0] = i2;
   break;
  }
 } while (0);
 i18 = i27 + 448 | 0;
 i6 = i18;
 i3 = i25;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 i6 = i2 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i23 >> 2] | 0 : i23;
 i19 = i27 + 436 | 0;
 i6 = i6 ? HEAP32[i19 >> 2] | 0 : i2 & 255;
 i16 = i21 + 11 | 0;
 i2 = HEAP8[i16 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i27 + 332 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i27 + 328 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
  i2 = HEAP8[i16 >> 0] | 0;
 } else {
  if (i3) i2 = HEAP32[i21 >> 2] | 0; else i2 = i21;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  i2 = HEAP8[i16 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   HEAP32[i27 + 328 >> 2] = i6;
   break;
  } else {
   i2 = i6 & 255;
   HEAP8[i16 >> 0] = i2;
   break;
  }
 } while (0);
 i14 = i27 + 340 | 0;
 i6 = i14;
 i3 = i18;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 i6 = i2 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i21 >> 2] | 0 : i21;
 i15 = i27 + 328 | 0;
 i6 = i6 ? HEAP32[i15 >> 2] | 0 : i2 & 255;
 i13 = i20 + 11 | 0;
 i2 = HEAP8[i13 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i27 + 224 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i27 + 220 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
  i2 = HEAP8[i13 >> 0] | 0;
 } else {
  if (i3) i2 = HEAP32[i20 >> 2] | 0; else i2 = i20;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  i2 = HEAP8[i13 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   HEAP32[i27 + 220 >> 2] = i6;
   break;
  } else {
   i2 = i6 & 255;
   HEAP8[i13 >> 0] = i2;
   break;
  }
 } while (0);
 i11 = i27 + 232 | 0;
 i6 = i11;
 i3 = i14;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 i6 = i2 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i20 >> 2] | 0 : i20;
 i12 = i27 + 220 | 0;
 i6 = i6 ? HEAP32[i12 >> 2] | 0 : i2 & 255;
 i10 = i17 + 11 | 0;
 i2 = HEAP8[i10 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i27 + 116 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i27 + 112 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
  i2 = HEAP8[i10 >> 0] | 0;
 } else {
  if (i3) i2 = HEAP32[i17 >> 2] | 0; else i2 = i17;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  i2 = HEAP8[i10 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   HEAP32[i27 + 112 >> 2] = i6;
   break;
  } else {
   i2 = i6 & 255;
   HEAP8[i10 >> 0] = i2;
   break;
  }
 } while (0);
 i8 = i27 + 124 | 0;
 i6 = i8;
 i3 = i11;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 i6 = i2 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i17 >> 2] | 0 : i17;
 i9 = i27 + 112 | 0;
 i6 = i6 ? HEAP32[i9 >> 2] | 0 : i2 & 255;
 i4 = i27 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i27 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i27 + 4 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i27, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
 } else {
  if (i3) i2 = HEAP32[i27 >> 2] | 0; else i2 = i27;
  if (i6 | 0) _memmove(i2 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i27 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 i6 = i27 + 16 | 0;
 i3 = i8;
 i5 = i6 + 92 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i5 | 0));
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i30 + 11 | 0;
 HEAP8[i4 >> 0] = 4;
 HEAP32[i30 >> 2] = 1953718598;
 HEAP8[i30 + 4 >> 0] = 0;
 L119 : do if ((i17 | 0) != (i30 | 0)) {
  do if ((HEAP8[i10 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 116 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 4) {
    i10 = HEAP32[i9 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, 5 - i2 | 0, i10, 0, i10, 4, i30);
    break L119;
   } else {
    i2 = HEAP32[i17 >> 2] | 0;
    break;
   }
  } else i2 = i17; while (0);
  i17 = HEAP32[i30 >> 2] | 0;
  HEAP8[i2 >> 0] = i17;
  HEAP8[i2 + 1 >> 0] = i17 >> 8;
  HEAP8[i2 + 2 >> 0] = i17 >> 16;
  HEAP8[i2 + 3 >> 0] = i17 >> 24;
  HEAP8[i2 + 4 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i9 >> 2] = 4;
   break;
  } else {
   HEAP8[i10 >> 0] = 4;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i17 = HEAP32[i30 >> 2] | 0;
  i10 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 66;
  HEAP32[i28 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i28);
 }
 HEAPF32[i27 + 144 >> 2] = Math_fround(20.0);
 HEAP32[i27 + 168 >> 2] = 2;
 i4 = i27 + 172 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP16[i4 + 16 >> 1] = 0;
 HEAPF32[i27 + 192 >> 2] = Math_fround(.400000006);
 HEAP32[i27 + 200 >> 2] = 16;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i30 + 11 | 0;
 HEAP8[i4 >> 0] = 6;
 HEAP8[i30 >> 0] = HEAP8[gb + 405500 >> 0] | 0;
 HEAP8[i30 + 1 >> 0] = HEAP8[gb + 405500 + 1 >> 0] | 0;
 HEAP8[i30 + 2 >> 0] = HEAP8[gb + 405500 + 2 >> 0] | 0;
 HEAP8[i30 + 3 >> 0] = HEAP8[gb + 405500 + 3 >> 0] | 0;
 HEAP8[i30 + 4 >> 0] = HEAP8[gb + 405500 + 4 >> 0] | 0;
 HEAP8[i30 + 5 >> 0] = HEAP8[gb + 405500 + 5 >> 0] | 0;
 HEAP8[i30 + 6 >> 0] = 0;
 L134 : do if ((i20 | 0) != (i30 | 0)) {
  do if ((HEAP8[i13 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 224 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 6) {
    i17 = HEAP32[i12 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i3, 7 - i2 | 0, i17, 0, i17, 6, i30);
    break L134;
   } else {
    i2 = HEAP32[i20 >> 2] | 0;
    break;
   }
  } else i2 = i20; while (0);
  _memmove(i2 | 0, i30 | 0, 6) | 0;
  HEAP8[i2 + 6 >> 0] = 0;
  if ((HEAP8[i13 >> 0] | 0) < 0) {
   HEAP32[i12 >> 2] = 6;
   break;
  } else {
   HEAP8[i13 >> 0] = 6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i20 = HEAP32[i30 >> 2] | 0;
  i17 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 66;
  HEAP32[i28 + 4 >> 2] = i17;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i28);
 }
 HEAP32[i11 >> 2] = 1;
 HEAP32[i27 + 236 >> 2] = 1;
 HEAPF32[i27 + 252 >> 2] = Math_fround(20.0);
 HEAP32[i27 + 276 >> 2] = 2;
 HEAP32[i27 + 280 >> 2] = 0;
 HEAP32[i27 + 284 >> 2] = 1;
 HEAP32[i27 + 288 >> 2] = 0;
 HEAP32[i27 + 292 >> 2] = 1;
 HEAP8[i27 + 296 >> 0] = 0;
 HEAP8[i27 + 297 >> 0] = 0;
 HEAPF32[i27 + 300 >> 2] = Math_fround(.699999988);
 HEAP32[i27 + 308 >> 2] = 64;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i30 + 11 | 0;
 HEAP8[i4 >> 0] = 4;
 HEAP32[i30 >> 2] = 1685024583;
 HEAP8[i30 + 4 >> 0] = 0;
 L149 : do if ((i21 | 0) != (i30 | 0)) {
  do if ((HEAP8[i16 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 332 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 4) {
    i20 = HEAP32[i15 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i3, 5 - i2 | 0, i20, 0, i20, 4, i30);
    break L149;
   } else {
    i2 = HEAP32[i21 >> 2] | 0;
    break;
   }
  } else i2 = i21; while (0);
  i21 = HEAP32[i30 >> 2] | 0;
  HEAP8[i2 >> 0] = i21;
  HEAP8[i2 + 1 >> 0] = i21 >> 8;
  HEAP8[i2 + 2 >> 0] = i21 >> 16;
  HEAP8[i2 + 3 >> 0] = i21 >> 24;
  HEAP8[i2 + 4 >> 0] = 0;
  if ((HEAP8[i16 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = 4;
   break;
  } else {
   HEAP8[i16 >> 0] = 4;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i21 = HEAP32[i30 >> 2] | 0;
  i20 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 66;
  HEAP32[i28 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i28);
 }
 HEAP32[i14 >> 2] = 2;
 HEAP32[i27 + 344 >> 2] = 2;
 HEAP32[i27 + 348 >> 2] = 1;
 HEAP32[i27 + 356 >> 2] = 2;
 HEAPF32[i27 + 360 >> 2] = Math_fround(40.0);
 HEAPF32[i27 + 368 >> 2] = Math_fround(.333333343);
 HEAP32[i27 + 384 >> 2] = 2;
 HEAP32[i27 + 388 >> 2] = 0;
 HEAP32[i27 + 392 >> 2] = 1;
 HEAP32[i27 + 400 >> 2] = 1;
 HEAP8[i27 + 405 >> 0] = 1;
 HEAP8[i27 + 406 >> 0] = 1;
 HEAP8[i27 + 407 >> 0] = 1;
 HEAPF32[i27 + 408 >> 2] = Math_fround(1.0);
 HEAP32[i27 + 416 >> 2] = 256;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i30 + 11 | 0;
 HEAP8[i4 >> 0] = 9;
 i6 = i30;
 i3 = gb + 405507 | 0;
 i5 = i6 + 9 | 0;
 do {
  HEAP8[i6 >> 0] = HEAP8[i3 >> 0] | 0;
  i6 = i6 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i6 | 0) < (i5 | 0));
 HEAP8[i30 + 9 >> 0] = 0;
 L164 : do if ((i23 | 0) != (i30 | 0)) {
  do if ((HEAP8[i22 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 440 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 9) {
    i22 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i23, i3, 10 - i2 | 0, i22, 0, i22, 9, i30);
    break L164;
   } else {
    i2 = HEAP32[i23 >> 2] | 0;
    break;
   }
  } else i2 = i23; while (0);
  _memmove(i2 | 0, i30 | 0, 9) | 0;
  HEAP8[i2 + 9 >> 0] = 0;
  if ((HEAP8[i22 >> 0] | 0) < 0) {
   HEAP32[i19 >> 2] = 9;
   break;
  } else {
   HEAP8[i22 >> 0] = 9;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i23 = HEAP32[i30 >> 2] | 0;
  i22 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 66;
  HEAP32[i28 + 4 >> 2] = i22;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i28);
 }
 HEAP32[i18 >> 2] = 3;
 HEAP32[i27 + 452 >> 2] = 2;
 HEAP32[i27 + 456 >> 2] = 2;
 HEAP32[i27 + 464 >> 2] = 2;
 HEAPF32[i27 + 468 >> 2] = Math_fround(70.0);
 HEAPF32[i27 + 476 >> 2] = Math_fround(.333333343);
 HEAP32[i27 + 492 >> 2] = 4;
 HEAP32[i27 + 496 >> 2] = 0;
 HEAP32[i27 + 500 >> 2] = 2;
 HEAP32[i27 + 504 >> 2] = 2;
 HEAP32[i27 + 508 >> 2] = 1;
 HEAP32[i27 + 512 >> 2] = 16843009;
 HEAPF32[i27 + 516 >> 2] = Math_fround(1.5);
 HEAP32[i27 + 524 >> 2] = 1024;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i30 + 11 | 0;
 HEAP8[i4 >> 0] = 9;
 i6 = i30;
 i3 = gb + 405517 | 0;
 i5 = i6 + 9 | 0;
 do {
  HEAP8[i6 >> 0] = HEAP8[i3 >> 0] | 0;
  i6 = i6 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i6 | 0) < (i5 | 0));
 HEAP8[i30 + 9 >> 0] = 0;
 L179 : do if ((i1 | 0) != (i30 | 0)) {
  do if ((HEAP8[i26 >> 0] | 0) < 0) {
   i2 = HEAP32[i27 + 548 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 9) {
    i26 = HEAP32[i24 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 10 - i2 | 0, i26, 0, i26, 9, i30);
    break L179;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } while (0);
  _memmove(i1 | 0, i30 | 0, 9) | 0;
  HEAP8[i1 + 9 >> 0] = 0;
  if ((HEAP8[i26 >> 0] | 0) < 0) {
   HEAP32[i24 >> 2] = 9;
   break;
  } else {
   HEAP8[i26 >> 0] = 9;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i26 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i28 >> 2] = 66;
  HEAP32[i28 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i26, i28);
 }
 HEAP32[i25 >> 2] = 4;
 HEAP32[i27 + 560 >> 2] = 2;
 HEAP32[i27 + 564 >> 2] = 2;
 HEAP32[i27 + 572 >> 2] = 4;
 HEAPF32[i27 + 576 >> 2] = Math_fround(150.0);
 HEAPF32[i27 + 588 >> 2] = Math_fround(.0666666701);
 HEAPF32[i27 + 592 >> 2] = Math_fround(.200000003);
 HEAPF32[i27 + 596 >> 2] = Math_fround(.466666669);
 HEAP32[i27 + 600 >> 2] = 4;
 HEAP32[i27 + 604 >> 2] = 0;
 HEAP32[i27 + 608 >> 2] = 2;
 HEAP32[i27 + 612 >> 2] = 2;
 HEAP32[i27 + 616 >> 2] = 1;
 HEAP32[i27 + 620 >> 2] = 16843009;
 HEAPF32[i27 + 624 >> 2] = Math_fround(2.0);
 HEAP32[i27 + 632 >> 2] = 4096;
 if ((HEAP8[i31 >> 0] | 0) >= 0) {
  STACKTOP = i32;
  return;
 }
 i31 = HEAP32[i29 >> 2] | 0;
 i30 = HEAP32[i29 + 12 >> 2] | 0;
 HEAP32[i28 >> 2] = 66;
 HEAP32[i28 + 4 >> 2] = i30;
 __Z19free_alloc_internalPvRK10MemLabelId(i31, i28);
 STACKTOP = i32;
 return;
}

function __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0;
 i41 = HEAP32[i4 >> 2] | 0;
 i43 = HEAP32[i4 + 32 >> 2] | 0;
 i46 = HEAP32[i4 + 64 >> 2] | 0;
 i48 = HEAP32[i4 + 96 >> 2] | 0;
 i20 = HEAP32[i41 >> 2] | 0;
 i17 = HEAP32[i41 + 4 >> 2] | 0;
 i13 = HEAP32[i41 + 8 >> 2] | 0;
 i42 = i41 + 16 | 0;
 i9 = HEAP32[i42 >> 2] | 0;
 i5 = HEAP32[i42 + 4 >> 2] | 0;
 i1 = HEAP32[i42 + 8 >> 2] | 0;
 i21 = HEAP32[i43 >> 2] | 0;
 i18 = HEAP32[i43 + 4 >> 2] | 0;
 i14 = HEAP32[i43 + 8 >> 2] | 0;
 i44 = i43 + 16 | 0;
 i10 = HEAP32[i44 >> 2] | 0;
 i6 = HEAP32[i44 + 4 >> 2] | 0;
 i2 = HEAP32[i44 + 8 >> 2] | 0;
 i22 = HEAP32[i46 >> 2] | 0;
 i19 = HEAP32[i46 + 4 >> 2] | 0;
 i15 = HEAP32[i46 + 8 >> 2] | 0;
 i45 = i46 + 16 | 0;
 i11 = HEAP32[i45 >> 2] | 0;
 i7 = HEAP32[i45 + 4 >> 2] | 0;
 i3 = HEAP32[i45 + 8 >> 2] | 0;
 i23 = HEAP32[i48 >> 2] | 0;
 i25 = HEAP32[i48 + 4 >> 2] | 0;
 i24 = HEAP32[i48 + 8 >> 2] | 0;
 i47 = i48 + 16 | 0;
 i16 = HEAP32[i47 >> 2] | 0;
 i12 = HEAP32[i47 + 4 >> 2] | 0;
 i8 = HEAP32[i47 + 8 >> 2] | 0;
 i26 = HEAP32[i4 + 16 >> 2] | 0;
 i39 = HEAP16[i4 + 26 >> 1] | 0;
 i40 = i26 + ((i39 & 65535) << 4) | 0;
 if (!(i39 << 16 >> 16)) {
  i49 = i23;
  i51 = i22;
  i53 = i21;
  i4 = i25;
  i50 = i19;
  i52 = i18;
  i54 = i17;
  i19 = i24;
  i18 = i15;
  i17 = i14;
  i15 = i13;
  i30 = i16;
  i27 = i11;
  i24 = i10;
  i21 = i9;
  i39 = i12;
  i28 = i7;
  i25 = i6;
  i22 = i5;
  i40 = i8;
  i29 = i3;
  i26 = i2;
  i23 = i1;
  HEAP32[i41 >> 2] = i20;
  i20 = i41 + 4 | 0;
  HEAP32[i20 >> 2] = i54;
  i20 = i41 + 8 | 0;
  HEAP32[i20 >> 2] = i15;
  HEAP32[i43 >> 2] = i53;
  i20 = i43 + 4 | 0;
  HEAP32[i20 >> 2] = i52;
  i20 = i43 + 8 | 0;
  HEAP32[i20 >> 2] = i17;
  HEAP32[i46 >> 2] = i51;
  i20 = i46 + 4 | 0;
  HEAP32[i20 >> 2] = i50;
  i20 = i46 + 8 | 0;
  HEAP32[i20 >> 2] = i18;
  HEAP32[i48 >> 2] = i49;
  i20 = i48 + 4 | 0;
  HEAP32[i20 >> 2] = i4;
  i20 = i48 + 8 | 0;
  HEAP32[i20 >> 2] = i19;
  HEAP32[i42 >> 2] = i21;
  i42 = i41 + 20 | 0;
  HEAP32[i42 >> 2] = i22;
  i42 = i41 + 24 | 0;
  HEAP32[i42 >> 2] = i23;
  HEAP32[i44 >> 2] = i24;
  i44 = i43 + 20 | 0;
  HEAP32[i44 >> 2] = i25;
  i44 = i43 + 24 | 0;
  HEAP32[i44 >> 2] = i26;
  HEAP32[i45 >> 2] = i27;
  i45 = i46 + 20 | 0;
  HEAP32[i45 >> 2] = i28;
  i46 = i46 + 24 | 0;
  HEAP32[i46 >> 2] = i29;
  HEAP32[i47 >> 2] = i30;
  i47 = i48 + 20 | 0;
  HEAP32[i47 >> 2] = i39;
  i48 = i48 + 24 | 0;
  HEAP32[i48 >> 2] = i40;
  return;
 } else {
  i4 = i8;
  i8 = i12;
  i12 = i16;
  i16 = i26;
 }
 while (1) {
  i28 = i16 + 64 | 0;
  i29 = i16 + (((HEAPU8[i16 + 1 >> 0] | 0) << 4) + 64) | 0;
  i54 = HEAP8[i16 + 2 >> 0] | 0;
  i30 = i54 & 255;
  i39 = i29 + (i30 * 192 | 0) | 0;
  f31 = Math_fround(HEAPF32[i16 + 16 >> 2]);
  f32 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f33 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  f34 = Math_fround(HEAPF32[i16 + 28 >> 2]);
  f35 = Math_fround(HEAPF32[i16 + 32 >> 2]);
  f36 = Math_fround(HEAPF32[i16 + 36 >> 2]);
  f37 = Math_fround(HEAPF32[i16 + 40 >> 2]);
  f38 = Math_fround(HEAPF32[i16 + 44 >> 2]);
  if (!(i54 << 24 >> 24)) i16 = i24; else {
   i27 = i16 + 12 | 0;
   i26 = i18;
   i16 = i24;
   i18 = 0;
   while (1) {
    i24 = i18 + 1 | 0;
    i51 = i18 >>> (HEAP32[i27 >> 2] | 0);
    f114 = Math_fround(HEAPF32[i28 + (i51 << 4) >> 2]);
    f113 = Math_fround(HEAPF32[i28 + (i51 << 4) + 4 >> 2]);
    f112 = Math_fround(HEAPF32[i28 + (i51 << 4) + 8 >> 2]);
    f114 = Math_fround(f31 * f114);
    f113 = Math_fround(f32 * f113);
    f112 = Math_fround(f33 * f112);
    f111 = Math_fround(f34 * Math_fround(HEAPF32[i28 + (i51 << 4) + 12 >> 2]));
    f58 = Math_fround(-f114);
    f57 = Math_fround(-f113);
    f56 = Math_fround(-f112);
    f55 = Math_fround(-f111);
    f98 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 96 >> 2]);
    f97 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 100 >> 2]);
    f96 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 104 >> 2]);
    f95 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 108 >> 2]);
    f82 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 112 >> 2]);
    f81 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 116 >> 2]);
    f80 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 120 >> 2]);
    f79 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 124 >> 2]);
    f69 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 128 >> 2]);
    f67 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 132 >> 2]);
    f65 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 136 >> 2]);
    f63 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 140 >> 2]);
    f106 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) >> 2]);
    f105 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 4 >> 2]);
    f104 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 8 >> 2]);
    f103 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 12 >> 2]);
    f90 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 16 >> 2]);
    f89 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 20 >> 2]);
    f88 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 24 >> 2]);
    f87 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 28 >> 2]);
    f74 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 32 >> 2]);
    f73 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 36 >> 2]);
    f72 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 40 >> 2]);
    f71 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 44 >> 2]);
    f75 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 48 >> 2]);
    f76 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 52 >> 2]);
    f77 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 56 >> 2]);
    f78 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 60 >> 2]);
    f133 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 64 >> 2]);
    f129 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 68 >> 2]);
    f125 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 72 >> 2]);
    f121 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 76 >> 2]);
    f132 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 80 >> 2]);
    f128 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 84 >> 2]);
    f124 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 88 >> 2]);
    f120 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 92 >> 2]);
    i51 = i29 + (i18 * 192 | 0) + 144 | 0;
    f62 = Math_fround(HEAPF32[i51 >> 2]);
    i52 = i29 + (i18 * 192 | 0) + 148 | 0;
    f61 = Math_fround(HEAPF32[i52 >> 2]);
    i53 = i29 + (i18 * 192 | 0) + 152 | 0;
    f60 = Math_fround(HEAPF32[i53 >> 2]);
    i54 = i29 + (i18 * 192 | 0) + 156 | 0;
    f59 = Math_fround(HEAPF32[i54 >> 2]);
    f131 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 160 >> 2]);
    f127 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 164 >> 2]);
    f123 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 168 >> 2]);
    f119 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 172 >> 2]);
    f118 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 176 >> 2]);
    f117 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 180 >> 2]);
    f116 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 184 >> 2]);
    f115 = Math_fround(HEAPF32[i29 + (i18 * 192 | 0) + 188 >> 2]);
    f110 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f134 = Math_fround(f110 * f106);
    f109 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f130 = Math_fround(f109 * f105);
    f108 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f126 = Math_fround(f108 * f104);
    f107 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f122 = Math_fround(f107 * f103);
    f102 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f75 = Math_fround(f102 * f75);
    f101 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f76 = Math_fround(f101 * f76);
    f100 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f77 = Math_fround(f100 * f77);
    f99 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f78 = Math_fround(f99 * f78);
    f94 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f93 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f92 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f91 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f134 = Math_fround(f134 + Math_fround(f94 * f90));
    f130 = Math_fround(f130 + Math_fround(f93 * f89));
    f126 = Math_fround(f126 + Math_fround(f92 * f88));
    f122 = Math_fround(f122 + Math_fround(f91 * f87));
    f86 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f85 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f84 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f83 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f133 = Math_fround(f75 + Math_fround(f86 * f133));
    f129 = Math_fround(f76 + Math_fround(f85 * f129));
    f125 = Math_fround(f77 + Math_fround(f84 * f125));
    f121 = Math_fround(f78 + Math_fround(f83 * f121));
    f78 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f77 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f76 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f75 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f134 = Math_fround(f134 + Math_fround(f78 * f74));
    f130 = Math_fround(f130 + Math_fround(f77 * f73));
    f126 = Math_fround(f126 + Math_fround(f76 * f72));
    f122 = Math_fround(f122 + Math_fround(f75 * f71));
    f70 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f68 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f66 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f64 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f106 = Math_fround(f35 * f106);
    f105 = Math_fround(f36 * f105);
    f104 = Math_fround(f37 * f104);
    f103 = Math_fround(f38 * f103);
    f90 = Math_fround(f35 * f90);
    f89 = Math_fround(f36 * f89);
    f88 = Math_fround(f37 * f88);
    f87 = Math_fround(f38 * f87);
    f74 = Math_fround(f35 * f74);
    f73 = Math_fround(f36 * f73);
    f72 = Math_fround(f37 * f72);
    f71 = Math_fround(f38 * f71);
    f118 = Math_fround(Math_fround(Math_fround(f134 + Math_fround(f133 + Math_fround(f70 * f132))) * f131) + Math_fround(f62 - Math_fround(f131 * f118)));
    f117 = Math_fround(Math_fround(Math_fround(f130 + Math_fround(f129 + Math_fround(f68 * f128))) * f127) + Math_fround(f61 - Math_fround(f127 * f117)));
    f116 = Math_fround(Math_fround(Math_fround(f126 + Math_fround(f125 + Math_fround(f66 * f124))) * f123) + Math_fround(f60 - Math_fround(f123 * f116)));
    f115 = Math_fround(Math_fround(Math_fround(f122 + Math_fround(f121 + Math_fround(f64 * f120))) * f119) + Math_fround(f59 - Math_fround(f119 * f115)));
    f114 = f118 < f114 ? f118 : f114;
    f113 = f117 < f113 ? f117 : f113;
    f112 = f116 < f112 ? f116 : f112;
    f111 = f115 < f111 ? f115 : f111;
    f58 = f114 > f58 ? f114 : f58;
    f57 = f113 > f57 ? f113 : f57;
    f56 = f112 > f56 ? f112 : f56;
    f55 = f111 > f55 ? f111 : f55;
    f62 = Math_fround(f58 - f62);
    f61 = Math_fround(f57 - f61);
    f60 = Math_fround(f56 - f60);
    f59 = Math_fround(f55 - f59);
    f106 = Math_fround(f110 + Math_fround(f106 * f62));
    f105 = Math_fround(f109 + Math_fround(f105 * f61));
    f104 = Math_fround(f108 + Math_fround(f104 * f60));
    f103 = Math_fround(f107 + Math_fround(f103 * f59));
    i20 = (HEAPF32[tempDoublePtr >> 2] = f106, HEAP32[tempDoublePtr >> 2] | 0);
    i21 = (HEAPF32[tempDoublePtr >> 2] = f105, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
    f98 = Math_fround(f102 + Math_fround(f98 * f62));
    f97 = Math_fround(f101 + Math_fround(f97 * f61));
    f96 = Math_fround(f100 + Math_fround(f96 * f60));
    f95 = Math_fround(f99 + Math_fround(f95 * f59));
    i9 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f97, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f96, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f95, HEAP32[tempDoublePtr >> 2] | 0);
    f90 = Math_fround(f94 + Math_fround(f90 * f62));
    f89 = Math_fround(f93 + Math_fround(f89 * f61));
    f88 = Math_fround(f92 + Math_fround(f88 * f60));
    f87 = Math_fround(f91 + Math_fround(f87 * f59));
    i17 = (HEAPF32[tempDoublePtr >> 2] = f90, HEAP32[tempDoublePtr >> 2] | 0);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f89, HEAP32[tempDoublePtr >> 2] | 0);
    i19 = (HEAPF32[tempDoublePtr >> 2] = f88, HEAP32[tempDoublePtr >> 2] | 0);
    i25 = (HEAPF32[tempDoublePtr >> 2] = f87, HEAP32[tempDoublePtr >> 2] | 0);
    f82 = Math_fround(f86 + Math_fround(f82 * f62));
    f81 = Math_fround(f85 + Math_fround(f81 * f61));
    f80 = Math_fround(f84 + Math_fround(f80 * f60));
    f79 = Math_fround(f83 + Math_fround(f79 * f59));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f79, HEAP32[tempDoublePtr >> 2] | 0);
    f74 = Math_fround(f78 + Math_fround(f74 * f62));
    f73 = Math_fround(f77 + Math_fround(f73 * f61));
    f72 = Math_fround(f76 + Math_fround(f72 * f60));
    f71 = Math_fround(f75 + Math_fround(f71 * f59));
    i13 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
    f62 = Math_fround(f70 + Math_fround(f69 * f62));
    f61 = Math_fround(f68 + Math_fround(f67 * f61));
    f60 = Math_fround(f66 + Math_fround(f65 * f60));
    f59 = Math_fround(f64 + Math_fround(f63 * f59));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i51 >> 2] = f58;
    HEAPF32[i52 >> 2] = f57;
    HEAPF32[i53 >> 2] = f56;
    HEAPF32[i54 >> 2] = f55;
    if ((i24 | 0) == (i30 | 0)) break; else {
     i26 = i18;
     i18 = i24;
    }
   }
  }
  if (i39 >>> 0 < i40 >>> 0) {
   i24 = i16;
   i16 = i39;
  } else {
   i24 = i25;
   break;
  }
 }
 HEAP32[i41 >> 2] = i20;
 i54 = i41 + 4 | 0;
 HEAP32[i54 >> 2] = i17;
 i54 = i41 + 8 | 0;
 HEAP32[i54 >> 2] = i13;
 HEAP32[i43 >> 2] = i21;
 i54 = i43 + 4 | 0;
 HEAP32[i54 >> 2] = i18;
 i54 = i43 + 8 | 0;
 HEAP32[i54 >> 2] = i14;
 HEAP32[i46 >> 2] = i22;
 i54 = i46 + 4 | 0;
 HEAP32[i54 >> 2] = i19;
 i54 = i46 + 8 | 0;
 HEAP32[i54 >> 2] = i15;
 HEAP32[i48 >> 2] = i23;
 i54 = i48 + 4 | 0;
 HEAP32[i54 >> 2] = i24;
 i54 = i48 + 8 | 0;
 HEAP32[i54 >> 2] = i16;
 HEAP32[i42 >> 2] = i9;
 i54 = i41 + 20 | 0;
 HEAP32[i54 >> 2] = i5;
 i54 = i41 + 24 | 0;
 HEAP32[i54 >> 2] = i1;
 HEAP32[i44 >> 2] = i10;
 i54 = i43 + 20 | 0;
 HEAP32[i54 >> 2] = i6;
 i54 = i43 + 24 | 0;
 HEAP32[i54 >> 2] = i2;
 HEAP32[i45 >> 2] = i11;
 i54 = i46 + 20 | 0;
 HEAP32[i54 >> 2] = i7;
 i54 = i46 + 24 | 0;
 HEAP32[i54 >> 2] = i3;
 HEAP32[i47 >> 2] = i12;
 i54 = i48 + 20 | 0;
 HEAP32[i54 >> 2] = i8;
 i54 = i48 + 24 | 0;
 HEAP32[i54 >> 2] = i4;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i55, i56, i60, i1, i80, i81, i82, i83, i85, i87, i73) {
 i55 = i55 | 0;
 i56 = i56 | 0;
 i60 = i60 | 0;
 i1 = i1 | 0;
 i80 = i80 | 0;
 i81 = i81 | 0;
 i82 = i82 | 0;
 i83 = i83 | 0;
 i85 = i85 | 0;
 i87 = i87 | 0;
 i73 = i73 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f57 = f0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i84 = 0, i86 = 0, i88 = 0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0;
 i88 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i88 + 288 | 0;
 i67 = i88 + 468 | 0;
 i66 = i88 + 456 | 0;
 i78 = i88 + 304 | 0;
 i76 = i88 + 224 | 0;
 i77 = i88 + 160 | 0;
 i84 = i88 + 440 | 0;
 i86 = i88 + 424 | 0;
 i61 = i88 + 416 | 0;
 i79 = i88 + 144 | 0;
 i34 = i88 + 128 | 0;
 i33 = i88 + 112 | 0;
 i35 = i88 + 404 | 0;
 i36 = i88 + 96 | 0;
 i62 = i88 + 80 | 0;
 i69 = i88 + 64 | 0;
 i70 = i88 + 48 | 0;
 i68 = i88 + 392 | 0;
 i59 = i88 + 32 | 0;
 i58 = i88 + 380 | 0;
 i64 = i88 + 16 | 0;
 i65 = i88;
 i63 = i88 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f74 = Math_fround(HEAPF32[i55 + 16 >> 2]);
 f75 = Math_fround(HEAPF32[i56 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i55 + 32 >> 2]);
 f72 = Math_fround(HEAPF32[i56 + 32 >> 2]);
 f57 = Math_fround((f57 > f72 ? f72 : f57) * Math_fround(.100000001));
 f57 = Math_fround(f57 * f57);
 f72 = Math_fround(f74 + f75);
 HEAP32[i61 >> 2] = 0;
 i1 = HEAP8[i73 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i60 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i60 + 56 >> 2]);
  i54 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i54 ? f5 : Math_fround(1.0);
  f6 = i54 ? f6 : Math_fround(0.0);
  f7 = i54 ? f7 : Math_fround(0.0);
  HEAPF32[i79 >> 2] = f5;
  HEAPF32[i79 + 4 >> 2] = f6;
  HEAPF32[i79 + 8 >> 2] = f7;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i36 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  i54 = i79;
  i53 = i36;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i71 = 7;
 } else {
  HEAP32[i34 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f4 = Math_fround(HEAPF32[i55 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i55 + 148 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 152 >> 2]);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f11 = Math_fround(-f6);
  f12 = Math_fround(HEAPF32[i60 + 48 >> 2]);
  f13 = Math_fround(HEAPF32[i60 + 52 >> 2]);
  f14 = Math_fround(HEAPF32[i60 + 56 >> 2]);
  f15 = Math_fround(HEAPF32[i60 >> 2]);
  f16 = Math_fround(HEAPF32[i60 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i60 + 32 >> 2]);
  f18 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i60 + 20 >> 2]);
  f20 = Math_fround(HEAPF32[i60 + 36 >> 2]);
  f21 = Math_fround(HEAPF32[i60 + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i60 + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i60 + 40 >> 2]);
  f24 = Math_fround(HEAPF32[i56 + 144 >> 2]);
  f25 = Math_fround(HEAPF32[i56 + 148 >> 2]);
  f26 = Math_fround(HEAPF32[i56 + 152 >> 2]);
  f27 = Math_fround(-f24);
  f28 = Math_fround(-f25);
  f29 = Math_fround(-f26);
  i30 = i34 + 4 | 0;
  i31 = i34 + 8 | 0;
  i32 = i34 + 12 | 0;
  i2 = i1 & 255;
  i9 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i53 = HEAPU8[i85 + i3 >> 0] | 0;
   HEAP32[i84 + (i3 << 2) >> 2] = i53;
   i54 = HEAPU8[i87 + i3 >> 0] | 0;
   HEAP32[i86 + (i3 << 2) >> 2] = i54;
   f90 = HEAP32[gb + 48 + (i53 << 4) >> 2] | 0 ? f4 : f7;
   f91 = HEAP32[gb + 48 + (i53 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f92 = HEAP32[gb + 48 + (i53 << 4) + 8 >> 2] | 0 ? f6 : f11;
   f94 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f90 * f15) + Math_fround(f91 * f16)) + Math_fround(f92 * f17)));
   f93 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f90 * f18) + Math_fround(f91 * f19)) + Math_fround(f92 * f20)));
   f92 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f90 * f21) + Math_fround(f91 * f22)) + Math_fround(f92 * f23)));
   f91 = HEAP32[gb + 48 + (i54 << 4) >> 2] | 0 ? f24 : f27;
   f90 = HEAP32[gb + 48 + (i54 << 4) + 4 >> 2] | 0 ? f25 : f28;
   f89 = HEAP32[gb + 48 + (i54 << 4) + 8 >> 2] | 0 ? f26 : f29;
   f96 = Math_fround(f93 - f90);
   f95 = Math_fround(f92 - f89);
   HEAPF32[i34 >> 2] = Math_fround(f94 - f91);
   HEAPF32[i30 >> 2] = f96;
   HEAPF32[i31 >> 2] = f95;
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   HEAPF32[i76 + (i1 << 4) >> 2] = f94;
   HEAPF32[i76 + (i1 << 4) + 4 >> 2] = f93;
   HEAPF32[i76 + (i1 << 4) + 8 >> 2] = f92;
   HEAPF32[i76 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i77 + (i1 << 4) >> 2] = f91;
   HEAPF32[i77 + (i1 << 4) + 4 >> 2] = f90;
   HEAPF32[i77 + (i1 << 4) + 8 >> 2] = f89;
   HEAPF32[i77 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i54 = i78 + (i1 << 4) | 0;
   HEAP32[i54 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i54 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i61 >> 2] = i9;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i33, i78, i76, i77, i84, i86, i34, i61);
  HEAP32[i79 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i79 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i79 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i79 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i79 >> 2]);
  f6 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i79 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i67 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i66 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i36 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i79 + 12 >> 2];
  if (f4 > f57) {
   i54 = i79;
   i53 = i36;
   i71 = 7;
  } else i2 = HEAP32[i61 >> 2] | 0;
 }
 do if ((i71 | 0) == 7) {
  i51 = i79 + 4 | 0;
  i52 = i79 + 8 | 0;
  i31 = i60 + 4 | 0;
  i32 = i60 + 8 | 0;
  i33 = i60 + 16 | 0;
  i34 = i60 + 20 | 0;
  i35 = i60 + 24 | 0;
  i36 = i60 + 32 | 0;
  i37 = i60 + 36 | 0;
  i38 = i60 + 40 | 0;
  i39 = i55 + 144 | 0;
  i40 = i55 + 148 | 0;
  i41 = i55 + 152 | 0;
  i42 = i60 + 48 | 0;
  i43 = i60 + 52 | 0;
  i44 = i60 + 56 | 0;
  i45 = i56 + 144 | 0;
  i46 = i56 + 148 | 0;
  i47 = i56 + 152 | 0;
  i48 = i62 + 4 | 0;
  i49 = i62 + 8 | 0;
  i50 = i62 + 12 | 0;
  i30 = i55 + 48 | 0;
  i9 = i56 + 48 | 0;
  while (1) {
   HEAP32[i66 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
   HEAP32[i53 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
   f29 = Math_fround(-f5);
   f27 = Math_fround(-f6);
   f23 = Math_fround(-f7);
   i3 = HEAP32[i61 >> 2] | 0;
   f25 = Math_fround(HEAPF32[i60 >> 2]);
   f92 = Math_fround(f25 * f29);
   f28 = Math_fround(HEAPF32[i31 >> 2]);
   f92 = Math_fround(f92 + Math_fround(f28 * f27));
   f94 = Math_fround(HEAPF32[i32 >> 2]);
   f92 = Math_fround(f92 + Math_fround(f94 * f23));
   f26 = Math_fround(HEAPF32[i33 >> 2]);
   f24 = Math_fround(f26 * f29);
   f96 = Math_fround(HEAPF32[i34 >> 2]);
   f24 = Math_fround(f24 + Math_fround(f96 * f27));
   f90 = Math_fround(HEAPF32[i35 >> 2]);
   f24 = Math_fround(f24 + Math_fround(f90 * f23));
   f93 = Math_fround(HEAPF32[i36 >> 2]);
   f29 = Math_fround(f93 * f29);
   f95 = Math_fround(HEAPF32[i37 >> 2]);
   f27 = Math_fround(f29 + Math_fround(f95 * f27));
   f29 = Math_fround(HEAPF32[i38 >> 2]);
   i56 = f92 > Math_fround(0.0);
   i2 = f24 > Math_fround(0.0);
   i55 = Math_fround(f27 + Math_fround(f29 * f23)) > Math_fround(0.0);
   f23 = Math_fround(HEAPF32[i39 >> 2]);
   f27 = Math_fround(HEAPF32[i40 >> 2]);
   f24 = Math_fround(HEAPF32[i41 >> 2]);
   f92 = Math_fround(-f23);
   f89 = Math_fround(-f27);
   f91 = Math_fround(-f24);
   f92 = i56 ? f23 : f92;
   f89 = i2 ? f27 : f89;
   f91 = i55 ? f24 : f91;
   HEAP32[i84 + (i3 << 2) >> 2] = i2 << 31 >> 31 << 1 & 2 | i56 & 1 | i55 << 31 >> 31 << 2 & 4;
   f24 = Math_fround(HEAPF32[i42 >> 2]);
   f27 = Math_fround(HEAPF32[i43 >> 2]);
   f93 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f25 * f92) + Math_fround(f26 * f89)) + Math_fround(f93 * f91)));
   f95 = Math_fround(f27 + Math_fround(Math_fround(Math_fround(f28 * f92) + Math_fround(f96 * f89)) + Math_fround(f95 * f91)));
   f91 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) + Math_fround(Math_fround(Math_fround(f94 * f92) + Math_fround(f90 * f89)) + Math_fround(f29 * f91)));
   HEAPF32[i76 + (i3 << 4) >> 2] = f93;
   HEAPF32[i76 + (i3 << 4) + 4 >> 2] = f95;
   HEAPF32[i76 + (i3 << 4) + 8 >> 2] = f91;
   HEAPF32[i76 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i55 = f5 > Math_fround(0.0);
   i56 = f6 > Math_fround(0.0);
   i2 = f7 > Math_fround(0.0);
   HEAP32[i86 + (i3 << 2) >> 2] = i56 << 31 >> 31 << 1 & 2 | i55 & 1 | i2 << 31 >> 31 << 2 & 4;
   f29 = Math_fround(HEAPF32[i45 >> 2]);
   f89 = Math_fround(HEAPF32[i46 >> 2]);
   f90 = Math_fround(HEAPF32[i47 >> 2]);
   f92 = Math_fround(-f29);
   f94 = Math_fround(-f89);
   f96 = Math_fround(-f90);
   f92 = i55 ? f29 : f92;
   f94 = i56 ? f89 : f94;
   f96 = i2 ? f90 : f96;
   HEAPF32[i77 + (i3 << 4) >> 2] = f92;
   HEAPF32[i77 + (i3 << 4) + 4 >> 2] = f94;
   HEAPF32[i77 + (i3 << 4) + 8 >> 2] = f96;
   HEAPF32[i77 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f92 = Math_fround(f93 - f92);
   f94 = Math_fround(f95 - f94);
   f96 = Math_fround(f91 - f96);
   HEAPF32[i62 >> 2] = f92;
   HEAPF32[i48 >> 2] = f94;
   HEAPF32[i49 >> 2] = f96;
   HEAPF32[i50 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i61 >> 2] | 0;
   i2 = i78 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i62 + 12 >> 2];
   f91 = Math_fround(HEAPF32[i30 >> 2]);
   f95 = Math_fround(HEAPF32[i9 >> 2]);
   f95 = f91 > f95 ? f91 : f95;
   f10 = f10 > f95 ? f10 : f95;
   f95 = Math_fround(f72 + f10);
   f95 = Math_fround(f4 * Math_fround(f95 * f95));
   f91 = Math_fround(HEAPF32[i79 >> 2]);
   f93 = Math_fround(HEAPF32[i51 >> 2]);
   f96 = Math_fround(Math_fround(Math_fround(f91 * f92) + Math_fround(f93 * f94)) + Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f96));
   i2 = f96 > Math_fround(0.0) & Math_fround(f96 * f96) > f95;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f96) | i2) {
    i71 = 9;
    break;
   }
   HEAP32[i61 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i59, i78, i76, i77, i84, i86, i62, i61);
   HEAP32[i54 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i54 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i79 >> 2]);
   f6 = Math_fround(HEAPF32[i51 >> 2]);
   f7 = Math_fround(HEAPF32[i52 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i67 >> 2] = HEAP32[i58 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f57 & i1)) break; else f4 = f8;
  }
  if ((i71 | 0) == 9) {
   if (i85 | 0) {
    HEAP8[i73 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
      HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i87 = 0;
    STACKTOP = i88;
    return i87 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i69, i70, i3);
   f93 = Math_fround(Math_sqrt(Math_fround(f4)));
   f94 = Math_fround(HEAPF32[i79 >> 2]);
   f95 = Math_fround(HEAPF32[i51 >> 2]);
   f96 = Math_fround(Math_fround(1.0) / f93);
   f94 = Math_fround(f94 * f96);
   f95 = Math_fround(f95 * f96);
   f96 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f96);
   f92 = Math_fround(HEAPF32[i69 >> 2]);
   f91 = Math_fround(HEAPF32[i69 + 4 >> 2]);
   f91 = Math_fround(f91 - Math_fround(f74 * f95));
   f90 = Math_fround(Math_fround(HEAPF32[i69 + 8 >> 2]) - Math_fround(f74 * f96));
   HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
   HEAPF32[i80 + 4 >> 2] = f91;
   HEAPF32[i80 + 8 >> 2] = f90;
   HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
   f90 = Math_fround(HEAPF32[i70 >> 2]);
   f91 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f91 = Math_fround(Math_fround(f75 * f95) + f91);
   f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i70 + 8 >> 2]));
   HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
   HEAPF32[i81 + 4 >> 2] = f91;
   HEAPF32[i81 + 8 >> 2] = f92;
   HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
   i87 = i83 + 4 | 0;
   HEAP32[i87 >> 2] = HEAP32[i68 >> 2];
   HEAP32[i87 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
   HEAP32[i87 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
   HEAPF32[i82 >> 2] = f94;
   HEAPF32[i82 + 4 >> 2] = f95;
   HEAPF32[i82 + 8 >> 2] = f96;
   HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
   i87 = 1;
   STACKTOP = i88;
   return i87 | 0;
  }
  i2 = HEAP32[i61 >> 2] | 0;
  if (i1) {
   if (!i85) i1 = 6; else break;
   STACKTOP = i88;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i85 | 0) {
   HEAP8[i73 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
     HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i54 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i78, i76, i77, i79, i64, i65, i2);
  HEAP32[i67 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  f93 = Math_fround(Math_sqrt(Math_fround(f4)));
  f94 = Math_fround(HEAPF32[i79 >> 2]);
  f95 = Math_fround(HEAPF32[i79 + 4 >> 2]);
  f96 = Math_fround(Math_fround(1.0) / f93);
  f94 = Math_fround(f94 * f96);
  f95 = Math_fround(f95 * f96);
  f96 = Math_fround(Math_fround(HEAPF32[i79 + 8 >> 2]) * f96);
  f92 = Math_fround(HEAPF32[i64 >> 2]);
  f91 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f91 = Math_fround(f91 - Math_fround(f74 * f95));
  f90 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) - Math_fround(f74 * f96));
  HEAPF32[i80 >> 2] = Math_fround(f92 - Math_fround(f74 * f94));
  HEAPF32[i80 + 4 >> 2] = f91;
  HEAPF32[i80 + 8 >> 2] = f90;
  HEAPF32[i80 + 12 >> 2] = Math_fround(0.0);
  f90 = Math_fround(HEAPF32[i65 >> 2]);
  f91 = Math_fround(HEAPF32[i65 + 4 >> 2]);
  f91 = Math_fround(Math_fround(f75 * f95) + f91);
  f92 = Math_fround(Math_fround(f75 * f96) + Math_fround(HEAPF32[i65 + 8 >> 2]));
  HEAPF32[i81 >> 2] = Math_fround(Math_fround(f75 * f94) + f90);
  HEAPF32[i81 + 4 >> 2] = f91;
  HEAPF32[i81 + 8 >> 2] = f92;
  HEAPF32[i81 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i83 >> 2] = Math_fround(f93 - f72);
  i87 = i83 + 4 | 0;
  HEAP32[i87 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i87 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i87 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAPF32[i82 >> 2] = f94;
  HEAPF32[i82 + 4 >> 2] = f95;
  HEAPF32[i82 + 8 >> 2] = f96;
  HEAPF32[i82 + 12 >> 2] = Math_fround(0.0);
  i87 = 3;
  STACKTOP = i88;
  return i87 | 0;
 } while (0);
 HEAP8[i73 >> 0] = i2;
 if (!i2) {
  i87 = 6;
  STACKTOP = i88;
  return i87 | 0;
 } else i1 = 0;
 do {
  HEAP8[i85 + i1 >> 0] = HEAP32[i84 + (i1 << 2) >> 2];
  HEAP8[i87 + i1 >> 0] = HEAP32[i86 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i88;
 return i1 | 0;
}

function __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i51, i2, i20, i43, i1, i21, i52, i53) {
 i51 = i51 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i43 = i43 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, f42 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f54 = f0, f55 = f0, f56 = f0;
 HEAP32[i21 >> 2] = 3;
 i17 = HEAP32[i1 >> 2] | 0;
 i18 = HEAP32[i1 + 4 >> 2] | 0;
 i41 = HEAP32[i1 + 8 >> 2] | 0;
 i16 = i2 + (i17 << 4) | 0;
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + (i17 << 4) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + (i17 << 4) + 8 >> 2]);
 i1 = i2 + (i18 << 4) | 0;
 f25 = Math_fround(HEAPF32[i1 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + (i18 << 4) + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + (i18 << 4) + 8 >> 2]);
 i15 = i2 + (i41 << 4) | 0;
 f28 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + (i41 << 4) + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + (i41 << 4) + 8 >> 2]);
 f3 = Math_fround(f25 - f22);
 f4 = Math_fround(f24 - f19);
 f5 = Math_fround(f23 - f14);
 f6 = Math_fround(f28 - f22);
 f7 = Math_fround(f27 - f19);
 f8 = Math_fround(f26 - f14);
 f47 = Math_fround(f25 - f28);
 f48 = Math_fround(f24 - f27);
 f49 = Math_fround(f23 - f26);
 f50 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8));
 f49 = Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f48 * f48)) + Math_fround(f49 * f49));
 if ((f50 > f49 ? f49 : f50) <= Math_fround(1.1920929e-07)) {
  HEAP32[i21 >> 2] = 2;
  __ZN5physx2Gu21closestPtPointSegmentERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i51, i16, i1, i20 + (i17 << 4) | 0, i20 + (i18 << 4) | 0, i43 + (i17 << 4) | 0, i43 + (i18 << 4) | 0, i21, i52, i53);
  return;
 }
 f46 = Math_fround(-f22);
 f12 = Math_fround(-f19);
 f11 = Math_fround(-f14);
 f47 = Math_fround(-f25);
 f9 = Math_fround(-f24);
 f13 = Math_fround(-f23);
 f48 = Math_fround(-f28);
 f49 = Math_fround(-f27);
 f50 = Math_fround(-f26);
 f10 = Math_fround(Math_fround(Math_fround(f3 * f46) + Math_fround(f4 * f12)) + Math_fround(f5 * f11));
 f11 = Math_fround(Math_fround(Math_fround(f6 * f46) + Math_fround(f7 * f12)) + Math_fround(f8 * f11));
 f12 = Math_fround(Math_fround(Math_fround(f3 * f47) + Math_fround(f4 * f9)) + Math_fround(f5 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f6 * f47) + Math_fround(f7 * f9)) + Math_fround(f8 * f13));
 f9 = Math_fround(Math_fround(Math_fround(f3 * f48) + Math_fround(f4 * f49)) + Math_fround(f5 * f50));
 f3 = Math_fround(Math_fround(Math_fround(f6 * f48) + Math_fround(f7 * f49)) + Math_fround(f8 * f50));
 f4 = Math_fround(Math_fround(f12 * f3) - Math_fround(f9 * f13));
 f5 = Math_fround(Math_fround(f9 * f11) - Math_fround(f10 * f3));
 f6 = Math_fround(Math_fround(f10 * f13) - Math_fround(f12 * f11));
 if (f10 <= Math_fround(0.0) & f11 <= Math_fround(0.0)) {
  i41 = i20 + (i17 << 4) | 0;
  HEAP32[i52 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  i52 = i43 + (i17 << 4) | 0;
  HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i51 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  return;
 }
 if (f12 >= Math_fround(0.0) & f12 >= f13) {
  i41 = i20 + (i18 << 4) | 0;
  HEAP32[i52 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  i52 = i43 + (i18 << 4) | 0;
  HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i51 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  return;
 }
 if (f3 >= Math_fround(0.0) & f3 >= f9) {
  i21 = i20 + (i41 << 4) | 0;
  HEAP32[i52 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  i52 = i43 + (i41 << 4) | 0;
  HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i51 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  return;
 }
 if (f10 >= Math_fround(0.0) & f12 <= Math_fround(0.0) & f6 <= Math_fround(0.0)) {
  __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i51, i16, i1, i20 + (i17 << 4) | 0, i20 + (i18 << 4) | 0, i43 + (i17 << 4) | 0, i43 + (i18 << 4) | 0, i21, i52, i53);
  return;
 }
 if (f13 >= f12 & f9 >= f3 & f4 <= Math_fround(0.0)) {
  __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i51, i1, i15, i20 + (i18 << 4) | 0, i20 + (i41 << 4) | 0, i43 + (i18 << 4) | 0, i43 + (i41 << 4) | 0, i21, i52, i53);
  return;
 }
 if (f11 >= Math_fround(0.0) & f3 <= Math_fround(0.0) & f5 <= Math_fround(0.0)) {
  __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i51, i16, i15, i20 + (i17 << 4) | 0, i20 + (i41 << 4) | 0, i43 + (i17 << 4) | 0, i43 + (i41 << 4) | 0, i21, i52, i53);
  return;
 }
 HEAP32[i21 >> 2] = 3;
 f6 = Math_fround(HEAPF32[i20 + (i17 << 4) >> 2]);
 f7 = Math_fround(HEAPF32[i20 + (i17 << 4) + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i20 + (i17 << 4) + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i20 + (i18 << 4) >> 2]);
 f40 = Math_fround(HEAPF32[i20 + (i18 << 4) + 4 >> 2]);
 f42 = Math_fround(HEAPF32[i20 + (i18 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i20 + (i41 << 4) >> 2]);
 f33 = Math_fround(HEAPF32[i20 + (i41 << 4) + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i20 + (i41 << 4) + 8 >> 2]);
 f50 = Math_fround(HEAPF32[i43 + (i17 << 4) >> 2]);
 f49 = Math_fround(HEAPF32[i43 + (i17 << 4) + 4 >> 2]);
 f48 = Math_fround(HEAPF32[i43 + (i17 << 4) + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i43 + (i18 << 4) >> 2]);
 f35 = Math_fround(HEAPF32[i43 + (i18 << 4) + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i43 + (i18 << 4) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i43 + (i41 << 4) >> 2]);
 f4 = Math_fround(HEAPF32[i43 + (i41 << 4) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i43 + (i41 << 4) + 8 >> 2]);
 L29 : while (1) {
  f39 = f11;
  f37 = f9;
  f38 = f29;
  f36 = f5;
  f30 = f3;
  f31 = f4;
  f32 = f10;
  while (1) {
   f29 = Math_fround(f25 - f22);
   f5 = Math_fround(f24 - f19);
   f44 = Math_fround(f23 - f14);
   f45 = Math_fround(f28 - f22);
   f46 = Math_fround(f27 - f19);
   f47 = Math_fround(f26 - f14);
   f13 = Math_fround(f28 - f25);
   f55 = Math_fround(f27 - f24);
   f54 = Math_fround(f26 - f23);
   f11 = Math_fround(Math_fround(f44 * f44) + Math_fround(Math_fround(f5 * f5) + Math_fround(f29 * f29)));
   f12 = Math_fround(Math_fround(f47 * f47) + Math_fround(Math_fround(f46 * f46) + Math_fround(f45 * f45)));
   f13 = Math_fround(Math_fround(f54 * f54) + Math_fround(Math_fround(f55 * f55) + Math_fround(f13 * f13)));
   i43 = f12 > f13;
   f55 = i43 ? f12 : f13;
   f54 = i43 ? f13 : f12;
   f3 = Math_fround(Math_fround(f5 * f47) - Math_fround(f44 * f46));
   f9 = Math_fround(Math_fround(f44 * f45) - Math_fround(f29 * f47));
   f10 = Math_fround(Math_fround(f29 * f46) - Math_fround(f5 * f45));
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f3 * f3) + Math_fround(f9 * f9)))));
   if (f4 < Math_fround(100.0) ? Math_fround(Math_fround(Math_sqrt(Math_fround(f11 > f55 ? f11 : f55))) / Math_fround(Math_sqrt(Math_fround(f11 > f54 ? f54 : f11)))) < Math_fround(4.0) : 0) {
    f13 = f5;
    f12 = f44;
    f11 = f45;
    f10 = f46;
    f9 = f47;
    f5 = f48;
    f4 = f49;
    f3 = f50;
    break L29;
   }
   f55 = Math_fround(Math_fround(1.0) / f4);
   f5 = Math_fround(f3 * f55);
   f4 = Math_fround(f9 * f55);
   f3 = Math_fround(f10 * f55);
   if (!(!(f11 >= f12) | !(f11 >= f13))) {
    f11 = f42;
    f12 = f40;
    f13 = f39;
    f29 = f38;
    f9 = f37;
    f10 = f32;
    i1 = 19;
    break;
   }
   if (f12 >= f13) {
    f9 = f42;
    f10 = f40;
    f11 = f39;
    f12 = f38;
    f13 = f37;
    i1 = 21;
    break;
   }
   f12 = Math_fround(Math_fround(f25 + f28) * Math_fround(.5));
   f13 = Math_fround(Math_fround(f24 + f27) * Math_fround(.5));
   f29 = Math_fround(Math_fround(f23 + f26) * Math_fround(.5));
   f44 = Math_fround(Math_fround(f39 + f37) * Math_fround(.5));
   f45 = Math_fround(Math_fround(f40 + f33) * Math_fround(.5));
   f46 = Math_fround(Math_fround(f42 + f38) * Math_fround(.5));
   f47 = Math_fround(Math_fround(f36 + f30) * Math_fround(.5));
   f54 = Math_fround(Math_fround(f35 + f31) * Math_fround(.5));
   f55 = Math_fround(Math_fround(f34 + f32) * Math_fround(.5));
   f56 = Math_fround(f12 - f22);
   f11 = Math_fround(f13 - f19);
   f10 = Math_fround(f29 - f14);
   f9 = Math_fround(Math_fround(f11 * f3) - Math_fround(f10 * f4));
   f10 = Math_fround(Math_fround(f10 * f5) - Math_fround(f56 * f3));
   f11 = Math_fround(Math_fround(f56 * f4) - Math_fround(f11 * f5));
   f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10))))));
   f9 = Math_fround(f9 * f5);
   f10 = Math_fround(f10 * f5);
   f5 = Math_fround(f11 * f5);
   f11 = Math_fround(Math_fround(f29 * f5) + Math_fround(Math_fround(f12 * f9) + Math_fround(f13 * f10)));
   i43 = Math_fround(f11 * Math_fround(Math_fround(Math_fround(f23 * f5) + Math_fround(Math_fround(f25 * f9) + Math_fround(f24 * f10))) - f11)) < Math_fround(-0.0);
   f25 = i43 ? f25 : f12;
   f24 = i43 ? f24 : f13;
   f23 = i43 ? f23 : f29;
   f28 = i43 ? f12 : f28;
   f27 = i43 ? f13 : f27;
   f26 = i43 ? f29 : f26;
   f39 = i43 ? f39 : f44;
   f37 = i43 ? f44 : f37;
   f40 = i43 ? f40 : f45;
   f33 = i43 ? f45 : f33;
   f42 = i43 ? f42 : f46;
   f38 = i43 ? f46 : f38;
   f36 = i43 ? f36 : f47;
   f30 = i43 ? f47 : f30;
   f35 = i43 ? f35 : f54;
   f31 = i43 ? f54 : f31;
   f34 = i43 ? f34 : f55;
   f32 = i43 ? f55 : f32;
  }
  if ((i1 | 0) == 19) {
   f46 = Math_fround(Math_fround(f22 + f25) * Math_fround(.5));
   f45 = Math_fround(Math_fround(f19 + f24) * Math_fround(.5));
   f44 = Math_fround(Math_fround(f14 + f23) * Math_fround(.5));
   f47 = Math_fround(Math_fround(f6 + f13) * Math_fround(.5));
   f40 = Math_fround(Math_fround(f7 + f12) * Math_fround(.5));
   f42 = Math_fround(Math_fround(f8 + f11) * Math_fround(.5));
   f56 = Math_fround(Math_fround(f50 + f36) * Math_fround(.5));
   f55 = Math_fround(Math_fround(f49 + f35) * Math_fround(.5));
   f54 = Math_fround(Math_fround(f48 + f34) * Math_fround(.5));
   f32 = Math_fround(f46 - f28);
   f39 = Math_fround(f45 - f27);
   f38 = Math_fround(f44 - f26);
   f37 = Math_fround(Math_fround(f39 * f3) - Math_fround(f38 * f4));
   f38 = Math_fround(Math_fround(f38 * f5) - Math_fround(f32 * f3));
   f5 = Math_fround(Math_fround(f32 * f4) - Math_fround(f39 * f5));
   f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f37 * f37) + Math_fround(f38 * f38))))));
   f3 = Math_fround(f37 * f39);
   f4 = Math_fround(f38 * f39);
   f39 = Math_fround(f5 * f39);
   f5 = Math_fround(Math_fround(f44 * f39) + Math_fround(Math_fround(f46 * f3) + Math_fround(f45 * f4)));
   i43 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f14 * f39) + Math_fround(Math_fround(f22 * f3) + Math_fround(f19 * f4))) - f5)) < Math_fround(-0.0);
   f14 = i43 ? f14 : f44;
   f19 = i43 ? f19 : f45;
   f22 = i43 ? f22 : f46;
   f23 = i43 ? f44 : f23;
   f24 = i43 ? f45 : f24;
   f25 = i43 ? f46 : f25;
   f8 = i43 ? f8 : f42;
   f7 = i43 ? f7 : f40;
   f6 = i43 ? f6 : f47;
   f42 = i43 ? f42 : f11;
   f40 = i43 ? f40 : f12;
   f11 = i43 ? f47 : f13;
   f48 = i43 ? f48 : f54;
   f49 = i43 ? f49 : f55;
   f50 = i43 ? f50 : f56;
   f34 = i43 ? f54 : f34;
   f35 = i43 ? f55 : f35;
   f5 = i43 ? f56 : f36;
   f4 = f31;
   f3 = f30;
   continue;
  } else if ((i1 | 0) == 21) {
   f42 = Math_fround(Math_fround(f22 + f28) * Math_fround(.5));
   f40 = Math_fround(Math_fround(f19 + f27) * Math_fround(.5));
   f45 = Math_fround(Math_fround(f14 + f26) * Math_fround(.5));
   f47 = Math_fround(Math_fround(f6 + f13) * Math_fround(.5));
   f46 = Math_fround(Math_fround(f7 + f33) * Math_fround(.5));
   f29 = Math_fround(Math_fround(f8 + f12) * Math_fround(.5));
   f56 = Math_fround(Math_fround(f50 + f30) * Math_fround(.5));
   f55 = Math_fround(Math_fround(f49 + f31) * Math_fround(.5));
   f54 = Math_fround(Math_fround(f48 + f32) * Math_fround(.5));
   f37 = Math_fround(f42 - f25);
   f44 = Math_fround(f40 - f24);
   f39 = Math_fround(f45 - f23);
   f38 = Math_fround(Math_fround(f44 * f3) - Math_fround(f39 * f4));
   f39 = Math_fround(Math_fround(f39 * f5) - Math_fround(f37 * f3));
   f5 = Math_fround(Math_fround(f37 * f4) - Math_fround(f44 * f5));
   f44 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39))))));
   f3 = Math_fround(f38 * f44);
   f4 = Math_fround(f39 * f44);
   f44 = Math_fround(f5 * f44);
   f5 = Math_fround(Math_fround(f45 * f44) + Math_fround(Math_fround(f42 * f3) + Math_fround(f40 * f4)));
   i43 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f14 * f44) + Math_fround(Math_fround(f22 * f3) + Math_fround(f19 * f4))) - f5)) < Math_fround(-0.0);
   f14 = i43 ? f14 : f45;
   f19 = i43 ? f19 : f40;
   f22 = i43 ? f22 : f42;
   f26 = i43 ? f45 : f26;
   f27 = i43 ? f40 : f27;
   f28 = i43 ? f42 : f28;
   f8 = i43 ? f8 : f29;
   f7 = i43 ? f7 : f46;
   f6 = i43 ? f6 : f47;
   f42 = f9;
   f40 = f10;
   f29 = i43 ? f29 : f12;
   f33 = i43 ? f46 : f33;
   f9 = i43 ? f47 : f13;
   f48 = i43 ? f48 : f54;
   f49 = i43 ? f49 : f55;
   f50 = i43 ? f50 : f56;
   f5 = f36;
   f10 = i43 ? f54 : f32;
   f4 = i43 ? f55 : f31;
   f3 = i43 ? f56 : f30;
   continue;
  }
 }
 f50 = Math_fround(-f22);
 f54 = Math_fround(-f19);
 f44 = Math_fround(-f14);
 f56 = Math_fround(-f25);
 f48 = Math_fround(-f24);
 f45 = Math_fround(-f23);
 f49 = Math_fround(-f28);
 f47 = Math_fround(-f27);
 f46 = Math_fround(-f26);
 f55 = Math_fround(Math_fround(f12 * f44) + Math_fround(Math_fround(f13 * f54) + Math_fround(f29 * f50)));
 f50 = Math_fround(Math_fround(f9 * f44) + Math_fround(Math_fround(f10 * f54) + Math_fround(f11 * f50)));
 f54 = Math_fround(Math_fround(f12 * f45) + Math_fround(Math_fround(f13 * f48) + Math_fround(f29 * f56)));
 f56 = Math_fround(Math_fround(f9 * f45) + Math_fround(Math_fround(f10 * f48) + Math_fround(f11 * f56)));
 f48 = Math_fround(Math_fround(f12 * f46) + Math_fround(Math_fround(f13 * f47) + Math_fround(f29 * f49)));
 f49 = Math_fround(Math_fround(f9 * f46) + Math_fround(Math_fround(f10 * f47) + Math_fround(f11 * f49)));
 f47 = Math_fround(Math_fround(f48 * f50) - Math_fround(f55 * f49));
 f50 = Math_fround(Math_fround(f55 * f56) - Math_fround(f54 * f50));
 f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f54 * f49) - Math_fround(f48 * f56)) + Math_fround(f47 + f50)));
 f47 = Math_fround(f47 * f56);
 f56 = Math_fround(f50 * f56);
 f50 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f39 - f6) * f47) + Math_fround(Math_fround(f37 - f6) * f56)));
 f48 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f40 - f7) * f47) + Math_fround(Math_fround(f33 - f7) * f56)));
 f49 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f42 - f8) * f47) + Math_fround(Math_fround(f38 - f8) * f56)));
 f54 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f36 - f3) * f47) + Math_fround(Math_fround(f30 - f3) * f56)));
 f55 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f35 - f4) * f47) + Math_fround(Math_fround(f31 - f4) * f56)));
 f56 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f34 - f5) * f47) + Math_fround(Math_fround(f32 - f5) * f56)));
 HEAPF32[i52 >> 2] = f50;
 HEAPF32[i52 + 4 >> 2] = f48;
 HEAPF32[i52 + 8 >> 2] = f49;
 HEAPF32[i52 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i53 >> 2] = f54;
 HEAPF32[i53 + 4 >> 2] = f55;
 HEAPF32[i53 + 8 >> 2] = f56;
 HEAPF32[i53 + 12 >> 2] = Math_fround(0.0);
 f55 = Math_fround(f48 - f55);
 f56 = Math_fround(f49 - f56);
 HEAPF32[i51 >> 2] = Math_fround(f50 - f54);
 HEAPF32[i51 + 4 >> 2] = f55;
 HEAPF32[i51 + 8 >> 2] = f56;
 HEAPF32[i51 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i48, i50, i54, i1, i74, i75, i76, i77, i79, i81, i67) {
 i48 = i48 | 0;
 i50 = i50 | 0;
 i54 = i54 | 0;
 i1 = i1 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i76 = i76 | 0;
 i77 = i77 | 0;
 i79 = i79 | 0;
 i81 = i81 | 0;
 i67 = i67 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f49 = f0, f51 = f0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, f66 = f0, f68 = f0, f69 = f0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i78 = 0, i80 = 0, i82 = 0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0;
 i82 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i82 + 288 | 0;
 i61 = i82 + 468 | 0;
 i60 = i82 + 456 | 0;
 i72 = i82 + 304 | 0;
 i70 = i82 + 224 | 0;
 i71 = i82 + 160 | 0;
 i78 = i82 + 440 | 0;
 i80 = i82 + 424 | 0;
 i55 = i82 + 416 | 0;
 i73 = i82 + 144 | 0;
 i23 = i82 + 128 | 0;
 i22 = i82 + 112 | 0;
 i24 = i82 + 404 | 0;
 i25 = i82 + 96 | 0;
 i56 = i82 + 80 | 0;
 i63 = i82 + 64 | 0;
 i64 = i82 + 48 | 0;
 i62 = i82 + 392 | 0;
 i53 = i82 + 32 | 0;
 i52 = i82 + 380 | 0;
 i58 = i82 + 16 | 0;
 i59 = i82;
 i57 = i82 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f68 = Math_fround(HEAPF32[i48 + 16 >> 2]);
 f69 = Math_fround(HEAPF32[i50 + 16 >> 2]);
 f49 = Math_fround(HEAPF32[i1 >> 2]);
 f51 = Math_fround(HEAPF32[i48 + 32 >> 2]);
 f66 = Math_fround(HEAPF32[i50 + 32 >> 2]);
 f51 = Math_fround((f51 > f66 ? f66 : f51) * Math_fround(.100000001));
 f51 = Math_fround(f51 * f51);
 f66 = Math_fround(f68 + f69);
 HEAP32[i55 >> 2] = 0;
 i1 = HEAP8[i67 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i54 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i54 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i54 + 56 >> 2]);
  i47 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i47 ? f5 : Math_fround(1.0);
  f6 = i47 ? f6 : Math_fround(0.0);
  f7 = i47 ? f7 : Math_fround(0.0);
  HEAPF32[i73 >> 2] = f5;
  HEAPF32[i73 + 4 >> 2] = f6;
  HEAPF32[i73 + 8 >> 2] = f7;
  HEAPF32[i73 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i25 >> 2] = HEAP32[i73 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i73 + 12 >> 2];
  i47 = i73;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i65 = 7;
 } else {
  HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i9 = i48 + 96 | 0;
  f4 = Math_fround(HEAPF32[i54 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i54 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i54 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i54 >> 2]);
  f10 = Math_fround(HEAPF32[i54 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i54 + 32 >> 2]);
  f12 = Math_fround(HEAPF32[i54 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i54 + 20 >> 2]);
  f14 = Math_fround(HEAPF32[i54 + 36 >> 2]);
  f15 = Math_fround(HEAPF32[i54 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i54 + 24 >> 2]);
  f17 = Math_fround(HEAPF32[i54 + 40 >> 2]);
  i18 = i50 + 96 | 0;
  i19 = i23 + 4 | 0;
  i20 = i23 + 8 | 0;
  i21 = i23 + 12 | 0;
  i1 = i1 & 255;
  i8 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i3 = 0;
  while (1) {
   i46 = HEAPU8[i79 + i3 >> 0] | 0;
   HEAP32[i78 + (i3 << 2) >> 2] = i46;
   i47 = HEAPU8[i81 + i3 >> 0] | 0;
   HEAP32[i80 + (i3 << 2) >> 2] = i47;
   i46 = 1 - i46 | 0;
   f84 = Math_fround(HEAPF32[i9 + (i46 << 4) >> 2]);
   f85 = Math_fround(HEAPF32[i9 + (i46 << 4) + 4 >> 2]);
   f86 = Math_fround(HEAPF32[i9 + (i46 << 4) + 8 >> 2]);
   f88 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f84 * f7) + Math_fround(f85 * f10)) + Math_fround(f86 * f11)));
   f87 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f84 * f12) + Math_fround(f85 * f13)) + Math_fround(f86 * f14)));
   f86 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f84 * f15) + Math_fround(f85 * f16)) + Math_fround(f86 * f17)));
   i47 = 1 - i47 | 0;
   f85 = Math_fround(HEAPF32[i18 + (i47 << 4) >> 2]);
   f84 = Math_fround(HEAPF32[i18 + (i47 << 4) + 4 >> 2]);
   f83 = Math_fround(HEAPF32[i18 + (i47 << 4) + 8 >> 2]);
   i47 = HEAP32[i18 + (i47 << 4) + 12 >> 2] | 0;
   f90 = Math_fround(f87 - f84);
   f89 = Math_fround(f86 - f83);
   HEAPF32[i23 >> 2] = Math_fround(f88 - f85);
   HEAPF32[i19 >> 2] = f90;
   HEAPF32[i20 >> 2] = f89;
   HEAPF32[i21 >> 2] = Math_fround(0.0);
   HEAPF32[i70 + (i2 << 4) >> 2] = f88;
   HEAPF32[i70 + (i2 << 4) + 4 >> 2] = f87;
   HEAPF32[i70 + (i2 << 4) + 8 >> 2] = f86;
   HEAPF32[i70 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i71 + (i2 << 4) >> 2] = f85;
   HEAPF32[i71 + (i2 << 4) + 4 >> 2] = f84;
   HEAPF32[i71 + (i2 << 4) + 8 >> 2] = f83;
   HEAP32[i71 + (i2 << 4) + 12 >> 2] = i47;
   i47 = i72 + (i2 << 4) | 0;
   HEAP32[i47 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i47 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i47 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i47 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i55 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i22, i72, i70, i71, i78, i80, i23, i55);
  HEAP32[i73 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i73 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i73 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i73 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i73 >> 2]);
  f6 = Math_fround(HEAPF32[i73 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i73 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i61 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i60 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i25 >> 2] = HEAP32[i73 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i73 + 12 >> 2];
  if (f4 > f51) {
   i47 = i73;
   i65 = 7;
  } else i2 = HEAP32[i55 >> 2] | 0;
 }
 do if ((i65 | 0) == 7) {
  i45 = i73 + 4 | 0;
  i46 = i73 + 8 | 0;
  i18 = i54 + 4 | 0;
  i19 = i54 + 8 | 0;
  i20 = i54 + 16 | 0;
  i21 = i54 + 20 | 0;
  i22 = i54 + 24 | 0;
  i23 = i54 + 32 | 0;
  i24 = i54 + 36 | 0;
  i26 = i54 + 40 | 0;
  i27 = i48 + 96 | 0;
  i28 = i48 + 100 | 0;
  i29 = i48 + 104 | 0;
  i30 = i48 + 112 | 0;
  i31 = i48 + 116 | 0;
  i32 = i48 + 120 | 0;
  i33 = i54 + 48 | 0;
  i34 = i54 + 52 | 0;
  i35 = i54 + 56 | 0;
  i36 = i50 + 96 | 0;
  i37 = i50 + 100 | 0;
  i38 = i50 + 104 | 0;
  i39 = i50 + 112 | 0;
  i40 = i50 + 116 | 0;
  i41 = i50 + 120 | 0;
  i42 = i56 + 4 | 0;
  i43 = i56 + 8 | 0;
  i44 = i56 + 12 | 0;
  i9 = i48 + 48 | 0;
  i8 = i50 + 48 | 0;
  f11 = f49;
  while (1) {
   HEAP32[i60 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i60 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
   HEAP32[i60 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
   HEAP32[i25 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
   f49 = Math_fround(-f5);
   f12 = Math_fround(-f6);
   f10 = Math_fround(-f7);
   i3 = HEAP32[i55 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i54 >> 2]);
   f92 = Math_fround(f14 * f49);
   f90 = Math_fround(HEAPF32[i18 >> 2]);
   f92 = Math_fround(f92 + Math_fround(f90 * f12));
   f86 = Math_fround(HEAPF32[i19 >> 2]);
   f92 = Math_fround(f92 + Math_fround(f86 * f10));
   f15 = Math_fround(HEAPF32[i20 >> 2]);
   f91 = Math_fround(f15 * f49);
   f88 = Math_fround(HEAPF32[i21 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f88 * f12));
   f84 = Math_fround(HEAPF32[i22 >> 2]);
   f91 = Math_fround(f91 + Math_fround(f84 * f10));
   f87 = Math_fround(HEAPF32[i23 >> 2]);
   f49 = Math_fround(f87 * f49);
   f89 = Math_fround(HEAPF32[i24 >> 2]);
   f12 = Math_fround(f49 + Math_fround(f89 * f12));
   f49 = Math_fround(HEAPF32[i26 >> 2]);
   f10 = Math_fround(f12 + Math_fround(f49 * f10));
   f12 = Math_fround(HEAPF32[i27 >> 2]);
   f16 = Math_fround(HEAPF32[i28 >> 2]);
   f13 = Math_fround(HEAPF32[i29 >> 2]);
   f93 = Math_fround(Math_fround(Math_fround(f92 * f12) + Math_fround(f91 * f16)) + Math_fround(f10 * f13));
   f17 = Math_fround(HEAPF32[i30 >> 2]);
   f83 = Math_fround(HEAPF32[i31 >> 2]);
   f85 = Math_fround(HEAPF32[i32 >> 2]);
   i2 = f93 > Math_fround(Math_fround(Math_fround(f92 * f17) + Math_fround(f91 * f83)) + Math_fround(f10 * f85));
   HEAP32[i78 + (i3 << 2) >> 2] = i2 & 1;
   f17 = i2 ? f12 : f17;
   f83 = i2 ? f16 : f83;
   f85 = i2 ? f13 : f85;
   f13 = Math_fround(HEAPF32[i33 >> 2]);
   f16 = Math_fround(HEAPF32[i34 >> 2]);
   f87 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(f15 * f83)) + Math_fround(f87 * f85)));
   f89 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f90 * f17) + Math_fround(f88 * f83)) + Math_fround(f89 * f85)));
   f85 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) + Math_fround(Math_fround(Math_fround(f86 * f17) + Math_fround(f84 * f83)) + Math_fround(f49 * f85)));
   HEAPF32[i70 + (i3 << 4) >> 2] = f87;
   HEAPF32[i70 + (i3 << 4) + 4 >> 2] = f89;
   HEAPF32[i70 + (i3 << 4) + 8 >> 2] = f85;
   HEAPF32[i70 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f49 = Math_fround(HEAPF32[i36 >> 2]);
   f83 = Math_fround(HEAPF32[i37 >> 2]);
   f84 = Math_fround(HEAPF32[i38 >> 2]);
   f17 = Math_fround(Math_fround(Math_fround(f49 * f5) + Math_fround(f83 * f6)) + Math_fround(f84 * f7));
   f86 = Math_fround(HEAPF32[i39 >> 2]);
   f88 = Math_fround(HEAPF32[i40 >> 2]);
   f90 = Math_fround(HEAPF32[i41 >> 2]);
   i2 = f17 > Math_fround(Math_fround(Math_fround(f5 * f86) + Math_fround(f6 * f88)) + Math_fround(f7 * f90));
   HEAP32[i80 + (i3 << 2) >> 2] = i2 & 1;
   f86 = i2 ? f49 : f86;
   f88 = i2 ? f83 : f88;
   f90 = i2 ? f84 : f90;
   HEAPF32[i71 + (i3 << 4) >> 2] = f86;
   HEAPF32[i71 + (i3 << 4) + 4 >> 2] = f88;
   HEAPF32[i71 + (i3 << 4) + 8 >> 2] = f90;
   HEAPF32[i71 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f86 = Math_fround(f87 - f86);
   f88 = Math_fround(f89 - f88);
   f90 = Math_fround(f85 - f90);
   HEAPF32[i56 >> 2] = f86;
   HEAPF32[i42 >> 2] = f88;
   HEAPF32[i43 >> 2] = f90;
   HEAPF32[i44 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i55 >> 2] | 0;
   i2 = i72 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   f85 = Math_fround(HEAPF32[i9 >> 2]);
   f89 = Math_fround(HEAPF32[i8 >> 2]);
   f89 = f85 > f89 ? f85 : f89;
   f11 = f11 > f89 ? f11 : f89;
   f89 = Math_fround(f66 + f11);
   f89 = Math_fround(f4 * Math_fround(f89 * f89));
   f85 = Math_fround(HEAPF32[i73 >> 2]);
   f87 = Math_fround(HEAPF32[i45 >> 2]);
   f90 = Math_fround(Math_fround(Math_fround(f85 * f86) + Math_fround(f87 * f88)) + Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f90));
   i2 = f90 > Math_fround(0.0) & Math_fround(f90 * f90) > f89;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f90) | i2) {
    i65 = 9;
    break;
   }
   HEAP32[i55 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i53, i72, i70, i71, i78, i80, i56, i55);
   HEAP32[i47 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i47 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i47 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   HEAP32[i47 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i73 >> 2]);
   f6 = Math_fround(HEAPF32[i45 >> 2]);
   f7 = Math_fround(HEAPF32[i46 >> 2]);
   f10 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i61 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i61 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i61 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   i1 = f4 > f10;
   if (!(f10 > f51 & i1)) break; else f4 = f10;
  }
  if ((i65 | 0) == 9) {
   if (i79 | 0) {
    HEAP8[i67 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
      HEAP8[i81 + i1 >> 0] = HEAP32[i80 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i81 = 0;
    STACKTOP = i82;
    return i81 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i72, i70, i71, i73, i63, i64, i3);
   f90 = Math_fround(Math_sqrt(Math_fround(f4)));
   f91 = Math_fround(HEAPF32[i73 >> 2]);
   f92 = Math_fround(HEAPF32[i45 >> 2]);
   f93 = Math_fround(Math_fround(1.0) / f90);
   f91 = Math_fround(f91 * f93);
   f92 = Math_fround(f92 * f93);
   f93 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f93);
   f89 = Math_fround(HEAPF32[i63 >> 2]);
   f88 = Math_fround(HEAPF32[i63 + 4 >> 2]);
   f88 = Math_fround(f88 - Math_fround(f68 * f92));
   f87 = Math_fround(Math_fround(HEAPF32[i63 + 8 >> 2]) - Math_fround(f68 * f93));
   HEAPF32[i74 >> 2] = Math_fround(f89 - Math_fround(f68 * f91));
   HEAPF32[i74 + 4 >> 2] = f88;
   HEAPF32[i74 + 8 >> 2] = f87;
   HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
   f87 = Math_fround(HEAPF32[i64 >> 2]);
   f88 = Math_fround(HEAPF32[i64 + 4 >> 2]);
   f88 = Math_fround(Math_fround(f69 * f92) + f88);
   f89 = Math_fround(Math_fround(f69 * f93) + Math_fround(HEAPF32[i64 + 8 >> 2]));
   HEAPF32[i75 >> 2] = Math_fround(Math_fround(f69 * f91) + f87);
   HEAPF32[i75 + 4 >> 2] = f88;
   HEAPF32[i75 + 8 >> 2] = f89;
   HEAPF32[i75 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i77 >> 2] = Math_fround(f90 - f66);
   i81 = i77 + 4 | 0;
   HEAP32[i81 >> 2] = HEAP32[i62 >> 2];
   HEAP32[i81 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
   HEAP32[i81 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
   HEAPF32[i76 >> 2] = f91;
   HEAPF32[i76 + 4 >> 2] = f92;
   HEAPF32[i76 + 8 >> 2] = f93;
   HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
   i81 = 1;
   STACKTOP = i82;
   return i81 | 0;
  }
  i2 = HEAP32[i55 >> 2] | 0;
  if (i1) {
   if (!i79) i1 = 6; else break;
   STACKTOP = i82;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i79 | 0) {
   HEAP8[i67 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
     HEAP8[i81 + i1 >> 0] = HEAP32[i80 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i47 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i47 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i72, i70, i71, i73, i58, i59, i2);
  HEAP32[i61 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  f90 = Math_fround(Math_sqrt(Math_fround(f4)));
  f91 = Math_fround(HEAPF32[i73 >> 2]);
  f92 = Math_fround(HEAPF32[i73 + 4 >> 2]);
  f93 = Math_fround(Math_fround(1.0) / f90);
  f91 = Math_fround(f91 * f93);
  f92 = Math_fround(f92 * f93);
  f93 = Math_fround(Math_fround(HEAPF32[i73 + 8 >> 2]) * f93);
  f89 = Math_fround(HEAPF32[i58 >> 2]);
  f88 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f88 = Math_fround(f88 - Math_fround(f68 * f92));
  f87 = Math_fround(Math_fround(HEAPF32[i58 + 8 >> 2]) - Math_fround(f68 * f93));
  HEAPF32[i74 >> 2] = Math_fround(f89 - Math_fround(f68 * f91));
  HEAPF32[i74 + 4 >> 2] = f88;
  HEAPF32[i74 + 8 >> 2] = f87;
  HEAPF32[i74 + 12 >> 2] = Math_fround(0.0);
  f87 = Math_fround(HEAPF32[i59 >> 2]);
  f88 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f88 = Math_fround(Math_fround(f69 * f92) + f88);
  f89 = Math_fround(Math_fround(f69 * f93) + Math_fround(HEAPF32[i59 + 8 >> 2]));
  HEAPF32[i75 >> 2] = Math_fround(Math_fround(f69 * f91) + f87);
  HEAPF32[i75 + 4 >> 2] = f88;
  HEAPF32[i75 + 8 >> 2] = f89;
  HEAPF32[i75 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i77 >> 2] = Math_fround(f90 - f66);
  i81 = i77 + 4 | 0;
  HEAP32[i81 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i81 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i81 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAPF32[i76 >> 2] = f91;
  HEAPF32[i76 + 4 >> 2] = f92;
  HEAPF32[i76 + 8 >> 2] = f93;
  HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
  i81 = 3;
  STACKTOP = i82;
  return i81 | 0;
 } while (0);
 HEAP8[i67 >> 0] = i2;
 if (!i2) {
  i81 = 6;
  STACKTOP = i82;
  return i81 | 0;
 } else i1 = 0;
 do {
  HEAP8[i79 + i1 >> 0] = HEAP32[i78 + (i1 << 2) >> 2];
  HEAP8[i81 + i1 >> 0] = HEAP32[i80 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i82;
 return i1 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i51, i53, i57, i1, i77, i78, i79, i80, i82, i84, i70) {
 i51 = i51 | 0;
 i53 = i53 | 0;
 i57 = i57 | 0;
 i1 = i1 | 0;
 i77 = i77 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 i80 = i80 | 0;
 i82 = i82 | 0;
 i84 = i84 | 0;
 i70 = i70 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f52 = f0, f54 = f0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f71 = f0, f72 = f0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i81 = 0, i83 = 0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0;
 i85 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i85 + 288 | 0;
 i64 = i85 + 468 | 0;
 i63 = i85 + 456 | 0;
 i75 = i85 + 304 | 0;
 i73 = i85 + 224 | 0;
 i74 = i85 + 160 | 0;
 i81 = i85 + 440 | 0;
 i83 = i85 + 424 | 0;
 i58 = i85 + 416 | 0;
 i76 = i85 + 144 | 0;
 i28 = i85 + 128 | 0;
 i27 = i85 + 112 | 0;
 i29 = i85 + 404 | 0;
 i30 = i85 + 96 | 0;
 i59 = i85 + 80 | 0;
 i66 = i85 + 64 | 0;
 i67 = i85 + 48 | 0;
 i65 = i85 + 392 | 0;
 i56 = i85 + 32 | 0;
 i55 = i85 + 380 | 0;
 i61 = i85 + 16 | 0;
 i62 = i85;
 i60 = i85 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f71 = Math_fround(HEAPF32[i51 + 16 >> 2]);
 f72 = Math_fround(HEAPF32[i53 + 16 >> 2]);
 f52 = Math_fround(HEAPF32[i1 >> 2]);
 f54 = Math_fround(HEAPF32[i51 + 32 >> 2]);
 f69 = Math_fround(HEAPF32[i53 + 32 >> 2]);
 f54 = Math_fround((f54 > f69 ? f69 : f54) * Math_fround(.100000001));
 f54 = Math_fround(f54 * f54);
 f69 = Math_fround(f71 + f72);
 HEAP32[i58 >> 2] = 0;
 i1 = HEAP8[i70 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f5 = Math_fround(HEAPF32[i57 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i57 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i57 + 56 >> 2]);
  i50 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i50 ? f5 : Math_fround(1.0);
  f6 = i50 ? f6 : Math_fround(0.0);
  f7 = i50 ? f7 : Math_fround(0.0);
  HEAPF32[i76 >> 2] = f5;
  HEAPF32[i76 + 4 >> 2] = f6;
  HEAPF32[i76 + 8 >> 2] = f7;
  HEAPF32[i76 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i30 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  i50 = i76;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i68 = 7;
 } else {
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i9 = i51 + 96 | 0;
  f4 = Math_fround(HEAPF32[i57 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i57 + 52 >> 2]);
  f6 = Math_fround(HEAPF32[i57 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i57 >> 2]);
  f10 = Math_fround(HEAPF32[i57 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i57 + 32 >> 2]);
  f12 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i57 + 20 >> 2]);
  f14 = Math_fround(HEAPF32[i57 + 36 >> 2]);
  f15 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i57 + 24 >> 2]);
  f17 = Math_fround(HEAPF32[i57 + 40 >> 2]);
  f18 = Math_fround(HEAPF32[i53 + 144 >> 2]);
  f19 = Math_fround(HEAPF32[i53 + 148 >> 2]);
  f20 = Math_fround(HEAPF32[i53 + 152 >> 2]);
  f21 = Math_fround(-f18);
  f22 = Math_fround(-f19);
  f23 = Math_fround(-f20);
  i24 = i28 + 4 | 0;
  i25 = i28 + 8 | 0;
  i26 = i28 + 12 | 0;
  i2 = i1 & 255;
  i8 = i2 >>> 0 > 1 ? i2 : 1;
  i1 = 0;
  i3 = 0;
  while (1) {
   i49 = HEAPU8[i82 + i3 >> 0] | 0;
   HEAP32[i81 + (i3 << 2) >> 2] = i49;
   i50 = HEAPU8[i84 + i3 >> 0] | 0;
   HEAP32[i83 + (i3 << 2) >> 2] = i50;
   i49 = 1 - i49 | 0;
   f87 = Math_fround(HEAPF32[i9 + (i49 << 4) >> 2]);
   f88 = Math_fround(HEAPF32[i9 + (i49 << 4) + 4 >> 2]);
   f89 = Math_fround(HEAPF32[i9 + (i49 << 4) + 8 >> 2]);
   f91 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f87 * f7) + Math_fround(f88 * f10)) + Math_fround(f89 * f11)));
   f90 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f87 * f12) + Math_fround(f88 * f13)) + Math_fround(f89 * f14)));
   f89 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f87 * f15) + Math_fround(f88 * f16)) + Math_fround(f89 * f17)));
   f88 = HEAP32[gb + 48 + (i50 << 4) >> 2] | 0 ? f18 : f21;
   f87 = HEAP32[gb + 48 + (i50 << 4) + 4 >> 2] | 0 ? f19 : f22;
   f86 = HEAP32[gb + 48 + (i50 << 4) + 8 >> 2] | 0 ? f20 : f23;
   f93 = Math_fround(f90 - f87);
   f92 = Math_fround(f89 - f86);
   HEAPF32[i28 >> 2] = Math_fround(f91 - f88);
   HEAPF32[i24 >> 2] = f93;
   HEAPF32[i25 >> 2] = f92;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i73 + (i1 << 4) >> 2] = f91;
   HEAPF32[i73 + (i1 << 4) + 4 >> 2] = f90;
   HEAPF32[i73 + (i1 << 4) + 8 >> 2] = f89;
   HEAPF32[i73 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i74 + (i1 << 4) >> 2] = f88;
   HEAPF32[i74 + (i1 << 4) + 4 >> 2] = f87;
   HEAPF32[i74 + (i1 << 4) + 8 >> 2] = f86;
   HEAPF32[i74 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i50 = i75 + (i1 << 4) | 0;
   HEAP32[i50 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i58 >> 2] = i8;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i27, i75, i73, i74, i81, i83, i28, i58);
  HEAP32[i76 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i76 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i76 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i76 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i76 >> 2]);
  f6 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i76 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i64 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i63 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i30 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  if (f4 > f54) {
   i50 = i76;
   i68 = 7;
  } else i2 = HEAP32[i58 >> 2] | 0;
 }
 do if ((i68 | 0) == 7) {
  i48 = i76 + 4 | 0;
  i49 = i76 + 8 | 0;
  i24 = i57 + 4 | 0;
  i25 = i57 + 8 | 0;
  i26 = i57 + 16 | 0;
  i27 = i57 + 20 | 0;
  i28 = i57 + 24 | 0;
  i29 = i57 + 32 | 0;
  i31 = i57 + 36 | 0;
  i32 = i57 + 40 | 0;
  i33 = i51 + 96 | 0;
  i34 = i51 + 100 | 0;
  i35 = i51 + 104 | 0;
  i36 = i51 + 112 | 0;
  i37 = i51 + 116 | 0;
  i38 = i51 + 120 | 0;
  i39 = i57 + 48 | 0;
  i40 = i57 + 52 | 0;
  i41 = i57 + 56 | 0;
  i42 = i53 + 144 | 0;
  i43 = i53 + 148 | 0;
  i44 = i53 + 152 | 0;
  i45 = i59 + 4 | 0;
  i46 = i59 + 8 | 0;
  i47 = i59 + 12 | 0;
  i9 = i51 + 48 | 0;
  i8 = i53 + 48 | 0;
  f11 = f52;
  while (1) {
   HEAP32[i63 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i30 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
   f52 = Math_fround(-f5);
   f18 = Math_fround(-f6);
   f17 = Math_fround(-f7);
   i3 = HEAP32[i58 >> 2] | 0;
   f20 = Math_fround(HEAPF32[i57 >> 2]);
   f15 = Math_fround(f20 * f52);
   f23 = Math_fround(HEAPF32[i24 >> 2]);
   f15 = Math_fround(f15 + Math_fround(f23 * f18));
   f91 = Math_fround(HEAPF32[i25 >> 2]);
   f15 = Math_fround(f15 + Math_fround(f91 * f17));
   f21 = Math_fround(HEAPF32[i26 >> 2]);
   f16 = Math_fround(f21 * f52);
   f93 = Math_fround(HEAPF32[i27 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f93 * f18));
   f87 = Math_fround(HEAPF32[i28 >> 2]);
   f16 = Math_fround(f16 + Math_fround(f87 * f17));
   f90 = Math_fround(HEAPF32[i29 >> 2]);
   f52 = Math_fround(f90 * f52);
   f92 = Math_fround(HEAPF32[i31 >> 2]);
   f18 = Math_fround(f52 + Math_fround(f92 * f18));
   f52 = Math_fround(HEAPF32[i32 >> 2]);
   f17 = Math_fround(f18 + Math_fround(f52 * f17));
   f18 = Math_fround(HEAPF32[i33 >> 2]);
   f22 = Math_fround(HEAPF32[i34 >> 2]);
   f19 = Math_fround(HEAPF32[i35 >> 2]);
   f14 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(f16 * f22)) + Math_fround(f17 * f19));
   f89 = Math_fround(HEAPF32[i36 >> 2]);
   f86 = Math_fround(HEAPF32[i37 >> 2]);
   f88 = Math_fround(HEAPF32[i38 >> 2]);
   i51 = f14 > Math_fround(Math_fround(Math_fround(f15 * f89) + Math_fround(f16 * f86)) + Math_fround(f17 * f88));
   HEAP32[i81 + (i3 << 2) >> 2] = i51 & 1;
   f89 = i51 ? f18 : f89;
   f86 = i51 ? f22 : f86;
   f88 = i51 ? f19 : f88;
   f19 = Math_fround(HEAPF32[i39 >> 2]);
   f22 = Math_fround(HEAPF32[i40 >> 2]);
   f90 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f20 * f89) + Math_fround(f21 * f86)) + Math_fround(f90 * f88)));
   f92 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f23 * f89) + Math_fround(f93 * f86)) + Math_fround(f92 * f88)));
   f88 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + Math_fround(Math_fround(Math_fround(f91 * f89) + Math_fround(f87 * f86)) + Math_fround(f52 * f88)));
   HEAPF32[i73 + (i3 << 4) >> 2] = f90;
   HEAPF32[i73 + (i3 << 4) + 4 >> 2] = f92;
   HEAPF32[i73 + (i3 << 4) + 8 >> 2] = f88;
   HEAPF32[i73 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i51 = f5 > Math_fround(0.0);
   i53 = f6 > Math_fround(0.0);
   i2 = f7 > Math_fround(0.0);
   HEAP32[i83 + (i3 << 2) >> 2] = i53 << 31 >> 31 << 1 & 2 | i51 & 1 | i2 << 31 >> 31 << 2 & 4;
   f52 = Math_fround(HEAPF32[i42 >> 2]);
   f86 = Math_fround(HEAPF32[i43 >> 2]);
   f87 = Math_fround(HEAPF32[i44 >> 2]);
   f89 = Math_fround(-f52);
   f91 = Math_fround(-f86);
   f93 = Math_fround(-f87);
   f89 = i51 ? f52 : f89;
   f91 = i53 ? f86 : f91;
   f93 = i2 ? f87 : f93;
   HEAPF32[i74 + (i3 << 4) >> 2] = f89;
   HEAPF32[i74 + (i3 << 4) + 4 >> 2] = f91;
   HEAPF32[i74 + (i3 << 4) + 8 >> 2] = f93;
   HEAPF32[i74 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   f89 = Math_fround(f90 - f89);
   f91 = Math_fround(f92 - f91);
   f93 = Math_fround(f88 - f93);
   HEAPF32[i59 >> 2] = f89;
   HEAPF32[i45 >> 2] = f91;
   HEAPF32[i46 >> 2] = f93;
   HEAPF32[i47 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i58 >> 2] | 0;
   i2 = i75 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i59 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
   f88 = Math_fround(HEAPF32[i9 >> 2]);
   f92 = Math_fround(HEAPF32[i8 >> 2]);
   f92 = f88 > f92 ? f88 : f92;
   f11 = f11 > f92 ? f11 : f92;
   f92 = Math_fround(f69 + f11);
   f92 = Math_fround(f4 * Math_fround(f92 * f92));
   f88 = Math_fround(HEAPF32[i76 >> 2]);
   f90 = Math_fround(HEAPF32[i48 >> 2]);
   f93 = Math_fround(Math_fround(Math_fround(f88 * f89) + Math_fround(f90 * f91)) + Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f93));
   i2 = f93 > Math_fround(0.0) & Math_fround(f93 * f93) > f92;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f93) | i2) {
    i68 = 9;
    break;
   }
   HEAP32[i58 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i56, i75, i73, i74, i81, i83, i59, i58);
   HEAP32[i50 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i76 >> 2]);
   f6 = Math_fround(HEAPF32[i48 >> 2]);
   f7 = Math_fround(HEAPF32[i49 >> 2]);
   f10 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i64 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i64 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i64 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   i1 = f4 > f10;
   if (!(f10 > f54 & i1)) break; else f4 = f10;
  }
  if ((i68 | 0) == 9) {
   if (i82 | 0) {
    HEAP8[i70 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
      HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i84 = 0;
    STACKTOP = i85;
    return i84 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i66, i67, i3);
   f90 = Math_fround(Math_sqrt(Math_fround(f4)));
   f91 = Math_fround(HEAPF32[i76 >> 2]);
   f92 = Math_fround(HEAPF32[i48 >> 2]);
   f93 = Math_fround(Math_fround(1.0) / f90);
   f91 = Math_fround(f91 * f93);
   f92 = Math_fround(f92 * f93);
   f93 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f93);
   f89 = Math_fround(HEAPF32[i66 >> 2]);
   f88 = Math_fround(HEAPF32[i66 + 4 >> 2]);
   f88 = Math_fround(f88 - Math_fround(f71 * f92));
   f87 = Math_fround(Math_fround(HEAPF32[i66 + 8 >> 2]) - Math_fround(f71 * f93));
   HEAPF32[i77 >> 2] = Math_fround(f89 - Math_fround(f71 * f91));
   HEAPF32[i77 + 4 >> 2] = f88;
   HEAPF32[i77 + 8 >> 2] = f87;
   HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
   f87 = Math_fround(HEAPF32[i67 >> 2]);
   f88 = Math_fround(HEAPF32[i67 + 4 >> 2]);
   f88 = Math_fround(Math_fround(f72 * f92) + f88);
   f89 = Math_fround(Math_fround(f72 * f93) + Math_fround(HEAPF32[i67 + 8 >> 2]));
   HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f91) + f87);
   HEAPF32[i78 + 4 >> 2] = f88;
   HEAPF32[i78 + 8 >> 2] = f89;
   HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i80 >> 2] = Math_fround(f90 - f69);
   i84 = i80 + 4 | 0;
   HEAP32[i84 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i84 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
   HEAP32[i84 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
   HEAPF32[i79 >> 2] = f91;
   HEAPF32[i79 + 4 >> 2] = f92;
   HEAPF32[i79 + 8 >> 2] = f93;
   HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
   i84 = 1;
   STACKTOP = i85;
   return i84 | 0;
  }
  i2 = HEAP32[i58 >> 2] | 0;
  if (i1) {
   if (!i82) i1 = 6; else break;
   STACKTOP = i85;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i82 | 0) {
   HEAP8[i70 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
     HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i50 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i50 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i75, i73, i74, i76, i61, i62, i2);
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  f90 = Math_fround(Math_sqrt(Math_fround(f4)));
  f91 = Math_fround(HEAPF32[i76 >> 2]);
  f92 = Math_fround(HEAPF32[i76 + 4 >> 2]);
  f93 = Math_fround(Math_fround(1.0) / f90);
  f91 = Math_fround(f91 * f93);
  f92 = Math_fround(f92 * f93);
  f93 = Math_fround(Math_fround(HEAPF32[i76 + 8 >> 2]) * f93);
  f89 = Math_fround(HEAPF32[i61 >> 2]);
  f88 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f88 = Math_fround(f88 - Math_fround(f71 * f92));
  f87 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) - Math_fround(f71 * f93));
  HEAPF32[i77 >> 2] = Math_fround(f89 - Math_fround(f71 * f91));
  HEAPF32[i77 + 4 >> 2] = f88;
  HEAPF32[i77 + 8 >> 2] = f87;
  HEAPF32[i77 + 12 >> 2] = Math_fround(0.0);
  f87 = Math_fround(HEAPF32[i62 >> 2]);
  f88 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f88 = Math_fround(Math_fround(f72 * f92) + f88);
  f89 = Math_fround(Math_fround(f72 * f93) + Math_fround(HEAPF32[i62 + 8 >> 2]));
  HEAPF32[i78 >> 2] = Math_fround(Math_fround(f72 * f91) + f87);
  HEAPF32[i78 + 4 >> 2] = f88;
  HEAPF32[i78 + 8 >> 2] = f89;
  HEAPF32[i78 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i80 >> 2] = Math_fround(f90 - f69);
  i84 = i80 + 4 | 0;
  HEAP32[i84 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i84 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
  HEAP32[i84 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
  HEAPF32[i79 >> 2] = f91;
  HEAPF32[i79 + 4 >> 2] = f92;
  HEAPF32[i79 + 8 >> 2] = f93;
  HEAPF32[i79 + 12 >> 2] = Math_fround(0.0);
  i84 = 3;
  STACKTOP = i85;
  return i84 | 0;
 } while (0);
 HEAP8[i70 >> 0] = i2;
 if (!i2) {
  i84 = 6;
  STACKTOP = i85;
  return i84 | 0;
 } else i1 = 0;
 do {
  HEAP8[i82 + i1 >> 0] = HEAP32[i81 + (i1 << 2) >> 2];
  HEAP8[i84 + i1 >> 0] = HEAP32[i83 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i85;
 return i1 | 0;
}

function __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i1, i2, i6, i3, i4, i5, i8, i34, i35, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i7 = i7 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i36 + 512 | 0;
 i32 = i36 + 256 | 0;
 i33 = i36;
 i17 = HEAP16[i3 + (HEAP32[i4 >> 2] << 4) + 8 + (HEAP32[i5 >> 2] << 1) >> 1] | 0;
 HEAP16[i9 >> 1] = i17;
 i38 = i9 + 2 | 0;
 i18 = HEAP16[i3 + (HEAP32[i4 + 4 >> 2] << 4) + 8 + (HEAP32[i5 + 4 >> 2] << 1) >> 1] | 0;
 HEAP16[i38 >> 1] = i18;
 i37 = i9 + 4 | 0;
 i19 = HEAP16[i3 + (HEAP32[i4 + 8 >> 2] << 4) + 8 + (HEAP32[i5 + 8 >> 2] << 1) >> 1] | 0;
 HEAP16[i37 >> 1] = i19;
 i41 = i9 + 6 | 0;
 i21 = HEAP16[i3 + (HEAP32[i4 + 12 >> 2] << 4) + 8 + (HEAP32[i5 + 12 >> 2] << 1) >> 1] | 0;
 HEAP16[i41 >> 1] = i21;
 i17 = i17 & 65535;
 i22 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i28 = i22 + (Math_imul(i10, i17) | 0) | 0;
 i18 = i18 & 65535;
 i29 = i22 + (Math_imul(i18, i10) | 0) | 0;
 i19 = i19 & 65535;
 i30 = i22 + (Math_imul(i19, i10) | 0) | 0;
 i1 = i21 & 65535;
 i10 = i22 + (Math_imul(i10, i1) | 0) | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 i21 = HEAP32[i2 + 4 >> 2] | 0;
 i17 = i22 + (Math_imul(i21, i17) | 0) | 0;
 i18 = i22 + (Math_imul(i21, i18) | 0) | 0;
 i19 = i22 + (Math_imul(i21, i19) | 0) | 0;
 i1 = i22 + (Math_imul(i21, i1) | 0) | 0;
 i21 = HEAP32[i29 >> 2] | 0;
 i22 = HEAP32[i30 >> 2] | 0;
 i23 = HEAP32[i10 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i28 >> 2];
 i20 = i34 + 4 | 0;
 HEAP32[i20 >> 2] = i21;
 i21 = i34 + 8 | 0;
 HEAP32[i21 >> 2] = i22;
 i22 = i34 + 12 | 0;
 HEAP32[i22 >> 2] = i23;
 i23 = i34 + 16 | 0;
 i25 = HEAP32[i29 + 4 >> 2] | 0;
 i26 = HEAP32[i30 + 4 >> 2] | 0;
 i27 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i23 >> 2] = HEAP32[i28 + 4 >> 2];
 i24 = i34 + 20 | 0;
 HEAP32[i24 >> 2] = i25;
 i25 = i34 + 24 | 0;
 HEAP32[i25 >> 2] = i26;
 i26 = i34 + 28 | 0;
 HEAP32[i26 >> 2] = i27;
 i27 = i34 + 32 | 0;
 i29 = HEAP32[i29 + 8 >> 2] | 0;
 i30 = HEAP32[i30 + 8 >> 2] | 0;
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 + 8 >> 2];
 i28 = i34 + 36 | 0;
 HEAP32[i28 >> 2] = i29;
 i29 = i34 + 40 | 0;
 HEAP32[i29 >> 2] = i30;
 i30 = i34 + 44 | 0;
 HEAP32[i30 >> 2] = i10;
 i10 = HEAP32[i18 >> 2] | 0;
 i11 = HEAP32[i19 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i35 >> 2] = HEAP32[i17 >> 2];
 i31 = i35 + 4 | 0;
 HEAP32[i31 >> 2] = i10;
 i10 = i35 + 8 | 0;
 HEAP32[i10 >> 2] = i11;
 i11 = i35 + 12 | 0;
 HEAP32[i11 >> 2] = i12;
 i12 = i35 + 16 | 0;
 i14 = HEAP32[i18 + 4 >> 2] | 0;
 i15 = HEAP32[i19 + 4 >> 2] | 0;
 i16 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i17 + 4 >> 2];
 i13 = i35 + 20 | 0;
 HEAP32[i13 >> 2] = i14;
 i14 = i35 + 24 | 0;
 HEAP32[i14 >> 2] = i15;
 i15 = i35 + 28 | 0;
 HEAP32[i15 >> 2] = i16;
 i16 = i35 + 32 | 0;
 i18 = HEAP32[i18 + 8 >> 2] | 0;
 i19 = HEAP32[i19 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 + 8 >> 2];
 i17 = i35 + 36 | 0;
 HEAP32[i17 >> 2] = i18;
 i18 = i35 + 40 | 0;
 HEAP32[i18 >> 2] = i19;
 i19 = i35 + 44 | 0;
 HEAP32[i19 >> 2] = i1;
 i1 = HEAP16[i9 >> 1] | 0;
 i5 = i1 & 65535;
 i40 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i39 = HEAP32[i40 + (Math_imul(i6, i5) | 0) >> 2] | 0;
 i2 = HEAPU16[i38 >> 1] | 0;
 i38 = HEAP32[i40 + (Math_imul(i2, i6) | 0) >> 2] | 0;
 i3 = HEAPU16[i37 >> 1] | 0;
 i37 = HEAP32[i40 + (Math_imul(i3, i6) | 0) >> 2] | 0;
 i4 = HEAPU16[i41 >> 1] | 0;
 i6 = HEAP32[i40 + (Math_imul(i4, i6) | 0) >> 2] | 0;
 HEAP32[i7 >> 2] = i39;
 HEAP32[i7 + 4 >> 2] = i38;
 HEAP32[i7 + 8 >> 2] = i37;
 HEAP32[i7 + 12 >> 2] = i6;
 if (!i8) {
  STACKTOP = i36;
  return;
 }
 if (HEAP32[i8 + 76 >> 2] | 0) {
  HEAP32[i32 >> 2] = i5;
  HEAP32[i32 + 4 >> 2] = i2;
  HEAP32[i32 + 8 >> 2] = i3;
  HEAP32[i32 + 12 >> 2] = i4;
  __Z26ApplyBlendShapesToVerticesR12SkinMeshInfoRKN4math5_int4EPNS1_8floatNx3ES6_(i8, i32, i34, i35);
 }
 if (!(HEAP32[i8 + 28 >> 2] | 0)) {
  STACKTOP = i36;
  return;
 }
 L10 : do switch (HEAP32[i8 + 20 >> 2] | 0) {
 case 1:
  {
   i4 = HEAP32[i8 + 68 >> 2] | 0;
   i3 = HEAP32[i8 + 24 >> 2] | 0;
   i2 = 0;
   while (1) {
    i41 = i32 + (i2 << 6) | 0;
    i38 = HEAP32[i3 + ((i1 & 65535) << 2) >> 2] | 0;
    i1 = HEAP32[i4 + (i38 << 6) + 4 >> 2] | 0;
    i40 = HEAP32[i4 + (i38 << 6) + 8 >> 2] | 0;
    i39 = HEAP32[i4 + (i38 << 6) + 12 >> 2] | 0;
    HEAP32[i41 >> 2] = HEAP32[i4 + (i38 << 6) >> 2];
    HEAP32[i32 + (i2 << 6) + 4 >> 2] = i1;
    HEAP32[i32 + (i2 << 6) + 8 >> 2] = i40;
    HEAP32[i32 + (i2 << 6) + 12 >> 2] = i39;
    i39 = HEAP32[i4 + (i38 << 6) + 20 >> 2] | 0;
    i40 = HEAP32[i4 + (i38 << 6) + 24 >> 2] | 0;
    i1 = HEAP32[i4 + (i38 << 6) + 28 >> 2] | 0;
    HEAP32[i41 + 16 >> 2] = HEAP32[i4 + (i38 << 6) + 16 >> 2];
    HEAP32[i41 + 20 >> 2] = i39;
    HEAP32[i41 + 24 >> 2] = i40;
    HEAP32[i41 + 28 >> 2] = i1;
    i1 = HEAP32[i4 + (i38 << 6) + 36 >> 2] | 0;
    i40 = HEAP32[i4 + (i38 << 6) + 40 >> 2] | 0;
    i39 = HEAP32[i4 + (i38 << 6) + 44 >> 2] | 0;
    HEAP32[i41 + 32 >> 2] = HEAP32[i4 + (i38 << 6) + 32 >> 2];
    HEAP32[i41 + 36 >> 2] = i1;
    HEAP32[i41 + 40 >> 2] = i40;
    HEAP32[i41 + 44 >> 2] = i39;
    i39 = HEAP32[i4 + (i38 << 6) + 52 >> 2] | 0;
    i40 = HEAP32[i4 + (i38 << 6) + 56 >> 2] | 0;
    i1 = HEAP32[i4 + (i38 << 6) + 60 >> 2] | 0;
    HEAP32[i41 + 48 >> 2] = HEAP32[i4 + (i38 << 6) + 48 >> 2];
    HEAP32[i41 + 52 >> 2] = i39;
    HEAP32[i41 + 56 >> 2] = i40;
    HEAP32[i41 + 60 >> 2] = i1;
    i1 = i2 + 1 | 0;
    if ((i1 | 0) == 4) break L10;
    i2 = i1;
    i1 = HEAP16[i9 + (i1 << 1) >> 1] | 0;
   }
  }
 case 2:
  {
   i40 = i8 + 68 | 0;
   i41 = i8 + 24 | 0;
   __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i5);
   __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 64 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i2);
   __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 128 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i3);
   __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 192 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i4);
   break;
  }
 default:
  {
   i40 = i8 + 68 | 0;
   i41 = i8 + 24 | 0;
   __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i5);
   __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 64 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i2);
   __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 128 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i3);
   __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i32 + 192 | 0, HEAP32[i40 >> 2] | 0, HEAP32[i41 >> 2] | 0, i4);
  }
 } while (0);
 i2 = i32 + 64 | 0;
 i3 = i32 + 128 | 0;
 i4 = i32 + 192 | 0;
 i5 = i33 + 64 | 0;
 i6 = i33 + 128 | 0;
 i1 = 0;
 do {
  i39 = HEAP32[i2 + (i1 << 4) >> 2] | 0;
  i40 = HEAP32[i3 + (i1 << 4) >> 2] | 0;
  i41 = HEAP32[i4 + (i1 << 4) >> 2] | 0;
  HEAP32[i33 + (i1 << 4) >> 2] = HEAP32[i32 + (i1 << 4) >> 2];
  HEAP32[i33 + (i1 << 4) + 4 >> 2] = i39;
  HEAP32[i33 + (i1 << 4) + 8 >> 2] = i40;
  HEAP32[i33 + (i1 << 4) + 12 >> 2] = i41;
  i41 = HEAP32[i2 + (i1 << 4) + 4 >> 2] | 0;
  i40 = HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0;
  i39 = HEAP32[i4 + (i1 << 4) + 4 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i32 + (i1 << 4) + 4 >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i41;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i40;
  HEAP32[i5 + (i1 << 4) + 12 >> 2] = i39;
  i39 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
  i40 = HEAP32[i3 + (i1 << 4) + 8 >> 2] | 0;
  i41 = HEAP32[i4 + (i1 << 4) + 8 >> 2] | 0;
  HEAP32[i6 + (i1 << 4) >> 2] = HEAP32[i32 + (i1 << 4) + 8 >> 2];
  HEAP32[i6 + (i1 << 4) + 4 >> 2] = i39;
  HEAP32[i6 + (i1 << 4) + 8 >> 2] = i40;
  HEAP32[i6 + (i1 << 4) + 12 >> 2] = i41;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 f42 = Math_fround(HEAPF32[i34 >> 2]);
 f43 = Math_fround(HEAPF32[i20 >> 2]);
 f44 = Math_fround(HEAPF32[i21 >> 2]);
 f45 = Math_fround(HEAPF32[i22 >> 2]);
 f47 = Math_fround(HEAPF32[i34 + 16 >> 2]);
 f48 = Math_fround(HEAPF32[i24 >> 2]);
 f49 = Math_fround(HEAPF32[i25 >> 2]);
 f46 = Math_fround(HEAPF32[i26 >> 2]);
 f50 = Math_fround(HEAPF32[i34 + 32 >> 2]);
 f51 = Math_fround(HEAPF32[i28 >> 2]);
 f52 = Math_fround(HEAPF32[i29 >> 2]);
 f53 = Math_fround(HEAPF32[i30 >> 2]);
 f54 = Math_fround(f42 * Math_fround(HEAPF32[i33 >> 2]));
 i72 = i33 + 4 | 0;
 f55 = Math_fround(f43 * Math_fround(HEAPF32[i72 >> 2]));
 i71 = i33 + 8 | 0;
 f56 = Math_fround(f44 * Math_fround(HEAPF32[i71 >> 2]));
 i70 = i33 + 12 | 0;
 f57 = Math_fround(f45 * Math_fround(HEAPF32[i70 >> 2]));
 i69 = i33 + 16 | 0;
 f58 = Math_fround(f47 * Math_fround(HEAPF32[i69 >> 2]));
 i68 = i33 + 20 | 0;
 f59 = Math_fround(f48 * Math_fround(HEAPF32[i68 >> 2]));
 i67 = i33 + 24 | 0;
 f60 = Math_fround(f49 * Math_fround(HEAPF32[i67 >> 2]));
 i66 = i33 + 28 | 0;
 f58 = Math_fround(f54 + f58);
 f59 = Math_fround(f55 + f59);
 f60 = Math_fround(f56 + f60);
 f57 = Math_fround(f57 + Math_fround(f46 * Math_fround(HEAPF32[i66 >> 2])));
 i65 = i33 + 32 | 0;
 f56 = Math_fround(f50 * Math_fround(HEAPF32[i65 >> 2]));
 i64 = i33 + 36 | 0;
 f55 = Math_fround(f51 * Math_fround(HEAPF32[i64 >> 2]));
 i63 = i33 + 40 | 0;
 f54 = Math_fround(f52 * Math_fround(HEAPF32[i63 >> 2]));
 i62 = i33 + 44 | 0;
 f56 = Math_fround(f58 + f56);
 f55 = Math_fround(f59 + f55);
 f54 = Math_fround(f60 + f54);
 f57 = Math_fround(f57 + Math_fround(f53 * Math_fround(HEAPF32[i62 >> 2])));
 f56 = Math_fround(f56 + Math_fround(HEAPF32[i33 + 48 >> 2]));
 f55 = Math_fround(f55 + Math_fround(HEAPF32[i33 + 52 >> 2]));
 f54 = Math_fround(f54 + Math_fround(HEAPF32[i33 + 56 >> 2]));
 f57 = Math_fround(f57 + Math_fround(HEAPF32[i33 + 60 >> 2]));
 HEAPF32[i34 >> 2] = f56;
 HEAPF32[i20 >> 2] = f55;
 HEAPF32[i21 >> 2] = f54;
 HEAPF32[i22 >> 2] = f57;
 f57 = Math_fround(f42 * Math_fround(HEAPF32[i5 >> 2]));
 i61 = i33 + 68 | 0;
 f54 = Math_fround(f43 * Math_fround(HEAPF32[i61 >> 2]));
 i1 = i33 + 72 | 0;
 f55 = Math_fround(f44 * Math_fround(HEAPF32[i1 >> 2]));
 i2 = i33 + 76 | 0;
 f56 = Math_fround(f45 * Math_fround(HEAPF32[i2 >> 2]));
 i3 = i5 + 16 | 0;
 f60 = Math_fround(f47 * Math_fround(HEAPF32[i3 >> 2]));
 i4 = i5 + 20 | 0;
 f59 = Math_fround(f48 * Math_fround(HEAPF32[i4 >> 2]));
 i7 = i5 + 24 | 0;
 f58 = Math_fround(f49 * Math_fround(HEAPF32[i7 >> 2]));
 i8 = i5 + 28 | 0;
 f60 = Math_fround(f57 + f60);
 f59 = Math_fround(f54 + f59);
 f58 = Math_fround(f55 + f58);
 f56 = Math_fround(f56 + Math_fround(f46 * Math_fround(HEAPF32[i8 >> 2])));
 i9 = i5 + 32 | 0;
 f55 = Math_fround(f50 * Math_fround(HEAPF32[i9 >> 2]));
 i20 = i5 + 36 | 0;
 f54 = Math_fround(f51 * Math_fround(HEAPF32[i20 >> 2]));
 i21 = i5 + 40 | 0;
 f57 = Math_fround(f52 * Math_fround(HEAPF32[i21 >> 2]));
 i22 = i5 + 44 | 0;
 f55 = Math_fround(f60 + f55);
 f54 = Math_fround(f59 + f54);
 f57 = Math_fround(f58 + f57);
 f56 = Math_fround(f56 + Math_fround(f53 * Math_fround(HEAPF32[i22 >> 2])));
 f55 = Math_fround(f55 + Math_fround(HEAPF32[i5 + 48 >> 2]));
 f54 = Math_fround(f54 + Math_fround(HEAPF32[i5 + 52 >> 2]));
 f57 = Math_fround(f57 + Math_fround(HEAPF32[i5 + 56 >> 2]));
 f56 = Math_fround(f56 + Math_fround(HEAPF32[i5 + 60 >> 2]));
 HEAPF32[i23 >> 2] = f55;
 HEAPF32[i24 >> 2] = f54;
 HEAPF32[i25 >> 2] = f57;
 HEAPF32[i26 >> 2] = f56;
 f42 = Math_fround(f42 * Math_fround(HEAPF32[i6 >> 2]));
 i23 = i33 + 132 | 0;
 f43 = Math_fround(f43 * Math_fround(HEAPF32[i23 >> 2]));
 i24 = i33 + 136 | 0;
 f44 = Math_fround(f44 * Math_fround(HEAPF32[i24 >> 2]));
 i25 = i33 + 140 | 0;
 f45 = Math_fround(f45 * Math_fround(HEAPF32[i25 >> 2]));
 i26 = i6 + 16 | 0;
 f47 = Math_fround(f47 * Math_fround(HEAPF32[i26 >> 2]));
 i32 = i6 + 20 | 0;
 f48 = Math_fround(f48 * Math_fround(HEAPF32[i32 >> 2]));
 i34 = i6 + 24 | 0;
 f49 = Math_fround(f49 * Math_fround(HEAPF32[i34 >> 2]));
 i37 = i6 + 28 | 0;
 f47 = Math_fround(f42 + f47);
 f48 = Math_fround(f43 + f48);
 f49 = Math_fround(f44 + f49);
 f46 = Math_fround(f45 + Math_fround(f46 * Math_fround(HEAPF32[i37 >> 2])));
 i38 = i6 + 32 | 0;
 f50 = Math_fround(f50 * Math_fround(HEAPF32[i38 >> 2]));
 i39 = i6 + 36 | 0;
 f51 = Math_fround(f51 * Math_fround(HEAPF32[i39 >> 2]));
 i40 = i6 + 40 | 0;
 f52 = Math_fround(f52 * Math_fround(HEAPF32[i40 >> 2]));
 i41 = i6 + 44 | 0;
 f50 = Math_fround(f47 + f50);
 f51 = Math_fround(f48 + f51);
 f52 = Math_fround(f49 + f52);
 f53 = Math_fround(f46 + Math_fround(f53 * Math_fround(HEAPF32[i41 >> 2])));
 f50 = Math_fround(f50 + Math_fround(HEAPF32[i6 + 48 >> 2]));
 f51 = Math_fround(f51 + Math_fround(HEAPF32[i6 + 52 >> 2]));
 f52 = Math_fround(f52 + Math_fround(HEAPF32[i6 + 56 >> 2]));
 f53 = Math_fround(f53 + Math_fround(HEAPF32[i6 + 60 >> 2]));
 HEAPF32[i27 >> 2] = f50;
 HEAPF32[i28 >> 2] = f51;
 HEAPF32[i29 >> 2] = f52;
 HEAPF32[i30 >> 2] = f53;
 f53 = Math_fround(HEAPF32[i35 >> 2]);
 f52 = Math_fround(HEAPF32[i31 >> 2]);
 f51 = Math_fround(HEAPF32[i10 >> 2]);
 f50 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i35 + 16 >> 2]);
 f49 = Math_fround(HEAPF32[i13 >> 2]);
 f48 = Math_fround(HEAPF32[i14 >> 2]);
 f47 = Math_fround(HEAPF32[i15 >> 2]);
 f45 = Math_fround(HEAPF32[i35 + 32 >> 2]);
 f44 = Math_fround(HEAPF32[i17 >> 2]);
 f43 = Math_fround(HEAPF32[i18 >> 2]);
 f42 = Math_fround(HEAPF32[i19 >> 2]);
 f56 = Math_fround(f53 * Math_fround(HEAPF32[i33 >> 2]));
 f57 = Math_fround(f52 * Math_fround(HEAPF32[i72 >> 2]));
 f54 = Math_fround(f51 * Math_fround(HEAPF32[i71 >> 2]));
 f55 = Math_fround(f50 * Math_fround(HEAPF32[i70 >> 2]));
 f58 = Math_fround(f46 * Math_fround(HEAPF32[i69 >> 2]));
 f59 = Math_fround(f49 * Math_fround(HEAPF32[i68 >> 2]));
 f60 = Math_fround(f48 * Math_fround(HEAPF32[i67 >> 2]));
 f58 = Math_fround(f56 + f58);
 f59 = Math_fround(f57 + f59);
 f60 = Math_fround(f54 + f60);
 f55 = Math_fround(f55 + Math_fround(f47 * Math_fround(HEAPF32[i66 >> 2])));
 f54 = Math_fround(f45 * Math_fround(HEAPF32[i65 >> 2]));
 f57 = Math_fround(f44 * Math_fround(HEAPF32[i64 >> 2]));
 f56 = Math_fround(f43 * Math_fround(HEAPF32[i63 >> 2]));
 f57 = Math_fround(f59 + f57);
 f56 = Math_fround(f60 + f56);
 f55 = Math_fround(f55 + Math_fround(f42 * Math_fround(HEAPF32[i62 >> 2])));
 HEAPF32[i35 >> 2] = Math_fround(f58 + f54);
 HEAPF32[i31 >> 2] = f57;
 HEAPF32[i10 >> 2] = f56;
 HEAPF32[i11 >> 2] = f55;
 f55 = Math_fround(f53 * Math_fround(HEAPF32[i5 >> 2]));
 f56 = Math_fround(f52 * Math_fround(HEAPF32[i61 >> 2]));
 f57 = Math_fround(f51 * Math_fround(HEAPF32[i1 >> 2]));
 f54 = Math_fround(f50 * Math_fround(HEAPF32[i2 >> 2]));
 f58 = Math_fround(f46 * Math_fround(HEAPF32[i3 >> 2]));
 f60 = Math_fround(f49 * Math_fround(HEAPF32[i4 >> 2]));
 f59 = Math_fround(f48 * Math_fround(HEAPF32[i7 >> 2]));
 f58 = Math_fround(f55 + f58);
 f60 = Math_fround(f56 + f60);
 f59 = Math_fround(f57 + f59);
 f54 = Math_fround(f54 + Math_fround(f47 * Math_fround(HEAPF32[i8 >> 2])));
 f57 = Math_fround(f45 * Math_fround(HEAPF32[i9 >> 2]));
 f56 = Math_fround(f44 * Math_fround(HEAPF32[i20 >> 2]));
 f55 = Math_fround(f43 * Math_fround(HEAPF32[i21 >> 2]));
 f56 = Math_fround(f60 + f56);
 f55 = Math_fround(f59 + f55);
 f54 = Math_fround(f54 + Math_fround(f42 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f58 + f57);
 HEAPF32[i13 >> 2] = f56;
 HEAPF32[i14 >> 2] = f55;
 HEAPF32[i15 >> 2] = f54;
 f53 = Math_fround(f53 * Math_fround(HEAPF32[i6 >> 2]));
 f52 = Math_fround(f52 * Math_fround(HEAPF32[i23 >> 2]));
 f51 = Math_fround(f51 * Math_fround(HEAPF32[i24 >> 2]));
 f50 = Math_fround(f50 * Math_fround(HEAPF32[i25 >> 2]));
 f46 = Math_fround(f46 * Math_fround(HEAPF32[i26 >> 2]));
 f49 = Math_fround(f49 * Math_fround(HEAPF32[i32 >> 2]));
 f48 = Math_fround(f48 * Math_fround(HEAPF32[i34 >> 2]));
 f46 = Math_fround(f53 + f46);
 f49 = Math_fround(f52 + f49);
 f48 = Math_fround(f51 + f48);
 f47 = Math_fround(f50 + Math_fround(f47 * Math_fround(HEAPF32[i37 >> 2])));
 f45 = Math_fround(f45 * Math_fround(HEAPF32[i38 >> 2]));
 f44 = Math_fround(f44 * Math_fround(HEAPF32[i39 >> 2]));
 f43 = Math_fround(f43 * Math_fround(HEAPF32[i40 >> 2]));
 f44 = Math_fround(f49 + f44);
 f43 = Math_fround(f48 + f43);
 f42 = Math_fround(f47 + Math_fround(f42 * Math_fround(HEAPF32[i41 >> 2])));
 HEAPF32[i16 >> 2] = Math_fround(f46 + f45);
 HEAPF32[i17 >> 2] = f44;
 HEAPF32[i18 >> 2] = f43;
 HEAPF32[i19 >> 2] = f42;
 STACKTOP = i36;
 return;
}

function __ZN13TrailRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f(i91, i92, i4, i93) {
 i91 = i91 | 0;
 i92 = i92 | 0;
 i4 = i4 | 0;
 i93 = i93 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0;
 i103 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i97 = i103 + 672 | 0;
 i98 = i103 + 608 | 0;
 i102 = i103 + 596 | 0;
 i3 = i103 + 68 | 0;
 i99 = i103 + 64 | 0;
 i94 = i103;
 i95 = i103 + 592 | 0;
 if ((HEAP16[gb + 1159816 + 6 >> 1] | 0) > -1) {
  HEAP32[i98 >> 2] = 0;
  HEAP32[i97 >> 2] = HEAP32[i98 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159816 | 0, i97);
  i100 = gb + 1159816 | 0;
 } else i100 = 0;
 HEAP32[i102 >> 2] = 0;
 i101 = i102 + 4 | 0;
 i89 = gb + 63160 | 0;
 i90 = HEAP32[i89 + 4 >> 2] | 0;
 i1 = i101;
 HEAP32[i1 >> 2] = HEAP32[i89 >> 2];
 HEAP32[i1 + 4 >> 2] = i90;
 i1 = i92 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 421073 | 0, 312) | 0;
   i89 = gb + 64016 | 0;
   i88 = HEAP32[i89 >> 2] | 0;
   i89 = HEAP32[i89 + 4 >> 2] | 0;
   HEAP32[i102 >> 2] = i1;
   i90 = i101;
   HEAP32[i90 >> 2] = i88;
   HEAP32[i90 + 4 >> 2] = i89;
   break;
  }
 } while (0);
 i90 = i1 + 3 & -4;
 __ZN14BatchAllocatorC2Ev(i3);
 HEAP32[i99 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, i99, -1, 24, 1, 4);
 HEAP32[i99 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, 0, 0, 20, i92, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, (HEAP32[i99 >> 2] | 0) + 4 | 0, 0, 156, i92, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i3, gb + 64024 | 0);
 __Z25InvertMatrix4x4_General3DPKfPf(i93, i94) | 0;
 i88 = __ZNK6Camera20GetWorldToClipMatrixEv(i4) | 0;
 i41 = HEAP32[i4 + 880 >> 2] | 0;
 i89 = __Z12GetGfxDevicev() | 0;
 i42 = __ZN9GfxDevice13GetDynamicVBOEv(i89) | 0;
 i87 = HEAP32[i99 >> 2] | 0;
 __ZN17UniqueIDGenerator8CreateIDEv(i97, i89 + 4448 | 0);
 HEAP32[i87 + 8 >> 2] = HEAP32[i97 >> 2];
 if (!i92) i96 = 53; else {
  i43 = i93 + 4 | 0;
  i44 = i93 + 8 | 0;
  i45 = i93 + 12 | 0;
  i46 = i93 + 16 | 0;
  i47 = i93 + 20 | 0;
  i48 = i93 + 24 | 0;
  i49 = i93 + 28 | 0;
  i50 = i93 + 32 | 0;
  i51 = i93 + 36 | 0;
  i52 = i93 + 40 | 0;
  i53 = i93 + 44 | 0;
  i54 = i93 + 48 | 0;
  i55 = i93 + 52 | 0;
  i56 = i93 + 56 | 0;
  i57 = i93 + 60 | 0;
  i58 = i88 + 4 | 0;
  i59 = i88 + 8 | 0;
  i60 = i88 + 12 | 0;
  i61 = i88 + 16 | 0;
  i62 = i88 + 20 | 0;
  i63 = i88 + 24 | 0;
  i64 = i88 + 28 | 0;
  i65 = i88 + 32 | 0;
  i66 = i88 + 36 | 0;
  i67 = i88 + 40 | 0;
  i68 = i88 + 44 | 0;
  i69 = i88 + 48 | 0;
  i70 = i88 + 52 | 0;
  i71 = i88 + 56 | 0;
  i72 = i88 + 60 | 0;
  i73 = i94 + 4 | 0;
  i74 = i94 + 8 | 0;
  i75 = i94 + 12 | 0;
  i76 = i94 + 16 | 0;
  i77 = i94 + 20 | 0;
  i78 = i94 + 24 | 0;
  i79 = i94 + 28 | 0;
  i80 = i94 + 32 | 0;
  i81 = i94 + 36 | 0;
  i82 = i94 + 40 | 0;
  i83 = i94 + 44 | 0;
  i84 = i94 + 48 | 0;
  i85 = i94 + 52 | 0;
  i86 = i94 + 56 | 0;
  i87 = i94 + 60 | 0;
  i11 = i97 + 32 | 0;
  i12 = i97 + 36 | 0;
  i13 = i97 + 40 | 0;
  i14 = i97 + 48 | 0;
  i15 = i97 + 52 | 0;
  i16 = i97 + 56 | 0;
  i17 = i97 + 4 | 0;
  i18 = i97 + 8 | 0;
  i19 = i97 + 12 | 0;
  i20 = i97 + 16 | 0;
  i21 = i97 + 20 | 0;
  i22 = i97 + 24 | 0;
  i23 = i97 + 28 | 0;
  i24 = i97 + 44 | 0;
  i25 = i97 + 60 | 0;
  i26 = i98 + 4 | 0;
  i27 = i98 + 8 | 0;
  i28 = i98 + 12 | 0;
  i29 = i98 + 16 | 0;
  i30 = i98 + 20 | 0;
  i31 = i98 + 24 | 0;
  i32 = i98 + 28 | 0;
  i33 = i98 + 32 | 0;
  i34 = i98 + 36 | 0;
  i35 = i98 + 40 | 0;
  i36 = i98 + 44 | 0;
  i37 = i98 + 48 | 0;
  i38 = i98 + 52 | 0;
  i39 = i98 + 56 | 0;
  i40 = i98 + 60 | 0;
  i3 = 0;
  i1 = 0;
  i10 = 0;
  do {
   i7 = HEAP32[i91 + (i10 << 2) >> 2] | 0;
   i7 = (i7 | 0) == 0 ? 0 : i7 + -32 | 0;
   i8 = i7 + 400 | 0;
   do if (__ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle(i42, i8) | 0) if ((HEAP32[i7 + 548 >> 2] | 0) == (i41 | 0)) if ((HEAP32[i7 + 420 >> 2] | 0) == (HEAP32[i93 >> 2] | 0)) if ((HEAP32[i7 + 424 >> 2] | 0) == (HEAP32[i43 >> 2] | 0)) if ((HEAP32[i7 + 428 >> 2] | 0) == (HEAP32[i44 >> 2] | 0)) if ((HEAP32[i7 + 432 >> 2] | 0) == (HEAP32[i45 >> 2] | 0)) if ((HEAP32[i7 + 436 >> 2] | 0) == (HEAP32[i46 >> 2] | 0)) if ((HEAP32[i7 + 440 >> 2] | 0) == (HEAP32[i47 >> 2] | 0)) if ((HEAP32[i7 + 444 >> 2] | 0) == (HEAP32[i48 >> 2] | 0)) if ((HEAP32[i7 + 448 >> 2] | 0) == (HEAP32[i49 >> 2] | 0)) if ((HEAP32[i7 + 452 >> 2] | 0) == (HEAP32[i50 >> 2] | 0)) if ((HEAP32[i7 + 456 >> 2] | 0) == (HEAP32[i51 >> 2] | 0)) if ((HEAP32[i7 + 460 >> 2] | 0) == (HEAP32[i52 >> 2] | 0)) if ((HEAP32[i7 + 464 >> 2] | 0) == (HEAP32[i53 >> 2] | 0)) {
    if ((HEAP32[i7 + 468 >> 2] | 0) != (HEAP32[i54 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 472 >> 2] | 0) != (HEAP32[i55 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 476 >> 2] | 0) != (HEAP32[i56 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 480 >> 2] | 0) != (HEAP32[i57 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 484 >> 2] | 0) != (HEAP32[i88 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 488 >> 2] | 0) != (HEAP32[i58 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 492 >> 2] | 0) != (HEAP32[i59 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 496 >> 2] | 0) != (HEAP32[i60 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 500 >> 2] | 0) != (HEAP32[i61 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 504 >> 2] | 0) != (HEAP32[i62 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 508 >> 2] | 0) != (HEAP32[i63 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 512 >> 2] | 0) != (HEAP32[i64 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 516 >> 2] | 0) != (HEAP32[i65 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 520 >> 2] | 0) != (HEAP32[i66 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 524 >> 2] | 0) != (HEAP32[i67 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 528 >> 2] | 0) != (HEAP32[i68 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 532 >> 2] | 0) != (HEAP32[i69 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 536 >> 2] | 0) != (HEAP32[i70 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 540 >> 2] | 0) != (HEAP32[i71 >> 2] | 0)) {
     i96 = 44;
     break;
    }
    if ((HEAP32[i7 + 544 >> 2] | 0) != (HEAP32[i72 >> 2] | 0)) i96 = 44;
   } else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; else i96 = 44; while (0);
   if ((i96 | 0) == 44) {
    i96 = 0;
    i2 = HEAP32[i7 + 356 >> 2] | 0;
    if (i2) {
     i105 = i2 + 1 | 0;
     i9 = HEAP32[(HEAP32[i99 >> 2] | 0) + 4 >> 2] | 0;
     i104 = HEAP32[i7 + 344 >> 2] | 0;
     i5 = i104 + 4 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     i5 = i7 + 384 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i6 = i4 + 4 | 0;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i6 = HEAP32[i4 + 180 >> 2] | 0;
     i2 = Math_imul((i6 | 0) < 0 ? 0 : i6, i2 + -1 | 0) | 0;
     i6 = HEAP32[i4 + 184 >> 2] | 0;
     i6 = (i2 + i105 << 1) + ((i6 | 0) > 0 ? (i6 << 2) + 8 | 0 : 0) | 0;
     HEAP32[i9 + (i3 * 156 | 0) + 132 >> 2] = i105;
     HEAP32[i9 + (i3 * 156 | 0) + 136 >> 2] = HEAP32[i7 + 352 >> 2];
     HEAP32[i9 + (i3 * 156 | 0) + 140 >> 2] = i104;
     HEAP32[i9 + (i3 * 156 | 0) >> 2] = i4;
     i2 = HEAP32[i7 + 88 >> 2] | 0;
     i4 = HEAP32[i7 + 92 >> 2] | 0;
     HEAP32[i9 + (i3 * 156 | 0) + 144 >> 2] = HEAP32[i7 + 84 >> 2];
     HEAP32[i9 + (i3 * 156 | 0) + 148 >> 2] = i2;
     HEAP32[i9 + (i3 * 156 | 0) + 152 >> 2] = i4;
     if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + 188 >> 2] | 0)) {
      i105 = HEAP32[i43 >> 2] | 0;
      i104 = HEAP32[i44 >> 2] | 0;
      i5 = HEAP32[i45 >> 2] | 0;
      i4 = HEAP32[i46 >> 2] | 0;
      i2 = HEAP32[i47 >> 2] | 0;
      i106 = HEAP32[i48 >> 2] | 0;
      i107 = HEAP32[i49 >> 2] | 0;
      i108 = HEAP32[i50 >> 2] | 0;
      i109 = HEAP32[i51 >> 2] | 0;
      i110 = HEAP32[i52 >> 2] | 0;
      i111 = HEAP32[i53 >> 2] | 0;
      i112 = HEAP32[i54 >> 2] | 0;
      i113 = HEAP32[i55 >> 2] | 0;
      i114 = HEAP32[i56 >> 2] | 0;
      i115 = HEAP32[i57 >> 2] | 0;
      HEAP32[i9 + (i3 * 156 | 0) + 4 >> 2] = HEAP32[i93 >> 2];
      HEAP32[i9 + (i3 * 156 | 0) + 8 >> 2] = i105;
      HEAP32[i9 + (i3 * 156 | 0) + 12 >> 2] = i104;
      HEAP32[i9 + (i3 * 156 | 0) + 16 >> 2] = i5;
      HEAP32[i9 + (i3 * 156 | 0) + 20 >> 2] = i4;
      HEAP32[i9 + (i3 * 156 | 0) + 24 >> 2] = i2;
      HEAP32[i9 + (i3 * 156 | 0) + 28 >> 2] = i106;
      HEAP32[i9 + (i3 * 156 | 0) + 32 >> 2] = i107;
      HEAP32[i9 + (i3 * 156 | 0) + 36 >> 2] = i108;
      HEAP32[i9 + (i3 * 156 | 0) + 40 >> 2] = i109;
      HEAP32[i9 + (i3 * 156 | 0) + 44 >> 2] = i110;
      HEAP32[i9 + (i3 * 156 | 0) + 48 >> 2] = i111;
      HEAP32[i9 + (i3 * 156 | 0) + 52 >> 2] = i112;
      HEAP32[i9 + (i3 * 156 | 0) + 56 >> 2] = i113;
      HEAP32[i9 + (i3 * 156 | 0) + 60 >> 2] = i114;
      HEAP32[i9 + (i3 * 156 | 0) + 64 >> 2] = i115;
      i115 = HEAP32[i73 >> 2] | 0;
      i114 = HEAP32[i74 >> 2] | 0;
      i113 = HEAP32[i75 >> 2] | 0;
      i112 = HEAP32[i76 >> 2] | 0;
      i111 = HEAP32[i77 >> 2] | 0;
      i110 = HEAP32[i78 >> 2] | 0;
      i109 = HEAP32[i79 >> 2] | 0;
      i108 = HEAP32[i80 >> 2] | 0;
      i107 = HEAP32[i81 >> 2] | 0;
      i106 = HEAP32[i82 >> 2] | 0;
      i2 = HEAP32[i83 >> 2] | 0;
      i4 = HEAP32[i84 >> 2] | 0;
      i5 = HEAP32[i85 >> 2] | 0;
      i104 = HEAP32[i86 >> 2] | 0;
      i105 = HEAP32[i87 >> 2] | 0;
      HEAP32[i9 + (i3 * 156 | 0) + 68 >> 2] = HEAP32[i94 >> 2];
      HEAP32[i9 + (i3 * 156 | 0) + 72 >> 2] = i115;
      HEAP32[i9 + (i3 * 156 | 0) + 76 >> 2] = i114;
      HEAP32[i9 + (i3 * 156 | 0) + 80 >> 2] = i113;
      HEAP32[i9 + (i3 * 156 | 0) + 84 >> 2] = i112;
      HEAP32[i9 + (i3 * 156 | 0) + 88 >> 2] = i111;
      HEAP32[i9 + (i3 * 156 | 0) + 92 >> 2] = i110;
      HEAP32[i9 + (i3 * 156 | 0) + 96 >> 2] = i109;
      HEAP32[i9 + (i3 * 156 | 0) + 100 >> 2] = i108;
      HEAP32[i9 + (i3 * 156 | 0) + 104 >> 2] = i107;
      HEAP32[i9 + (i3 * 156 | 0) + 108 >> 2] = i106;
      HEAP32[i9 + (i3 * 156 | 0) + 112 >> 2] = i2;
      HEAP32[i9 + (i3 * 156 | 0) + 116 >> 2] = i4;
      HEAP32[i9 + (i3 * 156 | 0) + 120 >> 2] = i5;
      HEAP32[i9 + (i3 * 156 | 0) + 124 >> 2] = i104;
      HEAP32[i9 + (i3 * 156 | 0) + 128 >> 2] = i105;
     } else {
      i2 = i97;
      i4 = i7 + 36 | 0;
      i5 = i2 + 64 | 0;
      do {
       HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
       i2 = i2 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i2 | 0) < (i5 | 0));
      i104 = HEAP32[i11 >> 2] | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      i4 = HEAP32[i13 >> 2] | 0;
      HEAP32[i14 >> 2] = i104;
      HEAP32[i15 >> 2] = i5;
      HEAP32[i16 >> 2] = i4;
      i112 = HEAP32[i17 >> 2] | 0;
      i111 = HEAP32[i18 >> 2] | 0;
      i110 = HEAP32[i19 >> 2] | 0;
      i109 = HEAP32[i20 >> 2] | 0;
      i108 = HEAP32[i21 >> 2] | 0;
      i107 = HEAP32[i22 >> 2] | 0;
      i106 = HEAP32[i23 >> 2] | 0;
      i105 = HEAP32[i24 >> 2] | 0;
      i2 = HEAP32[i25 >> 2] | 0;
      HEAP32[i9 + (i3 * 156 | 0) + 68 >> 2] = HEAP32[i97 >> 2];
      HEAP32[i9 + (i3 * 156 | 0) + 72 >> 2] = i112;
      HEAP32[i9 + (i3 * 156 | 0) + 76 >> 2] = i111;
      HEAP32[i9 + (i3 * 156 | 0) + 80 >> 2] = i110;
      HEAP32[i9 + (i3 * 156 | 0) + 84 >> 2] = i109;
      HEAP32[i9 + (i3 * 156 | 0) + 88 >> 2] = i108;
      HEAP32[i9 + (i3 * 156 | 0) + 92 >> 2] = i107;
      HEAP32[i9 + (i3 * 156 | 0) + 96 >> 2] = i106;
      HEAP32[i9 + (i3 * 156 | 0) + 100 >> 2] = i104;
      HEAP32[i9 + (i3 * 156 | 0) + 104 >> 2] = i5;
      HEAP32[i9 + (i3 * 156 | 0) + 108 >> 2] = i4;
      HEAP32[i9 + (i3 * 156 | 0) + 112 >> 2] = i105;
      HEAP32[i9 + (i3 * 156 | 0) + 116 >> 2] = i104;
      HEAP32[i9 + (i3 * 156 | 0) + 120 >> 2] = i5;
      HEAP32[i9 + (i3 * 156 | 0) + 124 >> 2] = i4;
      HEAP32[i9 + (i3 * 156 | 0) + 128 >> 2] = i2;
      __Z25InvertMatrix4x4_General3DPKfPf(i97, i98) | 0;
      i2 = HEAP32[i26 >> 2] | 0;
      i4 = HEAP32[i27 >> 2] | 0;
      i5 = HEAP32[i28 >> 2] | 0;
      i104 = HEAP32[i29 >> 2] | 0;
      i105 = HEAP32[i30 >> 2] | 0;
      i106 = HEAP32[i31 >> 2] | 0;
      i107 = HEAP32[i32 >> 2] | 0;
      i108 = HEAP32[i33 >> 2] | 0;
      i109 = HEAP32[i34 >> 2] | 0;
      i110 = HEAP32[i35 >> 2] | 0;
      i111 = HEAP32[i36 >> 2] | 0;
      i112 = HEAP32[i37 >> 2] | 0;
      i113 = HEAP32[i38 >> 2] | 0;
      i114 = HEAP32[i39 >> 2] | 0;
      i115 = HEAP32[i40 >> 2] | 0;
      HEAP32[i9 + (i3 * 156 | 0) + 4 >> 2] = HEAP32[i98 >> 2];
      HEAP32[i9 + (i3 * 156 | 0) + 8 >> 2] = i2;
      HEAP32[i9 + (i3 * 156 | 0) + 12 >> 2] = i4;
      HEAP32[i9 + (i3 * 156 | 0) + 16 >> 2] = i5;
      HEAP32[i9 + (i3 * 156 | 0) + 20 >> 2] = i104;
      HEAP32[i9 + (i3 * 156 | 0) + 24 >> 2] = i105;
      HEAP32[i9 + (i3 * 156 | 0) + 28 >> 2] = i106;
      HEAP32[i9 + (i3 * 156 | 0) + 32 >> 2] = i107;
      HEAP32[i9 + (i3 * 156 | 0) + 36 >> 2] = i108;
      HEAP32[i9 + (i3 * 156 | 0) + 40 >> 2] = i109;
      HEAP32[i9 + (i3 * 156 | 0) + 44 >> 2] = i110;
      HEAP32[i9 + (i3 * 156 | 0) + 48 >> 2] = i111;
      HEAP32[i9 + (i3 * 156 | 0) + 52 >> 2] = i112;
      HEAP32[i9 + (i3 * 156 | 0) + 56 >> 2] = i113;
      HEAP32[i9 + (i3 * 156 | 0) + 60 >> 2] = i114;
      HEAP32[i9 + (i3 * 156 | 0) + 64 >> 2] = i115;
     }
     i2 = HEAP32[HEAP32[i99 >> 2] >> 2] | 0;
     HEAP32[i2 + (i3 * 20 | 0) + 8 >> 2] = i6;
     HEAP32[i2 + (i3 * 20 | 0) + 12 >> 2] = 0;
     HEAP32[i2 + (i3 * 20 | 0) + 16 >> 2] = 24;
     HEAP32[i7 + 416 >> 2] = i1;
     i2 = i7 + 420 | 0;
     i4 = i93;
     i5 = i2 + 64 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      i2 = i2 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i2 | 0) < (i5 | 0));
     i2 = i7 + 484 | 0;
     i4 = i88;
     i5 = i2 + 64 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      i2 = i2 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i2 | 0) < (i5 | 0));
     HEAP32[i7 + 548 >> 2] = i41;
     HEAP32[i90 + (i3 << 2) >> 2] = i8;
     i3 = i3 + 1 | 0;
     i1 = (i6 * 24 | 0) + i1 | 0;
    }
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i92 | 0));
  if (!i3) i96 = 53; else {
   HEAP32[i98 >> 2] = 0;
   HEAP32[i98 + 4 >> 2] = 0;
   HEAP32[i98 + 8 >> 2] = -1;
   HEAP32[i98 + 12 >> 2] = 0;
   i115 = HEAP32[i99 >> 2] | 0;
   i2 = HEAP32[i115 + 8 >> 2] | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i89 >> 2] | 0) + 252 >> 2] | 0, i89 | 0, fb + 2413 | 0, fb + 3380 | 0, i115 | 0, i3 | 0, 1, i98 | 0);
   HEAP32[i99 >> 2] = 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     i115 = HEAP32[i90 + (i1 << 2) >> 2] | 0;
     HEAP32[i115 >> 2] = HEAP32[i98 >> 2];
     HEAP32[i115 + 4 >> 2] = HEAP32[i98 + 4 >> 2];
     HEAP32[i115 + 8 >> 2] = HEAP32[i98 + 8 >> 2];
     HEAP32[i115 + 12 >> 2] = HEAP32[i98 + 12 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i115 = HEAP32[(HEAP32[i89 >> 2] | 0) + 256 >> 2] | 0;
   HEAP32[i95 >> 2] = i2;
   HEAP32[i97 >> 2] = HEAP32[i95 >> 2];
   mftCall_vii(i115 | 0, i89 | 0, i97 | 0);
  }
 }
 if ((i96 | 0) == 53) {
  i2 = HEAP32[i99 >> 2] | 0;
  if ((HEAP16[gb + 1159828 + 6 >> 1] | 0) > -1) {
   HEAP32[i98 >> 2] = 0;
   HEAP32[i97 >> 2] = HEAP32[i98 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159828 | 0, i97);
   i1 = gb + 1159828 | 0;
  } else i1 = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  HEAP32[i99 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i102 >> 2] | 0, i101);
 if (!i100) {
  STACKTOP = i103;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i100);
 STACKTOP = i103;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i10, i17, i16, i1) {
 i10 = i10 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 16 | 0;
 i21 = i22;
 i18 = i17 + 11 | 0;
 i8 = HEAP8[i18 >> 0] | 0;
 i7 = i8 << 24 >> 24 < 0;
 i19 = i17 + 4 | 0;
 i8 = i7 ? HEAP32[i19 >> 2] | 0 : i8 & 255;
 i11 = i10 + 11 | 0;
 i9 = HEAP8[i11 >> 0] | 0;
 i6 = i9 << 24 >> 24 < 0;
 i12 = i10 + 4 | 0;
 i9 = i6 ? HEAP32[i12 >> 2] | 0 : i9 & 255;
 i2 = i9 >>> 0 < i8 >>> 0;
 i1 = i2 ? i9 : i8;
 if (!i1) i13 = 3; else {
  i1 = _memcmp(i7 ? HEAP32[i17 >> 2] | 0 : i17, i6 ? HEAP32[i10 >> 2] | 0 : i10, i1) | 0;
  if (!i1) i13 = 3;
 }
 if ((i13 | 0) == 3) i1 = i8 >>> 0 < i9 >>> 0 ? -1 : i2 & 1;
 i5 = (i1 | 0) < 0;
 i14 = i16 + 11 | 0;
 i3 = HEAP8[i14 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i15 = i16 + 4 | 0;
 i3 = i2 ? HEAP32[i15 >> 2] | 0 : i3 & 255;
 i4 = i8 >>> 0 < i3 >>> 0;
 i1 = i4 ? i8 : i3;
 if (!i1) i13 = 6; else {
  i1 = _memcmp(i2 ? HEAP32[i16 >> 2] | 0 : i16, i7 ? HEAP32[i17 >> 2] | 0 : i17, i1) | 0;
  if (!i1) i13 = 6;
 }
 if ((i13 | 0) == 6) i1 = i3 >>> 0 < i8 >>> 0 ? -1 : i4 & 1;
 i1 = (i1 | 0) < 0;
 if (!i5) {
  if (!i1) {
   i21 = 0;
   STACKTOP = i22;
   return i21 | 0;
  }
  i2 = i7 ? HEAP32[i17 >> 2] | 0 : i17;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i21 + 12 >> 2] = i1;
  if (i8 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
   i1 = HEAP32[i21 + 12 >> 2] | 0;
   i13 = 12;
  } else if (i8 >>> 0 < 11) {
   HEAP8[i21 + 11 >> 0] = i8;
   if (!i8) i1 = i21; else {
    i1 = i21;
    i13 = 14;
   }
  } else i13 = 12;
  if ((i13 | 0) == 12) {
   i9 = i8 + 16 & -16;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i21 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i21 + 4 >> 2] = i8;
   i13 = 14;
  }
  if ((i13 | 0) == 14) _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  do if ((i17 | 0) != (i16 | 0)) {
   i5 = HEAP8[i14 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
   i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i18 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i9 = i2 ? HEAP32[i19 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i5 - i3 | 0, i9, 0, i9, i5, i4);
    break;
   }
   i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i18 >> 0] | 0) < 0) {
    HEAP32[i19 >> 2] = i5;
    break;
   } else {
    HEAP8[i18 >> 0] = i5;
    break;
   }
  } while (0);
  i4 = i21 + 11 | 0;
  do if ((i21 | 0) != (i16 | 0)) {
   i5 = HEAP8[i4 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i6 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
   i5 = i1 ? HEAP32[i21 + 4 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i14 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i15 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i5 - i3 | 0, i15, 0, i15, i5, i6);
    break;
   }
   i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i14 >> 0] | 0) < 0) {
    HEAP32[i15 >> 2] = i5;
    break;
   } else {
    HEAP8[i14 >> 0] = i5;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i16 = HEAP32[i21 >> 2] | 0;
   i15 = HEAP32[i21 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i16, i20);
  }
  i3 = HEAP8[i18 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i19 >> 2] | 0 : i3 & 255;
  i6 = HEAP8[i11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i12 >> 2] | 0 : i6 & 255;
  i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
  if (!i1) i13 = 39; else {
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = _memcmp(i2 ? HEAP32[i17 >> 2] | 0 : i17, i5 ? i4 : i10, i1) | 0;
   if (!i1) i13 = 39; else if ((i1 | 0) < 0) {
    i7 = i10;
    i8 = i10;
    i1 = i4;
   } else {
    i21 = 1;
    STACKTOP = i22;
    return i21 | 0;
   }
  }
  do if ((i13 | 0) == 39) if (i3 >>> 0 < i6 >>> 0) {
   i7 = i10;
   i8 = i10;
   i1 = HEAP32[i10 >> 2] | 0;
   break;
  } else {
   i21 = 1;
   STACKTOP = i22;
   return i21 | 0;
  } while (0);
  i2 = i5 ? i1 : i8;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i21 + 12 >> 2] = i1;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
   i1 = HEAP32[i21 + 12 >> 2] | 0;
   i13 = 45;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i21 + 11 >> 0] = i6;
   if (!i6) i1 = i21; else {
    i1 = i21;
    i13 = 47;
   }
  } else i13 = 45;
  if ((i13 | 0) == 45) {
   i16 = i6 + 16 & -16;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i21 + 8 >> 2] = i16 | -2147483648;
   HEAP32[i21 + 4 >> 2] = i6;
   i13 = 47;
  }
  if ((i13 | 0) == 47) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  do if ((i10 | 0) != (i17 | 0)) {
   i5 = HEAP8[i18 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i17 >> 2] | 0 : i17;
   i5 = i1 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i11 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i16 = i2 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i16, 0, i16, i5, i4);
    break;
   }
   i1 = i2 ? HEAP32[i7 >> 2] | 0 : i8;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i11 >> 0] | 0) < 0) {
    HEAP32[i12 >> 2] = i5;
    break;
   } else {
    HEAP8[i11 >> 0] = i5;
    break;
   }
  } while (0);
  i4 = i21 + 11 | 0;
  do if ((i21 | 0) != (i17 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
   i6 = i1 ? HEAP32[i21 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i18 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i19 = i2 ? HEAP32[i19 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i6 - i3 | 0, i19, 0, i19, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i18 >> 0] | 0) < 0) {
    HEAP32[i19 >> 2] = i6;
    break;
   } else {
    HEAP8[i18 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i19 = HEAP32[i21 >> 2] | 0;
   i21 = HEAP32[i21 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
  }
  i21 = 2;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (i1) {
  i2 = i6 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i21 + 12 >> 2] = i1;
  if (i9 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
   i1 = HEAP32[i21 + 12 >> 2] | 0;
   i13 = 75;
  } else if (i9 >>> 0 < 11) {
   HEAP8[i21 + 11 >> 0] = i9;
   if (!i9) i1 = i21; else {
    i1 = i21;
    i13 = 77;
   }
  } else i13 = 75;
  if ((i13 | 0) == 75) {
   i19 = i9 + 16 & -16;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i21 + 8 >> 2] = i19 | -2147483648;
   HEAP32[i21 + 4 >> 2] = i9;
   i13 = 77;
  }
  if ((i13 | 0) == 77) _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
  HEAP8[i1 + i9 >> 0] = 0;
  do if ((i10 | 0) != (i16 | 0)) {
   i5 = HEAP8[i14 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
   i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i11 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i19 = i2 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i19, 0, i19, i5, i4);
    break;
   }
   i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i11 >> 0] | 0) < 0) {
    HEAP32[i12 >> 2] = i5;
    break;
   } else {
    HEAP8[i11 >> 0] = i5;
    break;
   }
  } while (0);
  i4 = i21 + 11 | 0;
  do if ((i21 | 0) != (i16 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
   i6 = i1 ? HEAP32[i21 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i14 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i19 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i6 - i3 | 0, i19, 0, i19, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i14 >> 0] | 0) < 0) {
    HEAP32[i15 >> 2] = i6;
    break;
   } else {
    HEAP8[i14 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i19 = HEAP32[i21 >> 2] | 0;
   i21 = HEAP32[i21 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i20 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
  }
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i2 = i6 ? HEAP32[i10 >> 2] | 0 : i10;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i21 + 12 >> 2] = i1;
 if (i9 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
  i1 = HEAP32[i21 + 12 >> 2] | 0;
  i13 = 104;
 } else if (i9 >>> 0 < 11) {
  HEAP8[i21 + 11 >> 0] = i9;
  if (!i9) i1 = i21; else {
   i1 = i21;
   i13 = 106;
  }
 } else i13 = 104;
 if ((i13 | 0) == 104) {
  i8 = i9 + 16 & -16;
  HEAP32[i20 >> 2] = 66;
  HEAP32[i20 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i21 + 4 >> 2] = i9;
  i13 = 106;
 }
 if ((i13 | 0) == 106) _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
 HEAP8[i1 + i9 >> 0] = 0;
 do if ((i10 | 0) != (i17 | 0)) {
  i5 = HEAP8[i18 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i17 >> 2] | 0 : i17;
  i5 = i1 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i12 = i2 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i12, 0, i12, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i11 >> 0] | 0) < 0) {
   HEAP32[i12 >> 2] = i5;
   break;
  } else {
   HEAP8[i11 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i21 + 11 | 0;
 do if ((i21 | 0) != (i17 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
  i6 = i1 ? HEAP32[i21 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i18 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i12 = i2 ? HEAP32[i19 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i18 >> 0] | 0) < 0) {
   HEAP32[i19 >> 2] = i6;
   break;
  } else {
   HEAP8[i18 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i12 = HEAP32[i21 >> 2] | 0;
  i11 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i20 >> 2] = 66;
  HEAP32[i20 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i20);
 }
 i3 = HEAP8[i14 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i15 >> 2] | 0 : i3 & 255;
 i6 = HEAP8[i18 >> 0] | 0;
 i5 = i6 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i19 >> 2] | 0 : i6 & 255;
 i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 if (!i1) i13 = 131; else {
  i4 = HEAP32[i17 >> 2] | 0;
  i1 = _memcmp(i2 ? HEAP32[i16 >> 2] | 0 : i16, i5 ? i4 : i17, i1) | 0;
  if (!i1) i13 = 131; else if ((i1 | 0) < 0) {
   i7 = i17;
   i8 = i17;
   i1 = i4;
  } else {
   i21 = 1;
   STACKTOP = i22;
   return i21 | 0;
  }
 }
 do if ((i13 | 0) == 131) if (i3 >>> 0 < i6 >>> 0) {
  i7 = i17;
  i8 = i17;
  i1 = HEAP32[i17 >> 2] | 0;
  break;
 } else {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 } while (0);
 i2 = i5 ? i1 : i7;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i21 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
  i1 = HEAP32[i21 + 12 >> 2] | 0;
  i13 = 137;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i21 + 11 >> 0] = i6;
  if (!i6) i1 = i21; else {
   i1 = i21;
   i13 = 139;
  }
 } else i13 = 137;
 if ((i13 | 0) == 137) {
  i12 = i6 + 16 & -16;
  HEAP32[i20 >> 2] = 66;
  HEAP32[i20 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i21 + 4 >> 2] = i6;
  i13 = 139;
 }
 if ((i13 | 0) == 139) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 do if ((i17 | 0) != (i16 | 0)) {
  i5 = HEAP8[i14 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
  i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i18 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i19 = i2 ? HEAP32[i19 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i5 - i3 | 0, i19, 0, i19, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i7;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i18 >> 0] | 0) < 0) {
   HEAP32[i19 >> 2] = i5;
   break;
  } else {
   HEAP8[i18 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i21 + 11 | 0;
 do if ((i21 | 0) != (i16 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
  i6 = i1 ? HEAP32[i21 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i19 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i6 - i3 | 0, i19, 0, i19, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i14 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = i6;
   break;
  } else {
   HEAP8[i14 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i19 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i20 >> 2] = 66;
  HEAP32[i20 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
 }
 i21 = 2;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i41, i46, i45, i1, i67, i68, i69, i70, i72, i74, i60) {
 i41 = i41 | 0;
 i46 = i46 | 0;
 i45 = i45 | 0;
 i1 = i1 | 0;
 i67 = i67 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i70 = i70 | 0;
 i72 = i72 | 0;
 i74 = i74 | 0;
 i60 = i60 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f42 = f0, i43 = 0, i44 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f61 = f0, f62 = f0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i71 = 0, i73 = 0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i75 + 320 | 0;
 i54 = i75 + 500 | 0;
 i53 = i75 + 488 | 0;
 i65 = i75 + 336 | 0;
 i63 = i75 + 256 | 0;
 i64 = i75 + 192 | 0;
 i71 = i75 + 472 | 0;
 i73 = i75 + 456 | 0;
 i47 = i75 + 448 | 0;
 i66 = i75 + 176 | 0;
 i24 = i75 + 160 | 0;
 i25 = i75 + 144 | 0;
 i23 = i75 + 128 | 0;
 i26 = i75 + 436 | 0;
 i27 = i75 + 112 | 0;
 i49 = i75 + 96 | 0;
 i48 = i75 + 80 | 0;
 i56 = i75 + 64 | 0;
 i57 = i75 + 48 | 0;
 i55 = i75 + 424 | 0;
 i44 = i75 + 32 | 0;
 i43 = i75 + 412 | 0;
 i51 = i75 + 16 | 0;
 i52 = i75;
 i50 = i75 + 400 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f61 = Math_fround(HEAPF32[i41 + 16 >> 2]);
 f62 = Math_fround(HEAPF32[i46 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i1 >> 2]);
 f42 = Math_fround(HEAPF32[i41 + 32 >> 2]);
 f59 = Math_fround(HEAPF32[i46 + 32 >> 2]);
 f42 = Math_fround((f42 > f59 ? f59 : f42) * Math_fround(.100000001));
 f42 = Math_fround(f42 * f42);
 f59 = Math_fround(f61 + f62);
 HEAP32[i47 >> 2] = 0;
 if (!(HEAP8[i60 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i45 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i45 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i45 + 56 >> 2]);
  i40 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i40 ? f5 : Math_fround(1.0);
  f6 = i40 ? f6 : Math_fround(0.0);
  f7 = i40 ? f7 : Math_fround(0.0);
  HEAPF32[i66 >> 2] = f5;
  HEAPF32[i66 + 4 >> 2] = f6;
  HEAPF32[i66 + 8 >> 2] = f7;
  HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i27 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i66 + 12 >> 2];
  i40 = i66;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i58 = 7;
 } else {
  HEAP32[i24 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i45 + 48 | 0;
  i2 = i45 + 52 | 0;
  i3 = i45 + 56 | 0;
  i8 = i45 + 16 | 0;
  i9 = i45 + 32 | 0;
  i10 = i45 + 4 | 0;
  i11 = i45 + 20 | 0;
  i12 = i45 + 36 | 0;
  i13 = i45 + 8 | 0;
  i14 = i45 + 24 | 0;
  i15 = i45 + 40 | 0;
  i16 = i46 + 16 | 0;
  i17 = i25 + 4 | 0;
  i18 = i25 + 8 | 0;
  i19 = i24 + 4 | 0;
  i20 = i24 + 8 | 0;
  i21 = i24 + 12 | 0;
  i22 = 0;
  do {
   i39 = HEAPU8[i72 + i22 >> 0] | 0;
   HEAP32[i71 + (i22 << 2) >> 2] = i39;
   i40 = HEAPU8[i74 + i22 >> 0] | 0;
   HEAP32[i73 + (i22 << 2) >> 2] = i40;
   f78 = Math_fround(HEAPF32[i41 + 96 + (i39 << 4) >> 2]);
   f76 = Math_fround(HEAPF32[i41 + 96 + (i39 << 4) + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i41 + 96 + (i39 << 4) + 8 >> 2]);
   f77 = Math_fround(HEAPF32[i1 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f4 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(f78 * Math_fround(HEAPF32[i45 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f76 * Math_fround(HEAPF32[i8 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f28 * Math_fround(HEAPF32[i9 >> 2])));
   f7 = Math_fround(f78 * Math_fround(HEAPF32[i10 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f76 * Math_fround(HEAPF32[i11 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f28 * Math_fround(HEAPF32[i12 >> 2])));
   f78 = Math_fround(f78 * Math_fround(HEAPF32[i13 >> 2]));
   f76 = Math_fround(f78 + Math_fround(f76 * Math_fround(HEAPF32[i14 >> 2])));
   f6 = Math_fround(f77 + f6);
   f7 = Math_fround(f5 + f7);
   f28 = Math_fround(f4 + Math_fround(f76 + Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2]))));
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i25, i46, i40, i16);
   f76 = Math_fround(HEAPF32[i25 >> 2]);
   f4 = Math_fround(HEAPF32[i17 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f28 - Math_fround(HEAPF32[i18 >> 2]));
   HEAPF32[i24 >> 2] = Math_fround(f6 - f76);
   HEAPF32[i19 >> 2] = f4;
   HEAPF32[i20 >> 2] = f5;
   HEAPF32[i21 >> 2] = Math_fround(0.0);
   i40 = HEAP32[i47 >> 2] | 0;
   HEAPF32[i63 + (i40 << 4) >> 2] = f6;
   HEAPF32[i63 + (i40 << 4) + 4 >> 2] = f7;
   HEAPF32[i63 + (i40 << 4) + 8 >> 2] = f28;
   HEAPF32[i63 + (i40 << 4) + 12 >> 2] = Math_fround(0.0);
   i39 = i64 + (i40 << 4) | 0;
   HEAP32[i39 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
   HEAP32[i39 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
   HEAP32[i47 >> 2] = i40 + 1;
   i40 = i65 + (i40 << 4) | 0;
   HEAP32[i40 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
   i22 = i22 + 1 | 0;
  } while (i22 >>> 0 < (HEAPU8[i60 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i23, i65, i63, i64, i71, i73, i24, i47);
  HEAP32[i66 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i66 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i66 >> 2]);
  f6 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i66 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i54 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i53 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i66 + 12 >> 2];
  if (f4 > f42) {
   i40 = i66;
   i58 = 7;
  } else i2 = HEAP32[i47 >> 2] | 0;
 }
 do if ((i58 | 0) == 7) {
  i38 = i66 + 4 | 0;
  i39 = i66 + 8 | 0;
  i10 = i45 + 4 | 0;
  i11 = i45 + 8 | 0;
  i12 = i45 + 16 | 0;
  i13 = i45 + 20 | 0;
  i14 = i45 + 24 | 0;
  i15 = i45 + 32 | 0;
  i16 = i45 + 36 | 0;
  i17 = i45 + 40 | 0;
  i18 = i41 + 96 | 0;
  i19 = i41 + 100 | 0;
  i20 = i41 + 104 | 0;
  i21 = i41 + 112 | 0;
  i22 = i41 + 116 | 0;
  i23 = i41 + 120 | 0;
  i24 = i41 + 128 | 0;
  i25 = i41 + 132 | 0;
  i26 = i41 + 136 | 0;
  i30 = i45 + 48 | 0;
  i31 = i45 + 52 | 0;
  i32 = i45 + 56 | 0;
  i33 = i49 + 4 | 0;
  i34 = i49 + 8 | 0;
  i35 = i48 + 4 | 0;
  i36 = i48 + 8 | 0;
  i37 = i48 + 12 | 0;
  i8 = i41 + 48 | 0;
  i9 = i46 + 48 | 0;
  while (1) {
   HEAP32[i53 >> 2] = HEAP32[i54 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   f78 = Math_fround(-f5);
   f89 = Math_fround(-f6);
   f90 = Math_fround(-f7);
   i3 = HEAP32[i47 >> 2] | 0;
   f83 = Math_fround(HEAPF32[i45 >> 2]);
   f94 = Math_fround(f83 * f78);
   f80 = Math_fround(HEAPF32[i10 >> 2]);
   f94 = Math_fround(f94 + Math_fround(f80 * f89));
   f5 = Math_fround(HEAPF32[i11 >> 2]);
   f94 = Math_fround(f94 + Math_fround(f5 * f90));
   f77 = Math_fround(HEAPF32[i12 >> 2]);
   f93 = Math_fround(f77 * f78);
   f6 = Math_fround(HEAPF32[i13 >> 2]);
   f93 = Math_fround(f93 + Math_fround(f6 * f89));
   f76 = Math_fround(HEAPF32[i14 >> 2]);
   f93 = Math_fround(f93 + Math_fround(f76 * f90));
   f84 = Math_fround(HEAPF32[i15 >> 2]);
   f78 = Math_fround(f84 * f78);
   f81 = Math_fround(HEAPF32[i16 >> 2]);
   f89 = Math_fround(f78 + Math_fround(f81 * f89));
   f78 = Math_fround(HEAPF32[i17 >> 2]);
   f90 = Math_fround(f89 + Math_fround(f78 * f90));
   f89 = Math_fround(HEAPF32[i18 >> 2]);
   f87 = Math_fround(HEAPF32[i19 >> 2]);
   f82 = Math_fround(HEAPF32[i20 >> 2]);
   f88 = Math_fround(HEAPF32[i21 >> 2]);
   f86 = Math_fround(HEAPF32[i22 >> 2]);
   f85 = Math_fround(HEAPF32[i23 >> 2]);
   f79 = Math_fround(HEAPF32[i24 >> 2]);
   f28 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(HEAPF32[i26 >> 2]);
   f92 = Math_fround(Math_fround(Math_fround(f94 * f89) + Math_fround(f93 * f87)) + Math_fround(f90 * f82));
   f91 = Math_fround(Math_fround(Math_fround(f94 * f88) + Math_fround(f93 * f86)) + Math_fround(f90 * f85));
   f90 = Math_fround(Math_fround(Math_fround(f94 * f79) + Math_fround(f93 * f28)) + Math_fround(f90 * f7));
   i41 = f92 > f91 & f92 > f90;
   i2 = f91 > f90;
   HEAP32[i71 + (i3 << 2) >> 2] = i41 ? 0 : i2 ? 1 : 2;
   f79 = i41 ? f89 : i2 ? f88 : f79;
   f28 = i41 ? f87 : i2 ? f86 : f28;
   f7 = i41 ? f82 : i2 ? f85 : f7;
   f85 = Math_fround(HEAPF32[i30 >> 2]);
   f82 = Math_fround(HEAPF32[i31 >> 2]);
   f77 = Math_fround(f85 + Math_fround(Math_fround(f84 * f7) + Math_fround(Math_fround(f79 * f83) + Math_fround(f28 * f77))));
   f6 = Math_fround(f82 + Math_fround(Math_fround(f81 * f7) + Math_fround(Math_fround(f79 * f80) + Math_fround(f28 * f6))));
   f78 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + Math_fround(Math_fround(Math_fround(f79 * f5) + Math_fround(f28 * f76)) + Math_fround(f7 * f78)));
   HEAPF32[i63 + (i3 << 4) >> 2] = f77;
   HEAPF32[i63 + (i3 << 4) + 4 >> 2] = f6;
   HEAPF32[i63 + (i3 << 4) + 8 >> 2] = f78;
   HEAPF32[i63 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i49, i46, i66, i64 + (i3 << 4) | 0, i73 + (i3 << 2) | 0);
   f7 = Math_fround(HEAPF32[i49 >> 2]);
   f76 = Math_fround(HEAPF32[i33 >> 2]);
   f7 = Math_fround(f77 - f7);
   f76 = Math_fround(f6 - f76);
   f78 = Math_fround(f78 - Math_fround(HEAPF32[i34 >> 2]));
   HEAPF32[i48 >> 2] = f7;
   HEAPF32[i35 >> 2] = f76;
   HEAPF32[i36 >> 2] = f78;
   HEAPF32[i37 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i47 >> 2] | 0;
   i2 = i65 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i8 >> 2]);
   f77 = Math_fround(HEAPF32[i9 >> 2]);
   f77 = f6 > f77 ? f6 : f77;
   f29 = f29 > f77 ? f29 : f77;
   f77 = Math_fround(f59 + f29);
   f77 = Math_fround(f4 * Math_fround(f77 * f77));
   f6 = Math_fround(HEAPF32[i66 >> 2]);
   f28 = Math_fround(HEAPF32[i38 >> 2]);
   f78 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f28 * f76)) + Math_fround(Math_fround(HEAPF32[i39 >> 2]) * f78));
   i2 = f78 > Math_fround(0.0) & Math_fround(f78 * f78) > f77;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f78) | i2) {
    i58 = 9;
    break;
   }
   HEAP32[i47 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i44, i65, i63, i64, i71, i73, i48, i47);
   HEAP32[i40 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i66 >> 2]);
   f6 = Math_fround(HEAPF32[i38 >> 2]);
   f7 = Math_fround(HEAPF32[i39 >> 2]);
   f28 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i54 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   i1 = f4 > f28;
   if (!(f28 > f42 & i1)) break; else f4 = f28;
  }
  if ((i58 | 0) == 9) {
   if (i72 | 0) {
    HEAP8[i60 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
      HEAP8[i74 + i1 >> 0] = HEAP32[i73 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i74 = 0;
    STACKTOP = i75;
    return i74 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i65, i63, i64, i66, i56, i57, i3);
   f91 = Math_fround(Math_sqrt(Math_fround(f4)));
   f92 = Math_fround(HEAPF32[i66 >> 2]);
   f93 = Math_fround(HEAPF32[i38 >> 2]);
   f94 = Math_fround(Math_fround(1.0) / f91);
   f92 = Math_fround(f92 * f94);
   f93 = Math_fround(f93 * f94);
   f94 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) * f94);
   f90 = Math_fround(HEAPF32[i56 >> 2]);
   f89 = Math_fround(HEAPF32[i56 + 4 >> 2]);
   f89 = Math_fround(f89 - Math_fround(f61 * f93));
   f88 = Math_fround(Math_fround(HEAPF32[i56 + 8 >> 2]) - Math_fround(f61 * f94));
   HEAPF32[i67 >> 2] = Math_fround(f90 - Math_fround(f61 * f92));
   HEAPF32[i67 + 4 >> 2] = f89;
   HEAPF32[i67 + 8 >> 2] = f88;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   f88 = Math_fround(HEAPF32[i57 >> 2]);
   f89 = Math_fround(HEAPF32[i57 + 4 >> 2]);
   f89 = Math_fround(Math_fround(f62 * f93) + f89);
   f90 = Math_fround(Math_fround(f62 * f94) + Math_fround(HEAPF32[i57 + 8 >> 2]));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(f62 * f92) + f88);
   HEAPF32[i68 + 4 >> 2] = f89;
   HEAPF32[i68 + 8 >> 2] = f90;
   HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i70 >> 2] = Math_fround(f91 - f59);
   i74 = i70 + 4 | 0;
   HEAP32[i74 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i74 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i74 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   HEAPF32[i69 >> 2] = f92;
   HEAPF32[i69 + 4 >> 2] = f93;
   HEAPF32[i69 + 8 >> 2] = f94;
   HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
   i74 = 1;
   STACKTOP = i75;
   return i74 | 0;
  }
  i2 = HEAP32[i47 >> 2] | 0;
  if (i1) {
   if (!i72) i1 = 6; else break;
   STACKTOP = i75;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i72 | 0) {
   HEAP8[i60 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
     HEAP8[i74 + i1 >> 0] = HEAP32[i73 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i40 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i65, i63, i64, i66, i51, i52, i2);
  HEAP32[i54 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  f91 = Math_fround(Math_sqrt(Math_fround(f4)));
  f92 = Math_fround(HEAPF32[i66 >> 2]);
  f93 = Math_fround(HEAPF32[i66 + 4 >> 2]);
  f94 = Math_fround(Math_fround(1.0) / f91);
  f92 = Math_fround(f92 * f94);
  f93 = Math_fround(f93 * f94);
  f94 = Math_fround(Math_fround(HEAPF32[i66 + 8 >> 2]) * f94);
  f90 = Math_fround(HEAPF32[i51 >> 2]);
  f89 = Math_fround(HEAPF32[i51 + 4 >> 2]);
  f89 = Math_fround(f89 - Math_fround(f61 * f93));
  f88 = Math_fround(Math_fround(HEAPF32[i51 + 8 >> 2]) - Math_fround(f61 * f94));
  HEAPF32[i67 >> 2] = Math_fround(f90 - Math_fround(f61 * f92));
  HEAPF32[i67 + 4 >> 2] = f89;
  HEAPF32[i67 + 8 >> 2] = f88;
  HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
  f88 = Math_fround(HEAPF32[i52 >> 2]);
  f89 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  f89 = Math_fround(Math_fround(f62 * f93) + f89);
  f90 = Math_fround(Math_fround(f62 * f94) + Math_fround(HEAPF32[i52 + 8 >> 2]));
  HEAPF32[i68 >> 2] = Math_fround(Math_fround(f62 * f92) + f88);
  HEAPF32[i68 + 4 >> 2] = f89;
  HEAPF32[i68 + 8 >> 2] = f90;
  HEAPF32[i68 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i70 >> 2] = Math_fround(f91 - f59);
  i74 = i70 + 4 | 0;
  HEAP32[i74 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i74 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i74 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAPF32[i69 >> 2] = f92;
  HEAPF32[i69 + 4 >> 2] = f93;
  HEAPF32[i69 + 8 >> 2] = f94;
  HEAPF32[i69 + 12 >> 2] = Math_fround(0.0);
  i74 = 3;
  STACKTOP = i75;
  return i74 | 0;
 } while (0);
 HEAP8[i60 >> 0] = i2;
 if (!i2) {
  i74 = 6;
  STACKTOP = i75;
  return i74 | 0;
 } else i1 = 0;
 do {
  HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
  HEAP8[i74 + i1 >> 0] = HEAP32[i73 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i75;
 return i1 | 0;
}

function __ZN13AvatarBuilder12IsValidHumanERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i46, i47, i48, i50) {
 i46 = i46 | 0;
 i47 = i47 | 0;
 i48 = i48 | 0;
 i50 = i50 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i49 = 0, i51 = 0, i52 = 0, i53 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i53 + 32 | 0;
 i44 = i53 + 24 | 0;
 i42 = i53 + 16 | 0;
 i39 = i53 + 8 | 0;
 i38 = i53;
 i52 = i53 + 136 | 0;
 i35 = i53 + 120 | 0;
 i51 = i53 + 56 | 0;
 i41 = i53 + 40 | 0;
 i36 = i53 + 104 | 0;
 i37 = i53 + 88 | 0;
 i40 = i53 + 72 | 0;
 i14 = i46 + 4 | 0;
 i15 = i41 + 11 | 0;
 i16 = i41 + 4 | 0;
 i17 = i51 + 12 | 0;
 i11 = i51 + 12 | 0;
 i18 = i52 + 4 | 0;
 i19 = i51 + 8 | 0;
 i20 = i51 + 4 | 0;
 i21 = i51 + 11 | 0;
 i22 = i35 + 12 | 0;
 i12 = i35 + 12 | 0;
 i23 = i52 + 4 | 0;
 i24 = i35 + 8 | 0;
 i25 = i35 + 4 | 0;
 i26 = i35 + 11 | 0;
 i27 = i52 + 4 | 0;
 i28 = i52 + 4 | 0;
 i43 = i47 + 4 | 0;
 i29 = i36 + 12 | 0;
 i13 = i36 + 12 | 0;
 i30 = i52 + 4 | 0;
 i31 = i36 + 8 | 0;
 i32 = i36 + 4 | 0;
 i33 = i36 + 11 | 0;
 i34 = i52 + 4 | 0;
 i10 = 0;
 while (1) {
  i1 = HEAP32[i46 >> 2] | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i4 = __ZN7mecanim5human8BoneNameEj(i10) | 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i41 + 4 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i41, i4, _strlen(i4) | 0);
  i4 = HEAP8[i15 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i41 >> 2] | 0 : i41;
  i4 = i2 ? HEAP32[i16 >> 2] | 0 : i4 & 255;
  HEAP32[i51 >> 2] = 0;
  HEAP32[i51 + 4 >> 2] = 0;
  HEAP32[i51 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i17 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i51);
   i2 = HEAP32[i11 >> 2] | 0;
   i45 = 5;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i21 >> 0] = i4;
   if (!i4) i2 = i51; else {
    i2 = i51;
    i45 = 7;
   }
  } else i45 = 5;
  if ((i45 | 0) == 5) {
   i8 = i4 + 16 & -16;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i18 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i51 >> 2] = i2;
   HEAP32[i19 >> 2] = i8 | -2147483648;
   HEAP32[i20 >> 2] = i4;
   i45 = 7;
  }
  if ((i45 | 0) == 7) {
   i45 = 0;
   _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i2 + i4 >> 0] = 0;
  i4 = HEAP8[i21 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i51 >> 2] | 0 : i51;
  i4 = i2 ? HEAP32[i20 >> 2] | 0 : i4 & 255;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i22 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i35);
   i2 = HEAP32[i12 >> 2] | 0;
   i45 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i26 >> 0] = i4;
   if (!i4) i2 = i35; else {
    i2 = i35;
    i45 = 13;
   }
  } else i45 = 11;
  if ((i45 | 0) == 11) {
   i8 = i4 + 16 & -16;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i23 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i35 >> 2] = i2;
   HEAP32[i24 >> 2] = i8 | -2147483648;
   HEAP32[i25 >> 2] = i4;
   i45 = 13;
  }
  if ((i45 | 0) == 13) {
   i45 = 0;
   _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i2 + i4 >> 0] = 0;
  i8 = HEAP8[i26 >> 0] | 0;
  L21 : do if ((i1 | 0) != (i9 | 0)) {
   i3 = i8 << 24 >> 24 < 0;
   i4 = i8 & 255;
   i5 = HEAP32[i25 >> 2] | 0;
   i7 = i3 ? i5 : i4;
   i6 = HEAP32[i35 >> 2] | 0;
   if (i3) while (1) {
    i2 = i1 + 16 | 0;
    i4 = HEAP8[i2 + 11 >> 0] | 0;
    i3 = i4 << 24 >> 24 < 0;
    if ((i7 | 0) == ((i3 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255) | 0)) if (!(_strncmp(i6, i3 ? HEAP32[i2 >> 2] | 0 : i2, i5) | 0)) break L21;
    i1 = i1 + 76 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
   } else while (1) {
    i3 = i1 + 16 | 0;
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    if ((i7 | 0) == ((i2 ? HEAP32[i1 + 20 >> 2] | 0 : i6 & 255) | 0)) if (!(_strncmp(i35, i2 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0)) break L21;
    i1 = i1 + 76 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
   }
  } while (0);
  if (i8 << 24 >> 24 < 0) {
   i9 = HEAP32[i35 >> 2] | 0;
   i8 = HEAP32[i12 >> 2] | 0;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i27 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i52);
  }
  if ((HEAP8[i21 >> 0] | 0) < 0) {
   i9 = HEAP32[i51 >> 2] | 0;
   i8 = HEAP32[i11 >> 2] | 0;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i28 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i52);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
  if ((i1 | 0) != (HEAP32[i14 >> 2] | 0)) {
   i2 = HEAP32[i47 >> 2] | 0;
   i7 = HEAP32[i43 >> 2] | 0;
   i8 = i1 + 11 | 0;
   i5 = HEAP8[i8 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   HEAP32[i36 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i29 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i36);
    i3 = HEAP32[i13 >> 2] | 0;
    i45 = 30;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i33 >> 0] = i5;
    if (!i5) i3 = i36; else {
     i3 = i36;
     i45 = 32;
    }
   } else i45 = 30;
   if ((i45 | 0) == 30) {
    i9 = i5 + 16 & -16;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i30 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i36 >> 2] = i3;
    HEAP32[i31 >> 2] = i9 | -2147483648;
    HEAP32[i32 >> 2] = i5;
    i45 = 32;
   }
   if ((i45 | 0) == 32) {
    i45 = 0;
    _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i6 = HEAP8[i33 >> 0] | 0;
   L52 : do if ((i2 | 0) != (i7 | 0)) {
    i4 = i6 & 255;
    if (i6 << 24 >> 24 >= 0) while (1) {
     i9 = HEAP8[i2 + 11 >> 0] | 0;
     i3 = i9 << 24 >> 24 < 0;
     if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255) | 0)) if (!(_strncmp(i36, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L52;
     i2 = i2 + 36 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = i7;
      break L52;
     }
    }
    i4 = HEAP32[i32 >> 2] | 0;
    i5 = HEAP32[i36 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i2 + 11 >> 0] | 0;
     i3 = i9 << 24 >> 24 < 0;
     if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255) | 0)) if (!(_strncmp(i5, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L52;
     i2 = i2 + 36 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = i7;
      break;
     }
    }
   } while (0);
   if (i6 << 24 >> 24 < 0) {
    i9 = HEAP32[i36 >> 2] | 0;
    i7 = HEAP32[i13 >> 2] | 0;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i34 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i52);
   }
   if ((i2 | 0) == (HEAP32[i43 >> 2] | 0)) {
    i45 = 45;
    break;
   }
  }
  i1 = i10 + 1 | 0;
  if ((i1 | 0) < 24) i10 = i1; else break;
 }
 if ((i45 | 0) == 45) {
  if ((HEAP8[i8 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i51 = __ZN7mecanim5human8BoneNameEj(i10) | 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i37, i51, _strlen(i51) | 0);
  i51 = (HEAP8[i37 + 11 >> 0] | 0) < 0 ? HEAP32[i37 >> 2] | 0 : i37;
  HEAP32[i38 >> 2] = i1;
  HEAP32[i38 + 4 >> 2] = i51;
  __Z6FormatPKcz(i52, gb + 912594 | 0, i38);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i50, i52) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  i52 = 0;
  STACKTOP = i53;
  return i52 | 0;
 }
 i1 = HEAP32[gb + 1467164 >> 2] | 0;
 HEAP32[i51 >> 2] = 0;
 i11 = i51 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i51 + 8 >> 2] = 0;
 i2 = i1 + 4 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 i4 = i3 >> 4;
 if (i4 | 0) {
  if (i4 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i51);
  i38 = __Znwj(i3) | 0;
  HEAP32[i11 >> 2] = i38;
  HEAP32[i51 >> 2] = i38;
  HEAP32[i51 + 8 >> 2] = i38 + (i4 << 4);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i51, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i4);
 }
 i1 = __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE(0, i46, i47, i51) | 0;
 do if (!i1) {
  i3 = 0;
  i45 = 85;
 } else {
  i8 = i1 + 100 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if (!i2) {
   HEAP32[i39 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   __Z6FormatPKcz(i52, gb + 912639 | 0, i39);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i50, i52) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
   i5 = 0;
   break;
  }
  i1 = HEAP32[i47 >> 2] | 0;
  i7 = HEAP32[i43 >> 2] | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i41 + 4 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i41 + 12 >> 2] = i2;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i41);
   i2 = HEAP32[i41 + 12 >> 2] | 0;
   i45 = 59;
  } else if (i5 >>> 0 < 11) {
   i3 = i41 + 11 | 0;
   HEAP8[i3 >> 0] = i5;
   if (!i5) i2 = i41; else {
    i2 = i41;
    i45 = 61;
   }
  } else i45 = 59;
  if ((i45 | 0) == 59) {
   i3 = i5 + 16 & -16;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i52 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i41 >> 2] = i2;
   HEAP32[i41 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i41 + 4 >> 2] = i5;
   i3 = i41 + 11 | 0;
   i45 = 61;
  }
  if ((i45 | 0) == 61) _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i2 + i5 >> 0] = 0;
  i5 = HEAP8[i3 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i4 = i2 ? HEAP32[i41 >> 2] | 0 : i41;
  i5 = i2 ? HEAP32[i41 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i40 >> 2] = 0;
  HEAP32[i40 + 4 >> 2] = 0;
  HEAP32[i40 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i40 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
   i2 = HEAP32[i40 + 12 >> 2] | 0;
   i45 = 65;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i40 + 11 >> 0] = i5;
   if (!i5) i2 = i40; else {
    i2 = i40;
    i45 = 67;
   }
  } else i45 = 65;
  if ((i45 | 0) == 65) {
   i39 = i5 + 16 & -16;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i52 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i39, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i40 >> 2] = i2;
   HEAP32[i40 + 8 >> 2] = i39 | -2147483648;
   HEAP32[i40 + 4 >> 2] = i5;
   i45 = 67;
  }
  if ((i45 | 0) == 67) _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i2 + i5 >> 0] = 0;
  i6 = HEAP8[i40 + 11 >> 0] | 0;
  L107 : do if ((i1 | 0) != (i7 | 0)) {
   i4 = i6 & 255;
   if (i6 << 24 >> 24 >= 0) while (1) {
    i39 = HEAP8[i1 + 11 >> 0] | 0;
    i2 = i39 << 24 >> 24 < 0;
    if ((i4 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i39 & 255) | 0)) if (!(_strncmp(i40, i2 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0)) break L107;
    i1 = i1 + 36 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     i1 = i7;
     break L107;
    }
   }
   i4 = HEAP32[i40 + 4 >> 2] | 0;
   i5 = HEAP32[i40 >> 2] | 0;
   while (1) {
    i39 = HEAP8[i1 + 11 >> 0] | 0;
    i2 = i39 << 24 >> 24 < 0;
    if ((i4 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i39 & 255) | 0)) if (!(_strncmp(i5, i2 ? HEAP32[i1 >> 2] | 0 : i1, i4) | 0)) break L107;
    i1 = i1 + 36 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     i1 = i7;
     break;
    }
   }
  } while (0);
  i1 = (i1 | 0) == (HEAP32[i43 >> 2] | 0);
  if (i6 << 24 >> 24 < 0) {
   i39 = HEAP32[i40 >> 2] | 0;
   i40 = HEAP32[i40 + 12 >> 2] | 0;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i52 + 4 >> 2] = i40;
   __Z19free_alloc_internalPvRK10MemLabelId(i39, i52);
  }
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i40 = HEAP32[i41 >> 2] | 0;
   i41 = HEAP32[i41 + 12 >> 2] | 0;
   HEAP32[i52 >> 2] = 66;
   HEAP32[i52 + 4 >> 2] = i41;
   __Z19free_alloc_internalPvRK10MemLabelId(i40, i52);
  }
  if (i1) {
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP32[i42 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
   __Z6FormatPKcz(i52, gb + 912673 | 0, i42);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i50, i52) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
   i5 = 0;
  } else {
   i3 = 0;
   i45 = 85;
  }
 } while (0);
 L129 : do if ((i45 | 0) == 85) {
  L130 : while (1) {
   i45 = 0;
   i4 = __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE(i3, i46, i47, i51) | 0;
   L132 : do if (!((i4 | 0) == 0 | (i3 | 0) == 0)) {
    i1 = i3;
    while (1) {
     i2 = i1;
     i1 = HEAP32[gb + 179880 + (i1 << 2) >> 2] | 0;
     if (i1 >>> 0 >= 24) if (!i2) break L132; else continue;
     if (__ZN7mecanim5human12RequiredBoneEj(i1) | 0) break;
     if (!i1) break L132;
    }
    i1 = __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE(i1, i46, i47, i51) | 0;
    if (!(__Z22IsChildOrSameTransformR9TransformS0_(i4, i1) | 0)) {
     i45 = 91;
     break L130;
    }
   } while (0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= 54) break; else i45 = 85;
  }
  if ((i45 | 0) == 91) {
   i49 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i44 >> 2] = i49;
   HEAP32[i44 + 4 >> 2] = i5;
   __Z6FormatPKcz(i52, gb + 912745 | 0, i44);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i50, i52) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
   i5 = 0;
   break;
  }
  i1 = HEAP32[i43 >> 2] | 0;
  i2 = HEAP32[i47 >> 2] | 0;
  i3 = i1 - i2 | 0;
  i9 = i2;
  L144 : do if (i3 | 0) {
   i10 = (i1 - i2 | 0) / 36 | 0;
   i8 = (i1 | 0) == (i2 | 0);
   i1 = 0;
   i7 = (i3 | 0) / 36 | 0;
   L146 : while (1) {
    i4 = i9 + (i1 * 36 | 0) + 32 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (i48 | 0)) {
     i6 = HEAP32[i5 + 100 >> 2] | 0;
     if ((i6 | 0) != (i48 | 0)) {
      if (i8) break; else i3 = 0;
      while (1) {
       if ((HEAP32[i2 + (i3 * 36 | 0) + 32 >> 2] | 0) == (i6 | 0)) break;
       i3 = i3 + 1 | 0;
       if (i3 >>> 0 >= i7 >>> 0) break L146;
      }
      if ((i3 | 0) == -1) break;
     }
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 < i10 >>> 0) i7 = i10; else break L144;
   }
   i48 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
   i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
   HEAP32[i49 >> 2] = i48;
   HEAP32[i49 + 4 >> 2] = i5;
   __Z6FormatPKcz(i52, gb + 912787 | 0, i49);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i50, i52) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
   i5 = 0;
   break L129;
  } while (0);
  if (!(HEAP8[i46 + 86 >> 0] | 0)) {
   i5 = HEAP8[i50 + 11 >> 0] | 0;
   i5 = ((i5 << 24 >> 24 < 0 ? HEAP32[i50 + 4 >> 2] | 0 : i5 & 255) | 0) == 0;
   break;
  } else {
   i5 = __ZN13AvatarBuilder21IsValidHumanHierarchyERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i46, i47, 0, i50) | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i51 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i4 = i52 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i11 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i50 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i52 >> 2] = 66;
     HEAP32[i4 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i50, i52);
     i2 = HEAP32[i11 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i51 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i52 = i5;
 STACKTOP = i53;
 return i52 | 0;
}

function __ZL20outputConvexToStreamPN5physx7PxShapeEPKNS_12PxRigidActorERKNS_11PxTransformERNS_6shdfnd5ArrayIjNS8_19ReflectionAllocatorIjEEEERNS9_INS_10PxTriangleENSA_ISE_EEEESD_RKNS_14PxExtendedVec3ERKNS_9PxBounds3ERKNS_3Cct9CCTParamsEPNS_2Cm12RenderBufferERt(i33, i32, i26, i28, i62, i59, i34, i36, i60, i61, i57) {
 i33 = i33 | 0;
 i32 = i32 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i62 = i62 | 0;
 i59 = i59 | 0;
 i34 = i34 | 0;
 i36 = i36 | 0;
 i60 = i60 | 0;
 i61 = i61 | 0;
 i57 = i57 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f27 = f0, f29 = f0, f30 = f0, f31 = f0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i58 = 0, i63 = 0, d64 = 0.0, d65 = 0.0, d66 = 0.0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i63 + 120 | 0;
 i16 = i63 + 80 | 0;
 i3 = i63 + 24 | 0;
 i17 = i63 + 4 | 0;
 i56 = i63 + 44 | 0;
 i37 = i63;
 HEAP32[i16 >> 2] = 4;
 i18 = i16 + 4 | 0;
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 HEAPF32[i16 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i16 + 12 >> 2] = Math_fround(1.0);
 i19 = i16 + 16 | 0;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 i20 = i16 + 20 | 0;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 i21 = i16 + 24 | 0;
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 i22 = i16 + 28 | 0;
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i35 = i16 + 32 | 0;
 HEAP32[i35 >> 2] = 0;
 mftCall_iii(HEAP32[(HEAP32[i33 >> 2] | 0) + 52 >> 2] | 0, i33 | 0, i16 | 0) | 0;
 i35 = HEAP32[i35 >> 2] | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 36 >> 2] | 0, i35 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 32 >> 2] | 0, i35 | 0) | 0;
 i5 = (i16 | 0) == 0;
 if (i5) {
  i4 = i63 + 168 | 0;
  i1 = 0;
 } else {
  i2 = i3 + 16 | 0;
  i1 = 0;
  i4 = 0;
  do {
   mftCall_iiii(HEAP32[(HEAP32[i35 >> 2] | 0) + 40 >> 2] | 0, i35 | 0, i4 | 0, i3 | 0) | 0;
   i1 = i1 + -2 + (HEAPU16[i2 >> 1] | 0) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i16 | 0));
  i4 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i1 * 12 | 0) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  if (!i5) {
   i11 = i17 + 16 | 0;
   i12 = 0;
   i2 = i4;
   while (1) {
    mftCall_iiii(HEAP32[(HEAP32[i35 >> 2] | 0) + 40 >> 2] | 0, i35 | 0, i12 | 0, i17 | 0) | 0;
    i10 = HEAPU16[i11 >> 1] | 0;
    i3 = i10 + -2 | 0;
    if (i3) {
     i5 = HEAPU8[i6 >> 0] | 0;
     i7 = i10 * 3 | 0;
     i8 = 0;
     i9 = i2;
     while (1) {
      i40 = i8;
      i8 = i8 + 1 | 0;
      i39 = HEAPU8[i6 + ((i8 >>> 0) % (i10 >>> 0) | 0) >> 0] | 0;
      i40 = HEAPU8[i6 + (((i40 + 2 | 0) >>> 0) % (i10 >>> 0) | 0) >> 0] | 0;
      HEAP32[i9 >> 2] = i5;
      HEAP32[i9 + 4 >> 2] = i39;
      HEAP32[i9 + 8 >> 2] = i40;
      if ((i8 | 0) == (i3 | 0)) break; else i9 = i9 + 12 | 0;
     }
     i2 = i2 + (i7 + -6 << 2) | 0;
    }
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i16 | 0)) break; else i6 = i6 + i10 | 0;
   }
  }
 }
 f41 = Math_fround(HEAPF32[i26 >> 2]);
 f70 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f45 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f50 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f30 = Math_fround(f41 + f41);
 f55 = Math_fround(f70 + f70);
 f15 = Math_fround(f45 + f45);
 f53 = Math_fround(f70 * f55);
 f51 = Math_fround(f45 * f15);
 f70 = Math_fround(f30 * f70);
 f68 = Math_fround(f30 * f45);
 f54 = Math_fround(f30 * f50);
 f45 = Math_fround(f55 * f45);
 f55 = Math_fround(f55 * f50);
 f50 = Math_fround(f15 * f50);
 f15 = Math_fround(Math_fround(Math_fround(1.0) - f53) - f51);
 f14 = Math_fround(f70 + f50);
 f43 = Math_fround(f68 - f55);
 f50 = Math_fround(f70 - f50);
 f30 = Math_fround(Math_fround(1.0) - Math_fround(f41 * f30));
 f51 = Math_fround(f30 - f51);
 f41 = Math_fround(f45 + f54);
 f55 = Math_fround(f68 + f55);
 f54 = Math_fround(f45 - f54);
 f53 = Math_fround(f30 - f53);
 f30 = Math_fround(HEAPF32[i19 >> 2]);
 f45 = Math_fround(HEAPF32[i20 >> 2]);
 f68 = Math_fround(HEAPF32[i21 >> 2]);
 f70 = Math_fround(HEAPF32[i22 >> 2]);
 f27 = Math_fround(f30 + f30);
 f25 = Math_fround(f45 + f45);
 f49 = Math_fround(f68 + f68);
 f44 = Math_fround(f45 * f25);
 f69 = Math_fround(f68 * f49);
 f45 = Math_fround(f27 * f45);
 f23 = Math_fround(f27 * f68);
 f29 = Math_fround(f27 * f70);
 f68 = Math_fround(f25 * f68);
 f25 = Math_fround(f25 * f70);
 f70 = Math_fround(f49 * f70);
 f49 = Math_fround(Math_fround(Math_fround(1.0) - f44) - f69);
 f31 = Math_fround(f45 + f70);
 f48 = Math_fround(f23 - f25);
 f70 = Math_fround(f45 - f70);
 f27 = Math_fround(Math_fround(1.0) - Math_fround(f30 * f27));
 f69 = Math_fround(f27 - f69);
 f30 = Math_fround(f68 + f29);
 f25 = Math_fround(f23 + f25);
 f29 = Math_fround(f68 - f29);
 f44 = Math_fround(f27 - f44);
 f27 = Math_fround(HEAPF32[i18 >> 2]);
 f68 = Math_fround(f27 * f49);
 f23 = Math_fround(f27 * f70);
 f27 = Math_fround(f27 * f25);
 f45 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f67 = Math_fround(f31 * f45);
 f24 = Math_fround(f69 * f45);
 f45 = Math_fround(f29 * f45);
 f13 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f42 = Math_fround(f48 * f13);
 f52 = Math_fround(f30 * f13);
 f13 = Math_fround(f44 * f13);
 f47 = Math_fround(Math_fround(Math_fround(f49 * f68) + Math_fround(f31 * f67)) + Math_fround(f48 * f42));
 f46 = Math_fround(Math_fround(Math_fround(f49 * f23) + Math_fround(f31 * f24)) + Math_fround(f48 * f52));
 f48 = Math_fround(Math_fround(Math_fround(f49 * f27) + Math_fround(f31 * f45)) + Math_fround(f48 * f13));
 f31 = Math_fround(Math_fround(Math_fround(f70 * f68) + Math_fround(f69 * f67)) + Math_fround(f30 * f42));
 f49 = Math_fround(Math_fround(Math_fround(f70 * f23) + Math_fround(f69 * f24)) + Math_fround(f30 * f52));
 f30 = Math_fround(Math_fround(Math_fround(f70 * f27) + Math_fround(f69 * f45)) + Math_fround(f30 * f13));
 f42 = Math_fround(Math_fround(Math_fround(f25 * f68) + Math_fround(f29 * f67)) + Math_fround(f44 * f42));
 f52 = Math_fround(Math_fround(Math_fround(f25 * f23) + Math_fround(f29 * f24)) + Math_fround(f44 * f52));
 f13 = Math_fround(Math_fround(Math_fround(f25 * f27) + Math_fround(f29 * f45)) + Math_fround(f44 * f13));
 f44 = Math_fround(Math_fround(f55 * f48) + Math_fround(Math_fround(f15 * f47) + Math_fround(f50 * f46)));
 f45 = Math_fround(Math_fround(f54 * f48) + Math_fround(Math_fround(f14 * f47) + Math_fround(f51 * f46)));
 f46 = Math_fround(Math_fround(f53 * f48) + Math_fround(Math_fround(f43 * f47) + Math_fround(f41 * f46)));
 f47 = Math_fround(Math_fround(f55 * f30) + Math_fround(Math_fround(f15 * f31) + Math_fround(f50 * f49)));
 f48 = Math_fround(Math_fround(f54 * f30) + Math_fround(Math_fround(f14 * f31) + Math_fround(f51 * f49)));
 f49 = Math_fround(Math_fround(f53 * f30) + Math_fround(Math_fround(f43 * f31) + Math_fround(f41 * f49)));
 f50 = Math_fround(Math_fround(f55 * f13) + Math_fround(Math_fround(f15 * f42) + Math_fround(f50 * f52)));
 f51 = Math_fround(Math_fround(f54 * f13) + Math_fround(Math_fround(f14 * f42) + Math_fround(f51 * f52)));
 f52 = Math_fround(Math_fround(f53 * f13) + Math_fround(Math_fround(f43 * f42) + Math_fround(f41 * f52)));
 f41 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 f42 = Math_fround(HEAPF32[i26 + 20 >> 2]);
 f43 = Math_fround(HEAPF32[i26 + 24 >> 2]);
 d66 = +HEAPF64[i34 >> 3];
 f41 = Math_fround(+f41 - d66);
 d65 = +HEAPF64[i34 + 8 >> 3];
 f42 = Math_fround(+f42 - d65);
 d64 = +HEAPF64[i34 + 16 >> 3];
 f43 = Math_fround(+f43 - d64);
 f13 = Math_fround(d66);
 f53 = Math_fround(-f13);
 f14 = Math_fround(d65);
 f54 = Math_fround(-f14);
 f15 = Math_fround(d64);
 f55 = Math_fround(-f15);
 i39 = HEAP32[i28 + 4 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i28, i39 + 12 | 0);
 i38 = HEAP32[i28 >> 2] | 0;
 HEAP32[i38 + (i39 << 2) >> 2] = 2;
 HEAP32[i38 + (i39 + 1 << 2) >> 2] = i33;
 HEAP32[i38 + (i39 + 2 << 2) >> 2] = i32;
 i2 = i38 + (i39 + 4 << 2) | 0;
 HEAP32[i2 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i34 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i34 + 20 >> 2];
 i2 = i62 + 4 | 0;
 i40 = i38 + (i39 + 11 << 2) | 0;
 HEAP32[i40 >> 2] = HEAP32[i2 >> 2];
 i34 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 28 >> 2] | 0, i35 | 0) | 0;
 if (HEAP8[i60 + 56 >> 0] | 0) {
  f30 = Math_fround(HEAPF32[i36 + 12 >> 2]);
  f68 = Math_fround(HEAPF32[i36 >> 2]);
  f67 = Math_fround(f30 - f68);
  f31 = Math_fround(HEAPF32[i36 + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  f69 = Math_fround(f31 - f23);
  f24 = Math_fround(HEAPF32[i36 + 20 >> 2]);
  f25 = Math_fround(HEAPF32[i36 + 8 >> 2]);
  f67 = Math_fround(f67 * Math_fround(.5));
  f69 = Math_fround(f69 * Math_fround(.5));
  f70 = Math_fround(Math_fround(f24 - f25) * Math_fround(.5));
  f68 = Math_fround(Math_fround(Math_fround(f30 + f68) * Math_fround(.5)) - f13);
  f23 = Math_fround(Math_fround(Math_fround(f31 + f23) * Math_fround(.5)) - f14);
  f25 = Math_fround(Math_fround(Math_fround(f24 + f25) * Math_fround(.5)) - f15);
  f13 = Math_fround(f68 - f67);
  f15 = Math_fround(f23 - f69);
  f24 = Math_fround(f25 - f70);
  f14 = Math_fround(f67 + f68);
  f23 = Math_fround(f69 + f23);
  f25 = Math_fround(f70 + f25);
  if (!i1) i1 = 0; else {
   i10 = i56 + 4 | 0;
   i11 = i56 + 8 | 0;
   i12 = i56 + 12 | 0;
   i16 = i56 + 16 | 0;
   i17 = i56 + 20 | 0;
   i18 = i56 + 24 | 0;
   i19 = i56 + 28 | 0;
   i20 = i56 + 32 | 0;
   i21 = i58 + 4 | 0;
   i22 = i58 + 8 | 0;
   i26 = i58 + 12 | 0;
   f29 = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   f30 = Math_fround(Math_fround(f15 + f23) * Math_fround(.5));
   f31 = Math_fround(Math_fround(f24 + f25) * Math_fround(.5));
   i28 = i58 + 16 | 0;
   i32 = i58 + 20 | 0;
   i33 = i58 + 24 | 0;
   f27 = Math_fround(Math_fround(f14 - f13) * Math_fround(.5));
   f14 = Math_fround(Math_fround(f23 - f15) * Math_fround(.5));
   f13 = Math_fround(Math_fround(f25 - f24) * Math_fround(.5));
   i3 = i58 + 28 | 0;
   i5 = i58 + 32 | 0;
   i6 = i58 + 36 | 0;
   i7 = i60 + 52 | 0;
   i8 = i58 + 40 | 0;
   i9 = i58 + 44 | 0;
   i2 = i1;
   i1 = 0;
   while (1) {
    i2 = i2 + -1 | 0;
    i35 = HEAP32[i4 >> 2] | 0;
    i36 = HEAP32[i4 + 4 >> 2] | 0;
    i37 = HEAP32[i4 + 8 >> 2] | 0;
    f25 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) >> 2]);
    f67 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) + 4 >> 2]);
    f68 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) + 8 >> 2]);
    f69 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f25) + Math_fround(f48 * f67)) + Math_fround(f51 * f68)));
    f70 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f25) + Math_fround(f49 * f67)) + Math_fround(f52 * f68)));
    HEAPF32[i56 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f25) + Math_fround(f47 * f67)) + Math_fround(f50 * f68)));
    HEAPF32[i10 >> 2] = f69;
    HEAPF32[i11 >> 2] = f70;
    f70 = Math_fround(HEAPF32[i34 + (i36 * 12 | 0) >> 2]);
    f69 = Math_fround(HEAPF32[i34 + (i36 * 12 | 0) + 4 >> 2]);
    f68 = Math_fround(HEAPF32[i34 + (i36 * 12 | 0) + 8 >> 2]);
    f67 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f70) + Math_fround(f48 * f69)) + Math_fround(f51 * f68)));
    f25 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f70) + Math_fround(f49 * f69)) + Math_fround(f52 * f68)));
    HEAPF32[i12 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f70) + Math_fround(f47 * f69)) + Math_fround(f50 * f68)));
    HEAPF32[i16 >> 2] = f67;
    HEAPF32[i17 >> 2] = f25;
    f25 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) >> 2]);
    f67 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) + 4 >> 2]);
    f68 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) + 8 >> 2]);
    f69 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f25) + Math_fround(f48 * f67)) + Math_fround(f51 * f68)));
    f70 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f25) + Math_fround(f49 * f67)) + Math_fround(f52 * f68)));
    HEAPF32[i18 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f25) + Math_fround(f47 * f67)) + Math_fround(f50 * f68)));
    HEAPF32[i19 >> 2] = f69;
    HEAPF32[i20 >> 2] = f70;
    HEAP32[i58 >> 2] = 0;
    HEAP32[i21 >> 2] = -1;
    HEAP32[i22 >> 2] = i62;
    HEAP32[i26 >> 2] = i59;
    HEAPF32[i28 >> 2] = f29;
    HEAPF32[i32 >> 2] = f30;
    HEAPF32[i33 >> 2] = f31;
    HEAPF32[i3 >> 2] = f27;
    HEAPF32[i5 >> 2] = f14;
    HEAPF32[i6 >> 2] = f13;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP16[i9 >> 1] = 0;
    __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i58, i56, i12, i18);
    i37 = HEAP32[i58 >> 2] | 0;
    HEAP16[i57 >> 1] = (HEAPU16[i57 >> 1] | 0) + (HEAPU16[i9 >> 1] | 0);
    i1 = i37 + i1 | 0;
    if (!i2) break; else i4 = i4 + 12 | 0;
   }
  }
  HEAP32[i38 + (i39 + 10 << 2) >> 2] = i1;
  i58 = i1;
  i59 = HEAP32[i40 >> 2] | 0;
  i62 = HEAP32[i62 >> 2] | 0;
  i57 = i60 + 20 | 0;
  f68 = Math_fround(HEAPF32[i57 >> 2]);
  i57 = i60 + 24 | 0;
  f69 = Math_fround(HEAPF32[i57 >> 2]);
  i60 = i60 + 28 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i58, i59, i62, i61, f53, f54, f55, f68, f69, f70);
  STACKTOP = i63;
  return;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i62, i2 + i1 | 0);
 i3 = HEAP32[i62 >> 2] | 0;
 i5 = i38 + (i39 + 10 << 2) | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  i58 = 0;
  i59 = HEAP32[i40 >> 2] | 0;
  i62 = HEAP32[i62 >> 2] | 0;
  i57 = i60 + 20 | 0;
  f68 = Math_fround(HEAPF32[i57 >> 2]);
  i57 = i60 + 24 | 0;
  f69 = Math_fround(HEAPF32[i57 >> 2]);
  i60 = i60 + 28 | 0;
  f70 = Math_fround(HEAPF32[i60 >> 2]);
  __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i58, i59, i62, i61, f53, f54, f55, f68, f69, f70);
  STACKTOP = i63;
  return;
 }
 i6 = i59 + 8 | 0;
 i7 = i59 + 4 | 0;
 i3 = i3 + (i2 * 36 | 0) | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i57 = HEAP32[i4 >> 2] | 0;
  i58 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  f31 = Math_fround(HEAPF32[i34 + (i57 * 12 | 0) >> 2]);
  f67 = Math_fround(HEAPF32[i34 + (i57 * 12 | 0) + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i34 + (i57 * 12 | 0) + 8 >> 2]);
  f69 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f31) + Math_fround(f48 * f67)) + Math_fround(f51 * f68)));
  f70 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f31) + Math_fround(f49 * f67)) + Math_fround(f52 * f68)));
  HEAPF32[i3 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f31) + Math_fround(f47 * f67)) + Math_fround(f50 * f68)));
  HEAPF32[i3 + 4 >> 2] = f69;
  HEAPF32[i3 + 8 >> 2] = f70;
  f70 = Math_fround(HEAPF32[i34 + (i58 * 12 | 0) >> 2]);
  f69 = Math_fround(HEAPF32[i34 + (i58 * 12 | 0) + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i34 + (i58 * 12 | 0) + 8 >> 2]);
  f67 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f70) + Math_fround(f48 * f69)) + Math_fround(f51 * f68)));
  f31 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f70) + Math_fround(f49 * f69)) + Math_fround(f52 * f68)));
  HEAPF32[i3 + 12 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f70) + Math_fround(f47 * f69)) + Math_fround(f50 * f68)));
  HEAPF32[i3 + 16 >> 2] = f67;
  HEAPF32[i3 + 20 >> 2] = f31;
  f31 = Math_fround(HEAPF32[i34 + (i2 * 12 | 0) >> 2]);
  f67 = Math_fround(HEAPF32[i34 + (i2 * 12 | 0) + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i34 + (i2 * 12 | 0) + 8 >> 2]);
  f69 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f45 * f31) + Math_fround(f48 * f67)) + Math_fround(f51 * f68)));
  f70 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f46 * f31) + Math_fround(f49 * f67)) + Math_fround(f52 * f68)));
  HEAPF32[i3 + 24 >> 2] = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f44 * f31) + Math_fround(f47 * f67)) + Math_fround(f50 * f68)));
  HEAPF32[i3 + 28 >> 2] = f69;
  HEAPF32[i3 + 32 >> 2] = f70;
  HEAP32[i37 >> 2] = -1;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i59 >> 2] | 0) + (i2 << 2) >> 2] = -1;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i59, i37) | 0;
  if (!i1) break; else {
   i4 = i4 + 12 | 0;
   i3 = i3 + 36 | 0;
  }
 }
 i58 = HEAP32[i5 >> 2] | 0;
 i59 = HEAP32[i40 >> 2] | 0;
 i62 = HEAP32[i62 >> 2] | 0;
 i57 = i60 + 20 | 0;
 f68 = Math_fround(HEAPF32[i57 >> 2]);
 i57 = i60 + 24 | 0;
 f69 = Math_fround(HEAPF32[i57 >> 2]);
 i60 = i60 + 28 | 0;
 f70 = Math_fround(HEAPF32[i60 >> 2]);
 __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i58, i59, i62, i61, f53, f54, f55, f68, f69, f70);
 STACKTOP = i63;
 return;
}

function __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i32, i11, i17) {
 i32 = i32 | 0;
 i11 = i11 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, f34 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i33 + 48 | 0;
 i5 = i33 + 16 | 0;
 i4 = i33 + 8 | 0;
 i3 = i33;
 i13 = i33 + 44 | 0;
 i14 = i33 + 40 | 0;
 i16 = i33 + 36 | 0;
 i21 = i33 + 32 | 0;
 i22 = i33 + 28 | 0;
 i28 = i33 + 24 | 0;
 i29 = i33 + 20 | 0;
 i12 = i32 + 128 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i18 = i32 + 136 | 0;
 if (HEAP32[i18 >> 2] | 0) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 __ZN13RenderTexture15DestroySurfacesEv(i32);
 i27 = __Z12GetGfxDevicev() | 0;
 i30 = i32 + 80 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 if ((i1 | 0) >= 1) {
  i31 = i32 + 84 | 0;
  i2 = HEAP32[i31 >> 2] | 0;
  if ((i2 | 0) >= 1) {
   i19 = i32 + 104 | 0;
   if ((HEAP32[i19 >> 2] | 0) == 4) if (!((i1 | 0) == (i2 | 0) ? (i2 + -1 & i2 | i1 + -1 & i1 | 0) == 0 : 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408071 | 0, 0, gb + 406201 | 0, 333, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   }
   i15 = i32 + 96 | 0;
   i20 = i32 + 100 | 0;
   L15 : do if (!(mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 412 >> 2] | 0, i27 | 0, i1 | 0, i2 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0)) {
    i25 = HEAP32[i30 >> 2] | 0;
    if (!(i25 + -1 & i25)) {
     i25 = HEAP32[i31 >> 2] | 0;
     if (!(i25 + -1 & i25)) {
      if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2] | 0) >= 4) while (1) {
       i24 = (HEAP32[i30 >> 2] | 0) / 2 | 0;
       i24 = (i24 | 0) < 4 ? 4 : i24;
       HEAP32[i30 >> 2] = i24;
       i25 = (HEAP32[i31 >> 2] | 0) / 2 | 0;
       i25 = (i25 | 0) < 4 ? 4 : i25;
       HEAP32[i31 >> 2] = i25;
       if (mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 412 >> 2] | 0, i27 | 0, i24 | 0, i25 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0) break L15;
      }
      HEAP32[i3 >> 2] = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2];
      __Z6FormatPKcz(i26, gb + 408159 | 0, i3);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i26 + 11 >> 0] | 0) < 0 ? HEAP32[i26 >> 2] | 0 : i26, 0, gb + 406201 | 0, 343, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      i32 = 0;
      STACKTOP = i33;
      return i32 | 0;
     }
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408226 | 0, 0, gb + 406201 | 0, 357, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } while (0);
   i25 = HEAP32[i15 >> 2] | 0;
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 233 + i25 >> 0] | 0)) {
    HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
    __Z6FormatPKcz(i26, gb + 408284 | 0, i4);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i26 + 11 >> 0] | 0) < 0 ? HEAP32[i26 >> 2] | 0 : i26, 0, gb + 406201 | 0, 364, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   }
   i10 = i32 + 120 | 0;
   if (HEAP8[i10 >> 0] | 0) {
    i25 = HEAP32[i15 >> 2] | 0;
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 256 + i25 >> 0] | 0)) {
     HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
     __Z6FormatPKcz(i26, gb + 408338 | 0, i5);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i26 + 11 >> 0] | 0) < 0 ? HEAP32[i26 >> 2] | 0 : i26, 0, gb + 406201 | 0, 370, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     i32 = 0;
     STACKTOP = i33;
     return i32 | 0;
    }
   }
   i25 = HEAP32[i30 >> 2] | 0;
   if (!(i25 + -1 & i25)) {
    i25 = HEAP32[i31 >> 2] | 0;
    if (i25 + -1 & i25 | 0) i23 = 23;
   } else i23 = 23;
   if ((i23 | 0) == 23) if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 488 >> 2] | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408410 | 0, 0, gb + 406201 | 0, 376, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   }
   i1 = HEAP32[i19 >> 2] | 0;
   do if ((i1 | 0) == 4) {
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 500 >> 0] | 0) if (!(__Z15IsDepthRTFormat19RenderTextureFormat(HEAP32[i15 >> 2] | 0) | 0)) {
     i1 = HEAP32[i19 >> 2] | 0;
     break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408477 | 0, 0, gb + 406201 | 0, 382, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } while (0);
   do if ((i1 | 0) == 3) {
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0) {
     if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 501 >> 0] | 0) break;
     if (HEAP8[i10 >> 0] | 0) break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408529 | 0, 0, gb + 406201 | 0, 389, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } while (0);
   i1 = HEAP32[i19 >> 2] | 0;
   do if ((i1 | 0) == 5) {
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 482 >> 0] | 0) {
     i1 = HEAP32[i19 >> 2] | 0;
     break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408588 | 0, 0, gb + 406201 | 0, 395, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } while (0);
   if ((i1 | 0) == 6) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 483 >> 0] | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408653 | 0, 0, gb + 406201 | 0, 401, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   }
   i1 = HEAP32[i15 >> 2] | 0;
   if ((i1 | 0) == 1) {
    i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 505 >> 0] | 0) != 0;
    i1 = HEAP32[i15 >> 2] | 0;
   } else i2 = 0;
   if ((i1 | 0) == 3) i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0) != 0; else i1 = 0;
   i8 = i2 | i1;
   if (i8) if (!(HEAP32[i20 >> 2] | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408720 | 0, 0, gb + 406201 | 0, 414, 512, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    HEAP32[i20 >> 2] = 1;
   }
   i1 = (HEAP8[i32 + 116 >> 0] | 0) != 0;
   i1 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 170 >> 0] | 0) != 0;
   if ((HEAP32[i19 >> 2] | 0) == 3) i1 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 534 >> 0] | 0) == 0;
   i25 = HEAP32[i30 >> 2] | 0;
   if (!(i25 + -1 & i25)) {
    i6 = HEAP32[i31 >> 2] | 0;
    i6 = i1 & (i6 + -1 & i6 | 0) == 0;
   } else i6 = 0;
   i1 = HEAP32[i15 >> 2] | 0;
   switch (i1 | 0) {
   case 7:
    {
     i1 = __Z12GetGfxDevicev() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 704 >> 2] | 0, i1 | 0) | 0;
     break;
    }
   case 9:
    {
     i1 = __Z12GetGfxDevicev() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 708 >> 2] | 0, i1 | 0) | 0;
     break;
    }
   default:
    {}
   }
   i2 = HEAP32[i32 + 88 >> 2] | 0;
   i2 = (i2 | 0) < 1 ? 1 : (i2 | 0) > 8 ? 8 : i2;
   i25 = i32 + 118 | 0;
   i3 = HEAP8[i25 >> 0] | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   L92 : do if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) i2 = 1; else {
    i5 = __Z15GetGraphicsCapsv() | 0;
    i5 = HEAP32[(i3 << 24 >> 24 ? i5 + 372 + (i1 << 2) | 0 : i5 + 280 + (i1 << 2) | 0) >> 2] | 0;
    i4 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 464 + (i4 << 2) >> 2] | 0;
    if ((i2 | 0) <= 1) {
     i2 = 1;
     break;
    }
    while (1) {
     i24 = 1 << i2;
     if (!((i24 & i5 | 0) == 0 | (i24 & i4 | 0) == 0)) break L92;
     i3 = i2 >>> 1;
     if (i2 >>> 0 > 3) i2 = i3; else {
      i2 = i3;
      break;
     }
    }
   } while (0);
   i9 = (HEAP32[i19 >> 2] | 0) == 2 ? i2 : 1;
   i7 = (i9 | 0) > 1;
   i24 = i6 & (i7 ^ 1);
   L98 : do if (i8) {
    if ((i9 | 0) < 2) i2 = HEAP32[i32 + 48 >> 2] | 0; else i2 = 0;
    HEAP8[i32 + 156 >> 0] = 0;
    i6 = i2;
    i2 = 0;
    i5 = 0;
   } else {
    do if (i7) {
     if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0) {
      i23 = 67;
      break;
     }
     i2 = HEAP32[i32 + 48 >> 2] | 0;
     i3 = 0;
    } else i23 = 67; while (0);
    if ((i23 | 0) == 67) {
     i2 = 0;
     i3 = HEAP32[i32 + 48 >> 2] | 0;
    }
    do if ((HEAP32[i19 >> 2] | 0) == 2) {
     if (!((i9 | 0) < 2 & (HEAP32[i20 >> 2] | 0) != 0)) break;
     if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0)) break;
     i6 = HEAP32[i32 + 124 >> 2] | 0;
     HEAP8[i32 + 156 >> 0] = 1;
     i5 = i3;
     break L98;
    } while (0);
    HEAP8[i32 + 156 >> 0] = 0;
    i6 = 0;
    i5 = i3;
   } while (0);
   i4 = i24 ? 2 : 0;
   i4 = (HEAP8[i32 + 117 >> 0] | 0) == 0 ? i4 : i4 | 128;
   i4 = (HEAP8[i25 >> 0] | 0) == 0 ? i4 : i4 | 4;
   i4 = (HEAP8[i10 >> 0] | 0) == 0 ? i4 : i4 | 16;
   i4 = (HEAP32[i32 + 112 >> 2] | 0) == 0 ? i4 : i4 | 1024;
   i3 = HEAP32[i11 >> 2] | 0;
   i10 = i32 + 128 | 0;
   if (!i3) {
    i3 = HEAP32[(HEAP32[i27 >> 2] | 0) + 316 >> 2] | 0;
    HEAP32[i14 >> 2] = i5;
    i8 = HEAP32[i30 >> 2] | 0;
    i11 = HEAP32[i31 >> 2] | 0;
    i13 = HEAP32[i32 + 92 >> 2] | 0;
    i23 = HEAP32[i19 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 >> 2] = mftCall_iiiiiiiiii(i3 | 0, i27 | 0, i26 | 0, i8 | 0, i11 | 0, i9 | 0, i13 | 0, i23 | 0, i1 | 0, i4 | 0) | 0;
   } else {
    HEAP32[i13 >> 2] = i5;
    HEAP32[i26 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i10 >> 2] = __ZN9GfxDevice18AliasRenderSurfaceE9TextureIDP17RenderSurfaceBase(i27, i26, i3) | 0;
   }
   do if (i7) {
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0) break;
    i11 = HEAP32[(HEAP32[i27 >> 2] | 0) + 316 >> 2] | 0;
    HEAP32[i16 >> 2] = i2;
    i12 = HEAP32[i30 >> 2] | 0;
    i13 = HEAP32[i31 >> 2] | 0;
    i14 = HEAP32[i32 + 92 >> 2] | 0;
    i23 = HEAP32[i19 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i32 + 132 >> 2] = mftCall_iiiiiiiiii(i11 | 0, i27 | 0, i26 | 0, i12 | 0, i13 | 0, 1, i14 | 0, i23 | 0, i1 | 0, i4 | 0) | 0;
   } while (0);
   if ((HEAP32[i15 >> 2] | 0) == 3) {
    HEAP32[i32 + 108 >> 2] = 0;
    i1 = 8;
   } else i1 = 0;
   i1 = (HEAP8[i32 + 122 >> 0] | 0) == 0 ? i1 : i1 | 32;
   if (!i6) i1 = (HEAP32[i20 >> 2] | 0) == 0 ? i1 | 64 : i1;
   i2 = HEAP32[i17 >> 2] | 0;
   i8 = i32 + 136 | 0;
   if (!i2) {
    i23 = HEAP32[i20 >> 2] | 0;
    i16 = HEAP32[(HEAP32[i27 >> 2] | 0) + 320 >> 2] | 0;
    HEAP32[i22 >> 2] = i6;
    i17 = HEAP32[i30 >> 2] | 0;
    i20 = HEAP32[i31 >> 2] | 0;
    i21 = HEAP32[i19 >> 2] | 0;
    HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
    i1 = mftCall_iiiiiiiii(i16 | 0, i27 | 0, i26 | 0, i17 | 0, i20 | 0, i9 | 0, i21 | 0, i23 | 0, ((i23 | 0) == 0 ? i1 | 4096 : i1) | 0) | 0;
    HEAP32[i18 >> 2] = i1;
   } else {
    HEAP32[i21 >> 2] = i6;
    HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
    i1 = __ZN9GfxDevice18AliasRenderSurfaceE9TextureIDP17RenderSurfaceBase(i27, i26, i2) | 0;
    HEAP32[i8 >> 2] = i1;
   }
   do if (HEAP32[i10 >> 2] | 0) {
    if (!i1) break;
    i6 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 52 >> 2] | 0, i32 | 0) | 0;
    HEAP32[i32 + 140 >> 2] = i6;
    i5 = i27 + 3808 | 0;
    i7 = i5;
    i6 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, i6 | 0, ((i6 | 0) < 0) << 31 >> 31 | 0) | 0;
    i7 = getTempRet0() | 0;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i5 + 4 >> 2] = i7;
    i5 = HEAP32[i32 + 48 >> 2] | 0;
    i7 = i32;
    i6 = HEAP32[gb + 1158372 >> 2] | 0;
    i2 = i6 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    do if (!i1) {
     HEAP32[i26 >> 2] = i2;
     i4 = i2;
     i3 = i2;
    } else {
     while (1) {
      i2 = HEAP32[i1 + 16 >> 2] | 0;
      if (i5 >>> 0 < i2 >>> 0) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i23 = 92;
        break;
       } else i1 = i2;
      } else {
       if (i2 >>> 0 >= i5 >>> 0) {
        i23 = 97;
        break;
       }
       i3 = i1 + 4 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if (!i2) {
        i23 = 96;
        break;
       } else i1 = i2;
      }
     }
     if ((i23 | 0) == 92) {
      HEAP32[i26 >> 2] = i1;
      i4 = i1;
      i3 = i1;
      break;
     } else if ((i23 | 0) == 96) {
      HEAP32[i26 >> 2] = i1;
      i4 = i1;
      break;
     } else if ((i23 | 0) == 97) {
      HEAP32[i26 >> 2] = i1;
      i4 = i1;
      i3 = i26;
      break;
     }
    } while (0);
    if (!(HEAP32[i3 >> 2] | 0)) {
     i1 = __Znwj(24) | 0;
     i2 = i1 + 16 | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i2 + 4 >> 2] = i7;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = i4;
     HEAP32[i3 >> 2] = i1;
     i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     if (i2) {
      HEAP32[i6 >> 2] = i2;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
     i23 = i6 + 8 | 0;
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    }
    if (HEAP8[i32 + 156 >> 0] | 0) {
     i5 = HEAP32[i32 + 124 >> 2] | 0;
     i6 = HEAP32[gb + 1158372 >> 2] | 0;
     i2 = i6 + 4 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     do if (!i1) {
      HEAP32[i26 >> 2] = i2;
      i4 = i2;
      i3 = i2;
     } else {
      while (1) {
       i2 = HEAP32[i1 + 16 >> 2] | 0;
       if (i5 >>> 0 < i2 >>> 0) {
        i2 = HEAP32[i1 >> 2] | 0;
        if (!i2) {
         i23 = 107;
         break;
        } else i1 = i2;
       } else {
        if (i2 >>> 0 >= i5 >>> 0) {
         i23 = 112;
         break;
        }
        i3 = i1 + 4 | 0;
        i2 = HEAP32[i3 >> 2] | 0;
        if (!i2) {
         i23 = 111;
         break;
        } else i1 = i2;
       }
      }
      if ((i23 | 0) == 107) {
       HEAP32[i26 >> 2] = i1;
       i4 = i1;
       i3 = i1;
       break;
      } else if ((i23 | 0) == 111) {
       HEAP32[i26 >> 2] = i1;
       i4 = i1;
       break;
      } else if ((i23 | 0) == 112) {
       HEAP32[i26 >> 2] = i1;
       i4 = i1;
       i3 = i26;
       break;
      }
     } while (0);
     if (!(HEAP32[i3 >> 2] | 0)) {
      i1 = __Znwj(24) | 0;
      i2 = i1 + 16 | 0;
      HEAP32[i2 >> 2] = i5;
      HEAP32[i2 + 4 >> 2] = i7;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i4;
      HEAP32[i3 >> 2] = i1;
      i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
      if (i2) {
       HEAP32[i6 >> 2] = i2;
       i1 = HEAP32[i3 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
      i23 = i6 + 8 | 0;
      HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
     }
    }
    if (HEAP8[i32 + 121 >> 0] | 0) {
     i23 = HEAP32[(HEAP32[i27 >> 2] | 0) + 416 >> 2] | 0;
     HEAP32[i28 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
     mftCall_viiii(i23 | 0, i27 | 0, i26 | 0, 2, -4);
     i28 = HEAP32[(HEAP32[i27 >> 2] | 0) + 416 >> 2] | 0;
     HEAP32[i29 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
     mftCall_viiii(i28 | 0, i27 | 0, i26 | 0, 2, -4);
    }
    i3 = HEAP32[(HEAP32[i27 >> 2] | 0) + 684 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    mftCall_viii(i3 | 0, i27 | 0, i2 | 0, mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0);
    i2 = HEAP32[(HEAP32[i27 >> 2] | 0) + 684 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    mftCall_viii(i2 | 0, i27 | 0, i3 | 0, mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0) | 0);
    __ZN16RenderTextureMap6UpdateEPK17RenderSurfaceBaseP13RenderTexture(HEAP32[i10 >> 2] | 0, i32);
    __ZN16RenderTextureMap6UpdateEPK17RenderSurfaceBaseP13RenderTexture(HEAP32[i8 >> 2] | 0, i32);
    __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i32, HEAPU8[i25 >> 0] | 0);
    i3 = i32 + 76 | 0;
    HEAP32[i3 >> 2] = 1;
    i2 = HEAP32[i30 >> 2] | 0;
    do if (i2 | 0) {
     i1 = HEAP32[i31 >> 2] | 0;
     if (!i1) break;
     f34 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
     HEAPF32[i32 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
     HEAPF32[i32 + 72 >> 2] = f34;
     if (i24) i1 = __Z22CalculateMipMapCount3Diii(i2, i1, 1) | 0; else i1 = 1;
     HEAP32[i3 >> 2] = i1;
    } while (0);
    mftCall_vi(HEAP32[(HEAP32[i32 >> 2] | 0) + 92 >> 2] | 0, i32 | 0);
    i32 = 1;
    STACKTOP = i33;
    return i32 | 0;
   } while (0);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408841 | 0, 0, gb + 406201 | 0, 521, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
   __ZN13RenderTexture15DestroySurfacesEv(i32);
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408005 | 0, 0, gb + 406201 | 0, 327, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
 i32 = 0;
 STACKTOP = i33;
 return i32 | 0;
}

function __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i1, i2, i18) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24;
 L1 : while (1) {
  i15 = i2;
  i21 = i2 + -32 | 0;
  i16 = i2 + -64 | 0;
  i17 = i2 + -8 | 0;
  i19 = i2 + -24 | 0;
  i22 = i2 + -16 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    i4 = i3 >> 5;
    switch (i4 | 0) {
    case 2:
     {
      i20 = 5;
      break L1;
     }
    case 3:
     {
      i20 = 11;
      break L1;
     }
    case 4:
     {
      i20 = 12;
      break L1;
     }
    case 5:
     {
      i20 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i20 = 92;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 992) {
     i20 = 15;
     break L1;
    }
    i7 = (i4 | 0) / 2 | 0;
    i6 = i1 + (i7 << 5) | 0;
    if ((i3 | 0) > 31968) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 << 5) | 0, i6, i6 + (i3 << 5) | 0, i21, i18) | 0;
    } else i3 = __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i1, i6, i21, i18) | 0;
    i13 = i1 + 24 | 0;
    i12 = HEAP32[i13 >> 2] | 0;
    i11 = HEAP32[i1 + (i7 << 5) + 24 >> 2] | 0;
    if ((i12 | 0) == (i11 | 0)) {
     i4 = HEAP32[i1 + 8 >> 2] | 0;
     i5 = HEAP32[i1 + (i7 << 5) + 8 >> 2] | 0;
     if ((i4 | 0) < (i5 | 0)) {
      i4 = i21;
      break;
     }
     if ((i4 | 0) <= (i5 | 0)) {
      i9 = i1 + 16 | 0;
      i5 = HEAP32[i9 + 4 >> 2] | 0;
      i10 = i1 + (i7 << 5) + 16 | 0;
      i8 = HEAP32[i10 + 4 >> 2] | 0;
      if ((i5 | 0) < (i8 | 0) | ((i5 | 0) == (i8 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0)) {
       i4 = i21;
       break;
      }
     }
    } else if ((i12 | 0) < (i11 | 0)) {
     i4 = i21;
     break;
    }
    if ((i1 | 0) != (i16 | 0)) {
     i10 = i1 + (i7 << 5) + 8 | 0;
     i9 = i1 + (i7 << 5) + 16 | 0;
     i8 = i21;
     i4 = i16;
     while (1) {
      i5 = HEAP32[i8 + -8 >> 2] | 0;
      if ((i5 | 0) == (i11 | 0)) {
       i5 = HEAP32[i8 + -24 >> 2] | 0;
       i7 = HEAP32[i10 >> 2] | 0;
       if ((i5 | 0) < (i7 | 0)) {
        i20 = 62;
        break L5;
       }
       if ((i5 | 0) <= (i7 | 0)) {
        i7 = i8 + -16 | 0;
        i25 = HEAP32[i7 + 4 >> 2] | 0;
        i8 = i9;
        i5 = HEAP32[i8 + 4 >> 2] | 0;
        if ((i25 | 0) < (i5 | 0) | ((i25 | 0) == (i5 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0 : 0)) {
         i20 = 62;
         break L5;
        }
       }
      } else if ((i5 | 0) < (i11 | 0)) {
       i20 = 62;
       break L5;
      }
      i5 = i4 + -32 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i8 = i4;
       i4 = i5;
      }
     }
    }
    i5 = i1 + 32 | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    if ((i12 | 0) == (i3 | 0)) {
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i4 = HEAP32[i19 >> 2] | 0;
     if ((i3 | 0) < (i4 | 0)) i3 = i5; else if ((i3 | 0) > (i4 | 0)) i20 = 31; else {
      i14 = i1 + 16 | 0;
      i10 = HEAP32[i14 + 4 >> 2] | 0;
      i25 = i22;
      i11 = HEAP32[i25 + 4 >> 2] | 0;
      if ((i10 | 0) < (i11 | 0) | ((i10 | 0) == (i11 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0)) i3 = i5; else i20 = 31;
     }
    } else if ((i12 | 0) < (i3 | 0)) i3 = i5; else i20 = 31;
    if ((i20 | 0) == 31) {
     i20 = 0;
     if ((i5 | 0) == (i21 | 0)) {
      i20 = 92;
      break L1;
     }
     i6 = i1 + 8 | 0;
     i7 = i1 + 16 | 0;
     i3 = i5;
     while (1) {
      i4 = HEAP32[i3 + 24 >> 2] | 0;
      if ((i12 | 0) == (i4 | 0)) {
       i4 = HEAP32[i6 >> 2] | 0;
       i5 = HEAP32[i3 + 8 >> 2] | 0;
       if ((i4 | 0) < (i5 | 0)) break;
       if ((i4 | 0) <= (i5 | 0)) {
        i14 = i7;
        i10 = HEAP32[i14 + 4 >> 2] | 0;
        i25 = i3 + 16 | 0;
        i11 = HEAP32[i25 + 4 >> 2] | 0;
        if ((i10 | 0) < (i11 | 0) | ((i10 | 0) == (i11 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0)) break;
       }
      } else if ((i12 | 0) < (i4 | 0)) break;
      i3 = i3 + 32 | 0;
      if ((i3 | 0) == (i21 | 0)) {
       i20 = 92;
       break L1;
      }
     }
     HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i23 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i23 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
     HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
     HEAP32[i21 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
     HEAP32[i21 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
     HEAP32[i21 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
     i3 = i3 + 32 | 0;
    }
    if ((i3 | 0) == (i21 | 0)) {
     i20 = 92;
     break L1;
    }
    i9 = i1 + 8 | 0;
    i8 = i1 + 16 | 0;
    i5 = i21;
    i1 = i3;
    while (1) {
     i7 = HEAP32[i13 >> 2] | 0;
     while (1) {
      i3 = HEAP32[i1 + 24 >> 2] | 0;
      if ((i7 | 0) == (i3 | 0)) {
       i3 = HEAP32[i9 >> 2] | 0;
       i4 = HEAP32[i1 + 8 >> 2] | 0;
       if ((i3 | 0) < (i4 | 0)) break;
       if ((i3 | 0) <= (i4 | 0)) {
        i14 = i8;
        i11 = HEAP32[i14 + 4 >> 2] | 0;
        i25 = i1 + 16 | 0;
        i12 = HEAP32[i25 + 4 >> 2] | 0;
        if ((i11 | 0) < (i12 | 0) | ((i11 | 0) == (i12 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0)) break;
       }
      } else if ((i7 | 0) < (i3 | 0)) break;
      i1 = i1 + 32 | 0;
     }
     while (1) {
      i6 = i5;
      i5 = i5 + -32 | 0;
      i3 = HEAP32[i6 + -8 >> 2] | 0;
      if ((i7 | 0) != (i3 | 0)) if ((i7 | 0) < (i3 | 0)) continue; else break;
      i3 = HEAP32[i9 >> 2] | 0;
      i4 = HEAP32[i6 + -24 >> 2] | 0;
      if ((i3 | 0) < (i4 | 0)) continue;
      if ((i3 | 0) > (i4 | 0)) break;
      i14 = i8;
      i11 = HEAP32[i14 + 4 >> 2] | 0;
      i25 = i6 + -16 | 0;
      i12 = HEAP32[i25 + 4 >> 2] | 0;
      if (!((i11 | 0) < (i12 | 0) | ((i11 | 0) == (i12 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0))) break;
     }
     if (i1 >>> 0 >= i5 >>> 0) continue L5;
     HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i23 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
     HEAP32[i23 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
     HEAP32[i5 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
     i1 = i1 + 32 | 0;
    }
   }
   if ((i20 | 0) == 62) {
    i20 = 0;
    HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i23 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i23 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i23 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i23 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i23 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i23 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
    HEAP32[i23 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 32 | 0;
   L71 : do if (i5 >>> 0 < i4 >>> 0) {
    i12 = i6;
    while (1) {
     i9 = HEAP32[i12 + 24 >> 2] | 0;
     i10 = i12 + 8 | 0;
     i11 = i12 + 16 | 0;
     while (1) {
      i6 = HEAP32[i5 + 24 >> 2] | 0;
      if ((i6 | 0) == (i9 | 0)) {
       i6 = HEAP32[i5 + 8 >> 2] | 0;
       i7 = HEAP32[i10 >> 2] | 0;
       if ((i6 | 0) >= (i7 | 0)) {
        if ((i6 | 0) > (i7 | 0)) break;
        i13 = i5 + 16 | 0;
        i7 = HEAP32[i13 + 4 >> 2] | 0;
        i25 = i11;
        i8 = HEAP32[i25 + 4 >> 2] | 0;
        if (!((i7 | 0) < (i8 | 0) | ((i7 | 0) == (i8 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0))) break;
       }
      } else if ((i6 | 0) >= (i9 | 0)) break;
      i5 = i5 + 32 | 0;
     }
     while (1) {
      i8 = i4;
      i4 = i4 + -32 | 0;
      i6 = HEAP32[i8 + -8 >> 2] | 0;
      if ((i6 | 0) != (i9 | 0)) if ((i6 | 0) < (i9 | 0)) break; else continue;
      i6 = HEAP32[i8 + -24 >> 2] | 0;
      i7 = HEAP32[i10 >> 2] | 0;
      if ((i6 | 0) < (i7 | 0)) break;
      if ((i6 | 0) > (i7 | 0)) continue;
      i13 = i8 + -16 | 0;
      i7 = HEAP32[i13 + 4 >> 2] | 0;
      i25 = i11;
      i8 = HEAP32[i25 + 4 >> 2] | 0;
      if ((i7 | 0) < (i8 | 0) | ((i7 | 0) == (i8 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0)) break;
     }
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i12;
      i7 = i5;
      break L71;
     };
     HEAP32[i23 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
     HEAP32[i23 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
     HEAP32[i23 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
     HEAP32[i23 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
     HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
     HEAP32[i4 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
     i12 = (i12 | 0) == (i5 | 0) ? i4 : i12;
     i5 = i5 + 32 | 0;
     i3 = i3 + 1 | 0;
    }
   } else i7 = i5; while (0);
   do if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 + 24 >> 2] | 0;
    i5 = HEAP32[i7 + 24 >> 2] | 0;
    if ((i4 | 0) == (i5 | 0)) {
     i4 = HEAP32[i6 + 8 >> 2] | 0;
     i5 = HEAP32[i7 + 8 >> 2] | 0;
     if ((i4 | 0) >= (i5 | 0)) {
      if ((i4 | 0) > (i5 | 0)) break;
      i13 = i6 + 16 | 0;
      i11 = HEAP32[i13 + 4 >> 2] | 0;
      i25 = i7 + 16 | 0;
      i12 = HEAP32[i25 + 4 >> 2] | 0;
      if (!((i11 | 0) < (i12 | 0) | ((i11 | 0) == (i12 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0))) break;
     }
    } else if ((i4 | 0) >= (i5 | 0)) break;
    HEAP32[i23 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i23 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i23 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i23 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i23 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i23 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i23 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
    HEAP32[i23 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEbT0_S6_T_(i1, i7, i18) | 0;
    i4 = i7 + 32 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEbT0_S6_T_(i4, i2, i18) | 0) {
     i20 = 91;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i25 = i7;
   if ((i25 - i14 | 0) >= (i15 - i25 | 0)) {
    i20 = 90;
    break;
   }
   __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i1, i7, i18);
   i1 = i7 + 32 | 0;
  }
  if ((i20 | 0) == 90) {
   i20 = 0;
   __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i7 + 32 | 0, i2, i18);
   i2 = i7;
   continue;
  } else if ((i20 | 0) == 91) {
   i20 = 0;
   if (i3) {
    i20 = 92;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i20 | 0) == 5) {
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   i2 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    if ((i2 | 0) > (i3 | 0)) {
     STACKTOP = i24;
     return;
    }
    i19 = HEAP32[i22 + 4 >> 2] | 0;
    i25 = i1 + 16 | 0;
    i20 = HEAP32[i25 + 4 >> 2] | 0;
    if (!((i19 | 0) < (i20 | 0) | ((i19 | 0) == (i20 | 0) ? (HEAP32[i22 >> 2] | 0) >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0 : 0))) {
     STACKTOP = i24;
     return;
    }
   }
  } else if ((i2 | 0) >= (i3 | 0)) {
   STACKTOP = i24;
   return;
  };
  HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i23 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i23 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i23 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i23 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
  HEAP32[i21 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
  HEAP32[i21 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
  STACKTOP = i24;
  return;
 } else if ((i20 | 0) == 11) {
  __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i1, i1 + 32 | 0, i21, i18) | 0;
  STACKTOP = i24;
  return;
 } else if ((i20 | 0) == 12) {
  __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i21, i18) | 0;
  STACKTOP = i24;
  return;
 } else if ((i20 | 0) == 13) {
  __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i1 + 96 | 0, i21, i18) | 0;
  STACKTOP = i24;
  return;
 } else if ((i20 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i1, i2, i18);
  STACKTOP = i24;
  return;
 } else if ((i20 | 0) == 92) {
  STACKTOP = i24;
  return;
 }
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i59, i60, i1, i61, i62, i56, i64, i41, i43, i38, i63) {
 i59 = i59 | 0;
 i60 = i60 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 i56 = i56 | 0;
 i64 = i64 | 0;
 i41 = i41 | 0;
 i43 = i43 | 0;
 i38 = i38 | 0;
 i63 = i63 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f57 = f0, f58 = f0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, i73 = 0, i74 = 0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i65 + 460 | 0;
 i36 = i65 + 448 | 0;
 i55 = i65 + 128 | 0;
 i54 = i65 + 272 | 0;
 i52 = i65 + 208 | 0;
 i53 = i65 + 144 | 0;
 i40 = i65 + 432 | 0;
 i42 = i65 + 416 | 0;
 i34 = i65 + 112 | 0;
 i39 = i65 + 408 | 0;
 i15 = i65 + 96 | 0;
 i16 = i65 + 396 | 0;
 i17 = i65 + 80 | 0;
 i47 = i65 + 64 | 0;
 i51 = i65 + 48 | 0;
 i49 = i65 + 384 | 0;
 i50 = i65 + 372 | 0;
 i33 = i65 + 32 | 0;
 i32 = i65 + 360 | 0;
 i44 = i65 + 16 | 0;
 i48 = i65;
 i46 = i65 + 348 | 0;
 i45 = i65 + 336 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i59 + 16 >> 2]);
 i31 = i60 + 16 | 0;
 f58 = Math_fround(HEAPF32[i31 >> 2]);
 f12 = Math_fround(HEAPF32[i59 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i60 + 32 >> 2]);
 f12 = Math_fround((f12 > f3 ? f3 : f12) * Math_fround(.100000001));
 f12 = Math_fround(f12 * f12);
 f3 = Math_fround(f57 + f58);
 i28 = i34 + 4 | 0;
 i29 = i34 + 8 | 0;
 i30 = i34 + 12 | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 i1 = HEAP8[i38 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f25 = Math_fround(HEAPF32[i59 >> 2]);
  f4 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i59 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i60 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f5 = Math_fround(f25 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i60 + 8 >> 2]));
  i27 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i27 ? f5 : Math_fround(1.0);
  f6 = i27 ? f6 : Math_fround(0.0);
  f7 = i27 ? f7 : Math_fround(0.0);
  HEAPF32[i55 >> 2] = f5;
  HEAPF32[i55 + 4 >> 2] = f6;
  HEAPF32[i55 + 8 >> 2] = f7;
  HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i17 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  i27 = i55;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i35 = 6;
 } else {
  i14 = i59 + 96 | 0;
  f4 = Math_fround(HEAPF32[i60 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i60 + 148 >> 2]);
  f4 = Math_fround(f4 - f58);
  f5 = Math_fround(f5 - f58);
  f6 = Math_fround(Math_fround(HEAPF32[i60 + 152 >> 2]) - f58);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f9 = Math_fround(-f6);
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i27 = HEAPU8[i41 + i11 >> 0] | 0;
   HEAP32[i40 + (i11 << 2) >> 2] = i27;
   i26 = HEAPU8[i43 + i11 >> 0] | 0;
   HEAP32[i42 + (i11 << 2) >> 2] = i26;
   i27 = 1 - i27 | 0;
   f70 = Math_fround(HEAPF32[i14 + (i27 << 4) >> 2]);
   f69 = Math_fround(HEAPF32[i14 + (i27 << 4) + 4 >> 2]);
   f68 = Math_fround(HEAPF32[i14 + (i27 << 4) + 8 >> 2]);
   i27 = HEAP32[i14 + (i27 << 4) + 12 >> 2] | 0;
   f67 = HEAP32[gb + 48 + (i26 << 4) >> 2] | 0 ? f4 : f7;
   f66 = HEAP32[gb + 48 + (i26 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f25 = HEAP32[gb + 48 + (i26 << 4) + 8 >> 2] | 0 ? f6 : f9;
   f72 = Math_fround(f69 - f66);
   f71 = Math_fround(f68 - f25);
   HEAPF32[i34 >> 2] = Math_fround(f70 - f67);
   HEAPF32[i28 >> 2] = f72;
   HEAPF32[i29 >> 2] = f71;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   HEAPF32[i52 + (i2 << 4) >> 2] = f70;
   HEAPF32[i52 + (i2 << 4) + 4 >> 2] = f69;
   HEAPF32[i52 + (i2 << 4) + 8 >> 2] = f68;
   HEAP32[i52 + (i2 << 4) + 12 >> 2] = i27;
   HEAPF32[i53 + (i2 << 4) >> 2] = f67;
   HEAPF32[i53 + (i2 << 4) + 4 >> 2] = f66;
   HEAPF32[i53 + (i2 << 4) + 8 >> 2] = f25;
   HEAPF32[i53 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   i27 = i54 + (i2 << 4) | 0;
   HEAP32[i27 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i39 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i15, i54, i52, i53, i40, i42, i34, i39);
  HEAP32[i55 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i55 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i37 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i36 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  if (f4 > f12) {
   i27 = i55;
   i35 = 6;
  }
 }
 do if ((i35 | 0) == 6) {
  i24 = i55 + 4 | 0;
  i26 = i55 + 8 | 0;
  i2 = i59 + 96 | 0;
  i13 = i59 + 100 | 0;
  i14 = i59 + 104 | 0;
  i15 = i59 + 112 | 0;
  i16 = i59 + 116 | 0;
  i18 = i59 + 120 | 0;
  i19 = i60 + 144 | 0;
  i20 = i60 + 148 | 0;
  i21 = i60 + 152 | 0;
  i22 = i59 + 48 | 0;
  i23 = i60 + 48 | 0;
  f8 = f10;
  f25 = f4;
  while (1) {
   HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   f72 = Math_fround(-f5);
   f70 = Math_fround(-f6);
   f66 = Math_fround(-f7);
   i1 = HEAP32[i39 >> 2] | 0;
   f69 = Math_fround(HEAPF32[i2 >> 2]);
   f10 = Math_fround(HEAPF32[i13 >> 2]);
   f9 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f69 * f72) + Math_fround(f10 * f70)) + Math_fround(f9 * f66));
   f67 = Math_fround(HEAPF32[i15 >> 2]);
   f71 = Math_fround(HEAPF32[i16 >> 2]);
   f68 = Math_fround(HEAPF32[i18 >> 2]);
   i74 = f4 > Math_fround(Math_fround(Math_fround(f67 * f72) + Math_fround(f71 * f70)) + Math_fround(f68 * f66));
   HEAP32[i40 + (i1 << 2) >> 2] = i74 & 1;
   f67 = i74 ? f69 : f67;
   f71 = i74 ? f10 : f71;
   f68 = i74 ? f9 : f68;
   HEAPF32[i52 + (i1 << 4) >> 2] = f67;
   HEAPF32[i52 + (i1 << 4) + 4 >> 2] = f71;
   HEAPF32[i52 + (i1 << 4) + 8 >> 2] = f68;
   HEAPF32[i52 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f9 = Math_fround(HEAPF32[i19 >> 2]);
   f10 = Math_fround(HEAPF32[i20 >> 2]);
   f69 = Math_fround(HEAPF32[i21 >> 2]);
   f66 = Math_fround(HEAPF32[i31 >> 2]);
   f9 = Math_fround(f9 - f66);
   f10 = Math_fround(f10 - f66);
   f66 = Math_fround(f69 - f66);
   i74 = f5 > Math_fround(0.0);
   i73 = f6 > Math_fround(0.0);
   i11 = f7 > Math_fround(0.0);
   HEAP32[i42 + (i1 << 2) >> 2] = i73 << 31 >> 31 << 1 & 2 | i74 & 1 | i11 << 31 >> 31 << 2 & 4;
   f69 = Math_fround(-f9);
   f70 = Math_fround(-f10);
   f72 = Math_fround(-f66);
   f69 = i74 ? f9 : f69;
   f70 = i73 ? f10 : f70;
   f72 = i11 ? f66 : f72;
   HEAPF32[i53 + (i1 << 4) >> 2] = f69;
   HEAPF32[i53 + (i1 << 4) + 4 >> 2] = f70;
   HEAPF32[i53 + (i1 << 4) + 8 >> 2] = f72;
   HEAPF32[i53 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f69 = Math_fround(f67 - f69);
   f70 = Math_fround(f71 - f70);
   f72 = Math_fround(f68 - f72);
   HEAPF32[i34 >> 2] = f69;
   HEAPF32[i28 >> 2] = f70;
   HEAPF32[i29 >> 2] = f72;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i11 = i54 + (i1 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   f68 = Math_fround(HEAPF32[i22 >> 2]);
   f71 = Math_fround(HEAPF32[i23 >> 2]);
   f71 = f68 > f71 ? f68 : f71;
   f8 = f8 > f71 ? f8 : f71;
   f71 = Math_fround(f3 + f8);
   f72 = Math_fround(Math_fround(Math_fround(f5 * f69) + Math_fround(f6 * f70)) + Math_fround(f7 * f72));
   i11 = f72 > Math_fround(0.0) ? Math_fround(f72 * f72) > Math_fround(f25 * Math_fround(f71 * f71)) : 0;
   if (Math_fround(f25 * Math_fround(.00039999999)) >= Math_fround(f25 - f72) | i11) {
    f4 = f25;
    i35 = 8;
    break;
   }
   HEAP32[i39 >> 2] = i1 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i33, i54, i52, i53, i40, i42, i34, i39);
   HEAP32[i27 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i55 >> 2]);
   f6 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i37 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
   i1 = f25 > f4;
   if (!(f4 > f12 & i1)) break; else f25 = f4;
  }
  if ((i35 | 0) == 8) {
   i2 = i1 + -1 | 0;
   if (i41 | 0) {
    HEAP8[i38 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
      HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i74 = 0;
    STACKTOP = i65;
    return i74 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f4)));
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(Math_fround(1.0) / f10);
   f8 = Math_fround(f8 * f7);
   f9 = Math_fround(f9 * f7);
   f7 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f7);
   HEAPF32[i56 >> 2] = f8;
   HEAPF32[i56 + 4 >> 2] = f9;
   HEAPF32[i56 + 8 >> 2] = f7;
   HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i47, i51, HEAP32[i39 >> 2] | 0);
   f5 = Math_fround(HEAPF32[i47 >> 2]);
   f6 = Math_fround(HEAPF32[i47 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i47 + 8 >> 2]);
   if (i63) {
    f71 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
    f68 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
    f72 = Math_fround(f71 + f68);
    f70 = Math_fround(f6 - Math_fround(f9 * f71));
    f69 = Math_fround(f4 - Math_fround(f7 * f71));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f8 * f71));
    HEAPF32[i61 + 4 >> 2] = f70;
    HEAPF32[i61 + 8 >> 2] = f69;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f69 = Math_fround(HEAPF32[i51 >> 2]);
    f70 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f70 = Math_fround(Math_fround(f9 * f68) + f70);
    f71 = Math_fround(Math_fround(f7 * f68) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f8 * f68) + f69);
    HEAPF32[i62 + 4 >> 2] = f70;
    HEAPF32[i62 + 8 >> 2] = f71;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f72);
    i74 = i64 + 4 | 0;
    HEAP32[i74 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i74 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i74 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    i74 = 1;
    STACKTOP = i65;
    return i74 | 0;
   } else {
    f71 = Math_fround(f6 - Math_fround(f57 * f9));
    f70 = Math_fround(f4 - Math_fround(f57 * f7));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f8));
    HEAPF32[i61 + 4 >> 2] = f71;
    HEAPF32[i61 + 8 >> 2] = f70;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f70 = Math_fround(HEAPF32[i51 >> 2]);
    f71 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f71 = Math_fround(Math_fround(f58 * f9) + f71);
    f72 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f8) + f70);
    HEAPF32[i62 + 4 >> 2] = f71;
    HEAPF32[i62 + 8 >> 2] = f72;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f3);
    i74 = i64 + 4 | 0;
    HEAP32[i74 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i74 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
    HEAP32[i74 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
    i74 = 1;
    STACKTOP = i65;
    return i74 | 0;
   }
  }
  if (i1) {
   if (!i41) i1 = 6; else break;
   STACKTOP = i65;
   return i1 | 0;
  };
  HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  i11 = HEAP32[i39 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i41 | 0) {
   HEAP8[i38 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
     HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i27 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i44, i48, i11);
  HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f25)));
  f9 = Math_fround(HEAPF32[i55 >> 2]);
  f10 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i55 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i44 >> 2]);
  f6 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  if (i63) {
   f72 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
   f69 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
   f3 = Math_fround(f72 + f69);
   f71 = Math_fround(f6 - Math_fround(f10 * f72));
   f70 = Math_fround(f4 - Math_fround(f7 * f72));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f9 * f72));
   HEAPF32[i61 + 4 >> 2] = f71;
   HEAPF32[i61 + 8 >> 2] = f70;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f70 = Math_fround(HEAPF32[i48 >> 2]);
   f71 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f71 = Math_fround(Math_fround(f10 * f69) + f71);
   f72 = Math_fround(Math_fround(f7 * f69) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f9 * f69) + f70);
   HEAPF32[i62 + 4 >> 2] = f71;
   HEAPF32[i62 + 8 >> 2] = f72;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i74 = i64 + 4 | 0;
   HEAP32[i74 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i74 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i74 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  } else {
   f71 = Math_fround(f6 - Math_fround(f57 * f10));
   f70 = Math_fround(f4 - Math_fround(f57 * f7));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f9));
   HEAPF32[i61 + 4 >> 2] = f71;
   HEAPF32[i61 + 8 >> 2] = f70;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f70 = Math_fround(HEAPF32[i48 >> 2]);
   f71 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f71 = Math_fround(Math_fround(f58 * f10) + f71);
   f72 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f9) + f70);
   HEAPF32[i62 + 4 >> 2] = f71;
   HEAPF32[i62 + 8 >> 2] = f72;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i74 = i64 + 4 | 0;
   HEAP32[i74 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i74 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i74 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  }
  HEAPF32[i64 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i56 >> 2] = f9;
  HEAPF32[i56 + 4 >> 2] = f10;
  HEAPF32[i56 + 8 >> 2] = f7;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  i74 = f12 >= f25 ? 1 : 3;
  STACKTOP = i65;
  return i74 | 0;
 } while (0);
 i2 = HEAP32[i39 >> 2] | 0;
 HEAP8[i38 >> 0] = i2;
 if (!i2) {
  i74 = 6;
  STACKTOP = i65;
  return i74 | 0;
 } else i1 = 0;
 do {
  HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
  HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i65;
 return i1 | 0;
}

function __ZN5physx21PxcArticulationHelper12updateBodiesERKNS_25PxcArticulationSolverDescEf(i1, f27) {
 i1 = i1 | 0;
 f27 = Math_fround(f27);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i36;
 i25 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i1 + 24 >> 2] | 0;
 i33 = HEAP32[i1 + 4 >> 2] | 0;
 i34 = HEAP32[i1 + 12 >> 2] | 0;
 i35 = HEAP32[i1 + 8 >> 2] | 0;
 i20 = HEAP16[i25 + 8 >> 1] | 0;
 __ZN5physx18PxcFsFlushVelocityERNS_9PxcFsDataE(i25);
 i31 = i25 + 128 | 0;
 __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE(i26, i25, i31);
 __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE(i25, i31, i26);
 i30 = HEAP32[i1 + 28 >> 2] | 0;
 i32 = i20 & 65535;
 i18 = HEAPU16[i1 + 36 >> 1] | 0;
 i17 = i18 << 5;
 i29 = i20 << 16 >> 16 == 0;
 if (!i29) {
  i16 = 0;
  do {
   i1 = i34 + (i16 * 28 | 0) | 0;
   HEAP32[i30 + (i16 * 28 | 0) >> 2] = HEAP32[i1 >> 2];
   i9 = i34 + (i16 * 28 | 0) + 4 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 4 >> 2] = HEAP32[i9 >> 2];
   i10 = i34 + (i16 * 28 | 0) + 8 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 8 >> 2] = HEAP32[i10 >> 2];
   i11 = i34 + (i16 * 28 | 0) + 12 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 12 >> 2] = HEAP32[i11 >> 2];
   i12 = i34 + (i16 * 28 | 0) + 16 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 16 >> 2] = HEAP32[i12 >> 2];
   i13 = i34 + (i16 * 28 | 0) + 20 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 20 >> 2] = HEAP32[i13 >> 2];
   i14 = i34 + (i16 * 28 | 0) + 24 | 0;
   HEAP32[i30 + (i16 * 28 | 0) + 24 >> 2] = HEAP32[i14 >> 2];
   f7 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) >> 2]) * f27);
   f8 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) + 4 >> 2]) * f27);
   f15 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) + 8 >> 2]) * f27);
   f7 = Math_fround(f7 + Math_fround(HEAPF32[i34 + (i16 * 28 | 0) + 16 >> 2]));
   f8 = Math_fround(f8 + Math_fround(HEAPF32[i13 >> 2]));
   f15 = Math_fround(f15 + Math_fround(HEAPF32[i14 >> 2]));
   f6 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) + 16 >> 2]) * f27);
   f4 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) + 20 >> 2]) * f27);
   f2 = Math_fround(Math_fround(HEAPF32[i35 + (i16 << 5) + 24 >> 2]) * f27);
   f3 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4)) + Math_fround(f2 * f2));
   if (+f3 < 1.0e-24) {
    f5 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f2 = Math_fround(0.0);
    f3 = Math_fround(1.0);
   } else {
    f3 = Math_fround(Math_sqrt(Math_fround(f3)));
    f24 = Math_fround(Math_fround(1.0) / f3);
    f3 = Math_fround(f3 * Math_fround(.5));
    f37 = Math_fround(+Math_sin(+f3));
    f5 = Math_fround(f37 * Math_fround(f2 * f24));
    f4 = Math_fround(f37 * Math_fround(f4 * f24));
    f2 = Math_fround(f37 * Math_fround(f6 * f24));
    f3 = Math_fround(+Math_cos(+f3));
   }
   f40 = Math_fround(HEAPF32[i1 >> 2]);
   f39 = Math_fround(f3 * f40);
   f41 = Math_fround(HEAPF32[i11 >> 2]);
   f39 = Math_fround(f39 + Math_fround(f2 * f41));
   f37 = Math_fround(HEAPF32[i10 >> 2]);
   f39 = Math_fround(f39 + Math_fround(f4 * f37));
   f38 = Math_fround(HEAPF32[i9 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f5 * f40) + Math_fround(Math_fround(f4 * f41) + Math_fround(f3 * f38))) - Math_fround(f2 * f37));
   f24 = Math_fround(Math_fround(Math_fround(f2 * f38) + Math_fround(Math_fround(f5 * f41) + Math_fround(f3 * f37))) - Math_fround(f4 * f40));
   f37 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f41) - Math_fround(f2 * f40)) - Math_fround(f4 * f38)) - Math_fround(f5 * f37));
   HEAPF32[i1 >> 2] = Math_fround(f39 - Math_fround(f5 * f38));
   HEAPF32[i9 >> 2] = f6;
   HEAPF32[i10 >> 2] = f24;
   HEAPF32[i11 >> 2] = f37;
   HEAPF32[i12 >> 2] = f7;
   HEAPF32[i13 >> 2] = f8;
   HEAPF32[i14 >> 2] = f15;
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i32 | 0));
 }
 f24 = Math_fround(Math_fround(1.0) / f27);
 i23 = i30 + i17 | 0;
 i21 = i30 + (i18 * 176 | 0) | 0;
 i22 = i19 + 16 | 0;
 i19 = i19 + 8 | 0;
 do if (HEAP32[i19 >> 2] | 0) {
  i12 = (i20 & 65535) > 1;
  i13 = i32 * 144 | 0;
  i14 = i33 + 20 | 0;
  i16 = i25 + 24 | 0;
  i17 = i32 << 5;
  i18 = 0;
  i9 = 0;
  while (1) {
   if (i12) {
    i1 = 1;
    f2 = Math_fround(-3402823469999999843913219.0e14);
    do {
     i20 = HEAP32[i33 + (i1 << 5) + 24 >> 2] | 0;
     i11 = HEAP32[i33 + (i1 << 5) + 28 >> 2] | 0;
     f43 = Math_fround(Math_fround(HEAPF32[i20 + 16 >> 2]) * Math_fround(2.0));
     f42 = Math_fround(Math_fround(HEAPF32[i20 + 20 >> 2]) * Math_fround(2.0));
     f7 = Math_fround(Math_fround(HEAPF32[i20 + 24 >> 2]) * Math_fround(2.0));
     f5 = Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 12 >> 2]);
     f39 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
     f3 = Math_fround(HEAPF32[i34 + (i11 * 28 | 0) >> 2]);
     f38 = Math_fround(f43 * f3);
     f4 = Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 4 >> 2]);
     f38 = Math_fround(f38 + Math_fround(f42 * f4));
     f6 = Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 8 >> 2]);
     f38 = Math_fround(f38 + Math_fround(f7 * f6));
     f15 = Math_fround(Math_fround(f3 * f38) + Math_fround(Math_fround(f43 * f39) + Math_fround(f5 * Math_fround(Math_fround(f7 * f4) - Math_fround(f42 * f6)))));
     f37 = Math_fround(Math_fround(f4 * f38) + Math_fround(Math_fround(f42 * f39) + Math_fround(f5 * Math_fround(Math_fround(f43 * f6) - Math_fround(f7 * f3)))));
     f38 = Math_fround(Math_fround(Math_fround(f7 * f39) + Math_fround(f5 * Math_fround(Math_fround(f42 * f3) - Math_fround(f43 * f4)))) + Math_fround(f6 * f38));
     f15 = Math_fround(Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 16 >> 2]) + f15);
     f37 = Math_fround(Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 20 >> 2]) + f37);
     f38 = Math_fround(Math_fround(HEAPF32[i34 + (i11 * 28 | 0) + 24 >> 2]) + f38);
     f6 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
     f4 = Math_fround(Math_fround(HEAPF32[i20 + 48 >> 2]) * Math_fround(2.0));
     f43 = Math_fround(Math_fround(HEAPF32[i20 + 52 >> 2]) * Math_fround(2.0));
     f3 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 12 >> 2]);
     f42 = Math_fround(Math_fround(f3 * f3) + Math_fround(-.5));
     f5 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) >> 2]);
     f39 = Math_fround(f6 * f5);
     f7 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 4 >> 2]);
     f39 = Math_fround(f39 + Math_fround(f4 * f7));
     f8 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 8 >> 2]);
     f39 = Math_fround(f39 + Math_fround(f43 * f8));
     f40 = Math_fround(Math_fround(f5 * f39) + Math_fround(Math_fround(f6 * f42) + Math_fround(f3 * Math_fround(Math_fround(f43 * f7) - Math_fround(f4 * f8)))));
     f41 = Math_fround(Math_fround(f7 * f39) + Math_fround(Math_fround(f4 * f42) + Math_fround(f3 * Math_fround(Math_fround(f6 * f8) - Math_fround(f43 * f5)))));
     f39 = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f3 * Math_fround(Math_fround(f4 * f5) - Math_fround(f6 * f7)))) + Math_fround(f8 * f39));
     f40 = Math_fround(Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 16 >> 2]) + f40);
     f41 = Math_fround(Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 20 >> 2]) + f41);
     f40 = Math_fround(f15 - f40);
     f41 = Math_fround(f37 - f41);
     f39 = Math_fround(f38 - Math_fround(Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 24 >> 2]) + f39));
     f41 = Math_fround(Math_sqrt(Math_fround(Math_fround(f39 * f39) + Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41)))));
     f2 = f2 > f41 ? f2 : f41;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i32 | 0));
   } else f2 = Math_fround(-3402823469999999843913219.0e14);
   if (f2 <= Math_fround(HEAPF32[i22 >> 2])) {
    i28 = 19;
    break;
   }
   _memset(i23 | 0, 0, i13 | 0) | 0;
   __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE(i23, HEAP32[i14 >> 2] | 0, i34);
   if (i12) {
    i1 = 1;
    do {
     i20 = i34 + (i1 * 28 | 0) | 0;
     __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE(i23 + (i1 * 144 | 0) | 0, HEAP32[i33 + (i1 << 5) + 20 >> 2] | 0, i20);
     __ZN5physx21PxcArticulationHelper18setJointTransformsERNS_30PxcArticulationJointTransformsERKNS_11PxTransformES5_RKNS_24PxsArticulationJointCoreE(i21 + (i1 * 84 | 0) | 0, i34 + ((HEAP32[i33 + (i1 << 5) + 28 >> 2] | 0) * 28 | 0) | 0, i20, HEAP32[i33 + (i1 << 5) + 24 >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i32 | 0));
   }
   __ZN5physx21PxcArticulationHelper16prepareLtbMatrixERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEf(i25, i23, i34, i21, f24);
   __ZN5physx12PxcLtbFactorERNS_9PxcFsDataE(i25);
   i1 = i25 + (HEAPU16[i16 >> 1] | 0) | 0;
   if (i12) {
    i9 = 1;
    do {
     i20 = i26 + (i9 << 4) | 0;
     i11 = i1 + (i9 * 400 | 0) + 384 | 0;
     HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i32 | 0));
   }
   _memset(i35 | 0, 0, i17 | 0) | 0;
   __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE(i25, i35, i26);
   if (!i29) {
    i11 = 0;
    do {
     f7 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) >> 2]) * f27);
     f8 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) + 4 >> 2]) * f27);
     f15 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) + 8 >> 2]) * f27);
     i1 = i34 + (i11 * 28 | 0) + 16 | 0;
     f7 = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
     i9 = i34 + (i11 * 28 | 0) + 20 | 0;
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i9 >> 2]));
     i10 = i34 + (i11 * 28 | 0) + 24 | 0;
     f15 = Math_fround(f15 + Math_fround(HEAPF32[i10 >> 2]));
     f6 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) + 16 >> 2]) * f27);
     f4 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) + 20 >> 2]) * f27);
     f2 = Math_fround(Math_fround(HEAPF32[i35 + (i11 << 5) + 24 >> 2]) * f27);
     f3 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4)) + Math_fround(f2 * f2));
     if (+f3 < 1.0e-24) {
      f5 = Math_fround(0.0);
      f4 = Math_fround(0.0);
      f2 = Math_fround(0.0);
      f3 = Math_fround(1.0);
     } else {
      f3 = Math_fround(Math_sqrt(Math_fround(f3)));
      f43 = Math_fround(Math_fround(1.0) / f3);
      f3 = Math_fround(f3 * Math_fround(.5));
      f42 = Math_fround(+Math_sin(+f3));
      f5 = Math_fround(f42 * Math_fround(f2 * f43));
      f4 = Math_fround(f42 * Math_fround(f4 * f43));
      f2 = Math_fround(f42 * Math_fround(f6 * f43));
      f3 = Math_fround(+Math_cos(+f3));
     }
     i46 = i34 + (i11 * 28 | 0) | 0;
     f38 = Math_fround(HEAPF32[i46 >> 2]);
     f39 = Math_fround(f3 * f38);
     i20 = i34 + (i11 * 28 | 0) + 12 | 0;
     f37 = Math_fround(HEAPF32[i20 >> 2]);
     f39 = Math_fround(f39 + Math_fround(f2 * f37));
     i44 = i34 + (i11 * 28 | 0) + 8 | 0;
     f43 = Math_fround(HEAPF32[i44 >> 2]);
     f39 = Math_fround(f39 + Math_fround(f4 * f43));
     i45 = i34 + (i11 * 28 | 0) + 4 | 0;
     f40 = Math_fround(HEAPF32[i45 >> 2]);
     f41 = Math_fround(Math_fround(Math_fround(f5 * f38) + Math_fround(Math_fround(f4 * f37) + Math_fround(f3 * f40))) - Math_fround(f2 * f43));
     f42 = Math_fround(Math_fround(Math_fround(f2 * f40) + Math_fround(Math_fround(f5 * f37) + Math_fround(f3 * f43))) - Math_fround(f4 * f38));
     f43 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f37) - Math_fround(f2 * f38)) - Math_fround(f4 * f40)) - Math_fround(f5 * f43));
     HEAPF32[i46 >> 2] = Math_fround(f39 - Math_fround(f5 * f40));
     HEAPF32[i45 >> 2] = f41;
     HEAPF32[i44 >> 2] = f42;
     HEAPF32[i20 >> 2] = f43;
     HEAPF32[i1 >> 2] = f7;
     HEAPF32[i9 >> 2] = f8;
     HEAPF32[i10 >> 2] = f15;
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i32 | 0));
   }
   i18 = i18 + 1 | 0;
   if (i18 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) break; else i9 = 1;
  }
  if ((i28 | 0) == 19) if (!i9) break;
  if (i29) {
   STACKTOP = i36;
   return;
  } else i1 = 0;
  do {
   f2 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 16 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 16 >> 2]));
   f5 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 20 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 20 >> 2]));
   f42 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 24 >> 2]);
   f5 = Math_fround(f24 * f5);
   f42 = Math_fround(f24 * Math_fround(f42 - Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 24 >> 2])));
   HEAPF32[i35 + (i1 << 5) >> 2] = Math_fround(f24 * f2);
   HEAPF32[i35 + (i1 << 5) + 4 >> 2] = f5;
   HEAPF32[i35 + (i1 << 5) + 8 >> 2] = f42;
   HEAPF32[i35 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
   f42 = Math_fround(-Math_fround(HEAPF32[i30 + (i1 * 28 | 0) >> 2]));
   f5 = Math_fround(-Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 4 >> 2]));
   f2 = Math_fround(-Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 8 >> 2]));
   f39 = Math_fround(HEAPF32[i30 + (i1 * 28 | 0) + 12 >> 2]);
   f40 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 12 >> 2]);
   f7 = Math_fround(f40 * f42);
   f41 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) >> 2]);
   f7 = Math_fround(f7 + Math_fround(f39 * f41));
   f43 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 4 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f43 * f2));
   f4 = Math_fround(HEAPF32[i34 + (i1 * 28 | 0) + 8 >> 2]);
   f7 = Math_fround(f7 - Math_fround(f4 * f5));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f5) + Math_fround(f39 * f43)) + Math_fround(f4 * f42)) - Math_fround(f41 * f2));
   f3 = Math_fround(Math_fround(Math_fround(f41 * f5) + Math_fround(Math_fround(f40 * f2) + Math_fround(f39 * f4))) - Math_fround(f43 * f42));
   f2 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f41 * f42)) - Math_fround(f43 * f5)) - Math_fround(f4 * f2));
   f4 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f3 * f3));
   f5 = Math_fround(Math_sqrt(Math_fround(f4)));
   if (+f5 < 1.0e-12) {
    f4 = Math_fround(0.0);
    f3 = Math_fround(0.0);
    f2 = Math_fround(0.0);
   } else {
    if (f2 < Math_fround(0.0)) f8 = Math_fround(+Math_atan2(+Math_fround(-f5), +Math_fround(-f2))); else f8 = Math_fround(+Math_atan2(+f5, +f2));
    if (f4 > Math_fround(0.0)) {
     f2 = Math_fround(Math_fround(1.0) / f5);
     f5 = Math_fround(Math_fround(f3 * f2) * Math_fround(2.0));
     f3 = Math_fround(Math_fround(f6 * f2) * Math_fround(2.0));
     f2 = Math_fround(Math_fround(f7 * f2) * Math_fround(2.0));
    } else {
     f5 = Math_fround(0.0);
     f3 = Math_fround(0.0);
     f2 = Math_fround(0.0);
    }
    f4 = Math_fround(f8 * f2);
    f3 = Math_fround(f8 * f3);
    f2 = Math_fround(f8 * f5);
   }
   f42 = Math_fround(f24 * f3);
   f43 = Math_fround(f24 * f2);
   HEAPF32[i35 + (i1 << 5) + 16 >> 2] = Math_fround(f24 * f4);
   HEAPF32[i35 + (i1 << 5) + 20 >> 2] = f42;
   HEAPF32[i35 + (i1 << 5) + 24 >> 2] = f43;
   HEAPF32[i35 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i32 | 0));
 } while (0);
 if (i29) {
  STACKTOP = i36;
  return;
 } else i1 = 0;
 do {
  i45 = HEAP32[i33 + (i1 << 5) + 20 >> 2] | 0;
  HEAP32[i45 >> 2] = HEAP32[i34 + (i1 * 28 | 0) >> 2];
  HEAP32[i45 + 4 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 4 >> 2];
  HEAP32[i45 + 8 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 8 >> 2];
  HEAP32[i45 + 12 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 12 >> 2];
  HEAP32[i45 + 16 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 16 >> 2];
  HEAP32[i45 + 20 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 20 >> 2];
  HEAP32[i45 + 24 >> 2] = HEAP32[i34 + (i1 * 28 | 0) + 24 >> 2];
  i44 = HEAP32[i31 + (i1 << 5) + 4 >> 2] | 0;
  i46 = HEAP32[i31 + (i1 << 5) + 8 >> 2] | 0;
  HEAP32[i45 + 64 >> 2] = HEAP32[i31 + (i1 << 5) >> 2];
  HEAP32[i45 + 68 >> 2] = i44;
  HEAP32[i45 + 72 >> 2] = i46;
  i46 = HEAP32[i31 + (i1 << 5) + 20 >> 2] | 0;
  i44 = HEAP32[i31 + (i1 << 5) + 24 >> 2] | 0;
  HEAP32[i45 + 80 >> 2] = HEAP32[i31 + (i1 << 5) + 16 >> 2];
  HEAP32[i45 + 84 >> 2] = i46;
  HEAP32[i45 + 88 >> 2] = i44;
  i45 = HEAP32[i35 + (i1 << 5) + 4 >> 2] | 0;
  i44 = HEAP32[i35 + (i1 << 5) + 8 >> 2] | 0;
  i46 = HEAP32[i33 + (i1 << 5) + 16 >> 2] | 0;
  HEAP32[i46 >> 2] = HEAP32[i35 + (i1 << 5) >> 2];
  HEAP32[i46 + 4 >> 2] = i45;
  HEAP32[i46 + 8 >> 2] = i44;
  i44 = HEAP32[i35 + (i1 << 5) + 20 >> 2] | 0;
  i45 = HEAP32[i35 + (i1 << 5) + 24 >> 2] | 0;
  HEAP32[i46 + 16 >> 2] = HEAP32[i35 + (i1 << 5) + 16 >> 2];
  HEAP32[i46 + 20 >> 2] = i44;
  HEAP32[i46 + 24 >> 2] = i45;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i32 | 0));
 STACKTOP = i36;
 return;
}

function __ZN21WorldParticleCollider22UpdateParticleColliderERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i54, i55, i57, f58) {
 i54 = i54 | 0;
 i55 = i55 | 0;
 i57 = i57 | 0;
 f58 = Math_fround(f58);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f56 = f0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, i77 = 0, i78 = 0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i63 + 152 | 0;
 i60 = i63 + 88 | 0;
 i61 = i63 + 44 | 0;
 i53 = i63;
 i62 = i55 + 4 | 0;
 i3 = HEAP32[i55 >> 2] | 0;
 i1 = (HEAP32[i62 >> 2] | 0) - i3 | 0;
 i2 = (i1 | 0) / 48 | 0;
 f56 = Math_fround(HEAPF32[i54 + 32 >> 2]);
 f56 = Math_fround(f56 * f56);
 if (!(HEAP8[i57 + 36 >> 0] | 0)) {
  i52 = i54 + 28 | 0;
  __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i60, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i52 >> 2] | 0, gb + 28940 | 0) | 0);
  if ((i1 | 0) > 0) {
   i22 = i60 + 16 | 0;
   i23 = i60 + 32 | 0;
   i24 = i60 + 4 | 0;
   i25 = i60 + 20 | 0;
   i26 = i60 + 36 | 0;
   i27 = i60 + 8 | 0;
   i28 = i60 + 24 | 0;
   i29 = i60 + 40 | 0;
   i30 = i60 + 48 | 0;
   i31 = i60 + 52 | 0;
   i32 = i60 + 56 | 0;
   i18 = i61 + 4 | 0;
   i20 = i61 + 8 | 0;
   f21 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i16 = i61 + 12 | 0;
   i17 = i61 + 16 | 0;
   i19 = i61 + 20 | 0;
   i33 = i54 + 44 | 0;
   i34 = i54 + 36 | 0;
   i35 = i53 + 12 | 0;
   i36 = i53 + 16 | 0;
   i37 = i53 + 20 | 0;
   i38 = i53 + 4 | 0;
   i39 = i53 + 8 | 0;
   i40 = i54 + 48 | 0;
   i41 = i54 + 40 | 0;
   i42 = i57 + 4 | 0;
   i43 = i57 + 8 | 0;
   i44 = i57 + 12 | 0;
   i45 = i57 + 16 | 0;
   i46 = i57 + 20 | 0;
   i47 = i53 + 40 | 0;
   i48 = i59 + 8 | 0;
   i49 = i59 + 4 | 0;
   i50 = i59 + 8 | 0;
   i51 = i59 + 4 | 0;
   i1 = 0;
   do {
    i15 = HEAP32[i55 >> 2] | 0;
    f4 = Math_fround(HEAPF32[i15 + (i1 * 48 | 0) + 24 >> 2]);
    f8 = Math_fround(f4 * Math_fround(.50999999));
    i9 = i15 + (i1 * 48 | 0) + 12 | 0;
    f66 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f58);
    i10 = i15 + (i1 * 48 | 0) + 16 | 0;
    f69 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f58);
    i12 = i15 + (i1 * 48 | 0) + 20 | 0;
    f7 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f58);
    f11 = Math_fround(HEAPF32[i60 >> 2]);
    f5 = Math_fround(f66 * f11);
    f73 = Math_fround(HEAPF32[i22 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f69 * f73));
    f65 = Math_fround(HEAPF32[i23 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f7 * f65));
    f72 = Math_fround(HEAPF32[i24 >> 2]);
    f6 = Math_fround(f66 * f72);
    f71 = Math_fround(HEAPF32[i25 >> 2]);
    f6 = Math_fround(f6 + Math_fround(f69 * f71));
    f64 = Math_fround(HEAPF32[i26 >> 2]);
    f6 = Math_fround(f6 + Math_fround(f7 * f64));
    f70 = Math_fround(HEAPF32[i27 >> 2]);
    f66 = Math_fround(f66 * f70);
    f68 = Math_fround(HEAPF32[i28 >> 2]);
    f69 = Math_fround(f66 + Math_fround(f69 * f68));
    f66 = Math_fround(HEAPF32[i29 >> 2]);
    f7 = Math_fround(f69 + Math_fround(f7 * f66));
    i13 = i15 + (i1 * 48 | 0) | 0;
    f69 = Math_fround(HEAPF32[i13 >> 2]);
    f11 = Math_fround(f11 * f69);
    i14 = i15 + (i1 * 48 | 0) + 4 | 0;
    f67 = Math_fround(HEAPF32[i14 >> 2]);
    f73 = Math_fround(f11 + Math_fround(f73 * f67));
    i15 = i15 + (i1 * 48 | 0) + 8 | 0;
    f11 = Math_fround(HEAPF32[i15 >> 2]);
    f65 = Math_fround(f73 + Math_fround(f65 * f11));
    f65 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f65);
    f64 = Math_fround(Math_fround(Math_fround(f72 * f69) + Math_fround(f71 * f67)) + Math_fround(f64 * f11));
    f64 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f64);
    f11 = Math_fround(Math_fround(Math_fround(f70 * f69) + Math_fround(f68 * f67)) + Math_fround(f66 * f11));
    f64 = Math_fround(f64 - f6);
    f11 = Math_fround(Math_fround(f11 + Math_fround(HEAPF32[i32 >> 2])) - f7);
    HEAPF32[i61 >> 2] = Math_fround(f65 - f5);
    HEAPF32[i18 >> 2] = f64;
    HEAPF32[i20 >> 2] = f11;
    f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7))));
    if (!(f11 < f21)) {
     f4 = Math_fround(f4 * Math_fround(.5));
     f72 = Math_fround(f6 / f11);
     f73 = Math_fround(f7 / f11);
     HEAPF32[i16 >> 2] = Math_fround(f5 / f11);
     HEAPF32[i17 >> 2] = f72;
     HEAPF32[i19 >> 2] = f73;
     f4 = Math_fround(f4 + f11);
     i3 = __Z19GetRaycastInterfacev() | 0;
     do if (i3) if (mftCall_iiifiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i61 | 0, +f4, HEAP32[i33 >> 2] | 0, 0, i53 | 0) | 0) {
      i3 = HEAP32[i55 >> 2] | 0;
      f68 = Math_fround(HEAPF32[i60 >> 2]);
      f64 = Math_fround(HEAPF32[i9 >> 2]);
      f71 = Math_fround(f68 * f64);
      f7 = Math_fround(HEAPF32[i22 >> 2]);
      f69 = Math_fround(HEAPF32[i10 >> 2]);
      f71 = Math_fround(f71 + Math_fround(f7 * f69));
      f65 = Math_fround(HEAPF32[i23 >> 2]);
      f67 = Math_fround(HEAPF32[i12 >> 2]);
      f71 = Math_fround(f71 + Math_fround(f65 * f67));
      f70 = Math_fround(HEAPF32[i24 >> 2]);
      f72 = Math_fround(f64 * f70);
      f5 = Math_fround(HEAPF32[i25 >> 2]);
      f72 = Math_fround(f72 + Math_fround(f69 * f5));
      f6 = Math_fround(HEAPF32[i26 >> 2]);
      f72 = Math_fround(f72 + Math_fround(f67 * f6));
      f66 = Math_fround(HEAPF32[i27 >> 2]);
      f64 = Math_fround(f64 * f66);
      f74 = Math_fround(HEAPF32[i28 >> 2]);
      f69 = Math_fround(f64 + Math_fround(f69 * f74));
      f64 = Math_fround(HEAPF32[i29 >> 2]);
      f67 = Math_fround(f69 + Math_fround(f67 * f64));
      f69 = Math_fround(HEAPF32[i34 >> 2]);
      f71 = Math_fround(f71 * f69);
      f72 = Math_fround(f72 * f69);
      f67 = Math_fround(f69 * f67);
      f69 = Math_fround(HEAPF32[i35 >> 2]);
      f73 = Math_fround(f69 * f71);
      f76 = Math_fround(HEAPF32[i36 >> 2]);
      f73 = Math_fround(f73 + Math_fround(f72 * f76));
      f75 = Math_fround(HEAPF32[i37 >> 2]);
      f73 = Math_fround(Math_fround(f73 + Math_fround(f67 * f75)) * Math_fround(-2.0));
      f71 = Math_fround(f71 + Math_fround(f69 * f73));
      f72 = Math_fround(f72 + Math_fround(f76 * f73));
      f73 = Math_fround(f67 + Math_fround(f75 * f73));
      f67 = Math_fround(Math_fround(f4 - f4) / f11);
      f69 = Math_fround(f8 * f69);
      f4 = Math_fround(f8 * f76);
      f11 = Math_fround(f8 * f75);
      f69 = Math_fround(f69 + Math_fround(HEAPF32[i53 >> 2]));
      f4 = Math_fround(f4 + Math_fround(HEAPF32[i38 >> 2]));
      f67 = Math_fround(f67 * f58);
      f69 = Math_fround(f69 + Math_fround(f67 * f71));
      f4 = Math_fround(f4 + Math_fround(f67 * f72));
      f67 = Math_fround(Math_fround(f11 + Math_fround(HEAPF32[i39 >> 2])) + Math_fround(f67 * f73));
      f69 = Math_fround(f69 - Math_fround(HEAPF32[i30 >> 2]));
      f4 = Math_fround(f4 - Math_fround(HEAPF32[i31 >> 2]));
      f67 = Math_fround(f67 - Math_fround(HEAPF32[i32 >> 2]));
      f5 = Math_fround(Math_fround(f74 * f67) + Math_fround(Math_fround(f7 * f69) + Math_fround(f5 * f4)));
      f6 = Math_fround(Math_fround(f64 * f67) + Math_fround(Math_fround(f65 * f69) + Math_fround(f6 * f4)));
      HEAPF32[i13 >> 2] = Math_fround(Math_fround(f66 * f67) + Math_fround(Math_fround(f68 * f69) + Math_fround(f70 * f4)));
      HEAPF32[i14 >> 2] = f5;
      HEAPF32[i15 >> 2] = f6;
      f6 = Math_fround(f71 * Math_fround(HEAPF32[i60 >> 2]));
      f6 = Math_fround(f6 + Math_fround(f72 * Math_fround(HEAPF32[i24 >> 2])));
      f6 = Math_fround(f6 + Math_fround(f73 * Math_fround(HEAPF32[i27 >> 2])));
      f5 = Math_fround(f71 * Math_fround(HEAPF32[i22 >> 2]));
      f5 = Math_fround(f5 + Math_fround(f72 * Math_fround(HEAPF32[i25 >> 2])));
      f5 = Math_fround(f5 + Math_fround(f73 * Math_fround(HEAPF32[i28 >> 2])));
      f4 = Math_fround(f71 * Math_fround(HEAPF32[i23 >> 2]));
      f4 = Math_fround(f4 + Math_fround(f72 * Math_fround(HEAPF32[i26 >> 2])));
      f4 = Math_fround(f4 + Math_fround(f73 * Math_fround(HEAPF32[i29 >> 2])));
      HEAPF32[i9 >> 2] = f6;
      HEAPF32[i10 >> 2] = f5;
      HEAPF32[i12 >> 2] = f4;
      if (HEAP8[i40 >> 0] | 0) {
       i77 = HEAP32[(HEAP32[i47 >> 2] | 0) + 28 >> 2] | 0;
       HEAP32[i59 >> 2] = gb + 28900;
       HEAP32[i48 >> 2] = 0;
       HEAP32[i49 >> 2] = i77;
       __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i54, gb + 1105096 | 0, i59);
       i77 = HEAP32[i47 >> 2] | 0;
       i78 = HEAP32[i52 >> 2] | 0;
       HEAP32[i59 >> 2] = gb + 28900;
       HEAP32[i50 >> 2] = 0;
       HEAP32[i51 >> 2] = i78;
       __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i77, gb + 1105096 | 0, i59);
       f6 = Math_fround(HEAPF32[i9 >> 2]);
       f5 = Math_fround(HEAPF32[i10 >> 2]);
       f4 = Math_fround(HEAPF32[i12 >> 2]);
      }
      f76 = Math_fround(HEAPF32[i41 >> 2]);
      i78 = i3 + (i1 * 48 | 0) + 36 | 0;
      f76 = Math_fround(Math_fround(HEAPF32[i78 >> 2]) - f76);
      HEAPF32[i78 >> 2] = f76;
      if (f76 <= Math_fround(0.0) ? 1 : Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)) + Math_fround(f4 * f4)) < f56) {
       i2 = HEAP32[i55 >> 2] | 0;
       i3 = HEAP32[i62 >> 2] | 0;
       i9 = i2 + (i1 * 48 | 0) | 0;
       i10 = i3 + -48 | 0;
       i12 = i9 + 44 | 0;
       do {
        HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
        i9 = i9 + 4 | 0;
        i10 = i10 + 4 | 0;
       } while ((i9 | 0) < (i12 | 0));
       HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] = HEAP32[i3 + -4 >> 2];
       i2 = (HEAP32[i62 >> 2] | 0) + -48 | 0;
       HEAP32[i62 >> 2] = i2;
       i1 = i1 + -1 | 0;
       i2 = (i2 - (HEAP32[i55 >> 2] | 0) | 0) / 48 | 0;
       break;
      } else {
       f76 = Math_fround(HEAPF32[i57 >> 2]);
       f75 = Math_fround(HEAPF32[i13 >> 2]);
       f74 = Math_fround(HEAPF32[i42 >> 2]);
       f73 = Math_fround(HEAPF32[i14 >> 2]);
       f72 = Math_fround(HEAPF32[i43 >> 2]);
       f71 = Math_fround(HEAPF32[i15 >> 2]);
       HEAPF32[i57 >> 2] = f75 < f76 ? f75 : f76;
       HEAPF32[i42 >> 2] = f73 < f74 ? f73 : f74;
       HEAPF32[i43 >> 2] = f71 < f72 ? f71 : f72;
       f72 = Math_fround(HEAPF32[i44 >> 2]);
       f71 = Math_fround(HEAPF32[i13 >> 2]);
       f74 = Math_fround(HEAPF32[i45 >> 2]);
       f73 = Math_fround(HEAPF32[i14 >> 2]);
       f76 = Math_fround(HEAPF32[i46 >> 2]);
       f75 = Math_fround(HEAPF32[i15 >> 2]);
       HEAPF32[i44 >> 2] = f72 < f71 ? f71 : f72;
       HEAPF32[i45 >> 2] = f74 < f73 ? f73 : f74;
       HEAPF32[i46 >> 2] = f76 < f75 ? f75 : f76;
       break;
      }
     } while (0);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
  }
  STACKTOP = i63;
  return;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i63;
  return;
 }
 i18 = i60 + 4 | 0;
 i20 = i60 + 8 | 0;
 f21 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i16 = i60 + 12 | 0;
 i17 = i60 + 16 | 0;
 i19 = i60 + 20 | 0;
 i22 = i54 + 44 | 0;
 i23 = i54 + 36 | 0;
 i24 = i61 + 12 | 0;
 i25 = i61 + 16 | 0;
 i26 = i61 + 20 | 0;
 i27 = i61 + 4 | 0;
 i28 = i61 + 8 | 0;
 i29 = i54 + 48 | 0;
 i30 = i54 + 40 | 0;
 i31 = i57 + 4 | 0;
 i32 = i57 + 8 | 0;
 i33 = i57 + 12 | 0;
 i34 = i57 + 16 | 0;
 i35 = i57 + 20 | 0;
 i36 = i61 + 40 | 0;
 i37 = i59 + 8 | 0;
 i38 = i59 + 4 | 0;
 i39 = i54 + 28 | 0;
 i40 = i59 + 8 | 0;
 i41 = i59 + 4 | 0;
 i1 = 0;
 while (1) {
  i9 = i3 + (i1 * 48 | 0) + 12 | 0;
  f4 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f58);
  i10 = i3 + (i1 * 48 | 0) + 16 | 0;
  f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f58);
  i12 = i3 + (i1 * 48 | 0) + 20 | 0;
  f6 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f58);
  f7 = Math_fround(HEAPF32[i3 + (i1 * 48 | 0) + 24 >> 2]);
  f11 = Math_fround(f7 * Math_fround(.50999999));
  i14 = i3 + (i1 * 48 | 0) | 0;
  f75 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f4);
  i15 = i3 + (i1 * 48 | 0) + 4 | 0;
  f76 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f5);
  i13 = i3 + (i1 * 48 | 0) + 8 | 0;
  f8 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f6);
  HEAPF32[i60 >> 2] = f75;
  HEAPF32[i18 >> 2] = f76;
  HEAPF32[i20 >> 2] = f8;
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
  if (!(f8 < f21)) {
   f7 = Math_fround(f7 * Math_fround(.5));
   f75 = Math_fround(f5 / f8);
   f76 = Math_fround(f6 / f8);
   HEAPF32[i16 >> 2] = Math_fround(f4 / f8);
   HEAPF32[i17 >> 2] = f75;
   HEAPF32[i19 >> 2] = f76;
   f7 = Math_fround(f7 + f8);
   i3 = __Z19GetRaycastInterfacev() | 0;
   do if (i3) if (mftCall_iiifiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i60 | 0, +f7, HEAP32[i22 >> 2] | 0, 0, i61 | 0) | 0) {
    i3 = HEAP32[i55 >> 2] | 0;
    f73 = Math_fround(HEAPF32[i23 >> 2]);
    f76 = Math_fround(f73 * Math_fround(HEAPF32[i9 >> 2]));
    f75 = Math_fround(f73 * Math_fround(HEAPF32[i10 >> 2]));
    f73 = Math_fround(f73 * Math_fround(HEAPF32[i12 >> 2]));
    f6 = Math_fround(HEAPF32[i24 >> 2]);
    f4 = Math_fround(f76 * f6);
    f5 = Math_fround(HEAPF32[i25 >> 2]);
    f4 = Math_fround(f4 + Math_fround(f75 * f5));
    f74 = Math_fround(HEAPF32[i26 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(f73 * f74)) * Math_fround(-2.0));
    f6 = Math_fround(f76 + Math_fround(f6 * f4));
    f5 = Math_fround(f75 + Math_fround(f5 * f4));
    f4 = Math_fround(f73 + Math_fround(f74 * f4));
    HEAPF32[i9 >> 2] = f6;
    HEAPF32[i10 >> 2] = f5;
    HEAPF32[i12 >> 2] = f4;
    f74 = Math_fround(Math_fround(f7 - f7) / f8);
    f73 = Math_fround(f11 * Math_fround(HEAPF32[i24 >> 2]));
    f75 = Math_fround(f11 * Math_fround(HEAPF32[i25 >> 2]));
    f76 = Math_fround(f11 * Math_fround(HEAPF32[i26 >> 2]));
    f73 = Math_fround(f73 + Math_fround(HEAPF32[i61 >> 2]));
    f75 = Math_fround(f75 + Math_fround(HEAPF32[i27 >> 2]));
    f74 = Math_fround(f74 * f58);
    f75 = Math_fround(f75 + Math_fround(f74 * f5));
    f76 = Math_fround(Math_fround(f76 + Math_fround(HEAPF32[i28 >> 2])) + Math_fround(f74 * f4));
    HEAPF32[i14 >> 2] = Math_fround(f73 + Math_fround(f74 * f6));
    HEAPF32[i15 >> 2] = f75;
    HEAPF32[i13 >> 2] = f76;
    if (HEAP8[i29 >> 0] | 0) {
     i78 = HEAP32[(HEAP32[i36 >> 2] | 0) + 28 >> 2] | 0;
     HEAP32[i59 >> 2] = gb + 28900;
     HEAP32[i37 >> 2] = 0;
     HEAP32[i38 >> 2] = i78;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i54, gb + 1105096 | 0, i59);
     i78 = HEAP32[i36 >> 2] | 0;
     i77 = HEAP32[i39 >> 2] | 0;
     HEAP32[i59 >> 2] = gb + 28900;
     HEAP32[i40 >> 2] = 0;
     HEAP32[i41 >> 2] = i77;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i78, gb + 1105096 | 0, i59);
     f6 = Math_fround(HEAPF32[i9 >> 2]);
     f5 = Math_fround(HEAPF32[i10 >> 2]);
     f4 = Math_fround(HEAPF32[i12 >> 2]);
    }
    f76 = Math_fround(HEAPF32[i30 >> 2]);
    i78 = i3 + (i1 * 48 | 0) + 36 | 0;
    f76 = Math_fround(Math_fround(HEAPF32[i78 >> 2]) - f76);
    HEAPF32[i78 >> 2] = f76;
    if (f76 <= Math_fround(0.0) ? 1 : Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)) + Math_fround(f4 * f4)) < f56) {
     i2 = HEAP32[i55 >> 2] | 0;
     i3 = HEAP32[i62 >> 2] | 0;
     i9 = i2 + (i1 * 48 | 0) | 0;
     i10 = i3 + -48 | 0;
     i12 = i9 + 44 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
      i9 = i9 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i9 | 0) < (i12 | 0));
     HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] = HEAP32[i3 + -4 >> 2];
     i2 = (HEAP32[i62 >> 2] | 0) + -48 | 0;
     HEAP32[i62 >> 2] = i2;
     i2 = (i2 - (HEAP32[i55 >> 2] | 0) | 0) / 48 | 0;
     i1 = i1 + -1 | 0;
     break;
    } else {
     f76 = Math_fround(HEAPF32[i57 >> 2]);
     f75 = Math_fround(HEAPF32[i14 >> 2]);
     f74 = Math_fround(HEAPF32[i31 >> 2]);
     f73 = Math_fround(HEAPF32[i15 >> 2]);
     f72 = Math_fround(HEAPF32[i32 >> 2]);
     f71 = Math_fround(HEAPF32[i13 >> 2]);
     HEAPF32[i57 >> 2] = f75 < f76 ? f75 : f76;
     HEAPF32[i31 >> 2] = f73 < f74 ? f73 : f74;
     HEAPF32[i32 >> 2] = f71 < f72 ? f71 : f72;
     f72 = Math_fround(HEAPF32[i33 >> 2]);
     f71 = Math_fround(HEAPF32[i14 >> 2]);
     f74 = Math_fround(HEAPF32[i34 >> 2]);
     f73 = Math_fround(HEAPF32[i15 >> 2]);
     f76 = Math_fround(HEAPF32[i35 >> 2]);
     f75 = Math_fround(HEAPF32[i13 >> 2]);
     HEAPF32[i33 >> 2] = f72 < f71 ? f71 : f72;
     HEAPF32[i34 >> 2] = f74 < f73 ? f73 : f74;
     HEAPF32[i35 >> 2] = f76 < f75 ? f75 : f76;
     break;
    }
   } while (0);
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) break;
  i3 = HEAP32[i55 >> 2] | 0;
 }
 STACKTOP = i63;
 return;
}

function __ZN7VRInput20UpdateTrackedDevicesEv(i29) {
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i31 + 120 | 0;
 i27 = i31 + 108 | 0;
 i24 = i31 + 16 | 0;
 i28 = i31;
 i1 = HEAP32[i29 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 204 >> 2] | 0;
  if (i1 | 0) {
   i26 = i29 + 20 | 0;
   if (mftCall_iii(i1 | 0, 0, i24 | 0) | 0) {
    i14 = i28 + 12 | 0;
    i13 = i28 + 12 | 0;
    i15 = i30 + 4 | 0;
    i16 = i28 + 8 | 0;
    i17 = i28 + 4 | 0;
    i18 = i29 + 24 | 0;
    i19 = i29 + 32 | 0;
    i20 = i28 + 11 | 0;
    i21 = i30 + 4 | 0;
    i22 = i24 + 64 | 0;
    i23 = i24 + 76 | 0;
    i8 = 0;
    do {
     i8 = i8 + 1 | 0;
     HEAP32[i28 >> 2] = 0;
     HEAP32[i28 + 4 >> 2] = 0;
     HEAP32[i28 + 8 >> 2] = 0;
     i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i14 >> 2] = i1;
     i2 = _strlen(i24) | 0;
     if (i2 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i28);
      i1 = HEAP32[i13 >> 2] | 0;
      i25 = 8;
     } else if (i2 >>> 0 < 11) {
      HEAP8[i20 >> 0] = i2;
      if (!i2) i1 = i28; else {
       i1 = i28;
       i25 = 10;
      }
     } else i25 = 8;
     if ((i25 | 0) == 8) {
      i3 = i2 + 16 & -16;
      HEAP32[i30 >> 2] = 66;
      HEAP32[i15 >> 2] = i1;
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i28 >> 2] = i1;
      HEAP32[i16 >> 2] = i3 | -2147483648;
      HEAP32[i17 >> 2] = i2;
      i25 = 10;
     }
     if ((i25 | 0) == 10) {
      i25 = 0;
      _memcpy(i1 | 0, i24 | 0, i2 | 0) | 0;
     }
     HEAP8[i1 + i2 >> 0] = 0;
     i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
      i1 = HEAP32[i27 >> 2] | 0;
      HEAP32[i27 >> 2] = 0;
      i2 = HEAP32[i30 >> 2] | 0;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i2;
      HEAP32[i3 >> 2] = i1;
      i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
      if (!i2) i2 = i1; else {
       HEAP32[i26 >> 2] = i2;
       i2 = HEAP32[i3 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 >> 2] | 0, i2);
      HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
     }
     i2 = i1 + 32 | 0;
     if ((HEAP8[i20 >> 0] | 0) < 0) {
      i3 = HEAP32[i28 >> 2] | 0;
      i32 = HEAP32[i13 >> 2] | 0;
      HEAP32[i30 >> 2] = 66;
      HEAP32[i21 >> 2] = i32;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i30);
     };
     HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     i32 = i1 + 44 | 0;
     HEAP32[i32 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i32 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     HEAP32[i32 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
     HEAP8[i1 + 60 >> 0] = 1;
    } while (mftCall_iii(HEAP32[(HEAP32[i29 >> 2] | 0) + 204 >> 2] | 0, i8 | 0, i24 | 0) | 0);
   };
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 + 12 >> 2] = i1;
   HEAP32[i30 >> 2] = 66;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i28 + 8 >> 2] = -2147483632;
   HEAP32[i28 + 4 >> 2] = 12;
   i2 = i1;
   i3 = gb + 1044481 | 0;
   i8 = i2 + 12 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i8 | 0));
   HEAP8[i1 + 12 >> 0] = 0;
   i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
    i1 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = 0;
    i2 = HEAP32[i30 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i26 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 + 24 >> 2] | 0, i2);
    i32 = i29 + 32 | 0;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   }
   i14 = i29 + 36 | 0;
   HEAP32[i14 >> 2] = i1 + 32;
   if ((HEAP8[i28 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i28 >> 2] | 0;
    i25 = HEAP32[i28 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i30 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   };
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 + 12 >> 2] = i1;
   HEAP32[i30 >> 2] = 66;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i28 + 8 >> 2] = -2147483632;
   HEAP32[i28 + 4 >> 2] = 12;
   i2 = i1;
   i3 = gb + 1044481 | 0;
   i8 = i2 + 12 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i8 | 0));
   HEAP8[i1 + 12 >> 0] = 0;
   i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
    i1 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = 0;
    i2 = HEAP32[i30 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i26 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 + 24 >> 2] | 0, i2);
    i32 = i29 + 32 | 0;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   }
   HEAP8[i1 + 60 >> 0] = 1;
   if ((HEAP8[i28 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i28 >> 2] | 0;
    i25 = HEAP32[i28 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i30 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   };
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 + 12 >> 2] = i1;
   HEAP32[i30 >> 2] = 66;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i28 + 8 >> 2] = -2147483632;
   HEAP32[i28 + 4 >> 2] = 13;
   i2 = i1;
   i3 = gb + 1044494 | 0;
   i8 = i2 + 13 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i8 | 0));
   HEAP8[i1 + 13 >> 0] = 0;
   i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
    i1 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = 0;
    i2 = HEAP32[i30 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i26 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 + 24 >> 2] | 0, i2);
    i32 = i29 + 32 | 0;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   }
   i13 = i29 + 40 | 0;
   HEAP32[i13 >> 2] = i1 + 32;
   if ((HEAP8[i28 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i28 >> 2] | 0;
    i25 = HEAP32[i28 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i30 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   };
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 + 12 >> 2] = i1;
   HEAP32[i30 >> 2] = 66;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i28 + 8 >> 2] = -2147483632;
   HEAP32[i28 + 4 >> 2] = 13;
   i2 = i1;
   i3 = gb + 1044494 | 0;
   i8 = i2 + 13 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i8 | 0));
   HEAP8[i1 + 13 >> 0] = 0;
   i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
    i1 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = 0;
    i2 = HEAP32[i30 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i26 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 + 24 >> 2] | 0, i2);
    i32 = i29 + 32 | 0;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   }
   HEAP8[i1 + 60 >> 0] = 1;
   if ((HEAP8[i28 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i28 >> 2] | 0;
    i25 = HEAP32[i28 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i30 + 4 >> 2] = i25;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   }
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 + 12 >> 2] = i1;
   HEAP32[i30 >> 2] = 66;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i28 + 8 >> 2] = -2147483632;
   HEAP32[i28 + 4 >> 2] = 14;
   i2 = i1;
   i3 = gb + 1044508 | 0;
   i8 = i2 + 14 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i8 | 0));
   HEAP8[i1 + 14 >> 0] = 0;
   i2 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i26, i30, i28) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i27, i26, i28);
    i3 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = 0;
    i1 = HEAP32[i30 >> 2] | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = i1;
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if (!i1) i1 = i3; else {
     HEAP32[i26 >> 2] = i1;
     i1 = HEAP32[i2 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i29 + 24 >> 2] | 0, i1);
    i1 = i29 + 32 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = i3;
   }
   if ((HEAP8[i28 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i30 + 4 >> 2] = i28;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   }
   i32 = HEAP32[i14 >> 2] | 0;
   i28 = HEAP32[i13 >> 2] | 0;
   f33 = Math_fround(HEAPF32[i32 >> 2]);
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i28 >> 2]));
   f6 = Math_fround(HEAPF32[i32 + 4 >> 2]);
   f6 = Math_fround(f6 + Math_fround(HEAPF32[i28 + 4 >> 2]));
   f9 = Math_fround(HEAPF32[i32 + 8 >> 2]);
   f6 = Math_fround(f6 * Math_fround(.5));
   f9 = Math_fround(Math_fround(f9 + Math_fround(HEAPF32[i28 + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i1 + 32 >> 2] = Math_fround(f33 * Math_fround(.5));
   HEAPF32[i1 + 36 >> 2] = f6;
   HEAPF32[i1 + 40 >> 2] = f9;
   i28 = HEAP32[i14 >> 2] | 0;
   i32 = HEAP32[i13 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i28 + 12 >> 2]);
   f6 = Math_fround(HEAPF32[i32 + 12 >> 2]);
   f33 = Math_fround(f9 * f6);
   f10 = Math_fround(HEAPF32[i28 + 16 >> 2]);
   f7 = Math_fround(HEAPF32[i32 + 16 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f10 * f7));
   f11 = Math_fround(HEAPF32[i28 + 20 >> 2]);
   f5 = Math_fround(HEAPF32[i32 + 20 >> 2]);
   f33 = Math_fround(f33 + Math_fround(f11 * f5));
   f12 = Math_fround(HEAPF32[i28 + 24 >> 2]);
   f4 = Math_fround(HEAPF32[i32 + 24 >> 2]);
   if (Math_fround(f33 + Math_fround(f12 * f4)) < Math_fround(0.0)) {
    f5 = Math_fround(-f5);
    f7 = Math_fround(-f7);
    f6 = Math_fround(-f6);
    f4 = Math_fround(-f4);
   }
   f9 = Math_fround(f9 + Math_fround(Math_fround(f6 - f9) * Math_fround(.5)));
   f6 = Math_fround(f10 + Math_fround(Math_fround(f7 - f10) * Math_fround(.5)));
   f7 = Math_fround(f11 + Math_fround(Math_fround(f5 - f11) * Math_fround(.5)));
   f33 = Math_fround(f12 + Math_fround(Math_fround(f4 - f12) * Math_fround(.5)));
   f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9))))));
   f11 = Math_fround(f6 / f10);
   f12 = Math_fround(f7 / f10);
   f33 = Math_fround(f33 / f10);
   HEAPF32[i1 + 44 >> 2] = Math_fround(f9 / f10);
   HEAPF32[i1 + 48 >> 2] = f11;
   HEAPF32[i1 + 52 >> 2] = f12;
   HEAPF32[i1 + 56 >> 2] = f33;
   HEAP8[i1 + 60 >> 0] = 1;
  }
 }
 i19 = i29 + 20 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i20 = i29 + 24 | 0;
 if ((i2 | 0) == (i20 | 0)) {
  STACKTOP = i31;
  return;
 }
 i21 = i29 + 32 | 0;
 i22 = i29 + 28 | 0;
 i16 = i29 + 24 | 0;
 i17 = i30 + 4 | 0;
 i18 = i30 + 4 | 0;
 while (1) {
  i15 = i2 + 16 | 0;
  i1 = i2 + 60 | 0;
  L81 : do if (!(HEAP8[i1 >> 0] | 0)) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = (i3 | 0) == 0;
   if (i13) {
    i8 = i2;
    while (1) {
     i1 = HEAP32[i8 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) {
      i14 = i2;
      break;
     } else i8 = i1;
    }
   } else {
    i1 = i3;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     if (!i8) break; else i1 = i8;
    }
    i14 = i2;
   }
   if (i13) {
    i8 = i14;
    while (1) {
     i3 = HEAP32[i8 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i8 | 0)) break; else i8 = i3;
    }
   } else while (1) {
    i8 = HEAP32[i3 >> 2] | 0;
    if (!i8) break; else i3 = i8;
   }
   if ((HEAP32[i19 >> 2] | 0) == (i2 | 0)) HEAP32[i19 >> 2] = i3;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i14);
   if ((HEAP8[i15 + 11 >> 0] | 0) < 0) {
    i32 = HEAP32[i15 >> 2] | 0;
    i29 = HEAP32[i2 + 28 >> 2] | 0;
    HEAP32[i30 >> 2] = 66;
    HEAP32[i17 >> 2] = i29;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i30);
   }
   i32 = HEAP32[i22 >> 2] | 0;
   HEAP32[i30 >> 2] = 87;
   HEAP32[i18 >> 2] = i32;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i30);
  } else {
   HEAP8[i1 >> 0] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (i1 | 0) while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break L81; else i1 = i2;
   }
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } while (0);
  if ((i1 | 0) == (i20 | 0)) break; else i2 = i1;
 }
 STACKTOP = i31;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainMotionEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i72 + 16 | 0;
 i5 = i72;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i15 = HEAP32[i2 + 120 >> 2] | 0;
 if (!i15) {
  STACKTOP = i72;
  return;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i71 = i1 + (i11 << 4) | 0;
 i16 = HEAP32[i2 + 124 >> 2] | 0;
 i66 = (HEAP32[i7 >> 2] | 0) + 296 | 0;
 i9 = HEAP32[i2 + 128 >> 2] | 0;
 i10 = HEAP32[gb + 1097472 >> 2] | 0;
 i12 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
 i13 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
 i14 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
 i6 = i10 & (i9 ^ HEAP32[i66 >> 2]) ^ i9;
 i8 = i12 & (i9 ^ HEAP32[i66 + 4 >> 2]) ^ i9;
 i4 = i13 & (i9 ^ HEAP32[i66 + 8 >> 2]) ^ i9;
 i9 = i14 & (i9 ^ HEAP32[i66 + 12 >> 2]) ^ i9;
 if (!i16) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i3 + 4 >> 2] = i8;
  HEAP32[i3 + 8 >> 2] = i4;
  HEAP32[i3 + 12 >> 2] = i9;
  __ZN12_GLOBAL__N_115constrainMotionI8Scalar4fPKS1_EEvPT_PKS4_RKT0_S4_(i1, i71, i15, i3);
  STACKTOP = i72;
  return;
 }
 i2 = HEAP32[i7 + 716 >> 2] | 0;
 if ((i2 | 0) == 1) {
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 4 >> 2] = i8;
  HEAP32[i5 + 8 >> 2] = i4;
  HEAP32[i5 + 12 >> 2] = i9;
  __ZN12_GLOBAL__N_115constrainMotionI8Scalar4fPKS1_EEvPT_PKS4_RKT0_S4_(i1, i71, i16, i5);
  STACKTOP = i72;
  return;
 }
 f69 = Math_fround(i2 >>> 0);
 f70 = Math_fround(HEAPF32[i7 + 720 >> 2]);
 f70 = Math_fround(f70 + Math_fround(Math_fround(1.0) - Math_fround(f69 * f70)));
 f69 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f68 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f67 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i11 | 0) <= 0) {
  STACKTOP = i72;
  return;
 }
 while (1) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = i1 + 4 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i1 + 8 | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  i41 = i1 + 12 | 0;
  i42 = HEAP32[i41 >> 2] | 0;
  i43 = i1 + 16 | 0;
  i44 = HEAP32[i43 >> 2] | 0;
  i45 = i1 + 20 | 0;
  i46 = HEAP32[i45 >> 2] | 0;
  i47 = i1 + 24 | 0;
  i48 = HEAP32[i47 >> 2] | 0;
  i49 = i1 + 28 | 0;
  i50 = HEAP32[i49 >> 2] | 0;
  i51 = i1 + 32 | 0;
  i52 = HEAP32[i51 >> 2] | 0;
  i53 = i1 + 36 | 0;
  i54 = HEAP32[i53 >> 2] | 0;
  i55 = i1 + 40 | 0;
  i56 = HEAP32[i55 >> 2] | 0;
  i57 = i1 + 44 | 0;
  i58 = HEAP32[i57 >> 2] | 0;
  i59 = i1 + 48 | 0;
  i60 = HEAP32[i59 >> 2] | 0;
  i61 = i1 + 52 | 0;
  i62 = HEAP32[i61 >> 2] | 0;
  i63 = i1 + 56 | 0;
  i64 = HEAP32[i63 >> 2] | 0;
  i65 = i1 + 60 | 0;
  i66 = HEAP32[i65 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  f26 = Math_fround(HEAPF32[i15 >> 2]);
  f17 = Math_fround(f17 - f26);
  f18 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f18 = Math_fround(f18 - f22);
  f19 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f19 = Math_fround(f19 - f30);
  f21 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  f17 = Math_fround(f26 + Math_fround(f70 * f17));
  f18 = Math_fround(f22 + Math_fround(f70 * f18));
  f19 = Math_fround(f30 + Math_fround(f70 * f19));
  f20 = Math_fround(f20 + Math_fround(f70 * Math_fround(f21 - f20)));
  f17 = Math_fround(f17 - (HEAP32[tempDoublePtr >> 2] = i10 & i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f18 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i12 & i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(f19 - (HEAP32[tempDoublePtr >> 2] = i13 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i14 & i42, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f21 = Math_fround(HEAPF32[i16 + 16 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 16 >> 2]);
  f21 = Math_fround(f21 - f30);
  f22 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f26 = Math_fround(HEAPF32[i15 + 20 >> 2]);
  f22 = Math_fround(f22 - f26);
  f23 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  f39 = Math_fround(HEAPF32[i15 + 24 >> 2]);
  f23 = Math_fround(f23 - f39);
  f25 = Math_fround(HEAPF32[i16 + 28 >> 2]);
  f24 = Math_fround(HEAPF32[i15 + 28 >> 2]);
  f21 = Math_fround(f30 + Math_fround(f70 * f21));
  f22 = Math_fround(f26 + Math_fround(f70 * f22));
  f23 = Math_fround(f39 + Math_fround(f70 * f23));
  f24 = Math_fround(f24 + Math_fround(f70 * Math_fround(f25 - f24)));
  f21 = Math_fround(f21 - (HEAP32[tempDoublePtr >> 2] = i10 & i44, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f22 = Math_fround(f22 - (HEAP32[tempDoublePtr >> 2] = i12 & i46, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i13 & i48, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f24 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i14 & i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f25 = Math_fround(HEAPF32[i16 + 32 >> 2]);
  f39 = Math_fround(HEAPF32[i15 + 32 >> 2]);
  f25 = Math_fround(f25 - f39);
  f26 = Math_fround(HEAPF32[i16 + 36 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 36 >> 2]);
  f26 = Math_fround(f26 - f30);
  f27 = Math_fround(HEAPF32[i16 + 40 >> 2]);
  f40 = Math_fround(HEAPF32[i15 + 40 >> 2]);
  f27 = Math_fround(f27 - f40);
  f29 = Math_fround(HEAPF32[i16 + 44 >> 2]);
  f28 = Math_fround(HEAPF32[i15 + 44 >> 2]);
  f25 = Math_fround(f39 + Math_fround(f70 * f25));
  f26 = Math_fround(f30 + Math_fround(f70 * f26));
  f27 = Math_fround(f40 + Math_fround(f70 * f27));
  f28 = Math_fround(f28 + Math_fround(f70 * Math_fround(f29 - f28)));
  f25 = Math_fround(f25 - (HEAP32[tempDoublePtr >> 2] = i10 & i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f26 = Math_fround(f26 - (HEAP32[tempDoublePtr >> 2] = i12 & i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f27 = Math_fround(f27 - (HEAP32[tempDoublePtr >> 2] = i13 & i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f28 = Math_fround(f28 - (HEAP32[tempDoublePtr >> 2] = i14 & i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f29 = Math_fround(HEAPF32[i16 + 48 >> 2]);
  f40 = Math_fround(HEAPF32[i15 + 48 >> 2]);
  f29 = Math_fround(f29 - f40);
  f30 = Math_fround(HEAPF32[i16 + 52 >> 2]);
  f39 = Math_fround(HEAPF32[i15 + 52 >> 2]);
  f30 = Math_fround(f30 - f39);
  f31 = Math_fround(HEAPF32[i16 + 56 >> 2]);
  f38 = Math_fround(HEAPF32[i15 + 56 >> 2]);
  f31 = Math_fround(f31 - f38);
  f37 = Math_fround(HEAPF32[i16 + 60 >> 2]);
  f32 = Math_fround(HEAPF32[i15 + 60 >> 2]);
  f29 = Math_fround(f40 + Math_fround(f70 * f29));
  f30 = Math_fround(f39 + Math_fround(f70 * f30));
  f31 = Math_fround(f38 + Math_fround(f70 * f31));
  f32 = Math_fround(f32 + Math_fround(f70 * Math_fround(f37 - f32)));
  f29 = Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i10 & i60, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f30 = Math_fround(f30 - (HEAP32[tempDoublePtr >> 2] = i12 & i62, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f31 = Math_fround(f31 - (HEAP32[tempDoublePtr >> 2] = i13 & i64, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f32 = Math_fround(f32 - (HEAP32[tempDoublePtr >> 2] = i14 & i66, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f37 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
  f38 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
  f37 = Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f18 * f18) + Math_fround(Math_fround(f17 * f17) + f37)));
  f38 = Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f22 * f22) + Math_fround(Math_fround(f21 * f21) + f38)));
  f39 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f25 * f25) + f39)));
  f40 = Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f30 * f30) + Math_fround(Math_fround(f29 * f29) + Math_fround(HEAPF32[gb + 1097504 + 12 >> 2]))));
  f33 = Math_fround(f68 + Math_fround(f69 * f20));
  f34 = Math_fround(f68 + Math_fround(f69 * f24));
  f35 = Math_fround(f68 + Math_fround(f69 * f28));
  f36 = Math_fround(f68 + Math_fround(f69 * f32));
  i2 = f33 > Math_fround(0.0);
  f33 = i2 ? f33 : Math_fround(0.0);
  i2 = f34 > Math_fround(0.0);
  f34 = i2 ? f34 : Math_fround(0.0);
  i2 = f35 > Math_fround(0.0);
  f35 = i2 ? f35 : Math_fround(0.0);
  i2 = f36 > Math_fround(0.0);
  f36 = i2 ? f36 : Math_fround(0.0);
  f37 = Math_fround(Math_fround(1.0) - Math_fround(f33 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f37))))));
  f38 = Math_fround(Math_fround(1.0) - Math_fround(f34 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f38))))));
  f39 = Math_fround(Math_fround(1.0) - Math_fround(f35 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f39))))));
  f40 = Math_fround(Math_fround(1.0) - Math_fround(f36 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f40))))));
  i2 = f37 > Math_fround(0.0);
  i3 = f38 > Math_fround(0.0);
  i4 = f39 > Math_fround(0.0);
  i5 = f40 > Math_fround(0.0);
  if (i2 | i3 | i4 | i5) {
   i77 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i81 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i85 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i88 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i78 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
   i82 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i86 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i89 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i79 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i83 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i87 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i90 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i76 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   i80 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i84 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f31 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f27 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f32 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   i75 = f33 > f30;
   i74 = f34 > f31;
   i73 = f35 > f27;
   f25 = Math_fround(f67 * f37);
   f29 = Math_fround(f67 * f38);
   f37 = Math_fround(f67 * f39);
   f40 = Math_fround(f67 * f40);
   f39 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = i2 ? f25 : Math_fround(0.0);
   f39 = Math_fround(f39 * f25);
   f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i90 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f25);
   f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i89 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f25);
   f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i88 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f25);
   f28 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f39 + (i75 ? f28 : Math_fround(0.0)));
   f39 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround(f38 + (f33 > f31 ? f39 : Math_fround(0.0)));
   f38 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(f26 + (f33 > f27 ? f38 : Math_fround(0.0)));
   f26 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f25 + (f33 > f32 ? f26 : Math_fround(0.0)));
   HEAPF32[i1 >> 2] = f28;
   HEAPF32[i7 >> 2] = f39;
   HEAPF32[i9 >> 2] = f38;
   HEAPF32[i41 >> 2] = f33;
   i14 = HEAP32[gb + 1097472 + 4 >> 2] & i87;
   i41 = HEAP32[gb + 1097472 + 8 >> 2] & i86;
   i42 = HEAP32[gb + 1097472 + 12 >> 2] & i85;
   f33 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i84, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = i3 ? f29 : Math_fround(0.0);
   f33 = Math_fround(f29 * f33);
   f38 = Math_fround(f29 * (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f39 = Math_fround(f29 * (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f29 = Math_fround(f29 * (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f28 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround((f34 > f30 ? f28 : Math_fround(0.0)) + f33);
   f28 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround((i74 ? f28 : Math_fround(0.0)) + f38);
   f28 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((f34 > f27 ? f28 : Math_fround(0.0)) + f39);
   f28 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f34 = Math_fround((f34 > f32 ? f28 : Math_fround(0.0)) + f29);
   HEAPF32[i43 >> 2] = f33;
   HEAPF32[i45 >> 2] = f38;
   HEAPF32[i47 >> 2] = f39;
   HEAPF32[i49 >> 2] = f34;
   i48 = HEAP32[gb + 1097472 + 4 >> 2] & i83;
   i49 = HEAP32[gb + 1097472 + 8 >> 2] & i82;
   i50 = HEAP32[gb + 1097472 + 12 >> 2] & i81;
   f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i80, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = i4 ? f37 : Math_fround(0.0);
   f34 = Math_fround(f37 * f34);
   f39 = Math_fround(f37 * (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f38 = Math_fround(f37 * (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f37 = Math_fround(f37 * (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f33 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f34 = Math_fround((f35 > f30 ? f33 : Math_fround(0.0)) + f34);
   f33 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((f35 > f31 ? f33 : Math_fround(0.0)) + f39);
   f33 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround((i73 ? f33 : Math_fround(0.0)) + f38);
   f33 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround((f35 > f32 ? f33 : Math_fround(0.0)) + f37);
   HEAPF32[i51 >> 2] = f34;
   HEAPF32[i53 >> 2] = f39;
   HEAPF32[i55 >> 2] = f38;
   HEAPF32[i57 >> 2] = f37;
   i56 = HEAP32[gb + 1097472 + 4 >> 2] & i79;
   i57 = HEAP32[gb + 1097472 + 8 >> 2] & i78;
   i58 = HEAP32[gb + 1097472 + 12 >> 2] & i77;
   f37 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i76, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = i5 ? f40 : Math_fround(0.0);
   f37 = Math_fround(f40 * f37);
   f38 = Math_fround(f40 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f39 = Math_fround(f40 * (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f40 = Math_fround(f40 * (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f35 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround((i75 ? f35 : Math_fround(0.0)) + f37);
   f35 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround((i74 ? f35 : Math_fround(0.0)) + f38);
   f35 = (HEAP32[tempDoublePtr >> 2] = i64, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = Math_fround((i73 ? f35 : Math_fround(0.0)) + f39);
   f35 = (HEAP32[tempDoublePtr >> 2] = i66, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f40 = Math_fround((f36 > f32 ? f35 : Math_fround(0.0)) + f40);
   HEAPF32[i59 >> 2] = f37;
   HEAPF32[i61 >> 2] = f38;
   HEAPF32[i63 >> 2] = f39;
   HEAPF32[i65 >> 2] = f40;
  }
  i1 = i1 + 64 | 0;
  if (i1 >>> 0 >= i71 >>> 0) break;
  i10 = HEAP32[gb + 1097472 >> 2] | 0;
  i12 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
  i13 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
  i14 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
  i15 = i15 + 64 | 0;
  i16 = i16 + 64 | 0;
 }
 STACKTOP = i72;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i35, i41, i40, i1, i62, i63, i64, i65, i67, i69, i55) {
 i35 = i35 | 0;
 i41 = i41 | 0;
 i40 = i40 | 0;
 i1 = i1 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i67 = i67 | 0;
 i69 = i69 | 0;
 i55 = i55 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i66 = 0, i68 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i70 + 320 | 0;
 i49 = i70 + 500 | 0;
 i48 = i70 + 488 | 0;
 i60 = i70 + 336 | 0;
 i58 = i70 + 256 | 0;
 i59 = i70 + 192 | 0;
 i66 = i70 + 472 | 0;
 i68 = i70 + 456 | 0;
 i42 = i70 + 448 | 0;
 i61 = i70 + 176 | 0;
 i28 = i70 + 160 | 0;
 i29 = i70 + 144 | 0;
 i26 = i70 + 128 | 0;
 i30 = i70 + 436 | 0;
 i31 = i70 + 112 | 0;
 i44 = i70 + 96 | 0;
 i43 = i70 + 80 | 0;
 i51 = i70 + 64 | 0;
 i52 = i70 + 48 | 0;
 i50 = i70 + 424 | 0;
 i38 = i70 + 32 | 0;
 i37 = i70 + 412 | 0;
 i46 = i70 + 16 | 0;
 i47 = i70;
 i45 = i70 + 400 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i39 = i35 + 16 | 0;
 f56 = Math_fround(HEAPF32[i39 >> 2]);
 f57 = Math_fround(HEAPF32[i41 + 16 >> 2]);
 f32 = Math_fround(HEAPF32[i1 >> 2]);
 f36 = Math_fround(HEAPF32[i35 + 32 >> 2]);
 f54 = Math_fround(HEAPF32[i41 + 32 >> 2]);
 f36 = Math_fround((f36 > f54 ? f54 : f36) * Math_fround(.100000001));
 f36 = Math_fround(f36 * f36);
 f54 = Math_fround(f56 + f57);
 HEAP32[i42 >> 2] = 0;
 if (!(HEAP8[i55 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i40 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i40 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i40 + 56 >> 2]);
  i34 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i34 ? f5 : Math_fround(1.0);
  f6 = i34 ? f6 : Math_fround(0.0);
  f7 = i34 ? f7 : Math_fround(0.0);
  HEAPF32[i61 >> 2] = f5;
  HEAPF32[i61 + 4 >> 2] = f6;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i31 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  i34 = i61;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i53 = 8;
 } else {
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = i35 + 144 | 0;
  i3 = i35 + 148 | 0;
  i8 = i35 + 152 | 0;
  i9 = i40 + 48 | 0;
  i10 = i40 + 52 | 0;
  i11 = i40 + 56 | 0;
  i12 = i40 + 16 | 0;
  i13 = i40 + 32 | 0;
  i14 = i40 + 4 | 0;
  i15 = i40 + 20 | 0;
  i16 = i40 + 36 | 0;
  i17 = i40 + 8 | 0;
  i18 = i40 + 24 | 0;
  i19 = i40 + 40 | 0;
  i20 = i41 + 16 | 0;
  i21 = i29 + 4 | 0;
  i22 = i29 + 8 | 0;
  i23 = i28 + 4 | 0;
  i24 = i28 + 8 | 0;
  i25 = i28 + 12 | 0;
  f4 = f56;
  i1 = 0;
  while (1) {
   i33 = HEAPU8[i67 + i1 >> 0] | 0;
   HEAP32[i66 + (i1 << 2) >> 2] = i33;
   i34 = HEAPU8[i69 + i1 >> 0] | 0;
   HEAP32[i68 + (i1 << 2) >> 2] = i34;
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(f6 - f4);
   f5 = Math_fround(f5 - f4);
   f72 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f4);
   f73 = Math_fround(-f6);
   f71 = Math_fround(-f5);
   f27 = Math_fround(-f72);
   f73 = HEAP32[gb + 48 + (i33 << 4) >> 2] | 0 ? f6 : f73;
   f71 = HEAP32[gb + 48 + (i33 << 4) + 4 >> 2] | 0 ? f5 : f71;
   f27 = HEAP32[gb + 48 + (i33 << 4) + 8 >> 2] | 0 ? f72 : f27;
   f72 = Math_fround(HEAPF32[i9 >> 2]);
   f5 = Math_fround(HEAPF32[i10 >> 2]);
   f4 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(f73 * Math_fround(HEAPF32[i40 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f71 * Math_fround(HEAPF32[i12 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2])));
   f7 = Math_fround(f73 * Math_fround(HEAPF32[i14 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f71 * Math_fround(HEAPF32[i15 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f27 * Math_fround(HEAPF32[i16 >> 2])));
   f73 = Math_fround(f73 * Math_fround(HEAPF32[i17 >> 2]));
   f71 = Math_fround(f73 + Math_fround(f71 * Math_fround(HEAPF32[i18 >> 2])));
   f6 = Math_fround(f72 + f6);
   f7 = Math_fround(f5 + f7);
   f27 = Math_fround(f4 + Math_fround(f71 + Math_fround(f27 * Math_fround(HEAPF32[i19 >> 2]))));
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i29, i41, i34, i20);
   f71 = Math_fround(HEAPF32[i29 >> 2]);
   f4 = Math_fround(HEAPF32[i21 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f27 - Math_fround(HEAPF32[i22 >> 2]));
   HEAPF32[i28 >> 2] = Math_fround(f6 - f71);
   HEAPF32[i23 >> 2] = f4;
   HEAPF32[i24 >> 2] = f5;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i34 = HEAP32[i42 >> 2] | 0;
   HEAPF32[i58 + (i34 << 4) >> 2] = f6;
   HEAPF32[i58 + (i34 << 4) + 4 >> 2] = f7;
   HEAPF32[i58 + (i34 << 4) + 8 >> 2] = f27;
   HEAPF32[i58 + (i34 << 4) + 12 >> 2] = Math_fround(0.0);
   i33 = i59 + (i34 << 4) | 0;
   HEAP32[i33 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   HEAP32[i42 >> 2] = i34 + 1;
   i34 = i60 + (i34 << 4) | 0;
   HEAP32[i34 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i34 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAPU8[i55 >> 0] | 0) >>> 0) break;
   f4 = Math_fround(HEAPF32[i39 >> 2]);
  }
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i26, i60, i58, i59, i66, i68, i28, i42);
  HEAP32[i61 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i61 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i49 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i48 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i31 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  if (f4 > f36) {
   i34 = i61;
   i53 = 8;
  } else i2 = HEAP32[i42 >> 2] | 0;
 }
 do if ((i53 | 0) == 8) {
  i30 = i61 + 4 | 0;
  i33 = i61 + 8 | 0;
  i10 = i35 + 144 | 0;
  i11 = i35 + 148 | 0;
  i12 = i35 + 152 | 0;
  i13 = i40 + 4 | 0;
  i14 = i40 + 8 | 0;
  i15 = i40 + 16 | 0;
  i16 = i40 + 20 | 0;
  i17 = i40 + 24 | 0;
  i18 = i40 + 32 | 0;
  i19 = i40 + 36 | 0;
  i20 = i40 + 40 | 0;
  i21 = i40 + 48 | 0;
  i22 = i40 + 52 | 0;
  i23 = i40 + 56 | 0;
  i24 = i44 + 4 | 0;
  i25 = i44 + 8 | 0;
  i26 = i43 + 4 | 0;
  i28 = i43 + 8 | 0;
  i29 = i43 + 12 | 0;
  i8 = i35 + 48 | 0;
  i9 = i41 + 48 | 0;
  while (1) {
   HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i31 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   f83 = Math_fround(-f5);
   f71 = Math_fround(-f6);
   f5 = Math_fround(-f7);
   i3 = HEAP32[i42 >> 2] | 0;
   f81 = Math_fround(HEAPF32[i10 >> 2]);
   f77 = Math_fround(HEAPF32[i11 >> 2]);
   f79 = Math_fround(HEAPF32[i12 >> 2]);
   f80 = Math_fround(HEAPF32[i39 >> 2]);
   f81 = Math_fround(f81 - f80);
   f77 = Math_fround(f77 - f80);
   f80 = Math_fround(f79 - f80);
   f79 = Math_fround(HEAPF32[i40 >> 2]);
   f82 = Math_fround(f79 * f83);
   f76 = Math_fround(HEAPF32[i13 >> 2]);
   f82 = Math_fround(f82 + Math_fround(f76 * f71));
   f74 = Math_fround(HEAPF32[i14 >> 2]);
   f82 = Math_fround(f82 + Math_fround(f74 * f5));
   f78 = Math_fround(HEAPF32[i15 >> 2]);
   f73 = Math_fround(f78 * f83);
   f75 = Math_fround(HEAPF32[i16 >> 2]);
   f73 = Math_fround(f73 + Math_fround(f75 * f71));
   f27 = Math_fround(HEAPF32[i17 >> 2]);
   f73 = Math_fround(f73 + Math_fround(f27 * f5));
   f72 = Math_fround(HEAPF32[i18 >> 2]);
   f7 = Math_fround(f72 * f83);
   f6 = Math_fround(HEAPF32[i19 >> 2]);
   f71 = Math_fround(f7 + Math_fround(f6 * f71));
   f7 = Math_fround(HEAPF32[i20 >> 2]);
   i1 = f82 > Math_fround(0.0);
   i35 = f73 > Math_fround(0.0);
   i2 = Math_fround(f71 + Math_fround(f7 * f5)) > Math_fround(0.0);
   HEAP32[i66 + (i3 << 2) >> 2] = i35 << 31 >> 31 << 1 & 2 | i1 & 1 | i2 << 31 >> 31 << 2 & 4;
   f5 = Math_fround(-f81);
   f71 = Math_fround(-f77);
   f73 = Math_fround(-f80);
   f5 = i1 ? f81 : f5;
   f71 = i35 ? f77 : f71;
   f73 = i2 ? f80 : f73;
   f80 = Math_fround(HEAPF32[i21 >> 2]);
   f77 = Math_fround(HEAPF32[i22 >> 2]);
   f72 = Math_fround(f80 + Math_fround(Math_fround(Math_fround(f79 * f5) + Math_fround(f78 * f71)) + Math_fround(f72 * f73)));
   f6 = Math_fround(f77 + Math_fround(Math_fround(Math_fround(f76 * f5) + Math_fround(f75 * f71)) + Math_fround(f6 * f73)));
   f73 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + Math_fround(Math_fround(Math_fround(f74 * f5) + Math_fround(f27 * f71)) + Math_fround(f7 * f73)));
   HEAPF32[i58 + (i3 << 4) >> 2] = f72;
   HEAPF32[i58 + (i3 << 4) + 4 >> 2] = f6;
   HEAPF32[i58 + (i3 << 4) + 8 >> 2] = f73;
   HEAPF32[i58 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i44, i41, i61, i59 + (i3 << 4) | 0, i68 + (i3 << 2) | 0);
   f7 = Math_fround(HEAPF32[i44 >> 2]);
   f71 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(f72 - f7);
   f71 = Math_fround(f6 - f71);
   f73 = Math_fround(f73 - Math_fround(HEAPF32[i25 >> 2]));
   HEAPF32[i43 >> 2] = f7;
   HEAPF32[i26 >> 2] = f71;
   HEAPF32[i28 >> 2] = f73;
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i42 >> 2] | 0;
   i2 = i60 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i8 >> 2]);
   f72 = Math_fround(HEAPF32[i9 >> 2]);
   f72 = f6 > f72 ? f6 : f72;
   f32 = f32 > f72 ? f32 : f72;
   f72 = Math_fround(f54 + f32);
   f72 = Math_fround(f4 * Math_fround(f72 * f72));
   f6 = Math_fround(HEAPF32[i61 >> 2]);
   f27 = Math_fround(HEAPF32[i30 >> 2]);
   f73 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f27 * f71)) + Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f73));
   i2 = f73 > Math_fround(0.0) & Math_fround(f73 * f73) > f72;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f73) | i2) {
    i53 = 10;
    break;
   }
   HEAP32[i42 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i38, i60, i58, i59, i66, i68, i43, i42);
   HEAP32[i34 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i34 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i30 >> 2]);
   f7 = Math_fround(HEAPF32[i33 >> 2]);
   f27 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i49 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   i1 = f4 > f27;
   if (!(f27 > f36 & i1)) break; else f4 = f27;
  }
  if ((i53 | 0) == 10) {
   if (i67 | 0) {
    HEAP8[i55 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
      HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i69 = 0;
    STACKTOP = i70;
    return i69 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i51, i52, i3);
   f80 = Math_fround(Math_sqrt(Math_fround(f4)));
   f81 = Math_fround(HEAPF32[i61 >> 2]);
   f82 = Math_fround(HEAPF32[i30 >> 2]);
   f83 = Math_fround(Math_fround(1.0) / f80);
   f81 = Math_fround(f81 * f83);
   f82 = Math_fround(f82 * f83);
   f83 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f83);
   f79 = Math_fround(HEAPF32[i51 >> 2]);
   f78 = Math_fround(HEAPF32[i51 + 4 >> 2]);
   f78 = Math_fround(f78 - Math_fround(f56 * f82));
   f77 = Math_fround(Math_fround(HEAPF32[i51 + 8 >> 2]) - Math_fround(f56 * f83));
   HEAPF32[i62 >> 2] = Math_fround(f79 - Math_fround(f56 * f81));
   HEAPF32[i62 + 4 >> 2] = f78;
   HEAPF32[i62 + 8 >> 2] = f77;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   f77 = Math_fround(HEAPF32[i52 >> 2]);
   f78 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f78 = Math_fround(Math_fround(f57 * f82) + f78);
   f79 = Math_fround(Math_fround(f57 * f83) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f81) + f77);
   HEAPF32[i63 + 4 >> 2] = f78;
   HEAPF32[i63 + 8 >> 2] = f79;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i65 >> 2] = Math_fround(f80 - f54);
   i69 = i65 + 4 | 0;
   HEAP32[i69 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i69 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i69 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAPF32[i64 >> 2] = f81;
   HEAPF32[i64 + 4 >> 2] = f82;
   HEAPF32[i64 + 8 >> 2] = f83;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   i69 = 1;
   STACKTOP = i70;
   return i69 | 0;
  }
  i2 = HEAP32[i42 >> 2] | 0;
  if (i1) {
   if (!i67) i1 = 6; else break;
   STACKTOP = i70;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i67 | 0) {
   HEAP8[i55 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
     HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i34 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i46, i47, i2);
  HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  f80 = Math_fround(Math_sqrt(Math_fround(f4)));
  f81 = Math_fround(HEAPF32[i61 >> 2]);
  f82 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f83 = Math_fround(Math_fround(1.0) / f80);
  f81 = Math_fround(f81 * f83);
  f82 = Math_fround(f82 * f83);
  f83 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) * f83);
  f79 = Math_fround(HEAPF32[i46 >> 2]);
  f78 = Math_fround(HEAPF32[i46 + 4 >> 2]);
  f78 = Math_fround(f78 - Math_fround(f56 * f82));
  f77 = Math_fround(Math_fround(HEAPF32[i46 + 8 >> 2]) - Math_fround(f56 * f83));
  HEAPF32[i62 >> 2] = Math_fround(f79 - Math_fround(f56 * f81));
  HEAPF32[i62 + 4 >> 2] = f78;
  HEAPF32[i62 + 8 >> 2] = f77;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  f77 = Math_fround(HEAPF32[i47 >> 2]);
  f78 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f78 = Math_fround(Math_fround(f57 * f82) + f78);
  f79 = Math_fround(Math_fround(f57 * f83) + Math_fround(HEAPF32[i47 + 8 >> 2]));
  HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f81) + f77);
  HEAPF32[i63 + 4 >> 2] = f78;
  HEAPF32[i63 + 8 >> 2] = f79;
  HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i65 >> 2] = Math_fround(f80 - f54);
  i69 = i65 + 4 | 0;
  HEAP32[i69 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i69 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i69 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAPF32[i64 >> 2] = f81;
  HEAPF32[i64 + 4 >> 2] = f82;
  HEAPF32[i64 + 8 >> 2] = f83;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  i69 = 3;
  STACKTOP = i70;
  return i69 | 0;
 } while (0);
 HEAP8[i55 >> 0] = i2;
 if (!i2) {
  i69 = 6;
  STACKTOP = i70;
  return i69 | 0;
 } else i1 = 0;
 do {
  HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
  HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i70;
 return i1 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i61, i62, i1, i63, i64, i58, i66, i47, i49, i41, i65) {
 i61 = i61 | 0;
 i62 = i62 | 0;
 i1 = i1 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i58 = i58 | 0;
 i66 = i66 | 0;
 i47 = i47 | 0;
 i49 = i49 | 0;
 i41 = i41 | 0;
 i65 = i65 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f59 = f0, f60 = f0, i67 = 0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i67 + 476 | 0;
 i38 = i67 + 464 | 0;
 i57 = i67 + 208 | 0;
 i56 = i67 + 288 | 0;
 i54 = i67 + 224 | 0;
 i55 = i67 + 144 | 0;
 i46 = i67 + 448 | 0;
 i48 = i67 + 432 | 0;
 i37 = i67 + 128 | 0;
 i36 = i67 + 424 | 0;
 i17 = i67 + 112 | 0;
 i18 = i67 + 412 | 0;
 i19 = i67 + 96 | 0;
 i34 = i67 + 80 | 0;
 i50 = i67 + 64 | 0;
 i53 = i67 + 48 | 0;
 i51 = i67 + 400 | 0;
 i52 = i67 + 388 | 0;
 i35 = i67 + 32 | 0;
 i33 = i67 + 376 | 0;
 i42 = i67 + 16 | 0;
 i45 = i67;
 i44 = i67 + 364 | 0;
 i43 = i67 + 352 | 0;
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f59 = Math_fround(HEAPF32[i61 + 16 >> 2]);
 f60 = Math_fround(HEAPF32[i62 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i61 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i62 + 32 >> 2]);
 f29 = Math_fround((f29 > f3 ? f3 : f29) * Math_fround(.100000001));
 f29 = Math_fround(f29 * f29);
 f3 = Math_fround(f59 + f60);
 i30 = i37 + 4 | 0;
 i31 = i37 + 8 | 0;
 i32 = i37 + 12 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 i1 = HEAP8[i41 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f15 = Math_fround(HEAPF32[i61 >> 2]);
  f4 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i62 >> 2]);
  f6 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f5 = Math_fround(f15 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i62 + 8 >> 2]));
  i27 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i27 ? f5 : Math_fround(1.0);
  f6 = i27 ? f6 : Math_fround(0.0);
  f7 = i27 ? f7 : Math_fround(0.0);
  HEAPF32[i57 >> 2] = f5;
  HEAPF32[i57 + 4 >> 2] = f6;
  HEAPF32[i57 + 8 >> 2] = f7;
  HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i19 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
  i27 = i57;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i40 = 6;
 } else {
  i16 = i61 + 96 | 0;
  i14 = HEAP32[i62 + 200 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i62 + 96 >> 2]);
  f5 = Math_fround(HEAPF32[i62 + 112 >> 2]);
  f6 = Math_fround(HEAPF32[i62 + 128 >> 2]);
  f7 = Math_fround(HEAPF32[i62 + 100 >> 2]);
  f8 = Math_fround(HEAPF32[i62 + 116 >> 2]);
  f9 = Math_fround(HEAPF32[i62 + 132 >> 2]);
  f10 = Math_fround(HEAPF32[i62 + 104 >> 2]);
  f12 = Math_fround(HEAPF32[i62 + 120 >> 2]);
  f15 = Math_fround(HEAPF32[i62 + 136 >> 2]);
  i2 = i1 & 255;
  i11 = 0;
  i13 = 0;
  while (1) {
   i1 = HEAPU8[i47 + i13 >> 0] | 0;
   HEAP32[i46 + (i13 << 2) >> 2] = i1;
   i27 = HEAPU8[i49 + i13 >> 0] | 0;
   HEAP32[i48 + (i13 << 2) >> 2] = i27;
   i1 = 1 - i1 | 0;
   f73 = Math_fround(HEAPF32[i16 + (i1 << 4) >> 2]);
   f72 = Math_fround(HEAPF32[i16 + (i1 << 4) + 4 >> 2]);
   f71 = Math_fround(HEAPF32[i16 + (i1 << 4) + 8 >> 2]);
   i1 = HEAP32[i16 + (i1 << 4) + 12 >> 2] | 0;
   f74 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) >> 2]);
   f75 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 4 >> 2]);
   f68 = Math_fround(HEAPF32[i14 + (i27 * 12 | 0) + 8 >> 2]);
   f70 = Math_fround(Math_fround(Math_fround(f74 * f4) + Math_fround(f75 * f5)) + Math_fround(f68 * f6));
   f69 = Math_fround(Math_fround(Math_fround(f74 * f7) + Math_fround(f75 * f8)) + Math_fround(f68 * f9));
   f68 = Math_fround(Math_fround(Math_fround(f74 * f10) + Math_fround(f75 * f12)) + Math_fround(f68 * f15));
   f75 = Math_fround(f72 - f69);
   f74 = Math_fround(f71 - f68);
   HEAPF32[i37 >> 2] = Math_fround(f73 - f70);
   HEAPF32[i30 >> 2] = f75;
   HEAPF32[i31 >> 2] = f74;
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   HEAPF32[i54 + (i11 << 4) >> 2] = f73;
   HEAPF32[i54 + (i11 << 4) + 4 >> 2] = f72;
   HEAPF32[i54 + (i11 << 4) + 8 >> 2] = f71;
   HEAP32[i54 + (i11 << 4) + 12 >> 2] = i1;
   HEAPF32[i55 + (i11 << 4) >> 2] = f70;
   HEAPF32[i55 + (i11 << 4) + 4 >> 2] = f69;
   HEAPF32[i55 + (i11 << 4) + 8 >> 2] = f68;
   HEAPF32[i55 + (i11 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = i11 + 1 | 0;
   i27 = i56 + (i11 << 4) | 0;
   HEAP32[i27 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   i13 = i13 + 1 | 0;
   if (i13 >>> 0 >= i2 >>> 0) break; else i11 = i1;
  }
  HEAP32[i36 >> 2] = i1;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i17, i56, i54, i55, i46, i48, i37, i36);
  HEAP32[i57 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i57 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i57 >> 2]);
  f6 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i57 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i39 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i38 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
  if (f4 > f29) {
   i27 = i57;
   i40 = 6;
  }
 }
 do if ((i40 | 0) == 6) {
  i2 = i57 + 4 | 0;
  i14 = i57 + 8 | 0;
  i16 = i61 + 96 | 0;
  i17 = i61 + 100 | 0;
  i18 = i61 + 104 | 0;
  i20 = i61 + 112 | 0;
  i21 = i61 + 116 | 0;
  i22 = i61 + 120 | 0;
  i23 = i34 + 4 | 0;
  i24 = i34 + 8 | 0;
  i25 = i61 + 48 | 0;
  i26 = i62 + 48 | 0;
  f8 = f28;
  f15 = f4;
  while (1) {
   HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i38 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i38 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   f70 = Math_fround(-f5);
   f71 = Math_fround(-f6);
   f6 = Math_fround(-f7);
   i13 = HEAP32[i36 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i16 >> 2]);
   f73 = Math_fround(HEAPF32[i17 >> 2]);
   f72 = Math_fround(HEAPF32[i18 >> 2]);
   f69 = Math_fround(Math_fround(Math_fround(f5 * f70) + Math_fround(f73 * f71)) + Math_fround(f72 * f6));
   f74 = Math_fround(HEAPF32[i20 >> 2]);
   f4 = Math_fround(HEAPF32[i21 >> 2]);
   f75 = Math_fround(HEAPF32[i22 >> 2]);
   i11 = f69 > Math_fround(Math_fround(Math_fround(f74 * f70) + Math_fround(f4 * f71)) + Math_fround(f75 * f6));
   HEAP32[i46 + (i13 << 2) >> 2] = i11 & 1;
   f74 = i11 ? f5 : f74;
   f4 = i11 ? f73 : f4;
   f75 = i11 ? f72 : f75;
   HEAPF32[i54 + (i13 << 4) >> 2] = f74;
   HEAPF32[i54 + (i13 << 4) + 4 >> 2] = f4;
   HEAPF32[i54 + (i13 << 4) + 8 >> 2] = f75;
   HEAPF32[i54 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i34, i62, i57, i55 + (i13 << 4) | 0, i48 + (i13 << 2) | 0);
   f72 = Math_fround(HEAPF32[i34 >> 2]);
   f73 = Math_fround(HEAPF32[i23 >> 2]);
   f72 = Math_fround(f74 - f72);
   f73 = Math_fround(f4 - f73);
   f75 = Math_fround(f75 - Math_fround(HEAPF32[i24 >> 2]));
   HEAPF32[i37 >> 2] = f72;
   HEAPF32[i30 >> 2] = f73;
   HEAPF32[i31 >> 2] = f75;
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i36 >> 2] | 0;
   i11 = i56 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i25 >> 2]);
   f74 = Math_fround(HEAPF32[i26 >> 2]);
   f74 = f4 > f74 ? f4 : f74;
   f8 = f8 > f74 ? f8 : f74;
   f74 = Math_fround(f3 + f8);
   f74 = Math_fround(f15 * Math_fround(f74 * f74));
   f4 = Math_fround(HEAPF32[i57 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f4 * f72) + Math_fround(f5 * f73)) + Math_fround(f6 * f75));
   i11 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f74;
   if (Math_fround(f15 * Math_fround(.00039999999)) >= Math_fround(f15 - f75) | i11) {
    f7 = f15;
    i40 = 8;
    break;
   }
   HEAP32[i36 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i35, i56, i54, i55, i46, i48, i37, i36);
   HEAP32[i27 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i57 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i39 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   i1 = f15 > f4;
   if (!(f4 > f29 & i1)) break; else f15 = f4;
  }
  if ((i40 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i47 | 0) {
    HEAP8[i41 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
      HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i66 = 0;
    STACKTOP = i67;
    return i66 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i58 >> 2] = f9;
   HEAPF32[i58 + 4 >> 2] = f8;
   HEAPF32[i58 + 8 >> 2] = f7;
   HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i57, i50, i53, i13);
   f5 = Math_fround(HEAPF32[i50 >> 2]);
   f6 = Math_fround(HEAPF32[i50 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i50 + 8 >> 2]);
   if (i65) {
    f74 = HEAP32[i61 + 64 >> 2] | 0 ? Math_fround(0.0) : f59;
    f71 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
    f75 = Math_fround(f74 + f71);
    f73 = Math_fround(f6 - Math_fround(f8 * f74));
    f72 = Math_fround(f4 - Math_fround(f7 * f74));
    HEAPF32[i63 >> 2] = Math_fround(f5 - Math_fround(f9 * f74));
    HEAPF32[i63 + 4 >> 2] = f73;
    HEAPF32[i63 + 8 >> 2] = f72;
    HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
    f72 = Math_fround(HEAPF32[i53 >> 2]);
    f73 = Math_fround(HEAPF32[i53 + 4 >> 2]);
    f73 = Math_fround(Math_fround(f8 * f71) + f73);
    f74 = Math_fround(Math_fround(f7 * f71) + Math_fround(HEAPF32[i53 + 8 >> 2]));
    HEAPF32[i64 >> 2] = Math_fround(Math_fround(f9 * f71) + f72);
    HEAPF32[i64 + 4 >> 2] = f73;
    HEAPF32[i64 + 8 >> 2] = f74;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i66 >> 2] = Math_fround(f10 - f75);
    i66 = i66 + 4 | 0;
    HEAP32[i66 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i66 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
    HEAP32[i66 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
    i66 = 1;
    STACKTOP = i67;
    return i66 | 0;
   } else {
    f74 = Math_fround(f6 - Math_fround(f59 * f8));
    f73 = Math_fround(f4 - Math_fround(f59 * f7));
    HEAPF32[i63 >> 2] = Math_fround(f5 - Math_fround(f59 * f9));
    HEAPF32[i63 + 4 >> 2] = f74;
    HEAPF32[i63 + 8 >> 2] = f73;
    HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
    f73 = Math_fround(HEAPF32[i53 >> 2]);
    f74 = Math_fround(HEAPF32[i53 + 4 >> 2]);
    f74 = Math_fround(Math_fround(f60 * f8) + f74);
    f75 = Math_fround(Math_fround(f60 * f7) + Math_fround(HEAPF32[i53 + 8 >> 2]));
    HEAPF32[i64 >> 2] = Math_fround(Math_fround(f60 * f9) + f73);
    HEAPF32[i64 + 4 >> 2] = f74;
    HEAPF32[i64 + 8 >> 2] = f75;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i66 >> 2] = Math_fround(f10 - f3);
    i66 = i66 + 4 | 0;
    HEAP32[i66 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i66 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i66 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    i66 = 1;
    STACKTOP = i67;
    return i66 | 0;
   }
  }
  if (i1) {
   if (!i47) i1 = 6; else break;
   STACKTOP = i67;
   return i1 | 0;
  };
  HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  i11 = HEAP32[i36 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i47 | 0) {
   HEAP8[i41 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
     HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i27 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i57, i42, i45, i11);
  HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f15)));
  f9 = Math_fround(HEAPF32[i57 >> 2]);
  f10 = Math_fround(HEAPF32[i57 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i57 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i42 >> 2]);
  f6 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  if (i65) {
   f75 = HEAP32[i61 + 64 >> 2] | 0 ? Math_fround(0.0) : f59;
   f72 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
   f3 = Math_fround(f75 + f72);
   f74 = Math_fround(f6 - Math_fround(f10 * f75));
   f73 = Math_fround(f4 - Math_fround(f7 * f75));
   HEAPF32[i63 >> 2] = Math_fround(f5 - Math_fround(f9 * f75));
   HEAPF32[i63 + 4 >> 2] = f74;
   HEAPF32[i63 + 8 >> 2] = f73;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   f73 = Math_fround(HEAPF32[i45 >> 2]);
   f74 = Math_fround(HEAPF32[i45 + 4 >> 2]);
   f74 = Math_fround(Math_fround(f10 * f72) + f74);
   f75 = Math_fround(Math_fround(f7 * f72) + Math_fround(HEAPF32[i45 + 8 >> 2]));
   HEAPF32[i64 >> 2] = Math_fround(Math_fround(f9 * f72) + f73);
   HEAPF32[i64 + 4 >> 2] = f74;
   HEAPF32[i64 + 8 >> 2] = f75;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   i65 = i66 + 4 | 0;
   HEAP32[i65 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i65 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i65 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  } else {
   f74 = Math_fround(f6 - Math_fround(f59 * f10));
   f73 = Math_fround(f4 - Math_fround(f59 * f7));
   HEAPF32[i63 >> 2] = Math_fround(f5 - Math_fround(f59 * f9));
   HEAPF32[i63 + 4 >> 2] = f74;
   HEAPF32[i63 + 8 >> 2] = f73;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   f73 = Math_fround(HEAPF32[i45 >> 2]);
   f74 = Math_fround(HEAPF32[i45 + 4 >> 2]);
   f74 = Math_fround(Math_fround(f60 * f10) + f74);
   f75 = Math_fround(Math_fround(f60 * f7) + Math_fround(HEAPF32[i45 + 8 >> 2]));
   HEAPF32[i64 >> 2] = Math_fround(Math_fround(f60 * f9) + f73);
   HEAPF32[i64 + 4 >> 2] = f74;
   HEAPF32[i64 + 8 >> 2] = f75;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   i65 = i66 + 4 | 0;
   HEAP32[i65 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i65 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i65 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  }
  HEAPF32[i66 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i58 >> 2] = f9;
  HEAPF32[i58 + 4 >> 2] = f10;
  HEAPF32[i58 + 8 >> 2] = f7;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  i66 = f12 >= f15 ? 1 : 3;
  STACKTOP = i67;
  return i66 | 0;
 } while (0);
 i2 = HEAP32[i36 >> 2] | 0;
 HEAP8[i41 >> 0] = i2;
 if (!i2) {
  i66 = 6;
  STACKTOP = i67;
  return i66 | 0;
 } else i1 = 0;
 do {
  HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
  HEAP8[i49 + i1 >> 0] = HEAP32[i48 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i67;
 return i1 | 0;
}

function __ZL30InitializeCoreScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(480, gb + 63728 | 0, 16, gb + 589188 | 0, 16) | 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 HEAP32[i2 + 152 >> 2] = 0;
 HEAP32[i2 + 164 >> 2] = 0;
 HEAP32[i2 + 172 >> 2] = 0;
 HEAP32[i2 + 180 >> 2] = 0;
 HEAP32[i2 + 228 >> 2] = 0;
 HEAP32[i2 + 236 >> 2] = 0;
 HEAP32[i2 + 292 >> 2] = 0;
 HEAP32[i2 + 332 >> 2] = 0;
 HEAP32[i2 + 340 >> 2] = 0;
 HEAP32[i2 + 348 >> 2] = 0;
 HEAP32[i2 + 360 >> 2] = 0;
 HEAP32[i2 + 368 >> 2] = 0;
 HEAP32[i2 + 392 >> 2] = 0;
 HEAP32[i2 + 400 >> 2] = 0;
 HEAP32[i2 + 412 >> 2] = 0;
 HEAP32[i2 + 420 >> 2] = 0;
 HEAP32[i2 + 428 >> 2] = 0;
 HEAP32[i2 + 436 >> 2] = 0;
 HEAP32[gb + 1451044 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589309 | 0) | 0;
 HEAP32[HEAP32[gb + 1451044 >> 2] >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589327 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 4 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1034188 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 8 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 902235 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i2;
 i4 = i4 + 16 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 597861 | 0, gb + 589344 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589360 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 24 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589385 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 28 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589410 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 32 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589429 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = i4;
 i2 = i2 + 40 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589444 | 0, gb + 589466 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 48 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589444 | 0, gb + 589486 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 56 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589444 | 0, gb + 589514 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 64 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589444 | 0, gb + 589556 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 72 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856878 | 0, gb + 856892 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589578 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 80 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589589 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 84 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589596 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 88 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044265 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 92 >> 2] = i2;
 i4 = i4 + 96 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044265 | 0, gb + 589607 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 104 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044265 | 0, gb + 589624 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 112 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044265 | 0, gb + 589638 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589654 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 120 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589660 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 124 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589668 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 128 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589678 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 132 >> 2] = i4;
 i2 = i2 + 136 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589688 | 0, gb + 589701 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589712 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 144 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589734 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 148 >> 2] = i2;
 i4 = i4 + 152 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589734 | 0, gb + 589751 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589780 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 160 >> 2] = i4;
 i2 = i2 + 164 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589780 | 0, gb + 589788 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 172 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589780 | 0, gb + 589808 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 180 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 589828 | 0, gb + 589837 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 589866 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 188 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 589887 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 192 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 589896 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 196 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1033990 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 200 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589911 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 204 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589928 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 208 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589945 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 212 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589961 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 216 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 589979 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 220 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590006 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 224 >> 2] = i2;
 i4 = i4 + 228 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590006 | 0, gb + 590037 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 236 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590006 | 0, gb + 590056 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1034351 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 244 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590074 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 248 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590084 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 252 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590097 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 256 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590101 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 260 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590111 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 264 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590125 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 268 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590132 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 272 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 590158 | 0, gb + 609258 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 276 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590180 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 280 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590191 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 284 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1033949 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 288 >> 2] = i4;
 i2 = i2 + 292 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590196 | 0, gb + 590210 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 590238 | 0, gb + 590260 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 300 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 590238 | 0, gb + 590274 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 304 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 590238 | 0, gb + 590293 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 308 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 590238 | 0, gb + 590318 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 312 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590339 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 316 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590353 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 320 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590364 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 324 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 590380 | 0, gb + 590408 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 328 >> 2] = i2;
 i4 = i4 + 332 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 590380 | 0, gb + 590408 | 0, gb + 590421 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 340 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 590380 | 0, gb + 590408 | 0, gb + 590449 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 348 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 590380 | 0, gb + 590408 | 0, gb + 590470 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590493 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 356 >> 2] = i4;
 i2 = i2 + 360 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590510 | 0, gb + 590526 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 368 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590510 | 0, gb + 590544 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 590558 | 0, gb + 590584 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 376 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590614 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 380 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590629 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 384 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590655 | 0) | 0;
 i4 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i4 + 388 >> 2] = i2;
 i4 = i4 + 392 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590655 | 0, gb + 590670 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1451044 >> 2] | 0) + 400 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590655 | 0, gb + 590683 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590698 | 0) | 0;
 i2 = HEAP32[gb + 1451044 >> 2] | 0;
 HEAP32[i2 + 408 >> 2] = i4;
 i2 = i2 + 412 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590730 | 0, gb + 590748 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 420 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590730 | 0, gb + 590766 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 428 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590730 | 0, gb + 590788 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1451044 >> 2] | 0) + 436 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 590730 | 0, gb + 590823 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590840 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 444 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590862 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 448 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590877 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 452 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590885 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 456 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590893 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 460 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590901 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 464 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590919 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 468 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590938 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 472 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 590953 | 0) | 0;
 HEAP32[(HEAP32[gb + 1451044 >> 2] | 0) + 476 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN5physx27collideWithConvexPlanesSIMDERNS_21PxsParticleCollDataV4EPKNS_7PxPlaneEjf(i105, i1, i71, f106) {
 i105 = i105 | 0;
 i1 = i1 | 0;
 i71 = i71 | 0;
 f106 = Math_fround(f106);
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, i70 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f107 = f0, i108 = 0, f109 = f0, i110 = 0, i111 = 0, f112 = f0, i113 = 0, i114 = 0, f115 = f0, i116 = 0, i117 = 0, f118 = f0, f119 = f0, f120 = f0, f121 = f0, f122 = f0, f123 = f0, f124 = f0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0, i137 = 0;
 i72 = i105 + 80 | 0;
 f73 = Math_fround(HEAPF32[i72 >> 2]);
 f84 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f95 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f103 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 16 | 0;
 f104 = Math_fround(HEAPF32[i72 >> 2]);
 f74 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f75 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f76 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 96 | 0;
 f77 = Math_fround(HEAPF32[i72 >> 2]);
 f78 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f79 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f80 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 32 | 0;
 f81 = Math_fround(HEAPF32[i72 >> 2]);
 f82 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f83 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f85 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 112 | 0;
 f86 = Math_fround(HEAPF32[i72 >> 2]);
 f87 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f88 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f89 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 48 | 0;
 f90 = Math_fround(HEAPF32[i72 >> 2]);
 f91 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f92 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f93 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 128 | 0;
 f94 = Math_fround(HEAPF32[i72 >> 2]);
 f96 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f97 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f98 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 i72 = i105 + 64 | 0;
 f99 = Math_fround(HEAPF32[i72 >> 2]);
 f100 = Math_fround(HEAPF32[i72 + 4 >> 2]);
 f101 = Math_fround(HEAPF32[i72 + 8 >> 2]);
 f102 = Math_fround(HEAPF32[i72 + 12 >> 2]);
 f58 = Math_fround(f73 - f104);
 f59 = Math_fround(f84 - f74);
 f60 = Math_fround(f95 - f75);
 f61 = Math_fround(f77 - f81);
 f62 = Math_fround(f78 - f82);
 f63 = Math_fround(f79 - f83);
 f64 = Math_fround(f86 - f90);
 f65 = Math_fround(f87 - f91);
 f66 = Math_fround(f88 - f92);
 f67 = Math_fround(f94 - f99);
 f68 = Math_fround(f96 - f100);
 f69 = Math_fround(f97 - f101);
 if (!i71) {
  f2 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f26 = Math_fround(3402823469999999843913219.0e14);
  f29 = Math_fround(3402823469999999843913219.0e14);
  f32 = Math_fround(3402823469999999843913219.0e14);
  f35 = Math_fround(3402823469999999843913219.0e14);
  f54 = Math_fround(-3402823469999999843913219.0e14);
  f56 = Math_fround(-3402823469999999843913219.0e14);
  f55 = Math_fround(-3402823469999999843913219.0e14);
  f53 = Math_fround(-3402823469999999843913219.0e14);
  f52 = Math_fround(-3402823469999999843913219.0e14);
  f51 = Math_fround(-3402823469999999843913219.0e14);
  f50 = Math_fround(-3402823469999999843913219.0e14);
  f49 = Math_fround(-3402823469999999843913219.0e14);
  f48 = Math_fround(0.0);
  f47 = Math_fround(0.0);
  f46 = Math_fround(0.0);
  f45 = Math_fround(0.0);
  f44 = Math_fround(0.0);
  f43 = Math_fround(0.0);
  f42 = Math_fround(0.0);
  f41 = Math_fround(0.0);
  f40 = Math_fround(0.0);
  f39 = Math_fround(0.0);
  f38 = Math_fround(0.0);
  f37 = Math_fround(0.0);
  f36 = Math_fround(0.0);
  f34 = Math_fround(0.0);
  f33 = Math_fround(0.0);
  f31 = Math_fround(0.0);
  f30 = Math_fround(0.0);
  f28 = Math_fround(0.0);
  f27 = Math_fround(0.0);
  f25 = Math_fround(0.0);
  f24 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f21 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  i6 = 1;
  i4 = 1;
  i3 = 1;
  i1 = 1;
 } else {
  f49 = Math_fround(-3402823469999999843913219.0e14);
  f50 = Math_fround(-3402823469999999843913219.0e14);
  f51 = Math_fround(-3402823469999999843913219.0e14);
  f52 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f53 = Math_fround(-3402823469999999843913219.0e14);
  f55 = Math_fround(-3402823469999999843913219.0e14);
  f56 = Math_fround(-3402823469999999843913219.0e14);
  f54 = Math_fround(-3402823469999999843913219.0e14);
  f37 = Math_fround(0.0);
  f38 = Math_fround(0.0);
  f39 = Math_fround(0.0);
  f40 = Math_fround(0.0);
  f41 = Math_fround(0.0);
  f42 = Math_fround(0.0);
  f43 = Math_fround(0.0);
  f44 = Math_fround(0.0);
  f45 = Math_fround(0.0);
  f46 = Math_fround(0.0);
  f47 = Math_fround(0.0);
  f48 = Math_fround(0.0);
  i3 = 0;
  i4 = 0;
  i6 = 0;
  i57 = 0;
  f35 = Math_fround(3402823469999999843913219.0e14);
  f32 = Math_fround(3402823469999999843913219.0e14);
  f29 = Math_fround(3402823469999999843913219.0e14);
  f26 = Math_fround(3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
  f21 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f24 = Math_fround(0.0);
  f25 = Math_fround(0.0);
  f27 = Math_fround(0.0);
  f28 = Math_fround(0.0);
  f30 = Math_fround(0.0);
  f31 = Math_fround(0.0);
  f33 = Math_fround(0.0);
  f34 = Math_fround(0.0);
  f36 = Math_fround(0.0);
  i70 = 0;
  while (1) {
   f124 = Math_fround(HEAPF32[i1 >> 2]);
   f123 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f122 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f107 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f118 = Math_fround(Math_fround(f95 * f122) + Math_fround(Math_fround(f84 * f123) + Math_fround(Math_fround(f73 * f124) + f107)));
   f119 = Math_fround(Math_fround(f79 * f122) + Math_fround(Math_fround(f78 * f123) + Math_fround(Math_fround(f77 * f124) + f107)));
   f120 = Math_fround(Math_fround(f88 * f122) + Math_fround(Math_fround(f87 * f123) + Math_fround(Math_fround(f86 * f124) + f107)));
   f121 = Math_fround(Math_fround(f97 * f122) + Math_fround(Math_fround(f96 * f123) + Math_fround(Math_fround(f94 * f124) + f107)));
   f115 = Math_fround(Math_fround(f75 * f122) + Math_fround(Math_fround(f74 * f123) + Math_fround(Math_fround(f104 * f124) + f107)));
   f112 = Math_fround(Math_fround(f83 * f122) + Math_fround(Math_fround(f82 * f123) + Math_fround(Math_fround(f81 * f124) + f107)));
   f109 = Math_fround(Math_fround(f92 * f122) + Math_fround(Math_fround(f91 * f123) + Math_fround(Math_fround(f90 * f124) + f107)));
   f107 = Math_fround(Math_fround(f101 * f122) + Math_fround(Math_fround(f100 * f123) + Math_fround(Math_fround(f99 * f124) + f107)));
   i72 = f115 > f49;
   i110 = f112 > f50;
   i113 = f109 > f51;
   i116 = f107 > f52;
   f49 = i72 ? f115 : f49;
   f50 = i110 ? f112 : f50;
   f51 = i113 ? f109 : f51;
   f52 = i116 ? f107 : f52;
   f7 = i72 ? f124 : f7;
   f9 = i72 ? f123 : f9;
   f10 = i72 ? f122 : f10;
   f12 = i110 ? f124 : f12;
   f13 = i110 ? f123 : f13;
   f14 = i110 ? f122 : f14;
   f15 = i113 ? f124 : f15;
   f16 = i113 ? f123 : f16;
   f17 = i113 ? f122 : f17;
   f18 = i116 ? f124 : f18;
   f19 = i116 ? f123 : f19;
   f20 = i116 ? f122 : f20;
   i116 = f53 > Math_fround(0.0);
   i113 = f55 > Math_fround(0.0);
   i110 = f56 > Math_fround(0.0);
   i72 = f54 > Math_fround(0.0);
   i117 = f118 > Math_fround(0.0);
   i114 = f119 > Math_fround(0.0);
   i111 = f120 > Math_fround(0.0);
   i108 = f121 > Math_fround(0.0);
   i128 = f118 > f53;
   i127 = f119 > f55;
   i126 = f120 > f56;
   i125 = f121 > f54;
   f53 = i128 ? f118 : f53;
   f55 = i127 ? f119 : f55;
   f56 = i126 ? f120 : f56;
   f54 = i125 ? f121 : f54;
   f37 = i128 ? f124 : f37;
   f38 = i128 ? f123 : f38;
   f39 = i128 ? f122 : f39;
   f40 = i127 ? f124 : f40;
   f41 = i127 ? f123 : f41;
   f42 = i127 ? f122 : f42;
   f43 = i126 ? f124 : f43;
   f44 = i126 ? f123 : f44;
   f45 = i126 ? f122 : f45;
   f46 = i125 ? f124 : f46;
   f47 = i125 ? f123 : f47;
   f48 = i125 ? f122 : f48;
   i3 = (i3 | 0) != 0 | i116 & i117;
   i4 = (i4 | 0) != 0 | i113 & i114;
   i6 = (i6 | 0) != 0 | i110 & i111;
   i72 = (i57 | 0) != 0 | i72 & i108;
   f121 = Math_fround(Math_fround(f60 * f122) + Math_fround(Math_fround(f58 * f124) + Math_fround(f59 * f123)));
   f120 = Math_fround(Math_fround(f63 * f122) + Math_fround(Math_fround(f61 * f124) + Math_fround(f62 * f123)));
   f119 = Math_fround(Math_fround(f66 * f122) + Math_fround(Math_fround(f64 * f124) + Math_fround(f65 * f123)));
   f118 = Math_fround(Math_fround(f69 * f122) + Math_fround(Math_fround(f67 * f124) + Math_fround(f68 * f123)));
   f115 = Math_fround(-Math_fround(f115 / f121));
   f112 = Math_fround(-Math_fround(f112 / f120));
   f109 = Math_fround(-Math_fround(f109 / f119));
   f107 = Math_fround(-Math_fround(f107 / f118));
   i57 = f121 > Math_fround(0.0) & f35 > f115;
   i110 = f120 > Math_fround(0.0) & f32 > f112;
   i113 = f119 > Math_fround(0.0) & f29 > f109;
   i116 = f118 > Math_fround(0.0) & f26 > f107;
   f35 = i57 ? f115 : f35;
   f32 = i110 ? f112 : f32;
   f29 = i113 ? f109 : f29;
   f26 = i116 ? f107 : f26;
   i116 = f121 < Math_fround(0.0) & f11 < f115;
   i113 = f120 < Math_fround(0.0) & f8 < f112;
   i110 = f119 < Math_fround(0.0) & f5 < f109;
   i57 = f118 < Math_fround(0.0) & f2 < f107;
   f21 = i116 ? f124 : f21;
   f22 = i116 ? f123 : f22;
   f23 = i116 ? f122 : f23;
   f24 = i113 ? f124 : f24;
   f25 = i113 ? f123 : f25;
   f27 = i113 ? f122 : f27;
   f28 = i110 ? f124 : f28;
   f30 = i110 ? f123 : f30;
   f31 = i110 ? f122 : f31;
   f33 = i57 ? f124 : f33;
   f34 = i57 ? f123 : f34;
   f36 = i57 ? f122 : f36;
   i117 = f121 == Math_fround(0.0) & i117;
   i114 = f120 == Math_fround(0.0) & i114;
   i111 = f119 == Math_fround(0.0) & i111;
   i108 = f118 == Math_fround(0.0) & i108;
   f11 = i117 ? Math_fround(1.0) : i116 ? f115 : f11;
   f8 = i114 ? Math_fround(1.0) : i113 ? f112 : f8;
   f5 = i111 ? Math_fround(1.0) : i110 ? f109 : f5;
   f2 = i108 ? Math_fround(1.0) : i57 ? f107 : f2;
   i70 = i70 + 1 | 0;
   if ((i70 | 0) == (i71 | 0)) {
    i70 = i3;
    i57 = i4;
    i3 = i6;
    i1 = i72;
    break;
   } else {
    i3 = i3 << 31 >> 31;
    i4 = i4 << 31 >> 31;
    i6 = i6 << 31 >> 31;
    i57 = i72 << 31 >> 31;
    i1 = i1 + 16 | 0;
   }
  }
  i6 = i1 ^ 1;
  i4 = i3 ^ 1;
  i3 = i57 ^ 1;
  i1 = i70 ^ 1;
 }
 i110 = i105 + 160 | 0;
 i114 = i105 + 164 | 0;
 i125 = i105 + 168 | 0;
 i128 = i105 + 172 | 0;
 f121 = Math_fround(HEAPF32[i105 + 144 >> 2]);
 f122 = Math_fround(HEAPF32[i105 + 148 >> 2]);
 f123 = Math_fround(HEAPF32[i105 + 152 >> 2]);
 f124 = Math_fround(HEAPF32[i105 + 156 >> 2]);
 i108 = f53 >= Math_fround(0.0) & (HEAP32[i110 >> 2] & 2 | 0) == 0;
 i113 = f55 >= Math_fround(0.0) & (HEAP32[i114 >> 2] & 2 | 0) == 0;
 i117 = f56 >= Math_fround(0.0) & (HEAP32[i125 >> 2] & 2 | 0) == 0;
 i127 = f54 >= Math_fround(0.0) & (HEAP32[i128 >> 2] & 2 | 0) == 0;
 i129 = i105 + 176 | 0;
 f115 = Math_fround(HEAPF32[i129 >> 2]);
 i57 = i105 + 180 | 0;
 f118 = Math_fround(HEAPF32[i57 >> 2]);
 i70 = i105 + 184 | 0;
 f119 = Math_fround(HEAPF32[i70 >> 2]);
 i71 = i105 + 188 | 0;
 f120 = Math_fround(HEAPF32[i71 >> 2]);
 i136 = f35 >= f11 & (f11 >= Math_fround(0.0) & f115 > f11);
 i134 = f32 >= f8 & (f8 >= Math_fround(0.0) & f118 > f8);
 i132 = f29 >= f5 & (f5 >= Math_fround(0.0) & f119 > f5);
 i130 = f26 >= f2 & (f2 >= Math_fround(0.0) & f120 > f2);
 i137 = f49 <= Math_fround(0.0);
 i135 = f50 <= Math_fround(0.0);
 i133 = f51 <= Math_fround(0.0);
 i131 = f52 <= Math_fround(0.0);
 i72 = i137 | i136;
 i111 = i135 | i134;
 i116 = i133 | i132;
 i126 = i131 | i130;
 f61 = i137 ? f7 : i136 ? f21 : f37;
 f62 = i137 ? f9 : i136 ? f22 : f38;
 f63 = i137 ? f10 : i136 ? f23 : f39;
 f64 = i135 ? f12 : i134 ? f24 : f40;
 f65 = i135 ? f13 : i134 ? f25 : f41;
 f66 = i135 ? f14 : i134 ? f27 : f42;
 f67 = i133 ? f15 : i132 ? f28 : f43;
 f68 = i133 ? f16 : i132 ? f30 : f44;
 f69 = i133 ? f17 : i132 ? f31 : f45;
 f107 = i131 ? f18 : i130 ? f33 : f46;
 f109 = i131 ? f19 : i130 ? f34 : f47;
 f112 = i131 ? f20 : i130 ? f36 : f48;
 f115 = i137 ? Math_fround(0.0) : i136 ? f11 : f115;
 f118 = i135 ? Math_fround(0.0) : i134 ? f8 : f118;
 f119 = i133 ? Math_fround(0.0) : i132 ? f5 : f119;
 f120 = i131 ? Math_fround(0.0) : i130 ? f2 : f120;
 f60 = Math_fround(f121 - (i137 ? f49 : i136 ? f121 : f53));
 f50 = Math_fround(f122 - (i135 ? f50 : i134 ? f122 : f55));
 f58 = Math_fround(f123 - (i133 ? f51 : i132 ? f123 : f56));
 f59 = Math_fround(f124 - (i131 ? f52 : i130 ? f124 : f54));
 f74 = Math_fround((i72 ? f74 : f84) + Math_fround(f62 * f60));
 f75 = Math_fround((i72 ? f75 : f95) + Math_fround(f63 * f60));
 f76 = Math_fround((i72 ? f76 : f103) + Math_fround(f60 * Math_fround(0.0)));
 f81 = Math_fround((i111 ? f81 : f77) + Math_fround(f64 * f50));
 f82 = Math_fround((i111 ? f82 : f78) + Math_fround(f65 * f50));
 f84 = Math_fround((i111 ? f83 : f79) + Math_fround(f66 * f50));
 f85 = Math_fround((i111 ? f85 : f80) + Math_fround(f50 * Math_fround(0.0)));
 f90 = Math_fround((i116 ? f90 : f86) + Math_fround(f67 * f58));
 f91 = Math_fround((i116 ? f91 : f87) + Math_fround(f68 * f58));
 f92 = Math_fround((i116 ? f92 : f88) + Math_fround(f69 * f58));
 f95 = Math_fround((i116 ? f93 : f89) + Math_fround(f58 * Math_fround(0.0)));
 f99 = Math_fround((i126 ? f99 : f94) + Math_fround(f107 * f59));
 f100 = Math_fround((i126 ? f100 : f96) + Math_fround(f109 * f59));
 f101 = Math_fround((i126 ? f101 : f97) + Math_fround(f112 * f59));
 f103 = Math_fround((i126 ? f102 : f98) + Math_fround(f59 * Math_fround(0.0)));
 HEAPF32[i105 + 256 >> 2] = Math_fround((i72 ? f104 : f73) + Math_fround(f61 * f60));
 HEAPF32[i105 + 260 >> 2] = f74;
 HEAPF32[i105 + 264 >> 2] = f75;
 HEAPF32[i105 + 268 >> 2] = f76;
 HEAPF32[i105 + 272 >> 2] = f81;
 HEAPF32[i105 + 276 >> 2] = f82;
 HEAPF32[i105 + 280 >> 2] = f84;
 HEAPF32[i105 + 284 >> 2] = f85;
 HEAPF32[i105 + 288 >> 2] = f90;
 HEAPF32[i105 + 292 >> 2] = f91;
 HEAPF32[i105 + 296 >> 2] = f92;
 HEAPF32[i105 + 300 >> 2] = f95;
 HEAPF32[i105 + 304 >> 2] = f99;
 HEAPF32[i105 + 308 >> 2] = f100;
 HEAPF32[i105 + 312 >> 2] = f101;
 HEAPF32[i105 + 316 >> 2] = f103;
 HEAPF32[i105 + 192 >> 2] = f61;
 HEAPF32[i105 + 196 >> 2] = f62;
 HEAPF32[i105 + 200 >> 2] = f63;
 HEAPF32[i105 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i105 + 208 >> 2] = f64;
 HEAPF32[i105 + 212 >> 2] = f65;
 HEAPF32[i105 + 216 >> 2] = f66;
 HEAPF32[i105 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i105 + 224 >> 2] = f67;
 HEAPF32[i105 + 228 >> 2] = f68;
 HEAPF32[i105 + 232 >> 2] = f69;
 HEAPF32[i105 + 236 >> 2] = Math_fround(0.0);
 HEAPF32[i105 + 240 >> 2] = f107;
 HEAPF32[i105 + 244 >> 2] = f109;
 HEAPF32[i105 + 248 >> 2] = f112;
 HEAPF32[i105 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i129 >> 2] = f115;
 HEAPF32[i57 >> 2] = f118;
 HEAPF32[i70 >> 2] = f119;
 HEAPF32[i71 >> 2] = f120;
 HEAP32[i110 >> 2] = i72 ? 8 : (i108 & f121 > f53 ? 16 : 0) | (i1 & (f53 < f106 & i108) ? 32 : 0);
 HEAP32[i114 >> 2] = i111 ? 8 : (i113 & f122 > f55 ? 16 : 0) | (i3 & (f55 < f106 & i113) ? 32 : 0);
 HEAP32[i125 >> 2] = i116 ? 8 : (i117 & f123 > f56 ? 16 : 0) | (i4 & (f56 < f106 & i117) ? 32 : 0);
 HEAP32[i128 >> 2] = i126 ? 8 : (i127 & f124 > f54 ? 16 : 0) | (i6 & (f54 < f106 & i127) ? 32 : 0);
 return;
}

function __ZN9Texture2D8TransferI14SafeBinaryReadEEvRT_(i23, i24) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i26 + 16 | 0;
 i10 = i26 + 72 | 0;
 i25 = i26 + 52 | 0;
 i13 = i26 + 48 | 0;
 i14 = i26 + 44 | 0;
 i19 = i26 + 40 | 0;
 i15 = i26 + 36 | 0;
 i16 = i26 + 32 | 0;
 i9 = i26 + 28 | 0;
 i18 = i26 + 24 | 0;
 i11 = i26;
 i12 = i26 + 8 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i23, i24);
 __ZN14SafeBinaryRead10SetVersionEi(i24, 2);
 i22 = i23 + 52 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i21 = HEAP32[i22 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i21 + 8 | 0);
  i2 = i1 + 28 | 0;
  i21 = i21 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  i2 = HEAP32[i22 >> 2] | 0;
  i21 = i2 + 4 | 0;
  HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + -1;
  if (!(HEAP32[i21 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i22 >> 2] = i1;
 }
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i20 = i25 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 63664 | 0);
 i6 = i17;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i21;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i9 >> 2] = 1;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 932215 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 11; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 11; else {
     HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 11) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i13, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i13 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 932223 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 22; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 22; else {
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 22) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i14, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i14 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 411088 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 33; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 33; else {
     HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i15, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i15 >> 2] = _llvm_bswap_i32(HEAP32[i15 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i15 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 411108 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 44; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 44; else {
     HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 44) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i19, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i19 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i19 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i24, 1) | 0) {
  i5 = HEAP32[i19 >> 2] | 0;
  i4 = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i13 >> 2] | 0, 1, i5) | 0;
  i5 = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i14 >> 2] | 0, 1, i5) | 0;
  HEAP8[i10 >> 0] = 0;
  i6 = HEAP32[gb + 36972 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 411124 | 0, i6, i17, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i24 + 16 | 0;
    i3 = HEAP32[i24 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i3 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i24 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i10 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 1);
   } else {
    i1 = HEAP32[i17 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i24 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i24);
  }
  if (!(HEAP8[i10 >> 0] | 0)) i1 = 1; else i1 = __Z22CalculateMipMapCount3Diii(i4, i5, 1) | 0;
  HEAP32[i9 >> 2] = i1;
  i1 = i6;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 410444 | 0, i7, i17, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i24 + 16 | 0;
    i6 = HEAP32[i24 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i8 = 68; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 68; else {
      HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
    if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i17 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i24 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i24);
  }
  i1 = HEAP32[gb + 36972 >> 2] | 0;
 }
 i3 = i23 + 111 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 425828 | 0, i1, i17, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i24 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i24 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 411133 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 89; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 89; else {
     HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i16, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i16 >> 2] = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i4 = i23 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 411146 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 100; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 100; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 100) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i2 = i23 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 431875 | 0, gb + 431893 | 0, i17, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i24); else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i4 = i23 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 431979 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i6 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 117; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 117; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 117) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i4 = i23 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i24, gb + 932818 | 0, i7, i17, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i24 + 16 | 0;
   i7 = HEAP32[i24 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i24 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i24 + 36 >> 2] | 0, 0 - (HEAP32[i24 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 128; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i24 + 24 >> 2] | 0) >>> 0) i8 = 128; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 128) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i24 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i17 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i24 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i24);
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i18 >> 2] = i1;
 __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i24, i18, gb + 411165 | 0, 1);
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i23 + 84 >> 2] = i4;
 HEAP32[i23 + 88 >> 2] = HEAP32[i14 >> 2];
 i3 = HEAP32[i19 >> 2] | 0;
 HEAP32[i23 + 92 >> 2] = i3;
 i2 = i23 + 96 | 0;
 HEAP32[i2 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(i4, (HEAP32[i9 >> 2] | 0) > 1, i3) | 0;
 i3 = i23 + 100 | 0;
 HEAP32[i3 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i14 >> 2] | 0, (HEAP32[i9 >> 2] | 0) > 1, HEAP32[i19 >> 2] | 0) | 0;
 i4 = i23 + 76 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) {
  i9 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i22 >> 2] = 0;
 }
 __ZN9Texture2D16DeleteGfxTextureEv(i23);
 __ZNK6Object14GetMemoryLabelEv(i17, i23);
 if ((HEAP32[i17 >> 2] | 0) == 22) __ZNK6Object14GetMemoryLabelEv(i11, i23); else {
  __ZNK6Object14GetMemoryLabelEv(i10, i23);
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i11 >> 2] = 19;
  HEAP32[i11 + 4 >> 2] = i10;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) {
  i10 = i1 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  if (!(HEAP32[i10 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i22 >> 2] = 0;
 }
 i10 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 888) | 0;
 i8 = i11;
 i11 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = i11;
 i9 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i19 >> 2] | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i10, i17, i9, i11, i13, i14, i15, i16, 1, 1);
 HEAP32[i22 >> 2] = i10;
 f28 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 >> 2] | 0));
 f27 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i3 >> 2] | 0));
 HEAPF32[i23 + 68 >> 2] = f28;
 HEAPF32[i23 + 72 >> 2] = f27;
 i17 = mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 136 >> 2] | 0, i23 | 0) | 0;
 if (!(i17 + -1 & i17)) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 140 >> 2] | 0, i23 | 0) | 0;
  i1 = (i1 + -1 & i1 | 0) == 0 & 1;
 } else i1 = 0;
 HEAP8[i23 + 108 >> 0] = i1;
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i24, HEAP32[i18 >> 2] | 0, i1, 0);
 L207 : do if (HEAP32[i24 >> 2] & 512 | 0) {
  i2 = HEAP32[i18 >> 2] | 0;
  switch (HEAP32[i19 >> 2] | 0) {
  case 6:
   {
    i3 = (i2 | 0) / 4 | 0;
    if ((i2 | 0) <= 3) break L207;
    i2 = 0;
    while (1) {
     HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
    }
    break;
   }
  case 2:
  case 7:
  case 13:
   {
    i3 = (i2 | 0) / 2 | 0;
    if ((i2 | 0) <= 1) break L207;
    i2 = 0;
    while (1) {
     HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
    }
    break;
   }
  default:
   break L207;
  }
 } while (0);
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN14SafeBinaryRead21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i24, 2, gb + 411176 | 0, i23 + 120 | 0, i1, 0);
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i26;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i21);
 HEAP32[i25 >> 2] = 0;
 STACKTOP = i26;
 return;
}

function __ZN9ShaderLab9IntShader26CreateFromSerializedShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_(i48, i49, i50, i51) {
 i48 = i48 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i52 = 0, i53 = 0, i54 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i53 + 24 | 0;
 i45 = i53;
 i42 = i53 + 40 | 0;
 i43 = i53 + 88 | 0;
 i44 = i53 + 72 | 0;
 if (!i50) {
  i2 = HEAP32[i49 >> 2] | 0;
  i3 = i49 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 }
 i47 = __ZnwjRK10MemLabelIdiPKci(144, gb + 63280 | 0, 16, gb + 472212 | 0, 78) | 0;
 __ZN9ShaderLab9IntShaderC2Ev(i47);
 i1 = i48 + 56 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i48 + 60 >> 2] | 0;
 } else i2 = i2 & 255;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i52, i1, i2);
 i2 = i48 + 24 | 0;
 i8 = i2 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i48 + 28 >> 2] | 0;
 } else {
  i3 = i2;
  i1 = i1 & 255;
 };
 HEAP32[i45 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i45, i3, i1);
 i7 = i47 + 120 | 0;
 i3 = HEAP8[i52 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i3 = i3 & 255;
 i5 = i4 ? HEAP32[i52 + 4 >> 2] | 0 : i3;
 L13 : do if (!i5) i46 = 17; else {
  i41 = HEAP8[i45 + 11 >> 0] | 0;
  i1 = i41 << 24 >> 24 < 0;
  if ((i5 | 0) == ((i1 ? HEAP32[i45 + 4 >> 2] | 0 : i41 & 255) | 0)) {
   i6 = HEAP32[i52 >> 2] | 0;
   i1 = i1 ? HEAP32[i45 >> 2] | 0 : i45;
   if (i4) if (!(_memcmp(i6, i1, i5) | 0)) break; else {
    i46 = 17;
    break;
   }
   if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i4 = i52;
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L13;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i46 = 17;
      break;
     }
    }
   } else i46 = 17;
  } else i46 = 17;
 } while (0);
 if ((i46 | 0) == 17) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i52) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
 i1 = HEAP8[i8 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i48 + 28 >> 2] | 0;
 } else i1 = i1 & 255;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i52, i2, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i47 + 96 | 0, i52) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
 i1 = i48 + 40 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i48 + 44 >> 2] | 0;
 } else i2 = i2 & 255;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i52, i1, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i47 + 108 | 0, i52) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
 i38 = i47 + 132 | 0;
 i39 = i48 + 72 | 0;
 i40 = i48 + 76 | 0;
 __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE7reserveEj(i38, (HEAP32[i40 >> 2] | 0) - (HEAP32[i39 >> 2] | 0) >> 5);
 i1 = HEAP32[i39 >> 2] | 0;
 if ((HEAP32[i40 >> 2] | 0) != (i1 | 0)) {
  i41 = i43 + 12 | 0;
  i5 = i43 + 12 | 0;
  i9 = i52 + 4 | 0;
  i10 = i43 + 8 | 0;
  i11 = i43 + 4 | 0;
  i12 = i44 + 12 | 0;
  i8 = i44 + 12 | 0;
  i13 = i52 + 4 | 0;
  i14 = i44 + 8 | 0;
  i15 = i44 + 4 | 0;
  i16 = i43 + 11 | 0;
  i17 = i42 + 12 | 0;
  i6 = i42 + 12 | 0;
  i18 = i52 + 4 | 0;
  i19 = i42 + 8 | 0;
  i20 = i42 + 4 | 0;
  i21 = i42 + 16 | 0;
  i22 = i44 + 11 | 0;
  i23 = i42 + 28 | 0;
  i7 = i42 + 28 | 0;
  i24 = i52 + 4 | 0;
  i25 = i42 + 24 | 0;
  i26 = i42 + 20 | 0;
  i27 = i42 + 11 | 0;
  i28 = i45 + 12 | 0;
  i29 = i21 + 11 | 0;
  i30 = i47 + 136 | 0;
  i31 = i47 + 140 | 0;
  i32 = i42 + 16 | 0;
  i33 = i32 + 11 | 0;
  i34 = i52 + 4 | 0;
  i35 = i52 + 4 | 0;
  i36 = i52 + 4 | 0;
  i37 = i52 + 4 | 0;
  i4 = 0;
  do {
   i2 = i1 + (i4 << 5) | 0;
   i3 = HEAP8[i2 + 11 >> 0] | 0;
   i54 = i3 << 24 >> 24 < 0;
   i2 = i54 ? HEAP32[i2 >> 2] | 0 : i2;
   i3 = i54 ? HEAP32[i1 + (i4 << 5) + 4 >> 2] | 0 : i3 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i41 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i5 >> 2] | 0;
    i46 = 46;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i16 >> 0] = i3;
    if (!i3) i1 = i43; else {
     i1 = i43;
     i46 = 48;
    }
   } else i46 = 46;
   if ((i46 | 0) == 46) {
    i54 = i3 + 16 & -16;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i9 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i54, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i10 >> 2] = i54 | -2147483648;
    HEAP32[i11 >> 2] = i3;
    i46 = 48;
   }
   if ((i46 | 0) == 48) {
    i46 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i39 >> 2] | 0;
   i2 = i1 + (i4 << 5) + 16 | 0;
   i3 = HEAP8[i2 + 11 >> 0] | 0;
   i54 = i3 << 24 >> 24 < 0;
   i2 = i54 ? HEAP32[i2 >> 2] | 0 : i2;
   i3 = i54 ? HEAP32[i1 + (i4 << 5) + 20 >> 2] | 0 : i3 & 255;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i44);
    i1 = HEAP32[i8 >> 2] | 0;
    i46 = 52;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 >> 0] = i3;
    if (!i3) i1 = i44; else {
     i1 = i44;
     i46 = 54;
    }
   } else i46 = 52;
   if ((i46 | 0) == 52) {
    i54 = i3 + 16 & -16;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i13 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i54, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i44 >> 2] = i1;
    HEAP32[i14 >> 2] = i54 | -2147483648;
    HEAP32[i15 >> 2] = i3;
    i46 = 54;
   }
   if ((i46 | 0) == 54) {
    i46 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = HEAP8[i16 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i3 = i1 ? HEAP32[i11 >> 2] | 0 : i3 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i17 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i6 >> 2] | 0;
    i46 = 58;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i27 >> 0] = i3;
    if (!i3) i1 = i42; else {
     i1 = i42;
     i46 = 60;
    }
   } else i46 = 58;
   if ((i46 | 0) == 58) {
    i54 = i3 + 16 & -16;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i18 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i54, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i19 >> 2] = i54 | -2147483648;
    HEAP32[i20 >> 2] = i3;
    i46 = 60;
   }
   if ((i46 | 0) == 60) {
    i46 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = HEAP8[i22 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i3 = i1 ? HEAP32[i15 >> 2] | 0 : i3 & 255;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i23 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
    i1 = HEAP32[i7 >> 2] | 0;
    i46 = 64;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i29 >> 0] = i3;
    if (!i3) i1 = i21; else {
     i1 = i21;
     i46 = 66;
    }
   } else i46 = 64;
   if ((i46 | 0) == 64) {
    i54 = i3 + 16 & -16;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i24 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i54, 16, i52, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i25 >> 2] = i54 | -2147483648;
    HEAP32[i26 >> 2] = i3;
    i46 = 66;
   }
   if ((i46 | 0) == 66) {
    i46 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP8[i27 >> 0] | 0;
   i54 = i1 << 24 >> 24 < 0;
   i3 = i54 ? HEAP32[i42 >> 2] | 0 : i42;
   i1 = i54 ? HEAP32[i20 >> 2] | 0 : i1 & 255;
   HEAP32[i45 >> 2] = 0;
   HEAP32[i45 + 4 >> 2] = 0;
   HEAP32[i45 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i45, i3, i1);
   i1 = HEAP8[i29 >> 0] | 0;
   i3 = i1 << 24 >> 24 < 0;
   i54 = i3 ? HEAP32[i21 >> 2] | 0 : i21;
   i1 = i3 ? HEAP32[i26 >> 2] | 0 : i1 & 255;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i28, i54, i1);
   i1 = HEAP32[i30 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i38, i45); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i45);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 12 | 0, i28);
    HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 24;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
   if ((HEAP8[i33 >> 0] | 0) < 0) {
    i54 = HEAP32[i32 >> 2] | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i34 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i54, i52);
   }
   if ((HEAP8[i27 >> 0] | 0) < 0) {
    i54 = HEAP32[i42 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i35 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i54, i52);
   }
   if ((HEAP8[i22 >> 0] | 0) < 0) {
    i54 = HEAP32[i44 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i36 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i54, i52);
   }
   if ((HEAP8[i16 >> 0] | 0) < 0) {
    i54 = HEAP32[i43 >> 2] | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    HEAP32[i52 >> 2] = 66;
    HEAP32[i37 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i54, i52);
   }
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
  } while (i4 >>> 0 < (HEAP32[i40 >> 2] | 0) - i1 >> 5 >>> 0);
 }
 i5 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 472212 | 0, 34) | 0;
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = gb + 33952 + 8;
 i54 = gb + 63280 | 0;
 i1 = HEAP32[i54 + 4 >> 2] | 0;
 i6 = i45;
 HEAP32[i6 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i45);
 i6 = i52;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i54 = i5 + 36 | 0;
 HEAP32[i54 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i54 + 4 >> 2] = i1;
 i54 = gb + 63280 | 0;
 i1 = HEAP32[i54 + 4 >> 2] | 0;
 i6 = i45;
 HEAP32[i6 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i45);
 i6 = i52;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i54 = i5 + 56 | 0;
 HEAP32[i54 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i54 + 4 >> 2] = i1;
 i54 = gb + 63280 | 0;
 i1 = HEAP32[i54 + 4 >> 2] | 0;
 i6 = i45;
 HEAP32[i6 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 HEAP32[i5 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i45);
 i6 = i52;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i54 = i5 + 76 | 0;
 HEAP32[i54 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i54 + 4 >> 2] = i1;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 96 >> 2] = 0;
 i54 = gb + 63280 | 0;
 i1 = HEAP32[i54 + 4 >> 2] | 0;
 i6 = i5 + 100 | 0;
 HEAP32[i6 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP8[i5 + 108 >> 0] = 1;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i6 = i48 + 4 | 0;
 i1 = HEAP32[i48 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) {
  i7 = i45 + 4 | 0;
  i8 = i45 + 8 | 0;
  i9 = i45 + 12 | 0;
  i4 = 0;
  do {
   i2 = i1 + (i4 * 88 | 0) | 0;
   HEAP32[i52 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(i52, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
   i2 = HEAP32[i1 + (i4 * 88 | 0) + 44 >> 2] | 0;
   L94 : do if (!i2) {
    i2 = 1;
    i46 = 30;
   } else {
    i3 = HEAP32[i1 + (i4 * 88 | 0) + 48 >> 2] & 32;
    switch (i2 | 0) {
    case 1:
     {
      i2 = (i3 | 0) != 0;
      i46 = 30;
      break L94;
     }
    case 4:
     {
      __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i5, i52, i1 + (i4 * 88 | 0) + 68 | 0) | 0;
      break L94;
     }
    case 3:
    case 2:
     {
      __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, i52, Math_fround(HEAPF32[i1 + (i4 * 88 | 0) + 52 >> 2]), i3 >>> 5);
      break L94;
     }
    default:
     break L94;
    }
   } while (0);
   if ((i46 | 0) == 30) {
    i46 = 0;
    HEAP32[i45 >> 2] = HEAP32[i1 + (i4 * 88 | 0) + 52 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 + (i4 * 88 | 0) + 56 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i1 + (i4 * 88 | 0) + 60 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i1 + (i4 * 88 | 0) + 64 >> 2];
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i5, i52, i45, i2 & 1);
   }
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i48 >> 2] | 0;
  } while (i4 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 88 | 0) >>> 0);
 }
 HEAP32[i47 + 92 >> 2] = i5;
 i9 = i48 + 12 | 0;
 i10 = i48 + 16 | 0;
 i1 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i5 = (i1 | 0) / 28 | 0;
 i11 = i47 + 8 | 0;
 i6 = HEAP32[i47 >> 2] | 0;
 if ((HEAP32[i11 >> 2] | 0) - i6 >> 2 >>> 0 < i5 >>> 0) {
  i7 = i47 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) - i6 | 0;
  i2 = i8 >> 2;
  if (!i1) i4 = 0; else i4 = __Znwj(i5 << 2) | 0;
  i3 = i4 + (i2 << 2) | 0;
  i1 = i3 + (0 - i2 << 2) | 0;
  if ((i8 | 0) > 0) _memcpy(i1 | 0, i6 | 0, i8 | 0) | 0;
  HEAP32[i47 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i11 >> 2] = i4 + (i5 << 2);
  if (i6 | 0) __ZdlPv(i6);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
  __ZN9ShaderLab9IntShader15ResolveFallbackERKNS_16SerializedShaderEP6ShaderRNSt3__26vectorI4PPtrIS4_ENS6_9allocatorIS9_EEEEb(i47, i48, i51, i49, i50);
  __ZN9ShaderLab9IntShader10LinkShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEb(i47, i48, i49, i50);
  STACKTOP = i53;
  return i47 | 0;
 }
 i4 = i47 + 4 | 0;
 i3 = 0;
 do {
  i54 = __ZN9ShaderLab9SubShader29CreateFromSerializedSubShaderERKNS_19SerializedSubShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_(i1 + (i3 * 28 | 0) | 0, i49, i50, i51) | 0;
  HEAP32[i52 >> 2] = i54;
  i1 = i54;
  do if (i54 | 0) {
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) {
    __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i47, i52);
    break;
   } else {
    HEAP32[i2 >> 2] = i1;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
    break;
   }
  } while (0);
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } while (i3 >>> 0 < (((HEAP32[i10 >> 2] | 0) - i1 | 0) / 28 | 0) >>> 0);
 __ZN9ShaderLab9IntShader15ResolveFallbackERKNS_16SerializedShaderEP6ShaderRNSt3__26vectorI4PPtrIS4_ENS6_9allocatorIS9_EEEEb(i47, i48, i51, i49, i50);
 __ZN9ShaderLab9IntShader10LinkShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEb(i47, i48, i49, i50);
 STACKTOP = i53;
 return i47 | 0;
}

function _vfwscanf(i54, i1, i24) {
 i54 = i54 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i56 + 24 | 0;
 i51 = i56;
 i35 = i56 + 128 | 0;
 i46 = i56 + 120 | 0;
 i49 = i56 + 144 | 0;
 i50 = i56 + 32 | 0;
 if ((HEAP32[i54 + 76 >> 2] | 0) > -1) i55 = ___lockfile(i54) | 0; else i55 = 0;
 i5 = i54 + 74 | 0;
 i48 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = i48 + 1 | i48;
 i5 = HEAP32[i1 >> 2] | 0;
 L4 : do if (!i5) {
  i1 = 0;
  i53 = 125;
 } else {
  i23 = i54 + 4 | 0;
  i25 = i54 + 8 | 0;
  i26 = i50 + 4 | 0;
  i27 = i50 + 8 | 0;
  i28 = i50 + 12 | 0;
  i29 = i50 + 16 | 0;
  i30 = i50 + 20 | 0;
  i31 = i50 + 24 | 0;
  i32 = i50 + 28 | 0;
  i33 = i50 + 32 | 0;
  i34 = i50 + 36 | 0;
  i36 = i50 + 40 | 0;
  i37 = i50 + 44 | 0;
  i38 = i50 + 48 | 0;
  i39 = i50 + 52 | 0;
  i40 = i50 + 56 | 0;
  i41 = i50 + 60 | 0;
  i42 = i50 + 64 | 0;
  i43 = i50 + 68 | 0;
  i44 = i50 + 72 | 0;
  i45 = i50 + 76 | 0;
  i47 = i50 + 80 | 0;
  i48 = i50 + 84 | 0;
  i4 = i1;
  i13 = 0;
  i12 = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
  L6 : while (1) {
   L8 : do if (!(_iswspace(i5) | 0)) {
    i5 = (HEAP32[i4 >> 2] | 0) == 37;
    L10 : do if (i5) {
     i7 = i4 + 4 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     L12 : do switch (i6 | 0) {
     case 37:
      break L10;
     case 42:
      {
       i6 = 0;
       i4 = i4 + 8 | 0;
       break;
      }
     default:
      {
       if (_iswdigit(i6) | 0) if ((HEAP32[i4 + 8 >> 2] | 0) == 36) {
        i5 = (HEAP32[i7 >> 2] | 0) + -48 | 0;
        HEAP32[i35 >> 2] = HEAP32[i24 >> 2];
        while (1) {
         i22 = (HEAP32[i35 >> 2] | 0) + (4 - 1) & ~(4 - 1);
         i6 = HEAP32[i22 >> 2] | 0;
         HEAP32[i35 >> 2] = i22 + 4;
         if (i5 >>> 0 > 1) i5 = i5 + -1 | 0; else break;
        }
        i4 = i4 + 12 | 0;
        break L12;
       }
       i4 = (HEAP32[i24 >> 2] | 0) + (4 - 1) & ~(4 - 1);
       i6 = HEAP32[i4 >> 2] | 0;
       HEAP32[i24 >> 2] = i4 + 4;
       i4 = i7;
      }
     } while (0);
     if (!(_iswdigit(HEAP32[i4 >> 2] | 0) | 0)) {
      i5 = 0;
      i8 = i4;
     } else {
      i5 = 0;
      do {
       i5 = (i5 * 10 | 0) + -48 + (HEAP32[i4 >> 2] | 0) | 0;
       i4 = i4 + 4 | 0;
      } while ((_iswdigit(HEAP32[i4 >> 2] | 0) | 0) != 0);
      i8 = i4;
     }
     i7 = HEAP32[i8 >> 2] | 0;
     if ((i7 | 0) == 109) {
      i7 = i8 + 4 | 0;
      i4 = (i6 | 0) != 0 & 1;
      i2 = 0;
      i3 = 0;
      i8 = i7;
      i7 = HEAP32[i7 >> 2] | 0;
     } else i4 = 0;
     i9 = i8 + 4 | 0;
     switch (i7 | 0) {
     case 104:
      {
       i22 = (HEAP32[i9 >> 2] | 0) == 104;
       i10 = i22 ? -2 : -1;
       i8 = i22 ? i8 + 8 | 0 : i9;
       break;
      }
     case 108:
      {
       i22 = (HEAP32[i9 >> 2] | 0) == 108;
       i10 = i22 ? 3 : 1;
       i8 = i22 ? i8 + 8 | 0 : i9;
       break;
      }
     case 106:
      {
       i10 = 3;
       i8 = i9;
       break;
      }
     case 116:
     case 122:
      {
       i10 = 1;
       i8 = i9;
       break;
      }
     case 76:
      {
       i10 = 2;
       i8 = i9;
       break;
      }
     case 110:
     case 112:
     case 67:
     case 83:
     case 91:
     case 99:
     case 115:
     case 88:
     case 71:
     case 70:
     case 69:
     case 65:
     case 103:
     case 102:
     case 101:
     case 97:
     case 120:
     case 117:
     case 111:
     case 105:
     case 100:
      {
       i10 = 0;
       break;
      }
     default:
      {
       i53 = 121;
       break L6;
      }
     }
     i22 = HEAP32[i8 >> 2] | 0;
     i11 = (i22 & 47 | 0) == 3;
     i7 = i22 | 32;
     i22 = i11 ? i7 : i22;
     i11 = i11 ? 1 : i10;
     switch (i22 | 0) {
     case 110:
      {
       i5 = i12;
       break;
      }
     case 91:
      {
       i53 = 51;
       break;
      }
     default:
      if ((i7 | 0) == 99) i53 = 51; else {
       i9 = i12;
       while (1) {
        i7 = HEAP32[i23 >> 2] | 0;
        if (i7 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) if ((HEAP8[i7 >> 0] | 0) > -1) {
         HEAP32[i23 >> 2] = i7 + 1;
         i7 = HEAPU8[i7 >> 0] | 0;
        } else i53 = 49; else i53 = 49;
        if ((i53 | 0) == 49) {
         i53 = 0;
         i7 = _getwc(i54) | 0;
        }
        if (!(_iswspace(i7) | 0)) {
         i53 = 55;
         break;
        } else i9 = i9 + 1 | 0;
       }
      }
     }
     do if ((i53 | 0) == 51) {
      i7 = HEAP32[i23 >> 2] | 0;
      i10 = HEAP32[i25 >> 2] | 0;
      if (i7 >>> 0 < i10 >>> 0) if ((HEAP8[i7 >> 0] | 0) > -1) {
       HEAP32[i23 >> 2] = i7 + 1;
       i7 = HEAPU8[i7 >> 0] | 0;
       i9 = i12;
       i53 = 57;
       break;
      }
      i7 = _getwc(i54) | 0;
      i9 = i12;
      i53 = 55;
     } while (0);
     if ((i53 | 0) == 55) {
      if ((i7 | 0) < 0) {
       i53 = 121;
       break L6;
      }
      i10 = HEAP32[i25 >> 2] | 0;
      i53 = 57;
     }
     L56 : do if ((i53 | 0) == 57) {
      i53 = 0;
      if (i7 >>> 0 < 128 & (i10 | 0) != 0) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1; else _ungetwc(i7, i54) | 0;
      L62 : do switch (i22 | 0) {
      case 110:
       {
        i5 = i9;
        break L56;
       }
      case 91:
      case 99:
      case 115:
       {
        i21 = (i22 | 0) == 99;
        L64 : do if (i21) {
         i7 = gb + 1470388 | 0;
         i10 = 1;
         i5 = (i5 | 0) < 1 ? 1 : i5;
        } else {
         if ((i22 | 0) == 115) {
          HEAP32[i50 >> 2] = 32;
          HEAP32[i26 >> 2] = 9;
          HEAP32[i27 >> 2] = 10;
          HEAP32[i28 >> 2] = 13;
          HEAP32[i29 >> 2] = 11;
          HEAP32[i30 >> 2] = 12;
          HEAP32[i31 >> 2] = 133;
          HEAP32[i32 >> 2] = 8192;
          HEAP32[i33 >> 2] = 8193;
          HEAP32[i34 >> 2] = 8194;
          HEAP32[i36 >> 2] = 8195;
          HEAP32[i37 >> 2] = 8196;
          HEAP32[i38 >> 2] = 8197;
          HEAP32[i39 >> 2] = 8198;
          HEAP32[i40 >> 2] = 8200;
          HEAP32[i41 >> 2] = 8201;
          HEAP32[i42 >> 2] = 8202;
          HEAP32[i43 >> 2] = 8232;
          HEAP32[i44 >> 2] = 8233;
          HEAP32[i45 >> 2] = 8287;
          HEAP32[i47 >> 2] = 12288;
          HEAP32[i48 >> 2] = 0;
          i7 = i50;
          i10 = 1;
          break;
         }
         i7 = i8 + 4 | 0;
         i20 = (HEAP32[i7 >> 2] | 0) == 94;
         i10 = i20 & 1;
         i7 = i20 ? i8 + 8 | 0 : i7;
         i8 = (HEAP32[i7 >> 2] | 0) == 93 ? i7 + 4 | 0 : i7;
         while (1) {
          switch (HEAP32[i8 >> 2] | 0) {
          case 0:
           {
            i53 = 121;
            break L6;
           }
          case 93:
           break L64;
          default:
           {}
          }
          i8 = i8 + 4 | 0;
         }
        } while (0);
        i3 = (i11 | 0) == 0 ? i6 : 0;
        i20 = (i11 | 0) == 1;
        i2 = i20 ? i6 : 0;
        i11 = (i5 | 0) < 1 ? -1 : i5;
        i19 = (i4 | 0) != 0;
        do if (i19) {
         i5 = i21 ? i11 + 1 | 0 : 31;
         if (i20) {
          i2 = _malloc(i5 << 2) | 0;
          if (!i2) {
           i53 = 121;
           break L6;
          } else break;
         } else {
          i3 = _malloc(i5) | 0;
          if (!i3) {
           i2 = 0;
           i3 = 0;
           i53 = 121;
           break L6;
          } else {
           i2 = 0;
           break;
          }
         }
        } else i5 = i13; while (0);
        L80 : do if (!i11) i11 = 0; else {
         i18 = i7 + 4 | 0;
         i14 = 0;
         i15 = 0;
         i17 = i5;
         i16 = i11;
         while (1) {
          i5 = HEAP32[i23 >> 2] | 0;
          do if (i5 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) {
           if ((HEAP8[i5 >> 0] | 0) <= -1) {
            i53 = 84;
            break;
           }
           HEAP32[i23 >> 2] = i5 + 1;
           i5 = HEAPU8[i5 >> 0] | 0;
          } else i53 = 84; while (0);
          if ((i53 | 0) == 84) {
           i53 = 0;
           i5 = _getwc(i54) | 0;
           if ((i5 | 0) < 0) {
            i53 = 105;
            break;
           }
          }
          switch (HEAP32[i7 >> 2] | 0) {
          case 45:
           {
            if ((i5 | 0) == 45) i11 = 1; else {
             i11 = i18;
             i53 = 88;
            }
            break;
           }
          case 93:
           {
            if ((i5 | 0) == 93) i11 = 1; else {
             i11 = i18;
             i53 = 88;
            }
            break;
           }
          default:
           {
            i11 = i7;
            i53 = 88;
           }
          }
          L93 : do if ((i53 | 0) == 88) while (1) {
           i53 = 0;
           L96 : do switch (HEAP32[i11 >> 2] | 0) {
           case 93:
           case 0:
            {
             i11 = 0;
             break L93;
            }
           case 45:
            {
             i12 = i11 + 4 | 0;
             i13 = HEAP32[i12 >> 2] | 0;
             switch (i13 | 0) {
             case 93:
             case 0:
              break L96;
             default:
              {}
             }
             i11 = HEAP32[i11 + -4 >> 2] | 0;
             if ((i11 | 0) >= (i13 | 0)) {
              i11 = i12;
              break L96;
             }
             while (1) {
              if ((i11 | 0) == (i5 | 0)) {
               i11 = 1;
               break L93;
              }
              i11 = i11 + 1 | 0;
              if ((i11 | 0) >= (i13 | 0)) {
               i11 = i12;
               break;
              }
             }
             break;
            }
           default:
            {}
           } while (0);
           if ((HEAP32[i11 >> 2] | 0) == (i5 | 0)) {
            i11 = 1;
            break L93;
           } else {
            i11 = i11 + 4 | 0;
            i53 = 88;
           }
          } while (0);
          if ((i11 | 0) == (i10 | 0)) {
           i53 = 103;
           break;
          }
          do if (!i2) {
           if (i20) {
            i11 = i15;
            i5 = i17;
            i2 = 0;
            break;
           }
           i2 = _wctomb(i3 | 0 ? i3 + i15 | 0 : i49, i5) | 0;
           if ((i2 | 0) < 0) {
            i2 = 0;
            i53 = 121;
            break L6;
           }
           i2 = i2 + i15 | 0;
           if (!(i19 & i2 >>> 0 > (i17 + -4 | 0) >>> 0)) {
            i11 = i2;
            i5 = i17;
            i2 = 0;
            break;
           }
           i5 = i17 << 1 | 1;
           i12 = _realloc(i3, i5) | 0;
           if (!i12) {
            i7 = 21;
            i2 = 0;
            i53 = 118;
            break L62;
           } else {
            i11 = i2;
            i2 = 0;
            i3 = i12;
           }
          } else {
           i11 = i15 + 1 | 0;
           HEAP32[i2 + (i15 << 2) >> 2] = i5;
           if (!(i19 & (i11 | 0) == (i17 | 0))) {
            i5 = i17;
            break;
           }
           i5 = i17 << 1 | 1;
           i12 = _realloc(i2, i5 << 2) | 0;
           if (!i12) {
            i7 = 21;
            i53 = 118;
            break L62;
           } else {
            i11 = i17;
            i2 = i12;
           }
          } while (0);
          i9 = i9 + 1 | 0;
          i16 = i16 - ((i16 | 0) > 0 & 1) | 0;
          if (!i16) break L80; else {
           i14 = 1;
           i15 = i11;
           i17 = i5;
          }
         }
         if ((i53 | 0) == 103) {
          i53 = 0;
          if (i5 >>> 0 < 128 & (HEAP32[i25 >> 2] | 0) != 0) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1; else i53 = 105;
         }
         if ((i53 | 0) == 105) {
          i53 = 0;
          _ungetwc(i5, i54) | 0;
         }
         if ((i22 | 0) != 99 & (i14 | 0) != 0) {
          i11 = i15;
          i5 = i17;
         } else break L6;
        } while (0);
        do if (i19) if (i20) {
         HEAP32[i6 >> 2] = i2;
         break;
        } else {
         HEAP32[i6 >> 2] = i3;
         break;
        } while (0);
        if (i21) i4 = i8; else {
         if (i2 | 0) HEAP32[i2 + (i11 << 2) >> 2] = 0;
         if (!i3) {
          i3 = 0;
          i4 = i8;
         } else {
          HEAP8[i3 + i11 >> 0] = 0;
          i4 = i8;
         }
        }
        break;
       }
      case 112:
      case 88:
      case 71:
      case 70:
      case 69:
      case 65:
      case 103:
      case 102:
      case 101:
      case 97:
      case 120:
      case 117:
      case 111:
      case 105:
      case 100:
       {
        i53 = (i6 | 0) != 0;
        HEAP32[i51 >> 2] = 2 - (i53 & 1);
        HEAP32[i51 + 4 >> 2] = gb + 1075251;
        HEAP32[i51 + 8 >> 2] = (i5 | 0) > 0 ? i5 : 0;
        HEAP32[i51 + 12 >> 2] = gb + 1075215 + ((i11 + 2 | 0) * 3 | 0);
        HEAP32[i51 + 16 >> 2] = i22;
        _snprintf(i49, 22, gb + 1075233 | 0, i51) | 0;
        HEAP32[i46 >> 2] = 0;
        HEAP32[i52 >> 2] = i53 ? i6 : i46;
        HEAP32[i52 + 4 >> 2] = i46;
        if ((_fscanf(i54, i49, i52) | 0) == -1) {
         i53 = 121;
         break L6;
        }
        i53 = HEAP32[i46 >> 2] | 0;
        i7 = (i53 | 0) == 0 ? 10 : 18;
        i5 = i13;
        i9 = i53 + i9 | 0;
        i53 = 118;
        break;
       }
      default:
       {
        i53 = 121;
        break L6;
       }
      } while (0);
      if ((i53 | 0) == 118) {
       i53 = 0;
       switch (i7 & 31) {
       case 9:
       case 21:
       case 15:
        {
         i53 = 121;
         break L6;
        }
       case 10:
        break L6;
       case 18:
        {
         i4 = i8;
         break;
        }
       default:
        {
         i1 = 0;
         break L4;
        }
       }
      }
      i1 = ((i6 | 0) != 0 & 1) + i1 | 0;
      i7 = i5;
      i6 = i9;
      break L8;
     } while (0);
     if (!i6) {
      i4 = i8;
      i7 = i13;
      i6 = i5;
      break L8;
     }
     switch (i11 | 0) {
     case -2:
      {
       HEAP8[i6 >> 0] = i5;
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     case -1:
      {
       HEAP16[i6 >> 1] = i5;
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     case 0:
      {
       HEAP32[i6 >> 2] = i5;
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     case 1:
      {
       HEAP32[i6 >> 2] = i5;
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     case 3:
      {
       i4 = i6;
       HEAP32[i4 >> 2] = i5;
       HEAP32[i4 + 4 >> 2] = ((i5 | 0) < 0) << 31 >> 31;
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     default:
      {
       i4 = i8;
       i7 = i13;
       i6 = i5;
       break L8;
      }
     }
    } while (0);
    i4 = i4 + ((i5 & 1) << 2) | 0;
    i5 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) if ((HEAP8[i5 >> 0] | 0) > -1) {
     HEAP32[i23 >> 2] = i5 + 1;
     i5 = HEAPU8[i5 >> 0] | 0;
    } else i53 = 20; else i53 = 20;
    if ((i53 | 0) == 20) {
     i53 = 0;
     i5 = _getwc(i54) | 0;
    }
    if ((i5 | 0) != (HEAP32[i4 >> 2] | 0)) {
     i53 = 22;
     break L6;
    }
    i7 = i13;
    i6 = i12 + 1 | 0;
   } else {
    while (1) {
     i5 = i4 + 4 | 0;
     if (!(_iswspace(HEAP32[i5 >> 2] | 0) | 0)) {
      i6 = i12;
      break;
     } else i4 = i5;
    }
    while (1) {
     i5 = HEAP32[i23 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) if ((HEAP8[i5 >> 0] | 0) > -1) {
      HEAP32[i23 >> 2] = i5 + 1;
      i5 = HEAPU8[i5 >> 0] | 0;
     } else i53 = 10; else i53 = 10;
     if ((i53 | 0) == 10) {
      i53 = 0;
      i5 = _getwc(i54) | 0;
     }
     if (!(_iswspace(i5) | 0)) break; else i6 = i6 + 1 | 0;
    }
    if (i5 >>> 0 < 128 & (HEAP32[i25 >> 2] | 0) != 0) {
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
     i7 = i13;
     break;
    } else {
     _ungetwc(i5, i54) | 0;
     i7 = i13;
     break;
    }
   } while (0);
   i4 = i4 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) {
    i53 = 125;
    break L4;
   } else {
    i13 = i7;
    i12 = i6;
   }
  }
  if ((i53 | 0) == 22) {
   if (i5 >>> 0 < 128 & (HEAP32[i25 >> 2] | 0) != 0) HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1; else _ungetwc(i5, i54) | 0;
   if ((i1 | 0) != 0 | (i5 | 0) > -1) {
    i53 = 125;
    break;
   } else {
    i1 = 0;
    i53 = 122;
   }
  } else if ((i53 | 0) == 121) if (!i1) {
   i1 = i4;
   i53 = 122;
  }
  if ((i53 | 0) == 122) {
   i4 = i1;
   i1 = -1;
  }
  if (!i4) i53 = 125; else {
   _free(i3);
   _free(i2);
   i53 = 125;
  }
 } while (0);
 if ((i53 | 0) == 125) if (i55) ___unlockfile(i54);
 STACKTOP = i56;
 return i1 | 0;
}

function __ZN5physx3Ext27GetExtensionsBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 192 | 0;
 i4 = i2 + 160 | 0;
 i3 = i2 + 128 | 0;
 i6 = i2 + 64 | 0;
 i8 = i2 + 32 | 0;
 i7 = i2;
 i9 = i2 + 96 | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 119216 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 119216 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 119216 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 119216 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 119216 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 119216 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 119216 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 119216 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119248 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119248 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119248 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119248 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119248 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119248 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119248 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119248 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 119280 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 119280 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 119280 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 119280 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 119280 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 119280 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 119280 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 119280 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119312 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119312 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119312 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119312 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119312 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119312 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119312 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119312 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119344 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119344 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119344 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119344 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119344 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119344 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119344 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119344 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 119376 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 119376 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 119376 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 119376 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 119376 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 119376 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 119376 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 119376 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119408 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119408 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119408 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119408 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119408 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119408 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119408 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119408 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119440 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119440 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119440 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119440 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119440 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119440 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119440 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119440 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 119472 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 119472 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 119472 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 119472 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 119472 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 119472 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 119472 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 119472 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 119504 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 119504 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 119504 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 119504 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 119504 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 119504 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 119504 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 119504 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119536 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119536 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119536 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119536 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119536 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119536 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119536 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119536 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 119568 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 119568 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 119568 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 119568 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 119568 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 119568 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 119568 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 119568 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119600 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119600 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119600 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119600 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119600 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119600 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119600 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119600 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119632 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119632 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119632 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119632 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119632 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119632 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119632 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119632 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 119664 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 119664 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 119664 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 119664 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 119664 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 119664 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 119664 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 119664 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 119696 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 119696 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 119696 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 119696 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 119696 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 119696 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 119696 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 119696 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119728 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119728 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119728 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119728 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119728 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119728 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119728 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119728 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 744241;
 HEAP32[i4 + 4 >> 2] = gb + 744948;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 28;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119760 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119760 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119760 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119760 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119760 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119760 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119760 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119760 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119792 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119792 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119792 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119792 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119792 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119792 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119792 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119792 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119824 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119824 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119824 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119824 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119824 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119824 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119824 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119824 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 744614;
 HEAP32[i4 + 4 >> 2] = gb + 744948;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 24;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119856 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119856 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119856 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119856 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119856 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119856 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119856 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119856 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119888 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119888 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119888 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119888 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119888 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119888 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119888 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119888 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 744725;
 HEAP32[i4 + 4 >> 2] = gb + 744948;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 28;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119920 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119920 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119920 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119920 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119920 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119920 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119920 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119920 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119952 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119952 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119952 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119952 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119952 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119952 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119952 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119952 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119984 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119984 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119984 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119984 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119984 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119984 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119984 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119984 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 744080;
 HEAP32[i4 + 4 >> 2] = gb + 744948;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 28;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119920 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119920 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119920 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119920 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119920 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119920 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119920 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119920 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119952 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119952 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119952 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119952 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119952 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119952 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119952 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119952 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116144 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116144 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116144 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116144 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116144 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116144 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116144 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116144 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 743901;
 HEAP32[i4 + 4 >> 2] = gb + 827530;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 12;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 __ZN5physx3Ext13RevoluteJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Ext14SphericalJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Ext13DistanceJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Ext7D6Joint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Ext14PrismaticJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx3Ext10FixedJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __Z38getBinaryMetaData_SerializationContextRN5physx14PxOutputStreamE(i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx19PxsContactReductionILj6EE14reduceContactsEv(i55) {
 i55 = i55 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, f57 = f0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i56 + 56 | 0;
 i15 = i56 + 48 | 0;
 i54 = i56 + 24 | 0;
 i53 = i56;
 i52 = i55 + 1200 | 0;
 i11 = HEAP32[i52 >> 2] | 0;
 HEAP32[i55 + 172 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i55 + 176 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i55 + 180 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i55 + 184 >> 2] = 0;
 HEAP16[i55 + 192 >> 1] = 0;
 HEAP16[i55 + 196 >> 1] = 0;
 HEAP32[i55 + 188 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP16[i55 + 198 >> 1] = 0;
 i11 = i55 + 1208 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 L1 : do if (i1 >>> 0 > 1) {
  i12 = i55 + 1204 | 0;
  i2 = 1;
  i3 = i1;
  i10 = 1;
  i1 = 1;
  do {
   i9 = i1 & 65535;
   L5 : do if (!(i1 << 16 >> 16)) i5 = -1; else {
    i4 = HEAP32[i12 >> 2] | 0;
    i6 = HEAP16[i4 + (i2 << 2) >> 1] | 0;
    i7 = i4 + (i2 << 2) + 2 | 0;
    i5 = i9;
    while (1) {
     i5 = i5 + -1 | 0;
     i8 = HEAPU16[i55 + 172 + (i5 * 28 | 0) + 20 >> 1] | 0;
     if ((HEAP16[i4 + (i8 << 2) >> 1] | 0) == i6 << 16 >> 16) if ((HEAP16[i4 + (i8 << 2) + 2 >> 1] | 0) == (HEAP16[i7 >> 1] | 0)) {
      i50 = HEAP32[i52 >> 2] | 0;
      f26 = Math_fround(HEAPF32[i55 + 172 + (i5 * 28 | 0) >> 2]);
      f26 = Math_fround(f26 * Math_fround(HEAPF32[i50 + (i2 << 6) >> 2]));
      f25 = Math_fround(HEAPF32[i55 + 172 + (i5 * 28 | 0) + 4 >> 2]);
      f25 = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i50 + (i2 << 6) + 4 >> 2])));
      f26 = Math_fround(HEAPF32[i55 + 172 + (i5 * 28 | 0) + 8 >> 2]);
      if (Math_fround(f25 + Math_fround(f26 * Math_fround(HEAPF32[i50 + (i2 << 6) + 8 >> 2]))) >= Math_fround(.995000004)) break L5;
     }
     if (!i5) {
      i5 = -1;
      break;
     }
    }
   } while (0);
   i4 = i9 + -1 | 0;
   if ((i5 | 0) != (i4 | 0)) {
    HEAP16[i55 + 172 + (i4 * 28 | 0) + 22 >> 1] = i2 - (HEAPU16[i55 + 172 + (i4 * 28 | 0) + 20 >> 1] | 0);
    if (i1 << 16 >> 16 == 32) {
     i1 = 32;
     break L1;
    }
    i3 = i55 + 172 + (i9 * 28 | 0) | 0;
    HEAP16[i55 + 172 + (i9 * 28 | 0) + 20 >> 1] = i10;
    HEAP32[i55 + 172 + (i9 * 28 | 0) + 12 >> 2] = 0;
    if ((i5 | 0) == -1) {
     HEAP16[i55 + 172 + (i9 * 28 | 0) + 24 >> 1] = i1;
     i50 = HEAP32[i52 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i50 + (i2 << 6) >> 2];
     HEAP32[i55 + 172 + (i9 * 28 | 0) + 4 >> 2] = HEAP32[i50 + (i2 << 6) + 4 >> 2];
     HEAP32[i55 + 172 + (i9 * 28 | 0) + 8 >> 2] = HEAP32[i50 + (i2 << 6) + 8 >> 2];
     HEAP32[i55 + 172 + (i9 * 28 | 0) + 16 >> 2] = HEAP32[(HEAP32[i52 >> 2] | 0) + (i2 << 6) + 12 >> 2];
    } else {
     i50 = HEAP16[i55 + 172 + (i5 * 28 | 0) + 24 >> 1] | 0;
     HEAP32[i55 + 172 + (i5 * 28 | 0) + 12 >> 2] = i3;
     HEAP32[i3 >> 2] = HEAP32[i55 + 172 + (i5 * 28 | 0) >> 2];
     HEAP32[i55 + 172 + (i9 * 28 | 0) + 4 >> 2] = HEAP32[i55 + 172 + (i5 * 28 | 0) + 4 >> 2];
     HEAP32[i55 + 172 + (i9 * 28 | 0) + 8 >> 2] = HEAP32[i55 + 172 + (i5 * 28 | 0) + 8 >> 2];
     i49 = i55 + 172 + ((i50 & 65535) * 28 | 0) + 16 | 0;
     f25 = Math_fround(HEAPF32[i49 >> 2]);
     f26 = Math_fround(HEAPF32[(HEAP32[i52 >> 2] | 0) + (i2 << 6) + 12 >> 2]);
     f26 = f25 < f26 ? f25 : f26;
     HEAPF32[i55 + 172 + (i9 * 28 | 0) + 16 >> 2] = f26;
     HEAPF32[i49 >> 2] = f26;
     HEAP16[i55 + 172 + (i9 * 28 | 0) + 24 >> 1] = i50;
    }
    HEAP16[i55 + 172 + (i9 * 28 | 0) + 26 >> 1] = i1;
    i3 = HEAP32[i11 >> 2] | 0;
    i1 = i1 + 1 << 16 >> 16;
   }
   i10 = i10 + 1 << 16 >> 16;
   i2 = i10 & 65535;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  i2 = 1;
  i1 = 1;
 } while (0);
 i50 = i1 & 65535;
 i49 = i50 + -1 | 0;
 HEAP16[i55 + 172 + (i49 * 28 | 0) + 22 >> 1] = i2 - (HEAPU16[i55 + 172 + (i49 * 28 | 0) + 20 >> 1] | 0);
 i1 = i1 << 16 >> 16 == 0;
 if (i1) {
  __ZN5physx6shdfnd4sortIPNS_15PxsContactPatchENS_27SortBoundsPredicateManifoldENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i55 + 1068 | 0, i50, i15, i51, 32);
  i54 = 0;
  i55 = i55 + 168 | 0;
  HEAP32[i55 >> 2] = i54;
  STACKTOP = i56;
  return;
 } else i2 = 0;
 do {
  HEAP32[i55 + 1068 + (i2 << 2) >> 2] = i55 + 172 + (i2 * 28 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i50 | 0));
 __ZN5physx6shdfnd4sortIPNS_15PxsContactPatchENS_27SortBoundsPredicateManifoldENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i55 + 1068 | 0, i50, i15, i51, 32);
 if (i1) {
  i54 = 0;
  i55 = i55 + 168 | 0;
  HEAP32[i55 >> 2] = i54;
  STACKTOP = i56;
  return;
 }
 i49 = i53 + 16 | 0;
 i39 = i54 + 4 | 0;
 i40 = i54 + 8 | 0;
 i41 = i54 + 12 | 0;
 i42 = i53 + 4 | 0;
 i43 = i53 + 8 | 0;
 i44 = i53 + 12 | 0;
 i45 = i54 + 16 | 0;
 i46 = i54 + 20 | 0;
 i47 = i53 + 20 | 0;
 i48 = 0;
 i11 = 0;
 L32 : while (1) {
  i37 = i55 + 1068 + (i48 << 2) | 0;
  i5 = HEAP32[i37 >> 2] | 0;
  L34 : do if ((HEAP16[i5 + 24 >> 1] | 0) == (HEAP16[i5 + 26 >> 1] | 0)) {
   if ((i11 | 0) == 6) {
    i1 = 6;
    i2 = 73;
    break L32;
   }
   i1 = i11 + 1 | 0;
   i38 = i55 + (i11 * 28 | 0) | 0;
   i4 = (i5 | 0) == 0;
   L37 : do if (i4) i2 = 0; else {
    i2 = 0;
    i3 = i5;
    do {
     i2 = (HEAPU16[i3 + 22 >> 1] | 0) + i2 | 0;
     i3 = HEAP32[i3 + 12 >> 2] | 0;
    } while ((i3 | 0) != 0);
    if (i2 >>> 0 < 7) {
     if (i4) break; else {
      i3 = 0;
      i9 = i5;
     }
     while (1) {
      i4 = HEAP16[i9 + 22 >> 1] | 0;
      if (i4 << 16 >> 16) {
       i8 = HEAPU16[i9 + 20 >> 1] | 0;
       i4 = i4 & 65535;
       i7 = i4 >>> 0 > 1 ? i4 : 1;
       i5 = 0;
       i6 = i3;
       while (1) {
        HEAP32[i55 + (i11 * 28 | 0) + 4 + (i6 << 2) >> 2] = i8 + i5;
        i5 = i5 + 1 | 0;
        if (i5 >>> 0 >= i4 >>> 0) break; else i6 = i6 + 1 | 0;
       }
       i3 = i3 + i7 | 0;
      }
      i9 = HEAP32[i9 + 12 >> 2] | 0;
      if (!i9) break L37;
     }
    }
    if (i4) i2 = 0; else {
     f13 = Math_fround(0.0);
     i2 = 0;
     do {
      i3 = HEAP16[i5 + 22 >> 1] | 0;
      if (i3 << 16 >> 16) {
       i6 = HEAPU16[i5 + 20 >> 1] | 0;
       i7 = HEAP32[i52 >> 2] | 0;
       i3 = i3 & 65535;
       i4 = 0;
       do {
        i35 = i6 + i4 | 0;
        f26 = Math_fround(HEAPF32[i7 + (i35 << 6) + 16 >> 2]);
        f26 = Math_fround(f26 * f26);
        f25 = Math_fround(HEAPF32[i7 + (i35 << 6) + 20 >> 2]);
        f25 = Math_fround(f26 + Math_fround(f25 * f25));
        f26 = Math_fround(HEAPF32[i7 + (i35 << 6) + 24 >> 2]);
        f26 = Math_fround(f25 + Math_fround(f26 * f26));
        i36 = f13 < f26;
        i2 = i36 ? i35 : i2;
        f13 = i36 ? f26 : f13;
        i4 = i4 + 1 | 0;
       } while (i4 >>> 0 < i3 >>> 0);
      }
      i5 = HEAP32[i5 + 12 >> 2] | 0;
     } while ((i5 | 0) != 0);
    }
    HEAP32[i55 + (i11 * 28 | 0) + 4 >> 2] = i2;
    i9 = HEAP32[i52 >> 2] | 0;
    f18 = Math_fround(HEAPF32[i9 + (i2 << 6) + 16 >> 2]);
    f19 = Math_fround(HEAPF32[i9 + (i2 << 6) + 20 >> 2]);
    f20 = Math_fround(HEAPF32[i9 + (i2 << 6) + 24 >> 2]);
    i3 = HEAP32[i37 >> 2] | 0;
    if (!i3) i4 = i2; else {
     i5 = i2;
     f13 = Math_fround(0.0);
     while (1) {
      i4 = HEAP16[i3 + 22 >> 1] | 0;
      if (!(i4 << 16 >> 16)) i4 = i5; else {
       i8 = HEAPU16[i3 + 20 >> 1] | 0;
       i6 = i4 & 65535;
       i7 = 0;
       i4 = i5;
       do {
        i35 = i8 + i7 | 0;
        f24 = Math_fround(f18 - Math_fround(HEAPF32[i9 + (i35 << 6) + 16 >> 2]));
        f25 = Math_fround(f19 - Math_fround(HEAPF32[i9 + (i35 << 6) + 20 >> 2]));
        f26 = Math_fround(f20 - Math_fround(HEAPF32[i9 + (i35 << 6) + 24 >> 2]));
        f26 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
        i36 = f26 > f13;
        i4 = i36 ? i35 : i4;
        f13 = i36 ? f26 : f13;
        i7 = i7 + 1 | 0;
       } while (i7 >>> 0 < i6 >>> 0);
      }
      i3 = HEAP32[i3 + 12 >> 2] | 0;
      if (!i3) break; else i5 = i4;
     }
    }
    HEAP32[i55 + (i11 * 28 | 0) + 8 >> 2] = i4;
    i10 = HEAP32[i52 >> 2] | 0;
    f24 = Math_fround(HEAPF32[i10 + (i4 << 6) + 16 >> 2]);
    f26 = Math_fround(HEAPF32[i10 + (i4 << 6) + 20 >> 2]);
    f24 = Math_fround(f18 - f24);
    f26 = Math_fround(f19 - f26);
    f23 = Math_fround(f20 - Math_fround(HEAPF32[i10 + (i4 << 6) + 24 >> 2]));
    i3 = HEAP32[i37 >> 2] | 0;
    f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    f14 = Math_fround(f26 * f16);
    f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    f14 = Math_fround(f14 - Math_fround(f23 * f25));
    f17 = Math_fround(HEAPF32[i3 >> 2]);
    f16 = Math_fround(Math_fround(f23 * f17) - Math_fround(f24 * f16));
    f17 = Math_fround(Math_fround(f24 * f25) - Math_fround(f26 * f17));
    if (!i3) i10 = i4; else {
     i6 = i4;
     f13 = Math_fround(0.0);
     while (1) {
      i5 = HEAP16[i3 + 22 >> 1] | 0;
      if (!(i5 << 16 >> 16)) i5 = i6; else {
       i9 = HEAPU16[i3 + 20 >> 1] | 0;
       i7 = i5 & 65535;
       i8 = 0;
       i5 = i6;
       do {
        i35 = i9 + i8 | 0;
        f25 = Math_fround(Math_fround(HEAPF32[i10 + (i35 << 6) + 16 >> 2]) - f18);
        f26 = Math_fround(Math_fround(HEAPF32[i10 + (i35 << 6) + 20 >> 2]) - f19);
        f26 = Math_fround(Math_fround(Math_fround(f14 * f25) + Math_fround(f16 * f26)) + Math_fround(f17 * Math_fround(Math_fround(HEAPF32[i10 + (i35 << 6) + 24 >> 2]) - f20)));
        i36 = f26 > f13;
        i5 = i36 ? i35 : i5;
        f13 = i36 ? f26 : f13;
        i8 = i8 + 1 | 0;
       } while (i8 >>> 0 < i7 >>> 0);
      }
      i3 = HEAP32[i3 + 12 >> 2] | 0;
      if (!i3) {
       i10 = i5;
       break;
      } else i6 = i5;
     }
    }
    HEAP32[i55 + (i11 * 28 | 0) + 12 >> 2] = i10;
    i3 = HEAP32[i37 >> 2] | 0;
    if (!i3) i5 = i10; else {
     i5 = i10;
     f13 = Math_fround(0.0);
     do {
      i6 = HEAP16[i3 + 22 >> 1] | 0;
      if (i6 << 16 >> 16) {
       i8 = HEAPU16[i3 + 20 >> 1] | 0;
       i9 = HEAP32[i52 >> 2] | 0;
       i6 = i6 & 65535;
       i7 = 0;
       do {
        i35 = i8 + i7 | 0;
        f26 = Math_fround(Math_fround(HEAPF32[i9 + (i35 << 6) + 16 >> 2]) - f18);
        f25 = Math_fround(Math_fround(HEAPF32[i9 + (i35 << 6) + 20 >> 2]) - f19);
        f26 = Math_fround(Math_fround(Math_fround(-Math_fround(f16 * f25)) - Math_fround(f14 * f26)) - Math_fround(f17 * Math_fround(Math_fround(HEAPF32[i9 + (i35 << 6) + 24 >> 2]) - f20)));
        i36 = f26 > f13;
        i5 = i36 ? i35 : i5;
        f13 = i36 ? f26 : f13;
        i7 = i7 + 1 | 0;
       } while (i7 >>> 0 < i6 >>> 0);
      }
      i3 = HEAP32[i3 + 12 >> 2] | 0;
     } while ((i3 | 0) != 0);
    }
    HEAP32[i55 + (i11 * 28 | 0) + 16 >> 2] = i5;
    i34 = HEAP32[i52 >> 2] | 0;
    i36 = i11 * 7 | 0;
    i35 = i55 + 4 + (i36 << 2) | 0;
    HEAP32[i53 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i53 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i53 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    HEAP32[i53 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
    HEAPF32[i54 >> 2] = Math_fround(Math_fround(HEAPF32[i34 + (i2 << 6) + 12 >> 2]) + Math_fround(-.00100000005));
    HEAPF32[i39 >> 2] = Math_fround(Math_fround(HEAPF32[i34 + (i4 << 6) + 12 >> 2]) + Math_fround(-.00100000005));
    HEAPF32[i40 >> 2] = Math_fround(Math_fround(HEAPF32[i34 + (i10 << 6) + 12 >> 2]) + Math_fround(-.00100000005));
    HEAPF32[i41 >> 2] = Math_fround(Math_fround(HEAPF32[i34 + (i5 << 6) + 12 >> 2]) + Math_fround(-.00100000005));
    i3 = HEAP32[i37 >> 2] | 0;
    if (i3 | 0) {
     i32 = i34 + (i2 << 6) + 16 | 0;
     i33 = i34 + (i2 << 6) + 20 | 0;
     i29 = i34 + (i2 << 6) + 24 | 0;
     i30 = i34 + (i4 << 6) + 16 | 0;
     i31 = i34 + (i4 << 6) + 20 | 0;
     i15 = i34 + (i4 << 6) + 24 | 0;
     i27 = i34 + (i10 << 6) + 16 | 0;
     i28 = i34 + (i10 << 6) + 20 | 0;
     i10 = i34 + (i10 << 6) + 24 | 0;
     i11 = i34 + (i5 << 6) + 16 | 0;
     i12 = i34 + (i5 << 6) + 20 | 0;
     i9 = i34 + (i5 << 6) + 24 | 0;
     do {
      i2 = HEAP16[i3 + 22 >> 1] | 0;
      if (i2 << 16 >> 16) {
       i8 = HEAPU16[i3 + 20 >> 1] | 0;
       i2 = i2 & 65535;
       f13 = Math_fround(HEAPF32[i32 >> 2]);
       f14 = Math_fround(HEAPF32[i33 >> 2]);
       f16 = Math_fround(HEAPF32[i29 >> 2]);
       f17 = Math_fround(HEAPF32[i30 >> 2]);
       f18 = Math_fround(HEAPF32[i31 >> 2]);
       f19 = Math_fround(HEAPF32[i15 >> 2]);
       f20 = Math_fround(HEAPF32[i27 >> 2]);
       f21 = Math_fround(HEAPF32[i28 >> 2]);
       f22 = Math_fround(HEAPF32[i10 >> 2]);
       f23 = Math_fround(HEAPF32[i11 >> 2]);
       f24 = Math_fround(HEAPF32[i12 >> 2]);
       f25 = Math_fround(HEAPF32[i9 >> 2]);
       i6 = 0;
       do {
        i4 = i8 + i6 | 0;
        f59 = Math_fround(HEAPF32[i34 + (i4 << 6) + 16 >> 2]);
        f26 = Math_fround(HEAPF32[i34 + (i4 << 6) + 20 >> 2]);
        f57 = Math_fround(HEAPF32[i34 + (i4 << 6) + 24 >> 2]);
        f62 = Math_fround(f13 - f59);
        f61 = Math_fround(f14 - f26);
        f60 = Math_fround(f16 - f57);
        f60 = Math_fround(Math_fround(Math_fround(f62 * f62) + Math_fround(f61 * f61)) + Math_fround(f60 * f60));
        i7 = f60 < Math_fround(3402823469999999843913219.0e14);
        f60 = i7 ? f60 : Math_fround(3402823469999999843913219.0e14);
        f61 = Math_fround(f17 - f59);
        f62 = Math_fround(f18 - f26);
        f63 = Math_fround(f19 - f57);
        f63 = Math_fround(Math_fround(Math_fround(f61 * f61) + Math_fround(f62 * f62)) + Math_fround(f63 * f63));
        i7 = f60 > f63;
        f60 = i7 ? f63 : f60;
        f63 = Math_fround(f20 - f59);
        f62 = Math_fround(f21 - f26);
        f61 = Math_fround(f22 - f57);
        f61 = Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f62 * f62)) + Math_fround(f61 * f61));
        i5 = f60 > f61;
        f59 = Math_fround(f23 - f59);
        f26 = Math_fround(f24 - f26);
        f57 = Math_fround(f25 - f57);
        i58 = (i5 ? f61 : f60) > Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f26 * f26)) + Math_fround(f57 * f57));
        i7 = i58 ? 3 : i5 ? 2 : i7 & 1;
        i5 = i54 + (i7 << 2) | 0;
        f57 = Math_fround(HEAPF32[i5 >> 2]);
        f26 = Math_fround(HEAPF32[i34 + (i4 << 6) + 12 >> 2]);
        if (f57 > f26) {
         HEAP32[i53 + (i7 << 2) >> 2] = i4;
         HEAPF32[i5 >> 2] = f26;
        }
        i6 = i6 + 1 | 0;
       } while (i6 >>> 0 < i2 >>> 0);
      }
      i3 = HEAP32[i3 + 12 >> 2] | 0;
     } while ((i3 | 0) != 0);
    }
    i2 = i51;
    i3 = i2 + 64 | 0;
    do {
     HEAP8[i2 >> 0] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i3 | 0));
    HEAP32[i35 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
    HEAP8[i51 + (HEAP32[i53 >> 2] | 0) >> 0] = 1;
    HEAP8[i51 + (HEAP32[i42 >> 2] | 0) >> 0] = 1;
    HEAP8[i51 + (HEAP32[i43 >> 2] | 0) >> 0] = 1;
    HEAP8[i51 + (HEAP32[i44 >> 2] | 0) >> 0] = 1;
    i2 = i49;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAPF32[i45 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i46 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i2 = HEAP32[i37 >> 2] | 0;
    if (i2 | 0) do {
     i3 = HEAP16[i2 + 22 >> 1] | 0;
     if (i3 << 16 >> 16) {
      i8 = HEAPU16[i2 + 20 >> 1] | 0;
      i5 = i3 & 65535;
      i7 = 0;
      do {
       i6 = i8 + i7 | 0;
       do if (!(HEAP8[i51 + i6 >> 0] | 0)) {
        f14 = Math_fround(HEAPF32[(HEAP32[i52 >> 2] | 0) + (i6 << 6) + 12 >> 2]);
        f13 = Math_fround(HEAPF32[i45 >> 2]);
        if (f14 < f13) {
         i3 = HEAP32[i49 >> 2] | 0;
         HEAPF32[i46 >> 2] = f13;
         HEAP32[i47 >> 2] = i3;
         i3 = i45;
         i4 = 4;
        } else if (f14 < Math_fround(HEAPF32[i46 >> 2])) {
         i3 = i46;
         i4 = 5;
        } else break;
        HEAPF32[i3 >> 2] = f14;
        HEAP32[i53 + (i4 << 2) >> 2] = i6;
       } while (0);
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i5 >>> 0);
     }
     i2 = HEAP32[i2 + 12 >> 2] | 0;
    } while ((i2 | 0) != 0);
    i35 = i49;
    i37 = HEAP32[i35 + 4 >> 2] | 0;
    i58 = i55 + 4 + (i36 + 4 << 2) | 0;
    HEAP32[i58 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i58 + 4 >> 2] = i37;
    HEAP32[i38 >> 2] = 6;
    break L34;
   } while (0);
   HEAP32[i38 >> 2] = i2;
  } else i1 = i11; while (0);
  i48 = i48 + 1 | 0;
  if (i48 >>> 0 >= i50 >>> 0) {
   i2 = 73;
   break;
  } else i11 = i1;
 }
 if ((i2 | 0) == 73) {
  i58 = i55 + 168 | 0;
  HEAP32[i58 >> 2] = i1;
  STACKTOP = i56;
  return;
 }
}

function __ZN17ProfilerFrameData9SerializeER13dynamic_arrayIiLj4EE(i9, i25) {
 i9 = i9 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29;
 i5 = i9 + 4 | 0;
 i27 = i25 + 12 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i28 = i25 + 16 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i28 >> 2] = i1;
   HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i24 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i25 >> 2] = i24;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i2;
 i7 = HEAP32[i25 >> 2] | 0;
 HEAP32[i7 + (i6 << 2) >> 2] = HEAP32[i5 >> 2];
 i4 = i9 + 8 | 0;
 i5 = HEAP32[i27 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i2 = HEAP32[i28 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i28 >> 2] = i1;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i25 >> 2] = i8;
   i1 = i8;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i25 >> 2] = i8;
   i1 = i8;
   break;
  } else {
   i1 = i7;
   i8 = i7;
  }
 } else {
  i1 = i7;
  i8 = i7;
 } while (0);
 HEAP32[i27 >> 2] = i6;
 HEAP32[i1 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
 i5 = HEAP32[i9 + 1136 >> 2] | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i7 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i28 >> 2] = i2;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i25 >> 2] = i8;
   i1 = i8;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i2;
   HEAP32[i25 >> 2] = i8;
   i1 = i8;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i7;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i5 = i9 + 1144 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i7 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i28 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i25 >> 2] = i1;
   i8 = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i2;
   HEAP32[i25 >> 2] = i1;
   i8 = i1;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i7;
 HEAP32[i1 + (i6 << 2) >> 2] = HEAP32[i5 >> 2];
 i5 = i9 + 1148 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i7 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i28 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i25 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i2;
   HEAP32[i25 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i7;
 HEAP32[i1 + (i6 << 2) >> 2] = HEAP32[i5 >> 2];
 __ZN16AllProfilerStats9SerializeER13dynamic_arrayIiLj4EE(i9 + 12 | 0, i25);
 __Z10WriteArrayI22AudioProfilerGroupInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE(i25, i9 + 1152 | 0);
 __Z10WriteArrayI20AudioProfilerDSPInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE(i25, i9 + 1172 | 0);
 __Z10WriteArrayIcEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE(i25, i9 + 1212 | 0);
 i24 = i9 + 1128 | 0;
 i2 = HEAP32[i27 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i28 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i3 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i28 >> 2] = i1;
   HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i23 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i25 >> 2] = i23;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i3;
 HEAP32[(HEAP32[i25 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i24 >> 2];
 if ((HEAP32[i24 >> 2] | 0) <= 0) {
  STACKTOP = i29;
  return;
 }
 i21 = i9 + 1124 | 0;
 i22 = i25 + 4 | 0;
 i20 = 0;
 do {
  i23 = HEAP32[i21 >> 2] | 0;
  i2 = i23 + (i20 * 144 | 0) + 120 | 0;
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i23 + (i20 * 144 | 0) + 124 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } else {
   i3 = i1 & 255;
   i1 = i2;
  }
  i2 = HEAP32[i27 >> 2] | 0;
  HEAP32[i26 >> 2] = 0;
  __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i25, ((i3 | 0) / 4 | 0) + 1 + i2 | 0, i26, 1);
  _memcpy((HEAP32[i25 >> 2] | 0) + (i2 << 2) | 0, i1 | 0, i3 + 1 | 0) | 0;
  i2 = i23 + (i20 * 144 | 0) + 132 | 0;
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i23 + (i20 * 144 | 0) + 136 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } else {
   i3 = i1 & 255;
   i1 = i2;
  }
  i18 = HEAP32[i27 >> 2] | 0;
  HEAP32[i26 >> 2] = 0;
  __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i25, ((i3 | 0) / 4 | 0) + 1 + i18 | 0, i26, 1);
  _memcpy((HEAP32[i25 >> 2] | 0) + (i18 << 2) | 0, i1 | 0, i3 + 1 | 0) | 0;
  i18 = i23 + (i20 * 144 | 0) | 0;
  i19 = i23 + (i20 * 144 | 0) + 12 | 0;
  i5 = HEAP32[i19 >> 2] | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i2 = i6 + 1 | 0;
  i3 = HEAP32[i28 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i2 >>> 0 > i4 >>> 0) {
   i1 = i3 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i28 >> 2] = i1;
    HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
    HEAP32[i28 >> 2] = i1;
    HEAP32[i25 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i27 >> 2] = i2;
  i3 = HEAP32[i25 >> 2] | 0;
  HEAP32[i3 + (i6 << 2) >> 2] = i5;
  if (!(HEAP32[i19 >> 2] | 0)) {
   i12 = i3;
   i7 = i3;
   i9 = i3;
   i1 = i3;
   i13 = i3;
   i14 = i3;
   i2 = i3;
   i6 = i3;
  } else {
   i17 = 0;
   i15 = i3;
   i7 = i3;
   i9 = i3;
   i1 = i3;
   i13 = i3;
   i14 = i3;
   i2 = i3;
   i6 = i3;
   i16 = i3;
   i8 = i3;
   while (1) {
    i10 = ~~Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + (i17 * 24 | 0) + 8 >> 2]);
    i11 = HEAP32[i27 >> 2] | 0;
    i12 = i11 + 1 | 0;
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i12 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i28 >> 2] = i3;
      i16 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i15, i3 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i16;
      i8 = i16;
      i15 = i16;
      i7 = i16;
      i9 = i16;
      i1 = i16;
      i13 = i16;
      i14 = i16;
      i2 = i16;
      i6 = i16;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i3;
      HEAP32[i25 >> 2] = i16;
      i8 = i16;
      i15 = i16;
      i7 = i16;
      i9 = i16;
      i1 = i16;
      i13 = i16;
      i14 = i16;
      i2 = i16;
      i6 = i16;
      break;
     }
    } while (0);
    HEAP32[i27 >> 2] = i12;
    HEAP32[i8 + (i11 << 2) >> 2] = i10;
    i10 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i17 * 24 | 0) >> 2] | 0;
    i11 = HEAP32[i27 >> 2] | 0;
    i12 = i11 + 1 | 0;
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i12 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i28 >> 2] = i3;
      i16 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i15, i3 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i16;
      i8 = i16;
      i15 = i16;
      i7 = i16;
      i9 = i16;
      i1 = i16;
      i13 = i16;
      i14 = i16;
      i2 = i16;
      i6 = i16;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i3;
      HEAP32[i25 >> 2] = i16;
      i8 = i16;
      i15 = i16;
      i7 = i16;
      i9 = i16;
      i1 = i16;
      i13 = i16;
      i14 = i16;
      i2 = i16;
      i6 = i16;
      break;
     }
    } while (0);
    HEAP32[i27 >> 2] = i12;
    HEAP32[i8 + (i11 << 2) >> 2] = i10;
    i10 = (HEAP32[i18 >> 2] | 0) + (i17 * 24 | 0) + 12 | 0;
    i11 = HEAP32[i27 >> 2] | 0;
    i12 = i11 + 1 | 0;
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i12 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i28 >> 2] = i3;
      i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i15, i3 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i3;
      i8 = i3;
      i7 = i3;
      i9 = i3;
      i1 = i3;
      i13 = i3;
      i14 = i3;
      i2 = i3;
      i6 = i3;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i3;
      HEAP32[i25 >> 2] = i16;
      i8 = i16;
      i7 = i16;
      i9 = i16;
      i1 = i16;
      i13 = i16;
      i14 = i16;
      i2 = i16;
      i6 = i16;
      i3 = i16;
      break;
     } else i3 = i16;
    } else i3 = i16; while (0);
    HEAP32[i27 >> 2] = i12;
    HEAP32[i8 + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
    i17 = i17 + 1 | 0;
    if (i17 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) {
     i12 = i3;
     break;
    } else {
     i15 = i8;
     i16 = i3;
    }
   }
  }
  i15 = i23 + (i20 * 144 | 0) + 32 | 0;
  i8 = HEAP32[i15 >> 2] | 0;
  i10 = HEAP32[i27 >> 2] | 0;
  i11 = i10 + 1 | 0;
  i4 = HEAP32[i28 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i11 >>> 0 > i5 >>> 0) {
   i3 = i4 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i28 >> 2] = i3;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i12, i3 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i25 >> 2] = i2;
    i6 = i2;
    i7 = i2;
    i9 = i2;
    i1 = i2;
    i3 = i2;
    i5 = i2;
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i2 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
    HEAP32[i28 >> 2] = i3;
    HEAP32[i25 >> 2] = i2;
    i6 = i2;
    i7 = i2;
    i9 = i2;
    i1 = i2;
    i3 = i2;
    i5 = i2;
    break;
   } else {
    i3 = i13;
    i5 = i14;
   }
  } else {
   i3 = i13;
   i5 = i14;
  } while (0);
  HEAP32[i27 >> 2] = i11;
  HEAP32[i6 + (i10 << 2) >> 2] = i8;
  if (HEAP32[i15 >> 2] | 0) {
   i14 = i23 + (i20 * 144 | 0) + 20 | 0;
   i13 = 0;
   i12 = i2;
   i6 = i3;
   while (1) {
    i8 = (HEAP32[i14 >> 2] | 0) + (i13 << 4) + 4 | 0;
    i10 = HEAP32[i27 >> 2] | 0;
    i11 = i10 + 1 | 0;
    i3 = HEAP32[i28 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i11 >>> 0 > i4 >>> 0) {
     i2 = i3 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i28 >> 2] = i2;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i12, i2 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i1;
      i2 = i1;
      i12 = i1;
      i7 = i1;
      i9 = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i2;
      HEAP32[i25 >> 2] = i1;
      i2 = i1;
      i12 = i1;
      i7 = i1;
      i9 = i1;
      break;
     } else {
      i2 = i5;
      i12 = i6;
     }
    } else {
     i2 = i5;
     i12 = i6;
    } while (0);
    HEAP32[i27 >> 2] = i11;
    HEAP32[i2 + (i10 << 2) >> 2] = HEAP32[i8 >> 2];
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 4) >> 2] | 0;
    i6 = HEAP32[i27 >> 2] | 0;
    i8 = i6 + 1 | 0;
    i3 = HEAP32[i28 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i8 >>> 0 > i4 >>> 0) {
     i2 = i3 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i28 >> 2] = i2;
      i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i12, i2 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i7;
      i1 = i7;
      i9 = i7;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i2;
      HEAP32[i25 >> 2] = i7;
      i1 = i7;
      i9 = i7;
      break;
     }
    } while (0);
    HEAP32[i27 >> 2] = i8;
    HEAP32[i1 + (i6 << 2) >> 2] = i5;
    i4 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 4) + 12 >> 2] | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i2 = HEAP32[i28 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i6 >>> 0 > i3 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i3 >>> 0 >= i1 >>> 0) {
      i2 = i7;
      break;
     }
     if ((i2 | 0) > -1) {
      HEAP32[i28 >> 2] = i1;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i25 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i28 >> 2] = i1;
      HEAP32[i25 >> 2] = i2;
      break;
     }
    } else i2 = i7; while (0);
    HEAP32[i27 >> 2] = i6;
    HEAP32[i2 + (i5 << 2) >> 2] = i4;
    i13 = i13 + 1 | 0;
    if (i13 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else {
     i12 = i2;
     i7 = i2;
     i9 = i2;
     i1 = i2;
     i6 = i2;
     i5 = i2;
    }
   }
  }
  __Z10WriteArrayIN12ProfilerData17AllocatedGCMemoryEEvR13dynamic_arrayIiLj4EERKS2_IT_Xsr11AlignOfTypeIS5_EE5alignEE(i25, i23 + (i20 * 144 | 0) + 60 | 0);
  if (HEAP32[i19 >> 2] | 0) {
   i1 = 0;
   do {
    __Z17WriteConditionalyR13dynamic_arrayIiLj4EEP19ProfilerInformation(i25, HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 * 24 | 0) + 16 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0);
  }
  __Z10WriteArrayIjEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE(i25, i23 + (i20 * 144 | 0) + 80 | 0);
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) < (HEAP32[i24 >> 2] | 0));
 STACKTOP = i29;
 return;
}

function __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i33, i28, i4, i3, i29) {
 i33 = i33 | 0;
 i28 = i28 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i34 + 424 | 0;
 i30 = i34 + 412 | 0;
 i31 = i34 + 352 | 0;
 i1 = i34 + 192 | 0;
 i2 = i34 + 160 | 0;
 i27 = i34;
 if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i3 + 4 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i3 + 8 >> 2]) == Math_fround(1.0)) {
  HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i30 + 4 >> 2] = i28 + 16;
  HEAP32[i30 + 8 >> 2] = HEAP32[i28 + 4 >> 2];
  f17 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f17 = Math_fround(f17 * Math_fround(-2.0));
  f18 = Math_fround(f18 * Math_fround(-2.0));
  f19 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(-2.0));
  f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f22 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(f17 * f16);
  f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f18 * f15));
  f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f19 * f13));
  f14 = Math_fround(Math_fround(f16 * f10) + Math_fround(Math_fround(f17 * f22) - Math_fround(f12 * Math_fround(Math_fround(f19 * f15) - Math_fround(f18 * f13)))));
  f11 = Math_fround(Math_fround(f15 * f10) + Math_fround(Math_fround(f18 * f22) - Math_fround(f12 * Math_fround(Math_fround(f17 * f13) - Math_fround(f19 * f16)))));
  f10 = Math_fround(Math_fround(Math_fround(f19 * f22) - Math_fround(f12 * Math_fround(Math_fround(f18 * f16) - Math_fround(f17 * f15)))) + Math_fround(f13 * f10));
  f15 = Math_fround(-f15);
  f13 = Math_fround(-f13);
  HEAPF32[i2 >> 2] = Math_fround(-f16);
  HEAPF32[i2 + 4 >> 2] = f15;
  HEAPF32[i2 + 8 >> 2] = f13;
  HEAPF32[i2 + 12 >> 2] = f12;
  HEAPF32[i2 + 16 >> 2] = f14;
  HEAPF32[i2 + 20 >> 2] = f11;
  HEAPF32[i2 + 24 >> 2] = f10;
  __ZN5physx23transformBoxOrthonormalERKNS_2Gu3BoxERKNS_11PxTransformE(i1, i33, i2);
  HEAP32[i31 >> 2] = HEAP32[i1 >> 2];
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i31 + 4 >> 2] = i5;
  i9 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i31 + 8 >> 2] = i9;
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i31 + 12 >> 2] = i4;
  i37 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i31 + 16 >> 2] = i37;
  i35 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP32[i31 + 20 >> 2] = i35;
  i3 = HEAP32[i1 + 24 >> 2] | 0;
  HEAP32[i31 + 24 >> 2] = i3;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  HEAP32[i31 + 28 >> 2] = i2;
  i36 = HEAP32[i1 + 32 >> 2] | 0;
  HEAP32[i31 + 32 >> 2] = i36;
  i6 = HEAP32[i1 + 36 >> 2] | 0;
  HEAP32[i31 + 36 >> 2] = i6;
  i7 = HEAP32[i1 + 40 >> 2] | 0;
  HEAP32[i31 + 40 >> 2] = i7;
  i8 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i31 + 44 >> 2] = i8;
  HEAP32[i31 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i31 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i31 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
  f10 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f10 * f11);
  f12 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f14 - Math_fround(f12 * f13));
  f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f12 * f15);
  f17 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = Math_fround(f17 * f11);
  f22 = Math_fround(f16 - f18);
  f19 = Math_fround(Math_fround(f17 * f13) - Math_fround(f10 * f15));
  f20 = Math_fround(HEAPF32[i31 >> 2]);
  f23 = Math_fround(f14 * f20);
  f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(Math_fround(f21 * f22) + f23);
  f22 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(Math_fround(f22 * f19) + f23);
  i9 = f23 != Math_fround(0.0);
  f24 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i9) {
   f23 = Math_fround(Math_fround(1.0) / f23);
   f40 = Math_fround(f14 * f23);
   f39 = Math_fround(-Math_fround(Math_fround(Math_fround(f21 * f11) - Math_fround(f22 * f13)) * f23));
   f38 = Math_fround(Math_fround(Math_fround(f21 * f12) - Math_fround(f22 * f10)) * f23);
   f14 = Math_fround(-Math_fround(Math_fround(f18 - f16) * f23));
   f16 = Math_fround(Math_fround(Math_fround(f11 * f20) - Math_fround(f22 * f15)) * f23);
   f18 = Math_fround(-Math_fround(Math_fround(Math_fround(f12 * f20) - Math_fround(f22 * f17)) * f23));
   f19 = Math_fround(f19 * f23);
   f22 = Math_fround(-Math_fround(Math_fround(Math_fround(f13 * f20) - Math_fround(f21 * f15)) * f23));
   f23 = Math_fround(Math_fround(Math_fround(f10 * f20) - Math_fround(f21 * f17)) * f23);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = 1065353216;
   i2 = 0;
   i3 = 0;
   i4 = 1065353216;
   i5 = 0;
   i6 = 0;
   i7 = 0;
   i8 = 1065353216;
   i9 = 0;
  }
  f23 = Math_fround(-f24);
  f38 = Math_fround(-f25);
  f40 = Math_fround(-f26);
  f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
  f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
  f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38);
  f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38);
  f24 = Math_fround(f23 + f24);
  f25 = Math_fround(f39 + f25);
  f26 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38) + f26);
  f38 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40);
  f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40);
  f38 = Math_fround(f24 + f38);
  f39 = Math_fround(f25 + f39);
  f40 = Math_fround(f26 + Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40));
  HEAP32[i32 >> 2] = i4;
  HEAP32[i32 + 4 >> 2] = i5;
  HEAP32[i32 + 8 >> 2] = i6;
  HEAP32[i32 + 12 >> 2] = i7;
  HEAP32[i32 + 16 >> 2] = i8;
  HEAP32[i32 + 20 >> 2] = i9;
  HEAP32[i32 + 24 >> 2] = i3;
  HEAP32[i32 + 28 >> 2] = i2;
  HEAP32[i32 + 32 >> 2] = i1;
  HEAP32[i27 + 4 >> 2] = 2;
  HEAP32[i27 >> 2] = gb + 85876 + 8;
  HEAP32[i27 + 8 >> 2] = i28;
  HEAP32[i27 + 16 >> 2] = i32;
  i37 = i27 + 68 | 0;
  HEAP8[i37 >> 0] = 0;
  HEAP32[i27 + 116 >> 2] = i29;
  f39 = Math_fround(-f39);
  f40 = Math_fround(-f40);
  HEAPF32[i27 + 144 >> 2] = Math_fround(-f38);
  HEAPF32[i27 + 148 >> 2] = f39;
  HEAPF32[i27 + 152 >> 2] = f40;
  HEAPF32[i27 + 156 >> 2] = Math_fround(0.0);
  i35 = HEAP32[i33 + 52 >> 2] | 0;
  i36 = HEAP32[i33 + 56 >> 2] | 0;
  HEAP32[i27 + 128 >> 2] = HEAP32[i33 + 48 >> 2];
  HEAP32[i27 + 132 >> 2] = i35;
  HEAP32[i27 + 136 >> 2] = i36;
  HEAPF32[i27 + 140 >> 2] = Math_fround(0.0);
  __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i31, 1, i30, i27, 1);
  i37 = HEAP8[i37 >> 0] | 0;
  i37 = i37 << 24 >> 24 != 0;
  STACKTOP = i34;
  return i37 | 0;
 }
 HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i30 + 4 >> 2] = i28 + 16;
 HEAP32[i30 + 8 >> 2] = HEAP32[i28 + 4 >> 2];
 __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i31, i33, i4, i3);
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f49 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f41 = Math_fround(f15 + f15);
 f12 = Math_fround(f49 + f49);
 f10 = Math_fround(f18 + f18);
 f44 = Math_fround(f49 * f12);
 f47 = Math_fround(f18 * f10);
 f49 = Math_fround(f41 * f49);
 f21 = Math_fround(f41 * f18);
 f42 = Math_fround(f41 * f48);
 f18 = Math_fround(f12 * f18);
 f12 = Math_fround(f12 * f48);
 f48 = Math_fround(f10 * f48);
 f10 = Math_fround(Math_fround(Math_fround(1.0) - f44) - f47);
 f39 = Math_fround(f49 + f48);
 f13 = Math_fround(f21 - f12);
 f48 = Math_fround(f49 - f48);
 f41 = Math_fround(Math_fround(1.0) - Math_fround(f15 * f41));
 f47 = Math_fround(f41 - f47);
 f15 = Math_fround(f18 + f42);
 f12 = Math_fround(f21 + f12);
 f42 = Math_fround(f18 - f42);
 f44 = Math_fround(f41 - f44);
 f41 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f49 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f38 = Math_fround(f41 + f41);
 f46 = Math_fround(f18 + f18);
 f23 = Math_fround(f21 + f21);
 f16 = Math_fround(f18 * f46);
 f22 = Math_fround(f21 * f23);
 f18 = Math_fround(f38 * f18);
 f19 = Math_fround(f38 * f21);
 f43 = Math_fround(f38 * f49);
 f21 = Math_fround(f46 * f21);
 f46 = Math_fround(f46 * f49);
 f49 = Math_fround(f23 * f49);
 f23 = Math_fround(Math_fround(Math_fround(1.0) - f16) - f22);
 f11 = Math_fround(f18 + f49);
 f24 = Math_fround(f19 - f46);
 f49 = Math_fround(f18 - f49);
 f38 = Math_fround(Math_fround(1.0) - Math_fround(f41 * f38));
 f22 = Math_fround(f38 - f22);
 f41 = Math_fround(f21 + f43);
 f46 = Math_fround(f19 + f46);
 f43 = Math_fround(f21 - f43);
 f16 = Math_fround(f38 - f16);
 f38 = Math_fround(HEAPF32[i3 >> 2]);
 f21 = Math_fround(f38 * f23);
 f19 = Math_fround(f38 * f49);
 f38 = Math_fround(f38 * f46);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(f11 * f18);
 f40 = Math_fround(f22 * f18);
 f18 = Math_fround(f43 * f18);
 f45 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f17 = Math_fround(f24 * f45);
 f26 = Math_fround(f41 * f45);
 f45 = Math_fround(f16 * f45);
 f25 = Math_fround(Math_fround(Math_fround(f23 * f21) + Math_fround(f11 * f20)) + Math_fround(f24 * f17));
 f14 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f11 * f40)) + Math_fround(f24 * f26));
 f24 = Math_fround(Math_fround(Math_fround(f23 * f38) + Math_fround(f11 * f18)) + Math_fround(f24 * f45));
 f11 = Math_fround(Math_fround(Math_fround(f49 * f21) + Math_fround(f22 * f20)) + Math_fround(f41 * f17));
 f23 = Math_fround(Math_fround(Math_fround(f49 * f19) + Math_fround(f22 * f40)) + Math_fround(f41 * f26));
 f41 = Math_fround(Math_fround(Math_fround(f49 * f38) + Math_fround(f22 * f18)) + Math_fround(f41 * f45));
 f17 = Math_fround(Math_fround(Math_fround(f46 * f21) + Math_fround(f43 * f20)) + Math_fround(f16 * f17));
 f26 = Math_fround(Math_fround(Math_fround(f46 * f19) + Math_fround(f43 * f40)) + Math_fround(f16 * f26));
 f45 = Math_fround(Math_fround(Math_fround(f46 * f38) + Math_fround(f43 * f18)) + Math_fround(f16 * f45));
 f16 = Math_fround(Math_fround(f12 * f24) + Math_fround(Math_fround(f10 * f25) + Math_fround(f48 * f14)));
 f18 = Math_fround(Math_fround(f42 * f24) + Math_fround(Math_fround(f39 * f25) + Math_fround(f47 * f14)));
 f14 = Math_fround(Math_fround(f44 * f24) + Math_fround(Math_fround(f13 * f25) + Math_fround(f15 * f14)));
 f25 = Math_fround(Math_fround(f12 * f41) + Math_fround(Math_fround(f10 * f11) + Math_fround(f48 * f23)));
 f24 = Math_fround(Math_fround(f42 * f41) + Math_fround(Math_fround(f39 * f11) + Math_fround(f47 * f23)));
 f23 = Math_fround(Math_fround(f44 * f41) + Math_fround(Math_fround(f13 * f11) + Math_fround(f15 * f23)));
 f48 = Math_fround(Math_fround(f12 * f45) + Math_fround(Math_fround(f10 * f17) + Math_fround(f48 * f26)));
 f47 = Math_fround(Math_fround(f42 * f45) + Math_fround(Math_fround(f39 * f17) + Math_fround(f47 * f26)));
 f26 = Math_fround(Math_fround(f44 * f45) + Math_fround(Math_fround(f13 * f17) + Math_fround(f15 * f26)));
 f15 = Math_fround(HEAPF32[i33 >> 2]);
 f17 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f45 = Math_fround(HEAPF32[i33 + 12 >> 2]);
 f44 = Math_fround(HEAPF32[i33 + 16 >> 2]);
 f39 = Math_fround(HEAPF32[i33 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i33 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i33 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i33 + 32 >> 2]);
 f11 = Math_fround(HEAPF32[i33 + 36 >> 2]);
 f41 = Math_fround(HEAPF32[i33 + 40 >> 2]);
 f11 = Math_fround(-f11);
 f41 = Math_fround(-f41);
 f43 = Math_fround(-Math_fround(HEAPF32[i33 + 44 >> 2]));
 f38 = Math_fround(Math_fround(Math_fround(f15 * f11) + Math_fround(f17 * f41)) + Math_fround(f13 * f43));
 f46 = Math_fround(Math_fround(Math_fround(f45 * f11) + Math_fround(f44 * f41)) + Math_fround(f39 * f43));
 f43 = Math_fround(Math_fround(Math_fround(f42 * f11) + Math_fround(f10 * f41)) + Math_fround(f12 * f43));
 f41 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f40 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 HEAP32[i1 + 4 >> 2] = 2;
 HEAP32[i1 >> 2] = gb + 85896 + 8;
 HEAP32[i1 + 8 >> 2] = i28;
 HEAP32[i1 + 16 >> 2] = i32;
 i37 = i1 + 68 | 0;
 HEAP8[i37 >> 0] = 0;
 HEAP32[i1 + 116 >> 2] = i29;
 f19 = Math_fround(Math_fround(f14 * f39) + Math_fround(Math_fround(f45 * f16) + Math_fround(f44 * f18)));
 f20 = Math_fround(Math_fround(Math_fround(f16 * f42) + Math_fround(f18 * f10)) + Math_fround(f14 * f12));
 f21 = Math_fround(Math_fround(f13 * f23) + Math_fround(Math_fround(f15 * f25) + Math_fround(f17 * f24)));
 f22 = Math_fround(Math_fround(f39 * f23) + Math_fround(Math_fround(f45 * f25) + Math_fround(f44 * f24)));
 f23 = Math_fround(Math_fround(Math_fround(f25 * f42) + Math_fround(f24 * f10)) + Math_fround(f23 * f12));
 f24 = Math_fround(Math_fround(f13 * f26) + Math_fround(Math_fround(f15 * f48) + Math_fround(f17 * f47)));
 f25 = Math_fround(Math_fround(f39 * f26) + Math_fround(Math_fround(f45 * f48) + Math_fround(f44 * f47)));
 f26 = Math_fround(Math_fround(Math_fround(f48 * f42) + Math_fround(f47 * f10)) + Math_fround(f26 * f12));
 f38 = Math_fround(f38 + Math_fround(Math_fround(Math_fround(f15 * f41) + Math_fround(f17 * f11)) + Math_fround(f13 * f40)));
 f39 = Math_fround(f46 + Math_fround(Math_fround(Math_fround(f45 * f41) + Math_fround(f44 * f11)) + Math_fround(f39 * f40)));
 f40 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(f10 * f11)) + Math_fround(f12 * f40)));
 HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(f13 * f14) + Math_fround(Math_fround(f15 * f16) + Math_fround(f17 * f18)));
 HEAPF32[i1 + 24 >> 2] = f19;
 HEAPF32[i1 + 28 >> 2] = f20;
 HEAPF32[i1 + 32 >> 2] = f21;
 HEAPF32[i1 + 36 >> 2] = f22;
 HEAPF32[i1 + 40 >> 2] = f23;
 HEAPF32[i1 + 44 >> 2] = f24;
 HEAPF32[i1 + 48 >> 2] = f25;
 HEAPF32[i1 + 52 >> 2] = f26;
 HEAPF32[i1 + 56 >> 2] = f38;
 HEAPF32[i1 + 60 >> 2] = f39;
 HEAPF32[i1 + 64 >> 2] = f40;
 i35 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i35 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i35 = HEAP32[i33 + 52 >> 2] | 0;
 i36 = HEAP32[i33 + 56 >> 2] | 0;
 HEAP32[i1 + 128 >> 2] = HEAP32[i33 + 48 >> 2];
 HEAP32[i1 + 132 >> 2] = i35;
 HEAP32[i1 + 136 >> 2] = i36;
 HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i31, 1, i30, i1, 1);
 i37 = HEAP8[i37 >> 0] | 0;
 i37 = i37 << 24 >> 24 != 0;
 STACKTOP = i34;
 return i37 | 0;
}

function __ZNK5physx31PxVehicleWheelDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 24 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj573ENS_22PxRepXPropertyAccessorILj573ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 40 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj574ENS_22PxRepXPropertyAccessorILj574ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 56 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj575ENS_22PxRepXPropertyAccessorILj575ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 72 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj576ENS_22PxRepXPropertyAccessorILj576ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 88 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj577ENS_22PxRepXPropertyAccessorILj577ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 104 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj578ENS_22PxRepXPropertyAccessorILj578ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 120 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj579ENS_22PxRepXPropertyAccessorILj579ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 136 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj580ENS_22PxRepXPropertyAccessorILj580ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 152 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj581ENS_22PxRepXPropertyAccessorILj581ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 11 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 11 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i10, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 12 | 0;
 i12 = i14;
 i2 = i10;
 L1 : do if ((i2 - i1 | 0) > 2) {
  if ((HEAP8[i1 >> 0] | 0) == 103) {
   i3 = (HEAP8[i1 + 1 >> 0] | 0) == 115;
   i5 = i3;
   i3 = i3 ? i1 + 2 | 0 : i1;
  } else {
   i5 = 0;
   i3 = i1;
  }
  i4 = __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i3, i10, i11) | 0;
  if ((i4 | 0) != (i3 | 0)) {
   if (!i5) {
    i1 = i4;
    break;
   }
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) break;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i2 + -24 | 0, 0, gb + 1086571 | 0) | 0;
   i1 = i4;
   break;
  }
  if ((i2 - i3 | 0) > 2) if ((HEAP8[i3 >> 0] | 0) == 115) if ((HEAP8[i3 + 1 >> 0] | 0) == 114) {
   i4 = i3 + 2 | 0;
   L14 : do if ((HEAP8[i4 >> 0] | 0) == 78) {
    i9 = i3 + 3 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_(i9, i10, i11) | 0;
    if ((i2 | 0) == (i9 | 0) | (i2 | 0) == (i10 | 0)) break L1;
    i5 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i2, i10, i11) | 0;
    i9 = i11 + 4 | 0;
    do if ((i5 | 0) == (i2 | 0)) i8 = i11; else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (((i2 - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i2 = HEAP32[i9 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i8 = i4 + -24 | 0;
      HEAP32[i9 >> 2] = i8;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i8);
      i4 = HEAP32[i9 >> 2] | 0;
     }
     i8 = HEAP8[i13 + 11 >> 0] | 0;
     i7 = i8 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i7 ? HEAP32[i13 >> 2] | 0 : i13) | 0, (i7 ? HEAP32[i13 + 4 >> 2] | 0 : i8 & 255) | 0) | 0;
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
      break L14;
     }
     if ((i5 | 0) != (i10 | 0)) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
      i2 = i5;
      i8 = i11;
      break;
     }
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i3 + -24 | 0;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) break;
      i12 = i3 + -24 | 0;
      HEAP32[i9 >> 2] = i12;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i12);
      i3 = HEAP32[i9 >> 2] | 0;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     break L1;
    } while (0);
    i6 = i12 + 11 | 0;
    i7 = i12 + 4 | 0;
    while (1) {
     if ((HEAP8[i2 >> 0] | 0) == 69) {
      i3 = 43;
      break;
     }
     i5 = __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i2, i10, i11) | 0;
     if ((i5 | 0) == (i2 | 0) | (i5 | 0) == (i10 | 0)) break L1;
     i2 = HEAP32[i9 >> 2] | 0;
     if (((i2 - (HEAP32[i8 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i4 = HEAP32[i9 >> 2] | 0;
     i2 = i4 + -24 | 0;
     i3 = i4;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) break;
      i15 = i3 + -24 | 0;
      HEAP32[i9 >> 2] = i15;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      i3 = HEAP32[i9 >> 2] | 0;
     }
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i13 | 0, 0, gb + 1086571 | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     if (i15 & 1) {
      i3 = 40;
      break;
     };
     HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i2 = 0;
     while (1) {
      if ((i2 | 0) == 3) break;
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     }
     i15 = HEAP8[i6 >> 0] | 0;
     i3 = i15 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i4 + -48 | 0, (i3 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i3 ? HEAP32[i7 >> 2] | 0 : i15 & 255) | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     if (i15 & 1) {
      i3 = 41;
      break;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     i2 = i5;
    }
    if ((i3 | 0) == 40) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 41) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
    } else if ((i3 | 0) == 43) {
     i15 = i2 + 1 | 0;
     i4 = __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i15, i10, i11) | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i2 = HEAP32[i9 >> 2] | 0;
      if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) break L1;
      i3 = i2 + -24 | 0;
      while (1) {
       if ((i2 | 0) == (i3 | 0)) break L1;
       i15 = i2 + -24 | 0;
       HEAP32[i9 >> 2] = i15;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       i2 = HEAP32[i9 >> 2] | 0;
      }
     }
     i2 = HEAP32[i9 >> 2] | 0;
     if (((i2 - (HEAP32[i8 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i3 = HEAP32[i9 >> 2] | 0;
     i1 = i3 + -24 | 0;
     i2 = i3;
     while (1) {
      if ((i2 | 0) == (i1 | 0)) break;
      i15 = i2 + -24 | 0;
      HEAP32[i9 >> 2] = i15;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      i2 = HEAP32[i9 >> 2] | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iiii(fb + 520 | 0, i13 | 0, 0, gb + 1086571 | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     do if (i15 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      i15 = HEAP8[i12 + 11 >> 0] | 0;
      i11 = i15 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i3 + -48 | 0, (i11 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i11 ? HEAP32[i12 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
      i15 = __THREW__;
      __THREW__ = 0;
      if (i15 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       i1 = i4;
       break L1;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     break;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
   } else {
    i2 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_(i4, i10, i11) | 0;
    if ((i2 | 0) != (i4 | 0)) {
     i6 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i2, i10, i11) | 0;
     do if ((i6 | 0) != (i2 | 0)) {
      i5 = i11 + 4 | 0;
      i2 = HEAP32[i5 >> 2] | 0;
      if (((i2 - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
      i2 = HEAP32[i5 >> 2] | 0;
      i3 = i2 + -24 | 0;
      i4 = i2;
      while (1) {
       if ((i4 | 0) == (i3 | 0)) break;
       i15 = i4 + -24 | 0;
       HEAP32[i5 >> 2] = i15;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       i4 = HEAP32[i5 >> 2] | 0;
      }
      i15 = HEAP8[i13 + 11 >> 0] | 0;
      i9 = i15 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i9 ? HEAP32[i13 >> 2] | 0 : i13) | 0, (i9 ? HEAP32[i13 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
      i15 = __THREW__;
      __THREW__ = 0;
      if (i15 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       break L14;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       i2 = i6;
       break;
      }
     } while (0);
     i5 = __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i2, i10, i11) | 0;
     if ((i5 | 0) == (i2 | 0)) {
      i4 = i11 + 4 | 0;
      i2 = HEAP32[i4 >> 2] | 0;
      if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) break L1;
      i3 = i2 + -24 | 0;
      while (1) {
       if ((i2 | 0) == (i3 | 0)) break L1;
       i15 = i2 + -24 | 0;
       HEAP32[i4 >> 2] = i15;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       i2 = HEAP32[i4 >> 2] | 0;
      }
     }
     i4 = i11 + 4 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (((i2 - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i3 = HEAP32[i4 >> 2] | 0;
     i1 = i3 + -24 | 0;
     i2 = i3;
     while (1) {
      if ((i2 | 0) == (i1 | 0)) break;
      i15 = i2 + -24 | 0;
      HEAP32[i4 >> 2] = i15;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      i2 = HEAP32[i4 >> 2] | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iiii(fb + 520 | 0, i13 | 0, 0, gb + 1086571 | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     do if (i15 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      i15 = HEAP8[i12 + 11 >> 0] | 0;
      i11 = i15 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i3 + -48 | 0, (i11 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i11 ? HEAP32[i12 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
      i15 = __THREW__;
      __THREW__ = 0;
      if (i15 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       i1 = i5;
       break L1;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     break;
    }
    i6 = __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i4, i10, i11) | 0;
    if ((i6 | 0) == (i4 | 0) | (i6 | 0) == (i10 | 0)) break L1;
    if (i5) {
     i2 = i11 + 4 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((HEAP32[i11 >> 2] | 0) == (i3 | 0)) break L1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i3 + -24 | 0, 0, gb + 1086571 | 0) | 0;
     i9 = i2;
    } else i9 = i11 + 4 | 0;
    i7 = i12 + 11 | 0;
    i8 = i12 + 4 | 0;
    i2 = i6;
    while (1) {
     if ((HEAP8[i2 >> 0] | 0) == 69) {
      i3 = 109;
      break;
     }
     i5 = __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i2, i10, i11) | 0;
     if ((i5 | 0) == (i2 | 0) | (i5 | 0) == (i10 | 0)) break L1;
     i2 = HEAP32[i9 >> 2] | 0;
     if (((i2 - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i4 = HEAP32[i9 >> 2] | 0;
     i2 = i4 + -24 | 0;
     i3 = i4;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) break;
      i15 = i3 + -24 | 0;
      HEAP32[i9 >> 2] = i15;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      i3 = HEAP32[i9 >> 2] | 0;
     }
     __THREW__ = 0;
     i3 = invoke_iiii(fb + 520 | 0, i13 | 0, 0, gb + 1086571 | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     if (i15 & 1) {
      i3 = 106;
      break;
     };
     HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i2 = 0;
     while (1) {
      if ((i2 | 0) == 3) break;
      HEAP32[i3 + (i2 << 2) >> 2] = 0;
      i2 = i2 + 1 | 0;
     }
     i15 = HEAP8[i7 >> 0] | 0;
     i6 = i15 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i4 + -48 | 0, (i6 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i6 ? HEAP32[i8 >> 2] | 0 : i15 & 255) | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     if (i15 & 1) {
      i3 = 107;
      break;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     i2 = i5;
    }
    if ((i3 | 0) == 106) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 107) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
    } else if ((i3 | 0) == 109) {
     i15 = i2 + 1 | 0;
     i4 = __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i15, i10, i11) | 0;
     if ((i4 | 0) == (i15 | 0)) {
      i2 = HEAP32[i9 >> 2] | 0;
      if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) break L1;
      i3 = i2 + -24 | 0;
      while (1) {
       if ((i2 | 0) == (i3 | 0)) break L1;
       i15 = i2 + -24 | 0;
       HEAP32[i9 >> 2] = i15;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
       i2 = HEAP32[i9 >> 2] | 0;
      }
     }
     i2 = HEAP32[i9 >> 2] | 0;
     if (((i2 - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i13, i2 + -24 | 0);
     i3 = HEAP32[i9 >> 2] | 0;
     i1 = i3 + -24 | 0;
     i2 = i3;
     while (1) {
      if ((i2 | 0) == (i1 | 0)) break;
      i15 = i2 + -24 | 0;
      HEAP32[i9 >> 2] = i15;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      i2 = HEAP32[i9 >> 2] | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iiii(fb + 520 | 0, i13 | 0, 0, gb + 1086571 | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     do if (i15 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      i15 = HEAP8[i12 + 11 >> 0] | 0;
      i11 = i15 << 24 >> 24 < 0;
      __THREW__ = 0;
      invoke_iiii(fb + 519 | 0, i3 + -48 | 0, (i11 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i11 ? HEAP32[i12 + 4 >> 2] | 0 : i15 & 255) | 0) | 0;
      i15 = __THREW__;
      __THREW__ = 0;
      if (i15 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
       i1 = i4;
       break L1;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     break;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
   } while (0);
   ___resumeException(i1 | 0);
  }
 } while (0);
 STACKTOP = i14;
 return i1 | 0;
}

function __Z23UpdateCaptureScreenshotv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i46;
 i39 = i46 + 120 | 0;
 i1 = i46 + 104 | 0;
 i34 = i46 + 88 | 0;
 i41 = i46 + 68 | 0;
 i42 = i46 + 48 | 0;
 i43 = i46 + 28 | 0;
 i32 = i46 + 24 | 0;
 i33 = i46 + 20 | 0;
 if (!(HEAP32[gb + 1162560 >> 2] | 0)) {
  STACKTOP = i46;
  return;
 }
 i28 = HEAP32[gb + 1162564 >> 2] | 0;
 i44 = __Z12GetGfxDevicev() | 0;
 i29 = __Z16GetRenderManagerv() | 0;
 i30 = __Z16GetScreenManagerv() | 0;
 f24 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 80 >> 2] | 0, i30 | 0) | 0);
 f25 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 84 >> 2] | 0, i30 | 0) | 0);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = f24;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = f25;
 __Z14RectfToRectIntRK5RectTIfE(i34, i1);
 i30 = HEAP32[i34 + 8 >> 2] | 0;
 i31 = HEAP32[i34 + 12 >> 2] | 0;
 i40 = __Znwj(20) | 0;
 if ((i28 | 0) > 1) {
  __ZN5ImageC2Eii13TextureFormat(i40, Math_imul(i30, i28) | 0, Math_imul(i31, i28) | 0, 4);
  __ZN5ImageC2Eii13TextureFormat(i41, i30, i31, 4);
  i35 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 84 >> 2] | 0, i44 | 0) | 0;
  HEAP32[i42 >> 2] = 0;
  i36 = i42 + 12 | 0;
  HEAP32[i36 >> 2] = 0;
  i37 = i42 + 16 | 0;
  HEAP32[i37 >> 2] = 0;
  i1 = HEAP32[gb + 63664 >> 2] | 0;
  i2 = HEAP32[gb + 63664 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1163236 >> 2] | 0;
  if ((i1 | 0) < 4 | (i2 | 0) != 0 | (i3 | 0) == 0) {
   HEAP32[i42 + 4 >> 2] = i1;
   HEAP32[i42 + 8 >> 2] = i2;
   i1 = 0;
   i45 = 7;
  } else {
   i26 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
   i27 = HEAP32[i37 >> 2] | 0;
   HEAP32[i42 + 4 >> 2] = i1;
   HEAP32[i42 + 8 >> 2] = i26;
   if ((i27 | 0) > -1) {
    i1 = HEAP32[i42 >> 2] | 0;
    i45 = 7;
   }
  }
  if ((i45 | 0) == 7) {
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i42 + 4 | 0);
   HEAP32[i42 >> 2] = 0;
  }
  HEAP32[i42 >> 2] = 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i37 >> 2] = 0;
  i1 = HEAP32[i29 + 8 >> 2] | 0;
  i9 = i29 + 4 | 0;
  i2 = i1;
  if ((i2 | 0) != (i9 | 0)) {
   i10 = i42 + 4 | 0;
   do {
    i5 = i1 + 8 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i39 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i45 = 16; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i3 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i38, i1, i39);
       i3 = HEAP32[i38 >> 2] | 0;
       i27 = HEAP32[i1 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i3 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i45 = 16; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i45 = 18;
      }
     }
     if ((i45 | 0) == 16) i45 = 18;
     if ((i45 | 0) == 18) {
      i45 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
      if (!i1) break;
     }
     i7 = HEAP32[i1 + 4 >> 2] | 0;
     i3 = i1 + 864 | 0;
     HEAP32[i38 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i38 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i38 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i38 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     i3 = HEAP32[i36 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i37 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i37 >> 2] = i1;
       HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i1 * 20 | 0, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i27 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i27 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i36 >> 2] | 0) * 20 | 0) | 0;
       HEAP32[i37 >> 2] = i1;
       HEAP32[i42 >> 2] = i27;
       break;
      }
     } while (0);
     HEAP32[i36 >> 2] = i4;
     i27 = HEAP32[i42 >> 2] | 0;
     HEAP32[i27 + (i3 * 20 | 0) >> 2] = i7;
     i27 = i27 + (i3 * 20 | 0) + 4 | 0;
     HEAP32[i27 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i27 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
     HEAP32[i27 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
     HEAP32[i27 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    } while (0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i9 | 0));
  }
  f25 = Math_fround(i28 | 0);
  f8 = Math_fround(Math_fround(-1.0) - Math_fround(_log2f(f25)));
  i2 = gb + 64016 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i43 >> 2] = 0;
  i26 = i43 + 12 | 0;
  HEAP32[i26 >> 2] = 0;
  i27 = i43 + 16 | 0;
  HEAP32[i27 >> 2] = 0;
  i3 = HEAP32[gb + 1163236 >> 2] | 0;
  if ((i4 | 0) < 4 | (i2 | 0) != 0 | (i3 | 0) == 0) {
   i5 = i4;
   i1 = i2;
  } else {
   i2 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
   i1 = gb + 64016 | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1163236 >> 2] | 0;
  }
  HEAP32[i43 + 4 >> 2] = i4;
  HEAP32[i43 + 8 >> 2] = i2;
  HEAP32[i38 >> 2] = 0;
  i2 = i38 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  i4 = i38 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  if (!((i3 | 0) == 0 | ((i5 | 0) < 4 | (i1 | 0) != 0))) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
  HEAP32[i38 + 4 >> 2] = i5;
  HEAP32[i38 + 8 >> 2] = i1;
  __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 26572 | 0, i38, 0);
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i26 >> 2] = i1;
  i2 = HEAP32[i27 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i27 >> 2] = i1;
   HEAP32[i43 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i43 >> 2] | 0, i1 << 3, 4, i43 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i43 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i23 | 0, HEAP32[i43 >> 2] | 0, HEAP32[i26 >> 2] << 3 | 0) | 0;
   HEAP32[i27 >> 2] = i1;
   HEAP32[i43 >> 2] = i23;
   break;
  } while (0);
  __ZN15TextureSettings14GetAnisoLimitsERiS0_(i32, i33);
  __ZN15TextureSettings14SetAnisoLimitsEii(16, 16);
  if (HEAP32[i26 >> 2] | 0) {
   i2 = 0;
   do {
    i3 = HEAP32[(HEAP32[i38 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[(HEAP32[i43 >> 2] | 0) + (i2 << 3) >> 2] = i1;
    i1 = i3 + 40 | 0;
    HEAP32[(HEAP32[i43 >> 2] | 0) + (i2 << 3) + 4 >> 2] = HEAP32[i1 >> 2];
    if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0) | 0) == 2) HEAPF32[i1 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i1 >> 2]));
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0);
  }
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i38 + 4 | 0);
   HEAP32[i38 >> 2] = 0;
  }
  if ((i28 | 0) > 0) {
   i13 = i34 + 4 | 0;
   i14 = i41 + 16 | 0;
   i15 = i41 + 4 | 0;
   i16 = i41 + 8 | 0;
   i17 = i40 + 16 | 0;
   i18 = i38 + 8 | 0;
   i19 = i38 + 12 | 0;
   i20 = i39 + 32 | 0;
   i21 = i39 + 36 | 0;
   i22 = i39 + 48 | 0;
   i23 = i39 + 52 | 0;
   i10 = 0;
   do {
    f24 = Math_fround(Math_fround(Math_fround(i10 | 0) / f25) + Math_fround(-.5));
    i9 = 0;
    do {
     if (HEAP32[i36 >> 2] | 0) {
      f12 = Math_fround(Math_fround(Math_fround(i9 | 0) / f25) + Math_fround(-.5));
      i5 = HEAP32[i42 >> 2] | 0;
      do {
       i1 = HEAP32[i5 >> 2] | 0;
       do if (i1 | 0) {
        HEAP32[i39 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i1) i45 = 86; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i38, i1, i39);
          i2 = HEAP32[i38 >> 2] | 0;
          i7 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
          i45 = 86;
          break;
         }
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i45 = 88;
        } while (0);
        if ((i45 | 0) == 86) i45 = 88;
        if ((i45 | 0) == 88) {
         i45 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
         if (!i1) break;
        }
        __ZN6Camera21ResetProjectionMatrixEv(i1);
        __ZNK6Camera13GetCameraRectEb(i38, i1, 1);
        f8 = Math_fround(f12 / Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(.5)));
        f11 = Math_fround(f24 / Math_fround(Math_fround(HEAPF32[i19 >> 2]) * Math_fround(.5)));
        i2 = i39;
        i3 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0;
        i4 = i2 + 64 | 0;
        do {
         HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
         i2 = i2 + 4 | 0;
         i3 = i3 + 4 | 0;
        } while ((i2 | 0) < (i4 | 0));
        if (!(HEAP8[i1 + 1088 >> 0] | 0)) {
         HEAPF32[i20 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i20 >> 2]));
         HEAPF32[i21 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i21 >> 2]));
        } else {
         HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f8);
         HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
        }
        __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(i1, i39);
       } while (0);
       i5 = i5 + 20 | 0;
      } while ((i5 | 0) != ((HEAP32[i42 >> 2] | 0) + ((HEAP32[i36 >> 2] | 0) * 20 | 0) | 0));
     }
     __Z20PlayerUpdateCanvasesv();
     __Z24PlayerEmitCanvasGeometryv();
     __ZN13RenderManager13RenderCamerasEiPFvvE(i29, 0, 0);
     i5 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 84 >> 2] | 0, i44 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 80 >> 2] | 0, i44 | 0, 0);
     __Z20PlayerRenderUnityGUIi(0);
     mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 80 >> 2] | 0, i44 | 0, i5 | 0);
     __Z26PlayerRenderCanvasOverlaysi(0);
     mftCall_iiiiiii(HEAP32[(HEAP32[i44 >> 2] | 0) + 596 >> 2] | 0, i44 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i13 >> 2] | 0, i30 | 0, i31 | 0, HEAP32[i14 >> 2] | 0) | 0;
     i5 = HEAP32[i15 >> 2] | 0;
     i6 = HEAP32[i16 >> 2] | 0;
     i1 = Math_imul(i5, i28) | 0;
     if ((i6 | 0) > 0) {
      i7 = Math_imul(i1, i28) | 0;
      if ((i5 | 0) > 0) {
       i3 = 0;
       i4 = HEAP32[i14 >> 2] | 0;
       i1 = (HEAP32[i17 >> 2] | 0) + ((Math_imul(i1, i10) | 0) + i9 << 2) | 0;
       while (1) {
        i2 = 0;
        do {
         HEAP32[i1 + ((Math_imul(i2, i28) | 0) << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i5 | 0));
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i6 | 0)) break; else {
         i4 = i4 + (i5 << 2) | 0;
         i1 = i1 + (i7 << 2) | 0;
        }
       }
      }
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i28 | 0));
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i28 | 0));
  }
  __ZN15TextureSettings14SetAnisoLimitsEii(HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0);
  if (HEAP32[i26 >> 2] | 0) {
   i4 = HEAP32[i43 >> 2] | 0;
   do {
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i39 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i45 = 54; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i38, i1, i39);
       i2 = HEAP32[i38 >> 2] | 0;
       i34 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i34 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i34 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i45 = 54; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i45 = 56;
      }
     }
     if ((i45 | 0) == 54) i45 = 56;
     if ((i45 | 0) == 56) {
      i45 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     HEAP32[i1 + 32 + 8 >> 2] = HEAP32[i4 + 4 >> 2];
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
    } while (0);
    i4 = i4 + 8 | 0;
   } while ((i4 | 0) != ((HEAP32[i43 >> 2] | 0) + (HEAP32[i26 >> 2] << 3) | 0));
  }
  if (HEAP32[i36 >> 2] | 0) {
   i4 = HEAP32[i42 >> 2] | 0;
   do {
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i39 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     do if (!i1) i45 = 67; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i38, i1, i39);
       i2 = HEAP32[i38 >> 2] | 0;
       i34 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i34 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i34 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
       i45 = 67;
       break;
      }
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i45 = 69;
     } while (0);
     if ((i45 | 0) == 67) i45 = 69;
     if ((i45 | 0) == 69) {
      i45 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i1, i4 + 4 | 0);
     __ZN6Camera21ResetProjectionMatrixEv(i1);
    } while (0);
    i4 = i4 + 20 | 0;
   } while ((i4 | 0) != ((HEAP32[i42 >> 2] | 0) + ((HEAP32[i36 >> 2] | 0) * 20 | 0) | 0));
  }
  mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 80 >> 2] | 0, i44 | 0, i35 | 0);
  if ((HEAP32[i27 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 >> 2] | 0, i43 + 4 | 0);
   HEAP32[i43 >> 2] = 0;
  }
  if ((HEAP32[i37 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i42 + 4 | 0);
   HEAP32[i42 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 + 16 >> 2] | 0, gb + 63184 | 0);
  i45 = 102;
 } else {
  __ZN5ImageC2Eii13TextureFormat(i40, i30, i31, 4);
  i1 = i40 + 16 | 0;
  if (mftCall_iiiiiii(HEAP32[(HEAP32[i44 >> 2] | 0) + 596 >> 2] | 0, i44 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i34 + 4 >> 2] | 0, i30 | 0, i31 | 0, HEAP32[i1 >> 2] | 0) | 0) i45 = 102; else {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63184 | 0);
   __ZdlPv(i40);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 444909 | 0, 0, gb + 444834 | 0, 402, 1, 0, 0, 0);
  }
 }
 if ((i45 | 0) == 102) {
  i45 = __Znwj(16) | 0;
  HEAP32[i45 >> 2] = 0;
  HEAP32[i45 + 4 >> 2] = 0;
  HEAP32[i45 + 8 >> 2] = 0;
  HEAP32[i45 + 12 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i45, HEAP32[gb + 1162560 >> 2] | 0) | 0;
  HEAP32[i45 + 12 >> 2] = i40;
  __Z21WriteImageAsyncThreadPv(i45) | 0;
 }
 _free(HEAP32[gb + 1162560 >> 2] | 0);
 HEAP32[gb + 1162560 >> 2] = 0;
 STACKTOP = i46;
 return;
}

function __ZN11HaloManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj(i2, i90) {
 i2 = i2 | 0;
 i90 = i90 | 0;
 var i1 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i91 = 0, i92 = 0, i93 = 0;
 i91 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i89 = i91 + 4 | 0;
 i1 = i91;
 if ((HEAP16[gb + 1110856 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i89 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110856 | 0, i89);
  i87 = gb + 1110856 | 0;
 } else i87 = 0;
 i88 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i90 * 20 | 0) >> 2] | 0;
 if (i1 | 0) {
  i15 = i88 + (i90 * 2580 | 0) + 2572 | 0;
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i16 = i88 + (i90 * 2580 | 0) + 2576 | 0;
   i17 = i89 + 4 | 0;
   i18 = i89 + 8 | 0;
   i19 = i89 + 12 | 0;
   i20 = i89 + 16 | 0;
   i21 = i89 + 20 | 0;
   i22 = i89 + 24 | 0;
   i23 = i89 + 28 | 0;
   i24 = i89 + 32 | 0;
   i25 = i89 + 36 | 0;
   i26 = i89 + 40 | 0;
   i27 = i89 + 44 | 0;
   i28 = i89 + 48 | 0;
   i29 = i89 + 52 | 0;
   i30 = i89 + 56 | 0;
   i31 = i89 + 60 | 0;
   i32 = i89 + 64 | 0;
   i33 = i89 + 68 | 0;
   i34 = i89 + 72 | 0;
   i35 = i89 + 76 | 0;
   i36 = i89 + 80 | 0;
   i37 = i89 + 84 | 0;
   i38 = i89 + 88 | 0;
   i39 = i89 + 92 | 0;
   i40 = i89 + 96 | 0;
   i41 = i89 + 100 | 0;
   i42 = i89 + 104 | 0;
   i43 = i89 + 108 | 0;
   i44 = i89 + 112 | 0;
   i45 = i89 + 116 | 0;
   i46 = i89 + 120 | 0;
   i47 = i89 + 124 | 0;
   i48 = i89 + 128 | 0;
   i49 = i89 + 132 | 0;
   i50 = i89 + 136 | 0;
   i51 = i89 + 140 | 0;
   i52 = i89 + 144 | 0;
   i53 = i89 + 148 | 0;
   i54 = i89 + 152 | 0;
   i55 = i89 + 156 | 0;
   i56 = i89 + 160 | 0;
   i57 = i89 + 164 | 0;
   i58 = i89 + 168 | 0;
   i59 = i89 + 172 | 0;
   i60 = i89 + 176 | 0;
   i61 = i89 + 180 | 0;
   i62 = i89 + 184 | 0;
   i63 = i89 + 188 | 0;
   i64 = i89 + 192 | 0;
   i65 = i89 + 196 | 0;
   i66 = i89 + 200 | 0;
   i67 = i89 + 204 | 0;
   i68 = i89 + 208 | 0;
   i69 = i89 + 212 | 0;
   i70 = i89 + 216 | 0;
   i71 = i89 + 220 | 0;
   i72 = i89 + 224 | 0;
   i73 = i89 + 228 | 0;
   i74 = i89 + 232 | 0;
   i75 = i89 + 236 | 0;
   i76 = i89 + 240 | 0;
   i77 = i89 + 244 | 0;
   i78 = i89 + 248 | 0;
   i79 = i89 + 24 | 0;
   i80 = i89 + 48 | 0;
   i81 = i89 + 96 | 0;
   i82 = i89 + 120 | 0;
   i83 = i89 + 144 | 0;
   i84 = i89 + 192 | 0;
   i85 = i89 + 216 | 0;
   i86 = i88 + (i90 * 2580 | 0) + 2560 | 0;
   i14 = 0;
   while (1) {
    i11 = i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 12 | 0;
    i12 = i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 20 | 0;
    f13 = Math_fround(HEAPF32[i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 28 >> 2]);
    f3 = Math_fround(HEAPF32[i12 >> 2]);
    if (!(f3 <= Math_fround(f13 * Math_fround(-2.0)))) {
     f6 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(-255.0)) / f13) + Math_fround(-255.0)) + Math_fround(.5));
     i2 = f6 >= Math_fround(0.0);
     f10 = Math_fround(f6 + Math_fround(-.99999994));
     i2 = ~~(i2 ? f6 : f10) + 1 | 0;
     i9 = HEAP32[i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 24 >> 2] | 0;
     i2 = (Math_imul(i9 & 16711935, i2) | 0) >>> 8 & 16711935 | (Math_imul(i9 >>> 8 & 16711935, i2) | 0) & -16711936;
    } else i2 = HEAP32[i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 24 >> 2] | 0;
    f3 = Math_fround(Math_fround(i2 & 255) / Math_fround(255.0));
    f4 = Math_fround(Math_fround((i2 & 65535) >>> 8 & 255) / Math_fround(255.0));
    f6 = Math_fround(Math_fround(i2 >>> 16 & 255) / Math_fround(255.0));
    f10 = Math_fround(Math_fround(i2 >>> 24 & 255) / Math_fround(255.0));
    do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
     do if (!(f3 <= Math_fround(.0404499993))) {
      if (f3 < Math_fround(1.0)) {
       f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, 2.20000005));
     } else f3 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
     do if (!(f4 <= Math_fround(.0404499993))) {
      if (f4 < Math_fround(1.0)) {
       f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
     } else f4 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
     if (f6 <= Math_fround(.0404499993)) {
      f6 = Math_fround(f6 / Math_fround(12.9200001));
      break;
     }
     if (f6 < Math_fround(1.0)) {
      f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f6 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f6 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f6, 2.20000005));
    } while (0);
    i2 = f3 < Math_fround(0.0);
    f3 = i2 ? Math_fround(0.0) : f3;
    i2 = f3 > Math_fround(1.0);
    i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f3) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i5 = f4 < Math_fround(0.0);
    f4 = i5 ? Math_fround(0.0) : f4;
    i5 = f4 > Math_fround(1.0);
    i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i7 = f6 < Math_fround(0.0);
    f6 = i7 ? Math_fround(0.0) : f6;
    i7 = f6 > Math_fround(1.0);
    i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i9 = f10 > Math_fround(1.0);
    i9 = ~~Math_fround(Math_fround((i9 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
    i9 = i9 << 24;
    i8 = i7 << 16 & 16711680 | i9;
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
     i7 = i2;
     i5 = (i8 | i5 << 8 & 65280) >>> 8;
     i2 = i8 >>> 16;
    }
    if (!(HEAP8[i16 >> 0] | 0)) {
     f10 = Math_fround(Math_fround(f13 * Math_fround(.333000004)) + Math_fround(HEAPF32[i12 >> 2]));
     i93 = HEAP32[i11 >> 2] | 0;
     i8 = i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) + 16 | 0;
     i92 = HEAP32[i8 >> 2] | 0;
     HEAP32[i89 >> 2] = i93;
     HEAP32[i17 >> 2] = i92;
     HEAPF32[i18 >> 2] = f10;
     HEAP32[i19 >> 2] = i93;
     HEAP32[i20 >> 2] = i92;
     HEAPF32[i21 >> 2] = f10;
     f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f13);
     i92 = HEAP32[i8 >> 2] | 0;
     i93 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i22 >> 2] = f6;
     HEAP32[i23 >> 2] = i92;
     HEAP32[i24 >> 2] = i93;
     i93 = HEAP32[i8 >> 2] | 0;
     HEAP32[i25 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i26 >> 2] = i93;
     HEAPF32[i27 >> 2] = f10;
     f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f13);
     f4 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f13);
     i93 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i28 >> 2] = f6;
     HEAPF32[i29 >> 2] = f4;
     HEAP32[i30 >> 2] = i93;
     i93 = HEAP32[i8 >> 2] | 0;
     HEAP32[i31 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i32 >> 2] = i93;
     HEAPF32[i33 >> 2] = f10;
     f4 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f13);
     i93 = HEAP32[i12 >> 2] | 0;
     HEAP32[i34 >> 2] = HEAP32[i11 >> 2];
     HEAPF32[i35 >> 2] = f4;
     HEAP32[i36 >> 2] = i93;
     i93 = HEAP32[i8 >> 2] | 0;
     HEAP32[i37 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i38 >> 2] = i93;
     HEAPF32[i39 >> 2] = f10;
     f4 = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
     f6 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f13);
     i93 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i40 >> 2] = f4;
     HEAPF32[i41 >> 2] = f6;
     HEAP32[i42 >> 2] = i93;
     i93 = HEAP32[i8 >> 2] | 0;
     HEAP32[i43 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i44 >> 2] = i93;
     HEAPF32[i45 >> 2] = f10;
     f6 = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
     i93 = HEAP32[i8 >> 2] | 0;
     i92 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i46 >> 2] = f6;
     HEAP32[i47 >> 2] = i93;
     HEAP32[i48 >> 2] = i92;
     i92 = HEAP32[i8 >> 2] | 0;
     HEAP32[i49 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i50 >> 2] = i92;
     HEAPF32[i51 >> 2] = f10;
     f6 = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
     f4 = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
     i92 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i52 >> 2] = f6;
     HEAPF32[i53 >> 2] = f4;
     HEAP32[i54 >> 2] = i92;
     i92 = HEAP32[i8 >> 2] | 0;
     HEAP32[i55 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i56 >> 2] = i92;
     HEAPF32[i57 >> 2] = f10;
     f4 = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
     i92 = HEAP32[i12 >> 2] | 0;
     HEAP32[i58 >> 2] = HEAP32[i11 >> 2];
     HEAPF32[i59 >> 2] = f4;
     HEAP32[i60 >> 2] = i92;
     i92 = HEAP32[i8 >> 2] | 0;
     HEAP32[i61 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i62 >> 2] = i92;
     HEAPF32[i63 >> 2] = f10;
     f4 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f13);
     f6 = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
     i92 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i64 >> 2] = f4;
     HEAPF32[i65 >> 2] = f6;
     HEAP32[i66 >> 2] = i92;
     i92 = HEAP32[i8 >> 2] | 0;
     HEAP32[i67 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i68 >> 2] = i92;
     HEAPF32[i69 >> 2] = f10;
     f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f13);
     i92 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i12 >> 2] | 0;
     HEAPF32[i70 >> 2] = f13;
     HEAP32[i71 >> 2] = i92;
     HEAP32[i72 >> 2] = i12;
     i12 = HEAP32[i8 >> 2] | 0;
     HEAP32[i73 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i74 >> 2] = i12;
     HEAPF32[i75 >> 2] = f10;
     i12 = HEAP32[i8 >> 2] | 0;
     HEAP32[i76 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i77 >> 2] = i12;
     HEAPF32[i78 >> 2] = f10;
    } else __Z28GetHaloVertexPositionsStereoP8Vector3fRKS_S2_f(i89, i88 + (i90 * 2580 | 0) + (i14 * 40 | 0) | 0, i86, f13);
    HEAP32[i1 >> 2] = HEAP32[i89 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i89 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i89 + 8 >> 2];
    i93 = i7 & 255 | i9 | i5 << 8 & 65280 | i2 << 16 & 16711680;
    HEAP32[i1 + 12 >> 2] = i93;
    HEAPF32[i1 + 16 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 20 >> 2] = Math_fround(.5);
    i92 = i1 + 24 | 0;
    HEAP32[i92 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i1 + 36 >> 2] = i93;
    HEAPF32[i1 + 40 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 44 >> 2] = Math_fround(.5);
    i92 = i1 + 48 | 0;
    HEAP32[i92 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i79 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i79 + 8 >> 2];
    HEAP32[i1 + 60 >> 2] = i93;
    HEAPF32[i1 + 64 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 68 >> 2] = Math_fround(.5);
    i92 = i1 + 72 | 0;
    HEAP32[i92 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
    HEAP32[i1 + 84 >> 2] = i93;
    HEAPF32[i1 + 88 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 92 >> 2] = Math_fround(.5);
    i92 = i1 + 96 | 0;
    HEAP32[i92 >> 2] = HEAP32[i80 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
    HEAP32[i1 + 108 >> 2] = i93;
    HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
    i92 = i1 + 120 | 0;
    HEAP32[i92 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    HEAP32[i1 + 132 >> 2] = i93;
    HEAPF32[i1 + 136 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 140 >> 2] = Math_fround(.5);
    i92 = i1 + 144 | 0;
    HEAP32[i92 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
    HEAP32[i1 + 156 >> 2] = i93;
    HEAPF32[i1 + 160 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
    i92 = i1 + 168 | 0;
    HEAP32[i92 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    HEAP32[i1 + 180 >> 2] = i93;
    HEAPF32[i1 + 184 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 188 >> 2] = Math_fround(.5);
    i92 = i1 + 192 | 0;
    HEAP32[i92 >> 2] = HEAP32[i81 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i81 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i81 + 8 >> 2];
    HEAP32[i1 + 204 >> 2] = i93;
    HEAPF32[i1 + 208 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 212 >> 2] = Math_fround(0.0);
    i92 = i1 + 216 | 0;
    HEAP32[i92 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
    HEAP32[i1 + 228 >> 2] = i93;
    HEAPF32[i1 + 232 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 236 >> 2] = Math_fround(.5);
    i92 = i1 + 240 | 0;
    HEAP32[i92 >> 2] = HEAP32[i82 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i82 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i82 + 8 >> 2];
    HEAP32[i1 + 252 >> 2] = i93;
    HEAPF32[i1 + 256 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 260 >> 2] = Math_fround(.5);
    i92 = i1 + 264 | 0;
    HEAP32[i92 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    HEAP32[i1 + 276 >> 2] = i93;
    HEAPF32[i1 + 280 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 284 >> 2] = Math_fround(.5);
    i92 = i1 + 288 | 0;
    HEAP32[i92 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i83 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i83 + 8 >> 2];
    HEAP32[i1 + 300 >> 2] = i93;
    HEAPF32[i1 + 304 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 308 >> 2] = Math_fround(1.0);
    i92 = i1 + 312 | 0;
    HEAP32[i92 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    HEAP32[i1 + 324 >> 2] = i93;
    HEAPF32[i1 + 328 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 332 >> 2] = Math_fround(.5);
    i92 = i1 + 336 | 0;
    HEAP32[i92 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
    HEAP32[i1 + 348 >> 2] = i93;
    HEAPF32[i1 + 352 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 356 >> 2] = Math_fround(1.0);
    i92 = i1 + 360 | 0;
    HEAP32[i92 >> 2] = HEAP32[i61 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
    HEAP32[i1 + 372 >> 2] = i93;
    HEAPF32[i1 + 376 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 380 >> 2] = Math_fround(.5);
    i92 = i1 + 384 | 0;
    HEAP32[i92 >> 2] = HEAP32[i84 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i84 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i84 + 8 >> 2];
    HEAP32[i1 + 396 >> 2] = i93;
    HEAPF32[i1 + 400 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 404 >> 2] = Math_fround(1.0);
    i92 = i1 + 408 | 0;
    HEAP32[i92 >> 2] = HEAP32[i67 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
    HEAP32[i1 + 420 >> 2] = i93;
    HEAPF32[i1 + 424 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 428 >> 2] = Math_fround(.5);
    i92 = i1 + 432 | 0;
    HEAP32[i92 >> 2] = HEAP32[i85 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i85 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i85 + 8 >> 2];
    HEAP32[i1 + 444 >> 2] = i93;
    HEAPF32[i1 + 448 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 452 >> 2] = Math_fround(.5);
    i92 = i1 + 456 | 0;
    HEAP32[i92 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
    HEAP32[i1 + 468 >> 2] = i93;
    HEAPF32[i1 + 472 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 476 >> 2] = Math_fround(.5);
    i92 = i1 + 480 | 0;
    HEAP32[i92 >> 2] = HEAP32[i76 >> 2];
    HEAP32[i92 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
    HEAP32[i92 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
    HEAP32[i1 + 492 >> 2] = i93;
    HEAPF32[i1 + 496 >> 2] = Math_fround(.5);
    HEAPF32[i1 + 500 >> 2] = Math_fround(.5);
    i14 = i14 + 1 | 0;
    if ((i14 | 0) >= (HEAP32[i15 >> 2] | 0)) break; else i1 = i1 + 504 | 0;
   }
  }
 }
 if (!i87) {
  STACKTOP = i91;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i87);
 STACKTOP = i91;
 return;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i59, i60, i1, i61, i62, i56, i64, i41, i43, i39, i63) {
 i59 = i59 | 0;
 i60 = i60 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 i56 = i56 | 0;
 i64 = i64 | 0;
 i41 = i41 | 0;
 i43 = i43 | 0;
 i39 = i39 | 0;
 i63 = i63 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f57 = f0, f58 = f0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, i73 = 0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i65 + 460 | 0;
 i37 = i65 + 448 | 0;
 i55 = i65 + 128 | 0;
 i54 = i65 + 272 | 0;
 i52 = i65 + 208 | 0;
 i53 = i65 + 144 | 0;
 i40 = i65 + 432 | 0;
 i42 = i65 + 416 | 0;
 i35 = i65 + 112 | 0;
 i34 = i65 + 408 | 0;
 i15 = i65 + 96 | 0;
 i16 = i65 + 396 | 0;
 i17 = i65 + 80 | 0;
 i47 = i65 + 64 | 0;
 i51 = i65 + 48 | 0;
 i49 = i65 + 384 | 0;
 i50 = i65 + 372 | 0;
 i33 = i65 + 32 | 0;
 i32 = i65 + 360 | 0;
 i44 = i65 + 16 | 0;
 i48 = i65;
 i46 = i65 + 348 | 0;
 i45 = i65 + 336 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i59 + 16 >> 2]);
 f58 = Math_fround(HEAPF32[i60 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i59 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i60 + 32 >> 2]);
 f12 = Math_fround((f12 > f3 ? f3 : f12) * Math_fround(.100000001));
 f12 = Math_fround(f12 * f12);
 f3 = Math_fround(f57 + f58);
 i29 = i35 + 4 | 0;
 i30 = i35 + 8 | 0;
 i31 = i35 + 12 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 HEAP32[i34 >> 2] = 0;
 i1 = HEAP8[i39 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  f26 = Math_fround(HEAPF32[i59 >> 2]);
  f4 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i59 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i60 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f5 = Math_fround(f26 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i60 + 8 >> 2]));
  i28 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i28 ? f5 : Math_fround(1.0);
  f6 = i28 ? f6 : Math_fround(0.0);
  f7 = i28 ? f7 : Math_fround(0.0);
  HEAPF32[i55 >> 2] = f5;
  HEAPF32[i55 + 4 >> 2] = f6;
  HEAPF32[i55 + 8 >> 2] = f7;
  HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i17 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  i28 = i55;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i36 = 6;
 } else {
  i14 = i59 + 96 | 0;
  f4 = Math_fround(HEAPF32[i60 + 144 >> 2]);
  f5 = Math_fround(HEAPF32[i60 + 148 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 152 >> 2]);
  f7 = Math_fround(-f4);
  f8 = Math_fround(-f5);
  f9 = Math_fround(-f6);
  i1 = i1 & 255;
  i13 = i1 >>> 0 > 1 ? i1 : 1;
  i2 = 0;
  i11 = 0;
  while (1) {
   i28 = HEAPU8[i41 + i11 >> 0] | 0;
   HEAP32[i40 + (i11 << 2) >> 2] = i28;
   i27 = HEAPU8[i43 + i11 >> 0] | 0;
   HEAP32[i42 + (i11 << 2) >> 2] = i27;
   i28 = 1 - i28 | 0;
   f70 = Math_fround(HEAPF32[i14 + (i28 << 4) >> 2]);
   f69 = Math_fround(HEAPF32[i14 + (i28 << 4) + 4 >> 2]);
   f68 = Math_fround(HEAPF32[i14 + (i28 << 4) + 8 >> 2]);
   i28 = HEAP32[i14 + (i28 << 4) + 12 >> 2] | 0;
   f67 = HEAP32[gb + 48 + (i27 << 4) >> 2] | 0 ? f4 : f7;
   f66 = HEAP32[gb + 48 + (i27 << 4) + 4 >> 2] | 0 ? f5 : f8;
   f26 = HEAP32[gb + 48 + (i27 << 4) + 8 >> 2] | 0 ? f6 : f9;
   f72 = Math_fround(f69 - f66);
   f71 = Math_fround(f68 - f26);
   HEAPF32[i35 >> 2] = Math_fround(f70 - f67);
   HEAPF32[i29 >> 2] = f72;
   HEAPF32[i30 >> 2] = f71;
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAPF32[i52 + (i2 << 4) >> 2] = f70;
   HEAPF32[i52 + (i2 << 4) + 4 >> 2] = f69;
   HEAPF32[i52 + (i2 << 4) + 8 >> 2] = f68;
   HEAP32[i52 + (i2 << 4) + 12 >> 2] = i28;
   HEAPF32[i53 + (i2 << 4) >> 2] = f67;
   HEAPF32[i53 + (i2 << 4) + 4 >> 2] = f66;
   HEAPF32[i53 + (i2 << 4) + 8 >> 2] = f26;
   HEAPF32[i53 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   i28 = i54 + (i2 << 4) | 0;
   HEAP32[i28 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i28 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i28 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i28 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i34 >> 2] = i13;
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i15, i54, i52, i53, i40, i42, i35, i34);
  HEAP32[i55 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i55 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i38 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i37 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  if (f4 > f12) {
   i28 = i55;
   i36 = 6;
  }
 }
 do if ((i36 | 0) == 6) {
  i25 = i55 + 4 | 0;
  i27 = i55 + 8 | 0;
  i2 = i59 + 96 | 0;
  i14 = i59 + 100 | 0;
  i15 = i59 + 104 | 0;
  i16 = i59 + 112 | 0;
  i18 = i59 + 116 | 0;
  i19 = i59 + 120 | 0;
  i20 = i60 + 144 | 0;
  i21 = i60 + 148 | 0;
  i22 = i60 + 152 | 0;
  i23 = i59 + 48 | 0;
  i24 = i60 + 48 | 0;
  f8 = f10;
  f26 = f4;
  while (1) {
   HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   f72 = Math_fround(-f5);
   f70 = Math_fround(-f6);
   f69 = Math_fround(-f7);
   i13 = HEAP32[i34 >> 2] | 0;
   f66 = Math_fround(HEAPF32[i2 >> 2]);
   f10 = Math_fround(HEAPF32[i14 >> 2]);
   f9 = Math_fround(HEAPF32[i15 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f66 * f72) + Math_fround(f10 * f70)) + Math_fround(f9 * f69));
   f67 = Math_fround(HEAPF32[i16 >> 2]);
   f71 = Math_fround(HEAPF32[i18 >> 2]);
   f68 = Math_fround(HEAPF32[i19 >> 2]);
   i73 = f4 > Math_fround(Math_fround(Math_fround(f67 * f72) + Math_fround(f71 * f70)) + Math_fround(f68 * f69));
   HEAP32[i40 + (i13 << 2) >> 2] = i73 & 1;
   f67 = i73 ? f66 : f67;
   f71 = i73 ? f10 : f71;
   f68 = i73 ? f9 : f68;
   HEAPF32[i52 + (i13 << 4) >> 2] = f67;
   HEAPF32[i52 + (i13 << 4) + 4 >> 2] = f71;
   HEAPF32[i52 + (i13 << 4) + 8 >> 2] = f68;
   HEAPF32[i52 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   i73 = f5 > Math_fround(0.0);
   i1 = f6 > Math_fround(0.0);
   i11 = f7 > Math_fround(0.0);
   HEAP32[i42 + (i13 << 2) >> 2] = i1 << 31 >> 31 << 1 & 2 | i73 & 1 | i11 << 31 >> 31 << 2 & 4;
   f9 = Math_fround(HEAPF32[i20 >> 2]);
   f10 = Math_fround(HEAPF32[i21 >> 2]);
   f66 = Math_fround(HEAPF32[i22 >> 2]);
   f69 = Math_fround(-f9);
   f70 = Math_fround(-f10);
   f72 = Math_fround(-f66);
   f69 = i73 ? f9 : f69;
   f70 = i1 ? f10 : f70;
   f72 = i11 ? f66 : f72;
   HEAPF32[i53 + (i13 << 4) >> 2] = f69;
   HEAPF32[i53 + (i13 << 4) + 4 >> 2] = f70;
   HEAPF32[i53 + (i13 << 4) + 8 >> 2] = f72;
   HEAPF32[i53 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   f69 = Math_fround(f67 - f69);
   f70 = Math_fround(f71 - f70);
   f72 = Math_fround(f68 - f72);
   HEAPF32[i35 >> 2] = f69;
   HEAPF32[i29 >> 2] = f70;
   HEAPF32[i30 >> 2] = f72;
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   i11 = i54 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   f68 = Math_fround(HEAPF32[i23 >> 2]);
   f71 = Math_fround(HEAPF32[i24 >> 2]);
   f71 = f68 > f71 ? f68 : f71;
   f8 = f8 > f71 ? f8 : f71;
   f71 = Math_fround(f3 + f8);
   f72 = Math_fround(Math_fround(Math_fround(f5 * f69) + Math_fround(f6 * f70)) + Math_fround(f7 * f72));
   i11 = f72 > Math_fround(0.0) ? Math_fround(f72 * f72) > Math_fround(f26 * Math_fround(f71 * f71)) : 0;
   if (Math_fround(f26 * Math_fround(.00039999999)) >= Math_fround(f26 - f72) | i11) {
    f4 = f26;
    i36 = 8;
    break;
   }
   HEAP32[i34 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i33, i54, i52, i53, i40, i42, i35, i34);
   HEAP32[i28 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i28 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i28 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i28 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i55 >> 2]);
   f6 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(HEAPF32[i27 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i38 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i38 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   HEAP32[i38 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
   i1 = f26 > f4;
   if (!(f4 > f12 & i1)) break; else f26 = f4;
  }
  if ((i36 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i41 | 0) {
    HEAP8[i39 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
      HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i73 = 0;
    STACKTOP = i65;
    return i73 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f4)));
   f8 = Math_fround(HEAPF32[i55 >> 2]);
   f9 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(Math_fround(1.0) / f10);
   f8 = Math_fround(f8 * f7);
   f9 = Math_fround(f9 * f7);
   f7 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f7);
   HEAPF32[i56 >> 2] = f8;
   HEAPF32[i56 + 4 >> 2] = f9;
   HEAPF32[i56 + 8 >> 2] = f7;
   HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i47, i51, i13);
   f5 = Math_fround(HEAPF32[i47 >> 2]);
   f6 = Math_fround(HEAPF32[i47 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i47 + 8 >> 2]);
   if (i63) {
    f71 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
    f68 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
    f72 = Math_fround(f71 + f68);
    f70 = Math_fround(f6 - Math_fround(f9 * f71));
    f69 = Math_fround(f4 - Math_fround(f7 * f71));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f8 * f71));
    HEAPF32[i61 + 4 >> 2] = f70;
    HEAPF32[i61 + 8 >> 2] = f69;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f69 = Math_fround(HEAPF32[i51 >> 2]);
    f70 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f70 = Math_fround(Math_fround(f9 * f68) + f70);
    f71 = Math_fround(Math_fround(f7 * f68) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f8 * f68) + f69);
    HEAPF32[i62 + 4 >> 2] = f70;
    HEAPF32[i62 + 8 >> 2] = f71;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f72);
    i73 = i64 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    i73 = 1;
    STACKTOP = i65;
    return i73 | 0;
   } else {
    f71 = Math_fround(f6 - Math_fround(f57 * f9));
    f70 = Math_fround(f4 - Math_fround(f57 * f7));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f8));
    HEAPF32[i61 + 4 >> 2] = f71;
    HEAPF32[i61 + 8 >> 2] = f70;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f70 = Math_fround(HEAPF32[i51 >> 2]);
    f71 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f71 = Math_fround(Math_fround(f58 * f9) + f71);
    f72 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f8) + f70);
    HEAPF32[i62 + 4 >> 2] = f71;
    HEAPF32[i62 + 8 >> 2] = f72;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f3);
    i73 = i64 + 4 | 0;
    HEAP32[i73 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i73 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
    HEAP32[i73 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
    i73 = 1;
    STACKTOP = i65;
    return i73 | 0;
   }
  }
  if (i1) {
   if (!i41) i1 = 6; else break;
   STACKTOP = i65;
   return i1 | 0;
  };
  HEAP32[i38 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
  i11 = HEAP32[i34 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i41 | 0) {
   HEAP8[i39 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
     HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i28 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i44, i48, i11);
  HEAP32[i38 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f26)));
  f9 = Math_fround(HEAPF32[i55 >> 2]);
  f10 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i55 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i44 >> 2]);
  f6 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  if (i63) {
   f72 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
   f69 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
   f3 = Math_fround(f72 + f69);
   f71 = Math_fround(f6 - Math_fround(f10 * f72));
   f70 = Math_fround(f4 - Math_fround(f7 * f72));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f9 * f72));
   HEAPF32[i61 + 4 >> 2] = f71;
   HEAPF32[i61 + 8 >> 2] = f70;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f70 = Math_fround(HEAPF32[i48 >> 2]);
   f71 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f71 = Math_fround(Math_fround(f10 * f69) + f71);
   f72 = Math_fround(Math_fround(f7 * f69) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f9 * f69) + f70);
   HEAPF32[i62 + 4 >> 2] = f71;
   HEAPF32[i62 + 8 >> 2] = f72;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i73 = i64 + 4 | 0;
   HEAP32[i73 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i73 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i73 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  } else {
   f71 = Math_fround(f6 - Math_fround(f57 * f10));
   f70 = Math_fround(f4 - Math_fround(f57 * f7));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f9));
   HEAPF32[i61 + 4 >> 2] = f71;
   HEAPF32[i61 + 8 >> 2] = f70;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f70 = Math_fround(HEAPF32[i48 >> 2]);
   f71 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f71 = Math_fround(Math_fround(f58 * f10) + f71);
   f72 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i48 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f9) + f70);
   HEAPF32[i62 + 4 >> 2] = f71;
   HEAPF32[i62 + 8 >> 2] = f72;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i73 = i64 + 4 | 0;
   HEAP32[i73 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i73 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i73 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  }
  HEAPF32[i64 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i56 >> 2] = f9;
  HEAPF32[i56 + 4 >> 2] = f10;
  HEAPF32[i56 + 8 >> 2] = f7;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  i73 = f12 >= f26 ? 1 : 3;
  STACKTOP = i65;
  return i73 | 0;
 } while (0);
 i2 = HEAP32[i34 >> 2] | 0;
 HEAP8[i39 >> 0] = i2;
 if (!i2) {
  i73 = 6;
  STACKTOP = i65;
  return i73 | 0;
 } else i1 = 0;
 do {
  HEAP8[i41 + i1 >> 0] = HEAP32[i40 + (i1 << 2) >> 2];
  HEAP8[i43 + i1 >> 0] = HEAP32[i42 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i65;
 return i1 | 0;
}

function __ZNK14NavMeshManager11TriangulateERNS_13TriangulationE(i1, i24) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i47 + 28 | 0;
 i32 = i47 + 16 | 0;
 i42 = i47 + 4 | 0;
 i43 = i47;
 i44 = i24 + 20 | 0;
 i45 = i24 + 40 | 0;
 i46 = i24 + 16 | 0;
 if ((HEAP32[i46 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i24 + 4 | 0);
  HEAP32[i24 >> 2] = 0;
 }
 HEAP32[i24 >> 2] = 0;
 i25 = i24 + 12 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i46 >> 2] = 0;
 i26 = i24 + 36 | 0;
 if ((HEAP32[i26 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i44 >> 2] | 0, i24 + 24 | 0);
  HEAP32[i44 >> 2] = 0;
 }
 HEAP32[i44 >> 2] = 0;
 i27 = i24 + 32 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 i29 = i24 + 56 | 0;
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i24 + 44 | 0);
  HEAP32[i45 >> 2] = 0;
 }
 HEAP32[i45 >> 2] = 0;
 i30 = i24 + 52 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i29 >> 2] = 0;
 i31 = i1 + 108 | 0;
 i2 = HEAP32[i31 >> 2] | 0;
 if (!i2) {
  STACKTOP = i47;
  return;
 }
 i33 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i33) {
  STACKTOP = i47;
  return;
 }
 i34 = i32 + 4 | 0;
 i35 = i32 + 8 | 0;
 i36 = i32 + 4 | 0;
 i37 = i36;
 i38 = i24 + 4 | 0;
 i39 = i24 + 24 | 0;
 i40 = i42 + 4 | 0;
 i41 = i42 + 8 | 0;
 i22 = i1 + 112 | 0;
 i23 = i24 + 44 | 0;
 i1 = 0;
 while (1) {
  i18 = __ZNK9dtNavMesh7getTileEi(i2, i1) | 0;
  if (i18 | 0) {
   i19 = i18 + 8 | 0;
   i2 = HEAP32[i19 >> 2] | 0;
   if (i2 | 0) if (HEAP32[i2 + 20 >> 2] | 0) {
    i20 = i18 + 16 | 0;
    i21 = i18 + 20 | 0;
    i17 = 0;
    do {
     i15 = HEAP32[i20 >> 2] | 0;
     i8 = HEAP8[i15 + (i17 << 5) + 28 >> 0] | 0;
     i16 = i8 & 255;
     if ((i8 & 255) >= 3) {
      HEAP32[i34 >> 2] = 0;
      HEAP32[i35 >> 2] = 0;
      HEAP32[i32 >> 2] = i36;
      i7 = 0;
      i4 = 0;
      do {
       i6 = HEAP16[i15 + (i17 << 5) + (i7 << 1) >> 1] | 0;
       if (!i4) i14 = 53; else {
        i2 = i36;
        L29 : while (1) {
         i3 = i4;
         while (1) {
          if ((HEAPU16[i3 + 16 >> 1] | 0) >= (i6 & 65535)) break;
          i3 = HEAP32[i3 + 4 >> 2] | 0;
          if (!i3) break L29;
         }
         i4 = HEAP32[i3 >> 2] | 0;
         if (!i4) {
          i2 = i3;
          break;
         } else i2 = i3;
        }
        if ((i2 | 0) == (i36 | 0)) i14 = 53; else if ((i6 & 65535) < (HEAPU16[i2 + 16 >> 1] | 0)) i14 = 53;
       }
       if ((i14 | 0) == 53) {
        i2 = __ZNK9dtNavMesh14getPolyRefBaseEPK10dtMeshTile(HEAP32[i31 >> 2] | 0, i18) | 0;
        i5 = getTempRet0() | 0;
        i14 = (HEAP32[i21 >> 2] | 0) + ((i6 & 65535) * 3 << 2) | 0;
        HEAP32[i42 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i40 >> 2] = HEAP32[i14 + 4 >> 2];
        HEAP32[i41 >> 2] = HEAP32[i14 + 8 >> 2];
        __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(HEAP32[i22 >> 2] | 0, i2 | i17, i5, i42, i43) | 0;
        HEAP32[i40 >> 2] = HEAP32[i43 >> 2];
        i5 = HEAP32[i30 >> 2] | 0;
        i2 = HEAP32[i36 >> 2] | 0;
        do if (!i2) {
         HEAP32[i28 >> 2] = i36;
         i3 = i37;
         i4 = i36;
         i14 = 63;
        } else {
         while (1) {
          i3 = HEAP16[i2 + 16 >> 1] | 0;
          if ((i6 & 65535) < (i3 & 65535)) {
           i3 = HEAP32[i2 >> 2] | 0;
           if (!i3) {
            i14 = 56;
            break;
           } else i2 = i3;
          } else {
           if ((i3 & 65535) >= (i6 & 65535)) {
            i14 = 62;
            break;
           }
           i4 = i2 + 4 | 0;
           i3 = HEAP32[i4 >> 2] | 0;
           if (!i3) {
            i14 = 60;
            break;
           } else i2 = i3;
          }
         }
         if ((i14 | 0) == 56) {
          HEAP32[i28 >> 2] = i2;
          i3 = i2;
          i4 = i2;
          i14 = 63;
          break;
         } else if ((i14 | 0) == 60) {
          HEAP32[i28 >> 2] = i2;
          i3 = i2;
          i14 = 63;
          break;
         } else if ((i14 | 0) == 62) {
          i14 = 0;
          HEAP32[i28 >> 2] = i2;
          if (!i2) {
           i3 = i2;
           i4 = i28;
           i14 = 63;
           break;
          } else break;
         }
        } while (0);
        if ((i14 | 0) == 63) {
         i14 = 0;
         i2 = __Znwj(24) | 0;
         HEAP16[i2 + 16 >> 1] = i6;
         HEAP32[i2 + 20 >> 2] = 0;
         HEAP32[i2 >> 2] = 0;
         HEAP32[i2 + 4 >> 2] = 0;
         HEAP32[i2 + 8 >> 2] = i3;
         HEAP32[i4 >> 2] = i2;
         i3 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
         if (!i3) i3 = i2; else {
          HEAP32[i32 >> 2] = i3;
          i3 = HEAP32[i4 >> 2] | 0;
         }
         __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i34 >> 2] | 0, i3);
         HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
        }
        HEAP32[i2 + 20 >> 2] = i5;
        i3 = HEAP32[i30 >> 2] | 0;
        i4 = i3 + 1 | 0;
        i5 = HEAP32[i29 >> 2] | 0;
        i6 = i5 & 2147483647;
        do if (i4 >>> 0 > i6 >>> 0) {
         i2 = i5 << 1;
         i2 = (i2 | 0) == 0 ? 1 : i2;
         if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
          HEAP32[i29 >> 2] = i2;
          HEAP32[i45 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i45 >> 2] | 0, i2 * 12 | 0, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i13 | 0, HEAP32[i45 >> 2] | 0, (HEAP32[i30 >> 2] | 0) * 12 | 0) | 0;
          HEAP32[i29 >> 2] = i2;
          HEAP32[i45 >> 2] = i13;
          break;
         }
        } while (0);
        HEAP32[i30 >> 2] = i4;
        i13 = HEAP32[i45 >> 2] | 0;
        HEAP32[i13 + (i3 * 12 | 0) >> 2] = HEAP32[i42 >> 2];
        HEAP32[i13 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i40 >> 2];
        HEAP32[i13 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i41 >> 2];
       }
       i7 = i7 + 1 | 0;
       i4 = HEAP32[i36 >> 2] | 0;
      } while ((i7 | 0) != (i16 | 0));
      i7 = i15 + (i17 << 5) | 0;
      do if (!i4) {
       HEAP32[i28 >> 2] = i36;
       i5 = i37;
       i3 = i36;
       i14 = 27;
      } else {
       i6 = HEAP16[i7 >> 1] | 0;
       i2 = i4;
       while (1) {
        i3 = HEAP16[i2 + 16 >> 1] | 0;
        if ((i6 & 65535) < (i3 & 65535)) {
         i3 = HEAP32[i2 >> 2] | 0;
         if (!i3) {
          i14 = 20;
          break;
         } else i2 = i3;
        } else {
         if ((i3 & 65535) >= (i6 & 65535)) {
          i14 = 26;
          break;
         }
         i3 = i2 + 4 | 0;
         i5 = HEAP32[i3 >> 2] | 0;
         if (!i5) {
          i14 = 24;
          break;
         } else i2 = i5;
        }
       }
       if ((i14 | 0) == 20) {
        HEAP32[i28 >> 2] = i2;
        i5 = i2;
        i3 = i2;
        i14 = 27;
        break;
       } else if ((i14 | 0) == 24) {
        HEAP32[i28 >> 2] = i2;
        i5 = i2;
        i14 = 27;
        break;
       } else if ((i14 | 0) == 26) {
        i14 = 0;
        HEAP32[i28 >> 2] = i2;
        if (!i2) {
         i5 = i2;
         i3 = i28;
         i14 = 27;
         break;
        } else break;
       }
      } while (0);
      if ((i14 | 0) == 27) {
       i4 = __Znwj(24) | 0;
       HEAP16[i4 + 16 >> 1] = HEAP16[i7 >> 1] | 0;
       HEAP32[i4 + 20 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = i5;
       HEAP32[i3 >> 2] = i4;
       i2 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
       if (!i2) i2 = i4; else {
        HEAP32[i32 >> 2] = i2;
        i2 = HEAP32[i3 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i34 >> 2] | 0, i2);
       HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
       i2 = i4;
       i4 = HEAP32[i36 >> 2] | 0;
      }
      i13 = HEAP32[i2 + 20 >> 2] | 0;
      i6 = i15 + (i17 << 5) + 2 | 0;
      do if (!i4) {
       HEAP32[i28 >> 2] = i36;
       i3 = i37;
       i4 = i36;
       i14 = 41;
      } else {
       i5 = HEAP16[i6 >> 1] | 0;
       i2 = i4;
       while (1) {
        i3 = HEAP16[i2 + 16 >> 1] | 0;
        if ((i5 & 65535) < (i3 & 65535)) {
         i3 = HEAP32[i2 >> 2] | 0;
         if (!i3) {
          i14 = 34;
          break;
         } else i2 = i3;
        } else {
         if ((i3 & 65535) >= (i5 & 65535)) {
          i14 = 40;
          break;
         }
         i4 = i2 + 4 | 0;
         i3 = HEAP32[i4 >> 2] | 0;
         if (!i3) {
          i14 = 38;
          break;
         } else i2 = i3;
        }
       }
       if ((i14 | 0) == 34) {
        HEAP32[i28 >> 2] = i2;
        i3 = i2;
        i4 = i2;
        i14 = 41;
        break;
       } else if ((i14 | 0) == 38) {
        HEAP32[i28 >> 2] = i2;
        i3 = i2;
        i14 = 41;
        break;
       } else if ((i14 | 0) == 40) {
        i14 = 0;
        HEAP32[i28 >> 2] = i2;
        if (!i2) {
         i3 = i2;
         i4 = i28;
         i14 = 41;
         break;
        } else break;
       }
      } while (0);
      if ((i14 | 0) == 41) {
       i14 = 0;
       i2 = __Znwj(24) | 0;
       HEAP16[i2 + 16 >> 1] = HEAP16[i6 >> 1] | 0;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i3;
       HEAP32[i4 >> 2] = i2;
       i3 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
       if (!i3) i3 = i2; else {
        HEAP32[i32 >> 2] = i3;
        i3 = HEAP32[i4 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i34 >> 2] | 0, i3);
       HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
      }
      i12 = (i8 & 255) > 2;
      if (i12) {
       i10 = HEAP32[i2 + 20 >> 2] | 0;
       i11 = 2;
       do {
        i6 = i15 + (i17 << 5) + (i11 << 1) | 0;
        i2 = HEAP32[i36 >> 2] | 0;
        do if (!i2) {
         HEAP32[i28 >> 2] = i36;
         i3 = i37;
         i4 = i36;
         i14 = 86;
        } else {
         i5 = HEAP16[i6 >> 1] | 0;
         while (1) {
          i3 = HEAP16[i2 + 16 >> 1] | 0;
          if ((i5 & 65535) < (i3 & 65535)) {
           i3 = HEAP32[i2 >> 2] | 0;
           if (!i3) {
            i14 = 79;
            break;
           } else i2 = i3;
          } else {
           if ((i3 & 65535) >= (i5 & 65535)) {
            i14 = 85;
            break;
           }
           i4 = i2 + 4 | 0;
           i3 = HEAP32[i4 >> 2] | 0;
           if (!i3) {
            i14 = 83;
            break;
           } else i2 = i3;
          }
         }
         if ((i14 | 0) == 79) {
          HEAP32[i28 >> 2] = i2;
          i3 = i2;
          i4 = i2;
          i14 = 86;
          break;
         } else if ((i14 | 0) == 83) {
          HEAP32[i28 >> 2] = i2;
          i3 = i2;
          i14 = 86;
          break;
         } else if ((i14 | 0) == 85) {
          i14 = 0;
          HEAP32[i28 >> 2] = i2;
          if (!i2) {
           i3 = i2;
           i4 = i28;
           i14 = 86;
           break;
          } else break;
         }
        } while (0);
        if ((i14 | 0) == 86) {
         i14 = 0;
         i2 = __Znwj(24) | 0;
         HEAP16[i2 + 16 >> 1] = HEAP16[i6 >> 1] | 0;
         HEAP32[i2 + 20 >> 2] = 0;
         HEAP32[i2 >> 2] = 0;
         HEAP32[i2 + 4 >> 2] = 0;
         HEAP32[i2 + 8 >> 2] = i3;
         HEAP32[i4 >> 2] = i2;
         i3 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
         if (!i3) i3 = i2; else {
          HEAP32[i32 >> 2] = i3;
          i3 = HEAP32[i4 >> 2] | 0;
         }
         __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i34 >> 2] | 0, i3);
         HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
        }
        i9 = i10;
        i10 = HEAP32[i2 + 20 >> 2] | 0;
        i6 = HEAP32[i27 >> 2] | 0;
        i3 = i6 + 1 | 0;
        i4 = HEAP32[i26 >> 2] | 0;
        i5 = i4 & 2147483647;
        do if (i3 >>> 0 > i5 >>> 0) {
         i2 = i4 << 1;
         i2 = (i2 | 0) == 0 ? 1 : i2;
         if (i5 >>> 0 >= i2 >>> 0) break;
         if ((i4 | 0) > -1) {
          HEAP32[i26 >> 2] = i2;
          HEAP32[i44 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i44 >> 2] | 0, i2 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i8 | 0, HEAP32[i44 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
          HEAP32[i26 >> 2] = i2;
          HEAP32[i44 >> 2] = i8;
          break;
         }
        } while (0);
        HEAP32[i27 >> 2] = i3;
        i5 = HEAP32[i44 >> 2] | 0;
        HEAP32[i5 + (i6 << 2) >> 2] = i13;
        i6 = HEAP32[i27 >> 2] | 0;
        i7 = i6 + 1 | 0;
        i3 = HEAP32[i26 >> 2] | 0;
        i4 = i3 & 2147483647;
        do if (i7 >>> 0 > i4 >>> 0) {
         i2 = i3 << 1;
         i2 = (i2 | 0) == 0 ? 1 : i2;
         if (i4 >>> 0 >= i2 >>> 0) {
          i2 = i5;
          i8 = i5;
          break;
         }
         if ((i3 | 0) > -1) {
          HEAP32[i26 >> 2] = i2;
          i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i2 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
          HEAP32[i44 >> 2] = i8;
          i2 = i8;
          break;
         } else {
          i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i8 | 0, HEAP32[i44 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
          HEAP32[i26 >> 2] = i2;
          HEAP32[i44 >> 2] = i8;
          i2 = i8;
          break;
         }
        } else {
         i2 = i5;
         i8 = i5;
        } while (0);
        HEAP32[i27 >> 2] = i7;
        HEAP32[i2 + (i6 << 2) >> 2] = i9;
        i6 = HEAP32[i27 >> 2] | 0;
        i7 = i6 + 1 | 0;
        i4 = HEAP32[i26 >> 2] | 0;
        i5 = i4 & 2147483647;
        do if (i7 >>> 0 > i5 >>> 0) {
         i3 = i4 << 1;
         i3 = (i3 | 0) == 0 ? 1 : i3;
         if (i5 >>> 0 >= i3 >>> 0) break;
         if ((i4 | 0) > -1) {
          HEAP32[i26 >> 2] = i3;
          i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i3 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
          HEAP32[i44 >> 2] = i2;
          break;
         } else {
          i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i2 | 0, HEAP32[i44 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
          HEAP32[i26 >> 2] = i3;
          HEAP32[i44 >> 2] = i2;
          break;
         }
        } while (0);
        HEAP32[i27 >> 2] = i7;
        HEAP32[i2 + (i6 << 2) >> 2] = i10;
        i11 = i11 + 1 | 0;
       } while ((i11 | 0) != (i16 | 0));
       if (i12) {
        i4 = i15 + (i17 << 5) + 29 | 0;
        i2 = 2;
        do {
         i5 = HEAPU8[i4 >> 0] | 0;
         i6 = HEAP32[i25 >> 2] | 0;
         i7 = i6 + 1 | 0;
         i8 = HEAP32[i46 >> 2] | 0;
         i9 = i8 & 2147483647;
         do if (i7 >>> 0 > i9 >>> 0) {
          i3 = i8 << 1;
          i3 = (i3 | 0) == 0 ? 1 : i3;
          if (i9 >>> 0 >= i3 >>> 0) break;
          if ((i8 | 0) > -1) {
           HEAP32[i46 >> 2] = i3;
           HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i3 << 2, 4, i38, 0, gb + 1047584 | 0, 464) | 0;
           break;
          } else {
           i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i38, 0, gb + 1047584 | 0, 446) | 0;
           _memcpy(i15 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i25 >> 2] << 2 | 0) | 0;
           HEAP32[i46 >> 2] = i3;
           HEAP32[i24 >> 2] = i15;
           break;
          }
         } while (0);
         HEAP32[i25 >> 2] = i7;
         HEAP32[(HEAP32[i24 >> 2] | 0) + (i6 << 2) >> 2] = i5;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) != (i16 | 0));
       }
      }
      __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i32, HEAP32[i36 >> 2] | 0);
      i2 = HEAP32[i19 >> 2] | 0;
     }
     i17 = i17 + 1 | 0;
    } while (i17 >>> 0 < (HEAP32[i2 + 20 >> 2] | 0) >>> 0);
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i33 | 0)) break;
  i2 = HEAP32[i31 >> 2] | 0;
 }
 STACKTOP = i47;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i2 + 960 | 0;
 i32 = i2 + 928 | 0;
 i31 = i2 + 896 | 0;
 i30 = i2 + 864 | 0;
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i33 >> 2] = HEAP32[gb + 128580 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[gb + 128580 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[gb + 128580 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[gb + 128580 + 12 >> 2];
 HEAP32[i33 + 16 >> 2] = HEAP32[gb + 128580 + 16 >> 2];
 HEAP32[i33 + 20 >> 2] = HEAP32[gb + 128580 + 20 >> 2];
 HEAP32[i33 + 24 >> 2] = HEAP32[gb + 128580 + 24 >> 2];
 HEAP32[i33 + 28 >> 2] = HEAP32[gb + 128580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i33 | 0, 32) | 0;
 HEAP32[i32 >> 2] = HEAP32[gb + 128612 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[gb + 128612 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[gb + 128612 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[gb + 128612 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[gb + 128612 + 16 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[gb + 128612 + 20 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[gb + 128612 + 24 >> 2];
 HEAP32[i32 + 28 >> 2] = HEAP32[gb + 128612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i32 | 0, 32) | 0;
 HEAP32[i31 >> 2] = HEAP32[gb + 128644 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[gb + 128644 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[gb + 128644 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[gb + 128644 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[gb + 128644 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[gb + 128644 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[gb + 128644 + 24 >> 2];
 HEAP32[i31 + 28 >> 2] = HEAP32[gb + 128644 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i31 | 0, 32) | 0;
 HEAP32[i30 >> 2] = HEAP32[gb + 128676 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[gb + 128676 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[gb + 128676 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[gb + 128676 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[gb + 128676 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[gb + 128676 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[gb + 128676 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[gb + 128676 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i30 | 0, 32) | 0;
 HEAP32[i29 >> 2] = HEAP32[gb + 128708 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 128708 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 128708 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 128708 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 128708 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 128708 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 128708 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 128708 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 128740 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 128740 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 128740 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 128740 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 128740 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 128740 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 128740 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 128740 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 128772 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 128772 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 128772 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 128772 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 128772 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 128772 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 128772 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 128772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 128804 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 128804 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 128804 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 128804 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 128804 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 128804 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 128804 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 128804 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 128836 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 128836 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 128836 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 128836 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 128836 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 128836 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 128836 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 128836 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 128868 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 128868 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 128868 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 128868 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 128868 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 128868 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 128868 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 128868 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 128900 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 128900 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 128900 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 128900 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 128900 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 128900 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 128900 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 128900 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 128932 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 128932 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 128932 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 128932 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 128932 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 128932 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 128932 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 128932 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 128964 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 128964 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 128964 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 128964 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 128964 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 128964 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 128964 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 128964 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 128996 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 128996 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 128996 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 128996 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 128996 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 128996 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 128996 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 128996 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 129028 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 129028 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 129028 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 129028 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 129028 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 129028 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 129028 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 129028 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 129060 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 129060 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 129060 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 129060 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 129060 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 129060 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 129060 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 129060 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 129092 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 129092 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 129092 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 129092 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 129092 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 129092 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 129092 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 129092 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 129124 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 129124 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 129124 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 129124 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 129124 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 129124 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 129124 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 129124 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 129156 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 129156 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 129156 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 129156 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 129156 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 129156 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 129156 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 129156 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 129188 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 129188 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 129188 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 129188 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 129188 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 129188 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 129188 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 129188 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 129220 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 129220 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 129220 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 129220 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 129220 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 129220 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 129220 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 129220 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 129252 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 129252 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 129252 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 129252 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 129252 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 129252 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 129252 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 129252 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 129284 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 129284 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 129284 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 129284 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 129284 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 129284 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 129284 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 129284 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 129316 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 129316 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 129316 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 129316 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 129316 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 129316 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 129316 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 129316 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 129348 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 129348 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 129348 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 129348 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 129348 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 129348 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 129348 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 129348 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 129380 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 129380 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 129380 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 129380 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 129380 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 129380 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 129380 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 129380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 129412 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 129412 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 129412 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 129412 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 129412 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 129412 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 129412 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 129412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 129444 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 129444 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 129444 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 129444 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 129444 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 129444 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 129444 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 129444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 129476 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 129476 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 129476 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 129476 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 129476 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 129476 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 129476 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 129476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 129508 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 129508 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 129508 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 129508 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 129508 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 129508 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 129508 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 129508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 129540 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 129540 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 129540 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 129540 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 129540 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 129540 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 129540 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 129540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i41, i43, i42, i1, i65, i66, i67, i68, i70, i72, i58) {
 i41 = i41 | 0;
 i43 = i43 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 i67 = i67 | 0;
 i68 = i68 | 0;
 i70 = i70 | 0;
 i72 = i72 | 0;
 i58 = i58 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f59 = f0, f60 = f0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i69 = 0, i71 = 0, i73 = 0, f74 = f0, f75 = f0, f76 = f0, f77 = f0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i73 + 432 | 0;
 i44 = i73 + 416 | 0;
 i2 = i73 + 336 | 0;
 i52 = i73 + 548 | 0;
 i51 = i73 + 536 | 0;
 i63 = i73 + 352 | 0;
 i61 = i73 + 272 | 0;
 i62 = i73 + 208 | 0;
 i69 = i73 + 520 | 0;
 i71 = i73 + 504 | 0;
 i45 = i73 + 496 | 0;
 i64 = i73 + 192 | 0;
 i28 = i73 + 176 | 0;
 i26 = i73 + 160 | 0;
 i29 = i73 + 144 | 0;
 i27 = i73 + 128 | 0;
 i30 = i73 + 484 | 0;
 i32 = i73 + 112 | 0;
 i47 = i73 + 96 | 0;
 i46 = i73 + 80 | 0;
 i54 = i73 + 64 | 0;
 i55 = i73 + 48 | 0;
 i53 = i73 + 472 | 0;
 i39 = i73 + 32 | 0;
 i38 = i73 + 460 | 0;
 i49 = i73 + 16 | 0;
 i50 = i73;
 i48 = i73 + 448 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f59 = Math_fround(HEAPF32[i41 + 16 >> 2]);
 f60 = Math_fround(HEAPF32[i43 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f37 = Math_fround(HEAPF32[i41 + 32 >> 2]);
 f57 = Math_fround(HEAPF32[i43 + 32 >> 2]);
 f37 = Math_fround((f37 > f57 ? f57 : f37) * Math_fround(.100000001));
 f37 = Math_fround(f37 * f37);
 f57 = Math_fround(f59 + f60);
 HEAP32[i45 >> 2] = 0;
 if (!(HEAP8[i58 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i42 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i42 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i42 + 56 >> 2]);
  i36 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i36 ? f5 : Math_fround(1.0);
  f6 = i36 ? f6 : Math_fround(0.0);
  f7 = i36 ? f7 : Math_fround(0.0);
  HEAPF32[i64 >> 2] = f5;
  HEAPF32[i64 + 4 >> 2] = f6;
  HEAPF32[i64 + 8 >> 2] = f7;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i32 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  i36 = i64;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i56 = 7;
 } else {
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i41 + 16 | 0;
  i2 = i42 + 48 | 0;
  i3 = i42 + 52 | 0;
  i8 = i42 + 56 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 8 | 0;
  i11 = i42 + 16 | 0;
  i12 = i42 + 32 | 0;
  i13 = i42 + 4 | 0;
  i14 = i42 + 20 | 0;
  i15 = i42 + 36 | 0;
  i16 = i42 + 8 | 0;
  i17 = i42 + 24 | 0;
  i18 = i42 + 40 | 0;
  i19 = i43 + 16 | 0;
  i20 = i29 + 4 | 0;
  i21 = i29 + 8 | 0;
  i22 = i28 + 4 | 0;
  i23 = i28 + 8 | 0;
  i24 = i28 + 12 | 0;
  i25 = 0;
  do {
   i35 = HEAPU8[i70 + i25 >> 0] | 0;
   HEAP32[i69 + (i25 << 2) >> 2] = i35;
   i36 = HEAPU8[i72 + i25 >> 0] | 0;
   HEAP32[i71 + (i25 << 2) >> 2] = i36;
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i26, i41, i35, i1);
   f75 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(HEAPF32[i8 >> 2]);
   f76 = Math_fround(HEAPF32[i26 >> 2]);
   f74 = Math_fround(HEAPF32[i9 >> 2]);
   f31 = Math_fround(HEAPF32[i10 >> 2]);
   f6 = Math_fround(f76 * Math_fround(HEAPF32[i42 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f74 * Math_fround(HEAPF32[i11 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f31 * Math_fround(HEAPF32[i12 >> 2])));
   f7 = Math_fround(f76 * Math_fround(HEAPF32[i13 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f74 * Math_fround(HEAPF32[i14 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f31 * Math_fround(HEAPF32[i15 >> 2])));
   f76 = Math_fround(f76 * Math_fround(HEAPF32[i16 >> 2]));
   f74 = Math_fround(f76 + Math_fround(f74 * Math_fround(HEAPF32[i17 >> 2])));
   f6 = Math_fround(f75 + f6);
   f7 = Math_fround(f5 + f7);
   f31 = Math_fround(f4 + Math_fround(f74 + Math_fround(f31 * Math_fround(HEAPF32[i18 >> 2]))));
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i29, i43, i36, i19);
   f74 = Math_fround(HEAPF32[i29 >> 2]);
   f4 = Math_fround(HEAPF32[i20 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f31 - Math_fround(HEAPF32[i21 >> 2]));
   HEAPF32[i28 >> 2] = Math_fround(f6 - f74);
   HEAPF32[i22 >> 2] = f4;
   HEAPF32[i23 >> 2] = f5;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   i36 = HEAP32[i45 >> 2] | 0;
   HEAPF32[i61 + (i36 << 4) >> 2] = f6;
   HEAPF32[i61 + (i36 << 4) + 4 >> 2] = f7;
   HEAPF32[i61 + (i36 << 4) + 8 >> 2] = f31;
   HEAPF32[i61 + (i36 << 4) + 12 >> 2] = Math_fround(0.0);
   i35 = i62 + (i36 << 4) | 0;
   HEAP32[i35 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i35 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i35 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i35 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   HEAP32[i45 >> 2] = i36 + 1;
   i36 = i63 + (i36 << 4) | 0;
   HEAP32[i36 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i25 = i25 + 1 | 0;
  } while (i25 >>> 0 < (HEAPU8[i58 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i27, i63, i61, i62, i69, i71, i28, i45);
  HEAP32[i64 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i64 >> 2]);
  f6 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i52 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i51 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i32 >> 2] = HEAP32[i64 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
  if (f4 > f37) {
   i36 = i64;
   i56 = 7;
  } else i2 = HEAP32[i45 >> 2] | 0;
 }
 do if ((i56 | 0) == 7) {
  i34 = i64 + 4 | 0;
  i35 = i64 + 8 | 0;
  i8 = i42 + 4 | 0;
  i9 = i42 + 8 | 0;
  i10 = i42 + 16 | 0;
  i11 = i42 + 20 | 0;
  i12 = i42 + 24 | 0;
  i13 = i42 + 32 | 0;
  i14 = i42 + 36 | 0;
  i15 = i42 + 40 | 0;
  i16 = i40 + 4 | 0;
  i17 = i40 + 8 | 0;
  i18 = i40 + 12 | 0;
  i19 = i42 + 48 | 0;
  i20 = i42 + 52 | 0;
  i21 = i42 + 56 | 0;
  i22 = i44 + 4 | 0;
  i23 = i44 + 8 | 0;
  i24 = i47 + 4 | 0;
  i25 = i47 + 8 | 0;
  i26 = i46 + 4 | 0;
  i27 = i46 + 8 | 0;
  i28 = i46 + 12 | 0;
  i29 = i41 + 48 | 0;
  i30 = i43 + 48 | 0;
  while (1) {
   HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i51 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i51 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i32 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   f76 = Math_fround(-f5);
   f77 = Math_fround(-f6);
   f5 = Math_fround(-f7);
   i3 = HEAP32[i45 >> 2] | 0;
   i2 = i61 + (i3 << 4) | 0;
   f74 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) * f76);
   f74 = Math_fround(f74 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f77));
   f74 = Math_fround(f74 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f5));
   f31 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f76);
   f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f77));
   f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f5));
   f7 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f76);
   f77 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f77));
   f5 = Math_fround(f77 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f5));
   HEAPF32[i40 >> 2] = f74;
   HEAPF32[i16 >> 2] = f31;
   HEAPF32[i17 >> 2] = f5;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i44, i41, i40, i2, i69 + (i3 << 2) | 0);
   f5 = Math_fround(HEAPF32[i19 >> 2]);
   f31 = Math_fround(HEAPF32[i20 >> 2]);
   f74 = Math_fround(HEAPF32[i21 >> 2]);
   f77 = Math_fround(HEAPF32[i44 >> 2]);
   f7 = Math_fround(HEAPF32[i22 >> 2]);
   f76 = Math_fround(HEAPF32[i23 >> 2]);
   f75 = Math_fround(f77 * Math_fround(HEAPF32[i42 >> 2]));
   f75 = Math_fround(f75 + Math_fround(f7 * Math_fround(HEAPF32[i10 >> 2])));
   f75 = Math_fround(f75 + Math_fround(f76 * Math_fround(HEAPF32[i13 >> 2])));
   f6 = Math_fround(f77 * Math_fround(HEAPF32[i8 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i11 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f76 * Math_fround(HEAPF32[i14 >> 2])));
   f77 = Math_fround(f77 * Math_fround(HEAPF32[i9 >> 2]));
   f7 = Math_fround(f77 + Math_fround(f7 * Math_fround(HEAPF32[i12 >> 2])));
   f75 = Math_fround(f5 + f75);
   f6 = Math_fround(f31 + f6);
   f76 = Math_fround(f74 + Math_fround(f7 + Math_fround(f76 * Math_fround(HEAPF32[i15 >> 2]))));
   HEAPF32[i2 >> 2] = f75;
   HEAPF32[i61 + (i3 << 4) + 4 >> 2] = f6;
   HEAPF32[i61 + (i3 << 4) + 8 >> 2] = f76;
   HEAPF32[i61 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i45 >> 2] | 0;
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i47, i43, i64, i62 + (i3 << 4) | 0, i71 + (i3 << 2) | 0);
   f7 = Math_fround(HEAPF32[i47 >> 2]);
   f74 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(f75 - f7);
   f74 = Math_fround(f6 - f74);
   f76 = Math_fround(f76 - Math_fround(HEAPF32[i25 >> 2]));
   HEAPF32[i46 >> 2] = f7;
   HEAPF32[i26 >> 2] = f74;
   HEAPF32[i27 >> 2] = f76;
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i45 >> 2] | 0;
   i2 = i63 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i46 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i29 >> 2]);
   f75 = Math_fround(HEAPF32[i30 >> 2]);
   f75 = f6 > f75 ? f6 : f75;
   f33 = f33 > f75 ? f33 : f75;
   f75 = Math_fround(f57 + f33);
   f75 = Math_fround(f4 * Math_fround(f75 * f75));
   f6 = Math_fround(HEAPF32[i64 >> 2]);
   f31 = Math_fround(HEAPF32[i34 >> 2]);
   f76 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f31 * f74)) + Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f76));
   i2 = f76 > Math_fround(0.0) & Math_fround(f76 * f76) > f75;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f76) | i2) {
    i56 = 9;
    break;
   }
   HEAP32[i45 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i39, i63, i61, i62, i69, i71, i46, i45);
   HEAP32[i36 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i64 >> 2]);
   f6 = Math_fround(HEAPF32[i34 >> 2]);
   f7 = Math_fround(HEAPF32[i35 >> 2]);
   f31 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i52 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i52 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i52 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   i1 = f4 > f31;
   if (!(f31 > f37 & i1)) break; else f4 = f31;
  }
  if ((i56 | 0) == 9) {
   if (i70 | 0) {
    HEAP8[i58 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i70 + i1 >> 0] = HEAP32[i69 + (i1 << 2) >> 2];
      HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i72 = 0;
    STACKTOP = i73;
    return i72 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i54, i55, i3);
   f74 = Math_fround(Math_sqrt(Math_fround(f4)));
   f75 = Math_fround(HEAPF32[i64 >> 2]);
   f76 = Math_fround(HEAPF32[i34 >> 2]);
   f77 = Math_fround(Math_fround(1.0) / f74);
   f75 = Math_fround(f75 * f77);
   f76 = Math_fround(f76 * f77);
   f77 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f77);
   f31 = Math_fround(HEAPF32[i54 >> 2]);
   f37 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f37 = Math_fround(f37 - Math_fround(f59 * f76));
   f33 = Math_fround(Math_fround(HEAPF32[i54 + 8 >> 2]) - Math_fround(f59 * f77));
   HEAPF32[i65 >> 2] = Math_fround(f31 - Math_fround(f59 * f75));
   HEAPF32[i65 + 4 >> 2] = f37;
   HEAPF32[i65 + 8 >> 2] = f33;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   f33 = Math_fround(HEAPF32[i55 >> 2]);
   f37 = Math_fround(HEAPF32[i55 + 4 >> 2]);
   f37 = Math_fround(Math_fround(f60 * f76) + f37);
   f59 = Math_fround(Math_fround(f60 * f77) + Math_fround(HEAPF32[i55 + 8 >> 2]));
   HEAPF32[i66 >> 2] = Math_fround(Math_fround(f60 * f75) + f33);
   HEAPF32[i66 + 4 >> 2] = f37;
   HEAPF32[i66 + 8 >> 2] = f59;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i68 >> 2] = Math_fround(f74 - f57);
   i72 = i68 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i53 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
   HEAPF32[i67 >> 2] = f75;
   HEAPF32[i67 + 4 >> 2] = f76;
   HEAPF32[i67 + 8 >> 2] = f77;
   HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
   i72 = 1;
   STACKTOP = i73;
   return i72 | 0;
  }
  i2 = HEAP32[i45 >> 2] | 0;
  if (i1) {
   if (!i70) i1 = 6; else break;
   STACKTOP = i73;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i70 | 0) {
   HEAP8[i58 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i70 + i1 >> 0] = HEAP32[i69 + (i1 << 2) >> 2];
     HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i36 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i63, i61, i62, i64, i49, i50, i2);
  HEAP32[i52 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  f74 = Math_fround(Math_sqrt(Math_fround(f4)));
  f75 = Math_fround(HEAPF32[i64 >> 2]);
  f76 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f77 = Math_fround(Math_fround(1.0) / f74);
  f75 = Math_fround(f75 * f77);
  f76 = Math_fround(f76 * f77);
  f77 = Math_fround(Math_fround(HEAPF32[i64 + 8 >> 2]) * f77);
  f31 = Math_fround(HEAPF32[i49 >> 2]);
  f37 = Math_fround(HEAPF32[i49 + 4 >> 2]);
  f37 = Math_fround(f37 - Math_fround(f59 * f76));
  f33 = Math_fround(Math_fround(HEAPF32[i49 + 8 >> 2]) - Math_fround(f59 * f77));
  HEAPF32[i65 >> 2] = Math_fround(f31 - Math_fround(f59 * f75));
  HEAPF32[i65 + 4 >> 2] = f37;
  HEAPF32[i65 + 8 >> 2] = f33;
  HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
  f33 = Math_fround(HEAPF32[i50 >> 2]);
  f37 = Math_fround(HEAPF32[i50 + 4 >> 2]);
  f37 = Math_fround(Math_fround(f60 * f76) + f37);
  f59 = Math_fround(Math_fround(f60 * f77) + Math_fround(HEAPF32[i50 + 8 >> 2]));
  HEAPF32[i66 >> 2] = Math_fround(Math_fround(f60 * f75) + f33);
  HEAPF32[i66 + 4 >> 2] = f37;
  HEAPF32[i66 + 8 >> 2] = f59;
  HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i68 >> 2] = Math_fround(f74 - f57);
  i72 = i68 + 4 | 0;
  HEAP32[i72 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i72 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i72 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAPF32[i67 >> 2] = f75;
  HEAPF32[i67 + 4 >> 2] = f76;
  HEAPF32[i67 + 8 >> 2] = f77;
  HEAPF32[i67 + 12 >> 2] = Math_fround(0.0);
  i72 = 3;
  STACKTOP = i73;
  return i72 | 0;
 } while (0);
 HEAP8[i58 >> 0] = i2;
 if (!i2) {
  i72 = 6;
  STACKTOP = i73;
  return i72 | 0;
 } else i1 = 0;
 do {
  HEAP8[i70 + i1 >> 0] = HEAP32[i69 + (i1 << 2) >> 2];
  HEAP8[i72 + i1 >> 0] = HEAP32[i71 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i73;
 return i1 | 0;
}

function __Z21sweepCapsule_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i30, i34, i3, i40, f29, i38, i31, f1) {
 i30 = i30 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 i40 = i40 | 0;
 f29 = Math_fround(f29);
 i38 = i38 | 0;
 i31 = i31 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i41 + 220 | 0;
 i32 = i41 + 192 | 0;
 i39 = i41 + 104 | 0;
 i36 = i41 + 92 | 0;
 i37 = i41 + 80 | 0;
 i35 = i41 + 232 | 0;
 i16 = i41 + 32 | 0;
 i33 = i41 + 120 | 0;
 i17 = i41;
 i13 = HEAP32[i30 + 36 >> 2] | 0;
 i26 = HEAP8[i30 + 32 >> 0] & 2;
 i27 = HEAP16[i31 >> 1] & 128;
 i25 = i27 << 16 >> 16 != 0 | i26 << 24 >> 24 != 0;
 HEAP32[i28 >> 2] = HEAP32[i13 + 32 >> 2];
 HEAP32[i28 + 4 >> 2] = i13 + 48;
 HEAP32[i28 + 8 >> 2] = HEAP32[i13 + 36 >> 2];
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f1);
 i13 = HEAP32[i3 >> 2] | 0;
 HEAP32[i32 >> 2] = i13;
 i21 = i32 + 4 | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = i11;
 i22 = i32 + 8 | 0;
 i12 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i22 >> 2] = i12;
 i18 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i32 + 12 >> 2] = i18;
 i23 = i32 + 16 | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i23 >> 2] = i6;
 i24 = i32 + 20 | 0;
 i3 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i24 >> 2] = i3;
 i7 = i32 + 24 | 0;
 HEAPF32[i7 >> 2] = f5;
 f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(HEAPF32[i34 + 16 >> 2]);
 f5 = Math_fround(f5 - f47);
 f2 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i11 = i34 + 20 | 0;
 f52 = Math_fround(HEAPF32[i11 >> 2]);
 f2 = Math_fround(f2 - f52);
 f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i12 = i34 + 24 | 0;
 f49 = Math_fround(HEAPF32[i12 >> 2]);
 f5 = Math_fround(f5 * Math_fround(2.0));
 f2 = Math_fround(f2 * Math_fround(2.0));
 f4 = Math_fround(Math_fround(f4 - f49) * Math_fround(2.0));
 i13 = i34 + 12 | 0;
 f50 = Math_fround(HEAPF32[i13 >> 2]);
 f51 = Math_fround(Math_fround(f50 * f50) + Math_fround(-.5));
 f54 = Math_fround(HEAPF32[i34 >> 2]);
 f43 = Math_fround(f5 * f54);
 i14 = i34 + 4 | 0;
 f48 = Math_fround(HEAPF32[i14 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f2 * f48));
 i15 = i34 + 8 | 0;
 f46 = Math_fround(HEAPF32[i15 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f4 * f46));
 f1 = Math_fround(Math_fround(f54 * f43) + Math_fround(Math_fround(f5 * f51) - Math_fround(f50 * Math_fround(Math_fround(f4 * f48) - Math_fround(f2 * f46)))));
 f44 = Math_fround(Math_fround(f48 * f43) + Math_fround(Math_fround(f2 * f51) - Math_fround(f50 * Math_fround(Math_fround(f5 * f46) - Math_fround(f4 * f54)))));
 f43 = Math_fround(Math_fround(Math_fround(f4 * f51) - Math_fround(f50 * Math_fround(Math_fround(f2 * f54) - Math_fround(f5 * f48)))) + Math_fround(f46 * f43));
 f47 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
 f52 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f52);
 f47 = Math_fround(f47 * Math_fround(2.0));
 f52 = Math_fround(f52 * Math_fround(2.0));
 f49 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f49) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(Math_fround(f54 * f47) + Math_fround(f48 * f52)) + Math_fround(f46 * f49));
 f2 = Math_fround(Math_fround(f54 * f5) + Math_fround(Math_fround(f51 * f47) - Math_fround(f50 * Math_fround(Math_fround(f48 * f49) - Math_fround(f46 * f52)))));
 f4 = Math_fround(Math_fround(f48 * f5) + Math_fround(Math_fround(f51 * f52) - Math_fround(f50 * Math_fround(Math_fround(f46 * f47) - Math_fround(f54 * f49)))));
 f5 = Math_fround(Math_fround(Math_fround(f51 * f49) - Math_fround(f50 * Math_fround(Math_fround(f54 * f52) - Math_fround(f48 * f47)))) + Math_fround(f46 * f5));
 f47 = Math_fround(Math_fround(f44 + f4) * Math_fround(.5));
 f52 = Math_fround(Math_fround(f43 + f5) * Math_fround(.5));
 HEAPF32[i39 >> 2] = Math_fround(Math_fround(f1 + f2) * Math_fround(.5));
 i3 = i39 + 4 | 0;
 HEAPF32[i3 >> 2] = f47;
 i6 = i39 + 8 | 0;
 HEAPF32[i6 >> 2] = f52;
 f52 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) * Math_fround(2.0));
 f47 = Math_fround(Math_fround(HEAPF32[i40 + 4 >> 2]) * Math_fround(2.0));
 f49 = Math_fround(Math_fround(HEAPF32[i40 + 8 >> 2]) * Math_fround(2.0));
 f53 = Math_fround(Math_fround(Math_fround(f52 * f54) + Math_fround(f47 * f48)) + Math_fround(f49 * f46));
 f45 = Math_fround(Math_fround(f48 * f53) + Math_fround(Math_fround(f47 * f51) - Math_fround(f50 * Math_fround(Math_fround(f52 * f46) - Math_fround(f49 * f54)))));
 f42 = Math_fround(Math_fround(Math_fround(f49 * f51) - Math_fround(f50 * Math_fround(Math_fround(f47 * f54) - Math_fround(f52 * f48)))) + Math_fround(f46 * f53));
 HEAPF32[i36 >> 2] = Math_fround(Math_fround(f54 * f53) + Math_fround(Math_fround(f52 * f51) - Math_fround(f50 * Math_fround(Math_fround(f49 * f48) - Math_fround(f47 * f46)))));
 i18 = i36 + 4 | 0;
 HEAPF32[i18 >> 2] = f45;
 i19 = i36 + 8 | 0;
 HEAPF32[i19 >> 2] = f42;
 f42 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(f42 + Math_fround(Math_fround(Math_abs(Math_fround(f44 - f4))) * Math_fround(.5)));
 f5 = Math_fround(f42 + Math_fround(Math_fround(Math_abs(Math_fround(f43 - f5))) * Math_fround(.5)));
 HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(Math_fround(Math_abs(Math_fround(f1 - f2))) * Math_fround(.5)));
 i7 = i37 + 4 | 0;
 HEAPF32[i7 >> 2] = f4;
 i8 = i37 + 8 | 0;
 HEAPF32[i8 >> 2] = f5;
 i9 = i30 + 4 | 0;
 i10 = i30 + 8 | 0;
 if (Math_fround(HEAPF32[i9 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i10 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i30 + 12 >> 2]) == Math_fround(1.0)) {
  f53 = Math_fround(HEAPF32[i34 >> 2]);
  f47 = Math_fround(f53 + f53);
  f46 = Math_fround(HEAPF32[i14 >> 2]);
  f2 = Math_fround(f46 + f46);
  f48 = Math_fround(HEAPF32[i15 >> 2]);
  f52 = Math_fround(f48 + f48);
  f51 = Math_fround(HEAPF32[i13 >> 2]);
  f1 = Math_fround(f47 * f51);
  f54 = Math_fround(f2 * f51);
  f51 = Math_fround(f51 * f52);
  f44 = Math_fround(f53 * f2);
  f45 = Math_fround(f53 * f52);
  f2 = Math_fround(f46 * f2);
  f46 = Math_fround(f46 * f52);
  f52 = Math_fround(f48 * f52);
  f48 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f52);
  f49 = Math_fround(f44 + f51);
  f50 = Math_fround(f45 - f54);
  f51 = Math_fround(f44 - f51);
  f47 = Math_fround(Math_fround(1.0) - Math_fround(f53 * f47));
  f52 = Math_fround(f47 - f52);
  f53 = Math_fround(f46 + f1);
  f54 = Math_fround(f45 + f54);
  f1 = Math_fround(f46 - f1);
  f2 = Math_fround(f47 - f2);
  i17 = HEAP32[i34 + 16 >> 2] | 0;
  i18 = HEAP32[i11 >> 2] | 0;
  i19 = HEAP32[i12 >> 2] | 0;
  HEAPF32[i35 >> 2] = f48;
  HEAPF32[i35 + 4 >> 2] = f49;
  HEAPF32[i35 + 8 >> 2] = f50;
  HEAPF32[i35 + 12 >> 2] = f51;
  HEAPF32[i35 + 16 >> 2] = f52;
  HEAPF32[i35 + 20 >> 2] = f53;
  HEAPF32[i35 + 24 >> 2] = f54;
  HEAPF32[i35 + 28 >> 2] = f1;
  HEAPF32[i35 + 32 >> 2] = f2;
  HEAP32[i35 + 36 >> 2] = i17;
  HEAP32[i35 + 40 >> 2] = i18;
  HEAP32[i35 + 44 >> 2] = i19;
  f2 = Math_fround(1.0);
  f1 = f29;
 } else i20 = 4; else i20 = 4; else i20 = 4;
 if ((i20 | 0) == 4) {
  __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i16, i34, i9);
  HEAP32[i35 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i35 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i35 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP32[i35 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
  HEAP32[i35 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
  HEAP32[i35 + 32 >> 2] = HEAP32[i16 + 32 >> 2];
  HEAP32[i35 + 36 >> 2] = HEAP32[i16 + 36 >> 2];
  HEAP32[i35 + 40 >> 2] = HEAP32[i16 + 40 >> 2];
  HEAP32[i35 + 44 >> 2] = HEAP32[i16 + 44 >> 2];
  f48 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i9 >> 2]));
  f2 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 >> 2]));
  f52 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i30 + 12 >> 2]));
  i20 = i17 + 12 | 0;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i17 + 4 >> 2] = f2;
  HEAPF32[i17 + 8 >> 2] = f52;
  HEAP32[i20 >> 2] = HEAP32[i30 + 16 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i30 + 20 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i30 + 24 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i30 + 28 >> 2];
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i33, i17, i20);
  f52 = Math_fround(HEAPF32[i39 >> 2]);
  f2 = Math_fround(HEAPF32[i37 >> 2]);
  f48 = Math_fround(f52 - f2);
  f43 = Math_fround(HEAPF32[i3 >> 2]);
  f62 = Math_fround(HEAPF32[i7 >> 2]);
  f47 = Math_fround(f43 - f62);
  f59 = Math_fround(HEAPF32[i6 >> 2]);
  f63 = Math_fround(HEAPF32[i8 >> 2]);
  f45 = Math_fround(f59 - f63);
  f49 = Math_fround(f52 + f2);
  f44 = Math_fround(f43 + f62);
  f46 = Math_fround(f59 + f63);
  f5 = Math_fround(Math_fround(f48 + f49) * Math_fround(.5));
  f51 = Math_fround(Math_fround(f47 + f44) * Math_fround(.5));
  f61 = Math_fround(Math_fround(f45 + f46) * Math_fround(.5));
  f58 = Math_fround(HEAPF32[i33 >> 2]);
  f53 = Math_fround(f5 * f58);
  f56 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f1 = Math_fround(f5 * f56);
  f42 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f5 = Math_fround(f5 * f42);
  f57 = Math_fround(HEAPF32[i33 + 12 >> 2]);
  f64 = Math_fround(f51 * f57);
  f55 = Math_fround(HEAPF32[i33 + 16 >> 2]);
  f4 = Math_fround(f51 * f55);
  f54 = Math_fround(HEAPF32[i33 + 20 >> 2]);
  f64 = Math_fround(f53 + f64);
  f4 = Math_fround(f1 + f4);
  f51 = Math_fround(f5 + Math_fround(f51 * f54));
  f5 = Math_fround(HEAPF32[i33 + 24 >> 2]);
  f1 = Math_fround(f61 * f5);
  f53 = Math_fround(HEAPF32[i33 + 28 >> 2]);
  f60 = Math_fround(f61 * f53);
  f50 = Math_fround(HEAPF32[i33 + 32 >> 2]);
  f1 = Math_fround(f64 + f1);
  f60 = Math_fround(f4 + f60);
  f61 = Math_fround(f51 + Math_fround(f61 * f50));
  f48 = Math_fround(Math_fround(f49 - f48) * Math_fround(.5));
  f47 = Math_fround(Math_fround(f44 - f47) * Math_fround(.5));
  f45 = Math_fround(Math_fround(f46 - f45) * Math_fround(.5));
  f46 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f58))) + Math_fround(Math_abs(Math_fround(f47 * f57)))) + Math_fround(Math_abs(Math_fround(f45 * f5))));
  f44 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f56))) + Math_fround(Math_abs(Math_fround(f47 * f55)))) + Math_fround(Math_abs(Math_fround(f45 * f53))));
  f45 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f42))) + Math_fround(Math_abs(Math_fround(f47 * f54)))) + Math_fround(Math_abs(Math_fround(f45 * f50))));
  f47 = Math_fround(f1 - f46);
  f48 = Math_fround(f60 - f44);
  f49 = Math_fround(f61 - f45);
  f46 = Math_fround(f1 + f46);
  f44 = Math_fround(f60 + f44);
  f45 = Math_fround(f61 + f45);
  f61 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * f29);
  f60 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
  f61 = Math_fround(f52 + f61);
  f60 = Math_fround(f43 + f60);
  f59 = Math_fround(f59 + Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f29));
  f43 = Math_fround(f61 - f2);
  f52 = Math_fround(f60 - f62);
  f1 = Math_fround(f59 - f63);
  f61 = Math_fround(f2 + f61);
  f60 = Math_fround(f62 + f60);
  f59 = Math_fround(f63 + f59);
  f63 = Math_fround(Math_fround(f43 + f61) * Math_fround(.5));
  f62 = Math_fround(Math_fround(f52 + f60) * Math_fround(.5));
  f2 = Math_fround(Math_fround(f1 + f59) * Math_fround(.5));
  f51 = Math_fround(Math_fround(Math_fround(f58 * f63) + Math_fround(f57 * f62)) + Math_fround(f5 * f2));
  f4 = Math_fround(Math_fround(Math_fround(f56 * f63) + Math_fround(f55 * f62)) + Math_fround(f53 * f2));
  f2 = Math_fround(Math_fround(Math_fround(f42 * f63) + Math_fround(f54 * f62)) + Math_fround(f50 * f2));
  f43 = Math_fround(Math_fround(f61 - f43) * Math_fround(.5));
  f52 = Math_fround(Math_fround(f60 - f52) * Math_fround(.5));
  f1 = Math_fround(Math_fround(f59 - f1) * Math_fround(.5));
  f5 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f58 * f43))) + Math_fround(Math_abs(Math_fround(f57 * f52)))) + Math_fround(Math_abs(Math_fround(f5 * f1))));
  f53 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f56 * f43))) + Math_fround(Math_abs(Math_fround(f55 * f52)))) + Math_fround(Math_abs(Math_fround(f53 * f1))));
  f1 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f42 * f43))) + Math_fround(Math_abs(Math_fround(f54 * f52)))) + Math_fround(Math_abs(Math_fround(f50 * f1))));
  f50 = Math_fround(f51 - f5);
  f52 = Math_fround(f4 - f53);
  f54 = Math_fround(f2 - f1);
  f51 = Math_fround(f5 + f51);
  f53 = Math_fround(f4 + f53);
  f1 = Math_fround(f2 + f1);
  f2 = Math_fround(Math_fround(f47 + f46) * Math_fround(.5));
  f4 = Math_fround(Math_fround(f48 + f44) * Math_fround(.5));
  f5 = Math_fround(Math_fround(f49 + f45) * Math_fround(.5));
  HEAPF32[i39 >> 2] = f2;
  HEAPF32[i3 >> 2] = f4;
  HEAPF32[i6 >> 2] = f5;
  f48 = Math_fround(Math_fround(f44 - f48) * Math_fround(.5));
  f49 = Math_fround(Math_fround(f45 - f49) * Math_fround(.5));
  HEAPF32[i37 >> 2] = Math_fround(Math_fround(f46 - f47) * Math_fround(.5));
  HEAPF32[i7 >> 2] = f48;
  HEAPF32[i8 >> 2] = f49;
  f2 = Math_fround(Math_fround(Math_fround(f50 + f51) * Math_fround(.5)) - f2);
  f4 = Math_fround(Math_fround(Math_fround(f52 + f53) * Math_fround(.5)) - f4);
  f5 = Math_fround(Math_fround(Math_fround(f54 + f1) * Math_fround(.5)) - f5);
  HEAPF32[i36 >> 2] = f2;
  HEAPF32[i18 >> 2] = f4;
  HEAPF32[i19 >> 2] = f5;
  f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)))));
  if (f1 < Math_fround(9.99999968e-21)) f1 = Math_fround(0.0); else {
   f64 = Math_fround(Math_fround(1.0) / f1);
   HEAPF32[i36 >> 2] = Math_fround(f2 * f64);
   HEAPF32[i18 >> 2] = Math_fround(f4 * f64);
   HEAPF32[i19 >> 2] = Math_fround(f5 * f64);
  }
  f2 = Math_fround(f1 / f29);
 }
 HEAP32[i33 + 4 >> 2] = 2;
 HEAP32[i33 >> 2] = gb + 85588 + 8;
 HEAP32[i33 + 8 >> 2] = i38;
 HEAP32[i33 + 12 >> 2] = i35;
 HEAPF32[i33 + 16 >> 2] = f29;
 HEAPF32[i33 + 20 >> 2] = f29;
 HEAPF32[i33 + 24 >> 2] = f2;
 HEAP8[i33 + 28 >> 0] = (i26 & 255) >>> 1 | (i27 & 65535) >>> 7 & 255;
 HEAP32[i33 + 32 >> 2] = i32;
 HEAP32[i33 + 36 >> 2] = i40;
 HEAP32[i33 + 40 >> 2] = i31;
 HEAPF32[i33 + 44 >> 2] = Math_fround(2.0);
 HEAPF32[i33 + 48 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i33 + 52 >> 0] = 0;
 HEAP8[i33 + 53 >> 0] = 0;
 HEAPF32[i38 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 f64 = Math_fround(HEAPF32[i32 >> 2]);
 if (!(f64 == Math_fround(HEAPF32[i32 + 12 >> 2]))) {
  i35 = 0;
  i40 = i33 + 54 | 0;
  HEAP8[i40 >> 0] = i35;
  __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i39, i36, f1, 1, i28, i33, i37);
  i40 = __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf(i33, i38, i32, i30, i34, i25, f29) | 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 f64 = Math_fround(HEAPF32[i21 >> 2]);
 if (!(f64 == Math_fround(HEAPF32[i23 >> 2]))) {
  i35 = 0;
  i40 = i33 + 54 | 0;
  HEAP8[i40 >> 0] = i35;
  __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i39, i36, f1, 1, i28, i33, i37);
  i40 = __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf(i33, i38, i32, i30, i34, i25, f29) | 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 f64 = Math_fround(HEAPF32[i22 >> 2]);
 i35 = f64 == Math_fround(HEAPF32[i24 >> 2]) & 1;
 i40 = i33 + 54 | 0;
 HEAP8[i40 >> 0] = i35;
 __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i39, i36, f1, 1, i28, i33, i37);
 i40 = __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf(i33, i38, i32, i30, i34, i25, f29) | 0;
 STACKTOP = i41;
 return i40 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i38, i43, i42, i1, i64, i65, i66, i67, i69, i71, i57) {
 i38 = i38 | 0;
 i43 = i43 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i66 = i66 | 0;
 i67 = i67 | 0;
 i69 = i69 | 0;
 i71 = i71 | 0;
 i57 = i57 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f39 = f0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i68 = 0, i70 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i72 + 320 | 0;
 i51 = i72 + 500 | 0;
 i50 = i72 + 488 | 0;
 i62 = i72 + 336 | 0;
 i60 = i72 + 256 | 0;
 i61 = i72 + 192 | 0;
 i68 = i72 + 472 | 0;
 i70 = i72 + 456 | 0;
 i44 = i72 + 448 | 0;
 i63 = i72 + 176 | 0;
 i25 = i72 + 160 | 0;
 i26 = i72 + 144 | 0;
 i24 = i72 + 128 | 0;
 i27 = i72 + 436 | 0;
 i28 = i72 + 112 | 0;
 i46 = i72 + 96 | 0;
 i45 = i72 + 80 | 0;
 i53 = i72 + 64 | 0;
 i54 = i72 + 48 | 0;
 i52 = i72 + 424 | 0;
 i41 = i72 + 32 | 0;
 i40 = i72 + 412 | 0;
 i48 = i72 + 16 | 0;
 i49 = i72;
 i47 = i72 + 400 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f58 = Math_fround(HEAPF32[i38 + 16 >> 2]);
 f59 = Math_fround(HEAPF32[i43 + 16 >> 2]);
 f30 = Math_fround(HEAPF32[i1 >> 2]);
 f39 = Math_fround(HEAPF32[i38 + 32 >> 2]);
 f56 = Math_fround(HEAPF32[i43 + 32 >> 2]);
 f39 = Math_fround((f39 > f56 ? f56 : f39) * Math_fround(.100000001));
 f39 = Math_fround(f39 * f39);
 f56 = Math_fround(f58 + f59);
 HEAP32[i44 >> 2] = 0;
 if (!(HEAP8[i57 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i42 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i42 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i42 + 56 >> 2]);
  i37 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i37 ? f5 : Math_fround(1.0);
  f6 = i37 ? f6 : Math_fround(0.0);
  f7 = i37 ? f7 : Math_fround(0.0);
  HEAPF32[i63 >> 2] = f5;
  HEAPF32[i63 + 4 >> 2] = f6;
  HEAPF32[i63 + 8 >> 2] = f7;
  HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i28 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i37 = i63;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i55 = 7;
 } else {
  HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i38 + 96 | 0;
  i2 = i42 + 48 | 0;
  i3 = i42 + 52 | 0;
  i8 = i42 + 56 | 0;
  i9 = i42 + 16 | 0;
  i10 = i42 + 32 | 0;
  i11 = i42 + 4 | 0;
  i12 = i42 + 20 | 0;
  i13 = i42 + 36 | 0;
  i14 = i42 + 8 | 0;
  i15 = i42 + 24 | 0;
  i16 = i42 + 40 | 0;
  i17 = i43 + 16 | 0;
  i18 = i26 + 4 | 0;
  i19 = i26 + 8 | 0;
  i20 = i25 + 4 | 0;
  i21 = i25 + 8 | 0;
  i22 = i25 + 12 | 0;
  i23 = 0;
  do {
   i36 = HEAPU8[i69 + i23 >> 0] | 0;
   HEAP32[i68 + (i23 << 2) >> 2] = i36;
   i37 = HEAPU8[i71 + i23 >> 0] | 0;
   HEAP32[i70 + (i23 << 2) >> 2] = i37;
   i36 = 1 - i36 | 0;
   f75 = Math_fround(HEAPF32[i1 + (i36 << 4) >> 2]);
   f73 = Math_fround(HEAPF32[i1 + (i36 << 4) + 4 >> 2]);
   f29 = Math_fround(HEAPF32[i1 + (i36 << 4) + 8 >> 2]);
   f74 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(HEAPF32[i8 >> 2]);
   f6 = Math_fround(f75 * Math_fround(HEAPF32[i42 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f73 * Math_fround(HEAPF32[i9 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f29 * Math_fround(HEAPF32[i10 >> 2])));
   f7 = Math_fround(f75 * Math_fround(HEAPF32[i11 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f73 * Math_fround(HEAPF32[i12 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f29 * Math_fround(HEAPF32[i13 >> 2])));
   f75 = Math_fround(f75 * Math_fround(HEAPF32[i14 >> 2]));
   f73 = Math_fround(f75 + Math_fround(f73 * Math_fround(HEAPF32[i15 >> 2])));
   f6 = Math_fround(f74 + f6);
   f7 = Math_fround(f5 + f7);
   f29 = Math_fround(f4 + Math_fround(f73 + Math_fround(f29 * Math_fround(HEAPF32[i16 >> 2]))));
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i26, i43, i37, i17);
   f73 = Math_fround(HEAPF32[i26 >> 2]);
   f4 = Math_fround(HEAPF32[i18 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f29 - Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i25 >> 2] = Math_fround(f6 - f73);
   HEAPF32[i20 >> 2] = f4;
   HEAPF32[i21 >> 2] = f5;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   i37 = HEAP32[i44 >> 2] | 0;
   HEAPF32[i60 + (i37 << 4) >> 2] = f6;
   HEAPF32[i60 + (i37 << 4) + 4 >> 2] = f7;
   HEAPF32[i60 + (i37 << 4) + 8 >> 2] = f29;
   HEAPF32[i60 + (i37 << 4) + 12 >> 2] = Math_fround(0.0);
   i36 = i61 + (i37 << 4) | 0;
   HEAP32[i36 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
   HEAP32[i44 >> 2] = i37 + 1;
   i37 = i62 + (i37 << 4) | 0;
   HEAP32[i37 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
   HEAP32[i37 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
   i23 = i23 + 1 | 0;
  } while (i23 >>> 0 < (HEAPU8[i57 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i24, i62, i60, i61, i68, i70, i25, i44);
  HEAP32[i63 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i63 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i63 >> 2]);
  f6 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i63 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i51 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i50 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i28 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  if (f4 > f39) {
   i37 = i63;
   i55 = 7;
  } else i2 = HEAP32[i44 >> 2] | 0;
 }
 do if ((i55 | 0) == 7) {
  i35 = i63 + 4 | 0;
  i36 = i63 + 8 | 0;
  i10 = i42 + 4 | 0;
  i11 = i42 + 8 | 0;
  i12 = i42 + 16 | 0;
  i13 = i42 + 20 | 0;
  i14 = i42 + 24 | 0;
  i15 = i42 + 32 | 0;
  i16 = i42 + 36 | 0;
  i17 = i42 + 40 | 0;
  i18 = i38 + 96 | 0;
  i19 = i38 + 100 | 0;
  i20 = i38 + 104 | 0;
  i21 = i38 + 112 | 0;
  i22 = i38 + 116 | 0;
  i23 = i38 + 120 | 0;
  i24 = i42 + 48 | 0;
  i25 = i42 + 52 | 0;
  i26 = i42 + 56 | 0;
  i27 = i46 + 4 | 0;
  i31 = i46 + 8 | 0;
  i32 = i45 + 4 | 0;
  i33 = i45 + 8 | 0;
  i34 = i45 + 12 | 0;
  i8 = i38 + 48 | 0;
  i9 = i43 + 48 | 0;
  while (1) {
   HEAP32[i50 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i28 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i28 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i28 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f79 = Math_fround(-f5);
   f83 = Math_fround(-f6);
   f84 = Math_fround(-f7);
   i3 = HEAP32[i44 >> 2] | 0;
   f81 = Math_fround(HEAPF32[i42 >> 2]);
   f86 = Math_fround(f81 * f79);
   f78 = Math_fround(HEAPF32[i10 >> 2]);
   f86 = Math_fround(f86 + Math_fround(f78 * f83));
   f76 = Math_fround(HEAPF32[i11 >> 2]);
   f86 = Math_fround(f86 + Math_fround(f76 * f84));
   f80 = Math_fround(HEAPF32[i12 >> 2]);
   f85 = Math_fround(f80 * f79);
   f77 = Math_fround(HEAPF32[i13 >> 2]);
   f85 = Math_fround(f85 + Math_fround(f77 * f83));
   f29 = Math_fround(HEAPF32[i14 >> 2]);
   f85 = Math_fround(f85 + Math_fround(f29 * f84));
   f74 = Math_fround(HEAPF32[i15 >> 2]);
   f7 = Math_fround(f74 * f79);
   f6 = Math_fround(HEAPF32[i16 >> 2]);
   f83 = Math_fround(f7 + Math_fround(f6 * f83));
   f7 = Math_fround(HEAPF32[i17 >> 2]);
   f84 = Math_fround(f83 + Math_fround(f7 * f84));
   f83 = Math_fround(HEAPF32[i18 >> 2]);
   f79 = Math_fround(HEAPF32[i19 >> 2]);
   f82 = Math_fround(HEAPF32[i20 >> 2]);
   f87 = Math_fround(Math_fround(Math_fround(f86 * f83) + Math_fround(f85 * f79)) + Math_fround(f84 * f82));
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   f73 = Math_fround(HEAPF32[i22 >> 2]);
   f75 = Math_fround(HEAPF32[i23 >> 2]);
   i2 = f87 > Math_fround(Math_fround(Math_fround(f86 * f5) + Math_fround(f85 * f73)) + Math_fround(f84 * f75));
   HEAP32[i68 + (i3 << 2) >> 2] = i2 & 1;
   f5 = i2 ? f83 : f5;
   f73 = i2 ? f79 : f73;
   f75 = i2 ? f82 : f75;
   f82 = Math_fround(HEAPF32[i24 >> 2]);
   f79 = Math_fround(HEAPF32[i25 >> 2]);
   f74 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f81 * f5) + Math_fround(f80 * f73)) + Math_fround(f74 * f75)));
   f6 = Math_fround(f79 + Math_fround(Math_fround(Math_fround(f78 * f5) + Math_fround(f77 * f73)) + Math_fround(f6 * f75)));
   f75 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + Math_fround(Math_fround(Math_fround(f76 * f5) + Math_fround(f29 * f73)) + Math_fround(f7 * f75)));
   HEAPF32[i60 + (i3 << 4) >> 2] = f74;
   HEAPF32[i60 + (i3 << 4) + 4 >> 2] = f6;
   HEAPF32[i60 + (i3 << 4) + 8 >> 2] = f75;
   HEAPF32[i60 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i46, i43, i63, i61 + (i3 << 4) | 0, i70 + (i3 << 2) | 0);
   f7 = Math_fround(HEAPF32[i46 >> 2]);
   f73 = Math_fround(HEAPF32[i27 >> 2]);
   f7 = Math_fround(f74 - f7);
   f73 = Math_fround(f6 - f73);
   f75 = Math_fround(f75 - Math_fround(HEAPF32[i31 >> 2]));
   HEAPF32[i45 >> 2] = f7;
   HEAPF32[i32 >> 2] = f73;
   HEAPF32[i33 >> 2] = f75;
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i44 >> 2] | 0;
   i2 = i62 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i8 >> 2]);
   f74 = Math_fround(HEAPF32[i9 >> 2]);
   f74 = f6 > f74 ? f6 : f74;
   f30 = f30 > f74 ? f30 : f74;
   f74 = Math_fround(f56 + f30);
   f74 = Math_fround(f4 * Math_fround(f74 * f74));
   f6 = Math_fround(HEAPF32[i63 >> 2]);
   f29 = Math_fround(HEAPF32[i35 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f29 * f73)) + Math_fround(Math_fround(HEAPF32[i36 >> 2]) * f75));
   i2 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f74;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f75) | i2) {
    i55 = 9;
    break;
   }
   HEAP32[i44 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i41, i62, i60, i61, i68, i70, i45, i44);
   HEAP32[i37 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i37 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i63 >> 2]);
   f6 = Math_fround(HEAPF32[i35 >> 2]);
   f7 = Math_fround(HEAPF32[i36 >> 2]);
   f29 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i51 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i51 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i51 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   i1 = f4 > f29;
   if (!(f29 > f39 & i1)) break; else f4 = f29;
  }
  if ((i55 | 0) == 9) {
   if (i69 | 0) {
    HEAP8[i57 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
      HEAP8[i71 + i1 >> 0] = HEAP32[i70 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i71 = 0;
    STACKTOP = i72;
    return i71 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i62, i60, i61, i63, i53, i54, i3);
   f84 = Math_fround(Math_sqrt(Math_fround(f4)));
   f85 = Math_fround(HEAPF32[i63 >> 2]);
   f86 = Math_fround(HEAPF32[i35 >> 2]);
   f87 = Math_fround(Math_fround(1.0) / f84);
   f85 = Math_fround(f85 * f87);
   f86 = Math_fround(f86 * f87);
   f87 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * f87);
   f83 = Math_fround(HEAPF32[i53 >> 2]);
   f82 = Math_fround(HEAPF32[i53 + 4 >> 2]);
   f82 = Math_fround(f82 - Math_fround(f58 * f86));
   f81 = Math_fround(Math_fround(HEAPF32[i53 + 8 >> 2]) - Math_fround(f58 * f87));
   HEAPF32[i64 >> 2] = Math_fround(f83 - Math_fround(f58 * f85));
   HEAPF32[i64 + 4 >> 2] = f82;
   HEAPF32[i64 + 8 >> 2] = f81;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   f81 = Math_fround(HEAPF32[i54 >> 2]);
   f82 = Math_fround(HEAPF32[i54 + 4 >> 2]);
   f82 = Math_fround(Math_fround(f59 * f86) + f82);
   f83 = Math_fround(Math_fround(f59 * f87) + Math_fround(HEAPF32[i54 + 8 >> 2]));
   HEAPF32[i65 >> 2] = Math_fround(Math_fround(f59 * f85) + f81);
   HEAPF32[i65 + 4 >> 2] = f82;
   HEAPF32[i65 + 8 >> 2] = f83;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i67 >> 2] = Math_fround(f84 - f56);
   i71 = i67 + 4 | 0;
   HEAP32[i71 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i71 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i71 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAPF32[i66 >> 2] = f85;
   HEAPF32[i66 + 4 >> 2] = f86;
   HEAPF32[i66 + 8 >> 2] = f87;
   HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
   i71 = 1;
   STACKTOP = i72;
   return i71 | 0;
  }
  i2 = HEAP32[i44 >> 2] | 0;
  if (i1) {
   if (!i69) i1 = 6; else break;
   STACKTOP = i72;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i69 | 0) {
   HEAP8[i57 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
     HEAP8[i71 + i1 >> 0] = HEAP32[i70 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i37 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i37 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i62, i60, i61, i63, i48, i49, i2);
  HEAP32[i51 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  f84 = Math_fround(Math_sqrt(Math_fround(f4)));
  f85 = Math_fround(HEAPF32[i63 >> 2]);
  f86 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f87 = Math_fround(Math_fround(1.0) / f84);
  f85 = Math_fround(f85 * f87);
  f86 = Math_fround(f86 * f87);
  f87 = Math_fround(Math_fround(HEAPF32[i63 + 8 >> 2]) * f87);
  f83 = Math_fround(HEAPF32[i48 >> 2]);
  f82 = Math_fround(HEAPF32[i48 + 4 >> 2]);
  f82 = Math_fround(f82 - Math_fround(f58 * f86));
  f81 = Math_fround(Math_fround(HEAPF32[i48 + 8 >> 2]) - Math_fround(f58 * f87));
  HEAPF32[i64 >> 2] = Math_fround(f83 - Math_fround(f58 * f85));
  HEAPF32[i64 + 4 >> 2] = f82;
  HEAPF32[i64 + 8 >> 2] = f81;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  f81 = Math_fround(HEAPF32[i49 >> 2]);
  f82 = Math_fround(HEAPF32[i49 + 4 >> 2]);
  f82 = Math_fround(Math_fround(f59 * f86) + f82);
  f83 = Math_fround(Math_fround(f59 * f87) + Math_fround(HEAPF32[i49 + 8 >> 2]));
  HEAPF32[i65 >> 2] = Math_fround(Math_fround(f59 * f85) + f81);
  HEAPF32[i65 + 4 >> 2] = f82;
  HEAPF32[i65 + 8 >> 2] = f83;
  HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i67 >> 2] = Math_fround(f84 - f56);
  i71 = i67 + 4 | 0;
  HEAP32[i71 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i71 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i71 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAPF32[i66 >> 2] = f85;
  HEAPF32[i66 + 4 >> 2] = f86;
  HEAPF32[i66 + 8 >> 2] = f87;
  HEAPF32[i66 + 12 >> 2] = Math_fround(0.0);
  i71 = 3;
  STACKTOP = i72;
  return i71 | 0;
 } while (0);
 HEAP8[i57 >> 0] = i2;
 if (!i2) {
  i71 = 6;
  STACKTOP = i72;
  return i71 | 0;
 } else i1 = 0;
 do {
  HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
  HEAP8[i71 + i1 >> 0] = HEAP32[i70 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i72;
 return i1 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i62, i63, i1, i64, i65, i59, i67, i48, i50, i42, i66) {
 i62 = i62 | 0;
 i63 = i63 | 0;
 i1 = i1 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i59 = i59 | 0;
 i67 = i67 | 0;
 i48 = i48 | 0;
 i50 = i50 | 0;
 i42 = i42 | 0;
 i66 = i66 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f60 = f0, f61 = f0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i68 + 492 | 0;
 i39 = i68 + 480 | 0;
 i58 = i68 + 160 | 0;
 i57 = i68 + 304 | 0;
 i55 = i68 + 240 | 0;
 i56 = i68 + 176 | 0;
 i47 = i68 + 464 | 0;
 i49 = i68 + 448 | 0;
 i38 = i68 + 144 | 0;
 i37 = i68 + 440 | 0;
 i15 = i68 + 128 | 0;
 i16 = i68 + 112 | 0;
 i17 = i68 + 428 | 0;
 i18 = i68 + 96 | 0;
 i35 = i68 + 80 | 0;
 i51 = i68 + 64 | 0;
 i54 = i68 + 48 | 0;
 i52 = i68 + 416 | 0;
 i53 = i68 + 404 | 0;
 i36 = i68 + 32 | 0;
 i34 = i68 + 392 | 0;
 i43 = i68 + 16 | 0;
 i46 = i68;
 i45 = i68 + 380 | 0;
 i44 = i68 + 368 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f60 = Math_fround(HEAPF32[i62 + 16 >> 2]);
 f61 = Math_fround(HEAPF32[i63 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i62 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i63 + 32 >> 2]);
 f9 = Math_fround((f9 > f3 ? f3 : f9) * Math_fround(.100000001));
 f9 = Math_fround(f9 * f9);
 f3 = Math_fround(f60 + f61);
 i31 = i38 + 4 | 0;
 i32 = i38 + 8 | 0;
 i33 = i38 + 12 | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 HEAP32[i37 >> 2] = 0;
 if (!(HEAP8[i42 >> 0] | 0)) {
  f29 = Math_fround(HEAPF32[i62 >> 2]);
  f4 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i62 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i63 >> 2]);
  f6 = Math_fround(HEAPF32[i63 + 4 >> 2]);
  f5 = Math_fround(f29 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i63 + 8 >> 2]));
  i30 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i30 ? f5 : Math_fround(1.0);
  f6 = i30 ? f6 : Math_fround(0.0);
  f7 = i30 ? f7 : Math_fround(0.0);
  HEAPF32[i58 >> 2] = f5;
  HEAPF32[i58 + 4 >> 2] = f6;
  HEAPF32[i58 + 8 >> 2] = f7;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i18 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  i30 = i58;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i41 = 6;
 } else {
  i1 = i63 + 16 | 0;
  i2 = i15 + 4 | 0;
  i11 = i15 + 8 | 0;
  i13 = i15 + 12 | 0;
  i14 = 0;
  do {
   i27 = HEAPU8[i48 + i14 >> 0] | 0;
   HEAP32[i47 + (i14 << 2) >> 2] = i27;
   i28 = HEAPU8[i50 + i14 >> 0] | 0;
   HEAP32[i49 + (i14 << 2) >> 2] = i28;
   f5 = Math_fround(HEAPF32[i62 + 96 + (i27 << 4) >> 2]);
   f6 = Math_fround(HEAPF32[i62 + 96 + (i27 << 4) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i62 + 96 + (i27 << 4) + 8 >> 2]);
   i27 = HEAP32[i62 + 96 + (i27 << 4) + 12 >> 2] | 0;
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i15, i63, i28, i1);
   f10 = Math_fround(HEAPF32[i15 >> 2]);
   f12 = Math_fround(HEAPF32[i2 >> 2]);
   f29 = Math_fround(HEAPF32[i11 >> 2]);
   i28 = HEAP32[i13 >> 2] | 0;
   f69 = Math_fround(f6 - f12);
   f4 = Math_fround(f7 - f29);
   HEAPF32[i38 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i31 >> 2] = f69;
   HEAPF32[i32 >> 2] = f4;
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   i30 = HEAP32[i37 >> 2] | 0;
   HEAPF32[i55 + (i30 << 4) >> 2] = f5;
   HEAPF32[i55 + (i30 << 4) + 4 >> 2] = f6;
   HEAPF32[i55 + (i30 << 4) + 8 >> 2] = f7;
   HEAP32[i55 + (i30 << 4) + 12 >> 2] = i27;
   HEAPF32[i56 + (i30 << 4) >> 2] = f10;
   HEAPF32[i56 + (i30 << 4) + 4 >> 2] = f12;
   HEAPF32[i56 + (i30 << 4) + 8 >> 2] = f29;
   HEAP32[i56 + (i30 << 4) + 12 >> 2] = i28;
   HEAP32[i37 >> 2] = i30 + 1;
   i30 = i57 + (i30 << 4) | 0;
   HEAP32[i30 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < (HEAPU8[i42 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i16, i57, i55, i56, i47, i49, i38, i37);
  HEAP32[i58 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i58 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i58 >> 2]);
  f6 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i40 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i39 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  if (f4 > f9) {
   i30 = i58;
   i41 = 6;
  }
 }
 do if ((i41 | 0) == 6) {
  i2 = i58 + 4 | 0;
  i14 = i58 + 8 | 0;
  i15 = i62 + 96 | 0;
  i16 = i62 + 100 | 0;
  i17 = i62 + 104 | 0;
  i19 = i62 + 112 | 0;
  i20 = i62 + 116 | 0;
  i21 = i62 + 120 | 0;
  i22 = i62 + 128 | 0;
  i23 = i62 + 132 | 0;
  i24 = i62 + 136 | 0;
  i25 = i35 + 4 | 0;
  i26 = i35 + 8 | 0;
  i27 = i62 + 48 | 0;
  i28 = i63 + 48 | 0;
  f29 = f4;
  while (1) {
   HEAP32[i39 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   f76 = Math_fround(-f5);
   f75 = Math_fround(-f6);
   f72 = Math_fround(-f7);
   i13 = HEAP32[i37 >> 2] | 0;
   f71 = Math_fround(HEAPF32[i15 >> 2]);
   f6 = Math_fround(HEAPF32[i16 >> 2]);
   f10 = Math_fround(HEAPF32[i17 >> 2]);
   f70 = Math_fround(HEAPF32[i19 >> 2]);
   f5 = Math_fround(HEAPF32[i20 >> 2]);
   f7 = Math_fround(HEAPF32[i21 >> 2]);
   f12 = Math_fround(HEAPF32[i22 >> 2]);
   f4 = Math_fround(HEAPF32[i23 >> 2]);
   f69 = Math_fround(HEAPF32[i24 >> 2]);
   f74 = Math_fround(Math_fround(Math_fround(f71 * f76) + Math_fround(f6 * f75)) + Math_fround(f10 * f72));
   f73 = Math_fround(Math_fround(Math_fround(f70 * f76) + Math_fround(f5 * f75)) + Math_fround(f7 * f72));
   f72 = Math_fround(Math_fround(Math_fround(f12 * f76) + Math_fround(f4 * f75)) + Math_fround(f69 * f72));
   i1 = f74 > f73 & f74 > f72;
   i11 = f73 > f72;
   HEAP32[i47 + (i13 << 2) >> 2] = i1 ? 0 : i11 ? 1 : 2;
   f12 = i1 ? f71 : i11 ? f70 : f12;
   f4 = i1 ? f6 : i11 ? f5 : f4;
   f69 = i1 ? f10 : i11 ? f7 : f69;
   HEAPF32[i55 + (i13 << 4) >> 2] = f12;
   HEAPF32[i55 + (i13 << 4) + 4 >> 2] = f4;
   HEAPF32[i55 + (i13 << 4) + 8 >> 2] = f69;
   HEAPF32[i55 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i35, i63, i58, i56 + (i13 << 4) | 0, i49 + (i13 << 2) | 0);
   f7 = Math_fround(HEAPF32[i35 >> 2]);
   f10 = Math_fround(HEAPF32[i25 >> 2]);
   f7 = Math_fround(f12 - f7);
   f10 = Math_fround(f4 - f10);
   f69 = Math_fround(f69 - Math_fround(HEAPF32[i26 >> 2]));
   HEAPF32[i38 >> 2] = f7;
   HEAPF32[i31 >> 2] = f10;
   HEAPF32[i32 >> 2] = f69;
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i37 >> 2] | 0;
   i11 = i57 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i27 >> 2]);
   f12 = Math_fround(HEAPF32[i28 >> 2]);
   f12 = f4 > f12 ? f4 : f12;
   f8 = f8 > f12 ? f8 : f12;
   f12 = Math_fround(f3 + f8);
   f12 = Math_fround(f29 * Math_fround(f12 * f12));
   f4 = Math_fround(HEAPF32[i58 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f69 = Math_fround(Math_fround(Math_fround(f4 * f7) + Math_fround(f5 * f10)) + Math_fround(f6 * f69));
   i11 = f69 > Math_fround(0.0) & Math_fround(f69 * f69) > f12;
   if (Math_fround(f29 * Math_fround(.00039999999)) >= Math_fround(f29 - f69) | i11) {
    f7 = f29;
    i41 = 8;
    break;
   }
   HEAP32[i37 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i36, i57, i55, i56, i47, i49, i38, i37);
   HEAP32[i30 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i58 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i40 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   i1 = f29 > f4;
   if (!(f4 > f9 & i1)) break; else f29 = f4;
  }
  if ((i41 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i48 | 0) {
    HEAP8[i42 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
      HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i67 = 0;
    STACKTOP = i68;
    return i67 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i59 >> 2] = f9;
   HEAPF32[i59 + 4 >> 2] = f8;
   HEAPF32[i59 + 8 >> 2] = f7;
   HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i57, i55, i56, i58, i51, i54, i13);
   f5 = Math_fround(HEAPF32[i51 >> 2]);
   f6 = Math_fround(HEAPF32[i51 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i51 + 8 >> 2]);
   if (i66) {
    f75 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
    f72 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
    f76 = Math_fround(f75 + f72);
    f74 = Math_fround(f6 - Math_fround(f8 * f75));
    f73 = Math_fround(f4 - Math_fround(f7 * f75));
    HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f9 * f75));
    HEAPF32[i64 + 4 >> 2] = f74;
    HEAPF32[i64 + 8 >> 2] = f73;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    f73 = Math_fround(HEAPF32[i54 >> 2]);
    f74 = Math_fround(HEAPF32[i54 + 4 >> 2]);
    f74 = Math_fround(Math_fround(f8 * f72) + f74);
    f75 = Math_fround(Math_fround(f7 * f72) + Math_fround(HEAPF32[i54 + 8 >> 2]));
    HEAPF32[i65 >> 2] = Math_fround(Math_fround(f9 * f72) + f73);
    HEAPF32[i65 + 4 >> 2] = f74;
    HEAPF32[i65 + 8 >> 2] = f75;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i67 >> 2] = Math_fround(f10 - f76);
    i67 = i67 + 4 | 0;
    HEAP32[i67 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i67 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i67 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    i67 = 1;
    STACKTOP = i68;
    return i67 | 0;
   } else {
    f75 = Math_fround(f6 - Math_fround(f60 * f8));
    f74 = Math_fround(f4 - Math_fround(f60 * f7));
    HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f60 * f9));
    HEAPF32[i64 + 4 >> 2] = f75;
    HEAPF32[i64 + 8 >> 2] = f74;
    HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
    f74 = Math_fround(HEAPF32[i54 >> 2]);
    f75 = Math_fround(HEAPF32[i54 + 4 >> 2]);
    f75 = Math_fround(Math_fround(f61 * f8) + f75);
    f76 = Math_fround(Math_fround(f61 * f7) + Math_fround(HEAPF32[i54 + 8 >> 2]));
    HEAPF32[i65 >> 2] = Math_fround(Math_fround(f61 * f9) + f74);
    HEAPF32[i65 + 4 >> 2] = f75;
    HEAPF32[i65 + 8 >> 2] = f76;
    HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i67 >> 2] = Math_fround(f10 - f3);
    i67 = i67 + 4 | 0;
    HEAP32[i67 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i67 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
    HEAP32[i67 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
    i67 = 1;
    STACKTOP = i68;
    return i67 | 0;
   }
  }
  if (i1) {
   if (!i48) i1 = 6; else break;
   STACKTOP = i68;
   return i1 | 0;
  };
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  i11 = HEAP32[i37 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i48 | 0) {
   HEAP8[i42 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
     HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i30 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i57, i55, i56, i58, i43, i46, i11);
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f29)));
  f9 = Math_fround(HEAPF32[i58 >> 2]);
  f10 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i58 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i43 >> 2]);
  f6 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  if (i66) {
   f76 = HEAP32[i62 + 64 >> 2] | 0 ? Math_fround(0.0) : f60;
   f73 = HEAP32[i63 + 64 >> 2] | 0 ? Math_fround(0.0) : f61;
   f3 = Math_fround(f76 + f73);
   f75 = Math_fround(f6 - Math_fround(f10 * f76));
   f74 = Math_fround(f4 - Math_fround(f7 * f76));
   HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f9 * f76));
   HEAPF32[i64 + 4 >> 2] = f75;
   HEAPF32[i64 + 8 >> 2] = f74;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   f74 = Math_fround(HEAPF32[i46 >> 2]);
   f75 = Math_fround(HEAPF32[i46 + 4 >> 2]);
   f75 = Math_fround(Math_fround(f10 * f73) + f75);
   f76 = Math_fround(Math_fround(f7 * f73) + Math_fround(HEAPF32[i46 + 8 >> 2]));
   HEAPF32[i65 >> 2] = Math_fround(Math_fround(f9 * f73) + f74);
   HEAPF32[i65 + 4 >> 2] = f75;
   HEAPF32[i65 + 8 >> 2] = f76;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   i66 = i67 + 4 | 0;
   HEAP32[i66 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  } else {
   f75 = Math_fround(f6 - Math_fround(f60 * f10));
   f74 = Math_fround(f4 - Math_fround(f60 * f7));
   HEAPF32[i64 >> 2] = Math_fround(f5 - Math_fround(f60 * f9));
   HEAPF32[i64 + 4 >> 2] = f75;
   HEAPF32[i64 + 8 >> 2] = f74;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   f74 = Math_fround(HEAPF32[i46 >> 2]);
   f75 = Math_fround(HEAPF32[i46 + 4 >> 2]);
   f75 = Math_fround(Math_fround(f61 * f10) + f75);
   f76 = Math_fround(Math_fround(f61 * f7) + Math_fround(HEAPF32[i46 + 8 >> 2]));
   HEAPF32[i65 >> 2] = Math_fround(Math_fround(f61 * f9) + f74);
   HEAPF32[i65 + 4 >> 2] = f75;
   HEAPF32[i65 + 8 >> 2] = f76;
   HEAPF32[i65 + 12 >> 2] = Math_fround(0.0);
   i66 = i67 + 4 | 0;
   HEAP32[i66 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  }
  HEAPF32[i67 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i59 >> 2] = f9;
  HEAPF32[i59 + 4 >> 2] = f10;
  HEAPF32[i59 + 8 >> 2] = f7;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  i67 = f12 >= f29 ? 1 : 3;
  STACKTOP = i68;
  return i67 | 0;
 } while (0);
 i2 = HEAP32[i37 >> 2] | 0;
 HEAP8[i42 >> 0] = i2;
 if (!i2) {
  i67 = 6;
  STACKTOP = i68;
  return i67 | 0;
 } else i1 = 0;
 do {
  HEAP8[i48 + i1 >> 0] = HEAP32[i47 + (i1 << 2) >> 2];
  HEAP8[i50 + i1 >> 0] = HEAP32[i49 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i68;
 return i1 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim18visualizeParticlesERNS_2Cm12RenderOutputE(i51, i60) {
 i51 = i51 | 0;
 i60 = i60 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, i58 = 0, i59 = 0, i61 = 0, f62 = f0, f63 = f0, i64 = 0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i61 + 352 | 0;
 i36 = i61 + 320 | 0;
 i37 = i61 + 312 | 0;
 i38 = i61 + 280 | 0;
 i39 = i61 + 272 | 0;
 i40 = i61 + 240 | 0;
 i41 = i61 + 232 | 0;
 i42 = i61 + 168 | 0;
 i48 = i61 + 156 | 0;
 i49 = i61 + 144 | 0;
 i50 = i61 + 132 | 0;
 i44 = i61 + 120 | 0;
 i45 = i61 + 108 | 0;
 i46 = i61 + 96 | 0;
 i52 = i61 + 32 | 0;
 i56 = i61;
 f57 = Math_fround(HEAPF32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0) + 64 >> 2]);
 HEAP32[i55 + 16 >> 2] = 0;
 i58 = i55 + 20 | 0;
 HEAP32[i58 >> 2] = 12;
 HEAP32[i55 + 24 >> 2] = 0;
 i59 = i55 + 28 | 0;
 HEAP32[i59 >> 2] = 12;
 HEAP32[i55 + 32 >> 2] = 0;
 HEAP32[i55 + 36 >> 2] = 4;
 HEAP32[i55 + 40 >> 2] = 0;
 HEAP32[i55 + 44 >> 2] = 4;
 i47 = HEAP32[i51 + 56 >> 2] | 0;
 i47 = mftCall_ii(HEAP32[HEAP32[i47 >> 2] >> 2] | 0, i47 | 0) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i47 >> 2] | 0) + 20 >> 2] | 0, i47 | 0, i55 | 0, 0, 0);
 if (!(HEAP32[i55 + 4 >> 2] | 0)) {
  STACKTOP = i61;
  return;
 }
 i2 = i51 + 52 | 0;
 i43 = (__ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(HEAP32[i2 >> 2] | 0) | 0) & 1;
 i47 = ((__ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(HEAP32[i2 >> 2] | 0) | 0) & 2) != 0;
 i43 = i43 << 16 >> 16 == 0;
 L4 : do if (!(i43 | !(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0, 29)) > Math_fround(0.0)))) {
  f33 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv(HEAP32[i2 >> 2] | 0));
  i34 = HEAP32[i55 + 12 >> 2] | 0;
  i35 = i34 + 4 | 0;
  i5 = HEAP32[i35 >> 2] & 2147483647;
  if (i5 | 0) {
   i4 = HEAP32[i34 >> 2] | 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if (i3 | 0) break;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) break L4;
   }
   i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
   i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i2 << 5;
   i3 = i3 + -1 & i3;
   L11 : do if (!i3) do {
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = 0;
     break L11;
    }
    i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   } while ((i3 | 0) == 0); while (0);
   if ((i6 | 0) != -1) {
    i12 = i55 + 16 | 0;
    i13 = i55 + 24 | 0;
    f15 = Math_fround(f33 * Math_fround(.990000009));
    i14 = i36 + 4 | 0;
    i16 = i36 + 8 | 0;
    i17 = i36 + 12 | 0;
    i18 = i36 + 16 | 0;
    i19 = i36 + 20 | 0;
    i20 = i36 + 24 | 0;
    i21 = i37 + 4 | 0;
    i22 = i38 + 4 | 0;
    i23 = i38 + 8 | 0;
    i24 = i38 + 12 | 0;
    i25 = i38 + 16 | 0;
    i26 = i38 + 20 | 0;
    i27 = i38 + 24 | 0;
    i28 = i39 + 4 | 0;
    i29 = i40 + 4 | 0;
    i30 = i40 + 8 | 0;
    i31 = i40 + 12 | 0;
    i32 = i40 + 16 | 0;
    i9 = i40 + 20 | 0;
    i10 = i40 + 24 | 0;
    i11 = i41 + 4 | 0;
    i4 = i6;
    do {
     i8 = i2 << 5;
     L19 : do if (i47) while (1) {
      i5 = HEAP32[i12 >> 2] | 0;
      i6 = Math_imul(HEAP32[i58 >> 2] | 0, i4) | 0;
      i7 = i5 + i6 | 0;
      i64 = HEAP32[i13 >> 2] | 0;
      i4 = Math_imul(HEAP32[i59 >> 2] | 0, i4) | 0;
      f62 = Math_fround(HEAPF32[i64 + i4 >> 2]);
      f62 = Math_fround(f62 * f62);
      f63 = Math_fround(HEAPF32[i64 + (i4 + 4) >> 2]);
      f63 = Math_fround(f62 + Math_fround(f63 * f63));
      f62 = Math_fround(HEAPF32[i64 + (i4 + 8) >> 2]);
      if (!(Math_fround(f57 * Math_fround(Math_sqrt(Math_fround(f63 + Math_fround(f62 * f62))))) >= f15)) __ZN5physx2Cm12RenderOutputlsEj(i60, -16711936) | 0; else __ZN5physx2Cm12RenderOutputlsEj(i60, -65536) | 0;
      HEAP32[i36 >> 2] = 0;
      HEAP32[i14 >> 2] = 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i17 >> 2] = 1065353216;
      HEAP32[i18 >> 2] = HEAP32[i7 >> 2];
      i4 = i5 + (i6 + 4) | 0;
      HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
      i64 = i5 + (i6 + 8) | 0;
      HEAP32[i20 >> 2] = HEAP32[i64 >> 2];
      i6 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i36) | 0;
      HEAP32[i37 >> 2] = 12;
      HEAPF32[i21 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i37) | 0;
      HEAP32[i38 >> 2] = 0;
      HEAP32[i22 >> 2] = 1060439283;
      HEAP32[i23 >> 2] = 0;
      HEAP32[i24 >> 2] = 1060439283;
      HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i26 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i27 >> 2] = HEAP32[i64 >> 2];
      i6 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i38) | 0;
      HEAP32[i39 >> 2] = 12;
      HEAPF32[i28 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i39) | 0;
      HEAP32[i40 >> 2] = 1056964608;
      HEAP32[i29 >> 2] = 1056964608;
      HEAP32[i30 >> 2] = 1056964608;
      HEAP32[i31 >> 2] = 1056964608;
      HEAP32[i32 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i64 >> 2];
      i64 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i40) | 0;
      HEAP32[i41 >> 2] = 12;
      HEAPF32[i11 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i64, i41) | 0;
      if (!i3) break L4;
      i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i8;
      i3 = i3 + -1 & i3;
      if (!i3) break L19;
      if ((i4 | 0) == -1) break L4;
     } else while (1) {
      i5 = HEAP32[i12 >> 2] | 0;
      i64 = Math_imul(HEAP32[i58 >> 2] | 0, i4) | 0;
      i6 = i5 + i64 | 0;
      __ZN5physx2Cm12RenderOutputlsEj(i60, -16711936) | 0;
      HEAP32[i36 >> 2] = 0;
      HEAP32[i14 >> 2] = 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i17 >> 2] = 1065353216;
      HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
      i7 = i5 + (i64 + 4) | 0;
      HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
      i64 = i5 + (i64 + 8) | 0;
      HEAP32[i20 >> 2] = HEAP32[i64 >> 2];
      i5 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i36) | 0;
      HEAP32[i37 >> 2] = 12;
      HEAPF32[i21 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i5, i37) | 0;
      HEAP32[i38 >> 2] = 0;
      HEAP32[i22 >> 2] = 1060439283;
      HEAP32[i23 >> 2] = 0;
      HEAP32[i24 >> 2] = 1060439283;
      HEAP32[i25 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i26 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i27 >> 2] = HEAP32[i64 >> 2];
      i5 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i38) | 0;
      HEAP32[i39 >> 2] = 12;
      HEAPF32[i28 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i5, i39) | 0;
      HEAP32[i40 >> 2] = 1056964608;
      HEAP32[i29 >> 2] = 1056964608;
      HEAP32[i30 >> 2] = 1056964608;
      HEAP32[i31 >> 2] = 1056964608;
      HEAP32[i32 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i64 >> 2];
      i64 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i60, i40) | 0;
      HEAP32[i41 >> 2] = 12;
      HEAPF32[i11 >> 2] = f33;
      __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i64, i41) | 0;
      if (!i3) break L4;
      i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i8;
      i3 = i3 + -1 & i3;
      if (!i3) break L19;
      if ((i4 | 0) == -1) break L4;
     } while (0);
     i5 = HEAP32[i35 >> 2] & 2147483647;
     do {
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i5 >>> 0) {
       i3 = 0;
       break;
      }
      i3 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     } while ((i3 | 0) == 0);
    } while ((i4 | 0) != -1);
   }
  }
 } while (0);
 L38 : do if (!(i43 | !(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0, 23)) > Math_fround(0.0)))) {
  f15 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0, 23));
  f15 = Math_fround(Math_fround(f15 * Math_fround(HEAPF32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0) + 1408 >> 2])) * Math_fround(.5));
  i21 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(i60, -16776961) | 0, 1) | 0;
  HEAPF32[i42 >> 2] = Math_fround(1.0);
  i22 = i42 + 4 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAPF32[i42 + 20 >> 2] = Math_fround(1.0);
  i22 = i42 + 24 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAPF32[i42 + 40 >> 2] = Math_fround(1.0);
  i22 = i42 + 44 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAPF32[i42 + 60 >> 2] = Math_fround(1.0);
  __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i21, i42) | 0;
  i21 = HEAP32[i55 + 12 >> 2] | 0;
  i22 = i21 + 4 | 0;
  i5 = HEAP32[i22 >> 2] & 2147483647;
  if (i5 | 0) {
   i4 = HEAP32[i21 >> 2] | 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if (i3 | 0) break;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) break L38;
   }
   i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
   i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i2 << 5;
   i3 = i3 + -1 & i3;
   L45 : do if (!i3) do {
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = 0;
     break L45;
    }
    i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   } while ((i3 | 0) == 0); while (0);
   if ((i6 | 0) != -1) {
    i7 = i55 + 16 | 0;
    i8 = i48 + 4 | 0;
    i9 = i48 + 8 | 0;
    i10 = i49 + 4 | 0;
    i11 = i49 + 8 | 0;
    i12 = i50 + 4 | 0;
    i13 = i50 + 8 | 0;
    i14 = i44 + 4 | 0;
    i16 = i44 + 8 | 0;
    i17 = i45 + 4 | 0;
    i18 = i45 + 8 | 0;
    i19 = i46 + 4 | 0;
    i20 = i46 + 8 | 0;
    i4 = i6;
    do {
     i5 = i2 << 5;
     while (1) {
      i64 = HEAP32[i7 >> 2] | 0;
      i42 = Math_imul(HEAP32[i58 >> 2] | 0, i4) | 0;
      i40 = i64 + i42 | 0;
      f33 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + Math_fround(0.0));
      i41 = i64 + (i42 + 4) | 0;
      f62 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + Math_fround(0.0));
      i42 = i64 + (i42 + 8) | 0;
      f63 = Math_fround(f15 + Math_fround(HEAPF32[i42 >> 2]));
      HEAPF32[i48 >> 2] = f33;
      HEAPF32[i8 >> 2] = f62;
      HEAPF32[i9 >> 2] = f63;
      i64 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i60, i48) | 0;
      i39 = HEAP32[i41 >> 2] | 0;
      f63 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) - f15);
      HEAP32[i49 >> 2] = HEAP32[i40 >> 2];
      HEAP32[i10 >> 2] = i39;
      HEAPF32[i11 >> 2] = f63;
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i64, i49) | 0;
      f63 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + Math_fround(0.0));
      f62 = Math_fround(f15 + Math_fround(HEAPF32[i41 >> 2]));
      f33 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + Math_fround(0.0));
      HEAPF32[i50 >> 2] = f63;
      HEAPF32[i12 >> 2] = f62;
      HEAPF32[i13 >> 2] = f33;
      i64 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i60, i50) | 0;
      f33 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) - f15);
      i39 = HEAP32[i42 >> 2] | 0;
      HEAP32[i44 >> 2] = HEAP32[i40 >> 2];
      HEAPF32[i14 >> 2] = f33;
      HEAP32[i16 >> 2] = i39;
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i64, i44) | 0;
      f33 = Math_fround(f15 + Math_fround(HEAPF32[i40 >> 2]));
      f62 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + Math_fround(0.0));
      f63 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) + Math_fround(0.0));
      HEAPF32[i45 >> 2] = f33;
      HEAPF32[i17 >> 2] = f62;
      HEAPF32[i18 >> 2] = f63;
      i64 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i60, i45) | 0;
      f63 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f15);
      i41 = HEAP32[i41 >> 2] | 0;
      i42 = HEAP32[i42 >> 2] | 0;
      HEAPF32[i46 >> 2] = f63;
      HEAP32[i19 >> 2] = i41;
      HEAP32[i20 >> 2] = i42;
      __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i64, i46) | 0;
      if (!i3) break L38;
      i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i5;
      i3 = i3 + -1 & i3;
      if (!i3) break;
      if ((i4 | 0) == -1) break L38;
     }
     i5 = HEAP32[i22 >> 2] & 2147483647;
     do {
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i5 >>> 0) {
       i3 = 0;
       break;
      }
      i3 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     } while ((i3 | 0) == 0);
    } while ((i4 | 0) != -1);
   }
  }
 } while (0);
 if (i43 | !(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0, 24)) > Math_fround(0.0)) | i47 ^ 1) {
  STACKTOP = i61;
  return;
 }
 f15 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0, 24));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i51) | 0) + 1408 >> 2]));
 i13 = __ZN5physx2Cm12RenderOutputlsEj(i60, -65536) | 0;
 HEAPF32[i52 >> 2] = Math_fround(1.0);
 i14 = i52 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAPF32[i52 + 20 >> 2] = Math_fround(1.0);
 i14 = i52 + 24 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAPF32[i52 + 40 >> 2] = Math_fround(1.0);
 i14 = i52 + 44 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAPF32[i52 + 60 >> 2] = Math_fround(1.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i13, i52) | 0;
 i13 = HEAP32[i55 + 12 >> 2] | 0;
 i14 = i13 + 4 | 0;
 i5 = HEAP32[i14 >> 2] & 2147483647;
 if (!i5) {
  STACKTOP = i61;
  return;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  if (i3 | 0) {
   i1 = i2;
   i54 = i3;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i5 >>> 0) {
   i53 = 62;
   break;
  }
 }
 if ((i53 | 0) == 62) {
  STACKTOP = i61;
  return;
 }
 i3 = (Math_imul(i54 & 0 - i54, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
 i2 = i54 + -1 & i54;
 L75 : do if (!i2) do {
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i2 = 0;
   break L75;
  }
  i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
 } while ((i2 | 0) == 0); while (0);
 if ((i3 | 0) == -1) {
  STACKTOP = i61;
  return;
 }
 i12 = i55 + 16 | 0;
 i5 = i55 + 24 | 0;
 i6 = i56 + 4 | 0;
 i7 = i56 + 8 | 0;
 i8 = i56 + 12 | 0;
 i9 = i56 + 16 | 0;
 i10 = i56 + 20 | 0;
 i11 = i56 + 24 | 0;
 L83 : while (1) {
  i4 = i1 << 5;
  while (1) {
   i53 = HEAP32[i12 >> 2] | 0;
   i64 = Math_imul(HEAP32[i58 >> 2] | 0, i3) | 0;
   i54 = i53 + i64 | 0;
   i52 = HEAP32[i5 >> 2] | 0;
   i55 = Math_imul(HEAP32[i59 >> 2] | 0, i3) | 0;
   f33 = Math_fround(f57 * Math_fround(HEAPF32[i52 + i55 >> 2]));
   f62 = Math_fround(f57 * Math_fround(HEAPF32[i52 + (i55 + 4) >> 2]));
   f63 = Math_fround(f57 * Math_fround(HEAPF32[i52 + (i55 + 8) >> 2]));
   HEAP32[i56 >> 2] = HEAP32[i54 >> 2];
   i55 = i53 + (i64 + 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i55 >> 2];
   i64 = i53 + (i64 + 8) | 0;
   HEAP32[i7 >> 2] = HEAP32[i64 >> 2];
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i54 >> 2]));
   f62 = Math_fround(f62 + Math_fround(HEAPF32[i55 >> 2]));
   f63 = Math_fround(f63 + Math_fround(HEAPF32[i64 >> 2]));
   HEAPF32[i8 >> 2] = f33;
   HEAPF32[i9 >> 2] = f62;
   HEAPF32[i10 >> 2] = f63;
   HEAPF32[i11 >> 2] = f15;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i60, i56) | 0;
   if (!i2) {
    i53 = 62;
    break L83;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
   i2 = i2 + -1 & i2;
   if (!i2) break;
   if ((i3 | 0) == -1) {
    i53 = 62;
    break L83;
   }
  }
  i4 = HEAP32[i14 >> 2] & 2147483647;
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i2 = 0;
    break;
   }
   i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
  if ((i3 | 0) == -1) {
   i53 = 62;
   break;
  }
 }
 if ((i53 | 0) == 62) {
  STACKTOP = i61;
  return;
 }
}

function __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE(i66, i2, i63, i64, i1) {
 i66 = i66 | 0;
 i2 = i2 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i65 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, f90 = f0, i91 = 0, f92 = f0, i93 = 0, f94 = f0, i95 = 0, f96 = f0, i97 = 0, f98 = f0, i99 = 0, f100 = f0, i101 = 0, f102 = f0, i103 = 0, f104 = f0, i105 = 0, f106 = f0, i107 = 0, f108 = f0, i109 = 0, f110 = f0, i111 = 0, f112 = f0, i113 = 0, f114 = f0, i115 = 0, f116 = f0, i117 = 0, f118 = f0, f119 = f0, f120 = f0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i67 + 640 | 0;
 i62 = i67 + 544 | 0;
 i65 = i67 + 496 | 0;
 i61 = i67 + 448 | 0;
 i53 = i67 + 304 | 0;
 i54 = i67 + 288 | 0;
 i57 = i67 + 144 | 0;
 i58 = i67;
 i59 = i66 + 26 | 0;
 i60 = i66 + ((HEAPU16[i59 >> 1] | 0) + 144) | 0;
 i50 = i66 + 8 | 0;
 i47 = HEAPU16[i50 >> 1] | 0;
 i55 = i66 + ((i47 * 432 | 0) + (HEAPU16[i66 + 24 >> 1] | 0)) | 0;
 i56 = i66 + (HEAPU16[i66 + 10 >> 1] | 0) | 0;
 i49 = i1 + 8 | 0;
 i48 = HEAP32[i49 >> 2] | 0;
 i51 = (HEAP32[i1 >> 2] | 0) + i48 | 0;
 i1 = i47 * 144 | 0;
 HEAP32[i49 >> 2] = i48 + i1;
 _memcpy(i51 | 0, i2 | 0, i1 | 0) | 0;
 i1 = (HEAPU16[i50 >> 1] | 0) + -1 | 0;
 if (!i1) {
  i65 = HEAP16[i59 >> 1] | 0;
  i65 = i65 & 65535;
  i64 = i66 + i65 | 0;
  __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i58, i51);
  HEAP32[i64 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  i64 = i65 + 16 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 16 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 32 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 32 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 48 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 48 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 64 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 64 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 80 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 80 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 96 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 96 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i64 = i65 + 112 | 0;
  i64 = i66 + i64 | 0;
  i63 = i58 + 112 | 0;
  HEAP32[i64 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAP32[i64 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
  i65 = i65 + 128 | 0;
  i66 = i66 + i65 | 0;
  i65 = i58 + 128 | 0;
  HEAP32[i66 >> 2] = HEAP32[i65 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
  HEAP32[i66 + 12 >> 2] = HEAP32[i65 + 12 >> 2];
  STACKTOP = i67;
  return;
 }
 i6 = i65 + 4 | 0;
 i7 = i65 + 8 | 0;
 i8 = i65 + 16 | 0;
 i9 = i65 + 20 | 0;
 i10 = i65 + 24 | 0;
 i11 = i65 + 32 | 0;
 i12 = i65 + 36 | 0;
 i13 = i65 + 40 | 0;
 i14 = i61 + 4 | 0;
 i15 = i61 + 8 | 0;
 i16 = i61 + 12 | 0;
 i17 = i61 + 16 | 0;
 i18 = i61 + 20 | 0;
 i19 = i61 + 24 | 0;
 i20 = i61 + 28 | 0;
 i21 = i61 + 32 | 0;
 i22 = i61 + 36 | 0;
 i23 = i61 + 40 | 0;
 i24 = i61 + 44 | 0;
 i25 = i53 + 4 | 0;
 i26 = i53 + 8 | 0;
 i27 = i53 + 16 | 0;
 i28 = i53 + 20 | 0;
 i29 = i53 + 24 | 0;
 i30 = i53 + 32 | 0;
 i31 = i53 + 36 | 0;
 i32 = i53 + 40 | 0;
 i33 = i53 + 48 | 0;
 i34 = i53 + 52 | 0;
 i35 = i53 + 56 | 0;
 i36 = i53 + 64 | 0;
 i37 = i53 + 68 | 0;
 i38 = i53 + 72 | 0;
 i39 = i53 + 80 | 0;
 i40 = i53 + 84 | 0;
 i41 = i53 + 88 | 0;
 i42 = i53 + 96 | 0;
 i43 = i53 + 100 | 0;
 i44 = i53 + 104 | 0;
 i45 = i53 + 112 | 0;
 i46 = i53 + 116 | 0;
 i47 = i53 + 120 | 0;
 i48 = i53 + 128 | 0;
 i49 = i53 + 132 | 0;
 i50 = i53 + 136 | 0;
 do {
  i2 = i51 + (i1 * 144 | 0) | 0;
  __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i65, i2, i55 + (i1 * 96 | 0) | 0, i62);
  f73 = Math_fround(HEAPF32[i63 + (i1 << 2) >> 2]);
  f74 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) >> 2]);
  f70 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 4 >> 2]);
  f71 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 8 >> 2]);
  f77 = Math_fround(HEAPF32[i65 >> 2]);
  f75 = Math_fround(HEAPF32[i6 >> 2]);
  f77 = Math_fround(Math_fround(f73 * f74) + f77);
  f75 = Math_fround(Math_fround(f73 * f70) + f75);
  f71 = Math_fround(Math_fround(f73 * f71) + Math_fround(HEAPF32[i7 >> 2]));
  f70 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 16 >> 2]);
  f74 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 20 >> 2]);
  f72 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 24 >> 2]);
  f68 = Math_fround(HEAPF32[i8 >> 2]);
  f76 = Math_fround(HEAPF32[i9 >> 2]);
  f68 = Math_fround(Math_fround(f73 * f70) + f68);
  f76 = Math_fround(Math_fround(f73 * f74) + f76);
  f72 = Math_fround(Math_fround(f73 * f72) + Math_fround(HEAPF32[i10 >> 2]));
  f74 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 32 >> 2]);
  f70 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 36 >> 2]);
  f79 = Math_fround(HEAPF32[i64 + (i1 * 48 | 0) + 40 >> 2]);
  f78 = Math_fround(HEAPF32[i11 >> 2]);
  f69 = Math_fround(HEAPF32[i12 >> 2]);
  f78 = Math_fround(Math_fround(f73 * f74) + f78);
  f69 = Math_fround(Math_fround(f73 * f70) + f69);
  f79 = Math_fround(Math_fround(f73 * f79) + Math_fround(HEAPF32[i13 >> 2]));
  f73 = Math_fround(Math_fround(f76 * f79) - Math_fround(f72 * f69));
  f72 = Math_fround(Math_fround(f72 * f78) - Math_fround(f68 * f79));
  f70 = Math_fround(Math_fround(f68 * f69) - Math_fround(f76 * f78));
  f74 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f71 * f70) + Math_fround(Math_fround(f77 * f73) + Math_fround(f75 * f72))));
  f72 = Math_fround(f74 * f72);
  f70 = Math_fround(f74 * f70);
  f71 = Math_fround(f74 * Math_fround(Math_fround(f77 * f79) - Math_fround(f71 * f78)));
  f69 = Math_fround(f74 * Math_fround(Math_fround(f75 * f78) - Math_fround(f77 * f69)));
  f68 = Math_fround(Math_fround(Math_fround(f77 * f76) - Math_fround(f75 * f68)) * f74);
  HEAPF32[i61 >> 2] = Math_fround(f74 * f73);
  HEAPF32[i14 >> 2] = f72;
  HEAPF32[i15 >> 2] = f70;
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  HEAPF32[i17 >> 2] = f72;
  HEAPF32[i18 >> 2] = f71;
  HEAPF32[i19 >> 2] = f69;
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  HEAPF32[i21 >> 2] = f70;
  HEAPF32[i22 >> 2] = f69;
  HEAPF32[i23 >> 2] = f68;
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  i3 = i60 + (i1 * 160 | 0) + 96 | 0;
  i4 = i61;
  i5 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i5 = HEAPU8[i66 + 64 + i1 >> 0] | 0;
  i117 = i56 + (i1 << 5) | 0;
  HEAP32[i54 >> 2] = HEAP32[i117 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i117 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i117 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i117 + 12 >> 2];
  __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_(i57, i2, i61, i62, i60 + (i1 * 160 | 0) | 0);
  HEAP32[i52 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE(i53, i52, i57);
  i117 = i51 + (i5 * 144 | 0) | 0;
  f120 = Math_fround(HEAPF32[i117 >> 2]);
  i115 = i51 + (i5 * 144 | 0) + 4 | 0;
  f119 = Math_fround(HEAPF32[i115 >> 2]);
  i113 = i51 + (i5 * 144 | 0) + 8 | 0;
  f114 = Math_fround(HEAPF32[i113 >> 2]);
  f118 = Math_fround(HEAPF32[i53 >> 2]);
  f116 = Math_fround(HEAPF32[i25 >> 2]);
  f118 = Math_fround(f120 + f118);
  f116 = Math_fround(f119 + f116);
  f114 = Math_fround(f114 + Math_fround(HEAPF32[i26 >> 2]));
  i111 = i51 + (i5 * 144 | 0) + 16 | 0;
  f119 = Math_fround(HEAPF32[i111 >> 2]);
  i109 = i51 + (i5 * 144 | 0) + 20 | 0;
  f120 = Math_fround(HEAPF32[i109 >> 2]);
  i107 = i51 + (i5 * 144 | 0) + 24 | 0;
  f108 = Math_fround(HEAPF32[i107 >> 2]);
  f112 = Math_fround(HEAPF32[i27 >> 2]);
  f110 = Math_fround(HEAPF32[i28 >> 2]);
  f112 = Math_fround(f119 + f112);
  f110 = Math_fround(f120 + f110);
  f108 = Math_fround(f108 + Math_fround(HEAPF32[i29 >> 2]));
  i105 = i51 + (i5 * 144 | 0) + 32 | 0;
  f120 = Math_fround(HEAPF32[i105 >> 2]);
  i103 = i51 + (i5 * 144 | 0) + 36 | 0;
  f119 = Math_fround(HEAPF32[i103 >> 2]);
  i101 = i51 + (i5 * 144 | 0) + 40 | 0;
  f102 = Math_fround(HEAPF32[i101 >> 2]);
  f106 = Math_fround(HEAPF32[i30 >> 2]);
  f104 = Math_fround(HEAPF32[i31 >> 2]);
  f106 = Math_fround(f120 + f106);
  f104 = Math_fround(f119 + f104);
  f102 = Math_fround(f102 + Math_fround(HEAPF32[i32 >> 2]));
  i99 = i51 + (i5 * 144 | 0) + 48 | 0;
  f119 = Math_fround(HEAPF32[i99 >> 2]);
  i97 = i51 + (i5 * 144 | 0) + 52 | 0;
  f120 = Math_fround(HEAPF32[i97 >> 2]);
  i95 = i51 + (i5 * 144 | 0) + 56 | 0;
  f96 = Math_fround(HEAPF32[i95 >> 2]);
  f100 = Math_fround(HEAPF32[i33 >> 2]);
  f98 = Math_fround(HEAPF32[i34 >> 2]);
  f100 = Math_fround(f119 + f100);
  f98 = Math_fround(f120 + f98);
  f96 = Math_fround(f96 + Math_fround(HEAPF32[i35 >> 2]));
  i93 = i51 + (i5 * 144 | 0) + 64 | 0;
  f120 = Math_fround(HEAPF32[i93 >> 2]);
  i91 = i51 + (i5 * 144 | 0) + 68 | 0;
  f119 = Math_fround(HEAPF32[i91 >> 2]);
  i89 = i51 + (i5 * 144 | 0) + 72 | 0;
  f90 = Math_fround(HEAPF32[i89 >> 2]);
  f94 = Math_fround(HEAPF32[i36 >> 2]);
  f92 = Math_fround(HEAPF32[i37 >> 2]);
  f94 = Math_fround(f120 + f94);
  f92 = Math_fround(f119 + f92);
  f90 = Math_fround(f90 + Math_fround(HEAPF32[i38 >> 2]));
  i88 = i51 + (i5 * 144 | 0) + 80 | 0;
  f119 = Math_fround(HEAPF32[i88 >> 2]);
  i87 = i51 + (i5 * 144 | 0) + 84 | 0;
  f120 = Math_fround(HEAPF32[i87 >> 2]);
  i86 = i51 + (i5 * 144 | 0) + 88 | 0;
  f70 = Math_fround(HEAPF32[i86 >> 2]);
  f68 = Math_fround(HEAPF32[i39 >> 2]);
  f69 = Math_fround(HEAPF32[i40 >> 2]);
  f68 = Math_fround(f119 + f68);
  f69 = Math_fround(f120 + f69);
  f70 = Math_fround(f70 + Math_fround(HEAPF32[i41 >> 2]));
  i85 = i51 + (i5 * 144 | 0) + 96 | 0;
  f120 = Math_fround(HEAPF32[i85 >> 2]);
  i84 = i51 + (i5 * 144 | 0) + 100 | 0;
  f119 = Math_fround(HEAPF32[i84 >> 2]);
  i83 = i51 + (i5 * 144 | 0) + 104 | 0;
  f73 = Math_fround(HEAPF32[i83 >> 2]);
  f71 = Math_fround(HEAPF32[i42 >> 2]);
  f72 = Math_fround(HEAPF32[i43 >> 2]);
  f71 = Math_fround(f120 + f71);
  f72 = Math_fround(f119 + f72);
  f73 = Math_fround(f73 + Math_fround(HEAPF32[i44 >> 2]));
  i82 = i51 + (i5 * 144 | 0) + 112 | 0;
  f119 = Math_fround(HEAPF32[i82 >> 2]);
  i81 = i51 + (i5 * 144 | 0) + 116 | 0;
  f120 = Math_fround(HEAPF32[i81 >> 2]);
  i80 = i51 + (i5 * 144 | 0) + 120 | 0;
  f76 = Math_fround(HEAPF32[i80 >> 2]);
  f74 = Math_fround(HEAPF32[i45 >> 2]);
  f75 = Math_fround(HEAPF32[i46 >> 2]);
  f74 = Math_fround(f119 + f74);
  f75 = Math_fround(f120 + f75);
  f76 = Math_fround(f76 + Math_fround(HEAPF32[i47 >> 2]));
  i2 = i51 + (i5 * 144 | 0) + 128 | 0;
  f120 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i51 + (i5 * 144 | 0) + 132 | 0;
  f119 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i51 + (i5 * 144 | 0) + 136 | 0;
  f79 = Math_fround(HEAPF32[i4 >> 2]);
  f77 = Math_fround(HEAPF32[i48 >> 2]);
  f78 = Math_fround(HEAPF32[i49 >> 2]);
  f77 = Math_fround(f120 + f77);
  f78 = Math_fround(f119 + f78);
  f79 = Math_fround(f79 + Math_fround(HEAPF32[i50 >> 2]));
  HEAPF32[i117 >> 2] = f118;
  HEAPF32[i115 >> 2] = f116;
  HEAPF32[i113 >> 2] = f114;
  HEAPF32[i51 + (i5 * 144 | 0) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i111 >> 2] = f112;
  HEAPF32[i109 >> 2] = f110;
  HEAPF32[i107 >> 2] = f108;
  HEAPF32[i51 + (i5 * 144 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i105 >> 2] = f106;
  HEAPF32[i103 >> 2] = f104;
  HEAPF32[i101 >> 2] = f102;
  HEAPF32[i51 + (i5 * 144 | 0) + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i99 >> 2] = f100;
  HEAPF32[i97 >> 2] = f98;
  HEAPF32[i95 >> 2] = f96;
  HEAPF32[i51 + (i5 * 144 | 0) + 60 >> 2] = Math_fround(0.0);
  HEAPF32[i93 >> 2] = f94;
  HEAPF32[i91 >> 2] = f92;
  HEAPF32[i89 >> 2] = f90;
  HEAPF32[i51 + (i5 * 144 | 0) + 76 >> 2] = Math_fround(0.0);
  HEAPF32[i88 >> 2] = f68;
  HEAPF32[i87 >> 2] = f69;
  HEAPF32[i86 >> 2] = f70;
  HEAPF32[i51 + (i5 * 144 | 0) + 92 >> 2] = Math_fround(0.0);
  HEAPF32[i85 >> 2] = f71;
  HEAPF32[i84 >> 2] = f72;
  HEAPF32[i83 >> 2] = f73;
  HEAPF32[i51 + (i5 * 144 | 0) + 108 >> 2] = Math_fround(0.0);
  HEAPF32[i82 >> 2] = f74;
  HEAPF32[i81 >> 2] = f75;
  HEAPF32[i80 >> 2] = f76;
  HEAPF32[i51 + (i5 * 144 | 0) + 124 >> 2] = Math_fround(0.0);
  HEAPF32[i2 >> 2] = f77;
  HEAPF32[i3 >> 2] = f78;
  HEAPF32[i4 >> 2] = f79;
  HEAPF32[i51 + (i5 * 144 | 0) + 140 >> 2] = Math_fround(0.0);
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 i117 = HEAP16[i59 >> 1] | 0;
 i117 = i117 & 65535;
 i115 = i66 + i117 | 0;
 __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i58, i51);
 HEAP32[i115 >> 2] = HEAP32[i58 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
 i115 = i117 + 16 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 16 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 32 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 32 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 48 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 48 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 64 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 64 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 80 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 80 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 96 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 96 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i115 = i117 + 112 | 0;
 i115 = i66 + i115 | 0;
 i113 = i58 + 112 | 0;
 HEAP32[i115 >> 2] = HEAP32[i113 >> 2];
 HEAP32[i115 + 4 >> 2] = HEAP32[i113 + 4 >> 2];
 HEAP32[i115 + 8 >> 2] = HEAP32[i113 + 8 >> 2];
 HEAP32[i115 + 12 >> 2] = HEAP32[i113 + 12 >> 2];
 i117 = i117 + 128 | 0;
 i117 = i66 + i117 | 0;
 i115 = i58 + 128 | 0;
 HEAP32[i117 >> 2] = HEAP32[i115 >> 2];
 HEAP32[i117 + 4 >> 2] = HEAP32[i115 + 4 >> 2];
 HEAP32[i117 + 8 >> 2] = HEAP32[i115 + 8 >> 2];
 HEAP32[i117 + 12 >> 2] = HEAP32[i115 + 12 >> 2];
 STACKTOP = i67;
 return;
}

function __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i24, i28, i27) {
 i24 = i24 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 2384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29 + 2128 | 0;
 i25 = i29 + 80 | 0;
 i5 = i29 + 64 | 0;
 i6 = i29 + 48 | 0;
 i17 = i29 + 32 | 0;
 i18 = i29 + 16 | 0;
 i19 = i29;
 i7 = HEAPU16[i28 + 26 >> 1] | 0;
 i20 = i28 + (i7 + 144) | 0;
 i16 = i28 + (HEAPU16[i28 + 10 >> 1] | 0) | 0;
 i22 = i28 + 128 | 0;
 i4 = i20 + (i27 * 160 | 0) + 152 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i23 = i28 + 16 | 0;
 i3 = i23;
 i2 = HEAP32[i3 >> 2] & i1;
 i3 = HEAP32[i3 + 4 >> 2] & i4;
 if ((i2 | 0) == 0 & (i3 | 0) == 0) {
  i28 = i22 + (i27 << 5) | 0;
  HEAP32[i24 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  i28 = i24 + 16 | 0;
  i27 = i22 + (i27 << 5) + 16 | 0;
  HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  STACKTOP = i29;
  return;
 }
 i14 = _i64Subtract(0, 0, i2 | 0, i3 | 0) | 0;
 i14 = _i64Subtract(0, 0, i2 & i14 | 0, i3 & (getTempRet0() | 0) | 0) | 0;
 i14 = i1 & i14;
 i15 = i4 & (getTempRet0() | 0);
 i4 = HEAPU16[i28 + 8 >> 1] | 0;
 i21 = i22 + (i4 << 5) | 0;
 i4 = i22 + (i4 << 6) | 0;
 if ((i14 & 1 | 0) == 0 & 0 == 0) {
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  i1 = i14;
  i2 = i15;
  i6 = 0;
  i5 = 0;
  i3 = 0;
 } else {
  i2 = i28 + 32 | 0;
  f38 = Math_fround(HEAPF32[i28 + 32 >> 2]);
  f13 = Math_fround(HEAPF32[i28 + 36 >> 2]);
  f38 = Math_fround(-f38);
  f13 = Math_fround(-f13);
  f32 = Math_fround(-Math_fround(HEAPF32[i28 + 40 >> 2]));
  i1 = i28 + 48 | 0;
  f36 = Math_fround(HEAPF32[i28 + 48 >> 2]);
  f30 = Math_fround(HEAPF32[i28 + 52 >> 2]);
  f36 = Math_fround(-f36);
  f30 = Math_fround(-f30);
  f12 = Math_fround(-Math_fround(HEAPF32[i28 + 56 >> 2]));
  f46 = Math_fround(Math_fround(HEAPF32[i28 + i7 >> 2]) * f38);
  f46 = Math_fround(f46 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 16) >> 2]) * f13));
  f46 = Math_fround(f46 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 32) >> 2]) * f32));
  f45 = Math_fround(Math_fround(HEAPF32[i28 + (i7 + 4) >> 2]) * f38);
  f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 20) >> 2]) * f13));
  f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 36) >> 2]) * f32));
  f44 = Math_fround(Math_fround(HEAPF32[i28 + (i7 + 8) >> 2]) * f38);
  f44 = Math_fround(f44 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 24) >> 2]) * f13));
  f44 = Math_fround(f44 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 40) >> 2]) * f32));
  f43 = Math_fround(HEAPF32[i28 + (i7 + 48) >> 2]);
  f8 = Math_fround(f43 * f36);
  f41 = Math_fround(HEAPF32[i28 + (i7 + 64) >> 2]);
  f8 = Math_fround(f8 + Math_fround(f41 * f30));
  f39 = Math_fround(HEAPF32[i28 + (i7 + 80) >> 2]);
  f8 = Math_fround(f8 + Math_fround(f39 * f12));
  f42 = Math_fround(HEAPF32[i28 + (i7 + 52) >> 2]);
  f9 = Math_fround(f42 * f36);
  f40 = Math_fround(HEAPF32[i28 + (i7 + 68) >> 2]);
  f9 = Math_fround(f9 + Math_fround(f40 * f30));
  f37 = Math_fround(HEAPF32[i28 + (i7 + 84) >> 2]);
  f9 = Math_fround(f9 + Math_fround(f37 * f12));
  f35 = Math_fround(HEAPF32[i28 + (i7 + 56) >> 2]);
  f10 = Math_fround(f35 * f36);
  f34 = Math_fround(HEAPF32[i28 + (i7 + 72) >> 2]);
  f10 = Math_fround(f10 + Math_fround(f34 * f30));
  f11 = Math_fround(HEAPF32[i28 + (i7 + 88) >> 2]);
  f8 = Math_fround(f46 + f8);
  f9 = Math_fround(f45 + f9);
  f10 = Math_fround(f44 + Math_fround(f10 + Math_fround(f11 * f12)));
  f35 = Math_fround(Math_fround(Math_fround(f43 * f38) + Math_fround(f42 * f13)) + Math_fround(f35 * f32));
  f34 = Math_fround(Math_fround(Math_fround(f41 * f38) + Math_fround(f40 * f13)) + Math_fround(f34 * f32));
  f32 = Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(f37 * f13)) + Math_fround(f11 * f32));
  f11 = Math_fround(Math_fround(HEAPF32[i28 + (i7 + 96) >> 2]) * f36);
  f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 112) >> 2]) * f30));
  f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 128) >> 2]) * f12));
  f13 = Math_fround(Math_fround(HEAPF32[i28 + (i7 + 100) >> 2]) * f36);
  f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 116) >> 2]) * f30));
  f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 132) >> 2]) * f12));
  f36 = Math_fround(Math_fround(HEAPF32[i28 + (i7 + 104) >> 2]) * f36);
  f30 = Math_fround(f36 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 120) >> 2]) * f30));
  f11 = Math_fround(f35 + f11);
  f13 = Math_fround(f34 + f13);
  f12 = Math_fround(f32 + Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i28 + (i7 + 136) >> 2]) * f12)));
  f30 = Math_fround(HEAPF32[i22 >> 2]);
  i31 = i28 + 132 | 0;
  f32 = Math_fround(HEAPF32[i31 >> 2]);
  i33 = i28 + 136 | 0;
  f32 = Math_fround(f9 + f32);
  f34 = Math_fround(f10 + Math_fround(HEAPF32[i33 >> 2]));
  HEAPF32[i22 >> 2] = Math_fround(f8 + f30);
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i28 + 140 >> 2] = Math_fround(0.0);
  i33 = i28 + 144 | 0;
  f34 = Math_fround(HEAPF32[i33 >> 2]);
  i31 = i22 + 20 | 0;
  f32 = Math_fround(HEAPF32[i31 >> 2]);
  i3 = i28 + 152 | 0;
  f32 = Math_fround(f13 + f32);
  f30 = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i33 >> 2] = Math_fround(f11 + f34);
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i3 >> 2] = f30;
  HEAPF32[i28 + 156 >> 2] = Math_fround(0.0);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i26 >> 2] = 0;
  HEAPF32[i25 >> 2] = f8;
  HEAPF32[i25 + 4 >> 2] = f9;
  HEAPF32[i25 + 8 >> 2] = f10;
  HEAPF32[i25 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 16 >> 2] = f11;
  HEAPF32[i25 + 20 >> 2] = f13;
  HEAPF32[i25 + 24 >> 2] = f12;
  HEAPF32[i25 + 28 >> 2] = Math_fround(0.0);
  i5 = i28 + (i7 + 288) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i14 | 0, i15 | 0, -1, -1) | 0;
  i2 = getTempRet0() | 0;
  i3 = 1;
 }
 if (!((i1 | 0) == 0 & (i2 | 0) == 0)) while (1) {
  i47 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
  i33 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i33 = i1 | 0 ? HEAP32[gb + 90668 + (i47 << 2) >> 2] | 0 : (HEAP32[gb + 90668 + (i33 << 2) >> 2] | 0) + 32 | 0;
  i47 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i1 = i47 & i1;
  i2 = (getTempRet0() | 0) & i2;
  i47 = i21 + (i33 << 5) | 0;
  f35 = Math_fround(HEAPF32[i47 >> 2]);
  f34 = Math_fround(HEAPF32[i21 + (i33 << 5) + 4 >> 2]);
  f35 = Math_fround(f8 + f35);
  f34 = Math_fround(f9 + f34);
  f30 = Math_fround(f10 + Math_fround(HEAPF32[i21 + (i33 << 5) + 8 >> 2]));
  i7 = i21 + (i33 << 5) + 16 | 0;
  f41 = Math_fround(HEAPF32[i7 >> 2]);
  f43 = Math_fround(HEAPF32[i21 + (i33 << 5) + 20 >> 2]);
  f41 = Math_fround(f11 + f41);
  f43 = Math_fround(f13 + f43);
  f45 = Math_fround(f12 + Math_fround(HEAPF32[i21 + (i33 << 5) + 24 >> 2]));
  i31 = i4 + (i33 << 4) | 0;
  f39 = Math_fround(HEAPF32[i31 >> 2]);
  f38 = Math_fround(HEAPF32[i4 + (i33 << 4) + 4 >> 2]);
  f37 = Math_fround(HEAPF32[i4 + (i33 << 4) + 8 >> 2]);
  f51 = Math_fround(f39 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 96 >> 2]));
  f51 = Math_fround(f51 + Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 112 >> 2])));
  f51 = Math_fround(f51 + Math_fround(f37 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 128 >> 2])));
  f32 = Math_fround(f39 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 100 >> 2]));
  f32 = Math_fround(f32 + Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 116 >> 2])));
  f32 = Math_fround(f32 + Math_fround(f37 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 132 >> 2])));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 104 >> 2]));
  f38 = Math_fround(f39 + Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 120 >> 2])));
  f37 = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 136 >> 2])));
  f38 = Math_fround(HEAPF32[i16 + (i33 << 5) >> 2]);
  f39 = Math_fround(HEAPF32[i16 + (i33 << 5) + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i16 + (i33 << 5) + 8 >> 2]);
  f35 = Math_fround(f35 + Math_fround(Math_fround(f43 * f36) - Math_fround(f45 * f39)));
  f36 = Math_fround(f34 + Math_fround(Math_fround(f45 * f38) - Math_fround(f41 * f36)));
  f38 = Math_fround(f30 + Math_fround(Math_fround(f41 * f39) - Math_fround(f43 * f38)));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) >> 2]);
  f30 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 4 >> 2]);
  f30 = Math_fround(Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 8 >> 2])) + Math_fround(Math_fround(f39 * f35) + Math_fround(f30 * f36)));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 32 >> 2]);
  f34 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 36 >> 2]);
  f34 = Math_fround(Math_fround(Math_fround(f35 * f39) + Math_fround(f36 * f34)) + Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 40 >> 2])));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 64 >> 2]);
  f40 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 68 >> 2]);
  f40 = Math_fround(Math_fround(Math_fround(f35 * f39) + Math_fround(f36 * f40)) + Math_fround(f38 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 72 >> 2])));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 16 >> 2]);
  f42 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 20 >> 2]);
  f42 = Math_fround(Math_fround(Math_fround(f41 * f39) + Math_fround(f43 * f42)) + Math_fround(f45 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 24 >> 2])));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 48 >> 2]);
  f44 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 52 >> 2]);
  f44 = Math_fround(Math_fround(Math_fround(f41 * f39) + Math_fround(f43 * f44)) + Math_fround(f45 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 56 >> 2])));
  f39 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 80 >> 2]);
  f46 = Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 84 >> 2]);
  f42 = Math_fround(f51 + Math_fround(f30 + f42));
  f44 = Math_fround(f32 + Math_fround(f34 + f44));
  f46 = Math_fround(f37 + Math_fround(f40 + Math_fround(Math_fround(Math_fround(f41 * f39) + Math_fround(f43 * f46)) + Math_fround(f45 * Math_fround(HEAPF32[i20 + (i33 * 160 | 0) + 88 >> 2])))));
  f39 = Math_fround(HEAPF32[i16 + (i33 << 5) + 16 >> 2]);
  f40 = Math_fround(HEAPF32[i16 + (i33 << 5) + 20 >> 2]);
  f37 = Math_fround(HEAPF32[i16 + (i33 << 5) + 24 >> 2]);
  f8 = Math_fround(f35 - Math_fround(Math_fround(f40 * f46) - Math_fround(f44 * f37)));
  f9 = Math_fround(f36 - Math_fround(Math_fround(f42 * f37) - Math_fround(f39 * f46)));
  f10 = Math_fround(f38 - Math_fround(Math_fround(f44 * f39) - Math_fround(f42 * f40)));
  f11 = Math_fround(f41 - f42);
  f13 = Math_fround(f43 - f44);
  f12 = Math_fround(f45 - f46);
  i48 = i22 + (i33 << 5) | 0;
  f46 = Math_fround(HEAPF32[i48 >> 2]);
  i49 = i22 + (i33 << 5) + 4 | 0;
  f45 = Math_fround(HEAPF32[i49 >> 2]);
  i50 = i22 + (i33 << 5) + 8 | 0;
  f45 = Math_fround(f45 + f9);
  f44 = Math_fround(f10 + Math_fround(HEAPF32[i50 >> 2]));
  HEAPF32[i48 >> 2] = Math_fround(f46 + f8);
  HEAPF32[i49 >> 2] = f45;
  HEAPF32[i50 >> 2] = f44;
  HEAPF32[i22 + (i33 << 5) + 12 >> 2] = Math_fround(0.0);
  i50 = i22 + (i33 << 5) + 16 | 0;
  f44 = Math_fround(HEAPF32[i50 >> 2]);
  i49 = i22 + (i33 << 5) + 20 | 0;
  f45 = Math_fround(HEAPF32[i49 >> 2]);
  i48 = i22 + (i33 << 5) + 24 | 0;
  f45 = Math_fround(f13 + f45);
  f46 = Math_fround(f12 + Math_fround(HEAPF32[i48 >> 2]));
  HEAPF32[i50 >> 2] = Math_fround(f11 + f44);
  HEAPF32[i49 >> 2] = f45;
  HEAPF32[i48 >> 2] = f46;
  HEAPF32[i22 + (i33 << 5) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i47 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i47 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  HEAP32[i31 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i26 + (i33 << 2) >> 2] = i3;
  i33 = i20 + (i33 * 160 | 0) + 144 | 0;
  i6 = HEAP32[i33 >> 2] | i6;
  i5 = HEAP32[i33 + 4 >> 2] | i5;
  HEAPF32[i25 + (i3 << 5) >> 2] = f8;
  HEAPF32[i25 + (i3 << 5) + 4 >> 2] = f9;
  HEAPF32[i25 + (i3 << 5) + 8 >> 2] = f10;
  HEAPF32[i25 + (i3 << 5) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + (i3 << 5) + 16 >> 2] = f11;
  HEAPF32[i25 + (i3 << 5) + 20 >> 2] = f13;
  HEAPF32[i25 + (i3 << 5) + 24 >> 2] = f12;
  HEAPF32[i25 + (i3 << 5) + 28 >> 2] = Math_fround(0.0);
  if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 1 | 0;
 }
 i4 = ~i14;
 i3 = ~i15;
 i1 = i6 & i4;
 i2 = i5 & i3;
 if (!((i1 | 0) == 0 & (i2 | 0) == 0)) do {
  i33 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
  i50 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i50 = i1 | 0 ? HEAP32[gb + 90668 + (i33 << 2) >> 2] | 0 : (HEAP32[gb + 90668 + (i50 << 2) >> 2] | 0) + 32 | 0;
  i33 = HEAP32[i26 + ((HEAPU8[i28 + 64 + i50 >> 0] | 0) << 2) >> 2] | 0;
  i49 = i21 + (i50 << 5) | 0;
  f45 = Math_fround(HEAPF32[i49 >> 2]);
  i48 = i21 + (i50 << 5) + 4 | 0;
  f46 = Math_fround(HEAPF32[i48 >> 2]);
  i47 = i21 + (i50 << 5) + 8 | 0;
  f44 = Math_fround(HEAPF32[i47 >> 2]);
  f51 = Math_fround(HEAPF32[i25 + (i33 << 5) >> 2]);
  f43 = Math_fround(HEAPF32[i25 + (i33 << 5) + 4 >> 2]);
  f43 = Math_fround(f46 + f43);
  f44 = Math_fround(f44 + Math_fround(HEAPF32[i25 + (i33 << 5) + 8 >> 2]));
  HEAPF32[i49 >> 2] = Math_fround(f45 + f51);
  HEAPF32[i48 >> 2] = f43;
  HEAPF32[i47 >> 2] = f44;
  HEAPF32[i21 + (i50 << 5) + 12 >> 2] = Math_fround(0.0);
  i47 = i21 + (i50 << 5) + 16 | 0;
  f44 = Math_fround(HEAPF32[i47 >> 2]);
  i48 = i21 + (i50 << 5) + 20 | 0;
  f43 = Math_fround(HEAPF32[i48 >> 2]);
  i49 = i21 + (i50 << 5) + 24 | 0;
  f51 = Math_fround(HEAPF32[i49 >> 2]);
  f45 = Math_fround(HEAPF32[i25 + (i33 << 5) + 16 >> 2]);
  f46 = Math_fround(HEAPF32[i25 + (i33 << 5) + 20 >> 2]);
  f46 = Math_fround(f43 + f46);
  f51 = Math_fround(f51 + Math_fround(HEAPF32[i25 + (i33 << 5) + 24 >> 2]));
  HEAPF32[i47 >> 2] = Math_fround(f44 + f45);
  HEAPF32[i48 >> 2] = f46;
  HEAPF32[i49 >> 2] = f51;
  HEAPF32[i21 + (i50 << 5) + 28 >> 2] = Math_fround(0.0);
  i50 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i1 = i50 & i1;
  i2 = (getTempRet0() | 0) & i2;
 } while (!((i1 | 0) == 0 & (i2 | 0) == 0));
 i48 = i23;
 i49 = (HEAP32[i48 + 4 >> 2] | i5) & i3;
 i50 = i23;
 HEAP32[i50 >> 2] = (HEAP32[i48 >> 2] | i6) & i4;
 HEAP32[i50 + 4 >> 2] = i49;
 i50 = i22 + (i27 << 5) | 0;
 HEAP32[i24 >> 2] = HEAP32[i50 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
 i50 = i24 + 16 | 0;
 i49 = i22 + (i27 << 5) + 16 | 0;
 HEAP32[i50 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
 STACKTOP = i29;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl21AddCharacterToTextureEjifj(i34, i35, i40, f41, i42) {
 i34 = i34 | 0;
 i35 = i35 | 0;
 i40 = i40 | 0;
 f41 = Math_fround(f41);
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, i53 = 0, f54 = f0, f55 = f0, f56 = f0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i51 + 116 | 0;
 i43 = i51 + 96 | 0;
 i44 = i51 + 80 | 0;
 i45 = i51 + 72 | 0;
 i46 = i51 + 64 | 0;
 i47 = i51 + 60 | 0;
 i36 = i51 + 56 | 0;
 i49 = i51 + 40 | 0;
 i37 = i51 + 24 | 0;
 i38 = i51 + 68 | 0;
 i39 = i51;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i45 >> 2] = 0;
 HEAP32[i46 >> 2] = 0;
 HEAP32[i47 >> 2] = 0;
 HEAPF32[i36 >> 2] = Math_fround(0.0);
 i6 = __ZN20TextRenderingPrivate8FontImpl18GetCharacterBitmapERjS1_S1_R5RectTIfERfjifj(i34, i45, i46, i47, i44, i36, i35, i40, f41, HEAP32[i34 + 188 >> 2] | i42) | 0;
 HEAP32[i49 >> 2] = 0;
 i50 = i49 + 4 | 0;
 HEAP32[i50 >> 2] = 0;
 HEAP32[i49 + 8 >> 2] = 0;
 HEAP32[i49 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 if (!i6) {
  i2 = HEAP32[i46 >> 2] | 0;
  i1 = HEAP32[i45 >> 2] | 0;
  if (!(Math_imul(i1, i2) | 0)) i24 = 5; else {
   HEAP32[i45 >> 2] = 0;
   HEAP32[i46 >> 2] = 0;
   HEAPF32[i36 >> 2] = Math_fround(0.0);
   i1 = 0;
   i2 = 0;
   i24 = 15;
  }
 } else {
  i1 = HEAP32[i45 >> 2] | 0;
  i2 = HEAP32[i46 >> 2] | 0;
  i24 = 5;
 }
 if ((i24 | 0) == 5) if (i1 >>> 0 > i2 >>> 0) {
  i2 = Math_imul(i2, i1) | 0;
  if (i2) {
   __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier1ELi16EEE8__appendEj(i49, i2);
   i1 = HEAP32[i45 >> 2] | 0;
  }
  i2 = HEAP32[i46 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i5 = 0;
   i3 = i2;
   do {
    if (!i3) i3 = 0; else {
     i4 = ~i5;
     i1 = i3 + -1 + (Math_imul(i1 + i4 | 0, i3) | 0) | 0;
     HEAP8[(HEAP32[i49 >> 2] | 0) + i1 >> 0] = HEAP8[i6 + i5 >> 0] | 0;
     i1 = HEAP32[i46 >> 2] | 0;
     if (i1 >>> 0 > 1) {
      i2 = 1;
      do {
       i33 = HEAP8[i6 + ((Math_imul(HEAP32[i47 >> 2] | 0, i2) | 0) + i5) >> 0] | 0;
       i1 = i1 + ~i2 + (Math_imul((HEAP32[i45 >> 2] | 0) + i4 | 0, i1) | 0) | 0;
       HEAP8[(HEAP32[i49 >> 2] | 0) + i1 >> 0] = i33;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i46 >> 2] | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     i2 = i1;
     i3 = i1;
     i1 = HEAP32[i45 >> 2] | 0;
    }
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
  }
  i28 = HEAP32[i49 >> 2] | 0;
  HEAP32[i47 >> 2] = i2;
  HEAP32[i46 >> 2] = i1;
  HEAP32[i45 >> 2] = i2;
  i29 = 1;
 } else i24 = 15;
 if ((i24 | 0) == 15) if ((HEAP32[i47 >> 2] | 0) >>> 0 > i1 >>> 0) {
  i2 = Math_imul(i2, i1) | 0;
  if (i2) {
   __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier1ELi16EEE8__appendEj(i49, i2);
   i1 = HEAP32[i45 >> 2] | 0;
  }
  if (!i1) i1 = 0; else {
   i3 = 0;
   i2 = HEAP32[i46 >> 2] | 0;
   do {
    if (!i2) i2 = 0; else {
     HEAP8[(HEAP32[i49 >> 2] | 0) + i3 >> 0] = HEAP8[i6 + i3 >> 0] | 0;
     i1 = HEAP32[i46 >> 2] | 0;
     if (i1 >>> 0 > 1) {
      i2 = 1;
      do {
       i33 = HEAP8[i6 + ((Math_imul(HEAP32[i47 >> 2] | 0, i2) | 0) + i3) >> 0] | 0;
       i1 = (Math_imul(HEAP32[i45 >> 2] | 0, i2) | 0) + i3 | 0;
       HEAP8[(HEAP32[i49 >> 2] | 0) + i1 >> 0] = i33;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i46 >> 2] | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     i2 = i1;
     i1 = HEAP32[i45 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
  i28 = HEAP32[i49 >> 2] | 0;
  HEAP32[i47 >> 2] = i1;
  i29 = 0;
 } else {
  i28 = i6;
  i29 = 0;
 }
 i30 = i34 + 24 | 0;
 f52 = Math_fround(Math_fround(HEAP32[i30 >> 2] | 0) / f41);
 HEAPF32[i44 >> 2] = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f52);
 i19 = i44 + 4 | 0;
 HEAPF32[i19 >> 2] = Math_fround(f52 + Math_fround(HEAPF32[i19 >> 2]));
 f52 = Math_fround(f52 * Math_fround(2.0));
 i19 = i44 + 8 | 0;
 HEAPF32[i19 >> 2] = Math_fround(f52 + Math_fround(HEAPF32[i19 >> 2]));
 i19 = i44 + 12 | 0;
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f52);
 i19 = i34 + 164 | 0;
 i25 = i34 + 148 | 0;
 i23 = i34 + 152 | 0;
 i27 = i34 + 184 | 0;
 i31 = i34 + 168 | 0;
 i26 = i34 + 180 | 0;
 i32 = i34 + 172 | 0;
 i7 = i34 + 164 | 0;
 i8 = i34 + 20 | 0;
 i33 = i37 + 4 | 0;
 i21 = i37 + 8 | 0;
 i22 = i37 + 12 | 0;
 i10 = i34 + 132 | 0;
 i17 = i34 + 136 | 0;
 L41 : while (1) {
  i1 = HEAP32[i19 >> 2] | 0;
  i5 = i1;
  if ((i5 | 0) != (i23 | 0)) {
   i20 = HEAP32[i8 >> 2] | 0;
   i16 = HEAP32[i30 >> 2] << 1;
   i15 = i20 + (HEAP32[i45 >> 2] | 0) + i16 | 0;
   i16 = (HEAP32[i46 >> 2] | 0) + i20 + i16 | 0;
   i20 = i1;
   i18 = i5;
   while (1) {
    i4 = HEAP32[i18 + 16 >> 2] | 0;
    i9 = HEAP32[i18 + 20 >> 2] | 0;
    HEAP32[i37 >> 2] = i4;
    HEAP32[i33 >> 2] = i9;
    HEAP32[i21 >> 2] = i15;
    HEAP32[i22 >> 2] = i16;
    L47 : do if ((i4 | i9 | 0) >= 0) {
     i2 = i15 + i4 | 0;
     i11 = HEAP32[i26 >> 2] | 0;
     if ((i2 | 0) <= (i11 | 0)) {
      i6 = i9 + i16 | 0;
      if ((i6 | 0) <= (i11 | 0)) {
       i12 = HEAP32[i10 >> 2] | 0;
       i13 = HEAP32[i17 >> 2] | 0;
       i14 = (i12 | 0) == (i13 | 0);
       if (i14) {
        i24 = 36;
        break L41;
       } else i1 = i12;
       while (1) {
        i3 = HEAP32[i1 >> 2] | 0;
        if (((HEAP32[i1 + 8 >> 2] | 0) + i3 | 0) > (i4 | 0)) {
         i53 = HEAP32[i1 + 4 >> 2] | 0;
         if ((i53 | 0) < (i6 | 0) & ((i3 | 0) < (i2 | 0) ? ((HEAP32[i1 + 12 >> 2] | 0) + i53 | 0) > (i9 | 0) : 0)) break L47;
        }
        i1 = i1 + 16 | 0;
        if ((i1 | 0) == (i13 | 0)) {
         i24 = 36;
         break L41;
        }
       }
      }
     }
    } while (0);
    i1 = HEAP32[i18 + 4 >> 2] | 0;
    if (!i1) {
     i1 = i20;
     while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
       i1 = i2;
       break;
      } else i1 = i2;
     }
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i23 | 0)) break; else {
     i20 = i1;
     i18 = i1;
    }
   }
  }
  i1 = HEAP32[i25 >> 2] | 0;
  if ((i5 | 0) != (i1 | 0)) {
   HEAP32[i7 >> 2] = i1;
   continue;
  }
  i1 = (HEAP32[i27 >> 2] | 0) + 1 | 0;
  i53 = HEAP32[i26 >> 2] | 0;
  if (i1 >>> 0 >= (Math_imul(((HEAP32[i32 >> 2] | 0) >>> 0) / (i53 >>> 0) | 0, ((HEAP32[i31 >> 2] | 0) >>> 0) / (i53 >>> 0) | 0) | 0) >>> 0) {
   i2 = 0;
   break;
  }
  HEAP32[i27 >> 2] = i1;
  __ZN20TextRenderingPrivate8FontImpl16ResetPackingDataEv(i34);
 }
 if ((i24 | 0) == 36) {
  L71 : do if ((i4 | 0) >= 1) {
   i5 = i4;
   while (1) {
    i4 = i5 + -1 | 0;
    i2 = i4 + i15 | 0;
    if ((i2 | 0) > (i11 | 0)) {
     i4 = i5;
     break L71;
    }
    if (!i14) {
     i1 = i12;
     do {
      i3 = HEAP32[i1 >> 2] | 0;
      if (((HEAP32[i1 + 8 >> 2] | 0) + i3 | 0) >= (i5 | 0)) {
       i53 = HEAP32[i1 + 4 >> 2] | 0;
       if ((i53 | 0) < (i6 | 0) & ((i3 | 0) < (i2 | 0) ? ((HEAP32[i1 + 12 >> 2] | 0) + i53 | 0) > (i9 | 0) : 0)) {
        i4 = i5;
        break L71;
       }
      }
      i1 = i1 + 16 | 0;
     } while ((i1 | 0) != (i13 | 0));
    }
    HEAP32[i37 >> 2] = i4;
    HEAP32[i33 >> 2] = i9;
    HEAP32[i21 >> 2] = i15;
    HEAP32[i22 >> 2] = i16;
    if ((i5 | 0) < 2) break; else i5 = i4;
   }
  } while (0);
  L83 : do if (!((i4 | 0) < 0 | (i9 | 0) < 1)) {
   i7 = i15 + i4 | 0;
   i8 = (i7 | 0) > (i11 | 0);
   i5 = i9;
   do {
    i6 = i5;
    i5 = i5 + -1 | 0;
    if (i8) break L83;
    i2 = i5 + i16 | 0;
    if ((i2 | 0) > (i11 | 0)) break L83;
    if (!i14) {
     i1 = i12;
     do {
      i3 = HEAP32[i1 >> 2] | 0;
      if (((HEAP32[i1 + 8 >> 2] | 0) + i3 | 0) > (i4 | 0)) {
       i53 = HEAP32[i1 + 4 >> 2] | 0;
       if ((i53 | 0) < (i2 | 0) & ((i3 | 0) < (i7 | 0) ? ((HEAP32[i1 + 12 >> 2] | 0) + i53 | 0) >= (i6 | 0) : 0)) break L83;
      }
      i1 = i1 + 16 | 0;
     } while ((i1 | 0) != (i13 | 0));
    }
    HEAP32[i37 >> 2] = i4;
    HEAP32[i33 >> 2] = i5;
    HEAP32[i21 >> 2] = i15;
    HEAP32[i22 >> 2] = i16;
   } while ((i6 | 0) >= 2);
  } while (0);
  if ((i13 | 0) == (HEAP32[i34 + 140 >> 2] | 0)) __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl7IntRectE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i34 + 132 | 0, i37); else {
   HEAP32[i13 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 16;
  }
  HEAP32[i19 >> 2] = i20;
  i3 = i20;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i3;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  HEAP32[i19 >> 2] = i1;
  i1 = HEAP32[i18 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i3;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i25 >> 2] | 0) == (i18 | 0)) HEAP32[i25 >> 2] = i1;
  i11 = i34 + 160 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  i10 = i34 + 156 | 0;
  i12 = i34 + 152 | 0;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i3);
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i48 >> 2] = 34;
  HEAP32[i48 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i48);
  i7 = (HEAP32[i21 >> 2] | 0) + (HEAP32[i37 >> 2] | 0) | 0;
  i2 = HEAP32[i26 >> 2] | 0;
  if (i7 >>> 0 < i2 >>> 0) {
   i8 = HEAP32[i33 >> 2] | 0;
   i1 = HEAP32[i23 >> 2] | 0;
   do if (!i1) {
    HEAP32[i43 >> 2] = i23;
    i4 = i23;
    i3 = i23;
   } else {
    i6 = i8 + i7 | 0;
    while (1) {
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     i4 = (HEAP32[i1 + 20 >> 2] | 0) + i3 | 0;
     i5 = (i6 | 0) == (i4 | 0);
     if (i5 ? (i7 | 0) < (i3 | 0) : (i6 | 0) < (i4 | 0)) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) {
       i24 = 68;
       break;
      } else i1 = i3;
     } else {
      if (!(i5 ? (i3 | 0) < (i7 | 0) : (i4 | 0) < (i6 | 0))) {
       i24 = 73;
       break;
      }
      i5 = i1 + 4 | 0;
      i3 = HEAP32[i5 >> 2] | 0;
      if (!i3) {
       i24 = 72;
       break;
      } else i1 = i3;
     }
    }
    if ((i24 | 0) == 68) {
     HEAP32[i43 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i24 | 0) == 72) {
     HEAP32[i43 >> 2] = i1;
     i4 = i1;
     i3 = i5;
     break;
    } else if ((i24 | 0) == 73) {
     HEAP32[i43 >> 2] = i1;
     i4 = i1;
     i3 = i43;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP32[i48 >> 2] = 34;
    HEAP32[i48 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = i7;
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i25 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i1);
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    i2 = HEAP32[i26 >> 2] | 0;
   }
  }
  i1 = HEAP32[i33 >> 2] | 0;
  i8 = (HEAP32[i22 >> 2] | 0) + i1 | 0;
  if (i8 >>> 0 < i2 >>> 0) {
   i9 = HEAP32[i37 >> 2] | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   do if (!i3) {
    HEAP32[i43 >> 2] = i23;
    i4 = i23;
    i3 = i23;
   } else {
    i7 = i9 + i8 | 0;
    while (1) {
     i4 = HEAP32[i3 + 16 >> 2] | 0;
     i5 = (HEAP32[i3 + 20 >> 2] | 0) + i4 | 0;
     i6 = (i7 | 0) == (i5 | 0);
     if (i6 ? (i9 | 0) < (i4 | 0) : (i7 | 0) < (i5 | 0)) {
      i4 = HEAP32[i3 >> 2] | 0;
      if (!i4) {
       i24 = 85;
       break;
      } else i3 = i4;
     } else {
      if (!(i6 ? (i4 | 0) < (i9 | 0) : (i5 | 0) < (i7 | 0))) {
       i24 = 90;
       break;
      }
      i5 = i3 + 4 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) {
       i24 = 89;
       break;
      } else i3 = i4;
     }
    }
    if ((i24 | 0) == 85) {
     HEAP32[i43 >> 2] = i3;
     i4 = i3;
     break;
    } else if ((i24 | 0) == 89) {
     HEAP32[i43 >> 2] = i3;
     i4 = i3;
     i3 = i5;
     break;
    } else if ((i24 | 0) == 90) {
     HEAP32[i43 >> 2] = i3;
     i4 = i3;
     i3 = i43;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP32[i48 >> 2] = 34;
    HEAP32[i48 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i48, 0, gb + 1049224 | 0, 75) | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = i9;
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i25 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i1);
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    i2 = HEAP32[i26 >> 2] | 0;
    i1 = HEAP32[i33 >> 2] | 0;
   }
  }
  i27 = Math_imul(i2, HEAP32[i27 >> 2] | 0) | 0;
  i53 = HEAP32[i31 >> 2] | 0;
  HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + ((i27 >>> 0) % (i53 >>> 0) | 0);
  HEAP32[i33 >> 2] = i1 + (Math_imul(i2, (i27 >>> 0) / (i53 >>> 0) | 0) | 0);
  if (i28 | 0) {
   i1 = HEAP32[i47 >> 2] | 0;
   i2 = HEAP32[i46 >> 2] | 0;
   HEAP32[i48 >> 2] = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[i34 + 76 >> 2] | 0) | 0;
   i9 = __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E(i48) | 0;
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0)) {
    i1 = Math_imul(i2, i1) | 0;
    i2 = __Z12GetGfxDevicev() | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 440 >> 2] | 0;
    HEAP32[i38 >> 2] = HEAP32[i9 + 48 >> 2];
    i5 = HEAP32[i30 >> 2] | 0;
    i4 = i5 + (HEAP32[i37 >> 2] | 0) | 0;
    i5 = (HEAP32[i33 >> 2] | 0) + i5 | 0;
    i6 = HEAP32[i47 >> 2] | 0;
    i7 = HEAP32[i46 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i8 = HEAP32[i9 + 60 >> 2] | 0; else i8 = 0;
    HEAP32[i48 >> 2] = HEAP32[i38 >> 2];
    mftCall_viiiiiiiiiii(i3 | 0, i2 | 0, i48 | 0, i28 | 0, i1 | 0, 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, 1, i8 | 0);
   }
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0) {
    HEAP32[i48 >> 2] = 0;
    HEAP32[i48 + 4 >> 2] = 0;
    HEAP32[i48 + 8 >> 2] = 0;
    HEAP32[i48 + 12 >> 2] = 0;
    HEAP32[i48 + 16 >> 2] = 0;
    if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i9, i48, 0, 0) | 0) {
     i53 = HEAP32[i30 >> 2] | 0;
     __ZNK14ImageReference9ClipImageEiiii(i43, i48, i53 + (HEAP32[i37 >> 2] | 0) | 0, (HEAP32[i33 >> 2] | 0) + i53 | 0, HEAP32[i45 >> 2] | 0, HEAP32[i46 >> 2] | 0);
     __ZN14ImageReferenceC2Eiii13TextureFormatPv(i39, HEAP32[i45 >> 2] | 0, HEAP32[i46 >> 2] | 0, HEAP32[i47 >> 2] | 0, 1, i28);
     __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i43, i39, 0);
    }
   }
  }
  f55 = Math_fround((HEAP32[i31 >> 2] | 0) >>> 0);
  f52 = Math_fround((HEAP32[i32 >> 2] | 0) >>> 0);
  f56 = Math_fround(Math_fround(HEAP32[i37 >> 2] | 0) / f55);
  i2 = HEAP32[i46 >> 2] | 0;
  i53 = HEAP32[i30 >> 2] << 1;
  f54 = Math_fround(Math_fround((i2 + (HEAP32[i33 >> 2] | 0) + i53 | 0) >>> 0) / f52);
  f55 = Math_fround(Math_fround(((HEAP32[i45 >> 2] | 0) + i53 | 0) >>> 0) / f55);
  f52 = Math_fround(-Math_fround(Math_fround((i53 + i2 | 0) >>> 0) / f52));
  HEAPF32[i48 >> 2] = f56;
  HEAPF32[i48 + 8 >> 2] = f55;
  HEAPF32[i48 + 4 >> 2] = f54;
  HEAPF32[i48 + 12 >> 2] = f52;
  __ZN20TextRenderingPrivate8FontImpl21AddCharacterInfoEntryERK5RectTIfES4_fibijf(i34, i48, i44, Math_fround(HEAPF32[i36 >> 2]), i35, i29, i40, i42, f41);
  i2 = 1;
 }
 i1 = HEAP32[i49 >> 2] | 0;
 if (!i1) {
  STACKTOP = i51;
  return i2 | 0;
 }
 if ((HEAP32[i50 >> 2] | 0) != (i1 | 0)) HEAP32[i50 >> 2] = i1;
 i53 = HEAP32[i49 + 12 >> 2] | 0;
 HEAP32[i48 >> 2] = 1;
 HEAP32[i48 + 4 >> 2] = i53;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i48);
 STACKTOP = i51;
 return i2 | 0;
}

function __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf(i4, i5, i6, i7, i9, i10, i12, i13, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i8 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 do if ((i7 + -10 | 0) >>> 0 >= 3) if (((i7 | 1) + -25 | 0) >>> 0 >= 5) {
  i3 = i7 + -30 | 0;
  if (i3 >>> 0 < 15) {
   if ((i7 + -48 | 0) >>> 0 < 12 | ((i7 + -45 | 0) >>> 0 < 3 | (30847 >>> (i3 & 65535) & 1) != 0)) break;
  } else if ((i7 + -45 | 0) >>> 0 < 3 | (i7 + -48 | 0) >>> 0 < 12) break;
  if ((i12 | 0) < 1 | (i13 | 0) < 1) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 404561 | 0, 0, gb + 404494 | 0, 1860, 1, 0, 0, 0);
   i13 = 0;
   return i13 | 0;
  }
  if ((Math_imul(i13, i12) | 0) > (i1 | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 404689 | 0, 0, gb + 404494 | 0, 1867, 1, 0, 0, 0);
   i13 = 0;
   return i13 | 0;
  }
  if ((i10 | i9 | 0) >= 0) {
   i1 = i12 + i9 | 0;
   if ((i1 | 0) >= 0) {
    i11 = i13 + i10 | 0;
    if (!((i11 | 0) > (i6 | 0) | ((i1 | 0) > (i5 | 0) | (i11 | 0) < 0))) {
     i11 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i5, i7) | 0;
     if (!i4) i8 = 19; else {
      if ((i7 | 0) < 9) i1 = 1; else i1 = (i7 | 0) == 1e3 | ((i7 | 0) == 23 | (i7 + -13 | 0) >>> 0 < 9);
      if (!((i5 | 0) > 0 & (i6 | 0) > 0 & (i7 | 0) > 0 & i1)) i8 = 19;
     }
     if ((i8 | 0) == 19) i4 = 0;
     do switch (i7 | 0) {
     case 5:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(5) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i13 = 1;
        return i13 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f19 = Math_fround(HEAPF32[i4 >> 2]);
         i16 = f19 < Math_fround(0.0);
         i15 = f19 > Math_fround(1.0);
         i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
         i14 = f19 < Math_fround(0.0);
         i8 = f19 > Math_fround(1.0);
         i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
         i9 = f19 < Math_fround(0.0);
         i10 = f19 > Math_fround(1.0);
         i10 = ~~Math_fround(Math_fround((i10 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 12 >> 2]);
         i18 = f19 < Math_fround(0.0);
         i17 = f19 > Math_fround(1.0);
         i17 = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         HEAP8[i1 >> 0] = i18 ? 0 : i17;
         HEAP8[i1 + 1 >> 0] = i16 ? 0 : i15;
         HEAP8[i1 + 2 >> 0] = i14 ? 0 : i8;
         HEAP8[i1 + 3 >> 0] = i9 ? 0 : i10;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 4:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(4) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f19 = Math_fround(HEAPF32[i4 >> 2]);
         i8 = f19 < Math_fround(0.0);
         i9 = f19 > Math_fround(1.0);
         i9 = ~~Math_fround(Math_fround((i9 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
         i10 = f19 < Math_fround(0.0);
         i14 = f19 > Math_fround(1.0);
         i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
         i15 = f19 < Math_fround(0.0);
         i16 = f19 > Math_fround(1.0);
         i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 12 >> 2]);
         i17 = f19 < Math_fround(0.0);
         i18 = f19 > Math_fround(1.0);
         i18 = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         HEAP8[i1 >> 0] = i8 ? 0 : i9;
         HEAP8[i1 + 1 >> 0] = i10 ? 0 : i14;
         HEAP8[i1 + 2 >> 0] = i15 ? 0 : i16;
         HEAP8[i1 + 3 >> 0] = i17 ? 0 : i18;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 3:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(3) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f19 = Math_fround(HEAPF32[i4 >> 2]);
         i10 = f19 < Math_fround(0.0);
         i14 = f19 > Math_fround(1.0);
         i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
         i15 = f19 < Math_fround(0.0);
         i16 = f19 > Math_fround(1.0);
         i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
         i17 = f19 < Math_fround(0.0);
         i18 = f19 > Math_fround(1.0);
         i18 = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         HEAP8[i1 >> 0] = i10 ? 0 : i14;
         HEAP8[i1 + 1 >> 0] = i15 ? 0 : i16;
         HEAP8[i1 + 2 >> 0] = i17 ? 0 : i18;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 1:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(1) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f19 = Math_fround(HEAPF32[i4 + 12 >> 2]);
         i17 = f19 < Math_fround(0.0);
         i18 = f19 > Math_fround(1.0);
         i18 = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
         HEAP8[i1 >> 0] = i17 ? 0 : i18;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 7:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(7) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f21 = Math_fround(HEAPF32[i4 >> 2]);
         f20 = Math_fround(HEAPF32[i4 + 4 >> 2]);
         f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
         i15 = f21 < Math_fround(0.0);
         i16 = f21 > Math_fround(1.0);
         i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f21) * Math_fround(31.0)) + Math_fround(.5)) >>> 0;
         i10 = f20 < Math_fround(0.0);
         i14 = f20 > Math_fround(1.0);
         i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f20) * Math_fround(63.0)) + Math_fround(.5)) >>> 0;
         i17 = f19 < Math_fround(0.0);
         i18 = f19 > Math_fround(1.0);
         i18 = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f19) * Math_fround(31.0)) + Math_fround(.5)) >>> 0;
         HEAP16[i1 >> 1] = (i10 ? 0 : i14 << 5) | (i15 ? 0 : i16 << 11) | (i17 ? 0 : i18);
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 15:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(15) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         i17 = HEAP32[i4 >> 2] | 0;
         i18 = i17 >>> 23 & 255;
         HEAP16[i1 >> 1] = HEAPU16[gb + 1477124 + (i18 << 1) >> 1] | 0 | i17 >>> 16 & 32768 | (i17 & 8388607) >>> (HEAPU8[gb + 1546331 + i18 >> 0] | 0);
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 16:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(16) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         i18 = HEAP32[i4 >> 2] | 0;
         i17 = i18 >>> 23 & 255;
         HEAP16[i1 >> 1] = HEAPU16[gb + 1477124 + (i17 << 1) >> 1] | 0 | i18 >>> 16 & 32768 | (i18 & 8388607) >>> (HEAPU8[gb + 1546331 + i17 >> 0] | 0);
         i17 = HEAP32[i4 + 4 >> 2] | 0;
         i18 = i17 >>> 23 & 255;
         HEAP16[i1 + 2 >> 1] = HEAPU16[gb + 1477124 + (i18 << 1) >> 1] | 0 | i17 >>> 16 & 32768 | (i17 & 8388607) >>> (HEAPU8[gb + 1546331 + i18 >> 0] | 0);
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 17:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(17) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         i18 = HEAP32[i4 >> 2] | 0;
         i17 = i18 >>> 23 & 255;
         HEAP16[i1 >> 1] = HEAPU16[gb + 1477124 + (i17 << 1) >> 1] | 0 | i18 >>> 16 & 32768 | (i18 & 8388607) >>> (HEAPU8[gb + 1546331 + i17 >> 0] | 0);
         i17 = HEAP32[i4 + 4 >> 2] | 0;
         i18 = i17 >>> 23 & 255;
         HEAP16[i1 + 2 >> 1] = HEAPU16[gb + 1477124 + (i18 << 1) >> 1] | 0 | i17 >>> 16 & 32768 | (i17 & 8388607) >>> (HEAPU8[gb + 1546331 + i18 >> 0] | 0);
         i18 = HEAP32[i4 + 8 >> 2] | 0;
         i17 = i18 >>> 23 & 255;
         HEAP16[i1 + 4 >> 1] = HEAPU16[gb + 1477124 + (i17 << 1) >> 1] | 0 | i18 >>> 16 & 32768 | (i18 & 8388607) >>> (HEAPU8[gb + 1546331 + i17 >> 0] | 0);
         i17 = HEAP32[i4 + 12 >> 2] | 0;
         i18 = i17 >>> 23 & 255;
         HEAP16[i1 + 6 >> 1] = HEAPU16[gb + 1477124 + (i18 << 1) >> 1] | 0 | i17 >>> 16 & 32768 | (i17 & 8388607) >>> (HEAPU8[gb + 1546331 + i18 >> 0] | 0);
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 18:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(18) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 19:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(19) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     case 20:
      {
       i7 = __Z25GetBytesFromTextureFormat13TextureFormat(20) | 0;
       if (!((i12 | 0) > 0 & (i13 | 0) > 0)) {
        i18 = 1;
        return i18 | 0;
       }
       i6 = 0;
       i5 = i4 + (Math_imul(i11, i10) | 0) + (Math_imul(i7, i9) | 0) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i12 | 0)) break; else {
          i1 = i1 + i7 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i1 = 1;
         break;
        } else {
         i5 = i5 + i11 | 0;
         i2 = i2 + (i12 << 4) | 0;
        }
       }
       return i1 | 0;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 404494 | 0, 1893, 1, 0, 0, 0);
       i18 = 0;
       return i18 | 0;
      }
     } while (0);
    }
   }
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 404730 | 0, 0, gb + 404494 | 0, 1873, 1, 0, 0, 0);
  i18 = 0;
  return i18 | 0;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 404494 | 0, 1855, 1, 0, 0, 0);
 i18 = 0;
 return i18 | 0;
}

function __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i1, i2, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 L1 : while (1) {
  i16 = i2;
  i21 = i2 + -20 | 0;
  i17 = i2 + -40 | 0;
  i18 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i15 = i1;
    i3 = i16 - i15 | 0;
    switch ((i3 | 0) / 20 | 0 | 0) {
    case 2:
     {
      i20 = 5;
      break L1;
     }
    case 3:
     {
      i20 = 11;
      break L1;
     }
    case 4:
     {
      i20 = 12;
      break L1;
     }
    case 5:
     {
      i20 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i20 = 115;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 620) {
     i20 = 15;
     break L1;
    }
    i4 = (i3 >>> 0) / 40 | 0;
    i11 = i1 + (i4 * 20 | 0) | 0;
    if ((i3 | 0) > 19980) {
     i3 = (i3 >>> 0) / 80 | 0;
     i3 = __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 * 20 | 0) | 0, i11, i11 + (i3 * 20 | 0) | 0, i21, i19) | 0;
    } else i3 = __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i1, i11, i21, i19) | 0;
    i14 = i1 + 16 | 0;
    i10 = HEAP32[i14 >> 2] | 0;
    i13 = i10 & 255;
    i4 = HEAP32[i1 + (i4 * 20 | 0) + 16 >> 2] | 0;
    i8 = i4 & 255;
    i12 = (i10 & 65535) >>> 8 & 255;
    i9 = (i4 & 65535) >>> 8 & 255;
    do if (i13 << 24 >> 24 == i8 << 24 >> 24) if (i12 << 24 >> 24 == i9 << 24 >> 24) if ((i10 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) {
     i4 = i21;
     break L5;
    } else break; else if ((i12 & 255) < (i9 & 255)) {
     i4 = i21;
     break L5;
    } else break; else if ((i13 & 255) < (i8 & 255)) {
     i4 = i21;
     break L5;
    } while (0);
    L20 : do if ((i1 | 0) != (i17 | 0)) {
     if (!(i4 & 65536)) {
      i5 = i21;
      i4 = i17;
      while (1) {
       i5 = HEAP32[i5 + -4 >> 2] | 0;
       i6 = i5 & 255;
       if (i6 << 24 >> 24 == i8 << 24 >> 24) {
        if (((i5 & 65535) >>> 8 & 255) < (i9 & 255)) {
         i20 = 77;
         break L5;
        }
       } else if ((i6 & 255) < (i8 & 255)) {
        i20 = 77;
        break L5;
       }
       i5 = i4 + -20 | 0;
       if ((i1 | 0) == (i5 | 0)) break L20; else {
        i7 = i4;
        i4 = i5;
        i5 = i7;
       }
      }
     } else {
      i5 = i21;
      i4 = i17;
     }
     while (1) {
      i5 = HEAP32[i5 + -4 >> 2] | 0;
      i6 = i5 & 255;
      i7 = (i5 & 65535) >>> 8 & 255;
      do if (i6 << 24 >> 24 == i8 << 24 >> 24) if (i7 << 24 >> 24 == i9 << 24 >> 24) if (!(i5 & 65536)) {
       i20 = 77;
       break L5;
      } else break; else if ((i7 & 255) < (i9 & 255)) {
       i20 = 77;
       break L5;
      } else break; else if ((i6 & 255) < (i8 & 255)) {
       i20 = 77;
       break L5;
      } while (0);
      i5 = i4 + -20 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i7 = i4;
       i4 = i5;
       i5 = i7;
      }
     }
    } while (0);
    i1 = i1 + 20 | 0;
    i3 = HEAP32[i18 >> 2] | 0;
    i4 = i3 & 255;
    i5 = (i3 & 65535) >>> 8 & 255;
    do if (i13 << 24 >> 24 == i4 << 24 >> 24) if (i12 << 24 >> 24 == i5 << 24 >> 24) if ((i10 & 65536 | 0) == 0 & (i3 & 65536 | 0) != 0) break; else {
     i20 = 37;
     break;
    } else if ((i12 & 255) < (i5 & 255)) break; else {
     i20 = 37;
     break;
    } else if ((i13 & 255) >= (i4 & 255)) i20 = 37; while (0);
    if ((i20 | 0) == 37) {
     i20 = 0;
     if ((i1 | 0) == (i21 | 0)) {
      i20 = 115;
      break L1;
     }
     L48 : do if (!(i10 & 65536)) while (1) {
      i5 = HEAP32[i1 + 16 >> 2] | 0;
      i3 = i5 & 255;
      i4 = (i5 & 65535) >>> 8 & 255;
      do if (i13 << 24 >> 24 == i3 << 24 >> 24) if (i12 << 24 >> 24 == i4 << 24 >> 24) if (!(i5 & 65536)) break; else break L48; else if ((i12 & 255) < (i4 & 255)) break L48; else break; else if ((i13 & 255) < (i3 & 255)) break L48; while (0);
      i1 = i1 + 20 | 0;
      if ((i1 | 0) == (i21 | 0)) {
       i20 = 115;
       break L1;
      }
     } else while (1) {
      i3 = HEAP32[i1 + 16 >> 2] | 0;
      i4 = i3 & 255;
      if (i13 << 24 >> 24 == i4 << 24 >> 24) {
       if ((i12 & 255) < ((i3 & 65535) >>> 8 & 255)) break L48;
      } else if ((i13 & 255) < (i4 & 255)) break L48;
      i1 = i1 + 20 | 0;
      if ((i1 | 0) == (i21 | 0)) {
       i20 = 115;
       break L1;
      }
     } while (0);
     HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP16[i1 + 16 >> 1] = HEAP16[i21 + 16 >> 1] | 0;
     HEAP8[i1 + 18 >> 0] = HEAP8[i21 + 18 >> 0] | 0;
     HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
     HEAP16[i21 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
     HEAP8[i21 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
     i1 = i1 + 20 | 0;
    }
    if ((i1 | 0) == (i21 | 0)) {
     i20 = 115;
     break L1;
    } else i3 = i21;
    while (1) {
     i7 = HEAP32[i14 >> 2] | 0;
     i8 = i7 & 255;
     i9 = (i7 & 65535) >>> 8 & 255;
     i7 = (i7 & 65536 | 0) == 0;
     L68 : do if (i7) while (1) {
      i4 = HEAP32[i1 + 16 >> 2] | 0;
      i5 = i4 & 255;
      i6 = (i4 & 65535) >>> 8 & 255;
      do if (i8 << 24 >> 24 == i5 << 24 >> 24) if (i9 << 24 >> 24 == i6 << 24 >> 24) if (!(i4 & 65536)) break; else break L68; else if ((i9 & 255) < (i6 & 255)) break L68; else break; else if ((i8 & 255) < (i5 & 255)) break L68; while (0);
      i1 = i1 + 20 | 0;
     } else while (1) {
      i4 = HEAP32[i1 + 16 >> 2] | 0;
      i5 = i4 & 255;
      if (i8 << 24 >> 24 == i5 << 24 >> 24) {
       if ((i9 & 255) < ((i4 & 65535) >>> 8 & 255)) break L68;
      } else if ((i8 & 255) < (i5 & 255)) break L68;
      i1 = i1 + 20 | 0;
     } while (0);
     if (i7) while (1) {
      i6 = i3 + -20 | 0;
      i3 = HEAP32[i3 + -4 >> 2] | 0;
      i4 = i3 & 255;
      i5 = (i3 & 65535) >>> 8 & 255;
      if (i8 << 24 >> 24 != i4 << 24 >> 24) if ((i8 & 255) < (i4 & 255)) {
       i3 = i6;
       continue;
      } else {
       i3 = i6;
       break;
      }
      if (i9 << 24 >> 24 == i5 << 24 >> 24) if (!(i3 & 65536)) {
       i3 = i6;
       break;
      } else {
       i3 = i6;
       continue;
      } else if ((i9 & 255) < (i5 & 255)) {
       i3 = i6;
       continue;
      } else {
       i3 = i6;
       break;
      }
     } else while (1) {
      i5 = i3 + -20 | 0;
      i3 = HEAP32[i3 + -4 >> 2] | 0;
      i4 = i3 & 255;
      if (i8 << 24 >> 24 == i4 << 24 >> 24) if ((i9 & 255) < ((i3 & 65535) >>> 8 & 255)) {
       i3 = i5;
       continue;
      } else {
       i3 = i5;
       break;
      } else if ((i8 & 255) < (i4 & 255)) {
       i3 = i5;
       continue;
      } else {
       i3 = i5;
       break;
      }
     }
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i22 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i22 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP16[i1 + 16 >> 1] = HEAP16[i3 + 16 >> 1] | 0;
     HEAP8[i1 + 18 >> 0] = HEAP8[i3 + 18 >> 0] | 0;
     HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
     HEAP16[i3 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
     HEAP8[i3 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
     i1 = i1 + 20 | 0;
    }
   }
   if ((i20 | 0) == 77) {
    i20 = 0;
    HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP16[i1 + 16 >> 1] = HEAP16[i4 + 16 >> 1] | 0;
    HEAP8[i1 + 18 >> 0] = HEAP8[i4 + 18 >> 0] | 0;
    HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
    HEAP16[i4 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
    HEAP8[i4 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 20 | 0;
   L104 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i9 = HEAP32[i11 + 16 >> 2] | 0;
    i10 = i9 & 255;
    i12 = (i9 & 65535) >>> 8 & 255;
    i9 = (i9 & 65536 | 0) == 0;
    L107 : do if (i9) while (1) {
     i6 = HEAP32[i5 + 16 >> 2] | 0;
     i7 = i6 & 255;
     if (i7 << 24 >> 24 == i10 << 24 >> 24) {
      if (((i6 & 65535) >>> 8 & 255) >= (i12 & 255)) break L107;
     } else if ((i7 & 255) >= (i10 & 255)) break L107;
     i5 = i5 + 20 | 0;
    } else while (1) {
     i6 = HEAP32[i5 + 16 >> 2] | 0;
     i7 = i6 & 255;
     i8 = (i6 & 65535) >>> 8 & 255;
     do if (i7 << 24 >> 24 == i10 << 24 >> 24) if (i8 << 24 >> 24 == i12 << 24 >> 24) if (!(i6 & 65536)) break; else break L107; else if ((i8 & 255) < (i12 & 255)) break; else break L107; else if ((i7 & 255) >= (i10 & 255)) break L107; while (0);
     i5 = i5 + 20 | 0;
    } while (0);
    if (i9) while (1) {
     i7 = i4 + -20 | 0;
     i4 = HEAP32[i4 + -4 >> 2] | 0;
     i6 = i4 & 255;
     if (i6 << 24 >> 24 == i10 << 24 >> 24) if (((i4 & 65535) >>> 8 & 255) < (i12 & 255)) {
      i4 = i7;
      break;
     } else {
      i4 = i7;
      continue;
     } else if ((i6 & 255) < (i10 & 255)) {
      i4 = i7;
      break;
     } else {
      i4 = i7;
      continue;
     }
    } else while (1) {
     i8 = i4 + -20 | 0;
     i4 = HEAP32[i4 + -4 >> 2] | 0;
     i6 = i4 & 255;
     i7 = (i4 & 65535) >>> 8 & 255;
     if (i6 << 24 >> 24 != i10 << 24 >> 24) if ((i6 & 255) < (i10 & 255)) {
      i4 = i8;
      break;
     } else {
      i4 = i8;
      continue;
     }
     if (i7 << 24 >> 24 == i12 << 24 >> 24) if (!(i4 & 65536)) {
      i4 = i8;
      break;
     } else {
      i4 = i8;
      continue;
     } else if ((i7 & 255) < (i12 & 255)) {
      i4 = i8;
      break;
     } else {
      i4 = i8;
      continue;
     }
    }
    if (i5 >>> 0 > i4 >>> 0) break L104;
    HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP16[i5 + 16 >> 1] = HEAP16[i4 + 16 >> 1] | 0;
    HEAP8[i5 + 18 >> 0] = HEAP8[i4 + 18 >> 0] | 0;
    HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
    HEAP16[i4 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
    HEAP8[i4 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
    i11 = (i11 | 0) == (i5 | 0) ? i4 : i11;
    i5 = i5 + 20 | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   L141 : do if ((i5 | 0) != (i11 | 0)) {
    i4 = HEAP32[i11 + 16 >> 2] | 0;
    i6 = i4 & 255;
    i7 = HEAP32[i5 + 16 >> 2] | 0;
    i8 = i7 & 255;
    i9 = (i4 & 65535) >>> 8 & 255;
    i10 = (i7 & 65535) >>> 8 & 255;
    do if (i6 << 24 >> 24 == i8 << 24 >> 24) if (i9 << 24 >> 24 == i10 << 24 >> 24) if ((i4 & 65536 | 0) == 0 & (i7 & 65536 | 0) != 0) break; else break L141; else if ((i9 & 255) < (i10 & 255)) break; else break L141; else if ((i6 & 255) >= (i8 & 255)) break L141; while (0);
    HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP16[i5 + 16 >> 1] = HEAP16[i11 + 16 >> 1] | 0;
    HEAP8[i5 + 18 >> 0] = HEAP8[i11 + 18 >> 0] | 0;
    HEAP32[i11 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
    HEAP16[i11 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
    HEAP8[i11 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEbT0_S6_T_(i1, i5, i19) | 0;
    i4 = i5 + 20 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEbT0_S6_T_(i4, i2, i19) | 0) {
     i20 = 114;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i14 = i5;
   if ((i14 - i15 | 0) >= (i16 - i14 | 0)) {
    i20 = 113;
    break;
   }
   __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i1, i5, i19);
   i1 = i5 + 20 | 0;
  }
  if ((i20 | 0) == 113) {
   i20 = 0;
   __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i5 + 20 | 0, i2, i19);
   i2 = i5;
   continue;
  } else if ((i20 | 0) == 114) {
   i20 = 0;
   if (i3) {
    i20 = 115;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i20 | 0) == 5) {
  i2 = HEAP32[i18 >> 2] | 0;
  i3 = i2 & 255;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  i5 = i4 & 255;
  i6 = (i2 & 65535) >>> 8 & 255;
  i7 = (i4 & 65535) >>> 8 & 255;
  do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
   if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
   STACKTOP = i23;
   return;
  } else {
   if ((i6 & 255) < (i7 & 255)) break;
   STACKTOP = i23;
   return;
  } else if ((i3 & 255) >= (i5 & 255)) {
   STACKTOP = i23;
   return;
  } while (0);
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP16[i1 + 16 >> 1] = HEAP16[i21 + 16 >> 1] | 0;
  HEAP8[i1 + 18 >> 0] = HEAP8[i21 + 18 >> 0] | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  HEAP16[i21 + 16 >> 1] = HEAP16[i22 + 16 >> 1] | 0;
  HEAP8[i21 + 18 >> 0] = HEAP8[i22 + 18 >> 0] | 0;
  STACKTOP = i23;
  return;
 } else if ((i20 | 0) == 11) {
  __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i1, i1 + 20 | 0, i21, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i20 | 0) == 12) {
  __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i21, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i20 | 0) == 13) {
  __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i1 + 60 | 0, i21, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i20 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i1, i2, i19);
  STACKTOP = i23;
  return;
 } else if ((i20 | 0) == 115) {
  STACKTOP = i23;
  return;
 }
}

function __ZN5Unity17ConfigurableJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 348 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 352 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 356 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 108 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 112 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 116 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 140 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 144 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i3 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 148 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 152 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 156 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 160 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 164 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 168 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 172 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 176 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 180 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 184 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 188 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 192 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 196 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 200 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 296 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 300 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 324 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 328 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 332 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 204 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 208 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 212 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 216 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 220 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 224 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 228 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 232 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 236 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i6, i5 + 308 | 0, gb + 735246 | 0, 0);
 i1 = i5 + 336 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 340 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 344 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 252 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 256 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 260 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 240 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 244 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 248 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 264 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 268 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 272 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 276 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 280 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 284 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 292 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 293 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
  return;
 }
}

function __Z28DeoptimizeTransformHierarchyR10GameObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i43 + 32 | 0;
 i33 = i43 + 24 | 0;
 i39 = i43;
 i42 = i43 + 88 | 0;
 i38 = i43 + 68 | 0;
 i30 = i43 + 56 | 0;
 i31 = i43 + 44 | 0;
 i32 = i43 + 104 | 0;
 i37 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 67008 | 0) | 0;
 if (!i37) {
  STACKTOP = i43;
  return;
 }
 if (!(__ZNK8Animator13IsOptimizableEv(i37) | 0)) {
  STACKTOP = i43;
  return;
 }
 if (HEAP8[i37 + 561 >> 0] | 0) {
  STACKTOP = i43;
  return;
 }
 i1 = __ZN8Animator13GetAvatarRootEv(i37) | 0;
 if (!i1) {
  STACKTOP = i43;
  return;
 }
 i35 = HEAP32[i1 + 28 >> 2] | 0;
 i28 = __ZN8Animator9GetAvatarEv(i37) | 0;
 i1 = __ZNK6Avatar6GetTOSEv(i28) | 0;
 i28 = __ZNK6Avatar8GetAssetEv(i28) | 0;
 i36 = (HEAP32[i28 >> 2] | 0) + i28 | 0;
 i28 = i28 + 8 | 0;
 i28 = (HEAP32[i28 >> 2] | 0) + i28 | 0;
 HEAP32[i42 >> 2] = 0;
 i40 = i42 + 4 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 HEAP32[i42 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 if (HEAP32[i36 >> 2] | 0) {
  i20 = i39 + 12 | 0;
  i21 = i39 + 11 | 0;
  i22 = i36 + 8 | 0;
  i7 = i1 + 4 | 0;
  i8 = i38 + 12 | 0;
  i6 = i38 + 12 | 0;
  i9 = i41 + 4 | 0;
  i10 = i38 + 8 | 0;
  i11 = i38 + 4 | 0;
  i12 = i42 + 8 | 0;
  i13 = i38 + 11 | 0;
  i14 = i41 + 4 | 0;
  i15 = i39 + 12 | 0;
  i16 = i41 + 4 | 0;
  i17 = i41 + 4 | 0;
  i18 = i22;
  i19 = i39 + 4 | 0;
  i5 = 0;
  do {
   HEAP32[i39 >> 2] = 0;
   HEAP32[i39 + 4 >> 2] = 0;
   HEAP32[i39 + 8 >> 2] = 0;
   HEAP32[i20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i21 >> 0] = 0;
   HEAP8[i39 >> 0] = 0;
   i1 = HEAP32[i7 >> 2] | 0;
   do if (!i1) i1 = 0; else {
    i4 = HEAP32[(HEAP32[i22 >> 2] | 0) + i18 + (i5 << 2) >> 2] | 0;
    i2 = i7;
    L19 : while (1) {
     i3 = i1;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
      i1 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i1) break L19; else i3 = i1;
     }
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      break;
     } else i2 = i3;
    }
    if ((i2 | 0) == (i7 | 0)) i1 = 0; else if (i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) i1 = 0; else {
     i1 = i2 + 20 | 0;
     if ((i39 | 0) == (i1 | 0)) i1 = 0; else {
      i29 = HEAP8[i1 + 11 >> 0] | 0;
      i27 = i29 << 24 >> 24 < 0;
      i1 = i27 ? HEAP32[i1 >> 2] | 0 : i1;
      i2 = i27 ? HEAP32[i2 + 24 >> 2] | 0 : i29 & 255;
      if (i2 >>> 0 > 10) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i39, 10, i2 + -10 | 0, 0, 0, 0, i2, i1);
       i1 = HEAP8[i21 >> 0] | 0;
       break;
      }
      if (i2 | 0) _memmove(i39 | 0, i1 | 0, i2 | 0) | 0;
      HEAP8[i39 + i2 >> 0] = 0;
      i1 = HEAP8[i21 >> 0] | 0;
      if (i1 << 24 >> 24 < 0) {
       HEAP32[i19 >> 2] = i2;
       break;
      } else {
       i1 = i2 & 255;
       HEAP8[i21 >> 0] = i1;
       break;
      }
     }
    }
   } while (0);
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i39 >> 2] | 0 : i39;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
    i1 = HEAP32[i6 >> 2] | 0;
    i34 = 28;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i13 >> 0] = i3;
    if (!i3) i1 = i38; else {
     i1 = i38;
     i34 = 30;
    }
   } else i34 = 28;
   if ((i34 | 0) == 28) {
    i29 = i3 + 16 & -16;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i9 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i41, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i38 >> 2] = i1;
    HEAP32[i10 >> 2] = i29 | -2147483648;
    HEAP32[i11 >> 2] = i3;
    i34 = 30;
   }
   if ((i34 | 0) == 30) {
    i34 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i40 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i42, i38); else {
    i4 = HEAP8[i13 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i38 >> 2] | 0 : i38;
    i4 = i2 ? HEAP32[i11 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i34 = 35;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i34 = 37;
    } else i34 = 35;
    if ((i34 | 0) == 35) {
     i27 = i4 + 16 & -16;
     HEAP32[i41 >> 2] = 66;
     HEAP32[i17 >> 2] = i2;
     i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i27, 16, i41, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i29;
     HEAP32[i1 + 8 >> 2] = i27 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i29;
     i34 = 37;
    }
    if ((i34 | 0) == 37) {
     i34 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + 16;
   }
   if ((HEAP8[i13 >> 0] | 0) < 0) {
    i29 = HEAP32[i38 >> 2] | 0;
    i27 = HEAP32[i6 >> 2] | 0;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i14 >> 2] = i27;
    __Z19free_alloc_internalPvRK10MemLabelId(i29, i41);
   }
   if ((HEAP8[i21 >> 0] | 0) < 0) {
    i29 = HEAP32[i39 >> 2] | 0;
    i27 = HEAP32[i15 >> 2] | 0;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i16 >> 2] = i27;
    __Z19free_alloc_internalPvRK10MemLabelId(i29, i41);
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i36 >> 2] | 0) >>> 0);
 }
 i29 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i35, gb + 28940 | 0) | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 if ((HEAP32[i40 >> 2] | 0) - i1 >> 4 >>> 0 > 1) {
  i14 = i38 + 11 | 0;
  i15 = i38 + 4 | 0;
  i16 = i39 + 12 | 0;
  i12 = i39 + 12 | 0;
  i17 = i41 + 4 | 0;
  i18 = i39 + 8 | 0;
  i19 = i39 + 4 | 0;
  i20 = i39 + 11 | 0;
  i21 = i30 + 11 | 0;
  i22 = i30 + 4 | 0;
  i23 = i38 + 12 | 0;
  i13 = i38 + 12 | 0;
  i24 = i41 + 4 | 0;
  i25 = i38 + 8 | 0;
  i26 = i38 + 4 | 0;
  i27 = i38 + 11 | 0;
  i8 = i28 + 4 | 0;
  i9 = i8;
  i10 = i41 + 4 | 0;
  i11 = i41 + 4 | 0;
  i7 = 1;
  do {
   i4 = i1 + (i7 << 4) | 0;
   i6 = i4 + 11 | 0;
   i2 = HEAP8[i6 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i3 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i1 + (i7 << 4) + 4 >> 2] | 0;
   } else {
    i3 = i4;
    i2 = i2 & 255;
   };
   HEAP32[i30 >> 2] = 0;
   HEAP32[i30 + 4 >> 2] = 0;
   HEAP32[i30 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i30, i3, i2);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i38, i30);
   i5 = HEAP8[i14 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i38 >> 2] | 0 : i38;
   i5 = i2 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
   HEAP32[i39 >> 2] = 0;
   HEAP32[i39 + 4 >> 2] = 0;
   HEAP32[i39 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
    i2 = HEAP32[i12 >> 2] | 0;
    i34 = 53;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i20 >> 0] = i5;
    if (!i5) i2 = i39; else {
     i2 = i39;
     i34 = 55;
    }
   } else i34 = 53;
   if ((i34 | 0) == 53) {
    i28 = i5 + 16 & -16;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i17 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i28, 16, i41, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i39 >> 2] = i2;
    HEAP32[i18 >> 2] = i28 | -2147483648;
    HEAP32[i19 >> 2] = i5;
    i34 = 55;
   }
   if ((i34 | 0) == 55) {
    i34 = 0;
    _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
   i2 = __Z21FindTransformWithNameP9TransformPKc(i29, (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i39 >> 2] | 0 : i39) | 0;
   if (!i2) {
    i2 = HEAP8[i20 >> 0] | 0;
    i5 = i2 << 24 >> 24 < 0;
    i28 = i5 ? HEAP32[i39 >> 2] | 0 : i39;
    i2 = i5 ? HEAP32[i19 >> 2] | 0 : i2 & 255;
    HEAP32[i41 >> 2] = 0;
    HEAP32[i41 + 4 >> 2] = 0;
    HEAP32[i41 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i41, i28, i2);
    HEAP32[i33 >> 2] = 0;
    i2 = __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz(i41, 1, 0, gb + 1044255 | 0, i33) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i41);
    i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
   }
   i3 = HEAP8[i6 >> 0] | 0;
   if (i3 << 24 >> 24 < 0) {
    i4 = HEAP32[i4 >> 2] | 0;
    i1 = HEAP32[i1 + (i7 << 4) + 4 >> 2] | 0;
   } else i1 = i3 & 255;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 0;
   HEAP32[i31 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, i4, i1);
   __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i30, i31);
   i4 = HEAP8[i21 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i30 >> 2] | 0 : i30;
   i4 = i1 ? HEAP32[i22 >> 2] | 0 : i4 & 255;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i23 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
    i1 = HEAP32[i13 >> 2] | 0;
    i34 = 64;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i27 >> 0] = i4;
    if (!i4) i1 = i38; else {
     i1 = i38;
     i34 = 66;
    }
   } else i34 = 64;
   if ((i34 | 0) == 64) {
    i28 = i4 + 16 & -16;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i24 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i28, 16, i41, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i38 >> 2] = i1;
    HEAP32[i25 >> 2] = i28 | -2147483648;
    HEAP32[i26 >> 2] = i4;
    i34 = 66;
   }
   if ((i34 | 0) == 66) {
    i34 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
   i28 = HEAP8[i27 >> 0] | 0;
   i1 = i28 << 24 >> 24 < 0;
   if (!((i1 ? HEAP32[i26 >> 2] | 0 : i28 & 255) | 0)) i1 = i29; else i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i29, i1 ? HEAP32[i38 >> 2] | 0 : i38, 0) | 0;
   __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i2, i1, 1) | 0;
   __ZN9Transform18GetTransformAccessEv(i32, i2);
   i28 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
   HEAP32[i41 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i41 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   __Z11SetLocalTRS15TransformAccessRKN4math7_float3ERKNS0_7_float4ES3_(i41, i28 + (i7 * 40 | 0) | 0, i28 + (i7 * 40 | 0) + 12 | 0, i28 + (i7 * 40 | 0) + 28 | 0) | 0;
   if ((HEAP8[i27 >> 0] | 0) < 0) {
    i28 = HEAP32[i38 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i10 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i28, i41);
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i28 = HEAP32[i39 >> 2] | 0;
    i6 = HEAP32[i12 >> 2] | 0;
    HEAP32[i41 >> 2] = 66;
    HEAP32[i11 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i28, i41);
   }
   i7 = i7 + 1 | 0;
   i1 = HEAP32[i42 >> 2] | 0;
  } while (i7 >>> 0 < (HEAP32[i40 >> 2] | 0) - i1 >> 4 >>> 0);
 }
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i39;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i38 >> 2] = 0;
 i10 = i38 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i38 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i38 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i41, i39);
 i32 = i41;
 i33 = HEAP32[i32 + 4 >> 2] | 0;
 i34 = i12;
 HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i34 + 4 >> 2] = i33;
 __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i35, 1, __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(137) | 0, i38);
 if (HEAP32[i10 >> 2] | 0) {
  i6 = i39 + 12 | 0;
  i7 = i39 + 16 | 0;
  i8 = i39 + 4 | 0;
  i5 = 0;
  do {
   i9 = HEAP32[(HEAP32[i38 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i4 = __ZN19SkinnedMeshRenderer7GetMeshEv(i9) | 0;
   i2 = (i4 | 0) != 0;
   if (i2) {
    i1 = HEAP32[i4 + 184 >> 2] | 0;
    if (!i1) i1 = 0; else {
     i1 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i36, i1) | 0;
     i1 = (HEAP32[i42 >> 2] | 0) + (i1 << 4) | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i29, i1, 0) | 0;
    }
   } else i1 = 0;
   if ((i1 | 0) != (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0)) __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform(i9, i1);
   if (i2) {
    HEAP32[i39 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i41, gb + 63664 | 0);
    i3 = i41;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i1 = i8;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = i2;
    i1 = HEAP32[i4 + 156 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i1;
    i3 = HEAP32[i7 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i39 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i39 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i35 | 0, HEAP32[i39 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i39 >> 2] = i35;
     break;
    } while (0);
    if (i1 >>> 0 > i2 >>> 0) _memset((HEAP32[i39 >> 2] | 0) + (i2 << 2) | 0, 0, i1 - i2 << 2 | 0) | 0;
    if (HEAP32[i6 >> 2] | 0) {
     i3 = i4 + 144 | 0;
     i2 = 0;
     do {
      i1 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i36, HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0;
      i1 = (HEAP32[i42 >> 2] | 0) + (i1 << 4) | 0;
      if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
      i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i29, i1, 0) | 0;
      if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
      HEAP32[(HEAP32[i39 >> 2] | 0) + (i2 << 2) >> 2] = i1;
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
    }
    __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE(i9, i39);
    if ((HEAP32[i7 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i8);
     HEAP32[i39 >> 2] = 0;
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 __ZN8Animator24SetHasTransformHierarchyEb(i37, 1);
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i12);
  HEAP32[i38 >> 2] = 0;
 }
 i1 = HEAP32[i42 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i40 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i4 = i41 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i40 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i39 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i41 >> 2] = 66;
     HEAP32[i4 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i39, i41);
     i2 = HEAP32[i40 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i42 >> 2] | 0;
  }
  i42 = HEAP32[i42 + 12 >> 2] | 0;
  HEAP32[i41 >> 2] = 1;
  HEAP32[i41 + 4 >> 2] = i42;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i41);
 }
 STACKTOP = i43;
 return;
}

function __Z24sweepBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i14, i17, i12, i19, f13, i18, i15, f16) {
 i14 = i14 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i19 = i19 | 0;
 f13 = Math_fround(f13);
 i18 = i18 | 0;
 i15 = i15 | 0;
 f16 = Math_fround(f16);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i20 + 192 | 0;
 i11 = i20 + 340 | 0;
 i1 = i20 + 160 | 0;
 i49 = i20;
 i25 = i20 + 320 | 0;
 i51 = i20 + 308 | 0;
 i24 = i20 + 296 | 0;
 i21 = i20 + 284 | 0;
 i23 = i20 + 272 | 0;
 f37 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 >> 2])));
 f47 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 + 4 >> 2])));
 f36 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 + 8 >> 2])));
 i52 = i12 + 12 | 0;
 f40 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 >> 2])));
 f26 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 + 4 >> 2])));
 f46 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 + 8 >> 2])));
 i52 = i12 + 24 | 0;
 f44 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 >> 2])));
 f41 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 + 4 >> 2])));
 f33 = Math_fround(Math_abs(Math_fround(HEAPF32[i52 + 8 >> 2])));
 f45 = Math_fround(HEAPF32[i12 + 48 >> 2]);
 i52 = i12 + 52 | 0;
 f39 = Math_fround(HEAPF32[i52 >> 2]);
 i9 = i12 + 56 | 0;
 f38 = Math_fround(HEAPF32[i9 >> 2]);
 f44 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f45) + Math_fround(f40 * f39)) + Math_fround(f44 * f38)) + f16);
 f41 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f45) + Math_fround(f26 * f39)) + Math_fround(f41 * f38)) + f16);
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f45) + Math_fround(f46 * f39)) + Math_fround(f33 * f38)) + f16);
 i50 = i14 + 20 | 0;
 i10 = (HEAP8[i50 >> 0] & 2) != 0;
 i48 = i12 + 36 | 0;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i22, i12);
 i54 = HEAP32[i22 >> 2] | 0;
 HEAP32[i11 >> 2] = i54;
 i2 = i11 + 4 | 0;
 i53 = HEAP32[i22 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i53;
 i3 = i11 + 8 | 0;
 i8 = HEAP32[i22 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = i8;
 i4 = i11 + 12 | 0;
 i7 = HEAP32[i22 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = i7;
 i57 = HEAP32[i48 >> 2] | 0;
 HEAP32[i11 + 16 >> 2] = i57;
 i5 = i11 + 20 | 0;
 i29 = i12 + 40 | 0;
 i56 = HEAP32[i29 >> 2] | 0;
 HEAP32[i5 >> 2] = i56;
 i6 = i11 + 24 | 0;
 i30 = i12 + 44 | 0;
 i55 = HEAP32[i30 >> 2] | 0;
 HEAP32[i6 >> 2] = i55;
 f33 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f33 * Math_fround(-2.0));
 f39 = Math_fround(f39 * Math_fround(-2.0));
 f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(-2.0));
 f45 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(Math_fround(f45 * f45) + Math_fround(-.5));
 f26 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f33 * f26);
 f40 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f47 + Math_fround(f39 * f40));
 f37 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(f47 + Math_fround(f46 * f37));
 f34 = Math_fround(Math_fround(f26 * f47) + Math_fround(Math_fround(f33 * f36) - Math_fround(f45 * Math_fround(Math_fround(f46 * f40) - Math_fround(f39 * f37)))));
 f42 = Math_fround(Math_fround(f40 * f47) + Math_fround(Math_fround(f39 * f36) - Math_fround(f45 * Math_fround(Math_fround(f33 * f37) - Math_fround(f46 * f26)))));
 f47 = Math_fround(Math_fround(Math_fround(f46 * f36) - Math_fround(f45 * Math_fround(Math_fround(f39 * f26) - Math_fround(f33 * f40)))) + Math_fround(f37 * f47));
 f26 = Math_fround(-f26);
 f40 = Math_fround(-f40);
 f37 = Math_fround(-f37);
 HEAPF32[i1 >> 2] = f26;
 HEAPF32[i1 + 4 >> 2] = f40;
 HEAPF32[i1 + 8 >> 2] = f37;
 HEAP32[i1 + 12 >> 2] = i7;
 HEAPF32[i1 + 16 >> 2] = f34;
 HEAPF32[i1 + 20 >> 2] = f42;
 HEAPF32[i1 + 24 >> 2] = f47;
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 f47 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f13);
 i7 = i19 + 4 | 0;
 f42 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f13);
 i8 = i19 + 8 | 0;
 f47 = Math_fround(f47 * Math_fround(2.0));
 f42 = Math_fround(f42 * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f13) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(f47 * f26) + Math_fround(f42 * f40)) + Math_fround(f34 * f37));
 f39 = Math_fround(Math_fround(f33 * f26) + Math_fround(Math_fround(f36 * f47) + Math_fround(f45 * Math_fround(Math_fround(f34 * f40) - Math_fround(f42 * f37)))));
 f46 = Math_fround(Math_fround(f33 * f40) + Math_fround(Math_fround(f36 * f42) + Math_fround(f45 * Math_fround(Math_fround(f47 * f37) - Math_fround(f34 * f26)))));
 f37 = Math_fround(Math_fround(Math_fround(f36 * f34) + Math_fround(f45 * Math_fround(Math_fround(f42 * f26) - Math_fround(f47 * f40)))) + Math_fround(f33 * f37));
 HEAP32[i49 >> 2] = 0;
 HEAP32[i49 + 4 >> 2] = 0;
 HEAP32[i49 + 8 >> 2] = 0;
 HEAP32[i49 + 12 >> 2] = 0;
 i53 = HEAP32[i12 + 48 >> 2] | 0;
 i52 = HEAP32[i52 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i54 = i49 + 64 | 0;
 HEAP32[i49 + 80 >> 2] = 3;
 HEAPF32[i49 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i54 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i49 + 144 >> 2] = i53;
 HEAP32[i49 + 148 >> 2] = i52;
 HEAP32[i49 + 152 >> 2] = i9;
 HEAPF32[i49 + 156 >> 2] = Math_fround(0.0);
 f33 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = f33 <= f40 ? f33 : f40;
 f47 = f40 <= f47 ? f40 : f47;
 HEAPF32[i49 + 16 >> 2] = Math_fround(f47 * Math_fround(.150000006));
 HEAPF32[i49 + 32 >> 2] = Math_fround(f47 * Math_fround(.0500000007));
 i9 = i18 + 40 | 0;
 HEAPF32[i9 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i22 >> 2] = gb + 85320 + 8;
 HEAP32[i25 + 12 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i25 + 16 >> 2] = i14;
 HEAPF32[i25 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i14 + 8 >> 2]));
 HEAPF32[i25 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i14 + 12 >> 2]));
 HEAPF32[i25 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i14 + 16 >> 2]));
 HEAP32[i22 + 4 >> 2] = i1;
 i1 = i22 + 68 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i22 + 70 >> 0] = 0;
 HEAP32[i22 + 8 >> 2] = i17;
 HEAP32[i22 + 12 >> 2] = i25;
 HEAP32[i22 + 16 >> 2] = i49;
 HEAPF32[i22 + 48 >> 2] = f39;
 HEAPF32[i22 + 52 >> 2] = f46;
 HEAPF32[i22 + 56 >> 2] = f37;
 HEAP32[i22 + 60 >> 2] = i18;
 HEAPF32[i22 + 64 >> 2] = f16;
 HEAPF32[i22 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i49 = i22 + 36 | 0;
 HEAP32[i49 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
 i49 = HEAP16[i15 >> 1] | 0;
 HEAP8[i22 + 71 >> 0] = (i49 & 65535) >>> 6 & 1;
 HEAP8[i22 + 69 >> 0] = ((HEAPU8[i50 >> 0] | 0) >>> 1 | (i49 & 65535) >>> 7 & 255) & 1;
 f37 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 f46 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f37 = Math_fround(f37 * Math_fround(-2.0));
 f46 = Math_fround(f46 * Math_fround(-2.0));
 f39 = Math_fround(Math_fround(HEAPF32[i17 + 24 >> 2]) * Math_fround(-2.0));
 f47 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f40 = Math_fround(Math_fround(f47 * f47) + Math_fround(-.5));
 f33 = Math_fround(HEAPF32[i17 >> 2]);
 f26 = Math_fround(f37 * f33);
 f42 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f46 * f42));
 f45 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f39 * f45));
 f34 = Math_fround(Math_fround(f33 * f26) + Math_fround(Math_fround(f37 * f40) - Math_fround(f47 * Math_fround(Math_fround(f39 * f42) - Math_fround(f46 * f45)))));
 f36 = Math_fround(Math_fround(f42 * f26) + Math_fround(Math_fround(f46 * f40) - Math_fround(f47 * Math_fround(Math_fround(f37 * f45) - Math_fround(f39 * f33)))));
 f26 = Math_fround(Math_fround(Math_fround(f39 * f40) - Math_fround(f47 * Math_fround(Math_fround(f46 * f33) - Math_fround(f37 * f42)))) + Math_fround(f45 * f26));
 f37 = Math_fround(-f33);
 f46 = Math_fround(-f42);
 f39 = Math_fround(-f45);
 f31 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(2.0));
 f43 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(Math_fround(f31 * f37) + Math_fround(f32 * f46)) + Math_fround(f43 * f39));
 f34 = Math_fround(f34 + Math_fround(Math_fround(f35 * f37) + Math_fround(Math_fround(f40 * f31) + Math_fround(f47 * Math_fround(Math_fround(f43 * f46) - Math_fround(f32 * f39))))));
 f36 = Math_fround(f36 + Math_fround(Math_fround(f35 * f46) + Math_fround(Math_fround(f40 * f32) + Math_fround(f47 * Math_fround(Math_fround(f31 * f39) - Math_fround(f43 * f37))))));
 f35 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f40 * f43) + Math_fround(f47 * Math_fround(Math_fround(f32 * f37) - Math_fround(f31 * f46)))) + Math_fround(f35 * f39)));
 HEAPF32[i24 >> 2] = f34;
 i30 = i24 + 4 | 0;
 HEAPF32[i30 >> 2] = f36;
 i29 = i24 + 8 | 0;
 HEAPF32[i29 >> 2] = f35;
 f31 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(2.0));
 f43 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(Math_fround(f31 * f37) + Math_fround(f32 * f46)) + Math_fround(f43 * f39));
 f28 = Math_fround(Math_fround(f26 * f37) + Math_fround(Math_fround(f40 * f31) + Math_fround(f47 * Math_fround(Math_fround(f43 * f46) - Math_fround(f32 * f39)))));
 f27 = Math_fround(Math_fround(f26 * f46) + Math_fround(Math_fround(f40 * f32) + Math_fround(f47 * Math_fround(Math_fround(f31 * f39) - Math_fround(f43 * f37)))));
 f26 = Math_fround(Math_fround(Math_fround(f40 * f43) + Math_fround(f47 * Math_fround(Math_fround(f32 * f37) - Math_fround(f31 * f46)))) + Math_fround(f26 * f39));
 f33 = Math_fround(f37 - f33);
 f42 = Math_fround(f46 - f42);
 f45 = Math_fround(f39 - f45);
 f31 = Math_fround(f42 * f46);
 f32 = Math_fround(f45 * f39);
 f46 = Math_fround(f33 * f46);
 f43 = Math_fround(f33 * f39);
 f40 = Math_fround(f47 * f33);
 f39 = Math_fround(f42 * f39);
 f42 = Math_fround(f47 * f42);
 f45 = Math_fround(f47 * f45);
 f37 = Math_fround(Math_fround(1.0) - Math_fround(f33 * f37));
 f33 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f44 * Math_fround(Math_fround(Math_fround(1.0) - f31) - f32)))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f46 - f45))))) + Math_fround(Math_abs(Math_fround(f38 * Math_fround(f43 + f42)))));
 f32 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f44 * Math_fround(f46 + f45)))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f37 - f32))))) + Math_fround(Math_abs(Math_fround(f38 * Math_fround(f39 - f40)))));
 f31 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f44 * Math_fround(f43 - f42)))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f40 + f39))))) + Math_fround(Math_abs(Math_fround(f38 * Math_fround(f37 - f31)))));
 f32 = Math_fround(Math_fround(Math_fround(f32 + f36) - Math_fround(f36 - f32)) * Math_fround(.5));
 f31 = Math_fround(Math_fround(Math_fround(f35 + f31) - Math_fround(f35 - f31)) * Math_fround(.5));
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(Math_fround(f33 + f34) - Math_fround(f34 - f33)) * Math_fround(.5));
 HEAPF32[i21 + 4 >> 2] = f32;
 HEAPF32[i21 + 8 >> 2] = f31;
 f28 = Math_fround(f28 * f13);
 f27 = Math_fround(f27 * f13);
 f26 = Math_fround(f26 * f13);
 f28 = Math_fround(f28 + Math_fround(HEAPF32[i24 >> 2]));
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i30 >> 2]));
 f26 = Math_fround(f26 + Math_fround(HEAPF32[i29 >> 2]));
 HEAPF32[i23 >> 2] = f28;
 HEAPF32[i23 + 4 >> 2] = f27;
 HEAPF32[i23 + 8 >> 2] = f26;
 __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI21BoxTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i25, i24, i23, i22, i21);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i57 = 0;
  STACKTOP = i20;
  return i57 | 0;
 }
 if (!(i1 & 16711680)) {
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f13);
  i57 = i18 + 28 | 0;
  f45 = Math_fround(Math_fround(HEAPF32[i57 >> 2]) * Math_fround(2.0));
  i56 = i18 + 32 | 0;
  f37 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) * Math_fround(2.0));
  i55 = i18 + 36 | 0;
  f47 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * Math_fround(2.0));
  f39 = Math_fround(HEAPF32[i4 >> 2]);
  f38 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
  f41 = Math_fround(HEAPF32[i11 >> 2]);
  f46 = Math_fround(f45 * f41);
  f43 = Math_fround(HEAPF32[i2 >> 2]);
  f46 = Math_fround(f46 + Math_fround(f37 * f43));
  f44 = Math_fround(HEAPF32[i3 >> 2]);
  f46 = Math_fround(f46 + Math_fround(f47 * f44));
  f40 = Math_fround(Math_fround(f43 * f46) + Math_fround(Math_fround(f37 * f38) + Math_fround(f39 * Math_fround(Math_fround(f45 * f44) - Math_fround(f47 * f41)))));
  f42 = Math_fround(Math_fround(Math_fround(f47 * f38) + Math_fround(f39 * Math_fround(Math_fround(f37 * f41) - Math_fround(f45 * f43)))) + Math_fround(f44 * f46));
  HEAPF32[i57 >> 2] = Math_fround(Math_fround(f41 * f46) + Math_fround(Math_fround(f45 * f38) + Math_fround(f39 * Math_fround(Math_fround(f47 * f43) - Math_fround(f37 * f44)))));
  HEAPF32[i56 >> 2] = f40;
  HEAPF32[i55 >> 2] = f42;
  i55 = i18 + 16 | 0;
  f42 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * Math_fround(2.0));
  i56 = i18 + 20 | 0;
  f40 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) * Math_fround(2.0));
  i57 = i18 + 24 | 0;
  f37 = Math_fround(Math_fround(HEAPF32[i57 >> 2]) * Math_fround(2.0));
  f47 = Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(f40 * f43)) + Math_fround(f37 * f44));
  f45 = Math_fround(Math_fround(f41 * f47) + Math_fround(Math_fround(f42 * f38) + Math_fround(f39 * Math_fround(Math_fround(f37 * f43) - Math_fround(f40 * f44)))));
  f46 = Math_fround(Math_fround(f43 * f47) + Math_fround(Math_fround(f40 * f38) + Math_fround(f39 * Math_fround(Math_fround(f42 * f44) - Math_fround(f37 * f41)))));
  f47 = Math_fround(Math_fround(Math_fround(f37 * f38) + Math_fround(f39 * Math_fround(Math_fround(f40 * f41) - Math_fround(f42 * f43)))) + Math_fround(f44 * f47));
  f45 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) + f45);
  f46 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f46);
  f47 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f47);
  HEAPF32[i55 >> 2] = f45;
  HEAPF32[i56 >> 2] = f46;
  HEAPF32[i57 >> 2] = f47;
  HEAP16[i18 + 12 >> 1] = 7;
  i57 = 1;
  STACKTOP = i20;
  return i57 | 0;
 }
 i1 = i18 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 if (!(HEAP16[i15 >> 1] & 512)) {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  f45 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
  f46 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
  f47 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i18 + 28 >> 2] = f45;
  HEAPF32[i18 + 32 >> 2] = f46;
  HEAPF32[i18 + 36 >> 2] = f47;
  i57 = 1;
  STACKTOP = i20;
  return i57 | 0;
 }
 if (__ZN5physx2Gu25computeBox_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbjRNS_10PxSweepHitE(i14, i17, i12, i11, f16, f13, i10, 1, i18) | 0) {
  HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 1;
  i57 = 1;
  STACKTOP = i20;
  return i57 | 0;
 } else {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  f45 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
  f46 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
  f47 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i18 + 28 >> 2] = f45;
  HEAPF32[i18 + 32 >> 2] = f46;
  HEAPF32[i18 + 36 >> 2] = f47;
  i57 = 1;
  STACKTOP = i20;
  return i57 | 0;
 }
 return 0;
}

function __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i29, i18) {
 i29 = i29 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, d9 = 0.0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 136 | 0;
 i22 = i30 + 100 | 0;
 i23 = i30 + 52 | 0;
 i24 = i30 + 24 | 0;
 i19 = i30 + 88 | 0;
 i20 = i30 + 72 | 0;
 i21 = i30 + 56 | 0;
 i25 = i30;
 i26 = i30 + 8 | 0;
 i16 = i30 + 40 | 0;
 HEAP32[i23 >> 2] = 0;
 i28 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i29 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
 i1 = HEAP32[i29 + 36 >> 2] | 0;
 if (i1 >>> 0 < 2) if (!(HEAP32[i29 + 344 >> 2] | 0)) {
  if (!i1) {
   __ZNK9Transform16GetLocalPositionEv(i27, i28);
   i1 = i27 + 8 | 0;
   f12 = Math_fround(HEAPF32[i1 >> 2]);
   i17 = f12 < Math_fround(0.0);
   f11 = Math_fround(-f12);
   if (!((i17 ? f11 : f12) <= Math_fround(9.99999997e-07))) {
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    i1 = HEAP32[i27 + 4 >> 2] | 0;
    HEAP32[i22 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i22 + 4 >> 2] = i1;
    HEAP32[i22 + 8 >> 2] = 0;
    __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i28, i22);
    HEAP32[i23 >> 2] = 1;
    i1 = 1;
   } else i1 = 0;
  } else i1 = 0;
  i5 = i28 + 136 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  f6 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i4 ^ i2 | 0) > -1) {
   i17 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
   if ((((i17 | 0) < 0 ? 0 - i17 | 0 : i17) | 0) > 10) i17 = 13; else i17 = 10;
  } else if (f3 == f6) i17 = 10; else i17 = 13;
  do if ((i17 | 0) == 10) {
   f3 = Math_fround(HEAPF32[i28 + 140 >> 2]);
   f7 = Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i4 ^ i2 | 0) > -1) {
    i15 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
    if ((((i15 | 0) < 0 ? 0 - i15 | 0 : i15) | 0) < 11) break; else {
     i17 = 13;
     break;
    }
   } else if (f3 == f7) break; else {
    i17 = 13;
    break;
   }
  } while (0);
  if ((i17 | 0) == 13) {
   i14 = gb + 1162356 | 0;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i17 = i5;
   HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i17 + 4 >> 2] = i15;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i28, 1, 0);
   f6 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
  }
  i5 = i28 + 144 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i4 ^ i2 | 0) > -1) {
   i17 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
   if ((((i17 | 0) < 0 ? 0 - i17 | 0 : i17) | 0) > 10) i17 = 20; else i17 = 17;
  } else if (f3 == f6) i17 = 17; else i17 = 20;
  do if ((i17 | 0) == 17) {
   f3 = Math_fround(HEAPF32[i28 + 148 >> 2]);
   f6 = Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i4 ^ i2 | 0) > -1) {
    i15 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
    if ((((i15 | 0) < 0 ? 0 - i15 | 0 : i15) | 0) < 11) break; else {
     i17 = 20;
     break;
    }
   } else if (f3 == f6) break; else {
    i17 = 20;
    break;
   }
  } while (0);
  if ((i17 | 0) == 20) {
   i14 = gb + 1162356 | 0;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i17 = i5;
   HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i17 + 4 >> 2] = i15;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i28, 1, 0);
  }
  i4 = i28 + 168 | 0;
  f3 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i2 | 0) > -1) if ((((i2 | 0) < 1056964608 ? 1056964608 - i2 | 0 : i2 + -1056964608 | 0) | 0) > 10) i17 = 27; else i17 = 24; else if (f3 == Math_fround(.5)) i17 = 24; else i17 = 27;
  do if ((i17 | 0) == 24) {
   f3 = Math_fround(HEAPF32[i28 + 172 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i2 | 0) > -1) if ((((i2 | 0) < 1056964608 ? 1056964608 - i2 | 0 : i2 + -1056964608 | 0) | 0) < 11) break; else {
    i17 = 27;
    break;
   } else if (f3 == Math_fround(.5)) break; else {
    i17 = 27;
    break;
   }
  } while (0);
  if ((i17 | 0) == 27) {
   HEAP32[i4 >> 2] = 1056964608;
   HEAP32[i28 + 172 >> 2] = 1056964608;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i28, 1, 0);
  }
  i15 = (__ZNK2UI6Canvas13GetRenderModeEv(i29) | 0) == 0;
  if (i15) {
   i2 = __Z16GetScreenManagerv() | 0;
   f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0);
   i2 = __Z16GetScreenManagerv() | 0;
   f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(HEAPF32[i29 + 352 >> 2]);
   f12 = f3;
   i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i14 = i29 + 40 | 0;
   HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i17 = 35; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i4 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i4 + (i5 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i22);
     i4 = HEAP32[i27 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i4 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i4 << 3) | 0;
     i4 = HEAP32[i5 + 28 >> 2] | 0;
     i5 = HEAP32[i5 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i17 = 35; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i17 = 37;
    }
   }
   if ((i17 | 0) == 35) i17 = 37;
   if ((i17 | 0) == 37) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
   __ZNK6Camera13GetCameraRectEb(i24, i2, 1);
   i13 = HEAP32[i24 + 8 >> 2] | 0;
   i4 = HEAP32[i24 + 12 >> 2] | 0;
   f6 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f6 != f6 | Math_fround(0.0) != Math_fround(0.0) | f6 == Math_fround(0.0)) f3 = Math_fround(1.0); else {
    HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i17 = 44; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i5 = HEAP32[i2 + 28 >> 2] | 0;
      i8 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i5 + (i8 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i22);
      i5 = HEAP32[i27 >> 2] | 0;
      i31 = HEAP32[i2 + 28 >> 2] | 0;
      i8 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i5 | 0) == -1 ? i31 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i31 + (i5 << 3) | 0;
      i5 = HEAP32[i8 + 28 >> 2] | 0;
      i8 = HEAP32[i8 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i5 + (i8 << 3) | 0)) i17 = 44; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i17 = 46;
     }
    }
    if ((i17 | 0) == 44) i17 = 46;
    if ((i17 | 0) == 46) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
    if (!(HEAP8[i2 + 1088 >> 0] | 0)) {
     d9 = +Math_fround(HEAPF32[i29 + 364 >> 2]) * 2.0;
     HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i17 = 62; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i5 = HEAP32[i2 + 28 >> 2] | 0;
       i8 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i5 + (i8 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i31 = HEAP32[i2 + 28 >> 2] | 0;
       i8 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i5 | 0) == -1 ? i31 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i31 + (i5 << 3) | 0;
       i5 = HEAP32[i8 + 28 >> 2] | 0;
       i8 = HEAP32[i8 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i5 + (i8 << 3) | 0)) i17 = 62; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i17 = 64;
      }
     }
     if ((i17 | 0) == 62) i17 = 64;
     if ((i17 | 0) == 64) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
     f3 = Math_fround(d9 * +Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(__ZNK6Camera6GetFovEv(i2)) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)))));
    } else {
     HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i17 = 53; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i5 = HEAP32[i2 + 28 >> 2] | 0;
       i8 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i5 + (i8 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i22);
       i5 = HEAP32[i27 >> 2] | 0;
       i31 = HEAP32[i2 + 28 >> 2] | 0;
       i8 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i5 | 0) == -1 ? i31 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i31 + (i5 << 3) | 0;
       i5 = HEAP32[i8 + 28 >> 2] | 0;
       i8 = HEAP32[i8 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i5 + (i8 << 3) | 0)) i17 = 53; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i17 = 55;
      }
     }
     if ((i17 | 0) == 53) i17 = 55;
     if ((i17 | 0) == 55) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i14 >> 2] | 0) | 0;
     f3 = Math_fround(Math_fround(HEAPF32[i2 + 916 >> 2]) * Math_fround(2.0));
    }
    f3 = Math_fround(f3 / f6);
   }
   f11 = Math_fround(HEAPF32[i29 + 352 >> 2]);
   f12 = Math_fround(f3 * f11);
   i2 = i13;
   f3 = f11;
  }
  f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f10 / f3);
  f6 = Math_fround(f11 / f3);
  i5 = i28 + 160 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  if (f3 != f7) i17 = 70; else if (Math_fround(HEAPF32[i28 + 164 >> 2]) != f6) i17 = 70;
  L104 : do if ((i17 | 0) == 70) {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i2 ^ i4 | 0) > -1) {
    i31 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
    if ((((i31 | 0) < 0 ? 0 - i31 | 0 : i31) | 0) <= 10) i17 = 73;
   } else if (f3 == f7) i17 = 73;
   do if ((i17 | 0) == 73) {
    f3 = Math_fround(HEAPF32[i28 + 164 >> 2]);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    if ((i2 ^ i4 | 0) > -1) {
     i31 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
     if ((((i31 | 0) < 0 ? 0 - i31 | 0 : i31) | 0) < 11) break L104; else break;
    } else if (f3 == f6) break L104; else break;
   } while (0);
   HEAPF32[i5 >> 2] = f7;
   HEAPF32[i28 + 164 >> 2] = f6;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i28, 1, 0);
  } while (0);
  if (i15) {
   f7 = Math_fround(f10 * Math_fround(.5));
   f6 = Math_fround(f11 * Math_fround(.5));
   i5 = i28 + 152 | 0;
   f3 = Math_fround(HEAPF32[i5 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i2 ^ i4 | 0) > -1) {
    i31 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
    if ((((i31 | 0) < 0 ? 0 - i31 | 0 : i31) | 0) > 10) i17 = 84; else i17 = 81;
   } else if (f3 == f7) i17 = 81; else i17 = 84;
   do if ((i17 | 0) == 81) {
    f3 = Math_fround(HEAPF32[i28 + 156 >> 2]);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    if ((i2 ^ i4 | 0) > -1) {
     i31 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
     if ((((i31 | 0) < 0 ? 0 - i31 | 0 : i31) | 0) < 11) break; else {
      i17 = 84;
      break;
     }
    } else if (f3 == f6) break; else {
     i17 = 84;
     break;
    }
   } while (0);
   if ((i17 | 0) == 84) {
    HEAPF32[i5 >> 2] = f7;
    HEAPF32[i28 + 156 >> 2] = f6;
    __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i28, 1, 0);
   }
   HEAPF32[i22 >> 2] = f12;
   HEAPF32[i22 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 16 >> 2] = f12;
   HEAPF32[i22 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 28 >> 2] = Math_fround(0.0);
   HEAPF32[i22 + 32 >> 2] = f12;
   __ZNK9Transform13GetLocalScaleEv(i19, i28);
   if (Math_fround(HEAPF32[i19 >> 2]) != f12) i17 = 88; else if (Math_fround(HEAPF32[i19 + 4 >> 2]) != f12) i17 = 88; else if (Math_fround(HEAPF32[i19 + 8 >> 2]) != f12) i17 = 88;
   if ((i17 | 0) == 88) {
    i1 = i1 | 8;
    HEAP32[i23 >> 2] = i1;
   }
   __ZNK9Transform11GetRotationEv(i20, i28);
   if (Math_fround(HEAPF32[i20 >> 2]) != Math_fround(0.0)) i17 = 93; else if (Math_fround(HEAPF32[i20 + 4 >> 2]) != Math_fround(0.0)) i17 = 93; else if (Math_fround(HEAPF32[i20 + 8 >> 2]) != Math_fround(0.0)) i17 = 93; else if (Math_fround(HEAPF32[i20 + 12 >> 2]) != Math_fround(1.0)) i17 = 93;
   if ((i17 | 0) == 93) {
    i1 = i1 | 2;
    HEAP32[i23 >> 2] = i1;
   }
   __ZNK9Transform11GetPositionEv(i21, i28);
   if (Math_fround(HEAPF32[i21 >> 2]) != f7) i17 = 97; else if (Math_fround(HEAPF32[i21 + 4 >> 2]) != f6) i17 = 97; else if (Math_fround(HEAPF32[i21 + 8 >> 2]) != Math_fround(0.0)) i17 = 97;
   if ((i17 | 0) == 97) {
    i1 = i1 | 1;
    HEAP32[i23 >> 2] = i1;
   }
   __ZN9Transform18GetTransformAccessEv(i25, i28);
   HEAPF32[i24 >> 2] = f7;
   HEAPF32[i24 + 4 >> 2] = f6;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i26 + 4 >> 2] = 0;
   HEAP32[i26 + 8 >> 2] = 0;
   HEAP32[i26 + 12 >> 2] = 1065353216;
   HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E(i27, i24, i26, i22) | 0;
  } else {
   __ZNK9Transform13GetLocalScaleEv(i16, i28);
   if (Math_fround(HEAPF32[i16 >> 2]) != f12) i17 = 102; else if (Math_fround(HEAPF32[i16 + 4 >> 2]) != f12) i17 = 102; else if (Math_fround(HEAPF32[i16 + 8 >> 2]) != f12) i17 = 102;
   if ((i17 | 0) == 102) {
    HEAPF32[i27 >> 2] = f12;
    HEAPF32[i27 + 4 >> 2] = f12;
    HEAPF32[i27 + 8 >> 2] = f12;
    __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i28, i27);
    i1 = i1 | 8;
    HEAP32[i23 >> 2] = i1;
   }
   if (i18) {
    __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi(i29, i23);
    i1 = HEAP32[i23 >> 2] | 0;
   }
  }
  if (i1 | 0) __ZN9Transform20SendTransformChangedEi(i28, i1);
 } else i17 = 107; else i17 = 107;
 if ((i17 | 0) == 107) (__ZNK2UI13RectTransform17GetDrivenByObjectEv(i28) | 0) == (i29 | 0);
 i1 = HEAP32[i29 + 424 >> 2] | 0;
 i2 = i29 + 428 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 do {
  __ZN2UI6Canvas25UpdateCanvasRectTransformEb(HEAP32[i1 >> 2] | 0, 1);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 STACKTOP = i30;
 return;
}

function __ZN5physx9NpFactoryD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 93248 + 8;
 i1 = HEAP32[i5 + 440 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i1 = i5 + 4552 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 4536 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 4256 | 0);
 i3 = i5 + 4520 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 4524 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 4528 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 4260 | 0) == (i1 | 0)) {
   HEAP8[i5 + 4516 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 i1 = i5 + 4252 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 4236 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 3956 | 0);
 i3 = i5 + 4220 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 4224 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 4228 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 3960 | 0) == (i1 | 0)) {
   HEAP8[i5 + 4216 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 i6 = HEAP32[i5 + 3952 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 3944 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i1 = i5 + 3940 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 3924 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 3644 | 0);
 i3 = i5 + 3908 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 3912 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 3916 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 3648 | 0) == (i1 | 0)) {
   HEAP8[i5 + 3904 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 i1 = i5 + 3640 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 3624 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 3344 | 0);
 i3 = i5 + 3608 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 3612 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 3616 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 3348 | 0) == (i1 | 0)) {
   HEAP8[i5 + 3604 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 3340 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 3324 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 3044 | 0);
 i3 = i5 + 3308 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 3312 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 3316 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 3048 | 0) == (i1 | 0)) {
   HEAP8[i5 + 3304 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 3040 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 3024 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 2744 | 0);
 i3 = i5 + 3008 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 3012 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 3016 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 2748 | 0) == (i1 | 0)) {
   HEAP8[i5 + 3004 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 2740 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 2724 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 2444 | 0);
 i3 = i5 + 2708 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 2712 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 2716 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 2448 | 0) == (i1 | 0)) {
   HEAP8[i5 + 2704 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 2440 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 2424 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 2144 | 0);
 i3 = i5 + 2408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 2412 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 2416 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 2148 | 0) == (i1 | 0)) {
   HEAP8[i5 + 2404 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 2140 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 2124 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 1844 | 0);
 i3 = i5 + 2108 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 2112 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 2116 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 1848 | 0) == (i1 | 0)) {
   HEAP8[i5 + 2104 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 1840 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 1824 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 1544 | 0);
 i3 = i5 + 1808 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 1812 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 1816 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 1548 | 0) == (i1 | 0)) {
   HEAP8[i5 + 1804 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 1540 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 1524 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 1244 | 0);
 i3 = i5 + 1508 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 1512 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 1516 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 1248 | 0) == (i1 | 0)) {
   HEAP8[i5 + 1504 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 1240 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 1224 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 944 | 0);
 i3 = i5 + 1208 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 1212 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 1216 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 948 | 0) == (i1 | 0)) {
   HEAP8[i5 + 1204 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 940 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 924 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 644 | 0);
 i3 = i5 + 908 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 912 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 916 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 648 | 0) == (i1 | 0)) {
   HEAP8[i5 + 904 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 } while (0);
 i1 = i5 + 604 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i5 + 564 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i5 + 524 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i5 + 484 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i5 + 444 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i5 + 436 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 if (HEAP32[i5 + 420 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i5 + 140 | 0);
 i3 = i5 + 404 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 408 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 412 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) {
  __ZN5physx13GuMeshFactoryD2Ev(i5);
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 144 | 0) == (i1 | 0)) {
  HEAP8[i5 + 400 >> 0] = 0;
  __ZN5physx13GuMeshFactoryD2Ev(i5);
  return;
 }
 if (!i1) {
  __ZN5physx13GuMeshFactoryD2Ev(i5);
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 __ZN5physx13GuMeshFactoryD2Ev(i5);
 return;
}

function __ZNK5physx13NpVolumeCache10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i90, i88, i95, i86, i83, i82, f87) {
 i90 = i90 | 0;
 i88 = i88 | 0;
 i95 = i95 | 0;
 i86 = i86 | 0;
 i83 = i83 | 0;
 i82 = i82 | 0;
 f87 = Math_fround(f87);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i84 = 0, i85 = 0, i89 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, f101 = f0, f102 = f0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0;
 i97 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i97;
 i96 = i97 + 48 | 0;
 i84 = i97 + 118 | 0;
 i81 = i97 + 40 | 0;
 i6 = i97 + 120 | 0;
 i89 = i97 + 32 | 0;
 i85 = i97 + 4 | 0;
 i78 = i97 + 116 | 0;
 i93 = i95 + 52 | 0;
 HEAP8[i93 >> 0] = 0;
 i94 = i95 + 64 | 0;
 HEAP32[i94 >> 2] = 0;
 i79 = i83 + 16 | 0;
 i8 = HEAP16[i79 >> 1] | 0;
 HEAP16[i84 >> 1] = i8;
 i4 = i90 + 80 | 0;
 i2 = i90 + 112 | 0;
 i80 = i8 & 65535;
 i1 = i90 + 4 | 0;
 if (!(HEAP8[i90 + 116 >> 0] | 0)) if ((i80 & 1 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0) == (HEAP32[i90 + 108 >> 2] | 0)) i7 = 9; else i7 = 4; else if (!(i80 & 1)) i7 = 9; else i7 = 4;
 if ((i7 | 0) == 4) if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i90, 0, 0, 0) | 0) == 1) i7 = 6; else if ((HEAP32[i1 >> 2] | 0) == -1) i7 = 7; else i7 = 9;
 do if ((i7 | 0) == 9) {
  if (!(HEAP8[i90 + 117 >> 0] | 0)) {
   if (!((i80 & 2 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0) == (HEAP32[i2 >> 2] | 0))) i7 = 73;
  } else if (i80 & 2 | 0) i7 = 73;
  if ((i7 | 0) == 73) {
   if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i90, 1, 0, 0) | 0) == 1) {
    i7 = 6;
    break;
   }
   if ((HEAP32[i1 >> 2] | 0) == -1) {
    i7 = 7;
    break;
   }
  }
  i3 = HEAP32[i90 + 88 >> 2] | 0;
  HEAP32[i81 >> 2] = i3;
  i92 = HEAP32[i90 + 100 >> 2] | 0;
  HEAP32[i81 + 4 >> 2] = i92;
  if (!(i3 | i92)) {
   i96 = 0;
   STACKTOP = i97;
   return i96 | 0;
  }
  i77 = i88 + 8 | 0;
  i7 = HEAP32[i77 >> 2] | 0;
  i76 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
  i92 = HEAP32[i90 + 72 >> 2] | 0;
  i1 = HEAP32[i90 + 76 >> 2] | 0;
  i92 = i92 >>> 0 < i1 >>> 0 ? i1 : i92;
  i1 = i92 * 48 | 0;
  if (i92 >>> 0 < 128) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i92 = 0;
  } else {
   i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i6, i1, gb + 704671 | 0, 615) | 0;
   i92 = i2;
  }
  i42 = (HEAP16[i79 >> 1] & 32) != 0;
  i43 = i95 + 60 | 0;
  i44 = i88 + 4 | 0;
  i45 = i88 + 12 | 0;
  i46 = i88 + 16 | 0;
  i47 = i96 + 4 | 0;
  i48 = i96 + 8 | 0;
  i49 = i96 + 12 | 0;
  i50 = i96 + 16 | 0;
  i51 = i96 + 20 | 0;
  i52 = i96 + 44 | 0;
  i53 = i96 + 52 | 0;
  i54 = i96 + 56 | 0;
  i55 = i96 + 60 | 0;
  i56 = i96 + 64 | 0;
  i66 = i95 + 4 | 0;
  i57 = i96 + 4 | 0;
  i67 = i95 + 16 | 0;
  i68 = i95 + 20 | 0;
  i58 = i96 + 20 | 0;
  i59 = i96 + 24 | 0;
  i69 = i95 + 24 | 0;
  i60 = i96 + 28 | 0;
  i70 = i95 + 28 | 0;
  i71 = i95 + 32 | 0;
  i61 = i96 + 32 | 0;
  i62 = i96 + 36 | 0;
  i72 = i95 + 36 | 0;
  i63 = i96 + 40 | 0;
  i73 = i95 + 40 | 0;
  i74 = i95 + 44 | 0;
  i64 = i96 + 48 | 0;
  i75 = i95 + 48 | 0;
  i91 = i95 + 56 | 0;
  i14 = i2 + 4 | 0;
  i65 = i2 + 12 | 0;
  i15 = i2 + 40 | 0;
  i16 = i2 + 16 | 0;
  i17 = i2 + 20 | 0;
  i18 = i2 + 24 | 0;
  i19 = i2 + 28 | 0;
  i20 = i2 + 32 | 0;
  i21 = i2 + 36 | 0;
  i22 = i2 + 40 | 0;
  i23 = i2 + 28 | 0;
  i24 = i2 + 32 | 0;
  i25 = i2 + 36 | 0;
  i26 = i2 + 16 | 0;
  i27 = i2 + 20 | 0;
  i28 = i2 + 24 | 0;
  i29 = i2 + 28 | 0;
  i30 = i2 + 32 | 0;
  i31 = i2 + 36 | 0;
  i32 = i2 + 40 | 0;
  i33 = i2 + 44 | 0;
  i34 = i2 + 16 | 0;
  i35 = i2 + 20 | 0;
  i36 = i2 + 24 | 0;
  i37 = i2 + 28 | 0;
  i38 = i2 + 32 | 0;
  i39 = i2 + 36 | 0;
  i40 = i2 + 40 | 0;
  i41 = i2 + 44 | 0;
  i13 = (i82 | 0) == 0 | (i8 & 8) == 0;
  i12 = i3;
  i1 = i7;
  i3 = 0;
  L23 : while (1) {
   if (i12) {
    i11 = i90 + 84 + (i3 * 12 | 0) | 0;
    i10 = 0;
    do {
     i4 = (HEAP32[i11 >> 2] | 0) + (i10 << 3) | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     L29 : do if (((i9 | 0 ? (HEAP16[i9 + 4 >> 1] | 0) == 5 : 0) ? 2 : 1) & i80) {
      HEAP32[i89 >> 2] = HEAP32[i43 >> 2] | 0 ? 1 : 2;
      i9 = HEAP16[i86 >> 1] | 0;
      i7 = __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE(i4, i89, i84, i83, i82, i76, i86) | 0;
      i4 = HEAP32[i89 >> 2] | 0;
      if (!((i7 | 0) == 0 | (i4 | 0) == 0)) {
       i8 = i7 + 4 | 0;
       i6 = HEAP32[i8 >> 2] | 0;
       __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE(i85, i6, HEAP32[i7 >> 2] | 0);
       if (!(HEAP32[i6 + 36 >> 2] & 1)) i6 = i6 + 116 | 0; else i6 = (HEAP32[i6 + 40 >> 2] | 0) + 56 | 0;
       i100 = HEAP32[i44 >> 2] | 0;
       f5 = Math_fround(HEAPF32[i77 >> 2]);
       i99 = HEAP32[i45 >> 2] | 0;
       i98 = HEAP32[i46 >> 2] | 0;
       HEAP16[i96 >> 1] = i9;
       if (__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i100, f5, i99, i98, i6, i85, i2, i96, Math_fround(0.0)) | 0) {
        HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
        i6 = HEAP16[i65 >> 1] | 0;
        if (!(i6 & 4)) HEAPF32[i15 >> 2] = Math_fround(0.0);
        if (!(i6 & 1)) {
         HEAP32[i16 >> 2] = 0;
         HEAP32[i17 >> 2] = 0;
         HEAP32[i18 >> 2] = 0;
        }
        if (!(i6 & 2)) {
         HEAP32[i19 >> 2] = 0;
         HEAP32[i20 >> 2] = 0;
         HEAP32[i21 >> 2] = 0;
        }
        if (Math_fround(HEAPF32[i22 >> 2]) == Math_fround(0.0)) {
         i100 = HEAP32[i44 >> 2] | 0;
         f102 = Math_fround(-Math_fround(HEAPF32[i100 >> 2]));
         f101 = Math_fround(-Math_fround(HEAPF32[i100 + 4 >> 2]));
         f5 = Math_fround(-Math_fround(HEAPF32[i100 + 8 >> 2]));
         HEAPF32[i23 >> 2] = f102;
         HEAPF32[i24 >> 2] = f101;
         HEAPF32[i25 >> 2] = f5;
        }
        if (!i13) i4 = mftCall_iiii(HEAP32[(HEAP32[i82 >> 2] | 0) + 4 >> 2] | 0, i82 | 0, i83 | 0, i2 | 0) | 0;
        if ((i4 | 0) != 0 & (HEAP16[i79 >> 1] & 16) != 0) {
         i7 = 33;
         break L23;
        }
        switch ((i42 ? 1 : i4) | 0) {
        case 1:
         break;
        case 2:
         {
          f5 = Math_fround(HEAPF32[i22 >> 2]);
          if (!(f5 <= (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break L29;
          i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
          HEAP32[i66 >> 2] = HEAP32[i2 >> 2];
          HEAP32[i66 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
          HEAP32[i66 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
          HEAP16[i67 >> 1] = HEAP16[i65 >> 1] | 0;
          HEAP32[i68 >> 2] = HEAP32[i34 >> 2];
          HEAP32[i69 >> 2] = HEAP32[i35 >> 2];
          HEAP32[i70 >> 2] = HEAP32[i36 >> 2];
          HEAP32[i71 >> 2] = HEAP32[i37 >> 2];
          HEAP32[i72 >> 2] = HEAP32[i38 >> 2];
          HEAP32[i73 >> 2] = HEAP32[i39 >> 2];
          HEAP32[i74 >> 2] = HEAP32[i40 >> 2];
          HEAP32[i75 >> 2] = HEAP32[i41 >> 2];
          HEAP8[i93 >> 0] = 1;
          break L29;
         }
        default:
         break L29;
        }
        i6 = HEAP32[i43 >> 2] | 0;
        if (!i6) break;
        f102 = Math_fround(HEAPF32[i22 >> 2]);
        if (!(f102 <= (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
        i4 = HEAP32[i94 >> 2] | 0;
        if ((i4 | 0) == (i6 | 0)) {
         HEAP32[i47 >> 2] = 0;
         HEAP32[i48 >> 2] = 0;
         HEAP32[i49 >> 2] = -1;
         HEAP16[i50 >> 1] = 0;
         HEAP32[i51 >> 2] = 0;
         HEAP32[i51 + 4 >> 2] = 0;
         HEAP32[i51 + 8 >> 2] = 0;
         HEAP32[i51 + 12 >> 2] = 0;
         HEAP32[i51 + 16 >> 2] = 0;
         HEAP32[i51 + 20 >> 2] = 0;
         HEAPF32[i52 >> 2] = Math_fround(3402823469999999843913219.0e14);
         HEAP8[i53 >> 0] = 0;
         HEAP32[i54 >> 2] = 0;
         HEAP32[i55 >> 2] = 0;
         HEAP32[i56 >> 2] = 0;
         HEAP32[i96 >> 2] = gb + 93084 + 8;
         HEAP16[i78 >> 1] = HEAP16[i86 >> 1] | 0;
         if (__ZNK5physx13NpVolumeCache10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i90, i88, i96, i78, i83, i82, f87) | 0) {
          HEAP32[i66 >> 2] = HEAP32[i57 >> 2];
          HEAP32[i66 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
          HEAP32[i66 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
          HEAP16[i67 >> 1] = HEAP16[i50 >> 1] | 0;
          HEAP32[i68 >> 2] = HEAP32[i58 >> 2];
          HEAP32[i69 >> 2] = HEAP32[i59 >> 2];
          HEAP32[i70 >> 2] = HEAP32[i60 >> 2];
          HEAP32[i71 >> 2] = HEAP32[i61 >> 2];
          HEAP32[i72 >> 2] = HEAP32[i62 >> 2];
          HEAP32[i73 >> 2] = HEAP32[i63 >> 2];
          i100 = HEAP32[i52 >> 2] | 0;
          HEAP32[i74 >> 2] = i100;
          HEAP32[i75 >> 2] = HEAP32[i64 >> 2];
          HEAP8[i93 >> 0] = 1;
          i7 = HEAP32[i91 >> 2] | 0;
          i8 = HEAP32[i94 >> 2] | 0;
          f5 = (HEAP32[tempDoublePtr >> 2] = i100, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          if (!i8) i4 = 0; else {
           i9 = 0;
           i4 = i8;
           do {
            i6 = i7 + (i9 * 48 | 0) + 40 | 0;
            if (Math_fround(HEAPF32[i6 >> 2]) > f5) {
             i4 = i4 + -1 | 0;
             i108 = HEAP16[i7 + (i4 * 48 | 0) + 12 >> 1] | 0;
             i107 = HEAP32[i7 + (i4 * 48 | 0) + 16 >> 2] | 0;
             i106 = HEAP32[i7 + (i4 * 48 | 0) + 20 >> 2] | 0;
             i105 = HEAP32[i7 + (i4 * 48 | 0) + 24 >> 2] | 0;
             i104 = HEAP32[i7 + (i4 * 48 | 0) + 28 >> 2] | 0;
             i103 = HEAP32[i7 + (i4 * 48 | 0) + 32 >> 2] | 0;
             i98 = HEAP32[i7 + (i4 * 48 | 0) + 36 >> 2] | 0;
             i99 = HEAP32[i7 + (i4 * 48 | 0) + 40 >> 2] | 0;
             i100 = HEAP32[i7 + (i4 * 48 | 0) + 44 >> 2] | 0;
             _memmove(i7 + (i9 * 48 | 0) | 0, i7 + (i4 * 48 | 0) | 0, 12) | 0;
             HEAP16[i7 + (i9 * 48 | 0) + 12 >> 1] = i108;
             HEAP32[i7 + (i9 * 48 | 0) + 16 >> 2] = i107;
             HEAP32[i7 + (i9 * 48 | 0) + 20 >> 2] = i106;
             HEAP32[i7 + (i9 * 48 | 0) + 24 >> 2] = i105;
             HEAP32[i7 + (i9 * 48 | 0) + 28 >> 2] = i104;
             HEAP32[i7 + (i9 * 48 | 0) + 32 >> 2] = i103;
             HEAP32[i7 + (i9 * 48 | 0) + 36 >> 2] = i98;
             HEAP32[i6 >> 2] = i99;
             HEAP32[i7 + (i9 * 48 | 0) + 44 >> 2] = i100;
            }
            i9 = i9 + 1 | 0;
           } while ((i9 | 0) != (i8 | 0));
          }
          HEAP32[i94 >> 2] = i4;
         } else i4 = HEAP32[i94 >> 2] | 0;
         if ((i4 | 0) == (HEAP32[i43 >> 2] | 0)) {
          if (!(mftCall_iiii(HEAP32[HEAP32[i95 >> 2] >> 2] | 0, i95 | 0, HEAP32[i91 >> 2] | 0, i4 | 0) | 0)) {
           i7 = 49;
           break L23;
          }
          HEAP32[i94 >> 2] = 0;
          i4 = 0;
         }
        }
        HEAP32[i94 >> 2] = i4 + 1;
        i108 = HEAP32[i91 >> 2] | 0;
        i107 = i108 + (i4 * 48 | 0) | 0;
        HEAP32[i107 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i107 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i107 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP16[i108 + (i4 * 48 | 0) + 12 >> 1] = HEAP16[i65 >> 1] | 0;
        HEAP32[i108 + (i4 * 48 | 0) + 16 >> 2] = HEAP32[i26 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 20 >> 2] = HEAP32[i27 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 24 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 28 >> 2] = HEAP32[i29 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 32 >> 2] = HEAP32[i30 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 36 >> 2] = HEAP32[i31 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 40 >> 2] = HEAP32[i32 >> 2];
        HEAP32[i108 + (i4 * 48 | 0) + 44 >> 2] = HEAP32[i33 >> 2];
       }
      }
     } while (0);
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < i12 >>> 0);
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= 2) {
    i7 = 56;
    break;
   }
   i12 = HEAP32[i81 + (i3 << 2) >> 2] | 0;
  }
  if ((i7 | 0) == 33) {
   HEAP32[i66 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP16[i67 >> 1] = HEAP16[i65 >> 1] | 0;
   HEAP32[i68 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i69 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i70 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i71 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i72 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i73 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i74 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i75 >> 2] = HEAP32[i2 + 44 >> 2];
   mftCall_vi(HEAP32[(HEAP32[i95 >> 2] | 0) + 4 >> 2] | 0, i95 | 0);
   HEAP8[i93 >> 0] = 1;
   i1 = 1;
  } else if ((i7 | 0) == 49) {
   mftCall_vi(HEAP32[(HEAP32[i95 >> 2] | 0) + 4 >> 2] | 0, i95 | 0);
   i1 = (HEAP8[i93 >> 0] | 0) != 0;
  } else if ((i7 | 0) == 56) {
   i1 = HEAP32[i94 >> 2] | 0;
   if (!(HEAP8[i93 >> 0] | 0)) i7 = 63; else if (i1 | 0) {
    i4 = HEAP32[i91 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i95 + 4 + 40 >> 2]);
    i6 = 0;
    i2 = i1;
    do {
     i3 = i4 + (i6 * 48 | 0) + 40 | 0;
     if (Math_fround(HEAPF32[i3 >> 2]) > f5) {
      i2 = i2 + -1 | 0;
      i98 = HEAP16[i4 + (i2 * 48 | 0) + 12 >> 1] | 0;
      i99 = HEAP32[i4 + (i2 * 48 | 0) + 16 >> 2] | 0;
      i100 = HEAP32[i4 + (i2 * 48 | 0) + 20 >> 2] | 0;
      i103 = HEAP32[i4 + (i2 * 48 | 0) + 24 >> 2] | 0;
      i104 = HEAP32[i4 + (i2 * 48 | 0) + 28 >> 2] | 0;
      i105 = HEAP32[i4 + (i2 * 48 | 0) + 32 >> 2] | 0;
      i106 = HEAP32[i4 + (i2 * 48 | 0) + 36 >> 2] | 0;
      i107 = HEAP32[i4 + (i2 * 48 | 0) + 40 >> 2] | 0;
      i108 = HEAP32[i4 + (i2 * 48 | 0) + 44 >> 2] | 0;
      _memmove(i4 + (i6 * 48 | 0) | 0, i4 + (i2 * 48 | 0) | 0, 12) | 0;
      HEAP16[i4 + (i6 * 48 | 0) + 12 >> 1] = i98;
      HEAP32[i4 + (i6 * 48 | 0) + 16 >> 2] = i99;
      HEAP32[i4 + (i6 * 48 | 0) + 20 >> 2] = i100;
      HEAP32[i4 + (i6 * 48 | 0) + 24 >> 2] = i103;
      HEAP32[i4 + (i6 * 48 | 0) + 28 >> 2] = i104;
      HEAP32[i4 + (i6 * 48 | 0) + 32 >> 2] = i105;
      HEAP32[i4 + (i6 * 48 | 0) + 36 >> 2] = i106;
      HEAP32[i3 >> 2] = i107;
      HEAP32[i4 + (i6 * 48 | 0) + 44 >> 2] = i108;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    i1 = i2;
    HEAP32[i94 >> 2] = i1;
    i7 = 63;
   }
   if ((i7 | 0) == 63) if (i1 | 0) if (mftCall_iiii(HEAP32[HEAP32[i95 >> 2] >> 2] | 0, i95 | 0, HEAP32[i91 >> 2] | 0, i1 | 0) | 0) HEAP32[i94 >> 2] = 0;
   mftCall_vi(HEAP32[(HEAP32[i95 >> 2] | 0) + 4 >> 2] | 0, i95 | 0);
   i1 = (HEAP8[i93 >> 0] | 0) != 0;
  }
  if (i92 | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i96, i92);
  i108 = i1;
  STACKTOP = i97;
  return i108 | 0;
 } while (0);
 if ((i7 | 0) == 6) if ((HEAP32[i1 >> 2] | 0) == -1) i7 = 7;
 if ((i7 | 0) == 7) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 128, gb + 704671 | 0, 582, gb + 704746 | 0, i3);
 i105 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
 i104 = HEAP32[(HEAP32[i105 >> 2] | 0) + 352 >> 2] | 0;
 i106 = HEAP32[i88 + 12 >> 2] | 0;
 i107 = HEAP32[i88 + 16 >> 2] | 0;
 i108 = HEAP32[i88 + 4 >> 2] | 0;
 f102 = Math_fround(HEAPF32[i88 + 8 >> 2]);
 HEAP16[i96 >> 1] = HEAP16[i86 >> 1] | 0;
 mftCall_iiiiifiiiiif(i104 | 0, i105 | 0, i106 | 0, i107 | 0, i108 | 0, +f102, i95 | 0, i96 | 0, i83 | 0, i82 | 0, 0, 0.0) | 0;
 i108 = (HEAP8[i93 >> 0] | 0) != 0 | (HEAP32[i94 >> 2] | 0) != 0;
 STACKTOP = i97;
 return i108 | 0;
}

function __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i20 + 8 | 0;
 i14 = i20;
 i11 = i20 + 48 | 0;
 i19 = i20 + 28 | 0;
 i13 = i15 + 4 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 464702 | 0, i20 + 24 | 0);
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i16 = i14;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i16 = i19 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i14);
 i8 = i10;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i18;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i14 >> 2] = 0;
 i12 = i15 + 13 | 0;
 i2 = (HEAP8[i12 >> 0] | 0) == 0;
 do if (i2) {
  HEAP32[i11 >> 2] = i19;
  i1 = HEAP32[i15 + 16 >> 2] | 0;
  if ((i1 | 0) == 1 & i2) {
   i8 = HEAP32[i13 >> 2] | 0;
   i7 = __Z21GetManagerFromContexti(5) | 0;
   i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
   i2 = HEAP32[i7 + 200 >> 2] | 0;
   i7 = HEAP32[i7 + 204 >> 2] | 0;
   i1 = i7 - i2 >> 3;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i21 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i21 << 3) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0;
     i4 = i4 + 8 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i21 | 0 : i21;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   if ((i1 | 0) == (i7 | 0)) i9 = 48; else if ((HEAP32[i1 >> 2] | 0) >>> 0 > i6 >>> 0) i9 = 48; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 48; else {
     HEAP32[i10 + 4 >> 2] = i1;
     HEAP32[i10 >> 2] = 0;
     i2 = 0;
    }
   }
   if ((i9 | 0) == 48) {
    i21 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
    i2 = __Z28scripting_class_is_interfaceP11Il2CppClass(i21) | 0;
    i2 = i2 ? 2 : 1;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i10 + 8 >> 2] = i21;
   }
   i4 = HEAP32[i15 + 12 >> 2] | 0;
   i1 = (i2 | 0) == 0;
   i3 = (i4 & 255) << 24 >> 24 == 0;
   i4 = i4 >>> 16 & 255;
   do if (i3 | i1 ^ 1) {
    if (i1 & i3) {
     __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
     break;
    }
    i1 = (i2 | 0) == 1;
    if (!(i3 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb0ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i3) {
     __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
     break;
    }
    i1 = (i2 | 0) == 2;
    if (!(i3 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb0ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i3) __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
   } else __ZL34GetComponentsImplementationRecurseILb0ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0; while (0);
   break;
  }
  if ((i1 | 0) == 0 & i2) {
   i8 = HEAP32[i13 >> 2] | 0;
   i7 = __Z21GetManagerFromContexti(5) | 0;
   i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
   i2 = HEAP32[i7 + 200 >> 2] | 0;
   i7 = HEAP32[i7 + 204 >> 2] | 0;
   i1 = i7 - i2 >> 3;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i21 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i21 << 3) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0;
     i4 = i4 + 8 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i21 | 0 : i21;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   if ((i1 | 0) == (i7 | 0)) i9 = 107; else if ((HEAP32[i1 >> 2] | 0) >>> 0 > i6 >>> 0) i9 = 107; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 107; else {
     HEAP32[i10 + 4 >> 2] = i1;
     HEAP32[i10 >> 2] = 0;
     i2 = 0;
    }
   }
   if ((i9 | 0) == 107) {
    i21 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
    i2 = __Z28scripting_class_is_interfaceP11Il2CppClass(i21) | 0;
    i2 = i2 ? 2 : 1;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i10 + 8 >> 2] = i21;
   }
   i4 = HEAP32[i15 + 12 >> 2] | 0;
   i1 = (i2 | 0) == 0;
   i3 = (i4 & 255) << 24 >> 24 == 0;
   i4 = i4 >>> 16 & 255;
   do if (i3 | i1 ^ 1) {
    if (i1 & i3) {
     __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
     break;
    }
    i1 = (i2 | 0) == 1;
    if (!(i3 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i3) {
     __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
     break;
    }
    i1 = (i2 | 0) == 2;
    if (!(i3 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i3) __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, 1, i10, i11) | 0;
   } else __ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i4 << 24 >> 24 != 0, i10, i11) | 0; while (0);
  }
 } else {
  HEAP32[i11 >> 2] = i14;
  i1 = HEAP32[i15 + 16 >> 2] | 0;
  if (!((i1 | 0) != 1 | i2)) {
   i8 = HEAP32[i13 >> 2] | 0;
   i7 = __Z21GetManagerFromContexti(5) | 0;
   i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
   i2 = HEAP32[i7 + 200 >> 2] | 0;
   i7 = HEAP32[i7 + 204 >> 2] | 0;
   i1 = i7 - i2 >> 3;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i21 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i21 << 3) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0;
     i4 = i4 + 8 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i21 | 0 : i21;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   if ((i1 | 0) == (i7 | 0)) i9 = 10; else if ((HEAP32[i1 >> 2] | 0) >>> 0 > i6 >>> 0) i9 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 10; else {
     HEAP32[i10 + 4 >> 2] = i1;
     HEAP32[i10 >> 2] = 0;
     i6 = 0;
     i4 = 0;
     i5 = i1;
    }
   }
   if ((i9 | 0) == 10) {
    i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
    i4 = __Z28scripting_class_is_interfaceP11Il2CppClass(i6) | 0;
    i4 = i4 ? 2 : 1;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i10 + 8 >> 2] = i6;
    i5 = 0;
   }
   i3 = HEAP32[i15 + 12 >> 2] | 0;
   i1 = (i4 | 0) == 0;
   i2 = (i3 & 255) << 24 >> 24 == 0;
   i3 = i3 >>> 16 & 255;
   L80 : do if (i2 | i1 ^ 1) {
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i4 = i1 + (i21 << 3) | 0;
     if (!i21) break;
     i3 = HEAP32[i5 + 24 >> 2] | 0;
     i2 = HEAP32[i5 + 28 >> 2] | 0;
     while (1) {
      if (((HEAP32[i1 >> 2] | 0) - i3 | 0) >>> 0 < i2 >>> 0) break;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i4 | 0)) break L80;
     }
     HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
     break;
    }
    i1 = (i4 | 0) == 1;
    if (!(i2 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb1ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i4 = i1 + (i21 << 3) | 0;
     if (!i21) break;
     while (1) {
      if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
       i2 = i1 + 4 | 0;
       i3 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i2 >> 2] | 0) | 0;
       if (i3 | 0) {
        if ((i3 | 0) == (i6 | 0)) break;
        if (__Z26scripting_class_has_parentP11Il2CppClassS0_(i3, i6) | 0) break;
       }
      }
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i4 | 0)) break L80;
     }
     HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i2 >> 2];
     break;
    }
    i1 = (i4 | 0) == 2;
    if (!(i2 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb1ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i3 = i1 + (i21 << 3) | 0;
     if (i21 | 0) {
      while (1) {
       i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
       if ((i2 | 0) == (gb + 27592 | 0)) i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i1 + 4 >> 2] | 0) | 0; else {
        i21 = __Z21GetManagerFromContexti(5) | 0;
        i2 = HEAP32[(HEAP32[i21 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
       }
       if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i6) | 0) break;
       i1 = i1 + 8 | 0;
       if ((i1 | 0) == (i3 | 0)) break L80;
      }
      HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
     }
    }
   } else __ZL34GetComponentsImplementationRecurseILb1ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0; while (0);
   break;
  }
  if (!((i1 | 0) != 0 | i2)) {
   i8 = HEAP32[i13 >> 2] | 0;
   i7 = __Z21GetManagerFromContexti(5) | 0;
   i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
   i2 = HEAP32[i7 + 200 >> 2] | 0;
   i7 = HEAP32[i7 + 204 >> 2] | 0;
   i1 = i7 - i2 >> 3;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i21 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i21 << 3) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0;
     i4 = i4 + 8 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i21 | 0 : i21;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   if ((i1 | 0) == (i7 | 0)) i9 = 69; else if ((HEAP32[i1 >> 2] | 0) >>> 0 > i6 >>> 0) i9 = 69; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 69; else {
     HEAP32[i10 + 4 >> 2] = i1;
     HEAP32[i10 >> 2] = 0;
     i4 = 0;
     i5 = i1;
     i6 = 0;
    }
   }
   if ((i9 | 0) == 69) {
    i6 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i8) | 0;
    i4 = __Z28scripting_class_is_interfaceP11Il2CppClass(i6) | 0;
    i4 = i4 ? 2 : 1;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i10 + 8 >> 2] = i6;
    i5 = 0;
   }
   i3 = HEAP32[i15 + 12 >> 2] | 0;
   i1 = (i4 | 0) == 0;
   i2 = (i3 & 255) << 24 >> 24 == 0;
   i3 = i3 >>> 16 & 255;
   L133 : do if (i2 | i1 ^ 1) {
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i4 = i1 + (i21 << 3) | 0;
     if (!i21) break;
     i3 = HEAP32[i5 + 24 >> 2] | 0;
     i2 = HEAP32[i5 + 28 >> 2] | 0;
     while (1) {
      if (((HEAP32[i1 >> 2] | 0) - i3 | 0) >>> 0 < i2 >>> 0) break;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i4 | 0)) break L133;
     }
     HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
     break;
    }
    i1 = (i4 | 0) == 1;
    if (!(i2 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i4 = i1 + (i21 << 3) | 0;
     if (!i21) break;
     while (1) {
      if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
       i2 = i1 + 4 | 0;
       i3 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i2 >> 2] | 0) | 0;
       if (i3 | 0) {
        if ((i3 | 0) == (i6 | 0)) break;
        if (__Z26scripting_class_has_parentP11Il2CppClassS0_(i3, i6) | 0) break;
       }
      }
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i4 | 0)) break L133;
     }
     HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i2 >> 2];
     break;
    }
    i1 = (i4 | 0) == 2;
    if (!(i2 | i1 ^ 1)) {
     __ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0;
     break;
    }
    if (i1 & i2) {
     i21 = HEAP32[i15 >> 2] | 0;
     HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     i21 = HEAP32[i21 + 40 >> 2] | 0;
     i3 = i1 + (i21 << 3) | 0;
     if (i21 | 0) {
      while (1) {
       i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
       if ((i2 | 0) == (gb + 27592 | 0)) i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i1 + 4 >> 2] | 0) | 0; else {
        i21 = __Z21GetManagerFromContexti(5) | 0;
        i2 = HEAP32[(HEAP32[i21 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
       }
       if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i6) | 0) break;
       i1 = i1 + 8 | 0;
       if ((i1 | 0) == (i3 | 0)) break L133;
      }
      HEAP32[HEAP32[i11 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
     }
    }
   } else __ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i15 >> 2] | 0, i3 << 24 >> 24 != 0, i10, i11) | 0; while (0);
  }
 } while (0);
 L174 : do if (!(HEAP8[i12 >> 0] | 0)) {
  if (!(HEAP8[i15 + 20 >> 0] | 0)) i5 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 128 >> 2] | 0; else i5 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(HEAP32[i13 >> 2] | 0) | 0;
  i4 = HEAP32[i15 + 8 >> 2] | 0;
  if (!i4) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, HEAP32[i16 >> 2] | 0) | 0;
   __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayIPN5Unity9ComponentELj4EEEiP11Il2CppArrayRKT_i(i1, i19, 0) | 0;
   break;
  }
  i3 = i4 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = _il2cpp_array_length(i1 | 0) | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, i2) | 0;
   HEAP32[i3 >> 2] = i1;
  } else i1 = HEAP32[i3 >> 2] | 0;
  __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayIPN5Unity9ComponentELj4EEEiP11Il2CppArrayRKT_i(i1, i19, 0) | 0;
  HEAP32[i4 + 12 >> 2] = HEAP32[i16 >> 2];
  i1 = i4 + 16 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = 0;
 } else {
  i3 = HEAP32[i14 >> 2] | 0;
  if (!i3) i1 = 0; else {
   i1 = HEAP32[i3 + 20 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
    if ((i1 | 0) == (gb + 27592 | 0)) i1 = 0; else {
     while (1) {
      i2 = __Z21GetManagerFromContexti(5) | 0;
      i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
      if (i2 | 0) break;
      i1 = HEAP32[i1 >> 2] | 0;
      if ((i1 | 0) == (gb + 28304 | 0)) {
       i1 = 0;
       break L174;
      }
     }
     i1 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
    }
   }
  }
 } while (0);
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i20;
 return i1 | 0;
}

function __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_(i1, i2, i34) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i34 = i34 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i41 + 216 | 0;
 i39 = i41 + 208 | 0;
 i35 = i41 + 40 | 0;
 i36 = i41 + 32 | 0;
 i37 = i41 + 24 | 0;
 i38 = i41 + 16 | 0;
 i30 = i41 + 8 | 0;
 i31 = i41;
 i28 = i41 + 200 | 0;
 i8 = i41 + 192 | 0;
 i9 = i41 + 184 | 0;
 i10 = i41 + 176 | 0;
 i11 = i41 + 168 | 0;
 i12 = i41 + 160 | 0;
 i13 = i41 + 152 | 0;
 i14 = i41 + 144 | 0;
 i15 = i41 + 136 | 0;
 i16 = i41 + 128 | 0;
 i17 = i41 + 120 | 0;
 i18 = i41 + 112 | 0;
 i19 = i41 + 104 | 0;
 i20 = i41 + 96 | 0;
 i21 = i41 + 88 | 0;
 i22 = i41 + 80 | 0;
 i23 = i41 + 72 | 0;
 i24 = i41 + 64 | 0;
 i25 = i41 + 56 | 0;
 i26 = i41 + 48 | 0;
 i32 = i2;
 L1 : while (1) {
  i7 = i32;
  i27 = i32 + -8 | 0;
  while (1) {
   i33 = i1;
   L5 : while (1) {
    i6 = i33;
    i1 = i7 - i6 | 0;
    i2 = i1 >> 3;
    switch (i2 | 0) {
    case 2:
     {
      i29 = 5;
      break L1;
     }
    case 3:
     {
      i29 = 7;
      break L1;
     }
    case 4:
     {
      i29 = 8;
      break L1;
     }
    case 5:
     {
      i29 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i29 = 57;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 248) {
     i29 = 15;
     break L1;
    }
    i4 = i33 + (((i2 | 0) / 2 | 0) << 3) | 0;
    if ((i1 | 0) > 7992) {
     i1 = (i2 | 0) / 4 | 0;
     i1 = __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_(i33, i33 + (i1 << 3) | 0, i4, i4 + (i1 << 3) | 0, i27, i34) | 0;
    } else i1 = __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i33, i4, i27, i34) | 0;
    i5 = HEAP32[i34 >> 2] | 0;
    i3 = i33;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i42 = i9;
    HEAP32[i42 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i42 + 4 >> 2] = i2;
    i42 = i4;
    i2 = HEAP32[i42 + 4 >> 2] | 0;
    i3 = i10;
    HEAP32[i3 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i3 + 4 >> 2] = i2;
    HEAP32[i39 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    if (mftCall_iii(i5 | 0, i39 | 0, i40 | 0) | 0) {
     i2 = i27;
     break;
    } else i2 = i27;
    while (1) {
     i2 = i2 + -8 | 0;
     if ((i33 | 0) == (i2 | 0)) break;
     i42 = HEAP32[i34 >> 2] | 0;
     i5 = i2;
     i3 = HEAP32[i5 + 4 >> 2] | 0;
     i43 = i19;
     HEAP32[i43 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i43 + 4 >> 2] = i3;
     i43 = i4;
     i3 = HEAP32[i43 + 4 >> 2] | 0;
     i5 = i20;
     HEAP32[i5 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i5 + 4 >> 2] = i3;
     HEAP32[i39 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i39 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i40 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i40 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     if (mftCall_iii(i42 | 0, i39 | 0, i40 | 0) | 0) {
      i29 = 40;
      break L5;
     }
    }
    i1 = i33 + 8 | 0;
    i43 = HEAP32[i34 >> 2] | 0;
    i42 = i33;
    i6 = HEAP32[i42 + 4 >> 2] | 0;
    i5 = i11;
    HEAP32[i5 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i5 + 4 >> 2] = i6;
    i5 = i27;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i42 = i12;
    HEAP32[i42 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i42 + 4 >> 2] = i6;
    HEAP32[i39 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    if (!(mftCall_iii(i43 | 0, i39 | 0, i40 | 0) | 0)) {
     if ((i1 | 0) == (i27 | 0)) {
      i29 = 57;
      break L1;
     }
     while (1) {
      i43 = HEAP32[i34 >> 2] | 0;
      i42 = i33;
      i6 = HEAP32[i42 + 4 >> 2] | 0;
      i5 = i13;
      HEAP32[i5 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i5 + 4 >> 2] = i6;
      i5 = i1;
      i6 = HEAP32[i5 + 4 >> 2] | 0;
      i42 = i14;
      HEAP32[i42 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i42 + 4 >> 2] = i6;
      HEAP32[i39 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i40 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      if (mftCall_iii(i43 | 0, i39 | 0, i40 | 0) | 0) break;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i27 | 0)) {
       i29 = 57;
       break L1;
      }
     }
     i42 = i1;
     i6 = HEAP32[i42 >> 2] | 0;
     i42 = HEAP32[i42 + 4 >> 2] | 0;
     i4 = i27;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i43 = i1;
     HEAP32[i43 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i43 + 4 >> 2] = i5;
     i43 = i27;
     HEAP32[i43 >> 2] = i6;
     HEAP32[i43 + 4 >> 2] = i42;
     i1 = i1 + 8 | 0;
    }
    if ((i1 | 0) == (i27 | 0)) {
     i29 = 57;
     break L1;
    } else i2 = i27;
    while (1) {
     while (1) {
      i43 = HEAP32[i34 >> 2] | 0;
      i3 = i33;
      i42 = HEAP32[i3 + 4 >> 2] | 0;
      i6 = i15;
      HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i6 + 4 >> 2] = i42;
      i6 = i1;
      i42 = HEAP32[i6 + 4 >> 2] | 0;
      i3 = i16;
      HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i3 + 4 >> 2] = i42;
      HEAP32[i39 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i40 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      i3 = i1 + 8 | 0;
      if (mftCall_iii(i43 | 0, i39 | 0, i40 | 0) | 0) break; else i1 = i3;
     }
     do {
      i43 = HEAP32[i34 >> 2] | 0;
      i42 = i33;
      i6 = HEAP32[i42 + 4 >> 2] | 0;
      i5 = i17;
      HEAP32[i5 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i5 + 4 >> 2] = i6;
      i2 = i2 + -8 | 0;
      i5 = i2;
      i6 = HEAP32[i5 + 4 >> 2] | 0;
      i42 = i18;
      HEAP32[i42 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i42 + 4 >> 2] = i6;
      HEAP32[i39 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i40 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     } while (mftCall_iii(i43 | 0, i39 | 0, i40 | 0) | 0);
     if (i1 >>> 0 >= i2 >>> 0) {
      i33 = i1;
      continue L5;
     }
     i43 = i1;
     i42 = HEAP32[i43 >> 2] | 0;
     i43 = HEAP32[i43 + 4 >> 2] | 0;
     i5 = i2;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i1 + 4 >> 2] = i6;
     i1 = i2;
     HEAP32[i1 >> 2] = i42;
     HEAP32[i1 + 4 >> 2] = i43;
     i1 = i3;
    }
   }
   if ((i29 | 0) == 40) {
    i29 = 0;
    i42 = i33;
    i5 = HEAP32[i42 >> 2] | 0;
    i42 = HEAP32[i42 + 4 >> 2] | 0;
    i44 = i2;
    i3 = HEAP32[i44 + 4 >> 2] | 0;
    i43 = i33;
    HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i43 + 4 >> 2] = i3;
    i43 = i2;
    HEAP32[i43 >> 2] = i5;
    HEAP32[i43 + 4 >> 2] = i42;
    i1 = i1 + 1 | 0;
   }
   i3 = i33 + 8 | 0;
   L35 : do if (i3 >>> 0 < i2 >>> 0) {
    i5 = i4;
    while (1) {
     while (1) {
      i44 = HEAP32[i34 >> 2] | 0;
      i4 = i3;
      i43 = HEAP32[i4 + 4 >> 2] | 0;
      i42 = i21;
      HEAP32[i42 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i42 + 4 >> 2] = i43;
      i42 = i5;
      i43 = HEAP32[i42 + 4 >> 2] | 0;
      i4 = i22;
      HEAP32[i4 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i4 + 4 >> 2] = i43;
      HEAP32[i39 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i40 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      i4 = i3 + 8 | 0;
      if (mftCall_iii(i44 | 0, i39 | 0, i40 | 0) | 0) i3 = i4; else break;
     }
     do {
      i44 = HEAP32[i34 >> 2] | 0;
      i2 = i2 + -8 | 0;
      i43 = i2;
      i42 = HEAP32[i43 + 4 >> 2] | 0;
      i45 = i23;
      HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
      HEAP32[i45 + 4 >> 2] = i42;
      i45 = i5;
      i42 = HEAP32[i45 + 4 >> 2] | 0;
      i43 = i24;
      HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
      HEAP32[i43 + 4 >> 2] = i42;
      HEAP32[i39 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i40 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     } while (!(mftCall_iii(i44 | 0, i39 | 0, i40 | 0) | 0));
     if (i3 >>> 0 > i2 >>> 0) {
      i2 = i5;
      break L35;
     }
     i44 = i3;
     i43 = HEAP32[i44 >> 2] | 0;
     i44 = HEAP32[i44 + 4 >> 2] | 0;
     i46 = i2;
     i42 = HEAP32[i46 + 4 >> 2] | 0;
     i45 = i3;
     HEAP32[i45 >> 2] = HEAP32[i46 >> 2];
     HEAP32[i45 + 4 >> 2] = i42;
     i45 = i2;
     HEAP32[i45 >> 2] = i43;
     HEAP32[i45 + 4 >> 2] = i44;
     i5 = (i5 | 0) == (i3 | 0) ? i2 : i5;
     i3 = i4;
     i1 = i1 + 1 | 0;
    }
   } else i2 = i4; while (0);
   if ((i3 | 0) != (i2 | 0)) {
    i46 = HEAP32[i34 >> 2] | 0;
    i45 = i2;
    i44 = HEAP32[i45 + 4 >> 2] | 0;
    i43 = i25;
    HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i43 + 4 >> 2] = i44;
    i43 = i3;
    i44 = HEAP32[i43 + 4 >> 2] | 0;
    i45 = i26;
    HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i45 + 4 >> 2] = i44;
    HEAP32[i39 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
     i45 = i3;
     i44 = HEAP32[i45 >> 2] | 0;
     i45 = HEAP32[i45 + 4 >> 2] | 0;
     i42 = i2;
     i43 = HEAP32[i42 + 4 >> 2] | 0;
     i46 = i3;
     HEAP32[i46 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i46 + 4 >> 2] = i43;
     i46 = i2;
     HEAP32[i46 >> 2] = i44;
     HEAP32[i46 + 4 >> 2] = i45;
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEbT0_S8_T_(i33, i3, i34) | 0;
    i1 = i3 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEbT0_S8_T_(i1, i32, i34) | 0) {
     i29 = 56;
     break;
    }
    if (i2) continue;
   }
   i46 = i3;
   if ((i46 - i6 | 0) >= (i7 - i46 | 0)) {
    i29 = 55;
    break;
   }
   __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_(i33, i3, i34);
   i1 = i3 + 8 | 0;
  }
  if ((i29 | 0) == 55) {
   i29 = 0;
   __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_(i3 + 8 | 0, i32, i34);
   i1 = i33;
   i32 = i3;
   continue;
  } else if ((i29 | 0) == 56) {
   i29 = 0;
   if (i2) {
    i29 = 57;
    break;
   } else {
    i1 = i33;
    i32 = i3;
    continue;
   }
  }
 }
 if ((i29 | 0) == 5) {
  i46 = HEAP32[i34 >> 2] | 0;
  i45 = i27;
  i44 = HEAP32[i45 + 4 >> 2] | 0;
  i43 = i28;
  HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i43 + 4 >> 2] = i44;
  i43 = i33;
  i44 = HEAP32[i43 + 4 >> 2] | 0;
  i45 = i8;
  HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i45 + 4 >> 2] = i44;
  HEAP32[i39 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  if (!(mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0)) {
   STACKTOP = i41;
   return;
  }
  i45 = i33;
  i44 = HEAP32[i45 >> 2] | 0;
  i45 = HEAP32[i45 + 4 >> 2] | 0;
  i42 = i27;
  i43 = HEAP32[i42 + 4 >> 2] | 0;
  i46 = i33;
  HEAP32[i46 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i46 + 4 >> 2] = i43;
  i46 = i27;
  HEAP32[i46 >> 2] = i44;
  HEAP32[i46 + 4 >> 2] = i45;
  STACKTOP = i41;
  return;
 } else if ((i29 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i33, i33 + 8 | 0, i27, i34) | 0;
  STACKTOP = i41;
  return;
 } else if ((i29 | 0) == 8) {
  i1 = i33 + 8 | 0;
  i2 = i33 + 16 | 0;
  __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i33, i1, i2, i34) | 0;
  i46 = HEAP32[i34 >> 2] | 0;
  i45 = i27;
  i44 = HEAP32[i45 + 4 >> 2] | 0;
  i43 = i35;
  HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i43 + 4 >> 2] = i44;
  i43 = i2;
  i44 = HEAP32[i43 + 4 >> 2] | 0;
  i45 = i36;
  HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i45 + 4 >> 2] = i44;
  HEAP32[i39 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
   i45 = i2;
   i44 = HEAP32[i45 >> 2] | 0;
   i45 = HEAP32[i45 + 4 >> 2] | 0;
   i42 = i27;
   i43 = HEAP32[i42 + 4 >> 2] | 0;
   i46 = i2;
   HEAP32[i46 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i46 + 4 >> 2] = i43;
   i46 = i27;
   HEAP32[i46 >> 2] = i44;
   HEAP32[i46 + 4 >> 2] = i45;
   i46 = HEAP32[i34 >> 2] | 0;
   i45 = i2;
   i44 = HEAP32[i45 + 4 >> 2] | 0;
   i43 = i37;
   HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i43 + 4 >> 2] = i44;
   i43 = i1;
   i44 = HEAP32[i43 + 4 >> 2] | 0;
   i45 = i38;
   HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i45 + 4 >> 2] = i44;
   HEAP32[i39 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
    i43 = i1;
    i42 = HEAP32[i43 >> 2] | 0;
    i43 = HEAP32[i43 + 4 >> 2] | 0;
    i44 = i2;
    i45 = HEAP32[i44 >> 2] | 0;
    i44 = HEAP32[i44 + 4 >> 2] | 0;
    i46 = i1;
    HEAP32[i46 >> 2] = i45;
    HEAP32[i46 + 4 >> 2] = i44;
    i46 = i2;
    HEAP32[i46 >> 2] = i42;
    HEAP32[i46 + 4 >> 2] = i43;
    i46 = HEAP32[i34 >> 2] | 0;
    i43 = i30;
    HEAP32[i43 >> 2] = i45;
    HEAP32[i43 + 4 >> 2] = i44;
    i43 = i33;
    i44 = HEAP32[i43 + 4 >> 2] | 0;
    i45 = i31;
    HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i45 + 4 >> 2] = i44;
    HEAP32[i39 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
     i45 = i33;
     i44 = HEAP32[i45 >> 2] | 0;
     i45 = HEAP32[i45 + 4 >> 2] | 0;
     i42 = i1;
     i43 = HEAP32[i42 + 4 >> 2] | 0;
     i46 = i33;
     HEAP32[i46 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i46 + 4 >> 2] = i43;
     i46 = i1;
     HEAP32[i46 >> 2] = i44;
     HEAP32[i46 + 4 >> 2] = i45;
    }
   }
  }
  STACKTOP = i41;
  return;
 } else if ((i29 | 0) == 13) {
  __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_(i33, i33 + 8 | 0, i33 + 16 | 0, i33 + 24 | 0, i27, i34) | 0;
  STACKTOP = i41;
  return;
 } else if ((i29 | 0) == 15) {
  i2 = i33 + 16 | 0;
  __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i33, i33 + 8 | 0, i2, i34) | 0;
  i1 = i33 + 24 | 0;
  if ((i1 | 0) != (i32 | 0)) while (1) {
   i46 = HEAP32[i34 >> 2] | 0;
   i45 = i1;
   i44 = HEAP32[i45 + 4 >> 2] | 0;
   i43 = i35;
   HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i43 + 4 >> 2] = i44;
   i43 = i2;
   i44 = HEAP32[i43 + 4 >> 2] | 0;
   i45 = i36;
   HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i45 + 4 >> 2] = i44;
   HEAP32[i39 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
    i5 = i1;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i3 = i1;
    while (1) {
     i44 = i2;
     i45 = HEAP32[i44 + 4 >> 2] | 0;
     i46 = i3;
     HEAP32[i46 >> 2] = HEAP32[i44 >> 2];
     HEAP32[i46 + 4 >> 2] = i45;
     if ((i2 | 0) == (i33 | 0)) break;
     i46 = HEAP32[i34 >> 2] | 0;
     i3 = i37;
     HEAP32[i3 >> 2] = i4;
     HEAP32[i3 + 4 >> 2] = i5;
     i3 = i2 + -8 | 0;
     i43 = i3;
     i44 = HEAP32[i43 + 4 >> 2] | 0;
     i45 = i38;
     HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i45 + 4 >> 2] = i44;
     HEAP32[i39 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i39 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
     if (mftCall_iii(i46 | 0, i39 | 0, i40 | 0) | 0) {
      i46 = i2;
      i2 = i3;
      i3 = i46;
     } else break;
    }
    i46 = i2;
    HEAP32[i46 >> 2] = i4;
    HEAP32[i46 + 4 >> 2] = i5;
   }
   i2 = i1 + 8 | 0;
   if ((i2 | 0) == (i32 | 0)) break; else {
    i46 = i1;
    i1 = i2;
    i2 = i46;
   }
  }
  STACKTOP = i41;
  return;
 } else if ((i29 | 0) == 57) {
  STACKTOP = i41;
  return;
 }
}

function __ZN9InputAxis8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13, i11) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 16 | 0;
 i10 = i15;
 i1 = i13 + 4 | 0;
 i7 = i1 + 11 | 0;
 i3 = HEAP8[i7 >> 0] | 0;
 i6 = i13 + 8 | 0;
 i2 = i3 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i3 & 255;
 HEAP32[i9 >> 2] = i2;
 i14 = i11 + 16 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i12 = i11 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i3 = HEAP8[i7 >> 0] | 0;
 }
 i4 = i3 << 24 >> 24 < 0;
 i2 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i3 & 255;
 i4 = i2 + i6 | 0;
 if (i6 | 0) do {
  i3 = HEAP32[i14 >> 2] | 0;
  if ((i3 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i2, 1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
 i6 = i13 + 24 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i13 + 28 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i3;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i6 = i13 + 40 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i13 + 44 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i3;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = HEAP32[i13 + 60 >> 2] | 0;
 do if (i1 >>> 0 > 569) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = i10 + 11 | 0;
  i2 = i10;
  i1 = 0;
  i8 = 34;
 } else {
  i1 = HEAP32[gb + 59864 + (i1 << 2) >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
  i1 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i10 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i7 = i1 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i9 >> 2] | 0 : i9;
  i1 = i7 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  if (i2 << 24 >> 24 < 0) {
   i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
   i5 = 1;
  } else {
   i4 = 10;
   i5 = 0;
  }
  if (i1 >>> 0 > i4 >>> 0) {
   i7 = i10 + 4 | 0;
   i5 = i5 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i1 - i4 | 0, i5, 0, i5, i1, i6);
   i6 = i7;
   break;
  }
  i2 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
  if (!i1) {
   i1 = 0;
   i8 = 34;
  } else {
   _memmove(i2 | 0, i6 | 0, i1 | 0) | 0;
   i8 = 34;
  }
 } while (0);
 do if ((i8 | 0) == 34) {
  HEAP8[i2 + i1 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i6 = i10 + 4 | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   HEAP8[i3 >> 0] = i1;
   i6 = i10 + 4 | 0;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i3 >> 0] | 0;
 }
 i7 = i2 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i7 = i7 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i4 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = HEAP32[i13 + 56 >> 2] | 0;
 do if (i1 >>> 0 > 569) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = i10 + 11 | 0;
  i2 = i10;
  i1 = 0;
  i8 = 55;
 } else {
  i1 = HEAP32[gb + 59864 + (i1 << 2) >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
  i1 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i10 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i7 = i1 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i9 >> 2] | 0 : i9;
  i1 = i7 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  if (i2 << 24 >> 24 < 0) {
   i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
   i5 = 1;
  } else {
   i4 = 10;
   i5 = 0;
  }
  if (i1 >>> 0 > i4 >>> 0) {
   i7 = i10 + 4 | 0;
   i5 = i5 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i1 - i4 | 0, i5, 0, i5, i1, i6);
   i6 = i7;
   break;
  }
  i2 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
  if (!i1) {
   i1 = 0;
   i8 = 55;
  } else {
   _memmove(i2 | 0, i6 | 0, i1 | 0) | 0;
   i8 = 55;
  }
 } while (0);
 do if ((i8 | 0) == 55) {
  HEAP8[i2 + i1 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i6 = i10 + 4 | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   HEAP8[i3 >> 0] = i1;
   i6 = i10 + 4 | 0;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i3 >> 0] | 0;
 }
 i7 = i2 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i7 = i7 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i4 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = HEAP32[i13 + 68 >> 2] | 0;
 do if (i1 >>> 0 > 569) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = i10 + 11 | 0;
  i2 = i10;
  i1 = 0;
  i8 = 76;
 } else {
  i1 = HEAP32[gb + 59864 + (i1 << 2) >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
  i1 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i10 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i7 = i1 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i9 >> 2] | 0 : i9;
  i1 = i7 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  if (i2 << 24 >> 24 < 0) {
   i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
   i5 = 1;
  } else {
   i4 = 10;
   i5 = 0;
  }
  if (i1 >>> 0 > i4 >>> 0) {
   i7 = i10 + 4 | 0;
   i5 = i5 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i1 - i4 | 0, i5, 0, i5, i1, i6);
   i6 = i7;
   break;
  }
  i2 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
  if (!i1) {
   i1 = 0;
   i8 = 76;
  } else {
   _memmove(i2 | 0, i6 | 0, i1 | 0) | 0;
   i8 = 76;
  }
 } while (0);
 do if ((i8 | 0) == 76) {
  HEAP8[i2 + i1 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i6 = i10 + 4 | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   HEAP8[i3 >> 0] = i1;
   i6 = i10 + 4 | 0;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i3 >> 0] | 0;
 }
 i7 = i2 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i7 = i7 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i4 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = HEAP32[i13 + 64 >> 2] | 0;
 do if (i1 >>> 0 > 569) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = i10 + 11 | 0;
  i2 = i10;
  i1 = 0;
  i8 = 97;
 } else {
  i1 = HEAP32[gb + 59864 + (i1 << 2) >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
  i1 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i10 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i7 = i1 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i9 >> 2] | 0 : i9;
  i1 = i7 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  if (i2 << 24 >> 24 < 0) {
   i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
   i5 = 1;
  } else {
   i4 = 10;
   i5 = 0;
  }
  if (i1 >>> 0 > i4 >>> 0) {
   i7 = i10 + 4 | 0;
   i5 = i5 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i1 - i4 | 0, i5, 0, i5, i1, i6);
   i6 = i3;
   i5 = i7;
   break;
  }
  i2 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
  if (!i1) {
   i1 = 0;
   i8 = 97;
   break;
  }
  _memmove(i2 | 0, i6 | 0, i1 | 0) | 0;
  i8 = 97;
 } while (0);
 do if ((i8 | 0) == 97) {
  HEAP8[i2 + i1 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i5 = i10 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   i6 = i3;
   break;
  } else {
   HEAP8[i3 >> 0] = i1;
   i6 = i3;
   i5 = i10 + 4 | 0;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i2 = HEAP8[i6 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i3 = HEAP32[i14 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i14 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i9, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i10 >> 2] | 0 : i10;
 i8 = i8 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 i1 = i13 + 92 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i13 + 96 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i13 + 100 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i13 + 104 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
  HEAP32[i14 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i1 = i13 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i13 + 76 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i13 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i13 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i2;
  STACKTOP = i15;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i14, i1, 4);
  STACKTOP = i15;
  return;
 }
}

function __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i27, i6, i7, i9, i1, i13, i4, i21, i12) {
 i27 = i27 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i21 = i21 | 0;
 i12 = i12 | 0;
 var i2 = 0, f3 = f0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i29 + 144 | 0;
 i23 = i29 + 80 | 0;
 i28 = i29 + 40 | 0;
 i26 = i29;
 i2 = i29 + 92 | 0;
 i19 = i29 + 132 | 0;
 i22 = i29 + 128 | 0;
 switch (i1 | 0) {
 case 7:
  {
   i1 = __Z12GetGfxDevicev() | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 704 >> 2] | 0, i1 | 0) | 0;
   break;
  }
 case 9:
  {
   i1 = __Z12GetGfxDevicev() | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 708 >> 2] | 0, i1 | 0) | 0;
   break;
  }
 default:
  {}
 }
 i24 = i13 >>> 1;
 i10 = i13 & 1;
 i8 = (i10 | 0) != 0;
 i10 = (i10 << 1) + 2 | 0;
 if ((i4 | 0) != 1 & (__Z19GetActiveColorSpacev() | 0) == 1) {
  i11 = __Z12GetGfxDevicev() | 0;
  i11 = (i1 | 0) != (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 708 >> 2] | 0, i11 | 0) | 0) & 1;
 } else i11 = 0;
 if ((i6 | 0) < 1 | (i7 | 0) < 1) {
  if (i8) {
   i28 = 0;
   STACKTOP = i29;
   return i28 | 0;
  }
  i4 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (!i4) {
   i28 = 0;
   STACKTOP = i29;
   return i28 | 0;
  }
  __ZNK6Camera24GetScreenViewportRectIntEv(i5, i4);
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  if ((i6 | 0) < 0) i6 = (i4 | 0) / (0 - i6 | 0) | 0; else i6 = i4;
  i4 = HEAP32[i5 + 12 >> 2] | 0;
  if ((i7 | 0) < 0) i4 = (i4 | 0) / (0 - i7 | 0) | 0;
  i14 = i4;
 } else i14 = i7;
 if (i8) {
  i4 = i12 + -1 | 0;
  if (i4 >>> 0 > 7 | ((i6 | 0) != (i14 | 0) | (i6 + -1 & i6 | 0) != 0)) {
   i28 = 0;
   STACKTOP = i29;
   return i28 | 0;
  }
 } else {
  i4 = i12 + -1 | 0;
  if (i4 >>> 0 > 7) {
   i28 = 0;
   STACKTOP = i29;
   return i28 | 0;
  }
 }
 if (i4 & i12 | 0) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i15 = i2 + 4 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = i9;
 i15 = i2 + 4 | 0;
 HEAP32[i15 >> 2] = i1;
 i17 = i2 + 8 | 0;
 HEAP32[i17 >> 2] = i10;
 i16 = i2 + 12 | 0;
 HEAP8[i16 >> 0] = i11;
 HEAP32[i2 + 16 >> 2] = i21;
 i18 = i2 + 20 | 0;
 HEAP32[i18 >> 2] = i12;
 i20 = i2 + 24 | 0;
 HEAP8[i20 >> 0] = i13 >>> 2 & 1;
 i8 = i2 + 28 | 0;
 HEAP32[i8 >> 2] = i6;
 i11 = i2 + 32 | 0;
 HEAP32[i11 >> 2] = i14;
 i7 = i27;
 i1 = HEAP32[i27 + 4 >> 2] | 0;
 i4 = i1;
 L32 : do if ((i4 | 0) == (i27 | 0)) i12 = i7; else while (1) {
  if (__ZN19RenderBufferManager24IsReusableWithParametersERKNSt3__24pairIK4PPtrI13RenderTextureENS_23RenderTextureParametersEEERKS6_(i1 + 12 | 0, i2) | 0) {
   i12 = i1;
   break L32;
  }
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i4 = i1;
  if ((i4 | 0) == (i27 | 0)) {
   i12 = i7;
   break;
  }
 } while (0);
 do if ((i12 | 0) == (i27 | 0)) i25 = 31; else {
  i10 = i12;
  i9 = i10 + 12 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) i25 = 31; else {
   HEAP32[i28 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i25 = 28; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i7 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i4 + (i7 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i28);
     i4 = HEAP32[i5 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i7 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i4 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i4 << 3) | 0;
     i4 = HEAP32[i7 + 28 >> 2] | 0;
     i7 = HEAP32[i7 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 + (i7 << 3) | 0)) i25 = 28; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i25 = 30;
   }
   if ((i25 | 0) == 28) i25 = 30;
   if ((i25 | 0) == 30) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0)) {
    i25 = 31;
    break;
   }
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i28 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i25 = 96; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i28);
      i2 = HEAP32[i5 >> 2] | 0;
      i23 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
      i2 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i25 = 96; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i25 = 98;
     }
    }
    if ((i25 | 0) == 96) i25 = 98;
    if ((i25 | 0) == 98) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
   }
   i9 = i27 + 12 | 0;
   i8 = i10 + 12 | 0;
   i4 = i27 + 16 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   do if (!i2) {
    HEAP32[i5 >> 2] = i4;
    i7 = i4;
    i6 = i4;
   } else {
    i7 = HEAP32[i8 >> 2] | 0;
    while (1) {
     i4 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i7 | 0) < (i4 | 0)) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i25 = 104;
       break;
      } else i2 = i4;
     } else {
      if ((i4 | 0) >= (i7 | 0)) {
       i25 = 109;
       break;
      }
      i6 = i2 + 4 | 0;
      i4 = HEAP32[i6 >> 2] | 0;
      if (!i4) {
       i25 = 108;
       break;
      } else i2 = i4;
     }
    }
    if ((i25 | 0) == 104) {
     HEAP32[i5 >> 2] = i2;
     i7 = i2;
     i6 = i2;
     break;
    } else if ((i25 | 0) == 108) {
     HEAP32[i5 >> 2] = i2;
     i7 = i2;
     break;
    } else if ((i25 | 0) == 109) {
     HEAP32[i5 >> 2] = i2;
     i7 = i2;
     i6 = i5;
     break;
    }
   } while (0);
   if (!(HEAP32[i6 >> 2] | 0)) {
    __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE16__construct_nodeERKNS_4pairIKS4_S6_EE(i28, i9, i8);
    i2 = HEAP32[i28 >> 2] | 0;
    HEAP32[i28 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i7;
    HEAP32[i6 >> 2] = i2;
    i4 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i9 >> 2] = i4;
     i2 = HEAP32[i6 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i27 + 16 >> 2] | 0, i2);
    i23 = i27 + 20 | 0;
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
   }
   HEAP32[i22 >> 2] = i12;
   HEAP32[i5 >> 2] = HEAP32[i22 >> 2];
   __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5eraseENS_21__list_const_iteratorIS9_PvEE(i27, i5) | 0;
   __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
   HEAP32[i1 + 44 >> 2] = 1;
   HEAP32[i1 + 36 >> 2] = 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
   i27 = i24 & 1;
   HEAP8[i1 + 121 >> 0] = i27;
   do if (i27 | 0) {
    i2 = i1 + 128 | 0;
    i4 = i1 + 136 | 0;
    if (!(HEAP32[i2 >> 2] | 0)) if (!(HEAP32[i4 >> 2] | 0)) break;
    i6 = __Z12GetGfxDevicev() | 0;
    i27 = HEAP32[i2 >> 2] | 0;
    HEAP32[i5 >> 2] = i27;
    i2 = HEAP32[i1 + 132 >> 2] | 0;
    HEAP32[i28 >> 2] = i2;
    HEAP32[i26 >> 2] = HEAP32[i4 >> 2];
    if (i27) {
     mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 336 >> 2] | 0, i6 | 0, i5 | 0);
     i2 = HEAP32[i28 >> 2] | 0;
    }
    if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 336 >> 2] | 0, i6 | 0, i28 | 0);
    if (HEAP32[i26 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 336 >> 2] | 0, i6 | 0, i26 | 0);
   } while (0);
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0)) {
    i2 = i1 + 72 | 0;
    f3 = Math_fround(HEAPF32[i2 >> 2]);
    if (f3 < Math_fround(0.0)) HEAPF32[i2 >> 2] = Math_fround(-f3);
   }
  }
 } while (0);
 if ((i25 | 0) == 31) {
  i9 = i27 + 28 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 407408 | 0, 144) | 0;
  i13 = gb + 63520 | 0;
  i22 = HEAP32[i13 + 4 >> 2] | 0;
  i4 = i28;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = i22;
  HEAP32[i5 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i1, i5, 0);
  HEAP32[i1 >> 2] = gb + 44300 + 8;
  HEAP32[i1 + 96 >> 2] = 0;
  HEAP32[i1 + 100 >> 2] = 2;
  HEAP32[i1 + 104 >> 2] = 2;
  HEAP32[i1 + 108 >> 2] = 2;
  HEAP32[i1 + 112 >> 2] = 0;
  HEAP8[i1 + 116 >> 0] = 0;
  HEAP8[i1 + 117 >> 0] = 1;
  i4 = i1 + 118 | 0;
  HEAP16[i4 >> 1] = 0;
  HEAP16[i4 + 2 >> 1] = 0;
  HEAP8[i4 + 4 >> 0] = 0;
  HEAP8[i1 + 123 >> 0] = 1;
  i4 = i1 + 124 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = 0;
  HEAP32[i1 + 152 >> 2] = i1;
  HEAP32[i1 + 80 >> 2] = 256;
  HEAP32[i1 + 84 >> 2] = 256;
  HEAP32[i1 + 92 >> 2] = 1;
  HEAP32[i1 + 88 >> 2] = 1;
  HEAP32[i1 + 44 >> 2] = 1;
  i22 = __Z25GetUncheckedRealGfxDevicev() | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 420 >> 2] | 0, i22 | 0) | 0;
  HEAP8[i1 + 156 >> 0] = 0;
  __Z19pop_allocation_rootv();
  i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i23 + 4 >> 2] = i6;
  HEAP32[i23 + 8 >> 2] = i14;
  __Z6FormatPKcz(i19, gb + 407489 | 0, i23);
  mftCall_vii(i4 | 0, i1 | 0, ((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  i4 = HEAP32[i8 >> 2] | 0;
  i9 = i1 + 128 | 0;
  if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
   HEAP32[i1 + 80 >> 2] = i4;
   i6 = (HEAP8[i1 + 116 >> 0] | 0) == 0;
   i8 = i1 + 76 | 0;
   HEAP32[i8 >> 2] = 1;
   if (i4 | 0) {
    i7 = HEAP32[i1 + 84 >> 2] | 0;
    if (i7 | 0) {
     f3 = Math_fround(Math_fround(1.0) / Math_fround(i7 | 0));
     HEAPF32[i1 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i4 | 0));
     HEAPF32[i1 + 72 >> 2] = f3;
     if (i6) i4 = 1; else i4 = __Z22CalculateMipMapCount3Diii(i4, i7, 1) | 0;
     HEAP32[i8 >> 2] = i4;
    }
   }
  } else i25 = 38; else i25 = 38;
  if ((i25 | 0) == 38) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407509 | 0, 0, gb + 406201 | 0, 911, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  i4 = HEAP32[i11 >> 2] | 0;
  if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
   HEAP32[i1 + 84 >> 2] = i4;
   i6 = HEAP8[i1 + 116 >> 0] | 0;
   i8 = i1 + 76 | 0;
   HEAP32[i8 >> 2] = 1;
   i7 = HEAP32[i1 + 80 >> 2] | 0;
   if (!((i4 | 0) == 0 | (i7 | 0) == 0)) {
    f3 = Math_fround(Math_fround(1.0) / Math_fround(i4 | 0));
    HEAPF32[i1 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i7 | 0));
    HEAPF32[i1 + 72 >> 2] = f3;
    if (!(i6 << 24 >> 24)) i4 = 1; else i4 = __Z22CalculateMipMapCount3Diii(i7, i4, 1) | 0;
    HEAP32[i8 >> 2] = i4;
   }
  } else i25 = 45; else i25 = 45;
  if ((i25 | 0) == 45) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407575 | 0, 0, gb + 406201 | 0, 921, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i1, HEAP32[i15 >> 2] | 0);
  i4 = HEAP32[i2 >> 2] | 0;
  do if (i4 >>> 0 > 2) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407642 | 0, 0, gb + 406201 | 0, 939, 1, 0, 0, 0); else {
   i6 = i1 + 100 | 0;
   if ((HEAP32[i6 >> 2] | 0) != (i4 | 0)) {
    if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
     HEAP32[i6 >> 2] = i4;
     break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407669 | 0, 0, gb + 406201 | 0, 942, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   }
  } while (0);
  __ZN13RenderTexture12SetDimensionE16TextureDimension(i1, HEAP32[i17 >> 2] | 0);
  if (!(HEAP8[i16 >> 0] | 0)) i6 = 0; else if ((__Z19GetActiveColorSpacev() | 0) == 1) {
   i25 = HEAP32[i1 + 96 >> 2] | 0;
   i6 = __Z12GetGfxDevicev() | 0;
   i6 = (i25 | 0) != (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 708 >> 2] | 0, i6 | 0) | 0);
  } else i6 = 0;
  i4 = i1 + 118 | 0;
  do if ((HEAPU8[i4 >> 0] | 0) != (i6 & 1 | 0)) {
   if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
    HEAP8[i4 >> 0] = i6 & 1;
    break;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407742 | 0, 0, gb + 406201 | 0, 886, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  } while (0);
  i4 = i1 + 112 | 0;
  do if ((HEAP32[i4 >> 2] | 0) != (i21 | 0)) {
   if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i21;
    break;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407812 | 0, 0, gb + 406201 | 0, 891, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  } while (0);
  i4 = HEAP32[i18 >> 2] | 0;
  do if (!(i4 + -1 & (i4 | -8))) {
   i6 = i1 + 88 | 0;
   if ((HEAP32[i6 >> 2] | 0) != (i4 | 0)) {
    if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
     HEAP32[i6 >> 2] = i4;
     break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407931 | 0, 0, gb + 406201 | 0, 873, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   }
  } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407881 | 0, 0, gb + 406201 | 0, 870, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0); while (0);
  HEAP8[i1 + 122 >> 0] = HEAP8[i20 >> 0] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
  if (!(i24 & 1)) {
   HEAP32[i5 >> 2] = 0;
   __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i1, i5, i5) | 0;
  }
  i8 = i27 + 12 | 0;
  i6 = i26;
  i4 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   i6 = i6 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i6 | 0) < (i4 | 0));
  i7 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i28 >> 2] = i7;
  i6 = i28 + 4 | 0;
  i2 = i26;
  i4 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   i6 = i6 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i6 | 0) < (i4 | 0));
  i4 = i27 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if (!i2) {
   HEAP32[i5 >> 2] = i4;
   i7 = i4;
   i5 = i4;
  } else {
   while (1) {
    i4 = HEAP32[i2 + 16 >> 2] | 0;
    if ((i7 | 0) < (i4 | 0)) {
     i4 = HEAP32[i2 >> 2] | 0;
     if (!i4) {
      i25 = 78;
      break;
     } else i2 = i4;
    } else {
     if ((i4 | 0) >= (i7 | 0)) {
      i25 = 83;
      break;
     }
     i6 = i2 + 4 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     if (!i4) {
      i25 = 82;
      break;
     } else i2 = i4;
    }
   }
   if ((i25 | 0) == 78) {
    HEAP32[i5 >> 2] = i2;
    i7 = i2;
    i5 = i2;
    break;
   } else if ((i25 | 0) == 82) {
    HEAP32[i5 >> 2] = i2;
    i7 = i2;
    i5 = i6;
    break;
   } else if ((i25 | 0) == 83) {
    HEAP32[i5 >> 2] = i2;
    i7 = i2;
    break;
   }
  } while (0);
  if (!(HEAP32[i5 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE16__construct_nodeERKNS_4pairIKS4_S6_EE(i23, i8, i28);
   i2 = HEAP32[i23 >> 2] | 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i7;
   HEAP32[i5 >> 2] = i2;
   i4 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i8 >> 2] = i4;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i27 + 16 >> 2] | 0, i2);
   i28 = i27 + 20 | 0;
   HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + 1;
  }
 }
 i28 = i1;
 STACKTOP = i29;
 return i28 | 0;
}

function __ZN9InputAxis8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i5 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 3);
 i1 = i6 + 4 | 0;
 i4 = HEAP32[gb + 37260 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034561 | 0, i4, i7, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1, 1); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
 i2 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434610 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434626 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434650 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i5, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i9 + 128 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) i1 = i5 + 11 | 0; else {
  i1 = i5 + 11 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i12 = i2 << 24 >> 24 < 0;
  i11 = i12 ? HEAP32[i5 >> 2] | 0 : i5;
  i2 = i12 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, i2);
  i2 = HEAP8[i7 + 11 >> 0] | 0;
  if (!((i2 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i2 & 255) | 0)) i2 = 0; else {
   i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i7) | 0;
   if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i2 + 28 >> 2] | 0;
  }
  HEAP32[i6 + 60 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434665 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i5, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(HEAP8[i3 >> 0] | 0)) i1 = i5 + 11 | 0; else {
  i1 = i5 + 11 | 0;
  i12 = HEAP8[i1 >> 0] | 0;
  i2 = i12 << 24 >> 24 < 0;
  i11 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
  i12 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i12 & 255;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, i12);
  i12 = HEAP8[i7 + 11 >> 0] | 0;
  if (!((i12 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255) | 0)) i2 = 0; else {
   i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i7) | 0;
   if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i2 + 28 >> 2] | 0;
  }
  HEAP32[i6 + 56 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434680 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i5, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(HEAP8[i3 >> 0] | 0)) i1 = i5 + 11 | 0; else {
  i1 = i5 + 11 | 0;
  i12 = HEAP8[i1 >> 0] | 0;
  i2 = i12 << 24 >> 24 < 0;
  i11 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
  i12 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i12 & 255;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, i12);
  i12 = HEAP8[i7 + 11 >> 0] | 0;
  if (!((i12 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255) | 0)) i2 = 0; else {
   i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i7) | 0;
   if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i2 + 28 >> 2] | 0;
  }
  HEAP32[i6 + 68 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434698 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i5, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(HEAP8[i3 >> 0] | 0)) i1 = i5 + 11 | 0; else {
  i1 = i5 + 11 | 0;
  i12 = HEAP8[i1 >> 0] | 0;
  i4 = i12 << 24 >> 24 < 0;
  i11 = i4 ? HEAP32[i5 >> 2] | 0 : i5;
  i12 = i4 ? HEAP32[i5 + 4 >> 2] | 0 : i12 & 255;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, i12);
  i12 = HEAP8[i7 + 11 >> 0] | 0;
  if (!((i12 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255) | 0)) i2 = 0; else {
   i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i7) | 0;
   if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i2 + 28 >> 2] | 0;
  }
  HEAP32[i6 + 64 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 }
 i4 = i6 + 92 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434716 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i12 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 83;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434724 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i12 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 94;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434729 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i12 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 105;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 104 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434741 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  L152 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i12 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L152;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 105 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434746 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  L164 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i12 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L164;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 76 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1047471 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i12 >>> 0) i8 = 134; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 134;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 134) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434753 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i12 >>> 0) i8 = 145; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 145;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 145) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 434758 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i12 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i12 >>> 0) i8 = 156; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 156;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 156) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i9 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_(i1, i10, i14) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 104 | 0;
 i11 = i16 + 80 | 0;
 i6 = i16 + 60 | 0;
 i7 = i16 + 40 | 0;
 i8 = i16 + 20 | 0;
 i9 = i16;
 L1 : do if ((i10 - i1 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == 83) {
  i4 = HEAP8[i1 + 1 >> 0] | 0;
  L4 : do switch (i4 | 0) {
  case 97:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc(i15, gb + 1086482 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i9 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i9);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 98:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc(i15, gb + 1086497 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i8, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i8 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i8);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i8);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 115:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i15, gb + 1086515 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i7, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i7 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i7);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i7);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 105:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc(i15, gb + 1086527 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i6, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i6 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i6);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i6);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 111:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc(i15, gb + 1086540 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i15);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i11, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i11 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i11);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 100:
   {
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc(i11, gb + 1086553 | 0);
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i11);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i15 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i11);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
    i1 = i1 + 2 | 0;
    break L1;
   }
  case 95:
   {
    i2 = HEAP32[i14 + 16 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i14 + 20 >> 2] | 0)) break L1;
    i7 = HEAP32[i2 + 4 >> 2] | 0;
    i8 = i14 + 4 | 0;
    i9 = i14 + 8 | 0;
    i10 = i14 + 12 | 0;
    i11 = i15 + 8 | 0;
    i6 = HEAP32[i2 >> 2] | 0;
    while (1) {
     if ((i6 | 0) == (i7 | 0)) {
      i2 = 43;
      break;
     }
     i3 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i9 >> 2] | 0;
     i4 = i13;
     if ((i3 | 0) == (i13 | 0)) {
      i5 = HEAP32[i14 >> 2] | 0;
      i2 = (i3 - i5 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       i2 = 49;
       break;
      }
      i5 = (i4 - i5 | 0) / 24 | 0;
      i13 = i5 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i5 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i10);
      i3 = HEAP32[i11 >> 2] | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i3 | 0, i6 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i2 = 53;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i6 + 12 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i2 = 52;
       break;
      }
      HEAP32[i11 >> 2] = i3 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i6);
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i6 + 12 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i2 = 46;
       break;
      }
      HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 24;
     }
     i6 = i6 + 24 | 0;
    }
    if ((i2 | 0) == 43) {
     i1 = i1 + 2 | 0;
     break L1;
    } else if ((i2 | 0) == 46) {
     i16 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
     ___resumeException(i16 | 0);
    } else if ((i2 | 0) == 49) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14); else if ((i2 | 0) == 52) {
     i12 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
    } else if ((i2 | 0) == 53) {
     i12 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    }
    __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
    ___resumeException(i12 | 0);
   }
  default:
   {
    i3 = i4 + -48 | 0;
    i2 = i3 >>> 0 < 10;
    if (!i2) if (!(_isupper(i4) | 0)) break L1;
    i11 = i1 + 2 | 0;
    i2 = i2 ? i3 : i4 + -55 | 0;
    while (1) {
     if ((i11 | 0) == (i10 | 0)) break L1;
     i3 = HEAP8[i11 >> 0] | 0;
     i4 = i3 << 24 >> 24;
     i6 = i4 + -48 | 0;
     i5 = i6 >>> 0 < 10;
     if (!i5) if (!(_isupper(i4) | 0)) break;
     i11 = i11 + 1 | 0;
     i2 = (i5 ? i6 : i4 + -55 | 0) + (i2 * 36 | 0) | 0;
    }
    if (i3 << 24 >> 24 != 95) break L1;
    i2 = i2 + 1 | 0;
    i12 = HEAP32[i14 + 16 >> 2] | 0;
    i3 = i12;
    if (i2 >>> 0 >= (HEAP32[i14 + 20 >> 2] | 0) - i12 >> 4 >>> 0) break L1;
    i6 = HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0;
    i7 = i14 + 4 | 0;
    i8 = i14 + 8 | 0;
    i9 = i14 + 12 | 0;
    i10 = i15 + 8 | 0;
    i5 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
    while (1) {
     if ((i5 | 0) == (i6 | 0)) {
      i2 = 68;
      break;
     }
     i1 = HEAP32[i7 >> 2] | 0;
     i12 = HEAP32[i8 >> 2] | 0;
     i3 = i12;
     if ((i1 | 0) == (i12 | 0)) {
      i4 = HEAP32[i14 >> 2] | 0;
      i1 = (i1 - i4 | 0) / 24 | 0;
      i2 = i1 + 1 | 0;
      if (i2 >>> 0 > 178956970) {
       i2 = 74;
       break;
      }
      i4 = (i3 - i4 | 0) / 24 | 0;
      i12 = i4 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i4 >>> 0 < 89478485 ? (i12 >>> 0 < i2 >>> 0 ? i2 : i12) : 178956970, i1, i9);
      i1 = HEAP32[i10 >> 2] | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i1 | 0, i5 | 0);
      i12 = __THREW__;
      __THREW__ = 0;
      if (i12 & 1) {
       i2 = 78;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i1 + 12 | 0, i5 + 12 | 0);
      i12 = __THREW__;
      __THREW__ = 0;
      if (i12 & 1) {
       i2 = 77;
       break;
      }
      HEAP32[i10 >> 2] = i1 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i1, i5);
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i1 + 12 | 0, i5 + 12 | 0);
      i12 = __THREW__;
      __THREW__ = 0;
      if (i12 & 1) {
       i2 = 71;
       break;
      }
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 24;
     }
     i5 = i5 + 24 | 0;
    }
    if ((i2 | 0) == 68) {
     i1 = i11 + 1 | 0;
     break L1;
    } else if ((i2 | 0) == 71) {
     i16 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
     ___resumeException(i16 | 0);
    } else if ((i2 | 0) == 74) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14); else if ((i2 | 0) == 77) {
     i13 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
    } else if ((i2 | 0) == 78) {
     i13 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    }
    __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
    ___resumeException(i13 | 0);
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 348 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 352 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 356 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 108 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 112 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 116 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 140 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 144 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
  i3 = i2;
 }
 i1 = i5 + 148 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 152 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 156 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 160 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 164 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 168 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 172 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 176 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 180 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 184 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 188 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 192 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 196 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 200 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 296 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 300 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 324 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 328 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 332 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 204 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 208 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 212 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 216 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 220 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 224 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 228 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 232 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 236 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i6, i5 + 308 | 0, gb + 735246 | 0, 0);
 i1 = i5 + 336 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 340 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 344 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 252 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 256 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 260 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 240 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 244 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 248 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 264 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 268 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 272 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 276 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 280 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 284 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 292 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 293 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
  return;
 }
}

function __ZN5physx17ConvexHullBuilder17CreatePolygonDataEv(i46) {
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, f48 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i47;
 i44 = i47 + 56 | 0;
 i45 = i47 + 40 | 0;
 i43 = i47 + 24 | 0;
 i39 = i47 + 16 | 0;
 i13 = i47 + 74 | 0;
 i14 = i47 + 73 | 0;
 i38 = i47 + 4 | 0;
 i40 = i47 + 72 | 0;
 i41 = i46 + 20 | 0;
 HEAP8[(HEAP32[i41 >> 2] | 0) + 39 >> 0] = 0;
 i37 = i46 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i47 + 78 | 0, HEAP32[i37 >> 2] | 0);
 HEAP32[i37 >> 2] = 0;
 i42 = i46 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i47 + 77 | 0, HEAP32[i42 >> 2] | 0);
 HEAP32[i42 >> 2] = 0;
 i42 = i46 + 4 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i47 + 76 | 0, HEAP32[i42 >> 2] | 0);
 HEAP32[i42 >> 2] = 0;
 __ZN5physx2Gu9ContainerC2Ev(i44);
 __ZN5physx2Gu9ContainerC2Ev(i45);
 __ZN5physx2Gu9ContainerC2Ev(i43);
 if (!(__ZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_(i39, i44, i46, i45, i43) | 0)) {
  i46 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i43);
  __ZN5physx2Gu9ContainerD2Ev(i45);
  __ZN5physx2Gu9ContainerD2Ev(i44);
  STACKTOP = i47;
  return i46 | 0;
 }
 i2 = HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0;
 i1 = HEAP32[i43 + 4 >> 2] | 0;
 if (!i1) {
  i7 = HEAP32[i39 >> 2] | 0;
  i12 = HEAP32[i46 >> 2] | 0;
 } else {
  i12 = (i2 & 255) - i1 | 0;
  i2 = i12 & 255;
  i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i47 + 75 | 0, (i12 & 255) * 12 | 0, gb + 726825 | 0, 1440) | 0;
  i1 = HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i10 = 0; else {
   i36 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i35 = HEAP32[(HEAP32[i36 >> 2] | 0) + 8 >> 2] | 0;
   i10 = _PxGetFoundation() | 0;
   i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0;
   i10 = mftCall_iiiiii(i35 | 0, i36 | 0, i1 & 255 | 0, (i10 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1441) | 0;
   if (HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0) {
    i11 = 0;
    i8 = 0;
    i1 = 0;
    while (1) {
     if (__ZNK5physx2Gu9Container8ContainsEjPj(i43, i11, 0) | 0) i7 = -1; else {
      i7 = i8 & 255;
      i36 = HEAP32[i46 >> 2] | 0;
      HEAP32[i12 + (i7 * 12 | 0) >> 2] = HEAP32[i36 + (i11 * 12 | 0) >> 2];
      HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] = HEAP32[i36 + (i11 * 12 | 0) + 4 >> 2];
      HEAP32[i12 + (i7 * 12 | 0) + 8 >> 2] = HEAP32[i36 + (i11 * 12 | 0) + 8 >> 2];
      i7 = i8;
      i8 = i8 + 1 << 24 >> 24;
     }
     HEAP8[i10 + i11 >> 0] = i7;
     i1 = i1 + 1 << 24 >> 24;
     if ((i1 & 255) < (HEAPU8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0)) i11 = i1 & 255; else break;
    }
   }
  }
  i1 = HEAP32[i39 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i8 = HEAP32[i44 + 8 >> 2] | 0;
   i11 = 0;
   while (1) {
    i7 = HEAP32[i8 >> 2] | 0;
    if (i7) {
     i1 = 0;
     do {
      i1 = i1 + 1 | 0;
      i36 = i8 + (i1 << 2) | 0;
      HEAP32[i36 >> 2] = HEAPU8[i10 + (HEAP32[i36 >> 2] | 0) >> 0];
     } while ((i1 | 0) != (i7 | 0));
     i1 = HEAP32[i39 >> 2] | 0;
    }
    i11 = i11 + 1 | 0;
    if (i11 >>> 0 >= i1 >>> 0) break; else i8 = i8 + (i7 + 1 << 2) | 0;
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i10);
  i7 = i1;
 }
 if (i7 >>> 0 > 255) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726825 | 0, 1479, gb + 727038 | 0, i15);
  i46 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i43);
  __ZN5physx2Gu9ContainerD2Ev(i45);
  __ZN5physx2Gu9ContainerD2Ev(i44);
  STACKTOP = i47;
  return i46 | 0;
 }
 HEAP8[(HEAP32[i41 >> 2] | 0) + 39 >> 0] = i7;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, (i7 & 255) * 20 | 0, gb + 726825 | 0, 1485) | 0;
 HEAP32[i42 >> 2] = i1;
 _memset(i1 | 0, 0, (HEAPU8[(HEAP32[i41 >> 2] | 0) + 39 >> 0] | 0) * 20 | 0) | 0;
 __ZNK5physx17ConvexHullBuilder17ComputeGeomCenterERNS_6PxVec3E(i46, i38) | 0;
 i1 = HEAP32[i44 + 4 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) i1 = 0; else {
  i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i34 = HEAP32[(HEAP32[i35 >> 2] | 0) + 8 >> 2] | 0;
  i36 = _PxGetFoundation() | 0;
  i36 = mftCall_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 24 >> 2] | 0, i36 | 0) | 0;
  i1 = mftCall_iiiiii(i34 | 0, i35 | 0, i1 - i7 | 0, (i36 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1496) | 0;
 }
 HEAP32[i37 >> 2] = i1;
 L33 : do if (!i7) i15 = 0; else {
  i32 = (i12 | 0) != 0;
  i33 = i38 + 4 | 0;
  i34 = i38 + 8 | 0;
  i35 = i46 + 36 | 0;
  i10 = i1;
  i7 = HEAP32[i42 >> 2] | 0;
  i36 = HEAP32[i44 + 8 >> 2] | 0;
  i30 = i1;
  i27 = HEAP32[i45 + 8 >> 2] | 0;
  i31 = 0;
  while (1) {
   HEAP16[i7 + (i31 * 20 | 0) + 16 >> 1] = i30 - i10;
   i29 = HEAP32[i36 >> 2] | 0;
   i1 = i29 & 255;
   HEAP8[i7 + (i31 * 20 | 0) + 18 >> 0] = i1;
   L37 : do if (i29) {
    i10 = 0;
    i1 = 0;
    while (1) {
     i8 = i1;
     while (1) {
      i8 = i8 + 1 | 0;
      i1 = HEAP32[i36 + (i8 << 2) >> 2] | 0;
      if ((i1 | 0) != 255) {
       i7 = i1;
       i1 = i8;
       break;
      }
      i7 = HEAP32[i42 >> 2] | 0;
      i28 = i7 + (i31 * 20 | 0) + 18 | 0;
      i1 = (HEAP8[i28 >> 0] | 0) + -1 << 24 >> 24;
      HEAP8[i28 >> 0] = i1;
      if (i8 >>> 0 >= i29 >>> 0) break L37;
     }
     HEAP8[i30 + i10 >> 0] = i7;
     if (i1 >>> 0 < i29 >>> 0) i10 = i10 + 1 | 0; else break;
    }
    i7 = HEAP32[i42 >> 2] | 0;
    i1 = HEAP8[i7 + (i31 * 20 | 0) + 18 >> 0] | 0;
   } while (0);
   i26 = i1 & 255;
   i28 = (i30 | 0) != 0;
   i25 = i28 & i1 << 24 >> 24 != 0;
   if (i32 & i25) {
    i11 = HEAPU8[i30 + (i26 + -1) >> 0] | 0;
    f6 = Math_fround(HEAPF32[i12 + (i11 * 12 | 0) + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i12 + (i11 * 12 | 0) + 8 >> 2]);
    i10 = 0;
    f19 = Math_fround(HEAPF32[i12 + (i11 * 12 | 0) >> 2]);
    i11 = 0;
    i8 = 0;
    f17 = Math_fround(0.0);
    f16 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    i13 = 0;
    while (1) {
     i24 = HEAPU8[i30 + i13 >> 0] | 0;
     f48 = f6;
     f6 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) + 4 >> 2]);
     f5 = Math_fround(f48 - f6);
     f4 = f18;
     f18 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) + 8 >> 2]);
     f5 = Math_fround(f5 * Math_fround(f4 + f18));
     f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f5);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     f4 = Math_fround(f4 - f18);
     f3 = f19;
     f19 = Math_fround(HEAPF32[i12 + (i24 * 12 | 0) >> 2]);
     f4 = Math_fround(f4 * Math_fround(f3 + f19));
     f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f4);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
     f3 = Math_fround(Math_fround(f48 + f6) * Math_fround(f3 - f19));
     f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f3);
     f17 = Math_fround(f17 + f19);
     f16 = Math_fround(f16 + f6);
     f9 = Math_fround(f9 + f18);
     i13 = i13 + 1 | 0;
     if ((i13 | 0) == (i26 | 0)) break; else i8 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    }
    i8 = i7 + (i31 * 20 | 0) | 0;
    HEAPF32[i8 >> 2] = f5;
    i10 = i7 + (i31 * 20 | 0) + 4 | 0;
    HEAPF32[i10 >> 2] = f4;
    i11 = i7 + (i31 * 20 | 0) + 8 | 0;
    HEAPF32[i11 >> 2] = f3;
    f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
    if (f6 > Math_fround(0.0)) {
     f48 = Math_fround(Math_fround(1.0) / f6);
     f5 = Math_fround(f5 * f48);
     HEAPF32[i8 >> 2] = f5;
     f4 = Math_fround(f4 * f48);
     HEAPF32[i10 >> 2] = f4;
     f3 = Math_fround(f3 * f48);
     HEAPF32[i11 >> 2] = f3;
    }
    HEAPF32[i7 + (i31 * 20 | 0) + 12 >> 2] = Math_fround(Math_fround(-Math_fround(Math_fround(f9 * f3) + Math_fround(Math_fround(f16 * f4) + Math_fround(f17 * f5)))) / Math_fround(i1 & 255));
   }
   i15 = HEAP32[i27 >> 2] | 0;
   i1 = i27 + 4 | 0;
   if (!i15) i13 = i1; else {
    i20 = HEAP32[i35 >> 2] | 0;
    i21 = HEAP32[i46 >> 2] | 0;
    i22 = i7 + (i31 * 20 | 0) | 0;
    i23 = i7 + (i31 * 20 | 0) + 4 | 0;
    i24 = i7 + (i31 * 20 | 0) + 8 | 0;
    i8 = 0;
    i14 = 0;
    while (1) {
     i13 = HEAP32[i1 >> 2] | 0;
     i11 = HEAP32[i20 + (i13 * 12 | 0) >> 2] | 0;
     i10 = HEAP32[i20 + (i13 * 12 | 0) + 4 >> 2] | 0;
     i13 = HEAP32[i20 + (i13 * 12 | 0) + 8 >> 2] | 0;
     f19 = Math_fround(HEAPF32[i21 + (i10 * 12 | 0) >> 2]);
     f5 = Math_fround(HEAPF32[i21 + (i11 * 12 | 0) >> 2]);
     f19 = Math_fround(f19 - f5);
     f6 = Math_fround(HEAPF32[i21 + (i10 * 12 | 0) + 4 >> 2]);
     f48 = Math_fround(HEAPF32[i21 + (i11 * 12 | 0) + 4 >> 2]);
     f6 = Math_fround(f6 - f48);
     f18 = Math_fround(HEAPF32[i21 + (i10 * 12 | 0) + 8 >> 2]);
     f4 = Math_fround(HEAPF32[i21 + (i11 * 12 | 0) + 8 >> 2]);
     f18 = Math_fround(f18 - f4);
     f5 = Math_fround(Math_fround(HEAPF32[i21 + (i13 * 12 | 0) >> 2]) - f5);
     f48 = Math_fround(Math_fround(HEAPF32[i21 + (i13 * 12 | 0) + 4 >> 2]) - f48);
     f4 = Math_fround(Math_fround(HEAPF32[i21 + (i13 * 12 | 0) + 8 >> 2]) - f4);
     f3 = Math_fround(Math_fround(f6 * f4) - Math_fround(f18 * f48));
     f4 = Math_fround(Math_fround(f18 * f5) - Math_fround(f19 * f4));
     f5 = Math_fround(Math_fround(f19 * f48) - Math_fround(f6 * f5));
     f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)));
     if (f6 > Math_fround(0.0)) {
      f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
      f18 = Math_fround(f3 * f48);
      f19 = Math_fround(f4 * f48);
      f48 = Math_fround(f5 * f48);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
      i11 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     } else {
      i10 = 0;
      i11 = 0;
      i13 = 0;
     }
     if (!i14) {
      f48 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f18 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f19 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f18 = Math_fround(f18 * Math_fround(HEAPF32[i22 >> 2]));
      f19 = Math_fround(f18 + Math_fround(f19 * Math_fround(HEAPF32[i23 >> 2])));
      if (Math_fround(f19 + Math_fround(f48 * Math_fround(HEAPF32[i24 >> 2]))) < Math_fround(0.0)) i8 = 1;
     }
     i14 = i14 + 1 | 0;
     if ((i14 | 0) == (i15 | 0)) break; else i1 = i1 + 4 | 0;
    }
    i10 = i27 + (i15 + 1 << 2) | 0;
    if (i8) {
     i23 = i7 + (i31 * 20 | 0) | 0;
     f18 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
     i24 = i7 + (i31 * 20 | 0) + 4 | 0;
     f19 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
     i27 = i7 + (i31 * 20 | 0) + 8 | 0;
     f48 = Math_fround(-Math_fround(HEAPF32[i27 >> 2]));
     HEAPF32[i23 >> 2] = f18;
     HEAPF32[i24 >> 2] = f19;
     HEAPF32[i27 >> 2] = f48;
     i27 = i7 + (i31 * 20 | 0) + 12 | 0;
     HEAPF32[i27 >> 2] = Math_fround(-Math_fround(HEAPF32[i27 >> 2]));
     if (i25) {
      i8 = i26 >>> 1;
      if (!i8) i13 = i10; else {
       i1 = i26 + -1 | 0;
       i7 = 0;
       do {
        i25 = i30 + i7 | 0;
        i27 = i30 + (i1 - i7) | 0;
        i26 = HEAP8[i25 >> 0] | 0;
        HEAP8[i25 >> 0] = HEAP8[i27 >> 0] | 0;
        HEAP8[i27 >> 0] = i26;
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) != (i8 | 0));
       i7 = HEAP32[i42 >> 2] | 0;
       i13 = i10;
      }
     } else i13 = i10;
    } else i13 = i10;
   }
   i1 = HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0;
   if (!(i1 << 24 >> 24)) {
    f6 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) >> 2]);
    f5 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) + 8 >> 2]);
    f3 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) + 12 >> 2]);
   } else {
    i11 = HEAP32[i46 >> 2] | 0;
    i8 = i1 & 255;
    f6 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) >> 2]);
    f5 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i7 + (i31 * 20 | 0) + 8 >> 2]);
    i1 = i7 + (i31 * 20 | 0) + 12 | 0;
    f9 = Math_fround(HEAPF32[i1 >> 2]);
    i10 = 0;
    while (1) {
     f3 = Math_fround(f6 * Math_fround(HEAPF32[i11 + (i10 * 12 | 0) >> 2]));
     f3 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i11 + (i10 * 12 | 0) + 4 >> 2])));
     f3 = Math_fround(-Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i11 + (i10 * 12 | 0) + 8 >> 2]))));
     if (f9 > f3) HEAPF32[i1 >> 2] = f3; else f3 = f9;
     i10 = i10 + 1 | 0;
     if (i10 >>> 0 >= i8 >>> 0) break; else f9 = f3;
    }
   }
   f48 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * f6);
   f48 = Math_fround(f48 + Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f5));
   if (Math_fround(f3 + Math_fround(f48 + Math_fround(Math_fround(HEAPF32[i34 >> 2]) * f4))) > Math_fround(0.0)) {
    i27 = HEAP8[i7 + (i31 * 20 | 0) + 18 >> 0] | 0;
    i1 = i27 & 255;
    if (i28 & i27 << 24 >> 24 != 0) {
     i8 = i1 >>> 1;
     if (i8) {
      i1 = i1 + -1 | 0;
      i7 = 0;
      do {
       i26 = i30 + i7 | 0;
       i28 = i30 + (i1 - i7) | 0;
       i27 = HEAP8[i26 >> 0] | 0;
       HEAP8[i26 >> 0] = HEAP8[i28 >> 0] | 0;
       HEAP8[i28 >> 0] = i27;
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i8 | 0));
      i28 = HEAP32[i42 >> 2] | 0;
      f6 = Math_fround(HEAPF32[i28 + (i31 * 20 | 0) >> 2]);
      f5 = Math_fround(HEAPF32[i28 + (i31 * 20 | 0) + 4 >> 2]);
      f4 = Math_fround(HEAPF32[i28 + (i31 * 20 | 0) + 8 >> 2]);
      i7 = i28;
      f3 = Math_fround(HEAPF32[i28 + (i31 * 20 | 0) + 12 >> 2]);
     }
    }
    f19 = Math_fround(-f5);
    f48 = Math_fround(-f4);
    HEAPF32[i7 + (i31 * 20 | 0) >> 2] = Math_fround(-f6);
    HEAPF32[i7 + (i31 * 20 | 0) + 4 >> 2] = f19;
    HEAPF32[i7 + (i31 * 20 | 0) + 8 >> 2] = f48;
    HEAPF32[i7 + (i31 * 20 | 0) + 12 >> 2] = Math_fround(-f3);
    i8 = i7;
   } else i8 = i7;
   i11 = i31 + 1 | 0;
   i1 = HEAP32[i39 >> 2] | 0;
   if (i11 >>> 0 >= i1 >>> 0) {
    i15 = i1;
    break L33;
   }
   i10 = HEAP32[i37 >> 2] | 0;
   i7 = i8;
   i36 = i36 + (i29 + 1 << 2) | 0;
   i30 = i30 + (HEAPU8[i8 + (i31 * 20 | 0) + 18 >> 0] | 0) | 0;
   i27 = i13;
   i31 = i11;
  }
 } while (0);
 i1 = HEAP32[i46 >> 2] | 0;
 if ((i12 | 0) != (i1 | 0)) {
  _memcpy(i1 | 0, i12 | 0, (i2 & 255) * 12 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i40, i12);
  HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] = i2;
 }
 if (!(__ZN5physx17ConvexHullBuilder23CalculateVertexMapTableEjb(i46, i15, 0) | 0)) {
  i46 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i43);
  __ZN5physx2Gu9ContainerD2Ev(i45);
  __ZN5physx2Gu9ContainerD2Ev(i44);
  STACKTOP = i47;
  return i46 | 0;
 }
 if (i15 | 0) {
  i13 = HEAP8[(HEAP32[i41 >> 2] | 0) + 38 >> 0] | 0;
  i14 = HEAP32[i46 >> 2] | 0;
  i10 = HEAP32[i42 >> 2] | 0;
  i11 = i13 << 24 >> 24 == 0;
  i12 = 0;
  do {
   if (i11) i1 = -1; else {
    f3 = Math_fround(HEAPF32[i10 + (i12 * 20 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i10 + (i12 * 20 | 0) + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i10 + (i12 * 20 | 0) + 8 >> 2]);
    i7 = i14;
    i8 = 0;
    f9 = Math_fround(3402823469999999843913219.0e14);
    i1 = -1;
    while (1) {
     f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f3);
     f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) * f4));
     f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * f5));
     i2 = f6 < f9;
     i1 = i2 ? i8 : i1;
     i8 = i8 + 1 << 24 >> 24;
     if ((i8 & 255) >= (i13 & 255)) break; else {
      i7 = i7 + 12 | 0;
      f9 = i2 ? f6 : f9;
     }
    }
   }
   HEAP8[i10 + (i12 * 20 | 0) + 19 >> 0] = i1;
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < i15 >>> 0);
 }
 i46 = __ZN5physx17ConvexHullBuilder27CreateTrianglesFromPolygonsEv(i46) | 0;
 __ZN5physx2Gu9ContainerD2Ev(i43);
 __ZN5physx2Gu9ContainerD2Ev(i45);
 __ZN5physx2Gu9ContainerD2Ev(i44);
 STACKTOP = i47;
 return i46 | 0;
}

function __ZN5Unity5Cloth6CreateEv(i25) {
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i31 + 64 | 0;
 i24 = i31;
 i3 = i31 + 160 | 0;
 i20 = i31 + 148 | 0;
 i29 = i31 + 128 | 0;
 i26 = i31 + 100 | 0;
 i27 = i31 + 172 | 0;
 i28 = i25 + 228 | 0;
 if (HEAP32[i28 >> 2] | 0) {
  STACKTOP = i31;
  return;
 }
 i2 = i25 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31632 | 0) | 0;
  if (i1 | 0) HEAP32[i1 + 504 >> 2] = 0;
 }
 i22 = i25 + 240 | 0;
 HEAP32[i22 >> 2] = 0;
 i6 = i25 + 244 | 0;
 HEAP32[i6 >> 2] = 0;
 i21 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 31632 | 0) | 0;
 if (!i21) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838499 | 0, 0, gb + 838562 | 0, 176, 1, HEAP32[i25 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i31;
  return;
 }
 HEAP32[i21 + 504 >> 2] = i25;
 if (!(__ZN19SkinnedMeshRenderer7GetMeshEv(i21) | 0)) {
  STACKTOP = i31;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i21) | 0);
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(f15 * f15);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f14 = Math_fround(f15 + Math_fround(f14 * f14));
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 do if (Math_fround(Math_sqrt(Math_fround(f14 + Math_fround(f15 * f15)))) < Math_fround(1.1920929e-07)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838626 | 0, 0, gb + 838562 | 0, 191, 512, HEAP32[i25 + 4 >> 2] | 0, 0, 0); else {
  i5 = i25 + 360 | 0;
  __ZNK9Transform11GetPositionEv(i23, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i21) | 0);
  HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  i5 = i25 + 236 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i24 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i30 = 16; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
     i2 = HEAP32[i23 >> 2] | 0;
     i19 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i30 = 16; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i30 = 18;
   }
   if ((i30 | 0) == 16) i30 = 18;
   if ((i30 | 0) == 18) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   i4 = __ZN19SkinnedMeshRenderer7GetMeshEv(i21) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i24 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i30 = 25; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i2 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i2 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
      i2 = HEAP32[i23 >> 2] | 0;
      i19 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = HEAP32[i3 + 28 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i2 << 3) | 0)) i30 = 25; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i30 = 27;
     }
    }
    if ((i30 | 0) == 25) i30 = 27;
    if ((i30 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
   if ((i4 | 0) == (i1 | 0)) {
    if (!(HEAP32[i6 >> 2] | 0)) break;
    HEAP32[i24 >> 2] = HEAP32[i5 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i30 = 36; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
      i2 = HEAP32[i23 >> 2] | 0;
      i19 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i30 = 36; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i30 = 38;
     }
    }
    if ((i30 | 0) == 36) i30 = 38;
    if ((i30 | 0) == 38) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if ((HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) break;
   }
   i1 = i25 + 128 | 0;
   i2 = i25 + 144 | 0;
   if ((HEAP32[i2 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i25 + 132 | 0);
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 >> 2] = 0;
   HEAP32[i25 + 140 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
  } while (0);
  i1 = __ZN19SkinnedMeshRenderer7GetMeshEv(i21) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i24 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i30 = 50; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
    i2 = HEAP32[i23 >> 2] | 0;
    i19 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i30 = 50; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i30 = 52;
   }
  }
  if ((i30 | 0) == 50) i30 = 52;
  if ((i30 | 0) == 52) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i17 = i25 + 288 | 0;
  i19 = i25 + 268 | 0;
  if (!(__Z19ExtractDataFromMeshR4MeshR13dynamic_arrayI8Vector3fLj4EERS1_ItLj2EES6_(i1, i17, i19, i25 + 248 | 0) | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838666 | 0, 0, gb + 838562 | 0, 206, 1, HEAP32[i25 + 4 >> 2] | 0, 0, 0);
   break;
  }
  i16 = i25 + 300 | 0;
  HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i25 + 260 >> 2];
  i18 = i25 + 280 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  L85 : do if (i1 | 0) {
   i11 = i25 + 284 | 0;
   i12 = i25 + 272 | 0;
   i8 = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   while (1) {
    i9 = i8 + 1 | 0;
    i10 = i8 + 2 | 0;
    i7 = i2;
    i6 = i2;
    i4 = i2;
    while (1) {
     i2 = HEAP16[i6 + (i8 << 1) >> 1] | 0;
     i3 = HEAP16[i6 + (i9 << 1) >> 1] | 0;
     if (i2 << 16 >> 16 != i3 << 16 >> 16) {
      i5 = HEAP16[i6 + (i10 << 1) >> 1] | 0;
      if (!(i3 << 16 >> 16 == i5 << 16 >> 16 ? 1 : i5 << 16 >> 16 == i2 << 16 >> 16)) break;
     }
     i5 = i1 + -3 | 0;
     HEAP16[i6 + (i8 << 1) >> 1] = HEAP16[i6 + (i5 << 1) >> 1] | 0;
     HEAP16[i6 + (i9 << 1) >> 1] = HEAP16[i6 + (i1 + -2 << 1) >> 1] | 0;
     HEAP16[i6 + (i10 << 1) >> 1] = HEAP16[i6 + (i1 + -1 << 1) >> 1] | 0;
     HEAP32[i18 >> 2] = i5;
     i1 = HEAP32[i11 >> 2] | 0;
     do if ((i1 & 2147483647) >>> 0 < i5 >>> 0) if ((i1 | 0) > -1) {
      HEAP32[i11 >> 2] = i5;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 1, 2, i12, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i2;
      i3 = i2;
      i4 = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i18 >> 2] << 1 | 0) | 0;
      HEAP32[i11 >> 2] = i5;
      HEAP32[i19 >> 2] = i2;
      i3 = i2;
      i4 = i2;
      break;
     } else {
      i3 = i7;
      i2 = i6;
     } while (0);
     if (i8 >>> 0 < i5 >>> 0) {
      i1 = i5;
      i7 = i3;
      i6 = i2;
     } else break L85;
    }
    i8 = i8 + 3 | 0;
    if (i8 >>> 0 >= i1 >>> 0) break; else i2 = i7;
   }
  } while (0);
  __ZN5Unity5Cloth13UpdateNormalsEv(i25);
  i9 = __Z16GetClothingScenev() | 0;
  i10 = i25 + 232 | 0;
  HEAP32[i10 >> 2] = i9;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 252 >> 2] | 0, i20 | 0, i9 | 0);
  __ZNK9Transform11GetRotationEv(i23, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i21) | 0);
  f35 = Math_fround(HEAPF32[i23 >> 2]);
  f38 = Math_fround(-f35);
  f37 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f36 = Math_fround(-f37);
  f14 = Math_fround(HEAPF32[i23 + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i23 + 12 >> 2]);
  f35 = Math_fround(f35 * Math_fround(-2.0));
  f37 = Math_fround(f37 * Math_fround(-2.0));
  f40 = Math_fround(f14 * Math_fround(-2.0));
  f33 = Math_fround(f35 * f38);
  f32 = Math_fround(f37 * f36);
  f14 = Math_fround(f14 * f40);
  f41 = Math_fround(f37 * f38);
  f38 = Math_fround(f40 * f38);
  f36 = Math_fround(f40 * f36);
  f35 = Math_fround(f35 * f13);
  f37 = Math_fround(f37 * f13);
  f40 = Math_fround(f13 * f40);
  f13 = Math_fround(Math_fround(1.0) - Math_fround(f32 - f14));
  f39 = Math_fround(HEAPF32[i20 >> 2]);
  f13 = Math_fround(f39 * f13);
  f42 = Math_fround(f41 - f40);
  f34 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f13 = Math_fround(Math_fround(f42 * f34) + f13);
  f42 = Math_fround(f38 + f37);
  f15 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f13 = Math_fround(Math_fround(f42 * f15) + f13);
  f14 = Math_fround(Math_fround(Math_fround(f36 - f35) * f15) + Math_fround(Math_fround(f39 * Math_fround(f41 + f40)) + Math_fround(f34 * Math_fround(Math_fround(1.0) - Math_fround(f33 - f14)))));
  f15 = Math_fround(Math_fround(Math_fround(f39 * Math_fround(f38 - f37)) + Math_fround(Math_fround(f36 + f35) * f34)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f33 + f32)) * f15));
  i9 = gb + 64016 | 0;
  i12 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i24;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i29 >> 2] = 0;
  i11 = i29 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i29 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i23, i24);
  i9 = i23;
  i20 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = i12;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = i20;
  i1 = HEAP32[i22 >> 2] | 0;
  HEAP32[i29 + 12 >> 2] = i1;
  if (!i1) i1 = 0; else {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 4, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i22 >> 2] | 0;
  }
  i2 = i25 + 128 | 0;
  HEAPF32[i23 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i23 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
  __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy(i2, i1, i23, 1);
  i9 = i25 + 359 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZNK9Transform13GetWorldScaleEv(i23, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i21) | 0);
  __ZN10Matrix4x4fC2ERK10Matrix3x3f(i24, i23);
  i7 = HEAP32[i17 >> 2] | 0;
  __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fPS2_i(i24, i7, i7, HEAP32[i16 >> 2] | 0);
  i7 = HEAP32[i22 >> 2] | 0;
  do if (!i7) i30 = 76; else {
   i8 = HEAP32[i29 >> 2] | 0;
   i5 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i6 = i8;
   i3 = 0;
   i1 = 0;
   do {
    i23 = HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i8 + (i3 << 4) >> 2] = HEAP32[i5 + (i3 * 12 | 0) >> 2];
    HEAP32[i8 + (i3 << 4) + 4 >> 2] = i23;
    HEAP32[i8 + (i3 << 4) + 8 >> 2] = i2;
    i2 = i8 + (i3 << 4) + 12 | 0;
    if (Math_fround(HEAPF32[i4 + (i3 << 3) >> 2]) > Math_fround(0.0)) {
     HEAPF32[i2 >> 2] = Math_fround(1.0);
     i1 = 1;
    } else {
     HEAPF32[i2 >> 2] = Math_fround(0.0);
     HEAP8[i9 >> 0] = 1;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i7 >>> 0);
   if (!i1) if (!i25) {
    i1 = 0;
    i30 = 77;
    break;
   } else {
    i30 = 76;
    break;
   }
   i1 = i24 + 4 | 0;
   i2 = i1 + 44 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i24 + 4 >> 2] = i6;
   HEAP32[i24 + 8 >> 2] = i7;
   HEAP32[i24 >> 2] = 16;
   HEAP32[i24 + 16 >> 2] = i8 + 12;
   HEAP32[i24 + 20 >> 2] = i7;
   HEAP32[i24 + 12 >> 2] = 16;
   HEAP32[i24 + 32 >> 2] = ((HEAP32[i18 >> 2] | 0) >>> 0) / 3 | 0;
   HEAP32[i24 + 28 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i24 + 24 >> 2] = 6;
   HEAP16[i24 + 48 >> 1] = 2;
   i1 = __Z14GetDynamicsSDKv() | 0;
   HEAPF32[i26 >> 2] = f13;
   HEAPF32[i26 + 4 >> 2] = f14;
   HEAPF32[i26 + 8 >> 2] = f15;
   i1 = __ZN5physx19PxClothFabricCreateERNS_9PxPhysicsERKNS_15PxClothMeshDescERKNS_6PxVec3Eb(i1, i24, i26, 1) | 0;
   if (!i1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838796 | 0, 0, gb + 838562 | 0, 287, 1, HEAP32[i25 + 4 >> 2] | 0, 0, 0); else {
    i23 = __Z14GetDynamicsSDKv() | 0;
    i22 = HEAP32[(HEAP32[i23 >> 2] | 0) + 120 >> 2] | 0;
    HEAPF32[i26 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i26 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + 24 >> 2] = Math_fround(0.0);
    i24 = HEAP32[i29 >> 2] | 0;
    HEAP16[i27 >> 1] = 0;
    HEAP32[i28 >> 2] = mftCall_iiiiii(i22 | 0, i23 | 0, i26 | 0, i1 | 0, i24 | 0, i27 | 0) | 0;
    __ZN5Unity5Cloth14SetupCollidersEv(i25);
    i27 = HEAP32[i28 >> 2] | 0;
    HEAP32[i27 + 8 >> 2] = i25;
    i24 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 44 >> 2] | 0, i24 | 0, i27 | 0);
    HEAP32[i25 + 328 >> 2] = 0;
    HEAP32[i25 + 332 >> 2] = 0;
    HEAP32[i25 + 336 >> 2] = 0;
    i28 = HEAP32[i28 >> 2] | 0;
    mftCall_viif(HEAP32[(HEAP32[i28 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, i28 | 0, 1.0);
    f36 = Math_fround(HEAPF32[i26 >> 2]);
    f41 = Math_fround(HEAPF32[i26 + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i26 + 8 >> 2]);
    f37 = Math_fround(HEAPF32[i26 + 12 >> 2]);
    f34 = Math_fround(HEAPF32[i26 + 16 >> 2]);
    f35 = Math_fround(HEAPF32[i26 + 20 >> 2]);
    f38 = Math_fround(Math_fround(f41 + f34) * Math_fround(.5));
    f39 = Math_fround(Math_fround(f42 + f35) * Math_fround(.5));
    f40 = Math_fround(Math_fround(f37 - f36) * Math_fround(.5));
    f41 = Math_fround(Math_fround(f34 - f41) * Math_fround(.5));
    f42 = Math_fround(Math_fround(f35 - f42) * Math_fround(.5));
    HEAPF32[i25 + 96 >> 2] = Math_fround(Math_fround(f36 + f37) * Math_fround(.5));
    HEAPF32[i25 + 100 >> 2] = f38;
    HEAPF32[i25 + 104 >> 2] = f39;
    HEAPF32[i25 + 108 >> 2] = f40;
    HEAPF32[i25 + 112 >> 2] = f41;
    HEAPF32[i25 + 116 >> 2] = f42;
    __ZN5Unity5Cloth18ApplyConfigurationEv(i25);
   }
  } while (0);
  if ((i30 | 0) == 76) {
   i1 = HEAP32[i25 + 4 >> 2] | 0;
   i30 = 77;
  }
  if ((i30 | 0) == 77) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838724 | 0, 0, gb + 838562 | 0, 268, 4, i1, 0, 0);
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i12);
   HEAP32[i29 >> 2] = 0;
  }
 } while (0);
 STACKTOP = i31;
 return;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i38, i40, i39, i1, i62, i63, i64, i65, i67, i69, i55) {
 i38 = i38 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i67 = i67 | 0;
 i69 = i69 | 0;
 i55 = i55 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i66 = 0, i68 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i70 + 432 | 0;
 i49 = i70 + 548 | 0;
 i48 = i70 + 536 | 0;
 i60 = i70 + 368 | 0;
 i58 = i70 + 304 | 0;
 i59 = i70 + 240 | 0;
 i66 = i70 + 520 | 0;
 i68 = i70 + 504 | 0;
 i41 = i70 + 496 | 0;
 i61 = i70 + 224 | 0;
 i29 = i70 + 208 | 0;
 i27 = i70 + 192 | 0;
 i30 = i70 + 176 | 0;
 i28 = i70 + 160 | 0;
 i31 = i70 + 484 | 0;
 i32 = i70 + 144 | 0;
 i43 = i70 + 128 | 0;
 i36 = i70 + 112 | 0;
 i44 = i70 + 96 | 0;
 i42 = i70 + 80 | 0;
 i51 = i70 + 64 | 0;
 i52 = i70 + 48 | 0;
 i50 = i70 + 472 | 0;
 i37 = i70 + 32 | 0;
 i35 = i70 + 460 | 0;
 i46 = i70 + 16 | 0;
 i47 = i70;
 i45 = i70 + 448 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f56 = Math_fround(HEAPF32[i38 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i40 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(HEAPF32[i38 + 32 >> 2]);
 f54 = Math_fround(HEAPF32[i40 + 32 >> 2]);
 f34 = Math_fround((f34 > f54 ? f54 : f34) * Math_fround(.100000001));
 f34 = Math_fround(f34 * f34);
 f54 = Math_fround(f56 + f57);
 HEAP32[i41 >> 2] = 0;
 if (!(HEAP8[i55 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i39 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i39 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i39 + 56 >> 2]);
  i29 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i29 ? f5 : Math_fround(1.0);
  f6 = i29 ? f6 : Math_fround(0.0);
  f7 = i29 ? f7 : Math_fround(0.0);
  HEAPF32[i61 >> 2] = f5;
  HEAPF32[i61 + 4 >> 2] = f6;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i32 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  i29 = i61;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i53 = 7;
 } else {
  HEAP32[i29 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i38 + 16 | 0;
  i2 = i39 + 48 | 0;
  i3 = i39 + 52 | 0;
  i9 = i39 + 56 | 0;
  i10 = i27 + 4 | 0;
  i11 = i27 + 8 | 0;
  i12 = i39 + 16 | 0;
  i13 = i39 + 32 | 0;
  i14 = i39 + 4 | 0;
  i15 = i39 + 20 | 0;
  i16 = i39 + 36 | 0;
  i17 = i39 + 8 | 0;
  i18 = i39 + 24 | 0;
  i19 = i39 + 40 | 0;
  i20 = i40 + 16 | 0;
  i21 = i30 + 4 | 0;
  i22 = i30 + 8 | 0;
  i23 = i29 + 4 | 0;
  i24 = i29 + 8 | 0;
  i25 = i29 + 12 | 0;
  i26 = 0;
  do {
   i72 = HEAPU8[i67 + i26 >> 0] | 0;
   HEAP32[i66 + (i26 << 2) >> 2] = i72;
   i71 = HEAPU8[i69 + i26 >> 0] | 0;
   HEAP32[i68 + (i26 << 2) >> 2] = i71;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i27, i38, i72, i1);
   f74 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(HEAPF32[i9 >> 2]);
   f75 = Math_fround(HEAPF32[i27 >> 2]);
   f73 = Math_fround(HEAPF32[i10 >> 2]);
   f8 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(f75 * Math_fround(HEAPF32[i39 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f73 * Math_fround(HEAPF32[i12 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2])));
   f7 = Math_fround(f75 * Math_fround(HEAPF32[i14 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f73 * Math_fround(HEAPF32[i15 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
   f75 = Math_fround(f75 * Math_fround(HEAPF32[i17 >> 2]));
   f73 = Math_fround(f75 + Math_fround(f73 * Math_fround(HEAPF32[i18 >> 2])));
   f6 = Math_fround(f74 + f6);
   f7 = Math_fround(f5 + f7);
   f8 = Math_fround(f4 + Math_fround(f73 + Math_fround(f8 * Math_fround(HEAPF32[i19 >> 2]))));
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i30, i40, i71, i20);
   f73 = Math_fround(HEAPF32[i30 >> 2]);
   f4 = Math_fround(HEAPF32[i21 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f8 - Math_fround(HEAPF32[i22 >> 2]));
   HEAPF32[i29 >> 2] = Math_fround(f6 - f73);
   HEAPF32[i23 >> 2] = f4;
   HEAPF32[i24 >> 2] = f5;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i71 = HEAP32[i41 >> 2] | 0;
   HEAPF32[i58 + (i71 << 4) >> 2] = f6;
   HEAPF32[i58 + (i71 << 4) + 4 >> 2] = f7;
   HEAPF32[i58 + (i71 << 4) + 8 >> 2] = f8;
   HEAPF32[i58 + (i71 << 4) + 12 >> 2] = Math_fround(0.0);
   i72 = i59 + (i71 << 4) | 0;
   HEAP32[i72 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i72 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   HEAP32[i41 >> 2] = i71 + 1;
   i71 = i60 + (i71 << 4) | 0;
   HEAP32[i71 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i71 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i71 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i71 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   i26 = i26 + 1 | 0;
  } while (i26 >>> 0 < (HEAPU8[i55 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i28, i60, i58, i59, i66, i68, i29, i41);
  HEAP32[i61 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i61 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i49 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i48 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i32 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  if (f4 > f34) {
   i29 = i61;
   i53 = 7;
  } else i2 = HEAP32[i41 >> 2] | 0;
 }
 do if ((i53 | 0) == 7) {
  i27 = i61 + 4 | 0;
  i28 = i61 + 8 | 0;
  i11 = i36 + 4 | 0;
  i12 = i36 + 8 | 0;
  i13 = i36 + 12 | 0;
  i14 = i40 + 196 | 0;
  i15 = i40 + 200 | 0;
  i16 = i40 + 204 | 0;
  i17 = i40 + 16 | 0;
  i18 = i43 + 4 | 0;
  i19 = i43 + 8 | 0;
  i20 = i44 + 4 | 0;
  i21 = i44 + 8 | 0;
  i22 = i42 + 4 | 0;
  i23 = i42 + 8 | 0;
  i24 = i42 + 12 | 0;
  i25 = i38 + 48 | 0;
  i26 = i40 + 48 | 0;
  while (1) {
   HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i32 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   f74 = Math_fround(-f6);
   f75 = Math_fround(-f7);
   HEAPF32[i36 >> 2] = Math_fround(-f5);
   HEAPF32[i11 >> 2] = f74;
   HEAPF32[i12 >> 2] = f75;
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   i10 = HEAP32[i41 >> 2] | 0;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVERS4_Ri(i43, i38, i36, i39, i58 + (i10 << 4) | 0, i66 + (i10 << 2) | 0);
   i10 = HEAP32[i41 >> 2] | 0;
   i9 = i59 + (i10 << 4) | 0;
   i10 = i68 + (i10 << 2) | 0;
   if (!(HEAP32[i14 >> 2] | 0)) {
    i1 = HEAP32[i15 >> 2] | 0;
    if ((HEAPU8[i16 >> 0] | 0) > 1) {
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i61 >> 2]));
     f75 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f75 = Math_fround(f6 + Math_fround(f75 * Math_fround(HEAPF32[i27 >> 2])));
     f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f6 = Math_fround(f75 + Math_fround(f6 * Math_fround(HEAPF32[i28 >> 2])));
     i2 = 1;
     i1 = 0;
     while (1) {
      i3 = HEAP32[i15 >> 2] | 0;
      f8 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) >> 2]);
      f74 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2]);
      f73 = Math_fround(HEAPF32[i61 >> 2]);
      f75 = Math_fround(HEAPF32[i27 >> 2]);
      f5 = Math_fround(Math_fround(Math_fround(f8 * f73) + Math_fround(f74 * f75)) + Math_fround(f5 * Math_fround(HEAPF32[i28 >> 2])));
      i3 = f5 > f6;
      i1 = i3 ? i2 : i1;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 < (HEAPU8[i16 >> 0] | 0) >>> 0) f6 = i3 ? f5 : f6; else break;
     }
    } else i1 = 0;
   } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i40, i61) | 0;
   HEAP32[i10 >> 2] = i1;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i44, i40, i1, i17);
   HEAP32[i9 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   f74 = Math_fround(HEAPF32[i43 >> 2]);
   f6 = Math_fround(HEAPF32[i18 >> 2]);
   f75 = Math_fround(HEAPF32[i19 >> 2]);
   f7 = Math_fround(HEAPF32[i44 >> 2]);
   f73 = Math_fround(HEAPF32[i20 >> 2]);
   f7 = Math_fround(f74 - f7);
   f73 = Math_fround(f6 - f73);
   f75 = Math_fround(f75 - Math_fround(HEAPF32[i21 >> 2]));
   HEAPF32[i42 >> 2] = f7;
   HEAPF32[i22 >> 2] = f73;
   HEAPF32[i23 >> 2] = f75;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i41 >> 2] | 0;
   i2 = i60 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i25 >> 2]);
   f74 = Math_fround(HEAPF32[i26 >> 2]);
   f74 = f6 > f74 ? f6 : f74;
   f33 = f33 > f74 ? f33 : f74;
   f74 = Math_fround(f54 + f33);
   f74 = Math_fround(f4 * Math_fround(f74 * f74));
   f6 = Math_fround(HEAPF32[i61 >> 2]);
   f8 = Math_fround(HEAPF32[i27 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f73)) + Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f75));
   i2 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f74;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f75) | i2) {
    i53 = 14;
    break;
   }
   HEAP32[i41 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i37, i60, i58, i59, i66, i68, i42, i41);
   HEAP32[i29 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i29 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i29 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i29 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i27 >> 2]);
   f7 = Math_fround(HEAPF32[i28 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i49 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f34 & i1)) break; else f4 = f8;
  }
  if ((i53 | 0) == 14) {
   if (i67 | 0) {
    HEAP8[i55 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
      HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i72 = 0;
    STACKTOP = i70;
    return i72 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i51, i52, i3);
   f34 = Math_fround(Math_sqrt(Math_fround(f4)));
   f73 = Math_fround(HEAPF32[i61 >> 2]);
   f74 = Math_fround(HEAPF32[i27 >> 2]);
   f75 = Math_fround(Math_fround(1.0) / f34);
   f73 = Math_fround(f73 * f75);
   f74 = Math_fround(f74 * f75);
   f75 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f75);
   f7 = Math_fround(HEAPF32[i51 >> 2]);
   f33 = Math_fround(HEAPF32[i51 + 4 >> 2]);
   f33 = Math_fround(f33 - Math_fround(f56 * f74));
   f8 = Math_fround(Math_fround(HEAPF32[i51 + 8 >> 2]) - Math_fround(f56 * f75));
   HEAPF32[i62 >> 2] = Math_fround(f7 - Math_fround(f56 * f73));
   HEAPF32[i62 + 4 >> 2] = f33;
   HEAPF32[i62 + 8 >> 2] = f8;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   f8 = Math_fround(HEAPF32[i52 >> 2]);
   f33 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f33 = Math_fround(Math_fround(f57 * f74) + f33);
   f56 = Math_fround(Math_fround(f57 * f75) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f73) + f8);
   HEAPF32[i63 + 4 >> 2] = f33;
   HEAPF32[i63 + 8 >> 2] = f56;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i65 >> 2] = Math_fround(f34 - f54);
   i72 = i65 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAPF32[i64 >> 2] = f73;
   HEAPF32[i64 + 4 >> 2] = f74;
   HEAPF32[i64 + 8 >> 2] = f75;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   i72 = 1;
   STACKTOP = i70;
   return i72 | 0;
  }
  i2 = HEAP32[i41 >> 2] | 0;
  if (i1) {
   if (!i67) i1 = 6; else break;
   STACKTOP = i70;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i67 | 0) {
   HEAP8[i55 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
     HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i29 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i46, i47, i2);
  HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  f34 = Math_fround(Math_sqrt(Math_fround(f4)));
  f73 = Math_fround(HEAPF32[i61 >> 2]);
  f74 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f75 = Math_fround(Math_fround(1.0) / f34);
  f73 = Math_fround(f73 * f75);
  f74 = Math_fround(f74 * f75);
  f75 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) * f75);
  f7 = Math_fround(HEAPF32[i46 >> 2]);
  f33 = Math_fround(HEAPF32[i46 + 4 >> 2]);
  f33 = Math_fround(f33 - Math_fround(f56 * f74));
  f8 = Math_fround(Math_fround(HEAPF32[i46 + 8 >> 2]) - Math_fround(f56 * f75));
  HEAPF32[i62 >> 2] = Math_fround(f7 - Math_fround(f56 * f73));
  HEAPF32[i62 + 4 >> 2] = f33;
  HEAPF32[i62 + 8 >> 2] = f8;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  f8 = Math_fround(HEAPF32[i47 >> 2]);
  f33 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f33 = Math_fround(Math_fround(f57 * f74) + f33);
  f56 = Math_fround(Math_fround(f57 * f75) + Math_fround(HEAPF32[i47 + 8 >> 2]));
  HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f73) + f8);
  HEAPF32[i63 + 4 >> 2] = f33;
  HEAPF32[i63 + 8 >> 2] = f56;
  HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i65 >> 2] = Math_fround(f34 - f54);
  i72 = i65 + 4 | 0;
  HEAP32[i72 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i72 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i72 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAPF32[i64 >> 2] = f73;
  HEAPF32[i64 + 4 >> 2] = f74;
  HEAPF32[i64 + 8 >> 2] = f75;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  i72 = 3;
  STACKTOP = i70;
  return i72 | 0;
 } while (0);
 HEAP8[i55 >> 0] = i2;
 if (!i2) {
  i72 = 6;
  STACKTOP = i70;
  return i72 | 0;
 } else i1 = 0;
 do {
  HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
  HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i70;
 return i1 | 0;
}

function __ZN19MeshParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi(i30, i31, i32, i33, i2) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i36 + 160 | 0;
 i35 = i36 + 96 | 0;
 i3 = i36 + 72 | 0;
 i12 = i36 + 88 | 0;
 i13 = i36 + 64 | 0;
 i14 = i36 + 56 | 0;
 i15 = i36 + 48 | 0;
 i16 = i36 + 40 | 0;
 i17 = i36 + 32 | 0;
 i21 = i36 + 24 | 0;
 i22 = i36 + 16 | 0;
 i19 = i36 + 8 | 0;
 i20 = i36;
 i6 = i30 + 236 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i35 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i34, i1, i35);
    i4 = HEAP32[i34 >> 2] | 0;
    i29 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i4 | 0) == -1 ? i29 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i29 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 i29 = i30 + 72 | 0;
 __ZNK9Transform13GetWorldScaleEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i30 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN10Matrix4x4fC2ERK10Matrix3x3f(i35, i34);
 f28 = Math_fround(HEAPF32[i34 >> 2]);
 i10 = i34 + 4 | 0;
 f52 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i34 + 8 | 0;
 f42 = Math_fround(HEAPF32[i11 >> 2]);
 i18 = i34 + 12 | 0;
 f51 = Math_fround(HEAPF32[i18 >> 2]);
 i23 = i34 + 16 | 0;
 f50 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i34 + 20 | 0;
 f39 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = i34 + 24 | 0;
 f49 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i34 + 28 | 0;
 f47 = Math_fround(HEAPF32[i26 >> 2]);
 i27 = i34 + 32 | 0;
 f45 = Math_fround(HEAPF32[i27 >> 2]);
 f43 = Math_fround(HEAPF32[i33 >> 2]);
 f44 = Math_fround(f28 * f43);
 f46 = Math_fround(HEAPF32[i33 + 12 >> 2]);
 f44 = Math_fround(f44 + Math_fround(f52 * f46));
 f38 = Math_fround(HEAPF32[i33 + 24 >> 2]);
 f44 = Math_fround(f44 + Math_fround(f42 * f38));
 f41 = Math_fround(Math_fround(Math_fround(f51 * f43) + Math_fround(f50 * f46)) + Math_fround(f39 * f38));
 f38 = Math_fround(Math_fround(Math_fround(f49 * f43) + Math_fround(f47 * f46)) + Math_fround(f45 * f38));
 f46 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f43 = Math_fround(f28 * f46);
 f48 = Math_fround(HEAPF32[i33 + 16 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f52 * f48));
 f37 = Math_fround(HEAPF32[i33 + 28 >> 2]);
 f43 = Math_fround(f43 + Math_fround(f42 * f37));
 f40 = Math_fround(Math_fround(Math_fround(f51 * f46) + Math_fround(f50 * f48)) + Math_fround(f39 * f37));
 f37 = Math_fround(Math_fround(Math_fround(f49 * f46) + Math_fround(f47 * f48)) + Math_fround(f45 * f37));
 f48 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f28 = Math_fround(f28 * f48);
 f46 = Math_fround(HEAPF32[i33 + 20 >> 2]);
 f52 = Math_fround(f28 + Math_fround(f52 * f46));
 f28 = Math_fround(HEAPF32[i33 + 32 >> 2]);
 f42 = Math_fround(f52 + Math_fround(f42 * f28));
 f39 = Math_fround(Math_fround(Math_fround(f51 * f48) + Math_fround(f50 * f46)) + Math_fround(f39 * f28));
 f28 = Math_fround(Math_fround(Math_fround(f49 * f48) + Math_fround(f47 * f46)) + Math_fround(f45 * f28));
 HEAPF32[i34 >> 2] = f44;
 HEAPF32[i10 >> 2] = f43;
 HEAPF32[i11 >> 2] = f42;
 HEAPF32[i18 >> 2] = f41;
 HEAPF32[i23 >> 2] = f40;
 HEAPF32[i24 >> 2] = f39;
 HEAPF32[i25 >> 2] = f38;
 HEAPF32[i26 >> 2] = f37;
 HEAPF32[i27 >> 2] = f28;
 __ZN10Matrix3x3f15InvertTransposeEv(i34);
 f28 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (i1 | 0) if (__ZNK4Mesh15GetSubMeshCountEv(i1) | 0) {
  i5 = HEAP32[i1 + 32 >> 2] | 0;
  i6 = HEAP32[i5 + 128 >> 2] | 0;
  i18 = i6 + 36 | 0;
  if (HEAP32[i18 >> 2] | 0) {
   i4 = HEAP32[i5 + 92 >> 2] | 0;
   if (i4 | 0) {
    i23 = HEAP32[i5 + 100 >> 2] | 0;
    i3 = i5 + 8 | 0;
    i27 = HEAP16[i5 + 10 >> 1] | 0;
    if ((i27 & 65535) < 768 | (i27 & 255) != 0) {
     i26 = 0;
     i27 = 0;
    } else if (!(HEAP8[i5 + 11 >> 0] | 0)) {
     i26 = 0;
     i27 = 1;
    } else {
     i26 = HEAP16[i3 >> 1] | 0;
     i26 = i4 + (((i26 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i26 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i27 = HEAPU8[i3 + 32 + ((HEAPU8[i3 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    i25 = HEAP16[i5 + 14 >> 1] | 0;
    if ((i25 & 65535) < 768 | (i25 & 255) != 0) {
     i25 = 0;
     i24 = 0;
    } else if (!(HEAP8[i5 + 15 >> 0] | 0)) {
     i25 = 0;
     i24 = 1;
    } else {
     i25 = HEAP16[i5 + 12 >> 1] | 0;
     i25 = i4 + (((i25 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i25 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i24 = HEAPU8[i3 + 32 + ((HEAPU8[i5 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    i11 = __ZN4Mesh18GetSubMeshBuffer16Ei(i1, 0) | 0;
    if (HEAP8[i30 + 221 >> 0] | 0) {
     if (!i23) {
      STACKTOP = i36;
      return;
     }
     i12 = i30 + 232 | 0;
     i1 = HEAP32[i12 >> 2] | 0;
     if ((i1 | 0) >= (i23 | 0)) {
      HEAP32[i12 >> 2] = 0;
      i1 = 0;
     }
     i4 = i31 + 4 | 0;
     i3 = HEAP32[i31 >> 2] | 0;
     if ((((HEAP32[i4 >> 2] | 0) - i3 | 0) / 48 | 0) >>> 0 <= i2 >>> 0) {
      STACKTOP = i36;
      return;
     }
     i5 = i19 + 4 | 0;
     i6 = i20 + 4 | 0;
     i7 = i30 + 76 | 0;
     i8 = i30 + 80 | 0;
     i9 = i30 + 84 | 0;
     i10 = i30 + 88 | 0;
     i11 = i30 + 92 | 0;
     do {
      HEAP32[i19 >> 2] = i26;
      HEAP32[i5 >> 2] = i27;
      HEAP32[i20 >> 2] = i25;
      HEAP32[i6 >> 2] = i24;
      __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_(i30, i1, i3 + (i2 * 48 | 0) | 0, i32, i35, i33, i34, f28, i19, i20);
      i22 = HEAP32[i31 >> 2] | 0;
      f52 = Math_fround(HEAPF32[i29 >> 2]);
      i18 = i22 + (i2 * 48 | 0) | 0;
      f51 = Math_fround(HEAPF32[i18 >> 2]);
      f50 = Math_fround(HEAPF32[i7 >> 2]);
      i21 = i22 + (i2 * 48 | 0) + 4 | 0;
      f49 = Math_fround(HEAPF32[i21 >> 2]);
      f48 = Math_fround(HEAPF32[i8 >> 2]);
      i22 = i22 + (i2 * 48 | 0) + 8 | 0;
      f47 = Math_fround(HEAPF32[i22 >> 2]);
      HEAPF32[i29 >> 2] = f51 < f52 ? f51 : f52;
      HEAPF32[i7 >> 2] = f49 < f50 ? f49 : f50;
      HEAPF32[i8 >> 2] = f47 < f48 ? f47 : f48;
      f48 = Math_fround(HEAPF32[i9 >> 2]);
      f47 = Math_fround(HEAPF32[i18 >> 2]);
      f50 = Math_fround(HEAPF32[i10 >> 2]);
      f49 = Math_fround(HEAPF32[i21 >> 2]);
      f52 = Math_fround(HEAPF32[i11 >> 2]);
      f51 = Math_fround(HEAPF32[i22 >> 2]);
      HEAPF32[i9 >> 2] = f48 < f47 ? f47 : f48;
      HEAPF32[i10 >> 2] = f50 < f49 ? f49 : f50;
      HEAPF32[i11 >> 2] = f52 < f51 ? f51 : f52;
      i22 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
      i1 = (i22 | 0) < (i23 | 0) ? i22 : 0;
      HEAP32[i12 >> 2] = i1;
      i2 = i2 + 1 | 0;
      i3 = HEAP32[i31 >> 2] | 0;
     } while (i2 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i3 | 0) / 48 | 0) >>> 0);
     STACKTOP = i36;
     return;
    }
    if (!(HEAP8[i30 + 220 >> 0] | 0)) {
     if (!i23) {
      STACKTOP = i36;
      return;
     }
     i4 = i31 + 4 | 0;
     i1 = HEAP32[i31 >> 2] | 0;
     if ((((HEAP32[i4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i2 >>> 0) {
      STACKTOP = i36;
      return;
     }
     i5 = (i23 | 0) > 0;
     i6 = i21 + 4 | 0;
     i7 = i22 + 4 | 0;
     i8 = i30 + 76 | 0;
     i9 = i30 + 80 | 0;
     i10 = i30 + 84 | 0;
     i11 = i30 + 88 | 0;
     i12 = i30 + 92 | 0;
     i13 = (i23 | 0) < 0;
     i14 = 0 - i23 | 0;
     do {
      if (i5) {
       i20 = HEAP32[gb + 1477044 >> 2] | 0;
       i20 = i20 << 11 ^ i20;
       HEAP32[gb + 1477044 >> 2] = HEAP32[gb + 1477048 >> 2];
       HEAP32[gb + 1477048 >> 2] = HEAP32[gb + 1477052 >> 2];
       i3 = HEAP32[gb + 1477056 >> 2] | 0;
       HEAP32[gb + 1477052 >> 2] = i3;
       i3 = i20 >>> 8 ^ i20 ^ i3 ^ i3 >>> 19;
       HEAP32[gb + 1477056 >> 2] = i3;
       i3 = (i3 >>> 0) % (i23 >>> 0) | 0;
      } else if (i13) {
       i20 = HEAP32[gb + 1477044 >> 2] | 0;
       i20 = i20 << 11 ^ i20;
       HEAP32[gb + 1477044 >> 2] = HEAP32[gb + 1477048 >> 2];
       HEAP32[gb + 1477048 >> 2] = HEAP32[gb + 1477052 >> 2];
       i3 = HEAP32[gb + 1477056 >> 2] | 0;
       HEAP32[gb + 1477052 >> 2] = i3;
       i3 = i20 >>> 8 ^ i20 ^ i3 ^ i3 >>> 19;
       HEAP32[gb + 1477056 >> 2] = i3;
       i3 = 0 - ((i3 >>> 0) % (i14 >>> 0) | 0) | 0;
      } else i3 = 0;
      HEAP32[i21 >> 2] = i26;
      HEAP32[i6 >> 2] = i27;
      HEAP32[i22 >> 2] = i25;
      HEAP32[i7 >> 2] = i24;
      __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_(i30, i3, i1 + (i2 * 48 | 0) | 0, i32, i35, i33, i34, f28, i21, i22);
      i1 = HEAP32[i31 >> 2] | 0;
      f52 = Math_fround(HEAPF32[i29 >> 2]);
      i19 = i1 + (i2 * 48 | 0) | 0;
      f51 = Math_fround(HEAPF32[i19 >> 2]);
      f50 = Math_fround(HEAPF32[i8 >> 2]);
      i20 = i1 + (i2 * 48 | 0) + 4 | 0;
      f49 = Math_fround(HEAPF32[i20 >> 2]);
      f48 = Math_fround(HEAPF32[i9 >> 2]);
      i1 = i1 + (i2 * 48 | 0) + 8 | 0;
      f47 = Math_fround(HEAPF32[i1 >> 2]);
      HEAPF32[i29 >> 2] = f51 < f52 ? f51 : f52;
      HEAPF32[i8 >> 2] = f49 < f50 ? f49 : f50;
      HEAPF32[i9 >> 2] = f47 < f48 ? f47 : f48;
      f48 = Math_fround(HEAPF32[i10 >> 2]);
      f47 = Math_fround(HEAPF32[i19 >> 2]);
      f50 = Math_fround(HEAPF32[i11 >> 2]);
      f49 = Math_fround(HEAPF32[i20 >> 2]);
      f52 = Math_fround(HEAPF32[i12 >> 2]);
      f51 = Math_fround(HEAPF32[i1 >> 2]);
      HEAPF32[i10 >> 2] = f48 < f47 ? f47 : f48;
      HEAPF32[i11 >> 2] = f50 < f49 ? f49 : f50;
      HEAPF32[i12 >> 2] = f52 < f51 ? f51 : f52;
      i2 = i2 + 1 | 0;
      i1 = HEAP32[i31 >> 2] | 0;
     } while (i2 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0);
     STACKTOP = i36;
     return;
    }
    switch (HEAP32[i6 + 40 >> 2] | 0) {
    case 1:
     {
      i3 = i31 + 4 | 0;
      i1 = HEAP32[i31 >> 2] | 0;
      if ((((HEAP32[i3 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i2 >>> 0) {
       STACKTOP = i36;
       return;
      }
      i4 = i14 + 4 | 0;
      i5 = i15 + 4 | 0;
      i6 = i30 + 76 | 0;
      i7 = i30 + 80 | 0;
      i8 = i30 + 84 | 0;
      i9 = i30 + 88 | 0;
      i10 = i30 + 92 | 0;
      do {
       HEAP32[i14 >> 2] = i26;
       HEAP32[i4 >> 2] = i27;
       HEAP32[i15 >> 2] = i25;
       HEAP32[i5 >> 2] = i24;
       __ZN19MeshParticleEmitter18SetupParticleStripER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti(i30, i1 + (i2 * 48 | 0) | 0, i32, i35, i33, i34, f28, i14, i15, i11, HEAP32[i18 >> 2] | 0);
       i23 = HEAP32[i31 >> 2] | 0;
       f52 = Math_fround(HEAPF32[i29 >> 2]);
       i21 = i23 + (i2 * 48 | 0) | 0;
       f51 = Math_fround(HEAPF32[i21 >> 2]);
       f50 = Math_fround(HEAPF32[i6 >> 2]);
       i22 = i23 + (i2 * 48 | 0) + 4 | 0;
       f49 = Math_fround(HEAPF32[i22 >> 2]);
       f48 = Math_fround(HEAPF32[i7 >> 2]);
       i23 = i23 + (i2 * 48 | 0) + 8 | 0;
       f47 = Math_fround(HEAPF32[i23 >> 2]);
       HEAPF32[i29 >> 2] = f51 < f52 ? f51 : f52;
       HEAPF32[i6 >> 2] = f49 < f50 ? f49 : f50;
       HEAPF32[i7 >> 2] = f47 < f48 ? f47 : f48;
       f48 = Math_fround(HEAPF32[i8 >> 2]);
       f47 = Math_fround(HEAPF32[i21 >> 2]);
       f50 = Math_fround(HEAPF32[i9 >> 2]);
       f49 = Math_fround(HEAPF32[i22 >> 2]);
       f52 = Math_fround(HEAPF32[i10 >> 2]);
       f51 = Math_fround(HEAPF32[i23 >> 2]);
       HEAPF32[i8 >> 2] = f48 < f47 ? f47 : f48;
       HEAPF32[i9 >> 2] = f50 < f49 ? f49 : f50;
       HEAPF32[i10 >> 2] = f52 < f51 ? f51 : f52;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i31 >> 2] | 0;
      } while (i2 >>> 0 < (((HEAP32[i3 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0);
      STACKTOP = i36;
      return;
     }
    case 0:
     {
      i3 = i31 + 4 | 0;
      i1 = HEAP32[i31 >> 2] | 0;
      if ((((HEAP32[i3 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i2 >>> 0) {
       STACKTOP = i36;
       return;
      }
      i4 = i16 + 4 | 0;
      i5 = i17 + 4 | 0;
      i6 = i30 + 76 | 0;
      i7 = i30 + 80 | 0;
      i8 = i30 + 84 | 0;
      i9 = i30 + 88 | 0;
      i10 = i30 + 92 | 0;
      do {
       HEAP32[i16 >> 2] = i26;
       HEAP32[i4 >> 2] = i27;
       HEAP32[i17 >> 2] = i25;
       HEAP32[i5 >> 2] = i24;
       __ZN19MeshParticleEmitter16SetupParticleTriER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti(i30, i1 + (i2 * 48 | 0) | 0, i32, i35, i33, i34, f28, i16, i17, i11, ((HEAP32[i18 >> 2] | 0) >>> 0) / 3 | 0);
       i23 = HEAP32[i31 >> 2] | 0;
       f52 = Math_fround(HEAPF32[i29 >> 2]);
       i21 = i23 + (i2 * 48 | 0) | 0;
       f51 = Math_fround(HEAPF32[i21 >> 2]);
       f50 = Math_fround(HEAPF32[i6 >> 2]);
       i22 = i23 + (i2 * 48 | 0) + 4 | 0;
       f49 = Math_fround(HEAPF32[i22 >> 2]);
       f48 = Math_fround(HEAPF32[i7 >> 2]);
       i23 = i23 + (i2 * 48 | 0) + 8 | 0;
       f47 = Math_fround(HEAPF32[i23 >> 2]);
       HEAPF32[i29 >> 2] = f51 < f52 ? f51 : f52;
       HEAPF32[i6 >> 2] = f49 < f50 ? f49 : f50;
       HEAPF32[i7 >> 2] = f47 < f48 ? f47 : f48;
       f48 = Math_fround(HEAPF32[i8 >> 2]);
       f47 = Math_fround(HEAPF32[i21 >> 2]);
       f50 = Math_fround(HEAPF32[i9 >> 2]);
       f49 = Math_fround(HEAPF32[i22 >> 2]);
       f52 = Math_fround(HEAPF32[i10 >> 2]);
       f51 = Math_fround(HEAPF32[i23 >> 2]);
       HEAPF32[i8 >> 2] = f48 < f47 ? f47 : f48;
       HEAPF32[i9 >> 2] = f50 < f49 ? f49 : f50;
       HEAPF32[i10 >> 2] = f52 < f51 ? f51 : f52;
       i2 = i2 + 1 | 0;
       i1 = HEAP32[i31 >> 2] | 0;
      } while (i2 >>> 0 < (((HEAP32[i3 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0);
      STACKTOP = i36;
      return;
     }
    default:
     {
      STACKTOP = i36;
      return;
     }
    }
   }
  }
 }
 i4 = i31 + 4 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if ((((HEAP32[i4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 > i2 >>> 0) {
  i5 = i12 + 4 | 0;
  i6 = i13 + 4 | 0;
  i7 = i30 + 76 | 0;
  i8 = i30 + 80 | 0;
  i9 = i30 + 84 | 0;
  i10 = i30 + 88 | 0;
  i11 = i30 + 92 | 0;
  do {
   HEAP32[i12 >> 2] = i3;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i6 >> 2] = 1;
   __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_(i30, 0, i1 + (i2 * 48 | 0) | 0, i32, i35, i33, i34, f28, i12, i13);
   i27 = HEAP32[i31 >> 2] | 0;
   f52 = Math_fround(HEAPF32[i29 >> 2]);
   i25 = i27 + (i2 * 48 | 0) | 0;
   f51 = Math_fround(HEAPF32[i25 >> 2]);
   f50 = Math_fround(HEAPF32[i7 >> 2]);
   i26 = i27 + (i2 * 48 | 0) + 4 | 0;
   f49 = Math_fround(HEAPF32[i26 >> 2]);
   f48 = Math_fround(HEAPF32[i8 >> 2]);
   i27 = i27 + (i2 * 48 | 0) + 8 | 0;
   f47 = Math_fround(HEAPF32[i27 >> 2]);
   HEAPF32[i29 >> 2] = f51 < f52 ? f51 : f52;
   HEAPF32[i7 >> 2] = f49 < f50 ? f49 : f50;
   HEAPF32[i8 >> 2] = f47 < f48 ? f47 : f48;
   f48 = Math_fround(HEAPF32[i9 >> 2]);
   f47 = Math_fround(HEAPF32[i25 >> 2]);
   f50 = Math_fround(HEAPF32[i10 >> 2]);
   f49 = Math_fround(HEAPF32[i26 >> 2]);
   f52 = Math_fround(HEAPF32[i11 >> 2]);
   f51 = Math_fround(HEAPF32[i27 >> 2]);
   HEAPF32[i9 >> 2] = f48 < f47 ? f47 : f48;
   HEAPF32[i10 >> 2] = f50 < f49 ? f49 : f50;
   HEAPF32[i11 >> 2] = f52 < f51 ? f51 : f52;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i31 >> 2] | 0;
  } while (i2 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0);
 }
 STACKTOP = i36;
 return;
}

function __ZN5Umbra15ImpShadowCullerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 i2 = i1 + 108 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 i2 = i1 + 132 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 148 >> 2] = Math_fround(1.0);
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 168 >> 2] = Math_fround(1.0);
 i2 = i1 + 172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 188 >> 2] = Math_fround(1.0);
 _memset(i1 + 240 | 0, 0, 32768) | 0;
 HEAPF32[i1 + 192 >> 2] = Math_fround(64.0);
 HEAPF32[i1 + 196 >> 2] = Math_fround(64.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(64.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(64.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(128.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(128.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(128.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(128.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(65534.0);
 HEAPF32[i1 + 228 >> 2] = Math_fround(65534.0);
 HEAPF32[i1 + 232 >> 2] = Math_fround(65534.0);
 HEAPF32[i1 + 236 >> 2] = Math_fround(65534.0);
 i2 = i1 + 33008 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAPF32[i1 + 33040 >> 2] = Math_fround(1.0);
 i2 = i1 + 33044 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33060 >> 2] = Math_fround(1.0);
 i2 = i1 + 33064 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33080 >> 2] = Math_fround(1.0);
 i2 = i1 + 33084 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33100 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 33104 >> 2] = Math_fround(1.0);
 i2 = i1 + 33108 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33124 >> 2] = Math_fround(1.0);
 i2 = i1 + 33128 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33144 >> 2] = Math_fround(1.0);
 i2 = i1 + 33148 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 33164 >> 2] = Math_fround(1.0);
 i2 = i1 + 34248 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 34416 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 33168 | 0, 0, 1068) | 0;
 i2 = i1 + 34356 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = i1 + 34448 | 0;
 HEAP32[i1 + 34480 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP16[i2 + 24 >> 1] = 0;
 HEAP8[i2 + 26 >> 0] = 0;
 HEAPF32[i1 + 34496 >> 2] = Math_fround(1.0);
 i2 = i1 + 34500 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34516 >> 2] = Math_fround(1.0);
 i2 = i1 + 34520 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34536 >> 2] = Math_fround(1.0);
 i2 = i1 + 34540 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34556 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 34560 >> 2] = Math_fround(1.0);
 i2 = i1 + 34564 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34580 >> 2] = Math_fround(1.0);
 i2 = i1 + 34584 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34600 >> 2] = Math_fround(1.0);
 i2 = i1 + 34604 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 34620 >> 2] = Math_fround(1.0);
 i2 = i1 + 35704 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 35872 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 34624 | 0, 0, 1068) | 0;
 i2 = i1 + 35812 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 35904 >> 2] = Math_fround(1.0);
 i2 = i1 + 35908 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 35924 >> 2] = Math_fround(1.0);
 i2 = i1 + 35928 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 35944 >> 2] = Math_fround(1.0);
 i2 = i1 + 35948 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 35964 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 35968 >> 2] = Math_fround(1.0);
 i2 = i1 + 35972 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 35988 >> 2] = Math_fround(1.0);
 i2 = i1 + 35992 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 36008 >> 2] = Math_fround(1.0);
 i2 = i1 + 36012 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 36028 >> 2] = Math_fround(1.0);
 i2 = i1 + 37112 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 37280 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 36032 | 0, 0, 1068) | 0;
 i2 = i1 + 37220 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 37312 >> 2] = Math_fround(1.0);
 i2 = i1 + 37316 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37332 >> 2] = Math_fround(1.0);
 i2 = i1 + 37336 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37352 >> 2] = Math_fround(1.0);
 i2 = i1 + 37356 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37372 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 37376 >> 2] = Math_fround(1.0);
 i2 = i1 + 37380 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37396 >> 2] = Math_fround(1.0);
 i2 = i1 + 37400 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37416 >> 2] = Math_fround(1.0);
 i2 = i1 + 37420 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 37436 >> 2] = Math_fround(1.0);
 i2 = i1 + 38520 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 38688 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 37440 | 0, 0, 1068) | 0;
 i2 = i1 + 38628 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 38720 >> 2] = Math_fround(1.0);
 i2 = i1 + 38724 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38740 >> 2] = Math_fround(1.0);
 i2 = i1 + 38744 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38760 >> 2] = Math_fround(1.0);
 i2 = i1 + 38764 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38780 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 38784 >> 2] = Math_fround(1.0);
 i2 = i1 + 38788 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38804 >> 2] = Math_fround(1.0);
 i2 = i1 + 38808 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38824 >> 2] = Math_fround(1.0);
 i2 = i1 + 38828 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 38844 >> 2] = Math_fround(1.0);
 i2 = i1 + 39928 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 40096 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 38848 | 0, 0, 1068) | 0;
 i2 = i1 + 40036 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 40128 >> 2] = Math_fround(1.0);
 i2 = i1 + 40132 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40148 >> 2] = Math_fround(1.0);
 i2 = i1 + 40152 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40168 >> 2] = Math_fround(1.0);
 i2 = i1 + 40172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40188 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 40192 >> 2] = Math_fround(1.0);
 i2 = i1 + 40196 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40212 >> 2] = Math_fround(1.0);
 i2 = i1 + 40216 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40232 >> 2] = Math_fround(1.0);
 i2 = i1 + 40236 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40252 >> 2] = Math_fround(1.0);
 i2 = i1 + 41336 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 41504 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 40256 | 0, 0, 1068) | 0;
 i2 = i1 + 41444 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 41536 >> 2] = Math_fround(1.0);
 i2 = i1 + 41540 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41556 >> 2] = Math_fround(1.0);
 i2 = i1 + 41560 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41576 >> 2] = Math_fround(1.0);
 i2 = i1 + 41580 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41596 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 41600 >> 2] = Math_fround(1.0);
 i2 = i1 + 41604 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41620 >> 2] = Math_fround(1.0);
 i2 = i1 + 41624 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41640 >> 2] = Math_fround(1.0);
 i2 = i1 + 41644 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 41660 >> 2] = Math_fround(1.0);
 i2 = i1 + 42744 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 42912 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 41664 | 0, 0, 1068) | 0;
 i2 = i1 + 42852 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 42944 >> 2] = Math_fround(1.0);
 i2 = i1 + 42948 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 42964 >> 2] = Math_fround(1.0);
 i2 = i1 + 42968 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 42984 >> 2] = Math_fround(1.0);
 i2 = i1 + 42988 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 43004 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 43008 >> 2] = Math_fround(1.0);
 i2 = i1 + 43012 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 43028 >> 2] = Math_fround(1.0);
 i2 = i1 + 43032 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 43048 >> 2] = Math_fround(1.0);
 i2 = i1 + 43052 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 43068 >> 2] = Math_fround(1.0);
 i2 = i1 + 44152 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 44320 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 43072 | 0, 0, 1068) | 0;
 i2 = i1 + 44260 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 44352 >> 2] = Math_fround(1.0);
 i2 = i1 + 44356 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44372 >> 2] = Math_fround(1.0);
 i2 = i1 + 44376 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44392 >> 2] = Math_fround(1.0);
 i2 = i1 + 44396 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44412 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44416 >> 2] = Math_fround(1.0);
 i2 = i1 + 44420 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44436 >> 2] = Math_fround(1.0);
 i2 = i1 + 44440 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44456 >> 2] = Math_fround(1.0);
 i2 = i1 + 44460 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 44476 >> 2] = Math_fround(1.0);
 i2 = i1 + 45560 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 45728 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 44480 | 0, 0, 1068) | 0;
 i2 = i1 + 45668 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return;
}

function __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i10, i8, 1); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034568 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034591 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034599 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034608 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034618 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034629 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034639 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034650 | 0, gb + 1034577 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034662 | 0, gb + 1033949 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034671 | 0, gb + 1033949 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 208 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034680 | 0, gb + 1033949 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 224 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034690 | 0, gb + 1033949 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 240 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034701 | 0, gb + 1034708 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 284 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034730 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   do if (i1 >>> 0 < i6 >>> 0) i7 = 90; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 90;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   } while (0);
   if ((i7 | 0) == 90) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034741 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 101; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 101;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 101) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 244 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034753 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 112; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 112;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 112) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 248 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034765 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  L160 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L160;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 249 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034776 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  L172 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i4 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L172;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 252 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034787 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 141; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 141;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 141) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 256 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034802 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 152; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 152;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 152) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 260 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034818 | 0, HEAP32[gb + 37320 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 276 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034834 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 169; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 169;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 169) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034847 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 180; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 180;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 180) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034861 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  L252 : do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L252;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 293 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034876 | 0, i6, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 L265 : do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i9 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L265;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZNK5physx2Gu29ConvexVsMeshContactGeneration16generateContactsERKNS_7PxPlaneEPKNS_6PxVec3ERS6_RS5_fj(i28, i21, i22, i1, i9, f12, i20) {
 i28 = i28 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 f12 = Math_fround(f12);
 i20 = i20 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i31 + 232 | 0;
 i26 = i31 + 216 | 0;
 i19 = i31 + 104 | 0;
 i29 = i31 + 92 | 0;
 i18 = i31 + 8 | 0;
 i30 = i31 + 248 | 0;
 i23 = i31 + 168 | 0;
 i24 = i31 + 120 | 0;
 i25 = i31 + 4 | 0;
 i27 = i31;
 i16 = i31 + 56 | 0;
 i17 = i31 + 20 | 0;
 i15 = i28 + 2188 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 f32 = Math_fround(HEAPF32[i1 >> 2]);
 f33 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
 f4 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 4 >> 2]));
 f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 8 >> 2]));
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f34 = Math_fround(f2 * Math_fround(HEAPF32[i7 + 12 >> 2]));
 f3 = Math_fround(f2 * Math_fround(HEAPF32[i7 + 16 >> 2]));
 f34 = Math_fround(f33 + f34);
 f3 = Math_fround(f4 + f3);
 f2 = Math_fround(f32 + Math_fround(f2 * Math_fround(HEAPF32[i7 + 20 >> 2])));
 f32 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 24 >> 2]));
 f33 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 28 >> 2]));
 f4 = Math_fround(f34 + f4);
 f33 = Math_fround(f3 + f33);
 f32 = Math_fround(f2 + Math_fround(f32 * Math_fround(HEAPF32[i7 + 32 >> 2])));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 + 36 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i7 + 40 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i7 + 44 >> 2]));
 f4 = Math_fround(Math_fround(HEAPF32[i28 + 2168 >> 2]) - f4);
 f33 = Math_fround(Math_fround(HEAPF32[i28 + 2172 >> 2]) - f33);
 f32 = Math_fround(Math_fround(HEAPF32[i28 + 2176 >> 2]) - f32);
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(f4 * f2);
 i7 = i9 + 4 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f33 = Math_fround(f4 + Math_fround(f33 * f3));
 i8 = i9 + 8 | 0;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 if (Math_fround(f33 + Math_fround(f32 * f4)) < Math_fround(0.0)) {
  f2 = Math_fround(-f2);
  f3 = Math_fround(-f3);
  f4 = Math_fround(-f4);
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i7 >> 2] = f3;
  HEAPF32[i8 >> 2] = f4;
 }
 i13 = i28 + 2180 | 0;
 i11 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i11 + 68 >> 2] | 0;
 i14 = i28 + 2192 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i6 = i28 + 2184 | 0;
 i35 = HEAP32[i6 >> 2] | 0;
 f2 = Math_fround(-f2);
 f3 = Math_fround(-f3);
 f34 = Math_fround(-f4);
 f32 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f2);
 f32 = Math_fround(f32 + Math_fround(Math_fround(HEAPF32[i35 + 4 >> 2]) * f3));
 f32 = Math_fround(f32 + Math_fround(Math_fround(HEAPF32[i35 + 8 >> 2]) * f34));
 f33 = Math_fround(Math_fround(HEAPF32[i35 + 12 >> 2]) * f2);
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i35 + 16 >> 2]) * f3));
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i35 + 20 >> 2]) * f34));
 f4 = Math_fround(Math_fround(HEAPF32[i35 + 24 >> 2]) * f2);
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i35 + 28 >> 2]) * f3));
 f34 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i35 + 32 >> 2]) * f34));
 HEAPF32[i5 >> 2] = f32;
 HEAPF32[i5 + 4 >> 2] = f33;
 HEAPF32[i5 + 8 >> 2] = f34;
 i10 = mftCall_iiii(i1 | 0, i11 | 0, i10 | 0, i5 | 0) | 0;
 i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0;
 i1 = i11 + (i10 * 20 | 0) | 0;
 i5 = i28 + 2201 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i35 = HEAP32[i14 >> 2] | 0;
  f33 = Math_fround(HEAPF32[i11 + (i10 * 20 | 0) + 12 >> 2]);
  f2 = Math_fround(HEAPF32[i35 + 36 >> 2]);
  f32 = Math_fround(HEAPF32[i1 >> 2]);
  f2 = Math_fround(f2 * f32);
  f3 = Math_fround(HEAPF32[i35 + 40 >> 2]);
  f34 = Math_fround(HEAPF32[i11 + (i10 * 20 | 0) + 4 >> 2]);
  f3 = Math_fround(f2 + Math_fround(f3 * f34));
  f2 = Math_fround(HEAPF32[i35 + 44 >> 2]);
  f4 = Math_fround(HEAPF32[i11 + (i10 * 20 | 0) + 8 >> 2]);
  f2 = Math_fround(f3 + Math_fround(f2 * f4));
  f3 = Math_fround(f32 * Math_fround(HEAPF32[i35 + 48 >> 2]));
  f3 = Math_fround(f3 + Math_fround(f34 * Math_fround(HEAPF32[i35 + 52 >> 2])));
  f3 = Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i35 + 56 >> 2])));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i35 + 60 >> 2]));
  f34 = Math_fround(f32 + Math_fround(f34 * Math_fround(HEAPF32[i35 + 64 >> 2])));
  f4 = Math_fround(f34 + Math_fround(f4 * Math_fround(HEAPF32[i35 + 68 >> 2])));
  f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4)))));
  f2 = Math_fround(f2 * f34);
  f3 = Math_fround(f3 * f34);
  f4 = Math_fround(f4 * f34);
  HEAPF32[i26 >> 2] = f2;
  HEAPF32[i26 + 4 >> 2] = f3;
  HEAPF32[i26 + 8 >> 2] = f4;
  HEAPF32[i26 + 12 >> 2] = Math_fround(f33 * f34);
 } else {
  i36 = HEAP32[i1 >> 2] | 0;
  HEAP32[i26 >> 2] = i36;
  i1 = HEAP32[i11 + (i10 * 20 | 0) + 4 >> 2] | 0;
  HEAP32[i26 + 4 >> 2] = i1;
  i35 = HEAP32[i11 + (i10 * 20 | 0) + 8 >> 2] | 0;
  HEAP32[i26 + 8 >> 2] = i35;
  HEAP32[i26 + 12 >> 2] = HEAP32[i11 + (i10 * 20 | 0) + 12 >> 2];
  f2 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 i36 = HEAP32[i6 >> 2] | 0;
 f47 = Math_fround(f2 * Math_fround(HEAPF32[i36 >> 2]));
 f52 = Math_fround(f2 * Math_fround(HEAPF32[i36 + 4 >> 2]));
 f45 = Math_fround(f2 * Math_fround(HEAPF32[i36 + 8 >> 2]));
 f37 = Math_fround(f3 * Math_fround(HEAPF32[i36 + 12 >> 2]));
 f39 = Math_fround(f3 * Math_fround(HEAPF32[i36 + 16 >> 2]));
 f37 = Math_fround(f47 + f37);
 f39 = Math_fround(f52 + f39);
 f45 = Math_fround(f45 + Math_fround(f3 * Math_fround(HEAPF32[i36 + 20 >> 2])));
 f52 = Math_fround(f4 * Math_fround(HEAPF32[i36 + 24 >> 2]));
 f2 = Math_fround(f4 * Math_fround(HEAPF32[i36 + 28 >> 2]));
 f52 = Math_fround(f37 + f52);
 f2 = Math_fround(f39 + f2);
 f45 = Math_fround(f45 + Math_fround(f4 * Math_fround(HEAPF32[i36 + 32 >> 2])));
 HEAPF32[i19 >> 2] = f52;
 HEAPF32[i19 + 4 >> 2] = f2;
 HEAPF32[i19 + 8 >> 2] = f45;
 f39 = Math_fround(HEAPF32[i9 >> 2]);
 f52 = Math_fround(f52 * f39);
 f37 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(f52 + Math_fround(f2 * f37));
 f52 = Math_fround(HEAPF32[i8 >> 2]);
 f45 = Math_fround(Math_abs(Math_fround(f2 + Math_fround(f45 * f52))));
 i9 = HEAP32[i15 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i21 >> 2]);
 f47 = Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2]));
 f54 = Math_fround(f2 * Math_fround(HEAPF32[i9 + 4 >> 2]));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i9 + 8 >> 2]));
 f42 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f41 = Math_fround(f42 * Math_fround(HEAPF32[i9 + 12 >> 2]));
 f3 = Math_fround(f42 * Math_fround(HEAPF32[i9 + 16 >> 2]));
 f41 = Math_fround(f47 + f41);
 f3 = Math_fround(f54 + f3);
 f42 = Math_fround(f2 + Math_fround(f42 * Math_fround(HEAPF32[i9 + 20 >> 2])));
 f2 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f54 = Math_fround(f2 * Math_fround(HEAPF32[i9 + 24 >> 2]));
 f47 = Math_fround(f2 * Math_fround(HEAPF32[i9 + 28 >> 2]));
 f54 = Math_fround(f41 + f54);
 f47 = Math_fround(f3 + f47);
 f2 = Math_fround(f42 + Math_fround(f2 * Math_fround(HEAPF32[i9 + 32 >> 2])));
 HEAPF32[i29 >> 2] = f54;
 HEAPF32[i29 + 4 >> 2] = f47;
 HEAPF32[i29 + 8 >> 2] = f2;
 i9 = f45 > Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f54 * f39) + Math_fround(f47 * f37)) + Math_fround(f2 * f52))));
 f2 = Math_fround(-f12);
 i7 = f12 <= Math_fround(-0.0);
 f2 = i7 ? f2 : Math_fround(0.0);
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i28 + 2204 >> 2]));
 f39 = Math_fround(f39 * f2);
 f37 = Math_fround(f37 * f2);
 f52 = Math_fround(f52 * f2);
 HEAPF32[i18 >> 2] = f39;
 HEAPF32[i18 + 4 >> 2] = f37;
 HEAPF32[i18 + 8 >> 2] = f52;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i30 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i30 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i30 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i30 + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 f47 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f54 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 f45 = Math_fround(HEAPF32[i7 + 44 >> 2]);
 i7 = HEAP32[i28 + 2208 >> 2] | 0;
 f42 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f41 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f51 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f39 = Math_fround(f47 - f39);
 HEAPF32[i30 + 36 >> 2] = f39;
 f37 = Math_fround(f54 - f37);
 HEAPF32[i30 + 40 >> 2] = f37;
 f52 = Math_fround(f45 - f52);
 HEAPF32[i30 + 44 >> 2] = f52;
 i7 = HEAP32[i28 + 2212 >> 2] | 0;
 f45 = Math_fround(HEAPF32[i7 >> 2]);
 f54 = Math_fround(-f45);
 f47 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f33 = Math_fround(-f47);
 f38 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f48 = Math_fround(-f38);
 f43 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f32 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f46 = Math_fround(f39 - f32);
 f34 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f44 = Math_fround(f37 - f34);
 f53 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f46 = Math_fround(f46 * Math_fround(2.0));
 f44 = Math_fround(f44 * Math_fround(2.0));
 f50 = Math_fround(Math_fround(f52 - f53) * Math_fround(2.0));
 f49 = Math_fround(Math_fround(f43 * f43) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f46 * f54) + Math_fround(f44 * f33)) + Math_fround(f50 * f48));
 f40 = Math_fround(Math_fround(f4 * f54) + Math_fround(Math_fround(f49 * f46) + Math_fround(f43 * Math_fround(Math_fround(f50 * f33) - Math_fround(f44 * f48)))));
 f12 = Math_fround(Math_fround(f4 * f33) + Math_fround(Math_fround(f49 * f44) + Math_fround(f43 * Math_fround(Math_fround(f46 * f48) - Math_fround(f50 * f54)))));
 f4 = Math_fround(Math_fround(Math_fround(f49 * f50) + Math_fround(f43 * Math_fround(Math_fround(f44 * f54) - Math_fround(f46 * f33)))) + Math_fround(f4 * f48));
 f46 = Math_fround(Math_fround(Math_fround(f41 * f33) + Math_fround(Math_fround(f51 * f54) + Math_fround(f42 * f43))) - Math_fround(f3 * f48));
 f44 = Math_fround(Math_fround(Math_fround(f42 * f48) + Math_fround(Math_fround(f51 * f33) + Math_fround(f3 * f43))) - Math_fround(f41 * f54));
 f50 = Math_fround(Math_fround(Math_fround(f3 * f54) + Math_fround(Math_fround(f51 * f48) + Math_fround(f41 * f43))) - Math_fround(f42 * f33));
 f49 = Math_fround(f51 * f43);
 f48 = Math_fround(Math_fround(Math_fround(f49 - Math_fround(f42 * f54)) - Math_fround(f3 * f33)) - Math_fround(f41 * f48));
 f42 = Math_fround(-f42);
 f3 = Math_fround(-f3);
 f41 = Math_fround(-f41);
 f39 = Math_fround(Math_fround(f32 - f39) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(f34 - f37) * Math_fround(2.0));
 f52 = Math_fround(Math_fround(f53 - f52) * Math_fround(2.0));
 f53 = Math_fround(Math_fround(f51 * f51) + Math_fround(-.5));
 f34 = Math_fround(Math_fround(Math_fround(f39 * f42) + Math_fround(f37 * f3)) + Math_fround(f52 * f41));
 f32 = Math_fround(Math_fround(f34 * f42) + Math_fround(Math_fround(f53 * f39) + Math_fround(f51 * Math_fround(Math_fround(f52 * f3) - Math_fround(f37 * f41)))));
 f33 = Math_fround(Math_fround(f34 * f3) + Math_fround(Math_fround(f53 * f37) + Math_fround(f51 * Math_fround(Math_fround(f39 * f41) - Math_fround(f52 * f42)))));
 f34 = Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(f51 * Math_fround(Math_fround(f37 * f42) - Math_fround(f39 * f3)))) + Math_fround(f34 * f41));
 f39 = Math_fround(Math_fround(Math_fround(f38 * f3) + Math_fround(Math_fround(f51 * f45) + Math_fround(f43 * f42))) - Math_fround(f47 * f41));
 f37 = Math_fround(Math_fround(Math_fround(f45 * f41) + Math_fround(Math_fround(f51 * f47) + Math_fround(f43 * f3))) - Math_fround(f38 * f42));
 f43 = Math_fround(Math_fround(Math_fround(f47 * f42) + Math_fround(Math_fround(f51 * f38) + Math_fround(f43 * f41))) - Math_fround(f45 * f3));
 f41 = Math_fround(Math_fround(Math_fround(f49 - Math_fround(f45 * f42)) - Math_fround(f47 * f3)) - Math_fround(f38 * f41));
 f38 = Math_fround(f46 + f46);
 f3 = Math_fround(f44 + f44);
 f47 = Math_fround(f50 + f50);
 f42 = Math_fround(f48 * f38);
 f45 = Math_fround(f48 * f3);
 f48 = Math_fround(f48 * f47);
 f38 = Math_fround(f46 * f38);
 f49 = Math_fround(f46 * f3);
 f46 = Math_fround(f46 * f47);
 f3 = Math_fround(f44 * f3);
 f44 = Math_fround(f44 * f47);
 f47 = Math_fround(f50 * f47);
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f3) - f47);
 HEAPF32[i23 + 4 >> 2] = Math_fround(f49 + f48);
 HEAPF32[i23 + 8 >> 2] = Math_fround(f46 - f45);
 HEAPF32[i23 + 12 >> 2] = Math_fround(f49 - f48);
 f38 = Math_fround(Math_fround(1.0) - f38);
 HEAPF32[i23 + 16 >> 2] = Math_fround(f38 - f47);
 HEAPF32[i23 + 20 >> 2] = Math_fround(f44 + f42);
 HEAPF32[i23 + 24 >> 2] = Math_fround(f46 + f45);
 HEAPF32[i23 + 28 >> 2] = Math_fround(f44 - f42);
 HEAPF32[i23 + 32 >> 2] = Math_fround(f38 - f3);
 HEAPF32[i23 + 36 >> 2] = f40;
 HEAPF32[i23 + 40 >> 2] = f12;
 HEAPF32[i23 + 44 >> 2] = f4;
 f4 = Math_fround(f39 + f39);
 f12 = Math_fround(f37 + f37);
 f40 = Math_fround(f43 + f43);
 f3 = Math_fround(f41 * f4);
 f38 = Math_fround(f41 * f12);
 f41 = Math_fround(f41 * f40);
 f4 = Math_fround(f39 * f4);
 f42 = Math_fround(f39 * f12);
 f39 = Math_fround(f39 * f40);
 f12 = Math_fround(f37 * f12);
 f37 = Math_fround(f37 * f40);
 f40 = Math_fround(f43 * f40);
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f12) - f40);
 HEAPF32[i24 + 4 >> 2] = Math_fround(f42 + f41);
 HEAPF32[i24 + 8 >> 2] = Math_fround(f39 - f38);
 HEAPF32[i24 + 12 >> 2] = Math_fround(f42 - f41);
 f4 = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i24 + 16 >> 2] = Math_fround(f4 - f40);
 HEAPF32[i24 + 20 >> 2] = Math_fround(f37 + f3);
 HEAPF32[i24 + 24 >> 2] = Math_fround(f39 + f38);
 HEAPF32[i24 + 28 >> 2] = Math_fround(f37 - f3);
 HEAPF32[i24 + 32 >> 2] = Math_fround(f4 - f12);
 HEAPF32[i24 + 36 >> 2] = f32;
 HEAPF32[i24 + 40 >> 2] = f33;
 HEAPF32[i24 + 44 >> 2] = f34;
 i7 = HEAP8[i5 >> 0] | 0;
 i8 = i11 + (i10 * 20 | 0) + 18 | 0;
 if (!(i7 << 24 >> 24)) {
  i5 = HEAP8[i8 >> 0] | 0;
  i6 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * ((i5 & 255) * 12 | 0) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i5 & 255) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 } else {
  i6 = 0;
  i1 = 0;
 }
 i36 = HEAP32[i13 >> 2] | 0;
 __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE(i25, i27, i6, i1, i7 << 24 >> 24 != 0, HEAP32[i36 + 28 >> 2] | 0, (HEAP32[i36 + 32 >> 2] | 0) + (HEAPU16[i11 + (i10 * 20 | 0) + 16 >> 1] | 0) | 0, HEAPU8[i8 >> 0] | 0, HEAP32[i14 >> 2] | 0);
 __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E(i16, i26);
 __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E(i17, i21);
 if (i9) {
  if (__ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f(HEAPU8[i8 >> 0] | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] | 0, i30, i26, i16, 3, i22, gb + 656001 | 0, HEAP32[i15 >> 2] | 0, i21, i17, i19, i23, i24, -1, i20, HEAP32[i28 + 2216 >> 2] | 0, 1, i18, f2) | 0) {
   i36 = 1;
   STACKTOP = i31;
   return i36 | 0;
  }
 } else if (__ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f(3, i22, gb + 656001 | 0, HEAP32[i15 >> 2] | 0, i21, i17, HEAPU8[i8 >> 0] | 0, HEAP32[i25 >> 2] | 0, HEAP32[i27 >> 2] | 0, i30, i26, i16, i29, i24, i23, -1, i20, HEAP32[i28 + 2216 >> 2] | 0, 0, i18, f2) | 0) {
  i36 = 1;
  STACKTOP = i31;
  return i36 | 0;
 }
 i36 = 0;
 STACKTOP = i31;
 return i36 | 0;
}

function __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 L1 : while (1) {
  i9 = i2;
  i11 = i2 + -12 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    switch ((i3 | 0) / 12 | 0 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 68;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 372) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i3 >>> 0) / 24 | 0) * 12 | 0) | 0;
    do if ((i3 | 0) > 11988) {
     i4 = (i3 >>> 0) / 48 | 0;
     i6 = i1 + (i4 * 12 | 0) | 0;
     i4 = i7 + (i4 * 12 | 0) | 0;
     i3 = __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i1, i6, i7, i4, i12) | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i4 | 0) | 0) {
      HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      i5 = i3 + 1 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0) {
       HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       i4 = i3 + 2 | 0;
       if (mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i6 | 0) | 0) {
        HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
        HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
        HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
        HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
        HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
        if (mftCall_iii(HEAP32[i12 >> 2] | 0, i6 | 0, i1 | 0) | 0) {
         HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
         HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
         HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
         HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
         HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
         HEAP32[i6 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i4;
      } else i3 = i5;
     }
    } else {
     i6 = mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i1 | 0) | 0;
     i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i7 | 0) | 0;
     if (!i6) {
      if (!i3) {
       i3 = 0;
       break;
      };
      HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i1 | 0) | 0)) {
       i3 = 1;
       break;
      };
      HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      i3 = 2;
      break;
     }
     if (i3) {
      HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      i3 = 1;
      break;
     };
     HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i7 | 0) | 0) {
      HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i7 | 0) | 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -12 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0) {
      i10 = 51;
      break L5;
     }
    }
    i3 = i1 + 12 | 0;
    if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i11 | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i10 = 68;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 12 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i10 = 68;
       break L1;
      }
     }
     HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     i3 = i3 + 12 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i10 = 68;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i5 = i3 + 12 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -12 | 0; while (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i4 | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     };
     HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     i3 = i5;
    }
   }
   if ((i10 | 0) == 51) {
    i10 = 0;
    HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 12 | 0;
   L48 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    while (1) {
     i6 = i5 + 12 | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i5 | 0, i7 | 0) | 0) i5 = i6; else break;
    }
    do i4 = i4 + -12 | 0; while (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i7;
     break L48;
    };
    HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
    i5 = i6;
    i3 = i3 + 1 | 0;
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i5 | 0) | 0) {
    HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEbT0_S9_T_(i1, i5, i12) | 0;
    i4 = i5 + 12 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEbT0_S9_T_(i4, i2, i12) | 0) {
     i10 = 67;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i7 = i5;
   if ((i7 - i8 | 0) >= (i9 - i7 | 0)) {
    i10 = 66;
    break;
   }
   __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i1, i5, i12);
   i1 = i5 + 12 | 0;
  }
  if ((i10 | 0) == 66) {
   i10 = 0;
   __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i5 + 12 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i10 | 0) == 67) {
   i10 = 0;
   if (i3) {
    i10 = 68;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i1 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 12 | 0;
  i10 = mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
  i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i2 | 0) | 0;
  if (!i10) {
   if (!i3) {
    STACKTOP = i14;
    return;
   };
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0)) {
    STACKTOP = i14;
    return;
   };
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   STACKTOP = i14;
   return;
  }
  if (i3) {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i2 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i11, i12) | 0;
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 12 | 0;
  i3 = i1 + 24 | 0;
  i4 = i1 + 36 | 0;
  __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i1, i2, i3, i4, i12) | 0;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i4 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0)) {
   STACKTOP = i14;
   return;
  };
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i1, i2, i12);
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 68) {
  STACKTOP = i14;
  return;
 }
}

function __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i1, i2, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0;
 L1 : while (1) {
  i16 = i2;
  i17 = i2 + -16 | 0;
  i20 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i15 = i1;
    i3 = i16 - i15 | 0;
    i4 = i3 >> 4;
    switch (i4 | 0) {
    case 2:
     {
      i18 = 5;
      break L1;
     }
    case 3:
     {
      i18 = 7;
      break L1;
     }
    case 4:
     {
      i18 = 15;
      break L1;
     }
    case 5:
     {
      i18 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i18 = 69;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 112) {
     i18 = 22;
     break L1;
    }
    i12 = (i4 | 0) / 2 | 0;
    i14 = i1 + (i12 << 4) | 0;
    do if ((i3 | 0) > 15984) {
     i11 = (i4 | 0) / 4 | 0;
     i13 = i1 + (i11 << 4) | 0;
     i9 = i14 + (i11 << 4) | 0;
     i3 = __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i1, i13, i14, i9, i19) | 0;
     i5 = i17;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     i7 = i9;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     if (!(i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0)) {
      i4 = i14;
      break;
     }
     i10 = i9;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i10 + 4 >> 2] = i5;
     i10 = i17;
     HEAP32[i10 >> 2] = i6;
     HEAP32[i10 + 4 >> 2] = i7;
     i10 = i9 + 8 | 0;
     i4 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i20 >> 2] = i4;
     i4 = i3 + 1 | 0;
     i6 = i9;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     i8 = i14;
     i7 = HEAP32[i8 >> 2] | 0;
     i8 = HEAP32[i8 + 4 >> 2] | 0;
     if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
      i4 = i14;
      HEAP32[i4 >> 2] = i5;
      HEAP32[i4 + 4 >> 2] = i6;
      HEAP32[i9 >> 2] = i7;
      HEAP32[i9 + 4 >> 2] = i8;
      i9 = i1 + (i12 << 4) + 8 | 0;
      i4 = HEAP32[i9 >> 2] | 0;
      HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i10 >> 2] = i4;
      i4 = i3 + 2 | 0;
      i6 = i14;
      i5 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
      i8 = i13;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
       i4 = i13;
       HEAP32[i4 >> 2] = i5;
       HEAP32[i4 + 4 >> 2] = i6;
       i5 = i14;
       HEAP32[i5 >> 2] = i7;
       HEAP32[i5 + 4 >> 2] = i8;
       i8 = i1 + (i11 << 4) + 8 | 0;
       i5 = HEAP32[i8 >> 2] | 0;
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i9 >> 2] = i5;
       i5 = i13;
       i4 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i7 = i1;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) {
        i12 = i1;
        HEAP32[i12 >> 2] = i4;
        HEAP32[i12 + 4 >> 2] = i5;
        HEAP32[i13 >> 2] = i6;
        HEAP32[i13 + 4 >> 2] = i7;
        i13 = i1 + 8 | 0;
        i4 = HEAP32[i13 >> 2] | 0;
        HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i8 >> 2] = i4;
        i3 = i3 + 4 | 0;
        i4 = i14;
       } else {
        i3 = i3 + 3 | 0;
        i4 = i14;
       }
      } else {
       i3 = i4;
       i4 = i14;
      }
     } else {
      i3 = i4;
      i4 = i14;
     }
    } else {
     i4 = i14;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     i9 = i1;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     i6 = i17;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     i7 = i6 >>> 0 < i4 >>> 0 | (i6 | 0) == (i4 | 0) & i5 >>> 0 < i3 >>> 0;
     if (!(i4 >>> 0 < i9 >>> 0 | (i4 | 0) == (i9 | 0) & i3 >>> 0 < i8 >>> 0)) {
      if (!i7) {
       i3 = 0;
       i4 = i14;
       break;
      }
      i7 = i14;
      HEAP32[i7 >> 2] = i5;
      HEAP32[i7 + 4 >> 2] = i6;
      i5 = i17;
      HEAP32[i5 >> 2] = i3;
      HEAP32[i5 + 4 >> 2] = i4;
      i3 = i1 + (i12 << 4) + 8 | 0;
      i5 = HEAP32[i3 >> 2] | 0;
      HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i5;
      i5 = i14;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      i7 = i1;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      if (!(i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0)) {
       i3 = 1;
       i4 = i14;
       break;
      }
      i13 = i1;
      HEAP32[i13 >> 2] = i4;
      HEAP32[i13 + 4 >> 2] = i5;
      i13 = i14;
      HEAP32[i13 >> 2] = i6;
      HEAP32[i13 + 4 >> 2] = i7;
      i13 = i1 + 8 | 0;
      i4 = HEAP32[i13 >> 2] | 0;
      HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i3 >> 2] = i4;
      i3 = 2;
      i4 = i14;
      break;
     }
     if (i7) {
      i4 = i1;
      HEAP32[i4 >> 2] = i5;
      HEAP32[i4 + 4 >> 2] = i6;
      i4 = i17;
      HEAP32[i4 >> 2] = i8;
      HEAP32[i4 + 4 >> 2] = i9;
      i4 = i1 + 8 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i3;
      i3 = 1;
      i4 = i14;
      break;
     }
     i6 = i1;
     HEAP32[i6 >> 2] = i3;
     HEAP32[i6 + 4 >> 2] = i4;
     i6 = i14;
     HEAP32[i6 >> 2] = i8;
     HEAP32[i6 + 4 >> 2] = i9;
     i6 = i1 + 8 | 0;
     i3 = i1 + (i12 << 4) + 8 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i3 >> 2] = i4;
     i6 = i17;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     if (i6 >>> 0 < i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0) {
      i13 = i14;
      HEAP32[i13 >> 2] = i5;
      HEAP32[i13 + 4 >> 2] = i6;
      i13 = i17;
      HEAP32[i13 >> 2] = i8;
      HEAP32[i13 + 4 >> 2] = i9;
      HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i4;
      i3 = 2;
      i4 = i14;
     } else {
      i3 = 1;
      i4 = i14;
     }
    } while (0);
    i11 = i1;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i7 = i4;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    if (i11 >>> 0 < i7 >>> 0 | (i11 | 0) == (i7 | 0) & i10 >>> 0 < i6 >>> 0) {
     i4 = i17;
     break;
    } else i5 = i17;
    while (1) {
     i4 = i5 + -16 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i9 = i4;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     if (i9 >>> 0 < i7 >>> 0 | (i9 | 0) == (i7 | 0) & i8 >>> 0 < i6 >>> 0) {
      i18 = 52;
      break L5;
     } else i5 = i4;
    }
    i3 = i1 + 16 | 0;
    i7 = i17;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    if (!(i11 >>> 0 < i7 >>> 0 | (i11 | 0) == (i7 | 0) & i10 >>> 0 < i6 >>> 0)) {
     if ((i3 | 0) == (i17 | 0)) {
      i18 = 69;
      break L1;
     }
     while (1) {
      i5 = i3;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if (i11 >>> 0 < i5 >>> 0 | (i11 | 0) == (i5 | 0) & i10 >>> 0 < i4 >>> 0) break;
      i3 = i3 + 16 | 0;
      if ((i3 | 0) == (i17 | 0)) {
       i18 = 69;
       break L1;
      }
     }
     i14 = i3;
     HEAP32[i14 >> 2] = i6;
     HEAP32[i14 + 4 >> 2] = i7;
     i14 = i17;
     HEAP32[i14 >> 2] = i4;
     HEAP32[i14 + 4 >> 2] = i5;
     i14 = i3 + 8 | 0;
     i15 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i20 >> 2] = i15;
     i3 = i3 + 16 | 0;
    }
    if ((i3 | 0) == (i17 | 0)) {
     i18 = 69;
     break L1;
    } else i4 = i17;
    while (1) {
     i12 = i1;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     while (1) {
      i9 = i3;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      i10 = i3 + 16 | 0;
      if (i12 >>> 0 < i9 >>> 0 | (i12 | 0) == (i9 | 0) & i11 >>> 0 < i8 >>> 0) break; else i3 = i10;
     }
     while (1) {
      i5 = i4 + -16 | 0;
      i7 = i5;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      if (i12 >>> 0 < i7 >>> 0 | (i12 | 0) == (i7 | 0) & i11 >>> 0 < i6 >>> 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i15 = i3;
     HEAP32[i15 >> 2] = i6;
     HEAP32[i15 + 4 >> 2] = i7;
     i15 = i5;
     HEAP32[i15 >> 2] = i8;
     HEAP32[i15 + 4 >> 2] = i9;
     i15 = i3 + 8 | 0;
     i4 = i4 + -8 | 0;
     i3 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     i4 = i5;
     i3 = i10;
    }
   }
   if ((i18 | 0) == 52) {
    i18 = 0;
    i13 = i1;
    HEAP32[i13 >> 2] = i8;
    HEAP32[i13 + 4 >> 2] = i9;
    i13 = i4;
    HEAP32[i13 >> 2] = i10;
    HEAP32[i13 + 4 >> 2] = i11;
    i11 = i1 + 8 | 0;
    i13 = i5 + -8 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i13 >> 2] = i12;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 16 | 0;
   L50 : do if (i5 >>> 0 < i4 >>> 0) {
    i9 = i14;
    while (1) {
     i14 = i9;
     i13 = HEAP32[i14 >> 2] | 0;
     i14 = HEAP32[i14 + 4 >> 2] | 0;
     while (1) {
      i11 = i5;
      i10 = HEAP32[i11 >> 2] | 0;
      i11 = HEAP32[i11 + 4 >> 2] | 0;
      i12 = i5 + 16 | 0;
      if (i11 >>> 0 < i14 >>> 0 | (i11 | 0) == (i14 | 0) & i10 >>> 0 < i13 >>> 0) i5 = i12; else break;
     }
     while (1) {
      i6 = i4 + -16 | 0;
      i8 = i6;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      if (i8 >>> 0 < i14 >>> 0 | (i8 | 0) == (i14 | 0) & i7 >>> 0 < i13 >>> 0) break; else i4 = i6;
     }
     if (i5 >>> 0 > i6 >>> 0) break L50;
     i13 = i5;
     HEAP32[i13 >> 2] = i7;
     HEAP32[i13 + 4 >> 2] = i8;
     i13 = i6;
     HEAP32[i13 >> 2] = i10;
     HEAP32[i13 + 4 >> 2] = i11;
     i13 = i5 + 8 | 0;
     i4 = i4 + -8 | 0;
     i14 = HEAP32[i13 >> 2] | 0;
     HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i14;
     i9 = (i9 | 0) == (i5 | 0) ? i6 : i9;
     i4 = i6;
     i5 = i12;
     i3 = i3 + 1 | 0;
    }
   } else i9 = i14; while (0);
   if ((i5 | 0) != (i9 | 0)) {
    i6 = i9;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i4 >>> 0 < i7 >>> 0) {
     i12 = i5;
     HEAP32[i12 >> 2] = i4;
     HEAP32[i12 + 4 >> 2] = i6;
     i12 = i9;
     HEAP32[i12 >> 2] = i7;
     HEAP32[i12 + 4 >> 2] = i8;
     i12 = i5 + 8 | 0;
     i14 = i9 + 8 | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i14 >> 2] = i13;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR12GCHandleLessPNS_4pairIyiEEEEbT0_S6_T_(i1, i5, i19) | 0;
    i4 = i5 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR12GCHandleLessPNS_4pairIyiEEEEbT0_S6_T_(i4, i2, i19) | 0) {
     i18 = 68;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i14 = i5;
   if ((i14 - i15 | 0) >= (i16 - i14 | 0)) {
    i18 = 67;
    break;
   }
   __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i1, i5, i19);
   i1 = i5 + 16 | 0;
  }
  if ((i18 | 0) == 67) {
   i18 = 0;
   __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i5 + 16 | 0, i2, i19);
   i2 = i5;
   continue;
  } else if ((i18 | 0) == 68) {
   i18 = 0;
   if (i3) {
    i18 = 69;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i18 | 0) == 5) {
  i6 = i2 + -16 | 0;
  i3 = i6;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (!(i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0)) return;
  i18 = i1;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i18 + 4 >> 2] = i3;
  i18 = i6;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  i18 = i1 + 8 | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i20 >> 2] = i19;
  return;
 } else if ((i18 | 0) == 7) {
  i10 = i1 + 16 | 0;
  i6 = i10;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i1;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i2 + -16 | 0;
  i3 = i7;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i3 >>> 0 < i6 >>> 0 | (i3 | 0) == (i6 | 0) & i2 >>> 0 < i5 >>> 0;
  if (!(i6 >>> 0 < i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0)) {
   if (!i4) return;
   i4 = i10;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = i3;
   i3 = i7;
   HEAP32[i3 >> 2] = i5;
   HEAP32[i3 + 4 >> 2] = i6;
   i6 = i1 + 24 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i20 >> 2] = i3;
   i3 = i10;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i1;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (!(i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0)) return;
   i19 = i1;
   HEAP32[i19 >> 2] = i2;
   HEAP32[i19 + 4 >> 2] = i3;
   i19 = i10;
   HEAP32[i19 >> 2] = i4;
   HEAP32[i19 + 4 >> 2] = i5;
   i19 = i1 + 8 | 0;
   i20 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i20;
   return;
  }
  if (i4) {
   i18 = i1;
   HEAP32[i18 >> 2] = i2;
   HEAP32[i18 + 4 >> 2] = i3;
   i18 = i7;
   HEAP32[i18 >> 2] = i8;
   HEAP32[i18 + 4 >> 2] = i9;
   i18 = i1 + 8 | 0;
   i19 = HEAP32[i18 >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i20 >> 2] = i19;
   return;
  }
  i4 = i1;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 4 >> 2] = i6;
  i4 = i10;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i4 + 4 >> 2] = i9;
  i4 = i1 + 8 | 0;
  i1 = i1 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i4 = i7;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(i4 >>> 0 < i9 >>> 0 | (i4 | 0) == (i9 | 0) & i3 >>> 0 < i8 >>> 0)) return;
  i19 = i10;
  HEAP32[i19 >> 2] = i3;
  HEAP32[i19 + 4 >> 2] = i4;
  i19 = i7;
  HEAP32[i19 >> 2] = i8;
  HEAP32[i19 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i20 >> 2] = i2;
  return;
 } else if ((i18 | 0) == 15) {
  __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i17, i19) | 0;
  return;
 } else if ((i18 | 0) == 16) {
  i11 = i1 + 16 | 0;
  i10 = i1 + 32 | 0;
  i9 = i1 + 48 | 0;
  __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i1, i11, i10, i9, i19) | 0;
  i2 = i2 + -16 | 0;
  i4 = i2;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i9;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  if (!(i4 >>> 0 < i6 >>> 0 | (i4 | 0) == (i6 | 0) & i3 >>> 0 < i5 >>> 0)) return;
  i8 = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i8 + 4 >> 2] = i4;
  i4 = i2;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 4 >> 2] = i6;
  i4 = i1 + 56 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i20 >> 2] = i8;
  i8 = i9;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = i10;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(i8 >>> 0 < i3 >>> 0 | (i8 | 0) == (i3 | 0) & i7 >>> 0 < i2 >>> 0)) return;
  i5 = i10;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i5 + 4 >> 2] = i8;
  i5 = i9;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  i5 = i1 + 40 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i4 >> 2] = i3;
  i3 = i11;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(i8 >>> 0 < i3 >>> 0 | (i8 | 0) == (i3 | 0) & i7 >>> 0 < i2 >>> 0)) return;
  i4 = i11;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i4 + 4 >> 2] = i8;
  i4 = i10;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i1 + 24 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i5 >> 2] = i3;
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(i8 >>> 0 < i3 >>> 0 | (i8 | 0) == (i3 | 0) & i7 >>> 0 < i2 >>> 0)) return;
  i19 = i1;
  HEAP32[i19 >> 2] = i7;
  HEAP32[i19 + 4 >> 2] = i8;
  i19 = i11;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i3;
  i19 = i1 + 8 | 0;
  i20 = HEAP32[i19 >> 2] | 0;
  HEAP32[i19 >> 2] = i6;
  HEAP32[i4 >> 2] = i20;
  return;
 } else if ((i18 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i1, i2, i19);
  return;
 } else if ((i18 | 0) == 69) return;
}

function __ZNSt3__212__next_primeEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 i8 = i10 + 8 | 0;
 i3 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 do if (i1 >>> 0 < 212) i1 = HEAP32[(__ZNSt3__213__lower_boundIRNS_6__lessIjjEEPKjjEET0_S6_S6_RKT1_T_(gb + 208232 | 0, gb + 208232 + 192 | 0, i8, i2) | 0) >> 2] | 0; else {
  if (i1 >>> 0 > 4294967291) {
   i1 = ___cxa_allocate_exception(8) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4505 | 0, i1 | 0, gb + 1077217 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) {
    i10 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    ___cxa_free_exception(i1 | 0);
    ___resumeException(i10 | 0);
   } else {
    HEAP32[i1 >> 2] = gb + 216424 + 8;
    ___cxa_throw(i1 | 0, gb + 13224 | 0, fb + 3224 | 0);
   }
  }
  i7 = (i1 >>> 0) / 210 | 0;
  i5 = i7 * 210 | 0;
  HEAP32[i3 >> 2] = i1 - i5;
  i4 = (__ZNSt3__213__lower_boundIRNS_6__lessIjjEEPKjjEET0_S6_S6_RKT1_T_(gb + 208424 | 0, gb + 208424 + 192 | 0, i3, i2) | 0) - (gb + 208424) >> 2;
  i1 = 0;
  i6 = i4;
  i5 = (HEAP32[gb + 208424 + (i4 << 2) >> 2] | 0) + i5 | 0;
  L10 : while (1) {
   i2 = 5;
   while (1) {
    if (i2 >>> 0 >= 47) {
     i4 = 211;
     i9 = 12;
     break;
    }
    i3 = HEAP32[gb + 208232 + (i2 << 2) >> 2] | 0;
    i4 = (i5 >>> 0) / (i3 >>> 0) | 0;
    if (i4 >>> 0 < i3 >>> 0) {
     i9 = 111;
     break L10;
    }
    if ((i5 | 0) == (Math_imul(i4, i3) | 0)) break; else i2 = i2 + 1 | 0;
   }
   L16 : do if ((i9 | 0) == 12) {
    L17 : while (1) {
     i9 = 0;
     i2 = (i5 >>> 0) / (i4 >>> 0) | 0;
     do if (i2 >>> 0 < i4 >>> 0) {
      i2 = i4;
      i3 = 1;
      i1 = i5;
     } else if ((i5 | 0) == (Math_imul(i2, i4) | 0)) {
      i2 = i4;
      i3 = 9;
     } else {
      i2 = i4 + 10 | 0;
      i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
      if (i3 >>> 0 < i2 >>> 0) {
       i3 = 1;
       i1 = i5;
      } else if ((i5 | 0) == (Math_imul(i3, i2) | 0)) i3 = 9; else {
       i2 = i4 + 12 | 0;
       i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
       if (i3 >>> 0 < i2 >>> 0) {
        i3 = 1;
        i1 = i5;
       } else if ((i5 | 0) == (Math_imul(i3, i2) | 0)) i3 = 9; else {
        i2 = i4 + 16 | 0;
        i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
        if (i3 >>> 0 < i2 >>> 0) {
         i3 = 1;
         i1 = i5;
        } else if ((i5 | 0) == (Math_imul(i3, i2) | 0)) i3 = 9; else {
         i2 = i4 + 18 | 0;
         i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
         if (i3 >>> 0 < i2 >>> 0) {
          i3 = 1;
          i1 = i5;
         } else if ((i5 | 0) == (Math_imul(i3, i2) | 0)) i3 = 9; else {
          i2 = i4 + 22 | 0;
          i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
          if (i3 >>> 0 < i2 >>> 0) {
           i3 = 1;
           i1 = i5;
          } else if ((i5 | 0) == (Math_imul(i3, i2) | 0)) i3 = 9; else {
           i2 = i4 + 28 | 0;
           i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
           if (i3 >>> 0 < i2 >>> 0) {
            i3 = 1;
            i1 = i5;
           } else {
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 30 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 36 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 40 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 42 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 46 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 52 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 58 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 60 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 66 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 70 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 72 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 78 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 82 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 88 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 96 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 100 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 102 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 106 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 108 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 112 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 120 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 126 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 130 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 136 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 138 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 142 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 148 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 150 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 156 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 162 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 166 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 168 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 172 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 178 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 180 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 186 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 190 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 192 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 196 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 198 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            if ((i5 | 0) == (Math_imul(i3, i2) | 0)) {
             i3 = 9;
             break;
            }
            i2 = i4 + 208 | 0;
            i3 = (i5 >>> 0) / (i2 >>> 0) | 0;
            if (i3 >>> 0 < i2 >>> 0) {
             i3 = 1;
             i1 = i5;
             break;
            }
            i3 = (i5 | 0) == (Math_imul(i3, i2) | 0);
            i2 = i3 ? i2 : i4 + 210 | 0;
            i3 = i3 ? 9 : 0;
           }
          }
         }
        }
       }
      }
     } while (0);
     switch (i3 & 15) {
     case 9:
      break L16;
     case 0:
      {
       i4 = i2;
       i9 = 12;
       break;
      }
     default:
      break L17;
     }
    }
    if (i3) {
     i9 = 112;
     break L10;
    }
   } while (0);
   i4 = i6 + 1 | 0;
   i3 = (i4 | 0) == 48;
   i5 = (i3 & 1) + i7 | 0;
   i4 = i3 ? 0 : i4;
   i6 = i4;
   i7 = i5;
   i5 = (HEAP32[gb + 208424 + (i4 << 2) >> 2] | 0) + (i5 * 210 | 0) | 0;
  }
  if ((i9 | 0) == 111) {
   HEAP32[i8 >> 2] = i5;
   i1 = i5;
   break;
  } else if ((i9 | 0) == 112) {
   HEAP32[i8 >> 2] = i5;
   break;
  }
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN5physx2Cm12RenderOutput13outputCapsuleEffRKNS0_8Matrix34E(i74, f63, f16, i1) {
 i74 = i74 | 0;
 f63 = Math_fround(f63);
 f16 = Math_fround(f16);
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, i73 = 0, i75 = 0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i73 = i75 + 16 | 0;
 i42 = i75;
 i48 = HEAP32[i1 >> 2] | 0;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i52 = HEAP32[i1 + 8 >> 2] | 0;
 i53 = HEAP32[i1 + 12 >> 2] | 0;
 i43 = HEAP32[i1 + 16 >> 2] | 0;
 i44 = HEAP32[i1 + 20 >> 2] | 0;
 i45 = HEAP32[i1 + 24 >> 2] | 0;
 i46 = HEAP32[i1 + 28 >> 2] | 0;
 i47 = HEAP32[i1 + 32 >> 2] | 0;
 i49 = HEAP32[i1 + 36 >> 2] | 0;
 i50 = HEAP32[i1 + 40 >> 2] | 0;
 i11 = HEAP32[i1 + 44 >> 2] | 0;
 f59 = Math_fround(-f16);
 f10 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = Math_fround(f10 * f59);
 f13 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f58 = Math_fround(f13 * f59);
 f14 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f59 = Math_fround(f14 * f59);
 f55 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f55 * Math_fround(0.0));
 f56 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(f56 * Math_fround(0.0));
 f57 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(f57 * Math_fround(0.0));
 f64 = Math_fround(f54 + f15);
 f68 = Math_fround(f58 + f17);
 f69 = Math_fround(f59 + f18);
 f65 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f60 = Math_fround(f65 * Math_fround(0.0));
 f66 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f61 = Math_fround(f66 * Math_fround(0.0));
 f67 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f62 = Math_fround(f67 * Math_fround(0.0));
 f7 = Math_fround(f64 + f60);
 f8 = Math_fround(f68 + f61);
 f9 = Math_fround(f69 + f62);
 f70 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 + f70);
 f71 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f8 + f71);
 f72 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + f72);
 i12 = i74 + 36 | 0;
 HEAP32[i12 >> 2] = i48;
 i27 = i74 + 40 | 0;
 HEAP32[i27 >> 2] = i51;
 i28 = i74 + 44 | 0;
 HEAP32[i28 >> 2] = i52;
 i29 = i74 + 48 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i74 + 52 | 0;
 HEAP32[i30 >> 2] = i53;
 i31 = i74 + 56 | 0;
 HEAP32[i31 >> 2] = i43;
 i32 = i74 + 60 | 0;
 HEAP32[i32 >> 2] = i44;
 i33 = i74 + 64 | 0;
 HEAP32[i33 >> 2] = 0;
 i34 = i74 + 68 | 0;
 HEAP32[i34 >> 2] = i45;
 i35 = i74 + 72 | 0;
 HEAP32[i35 >> 2] = i46;
 i36 = i74 + 76 | 0;
 HEAP32[i36 >> 2] = i47;
 i37 = i74 + 80 | 0;
 HEAP32[i37 >> 2] = 0;
 i38 = i74 + 84 | 0;
 HEAPF32[i38 >> 2] = f7;
 i39 = i74 + 88 | 0;
 HEAPF32[i39 >> 2] = f8;
 i40 = i74 + 92 | 0;
 HEAPF32[i40 >> 2] = f9;
 i41 = i74 + 96 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 i4 = i74 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f5 = Math_fround(3.14159274);
 i3 = 0;
 do {
  f26 = Math_fround(Math_fround(+Math_cos(+f5)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f5)) * f63);
  HEAPF32[i1 >> 2] = f26;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f5 = Math_fround(f5 + Math_fround(.0314159282));
 } while ((i3 | 0) != 100);
 f5 = Math_fround(f63 * Math_fround(1.74845553e-07));
 HEAPF32[i42 >> 2] = f5;
 HEAPF32[i42 + 4 >> 2] = f63;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 f22 = Math_fround(-f65);
 f23 = Math_fround(-f66);
 f24 = Math_fround(-f67);
 HEAP32[i12 >> 2] = i48;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i28 >> 2] = i52;
 HEAP32[i29 >> 2] = 0;
 HEAPF32[i30 >> 2] = f22;
 HEAPF32[i31 >> 2] = f23;
 HEAPF32[i32 >> 2] = f24;
 HEAP32[i33 >> 2] = -2147483648;
 HEAP32[i34 >> 2] = i53;
 HEAP32[i35 >> 2] = i43;
 HEAP32[i36 >> 2] = i44;
 HEAP32[i37 >> 2] = 0;
 HEAPF32[i38 >> 2] = f7;
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i40 >> 2] = f9;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f6 = Math_fround(3.14159274);
 i3 = 0;
 do {
  f26 = Math_fround(Math_fround(+Math_cos(+f6)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f6)) * f63);
  HEAPF32[i1 >> 2] = f26;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f6 = Math_fround(f6 + Math_fround(.0314159282));
 } while ((i3 | 0) != 100);
 HEAPF32[i42 >> 2] = f5;
 HEAPF32[i42 + 4 >> 2] = f63;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 f19 = Math_fround(-f55);
 f20 = Math_fround(-f56);
 f21 = Math_fround(-f57);
 HEAPF32[i12 >> 2] = f19;
 HEAPF32[i27 >> 2] = f20;
 HEAPF32[i28 >> 2] = f21;
 HEAP32[i29 >> 2] = -2147483648;
 HEAPF32[i30 >> 2] = f22;
 HEAPF32[i31 >> 2] = f23;
 HEAPF32[i32 >> 2] = f24;
 HEAP32[i33 >> 2] = -2147483648;
 HEAP32[i34 >> 2] = i48;
 HEAP32[i35 >> 2] = i51;
 HEAP32[i36 >> 2] = i52;
 HEAP32[i37 >> 2] = 0;
 HEAPF32[i38 >> 2] = f7;
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i40 >> 2] = f9;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f5 = Math_fround(0.0);
 i3 = 0;
 do {
  f26 = Math_fround(Math_fround(+Math_cos(+f5)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f5)) * f63);
  HEAPF32[i1 >> 2] = f26;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f5 = Math_fround(f5 + Math_fround(.0628318563));
 } while ((i3 | 0) != 100);
 HEAPF32[i42 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 4 >> 2] = f63;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 f25 = Math_fround(f10 * f16);
 f26 = Math_fround(f13 * f16);
 f13 = Math_fround(f14 * f16);
 f15 = Math_fround(f25 + f15);
 f16 = Math_fround(f26 + f17);
 f17 = Math_fround(f13 + f18);
 f7 = Math_fround(Math_fround(f15 + f60) + f70);
 f8 = Math_fround(Math_fround(f16 + f61) + f71);
 f9 = Math_fround(Math_fround(f17 + f62) + f72);
 HEAP32[i12 >> 2] = i48;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i28 >> 2] = i52;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 >> 2] = i53;
 HEAP32[i31 >> 2] = i43;
 HEAP32[i32 >> 2] = i44;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i34 >> 2] = i45;
 HEAP32[i35 >> 2] = i46;
 HEAP32[i36 >> 2] = i47;
 HEAP32[i37 >> 2] = 0;
 HEAPF32[i38 >> 2] = f7;
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i40 >> 2] = f9;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f5 = Math_fround(0.0);
 i3 = 0;
 do {
  f18 = Math_fround(Math_fround(+Math_cos(+f5)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f5)) * f63);
  HEAPF32[i1 >> 2] = f18;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f5 = Math_fround(f5 + Math_fround(.0314159282));
 } while ((i3 | 0) != 100);
 f5 = Math_fround(f63 * Math_fround(-8.74227765e-08));
 f14 = Math_fround(-f63);
 HEAPF32[i42 >> 2] = f5;
 HEAPF32[i42 + 4 >> 2] = f14;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 HEAP32[i12 >> 2] = i48;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i28 >> 2] = i52;
 HEAP32[i29 >> 2] = 0;
 HEAPF32[i30 >> 2] = f22;
 HEAPF32[i31 >> 2] = f23;
 HEAPF32[i32 >> 2] = f24;
 HEAP32[i33 >> 2] = -2147483648;
 HEAP32[i34 >> 2] = i53;
 HEAP32[i35 >> 2] = i43;
 HEAP32[i36 >> 2] = i44;
 HEAP32[i37 >> 2] = 0;
 HEAPF32[i38 >> 2] = f7;
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i40 >> 2] = f9;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f6 = Math_fround(0.0);
 i3 = 0;
 do {
  f18 = Math_fround(Math_fround(+Math_cos(+f6)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f6)) * f63);
  HEAPF32[i1 >> 2] = f18;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f6 = Math_fround(f6 + Math_fround(.0314159282));
 } while ((i3 | 0) != 100);
 HEAPF32[i42 >> 2] = f5;
 HEAPF32[i42 + 4 >> 2] = f14;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 HEAPF32[i12 >> 2] = f19;
 HEAPF32[i27 >> 2] = f20;
 HEAPF32[i28 >> 2] = f21;
 HEAP32[i29 >> 2] = -2147483648;
 HEAPF32[i30 >> 2] = f22;
 HEAPF32[i31 >> 2] = f23;
 HEAPF32[i32 >> 2] = f24;
 HEAP32[i33 >> 2] = -2147483648;
 HEAP32[i34 >> 2] = i48;
 HEAP32[i35 >> 2] = i51;
 HEAP32[i36 >> 2] = i52;
 HEAP32[i37 >> 2] = 0;
 HEAPF32[i38 >> 2] = f7;
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i40 >> 2] = f9;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i74 >> 2] = 2;
 HEAP32[i4 >> 2] = 0;
 i1 = i73 + 4 | 0;
 i2 = i73 + 8 | 0;
 f5 = Math_fround(0.0);
 i3 = 0;
 do {
  f24 = Math_fround(Math_fround(+Math_cos(+f5)) * f63);
  HEAPF32[i73 >> 2] = Math_fround(Math_fround(+Math_sin(+f5)) * f63);
  HEAPF32[i1 >> 2] = f24;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i73) | 0;
  i3 = i3 + 1 | 0;
  f5 = Math_fround(f5 + Math_fround(.0628318563));
 } while ((i3 | 0) != 100);
 HEAPF32[i42 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 4 >> 2] = f63;
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i74, i42) | 0;
 HEAP32[i12 >> 2] = i48;
 HEAP32[i27 >> 2] = i51;
 HEAP32[i28 >> 2] = i52;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 >> 2] = i53;
 HEAP32[i31 >> 2] = i43;
 HEAP32[i32 >> 2] = i44;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i34 >> 2] = i45;
 HEAP32[i35 >> 2] = i46;
 HEAP32[i36 >> 2] = i47;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i38 >> 2] = i49;
 HEAP32[i39 >> 2] = i50;
 HEAP32[i40 >> 2] = i11;
 HEAP32[i41 >> 2] = 0;
 f8 = Math_fround(f55 * f63);
 f9 = Math_fround(f56 * f63);
 f10 = Math_fround(f57 * f63);
 f5 = Math_fround(Math_fround(Math_fround(f54 + f8) + f60) + f70);
 f6 = Math_fround(Math_fround(Math_fround(f58 + f9) + f61) + f71);
 f7 = Math_fround(Math_fround(Math_fround(f59 + f10) + f62) + f72);
 f8 = Math_fround(Math_fround(Math_fround(f25 + f8) + f60) + f70);
 f9 = Math_fround(Math_fround(Math_fround(f26 + f9) + f61) + f71);
 f10 = Math_fround(Math_fround(Math_fround(f13 + f10) + f62) + f72);
 i11 = i74 + 100 | 0;
 i53 = HEAP32[i11 >> 2] | 0;
 i1 = i53 + 16 | 0;
 i12 = i74 + 4 | 0;
 HEAPF32[i73 >> 2] = f5;
 HEAPF32[i73 + 4 >> 2] = f6;
 HEAPF32[i73 + 8 >> 2] = f7;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i73 + 12 >> 2] = i2;
 HEAPF32[i73 + 16 >> 2] = f8;
 HEAPF32[i73 + 20 >> 2] = f9;
 HEAPF32[i73 + 24 >> 2] = f10;
 HEAP32[i73 + 28 >> 2] = i2;
 i3 = i53 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i53 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  i53 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i53 + (i4 << 5) >> 2] = f5;
  HEAPF32[i53 + (i4 << 5) + 4 >> 2] = f6;
  HEAPF32[i53 + (i4 << 5) + 8 >> 2] = f7;
  HEAP32[i53 + (i4 << 5) + 12 >> 2] = i2;
  HEAPF32[i53 + (i4 << 5) + 16 >> 2] = f8;
  HEAPF32[i53 + (i4 << 5) + 20 >> 2] = f9;
  HEAPF32[i53 + (i4 << 5) + 24 >> 2] = f10;
  HEAP32[i53 + (i4 << 5) + 28 >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i73) | 0;
 f7 = Math_fround(f55 * f14);
 f6 = Math_fround(f56 * f14);
 f5 = Math_fround(f57 * f14);
 f10 = Math_fround(Math_fround(Math_fround(f54 + f7) + f60) + f70);
 f9 = Math_fround(Math_fround(Math_fround(f58 + f6) + f61) + f71);
 f8 = Math_fround(Math_fround(Math_fround(f59 + f5) + f62) + f72);
 f7 = Math_fround(Math_fround(Math_fround(f25 + f7) + f60) + f70);
 f6 = Math_fround(Math_fround(Math_fround(f26 + f6) + f61) + f71);
 f5 = Math_fround(Math_fround(Math_fround(f13 + f5) + f62) + f72);
 i53 = HEAP32[i11 >> 2] | 0;
 i1 = i53 + 16 | 0;
 HEAPF32[i73 >> 2] = f10;
 HEAPF32[i73 + 4 >> 2] = f9;
 HEAPF32[i73 + 8 >> 2] = f8;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i73 + 12 >> 2] = i2;
 HEAPF32[i73 + 16 >> 2] = f7;
 HEAPF32[i73 + 20 >> 2] = f6;
 HEAPF32[i73 + 24 >> 2] = f5;
 HEAP32[i73 + 28 >> 2] = i2;
 i3 = i53 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i53 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  i53 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i53 + (i4 << 5) >> 2] = f10;
  HEAPF32[i53 + (i4 << 5) + 4 >> 2] = f9;
  HEAPF32[i53 + (i4 << 5) + 8 >> 2] = f8;
  HEAP32[i53 + (i4 << 5) + 12 >> 2] = i2;
  HEAPF32[i53 + (i4 << 5) + 16 >> 2] = f7;
  HEAPF32[i53 + (i4 << 5) + 20 >> 2] = f6;
  HEAPF32[i53 + (i4 << 5) + 24 >> 2] = f5;
  HEAP32[i53 + (i4 << 5) + 28 >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i73) | 0;
 f8 = Math_fround(f65 * f63);
 f9 = Math_fround(f66 * f63);
 f10 = Math_fround(f67 * f63);
 f5 = Math_fround(Math_fround(f64 + f8) + f70);
 f6 = Math_fround(Math_fround(f68 + f9) + f71);
 f7 = Math_fround(Math_fround(f69 + f10) + f72);
 f8 = Math_fround(Math_fround(f15 + f8) + f70);
 f9 = Math_fround(Math_fround(f16 + f9) + f71);
 f10 = Math_fround(Math_fround(f17 + f10) + f72);
 i53 = HEAP32[i11 >> 2] | 0;
 i1 = i53 + 16 | 0;
 HEAPF32[i73 >> 2] = f5;
 HEAPF32[i73 + 4 >> 2] = f6;
 HEAPF32[i73 + 8 >> 2] = f7;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i73 + 12 >> 2] = i2;
 HEAPF32[i73 + 16 >> 2] = f8;
 HEAPF32[i73 + 20 >> 2] = f9;
 HEAPF32[i73 + 24 >> 2] = f10;
 HEAP32[i73 + 28 >> 2] = i2;
 i3 = i53 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i53 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  i53 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i53 + (i4 << 5) >> 2] = f5;
  HEAPF32[i53 + (i4 << 5) + 4 >> 2] = f6;
  HEAPF32[i53 + (i4 << 5) + 8 >> 2] = f7;
  HEAP32[i53 + (i4 << 5) + 12 >> 2] = i2;
  HEAPF32[i53 + (i4 << 5) + 16 >> 2] = f8;
  HEAPF32[i53 + (i4 << 5) + 20 >> 2] = f9;
  HEAPF32[i53 + (i4 << 5) + 24 >> 2] = f10;
  HEAP32[i53 + (i4 << 5) + 28 >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i73) | 0;
 f7 = Math_fround(f65 * f14);
 f6 = Math_fround(f66 * f14);
 f5 = Math_fround(f67 * f14);
 f10 = Math_fround(Math_fround(f64 + f7) + f70);
 f9 = Math_fround(Math_fround(f68 + f6) + f71);
 f8 = Math_fround(Math_fround(f69 + f5) + f72);
 f7 = Math_fround(Math_fround(f15 + f7) + f70);
 f6 = Math_fround(Math_fround(f16 + f6) + f71);
 f5 = Math_fround(Math_fround(f17 + f5) + f72);
 i53 = HEAP32[i11 >> 2] | 0;
 i4 = i53 + 16 | 0;
 HEAPF32[i73 >> 2] = f10;
 HEAPF32[i73 + 4 >> 2] = f9;
 HEAPF32[i73 + 8 >> 2] = f8;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i73 + 12 >> 2] = i1;
 HEAPF32[i73 + 16 >> 2] = f7;
 HEAPF32[i73 + 20 >> 2] = f6;
 HEAPF32[i73 + 24 >> 2] = f5;
 HEAP32[i73 + 28 >> 2] = i1;
 i2 = i53 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i53 + 24 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i73 = HEAP32[i4 >> 2] | 0;
  HEAPF32[i73 + (i3 << 5) >> 2] = f10;
  HEAPF32[i73 + (i3 << 5) + 4 >> 2] = f9;
  HEAPF32[i73 + (i3 << 5) + 8 >> 2] = f8;
  HEAP32[i73 + (i3 << 5) + 12 >> 2] = i1;
  HEAPF32[i73 + (i3 << 5) + 16 >> 2] = f7;
  HEAPF32[i73 + (i3 << 5) + 20 >> 2] = f6;
  HEAPF32[i73 + (i3 << 5) + 24 >> 2] = f5;
  HEAP32[i73 + (i3 << 5) + 28 >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  STACKTOP = i75;
  return i74 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i4, i73) | 0;
  STACKTOP = i75;
  return i74 | 0;
 }
 return 0;
}

function __ZN13BuildSettings8TransferI14SafeBinaryReadEEvRT_(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 24 | 0;
 i10 = i12;
 i6 = i12 + 28 | 0;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i8, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i2 = i8 + 28 | 0;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443262 | 0, i9, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443269 | 0, i9, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443286 | 0, i9, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i8 + 108 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443303 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 111 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443317 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443336 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i13 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 113 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443355 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 114 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443374 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 115 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443385 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443405 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 117 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443416 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 118 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443431 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 109 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443452 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 110 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443471 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 119 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443493 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  L159 : do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i13 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L159;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443506 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  L171 : do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i13 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L171;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 121 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443524 | 0, i4, i10, 0) | 0;
 if (i1 | 0) {
  L183 : do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i13 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L183;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i11, 1) | 0) HEAP8[i5 >> 0] = 1;
 i1 = i8 + 140 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443544 | 0, i3, i10, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i1, 1); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 124 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443554 | 0, i3, i10, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i4, 1); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN12UnityVersionC2EPKc(i6, i1);
 __ZN12UnityVersionC2EPKc(i10, gb + 443566 | 0);
 if (__ZNK12UnityVersionltERKS_(i6, i10) | 0) {
  __Z6FormatPKcz(i10, gb + 443574 | 0, i7);
  __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE(i10, 0, gb + 443603 | 0, 203, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  _exit(1);
 }
 i2 = i8 + 76 | 0;
 i3 = HEAP32[gb + 37052 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443674 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS5_EENS7_9allocatorINS7_4pairIS5_S6_EEEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(HEAP32[i8 + 80 >> 2] | 0, HEAP32[i8 + 84 >> 2] | 0, i10);
 i2 = i8 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443693 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128S2_NSt3__24lessIS2_EENS3_9allocatorINS3_4pairIS2_S2_EEEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 443706 | 0, i9, i10, 1) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function _decode_mcu(i29, i30) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i34 + 16 | 0;
 i32 = i34;
 i5 = i29 + 408 | 0;
 i33 = HEAP32[i5 >> 2] | 0;
 i3 = i29 + 252 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 1; else {
  i4 = i33 + 36 | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i27 = i33 + 16 | 0;
   i28 = HEAP32[i29 + 404 >> 2] | 0;
   i25 = i28 + 20 | 0;
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + ((HEAP32[i27 >> 2] | 0) / 8 | 0);
   HEAP32[i27 >> 2] = 0;
   if (!((mftCall_ii(HEAP32[i28 + 8 >> 2] | 0, i29 | 0) | 0) << 24 >> 24)) {
    i33 = 0;
    STACKTOP = i34;
    return i33 | 0;
   }
   i2 = i29 + 292 | 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i33 + 20 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   if (!(HEAP32[i29 + 380 >> 2] | 0)) {
    HEAP8[i33 + 8 >> 0] = 0;
    i1 = 0;
   } else i1 = 0;
  } else i1 = 0;
 }
 i28 = i29 + 24 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i22 = i3 + 4 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 i27 = i29 + 320 | 0;
 i24 = HEAP32[i27 >> 2] | 0;
 if (i23 >>> 0 < i24 << 7 >>> 0) i26 = 10; else if (HEAP32[i29 + 380 >> 2] | 0) i26 = 10;
 if ((i26 | 0) == 10) i1 = 0;
 L18 : do if (!(HEAP8[i33 + 8 >> 0] | 0)) {
  i25 = HEAP32[i5 >> 2] | 0;
  do if (!i1) {
   i4 = HEAP32[i25 + 16 >> 2] | 0;
   i5 = HEAP32[i25 + 12 >> 2] | 0;
  } else {
   i17 = HEAP32[i3 >> 2] | 0;
   i18 = i25 + 12 | 0;
   i5 = HEAP32[i18 >> 2] | 0;
   i19 = i25 + 16 | 0;
   i4 = HEAP32[i19 >> 2] | 0;
   i20 = i25 + 20 | 0;
   HEAP32[i31 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i31 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i21 = i29 + 380 | 0;
   if ((i24 | 0) > 0) {
    i6 = i5;
    i2 = i4;
    i1 = i17;
    i16 = 0;
    do {
     i13 = HEAP32[i30 + (i16 << 2) >> 2] | 0;
     i11 = HEAP32[i25 + 72 + (i16 << 2) >> 2] | 0;
     i15 = HEAP32[i25 + 112 + (i16 << 2) >> 2] | 0;
     if ((i2 | 0) < 16) {
      i10 = i1 + 1 | 0;
      i14 = HEAP8[i1 >> 0] | 0;
      i8 = HEAP8[i10 >> 0] | 0;
      i9 = i8 & 255;
      i6 = i6 << 8;
      i7 = i14 & 255 | i6;
      if (i14 << 24 >> 24 == -1) if (!(i8 << 24 >> 24)) {
       i6 = i7;
       i1 = i1 + 2 | 0;
      } else HEAP32[i21 >> 2] = i9; else {
       i6 = i7;
       i1 = i10;
      }
      i10 = i1 + 1 | 0;
      i14 = HEAP8[i1 >> 0] | 0;
      i7 = HEAP8[i10 >> 0] | 0;
      i8 = i7 & 255;
      i6 = i6 << 8;
      i9 = i14 & 255 | i6;
      i2 = i2 + 16 | 0;
      if (i14 << 24 >> 24 == -1) if (!(i7 << 24 >> 24)) {
       i6 = i9;
       i1 = i1 + 2 | 0;
      } else HEAP32[i21 >> 2] = i8; else {
       i6 = i9;
       i1 = i10;
      }
     }
     i7 = HEAP32[i11 + 148 + ((i6 >> i2 + -8 & 255) << 2) >> 2] | 0;
     i8 = i7 >> 8;
     i2 = i2 - i8 | 0;
     i7 = i7 & 255;
     if ((i8 | 0) > 8) {
      i7 = i6 >> i2 & (1 << i8) + -1;
      if ((i7 | 0) > (HEAP32[i11 + (i8 << 2) >> 2] | 0)) do {
       i2 = i2 + -1 | 0;
       i7 = i6 >>> i2 & 1 | i7 << 1;
       i8 = i8 + 1 | 0;
      } while ((i7 | 0) > (HEAP32[i11 + (i8 << 2) >> 2] | 0));
      i7 = HEAPU8[((HEAP32[i11 + 72 + (i8 << 2) >> 2] | 0) + i7 & 255) + ((HEAP32[i11 + 144 >> 2] | 0) + 17) >> 0] | 0;
     }
     if (!i7) i7 = 0; else {
      if ((i2 | 0) < 16) {
       i11 = i1 + 1 | 0;
       i14 = HEAP8[i1 >> 0] | 0;
       i9 = HEAP8[i11 >> 0] | 0;
       i10 = i9 & 255;
       i6 = i6 << 8;
       i8 = i14 & 255 | i6;
       if (i14 << 24 >> 24 == -1) if (!(i9 << 24 >> 24)) {
        i6 = i8;
        i1 = i1 + 2 | 0;
       } else HEAP32[i21 >> 2] = i10; else {
        i6 = i8;
        i1 = i11;
       }
       i11 = i1 + 1 | 0;
       i14 = HEAP8[i1 >> 0] | 0;
       i8 = HEAP8[i11 >> 0] | 0;
       i9 = i8 & 255;
       i6 = i6 << 8;
       i10 = i14 & 255 | i6;
       i2 = i2 + 16 | 0;
       if (i14 << 24 >> 24 == -1) if (!(i8 << 24 >> 24)) {
        i6 = i10;
        i1 = i1 + 2 | 0;
       } else HEAP32[i21 >> 2] = i9; else {
        i6 = i10;
        i1 = i11;
       }
      }
      i2 = i2 - i7 | 0;
      i14 = i6 >> i2 & (1 << i7) + -1;
      i7 = (i14 - (1 << i7 + -1) >> 31 & (-1 << i7) + 1) + i14 | 0;
     }
     if (HEAP8[i25 + 152 + i16 >> 0] | 0) {
      i12 = i31 + (HEAP32[i29 + 324 + (i16 << 2) >> 2] << 2) | 0;
      i14 = (HEAP32[i12 >> 2] | 0) + i7 | 0;
      HEAP32[i12 >> 2] = i14;
      HEAP16[i13 >> 1] = i14;
     }
     i14 = i15 + 144 | 0;
     L57 : do if (!(HEAP8[i25 + 162 + i16 >> 0] | 0)) {
      i13 = 1;
      do {
       do if ((i2 | 0) < 16) {
        i10 = i1 + 1 | 0;
        i12 = HEAP8[i1 >> 0] | 0;
        i8 = HEAP8[i10 >> 0] | 0;
        i9 = i8 & 255;
        i6 = i6 << 8;
        i7 = i12 & 255 | i6;
        do if (i12 << 24 >> 24 == -1) {
         if (!(i8 << 24 >> 24)) {
          i6 = i7;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i9;
        } else {
         i6 = i7;
         i1 = i10;
        } while (0);
        i10 = i1 + 1 | 0;
        i12 = HEAP8[i1 >> 0] | 0;
        i7 = HEAP8[i10 >> 0] | 0;
        i8 = i7 & 255;
        i6 = i6 << 8;
        i9 = i12 & 255 | i6;
        i2 = i2 + 16 | 0;
        if (i12 << 24 >> 24 == -1) {
         if (!(i7 << 24 >> 24)) {
          i6 = i9;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i8;
        } else {
         i6 = i9;
         i1 = i10;
        }
       } while (0);
       i8 = HEAP32[i15 + 148 + ((i6 >> i2 + -8 & 255) << 2) >> 2] | 0;
       i9 = i8 >> 8;
       i2 = i2 - i9 | 0;
       i8 = i8 & 255;
       if ((i9 | 0) > 8) {
        i7 = i6 >> i2 & (1 << i9) + -1;
        if ((i7 | 0) > (HEAP32[i15 + (i9 << 2) >> 2] | 0)) {
         i8 = i9;
         do {
          i2 = i2 + -1 | 0;
          i7 = i6 >>> i2 & 1 | i7 << 1;
          i8 = i8 + 1 | 0;
         } while ((i7 | 0) > (HEAP32[i15 + (i8 << 2) >> 2] | 0));
        } else i8 = i9;
        i8 = HEAPU8[((HEAP32[i15 + 72 + (i8 << 2) >> 2] | 0) + i7 & 255) + ((HEAP32[i14 >> 2] | 0) + 17) >> 0] | 0;
       }
       i7 = i8 >>> 4;
       i12 = i8 & 15;
       if (!i12) if ((i7 | 0) == 15) i7 = 15; else break L57; else {
        do if ((i2 | 0) < 16) {
         i11 = i1 + 1 | 0;
         i35 = HEAP8[i1 >> 0] | 0;
         i9 = HEAP8[i11 >> 0] | 0;
         i10 = i9 & 255;
         i6 = i6 << 8;
         i8 = i35 & 255 | i6;
         do if (i35 << 24 >> 24 == -1) {
          if (!(i9 << 24 >> 24)) {
           i6 = i8;
           i1 = i1 + 2 | 0;
           break;
          }
          HEAP32[i21 >> 2] = i10;
         } else {
          i6 = i8;
          i1 = i11;
         } while (0);
         i10 = i1 + 1 | 0;
         i35 = HEAP8[i1 >> 0] | 0;
         i8 = HEAP8[i10 >> 0] | 0;
         i6 = i6 << 8;
         i9 = i35 & 255 | i6;
         i2 = i2 + 16 | 0;
         if (i35 << 24 >> 24 != -1) {
          i6 = i9;
          i1 = i10;
          break;
         }
         if (!(i8 << 24 >> 24)) {
          i6 = i9;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i8 & 255;
        } while (0);
        i2 = i2 - i12 | 0;
       }
       i13 = i13 + 1 + i7 | 0;
      } while ((i13 | 0) < 64);
     } else {
      i11 = 1;
      do {
       do if ((i2 | 0) < 16) {
        i10 = i1 + 1 | 0;
        i35 = HEAP8[i1 >> 0] | 0;
        i8 = HEAP8[i10 >> 0] | 0;
        i9 = i8 & 255;
        i6 = i6 << 8;
        i7 = i35 & 255 | i6;
        do if (i35 << 24 >> 24 == -1) {
         if (!(i8 << 24 >> 24)) {
          i6 = i7;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i9;
        } else {
         i6 = i7;
         i1 = i10;
        } while (0);
        i10 = i1 + 1 | 0;
        i35 = HEAP8[i1 >> 0] | 0;
        i8 = HEAP8[i10 >> 0] | 0;
        i9 = i8 & 255;
        i6 = i6 << 8;
        i7 = i35 & 255 | i6;
        i2 = i2 + 16 | 0;
        if (i35 << 24 >> 24 == -1) {
         if (!(i8 << 24 >> 24)) {
          i6 = i7;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i9;
        } else {
         i6 = i7;
         i1 = i10;
        }
       } while (0);
       i7 = HEAP32[i15 + 148 + ((i6 >> i2 + -8 & 255) << 2) >> 2] | 0;
       i9 = i7 >> 8;
       i2 = i2 - i9 | 0;
       i7 = i7 & 255;
       if ((i9 | 0) > 8) {
        i8 = i6 >> i2 & (1 << i9) + -1;
        if ((i8 | 0) > (HEAP32[i15 + (i9 << 2) >> 2] | 0)) {
         i7 = i9;
         do {
          i2 = i2 + -1 | 0;
          i8 = i6 >>> i2 & 1 | i8 << 1;
          i7 = i7 + 1 | 0;
         } while ((i8 | 0) > (HEAP32[i15 + (i7 << 2) >> 2] | 0));
        } else i7 = i9;
        i7 = HEAPU8[((HEAP32[i15 + 72 + (i7 << 2) >> 2] | 0) + i8 & 255) + ((HEAP32[i14 >> 2] | 0) + 17) >> 0] | 0;
       }
       i8 = i7 >>> 4;
       i12 = i7 & 15;
       if (!i12) {
        if ((i8 | 0) != 15) break L57;
        i7 = i11 + 15 | 0;
       } else {
        i7 = i8 + i11 | 0;
        do if ((i2 | 0) < 16) {
         i11 = i1 + 1 | 0;
         i35 = HEAP8[i1 >> 0] | 0;
         i9 = HEAP8[i11 >> 0] | 0;
         i10 = i9 & 255;
         i6 = i6 << 8;
         i8 = i35 & 255 | i6;
         do if (i35 << 24 >> 24 == -1) {
          if (!(i9 << 24 >> 24)) {
           i6 = i8;
           i1 = i1 + 2 | 0;
           break;
          }
          HEAP32[i21 >> 2] = i10;
         } else {
          i6 = i8;
          i1 = i11;
         } while (0);
         i10 = i1 + 1 | 0;
         i35 = HEAP8[i1 >> 0] | 0;
         i8 = HEAP8[i10 >> 0] | 0;
         i6 = i6 << 8;
         i9 = i35 & 255 | i6;
         i2 = i2 + 16 | 0;
         if (i35 << 24 >> 24 != -1) {
          i6 = i9;
          i1 = i10;
          break;
         }
         if (!(i8 << 24 >> 24)) {
          i6 = i9;
          i1 = i1 + 2 | 0;
          break;
         }
         HEAP32[i21 >> 2] = i8 & 255;
        } while (0);
        i2 = i2 - i12 | 0;
        i35 = i6 >> i2 & (1 << i12) + -1;
        HEAP16[i13 + (HEAP32[gb + 15416 + (i7 << 2) >> 2] << 1) >> 1] = (i35 - (1 << i12 + -1) >> 31 & (-1 << i12) + 1) + i35;
       }
       i11 = i7 + 1 | 0;
      } while ((i11 | 0) < 64);
     } while (0);
     i16 = i16 + 1 | 0;
    } while ((i16 | 0) != (i24 | 0));
   } else {
    i6 = i5;
    i2 = i4;
    i1 = i17;
   }
   if (!(HEAP32[i21 >> 2] | 0)) {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i22 >> 2] = i23 + i17 - i1;
    HEAP32[i18 >> 2] = i6;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i20 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
    break L18;
   } else {
    HEAP32[i21 >> 2] = 0;
    break;
   }
  } while (0);
  HEAP32[i31 + 16 >> 2] = i29;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i31 >> 2] = i2;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i12 = i31 + 4 | 0;
  HEAP32[i12 >> 2] = i1;
  i13 = i25 + 12 | 0;
  i14 = i25 + 16 | 0;
  i15 = i25 + 20 | 0;
  HEAP32[i32 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  do if ((i24 | 0) > 0) {
   i10 = i31 + 8 | 0;
   i11 = i31 + 12 | 0;
   i9 = 0;
   L129 : while (1) {
    i7 = HEAP32[i30 + (i9 << 2) >> 2] | 0;
    i3 = HEAP32[i25 + 72 + (i9 << 2) >> 2] | 0;
    i8 = HEAP32[i25 + 112 + (i9 << 2) >> 2] | 0;
    if ((i4 | 0) < 8) {
     if (!((_jpeg_fill_bit_buffer(i31, i5, i4, 0) | 0) << 24 >> 24)) break;
     i5 = HEAP32[i10 >> 2] | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     if ((i4 | 0) < 8) {
      i2 = 1;
      i26 = 94;
     } else i26 = 92;
    } else i26 = 92;
    if ((i26 | 0) == 92) {
     i26 = 0;
     i1 = HEAP32[i3 + 148 + ((i5 >> i4 + -8 & 255) << 2) >> 2] | 0;
     i2 = i1 >> 8;
     if ((i2 | 0) < 9) {
      i1 = i1 & 255;
      i4 = i4 - i2 | 0;
     } else i26 = 94;
    }
    if ((i26 | 0) == 94) {
     i26 = 0;
     i1 = _jpeg_huff_decode(i31, i5, i4, i3, i2) | 0;
     if ((i1 | 0) < 0) break;
     i5 = HEAP32[i10 >> 2] | 0;
     i4 = HEAP32[i11 >> 2] | 0;
    }
    if (!i1) i1 = 0; else {
     if ((i4 | 0) < (i1 | 0)) {
      if (!((_jpeg_fill_bit_buffer(i31, i5, i4, i1) | 0) << 24 >> 24)) break;
      i5 = HEAP32[i10 >> 2] | 0;
      i4 = HEAP32[i11 >> 2] | 0;
     }
     i4 = i4 - i1 | 0;
     i35 = i5 >> i4 & (1 << i1) + -1;
     i1 = (i35 - (1 << i1 + -1) >> 31 & (-1 << i1) + 1) + i35 | 0;
    }
    if (HEAP8[i25 + 152 + i9 >> 0] | 0) {
     i24 = i32 + (HEAP32[i29 + 324 + (i9 << 2) >> 2] << 2) | 0;
     i35 = (HEAP32[i24 >> 2] | 0) + i1 | 0;
     HEAP32[i24 >> 2] = i35;
     HEAP16[i7 >> 1] = i35;
    }
    L151 : do if (!(HEAP8[i25 + 162 + i9 >> 0] | 0)) {
     i3 = 1;
     do {
      if ((i4 | 0) < 8) {
       if (!((_jpeg_fill_bit_buffer(i31, i5, i4, 0) | 0) << 24 >> 24)) break L129;
       i5 = HEAP32[i10 >> 2] | 0;
       i4 = HEAP32[i11 >> 2] | 0;
       if ((i4 | 0) < 8) {
        i2 = 1;
        i26 = 124;
       } else i26 = 122;
      } else i26 = 122;
      if ((i26 | 0) == 122) {
       i26 = 0;
       i1 = HEAP32[i8 + 148 + ((i5 >> i4 + -8 & 255) << 2) >> 2] | 0;
       i2 = i1 >> 8;
       if ((i2 | 0) < 9) {
        i1 = i1 & 255;
        i4 = i4 - i2 | 0;
       } else i26 = 124;
      }
      if ((i26 | 0) == 124) {
       i26 = 0;
       i1 = _jpeg_huff_decode(i31, i5, i4, i8, i2) | 0;
       if ((i1 | 0) < 0) break L129;
       i5 = HEAP32[i10 >> 2] | 0;
       i4 = HEAP32[i11 >> 2] | 0;
      }
      i2 = i1 >> 4;
      i1 = i1 & 15;
      if (!i1) if ((i2 | 0) == 15) i1 = 15; else break L151; else {
       if ((i4 | 0) < (i1 | 0)) {
        if (!((_jpeg_fill_bit_buffer(i31, i5, i4, i1) | 0) << 24 >> 24)) break L129;
        i5 = HEAP32[i10 >> 2] | 0;
        i4 = HEAP32[i11 >> 2] | 0;
       }
       i4 = i4 - i1 | 0;
       i1 = i2;
      }
      i3 = i3 + 1 + i1 | 0;
     } while ((i3 | 0) < 64);
    } else {
     i6 = 1;
     do {
      if ((i4 | 0) < 8) {
       if (!((_jpeg_fill_bit_buffer(i31, i5, i4, 0) | 0) << 24 >> 24)) break L129;
       i5 = HEAP32[i10 >> 2] | 0;
       i4 = HEAP32[i11 >> 2] | 0;
       if ((i4 | 0) < 8) {
        i1 = 1;
        i26 = 109;
       } else i26 = 107;
      } else i26 = 107;
      if ((i26 | 0) == 107) {
       i26 = 0;
       i2 = HEAP32[i8 + 148 + ((i5 >> i4 + -8 & 255) << 2) >> 2] | 0;
       i1 = i2 >> 8;
       if ((i1 | 0) < 9) {
        i4 = i4 - i1 | 0;
        i1 = i2 & 255;
       } else i26 = 109;
      }
      if ((i26 | 0) == 109) {
       i26 = 0;
       i1 = _jpeg_huff_decode(i31, i5, i4, i8, i1) | 0;
       if ((i1 | 0) < 0) break L129;
       i5 = HEAP32[i10 >> 2] | 0;
       i4 = HEAP32[i11 >> 2] | 0;
      }
      i2 = i1 >> 4;
      i3 = i1 & 15;
      if (!i3) {
       if ((i2 | 0) != 15) break L151;
       i1 = i6 + 15 | 0;
      } else {
       i1 = i2 + i6 | 0;
       if ((i4 | 0) < (i3 | 0)) {
        if (!((_jpeg_fill_bit_buffer(i31, i5, i4, i3) | 0) << 24 >> 24)) break L129;
        i5 = HEAP32[i10 >> 2] | 0;
        i4 = HEAP32[i11 >> 2] | 0;
       }
       i4 = i4 - i3 | 0;
       i35 = i5 >> i4 & (1 << i3) + -1;
       HEAP16[i7 + (HEAP32[gb + 15416 + (i1 << 2) >> 2] << 1) >> 1] = (i35 - (1 << i3 + -1) >> 31 & (-1 << i3) + 1) + i35;
      }
      i6 = i1 + 1 | 0;
     } while ((i6 | 0) < 64);
    } while (0);
    i9 = i9 + 1 | 0;
    if ((i9 | 0) >= (HEAP32[i27 >> 2] | 0)) {
     i26 = 134;
     break;
    }
   }
   if ((i26 | 0) == 134) {
    i3 = HEAP32[i28 >> 2] | 0;
    i2 = HEAP32[i31 >> 2] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    break;
   }
   i35 = 0;
   STACKTOP = i34;
   return i35 | 0;
  } while (0);
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 } while (0);
 i35 = i33 + 36 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + -1;
 i35 = 1;
 STACKTOP = i34;
 return i35 | 0;
}

function __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i59, i60, i1, i61, i62, i56, i64, i45, i47, i39, i63) {
 i59 = i59 | 0;
 i60 = i60 | 0;
 i1 = i1 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 i56 = i56 | 0;
 i64 = i64 | 0;
 i45 = i45 | 0;
 i47 = i47 | 0;
 i39 = i39 | 0;
 i63 = i63 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f57 = f0, f58 = f0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i65 + 492 | 0;
 i36 = i65 + 480 | 0;
 i55 = i65 + 160 | 0;
 i54 = i65 + 304 | 0;
 i52 = i65 + 240 | 0;
 i53 = i65 + 176 | 0;
 i44 = i65 + 464 | 0;
 i46 = i65 + 448 | 0;
 i35 = i65 + 144 | 0;
 i34 = i65 + 440 | 0;
 i16 = i65 + 128 | 0;
 i17 = i65 + 112 | 0;
 i18 = i65 + 428 | 0;
 i19 = i65 + 96 | 0;
 i32 = i65 + 80 | 0;
 i48 = i65 + 64 | 0;
 i51 = i65 + 48 | 0;
 i49 = i65 + 416 | 0;
 i50 = i65 + 404 | 0;
 i33 = i65 + 32 | 0;
 i31 = i65 + 392 | 0;
 i40 = i65 + 16 | 0;
 i43 = i65;
 i42 = i65 + 380 | 0;
 i41 = i65 + 368 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f57 = Math_fround(HEAPF32[i59 + 16 >> 2]);
 f58 = Math_fround(HEAPF32[i60 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i59 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i60 + 32 >> 2]);
 f9 = Math_fround((f9 > f3 ? f3 : f9) * Math_fround(.100000001));
 f9 = Math_fround(f9 * f9);
 f3 = Math_fround(f57 + f58);
 i28 = i35 + 4 | 0;
 i29 = i35 + 8 | 0;
 i30 = i35 + 12 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 HEAP32[i34 >> 2] = 0;
 if (!(HEAP8[i39 >> 0] | 0)) {
  f26 = Math_fround(HEAPF32[i59 >> 2]);
  f4 = Math_fround(HEAPF32[i59 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i59 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i60 >> 2]);
  f6 = Math_fround(HEAPF32[i60 + 4 >> 2]);
  f5 = Math_fround(f26 - f5);
  f6 = Math_fround(f4 - f6);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i60 + 8 >> 2]));
  i27 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i27 ? f5 : Math_fround(1.0);
  f6 = i27 ? f6 : Math_fround(0.0);
  f7 = i27 ? f7 : Math_fround(0.0);
  HEAPF32[i55 >> 2] = f5;
  HEAPF32[i55 + 4 >> 2] = f6;
  HEAPF32[i55 + 8 >> 2] = f7;
  HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i19 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  i27 = i55;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i38 = 6;
 } else {
  i1 = i59 + 96 | 0;
  i2 = i60 + 16 | 0;
  i11 = i16 + 4 | 0;
  i13 = i16 + 8 | 0;
  i14 = i16 + 12 | 0;
  i15 = 0;
  do {
   i24 = HEAPU8[i45 + i15 >> 0] | 0;
   HEAP32[i44 + (i15 << 2) >> 2] = i24;
   i25 = HEAPU8[i47 + i15 >> 0] | 0;
   HEAP32[i46 + (i15 << 2) >> 2] = i25;
   i24 = 1 - i24 | 0;
   f5 = Math_fround(HEAPF32[i1 + (i24 << 4) >> 2]);
   f6 = Math_fround(HEAPF32[i1 + (i24 << 4) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i1 + (i24 << 4) + 8 >> 2]);
   i24 = HEAP32[i1 + (i24 << 4) + 12 >> 2] | 0;
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i16, i60, i25, i2);
   f10 = Math_fround(HEAPF32[i16 >> 2]);
   f12 = Math_fround(HEAPF32[i11 >> 2]);
   f26 = Math_fround(HEAPF32[i13 >> 2]);
   i25 = HEAP32[i14 >> 2] | 0;
   f66 = Math_fround(f6 - f12);
   f4 = Math_fround(f7 - f26);
   HEAPF32[i35 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i28 >> 2] = f66;
   HEAPF32[i29 >> 2] = f4;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i27 = HEAP32[i34 >> 2] | 0;
   HEAPF32[i52 + (i27 << 4) >> 2] = f5;
   HEAPF32[i52 + (i27 << 4) + 4 >> 2] = f6;
   HEAPF32[i52 + (i27 << 4) + 8 >> 2] = f7;
   HEAP32[i52 + (i27 << 4) + 12 >> 2] = i24;
   HEAPF32[i53 + (i27 << 4) >> 2] = f10;
   HEAPF32[i53 + (i27 << 4) + 4 >> 2] = f12;
   HEAPF32[i53 + (i27 << 4) + 8 >> 2] = f26;
   HEAP32[i53 + (i27 << 4) + 12 >> 2] = i25;
   HEAP32[i34 >> 2] = i27 + 1;
   i27 = i54 + (i27 << 4) | 0;
   HEAP32[i27 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < (HEAPU8[i39 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i17, i54, i52, i53, i44, i46, i35, i34);
  HEAP32[i55 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i55 >> 2]);
  f6 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i55 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i37 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i36 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  if (f4 > f9) {
   i27 = i55;
   i38 = 6;
  }
 }
 do if ((i38 | 0) == 6) {
  i2 = i55 + 4 | 0;
  i14 = i55 + 8 | 0;
  i15 = i59 + 96 | 0;
  i16 = i59 + 100 | 0;
  i17 = i59 + 104 | 0;
  i18 = i59 + 112 | 0;
  i20 = i59 + 116 | 0;
  i21 = i59 + 120 | 0;
  i22 = i32 + 4 | 0;
  i23 = i32 + 8 | 0;
  i24 = i59 + 48 | 0;
  i25 = i60 + 48 | 0;
  f26 = f4;
  while (1) {
   HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   f68 = Math_fround(-f5);
   f67 = Math_fround(-f6);
   f6 = Math_fround(-f7);
   i13 = HEAP32[i34 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i15 >> 2]);
   f10 = Math_fround(HEAPF32[i16 >> 2]);
   f7 = Math_fround(HEAPF32[i17 >> 2]);
   f69 = Math_fround(Math_fround(Math_fround(f5 * f68) + Math_fround(f10 * f67)) + Math_fround(f7 * f6));
   f12 = Math_fround(HEAPF32[i18 >> 2]);
   f4 = Math_fround(HEAPF32[i20 >> 2]);
   f66 = Math_fround(HEAPF32[i21 >> 2]);
   i11 = f69 > Math_fround(Math_fround(Math_fround(f12 * f68) + Math_fround(f4 * f67)) + Math_fround(f66 * f6));
   HEAP32[i44 + (i13 << 2) >> 2] = i11 & 1;
   f12 = i11 ? f5 : f12;
   f4 = i11 ? f10 : f4;
   f66 = i11 ? f7 : f66;
   HEAPF32[i52 + (i13 << 4) >> 2] = f12;
   HEAPF32[i52 + (i13 << 4) + 4 >> 2] = f4;
   HEAPF32[i52 + (i13 << 4) + 8 >> 2] = f66;
   HEAPF32[i52 + (i13 << 4) + 12 >> 2] = Math_fround(0.0);
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i32, i60, i55, i53 + (i13 << 4) | 0, i46 + (i13 << 2) | 0);
   f7 = Math_fround(HEAPF32[i32 >> 2]);
   f10 = Math_fround(HEAPF32[i22 >> 2]);
   f7 = Math_fround(f12 - f7);
   f10 = Math_fround(f4 - f10);
   f66 = Math_fround(f66 - Math_fround(HEAPF32[i23 >> 2]));
   HEAPF32[i35 >> 2] = f7;
   HEAPF32[i28 >> 2] = f10;
   HEAPF32[i29 >> 2] = f66;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i13 = HEAP32[i34 >> 2] | 0;
   i11 = i54 + (i13 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   f4 = Math_fround(HEAPF32[i24 >> 2]);
   f12 = Math_fround(HEAPF32[i25 >> 2]);
   f12 = f4 > f12 ? f4 : f12;
   f8 = f8 > f12 ? f8 : f12;
   f12 = Math_fround(f3 + f8);
   f12 = Math_fround(f26 * Math_fround(f12 * f12));
   f4 = Math_fround(HEAPF32[i55 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f66 = Math_fround(Math_fround(Math_fround(f4 * f7) + Math_fround(f5 * f10)) + Math_fround(f6 * f66));
   i11 = f66 > Math_fround(0.0) & Math_fround(f66 * f66) > f12;
   if (Math_fround(f26 * Math_fround(.00039999999)) >= Math_fround(f26 - f66) | i11) {
    f7 = f26;
    i38 = 8;
    break;
   }
   HEAP32[i34 >> 2] = i13 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i33, i54, i52, i53, i44, i46, i35, i34);
   HEAP32[i27 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i55 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i37 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i37 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i37 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   i1 = f26 > f4;
   if (!(f4 > f9 & i1)) break; else f26 = f4;
  }
  if ((i38 | 0) == 8) {
   i2 = i13 + -1 | 0;
   if (i45 | 0) {
    HEAP8[i39 >> 0] = i2;
    if (i2 | 0) {
     i1 = 0;
     do {
      HEAP8[i45 + i1 >> 0] = HEAP32[i44 + (i1 << 2) >> 2];
      HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   if (i11) {
    i64 = 0;
    STACKTOP = i65;
    return i64 | 0;
   }
   f10 = Math_fround(Math_sqrt(Math_fround(f7)));
   f7 = Math_fround(Math_fround(1.0) / f10);
   f9 = Math_fround(f4 * f7);
   f8 = Math_fround(f5 * f7);
   f7 = Math_fround(f6 * f7);
   HEAPF32[i56 >> 2] = f9;
   HEAPF32[i56 + 4 >> 2] = f8;
   HEAPF32[i56 + 8 >> 2] = f7;
   HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i48, i51, i13);
   f5 = Math_fround(HEAPF32[i48 >> 2]);
   f6 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i48 + 8 >> 2]);
   if (i63) {
    f68 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
    f58 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
    f69 = Math_fround(f68 + f58);
    f67 = Math_fround(f6 - Math_fround(f8 * f68));
    f66 = Math_fround(f4 - Math_fround(f7 * f68));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f9 * f68));
    HEAPF32[i61 + 4 >> 2] = f67;
    HEAPF32[i61 + 8 >> 2] = f66;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f66 = Math_fround(HEAPF32[i51 >> 2]);
    f67 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f67 = Math_fround(Math_fround(f8 * f58) + f67);
    f68 = Math_fround(Math_fround(f7 * f58) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f9 * f58) + f66);
    HEAPF32[i62 + 4 >> 2] = f67;
    HEAPF32[i62 + 8 >> 2] = f68;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f69);
    i64 = i64 + 4 | 0;
    HEAP32[i64 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i64 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i64 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    i64 = 1;
    STACKTOP = i65;
    return i64 | 0;
   } else {
    f68 = Math_fround(f6 - Math_fround(f57 * f8));
    f67 = Math_fround(f4 - Math_fround(f57 * f7));
    HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f9));
    HEAPF32[i61 + 4 >> 2] = f68;
    HEAPF32[i61 + 8 >> 2] = f67;
    HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
    f67 = Math_fround(HEAPF32[i51 >> 2]);
    f68 = Math_fround(HEAPF32[i51 + 4 >> 2]);
    f68 = Math_fround(Math_fround(f58 * f8) + f68);
    f69 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i51 + 8 >> 2]));
    HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f9) + f67);
    HEAPF32[i62 + 4 >> 2] = f68;
    HEAPF32[i62 + 8 >> 2] = f69;
    HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i64 >> 2] = Math_fround(f10 - f3);
    i64 = i64 + 4 | 0;
    HEAP32[i64 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i64 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
    HEAP32[i64 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
    i64 = 1;
    STACKTOP = i65;
    return i64 | 0;
   }
  }
  if (i1) {
   if (!i45) i1 = 6; else break;
   STACKTOP = i65;
   return i1 | 0;
  };
  HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  i11 = HEAP32[i34 >> 2] | 0;
  i2 = i11 + -1 | 0;
  if (i45 | 0) {
   HEAP8[i39 >> 0] = i2;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP8[i45 + i1 >> 0] = HEAP32[i44 + (i1 << 2) >> 2];
     HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  f12 = Math_fround(f3 + f8);
  f12 = Math_fround(f12 * f12);
  HEAP32[i27 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i54, i52, i53, i55, i40, i43, i11);
  HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  f8 = Math_fround(Math_sqrt(Math_fround(f26)));
  f9 = Math_fround(HEAPF32[i55 >> 2]);
  f10 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f7 = Math_fround(Math_fround(1.0) / f8);
  f9 = Math_fround(f9 * f7);
  f10 = Math_fround(f10 * f7);
  f7 = Math_fround(Math_fround(HEAPF32[i55 + 8 >> 2]) * f7);
  f5 = Math_fround(HEAPF32[i40 >> 2]);
  f6 = Math_fround(HEAPF32[i40 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i40 + 8 >> 2]);
  if (i63) {
   f69 = HEAP32[i59 + 64 >> 2] | 0 ? Math_fround(0.0) : f57;
   f66 = HEAP32[i60 + 64 >> 2] | 0 ? Math_fround(0.0) : f58;
   f3 = Math_fround(f69 + f66);
   f68 = Math_fround(f6 - Math_fround(f10 * f69));
   f67 = Math_fround(f4 - Math_fround(f7 * f69));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f9 * f69));
   HEAPF32[i61 + 4 >> 2] = f68;
   HEAPF32[i61 + 8 >> 2] = f67;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f67 = Math_fround(HEAPF32[i43 >> 2]);
   f68 = Math_fround(HEAPF32[i43 + 4 >> 2]);
   f68 = Math_fround(Math_fround(f10 * f66) + f68);
   f69 = Math_fround(Math_fround(f7 * f66) + Math_fround(HEAPF32[i43 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f9 * f66) + f67);
   HEAPF32[i62 + 4 >> 2] = f68;
   HEAPF32[i62 + 8 >> 2] = f69;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i63 = i64 + 4 | 0;
   HEAP32[i63 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  } else {
   f68 = Math_fround(f6 - Math_fround(f57 * f10));
   f67 = Math_fround(f4 - Math_fround(f57 * f7));
   HEAPF32[i61 >> 2] = Math_fround(f5 - Math_fround(f57 * f9));
   HEAPF32[i61 + 4 >> 2] = f68;
   HEAPF32[i61 + 8 >> 2] = f67;
   HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
   f67 = Math_fround(HEAPF32[i43 >> 2]);
   f68 = Math_fround(HEAPF32[i43 + 4 >> 2]);
   f68 = Math_fround(Math_fround(f58 * f10) + f68);
   f69 = Math_fround(Math_fround(f58 * f7) + Math_fround(HEAPF32[i43 + 8 >> 2]));
   HEAPF32[i62 >> 2] = Math_fround(Math_fround(f58 * f9) + f67);
   HEAPF32[i62 + 4 >> 2] = f68;
   HEAPF32[i62 + 8 >> 2] = f69;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   i63 = i64 + 4 | 0;
   HEAP32[i63 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i63 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i63 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  }
  HEAPF32[i64 >> 2] = Math_fround(f8 - f3);
  HEAPF32[i56 >> 2] = f9;
  HEAPF32[i56 + 4 >> 2] = f10;
  HEAPF32[i56 + 8 >> 2] = f7;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  i64 = f12 >= f26 ? 1 : 3;
  STACKTOP = i65;
  return i64 | 0;
 } while (0);
 i2 = HEAP32[i34 >> 2] | 0;
 HEAP8[i39 >> 0] = i2;
 if (!i2) {
  i64 = 6;
  STACKTOP = i65;
  return i64 | 0;
 } else i1 = 0;
 do {
  HEAP8[i45 + i1 >> 0] = HEAP32[i44 + (i1 << 2) >> 2];
  HEAP8[i47 + i1 >> 0] = HEAP32[i46 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i65;
 return i1 | 0;
}

function __ZN13TranslateGLES10InitFormatERK12GraphicsCaps(i18, i4) {
 i18 = i18 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 1904 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27;
 i25 = (HEAP8[i4 + 493 >> 0] | 0) != 0;
 i2 = HEAP32[i4 + 540 >> 2] | 0;
 i26 = HEAP8[i4 + 684 >> 0] | 0;
 i3 = i26 << 24 >> 24 != 0;
 i1 = (i2 | 0) != 1 | i3;
 i17 = i25 & (i1 ^ 1);
 i19 = i1 ? 35905 : 35904;
 i20 = i1 ? 35907 : 35906;
 i21 = i17 ? 35904 : 6407;
 i22 = HEAP32[i4 + 680 >> 2] | 0;
 i23 = (i22 | 0) == 2;
 if ((i22 | 0) == 1) {
  i15 = (i2 + -5 | 0) >>> 0 < 8 ? 32856 : i3 ? 37793 : 32993;
  i16 = 32993;
 } else {
  i15 = i1 ? 32856 : 6408;
  i16 = 6408;
 }
 i13 = (i2 | 0) == 1;
 i14 = i13 ? 36193 : 5131;
 i5 = i3 ? 4 : 0;
 i6 = i5 | 1;
 i8 = HEAP32[gb + 1451148 >> 2] | 0;
 i7 = HEAP8[i8 + 171 >> 0] | 0 ? 3 : i5 | 3;
 i8 = HEAP8[i8 + 172 >> 0] | 0 ? 1 : i6;
 i9 = i5 | 128;
 i10 = i5 | 64;
 i11 = i5 | 32;
 i12 = HEAP8[i4 + 723 >> 0] | 0 ? 36396 : 33189;
 if (!(HEAP8[i4 + 699 >> 0] | 0)) {
  i3 = (HEAP8[i4 + 676 >> 0] | 0) == 0;
  i1 = i3 ? 5123 : 5121;
  i2 = 6402;
  i3 = i3 ? i12 : 33190;
 } else {
  i1 = 34042;
  i2 = 34041;
  i3 = i13 ? 34041 : 35056;
 }
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP32[i24 + 16 >> 2] = 0;
 HEAP32[i24 + 20 >> 2] = 0;
 HEAP32[i24 + 24 >> 2] = 32849;
 HEAP32[i24 + 28 >> 2] = 6407;
 HEAP32[i24 + 32 >> 2] = 5121;
 HEAP32[i24 + 36 >> 2] = i5;
 HEAP32[i24 + 40 >> 2] = 3;
 HEAP32[i24 + 44 >> 2] = 3;
 HEAP32[i24 + 48 >> 2] = i19;
 HEAP32[i24 + 52 >> 2] = i21;
 HEAP32[i24 + 56 >> 2] = 5121;
 HEAP32[i24 + 60 >> 2] = i5;
 HEAP32[i24 + 64 >> 2] = 3;
 HEAP32[i24 + 68 >> 2] = 3;
 HEAP32[i24 + 72 >> 2] = 32856;
 HEAP32[i24 + 76 >> 2] = 6408;
 HEAP32[i24 + 80 >> 2] = 5121;
 HEAP32[i24 + 84 >> 2] = i5;
 HEAP32[i24 + 88 >> 2] = 4;
 HEAP32[i24 + 92 >> 2] = 4;
 HEAP32[i24 + 96 >> 2] = i20;
 HEAP32[i24 + 100 >> 2] = i17 ? 35906 : 6408;
 HEAP32[i24 + 104 >> 2] = 5121;
 HEAP32[i24 + 108 >> 2] = i5;
 HEAP32[i24 + 112 >> 2] = 4;
 HEAP32[i24 + 116 >> 2] = 4;
 HEAP32[i24 + 120 >> 2] = 32849;
 HEAP32[i24 + 124 >> 2] = 6407;
 HEAP32[i24 + 128 >> 2] = 5121;
 HEAP32[i24 + 132 >> 2] = i5;
 HEAP32[i24 + 136 >> 2] = 5;
 HEAP32[i24 + 140 >> 2] = 3;
 HEAP32[i24 + 144 >> 2] = i19;
 HEAP32[i24 + 148 >> 2] = i21;
 HEAP32[i24 + 152 >> 2] = 5121;
 HEAP32[i24 + 156 >> 2] = i5;
 HEAP32[i24 + 160 >> 2] = 5;
 HEAP32[i24 + 164 >> 2] = 3;
 HEAP32[i24 + 168 >> 2] = i15;
 HEAP32[i24 + 172 >> 2] = i16;
 HEAP32[i24 + 176 >> 2] = 5121;
 HEAP32[i24 + 180 >> 2] = i5;
 HEAP32[i24 + 184 >> 2] = 6;
 HEAP32[i24 + 188 >> 2] = 4;
 HEAP32[i24 + 192 >> 2] = i20;
 HEAP32[i24 + 196 >> 2] = i16;
 HEAP32[i24 + 200 >> 2] = 5121;
 HEAP32[i24 + 204 >> 2] = i5;
 HEAP32[i24 + 208 >> 2] = 6;
 HEAP32[i24 + 212 >> 2] = 4;
 HEAP32[i24 + 216 >> 2] = 32856;
 HEAP32[i24 + 220 >> 2] = 6408;
 HEAP32[i24 + 224 >> 2] = 5121;
 HEAP32[i24 + 228 >> 2] = i5;
 HEAP32[i24 + 232 >> 2] = 8;
 HEAP32[i24 + 236 >> 2] = 4;
 HEAP32[i24 + 240 >> 2] = i19;
 HEAP32[i24 + 244 >> 2] = 6408;
 HEAP32[i24 + 248 >> 2] = 5121;
 HEAP32[i24 + 252 >> 2] = i5;
 HEAP32[i24 + 256 >> 2] = 8;
 HEAP32[i24 + 260 >> 2] = 4;
 HEAP32[i24 + 264 >> 2] = 32857;
 HEAP32[i24 + 268 >> 2] = 6408;
 HEAP32[i24 + 272 >> 2] = 33640;
 HEAP32[i24 + 276 >> 2] = i5;
 HEAP32[i24 + 280 >> 2] = 4;
 HEAP32[i24 + 284 >> 2] = 4;
 HEAP32[i24 + 288 >> 2] = 33321;
 HEAP32[i24 + 292 >> 2] = 6403;
 HEAP32[i24 + 296 >> 2] = 5121;
 HEAP32[i24 + 300 >> 2] = i5;
 HEAP32[i24 + 304 >> 2] = 1;
 HEAP32[i24 + 308 >> 2] = 1;
 HEAP32[i24 + 312 >> 2] = i23 ? 33321 : 6406;
 HEAP32[i24 + 316 >> 2] = i23 ? 6403 : 6406;
 HEAP32[i24 + 320 >> 2] = 5121;
 HEAP32[i24 + 324 >> 2] = i13 | i26 << 24 >> 24 == 0 ? 0 : i22 | 0 ? 4 : 0;
 HEAP32[i24 + 328 >> 2] = 7;
 HEAP32[i24 + 332 >> 2] = 1;
 HEAP32[i24 + 336 >> 2] = 33322;
 HEAP32[i24 + 340 >> 2] = 6403;
 HEAP32[i24 + 344 >> 2] = 5123;
 HEAP32[i24 + 348 >> 2] = i5;
 HEAP32[i24 + 352 >> 2] = 7;
 HEAP32[i24 + 356 >> 2] = 2;
 HEAP32[i24 + 360 >> 2] = 36194;
 HEAP32[i24 + 364 >> 2] = 6407;
 HEAP32[i24 + 368 >> 2] = 33635;
 HEAP32[i24 + 372 >> 2] = i5;
 HEAP32[i24 + 376 >> 2] = 3;
 HEAP32[i24 + 380 >> 2] = 2;
 HEAP32[i24 + 384 >> 2] = 32855;
 HEAP32[i24 + 388 >> 2] = 6408;
 HEAP32[i24 + 392 >> 2] = 32820;
 HEAP32[i24 + 396 >> 2] = i5;
 HEAP32[i24 + 400 >> 2] = 4;
 HEAP32[i24 + 404 >> 2] = 2;
 HEAP32[i24 + 408 >> 2] = 32854;
 HEAP32[i24 + 412 >> 2] = 6408;
 HEAP32[i24 + 416 >> 2] = 32819;
 HEAP32[i24 + 420 >> 2] = i5;
 HEAP32[i24 + 424 >> 2] = 4;
 HEAP32[i24 + 428 >> 2] = 2;
 HEAP32[i24 + 432 >> 2] = 32854;
 HEAP32[i24 + 436 >> 2] = 6408;
 HEAP32[i24 + 440 >> 2] = 32819;
 HEAP32[i24 + 444 >> 2] = i5;
 HEAP32[i24 + 448 >> 2] = 6;
 HEAP32[i24 + 452 >> 2] = 2;
 HEAP32[i24 + 456 >> 2] = 33325;
 HEAP32[i24 + 460 >> 2] = 6403;
 HEAP32[i24 + 464 >> 2] = i14;
 HEAP32[i24 + 468 >> 2] = i10;
 HEAP32[i24 + 472 >> 2] = 1;
 HEAP32[i24 + 476 >> 2] = 2;
 HEAP32[i24 + 480 >> 2] = 33327;
 HEAP32[i24 + 484 >> 2] = 33319;
 HEAP32[i24 + 488 >> 2] = i14;
 HEAP32[i24 + 492 >> 2] = i10;
 HEAP32[i24 + 496 >> 2] = 2;
 HEAP32[i24 + 500 >> 2] = 4;
 HEAP32[i24 + 504 >> 2] = 34842;
 HEAP32[i24 + 508 >> 2] = 6408;
 HEAP32[i24 + 512 >> 2] = i14;
 HEAP32[i24 + 516 >> 2] = i10;
 HEAP32[i24 + 520 >> 2] = 4;
 HEAP32[i24 + 524 >> 2] = 8;
 HEAP32[i24 + 528 >> 2] = 33326;
 HEAP32[i24 + 532 >> 2] = 6403;
 HEAP32[i24 + 536 >> 2] = 5126;
 HEAP32[i24 + 540 >> 2] = i11;
 HEAP32[i24 + 544 >> 2] = 1;
 HEAP32[i24 + 548 >> 2] = 4;
 HEAP32[i24 + 552 >> 2] = 33328;
 HEAP32[i24 + 556 >> 2] = 33319;
 HEAP32[i24 + 560 >> 2] = 5126;
 HEAP32[i24 + 564 >> 2] = i11;
 HEAP32[i24 + 568 >> 2] = 2;
 HEAP32[i24 + 572 >> 2] = 8;
 HEAP32[i24 + 576 >> 2] = 34837;
 HEAP32[i24 + 580 >> 2] = 6407;
 HEAP32[i24 + 584 >> 2] = 5126;
 HEAP32[i24 + 588 >> 2] = i11;
 HEAP32[i24 + 592 >> 2] = 3;
 HEAP32[i24 + 596 >> 2] = 12;
 HEAP32[i24 + 600 >> 2] = 34836;
 HEAP32[i24 + 604 >> 2] = 6408;
 HEAP32[i24 + 608 >> 2] = 5126;
 HEAP32[i24 + 612 >> 2] = i11;
 HEAP32[i24 + 616 >> 2] = 4;
 HEAP32[i24 + 620 >> 2] = 16;
 HEAP32[i24 + 624 >> 2] = 35898;
 HEAP32[i24 + 628 >> 2] = 6407;
 HEAP32[i24 + 632 >> 2] = 35899;
 HEAP32[i24 + 636 >> 2] = i5;
 HEAP32[i24 + 640 >> 2] = 3;
 HEAP32[i24 + 644 >> 2] = 4;
 HEAP32[i24 + 648 >> 2] = 33333;
 HEAP32[i24 + 652 >> 2] = 36244;
 HEAP32[i24 + 656 >> 2] = 5124;
 HEAP32[i24 + 660 >> 2] = i9;
 HEAP32[i24 + 664 >> 2] = 1;
 HEAP32[i24 + 668 >> 2] = 4;
 HEAP32[i24 + 672 >> 2] = 33339;
 HEAP32[i24 + 676 >> 2] = 33320;
 HEAP32[i24 + 680 >> 2] = 5124;
 HEAP32[i24 + 684 >> 2] = i9;
 HEAP32[i24 + 688 >> 2] = 2;
 HEAP32[i24 + 692 >> 2] = 8;
 HEAP32[i24 + 696 >> 2] = 36226;
 HEAP32[i24 + 700 >> 2] = 36249;
 HEAP32[i24 + 704 >> 2] = 5124;
 HEAP32[i24 + 708 >> 2] = i9;
 HEAP32[i24 + 712 >> 2] = 4;
 HEAP32[i24 + 716 >> 2] = 16;
 HEAP32[i24 + 720 >> 2] = i12;
 HEAP32[i24 + 724 >> 2] = 6402;
 HEAP32[i24 + 728 >> 2] = 5123;
 HEAP32[i24 + 732 >> 2] = i5 | 8;
 HEAP32[i24 + 736 >> 2] = 4;
 HEAP32[i24 + 740 >> 2] = 2;
 HEAP32[i24 + 744 >> 2] = i3;
 HEAP32[i24 + 748 >> 2] = i2;
 HEAP32[i24 + 752 >> 2] = i1;
 HEAP32[i24 + 756 >> 2] = i5 | 24;
 HEAP32[i24 + 760 >> 2] = 4;
 HEAP32[i24 + 764 >> 2] = 3;
 HEAP32[i24 + 768 >> 2] = 36168;
 HEAP32[i24 + 772 >> 2] = 0;
 HEAP32[i24 + 776 >> 2] = 0;
 HEAP32[i24 + 780 >> 2] = i5 | 16;
 HEAP32[i24 + 784 >> 2] = 4;
 HEAP32[i24 + 788 >> 2] = 1;
 HEAP32[i24 + 792 >> 2] = 36561;
 HEAP32[i24 + 796 >> 2] = 0;
 HEAP32[i24 + 800 >> 2] = 0;
 HEAP32[i24 + 804 >> 2] = i5;
 HEAP32[i24 + 808 >> 2] = 4;
 HEAP32[i24 + 812 >> 2] = 0;
 HEAP32[i24 + 816 >> 2] = 33776;
 HEAP32[i24 + 820 >> 2] = 0;
 HEAP32[i24 + 824 >> 2] = 0;
 HEAP32[i24 + 828 >> 2] = i8;
 HEAP32[i24 + 832 >> 2] = 3;
 HEAP32[i24 + 836 >> 2] = 8;
 HEAP32[i24 + 840 >> 2] = i25 ? 35916 : 33776;
 HEAP32[i24 + 844 >> 2] = 0;
 HEAP32[i24 + 848 >> 2] = 0;
 HEAP32[i24 + 852 >> 2] = i8;
 HEAP32[i24 + 856 >> 2] = 3;
 HEAP32[i24 + 860 >> 2] = 8;
 HEAP32[i24 + 864 >> 2] = 33778;
 HEAP32[i24 + 868 >> 2] = 0;
 HEAP32[i24 + 872 >> 2] = 0;
 HEAP32[i24 + 876 >> 2] = i8;
 HEAP32[i24 + 880 >> 2] = 4;
 HEAP32[i24 + 884 >> 2] = 16;
 HEAP32[i24 + 888 >> 2] = i25 ? 35918 : 33778;
 HEAP32[i24 + 892 >> 2] = 0;
 HEAP32[i24 + 896 >> 2] = 0;
 HEAP32[i24 + 900 >> 2] = i8;
 HEAP32[i24 + 904 >> 2] = 4;
 HEAP32[i24 + 908 >> 2] = 16;
 HEAP32[i24 + 912 >> 2] = 33779;
 HEAP32[i24 + 916 >> 2] = 0;
 HEAP32[i24 + 920 >> 2] = 0;
 HEAP32[i24 + 924 >> 2] = i8;
 HEAP32[i24 + 928 >> 2] = 4;
 HEAP32[i24 + 932 >> 2] = 16;
 HEAP32[i24 + 936 >> 2] = i25 ? 35919 : 33779;
 HEAP32[i24 + 940 >> 2] = 0;
 HEAP32[i24 + 944 >> 2] = 0;
 HEAP32[i24 + 948 >> 2] = i8;
 HEAP32[i24 + 952 >> 2] = 4;
 HEAP32[i24 + 956 >> 2] = 16;
 HEAP32[i24 + 960 >> 2] = 36283;
 HEAP32[i24 + 964 >> 2] = 0;
 HEAP32[i24 + 968 >> 2] = 0;
 HEAP32[i24 + 972 >> 2] = i6;
 HEAP32[i24 + 976 >> 2] = 1;
 HEAP32[i24 + 980 >> 2] = 8;
 HEAP32[i24 + 984 >> 2] = 36285;
 HEAP32[i24 + 988 >> 2] = 0;
 HEAP32[i24 + 992 >> 2] = 0;
 HEAP32[i24 + 996 >> 2] = i6;
 HEAP32[i24 + 1e3 >> 2] = 2;
 HEAP32[i24 + 1004 >> 2] = 16;
 HEAP32[i24 + 1008 >> 2] = 36495;
 HEAP32[i24 + 1012 >> 2] = 0;
 HEAP32[i24 + 1016 >> 2] = 0;
 HEAP32[i24 + 1020 >> 2] = i6;
 HEAP32[i24 + 1024 >> 2] = 3;
 HEAP32[i24 + 1028 >> 2] = 16;
 HEAP32[i24 + 1032 >> 2] = 36492;
 HEAP32[i24 + 1036 >> 2] = 0;
 HEAP32[i24 + 1040 >> 2] = 0;
 HEAP32[i24 + 1044 >> 2] = i6;
 HEAP32[i24 + 1048 >> 2] = 4;
 HEAP32[i24 + 1052 >> 2] = 16;
 HEAP32[i24 + 1056 >> 2] = i25 ? 36493 : 36492;
 HEAP32[i24 + 1060 >> 2] = 0;
 HEAP32[i24 + 1064 >> 2] = 0;
 HEAP32[i24 + 1068 >> 2] = i6;
 HEAP32[i24 + 1072 >> 2] = 4;
 HEAP32[i24 + 1076 >> 2] = 16;
 HEAP32[i24 + 1080 >> 2] = 35841;
 HEAP32[i24 + 1084 >> 2] = 0;
 HEAP32[i24 + 1088 >> 2] = 0;
 HEAP32[i24 + 1092 >> 2] = i6;
 HEAP32[i24 + 1096 >> 2] = 3;
 HEAP32[i24 + 1100 >> 2] = 32;
 HEAP32[i24 + 1104 >> 2] = i25 ? 35412 : 35841;
 HEAP32[i24 + 1108 >> 2] = 0;
 HEAP32[i24 + 1112 >> 2] = 0;
 HEAP32[i24 + 1116 >> 2] = i6;
 HEAP32[i24 + 1120 >> 2] = 3;
 HEAP32[i24 + 1124 >> 2] = 32;
 HEAP32[i24 + 1128 >> 2] = 35840;
 HEAP32[i24 + 1132 >> 2] = 0;
 HEAP32[i24 + 1136 >> 2] = 0;
 HEAP32[i24 + 1140 >> 2] = i6;
 HEAP32[i24 + 1144 >> 2] = 3;
 HEAP32[i24 + 1148 >> 2] = 32;
 HEAP32[i24 + 1152 >> 2] = i25 ? 35413 : 35840;
 HEAP32[i24 + 1156 >> 2] = 0;
 HEAP32[i24 + 1160 >> 2] = 0;
 HEAP32[i24 + 1164 >> 2] = i6;
 HEAP32[i24 + 1168 >> 2] = 3;
 HEAP32[i24 + 1172 >> 2] = 32;
 HEAP32[i24 + 1176 >> 2] = 35843;
 HEAP32[i24 + 1180 >> 2] = 0;
 HEAP32[i24 + 1184 >> 2] = 0;
 HEAP32[i24 + 1188 >> 2] = i6;
 HEAP32[i24 + 1192 >> 2] = 4;
 HEAP32[i24 + 1196 >> 2] = 32;
 HEAP32[i24 + 1200 >> 2] = i25 ? 35414 : 35843;
 HEAP32[i24 + 1204 >> 2] = 0;
 HEAP32[i24 + 1208 >> 2] = 0;
 HEAP32[i24 + 1212 >> 2] = i6;
 HEAP32[i24 + 1216 >> 2] = 4;
 HEAP32[i24 + 1220 >> 2] = 32;
 HEAP32[i24 + 1224 >> 2] = 35842;
 HEAP32[i24 + 1228 >> 2] = 0;
 HEAP32[i24 + 1232 >> 2] = 0;
 HEAP32[i24 + 1236 >> 2] = i6;
 HEAP32[i24 + 1240 >> 2] = 4;
 HEAP32[i24 + 1244 >> 2] = 32;
 HEAP32[i24 + 1248 >> 2] = i25 ? 35415 : 35842;
 HEAP32[i24 + 1252 >> 2] = 0;
 HEAP32[i24 + 1256 >> 2] = 0;
 HEAP32[i24 + 1260 >> 2] = i6;
 HEAP32[i24 + 1264 >> 2] = 4;
 HEAP32[i24 + 1268 >> 2] = 32;
 HEAP32[i24 + 1272 >> 2] = 35986;
 HEAP32[i24 + 1276 >> 2] = 0;
 HEAP32[i24 + 1280 >> 2] = 0;
 HEAP32[i24 + 1284 >> 2] = i6;
 HEAP32[i24 + 1288 >> 2] = 3;
 HEAP32[i24 + 1292 >> 2] = 8;
 HEAP32[i24 + 1296 >> 2] = 34798;
 HEAP32[i24 + 1300 >> 2] = 0;
 HEAP32[i24 + 1304 >> 2] = 0;
 HEAP32[i24 + 1308 >> 2] = i6;
 HEAP32[i24 + 1312 >> 2] = 4;
 HEAP32[i24 + 1316 >> 2] = 16;
 HEAP32[i24 + 1320 >> 2] = i13 ? 36196 : 37492;
 HEAP32[i24 + 1324 >> 2] = 0;
 HEAP32[i24 + 1328 >> 2] = 0;
 HEAP32[i24 + 1332 >> 2] = i7;
 HEAP32[i24 + 1336 >> 2] = 3;
 HEAP32[i24 + 1340 >> 2] = 16;
 HEAP32[i24 + 1344 >> 2] = i13 ? 36196 : 37493;
 HEAP32[i24 + 1348 >> 2] = 0;
 HEAP32[i24 + 1352 >> 2] = 0;
 HEAP32[i24 + 1356 >> 2] = i7;
 HEAP32[i24 + 1360 >> 2] = 3;
 HEAP32[i24 + 1364 >> 2] = 16;
 HEAP32[i24 + 1368 >> 2] = 37492;
 HEAP32[i24 + 1372 >> 2] = 0;
 HEAP32[i24 + 1376 >> 2] = 0;
 HEAP32[i24 + 1380 >> 2] = i7;
 HEAP32[i24 + 1384 >> 2] = 3;
 HEAP32[i24 + 1388 >> 2] = 8;
 HEAP32[i24 + 1392 >> 2] = 37493;
 HEAP32[i24 + 1396 >> 2] = 0;
 HEAP32[i24 + 1400 >> 2] = 0;
 HEAP32[i24 + 1404 >> 2] = i7;
 HEAP32[i24 + 1408 >> 2] = 3;
 HEAP32[i24 + 1412 >> 2] = 8;
 HEAP32[i24 + 1416 >> 2] = 37494;
 HEAP32[i24 + 1420 >> 2] = 0;
 HEAP32[i24 + 1424 >> 2] = 0;
 HEAP32[i24 + 1428 >> 2] = i7;
 HEAP32[i24 + 1432 >> 2] = 4;
 HEAP32[i24 + 1436 >> 2] = 8;
 HEAP32[i24 + 1440 >> 2] = 37495;
 HEAP32[i24 + 1444 >> 2] = 0;
 HEAP32[i24 + 1448 >> 2] = 0;
 HEAP32[i24 + 1452 >> 2] = i7;
 HEAP32[i24 + 1456 >> 2] = 4;
 HEAP32[i24 + 1460 >> 2] = 8;
 HEAP32[i24 + 1464 >> 2] = 37496;
 HEAP32[i24 + 1468 >> 2] = 0;
 HEAP32[i24 + 1472 >> 2] = 0;
 HEAP32[i24 + 1476 >> 2] = i7;
 HEAP32[i24 + 1480 >> 2] = 4;
 HEAP32[i24 + 1484 >> 2] = 16;
 HEAP32[i24 + 1488 >> 2] = 37497;
 HEAP32[i24 + 1492 >> 2] = 0;
 HEAP32[i24 + 1496 >> 2] = 0;
 HEAP32[i24 + 1500 >> 2] = i7;
 HEAP32[i24 + 1504 >> 2] = 4;
 HEAP32[i24 + 1508 >> 2] = 16;
 HEAP32[i24 + 1512 >> 2] = 37488;
 HEAP32[i24 + 1516 >> 2] = 0;
 HEAP32[i24 + 1520 >> 2] = 0;
 HEAP32[i24 + 1524 >> 2] = i7;
 HEAP32[i24 + 1528 >> 2] = 1;
 HEAP32[i24 + 1532 >> 2] = 8;
 HEAP32[i24 + 1536 >> 2] = 37489;
 HEAP32[i24 + 1540 >> 2] = 0;
 HEAP32[i24 + 1544 >> 2] = 0;
 HEAP32[i24 + 1548 >> 2] = i7;
 HEAP32[i24 + 1552 >> 2] = 1;
 HEAP32[i24 + 1556 >> 2] = 8;
 HEAP32[i24 + 1560 >> 2] = 37490;
 HEAP32[i24 + 1564 >> 2] = 0;
 HEAP32[i24 + 1568 >> 2] = 0;
 HEAP32[i24 + 1572 >> 2] = i7;
 HEAP32[i24 + 1576 >> 2] = 2;
 HEAP32[i24 + 1580 >> 2] = 16;
 HEAP32[i24 + 1584 >> 2] = 37491;
 HEAP32[i24 + 1588 >> 2] = 0;
 HEAP32[i24 + 1592 >> 2] = 0;
 HEAP32[i24 + 1596 >> 2] = i7;
 HEAP32[i24 + 1600 >> 2] = 2;
 HEAP32[i24 + 1604 >> 2] = 16;
 HEAP32[i24 + 1608 >> 2] = 37808;
 HEAP32[i24 + 1612 >> 2] = 0;
 HEAP32[i24 + 1616 >> 2] = 0;
 HEAP32[i24 + 1620 >> 2] = i6;
 HEAP32[i24 + 1624 >> 2] = 4;
 HEAP32[i24 + 1628 >> 2] = 16;
 HEAP32[i24 + 1632 >> 2] = 37840;
 HEAP32[i24 + 1636 >> 2] = 0;
 HEAP32[i24 + 1640 >> 2] = 0;
 HEAP32[i24 + 1644 >> 2] = i6;
 HEAP32[i24 + 1648 >> 2] = 4;
 HEAP32[i24 + 1652 >> 2] = 16;
 HEAP32[i24 + 1656 >> 2] = 37810;
 HEAP32[i24 + 1660 >> 2] = 0;
 HEAP32[i24 + 1664 >> 2] = 0;
 HEAP32[i24 + 1668 >> 2] = i6;
 HEAP32[i24 + 1672 >> 2] = 4;
 HEAP32[i24 + 1676 >> 2] = 16;
 HEAP32[i24 + 1680 >> 2] = 37842;
 HEAP32[i24 + 1684 >> 2] = 0;
 HEAP32[i24 + 1688 >> 2] = 0;
 HEAP32[i24 + 1692 >> 2] = i6;
 HEAP32[i24 + 1696 >> 2] = 4;
 HEAP32[i24 + 1700 >> 2] = 16;
 HEAP32[i24 + 1704 >> 2] = 37812;
 HEAP32[i24 + 1708 >> 2] = 0;
 HEAP32[i24 + 1712 >> 2] = 0;
 HEAP32[i24 + 1716 >> 2] = i6;
 HEAP32[i24 + 1720 >> 2] = 4;
 HEAP32[i24 + 1724 >> 2] = 16;
 HEAP32[i24 + 1728 >> 2] = 37844;
 HEAP32[i24 + 1732 >> 2] = 0;
 HEAP32[i24 + 1736 >> 2] = 0;
 HEAP32[i24 + 1740 >> 2] = i6;
 HEAP32[i24 + 1744 >> 2] = 4;
 HEAP32[i24 + 1748 >> 2] = 16;
 HEAP32[i24 + 1752 >> 2] = 37815;
 HEAP32[i24 + 1756 >> 2] = 0;
 HEAP32[i24 + 1760 >> 2] = 0;
 HEAP32[i24 + 1764 >> 2] = i6;
 HEAP32[i24 + 1768 >> 2] = 4;
 HEAP32[i24 + 1772 >> 2] = 16;
 HEAP32[i24 + 1776 >> 2] = 37847;
 HEAP32[i24 + 1780 >> 2] = 0;
 HEAP32[i24 + 1784 >> 2] = 0;
 HEAP32[i24 + 1788 >> 2] = i6;
 HEAP32[i24 + 1792 >> 2] = 4;
 HEAP32[i24 + 1796 >> 2] = 16;
 HEAP32[i24 + 1800 >> 2] = 37819;
 HEAP32[i24 + 1804 >> 2] = 0;
 HEAP32[i24 + 1808 >> 2] = 0;
 HEAP32[i24 + 1812 >> 2] = i6;
 HEAP32[i24 + 1816 >> 2] = 4;
 HEAP32[i24 + 1820 >> 2] = 16;
 HEAP32[i24 + 1824 >> 2] = 37851;
 HEAP32[i24 + 1828 >> 2] = 0;
 HEAP32[i24 + 1832 >> 2] = 0;
 HEAP32[i24 + 1836 >> 2] = i6;
 HEAP32[i24 + 1840 >> 2] = 4;
 HEAP32[i24 + 1844 >> 2] = 16;
 HEAP32[i24 + 1848 >> 2] = 37821;
 HEAP32[i24 + 1852 >> 2] = 0;
 HEAP32[i24 + 1856 >> 2] = 0;
 HEAP32[i24 + 1860 >> 2] = i6;
 HEAP32[i24 + 1864 >> 2] = 4;
 HEAP32[i24 + 1868 >> 2] = 16;
 HEAP32[i24 + 1872 >> 2] = 37853;
 HEAP32[i24 + 1876 >> 2] = 0;
 HEAP32[i24 + 1880 >> 2] = 0;
 HEAP32[i24 + 1884 >> 2] = i6;
 HEAP32[i24 + 1888 >> 2] = 4;
 HEAP32[i24 + 1892 >> 2] = 16;
 _memcpy(i18 + 28 | 0, i24 | 0, 1896) | 0;
 STACKTOP = i27;
 return;
}

function __Z19DoPrePassRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb(i41, i22, i28, i24, i29, i42, i30) {
 i41 = i41 | 0;
 i22 = i22 | 0;
 i28 = i28 | 0;
 i24 = i24 | 0;
 i29 = i29 | 0;
 i42 = i42 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i47 + 8 | 0;
 i39 = i47;
 i35 = i47 + 272 | 0;
 i34 = i47 + 248 | 0;
 i17 = i47 + 232 | 0;
 i15 = i47 + 220 | 0;
 i16 = i47 + 216 | 0;
 i31 = i47 + 80 | 0;
 i20 = i47 + 56 | 0;
 i32 = i47 + 440 | 0;
 i43 = i47 + 32 | 0;
 i25 = i47 + 28 | 0;
 i26 = i47 + 436 | 0;
 i27 = i47 + 432 | 0;
 i36 = i47 + 24 | 0;
 i33 = i47 + 268 | 0;
 i37 = i47 + 264 | 0;
 i38 = i47 + 224 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i42 >> 2] = 0;
 HEAP8[i30 >> 0] = 0;
 i23 = HEAP32[gb + 1166248 >> 2] | 0;
 i45 = gb + 64016 | 0;
 i44 = HEAP32[i45 + 4 >> 2] | 0;
 i13 = i39;
 HEAP32[i13 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i13 + 4 >> 2] = i44;
 HEAP32[i35 + 140 >> 2] = 0;
 i13 = i35 + 152 | 0;
 i44 = i35 + 156 | 0;
 HEAP32[i44 >> 2] = 0;
 i45 = i35 + 144 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i40, i39);
 i3 = i40;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i46 = i45;
 HEAP32[i46 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i46 + 4 >> 2] = i1;
 HEAP32[i35 >> 2] = i41;
 HEAP32[i35 + 4 >> 2] = i22;
 i46 = i35 + 140 | 0;
 HEAP32[i13 >> 2] = 0;
 i1 = __Z17GetRenderSettingsv() | 0;
 i3 = __Z19GetLightmapSettingsv() | 0;
 i2 = i35 + 8 | 0;
 i1 = i1 + 192 | 0;
 i4 = i2 + 108 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i35 + 116 >> 2] = HEAP32[i3 + 80 >> 2];
 i1 = __ZNK16LightmapSettings14GetLightProbesEv(i3) | 0;
 if (!i1) i19 = 4; else {
  i2 = i1 + 32 | 0;
  if (!(__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2) | 0)) i19 = 4; else {
   HEAP32[i35 + 120 >> 2] = i2;
   HEAP32[i35 + 124 >> 2] = i1 + 148;
   HEAP32[i35 + 128 >> 2] = i1 + 168;
   HEAP32[i35 + 132 >> 2] = HEAP32[i1 + 188 >> 2];
  }
 }
 if ((i19 | 0) == 4) {
  i21 = i35 + 120 | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  HEAP32[i21 + 12 >> 2] = 0;
 }
 i21 = (__ZNK16LightmapSettings19AreLightProbesBakedEv(i3) | 0) & 1;
 i1 = i35 + 136 | 0;
 HEAP8[i1 >> 0] = HEAP8[i1 >> 0] & -2 | i21;
 i21 = __ZNK16LightmapSettings23HasLightProbeTetrahedraEv(i3) | 0;
 i14 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i21 ? i14 << 1 & 2 : 0) | i14 & -3;
 i1 = HEAP32[i22 >> 2] | 0;
 i14 = i22 + 12 | 0;
 i21 = HEAP32[i14 >> 2] | 0;
 i11 = i1 + (i21 << 5) | 0;
 if (i21 | 0) {
  i2 = 0;
  while (1) {
   i4 = HEAP32[i13 >> 2] | 0;
   i8 = i4 + 1 | 0;
   i9 = HEAP32[i44 >> 2] | 0;
   i10 = i9 & 2147483647;
   do if (i8 >>> 0 > i10 >>> 0) {
    i3 = i9 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
     HEAP32[i44 >> 2] = i3;
     HEAP32[i46 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i46 >> 2] | 0, i3 << 2, 4, i45, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i45, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i21 | 0, HEAP32[i46 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
     HEAP32[i44 >> 2] = i3;
     HEAP32[i46 >> 2] = i21;
     break;
    }
   } while (0);
   HEAP32[i13 >> 2] = i8;
   HEAP32[(HEAP32[i46 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   i1 = i1 + 32 | 0;
   if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 i21 = i41 + 8 | 0;
 i2 = (HEAP32[i21 >> 2] | 0) + 1064 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 509 >> 0] | 0)) i3 = 1; else {
  i1 = HEAP32[i2 >> 2] | 0;
  i19 = 10;
 } else i19 = 10;
 if ((i19 | 0) == 10) i3 = (i1 | 0) == 1;
 i2 = HEAP32[i41 + 1832 >> 2] | 0;
 if ((HEAP16[gb + 1115e3 + 6 >> 1] | 0) > -1) {
  HEAP32[i39 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115e3 | 0, i40);
  i1 = gb + 1115e3 | 0;
 } else i1 = 0;
 i13 = HEAP32[i22 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 i14 = i39;
 HEAP32[i14 >> 2] = i3 & 1;
 HEAP32[i14 + 4 >> 2] = i2;
 HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
 __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i13, i13 + (i18 << 5) | 0, i18 << 5 >> 5, i40);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i8 = __Z12GetGfxDevicev() | 0;
 __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_(HEAP32[i21 >> 2] | 0, i17, i15, i16);
 f12 = Math_fround(HEAPF32[i15 >> 2]);
 __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f(HEAP32[i21 >> 2] | 0, Math_fround(1.0), f12, Math_fround(HEAPF32[i16 >> 2]), i34);
 i18 = i8 + 708 | 0;
 HEAP32[i18 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 i18 = i8 + 948 | 0;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 __ZNK14RenderSettings19GetFlatAmbientColorEv(i40, __Z17GetRenderSettingsv() | 0);
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f5 = Math_fround(HEAPF32[i40 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f7 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  f5 = Math_fround(HEAPF32[i40 + 4 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f6 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  f5 = Math_fround(HEAPF32[i40 + 8 >> 2]);
  do if (!(f5 <= Math_fround(.0404499993))) {
   if (f5 < Math_fround(1.0)) {
    f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
  } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = i40 + 12 | 0;
 } else {
  i3 = HEAP32[i40 >> 2] | 0;
  i4 = HEAP32[i40 + 4 >> 2] | 0;
  i1 = HEAP32[i40 + 8 >> 2] | 0;
  i2 = i40 + 12 | 0;
 }
 i17 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + 692 >> 2] = i3;
 HEAP32[i8 + 696 >> 2] = i4;
 HEAP32[i8 + 700 >> 2] = i1;
 HEAP32[i8 + 704 >> 2] = i17;
 i17 = __Z12GetGfxDevicev() | 0;
 i18 = HEAP32[(HEAP32[i21 >> 2] | 0) + 1144 >> 2] | 0;
 __ZN13RenderTexture6CreateEv(i18) | 0;
 i16 = i24 + 312 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i15 = HEAP32[i24 + 324 >> 2] | 0;
 i3 = i1 + (i15 * 180 | 0) | 0;
 if (!i15) i9 = 0; else {
  i2 = -1;
  do {
   i15 = HEAP32[i1 + 16 >> 2] | 0;
   i2 = ((i15 | 0) == 0 ? -1 : i15) & i2;
   i1 = i1 + 180 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i9 = ~i2;
 }
 HEAP32[i31 >> 2] = i9;
 i2 = i31 + 4 | 0;
 i4 = i2 + 128 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i8 = i31 + 132 | 0;
 HEAP32[i8 >> 2] = 0;
 i3 = 1;
 i2 = 3;
 i4 = 0;
 i1 = 0;
 while (1) {
  if (i3 & i9) {
   if ((i1 | 0) < 4) {
    HEAP32[i31 + 4 + (i4 << 2) >> 2] = i2;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == 32) break; else i3 = i3 << 1;
 }
 i14 = i23 + 148 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i1 = i20 + 12 | 0;
 HEAPF32[i1 >> 2] = f7;
 i2 = i20 + 16 | 0;
 HEAPF32[i2 >> 2] = f5;
 i3 = i20 + 20 | 0;
 HEAPF32[i3 >> 2] = f12;
 i15 = __ZN17PrePassRenderLoop14RenderBasePassEP13RenderTextureRK14LightingLayersR13dynamic_arrayI16RenderObjectDataLj4EERbR10MinMaxAABB(i35, i18, i31, i28, i32, i20) | 0;
 HEAP32[i29 >> 2] = i15;
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f12 == f5) {
  f7 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  if (f7 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f7 = Math_fround(HEAPF32[i20 + 8 >> 2]);
   if (!(f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2]))) i19 = 48;
  } else i19 = 48;
 } else i19 = 48;
 do if ((i19 | 0) == 48) {
  f6 = Math_fround(-f5);
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  if (f7 == f6) {
   f48 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   f49 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i3 >> 2]);
   if (!(f5 != f49 | f6 != f48)) break;
  } else {
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i3 >> 2]);
  }
  HEAPF32[i20 >> 2] = Math_fround(f12 + Math_fround(-.00999999977));
  i19 = i20 + 4 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + Math_fround(-.00999999977));
  i19 = i20 + 8 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + Math_fround(-.00999999977));
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(.00999999977));
  HEAPF32[i2 >> 2] = Math_fround(f5 + Math_fround(.00999999977));
  HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(.00999999977));
 } while (0);
 HEAP32[i43 + 8 >> 2] = 0;
 i13 = i43 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i43 + 16 >> 2] = 0;
 __Z24SetupActiveLightsContextR21ActiveLightingContextRK12ActiveLightsRK11CullResultsP14ShadowMapCacheRK10MinMaxAABB(i43, i16, i24, HEAP32[i41 + 1728 >> 2] | 0, i20);
 i3 = HEAP32[i15 + 128 >> 2] | 0;
 i2 = HEAP32[i18 + 136 >> 2] | 0;
 i1 = HEAP32[i18 + 124 >> 2] | 0;
 HEAP32[i25 >> 2] = i1;
 i10 = HEAP32[i18 + 100 >> 2] | 0;
 i11 = (HEAP32[i17 + 4388 >> 2] | 0) == 8;
 if (i11) {
  i9 = __Z19RenderBasePassDepthRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERS2_I17PrePassRenderDataLj4EER17ShaderPassContext(i41, i22, i46, i23) | 0;
  i1 = HEAP32[i9 + 48 >> 2] | 0;
  HEAP32[i25 >> 2] = i1;
  HEAP32[i29 >> 2] = i9;
  i8 = HEAP32[i9 + 128 >> 2] | 0;
  i9 = HEAP32[i9 + 136 >> 2] | 0;
  HEAP8[i30 >> 0] = 1;
 } else {
  i9 = i2;
  i8 = i3;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) {
  if (!(HEAP8[i24 + 332 >> 0] | 0)) i2 = 1; else {
   i2 = HEAP32[i16 >> 2] | 0;
   if (!i2) i2 = 1; else {
    i2 = HEAP32[i2 >> 2] | 0;
    if (!i2) i2 = 1; else if ((HEAP32[i2 + 40 >> 2] | 0) == 1) i2 = (HEAP32[i2 + 96 >> 2] | 0) == 0; else i2 = 1;
   }
  }
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = HEAP32[i3 + 1072 >> 2] & 1;
  if (!(i2 & (i4 | 0) == 0)) {
   if ((HEAP16[gb + 1115060 + 6 >> 1] | 0) > -1) {
    HEAP32[i39 >> 2] = i3;
    HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115060 | 0, i40);
    i2 = gb + 1115060 | 0;
   } else i2 = 0;
   i24 = HEAP32[gb + 1115060 >> 2] | 0;
   i23 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 648 >> 2] | 0, i23 | 0, i24 | 0);
   i24 = HEAP32[gb + 1163232 >> 2] | 0;
   HEAP32[gb + 1163232 >> 2] = 1;
   HEAP32[i26 >> 2] = i8;
   HEAP32[i27 >> 2] = i9;
   HEAP32[i39 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i40 >> 2] = HEAP32[i27 >> 2];
   __Z29RenderForwardObjectsIntoDepthRK17RenderLoopContextP13RenderTextureP13dynamic_arrayI16RenderObjectDataLj4EE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseESC_iib(i41, i18, i28, i39, i40, 0, 0, (i4 | 0) != 0);
   HEAP32[gb + 1163232 >> 2] = i24;
   i28 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i28 >> 2] | 0) + 652 >> 2] | 0, i28 | 0);
   if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  }
 }
 if (!i11) {
  __Z31ResolveDepthIntoTextureIfNeededR9GfxDeviceR10RenderLoop17DepthBufferFormatRP13RenderTextureP9TextureIDPb(i17, HEAP32[i41 + 1888 >> 2] | 0, i10, i29, i25, i30);
  i1 = HEAP32[i25 >> 2] | 0;
 }
 HEAP32[i36 >> 2] = 0;
 HEAP32[i33 >> 2] = i1;
 i1 = (HEAP8[i32 >> 0] | 0) != 0;
 HEAP32[i40 >> 2] = HEAP32[i33 >> 2];
 __ZN17PrePassRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDS3_RS3_RK8Vector4fRK14LightingLayersR10MinMaxAABBb(i35, i43, i18, i40, i15, i36, i34, i31, 0, i1);
 HEAP8[i14 >> 0] = 1;
 i1 = HEAP32[i21 >> 2] | 0;
 if (HEAP8[i1 + 1093 >> 0] | 0) {
  HEAP32[i40 >> 2] = 0;
  HEAP32[i40 + 4 >> 2] = 0;
  HEAP32[i40 + 8 >> 2] = 0;
  HEAP32[i40 + 12 >> 2] = 0;
  mftCall_viiifi(HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0, i17 | 0, 4, i40 | 0, 1.0, 0);
  i1 = HEAP32[i21 >> 2] | 0;
 }
 __ZN17PrePassRenderLoop15RenderFinalPassEP13RenderTextureS1_b(i35, i18, HEAP32[i36 >> 2] | 0, (HEAP8[i1 + 1092 >> 0] | 0) != 0);
 i1 = HEAP32[i36 >> 2] | 0;
 if (i1 | 0) {
  i35 = HEAP32[(HEAP32[i17 >> 2] | 0) + 416 >> 2] | 0;
  HEAP32[i37 >> 2] = HEAP32[i1 + 128 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i37 >> 2];
  mftCall_viiii(i35 | 0, i17 | 0, i40 | 0, 0, -4);
  i37 = HEAP32[(HEAP32[i17 >> 2] | 0) + 416 >> 2] | 0;
  HEAP32[i38 >> 2] = HEAP32[(HEAP32[i36 >> 2] | 0) + 136 >> 2];
  HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
  mftCall_viiii(i37 | 0, i17 | 0, i40 | 0, 0, -4);
 }
 i38 = HEAP32[i21 >> 2] | 0;
 i1 = i38;
 if (HEAP32[i38 + 1072 >> 2] & 2 | 0) {
  if ((HEAP16[gb + 1115072 + 6 >> 1] | 0) > -1) {
   HEAP32[i39 >> 2] = i1;
   HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115072 | 0, i40);
   i1 = gb + 1115072 | 0;
  } else i1 = 0;
  i40 = HEAP32[gb + 1115072 >> 2] | 0;
  i39 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 648 >> 2] | 0, i39 | 0, i40 | 0);
  HEAP32[i42 >> 2] = __Z26CombineDepthNormalsTextureRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EE(i41, 0) | 0;
  i42 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i42 >> 2] | 0) + 652 >> 2] | 0, i42 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i18, 0, -1, 0, 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 112 >> 2] | 0, i17 | 0, i41 + 1732 | 0);
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 148 >> 2] | 0, i17 | 0, 0);
 i2 = HEAP32[i43 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i3 = HEAP32[i43 + 4 >> 2] | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0;
   if (i4 | 0) {
    i42 = i4 + 4 | 0;
    HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + -1;
    if (!(HEAP32[i42 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i42 = i1 + 4 | 0;
  HEAP32[i42 >> 2] = (HEAP32[i42 >> 2] | 0) + -1;
  if (!(HEAP32[i42 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 + 4 >> 2] | 0, gb + 64016 | 0);
 if ((HEAP32[i44 >> 2] | 0) <= -1) {
  STACKTOP = i47;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i46 >> 2] | 0, i45);
 HEAP32[i46 >> 2] = 0;
 STACKTOP = i47;
 return;
}

function __ZN14ParticleSystem12StartModulesERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK27ParticleSystemEmissionStatebRK8Vector3fRK10Matrix4x4fR23ParticleSystemParticlesjffjfjRjb(i37, i43, i45, i9, i7, i8, i6, i46, i41, f40, f3, i38, f39, i1, i44, i2) {
 i37 = i37 | 0;
 i43 = i43 | 0;
 i45 = i45 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i46 = i46 | 0;
 i41 = i41 | 0;
 f40 = Math_fround(f40);
 f3 = Math_fround(f3);
 i38 = i38 | 0;
 f39 = Math_fround(f39);
 i1 = i1 | 0;
 i44 = i44 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i42 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i47 + 16 | 0;
 i4 = i47;
 i5 = i47 + 4 | 0;
 HEAPF32[i4 >> 2] = f3;
 __ZN13InitialModule5StartERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fjf(HEAP32[i37 + 44 >> 2] | 0, i43, i46, i6, i41, f3);
 if (HEAP8[i37 + 52 >> 0] | 0) __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb(i37 + 48 | 0, i43, i45, i46, i6, i41, i2);
 i1 = HEAP32[i37 + 920 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN12LightsModule5StartER23ParticleSystemParticlesjj(i1, i46, i41, HEAP32[i44 >> 2] | 0);
 i33 = HEAP32[i8 >> 2] | 0;
 i34 = HEAP32[i8 + 4 >> 2] | 0;
 i35 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i33;
 HEAP32[i5 + 4 >> 2] = i34;
 HEAP32[i5 + 8 >> 2] = i35;
 __ZN14ParticleSystem13StartVelocityERS_RK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjRKN4math7_float3ERKfbb(i37, i43, i46, i41, i5, i4, 1, i7);
 i5 = HEAP32[i46 + 12 >> 2] | 0;
 f36 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 i9 = i5 >>> 0 > i41 >>> 0;
 f15 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!i9) {
  STACKTOP = i47;
  return;
 }
 i10 = i42 + 4 | 0;
 i12 = i42 + 8 | 0;
 i13 = i42 + 12 | 0;
 i14 = i46 + 20 | 0;
 i18 = i46 + 40 | 0;
 i19 = i46 + 520 | 0;
 i20 = i46 + 540 | 0;
 i21 = i46 + 60 | 0;
 i22 = i46 + 80 | 0;
 i23 = i46 + 100 | 0;
 i24 = i46 + 120 | 0;
 i25 = i46 + 140 | 0;
 i26 = i46 + 160 | 0;
 i27 = i46 + 869 | 0;
 i28 = i37 + 916 | 0;
 i29 = i46 + 870 | 0;
 i30 = i46 + 400 | 0;
 i31 = i46 + 340 | 0;
 i32 = i46 + 360 | 0;
 i33 = i46 + 380 | 0;
 i34 = i46 + 300 | 0;
 i35 = i46 + 320 | 0;
 i1 = i41;
 i4 = 0;
 i6 = 2;
 i7 = 3;
 i8 = 1;
 while (1) {
  f67 = Math_fround(f3 * Math_fround(f36 + Math_fround(i4 | 0)));
  f65 = Math_fround(f3 * Math_fround(f36 + Math_fround(i8 | 0)));
  f63 = Math_fround(f3 * Math_fround(f36 + Math_fround(i6 | 0)));
  f61 = Math_fround(f3 * Math_fround(f36 + Math_fround(i7 | 0)));
  f67 = (i4 | 0) < (i38 | 0) ? f67 : Math_fround(0.0);
  i2 = f67 < Math_fround(0.0);
  f67 = i2 ? Math_fround(0.0) : f67;
  f65 = (i8 | 0) < (i38 | 0) ? f65 : Math_fround(0.0);
  i2 = f65 < Math_fround(0.0);
  f65 = i2 ? Math_fround(0.0) : f65;
  f63 = (i6 | 0) < (i38 | 0) ? f63 : Math_fround(0.0);
  i2 = f63 < Math_fround(0.0);
  f63 = i2 ? Math_fround(0.0) : f63;
  f61 = (i7 | 0) < (i38 | 0) ? f61 : Math_fround(0.0);
  i2 = f61 < Math_fround(0.0);
  f61 = i2 ? Math_fround(0.0) : f61;
  i2 = f67 > Math_fround(1.0);
  f67 = i2 ? Math_fround(1.0) : f67;
  i2 = f65 > Math_fround(1.0);
  f65 = i2 ? Math_fround(1.0) : f65;
  i2 = f63 > Math_fround(1.0);
  f63 = i2 ? Math_fround(1.0) : f63;
  i2 = f61 > Math_fround(1.0);
  f61 = i2 ? Math_fround(1.0) : f61;
  f73 = Math_fround(f65 * f40);
  f74 = Math_fround(f63 * f40);
  f75 = Math_fround(f61 * f40);
  HEAPF32[i42 >> 2] = Math_fround(f67 * f40);
  HEAPF32[i10 >> 2] = f73;
  HEAPF32[i12 >> 2] = f74;
  HEAPF32[i13 >> 2] = f75;
  i2 = i1;
  i1 = i1 + 4 | 0;
  __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i37, i43, i45, i46, i2, i1, i42);
  f67 = Math_fround(Math_fround(f67 + f39) * f40);
  f65 = Math_fround(Math_fround(f65 + f39) * f40);
  f63 = Math_fround(Math_fround(f63 + f39) * f40);
  f61 = Math_fround(Math_fround(f61 + f39) * f40);
  f75 = Math_fround(f67 * f15);
  f74 = Math_fround(f65 * f15);
  f73 = Math_fround(f63 * f15);
  f72 = Math_fround(f61 * f15);
  f71 = Math_fround(f67 * f16);
  f70 = Math_fround(f65 * f16);
  f69 = Math_fround(f63 * f16);
  f68 = Math_fround(f61 * f16);
  f67 = Math_fround(f67 * f17);
  f65 = Math_fround(f65 * f17);
  f63 = Math_fround(f63 * f17);
  f61 = Math_fround(f61 * f17);
  i85 = (HEAP32[i46 >> 2] | 0) + (i2 << 2) | 0;
  f81 = Math_fround(HEAPF32[i85 >> 2]);
  f80 = Math_fround(HEAPF32[i85 + 4 >> 2]);
  f79 = Math_fround(HEAPF32[i85 + 8 >> 2]);
  f82 = Math_fround(HEAPF32[i85 + 12 >> 2]);
  i85 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f48 = Math_fround(HEAPF32[i85 >> 2]);
  f50 = Math_fround(HEAPF32[i85 + 4 >> 2]);
  f78 = Math_fround(HEAPF32[i85 + 8 >> 2]);
  f76 = Math_fround(HEAPF32[i85 + 12 >> 2]);
  i85 = (HEAP32[i18 >> 2] | 0) + (i2 << 2) | 0;
  f49 = Math_fround(HEAPF32[i85 >> 2]);
  f51 = Math_fround(HEAPF32[i85 + 4 >> 2]);
  f77 = Math_fround(HEAPF32[i85 + 8 >> 2]);
  f75 = Math_fround(f81 - f75);
  f74 = Math_fround(f80 - f74);
  f73 = Math_fround(f79 - f73);
  f72 = Math_fround(f82 - f72);
  f71 = Math_fround(f48 - f71);
  f70 = Math_fround(f50 - f70);
  f69 = Math_fround(f78 - f69);
  f68 = Math_fround(f76 - f68);
  f67 = Math_fround(f49 - f67);
  f65 = Math_fround(f51 - f65);
  f63 = Math_fround(f77 - f63);
  f61 = Math_fround(Math_fround(HEAPF32[i85 + 12 >> 2]) - f61);
  i85 = (HEAP32[i19 >> 2] | 0) + (i2 << 2) | 0;
  f77 = Math_fround(HEAPF32[i85 >> 2]);
  i84 = i85 + 4 | 0;
  f51 = Math_fround(HEAPF32[i84 >> 2]);
  i83 = i85 + 8 | 0;
  f49 = Math_fround(HEAPF32[i83 >> 2]);
  i11 = i85 + 12 | 0;
  f76 = Math_fround(HEAPF32[i11 >> 2]);
  f78 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) * Math_fround(100.0));
  f50 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(100.0));
  f48 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(100.0));
  f82 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(100.0));
  i86 = (HEAP32[i20 >> 2] | 0) + (i2 << 2) | 0;
  f79 = Math_fround(HEAPF32[i86 >> 2]);
  f80 = Math_fround(HEAPF32[i86 + 4 >> 2]);
  f81 = Math_fround(HEAPF32[i86 + 8 >> 2]);
  f80 = Math_fround(f51 + Math_fround(f50 * f80));
  f81 = Math_fround(f49 + Math_fround(f48 * f81));
  f82 = Math_fround(f76 + Math_fround(f82 * Math_fround(HEAPF32[i86 + 12 >> 2])));
  HEAPF32[i85 >> 2] = Math_fround(f77 + Math_fround(f78 * f79));
  HEAPF32[i84 >> 2] = f80;
  HEAPF32[i83 >> 2] = f81;
  HEAPF32[i11 >> 2] = f82;
  i11 = (HEAP32[i21 >> 2] | 0) + (i2 << 2) | 0;
  f82 = Math_fround(HEAPF32[i11 >> 2]);
  f81 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f80 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f79 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  i11 = (HEAP32[i22 >> 2] | 0) + (i2 << 2) | 0;
  f78 = Math_fround(HEAPF32[i11 >> 2]);
  f77 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f76 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f48 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  i11 = (HEAP32[i23 >> 2] | 0) + (i2 << 2) | 0;
  f49 = Math_fround(HEAPF32[i11 >> 2]);
  f50 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f60 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  i11 = (HEAP32[i24 >> 2] | 0) + (i2 << 2) | 0;
  f59 = Math_fround(HEAPF32[i11 >> 2]);
  f58 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f57 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f56 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  i11 = (HEAP32[i25 >> 2] | 0) + (i2 << 2) | 0;
  f55 = Math_fround(HEAPF32[i11 >> 2]);
  f54 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f53 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  i11 = (HEAP32[i26 >> 2] | 0) + (i2 << 2) | 0;
  f66 = Math_fround(HEAPF32[i11 >> 2]);
  f64 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f62 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f59 = Math_fround(f82 + f59);
  f58 = Math_fround(f81 + f58);
  f57 = Math_fround(f80 + f57);
  f56 = Math_fround(f79 + f56);
  f55 = Math_fround(f78 + f55);
  f54 = Math_fround(f77 + f54);
  f53 = Math_fround(f76 + f53);
  f52 = Math_fround(f48 + f52);
  f66 = Math_fround(f49 + f66);
  f64 = Math_fround(f50 + f64);
  f62 = Math_fround(f51 + f62);
  f60 = Math_fround(f60 + Math_fround(HEAPF32[i11 + 12 >> 2]));
  f51 = Math_fround(HEAPF32[i42 >> 2]);
  f59 = Math_fround(f59 * f51);
  f50 = Math_fround(HEAPF32[i10 >> 2]);
  f58 = Math_fround(f58 * f50);
  f49 = Math_fround(HEAPF32[i12 >> 2]);
  f57 = Math_fround(f57 * f49);
  f48 = Math_fround(HEAPF32[i13 >> 2]);
  f59 = Math_fround(f75 + f59);
  f58 = Math_fround(f74 + f58);
  f57 = Math_fround(f73 + f57);
  f56 = Math_fround(f72 + Math_fround(f56 * f48));
  f55 = Math_fround(f71 + Math_fround(f55 * f51));
  f54 = Math_fround(f70 + Math_fround(f54 * f50));
  f53 = Math_fround(f69 + Math_fround(f53 * f49));
  f52 = Math_fround(f68 + Math_fround(f52 * f48));
  f51 = Math_fround(f67 + Math_fround(f66 * f51));
  f50 = Math_fround(f65 + Math_fround(f64 * f50));
  f49 = Math_fround(f63 + Math_fround(f62 * f49));
  f48 = Math_fround(f61 + Math_fround(f60 * f48));
  i11 = (HEAP32[i46 >> 2] | 0) + (i2 << 2) | 0;
  HEAPF32[i11 >> 2] = f59;
  HEAPF32[i11 + 4 >> 2] = f58;
  HEAPF32[i11 + 8 >> 2] = f57;
  HEAPF32[i11 + 12 >> 2] = f56;
  i11 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  HEAPF32[i11 >> 2] = f55;
  HEAPF32[i11 + 4 >> 2] = f54;
  HEAPF32[i11 + 8 >> 2] = f53;
  HEAPF32[i11 + 12 >> 2] = f52;
  i11 = (HEAP32[i18 >> 2] | 0) + (i2 << 2) | 0;
  HEAPF32[i11 >> 2] = f51;
  HEAPF32[i11 + 4 >> 2] = f50;
  HEAPF32[i11 + 8 >> 2] = f49;
  HEAPF32[i11 + 12 >> 2] = f48;
  do if (HEAP8[i27 >> 0] | 0) if (!(HEAP8[i29 >> 0] | 0)) {
   i83 = (HEAP32[i30 >> 2] | 0) + (i2 << 2) | 0;
   f78 = Math_fround(HEAPF32[i83 >> 2]);
   f76 = Math_fround(HEAPF32[i83 + 4 >> 2]);
   f77 = Math_fround(HEAPF32[i83 + 8 >> 2]);
   f82 = Math_fround(HEAPF32[i83 + 12 >> 2]);
   f78 = Math_fround(f78 * Math_fround(HEAPF32[i42 >> 2]));
   f76 = Math_fround(f76 * Math_fround(HEAPF32[i10 >> 2]));
   f77 = Math_fround(f77 * Math_fround(HEAPF32[i12 >> 2]));
   f82 = Math_fround(f82 * Math_fround(HEAPF32[i13 >> 2]));
   i83 = (HEAP32[i31 >> 2] | 0) + (i2 << 2) | 0;
   f79 = Math_fround(HEAPF32[i83 >> 2]);
   i84 = i83 + 4 | 0;
   f80 = Math_fround(HEAPF32[i84 >> 2]);
   i85 = i83 + 8 | 0;
   f81 = Math_fround(HEAPF32[i85 >> 2]);
   i86 = i83 + 12 | 0;
   f80 = Math_fround(f76 + f80);
   f81 = Math_fround(f77 + f81);
   f82 = Math_fround(f82 + Math_fround(HEAPF32[i86 >> 2]));
   HEAPF32[i83 >> 2] = Math_fround(f78 + f79);
   HEAPF32[i84 >> 2] = f80;
   HEAPF32[i85 >> 2] = f81;
   HEAPF32[i86 >> 2] = f82;
   break;
  } else {
   i93 = (HEAP32[i32 >> 2] | 0) + (i2 << 2) | 0;
   f70 = Math_fround(HEAPF32[i93 >> 2]);
   f60 = Math_fround(HEAPF32[i93 + 4 >> 2]);
   f61 = Math_fround(HEAPF32[i93 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[i93 + 12 >> 2]);
   i93 = (HEAP32[i33 >> 2] | 0) + (i2 << 2) | 0;
   f63 = Math_fround(HEAPF32[i93 >> 2]);
   f64 = Math_fround(HEAPF32[i93 + 4 >> 2]);
   f65 = Math_fround(HEAPF32[i93 + 8 >> 2]);
   f66 = Math_fround(HEAPF32[i93 + 12 >> 2]);
   i93 = (HEAP32[i30 >> 2] | 0) + (i2 << 2) | 0;
   f74 = Math_fround(HEAPF32[i93 >> 2]);
   f73 = Math_fround(HEAPF32[i93 + 4 >> 2]);
   f72 = Math_fround(HEAPF32[i93 + 8 >> 2]);
   f71 = Math_fround(HEAPF32[i93 + 12 >> 2]);
   f67 = Math_fround(HEAPF32[i42 >> 2]);
   f70 = Math_fround(f70 * f67);
   f68 = Math_fround(HEAPF32[i10 >> 2]);
   f60 = Math_fround(f60 * f68);
   f69 = Math_fround(HEAPF32[i12 >> 2]);
   f61 = Math_fround(f61 * f69);
   f82 = Math_fround(HEAPF32[i13 >> 2]);
   f62 = Math_fround(f62 * f82);
   f63 = Math_fround(f63 * f67);
   f64 = Math_fround(f64 * f68);
   f65 = Math_fround(f65 * f69);
   f66 = Math_fround(f66 * f82);
   f67 = Math_fround(f74 * f67);
   f68 = Math_fround(f73 * f68);
   f69 = Math_fround(f72 * f69);
   f82 = Math_fround(f71 * f82);
   i93 = (HEAP32[i34 >> 2] | 0) + (i2 << 2) | 0;
   f71 = Math_fround(HEAPF32[i93 >> 2]);
   i92 = i93 + 4 | 0;
   f72 = Math_fround(HEAPF32[i92 >> 2]);
   i91 = i93 + 8 | 0;
   f73 = Math_fround(HEAPF32[i91 >> 2]);
   i90 = i93 + 12 | 0;
   f74 = Math_fround(HEAPF32[i90 >> 2]);
   i89 = (HEAP32[i35 >> 2] | 0) + (i2 << 2) | 0;
   f75 = Math_fround(HEAPF32[i89 >> 2]);
   i88 = i89 + 4 | 0;
   f76 = Math_fround(HEAPF32[i88 >> 2]);
   i87 = i89 + 8 | 0;
   f77 = Math_fround(HEAPF32[i87 >> 2]);
   i11 = i89 + 12 | 0;
   f78 = Math_fround(HEAPF32[i11 >> 2]);
   i83 = (HEAP32[i31 >> 2] | 0) + (i2 << 2) | 0;
   f79 = Math_fround(HEAPF32[i83 >> 2]);
   i84 = i83 + 4 | 0;
   f80 = Math_fround(HEAPF32[i84 >> 2]);
   i85 = i83 + 8 | 0;
   f81 = Math_fround(HEAPF32[i85 >> 2]);
   i86 = i83 + 12 | 0;
   f72 = Math_fround(f60 + f72);
   f73 = Math_fround(f61 + f73);
   f74 = Math_fround(f62 + f74);
   f75 = Math_fround(f63 + f75);
   f76 = Math_fround(f64 + f76);
   f77 = Math_fround(f65 + f77);
   f78 = Math_fround(f66 + f78);
   f79 = Math_fround(f67 + f79);
   f80 = Math_fround(f68 + f80);
   f81 = Math_fround(f69 + f81);
   f82 = Math_fround(f82 + Math_fround(HEAPF32[i86 >> 2]));
   HEAPF32[i93 >> 2] = Math_fround(f70 + f71);
   HEAPF32[i92 >> 2] = f72;
   HEAPF32[i91 >> 2] = f73;
   HEAPF32[i90 >> 2] = f74;
   HEAPF32[i89 >> 2] = f75;
   HEAPF32[i88 >> 2] = f76;
   HEAPF32[i87 >> 2] = f77;
   HEAPF32[i11 >> 2] = f78;
   HEAPF32[i83 >> 2] = f79;
   HEAPF32[i84 >> 2] = f80;
   HEAPF32[i85 >> 2] = f81;
   HEAPF32[i86 >> 2] = f82;
   break;
  } while (0);
  i11 = HEAP32[i28 >> 2] | 0;
  if (HEAP8[i11 + 4 >> 0] | 0) __ZNK9SubModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i11, i43, i45, i46, i2, i1, i42);
  if (i1 >>> 0 >= i5 >>> 0) break; else {
   i4 = i4 + 4 | 0;
   i6 = i6 + 4 | 0;
   i7 = i7 + 4 | 0;
   i8 = i8 + 4 | 0;
  }
 }
 if (!i9) {
  STACKTOP = i47;
  return;
 }
 i6 = i46 + 520 | 0;
 i7 = i45 + 428 | 0;
 i8 = i45 + 496 | 0;
 i9 = i42 + 4 | 0;
 i10 = i42 + 8 | 0;
 i11 = i42 + 12 | 0;
 i12 = i42 + 16 | 0;
 i13 = i42 + 20 | 0;
 i14 = i45 + 424 | 0;
 i1 = i41;
 L25 : while (1) {
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  while (1) {
   if (Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]) > Math_fround(100.0)) break;
   i1 = i2 + 1 | 0;
   if (i1 >>> 0 < i5 >>> 0) i2 = i1; else {
    i1 = 16;
    break L25;
   }
  }
  if (HEAP32[i7 >> 2] | 0) {
   i1 = 0;
   do {
    i93 = HEAP32[i8 >> 2] | 0;
    HEAPF32[i42 >> 2] = Math_fround(0.0);
    HEAPF32[i9 >> 2] = Math_fround(0.0);
    HEAP32[i10 >> 2] = i93;
    i93 = (Math_imul(i93, 1812433253) | 0) + 1 | 0;
    HEAP32[i11 >> 2] = i93;
    i93 = (Math_imul(i93, 1812433253) | 0) + 1 | 0;
    HEAP32[i12 >> 2] = i93;
    HEAP32[i13 >> 2] = (Math_imul(i93, 1812433253) | 0) + 1;
    __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i42, (HEAP32[i14 >> 2] | 0) + (i1 * 600 | 0) | 0, i43, i45, i46, 2, i1, i2, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
  i5 = i5 + -1 | 0;
  __ZN23ParticleSystemParticles14element_assignEjj(i46, i2, i5);
  i1 = HEAP32[i44 >> 2] | 0;
  if (i1 | 0) HEAP32[i44 >> 2] = i1 + -1;
  if (i2 >>> 0 >= i5 >>> 0) {
   i1 = 16;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == 16) {
  STACKTOP = i47;
  return;
 }
}

function __ZN15AudioReverbZone8TransferI14SafeBinaryReadEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i7, i10);
 i4 = i7 + 48 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864216 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864230 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 56 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864185 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864003 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864010 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864033 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864045 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864244 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864166 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864258 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864093 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864129 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864267 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864107 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864119 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i9 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i9 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864152 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i9 = 171; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i9 = 171;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i9 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 864143 | 0, i5, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i8 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i8 >>> 0) i9 = 182; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    i9 = 182;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i9 | 0) == 182) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (!(HEAP32[i10 >> 2] & 512)) break;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN13GfxDeviceGLES30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb(i5, i1, i31, i25, i12, i32) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 i25 = i25 | 0;
 i12 = i12 | 0;
 i32 = i32 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i36 + 24 | 0;
 i35 = i36 + 64 | 0;
 i33 = i36 + 40 | 0;
 i27 = i36;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  STACKTOP = i36;
  return;
 }
 if (!i32) {
  i1 = HEAP32[i31 + 16 >> 2] | 0;
  i2 = i31 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
  i1 = HEAP32[i31 + 28 >> 2] | 0;
  i2 = i31 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
  i1 = HEAP32[i31 + 40 >> 2] | 0;
  i2 = i31 + 44 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
  i1 = HEAP32[i31 + 52 >> 2] | 0;
  i2 = i31 + 56 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
 }
 i23 = i31 + 4 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i24 = i31 + 8 | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i2 + (~(((i2 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
 i3 = HEAP32[i4 >> 2] | 0;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(i5 + 6616 | 0, i3, 0, 0);
 HEAP32[i35 + 28 >> 2] = 0;
 HEAP32[i35 + 32 >> 2] = 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 HEAP32[i35 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
 i21 = i34;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i26 = i35 + 20 | 0;
 HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i26 + 4 >> 2] = i22;
 i26 = i35 + 36 | 0;
 i22 = i35 + 72 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i35 + 76 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i26 + 16 >> 2] = 0;
 HEAP32[i26 + 20 >> 2] = 0;
 HEAP32[i26 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
 i21 = i34;
 i28 = HEAP32[i21 + 4 >> 2] | 0;
 i11 = i35 + 64 | 0;
 HEAP32[i11 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i11 + 4 >> 2] = i28;
 i11 = i35 + 80 | 0;
 i28 = i35 + 104 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i35 + 108 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
 i21 = i34;
 i1 = HEAP32[i21 + 4 >> 2] | 0;
 i30 = i35 + 96 | 0;
 HEAP32[i30 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i30 + 4 >> 2] = i1;
 HEAP32[i35 + 112 >> 2] = 0;
 HEAP32[i35 + 116 >> 2] = 0;
 HEAP32[i35 + 120 >> 2] = 0;
 HEAP32[i35 + 124 >> 2] = -1;
 i30 = i35 + 128 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i35 + 144 >> 2] = -1;
 i30 = i35 + 148 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i35 + 164 >> 2] = -1;
 i30 = i35 + 168 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i35 + 184 >> 2] = -1;
 i30 = i35 + 188 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i35 + 204 >> 2] = -1;
 i30 = i35 + 208 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i35 + 224 >> 2] = -1;
 i30 = i35 + 228 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP8[i30 + 12 >> 0] = 0;
 HEAP32[i34 >> 2] = 0;
 i30 = i34 + 4 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet(i3, i35, i34);
 mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, 33383, i31 + 84 | 0);
 i3 = __ZNK20GpuProgramParameters14GetValueParamsEv(i35) | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i3 + 12 >> 2] | 0) * 20 | 0) | 0;
 i1 = HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i35) | 0) >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i33 + 4 | 0;
  i5 = i33 + 8 | 0;
  i6 = i33 + 12 | 0;
  i7 = i33 + 16 | 0;
  i8 = i33 + 20 | 0;
  i9 = i12 + 4 | 0;
  i10 = i12 + 8 | 0;
  do {
   HEAP32[i33 >> 2] = -1;
   HEAP32[i33 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i1 + 8 >> 2];
   i2 = HEAP16[i1 + 16 >> 1] | 0;
   HEAP32[i7 >> 2] = i2 & 255;
   HEAP32[i8 >> 2] = (i2 & 65535) >>> 8 & 65535;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i33); else {
    HEAP32[i2 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i33 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i33 + 20 >> 2];
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 24;
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i21 = HEAP32[i35 + 84 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i21 | 0)) {
  i9 = i33 + 8 | 0;
  i10 = i33 + 12 | 0;
  i11 = i33 + 16 | 0;
  i12 = i33 + 4 | 0;
  i13 = i27 + 4 | 0;
  i14 = i27 + 8 | 0;
  i15 = i27 + 12 | 0;
  i16 = i27 + 16 | 0;
  i17 = i27 + 20 | 0;
  i18 = i27 + 4 | 0;
  i19 = i27 + 8 | 0;
  i20 = i31 + 12 | 0;
  do {
   HEAP32[i33 >> 2] = -1;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i33 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i1 + 24 >> 2];
   i3 = __Z15FindOrAddByNameI15ComputeShaderCBERT_RNSt3__26vectorIS1_NS3_9allocatorIS1_EEEERKS1_(i25, i33) | 0;
   i6 = i3 + 8 | 0;
   i7 = i3 + 12 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i4 = i8;
   L33 : do if ((i8 | 0) == (HEAP32[i6 >> 2] | 0)) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i5 = HEAP32[i1 + 16 >> 2] | 0;
    i8 = i2 + (i5 * 20 | 0) | 0;
    if (i5 | 0) {
     i5 = i3 + 16 | 0;
     i3 = i4;
     while (1) {
      HEAP32[i27 >> 2] = -1;
      HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i2 + 12 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i15 >> 2] = HEAP32[i2 + 8 >> 2];
      i4 = HEAP16[i2 + 16 >> 1] | 0;
      HEAP32[i16 >> 2] = i4 & 255;
      HEAP32[i17 >> 2] = (i4 & 65535) >>> 8 & 65535;
      if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i6, i27); else {
       HEAP32[i3 >> 2] = HEAP32[i27 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
       HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 24;
      }
      i2 = i2 + 20 | 0;
      if ((i2 | 0) == (i8 | 0)) break L33;
      i3 = HEAP32[i7 >> 2] | 0;
     }
    }
   } while (0);
   HEAP32[i27 >> 2] = -1;
   HEAP32[i18 >> 2] = -1;
   HEAP32[i27 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i1 + 28 >> 2];
   i2 = HEAP32[i24 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i23, i27); else {
    HEAP32[i2 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
    HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 20;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   if (i2 | 0) {
    i4 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) != (i2 | 0)) HEAP32[i10 >> 2] = i4 + (~(((i4 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
    __ZdlPv(i2);
   }
   i1 = i1 + 52 | 0;
  } while ((i1 | 0) != (i21 | 0));
 }
 i1 = HEAP32[i35 + 60 >> 2] | 0;
 i25 = HEAP32[i22 >> 2] | 0;
 i10 = i1 + (i25 << 4) | 0;
 if (i25 | 0) {
  i11 = i31 + 40 | 0;
  i12 = i31 + 44 | 0;
  i13 = i31 + 52 | 0;
  i14 = i31 + 56 | 0;
  i15 = i33 + 4 | 0;
  i16 = i33 + 8 | 0;
  i17 = i33 + 12 | 0;
  i18 = i33 + 16 | 0;
  i19 = i31 + 48 | 0;
  do {
   L59 : do if (i32) {
    i8 = HEAP32[i11 >> 2] | 0;
    i25 = (HEAP32[i12 >> 2] | 0) - i8 | 0;
    i3 = (i25 | 0) / 20 | 0;
    L61 : do if (!i25) i2 = 0; else {
     i4 = HEAP32[i1 >> 2] | 0;
     i5 = i1 + 4 | 0;
     i6 = i1 + 8 | 0;
     i9 = i1 + 12 | 0;
     i7 = 0;
     while (1) {
      if ((HEAP32[i8 + (i7 * 20 | 0) >> 2] | 0) == (i4 | 0)) break;
      i2 = i7 + 1 | 0;
      if (i2 >>> 0 < i3 >>> 0) i7 = i2; else {
       i2 = 0;
       break L61;
      }
     }
     HEAP32[i8 + (i7 * 20 | 0) + 8 >> 2] = HEAP32[i5 >> 2];
     i2 = HEAP32[i6 >> 2] | 0;
     i3 = i8 + (i7 * 20 | 0) + 12 | 0;
     if ((i2 | 0) > -1) {
      HEAP32[i3 >> 2] = i2;
      HEAP32[i8 + (i7 * 20 | 0) + 16 >> 2] = HEAP32[i9 >> 2];
      i2 = 1;
      break;
     } else {
      HEAP32[i3 >> 2] = -1;
      HEAP32[i8 + (i7 * 20 | 0) + 16 >> 2] = -1;
      i2 = 1;
      break;
     }
    } while (0);
    i9 = HEAP32[i13 >> 2] | 0;
    i25 = (HEAP32[i14 >> 2] | 0) - i9 | 0;
    i7 = (i25 | 0) / 20 | 0;
    if (!((i25 | 0) == 0 | i2)) {
     i3 = HEAP32[i1 >> 2] | 0;
     i4 = i1 + 4 | 0;
     i5 = i1 + 8 | 0;
     i8 = i1 + 12 | 0;
     i6 = 0;
     while (1) {
      if ((HEAP32[i9 + (i6 * 20 | 0) >> 2] | 0) == (i3 | 0)) break;
      i2 = i6 + 1 | 0;
      if (i2 >>> 0 < i7 >>> 0) i6 = i2; else break L59;
     }
     HEAP32[i9 + (i6 * 20 | 0) + 8 >> 2] = HEAP32[i4 >> 2];
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i9 + (i6 * 20 | 0) + 12 | 0;
     if ((i2 | 0) > -1) {
      HEAP32[i3 >> 2] = i2;
      HEAP32[i9 + (i6 * 20 | 0) + 16 >> 2] = HEAP32[i8 >> 2];
      break;
     } else {
      HEAP32[i3 >> 2] = -1;
      HEAP32[i9 + (i6 * 20 | 0) + 16 >> 2] = -1;
      break;
     }
    }
   } else {
    HEAP32[i33 >> 2] = -1;
    HEAP32[i15 >> 2] = -1;
    HEAP32[i33 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i17 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i1 + 12 >> 2];
    i2 = HEAP32[i12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i19 >> 2] | 0)) __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i11, i33); else {
     HEAP32[i2 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i33 + 16 >> 2];
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 20;
    }
   } while (0);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i10 | 0));
 }
 L86 : do if (i32) {
  i8 = i31 + 16 | 0;
  i9 = i31 + 20 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   i10 = i35 + 40 | 0;
   i11 = i31 + 28 | 0;
   i12 = i31 + 32 | 0;
   i7 = (i1 >>> 0) / 20 | 0;
   while (1) {
    i6 = i7 + -1 | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i26 >> 2] | 0;
    L91 : do if ((i1 | 0) == (i3 | 0)) i29 = 67; else {
     i4 = HEAP32[i2 + (i6 * 20 | 0) + 4 >> 2] | 0;
     while (1) {
      if ((i4 | 0) == (HEAP32[i1 >> 2] | 0)) break;
      i1 = i1 + 16 | 0;
      if ((i1 | 0) == (i3 | 0)) {
       i29 = 67;
       break L91;
      }
     }
     i25 = i2 + (i6 * 20 | 0) + 8 | 0;
     i27 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] & -65536 | i27;
     HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 3) + 4 >> 2] = i27;
    } while (0);
    if ((i29 | 0) == 67) {
     i29 = 0;
     i3 = i2 + (i6 * 20 | 0) | 0;
     i1 = i3 + 20 | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     i4 = i2 - i1 | 0;
     if (i4) {
      _memmove(i3 | 0, i1 | 0, i4 | 0) | 0;
      i2 = HEAP32[i9 >> 2] | 0;
     }
     i1 = i3 + (((i4 | 0) / 20 | 0) * 20 | 0) | 0;
     if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
     i4 = (HEAP32[i11 >> 2] | 0) + (i6 << 3) | 0;
     i1 = i4 + 8 | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i3 = i2 - i1 | 0;
     i5 = i3 >> 3;
     if (i5) {
      _memmove(i4 | 0, i1 | 0, i3 | 0) | 0;
      i2 = HEAP32[i12 >> 2] | 0;
     }
     i1 = i4 + (i5 << 3) | 0;
     if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
    }
    if ((i7 | 0) <= 1) break L86;
    i7 = i6;
    i2 = HEAP32[i8 >> 2] | 0;
   }
  }
 } else {
  i12 = HEAP32[i35 + 40 >> 2] | 0;
  i1 = HEAP32[i26 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i3 = i33 + 4 | 0;
   i4 = i33 + 8 | 0;
   i5 = i31 + 20 | 0;
   i6 = i31 + 24 | 0;
   i7 = i31 + 16 | 0;
   i8 = i27 + 4 | 0;
   i9 = i31 + 32 | 0;
   i10 = i31 + 36 | 0;
   i11 = i31 + 28 | 0;
   do {
    HEAP32[i33 >> 2] = -1;
    HEAP32[i3 >> 2] = -1;
    HEAP32[i33 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
    i2 = HEAP32[i5 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i7, i33); else {
     HEAP32[i2 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i33 + 16 >> 2];
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 20;
    }
    HEAP32[i27 >> 2] = 4;
    HEAP32[i8 >> 2] = 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i11, i27); else {
     i25 = i27;
     i26 = HEAP32[i25 + 4 >> 2] | 0;
     i29 = i2;
     HEAP32[i29 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i29 + 4 >> 2] = i26;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 8;
    }
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 i2 = HEAP32[i35 + 92 >> 2] | 0;
 i29 = HEAP32[i28 >> 2] | 0;
 i8 = i2 + (i29 << 3) | 0;
 L124 : do if (i29 | 0) {
  i4 = i31 + 52 | 0;
  i7 = i31 + 56 | 0;
  i5 = i33 + 4 | 0;
  i6 = i33 + 8 | 0;
  i3 = i31 + 60 | 0;
  if (!i32) while (1) {
   HEAP32[i33 >> 2] = -1;
   HEAP32[i5 >> 2] = -1;
   HEAP32[i33 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i33); else {
    HEAP32[i1 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i33 + 16 >> 2];
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 20;
   }
   i2 = i2 + 8 | 0;
   if ((i2 | 0) == (i8 | 0)) break L124;
  }
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  i5 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
  i4 = (i5 | 0) / 20 | 0;
  i5 = (i5 | 0) == 0;
  do {
   L136 : do if (!i5) {
    i3 = HEAP32[i2 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0) == (i3 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L136;
    }
    HEAP32[i6 + (i1 * 20 | 0) + 8 >> 2] = HEAP32[i2 + 4 >> 2];
   } while (0);
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i8 | 0));
 } while (0);
 i1 = HEAP32[i34 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i30 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i30 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 __ZN20GpuProgramParametersD2Ev(i35);
 STACKTOP = i36;
 return;
}

function __ZN5physx11HullLibrary16CreateConvexHullERKNS_8HullDescERNS_10HullResultE(i25, i33, i32) {
 i25 = i25 | 0;
 i33 = i33 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i39 + 25 | 0;
 i35 = i39 + 24 | 0;
 i37 = i39;
 i26 = i39 + 22 | 0;
 i36 = i39 + 21 | 0;
 i38 = i39 + 20 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i37 + 16 >> 2] = 0;
 i15 = i33 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i39 + 23 | 0, i1 >>> 0 < 8 ? 96 : i1 * 12 | 0, gb + 730220 | 0, 2544) | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i33 + 12 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i33 + 16 >> 2]);
 if (!i15) i2 = 1; else {
  i13 = HEAP32[i33 + 8 >> 2] | 0;
  f12 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f10 = Math_fround(3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  i2 = 0;
  i3 = i13;
  while (1) {
   f30 = Math_fround(HEAPF32[i3 >> 2]);
   f12 = f30 < f12 ? f30 : f12;
   f8 = f30 > f8 ? f30 : f8;
   f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f10 = f30 < f10 ? f30 : f10;
   f5 = f30 > f5 ? f30 : f5;
   f30 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f9 = f30 < f9 ? f30 : f9;
   f7 = f30 > f7 ? f30 : f7;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i15 | 0)) break; else i3 = i3 + i16 | 0;
  }
  f8 = Math_fround(f8 - f12);
  f5 = Math_fround(f5 - f10);
  f7 = Math_fround(f7 - f9);
  f12 = Math_fround(f12 + Math_fround(f8 * Math_fround(.5)));
  f17 = Math_fround(f10 + Math_fround(f5 * Math_fround(.5)));
  f18 = Math_fround(f9 + Math_fround(f7 * Math_fround(.5)));
  i2 = f8 < Math_fround(9.99999997e-07);
  i3 = f5 < Math_fround(9.99999997e-07);
  i4 = f7 < Math_fround(9.99999997e-07);
  do if (i15 >>> 0 < 3 | (i2 | i3 | i4)) {
   i28 = f8 > Math_fround(9.99999997e-07) & f8 < Math_fround(3402823469999999843913219.0e14);
   f9 = i28 ? f8 : Math_fround(3402823469999999843913219.0e14);
   i28 = f5 > Math_fround(9.99999997e-07) & f5 < f9;
   f9 = i28 ? f5 : f9;
   i28 = f7 > Math_fround(9.99999997e-07) & f7 < f9;
   f9 = i28 ? f7 : f9;
   if (f9 == Math_fround(3402823469999999843913219.0e14)) {
    f9 = Math_fround(.0199999996);
    f8 = Math_fround(.0199999996);
    f5 = Math_fround(.0199999996);
   } else {
    f10 = Math_fround(f9 * Math_fround(.100000001));
    f9 = i2 ? f10 : f8;
    f8 = i3 ? f10 : f5;
    if (i4) f5 = f10; else f5 = f7;
   }
   f30 = Math_fround(f9 * Math_fround(.5));
   f31 = Math_fround(f12 - f30);
   f30 = Math_fround(f12 + f30);
   f7 = Math_fround(f8 * Math_fround(.5));
   f29 = Math_fround(f17 - f7);
   f7 = Math_fround(f17 + f7);
   f8 = Math_fround(f5 * Math_fround(.5));
   f5 = Math_fround(f18 - f8);
   f8 = Math_fround(f18 + f8);
   HEAPF32[i1 >> 2] = f31;
   HEAPF32[i1 + 4 >> 2] = f29;
   HEAPF32[i1 + 8 >> 2] = f5;
   HEAPF32[i1 + 12 >> 2] = f30;
   HEAPF32[i1 + 16 >> 2] = f29;
   HEAPF32[i1 + 20 >> 2] = f5;
   HEAPF32[i1 + 24 >> 2] = f30;
   HEAPF32[i1 + 28 >> 2] = f7;
   HEAPF32[i1 + 32 >> 2] = f5;
   HEAPF32[i1 + 36 >> 2] = f31;
   HEAPF32[i1 + 40 >> 2] = f7;
   HEAPF32[i1 + 44 >> 2] = f5;
   HEAPF32[i1 + 48 >> 2] = f31;
   HEAPF32[i1 + 52 >> 2] = f29;
   HEAPF32[i1 + 56 >> 2] = f8;
   HEAPF32[i1 + 60 >> 2] = f30;
   HEAPF32[i1 + 64 >> 2] = f29;
   HEAPF32[i1 + 68 >> 2] = f8;
   HEAPF32[i1 + 72 >> 2] = f30;
   HEAPF32[i1 + 76 >> 2] = f7;
   HEAPF32[i1 + 80 >> 2] = f8;
   HEAPF32[i1 + 84 >> 2] = f31;
   HEAPF32[i1 + 88 >> 2] = f7;
   HEAPF32[i1 + 92 >> 2] = f8;
   f8 = Math_fround(1.0);
   i2 = 8;
   f7 = Math_fround(1.0);
   f5 = Math_fround(1.0);
   i24 = 27;
  } else {
   f23 = Math_fround(Math_fround(1.0) / f8);
   f29 = Math_fround(Math_fround(1.0) / f5);
   f30 = Math_fround(Math_fround(1.0) / f7);
   f22 = Math_fround(f12 * f23);
   f21 = Math_fround(f17 * f29);
   f20 = Math_fround(f18 * f30);
   i2 = 0;
   i14 = 0;
   do {
    f17 = Math_fround(HEAPF32[i13 >> 2]);
    f18 = Math_fround(HEAPF32[i13 + 4 >> 2]);
    f17 = Math_fround(f23 * f17);
    f18 = Math_fround(f29 * f18);
    f19 = Math_fround(f30 * Math_fround(HEAPF32[i13 + 8 >> 2]));
    i13 = i13 + i16 | 0;
    L15 : do if (!i2) i3 = 0; else {
     i3 = 0;
     while (1) {
      i11 = i3 * 3 | 0;
      i4 = i1 + (i11 << 2) | 0;
      f10 = Math_fround(HEAPF32[i4 >> 2]);
      i6 = i1 + (i11 + 1 << 2) | 0;
      i11 = i1 + (i11 + 2 << 2) | 0;
      f12 = Math_fround(HEAPF32[i11 >> 2]);
      if (Math_fround(Math_abs(Math_fround(f10 - f17))) < f31) {
       f40 = Math_fround(Math_abs(Math_fround(f12 - f19)));
       f9 = Math_fround(HEAPF32[i6 >> 2]);
       if (f40 < f31 ? Math_fround(Math_abs(Math_fround(f9 - f18))) < f31 : 0) break;
      }
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= i2 >>> 0) break L15;
     }
     f42 = Math_fround(f17 - f22);
     f41 = Math_fround(f18 - f21);
     f43 = Math_fround(f19 - f20);
     f10 = Math_fround(f10 - f22);
     f40 = Math_fround(f9 - f21);
     f12 = Math_fround(f12 - f20);
     if (Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f42 * f42) + Math_fround(f41 * f41))) > Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f10 * f10) + Math_fround(f40 * f40)))) {
      HEAPF32[i4 >> 2] = f17;
      HEAPF32[i6 >> 2] = f18;
      HEAPF32[i11 >> 2] = f19;
     }
    } while (0);
    if ((i3 | 0) == (i2 | 0)) {
     i28 = i2 * 3 | 0;
     HEAPF32[i1 + (i28 << 2) >> 2] = f17;
     HEAPF32[i1 + (i28 + 1 << 2) >> 2] = f18;
     HEAPF32[i1 + (i28 + 2 << 2) >> 2] = f19;
     i2 = i2 + 1 | 0;
    }
    i14 = i14 + 1 | 0;
   } while ((i14 | 0) != (i15 | 0));
   if (!i2) {
    i11 = 0;
    f17 = Math_fround(-3402823469999999843913219.0e14);
    f12 = Math_fround(3402823469999999843913219.0e14);
    f10 = Math_fround(-3402823469999999843913219.0e14);
    f18 = Math_fround(3402823469999999843913219.0e14);
    f9 = Math_fround(-3402823469999999843913219.0e14);
    f19 = Math_fround(3402823469999999843913219.0e14);
   } else {
    f12 = Math_fround(3402823469999999843913219.0e14);
    f17 = Math_fround(-3402823469999999843913219.0e14);
    f18 = Math_fround(3402823469999999843913219.0e14);
    f10 = Math_fround(-3402823469999999843913219.0e14);
    f19 = Math_fround(3402823469999999843913219.0e14);
    f9 = Math_fround(-3402823469999999843913219.0e14);
    i3 = 0;
    do {
     i28 = i3 * 3 | 0;
     f43 = Math_fround(HEAPF32[i1 + (i28 << 2) >> 2]);
     f12 = f43 < f12 ? f43 : f12;
     f17 = f43 > f17 ? f43 : f17;
     f43 = Math_fround(HEAPF32[i1 + (i28 + 1 << 2) >> 2]);
     f18 = f43 < f18 ? f43 : f18;
     f10 = f43 > f10 ? f43 : f10;
     f43 = Math_fround(HEAPF32[i1 + (i28 + 2 << 2) >> 2]);
     f19 = f43 < f19 ? f43 : f19;
     f9 = f43 > f9 ? f43 : f9;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i2 | 0));
    i11 = i2;
   }
   f22 = Math_fround(f17 - f12);
   f23 = Math_fround(f10 - f18);
   f9 = Math_fround(f9 - f19);
   i3 = f22 < Math_fround(9.99999997e-07);
   i4 = f23 < Math_fround(9.99999997e-07);
   i6 = f9 < Math_fround(9.99999997e-07);
   if (!(i11 >>> 0 < 3 | (i6 | (i4 | i3)))) if (!i2) {
    i2 = 0;
    break;
   } else {
    i24 = 27;
    break;
   }
   f21 = Math_fround(f12 + Math_fround(f22 * Math_fround(.5)));
   f20 = Math_fround(f18 + Math_fround(f23 * Math_fround(.5)));
   f18 = Math_fround(f19 + Math_fround(f9 * Math_fround(.5)));
   i28 = f22 >= Math_fround(9.99999997e-07) & f22 < Math_fround(3402823469999999843913219.0e14);
   f10 = i28 ? f22 : Math_fround(3402823469999999843913219.0e14);
   i28 = f23 >= Math_fround(9.99999997e-07) & f23 < f10;
   f10 = i28 ? f23 : f10;
   i28 = f9 >= Math_fround(9.99999997e-07) & f9 < f10;
   f10 = i28 ? f9 : f10;
   if (f10 == Math_fround(3402823469999999843913219.0e14)) {
    f12 = Math_fround(.0199999996);
    f10 = Math_fround(.0199999996);
    f9 = Math_fround(.0199999996);
   } else {
    f17 = Math_fround(f10 * Math_fround(.100000001));
    f12 = i3 ? f17 : f22;
    f10 = i4 ? f17 : f23;
    if (i6) f9 = f17;
   }
   f40 = Math_fround(f12 * Math_fround(.5));
   f41 = Math_fround(f21 - f40);
   f40 = Math_fround(f21 + f40);
   f42 = Math_fround(f10 * Math_fround(.5));
   f31 = Math_fround(f20 - f42);
   f42 = Math_fround(f20 + f42);
   f43 = Math_fround(f9 * Math_fround(.5));
   f30 = Math_fround(f18 - f43);
   f43 = Math_fround(f18 + f43);
   HEAPF32[i1 >> 2] = f41;
   HEAPF32[i1 + 4 >> 2] = f31;
   HEAPF32[i1 + 8 >> 2] = f30;
   HEAPF32[i1 + 12 >> 2] = f40;
   HEAPF32[i1 + 16 >> 2] = f31;
   HEAPF32[i1 + 20 >> 2] = f30;
   HEAPF32[i1 + 24 >> 2] = f40;
   HEAPF32[i1 + 28 >> 2] = f42;
   HEAPF32[i1 + 32 >> 2] = f30;
   HEAPF32[i1 + 36 >> 2] = f41;
   HEAPF32[i1 + 40 >> 2] = f42;
   HEAPF32[i1 + 44 >> 2] = f30;
   HEAPF32[i1 + 48 >> 2] = f41;
   HEAPF32[i1 + 52 >> 2] = f31;
   HEAPF32[i1 + 56 >> 2] = f43;
   HEAPF32[i1 + 60 >> 2] = f40;
   HEAPF32[i1 + 64 >> 2] = f31;
   HEAPF32[i1 + 68 >> 2] = f43;
   HEAPF32[i1 + 72 >> 2] = f40;
   HEAPF32[i1 + 76 >> 2] = f42;
   HEAPF32[i1 + 80 >> 2] = f43;
   HEAPF32[i1 + 84 >> 2] = f41;
   HEAPF32[i1 + 88 >> 2] = f42;
   HEAPF32[i1 + 92 >> 2] = f43;
   i2 = 8;
   i24 = 27;
  } while (0);
  if ((i24 | 0) == 27) {
   i3 = 0;
   do {
    i28 = i3 * 3 | 0;
    i27 = i1 + (i28 << 2) | 0;
    HEAPF32[i27 >> 2] = Math_fround(f8 * Math_fround(HEAPF32[i27 >> 2]));
    i27 = i1 + (i28 + 1 << 2) | 0;
    HEAPF32[i27 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
    i28 = i1 + (i28 + 2 << 2) | 0;
    HEAPF32[i28 >> 2] = Math_fround(f7 * Math_fround(HEAPF32[i28 >> 2]));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i2 | 0));
  }
  f42 = Math_fround(HEAPF32[i33 + 20 >> 2]);
  f42 = HEAP32[i33 >> 2] & 4 | 0 ? f42 : Math_fround(0.0);
  f43 = Math_fround(HEAPF32[i33 + 24 >> 2]);
  i2 = __ZN5physx11HullLibrary11ComputeHullEjPKfRNS_11PHullResultEjff(i25, i2, i1, i37, HEAP32[i33 + 28 >> 2] | 0, f42, f43) | 0;
  if (!i2) {
   i3 = HEAP32[i37 >> 2] | 0;
   i25 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26, i3 * 12 | 0, gb + 730220 | 0, 2575) | 0;
   i26 = i37 + 12 | 0;
   i14 = HEAP32[i26 >> 2] | 0;
   i27 = i37 + 16 | 0;
   i15 = HEAP32[i27 >> 2] | 0;
   i28 = i37 + 4 | 0;
   i24 = HEAP32[i28 >> 2] | 0;
   i2 = i3 >>> 0 > 1073741823 ? -1 : i3 << 2;
   if (!i2) i16 = 0; else {
    i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
    i16 = _PxGetFoundation() | 0;
    i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
    i16 = mftCall_iiiiii(i11 | 0, i13 | 0, i2 | 0, (i16 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 2236) | 0;
   }
   _memset(i16 | 0, 0, i3 << 2 | 0) | 0;
   if (!i24) i13 = 0; else {
    i2 = 0;
    i13 = 0;
    do {
     i3 = i15 + (i13 << 2) | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     i6 = i16 + (i4 << 2) | 0;
     i11 = HEAP32[i6 >> 2] | 0;
     if (!i11) {
      HEAP32[i3 >> 2] = i2;
      i4 = i4 * 3 | 0;
      i11 = i2 * 3 | 0;
      HEAP32[i25 + (i11 << 2) >> 2] = HEAP32[i14 + (i4 << 2) >> 2];
      HEAP32[i25 + (i11 + 1 << 2) >> 2] = HEAP32[i14 + (i4 + 1 << 2) >> 2];
      HEAP32[i25 + (i11 + 2 << 2) >> 2] = HEAP32[i14 + (i4 + 2 << 2) >> 2];
      i2 = i2 + 1 | 0;
      HEAP32[i6 >> 2] = i2;
     } else HEAP32[i3 >> 2] = i11 + -1;
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) != (i24 | 0));
    i13 = i2;
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i34, i16);
   do if (!(HEAP32[i33 >> 2] & 1)) {
    HEAP8[i32 >> 0] = 1;
    HEAP32[i32 + 4 >> 2] = i13;
    i2 = i13 * 3 | 0;
    i2 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
    if (!i2) i3 = 0; else {
     i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
     i3 = _PxGetFoundation() | 0;
     i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
     i3 = mftCall_iiiiii(i15 | 0, i16 | 0, i2 | 0, (i3 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 2615) | 0;
    }
    i4 = i32 + 8 | 0;
    HEAP32[i4 >> 2] = i3;
    i11 = i37 + 8 | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i32 + 12 >> 2] = i2;
    i2 = i2 + i24 | 0;
    HEAP32[i32 + 16 >> 2] = i2;
    i2 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
    if (!i2) i6 = 0; else {
     i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i24 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
     i6 = _PxGetFoundation() | 0;
     i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
     i6 = mftCall_iiiiii(i24 | 0, i3 | 0, i2 | 0, (i6 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 2618) | 0;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    i2 = i32 + 20 | 0;
    HEAP32[i2 >> 2] = i6;
    _memcpy(i3 | 0, i25 | 0, i13 * 12 | 0) | 0;
    if (HEAP32[i11 >> 2] | 0) {
     i3 = HEAP32[i2 >> 2] | 0;
     i4 = 0;
     i6 = HEAP32[i27 >> 2] | 0;
     while (1) {
      HEAP32[i3 >> 2] = 3;
      if (!(HEAP32[i33 >> 2] & 2)) {
       HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 4 >> 2];
       i2 = i6 + 8 | 0;
      } else {
       HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 8 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 4 >> 2];
       i2 = i6;
      }
      HEAP32[i3 + 12 >> 2] = HEAP32[i2 >> 2];
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else {
       i3 = i3 + 16 | 0;
       i6 = i6 + 12 | 0;
      }
     }
    }
   } else {
    HEAP8[i32 >> 0] = 0;
    HEAP32[i32 + 4 >> 2] = i13;
    i2 = i13 * 3 | 0;
    i2 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
    if (!i2) i3 = 0; else {
     i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
     i3 = _PxGetFoundation() | 0;
     i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
     i3 = mftCall_iiiiii(i15 | 0, i16 | 0, i2 | 0, (i3 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 2584) | 0;
    }
    i4 = i32 + 8 | 0;
    HEAP32[i4 >> 2] = i3;
    i11 = i37 + 8 | 0;
    HEAP32[i32 + 12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i32 + 16 >> 2] = i24;
    i2 = i24 >>> 0 > 1073741823 ? -1 : i24 << 2;
    if (!i2) i6 = 0; else {
     i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i24 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
     i6 = _PxGetFoundation() | 0;
     i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
     i6 = mftCall_iiiiii(i24 | 0, i3 | 0, i2 | 0, (i6 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 2588) | 0;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    i2 = i32 + 20 | 0;
    HEAP32[i2 >> 2] = i6;
    _memcpy(i3 | 0, i25 | 0, i13 * 12 | 0) | 0;
    if (!(HEAP32[i33 >> 2] & 2)) {
     _memcpy(HEAP32[i2 >> 2] | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] << 2 | 0) | 0;
     break;
    }
    if (HEAP32[i11 >> 2] | 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i3 = 0;
     i4 = HEAP32[i27 >> 2] | 0;
     while (1) {
      HEAP32[i2 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i4 >> 2];
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break; else {
       i2 = i2 + 12 | 0;
       i4 = i4 + 12 | 0;
      }
     }
    }
   } while (0);
   i33 = HEAP32[i26 >> 2] | 0;
   i1 = (i33 | 0) == (i1 | 0) ? 0 : i1;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i34, HEAP32[i27 >> 2] | 0);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i35, i33);
   HEAP32[i37 >> 2] = 0;
   HEAP32[i28 >> 2] = 0;
   i37 = i26;
   HEAP32[i37 >> 2] = 0;
   HEAP32[i37 + 4 >> 2] = 0;
   if (!i25) i2 = 0; else {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i36, i25);
    i2 = 0;
   }
  }
 }
 if (!i1) {
  STACKTOP = i39;
  return i2 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i1);
 STACKTOP = i39;
 return i2 | 0;
}

function __Z25CalculateFocusedLightHullPK8Vector3fRS0_RK10MinMaxAABBR13dynamic_arrayIS_Lj4EE(i1, i19, i41, i42) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 9712 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i47 + 112 | 0;
 i17 = i47 + 9328 | 0;
 i18 = i47 + 16 | 0;
 i22 = i47 + 8 | 0;
 i21 = i47;
 i45 = i41 + 4 | 0;
 f39 = Math_fround(-Math_fround(HEAPF32[i45 >> 2]));
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 12 >> 2] = f39;
 i40 = i41 + 16 | 0;
 i43 = HEAP32[i40 >> 2] | 0;
 HEAPF32[i18 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i18 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i18 + 28 >> 2] = i43;
 f39 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 HEAPF32[i18 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i18 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 44 >> 2] = f39;
 i43 = HEAP32[i41 + 12 >> 2] | 0;
 HEAPF32[i18 + 48 >> 2] = Math_fround(-1.0);
 HEAPF32[i18 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 56 >> 2] = Math_fround(0.0);
 HEAP32[i18 + 60 >> 2] = i43;
 i43 = i41 + 8 | 0;
 f39 = Math_fround(-Math_fround(HEAPF32[i43 >> 2]));
 HEAPF32[i18 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i18 + 76 >> 2] = f39;
 i44 = i41 + 20 | 0;
 i10 = HEAP32[i44 >> 2] | 0;
 HEAPF32[i18 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 88 >> 2] = Math_fround(-1.0);
 HEAP32[i18 + 92 >> 2] = i10;
 HEAP32[i22 >> 2] = i16;
 HEAP32[i22 + 4 >> 2] = i16 + 3072;
 HEAP32[i21 >> 2] = i17;
 HEAP32[i21 + 4 >> 2] = i17 + 128;
 HEAP8[i17 >> 0] = 4;
 HEAP8[i17 + 1 >> 0] = 4;
 HEAP8[i17 + 2 >> 0] = 4;
 HEAP8[i17 + 3 >> 0] = 4;
 HEAP8[i17 + 4 >> 0] = 4;
 HEAP8[i17 + 5 >> 0] = 4;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i10 = i16 + 12 | 0;
 i32 = i1 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 i10 = i16 + 24 | 0;
 i2 = i1 + 24 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i10 = i16 + 36 | 0;
 i14 = i1 + 36 | 0;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i10 = i16 + 48 | 0;
 i15 = i1 + 84 | 0;
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i10 = i16 + 60 | 0;
 i35 = i1 + 72 | 0;
 HEAP32[i10 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 i10 = i16 + 72 | 0;
 i31 = i1 + 60 | 0;
 HEAP32[i10 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i10 = i16 + 84 | 0;
 i30 = i1 + 48 | 0;
 HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 i10 = i16 + 96 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i10 = i16 + 108 | 0;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i10 = i16 + 120 | 0;
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i10 = i16 + 132 | 0;
 HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 i10 = i16 + 144 | 0;
 HEAP32[i10 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 i10 = i16 + 156 | 0;
 HEAP32[i10 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i10 = i16 + 168 | 0;
 HEAP32[i10 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 i10 = i16 + 180 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i10 = i16 + 192 | 0;
 HEAP32[i10 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 i10 = i16 + 204 | 0;
 HEAP32[i10 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i10 = i16 + 216 | 0;
 HEAP32[i10 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 i10 = i16 + 228 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i10 = i16 + 240 | 0;
 HEAP32[i10 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 i10 = i16 + 252 | 0;
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i10 = i16 + 264 | 0;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i10 = i16 + 276 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i16 = i16 + 6144 | 0;
 i17 = i17 + 256 | 0;
 i10 = 6;
 i2 = 0;
 i14 = 0;
 i15 = 0;
 while (1) {
  i5 = HEAP32[i22 + (i14 << 2) >> 2] | 0;
  i3 = i14;
  i14 = 1 - i14 | 0;
  i4 = HEAP32[i22 + (i14 << 2) >> 2] | 0;
  i3 = HEAP32[i21 + (i3 << 2) >> 2] | 0;
  i1 = HEAP32[i21 + (i14 << 2) >> 2] | 0;
  HEAP8[i17 >> 0] = 0;
  if (!i10) {
   i4 = i2;
   i3 = 0;
  } else {
   i9 = i18 + (i15 << 4) | 0;
   i8 = i3;
   i7 = 0;
   i3 = i10;
   while (1) {
    i6 = HEAP8[i8 >> 0] | 0;
    if (__Z16ClipPolysByPlanehPK8Vector3fRK5PlanePhPS_S5_S6_(i6, i5, i9, i1, i4, i17, i16) | 0) {
     i35 = HEAPU8[i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i4 = i4 + (i35 * 12 | 0) | 0;
     i2 = i35 + i2 | 0;
    } else {
     i3 = i3 + -1 | 0;
     if (!i3) {
      i5 = i1;
      i3 = 0;
      break;
     }
    }
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i10 >>> 0) {
     i5 = i1;
     break;
    } else {
     i8 = i8 + 1 | 0;
     i5 = i5 + ((i6 & 255) * 12 | 0) | 0;
    }
   }
   i1 = HEAP8[i17 >> 0] | 0;
   if ((i15 | 0) < 5 & i1 << 24 >> 24 != 0) {
    HEAP8[i5 >> 0] = i1;
    _memcpy(i4 | 0, i16 | 0, (i1 & 255) * 12 | 0) | 0;
    i4 = i2;
    i3 = i3 + 1 | 0;
   } else i4 = i2;
  }
  i15 = i15 + 1 | 0;
  if ((i15 | 0) == 6) break; else {
   i10 = i3;
   i2 = i4;
  }
 }
 if (!i3) {
  STACKTOP = i47;
  return;
 }
 f36 = Math_fround(HEAPF32[i19 >> 2]);
 f37 = Math_fround(-f36);
 f38 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f39 = Math_fround(-f38);
 f33 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f34 = Math_fround(-f33);
 i1 = i4 << 1;
 i35 = i42 + 16 | 0;
 i2 = HEAP32[i35 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i35 >> 2] = i1;
  HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i4 * 24 | 0, 4, i42 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 24 | 0, 4, i42 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i32 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i42 + 12 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i35 >> 2] = i1;
  HEAP32[i42 >> 2] = i32;
  break;
 } while (0);
 i19 = i42 + 12 | 0;
 i25 = i42 + 4 | 0;
 i26 = f33 < Math_fround(-1.00000001e-10);
 i27 = f33 > Math_fround(1.00000001e-10);
 i28 = f38 < Math_fround(-1.00000001e-10);
 i29 = f38 > Math_fround(1.00000001e-10);
 i30 = f36 < Math_fround(-1.00000001e-10);
 i31 = i41 + 12 | 0;
 i32 = f36 > Math_fround(1.00000001e-10);
 i18 = HEAP32[i21 >> 2] | 0;
 i15 = HEAP32[i22 >> 2] | 0;
 i16 = 0;
 i1 = 0;
 i4 = 0;
 i2 = 0;
 while (1) {
  i17 = HEAP8[i18 >> 0] | 0;
  i18 = i18 + 1 | 0;
  if (i17 << 24 >> 24) {
   i9 = HEAP32[i19 >> 2] | 0;
   i14 = 0;
   while (1) {
    i8 = i15 + (i14 * 12 | 0) | 0;
    i10 = i9 + 1 | 0;
    i6 = HEAP32[i35 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i10 >>> 0 > i7 >>> 0) {
     i5 = i6 << 1;
     i5 = (i5 | 0) == 0 ? 1 : i5;
     if (i7 >>> 0 < i5 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i35 >> 2] = i5;
      HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i5 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i22 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i35 >> 2] = i5;
      HEAP32[i42 >> 2] = i22;
      break;
     }
    } while (0);
    HEAP32[i19 >> 2] = i10;
    i5 = HEAP32[i42 >> 2] | 0;
    HEAP32[i5 + (i9 * 12 | 0) >> 2] = HEAP32[i8 >> 2];
    i6 = i15 + (i14 * 12 | 0) + 4 | 0;
    HEAP32[i5 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i6 >> 2];
    i22 = i15 + (i14 * 12 | 0) + 8 | 0;
    HEAP32[i5 + (i9 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    f24 = Math_fround(HEAPF32[i22 >> 2]);
    f11 = Math_fround(f24 - Math_fround(HEAPF32[i43 >> 2]));
    do if (i26) {
     f11 = Math_fround(f11 / f33);
     if (f11 > Math_fround(1000000019999999998489706.0e6)) i5 = i10; else {
      i22 = f11 > Math_fround(0.0);
      f11 = i22 ? f11 : Math_fround(0.0);
      f12 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f24);
      if (i27) {
       f13 = Math_fround(1000000019999999998489706.0e6);
       i46 = 32;
      } else {
       f12 = Math_fround(f12 / f34);
       if (f12 < f11) i5 = i10; else if (f12 < Math_fround(1000000019999999998489706.0e6)) i46 = 39; else {
        f12 = Math_fround(1000000019999999998489706.0e6);
        i46 = 39;
       }
      }
     }
    } else if (i27) {
     f11 = Math_fround(f11 / f33);
     if (f11 < Math_fround(0.0)) {
      i5 = i10;
      break;
     }
     i46 = f11 < Math_fround(1000000019999999998489706.0e6);
     f13 = i46 ? f11 : Math_fround(1000000019999999998489706.0e6);
     f11 = Math_fround(0.0);
     f12 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f24);
     i46 = 32;
     break;
    } else {
     if (!(f11 >= Math_fround(0.0))) {
      i5 = i10;
      break;
     }
     if (!(Math_fround(Math_fround(HEAPF32[i44 >> 2]) - f24) >= Math_fround(0.0))) {
      i5 = i10;
      break;
     } else {
      f11 = Math_fround(0.0);
      f12 = Math_fround(1000000019999999998489706.0e6);
      i46 = 39;
      break;
     }
    } while (0);
    if ((i46 | 0) == 32) {
     i46 = 0;
     f12 = Math_fround(f12 / f34);
     if (f12 > f13) i5 = i10; else if (f12 > f11) {
      f11 = f12;
      f12 = f13;
      i46 = 39;
     } else {
      f12 = f13;
      i46 = 39;
     }
    }
    L53 : do if ((i46 | 0) == 39) {
     i46 = 0;
     f23 = Math_fround(HEAPF32[i6 >> 2]);
     f13 = Math_fround(f23 - Math_fround(HEAPF32[i45 >> 2]));
     do if (i28) {
      f13 = Math_fround(f13 / f38);
      if (f13 > f12) {
       i5 = i10;
       break L53;
      }
      f11 = f13 > f11 ? f13 : f11;
      f13 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f23);
      if (i29) i46 = 46; else {
       f13 = Math_fround(f13 / f39);
       if (f13 < f11) {
        i5 = i10;
        break L53;
       }
       if (f13 < f12) f12 = f13;
      }
     } else if (i29) {
      f13 = Math_fround(f13 / f38);
      if (f13 < f11) {
       i5 = i10;
       break L53;
      }
      f12 = f13 < f12 ? f13 : f12;
      f13 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f23);
      i46 = 46;
      break;
     } else {
      if (!(f13 >= Math_fround(0.0))) {
       i5 = i10;
       break L53;
      }
      if (!(Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f23) >= Math_fround(0.0))) {
       i5 = i10;
       break L53;
      } else break;
     } while (0);
     if ((i46 | 0) == 46) {
      i46 = 0;
      f13 = Math_fround(f13 / f39);
      if (f13 > f12) {
       i5 = i10;
       break;
      }
      if (f13 > f11) f11 = f13;
     }
     f20 = Math_fround(HEAPF32[i8 >> 2]);
     f13 = Math_fround(f20 - Math_fround(HEAPF32[i41 >> 2]));
     do if (i30) {
      f13 = Math_fround(f13 / f36);
      if (f13 > f12) {
       i5 = i10;
       break L53;
      }
      f11 = f13 > f11 ? f13 : f11;
      f13 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f20);
      if (i32) i46 = 60; else {
       f13 = Math_fround(f13 / f37);
       if (f13 < f11) {
        i5 = i10;
        break L53;
       }
       if (f13 < f12) f12 = f13;
      }
     } else if (i32) {
      f13 = Math_fround(f13 / f36);
      if (f13 < f11) {
       i5 = i10;
       break L53;
      }
      f12 = f13 < f12 ? f13 : f12;
      f13 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f20);
      i46 = 60;
      break;
     } else {
      if (!(f13 >= Math_fround(0.0))) {
       i5 = i10;
       break L53;
      }
      if (!(Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f20) >= Math_fround(0.0))) {
       i5 = i10;
       break L53;
      } else break;
     } while (0);
     if ((i46 | 0) == 60) {
      i46 = 0;
      f13 = Math_fround(f13 / f37);
      if (f13 > f12) {
       i5 = i10;
       break;
      }
      if (f13 > f11) f11 = f13;
     }
     if (!(f11 >= Math_fround(0.0))) i6 = 0; else {
      f49 = Math_fround(f20 + Math_fround(f11 * f37));
      f48 = Math_fround(f23 + Math_fround(f11 * f39));
      f13 = Math_fround(f24 + Math_fround(f11 * f34));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      i6 = 1;
      i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     }
     if (!(f12 >= Math_fround(0.0))) {
      if (!i6) {
       i5 = i10;
       break;
      }
     } else {
      f20 = Math_fround(Math_fround(f12 * f37) + f20);
      f48 = Math_fround(Math_fround(f12 * f39) + f23);
      f49 = Math_fround(Math_fround(f12 * f34) + f24);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
     }
     i9 = i9 + 2 | 0;
     i7 = HEAP32[i35 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i9 >>> 0 > i8 >>> 0) {
      i6 = i7 << 1;
      i6 = (i6 | 0) == 0 ? 1 : i6;
      if (i8 >>> 0 < i6 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i35 >> 2] = i6;
       i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i6 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i42 >> 2] = i5;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 12 | 0, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i35 >> 2] = i6;
       HEAP32[i42 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i19 >> 2] = i9;
     HEAP32[i5 + (i10 * 12 | 0) >> 2] = i1;
     HEAP32[i5 + (i10 * 12 | 0) + 4 >> 2] = i4;
     HEAP32[i5 + (i10 * 12 | 0) + 8 >> 2] = i2;
     i5 = i9;
    } while (0);
    i14 = i14 + 1 | 0;
    if ((i14 & 255) << 24 >> 24 == i17 << 24 >> 24) break; else i9 = i5;
   }
  }
  i16 = i16 + 1 | 0;
  if ((i16 | 0) == (i3 | 0)) break; else i15 = i15 + ((i17 & 255) * 12 | 0) | 0;
 }
 STACKTOP = i47;
 return;
}

function __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 80 | 0;
 i15 = i16;
 i8 = i16 + 64 | 0;
 i9 = i16 + 52 | 0;
 i10 = i16 + 40 | 0;
 i11 = i16 + 28 | 0;
 i12 = i16 + 16 | 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (i1 & 1048576 | 0) {
  if (!(i1 & 4194304)) i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = 8;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i15 + 11 >> 0] = i3;
   if (!i3) i1 = i15; else {
    i1 = i15;
    i4 = 10;
   }
  } else i4 = 8;
  if ((i4 | 0) == 8) {
   i12 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i15 + 4 >> 2] = i3;
   i4 = 10;
  }
  if ((i4 | 0) == 10) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i15 + 11 | 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  STACKTOP = i16;
  return;
 }
 if (i1 & 256 | 0) {
  i12 = (i1 | 0) == 258;
  i11 = i12 ? gb + 1087447 | 0 : gb + 1087441 | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i12 = i12 ? 4 : 5;
  i4 = i15 + 11 | 0;
  HEAP8[i4 >> 0] = i12;
  _memcpy(i15 | 0, i11 | 0, i12 | 0) | 0;
  HEAP8[i15 + i12 >> 0] = 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  STACKTOP = i16;
  return;
 }
 if (i1 & 1024 | 0) {
  __Z11IntToStringi(i8, HEAP32[i2 >> 2] | 0);
  i2 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = 42;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i15 + 11 >> 0] = i3;
   if (!i3) i1 = i15; else {
    i1 = i15;
    i4 = 44;
   }
  } else i4 = 42;
  if ((i4 | 0) == 42) {
   i12 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i15 + 4 >> 2] = i3;
   i4 = 44;
  }
  if ((i4 | 0) == 44) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i15 + 11 | 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i16;
  return;
 }
 if (i1 & 2048 | 0) {
  __Z19UnsignedIntToStringj(i9, HEAP32[i2 >> 2] | 0);
  i2 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = 62;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i15 + 11 >> 0] = i3;
   if (!i3) i1 = i15; else {
    i1 = i15;
    i4 = 64;
   }
  } else i4 = 62;
  if ((i4 | 0) == 62) {
   i12 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i15 + 4 >> 2] = i3;
   i4 = 64;
  }
  if ((i4 | 0) == 64) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i15 + 11 | 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i16;
  return;
 }
 if (i1 & 4096 | 0) {
  __Z13Int64ToStringx(i10, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
  i2 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = 82;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i15 + 11 >> 0] = i3;
   if (!i3) i1 = i15; else {
    i1 = i15;
    i4 = 84;
   }
  } else i4 = 82;
  if ((i4 | 0) == 82) {
   i12 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i15 + 4 >> 2] = i3;
   i4 = 84;
  }
  if ((i4 | 0) == 84) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i15 + 11 | 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i16;
  return;
 }
 if (i1 & 8192 | 0) {
  __Z21UnsignedInt64ToStringy(i11, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
  i2 = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = 102;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i15 + 11 >> 0] = i3;
   if (!i3) i1 = i15; else {
    i1 = i15;
    i4 = 104;
   }
  } else i4 = 102;
  if ((i4 | 0) == 102) {
   i12 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i15 + 4 >> 2] = i3;
   i4 = 104;
  }
  if ((i4 | 0) == 104) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i15 + 11 | 0;
  do if ((i15 | 0) != (i13 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
   i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
   i7 = i13 + 11 | 0;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i12 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i12, 0, i12, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i13 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i16;
  return;
 }
 if (!(i1 & 16384)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = i15 + 11 | 0;
  HEAP8[i1 >> 0] = 0;
  HEAP8[i15 >> 0] = 0;
  i2 = i13 + 11 | 0;
  HEAP8[((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) HEAP32[i13 + 4 >> 2] = 0; else HEAP8[i2 >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  STACKTOP = i16;
  return;
 }
 __Z14DoubleToStringd(i12, +HEAPF64[i2 >> 3]);
 i2 = (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i4 = 122;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i15 + 11 >> 0] = i3;
  if (!i3) i1 = i15; else {
   i1 = i15;
   i4 = 124;
  }
 } else i4 = 122;
 if ((i4 | 0) == 122) {
  i11 = i3 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i3;
  i4 = 124;
 }
 if ((i4 | 0) == 124) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i15 + 11 | 0;
 do if ((i15 | 0) != (i13 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
  i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
  i7 = i13 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i6 - i3 | 0, i11, 0, i11, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i13 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i16;
 return;
}

function __GLOBAL__sub_I_runtime_graphics6_lump_cpp() {
 var i1 = 0, i2 = 0;
 HEAP8[gb + 1158400 >> 0] = 1;
 HEAP8[gb + 1158400 + 1 >> 0] = 0;
 HEAP8[gb + 1158400 + 2 >> 0] = 0;
 HEAP32[gb + 1158400 + 4 >> 2] = 1;
 HEAP32[gb + 1158400 + 8 >> 2] = 0;
 HEAP32[gb + 1158400 + 12 >> 2] = 0;
 HEAP32[gb + 1158400 + 16 >> 2] = 0;
 HEAP32[gb + 1158400 + 20 >> 2] = 8;
 HEAP32[gb + 1158400 + 24 >> 2] = 0;
 HEAP32[gb + 1158400 + 28 >> 2] = 255;
 i1 = gb + 1158400 + 32 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[gb + 1158468 >> 0] = 1;
 HEAP8[gb + 1158468 + 1 >> 0] = 0;
 HEAP8[gb + 1158468 + 2 >> 0] = 0;
 HEAP32[gb + 1158468 + 4 >> 2] = 2;
 HEAP32[gb + 1158468 + 8 >> 2] = 0;
 HEAP32[gb + 1158468 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1158468 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1158468 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1158468 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1158468 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1158468 + 32 >> 2] = 5;
 HEAP32[gb + 1158468 + 36 >> 2] = 11;
 HEAP32[gb + 1158468 + 40 >> 2] = 63488;
 HEAP32[gb + 1158468 + 44 >> 2] = 6;
 HEAP32[gb + 1158468 + 48 >> 2] = 5;
 HEAP32[gb + 1158468 + 52 >> 2] = 2016;
 HEAP32[gb + 1158468 + 56 >> 2] = 5;
 HEAP32[gb + 1158468 + 60 >> 2] = 0;
 HEAP32[gb + 1158468 + 64 >> 2] = 31;
 HEAP8[gb + 1158536 >> 0] = 1;
 HEAP8[gb + 1158536 + 1 >> 0] = 0;
 HEAP8[gb + 1158536 + 2 >> 0] = 0;
 HEAP32[gb + 1158536 + 4 >> 2] = 2;
 HEAP32[gb + 1158536 + 8 >> 2] = 0;
 HEAP32[gb + 1158536 + 12 >> 2] = 0;
 HEAP32[gb + 1158536 + 16 >> 2] = 0;
 HEAP32[gb + 1158536 + 20 >> 2] = 4;
 HEAP32[gb + 1158536 + 24 >> 2] = 0;
 HEAP32[gb + 1158536 + 28 >> 2] = 15;
 HEAP32[gb + 1158536 + 32 >> 2] = 4;
 HEAP32[gb + 1158536 + 36 >> 2] = 12;
 HEAP32[gb + 1158536 + 40 >> 2] = 61440;
 HEAP32[gb + 1158536 + 44 >> 2] = 4;
 HEAP32[gb + 1158536 + 48 >> 2] = 8;
 HEAP32[gb + 1158536 + 52 >> 2] = 3840;
 HEAP32[gb + 1158536 + 56 >> 2] = 4;
 HEAP32[gb + 1158536 + 60 >> 2] = 4;
 HEAP32[gb + 1158536 + 64 >> 2] = 240;
 HEAP8[gb + 1158604 >> 0] = 1;
 HEAP8[gb + 1158604 + 1 >> 0] = 0;
 HEAP8[gb + 1158604 + 2 >> 0] = 0;
 HEAP32[gb + 1158604 + 4 >> 2] = 2;
 HEAP32[gb + 1158604 + 8 >> 2] = 0;
 HEAP32[gb + 1158604 + 12 >> 2] = 0;
 HEAP32[gb + 1158604 + 16 >> 2] = 0;
 HEAP32[gb + 1158604 + 20 >> 2] = 4;
 HEAP32[gb + 1158604 + 24 >> 2] = 12;
 HEAP32[gb + 1158604 + 28 >> 2] = 61440;
 HEAP32[gb + 1158604 + 32 >> 2] = 4;
 HEAP32[gb + 1158604 + 36 >> 2] = 8;
 HEAP32[gb + 1158604 + 40 >> 2] = 3840;
 HEAP32[gb + 1158604 + 44 >> 2] = 4;
 HEAP32[gb + 1158604 + 48 >> 2] = 4;
 HEAP32[gb + 1158604 + 52 >> 2] = 240;
 HEAP32[gb + 1158604 + 56 >> 2] = 4;
 HEAP32[gb + 1158604 + 60 >> 2] = 0;
 HEAP32[gb + 1158604 + 64 >> 2] = 15;
 HEAP8[gb + 1158672 >> 0] = 1;
 HEAP8[gb + 1158672 + 1 >> 0] = 0;
 HEAP8[gb + 1158672 + 2 >> 0] = 0;
 HEAP32[gb + 1158672 + 4 >> 2] = 3;
 HEAP32[gb + 1158672 + 8 >> 2] = 0;
 HEAP32[gb + 1158672 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1158672 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1158672 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1158672 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1158672 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1158672 + 32 >> 2] = 8;
 HEAP32[gb + 1158672 + 36 >> 2] = 0;
 HEAP32[gb + 1158672 + 40 >> 2] = 255;
 HEAP32[gb + 1158672 + 44 >> 2] = 8;
 HEAP32[gb + 1158672 + 48 >> 2] = 8;
 HEAP32[gb + 1158672 + 52 >> 2] = 65280;
 HEAP32[gb + 1158672 + 56 >> 2] = 8;
 HEAP32[gb + 1158672 + 60 >> 2] = 16;
 HEAP32[gb + 1158672 + 64 >> 2] = 16711680;
 HEAP8[gb + 1158740 >> 0] = 1;
 HEAP8[gb + 1158740 + 1 >> 0] = 0;
 HEAP8[gb + 1158740 + 2 >> 0] = 0;
 HEAP32[gb + 1158740 + 4 >> 2] = 3;
 HEAP32[gb + 1158740 + 8 >> 2] = 0;
 HEAP32[gb + 1158740 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1158740 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1158740 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1158740 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1158740 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1158740 + 32 >> 2] = 8;
 HEAP32[gb + 1158740 + 36 >> 2] = 16;
 HEAP32[gb + 1158740 + 40 >> 2] = 16711680;
 HEAP32[gb + 1158740 + 44 >> 2] = 8;
 HEAP32[gb + 1158740 + 48 >> 2] = 8;
 HEAP32[gb + 1158740 + 52 >> 2] = 65280;
 HEAP32[gb + 1158740 + 56 >> 2] = 8;
 HEAP32[gb + 1158740 + 60 >> 2] = 0;
 HEAP32[gb + 1158740 + 64 >> 2] = 255;
 HEAP8[gb + 1158808 >> 0] = 1;
 HEAP8[gb + 1158808 + 1 >> 0] = 0;
 HEAP8[gb + 1158808 + 2 >> 0] = 0;
 HEAP32[gb + 1158808 + 4 >> 2] = 4;
 HEAP32[gb + 1158808 + 8 >> 2] = 0;
 HEAP32[gb + 1158808 + 12 >> 2] = 0;
 HEAP32[gb + 1158808 + 16 >> 2] = 0;
 HEAP32[gb + 1158808 + 20 >> 2] = 8;
 HEAP32[gb + 1158808 + 24 >> 2] = 24;
 HEAP32[gb + 1158808 + 28 >> 2] = -16777216;
 HEAP32[gb + 1158808 + 32 >> 2] = 8;
 HEAP32[gb + 1158808 + 36 >> 2] = 0;
 HEAP32[gb + 1158808 + 40 >> 2] = 255;
 HEAP32[gb + 1158808 + 44 >> 2] = 8;
 HEAP32[gb + 1158808 + 48 >> 2] = 8;
 HEAP32[gb + 1158808 + 52 >> 2] = 65280;
 HEAP32[gb + 1158808 + 56 >> 2] = 8;
 HEAP32[gb + 1158808 + 60 >> 2] = 16;
 HEAP32[gb + 1158808 + 64 >> 2] = 16711680;
 HEAP8[gb + 1158876 >> 0] = 1;
 HEAP8[gb + 1158876 + 1 >> 0] = 0;
 HEAP8[gb + 1158876 + 2 >> 0] = 0;
 HEAP32[gb + 1158876 + 4 >> 2] = 4;
 HEAP32[gb + 1158876 + 8 >> 2] = 0;
 HEAP32[gb + 1158876 + 12 >> 2] = 0;
 HEAP32[gb + 1158876 + 16 >> 2] = 0;
 HEAP32[gb + 1158876 + 20 >> 2] = 8;
 HEAP32[gb + 1158876 + 24 >> 2] = 0;
 HEAP32[gb + 1158876 + 28 >> 2] = 255;
 HEAP32[gb + 1158876 + 32 >> 2] = 8;
 HEAP32[gb + 1158876 + 36 >> 2] = 24;
 HEAP32[gb + 1158876 + 40 >> 2] = -16777216;
 HEAP32[gb + 1158876 + 44 >> 2] = 8;
 HEAP32[gb + 1158876 + 48 >> 2] = 16;
 HEAP32[gb + 1158876 + 52 >> 2] = 16711680;
 HEAP32[gb + 1158876 + 56 >> 2] = 8;
 HEAP32[gb + 1158876 + 60 >> 2] = 8;
 HEAP32[gb + 1158876 + 64 >> 2] = 65280;
 HEAP8[gb + 1158944 >> 0] = 1;
 HEAP8[gb + 1158944 + 1 >> 0] = 0;
 HEAP8[gb + 1158944 + 2 >> 0] = 0;
 HEAP32[gb + 1158944 + 4 >> 2] = 4;
 HEAP32[gb + 1158944 + 8 >> 2] = 0;
 HEAP32[gb + 1158944 + 12 >> 2] = 0;
 HEAP32[gb + 1158944 + 16 >> 2] = 0;
 HEAP32[gb + 1158944 + 20 >> 2] = 8;
 HEAP32[gb + 1158944 + 24 >> 2] = 0;
 HEAP32[gb + 1158944 + 28 >> 2] = 255;
 HEAP32[gb + 1158944 + 32 >> 2] = 8;
 HEAP32[gb + 1158944 + 36 >> 2] = 8;
 HEAP32[gb + 1158944 + 40 >> 2] = 65280;
 HEAP32[gb + 1158944 + 44 >> 2] = 8;
 HEAP32[gb + 1158944 + 48 >> 2] = 16;
 HEAP32[gb + 1158944 + 52 >> 2] = 16711680;
 HEAP32[gb + 1158944 + 56 >> 2] = 8;
 HEAP32[gb + 1158944 + 60 >> 2] = 24;
 HEAP32[gb + 1158944 + 64 >> 2] = -16777216;
 HEAP8[gb + 1159012 >> 0] = 1;
 HEAP8[gb + 1159012 + 1 >> 0] = 0;
 HEAP8[gb + 1159012 + 2 >> 0] = 0;
 HEAP32[gb + 1159012 + 4 >> 2] = 4;
 HEAP32[gb + 1159012 + 8 >> 2] = 0;
 HEAP32[gb + 1159012 + 12 >> 2] = 0;
 HEAP32[gb + 1159012 + 16 >> 2] = 0;
 HEAP32[gb + 1159012 + 20 >> 2] = 8;
 HEAP32[gb + 1159012 + 24 >> 2] = 24;
 HEAP32[gb + 1159012 + 28 >> 2] = -16777216;
 HEAP32[gb + 1159012 + 32 >> 2] = 8;
 HEAP32[gb + 1159012 + 36 >> 2] = 16;
 HEAP32[gb + 1159012 + 40 >> 2] = 16711680;
 HEAP32[gb + 1159012 + 44 >> 2] = 8;
 HEAP32[gb + 1159012 + 48 >> 2] = 8;
 HEAP32[gb + 1159012 + 52 >> 2] = 65280;
 HEAP32[gb + 1159012 + 56 >> 2] = 8;
 HEAP32[gb + 1159012 + 60 >> 2] = 0;
 HEAP32[gb + 1159012 + 64 >> 2] = 255;
 HEAP8[gb + 1159080 >> 0] = 0;
 HEAP8[gb + 1159080 + 1 >> 0] = 0;
 HEAP8[gb + 1159080 + 2 >> 0] = 1;
 HEAP32[gb + 1159080 + 4 >> 2] = 2;
 HEAP32[gb + 1159080 + 8 >> 2] = 0;
 HEAP32[gb + 1159080 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1159080 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1159080 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1159080 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1159080 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1159080 + 32 >> 2] = 1;
 HEAP32[gb + 1159080 + 36 >> 2] = 0;
 HEAP32[gb + 1159080 + 40 >> 2] = 1;
 HEAP32[gb + 1159080 + 44 >> 2] = 0;
 HEAP32[gb + 1159080 + 44 + 4 >> 2] = 0;
 HEAP32[gb + 1159080 + 44 + 8 >> 2] = 0;
 HEAP32[gb + 1159080 + 44 + 12 >> 2] = 0;
 HEAP32[gb + 1159080 + 44 + 16 >> 2] = 0;
 HEAP32[gb + 1159080 + 44 + 20 >> 2] = 0;
 HEAP8[gb + 1159148 >> 0] = 0;
 HEAP8[gb + 1159148 + 1 >> 0] = 0;
 HEAP8[gb + 1159148 + 2 >> 0] = 1;
 HEAP32[gb + 1159148 + 4 >> 2] = 4;
 HEAP32[gb + 1159148 + 8 >> 2] = 0;
 HEAP32[gb + 1159148 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1159148 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1159148 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1159148 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1159148 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1159148 + 32 >> 2] = 1;
 HEAP32[gb + 1159148 + 36 >> 2] = 0;
 HEAP32[gb + 1159148 + 40 >> 2] = 1;
 HEAP32[gb + 1159148 + 44 >> 2] = 1;
 HEAP32[gb + 1159148 + 48 >> 2] = 1;
 HEAP32[gb + 1159148 + 52 >> 2] = 2;
 HEAP32[gb + 1159148 + 56 >> 2] = 0;
 HEAP32[gb + 1159148 + 60 >> 2] = 0;
 HEAP32[gb + 1159148 + 64 >> 2] = 0;
 HEAP8[gb + 1159216 >> 0] = 0;
 HEAP8[gb + 1159216 + 1 >> 0] = 0;
 HEAP8[gb + 1159216 + 2 >> 0] = 1;
 HEAP32[gb + 1159216 + 4 >> 2] = 8;
 HEAP32[gb + 1159216 + 8 >> 2] = 0;
 HEAP32[gb + 1159216 + 12 >> 2] = 0;
 HEAP32[gb + 1159216 + 16 >> 2] = 0;
 HEAP32[gb + 1159216 + 20 >> 2] = 1;
 HEAP32[gb + 1159216 + 24 >> 2] = 3;
 HEAP32[gb + 1159216 + 28 >> 2] = 8;
 HEAP32[gb + 1159216 + 32 >> 2] = 1;
 HEAP32[gb + 1159216 + 36 >> 2] = 0;
 HEAP32[gb + 1159216 + 40 >> 2] = 1;
 HEAP32[gb + 1159216 + 44 >> 2] = 1;
 HEAP32[gb + 1159216 + 48 >> 2] = 1;
 HEAP32[gb + 1159216 + 52 >> 2] = 2;
 HEAP32[gb + 1159216 + 56 >> 2] = 1;
 HEAP32[gb + 1159216 + 60 >> 2] = 2;
 HEAP32[gb + 1159216 + 64 >> 2] = 4;
 HEAP8[gb + 1159284 >> 0] = 0;
 HEAP8[gb + 1159284 + 1 >> 0] = 1;
 HEAP8[gb + 1159284 + 2 >> 0] = 0;
 HEAP32[gb + 1159284 + 4 >> 2] = 4;
 HEAP32[gb + 1159284 + 8 >> 2] = 0;
 HEAP32[gb + 1159284 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1159284 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1159284 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1159284 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1159284 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1159284 + 32 >> 2] = 1;
 HEAP32[gb + 1159284 + 36 >> 2] = 0;
 HEAP32[gb + 1159284 + 40 >> 2] = 1;
 HEAP32[gb + 1159284 + 44 >> 2] = 0;
 HEAP32[gb + 1159284 + 44 + 4 >> 2] = 0;
 HEAP32[gb + 1159284 + 44 + 8 >> 2] = 0;
 HEAP32[gb + 1159284 + 44 + 12 >> 2] = 0;
 HEAP32[gb + 1159284 + 44 + 16 >> 2] = 0;
 HEAP32[gb + 1159284 + 44 + 20 >> 2] = 0;
 HEAP8[gb + 1159352 >> 0] = 0;
 HEAP8[gb + 1159352 + 1 >> 0] = 1;
 HEAP8[gb + 1159352 + 2 >> 0] = 0;
 HEAP32[gb + 1159352 + 4 >> 2] = 8;
 HEAP32[gb + 1159352 + 8 >> 2] = 0;
 HEAP32[gb + 1159352 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1159352 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1159352 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1159352 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1159352 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1159352 + 32 >> 2] = 1;
 HEAP32[gb + 1159352 + 36 >> 2] = 0;
 HEAP32[gb + 1159352 + 40 >> 2] = 1;
 HEAP32[gb + 1159352 + 44 >> 2] = 1;
 HEAP32[gb + 1159352 + 48 >> 2] = 1;
 HEAP32[gb + 1159352 + 52 >> 2] = 2;
 HEAP32[gb + 1159352 + 56 >> 2] = 0;
 HEAP32[gb + 1159352 + 60 >> 2] = 0;
 HEAP32[gb + 1159352 + 64 >> 2] = 0;
 HEAP8[gb + 1159420 >> 0] = 0;
 HEAP8[gb + 1159420 + 1 >> 0] = 1;
 HEAP8[gb + 1159420 + 2 >> 0] = 0;
 HEAP32[gb + 1159420 + 4 >> 2] = 12;
 HEAP32[gb + 1159420 + 8 >> 2] = 0;
 HEAP32[gb + 1159420 + 8 + 4 >> 2] = 0;
 HEAP32[gb + 1159420 + 8 + 8 >> 2] = 0;
 HEAP32[gb + 1159420 + 8 + 12 >> 2] = 0;
 HEAP32[gb + 1159420 + 8 + 16 >> 2] = 0;
 HEAP32[gb + 1159420 + 8 + 20 >> 2] = 0;
 HEAP32[gb + 1159420 + 32 >> 2] = 1;
 HEAP32[gb + 1159420 + 36 >> 2] = 0;
 HEAP32[gb + 1159420 + 40 >> 2] = 1;
 HEAP32[gb + 1159420 + 44 >> 2] = 1;
 HEAP32[gb + 1159420 + 48 >> 2] = 1;
 HEAP32[gb + 1159420 + 52 >> 2] = 2;
 HEAP32[gb + 1159420 + 56 >> 2] = 1;
 HEAP32[gb + 1159420 + 60 >> 2] = 2;
 HEAP32[gb + 1159420 + 64 >> 2] = 4;
 HEAP8[gb + 1159488 >> 0] = 0;
 HEAP8[gb + 1159488 + 1 >> 0] = 1;
 HEAP8[gb + 1159488 + 2 >> 0] = 0;
 HEAP32[gb + 1159488 + 4 >> 2] = 16;
 HEAP32[gb + 1159488 + 8 >> 2] = 0;
 HEAP32[gb + 1159488 + 12 >> 2] = 0;
 HEAP32[gb + 1159488 + 16 >> 2] = 0;
 HEAP32[gb + 1159488 + 20 >> 2] = 1;
 HEAP32[gb + 1159488 + 24 >> 2] = 3;
 HEAP32[gb + 1159488 + 28 >> 2] = 8;
 HEAP32[gb + 1159488 + 32 >> 2] = 1;
 HEAP32[gb + 1159488 + 36 >> 2] = 0;
 HEAP32[gb + 1159488 + 40 >> 2] = 1;
 HEAP32[gb + 1159488 + 44 >> 2] = 1;
 HEAP32[gb + 1159488 + 48 >> 2] = 1;
 HEAP32[gb + 1159488 + 52 >> 2] = 2;
 HEAP32[gb + 1159488 + 56 >> 2] = 1;
 HEAP32[gb + 1159488 + 60 >> 2] = 2;
 HEAP32[gb + 1159488 + 64 >> 2] = 4;
 HEAP8[gb + 1159556 >> 0] = 0;
 HEAP8[gb + 1159556 + 1 >> 0] = 1;
 HEAP8[gb + 1159556 + 2 >> 0] = 0;
 HEAP32[gb + 1159556 + 4 >> 2] = 16;
 HEAP32[gb + 1159556 + 8 >> 2] = 0;
 HEAP32[gb + 1159556 + 12 >> 2] = 0;
 HEAP32[gb + 1159556 + 16 >> 2] = 0;
 HEAP32[gb + 1159556 + 20 >> 2] = 1;
 HEAP32[gb + 1159556 + 24 >> 2] = 0;
 HEAP32[gb + 1159556 + 28 >> 2] = 1;
 HEAP32[gb + 1159556 + 32 >> 2] = 1;
 HEAP32[gb + 1159556 + 36 >> 2] = 1;
 HEAP32[gb + 1159556 + 40 >> 2] = 2;
 HEAP32[gb + 1159556 + 44 >> 2] = 1;
 HEAP32[gb + 1159556 + 48 >> 2] = 2;
 HEAP32[gb + 1159556 + 52 >> 2] = 4;
 HEAP32[gb + 1159556 + 56 >> 2] = 1;
 HEAP32[gb + 1159556 + 60 >> 2] = 3;
 HEAP32[gb + 1159556 + 64 >> 2] = 8;
 HEAPF32[gb + 1159624 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 16 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 24 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 60 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 68 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 80 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 112 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 124 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 132 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 152 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 164 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1159624 + 168 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1159624 + 188 >> 2] = Math_fround(-1.0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159816 | 0, gb + 421574 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159828 | 0, gb + 421609 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159840 | 0, gb + 421641 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159852 | 0, gb + 421662 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159864 | 0, gb + 421682 | 0, 11, 0);
 HEAP32[gb + 1477024 >> 2] = -1;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159876 | 0, gb + 421713 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159888 | 0, gb + 421738 | 0, 11, 0);
 return;
}

function __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo(i35, i1, i41, i42, i43) {
 i35 = i35 | 0;
 i1 = i1 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i51 + 328 | 0;
 i50 = i51 + 288 | 0;
 i44 = i51 + 316 | 0;
 i45 = i51 + 280 | 0;
 i46 = i51 + 272 | 0;
 i47 = i51 + 312 | 0;
 i48 = i51 + 32 | 0;
 i36 = i51 + 24 | 0;
 i37 = i51 + 16 | 0;
 i38 = i51 + 296 | 0;
 i39 = i51 + 8 | 0;
 i40 = i51;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  i50 = 0;
  STACKTOP = i51;
  return i50 | 0;
 }
 i34 = i1 + 40 | 0;
 i2 = HEAP32[i34 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  i50 = 1;
  STACKTOP = i51;
  return i50 | 0;
 }
 i16 = i1 + 28 | 0;
 i17 = i35 + 4 | 0;
 i18 = i17 + 11 | 0;
 i19 = i35 + 52 | 0;
 i20 = i35 + 56 | 0;
 i21 = i35 + 60 | 0;
 i15 = i36 + 4 | 0;
 i14 = i45 + 4 | 0;
 i22 = i48 + 233 | 0;
 i23 = i48 + 216 | 0;
 i11 = i39 + 4 | 0;
 i12 = i37 + 4 | 0;
 i24 = i38 + 11 | 0;
 i25 = i44 + 11 | 0;
 i26 = i38 + 12 | 0;
 i27 = i49 + 4 | 0;
 i13 = i46 + 4 | 0;
 i28 = i35 + 40 | 0;
 i29 = i35 + 44 | 0;
 i30 = i35 + 20 | 0;
 i31 = i30 + 11 | 0;
 i32 = i49 + 36 | 0;
 i33 = i35 + 36 | 0;
 i10 = 0;
 i1 = i2;
 while (1) {
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i10 << 3) >> 2] << 2) >> 2] | 0;
  if (i3) if ((HEAP32[i3 + 16 >> 2] | 0) == 114) {
   i6 = HEAP32[i2 + (i10 << 3) + 4 >> 2] | 0;
   i8 = __ZNK13MonoBehaviour8GetClassEv(i6) | 0;
   __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc(i40, i8, (HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17);
   if (HEAP32[i40 >> 2] | 0) {
    i8 = i40;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i1 = HEAP32[i6 + 20 >> 2] | 0;
    if (!((i7 | 0) == 0 | (i1 | 0) == 0)) {
     HEAP32[i19 >> 2] = i41;
     HEAP32[i20 >> 2] = i42;
     HEAP32[i21 >> 2] = i43;
     HEAP32[i36 >> 2] = i7;
     HEAP32[i15 >> 2] = i8;
     HEAP32[i49 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
     __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i48, i1, i49);
     HEAP32[i45 >> 2] = i7;
     HEAP32[i14 >> 2] = i8;
     HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
     i1 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i49) | 0;
     L16 : do if (!i1) i9 = 88; else {
      if ((i1 | 0) <= 1) {
       HEAP32[i46 >> 2] = i7;
       HEAP32[i13 >> 2] = i8;
       HEAP32[i49 >> 2] = HEAP32[i46 >> 2];
       HEAP32[i49 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
       i5 = __Z25scripting_class_from_typePK10Il2CppType(__Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi(i49, 0) | 0) | 0;
       i1 = __Z19GetScriptingManagerv() | 0;
       if ((i5 | 0) == (HEAP32[i1 + 132 >> 2] | 0)) {
        __ZN18ScriptingArguments8AddFloatEf(i48, Math_fround(HEAPF32[i28 >> 2]));
        i9 = 88;
        break;
       }
       if ((i5 | 0) == (HEAP32[i1 + 80 >> 2] | 0)) {
        __ZN18ScriptingArguments6AddIntEi(i48, HEAP32[i29 >> 2] | 0);
        i9 = 88;
        break;
       }
       if ((i5 | 0) == (HEAP32[i1 + 128 >> 2] | 0)) {
        __ZN18ScriptingArguments9AddStringEPKc(i48, (HEAP8[i31 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30);
        i9 = 88;
        break;
       }
       if ((i5 | 0) == (HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) >> 2] | 0)) {
        i2 = i32;
        i4 = i2 + 36 | 0;
        do {
         HEAP32[i2 >> 2] = 0;
         i2 = i2 + 4 | 0;
        } while ((i2 | 0) < (i4 | 0));
        __Z20AnimationEventToMonoRK14AnimationEventR18MonoAnimationEvent(i35, i49);
        i1 = _il2cpp_object_new(HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) >> 2] | 0) | 0;
        i2 = i1 + 8 | 0;
        i3 = i49;
        i4 = i2 + 80 | 0;
        do {
         HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
         i2 = i2 + 4 | 0;
         i3 = i3 + 4 | 0;
        } while ((i2 | 0) < (i4 | 0));
        __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i48, i1);
        i9 = 88;
        break;
       }
       L32 : do if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i5, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0) {
        i1 = HEAP32[i33 >> 2] | 0;
        HEAP32[i47 >> 2] = i1;
        L34 : do if (!i1) {
         i1 = 0;
         i9 = 38;
        } else {
         HEAP32[i44 >> 2] = i1;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i1) i9 = 25; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i3 = HEAP32[i1 + 28 >> 2] | 0;
           i4 = HEAP32[i1 + 32 >> 2] | 0;
           i2 = i3 + (i4 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
           i2 = HEAP32[i49 >> 2] | 0;
           i3 = HEAP32[i1 + 28 >> 2] | 0;
           i52 = HEAP32[gb + 1104264 >> 2] | 0;
           i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
           i3 = HEAP32[i52 + 28 >> 2] | 0;
           i4 = HEAP32[i52 + 32 >> 2] | 0;
           i1 = i52;
          }
          if ((i2 | 0) == (i3 + (i4 << 3) | 0)) {
           i9 = 25;
           break;
          }
          if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 27;
         } while (0);
         if ((i9 | 0) == 25) i9 = 27;
         do if ((i9 | 0) == 27) {
          i9 = 0;
          if (__Z31ReadObjectFromPersistentManageri(HEAP32[i47 >> 2] | 0) | 0) {
           i1 = HEAP32[gb + 1104264 >> 2] | 0;
           break;
          }
          i1 = HEAP32[i33 >> 2] | 0;
          if (!i1) {
           i1 = 0;
           i9 = 38;
           break L34;
          }
          HEAP32[i44 >> 2] = i1;
          i1 = HEAP32[gb + 1104264 >> 2] | 0;
          do if (!i1) i9 = 35; else {
           if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
            i2 = HEAP32[i1 + 28 >> 2] | 0;
            i3 = HEAP32[i1 + 32 >> 2] | 0;
            i1 = i2 + (i3 << 3) | 0;
           } else {
            __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
            i2 = HEAP32[i49 >> 2] | 0;
            i52 = HEAP32[i1 + 28 >> 2] | 0;
            i3 = HEAP32[gb + 1104264 >> 2] | 0;
            i1 = (i2 | 0) == -1 ? i52 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i52 + (i2 << 3) | 0;
            i2 = HEAP32[i3 + 28 >> 2] | 0;
            i3 = HEAP32[i3 + 32 >> 2] | 0;
           }
           if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
            i9 = 35;
            break;
           }
           i1 = HEAP32[i1 + 4 >> 2] | 0;
           if (i1 | 0) {
            i9 = 38;
            break L34;
           }
          } while (0);
          i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i33 >> 2] | 0) | 0;
          i9 = 38;
          break L34;
         } while (0);
         HEAP32[i44 >> 2] = HEAP32[i47 >> 2];
         do if (!i1) i9 = 44; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i2 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[i1 + 32 >> 2] | 0;
           i1 = i2 + (i3 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
           i2 = HEAP32[i49 >> 2] | 0;
           i52 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[gb + 1104264 >> 2] | 0;
           i1 = (i2 | 0) == -1 ? i52 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i52 + (i2 << 3) | 0;
           i2 = HEAP32[i3 + 28 >> 2] | 0;
           i3 = HEAP32[i3 + 32 >> 2] | 0;
          }
          if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
           i9 = 44;
           break;
          }
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i9 = 46;
         } while (0);
         if ((i9 | 0) == 44) i9 = 46;
         if ((i9 | 0) == 46) {
          i9 = 0;
          i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i47 >> 2] | 0) | 0;
         }
         do if (((HEAP32[i1 + 8 >> 2] | 0) >>> 21 | 0) == (HEAP32[gb + 27592 + 24 >> 2] | 0)) {
          i1 = __Z17dynamic_pptr_castIP13MonoBehaviour6ObjectET_RK4PPtrIT0_E(i47) | 0;
          if (!i1) break;
          if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__ZNK13MonoBehaviour8GetClassEv(i1) | 0, i5) | 0)) break;
          i1 = HEAP32[i33 >> 2] | 0;
          L78 : do if (!i1) i1 = 0; else {
           HEAP32[i44 >> 2] = i1;
           i1 = HEAP32[gb + 1104264 >> 2] | 0;
           do if (!i1) i9 = 56; else {
            if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
             i2 = HEAP32[i1 + 28 >> 2] | 0;
             i3 = HEAP32[i1 + 32 >> 2] | 0;
             i1 = i2 + (i3 << 3) | 0;
            } else {
             __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
             i2 = HEAP32[i49 >> 2] | 0;
             i52 = HEAP32[i1 + 28 >> 2] | 0;
             i3 = HEAP32[gb + 1104264 >> 2] | 0;
             i1 = (i2 | 0) == -1 ? i52 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i52 + (i2 << 3) | 0;
             i2 = HEAP32[i3 + 28 >> 2] | 0;
             i3 = HEAP32[i3 + 32 >> 2] | 0;
            }
            if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
             i9 = 56;
             break;
            }
            i1 = HEAP32[i1 + 4 >> 2] | 0;
            if (i1 | 0) break L78;
           } while (0);
           if ((i9 | 0) == 56) i9 = 0;
           i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i33 >> 2] | 0) | 0;
          } while (0);
          __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i48, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
          break L34;
         } else {
          HEAP32[i44 >> 2] = HEAP32[i47 >> 2];
          i1 = HEAP32[gb + 1104264 >> 2] | 0;
          do if (!i1) i9 = 65; else {
           if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
            i2 = HEAP32[i1 + 28 >> 2] | 0;
            i3 = HEAP32[i1 + 32 >> 2] | 0;
            i1 = i2 + (i3 << 3) | 0;
           } else {
            __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
            i2 = HEAP32[i49 >> 2] | 0;
            i52 = HEAP32[i1 + 28 >> 2] | 0;
            i3 = HEAP32[gb + 1104264 >> 2] | 0;
            i1 = (i2 | 0) == -1 ? i52 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i52 + (i2 << 3) | 0;
            i2 = HEAP32[i3 + 28 >> 2] | 0;
            i3 = HEAP32[i3 + 32 >> 2] | 0;
           }
           if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
            i9 = 65;
            break;
           }
           i1 = HEAP32[i1 + 4 >> 2] | 0;
           if (!i1) i9 = 67;
          } while (0);
          if ((i9 | 0) == 65) i9 = 67;
          if ((i9 | 0) == 67) {
           i9 = 0;
           i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i47 >> 2] | 0) | 0;
          }
          i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
          if (!i1) i1 = 0; else i1 = __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE(i1) | 0;
          if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i5) | 0)) break;
          i1 = HEAP32[i33 >> 2] | 0;
          L108 : do if (!i1) i1 = 0; else {
           HEAP32[i44 >> 2] = i1;
           i1 = HEAP32[gb + 1104264 >> 2] | 0;
           do if (!i1) i9 = 77; else {
            if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
             i2 = HEAP32[i1 + 28 >> 2] | 0;
             i3 = HEAP32[i1 + 32 >> 2] | 0;
             i1 = i2 + (i3 << 3) | 0;
            } else {
             __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i49, i1, i44);
             i2 = HEAP32[i49 >> 2] | 0;
             i52 = HEAP32[i1 + 28 >> 2] | 0;
             i3 = HEAP32[gb + 1104264 >> 2] | 0;
             i1 = (i2 | 0) == -1 ? i52 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i52 + (i2 << 3) | 0;
             i2 = HEAP32[i3 + 28 >> 2] | 0;
             i3 = HEAP32[i3 + 32 >> 2] | 0;
            }
            if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
             i9 = 77;
             break;
            }
            i1 = HEAP32[i1 + 4 >> 2] | 0;
            if (i1 | 0) break L108;
           } while (0);
           if ((i9 | 0) == 77) i9 = 0;
           i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i33 >> 2] | 0) | 0;
          } while (0);
          __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i48, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
          break L34;
         } while (0);
         break L32;
        } while (0);
        if ((i9 | 0) == 38) __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i48, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
        i9 = 88;
        break L16;
       } while (0);
       if (__Z23scripting_class_is_enumP11Il2CppClass(i5) | 0) {
        __ZN18ScriptingArguments6AddIntEi(i48, HEAP32[i29 >> 2] | 0);
        i9 = 88;
        break;
       }
      }
      HEAP32[i37 >> 2] = i7;
      HEAP32[i12 >> 2] = i8;
      HEAP32[i49 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i49 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      i8 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i49) | 0;
      __ZN13MonoBehaviour18GetScriptClassNameEv(i38, i6);
      i52 = (HEAP8[i24 >> 0] | 0) < 0 ? HEAP32[i38 >> 2] | 0 : i38;
      HEAP32[i50 >> 2] = i8;
      HEAP32[i50 + 4 >> 2] = i52;
      __Z6FormatPKcz(i44, gb + 897100 | 0, i50);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i25 >> 0] | 0) < 0 ? HEAP32[i44 >> 2] | 0 : i44, 0, gb + 897278 | 0, 129, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i44);
      if ((HEAP8[i24 >> 0] | 0) < 0) {
       i52 = HEAP32[i38 >> 2] | 0;
       i8 = HEAP32[i26 >> 2] | 0;
       HEAP32[i49 >> 2] = 66;
       HEAP32[i27 >> 2] = i8;
       __Z19free_alloc_internalPvRK10MemLabelId(i52, i49);
      }
     } while (0);
     if ((i9 | 0) == 88) {
      i9 = 0;
      i52 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
      HEAP8[i22 >> 0] = 1;
      HEAP32[i23 >> 2] = HEAP32[i6 + 4 >> 2];
      HEAP32[i49 >> 2] = 0;
      i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i48, i49, 0) | 0;
      __Z24SetExecutionRestrictions21ExecutionRestrictions(i52) | 0;
      if (i1 | 0) {
       HEAP32[i39 >> 2] = i7;
       HEAP32[i11 >> 2] = i8;
       HEAP32[i49 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i49 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
       __ZN13MonoBehaviour26HandleCoroutineReturnValueE21ScriptingMethodIl2CppP12Il2CppObject(i6, i49, i1) | 0;
      }
      HEAP32[i19 >> 2] = 0;
      HEAP32[i20 >> 2] = 0;
      HEAP32[i21 >> 2] = 0;
     }
    }
   }
   i1 = HEAP32[i34 >> 2] | 0;
  }
  i10 = i10 + 1 | 0;
  if ((i10 | 0) >= (i1 | 0)) {
   i1 = 1;
   break;
  }
 }
 STACKTOP = i51;
 return i1 | 0;
}

function __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i17, i13) {
 i17 = i17 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 8 | 0;
 i14 = i19;
 i15 = i17 + 1988 | 0;
 HEAP32[i15 >> 2] = __ZN2gl17GetCurrentContextEv() | 0;
 i18 = i17 + 1992 | 0;
 HEAP8[i18 >> 0] = 0;
 i3 = i17 + 1592 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i17 + 772 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i12 = i17 + 860 | 0;
 mftCall_vi(i2 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 4) | 0);
 i2 = HEAP8[i18 >> 0] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(i2 << 24 >> 24 != 0 & (i1 & 1 | 0) == 0)) {
  HEAP32[i3 >> 2] = i1 & -2;
  i1 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i1 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 0) | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
 }
 if (!(i2 << 24 >> 24 != 0 & (i1 & 4096 | 0) == 0)) {
  HEAP32[i3 >> 2] = i1 & -4097;
  i1 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i1 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 12) | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
 }
 if (!(i2 << 24 >> 24 != 0 & (i1 & 16384 | 0) == 0)) {
  HEAP32[i3 >> 2] = i1 & -16385;
  i1 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i1 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 14) | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
 }
 if (!(i2 << 24 >> 24 != 0 & (i1 & 512 | 0) == 0)) {
  HEAP32[i3 >> 2] = i1 & -513;
  i1 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i1 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 9) | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP8[i18 >> 0] | 0;
 }
 if (!(i2 << 24 >> 24 != 0 & (i1 & 8192 | 0) == 0)) {
  HEAP32[i3 >> 2] = i1 & -8193;
  i10 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 13) | 0);
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 653 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!((HEAP8[i18 >> 0] | 0) != 0 & (i1 & 64 | 0) == 0)) {
   HEAP32[i3 >> 2] = i1 & -65;
   i10 = HEAP32[i4 >> 2] | 0;
   mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 6) | 0);
  }
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP8[i18 >> 0] | 0) == 0 | (i1 & 32 | 0) == 0) {
  HEAP32[i3 >> 2] = i1 | 32;
  i10 = HEAP32[i17 + 768 >> 2] | 0;
  mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 5) | 0);
 }
 if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -5 | 0) >>> 0 < 8) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP8[i18 >> 0] | 0) == 0 | (i1 & 256 | 0) == 0) {
   HEAP32[i3 >> 2] = i1 | 256;
   i10 = HEAP32[i17 + 768 >> 2] | 0;
   mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 8) | 0);
  }
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 688 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP8[i18 >> 0] | 0) == 0 | (i1 & 32768 | 0) == 0) {
   HEAP32[i3 >> 2] = i1 | 32768;
   i10 = HEAP32[i17 + 768 >> 2] | 0;
   mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 15) | 0);
  }
 }
 mftCall_vi(HEAP32[i17 + 40 >> 2] | 0, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP8[i18 >> 0] | 0) == 0 | (i1 & 16 | 0) == 0) {
  HEAP32[i3 >> 2] = i1 | 16;
  i10 = HEAP32[i17 + 768 >> 2] | 0;
  mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 4) | 0);
 }
 mftCall_vi(HEAP32[i17 + 36 >> 2] | 0, 519);
 mftCall_viiii(HEAP32[i17 + 28 >> 2] | 0, 1, 1, 1, 1);
 mftCall_viiii(HEAP32[i17 + 20 >> 2] | 0, 1, 0, 1, 0);
 mftCall_vii(HEAP32[i17 + 12 >> 2] | 0, 32774, 32774);
 i10 = i17 + 756 | 0;
 mftCall_viiii(HEAP32[i10 >> 2] | 0, 1028, 519, 0, 255);
 i1 = i17 + 760 | 0;
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 1028, 7680, 7680, 7680);
 mftCall_viiii(HEAP32[i10 >> 2] | 0, 1029, 519, 0, 255);
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 1029, 7680, 7680, 7680);
 mftCall_vi(HEAP32[i17 + 752 >> 2] | 0, 255);
 i1 = i17 + 1576 | 0;
 if (!(HEAP8[i18 >> 0] | 0)) i16 = 27; else if ((HEAP32[i1 >> 2] | 0) != 2) i16 = 27;
 if ((i16 | 0) == 27) {
  HEAP32[i1 >> 2] = 2;
  mftCall_vi(HEAP32[i17 + 744 >> 2] | 0, 1029);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP8[i18 >> 0] | 0) == 0 | (i1 & 2 | 0) == 0) {
   HEAP32[i3 >> 2] = i1 | 2;
   i10 = HEAP32[i17 + 768 >> 2] | 0;
   mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 1) | 0);
  }
 }
 mftCall_vi(HEAP32[i17 + 68 >> 2] | 0, 2304);
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 718 >> 0] | 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 718 >> 0] | 0) {
  i1 = i17 + 1596 | 0;
  if (!(HEAP8[i18 >> 0] | 0)) {
   HEAP8[i1 >> 0] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i16 = 35;
  } else {
   if (!(HEAP8[i1 >> 0] | 0)) break;
   HEAP8[i1 >> 0] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 & 1024 | 0) i16 = 35;
  }
  if ((i16 | 0) == 35) {
   HEAP32[i3 >> 2] = i1 & -1025;
   i10 = HEAP32[i4 >> 2] | 0;
   mftCall_vi(i10 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i12 >> 2] | 0, 10) | 0);
  }
  mftCall_vii(HEAP32[i17 + 780 >> 2] | 0, 1032, 6914);
 } while (0);
 i1 = i17 + 1860 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 690 >> 0] | 0) {
  i10 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0;
  i3 = (i10 | 0) > 32 ? 32 : i10;
  if ((i10 | 0) > 0) {
   i4 = i17 + 832 | 0;
   i1 = 0;
   do {
    i2 = i17 + 1860 + (i1 << 2) | 0;
    if (!(HEAP8[i18 >> 0] | 0)) i16 = 42; else if (HEAP32[i2 >> 2] | 0) i16 = 42;
    if ((i16 | 0) == 42) {
     i16 = 0;
     HEAP32[i2 >> 2] = 0;
     mftCall_vii(HEAP32[i4 >> 2] | 0, i1 | 0, 0);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
 }
 if (HEAP32[gb + 1451084 >> 2] | 0) HEAP32[gb + 1451088 >> 2] = 0;
 i10 = i17 + 892 | 0;
 i3 = i17 + 644 | 0;
 HEAP32[i10 >> 2] = -1;
 HEAP32[i10 + 4 >> 2] = -1;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP32[i10 + 12 >> 2] = -1;
 HEAP32[i10 + 16 >> 2] = -1;
 HEAP32[i10 + 20 >> 2] = -1;
 mftCall_vii(HEAP32[i3 >> 2] | 0, 34962, 0);
 mftCall_vii(HEAP32[i3 >> 2] | 0, 34963, 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 697 >> 0] | 0) mftCall_vii(HEAP32[i3 >> 2] | 0, 36671, 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) {
  mftCall_vii(HEAP32[i3 >> 2] | 0, 36662, 0);
  mftCall_vii(HEAP32[i3 >> 2] | 0, 36663, 0);
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 661 >> 0] | 0) if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 560 >> 2] | 0) {
  i2 = i17 + 652 | 0;
  i1 = 0;
  do {
   HEAP32[i17 + 916 + (i1 << 2) >> 2] = -1;
   mftCall_viii(HEAP32[i2 >> 2] | 0, 35345, i1 | 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 560 >> 2] | 0) >>> 0);
 }
 HEAP32[i17 + 1580 >> 2] = -1;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 511 >> 0] | 0) if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 564 >> 2] | 0) {
  i2 = i17 + 652 | 0;
  i1 = 0;
  do {
   HEAP32[i17 + 1172 + (i1 << 2) >> 2] = -1;
   mftCall_viii(HEAP32[i2 >> 2] | 0, 35982, i1 | 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 564 >> 2] | 0) >>> 0);
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 568 >> 2] | 0) {
   i2 = i17 + 652 | 0;
   i1 = 0;
   do {
    HEAP32[i17 + 1188 + (i1 << 2) >> 2] = -1;
    mftCall_viii(HEAP32[i2 >> 2] | 0, 37074, i1 | 0, 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 568 >> 2] | 0) >>> 0);
  }
  if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 572 >> 2] | 0) {
   i2 = i17 + 652 | 0;
   i1 = 0;
   do {
    HEAP32[i17 + 1284 + (i1 << 2) >> 2] = -1;
    mftCall_viii(HEAP32[i2 >> 2] | 0, 37568, i1 | 0, 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 572 >> 2] | 0) >>> 0);
  }
  mftCall_vii(HEAP32[i3 >> 2] | 0, 37102, 0);
 }
 i1 = i17 + 868 | 0;
 HEAP32[i1 >> 2] = -1;
 i4 = i17 + 872 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 mftCall_vi(HEAP32[i17 + 516 >> 2] | 0, 0);
 i4 = i17 + 1600 | 0;
 HEAP32[i4 >> 2] = -1;
 i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i5 = i17 + 808 | 0;
  i6 = i17 + 812 | 0;
  do {
   i2 = i1;
   i1 = i1 + -1 | 0;
   i3 = i17 + 1604 + (i1 << 2) | 0;
   HEAP32[i3 >> 2] = 0;
   if (!(HEAP8[i18 >> 0] | 0)) i16 = 71; else if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) i16 = 71;
   do if ((i16 | 0) == 71) {
    i16 = 0;
    mftCall_vi(HEAP32[i5 >> 2] | 0, i2 + 33983 | 0);
    HEAP32[i4 >> 2] = i1;
    if (HEAP8[i18 >> 0] | 0) if (!(HEAP32[i3 >> 2] | 0)) break;
    i10 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, 2) | 0;
    mftCall_vii(HEAP32[i6 >> 2] | 0, i10 | 0, 0);
    HEAP32[i17 + 1604 + (HEAP32[i4 >> 2] << 2) >> 2] = 0;
    HEAP32[i17 + 1732 + (HEAP32[i4 >> 2] << 2) >> 2] = 2;
   } while (0);
  } while ((i2 | 0) > 1);
 }
 do if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -5 | 0) >>> 0 < 8) i16 = 77; else {
  if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -2 | 0) >>> 0 < 3) {
   i16 = 77;
   break;
  }
  i1 = i17 + 776 | 0;
 } while (0);
 if ((i16 | 0) == 77) {
  i1 = i17 + 776 | 0;
  mftCall_vii(HEAP32[i1 >> 2] | 0, 3314, 0);
 }
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3333, 1);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3317, 1);
 i8 = i17 + 876 | 0;
 i6 = i11 + 4 | 0;
 i9 = i17 + 884 | 0;
 i10 = i17 + 544 | 0;
 i2 = i17 + 876 | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -559030611;
 __ZNK14GfxContextGLES13GetDefaultFBOEv(i11, i13);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = (i1 | 0) == 0;
 if (i5) {
  if (HEAP32[i2 >> 2] | 0) i16 = 80;
 } else i16 = 80;
 do if ((i16 | 0) == 80) {
  if ((HEAP32[i17 + 880 >> 2] | 0) == (i4 | 0)) if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) break;
  i7 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i12 >> 2] | 0, 0) | 0;
  i3 = i4;
  if ((i7 | 0) == 36160) {
   i2 = i8;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i9;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i3;
  } else {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i3;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  if (i5) i16 = 87; else if ((HEAP32[i15 >> 2] | 0) == (i4 | 0)) i16 = 87; else i1 = -1;
  mftCall_vii(i2 | 0, i7 | 0, i1 | 0);
 } while (0);
 i1 = i9;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -559030611;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 >> 2] = -1;
 i1 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i12 >> 2] | 0, 1) | 0;
 if ((i1 | 0) == 36160) {
  i12 = i8;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = -1;
 }
 i12 = i9;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = -1;
 mftCall_vii(HEAP32[i10 >> 2] | 0, i1 | 0, 0);
 i1 = i17 + 1564 | 0;
 __ZNK14GfxContextGLES21GetDefaultVertexArrayEv(i14, i13);
 i12 = i14;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 695 >> 0] | 0) {
  i2 = i17 + 1316 | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = -1;
  HEAP32[i3 + 4 >> 2] = -559030611;
  i3 = i1;
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if ((HEAP8[i18 >> 0] | 0) != 0 & (i3 | 0) == (-559030611 | 0) & (i1 | 0) == -1) break;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = HEAP32[i17 + 688 >> 2] | 0;
  if (!i1) i16 = 92; else if ((HEAP32[i15 >> 2] | 0) == (i3 | 0)) i16 = 92; else i1 = -1;
  mftCall_vi(i2 | 0, i1 | 0);
 } while (0);
 i3 = i17 + 1572 | 0;
 if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0)) {
  HEAP32[i3 >> 2] = 0;
  i3 = i17 + 1324 | 0;
  i4 = i17 + 1340 | 0;
  i5 = i17 + 1356 | 0;
  i6 = i17 + 1372 | 0;
  i7 = i17 + 1388 | 0;
  i8 = i17 + 1404 | 0;
  i9 = i17 + 1420 | 0;
  i10 = i17 + 1436 | 0;
  i11 = i17 + 1452 | 0;
  i12 = i17 + 1468 | 0;
  i13 = i17 + 1484 | 0;
  i14 = i17 + 1500 | 0;
  i15 = i17 + 1516 | 0;
  i16 = i17 + 1532 | 0;
  i17 = i17 + 1548 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP8[i3 + 12 >> 0] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP8[i4 + 12 >> 0] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP8[i5 + 12 >> 0] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP8[i6 + 12 >> 0] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP8[i7 + 12 >> 0] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP8[i8 + 12 >> 0] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP8[i9 + 12 >> 0] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP8[i10 + 12 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP8[i11 + 12 >> 0] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP8[i12 + 12 >> 0] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP8[i13 + 12 >> 0] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP8[i14 + 12 >> 0] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP8[i15 + 12 >> 0] = 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP8[i16 + 12 >> 0] = 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP8[i17 + 12 >> 0] = 0;
  HEAP8[i18 >> 0] = 1;
  STACKTOP = i19;
  return;
 }
 i5 = i17 + 708 | 0;
 i1 = 0;
 do {
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = 1 << i1;
  if (!((HEAP8[i18 >> 0] | 0) != 0 & (i2 & i4 | 0) == 0)) {
   HEAP32[i3 >> 2] = i2 & ~i4;
   mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0) >>> 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i17 + 1324 | 0;
 i4 = i17 + 1340 | 0;
 i5 = i17 + 1356 | 0;
 i6 = i17 + 1372 | 0;
 i7 = i17 + 1388 | 0;
 i8 = i17 + 1404 | 0;
 i9 = i17 + 1420 | 0;
 i10 = i17 + 1436 | 0;
 i11 = i17 + 1452 | 0;
 i12 = i17 + 1468 | 0;
 i13 = i17 + 1484 | 0;
 i14 = i17 + 1500 | 0;
 i15 = i17 + 1516 | 0;
 i16 = i17 + 1532 | 0;
 i17 = i17 + 1548 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP8[i6 + 12 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP8[i7 + 12 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP8[i9 + 12 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP8[i10 + 12 >> 0] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP8[i11 + 12 >> 0] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP8[i12 + 12 >> 0] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP8[i13 + 12 >> 0] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP8[i14 + 12 >> 0] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP8[i15 + 12 >> 0] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP8[i16 + 12 >> 0] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP8[i17 + 12 >> 0] = 0;
 HEAP8[i18 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZN16Physics2DManager11FixedUpdateEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 32 | 0;
 i26 = i27 + 16 | 0;
 i22 = i27;
 if ((HEAP16[gb + 1457524 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457524 | 0, i24);
  i25 = gb + 1457524 | 0;
 } else i25 = 0;
 f7 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
 if ((HEAP16[gb + 1457536 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457536 | 0, i24);
  i4 = gb + 1457536 | 0;
 } else i4 = 0;
 i21 = i23 + 596 | 0;
 i8 = i23 + 600 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i21 | 0)) do {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  do if (HEAP8[i3 + 48 >> 0] | 0) if (!(HEAP32[i3 + 56 >> 2] | 0)) {
   HEAP8[i1 + 109 >> 0] = 0;
   break;
  } else {
   i20 = i1 + 12 | 0;
   i19 = i1 + 68 | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i20 = i1 + 24 | 0;
   i19 = i1 + 80 | 0;
   HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP8[i1 + 109 >> 0] = 1;
   break;
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i21 | 0));
 if (i4 | 0) __Z12profiler_endP19ProfilerInformation(i4);
 i2 = __Z21GetManagerFromContexti(16) | 0;
 if ((HEAP16[gb + 1457560 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457560 | 0, i24);
  i1 = gb + 1457560 | 0;
 } else i1 = 0;
 __ZN7b2World4StepEfii(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, f7, HEAP32[i2 + 40 >> 2] | 0, HEAP32[i2 + 44 >> 2] | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if ((HEAP16[gb + 1457584 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457584 | 0, i24);
  i20 = gb + 1457584 | 0;
 } else i20 = 0;
 i18 = i23 + 616 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 if (i2 | 0) {
  i3 = i23 + 604 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i4 = __ZN14MessageHandler3GetEv() | 0;
   i5 = HEAP32[i5 + 24 >> 2] | 0;
   if ((i5 | 0) != -2147483648) {
    i17 = (Math_imul(HEAP32[i4 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i5 | 0;
    i19 = (HEAP32[i4 + 16 >> 2] | 0) + (i17 >>> 5 << 2) | 0;
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & ~(1 << (i17 & 31));
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i19 = i23 + 624 | 0;
 HEAP8[i19 >> 0] = 0;
 i17 = i23 + 625 | 0;
 if (HEAP8[i17 >> 0] | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i21 | 0)) do {
   i16 = i1 + 4 | 0;
   i15 = i1;
   i1 = HEAP32[i16 >> 2] | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i16 >> 2] = 0;
  } while ((i1 | 0) != (i21 | 0));
  HEAP32[i8 >> 2] = i21;
  HEAP32[i21 >> 2] = i21;
 }
 i16 = i24 + 4 | 0;
 i13 = 0;
 do {
  i1 = HEAP32[i23 + 68 + (i13 << 3) + 4 >> 2] | 0;
  i14 = i23 + 68 + (i13 << 3) | 0;
  i2 = i1;
  if ((i2 | 0) != (i14 | 0)) {
   i15 = (i13 | 0) > 0;
   do {
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    do if (HEAP8[i12 + 48 >> 0] | 0) {
     i10 = i12 + 116 | 0;
     i3 = i12 + 226 | 0;
     i9 = HEAP16[i3 >> 1] | 0;
     i1 = (i9 & 65535) >>> 8 & 255;
     if ((i9 & 255) << 24 >> 24) {
      HEAP8[i3 >> 0] = 0;
      i8 = i12 + 124 | 0;
      i3 = HEAP32[i8 >> 2] | 0;
      i9 = HEAP32[i3 + 92 >> 2] | 0;
      if (i9) {
       i4 = HEAP32[i12 + 212 >> 2] | 0;
       i5 = HEAP32[i12 + 216 >> 2] | 0;
       if (!(HEAP32[i9 >> 2] | 0)) i1 = i3; else {
        f6 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f6 = Math_fround(f6 * f6);
        f11 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        do if (Math_fround(f6 + Math_fround(f11 * f11)) > Math_fround(0.0)) {
         i1 = i9 + 4 | 0;
         i3 = HEAPU16[i1 >> 1] | 0;
         if (i3 & 2 | 0) break;
         HEAP16[i1 >> 1] = i3 | 2;
         HEAPF32[i9 + 144 >> 2] = Math_fround(0.0);
        } while (0);
        HEAP32[i9 + 64 >> 2] = i4;
        HEAP32[i9 + 68 >> 2] = i5;
        i1 = HEAP32[i8 >> 2] | 0;
       }
       HEAP32[i9 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
       i1 = HEAP8[i12 + 227 >> 0] | 0;
      }
     }
     if (i1 << 24 >> 24) {
      HEAP8[i12 + 227 >> 0] = 0;
      i3 = HEAP32[i12 + 124 >> 2] | 0;
      i4 = HEAP32[i3 + 92 >> 2] | 0;
      if (i4 | 0) {
       f6 = Math_fround(HEAPF32[i12 + 220 >> 2]);
       do if (HEAP32[i4 >> 2] | 0) {
        i5 = i4 + 4 | 0;
        i1 = HEAP16[i5 >> 1] | 0;
        if (i1 & 16) break;
        do if (Math_fround(f6 * f6) > Math_fround(0.0)) {
         i1 = i1 & 65535;
         if (i1 & 2 | 0) break;
         HEAP16[i5 >> 1] = i1 | 2;
         HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
        } while (0);
        HEAPF32[i4 + 72 >> 2] = f6;
       } while (0);
       HEAP32[i4 + 136 >> 2] = HEAP32[i3 + 40 >> 2];
      }
     }
     do if (HEAP8[i17 >> 0] | 0) if (HEAP32[i12 + 56 >> 2] | 0) {
      if ((i10 | 0) == (i21 | 0)) break;
      i1 = HEAP32[i10 >> 2] | 0;
      if (!i1) i1 = i12 + 120 | 0; else {
       i9 = i12 + 120 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
       HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
       HEAP32[i10 >> 2] = 0;
       HEAP32[i9 >> 2] = 0;
       i1 = i9;
      }
      i9 = HEAP32[i21 >> 2] | 0;
      HEAP32[i10 >> 2] = i9;
      HEAP32[i1 >> 2] = i21;
      HEAP32[i9 + 4 >> 2] = i10;
      HEAP32[HEAP32[i1 >> 2] >> 2] = i10;
     } while (0);
     i4 = HEAP32[i12 + 92 >> 2] | 0;
     if (i4 | 0) {
      if (!(HEAP16[i4 + 4 >> 1] & 2)) {
       if (!i15) break;
       if ((HEAP32[i12 + 68 >> 2] | 0) != 2) break;
      }
      i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
      i8 = i4 + 12 | 0;
      i1 = i8;
      i3 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      i5 = i4 + 56 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!((i4 & 2139095040 | 0) != 2139095040 & ((i3 & 2139095040 | 0) != 2139095040 & (i1 & 2139095040 | 0) != 2139095040))) {
       __ZN11Rigidbody2D16CorrectBodyStateEv(i12);
       i1 = i8;
       i4 = HEAP32[i5 >> 2] | 0;
       i3 = HEAP32[i1 >> 2] | 0;
       i1 = HEAP32[i1 + 4 >> 2] | 0;
      }
      __ZNK9Transform11GetPositionEv(i24, i9);
      HEAP32[i24 >> 2] = i3;
      HEAP32[i16 >> 2] = i1;
      __ZNK9Transform11GetRotationEv(i22, i9);
      __ZN16PhysicsUtility2D21XRotUpdateFromRBAngleERK11Quaternionff(i26, i22, (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      i10 = i12 + 224 | 0;
      HEAP8[i10 >> 0] = 1;
      __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i9, i24, i26);
      i9 = i12 + 184 | 0;
      HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
      i9 = i12 + 196 | 0;
      HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
      i9 = i12 + 156 | 0;
      HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
      i12 = i12 + 168 | 0;
      HEAP32[i12 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
      HEAP8[i10 >> 0] = 0;
     }
    } while (0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i14 | 0));
  }
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 64);
 HEAP8[i17 >> 0] = 0;
 i2 = HEAP32[i18 >> 2] | 0;
 if (i2 | 0) {
  i3 = i23 + 604 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i4 = __ZN14MessageHandler3GetEv() | 0;
   i5 = HEAP32[i5 + 24 >> 2] | 0;
   if ((i5 | 0) != -2147483648) {
    i21 = (Math_imul(HEAP32[i4 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i5 | 0;
    i22 = (HEAP32[i4 + 16 >> 2] | 0) + (i21 >>> 5 << 2) | 0;
    HEAP32[i22 >> 2] = 1 << (i21 & 31) | HEAP32[i22 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP8[i19 >> 0] = 1;
 if (i20 | 0) __Z12profiler_endP19ProfilerInformation(i20);
 if ((HEAP16[gb + 1457548 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457548 | 0, i24);
  i3 = gb + 1457548 | 0;
 } else i3 = 0;
 i1 = HEAP32[i23 + 584 >> 2] | 0;
 i4 = i23 + 580 | 0;
 i2 = i1;
 if ((i2 | 0) != (i4 | 0)) do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (HEAP32[i1 + 48 >> 2] | 0) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, +f7);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i4 | 0));
 if (i3 | 0) __Z12profiler_endP19ProfilerInformation(i3);
 if ((HEAP16[gb + 1457572 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457572 | 0, i24);
  i16 = gb + 1457572 | 0;
 } else i16 = 0;
 i2 = HEAP32[i23 + 592 >> 2] | 0;
 i14 = i23 + 588 | 0;
 i1 = i2;
 if ((i1 | 0) != (i14 | 0)) {
  i15 = f7 < Math_fround(.0000999999974);
  f11 = Math_fround(Math_fround(1.0) / f7);
  i10 = i24 + 4 | 0;
  i12 = i24 + 8 | 0;
  i13 = i24 + 4 | 0;
  do {
   i4 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
   f6 = Math_fround(HEAPF32[i4 + 44 >> 2]);
   f7 = Math_fround(HEAPF32[i4 + 48 >> 2]);
   if (f6 != Math_fround(inf)) {
    i1 = HEAP32[i4 + 60 >> 2] | 0;
    if (i15 | (i1 | 0) == 0) {
     i1 = HEAP32[gb + 1162356 >> 2] | 0;
     i3 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
    } else {
     mftCall_viif(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i24 | 0, i1 | 0, +f11);
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i10 >> 2] | 0;
    }
    f28 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f28 = Math_fround(f28 * f28);
    f29 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (Math_fround(Math_sqrt(Math_fround(Math_fround(f29 * f29) + f28))) > f6) i9 = 106; else i9 = 101;
   } else i9 = 101;
   do if ((i9 | 0) == 101) {
    i9 = 0;
    if (!(f7 != Math_fround(inf))) break;
    i1 = HEAP32[i4 + 60 >> 2] | 0;
    if (i15 | (i1 | 0) == 0) f6 = Math_fround(0.0); else f6 = Math_fround(+mftCall_fif(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, +f11));
    if (f6 > f7) i9 = 106;
   } while (0);
   do if ((i9 | 0) == 106) {
    i9 = 0;
    i8 = HEAP32[i4 + 4 >> 2] | 0;
    i23 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
    i22 = HEAP32[i4 + 28 >> 2] | 0;
    HEAP32[i24 >> 2] = gb + 32628;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = i4;
    __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i22, gb + 1104976 | 0, i24);
    __Z24SetExecutionRestrictions21ExecutionRestrictions(i23) | 0;
    if (!i8) break;
    HEAP32[i26 >> 2] = i8;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    do if (!i1) i9 = 112; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i5 = HEAP32[i1 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i24, i1, i26);
      i3 = HEAP32[i24 >> 2] | 0;
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i23 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i3 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i3 << 3) | 0;
      i4 = HEAP32[i23 + 28 >> 2] | 0;
      i5 = HEAP32[i23 + 32 >> 2] | 0;
      i1 = i23;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) {
      i9 = 112;
      break;
     }
     if (!(HEAP32[i3 + 4 >> 2] | 0)) i9 = 114;
    } while (0);
    if ((i9 | 0) == 112) i9 = 114;
    if ((i9 | 0) == 114) {
     i9 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i8) | 0)) break;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i26 >> 2] = i8;
    do if (!i1) i9 = 121; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i24, i1, i26);
      i3 = HEAP32[i24 >> 2] | 0;
      i23 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
      i9 = 121;
      break;
     }
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 123;
    } while (0);
    if ((i9 | 0) == 121) i9 = 123;
    if ((i9 | 0) == 123) {
     i9 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
    }
    if (!(HEAP32[i1 + 28 >> 2] | 0)) break;
    HEAP32[i26 >> 2] = i8;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    do if (!i1) i9 = 130; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i24, i1, i26);
      i3 = HEAP32[i24 >> 2] | 0;
      i23 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
      i9 = 130;
      break;
     }
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 132;
    } while (0);
    if ((i9 | 0) == 130) i9 = 132;
    if ((i9 | 0) == 132) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
    __Z22DestroyObjectHighLevelP6Objectb(i1, 1);
   } while (0);
   i1 = i2;
  } while ((i1 | 0) != (i14 | 0));
 }
 if (i16 | 0) __Z12profiler_endP19ProfilerInformation(i16);
 if ((HEAP16[gb + 1457596 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457596 | 0, i24);
  i1 = gb + 1457596 | 0;
 } else i1 = 0;
 i2 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 __ZN19CollisionListener2D16ReportCollisionsEv((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0);
 if ((HEAP16[gb + 1457560 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457560 | 0, i24);
  __Z12profiler_endP19ProfilerInformation(gb + 1457560 | 0);
 }
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i2) | 0;
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if (!i25) {
  STACKTOP = i27;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i25);
 STACKTOP = i27;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5writeERN5physx8debugger15PvdOutputStreamE(i11, i19) {
 i11 = i11 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 20 | 0;
 i15 = i21 + 16 | 0;
 i18 = i21 + 8 | 0;
 i16 = i21 + 4 | 0;
 i10 = i21;
 i17 = i21 + 12 | 0;
 HEAP32[i17 >> 2] = 1;
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i17 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i11 + 240 | 0, 4) | 0;
 i17 = i11 + 160 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i5 + 112 >> 2];
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 60 | 0, 4) | 0;
 i8 = i5 + 88 | 0;
 L1 : do if (!(HEAP32[i5 + 92 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i5 + 96 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L1;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i5 + 80 | 0;
 i7 = i5 + 84 | 0;
 i4 = i5 + 96 | 0;
 L8 : while (1) {
  do {
   if ((i1 | 0) == -1) break L8;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, (HEAP32[i6 >> 2] | 0) + (i1 << 3) | 0, 4) | 0;
   HEAP32[i15 >> 2] = (_strlen(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0) | 0) + 1;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L8;
   }
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i1 = i2; else continue L8;
  }
 }
 i1 = i11 + 152 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i16 | 0, 4) | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i11 + 148 | 0;
  i7 = 0;
  do {
   i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   i14 = (i5 | 0) != 0;
   HEAP32[i18 >> 2] = i14 & 1;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i18 | 0, 4) | 0;
   if (i14) {
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i5 + 4 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i5 + 8 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 12 | 0, 4) | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i5 + 20 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 24 | 0, 4) | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i5 + 28 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i5 + 32 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    HEAP32[i20 >> 2] = HEAP32[i5 + 36 >> 2];
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 40 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 44 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i5 + 48 | 0, 4) | 0;
    i3 = i5 + 68 | 0;
    HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    if (HEAP32[i3 >> 2] | 0) {
     i4 = i5 + 64 | 0;
     i6 = 0;
     do {
      i14 = HEAP32[i4 >> 2] | 0;
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i14 + (i6 << 3) + 4 | 0, 4) | 0;
      i13 = HEAP32[i17 >> 2] | 0;
      HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0, HEAP32[i14 + (i6 << 3) >> 2] | 0) | 0;
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
      i6 = i6 + 1 | 0;
     } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
    }
    i14 = HEAP32[i17 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0, HEAP32[i5 + 16 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i6 = i11 + 128 | 0;
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i16 | 0, 4) | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i11 + 124 | 0;
  i9 = 0;
  do {
   i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i14 = (i8 | 0) != 0;
   HEAP32[i18 >> 2] = i14 & 1;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i18 | 0, 4) | 0;
   if (i14) {
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 12 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 16 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 20 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 24 | 0, 4) | 0;
    HEAP8[i20 >> 0] = HEAP8[i8 + 68 >> 0] | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 1) | 0;
    HEAP8[i20 >> 0] = HEAP8[i8 + 69 >> 0] | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 1) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 28 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 32 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 36 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 48 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 52 | 0, 4) | 0;
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i8 + 56 | 0, 4) | 0;
    i1 = i8 + 88 | 0;
    HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
    if (HEAP32[i1 >> 2] | 0) {
     i2 = i8 + 84 | 0;
     i3 = 0;
     do {
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, (HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 40 | 0, 4) | 0;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
    }
    i5 = i8 + 112 | 0;
    HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    if (HEAP32[i5 >> 2] | 0) {
     i1 = i8 + 108 | 0;
     i2 = 0;
     do {
      i14 = HEAP32[i1 >> 2] | 0;
      HEAP32[i20 >> 2] = HEAP32[i14 + (i2 << 3) >> 2];
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i14 + (i2 << 3) + 4 | 0, 4) | 0;
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
    }
    i2 = i8 + 136 | 0;
    HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
    mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
    i4 = i8 + 132 | 0;
    if (!(HEAP32[i2 >> 2] | 0)) i1 = 0; else {
     i3 = 0;
     do {
      i1 = HEAP32[i4 >> 2] | 0;
      HEAP32[i20 >> 2] = HEAP32[i1 + (i3 << 3) >> 2];
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
      mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 + (i3 << 3) + 4 | 0, 4) | 0;
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i2 >> 2] | 0;
     } while (i3 >>> 0 < i1 >>> 0);
    }
    i13 = HEAP32[i8 + 108 >> 2] | 0;
    i14 = i13 + (HEAP32[i5 >> 2] << 3) | 0;
    HEAP32[i8 + 40 >> 2] = i13;
    HEAP32[i8 + 44 >> 2] = i14;
    i14 = HEAP32[i4 >> 2] | 0;
    HEAP32[i8 + 60 >> 2] = i14;
    HEAP32[i8 + 64 >> 2] = i14 + (i1 << 3);
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i14 = i11 + 232 | 0;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 | 0, 4) | 0;
 if (!(HEAP32[i14 >> 2] | 0)) {
  STACKTOP = i21;
  return;
 }
 i11 = i11 + 228 | 0;
 i13 = 0;
 do {
  i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  i10 = (i12 | 0) != 0;
  HEAP32[i16 >> 2] = i10 & 1;
  mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i16 | 0, 4) | 0;
  if (i10) {
   i4 = HEAP32[i17 >> 2] | 0;
   HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i12 + 12 | 0, 4) | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, HEAP32[i12 + 16 >> 2] | 0) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, HEAP32[i12 + 20 >> 2] | 0) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i12 + 24 | 0, 4) | 0;
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i12 + 36 | 0, 4) | 0;
   i4 = i12 + 68 | 0;
   HEAP32[i18 >> 2] = HEAP32[i4 >> 2];
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i18 | 0, 4) | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i1 = i12 + 64 | 0;
    i2 = 0;
    do {
     i10 = HEAP32[i1 >> 2] | 0;
     i9 = HEAP32[i17 >> 2] | 0;
     HEAP32[i20 >> 2] = mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0, HEAP32[i10 + (i2 * 76 | 0) + 52 >> 2] | 0) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
     i9 = HEAP32[i17 >> 2] | 0;
     HEAP32[i15 >> 2] = mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0, HEAP32[i10 + (i2 * 76 | 0) + 56 >> 2] | 0) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i15 | 0, 4) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 + (i2 * 76 | 0) + 60 | 0, 4) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 + (i2 * 76 | 0) + 64 | 0, 4) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 + (i2 * 76 | 0) + 68 | 0, 4) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 + (i2 * 76 | 0) + 72 | 0, 4) | 0;
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i10 + (i2 * 76 | 0) + 40 | 0, 4) | 0;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
   }
   i10 = i12 + 116 | 0;
   HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
   mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i20 | 0, 4) | 0;
   if (!(HEAP32[i10 >> 2] | 0)) i2 = 0; else {
    i1 = i12 + 112 | 0;
    i3 = 0;
    do {
     mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, (HEAP32[i1 >> 2] | 0) + (i3 << 2) | 0, 4) | 0;
     i3 = i3 + 1 | 0;
     i2 = HEAP32[i10 >> 2] | 0;
    } while (i3 >>> 0 < i2 >>> 0);
   }
   i8 = i12 + 76 | 0;
   i9 = i12 + 92 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != (i7 | 0)) {
    HEAP32[i9 >> 2] = 0;
    if (!i7) i1 = 0; else {
     i3 = i12 + 64 | 0;
     i4 = i12 + 96 | 0;
     i5 = i12 + 88 | 0;
     i1 = 0;
     i6 = 0;
     do {
      i2 = HEAP32[i3 >> 2] | 0;
      if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i22 = HEAP32[i5 >> 2] | 0;
       HEAP32[i22 + (i1 * 76 | 0) >> 2] = gb + 148864 + 8;
       i23 = i2 + (i6 * 76 | 0) + 4 | 0;
       i24 = HEAP32[i23 + 4 >> 2] | 0;
       i25 = i22 + (i1 * 76 | 0) + 4 | 0;
       HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i25 + 4 >> 2] = i24;
       HEAP32[i22 + (i1 * 76 | 0) + 12 >> 2] = HEAP32[i2 + (i6 * 76 | 0) + 12 >> 2];
       i25 = i2 + (i6 * 76 | 0) + 16 | 0;
       i24 = HEAP32[i25 + 4 >> 2] | 0;
       i23 = i22 + (i1 * 76 | 0) + 16 | 0;
       HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
       HEAP32[i23 + 4 >> 2] = i24;
       HEAP32[i22 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i2 + (i6 * 76 | 0) + 24 >> 2];
       i23 = i22 + (i1 * 76 | 0) + 28 | 0;
       i24 = i2 + (i6 * 76 | 0) + 28 | 0;
       HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
       HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
       HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
       HEAP32[i22 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i2 + (i6 * 76 | 0) + 40 >> 2];
       i23 = i2 + (i6 * 76 | 0) + 44 | 0;
       i24 = HEAP32[i23 + 4 >> 2] | 0;
       i25 = i22 + (i1 * 76 | 0) + 44 | 0;
       HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
       HEAP32[i25 + 4 >> 2] = i24;
       i25 = i2 + (i6 * 76 | 0) + 52 | 0;
       i24 = HEAP32[i25 + 4 >> 2] | 0;
       i23 = i22 + (i1 * 76 | 0) + 52 | 0;
       HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
       HEAP32[i23 + 4 >> 2] = i24;
       HEAP32[i22 + (i1 * 76 | 0) + 60 >> 2] = HEAP32[i2 + (i6 * 76 | 0) + 60 >> 2];
       i1 = i22 + (i1 * 76 | 0) + 64 | 0;
       i2 = i2 + (i6 * 76 | 0) + 64 | 0;
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
       HEAP32[i9 >> 2] = i1;
      } else {
       __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i8, i2 + (i6 * 76 | 0) | 0) | 0;
       i1 = HEAP32[i9 >> 2] | 0;
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i7 | 0));
     i2 = HEAP32[i10 >> 2] | 0;
    }
   }
   i25 = HEAP32[i12 + 88 >> 2] | 0;
   HEAP32[i12 + 28 >> 2] = i25;
   HEAP32[i12 + 32 >> 2] = i25 + (i1 * 76 | 0);
   i25 = HEAP32[i12 + 112 >> 2] | 0;
   HEAP32[i12 + 40 >> 2] = i25;
   HEAP32[i12 + 44 >> 2] = i25 + (i2 << 2);
  }
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 STACKTOP = i21;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i1, i2, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23;
 L1 : while (1) {
  i15 = i2;
  i20 = i2 + -12 | 0;
  i16 = i2 + -24 | 0;
  i17 = i20 + 11 | 0;
  i18 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    switch ((i3 | 0) / 12 | 0 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 11;
      break L1;
     }
    case 4:
     {
      i22 = 12;
      break L1;
     }
    case 5:
     {
      i22 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 114;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 84) {
     i22 = 15;
     break L1;
    }
    i4 = (i3 >>> 0) / 24 | 0;
    i9 = i1 + (i4 * 12 | 0) | 0;
    if ((i3 | 0) > 11988) {
     i3 = (i3 >>> 0) / 48 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_(i1, i1 + (i3 * 12 | 0) | 0, i9, i9 + (i3 * 12 | 0) | 0, i20, i19) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i1, i9, i20, i19) | 0;
    i12 = i1 + 11 | 0;
    i11 = HEAP8[i12 >> 0] | 0;
    i10 = i11 << 24 >> 24 < 0;
    i13 = i1 + 4 | 0;
    i11 = i10 ? HEAP32[i13 >> 2] | 0 : i11 & 255;
    i8 = HEAP8[i9 + 11 >> 0] | 0;
    i5 = i8 << 24 >> 24 < 0;
    i8 = i5 ? HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] | 0 : i8 & 255;
    i4 = i8 >>> 0 < i11 >>> 0 ? i8 : i11;
    if (!i4) i22 = 21; else {
     i4 = _memcmp(i10 ? HEAP32[i1 >> 2] | 0 : i1, i5 ? HEAP32[i9 >> 2] | 0 : i9, i4) | 0;
     if (!i4) i22 = 21; else if ((i4 | 0) < 0) {
      i4 = i20;
      break;
     }
    }
    if ((i22 | 0) == 21) {
     i22 = 0;
     if (i11 >>> 0 < i8 >>> 0) {
      i4 = i20;
      break;
     }
    }
    if ((i1 | 0) != (i16 | 0)) if (i5) {
     i5 = i20;
     i4 = i16;
     while (1) {
      i7 = HEAP8[i4 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i5 + -8 >> 2] | 0 : i7 & 255;
      i5 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
      if (!i5) i22 = 28; else {
       i5 = _memcmp(i6 ? HEAP32[i4 >> 2] | 0 : i4, HEAP32[i9 >> 2] | 0, i5) | 0;
       if (!i5) i22 = 28; else if ((i5 | 0) < 0) {
        i22 = 76;
        break L5;
       }
      }
      if ((i22 | 0) == 28) {
       i22 = 0;
       if (i7 >>> 0 < i8 >>> 0) {
        i22 = 76;
        break L5;
       }
      }
      i5 = i4 + -12 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i7 = i4;
       i4 = i5;
       i5 = i7;
      }
     }
    } else {
     i5 = i20;
     i4 = i16;
     while (1) {
      i7 = HEAP8[i4 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i5 + -8 >> 2] | 0 : i7 & 255;
      i5 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
      if (!i5) i22 = 73; else {
       i5 = _memcmp(i6 ? HEAP32[i4 >> 2] | 0 : i4, i9, i5) | 0;
       if (!i5) i22 = 73; else if ((i5 | 0) < 0) {
        i22 = 76;
        break L5;
       }
      }
      if ((i22 | 0) == 73) {
       i22 = 0;
       if (i7 >>> 0 < i8 >>> 0) {
        i22 = 76;
        break L5;
       }
      }
      i5 = i4 + -12 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i7 = i4;
       i4 = i5;
       i5 = i7;
      }
     }
    }
    i3 = i1 + 12 | 0;
    i6 = HEAP8[i17 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i18 >> 2] | 0 : i6 & 255;
    i4 = i6 >>> 0 < i11 >>> 0 ? i6 : i11;
    if (!i4) i22 = 32; else {
     i4 = _memcmp(i10 ? HEAP32[i1 >> 2] | 0 : i1, i5 ? HEAP32[i20 >> 2] | 0 : i20, i4) | 0;
     if (!i4) i22 = 32; else if ((i4 | 0) >= 0) i22 = 34;
    }
    if ((i22 | 0) == 32) {
     i22 = 0;
     if (i11 >>> 0 >= i6 >>> 0) i22 = 34;
    }
    if ((i22 | 0) == 34) {
     i22 = 0;
     if ((i3 | 0) == (i20 | 0)) {
      i22 = 114;
      break L1;
     }
     L47 : do if (i10) while (1) {
      i6 = HEAP8[i3 + 11 >> 0] | 0;
      i5 = i6 << 24 >> 24 < 0;
      i6 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
      i4 = i6 >>> 0 < i11 >>> 0 ? i6 : i11;
      if (!i4) i22 = 39; else {
       i4 = _memcmp(HEAP32[i1 >> 2] | 0, i5 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0;
       if (!i4) i22 = 39; else if ((i4 | 0) < 0) break L47;
      }
      if ((i22 | 0) == 39) {
       i22 = 0;
       if (i11 >>> 0 < i6 >>> 0) break L47;
      }
      i3 = i3 + 12 | 0;
      if ((i3 | 0) == (i20 | 0)) {
       i22 = 114;
       break L1;
      }
     } else while (1) {
      i6 = HEAP8[i3 + 11 >> 0] | 0;
      i5 = i6 << 24 >> 24 < 0;
      i6 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
      i4 = i6 >>> 0 < i11 >>> 0 ? i6 : i11;
      if (!i4) i22 = 43; else {
       i4 = _memcmp(i1, i5 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0;
       if (!i4) i22 = 43; else if ((i4 | 0) < 0) break L47;
      }
      if ((i22 | 0) == 43) {
       i22 = 0;
       if (i11 >>> 0 < i6 >>> 0) break L47;
      }
      i3 = i3 + 12 | 0;
      if ((i3 | 0) == (i20 | 0)) {
       i22 = 114;
       break L1;
      }
     } while (0);
     HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     i3 = i3 + 12 | 0;
    }
    if ((i3 | 0) == (i20 | 0)) {
     i22 = 114;
     break L1;
    }
    i4 = i20;
    while (1) {
     i9 = HEAP8[i12 >> 0] | 0;
     i8 = i9 << 24 >> 24 < 0;
     i9 = i8 ? HEAP32[i13 >> 2] | 0 : i9 & 255;
     L69 : do if (i8) while (1) {
      i7 = HEAP8[i3 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
      i5 = i7 >>> 0 < i9 >>> 0 ? i7 : i9;
      if (!i5) i22 = 53; else {
       i5 = _memcmp(HEAP32[i1 >> 2] | 0, i6 ? HEAP32[i3 >> 2] | 0 : i3, i5) | 0;
       if (!i5) i22 = 53; else if ((i5 | 0) < 0) break L69;
      }
      if ((i22 | 0) == 53) {
       i22 = 0;
       if (i9 >>> 0 < i7 >>> 0) break L69;
      }
      i3 = i3 + 12 | 0;
     } else while (1) {
      i7 = HEAP8[i3 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
      i5 = i7 >>> 0 < i9 >>> 0 ? i7 : i9;
      if (!i5) i22 = 57; else {
       i5 = _memcmp(i1, i6 ? HEAP32[i3 >> 2] | 0 : i3, i5) | 0;
       if (!i5) i22 = 57; else if ((i5 | 0) < 0) break L69;
      }
      if ((i22 | 0) == 57) {
       i22 = 0;
       if (i9 >>> 0 < i7 >>> 0) break L69;
      }
      i3 = i3 + 12 | 0;
     } while (0);
     L87 : do if (i8) while (1) {
      i7 = i4 + -12 | 0;
      i6 = HEAP8[i7 + 11 >> 0] | 0;
      i5 = i6 << 24 >> 24 < 0;
      i6 = i5 ? HEAP32[i4 + -8 >> 2] | 0 : i6 & 255;
      i4 = i6 >>> 0 < i9 >>> 0 ? i6 : i9;
      if (i4 | 0) {
       i4 = _memcmp(HEAP32[i1 >> 2] | 0, i5 ? HEAP32[i7 >> 2] | 0 : i7, i4) | 0;
       if (i4 | 0) if ((i4 | 0) < 0) {
        i4 = i7;
        continue;
       } else {
        i4 = i7;
        break L87;
       }
      }
      if (i9 >>> 0 < i6 >>> 0) i4 = i7; else {
       i4 = i7;
       break;
      }
     } else while (1) {
      i7 = i4 + -12 | 0;
      i6 = HEAP8[i7 + 11 >> 0] | 0;
      i5 = i6 << 24 >> 24 < 0;
      i6 = i5 ? HEAP32[i4 + -8 >> 2] | 0 : i6 & 255;
      i4 = i6 >>> 0 < i9 >>> 0 ? i6 : i9;
      if (i4 | 0) {
       i4 = _memcmp(i1, i5 ? HEAP32[i7 >> 2] | 0 : i7, i4) | 0;
       if (i4 | 0) if ((i4 | 0) < 0) {
        i4 = i7;
        continue;
       } else {
        i4 = i7;
        break L87;
       }
      }
      if (i9 >>> 0 < i6 >>> 0) i4 = i7; else {
       i4 = i7;
       break;
      }
     } while (0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     };
     HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     i3 = i3 + 12 | 0;
    }
   }
   if ((i22 | 0) == 76) {
    i22 = 0;
    HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 12 | 0;
   L105 : do if (i5 >>> 0 < i4 >>> 0) {
    i11 = i9;
    while (1) {
     i10 = HEAP8[i11 + 11 >> 0] | 0;
     i9 = i10 << 24 >> 24 < 0;
     i10 = i9 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255;
     L108 : do if (i9) while (1) {
      i8 = HEAP8[i5 + 11 >> 0] | 0;
      i7 = i8 << 24 >> 24 < 0;
      i8 = i7 ? HEAP32[i5 + 4 >> 2] | 0 : i8 & 255;
      i6 = i10 >>> 0 < i8 >>> 0 ? i10 : i8;
      if (!i6) i22 = 82; else {
       i6 = _memcmp(i7 ? HEAP32[i5 >> 2] | 0 : i5, HEAP32[i11 >> 2] | 0, i6) | 0;
       if (!i6) i22 = 82; else if ((i6 | 0) >= 0) break L108;
      }
      if ((i22 | 0) == 82) {
       i22 = 0;
       if (i8 >>> 0 >= i10 >>> 0) break L108;
      }
      i5 = i5 + 12 | 0;
     } else while (1) {
      i8 = HEAP8[i5 + 11 >> 0] | 0;
      i7 = i8 << 24 >> 24 < 0;
      i8 = i7 ? HEAP32[i5 + 4 >> 2] | 0 : i8 & 255;
      i6 = i10 >>> 0 < i8 >>> 0 ? i10 : i8;
      if (!i6) i22 = 86; else {
       i6 = _memcmp(i7 ? HEAP32[i5 >> 2] | 0 : i5, i11, i6) | 0;
       if (!i6) i22 = 86; else if ((i6 | 0) >= 0) break L108;
      }
      if ((i22 | 0) == 86) {
       i22 = 0;
       if (i8 >>> 0 >= i10 >>> 0) break L108;
      }
      i5 = i5 + 12 | 0;
     } while (0);
     L126 : do if (i9) while (1) {
      i8 = i4 + -12 | 0;
      i7 = HEAP8[i8 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i4 + -8 >> 2] | 0 : i7 & 255;
      i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
      if (i4 | 0) {
       i4 = _memcmp(i6 ? HEAP32[i8 >> 2] | 0 : i8, HEAP32[i11 >> 2] | 0, i4) | 0;
       if (i4 | 0) if ((i4 | 0) < 0) {
        i4 = i8;
        break L126;
       } else {
        i4 = i8;
        continue;
       }
      }
      if (i7 >>> 0 < i10 >>> 0) {
       i4 = i8;
       break;
      } else i4 = i8;
     } else while (1) {
      i8 = i4 + -12 | 0;
      i7 = HEAP8[i8 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i4 + -8 >> 2] | 0 : i7 & 255;
      i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
      if (i4 | 0) {
       i4 = _memcmp(i6 ? HEAP32[i8 >> 2] | 0 : i8, i11, i4) | 0;
       if (i4 | 0) if ((i4 | 0) < 0) {
        i4 = i8;
        break L126;
       } else {
        i4 = i8;
        continue;
       }
      }
      if (i7 >>> 0 < i10 >>> 0) {
       i4 = i8;
       break;
      } else i4 = i8;
     } while (0);
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i11;
      i10 = i5;
      break L105;
     };
     HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     i11 = (i11 | 0) == (i5 | 0) ? i4 : i11;
     i5 = i5 + 12 | 0;
     i3 = i3 + 1 | 0;
    }
   } else {
    i4 = i9;
    i10 = i5;
   } while (0);
   do if ((i10 | 0) != (i4 | 0)) {
    i8 = HEAP8[i4 + 11 >> 0] | 0;
    i6 = i8 << 24 >> 24 < 0;
    i8 = i6 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
    i9 = HEAP8[i10 + 11 >> 0] | 0;
    i7 = i9 << 24 >> 24 < 0;
    i9 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i9 & 255;
    i5 = i9 >>> 0 < i8 >>> 0 ? i9 : i8;
    if (!i5) i22 = 103; else {
     i5 = _memcmp(i6 ? HEAP32[i4 >> 2] | 0 : i4, i7 ? HEAP32[i10 >> 2] | 0 : i10, i5) | 0;
     if (!i5) i22 = 103; else if ((i5 | 0) < 0) i5 = i10; else break;
    }
    if ((i22 | 0) == 103) {
     i22 = 0;
     if (i8 >>> 0 >= i9 >>> 0) break;
     i5 = i10;
    };
    HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEbT0_SB_T_(i1, i10, i19) | 0;
    i4 = i10 + 12 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEbT0_SB_T_(i4, i2, i19) | 0) {
     i22 = 113;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i10;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i22 = 112;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i1, i10, i19);
   i1 = i10 + 12 | 0;
  }
  if ((i22 | 0) == 112) {
   i22 = 0;
   __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i10 + 12 | 0, i2, i19);
   i2 = i10;
   continue;
  } else if ((i22 | 0) == 113) {
   i22 = 0;
   if (i3) {
    i22 = 114;
    break;
   } else {
    i2 = i10;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  i5 = HEAP8[i17 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i18 >> 2] | 0 : i5 & 255;
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
  i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
  if (!i2) i22 = 7; else {
   i2 = _memcmp(i4 ? HEAP32[i20 >> 2] | 0 : i20, i3 ? HEAP32[i1 >> 2] | 0 : i1, i2) | 0;
   if (!i2) i22 = 7; else if ((i2 | 0) >= 0) {
    STACKTOP = i23;
    return;
   }
  }
  do if ((i22 | 0) == 7) if (i5 >>> 0 < i6 >>> 0) break; else {
   STACKTOP = i23;
   return;
  } while (0);
  HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  STACKTOP = i23;
  return;
 } else if ((i22 | 0) == 11) {
  __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i1, i1 + 12 | 0, i20, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i22 | 0) == 12) {
  __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i20, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i22 | 0) == 13) {
  __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i1 + 36 | 0, i20, i19) | 0;
  STACKTOP = i23;
  return;
 } else if ((i22 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i1, i2, i19);
  STACKTOP = i23;
  return;
 } else if ((i22 | 0) == 114) {
  STACKTOP = i23;
  return;
 }
}

function __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i1, i58, i59, i57) {
 i1 = i1 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 i57 = i57 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i69 + 184 | 0;
 i23 = i69 + 168 | 0;
 i66 = i69 + 104 | 0;
 i60 = i69 + 88 | 0;
 i62 = i69 + 272 | 0;
 i65 = i69 + 84 | 0;
 i63 = i69 + 270 | 0;
 i64 = i69 + 56 | 0;
 i25 = i69 + 40 | 0;
 i26 = i69 + 24 | 0;
 i61 = i69;
 i35 = i69 + 268 | 0;
 HEAP32[i66 >> 2] = 0;
 HEAP32[i66 + 4 >> 2] = 0;
 HEAP32[i66 + 8 >> 2] = -1;
 HEAP16[i66 + 12 >> 1] = 0;
 i67 = i66 + 16 | 0;
 HEAP32[i67 >> 2] = 0;
 HEAP32[i67 + 4 >> 2] = 0;
 HEAP32[i67 + 8 >> 2] = 0;
 HEAP32[i67 + 12 >> 2] = 0;
 HEAP32[i67 + 16 >> 2] = 0;
 HEAP32[i67 + 20 >> 2] = 0;
 HEAPF32[i66 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i66 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i66 + 48 >> 2] = Math_fround(0.0);
 if (!i57) {
  i68 = 1;
  STACKTOP = i69;
  return i68 | 0;
 }
 i27 = i60 + 4 | 0;
 i28 = i1 + 20 | 0;
 i67 = i1 + 12 | 0;
 i29 = i1 + 41 | 0;
 i30 = i1 + 16 | 0;
 i31 = i1 + 24 | 0;
 i32 = i1 + 4 | 0;
 i33 = i1 + 32 | 0;
 i34 = i60 + 8 | 0;
 i36 = i60 + 12 | 0;
 i37 = i1 + 8 | 0;
 i38 = i1 + 39 | 0;
 i39 = i1 + 28 | 0;
 i40 = i1 + 40 | 0;
 i41 = i1 + 38 | 0;
 i42 = i1 + 36 | 0;
 i43 = i61 + 16 | 0;
 i44 = i61 + 18 | 0;
 i45 = i24 + 4 | 0;
 i46 = i24 + 8 | 0;
 i47 = i24 + 12 | 0;
 i48 = i24 + 16 | 0;
 i49 = i24 + 20 | 0;
 i50 = i24 + 44 | 0;
 i51 = i24 + 48 | 0;
 i52 = i24 + 52 | 0;
 i53 = i24 + 68 | 0;
 i54 = i24 + 72 | 0;
 i55 = i24 + 76 | 0;
 i56 = i24 + 80 | 0;
 i13 = i1 + 37 | 0;
 i14 = i24 + 4 | 0;
 i15 = i24 + 20 | 0;
 i16 = i24 + 24 | 0;
 i17 = i24 + 28 | 0;
 i18 = i24 + 32 | 0;
 i19 = i24 + 36 | 0;
 i20 = i24 + 40 | 0;
 i21 = i14 + 40 | 0;
 i22 = 0;
 L4 : while (1) {
  HEAP32[i60 >> 2] = 0;
  HEAP32[i27 >> 2] = 0;
  __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E(i59 + (i22 << 3) | 0, i60);
  i1 = HEAP32[i28 >> 2] | 0;
  i7 = HEAP16[i1 + 16 >> 1] | 0;
  HEAP16[i62 >> 1] = i7;
  i12 = HEAP8[i29 >> 0] | 0;
  i2 = (i7 << 16 >> 16 < 0 ? 1 : (HEAP32[(HEAP32[i67 >> 2] | 0) + 76 >> 2] | 0) != 0) & i12 << 24 >> 24 == 0 ? 1 : 2;
  HEAP32[i65 >> 2] = i2;
  HEAP16[i63 >> 1] = HEAP16[i30 >> 1] | 0;
  if (!(i12 << 24 >> 24)) {
   i12 = (__ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj(i60, i65, i62, i1, HEAP32[i31 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0, i63) | 0) ^ 1;
   i1 = HEAP32[i65 >> 2] | 0;
   if (!((i1 | 0) == 0 | i12)) {
    i12 = i1;
    i68 = 5;
   }
  } else {
   i12 = i2;
   i68 = 5;
  }
  L8 : do if ((i68 | 0) == 5) {
   i68 = 0;
   i1 = HEAP32[i34 >> 2] | 0;
   __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE(i64, i1, HEAP32[i36 >> 2] | 0);
   if (!(HEAP32[i1 + 4 >> 2] & 1)) i2 = i1 + 84 | 0; else i2 = (HEAP32[i1 + 8 >> 2] | 0) + 56 | 0;
   i5 = HEAP32[i67 >> 2] | 0;
   i1 = HEAP32[i5 + 76 >> 2] | 0;
   i3 = HEAP32[i5 + 80 >> 2] | 0;
   i6 = i1 >>> 0 > i3 >>> 0;
   i1 = i6 ? i1 - i3 | 0 : 1;
   i3 = i6 ? (HEAP32[i5 + 72 >> 2] | 0) + (i3 << 6) | 0 : i66;
   i5 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP16[i63 >> 1] | 0;
   if ((i5 | 0) == 5) i1 = i6 & 32 ? i1 : 1;
   i10 = HEAP32[i37 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i39 >> 2]);
   i11 = (HEAP8[i40 >> 0] | 0) != 0;
   i8 = HEAP32[(HEAP32[(HEAP32[i32 >> 2] | 0) + 3392 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP16[i24 >> 1] = ((HEAP8[i38 >> 0] | 0) == 0 ? 4 : 64) | i6;
   i11 = mftCall_iiiiifiiiiii(i8 | 0, i2 | 0, i64 | 0, i9 | 0, i10 | 0, +f4, i24 | 0, i1 | 0, i3 | 0, i11 | 0, 0, 0) | 0;
   if (i11 | 0) {
    i10 = (i7 & 8) == 0;
    i1 = 0;
    while (1) {
     i2 = i3 + (i1 << 6) | 0;
     HEAP32[i2 >> 2] = HEAP32[i60 >> 2];
     HEAP32[i3 + (i1 << 6) + 4 >> 2] = HEAP32[i27 >> 2];
     do if (!(HEAP8[i29 >> 0] | 0)) {
      i5 = HEAP32[i31 >> 2] | 0;
      i6 = (i5 | 0) == 0;
      if (i6) {
       if ((HEAP32[i33 >> 2] | 0) == 0 | i10) {
        i5 = i12;
        break;
       }
      } else if (i10) {
       i5 = i12;
       break;
      }
      if (!i6) {
       i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, HEAP32[i28 >> 2] | 0, i2 | 0) | 0;
       break;
      }
      i5 = HEAP32[i33 >> 2] | 0;
      i6 = HEAP32[i5 + 12 >> 2] | 0;
      if (!i6) i5 = i12; else {
       i9 = HEAP32[i28 >> 2] | 0;
       HEAP32[i25 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       i9 = (HEAP32[i34 >> 2] | 0) + 16 | 0;
       HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i26 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       i9 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
       HEAP32[i23 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
       HEAP32[i23 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
       HEAP32[i23 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
       HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i24 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
       HEAP32[i24 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
       HEAP32[i24 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
       i5 = mftCall_iiiiii(i6 | 0, i23 | 0, i24 | 0, i9 | 0, i5 | 0, i2 | 0) | 0;
      }
     } else i5 = i12; while (0);
     if ((i5 | 0) != 0 & (HEAP8[i38 >> 0] | 0) != 0) {
      i68 = 21;
      break L4;
     }
     switch (((HEAP8[i41 >> 0] | 0) == 0 ? i5 : 1) | 0) {
     case 1:
      {
       i5 = HEAP32[i67 >> 2] | 0;
       i7 = i5 + 76 | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       if (i8 | 0) if (HEAP8[i42 >> 0] | 0) {
        f4 = Math_fround(HEAPF32[i2 + 40 >> 2]);
        if (f4 <= Math_fround(HEAPF32[i39 >> 2])) {
         i6 = HEAP32[i5 + 80 >> 2] | 0;
         if ((i6 | 0) == (i8 | 0)) {
          i8 = HEAP32[i28 >> 2] | 0;
          HEAP32[i61 >> 2] = HEAP32[i8 >> 2];
          HEAP32[i61 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
          HEAP32[i61 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
          HEAP32[i61 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
          i9 = HEAP16[i8 + 16 >> 1] | 0;
          HEAP16[i43 >> 1] = i9;
          HEAP8[i44 >> 0] = HEAP8[i8 + 18 >> 0] | 0;
          HEAP16[i43 >> 1] = i9 & 65535 | 32768;
          HEAP32[i45 >> 2] = 0;
          HEAP32[i46 >> 2] = 0;
          HEAP32[i47 >> 2] = -1;
          HEAP16[i48 >> 1] = 0;
          HEAP32[i49 >> 2] = 0;
          HEAP32[i49 + 4 >> 2] = 0;
          HEAP32[i49 + 8 >> 2] = 0;
          HEAP32[i49 + 12 >> 2] = 0;
          HEAP32[i49 + 16 >> 2] = 0;
          HEAP32[i49 + 20 >> 2] = 0;
          HEAPF32[i50 >> 2] = Math_fround(3402823469999999843913219.0e14);
          HEAPF32[i51 >> 2] = Math_fround(0.0);
          HEAPF32[i52 >> 2] = Math_fround(0.0);
          HEAP8[i53 >> 0] = 0;
          HEAP32[i54 >> 2] = 0;
          HEAP32[i55 >> 2] = 0;
          HEAP32[i56 >> 2] = 0;
          HEAP32[i24 >> 2] = gb + 85940 + 8;
          if (!(HEAP8[i13 >> 0] | 0)) if (HEAP32[i7 >> 2] | 0) {
           i8 = HEAP32[i32 >> 2] | 0;
           i9 = HEAP32[i37 >> 2] | 0;
           HEAP16[i35 >> 1] = HEAP16[i30 >> 1] | 0;
           if (__ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i8, i9, i24, i35, 0, i61, HEAP32[i31 >> 2] | 0, HEAP32[i33 >> 2] | 0) | 0) {
            i5 = HEAP32[i67 >> 2] | 0;
            i8 = i5 + 4 | 0;
            HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
            HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
            HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
            HEAP16[i5 + 16 >> 1] = HEAP16[i48 >> 1] | 0;
            HEAP32[i5 + 20 >> 2] = HEAP32[i15 >> 2];
            HEAP32[i5 + 24 >> 2] = HEAP32[i16 >> 2];
            HEAP32[i5 + 28 >> 2] = HEAP32[i17 >> 2];
            HEAP32[i5 + 32 >> 2] = HEAP32[i18 >> 2];
            HEAP32[i5 + 36 >> 2] = HEAP32[i19 >> 2];
            HEAP32[i5 + 40 >> 2] = HEAP32[i20 >> 2];
            HEAP32[i5 + 44 >> 2] = HEAP32[i50 >> 2];
            i5 = i5 + 48 | 0;
            HEAP32[i5 >> 2] = HEAP32[i51 >> 2];
            HEAP32[i5 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
            HEAP32[i5 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
            HEAP32[i5 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
            HEAP32[i5 + 16 >> 2] = HEAP32[i51 + 16 >> 2];
            HEAP8[(HEAP32[i67 >> 2] | 0) + 68 >> 0] = 1;
            i5 = HEAP32[i67 >> 2] | 0;
            i8 = HEAP32[i5 + 72 >> 2] | 0;
            i9 = HEAP32[i5 + 80 >> 2] | 0;
            f4 = Math_fround(HEAPF32[i21 >> 2]);
            if (!i9) {
             i7 = i5;
             i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
             i5 = 0;
            } else {
             i7 = 0;
             i5 = i9;
             do {
              i6 = i8 + (i7 << 6) + 40 | 0;
              if (Math_fround(HEAPF32[i6 >> 2]) > f4) {
               i5 = i5 + -1 | 0;
               i77 = HEAP16[i8 + (i5 << 6) + 12 >> 1] | 0;
               i76 = HEAP32[i8 + (i5 << 6) + 16 >> 2] | 0;
               i75 = HEAP32[i8 + (i5 << 6) + 20 >> 2] | 0;
               i74 = HEAP32[i8 + (i5 << 6) + 24 >> 2] | 0;
               i73 = HEAP32[i8 + (i5 << 6) + 28 >> 2] | 0;
               i72 = HEAP32[i8 + (i5 << 6) + 32 >> 2] | 0;
               i71 = HEAP32[i8 + (i5 << 6) + 36 >> 2] | 0;
               i70 = HEAP32[i8 + (i5 << 6) + 40 >> 2] | 0;
               _memmove(i8 + (i7 << 6) | 0, i8 + (i5 << 6) | 0, 12) | 0;
               HEAP16[i8 + (i7 << 6) + 12 >> 1] = i77;
               HEAP32[i8 + (i7 << 6) + 16 >> 2] = i76;
               HEAP32[i8 + (i7 << 6) + 20 >> 2] = i75;
               HEAP32[i8 + (i7 << 6) + 24 >> 2] = i74;
               HEAP32[i8 + (i7 << 6) + 28 >> 2] = i73;
               HEAP32[i8 + (i7 << 6) + 32 >> 2] = i72;
               HEAP32[i8 + (i7 << 6) + 36 >> 2] = i71;
               HEAP32[i6 >> 2] = i70;
               _memmove(i8 + (i7 << 6) + 44 | 0, i8 + (i5 << 6) + 44 | 0, 20) | 0;
              }
              i7 = i7 + 1 | 0;
             } while ((i7 | 0) != (i9 | 0));
             i7 = HEAP32[i67 >> 2] | 0;
             i6 = HEAP32[i21 >> 2] | 0;
            }
            HEAP32[i7 + 80 >> 2] = i5;
            HEAP32[i39 >> 2] = i6;
            HEAP32[i58 >> 2] = i6;
           }
          }
          HEAP8[i13 >> 0] = 1;
          i5 = HEAP32[i67 >> 2] | 0;
          i6 = HEAP32[i5 + 80 >> 2] | 0;
          if ((i6 | 0) == (HEAP32[i5 + 76 >> 2] | 0)) {
           i77 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, HEAP32[i5 + 72 >> 2] | 0, i6 | 0) | 0;
           HEAP8[i42 >> 0] = i77 & 1;
           if (!i77) {
            i1 = 0;
            i68 = 44;
            break L4;
           }
           HEAP32[(HEAP32[i67 >> 2] | 0) + 80 >> 2] = 0;
           i6 = HEAP32[i67 >> 2] | 0;
           i5 = i6;
           i6 = HEAP32[i6 + 80 >> 2] | 0;
          }
         }
         i77 = HEAP32[i5 + 72 >> 2] | 0;
         HEAP32[i5 + 80 >> 2] = i6 + 1;
         i76 = i77 + (i6 << 6) | 0;
         HEAP32[i76 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i76 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i76 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         HEAP16[i77 + (i6 << 6) + 12 >> 1] = HEAP16[i3 + (i1 << 6) + 12 >> 1] | 0;
         HEAP32[i77 + (i6 << 6) + 16 >> 2] = HEAP32[i3 + (i1 << 6) + 16 >> 2];
         HEAP32[i77 + (i6 << 6) + 20 >> 2] = HEAP32[i3 + (i1 << 6) + 20 >> 2];
         HEAP32[i77 + (i6 << 6) + 24 >> 2] = HEAP32[i3 + (i1 << 6) + 24 >> 2];
         HEAP32[i77 + (i6 << 6) + 28 >> 2] = HEAP32[i3 + (i1 << 6) + 28 >> 2];
         HEAP32[i77 + (i6 << 6) + 32 >> 2] = HEAP32[i3 + (i1 << 6) + 32 >> 2];
         HEAP32[i77 + (i6 << 6) + 36 >> 2] = HEAP32[i3 + (i1 << 6) + 36 >> 2];
         HEAP32[i77 + (i6 << 6) + 40 >> 2] = HEAP32[i3 + (i1 << 6) + 40 >> 2];
         i77 = i77 + (i6 << 6) + 44 | 0;
         i76 = i3 + (i1 << 6) + 44 | 0;
         HEAP32[i77 >> 2] = HEAP32[i76 >> 2];
         HEAP32[i77 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
         HEAP32[i77 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
         HEAP32[i77 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
         HEAP32[i77 + 16 >> 2] = HEAP32[i76 + 16 >> 2];
        }
       }
       break;
      }
     case 2:
      {
       f4 = Math_fround(HEAPF32[i2 + 40 >> 2]);
       if (f4 <= Math_fround(HEAPF32[i39 >> 2])) {
        HEAPF32[i39 >> 2] = f4;
        HEAPF32[i58 >> 2] = f4;
        i77 = HEAP32[i67 >> 2] | 0;
        i76 = i77 + 4 | 0;
        HEAP32[i76 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i76 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i76 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP16[i77 + 16 >> 1] = HEAP16[i3 + (i1 << 6) + 12 >> 1] | 0;
        HEAP32[i77 + 20 >> 2] = HEAP32[i3 + (i1 << 6) + 16 >> 2];
        HEAP32[i77 + 24 >> 2] = HEAP32[i3 + (i1 << 6) + 20 >> 2];
        HEAP32[i77 + 28 >> 2] = HEAP32[i3 + (i1 << 6) + 24 >> 2];
        HEAP32[i77 + 32 >> 2] = HEAP32[i3 + (i1 << 6) + 28 >> 2];
        HEAP32[i77 + 36 >> 2] = HEAP32[i3 + (i1 << 6) + 32 >> 2];
        HEAP32[i77 + 40 >> 2] = HEAP32[i3 + (i1 << 6) + 36 >> 2];
        HEAP32[i77 + 44 >> 2] = HEAP32[i3 + (i1 << 6) + 40 >> 2];
        i77 = i77 + 48 | 0;
        i76 = i3 + (i1 << 6) + 44 | 0;
        HEAP32[i77 >> 2] = HEAP32[i76 >> 2];
        HEAP32[i77 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
        HEAP32[i77 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
        HEAP32[i77 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
        HEAP32[i77 + 16 >> 2] = HEAP32[i76 + 16 >> 2];
        HEAP8[(HEAP32[i67 >> 2] | 0) + 68 >> 0] = 1;
       }
       break;
      }
     default:
      {}
     }
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i11 >>> 0) break L8;
    }
   }
  } while (0);
  i22 = i22 + 1 | 0;
  if (i22 >>> 0 >= i57 >>> 0) {
   i1 = 1;
   i68 = 44;
   break;
  }
 }
 if ((i68 | 0) == 21) {
  i77 = HEAP32[i67 >> 2] | 0;
  i76 = i77 + 4 | 0;
  HEAP32[i76 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i76 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i76 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP16[i77 + 16 >> 1] = HEAP16[i3 + (i1 << 6) + 12 >> 1] | 0;
  HEAP32[i77 + 20 >> 2] = HEAP32[i3 + (i1 << 6) + 16 >> 2];
  HEAP32[i77 + 24 >> 2] = HEAP32[i3 + (i1 << 6) + 20 >> 2];
  HEAP32[i77 + 28 >> 2] = HEAP32[i3 + (i1 << 6) + 24 >> 2];
  HEAP32[i77 + 32 >> 2] = HEAP32[i3 + (i1 << 6) + 28 >> 2];
  HEAP32[i77 + 36 >> 2] = HEAP32[i3 + (i1 << 6) + 32 >> 2];
  HEAP32[i77 + 40 >> 2] = HEAP32[i3 + (i1 << 6) + 36 >> 2];
  HEAP32[i77 + 44 >> 2] = HEAP32[i3 + (i1 << 6) + 40 >> 2];
  i77 = i77 + 48 | 0;
  i76 = i3 + (i1 << 6) + 44 | 0;
  HEAP32[i77 >> 2] = HEAP32[i76 >> 2];
  HEAP32[i77 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
  HEAP32[i77 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
  HEAP32[i77 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  HEAP32[i77 + 16 >> 2] = HEAP32[i76 + 16 >> 2];
  HEAP8[(HEAP32[i67 >> 2] | 0) + 68 >> 0] = 1;
  i77 = 0;
  STACKTOP = i69;
  return i77 | 0;
 } else if ((i68 | 0) == 44) {
  STACKTOP = i69;
  return i1 | 0;
 }
 return 0;
}

function _iconv(i1, i37, i38, i39, i40) {
 i1 = i1 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i46;
 i42 = i46 + 16 | 0;
 i43 = i46 + 12 | 0;
 i44 = i46 + 8 | 0;
 i45 = i46 + 20 | 0;
 i24 = i1;
 i1 = i24 & 65535;
 i24 = (i24 >>> 16) + (gb + 1069354) | 0;
 i22 = i24 + 1 | 0;
 i25 = gb + 1069354 + i1 | 0;
 i23 = i25 + 1 | 0;
 i36 = i41;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 4 >> 2] = 0;
 i24 = HEAP8[i24 >> 0] | 0;
 i25 = HEAP8[i25 >> 0] | 0;
 L1 : do if (!i37) i1 = 0; else {
  i2 = HEAP32[i37 >> 2] | 0;
  if (!i2) i1 = 0; else {
   i3 = HEAP32[i38 >> 2] | 0;
   if (!i3) i1 = 0; else {
    i21 = i24 & 255;
    i26 = i21 + 128 | 0;
    i27 = i21 & 3;
    i28 = i27 ^ 1;
    i29 = i27 ^ 2;
    i30 = i27 ^ 3;
    i31 = i21 & 1;
    i32 = i31 ^ 1;
    i33 = (i21 & 254 | 0) == 196;
    i34 = i24 << 24 >> 24 == -38;
    i35 = i24 << 24 >> 24 == -40;
    i17 = i25 & 255;
    i10 = i17 + -192 | 0;
    i36 = i10 >>> 0 > 8;
    i9 = i1;
    i10 = gb + 1073379 + i10 | 0;
    i11 = i17 + 128 | 0;
    i12 = 128 - i17 | 0;
    i13 = (i12 | 0) == 0;
    i14 = (i24 & -2) << 24 >> 24 == -60;
    i15 = i17 & 1;
    i16 = i15 ^ 1;
    i17 = i17 & 3;
    i18 = i17 ^ 1;
    i19 = i17 ^ 2;
    i20 = i17 ^ 3;
    i21 = (i21 + -192 | 0) >>> 0 < 7;
    i1 = 0;
    i6 = i2;
    i8 = i3;
    L5 : while (1) {
     i5 = HEAP8[i6 >> 0] | 0;
     i3 = i5 & 255;
     L7 : do if (i5 << 24 >> 24 < 0 | i21) {
      do switch (i24 << 24 >> 24) {
      case -57:
       {
        i1 = 84;
        i7 = 112;
        break L5;
       }
      case -56:
       {
        i2 = _mbrtowc(i42, i6, i8, i41) | 0;
        switch (i2 | 0) {
        case -1:
         {
          i1 = 84;
          i7 = 112;
          break L5;
         }
        case -2:
         {
          i1 = 22;
          break L5;
         }
        case 0:
         {
          i2 = 1;
          break;
         }
        default:
         {}
        }
        i3 = HEAP32[i42 >> 2] | 0;
        i7 = 86;
        break L7;
       }
      case -58:
       {
        if (i8 >>> 0 < 4) {
         i1 = 22;
         break L5;
        }
        i3 = HEAP32[i6 >> 2] | 0;
        i7 = 14;
        break;
       }
      case -61:
      case -64:
       {
        if (i8 >>> 0 < 4) {
         i1 = 22;
         break L5;
        }
        i3 = HEAPU8[i6 + i28 >> 0] << 16 | HEAPU8[i6 + i27 >> 0] << 24 | HEAPU8[i6 + i29 >> 0] << 8 | HEAPU8[i6 + i30 >> 0];
        i7 = 14;
        break;
       }
      case -63:
      case -62:
      case -59:
      case -60:
       {
        if (i8 >>> 0 < 2) {
         i1 = 22;
         break L5;
        }
        i5 = HEAPU8[i6 + i31 >> 0] << 8;
        i3 = i5 | HEAPU8[i6 + i32 >> 0];
        switch ((i5 & 64512) << 16 >> 16) {
        case -9216:
         {
          i1 = 84;
          i7 = 112;
          break L5;
         }
        case -10240:
         break;
        default:
         {
          i2 = 2;
          i7 = 86;
          break L7;
         }
        }
        if (i33) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        if (i8 >>> 0 < 4) {
         i1 = 22;
         break L5;
        }
        i4 = i6 + 2 | 0;
        i4 = (HEAPU8[i4 + i31 >> 0] << 8 | HEAPU8[i4 + i32 >> 0]) + -56320 | 0;
        if (i4 >>> 0 > 1023) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        i2 = 4;
        i3 = (i3 << 10) + -56557568 + i4 | 0;
        i7 = 86;
        break L7;
       }
      case -47:
       {
        if ((i3 + -161 | 0) >>> 0 < 63) {
         i2 = 1;
         i3 = i3 + 65216 | 0;
         i7 = 86;
         break L7;
        }
        if (i8 >>> 0 < 2) {
         i1 = 22;
         break L5;
        }
        i4 = HEAP8[i6 + 1 >> 0] | 0;
        i5 = i4 & 255;
        i2 = i3 + -129 | 0;
        if (i2 >>> 0 >= 31) {
         if ((i3 & 240 | 0) != 224) {
          i1 = 84;
          i7 = 112;
          break L5;
         }
         i2 = i3 + -193 | 0;
        }
        i2 = i2 << 1;
        i3 = i5 + -64 | 0;
        if (i3 >>> 0 < 95) {
         if (i4 << 24 >> 24 == 127) {
          i1 = 84;
          i7 = 112;
          break L5;
         }
         i3 = i3 + (i4 << 24 >> 24 >> 7 << 24 >> 24) | 0;
        } else {
         i3 = i5 + -159 | 0;
         i7 = i3 >>> 0 < 94;
         i3 = i7 ? i3 : i5;
         i2 = i2 | i7 & 1;
        }
        i3 = HEAP16[gb + 229594 + (i2 * 188 | 0) + (i3 << 1) >> 1] | 0;
        if (!(i3 << 16 >> 16)) {
         i1 = 84;
         i7 = 112;
         break L5;
        } else {
         i2 = 2;
         i3 = i3 & 65535;
         i7 = 86;
         break L7;
        }
       }
      case -48:
       {
        if (i8 >>> 0 < 2) {
         i1 = 22;
         break L5;
        }
        i4 = HEAPU8[i6 + 1 >> 0] | 0;
        if (i5 << 24 >> 24 == -114) {
         if ((i4 + -161 | 0) >>> 0 > 62) {
          i1 = 84;
          i7 = 112;
          break L5;
         }
         i2 = 2;
         i3 = i4 + 65216 | 0;
         i7 = 86;
         break L7;
        } else {
         i3 = i3 + -161 | 0;
         i2 = i4 + -161 | 0;
         if (i3 >>> 0 > 83 | i2 >>> 0 > 93) {
          i1 = 84;
          i7 = 112;
          break L5;
         }
         i3 = HEAP16[gb + 229594 + (i3 * 188 | 0) + (i2 << 1) >> 1] | 0;
         if (!(i3 << 16 >> 16)) {
          i1 = 84;
          i7 = 112;
          break L5;
         } else {
          i2 = 2;
          i3 = i3 & 65535;
          i7 = 86;
          break L7;
         }
        }
       }
      case -38:
       {
        if ((i5 & 255) < 161) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        break;
       }
      case -40:
      case -39:
       break;
      case -32:
       {
        if (i8 >>> 0 < 2) {
         i1 = 22;
         break L5;
        }
        i2 = HEAPU8[i6 + 1 >> 0] | 0;
        i4 = i2 + -64 | 0;
        if (i4 >>> 0 > 190 | (i2 + -127 | 0) >>> 0 < 34) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        i4 = i4 >>> 0 > 62 ? i2 + -98 | 0 : i4;
        i2 = i3 + -161 | 0;
        if (i2 >>> 0 <= 88) {
         i3 = HEAPU16[gb + 303610 + (i2 * 314 | 0) + (i4 << 1) >> 1] | 0;
         if ((i2 | 0) == 39) {
          i2 = i4 + -58 | 0;
          if (i2 >>> 0 < 9) i2 = 261 >>> (i2 & 511) & 511; else i2 = 0;
         } else i2 = 0;
         i3 = i2 << 17 & 131072 | i3;
         if (!i3) {
          i1 = 84;
          i7 = 112;
          break L5;
         } else {
          i2 = 2;
          i7 = 86;
          break L7;
         }
        }
        i2 = i3 + -135 | 0;
        if (i2 >>> 0 > 119) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        i3 = i4 + (((i5 & 255) < 161 ? i2 : i3 + -224 | 0) * 157 | 0) | 0;
        i4 = HEAPU16[gb + 293266 + (i3 << 1) >> 1] | 0;
        i3 = (HEAPU16[gb + 293266 + ((i3 >>> 4) + 4867 << 1) >> 1] | 0) >>> (i3 & 15) << 17 & 131072 | i4;
        if ((i3 & 196352 | 0) != 56320) if (!i3) {
         i1 = 84;
         i7 = 112;
         break L5;
        } else {
         i2 = 2;
         i7 = 86;
         break L7;
        }
        if (i36) i2 = 2; else i2 = HEAP8[i10 >> 0] | 0;
        if (i2 >>> 0 > (HEAP32[i40 >> 2] | 0) >>> 0) {
         i1 = 7;
         i7 = 112;
         break L5;
        }
        HEAP32[i43 >> 2] = (i4 & 255) + (gb + 1073389);
        HEAP32[i44 >> 2] = 4;
        i1 = (_iconv(i9, i43, i44, i39, i40) | 0) + i1 | 0;
        i2 = 2;
        break L7;
       }
      case -24:
       {
        if (i8 >>> 0 < 2) {
         i1 = 22;
         break L5;
        }
        i4 = HEAP8[i6 + 1 >> 0] | 0;
        i5 = i4 & 255;
        i6 = i3 + -161 | 0;
        i2 = i5 + -161 | 0;
        if (!(i6 >>> 0 > 92 | i2 >>> 0 > 93)) {
         i3 = HEAP16[gb + 331556 + (i6 * 188 | 0) + (i2 << 1) >> 1] | 0;
         if (!(i3 << 16 >> 16)) {
          i1 = 84;
          i7 = 112;
          break L5;
         } else {
          i2 = 2;
          i3 = i3 & 65535;
          i7 = 86;
          break L7;
         }
        }
        i3 = i3 + -129 | 0;
        if (i3 >>> 0 > 92) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        if (i3 >>> 0 > 68 & (i4 & 255) > 82) {
         i1 = 84;
         i7 = 112;
         break L5;
        }
        i2 = i5 + -65 | 0;
        do if (i2 >>> 0 >= 26) {
         if ((i5 + -97 | 0) >>> 0 < 26) {
          i2 = i5 + -71 | 0;
          break;
         }
         if ((i5 + -129 | 0) >>> 0 >= 126) {
          i1 = 84;
          i7 = 112;
          break L5;
         }
         i2 = i5 + -77 | 0;
        } while (0);
        i3 = (i3 >>> 0 < 32 ? i3 * 178 | 0 : (i6 * 84 | 0) + 5696 | 0) + 44032 + i2 | 0;
        if (i3 >>> 0 < 44032) {
         i2 = 2;
         i7 = 86;
         break L7;
        } else i7 = 44032;
        while (1) {
         i6 = i3 - i7 | 0;
         i4 = 0;
         i2 = 0;
         do {
          i5 = 0;
          do {
           i2 = (((HEAPU16[gb + 331556 + (i4 * 188 | 0) + (i5 << 1) >> 1] | 0) - i7 | 0) >>> 0 <= i6 >>> 0 & 1) + i2 | 0;
           i5 = i5 + 1 | 0;
          } while ((i5 | 0) != 94);
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != 93);
         i7 = i3 + 1 | 0;
         i3 = i2 + i3 | 0;
         if (i3 >>> 0 < i7 >>> 0) {
          i2 = 2;
          i7 = 86;
          break L7;
         }
        }
       }
      default:
       {
        if (i3 >>> 0 < i26 >>> 0) {
         i2 = 1;
         i7 = 86;
         break L7;
        }
        i7 = i3 - i26 | 0;
        i6 = (i7 * 5 | 0) >>> 2;
        i7 = i7 << 1 & 6;
        i7 = HEAPU8[i22 + (i6 + 1) >> 0] << 8 - i7 & 1023 | (HEAPU8[i22 + i6 >> 0] | 0) >>> i7;
        i3 = (i7 | 0) == 0 ? i3 : HEAPU16[gb + 349040 + (i7 << 1) >> 1] | 0;
        if ((i3 | 0) == 1) {
         i1 = 84;
         i7 = 112;
         break L5;
        } else {
         i2 = 1;
         i7 = 86;
         break L7;
        }
       }
      } while (0);
      if ((i7 | 0) == 14) if (i3 >>> 0 > 1114111 | (i3 & -2048 | 0) == 55296) {
       i1 = 84;
       i7 = 112;
       break L5;
      } else {
       i2 = 4;
       i7 = 86;
       break;
      }
      i4 = i3 + -129 | 0;
      if (i4 >>> 0 > 125) {
       i1 = 84;
       i7 = 112;
       break L5;
      }
      if (i8 >>> 0 < 2) {
       i1 = 22;
       break L5;
      }
      i2 = HEAP8[i6 + 1 >> 0] | 0;
      i5 = i2 & 255;
      if (i34 & (i2 & 255) < 161) {
       i1 = 84;
       i7 = 112;
       break L5;
      }
      i3 = i5 + -64 | 0;
      if (!(i2 << 24 >> 24 == 127 | i3 >>> 0 > 190)) {
       i2 = 2;
       i3 = HEAPU16[gb + 245386 + (i4 * 380 | 0) + ((i3 >>> 0 > 63 ? i5 + -65 | 0 : i3) << 1) >> 1] | 0;
       i7 = 86;
       break;
      }
      if (!(i35 & (i5 + -48 | 0) >>> 0 < 10)) {
       i1 = 84;
       i7 = 112;
       break L5;
      }
      if (i8 >>> 0 < 4) {
       i1 = 22;
       break L5;
      }
      i3 = (HEAPU8[i6 + 2 >> 0] | 0) + -129 | 0;
      if (i3 >>> 0 > 126) {
       i1 = 84;
       i7 = 112;
       break L5;
      }
      i2 = (HEAPU8[i6 + 3 >> 0] | 0) + -48 | 0;
      if (i2 >>> 0 > 9) {
       i1 = 84;
       i7 = 112;
       break L5;
      }
      i7 = 0;
      i3 = ((i5 + (i4 * 10 | 0) | 0) * 1260 | 0) + -60352 + (i3 * 10 | 0) + i2 | 0;
      do {
       i6 = i3 - i7 | 0;
       i5 = 0;
       i2 = 0;
       do {
        i4 = 0;
        do {
         i2 = (((HEAPU16[gb + 245386 + (i5 * 380 | 0) + (i4 << 1) >> 1] | 0) - i7 | 0) >>> 0 <= i6 >>> 0 & 1) + i2 | 0;
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) != 190);
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) != 126);
       i7 = i3 + 1 | 0;
       i3 = i2 + i3 | 0;
      } while (i3 >>> 0 >= i7 >>> 0);
      i2 = 4;
      i7 = 86;
     } else {
      i2 = 1;
      i7 = 86;
     } while (0);
     L109 : do if ((i7 | 0) == 86) {
      i7 = 0;
      switch (i25 << 24 >> 24) {
      case -58:
       {
        if ((HEAP32[i40 >> 2] | 0) >>> 0 < 4) {
         i1 = 7;
         i7 = 112;
         break L5;
        }
        i6 = HEAP32[i39 >> 2] | 0;
        HEAP32[i6 >> 2] = i3;
        HEAP32[i39 >> 2] = i6 + 4;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + -4;
        break L109;
       }
      case -56:
       {
        if ((HEAP32[i40 >> 2] | 0) >>> 0 < 4) {
         i3 = _wctomb(i45, i3) | 0;
         if ((HEAP32[i40 >> 2] | 0) >>> 0 < i3 >>> 0) {
          i7 = 92;
          break L5;
         }
         i4 = HEAP32[i39 >> 2] | 0;
         _memcpy(i4 | 0, i45 | 0, i3 | 0) | 0;
        } else {
         i4 = HEAP32[i39 >> 2] | 0;
         i3 = _wctomb(i4, i3) | 0;
        }
        HEAP32[i39 >> 2] = i4 + i3;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) - i3;
        break L109;
       }
      case -57:
       {
        if (i3 >>> 0 > 127) i7 = 96;
        break;
       }
      case -63:
      case -62:
      case -59:
      case -60:
       if (i14 | i3 >>> 0 < 65536) {
        i3 = i3 >>> 0 > 65535 ? 65533 : i3;
        if ((HEAP32[i40 >> 2] | 0) >>> 0 < 2) {
         i1 = 7;
         i7 = 112;
         break L5;
        }
        i6 = HEAP32[i39 >> 2] | 0;
        HEAP8[i6 + i15 >> 0] = i3 >>> 8;
        HEAP8[i6 + i16 >> 0] = i3;
        HEAP32[i39 >> 2] = i6 + 2;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + -2;
        break L109;
       } else {
        if ((HEAP32[i40 >> 2] | 0) >>> 0 < 4) {
         i1 = 7;
         i7 = 112;
         break L5;
        }
        i4 = i3 + -65536 | 0;
        i6 = HEAP32[i39 >> 2] | 0;
        HEAP8[i6 + i15 >> 0] = i4 >>> 18 | 216;
        HEAP8[i6 + i16 >> 0] = i4 >>> 10;
        i5 = i6 + 2 | 0;
        HEAP8[i5 + i15 >> 0] = i4 >>> 8 & 3 | 220;
        HEAP8[i5 + i16 >> 0] = i4;
        HEAP32[i39 >> 2] = i6 + 4;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + -4;
        break L109;
       }
      case -61:
      case -64:
       {
        if ((HEAP32[i40 >> 2] | 0) >>> 0 < 4) {
         i1 = 7;
         i7 = 112;
         break L5;
        }
        i6 = HEAP32[i39 >> 2] | 0;
        HEAP8[i6 + i17 >> 0] = i3 >>> 24;
        HEAP8[i6 + i18 >> 0] = i3 >>> 16;
        HEAP8[i6 + i19 >> 0] = i3 >>> 8;
        HEAP8[i6 + i20 >> 0] = i3;
        HEAP32[i39 >> 2] = i6 + 4;
        HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + -4;
        break L109;
       }
      default:
       {}
      }
      L129 : while (1) {
       if ((i7 | 0) == 96) {
        i7 = 0;
        i1 = i1 + 1 | 0;
        i3 = 42;
       }
       if (!(HEAP32[i40 >> 2] | 0)) {
        i1 = 7;
        i7 = 112;
        break L5;
       }
       if (i3 >>> 0 < i11 >>> 0) break;
       if (i13) {
        i7 = 96;
        continue;
       } else i4 = 0;
       while (1) {
        i6 = (i4 * 5 | 0) >>> 2;
        i7 = i4 << 1 & 6;
        if ((i3 | 0) == (HEAPU16[gb + 349040 + ((HEAPU8[i23 + (i6 + 1) >> 0] << 8 - i7 & 1023 | (HEAPU8[i23 + i6 >> 0] | 0) >>> i7) << 1) >> 1] | 0)) {
         i7 = 102;
         break L129;
        }
        i4 = i4 + 1 | 0;
        if (i4 >>> 0 >= i12 >>> 0) {
         i7 = 96;
         continue L129;
        }
       }
      }
      if ((i7 | 0) == 102) {
       i7 = 0;
       i3 = i4 + 128 | 0;
      }
      i6 = HEAP32[i39 >> 2] | 0;
      HEAP32[i39 >> 2] = i6 + 1;
      HEAP8[i6 >> 0] = i3;
      HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + -1;
     } while (0);
     i6 = (HEAP32[i37 >> 2] | 0) + i2 | 0;
     HEAP32[i37 >> 2] = i6;
     i8 = i8 - i2 | 0;
     HEAP32[i38 >> 2] = i8;
     if (!i8) break L1;
    }
    if ((i7 | 0) == 92) i1 = 7;
    HEAP32[(___errno_location() | 0) >> 2] = i1;
    i1 = -1;
   }
  }
 } while (0);
 STACKTOP = i46;
 return i1 | 0;
}

function __Z27RemoveUnnecessaryTransformsR10GameObjectPK16HumanDescriptionPK8UnityStrjb(i34, i29, i31, i32, i33) {
 i34 = i34 | 0;
 i29 = i29 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i46 + 16 | 0;
 i38 = i46;
 i44 = i46 + 64 | 0;
 i45 = i46 + 44 | 0;
 i30 = i46 + 80 | 0;
 i37 = i46 + 24 | 0;
 i9 = i44 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i44 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i41 = i44 + 4 | 0;
 HEAP32[i44 >> 2] = i41;
 i39 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i34, gb + 28940 | 0) | 0;
 i43 = gb + 64016 | 0;
 i42 = HEAP32[i43 + 4 >> 2] | 0;
 i35 = i38;
 HEAP32[i35 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i35 + 4 >> 2] = i42;
 HEAP32[i45 >> 2] = 0;
 i35 = i45 + 12 | 0;
 HEAP32[i35 >> 2] = 0;
 i42 = i45 + 16 | 0;
 HEAP32[i42 >> 2] = 0;
 i43 = i45 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i36, i38);
 i27 = i36;
 i28 = HEAP32[i27 + 4 >> 2] | 0;
 i1 = i43;
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i1 + 4 >> 2] = i28;
 __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i34, 1, __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(4) | 0, i45);
 i1 = HEAP32[i35 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i11 = i41;
  i8 = 0;
  do {
   i6 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i7 = (HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + 40 >> 2] | 0) > 1 & 1;
   i2 = HEAP32[i41 >> 2] | 0;
   do if (!i2) {
    HEAP32[i36 >> 2] = i41;
    i4 = i11;
    i3 = i41;
   } else {
    i4 = i6;
    while (1) {
     i3 = HEAP32[i2 + 16 >> 2] | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i40 = 11;
       break;
      } else i2 = i3;
     } else {
      if (i3 >>> 0 >= i4 >>> 0) {
       i40 = 16;
       break;
      }
      i5 = i2 + 4 | 0;
      i3 = HEAP32[i5 >> 2] | 0;
      if (!i3) {
       i40 = 15;
       break;
      } else i2 = i3;
     }
    }
    if ((i40 | 0) == 11) {
     i40 = 0;
     HEAP32[i36 >> 2] = i2;
     i4 = i2;
     i3 = i2;
     break;
    } else if ((i40 | 0) == 15) {
     i40 = 0;
     HEAP32[i36 >> 2] = i2;
     i4 = i2;
     i3 = i5;
     break;
    } else if ((i40 | 0) == 16) {
     i40 = 0;
     HEAP32[i36 >> 2] = i2;
     i4 = i2;
     i3 = i36;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(24) | 0;
    HEAP32[i1 + 16 >> 2] = i6;
    HEAP8[i1 + 20 >> 0] = i7;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i44 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    i1 = HEAP32[i35 >> 2] | 0;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i1 >>> 0);
  if ((i29 | 0) != 0 & (i1 | 0) != 0) {
   i13 = i29 + 4 | 0;
   i14 = i38 + 12 | 0;
   i11 = i38 + 12 | 0;
   i15 = i36 + 4 | 0;
   i16 = i38 + 8 | 0;
   i17 = i38 + 4 | 0;
   i18 = i38 + 11 | 0;
   i19 = i30 + 12 | 0;
   i12 = i30 + 12 | 0;
   i20 = i36 + 4 | 0;
   i21 = i30 + 8 | 0;
   i22 = i30 + 4 | 0;
   i23 = i30 + 11 | 0;
   i24 = i36 + 4 | 0;
   i25 = i36 + 4 | 0;
   i26 = i29 + 52 | 0;
   i27 = i26 + 11 | 0;
   i28 = i29 + 56 | 0;
   i10 = 0;
   L28 : while (1) {
    i5 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i10 << 2) >> 2] | 0;
    i2 = HEAP32[i41 >> 2] | 0;
    if (!i2) i40 = 31; else {
     i4 = i5;
     i1 = i41;
     L32 : while (1) {
      i3 = i2;
      while (1) {
       if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i2) break L32; else i3 = i2;
      }
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i1 = i3;
       break;
      } else i1 = i3;
     }
     if ((i1 | 0) == (i41 | 0)) i40 = 31; else if (i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i40 = 31;
    }
    if ((i40 | 0) == 31) {
     i40 = 0;
     i1 = i41;
    }
    i2 = HEAP32[i29 >> 2] | 0;
    i7 = HEAP32[i13 >> 2] | 0;
    i9 = i5;
    i8 = i5;
    i4 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
    HEAP32[i38 >> 2] = 0;
    HEAP32[i38 + 4 >> 2] = 0;
    HEAP32[i38 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i14 >> 2] = i3;
    i5 = _strlen(i4) | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
     i3 = HEAP32[i11 >> 2] | 0;
     i40 = 35;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i18 >> 0] = i5;
     if (!i5) i3 = i38; else {
      i3 = i38;
      i40 = 37;
     }
    } else i40 = 35;
    if ((i40 | 0) == 35) {
     i6 = i5 + 16 & -16;
     HEAP32[i36 >> 2] = 66;
     HEAP32[i15 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i36, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i38 >> 2] = i3;
     HEAP32[i16 >> 2] = i6 | -2147483648;
     HEAP32[i17 >> 2] = i5;
     i40 = 37;
    }
    if ((i40 | 0) == 37) {
     i40 = 0;
     _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i3 + i5 >> 0] = 0;
    i5 = HEAP8[i18 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i38 >> 2] | 0 : i38;
    i5 = i3 ? HEAP32[i17 >> 2] | 0 : i5 & 255;
    HEAP32[i30 >> 2] = 0;
    HEAP32[i30 + 4 >> 2] = 0;
    HEAP32[i30 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i19 >> 2] = i3;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i30);
     i3 = HEAP32[i12 >> 2] | 0;
     i40 = 41;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i23 >> 0] = i5;
     if (!i5) i3 = i30; else {
      i3 = i30;
      i40 = 43;
     }
    } else i40 = 41;
    if ((i40 | 0) == 41) {
     i6 = i5 + 16 & -16;
     HEAP32[i36 >> 2] = 66;
     HEAP32[i20 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i36, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i30 >> 2] = i3;
     HEAP32[i21 >> 2] = i6 | -2147483648;
     HEAP32[i22 >> 2] = i5;
     i40 = 43;
    }
    if ((i40 | 0) == 43) {
     i40 = 0;
     _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i3 + i5 >> 0] = 0;
    i6 = HEAP8[i23 >> 0] | 0;
    L61 : do if ((i2 | 0) != (i7 | 0)) {
     i4 = i6 & 255;
     if (i6 << 24 >> 24 >= 0) while (1) {
      i5 = HEAP8[i2 + 11 >> 0] | 0;
      i3 = i5 << 24 >> 24 < 0;
      if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) | 0)) if (!(_strncmp(i30, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L61;
      i2 = i2 + 76 | 0;
      if ((i2 | 0) == (i7 | 0)) {
       i2 = i7;
       break L61;
      }
     }
     i4 = HEAP32[i22 >> 2] | 0;
     i5 = HEAP32[i30 >> 2] | 0;
     while (1) {
      i47 = HEAP8[i2 + 11 >> 0] | 0;
      i3 = i47 << 24 >> 24 < 0;
      if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i47 & 255) | 0)) if (!(_strncmp(i5, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L61;
      i2 = i2 + 76 | 0;
      if ((i2 | 0) == (i7 | 0)) {
       i2 = i7;
       break;
      }
     }
    } while (0);
    i2 = (i2 | 0) == (HEAP32[i13 >> 2] | 0);
    if (i6 << 24 >> 24 < 0) {
     i47 = HEAP32[i30 >> 2] | 0;
     i7 = HEAP32[i12 >> 2] | 0;
     HEAP32[i36 >> 2] = 66;
     HEAP32[i24 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i47, i36);
    }
    if ((HEAP8[i18 >> 0] | 0) < 0) {
     i47 = HEAP32[i38 >> 2] | 0;
     i7 = HEAP32[i11 >> 2] | 0;
     HEAP32[i36 >> 2] = 66;
     HEAP32[i25 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i47, i36);
    }
    do if (i2) {
     i2 = HEAP8[i27 >> 0] | 0;
     if (i2 << 24 >> 24 < 0) i2 = HEAP32[i28 >> 2] | 0; else i2 = i2 & 255;
     if (i2 | 0) {
      i5 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
      i6 = _strlen(i5) | 0;
      i2 = HEAP8[i27 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) i7 = HEAP32[i28 >> 2] | 0; else i7 = i2 & 255;
      if ((i6 | 0) == -1) break L28;
      if (i2 << 24 >> 24 < 0) i4 = HEAP32[i26 >> 2] | 0; else i4 = i26;
      i3 = i7 >>> 0 > i6 >>> 0;
      i2 = i3 ? i6 : i7;
      if (i2 | 0) if (_memcmp(i4, i5, i2) | 0) break;
      if (i7 >>> 0 >= i6 >>> 0 & (i3 ^ 1)) HEAP8[i1 + 20 >> 0] = 1;
     }
    } else HEAP8[i1 + 20 >> 0] = 1; while (0);
    i10 = i10 + 1 | 0;
    if (i10 >>> 0 >= (HEAP32[i35 >> 2] | 0) >>> 0) break L1;
   }
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i26);
  }
 } while (0);
 if (i32 | 0) {
  i5 = 0;
  do {
   i1 = i31 + (i5 << 4) | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i4 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i39, i1, 0) | 0;
   i2 = HEAP32[i41 >> 2] | 0;
   if (!i2) i40 = 86; else {
    i1 = i41;
    L114 : while (1) {
     i3 = i2;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L114; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) == (i41 | 0)) i40 = 86; else if (i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i40 = 86;
   }
   if ((i40 | 0) == 86) {
    i40 = 0;
    i1 = i41;
   }
   HEAP8[i1 + 20 >> 0] = 1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i32 | 0));
 }
 if (i33) {
  i11 = gb + 64016 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i38;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i37 >> 2] = 0;
  i9 = i37 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i37 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i37 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i36, i38);
  i32 = i36;
  i33 = HEAP32[i32 + 4 >> 2] | 0;
  i47 = i11;
  HEAP32[i47 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i47 + 4 >> 2] = i33;
  __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i34, 1, __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(137) | 0, i37);
  if (HEAP32[i9 >> 2] | 0) {
   i7 = 0;
   do {
    i1 = HEAP32[(HEAP32[i37 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i8 = i1 + 372 | 0;
    if (HEAP32[i8 >> 2] | 0) {
     i6 = i1 + 360 | 0;
     i5 = 0;
     do {
      i4 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = 0; else {
       HEAP32[i38 >> 2] = i1;
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i1) i40 = 102; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i36, i1, i38);
         i2 = HEAP32[i36 >> 2] | 0;
         i47 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i47 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i47 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i40 = 102; else {
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i40 = 104;
        }
       }
       if ((i40 | 0) == 102) i40 = 104;
       if ((i40 | 0) == 104) {
        i40 = 0;
        i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
       }
      }
      i3 = HEAP32[i41 >> 2] | 0;
      if (!i3) i40 = 113; else {
       i2 = i41;
       L152 : while (1) {
        i4 = i3;
        while (1) {
         if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i1 >>> 0) break;
         i3 = HEAP32[i4 + 4 >> 2] | 0;
         if (!i3) break L152; else i4 = i3;
        }
        i3 = HEAP32[i4 >> 2] | 0;
        if (!i3) {
         i2 = i4;
         break;
        } else i2 = i4;
       }
       if ((i2 | 0) == (i41 | 0)) i40 = 113; else if (i1 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) i40 = 113; else i1 = i2;
      }
      if ((i40 | 0) == 113) {
       i40 = 0;
       i1 = i41;
      }
      HEAP8[i1 + 20 >> 0] = 1;
      i5 = i5 + 1 | 0;
     } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  }
  if ((HEAP32[i10 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i11);
   HEAP32[i37 >> 2] = 0;
  }
 }
 i5 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
 i8 = (i5 | 0) > -1;
 if (i8) {
  i9 = HEAP32[i45 >> 2] | 0;
  i7 = HEAP32[i41 >> 2] | 0;
  if (!i7) {
   i4 = i41 + 20 | 0;
   i3 = i5;
   i1 = HEAP8[i41 + 20 >> 0] | 0;
   do {
    i2 = HEAP32[i9 + (i3 << 2) >> 2] | 0;
    if (!((i2 | 0) == (i39 | 0) | i1 << 24 >> 24 == 0)) if (HEAP32[i2 + 100 >> 2] | 0) {
     HEAP8[i4 >> 0] = 1;
     i1 = 1;
    }
    i3 = i3 + -1 | 0;
   } while ((i3 | 0) > -1);
  } else {
   i6 = i5;
   do {
    i4 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
    i1 = i41;
    i3 = i7;
    L181 : while (1) {
     i2 = i3;
     while (1) {
      if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) break L181;
     }
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i1 = i2;
      break;
     } else i1 = i2;
    }
    if ((i1 | 0) == (i41 | 0)) i40 = 131; else if (i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i40 = 131;
    if ((i40 | 0) == 131) {
     i40 = 0;
     i1 = i41;
    }
    if (!((i4 | 0) == (i39 | 0) | (HEAP8[i1 + 20 >> 0] | 0) == 0)) {
     i4 = HEAP32[i4 + 100 >> 2] | 0;
     if (i4 | 0) {
      i1 = i41;
      i3 = i7;
      L195 : while (1) {
       i2 = i3;
       while (1) {
        if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if (!i2) break L195;
       }
       i3 = HEAP32[i2 >> 2] | 0;
       if (!i3) {
        i1 = i2;
        break;
       } else i1 = i2;
      }
      if ((i1 | 0) == (i41 | 0)) i40 = 140; else if (i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i40 = 140;
      if ((i40 | 0) == 140) {
       i40 = 0;
       i1 = i41;
      }
      HEAP8[i1 + 20 >> 0] = 1;
     }
    }
    i6 = i6 + -1 | 0;
   } while ((i6 | 0) > -1);
  }
  if (i8) do {
   i6 = HEAP32[(HEAP32[i45 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i2 = HEAP32[i41 >> 2] | 0;
   if (!i2) i40 = 154; else {
    i4 = i6;
    i1 = i41;
    L214 : while (1) {
     i3 = i2;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L214; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) == (i41 | 0)) i40 = 154; else if (i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i40 = 154;
   }
   if ((i40 | 0) == 154) {
    i40 = 0;
    i1 = i41;
   }
   if (!(HEAP8[i1 + 20 >> 0] | 0)) __Z22DestroyObjectHighLevelP6Objectb(HEAP32[i6 + 28 >> 2] | 0, 0);
   i5 = i5 + -1 | 0;
  } while ((i5 | 0) > -1);
 }
 if ((HEAP32[i42 >> 2] | 0) <= -1) {
  i47 = HEAP32[i41 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i44, i47);
  STACKTOP = i46;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i43);
 HEAP32[i45 >> 2] = 0;
 i47 = HEAP32[i41 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i44, i47);
 STACKTOP = i46;
 return;
}

function __ZN19MeshParticleEmitter16SetupParticleTriER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti(i23, i24, i21, i18, i25, i20, f22, i15, i19, i13, i2) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 f22 = Math_fround(f22);
 i15 = i15 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f14 = f0, f16 = f0, f17 = f0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0;
 f14 = Math_fround(HEAPF32[i23 + 124 >> 2]);
 f16 = Math_fround(HEAPF32[i23 + 128 >> 2]);
 i3 = HEAP32[gb + 1477044 >> 2] | 0;
 i3 = i3 << 11 ^ i3;
 i4 = HEAP32[gb + 1477048 >> 2] | 0;
 HEAP32[gb + 1477044 >> 2] = i4;
 i11 = HEAP32[gb + 1477052 >> 2] | 0;
 HEAP32[gb + 1477048 >> 2] = i11;
 i1 = HEAP32[gb + 1477056 >> 2] | 0;
 HEAP32[gb + 1477052 >> 2] = i1;
 i3 = i3 >>> 8 ^ i3 ^ i1;
 i12 = i3 ^ i1 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i12;
 f17 = Math_fround(Math_fround((i12 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f17 = Math_fround(Math_fround(f14 * f17) + Math_fround(f16 * Math_fround(Math_fround(1.0) - f17)));
 i5 = f17 < Math_fround(0.0);
 i26 = f17 > Math_fround(100000001999999991808.0);
 f17 = i26 ? Math_fround(100000001999999991808.0) : f17;
 f17 = i5 ? Math_fround(0.0) : f17;
 HEAPF32[i24 + 40 >> 2] = f17;
 HEAPF32[i24 + 36 >> 2] = Math_fround(Math_fround(f17 + f22) + Math_fround(.00100000005));
 if ((i2 | 0) > 0) {
  i5 = i4 << 11 ^ i4;
  HEAP32[gb + 1477044 >> 2] = i11;
  HEAP32[gb + 1477048 >> 2] = i1;
  HEAP32[gb + 1477052 >> 2] = i12;
  i3 = i5 >>> 8 ^ i5 ^ i12 ^ i3 >>> 19;
  HEAP32[gb + 1477056 >> 2] = i3;
  i5 = (i3 >>> 0) % (i2 >>> 0) | 0;
  i4 = i11;
  i2 = i1;
  i1 = i12;
 } else if ((i2 | 0) < 0) {
  i5 = i4 << 11 ^ i4;
  HEAP32[gb + 1477044 >> 2] = i11;
  HEAP32[gb + 1477048 >> 2] = i1;
  HEAP32[gb + 1477052 >> 2] = i12;
  i3 = i5 >>> 8 ^ i5 ^ i12 ^ i3 >>> 19;
  HEAP32[gb + 1477056 >> 2] = i3;
  i5 = 0 - ((i3 >>> 0) % ((0 - i2 | 0) >>> 0) | 0) | 0;
  i4 = i11;
  i2 = i1;
  i1 = i12;
 } else {
  i5 = 0;
  i3 = i12;
  i2 = i11;
 }
 i13 = i13 + (i5 * 3 << 1) | 0;
 i4 = i4 << 11 ^ i4;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i26 = i4 ^ i3 >>> 19;
 f6 = Math_fround(Math_fround((i26 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i2 = i2 << 11 ^ i2;
 HEAP32[gb + 1477044 >> 2] = i1;
 HEAP32[gb + 1477048 >> 2] = i3;
 HEAP32[gb + 1477052 >> 2] = i26;
 i4 = i2 >>> 8 ^ i2 ^ i26 ^ i4 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i4;
 f7 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i4 = Math_fround(f6 + f7) > Math_fround(1.0);
 f8 = Math_fround(Math_fround(1.0) - f6);
 f10 = Math_fround(Math_fround(1.0) - f7);
 f7 = i4 ? f10 : f7;
 f6 = i4 ? f8 : f6;
 f8 = Math_fround(Math_fround(Math_fround(1.0) - f6) - f7);
 i4 = HEAPU16[i13 >> 1] | 0;
 i26 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i26 + (Math_imul(i1, i4) | 0) | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f6);
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f6);
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f6);
 i2 = HEAPU16[i13 + 2 >> 1] | 0;
 i3 = i26 + (Math_imul(i2, i1) | 0) | 0;
 f17 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
 f16 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f17 = Math_fround(f10 + f17);
 f16 = Math_fround(f9 + f16);
 f14 = Math_fround(f14 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 i3 = HEAPU16[i13 + 4 >> 1] | 0;
 i1 = i26 + (Math_imul(i3, i1) | 0) | 0;
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i1 >> 2]));
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f9 = Math_fround(f17 + f9);
 f10 = Math_fround(f16 + f10);
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 8 >> 2])));
 f16 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f16 = Math_fround(f16 + Math_fround(f10 * Math_fround(HEAPF32[i18 + 16 >> 2])));
 f16 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 32 >> 2])));
 f16 = Math_fround(Math_fround(HEAPF32[i18 + 48 >> 2]) + f16);
 f17 = Math_fround(f9 * Math_fround(HEAPF32[i18 + 4 >> 2]));
 f17 = Math_fround(f17 + Math_fround(f10 * Math_fround(HEAPF32[i18 + 20 >> 2])));
 f17 = Math_fround(f17 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 36 >> 2])));
 f17 = Math_fround(Math_fround(HEAPF32[i18 + 52 >> 2]) + f17);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i18 + 8 >> 2]));
 f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i18 + 24 >> 2])));
 f14 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 40 >> 2])));
 f14 = Math_fround(Math_fround(HEAPF32[i18 + 56 >> 2]) + f14);
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) {
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 } else {
  i26 = HEAP32[i19 + 4 >> 2] | 0;
  i18 = i1 + (Math_imul(i26, i4) | 0) | 0;
  i19 = i1 + (Math_imul(i26, i2) | 0) | 0;
  i26 = i1 + (Math_imul(i26, i3) | 0) | 0;
  f29 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
  f27 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 4 >> 2]));
  f9 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 8 >> 2]));
  f28 = Math_fround(f7 * Math_fround(HEAPF32[i19 >> 2]));
  f10 = Math_fround(f7 * Math_fround(HEAPF32[i19 + 4 >> 2]));
  f28 = Math_fround(f29 + f28);
  f10 = Math_fround(f27 + f10);
  f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i19 + 8 >> 2])));
  f27 = Math_fround(f8 * Math_fround(HEAPF32[i26 >> 2]));
  f6 = Math_fround(f8 * Math_fround(HEAPF32[i26 + 4 >> 2]));
  f27 = Math_fround(f28 + f27);
  f6 = Math_fround(f10 + f6);
  f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i26 + 8 >> 2])));
  f7 = Math_fround(f27 * Math_fround(HEAPF32[i20 >> 2]));
  f7 = Math_fround(f7 + Math_fround(f6 * Math_fround(HEAPF32[i20 + 12 >> 2])));
  f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i20 + 24 >> 2])));
  f10 = Math_fround(f27 * Math_fround(HEAPF32[i20 + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i20 + 16 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i20 + 28 >> 2])));
  f8 = Math_fround(f27 * Math_fround(HEAPF32[i20 + 8 >> 2]));
  f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i20 + 20 >> 2])));
  f9 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i20 + 32 >> 2])));
  f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f10 * f10)) + Math_fround(f9 * f9));
  if (!(f6 == Math_fround(0.0))) f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
  f8 = Math_fround(f7 * f6);
  f7 = Math_fround(f9 * f6);
  f6 = Math_fround(f10 * f6);
 }
 i31 = i23 + 44 | 0;
 HEAP32[i24 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i4 = HEAP32[gb + 1477044 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 i1 = HEAP32[gb + 1477048 >> 2] | 0;
 i2 = HEAP32[gb + 1477052 >> 2] | 0;
 i3 = HEAP32[gb + 1477056 >> 2] | 0;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i3 >>> 19;
 f27 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f27 = Math_fround(Math_fround(f27 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f27) * f22));
 f34 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f27);
 i26 = i21 + 4 | 0;
 f28 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f27);
 i20 = i21 + 8 | 0;
 f27 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f27);
 f34 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f34);
 HEAPF32[i24 >> 2] = f34;
 i33 = i24 + 4 | 0;
 f28 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) + f28);
 HEAPF32[i33 >> 2] = f28;
 i32 = i24 + 8 | 0;
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i32 >> 2]));
 HEAPF32[i32 >> 2] = f27;
 f9 = Math_fround(HEAPF32[i23 + 32 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i31 >> 2]));
 f29 = Math_fround(HEAPF32[i23 + 36 >> 2]);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i23 + 48 >> 2]));
 f22 = Math_fround(HEAPF32[i23 + 40 >> 2]);
 i1 = i1 << 11 ^ i1;
 i1 = i1 >>> 8 ^ i1 ^ i5;
 i4 = i1 ^ i4 >>> 19;
 f10 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f29 = Math_fround(f29 * f10);
 f22 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i23 + 52 >> 2])) * f10);
 f10 = Math_fround(f34 + Math_fround(f9 * f10));
 HEAPF32[i24 >> 2] = f10;
 f29 = Math_fround(f28 + f29);
 HEAPF32[i33 >> 2] = f29;
 f27 = Math_fround(f22 + f27);
 HEAPF32[i32 >> 2] = f27;
 f22 = Math_fround(f16 * Math_fround(HEAPF32[i25 >> 2]));
 i31 = i25 + 12 | 0;
 f22 = Math_fround(f22 + Math_fround(f17 * Math_fround(HEAPF32[i31 >> 2])));
 i30 = i25 + 24 | 0;
 f22 = Math_fround(f22 + Math_fround(f14 * Math_fround(HEAPF32[i30 >> 2])));
 i11 = i25 + 4 | 0;
 f28 = Math_fround(f16 * Math_fround(HEAPF32[i11 >> 2]));
 i12 = i25 + 16 | 0;
 f28 = Math_fround(f28 + Math_fround(f17 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i25 + 28 | 0;
 f28 = Math_fround(f28 + Math_fround(f14 * Math_fround(HEAPF32[i13 >> 2])));
 i15 = i25 + 8 | 0;
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i15 >> 2]));
 i18 = i25 + 20 | 0;
 f17 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i18 >> 2])));
 i19 = i25 + 32 | 0;
 f17 = Math_fround(f17 + Math_fround(f14 * Math_fround(HEAPF32[i19 >> 2])));
 HEAPF32[i24 >> 2] = Math_fround(f22 + f10);
 HEAPF32[i33 >> 2] = Math_fround(f28 + f29);
 HEAPF32[i32 >> 2] = Math_fround(f17 + f27);
 f27 = Math_fround(HEAPF32[i23 + 224 >> 2]);
 f17 = Math_fround(HEAPF32[i23 + 228 >> 2]);
 i2 = i2 << 11 ^ i2;
 i1 = i2 >>> 8 ^ i2 ^ i4 ^ i1 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i1;
 f29 = Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f29 = Math_fround(Math_fround(f27 * f29) + Math_fround(f17 * Math_fround(Math_fround(1.0) - f29)));
 f17 = Math_fround(f8 * f29);
 f27 = Math_fround(f6 * f29);
 f29 = Math_fround(f7 * f29);
 f17 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f17);
 f27 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f27);
 f29 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f29);
 i20 = i24 + 12 | 0;
 HEAPF32[i20 >> 2] = f17;
 i21 = i24 + 16 | 0;
 HEAPF32[i21 >> 2] = f27;
 i26 = i24 + 20 | 0;
 HEAPF32[i26 >> 2] = f29;
 i3 = i3 << 11 ^ i3;
 i1 = HEAP32[gb + 1477056 >> 2] | 0;
 i3 = i3 >>> 8 ^ i3 ^ i1;
 i2 = i3 ^ i1 >>> 19;
 f28 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f28 = Math_fround(Math_fround(Math_fround(1.0) - f28) - f28);
 i5 = i5 << 11 ^ i5;
 i5 = i5 >>> 8 ^ i5 ^ i2;
 i3 = i5 ^ i3 >>> 19;
 f14 = Math_fround(Math_fround((i3 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f14 = Math_fround(Math_fround(f14 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f14) * Math_fround(6.28318548)));
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f28 * f28))));
 f10 = Math_fround(f16 * Math_fround(+Math_cos(+f14)));
 f14 = Math_fround(f16 * Math_fround(+Math_sin(+f14)));
 i4 = i4 << 11 ^ i4;
 HEAP32[gb + 1477044 >> 2] = i1;
 HEAP32[gb + 1477048 >> 2] = i2;
 HEAP32[gb + 1477052 >> 2] = i3;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i5 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i5;
 f16 = Math_fround(+Math_pow(+Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07)), .333333343));
 f10 = Math_fround(f10 * f16);
 f14 = Math_fround(f14 * f16);
 f28 = Math_fround(f16 * f28);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i23 + 180 >> 2]));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i23 + 184 >> 2]));
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i23 + 188 >> 2]));
 f16 = Math_fround(f10 * Math_fround(HEAPF32[i25 >> 2]));
 f16 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i31 >> 2])));
 f16 = Math_fround(f16 + Math_fround(f28 * Math_fround(HEAPF32[i30 >> 2])));
 f22 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f22 = Math_fround(f22 + Math_fround(f14 * Math_fround(HEAPF32[i12 >> 2])));
 f22 = Math_fround(f22 + Math_fround(f28 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i15 >> 2]));
 f14 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2])));
 f28 = Math_fround(f14 + Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2])));
 HEAPF32[i20 >> 2] = Math_fround(f16 + f17);
 HEAPF32[i21 >> 2] = Math_fround(f22 + f27);
 HEAPF32[i26 >> 2] = Math_fround(f28 + f29);
 if (!(HEAP8[i23 + 193 >> 0] | 0)) {
  f28 = Math_fround(0.0);
  i33 = i1;
  i30 = i5;
  i31 = i2;
  i26 = i3;
  i32 = i24 + 28 | 0;
  HEAPF32[i32 >> 2] = f28;
  i32 = i23 + 200 | 0;
  f28 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i23 + 196 | 0;
  f27 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i33 << 11;
  i33 = i32 ^ i33;
  i32 = i30 >>> 19;
  i25 = i33 >>> 8;
  i33 = i25 ^ i33;
  i33 = i33 ^ i30;
  i32 = i33 ^ i32;
  i25 = i32 & 8388607;
  f34 = Math_fround(i25 >>> 0);
  f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
  f29 = Math_fround(f27 * f34);
  f34 = Math_fround(Math_fround(1.0) - f34);
  f34 = Math_fround(f27 * f34);
  f29 = Math_fround(f34 - f29);
  f29 = Math_fround(f28 + f29);
  f29 = Math_fround(f29 / Math_fround(360.0));
  f29 = Math_fround(f29 * Math_fround(2.0));
  f29 = Math_fround(f29 * Math_fround(3.14159274));
  i25 = i24 + 32 | 0;
  HEAPF32[i25 >> 2] = f29;
  i25 = i24 + 44 | 0;
  HEAP32[i25 >> 2] = -1;
  i25 = i23 + 116 | 0;
  f29 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i23 + 120 | 0;
  f28 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i31 << 11;
  i31 = i25 ^ i31;
  HEAP32[gb + 1477044 >> 2] = i26;
  HEAP32[gb + 1477048 >> 2] = i30;
  HEAP32[gb + 1477052 >> 2] = i32;
  i33 = i33 >>> 19;
  i30 = i31 >>> 8;
  i31 = i30 ^ i31;
  i32 = i31 ^ i32;
  i33 = i32 ^ i33;
  HEAP32[gb + 1477056 >> 2] = i33;
  i33 = i33 & 8388607;
  f34 = Math_fround(i33 >>> 0);
  f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
  f29 = Math_fround(f29 * f34);
  f34 = Math_fround(Math_fround(1.0) - f34);
  f34 = Math_fround(f28 * f34);
  f34 = Math_fround(f29 + f34);
  i33 = i24 + 24 | 0;
  HEAPF32[i33 >> 2] = f34;
  return;
 }
 i30 = i1 << 11 ^ i1;
 HEAP32[gb + 1477044 >> 2] = i2;
 HEAP32[gb + 1477048 >> 2] = i3;
 HEAP32[gb + 1477052 >> 2] = i5;
 i30 = i30 >>> 8 ^ i30 ^ i5 ^ i4 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i30;
 f28 = Math_fround(Math_fround((i30 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f28 = Math_fround(Math_fround(f28 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f28) * Math_fround(6.28318548)));
 i33 = i2;
 i31 = i3;
 i26 = i5;
 i32 = i24 + 28 | 0;
 HEAPF32[i32 >> 2] = f28;
 i32 = i23 + 200 | 0;
 f28 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = i23 + 196 | 0;
 f27 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = i33 << 11;
 i33 = i32 ^ i33;
 i32 = i30 >>> 19;
 i25 = i33 >>> 8;
 i33 = i25 ^ i33;
 i33 = i33 ^ i30;
 i32 = i33 ^ i32;
 i25 = i32 & 8388607;
 f34 = Math_fround(i25 >>> 0);
 f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
 f29 = Math_fround(f27 * f34);
 f34 = Math_fround(Math_fround(1.0) - f34);
 f34 = Math_fround(f27 * f34);
 f29 = Math_fround(f34 - f29);
 f29 = Math_fround(f28 + f29);
 f29 = Math_fround(f29 / Math_fround(360.0));
 f29 = Math_fround(f29 * Math_fround(2.0));
 f29 = Math_fround(f29 * Math_fround(3.14159274));
 i25 = i24 + 32 | 0;
 HEAPF32[i25 >> 2] = f29;
 i25 = i24 + 44 | 0;
 HEAP32[i25 >> 2] = -1;
 i25 = i23 + 116 | 0;
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i23 + 120 | 0;
 f28 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i31 << 11;
 i31 = i25 ^ i31;
 HEAP32[gb + 1477044 >> 2] = i26;
 HEAP32[gb + 1477048 >> 2] = i30;
 HEAP32[gb + 1477052 >> 2] = i32;
 i33 = i33 >>> 19;
 i30 = i31 >>> 8;
 i31 = i30 ^ i31;
 i32 = i31 ^ i32;
 i33 = i32 ^ i33;
 HEAP32[gb + 1477056 >> 2] = i33;
 i33 = i33 & 8388607;
 f34 = Math_fround(i33 >>> 0);
 f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
 f29 = Math_fround(f29 * f34);
 f34 = Math_fround(Math_fround(1.0) - f34);
 f34 = Math_fround(f28 * f34);
 f34 = Math_fround(f29 + f34);
 i33 = i24 + 24 | 0;
 HEAPF32[i33 >> 2] = f34;
 return;
}

function __Z25ApproximateUVDistributionPK10Matrix4x4fR4MeshRK8Vector2ffi(i34, i9, i27, f31, i10) {
 i34 = i34 | 0;
 i9 = i9 | 0;
 i27 = i27 | 0;
 f31 = Math_fround(f31);
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i28 = 0, i29 = 0, f30 = f0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i50 + 8 | 0;
 i33 = i50;
 i49 = i50 + 96 | 0;
 i40 = i50 + 76 | 0;
 i43 = i50 + 56 | 0;
 i44 = i50 + 36 | 0;
 i35 = i50 + 16 | 0;
 HEAP32[i49 >> 2] = 0;
 i47 = i49 + 4 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i49 + 8 >> 2] = 0;
 HEAP32[i49 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i9, i49);
 i6 = gb + 64016 | 0;
 i37 = HEAP32[i6 + 4 >> 2] | 0;
 i36 = i33;
 HEAP32[i36 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i36 + 4 >> 2] = i37;
 HEAP32[i40 >> 2] = 0;
 i36 = i40 + 16 | 0;
 HEAP32[i36 >> 2] = 0;
 i37 = i40 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i48, i33);
 i6 = i48;
 i38 = HEAP32[i6 + 4 >> 2] | 0;
 i39 = i37;
 HEAP32[i39 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i39 + 4 >> 2] = i38;
 i39 = gb + 64016 | 0;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i6 = i33;
 HEAP32[i6 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i6 + 4 >> 2] = i38;
 HEAP32[i43 >> 2] = 0;
 i6 = i43 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i38 = i43 + 16 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i43 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i48, i33);
 i11 = i48;
 i41 = HEAP32[i11 + 4 >> 2] | 0;
 i42 = i39;
 HEAP32[i42 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i42 + 4 >> 2] = i41;
 i42 = gb + 64016 | 0;
 i41 = HEAP32[i42 + 4 >> 2] | 0;
 i11 = i33;
 HEAP32[i11 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i11 + 4 >> 2] = i41;
 HEAP32[i44 >> 2] = 0;
 i11 = i44 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i41 = i44 + 16 | 0;
 HEAP32[i41 >> 2] = 0;
 i42 = i44 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i48, i33);
 i32 = i48;
 i45 = HEAP32[i32 + 4 >> 2] | 0;
 i46 = i42;
 HEAP32[i46 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i46 + 4 >> 2] = i45;
 i46 = gb + 64016 | 0;
 i45 = HEAP32[i46 + 4 >> 2] | 0;
 i32 = i33;
 HEAP32[i32 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i32 + 4 >> 2] = i45;
 HEAP32[i35 >> 2] = 0;
 i32 = i35 + 12 | 0;
 HEAP32[i32 >> 2] = 0;
 i45 = i35 + 16 | 0;
 HEAP32[i45 >> 2] = 0;
 i46 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i48, i33);
 i33 = i48;
 i29 = HEAP32[i33 + 4 >> 2] | 0;
 i28 = i46;
 HEAP32[i28 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = (HEAP32[i47 >> 2] | 0) - (HEAP32[i49 >> 2] | 0) >> 2;
 i29 = (i28 >>> 0) / 3 | 0;
 HEAP32[i40 + 12 >> 2] = i29;
 if (i28 >>> 0 > 2) {
  HEAP32[i36 >> 2] = i29;
  HEAP32[i40 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i29 << 2, 4, i37, 0, gb + 1047584 | 0, 464) | 0;
  i2 = HEAP32[i38 >> 2] | 0;
 } else i2 = 0;
 i5 = i9 + 32 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i38 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i43 >> 2] | 0, i1 * 12 | 0, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i43 >> 2] = i1;
  break;
 } else {
  i33 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i33 | 0, HEAP32[i43 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i38 >> 2] = i1;
  HEAP32[i43 >> 2] = i33;
  i1 = i33;
  break;
 } else i1 = HEAP32[i43 >> 2] | 0; while (0);
 __ZNK4Mesh18ExtractVertexArrayEP8Vector3f(i9, i1);
 i33 = (i34 | 0) != 0;
 if (i33) {
  i2 = HEAP32[i43 >> 2] | 0;
  __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fPS2_i(i34, i2, i2, HEAP32[i6 >> 2] | 0);
 }
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = HEAP32[i41 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i41 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i44 >> 2] | 0, i1 << 3, 4, i42, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i44 >> 2] = i1;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i42, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i44 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
  HEAP32[i41 >> 2] = i1;
  HEAP32[i44 >> 2] = i6;
  i1 = i6;
  break;
 } else i1 = HEAP32[i44 >> 2] | 0; while (0);
 __ZNK4Mesh14ExtractUvArrayEiPfi(i9, i10, i1, 2);
 f3 = Math_fround(HEAPF32[i27 >> 2]);
 if (f3 != Math_fround(1.0)) {
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   i6 = i27 + 4 | 0;
   i12 = 18;
  }
 } else {
  i2 = i27 + 4 | 0;
  i10 = Math_fround(HEAPF32[i2 >> 2]) != Math_fround(1.0);
  i1 = HEAP32[i11 >> 2] | 0;
  if (i10 & (i1 | 0) != 0) {
   i6 = i2;
   i12 = 18;
  }
 }
 if ((i12 | 0) == 18) {
  i5 = HEAP32[i44 >> 2] | 0;
  HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
  f30 = Math_fround(HEAPF32[i6 >> 2]);
  i12 = i5 + 4 | 0;
  HEAPF32[i12 >> 2] = Math_fround(f30 * Math_fround(HEAPF32[i12 >> 2]));
  if (i1 >>> 0 > 1) {
   i2 = 1;
   do {
    f30 = Math_fround(HEAPF32[i27 >> 2]);
    i12 = i5 + (i2 << 3) | 0;
    HEAPF32[i12 >> 2] = Math_fround(f30 * Math_fround(HEAPF32[i12 >> 2]));
    f30 = Math_fround(HEAPF32[i6 >> 2]);
    i12 = i5 + (i2 << 3) + 4 | 0;
    HEAPF32[i12 >> 2] = Math_fround(f30 * Math_fround(HEAPF32[i12 >> 2]));
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i1 >>> 0);
  }
 }
 if (i28 >>> 0 > 2) {
  i5 = HEAP32[i49 >> 2] | 0;
  i6 = HEAP32[i43 >> 2] | 0;
  i1 = HEAP32[i40 >> 2] | 0;
  i2 = 0;
  do {
   i27 = i2 * 3 | 0;
   i12 = HEAP32[i5 + (i27 << 2) >> 2] | 0;
   f25 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) >> 2]);
   f23 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) + 8 >> 2]);
   i12 = HEAP32[i5 + (i27 + 1 << 2) >> 2] | 0;
   f22 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) >> 2]);
   f24 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) + 4 >> 2]);
   f21 = Math_fround(HEAPF32[i6 + (i12 * 12 | 0) + 8 >> 2]);
   i27 = HEAP32[i5 + (i27 + 2 << 2) >> 2] | 0;
   f20 = Math_fround(HEAPF32[i6 + (i27 * 12 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i6 + (i27 * 12 | 0) + 4 >> 2]);
   f22 = Math_fround(f22 - f25);
   f24 = Math_fround(f24 - f23);
   f21 = Math_fround(f21 - f30);
   f25 = Math_fround(f20 - f25);
   f23 = Math_fround(f26 - f23);
   f30 = Math_fround(Math_fround(HEAPF32[i6 + (i27 * 12 | 0) + 8 >> 2]) - f30);
   f26 = Math_fround(Math_fround(f24 * f30) - Math_fround(f21 * f23));
   f30 = Math_fround(Math_fround(f21 * f25) - Math_fround(f22 * f30));
   f25 = Math_fround(Math_fround(f22 * f23) - Math_fround(f24 * f25));
   HEAPF32[i1 + (i2 << 2) >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f26 * f26) + Math_fround(f30 * f30))))) * Math_fround(.5));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i29 | 0));
  i27 = i40;
 } else {
  i27 = i40;
  i1 = HEAP32[i40 >> 2] | 0;
 }
 _qsort(i1, i29, 4, fb + 610 | 0);
 i12 = i29 - ((i28 >>> 0) / 30 | 0) | 0;
 i5 = HEAP32[i40 >> 2] | 0;
 if (!i12) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(nan);
 } else {
  f3 = Math_fround(0.0);
  i1 = 0;
  do {
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  f7 = Math_fround(i12 >>> 0);
  f3 = Math_fround(f3 / f7);
  f4 = Math_fround(0.0);
  i1 = 0;
  do {
   f4 = Math_fround(f4 + Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  f8 = Math_fround(f4 / f7);
  f4 = Math_fround(0.0);
  i1 = 0;
  i2 = 0;
  do {
   f7 = Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
   if (f7 < f8) {
    f30 = Math_fround(f7 - f8);
    f4 = Math_fround(f4 + Math_fround(f30 * f30));
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  if (!i1) f4 = Math_fround(0.0); else f4 = Math_fround(Math_sqrt(Math_fround(f4 / Math_fround(i1 | 0))));
 }
 f30 = Math_fround(f3 - f4);
 i29 = f30 > Math_fround(.00100000005);
 f30 = i29 ? f30 : Math_fround(.00100000005);
 f30 = +f4 < .1 ? Math_fround(.00100000005) : f30;
 if ((i12 | 0) > 0) {
  i11 = 0;
  do {
   i29 = i11 * 3 | 0;
   i6 = HEAP32[i49 >> 2] | 0;
   i9 = HEAP32[i6 + (i29 << 2) >> 2] | 0;
   i10 = HEAP32[i6 + (i29 + 1 << 2) >> 2] | 0;
   i29 = HEAP32[i6 + (i29 + 2 << 2) >> 2] | 0;
   i6 = HEAP32[i43 >> 2] | 0;
   i28 = HEAP32[i44 >> 2] | 0;
   f19 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) + 4 >> 2]);
   f21 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) + 8 >> 2]);
   f52 = Math_fround(HEAPF32[i6 + (i10 * 12 | 0) >> 2]);
   f51 = Math_fround(HEAPF32[i6 + (i10 * 12 | 0) + 4 >> 2]);
   f24 = Math_fround(HEAPF32[i6 + (i10 * 12 | 0) + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i6 + (i29 * 12 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i6 + (i29 * 12 | 0) + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i6 + (i29 * 12 | 0) + 8 >> 2]);
   f4 = Math_fround(HEAPF32[i28 + (i9 << 3) >> 2]);
   f7 = Math_fround(HEAPF32[i28 + (i9 << 3) + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i28 + (i10 << 3) >> 2]);
   f13 = Math_fround(HEAPF32[i28 + (i10 << 3) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i28 + (i29 << 3) >> 2]);
   f3 = Math_fround(HEAPF32[i28 + (i29 << 3) + 4 >> 2]);
   f15 = Math_fround(f52 - f19);
   f16 = Math_fround(f51 - f20);
   f17 = Math_fround(f24 - f21);
   f18 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f17 * f17))));
   f19 = Math_fround(f25 - f19);
   f20 = Math_fround(f26 - f20);
   f21 = Math_fround(f23 - f21);
   f22 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))));
   f25 = Math_fround(f52 - f25);
   f26 = Math_fround(f51 - f26);
   f23 = Math_fround(f24 - f23);
   f23 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26)) + Math_fround(f23 * f23))));
   if (f18 < Math_fround(.00100000005) | f22 < Math_fround(.00100000005) | f23 < Math_fround(.00100000005)) i1 = 0; else {
    f24 = Math_fround(f18 * f18);
    f25 = Math_fround(f22 * f22);
    f26 = Math_fround(f23 * f23);
    if (Math_fround(+Math_acos(+Math_fround(Math_fround(Math_fround(f24 + f25) - f26) / Math_fround(Math_fround(f18 * Math_fround(2.0)) * f22)))) < Math_fround(.0872664675)) i1 = 0; else if (Math_fround(+Math_acos(+Math_fround(Math_fround(Math_fround(f25 + f26) - f24) / Math_fround(Math_fround(f22 * Math_fround(2.0)) * f23)))) < Math_fround(.0872664675)) i1 = 0; else if (Math_fround(+Math_acos(+Math_fround(Math_fround(Math_fround(f24 + f26) - f25) / Math_fround(f18 * Math_fround(f23 * Math_fround(2.0)))))) < Math_fround(.0872664675)) i1 = 0; else {
     f52 = Math_fround(Math_fround(f16 * f21) - Math_fround(f17 * f20));
     f51 = Math_fround(Math_fround(f17 * f19) - Math_fround(f15 * f21));
     f26 = Math_fround(Math_fround(f15 * f20) - Math_fround(f16 * f19));
     f51 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51))))) * Math_fround(.5));
     f52 = Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f8 - f4) * Math_fround(f3 - f7)) - Math_fround(Math_fround(f13 - f7) * Math_fround(f14 - f4))))) * Math_fround(.5));
     f3 = Math_fround(f51 / f52);
     if (f51 < f30 | f52 < f31) i1 = 0; else {
      i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
      if (f3 > Math_fround(.00100000005)) {
       i5 = HEAP32[i32 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i9 = HEAP32[i45 >> 2] | 0;
       i10 = i9 & 2147483647;
       do if (i6 >>> 0 > i10 >>> 0) {
        i2 = i9 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
         HEAP32[i45 >> 2] = i2;
         HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2 << 2, 4, i46, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i46, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i29 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i32 >> 2] << 2 | 0) | 0;
         HEAP32[i45 >> 2] = i2;
         HEAP32[i35 >> 2] = i29;
         break;
        }
       } while (0);
       HEAP32[i32 >> 2] = i6;
       HEAPF32[(HEAP32[i35 >> 2] | 0) + (i5 << 2) >> 2] = f3;
      }
     }
    }
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) < (i12 | 0));
 } else i1 = 0;
 i6 = HEAP32[i32 >> 2] | 0;
 if (i6) {
  i5 = HEAP32[i35 >> 2] | 0;
  f3 = Math_fround(0.0);
  i1 = 0;
  do {
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  f4 = Math_fround(i6 >>> 0);
  f8 = Math_fround(f3 / f4);
  f3 = Math_fround(0.0);
  i1 = 0;
  do {
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  f7 = Math_fround(f3 / f4);
  f3 = Math_fround(0.0);
  i1 = 0;
  i2 = 0;
  do {
   f4 = Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
   if (f4 > f7) {
    f52 = Math_fround(f4 - f7);
    f3 = Math_fround(f3 + Math_fround(f52 * f52));
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  if (!i1) f3 = Math_fround(0.0); else f3 = Math_fround(Math_sqrt(Math_fround(f3 / Math_fround(i1 | 0))));
  f52 = Math_fround(f8 + f3);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i32 = !(f3 <= Math_fround(.00100000005));
 f3 = i32 ? f3 : Math_fround(1.0);
 if (!(i32 | i33 ^ 1)) {
  f51 = Math_fround(HEAPF32[i34 >> 2]);
  f52 = Math_fround(HEAPF32[i34 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i34 + 8 >> 2]);
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(f52 * f52)) + Math_fround(f3 * f3))));
  f52 = Math_fround(HEAPF32[i34 + 16 >> 2]);
  f51 = Math_fround(HEAPF32[i34 + 20 >> 2]);
  f31 = Math_fround(HEAPF32[i34 + 24 >> 2]);
  f31 = Math_fround(f3 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51)) + Math_fround(f31 * f31)))));
  f51 = Math_fround(HEAPF32[i34 + 32 >> 2]);
  f52 = Math_fround(HEAPF32[i34 + 36 >> 2]);
  f3 = Math_fround(HEAPF32[i34 + 40 >> 2]);
  f3 = Math_fround(f31 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(f52 * f52)) + Math_fround(f3 * f3)))));
  f3 = Math_fround(f3 * f3);
 }
 if ((HEAP32[i45 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i46);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i41 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i44 >> 2] | 0, i42);
  HEAP32[i44 >> 2] = 0;
 }
 if ((HEAP32[i38 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 >> 2] | 0, i39);
  HEAP32[i43 >> 2] = 0;
 }
 if ((HEAP32[i36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i37);
  HEAP32[i40 >> 2] = 0;
 }
 i1 = HEAP32[i49 >> 2] | 0;
 if (!i1) {
  STACKTOP = i50;
  return Math_fround(f3);
 }
 i2 = HEAP32[i47 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i47 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i49 = HEAP32[i49 + 12 >> 2] | 0;
 HEAP32[i48 >> 2] = 1;
 HEAP32[i48 + 4 >> 2] = i49;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i48);
 STACKTOP = i50;
 return Math_fround(f3);
}

function __ZN11AudioSource4PlayEd(i21, d22) {
 i21 = i21 | 0;
 d22 = +d22;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23 + 80 | 0;
 i16 = i23 + 64 | 0;
 i15 = i23 + 48 | 0;
 i12 = i23 + 32 | 0;
 i11 = i23 + 24 | 0;
 i9 = i23 + 8 | 0;
 i8 = i23;
 i18 = i23 + 112 | 0;
 i20 = i23 + 96 | 0;
 i6 = i23 + 92 | 0;
 i19 = i23 + 88 | 0;
 i14 = i23 + 84 | 0;
 i17 = i23 + 108 | 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) {
  STACKTOP = i23;
  return;
 }
 if (!(HEAP8[i21 + 33 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 864287 | 0, 0, gb + 855390 | 0, 437, 512, HEAP32[i21 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i23;
  return;
 }
 __ZN11AudioSource16CreateFMODGroupsEv(i21);
 i5 = i21 + 440 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i20 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i20);
    i4 = HEAP32[i18 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i7 = 12;
  }
  if ((i7 | 0) == 10) i7 = 12;
  if ((i7 | 0) == 12) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
  if (!i1) i7 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i20);
    i2 = HEAP32[i18 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 21;
   }
  }
  if ((i7 | 0) == 19) i7 = 21;
  if ((i7 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i4 = HEAP32[i1 + 52 >> 2] | 0;
  if (i4 | 0) {
   HEAP32[i20 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i7 = 28; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i20);
     i2 = HEAP32[i18 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 28; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i7 = 30;
    }
   }
   if ((i7 | 0) == 28) i7 = 30;
   if ((i7 | 0) == 30) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   __ZN10AudioMixer16ResumeProcessingEv(i1);
  }
 } while (0);
 i4 = i21 + 436 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  i5 = 0;
  i2 = 0;
 } else {
  HEAP32[i20 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 38; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i20);
    i2 = HEAP32[i18 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 38; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 40;
   }
  }
  if ((i7 | 0) == 38) i7 = 40;
  if ((i7 | 0) == 40) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i5 = 0;
    i2 = 0;
    break;
   }
  }
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0) | 0)) {
   __ZN10SampleClip13LoadAudioDataEv(i1) | 0;
   i5 = i1;
   i2 = 1;
  } else {
   i5 = i1;
   i2 = 1;
  }
 } while (0);
 i13 = i21 + 456 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 L65 : do if (!i1) i7 = 51; else {
  do if (HEAP32[i1 + 16 >> 2] | 0) {
   i1 = HEAP32[i13 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE(i1, HEAP32[i21 + 488 >> 2] | 0) | 0;
   if (!(HEAP8[(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0) + 236 >> 0] | 0)) {
    __ZN11AudioSource4StopEb(i21, 0);
    i1 = HEAP32[i13 >> 2] | 0;
    if (!i1) {
     i7 = 51;
     break L65;
    } else break;
   }
   __ZN11AudioSource11AssignPropsEv(i21);
   HEAP8[i21 + 532 >> 0] = 0;
   __ZN11AudioSource16UpdatePauseStateEv(i21);
   STACKTOP = i23;
   return;
  } while (0);
  if (!(HEAP32[i1 + 16 >> 2] | 0)) i7 = 51;
 } while (0);
 L77 : do if ((i7 | 0) == 51) {
  do if (i2) {
   i1 = __ZN10SampleClip15AllocateChannelEby(i5, 1, 0, 0) | 0;
   i2 = i1;
   i3 = (i1 | 0) == 0;
   if (!i3) {
    i20 = i1 + 4 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   }
   i4 = HEAP32[i13 >> 2] | 0;
   if (i4 | 0) {
    i20 = i4 + 4 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
    if (!(HEAP32[i20 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
    }
   }
   HEAP32[i13 >> 2] = i2;
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   if (i3) {
    STACKTOP = i23;
    return;
   }
   i20 = i1 + 4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
   if (!(HEAP32[i20 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
    i1 = HEAP32[i13 >> 2] | 0;
    if (!i1) {
     STACKTOP = i23;
     return;
    }
   }
   if (!(HEAP32[i1 + 16 >> 2] | 0)) break L77;
   i1 = i5 + 120 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i13 >> 2] | 0;
   HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 240 >> 2] = i21;
  } else {
   HEAP32[i20 >> 2] = 0;
   i5 = i20 + 4 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   L97 : do if (__ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb(i21, i20, 1) | 0) {
    HEAP32[i6 >> 2] = 0;
    __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i6) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    L99 : do if (!i1) {
     i1 = HEAP32[i21 + 28 >> 2] | 0;
     if (!i1) i1 = gb + 1576256 | 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     HEAP32[i10 >> 2] = i1;
     __Z6FormatPKcz(i18, gb + 864975 | 0, i10);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 855390 | 0, 532, 512, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    } else {
     if (!(HEAP32[i1 + 20 >> 2] | 0)) {
      HEAP32[i1 + 16 >> 2] = i21;
      i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
      HEAP32[i21 + 536 >> 2] = i1;
      i1 = __ZN4FMOD3DSP6removeEv(i1) | 0;
      if (i1 | 0) {
       i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
       HEAP32[i9 >> 2] = gb + 855390;
       HEAP32[i9 + 4 >> 2] = 500;
       HEAP32[i9 + 8 >> 2] = gb + 855460;
       HEAP32[i9 + 12 >> 2] = i10;
       __Z6FormatPKcz(i18, gb + 883334 | 0, i9);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
      }
      i1 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
      i1 = __ZN4FMOD6System7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE(i1, -1, HEAP32[HEAP32[i20 >> 2] >> 2] | 0, 1, i19) | 0;
      switch (i1 | 0) {
      case 10:
       {
        if (!i21) i1 = 0; else i1 = HEAP32[i21 + 4 >> 2] | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 864656 | 0, 0, gb + 855390 | 0, 505, 512, i1, 0, 0);
        break;
       }
      case 0:
       {
        i1 = __ZN4FMOD7Channel7setModeEj(HEAP32[i19 >> 2] | 0, 82) | 0;
        if (i1 | 0) {
         i11 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
         HEAP32[i12 >> 2] = gb + 855390;
         HEAP32[i12 + 4 >> 2] = 516;
         HEAP32[i12 + 8 >> 2] = gb + 864753;
         HEAP32[i12 + 12 >> 2] = i11;
         __Z6FormatPKcz(i18, gb + 883334 | 0, i12);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
        }
        i1 = __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i14, 0, 0, 0, 0, 0) | 0;
        if (i1 | 0) {
         i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
         HEAP32[i15 >> 2] = gb + 855390;
         HEAP32[i15 + 4 >> 2] = 519;
         HEAP32[i15 + 8 >> 2] = gb + 864781;
         HEAP32[i15 + 12 >> 2] = i12;
         __Z6FormatPKcz(i18, gb + 883334 | 0, i15);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
        }
        i1 = __ZN4FMOD7Channel12setFrequencyEf(HEAP32[i19 >> 2] | 0, Math_fround(HEAP32[i14 >> 2] | 0)) | 0;
        if (i1 | 0) {
         i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
         HEAP32[i16 >> 2] = gb + 855390;
         HEAP32[i16 + 4 >> 2] = 520;
         HEAP32[i16 + 8 >> 2] = gb + 864877;
         HEAP32[i16 + 12 >> 2] = i15;
         __Z6FormatPKcz(i18, gb + 883334 | 0, i16);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
        }
        __ZN11SoundHandleC2Ev(i17);
        i1 = __ZnwjRK10MemLabelIdiPKci(252, gb + 63328 | 0, 16, gb + 883367 | 0, 296) | 0;
        __ZN11SoundHandleC2ERKS_(i18, i17);
        __ZN20SoundChannelInstanceC2E11SoundHandleb(i1, i18, 1);
        HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
        HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
        do if (!i1) i2 = 0; else {
         i1 = HEAP32[i1 + 248 >> 2] | 0;
         i2 = i1;
         if (!i1) break;
         i16 = i1 + 4 | 0;
         HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
        } while (0);
        __ZN11SoundHandleD2Ev(i18);
        i1 = i2;
        i3 = (i2 | 0) == 0;
        if (!i3) {
         i18 = i1 + 4 | 0;
         HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
        }
        i4 = HEAP32[i13 >> 2] | 0;
        do if (i4 | 0) {
         i18 = i4 + 4 | 0;
         HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + -1;
         if (HEAP32[i18 >> 2] | 0) break;
         mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
         __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
        } while (0);
        HEAP32[i13 >> 2] = i2;
        HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
        HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
        do if (!i3) {
         i18 = i1 + 4 | 0;
         HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + -1;
         if (HEAP32[i18 >> 2] | 0) break;
         mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i1 | 0);
         __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 8 | 0);
        } while (0);
        __ZN11SoundHandleD2Ev(i17);
        i1 = HEAP32[i13 >> 2] | 0;
        do if (i1 | 0) {
         if (!(HEAP32[i1 + 16 >> 2] | 0)) break;
         i1 = HEAP32[i13 >> 2] | 0;
         if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
         __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE(i1, HEAP32[i19 >> 2] | 0);
         HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0) + 240 >> 2] = i21;
        } while (0);
        break L99;
       }
      default:
       {
        HEAP32[i11 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
        __Z6FormatPKcz(i18, gb + 864711 | 0, i11);
        if (!i21) i1 = 0; else i1 = HEAP32[i21 + 4 >> 2] | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 855390 | 0, 510, 1, i1, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
       }
      }
     } else {
      __Z6FormatPKcz(i18, gb + 864324 | 0, i8);
      if (!i21) i1 = 0; else i1 = HEAP32[i21 + 4 >> 2] | 0;
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 855390 | 0, 495, 512, i1, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
     }
     i4 = 1;
     break L97;
    } while (0);
    i4 = 0;
   } else i4 = 0; while (0);
   i1 = HEAP32[i20 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    __ZdlPv(i1);
   }
   if (!i4) {
    i1 = HEAP32[i13 >> 2] | 0;
    break;
   } else {
    STACKTOP = i23;
    return;
   }
  } while (0);
  if (!i1) {
   STACKTOP = i23;
   return;
  }
 } while (0);
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE(i1, HEAP32[i21 + 488 >> 2] | 0) | 0;
 __ZN11AudioSource12ApplyFiltersEv(i21);
 __ZN11AudioSource11AssignPropsEv(i21);
 HEAP8[i21 + 532 >> 0] = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance14SetPositionPCMEj(i1, HEAP32[i21 + 528 >> 2] | 0) | 0;
 __ZN12AudioManager14ScheduleSourceEP11AudioSourced(__Z15GetAudioManagerv() | 0, i21, d22);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i24, i20, i10) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i26 + 196 | 0;
 i11 = i26;
 i18 = i26 + 168 | 0;
 i19 = i26 + 140 | 0;
 i9 = i26 + 136 | 0;
 i14 = i26 + 112 | 0;
 i15 = i26 + 56 | 0;
 i13 = i26 + 16 | 0;
 i12 = i26 + 96 | 0;
 i22 = i24 + 20 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 i17 = i24 + 32 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i23 = i24 + 4 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i16) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i24 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i22 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i24 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i24 + 36 | 0;
 if (HEAP8[i21 >> 0] | 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i16) | 0;
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i24, gb + 672885 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i6 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  L25 : do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i4 = i10 + 8 | 0;
    i5 = i10 + 4 | 0;
    i6 = i24 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
     HEAP32[i16 >> 2] = i1;
     do if (!i1) i25 = 26; else if (!(HEAP8[i1 >> 0] | 0)) i25 = 26; else {
      i1 = _strtoull(i1, i16, 10) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) i25 = 26; else {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i11 >> 2] = gb + 763461;
        i27 = i11 + 8 | 0;
        HEAP32[i27 >> 2] = i1;
        HEAP32[i27 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i11);
        HEAP32[i9 >> 2] = 0;
        HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
        break;
       }
       HEAP32[i9 >> 2] = i3;
       i1 = HEAP32[i5 >> 2] | 0;
       if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i3;
        HEAP32[i5 >> 2] = i1 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i9) | 0;
        break;
       }
      }
     } while (0);
     if ((i25 | 0) == 26) {
      i25 = 0;
      HEAP32[i9 >> 2] = 0;
     }
     if (!(HEAP8[i21 >> 0] | 0)) break L25;
     i27 = HEAP32[i22 >> 2] | 0;
    } while (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0) | 0);
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) i4 = 0; else {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 37;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 37) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i4 = HEAP32[i23 >> 2] | 0;
   i2 = i4;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
  }
  i1 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i1;
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i16) | 0;
  HEAP32[i14 >> 2] = 6;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAPF32[i14 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 16 >> 2] = Math_fround(1.0);
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i15 >> 2] = 5;
  HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 28 >> 2] = Math_fround(1.0);
  i1 = i15 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i13 >> 2] = 4;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  HEAP32[i13 + 32 >> 2] = 0;
  HEAP32[i12 >> 2] = 2;
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i24, gb + 673012 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i27 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    if (!(_strcasecmp(i1, gb + 753503 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 0;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753487 | 0) | 0)) {
     i27 = HEAP32[i24 + 28 >> 2] | 0;
     i27 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i27 | 0) | 0;
     i27 = mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, 4, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i27 >> 2] = 1;
     HEAP32[i20 >> 2] = i27;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753469 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i12) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753455 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 3;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672946 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i13) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672967 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i15) | 0;
     break;
    }
    if (_strcasecmp(i1, gb + 672990 | 0) | 0) break;
    HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i14) | 0;
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 80;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 80) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
  }
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i25 = 94;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i22 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i25 | 0) == 94) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i26;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0;
 L1 : while (1) {
  i14 = i2;
  i17 = i2 + -8 | 0;
  i16 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i3 = i14 - i13 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 15;
      break L1;
     }
    case 5:
     {
      i15 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i15 = 83;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 248) {
     i15 = 22;
     break L1;
    }
    i10 = (i4 | 0) / 2 | 0;
    i12 = i1 + (i10 << 3) | 0;
    do if ((i3 | 0) > 7992) {
     i9 = (i4 | 0) / 4 | 0;
     i11 = i1 + (i9 << 3) | 0;
     i6 = i12 + (i9 << 3) | 0;
     i3 = __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i11, i12, i6) | 0;
     f7 = Math_fround(HEAPF32[i16 >> 2]);
     i4 = i6 + 4 | 0;
     if (!(f7 < Math_fround(HEAPF32[i4 >> 2]))) {
      i4 = i1 + (i10 << 3) + 4 | 0;
      break;
     }
     i18 = i6;
     i19 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i21 = i17;
     i20 = HEAP32[i21 + 4 >> 2] | 0;
     i8 = i6;
     HEAP32[i8 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i8 + 4 >> 2] = i20;
     i8 = i17;
     HEAP32[i8 >> 2] = i19;
     HEAP32[i8 + 4 >> 2] = i18;
     i8 = i3 + 1 | 0;
     f7 = Math_fround(HEAPF32[i4 >> 2]);
     i4 = i1 + (i10 << 3) + 4 | 0;
     if (f7 < Math_fround(HEAPF32[i4 >> 2])) {
      i21 = i12;
      i20 = HEAP32[i21 >> 2] | 0;
      i21 = HEAP32[i21 + 4 >> 2] | 0;
      i18 = i6;
      i19 = HEAP32[i18 + 4 >> 2] | 0;
      i8 = i12;
      HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i8 + 4 >> 2] = i19;
      i8 = i6;
      HEAP32[i8 >> 2] = i20;
      HEAP32[i8 + 4 >> 2] = i21;
      i8 = i3 + 2 | 0;
      f7 = Math_fround(HEAPF32[i4 >> 2]);
      i6 = i1 + (i9 << 3) + 4 | 0;
      if (f7 < Math_fround(HEAPF32[i6 >> 2])) {
       i20 = i11;
       i19 = HEAP32[i20 >> 2] | 0;
       i20 = HEAP32[i20 + 4 >> 2] | 0;
       i10 = i12;
       i18 = HEAP32[i10 + 4 >> 2] | 0;
       i21 = i11;
       HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i21 + 4 >> 2] = i18;
       i21 = i12;
       HEAP32[i21 >> 2] = i19;
       HEAP32[i21 + 4 >> 2] = i20;
       f7 = Math_fround(HEAPF32[i6 >> 2]);
       if (f7 < Math_fround(HEAPF32[i1 + 4 >> 2])) {
        i20 = i1;
        i19 = HEAP32[i20 >> 2] | 0;
        i20 = HEAP32[i20 + 4 >> 2] | 0;
        i10 = i11;
        i18 = HEAP32[i10 + 4 >> 2] | 0;
        i21 = i1;
        HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
        HEAP32[i21 + 4 >> 2] = i18;
        i21 = i11;
        HEAP32[i21 >> 2] = i19;
        HEAP32[i21 + 4 >> 2] = i20;
        i3 = i3 + 4 | 0;
       } else i3 = i3 + 3 | 0;
      } else i3 = i8;
     } else i3 = i8;
    } else {
     i4 = i1 + (i10 << 3) + 4 | 0;
     f7 = Math_fround(HEAPF32[i4 >> 2]);
     i3 = i1 + 4 | 0;
     i21 = f7 < Math_fround(HEAPF32[i3 >> 2]);
     i8 = Math_fround(HEAPF32[i16 >> 2]) < f7;
     if (!i21) {
      if (!i8) {
       i3 = 0;
       break;
      }
      i20 = i12;
      i19 = HEAP32[i20 >> 2] | 0;
      i20 = HEAP32[i20 + 4 >> 2] | 0;
      i11 = i17;
      i18 = HEAP32[i11 + 4 >> 2] | 0;
      i21 = i12;
      HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i21 + 4 >> 2] = i18;
      i21 = i17;
      HEAP32[i21 >> 2] = i19;
      HEAP32[i21 + 4 >> 2] = i20;
      f7 = Math_fround(HEAPF32[i4 >> 2]);
      if (!(f7 < Math_fround(HEAPF32[i3 >> 2]))) {
       i3 = 1;
       break;
      }
      i21 = i1;
      i20 = HEAP32[i21 >> 2] | 0;
      i21 = HEAP32[i21 + 4 >> 2] | 0;
      i18 = i12;
      i19 = HEAP32[i18 + 4 >> 2] | 0;
      i3 = i1;
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i3 + 4 >> 2] = i19;
      i3 = i12;
      HEAP32[i3 >> 2] = i20;
      HEAP32[i3 + 4 >> 2] = i21;
      i3 = 2;
      break;
     }
     i6 = i1;
     i3 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     if (i8) {
      i19 = i17;
      i20 = HEAP32[i19 + 4 >> 2] | 0;
      i21 = i1;
      HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i21 + 4 >> 2] = i20;
      i21 = i17;
      HEAP32[i21 >> 2] = i3;
      HEAP32[i21 + 4 >> 2] = i6;
      i3 = 1;
      break;
     }
     i19 = i12;
     i20 = HEAP32[i19 + 4 >> 2] | 0;
     i21 = i1;
     HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i21 + 4 >> 2] = i20;
     i21 = i12;
     HEAP32[i21 >> 2] = i3;
     HEAP32[i21 + 4 >> 2] = i6;
     f7 = Math_fround(HEAPF32[i16 >> 2]);
     if (f7 < (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      i19 = i17;
      i20 = HEAP32[i19 + 4 >> 2] | 0;
      i21 = i12;
      HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i21 + 4 >> 2] = i20;
      i21 = i17;
      HEAP32[i21 >> 2] = i3;
      HEAP32[i21 + 4 >> 2] = i6;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    i8 = i1 + 4 | 0;
    f7 = Math_fround(HEAPF32[i8 >> 2]);
    f5 = Math_fround(HEAPF32[i4 >> 2]);
    if (f7 < f5) {
     i4 = i17;
     break;
    } else i4 = i17;
    while (1) {
     i6 = i4;
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (Math_fround(HEAPF32[i6 + -4 >> 2]) < f5) {
      i15 = 66;
      break L5;
     }
    }
    i1 = i1 + 8 | 0;
    if (!(f7 < Math_fround(HEAPF32[i16 >> 2]))) {
     if ((i1 | 0) == (i17 | 0)) {
      i15 = 83;
      break L1;
     }
     while (1) {
      if (f7 < Math_fround(HEAPF32[i1 + 4 >> 2])) break;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i17 | 0)) {
       i15 = 83;
       break L1;
      }
     }
     i20 = i1;
     i19 = HEAP32[i20 >> 2] | 0;
     i20 = HEAP32[i20 + 4 >> 2] | 0;
     i13 = i17;
     i18 = HEAP32[i13 + 4 >> 2] | 0;
     i21 = i1;
     HEAP32[i21 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i21 + 4 >> 2] = i18;
     i21 = i17;
     HEAP32[i21 >> 2] = i19;
     HEAP32[i21 + 4 >> 2] = i20;
     i1 = i1 + 8 | 0;
    }
    if ((i1 | 0) == (i17 | 0)) {
     i15 = 83;
     break L1;
    } else i3 = i17;
    while (1) {
     f5 = Math_fround(HEAPF32[i8 >> 2]);
     while (1) {
      i4 = i1 + 8 | 0;
      if (f5 < Math_fround(HEAPF32[i1 + 4 >> 2])) break; else i1 = i4;
     }
     do {
      i21 = i3;
      i3 = i3 + -8 | 0;
     } while (f5 < Math_fround(HEAPF32[i21 + -4 >> 2]));
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     i21 = i1;
     i20 = HEAP32[i21 >> 2] | 0;
     i21 = HEAP32[i21 + 4 >> 2] | 0;
     i18 = i3;
     i19 = HEAP32[i18 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i1 + 4 >> 2] = i19;
     i1 = i3;
     HEAP32[i1 >> 2] = i20;
     HEAP32[i1 + 4 >> 2] = i21;
     i1 = i4;
    }
   }
   if ((i15 | 0) == 66) {
    i15 = 0;
    i20 = i1;
    i19 = HEAP32[i20 >> 2] | 0;
    i20 = HEAP32[i20 + 4 >> 2] | 0;
    i11 = i4;
    i18 = HEAP32[i11 + 4 >> 2] | 0;
    i21 = i1;
    HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i21 + 4 >> 2] = i18;
    i21 = i4;
    HEAP32[i21 >> 2] = i19;
    HEAP32[i21 + 4 >> 2] = i20;
    i3 = i3 + 1 | 0;
   }
   i6 = i1 + 8 | 0;
   L50 : do if (i6 >>> 0 < i4 >>> 0) {
    i9 = i12;
    while (1) {
     f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
     while (1) {
      i8 = i6 + 8 | 0;
      if (Math_fround(HEAPF32[i6 + 4 >> 2]) < f5) i6 = i8; else break;
     }
     do {
      i21 = i4;
      i4 = i4 + -8 | 0;
     } while (!(Math_fround(HEAPF32[i21 + -4 >> 2]) < f5));
     if (i6 >>> 0 > i4 >>> 0) {
      i4 = i9;
      break L50;
     }
     i20 = i6;
     i19 = HEAP32[i20 >> 2] | 0;
     i20 = HEAP32[i20 + 4 >> 2] | 0;
     i12 = i4;
     i18 = HEAP32[i12 + 4 >> 2] | 0;
     i21 = i6;
     HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i21 + 4 >> 2] = i18;
     i21 = i4;
     HEAP32[i21 >> 2] = i19;
     HEAP32[i21 + 4 >> 2] = i20;
     i9 = (i9 | 0) == (i6 | 0) ? i4 : i9;
     i6 = i8;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i12; while (0);
   if ((i6 | 0) != (i4 | 0)) {
    f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    if (f7 < Math_fround(HEAPF32[i6 + 4 >> 2])) {
     i20 = i6;
     i19 = HEAP32[i20 >> 2] | 0;
     i20 = HEAP32[i20 + 4 >> 2] | 0;
     i12 = i4;
     i18 = HEAP32[i12 + 4 >> 2] | 0;
     i21 = i6;
     HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i21 + 4 >> 2] = i18;
     i21 = i4;
     HEAP32[i21 >> 2] = i19;
     HEAP32[i21 + 4 >> 2] = i20;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEbT0_S7_T_(i1, i6) | 0;
    i4 = i6 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEbT0_S7_T_(i4, i2) | 0) {
     i15 = 82;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i21 = i6;
   if ((i21 - i13 | 0) >= (i14 - i21 | 0)) {
    i15 = 81;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_(i1, i6);
   i1 = i6 + 8 | 0;
  }
  if ((i15 | 0) == 81) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_(i6 + 8 | 0, i2);
   i2 = i6;
   continue;
  } else if ((i15 | 0) == 82) {
   i15 = 0;
   if (i3) {
    i15 = 83;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  f7 = Math_fround(HEAPF32[i16 >> 2]);
  if (!(f7 < Math_fround(HEAPF32[i1 + 4 >> 2]))) return;
  i20 = i1;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i16 = i17;
  i18 = HEAP32[i16 + 4 >> 2] | 0;
  i21 = i1;
  HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i21 + 4 >> 2] = i18;
  i21 = i17;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  return;
 } else if ((i15 | 0) == 7) {
  i4 = i1 + 8 | 0;
  i2 = i1 + 12 | 0;
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i1 + 4 | 0;
  i21 = f7 < Math_fround(HEAPF32[i3 >> 2]);
  i6 = Math_fround(HEAPF32[i16 >> 2]) < f7;
  if (!i21) {
   if (!i6) return;
   i20 = i4;
   i19 = HEAP32[i20 >> 2] | 0;
   i20 = HEAP32[i20 + 4 >> 2] | 0;
   i16 = i17;
   i18 = HEAP32[i16 + 4 >> 2] | 0;
   i21 = i4;
   HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i21 + 4 >> 2] = i18;
   i21 = i17;
   HEAP32[i21 >> 2] = i19;
   HEAP32[i21 + 4 >> 2] = i20;
   f7 = Math_fround(HEAPF32[i2 >> 2]);
   if (!(f7 < Math_fround(HEAPF32[i3 >> 2]))) return;
   i20 = i1;
   i19 = HEAP32[i20 >> 2] | 0;
   i20 = HEAP32[i20 + 4 >> 2] | 0;
   i17 = i4;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i21 = i1;
   HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i21 + 4 >> 2] = i18;
   i21 = i4;
   HEAP32[i21 >> 2] = i19;
   HEAP32[i21 + 4 >> 2] = i20;
   return;
  }
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (i6) {
   i19 = i17;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i21 = i1;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   i21 = i17;
   HEAP32[i21 >> 2] = i2;
   HEAP32[i21 + 4 >> 2] = i3;
   return;
  }
  i19 = i4;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i1;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
  i21 = i4;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  f7 = Math_fround(HEAPF32[i16 >> 2]);
  if (!(f7 < (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])))) return;
  i19 = i17;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i4;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
  i21 = i17;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  return;
 } else if ((i15 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i17) | 0;
  return;
 } else if ((i15 | 0) == 16) {
  i6 = i1 + 8 | 0;
  i8 = i1 + 16 | 0;
  i4 = i1 + 24 | 0;
  __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i6, i8, i4) | 0;
  f7 = Math_fround(HEAPF32[i16 >> 2]);
  i2 = i1 + 28 | 0;
  if (!(f7 < Math_fround(HEAPF32[i2 >> 2]))) return;
  i20 = i4;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i16 = i17;
  i18 = HEAP32[i16 + 4 >> 2] | 0;
  i21 = i4;
  HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i21 + 4 >> 2] = i18;
  i21 = i17;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f7 < Math_fround(HEAPF32[i1 + 20 >> 2]))) return;
  i20 = i8;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i3 = i4;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i21 = i8;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  i21 = i4;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f5 < Math_fround(HEAPF32[i1 + 12 >> 2]))) return;
  i20 = i6;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i21 = i6;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  i21 = i8;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  if (!(f5 < Math_fround(HEAPF32[i1 + 4 >> 2]))) return;
  i20 = i1;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i21 = i1;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  i21 = i6;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  return;
 } else if ((i15 | 0) == 22) {
  i4 = i1 + 16 | 0;
  i9 = i1 + 8 | 0;
  f22 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  i8 = f7 < f22;
  do if (f22 < f5) {
   i6 = i1;
   i3 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if (i8) {
    i19 = i4;
    i20 = HEAP32[i19 + 4 >> 2] | 0;
    i21 = i1;
    HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i21 + 4 >> 2] = i20;
    i21 = i4;
    HEAP32[i21 >> 2] = i3;
    HEAP32[i21 + 4 >> 2] = i6;
    break;
   }
   i19 = i9;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i21 = i1;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   i21 = i9;
   HEAP32[i21 >> 2] = i3;
   HEAP32[i21 + 4 >> 2] = i6;
   if (f7 < (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i19 = i4;
    i20 = HEAP32[i19 + 4 >> 2] | 0;
    i21 = i9;
    HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i21 + 4 >> 2] = i20;
    i21 = i4;
    HEAP32[i21 >> 2] = i3;
    HEAP32[i21 + 4 >> 2] = i6;
   }
  } else if (i8) {
   i20 = i9;
   i19 = HEAP32[i20 >> 2] | 0;
   i20 = HEAP32[i20 + 4 >> 2] | 0;
   i6 = i4;
   i3 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i21 = i9;
   HEAP32[i21 >> 2] = i3;
   HEAP32[i21 + 4 >> 2] = i6;
   i21 = i4;
   HEAP32[i21 >> 2] = i19;
   HEAP32[i21 + 4 >> 2] = i20;
   if ((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f5) {
    i20 = i1;
    i19 = HEAP32[i20 >> 2] | 0;
    i20 = HEAP32[i20 + 4 >> 2] | 0;
    i21 = i1;
    HEAP32[i21 >> 2] = i3;
    HEAP32[i21 + 4 >> 2] = i6;
    i21 = i9;
    HEAP32[i21 >> 2] = i19;
    HEAP32[i21 + 4 >> 2] = i20;
   }
  } while (0);
  i3 = i1 + 24 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   if (f5 < Math_fround(HEAPF32[i4 + 4 >> 2])) {
    i8 = HEAP32[i3 >> 2] | 0;
    i6 = i3;
    while (1) {
     i19 = i4;
     i20 = HEAP32[i19 + 4 >> 2] | 0;
     i21 = i6;
     HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i21 + 4 >> 2] = i20;
     if ((i4 | 0) == (i1 | 0)) {
      i4 = i1;
      break;
     }
     if (f5 < Math_fround(HEAPF32[i4 + -4 >> 2])) {
      i6 = i4;
      i4 = i4 + -8 | 0;
     } else break;
    }
    HEAP32[i4 >> 2] = i8;
    HEAPF32[i4 + 4 >> 2] = f5;
   }
   i4 = i3 + 8 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i21 = i3;
    i3 = i4;
    i4 = i21;
   }
  }
  return;
 } else if ((i15 | 0) == 83) return;
}

function __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i24, i20, i10) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i26 + 196 | 0;
 i11 = i26;
 i18 = i26 + 168 | 0;
 i19 = i26 + 140 | 0;
 i9 = i26 + 136 | 0;
 i14 = i26 + 112 | 0;
 i15 = i26 + 56 | 0;
 i13 = i26 + 16 | 0;
 i12 = i26 + 96 | 0;
 i22 = i24 + 20 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 i17 = i24 + 32 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i23 = i24 + 4 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i16) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i24 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i22 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i24 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i24 + 36 | 0;
 if (HEAP8[i21 >> 0] | 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i16) | 0;
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i24, gb + 672885 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i6 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  L25 : do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i4 = i10 + 8 | 0;
    i5 = i10 + 4 | 0;
    i6 = i24 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
     HEAP32[i16 >> 2] = i1;
     do if (!i1) i25 = 26; else if (!(HEAP8[i1 >> 0] | 0)) i25 = 26; else {
      i1 = _strtoull(i1, i16, 10) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) i25 = 26; else {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i11 >> 2] = gb + 763461;
        i27 = i11 + 8 | 0;
        HEAP32[i27 >> 2] = i1;
        HEAP32[i27 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i11);
        HEAP32[i9 >> 2] = 0;
        HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
        break;
       }
       HEAP32[i9 >> 2] = i3;
       i1 = HEAP32[i5 >> 2] | 0;
       if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i3;
        HEAP32[i5 >> 2] = i1 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i9) | 0;
        break;
       }
      }
     } while (0);
     if ((i25 | 0) == 26) {
      i25 = 0;
      HEAP32[i9 >> 2] = 0;
     }
     if (!(HEAP8[i21 >> 0] | 0)) break L25;
     i27 = HEAP32[i22 >> 2] | 0;
    } while (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0) | 0);
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) i4 = 0; else {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 37;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 37) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i4 = HEAP32[i23 >> 2] | 0;
   i2 = i4;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
  }
  i1 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i1;
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i16) | 0;
  HEAP32[i14 >> 2] = 6;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAPF32[i14 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 16 >> 2] = Math_fround(1.0);
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i15 >> 2] = 5;
  HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 28 >> 2] = Math_fround(1.0);
  i1 = i15 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i13 >> 2] = 4;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  HEAP32[i13 + 32 >> 2] = 0;
  HEAP32[i12 >> 2] = 2;
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i24, gb + 673012 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i27 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    if (!(_strcasecmp(i1, gb + 753503 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 0;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753487 | 0) | 0)) {
     i27 = HEAP32[i24 + 28 >> 2] | 0;
     i27 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i27 | 0) | 0;
     i27 = mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, 4, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i27 >> 2] = 1;
     HEAP32[i20 >> 2] = i27;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753469 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i12) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753455 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 3;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672946 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i13) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672967 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i15) | 0;
     break;
    }
    if (_strcasecmp(i1, gb + 672990 | 0) | 0) break;
    HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i14) | 0;
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 80;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 80) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
  }
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i25 = 94;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i22 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i25 | 0) == 94) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i26;
 return;
}

function __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i24, i20, i10) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i26 + 196 | 0;
 i11 = i26;
 i18 = i26 + 168 | 0;
 i19 = i26 + 140 | 0;
 i9 = i26 + 136 | 0;
 i14 = i26 + 112 | 0;
 i15 = i26 + 56 | 0;
 i13 = i26 + 16 | 0;
 i12 = i26 + 96 | 0;
 i22 = i24 + 20 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 i17 = i24 + 32 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i23 = i24 + 4 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i16) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i24 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i22 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i24 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i24 + 36 | 0;
 if (HEAP8[i21 >> 0] | 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i16) | 0;
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i24, gb + 672885 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i6 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  L25 : do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i4 = i10 + 8 | 0;
    i5 = i10 + 4 | 0;
    i6 = i24 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
     HEAP32[i16 >> 2] = i1;
     do if (!i1) i25 = 26; else if (!(HEAP8[i1 >> 0] | 0)) i25 = 26; else {
      i1 = _strtoull(i1, i16, 10) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) i25 = 26; else {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i11 >> 2] = gb + 763461;
        i27 = i11 + 8 | 0;
        HEAP32[i27 >> 2] = i1;
        HEAP32[i27 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i11);
        HEAP32[i9 >> 2] = 0;
        HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
        break;
       }
       HEAP32[i9 >> 2] = i3;
       i1 = HEAP32[i5 >> 2] | 0;
       if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i3;
        HEAP32[i5 >> 2] = i1 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i9) | 0;
        break;
       }
      }
     } while (0);
     if ((i25 | 0) == 26) {
      i25 = 0;
      HEAP32[i9 >> 2] = 0;
     }
     if (!(HEAP8[i21 >> 0] | 0)) break L25;
     i27 = HEAP32[i22 >> 2] | 0;
    } while (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0) | 0);
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) i4 = 0; else {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 37;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 37) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i4 = HEAP32[i23 >> 2] | 0;
   i2 = i4;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
  }
  i1 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i1;
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i16) | 0;
  HEAP32[i14 >> 2] = 6;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAPF32[i14 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 16 >> 2] = Math_fround(1.0);
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i15 >> 2] = 5;
  HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 28 >> 2] = Math_fround(1.0);
  i1 = i15 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i13 >> 2] = 4;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  HEAP32[i13 + 32 >> 2] = 0;
  HEAP32[i12 >> 2] = 2;
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i24, gb + 673012 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i27 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    if (!(_strcasecmp(i1, gb + 753503 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 0;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753487 | 0) | 0)) {
     i27 = HEAP32[i24 + 28 >> 2] | 0;
     i27 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i27 | 0) | 0;
     i27 = mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, 4, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i27 >> 2] = 1;
     HEAP32[i20 >> 2] = i27;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753469 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i12) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753455 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 3;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672946 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i13) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672967 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i15) | 0;
     break;
    }
    if (_strcasecmp(i1, gb + 672990 | 0) | 0) break;
    HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i14) | 0;
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 80;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 80) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
  }
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i25 = 94;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i22 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i25 | 0) == 94) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i26;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_(i1, i2, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0;
 i18 = i2;
 L1 : while (1) {
  i13 = i18;
  i17 = i18 + -8 | 0;
  i16 = i18 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i12 = i1;
    i2 = i13 - i12 | 0;
    i3 = i2 >> 3;
    switch (i3 | 0) {
    case 2:
     {
      i14 = 5;
      break L1;
     }
    case 3:
     {
      i14 = 7;
      break L1;
     }
    case 4:
     {
      i14 = 15;
      break L1;
     }
    case 5:
     {
      i14 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i14 = 83;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 248) {
     i14 = 22;
     break L1;
    }
    i9 = (i3 | 0) / 2 | 0;
    i11 = i1 + (i9 << 3) | 0;
    do if ((i2 | 0) > 7992) {
     i8 = (i3 | 0) / 4 | 0;
     i10 = i1 + (i8 << 3) | 0;
     i5 = i11 + (i8 << 3) | 0;
     i2 = __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i10, i11, i5, i15) | 0;
     f6 = Math_fround(HEAPF32[i16 >> 2]);
     i3 = i5 + 4 | 0;
     if (!(f6 > Math_fround(HEAPF32[i3 >> 2]))) {
      i3 = i1 + (i9 << 3) + 4 | 0;
      break;
     }
     i19 = i5;
     i20 = HEAP32[i19 >> 2] | 0;
     i19 = HEAP32[i19 + 4 >> 2] | 0;
     i22 = i17;
     i21 = HEAP32[i22 + 4 >> 2] | 0;
     i7 = i5;
     HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i7 + 4 >> 2] = i21;
     i7 = i17;
     HEAP32[i7 >> 2] = i20;
     HEAP32[i7 + 4 >> 2] = i19;
     i7 = i2 + 1 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     i3 = i1 + (i9 << 3) + 4 | 0;
     if (f6 > Math_fround(HEAPF32[i3 >> 2])) {
      i22 = i11;
      i21 = HEAP32[i22 >> 2] | 0;
      i22 = HEAP32[i22 + 4 >> 2] | 0;
      i19 = i5;
      i20 = HEAP32[i19 + 4 >> 2] | 0;
      i7 = i11;
      HEAP32[i7 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i7 + 4 >> 2] = i20;
      i7 = i5;
      HEAP32[i7 >> 2] = i21;
      HEAP32[i7 + 4 >> 2] = i22;
      i7 = i2 + 2 | 0;
      f6 = Math_fround(HEAPF32[i3 >> 2]);
      i5 = i1 + (i8 << 3) + 4 | 0;
      if (f6 > Math_fround(HEAPF32[i5 >> 2])) {
       i21 = i10;
       i20 = HEAP32[i21 >> 2] | 0;
       i21 = HEAP32[i21 + 4 >> 2] | 0;
       i9 = i11;
       i19 = HEAP32[i9 + 4 >> 2] | 0;
       i22 = i10;
       HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i22 + 4 >> 2] = i19;
       i22 = i11;
       HEAP32[i22 >> 2] = i20;
       HEAP32[i22 + 4 >> 2] = i21;
       f6 = Math_fround(HEAPF32[i5 >> 2]);
       if (f6 > Math_fround(HEAPF32[i1 + 4 >> 2])) {
        i21 = i1;
        i20 = HEAP32[i21 >> 2] | 0;
        i21 = HEAP32[i21 + 4 >> 2] | 0;
        i9 = i10;
        i19 = HEAP32[i9 + 4 >> 2] | 0;
        i22 = i1;
        HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
        HEAP32[i22 + 4 >> 2] = i19;
        i22 = i10;
        HEAP32[i22 >> 2] = i20;
        HEAP32[i22 + 4 >> 2] = i21;
        i2 = i2 + 4 | 0;
       } else i2 = i2 + 3 | 0;
      } else i2 = i7;
     } else i2 = i7;
    } else {
     i3 = i1 + (i9 << 3) + 4 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     i2 = i1 + 4 | 0;
     i22 = f6 > Math_fround(HEAPF32[i2 >> 2]);
     i7 = Math_fround(HEAPF32[i16 >> 2]) > f6;
     if (!i22) {
      if (!i7) {
       i2 = 0;
       break;
      }
      i21 = i11;
      i20 = HEAP32[i21 >> 2] | 0;
      i21 = HEAP32[i21 + 4 >> 2] | 0;
      i10 = i17;
      i19 = HEAP32[i10 + 4 >> 2] | 0;
      i22 = i11;
      HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i22 + 4 >> 2] = i19;
      i22 = i17;
      HEAP32[i22 >> 2] = i20;
      HEAP32[i22 + 4 >> 2] = i21;
      f6 = Math_fround(HEAPF32[i3 >> 2]);
      if (!(f6 > Math_fround(HEAPF32[i2 >> 2]))) {
       i2 = 1;
       break;
      }
      i22 = i1;
      i21 = HEAP32[i22 >> 2] | 0;
      i22 = HEAP32[i22 + 4 >> 2] | 0;
      i19 = i11;
      i20 = HEAP32[i19 + 4 >> 2] | 0;
      i2 = i1;
      HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i2 + 4 >> 2] = i20;
      i2 = i11;
      HEAP32[i2 >> 2] = i21;
      HEAP32[i2 + 4 >> 2] = i22;
      i2 = 2;
      break;
     }
     i5 = i1;
     i2 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     if (i7) {
      i20 = i17;
      i21 = HEAP32[i20 + 4 >> 2] | 0;
      i22 = i1;
      HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i22 + 4 >> 2] = i21;
      i22 = i17;
      HEAP32[i22 >> 2] = i2;
      HEAP32[i22 + 4 >> 2] = i5;
      i2 = 1;
      break;
     }
     i20 = i11;
     i21 = HEAP32[i20 + 4 >> 2] | 0;
     i22 = i1;
     HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i22 + 4 >> 2] = i21;
     i22 = i11;
     HEAP32[i22 >> 2] = i2;
     HEAP32[i22 + 4 >> 2] = i5;
     f6 = Math_fround(HEAPF32[i16 >> 2]);
     if (f6 > (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      i20 = i17;
      i21 = HEAP32[i20 + 4 >> 2] | 0;
      i22 = i11;
      HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i22 + 4 >> 2] = i21;
      i22 = i17;
      HEAP32[i22 >> 2] = i2;
      HEAP32[i22 + 4 >> 2] = i5;
      i2 = 2;
     } else i2 = 1;
    } while (0);
    i7 = i1 + 4 | 0;
    f6 = Math_fround(HEAPF32[i7 >> 2]);
    f4 = Math_fround(HEAPF32[i3 >> 2]);
    if (f6 > f4) {
     i3 = i17;
     break;
    } else i3 = i17;
    while (1) {
     i5 = i3;
     i3 = i3 + -8 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if (Math_fround(HEAPF32[i5 + -4 >> 2]) > f4) {
      i14 = 66;
      break L5;
     }
    }
    i1 = i1 + 8 | 0;
    if (!(f6 > Math_fround(HEAPF32[i16 >> 2]))) {
     if ((i1 | 0) == (i17 | 0)) {
      i14 = 83;
      break L1;
     }
     while (1) {
      if (f6 > Math_fround(HEAPF32[i1 + 4 >> 2])) break;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i17 | 0)) {
       i14 = 83;
       break L1;
      }
     }
     i21 = i1;
     i20 = HEAP32[i21 >> 2] | 0;
     i21 = HEAP32[i21 + 4 >> 2] | 0;
     i12 = i17;
     i19 = HEAP32[i12 + 4 >> 2] | 0;
     i22 = i1;
     HEAP32[i22 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i22 + 4 >> 2] = i19;
     i22 = i17;
     HEAP32[i22 >> 2] = i20;
     HEAP32[i22 + 4 >> 2] = i21;
     i1 = i1 + 8 | 0;
    }
    if ((i1 | 0) == (i17 | 0)) {
     i14 = 83;
     break L1;
    } else i2 = i17;
    while (1) {
     f4 = Math_fround(HEAPF32[i7 >> 2]);
     while (1) {
      i3 = i1 + 8 | 0;
      if (f4 > Math_fround(HEAPF32[i1 + 4 >> 2])) break; else i1 = i3;
     }
     do {
      i22 = i2;
      i2 = i2 + -8 | 0;
     } while (f4 > Math_fround(HEAPF32[i22 + -4 >> 2]));
     if (i1 >>> 0 >= i2 >>> 0) continue L5;
     i22 = i1;
     i21 = HEAP32[i22 >> 2] | 0;
     i22 = HEAP32[i22 + 4 >> 2] | 0;
     i19 = i2;
     i20 = HEAP32[i19 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i1 + 4 >> 2] = i20;
     i1 = i2;
     HEAP32[i1 >> 2] = i21;
     HEAP32[i1 + 4 >> 2] = i22;
     i1 = i3;
    }
   }
   if ((i14 | 0) == 66) {
    i14 = 0;
    i21 = i1;
    i20 = HEAP32[i21 >> 2] | 0;
    i21 = HEAP32[i21 + 4 >> 2] | 0;
    i10 = i3;
    i19 = HEAP32[i10 + 4 >> 2] | 0;
    i22 = i1;
    HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i22 + 4 >> 2] = i19;
    i22 = i3;
    HEAP32[i22 >> 2] = i20;
    HEAP32[i22 + 4 >> 2] = i21;
    i2 = i2 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L50 : do if (i5 >>> 0 < i3 >>> 0) {
    i8 = i11;
    while (1) {
     f4 = Math_fround(HEAPF32[i8 + 4 >> 2]);
     while (1) {
      i7 = i5 + 8 | 0;
      if (Math_fround(HEAPF32[i5 + 4 >> 2]) > f4) i5 = i7; else break;
     }
     do {
      i22 = i3;
      i3 = i3 + -8 | 0;
     } while (!(Math_fround(HEAPF32[i22 + -4 >> 2]) > f4));
     if (i5 >>> 0 > i3 >>> 0) {
      i3 = i8;
      break L50;
     }
     i21 = i5;
     i20 = HEAP32[i21 >> 2] | 0;
     i21 = HEAP32[i21 + 4 >> 2] | 0;
     i11 = i3;
     i19 = HEAP32[i11 + 4 >> 2] | 0;
     i22 = i5;
     HEAP32[i22 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i22 + 4 >> 2] = i19;
     i22 = i3;
     HEAP32[i22 >> 2] = i20;
     HEAP32[i22 + 4 >> 2] = i21;
     i8 = (i8 | 0) == (i5 | 0) ? i3 : i8;
     i5 = i7;
     i2 = i2 + 1 | 0;
    }
   } else i3 = i11; while (0);
   if ((i5 | 0) != (i3 | 0)) {
    f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    if (f6 > Math_fround(HEAPF32[i5 + 4 >> 2])) {
     i21 = i5;
     i20 = HEAP32[i21 >> 2] | 0;
     i21 = HEAP32[i21 + 4 >> 2] | 0;
     i11 = i3;
     i19 = HEAP32[i11 + 4 >> 2] | 0;
     i22 = i5;
     HEAP32[i22 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i22 + 4 >> 2] = i19;
     i22 = i3;
     HEAP32[i22 >> 2] = i20;
     HEAP32[i22 + 4 >> 2] = i21;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11CulledLightS2_EEPS2_EEbT0_S6_T_(i1, i5, i15) | 0;
    i3 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11CulledLightS2_EEPS2_EEbT0_S6_T_(i3, i18, i15) | 0) {
     i14 = 82;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i22 = i5;
   if ((i22 - i12 | 0) >= (i13 - i22 | 0)) {
    i14 = 81;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_(i1, i5, i15);
   i1 = i5 + 8 | 0;
  }
  if ((i14 | 0) == 81) {
   i14 = 0;
   __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_(i5 + 8 | 0, i18, i15);
   i18 = i5;
   continue;
  } else if ((i14 | 0) == 82) {
   i14 = 0;
   if (i2) {
    i14 = 83;
    break;
   } else {
    i18 = i5;
    continue;
   }
  }
 }
 if ((i14 | 0) == 5) {
  f6 = Math_fround(HEAPF32[i16 >> 2]);
  if (!(f6 > Math_fround(HEAPF32[i1 + 4 >> 2]))) return;
  i21 = i1;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i18 = i17;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i22 = i1;
  HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i22 + 4 >> 2] = i19;
  i22 = i17;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  return;
 } else if ((i14 | 0) == 7) {
  i5 = i1 + 8 | 0;
  i2 = i1 + 12 | 0;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i1 + 4 | 0;
  i22 = f6 > Math_fround(HEAPF32[i3 >> 2]);
  i7 = Math_fround(HEAPF32[i16 >> 2]) > f6;
  if (!i22) {
   if (!i7) return;
   i21 = i5;
   i20 = HEAP32[i21 >> 2] | 0;
   i21 = HEAP32[i21 + 4 >> 2] | 0;
   i18 = i17;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i22 = i5;
   HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i22 + 4 >> 2] = i19;
   i22 = i17;
   HEAP32[i22 >> 2] = i20;
   HEAP32[i22 + 4 >> 2] = i21;
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   if (!(f6 > Math_fround(HEAPF32[i3 >> 2]))) return;
   i21 = i1;
   i20 = HEAP32[i21 >> 2] | 0;
   i21 = HEAP32[i21 + 4 >> 2] | 0;
   i18 = i5;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i22 = i1;
   HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i22 + 4 >> 2] = i19;
   i22 = i5;
   HEAP32[i22 >> 2] = i20;
   HEAP32[i22 + 4 >> 2] = i21;
   return;
  }
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (i7) {
   i20 = i17;
   i21 = HEAP32[i20 + 4 >> 2] | 0;
   i22 = i1;
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i22 + 4 >> 2] = i21;
   i22 = i17;
   HEAP32[i22 >> 2] = i2;
   HEAP32[i22 + 4 >> 2] = i3;
   return;
  }
  i20 = i5;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i22 = i1;
  HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i22 + 4 >> 2] = i21;
  i22 = i5;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  f6 = Math_fround(HEAPF32[i16 >> 2]);
  if (!(f6 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])))) return;
  i20 = i17;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i22 = i5;
  HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i22 + 4 >> 2] = i21;
  i22 = i17;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  return;
 } else if ((i14 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i17, i15) | 0;
  return;
 } else if ((i14 | 0) == 16) {
  i7 = i1 + 8 | 0;
  i8 = i1 + 16 | 0;
  i5 = i1 + 24 | 0;
  __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i7, i8, i5, i15) | 0;
  f6 = Math_fround(HEAPF32[i16 >> 2]);
  i2 = i1 + 28 | 0;
  if (!(f6 > Math_fround(HEAPF32[i2 >> 2]))) return;
  i21 = i5;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i18 = i17;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i22 = i5;
  HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i22 + 4 >> 2] = i19;
  i22 = i17;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f6 > Math_fround(HEAPF32[i1 + 20 >> 2]))) return;
  i21 = i8;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = i5;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i22 = i8;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  i22 = i5;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f4 > Math_fround(HEAPF32[i1 + 12 >> 2]))) return;
  i21 = i7;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i22 = i7;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  i22 = i8;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  if (!(f4 > Math_fround(HEAPF32[i1 + 4 >> 2]))) return;
  i21 = i1;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i22 = i1;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  i22 = i7;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  return;
 } else if ((i14 | 0) == 22) {
  i3 = i1 + 16 | 0;
  i8 = i1 + 8 | 0;
  f23 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  i7 = f6 > f23;
  do if (f23 > f4) {
   i5 = i1;
   i2 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (i7) {
    i20 = i3;
    i21 = HEAP32[i20 + 4 >> 2] | 0;
    i22 = i1;
    HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + 4 >> 2] = i21;
    i22 = i3;
    HEAP32[i22 >> 2] = i2;
    HEAP32[i22 + 4 >> 2] = i5;
    break;
   }
   i20 = i8;
   i21 = HEAP32[i20 + 4 >> 2] | 0;
   i22 = i1;
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i22 + 4 >> 2] = i21;
   i22 = i8;
   HEAP32[i22 >> 2] = i2;
   HEAP32[i22 + 4 >> 2] = i5;
   if (f6 > (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i20 = i3;
    i21 = HEAP32[i20 + 4 >> 2] | 0;
    i22 = i8;
    HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + 4 >> 2] = i21;
    i22 = i3;
    HEAP32[i22 >> 2] = i2;
    HEAP32[i22 + 4 >> 2] = i5;
   }
  } else if (i7) {
   i21 = i8;
   i20 = HEAP32[i21 >> 2] | 0;
   i21 = HEAP32[i21 + 4 >> 2] | 0;
   i5 = i3;
   i2 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i22 = i8;
   HEAP32[i22 >> 2] = i2;
   HEAP32[i22 + 4 >> 2] = i5;
   i22 = i3;
   HEAP32[i22 >> 2] = i20;
   HEAP32[i22 + 4 >> 2] = i21;
   if ((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f4) {
    i21 = i1;
    i20 = HEAP32[i21 >> 2] | 0;
    i21 = HEAP32[i21 + 4 >> 2] | 0;
    i22 = i1;
    HEAP32[i22 >> 2] = i2;
    HEAP32[i22 + 4 >> 2] = i5;
    i22 = i8;
    HEAP32[i22 >> 2] = i20;
    HEAP32[i22 + 4 >> 2] = i21;
   }
  } while (0);
  i2 = i1 + 24 | 0;
  if ((i2 | 0) == (i18 | 0)) return;
  while (1) {
   f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   if (f4 > Math_fround(HEAPF32[i3 + 4 >> 2])) {
    i7 = HEAP32[i2 >> 2] | 0;
    i5 = i2;
    while (1) {
     i20 = i3;
     i21 = HEAP32[i20 + 4 >> 2] | 0;
     i22 = i5;
     HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i22 + 4 >> 2] = i21;
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     if (f4 > Math_fround(HEAPF32[i3 + -4 >> 2])) {
      i5 = i3;
      i3 = i3 + -8 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i7;
    HEAPF32[i3 + 4 >> 2] = f4;
   }
   i3 = i2 + 8 | 0;
   if ((i3 | 0) == (i18 | 0)) break; else {
    i22 = i2;
    i2 = i3;
    i3 = i22;
   }
  }
  return;
 } else if ((i14 | 0) == 83) return;
}

function __ZN11UnityEngine9Animation29CreateAnimatorGenericBindingsERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEbRNS6_6memory9AllocatorER8Animator(i32, i25, i43, i30, i17, i31, i1) {
 i32 = i32 | 0;
 i25 = i25 | 0;
 i43 = i43 | 0;
 i30 = i30 | 0;
 i17 = i17 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i42 + 16 | 0;
 i19 = i42;
 i40 = i42 + 72 | 0;
 i41 = i42 + 52 | 0;
 i33 = i42 + 32 | 0;
 i28 = HEAP32[gb + 1466544 >> 2] | 0;
 i35 = gb + 64016 | 0;
 i34 = HEAP32[i35 + 4 >> 2] | 0;
 i29 = i19;
 HEAP32[i29 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i29 + 4 >> 2] = i34;
 HEAP32[i40 >> 2] = 0;
 i29 = i40 + 12 | 0;
 HEAP32[i29 >> 2] = 0;
 i34 = i40 + 16 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i40 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i19);
 i36 = i18;
 i37 = HEAP32[i36 + 4 >> 2] | 0;
 i14 = i35;
 HEAP32[i14 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i14 + 4 >> 2] = i37;
 i14 = gb + 64016 | 0;
 i37 = HEAP32[i14 + 4 >> 2] | 0;
 i36 = i19;
 HEAP32[i36 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i36 + 4 >> 2] = i37;
 HEAP32[i41 >> 2] = 0;
 i36 = i41 + 16 | 0;
 HEAP32[i36 >> 2] = 0;
 i37 = i41 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i19);
 i14 = i18;
 i38 = HEAP32[i14 + 4 >> 2] | 0;
 i39 = i37;
 HEAP32[i39 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i39 + 4 >> 2] = i38;
 i39 = gb + 64016 | 0;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i14 + 4 >> 2] = i38;
 HEAP32[i33 >> 2] = 0;
 i14 = i33 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i38 = i33 + 16 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i33 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i19);
 i27 = i18;
 i1 = HEAP32[i27 + 4 >> 2] | 0;
 i16 = i39;
 HEAP32[i16 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i18 >> 2] = -1;
 __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i25, i18, i40, i43, 1);
 i16 = i32 + 20 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i41 + 12 >> 2] = i1;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  HEAP32[i36 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i37, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i41 >> 2] = i1;
  if (!(HEAP32[i16 >> 2] | 0)) i2 = 0; else {
   i9 = i32 + 24 | 0;
   i10 = i43 + 20 | 0;
   i11 = i10;
   i12 = i43 + 36 | 0;
   i13 = i12;
   i8 = 0;
   i3 = i1;
   i7 = i1;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 3) >> 2] | 0;
    i5 = HEAP32[i29 >> 2] | 0;
    L6 : do if (!i5) i15 = 9; else {
     i6 = HEAP32[i40 >> 2] | 0;
     i2 = 0;
     while (1) {
      if ((HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0) == (i4 | 0)) break;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i5 >>> 0) {
       i15 = 9;
       break L6;
      }
     }
     HEAP32[i3 + (i8 << 2) >> 2] = i2;
     if ((i2 | 0) == -1) i4 = i7; else {
      i2 = HEAP32[i10 >> 2] | 0;
      if (!i2) i4 = i7; else {
       i27 = i2 + i11 + 40 | 0;
       if (!(HEAP32[(HEAP32[i27 >> 2] | 0) + i27 >> 2] | 0)) i4 = i7; else {
        i3 = HEAP32[i7 + (i8 << 2) >> 2] | 0;
        i2 = HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] | 0;
        if ((i2 | 0) == -1) {
         i4 = i7;
         i3 = i7;
        } else if ((HEAP32[(HEAP32[i12 >> 2] | 0) + i13 + (i2 << 2) >> 2] | 0) == -1) {
         i4 = i7;
         i3 = i7;
        } else {
         i7 = HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] | 0;
         i2 = HEAP32[i6 + (i3 * 12 | 0) >> 2] | 0;
         i3 = HEAP32[i14 >> 2] | 0;
         i4 = i3 + 1 | 0;
         i5 = HEAP32[i38 >> 2] | 0;
         i6 = i5 & 2147483647;
         do if (i4 >>> 0 > i6 >>> 0) {
          i1 = i5 << 1;
          i1 = (i1 | 0) == 0 ? 1 : i1;
          if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
           HEAP32[i38 >> 2] = i1;
           HEAP32[i33 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i33 >> 2] | 0, i1 << 3, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
           break;
          } else {
           i27 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
           _memcpy(i27 | 0, HEAP32[i33 >> 2] | 0, HEAP32[i14 >> 2] << 3 | 0) | 0;
           HEAP32[i38 >> 2] = i1;
           HEAP32[i33 >> 2] = i27;
           break;
          }
         } while (0);
         HEAP32[i14 >> 2] = i4;
         i3 = (HEAP32[i33 >> 2] | 0) + (i3 << 3) | 0;
         HEAP32[i3 >> 2] = i7;
         HEAP32[i3 + 4 >> 2] = i2;
         i3 = HEAP32[i41 >> 2] | 0;
         HEAP32[i3 + (i8 << 2) >> 2] = -1;
         i1 = i3;
         i4 = i3;
        }
       }
      }
     }
    } while (0);
    if ((i15 | 0) == 9) {
     i15 = 0;
     HEAP32[i3 + (i8 << 2) >> 2] = -1;
     i4 = i7;
    }
    i8 = i8 + 1 | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    if (i8 >>> 0 >= i2 >>> 0) break; else i7 = i4;
   }
  }
 }
 if (i17) {
  i26 = __ZN11UnityEngine9AnimationL56CalculateTransformBindingSizeBasedOnConstantOptimizationERKNS0_20AnimationSetBindingsERK13dynamic_arrayINS0_14BoundTransformELj4EEPKiPKN7mecanim9animation14AvatarConstantEb(i32, i40, i1, i43, 1) | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 } else {
  i26 = i2;
  i1 = i2;
 }
 i21 = i32 + 36 | 0;
 i20 = i26 - i1 + (HEAP32[HEAP32[(HEAP32[i21 >> 2] | 0) + 20 >> 2] >> 2] | 0) | 0;
 i9 = (i26 | 0) == (HEAP32[i32 + 16 >> 2] | 0) & i17;
 i4 = (i26 | 0) == 0;
 i5 = i26 << 4;
 i8 = i32 + 8 | 0;
 i7 = (HEAP32[i32 >> 2] << 4) + (i4 ? 52 : i5 + 52 | 0) + (HEAP32[i8 >> 2] << 4) | 0;
 i27 = mftCall_iiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i7 | 0, 64) | 0;
 HEAP32[i18 >> 2] = gb + 177508 + 8;
 i6 = i18 + 4 | 0;
 HEAP32[i6 >> 2] = i27;
 HEAP32[i18 + 8 >> 2] = i27;
 HEAP32[i18 + 12 >> 2] = i7;
 i1 = i27;
 i2 = (0 - i1 & 3) + i1 | 0;
 i3 = i2 + 52 | 0;
 i7 = i27 + i7 | 0;
 if (i3 >>> 0 > i7 >>> 0) i27 = 0; else {
  HEAP32[i6 >> 2] = i3;
  i27 = i2;
  i1 = i3;
 }
 HEAP32[i27 + 24 >> 2] = 0;
 HEAP32[i27 >> 2] = i26;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if (i4) i1 = 0; else {
  i1 = (0 - i1 & 3) + i1 | 0;
  i2 = i1 + i5 | 0;
  if (i2 >>> 0 > i7 >>> 0) i1 = 0; else HEAP32[i6 >> 2] = i2;
  i3 = i1 + (i26 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i17 = i27 + 4 | 0;
 HEAP32[i17 >> 2] = i1;
 i13 = i27 + 40 | 0;
 HEAP32[i13 >> 2] = -1;
 i14 = i27 + 44 | 0;
 HEAP32[i14 >> 2] = -1;
 i15 = i27 + 48 | 0;
 HEAP32[i15 >> 2] = -1;
 i2 = HEAP32[i32 >> 2] | 0;
 i24 = i27 + 8 | 0;
 HEAP32[i24 >> 2] = i2;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i2 << 4 | 0, 4) | 0;
  i3 = i1 + (i2 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i22 = i27 + 12 | 0;
 HEAP32[i22 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i23 = i27 + 16 | 0;
 HEAP32[i23 >> 2] = i2;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i2 << 4 | 0, 4) | 0;
  i3 = i1 + (i2 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i16 = i27 + 20 | 0;
 HEAP32[i16 >> 2] = i1;
 HEAP8[i27 + 36 >> 0] = i9 & 1;
 i8 = HEAP32[i27 >> 2] | 0;
 L52 : do if (!i8) i1 = 0; else {
  i9 = HEAP32[i41 >> 2] | 0;
  i10 = HEAP32[i32 + 24 >> 2] | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i40 >> 2] | 0;
  i1 = 0;
  i6 = 0;
  i7 = 0;
  i3 = 0;
  i4 = 0;
  while (1) {
   i2 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
   i5 = HEAP32[i10 + (i7 << 3) + 4 >> 2] | 0;
   HEAP32[i11 + (i7 << 4) + 4 >> 2] = i5;
   if ((i2 | 0) == -1) {
    HEAP32[i11 + (i7 << 4) + 12 >> 2] = 0;
    i2 = 0;
   } else {
    i2 = HEAP32[i12 + (i2 * 12 | 0) + 4 >> 2] | 0;
    HEAP32[i11 + (i7 << 4) + 12 >> 2] = i2;
    i1 = ((i5 | 0) == 3 ? 11 : 3) | i1;
    i2 = (i2 | 0) == (i25 | 0);
   }
   switch (i5 | 0) {
   case 1:
    {
     if (i2) HEAP32[i13 >> 2] = i4;
     i2 = i6;
     i4 = i4 + 1 | 0;
     break;
    }
   case 4:
   case 2:
    {
     if (i2) HEAP32[i14 >> 2] = i6;
     i2 = i6 + 1 | 0;
     break;
    }
   case 3:
    {
     if (i2) HEAP32[i15 >> 2] = i3;
     i2 = i6;
     i3 = i3 + 1 | 0;
     break;
    }
   default:
    i2 = i6;
   }
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i8 | 0)) break L52; else i6 = i2;
  }
 } while (0);
 HEAP32[i27 + 28 >> 2] = i1;
 if (HEAP32[i24 >> 2] | 0) {
  i7 = i32 + 4 | 0;
  i8 = i28 + 80 | 0;
  i6 = 0;
  do {
   i5 = HEAP32[i22 >> 2] | 0;
   i9 = i5 + (i6 << 4) + 12 | 0;
   HEAP32[i9 >> 2] = 0;
   i10 = i5 + (i6 << 4) + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   i11 = HEAP32[i7 >> 2] | 0;
   i12 = HEAP32[i11 + (i6 << 4) >> 2] | 0;
   i2 = HEAP32[i29 >> 2] | 0;
   L79 : do if (i2 | 0) {
    i3 = HEAP32[i40 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) == (i12 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break L79;
    }
    if ((i1 | 0) != -1) {
     i4 = i11 + (i6 << 4) | 0;
     i2 = HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i1 = i5 + (i6 << 4) | 0;
     if (HEAP8[i11 + (i6 << 4) + 14 >> 0] | 0) {
      __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i28, i4, i2, i1) | 0;
      break;
     }
     switch (HEAP16[i11 + (i6 << 4) + 12 >> 1] | 0) {
     case 95:
      break L79;
     case 1:
      {
       if ((i12 | 0) == 0 ? 1 : (HEAP32[i11 + (i6 << 4) + 4 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) break L79;
       HEAP32[i1 >> 2] = 0;
       HEAP32[i10 >> 2] = 7;
       HEAP32[i9 >> 2] = HEAP32[i2 + 28 >> 2];
       break L79;
      }
     case 114:
      {
       __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i28, i4, i2, i1) | 0;
       break L79;
      }
     default:
      {
       __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i28, i4, i2, i1) | 0;
       break L79;
      }
     }
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i23 >> 2] | 0) {
  i7 = i32 + 12 | 0;
  i6 = 0;
  do {
   i5 = HEAP32[i16 >> 2] | 0;
   HEAP32[i5 + (i6 << 4) + 12 >> 2] = 0;
   HEAP32[i5 + (i6 << 4) + 4 >> 2] = 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i8 + (i6 << 4) >> 2] | 0;
   i3 = HEAP32[i29 >> 2] | 0;
   L100 : do if (i3 | 0) {
    i4 = HEAP32[i40 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i4 + (i1 * 12 | 0) >> 2] | 0) == (i2 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i3 >>> 0) break L100;
    }
    if ((i1 | 0) != -1) {
     i3 = i8 + (i6 << 4) | 0;
     i2 = HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i1 = i5 + (i6 << 4) | 0;
     if (HEAP8[i8 + (i6 << 4) + 14 >> 0] | 0) {
      __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i28, i3, i2, i1) | 0;
      break;
     }
     if ((HEAP16[i8 + (i6 << 4) + 12 >> 1] | 0) == 114) __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i28, i3, i2, i1) | 0;
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i23 >> 2] | 0) >>> 0);
 }
 i11 = HEAP32[i21 >> 2] | 0;
 i11 = __ZN11UnityEngine9Animation31CreateControllerBindingConstantEPKN7mecanim9animation18ControllerConstantEPKNS2_12AnimationSetEPNS1_18ValueArrayConstantEjPKNS2_14AvatarConstantERNS1_6memory9AllocatorE(i30, i11, HEAP32[i11 + 20 >> 2] | 0, i20, i43, i31) | 0;
 HEAP32[i27 + 32 >> 2] = i11;
 i9 = HEAP32[i41 >> 2] | 0;
 i10 = HEAP32[i40 >> 2] | 0;
 i11 = HEAP32[i11 + 8 >> 2] | 0;
 if ((i26 | 0) > 0 & (i11 | 0) != 0) {
  i6 = HEAP32[i32 + 24 >> 2] | 0;
  i2 = -1;
  i3 = -1;
  i5 = 0;
  i1 = -1;
  while (1) {
   i7 = HEAP32[i6 + (i5 << 3) + 4 >> 2] | 0;
   i8 = (i7 | 0) == 3;
   L117 : do if (i8) {
    i4 = i2;
    i3 = i3 + 1 | 0;
   } else switch (i7 | 0) {
   case 2:
   case 4:
    {
     i1 = i1 + 1 | 0;
     i4 = i2;
     break L117;
    }
   case 1:
    {
     i4 = i2 + 1 | 0;
     break L117;
    }
   default:
    {
     i4 = i2;
     break L117;
    }
   } while (0);
   i2 = HEAP32[i9 + (i5 << 2) >> 2] | 0;
   L124 : do if ((i2 | 0) != -1) {
    i2 = HEAP32[i10 + (i2 * 12 | 0) + 8 >> 2] | 0;
    if ((i2 | 0) != -1) {
     if (i8) {
      HEAP32[i11 + (i2 * 12 | 0) + 8 >> 2] = i3;
      break;
     }
     switch (i7 | 0) {
     case 2:
     case 4:
      {
       HEAP32[i11 + (i2 * 12 | 0) + 4 >> 2] = i1;
       break L124;
      }
     case 1:
      {
       HEAP32[i11 + (i2 * 12 | 0) >> 2] = i4;
       break L124;
      }
     default:
      break L124;
     }
    }
   } while (0);
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i26 | 0)) break; else i2 = i4;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i27 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = i2 + (i1 << 4) + 12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) if (!(__ZNK6Object8HasEventEPFvPvS0_iEPKv(i5, fb + 913 | 0, i27) | 0)) __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i4 >> 2] | 0, fb + 913 | 0, i27);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = HEAP32[i22 >> 2] | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i3 = i5 + (i1 << 4) + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) if (!(__ZNK6Object8HasEventEPFvPvS0_iEPKv(i4, fb + 913 | 0, i27) | 0)) __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i3 >> 2] | 0, fb + 913 | 0, i27);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i5 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i3 = i5 + (i1 << 4) + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) if (!(__ZNK6Object8HasEventEPFvPvS0_iEPKv(i4, fb + 913 | 0, i27) | 0)) __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i3 >> 2] | 0, fb + 913 | 0, i27);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN11UnityEngine9AnimationL23InitializeDefaultValuesERKNS0_30AnimatorGenericBindingConstantEPKN7mecanim9animation14AvatarConstantEb(i27, i43, 1);
 if ((HEAP32[i38 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i39);
  HEAP32[i33 >> 2] = 0;
 }
 if ((HEAP32[i36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i37);
  HEAP32[i41 >> 2] = 0;
 }
 if ((HEAP32[i34 >> 2] | 0) <= -1) {
  STACKTOP = i42;
  return i27 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i40 >> 2] | 0, i35);
 HEAP32[i40 >> 2] = 0;
 STACKTOP = i42;
 return i27 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0;
 i14 = i2;
 L1 : while (1) {
  i10 = i14;
  i13 = i14 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i2 = i10 - i9 | 0;
    i4 = i2 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i11 = 5;
      break L1;
     }
    case 3:
     {
      i11 = 7;
      break L1;
     }
    case 4:
     {
      i11 = 15;
      break L1;
     }
    case 5:
     {
      i11 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i11 = 84;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 248) {
     i11 = 22;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    do if ((i2 | 0) > 7992) {
     i4 = (i4 | 0) / 4 | 0;
     i6 = i1 + (i4 << 3) | 0;
     i4 = i8 + (i4 << 3) | 0;
     i2 = __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i6, i8, i4, i12) | 0;
     f7 = Math_fround(HEAPF32[i13 >> 2]);
     if (!(f7 < Math_fround(HEAPF32[i4 >> 2]))) {
      i4 = i8;
      break;
     }
     i15 = i4;
     i16 = HEAP32[i15 >> 2] | 0;
     i15 = HEAP32[i15 + 4 >> 2] | 0;
     i18 = i13;
     i17 = HEAP32[i18 + 4 >> 2] | 0;
     i5 = i4;
     HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i5 + 4 >> 2] = i17;
     i5 = i13;
     HEAP32[i5 >> 2] = i16;
     HEAP32[i5 + 4 >> 2] = i15;
     i5 = i2 + 1 | 0;
     f7 = Math_fround(HEAPF32[i4 >> 2]);
     if (f7 < Math_fround(HEAPF32[i8 >> 2])) {
      i18 = i8;
      i17 = HEAP32[i18 >> 2] | 0;
      i18 = HEAP32[i18 + 4 >> 2] | 0;
      i5 = i4;
      i15 = HEAP32[i5 + 4 >> 2] | 0;
      i16 = i8;
      HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i16 + 4 >> 2] = i15;
      HEAP32[i4 >> 2] = i17;
      HEAP32[i4 + 4 >> 2] = i18;
      i4 = i2 + 2 | 0;
      f7 = Math_fround(HEAPF32[i8 >> 2]);
      if (f7 < Math_fround(HEAPF32[i6 >> 2])) {
       i17 = i6;
       i16 = HEAP32[i17 >> 2] | 0;
       i17 = HEAP32[i17 + 4 >> 2] | 0;
       i5 = i8;
       i15 = HEAP32[i5 + 4 >> 2] | 0;
       i18 = i6;
       HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i18 + 4 >> 2] = i15;
       i18 = i8;
       HEAP32[i18 >> 2] = i16;
       HEAP32[i18 + 4 >> 2] = i17;
       f7 = Math_fround(HEAPF32[i6 >> 2]);
       if (f7 < Math_fround(HEAPF32[i1 >> 2])) {
        i18 = i1;
        i17 = HEAP32[i18 >> 2] | 0;
        i18 = HEAP32[i18 + 4 >> 2] | 0;
        i15 = i6;
        i16 = HEAP32[i15 + 4 >> 2] | 0;
        i4 = i1;
        HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
        HEAP32[i4 + 4 >> 2] = i16;
        i4 = i6;
        HEAP32[i4 >> 2] = i17;
        HEAP32[i4 + 4 >> 2] = i18;
        i2 = i2 + 4 | 0;
        i4 = i8;
       } else {
        i2 = i2 + 3 | 0;
        i4 = i8;
       }
      } else {
       i2 = i4;
       i4 = i8;
      }
     } else {
      i2 = i5;
      i4 = i8;
     }
    } else {
     f7 = Math_fround(HEAPF32[i8 >> 2]);
     i18 = f7 < Math_fround(HEAPF32[i1 >> 2]);
     i2 = Math_fround(HEAPF32[i13 >> 2]) < f7;
     if (!i18) {
      if (!i2) {
       i2 = 0;
       i4 = i8;
       break;
      }
      i17 = i8;
      i16 = HEAP32[i17 >> 2] | 0;
      i17 = HEAP32[i17 + 4 >> 2] | 0;
      i6 = i13;
      i15 = HEAP32[i6 + 4 >> 2] | 0;
      i18 = i8;
      HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i18 + 4 >> 2] = i15;
      i18 = i13;
      HEAP32[i18 >> 2] = i16;
      HEAP32[i18 + 4 >> 2] = i17;
      f7 = Math_fround(HEAPF32[i8 >> 2]);
      if (!(f7 < Math_fround(HEAPF32[i1 >> 2]))) {
       i2 = 1;
       i4 = i8;
       break;
      }
      i4 = i1;
      i18 = HEAP32[i4 >> 2] | 0;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
      i16 = i8;
      i17 = HEAP32[i16 + 4 >> 2] | 0;
      i2 = i1;
      HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i2 + 4 >> 2] = i17;
      i2 = i8;
      HEAP32[i2 >> 2] = i18;
      HEAP32[i2 + 4 >> 2] = i4;
      i2 = 2;
      i4 = i8;
      break;
     }
     i5 = i1;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     if (i2) {
      i17 = i13;
      i18 = HEAP32[i17 + 4 >> 2] | 0;
      i2 = i1;
      HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i2 + 4 >> 2] = i18;
      i2 = i13;
      HEAP32[i2 >> 2] = i4;
      HEAP32[i2 + 4 >> 2] = i5;
      i2 = 1;
      i4 = i8;
      break;
     }
     i16 = i8;
     i17 = HEAP32[i16 + 4 >> 2] | 0;
     i18 = i1;
     HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i18 + 4 >> 2] = i17;
     i18 = i8;
     HEAP32[i18 >> 2] = i4;
     HEAP32[i18 + 4 >> 2] = i5;
     f7 = Math_fround(HEAPF32[i13 >> 2]);
     if (f7 < (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      i17 = i13;
      i18 = HEAP32[i17 + 4 >> 2] | 0;
      i2 = i8;
      HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i2 + 4 >> 2] = i18;
      i2 = i13;
      HEAP32[i2 >> 2] = i4;
      HEAP32[i2 + 4 >> 2] = i5;
      i2 = 2;
      i4 = i8;
     } else {
      i2 = 1;
      i4 = i8;
     }
    } while (0);
    f7 = Math_fround(HEAPF32[i1 >> 2]);
    f3 = Math_fround(HEAPF32[i4 >> 2]);
    if (f7 < f3) {
     i4 = i13;
     break;
    } else i4 = i13;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (Math_fround(HEAPF32[i4 >> 2]) < f3) {
      i11 = 67;
      break L5;
     }
    }
    i2 = i1 + 8 | 0;
    if (!(f7 < Math_fround(HEAPF32[i13 >> 2]))) {
     if ((i2 | 0) == (i13 | 0)) {
      i11 = 84;
      break L1;
     }
     while (1) {
      if (f7 < Math_fround(HEAPF32[i2 >> 2])) break;
      i2 = i2 + 8 | 0;
      if ((i2 | 0) == (i13 | 0)) {
       i11 = 84;
       break L1;
      }
     }
     i17 = i2;
     i16 = HEAP32[i17 >> 2] | 0;
     i17 = HEAP32[i17 + 4 >> 2] | 0;
     i9 = i13;
     i15 = HEAP32[i9 + 4 >> 2] | 0;
     i18 = i2;
     HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i18 + 4 >> 2] = i15;
     i18 = i13;
     HEAP32[i18 >> 2] = i16;
     HEAP32[i18 + 4 >> 2] = i17;
     i2 = i2 + 8 | 0;
    }
    if ((i2 | 0) == (i13 | 0)) {
     i11 = 84;
     break L1;
    } else i4 = i13;
    while (1) {
     f3 = Math_fround(HEAPF32[i1 >> 2]);
     while (1) {
      i5 = i2 + 8 | 0;
      if (f3 < Math_fround(HEAPF32[i2 >> 2])) break; else i2 = i5;
     }
     do i4 = i4 + -8 | 0; while (f3 < Math_fround(HEAPF32[i4 >> 2]));
     if (i2 >>> 0 >= i4 >>> 0) {
      i1 = i2;
      continue L5;
     }
     i18 = i2;
     i17 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i15 = i4;
     i16 = HEAP32[i15 + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i2 + 4 >> 2] = i16;
     i2 = i4;
     HEAP32[i2 >> 2] = i17;
     HEAP32[i2 + 4 >> 2] = i18;
     i2 = i5;
    }
   }
   if ((i11 | 0) == 67) {
    i11 = 0;
    i17 = i1;
    i16 = HEAP32[i17 >> 2] | 0;
    i17 = HEAP32[i17 + 4 >> 2] | 0;
    i6 = i4;
    i15 = HEAP32[i6 + 4 >> 2] | 0;
    i18 = i1;
    HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i18 + 4 >> 2] = i15;
    i18 = i4;
    HEAP32[i18 >> 2] = i16;
    HEAP32[i18 + 4 >> 2] = i17;
    i2 = i2 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L50 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    f3 = Math_fround(HEAPF32[i8 >> 2]);
    while (1) {
     i6 = i5 + 8 | 0;
     if (Math_fround(HEAPF32[i5 >> 2]) < f3) i5 = i6; else break;
    }
    do i4 = i4 + -8 | 0; while (!(Math_fround(HEAPF32[i4 >> 2]) < f3));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i8;
     break L50;
    }
    i17 = i5;
    i16 = HEAP32[i17 >> 2] | 0;
    i17 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i4;
    i15 = HEAP32[i19 + 4 >> 2] | 0;
    i18 = i5;
    HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i18 + 4 >> 2] = i15;
    i18 = i4;
    HEAP32[i18 >> 2] = i16;
    HEAP32[i18 + 4 >> 2] = i17;
    i8 = (i8 | 0) == (i5 | 0) ? i4 : i8;
    i5 = i6;
    i2 = i2 + 1 | 0;
   } else i4 = i8; while (0);
   if ((i5 | 0) != (i4 | 0)) {
    f7 = Math_fround(HEAPF32[i4 >> 2]);
    if (f7 < Math_fround(HEAPF32[i5 >> 2])) {
     i18 = i5;
     i17 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i15 = i4;
     i16 = HEAP32[i15 + 4 >> 2] | 0;
     i19 = i5;
     HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i19 + 4 >> 2] = i16;
     i19 = i4;
     HEAP32[i19 >> 2] = i17;
     HEAP32[i19 + 4 >> 2] = i18;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEbT0_S6_T_(i1, i5, i12) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEbT0_S6_T_(i4, i14, i12) | 0) {
     i11 = 83;
     break;
    }
    if (i2) {
     i1 = i4;
     continue;
    }
   }
   i19 = i5;
   if ((i19 - i9 | 0) >= (i10 - i19 | 0)) {
    i11 = 82;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_(i1, i5, i12);
   i1 = i5 + 8 | 0;
  }
  if ((i11 | 0) == 82) {
   i11 = 0;
   __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_(i5 + 8 | 0, i14, i12);
   i14 = i5;
   continue;
  } else if ((i11 | 0) == 83) {
   i11 = 0;
   if (i2) {
    i11 = 84;
    break;
   } else {
    i14 = i5;
    continue;
   }
  }
 }
 if ((i11 | 0) == 5) {
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f7 < Math_fround(HEAPF32[i1 >> 2]))) return;
  i18 = i1;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i13;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i13;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  return;
 } else if ((i11 | 0) == 7) {
  i2 = i1 + 8 | 0;
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  i19 = f7 < Math_fround(HEAPF32[i1 >> 2]);
  i4 = Math_fround(HEAPF32[i13 >> 2]) < f7;
  if (!i19) {
   if (!i4) return;
   i18 = i2;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   i15 = i13;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i19 = i2;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = i16;
   i19 = i13;
   HEAP32[i19 >> 2] = i17;
   HEAP32[i19 + 4 >> 2] = i18;
   f7 = Math_fround(HEAPF32[i2 >> 2]);
   if (!(f7 < Math_fround(HEAPF32[i1 >> 2]))) return;
   i18 = i1;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   i15 = i2;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i19 = i1;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = i16;
   i19 = i2;
   HEAP32[i19 >> 2] = i17;
   HEAP32[i19 + 4 >> 2] = i18;
   return;
  }
  i6 = i1;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  if (i4) {
   i17 = i13;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i1;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i19 = i13;
   HEAP32[i19 >> 2] = i5;
   HEAP32[i19 + 4 >> 2] = i6;
   return;
  }
  i17 = i2;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = i18;
  i19 = i2;
  HEAP32[i19 >> 2] = i5;
  HEAP32[i19 + 4 >> 2] = i6;
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f7 < (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])))) return;
  i17 = i13;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i19 = i2;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = i18;
  i19 = i13;
  HEAP32[i19 >> 2] = i5;
  HEAP32[i19 + 4 >> 2] = i6;
  return;
 } else if ((i11 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i13, i12) | 0;
  return;
 } else if ((i11 | 0) == 16) {
  i6 = i1 + 8 | 0;
  i8 = i1 + 16 | 0;
  i5 = i1 + 24 | 0;
  __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i1, i6, i8, i5, i12) | 0;
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f7 < Math_fround(HEAPF32[i5 >> 2]))) return;
  i18 = i5;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i13;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i5;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i13;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  if (!(f7 < Math_fround(HEAPF32[i8 >> 2]))) return;
  i18 = i8;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i4 = i5;
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i19 = i8;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i4;
  i19 = i5;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f3 < Math_fround(HEAPF32[i6 >> 2]))) return;
  i18 = i6;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i19 = i6;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i4;
  i19 = i8;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  if (!(f3 < Math_fround(HEAPF32[i1 >> 2]))) return;
  i18 = i1;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i4;
  i19 = i6;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  return;
 } else if ((i11 | 0) == 22) {
  i8 = i1 + 16 | 0;
  i6 = i1 + 8 | 0;
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  i2 = f3 < f20;
  do if (f20 < f7) {
   i5 = i1;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (i2) {
    i17 = i8;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i1;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
    i19 = i8;
    HEAP32[i19 >> 2] = i4;
    HEAP32[i19 + 4 >> 2] = i5;
    f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    break;
   }
   i17 = i6;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i1;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i19 = i6;
   HEAP32[i19 >> 2] = i4;
   HEAP32[i19 + 4 >> 2] = i5;
   f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f3 < f7) {
    i17 = i8;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i6;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
    i19 = i8;
    HEAP32[i19 >> 2] = i4;
    HEAP32[i19 + 4 >> 2] = i5;
    f3 = f7;
   }
  } else if (i2) {
   i17 = i6;
   i18 = HEAP32[i17 >> 2] | 0;
   i17 = HEAP32[i17 + 4 >> 2] | 0;
   i4 = i8;
   i2 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i19 = i6;
   HEAP32[i19 >> 2] = i2;
   HEAP32[i19 + 4 >> 2] = i4;
   i19 = i8;
   HEAP32[i19 >> 2] = i18;
   HEAP32[i19 + 4 >> 2] = i17;
   i19 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f7;
   f3 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i19) {
    i18 = i1;
    i17 = HEAP32[i18 >> 2] | 0;
    i18 = HEAP32[i18 + 4 >> 2] | 0;
    i19 = i1;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i19 + 4 >> 2] = i4;
    i19 = i6;
    HEAP32[i19 >> 2] = i17;
    HEAP32[i19 + 4 >> 2] = i18;
   }
  } while (0);
  i2 = i1 + 24 | 0;
  if ((i2 | 0) == (i14 | 0)) return; else {
   i6 = i2;
   i2 = i8;
  }
  while (1) {
   f7 = Math_fround(HEAPF32[i6 >> 2]);
   if (f7 < f3) {
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    i4 = i6;
    while (1) {
     i17 = i2;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = i4;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     if ((i2 | 0) == (i1 | 0)) {
      i2 = i1;
      break;
     }
     i4 = i2 + -8 | 0;
     if (f7 < Math_fround(HEAPF32[i4 >> 2])) {
      i19 = i2;
      i2 = i4;
      i4 = i19;
     } else break;
    }
    HEAPF32[i2 >> 2] = f7;
    HEAP32[i2 + 4 >> 2] = i5;
   }
   i2 = i6 + 8 | 0;
   if ((i2 | 0) == (i14 | 0)) break;
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   i19 = i6;
   i6 = i2;
   i2 = i19;
  }
  return;
 } else if ((i11 | 0) == 84) return;
}

function __ZN5physx2Sn10parseShapeINS0_17RepXVisitorReaderINS_7PxShapeEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i24, i20, i10) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i26 + 196 | 0;
 i11 = i26;
 i18 = i26 + 168 | 0;
 i19 = i26 + 140 | 0;
 i9 = i26 + 136 | 0;
 i14 = i26 + 112 | 0;
 i15 = i26 + 56 | 0;
 i13 = i26 + 16 | 0;
 i12 = i26 + 96 | 0;
 i22 = i24 + 20 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 i17 = i24 + 32 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i23 = i24 + 4 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i16) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i24 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i22 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i24 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i24 + 36 | 0;
 if (HEAP8[i21 >> 0] | 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i16) | 0;
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i24, gb + 672885 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i6 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  L25 : do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i4 = i10 + 8 | 0;
    i5 = i10 + 4 | 0;
    i6 = i24 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
     HEAP32[i16 >> 2] = i1;
     do if (!i1) i25 = 26; else if (!(HEAP8[i1 >> 0] | 0)) i25 = 26; else {
      i1 = _strtoull(i1, i16, 10) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) i25 = 26; else {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i11 >> 2] = gb + 763461;
        i27 = i11 + 8 | 0;
        HEAP32[i27 >> 2] = i1;
        HEAP32[i27 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i11);
        HEAP32[i9 >> 2] = 0;
        HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
        break;
       }
       HEAP32[i9 >> 2] = i3;
       i1 = HEAP32[i5 >> 2] | 0;
       if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
        HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i3;
        HEAP32[i5 >> 2] = i1 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i9) | 0;
        break;
       }
      }
     } while (0);
     if ((i25 | 0) == 26) {
      i25 = 0;
      HEAP32[i9 >> 2] = 0;
     }
     if (!(HEAP8[i21 >> 0] | 0)) break L25;
     i27 = HEAP32[i22 >> 2] | 0;
    } while (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0) | 0);
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) i4 = 0; else {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 37;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 37) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i4 = HEAP32[i23 >> 2] | 0;
   i2 = i4;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
  }
  i1 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i16 >> 2] = i1;
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i16) | 0;
  HEAP32[i14 >> 2] = 6;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAPF32[i14 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i14 + 16 >> 2] = Math_fround(1.0);
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i15 >> 2] = 5;
  HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 28 >> 2] = Math_fround(1.0);
  i1 = i15 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i13 >> 2] = 4;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  HEAP32[i13 + 32 >> 2] = 0;
  HEAP32[i12 >> 2] = 2;
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i24, gb + 673012 | 0);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
    if (!(HEAP8[i21 >> 0] | 0)) {
     i3 = i2;
     i2 = 0;
    } else {
     i2 = HEAP32[i22 >> 2] | 0;
     i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
     HEAP8[i21 >> 0] = i2;
     i1 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
    i27 = HEAP32[i24 >> 2] | 0;
    HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   }
  }
  do if (HEAP8[i21 >> 0] | 0) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i24, gb + 830924 | 0);
   if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
    HEAP8[i21 >> 0] = i1;
   }
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP8[(HEAP32[i27 + 4 >> 2] | 0) + ((HEAP32[i27 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
   if (i1 << 24 >> 24) {
    i1 = HEAP32[i22 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    if (!(_strcasecmp(i1, gb + 753503 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 0;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753487 | 0) | 0)) {
     i27 = HEAP32[i24 + 28 >> 2] | 0;
     i27 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i27 | 0) | 0;
     i27 = mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, 4, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i27 >> 2] = 1;
     HEAP32[i20 >> 2] = i27;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753469 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i12) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 753455 | 0) | 0)) {
     i27 = i24 + 28 | 0;
     i1 = HEAP32[i27 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
     HEAP32[i1 >> 2] = 3;
     HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i19);
     __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i18);
     i12 = i24 + 8 | 0;
     i13 = HEAP32[i24 >> 2] | 0;
     i14 = HEAP32[i23 >> 2] | 0;
     i15 = HEAP32[i22 >> 2] | 0;
     i19 = HEAP32[i27 >> 2] | 0;
     i27 = HEAP32[i17 >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (!(__ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i16, i13, i14, i15, i1, i19, i27, i18) | 0)) HEAP8[HEAP32[i24 + 40 >> 2] >> 0] = 1;
     HEAP32[i20 >> 2] = i1;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672946 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i13) | 0;
     break;
    }
    if (!(_strcasecmp(i1, gb + 672967 | 0) | 0)) {
     HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i15) | 0;
     break;
    }
    if (_strcasecmp(i1, gb + 672990 | 0) | 0) break;
    HEAP32[i20 >> 2] = __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i24, i14) | 0;
   }
  } while (0);
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (i3 >>> 0 > i5 >>> 0) {
    i1 = i3;
    i2 = i4;
    do {
     if (!i1) {
      i25 = 80;
      break;
     }
     i3 = i1 + -1 | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
      i1 = HEAP32[i22 >> 2] | 0;
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i1 = HEAP32[i24 >> 2] | 0;
      i2 = i1;
      i1 = HEAP32[i1 + 8 >> 2] | 0;
     }
     HEAP32[i2 + 8 >> 2] = i1 + -1;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP8[i21 >> 0] = 1;
     if (!i1) break;
     if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
    } while (i1 >>> 0 > i5 >>> 0);
    if ((i25 | 0) == 80) HEAP8[i21 >> 0] = 1;
    i1 = HEAP32[i23 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
  }
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i25 = 94;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i22 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i24 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i25 | 0) == 94) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i26;
 return;
}

function __ZN6Camera12RenderStereoENS_10RenderFlagE8CullFlagMS_FvR11CullResultsR17ShaderPassContextPK21CameraRenderingParamsS0_PvES9_(i53, i35, i5, i2, i36) {
 i53 = i53 | 0;
 i35 = i35 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i36 = i36 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 3184 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i55 + 3112 | 0;
 i39 = i55 + 2968 | 0;
 i37 = i55 + 2964 | 0;
 i38 = i55 + 2960 | 0;
 i52 = i55 + 2768 | 0;
 i42 = i55 + 2752 | 0;
 i54 = i55;
 i34 = HEAP32[i2 >> 2] | 0;
 i26 = HEAP32[i2 + 4 >> 2] | 0;
 i49 = i53 + 1117 | 0;
 HEAP8[i49 >> 0] = 1;
 i44 = i53 + 36 | 0;
 i28 = i52;
 i29 = i44;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i47 = i53 + 100 | 0;
 i48 = i52 + 64 | 0;
 i28 = i48;
 i29 = i47;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i45 = i53 + 228 | 0;
 i46 = i52 + 128 | 0;
 i28 = i46;
 i29 = i45;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i50 = i53 + 1080 | 0;
 i51 = HEAP32[i50 >> 2] | 0;
 i40 = i53 + 864 | 0;
 HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 i32 = __Z12GetIVRDevicev() | 0;
 if (!i32) {
  STACKTOP = i55;
  return;
 }
 i2 = i53 + 1112 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i33 = HEAP32[i53 + 824 >> 2] | 0;
  i27 = i33 & 1 ^ 1;
  i33 = (i33 >>> 1 & 1) + 1 | 0;
 } else {
  i27 = 0;
  i33 = 1;
 }
 if (__ZNK6Camera16GetStereoEnabledEv(i53) | 0) if (!(HEAP8[i53 + 1083 >> 0] | 0)) i41 = 8; else if (!(HEAP8[i53 + 1084 >> 0] | 0)) i41 = 8; else if ((HEAP32[i53 + 824 >> 2] | 0) == 3) i31 = 1; else i41 = 8; else i41 = 8;
 if ((i41 | 0) == 8) i31 = (HEAP8[i2 >> 0] | 0) != 0;
 mftCall_viii(HEAP32[(HEAP32[i32 >> 2] | 0) + 72 >> 2] | 0, i32 | 0, i53 | 0, i31 | 0);
 __ZN11CullResultsC2Ev(i54);
 __ZN11CullResultsC2Ev(i54 + 1376 | 0);
 if (i31) {
  i29 = i54 + 1072 | 0;
  i2 = i54 + 1008 | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i32 >> 2] | 0) + 100 >> 2] | 0, i32 | 0, i53 | 0, i29 | 0, i2 | 0, i54 + 1004 | 0);
  i28 = i44;
  i30 = i28 + 64 | 0;
  do {
   HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
   i28 = i28 + 4 | 0;
   i29 = i29 + 4 | 0;
  } while ((i28 | 0) < (i30 | 0));
  HEAP8[i50 >> 0] = 0;
  i4 = i53 + 1078 | 0;
  i28 = i47;
  i29 = i2;
  i30 = i28 + 64 | 0;
  do {
   HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
   i28 = i28 + 4 | 0;
   i29 = i29 + 4 | 0;
  } while ((i28 | 0) < (i30 | 0));
  HEAP8[i53 + 1081 >> 0] = 0;
  HEAP8[i4 >> 0] = 1;
  f3 = Math_fround(HEAPF32[i54 + 1016 >> 2]);
  if (!(f3 != Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i54 + 1032 >> 2]) != Math_fround(0.0))) {
   HEAP8[i53 + 1082 >> 0] = 0;
   i28 = i45;
   i29 = i2;
   i30 = i28 + 64 | 0;
   do {
    HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
    i28 = i28 + 4 | 0;
    i29 = i29 + 4 | 0;
   } while ((i28 | 0) < (i30 | 0));
  }
  HEAP32[i43 + 4 >> 2] = 0;
  HEAP32[i43 + 8 >> 2] = -1;
  HEAP32[i43 >> 2] = i53;
  i2 = i43 + 12 | 0;
  HEAP32[i2 >> 2] = i5 | 12;
  HEAP32[i43 + 16 >> 2] = 0;
  HEAP32[i43 + 20 >> 2] = 0;
  if (HEAP8[i53 + 1089 >> 0] | 0) HEAP32[i2 >> 2] = i5 | 14;
  __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i53, i43, i54);
 } else {
  HEAP8[i49 >> 0] = 0;
  if ((i27 | 0) < (i33 | 0)) {
   i7 = i53 + 1083 | 0;
   i8 = i53 + 1078 | 0;
   i9 = i53 + 1084 | 0;
   i10 = i53 + 1081 | 0;
   i11 = i5 | 4;
   i12 = i43 + 4 | 0;
   i13 = i43 + 8 | 0;
   i14 = i43 + 12 | 0;
   i15 = i43 + 16 | 0;
   i16 = i43 + 20 | 0;
   i17 = i53 + 1089 | 0;
   i4 = i5 | 6;
   i5 = i53 + 1082 | 0;
   i2 = i27;
   do {
    if (HEAP8[i7 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i53) | 0) {
     i28 = __Z12GetIVRDevicev() | 0;
     mftCall_viiii(HEAP32[(HEAP32[i28 >> 2] | 0) + 92 >> 2] | 0, i43 | 0, i28 | 0, i53 | 0, i2 | 0);
     i28 = i53 + 296 + (i2 << 6) | 0;
     i29 = i43;
     i30 = i28 + 64 | 0;
     do {
      HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
      i28 = i28 + 4 | 0;
      i29 = i29 + 4 | 0;
     } while ((i28 | 0) < (i30 | 0));
    }
    i28 = i44;
    i29 = i53 + 296 + (i2 << 6) | 0;
    i30 = i28 + 64 | 0;
    do {
     HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
     i28 = i28 + 4 | 0;
     i29 = i29 + 4 | 0;
    } while ((i28 | 0) < (i30 | 0));
    HEAP8[i50 >> 0] = 0;
    HEAP8[i8 >> 0] = 1;
    if (HEAP8[i9 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i53) | 0) {
     i28 = __Z12GetIVRDevicev() | 0;
     mftCall_viiii(HEAP32[(HEAP32[i28 >> 2] | 0) + 96 >> 2] | 0, i43 | 0, i28 | 0, i53 | 0, i2 | 0);
     i28 = i53 + 424 + (i2 << 6) | 0;
     i29 = i43;
     i30 = i28 + 64 | 0;
     do {
      HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
      i28 = i28 + 4 | 0;
      i29 = i29 + 4 | 0;
     } while ((i28 | 0) < (i30 | 0));
    }
    i6 = i53 + 424 + (i2 << 6) | 0;
    i28 = i47;
    i29 = i6;
    i30 = i28 + 64 | 0;
    do {
     HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
     i28 = i28 + 4 | 0;
     i29 = i29 + 4 | 0;
    } while ((i28 | 0) < (i30 | 0));
    HEAP8[i10 >> 0] = 0;
    HEAP8[i8 >> 0] = 1;
    f3 = Math_fround(HEAPF32[i53 + 424 + (i2 << 6) + 8 >> 2]);
    if (!(f3 != Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i53 + 424 + (i2 << 6) + 24 >> 2]) != Math_fround(0.0))) {
     HEAP8[i5 >> 0] = 0;
     i28 = i45;
     i29 = i6;
     i30 = i28 + 64 | 0;
     do {
      HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
      i28 = i28 + 4 | 0;
      i29 = i29 + 4 | 0;
     } while ((i28 | 0) < (i30 | 0));
    }
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = -1;
    HEAP32[i43 >> 2] = i53;
    HEAP32[i14 >> 2] = i11;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    if (HEAP8[i17 >> 0] | 0) HEAP32[i14 >> 2] = i4;
    __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i53, i43, i54 + (i2 * 1376 | 0) | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i33 | 0));
  }
 }
 __ZNK9Transform11GetPositionEv(i43, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i53 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i30 = i53 + 904 | 0;
 f57 = Math_fround(HEAPF32[i43 >> 2]);
 f57 = Math_fround(f57 - Math_fround(HEAPF32[i30 >> 2]));
 f1 = Math_fround(HEAPF32[i43 + 4 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i53 + 908 >> 2]));
 f3 = Math_fround(HEAPF32[i43 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i53 + 912 >> 2]));
 f56 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
 f1 = Math_fround(f1 * f56);
 f3 = Math_fround(f3 * f56);
 HEAPF32[i53 + 892 >> 2] = Math_fround(f57 * f56);
 HEAPF32[i53 + 896 >> 2] = f1;
 HEAPF32[i53 + 900 >> 2] = f3;
 HEAP32[i30 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 if ((i27 | 0) < (i33 | 0)) {
  i13 = i53 + 1083 | 0;
  i14 = i53 + 1078 | 0;
  i15 = i53 + 1084 | 0;
  i16 = i53 + 1081 | 0;
  i25 = i26 & 1;
  i17 = (i25 | i34 | 0) == 0;
  i18 = i53 + 1086 | 0;
  i9 = i53 + 864 | 0;
  i11 = i53 + 868 | 0;
  i12 = i53 + 872 | 0;
  i10 = i53 + 876 | 0;
  i19 = i43 + 8 | 0;
  i20 = i43 + 12 | 0;
  i21 = i43 + 4 | 0;
  i22 = i53 + 1060 | 0;
  i23 = i53 + 1077 | 0;
  i24 = i53 + 1079 | 0;
  i25 = (i25 | 0) == 0;
  i6 = i53 + (i26 >> 1) | 0;
  i7 = i34;
  i8 = i53 + 1082 | 0;
  i5 = i27;
  do {
   mftCall_viiii(HEAP32[(HEAP32[i32 >> 2] | 0) + 76 >> 2] | 0, i32 | 0, i53 | 0, i5 | 0, 0);
   if (HEAP8[i13 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i53) | 0) {
    i28 = __Z12GetIVRDevicev() | 0;
    mftCall_viiii(HEAP32[(HEAP32[i28 >> 2] | 0) + 92 >> 2] | 0, i43 | 0, i28 | 0, i53 | 0, i5 | 0);
    i28 = i53 + 296 + (i5 << 6) | 0;
    i29 = i43;
    i30 = i28 + 64 | 0;
    do {
     HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
     i28 = i28 + 4 | 0;
     i29 = i29 + 4 | 0;
    } while ((i28 | 0) < (i30 | 0));
   }
   i28 = i44;
   i29 = i53 + 296 + (i5 << 6) | 0;
   i30 = i28 + 64 | 0;
   do {
    HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
    i28 = i28 + 4 | 0;
    i29 = i29 + 4 | 0;
   } while ((i28 | 0) < (i30 | 0));
   HEAP8[i50 >> 0] = 0;
   HEAP8[i14 >> 0] = 1;
   if (HEAP8[i15 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i53) | 0) {
    i28 = __Z12GetIVRDevicev() | 0;
    mftCall_viiii(HEAP32[(HEAP32[i28 >> 2] | 0) + 96 >> 2] | 0, i43 | 0, i28 | 0, i53 | 0, i5 | 0);
    i28 = i53 + 424 + (i5 << 6) | 0;
    i29 = i43;
    i30 = i28 + 64 | 0;
    do {
     HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
     i28 = i28 + 4 | 0;
     i29 = i29 + 4 | 0;
    } while ((i28 | 0) < (i30 | 0));
   }
   i2 = i53 + 424 + (i5 << 6) | 0;
   i28 = i47;
   i29 = i2;
   i30 = i28 + 64 | 0;
   do {
    HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
    i28 = i28 + 4 | 0;
    i29 = i29 + 4 | 0;
   } while ((i28 | 0) < (i30 | 0));
   HEAP8[i16 >> 0] = 0;
   HEAP8[i14 >> 0] = 1;
   f57 = Math_fround(HEAPF32[i53 + 424 + (i5 << 6) + 8 >> 2]);
   if (!(f57 != Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i53 + 424 + (i5 << 6) + 24 >> 2]) != Math_fround(0.0))) {
    HEAP8[i8 >> 0] = 0;
    i28 = i45;
    i29 = i2;
    i30 = i28 + 64 | 0;
    do {
     HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
     i28 = i28 + 4 | 0;
     i29 = i29 + 4 | 0;
    } while ((i28 | 0) < (i30 | 0));
   }
   __ZNK6Camera28ExtractCameraRenderingParamsEv(i39, i53);
   i2 = i31 ? 0 : i5;
   if (!i17) {
    if (i25) i4 = i7; else i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + i34 >> 2] | 0;
    mftCall_viiiiii(i4 | 0, i6 | 0, i54 + (i2 * 1376 | 0) | 0, HEAP32[gb + 1166248 >> 2] | 0, i39 | 0, i35 | 0, i36 | 0);
   }
   mftCall_viii(HEAP32[(HEAP32[i32 >> 2] | 0) + 80 >> 2] | 0, i32 | 0, i53 | 0, i5 | 0);
   HEAP32[i40 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i40 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i40 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i40 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   if (HEAP8[i18 >> 0] | 0) {
    __ZL19GetCameraTargetRectRK6Camerab(i43, i53, 1);
    f1 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(HEAPF32[i11 >> 2]);
    f60 = Math_fround(HEAPF32[i12 >> 2]);
    f56 = Math_fround(HEAPF32[i10 >> 2]);
    f61 = Math_fround(HEAPF32[i19 >> 2]);
    f58 = Math_fround(HEAPF32[i20 >> 2]);
    f1 = Math_fround(f1 * f61);
    f60 = Math_fround(f60 * f61);
    f3 = Math_fround(f3 * f58);
    f56 = Math_fround(f56 * f58);
    f59 = Math_fround(HEAPF32[i43 >> 2]);
    f57 = Math_fround(HEAPF32[i21 >> 2]);
    f1 = Math_fround(f1 + f59);
    f3 = Math_fround(f3 + f57);
    f60 = Math_fround(f60 + f1);
    f56 = Math_fround(f56 + f3);
    f61 = Math_fround(f61 + f59);
    f58 = Math_fround(f58 + f57);
    f1 = Math_fround((f60 > f61 ? f61 : f60) - (f1 < f59 ? f59 : f1));
    f3 = Math_fround((f56 > f58 ? f58 : f56) - (f3 < f57 ? f57 : f3));
    i30 = f3 < Math_fround(0.0);
    f3 = i30 ? Math_fround(0.0) : f3;
    if (f3 != Math_fround(0.0)) {
     i30 = f1 < Math_fround(0.0);
     f1 = Math_fround((i30 ? Math_fround(0.0) : f1) / f3);
    } else f1 = Math_fround(1.0);
    HEAPF32[i22 >> 2] = f1;
    HEAP8[i23 >> 0] = 1;
    HEAP8[i24 >> 0] = 1;
    HEAP8[i14 >> 0] = 1;
    HEAP8[i18 >> 0] = 1;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i33 | 0));
 }
 __ZN21IntermediateRenderers5ClearEj(HEAP32[i53 + 1132 >> 2] | 0, 0);
 HEAP32[i39 >> 2] = 0;
 i6 = __Z12GetGfxDevicev() | 0;
 HEAP32[i37 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 368 >> 2] | 0, i6 | 0) | 0;
 i6 = __Z12GetGfxDevicev() | 0;
 HEAP32[i38 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 372 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i43 >> 2] = HEAP32[i38 >> 2];
 __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i53, 0, 1, i37, i43, i39);
 mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 84 >> 2] | 0, i32 | 0, i53 | 0);
 i6 = i53 + 744 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) i2 = 0; else {
  HEAP32[i39 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i41 = 36; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i4 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i43, i2, i39);
    i4 = HEAP32[i43 >> 2] | 0;
    i39 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i4 | 0) == -1 ? i39 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i39 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i41 = 36; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i41 = 38;
   }
  }
  if ((i41 | 0) == 36) i41 = 38;
  if ((i41 | 0) == 38) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 HEAP32[i53 + 1144 >> 2] = i2;
 __ZN6Camera18ApplyRenderTextureEv(i53) | 0;
 __Z19ClearShadowMapCacheP14ShadowMapCache(HEAP32[i53 + 1128 >> 2] | 0);
 HEAP32[i40 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
 i2 = i53 + 1086 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  __ZL19GetCameraTargetRectRK6Camerab(i43, i53, 1);
  f1 = Math_fround(HEAPF32[i53 + 864 >> 2]);
  f3 = Math_fround(HEAPF32[i53 + 868 >> 2]);
  f57 = Math_fround(HEAPF32[i53 + 872 >> 2]);
  f60 = Math_fround(HEAPF32[i53 + 876 >> 2]);
  f56 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f59 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  f1 = Math_fround(f1 * f56);
  f57 = Math_fround(f57 * f56);
  f3 = Math_fround(f3 * f59);
  f60 = Math_fround(f60 * f59);
  f58 = Math_fround(HEAPF32[i43 >> 2]);
  f61 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f1 = Math_fround(f1 + f58);
  f3 = Math_fround(f3 + f61);
  f57 = Math_fround(f57 + f1);
  f60 = Math_fround(f60 + f3);
  f56 = Math_fround(f56 + f58);
  f59 = Math_fround(f59 + f61);
  f1 = Math_fround((f57 > f56 ? f56 : f57) - (f1 < f58 ? f58 : f1));
  f3 = Math_fround((f60 > f59 ? f59 : f60) - (f3 < f61 ? f61 : f3));
  i43 = f3 < Math_fround(0.0);
  f3 = i43 ? Math_fround(0.0) : f3;
  if (f3 != Math_fround(0.0)) {
   i43 = f1 < Math_fround(0.0);
   f1 = Math_fround((i43 ? Math_fround(0.0) : f1) / f3);
  } else f1 = Math_fround(1.0);
  HEAPF32[i53 + 1060 >> 2] = f1;
  HEAP8[i53 + 1077 >> 0] = 1;
  HEAP8[i53 + 1079 >> 0] = 1;
  HEAP8[i53 + 1078 >> 0] = 1;
  HEAP8[i2 >> 0] = 1;
 }
 i28 = i44;
 i29 = i52;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i28 = i47;
 i29 = i48;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i28 = i45;
 i29 = i46;
 i30 = i28 + 64 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP8[i50 >> 0] = i51;
 HEAP8[i53 + 1081 >> 0] = (i51 & 65535) >>> 8;
 HEAP8[i53 + 1082 >> 0] = i51 >>> 16;
 HEAP32[i53 + 1076 >> 2] = 16843009;
 HEAP8[i49 >> 0] = 0;
 __ZN11CullResultsD2Ev(i54 + 1376 | 0);
 __ZN11CullResultsD2Ev(i54);
 STACKTOP = i55;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold20reduceContactsForPCMERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE(i47, i3, i4, i2) {
 i47 = i47 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i50 + 240 | 0;
 i49 = i50;
 HEAP8[i46 >> 0] = 0;
 HEAP8[i46 + 1 >> 0] = 0;
 HEAP8[i46 + 2 >> 0] = 0;
 HEAP8[i46 + 3 >> 0] = 0;
 HEAP8[i46 + 4 >> 0] = 0;
 i48 = i47 + 44 | 0;
 i1 = HEAP32[i48 >> 2] | 0;
 i9 = i49;
 i7 = i1;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i49 + 48 | 0;
 i7 = i1 + 48 | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i49 + 96 | 0;
 i7 = i1 + 96 | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i49 + 144 | 0;
 i7 = i1 + 144 | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i45 = i49 + 192 | 0;
 HEAP32[i45 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i45 = i49 + 208 | 0;
 HEAP32[i45 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i45 = i49 + 224 | 0;
 HEAP32[i45 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i45 = HEAP32[i2 + 12 >> 2] | 0;
 i44 = HEAP32[i49 + 44 >> 2] | 0;
 f42 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = f42 > (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i45 = i7 ? i44 : i45;
 i44 = HEAP32[i49 + 92 >> 2] | 0;
 f42 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f42 > (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i45 = i9 ? i44 : i45;
 i44 = HEAP32[i49 + 140 >> 2] | 0;
 f42 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = f42 > (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(HEAPF32[i49 + 188 >> 2]);
 i45 = (HEAP32[tempDoublePtr >> 2] = i8 ? i44 : i45, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f42;
 i7 = i45 ? 3 : i8 ? 2 : i9 ? 1 : i7 ? 0 : 4;
 HEAP8[i46 + i7 >> 0] = 1;
 i9 = i1;
 i7 = i49 + (i7 * 48 | 0) | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 f41 = Math_fround(HEAPF32[i49 + 16 >> 2]);
 f42 = Math_fround(HEAPF32[i49 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i49 + 24 >> 2]);
 i3 = HEAP32[i48 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f41 = Math_fround(f41 - f10);
 f42 = Math_fround(f42 - f11);
 f5 = Math_fround(f5 - f12);
 f5 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f5 * f5));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i45 = i46 + 1 | 0;
 if (!(HEAP8[i45 >> 0] | 0)) {
  f41 = Math_fround(HEAPF32[i49 + 64 >> 2]);
  f42 = Math_fround(HEAPF32[i49 + 68 >> 2]);
  f41 = Math_fround(f41 - f10);
  f42 = Math_fround(f42 - f11);
  f6 = Math_fround(Math_fround(HEAPF32[i49 + 72 >> 2]) - f12);
  f6 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f6 * f6));
  if (f6 > f5) {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = 1;
  } else i2 = 0;
 } else i2 = 0;
 i44 = i46 + 2 | 0;
 if (!(HEAP8[i44 >> 0] | 0)) {
  f41 = Math_fround(HEAPF32[i49 + 112 >> 2]);
  f42 = Math_fround(HEAPF32[i49 + 116 >> 2]);
  f41 = Math_fround(f41 - f10);
  f42 = Math_fround(f42 - f11);
  f5 = Math_fround(Math_fround(HEAPF32[i49 + 120 >> 2]) - f12);
  f5 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f5 * f5));
  if (f5 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = 2;
  }
 }
 i43 = i46 + 3 | 0;
 if (!(HEAP8[i43 >> 0] | 0)) {
  f41 = Math_fround(HEAPF32[i49 + 160 >> 2]);
  f42 = Math_fround(HEAPF32[i49 + 164 >> 2]);
  f41 = Math_fround(f41 - f10);
  f42 = Math_fround(f42 - f11);
  f5 = Math_fround(Math_fround(HEAPF32[i49 + 168 >> 2]) - f12);
  f5 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f5 * f5));
  if (f5 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = 3;
  }
 }
 i4 = i46 + 4 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  f40 = Math_fround(HEAPF32[i49 + 208 >> 2]);
  f41 = Math_fround(HEAPF32[i49 + 212 >> 2]);
  f40 = Math_fround(f40 - f10);
  f41 = Math_fround(f41 - f11);
  f42 = Math_fround(Math_fround(HEAPF32[i49 + 216 >> 2]) - f12);
  f42 = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41)) + Math_fround(f42 * f42));
  if (f42 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i2 = 4;
 }
 HEAP8[i46 + i2 >> 0] = 1;
 i9 = i3 + 48 | 0;
 i7 = i49 + (i2 * 48 | 0) | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i1 = 0;
 i3 = 0;
 do {
  if (!(HEAP8[i46 + i3 >> 0] | 0)) {
   i9 = HEAP32[i48 >> 2] | 0;
   f37 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 16 >> 2]);
   f38 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 20 >> 2]);
   f39 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 24 >> 2]);
   f42 = Math_fround(HEAPF32[i9 + 16 >> 2]);
   f5 = Math_fround(HEAPF32[i9 + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i9 + 24 >> 2]);
   f37 = Math_fround(f37 - f42);
   f38 = Math_fround(f38 - f5);
   f39 = Math_fround(f39 - f40);
   f41 = Math_fround(HEAPF32[i9 + 64 >> 2]);
   f36 = Math_fround(HEAPF32[i9 + 68 >> 2]);
   f42 = Math_fround(f41 - f42);
   f5 = Math_fround(f36 - f5);
   f40 = Math_fround(Math_fround(HEAPF32[i9 + 72 >> 2]) - f40);
   f36 = Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)) + Math_fround(f40 * f40));
   f41 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f42) + Math_fround(f38 * f5)) + Math_fround(f39 * f40)) / f36);
   i9 = f41 > Math_fround(1.0);
   f41 = i9 ? Math_fround(1.0) : f41;
   i9 = f41 > Math_fround(0.0);
   f41 = i9 ? f41 : Math_fround(0.0);
   i9 = f36 == Math_fround(0.0);
   f41 = i9 ? Math_fround(0.0) : f41;
   f42 = Math_fround(f37 - Math_fround(f42 * f41));
   f5 = Math_fround(f38 - Math_fround(f5 * f41));
   f41 = Math_fround(f39 - Math_fround(f40 * f41));
   f5 = Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)));
   if (f5 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = i3;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 HEAP8[i46 + i2 >> 0] = 1;
 i9 = (HEAP32[i48 >> 2] | 0) + 96 | 0;
 i7 = i49 + (i2 * 48 | 0) | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i1 = 0;
 i3 = 0;
 do {
  if (!(HEAP8[i46 + i3 >> 0] | 0)) {
   i9 = HEAP32[i48 >> 2] | 0;
   f17 = Math_fround(HEAPF32[i9 + 64 >> 2]);
   f18 = Math_fround(HEAPF32[i9 + 68 >> 2]);
   f19 = Math_fround(HEAPF32[i9 + 72 >> 2]);
   f29 = Math_fround(HEAPF32[i9 + 16 >> 2]);
   f30 = Math_fround(HEAPF32[i9 + 20 >> 2]);
   f31 = Math_fround(HEAPF32[i9 + 24 >> 2]);
   f32 = Math_fround(f17 - f29);
   f33 = Math_fround(f18 - f30);
   f34 = Math_fround(f19 - f31);
   f14 = Math_fround(HEAPF32[i9 + 112 >> 2]);
   f15 = Math_fround(HEAPF32[i9 + 116 >> 2]);
   f16 = Math_fround(HEAPF32[i9 + 120 >> 2]);
   f35 = Math_fround(f14 - f29);
   f36 = Math_fround(f15 - f30);
   f37 = Math_fround(f16 - f31);
   f20 = Math_fround(f14 - f17);
   f21 = Math_fround(f15 - f18);
   f22 = Math_fround(f16 - f19);
   f38 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 16 >> 2]);
   f39 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 24 >> 2]);
   f5 = Math_fround(f38 - f29);
   f6 = Math_fround(f39 - f30);
   f10 = Math_fround(f40 - f31);
   f11 = Math_fround(f38 - f17);
   f12 = Math_fround(f39 - f18);
   f13 = Math_fround(f40 - f19);
   f14 = Math_fround(f38 - f14);
   f15 = Math_fround(f39 - f15);
   f16 = Math_fround(f40 - f16);
   f23 = Math_fround(Math_fround(Math_fround(f32 * f5) + Math_fround(f33 * f6)) + Math_fround(f34 * f10));
   f41 = Math_fround(Math_fround(Math_fround(f35 * f5) + Math_fround(f36 * f6)) + Math_fround(f37 * f10));
   f24 = Math_fround(Math_fround(Math_fround(f32 * f11) + Math_fround(f33 * f12)) + Math_fround(f34 * f13));
   f25 = Math_fround(Math_fround(Math_fround(f35 * f11) + Math_fround(f36 * f12)) + Math_fround(f37 * f13));
   f26 = Math_fround(Math_fround(Math_fround(f32 * f14) + Math_fround(f33 * f15)) + Math_fround(f34 * f16));
   f42 = Math_fround(Math_fround(Math_fround(f35 * f14) + Math_fround(f36 * f15)) + Math_fround(f37 * f16));
   f27 = Math_fround(f25 - f24);
   f28 = Math_fround(f26 - f42);
   do if (f23 < Math_fround(0.0) & f41 < Math_fround(0.0)) f5 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f10 * f10)); else {
    if (f24 >= Math_fround(0.0) & f24 >= f25) {
     f5 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
     break;
    }
    if (f42 >= Math_fround(0.0) & f42 >= f26) {
     f5 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
     break;
    }
    f6 = Math_fround(Math_fround(f23 * f25) - Math_fround(f24 * f41));
    if (f23 >= Math_fround(0.0) & f24 < Math_fround(0.0) & f6 < Math_fround(0.0)) {
     f41 = Math_fround(f23 / Math_fround(f23 - f24));
     f42 = Math_fround(f38 - Math_fround(f29 + Math_fround(f32 * f41)));
     f5 = Math_fround(f39 - Math_fround(f30 + Math_fround(f33 * f41)));
     f41 = Math_fround(f40 - Math_fround(f31 + Math_fround(f34 * f41)));
     f5 = Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)));
     break;
    }
    f10 = Math_fround(Math_fround(f24 * f42) - Math_fround(f26 * f25));
    if (f25 >= f24 & f26 >= f42 & f10 < Math_fround(0.0)) {
     f41 = Math_fround(f27 / Math_fround(f27 + f28));
     f42 = Math_fround(f38 - Math_fround(f17 + Math_fround(f20 * f41)));
     f5 = Math_fround(f39 - Math_fround(f18 + Math_fround(f21 * f41)));
     f41 = Math_fround(f40 - Math_fround(f19 + Math_fround(f22 * f41)));
     f5 = Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)));
     break;
    }
    f5 = Math_fround(Math_fround(f26 * f41) - Math_fround(f23 * f42));
    if (f41 >= Math_fround(0.0) & f42 < Math_fround(0.0) & f5 < Math_fround(0.0)) {
     f41 = Math_fround(f41 / Math_fround(f41 - f42));
     f42 = Math_fround(f38 - Math_fround(f29 + Math_fround(f35 * f41)));
     f5 = Math_fround(f39 - Math_fround(f30 + Math_fround(f36 * f41)));
     f41 = Math_fround(f40 - Math_fround(f31 + Math_fround(f37 * f41)));
     f5 = Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)));
     break;
    } else {
     f41 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(f5 + f6)));
     f28 = Math_fround(f5 * f41);
     f41 = Math_fround(f6 * f41);
     f42 = Math_fround(f38 - Math_fround(f29 + Math_fround(Math_fround(f32 * f28) + Math_fround(f35 * f41))));
     f5 = Math_fround(f39 - Math_fround(f30 + Math_fround(Math_fround(f33 * f28) + Math_fround(f36 * f41))));
     f41 = Math_fround(f40 - Math_fround(f31 + Math_fround(Math_fround(f34 * f28) + Math_fround(f37 * f41))));
     f5 = Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f42 * f42) + Math_fround(f5 * f5)));
     break;
    }
   } while (0);
   if (f5 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = i3;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 i1 = i46 + i2 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  HEAP8[i47 + 32 >> 0] = 3;
  STACKTOP = i50;
  return 0;
 }
 HEAP8[i1 >> 0] = 1;
 i9 = (HEAP32[i48 >> 2] | 0) + 144 | 0;
 i7 = i49 + (i2 * 48 | 0) | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 if (!(HEAP8[i46 >> 0] | 0)) i3 = 0; else if (!(HEAP8[i45 >> 0] | 0)) i3 = 1; else if (!(HEAP8[i44 >> 0] | 0)) i3 = 2; else if (!(HEAP8[i43 >> 0] | 0)) i3 = 3; else i3 = (HEAP8[i4 >> 0] | 0) == 0 ? 4 : 0;
 i1 = HEAP32[i48 >> 2] | 0;
 f40 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) >> 2]);
 f41 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 4 >> 2]);
 f42 = Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 8 >> 2]);
 f36 = Math_fround(HEAPF32[i1 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f36 = Math_fround(f36 - f40);
 f38 = Math_fround(f38 - f41);
 f39 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f42);
 f39 = Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f38 * f38)) + Math_fround(f39 * f39));
 i2 = f39 < Math_fround(3402823469999999843913219.0e14);
 f39 = i2 ? f39 : Math_fround(3402823469999999843913219.0e14);
 f38 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f38 = Math_fround(f38 - f40);
 f36 = Math_fround(f36 - f41);
 f37 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) - f42);
 f37 = Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f36 * f36)) + Math_fround(f37 * f37));
 i2 = f39 > f37;
 f39 = i2 ? f37 : f39;
 f37 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f37 = Math_fround(f37 - f40);
 f36 = Math_fround(f36 - f41);
 f38 = Math_fround(Math_fround(HEAPF32[i1 + 104 >> 2]) - f42);
 f38 = Math_fround(Math_fround(Math_fround(f37 * f37) + Math_fround(f36 * f36)) + Math_fround(f38 * f38));
 i48 = f39 > f38;
 f36 = Math_fround(HEAPF32[i1 + 144 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 148 >> 2]);
 f40 = Math_fround(f36 - f40);
 f41 = Math_fround(f37 - f41);
 f42 = Math_fround(Math_fround(HEAPF32[i1 + 152 >> 2]) - f42);
 i47 = (i48 ? f38 : f39) > Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41)) + Math_fround(f42 * f42));
 i2 = i47 ? 3 : i48 ? 2 : i2 & 1;
 f42 = Math_fround(HEAPF32[i1 + (i2 * 48 | 0) + 44 >> 2]);
 if (!(f42 > Math_fround(HEAPF32[i49 + (i3 * 48 | 0) + 44 >> 2]))) {
  STACKTOP = i50;
  return 0;
 }
 i9 = i1 + (i2 * 48 | 0) | 0;
 i7 = i49 + (i3 * 48 | 0) | 0;
 i8 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  i9 = i9 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 STACKTOP = i50;
 return 0;
}

function _UNITY_png_init_read_transformations(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i21;
 i9 = i20 + 680 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i20 + 484 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = (i3 | 0) != 0;
 do if (!i2) if (i4) {
  HEAP32[i9 >> 2] = _UNITY_png_reciprocal(i3) | 0;
  i1 = 0;
  break;
 } else {
  HEAP32[i9 >> 2] = 1e5;
  HEAP32[i10 >> 2] = 1e5;
  i1 = 0;
  break;
 } else {
  if (!i4) {
   HEAP32[i10 >> 2] = _UNITY_png_reciprocal(i2) | 0;
   i1 = 0;
   break;
  }
  if (!(_UNITY_png_muldiv(i1, i2, i3, 1e5) | 0)) i1 = 1; else i1 = (_UNITY_png_gamma_significant(HEAP32[i1 >> 2] | 0) | 0) != 0;
  i1 = i1 & 1;
 } while (0);
 i19 = i20 + 754 | 0;
 HEAP16[i19 >> 1] = HEAPU16[i19 >> 1] | 1;
 i19 = i20 + 212 | 0;
 i17 = HEAP32[i19 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i17 & -8193 : i17 | 8192;
 HEAP32[i19 >> 2] = i1;
 if ((i1 & 262272 | 0) == 262144) {
  HEAP32[i19 >> 2] = i1 & -41943297;
  i17 = i20 + 208 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -8193;
  HEAP16[i20 + 424 >> 1] = 0;
 }
 i17 = (_UNITY_png_gamma_significant(HEAP32[i10 >> 2] | 0) | 0) == 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (i17) {
  i1 = i1 & -8388609;
  HEAP32[i19 >> 2] = i1;
  i17 = i20 + 208 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -8193;
 }
 if (!(i1 & 256)) {
  if ((i1 & 16512 | 0) == 16512) {
   i2 = HEAP16[i20 + 450 >> 1] | 0;
   i3 = HEAP32[i20 + 452 >> 2] | 0;
   if (i2 << 16 >> 16 == (i3 & 65535) << 16 >> 16) if (i2 << 16 >> 16 == (i3 >>> 16 & 65535) << 16 >> 16) {
    i17 = i20 + 204 | 0;
    HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 2048;
    HEAP16[i20 + 456 >> 1] = i2;
   }
  }
 } else if (!(HEAP8[i20 + 431 >> 0] & 2)) {
  i17 = i20 + 204 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 2048;
 }
 i17 = i20 + 431 | 0;
 i3 = HEAP8[i17 >> 0] | 0;
 if (i3 << 24 >> 24 == 3) {
  i7 = HEAP16[i20 + 424 >> 1] | 0;
  i8 = i7 << 16 >> 16 == 0;
  L30 : do if (i8) {
   i2 = 0;
   i18 = 27;
  } else {
   i5 = HEAP32[i20 + 524 >> 2] | 0;
   i6 = i7 & 65535;
   i4 = 0;
   i2 = 0;
   while (1) {
    i3 = HEAP8[i5 + i4 >> 0] | 0;
    if (i3 << 24 >> 24 != -1) if (!(i3 << 24 >> 24)) i2 = 1; else break L30;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (i6 | 0)) {
     i18 = 27;
     break;
    }
   }
  } while (0);
  if ((i18 | 0) == 27) {
   i3 = i1 & -8388609;
   HEAP32[i19 >> 2] = i3;
   i16 = i20 + 208 | 0;
   HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & -8193;
   i1 = i1 & -8388993;
   if (!i2) HEAP32[i19 >> 2] = i1; else i1 = i3;
  }
  if ((i1 & 4352 | 0) == 4352) {
   i16 = HEAPU8[i20 + 448 >> 0] | 0;
   i15 = HEAP32[i20 + 412 >> 2] | 0;
   HEAP16[i20 + 450 >> 1] = HEAPU8[i15 + (i16 * 3 | 0) >> 0] | 0;
   HEAP16[i20 + 452 >> 1] = HEAPU8[i15 + (i16 * 3 | 0) + 1 >> 0] | 0;
   HEAP16[i20 + 454 >> 1] = HEAPU8[i15 + (i16 * 3 | 0) + 2 >> 0] | 0;
   if ((i1 & 34078720 | 0) == 524288) {
    i3 = i7 & 65535;
    if (!i8) {
     i2 = HEAP32[i20 + 524 >> 2] | 0;
     i1 = 0;
     do {
      i16 = i2 + i1 | 0;
      HEAP8[i16 >> 0] = HEAPU8[i16 >> 0] ^ 255;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
     i1 = HEAP32[i19 >> 2] | 0;
    }
   }
  }
 } else {
  if (!(i3 & 4)) {
   i16 = (HEAP16[i20 + 424 >> 1] | 0) == 0;
   i2 = i1 & -8388609;
   HEAP32[i19 >> 2] = i2;
   i15 = i20 + 208 | 0;
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -8193;
   i1 = i1 & -8388993;
   if (i16) HEAP32[i19 >> 2] = i1; else i1 = i2;
  }
  if ((i3 & 2) == 0 & (i1 & 4352 | 0) == 4352) {
   i2 = HEAPU16[i20 + 456 >> 1] | 0;
   i3 = HEAPU16[i20 + 536 >> 1] | 0;
   switch (HEAP8[i20 + 432 >> 0] | 0) {
   case 1:
    {
     i3 = i3 * 255 | 0;
     i2 = i2 * 255 | 0;
     break;
    }
   case 2:
    {
     i3 = i3 * 85 | 0;
     i2 = i2 * 85 | 0;
     break;
    }
   case 4:
    {
     i3 = i3 * 17 | 0;
     i2 = i2 * 17 | 0;
     break;
    }
   default:
    {}
   }
   i16 = i2 & 65535;
   HEAP16[i20 + 454 >> 1] = i16;
   HEAP16[i20 + 452 >> 1] = i16;
   HEAP16[i20 + 450 >> 1] = i16;
   if (!(i1 & 33554432)) {
    i16 = i3 & 65535;
    HEAP16[i20 + 534 >> 1] = i16;
    HEAP16[i20 + 532 >> 1] = i16;
    HEAP16[i20 + 530 >> 1] = i16;
   }
  }
 }
 if ((i1 & 384 | 0) == 128 & (i1 & 67109888 | 0) != 0) if ((HEAP8[i20 + 432 >> 0] | 0) == 16) {
  i15 = i20 + 450 | 0;
  HEAP16[i15 >> 1] = (HEAPU16[i15 >> 1] | 0) * 257;
  i15 = i20 + 452 | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  HEAP16[i15 >> 1] = (i16 & 65535) * 257;
  HEAP16[i20 + 454 >> 1] = (i16 >>> 16) * 257;
  i16 = i20 + 456 | 0;
  HEAP16[i16 >> 1] = (HEAPU16[i16 >> 1] | 0) * 257;
 }
 i16 = i20 + 458 | 0;
 i15 = i20 + 448 | 0;
 HEAP16[i16 >> 1] = HEAP16[i15 >> 1] | 0;
 HEAP16[i16 + 2 >> 1] = HEAP16[i15 + 2 >> 1] | 0;
 HEAP16[i16 + 4 >> 1] = HEAP16[i15 + 4 >> 1] | 0;
 HEAP16[i16 + 6 >> 1] = HEAP16[i15 + 6 >> 1] | 0;
 HEAP16[i16 + 8 >> 1] = HEAP16[i15 + 8 >> 1] | 0;
 do if (!(i1 & 8192)) {
  if (i1 & 6291456) {
   if (_UNITY_png_gamma_significant(HEAP32[i9 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
   if (_UNITY_png_gamma_significant(HEAP32[i10 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
   i1 = HEAP32[i19 >> 2] | 0;
  }
  if (i1 & 128 | 0) {
   if (_UNITY_png_gamma_significant(HEAP32[i9 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
   if (_UNITY_png_gamma_significant(HEAP32[i10 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
   if ((HEAP8[i20 + 442 >> 0] | 0) == 3) if (_UNITY_png_gamma_significant(HEAP32[i20 + 444 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
  }
  i1 = HEAP32[i19 >> 2] | 0;
  if (i1 & 8388608) {
   if (_UNITY_png_gamma_significant(HEAP32[i10 >> 2] | 0) | 0) {
    i18 = 61;
    break;
   }
   i1 = HEAP32[i19 >> 2] | 0;
  }
  if (i1 & 128) if ((HEAP8[i17 >> 0] | 0) == 3) {
   i16 = HEAP16[i20 + 424 >> 1] | 0;
   i8 = i16 & 65535;
   i9 = HEAP32[i20 + 412 >> 2] | 0;
   i2 = HEAP16[i20 + 450 >> 1] | 0;
   i10 = i2 & 255;
   i3 = HEAP32[i20 + 452 >> 2] | 0;
   i11 = i3 & 255;
   i4 = i3 >>> 16;
   i12 = i4 & 255;
   if (i16 << 16 >> 16) {
    i7 = i20 + 524 | 0;
    i6 = i2 & 255;
    i5 = i3 & 255;
    i2 = i4 & 255;
    i1 = 0;
    do {
     i3 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
     switch (i4 << 24 >> 24) {
     case 0:
      {
       HEAP8[i9 + (i1 * 3 | 0) >> 0] = i10;
       HEAP8[i9 + (i1 * 3 | 0) + 1 >> 0] = i11;
       HEAP8[i9 + (i1 * 3 | 0) + 2 >> 0] = i12;
       break;
      }
     case -1:
      break;
     default:
      {
       i16 = i9 + (i1 * 3 | 0) | 0;
       i15 = i4 & 255;
       i15 = (Math_imul(i15 ^ 255, i6) | 0) + 128 + (Math_imul(HEAPU8[i16 >> 0] | 0, i15) | 0) | 0;
       HEAP8[i16 >> 0] = ((i15 >>> 8 & 255) + i15 | 0) >>> 8;
       i16 = i9 + (i1 * 3 | 0) + 1 | 0;
       i15 = HEAPU8[i3 >> 0] | 0;
       i15 = (Math_imul(i15, HEAPU8[i16 >> 0] | 0) | 0) + 128 + (Math_imul(i15 ^ 255, i5) | 0) | 0;
       HEAP8[i16 >> 0] = ((i15 >>> 8 & 255) + i15 | 0) >>> 8;
       i16 = i9 + (i1 * 3 | 0) + 2 | 0;
       i15 = HEAPU8[i3 >> 0] | 0;
       i15 = (Math_imul(i15, HEAPU8[i16 >> 0] | 0) | 0) + 128 + (Math_imul(i15 ^ 255, i2) | 0) | 0;
       HEAP8[i16 >> 0] = ((i15 >>> 8 & 255) + i15 | 0) >>> 8;
      }
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i8 | 0));
    i1 = HEAP32[i19 >> 2] | 0;
   }
   i1 = i1 & -129;
   HEAP32[i19 >> 2] = i1;
  }
 } else i18 = 61; while (0);
 do if ((i18 | 0) == 61) {
  _UNITY_png_build_gamma_table(i20, HEAPU8[i20 + 432 >> 0] | 0);
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = (HEAP8[i17 >> 0] | 0) == 3;
  if (!(i1 & 128)) {
   if (!i2) break;
   i4 = HEAP32[i20 + 412 >> 2] | 0;
   i18 = HEAP16[i20 + 416 >> 1] | 0;
   i5 = i18 & 65535;
   if (i18 << 16 >> 16) {
    i3 = HEAP32[i20 + 488 >> 2] | 0;
    i2 = 0;
    do {
     i18 = i4 + (i2 * 3 | 0) | 0;
     HEAP8[i18 >> 0] = HEAP8[i3 + (HEAPU8[i18 >> 0] | 0) >> 0] | 0;
     i18 = i4 + (i2 * 3 | 0) + 1 | 0;
     HEAP8[i18 >> 0] = HEAP8[i3 + (HEAPU8[i18 >> 0] | 0) >> 0] | 0;
     i18 = i4 + (i2 * 3 | 0) + 2 | 0;
     HEAP8[i18 >> 0] = HEAP8[i3 + (HEAPU8[i18 >> 0] | 0) >> 0] | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i5 | 0));
   }
   i1 = i1 & -8193;
   HEAP32[i19 >> 2] = i1;
   break;
  }
  if (!i2) {
   i8 = i20 + 442 | 0;
   switch (HEAP8[i8 >> 0] | 0) {
   case 1:
    {
     i11 = HEAP32[i10 >> 2] | 0;
     i12 = 1e5;
     break;
    }
   case 2:
    {
     i11 = _UNITY_png_reciprocal(HEAP32[i9 >> 2] | 0) | 0;
     i12 = _UNITY_png_reciprocal2(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
     break;
    }
   case 3:
    {
     i12 = i20 + 444 | 0;
     i11 = _UNITY_png_reciprocal(HEAP32[i12 >> 2] | 0) | 0;
     i12 = _UNITY_png_reciprocal2(HEAP32[i12 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
     break;
    }
   default:
    _UNITY_png_error(i20, gb + 353310 | 0);
   }
   i7 = _UNITY_png_gamma_significant(i11) | 0;
   i1 = _UNITY_png_gamma_significant(i12) | 0;
   i7 = (i7 | 0) != 0;
   if (i7) HEAP16[i20 + 466 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i20 + 456 >> 1] | 0, i11) | 0;
   i1 = (i1 | 0) != 0;
   if (i1) {
    i16 = i20 + 456 | 0;
    HEAP16[i16 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i16 >> 1] | 0, i12) | 0;
   }
   i2 = i20 + 450 | 0;
   i3 = HEAP16[i2 >> 1] | 0;
   i4 = i20 + 452 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i3 << 16 >> 16 == (i5 & 65535) << 16 >> 16) {
    i6 = i20 + 454 | 0;
    if (i3 << 16 >> 16 == (i5 >>> 16 & 65535) << 16 >> 16) if (i3 << 16 >> 16 == (HEAP16[i20 + 456 >> 1] | 0)) {
     i16 = HEAP16[i20 + 466 >> 1] | 0;
     HEAP16[i20 + 464 >> 1] = i16;
     HEAP16[i20 + 462 >> 1] = i16;
     HEAP16[i20 + 460 >> 1] = i16;
     HEAP16[i6 >> 1] = i3;
     HEAP16[i4 >> 1] = i3;
    } else i18 = 94; else i18 = 94;
   } else i18 = 94;
   if ((i18 | 0) == 94) {
    if (i7) {
     HEAP16[i20 + 460 >> 1] = _UNITY_png_gamma_correct(i20, i3 & 65535, i11) | 0;
     HEAP16[i20 + 462 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i4 >> 1] | 0, i11) | 0;
     HEAP16[i20 + 464 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i20 + 454 >> 1] | 0, i11) | 0;
    }
    if (i1) {
     HEAP16[i2 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i2 >> 1] | 0, i12) | 0;
     HEAP16[i4 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i4 >> 1] | 0, i12) | 0;
     i18 = i20 + 454 | 0;
     HEAP16[i18 >> 1] = _UNITY_png_gamma_correct(i20, HEAPU16[i18 >> 1] | 0, i12) | 0;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i1 = HEAP32[i19 >> 2] | 0;
   break;
  }
  i15 = HEAP32[i20 + 412 >> 2] | 0;
  i7 = HEAP16[i20 + 416 >> 1] | 0;
  i16 = i7 & 65535;
  switch (HEAP8[i20 + 442 >> 0] | 0) {
  case 2:
   {
    i4 = HEAPU16[i20 + 450 >> 1] | 0;
    i14 = HEAP32[i20 + 488 >> 2] | 0;
    i2 = HEAP32[i20 + 452 >> 2] | 0;
    i6 = i2 & 65535;
    i2 = i2 >>> 16;
    i3 = HEAP32[i20 + 500 >> 2] | 0;
    i1 = HEAP8[i3 + i4 >> 0] | 0;
    i4 = HEAP8[i14 + i4 >> 0] | 0;
    i5 = HEAP8[i3 + i2 >> 0] | 0;
    i3 = HEAP8[i3 + i6 >> 0] | 0;
    i6 = HEAP8[i14 + i6 >> 0] | 0;
    i2 = HEAP8[i14 + i2 >> 0] | 0;
    break;
   }
  case 1:
   {
    i5 = HEAP32[i10 >> 2] | 0;
    i2 = 1e5;
    i18 = 67;
    break;
   }
  case 3:
   {
    i2 = i20 + 444 | 0;
    i5 = _UNITY_png_reciprocal(HEAP32[i2 >> 2] | 0) | 0;
    i2 = _UNITY_png_reciprocal2(HEAP32[i2 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
    i18 = 67;
    break;
   }
  default:
   {
    i5 = 1e5;
    i2 = 1e5;
    i18 = 67;
   }
  }
  do if ((i18 | 0) == 67) {
   i14 = (_UNITY_png_gamma_significant(i2) | 0) == 0;
   i3 = i20 + 450 | 0;
   i1 = HEAP16[i3 >> 1] | 0;
   if (i14) {
    i2 = HEAP32[i20 + 452 >> 2] | 0;
    i4 = i1 & 255;
    i6 = i2 & 255;
    i2 = i2 >>> 16 & 255;
   } else {
    i4 = _UNITY_png_gamma_8bit_correct(i1 & 65535, i2) | 0;
    i6 = _UNITY_png_gamma_8bit_correct(HEAPU16[i20 + 452 >> 1] | 0, i2) | 0;
    i2 = _UNITY_png_gamma_8bit_correct(HEAPU16[i20 + 454 >> 1] | 0, i2) | 0;
   }
   i14 = (_UNITY_png_gamma_significant(i5) | 0) == 0;
   i1 = HEAP16[i3 >> 1] | 0;
   if (i14) {
    i3 = HEAP32[i20 + 452 >> 2] | 0;
    i1 = i1 & 255;
    i5 = i3 >>> 16 & 255;
    i3 = i3 & 255;
    break;
   } else {
    i1 = _UNITY_png_gamma_8bit_correct(i1 & 65535, i5) | 0;
    i3 = _UNITY_png_gamma_8bit_correct(HEAPU16[i20 + 452 >> 1] | 0, i5) | 0;
    i5 = _UNITY_png_gamma_8bit_correct(HEAPU16[i20 + 454 >> 1] | 0, i5) | 0;
    break;
   }
  } while (0);
  if (i7 << 16 >> 16) {
   i12 = i20 + 424 | 0;
   i13 = i20 + 524 | 0;
   i14 = i20 + 500 | 0;
   i10 = i1 & 255;
   i11 = i20 + 496 | 0;
   i9 = i3 & 255;
   i3 = i5 & 255;
   i5 = i20 + 488 | 0;
   i1 = 0;
   do {
    L148 : do if ((i1 | 0) < (HEAPU16[i12 >> 1] | 0)) {
     i7 = (HEAP32[i13 >> 2] | 0) + i1 | 0;
     i8 = HEAP8[i7 >> 0] | 0;
     switch (i8 << 24 >> 24) {
     case -1:
      {
       i18 = 79;
       break L148;
      }
     case 0:
      {
       HEAP8[i15 + (i1 * 3 | 0) >> 0] = i4;
       HEAP8[i15 + (i1 * 3 | 0) + 1 >> 0] = i6;
       HEAP8[i15 + (i1 * 3 | 0) + 2 >> 0] = i2;
       break L148;
      }
     default:
      {
       i24 = i15 + (i1 * 3 | 0) | 0;
       i23 = HEAP32[i14 >> 2] | 0;
       i8 = i8 & 255;
       i8 = (Math_imul(i8 ^ 255, i10) | 0) + 128 + (Math_imul(HEAPU8[i23 + (HEAPU8[i24 >> 0] | 0) >> 0] | 0, i8) | 0) | 0;
       i22 = HEAP32[i11 >> 2] | 0;
       HEAP8[i24 >> 0] = HEAP8[i22 + (((i8 >>> 8 & 255) + i8 | 0) >>> 8 & 255) >> 0] | 0;
       i8 = i15 + (i1 * 3 | 0) + 1 | 0;
       i24 = HEAPU8[i7 >> 0] | 0;
       i24 = (Math_imul(i24, HEAPU8[i23 + (HEAPU8[i8 >> 0] | 0) >> 0] | 0) | 0) + 128 + (Math_imul(i24 ^ 255, i9) | 0) | 0;
       HEAP8[i8 >> 0] = HEAP8[i22 + (((i24 >>> 8 & 255) + i24 | 0) >>> 8 & 255) >> 0] | 0;
       i8 = i15 + (i1 * 3 | 0) + 2 | 0;
       i7 = HEAPU8[i7 >> 0] | 0;
       i7 = (Math_imul(i7, HEAPU8[i23 + (HEAPU8[i8 >> 0] | 0) >> 0] | 0) | 0) + 128 + (Math_imul(i7 ^ 255, i3) | 0) | 0;
       HEAP8[i8 >> 0] = HEAP8[i22 + (((i7 >>> 8 & 255) + i7 | 0) >>> 8 & 255) >> 0] | 0;
       break L148;
      }
     }
    } else i18 = 79; while (0);
    if ((i18 | 0) == 79) {
     i18 = 0;
     i24 = i15 + (i1 * 3 | 0) | 0;
     i23 = HEAP32[i5 >> 2] | 0;
     HEAP8[i24 >> 0] = HEAP8[i23 + (HEAPU8[i24 >> 0] | 0) >> 0] | 0;
     i24 = i15 + (i1 * 3 | 0) + 1 | 0;
     HEAP8[i24 >> 0] = HEAP8[i23 + (HEAPU8[i24 >> 0] | 0) >> 0] | 0;
     i24 = i15 + (i1 * 3 | 0) + 2 | 0;
     HEAP8[i24 >> 0] = HEAP8[i23 + (HEAPU8[i24 >> 0] | 0) >> 0] | 0;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i16 | 0));
  }
  i1 = HEAP32[i19 >> 2] & -8321;
  HEAP32[i19 >> 2] = i1;
 } while (0);
 if ((i1 & 4104 | 0) != 8) {
  STACKTOP = i21;
  return;
 }
 if ((HEAP8[i17 >> 0] | 0) != 3) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP16[i20 + 416 >> 1] | 0;
 i8 = i6 & 65535;
 i24 = HEAP32[i20 + 512 >> 2] | 0;
 i3 = 8 - (i24 & 255) | 0;
 HEAP32[i19 >> 2] = i1 & -9;
 i6 = i6 << 16 >> 16 != 0;
 i4 = (i24 & 65535) >>> 8;
 i5 = i24 >>> 16;
 i7 = i5 & 255;
 if ((i24 & 255) << 24 >> 24 != 0 & (i3 | 0) > 0 & i6) {
  i2 = HEAP32[i20 + 412 >> 2] | 0;
  i1 = 0;
  do {
   i24 = i2 + (i1 * 3 | 0) | 0;
   HEAP8[i24 >> 0] = (HEAPU8[i24 >> 0] | 0) >>> i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 i3 = 8 - (i4 & 65535) | 0;
 if (i4 << 16 >> 16 != 0 & (i3 | 0) > 0 & i6) {
  i2 = HEAP32[i20 + 412 >> 2] | 0;
  i1 = 0;
  do {
   i24 = i2 + (i1 * 3 | 0) + 1 | 0;
   HEAP8[i24 >> 0] = (HEAPU8[i24 >> 0] | 0) >>> i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 i3 = 8 - (i5 & 255) | 0;
 if (!(i7 << 24 >> 24 != 0 & (i3 | 0) > 0 & i6)) {
  STACKTOP = i21;
  return;
 }
 i2 = HEAP32[i20 + 412 >> 2] | 0;
 i1 = 0;
 do {
  i24 = i2 + (i1 * 3 | 0) + 2 | 0;
  HEAP8[i24 >> 0] = (HEAPU8[i24 >> 0] | 0) >>> i3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i21;
 return;
}

function __ZN18MultiQueryCallbackIN5physx10PxSweepHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i1, i62, i63, i61) {
 i1 = i1 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i61 = i61 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i73 + 168 | 0;
 i25 = i73 + 152 | 0;
 i70 = i73 + 104 | 0;
 i64 = i73 + 88 | 0;
 i66 = i73 + 242 | 0;
 i69 = i73 + 84 | 0;
 i67 = i73 + 240 | 0;
 i68 = i73 + 56 | 0;
 i27 = i73 + 238 | 0;
 i28 = i73 + 40 | 0;
 i38 = i73 + 24 | 0;
 i65 = i73;
 i49 = i73 + 236 | 0;
 HEAP32[i70 >> 2] = 0;
 HEAP32[i70 + 4 >> 2] = 0;
 HEAP32[i70 + 8 >> 2] = -1;
 HEAP16[i70 + 12 >> 1] = 0;
 i71 = i70 + 16 | 0;
 HEAP32[i71 >> 2] = 0;
 HEAP32[i71 + 4 >> 2] = 0;
 HEAP32[i71 + 8 >> 2] = 0;
 HEAP32[i71 + 12 >> 2] = 0;
 HEAP32[i71 + 16 >> 2] = 0;
 HEAP32[i71 + 20 >> 2] = 0;
 HEAPF32[i70 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (!i61) {
  i72 = 1;
  STACKTOP = i73;
  return i72 | 0;
 }
 i29 = i64 + 4 | 0;
 i30 = i1 + 20 | 0;
 i71 = i1 + 12 | 0;
 i31 = i1 + 41 | 0;
 i32 = i1 + 16 | 0;
 i33 = i1 + 24 | 0;
 i34 = i1 + 4 | 0;
 i35 = i1 + 32 | 0;
 i36 = i64 + 8 | 0;
 i37 = i64 + 12 | 0;
 i39 = i1 + 8 | 0;
 i40 = i1 + 72 | 0;
 i41 = i1 + 39 | 0;
 i42 = i1 + 28 | 0;
 i43 = i1 + 40 | 0;
 i44 = i1 + 68 | 0;
 i45 = i1 + 44 | 0;
 i46 = i1 + 38 | 0;
 i47 = i1 + 36 | 0;
 i48 = i65 + 16 | 0;
 i50 = i65 + 18 | 0;
 i51 = i26 + 4 | 0;
 i52 = i26 + 8 | 0;
 i53 = i26 + 12 | 0;
 i54 = i26 + 16 | 0;
 i55 = i26 + 20 | 0;
 i56 = i26 + 44 | 0;
 i57 = i26 + 52 | 0;
 i58 = i26 + 56 | 0;
 i59 = i26 + 60 | 0;
 i60 = i26 + 64 | 0;
 i14 = i1 + 37 | 0;
 i15 = i26 + 4 | 0;
 i16 = i26 + 20 | 0;
 i17 = i26 + 24 | 0;
 i18 = i26 + 28 | 0;
 i19 = i26 + 32 | 0;
 i20 = i26 + 36 | 0;
 i21 = i26 + 40 | 0;
 i22 = i26 + 48 | 0;
 i23 = i15 + 40 | 0;
 i24 = 0;
 L4 : while (1) {
  HEAP32[i64 >> 2] = 0;
  HEAP32[i29 >> 2] = 0;
  __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E(i63 + (i24 << 3) | 0, i64);
  i1 = HEAP32[i30 >> 2] | 0;
  i6 = HEAP16[i1 + 16 >> 1] | 0;
  HEAP16[i66 >> 1] = i6;
  i13 = HEAP8[i31 >> 0] | 0;
  i2 = (i6 << 16 >> 16 < 0 ? 1 : (HEAP32[(HEAP32[i71 >> 2] | 0) + 60 >> 2] | 0) != 0) & i13 << 24 >> 24 == 0 ? 1 : 2;
  HEAP32[i69 >> 2] = i2;
  HEAP16[i67 >> 1] = HEAP16[i32 >> 1] | 0;
  if (!(i13 << 24 >> 24)) {
   i13 = (__ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj(i64, i69, i66, i1, HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0, HEAP32[i35 >> 2] | 0, i67) | 0) ^ 1;
   i1 = HEAP32[i69 >> 2] | 0;
   if (!((i1 | 0) == 0 | i13)) {
    i13 = i1;
    i72 = 5;
   }
  } else {
   i13 = i2;
   i72 = 5;
  }
  L8 : do if ((i72 | 0) == 5) {
   i72 = 0;
   i1 = HEAP32[i36 >> 2] | 0;
   __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE(i68, i1, HEAP32[i37 >> 2] | 0);
   if (!(HEAP32[i1 + 4 >> 2] & 1)) i2 = i1 + 84 | 0; else i2 = (HEAP32[i1 + 8 >> 2] | 0) + 56 | 0;
   i5 = HEAP32[i71 >> 2] | 0;
   i1 = HEAP32[i5 + 60 >> 2] | 0;
   i3 = HEAP32[i5 + 64 >> 2] | 0;
   i12 = i1 >>> 0 > i3 >>> 0;
   i1 = i12 ? i1 - i3 | 0 : 1;
   i3 = i12 ? (HEAP32[i5 + 56 >> 2] | 0) + (i3 * 48 | 0) | 0 : i70;
   i5 = HEAP16[i67 >> 1] | 0;
   if ((HEAP32[i2 >> 2] | 0) == 5) i1 = i5 & 32 ? i1 : 1;
   i10 = (HEAP32[i34 >> 2] | 0) + 3392 | 0;
   i11 = HEAP32[i39 >> 2] | 0;
   i12 = HEAP32[i40 >> 2] | 0;
   HEAP16[i27 >> 1] = ((HEAP8[i41 >> 0] | 0) == 0 ? 4 : 64) | i5;
   f4 = Math_fround(HEAPF32[i42 >> 2]);
   i12 = __ZN12GeomQueryAnyIN5physx10PxSweepHitEE7geomHitERKNS0_2Sq17SceneQueryManagerERKNS0_15MultiQueryInputERKNS3_9ShapeDataERKNS0_10PxGeometryERKNS0_11PxTransformENS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEjPS1_fbPNS0_9PxBounds3E(i10, i11, i12, i2, i68, i27, i1, i3, f4, (HEAP8[i43 >> 0] | 0) != 0, HEAP8[i44 >> 0] | 0 ? i45 : 0) | 0;
   if (i12 | 0) {
    i11 = (i6 & 8) == 0;
    i10 = (i5 & 512) != 0;
    i1 = 0;
    while (1) {
     i2 = i3 + (i1 * 48 | 0) | 0;
     HEAP32[i2 >> 2] = HEAP32[i64 >> 2];
     HEAP32[i3 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i29 >> 2];
     i9 = i2 + 40 | 0;
     if (!(Math_fround(HEAPF32[i9 >> 2]) != Math_fround(0.0) | i10)) {
      i8 = HEAP32[(HEAP32[i39 >> 2] | 0) + 4 >> 2] | 0;
      f75 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
      f74 = Math_fround(-Math_fround(HEAPF32[i8 + 4 >> 2]));
      f4 = Math_fround(-Math_fround(HEAPF32[i8 + 8 >> 2]));
      HEAPF32[i3 + (i1 * 48 | 0) + 28 >> 2] = f75;
      HEAPF32[i3 + (i1 * 48 | 0) + 32 >> 2] = f74;
      HEAPF32[i3 + (i1 * 48 | 0) + 36 >> 2] = f4;
     }
     do if (!(HEAP8[i31 >> 0] | 0)) {
      i5 = HEAP32[i33 >> 2] | 0;
      i6 = (i5 | 0) == 0;
      if (i6) {
       if ((HEAP32[i35 >> 2] | 0) == 0 | i11) {
        i5 = i13;
        break;
       }
      } else if (i11) {
       i5 = i13;
       break;
      }
      if (!i6) {
       i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, HEAP32[i30 >> 2] | 0, i2 | 0) | 0;
       break;
      }
      i5 = HEAP32[i35 >> 2] | 0;
      i6 = HEAP32[i5 + 12 >> 2] | 0;
      if (!i6) i5 = i13; else {
       i8 = HEAP32[i30 >> 2] | 0;
       HEAP32[i28 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i28 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       HEAP32[i28 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
       HEAP32[i28 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
       i8 = (HEAP32[i36 >> 2] | 0) + 16 | 0;
       HEAP32[i38 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i38 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       HEAP32[i38 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
       HEAP32[i38 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
       i8 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
       HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
       HEAP32[i25 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
       HEAP32[i26 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
       HEAP32[i26 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
       i5 = mftCall_iiiiii(i6 | 0, i25 | 0, i26 | 0, i8 | 0, i5 | 0, i2 | 0) | 0;
      }
     } else i5 = i13; while (0);
     if ((i5 | 0) != 0 & (HEAP8[i41 >> 0] | 0) != 0) {
      i72 = 23;
      break L4;
     }
     switch (((HEAP8[i46 >> 0] | 0) == 0 ? i5 : 1) | 0) {
     case 1:
      {
       i5 = HEAP32[i71 >> 2] | 0;
       i7 = i5 + 60 | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       if (i8 | 0) if (HEAP8[i47 >> 0] | 0) {
        f75 = Math_fround(HEAPF32[i9 >> 2]);
        if (f75 <= Math_fround(HEAPF32[i42 >> 2])) {
         i6 = HEAP32[i5 + 64 >> 2] | 0;
         if ((i6 | 0) == (i8 | 0)) {
          i8 = HEAP32[i30 >> 2] | 0;
          HEAP32[i65 >> 2] = HEAP32[i8 >> 2];
          HEAP32[i65 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
          HEAP32[i65 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
          HEAP32[i65 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
          i9 = HEAP16[i8 + 16 >> 1] | 0;
          HEAP16[i48 >> 1] = i9;
          HEAP8[i50 >> 0] = HEAP8[i8 + 18 >> 0] | 0;
          HEAP16[i48 >> 1] = i9 & 65535 | 32768;
          HEAP32[i51 >> 2] = 0;
          HEAP32[i52 >> 2] = 0;
          HEAP32[i53 >> 2] = -1;
          HEAP16[i54 >> 1] = 0;
          HEAP32[i55 >> 2] = 0;
          HEAP32[i55 + 4 >> 2] = 0;
          HEAP32[i55 + 8 >> 2] = 0;
          HEAP32[i55 + 12 >> 2] = 0;
          HEAP32[i55 + 16 >> 2] = 0;
          HEAP32[i55 + 20 >> 2] = 0;
          HEAPF32[i56 >> 2] = Math_fround(3402823469999999843913219.0e14);
          HEAP8[i57 >> 0] = 0;
          HEAP32[i58 >> 2] = 0;
          HEAP32[i59 >> 2] = 0;
          HEAP32[i60 >> 2] = 0;
          HEAP32[i26 >> 2] = gb + 93084 + 8;
          do if (!(HEAP8[i14 >> 0] | 0)) if (HEAP32[i7 >> 2] | 0) {
           i8 = HEAP32[i34 >> 2] | 0;
           i9 = HEAP32[i39 >> 2] | 0;
           HEAP16[i49 >> 1] = HEAP16[i32 >> 1] | 0;
           if (!(__ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i8, i9, i26, i49, 0, i65, HEAP32[i33 >> 2] | 0, HEAP32[i35 >> 2] | 0) | 0)) break;
           i5 = HEAP32[i71 >> 2] | 0;
           i8 = i5 + 4 | 0;
           HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
           HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
           HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
           HEAP16[i5 + 16 >> 1] = HEAP16[i54 >> 1] | 0;
           HEAP32[i5 + 20 >> 2] = HEAP32[i16 >> 2];
           HEAP32[i5 + 24 >> 2] = HEAP32[i17 >> 2];
           HEAP32[i5 + 28 >> 2] = HEAP32[i18 >> 2];
           HEAP32[i5 + 32 >> 2] = HEAP32[i19 >> 2];
           HEAP32[i5 + 36 >> 2] = HEAP32[i20 >> 2];
           HEAP32[i5 + 40 >> 2] = HEAP32[i21 >> 2];
           HEAP32[i5 + 44 >> 2] = HEAP32[i56 >> 2];
           HEAP32[i5 + 48 >> 2] = HEAP32[i22 >> 2];
           HEAP8[(HEAP32[i71 >> 2] | 0) + 52 >> 0] = 1;
           i5 = HEAP32[i71 >> 2] | 0;
           i8 = HEAP32[i5 + 56 >> 2] | 0;
           i9 = HEAP32[i5 + 64 >> 2] | 0;
           f4 = Math_fround(HEAPF32[i23 >> 2]);
           if (!i9) {
            i7 = i5;
            i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
            i5 = 0;
           } else {
            i7 = 0;
            i5 = i9;
            do {
             i6 = i8 + (i7 * 48 | 0) + 40 | 0;
             if (Math_fround(HEAPF32[i6 >> 2]) > f4) {
              i5 = i5 + -1 | 0;
              i84 = HEAP16[i8 + (i5 * 48 | 0) + 12 >> 1] | 0;
              i83 = HEAP32[i8 + (i5 * 48 | 0) + 16 >> 2] | 0;
              i82 = HEAP32[i8 + (i5 * 48 | 0) + 20 >> 2] | 0;
              i81 = HEAP32[i8 + (i5 * 48 | 0) + 24 >> 2] | 0;
              i80 = HEAP32[i8 + (i5 * 48 | 0) + 28 >> 2] | 0;
              i79 = HEAP32[i8 + (i5 * 48 | 0) + 32 >> 2] | 0;
              i78 = HEAP32[i8 + (i5 * 48 | 0) + 36 >> 2] | 0;
              i77 = HEAP32[i8 + (i5 * 48 | 0) + 40 >> 2] | 0;
              i76 = HEAP32[i8 + (i5 * 48 | 0) + 44 >> 2] | 0;
              _memmove(i8 + (i7 * 48 | 0) | 0, i8 + (i5 * 48 | 0) | 0, 12) | 0;
              HEAP16[i8 + (i7 * 48 | 0) + 12 >> 1] = i84;
              HEAP32[i8 + (i7 * 48 | 0) + 16 >> 2] = i83;
              HEAP32[i8 + (i7 * 48 | 0) + 20 >> 2] = i82;
              HEAP32[i8 + (i7 * 48 | 0) + 24 >> 2] = i81;
              HEAP32[i8 + (i7 * 48 | 0) + 28 >> 2] = i80;
              HEAP32[i8 + (i7 * 48 | 0) + 32 >> 2] = i79;
              HEAP32[i8 + (i7 * 48 | 0) + 36 >> 2] = i78;
              HEAP32[i6 >> 2] = i77;
              HEAP32[i8 + (i7 * 48 | 0) + 44 >> 2] = i76;
             }
             i7 = i7 + 1 | 0;
            } while ((i7 | 0) != (i9 | 0));
            i7 = HEAP32[i71 >> 2] | 0;
            i6 = HEAP32[i23 >> 2] | 0;
           }
           HEAP32[i7 + 64 >> 2] = i5;
           HEAP32[i42 >> 2] = i6;
           HEAP32[i62 >> 2] = i6;
          } while (0);
          HEAP8[i14 >> 0] = 1;
          i5 = HEAP32[i71 >> 2] | 0;
          i6 = HEAP32[i5 + 64 >> 2] | 0;
          if ((i6 | 0) == (HEAP32[i5 + 60 >> 2] | 0)) {
           i84 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, HEAP32[i5 + 56 >> 2] | 0, i6 | 0) | 0;
           HEAP8[i47 >> 0] = i84 & 1;
           if (!i84) {
            i1 = 0;
            i72 = 46;
            break L4;
           }
           HEAP32[(HEAP32[i71 >> 2] | 0) + 64 >> 2] = 0;
           i6 = HEAP32[i71 >> 2] | 0;
           i5 = i6;
           i6 = HEAP32[i6 + 64 >> 2] | 0;
          }
         }
         i84 = HEAP32[i5 + 56 >> 2] | 0;
         HEAP32[i5 + 64 >> 2] = i6 + 1;
         i83 = i84 + (i6 * 48 | 0) | 0;
         HEAP32[i83 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i83 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i83 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         HEAP16[i84 + (i6 * 48 | 0) + 12 >> 1] = HEAP16[i3 + (i1 * 48 | 0) + 12 >> 1] | 0;
         HEAP32[i84 + (i6 * 48 | 0) + 16 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 16 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 20 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 20 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 24 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 24 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 28 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 28 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 32 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 32 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 36 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 36 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 40 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 40 >> 2];
         HEAP32[i84 + (i6 * 48 | 0) + 44 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 44 >> 2];
        }
       }
       break;
      }
     case 2:
      {
       f4 = Math_fround(HEAPF32[i9 >> 2]);
       if (f4 <= Math_fround(HEAPF32[i42 >> 2])) {
        HEAPF32[i42 >> 2] = f4;
        HEAPF32[i62 >> 2] = f4;
        i84 = HEAP32[i71 >> 2] | 0;
        i83 = i84 + 4 | 0;
        HEAP32[i83 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i83 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i83 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP16[i84 + 16 >> 1] = HEAP16[i3 + (i1 * 48 | 0) + 12 >> 1] | 0;
        HEAP32[i84 + 20 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 16 >> 2];
        HEAP32[i84 + 24 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 20 >> 2];
        HEAP32[i84 + 28 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 24 >> 2];
        HEAP32[i84 + 32 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 28 >> 2];
        HEAP32[i84 + 36 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 32 >> 2];
        HEAP32[i84 + 40 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 36 >> 2];
        HEAP32[i84 + 44 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 40 >> 2];
        HEAP32[i84 + 48 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 44 >> 2];
        HEAP8[(HEAP32[i71 >> 2] | 0) + 52 >> 0] = 1;
       }
       break;
      }
     default:
      {}
     }
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i12 >>> 0) break L8;
    }
   }
  } while (0);
  i24 = i24 + 1 | 0;
  if (i24 >>> 0 >= i61 >>> 0) {
   i1 = 1;
   i72 = 46;
   break;
  }
 }
 if ((i72 | 0) == 23) {
  i84 = HEAP32[i71 >> 2] | 0;
  i83 = i84 + 4 | 0;
  HEAP32[i83 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i83 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i83 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP16[i84 + 16 >> 1] = HEAP16[i3 + (i1 * 48 | 0) + 12 >> 1] | 0;
  HEAP32[i84 + 20 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 16 >> 2];
  HEAP32[i84 + 24 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 20 >> 2];
  HEAP32[i84 + 28 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 24 >> 2];
  HEAP32[i84 + 32 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 28 >> 2];
  HEAP32[i84 + 36 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 32 >> 2];
  HEAP32[i84 + 40 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 36 >> 2];
  HEAP32[i84 + 44 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 40 >> 2];
  HEAP32[i84 + 48 >> 2] = HEAP32[i3 + (i1 * 48 | 0) + 44 >> 2];
  HEAP8[(HEAP32[i71 >> 2] | 0) + 52 >> 0] = 1;
  i84 = 0;
  STACKTOP = i73;
  return i84 | 0;
 } else if ((i72 | 0) == 46) {
  STACKTOP = i73;
  return i1 | 0;
 }
 return 0;
}

function __Z26FillCommonScriptingClassesR22CommonScriptingClasses(i26) {
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i29 + 368 | 0;
 i25 = i29 + 352 | 0;
 i24 = i29 + 336 | 0;
 i23 = i29 + 320 | 0;
 i22 = i29 + 304 | 0;
 i21 = i29 + 288 | 0;
 i20 = i29 + 272 | 0;
 i19 = i29 + 256 | 0;
 i18 = i29 + 240 | 0;
 i17 = i29 + 224 | 0;
 i16 = i29 + 208 | 0;
 i15 = i29 + 192 | 0;
 i14 = i29 + 176 | 0;
 i13 = i29 + 160 | 0;
 i12 = i29 + 144 | 0;
 i11 = i29 + 128 | 0;
 i10 = i29 + 112 | 0;
 i9 = i29 + 96 | 0;
 i8 = i29 + 80 | 0;
 i7 = i29 + 64 | 0;
 i6 = i29 + 48 | 0;
 i5 = i29 + 32 | 0;
 i4 = i29 + 16 | 0;
 i3 = i29;
 i27 = i29 + 380 | 0;
 if (HEAP32[gb + 1164184 + 768 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = gb + 1164184 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[gb + 1164184 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i2 >> 2] | 0); else mftCall_vi(HEAP32[i2 >> 2] | 0, HEAP32[gb + 1164184 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[gb + 1164184 + 768 >> 2] | 0) >>> 0);
 }
 HEAP32[i26 >> 2] = __Z25scripting_class_get_imageP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 464052 | 0, gb + 464071 | 0) | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = gb + 464052;
  HEAP32[i3 + 8 >> 2] = gb + 464071;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 8 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 590125 | 0) | 0;
 if (!i2) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = gb + 465948;
  HEAP32[i4 + 8 >> 2] = gb + 590125;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 12 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 774375 | 0) | 0;
 if (!i2) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = gb + 465948;
  HEAP32[i5 + 8 >> 2] = gb + 774375;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 84 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464198 | 0) | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = gb + 465948;
  HEAP32[i6 + 8 >> 2] = gb + 464198;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 36 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464204 | 0) | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = gb + 465948;
  HEAP32[i7 + 8 >> 2] = gb + 464204;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 i4 = i26 + 88 | 0;
 HEAP32[i4 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464211 | 0) | 0;
 if (!i2) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 4 >> 2] = gb + 465948;
  HEAP32[i8 + 8 >> 2] = gb + 464211;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 96 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464218 | 0) | 0;
 if (!i2) {
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 4 >> 2] = gb + 465948;
  HEAP32[i9 + 8 >> 2] = gb + 464218;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 72 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464224 | 0) | 0;
 if (!i2) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 4 >> 2] = gb + 465948;
  HEAP32[i10 + 8 >> 2] = gb + 464224;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 76 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464229 | 0) | 0;
 if (!i2) {
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 4 >> 2] = gb + 465948;
  HEAP32[i11 + 8 >> 2] = gb + 464229;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 80 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464234 | 0) | 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = gb + 465948;
  HEAP32[i12 + 8 >> 2] = gb + 464234;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 16 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464241 | 0) | 0;
 if (!i2) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 465948;
  HEAP32[i13 + 8 >> 2] = gb + 464241;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 20 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464248 | 0) | 0;
 if (!i2) {
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 4 >> 2] = gb + 465948;
  HEAP32[i14 + 8 >> 2] = gb + 464248;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i14);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 24 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464255 | 0) | 0;
 if (!i2) {
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 4 >> 2] = gb + 465948;
  HEAP32[i15 + 8 >> 2] = gb + 464255;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 i3 = i26 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464262 | 0) | 0;
 if (!i2) {
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 4 >> 2] = gb + 465948;
  HEAP32[i16 + 8 >> 2] = gb + 464262;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i16);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 32 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464268 | 0) | 0;
 if (!i2) {
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 4 >> 2] = gb + 465948;
  HEAP32[i17 + 8 >> 2] = gb + 464268;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i17);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 40 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464255 | 0) | 0;
 if (!i2) {
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 4 >> 2] = gb + 465948;
  HEAP32[i18 + 8 >> 2] = gb + 464255;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i18);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464274 | 0) | 0;
 if (!i2) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i19 + 4 >> 2] = gb + 465948;
  HEAP32[i19 + 8 >> 2] = gb + 464274;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i19);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 44 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464282 | 0) | 0;
 if (!i2) {
  HEAP32[i20 >> 2] = i1;
  HEAP32[i20 + 4 >> 2] = gb + 465948;
  HEAP32[i20 + 8 >> 2] = gb + 464282;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i20);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 48 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 464052 | 0, gb + 464300 | 0) | 0;
 if (!i2) {
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = gb + 464052;
  HEAP32[i21 + 8 >> 2] = gb + 464300;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i21);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 52 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 464052 | 0, gb + 464310 | 0) | 0;
 if (!i2) {
  HEAP32[i22 >> 2] = i1;
  HEAP32[i22 + 4 >> 2] = gb + 464052;
  HEAP32[i22 + 8 >> 2] = gb + 464310;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i22);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 56 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 464052 | 0, gb + 464320 | 0) | 0;
 if (!i2) {
  HEAP32[i23 >> 2] = i1;
  HEAP32[i23 + 4 >> 2] = gb + 464052;
  HEAP32[i23 + 8 >> 2] = gb + 464320;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i23);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 68 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 464052 | 0, gb + 464326 | 0) | 0;
 if (!i2) {
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 4 >> 2] = gb + 464052;
  HEAP32[i24 + 8 >> 2] = gb + 464326;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i24);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 64 >> 2] = i2;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464338 | 0) | 0;
 if (!i2) {
  HEAP32[i25 >> 2] = i1;
  HEAP32[i25 + 4 >> 2] = gb + 465948;
  HEAP32[i25 + 8 >> 2] = gb + 464338;
  __Z6FormatPKcz(i27, gb + 464083 | 0, i25);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 }
 HEAP32[i26 + 60 >> 2] = i2;
 i1 = i26 + 100 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i27, HEAP32[gb + 66476 >> 2] | 0, gb + 464052 | 0, gb + 464071 | 0, gb + 464347 | 0);
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i27 + 4 >> 0] | 0;
 i1 = i26 + 108 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i27, HEAP32[gb + 66476 >> 2] | 0, gb + 464052 | 0, gb + 464071 | 0, gb + 464356 | 0);
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i27 + 4 >> 0] | 0;
 i1 = i26 + 116 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i27, HEAP32[gb + 66476 >> 2] | 0, gb + 465948 | 0, gb + 464368 | 0, gb + 464380 | 0);
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i27 + 4 >> 0] | 0;
 i1 = HEAP32[gb + 66476 >> 2] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i1, gb + 465948 | 0, gb + 464388 | 0) | 0;
 if (i2 | 0) {
  i27 = i26 + 4 | 0;
  HEAP32[i27 >> 2] = i2;
  i27 = HEAP32[i4 >> 2] | 0;
  i27 = __Z25scripting_array_class_getP11Il2CppClassj(i27, 1) | 0;
  i28 = i26 + 92 | 0;
  HEAP32[i28 >> 2] = i27;
  STACKTOP = i29;
  return;
 }
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = gb + 465948;
 HEAP32[i28 + 8 >> 2] = gb + 464388;
 __Z6FormatPKcz(i27, gb + 464083 | 0, i28);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 i27 = i26 + 4 | 0;
 HEAP32[i27 >> 2] = i2;
 i27 = HEAP32[i4 >> 2] | 0;
 i27 = __Z25scripting_array_class_getP11Il2CppClassj(i27, 1) | 0;
 i28 = i26 + 92 | 0;
 HEAP32[i28 >> 2] = i27;
 STACKTOP = i29;
 return;
}

function __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup(i33, i32, i20) {
 i33 = i33 | 0;
 i32 = i32 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34 + 488 | 0;
 i31 = i34 + 160 | 0;
 i23 = i34 + 360 | 0;
 i24 = i34 + 32 | 0;
 i25 = i34 + 24 | 0;
 i4 = i34 + 16 | 0;
 i26 = i34 + 8 | 0;
 i29 = i34 + 264 | 0;
 i27 = i34;
 i22 = i29 + 68 | 0;
 i17 = i20 + 36 | 0;
 i8 = i29;
 i9 = i8 + 96 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 i1 = HEAP32[i17 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i20 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i29 >> 2] = 1;
  i2 = i29;
  i21 = 6;
  break;
 } else {
  HEAP32[i29 >> 2] = 0;
  break;
 } else {
  HEAP32[i29 >> 2] = i1;
  if (i1 | 0) {
   i2 = i29;
   i21 = 6;
  }
 } while (0);
 if ((i21 | 0) == 6) {
  i1 = 0;
  do {
   i28 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
   HEAP32[i29 + 4 + (i1 << 2) >> 2] = HEAP32[i28 >> 2];
   HEAP32[i29 + 36 + (i1 << 2) >> 2] = HEAP32[i28 + 36 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i18 = i20 + 32 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 do if (!i1) HEAP8[i29 + 92 >> 0] = 0; else {
  i2 = i29 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i29 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i29 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   break;
  } else {
   HEAP8[i2 >> 0] = 0;
   break;
  }
 } while (0);
 i13 = i20 + 40 | 0;
 HEAP32[i29 + 80 >> 2] = HEAP32[i13 >> 2];
 i14 = i20 + 48 | 0;
 HEAP32[i29 + 84 >> 2] = HEAP32[i14 >> 2];
 i15 = i20 + 44 | 0;
 HEAP32[i29 + 88 >> 2] = HEAP32[i15 >> 2];
 i28 = i32 + 4 | 0;
 i2 = HEAP32[i28 >> 2] | 0;
 if (i2 | 0) {
  i1 = i28;
  L20 : while (1) {
   i3 = i2;
   while (1) {
    if (!(__ZNK21GLESRenderTargetSetupltERKS_(i3 + 16 | 0, i29) | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L20; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i28 | 0)) if (!(__ZNK21GLESRenderTargetSetupltERKS_(i29, i1 + 16 | 0) | 0 | (i1 | 0) == (i28 | 0))) {
   i32 = i1;
   i32 = i32 + 112 | 0;
   i30 = i32;
   i30 = HEAP32[i30 >> 2] | 0;
   i32 = i32 + 4 | 0;
   i32 = HEAP32[i32 >> 2] | 0;
   i31 = i33;
   HEAP32[i31 >> 2] = i30;
   i33 = i33 + 4 | 0;
   HEAP32[i33 >> 2] = i32;
   STACKTOP = i34;
   return;
  }
 }
 i19 = HEAP32[gb + 1451080 >> 2] | 0;
 __ZN7ApiGLES17CreateFramebufferEv(i27, i19);
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i25, i19, 0);
 i16 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 668 >> 2] | 0;
 i11 = i27;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i30 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i19, 0, i30);
 i6 = HEAP32[i17 >> 2] | 0;
 if ((i6 | 0) > 0) {
  i7 = i19 + 52 | 0;
  i8 = i19 + 360 | 0;
  i9 = i19 + 56 | 0;
  i10 = i19 + 64 | 0;
  i11 = i19 + 60 | 0;
  i5 = 0;
  do {
   i12 = i5 + 36064 | 0;
   i4 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
   L34 : do if (!(HEAP32[i4 + 20 >> 2] & 64)) {
    HEAP32[i31 >> 2] = HEAP32[i4 >> 2];
    i1 = HEAP32[gb + 1157724 >> 2] | 0;
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i30, i1, i31);
     i2 = HEAP32[i30 >> 2] | 0;
     i35 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1157724 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i35 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i35 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) if (HEAP32[i1 >> 2] | 0) if (HEAP32[i4 + 40 >> 2] | 0) {
      i2 = HEAP32[i13 >> 2] | 0;
      if (!i2) i3 = 0; else if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 726 >> 0] | 0)) {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 602305 | 0, 0, gb + 602389 | 0, 157, 512, 0, 0, 0);
       i3 = 0;
      } else i3 = i2;
      switch (HEAP32[i4 + 24 >> 2] | 0) {
      case 4:
       {
        if ((HEAP32[i14 >> 2] | 0) == -1) {
         i2 = HEAP32[i10 >> 2] | 0;
         if (i2 | 0) {
          mftCall_viiii(i2 | 0, i16 | 0, i12 | 0, HEAP32[i1 >> 2] | 0, i3 | 0);
          break L34;
         }
        }
        i35 = HEAP32[i15 >> 2] | 0;
        mftCall_viiiii(HEAP32[i9 >> 2] | 0, i16 | 0, i12 | 0, ((i35 | 0) < 0 ? 34069 : ((i35 | 0) > 5 ? 5 : i35) + 34069 | 0) | 0, HEAP32[i1 >> 2] | 0, i3 | 0);
        break L34;
       }
      case 6:
      case 5:
      case 3:
       {
        i2 = HEAP32[i14 >> 2] | 0;
        if ((i2 | 0) == -1) {
         i2 = HEAP32[i10 >> 2] | 0;
         if (!i2) i2 = 0; else {
          mftCall_viiii(i2 | 0, i16 | 0, i12 | 0, HEAP32[i1 >> 2] | 0, i3 | 0);
          break L34;
         }
        }
        mftCall_viiiii(HEAP32[i11 >> 2] | 0, i16 | 0, i12 | 0, HEAP32[i1 >> 2] | 0, i3 | 0, i2 | 0);
        break L34;
       }
      default:
       {
        i2 = i4 + 16 | 0;
        if ((HEAP32[i2 >> 2] | 0) >>> 0 > 1) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0) {
         mftCall_viiiiii(HEAP32[i8 >> 2] | 0, i16 | 0, i12 | 0, 3553, HEAP32[i1 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
         break L34;
        }
        mftCall_viiiii(HEAP32[i9 >> 2] | 0, i16 | 0, i12 | 0, 3553, HEAP32[i1 >> 2] | 0, i3 | 0);
        break L34;
       }
      }
     }
    }
    mftCall_viiii(HEAP32[i7 >> 2] | 0, i16 | 0, i12 | 0, 36161, HEAP32[i4 + 36 >> 2] | 0);
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 i4 = HEAP32[i18 >> 2] | 0;
 do if (i4 | 0) if (!(HEAP32[i4 + 20 >> 2] & 64)) {
  HEAP32[i31 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i30, i1, i31);
   i2 = HEAP32[i30 >> 2] | 0;
   i35 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1157724 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i35 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i35 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
   i2 = 0;
   i1 = 0;
  } else {
   i35 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i35;
   if (!i35) i2 = 0; else i2 = (HEAP32[i1 >> 2] | 0) != 0;
  }
  if (__ZN2gl20IsFormatDepthStencilENS_9TexFormatE(HEAP32[i4 + 40 >> 2] | 0) | 0) if (i2) {
   mftCall_viiiii(HEAP32[i19 + 56 >> 2] | 0, i16 | 0, 33306, 3553, HEAP32[i1 >> 2] | 0, 0);
   break;
  } else {
   mftCall_viiii(HEAP32[i19 + 52 >> 2] | 0, i16 | 0, 33306, 36161, HEAP32[i4 + 36 >> 2] | 0);
   break;
  } else if (i2) {
   i35 = i19 + 56 | 0;
   mftCall_viiiii(HEAP32[i35 >> 2] | 0, i16 | 0, 36096, 3553, HEAP32[i1 >> 2] | 0, 0);
   mftCall_viiiii(HEAP32[i35 >> 2] | 0, i16 | 0, 36128, 3553, 0, 0);
   break;
  } else {
   i35 = i19 + 52 | 0;
   mftCall_viiii(HEAP32[i35 >> 2] | 0, i16 | 0, 36096, 36161, HEAP32[i4 + 36 >> 2] | 0);
   mftCall_viiii(HEAP32[i35 >> 2] | 0, i16 | 0, 36128, 36161, 0);
   break;
  }
 } while (0);
 i4 = i27;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[gb + 1451148 >> 2] | 0;
 if (!(HEAP32[i17 >> 2] | 0)) {
  if (HEAP8[i1 + 135 >> 0] | 0) {
   i35 = i31;
   HEAP32[i35 >> 2] = i3;
   HEAP32[i35 + 4 >> 2] = i4;
   HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i19, i30, 1, gb + 1451100 | 0);
  }
 } else if (HEAP8[i1 + 134 >> 0] | 0) {
  i1 = 0;
  do {
   i2 = __ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[i20 + (i1 << 2) >> 2] | 0) | 0;
   HEAP32[i23 + (i1 << 2) >> 2] = i2 ? 0 : i1 + 36064 | 0;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i17 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i35 = i24;
  HEAP32[i35 >> 2] = i3;
  HEAP32[i35 + 4 >> 2] = i4;
  HEAP32[i30 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i19, i30, i2, i23);
 }
 if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 124 >> 0] | 0) {
  i10 = HEAP32[i27 >> 2] | 0;
  i11 = HEAP32[i27 + 4 >> 2] | 0;
  i6 = HEAP32[i17 >> 2] | 0;
  L102 : do if ((i6 | 0) > 0) {
   i1 = 0;
   i5 = 0;
   while (1) {
    i2 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
    do if (!(__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(i2) | 0)) {
     i3 = HEAP32[i2 >> 2] | 0;
     do if (!i3) {
      i2 = HEAP32[i2 + 36 >> 2] | 0;
      if (!i2) {
       HEAP8[i24 >> 0] = 0;
       break;
      } else {
       __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc(i19, 8, i2, 128, 0, i24);
       break;
      }
     } else {
      HEAP32[i31 >> 2] = i3;
      i2 = HEAP32[gb + 1157724 >> 2] | 0;
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i30, i2, i31);
       i3 = HEAP32[i30 >> 2] | 0;
       i35 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1157724 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i35 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i35 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
      __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc(i19, 7, HEAP32[i2 >> 2] | 0, 128, 0, i24);
     } while (0);
     if (i1) if (!(_strcmp(i23, i24) | 0)) {
      i1 = 1;
      break;
     } else break L102; else {
      i8 = i23;
      i7 = i24;
      i9 = i8 + 128 | 0;
      do {
       HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
       i8 = i8 + 1 | 0;
       i7 = i7 + 1 | 0;
      } while ((i8 | 0) < (i9 | 0));
      i1 = 1;
      break;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i6 | 0)) {
     i4 = i1;
     i21 = 90;
     break;
    }
   }
  } else {
   i4 = 0;
   i21 = 90;
  } while (0);
  do if ((i21 | 0) == 90) {
   i1 = HEAP32[i18 >> 2] | 0;
   if (!i1) {
    if (!i4) break;
   } else {
    i2 = HEAP32[i1 >> 2] | 0;
    do if (!i2) {
     i1 = HEAP32[i1 + 36 >> 2] | 0;
     if (!i1) {
      HEAP8[i24 >> 0] = 0;
      break;
     } else {
      __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc(i19, 8, i1, 128, 0, i24);
      break;
     }
    } else {
     HEAP32[i31 >> 2] = i2;
     i1 = HEAP32[gb + 1157724 >> 2] | 0;
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i30, i1, i31);
      i2 = HEAP32[i30 >> 2] | 0;
      i35 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1157724 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i35 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i35 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
     __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc(i19, 7, HEAP32[i1 >> 2] | 0, 128, 0, i24);
    } while (0);
    if (i4) if (_strcmp(i23, i24) | 0) break;
   }
   i35 = (i10 | 0) == 0 | (__ZNK7ApiGLES10GetContextEv(i19) | 0) == (i11 | 0);
   __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i19, 9, i35 ? i10 : -1, 0, i24);
  } while (0);
 }
 i5 = i25;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i26;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i30 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i19, 0, i30);
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = i29 + 72 | 0;
 i5 = i27;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i31 + 68 | 0;
 i8 = i31;
 i7 = i29;
 i9 = i8 + 68 | 0;
 do {
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  i8 = i8 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i1 >> 2] = i2;
 i6 = i31 + 72 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 i6 = i31 + 96 | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i28 >> 2] | 0;
 do if (!i1) {
  HEAP32[i30 >> 2] = i28;
  i2 = i28;
  i3 = i28;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if (__ZNK21GLESRenderTargetSetupltERKS_(i31, i2) | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i21 = 109;
     break;
    } else i1 = i2;
   } else {
    if (!(__ZNK21GLESRenderTargetSetupltERKS_(i2, i31) | 0)) {
     i21 = 114;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i21 = 113;
     break;
    } else i1 = i2;
   }
  }
  if ((i21 | 0) == 109) {
   HEAP32[i30 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i21 | 0) == 113) {
   HEAP32[i30 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i21 | 0) == 114) {
   HEAP32[i30 >> 2] = i1;
   i2 = i1;
   i3 = i30;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(120) | 0;
  i8 = i1 + 16 | 0;
  i7 = i31;
  i9 = i8 + 96 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   i8 = i8 + 4 | 0;
   i7 = i7 + 4 | 0;
  } while ((i8 | 0) < (i9 | 0));
  i30 = i6;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i35 = i1 + 112 | 0;
  HEAP32[i35 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i35 + 4 >> 2] = i31;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i32 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i32 + 4 >> 2] | 0, i2);
  i35 = i32 + 8 | 0;
  HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + 1;
 }
 i32 = i1;
 i32 = i32 + 112 | 0;
 i31 = i32;
 i31 = HEAP32[i31 >> 2] | 0;
 i32 = i32 + 4 | 0;
 i32 = HEAP32[i32 >> 2] | 0;
 i35 = i33;
 i33 = i35;
 HEAP32[i33 >> 2] = i31;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = i32;
 STACKTOP = i34;
 return;
}

function __ZN5physx15PxSerialization27serializeCollectionToBinaryERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS3_b(i8, i27, i32, i1, i6) {
 i8 = i8 | 0;
 i27 = i27 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i34 + 384 | 0;
 i10 = i34 + 376 | 0;
 i4 = i34 + 372 | 0;
 i5 = i34 + 368 | 0;
 i9 = i34 + 364 | 0;
 i7 = i34 + 360 | 0;
 i30 = i34 + 144 | 0;
 i11 = i34 + 352 | 0;
 i33 = i34 + 128 | 0;
 i12 = i34 + 124 | 0;
 i14 = i34 + 112 | 0;
 i13 = i34 + 104 | 0;
 i16 = i34 + 96 | 0;
 i15 = i34 + 92 | 0;
 i17 = i34 + 88 | 0;
 i20 = i34 + 84 | 0;
 i19 = i34 + 72 | 0;
 i18 = i34;
 i22 = i34 + 60 | 0;
 i21 = i34 + 48 | 0;
 i26 = i34 + 44 | 0;
 i24 = i34 + 32 | 0;
 i23 = i34 + 20 | 0;
 i25 = i34 + 16 | 0;
 if (!(__ZN5physx15PxSerialization14isSerializableERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_(i27, i32, i1) | 0)) {
  i33 = 0;
  STACKTOP = i34;
  return i33 | 0;
 }
 __ZN5physx2Sn14sortCollectionERNS_2Cm10CollectionERNS0_21SerializationRegistryEb(i27, i32, 0);
 __ZN5physx2Sn20SerializationContextC2ERKNS_2Cm10CollectionEPS4_(i30, i27, i1);
 i28 = i27 + 80 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) {
  i2 = i27 + 48 | 0;
  i3 = 0;
  do {
   i29 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 4) >> 2] | 0;
   i35 = mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, HEAP16[i29 + 4 >> 1] | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[i35 >> 2] | 0) + 20 >> 2] | 0, i35 | 0, i29 | 0, i30 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 HEAP32[i11 >> 2] = i8;
 i1 = i11 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i33 >> 2] = gb + 140280 + 8;
 i29 = i33 + 4 | 0;
 HEAP32[i29 >> 2] = i11;
 HEAP32[i33 + 8 >> 2] = i27;
 HEAP8[i33 + 12 >> 0] = i6 & 1;
 HEAP32[i31 >> 2] = 1145193811;
 i2 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i31 | 0, 4) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 HEAP32[i10 >> 2] = 50529024;
 mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i10 | 0, 4);
 HEAP32[i4 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i4 | 0, 4);
 HEAP32[i5 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i5 | 0, 4);
 HEAP32[i9 >> 2] = __ZN5physx2Sn20getBinaryPlatformTagEv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i9 | 0, 4);
 HEAP32[i7 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i7 | 0, 4);
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = 0 - (HEAP32[i1 + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i2 | 0) | 0;
 if (i2) {
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i2 | 0);
  i1 = HEAP32[i29 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i28 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i12 | 0, 4) | 0;
 i35 = i1 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i4;
 i35 = HEAP32[i28 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 i4 = i14 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i14 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i14, i35, i13);
 HEAP32[i16 >> 2] = 0;
 if (HEAP32[i28 >> 2] | 0) {
  i1 = i27 + 48 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = 0;
  do {
   i12 = HEAP16[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 4) >> 2] | 0) + 4 >> 1] | 0;
   i35 = mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, i12 | 0) | 0;
   i10 = HEAP32[i16 >> 2] | 0;
   i12 = i12 & 65535;
   i13 = i2 + (i3 << 3) | 0;
   i11 = i13;
   HEAP8[i11 >> 0] = i10;
   HEAP8[i11 + 1 >> 0] = i10 >> 8;
   HEAP8[i11 + 2 >> 0] = i10 >> 16;
   HEAP8[i11 + 3 >> 0] = i10 >> 24;
   i13 = i13 + 4 | 0;
   HEAP8[i13 >> 0] = i12;
   HEAP8[i13 + 1 >> 0] = i12 >> 8;
   HEAP8[i13 + 2 >> 0] = i12 >> 16;
   HEAP8[i13 + 3 >> 0] = i12 >> 24;
   i35 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 24 >> 2] | 0, i35 | 0) | 0;
   HEAP32[i16 >> 2] = (0 - i35 & 15) + i35 + (HEAP32[i16 >> 2] | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i28 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = 0 - (HEAP32[i1 + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i2 | 0) | 0;
 if (i2) {
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i2 | 0);
  i1 = HEAP32[i29 >> 2] | 0;
 }
 i13 = HEAP32[i4 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 i35 = HEAP32[i1 >> 2] | 0;
 i35 = mftCall_iiii(HEAP32[HEAP32[i35 >> 2] >> 2] | 0, i35 | 0, i15 | 0, 4) | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i35;
 i1 = HEAP32[i14 >> 2] | 0;
 i35 = HEAP32[i29 >> 2] | 0;
 i15 = HEAP32[i35 >> 2] | 0;
 i15 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i1 | 0, i13 << 3 | 0) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i15;
 i35 = HEAP32[i29 >> 2] | 0;
 i15 = HEAP32[i35 >> 2] | 0;
 i16 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i16 | 0, 4) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i16;
 i35 = HEAP32[i5 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i35 | 0) < 0 | (i35 & 2147483647 | 0) == 0))) {
  i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i1 | 0);
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = 0 - (HEAP32[i1 + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i2 | 0) | 0;
 if (i2) {
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i2 | 0);
  i1 = HEAP32[i29 >> 2] | 0;
 }
 i5 = i30 + 48 | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 i6 = HEAP32[i1 >> 2] | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i17 | 0, 4) | 0;
 i35 = i1 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i6;
 i35 = HEAP32[i29 >> 2] | 0;
 i6 = HEAP32[i35 >> 2] | 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, HEAP32[i30 + 44 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i5;
 i35 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 44 >> 2] | 0, i27 | 0) | 0;
 HEAP32[i20 >> 2] = i35;
 HEAP32[i18 + 8 >> 2] = -1;
 HEAP32[i19 >> 2] = 0;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i19, i35, i18);
 HEAP32[i20 >> 2] = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 28 >> 2] | 0, i27 | 0) | 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  i4 = 0;
  do {
   i2 = mftCall_iii(HEAP32[(HEAP32[i27 >> 2] | 0) + 32 >> 2] | 0, i27 | 0, i4 | 0) | 0;
   i2 = mftCall_iii(HEAP32[(HEAP32[i27 >> 2] | 0) + 52 >> 2] | 0, i27 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
    i35 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = i35 + 1;
    i18 = i1 + (i35 << 4) | 0;
    i17 = i18;
    HEAP8[i17 >> 0] = i2;
    HEAP8[i17 + 1 >> 0] = i2 >> 8;
    HEAP8[i17 + 2 >> 0] = i2 >> 16;
    HEAP8[i17 + 3 >> 0] = i2 >> 24;
    i18 = i18 + 4 | 0;
    HEAP8[i18 >> 0] = i3;
    HEAP8[i18 + 1 >> 0] = i3 >> 8;
    HEAP8[i18 + 2 >> 0] = i3 >> 16;
    HEAP8[i18 + 3 >> 0] = i3 >> 24;
    i35 = i1 + (i35 << 4) + 8 | 0;
    HEAP8[i35 >> 0] = i4;
    HEAP8[i35 + 1 >> 0] = i4 >> 8;
    HEAP8[i35 + 2 >> 0] = i4 >> 16;
    HEAP8[i35 + 3 >> 0] = i4 >> 24;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 28 >> 2] | 0, i27 | 0) | 0) >>> 0);
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = 0 - (HEAP32[i1 + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i2 | 0) | 0;
 if (i2) {
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i2 | 0);
  i1 = HEAP32[i29 >> 2] | 0;
 }
 i35 = HEAP32[i1 >> 2] | 0;
 i35 = mftCall_iiii(HEAP32[HEAP32[i35 >> 2] >> 2] | 0, i35 | 0, i20 | 0, 4) | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i35;
 i1 = HEAP32[i19 >> 2] | 0;
 i35 = HEAP32[i29 >> 2] | 0;
 i20 = HEAP32[i35 >> 2] | 0;
 i20 = mftCall_iiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i1 | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i20;
 i35 = HEAP32[i6 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i35 | 0) < 0 | (i35 & 2147483647 | 0) == 0))) {
  i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i1 | 0);
 }
 i8 = HEAP32[i30 + 92 >> 2] | 0;
 HEAP32[i21 + 8 >> 2] = -1;
 HEAP32[i22 >> 2] = 0;
 i13 = i22 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i22 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i22, i8, i21);
 HEAP32[i26 >> 2] = 0;
 i8 = i30 + 68 | 0;
 L40 : do if (!(HEAP32[i30 + 72 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i30 + 76 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L40;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i12 = HEAP32[i22 >> 2] | 0;
 i6 = i30 + 60 | 0;
 i7 = i30 + 64 | 0;
 i5 = i30 + 76 | 0;
 L47 : while (1) {
  do {
   if ((i1 | 0) == -1) break L47;
   i35 = HEAP32[i26 >> 2] | 0;
   HEAP32[i26 >> 2] = i35 + 1;
   i22 = HEAP32[i6 >> 2] | 0;
   i19 = HEAP32[i22 + (i1 * 12 | 0) >> 2] | 0;
   i20 = HEAP32[i22 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i22 = HEAP32[i22 + (i1 * 12 | 0) + 8 >> 2] | 0;
   i21 = i12 + (i35 * 12 | 0) | 0;
   HEAP8[i21 >> 0] = i19;
   HEAP8[i21 + 1 >> 0] = i19 >> 8;
   HEAP8[i21 + 2 >> 0] = i19 >> 16;
   HEAP8[i21 + 3 >> 0] = i19 >> 24;
   i21 = i12 + (i35 * 12 | 0) + 4 | 0;
   HEAP8[i21 >> 0] = i20;
   HEAP8[i21 + 1 >> 0] = i20 >> 8;
   HEAP8[i21 + 2 >> 0] = i20 >> 16;
   HEAP8[i21 + 3 >> 0] = i20 >> 24;
   i35 = i12 + (i35 * 12 | 0) + 8 | 0;
   HEAP8[i35 >> 0] = i22;
   HEAP8[i35 + 1 >> 0] = i22 >> 8;
   HEAP8[i35 + 2 >> 0] = i22 >> 16;
   HEAP8[i35 + 3 >> 0] = i22 >> 24;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L47;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L47;
  }
 }
 i9 = HEAP32[i30 + 132 >> 2] | 0;
 HEAP32[i23 + 8 >> 2] = -1;
 HEAP32[i24 >> 2] = 0;
 i10 = i24 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i24 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i24, i9, i23);
 HEAP32[i25 >> 2] = 0;
 i9 = i30 + 108 | 0;
 L57 : do if (!(HEAP32[i30 + 112 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i30 + 116 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L57;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i8 = HEAP32[i24 >> 2] | 0;
 i6 = i30 + 100 | 0;
 i7 = i30 + 104 | 0;
 i5 = i30 + 116 | 0;
 L64 : while (1) {
  do {
   if ((i1 | 0) == -1) break L64;
   i35 = HEAP32[i25 >> 2] | 0;
   HEAP32[i25 >> 2] = i35 + 1;
   i24 = HEAP32[i6 >> 2] | 0;
   i21 = HEAP32[i24 + (i1 * 12 | 0) >> 2] | 0;
   i22 = HEAP32[i24 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i24 = HEAP32[i24 + (i1 * 12 | 0) + 8 >> 2] | 0;
   i23 = i8 + (i35 * 12 | 0) | 0;
   HEAP8[i23 >> 0] = i21;
   HEAP8[i23 + 1 >> 0] = i21 >> 8;
   HEAP8[i23 + 2 >> 0] = i21 >> 16;
   HEAP8[i23 + 3 >> 0] = i21 >> 24;
   i23 = i8 + (i35 * 12 | 0) + 4 | 0;
   HEAP8[i23 >> 0] = i22;
   HEAP8[i23 + 1 >> 0] = i22 >> 8;
   HEAP8[i23 + 2 >> 0] = i22 >> 16;
   HEAP8[i23 + 3 >> 0] = i22 >> 24;
   i35 = i8 + (i35 * 12 | 0) + 8 | 0;
   HEAP8[i35 >> 0] = i24;
   HEAP8[i35 + 1 >> 0] = i24 >> 8;
   HEAP8[i35 + 2 >> 0] = i24 >> 16;
   HEAP8[i35 + 3 >> 0] = i24 >> 24;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L64;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L64;
  }
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = 0 - (HEAP32[i1 + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i2 | 0) | 0;
 if (i2) {
  mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i2 | 0);
  i1 = HEAP32[i29 >> 2] | 0;
 }
 i35 = HEAP32[i1 >> 2] | 0;
 i26 = mftCall_iiii(HEAP32[HEAP32[i35 >> 2] >> 2] | 0, i35 | 0, i26 | 0, 4) | 0;
 i35 = i1 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i26;
 i35 = HEAP32[i29 >> 2] | 0;
 i26 = HEAP32[i35 >> 2] | 0;
 i26 = mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i12 | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i26;
 i35 = HEAP32[i29 >> 2] | 0;
 i26 = HEAP32[i35 >> 2] | 0;
 i26 = mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i25 | 0, 4) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i26;
 i35 = HEAP32[i29 >> 2] | 0;
 i26 = HEAP32[i35 >> 2] | 0;
 i26 = mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i8 | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
 i35 = i35 + 4 | 0;
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i26;
 i35 = HEAP32[i11 >> 2] | 0;
 if (!((i8 | 0) == 0 | ((i35 | 0) < 0 | (i35 & 2147483647 | 0) == 0))) {
  i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i8 | 0);
 }
 i35 = HEAP32[i14 >> 2] | 0;
 if (!((i12 | 0) == 0 | ((i35 | 0) < 0 | (i35 & 2147483647 | 0) == 0))) {
  i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i12 | 0);
 }
 i1 = 0 - (HEAP32[(HEAP32[i29 >> 2] | 0) + 4 >> 2] | 0) & 15;
 _memset(i31 | 0, 0, i1 | 0) | 0;
 if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i1 | 0);
 i5 = HEAP32[i28 >> 2] | 0;
 if (i5 | 0) {
  i6 = i27 + 48 | 0;
  i4 = 0;
  do {
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 4) >> 2] | 0;
   i2 = mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, HEAP16[i1 + 4 >> 1] | 0) | 0;
   i3 = 0 - (HEAP32[(HEAP32[i29 >> 2] | 0) + 4 >> 2] | 0) & 15;
   _memset(i31 | 0, 0, i3 | 0) | 0;
   if (i3 | 0) mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i3 | 0);
   mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 | 0, i33 | 0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
  i1 = HEAP32[i28 >> 2] | 0;
  if (i1 | 0) {
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 4) >> 2] | 0;
    i3 = mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, HEAP16[i2 + 4 >> 1] | 0) | 0;
    i4 = 0 - (HEAP32[(HEAP32[i29 >> 2] | 0) + 4 >> 2] | 0) & 15;
    _memset(i31 | 0, 0, i4 | 0) | 0;
    if (i4 | 0) mftCall_viii(HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0, i33 | 0, i31 | 0, i4 | 0);
    mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0, i33 | 0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i1 | 0));
  }
 }
 __ZN5physx2Sn20SerializationContextD2Ev(i30);
 i35 = 1;
 STACKTOP = i34;
 return i35 | 0;
}

function __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i3, i48, i49, i1, i2, f50, i51) {
 i3 = i3 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f50 = Math_fround(f50);
 i51 = i51 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i53;
 i47 = HEAP32[i3 + 72 + (i1 << 2) >> 2] | 0;
 i46 = HEAP32[i3 + 72 + (i2 << 2) >> 2] | 0;
 i34 = i3 + 40 | 0;
 i35 = i34;
 i39 = HEAP32[i34 >> 2] | 0;
 i38 = i39 + i35 | 0;
 i1 = i38 + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 i8 = HEAP32[i1 + (i47 << 3) >> 2] | 0;
 i36 = i38 + 16 | 0;
 i1 = HEAP32[i1 + (i46 << 3) + 4 >> 2] | 0;
 i36 = i36 + (HEAP32[i36 >> 2] | 0) | 0;
 i7 = HEAP32[i36 + (i1 * 76 | 0) >> 2] | 0;
 i5 = HEAP32[i36 + (i1 * 76 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i36 + (i1 * 76 | 0) + 8 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i36 + (i1 * 76 | 0) + 12 >> 2]);
 i2 = HEAP32[i36 + (i1 * 76 | 0) + 16 >> 2] | 0;
 i3 = HEAP32[i36 + (i1 * 76 | 0) + 20 >> 2] | 0;
 i4 = HEAP32[i36 + (i1 * 76 | 0) + 24 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i36 + (i1 * 76 | 0) + 28 >> 2]);
 i1 = HEAP32[i36 + (i1 * 76 | 0) + 36 >> 2] | 0;
 i36 = i49 + 4 | 0;
 i37 = i36;
 i32 = (HEAP32[i36 >> 2] | 0) + i37 | 0;
 HEAP32[i32 + (i8 * 40 | 0) + 12 >> 2] = 0;
 HEAP32[i32 + (i8 * 40 | 0) + 16 >> 2] = 0;
 HEAP32[i32 + (i8 * 40 | 0) + 20 >> 2] = 0;
 HEAP32[i32 + (i8 * 40 | 0) + 24 >> 2] = 1065353216;
 __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i39 | 0) == 0 ? 0 : i38, i48, i49, i46, i47);
 i38 = i48 + 4 | 0;
 i39 = i38;
 i8 = HEAP32[i38 >> 2] | 0;
 i32 = i8 + i39 + (i47 * 40 | 0) + 12 | 0;
 HEAP32[i52 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i52 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 i32 = (HEAP32[i36 >> 2] | 0) + i37 | 0;
 i28 = HEAP32[i32 + (i46 * 40 | 0) + 12 >> 2] | 0;
 i30 = HEAP32[i32 + (i46 * 40 | 0) + 16 >> 2] | 0;
 i31 = HEAP32[i32 + (i46 * 40 | 0) + 20 >> 2] | 0;
 i32 = HEAP32[i32 + (i46 * 40 | 0) + 24 >> 2] | 0;
 if ((i51 | 0) <= 0) {
  STACKTOP = i53;
  return;
 }
 f40 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i7 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i26 = i1 & -2147483648;
 f27 = Math_fround(f50 * Math_fround(10.0));
 f25 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(360.0);
 i1 = 0;
 i2 = i8;
 while (1) {
  i5 = i2 + i39 | 0;
  i2 = i5 + (i46 * 40 | 0) + 16 | 0;
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(f40 * f12);
  i3 = i5 + (i46 * 40 | 0) + 24 | 0;
  f14 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(f29 * f14);
  i4 = i5 + (i46 * 40 | 0) + 20 | 0;
  f13 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(f41 * f13);
  i5 = i5 + (i46 * 40 | 0) + 12 | 0;
  f54 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f42 * f14)) - Math_fround(f29 * f13)) - Math_fround(f41 * f54));
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f40 * f54)) - Math_fround(f42 * f13)) - Math_fround(f41 * f12));
  f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f42 * f12)) - Math_fround(f40 * f14)) - Math_fround(f29 * f54));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f54) - Math_fround(f40 * f13)) - Math_fround(f41 * f14)) - Math_fround(f29 * f12));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f12 = (HEAP32[tempDoublePtr >> 2] = i7 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f43 * f12);
  f11 = Math_fround(f33 * f9);
  f14 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f44 * f14);
  f54 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f33 * f54)) - Math_fround(f44 * f9)) - Math_fround(f45 * f14));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f45 * f12)) - Math_fround(f44 * f54)) - Math_fround(f43 * f14));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f43 * f54)) - Math_fround(f33 * f12)) - Math_fround(f45 * f9));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f45 * f54) - Math_fround(f44 * f12)) - Math_fround(f33 * f14)) - Math_fround(f43 * f9));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f9 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f9 * f9);
  f10 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f10 * f10);
  f12 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f14 + f13)))));
  f11 = Math_fround(f13 * f11);
  f9 = Math_fround(Math_fround(f13 * f9) / f11);
  f10 = Math_fround(Math_fround(f13 * f10) / f11);
  f11 = Math_fround(Math_fround(f13 * f12) / f11);
  f12 = Math_fround(f9 * f9);
  f13 = Math_fround(f12 + Math_fround(1.0));
  f14 = Math_fround(Math_fround(f10 - Math_fround(f11 * f9)) / f13);
  f14 = Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(+Math_atan(+(HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) ^ i26, Math_fround(HEAPF32[tempDoublePtr >> 2])))) * Math_fround(2.0)))) * Math_fround(57.2957802));
  if (f14 < f50 | f14 < f27 & f14 > f15) {
   i1 = 6;
   break;
  }
  f11 = Math_fround(Math_fround(f11 + Math_fround(f10 * f9)) / f13);
  f54 = Math_fround(Math_fround(f9 * f11) + Math_fround(0.0));
  f11 = Math_fround(f11 - Math_fround(f9 * Math_fround(0.0)));
  f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(1.0)) + Math_fround(f12 + Math_fround(f54 * f54))))));
  f55 = Math_fround(f9 * f56);
  f54 = Math_fround(f54 * f56);
  f11 = Math_fround(f11 * f56);
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f54) - Math_fround(f23 * f56)) - Math_fround(f29 * f11)) - Math_fround(f24 * f55));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f29 * f56) - Math_fround(f25 * f55)) - Math_fround(f23 * f11)) - Math_fround(f24 * f54));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f11) - Math_fround(f23 * f54)) - Math_fround(f25 * f56)) - Math_fround(f29 * f55));
  f54 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f55) - Math_fround(f25 * f11)) - Math_fround(f24 * f56)) - Math_fround(f29 * f54));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f54 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f22 * f54);
  f12 = Math_fround(f33 * f9);
  f56 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f21 * f56);
  f55 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f33 * f55)) - Math_fround(f21 * f9)) - Math_fround(f16 * f56));
  f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f16 * f54)) - Math_fround(f21 * f55)) - Math_fround(f22 * f56));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f22 * f55)) - Math_fround(f33 * f54)) - Math_fround(f16 * f9));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f55) - Math_fround(f21 * f54)) - Math_fround(f33 * f56)) - Math_fround(f22 * f9));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f9 = (HEAP32[tempDoublePtr >> 2] = i7 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f9 * f9);
  f13 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = Math_fround(f13 * f13);
  f54 = (HEAP32[tempDoublePtr >> 2] = i6 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f54 * f54)) + Math_fround(f56 + f11)))));
  f13 = Math_fround(f11 * f13);
  f54 = Math_fround(f11 * f54);
  f12 = Math_fround(f11 * f12);
  HEAPF32[i5 >> 2] = Math_fround(f11 * f9);
  HEAPF32[i2 >> 2] = f13;
  HEAPF32[i4 >> 2] = f54;
  HEAPF32[i3 >> 2] = f12;
  i5 = HEAP32[i34 >> 2] | 0;
  __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i5 | 0) == 0 ? 0 : i5 + i35 | 0, i48, i49, i46, i46);
  i5 = (HEAP32[i36 >> 2] | 0) + i37 | 0;
  f12 = Math_fround(HEAPF32[i5 + (i46 * 40 | 0) + 24 >> 2]);
  f54 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i46 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f17 * f54);
  f9 = Math_fround(f18 * f12);
  f11 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i46 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = Math_fround(f19 * f11);
  f55 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i46 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f18 * f55)) - Math_fround(f19 * f12)) - Math_fround(f20 * f11));
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f20 * f54)) - Math_fround(f19 * f55)) - Math_fround(f17 * f11));
  f56 = Math_fround(Math_fround(Math_fround(f56 - Math_fround(f17 * f55)) - Math_fround(f18 * f54)) - Math_fround(f20 * f12));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f55) - Math_fround(f19 * f54)) - Math_fround(f18 * f11)) - Math_fround(f17 * f12));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAP32[i38 >> 2] | 0) + i39 | 0;
  i8 = i6 + (i47 * 40 | 0) + 12 | 0;
  f12 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f56 = Math_fround(HEAPF32[i8 >> 2]);
  f13 = Math_fround(f56 * f12);
  i7 = i6 + (i47 * 40 | 0) + 24 | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  f54 = Math_fround(f11 * f9);
  f55 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = i6 + (i47 * 40 | 0) + 16 | 0;
  f15 = Math_fround(HEAPF32[i5 >> 2]);
  f10 = Math_fround(f15 * f55);
  f57 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = i6 + (i47 * 40 | 0) + 20 | 0;
  f58 = Math_fround(HEAPF32[i6 >> 2]);
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f9 * f58)) - Math_fround(f11 * f55)) - Math_fround(f15 * f57));
  f54 = Math_fround(Math_fround(Math_fround(f54 - Math_fround(f56 * f57)) - Math_fround(f58 * f55)) - Math_fround(f15 * f12));
  f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f58 * f12)) - Math_fround(f56 * f9)) - Math_fround(f11 * f57));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f55)) - Math_fround(f9 * f15)) - Math_fround(f11 * f12));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f12 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f12 * f12);
  f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f13 * f13);
  f15 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f10 + f11) + Math_fround(Math_fround(f54 * f54) + Math_fround(f15 * f15))))));
  f13 = Math_fround(f11 * f13);
  f15 = Math_fround(f11 * f15);
  f54 = Math_fround(f11 * f54);
  HEAPF32[i8 >> 2] = Math_fround(f11 * f12);
  HEAPF32[i5 >> 2] = f13;
  HEAPF32[i6 >> 2] = f15;
  HEAPF32[i7 >> 2] = f54;
  i7 = HEAP32[i34 >> 2] | 0;
  __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i((i7 | 0) == 0 ? 0 : i7 + i35 | 0, i52, i8, i47);
  i8 = HEAP32[i34 >> 2] | 0;
  __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i8 | 0) == 0 ? 0 : i8 + i35 | 0, i48, i49, i46, i47);
  i8 = (HEAP32[i36 >> 2] | 0) + i37 | 0;
  HEAP32[i8 + (i46 * 40 | 0) + 12 >> 2] = i28;
  HEAP32[i8 + (i46 * 40 | 0) + 16 >> 2] = i30;
  HEAP32[i8 + (i46 * 40 | 0) + 20 >> 2] = i31;
  HEAP32[i8 + (i46 * 40 | 0) + 24 >> 2] = i32;
  i8 = HEAP32[i34 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i8 | 0) == 0 ? 0 : i8 + i35 | 0, i49, i48, i46, i46);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i51 | 0)) {
   i1 = 6;
   break;
  }
  f15 = f14;
  i2 = HEAP32[i38 >> 2] | 0;
 }
 if ((i1 | 0) == 6) {
  STACKTOP = i53;
  return;
 }
}

function __Z15UpdateLightsTplILb0EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem(i95, i96, i3, i106, i107, i108, i109, i110, i111, i112, i2) {
 i95 = i95 | 0;
 i96 = i96 | 0;
 i3 = i3 | 0;
 i106 = i106 | 0;
 i107 = i107 | 0;
 i108 = i108 | 0;
 i109 = i109 | 0;
 i110 = i110 | 0;
 i111 = i111 | 0;
 i112 = i112 | 0;
 i2 = i2 | 0;
 var i1 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i113 = 0, f114 = f0, f115 = f0, f116 = f0;
 i113 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i97 = i113 + 312 | 0;
 i98 = i113 + 248 | 0;
 i99 = i113 + 184 | 0;
 i100 = i113 + 64 | 0;
 i101 = i113 + 48 | 0;
 i102 = i113 + 32 | 0;
 i103 = i113 + 16 | 0;
 i104 = i113;
 i105 = i112 + 871 | 0;
 if (!(HEAP8[i105 >> 0] | 0)) i28 = 0; else {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
  if (!i1) i28 = 0; else i28 = (HEAP16[i1 + 340 >> 1] | 0) == 4;
 }
 i39 = HEAP32[i2 + 40 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i39 + 316 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i39 + 320 >> 2]));
 f7 = Math_fround(+Math_pow(+Math_fround(Math_abs(Math_fround(f7 * Math_fround(HEAPF32[i39 + 324 >> 2])))), .333333343));
 f29 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 f29 = f29 < f7 ? f7 : f29;
 i39 = HEAP32[i112 + 12 >> 2] | 0;
 if (!i39) {
  STACKTOP = i113;
  return;
 }
 i40 = i112 + 608 | 0;
 i41 = i96 + 4 | 0;
 i42 = i3 + 8 | 0;
 i43 = i3 + 52 | 0;
 i44 = i3 + 56 | 0;
 i45 = i3 + 60 | 0;
 i46 = i3 + 124 | 0;
 i47 = i3 + 128 | 0;
 i48 = i3 + 132 | 0;
 i49 = i3 + 136 | 0;
 i50 = i3 + 140 | 0;
 i51 = i3 + 144 | 0;
 i52 = i3 + 148 | 0;
 i53 = i3 + 152 | 0;
 i54 = i3 + 156 | 0;
 i55 = i3 + 188 | 0;
 i56 = i3 + 204 | 0;
 i57 = i3 + 208 | 0;
 i58 = i3 + 216 | 0;
 i59 = i112 + 20 | 0;
 i60 = i112 + 40 | 0;
 i61 = i111 + 16 | 0;
 i62 = i111 + 32 | 0;
 i63 = i111 + 48 | 0;
 i64 = i111 + 4 | 0;
 i65 = i111 + 20 | 0;
 i66 = i111 + 36 | 0;
 i67 = i111 + 52 | 0;
 i68 = i97 + 4 | 0;
 i69 = i111 + 8 | 0;
 i70 = i111 + 24 | 0;
 i71 = i111 + 40 | 0;
 i72 = i111 + 56 | 0;
 i73 = i97 + 8 | 0;
 i74 = i100 + 108 | 0;
 i75 = i100 + 104 | 0;
 i76 = i101 + 12 | 0;
 i77 = i101 + 8 | 0;
 i78 = i101 + 4 | 0;
 i79 = i112 + 500 | 0;
 i80 = i102 + 12 | 0;
 i81 = i102 + 8 | 0;
 i82 = i102 + 4 | 0;
 i83 = i109 + 84 | 0;
 i84 = i102 + 12 | 0;
 i85 = i102 + 8 | 0;
 i86 = i102 + 4 | 0;
 i87 = i110 + 84 | 0;
 i94 = i106 | i108;
 i88 = i100 + 96 | 0;
 i89 = i2 + 860 | 0;
 i90 = i2 + 900 | 0;
 i91 = i3 + 44 | 0;
 i92 = i102 + 3 | 0;
 i93 = i3 + 20 | 0;
 i30 = i3 + 24 | 0;
 i31 = i3 + 28 | 0;
 i32 = i3 + 32 | 0;
 i33 = i100 + 84 | 0;
 i34 = i102 + 4 | 0;
 i35 = i100 + 88 | 0;
 i36 = i102 + 8 | 0;
 i37 = i100 + 92 | 0;
 i38 = i2 + 852 | 0;
 i23 = i2 + 892 | 0;
 i24 = i3 + 40 | 0;
 i25 = i3 + 48 | 0;
 i26 = i3 + 36 | 0;
 i27 = i3 + 96 | 0;
 i22 = i3 + 92 | 0;
 i9 = i3 + 85 | 0;
 i10 = i110 + 80 | 0;
 i11 = i104 + 12 | 0;
 i12 = i104 + 8 | 0;
 i13 = i104 + 4 | 0;
 i14 = i110 + 232 | 0;
 i15 = i110 + 144 | 0;
 i16 = i109 + 80 | 0;
 i17 = i103 + 12 | 0;
 i18 = i103 + 8 | 0;
 i19 = i103 + 4 | 0;
 i20 = i109 + 232 | 0;
 i21 = i109 + 144 | 0;
 i8 = 0;
 do {
  if (HEAP32[(HEAP32[i40 >> 2] | 0) + (i8 >>> 5 << 2) >> 2] & 1 << (i8 & 31) | 0) {
   if ((HEAP32[i41 >> 2] | 0) == (i96 | 0)) {
    i6 = __ZnwjRK10MemLabelIdiPKci(352, gb + 63264 | 0, 16, gb + 613235 | 0, 50) | 0;
    HEAP32[i6 + 4 >> 2] = 1;
    HEAP32[i6 >> 2] = gb + 33936 + 8;
    i1 = i6 + 8 | 0;
    i2 = i42;
    i5 = i1 + 44 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    HEAP32[i6 + 52 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i6 + 56 >> 2] = HEAP32[i44 >> 2];
    i1 = i6 + 60 | 0;
    i2 = i45;
    i5 = i1 + 64 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    HEAP32[i6 + 124 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i6 + 128 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i6 + 132 >> 2] = HEAP32[i48 >> 2];
    HEAP32[i6 + 136 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i6 + 140 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i6 + 144 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i6 + 148 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i6 + 152 >> 2] = HEAP32[i53 >> 2];
    i1 = i6 + 156 | 0;
    HEAP32[i1 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i54 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i54 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i54 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i54 + 28 >> 2];
    i1 = i6 + 188 | 0;
    HEAP32[i1 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
    HEAP32[i6 + 204 >> 2] = HEAP32[i56 >> 2];
    __ZN19RenderEventsContextC2ERKS_(i6 + 208 | 0, i57);
    i1 = i6 + 216 | 0;
    i2 = i58;
    i5 = i1 + 128 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i5 | 0));
    i1 = i6 + 344 | 0;
    HEAP32[i1 >> 2] = 0;
    i2 = i6 + 348 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i6 >> 2] = gb + 80340 + 8;
    HEAP32[i6 + 16 >> 2] = __Z28AllocateNextLowestInstanceIDv() | 0;
    if ((i1 | 0) == (i95 | 0)) i3 = i6; else {
     i3 = HEAP32[i1 >> 2] | 0;
     if (i3 | 0) {
      HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i2 >> 2] = 0;
     }
     i3 = HEAP32[i95 >> 2] | 0;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i2 >> 2] = i95;
     HEAP32[i3 + 4 >> 2] = i1;
     HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
     i3 = i6;
    }
   } else {
    i2 = HEAP32[i96 >> 2] | 0;
    i3 = i2 + -344 | 0;
    if ((i2 | 0) != (i95 | 0)) {
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) i1 = i2 + 4 | 0; else {
      i6 = i2 + 4 | 0;
      HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i6 >> 2] = 0;
      i1 = i6;
     }
     i6 = HEAP32[i95 >> 2] | 0;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i1 >> 2] = i95;
     HEAP32[i6 + 4 >> 2] = i2;
     HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
    }
   }
   f114 = Math_fround(HEAPF32[(HEAP32[i112 >> 2] | 0) + (i8 << 2) >> 2]);
   f4 = Math_fround(HEAPF32[(HEAP32[i59 >> 2] | 0) + (i8 << 2) >> 2]);
   f7 = Math_fround(HEAPF32[(HEAP32[i60 >> 2] | 0) + (i8 << 2) >> 2]);
   f115 = Math_fround(f114 * Math_fround(HEAPF32[i111 >> 2]));
   f115 = Math_fround(f115 + Math_fround(f4 * Math_fround(HEAPF32[i61 >> 2])));
   f115 = Math_fround(f115 + Math_fround(f7 * Math_fround(HEAPF32[i62 >> 2])));
   HEAPF32[i97 >> 2] = Math_fround(Math_fround(HEAPF32[i63 >> 2]) + f115);
   f115 = Math_fround(f114 * Math_fround(HEAPF32[i64 >> 2]));
   f115 = Math_fround(f115 + Math_fround(f4 * Math_fround(HEAPF32[i65 >> 2])));
   f115 = Math_fround(f115 + Math_fround(f7 * Math_fround(HEAPF32[i66 >> 2])));
   HEAPF32[i68 >> 2] = Math_fround(Math_fround(HEAPF32[i67 >> 2]) + f115);
   f114 = Math_fround(f114 * Math_fround(HEAPF32[i69 >> 2]));
   f4 = Math_fround(f114 + Math_fround(f4 * Math_fround(HEAPF32[i70 >> 2])));
   f7 = Math_fround(f4 + Math_fround(f7 * Math_fround(HEAPF32[i71 >> 2])));
   HEAPF32[i73 >> 2] = Math_fround(Math_fround(HEAPF32[i72 >> 2]) + f7);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i98, i97) | 0;
   __Z25InvertMatrix4x4_General3DPKfPf(i98, i99) | 0;
   i1 = i3 + 216 | 0;
   i2 = i98;
   i5 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i5 | 0));
   i1 = i3 + 280 | 0;
   i2 = i99;
   i5 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i5 | 0));
   __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i112, i100, 1, i8);
   f4 = Math_fround(HEAPF32[i74 >> 2]);
   if (f4 != Math_fround(0.0)) f4 = Math_fround(Math_fround(f4 - Math_fround(HEAPF32[i75 >> 2])) / f4); else f4 = Math_fround(0.0);
   HEAPF32[i76 >> 2] = f4;
   HEAPF32[i77 >> 2] = f4;
   HEAPF32[i78 >> 2] = f4;
   HEAPF32[i101 >> 2] = f4;
   i6 = (HEAP32[(HEAP32[i79 >> 2] | 0) + (i8 << 2) >> 2] | 0) + -1432315862 | 0;
   i1 = (Math_imul(i6, 1790253981) | 0) + 1900727103 | 0;
   i6 = i6 << 11 ^ i6;
   f4 = Math_fround(Math_fround(((i1 ^ i6 ^ i6 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i80 >> 2] = f4;
   HEAPF32[i81 >> 2] = f4;
   HEAPF32[i82 >> 2] = f4;
   HEAPF32[i102 >> 2] = f4;
   i1 = HEAP32[i83 >> 2] | 0;
   L28 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i6 = HEAP32[i16 >> 2] | 0;
     HEAP32[i17 >> 2] = i6;
     HEAP32[i18 >> 2] = i6;
     HEAP32[i19 >> 2] = i6;
     HEAP32[i103 >> 2] = i6;
     break;
    }
   case 3:
    {
     f115 = Math_fround(HEAPF32[(HEAP32[i20 >> 2] | 0) + 4 >> 2]);
     f114 = Math_fround(HEAPF32[i16 >> 2]);
     f115 = Math_fround(f115 * f114);
     f115 = Math_fround(f115 + Math_fround(f4 * Math_fround(Math_fround(f114 * Math_fround(HEAPF32[(HEAP32[i21 >> 2] | 0) + 4 >> 2])) - f115)));
     HEAPF32[i103 >> 2] = f115;
     HEAPF32[i19 >> 2] = f115;
     HEAPF32[i18 >> 2] = f115;
     HEAPF32[i17 >> 2] = f115;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i103, i109, i101, i102);
     break L28;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i103, i109, i101, i102);
     break L28;
    }
   } while (0);
   f7 = Math_fround(f29 * Math_fround(HEAPF32[i103 >> 2]));
   i6 = (HEAP32[(HEAP32[i79 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 1532700938 | 0;
   i1 = (Math_imul(i6, 1790253981) | 0) + 1900727103 | 0;
   i6 = i6 << 11 ^ i6;
   f4 = Math_fround(Math_fround(((i1 ^ i6 ^ i6 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i84 >> 2] = f4;
   HEAPF32[i85 >> 2] = f4;
   HEAPF32[i86 >> 2] = f4;
   HEAPF32[i102 >> 2] = f4;
   i1 = HEAP32[i87 >> 2] | 0;
   L36 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i6 = HEAP32[i10 >> 2] | 0;
     HEAP32[i11 >> 2] = i6;
     HEAP32[i12 >> 2] = i6;
     HEAP32[i13 >> 2] = i6;
     HEAP32[i104 >> 2] = i6;
     break;
    }
   case 3:
    {
     f115 = Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 4 >> 2]);
     f114 = Math_fround(HEAPF32[i10 >> 2]);
     f115 = Math_fround(f115 * f114);
     f115 = Math_fround(f115 + Math_fround(f4 * Math_fround(Math_fround(f114 * Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2])) - f115)));
     HEAPF32[i104 >> 2] = f115;
     HEAPF32[i13 >> 2] = f115;
     HEAPF32[i12 >> 2] = f115;
     HEAPF32[i11 >> 2] = f115;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i104, i110, i101, i102);
     break L36;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i104, i110, i101, i102);
     break L36;
    }
   } while (0);
   f4 = Math_fround(HEAPF32[i104 >> 2]);
   if (i94) {
    HEAP32[i102 >> 2] = HEAP32[i88 >> 2];
    i1 = HEAP32[i89 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i1, i100, i102);
    i1 = HEAP32[i90 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i1, i100, i102);
    if (i106) {
     i6 = HEAP32[i102 >> 2] | 0;
     f116 = Math_fround(Math_fround((i6 & 65535) >>> 8 & 255) / Math_fround(255.0));
     f114 = Math_fround(Math_fround(i6 >>> 16 & 255) / Math_fround(255.0));
     f115 = Math_fround(Math_fround(i6 >>> 24 & 255) / Math_fround(255.0));
     HEAPF32[i3 + 20 >> 2] = Math_fround(Math_fround(i6 & 255) / Math_fround(255.0));
     HEAPF32[i3 + 24 >> 2] = f116;
     HEAPF32[i3 + 28 >> 2] = f114;
     HEAPF32[i3 + 32 >> 2] = f115;
    } else {
     i2 = HEAP32[i30 >> 2] | 0;
     i5 = HEAP32[i31 >> 2] | 0;
     i6 = HEAP32[i32 >> 2] | 0;
     HEAP32[i3 + 20 >> 2] = HEAP32[i93 >> 2];
     HEAP32[i3 + 24 >> 2] = i2;
     HEAP32[i3 + 28 >> 2] = i5;
     HEAP32[i3 + 32 >> 2] = i6;
    }
    f4 = Math_fround(f4 * Math_fround(HEAPF32[i91 >> 2]));
    if (i108) f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPU8[i92 >> 0] | 0)) / Math_fround(255.0));
    HEAPF32[i3 + 44 >> 2] = f4;
   } else {
    i2 = HEAP32[i30 >> 2] | 0;
    i5 = HEAP32[i31 >> 2] | 0;
    i6 = HEAP32[i32 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = HEAP32[i93 >> 2];
    HEAP32[i3 + 24 >> 2] = i2;
    HEAP32[i3 + 28 >> 2] = i5;
    HEAP32[i3 + 32 >> 2] = i6;
    HEAPF32[i3 + 44 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i91 >> 2]));
   }
   if (i107) {
    HEAP32[i102 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
    i1 = HEAP32[i38 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i1, i100, (HEAP8[i105 >> 0] | 0) != 0, i102);
    i1 = HEAP32[i23 >> 2] | 0;
    if (HEAP8[i1 + 4 >> 0] | 0) __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i1, i100, (HEAP8[i105 >> 0] | 0) != 0, i102);
    f4 = Math_fround(HEAPF32[i102 >> 2]);
    do if (HEAP8[i105 >> 0] | 0) {
     f4 = Math_fround(f4 * Math_fround(HEAPF32[i34 >> 2]));
     if (i28) {
      f4 = Math_fround(+Math_pow(+Math_fround(f4 * Math_fround(HEAPF32[i36 >> 2])), .333333343));
      HEAPF32[i102 >> 2] = f4;
      break;
     } else {
      f4 = Math_fround(Math_sqrt(Math_fround(f4)));
      HEAPF32[i102 >> 2] = f4;
      break;
     }
    } while (0);
    i1 = HEAP32[i24 >> 2] | 0;
    HEAPF32[i3 + 48 >> 2] = Math_fround(f7 * Math_fround(f4 * Math_fround(HEAPF32[((i1 | 0) == 3 ? i56 : i25) >> 2])));
   } else {
    i1 = HEAP32[i24 >> 2] | 0;
    HEAPF32[i3 + 48 >> 2] = Math_fround(f7 * Math_fround(HEAPF32[((i1 | 0) == 3 ? i56 : i25) >> 2]));
   }
   HEAP32[i3 + 40 >> 2] = i1;
   HEAP32[i3 + 36 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i3 + 60 >> 2] = HEAP32[i45 >> 2];
   i6 = i3 + 96 | 0;
   HEAP32[i6 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
   HEAP32[i6 + 24 >> 2] = HEAP32[i27 + 24 >> 2];
   HEAP32[i3 + 92 >> 2] = HEAP32[i22 >> 2];
   HEAP8[i3 + 85 >> 0] = HEAP8[i9 >> 0] | 0;
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i39 | 0));
 STACKTOP = i113;
 return;
}

function __ZN12TreeRenderer24InitializePrototypeInfosEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i28 + 32 | 0;
 i23 = i28 + 16 | 0;
 i24 = i28;
 i5 = HEAP32[i1 >> 2] | 0;
 i25 = i5 + 28 | 0;
 i26 = i1 + 364 | 0;
 i4 = HEAP32[i26 >> 2] | 0;
 i6 = i1 + 368 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) i2 = i4; else {
  do {
   i2 = i1 + -44 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -40 | 0;
   if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -36 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = HEAP32[i26 >> 2] | 0;
 }
 i21 = i5 + 32 | 0;
 i3 = ((HEAP32[i21 >> 2] | 0) - (HEAP32[i25 >> 2] | 0) | 0) / 156 | 0;
 i4 = (i1 - i2 | 0) / 44 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZNSt3__26vectorIN12TreeRenderer13PrototypeInfoE13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE8__appendEj(i26, i3 - i4 | 0); else if (i3 >>> 0 < i4 >>> 0) {
  i4 = i2 + (i3 * 44 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) do {
   i2 = i1 + -44 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -40 | 0;
   if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -36 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i25 >> 2] | 0;
 if ((HEAP32[i21 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i28;
  return;
 }
 i20 = 0;
 do {
  i19 = HEAP32[i26 >> 2] | 0;
  do if ((HEAP32[i1 + (i20 * 156 | 0) + 4 >> 2] | 0) == 2) {
   i4 = HEAP32[i1 + (i20 * 156 | 0) + 8 >> 2] | 0;
   if (!i4) i27 = 30; else {
    HEAP32[i23 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i27 = 24; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
      i2 = HEAP32[i22 >> 2] | 0;
      i18 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 24; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i27 = 26;
     }
    }
    if ((i27 | 0) == 24) i27 = 26;
    if ((i27 | 0) == 26) {
     i27 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
     if (!i1) {
      i1 = HEAP32[i25 >> 2] | 0;
      i27 = 30;
      break;
     }
    }
    i13 = i1 + 56 | 0;
    i14 = i1 + 60 | 0;
    if (((HEAP32[i14 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0) > 0) {
     i15 = i19 + (i20 * 44 | 0) + 4 | 0;
     i16 = i19 + (i20 * 44 | 0) + 16 | 0;
     i17 = i19 + (i20 * 44 | 0) + 20 | 0;
     i18 = i19 + (i20 * 44 | 0) + 8 | 0;
     i10 = 0;
     do {
      i2 = __ZNK8LODGroup6GetLODEi(i1, i10) | 0;
      i11 = 1 << i10;
      i12 = i2 + 20 | 0;
      if (HEAP32[i12 >> 2] | 0) {
       i9 = i2 + 8 | 0;
       i8 = 0;
       do {
        i6 = __Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E((HEAP32[i9 >> 2] | 0) + (i8 << 2) | 0) | 0;
        if (i6 | 0) {
         i7 = HEAP32[i16 >> 2] | 0;
         L51 : do if (!i7) i27 = 94; else {
          i4 = HEAP32[i15 >> 2] | 0;
          i5 = HEAP32[i6 + 4 >> 2] | 0;
          i3 = 0;
          while (1) {
           i2 = i4 + (i3 * 72 | 0) | 0;
           i3 = i3 + 1 | 0;
           if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) break;
           if (i3 >>> 0 >= i7 >>> 0) {
            i27 = 94;
            break L51;
           }
          }
          if (!i2) i27 = 94;
         } while (0);
         do if ((i27 | 0) == 94) {
          i27 = 0;
          i3 = i7 + 1 | 0;
          i4 = HEAP32[i17 >> 2] | 0;
          i5 = i4 & 2147483647;
          do if (i3 >>> 0 > i5 >>> 0) {
           i2 = i4 << 1;
           i2 = (i2 | 0) == 0 ? 1 : i2;
           if (i5 >>> 0 >= i2 >>> 0) break;
           if ((i4 | 0) > -1) {
            HEAP32[i17 >> 2] = i2;
            HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i2 * 72 | 0, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
            break;
           } else {
            i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 72 | 0, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
            _memcpy(i5 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 72 | 0) | 0;
            HEAP32[i17 >> 2] = i2;
            HEAP32[i15 >> 2] = i5;
            break;
           }
          } while (0);
          HEAP32[i16 >> 2] = i3;
          i3 = HEAP32[i15 >> 2] | 0;
          i2 = i3 + (i7 * 72 | 0) | 0;
          HEAP32[i2 >> 2] = HEAP32[i6 + 4 >> 2];
          HEAP32[i3 + (i7 * 72 | 0) + 68 >> 2] = 0;
          i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
          i3 = i3 + (i7 * 72 | 0) + 4 | 0;
          if (!i4) {
           i4 = gb + 1162292 | 0;
           i5 = i3 + 64 | 0;
           do {
            HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
            i3 = i3 + 4 | 0;
            i4 = i4 + 4 | 0;
           } while ((i3 | 0) < (i5 | 0));
           break;
          } else {
           __ZNK9Transform16GetLocalPositionEv(i22, i4);
           __ZNK9Transform16GetLocalRotationEv(i23, i4);
           __ZNK9Transform13GetLocalScaleEv(i24, i4);
           __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i3, i22, i23, i24);
           break;
          }
         } while (0);
         i7 = i2 + 68 | 0;
         HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i11;
        }
        i8 = i8 + 1 | 0;
       } while (i8 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
      }
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) < (((HEAP32[i14 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0) / 28 | 0 | 0));
    }
    i18 = HEAP32[i25 >> 2] | 0;
    i4 = HEAP32[i18 + (i20 * 156 | 0) + 8 >> 2] | 0;
    L73 : do if ((i4 | 0) == 0 ? 1 : (HEAP32[i18 + (i20 * 156 | 0) + 4 >> 2] | 0) != 2) i27 = 66; else {
     HEAP32[i23 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i27 = 48; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
       i2 = HEAP32[i22 >> 2] | 0;
       i18 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 48; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i27 = 50;
      }
     }
     if ((i27 | 0) == 48) i27 = 50;
     if ((i27 | 0) == 50) {
      i27 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
      if (!i1) {
       i27 = 66;
       break;
      }
     }
     i10 = i1 + 56 | 0;
     i11 = i1 + 60 | 0;
     if (((HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0) > 0) {
      i9 = 0;
      L87 : while (1) {
       i2 = __ZNK8LODGroup6GetLODEi(i1, i9) | 0;
       i8 = i2 + 20 | 0;
       L89 : do if (HEAP32[i8 >> 2] | 0) {
        i7 = i2 + 8 | 0;
        i6 = 0;
        while (1) {
         i5 = (HEAP32[i7 >> 2] | 0) + (i6 << 2) | 0;
         HEAP32[i23 >> 2] = HEAP32[i5 >> 2];
         i2 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i2) i27 = 61; else {
          if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
           i3 = HEAP32[i2 + 28 >> 2] | 0;
           i4 = HEAP32[i2 + 32 >> 2] | 0;
           i2 = i3 + (i4 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i2, i23);
           i3 = HEAP32[i22 >> 2] | 0;
           i18 = HEAP32[i2 + 28 >> 2] | 0;
           i4 = HEAP32[gb + 1104264 >> 2] | 0;
           i2 = (i3 | 0) == -1 ? i18 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i18 + (i3 << 3) | 0;
           i3 = HEAP32[i4 + 28 >> 2] | 0;
           i4 = HEAP32[i4 + 32 >> 2] | 0;
          }
          if ((i2 | 0) == (i3 + (i4 << 3) | 0)) {
           i27 = 61;
           break;
          }
          i2 = HEAP32[i2 + 4 >> 2] | 0;
          if (!i2) i27 = 63;
         } while (0);
         if ((i27 | 0) == 61) i27 = 63;
         if ((i27 | 0) == 63) {
          i27 = 0;
          i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
         }
         i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 184796 | 0) | 0;
         i6 = i6 + 1 | 0;
         if (i2 | 0) break;
         if (i6 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) break L89;
        }
        i2 = HEAP32[i2 + 32 >> 2] | 0;
        if (i2 | 0) break L87;
       } while (0);
       i9 = i9 + 1 | 0;
       if ((i9 | 0) >= (((HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0) / 28 | 0 | 0)) {
        i27 = 66;
        break L73;
       }
      }
      i4 = i19 + (i20 * 44 | 0) + 24 | 0;
      HEAP32[i4 >> 2] = i2;
      HEAP32[i23 >> 2] = i2;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i27 = 72; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
        i2 = HEAP32[i22 >> 2] | 0;
        i18 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 72; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i27 = 74;
       }
      }
      if ((i27 | 0) == 72) i27 = 74;
      if ((i27 | 0) == 74) {
       i27 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      }
     } else i27 = 66;
    } while (0);
    if ((i27 | 0) == 66) {
     i27 = 0;
     HEAP32[i19 + (i20 * 44 | 0) + 24 >> 2] = 0;
     i1 = 0;
    }
    HEAP32[i19 + (i20 * 44 | 0) + 28 >> 2] = i1;
    HEAP8[i19 + (i20 * 44 | 0) + 32 >> 0] = 1;
    i4 = (HEAP32[i25 >> 2] | 0) + (i20 * 156 | 0) + 12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    do if (!i1) i27 = 104; else {
     HEAP32[i23 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i27 = 82; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
       i2 = HEAP32[i22 >> 2] | 0;
       i18 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 82; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i27 = 84;
      }
     }
     if ((i27 | 0) == 82) i27 = 84;
     if ((i27 | 0) == 84) {
      i27 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) {
       i27 = 104;
       break;
      }
     }
     i1 = HEAP32[i1 + 344 >> 2] | 0;
     i4 = i19 + (i20 * 44 | 0) + 36 | 0;
     HEAP32[i4 >> 2] = i1;
     if (!i1) i1 = 0; else {
      HEAP32[i23 >> 2] = i1;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i27 = 111; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
        i2 = HEAP32[i22 >> 2] | 0;
        i18 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 111; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i27 = 113;
       }
      }
      if ((i27 | 0) == 111) i27 = 113;
      if ((i27 | 0) == 113) {
       i27 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      }
     }
    } while (0);
    if ((i27 | 0) == 104) {
     i27 = 0;
     HEAP32[i19 + (i20 * 44 | 0) + 36 >> 2] = 0;
     i1 = 0;
    }
    HEAP32[i19 + (i20 * 44 | 0) + 40 >> 2] = i1;
   }
  } else i27 = 30; while (0);
  if ((i27 | 0) == 30) {
   i27 = 0;
   if ((HEAP32[i1 + (i20 * 156 | 0) + 4 >> 2] | 0) == 1) {
    i4 = HEAP32[i1 + (i20 * 156 | 0) + 16 >> 2] | 0;
    if (!i4) i1 = 0; else {
     HEAP32[i23 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i27 = 37; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i22, i1, i23);
       i2 = HEAP32[i22 >> 2] | 0;
       i18 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i27 = 37; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i27 = 39;
      }
     }
     if ((i27 | 0) == 37) i27 = 39;
     if ((i27 | 0) == 39) {
      i27 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
     }
    }
   } else i1 = 0;
   HEAP32[i19 + (i20 * 44 | 0) >> 2] = i1;
  }
  i20 = i20 + 1 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
 } while (i20 >>> 0 < (((HEAP32[i21 >> 2] | 0) - i1 | 0) / 156 | 0) >>> 0);
 STACKTOP = i28;
 return;
}

function __Z16PackTextureAtlasP9Texture2DiiPS0_P5RectTIfEiNS_10EInitFlagsE(i37, i1, i39, i40, i21, i25, i22) {
 i37 = i37 | 0;
 i1 = i1 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 i21 = i21 | 0;
 i25 = i25 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i46 + 16 | 0;
 i42 = i46;
 i44 = i46 + 124 | 0;
 i43 = i46 + 112 | 0;
 i41 = i46 + 80 | 0;
 i38 = i46 + 60 | 0;
 i23 = i46 + 40 | 0;
 i24 = i46 + 20 | 0;
 i20 = (i1 | 0) < 8 ? 8 : i1;
 HEAP32[i44 >> 2] = 0;
 i45 = i44 + 4 | 0;
 HEAP32[i45 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 i15 = (i39 | 0) != 0;
 L1 : do if (i15) {
  __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE8__appendEj(i44, i39);
  i14 = (i39 | 0) > 0;
  if (i14) {
   i12 = 0;
   i4 = 1;
   i2 = 0;
   i1 = 0;
   i11 = 1;
   while (1) {
    i9 = HEAP32[i44 >> 2] | 0;
    i10 = i40 + (i12 << 2) | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i7 = i9 + (i12 << 3) | 0;
    HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0;
    i9 = i9 + (i12 << 3) + 4 | 0;
    HEAP32[i9 >> 2] = i3;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i5 | 0) > (i20 | 0) & (i5 | 0) > 4) {
     i4 = i5;
     do {
      i36 = i4;
      i4 = (i4 | 0) / 2 | 0;
     } while ((i4 | 0) > (i20 | 0) & (i36 | 0) > 9);
     HEAP32[i7 >> 2] = i4;
     i4 = 0;
    }
    if ((i3 | 0) > (i20 | 0) & (i3 | 0) > 4) {
     do {
      i36 = i3;
      i3 = (i3 | 0) / 2 | 0;
     } while ((i3 | 0) > (i20 | 0) & (i36 | 0) > 9);
     HEAP32[i9 >> 2] = i3;
     i4 = 0;
    }
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i5 + 52 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i5 + 92 >> 2] | 0;
     i3 = (i3 | 0) == -1 ? 5 : i3;
    } else i3 = HEAP32[i3 + 36 >> 2] | 0;
    switch (i3 | 0) {
    case 2:
    case 13:
     {
      i7 = i11;
      break;
     }
    default:
     i7 = 0;
    }
    switch (i3 | 0) {
    case 10:
    case 12:
     {
      i3 = (i4 | 0) == 1 & (i3 | 0) == 12 ? 2 : i4;
      break;
     }
    default:
     i3 = 0;
    }
    i36 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0;
    i1 = i1 | i36 ^ 1;
    i2 = i2 | i36;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i39 | 0)) {
     i19 = i2;
     break L1;
    } else {
     i4 = i3;
     i11 = i7;
    }
   }
  } else {
   i3 = 1;
   i19 = 0;
   i1 = 0;
   i7 = 1;
   i14 = 0;
  }
 } else {
  i3 = 1;
  i19 = 0;
  i1 = 0;
  i7 = 1;
  i14 = 0;
 } while (0);
 i4 = i1 & i19 ? 0 : i3;
 HEAP32[i43 >> 2] = 0;
 i36 = i43 + 4 | 0;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i43 + 8 >> 2] = 0;
 if (i15) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i43, i39);
  i2 = HEAP32[i43 >> 2] | 0;
 } else i2 = 0;
 if (i14) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i39 | 0));
  i35 = HEAP32[i36 >> 2] | 0;
  HEAP32[i42 >> 2] = i44;
  __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_(i2, i35, i42);
  if (i14) {
   i3 = HEAP32[i44 >> 2] | 0;
   i1 = 0;
   i2 = 0;
   do {
    i1 = (Math_imul(HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i3 + (i2 << 3) >> 2] | 0) | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i39 | 0));
  } else i1 = 0;
 } else {
  i1 = HEAP32[i36 >> 2] | 0;
  HEAP32[i42 >> 2] = i44;
  __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_(i2, i1, i42);
  i1 = 0;
 }
 i2 = (~~Math_fround(Math_sqrt(Math_fround(i1 | 0))) >>> 0) + -1 | 0;
 i2 = i2 >>> 16 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 2 | i2;
 i2 = (i2 >>> 1 | i2) + 1 | 0;
 i2 = (i20 | 0) < (i2 | 0) ? i20 : i2;
 i1 = ((i1 | 0) / (i2 | 0) | 0) + -1 | 0;
 i1 = i1 >>> 16 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = (i1 >>> 1 | i1) + 1 | 0;
 HEAP32[i42 >> 2] = 0;
 i35 = i42 + 4 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i42 + 8 >> 2] = 0;
 if (i15) __ZNSt3__26vectorIP4NodeNS_9allocatorIS2_EEE8__appendEj(i42, i39);
 i15 = i41 + 28 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 HEAP32[i41 + 16 >> 2] = 0;
 HEAP32[i41 + 20 >> 2] = 0;
 HEAP8[i41 + 24 >> 0] = 0;
 i17 = i41 + 4 | 0;
 i18 = i41 + 24 | 0;
 i11 = i41 + 16 | 0;
 i12 = i41 + 20 | 0;
 f13 = Math_fround(i25 | 0);
 i32 = i2;
 i31 = (i20 | 0) < (i1 | 0) ? i20 : i1;
 i3 = 0;
 i5 = i4;
 i1 = 0;
 while (1) {
  if (i1 | 0) {
   __ZN4NodeD2Ev(i1);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i17 >> 2] | 0;
  if (i1 | 0) {
   __ZN4NodeD2Ev(i1);
   __ZdlPv(i1);
  }
  HEAP8[i18 >> 0] = 0;
  HEAP32[i15 >> 2] = 0;
  f6 = Math_fround(i32 | 0);
  f8 = Math_fround(i31 | 0);
  HEAP32[i41 >> 2] = 0;
  HEAP32[i41 + 4 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  HEAP32[i41 + 12 >> 2] = 0;
  HEAPF32[i11 >> 2] = f6;
  HEAPF32[i12 >> 2] = f8;
  i4 = (i5 | 0) != 0;
  if (i14) {
   i1 = 1;
   i2 = 0;
  } else {
   i33 = 55;
   break;
  }
  do {
   i29 = HEAP32[(HEAP32[i43 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i30 = HEAP32[i44 >> 2] | 0;
   HEAPF32[i38 >> 2] = Math_fround(HEAP32[i30 + (i29 << 3) >> 2] | 0);
   HEAPF32[i23 >> 2] = Math_fround(HEAP32[i30 + (i29 << 3) + 4 >> 2] | 0);
   i30 = __ZN4Node6InsertERfS0_ffbb(i41, i38, i23, f13, f13, i4, 0) | 0;
   HEAP32[(HEAP32[i42 >> 2] | 0) + (i29 << 2) >> 2] = i30;
   i30 = (i30 | 0) != 0;
   i1 = i1 & i30;
   i2 = i2 + 1 | 0;
  } while (i30 & (i2 | 0) < (i39 | 0));
  if (i1) {
   i33 = 52;
   break;
  }
  i1 = (i32 | 0) == (i20 | 0);
  i2 = (i31 | 0) == (i20 | 0);
  do if (i2 & i1) {
   if (i14) {
    i2 = HEAP32[i44 >> 2] | 0;
    i1 = 0;
    do {
     i4 = i2 + (i1 << 3) | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((i5 | 0) > 4) {
      i9 = i2 + (i1 << 3) + 4 | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      if ((i10 | 0) > 4) {
       HEAP32[i4 >> 2] = (i5 * 3 | 0) / 4 | 0;
       HEAP32[i9 >> 2] = (i10 * 3 | 0) / 4 | 0;
      }
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i39 | 0));
   }
   i1 = i20;
   i2 = i20;
   i3 = i3 + 1 | 0;
   i4 = 0;
  } else {
   if (i1) {
    i1 = i20;
    i2 = i31 << 1;
    i4 = i5;
    break;
   }
   if (i2) {
    i1 = i32 << 1;
    i2 = i20;
    i4 = i5;
    break;
   }
   if ((i32 | 0) < (i31 | 0)) {
    i1 = i32 << 1;
    i2 = i31;
    i4 = i5;
    break;
   } else {
    i1 = i32;
    i2 = i31 << 1;
    i4 = i5;
    break;
   }
  } while (0);
  if ((i3 | 0) >= 100) {
   i4 = 0;
   break;
  }
  i32 = i1;
  i31 = i2;
  i5 = i4;
  i1 = HEAP32[i41 >> 2] | 0;
 }
 if ((i33 | 0) == 52) if (i14) {
  i2 = HEAP32[i43 >> 2] | 0;
  i3 = HEAP32[i44 >> 2] | 0;
  i4 = HEAP32[i42 >> 2] | 0;
  i1 = 0;
  do {
   i33 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i30 = HEAP32[i4 + (i33 << 2) >> 2] | 0;
   f13 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f48 = Math_fround(f13 / f6);
   f16 = Math_fround(HEAPF32[i30 + 12 >> 2]);
   f47 = Math_fround(f16 / f8);
   f13 = Math_fround(Math_fround(Math_fround(Math_fround(HEAP32[i3 + (i33 << 3) >> 2] | 0) + f13) / f6) - f48);
   f16 = Math_fround(Math_fround(Math_fround(Math_fround(HEAP32[i3 + (i33 << 3) + 4 >> 2] | 0) + f16) / f8) - f47);
   HEAPF32[i21 + (i33 << 4) >> 2] = f48;
   HEAPF32[i21 + (i33 << 4) + 4 >> 2] = f47;
   HEAPF32[i21 + (i33 << 4) + 8 >> 2] = f13;
   HEAPF32[i21 + (i33 << 4) + 12 >> 2] = f16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i39 | 0));
  i33 = 55;
 } else i33 = 55;
 do if ((i33 | 0) == 55) {
  L83 : do switch (i5 | 0) {
  case 1:
   {
    i30 = 10;
    break;
   }
  case 2:
   {
    i30 = 12;
    break;
   }
  default:
   {
    if (i7) {
     if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 173 >> 0] | 0) {
      i30 = 2;
      break L83;
     }
     if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 184 >> 0] | 0) {
      i30 = 13;
      break L83;
     }
    }
    i30 = 5;
   }
  } while (0);
  if (!(mftCall_iiiiiiiii(HEAP32[(HEAP32[i37 >> 2] | 0) + 188 >> 2] | 0, i37 | 0, i32 | 0, i31 | 0, i30 | 0, i19 & 1 | i22 | 0, 1, -1, 0) | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 391784 | 0, 0, gb + 391813 | 0, 617, 1, 0, 0, 0);
   i4 = 0;
   break;
  }
  __ZN9Texture2D18UnshareTextureDataEv(i37);
  i2 = i37 + 52 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i29 = 0; else i29 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i5) {
   __ZN9Texture2D18UnshareTextureDataEv(i37);
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i1 + 40 >> 2] | 0) | 0;
   _memset(i29 | 0, 0, i1 - i29 | 0) | 0;
   i20 = __ZNK9Texture2D16CountDataMipmapsEv(i37) | 0;
   if (!i14) {
    i4 = 1;
    break;
   }
   i18 = i24 + 4 | 0;
   i19 = i24 + 8 | 0;
   i1 = 0;
   i17 = 0;
   do {
    i15 = HEAP32[(HEAP32[i43 >> 2] | 0) + (i17 << 2) >> 2] | 0;
    i4 = HEAP32[i44 >> 2] | 0;
    i5 = HEAP32[i4 + (i15 << 3) >> 2] | 0;
    i4 = HEAP32[i4 + (i15 << 3) + 4 >> 2] | 0;
    i2 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i15 << 2) >> 2] | 0;
    f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
    f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
    i3 = ~~Math_fround(HEAPF32[i2 + 16 >> 2]) - i25 | 0;
    i3 = (i3 | 0) > 1 ? i3 : 1;
    i2 = ~~Math_fround(HEAPF32[i2 + 20 >> 2]) - i25 | 0;
    i2 = (i2 | 0) > 1 ? i2 : 1;
    i15 = i40 + (i15 << 2) | 0;
    i14 = __ZNK9Texture2D16CountDataMipmapsEv(HEAP32[i15 >> 2] | 0) | 0;
    i14 = (i20 | 0) < (i14 | 0) ? i20 : i14;
    if (i14) {
     i12 = 0;
     i11 = (i2 | 0) < (i4 | 0) ? i2 : i4;
     i10 = (i3 | 0) < (i5 | 0) ? i3 : i5;
     i9 = ~~f6;
     i7 = ~~f8;
     i3 = i5;
     while (1) {
      HEAP32[i38 >> 2] = 0;
      HEAP32[i38 + 4 >> 2] = 0;
      HEAP32[i38 + 8 >> 2] = 0;
      HEAP32[i38 + 12 >> 2] = 0;
      HEAP32[i38 + 16 >> 2] = 0;
      __ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i37, i38, 0, i12) | 0;
      __ZNK14ImageReference9ClipImageEiiii(i23, i38, i7, i9, i10, i11);
      HEAP32[i24 >> 2] = 0;
      HEAP32[i24 + 4 >> 2] = 0;
      HEAP32[i24 + 8 >> 2] = 0;
      HEAP32[i24 + 12 >> 2] = 0;
      HEAP32[i24 + 16 >> 2] = 0;
      if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(HEAP32[i15 >> 2] | 0, i24, 0, i12) | 0) {
       if ((i10 | 0) == (HEAP32[i18 >> 2] | 0)) i2 = (i11 | 0) == (HEAP32[i19 >> 2] | 0) ? 0 : 2; else i2 = 2;
       __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i23, i24, i2);
      } else {
       if (!i1) {
        i1 = __Znwj(20) | 0;
        __ZN5ImageC2Eii13TextureFormat(i1, i3, i4, 4);
       } else __ZN5Image8SetImageEii13TextureFormatb(i1, i3, i4, 4, 0);
       i34 = HEAP32[i15 >> 2] | 0;
       mftCall_iiiiii(HEAP32[(HEAP32[i34 >> 2] | 0) + 168 >> 2] | 0, i34 | 0, i1 | 0, 2, 1, 0) | 0;
       if ((i10 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) i2 = (i11 | 0) == (HEAP32[i1 + 8 >> 2] | 0) ? 0 : 2; else i2 = 2;
       __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i23, i1, i2);
      }
      i3 = (i3 | 0) / 2 | 0;
      i2 = (i4 | 0) / 2 | 0;
      i12 = i12 + 1 | 0;
      if ((i12 | 0) == (i14 | 0)) break; else {
       i11 = (i11 | 0) / 2 | 0;
       i10 = (i10 | 0) / 2 | 0;
       i9 = (i9 | 0) / 2 | 0;
       i7 = (i7 | 0) / 2 | 0;
       i4 = (i2 | 0) < 1 ? 1 : i2;
       i3 = (i3 | 0) < 1 ? 1 : i3;
      }
     }
    }
    i17 = i17 + 1 | 0;
   } while ((i17 | 0) != (i39 | 0));
   if (!i1) {
    i4 = 1;
    break;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63184 | 0);
   __ZdlPv(i1);
   i4 = 1;
   break;
  } else {
   i28 = (i30 | 0) == 10 ? 8 : 16;
   __ZN9Texture2D18UnshareTextureDataEv(i37);
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i1 + 40 >> 2] | 0) | 0;
   _memset(i29 | 0, 0, i1 - i29 | 0) | 0;
   if (!i14) {
    i4 = 1;
    break;
   }
   i25 = i38 + 11 | 0;
   i26 = (i30 | 0) == 12;
   i23 = 0;
   while (1) {
    i27 = HEAP32[(HEAP32[i43 >> 2] | 0) + (i23 << 2) >> 2] | 0;
    i3 = HEAP32[i44 >> 2] | 0;
    i4 = HEAP32[i3 + (i27 << 3) >> 2] | 0;
    i3 = HEAP32[i3 + (i27 << 3) + 4 >> 2] | 0;
    i1 = HEAP32[i40 + (i27 << 2) >> 2] | 0;
    i24 = __ZNK9Texture2D16CountDataMipmapsEv(i1) | 0;
    i5 = __ZNK9Texture2D16CountDataMipmapsEv(i37) | 0;
    i24 = (i5 | 0) < (i24 | 0) ? i5 : i24;
    i27 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i27 << 2) >> 2] | 0;
    f16 = Math_fround(HEAPF32[i27 + 8 >> 2]);
    f13 = Math_fround(HEAPF32[i27 + 12 >> 2]);
    f8 = Math_fround(HEAPF32[i27 + 16 >> 2]);
    f6 = Math_fround(HEAPF32[i27 + 20 >> 2]);
    i27 = i1 + 52 | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    L133 : do if (!i5) i33 = 104; else {
     i2 = HEAP32[i5 + 8 >> 2] | 0;
     if (!i2) i33 = 104; else if ((i24 | 0) > 0) {
      i22 = i1 + 92 | 0;
      i20 = 0;
      i17 = i31;
      i15 = i32;
      i21 = i29;
      i19 = ~~f6;
      i18 = ~~f8;
      i7 = ~~f13;
      i10 = ~~f16;
      i14 = i3;
      i9 = i4;
      i1 = i5;
      while (1) {
       i3 = i21 + (Math_imul(((Math_imul(i15, (i7 | 0) / 4 | 0) | 0) / 4 | 0) + ((i10 | 0) / 4 | 0) | 0, i28) | 0) | 0;
       if (!i1) {
        i1 = HEAP32[i22 >> 2] | 0;
        i1 = (i1 | 0) == -1 ? 5 : i1;
       } else i1 = HEAP32[i1 + 36 >> 2] | 0;
       do if ((i1 | 0) == (i30 | 0)) __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib(i30, i2, i9, i14, i3, i15, i17, 0); else {
        if (!(i26 & (i1 | 0) == 10)) break;
        __Z28BlitCopyCompressedDXT1ToDXT5PKhiiPhii(i2, i9, i14, i3, i15, i17);
       } while (0);
       i12 = __Z18CalculateImageSizeii13TextureFormat(i9, i14, i1) | 0;
       i11 = __Z18CalculateImageSizeii13TextureFormat(i15, i17, i30) | 0;
       i10 = (i10 | 0) / 2 | 0;
       i7 = (i7 | 0) / 2 | 0;
       i4 = (i15 | 0) / 2 | 0;
       i3 = (i17 | 0) / 2 | 0;
       i9 = (i9 | 0) / 2 | 0;
       i5 = (i14 | 0) / 2 | 0;
       if ((i7 | i10) & 3 | 0) break L133;
       i1 = i20 + 1 | 0;
       if (!((i18 | 0) > 7 & (i19 | 0) > 7 & (i1 | 0) < (i24 | 0))) break L133;
       i20 = i1;
       i2 = i2 + i12 | 0;
       i17 = (i3 | 0) < 4 ? 4 : i3;
       i15 = (i4 | 0) < 4 ? 4 : i4;
       i21 = i21 + i11 | 0;
       i19 = (i19 | 0) / 2 | 0;
       i18 = (i18 | 0) / 2 | 0;
       i14 = (i5 | 0) < 4 ? 4 : i5;
       i9 = (i9 | 0) < 4 ? 4 : i9;
       i1 = HEAP32[i27 >> 2] | 0;
      }
     }
    } while (0);
    if ((i33 | 0) == 104) {
     i33 = 0;
     HEAP32[i34 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     __Z6FormatPKcz(i38, gb + 391887 | 0, i34);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i25 >> 0] | 0) < 0 ? HEAP32[i38 >> 2] | 0 : i38, 0, gb + 391813 | 0, 772, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
    }
    i23 = i23 + 1 | 0;
    if ((i23 | 0) == (i39 | 0)) {
     i4 = 1;
     break;
    }
   }
  }
 } while (0);
 __ZN4NodeD2Ev(i41);
 i1 = HEAP32[i42 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i35 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i35 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i43 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i36 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i36 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i44 >> 2] | 0;
 if (!i1) {
  STACKTOP = i46;
  return i4 | 0;
 }
 i2 = HEAP32[i45 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i45 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 __ZdlPv(i1);
 STACKTOP = i46;
 return i4 | 0;
}

function __Z24DoMotionVectorRenderLoopR17RenderLoopContext(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i38 + 136 | 0;
 i36 = i38;
 i33 = i38 + 288 | 0;
 i8 = i38 + 272 | 0;
 i34 = i38 + 268 | 0;
 i9 = i38 + 264 | 0;
 i10 = i38 + 508 | 0;
 i11 = i38 + 504 | 0;
 i12 = i38 + 500 | 0;
 i35 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 6;
 i13 = i16 + 8 | 0;
 if ((HEAP32[(HEAP32[i13 >> 2] | 0) + 1072 >> 2] & 5 | 0) != 5) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 if (!(__Z21SupportsMotionVectorsv() | 0)) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 i4 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 5) | 0;
 if (!(HEAP32[i4 + 4 >> 2] | 0)) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 HEAP32[i36 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i37 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i32, i1, i36);
   i2 = HEAP32[i32 >> 2] | 0;
   i31 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i31 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i31 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i37 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i37 = 12;
  }
 }
 if ((i37 | 0) == 10) i37 = 12;
 if ((i37 | 0) == 12) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   HEAP32[gb + 1163232 >> 2] = i35;
   STACKTOP = i38;
   return;
  }
 }
 if (!(__ZNK6Shader11IsSupportedEv(i1) | 0)) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 i31 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[i31 >> 2] | 0) + (HEAP32[i31 + 48 >> 2] << 2) >> 2] | 0) + 20 >> 2] | 0) < 3) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(i4, gb + 1115140 | 0, 3);
 i7 = HEAP32[gb + 1115140 >> 2] | 0;
 if (!i7) {
  HEAP32[gb + 1163232 >> 2] = i35;
  STACKTOP = i38;
  return;
 }
 i14 = __ZN8Material25AcquireSharedMaterialDataEv(i7) | 0;
 i30 = i33 + 20 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = i30;
 i4 = i1 + 1176 | 0;
 i15 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i31 = i33 + 148 | 0;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
 i3 = i32;
 i4 = __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i1) | 0;
 i15 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i3 = __Z25GetUncheckedRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, i32 | 0, i2 | 0, i2 ^ 1 | 0);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i32, __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0, i36);
 i3 = i31;
 i4 = i36;
 i15 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i15 | 0));
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i2 = HEAP32[i4 + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 L35 : do if ((i2 | 0) > 0) {
  i6 = 0;
  while (1) {
   i5 = i1 + (i6 << 2) | 0;
   i3 = i6 + 1 | 0;
   if ((HEAP32[(HEAP32[i5 >> 2] | 0) + 696 >> 2] | 0) == 12) break;
   if ((i3 | 0) < (i2 | 0)) i6 = i3; else {
    i37 = 20;
    break L35;
   }
  }
  if ((i6 | 0) == -1) i37 = 20; else {
   i29 = i33 + 4 | 0;
   HEAP32[i29 >> 2] = i4;
   i28 = i33 + 8 | 0;
   HEAP32[i28 >> 2] = HEAP32[i5 >> 2];
   i27 = i33 + 12 | 0;
   HEAP32[i27 >> 2] = i6;
   HEAP32[i33 >> 2] = i14;
   i1 = HEAP32[i13 >> 2] | 0;
   i26 = HEAP32[i1 + 1144 >> 2] | 0;
   if (!i26) i37 = 24; else if ((HEAP32[i26 + 88 >> 2] | 0) > 1) i37 = 24; else {
    __ZNK6Camera24GetScreenViewportRectIntEv(i8, i1);
    i2 = 0;
    i3 = HEAP32[i26 + 80 >> 2] | 0;
    i1 = HEAP32[i26 + 84 >> 2] | 0;
   }
   if ((i37 | 0) == 24) {
    __ZNK6Camera24GetScreenViewportRectIntEv(i8, i1);
    i2 = 1;
    i3 = HEAP32[i8 + 8 >> 2] | 0;
    i1 = HEAP32[i8 + 12 >> 2] | 0;
   }
   i24 = __Z22GetRenderBufferManagerv() | 0;
   i24 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i24, i3, i1, i2 ? 2 : 0, 13, 0, 0, 0, 1) | 0;
   HEAP32[i34 >> 2] = i24;
   __ZN13RenderTexture6CreateEv(i24) | 0;
   __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[i16 + 1888 >> 2] | 0, 15, HEAP32[i34 >> 2] | 0);
   i24 = HEAP32[i34 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i24 + 128 >> 2];
   HEAP32[i10 >> 2] = HEAP32[(i2 ? i24 : i26) + 136 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i10 >> 2];
   __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i9, i32, i34, 0, -1, 0, 0) | 0;
   i24 = __Z12GetGfxDevicev() | 0;
   i18 = HEAP32[i13 >> 2] | 0;
   __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i36, __Z12GetGfxDevicev() | 0);
   __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i18)), i24);
   HEAP32[i11 >> 2] = HEAP32[gb + 1114984 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i11 >> 2];
   __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i7, i32, i30);
   HEAP32[i12 >> 2] = HEAP32[gb + 1114988 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i12 >> 2];
   __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i7, i32, i31);
   i23 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i7, i2 ? 2 : 1, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
   f39 = Math_fround(i3 | 0);
   f17 = Math_fround(i1 | 0);
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   HEAPF32[i32 + 8 >> 2] = f39;
   HEAPF32[i32 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i32 + 12 >> 2] = f17;
   __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i24, i18, i23, i32, Math_fround(__ZNK6Camera17GetProjectionNearEv(i18)), 0);
   __ZN27DeviceViewProjMatricesStateD2Ev(i36);
   i18 = __ZnwjRK10MemLabelIdiPKci(56, gb + 64024 | 0, 16, gb + 388055 | 0, 479) | 0;
   i23 = gb + 64024 | 0;
   i24 = HEAP32[i23 >> 2] | 0;
   i23 = HEAP32[i23 + 4 >> 2] | 0;
   i19 = i18 + 4 | 0;
   HEAP32[i19 >> 2] = 1;
   HEAP32[i18 >> 2] = gb + 36848 + 8;
   i6 = i18 + 8 | 0;
   HEAP32[i6 >> 2] = 0;
   i20 = i36;
   HEAP32[i20 >> 2] = i24;
   HEAP32[i20 + 4 >> 2] = i23;
   i20 = i18 + 12 | 0;
   HEAP32[i20 >> 2] = 0;
   i21 = i18 + 24 | 0;
   HEAP32[i21 >> 2] = 0;
   i4 = i18 + 28 | 0;
   HEAP32[i4 >> 2] = 0;
   i5 = i18 + 16 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i36);
   i3 = i32;
   i25 = HEAP32[i3 + 4 >> 2] | 0;
   i22 = i5;
   HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i22 + 4 >> 2] = i25;
   i22 = i36;
   HEAP32[i22 >> 2] = i24;
   HEAP32[i22 + 4 >> 2] = i23;
   i22 = i18 + 32 | 0;
   HEAP32[i22 >> 2] = 0;
   i23 = i18 + 44 | 0;
   HEAP32[i23 >> 2] = 0;
   i24 = i18 + 48 | 0;
   HEAP32[i24 >> 2] = 0;
   i25 = i18 + 36 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i36);
   i3 = i32;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i1 = i25;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = i2;
   HEAP32[i18 + 52 >> 2] = i14;
   HEAP32[i6 >> 2] = i16;
   i6 = HEAP32[i16 + 1840 >> 2] | 0;
   i1 = HEAP32[i16 + 1852 >> 2] << 5;
   i2 = i1 >> 5;
   HEAP32[i21 >> 2] = i2;
   i3 = HEAP32[i4 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i4 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i20 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 5 | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i20 >> 2] = i1;
    break;
   } else i1 = HEAP32[i20 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i6 | 0, HEAP32[i21 >> 2] << 5 | 0) | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   i2 = HEAP32[i24 >> 2] | 0;
   if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
    if ((i2 | 0) > -1) {
     HEAP32[i24 >> 2] = i1;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 212 | 0, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
    } else {
     i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 212 | 0, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i15 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i23 >> 2] | 0) * 212 | 0) | 0;
     HEAP32[i24 >> 2] = i1;
     HEAP32[i22 >> 2] = i15;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   if (i1 | 0) {
    i16 = HEAP32[i16 + 1832 >> 2] | 0;
    f17 = Math_fround(HEAPF32[gb + 62452 >> 2]);
    i14 = i32 + 64 | 0;
    i12 = 0;
    i13 = HEAP32[i20 >> 2] | 0;
    while (1) {
     i7 = HEAP32[i13 + 8 >> 2] | 0;
     i8 = HEAP32[i16 >> 2] | 0;
     i5 = i8 + (i7 * 360 | 0) + 232 | 0;
     i1 = HEAPU16[i5 >> 1] | HEAPU8[i5 + 2 >> 0] << 16;
     L65 : do if (i1 & 3072 | 0) {
      L67 : do if (!(i1 & 512)) {
       i3 = HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0;
       i3 = HEAP32[(HEAP32[i3 >> 2] | 0) + (HEAP32[i3 + 48 >> 2] << 2) >> 2] | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       i3 = HEAP32[i3 + 20 >> 2] | 0;
       L69 : do if ((i3 | 0) > 0) {
        i1 = 0;
        while (1) {
         i4 = i1 + 1 | 0;
         if ((HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 696 >> 2] | 0) == 12) break;
         if ((i4 | 0) < (i3 | 0)) i1 = i4; else break L69;
        }
        if ((i1 | 0) > -1) break L67;
       } while (0);
       if (!(__Z20CompareApproximatelyRK10Matrix4x4fS1_f(i8 + (i7 * 360 | 0) | 0, i8 + (i7 * 360 | 0) + 64 | 0, f17) | 0)) break;
       if (((HEAPU16[i5 >> 1] | HEAPU8[i5 + 2 >> 0] << 16) & 3072 | 0) != 2048) break L65;
      } while (0);
      i11 = HEAP32[i33 >> 2] | 0;
      i10 = HEAP32[i29 >> 2] | 0;
      i6 = HEAP32[i28 >> 2] | 0;
      i5 = HEAP32[i27 >> 2] | 0;
      i3 = i32;
      i4 = i30;
      i15 = i3 + 64 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i15 | 0));
      i3 = i36;
      i4 = i31;
      i15 = i3 + 64 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i15 | 0));
      i3 = i14;
      i4 = i8 + (i7 * 360 | 0) + 64 | 0;
      i15 = i3 + 64 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i15 | 0));
      i3 = HEAP32[(HEAP32[i8 + (i7 * 360 | 0) + 324 >> 2] | 0) + (HEAPU16[i13 + 18 >> 1] << 3) >> 2] | 0;
      i7 = HEAP32[i13 >> 2] | 0;
      i2 = HEAP32[i7 + 32 >> 2] | 0;
      i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      i2 = HEAP32[i2 + 20 >> 2] | 0;
      L77 : do if ((i2 | 0) > 0) {
       i9 = 0;
       while (1) {
        i8 = HEAP32[i1 + (i9 << 2) >> 2] | 0;
        i4 = i9 + 1 | 0;
        if ((HEAP32[i8 + 696 >> 2] | 0) == 12) break;
        if ((i4 | 0) < (i2 | 0)) i9 = i4; else break L77;
       }
       i15 = (i9 | 0) == -1;
       i11 = i15 ? i11 : i3;
       i10 = i15 ? i10 : i7;
       i6 = i15 ? i6 : i8;
       i5 = i15 ? i5 : i9;
      } while (0);
      i7 = HEAP32[i23 >> 2] | 0;
      i2 = i7 + 1 | 0;
      i3 = HEAP32[i24 >> 2] | 0;
      i4 = i3 & 2147483647;
      do if (i2 >>> 0 > i4 >>> 0) {
       i1 = i3 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i4 >>> 0 >= i1 >>> 0) break;
       if ((i3 | 0) > -1) {
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 212 | 0, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 212 | 0, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i15 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i23 >> 2] | 0) * 212 | 0) | 0;
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = i15;
        break;
       }
      } while (0);
      HEAP32[i23 >> 2] = i2;
      i1 = HEAP32[i22 >> 2] | 0;
      HEAP32[i1 + (i7 * 212 | 0) >> 2] = i11;
      HEAP32[i1 + (i7 * 212 | 0) + 4 >> 2] = i10;
      HEAP32[i1 + (i7 * 212 | 0) + 8 >> 2] = i6;
      HEAP32[i1 + (i7 * 212 | 0) + 12 >> 2] = i5;
      HEAP32[i1 + (i7 * 212 | 0) + 16 >> 2] = i12;
      i3 = i1 + (i7 * 212 | 0) + 20 | 0;
      i4 = i32;
      i15 = i3 + 128 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i15 | 0));
      i3 = i1 + (i7 * 212 | 0) + 148 | 0;
      i4 = i36;
      i15 = i3 + 64 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i15 | 0));
     } while (0);
     i13 = i13 + 32 | 0;
     if ((i13 | 0) == ((HEAP32[i20 >> 2] | 0) + (HEAP32[i21 >> 2] << 5) | 0)) break; else i12 = i12 + 1 | 0;
    }
   }
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   i30 = HEAP32[i22 >> 2] | 0;
   i31 = HEAP32[i23 >> 2] | 0;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i32 + 4 >> 2] = 0;
   i33 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
   HEAP32[i33 >> 2] = i30;
   HEAP32[i33 + 4 >> 2] = i30 + (i31 * 212 | 0);
   HEAP32[i33 + 8 >> 2] = (i31 * 212 | 0) / 212 | 0;
   HEAP32[i33 + 12 >> 2] = i18;
   HEAP8[i33 + 16 >> 0] = 1;
   HEAP32[i33 + 20 >> 2] = gb + 1114936;
   __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i36, fb + 3350 | 0, i33, i32, 0);
   __ZN22MotionVectorRenderLoop16PerformRenderingER8JobFence(i18, i36);
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
   if (!(HEAP32[i19 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i18, gb + 64024 | 0);
   }
   __Z21ClearFenceWithoutSyncR8JobFence(i36);
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i26, 0, -1, 0, 0);
   __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, gb + 1114996 | 0, HEAP32[i34 >> 2] | 0);
  }
 } else i37 = 20; while (0);
 if ((i37 | 0) == 20) {
  i37 = i14 + 4 | 0;
  HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + -1;
  if (!(HEAP32[i37 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 63288 | 0);
  }
 }
 HEAP32[gb + 1163232 >> 2] = i35;
 STACKTOP = i38;
 return;
}

function __ZN4Mesh8TransferI24GenerateTypeTreeTransferEEvRT_(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i18;
 i6 = i18 + 392 | 0;
 i8 = i18 + 368 | 0;
 i9 = i18 + 264 | 0;
 i10 = i18 + 248 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i16, i17);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i17, 8);
 i11 = i16 + 32 | 0;
 if ((HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i11 >> 2] | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i15 = i2 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i11 >> 2] = i1;
 }
 i13 = i16 + 44 | 0;
 i3 = (HEAP8[i13 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i16, 1);
 i5 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425727 | 0, i5, (HEAP32[i11 >> 2] | 0) + 128 | 0, 1);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1155204 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i14 = i6 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, gb + 426521 | 0, i6, 0);
 __ZN7SubMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 i14 = i16 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425739 | 0, gb + 425748 | 0, i14, 1);
 __ZN14BlendShapeData8TransferI24GenerateTypeTreeTransferEEvRT_(i14, i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425763 | 0, i5, (HEAP32[i11 >> 2] | 0) + 144 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, gb + 1034429 | 0, i6, 0);
 __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425774 | 0, i5, i16 + 144 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, i5, i6, 0);
 i14 = i17 + 16 | 0;
 i15 = i17 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425791 | 0, i5, i16 + 184 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 i5 = i16 + 40 | 0;
 i1 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425810 | 0, i1, i5, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425828 | 0, i4, i16 + 41 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425841 | 0, i4, i16 + 42 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425856 | 0, i4, i16 + 43 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i17);
 if (!(HEAP8[i5 >> 0] | 0)) i12 = 7; else if (!(HEAP32[i17 >> 2] & 16384)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i4 = i8 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i8 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
  i20 = i7;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i2 = i5;
  HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i2 + 4 >> 2] = i19;
  __ZN14VertexDataInfoC2Ev(i9);
  HEAP32[i10 >> 2] = 0;
  i2 = i10 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i19 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425870 | 0, i19, i10, 1);
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, i1, i6, 0);
  HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425884 | 0, i19, i8, 1);
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, gb + 426264 | 0, i6, 0);
  __ZN13BoneInfluence8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425923 | 0, gb + 442181 | 0, i9, 1);
  __ZN10VertexData8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   i20 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 14;
   HEAP32[i7 + 4 >> 2] = i20;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  __ZN10VertexDataD2Ev(i9);
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i5);
   HEAP32[i8 >> 2] = 0;
  }
 } else i12 = 7;
 if ((i12 | 0) == 7) {
  i20 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425870 | 0, i20, (HEAP32[i11 >> 2] | 0) + 112 | 0, 1);
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, i1, i6, 0);
  HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425884 | 0, i20, (HEAP32[i11 >> 2] | 0) + 164 | 0, 1);
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 1041891 | 0, gb + 426264 | 0, i6, 0);
  __ZN13BoneInfluence8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  i20 = (HEAP32[i11 >> 2] | 0) + 8 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425923 | 0, gb + 442181 | 0, i20, 1);
  __ZN10VertexData8TransferI24GenerateTypeTreeTransferEEvRT_(i20, i17);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 }
 i2 = i7 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP8[i7 + 12 >> 0] = 0;
 i4 = i7 + 44 | 0;
 i5 = i7 + 72 | 0;
 i6 = i7 + 92 | 0;
 i8 = i7 + 120 | 0;
 i9 = i7 + 140 | 0;
 i10 = i7 + 168 | 0;
 i12 = i7 + 188 | 0;
 i19 = i7 + 208 | 0;
 i20 = i7 + 228 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i5 + 16 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP8[i6 + 24 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP8[i8 + 16 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP8[i9 + 24 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i10 + 16 >> 0] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP8[i12 + 16 >> 0] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP8[i19 + 16 >> 0] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer5AlignEv(i17);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425936 | 0, gb + 425953 | 0, i7, 1);
 __ZN14CompressedMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i17);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 __ZN14CompressedMeshD2Ev(i7);
 if (i3) {
  i19 = i16 + 48 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425968 | 0, gb + 1034406 | 0, i19, 1);
  __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i19, gb + 1034411 | 0, 0);
  i19 = i16 + 60 | 0;
  __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i19, gb + 1034420 | 0, 0);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  i19 = i16 + 224 | 0;
  i20 = HEAP32[gb + 37040 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425980 | 0, i20, i19, 1);
  i19 = HEAP32[i14 >> 2] | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i20 = HEAP32[i15 >> 2] | 0;
  i20 = i19 + (i20 * 24 | 0) + 12 | 0;
  HEAP32[i20 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
  i20 = i16 + 204 | 0;
  __ZN17CollisionMeshData8TransferI24GenerateTypeTreeTransferEEvRT_R4Mesh(i20, i17, i16);
  STACKTOP = i18;
  return;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 8 | 0;
 i2 = HEAP16[i4 + 18 >> 1] | 0;
 if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
  i6 = 0;
  i8 = 0;
 } else {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   i8 = 1;
  } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
   i6 = 0;
   i8 = 1;
  } else {
   i2 = HEAP32[i4 + 16 >> 2] | 0;
   i6 = i1 + ((i2 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i8 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i2 = i2 >>> 16 & 65535;
  }
 }
 if ((i2 & 65535) < 1024 | (i2 & 255) != 2) i7 = 0; else {
  i1 = HEAP32[i4 + 100 >> 2] | 0;
  i3 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i3) i7 = 0; else if (!(HEAP8[i4 + 19 >> 0] | 0)) i7 = 0; else {
   i2 = HEAP32[i4 + 16 >> 2] | 0;
   i7 = i3 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + (i2 >>> 8 & 255)) | 0;
   i2 = i2 >>> 16 & 65535;
  }
 }
 if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
  i1 = 0;
  i5 = 0;
 } else {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i20 = HEAP16[i4 + 16 >> 1] | 0;
   i1 = i1 + (((i20 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i20 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if ((i6 | 0) != (i7 | 0)) {
  i4 = i1;
  i3 = i6;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
   i1 = i3 + i8 | 0;
   i2 = i4 + i5 | 0;
   if ((i1 | 0) == (i7 | 0)) break; else {
    i4 = i2;
    i3 = i1;
    i1 = i2;
   }
  }
 }
 HEAP8[i13 >> 0] = HEAP8[i13 >> 0] | 16;
 i19 = i16 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425968 | 0, gb + 1034406 | 0, i19, 1);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i19, gb + 1034411 | 0, 0);
 i19 = i16 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i19, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 i19 = i16 + 224 | 0;
 i20 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i17, gb + 425980 | 0, i20, i19, 1);
 i19 = HEAP32[i14 >> 2] | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i15 >> 2] | 0;
 i20 = i19 + (i20 * 24 | 0) + 12 | 0;
 HEAP32[i20 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i17);
 i20 = i16 + 204 | 0;
 __ZN17CollisionMeshData8TransferI24GenerateTypeTreeTransferEEvRT_R4Mesh(i20, i17, i16);
 STACKTOP = i18;
 return;
}

function __Z20InvertMatrix4x4_FullPKfPf(i1, i31) {
 i1 = i1 | 0;
 i31 = i31 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i32;
 i10 = i30 + 32 | 0;
 i29 = i30 + 64 | 0;
 i5 = i30 + 96 | 0;
 HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAPF32[i30 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i30 + 36 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i30 + 40 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i30 + 44 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAPF32[i30 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 48 >> 2] = Math_fround(0.0);
 i28 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i29 >> 2] = i28;
 HEAP32[i30 + 68 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i30 + 72 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i30 + 76 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAPF32[i30 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 80 >> 2] = Math_fround(0.0);
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i30 + 100 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i30 + 104 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i30 + 108 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAPF32[i30 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 116 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 112 >> 2] = Math_fround(0.0);
 f9 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 f3 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i28 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 i28 = (i6 ? f8 : f9) > (i28 ? f14 : f3);
 i6 = i28 ? i5 : i29;
 i5 = i28 ? i29 : i5;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i29 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 i28 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 i28 = (i29 ? f14 : f3) > (i28 ? f8 : f9);
 i29 = i28 ? i6 : i10;
 i6 = i28 ? i10 : i6;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 i10 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 f3 = Math_fround(HEAPF32[i30 >> 2]);
 i28 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 i28 = (i10 ? f8 : f9) > (i28 ? f14 : f3);
 i10 = i28 ? i30 : i29;
 i30 = i28 ? i29 : i30;
 f3 = Math_fround(HEAPF32[i30 >> 2]);
 if (f3 == Math_fround(0.0)) {
  i1 = i31;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 f8 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) / f3);
 f9 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) / f3);
 f4 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) / f3);
 i26 = i30 + 4 | 0;
 f3 = Math_fround(HEAPF32[i26 >> 2]);
 f14 = Math_fround(f8 * f3);
 i7 = i10 + 4 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f14);
 f14 = Math_fround(f9 * f3);
 i1 = i6 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f14);
 f3 = Math_fround(f4 * f3);
 i2 = i5 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 i27 = i30 + 8 | 0;
 f3 = Math_fround(HEAPF32[i27 >> 2]);
 f14 = Math_fround(f8 * f3);
 i28 = i10 + 8 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f14);
 f14 = Math_fround(f9 * f3);
 i28 = i6 + 8 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f14);
 f3 = Math_fround(f4 * f3);
 i28 = i5 + 8 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f3);
 i28 = i30 + 12 | 0;
 f3 = Math_fround(HEAPF32[i28 >> 2]);
 f14 = Math_fround(f8 * f3);
 i29 = i10 + 12 | 0;
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f14);
 f14 = Math_fround(f9 * f3);
 i29 = i6 + 12 | 0;
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f14);
 f3 = Math_fround(f4 * f3);
 i29 = i5 + 12 | 0;
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f3);
 i29 = i30 + 16 | 0;
 f3 = Math_fround(HEAPF32[i29 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i25 = i10 + 16 | 0;
  HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f14);
  f14 = Math_fround(f9 * f3);
  i25 = i6 + 16 | 0;
  HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i25 = i5 + 16 | 0;
  HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f14);
 }
 i25 = i30 + 20 | 0;
 f3 = Math_fround(HEAPF32[i25 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i24 = i10 + 20 | 0;
  HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
  f14 = Math_fround(f9 * f3);
  i24 = i6 + 20 | 0;
  HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i24 = i5 + 20 | 0;
  HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
 }
 i24 = i30 + 24 | 0;
 f3 = Math_fround(HEAPF32[i24 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i23 = i10 + 24 | 0;
  HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f14);
  f14 = Math_fround(f9 * f3);
  i23 = i6 + 24 | 0;
  HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i23 = i5 + 24 | 0;
  HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f14);
 }
 i23 = i30 + 28 | 0;
 f3 = Math_fround(HEAPF32[i23 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i22 = i10 + 28 | 0;
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f14);
  f14 = Math_fround(f9 * f3);
  i22 = i6 + 28 | 0;
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i22 = i5 + 28 | 0;
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f14);
 }
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i22 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 i11 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 i11 = (i22 ? f14 : f3) > (i11 ? f8 : f9);
 i22 = i11 ? i5 : i6;
 i11 = i11 ? i6 : i5;
 f9 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 i1 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 i6 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 i6 = (i1 ? f8 : f9) > (i6 ? f14 : f3);
 i1 = i6 ? i22 : i10;
 i6 = i6 ? i10 : i22;
 i22 = i1 + 4 | 0;
 f3 = Math_fround(HEAPF32[i22 >> 2]);
 if (f3 == Math_fround(0.0)) {
  i1 = i31;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 f8 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) / f3);
 f4 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) / f3);
 i19 = i1 + 8 | 0;
 f3 = Math_fround(f8 * Math_fround(HEAPF32[i19 >> 2]));
 i2 = i6 + 8 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 f3 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 i5 = i11 + 8 | 0;
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3);
 i20 = i1 + 12 | 0;
 f3 = Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2]));
 i21 = i6 + 12 | 0;
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f3);
 f3 = Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2]));
 i21 = i11 + 12 | 0;
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f3);
 i21 = i1 + 16 | 0;
 f3 = Math_fround(HEAPF32[i21 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i18 = i6 + 16 | 0;
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i18 = i11 + 16 | 0;
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f14);
 }
 i18 = i1 + 20 | 0;
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i17 = i6 + 20 | 0;
  HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i17 = i11 + 20 | 0;
  HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f14);
 }
 i17 = i1 + 24 | 0;
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i16 = i6 + 24 | 0;
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i16 = i11 + 24 | 0;
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f14);
 }
 i16 = i1 + 28 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 if (f3 != Math_fround(0.0)) {
  f14 = Math_fround(f8 * f3);
  i15 = i6 + 28 | 0;
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f14);
  f14 = Math_fround(f4 * f3);
  i15 = i11 + 28 | 0;
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f14);
 }
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 i15 = f9 < Math_fround(0.0);
 f8 = Math_fround(-f9);
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i1 = f3 < Math_fround(0.0);
 f14 = Math_fround(-f3);
 i1 = (i15 ? f8 : f9) > (i1 ? f14 : f3);
 i2 = i1 ? i11 : i6;
 i1 = i1 ? i6 : i11;
 i15 = i2 + 8 | 0;
 f3 = Math_fround(HEAPF32[i15 >> 2]);
 if (f3 == Math_fround(0.0)) {
  i1 = i31;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f3);
 i5 = i2 + 12 | 0;
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 i6 = i1 + 12 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f4);
 HEAPF32[i6 >> 2] = f4;
 i6 = i2 + 16 | 0;
 f8 = Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]));
 i7 = i1 + 16 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 HEAPF32[i7 >> 2] = f8;
 i10 = i2 + 20 | 0;
 f9 = Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2]));
 i11 = i1 + 20 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f9);
 HEAPF32[i11 >> 2] = f9;
 i12 = i2 + 24 | 0;
 f14 = Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]));
 i13 = i1 + 24 | 0;
 f14 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f14);
 HEAPF32[i13 >> 2] = f14;
 i2 = i2 + 28 | 0;
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 i1 = i1 + 28 | 0;
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 HEAPF32[i1 >> 2] = f3;
 if (f4 == Math_fround(0.0)) {
  i1 = i31;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 } else {
  f4 = Math_fround(Math_fround(1.0) / f4);
  f8 = Math_fround(f4 * f8);
  HEAPF32[i7 >> 2] = f8;
  HEAPF32[i11 >> 2] = Math_fround(f4 * f9);
  HEAPF32[i13 >> 2] = Math_fround(f4 * f14);
  HEAPF32[i1 >> 2] = Math_fround(f4 * f3);
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  f4 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i15 >> 2]));
  HEAPF32[i6 >> 2] = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i6 >> 2]) - Math_fround(f3 * f8)));
  f8 = Math_fround(HEAPF32[i10 >> 2]);
  HEAPF32[i10 >> 2] = Math_fround(f4 * Math_fround(f8 - Math_fround(f3 * Math_fround(HEAPF32[i11 >> 2]))));
  f8 = Math_fround(HEAPF32[i12 >> 2]);
  HEAPF32[i12 >> 2] = Math_fround(f4 * Math_fround(f8 - Math_fround(f3 * Math_fround(HEAPF32[i13 >> 2]))));
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(f4 * Math_fround(f8 - Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]))));
  f3 = Math_fround(HEAPF32[i20 >> 2]);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f8);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i11 >> 2]));
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f8);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f8);
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f3);
  f3 = Math_fround(HEAPF32[i28 >> 2]);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f8);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i11 >> 2]));
  HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f8);
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f8);
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f3);
  f3 = Math_fround(HEAPF32[i19 >> 2]);
  f8 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i22 >> 2]));
  f4 = Math_fround(HEAPF32[i21 >> 2]);
  HEAPF32[i21 >> 2] = Math_fround(f8 * Math_fround(f4 - Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]))));
  f4 = Math_fround(HEAPF32[i18 >> 2]);
  HEAPF32[i18 >> 2] = Math_fround(f8 * Math_fround(f4 - Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2]))));
  f4 = Math_fround(HEAPF32[i17 >> 2]);
  HEAPF32[i17 >> 2] = Math_fround(f8 * Math_fround(f4 - Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]))));
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i16 >> 2] = Math_fround(f8 * Math_fround(f4 - Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]))));
  f3 = Math_fround(HEAPF32[i27 >> 2]);
  f4 = Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]));
  f4 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f4);
  HEAPF32[i29 >> 2] = f4;
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2]));
  f8 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f8);
  HEAPF32[i25 >> 2] = f8;
  f9 = Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]));
  f9 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f9);
  HEAPF32[i24 >> 2] = f9;
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
  f3 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f3);
  HEAPF32[i23 >> 2] = f3;
  f14 = Math_fround(HEAPF32[i26 >> 2]);
  f33 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i30 >> 2]));
  f4 = Math_fround(f33 * Math_fround(f4 - Math_fround(f14 * Math_fround(HEAPF32[i21 >> 2]))));
  HEAPF32[i29 >> 2] = f4;
  f8 = Math_fround(f33 * Math_fround(f8 - Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2]))));
  HEAPF32[i25 >> 2] = f8;
  f9 = Math_fround(f33 * Math_fround(f9 - Math_fround(f14 * Math_fround(HEAPF32[i17 >> 2]))));
  HEAPF32[i24 >> 2] = f9;
  f14 = Math_fround(f33 * Math_fround(f3 - Math_fround(f14 * Math_fround(HEAPF32[i16 >> 2]))));
  HEAPF32[i23 >> 2] = f14;
  HEAPF32[i31 >> 2] = f4;
  HEAPF32[i31 + 16 >> 2] = f8;
  HEAPF32[i31 + 32 >> 2] = f9;
  HEAPF32[i31 + 48 >> 2] = f14;
  HEAP32[i31 + 4 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i31 + 20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i31 + 36 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i31 + 52 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i31 + 24 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i31 + 40 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i31 + 56 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i31 + 28 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i31 + 44 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i31 + 60 >> 2] = HEAP32[i1 >> 2];
  i31 = 1;
  STACKTOP = i32;
  return i31 | 0;
 }
 return 0;
}

function __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i19 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 i17 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = HEAP32[i2 + 8 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i15 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i19 + 34236 >> 2] | 0;
 if (i1 | 0) {
  i2 = i19 + 34268 | 0;
  f11 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i21 = f11 > Math_fround(HEAPF32[i19 + 34372 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i20 = f11 > Math_fround(HEAPF32[i19 + 34376 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i3 = f11 > Math_fround(HEAPF32[i19 + 34380 >> 2]);
  i12 = Math_fround(HEAPF32[i19 + 34384 >> 2]) < Math_fround(1.0);
  f11 = Math_fround(HEAPF32[i19 + 34356 >> 2]);
  i5 = f11 > (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(HEAPF32[i19 + 34360 >> 2]);
  i6 = f11 > (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(HEAPF32[i19 + 34364 >> 2]);
  i7 = f11 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = i21 | i5;
  i6 = i20 | i6;
  i7 = i3 | i7;
  i12 = i12 | Math_fround(HEAPF32[i19 + 34368 >> 2]) > Math_fround(1.0);
  if ((i1 | 0) > 3) {
   i3 = i1 + -4 | 0;
   f11 = Math_fround(0.0);
   f10 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   while (1) {
    i31 = HEAP32[i2 >> 2] | 0;
    i30 = HEAP32[i2 + 4 >> 2] | 0;
    i29 = HEAP32[i2 + 8 >> 2] | 0;
    i21 = HEAP32[i2 + 12 >> 2] | 0;
    i32 = HEAP32[i19 + 33872 + (i31 << 4) >> 2] | 0;
    i20 = HEAP32[i19 + 33872 + (i31 << 4) + 4 >> 2] | 0;
    i28 = HEAP32[i19 + 33872 + (i31 << 4) + 8 >> 2] | 0;
    f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i32 | i32 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i31 << 4) >> 2]));
    f25 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i20 | i20 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = Math_fround(f25 * Math_fround(HEAPF32[i19 + 33520 + (i31 << 4) + 4 >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i28 | i28 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f23 * Math_fround(HEAPF32[i19 + 33520 + (i31 << 4) + 8 >> 2]));
    f25 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i31 << 4) + 12 >> 2]) + Math_fround(f23 + Math_fround(f26 + f25)));
    i31 = HEAP32[i19 + 33872 + (i30 << 4) >> 2] | 0;
    i28 = HEAP32[i19 + 33872 + (i30 << 4) + 4 >> 2] | 0;
    i20 = HEAP32[i19 + 33872 + (i30 << 4) + 8 >> 2] | 0;
    f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i31 | i31 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i30 << 4) >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i28 | i28 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f23 * Math_fround(HEAPF32[i19 + 33520 + (i30 << 4) + 4 >> 2]));
    f24 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i20 | i20 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f24 = Math_fround(f24 * Math_fround(HEAPF32[i19 + 33520 + (i30 << 4) + 8 >> 2]));
    f23 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i30 << 4) + 12 >> 2]) + Math_fround(f24 + Math_fround(f26 + f23)));
    i30 = HEAP32[i19 + 33872 + (i29 << 4) >> 2] | 0;
    i20 = HEAP32[i19 + 33872 + (i29 << 4) + 4 >> 2] | 0;
    i28 = HEAP32[i19 + 33872 + (i29 << 4) + 8 >> 2] | 0;
    f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i30 | i30 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i29 << 4) >> 2]));
    f24 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i20 | i20 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f24 = Math_fround(f24 * Math_fround(HEAPF32[i19 + 33520 + (i29 << 4) + 4 >> 2]));
    f22 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i28 | i28 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f22 = Math_fround(f22 * Math_fround(HEAPF32[i19 + 33520 + (i29 << 4) + 8 >> 2]));
    f24 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i29 << 4) + 12 >> 2]) + Math_fround(f22 + Math_fround(f26 + f24)));
    i29 = HEAP32[i19 + 33872 + (i21 << 4) >> 2] | 0;
    i28 = HEAP32[i19 + 33872 + (i21 << 4) + 4 >> 2] | 0;
    i20 = HEAP32[i19 + 33872 + (i21 << 4) + 8 >> 2] | 0;
    f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i29 | i29 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i21 << 4) >> 2]));
    f22 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i28 | i28 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f22 = Math_fround(f22 * Math_fround(HEAPF32[i19 + 33520 + (i21 << 4) + 4 >> 2]));
    f27 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i20 | i20 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f27 = Math_fround(f27 * Math_fround(HEAPF32[i19 + 33520 + (i21 << 4) + 8 >> 2]));
    f22 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i21 << 4) + 12 >> 2]) + Math_fround(f27 + Math_fround(f26 + f22)));
    f23 = f25 <= f23 ? f25 : f23;
    f22 = f24 <= f22 ? f24 : f22;
    f22 = f23 <= f22 ? f23 : f22;
    f11 = f11 <= f22 ? f11 : f22;
    f10 = f10 <= f22 ? f10 : f22;
    f9 = f9 <= f22 ? f9 : f22;
    f8 = f8 <= f22 ? f8 : f22;
    i1 = i1 + -4 | 0;
    if ((i1 | 0) <= 3) break; else i2 = i2 + 16 | 0;
   }
   i2 = i3 & -4;
   i1 = i3 - i2 | 0;
   i2 = i19 + 34268 + (i2 + 4 << 2) | 0;
  } else {
   f11 = Math_fround(0.0);
   f10 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  }
  switch (i1 | 0) {
  case 3:
   {
    i18 = HEAP32[i2 >> 2] | 0;
    i30 = HEAP32[i19 + 33872 + (i18 << 4) >> 2] | 0;
    i31 = HEAP32[i19 + 33872 + (i18 << 4) + 4 >> 2] | 0;
    i32 = HEAP32[i19 + 33872 + (i18 << 4) + 8 >> 2] | 0;
    f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17 & ~i30 | i30 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i19 + 33520 + (i18 << 4) >> 2]));
    f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 & ~i31 | i31 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i19 + 33520 + (i18 << 4) + 4 >> 2]));
    f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 & ~i32 | i32 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i19 + 33520 + (i18 << 4) + 8 >> 2]));
    f27 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i18 << 4) + 12 >> 2]) + Math_fround(f25 + Math_fround(f26 + f27)));
    i2 = i2 + 4 | 0;
    f11 = f11 <= f27 ? f11 : f27;
    f10 = f10 <= f27 ? f10 : f27;
    f9 = f9 <= f27 ? f9 : f27;
    f8 = f8 <= f27 ? f8 : f27;
    i18 = 8;
    break;
   }
  case 2:
   {
    i18 = 8;
    break;
   }
  case 1:
   {
    i18 = 9;
    break;
   }
  default:
   {}
  }
  if ((i18 | 0) == 8) {
   i32 = HEAP32[i2 >> 2] | 0;
   i29 = HEAP32[i19 + 33872 + (i32 << 4) >> 2] | 0;
   i30 = HEAP32[i19 + 33872 + (i32 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i19 + 33872 + (i32 << 4) + 8 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i29 | i29 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i30 | i30 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 4 >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i31 | i31 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 8 >> 2]));
   f27 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 12 >> 2]) + Math_fround(f25 + Math_fround(f26 + f27)));
   i2 = i2 + 4 | 0;
   f11 = f11 <= f27 ? f11 : f27;
   f10 = f10 <= f27 ? f10 : f27;
   f9 = f9 <= f27 ? f9 : f27;
   f8 = f8 <= f27 ? f8 : f27;
   i18 = 9;
  }
  if ((i18 | 0) == 9) {
   i32 = HEAP32[i2 >> 2] | 0;
   i29 = HEAP32[i19 + 33872 + (i32 << 4) >> 2] | 0;
   i30 = HEAP32[i19 + 33872 + (i32 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i19 + 33872 + (i32 << 4) + 8 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i29 | i29 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i30 | i30 & i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 4 >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i31 | i31 & i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 8 >> 2]));
   f27 = Math_fround(Math_fround(HEAPF32[i19 + 33520 + (i32 << 4) + 12 >> 2]) + Math_fround(f25 + Math_fround(f26 + f27)));
   f11 = f11 <= f27 ? f11 : f27;
   f10 = f10 <= f27 ? f10 : f27;
   f9 = f9 <= f27 ? f9 : f27;
   f8 = f8 <= f27 ? f8 : f27;
  }
  if (i5 | f11 < Math_fround(0.0) | (i6 | f10 < Math_fround(0.0)) | (i7 | f9 < Math_fround(0.0)) | (i12 | f8 < Math_fround(0.0))) {
   i32 = 0;
   return i32 | 0;
  }
 }
 if (!(HEAP8[i19 + 34472 >> 0] | 0)) {
  i32 = 1;
  return i32 | 0;
 }
 f44 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(HEAPF32[i19 + 64 >> 2]);
 f40 = Math_fround(HEAPF32[i19 + 68 >> 2]);
 f33 = Math_fround(HEAPF32[i19 + 72 >> 2]);
 f38 = Math_fround(HEAPF32[i19 + 80 >> 2]);
 f36 = Math_fround(HEAPF32[i19 + 84 >> 2]);
 f26 = Math_fround(HEAPF32[i19 + 88 >> 2]);
 f34 = Math_fround(HEAPF32[i19 + 96 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 100 >> 2]);
 f23 = Math_fround(HEAPF32[i19 + 104 >> 2]);
 f24 = Math_fround(HEAPF32[i19 + 112 >> 2]);
 f9 = Math_fround(HEAPF32[i19 + 116 >> 2]);
 f27 = Math_fround(HEAPF32[i19 + 120 >> 2]);
 f43 = Math_fround(f8 * f42);
 f41 = Math_fround(f8 * f40);
 f8 = Math_fround(f8 * f33);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
 f39 = Math_fround(f11 * f38);
 f37 = Math_fround(f11 * f36);
 f11 = Math_fround(f11 * f26);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
 i30 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 f35 = Math_fround(f25 * f34);
 f22 = Math_fround(f25 * f10);
 f25 = Math_fround(f25 * f23);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 f42 = Math_fround(f46 * f42);
 f40 = Math_fround(f46 * f40);
 f33 = Math_fround(f46 * f33);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
 f38 = Math_fround(f45 * f38);
 f36 = Math_fround(f45 * f36);
 f26 = Math_fround(f45 * f26);
 i28 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 f34 = Math_fround(f44 * f34);
 f10 = Math_fround(f44 * f10);
 f23 = Math_fround(f44 * f23);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = f43 > f42;
 i16 = f41 > f40;
 i20 = f39 > f38;
 i29 = f37 > f36;
 i32 = f35 > f34;
 i5 = f22 > f10;
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 ? i15 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i18 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f27 = Math_fround((f8 > f33 ? f33 : f8) + f27);
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20 ? i28 : i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f10);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29 ? i31 : i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f22);
 f27 = Math_fround((f11 > f26 ? f26 : f11) + f27);
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32 ? i6 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f10);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5 ? i4 : i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f22);
 f27 = Math_fround((f25 > f23 ? f23 : f25) + f27);
 f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 ? i14 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 ? i17 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20 ? i21 : i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29 ? i30 : i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32 ? i7 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5 ? i1 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f25 = Math_fround(HEAPF32[i19 + 192 >> 2]);
 f10 = Math_fround(f25 * f10);
 f23 = Math_fround(HEAPF32[i19 + 196 >> 2]);
 f22 = Math_fround(f23 * f22);
 f11 = Math_fround(HEAPF32[i19 + 200 >> 2]);
 f24 = Math_fround(f24 * f11);
 f26 = Math_fround(HEAPF32[i19 + 204 >> 2]);
 f10 = Math_fround(Math_fround(f25 + Math_fround(0.0)) + f10);
 f22 = Math_fround(Math_fround(f23 + Math_fround(0.0)) + f22);
 f24 = Math_fround(Math_fround(f11 + Math_fround(1.0)) + f24);
 f26 = Math_fround(Math_fround(f26 + Math_fround(1.0)) + Math_fround(f9 * f26));
 i4 = f10 <= Math_fround(0.0);
 f10 = i4 ? Math_fround(0.0) : f10;
 i4 = f22 <= Math_fround(0.0);
 f22 = i4 ? Math_fround(0.0) : f22;
 i4 = f24 <= Math_fround(0.0);
 f24 = i4 ? Math_fround(0.0) : f24;
 i4 = f26 <= Math_fround(0.0);
 f26 = i4 ? Math_fround(0.0) : f26;
 f9 = Math_fround(HEAPF32[i19 + 208 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 212 >> 2]);
 f23 = Math_fround(HEAPF32[i19 + 216 >> 2]);
 f25 = Math_fround(HEAPF32[i19 + 220 >> 2]);
 i4 = ~~(f9 <= f10 ? f9 : f10);
 i1 = ~~(f11 <= f22 ? f11 : f22);
 i5 = ~~(f23 <= f24 ? f23 : f24);
 i6 = ~~(f25 <= f26 ? f25 : f26);
 f26 = Math_fround(HEAPF32[i19 + 224 >> 2]);
 f27 = Math_fround(f27 * f26);
 i7 = f27 <= Math_fround(0.0);
 f27 = i7 ? Math_fround(0.0) : f27;
 i7 = ~~(f26 <= f27 ? f26 : f27);
 if (!((i4 | 0) < (i5 | 0) & (i1 | 0) < (i6 | 0))) {
  i32 = 0;
  return i32 | 0;
 }
 L23 : while (1) {
  i3 = i1 << 7;
  i2 = i4;
  do {
   if ((i7 | 0) < (HEAPU16[i19 + 240 + (i2 + i3 << 1) >> 1] | 0)) {
    i1 = 1;
    i18 = 17;
    break L23;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i6 | 0)) {
   i1 = 0;
   i18 = 17;
   break;
  }
 }
 if ((i18 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i1, i2, i33) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i33 = i33 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0;
 L1 : while (1) {
  i32 = i2;
  i59 = i2 + -88 | 0;
  i53 = i2 + -84 | 0;
  i54 = i2 + -80 | 0;
  i55 = i2 + -76 | 0;
  i56 = i2 + -72 | 0;
  i57 = i2 + -68 | 0;
  i58 = i2 + -64 | 0;
  i38 = i2 + -60 | 0;
  i39 = i2 + -56 | 0;
  i40 = i2 + -52 | 0;
  i41 = i2 + -48 | 0;
  i42 = i2 + -44 | 0;
  i43 = i2 + -40 | 0;
  i44 = i2 + -36 | 0;
  i45 = i2 + -32 | 0;
  i46 = i2 + -28 | 0;
  i47 = i2 + -24 | 0;
  i48 = i2 + -20 | 0;
  i49 = i2 + -16 | 0;
  i50 = i2 + -12 | 0;
  i51 = i2 + -8 | 0;
  i52 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i31 = i1;
    i3 = i32 - i31 | 0;
    switch ((i3 | 0) / 88 | 0 | 0) {
    case 2:
     {
      i34 = 5;
      break L1;
     }
    case 3:
     {
      i34 = 7;
      break L1;
     }
    case 4:
     {
      i34 = 8;
      break L1;
     }
    case 5:
     {
      i34 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i34 = 46;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 616) {
     i34 = 11;
     break L1;
    }
    i28 = i1 + (((i3 >>> 0) / 176 | 0) * 88 | 0) | 0;
    if ((i3 | 0) > 87912) {
     i3 = (i3 >>> 0) / 352 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + (i3 * 88 | 0) | 0, i28, i28 + (i3 * 88 | 0) | 0, i59, i33) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i1, i28, i59, i33) | 0;
    if (mftCall_iii(HEAP32[i33 >> 2] | 0, i1 | 0, i28 | 0) | 0) {
     i5 = i59;
     break;
    } else i4 = i59;
    while (1) {
     i5 = i4 + -88 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (mftCall_iii(HEAP32[i33 >> 2] | 0, i5 | 0, i28 | 0) | 0) {
      i34 = 29;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 88 | 0;
    if (!(mftCall_iii(HEAP32[i33 >> 2] | 0, i1 | 0, i59 | 0) | 0)) {
     if ((i3 | 0) == (i59 | 0)) {
      i34 = 46;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i33 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 88 | 0;
      if ((i3 | 0) == (i59 | 0)) {
       i34 = 46;
       break L1;
      }
     }
     i15 = HEAP32[i3 >> 2] | 0;
     i16 = HEAP32[i3 + 4 >> 2] | 0;
     i17 = HEAP32[i3 + 8 >> 2] | 0;
     i18 = HEAP32[i3 + 12 >> 2] | 0;
     i19 = HEAP32[i3 + 16 >> 2] | 0;
     i20 = HEAP32[i3 + 20 >> 2] | 0;
     i21 = HEAP32[i3 + 24 >> 2] | 0;
     i22 = HEAP32[i3 + 28 >> 2] | 0;
     i23 = HEAP32[i3 + 32 >> 2] | 0;
     i24 = HEAP32[i3 + 36 >> 2] | 0;
     i25 = HEAP32[i3 + 40 >> 2] | 0;
     i4 = HEAP32[i3 + 44 >> 2] | 0;
     i5 = HEAP32[i3 + 48 >> 2] | 0;
     i6 = HEAP32[i3 + 52 >> 2] | 0;
     i7 = HEAP32[i3 + 56 >> 2] | 0;
     i8 = HEAP32[i3 + 60 >> 2] | 0;
     i9 = HEAP32[i3 + 64 >> 2] | 0;
     i10 = HEAP32[i3 + 68 >> 2] | 0;
     i11 = HEAP32[i3 + 72 >> 2] | 0;
     i12 = HEAP32[i3 + 76 >> 2] | 0;
     i13 = HEAP32[i3 + 80 >> 2] | 0;
     i14 = HEAP32[i3 + 84 >> 2] | 0;
     i35 = i3;
     i36 = i59;
     i37 = i35 + 88 | 0;
     do {
      HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
      i35 = i35 + 4 | 0;
      i36 = i36 + 4 | 0;
     } while ((i35 | 0) < (i37 | 0));
     HEAP32[i59 >> 2] = i15;
     HEAP32[i53 >> 2] = i16;
     HEAP32[i54 >> 2] = i17;
     HEAP32[i55 >> 2] = i18;
     HEAP32[i56 >> 2] = i19;
     HEAP32[i57 >> 2] = i20;
     HEAP32[i58 >> 2] = i21;
     HEAP32[i38 >> 2] = i22;
     HEAP32[i39 >> 2] = i23;
     HEAP32[i40 >> 2] = i24;
     HEAP32[i41 >> 2] = i25;
     HEAP32[i42 >> 2] = i4;
     HEAP32[i43 >> 2] = i5;
     HEAP32[i44 >> 2] = i6;
     HEAP32[i45 >> 2] = i7;
     HEAP32[i46 >> 2] = i8;
     HEAP32[i47 >> 2] = i9;
     HEAP32[i48 >> 2] = i10;
     HEAP32[i49 >> 2] = i11;
     HEAP32[i50 >> 2] = i12;
     HEAP32[i51 >> 2] = i13;
     HEAP32[i52 >> 2] = i14;
     i3 = i3 + 88 | 0;
    }
    if ((i3 | 0) == (i59 | 0)) {
     i34 = 46;
     break L1;
    } else i4 = i59;
    while (1) {
     while (1) {
      i28 = i3 + 88 | 0;
      if (mftCall_iii(HEAP32[i33 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i28;
     }
     while (1) {
      i5 = i4 + -88 | 0;
      if (mftCall_iii(HEAP32[i33 >> 2] | 0, i1 | 0, i5 | 0) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i6 = HEAP32[i3 >> 2] | 0;
     i7 = HEAP32[i3 + 4 >> 2] | 0;
     i8 = HEAP32[i3 + 8 >> 2] | 0;
     i9 = HEAP32[i3 + 12 >> 2] | 0;
     i10 = HEAP32[i3 + 16 >> 2] | 0;
     i11 = HEAP32[i3 + 20 >> 2] | 0;
     i12 = HEAP32[i3 + 24 >> 2] | 0;
     i13 = HEAP32[i3 + 28 >> 2] | 0;
     i14 = HEAP32[i3 + 32 >> 2] | 0;
     i15 = HEAP32[i3 + 36 >> 2] | 0;
     i16 = HEAP32[i3 + 40 >> 2] | 0;
     i17 = HEAP32[i3 + 44 >> 2] | 0;
     i18 = HEAP32[i3 + 48 >> 2] | 0;
     i19 = HEAP32[i3 + 52 >> 2] | 0;
     i20 = HEAP32[i3 + 56 >> 2] | 0;
     i21 = HEAP32[i3 + 60 >> 2] | 0;
     i22 = HEAP32[i3 + 64 >> 2] | 0;
     i23 = HEAP32[i3 + 68 >> 2] | 0;
     i24 = HEAP32[i3 + 72 >> 2] | 0;
     i25 = HEAP32[i3 + 76 >> 2] | 0;
     i26 = HEAP32[i3 + 80 >> 2] | 0;
     i27 = HEAP32[i3 + 84 >> 2] | 0;
     i35 = i3;
     i36 = i5;
     i37 = i35 + 88 | 0;
     do {
      HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
      i35 = i35 + 4 | 0;
      i36 = i36 + 4 | 0;
     } while ((i35 | 0) < (i37 | 0));
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 + -84 >> 2] = i7;
     HEAP32[i4 + -80 >> 2] = i8;
     HEAP32[i4 + -76 >> 2] = i9;
     HEAP32[i4 + -72 >> 2] = i10;
     HEAP32[i4 + -68 >> 2] = i11;
     HEAP32[i4 + -64 >> 2] = i12;
     HEAP32[i4 + -60 >> 2] = i13;
     HEAP32[i4 + -56 >> 2] = i14;
     HEAP32[i4 + -52 >> 2] = i15;
     HEAP32[i4 + -48 >> 2] = i16;
     HEAP32[i4 + -44 >> 2] = i17;
     HEAP32[i4 + -40 >> 2] = i18;
     HEAP32[i4 + -36 >> 2] = i19;
     HEAP32[i4 + -32 >> 2] = i20;
     HEAP32[i4 + -28 >> 2] = i21;
     HEAP32[i4 + -24 >> 2] = i22;
     HEAP32[i4 + -20 >> 2] = i23;
     HEAP32[i4 + -16 >> 2] = i24;
     HEAP32[i4 + -12 >> 2] = i25;
     HEAP32[i4 + -8 >> 2] = i26;
     HEAP32[i4 + -4 >> 2] = i27;
     i4 = i5;
     i3 = i28;
    }
   }
   if ((i34 | 0) == 29) {
    i34 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i9 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = HEAP32[i1 + 16 >> 2] | 0;
    i11 = HEAP32[i1 + 20 >> 2] | 0;
    i12 = HEAP32[i1 + 24 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i14 = HEAP32[i1 + 32 >> 2] | 0;
    i15 = HEAP32[i1 + 36 >> 2] | 0;
    i16 = HEAP32[i1 + 40 >> 2] | 0;
    i17 = HEAP32[i1 + 44 >> 2] | 0;
    i18 = HEAP32[i1 + 48 >> 2] | 0;
    i19 = HEAP32[i1 + 52 >> 2] | 0;
    i20 = HEAP32[i1 + 56 >> 2] | 0;
    i21 = HEAP32[i1 + 60 >> 2] | 0;
    i22 = HEAP32[i1 + 64 >> 2] | 0;
    i23 = HEAP32[i1 + 68 >> 2] | 0;
    i24 = HEAP32[i1 + 72 >> 2] | 0;
    i25 = HEAP32[i1 + 76 >> 2] | 0;
    i26 = HEAP32[i1 + 80 >> 2] | 0;
    i27 = HEAP32[i1 + 84 >> 2] | 0;
    i35 = i1;
    i36 = i5;
    i37 = i35 + 88 | 0;
    do {
     HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
     i35 = i35 + 4 | 0;
     i36 = i36 + 4 | 0;
    } while ((i35 | 0) < (i37 | 0));
    HEAP32[i5 >> 2] = i6;
    HEAP32[i4 + -84 >> 2] = i7;
    HEAP32[i4 + -80 >> 2] = i8;
    HEAP32[i4 + -76 >> 2] = i9;
    HEAP32[i4 + -72 >> 2] = i10;
    HEAP32[i4 + -68 >> 2] = i11;
    HEAP32[i4 + -64 >> 2] = i12;
    HEAP32[i4 + -60 >> 2] = i13;
    HEAP32[i4 + -56 >> 2] = i14;
    HEAP32[i4 + -52 >> 2] = i15;
    HEAP32[i4 + -48 >> 2] = i16;
    HEAP32[i4 + -44 >> 2] = i17;
    HEAP32[i4 + -40 >> 2] = i18;
    HEAP32[i4 + -36 >> 2] = i19;
    HEAP32[i4 + -32 >> 2] = i20;
    HEAP32[i4 + -28 >> 2] = i21;
    HEAP32[i4 + -24 >> 2] = i22;
    HEAP32[i4 + -20 >> 2] = i23;
    HEAP32[i4 + -16 >> 2] = i24;
    HEAP32[i4 + -12 >> 2] = i25;
    HEAP32[i4 + -8 >> 2] = i26;
    HEAP32[i4 + -4 >> 2] = i27;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 88 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i30 = i28;
    while (1) {
     while (1) {
      i29 = i4 + 88 | 0;
      if (mftCall_iii(HEAP32[i33 >> 2] | 0, i4 | 0, i30 | 0) | 0) i4 = i29; else break;
     }
     while (1) {
      i6 = i5 + -88 | 0;
      if (mftCall_iii(HEAP32[i33 >> 2] | 0, i6 | 0, i30 | 0) | 0) break; else i5 = i6;
     }
     if (i4 >>> 0 > i6 >>> 0) {
      i26 = i30;
      i27 = i4;
      break L35;
     }
     i7 = HEAP32[i4 >> 2] | 0;
     i8 = HEAP32[i4 + 4 >> 2] | 0;
     i9 = HEAP32[i4 + 8 >> 2] | 0;
     i10 = HEAP32[i4 + 12 >> 2] | 0;
     i11 = HEAP32[i4 + 16 >> 2] | 0;
     i12 = HEAP32[i4 + 20 >> 2] | 0;
     i13 = HEAP32[i4 + 24 >> 2] | 0;
     i14 = HEAP32[i4 + 28 >> 2] | 0;
     i15 = HEAP32[i4 + 32 >> 2] | 0;
     i16 = HEAP32[i4 + 36 >> 2] | 0;
     i17 = HEAP32[i4 + 40 >> 2] | 0;
     i18 = HEAP32[i4 + 44 >> 2] | 0;
     i19 = HEAP32[i4 + 48 >> 2] | 0;
     i20 = HEAP32[i4 + 52 >> 2] | 0;
     i21 = HEAP32[i4 + 56 >> 2] | 0;
     i22 = HEAP32[i4 + 60 >> 2] | 0;
     i23 = HEAP32[i4 + 64 >> 2] | 0;
     i24 = HEAP32[i4 + 68 >> 2] | 0;
     i25 = HEAP32[i4 + 72 >> 2] | 0;
     i26 = HEAP32[i4 + 76 >> 2] | 0;
     i27 = HEAP32[i4 + 80 >> 2] | 0;
     i28 = HEAP32[i4 + 84 >> 2] | 0;
     i35 = i4;
     i36 = i6;
     i37 = i35 + 88 | 0;
     do {
      HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
      i35 = i35 + 4 | 0;
      i36 = i36 + 4 | 0;
     } while ((i35 | 0) < (i37 | 0));
     HEAP32[i6 >> 2] = i7;
     HEAP32[i5 + -84 >> 2] = i8;
     HEAP32[i5 + -80 >> 2] = i9;
     HEAP32[i5 + -76 >> 2] = i10;
     HEAP32[i5 + -72 >> 2] = i11;
     HEAP32[i5 + -68 >> 2] = i12;
     HEAP32[i5 + -64 >> 2] = i13;
     HEAP32[i5 + -60 >> 2] = i14;
     HEAP32[i5 + -56 >> 2] = i15;
     HEAP32[i5 + -52 >> 2] = i16;
     HEAP32[i5 + -48 >> 2] = i17;
     HEAP32[i5 + -44 >> 2] = i18;
     HEAP32[i5 + -40 >> 2] = i19;
     HEAP32[i5 + -36 >> 2] = i20;
     HEAP32[i5 + -32 >> 2] = i21;
     HEAP32[i5 + -28 >> 2] = i22;
     HEAP32[i5 + -24 >> 2] = i23;
     HEAP32[i5 + -20 >> 2] = i24;
     HEAP32[i5 + -16 >> 2] = i25;
     HEAP32[i5 + -12 >> 2] = i26;
     HEAP32[i5 + -8 >> 2] = i27;
     HEAP32[i5 + -4 >> 2] = i28;
     i30 = (i30 | 0) == (i4 | 0) ? i6 : i30;
     i5 = i6;
     i4 = i29;
     i3 = i3 + 1 | 0;
    }
   } else {
    i26 = i28;
    i27 = i4;
   } while (0);
   if ((i27 | 0) != (i26 | 0)) if (mftCall_iii(HEAP32[i33 >> 2] | 0, i26 | 0, i27 | 0) | 0) {
    i4 = HEAP32[i27 >> 2] | 0;
    i5 = HEAP32[i27 + 4 >> 2] | 0;
    i6 = HEAP32[i27 + 8 >> 2] | 0;
    i7 = HEAP32[i27 + 12 >> 2] | 0;
    i8 = HEAP32[i27 + 16 >> 2] | 0;
    i9 = HEAP32[i27 + 20 >> 2] | 0;
    i10 = HEAP32[i27 + 24 >> 2] | 0;
    i11 = HEAP32[i27 + 28 >> 2] | 0;
    i12 = HEAP32[i27 + 32 >> 2] | 0;
    i13 = HEAP32[i27 + 36 >> 2] | 0;
    i14 = HEAP32[i27 + 40 >> 2] | 0;
    i15 = HEAP32[i27 + 44 >> 2] | 0;
    i16 = HEAP32[i27 + 48 >> 2] | 0;
    i17 = HEAP32[i27 + 52 >> 2] | 0;
    i18 = HEAP32[i27 + 56 >> 2] | 0;
    i19 = HEAP32[i27 + 60 >> 2] | 0;
    i20 = HEAP32[i27 + 64 >> 2] | 0;
    i21 = HEAP32[i27 + 68 >> 2] | 0;
    i22 = HEAP32[i27 + 72 >> 2] | 0;
    i23 = HEAP32[i27 + 76 >> 2] | 0;
    i24 = HEAP32[i27 + 80 >> 2] | 0;
    i25 = HEAP32[i27 + 84 >> 2] | 0;
    i35 = i27;
    i36 = i26;
    i37 = i35 + 88 | 0;
    do {
     HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
     i35 = i35 + 4 | 0;
     i36 = i36 + 4 | 0;
    } while ((i35 | 0) < (i37 | 0));
    HEAP32[i26 >> 2] = i4;
    HEAP32[i26 + 4 >> 2] = i5;
    HEAP32[i26 + 8 >> 2] = i6;
    HEAP32[i26 + 12 >> 2] = i7;
    HEAP32[i26 + 16 >> 2] = i8;
    HEAP32[i26 + 20 >> 2] = i9;
    HEAP32[i26 + 24 >> 2] = i10;
    HEAP32[i26 + 28 >> 2] = i11;
    HEAP32[i26 + 32 >> 2] = i12;
    HEAP32[i26 + 36 >> 2] = i13;
    HEAP32[i26 + 40 >> 2] = i14;
    HEAP32[i26 + 44 >> 2] = i15;
    HEAP32[i26 + 48 >> 2] = i16;
    HEAP32[i26 + 52 >> 2] = i17;
    HEAP32[i26 + 56 >> 2] = i18;
    HEAP32[i26 + 60 >> 2] = i19;
    HEAP32[i26 + 64 >> 2] = i20;
    HEAP32[i26 + 68 >> 2] = i21;
    HEAP32[i26 + 72 >> 2] = i22;
    HEAP32[i26 + 76 >> 2] = i23;
    HEAP32[i26 + 80 >> 2] = i24;
    HEAP32[i26 + 84 >> 2] = i25;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRK16NavMeshCarveDataS3_EPS1_EEbT0_S8_T_(i1, i27, i33) | 0;
    i4 = i27 + 88 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRK16NavMeshCarveDataS3_EPS1_EEbT0_S8_T_(i4, i2, i33) | 0) {
     i34 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i37 = i27;
   if ((i37 - i31 | 0) >= (i32 - i37 | 0)) {
    i34 = 44;
    break;
   }
   __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i1, i27, i33);
   i1 = i27 + 88 | 0;
  }
  if ((i34 | 0) == 44) {
   i34 = 0;
   __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i27 + 88 | 0, i2, i33);
   i2 = i27;
   continue;
  } else if ((i34 | 0) == 45) {
   i34 = 0;
   if (i3) {
    i34 = 46;
    break;
   } else {
    i2 = i27;
    continue;
   }
  }
 }
 if ((i34 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i33 >> 2] | 0, i59 | 0, i1 | 0) | 0)) return;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = HEAP32[i1 + 16 >> 2] | 0;
  i7 = HEAP32[i1 + 20 >> 2] | 0;
  i8 = HEAP32[i1 + 24 >> 2] | 0;
  i9 = HEAP32[i1 + 28 >> 2] | 0;
  i10 = HEAP32[i1 + 32 >> 2] | 0;
  i11 = HEAP32[i1 + 36 >> 2] | 0;
  i12 = HEAP32[i1 + 40 >> 2] | 0;
  i13 = HEAP32[i1 + 44 >> 2] | 0;
  i14 = HEAP32[i1 + 48 >> 2] | 0;
  i15 = HEAP32[i1 + 52 >> 2] | 0;
  i16 = HEAP32[i1 + 56 >> 2] | 0;
  i17 = HEAP32[i1 + 60 >> 2] | 0;
  i18 = HEAP32[i1 + 64 >> 2] | 0;
  i19 = HEAP32[i1 + 68 >> 2] | 0;
  i20 = HEAP32[i1 + 72 >> 2] | 0;
  i21 = HEAP32[i1 + 76 >> 2] | 0;
  i22 = HEAP32[i1 + 80 >> 2] | 0;
  i23 = HEAP32[i1 + 84 >> 2] | 0;
  i35 = i1;
  i36 = i59;
  i37 = i35 + 88 | 0;
  do {
   HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
   i35 = i35 + 4 | 0;
   i36 = i36 + 4 | 0;
  } while ((i35 | 0) < (i37 | 0));
  HEAP32[i59 >> 2] = i2;
  HEAP32[i53 >> 2] = i3;
  HEAP32[i54 >> 2] = i4;
  HEAP32[i55 >> 2] = i5;
  HEAP32[i56 >> 2] = i6;
  HEAP32[i57 >> 2] = i7;
  HEAP32[i58 >> 2] = i8;
  HEAP32[i38 >> 2] = i9;
  HEAP32[i39 >> 2] = i10;
  HEAP32[i40 >> 2] = i11;
  HEAP32[i41 >> 2] = i12;
  HEAP32[i42 >> 2] = i13;
  HEAP32[i43 >> 2] = i14;
  HEAP32[i44 >> 2] = i15;
  HEAP32[i45 >> 2] = i16;
  HEAP32[i46 >> 2] = i17;
  HEAP32[i47 >> 2] = i18;
  HEAP32[i48 >> 2] = i19;
  HEAP32[i49 >> 2] = i20;
  HEAP32[i50 >> 2] = i21;
  HEAP32[i51 >> 2] = i22;
  HEAP32[i52 >> 2] = i23;
  return;
 } else if ((i34 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i1, i1 + 88 | 0, i59, i33) | 0;
  return;
 } else if ((i34 | 0) == 8) {
  __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i1 + 88 | 0, i1 + 176 | 0, i59, i33) | 0;
  return;
 } else if ((i34 | 0) == 9) {
  __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + 88 | 0, i1 + 176 | 0, i1 + 264 | 0, i59, i33) | 0;
  return;
 } else if ((i34 | 0) == 11) {
  __ZNSt3__218__insertion_sort_3IRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i1, i2, i33);
  return;
 } else if ((i34 | 0) == 46) return;
}

function __ZN5physx17PxsFluidCollision19addTempW2STransformERNS0_8TaskDataERKNS_31PxsParticleStreamContactManagerE(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i1 & 2147483647;
 i4 = i5 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 <= i3 >>> 0) {
  __ZN5physx6shdfnd5ArrayINS_19PxsW2STransformTempENS0_16AlignedAllocatorILj16ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i5, (i2 | 0) == 0 ? 1 : i1 << 1);
  i3 = HEAP32[i4 >> 2] | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 1;
 i1 = i2 + (i3 * 56 | 0) | 0;
 if (!(HEAP8[i6 + 13 >> 0] | 0)) {
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  f13 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f11 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(-2.0));
  f20 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f24 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i5 >> 2]);
  f25 = Math_fround(f13 * f18);
  f16 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f12 * f16));
  f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f11 * f14));
  f9 = Math_fround(Math_fround(f18 * f25) + Math_fround(Math_fround(f13 * f24) - Math_fround(f20 * Math_fround(Math_fround(f11 * f16) - Math_fround(f12 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f25) + Math_fround(Math_fround(f12 * f24) - Math_fround(f20 * Math_fround(Math_fround(f13 * f14) - Math_fround(f11 * f18)))));
  f25 = Math_fround(Math_fround(Math_fround(f11 * f24) - Math_fround(f20 * Math_fround(Math_fround(f12 * f18) - Math_fround(f13 * f16)))) + Math_fround(f14 * f25));
  f13 = Math_fround(-f18);
  f12 = Math_fround(-f16);
  f11 = Math_fround(-f14);
  i6 = HEAP32[i6 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f26 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f7 = Math_fround(f7 * Math_fround(-2.0));
  f26 = Math_fround(f26 * Math_fround(-2.0));
  f28 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(-2.0));
  f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f27 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i6 >> 2]);
  f23 = Math_fround(f7 * f17);
  f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f26 * f15));
  f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f28 * f10));
  f21 = Math_fround(Math_fround(Math_fround(f17 * f23) + Math_fround(Math_fround(f7 * f27) - Math_fround(f19 * Math_fround(Math_fround(f28 * f15) - Math_fround(f26 * f10))))) * Math_fround(2.0));
  f22 = Math_fround(Math_fround(Math_fround(f15 * f23) + Math_fround(Math_fround(f26 * f27) - Math_fround(f19 * Math_fround(Math_fround(f7 * f10) - Math_fround(f28 * f17))))) * Math_fround(2.0));
  f23 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f19 * Math_fround(Math_fround(f26 * f17) - Math_fround(f7 * f15)))) + Math_fround(f10 * f23)) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(f23 * f11) + Math_fround(Math_fround(f21 * f13) + Math_fround(f22 * f12)));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f7 * f13) + Math_fround(Math_fround(f24 * f21) + Math_fround(f20 * Math_fround(Math_fround(f23 * f12) - Math_fround(f22 * f11))))));
  f8 = Math_fround(f8 + Math_fround(Math_fround(f7 * f12) + Math_fround(Math_fround(f24 * f22) + Math_fround(f20 * Math_fround(Math_fround(f21 * f11) - Math_fround(f23 * f13))))));
  f7 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f24 * f23) + Math_fround(f20 * Math_fround(Math_fround(f22 * f13) - Math_fround(f21 * f12)))) + Math_fround(f7 * f11)));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f13) - Math_fround(f20 * f17)) + Math_fround(f16 * f10)) - Math_fround(f14 * f15));
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f19 * f12) - Math_fround(f20 * f15))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f19 * f11) - Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f15)) - Math_fround(f14 * f10));
  HEAPF32[i1 >> 2] = f13;
  HEAPF32[i2 + (i3 * 56 | 0) + 4 >> 2] = f12;
  HEAPF32[i2 + (i3 * 56 | 0) + 8 >> 2] = f11;
  HEAPF32[i2 + (i3 * 56 | 0) + 12 >> 2] = f10;
  HEAPF32[i2 + (i3 * 56 | 0) + 16 >> 2] = f9;
  HEAPF32[i2 + (i3 * 56 | 0) + 20 >> 2] = f8;
  HEAPF32[i2 + (i3 * 56 | 0) + 24 >> 2] = f7;
  HEAPF32[i2 + (i3 * 56 | 0) + 28 >> 2] = f13;
  HEAPF32[i2 + (i3 * 56 | 0) + 32 >> 2] = f12;
  HEAPF32[i2 + (i3 * 56 | 0) + 36 >> 2] = f11;
  HEAPF32[i2 + (i3 * 56 | 0) + 40 >> 2] = f10;
  HEAPF32[i2 + (i3 * 56 | 0) + 44 >> 2] = f9;
  HEAPF32[i2 + (i3 * 56 | 0) + 48 >> 2] = f8;
  HEAPF32[i2 + (i3 * 56 | 0) + 52 >> 2] = f7;
  return;
 } else {
  i5 = HEAP32[i6 >> 2] | 0;
  i35 = i6 + 4 | 0;
  i31 = HEAP32[i35 >> 2] | 0;
  f19 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
  f20 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
  f8 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
  f25 = Math_fround(HEAPF32[i31 + 12 >> 2]);
  i34 = i5 + 48 | 0;
  f23 = Math_fround(HEAPF32[i34 >> 2]);
  f23 = Math_fround(f23 - Math_fround(HEAPF32[i31 + 16 >> 2]));
  i33 = i5 + 52 | 0;
  f21 = Math_fround(HEAPF32[i33 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i31 + 20 >> 2]));
  i32 = i5 + 56 | 0;
  f22 = Math_fround(HEAPF32[i32 >> 2]);
  f23 = Math_fround(f23 * Math_fround(2.0));
  f21 = Math_fround(f21 * Math_fround(2.0));
  f22 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
  f18 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
  f14 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f21 * f20)) + Math_fround(f22 * f8));
  f17 = Math_fround(Math_fround(f14 * f19) + Math_fround(Math_fround(f18 * f23) + Math_fround(f25 * Math_fround(Math_fround(f22 * f20) - Math_fround(f21 * f8)))));
  f10 = Math_fround(Math_fround(f14 * f20) + Math_fround(Math_fround(f18 * f21) + Math_fround(f25 * Math_fround(Math_fround(f23 * f8) - Math_fround(f22 * f19)))));
  f14 = Math_fround(Math_fround(Math_fround(f18 * f22) + Math_fround(f25 * Math_fround(Math_fround(f21 * f19) - Math_fround(f23 * f20)))) + Math_fround(f14 * f8));
  i31 = i5 + 32 | 0;
  f23 = Math_fround(HEAPF32[i31 >> 2]);
  f21 = Math_fround(f25 * f23);
  i30 = i5 + 44 | 0;
  f22 = Math_fround(HEAPF32[i30 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f22 * f19));
  i29 = i5 + 40 | 0;
  f18 = Math_fround(HEAPF32[i29 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f18 * f20));
  i4 = i5 + 36 | 0;
  f24 = Math_fround(HEAPF32[i4 >> 2]);
  f21 = Math_fround(f21 - Math_fround(f24 * f8));
  f26 = Math_fround(Math_fround(Math_fround(f23 * f8) + Math_fround(Math_fround(f22 * f20) + Math_fround(f25 * f24))) - Math_fround(f18 * f19));
  f12 = Math_fround(Math_fround(Math_fround(f24 * f19) + Math_fround(Math_fround(f22 * f8) + Math_fround(f25 * f18))) - Math_fround(f23 * f20));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f22) - Math_fround(f23 * f19)) - Math_fround(f24 * f20)) - Math_fround(f18 * f8));
  i6 = HEAP32[i6 + 8 >> 2] | 0;
  f18 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f18 = Math_fround(f18 * Math_fround(-2.0));
  f20 = Math_fround(f20 * Math_fround(-2.0));
  f24 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(-2.0));
  f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f23 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f22 = Math_fround(HEAPF32[i6 >> 2]);
  f25 = Math_fround(f18 * f22);
  f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f20 * f16));
  f28 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f24 * f28));
  f27 = Math_fround(-f22);
  f11 = Math_fround(-f16);
  f13 = Math_fround(-f28);
  f15 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(Math_fround(f18 * f23) - Math_fround(f19 * Math_fround(Math_fround(f24 * f16) - Math_fround(f20 * f28))))) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(Math_fround(f16 * f25) + Math_fround(Math_fround(f20 * f23) - Math_fround(f19 * Math_fround(Math_fround(f18 * f28) - Math_fround(f24 * f22))))) * Math_fround(2.0));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f19 * Math_fround(Math_fround(f20 * f22) - Math_fround(f18 * f16)))) + Math_fround(f28 * f25)) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f16 = Math_fround(Math_fround(f12 * f25) + Math_fround(Math_fround(f21 * f15) + Math_fround(f26 * f9)));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f21 * f16) + Math_fround(Math_fround(f28 * f15) + Math_fround(f8 * Math_fround(Math_fround(f26 * f25) - Math_fround(f12 * f9))))));
  f10 = Math_fround(f10 + Math_fround(Math_fround(f26 * f16) + Math_fround(Math_fround(f28 * f9) + Math_fround(f8 * Math_fround(Math_fround(f12 * f15) - Math_fround(f21 * f25))))));
  f16 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f28 * f25) + Math_fround(f8 * Math_fround(Math_fround(f21 * f9) - Math_fround(f26 * f15)))) + Math_fround(f12 * f16)));
  f15 = Math_fround(Math_fround(Math_fround(f12 * f27) + Math_fround(Math_fround(f26 * f19) + Math_fround(f8 * f11))) - Math_fround(f21 * f13));
  f9 = Math_fround(Math_fround(Math_fround(f21 * f11) + Math_fround(Math_fround(f12 * f19) + Math_fround(f8 * f13))) - Math_fround(f26 * f27));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f19) - Math_fround(f21 * f27)) - Math_fround(f26 * f11)) - Math_fround(f12 * f13));
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f19) + Math_fround(f8 * f27)) + Math_fround(f26 * f13)) - Math_fround(f12 * f11));
  HEAPF32[i2 + (i3 * 56 | 0) + 4 >> 2] = f15;
  HEAPF32[i2 + (i3 * 56 | 0) + 8 >> 2] = f9;
  HEAPF32[i2 + (i3 * 56 | 0) + 12 >> 2] = f25;
  HEAPF32[i2 + (i3 * 56 | 0) + 16 >> 2] = f17;
  HEAPF32[i2 + (i3 * 56 | 0) + 20 >> 2] = f10;
  HEAPF32[i2 + (i3 * 56 | 0) + 24 >> 2] = f16;
  i6 = HEAP32[i35 >> 2] | 0;
  f16 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  f10 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
  f17 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
  f25 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f9 = Math_fround(HEAPF32[i34 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i6 + 16 >> 2]));
  f15 = Math_fround(HEAPF32[i33 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i6 + 20 >> 2]));
  f11 = Math_fround(HEAPF32[i32 >> 2]);
  f9 = Math_fround(f9 * Math_fround(2.0));
  f15 = Math_fround(f15 * Math_fround(2.0));
  f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i6 + 24 >> 2])) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
  f13 = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(f15 * f10)) + Math_fround(f11 * f17));
  f26 = Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f12 * f9) + Math_fround(f25 * Math_fround(Math_fround(f11 * f10) - Math_fround(f15 * f17)))));
  f27 = Math_fround(Math_fround(f13 * f10) + Math_fround(Math_fround(f12 * f15) + Math_fround(f25 * Math_fround(Math_fround(f9 * f17) - Math_fround(f11 * f16)))));
  f13 = Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f25 * Math_fround(Math_fround(f15 * f16) - Math_fround(f9 * f10)))) + Math_fround(f13 * f17));
  f9 = Math_fround(HEAPF32[i31 >> 2]);
  f15 = Math_fround(f25 * f9);
  f11 = Math_fround(HEAPF32[i30 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f11 * f16));
  f12 = Math_fround(HEAPF32[i29 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f12 * f10));
  f8 = Math_fround(HEAPF32[i4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(f8 * f17));
  f19 = Math_fround(Math_fround(Math_fround(f9 * f17) + Math_fround(Math_fround(f11 * f10) + Math_fround(f25 * f8))) - Math_fround(f12 * f16));
  f21 = Math_fround(Math_fround(Math_fround(f8 * f16) + Math_fround(Math_fround(f11 * f17) + Math_fround(f25 * f12))) - Math_fround(f9 * f10));
  f17 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f11) - Math_fround(f9 * f16)) - Math_fround(f8 * f10)) - Math_fround(f12 * f17));
  f12 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f10 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f10 = Math_fround(f10 * Math_fround(-2.0));
  f8 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(-2.0));
  f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f9 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  f25 = Math_fround(f12 * f11);
  f28 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f10 * f28));
  f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f8 * f14));
  f18 = Math_fround(-f11);
  f22 = Math_fround(-f28);
  f20 = Math_fround(-f14);
  f23 = Math_fround(Math_fround(Math_fround(f11 * f25) + Math_fround(Math_fround(f12 * f9) - Math_fround(f16 * Math_fround(Math_fround(f8 * f28) - Math_fround(f10 * f14))))) * Math_fround(2.0));
  f24 = Math_fround(Math_fround(Math_fround(f28 * f25) + Math_fround(Math_fround(f10 * f9) - Math_fround(f16 * Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * f11))))) * Math_fround(2.0));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f9) - Math_fround(f16 * Math_fround(Math_fround(f10 * f11) - Math_fround(f12 * f28)))) + Math_fround(f14 * f25)) * Math_fround(2.0));
  f14 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
  f28 = Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f15 * f23) + Math_fround(f19 * f24)));
  f26 = Math_fround(f26 + Math_fround(Math_fround(f15 * f28) + Math_fround(Math_fround(f14 * f23) + Math_fround(f17 * Math_fround(Math_fround(f19 * f25) - Math_fround(f21 * f24))))));
  f27 = Math_fround(f27 + Math_fround(Math_fround(f19 * f28) + Math_fround(Math_fround(f14 * f24) + Math_fround(f17 * Math_fround(Math_fround(f21 * f23) - Math_fround(f15 * f25))))));
  f28 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f14 * f25) + Math_fround(f17 * Math_fround(Math_fround(f15 * f24) - Math_fround(f19 * f23)))) + Math_fround(f21 * f28)));
  f23 = Math_fround(Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f19 * f16) + Math_fround(f17 * f22))) - Math_fround(f15 * f20));
  f24 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(Math_fround(f21 * f16) + Math_fround(f17 * f20))) - Math_fround(f19 * f18));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f18)) - Math_fround(f19 * f22)) - Math_fround(f21 * f20));
  HEAPF32[i2 + (i3 * 56 | 0) + 28 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) + Math_fround(f17 * f18)) + Math_fround(f19 * f20)) - Math_fround(f21 * f22));
  HEAPF32[i2 + (i3 * 56 | 0) + 32 >> 2] = f23;
  HEAPF32[i2 + (i3 * 56 | 0) + 36 >> 2] = f24;
  HEAPF32[i2 + (i3 * 56 | 0) + 40 >> 2] = f25;
  HEAPF32[i2 + (i3 * 56 | 0) + 44 >> 2] = f26;
  HEAPF32[i2 + (i3 * 56 | 0) + 48 >> 2] = f27;
  HEAPF32[i2 + (i3 * 56 | 0) + 52 >> 2] = f28;
  return;
 }
}

function __Z27QuaternionCurveToEulerCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE(i55, i56) {
 i55 = i55 | 0;
 i56 = i56 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i59 + 80 | 0;
 i49 = i59 + 64 | 0;
 i50 = i59 + 48 | 0;
 i51 = i59 + 36 | 0;
 i52 = i59 + 24 | 0;
 i53 = i59 + 12 | 0;
 i54 = i59;
 i47 = HEAP32[i55 + 164 >> 2] | 0;
 i6 = i47 << 4;
 i1 = HEAP32[i56 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i47;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i47 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i58 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i58 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = i58;
  break;
 } while (0);
 i57 = i56 + 4 | 0;
 i1 = HEAP32[i57 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i47;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i47 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i58 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i58 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = i58;
  break;
 } while (0);
 i58 = i56 + 8 | 0;
 i1 = HEAP32[i58 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i47;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i47 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i46 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i46 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i47;
  HEAP32[i2 >> 2] = i46;
  break;
 } while (0);
 if ((i47 | 0) > 0) {
  i31 = i55 + 152 | 0;
  i32 = i47 + -1 | 0;
  i7 = i48 + 4 | 0;
  i27 = i48 + 8 | 0;
  i4 = i48 + 12 | 0;
  i24 = i49 + 4 | 0;
  i26 = i49 + 8 | 0;
  i6 = i49 + 12 | 0;
  i23 = i50 + 4 | 0;
  i25 = i50 + 8 | 0;
  i5 = i50 + 12 | 0;
  f33 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  i34 = i55 + 180 | 0;
  i35 = i52 + 4 | 0;
  i36 = i52 + 8 | 0;
  i37 = i51 + 4 | 0;
  i38 = i51 + 8 | 0;
  i39 = i53 + 4 | 0;
  i40 = i53 + 8 | 0;
  i41 = i52 + 4 | 0;
  i42 = i52 + 8 | 0;
  i43 = i54 + 4 | 0;
  i44 = i54 + 8 | 0;
  i45 = i53 + 4 | 0;
  i46 = i53 + 8 | 0;
  i3 = 0;
  do {
   i1 = HEAP32[i31 >> 2] | 0;
   f28 = Math_fround(HEAPF32[i1 + (i3 * 52 | 0) >> 2]);
   if ((i3 | 0) > 0) f29 = Math_fround(f28 - Math_fround(HEAPF32[i1 + ((i3 + -1 | 0) * 52 | 0) >> 2])); else f29 = Math_fround(Math_fround(HEAPF32[i1 + ((i3 + 1 | 0) * 52 | 0) >> 2]) - f28);
   if ((i3 | 0) < (i32 | 0)) f30 = Math_fround(Math_fround(HEAPF32[i1 + ((i3 + 1 | 0) * 52 | 0) >> 2]) - f28); else f30 = Math_fround(f28 - Math_fround(HEAPF32[i1 + ((i3 + -1 | 0) * 52 | 0) >> 2]));
   i2 = i1 + (i3 * 52 | 0) + 4 | 0;
   HEAP32[i48 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i48 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   f18 = Math_fround(f29 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 20 >> 2]));
   f17 = Math_fround(f29 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 24 >> 2]));
   f16 = Math_fround(f29 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 28 >> 2]));
   f18 = Math_fround(f18 / Math_fround(3.0));
   f17 = Math_fround(f17 / Math_fround(3.0));
   f16 = Math_fround(f16 / Math_fround(3.0));
   f15 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 32 >> 2])) / Math_fround(3.0));
   f14 = Math_fround(HEAPF32[i48 >> 2]);
   f12 = Math_fround(HEAPF32[i7 >> 2]);
   f9 = Math_fround(HEAPF32[i27 >> 2]);
   f8 = Math_fround(HEAPF32[i4 >> 2]);
   f18 = Math_fround(f18 + f14);
   f17 = Math_fround(f17 + f12);
   f16 = Math_fround(f16 + f9);
   f15 = Math_fround(f15 + f8);
   HEAPF32[i49 >> 2] = f18;
   HEAPF32[i24 >> 2] = f17;
   HEAPF32[i26 >> 2] = f16;
   HEAPF32[i6 >> 2] = f15;
   f22 = Math_fround(f30 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 36 >> 2]));
   f21 = Math_fround(f30 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 40 >> 2]));
   f20 = Math_fround(f30 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 44 >> 2]));
   f22 = Math_fround(Math_fround(f22 / Math_fround(3.0)) + f14);
   f21 = Math_fround(Math_fround(f21 / Math_fround(3.0)) + f12);
   f20 = Math_fround(Math_fround(f20 / Math_fround(3.0)) + f9);
   f19 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i1 + (i3 * 52 | 0) + 48 >> 2])) / Math_fround(3.0)) + f8);
   HEAPF32[i50 >> 2] = f22;
   HEAPF32[i23 >> 2] = f21;
   HEAPF32[i25 >> 2] = f20;
   HEAPF32[i5 >> 2] = f19;
   f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f12 * f12)) + Math_fround(f9 * f9)) + Math_fround(f8 * f8))));
   if (f13 < f33) {
    f11 = Math_fround(1.0);
    f10 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f8 = Math_fround(0.0);
   } else {
    f11 = Math_fround(f8 / f13);
    f10 = Math_fround(f9 / f13);
    f9 = Math_fround(f12 / f13);
    f8 = Math_fround(f14 / f13);
   }
   HEAPF32[i48 >> 2] = f8;
   HEAPF32[i7 >> 2] = f9;
   HEAPF32[i27 >> 2] = f10;
   HEAPF32[i4 >> 2] = f11;
   f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f16 * f16)) + Math_fround(f15 * f15))));
   if (f8 < f33) {
    f11 = Math_fround(1.0);
    f10 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f8 = Math_fround(0.0);
   } else {
    f11 = Math_fround(f15 / f8);
    f10 = Math_fround(f16 / f8);
    f9 = Math_fround(f17 / f8);
    f8 = Math_fround(f18 / f8);
   }
   HEAPF32[i49 >> 2] = f8;
   HEAPF32[i24 >> 2] = f9;
   HEAPF32[i26 >> 2] = f10;
   HEAPF32[i6 >> 2] = f11;
   f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f21 * f21)) + Math_fround(f20 * f20)) + Math_fround(f19 * f19))));
   if (f8 < f33) {
    f11 = Math_fround(1.0);
    f10 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f8 = Math_fround(0.0);
   } else {
    f11 = Math_fround(f19 / f8);
    f10 = Math_fround(f20 / f8);
    f9 = Math_fround(f21 / f8);
    f8 = Math_fround(f22 / f8);
   }
   HEAPF32[i50 >> 2] = f8;
   HEAPF32[i23 >> 2] = f9;
   HEAPF32[i25 >> 2] = f10;
   HEAPF32[i5 >> 2] = f11;
   __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i52, i48, HEAP32[i34 >> 2] | 0);
   f10 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * Math_fround(57.2957763));
   f21 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * Math_fround(57.2957763));
   f9 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(57.2957763));
   HEAPF32[i51 >> 2] = f10;
   HEAPF32[i37 >> 2] = f21;
   HEAPF32[i38 >> 2] = f9;
   __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i53, i49, HEAP32[i34 >> 2] | 0);
   f9 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) * Math_fround(57.2957763));
   f21 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) * Math_fround(57.2957763));
   f8 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) * Math_fround(57.2957763));
   HEAPF32[i52 >> 2] = f9;
   HEAPF32[i41 >> 2] = f21;
   HEAPF32[i42 >> 2] = f8;
   __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i54, i50, HEAP32[i34 >> 2] | 0);
   f8 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) * Math_fround(57.2957763));
   f21 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) * Math_fround(57.2957763));
   f22 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) * Math_fround(57.2957763));
   HEAPF32[i53 >> 2] = f8;
   HEAPF32[i45 >> 2] = f21;
   HEAPF32[i46 >> 2] = f22;
   i2 = 0;
   while (1) {
    f21 = Math_fround(Math_fround(f9 - f10) + Math_fround(180.0));
    f21 = Math_fround(Math_fround(f10 + Math_fround(f21 - Math_fround(Math_fround(Math_floor(Math_fround(f21 / Math_fround(360.0)))) * Math_fround(360.0)))) + Math_fround(-180.0));
    HEAPF32[i52 + (i2 << 2) >> 2] = f21;
    f20 = Math_fround(Math_fround(f8 - f10) + Math_fround(180.0));
    f20 = Math_fround(Math_fround(f10 + Math_fround(f20 - Math_fround(Math_fround(Math_floor(Math_fround(f20 / Math_fround(360.0)))) * Math_fround(360.0)))) + Math_fround(-180.0));
    HEAPF32[i53 + (i2 << 2) >> 2] = f20;
    i60 = HEAP32[i51 + (i2 << 2) >> 2] | 0;
    f22 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(Math_fround(Math_fround(f21 - f22) * Math_fround(3.0)) / f29);
    f22 = Math_fround(Math_fround(Math_fround(f20 - f22) * Math_fround(3.0)) / f30);
    i1 = HEAP32[(HEAP32[i56 + (i2 << 2) >> 2] | 0) + 56 >> 2] | 0;
    HEAPF32[i1 + (i3 << 4) >> 2] = f28;
    HEAP32[i1 + (i3 << 4) + 4 >> 2] = i60;
    HEAPF32[i1 + (i3 << 4) + 8 >> 2] = f21;
    HEAPF32[i1 + (i3 << 4) + 12 >> 2] = f22;
    i1 = i2 + 1 | 0;
    if ((i1 | 0) == 3) break;
    f9 = Math_fround(HEAPF32[i52 + (i1 << 2) >> 2]);
    f10 = Math_fround(HEAPF32[i51 + (i1 << 2) >> 2]);
    i2 = i1;
    f8 = Math_fround(HEAPF32[i53 + (i1 << 2) >> 2]);
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i47 | 0));
 }
 i2 = HEAP32[i55 + 172 >> 2] | 0;
 i1 = HEAP32[i55 + 176 >> 2] | 0;
 switch (i2 | 0) {
 case 1:
  {
   i2 = HEAP32[i56 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 1;
   i3 = i2 + 4 | 0;
   i4 = i2 + 32 | 0;
   i5 = i2 + 28 | 0;
   if ((i1 | 0) == 1) {
    HEAP32[i2 + 80 >> 2] = 1;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    i60 = HEAP32[i57 >> 2] | 0;
    HEAP32[i60 + 76 >> 2] = 1;
    HEAP32[i60 + 80 >> 2] = 1;
    HEAPF32[i60 + 4 >> 2] = Math_fround(inf);
    HEAP32[i60 >> 2] = 0;
    HEAPF32[i60 + 32 >> 2] = Math_fround(inf);
    HEAP32[i60 + 28 >> 2] = 0;
    i60 = HEAP32[i58 >> 2] | 0;
    HEAP32[i60 + 76 >> 2] = 1;
    HEAP32[i60 + 80 >> 2] = 1;
    HEAPF32[i60 + 4 >> 2] = Math_fround(inf);
    HEAP32[i60 >> 2] = 0;
    HEAPF32[i60 + 32 >> 2] = Math_fround(inf);
    HEAP32[i60 + 28 >> 2] = 0;
    STACKTOP = i59;
    return;
   } else {
    i56 = (i1 | 0) == 3 ? 3 : (i1 | 0) == 0 ? 0 : 2;
    HEAP32[i2 + 80 >> 2] = i56;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    i60 = HEAP32[i57 >> 2] | 0;
    HEAP32[i60 + 76 >> 2] = 1;
    HEAP32[i60 + 80 >> 2] = i56;
    HEAPF32[i60 + 4 >> 2] = Math_fround(inf);
    HEAP32[i60 >> 2] = 0;
    HEAPF32[i60 + 32 >> 2] = Math_fround(inf);
    HEAP32[i60 + 28 >> 2] = 0;
    i60 = HEAP32[i58 >> 2] | 0;
    HEAP32[i60 + 76 >> 2] = 1;
    HEAP32[i60 + 80 >> 2] = i56;
    HEAPF32[i60 + 4 >> 2] = Math_fround(inf);
    HEAP32[i60 >> 2] = 0;
    HEAPF32[i60 + 32 >> 2] = Math_fround(inf);
    HEAP32[i60 + 28 >> 2] = 0;
    STACKTOP = i59;
    return;
   }
  }
 case 0:
  {
   i3 = HEAP32[i56 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i3 = HEAP32[i57 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i2 = HEAP32[i58 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 0;
   i3 = i2 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   i4 = i2 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i2 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i2 + 80 >> 2] = i1;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   STACKTOP = i59;
   return;
  }
 default:
  {
   i6 = HEAP32[i56 >> 2] | 0;
   i7 = (i2 | 0) == 3 ? 3 : 2;
   HEAP32[i6 + 76 >> 2] = i7;
   i3 = i6 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i4 = i6 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i6 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i6 + 80 >> 2] = i2;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   i3 = HEAP32[i57 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = i7;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i5 = HEAP32[i58 >> 2] | 0;
   HEAP32[i5 + 76 >> 2] = i7;
   i2 = i5 + 4 | 0;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   i3 = i5 + 32 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   i4 = i5 + 28 | 0;
   HEAP32[i4 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i5 + 80 >> 2] = i1;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   STACKTOP = i59;
   return;
  }
 }
}

function __ZN11UnityEngine9Animation32CreateAnimatorGenericBindingsOptERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEPKNS0_21AvatarBindingConstantEbRNS6_6memory9AllocatorER8Animator(i29, i2, i40, i27, i13, i3, i28, i1) {
 i29 = i29 | 0;
 i2 = i2 | 0;
 i40 = i40 | 0;
 i27 = i27 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i39 + 8 | 0;
 i6 = i39;
 i14 = i39 + 80 | 0;
 i33 = i39 + 60 | 0;
 i34 = i39 + 40 | 0;
 i16 = i39 + 24 | 0;
 i25 = HEAP32[gb + 1466544 >> 2] | 0;
 i31 = HEAP32[i40 >> 2] | 0;
 i7 = i40;
 i36 = gb + 64016 | 0;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 i26 = i6;
 HEAP32[i26 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i26 + 4 >> 2] = i35;
 HEAP32[i33 >> 2] = 0;
 i26 = i33 + 12 | 0;
 HEAP32[i26 >> 2] = 0;
 i35 = i33 + 16 | 0;
 HEAP32[i35 >> 2] = 0;
 i36 = i33 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i6);
 i22 = i18;
 i37 = HEAP32[i22 + 4 >> 2] | 0;
 i38 = i36;
 HEAP32[i38 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i38 + 4 >> 2] = i37;
 i38 = gb + 64016 | 0;
 i37 = HEAP32[i38 + 4 >> 2] | 0;
 i22 = i6;
 HEAP32[i22 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i22 + 4 >> 2] = i37;
 HEAP32[i34 >> 2] = 0;
 i22 = i34 + 12 | 0;
 HEAP32[i22 >> 2] = 0;
 i37 = i34 + 16 | 0;
 HEAP32[i37 >> 2] = 0;
 i38 = i34 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i6);
 i24 = i18;
 i30 = HEAP32[i24 + 4 >> 2] | 0;
 i32 = i38;
 HEAP32[i32 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i32 + 4 >> 2] = i30;
 i31 = (i31 | 0) == 0 ? 0 : i31 + i7 | 0;
 HEAP32[i18 >> 2] = -1;
 __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i2, i18, i33, i40, 0);
 if (i3) {
  i30 = __ZN11UnityEngine9AnimationL56CalculateTransformBindingSizeBasedOnConstantOptimizationERKNS0_20AnimationSetBindingsERK13dynamic_arrayINS0_14BoundTransformELj4EEPKiPKN7mecanim9animation14AvatarConstantEb(i29, i33, 0, i40, 0) | 0;
  i1 = i29 + 20 | 0;
  i21 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i21 = i29 + 20 | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  i30 = i1;
 }
 i24 = i29 + 36 | 0;
 i23 = i30 - i1 + (HEAP32[HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] >> 2] | 0) | 0;
 i17 = i3 ? (i30 | 0) == (HEAP32[i29 + 16 >> 2] | 0) & 1 : 0;
 i12 = i13 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i15 = i1 + 52 | 0;
 i5 = HEAP32[i29 >> 2] | 0;
 i5 = (i5 | 0) == 0 ? i15 : (0 - i1 & 3) + i15 + (i5 << 4) | 0;
 i15 = i29 + 8 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i5 = (i1 | 0) == 0 ? i5 : i5 + (i1 << 4) + (0 - i5 & 3) | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i5 | 0, 64) | 0;
 HEAP32[i16 >> 2] = gb + 177508 + 8;
 i4 = i16 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = i1;
 HEAP32[i16 + 12 >> 2] = i5;
 i2 = i1;
 i2 = (0 - i2 & 3) + i2 | 0;
 i3 = i2 + 52 | 0;
 i5 = i1 + i5 | 0;
 if (i3 >>> 0 > i5 >>> 0) i32 = 0; else {
  HEAP32[i4 >> 2] = i3;
  i32 = i2;
  i1 = i3;
 }
 i3 = HEAP32[i12 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i2 = i1 + i3 | 0;
  if (i2 >>> 0 > i5 >>> 0) i1 = 0; else HEAP32[i4 >> 2] = i2;
  _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i11 = i32 + 24 | 0;
 HEAP32[i11 >> 2] = i1;
 i19 = gb + 64016 | 0;
 i10 = HEAP32[i19 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i14 >> 2] = 0;
 i9 = i14 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i6);
 i19 = i18;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 i1 = HEAP32[(HEAP32[i40 >> 2] | 0) + i7 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 if (!i1) i8 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 1, i10, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i14 >> 2] = i8;
  _memset(i8 | 0, 0, i1 | 0) | 0;
  i8 = HEAP32[i14 >> 2] | 0;
 }
 i19 = i40 + 20 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) i6 = 0; else {
  i6 = i1 + i19 + 40 | 0;
  i6 = (HEAP32[(HEAP32[i6 >> 2] | 0) + i6 >> 2] | 0) != 0;
 }
 i20 = HEAP32[i40 >> 2] | 0;
 i7 = (i20 | 0) == 0 ? 0 : i20 + i7 | 0;
 if (HEAP32[i21 >> 2] | 0) {
  i2 = i29 + 24 | 0;
  i1 = 0;
  do {
   i3 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i7, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) >> 2] | 0) | 0;
   if ((i3 | 0) != -1) if ((HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0) == 3) HEAP8[i8 + i3 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 L29 : do if (i1 >>> 0 > 1) {
  i2 = i40 + 36 | 0;
  i3 = i2;
  i4 = i7 + 4 | 0;
  i5 = i4;
  if (i6) i1 = 1; else {
   i2 = 1;
   while (1) {
    if ((HEAP8[i8 + (HEAP32[(HEAP32[i4 >> 2] | 0) + i5 + (i2 << 3) >> 2] | 0) >> 0] | 0) == 1) {
     HEAP8[i8 + i2 >> 0] = 1;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i1 >>> 0) break L29;
   }
  }
  do {
   if ((HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2] | 0) == -1) {
    if ((HEAP8[i8 + (HEAP32[(HEAP32[i4 >> 2] | 0) + i5 + (i1 << 3) >> 2] | 0) >> 0] | 0) == 1) HEAP8[i8 + i1 >> 0] = 1;
   } else HEAP8[i8 + i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if (HEAP32[i12 >> 2] | 0) {
  i2 = i13 + 20 | 0;
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) + 4 >> 2] | 0;
   if ((i3 | 0) == -1) HEAP8[(HEAP32[i11 >> 2] | 0) + i1 >> 0] = 0; else HEAP8[(HEAP32[i11 >> 2] | 0) + i1 >> 0] = HEAP8[(HEAP32[i14 >> 2] | 0) + i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i10);
  HEAP32[i14 >> 2] = 0;
 }
 HEAP32[i32 >> 2] = 0;
 i13 = i32 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i32 + 40 >> 2] = -1;
 HEAP32[i32 + 44 >> 2] = -1;
 HEAP32[i32 + 48 >> 2] = -1;
 i2 = HEAP32[i29 >> 2] | 0;
 i20 = i32 + 8 | 0;
 HEAP32[i20 >> 2] = i2;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i2 << 4 | 0, 4) | 0;
  i3 = i1 + (i2 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i14 = i32 + 12 | 0;
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i15 >> 2] | 0;
 i15 = i32 + 16 | 0;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i2 << 4 | 0, 4) | 0;
  i3 = i1 + (i2 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i12 = i32 + 20 | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP8[i32 + 36 >> 0] = i17;
 if (HEAP32[i20 >> 2] | 0) {
  i8 = i29 + 4 | 0;
  i9 = i25 + 80 | 0;
  i7 = 0;
  do {
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP32[i2 + (i7 << 4) + 12 >> 2] = 0;
   HEAP32[i2 + (i7 << 4) + 4 >> 2] = 0;
   i2 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i31, HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 4) >> 2] | 0) | 0;
   i3 = HEAP32[i26 >> 2] | 0;
   L71 : do if (i3 | 0) {
    i4 = HEAP32[i33 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i4 + (i1 * 12 | 0) + 8 >> 2] | 0) == (i2 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i3 >>> 0) break L71;
    }
    if ((i1 | 0) != -1) {
     i5 = HEAP32[i8 >> 2] | 0;
     i6 = i5 + (i7 << 4) | 0;
     i1 = HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i2 = HEAP32[i14 >> 2] | 0;
     i3 = i2 + (i7 << 4) | 0;
     if (HEAP8[i5 + (i7 << 4) + 14 >> 0] | 0) {
      __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i25, i6, i1, i3) | 0;
      break;
     }
     switch (HEAP16[i5 + (i7 << 4) + 12 >> 1] | 0) {
     case 95:
      break L71;
     case 1:
      {
       if ((HEAP32[i5 + (i7 << 4) + 4 >> 2] | 0) != (HEAP32[i9 >> 2] | 0)) break L71;
       if (!(HEAP32[i6 >> 2] | 0)) break L71;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i2 + (i7 << 4) + 4 >> 2] = 7;
       HEAP32[i2 + (i7 << 4) + 12 >> 2] = HEAP32[i1 + 28 >> 2];
       break L71;
      }
     case 114:
      {
       __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i25, i6, i1, i3) | 0;
       break L71;
      }
     default:
      {
       __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i25, i6, i1, i3) | 0;
       break L71;
      }
     }
    }
   } while (0);
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i21 >> 2] | 0) {
  i7 = i29 + 24 | 0;
  i8 = i19;
  i9 = i40 + 36 | 0;
  i10 = i9;
  i6 = 0;
  do {
   i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 3) >> 2] | 0;
   i1 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i31, i11) | 0;
   if ((i1 | 0) != -1) {
    i2 = HEAP32[i19 >> 2] | 0;
    if (i2 | 0) {
     i18 = i2 + i8 + 40 | 0;
     if (HEAP32[(HEAP32[i18 >> 2] | 0) + i18 >> 2] | 0) if ((HEAP32[(HEAP32[i9 >> 2] | 0) + i10 + (i1 << 2) >> 2] | 0) != -1) {
      i2 = HEAP32[i22 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i37 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 >= i1 >>> 0) break;
       if ((i4 | 0) > -1) {
        HEAP32[i37 >> 2] = i1;
        HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i1 << 3, 4, i38, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i38, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i18 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i22 >> 2] << 3 | 0) | 0;
        HEAP32[i37 >> 2] = i1;
        HEAP32[i34 >> 2] = i18;
        break;
       }
      } while (0);
      HEAP32[i22 >> 2] = i3;
      i18 = (HEAP32[i34 >> 2] | 0) + (i2 << 3) | 0;
      HEAP32[i18 >> 2] = 0;
      HEAP32[i18 + 4 >> 2] = i11;
     }
    }
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i15 >> 2] | 0) {
  i7 = i29 + 12 | 0;
  i6 = 0;
  do {
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i2 + (i6 << 4) + 12 >> 2] = 0;
   HEAP32[i2 + (i6 << 4) + 4 >> 2] = 0;
   i2 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i31, HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 4) >> 2] | 0) | 0;
   i3 = HEAP32[i26 >> 2] | 0;
   L111 : do if (i3 | 0) {
    i5 = HEAP32[i33 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0) == (i2 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i3 >>> 0) break L111;
    }
    if ((i1 | 0) != -1) {
     i3 = HEAP32[i7 >> 2] | 0;
     i4 = i3 + (i6 << 4) | 0;
     i1 = HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i2 = (HEAP32[i12 >> 2] | 0) + (i6 << 4) | 0;
     if (HEAP8[i3 + (i6 << 4) + 14 >> 0] | 0) {
      __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i25, i4, i1, i2) | 0;
      break;
     }
     if ((HEAP16[i3 + (i6 << 4) + 12 >> 1] | 0) != 114) break;
     __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i25, i4, i1, i2) | 0;
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 i10 = HEAP32[i24 >> 2] | 0;
 i10 = __ZN11UnityEngine9Animation31CreateControllerBindingConstantEPKN7mecanim9animation18ControllerConstantEPKNS2_12AnimationSetEPNS1_18ValueArrayConstantEjPKNS2_14AvatarConstantERNS1_6memory9AllocatorE(i27, i10, HEAP32[i10 + 20 >> 2] | 0, i23, i40, i28) | 0;
 HEAP32[i32 + 32 >> 2] = i10;
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 if ((i30 | 0) > 0 & (i10 | 0) != 0) {
  i7 = i29 + 24 | 0;
  i2 = -1;
  i3 = -1;
  i6 = 0;
  i1 = -1;
  while (1) {
   i5 = HEAP32[i7 >> 2] | 0;
   i8 = HEAP32[i5 + (i6 << 3) + 4 >> 2] | 0;
   i9 = (i8 | 0) == 3;
   L128 : do if (i9) {
    i4 = i2;
    i3 = i3 + 1 | 0;
   } else switch (i8 | 0) {
   case 2:
   case 4:
    {
     i1 = i1 + 1 | 0;
     i4 = i2;
     break L128;
    }
   case 1:
    {
     i4 = i2 + 1 | 0;
     break L128;
    }
   default:
    {
     i4 = i2;
     break L128;
    }
   } while (0);
   i2 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i31, HEAP32[i5 + (i6 << 3) >> 2] | 0) | 0;
   L135 : do if ((i2 | 0) != -1) {
    if (i9) {
     HEAP32[i10 + (i2 * 12 | 0) + 8 >> 2] = i3;
     break;
    }
    switch (i8 | 0) {
    case 2:
    case 4:
     {
      HEAP32[i10 + (i2 * 12 | 0) + 4 >> 2] = i1;
      break L135;
     }
    case 1:
     {
      HEAP32[i10 + (i2 * 12 | 0) >> 2] = i4;
      break L135;
     }
    default:
     break L135;
    }
   } while (0);
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i30 | 0)) break; else i2 = i4;
  }
 }
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i32 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = i2 + (i1 << 4) + 12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if (i5 | 0) {
    if (__ZNK6Object8HasEventEPFvPvS0_iEPKv(i5, fb + 913 | 0, i32) | 0) break;
    __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i4 >> 2] | 0, fb + 913 | 0, i32);
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i3 = i5 + (i1 << 4) + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if (i4 | 0) {
    if (__ZNK6Object8HasEventEPFvPvS0_iEPKv(i4, fb + 913 | 0, i32) | 0) break;
    __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i3 >> 2] | 0, fb + 913 | 0, i32);
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i5 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i3 = i5 + (i1 << 4) + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if (i4 | 0) {
    if (__ZNK6Object8HasEventEPFvPvS0_iEPKv(i4, fb + 913 | 0, i32) | 0) break;
    __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i3 >> 2] | 0, fb + 913 | 0, i32);
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN11UnityEngine9AnimationL23InitializeDefaultValuesERKNS0_30AnimatorGenericBindingConstantEPKN7mecanim9animation14AvatarConstantEb(i32, i40, 0);
 if ((HEAP32[i37 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, i38);
  HEAP32[i34 >> 2] = 0;
 }
 if ((HEAP32[i35 >> 2] | 0) <= -1) {
  STACKTOP = i39;
  return i32 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i36);
 HEAP32[i33 >> 2] = 0;
 STACKTOP = i39;
 return i32 | 0;
}

function _vfscanf(i34, i1, i23) {
 i34 = i34 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i36 + 16 | 0;
 i29 = i36 + 8 | 0;
 i30 = i36 + 33 | 0;
 i31 = i36;
 i32 = i36 + 32 | 0;
 if ((HEAP32[i34 + 76 >> 2] | 0) > -1) i35 = ___lockfile(i34) | 0; else i35 = 0;
 i4 = HEAP8[i1 >> 0] | 0;
 L4 : do if (!(i4 << 24 >> 24)) i1 = 0; else {
  i17 = i34 + 4 | 0;
  i18 = i34 + 100 | 0;
  i19 = i34 + 108 | 0;
  i20 = i34 + 8 | 0;
  i21 = i30 + 10 | 0;
  i22 = i30 + 33 | 0;
  i16 = i29 + 4 | 0;
  i24 = i30 + 46 | 0;
  i25 = i30 + 94 | 0;
  i26 = i30 + 1 | 0;
  i27 = i30 + 1 | 0;
  i8 = i1;
  i13 = 0;
  i1 = 0;
  i3 = 0;
  i2 = 0;
  L6 : while (1) {
   L8 : do if (!(_isspace(i4 & 255) | 0)) {
    i4 = i4 << 24 >> 24 == 37;
    L10 : do if (i4) {
     i5 = i8 + 1 | 0;
     i6 = HEAP8[i5 >> 0] | 0;
     L12 : do switch (i6 << 24 >> 24) {
     case 37:
      break L10;
     case 42:
      {
       i15 = 0;
       i5 = i8 + 2 | 0;
       break;
      }
     default:
      {
       i4 = (i6 & 255) + -48 | 0;
       if (i4 >>> 0 < 10) if ((HEAP8[i8 + 2 >> 0] | 0) == 36) {
        HEAP32[i28 >> 2] = HEAP32[i23 >> 2];
        while (1) {
         i15 = (HEAP32[i28 >> 2] | 0) + (4 - 1) & ~(4 - 1);
         i5 = HEAP32[i15 >> 2] | 0;
         HEAP32[i28 >> 2] = i15 + 4;
         if (i4 >>> 0 > 1) i4 = i4 + -1 | 0; else break;
        }
        i15 = i5;
        i5 = i8 + 3 | 0;
        break L12;
       }
       i14 = (HEAP32[i23 >> 2] | 0) + (4 - 1) & ~(4 - 1);
       i15 = HEAP32[i14 >> 2] | 0;
       HEAP32[i23 >> 2] = i14 + 4;
      }
     } while (0);
     i8 = HEAP8[i5 >> 0] | 0;
     i4 = i8 & 255;
     if ((i4 + -48 | 0) >>> 0 < 10) {
      i6 = 0;
      do {
       i6 = (i6 * 10 | 0) + -48 + i4 | 0;
       i5 = i5 + 1 | 0;
       i8 = HEAP8[i5 >> 0] | 0;
       i4 = i8 & 255;
      } while ((i4 + -48 | 0) >>> 0 < 10);
     } else i6 = 0;
     if (i8 << 24 >> 24 == 109) {
      i8 = i5 + 1 | 0;
      i4 = (i15 | 0) != 0 & 1;
      i3 = 0;
      i2 = 0;
      i5 = i8;
      i8 = HEAP8[i8 >> 0] | 0;
     } else i4 = 0;
     i9 = i5 + 1 | 0;
     switch (i8 << 24 >> 24) {
     case 104:
      {
       i14 = (HEAP8[i9 >> 0] | 0) == 104;
       i8 = i14 ? -2 : -1;
       i5 = i14 ? i5 + 2 | 0 : i9;
       break;
      }
     case 108:
      {
       i14 = (HEAP8[i9 >> 0] | 0) == 108;
       i8 = i14 ? 3 : 1;
       i5 = i14 ? i5 + 2 | 0 : i9;
       break;
      }
     case 106:
      {
       i8 = 3;
       i5 = i9;
       break;
      }
     case 116:
     case 122:
      {
       i8 = 1;
       i5 = i9;
       break;
      }
     case 76:
      {
       i8 = 2;
       i5 = i9;
       break;
      }
     case 110:
     case 112:
     case 67:
     case 83:
     case 91:
     case 99:
     case 115:
     case 88:
     case 71:
     case 70:
     case 69:
     case 65:
     case 103:
     case 102:
     case 101:
     case 97:
     case 120:
     case 117:
     case 111:
     case 105:
     case 100:
      {
       i8 = 0;
       break;
      }
     default:
      {
       i33 = 154;
       break L6;
      }
     }
     i11 = HEAPU8[i5 >> 0] | 0;
     i12 = (i11 & 47 | 0) == 3;
     i11 = i12 ? i11 | 32 : i11;
     i12 = i12 ? 1 : i8;
     i10 = i11 & 255;
     switch (i10 << 24 >> 24) {
     case 99:
      {
       i6 = (i6 | 0) < 1 ? 1 : i6;
       break;
      }
     case 91:
      break;
     case 110:
      {
       if (!i15) {
        i6 = i13;
        break L8;
       }
       switch (i12 | 0) {
       case -2:
        {
         HEAP8[i15 >> 0] = i13;
         i6 = i13;
         break L8;
        }
       case -1:
        {
         HEAP16[i15 >> 1] = i13;
         i6 = i13;
         break L8;
        }
       case 0:
        {
         HEAP32[i15 >> 2] = i13;
         i6 = i13;
         break L8;
        }
       case 1:
        {
         HEAP32[i15 >> 2] = i13;
         i6 = i13;
         break L8;
        }
       case 3:
        {
         i6 = i15;
         HEAP32[i6 >> 2] = i13;
         HEAP32[i6 + 4 >> 2] = ((i13 | 0) < 0) << 31 >> 31;
         i6 = i13;
         break L8;
        }
       default:
        {
         i6 = i13;
         break L8;
        }
       }
      }
     default:
      {
       ___shlim(i34, 0);
       do {
        i8 = HEAP32[i17 >> 2] | 0;
        if (i8 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
         HEAP32[i17 >> 2] = i8 + 1;
         i8 = HEAPU8[i8 >> 0] | 0;
        } else i8 = ___shgetc(i34) | 0;
       } while ((_isspace(i8) | 0) != 0);
       if (!(HEAP32[i18 >> 2] | 0)) i8 = HEAP32[i17 >> 2] | 0; else {
        i8 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
        HEAP32[i17 >> 2] = i8;
       }
       i13 = (HEAP32[i19 >> 2] | 0) + i13 + i8 - (HEAP32[i20 >> 2] | 0) | 0;
      }
     }
     ___shlim(i34, i6);
     i8 = HEAP32[i17 >> 2] | 0;
     i9 = HEAP32[i18 >> 2] | 0;
     if (i8 >>> 0 < i9 >>> 0) HEAP32[i17 >> 2] = i8 + 1; else {
      if ((___shgetc(i34) | 0) < 0) {
       i33 = 154;
       break L6;
      }
      i9 = HEAP32[i18 >> 2] | 0;
     }
     if (i9 | 0) HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
     L68 : do switch (i10 << 24 >> 24) {
     case 91:
     case 99:
     case 115:
      {
       i14 = (i11 | 0) == 99;
       L70 : do if ((i11 | 16 | 0) == 115) {
        _memset(i26 | 0, -1, 256) | 0;
        HEAP8[i30 >> 0] = 0;
        if ((i11 | 0) == 115) {
         HEAP8[i22 >> 0] = 0;
         HEAP8[i21 >> 0] = 0;
         HEAP8[i21 + 1 >> 0] = 0;
         HEAP8[i21 + 2 >> 0] = 0;
         HEAP8[i21 + 3 >> 0] = 0;
         HEAP8[i21 + 4 >> 0] = 0;
        }
       } else {
        i10 = i5 + 1 | 0;
        i11 = (HEAP8[i10 >> 0] | 0) == 94;
        i8 = i11 & 1;
        i5 = i11 ? i5 + 2 | 0 : i10;
        _memset(i27 | 0, i11 & 1 | 0, 256) | 0;
        HEAP8[i30 >> 0] = 0;
        switch (HEAP8[i5 >> 0] | 0) {
        case 45:
         {
          i11 = (i8 ^ 1) & 255;
          HEAP8[i24 >> 0] = i11;
          i5 = i5 + 1 | 0;
          break;
         }
        case 93:
         {
          i11 = (i8 ^ 1) & 255;
          HEAP8[i25 >> 0] = i11;
          i5 = i5 + 1 | 0;
          break;
         }
        default:
         i11 = (i8 ^ 1) & 255;
        }
        while (1) {
         i8 = HEAP8[i5 >> 0] | 0;
         L81 : do switch (i8 << 24 >> 24) {
         case 0:
          {
           i33 = 154;
           break L6;
          }
         case 93:
          break L70;
         case 45:
          {
           i10 = i5 + 1 | 0;
           i8 = HEAP8[i10 >> 0] | 0;
           switch (i8 << 24 >> 24) {
           case 93:
           case 0:
            {
             i8 = 45;
             break L81;
            }
           default:
            {}
           }
           i5 = HEAP8[i5 + -1 >> 0] | 0;
           if ((i5 & 255) < (i8 & 255)) {
            i5 = i5 & 255;
            do {
             i5 = i5 + 1 | 0;
             HEAP8[i30 + i5 >> 0] = i11;
             i8 = HEAP8[i10 >> 0] | 0;
            } while ((i5 | 0) < (i8 & 255 | 0));
            i5 = i10;
           } else i5 = i10;
           break;
          }
         default:
          {}
         } while (0);
         HEAP8[i30 + ((i8 & 255) + 1) >> 0] = i11;
         i5 = i5 + 1 | 0;
        }
       } while (0);
       i8 = i14 ? i6 + 1 | 0 : 31;
       i11 = (i12 | 0) == 1;
       i12 = (i4 | 0) != 0;
       L89 : do if (i11) {
        if (i12) {
         i3 = _malloc(i8 << 2) | 0;
         if (!i3) {
          i2 = 0;
          i33 = 154;
          break L6;
         }
        } else i3 = i15;
        HEAP32[i29 >> 2] = 0;
        HEAP32[i16 >> 2] = 0;
        i10 = i8;
        i2 = 0;
        L95 : while (1) {
         i9 = (i3 | 0) == 0;
         do {
          L99 : while (1) {
           i8 = HEAP32[i17 >> 2] | 0;
           if (i8 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
            HEAP32[i17 >> 2] = i8 + 1;
            i8 = HEAPU8[i8 >> 0] | 0;
           } else i8 = ___shgetc(i34) | 0;
           if (!(HEAP8[i30 + (i8 + 1) >> 0] | 0)) break L95;
           HEAP8[i32 >> 0] = i8;
           switch (_mbrtowc(i31, i32, 1, i29) | 0) {
           case -1:
            {
             i2 = 0;
             i33 = 154;
             break L6;
            }
           case -2:
            break;
           default:
            break L99;
           }
          }
          if (!i9) {
           HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i31 >> 2];
           i2 = i2 + 1 | 0;
          }
         } while (!(i12 & (i2 | 0) == (i10 | 0)));
         i2 = i10 << 1 | 1;
         i8 = _realloc(i3, i2 << 2) | 0;
         if (!i8) {
          i2 = 0;
          i33 = 154;
          break L6;
         } else {
          i9 = i10;
          i10 = i2;
          i3 = i8;
          i2 = i9;
         }
        }
        if (!(_mbsinit(i29) | 0)) {
         i2 = 0;
         i33 = 154;
         break L6;
        } else {
         i9 = i2;
         i2 = 0;
        }
       } else {
        if (i12) {
         i2 = _malloc(i8) | 0;
         if (!i2) {
          i2 = 0;
          i3 = 0;
          i33 = 154;
          break L6;
         } else {
          i9 = i8;
          i3 = 0;
         }
         while (1) {
          do {
           i8 = HEAP32[i17 >> 2] | 0;
           if (i8 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
            HEAP32[i17 >> 2] = i8 + 1;
            i8 = HEAPU8[i8 >> 0] | 0;
           } else i8 = ___shgetc(i34) | 0;
           if (!(HEAP8[i30 + (i8 + 1) >> 0] | 0)) {
            i9 = i3;
            i3 = 0;
            break L89;
           }
           HEAP8[i2 + i3 >> 0] = i8;
           i3 = i3 + 1 | 0;
          } while ((i3 | 0) != (i9 | 0));
          i3 = i9 << 1 | 1;
          i8 = _realloc(i2, i3) | 0;
          if (!i8) {
           i3 = 0;
           i33 = 154;
           break L6;
          } else {
           i10 = i9;
           i9 = i3;
           i2 = i8;
           i3 = i10;
          }
         }
        }
        if (!i15) {
         i3 = i9;
         while (1) {
          i2 = HEAP32[i17 >> 2] | 0;
          if (i2 >>> 0 < i3 >>> 0) {
           HEAP32[i17 >> 2] = i2 + 1;
           i2 = HEAPU8[i2 >> 0] | 0;
          } else i2 = ___shgetc(i34) | 0;
          if (!(HEAP8[i30 + (i2 + 1) >> 0] | 0)) {
           i9 = 0;
           i2 = 0;
           i3 = 0;
           break L89;
          }
          i3 = HEAP32[i18 >> 2] | 0;
         }
        } else {
         i8 = 0;
         i3 = i9;
         while (1) {
          i2 = HEAP32[i17 >> 2] | 0;
          if (i2 >>> 0 < i3 >>> 0) {
           HEAP32[i17 >> 2] = i2 + 1;
           i2 = HEAPU8[i2 >> 0] | 0;
          } else i2 = ___shgetc(i34) | 0;
          if (!(HEAP8[i30 + (i2 + 1) >> 0] | 0)) {
           i9 = i8;
           i2 = i15;
           i3 = 0;
           break L89;
          }
          HEAP8[i15 + i8 >> 0] = i2;
          i8 = i8 + 1 | 0;
          i3 = HEAP32[i18 >> 2] | 0;
         }
        }
       } while (0);
       if (!(HEAP32[i18 >> 2] | 0)) i8 = HEAP32[i17 >> 2] | 0; else {
        i8 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
        HEAP32[i17 >> 2] = i8;
       }
       i8 = i8 - (HEAP32[i20 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
       if (!i8) break L6;
       if (!((i8 | 0) == (i6 | 0) | i14 ^ 1)) break L6;
       do if (i12) if (i11) {
        HEAP32[i15 >> 2] = i3;
        break;
       } else {
        HEAP32[i15 >> 2] = i2;
        break;
       } while (0);
       if (!i14) {
        if (i3 | 0) HEAP32[i3 + (i9 << 2) >> 2] = 0;
        if (!i2) {
         i2 = 0;
         break L68;
        }
        HEAP8[i2 + i9 >> 0] = 0;
       }
       break;
      }
     case 120:
     case 88:
     case 112:
      {
       i6 = 16;
       i33 = 136;
       break;
      }
     case 111:
      {
       i6 = 8;
       i33 = 136;
       break;
      }
     case 117:
     case 100:
      {
       i6 = 10;
       i33 = 136;
       break;
      }
     case 105:
      {
       i6 = 0;
       i33 = 136;
       break;
      }
     case 71:
     case 103:
     case 70:
     case 102:
     case 69:
     case 101:
     case 65:
     case 97:
      {
       d7 = +___floatscan(i34, i12, 0);
       if ((HEAP32[i19 >> 2] | 0) == ((HEAP32[i20 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0)) break L6;
       if (i15) switch (i12 | 0) {
       case 0:
        {
         HEAPF32[i15 >> 2] = Math_fround(d7);
         break L68;
        }
       case 1:
        {
         HEAPF64[i15 >> 3] = d7;
         break L68;
        }
       case 2:
        {
         HEAPF64[i15 >> 3] = d7;
         break L68;
        }
       default:
        break L68;
       }
       break;
      }
     default:
      {}
     } while (0);
     L169 : do if ((i33 | 0) == 136) {
      i33 = 0;
      i6 = ___intscan(i34, i6, 0, -1, -1) | 0;
      i8 = getTempRet0() | 0;
      if ((HEAP32[i19 >> 2] | 0) == ((HEAP32[i20 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0)) break L6;
      if ((i15 | 0) != 0 & (i11 | 0) == 112) {
       HEAP32[i15 >> 2] = i6;
       break;
      }
      if (i15) switch (i12 | 0) {
      case -2:
       {
        HEAP8[i15 >> 0] = i6;
        break L169;
       }
      case -1:
       {
        HEAP16[i15 >> 1] = i6;
        break L169;
       }
      case 0:
       {
        HEAP32[i15 >> 2] = i6;
        break L169;
       }
      case 1:
       {
        HEAP32[i15 >> 2] = i6;
        break L169;
       }
      case 3:
       {
        i14 = i15;
        HEAP32[i14 >> 2] = i6;
        HEAP32[i14 + 4 >> 2] = i8;
        break L169;
       }
      default:
       break L169;
      }
     } while (0);
     i1 = ((i15 | 0) != 0 & 1) + i1 | 0;
     i6 = (HEAP32[i19 >> 2] | 0) + i13 + (HEAP32[i17 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0;
     break L8;
    } while (0);
    i5 = i8 + (i4 & 1) | 0;
    ___shlim(i34, 0);
    i4 = HEAP32[i17 >> 2] | 0;
    if (i4 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
     HEAP32[i17 >> 2] = i4 + 1;
     i4 = HEAPU8[i4 >> 0] | 0;
    } else i4 = ___shgetc(i34) | 0;
    if ((i4 | 0) != (HEAPU8[i5 >> 0] | 0)) {
     i33 = 22;
     break L6;
    }
    i6 = i13 + 1 | 0;
   } else {
    i5 = i8;
    while (1) {
     i4 = i5 + 1 | 0;
     if (!(_isspace(HEAPU8[i4 >> 0] | 0) | 0)) break; else i5 = i4;
    }
    ___shlim(i34, 0);
    do {
     i4 = HEAP32[i17 >> 2] | 0;
     if (i4 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
      HEAP32[i17 >> 2] = i4 + 1;
      i4 = HEAPU8[i4 >> 0] | 0;
     } else i4 = ___shgetc(i34) | 0;
    } while ((_isspace(i4) | 0) != 0);
    if (!(HEAP32[i18 >> 2] | 0)) i4 = HEAP32[i17 >> 2] | 0; else {
     i4 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
     HEAP32[i17 >> 2] = i4;
    }
    i6 = (HEAP32[i19 >> 2] | 0) + i13 + i4 - (HEAP32[i20 >> 2] | 0) | 0;
   } while (0);
   i8 = i5 + 1 | 0;
   i4 = HEAP8[i8 >> 0] | 0;
   if (!(i4 << 24 >> 24)) break L4; else i13 = i6;
  }
  if ((i33 | 0) == 22) {
   if (HEAP32[i18 >> 2] | 0) HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
   if ((i1 | 0) != 0 | (i4 | 0) > -1) break; else {
    i4 = 0;
    i1 = i3;
    i33 = 155;
   }
  } else if ((i33 | 0) == 154) if (!i1) {
   i1 = i3;
   i33 = 155;
  }
  if ((i33 | 0) == 155) {
   i3 = i1;
   i1 = -1;
  }
  if (i4) {
   _free(i2);
   _free(i3);
  }
 } while (0);
 if (i35 | 0) ___unlockfile(i34);
 STACKTOP = i36;
 return i1 | 0;
}

function __ZN7mecanim5human5Human8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 12 | 0;
 i4 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906072 | 0, gb + 905989 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i7, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i9, i7 + 40 | 0, gb + 906080 | 0, 0);
 i2 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906091 | 0, gb + 905830 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i5 = i2;
    i1 = i1 | 0 ? i1 - i5 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i5;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i9, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906106 | 0, gb + 905830 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 60, 4) | 0;
    __ZN7mecanim4hand4HandC2Ev(i1);
    i5 = i2;
    i1 = i1 | 0 ? i1 - i5 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i5;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags(i9, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906117 | 0, gb + 905830 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 60, 4) | 0;
    __ZN7mecanim4hand4HandC2Ev(i1);
    i5 = i2;
    i1 = i1 | 0 ? i1 - i5 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i5;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags(i9, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i9 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 60;
 HEAP32[i4 + 4 >> 2] = i7 + 56;
 HEAP32[i4 + 8 >> 2] = i3;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906129 | 0, i3, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 68;
 HEAP32[i4 + 4 >> 2] = i7 + 64;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906139 | 0, i3, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i7 + 72;
 i2 = HEAP32[gb + 37256 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906155 | 0, i2, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi24EEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i7 + 168;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906172 | 0, i2, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi24EEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i7 + 264;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906188 | 0, i2, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi24EEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 360 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932253 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 69; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 69; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 69) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 364 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906204 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 80; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 80; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 80) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906215 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 91; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 91; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 91) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906230 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 102; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 102; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 102) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 376 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906246 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 113; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 113; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 113) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 380 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906257 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i6 = 124; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i6 = 124;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i6 | 0) == 124) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 384 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906270 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i6 = 135; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i6 = 135;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i6 | 0) == 135) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 388 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906283 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i6 = 146; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i6 = 146;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i6 | 0) == 146) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i9 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 392 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906297 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L207 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L207;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 393 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906311 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  L219 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L219;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 394 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906326 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 L232 : do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i8 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L232;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z16WarmupAllShadersv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, d63 = 0.0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0;
 i69 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i69 + 24 | 0;
 i68 = i69 + 8 | 0;
 i60 = i69;
 i54 = i69 + 288 | 0;
 i55 = i69 + 272 | 0;
 i64 = i69 + 76 | 0;
 i65 = i69 + 64 | 0;
 i66 = i69 + 52 | 0;
 i67 = i69 + 32 | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i1 + 4192 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 496 >> 2] | 0, i1 | 0);
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0) {
   i62 = 1;
   i10 = 3;
  }
 } else {
  i62 = 0;
  i10 = 3;
 }
 if ((i10 | 0) == 3) {
  if ((HEAP16[gb + 1166384 + 6 >> 1] | 0) > -1) {
   HEAP32[i60 >> 2] = 0;
   HEAP32[i53 >> 2] = HEAP32[i60 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166384 | 0, i53);
   i61 = gb + 1166384 | 0;
  } else i61 = 0;
  d63 = +__Z19GetTimeSinceStartupv();
  HEAP32[i55 >> 2] = 0;
  HEAP32[i55 + 4 >> 2] = 0;
  HEAP32[i55 + 8 >> 2] = -1;
  HEAP32[i55 + 12 >> 2] = 0;
  i1 = __Z12GetGfxDevicev() | 0;
  if ((HEAP32[i1 + 4388 >> 2] | 0) != 4) {
   i21 = __ZN9GfxDevice13GetDynamicVBOEv(i1) | 0;
   if (mftCall_iiiiiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, 60, 3, 0, 1, i55 | 0) | 0) {
    _memset(HEAP32[i55 >> 2] | 0, 0, 180) | 0;
    mftCall_viiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i55 | 0, 3, 0);
    __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i64, __Z12GetGfxDevicev() | 0);
    __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
    i22 = i65 + 4 | 0;
    HEAP32[i22 >> 2] = 0;
    i23 = i65 + 8 | 0;
    HEAP32[i23 >> 2] = 0;
    i56 = i65 + 4 | 0;
    HEAP32[i65 >> 2] = i56;
    i24 = i66 + 4 | 0;
    HEAP32[i24 >> 2] = 0;
    i25 = i66 + 8 | 0;
    HEAP32[i25 >> 2] = 0;
    i57 = i66 + 4 | 0;
    HEAP32[i66 >> 2] = i57;
    i59 = gb + 64016 | 0;
    i58 = HEAP32[i59 + 4 >> 2] | 0;
    i26 = i60;
    HEAP32[i26 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i26 + 4 >> 2] = i58;
    HEAP32[i67 >> 2] = 0;
    i26 = i67 + 12 | 0;
    HEAP32[i26 >> 2] = 0;
    i58 = i67 + 16 | 0;
    HEAP32[i58 >> 2] = 0;
    i59 = i67 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i53, i60);
    i51 = i53;
    i52 = HEAP32[i51 + 4 >> 2] | 0;
    i3 = i59;
    HEAP32[i3 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i3 + 4 >> 2] = i52;
    __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31552 | 0, i67, 0);
    i3 = HEAP32[i26 >> 2] | 0;
    if (!i3) {
     i2 = 0;
     i1 = 0;
    } else {
     i27 = i54 + 36 | 0;
     i28 = i54 + 40 | 0;
     i29 = i54 + 68 | 0;
     i30 = i54 + 80 | 0;
     i31 = i54 + 84 | 0;
     i32 = i54 + 72 | 0;
     i33 = i54 + 88 | 0;
     i34 = i54 + 100 | 0;
     i35 = i54 + 104 | 0;
     i36 = i54 + 92 | 0;
     i37 = i54 + 108 | 0;
     i38 = i54 + 120 | 0;
     i39 = i54 + 124 | 0;
     i40 = i54 + 112 | 0;
     i41 = i54 + 128 | 0;
     i42 = i54 + 132 | 0;
     i43 = i54 + 136 | 0;
     i44 = i54 + 144 | 0;
     i45 = i54 + 44 | 0;
     i46 = i54 + 148 | 0;
     i47 = i54 + 149 | 0;
     i48 = i54 + 88 | 0;
     i49 = i54 + 68 | 0;
     i50 = i56;
     i51 = i57;
     i52 = i54 + 4 | 0;
     i2 = 0;
     i1 = 0;
     i20 = 0;
     do {
      i18 = HEAP32[(HEAP32[i67 >> 2] | 0) + (i20 << 2) >> 2] | 0;
      i19 = HEAP32[i18 + 32 >> 2] | 0;
      if (i19) {
       i3 = i54;
       i4 = i3 + 36 | 0;
       do {
        HEAP32[i3 >> 2] = 0;
        i3 = i3 + 4 | 0;
       } while ((i3 | 0) < (i4 | 0));
       HEAP32[i28 >> 2] = 1;
       HEAP32[i27 >> 2] = gb + 33952 + 8;
       i5 = gb + 63280 | 0;
       i17 = HEAP32[i5 + 4 >> 2] | 0;
       i16 = i60;
       HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i16 + 4 >> 2] = i17;
       HEAP32[i29 >> 2] = 0;
       HEAP32[i30 >> 2] = 0;
       HEAP32[i31 >> 2] = 0;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i53, i60);
       i16 = i53;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i5 = i32;
       HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i5 + 4 >> 2] = i17;
       i5 = gb + 63280 | 0;
       i17 = HEAP32[i5 + 4 >> 2] | 0;
       i16 = i60;
       HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i16 + 4 >> 2] = i17;
       HEAP32[i33 >> 2] = 0;
       HEAP32[i34 >> 2] = 0;
       HEAP32[i35 >> 2] = 0;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i53, i60);
       i16 = i53;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i5 = i36;
       HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i5 + 4 >> 2] = i17;
       i5 = gb + 63280 | 0;
       i17 = HEAP32[i5 + 4 >> 2] | 0;
       i16 = i60;
       HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i16 + 4 >> 2] = i17;
       HEAP32[i37 >> 2] = 0;
       HEAP32[i38 >> 2] = 0;
       HEAP32[i39 >> 2] = 0;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i53, i60);
       i16 = i53;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i5 = i40;
       HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i5 + 4 >> 2] = i17;
       HEAP32[i41 >> 2] = 0;
       HEAP32[i42 >> 2] = 0;
       i5 = gb + 63280 | 0;
       i17 = HEAP32[i5 + 4 >> 2] | 0;
       i16 = i43;
       HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i16 + 4 >> 2] = i17;
       HEAP8[i44 >> 0] = 1;
       HEAP32[i45 >> 2] = 0;
       HEAP32[i45 + 4 >> 2] = 0;
       HEAP32[i45 + 8 >> 2] = 0;
       HEAP32[i45 + 12 >> 2] = 0;
       HEAP32[i45 + 16 >> 2] = 0;
       HEAP32[i45 + 20 >> 2] = 0;
       HEAP8[i46 >> 0] = 1;
       HEAP8[i47 >> 0] = 0;
       __ZN17ShaderPassContext8CopyFromERKS_(i54, HEAP32[gb + 1166248 >> 2] | 0);
       i16 = HEAP32[i19 + 92 >> 2] | 0;
       i17 = i19 + 4 | 0;
       i5 = HEAP32[i17 >> 2] | 0;
       i4 = HEAP32[i19 >> 2] | 0;
       if ((i5 | 0) == (i4 | 0)) i3 = 0; else {
        i3 = 0;
        i15 = 0;
        do {
         i13 = HEAP32[i4 + (i15 << 2) >> 2] | 0;
         i14 = i13 + 20 | 0;
         if (HEAP32[i14 >> 2] | 0) {
          i12 = 0;
          do {
           i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i12 << 2) >> 2] | 0;
           L24 : do if (!(HEAP32[i11 + 744 >> 2] | 0)) {
            i4 = HEAP32[i56 >> 2] | 0;
            do if (!i4) {
             HEAP32[i53 >> 2] = i56;
             i7 = i50;
             i6 = i56;
             i5 = i11;
            } else {
             i5 = i56;
             i7 = i4;
             L28 : while (1) {
              i6 = i7;
              while (1) {
               if ((HEAP32[i6 + 16 >> 2] | 0) >>> 0 >= i11 >>> 0) break;
               i6 = HEAP32[i6 + 4 >> 2] | 0;
               if (!i6) break L28;
              }
              i7 = HEAP32[i6 >> 2] | 0;
              if (!i7) {
               i5 = i6;
               break;
              } else i5 = i6;
             }
             if ((i5 | 0) != (i56 | 0)) if (i11 >>> 0 >= (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
              i4 = 0;
              break L24;
             }
             i8 = i11;
             while (1) {
              i5 = HEAP32[i4 + 16 >> 2] | 0;
              if (i11 >>> 0 < i5 >>> 0) {
               i5 = HEAP32[i4 >> 2] | 0;
               if (!i5) {
                i10 = 35;
                break;
               } else i4 = i5;
              } else {
               if (i5 >>> 0 >= i11 >>> 0) {
                i10 = 40;
                break;
               }
               i6 = i4 + 4 | 0;
               i5 = HEAP32[i6 >> 2] | 0;
               if (!i5) {
                i10 = 39;
                break;
               } else i4 = i5;
              }
             }
             if ((i10 | 0) == 35) {
              HEAP32[i53 >> 2] = i4;
              i7 = i4;
              i6 = i4;
              i5 = i8;
              break;
             } else if ((i10 | 0) == 39) {
              HEAP32[i53 >> 2] = i4;
              i7 = i4;
              i5 = i8;
              break;
             } else if ((i10 | 0) == 40) {
              HEAP32[i53 >> 2] = i4;
              i7 = i4;
              i6 = i53;
              i5 = i8;
              break;
             }
            } while (0);
            if (!(HEAP32[i6 >> 2] | 0)) {
             i4 = __Znwj(20) | 0;
             HEAP32[i4 + 16 >> 2] = i5;
             HEAP32[i4 >> 2] = 0;
             HEAP32[i4 + 4 >> 2] = 0;
             HEAP32[i4 + 8 >> 2] = i7;
             HEAP32[i6 >> 2] = i4;
             i5 = HEAP32[HEAP32[i65 >> 2] >> 2] | 0;
             if (i5) {
              HEAP32[i65 >> 2] = i5;
              i4 = HEAP32[i6 >> 2] | 0;
             }
             __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i22 >> 2] | 0, i4);
             HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
            }
            i4 = HEAP32[i11 + 36 >> 2] | 0;
            i5 = HEAP32[i11 + 40 >> 2] | 0;
            i6 = (i4 | 0) != 0;
            if (i6 & (i5 | 0) != 0) i4 = (HEAP32[i4 + 20 >> 2] | 0) > (HEAP32[i5 + 20 >> 2] | 0) ? i4 : i5; else {
             i4 = i6 ? i4 : i5;
             if (!i4) {
              i4 = 1;
              break;
             }
            }
            i5 = HEAP32[i57 >> 2] | 0;
            do if (!i5) {
             HEAP32[i53 >> 2] = i57;
             i8 = i51;
             i7 = i57;
             i6 = i4;
            } else {
             i6 = i57;
             i8 = i5;
             L62 : while (1) {
              i7 = i8;
              while (1) {
               if ((HEAP32[i7 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
               i7 = HEAP32[i7 + 4 >> 2] | 0;
               if (!i7) break L62;
              }
              i8 = HEAP32[i7 >> 2] | 0;
              if (!i8) {
               i6 = i7;
               break;
              } else i6 = i7;
             }
             if ((i6 | 0) != (i57 | 0)) if (i4 >>> 0 >= (HEAP32[i6 + 16 >> 2] | 0) >>> 0) {
              i4 = 0;
              break L24;
             }
             i9 = i4;
             while (1) {
              i6 = HEAP32[i5 + 16 >> 2] | 0;
              if (i4 >>> 0 < i6 >>> 0) {
               i6 = HEAP32[i5 >> 2] | 0;
               if (!i6) {
                i10 = 59;
                break;
               } else i5 = i6;
              } else {
               if (i6 >>> 0 >= i4 >>> 0) {
                i10 = 64;
                break;
               }
               i7 = i5 + 4 | 0;
               i6 = HEAP32[i7 >> 2] | 0;
               if (!i6) {
                i10 = 63;
                break;
               } else i5 = i6;
              }
             }
             if ((i10 | 0) == 59) {
              HEAP32[i53 >> 2] = i5;
              i8 = i5;
              i7 = i5;
              i6 = i9;
              break;
             } else if ((i10 | 0) == 63) {
              HEAP32[i53 >> 2] = i5;
              i8 = i5;
              i6 = i9;
              break;
             } else if ((i10 | 0) == 64) {
              HEAP32[i53 >> 2] = i5;
              i8 = i5;
              i7 = i53;
              i6 = i9;
              break;
             }
            } while (0);
            if (!(HEAP32[i7 >> 2] | 0)) {
             i5 = __Znwj(20) | 0;
             HEAP32[i5 + 16 >> 2] = i6;
             HEAP32[i5 >> 2] = 0;
             HEAP32[i5 + 4 >> 2] = 0;
             HEAP32[i5 + 8 >> 2] = i8;
             HEAP32[i7 >> 2] = i5;
             i6 = HEAP32[HEAP32[i66 >> 2] >> 2] | 0;
             if (i6) {
              HEAP32[i66 >> 2] = i6;
              i5 = HEAP32[i7 >> 2] | 0;
             }
             __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i24 >> 2] | 0, i5);
             HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
            }
            i8 = i4 + 20 | 0;
            if ((HEAP32[i8 >> 2] | 0) <= 0) {
             i4 = 0;
             break;
            }
            i7 = i4 + 28 | 0;
            i6 = 0;
            i4 = 0;
            do {
             i5 = (HEAP32[i7 >> 2] | 0) + (i6 << 5) | 0;
             HEAP32[i52 >> 2] = HEAP32[i5 >> 2];
             HEAP32[i52 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
             HEAP32[i52 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
             HEAP32[i52 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
             HEAP32[i52 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
             HEAP32[i52 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
             HEAP32[i52 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
             HEAP32[i52 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
             i5 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(i11, 0, i16, i54, i18, 0, 0, 0) | 0;
             if (i5) {
              i70 = HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0;
              i10 = HEAP32[gb + 1166396 + 4 >> 2] | 0;
              i9 = HEAP32[i10 + 4 >> 2] | 0;
              mftCall_viiiiiii(i70 | 0, i21 | 0, i55 | 0, i5 | 0, i9 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i10, HEAP32[i5 >> 2] | 0, 0) | 0, 0, 0);
              __Z15gpu_time_samplev();
              i4 = i4 + 1 | 0;
             }
             i6 = i6 + 1 | 0;
            } while ((i6 | 0) < (HEAP32[i8 >> 2] | 0));
           } else i4 = 0; while (0);
           i3 = i4 + i3 | 0;
           i12 = i12 + 1 | 0;
          } while (i12 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
          i5 = HEAP32[i17 >> 2] | 0;
          i4 = HEAP32[i19 >> 2] | 0;
         }
         i15 = i15 + 1 | 0;
        } while (i15 >>> 0 < i5 - i4 >> 2 >>> 0);
       }
       HEAP32[i27 >> 2] = gb + 33952 + 8;
       if ((HEAP32[i39 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i40);
        HEAP32[i37 >> 2] = 0;
       }
       if ((HEAP32[i35 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i48 >> 2] | 0, i36);
        HEAP32[i48 >> 2] = 0;
       }
       if ((HEAP32[i31 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i49 >> 2] | 0, i32);
        HEAP32[i49 >> 2] = 0;
       }
       i2 = i2 + 1 | 0;
       i1 = i3 + i1 | 0;
       i3 = HEAP32[i26 >> 2] | 0;
      }
      i20 = i20 + 1 | 0;
     } while (i20 >>> 0 < i3 >>> 0);
    }
    d63 = +__Z19GetTimeSinceStartupv() - d63;
    HEAP32[i68 >> 2] = i2;
    HEAP32[i68 + 4 >> 2] = i1;
    HEAPF64[i68 + 8 >> 3] = d63;
    _printf_console(gb + 479607 | 0, i68);
    if ((HEAP32[i58 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i67 >> 2] | 0, i59);
     HEAP32[i67 >> 2] = 0;
    }
    __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i66, HEAP32[i57 >> 2] | 0);
    __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i65, HEAP32[i56 >> 2] | 0);
    __ZN22DeviceMVPMatricesStateD2Ev(i64);
   }
  }
  if (i61 | 0) __Z12profiler_endP19ProfilerInformation(i61);
  if (!(i62 << 24 >> 24)) {
   STACKTOP = i69;
   return;
  }
 }
 i70 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i70 >> 2] | 0) + 500 >> 2] | 0, i70 | 0);
 STACKTOP = i69;
 return;
}

function __ZN11SoundHandle8Instance13CreateChannelERS_b(i13, i7, i8) {
 i13 = i13 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i5 = i15;
 i11 = i15 + 36 | 0;
 i14 = i15 + 12 | 0;
 i9 = i15 + 32 | 0;
 i3 = i15 + 28 | 0;
 i4 = i15 + 24 | 0;
 if (i13 | 0) if ((HEAP32[i13 + 44 >> 2] | 0) == 4) {
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (HEAP8[i13 + 116 >> 0] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 865301 | 0, 0, gb + 853741 | 0, 271, 1, 0, 0, 0);
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = i13 + 56 | 0;
 if (HEAP32[i1 >> 2] & 2 | 0) if ((HEAP32[i13 + 32 >> 2] | 0) != (i13 + 28 | 0)) {
  i2 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
  i3 = i13 + 64 | 0;
  i4 = HEAP32[i13 + 24 >> 2] | 0;
  i16 = HEAP32[i13 + 48 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i13 + 52 >> 2] | 0;
  i17 = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  i6 = HEAP32[i13 + 88 >> 2] | 0;
  i10 = HEAP32[i13 + 80 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  do if (!(__Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i11, i17, i16, i5, i6, i10, 0) | 0)) {
   i2 = __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i2, HEAP32[i11 >> 2] | 0, i3, i1, i4, 1) | 0;
   i3 = i2;
   HEAP32[i14 >> 2] = i2;
   if (!i2) i12 = 12; else {
    i1 = i2 + 16 | 0;
    i10 = HEAP32[i1 >> 2] | 0;
    if (!i10) i12 = 12; else {
     HEAP32[i10 + 104 >> 2] = i13;
     i17 = i13 + 108 | 0;
     HEAP32[i10 + 108 >> 2] = HEAP32[i17 >> 2];
     HEAP32[(HEAP32[i17 >> 2] | 0) + 104 >> 2] = i10;
     HEAP32[i17 >> 2] = i10;
     if ((HEAP32[i10 + 44 >> 2] | 0) == 4) {
      i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
      i3 = i10 + 116 | 0;
      if (!(HEAP8[i3 >> 0] | 0)) {
       i2 = i1 + 24 | 0;
       if ((i10 | 0) != (i2 | 0)) {
        i1 = HEAP32[i10 >> 2] | 0;
        if (!i1) i1 = i10 + 4 | 0; else {
         i17 = i10 + 4 | 0;
         HEAP32[i1 + 4 >> 2] = HEAP32[i17 >> 2];
         HEAP32[HEAP32[i17 >> 2] >> 2] = i1;
         HEAP32[i10 >> 2] = 0;
         HEAP32[i17 >> 2] = 0;
         i1 = i17;
        }
        i17 = HEAP32[i2 >> 2] | 0;
        HEAP32[i10 >> 2] = i17;
        HEAP32[i1 >> 2] = i2;
        HEAP32[i17 + 4 >> 2] = i10;
        HEAP32[HEAP32[i1 >> 2] >> 2] = i10;
       }
       HEAP8[i3 >> 0] = 1;
      }
      HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
      HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
      i1 = 0;
      break;
     }
     __ZN11SoundHandleaSERKS_(i7, i14);
     i1 = HEAP32[i1 >> 2] | 0;
     if (i1 | 0) if ((HEAP32[i1 + 44 >> 2] | 0) == 3) {
      i1 = __ZN11SoundHandle8Instance13CreateChannelERS_b(i10, i7, i8) | 0;
      break;
     }
     HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
     HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
     i1 = i2 + 4 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     HEAP32[i9 >> 2] = i3;
     i1 = __ZnwjRK10MemLabelIdiPKci(252, gb + 63328 | 0, 16, gb + 883367 | 0, 296) | 0;
     HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
     HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
     i17 = i2 + 4 | 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     HEAP32[i11 >> 2] = i3;
     __ZN20SoundChannelInstanceC2E11SoundHandleb(i1, i11, i8);
     HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
     HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
     if (!i1) i1 = 0; else {
      i2 = HEAP32[i1 + 248 >> 2] | 0;
      i1 = i2;
      if (i2) {
       i17 = i2 + 4 | 0;
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
      }
     }
     __ZN11SoundHandleD2Ev(i11);
     i7 = i1;
     __ZN11SoundHandleD2Ev(i9);
     i4 = i10 + 96 | 0;
     i6 = (i1 | 0) == 0;
     if (i6) i2 = 0; else i2 = HEAP32[i7 + 16 >> 2] | 0;
     i5 = i2 + 184 | 0;
     if ((i5 | 0) != (i4 | 0)) {
      i3 = HEAP32[i5 >> 2] | 0;
      if (!i3) i2 = i2 + 188 | 0; else {
       i2 = i2 + 188 | 0;
       HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
       HEAP32[i5 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
      }
      i17 = HEAP32[i4 >> 2] | 0;
      HEAP32[i5 >> 2] = i17;
      HEAP32[i2 >> 2] = i4;
      HEAP32[i17 + 4 >> 2] = i5;
      HEAP32[HEAP32[i2 >> 2] >> 2] = i5;
     }
     i4 = i10 + 28 | 0;
     if (i6) i2 = 0; else i2 = HEAP32[i7 + 16 >> 2] | 0;
     i5 = i2 + 172 | 0;
     if ((i5 | 0) != (i4 | 0)) {
      i3 = HEAP32[i5 >> 2] | 0;
      if (!i3) i2 = i2 + 176 | 0; else {
       i2 = i2 + 176 | 0;
       HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
       HEAP32[i5 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
      }
      i17 = HEAP32[i4 >> 2] | 0;
      HEAP32[i5 >> 2] = i17;
      HEAP32[i2 >> 2] = i4;
      HEAP32[i17 + 4 >> 2] = i5;
      HEAP32[HEAP32[i2 >> 2] >> 2] = i5;
     }
     HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
     HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
     if (i6) {
      HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
      HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
      i1 = 0;
      break;
     }
     i17 = i7 + 4 | 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
     HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
     if (!(HEAP32[i17 >> 2] | 0)) {
      mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i7 | 0);
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 8 | 0);
     }
    }
   }
  } else {
   HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
   HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
   HEAP32[i14 >> 2] = 0;
   i12 = 12;
  } while (0);
  if ((i12 | 0) == 12) {
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
   i1 = 0;
  }
  __ZN11SoundHandleD2Ev(i14);
  i17 = i1;
  STACKTOP = i15;
  return i17 | 0;
 }
 if ((HEAP32[i13 + 44 >> 2] | 0) != 3) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i17 = i1 + 4 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
  }
  HEAP32[i4 >> 2] = i1;
  i2 = __ZnwjRK10MemLabelIdiPKci(252, gb + 63328 | 0, 16, gb + 883367 | 0, 296) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  if (i1 | 0) {
   i17 = i1 + 4 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
  }
  HEAP32[i11 >> 2] = i1;
  __ZN20SoundChannelInstanceC2E11SoundHandleb(i2, i11, i8);
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  if (!i2) i2 = 0; else {
   i1 = HEAP32[i2 + 248 >> 2] | 0;
   i2 = i1;
   if (i1) {
    i17 = i1 + 4 | 0;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
   }
  }
  __ZN11SoundHandleD2Ev(i11);
  i7 = i2;
  __ZN11SoundHandleD2Ev(i4);
  i4 = i13 + 96 | 0;
  i6 = (i2 | 0) == 0;
  if (i6) i1 = 0; else i1 = HEAP32[i7 + 16 >> 2] | 0;
  i5 = i1 + 184 | 0;
  if ((i5 | 0) != (i4 | 0)) {
   i3 = HEAP32[i5 >> 2] | 0;
   if (!i3) i1 = i1 + 188 | 0; else {
    i1 = i1 + 188 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
   }
   i17 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 >> 2] = i17;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i5;
  }
  i4 = i13 + 28 | 0;
  if (i6) i1 = 0; else i1 = HEAP32[i7 + 16 >> 2] | 0;
  i5 = i1 + 172 | 0;
  if ((i5 | 0) != (i4 | 0)) {
   i3 = HEAP32[i5 >> 2] | 0;
   if (!i3) i1 = i1 + 176 | 0; else {
    i1 = i1 + 176 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
   }
   i17 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 >> 2] = i17;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i5;
  }
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  if (i6) {
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   i17 = 0;
   STACKTOP = i15;
   return i17 | 0;
  }
  i17 = i7 + 4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  if (HEAP32[i17 >> 2] | 0) {
   i17 = i2;
   STACKTOP = i15;
   return i17 | 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i7 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i7 + 8 | 0);
  i17 = i2;
  STACKTOP = i15;
  return i17 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i17 = i1 + 4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 HEAP32[i3 >> 2] = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(252, gb + 63328 | 0, 16, gb + 883367 | 0, 296) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 if (i1 | 0) {
  i17 = i1 + 4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 HEAP32[i11 >> 2] = i1;
 __ZN20SoundChannelInstanceC2E11SoundHandleb(i2, i11, i8);
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 if (!i2) i7 = 0; else {
  i1 = HEAP32[i2 + 248 >> 2] | 0;
  i2 = i1;
  if (!i1) i7 = i2; else {
   i7 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = i2;
  }
 }
 __ZN11SoundHandleD2Ev(i11);
 i8 = i7;
 __ZN11SoundHandleD2Ev(i3);
 HEAP32[i11 >> 2] = 0;
 i1 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 i1 = __ZN4FMOD6System9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE(i1, -1, HEAP32[i13 + 40 >> 2] | 0, 1, i11) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 L119 : do if ((i1 | 0) != 0 | (i2 | 0) == 0) {
  switch (i1 | 0) {
  case 10:
   {
    i1 = HEAP32[i13 + 52 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 864656 | 0, 0, gb + 853741 | 0, 310, 512, i1, 0, 0);
    break;
   }
  case 54:
   {
    HEAP32[i5 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT_486(54) | 0;
    __Z6FormatPKcz(i14, gb + 857699 | 0, i5);
    i1 = HEAP32[i13 + 52 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 853741 | 0, 313, 512, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i3 = i13 + 96 | 0;
    i5 = (i7 | 0) == 0;
    if (i5) i1 = 0; else i1 = HEAP32[i8 + 16 >> 2] | 0;
    i4 = i1 + 184 | 0;
    if ((i4 | 0) != (i3 | 0)) {
     i2 = HEAP32[i4 >> 2] | 0;
     if (!i2) i1 = i1 + 188 | 0; else {
      i1 = i1 + 188 | 0;
      HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i1 >> 2] = 0;
     }
     i17 = HEAP32[i3 >> 2] | 0;
     HEAP32[i4 >> 2] = i17;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i17 + 4 >> 2] = i4;
     HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
    }
    i3 = i13 + 28 | 0;
    if (i5) i1 = 0; else i1 = HEAP32[i8 + 16 >> 2] | 0;
    i4 = i1 + 172 | 0;
    if ((i4 | 0) != (i3 | 0)) {
     i2 = HEAP32[i4 >> 2] | 0;
     if (!i2) i1 = i1 + 176 | 0; else {
      i1 = i1 + 176 | 0;
      HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i1 >> 2] = 0;
     }
     i17 = HEAP32[i3 >> 2] | 0;
     HEAP32[i4 >> 2] = i17;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i17 + 4 >> 2] = i4;
     HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
    }
    HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
    HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
    if (i5) {
     i1 = 0;
     break L119;
    }
    i1 = i8 + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = i7;
    break L119;
   }
  default:
   {
    HEAP32[i6 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
    __Z6FormatPKcz(i14, gb + 864711 | 0, i6);
    i1 = HEAP32[i13 + 52 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 853741 | 0, 319, 1, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   }
  }
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i1 = 0;
 } else {
  i5 = (i7 | 0) == 0;
  if (i5) {
   __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE(0, i2);
   i4 = 0;
  } else {
   i4 = i8 + 16 | 0;
   __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE(HEAP32[i4 >> 2] | 0, i2);
   i4 = HEAP32[i4 >> 2] | 0;
  }
  i2 = i13 + 28 | 0;
  i3 = i4 + 172 | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i4 + 176 | 0; else {
    i17 = i4 + 176 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i17 >> 2];
    HEAP32[HEAP32[i17 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    i1 = i17;
   }
   i17 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i17;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i17 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  }
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  if (i5) i1 = 0; else {
   i1 = i8 + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = i7;
  }
 } while (0);
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 if (!i7) {
  i17 = i1;
  STACKTOP = i15;
  return i17 | 0;
 }
 i17 = i8 + 4 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
 if (HEAP32[i17 >> 2] | 0) {
  i17 = i1;
  STACKTOP = i15;
  return i17 | 0;
 }
 mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i8 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8 + 8 | 0);
 i17 = i1;
 STACKTOP = i15;
 return i17 | 0;
}

function __ZN7mecanim8skeleton15Skeleton2BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_(i1, i2, i3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i9 + 12 | 0;
 i23 = i9;
 i22 = i7 + 4 | 0;
 i17 = i22;
 i31 = (HEAP32[i22 >> 2] | 0) + i17 | 0;
 f18 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 24 >> 2]);
 f29 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 24 >> 2]);
 __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i23, i1, i7, i3);
 f42 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f42 = Math_fround(f42 * Math_fround(0.0));
 f27 = Math_fround(Math_fround(HEAPF32[i23 + 8 >> 2]) * Math_fround(.899999976));
 HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
 HEAPF32[i24 + 4 >> 2] = f42;
 HEAPF32[i24 + 8 >> 2] = f27;
 __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i1, i7, i24, i3);
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i7, i8, i4, i3);
 i24 = i8 + 4 | 0;
 i23 = i24;
 i31 = (HEAP32[i24 >> 2] | 0) + i23 | 0;
 f27 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) >> 2]);
 f42 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i31 + (i3 * 40 | 0) + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) >> 2]);
 f15 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i31 + (i2 * 40 | 0) + 8 >> 2]);
 f41 = Math_fround(f27 - f19);
 f43 = Math_fround(f42 - f15);
 f37 = Math_fround(f38 - f28);
 f40 = Math_fround(HEAPF32[i31 + (i4 * 40 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i31 + (i4 * 40 | 0) + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i31 + (i4 * 40 | 0) + 8 >> 2]);
 f27 = Math_fround(f40 - f27);
 f42 = Math_fround(f14 - f42);
 f38 = Math_fround(f39 - f38);
 f40 = Math_fround(f40 - f19);
 f14 = Math_fround(f14 - f15);
 f39 = Math_fround(f39 - f28);
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f36 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(f16 - f19);
 f15 = Math_fround(f36 - f15);
 f28 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f28);
 f36 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f43 * f43)) + Math_fround(Math_fround(f37 * f37) + Math_fround(0.0)))));
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f42 * f42)) + Math_fround(Math_fround(f38 * f38) + Math_fround(0.0)))));
 f39 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f39 * f39) + Math_fround(0.0)))));
 f14 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f28 * f28) + Math_fround(0.0)));
 f40 = Math_fround(Math_sqrt(Math_fround(f14)));
 f13 = Math_fround(Math_fround(f36 * f36) + Math_fround(f16 * f16));
 f16 = Math_fround(f36 * f16);
 f39 = Math_fround(+Math_acos(+Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(Math_fround(Math_fround(f13 - Math_fround(f39 * f39)) / f16) * Math_fround(.5)), Math_fround(-1.0))), Math_fround(1.0)))));
 f36 = Math_fround(Math_fround(f41 * f42) - Math_fround(f43 * f27));
 f42 = Math_fround(Math_fround(f43 * f38) - Math_fround(f37 * f42));
 f38 = Math_fround(Math_fround(f37 * f27) - Math_fround(f41 * f38));
 f41 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(0.0)) + Math_fround(Math_fround(f42 * f42) + Math_fround(f38 * f38))))));
 f42 = Math_fround(f42 * f41);
 f38 = Math_fround(f38 * f41);
 f41 = Math_fround(f36 * f41);
 f16 = Math_fround(Math_fround(Math_fround(f39 - Math_fround(+Math_acos(+Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(Math_fround(Math_fround(f13 - Math_fround(f40 * f40)) / f16) * Math_fround(.5)), Math_fround(-1.0))), Math_fround(1.0)))))) * Math_fround(.5)) * Math_fround(.159154937));
 f40 = Math_fround(f16 + Math_fround(-.25));
 f16 = Math_fround(f16 + Math_fround(0.0));
 f13 = Math_fround(+_roundf(+f40));
 f13 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f40 - f13))));
 f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - Math_fround(+_roundf(+f16))))));
 f40 = Math_fround(f13 * f13);
 f39 = Math_fround(f16 * f16);
 f36 = Math_fround(f40 * f40);
 f27 = Math_fround(f39 * f39);
 f40 = Math_fround(f13 * Math_fround(Math_fround(Math_fround(f36 * f36) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f40 * Math_fround(41.3416595))) + Math_fround(f36 * Math_fround(Math_fround(81.6018218) - Math_fround(f40 * Math_fround(76.5686187)))))));
 f39 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f27 * f27) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f39 * Math_fround(41.3416595))) + Math_fround(f27 * Math_fround(Math_fround(81.6018218) - Math_fround(f39 * Math_fround(76.5686187)))))));
 f42 = Math_fround(f42 * f40);
 f38 = Math_fround(f38 * f40);
 f40 = Math_fround(f41 * f40);
 i26 = i31 + (i3 * 40 | 0) + 12 | 0;
 f41 = Math_fround(HEAPF32[i26 >> 2]);
 f27 = Math_fround(f41 * f38);
 i5 = i31 + (i3 * 40 | 0) + 24 | 0;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f36 = Math_fround(f16 * f39);
 i25 = i31 + (i3 * 40 | 0) + 16 | 0;
 f13 = Math_fround(HEAPF32[i25 >> 2]);
 f37 = Math_fround(f13 * f40);
 i31 = i31 + (i3 * 40 | 0) + 20 | 0;
 f43 = Math_fround(HEAPF32[i31 >> 2]);
 f27 = Math_fround(Math_fround(Math_fround(f27 - Math_fround(f43 * f39)) - Math_fround(f16 * f40)) - Math_fround(f13 * f42));
 f36 = Math_fround(Math_fround(Math_fround(f36 - Math_fround(f41 * f42)) - Math_fround(f43 * f40)) - Math_fround(f13 * f38));
 f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f43 * f38)) - Math_fround(f41 * f39)) - Math_fround(f16 * f42));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f42) - Math_fround(f41 * f40)) - Math_fround(f13 * f39)) - Math_fround(f16 * f38));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f38 = (HEAP32[tempDoublePtr >> 2] = i34 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f38 * f38);
 f27 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f27 * f27);
 f39 = (HEAP32[tempDoublePtr >> 2] = i32 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f37 + f16) + Math_fround(Math_fround(f36 * f36) + Math_fround(f39 * f39))))));
 f27 = Math_fround(f16 * f27);
 f39 = Math_fround(f16 * f39);
 f36 = Math_fround(f16 * f36);
 HEAPF32[i26 >> 2] = Math_fround(f16 * f38);
 HEAPF32[i25 >> 2] = f27;
 HEAPF32[i31 >> 2] = f39;
 HEAPF32[i5 >> 2] = f36;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i8, i7, i3, i3);
 i5 = (HEAP32[i22 >> 2] | 0) + i17 | 0;
 i31 = i5 + (i3 * 40 | 0) + 12 | 0;
 f36 = Math_fround(HEAPF32[i31 >> 2]);
 f39 = Math_fround(f29 * f36);
 i25 = i5 + (i3 * 40 | 0) + 16 | 0;
 f27 = Math_fround(HEAPF32[i25 >> 2]);
 f38 = Math_fround(f20 * f27);
 i26 = i5 + (i3 * 40 | 0) + 20 | 0;
 f16 = Math_fround(HEAPF32[i26 >> 2]);
 f37 = Math_fround(f21 * f16);
 i5 = i5 + (i3 * 40 | 0) + 24 | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f37 = Math_fround(Math_fround(f39 + f38) + Math_fround(f37 + Math_fround(f30 * f13)));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 i32 = i32 & -2147483648;
 i35 = i32 ^ (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i34 = i32 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i33 = i32 ^ (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i32 = i32 ^ (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
 f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f20);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
 f13 = Math_fround(f29 + Math_fround(f13 * f6));
 f16 = Math_fround(f20 + Math_fround(f16 * f6));
 f27 = Math_fround(f21 + Math_fround(f27 * f6));
 f30 = Math_fround(f30 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30) * f6));
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f16 * f16)) + Math_fround(Math_fround(f27 * f27) + Math_fround(f30 * f30))))));
 f16 = Math_fround(f21 * f16);
 f27 = Math_fround(f21 * f27);
 f30 = Math_fround(f21 * f30);
 HEAPF32[i31 >> 2] = Math_fround(f21 * f13);
 HEAPF32[i25 >> 2] = f16;
 HEAPF32[i26 >> 2] = f27;
 HEAPF32[i5 >> 2] = f30;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i7, i8, i4, i3);
 i5 = (HEAP32[i24 >> 2] | 0) + i23 | 0;
 f30 = Math_fround(HEAPF32[i5 + (i4 * 40 | 0) >> 2]);
 f27 = Math_fround(HEAPF32[i5 + (i4 * 40 | 0) + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + (i4 * 40 | 0) + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + (i2 * 40 | 0) >> 2]);
 f21 = Math_fround(HEAPF32[i5 + (i2 * 40 | 0) + 4 >> 2]);
 f13 = Math_fround(f30 - f13);
 f21 = Math_fround(f27 - f21);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i5 + (i2 * 40 | 0) + 8 >> 2]));
 f27 = Math_fround(Math_fround(f15 * f13) - Math_fround(f19 * f21));
 f30 = Math_fround(Math_fround(f28 * f21) - Math_fround(f15 * f16));
 f20 = Math_fround(Math_fround(f19 * f16) - Math_fround(f28 * f13));
 f16 = Math_fround(Math_fround(Math_sqrt(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f21 * f21)) + Math_fround(Math_fround(f16 * f16) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f19 * f13) + Math_fround(f15 * f21)) + Math_fround(Math_fround(f28 * f16) + Math_fround(0.0))));
 f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f20 * f20)) + Math_fround(Math_fround(f27 * f27) + Math_fround(f16 * f16))))));
 f30 = Math_fround(f30 * f28);
 f20 = Math_fround(f28 * f20);
 f27 = Math_fround(f27 * f28);
 f16 = Math_fround(f28 * f16);
 i23 = i5 + (i2 * 40 | 0) + 12 | 0;
 f28 = Math_fround(HEAPF32[i23 >> 2]);
 f21 = Math_fround(f28 * f20);
 i4 = i5 + (i2 * 40 | 0) + 24 | 0;
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(f15 * f16);
 i3 = i5 + (i2 * 40 | 0) + 16 | 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f27 * f19);
 i5 = i5 + (i2 * 40 | 0) + 20 | 0;
 f29 = Math_fround(HEAPF32[i5 >> 2]);
 f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f29 * f16)) - Math_fround(f27 * f15)) - Math_fround(f30 * f19));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f28 * f30)) - Math_fround(f27 * f29)) - Math_fround(f20 * f19));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f20 * f29)) - Math_fround(f28 * f16)) - Math_fround(f30 * f15));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * f27)) - Math_fround(f19 * f16)) - Math_fround(f20 * f15));
 i24 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 i26 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i25 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f15 = (HEAP32[tempDoublePtr >> 2] = i26 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f15 * f15);
 f21 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f21 * f21);
 f16 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f14 + f20) + Math_fround(Math_fround(f13 * f13) + Math_fround(f16 * f16))))));
 f21 = Math_fround(f20 * f21);
 f16 = Math_fround(f20 * f16);
 f13 = Math_fround(f20 * f13);
 HEAPF32[i23 >> 2] = Math_fround(f20 * f15);
 HEAPF32[i3 >> 2] = f21;
 HEAPF32[i5 >> 2] = f16;
 HEAPF32[i4 >> 2] = f13;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i8, i7, i2, i2);
 i8 = (HEAP32[i22 >> 2] | 0) + i17 | 0;
 f13 = Math_fround(_exp2f(Math_fround(Math_fround(_log2f(Math_fround(Math_fround(1.0) - f6))) * Math_fround(4.0))));
 i4 = i8 + (i2 * 40 | 0) + 12 | 0;
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 f21 = Math_fround(f18 * f16);
 i5 = i8 + (i2 * 40 | 0) + 16 | 0;
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f20 = Math_fround(f10 * f15);
 i7 = i8 + (i2 * 40 | 0) + 20 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(f11 * f14);
 i8 = i8 + (i2 * 40 | 0) + 24 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f19 = Math_fround(Math_fround(f21 + f20) + Math_fround(f19 + Math_fround(f12 * f6)));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i3 & -2147483648;
 i17 = i3 ^ (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i3 ^ (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 ^ (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i3 ^ (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f16);
 f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
 f12 = Math_fround(f16 + Math_fround(f13 * f12));
 f11 = Math_fround(f15 + Math_fround(f13 * f11));
 f10 = Math_fround(f14 + Math_fround(f13 * f10));
 f6 = Math_fround(f6 + Math_fround(f13 * Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f6)));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6))))));
 f11 = Math_fround(f13 * f11);
 f10 = Math_fround(f13 * f10);
 f6 = Math_fround(f13 * f6);
 HEAPF32[i4 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i5 >> 2] = f11;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f6;
 STACKTOP = i9;
 return;
}

function __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_(i9, i10, i11, i12, i15, i16, i18, i19, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i17 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20 + 32 | 0;
 i7 = i20 + 16 | 0;
 i6 = i20 + 8 | 0;
 i5 = i20;
 i14 = i20 + 44 | 0;
 if ((i18 | 0) < 1 | (i19 | 0) < 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 404561 | 0, 0, gb + 404494 | 0, 1772, 1, 0, 0, 0);
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i1 = (i15 | 0) < 0;
 i3 = (i16 | 0) < 0;
 if ((i16 | i15 | 0) >= 0) {
  i4 = i18 + i15 | 0;
  if ((i4 | 0) >= 0) {
   i17 = i19 + i16 | 0;
   if (!((i17 | 0) > (i11 | 0) | ((i4 | 0) > (i10 | 0) | (i17 | 0) < 0))) {
    do if ((i12 + -10 | 0) >>> 0 < 3) i13 = 20; else if (((i12 | 1) + -25 | 0) >>> 0 < 5) i13 = 20; else {
     i1 = i12 + -30 | 0;
     if (i1 >>> 0 < 15) if ((i12 + -48 | 0) >>> 0 < 12 | ((i12 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
      i13 = 20;
      break;
     } else break; else if ((i12 + -45 | 0) >>> 0 < 3 | (i12 + -48 | 0) >>> 0 < 12) {
      i13 = 20;
      break;
     } else break;
    } while (0);
    L15 : do if ((i13 | 0) == 20) {
     switch (i12 | 0) {
     case 10:
     case 11:
     case 12:
     case 26:
     case 27:
      break;
     default:
      if ((i12 | 1 | 0) != 25) break L15;
     }
     __ZL19HandleDecompressionPKhii13TextureFormatiiii(i14, i9, i10, i11, i12, i15, i16, i18, i19);
     i8 = HEAP32[i14 >> 2] | 0;
     i3 = HEAP32[i14 + 4 >> 2] | 0;
     i4 = HEAP32[i14 + 8 >> 2] | 0;
     i1 = (i19 | 0) > 0;
     if (!(HEAP8[i14 + 12 >> 0] | 0)) {
      if (i1) {
       i7 = i4 << 2;
       if ((i18 | 0) > 0) {
        i6 = 0;
        i5 = i8 + (((i15 | 0) % (i3 | 0) | 0) << 2) + ((Math_imul((i16 | 0) % (i3 | 0) | 0, i4) | 0) << 2) | 0;
        while (1) {
         i1 = i5;
         i3 = 0;
         i4 = i2;
         while (1) {
          HEAP32[i4 >> 2] = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0] | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
          i3 = i3 + 1 | 0;
          if ((i3 | 0) == (i18 | 0)) break; else {
           i1 = i1 + 4 | 0;
           i4 = i4 + 4 | 0;
          }
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i19 | 0)) break; else {
          i5 = i5 + i7 | 0;
          i2 = i2 + (i18 << 2) | 0;
         }
        }
       }
      }
     } else if (i1) {
      i7 = i4 << 2;
      if ((i18 | 0) > 0) {
       i6 = 0;
       i5 = i8 + (((i15 | 0) % (i3 | 0) | 0) << 2) + ((Math_imul((i16 | 0) % (i3 | 0) | 0, i4) | 0) << 2) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         f24 = Math_fround(HEAPF32[i1 >> 2]);
         f23 = Math_fround(HEAPF32[i1 + 4 >> 2]);
         f22 = Math_fround(HEAPF32[i1 + 8 >> 2]);
         f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
         i17 = f24 < Math_fround(0.0);
         f24 = i17 ? Math_fround(0.0) : f24;
         i17 = f24 > Math_fround(1.0);
         HEAP8[i4 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
         i17 = f23 < Math_fround(0.0);
         f23 = i17 ? Math_fround(0.0) : f23;
         i17 = f23 > Math_fround(1.0);
         HEAP8[i4 + 1 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
         i17 = f22 < Math_fround(0.0);
         f22 = i17 ? Math_fround(0.0) : f22;
         i17 = f22 > Math_fround(1.0);
         HEAP8[i4 + 2 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f22) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
         i17 = f21 < Math_fround(0.0);
         f21 = i17 ? Math_fround(0.0) : f21;
         i17 = f21 > Math_fround(1.0);
         HEAP8[i4 + 3 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i18 | 0)) break; else {
          i1 = i1 + 16 | 0;
          i4 = i4 + 4 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i19 | 0)) break; else {
         i5 = i5 + (i7 << 2) | 0;
         i2 = i2 + (i18 << 2) | 0;
        }
       }
      }
     }
     __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
     i19 = 1;
     STACKTOP = i20;
     return i19 | 0;
    } while (0);
    i17 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i10, i12) | 0;
    if (!i9) i13 = 40; else {
     if ((i12 | 0) < 9) i1 = 1; else i1 = (i12 | 0) == 1e3 | ((i12 | 0) == 23 | (i12 + -13 | 0) >>> 0 < 9);
     if ((i10 | 0) > 0 & (i11 | 0) > 0 & (i12 | 0) > 0 & i1) i1 = i9; else i13 = 40;
    }
    if ((i13 | 0) == 40) i1 = 0;
    switch (i12 | 0) {
    case 5:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(5) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        HEAP32[i4 >> 2] = HEAPU8[i1 + 2 >> 0] << 8 | HEAPU8[i1 + 1 >> 0] | HEAPU8[i1 + 3 >> 0] << 16 | HEAPU8[i1 >> 0] << 24;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 4:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(4) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        HEAP32[i4 >> 2] = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0] | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 14:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(14) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        HEAP32[i4 >> 2] = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] | HEAPU8[i1 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 3:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(3) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        HEAP32[i4 >> 2] = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | -16777216;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 1:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(1) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        HEAP32[i4 >> 2] = HEAPU8[i1 >> 0] << 24 | 16777215;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 7:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(7) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        i15 = HEAP16[i1 >> 1] | 0;
        i16 = i15 & 65535;
        i15 = (i15 & 65535) >>> 11 & 65535;
        HEAP32[i4 >> 2] = i15 << 3 | i15 >>> 2 | (i16 >>> 3 & 252 | i16 >>> 9 & 3) << 8 | (i16 << 3 & 248 | i16 >>> 2 & 7) << 16 | -16777216;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 20:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(20) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f21 = Math_fround(HEAPF32[i1 >> 2]);
        f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
        f23 = Math_fround(HEAPF32[i1 + 8 >> 2]);
        f24 = Math_fround(HEAPF32[i1 + 12 >> 2]);
        i14 = f21 < Math_fround(0.0);
        f21 = i14 ? Math_fround(0.0) : f21;
        i14 = f21 > Math_fround(1.0);
        i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i13 = f22 < Math_fround(0.0);
        f22 = i13 ? Math_fround(0.0) : f22;
        i13 = f22 > Math_fround(1.0);
        i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f22) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i15 = f23 < Math_fround(0.0);
        f23 = i15 ? Math_fround(0.0) : f23;
        i15 = f23 > Math_fround(1.0);
        i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f23) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        i16 = f24 < Math_fround(0.0);
        f24 = i16 ? Math_fround(0.0) : f24;
        i16 = f24 > Math_fround(1.0);
        HEAP32[i4 >> 2] = i13 << 8 & 65280 | i14 & 255 | i15 << 16 & 16711680 | ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 17:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(17) | 0;
      if ((i19 | 0) <= 0) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i8 = i14 + 4 | 0;
      i9 = i14 + 8 | 0;
      i10 = i14 + 12 | 0;
      if ((i18 | 0) <= 0) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i1, 17, i14);
        f24 = Math_fround(HEAPF32[i14 >> 2]);
        i13 = f24 < Math_fround(0.0);
        f24 = i13 ? Math_fround(0.0) : f24;
        i13 = f24 > Math_fround(1.0);
        i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        f24 = Math_fround(HEAPF32[i8 >> 2]);
        i12 = f24 < Math_fround(0.0);
        f24 = i12 ? Math_fround(0.0) : f24;
        i12 = f24 > Math_fround(1.0);
        i12 = ~~Math_fround(Math_fround((i12 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        f24 = Math_fround(HEAPF32[i9 >> 2]);
        i15 = f24 < Math_fround(0.0);
        f24 = i15 ? Math_fround(0.0) : f24;
        i15 = f24 > Math_fround(1.0);
        i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
        f24 = Math_fround(HEAPF32[i10 >> 2]);
        i16 = f24 < Math_fround(0.0);
        f24 = i16 ? Math_fround(0.0) : f24;
        i16 = f24 > Math_fround(1.0);
        HEAP32[i4 >> 2] = i12 << 8 & 65280 | i13 & 255 | i15 << 16 & 16711680 | ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f24) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 4 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 2) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    default:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1823, 1, 0, 0, 0);
      i19 = 0;
      STACKTOP = i20;
      return i19 | 0;
     }
    }
   }
  }
 }
 if (i1) {
  HEAP32[i5 >> 2] = i15;
  _snprintf(i14, 255, gb + 404595 | 0, i5) | 0;
 }
 if (i3) {
  HEAP32[i6 >> 2] = i16;
  _snprintf(i14, 255, gb + 404595 | 0, i6) | 0;
 }
 if ((i18 + i15 | 0) > (i10 | 0)) {
  HEAP32[i7 >> 2] = i15;
  HEAP32[i7 + 4 >> 2] = i18;
  HEAP32[i7 + 8 >> 2] = i10;
  _snprintf(i14, 255, gb + 404639 | 0, i7) | 0;
 }
 if ((i19 + i16 | 0) > (i11 | 0)) {
  HEAP32[i8 >> 2] = i16;
  HEAP32[i8 + 4 >> 2] = i19;
  HEAP32[i8 + 8 >> 2] = i11;
  _snprintf(i14, 255, gb + 404639 | 0, i8) | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i14, 0, gb + 404494 | 0, 1790, 1, 0, 0, 0);
 i19 = 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN7mecanim5human25HumanPoseAddOverrideLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i9, i10, f6, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 f6 = Math_fround(f6);
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, i8 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0;
 if (!(f6 > Math_fround(0.0))) return;
 f7 = Math_fround(Math_fround(1.0) - f6);
 i5 = f6 < Math_fround(1.0);
 if (i5) {
  i1 = 0;
  do {
   i2 = i1;
   i1 = i1 + 1 | 0;
   if (HEAP32[i11 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) {
    i4 = i9 + 596 + (i2 << 2) | 0;
    f12 = Math_fround(f7 * Math_fround(HEAPF32[i4 >> 2]));
    HEAPF32[i4 >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i10 + 596 + (i2 << 2) >> 2]) * f6));
   }
  } while ((i1 | 0) != 52);
 } else {
  i1 = 0;
  do {
   i2 = i1;
   i1 = i1 + 1 | 0;
   if (HEAP32[i11 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) HEAP32[i9 + 596 + (i2 << 2) >> 2] = HEAP32[i10 + 596 + (i2 << 2) >> 2];
  } while ((i1 | 0) != 52);
 }
 i4 = i11 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 & 33554432) if (i5) {
  i2 = 0;
  do {
   i3 = i9 + 364 + (i2 << 2) | 0;
   f12 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
   HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i10 + 364 + (i2 << 2) >> 2]) * f6));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 20);
 } else {
  HEAP32[i9 + 364 >> 2] = HEAP32[i10 + 364 >> 2];
  HEAP32[i9 + 368 >> 2] = HEAP32[i10 + 368 >> 2];
  HEAP32[i9 + 372 >> 2] = HEAP32[i10 + 372 >> 2];
  HEAP32[i9 + 376 >> 2] = HEAP32[i10 + 376 >> 2];
  HEAP32[i9 + 380 >> 2] = HEAP32[i10 + 380 >> 2];
  HEAP32[i9 + 384 >> 2] = HEAP32[i10 + 384 >> 2];
  HEAP32[i9 + 388 >> 2] = HEAP32[i10 + 388 >> 2];
  HEAP32[i9 + 392 >> 2] = HEAP32[i10 + 392 >> 2];
  HEAP32[i9 + 396 >> 2] = HEAP32[i10 + 396 >> 2];
  HEAP32[i9 + 400 >> 2] = HEAP32[i10 + 400 >> 2];
  HEAP32[i9 + 404 >> 2] = HEAP32[i10 + 404 >> 2];
  HEAP32[i9 + 408 >> 2] = HEAP32[i10 + 408 >> 2];
  HEAP32[i9 + 412 >> 2] = HEAP32[i10 + 412 >> 2];
  HEAP32[i9 + 416 >> 2] = HEAP32[i10 + 416 >> 2];
  HEAP32[i9 + 420 >> 2] = HEAP32[i10 + 420 >> 2];
  HEAP32[i9 + 424 >> 2] = HEAP32[i10 + 424 >> 2];
  HEAP32[i9 + 428 >> 2] = HEAP32[i10 + 428 >> 2];
  HEAP32[i9 + 432 >> 2] = HEAP32[i10 + 432 >> 2];
  HEAP32[i9 + 436 >> 2] = HEAP32[i10 + 436 >> 2];
  HEAP32[i9 + 440 >> 2] = HEAP32[i10 + 440 >> 2];
  i1 = HEAP32[i4 >> 2] | 0;
  break;
 } while (0);
 do if (!(i1 & 67108864)) i1 = 0; else if (i5) {
  i1 = 0;
  do {
   i3 = i9 + 500 + (i1 << 2) | 0;
   f12 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
   HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i10 + 500 + (i1 << 2) >> 2]) * f6));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 20);
  i1 = 0;
 } else {
  HEAP32[i9 + 500 >> 2] = HEAP32[i10 + 500 >> 2];
  HEAP32[i9 + 504 >> 2] = HEAP32[i10 + 504 >> 2];
  HEAP32[i9 + 508 >> 2] = HEAP32[i10 + 508 >> 2];
  HEAP32[i9 + 512 >> 2] = HEAP32[i10 + 512 >> 2];
  HEAP32[i9 + 516 >> 2] = HEAP32[i10 + 516 >> 2];
  HEAP32[i9 + 520 >> 2] = HEAP32[i10 + 520 >> 2];
  HEAP32[i9 + 524 >> 2] = HEAP32[i10 + 524 >> 2];
  HEAP32[i9 + 528 >> 2] = HEAP32[i10 + 528 >> 2];
  HEAP32[i9 + 532 >> 2] = HEAP32[i10 + 532 >> 2];
  HEAP32[i9 + 536 >> 2] = HEAP32[i10 + 536 >> 2];
  HEAP32[i9 + 540 >> 2] = HEAP32[i10 + 540 >> 2];
  HEAP32[i9 + 544 >> 2] = HEAP32[i10 + 544 >> 2];
  HEAP32[i9 + 548 >> 2] = HEAP32[i10 + 548 >> 2];
  HEAP32[i9 + 552 >> 2] = HEAP32[i10 + 552 >> 2];
  HEAP32[i9 + 556 >> 2] = HEAP32[i10 + 556 >> 2];
  HEAP32[i9 + 560 >> 2] = HEAP32[i10 + 560 >> 2];
  HEAP32[i9 + 564 >> 2] = HEAP32[i10 + 564 >> 2];
  HEAP32[i9 + 568 >> 2] = HEAP32[i10 + 568 >> 2];
  HEAP32[i9 + 572 >> 2] = HEAP32[i10 + 572 >> 2];
  HEAP32[i9 + 576 >> 2] = HEAP32[i10 + 576 >> 2];
  i1 = 0;
  break;
 } while (0);
 do {
  i3 = i1 + 53 | 0;
  do if (HEAP32[i11 + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31) | 0) {
   i2 = i9 + 68 + (i1 << 6) | 0;
   i3 = i10 + 68 + (i1 << 6) | 0;
   if (i5) {
    f34 = Math_fround(HEAPF32[i3 >> 2]);
    f16 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 4 >> 2]);
    f30 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 8 >> 2]);
    f29 = Math_fround(HEAPF32[i2 >> 2]);
    i27 = i9 + 68 + (i1 << 6) + 4 | 0;
    f28 = Math_fround(HEAPF32[i27 >> 2]);
    i25 = i9 + 68 + (i1 << 6) + 8 | 0;
    f26 = Math_fround(HEAPF32[i25 >> 2]);
    f29 = Math_fround(f29 + Math_fround(Math_fround(f34 - f29) * f6));
    f28 = Math_fround(f28 + Math_fround(Math_fround(f16 - f28) * f6));
    f26 = Math_fround(f26 + Math_fround(Math_fround(f30 - f26) * f6));
    i23 = i9 + 68 + (i1 << 6) + 12 | 0;
    f30 = Math_fround(HEAPF32[i23 >> 2]);
    f16 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 12 >> 2]);
    f34 = Math_fround(f30 * f16);
    i21 = i9 + 68 + (i1 << 6) + 16 | 0;
    f31 = Math_fround(HEAPF32[i21 >> 2]);
    f20 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 16 >> 2]);
    f12 = Math_fround(f31 * f20);
    i19 = i9 + 68 + (i1 << 6) + 20 | 0;
    f32 = Math_fround(HEAPF32[i19 >> 2]);
    f22 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 20 >> 2]);
    f14 = Math_fround(f32 * f22);
    i17 = i9 + 68 + (i1 << 6) + 24 | 0;
    f18 = Math_fround(HEAPF32[i17 >> 2]);
    f24 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 24 >> 2]);
    f14 = Math_fround(Math_fround(f34 + f12) + Math_fround(f14 + Math_fround(f18 * f24)));
    i15 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = i15 & -2147483648;
    i33 = i15 ^ (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = i15 ^ (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = i15 ^ (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    i15 = i15 ^ (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
    f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
    f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f31);
    f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f32);
    f24 = Math_fround(f30 + Math_fround(f24 * f6));
    f22 = Math_fround(f31 + Math_fround(f22 * f6));
    f20 = Math_fround(f32 + Math_fround(f20 * f6));
    f18 = Math_fround(f18 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18) * f6));
    f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f22 * f22)) + Math_fround(Math_fround(f20 * f20) + Math_fround(f18 * f18))))));
    f24 = Math_fround(f32 * f24);
    f22 = Math_fround(f32 * f22);
    f20 = Math_fround(f32 * f20);
    f18 = Math_fround(f32 * f18);
    f32 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 28 >> 2]);
    f31 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 32 >> 2]);
    f30 = Math_fround(HEAPF32[i10 + 68 + (i1 << 6) + 36 >> 2]);
    i15 = i9 + 68 + (i1 << 6) + 28 | 0;
    f16 = Math_fround(HEAPF32[i15 >> 2]);
    i13 = i9 + 68 + (i1 << 6) + 32 | 0;
    f14 = Math_fround(HEAPF32[i13 >> 2]);
    i3 = i9 + 68 + (i1 << 6) + 36 | 0;
    f12 = Math_fround(HEAPF32[i3 >> 2]);
    f16 = Math_fround(f16 + Math_fround(Math_fround(f32 - f16) * f6));
    f14 = Math_fround(f14 + Math_fround(Math_fround(f31 - f14) * f6));
    f12 = Math_fround(f12 + Math_fround(Math_fround(f30 - f12) * f6));
    HEAPF32[i2 >> 2] = f29;
    HEAPF32[i27 >> 2] = f28;
    HEAPF32[i25 >> 2] = f26;
    HEAPF32[i23 >> 2] = f24;
    HEAPF32[i21 >> 2] = f22;
    HEAPF32[i19 >> 2] = f20;
    HEAPF32[i17 >> 2] = f18;
    HEAPF32[i15 >> 2] = f16;
    HEAPF32[i13 >> 2] = f14;
    HEAPF32[i3 >> 2] = f12;
    break;
   } else {
    i33 = HEAP32[i10 + 68 + (i1 << 6) + 4 >> 2] | 0;
    i25 = HEAP32[i10 + 68 + (i1 << 6) + 8 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i9 + 68 + (i1 << 6) + 4 >> 2] = i33;
    HEAP32[i9 + 68 + (i1 << 6) + 8 >> 2] = i25;
    i25 = HEAP32[i10 + 68 + (i1 << 6) + 16 >> 2] | 0;
    i33 = HEAP32[i10 + 68 + (i1 << 6) + 20 >> 2] | 0;
    i27 = HEAP32[i10 + 68 + (i1 << 6) + 24 >> 2] | 0;
    HEAP32[i9 + 68 + (i1 << 6) + 12 >> 2] = HEAP32[i10 + 68 + (i1 << 6) + 12 >> 2];
    HEAP32[i9 + 68 + (i1 << 6) + 16 >> 2] = i25;
    HEAP32[i9 + 68 + (i1 << 6) + 20 >> 2] = i33;
    HEAP32[i9 + 68 + (i1 << 6) + 24 >> 2] = i27;
    i27 = HEAP32[i10 + 68 + (i1 << 6) + 32 >> 2] | 0;
    i33 = HEAP32[i10 + 68 + (i1 << 6) + 36 >> 2] | 0;
    HEAP32[i9 + 68 + (i1 << 6) + 28 >> 2] = HEAP32[i10 + 68 + (i1 << 6) + 28 >> 2];
    HEAP32[i9 + 68 + (i1 << 6) + 32 >> 2] = i27;
    HEAP32[i9 + 68 + (i1 << 6) + 36 >> 2] = i33;
    break;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 do if (!(HEAP32[i11 >> 2] & 1)) {
  if (i5) {
   i1 = 0;
   i8 = 27;
  }
 } else if (i5) {
  f12 = Math_fround(HEAPF32[i10 >> 2]);
  f31 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i9 >> 2]);
  i17 = i9 + 4 | 0;
  f22 = Math_fround(HEAPF32[i17 >> 2]);
  i19 = i9 + 8 | 0;
  f24 = Math_fround(HEAPF32[i19 >> 2]);
  f20 = Math_fround(f20 + Math_fround(Math_fround(f12 - f20) * f6));
  f22 = Math_fround(f22 + Math_fround(Math_fround(f31 - f22) * f6));
  f24 = Math_fround(f24 + Math_fround(Math_fround(f18 - f24) * f6));
  i21 = i9 + 12 | 0;
  f18 = Math_fround(HEAPF32[i21 >> 2]);
  f31 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f12 = Math_fround(f18 * f31);
  i23 = i9 + 16 | 0;
  f16 = Math_fround(HEAPF32[i23 >> 2]);
  f29 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f34 = Math_fround(f16 * f29);
  i25 = i9 + 20 | 0;
  f14 = Math_fround(HEAPF32[i25 >> 2]);
  f28 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  f32 = Math_fround(f14 * f28);
  i27 = i9 + 24 | 0;
  f30 = Math_fround(HEAPF32[i27 >> 2]);
  f26 = Math_fround(HEAPF32[i10 + 24 >> 2]);
  f32 = Math_fround(Math_fround(f12 + f34) + Math_fround(f32 + Math_fround(f30 * f26)));
  i33 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = i33 & -2147483648;
  i15 = i33 ^ (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = i33 ^ (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = i33 ^ (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = i33 ^ (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18);
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f16);
  f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
  f26 = Math_fround(f18 + Math_fround(f26 * f6));
  f28 = Math_fround(f16 + Math_fround(f28 * f6));
  f29 = Math_fround(f14 + Math_fround(f29 * f6));
  f30 = Math_fround(f30 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30) * f6));
  f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f28 * f28)) + Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30))))));
  f26 = Math_fround(f14 * f26);
  f28 = Math_fround(f14 * f28);
  f29 = Math_fround(f14 * f29);
  f30 = Math_fround(f14 * f30);
  f14 = Math_fround(HEAPF32[i10 + 28 >> 2]);
  f16 = Math_fround(HEAPF32[i10 + 32 >> 2]);
  f18 = Math_fround(HEAPF32[i10 + 36 >> 2]);
  i33 = i9 + 28 | 0;
  f31 = Math_fround(HEAPF32[i33 >> 2]);
  i8 = i9 + 32 | 0;
  f32 = Math_fround(HEAPF32[i8 >> 2]);
  i1 = i9 + 36 | 0;
  f34 = Math_fround(HEAPF32[i1 >> 2]);
  f31 = Math_fround(f31 + Math_fround(Math_fround(f14 - f31) * f6));
  f32 = Math_fround(f32 + Math_fround(Math_fround(f16 - f32) * f6));
  f34 = Math_fround(f34 + Math_fround(Math_fround(f18 - f34) * f6));
  HEAPF32[i9 >> 2] = f20;
  HEAPF32[i17 >> 2] = f22;
  HEAPF32[i19 >> 2] = f24;
  HEAPF32[i21 >> 2] = f26;
  HEAPF32[i23 >> 2] = f28;
  HEAPF32[i25 >> 2] = f29;
  HEAPF32[i27 >> 2] = f30;
  HEAPF32[i33 >> 2] = f31;
  HEAPF32[i8 >> 2] = f32;
  HEAPF32[i1 >> 2] = f34;
  i1 = 0;
  i8 = 27;
  break;
 } else {
  i33 = HEAP32[i10 + 4 >> 2] | 0;
  i25 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = i33;
  HEAP32[i9 + 8 >> 2] = i25;
  i25 = HEAP32[i10 + 16 >> 2] | 0;
  i33 = HEAP32[i10 + 20 >> 2] | 0;
  i27 = HEAP32[i10 + 24 >> 2] | 0;
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = i25;
  HEAP32[i9 + 20 >> 2] = i33;
  HEAP32[i9 + 24 >> 2] = i27;
  i27 = HEAP32[i10 + 32 >> 2] | 0;
  i33 = HEAP32[i10 + 36 >> 2] | 0;
  HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  HEAP32[i9 + 32 >> 2] = i27;
  HEAP32[i9 + 36 >> 2] = i33;
  break;
 } while (0);
 if ((i8 | 0) == 27) {
  while (1) {
   i33 = i1 + 59 | 0;
   if (HEAP32[i11 + (i33 >>> 5 << 2) >> 2] & 1 << (i33 & 31) | 0) {
    i25 = i9 + 804 + (i1 * 12 | 0) | 0;
    f30 = Math_fround(HEAPF32[i25 >> 2]);
    i27 = i9 + 804 + (i1 * 12 | 0) + 4 | 0;
    f29 = Math_fround(HEAPF32[i27 >> 2]);
    i33 = i9 + 804 + (i1 * 12 | 0) + 8 | 0;
    f30 = Math_fround(f7 * f30);
    f29 = Math_fround(f7 * f29);
    f34 = Math_fround(f7 * Math_fround(HEAPF32[i33 >> 2]));
    f31 = Math_fround(HEAPF32[i10 + 804 + (i1 * 12 | 0) >> 2]);
    f32 = Math_fround(HEAPF32[i10 + 804 + (i1 * 12 | 0) + 4 >> 2]);
    f32 = Math_fround(f29 + Math_fround(f32 * f6));
    f34 = Math_fround(f34 + Math_fround(Math_fround(HEAPF32[i10 + 804 + (i1 * 12 | 0) + 8 >> 2]) * f6));
    HEAPF32[i25 >> 2] = Math_fround(f30 + Math_fround(f31 * f6));
    HEAPF32[i27 >> 2] = f32;
    HEAPF32[i33 >> 2] = f34;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 7) break; else i8 = 27;
  }
  return;
 }
 if (HEAP32[i4 >> 2] & 134217728 | 0) {
  i27 = HEAP32[i10 + 808 >> 2] | 0;
  i33 = HEAP32[i10 + 812 >> 2] | 0;
  HEAP32[i9 + 804 >> 2] = HEAP32[i10 + 804 >> 2];
  HEAP32[i9 + 808 >> 2] = i27;
  HEAP32[i9 + 812 >> 2] = i33;
 }
 if (HEAP32[i4 >> 2] & 268435456 | 0) {
  i27 = HEAP32[i10 + 820 >> 2] | 0;
  i33 = HEAP32[i10 + 824 >> 2] | 0;
  HEAP32[i9 + 816 >> 2] = HEAP32[i10 + 816 >> 2];
  HEAP32[i9 + 820 >> 2] = i27;
  HEAP32[i9 + 824 >> 2] = i33;
 }
 if (HEAP32[i4 >> 2] & 536870912 | 0) {
  i27 = HEAP32[i10 + 832 >> 2] | 0;
  i33 = HEAP32[i10 + 836 >> 2] | 0;
  HEAP32[i9 + 828 >> 2] = HEAP32[i10 + 828 >> 2];
  HEAP32[i9 + 832 >> 2] = i27;
  HEAP32[i9 + 836 >> 2] = i33;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 & 1073741824) {
  i33 = HEAP32[i10 + 844 >> 2] | 0;
  i1 = HEAP32[i10 + 848 >> 2] | 0;
  HEAP32[i9 + 840 >> 2] = HEAP32[i10 + 840 >> 2];
  HEAP32[i9 + 844 >> 2] = i33;
  HEAP32[i9 + 848 >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if ((i1 | 0) <= -1) {
  i27 = HEAP32[i10 + 856 >> 2] | 0;
  i33 = HEAP32[i10 + 860 >> 2] | 0;
  HEAP32[i9 + 852 >> 2] = HEAP32[i10 + 852 >> 2];
  HEAP32[i9 + 856 >> 2] = i27;
  HEAP32[i9 + 860 >> 2] = i33;
 }
 if (HEAP32[i11 + 8 >> 2] & 1 | 0) {
  i27 = HEAP32[i10 + 868 >> 2] | 0;
  i33 = HEAP32[i10 + 872 >> 2] | 0;
  HEAP32[i9 + 864 >> 2] = HEAP32[i10 + 864 >> 2];
  HEAP32[i9 + 868 >> 2] = i27;
  HEAP32[i9 + 872 >> 2] = i33;
 }
 if (!(HEAP32[i11 + 8 >> 2] & 2)) return;
 i27 = HEAP32[i10 + 880 >> 2] | 0;
 i33 = HEAP32[i10 + 884 >> 2] | 0;
 HEAP32[i9 + 876 >> 2] = HEAP32[i10 + 876 >> 2];
 HEAP32[i9 + 880 >> 2] = i27;
 HEAP32[i9 + 884 >> 2] = i33;
 return;
}

function __ZL21ContactReductionAllInRN5physx2Gu13ContactBufferEjjRKNS_7PxMat33EPKNS_6PxVec3EPKh(i67, i69, i4, i62, i64, i63) {
 i67 = i67 | 0;
 i69 = i69 | 0;
 i4 = i4 | 0;
 i62 = i62 | 0;
 i64 = i64 | 0;
 i63 = i63 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i65 = 0, i66 = 0, i68 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i61 = i70 + 64 | 0;
 i60 = i70 + 32 | 0;
 i59 = i70;
 i68 = i67 + 4096 | 0;
 i1 = HEAP32[i68 >> 2] | 0;
 i66 = i1 - i69 | 0;
 if (i66 >>> 0 < 5) {
  STACKTOP = i70;
  return;
 }
 if ((i66 | 0) == (i4 | 0)) {
  if (i4 >>> 0 > 1) {
   i1 = 0;
   f7 = Math_fround(HEAPF32[i67 + (i69 << 6) + 12 >> 2]);
   i3 = 1;
   while (1) {
    f5 = Math_fround(HEAPF32[i67 + (i3 + i69 << 6) + 12 >> 2]);
    i2 = f7 > f5;
    i1 = i2 ? i3 : i1;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) {
     i6 = i1;
     break;
    } else f7 = i2 ? f5 : f7;
   }
  } else i6 = 0;
  i1 = i4 << 14 & 1073725440;
  i2 = 0;
  i3 = 0;
  i4 = 1;
  while (1) {
   i66 = i3 >>> 16;
   i65 = i2 + i69 | 0;
   i64 = i66 + i69 | 0;
   HEAP32[i67 + (i65 << 6) >> 2] = HEAP32[i67 + (i64 << 6) >> 2];
   HEAP32[i67 + (i65 << 6) + 4 >> 2] = HEAP32[i67 + (i64 << 6) + 4 >> 2];
   HEAP32[i67 + (i65 << 6) + 8 >> 2] = HEAP32[i67 + (i64 << 6) + 8 >> 2];
   HEAP32[i67 + (i65 << 6) + 12 >> 2] = HEAP32[i67 + (i64 << 6) + 12 >> 2];
   HEAP32[i67 + (i65 << 6) + 16 >> 2] = HEAP32[i67 + (i64 << 6) + 16 >> 2];
   HEAP32[i67 + (i65 << 6) + 20 >> 2] = HEAP32[i67 + (i64 << 6) + 20 >> 2];
   HEAP32[i67 + (i65 << 6) + 24 >> 2] = HEAP32[i67 + (i64 << 6) + 24 >> 2];
   HEAP32[i67 + (i65 << 6) + 28 >> 2] = HEAP32[i67 + (i64 << 6) + 28 >> 2];
   HEAP32[i67 + (i65 << 6) + 32 >> 2] = HEAP32[i67 + (i64 << 6) + 32 >> 2];
   HEAP32[i67 + (i65 << 6) + 36 >> 2] = HEAP32[i67 + (i64 << 6) + 36 >> 2];
   HEAP32[i67 + (i65 << 6) + 40 >> 2] = HEAP32[i67 + (i64 << 6) + 40 >> 2];
   i65 = i67 + (i65 << 6) + 44 | 0;
   i64 = i67 + (i64 << 6) + 44 | 0;
   HEAP32[i65 >> 2] = HEAP32[i64 >> 2];
   HEAP32[i65 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
   HEAP32[i65 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
   HEAP32[i65 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
   HEAP32[i65 + 16 >> 2] = HEAP32[i64 + 16 >> 2];
   i4 = i4 & (i66 | 0) != (i6 | 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 4) break; else i3 = i3 + i1 | 0;
  }
  i1 = i69 + 4 | 0;
  if (i4) {
   i65 = i6 + i69 | 0;
   HEAP32[i67 + (i1 << 6) >> 2] = HEAP32[i67 + (i65 << 6) >> 2];
   HEAP32[i67 + (i1 << 6) + 4 >> 2] = HEAP32[i67 + (i65 << 6) + 4 >> 2];
   HEAP32[i67 + (i1 << 6) + 8 >> 2] = HEAP32[i67 + (i65 << 6) + 8 >> 2];
   HEAP32[i67 + (i1 << 6) + 12 >> 2] = HEAP32[i67 + (i65 << 6) + 12 >> 2];
   HEAP32[i67 + (i1 << 6) + 16 >> 2] = HEAP32[i67 + (i65 << 6) + 16 >> 2];
   HEAP32[i67 + (i1 << 6) + 20 >> 2] = HEAP32[i67 + (i65 << 6) + 20 >> 2];
   HEAP32[i67 + (i1 << 6) + 24 >> 2] = HEAP32[i67 + (i65 << 6) + 24 >> 2];
   HEAP32[i67 + (i1 << 6) + 28 >> 2] = HEAP32[i67 + (i65 << 6) + 28 >> 2];
   HEAP32[i67 + (i1 << 6) + 32 >> 2] = HEAP32[i67 + (i65 << 6) + 32 >> 2];
   HEAP32[i67 + (i1 << 6) + 36 >> 2] = HEAP32[i67 + (i65 << 6) + 36 >> 2];
   HEAP32[i67 + (i1 << 6) + 40 >> 2] = HEAP32[i67 + (i65 << 6) + 40 >> 2];
   i66 = i67 + (i1 << 6) + 44 | 0;
   i67 = i67 + (i65 << 6) + 44 | 0;
   HEAP32[i66 >> 2] = HEAP32[i67 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
   HEAP32[i66 + 12 >> 2] = HEAP32[i67 + 12 >> 2];
   HEAP32[i66 + 16 >> 2] = HEAP32[i67 + 16 >> 2];
   HEAP32[i68 >> 2] = i69 + 5;
   STACKTOP = i70;
   return;
  } else {
   HEAP32[i68 >> 2] = i1;
   STACKTOP = i70;
   return;
  }
 }
 HEAPF32[i61 >> 2] = Math_fround(1.0);
 i4 = i61 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAP32[i61 + 8 >> 2] = 0;
 i6 = i61 + 12 | 0;
 HEAPF32[i6 >> 2] = Math_fround(.923879504);
 i8 = i61 + 16 | 0;
 HEAPF32[i8 >> 2] = Math_fround(.382683456);
 HEAP32[i61 + 20 >> 2] = 0;
 i16 = i61 + 24 | 0;
 HEAPF32[i16 >> 2] = Math_fround(.707106769);
 i18 = i61 + 28 | 0;
 HEAPF32[i18 >> 2] = Math_fround(.707106769);
 HEAP32[i61 + 32 >> 2] = 0;
 HEAPF32[i61 + 36 >> 2] = Math_fround(.382683426);
 HEAPF32[i61 + 40 >> 2] = Math_fround(.923879504);
 HEAP32[i61 + 44 >> 2] = 0;
 HEAPF32[i61 + 48 >> 2] = Math_fround(-4.37113883e-08);
 HEAPF32[i61 + 52 >> 2] = Math_fround(1.0);
 HEAP32[i61 + 56 >> 2] = 0;
 HEAPF32[i61 + 60 >> 2] = Math_fround(-.382683516);
 HEAPF32[i61 + 64 >> 2] = Math_fround(.923879504);
 HEAP32[i61 + 68 >> 2] = 0;
 HEAPF32[i61 + 72 >> 2] = Math_fround(-.707106769);
 HEAPF32[i61 + 76 >> 2] = Math_fround(.707106769);
 HEAP32[i61 + 80 >> 2] = 0;
 i2 = i61 + 84 | 0;
 HEAPF32[i2 >> 2] = Math_fround(-.923879504);
 i3 = i61 + 88 | 0;
 HEAPF32[i3 >> 2] = Math_fround(.382683486);
 HEAP32[i61 + 92 >> 2] = 0;
 HEAPF32[i60 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i59 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i19 = i60 + 4 | 0;
 HEAPF32[i19 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i46 = i59 + 4 | 0;
 HEAPF32[i46 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i47 = i60 + 8 | 0;
 HEAPF32[i47 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i48 = i59 + 8 | 0;
 HEAPF32[i48 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i49 = i60 + 12 | 0;
 HEAPF32[i49 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i50 = i59 + 12 | 0;
 HEAPF32[i50 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i51 = i60 + 16 | 0;
 HEAPF32[i51 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i52 = i59 + 16 | 0;
 HEAPF32[i52 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i53 = i60 + 20 | 0;
 HEAPF32[i53 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i54 = i59 + 20 | 0;
 HEAPF32[i54 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i55 = i60 + 24 | 0;
 HEAPF32[i55 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i56 = i59 + 24 | 0;
 HEAPF32[i56 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i57 = i60 + 28 | 0;
 HEAPF32[i57 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i58 = i59 + 28 | 0;
 HEAPF32[i58 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i65 = (i1 | 0) == (i69 | 0);
 if (i65) {
  f25 = Math_fround(-3402823469999999843913219.0e14);
  f24 = Math_fround(3402823469999999843913219.0e14);
  f23 = Math_fround(-3402823469999999843913219.0e14);
  f22 = Math_fround(3402823469999999843913219.0e14);
  f21 = Math_fround(-3402823469999999843913219.0e14);
  f20 = Math_fround(3402823469999999843913219.0e14);
  f17 = Math_fround(-3402823469999999843913219.0e14);
  f15 = Math_fround(3402823469999999843913219.0e14);
  f14 = Math_fround(-3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  f12 = Math_fround(-3402823469999999843913219.0e14);
  f11 = Math_fround(3402823469999999843913219.0e14);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
 } else {
  f40 = Math_fround(HEAPF32[i62 >> 2]);
  f41 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i62 + 12 >> 2]);
  f43 = Math_fround(HEAPF32[i62 + 16 >> 2]);
  f44 = Math_fround(HEAPF32[i62 + 24 >> 2]);
  f45 = Math_fround(HEAPF32[i62 + 28 >> 2]);
  f39 = Math_fround(HEAPF32[i2 >> 2]);
  f38 = Math_fround(HEAPF32[i3 >> 2]);
  f37 = Math_fround(HEAPF32[i61 >> 2]);
  f36 = Math_fround(HEAPF32[i4 >> 2]);
  f35 = Math_fround(HEAPF32[i6 >> 2]);
  f34 = Math_fround(HEAPF32[i8 >> 2]);
  f33 = Math_fround(HEAPF32[i16 >> 2]);
  f32 = Math_fround(HEAPF32[i18 >> 2]);
  f9 = Math_fround(HEAPF32[i55 >> 2]);
  f10 = Math_fround(HEAPF32[i56 >> 2]);
  f5 = Math_fround(HEAPF32[i57 >> 2]);
  f26 = Math_fround(1.0);
  f27 = Math_fround(.923879504);
  f28 = Math_fround(.707106769);
  f29 = Math_fround(0.0);
  f30 = Math_fround(.382683456);
  f31 = Math_fround(.707106769);
  f24 = Math_fround(3402823469999999843913219.0e14);
  f25 = Math_fround(-3402823469999999843913219.0e14);
  f22 = Math_fround(3402823469999999843913219.0e14);
  f23 = Math_fround(-3402823469999999843913219.0e14);
  f20 = Math_fround(3402823469999999843913219.0e14);
  f21 = Math_fround(-3402823469999999843913219.0e14);
  f15 = Math_fround(3402823469999999843913219.0e14);
  f17 = Math_fround(-3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  f14 = Math_fround(-3402823469999999843913219.0e14);
  f11 = Math_fround(3402823469999999843913219.0e14);
  f12 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(HEAPF32[i58 >> 2]);
  i1 = 0;
  while (1) {
   i18 = HEAPU8[i63 + i1 >> 0] | 0;
   f71 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) >> 2]);
   f72 = Math_fround(f71 * f40);
   f71 = Math_fround(f71 * f41);
   f73 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) + 4 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f73 * f42));
   f73 = Math_fround(f71 + Math_fround(f73 * f43));
   f71 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) + 8 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f71 * f44));
   f71 = Math_fround(f73 + Math_fround(f71 * f45));
   f29 = Math_fround(Math_fround(f72 * f26) + Math_fround(f71 * f29));
   f24 = f24 < f29 ? f24 : f29;
   f25 = f25 > f29 ? f25 : f29;
   f30 = Math_fround(Math_fround(f72 * f27) + Math_fround(f71 * f30));
   f22 = f22 < f30 ? f22 : f30;
   f23 = f23 > f30 ? f23 : f30;
   f31 = Math_fround(Math_fround(f72 * f28) + Math_fround(f71 * f31));
   f20 = f20 < f31 ? f20 : f31;
   f21 = f21 > f31 ? f21 : f31;
   f31 = Math_fround(f71 * Math_fround(.923879504));
   f30 = Math_fround(Math_fround(f72 * Math_fround(.382683426)) + f31);
   f15 = f15 < f30 ? f15 : f30;
   f17 = f17 > f30 ? f17 : f30;
   f30 = Math_fround(Math_fround(f72 * Math_fround(-4.37113883e-08)) + f71);
   f13 = f13 < f30 ? f13 : f30;
   f14 = f14 > f30 ? f14 : f30;
   f31 = Math_fround(Math_fround(f72 * Math_fround(-.382683516)) + f31);
   f11 = f11 < f31 ? f11 : f31;
   f12 = f12 > f31 ? f12 : f31;
   f31 = Math_fround(Math_fround(f72 * Math_fround(-.707106769)) + Math_fround(f71 * Math_fround(.707106769)));
   f9 = f9 < f31 ? f9 : f31;
   f10 = f10 > f31 ? f10 : f31;
   f31 = Math_fround(Math_fround(f72 * f39) + Math_fround(f71 * f38));
   f5 = f5 < f31 ? f5 : f31;
   f7 = f7 > f31 ? f7 : f31;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i66 | 0)) break; else {
    f26 = f37;
    f27 = f35;
    f28 = f33;
    f29 = f36;
    f30 = f34;
    f31 = f32;
   }
  }
  HEAPF32[i60 >> 2] = f24;
  HEAPF32[i59 >> 2] = f25;
  HEAPF32[i19 >> 2] = f22;
  HEAPF32[i46 >> 2] = f23;
  HEAPF32[i47 >> 2] = f20;
  HEAPF32[i48 >> 2] = f21;
  HEAPF32[i49 >> 2] = f15;
  HEAPF32[i50 >> 2] = f17;
  HEAPF32[i51 >> 2] = f13;
  HEAPF32[i52 >> 2] = f14;
  HEAPF32[i53 >> 2] = f11;
  HEAPF32[i54 >> 2] = f12;
  HEAPF32[i55 >> 2] = f9;
  HEAPF32[i56 >> 2] = f10;
  HEAPF32[i57 >> 2] = f5;
  HEAPF32[i58 >> 2] = f7;
 }
 f73 = Math_fround(f25 - f24);
 f23 = Math_fround(f23 - f22);
 i60 = f23 > f73;
 f23 = i60 ? f23 : f73;
 f73 = Math_fround(f21 - f20);
 i59 = f73 > f23;
 f23 = i59 ? f73 : f23;
 f73 = Math_fround(f17 - f15);
 i58 = f73 > f23;
 f23 = i58 ? f73 : f23;
 f14 = Math_fround(f14 - f13);
 i57 = f14 > f23;
 f23 = i57 ? f14 : f23;
 f14 = Math_fround(f12 - f11);
 i56 = f14 > f23;
 f23 = i56 ? f14 : f23;
 f14 = Math_fround(f10 - f9);
 i55 = f14 > f23;
 i54 = Math_fround(f7 - f5) > (i55 ? f14 : f23);
 i60 = i54 ? 7 : i55 ? 6 : i56 ? 5 : i57 ? 4 : i58 ? 3 : i59 ? 2 : i60 & 1;
 f23 = Math_fround(HEAPF32[i61 + (i60 * 12 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i61 + (i60 * 12 | 0) + 4 >> 2]);
 if (i65) {
  i2 = 0;
  i3 = 0;
  i8 = 0;
  i1 = 0;
 } else {
  f15 = Math_fround(HEAPF32[i62 >> 2]);
  f17 = Math_fround(HEAPF32[i62 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i62 + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i62 + 16 >> 2]);
  f22 = Math_fround(HEAPF32[i62 + 24 >> 2]);
  f5 = Math_fround(HEAPF32[i62 + 28 >> 2]);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f12 = Math_fround(3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  i19 = 0;
  i2 = 0;
  i3 = 0;
  i8 = 0;
  i1 = 0;
  while (1) {
   i18 = HEAPU8[i63 + i19 >> 0] | 0;
   f73 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) >> 2]);
   f9 = Math_fround(f73 * f15);
   f73 = Math_fround(f73 * f17);
   f7 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) + 4 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f7 * f20));
   f7 = Math_fround(f73 + Math_fround(f7 * f21));
   f73 = Math_fround(HEAPF32[i64 + (i18 * 12 | 0) + 8 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f73 * f22));
   f73 = Math_fround(f7 + Math_fround(f73 * f5));
   f7 = Math_fround(Math_fround(f23 * f9) + Math_fround(f14 * f73));
   f9 = Math_fround(Math_fround(f23 * f73) - Math_fround(f14 * f9));
   i18 = f7 < f12;
   i8 = i18 ? i19 : i8;
   i16 = f7 > f10;
   i2 = i16 ? i19 : i2;
   i6 = f9 < f13;
   i1 = i6 ? i19 : i1;
   i4 = f9 > f11;
   i3 = i4 ? i19 : i3;
   i19 = i19 + 1 | 0;
   if ((i19 | 0) == (i66 | 0)) break; else {
    f10 = i16 ? f7 : f10;
    f11 = i4 ? f9 : f11;
    f12 = i18 ? f7 : f12;
    f13 = i6 ? f9 : f13;
   }
  }
 }
 i6 = (i2 | 0) == (i8 | 0) ? -1 : i2;
 i4 = (i1 | 0) == (i8 | 0) | (i1 | 0) == (i6 | 0) ? -1 : i1;
 i3 = (i3 | 0) == (i8 | 0) | (i3 | 0) == (i6 | 0) | (i3 | 0) == (i4 | 0) ? -1 : i3;
 if (i65) i1 = 0; else {
  i2 = 0;
  i1 = 0;
  do {
   if ((i2 | 0) == (i3 | 0) | ((i2 | 0) == (i4 | 0) | ((i2 | 0) == (i8 | 0) | (i2 | 0) == (i6 | 0)))) {
    i65 = i1 + i69 | 0;
    i64 = i2 + i69 | 0;
    HEAP32[i67 + (i65 << 6) >> 2] = HEAP32[i67 + (i64 << 6) >> 2];
    HEAP32[i67 + (i65 << 6) + 4 >> 2] = HEAP32[i67 + (i64 << 6) + 4 >> 2];
    HEAP32[i67 + (i65 << 6) + 8 >> 2] = HEAP32[i67 + (i64 << 6) + 8 >> 2];
    HEAP32[i67 + (i65 << 6) + 12 >> 2] = HEAP32[i67 + (i64 << 6) + 12 >> 2];
    HEAP32[i67 + (i65 << 6) + 16 >> 2] = HEAP32[i67 + (i64 << 6) + 16 >> 2];
    HEAP32[i67 + (i65 << 6) + 20 >> 2] = HEAP32[i67 + (i64 << 6) + 20 >> 2];
    HEAP32[i67 + (i65 << 6) + 24 >> 2] = HEAP32[i67 + (i64 << 6) + 24 >> 2];
    HEAP32[i67 + (i65 << 6) + 28 >> 2] = HEAP32[i67 + (i64 << 6) + 28 >> 2];
    HEAP32[i67 + (i65 << 6) + 32 >> 2] = HEAP32[i67 + (i64 << 6) + 32 >> 2];
    HEAP32[i67 + (i65 << 6) + 36 >> 2] = HEAP32[i67 + (i64 << 6) + 36 >> 2];
    HEAP32[i67 + (i65 << 6) + 40 >> 2] = HEAP32[i67 + (i64 << 6) + 40 >> 2];
    i65 = i67 + (i65 << 6) + 44 | 0;
    i64 = i67 + (i64 << 6) + 44 | 0;
    HEAP32[i65 >> 2] = HEAP32[i64 >> 2];
    HEAP32[i65 + 4 >> 2] = HEAP32[i64 + 4 >> 2];
    HEAP32[i65 + 8 >> 2] = HEAP32[i64 + 8 >> 2];
    HEAP32[i65 + 12 >> 2] = HEAP32[i64 + 12 >> 2];
    HEAP32[i65 + 16 >> 2] = HEAP32[i64 + 16 >> 2];
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i66 | 0));
 }
 HEAP32[i68 >> 2] = i1 + i69;
 STACKTOP = i70;
 return;
}

function __Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere(i45, i37, i1, i6) {
 i45 = i45 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i46 = 0, f47 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i46 + 128 | 0;
 i7 = i46 + 64 | 0;
 i27 = i46;
 if (!(i1 & 2)) {
  f3 = Math_fround(HEAPF32[i37 >> 2]);
  f4 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  if (!i1) f2 = Math_fround(1.0); else f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f5 * f5)))));
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i37 + 48 >> 2]));
  f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i37 + 52 >> 2]));
  f12 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i37 + 56 >> 2]));
  f10 = Math_fround(Math_fround(Math_fround(f8 * f3) + Math_fround(f13 * f4)) + Math_fround(f12 * f5));
  f11 = Math_fround(f8 * Math_fround(HEAPF32[i37 + 16 >> 2]));
  f11 = Math_fround(f11 + Math_fround(f13 * Math_fround(HEAPF32[i37 + 20 >> 2])));
  f11 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i37 + 24 >> 2])));
  f4 = Math_fround(f8 * Math_fround(HEAPF32[i37 + 32 >> 2]));
  f13 = Math_fround(f4 + Math_fround(f13 * Math_fround(HEAPF32[i37 + 36 >> 2])));
  f10 = Math_fround(f2 * Math_fround(f2 * f10));
  f11 = Math_fround(f2 * Math_fround(f2 * f11));
  f12 = Math_fround(f2 * Math_fround(f2 * Math_fround(f13 + Math_fround(f12 * Math_fround(HEAPF32[i37 + 40 >> 2])))));
  f13 = Math_fround(f2 * Math_fround(HEAPF32[i6 + 12 >> 2]));
  f4 = Math_fround(HEAPF32[i45 >> 2]);
  f5 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  i34 = i45 + 12 | 0;
  f43 = Math_fround(HEAPF32[i34 >> 2]);
  f2 = Math_fround(HEAPF32[i34 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i34 + 8 >> 2]);
  f4 = Math_fround(f10 - f4);
  f5 = Math_fround(f11 - f5);
  f8 = Math_fround(f12 - f8);
  i34 = f4 < Math_fround(-f43);
  i36 = f5 < Math_fround(-f2);
  i44 = f8 < Math_fround(-f3);
  f12 = Math_fround(-f4);
  f11 = Math_fround(-f5);
  f10 = Math_fround(-f8);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f10 = (HEAP32[tempDoublePtr >> 2] = i34 ? i1 : i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i36 ? i7 : i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f4 + f10);
  f11 = Math_fround(f5 + f11);
  f12 = Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i44 ? i9 : i45, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i6 = f4 > f43 ? i1 : (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = f5 > f2 ? i7 : (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i45 = f8 > f3 ? i9 : (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  f41 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f42 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround(f4 - f41);
  f42 = Math_fround(f5 - f42);
  f43 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i45 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(Math_fround(f43 * f43) + Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))) + Math_fround(0.0))) < Math_fround(f13 * f13);
  STACKTOP = i46;
  return i45 | 0;
 }
 f4 = Math_fround(HEAPF32[i37 >> 2]);
 f2 = Math_fround(HEAPF32[i45 >> 2]);
 f41 = Math_fround(f4 * f2);
 i28 = i37 + 16 | 0;
 f12 = Math_fround(HEAPF32[i28 >> 2]);
 f39 = Math_fround(HEAPF32[i45 + 4 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f12 * f39));
 i29 = i37 + 32 | 0;
 f8 = Math_fround(HEAPF32[i29 >> 2]);
 f43 = Math_fround(HEAPF32[i45 + 8 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f8 * f43));
 f41 = Math_fround(Math_fround(HEAPF32[i37 + 48 >> 2]) + f41);
 i30 = i37 + 4 | 0;
 f11 = Math_fround(HEAPF32[i30 >> 2]);
 f42 = Math_fround(f2 * f11);
 i31 = i37 + 20 | 0;
 f10 = Math_fround(HEAPF32[i31 >> 2]);
 f42 = Math_fround(f42 + Math_fround(f39 * f10));
 i32 = i37 + 36 | 0;
 f5 = Math_fround(HEAPF32[i32 >> 2]);
 f42 = Math_fround(f42 + Math_fround(f43 * f5));
 f42 = Math_fround(Math_fround(HEAPF32[i37 + 52 >> 2]) + f42);
 i33 = i37 + 8 | 0;
 f13 = Math_fround(HEAPF32[i33 >> 2]);
 f2 = Math_fround(f2 * f13);
 i34 = i37 + 24 | 0;
 f3 = Math_fround(HEAPF32[i34 >> 2]);
 f39 = Math_fround(f2 + Math_fround(f39 * f3));
 i35 = i37 + 40 | 0;
 f2 = Math_fround(HEAPF32[i35 >> 2]);
 f43 = Math_fround(f39 + Math_fround(f43 * f2));
 f43 = Math_fround(Math_fround(HEAPF32[i37 + 56 >> 2]) + f43);
 f41 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f41);
 f42 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f42);
 f43 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f43);
 f39 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)) + Math_fround(f43 * f43));
 i44 = i6 + 12 | 0;
 f40 = Math_fround(HEAPF32[i44 >> 2]);
 if (f39 < Math_fround(f40 * f40)) {
  i45 = 1;
  STACKTOP = i46;
  return i45 | 0;
 }
 HEAPF32[i20 >> 2] = f4;
 i18 = i20 + 4 | 0;
 HEAPF32[i18 >> 2] = f11;
 i19 = i20 + 8 | 0;
 HEAPF32[i19 >> 2] = f13;
 f40 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f11 * f11)) + Math_fround(f13 * f13))));
 if (f40 > Math_fround(0.0)) {
  f39 = Math_fround(Math_fround(1.0) / f40);
  f4 = Math_fround(f39 * f4);
  HEAPF32[i20 >> 2] = f4;
  f11 = Math_fround(f39 * f11);
  HEAPF32[i18 >> 2] = f11;
  f13 = Math_fround(f39 * f13);
  HEAPF32[i19 >> 2] = f13;
 }
 i23 = i20 + 12 | 0;
 HEAPF32[i23 >> 2] = f12;
 i21 = i20 + 16 | 0;
 HEAPF32[i21 >> 2] = f10;
 i22 = i20 + 20 | 0;
 HEAPF32[i22 >> 2] = f3;
 f39 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f10 * f10)) + Math_fround(f3 * f3))));
 if (f39 > Math_fround(0.0)) {
  f38 = Math_fround(Math_fround(1.0) / f39);
  f12 = Math_fround(f38 * f12);
  HEAPF32[i23 >> 2] = f12;
  f10 = Math_fround(f38 * f10);
  HEAPF32[i21 >> 2] = f10;
  f3 = Math_fround(f38 * f3);
  HEAPF32[i22 >> 2] = f3;
 }
 i26 = i20 + 24 | 0;
 HEAPF32[i26 >> 2] = f8;
 i24 = i20 + 28 | 0;
 HEAPF32[i24 >> 2] = f5;
 i25 = i20 + 32 | 0;
 HEAPF32[i25 >> 2] = f2;
 f38 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f5 * f5)) + Math_fround(f2 * f2))));
 if (f38 > Math_fround(0.0)) {
  f17 = Math_fround(Math_fround(1.0) / f38);
  f8 = Math_fround(f17 * f8);
  HEAPF32[i26 >> 2] = f8;
  f5 = Math_fround(f17 * f5);
  HEAPF32[i24 >> 2] = f5;
  f2 = Math_fround(f17 * f2);
  HEAPF32[i25 >> 2] = f2;
 }
 f17 = Math_fround(Math_fround(Math_fround(f4 * f12) + Math_fround(f11 * f10)) + Math_fround(f13 * f3));
 i36 = f17 < Math_fround(0.0);
 f14 = Math_fround(-f17);
 f17 = i36 ? f14 : f17;
 i36 = f17 < Math_fround(0.0);
 f17 = i36 ? Math_fround(0.0) : f17;
 f14 = Math_fround(Math_fround(Math_fround(f12 * f8) + Math_fround(f10 * f5)) + Math_fround(f3 * f2));
 i36 = f14 < Math_fround(0.0);
 f47 = Math_fround(-f14);
 f14 = i36 ? f47 : f14;
 f14 = f14 < f17 ? f17 : f14;
 f17 = Math_fround(Math_fround(Math_fround(f4 * f8) + Math_fround(f11 * f5)) + Math_fround(f13 * f2));
 i36 = f17 < Math_fround(0.0);
 f47 = Math_fround(-f17);
 f17 = i36 ? f47 : f17;
 i36 = (f17 < f14 ? f14 : f17) > Math_fround(.0000999999974);
 if (i36) {
  __ZN10Matrix4x4f8SetBasisERK8Vector3fS2_S2_(i7, i20, i23, i26) | 0;
  __Z25InvertMatrix4x4_General3DPKfPf(i7, i27) | 0;
  __ZN10Matrix4x4f9TransposeEv(i27) | 0;
  f17 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  i1 = HEAP32[gb + 1162364 >> 2] | 0;
  i6 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i7 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i27 >> 2]);
  f3 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4))));
  if (f5 > f17) {
   f47 = Math_fround(f2 / f5);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f3 / f5);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f4 / f5);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i9 = i1;
   i15 = i6;
   i16 = i7;
  }
  HEAP32[i20 >> 2] = i9;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i19 >> 2] = i16;
  f2 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f3 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f5 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f5 * f5))));
  f4 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f8 > f17) {
   f47 = Math_fround(f2 / f8);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f3 / f8);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f5 / f8);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i9 = i1;
   i15 = i6;
   i16 = i7;
  }
  HEAP32[i23 >> 2] = i9;
  HEAP32[i21 >> 2] = i15;
  HEAP32[i22 >> 2] = i16;
  f8 = Math_fround(HEAPF32[i27 + 32 >> 2]);
  f14 = Math_fround(HEAPF32[i27 + 36 >> 2]);
  f2 = Math_fround(HEAPF32[i27 + 40 >> 2]);
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f14 * f14)) + Math_fround(f2 * f2))));
  f12 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f5 > f17) {
   f47 = Math_fround(f8 / f5);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f14 / f5);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(f2 / f5);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  }
  HEAP32[i26 >> 2] = i1;
  HEAP32[i24 >> 2] = i6;
  HEAP32[i25 >> 2] = i7;
  f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i45 + 12 | 0;
  if (i36) {
   f47 = Math_fround(HEAPF32[i1 >> 2]);
   f39 = Math_fround(HEAPF32[i37 >> 2]);
   f40 = Math_fround(HEAPF32[i30 >> 2]);
   f47 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f39) * f4) + Math_fround(Math_fround(f47 * f40) * f11)) + Math_fround(Math_fround(f47 * Math_fround(HEAPF32[i33 >> 2])) * f13));
   f40 = Math_fround(Math_fround(Math_fround(f41 * f4) + Math_fround(f42 * f11)) + Math_fround(f43 * f13));
   i45 = f40 < Math_fround(0.0);
   f39 = Math_fround(-f40);
   i6 = f47 < Math_fround(0.0);
   f4 = Math_fround(-f47);
   f4 = Math_fround((i45 ? f39 : f40) - (i6 ? f4 : f47));
   i6 = f4 < Math_fround(0.0);
   f4 = i6 ? Math_fround(0.0) : f4;
   f47 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f40 = Math_fround(HEAPF32[i28 >> 2]);
   f39 = Math_fround(HEAPF32[i31 >> 2]);
   f47 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f40) * f12) + Math_fround(Math_fround(f47 * f39) * f10)) + Math_fround(Math_fround(f47 * Math_fround(HEAPF32[i34 >> 2])) * f3));
   f39 = Math_fround(Math_fround(Math_fround(f41 * f12) + Math_fround(f42 * f10)) + Math_fround(f43 * f3));
   i6 = f39 < Math_fround(0.0);
   f40 = Math_fround(-f39);
   i45 = f47 < Math_fround(0.0);
   f3 = Math_fround(-f47);
   f3 = Math_fround((i6 ? f40 : f39) - (i45 ? f3 : f47));
   i45 = f3 < Math_fround(0.0);
   f3 = i45 ? Math_fround(0.0) : f3;
   f47 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f39 = Math_fround(HEAPF32[i29 >> 2]);
   f40 = Math_fround(HEAPF32[i32 >> 2]);
   f47 = Math_fround(Math_fround(Math_fround(Math_fround(f47 * f39) * f8) + Math_fround(Math_fround(f47 * f40) * f5)) + Math_fround(Math_fround(f47 * Math_fround(HEAPF32[i35 >> 2])) * f2));
   f43 = Math_fround(Math_fround(Math_fround(f41 * f8) + Math_fround(f42 * f5)) + Math_fround(f43 * f2));
   i45 = f43 < Math_fround(0.0);
   f42 = Math_fround(-f43);
   i6 = f47 < Math_fround(0.0);
   f2 = Math_fround(-f47);
   f2 = Math_fround((i45 ? f42 : f43) - (i6 ? f2 : f47));
   i6 = f2 < Math_fround(0.0);
   f2 = i6 ? Math_fround(0.0) : f2;
   i6 = 15;
  } else i6 = 14;
 } else {
  i1 = i45 + 12 | 0;
  i6 = 14;
 }
 if ((i6 | 0) == 14) {
  f47 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f40);
  f40 = Math_fround(Math_fround(Math_fround(f41 * f4) + Math_fround(f42 * f11)) + Math_fround(f43 * f13));
  i37 = f40 < Math_fround(0.0);
  f17 = Math_fround(-f40);
  i35 = f47 < Math_fround(0.0);
  f4 = Math_fround(-f47);
  f4 = Math_fround((i37 ? f17 : f40) - (i35 ? f4 : f47));
  i35 = f4 < Math_fround(0.0);
  f4 = i35 ? Math_fround(0.0) : f4;
  f47 = Math_fround(Math_fround(HEAPF32[i45 + 12 + 4 >> 2]) * f39);
  f40 = Math_fround(Math_fround(Math_fround(f41 * f12) + Math_fround(f42 * f10)) + Math_fround(f43 * f3));
  i35 = f40 < Math_fround(0.0);
  f39 = Math_fround(-f40);
  i37 = f47 < Math_fround(0.0);
  f3 = Math_fround(-f47);
  f3 = Math_fround((i35 ? f39 : f40) - (i37 ? f3 : f47));
  i37 = f3 < Math_fround(0.0);
  f3 = i37 ? Math_fround(0.0) : f3;
  f47 = Math_fround(Math_fround(HEAPF32[i45 + 12 + 8 >> 2]) * f38);
  f43 = Math_fround(Math_fround(Math_fround(f41 * f8) + Math_fround(f42 * f5)) + Math_fround(f43 * f2));
  i37 = f43 < Math_fround(0.0);
  f42 = Math_fround(-f43);
  i45 = f47 < Math_fround(0.0);
  f2 = Math_fround(-f47);
  f2 = Math_fround((i37 ? f42 : f43) - (i45 ? f2 : f47));
  i45 = f2 < Math_fround(0.0);
  f2 = i45 ? Math_fround(0.0) : f2;
  if (i36) i6 = 15; else {
   f43 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2));
   f47 = Math_fround(HEAPF32[i44 >> 2]);
   i1 = f43 < Math_fround(f47 * f47);
  }
 }
 if ((i6 | 0) == 15) {
  f47 = f4 < f3 ? f3 : f4;
  i1 = (f47 < f2 ? f2 : f47) < Math_fround(HEAPF32[i44 >> 2]);
 }
 i45 = i1;
 STACKTOP = i46;
 return i45 | 0;
}

function __ZN5physx2Gu19sweepCapsuleCapsuleERKNS0_7CapsuleES3_RKNS_6PxVec3EfRfRS4_S8_jRt(i6, i50, i48, f41, i67, i66, i68, i65, i69) {
 i6 = i6 | 0;
 i50 = i50 | 0;
 i48 = i48 | 0;
 f41 = Math_fround(f41);
 i67 = i67 | 0;
 i66 = i66 | 0;
 i68 = i68 | 0;
 i65 = i65 | 0;
 i69 = i69 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i70 = 0, i71 = 0, i72 = 0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i72 + 48 | 0;
 i45 = i72 + 64 | 0;
 i47 = i72 + 40 | 0;
 i62 = i72 + 24 | 0;
 i70 = i72 + 12 | 0;
 i71 = i72;
 i63 = i6 + 24 | 0;
 f42 = Math_fround(HEAPF32[i63 >> 2]);
 i64 = i50 + 24 | 0;
 f42 = Math_fround(f42 + Math_fround(HEAPF32[i64 >> 2]));
 f7 = Math_fround(HEAPF32[i50 >> 2]);
 i49 = i50 + 12 | 0;
 f8 = Math_fround(HEAPF32[i49 >> 2]);
 f26 = Math_fround(f7 + f8);
 i52 = i50 + 4 | 0;
 f2 = Math_fround(HEAPF32[i52 >> 2]);
 i51 = i50 + 16 | 0;
 f3 = Math_fround(HEAPF32[i51 >> 2]);
 f28 = Math_fround(f2 + f3);
 i53 = i50 + 8 | 0;
 f4 = Math_fround(HEAPF32[i53 >> 2]);
 i54 = i50 + 20 | 0;
 f5 = Math_fround(HEAPF32[i54 >> 2]);
 f26 = Math_fround(f26 * Math_fround(.5));
 f28 = Math_fround(f28 * Math_fround(.5));
 f34 = Math_fround(Math_fround(f4 + f5) * Math_fround(.5));
 HEAPF32[i46 >> 2] = f26;
 HEAPF32[i46 + 4 >> 2] = f28;
 HEAPF32[i46 + 8 >> 2] = f34;
 L1 : do if (!(i65 & 16)) {
  f40 = Math_fround(HEAPF32[i6 >> 2]);
  i1 = i6 + 12 | 0;
  if (f40 == Math_fround(HEAPF32[i1 >> 2])) {
   f40 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   if (f40 == Math_fround(HEAPF32[i6 + 16 >> 2])) {
    f40 = Math_fround(HEAPF32[i6 + 8 >> 2]);
    if (f40 == Math_fround(HEAPF32[i6 + 20 >> 2])) {
     if (!(Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i50, i50 + 12 | 0, i6, 0)) < Math_fround(f42 * f42))) {
      i61 = i6;
      i56 = i1;
      i57 = i50;
      break;
     }
    } else i9 = 7;
   } else i9 = 7;
  } else i9 = 7;
  do if ((i9 | 0) == 7) if (f7 == f8 & f2 == f3 & f4 == f5) if (Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i6, i6 + 12 | 0, i50, 0)) < Math_fround(f42 * f42)) break; else {
   i61 = i6;
   i56 = i1;
   i57 = i50;
   break L1;
  } else if (Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i6, i50, 0, 0)) < Math_fround(f42 * f42)) break; else {
   i61 = i6;
   i56 = i1;
   i57 = i50;
   break L1;
  } while (0);
  HEAPF32[i67 >> 2] = Math_fround(0.0);
  f40 = Math_fround(-Math_fround(HEAPF32[i48 >> 2]));
  f41 = Math_fround(-Math_fround(HEAPF32[i48 + 4 >> 2]));
  f42 = Math_fround(-Math_fround(HEAPF32[i48 + 8 >> 2]));
  HEAPF32[i68 >> 2] = f40;
  HEAPF32[i68 + 4 >> 2] = f41;
  HEAPF32[i68 + 8 >> 2] = f42;
  HEAP16[i69 >> 1] = 6;
  i71 = 1;
  STACKTOP = i72;
  return i71 | 0;
 } else {
  i61 = i6;
  i56 = i6 + 12 | 0;
  i57 = i50;
 } while (0);
 f23 = Math_fround(HEAPF32[i49 >> 2]);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i50 >> 2]));
 f5 = Math_fround(HEAPF32[i51 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i52 >> 2]));
 f24 = Math_fround(HEAPF32[i54 >> 2]);
 f23 = Math_fround(f23 * Math_fround(.5));
 f5 = Math_fround(f5 * Math_fround(.5));
 f24 = Math_fround(Math_fround(f24 - Math_fround(HEAPF32[i53 >> 2])) * Math_fround(.5));
 f35 = Math_fround(HEAPF32[i61 >> 2]);
 f38 = Math_fround(f35 - f23);
 i58 = i6 + 4 | 0;
 f36 = Math_fround(HEAPF32[i58 >> 2]);
 f39 = Math_fround(f36 - f5);
 i59 = i6 + 8 | 0;
 f37 = Math_fround(HEAPF32[i59 >> 2]);
 f40 = Math_fround(f37 - f24);
 f31 = Math_fround(HEAPF32[i56 >> 2]);
 f29 = Math_fround(f31 - f23);
 i60 = i6 + 16 | 0;
 f32 = Math_fround(HEAPF32[i60 >> 2]);
 f30 = Math_fround(f32 - f5);
 i55 = i6 + 20 | 0;
 f33 = Math_fround(HEAPF32[i55 >> 2]);
 f27 = Math_fround(f33 - f24);
 f35 = Math_fround(f23 + f35);
 f36 = Math_fround(f5 + f36);
 f37 = Math_fround(f24 + f37);
 f31 = Math_fround(f23 + f31);
 f32 = Math_fround(f5 + f32);
 f33 = Math_fround(f24 + f33);
 f24 = Math_fround(f31 - f35);
 f5 = Math_fround(f32 - f36);
 f23 = Math_fround(f33 - f37);
 f3 = Math_fround(f29 - f35);
 f25 = Math_fround(f30 - f36);
 f4 = Math_fround(f27 - f37);
 f2 = Math_fround(Math_fround(f5 * f4) - Math_fround(f25 * f23));
 f4 = Math_fround(Math_fround(f3 * f23) - Math_fround(f24 * f4));
 f5 = Math_fround(Math_fround(f24 * f25) - Math_fround(f3 * f5));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)))));
 if (f3 > Math_fround(0.0)) {
  f25 = Math_fround(Math_fround(1.0) / f3);
  f2 = Math_fround(f2 * f25);
  f4 = Math_fround(f4 * f25);
  f5 = Math_fround(f5 * f25);
 }
 f23 = Math_fround(HEAPF32[i48 >> 2]);
 f22 = Math_fround(f2 * f23);
 i43 = i48 + 4 | 0;
 f24 = Math_fround(HEAPF32[i43 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f4 * f24));
 i44 = i48 + 8 | 0;
 f25 = Math_fround(HEAPF32[i44 >> 2]);
 f7 = Math_fround(f42 * f2);
 f3 = Math_fround(f42 * f4);
 f2 = Math_fround(f42 * f5);
 if (!(Math_fround(f22 + Math_fround(f5 * f25)) >= Math_fround(0.0))) {
  f22 = Math_fround(f27 + f2);
  f20 = Math_fround(f30 + f3);
  f18 = Math_fround(f29 + f7);
  f8 = Math_fround(f40 + f2);
  f5 = Math_fround(f39 + f3);
  f4 = Math_fround(f38 + f7);
  f10 = Math_fround(f33 + f2);
  f3 = Math_fround(f32 + f3);
  f2 = Math_fround(f31 + f7);
 } else {
  f22 = Math_fround(f27 - f2);
  f20 = Math_fround(f30 - f3);
  f18 = Math_fround(f29 - f7);
  f8 = Math_fround(f33 - f2);
  f5 = Math_fround(f32 - f3);
  f4 = Math_fround(f31 - f7);
  f10 = Math_fround(f40 - f2);
  f3 = Math_fround(f39 - f3);
  f2 = Math_fround(f38 - f7);
 }
 f21 = Math_fround(f4 - f18);
 f19 = Math_fround(f5 - f20);
 f13 = Math_fround(f8 - f22);
 f17 = Math_fround(f2 - f18);
 f14 = Math_fround(f3 - f20);
 f10 = Math_fround(f10 - f22);
 f3 = Math_fround(Math_fround(f10 * f24) - Math_fround(f14 * f25));
 f4 = Math_fround(Math_fround(f17 * f25) - Math_fround(f10 * f23));
 f7 = Math_fround(Math_fround(f14 * f23) - Math_fround(f17 * f24));
 f12 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f21 * f3) + Math_fround(f19 * f4)));
 if (f12 < Math_fround(9.99999974e-06)) {
  f3 = f41;
  i9 = 20;
 } else {
  f8 = Math_fround(f26 - f18);
  f5 = Math_fround(f28 - f20);
  f2 = Math_fround(f34 - f22);
  f34 = Math_fround(Math_fround(f7 * f2) + Math_fround(Math_fround(f4 * f5) + Math_fround(f3 * f8)));
  if (f34 < Math_fround(0.0) | f34 > f12) {
   f3 = f41;
   i9 = 20;
  } else {
   f4 = Math_fround(Math_fround(f13 * f5) - Math_fround(f19 * f2));
   f3 = Math_fround(Math_fround(f21 * f2) - Math_fround(f13 * f8));
   f2 = Math_fround(Math_fround(f19 * f8) - Math_fround(f21 * f5));
   f34 = Math_fround(Math_fround(f25 * f2) + Math_fround(Math_fround(f23 * f4) + Math_fround(f24 * f3)));
   if (f34 < Math_fround(0.0) | f34 > f12) {
    f3 = f41;
    i9 = 20;
   } else {
    f3 = Math_fround(Math_fround(Math_fround(f10 * f2) + Math_fround(Math_fround(f17 * f4) + Math_fround(f14 * f3))) * Math_fround(Math_fround(1.0) / f12));
    i16 = f3 >= Math_fround(0.0) & f3 < f41;
    f3 = i16 ? f3 : f41;
    if (i16) f17 = f3; else i9 = 20;
   }
  }
 }
 do if ((i9 | 0) == 20) {
  HEAPF32[i45 >> 2] = f38;
  HEAPF32[i45 + 4 >> 2] = f39;
  HEAPF32[i45 + 8 >> 2] = f40;
  HEAPF32[i45 + 12 >> 2] = f29;
  HEAPF32[i45 + 16 >> 2] = f30;
  HEAPF32[i45 + 20 >> 2] = f27;
  HEAPF32[i45 + 24 >> 2] = f42;
  HEAPF32[i45 + 28 >> 2] = f29;
  HEAPF32[i45 + 32 >> 2] = f30;
  HEAPF32[i45 + 36 >> 2] = f27;
  HEAPF32[i45 + 40 >> 2] = f31;
  HEAPF32[i45 + 44 >> 2] = f32;
  HEAPF32[i45 + 48 >> 2] = f33;
  i9 = i45 + 52 | 0;
  HEAPF32[i9 >> 2] = f42;
  HEAPF32[i45 + 56 >> 2] = f31;
  HEAPF32[i45 + 60 >> 2] = f32;
  HEAPF32[i45 + 64 >> 2] = f33;
  HEAPF32[i45 + 68 >> 2] = f35;
  HEAPF32[i45 + 72 >> 2] = f36;
  HEAPF32[i45 + 76 >> 2] = f37;
  i15 = i45 + 80 | 0;
  HEAPF32[i15 >> 2] = f42;
  HEAPF32[i45 + 84 >> 2] = f38;
  HEAPF32[i45 + 88 >> 2] = f39;
  HEAPF32[i45 + 92 >> 2] = f40;
  HEAPF32[i45 + 96 >> 2] = f35;
  HEAPF32[i45 + 100 >> 2] = f36;
  HEAPF32[i45 + 104 >> 2] = f37;
  i11 = i45 + 108 | 0;
  HEAPF32[i11 >> 2] = f42;
  i16 = i47 + 4 | 0;
  i1 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i46, i48, i45, i45 + 12 | 0, f42, i47) | 0;
  if (!i1) i6 = 0; else {
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   if ((i1 | 0) != 1) {
    f42 = Math_fround(HEAPF32[i16 >> 2]);
    f2 = f2 < f42 ? f2 : f42;
   }
   i1 = !(f2 >= Math_fround(0.0));
   i6 = !(f2 <= f3);
   f3 = i1 | i6 ? f3 : f2;
   i6 = (i1 | i6) ^ 1;
  }
  i1 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i46, i48, i45 + 28 | 0, i45 + 40 | 0, Math_fround(HEAPF32[i9 >> 2]), i47) | 0;
  if (i1) {
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   if ((i1 | 0) != 1) {
    f42 = Math_fround(HEAPF32[i16 >> 2]);
    f2 = f2 < f42 ? f2 : f42;
   }
   i1 = !(f2 >= Math_fround(0.0));
   i9 = !(f2 <= f3);
   f3 = i1 | i9 ? f3 : f2;
   i6 = i6 | (i1 | i9) ^ 1;
  }
  i1 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i46, i48, i45 + 56 | 0, i45 + 68 | 0, Math_fround(HEAPF32[i15 >> 2]), i47) | 0;
  if (!i1) i9 = i6; else {
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   if ((i1 | 0) != 1) {
    f42 = Math_fround(HEAPF32[i16 >> 2]);
    f2 = f2 < f42 ? f2 : f42;
   }
   i15 = !(f2 >= Math_fround(0.0));
   i9 = !(f2 <= f3);
   f3 = i15 | i9 ? f3 : f2;
   i9 = i6 | (i15 | i9) ^ 1;
  }
  i1 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i46, i48, i45 + 84 | 0, i45 + 96 | 0, Math_fround(HEAPF32[i11 >> 2]), i47) | 0;
  if (!i1) {
   if (i9) {
    f17 = f3;
    break;
   } else i1 = 0;
   STACKTOP = i72;
   return i1 | 0;
  }
  f2 = Math_fround(HEAPF32[i47 >> 2]);
  if ((i1 | 0) != 1) {
   f42 = Math_fround(HEAPF32[i16 >> 2]);
   f2 = f2 < f42 ? f2 : f42;
  }
  i1 = !(f2 >= Math_fround(0.0));
  i6 = !(f2 <= f3);
  if (i9 | (i1 | i6) ^ 1) f17 = i1 | i6 ? f3 : f2; else {
   i71 = 0;
   STACKTOP = i72;
   return i71 | 0;
  }
 } while (0);
 HEAP16[i69 >> 1] = 4;
 if (i65 & 3 | 0) {
  f13 = Math_fround(HEAPF32[i48 >> 2]);
  f14 = Math_fround(HEAPF32[i43 >> 2]);
  f13 = Math_fround(f17 * f13);
  f14 = Math_fround(f17 * f14);
  f12 = Math_fround(f17 * Math_fround(HEAPF32[i44 >> 2]));
  f40 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f13);
  f41 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) - f14);
  f42 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) - f12);
  f13 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) - f13);
  f14 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f14);
  f13 = Math_fround(f13 - f40);
  f14 = Math_fround(f14 - f41);
  f12 = Math_fround(Math_fround(Math_fround(HEAPF32[i55 >> 2]) - f12) - f42);
  f10 = Math_fround(HEAPF32[i49 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i50 >> 2]));
  f8 = Math_fround(HEAPF32[i51 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i52 >> 2]));
  f7 = Math_fround(HEAPF32[i54 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i53 >> 2]));
  HEAPF32[i62 >> 2] = f10;
  HEAPF32[i62 + 4 >> 2] = f8;
  HEAPF32[i62 + 8 >> 2] = f7;
  __ZL12edgeEdgeDistRN5physx6PxVec3ES1_RKS0_S3_S3_S3_(i70, i71, f40, f41, f42, f13, f14, f12, i57, i62);
  if (i65 & 2 | 0) {
   f2 = Math_fround(HEAPF32[i70 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i71 >> 2]));
   i1 = i70 + 4 | 0;
   f3 = Math_fround(HEAPF32[i1 >> 2]);
   i6 = i71 + 4 | 0;
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i6 >> 2]));
   i9 = i70 + 8 | 0;
   f4 = Math_fround(HEAPF32[i9 >> 2]);
   i11 = i71 + 8 | 0;
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i11 >> 2]));
   HEAPF32[i68 >> 2] = f2;
   i15 = i68 + 4 | 0;
   HEAPF32[i15 >> 2] = f3;
   i16 = i68 + 8 | 0;
   HEAPF32[i16 >> 2] = f4;
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4))));
   if (f5 > Math_fround(0.0)) {
    f42 = Math_fround(Math_fround(1.0) / f5);
    HEAPF32[i68 >> 2] = Math_fround(f2 * f42);
    HEAPF32[i15 >> 2] = Math_fround(f3 * f42);
    HEAPF32[i16 >> 2] = Math_fround(f4 * f42);
   }
   if (f5 < Math_fround(.00100000005)) {
    f5 = Math_fround(Math_fround(f12 * f8) - Math_fround(f14 * f7));
    f4 = Math_fround(Math_fround(f13 * f7) - Math_fround(f12 * f10));
    f2 = Math_fround(Math_fround(f14 * f10) - Math_fround(f13 * f8));
    HEAPF32[i68 >> 2] = f5;
    HEAPF32[i15 >> 2] = f4;
    HEAPF32[i16 >> 2] = f2;
    f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
    if (f3 > Math_fround(0.0)) {
     f42 = Math_fround(Math_fround(1.0) / f3);
     HEAPF32[i68 >> 2] = Math_fround(f5 * f42);
     HEAPF32[i15 >> 2] = Math_fround(f4 * f42);
     HEAPF32[i16 >> 2] = Math_fround(f2 * f42);
    }
    if (f3 < Math_fround(.00100000005)) {
     f3 = Math_fround(HEAPF32[i56 >> 2]);
     f41 = Math_fround(HEAPF32[i61 >> 2]);
     f3 = Math_fround(f3 - f41);
     f2 = Math_fround(HEAPF32[i60 >> 2]);
     f42 = Math_fround(HEAPF32[i58 >> 2]);
     f2 = Math_fround(f2 - f42);
     f4 = Math_fround(HEAPF32[i55 >> 2]);
     f5 = Math_fround(HEAPF32[i59 >> 2]);
     __ZL12edgeEdgeDistRN5physx6PxVec3ES1_RKS0_S3_S3_S3_(i70, i71, f41, f42, f5, f3, f2, Math_fround(f4 - f5), i57, i62);
     f5 = Math_fround(HEAPF32[i70 >> 2]);
     f5 = Math_fround(f5 - Math_fround(HEAPF32[i71 >> 2]));
     f4 = Math_fround(HEAPF32[i1 >> 2]);
     f4 = Math_fround(f4 - Math_fround(HEAPF32[i6 >> 2]));
     f2 = Math_fround(HEAPF32[i9 >> 2]);
     f2 = Math_fround(f2 - Math_fround(HEAPF32[i11 >> 2]));
     HEAPF32[i68 >> 2] = f5;
     HEAPF32[i15 >> 2] = f4;
     HEAPF32[i16 >> 2] = f2;
     f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
     if (f3 > Math_fround(0.0)) {
      f42 = Math_fround(Math_fround(1.0) / f3);
      HEAPF32[i68 >> 2] = Math_fround(f5 * f42);
      HEAPF32[i15 >> 2] = Math_fround(f4 * f42);
      HEAPF32[i16 >> 2] = Math_fround(f2 * f42);
     }
    }
   }
   HEAP16[i69 >> 1] = HEAPU16[i69 >> 1] | 0 | 2;
  }
  if (i65 & 1 | 0) {
   f40 = Math_fround(HEAPF32[i64 >> 2]);
   f37 = Math_fround(HEAPF32[i70 >> 2]);
   f36 = Math_fround(HEAPF32[i70 + 4 >> 2]);
   f37 = Math_fround(f40 * f37);
   f36 = Math_fround(f40 * f36);
   f42 = Math_fround(f40 * Math_fround(HEAPF32[i70 + 8 >> 2]));
   f38 = Math_fround(HEAPF32[i63 >> 2]);
   f39 = Math_fround(HEAPF32[i71 >> 2]);
   f41 = Math_fround(HEAPF32[i71 + 4 >> 2]);
   f40 = Math_fround(Math_fround(1.0) / Math_fround(f40 + f38));
   f41 = Math_fround(f40 * Math_fround(f36 + Math_fround(f38 * f41)));
   f42 = Math_fround(f40 * Math_fround(f42 + Math_fround(f38 * Math_fround(HEAPF32[i71 + 8 >> 2]))));
   HEAPF32[i66 >> 2] = Math_fround(Math_fround(f37 + Math_fround(f38 * f39)) * f40);
   HEAPF32[i66 + 4 >> 2] = f41;
   HEAPF32[i66 + 8 >> 2] = f42;
   HEAP16[i69 >> 1] = HEAPU16[i69 >> 1] | 0 | 1;
  }
 }
 HEAPF32[i67 >> 2] = f17;
 i71 = 1;
 STACKTOP = i72;
 return i71 | 0;
}

function __ZL22stbir__decode_scanlineP11stbir__infoi(i14, i8) {
 i14 = i14 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = HEAP32[i14 + 64 >> 2] | 0;
 i18 = HEAP32[i14 + 68 >> 2] | 0;
 i15 = HEAP32[i14 + 76 >> 2] | 0;
 i7 = HEAP32[i14 + 96 >> 2] | 0;
 i1 = HEAP32[i14 + 4 >> 2] | 0;
 i6 = HEAP32[i14 + 12 >> 2] | 0;
 i22 = HEAP32[i14 + 120 >> 2] | 0;
 i21 = HEAP32[i14 + 144 >> 2] | 0;
 i20 = Math_imul(i21, i23) | 0;
 i16 = i22 + (i20 << 2) | 0;
 i17 = HEAP32[i14 + 88 >> 2] | 0;
 i9 = HEAP32[i14 + 92 >> 2] | 0;
 i2 = HEAP32[i14 + 8 >> 2] | 0;
 i3 = (i8 | 0) > -1;
 i10 = (i2 | 0) > (i8 | 0);
 L1 : do if (i3 & i10) i2 = i8; else {
  i4 = 0 - i8 | 0;
  switch (i9 | 0) {
  case 3:
   if (i3) {
    i2 = (i8 | 0) % (i2 | 0) | 0;
    break L1;
   } else {
    i19 = (i4 | 0) % (i2 | 0) | 0;
    i2 = (i19 | 0) == 0 ? 0 : i2 - i19 | 0;
    break L1;
   }
  case 1:
   {
    i2 = (i8 | 0) < 0 ? 0 : i10 ? i8 : i2 + -1 | 0;
    break L1;
   }
  case 2:
   {
    if ((i8 | 0) < 0) {
     i2 = i10 ? i4 : i2 + -1 | 0;
     break L1;
    }
    i2 = i2 << 1;
    if (i10) {
     i2 = i8;
     break L1;
    }
    i2 = (i2 | 0) > (i8 | 0) ? i2 + ~i8 | 0 : 0;
    break L1;
   }
  default:
   {
    i2 = 0;
    break L1;
   }
  }
 } while (0);
 i13 = Math_imul(i2, i6) | 0;
 i13 = (HEAP32[i14 >> 2] | 0) + i13 | 0;
 i19 = i21 + i1 | 0;
 i3 = (i15 << 1) + i7 | 0;
 i2 = 0 - i21 | 0;
 if ((i9 | 0) == 4) if ((i8 | 0) < 0 | i10 ^ 1) {
  if (!((i19 | 0) > (i2 | 0) & (i23 | 0) > 0)) return;
  i3 = i23 << 2;
  i1 = i1 + (i21 << 1) | 0;
  i2 = 0;
  do {
   _memset(i22 + ((Math_imul(i23, i2) | 0) << 2) | 0, 0, i3 | 0) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  return;
 }
 switch (i3 | 0) {
 case 0:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i8 = (i23 | 0) > 0;
    i9 = i1 + -1 | 0;
    i10 = i1 << 1;
    i7 = i2;
    do {
     i11 = Math_imul(i7, i23) | 0;
     i4 = (i7 | 0) > -1;
     i6 = (i7 | 0) < (i1 | 0);
     L30 : do if (i4 & i6) i3 = i7; else {
      i3 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i4) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L30;
       } else {
        i3 = (i3 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L30;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i6 ? i7 : i9;
        break L30;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i6 ? i3 : i9;
         break L30;
        }
        if (i6) {
         i3 = i7;
         break L30;
        }
        i3 = (i10 | 0) > (i7 | 0) ? i10 + ~i7 | 0 : 0;
        break L30;
       }
      default:
       {
        i3 = 0;
        break L30;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i8) {
      i3 = 0;
      do {
       HEAPF32[i16 + (i3 + i11 << 2) >> 2] = Math_fround(Math_fround(HEAPU8[i13 + (i3 + i4) >> 0] | 0) / Math_fround(255.0));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 1:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = i14 + 72 | 0;
    i11 = i1 + -1 | 0;
    i12 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L52 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L52;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L52;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i11;
        break L52;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i11;
         break L52;
        }
        if (i4) {
         i3 = i7;
         break L52;
        }
        i3 = (i12 | 0) > (i7 | 0) ? i12 + ~i7 | 0 : 0;
        break L52;
       }
      default:
       {
        i3 = 0;
        break L52;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       HEAP32[i16 + (i3 + i8 << 2) >> 2] = HEAP32[gb + 72320 + ((HEAPU8[i13 + (i3 + i4) >> 0] | 0) << 2) >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     if (!(HEAP32[i10 >> 2] & 2)) HEAPF32[i16 + (i8 + i18 << 2) >> 2] = Math_fround(Math_fround(HEAPU8[i13 + (i4 + i18) >> 0] | 0) / Math_fround(255.0));
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 2:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = i1 + -1 | 0;
    i11 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L77 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L77;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L77;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i10;
        break L77;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i10;
         break L77;
        }
        if (i4) {
         i3 = i7;
         break L77;
        }
        i3 = (i11 | 0) > (i7 | 0) ? i11 + ~i7 | 0 : 0;
        break L77;
       }
      default:
       {
        i3 = 0;
        break L77;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       HEAPF32[i16 + (i3 + i8 << 2) >> 2] = Math_fround(Math_fround(HEAPU16[i13 + (i3 + i4 << 1) >> 1] | 0) / Math_fround(65535.0));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 3:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = (HEAP32[i14 + 72 >> 2] & 2 | 0) == 0;
    i11 = i1 + -1 | 0;
    i12 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L99 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L99;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L99;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i11;
        break L99;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i11;
         break L99;
        }
        if (i4) {
         i3 = i7;
         break L99;
        }
        i3 = (i12 | 0) > (i7 | 0) ? i12 + ~i7 | 0 : 0;
        break L99;
       }
      default:
       {
        i3 = 0;
        break L99;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       f5 = Math_fround(Math_fround(HEAPU16[i13 + (i3 + i4 << 1) >> 1] | 0) / Math_fround(65535.0));
       if (!(f5 <= Math_fround(.0404499993))) f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001)); else f5 = Math_fround(f5 / Math_fround(12.9200001));
       HEAPF32[i16 + (i3 + i8 << 2) >> 2] = f5;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     if (i10) HEAPF32[i16 + (i8 + i18 << 2) >> 2] = Math_fround(Math_fround(HEAPU16[i13 + (i4 + i18 << 1) >> 1] | 0) / Math_fround(65535.0));
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 4:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = i1 + -1 | 0;
    i11 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L128 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L128;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L128;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i10;
        break L128;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i10;
         break L128;
        }
        if (i4) {
         i3 = i7;
         break L128;
        }
        i3 = (i11 | 0) > (i7 | 0) ? i11 + ~i7 | 0 : 0;
        break L128;
       }
      default:
       {
        i3 = 0;
        break L128;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       HEAPF32[i16 + (i3 + i8 << 2) >> 2] = Math_fround(+((HEAP32[i13 + (i3 + i4 << 2) >> 2] | 0) >>> 0) / 4294967295.0);
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 5:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = (HEAP32[i14 + 72 >> 2] & 2 | 0) == 0;
    i11 = i1 + -1 | 0;
    i12 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L150 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L150;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L150;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i11;
        break L150;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i11;
         break L150;
        }
        if (i4) {
         i3 = i7;
         break L150;
        }
        i3 = (i12 | 0) > (i7 | 0) ? i12 + ~i7 | 0 : 0;
        break L150;
       }
      default:
       {
        i3 = 0;
        break L150;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       f5 = Math_fround(+((HEAP32[i13 + (i3 + i4 << 2) >> 2] | 0) >>> 0) / 4294967295.0);
       if (!(f5 <= Math_fround(.0404499993))) f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001)); else f5 = Math_fround(f5 / Math_fround(12.9200001));
       HEAPF32[i16 + (i3 + i8 << 2) >> 2] = f5;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     if (i10) HEAPF32[i16 + (i8 + i18 << 2) >> 2] = Math_fround(+((HEAP32[i13 + (i4 + i18 << 2) >> 2] | 0) >>> 0) / 4294967295.0);
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 6:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = i1 + -1 | 0;
    i11 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L179 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L179;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L179;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i10;
        break L179;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i10;
         break L179;
        }
        if (i4) {
         i3 = i7;
         break L179;
        }
        i3 = (i11 | 0) > (i7 | 0) ? i11 + ~i7 | 0 : 0;
        break L179;
       }
      default:
       {
        i3 = 0;
        break L179;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       HEAP32[i16 + (i3 + i8 << 2) >> 2] = HEAP32[i13 + (i3 + i4 << 2) >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 case 7:
  {
   if ((i19 | 0) > (i2 | 0)) {
    i9 = (i23 | 0) > 0;
    i10 = (HEAP32[i14 + 72 >> 2] & 2 | 0) == 0;
    i11 = i1 + -1 | 0;
    i12 = i1 << 1;
    i7 = i2;
    do {
     i8 = Math_imul(i7, i23) | 0;
     i3 = (i7 | 0) > -1;
     i4 = (i7 | 0) < (i1 | 0);
     L201 : do if (i3 & i4) i3 = i7; else {
      i6 = 0 - i7 | 0;
      switch (i17 | 0) {
      case 3:
       if (i3) {
        i3 = (i7 | 0) % (i1 | 0) | 0;
        break L201;
       } else {
        i3 = (i6 | 0) % (i1 | 0) | 0;
        i3 = (i3 | 0) == 0 ? 0 : i1 - i3 | 0;
        break L201;
       }
      case 1:
       {
        i3 = (i7 | 0) < 0 ? 0 : i4 ? i7 : i11;
        break L201;
       }
      case 2:
       {
        if ((i7 | 0) < 0) {
         i3 = i4 ? i6 : i11;
         break L201;
        }
        if (i4) {
         i3 = i7;
         break L201;
        }
        i3 = (i12 | 0) > (i7 | 0) ? i12 + ~i7 | 0 : 0;
        break L201;
       }
      default:
       {
        i3 = 0;
        break L201;
       }
      }
     } while (0);
     i4 = Math_imul(i3, i23) | 0;
     if (i9) {
      i3 = 0;
      do {
       f5 = Math_fround(HEAPF32[i13 + (i3 + i4 << 2) >> 2]);
       if (!(f5 <= Math_fround(.0404499993))) f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001)); else f5 = Math_fround(f5 / Math_fround(12.9200001));
       HEAPF32[i16 + (i3 + i8 << 2) >> 2] = f5;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i23 | 0));
     }
     if (i10) HEAP32[i16 + (i8 + i18 << 2) >> 2] = HEAP32[i13 + (i4 + i18 << 2) >> 2];
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i19 | 0));
   }
   break;
  }
 default:
  {}
 }
 if ((i19 | 0) > (i2 | 0) ? (HEAP32[i14 + 72 >> 2] & 1 | 0) == 0 : 0) {
  i7 = (i23 | 0) > 0;
  if ((i15 | 0) == 3) do {
   i4 = Math_imul(i2, i23) | 0;
   f5 = Math_fround(HEAPF32[i16 + (i4 + i18 << 2) >> 2]);
   if (i7) {
    i3 = 0;
    do {
     i6 = i16 + (i3 + i4 << 2) | 0;
     if ((i3 | 0) != (i18 | 0)) HEAPF32[i6 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i23 | 0));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i19 | 0)); else do {
   i4 = Math_imul(i2, i23) | 0;
   i15 = i16 + (i4 + i18 << 2) | 0;
   f5 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + Math_fround(8.27180613e-25));
   HEAPF32[i15 >> 2] = f5;
   if (i7) {
    i3 = 0;
    do {
     i6 = i16 + (i3 + i4 << 2) | 0;
     if ((i3 | 0) != (i18 | 0)) HEAPF32[i6 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i23 | 0));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i19 | 0));
 }
 if ((i17 | 0) != 4) return;
 i2 = (i21 | 0) > 0;
 if (!(i2 & (i23 | 0) > 0)) return;
 i3 = i23 << 2;
 i4 = 0;
 do {
  _memset(i22 + ((Math_imul(i23, i4) | 0) << 2) | 0, 0, i3 | 0) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i21 | 0));
 if (!(i2 & (i23 | 0) > 0)) return;
 i3 = (Math_imul(i1, i23) | 0) + i20 | 0;
 i4 = i23 << 2;
 i2 = 0;
 while (1) {
  _memset(i22 + (i3 + (Math_imul(i23, i2) | 0) << 2) | 0, 0, i4 | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i19 | 0)) break; else i2 = i2 + 1 | 0;
 }
 return;
}

function __ZN5physx46solveTankInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPKbPKfPNS_20ImplicitSolverOutputE(i1, i45, i28, i3) {
 i1 = i1 | 0;
 i45 = i45 | 0;
 i28 = i28 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, f48 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 4736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i47 + 4656 | 0;
 i25 = i47 + 4576 | 0;
 i39 = i47 + 4496 | 0;
 i29 = i47 + 4416 | 0;
 i33 = i47 + 2296 | 0;
 i32 = i47 + 2200 | 0;
 i31 = i47 + 80 | 0;
 i46 = i47;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 i22 = HEAP32[i1 + 36 >> 2] | 0;
 i27 = HEAP32[i1 + 40 >> 2] | 0;
 i23 = HEAP32[i1 + 44 >> 2] | 0;
 i38 = HEAP32[i1 + 48 >> 2] | 0;
 i24 = HEAP32[i1 + 52 >> 2] | 0;
 i41 = HEAP32[i1 + 56 >> 2] | 0;
 i42 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 64 >> 2] | 0;
 i36 = HEAP32[i1 + 68 >> 2] | 0;
 i44 = HEAP32[i3 >> 2] | 0;
 i20 = HEAP32[i3 + 4 >> 2] | 0;
 f9 = Math_fround(f13 * f12);
 f10 = Math_fround(f12 * f9);
 i43 = i41 + -1 | 0;
 i37 = (i43 | 0) == 0;
 if (!i37) {
  i1 = 0;
  do {
   i4 = i1 << 2;
   HEAP32[i26 + (i4 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 232 >> 2];
   i30 = i4 | 1;
   HEAP32[i26 + (i30 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 280 >> 2];
   i35 = i4 | 2;
   HEAP32[i26 + (i35 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 328 >> 2];
   i40 = i4 | 3;
   HEAP32[i26 + (i40 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 376 >> 2];
   HEAP32[i25 + (i4 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 208 >> 2];
   HEAP32[i25 + (i30 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 256 >> 2];
   HEAP32[i25 + (i35 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 304 >> 2];
   HEAP32[i25 + (i40 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 352 >> 2];
   HEAP32[i29 + (i4 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 228 >> 2];
   HEAP32[i29 + (i30 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 276 >> 2];
   HEAP32[i29 + (i35 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 324 >> 2];
   HEAP32[i29 + (i40 << 2) >> 2] = HEAP32[i5 + (i1 * 944 | 0) + 372 >> 2];
   HEAP32[i39 + (i4 << 2) >> 2] = HEAP32[i44 + (i1 * 224 | 0) >> 2];
   HEAP32[i39 + (i30 << 2) >> 2] = HEAP32[i44 + (i1 * 224 | 0) + 4 >> 2];
   HEAP32[i39 + (i35 << 2) >> 2] = HEAP32[i44 + (i1 * 224 | 0) + 8 >> 2];
   HEAP32[i39 + (i40 << 2) >> 2] = HEAP32[i44 + (i1 * 224 | 0) + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i43 | 0));
 }
 i40 = (i42 - (i41 << 2) | 0) == -4;
 if (!i40) {
  i1 = i43 << 2;
  i4 = i41 << 2;
  i3 = i42 + 4 - i4 | 0;
  _memcpy(i39 + (i4 + -4 << 2) | 0, i44 + (i43 * 224 | 0) | 0, i3 << 2 | 0) | 0;
  i4 = 0;
  do {
   i35 = i4 + i1 | 0;
   HEAP32[i26 + (i35 << 2) >> 2] = HEAP32[i5 + (i43 * 944 | 0) + 192 + (i4 * 48 | 0) + 40 >> 2];
   HEAP32[i25 + (i35 << 2) >> 2] = HEAP32[i5 + (i43 * 944 | 0) + 192 + (i4 * 48 | 0) + 16 >> 2];
   HEAP32[i29 + (i35 << 2) >> 2] = HEAP32[i5 + (i43 * 944 | 0) + 192 + (i4 * 48 | 0) + 36 >> 2];
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 f17 = Math_fround(HEAPF32[i5 + 192 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 240 >> 2]);
 i30 = i42 + 1 | 0;
 i5 = i33 + 2116 | 0;
 HEAP32[i5 >> 2] = i30;
 HEAP32[i32 + 92 >> 2] = i30;
 i35 = (i42 | 0) == 0;
 if (!i35) {
  i1 = 0;
  do {
   f2 = Math_fround(f11 * Math_fround(HEAPF32[i26 + (i1 << 2) >> 2]));
   f6 = Math_fround(HEAPF32[i22 + (i1 << 2) >> 2]);
   f7 = Math_fround(HEAPF32[i28 + (i1 << 2) >> 2]);
   f8 = Math_fround(f7 * Math_fround(f6 * Math_fround(f10 * f2)));
   i3 = 0;
   do {
    f21 = Math_fround(f8 * Math_fround(HEAPF32[i27 + (i3 << 2) >> 2]));
    HEAPF32[i33 + (i1 * 92 | 0) + (i3 << 2) >> 2] = Math_fround(f21 * Math_fround(HEAPF32[i28 + (i3 << 2) >> 2]));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i42 | 0));
   f19 = Math_fround(Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i27 + (i1 << 2) >> 2])) * f7) + Math_fround(1.0));
   HEAPF32[i33 + (i1 * 92 | 0) + (i1 << 2) >> 2] = Math_fround(f19 + Math_fround(f2 * Math_fround(HEAPF32[i25 + (i1 << 2) >> 2])));
   HEAPF32[i33 + (i1 * 92 | 0) + (i42 << 2) >> 2] = Math_fround(-Math_fround(f7 * Math_fround(f6 * Math_fround(f9 * f2))));
   f19 = Math_fround(HEAPF32[i39 + (i1 << 2) >> 2]);
   f21 = Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
   HEAPF32[i32 + (i1 << 2) >> 2] = Math_fround(f19 + Math_fround(f2 * Math_fround(f21 + Math_fround(HEAPF32[i24 + (i1 << 2) >> 2]))));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i42 | 0));
 }
 i22 = i20 + 76 | 0;
 f7 = Math_fround(HEAPF32[i22 >> 2]);
 f6 = Math_fround(f11 * Math_fround(HEAPF32[i36 + 104 >> 2]));
 f2 = Math_fround(f12 * Math_fround(f13 * f6));
 if (!i35) {
  i1 = 0;
  do {
   f21 = Math_fround(f2 * Math_fround(HEAPF32[i27 + (i1 << 2) >> 2]));
   HEAPF32[i33 + (i42 * 92 | 0) + (i1 << 2) >> 2] = Math_fround(-Math_fround(f21 * Math_fround(HEAPF32[i28 + (i1 << 2) >> 2])));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i42 | 0));
 }
 HEAPF32[i33 + (i42 * 92 | 0) + (i42 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f13 + f15) * f6) + Math_fround(1.0));
 HEAPF32[i32 + (i42 << 2) >> 2] = Math_fround(f7 + Math_fround(f14 * f6));
 HEAP32[i31 + 2116 >> 2] = i30;
 i20 = (i30 | 0) == 0;
 if (i20) {
  HEAP32[i5 >> 2] = 3;
  i34 = 20;
 } else {
  i3 = i42 >>> 0 > 2;
  i4 = 0;
  do {
   f6 = Math_fround(HEAPF32[i33 + (i4 * 92 | 0) >> 2]);
   f2 = Math_fround(HEAPF32[i33 + (i4 * 92 | 0) + 4 >> 2]);
   if (i3) {
    i1 = 2;
    do {
     f21 = Math_fround(f17 * Math_fround(HEAPF32[i33 + (i4 * 92 | 0) + (i1 << 2) >> 2]));
     f6 = Math_fround(f6 + Math_fround(f21 * Math_fround(HEAPF32[i29 + (i1 << 2) >> 2])));
     i28 = i1 | 1;
     f21 = Math_fround(f16 * Math_fround(HEAPF32[i33 + (i4 * 92 | 0) + (i28 << 2) >> 2]));
     f2 = Math_fround(f2 + Math_fround(f21 * Math_fround(HEAPF32[i29 + (i28 << 2) >> 2])));
     i1 = i1 + 2 | 0;
    } while (i1 >>> 0 < i42 >>> 0);
   }
   HEAPF32[i31 + (i4 * 92 | 0) >> 2] = f6;
   HEAPF32[i31 + (i4 * 92 | 0) + 4 >> 2] = f2;
   HEAP32[i31 + (i4 * 92 | 0) + 8 >> 2] = HEAP32[i33 + (i4 * 92 | 0) + (i42 << 2) >> 2];
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i30 | 0));
  HEAP32[i5 >> 2] = 3;
  if (i20) i34 = 20; else {
   i1 = 0;
   f2 = Math_fround(0.0);
   do {
    f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2]);
    f2 = Math_fround(f2 + Math_fround(f21 * f21));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i30 | 0));
   HEAPF32[i33 >> 2] = f2;
   if (i20) i34 = 53; else {
    i1 = 0;
    f6 = Math_fround(0.0);
    do {
     f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2]);
     f6 = Math_fround(f6 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2])));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i30 | 0));
    HEAPF32[i33 + 4 >> 2] = f6;
    if (i20) i34 = 56; else {
     i1 = 0;
     f7 = Math_fround(0.0);
     do {
      f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2]);
      f7 = Math_fround(f7 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2])));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i30 | 0));
     HEAPF32[i33 + 8 >> 2] = f7;
     if (i20) i34 = 59; else {
      i1 = 0;
      f8 = Math_fround(0.0);
      do {
       f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2]);
       f8 = Math_fround(f8 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2])));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i30 | 0));
      HEAPF32[i33 + 92 >> 2] = f8;
      if (i20) i34 = 62; else {
       i1 = 0;
       f9 = Math_fround(0.0);
       do {
        f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2]);
        f9 = Math_fround(f9 + Math_fround(f21 * f21));
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i30 | 0));
       HEAPF32[i33 + 96 >> 2] = f9;
       if (i20) i34 = 65; else {
        i1 = 0;
        f10 = Math_fround(0.0);
        do {
         f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2]);
         f10 = Math_fround(f10 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2])));
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != (i30 | 0));
        HEAPF32[i33 + 100 >> 2] = f10;
        if (i20) i34 = 68; else {
         i1 = 0;
         f11 = Math_fround(0.0);
         do {
          f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2]);
          f11 = Math_fround(f11 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2])));
          i1 = i1 + 1 | 0;
         } while ((i1 | 0) != (i30 | 0));
         HEAPF32[i33 + 184 >> 2] = f11;
         if (i20) i34 = 71; else {
          i1 = 0;
          f12 = Math_fround(0.0);
          do {
           f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2]);
           f12 = Math_fround(f12 + Math_fround(f21 * Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2])));
           i1 = i1 + 1 | 0;
          } while ((i1 | 0) != (i30 | 0));
          HEAPF32[i33 + 188 >> 2] = f12;
          if (i20) i34 = 74; else {
           i1 = 0;
           f13 = Math_fround(0.0);
           do {
            f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2]);
            f13 = Math_fround(f13 + Math_fround(f21 * f21));
            i1 = i1 + 1 | 0;
           } while ((i1 | 0) != (i30 | 0));
           f16 = f13;
           HEAPF32[i33 + 192 >> 2] = f16;
           if (i20) {
            f21 = f16;
            f13 = Math_fround(0.0);
            f19 = Math_fround(0.0);
            f18 = Math_fround(0.0);
           } else {
            i1 = 0;
            f13 = Math_fround(0.0);
            do {
             f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) >> 2]);
             f13 = Math_fround(f13 + Math_fround(f21 * Math_fround(HEAPF32[i32 + (i1 << 2) >> 2])));
             i1 = i1 + 1 | 0;
            } while ((i1 | 0) != (i30 | 0));
            if (i20) {
             f21 = f16;
             f19 = Math_fround(0.0);
             f18 = Math_fround(0.0);
            } else {
             i1 = 0;
             f14 = Math_fround(0.0);
             do {
              f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 4 >> 2]);
              f14 = Math_fround(f14 + Math_fround(f21 * Math_fround(HEAPF32[i32 + (i1 << 2) >> 2])));
              i1 = i1 + 1 | 0;
             } while ((i1 | 0) != (i30 | 0));
             if (i20) {
              f21 = f16;
              f19 = f14;
              f18 = Math_fround(0.0);
             } else {
              i1 = 0;
              f15 = Math_fround(0.0);
              do {
               f21 = Math_fround(HEAPF32[i31 + (i1 * 92 | 0) + 8 >> 2]);
               f15 = Math_fround(f15 + Math_fround(f21 * Math_fround(HEAPF32[i32 + (i1 << 2) >> 2])));
               i1 = i1 + 1 | 0;
              } while ((i1 | 0) != (i30 | 0));
              f21 = f16;
              f19 = f14;
              f18 = f15;
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
 if ((i34 | 0) == 20) {
  HEAPF32[i33 >> 2] = Math_fround(0.0);
  f2 = Math_fround(0.0);
  i34 = 53;
 }
 if ((i34 | 0) == 53) {
  HEAPF32[i33 + 4 >> 2] = Math_fround(0.0);
  f6 = Math_fround(0.0);
  i34 = 56;
 }
 if ((i34 | 0) == 56) {
  HEAPF32[i33 + 8 >> 2] = Math_fround(0.0);
  f7 = Math_fround(0.0);
  i34 = 59;
 }
 if ((i34 | 0) == 59) {
  HEAPF32[i33 + 92 >> 2] = Math_fround(0.0);
  f8 = Math_fround(0.0);
  i34 = 62;
 }
 if ((i34 | 0) == 62) {
  HEAPF32[i33 + 96 >> 2] = Math_fround(0.0);
  f9 = Math_fround(0.0);
  i34 = 65;
 }
 if ((i34 | 0) == 65) {
  HEAPF32[i33 + 100 >> 2] = Math_fround(0.0);
  f10 = Math_fround(0.0);
  i34 = 68;
 }
 if ((i34 | 0) == 68) {
  HEAPF32[i33 + 184 >> 2] = Math_fround(0.0);
  f11 = Math_fround(0.0);
  i34 = 71;
 }
 if ((i34 | 0) == 71) {
  HEAPF32[i33 + 188 >> 2] = Math_fround(0.0);
  f12 = Math_fround(0.0);
  i34 = 74;
 }
 if ((i34 | 0) == 74) {
  HEAPF32[i33 + 192 >> 2] = Math_fround(0.0);
  f21 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f18 = Math_fround(0.0);
 }
 f15 = Math_fround(Math_fround(f9 * f21) - Math_fround(f10 * f12));
 f16 = Math_fround(Math_fround(f8 * f21) - Math_fround(f10 * f11));
 f17 = Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f11));
 f14 = Math_fround(Math_fround(f7 * f17) + Math_fround(Math_fround(f2 * f15) - Math_fround(f6 * f16)));
 if (f14 == Math_fround(0.0)) {
  STACKTOP = i47;
  return;
 }
 f48 = Math_fround(Math_fround(1.0) / f14);
 f14 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(Math_fround(Math_fround(f6 * f21) - Math_fround(f7 * f12)) * f19)) + Math_fround(Math_fround(Math_fround(f6 * f10) - Math_fround(f7 * f9)) * f18)));
 f7 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f21) - Math_fround(f7 * f11)) * f19) - Math_fround(f16 * f13)) - Math_fround(Math_fround(Math_fround(f2 * f10) - Math_fround(f7 * f8)) * f18)));
 f6 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f17 * f13) - Math_fround(Math_fround(Math_fround(f2 * f12) - Math_fround(f6 * f11)) * f19)) + Math_fround(Math_fround(Math_fround(f2 * f9) - Math_fround(f6 * f8)) * f18)));
 f21 = Math_fround(HEAPF32[i36 + 88 >> 2]);
 i36 = f6 < Math_fround(0.0);
 f6 = i36 ? Math_fround(0.0) : f6;
 f6 = f6 > f21 ? f21 : f6;
 HEAPF32[i46 >> 2] = f14;
 HEAPF32[i46 + 4 >> 2] = f7;
 if (i42 >>> 0 > 2) {
  i1 = 2;
  do {
   HEAPF32[i46 + (i1 << 2) >> 2] = f14;
   HEAPF32[i46 + ((i1 | 1) << 2) >> 2] = f7;
   i1 = i1 + 2 | 0;
  } while (i1 >>> 0 < i42 >>> 0);
 }
 if (!i35) {
  i3 = 0;
  do {
   i1 = i46 + (i3 << 2) | 0;
   if (HEAP8[i38 + i3 >> 0] | 0) {
    f48 = Math_fround(HEAPF32[i1 >> 2]);
    if (Math_fround(f48 * Math_fround(HEAPF32[i39 + (i3 << 2) >> 2])) <= Math_fround(0.0)) HEAPF32[i1 >> 2] = Math_fround(0.0);
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i42 | 0));
 }
 if (!i37) {
  i4 = 0;
  do {
   i3 = i4 << 2;
   if (!(HEAP8[i45 + i3 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i46 + (i3 << 2) >> 2]);
   HEAPF32[i44 + (i4 * 224 | 0) >> 2] = f2;
   i1 = i3 | 1;
   if (!(HEAP8[i45 + i1 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i46 + (i1 << 2) >> 2]);
   HEAPF32[i44 + (i4 * 224 | 0) + 4 >> 2] = f2;
   i1 = i3 | 2;
   if (!(HEAP8[i45 + i1 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i46 + (i1 << 2) >> 2]);
   HEAPF32[i44 + (i4 * 224 | 0) + 8 >> 2] = f2;
   i1 = i3 | 3;
   if (!(HEAP8[i45 + i1 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i46 + (i1 << 2) >> 2]);
   HEAPF32[i44 + (i4 * 224 | 0) + 12 >> 2] = f2;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i43 | 0));
 }
 if (!i40) {
  i5 = i43 << 2;
  i3 = i42 + 4 - (i41 << 2) | 0;
  i4 = 0;
  do {
   i1 = i4 + i5 | 0;
   if (!(HEAP8[i45 + i1 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i46 + (i1 << 2) >> 2]);
   HEAPF32[i44 + (i43 * 224 | 0) + (i4 << 2) >> 2] = f2;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAPF32[i22 >> 2] = f6;
 STACKTOP = i47;
 return;
}

function __ZN5physx2Gu20pcmContactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i17, i12, i13, i15, i1, i42) {
 i2 = i2 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i42 = i42 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i16 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 3680 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i46 + 3472 | 0;
 i44 = i46 + 3456 | 0;
 i20 = i46 + 3376 | 0;
 i45 = i46 + 3344 | 0;
 i43 = i46 + 48 | 0;
 i9 = i46 + 3392 | 0;
 i21 = i46 + 32 | 0;
 i10 = i46 + 16 | 0;
 i11 = i46;
 i41 = i46 + 80 | 0;
 i38 = i46 + 3568 | 0;
 i36 = i46 + 3556 | 0;
 i37 = i46 + 3544 | 0;
 i35 = i46 + 3640 | 0;
 i39 = i46 + 3580 | 0;
 i40 = HEAP32[i1 >> 2] & -16;
 i33 = HEAP32[i12 >> 2] | 0;
 i16 = HEAP32[i12 + 4 >> 2] | 0;
 i6 = HEAP32[i12 + 8 >> 2] | 0;
 i5 = HEAP32[i12 + 12 >> 2] | 0;
 i7 = i12 + 16 | 0;
 i56 = HEAP32[i7 >> 2] | 0;
 i55 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i60 = HEAP32[i13 >> 2] | 0;
 i59 = HEAP32[i13 + 4 >> 2] | 0;
 i58 = HEAP32[i13 + 8 >> 2] | 0;
 i57 = HEAP32[i13 + 12 >> 2] | 0;
 i8 = i13 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i32 = HEAP32[i8 + 8 >> 2] | 0;
 i14 = i2 + 4 | 0;
 HEAP32[i44 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i45 >> 2] = i33;
 HEAP32[i45 + 4 >> 2] = i16;
 HEAP32[i45 + 8 >> 2] = i6;
 HEAP32[i45 + 12 >> 2] = i5;
 HEAP32[i45 + 16 >> 2] = i56;
 HEAP32[i45 + 20 >> 2] = i55;
 HEAP32[i45 + 24 >> 2] = i1;
 HEAPF32[i45 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i43 >> 2] = i60;
 HEAP32[i43 + 4 >> 2] = i59;
 HEAP32[i43 + 8 >> 2] = i58;
 HEAP32[i43 + 12 >> 2] = i57;
 HEAP32[i43 + 16 >> 2] = i3;
 HEAP32[i43 + 20 >> 2] = i4;
 HEAP32[i43 + 24 >> 2] = i32;
 HEAPF32[i43 + 28 >> 2] = Math_fround(0.0);
 f47 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = Math_fround(-f47);
 f52 = Math_fround(-f52);
 f27 = Math_fround(-f27);
 f30 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = Math_fround(f30 - f51);
 f54 = Math_fround(f31 - f54);
 f22 = Math_fround(f22 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f31 = Math_fround(Math_fround(f48 * f48) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f51 * f47) + Math_fround(f54 * f52)) + Math_fround(f22 * f27));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f47) + Math_fround(Math_fround(f31 * f51) + Math_fround(f48 * Math_fround(Math_fround(f22 * f52) - Math_fround(f54 * f27))))) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(Math_fround(f30 * f52) + Math_fround(Math_fround(f31 * f54) + Math_fround(f48 * Math_fround(Math_fround(f51 * f27) - Math_fround(f22 * f47))))) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f22) + Math_fround(f48 * Math_fround(Math_fround(f54 * f47) - Math_fround(f51 * f52)))) + Math_fround(f30 * f27)) * Math_fround(2.0));
 f51 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(Math_fround(f48 * f31) - Math_fround(Math_fround(Math_fround(f51 * f47) + Math_fround(f54 * f52)) + Math_fround(f22 * f27)));
 f25 = Math_fround(Math_fround(Math_fround(f22 * f52) - Math_fround(f54 * f27)) + Math_fround(Math_fround(f48 * f51) + Math_fround(f31 * f47)));
 f26 = Math_fround(Math_fround(Math_fround(f51 * f27) - Math_fround(f22 * f47)) + Math_fround(Math_fround(f48 * f54) + Math_fround(f31 * f52)));
 f27 = Math_fround(Math_fround(Math_fround(f54 * f47) - Math_fround(f51 * f52)) + Math_fround(Math_fround(f48 * f22) + Math_fround(f31 * f27)));
 HEAPF32[i9 + 48 >> 2] = f28;
 HEAPF32[i9 + 52 >> 2] = f29;
 HEAPF32[i9 + 56 >> 2] = f30;
 HEAPF32[i9 + 60 >> 2] = Math_fround(0.0);
 f31 = Math_fround(f25 + f25);
 f22 = Math_fround(f26 + f26);
 f48 = Math_fround(f27 + f27);
 f52 = Math_fround(f26 * f22);
 f51 = Math_fround(f27 * f48);
 f47 = Math_fround(f26 * f31);
 f54 = Math_fround(f27 * f31);
 f23 = Math_fround(f24 * f31);
 f53 = Math_fround(f27 * f22);
 f22 = Math_fround(f24 * f22);
 f48 = Math_fround(f24 * f48);
 f31 = Math_fround(Math_fround(1.0) - Math_fround(f25 * f31));
 f50 = Math_fround(f47 + f48);
 f49 = Math_fround(f54 - f22);
 f48 = Math_fround(f47 - f48);
 f47 = Math_fround(f31 - f51);
 f18 = Math_fround(f53 + f23);
 f22 = Math_fround(f54 + f22);
 f23 = Math_fround(f53 - f23);
 f31 = Math_fround(f31 - f52);
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f52) - f51);
 HEAPF32[i9 + 4 >> 2] = f50;
 HEAPF32[i9 + 8 >> 2] = f49;
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 16 >> 2] = f48;
 HEAPF32[i9 + 20 >> 2] = f47;
 HEAPF32[i9 + 24 >> 2] = f18;
 HEAPF32[i9 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 32 >> 2] = f22;
 HEAPF32[i9 + 36 >> 2] = f23;
 HEAPF32[i9 + 40 >> 2] = f31;
 HEAPF32[i9 + 44 >> 2] = Math_fround(0.0);
 f31 = Math_fround(HEAPF32[i44 >> 2]);
 HEAPF32[i21 >> 2] = Math_fround(f31 * Math_fround(.00100000005));
 HEAPF32[i10 >> 2] = Math_fround(f31 * Math_fround(.0500000007));
 i5 = i40 + 53 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 HEAPF32[i11 >> 2] = Math_fround(f31 + Math_fround(HEAPF32[i20 >> 2]));
 i16 = i40 + 52 | 0;
 i33 = HEAP8[i16 >> 0] | 0;
 if (i33 << 24 >> 24) {
  i1 = 0;
  do {
   i2 = i40 + 48 + i1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = i3 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i34, i40 + 64 + (i4 * 400 | 0) | 0, i9, i10, i11);
   if (!(HEAP32[i40 + 64 + (i4 * 400 | 0) + 384 >> 2] | 0)) {
    i59 = (HEAP8[i16 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i16 >> 0] = i59;
    i59 = (i59 & 255) + (i40 + 48) | 0;
    i60 = HEAP8[i59 >> 0] | 0;
    HEAP8[i59 >> 0] = i3;
    HEAP8[i2 >> 0] = i60;
    i1 = i1 + -1 | 0;
   } else HEAP32[i40 + 32 + (i4 << 2) >> 2] = HEAP32[i34 >> 2];
   i1 = i1 + 1 | 0;
   i60 = HEAPU8[i16 >> 0] | 0;
  } while (i1 >>> 0 < i60 >>> 0);
 }
 if ((HEAP8[i5 >> 0] | 0) == i6 << 24 >> 24) {
  f51 = Math_fround(Math_fround(HEAPF32[i44 >> 2]) * Math_fround(.0199999996));
  f48 = Math_fround(HEAPF32[i40 + 16 >> 2]);
  f54 = Math_fround(HEAPF32[i40 + 20 >> 2]);
  f48 = Math_fround(f28 - f48);
  f54 = Math_fround(f29 - f54);
  f53 = Math_fround(f30 - Math_fround(HEAPF32[i40 + 24 >> 2]));
  f50 = Math_fround(-f48);
  f49 = Math_fround(-f54);
  f52 = Math_fround(-f53);
  f50 = f48 > f50 ? f48 : f50;
  f49 = f54 > f49 ? f54 : f49;
  f49 = f50 >= f49 ? f50 : f49;
  i60 = (f53 > f52 ? f53 : f52) >= Math_fround(0.0);
  f50 = i60 ? f50 : Math_fround(0.0);
  f52 = Math_fround(HEAPF32[i40 >> 2]);
  f53 = Math_fround(HEAPF32[i40 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i40 + 8 >> 2]);
  if (!((f49 >= f50 ? f49 : f50) > f51 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f25 * f52) + Math_fround(f26 * f53)) + Math_fround(f27 * f54)) + Math_fround(f24 * Math_fround(HEAPF32[i40 + 12 >> 2]))) < Math_fround(.999800026))) {
   i60 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i40, i42, i45, i43, i44) | 0;
   STACKTOP = i46;
   return i60 | 0;
  }
 }
 f53 = Math_fround(HEAPF32[i7 >> 2]);
 f53 = Math_fround(f53 - Math_fround(HEAPF32[i8 >> 2]));
 f51 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f51 = Math_fround(f51 - Math_fround(HEAPF32[i13 + 20 >> 2]));
 f48 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f53 = Math_fround(f53 * Math_fround(2.0));
 f51 = Math_fround(f51 * Math_fround(2.0));
 f48 = Math_fround(Math_fround(f48 - Math_fround(HEAPF32[i13 + 24 >> 2])) * Math_fround(2.0));
 f50 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f49 = Math_fround(Math_fround(f50 * f50) + Math_fround(-.5));
 f52 = Math_fround(HEAPF32[i13 >> 2]);
 f23 = Math_fround(f53 * f52);
 f54 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f51 * f54));
 f18 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f48 * f18));
 f31 = Math_fround(Math_fround(f52 * f23) + Math_fround(Math_fround(f53 * f49) - Math_fround(f50 * Math_fround(Math_fround(f48 * f54) - Math_fround(f51 * f18)))));
 f22 = Math_fround(Math_fround(f54 * f23) + Math_fround(Math_fround(f51 * f49) - Math_fround(f50 * Math_fround(Math_fround(f53 * f18) - Math_fround(f48 * f52)))));
 f23 = Math_fround(Math_fround(Math_fround(f48 * f49) - Math_fround(f50 * Math_fround(Math_fround(f51 * f52) - Math_fround(f53 * f54)))) + Math_fround(f18 * f23));
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i15 >> 2]));
 HEAP32[i34 >> 2] = 1065353216;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 HEAP32[i34 + 16 >> 2] = 1065353216;
 HEAP32[i34 + 20 >> 2] = 0;
 HEAP32[i34 + 24 >> 2] = 0;
 HEAP32[i34 + 28 >> 2] = 0;
 HEAP32[i34 + 32 >> 2] = 1065353216;
 HEAP32[i34 + 36 >> 2] = 1065353216;
 HEAP32[i34 + 40 >> 2] = 0;
 HEAP32[i34 + 44 >> 2] = 0;
 HEAP32[i34 + 48 >> 2] = 0;
 HEAP32[i34 + 52 >> 2] = 1065353216;
 HEAP32[i34 + 56 >> 2] = 0;
 HEAP32[i34 + 60 >> 2] = 0;
 HEAP32[i34 + 64 >> 2] = 0;
 HEAP32[i34 + 68 >> 2] = 1065353216;
 i1 = i17 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i17 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i17 + 12 >> 2]) == Math_fround(1.0)) i7 = 1; else i19 = 12; else i19 = 12; else i19 = 12;
 if ((i19 | 0) == 12) {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i34, i1, i17 + 16 | 0);
  i7 = 0;
 }
 i15 = HEAP32[i17 + 40 >> 2] | 0;
 HEAP8[i16 >> 0] = 0;
 HEAPF32[i40 >> 2] = f25;
 HEAPF32[i40 + 4 >> 2] = f26;
 HEAPF32[i40 + 8 >> 2] = f27;
 HEAPF32[i40 + 12 >> 2] = f24;
 HEAPF32[i40 + 16 >> 2] = f28;
 HEAPF32[i40 + 20 >> 2] = f29;
 HEAPF32[i40 + 24 >> 2] = f30;
 HEAPF32[i40 + 28 >> 2] = Math_fround(0.0);
 i32 = HEAP32[i15 + 152 >> 2] | 0;
 HEAP32[i41 + 4 >> 2] = 2;
 HEAP32[i41 + 8 >> 2] = i34;
 HEAP32[i41 + 12 >> 2] = i32;
 HEAP8[i41 + 16 >> 0] = i7 & 1;
 i32 = i41 + 868 | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i41 >> 2] = gb + 105516 + 8;
 i33 = i41 + 880 | 0;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i33, i20, i21, i45, i43, i40, i42);
 HEAPF32[i41 + 3216 >> 2] = f31;
 HEAPF32[i41 + 3220 >> 2] = f22;
 HEAPF32[i41 + 3224 >> 2] = f23;
 HEAPF32[i41 + 3228 >> 2] = Math_fround(0.0);
 i17 = i41 + 3232 | 0;
 HEAP32[i17 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 f54 = Math_fround(HEAPF32[i44 >> 2]);
 f54 = Math_fround(f54 + Math_fround(HEAPF32[i20 >> 2]));
 HEAPF32[i41 + 3248 >> 2] = Math_fround(f54 * f54);
 HEAP32[i38 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i38 + 4 >> 2] = i15 + 32;
 HEAP32[i38 + 8 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAPF32[i36 >> 2] = f31;
 i15 = i36 + 4 | 0;
 HEAPF32[i15 >> 2] = f22;
 i17 = i36 + 8 | 0;
 HEAPF32[i17 >> 2] = f23;
 HEAPF32[i37 >> 2] = f18;
 i19 = i37 + 4 | 0;
 HEAPF32[i19 >> 2] = f18;
 i21 = i37 + 8 | 0;
 HEAPF32[i21 >> 2] = f18;
 HEAPF32[i35 >> 2] = Math_fround(1.0);
 i1 = i35 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i2 = i35 + 8 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
 i3 = i35 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i4 = i35 + 20 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i35 + 24 >> 2] = Math_fround(0.0);
 i5 = i35 + 28 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = i35 + 32 | 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 if (i7) {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = 1065353216;
  i14 = 0;
  i12 = 0;
  i13 = 0;
  i11 = 1065353216;
  i10 = 0;
  i9 = 0;
  i8 = 0;
  i7 = 1065353216;
  i6 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = i20;
  i2 = i20;
  i1 = i20;
 } else {
  __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i34, i36, i37, i35);
  i16 = HEAP32[i35 >> 2] | 0;
  i14 = HEAP32[i1 >> 2] | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[i35 + 12 >> 2] | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  i10 = HEAP32[i4 >> 2] | 0;
  i9 = HEAP32[i35 + 24 >> 2] | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i36 >> 2] | 0;
  i5 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i37 >> 2] | 0;
  i2 = HEAP32[i19 >> 2] | 0;
  i1 = HEAP32[i21 >> 2] | 0;
 }
 HEAP32[i39 >> 2] = i16;
 HEAP32[i39 + 4 >> 2] = i14;
 HEAP32[i39 + 8 >> 2] = i12;
 HEAP32[i39 + 12 >> 2] = i13;
 HEAP32[i39 + 16 >> 2] = i11;
 HEAP32[i39 + 20 >> 2] = i10;
 HEAP32[i39 + 24 >> 2] = i9;
 HEAP32[i39 + 28 >> 2] = i8;
 HEAP32[i39 + 32 >> 2] = i7;
 HEAP32[i39 + 36 >> 2] = i6;
 HEAP32[i39 + 40 >> 2] = i5;
 HEAP32[i39 + 44 >> 2] = i4;
 HEAP32[i39 + 48 >> 2] = i3;
 HEAP32[i39 + 52 >> 2] = i2;
 HEAP32[i39 + 56 >> 2] = i1;
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i39, 1, i38, i41, 1);
 i1 = HEAP32[i32 >> 2] | 0;
 if (i1 | 0) {
  i6 = i41 + 880 | 0;
  i3 = i41 + 852 | 0;
  i4 = i41 + 788 | 0;
  i5 = i41 + 596 | 0;
  i2 = i41 + 20 | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i6, i2, HEAP32[i4 >> 2] | 0, HEAP8[i3 >> 0] | 0, i5) | 0;
   if (!i1) break; else {
    i3 = i3 + 1 | 0;
    i4 = i4 + 4 | 0;
    i5 = i5 + 12 | 0;
    i2 = i2 + 36 | 0;
   }
  }
  HEAP32[i32 >> 2] = 0;
 }
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i33, 1, 0);
 i60 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i40, i42, i45, i43, i44) | 0;
 STACKTOP = i46;
 return i60 | 0;
}

function __ZN24EllipsoidParticleEmitter13SetupParticleER8ParticleRK8Vector3fRK10Matrix3x3ff(i33, i34, i2, i35, f1) {
 i33 = i33 | 0;
 i34 = i34 | 0;
 i2 = i2 | 0;
 i35 = i35 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f36 = f0;
 f18 = Math_fround(HEAPF32[i33 + 124 >> 2]);
 f10 = Math_fround(HEAPF32[i33 + 128 >> 2]);
 i4 = HEAP32[gb + 1469384 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 HEAP32[gb + 1469384 >> 2] = HEAP32[gb + 1469384 + 4 >> 2];
 HEAP32[gb + 1469384 + 4 >> 2] = HEAP32[gb + 1469384 + 8 >> 2];
 i26 = HEAP32[gb + 1469384 + 12 >> 2] | 0;
 HEAP32[gb + 1469384 + 8 >> 2] = i26;
 i26 = i4 >>> 8 ^ i4 ^ i26 ^ i26 >>> 19;
 HEAP32[gb + 1469384 + 12 >> 2] = i26;
 f12 = Math_fround(Math_fround((i26 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(f18 * f12) + Math_fround(f10 * Math_fround(Math_fround(1.0) - f12)));
 i26 = f12 < Math_fround(0.0);
 i4 = f12 > Math_fround(100000001999999991808.0);
 f12 = i4 ? Math_fround(100000001999999991808.0) : f12;
 f12 = i26 ? Math_fround(0.0) : f12;
 HEAPF32[i34 + 40 >> 2] = f12;
 HEAPF32[i34 + 36 >> 2] = Math_fround(Math_fround(f12 + f1) + Math_fround(.00100000005));
 i26 = i33 + 44 | 0;
 HEAP32[i34 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 i4 = HEAP32[gb + 1469384 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 i6 = HEAP32[gb + 1469384 + 4 >> 2] | 0;
 i20 = HEAP32[gb + 1469384 + 8 >> 2] | 0;
 i24 = HEAP32[gb + 1469384 + 12 >> 2] | 0;
 i4 = i4 >>> 8 ^ i4 ^ i24;
 i25 = i4 ^ i24 >>> 19;
 f12 = Math_fround(Math_fround((i25 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(f12 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f12) * f1));
 f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f12);
 f18 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f12);
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f12);
 f10 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) + f10);
 HEAPF32[i34 >> 2] = f10;
 i3 = i34 + 4 | 0;
 f18 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f18);
 HEAPF32[i3 >> 2] = f18;
 i32 = i34 + 8 | 0;
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i32 >> 2]));
 HEAPF32[i32 >> 2] = f12;
 f23 = Math_fround(HEAPF32[i33 + 32 >> 2]);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i26 >> 2]));
 f17 = Math_fround(HEAPF32[i33 + 36 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i33 + 48 >> 2]));
 f19 = Math_fround(HEAPF32[i33 + 40 >> 2]);
 i6 = i6 << 11 ^ i6;
 i6 = i6 >>> 8 ^ i6 ^ i25;
 i4 = i6 ^ i4 >>> 19;
 f16 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f17 = Math_fround(f17 * f16);
 f19 = Math_fround(Math_fround(f19 - Math_fround(HEAPF32[i33 + 52 >> 2])) * f16);
 HEAPF32[i34 >> 2] = Math_fround(f10 + Math_fround(f23 * f16));
 HEAPF32[i3 >> 2] = Math_fround(f18 + f17);
 HEAPF32[i32 >> 2] = Math_fround(f19 + f12);
 f12 = Math_fround(HEAPF32[i33 + 232 >> 2]);
 i20 = i20 << 11 ^ i20;
 i20 = i20 >>> 8 ^ i20 ^ i4;
 i6 = i20 ^ i6 >>> 19;
 f19 = Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f19 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f19);
 i24 = i24 << 11 ^ i24;
 i24 = i24 >>> 8 ^ i24 ^ i6;
 i20 = i24 ^ i20 >>> 19;
 f17 = Math_fround(Math_fround((i20 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f17 = Math_fround(Math_fround(f17 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f17) * Math_fround(6.28318548)));
 f18 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f19 * f19))));
 f16 = Math_fround(f18 * Math_fround(+Math_cos(+f17)));
 f17 = Math_fround(f18 * Math_fround(+Math_sin(+f17)));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i33 + 220 >> 2]));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i33 + 224 >> 2]));
 f19 = Math_fround(Math_fround(HEAPF32[i33 + 228 >> 2]) * f19);
 i25 = i25 << 11 ^ i25;
 HEAP32[gb + 1469384 >> 2] = i4;
 HEAP32[gb + 1469384 + 4 >> 2] = i6;
 HEAP32[gb + 1469384 + 8 >> 2] = i20;
 i24 = i25 >>> 8 ^ i25 ^ i20 ^ i24 >>> 19;
 HEAP32[gb + 1469384 + 12 >> 2] = i24;
 f18 = Math_fround(Math_fround((i24 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f18 = Math_fround(+Math_pow(+Math_fround(Math_fround(f12 * f18) + Math_fround(Math_fround(1.0) - f18)), .333333343));
 f16 = Math_fround(f16 * f18);
 f17 = Math_fround(f17 * f18);
 f18 = Math_fround(f19 * f18);
 f19 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f16);
 i24 = i35 + 12 | 0;
 f19 = Math_fround(f19 + Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2])));
 i25 = i35 + 24 | 0;
 f19 = Math_fround(f19 + Math_fround(f18 * Math_fround(HEAPF32[i25 >> 2])));
 i26 = i35 + 4 | 0;
 f12 = Math_fround(f16 * Math_fround(HEAPF32[i26 >> 2]));
 i27 = i35 + 16 | 0;
 f12 = Math_fround(f12 + Math_fround(f17 * Math_fround(HEAPF32[i27 >> 2])));
 i28 = i35 + 28 | 0;
 f12 = Math_fround(f12 + Math_fround(f18 * Math_fround(HEAPF32[i28 >> 2])));
 i29 = i35 + 8 | 0;
 f23 = Math_fround(f16 * Math_fround(HEAPF32[i29 >> 2]));
 i30 = i35 + 20 | 0;
 f23 = Math_fround(f23 + Math_fround(f17 * Math_fround(HEAPF32[i30 >> 2])));
 i31 = i35 + 32 | 0;
 f23 = Math_fround(f23 + Math_fround(f18 * Math_fround(HEAPF32[i31 >> 2])));
 HEAPF32[i34 >> 2] = Math_fround(f19 + Math_fround(HEAPF32[i34 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i32 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i32 >> 2]));
 i32 = i34 + 12 | 0;
 HEAP32[i32 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i4 = i4 << 11 ^ i4;
 i3 = HEAP32[gb + 1469384 + 12 >> 2] | 0;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i3 >>> 19;
 f23 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f23 = Math_fround(Math_fround(Math_fround(1.0) - f23) - f23);
 i6 = i6 << 11 ^ i6;
 i6 = i6 >>> 8 ^ i6 ^ i5;
 i4 = i6 ^ i4 >>> 19;
 f12 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(f12 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f12) * Math_fround(6.28318548)));
 f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f23 * f23))));
 f10 = Math_fround(f19 * Math_fround(+Math_cos(+f12)));
 f12 = Math_fround(f19 * Math_fround(+Math_sin(+f12)));
 i2 = i20 << 11 ^ i20;
 HEAP32[gb + 1469384 >> 2] = i3;
 HEAP32[gb + 1469384 + 4 >> 2] = i5;
 HEAP32[gb + 1469384 + 8 >> 2] = i4;
 i2 = i2 >>> 8 ^ i2 ^ i4;
 i6 = i2 ^ i6 >>> 19;
 HEAP32[gb + 1469384 + 12 >> 2] = i6;
 f19 = Math_fround(+Math_pow(+Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07)), .333333343));
 f10 = Math_fround(f10 * f19);
 f12 = Math_fround(f12 * f19);
 f23 = Math_fround(f19 * f23);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i33 + 180 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i33 + 184 >> 2]));
 f23 = Math_fround(f23 * Math_fround(HEAPF32[i33 + 188 >> 2]));
 f19 = Math_fround(f10 * Math_fround(HEAPF32[i35 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2])));
 f19 = Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i25 >> 2])));
 f21 = Math_fround(f10 * Math_fround(HEAPF32[i26 >> 2]));
 f21 = Math_fround(f21 + Math_fround(f12 * Math_fround(HEAPF32[i27 >> 2])));
 f21 = Math_fround(f21 + Math_fround(f23 * Math_fround(HEAPF32[i28 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i29 >> 2]));
 f12 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i30 >> 2])));
 f23 = Math_fround(f12 + Math_fround(f23 * Math_fround(HEAPF32[i31 >> 2])));
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i32 >> 2]));
 HEAPF32[i32 >> 2] = f19;
 i20 = i34 + 16 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i20 >> 2]));
 HEAPF32[i20 >> 2] = f21;
 i22 = i34 + 20 | 0;
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i22 >> 2]));
 HEAPF32[i22 >> 2] = f23;
 if (!(HEAP8[i33 + 193 >> 0] | 0)) {
  f1 = Math_fround(0.0);
  i2 = i6;
 } else {
  i3 = i3 << 11 ^ i3;
  HEAP32[gb + 1469384 >> 2] = i5;
  HEAP32[gb + 1469384 + 4 >> 2] = i4;
  HEAP32[gb + 1469384 + 8 >> 2] = i6;
  i2 = i3 >>> 8 ^ i3 ^ i6 ^ i2 >>> 19;
  HEAP32[gb + 1469384 + 12 >> 2] = i2;
  f1 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f1 = Math_fround(Math_fround(f1 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f1) * Math_fround(6.28318548)));
  i3 = i5;
  i5 = i4;
  i4 = i6;
 }
 HEAPF32[i34 + 28 >> 2] = f1;
 f10 = Math_fround(HEAPF32[i33 + 200 >> 2]);
 f9 = Math_fround(HEAPF32[i33 + 196 >> 2]);
 i15 = i3 << 11 ^ i3;
 HEAP32[gb + 1469384 >> 2] = i5;
 HEAP32[gb + 1469384 + 4 >> 2] = i4;
 HEAP32[gb + 1469384 + 8 >> 2] = i2;
 i15 = i15 >>> 8 ^ i15 ^ i2 ^ i2 >>> 19;
 HEAP32[gb + 1469384 + 12 >> 2] = i15;
 f7 = Math_fround(Math_fround((i15 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 HEAPF32[i34 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 + Math_fround(Math_fround(f9 * Math_fround(Math_fround(1.0) - f7)) - Math_fround(f9 * f7))) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f7 = Math_fround(-f17);
 f9 = Math_fround(f18 * f18);
 f10 = Math_fround(f16 * f16);
 f1 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 + Math_fround(0.0)))));
 f12 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 if (f1 > f12) {
  f8 = Math_fround(-f16);
  f36 = Math_fround(f18 / f1);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(Math_fround(0.0) / f1);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = Math_fround(f8 / f1);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i13 = HEAP32[gb + 1162364 >> 2] | 0;
  i14 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i15 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f8 = Math_fround(f17 * f17);
 f1 = Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f10 + Math_fround(0.0)))));
 if (f1 > f12) {
  f36 = Math_fround(f16 / f1);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(Math_fround(0.0) / f1);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(f7 / f1);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i5 = HEAP32[gb + 1162364 >> 2] | 0;
  i6 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i11 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f10 + f8))));
 if (f1 > f12) {
  f36 = Math_fround(f16 / f1);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(f17 / f1);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(f18 / f1);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i2 = HEAP32[gb + 1162364 >> 2] | 0;
  i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f17 = Math_fround(HEAPF32[i33 + 168 >> 2]);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17);
 f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17);
 f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17);
 f18 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f12);
 f18 = Math_fround(f18 + Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2])));
 f18 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i25 >> 2])));
 f36 = Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2]));
 f36 = Math_fround(f36 + Math_fround(f16 * Math_fround(HEAPF32[i27 >> 2])));
 f36 = Math_fround(f36 + Math_fround(f17 * Math_fround(HEAPF32[i28 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i29 >> 2]));
 f16 = Math_fround(f12 + Math_fround(f16 * Math_fround(HEAPF32[i30 >> 2])));
 f17 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i31 >> 2])));
 f18 = Math_fround(f18 + f19);
 HEAPF32[i32 >> 2] = f18;
 f36 = Math_fround(f36 + f21);
 HEAPF32[i20 >> 2] = f36;
 f21 = Math_fround(f17 + f23);
 HEAPF32[i22 >> 2] = f21;
 f23 = Math_fround(HEAPF32[i33 + 172 >> 2]);
 f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f16 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f19);
 f16 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2])));
 f16 = Math_fround(f16 + Math_fround(f23 * Math_fround(HEAPF32[i25 >> 2])));
 f12 = Math_fround(f19 * Math_fround(HEAPF32[i26 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f17 * Math_fround(HEAPF32[i27 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f23 * Math_fround(HEAPF32[i28 >> 2])));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i29 >> 2]));
 f17 = Math_fround(f19 + Math_fround(f17 * Math_fround(HEAPF32[i30 >> 2])));
 f23 = Math_fround(f17 + Math_fround(f23 * Math_fround(HEAPF32[i31 >> 2])));
 f18 = Math_fround(f16 + f18);
 HEAPF32[i32 >> 2] = f18;
 f36 = Math_fround(f12 + f36);
 HEAPF32[i20 >> 2] = f36;
 f21 = Math_fround(f23 + f21);
 HEAPF32[i22 >> 2] = f21;
 f23 = Math_fround(HEAPF32[i33 + 176 >> 2]);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f17 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f12);
 f17 = Math_fround(f17 + Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2])));
 f17 = Math_fround(f17 + Math_fround(f23 * Math_fround(HEAPF32[i25 >> 2])));
 f19 = Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f16 * Math_fround(HEAPF32[i27 >> 2])));
 f19 = Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i28 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i29 >> 2]));
 f16 = Math_fround(f12 + Math_fround(f16 * Math_fround(HEAPF32[i30 >> 2])));
 f23 = Math_fround(f16 + Math_fround(f23 * Math_fround(HEAPF32[i31 >> 2])));
 HEAPF32[i32 >> 2] = Math_fround(f17 + f18);
 HEAPF32[i20 >> 2] = Math_fround(f19 + f36);
 HEAPF32[i22 >> 2] = Math_fround(f23 + f21);
 HEAP32[i34 + 44 >> 2] = -1;
 f21 = Math_fround(HEAPF32[i33 + 116 >> 2]);
 f23 = Math_fround(HEAPF32[i33 + 120 >> 2]);
 i33 = HEAP32[gb + 1469384 >> 2] | 0;
 i33 = i33 << 11 ^ i33;
 HEAP32[gb + 1469384 >> 2] = HEAP32[gb + 1469384 + 4 >> 2];
 HEAP32[gb + 1469384 + 4 >> 2] = HEAP32[gb + 1469384 + 8 >> 2];
 i35 = HEAP32[gb + 1469384 + 12 >> 2] | 0;
 HEAP32[gb + 1469384 + 8 >> 2] = i35;
 i35 = i33 >>> 8 ^ i33 ^ i35 ^ i35 >>> 19;
 HEAP32[gb + 1469384 + 12 >> 2] = i35;
 f36 = Math_fround(Math_fround((i35 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 HEAPF32[i34 + 24 >> 2] = Math_fround(Math_fround(f21 * f36) + Math_fround(f23 * Math_fround(Math_fround(1.0) - f36)));
 return;
}

function __ZN5physx17PxsFluidCollision15updateSubPacketEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheESA_RNS_21PxsFluidLocalCellHashERNS_9PxBounds3ERKS5_PKjjPKNS_31PxsParticleStreamContactManagerEPKNS_19PxsW2STransformTempEjPKf(i49, i54, i57, i51, i53, i39, i47, i46, i41, i50, i43, i45, i58, i40, i44, i42, i38) {
 i49 = i49 | 0;
 i54 = i54 | 0;
 i57 = i57 | 0;
 i51 = i51 | 0;
 i53 = i53 | 0;
 i39 = i39 | 0;
 i47 = i47 | 0;
 i46 = i46 | 0;
 i41 = i41 | 0;
 i50 = i50 | 0;
 i43 = i43 | 0;
 i45 = i45 | 0;
 i58 = i58 | 0;
 i40 = i40 | 0;
 i44 = i44 | 0;
 i42 = i42 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i48 = 0, i52 = 0, i55 = 0, i56 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i59 + 24 | 0;
 i34 = i59 + 12 | 0;
 i35 = i59;
 i55 = i59 + 36 | 0;
 i56 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i59 + 37 | 0, i58 * 176 | 0, gb + 769468 | 0, 392) | 0;
 i52 = (i58 | 0) == 0;
 if (!i52) {
  i29 = i39 + 4 | 0;
  i30 = i37 + 4 | 0;
  i31 = i37 + 8 | 0;
  i32 = i49 + 4 | 0;
  i33 = i49 + 8 | 0;
  i14 = i49 + 88 | 0;
  i15 = i49 + 56 | 0;
  i17 = i49 + 12 | 0;
  i18 = i49 + 64 | 0;
  i19 = i34 + 4 | 0;
  i20 = i34 + 8 | 0;
  i21 = i35 + 4 | 0;
  i22 = i35 + 8 | 0;
  i23 = i39 + 12 | 0;
  i24 = (i57 | 0) == 0;
  i25 = i39 + 8 | 0;
  i36 = 0;
  do {
   i26 = HEAP32[i45 + (i36 << 2) >> 2] | 0;
   i27 = i54 + (i36 << 5) | 0;
   i28 = i56 + (i36 * 176 | 0) | 0;
   HEAP32[i56 + (i36 * 176 | 0) + 140 >> 2] = (HEAP32[i39 >> 2] | 0) + (i26 << 4);
   HEAP32[i56 + (i36 * 176 | 0) + 156 >> 2] = (HEAP32[i29 >> 2] | 0) + (i26 << 4);
   i62 = HEAP32[i54 + (i36 << 5) + 16 >> 2] | 0;
   HEAP32[i37 >> 2] = i62;
   i7 = i54 + (i36 << 5) + 20 | 0;
   i61 = HEAP32[i7 >> 2] | 0;
   HEAP32[i30 >> 2] = i61;
   i10 = i54 + (i36 << 5) + 24 | 0;
   i60 = HEAP32[i10 >> 2] | 0;
   HEAP32[i31 >> 2] = i60;
   i1 = HEAP32[i49 >> 2] | 0;
   i2 = HEAP32[i32 >> 2] | 0;
   i4 = HEAP32[i33 >> 2] | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (HEAP32[i14 >> 2] & 65536) {
    f16 = Math_fround(HEAPF32[i51 + (i26 * 12 | 0) >> 2]);
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f16);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    f16 = Math_fround(HEAPF32[i51 + (i26 * 12 | 0) + 4 >> 2]);
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f16);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    f16 = Math_fround(HEAPF32[i51 + (i26 * 12 | 0) + 8 >> 2]);
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f16);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f9 = Math_fround(HEAPF32[i15 >> 2]);
   f16 = Math_fround(HEAPF32[i17 >> 2]);
   f8 = Math_fround(HEAPF32[i18 >> 2]);
   f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
   f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
   i1 = i54 + (i36 << 5) + 16 | 0;
   f5 = Math_fround(f12 + f5);
   f6 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8) + f6);
   f3 = Math_fround(f16 * Math_fround(f13 + f3));
   HEAPF32[i1 >> 2] = f3;
   f5 = Math_fround(f16 * f5);
   HEAPF32[i7 >> 2] = f5;
   f6 = Math_fround(f16 * f6);
   HEAPF32[i10 >> 2] = f6;
   f8 = Math_fround(f8 * Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5))))));
   if (f8 > f9) {
    f16 = Math_fround(f9 / f8);
    HEAPF32[i1 >> 2] = Math_fround(f3 * f16);
    HEAPF32[i7 >> 2] = Math_fround(f5 * f16);
    HEAPF32[i10 >> 2] = Math_fround(f6 * f16);
   }
   HEAPF32[i34 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   HEAPF32[i21 >> 2] = Math_fround(0.0);
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   i2 = HEAP16[i54 + (i36 << 5) + 30 >> 1] | 0;
   if (!(i2 & 4)) i4 = 0; else {
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i34 >> 2] = HEAP32[i1 + (i26 << 4) >> 2];
    HEAP32[i19 >> 2] = HEAP32[i1 + (i26 << 4) + 4 >> 2];
    HEAP32[i20 >> 2] = HEAP32[i1 + (i26 << 4) + 8 >> 2];
    if (i24) i4 = 0; else i4 = HEAP32[i1 + (i26 << 4) + 12 >> 2] | 0;
   }
   if (!(i2 & 8)) i1 = 0; else {
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i35 >> 2] = HEAP32[i1 + (i26 << 4) >> 2];
    HEAP32[i21 >> 2] = HEAP32[i1 + (i26 << 4) + 4 >> 2];
    HEAP32[i22 >> 2] = HEAP32[i1 + (i26 << 4) + 8 >> 2];
    if (i24) i1 = 0; else i1 = HEAP32[i1 + (i26 << 4) + 12 >> 2] | 0;
   }
   __ZN5physx31initCollDataAndApplyConstraintsERNS_19PxsParticleCollDataERKNS_16PxsFluidParticleERKNS_6PxVec3EfS7_S7_PKNS_11PxsBodyCoreESA_jRKNS_27PxsFluidCollisionParametersE(i28, i27, i37, Math_fround(HEAPF32[i38 + (i36 << 2) >> 2]), i34, i35, i4, i1, i26, i49);
   i62 = i56 + (i36 * 176 | 0) + 62 | 0;
   HEAP16[i62 >> 1] = HEAPU16[i62 >> 1] & 65520;
   i36 = i36 + 1 | 0;
  } while ((i36 | 0) != (i58 | 0));
 }
 i14 = (i42 | 0) == 0;
 L20 : do if (i14) {
  i17 = i49 + 56 | 0;
  f16 = Math_fround(HEAPF32[i17 >> 2]);
  i18 = i49;
  f16 = Math_fround(f16 * f16);
  i48 = 43;
 } else {
  i2 = 0;
  i1 = 0;
  do {
   if (HEAP8[i40 + (i2 << 4) + 13 >> 0] | 0) {
    __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE(i49, i54, i58, i56, i39, i47, i41, i43, i40 + (i2 << 4) | 0, i44 + (i2 * 56 | 0) | 0);
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i42 | 0));
  i17 = i49 + 56 | 0;
  f16 = Math_fround(HEAPF32[i17 >> 2]);
  f16 = Math_fround(f16 * f16);
  if (i1 | 0) {
   i1 = (HEAP32[i49 + 88 >> 2] & 1 | 0) != 0;
   if (!i52) {
    i10 = 0;
    do {
     __ZN5physx17collisionResponseERNS_19PxsParticleCollDataEbbRNS_27PxsFluidCollisionParametersE(i56 + (i10 * 176 | 0) | 0, i1, 0, i49);
     f3 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = i56 + (i10 * 176 | 0) + 64 | 0;
     f6 = Math_fround(HEAPF32[i2 >> 2]);
     f5 = Math_fround(HEAPF32[i56 + (i10 * 176 | 0) + 48 >> 2]);
     f6 = Math_fround(f6 - f5);
     i4 = i56 + (i10 * 176 | 0) + 68 | 0;
     f9 = Math_fround(HEAPF32[i4 >> 2]);
     f8 = Math_fround(HEAPF32[i56 + (i10 * 176 | 0) + 52 >> 2]);
     f9 = Math_fround(f9 - f8);
     i7 = i56 + (i10 * 176 | 0) + 72 | 0;
     f12 = Math_fround(HEAPF32[i7 >> 2]);
     f11 = Math_fround(HEAPF32[i56 + (i10 * 176 | 0) + 56 >> 2]);
     f12 = Math_fround(f12 - f11);
     f13 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)) + Math_fround(f12 * f12));
     if (f13 > f16) {
      f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f13))));
      f9 = Math_fround(f8 + Math_fround(Math_fround(f3 * f9) * f63));
      f13 = Math_fround(f11 + Math_fround(Math_fround(f3 * f12) * f63));
      HEAPF32[i2 >> 2] = Math_fround(f5 + Math_fround(Math_fround(f3 * f6) * f63));
      HEAPF32[i4 >> 2] = f9;
      HEAPF32[i7 >> 2] = f13;
     }
     i62 = i56 + (i10 * 176 | 0) + 12 | 0;
     HEAP32[i62 >> 2] = HEAP32[i62 >> 2] & -8 | 4;
     HEAP32[i56 + (i10 * 176 | 0) + 16 >> 2] = 0;
     HEAP32[i56 + (i10 * 176 | 0) + 20 >> 2] = 0;
     HEAP32[i56 + (i10 * 176 | 0) + 24 >> 2] = 0;
     HEAPF32[i56 + (i10 * 176 | 0) + 44 >> 2] = Math_fround(1.0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i58 | 0));
   }
  }
  if (i14) {
   i18 = i49;
   i48 = 43;
  } else {
   if (!i47) {
    i1 = 0;
    while (1) {
     if (!(HEAP8[i40 + (i1 << 4) + 13 >> 0] | 0)) __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE(i49, i54, i58, i56, i39, 0, i41, i43, i40 + (i1 << 4) | 0, i44 + (i1 * 56 | 0) | 0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i42 | 0)) {
      i18 = i49;
      i48 = 43;
      break L20;
     }
    }
   }
   if (!i58) {
    i4 = 0;
    i1 = 0;
    do {
     i2 = i40 + (i4 << 4) | 0;
     if (!(HEAP8[i40 + (i4 << 4) + 13 >> 0] | 0)) {
      if (i1) i1 = 1; else i1 = (HEAP32[(HEAP32[i40 + (i4 << 4) + 4 >> 2] | 0) + 36 >> 2] | 0) == 5;
      __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE(i49, i54, 0, i56, i39, i47, i41, i43, i2, i44 + (i4 * 56 | 0) | 0);
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i42 | 0));
   } else {
    i4 = 0;
    i1 = 0;
    do {
     i2 = i40 + (i4 << 4) | 0;
     if (!(HEAP8[i40 + (i4 << 4) + 13 >> 0] | 0)) {
      if (i1) i1 = 1; else if ((HEAP32[(HEAP32[i40 + (i4 << 4) + 4 >> 2] | 0) + 36 >> 2] | 0) == 5) {
       i1 = 0;
       do {
        i62 = HEAP32[i45 + (i1 << 2) >> 2] | 0;
        HEAP32[i47 + (i1 << 5) >> 2] = HEAP32[i46 + (i62 << 5) >> 2];
        HEAP32[i47 + (i1 << 5) + 4 >> 2] = HEAP32[i46 + (i62 << 5) + 4 >> 2];
        HEAP32[i47 + (i1 << 5) + 8 >> 2] = HEAP32[i46 + (i62 << 5) + 8 >> 2];
        HEAP32[i47 + (i1 << 5) + 12 >> 2] = HEAP32[i46 + (i62 << 5) + 12 >> 2];
        HEAP32[i47 + (i1 << 5) + 16 >> 2] = HEAP32[i46 + (i62 << 5) + 16 >> 2];
        HEAP32[i47 + (i1 << 5) + 20 >> 2] = HEAP32[i46 + (i62 << 5) + 20 >> 2];
        HEAP32[i47 + (i1 << 5) + 24 >> 2] = HEAP32[i46 + (i62 << 5) + 24 >> 2];
        HEAP32[i47 + (i1 << 5) + 28 >> 2] = HEAP32[i46 + (i62 << 5) + 28 >> 2];
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i58 | 0));
       i1 = 1;
      } else i1 = 0;
      __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE(i49, i54, i58, i56, i39, i47, i41, i43, i2, i44 + (i4 * 56 | 0) | 0);
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i42 | 0));
   }
   if (i1) {
    if (!i52) {
     i1 = 0;
     do {
      i62 = HEAP32[i45 + (i1 << 2) >> 2] | 0;
      HEAP32[i46 + (i62 << 5) >> 2] = HEAP32[i47 + (i1 << 5) >> 2];
      HEAP32[i46 + (i62 << 5) + 4 >> 2] = HEAP32[i47 + (i1 << 5) + 4 >> 2];
      HEAP32[i46 + (i62 << 5) + 8 >> 2] = HEAP32[i47 + (i1 << 5) + 8 >> 2];
      HEAP32[i46 + (i62 << 5) + 12 >> 2] = HEAP32[i47 + (i1 << 5) + 12 >> 2];
      HEAP32[i46 + (i62 << 5) + 16 >> 2] = HEAP32[i47 + (i1 << 5) + 16 >> 2];
      HEAP32[i46 + (i62 << 5) + 20 >> 2] = HEAP32[i47 + (i1 << 5) + 20 >> 2];
      HEAP32[i46 + (i62 << 5) + 24 >> 2] = HEAP32[i47 + (i1 << 5) + 24 >> 2];
      HEAP32[i46 + (i62 << 5) + 28 >> 2] = HEAP32[i47 + (i1 << 5) + 28 >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i58 | 0));
     i18 = i49;
     i48 = 43;
    }
   } else {
    i18 = i49;
    i48 = 43;
   }
  }
 } while (0);
 if ((i48 | 0) == 43) if (!i52) {
  i15 = i49 + 88 | 0;
  i1 = i49 + 72 | 0;
  i14 = 0;
  do {
   i2 = i56 + (i14 * 176 | 0) | 0;
   __ZN5physx17collisionResponseERNS_19PxsParticleCollDataEbbRNS_27PxsFluidCollisionParametersE(i2, 0, 1, i18);
   f3 = Math_fround(HEAPF32[i17 >> 2]);
   i4 = i56 + (i14 * 176 | 0) + 64 | 0;
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   f5 = Math_fround(HEAPF32[i56 + (i14 * 176 | 0) + 48 >> 2]);
   f6 = Math_fround(f6 - f5);
   i7 = i56 + (i14 * 176 | 0) + 68 | 0;
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   f8 = Math_fround(HEAPF32[i56 + (i14 * 176 | 0) + 52 >> 2]);
   f9 = Math_fround(f9 - f8);
   i10 = i56 + (i14 * 176 | 0) + 72 | 0;
   f12 = Math_fround(HEAPF32[i10 >> 2]);
   f11 = Math_fround(HEAPF32[i56 + (i14 * 176 | 0) + 56 >> 2]);
   f12 = Math_fround(f12 - f11);
   f13 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)) + Math_fround(f12 * f12));
   if (f13 > f16) {
    f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f13))));
    f13 = Math_fround(f8 + Math_fround(Math_fround(f3 * f9) * f64));
    f63 = Math_fround(f11 + Math_fround(Math_fround(f3 * f12) * f64));
    HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(Math_fround(f3 * f6) * f64));
    HEAPF32[i7 >> 2] = f13;
    HEAPF32[i10 >> 2] = f63;
   }
   __ZN5physx14updateParticleERNS_16PxsFluidParticleERKNS_19PxsParticleCollDataEbRKNS_7PxPlaneERNS_9PxBounds3E(i54 + (i14 << 5) | 0, i2, (HEAP32[i15 >> 2] & 8 | 0) != 0, i1, i50);
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i58 | 0));
 }
 if (!((i51 | 0) == 0 | i52)) {
  i1 = 0;
  do {
   i62 = HEAP32[i56 + (i1 * 176 | 0) + 76 >> 2] | 0;
   HEAP32[i51 + (i62 * 12 | 0) >> 2] = HEAP32[i56 + (i1 * 176 | 0) >> 2];
   HEAP32[i51 + (i62 * 12 | 0) + 4 >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 4 >> 2];
   HEAP32[i51 + (i62 * 12 | 0) + 8 >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i58 | 0));
 }
 if (!((i53 | 0) == 0 | i52)) {
  i1 = 0;
  do {
   f16 = Math_fround(HEAPF32[i54 + (i1 << 5) + 16 >> 2]);
   f16 = Math_fround(f16 - Math_fround(HEAPF32[i56 + (i1 * 176 | 0) + 32 >> 2]));
   f63 = Math_fround(HEAPF32[i54 + (i1 << 5) + 20 >> 2]);
   f63 = Math_fround(f63 - Math_fround(HEAPF32[i56 + (i1 * 176 | 0) + 36 >> 2]));
   f64 = Math_fround(HEAPF32[i54 + (i1 << 5) + 24 >> 2]);
   f64 = Math_fround(f64 - Math_fround(HEAPF32[i56 + (i1 * 176 | 0) + 40 >> 2]));
   i62 = HEAP32[i56 + (i1 * 176 | 0) + 76 >> 2] | 0;
   HEAPF32[i53 + (i62 * 12 | 0) >> 2] = f16;
   HEAPF32[i53 + (i62 * 12 | 0) + 4 >> 2] = f63;
   HEAPF32[i53 + (i62 * 12 | 0) + 8 >> 2] = f64;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i58 | 0));
 }
 if ((i57 | 0) == 0 | i52) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i55, i56);
  STACKTOP = i59;
  return;
 } else i1 = 0;
 do {
  i62 = HEAP32[i56 + (i1 * 176 | 0) + 76 >> 2] | 0;
  HEAP32[i57 + (i62 << 4) + 12 >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 108 >> 2];
  HEAP32[i57 + (i62 << 4) >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 96 >> 2];
  HEAP32[i57 + (i62 << 4) + 4 >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 100 >> 2];
  HEAP32[i57 + (i62 << 4) + 8 >> 2] = HEAP32[i56 + (i1 * 176 | 0) + 104 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i58 | 0));
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i55, i56);
 STACKTOP = i59;
 return;
}

function __ZN12TreeRenderer11TreeUpdatedEi(i16, i30) {
 i16 = i16 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i38 + 184 | 0;
 i35 = i38 + 168 | 0;
 i31 = i38 + 152 | 0;
 i37 = i38 + 128 | 0;
 i32 = i38 + 64 | 0;
 i33 = i38;
 i12 = HEAP32[i16 >> 2] | 0;
 i14 = HEAP32[i12 + 16 >> 2] | 0;
 i11 = HEAP32[i14 + (i30 * 40 | 0) + 32 >> 2] | 0;
 i12 = HEAP32[i12 + 28 >> 2] | 0;
 i27 = HEAP32[(HEAP32[i16 + 236 >> 2] | 0) + (i30 << 2) >> 2] | 0;
 if ((i27 | 0) == -1) {
  STACKTOP = i38;
  return;
 }
 i28 = i14 + (i30 * 40 | 0) + 12 | 0;
 f8 = Math_fround(HEAPF32[i28 >> 2]);
 i29 = i14 + (i30 * 40 | 0) + 16 | 0;
 f6 = Math_fround(HEAPF32[i29 >> 2]);
 i15 = f8 == Math_fround(0.0) | f6 == Math_fround(0.0);
 f40 = Math_fround(HEAPF32[i14 + (i30 * 40 | 0) >> 2]);
 f40 = Math_fround(f40 * Math_fround(HEAPF32[i16 + 120 >> 2]));
 f41 = Math_fround(HEAPF32[i14 + (i30 * 40 | 0) + 4 >> 2]);
 f41 = Math_fround(f41 * Math_fround(HEAPF32[i16 + 124 >> 2]));
 f42 = Math_fround(HEAPF32[i14 + (i30 * 40 | 0) + 8 >> 2]);
 f42 = Math_fround(f42 * Math_fround(HEAPF32[i16 + 128 >> 2]));
 f40 = Math_fround(f40 + Math_fround(HEAPF32[i16 + 136 >> 2]));
 f41 = Math_fround(f41 + Math_fround(HEAPF32[i16 + 140 >> 2]));
 f42 = Math_fround(f42 + Math_fround(HEAPF32[i16 + 144 >> 2]));
 HEAPF32[i31 >> 2] = f40;
 i9 = i31 + 4 | 0;
 HEAPF32[i9 >> 2] = f41;
 i10 = i31 + 8 | 0;
 HEAPF32[i10 >> 2] = f42;
 f42 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 20 >> 2]);
 f41 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 24 >> 2]);
 f40 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 28 >> 2]);
 f39 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 36 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + (i11 * 156 | 0) + 40 >> 2]);
 HEAPF32[i37 >> 2] = Math_fround(f42 * f8);
 HEAPF32[i37 + 4 >> 2] = Math_fround(f41 * f6);
 HEAPF32[i37 + 8 >> 2] = Math_fround(f40 * f8);
 HEAPF32[i37 + 12 >> 2] = Math_fround(f39 * f8);
 HEAPF32[i37 + 16 >> 2] = Math_fround(f5 * f6);
 HEAPF32[i37 + 20 >> 2] = Math_fround(f7 * f8);
 i13 = i12 + (i11 * 156 | 0) + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if ((i1 | 0) == 2) {
  i4 = HEAP32[i12 + (i11 * 156 | 0) + 8 >> 2] | 0;
  if (i4 | 0) {
   HEAP32[i35 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i36 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i2 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i2 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i34, i1, i35);
     i2 = HEAP32[i34 >> 2] | 0;
     i26 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i26 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i26 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 32 >> 2] | 0;
     i3 = HEAP32[i3 + 28 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i2 << 3) | 0)) i36 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i36 = 11;
    }
   }
   if ((i36 | 0) == 9) i36 = 11;
   if ((i36 | 0) == 11) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i1 = HEAP32[i13 >> 2] | 0;
     i36 = 39;
     break;
    }
   }
   i26 = i16 + 400 | 0;
   i3 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i3 + (i27 * 24 | 0) >> 2] | 0;
   if ((HEAP32[i2 + 272 >> 2] | 0) == (i30 | 0)) {
    switch (HEAP32[i2 + 264 >> 2] | 0) {
    case 1:
     {
      i2 = i2 + 284 | 0;
      i36 = 17;
      break;
     }
    case 2:
     {
      i2 = i2 + 280 | 0;
      i36 = 17;
      break;
     }
    default:
     i2 = i3;
    }
    if ((i36 | 0) == 17) {
     i2 = HEAP32[i2 >> 2] | 0;
     if ((i2 | 0) == -1) i2 = i3; else {
      i25 = i16 + 380 | 0;
      i24 = (HEAP32[i25 >> 2] | 0) + (i2 * 88 | 0) + 4 | 0;
      HEAP32[i24 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      HEAP32[i24 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
      HEAP32[i24 + 16 >> 2] = HEAP32[i37 + 16 >> 2];
      HEAP32[i24 + 20 >> 2] = HEAP32[i37 + 20 >> 2];
      i25 = HEAP32[i25 >> 2] | 0;
      f42 = Math_fround(HEAPF32[i31 >> 2]);
      i24 = i25 + (i2 * 88 | 0) + 4 | 0;
      HEAPF32[i24 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i24 >> 2]));
      f42 = Math_fround(HEAPF32[i9 >> 2]);
      i24 = i25 + (i2 * 88 | 0) + 8 | 0;
      HEAPF32[i24 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i24 >> 2]));
      f42 = Math_fround(HEAPF32[i10 >> 2]);
      i2 = i25 + (i2 * 88 | 0) + 12 | 0;
      HEAPF32[i2 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i2 >> 2]));
      i2 = HEAP32[i26 >> 2] | 0;
     }
    }
    f39 = Math_fround(HEAPF32[i28 >> 2]);
    f41 = Math_fround(HEAPF32[i29 >> 2]);
    i24 = i12 + (i11 * 156 | 0) + 44 | 0;
    i25 = i12 + (i11 * 156 | 0) + 52 | 0;
    f42 = Math_fround(HEAPF32[i24 >> 2]);
    f40 = Math_fround(HEAPF32[i25 >> 2]);
    f42 = Math_fround(f39 * (f42 < f40 ? f40 : f42));
    i23 = i12 + (i11 * 156 | 0) + 48 | 0;
    f41 = Math_fround(f41 * Math_fround(HEAPF32[i23 >> 2]));
    __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i16 + 304 | 0, HEAPU16[i2 + (i27 * 24 | 0) + 14 >> 1] | 0, i1, i31, Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * (f42 < f41 ? f41 : f42)));
    f42 = Math_fround(HEAPF32[i28 >> 2]);
    f41 = Math_fround(HEAPF32[i29 >> 2]);
    HEAPF32[i34 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i24 >> 2]));
    HEAPF32[i34 + 4 >> 2] = Math_fround(f41 * Math_fround(HEAPF32[i23 >> 2]));
    HEAPF32[i34 + 8 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i25 >> 2]));
    if ((HEAP32[i13 >> 2] | 0) == 2) {
     f7 = Math_fround(Math_fround(HEAPF32[i14 + (i30 * 40 | 0) + 20 >> 2]) * Math_fround(.5));
     f5 = Math_fround(+Math_sin(+f7));
     f7 = Math_fround(+Math_cos(+f7));
     f6 = Math_fround(f5 * Math_fround(HEAPF32[gb + 62536 >> 2]));
     f8 = Math_fround(f5 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2]));
     f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]));
    } else {
     f5 = Math_fround(0.0);
     f6 = Math_fround(0.0);
     f7 = Math_fround(1.0);
     f8 = Math_fround(0.0);
    }
    HEAPF32[i35 + 12 >> 2] = f7;
    HEAPF32[i35 >> 2] = f6;
    HEAPF32[i35 + 4 >> 2] = f8;
    HEAPF32[i35 + 8 >> 2] = f5;
    __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i32, i31, i35, i34);
    i22 = i16 + 412 | 0;
    L31 : do if (i27 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0) {
     i21 = (i15 & 1) << 2 & 255;
     i20 = i16 + 420 | 0;
     f5 = Math_fround(HEAPF32[gb + 62452 >> 2]);
     i14 = i14 + (i30 * 40 | 0) + 20 | 0;
     i15 = i34 + 4 | 0;
     i16 = i34 + 8 | 0;
     i17 = i35 + 4 | 0;
     i18 = i35 + 8 | 0;
     i19 = i35 + 12 | 0;
     i12 = i27;
     while (1) {
      i1 = HEAP32[i26 >> 2] | 0;
      i13 = HEAP32[i1 + (i12 * 24 | 0) >> 2] | 0;
      if ((HEAP32[i13 + 272 >> 2] | 0) != (i30 | 0)) break L31;
      i27 = i1 + (i12 * 24 | 0) + 20 | 0;
      HEAP8[i27 >> 0] = HEAP8[i27 >> 0] & -5 | i21;
      switch (HEAP32[i13 + 264 >> 2] | 0) {
      case 1:
       {
        i1 = HEAP32[i20 >> 2] | 0;
        i2 = i1 + (i12 * 24 | 0) | 0;
        i3 = i13 + 156 | 0;
        i9 = i13 + 4 | 0;
        i10 = i32;
        i11 = i9 + 64 | 0;
        do {
         HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
         i9 = i9 + 4 | 0;
         i10 = i10 + 4 | 0;
        } while ((i9 | 0) < (i11 | 0));
        HEAP32[i13 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i32, f5) | 0;
        i43 = i13 + 132 | 0;
        __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i3, i32, i43);
        i4 = HEAP32[i13 + 136 >> 2] | 0;
        i9 = HEAP32[i13 + 140 >> 2] | 0;
        i10 = HEAP32[i13 + 144 >> 2] | 0;
        i11 = HEAP32[i13 + 148 >> 2] | 0;
        i27 = HEAP32[i13 + 152 >> 2] | 0;
        HEAP32[i2 >> 2] = HEAP32[i43 >> 2];
        HEAP32[i1 + (i12 * 24 | 0) + 4 >> 2] = i4;
        HEAP32[i1 + (i12 * 24 | 0) + 8 >> 2] = i9;
        HEAP32[i1 + (i12 * 24 | 0) + 12 >> 2] = i10;
        HEAP32[i1 + (i12 * 24 | 0) + 16 >> 2] = i11;
        HEAP32[i1 + (i12 * 24 | 0) + 20 >> 2] = i27;
        break;
       }
      case 2:
       {
        f41 = Math_fround(HEAPF32[i24 >> 2]);
        f42 = Math_fround(HEAPF32[i23 >> 2]);
        HEAPF32[i13 + 284 >> 2] = Math_fround(f41 * Math_fround(HEAPF32[i28 >> 2]));
        HEAPF32[i13 + 288 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i29 >> 2]));
        HEAP32[i13 + 292 >> 2] = HEAP32[i14 >> 2];
        i4 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, 0) | 0;
        if (!i4) i1 = 1; else {
         HEAP32[i35 >> 2] = i4;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
         if (!i1) i36 = 32; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i2 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[i1 + 32 >> 2] | 0;
           i1 = i2 + (i3 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i34, i1, i35);
           i2 = HEAP32[i34 >> 2] | 0;
           i43 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[gb + 1104264 >> 2] | 0;
           i1 = (i2 | 0) == -1 ? i43 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i43 + (i2 << 3) | 0;
           i2 = HEAP32[i3 + 28 >> 2] | 0;
           i3 = HEAP32[i3 + 32 >> 2] | 0;
          }
          if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i36 = 32; else {
           i1 = HEAP32[i1 + 4 >> 2] | 0;
           if (!i1) i36 = 34;
          }
         }
         if ((i36 | 0) == 32) i36 = 34;
         if ((i36 | 0) == 34) {
          i36 = 0;
          i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
         }
         i1 = (i1 | 0) == 0;
        }
        i2 = (HEAP32[i26 >> 2] | 0) + (i12 * 24 | 0) + 20 | 0;
        i9 = HEAP8[i2 >> 0] | 0;
        HEAP8[i2 >> 0] = (((i9 & 255) >>> 2 & 1 | i1 & 1) & 255) << 2 & 255 | i9 & -5;
        f42 = Math_fround(HEAPF32[i28 >> 2]);
        f41 = Math_fround(HEAPF32[i29 >> 2]);
        HEAPF32[i34 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i24 >> 2]));
        HEAPF32[i15 >> 2] = Math_fround(f41 * Math_fround(HEAPF32[i23 >> 2]));
        HEAPF32[i16 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i25 >> 2]));
        HEAPF32[i35 >> 2] = Math_fround(0.0);
        HEAPF32[i17 >> 2] = Math_fround(0.0);
        HEAPF32[i18 >> 2] = Math_fround(0.0);
        HEAPF32[i19 >> 2] = Math_fround(1.0);
        __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i33, i31, i35, i34);
        i1 = HEAP32[i20 >> 2] | 0;
        i2 = i1 + (i12 * 24 | 0) | 0;
        i9 = i13 + 4 | 0;
        i10 = i33;
        i11 = i9 + 64 | 0;
        do {
         HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
         i9 = i9 + 4 | 0;
         i10 = i10 + 4 | 0;
        } while ((i9 | 0) < (i11 | 0));
        HEAP32[i13 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i33, f5) | 0;
        i4 = i13 + 156 | 0;
        HEAP32[i4 >> 2] = HEAP32[i37 >> 2];
        HEAP32[i4 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
        HEAP32[i4 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
        HEAP32[i4 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
        HEAP32[i4 + 16 >> 2] = HEAP32[i37 + 16 >> 2];
        HEAP32[i4 + 20 >> 2] = HEAP32[i37 + 20 >> 2];
        i4 = i13 + 132 | 0;
        __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i37, i33, i4);
        i9 = HEAP32[i13 + 136 >> 2] | 0;
        i10 = HEAP32[i13 + 140 >> 2] | 0;
        i11 = HEAP32[i13 + 144 >> 2] | 0;
        i27 = HEAP32[i13 + 148 >> 2] | 0;
        i43 = HEAP32[i13 + 152 >> 2] | 0;
        HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i1 + (i12 * 24 | 0) + 4 >> 2] = i9;
        HEAP32[i1 + (i12 * 24 | 0) + 8 >> 2] = i10;
        HEAP32[i1 + (i12 * 24 | 0) + 12 >> 2] = i11;
        HEAP32[i1 + (i12 * 24 | 0) + 16 >> 2] = i27;
        HEAP32[i1 + (i12 * 24 | 0) + 20 >> 2] = i43;
        break;
       }
      default:
       {}
      }
      i12 = i12 + 1 | 0;
      if (i12 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) break L31;
     }
    } while (0);
   }
  }
 } else i36 = 39; while (0);
 do if ((i36 | 0) == 39) if ((i1 | 0) == 1) {
  i4 = HEAP32[i12 + (i11 * 156 | 0) + 16 >> 2] | 0;
  if (i4 | 0) {
   HEAP32[i35 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i36 = 46; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i34, i1, i35);
     i2 = HEAP32[i34 >> 2] | 0;
     i43 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i43 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i43 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i36 = 46; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i36 = 48;
   }
   if ((i36 | 0) == 46) i36 = 48;
   if ((i36 | 0) == 48) if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) break;
   i1 = HEAP32[i16 + 256 >> 2] | 0;
   i4 = HEAP32[i1 + (i27 * 24 | 0) >> 2] | 0;
   i1 = i1 + (i27 * 24 | 0) + 20 | 0;
   HEAP8[i1 >> 0] = HEAP8[i1 >> 0] & -5 | (i15 & 1) << 2 & 255;
   i1 = HEAP32[i16 + 276 >> 2] | 0;
   i2 = i1 + (i27 * 24 | 0) | 0;
   i3 = i4 + 4 | 0;
   i9 = i4 + 4 | 0;
   i10 = i3;
   i11 = i9 + 64 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP32[i4 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i3, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0;
   i33 = i4 + 156 | 0;
   HEAP32[i33 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   HEAP32[i33 + 16 >> 2] = HEAP32[i37 + 16 >> 2];
   HEAP32[i33 + 20 >> 2] = HEAP32[i37 + 20 >> 2];
   i33 = i4 + 132 | 0;
   __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i37, i3, i33);
   i34 = HEAP32[i4 + 136 >> 2] | 0;
   i35 = HEAP32[i4 + 140 >> 2] | 0;
   i36 = HEAP32[i4 + 144 >> 2] | 0;
   i37 = HEAP32[i4 + 148 >> 2] | 0;
   i43 = HEAP32[i4 + 152 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i1 + (i27 * 24 | 0) + 4 >> 2] = i34;
   HEAP32[i1 + (i27 * 24 | 0) + 8 >> 2] = i35;
   HEAP32[i1 + (i27 * 24 | 0) + 12 >> 2] = i36;
   HEAP32[i1 + (i27 * 24 | 0) + 16 >> 2] = i37;
   HEAP32[i1 + (i27 * 24 | 0) + 20 >> 2] = i43;
  }
 } while (0);
 STACKTOP = i38;
 return;
}

function __ZN26AnimatorControllerPlayable13GenerateGraphEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 8 | 0;
 i29 = i30;
 i7 = i8 + 148 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i28 = i8 + 144 | 0;
 i4 = i8 + 64 | 0;
 if ((i1 | 0) > 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i4);
 HEAP32[i28 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = i1 + 28 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 if ((i2 | 0) > -1) {
  i3 = i1 + 16 | 0;
  i4 = i8 + 56 | 0;
  i5 = i8 + 60 | 0;
  do {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if (i1 | 0) {
    __ZN8Playable10DisconnectEPS_i(i8, i2);
    HEAP8[i4 >> 0] = 0;
    __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv(i1);
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0, i5 | 0);
   }
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) > -1);
 }
 i1 = HEAP32[i8 + 84 >> 2] | 0;
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i24 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
 if (!i24) {
  STACKTOP = i30;
  return;
 }
 i25 = i8 + 60 | 0;
 i26 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 128, 8) | 0;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i26, 0, 0);
 HEAP32[i26 >> 2] = gb + 176764 + 8;
 i22 = gb + 63320 | 0;
 i23 = HEAP32[i22 + 4 >> 2] | 0;
 i21 = i29;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = i23;
 HEAP32[i26 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
 i21 = i27;
 i23 = HEAP32[i21 + 4 >> 2] | 0;
 i22 = i26 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 HEAP8[i26 + 72 >> 0] = 0;
 HEAP8[i26 + 73 >> 0] = 0;
 HEAP8[i26 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i26 + 76 | 0);
 HEAP32[i26 >> 2] = gb + 176908 + 8;
 HEAP32[i26 + 80 >> 2] = 0;
 HEAP32[i26 + 92 >> 2] = 0;
 HEAP32[i26 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, gb + 63664 | 0);
 i22 = i27;
 i23 = HEAP32[i22 + 4 >> 2] | 0;
 i21 = i26 + 84 | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = i23;
 HEAP32[i26 + 100 >> 2] = 0;
 HEAP32[i26 + 112 >> 2] = 0;
 HEAP32[i26 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, gb + 63664 | 0);
 i21 = i27;
 i23 = HEAP32[i21 + 4 >> 2] | 0;
 i22 = i26 + 104 | 0;
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 HEAP8[i26 + 120 >> 0] = 1;
 HEAP32[i26 + 48 >> 2] = 7;
 __ZN8Playable7ConnectEPS_S0_ii(i26, i8, -1, ((HEAP32[i6 >> 2] | 0) == 0) << 31 >> 31) | 0;
 HEAP8[i8 + 56 >> 0] = 0;
 i22 = i26 + 56 | 0;
 HEAP8[i22 >> 0] = 0;
 i23 = i24 + 8 | 0;
 if (!(HEAP32[i28 >> 2] | 0)) {
  i2 = HEAP32[i23 >> 2] | 0;
  if (!i2) i1 = 0; else {
   i3 = i2 << 3;
   i1 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i3 | 0, 4) | 0;
   if ((i1 | 0) != (i1 + (i2 << 3) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  }
  HEAP32[i28 >> 2] = i1;
 }
 i21 = HEAP32[i23 >> 2] | 0;
 HEAP32[i7 >> 2] = i21;
 if (!i21) i2 = 0; else {
  i5 = i24 + 12 | 0;
  i6 = i5;
  i4 = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   i2 = i1 + i6 + (i4 << 2) | 0;
   i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0;
   if (!i2) i1 = 0; else {
    i3 = i2 << 2;
    i1 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i3 | 0, 4) | 0;
    if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
   }
   i2 = HEAP32[i28 >> 2] | 0;
   HEAP32[i2 + (i4 << 3) >> 2] = i1;
   i1 = HEAP32[i5 >> 2] | 0;
   i21 = i1 + i6 + (i4 << 2) | 0;
   HEAP32[i2 + (i4 << 3) + 4 >> 2] = HEAP32[i21 + (HEAP32[i21 >> 2] | 0) + 28 >> 2];
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i23 >> 2] | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 i3 = HEAP32[i24 >> 2] | 0;
 if (!i3) {
  STACKTOP = i30;
  return;
 }
 i19 = i24 + 4 | 0;
 i20 = i19;
 i21 = i8 + 104 | 0;
 i18 = i8 + 100 | 0;
 i17 = 0;
 i1 = i2;
 do {
  if (!i1) i1 = 0; else {
   i16 = 0;
   i1 = i2;
   do {
    i14 = (HEAP32[i19 >> 2] | 0) + i20 + (i17 << 2) | 0;
    i14 = i14 + (HEAP32[i14 >> 2] | 0) | 0;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    if ((i16 | 0) == (HEAP32[i14 >> 2] | 0)) {
     i14 = HEAP32[(HEAP32[HEAP32[i21 >> 2] >> 2] | 0) + (i16 << 2) >> 2] | 0;
     i9 = (HEAP32[i18 >> 2] | 0) + 4 | 0;
     i9 = i9 + (HEAP32[i9 >> 2] | 0) + (i16 << 2) | 0;
     i8 = HEAP32[i9 >> 2] | 0;
     HEAP8[((i8 | 0) == 0 ? 0 : i9 + i8 | 0) + 80 >> 0] = 0;
     i8 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 80, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i8, 0, 0);
     HEAP32[i8 >> 2] = gb + 176764 + 8;
     i9 = gb + 63320 | 0;
     i10 = HEAP32[i9 + 4 >> 2] | 0;
     i11 = i29;
     HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i11 + 4 >> 2] = i10;
     HEAP32[i8 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i11 = i27;
     i10 = HEAP32[i11 + 4 >> 2] | 0;
     i9 = i8 + 64 | 0;
     HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i9 + 4 >> 2] = i10;
     HEAP8[i8 + 72 >> 0] = 0;
     HEAP8[i8 + 73 >> 0] = 0;
     HEAP8[i8 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i8 + 76 | 0);
     HEAP32[i8 >> 2] = gb + 177060 + 8;
     __ZN8Playable7ConnectEPS_S0_ii(i8, i26, -1, -1) | 0;
     HEAP8[i22 >> 0] = 0;
     i9 = i8 + 56 | 0;
     HEAP8[i9 >> 0] = 0;
     i10 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 80, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i10, 0, 0);
     HEAP32[i10 >> 2] = gb + 176764 + 8;
     i11 = gb + 63320 | 0;
     i1 = HEAP32[i11 + 4 >> 2] | 0;
     i12 = i29;
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i12 + 4 >> 2] = i1;
     HEAP32[i10 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i12 = i27;
     i1 = HEAP32[i12 + 4 >> 2] | 0;
     i11 = i10 + 64 | 0;
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = i1;
     HEAP8[i10 + 72 >> 0] = 0;
     HEAP8[i10 + 73 >> 0] = 0;
     HEAP8[i10 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i10 + 76 | 0);
     HEAP32[i10 >> 2] = gb + 177060 + 8;
     i11 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 80, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i11, 0, 0);
     HEAP32[i11 >> 2] = gb + 176764 + 8;
     i1 = gb + 63320 | 0;
     i12 = HEAP32[i1 + 4 >> 2] | 0;
     i13 = i29;
     HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     HEAP32[i11 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i13 = i27;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i1 = i11 + 64 | 0;
     HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i1 + 4 >> 2] = i12;
     HEAP8[i11 + 72 >> 0] = 0;
     HEAP8[i11 + 73 >> 0] = 0;
     HEAP8[i11 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i11 + 76 | 0);
     HEAP32[i11 >> 2] = gb + 177060 + 8;
     i1 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 88, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i1, 0, 0);
     HEAP32[i1 >> 2] = gb + 176764 + 8;
     i12 = gb + 63320 | 0;
     i13 = HEAP32[i12 + 4 >> 2] | 0;
     i7 = i29;
     HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i7 + 4 >> 2] = i13;
     HEAP32[i1 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i7 = i27;
     i13 = HEAP32[i7 + 4 >> 2] | 0;
     i12 = i1 + 64 | 0;
     HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i12 + 4 >> 2] = i13;
     HEAP8[i1 + 72 >> 0] = 0;
     HEAP8[i1 + 73 >> 0] = 0;
     HEAP8[i1 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i1 + 76 | 0);
     HEAP32[i1 >> 2] = gb + 177204 + 8;
     HEAP32[i1 + 84 >> 2] = 0;
     HEAP32[i10 + 48 >> 2] = 7;
     HEAP32[i11 + 48 >> 2] = 7;
     HEAP32[i1 + 48 >> 2] = 7;
     __ZN8Playable7ConnectEPS_S0_ii(i10, i8, -1, -1) | 0;
     HEAP8[i9 >> 0] = 0;
     i12 = i10 + 56 | 0;
     HEAP8[i12 >> 0] = 0;
     __ZN8Playable7ConnectEPS_S0_ii(i11, i8, -1, -1) | 0;
     HEAP8[i9 >> 0] = 0;
     i13 = i11 + 56 | 0;
     HEAP8[i13 >> 0] = 0;
     __ZN8Playable7ConnectEPS_S0_ii(i1, i8, -1, -1) | 0;
     HEAP8[i9 >> 0] = 0;
     HEAP8[i1 + 56 >> 0] = 0;
     __ZN8Playable14SetInputWeightEif(i8, 0, Math_fround(1.0));
     __ZN8Playable14SetInputWeightEif(i8, 1, Math_fround(0.0));
     __ZN8Playable14SetInputWeightEif(i8, 2, Math_fround(0.0));
     i14 = i14 + 12 | 0;
     i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
     if (HEAP32[i14 >> 2] | 0) {
      i7 = 0;
      do {
       i4 = mftCall_iiii(i1 | 0, i25 | 0, 184, 8) | 0;
       __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i4, 0, 0);
       HEAP32[i4 >> 2] = gb + 176764 + 8;
       i1 = gb + 63320 | 0;
       i5 = HEAP32[i1 + 4 >> 2] | 0;
       i6 = i29;
       HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
       HEAP32[i6 + 4 >> 2] = i5;
       HEAP32[i4 + 60 >> 2] = gb + 175924 + 8;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
       i6 = i27;
       i5 = HEAP32[i6 + 4 >> 2] | 0;
       i1 = i4 + 64 | 0;
       HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i1 + 4 >> 2] = i5;
       HEAP8[i4 + 72 >> 0] = 0;
       HEAP8[i4 + 73 >> 0] = 0;
       HEAP8[i4 + 74 >> 0] = 0;
       __ZN14AssetReferenceC2Ev(i4 + 76 | 0);
       HEAP32[i4 >> 2] = gb + 177348 + 8;
       HEAP32[i4 + 80 >> 2] = gb + 177492 + 8;
       i1 = i4 + 84 | 0;
       HEAP32[i1 >> 2] = 0;
       HEAP32[i1 + 4 >> 2] = 0;
       HEAP32[i1 + 8 >> 2] = 0;
       HEAP32[i1 + 12 >> 2] = 0;
       HEAP32[i1 + 16 >> 2] = 0;
       HEAPF32[i4 + 104 >> 2] = Math_fround(1.0);
       HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
       HEAP8[i4 + 112 >> 0] = 0;
       HEAP8[i4 + 113 >> 0] = 1;
       HEAP32[i4 + 116 >> 2] = 0;
       HEAP32[i4 + 120 >> 2] = 128;
       i1 = i4 + 168 | 0;
       i5 = i4 + 124 | 0;
       i6 = i5 + 44 | 0;
       do {
        HEAP32[i5 >> 2] = 0;
        i5 = i5 + 4 | 0;
       } while ((i5 | 0) < (i6 | 0));
       HEAPF32[i1 >> 2] = Math_fround(1.0);
       HEAP8[i4 + 172 >> 0] = 1;
       HEAP8[i4 + 173 >> 0] = 0;
       i1 = i4 + 48 | 0;
       HEAP32[i1 >> 2] = 1;
       i2 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 184, 8) | 0;
       __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i2, 0, 0);
       HEAP32[i2 >> 2] = gb + 176764 + 8;
       i3 = gb + 63320 | 0;
       i5 = HEAP32[i3 + 4 >> 2] | 0;
       i6 = i29;
       HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i6 + 4 >> 2] = i5;
       HEAP32[i2 + 60 >> 2] = gb + 175924 + 8;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
       i6 = i27;
       i5 = HEAP32[i6 + 4 >> 2] | 0;
       i3 = i2 + 64 | 0;
       HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i3 + 4 >> 2] = i5;
       HEAP8[i2 + 72 >> 0] = 0;
       HEAP8[i2 + 73 >> 0] = 0;
       HEAP8[i2 + 74 >> 0] = 0;
       __ZN14AssetReferenceC2Ev(i2 + 76 | 0);
       HEAP32[i2 >> 2] = gb + 177348 + 8;
       HEAP32[i2 + 80 >> 2] = gb + 177492 + 8;
       i3 = i2 + 84 | 0;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP32[i3 + 16 >> 2] = 0;
       HEAPF32[i2 + 104 >> 2] = Math_fround(1.0);
       HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
       HEAP8[i2 + 112 >> 0] = 0;
       HEAP8[i2 + 113 >> 0] = 1;
       HEAP32[i2 + 116 >> 2] = 0;
       HEAP32[i2 + 120 >> 2] = 128;
       i3 = i2 + 168 | 0;
       i5 = i2 + 124 | 0;
       i6 = i5 + 44 | 0;
       do {
        HEAP32[i5 >> 2] = 0;
        i5 = i5 + 4 | 0;
       } while ((i5 | 0) < (i6 | 0));
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAP8[i2 + 172 >> 0] = 1;
       HEAP8[i2 + 173 >> 0] = 0;
       i6 = i2 + 48 | 0;
       HEAP32[i6 >> 2] = 1;
       mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0, 0);
       mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, 0);
       HEAP32[i1 >> 2] = 7;
       HEAP32[i6 >> 2] = 7;
       __ZN8Playable7ConnectEPS_S0_ii(i4, i10, -1, -1) | 0;
       HEAP8[i12 >> 0] = 0;
       HEAP8[i4 + 56 >> 0] = 0;
       __ZN8Playable7ConnectEPS_S0_ii(i2, i11, -1, -1) | 0;
       HEAP8[i13 >> 0] = 0;
       HEAP8[i2 + 56 >> 0] = 0;
       __ZN8Playable14SetInputWeightEif(i10, i7, Math_fround(0.0));
       __ZN8Playable14SetInputWeightEif(i11, i7, Math_fround(0.0));
       i7 = i7 + 1 | 0;
       i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
      } while (i7 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
     }
     i1 = mftCall_iiii(i1 | 0, i25 | 0, 88, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i1, 0, 0);
     HEAP32[i1 >> 2] = gb + 176764 + 8;
     i7 = gb + 63320 | 0;
     i6 = HEAP32[i7 + 4 >> 2] | 0;
     i5 = i29;
     HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i5 + 4 >> 2] = i6;
     HEAP32[i1 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i5 = i27;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i7 = i1 + 64 | 0;
     HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i7 + 4 >> 2] = i6;
     HEAP8[i1 + 72 >> 0] = 0;
     HEAP8[i1 + 73 >> 0] = 0;
     HEAP8[i1 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i1 + 76 | 0);
     HEAP32[i1 >> 2] = gb + 177204 + 8;
     HEAP32[i1 + 84 >> 2] = 0;
     HEAP32[i1 + 48 >> 2] = 7;
     __ZN8Playable7ConnectEPS_S0_ii(i1, i10, -1, -1) | 0;
     HEAP8[i12 >> 0] = 0;
     HEAP8[i1 + 56 >> 0] = 0;
     __ZN8Playable14SetInputWeightEif(i10, HEAP32[i14 >> 2] | 0, Math_fround(0.0));
     i1 = mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 88, 8) | 0;
     __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i1, 0, 0);
     HEAP32[i1 >> 2] = gb + 176764 + 8;
     i12 = gb + 63320 | 0;
     i10 = HEAP32[i12 + 4 >> 2] | 0;
     i7 = i29;
     HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i7 + 4 >> 2] = i10;
     HEAP32[i1 + 60 >> 2] = gb + 175924 + 8;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i29);
     i7 = i27;
     i10 = HEAP32[i7 + 4 >> 2] | 0;
     i12 = i1 + 64 | 0;
     HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i12 + 4 >> 2] = i10;
     HEAP8[i1 + 72 >> 0] = 0;
     HEAP8[i1 + 73 >> 0] = 0;
     HEAP8[i1 + 74 >> 0] = 0;
     __ZN14AssetReferenceC2Ev(i1 + 76 | 0);
     HEAP32[i1 >> 2] = gb + 177204 + 8;
     HEAP32[i1 + 84 >> 2] = 0;
     HEAP32[i1 + 48 >> 2] = 7;
     __ZN8Playable7ConnectEPS_S0_ii(i1, i11, -1, -1) | 0;
     HEAP8[i13 >> 0] = 0;
     HEAP8[i1 + 56 >> 0] = 0;
     __ZN8Playable14SetInputWeightEif(i11, HEAP32[i14 >> 2] | 0, Math_fround(0.0));
     HEAP8[i9 >> 0] = 0;
     HEAP32[i8 + 48 >> 2] = 7;
     HEAP32[(HEAP32[(HEAP32[i28 >> 2] | 0) + (i16 << 3) >> 2] | 0) + (i15 << 2) >> 2] = i8;
     i1 = HEAP32[i23 >> 2] | 0;
    }
    i16 = i16 + 1 | 0;
   } while (i16 >>> 0 < i1 >>> 0);
   i3 = HEAP32[i24 >> 2] | 0;
   i2 = i1;
  }
  i17 = i17 + 1 | 0;
 } while (i17 >>> 0 < i3 >>> 0);
 STACKTOP = i30;
 return;
}

function __Z27GenerateOutlineFromMeshDataRK13dynamic_arrayItLj2EERKS_I12SpriteVertexLj4EERS_I8Vector2fLj4EE(i7, i25, i24) {
 i7 = i7 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i28 + 8 | 0;
 i15 = i28;
 i9 = i28 + 36 | 0;
 i27 = i28 + 16 | 0;
 i21 = i9 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i9 + 8 | 0;
 HEAP8[i22 >> 0] = 0;
 i16 = i9 + 12 | 0;
 HEAP32[i16 >> 2] = -1;
 i17 = i9 + 16 | 0;
 HEAP32[i17 >> 2] = -1;
 HEAP32[i9 + 20 >> 2] = 0;
 i18 = i9 + 24 | 0;
 i19 = i9 + 28 | 0;
 i26 = i9 + 36 | 0;
 i20 = i9 + 40 | 0;
 HEAP32[i20 >> 2] = 32;
 i8 = i9 + 44 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 16;
 HEAP32[i9 + 48 >> 2] = 6;
 HEAP8[i9 + 56 >> 0] = 0;
 HEAP8[i9 + 9 >> 0] = 1;
 i13 = i9 + 24 | 0;
 i10 = i13;
 HEAP32[i10 >> 2] = -1;
 HEAP32[i10 + 4 >> 2] = -1;
 HEAP32[i9 + 32 >> 2] = 0;
 i10 = __Znwj(384) | 0;
 HEAP32[i26 >> 2] = i10;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 36 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 48 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 60 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 72 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 84 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 96 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 108 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 120 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 132 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 144 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 156 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 168 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 180 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 192 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 204 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 216 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 228 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 240 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 252 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 264 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 276 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 288 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 300 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 312 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 324 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 336 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 348 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i12 = i10 + 360 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i10 = i10 + 372 | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i10 = i7 + 12 | 0;
 L1 : do if (HEAP32[i10 >> 2] | 0) {
  i11 = i15 + 4 | 0;
  i12 = i15 + 4 | 0;
  i13 = i15 + 4 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = i1 + 1 | 0;
   i5 = HEAPU16[i4 + (i6 << 1) >> 1] | 0;
   HEAP32[i15 >> 2] = HEAPU16[i4 + (i1 << 1) >> 1];
   HEAP32[i11 >> 2] = i5;
   if ((HEAP32[i8 >> 2] | 0) == (i2 | 0)) {
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = i3 + (i4 * 12 | 0) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i14, i9, i15);
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (i4 * 12 | 0) | 0 : i3 + (i2 * 12 | 0) | 0;
   }
   if ((i2 | 0) == (i3 + (i4 * 12 | 0) | 0)) HEAP32[(__ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_(i9, i15) | 0) >> 2] = 1; else {
    i5 = i2 + 8 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   }
   i3 = HEAP32[i7 >> 2] | 0;
   i5 = i1 + 2 | 0;
   i4 = HEAPU16[i3 + (i5 << 1) >> 1] | 0;
   HEAP32[i15 >> 2] = HEAPU16[i3 + (i6 << 1) >> 1];
   HEAP32[i12 >> 2] = i4;
   if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i21 >> 2] | 0)) {
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = i3 + (i4 * 12 | 0) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i14, i9, i15);
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (i4 * 12 | 0) | 0 : i3 + (i2 * 12 | 0) | 0;
   }
   if ((i2 | 0) == (i3 + (i4 * 12 | 0) | 0)) HEAP32[(__ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_(i9, i15) | 0) >> 2] = 1; else {
    i6 = i2 + 8 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   }
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = HEAPU16[i4 + (i1 << 1) >> 1] | 0;
   HEAP32[i15 >> 2] = HEAPU16[i4 + (i5 << 1) >> 1];
   HEAP32[i13 >> 2] = i6;
   if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i21 >> 2] | 0)) {
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = i3 + (i4 * 12 | 0) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i14, i9, i15);
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i20 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (i4 * 12 | 0) | 0 : i3 + (i2 * 12 | 0) | 0;
   }
   if ((i2 | 0) == (i3 + (i4 * 12 | 0) | 0)) HEAP32[(__ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_(i9, i15) | 0) >> 2] = 1; else {
    i6 = i2 + 8 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   }
   i1 = i1 + 3 | 0;
   if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break L1;
   i2 = HEAP32[i21 >> 2] | 0;
  }
 } while (0);
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i15;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i27 >> 2] = 0;
 i8 = i27 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i27 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i15);
 i7 = i14;
 i15 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = HEAP32[i26 >> 2] | 0;
 i15 = HEAP32[i20 >> 2] | 0;
 i7 = i1 + (i15 * 12 | 0) | 0;
 L31 : do if (!i15) i23 = 19; else {
  i5 = HEAP32[i18 >> 2] | 0;
  i6 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i4 = HEAP32[i17 >> 2] | 0;
  if ((HEAP8[i22 >> 0] | 0) == 0 | (HEAP32[i21 >> 2] | 0) == 0) while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i5 | 0) == (i2 | 0)) {
    if ((i6 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i23 = 7;
   } else i23 = 7;
   if ((i23 | 0) == 7) {
    i23 = 0;
    if ((i6 | 0) != (i2 | 0)) {
     i23 = 19;
     break L31;
    }
    if ((i5 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i23 = 19;
     break L31;
    }
   }
   i1 = i1 + 12 | 0;
   if ((i1 | 0) == (i7 | 0)) break L31;
  }
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i5 | 0) == (i2 | 0)) {
    if ((i6 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i23 = 12;
   } else i23 = 12;
   do if ((i23 | 0) == 12) {
    i23 = 0;
    if ((i6 | 0) == (i2 | 0)) if ((i5 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
    if ((i3 | 0) == (i2 | 0)) if ((i4 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
    if ((i4 | 0) != (i2 | 0)) {
     i23 = 19;
     break L31;
    }
    if ((i3 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i23 = 19;
     break L31;
    }
   } while (0);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i7 | 0));
 } while (0);
 if ((i23 | 0) == 19) if ((i1 | 0) != (i7 | 0)) do {
  if ((HEAP32[i1 + 8 >> 2] | 0) == 1) {
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i2 = i5 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i9 >> 2] = i2;
     HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i2 << 3, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i15 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
     HEAP32[i9 >> 2] = i2;
     HEAP32[i27 >> 2] = i15;
     break;
    }
   } while (0);
   HEAP32[i8 >> 2] = i4;
   i13 = i1;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = (HEAP32[i27 >> 2] | 0) + (i3 << 3) | 0;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = i14;
  }
  i1 = i1 + 12 | 0;
  L71 : do if ((i1 | 0) == (i7 | 0)) i1 = i7; else {
   i5 = HEAP32[i18 >> 2] | 0;
   i6 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   if ((HEAP8[i22 >> 0] | 0) == 0 | (HEAP32[i21 >> 2] | 0) == 0) while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i5 | 0) == (i2 | 0)) {
     if ((i6 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i23 = 53;
    } else i23 = 53;
    if ((i23 | 0) == 53) {
     i23 = 0;
     if ((i6 | 0) != (i2 | 0)) break L71;
     if ((i5 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L71;
    }
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     i1 = i7;
     break L71;
    }
   }
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i5 | 0) == (i2 | 0)) {
     if ((i6 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i23 = 58;
    } else i23 = 58;
    do if ((i23 | 0) == 58) {
     i23 = 0;
     if ((i6 | 0) == (i2 | 0)) if ((i5 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
     if ((i3 | 0) == (i2 | 0)) if ((i4 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
     if ((i4 | 0) != (i2 | 0)) break L71;
     if ((i3 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L71;
    } while (0);
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     i1 = i7;
     break;
    }
   }
  } while (0);
 } while ((i1 | 0) != ((HEAP32[i26 >> 2] | 0) + ((HEAP32[i20 >> 2] | 0) * 12 | 0) | 0));
 i2 = HEAP32[i27 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i6 = 1;
  i3 = i2 + 4 | 0;
  do {
   i4 = HEAP32[i3 >> 2] | 0;
   L102 : do if (i6 >>> 0 < i1 >>> 0) {
    i3 = i6;
    while (1) {
     i5 = i2 + (i3 << 3) | 0;
     i3 = i3 + 1 | 0;
     if ((HEAP32[i5 >> 2] | 0) == (i4 | 0)) break;
     if (i3 >>> 0 >= i1 >>> 0) break L102;
    }
    i2 = i2 + (i6 << 3) | 0;
    i1 = i2;
    i23 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i21 = i5;
    i22 = HEAP32[i21 + 4 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i2 + 4 >> 2] = i22;
    i2 = i5;
    HEAP32[i2 >> 2] = i23;
    HEAP32[i2 + 4 >> 2] = i1;
    i2 = HEAP32[i27 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while (0);
   i3 = i6;
   i6 = i6 + 1 | 0;
   i3 = i2 + (i3 << 3) + 4 | 0;
  } while (i6 >>> 0 < i1 >>> 0);
 }
 i2 = i24 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i24 + 4 | 0);
  HEAP32[i24 >> 2] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i24 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 3, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i24 >> 2] = i5;
  i3 = HEAP32[i8 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i27 >> 2] | 0;
   i2 = HEAP32[i25 >> 2] | 0;
   i1 = 0;
   do {
    i25 = HEAP32[i4 + (i1 << 3) >> 2] | 0;
    HEAP32[i5 + (i1 << 3) >> 2] = HEAP32[i2 + (i25 * 20 | 0) >> 2];
    HEAP32[i5 + (i1 << 3) + 4 >> 2] = HEAP32[i2 + (i25 * 20 | 0) + 4 >> 2];
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  }
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i10);
  HEAP32[i27 >> 2] = 0;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i28;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEbT0_S6_T_(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 switch ((i10 - i11 | 0) / 24 | 0 | 0) {
 case 2:
  {
   i1 = i10 + -24 | 0;
   f4 = Math_fround(HEAPF32[i1 >> 2]);
   f3 = Math_fround(HEAPF32[i11 >> 2]);
   if (f4 != f3) {
    if (!(f4 < f3)) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    }
   } else if ((HEAP32[i10 + -20 >> 2] | 0) >= (HEAP32[i11 + 4 >> 2] | 0)) {
    i12 = 1;
    STACKTOP = i13;
    return i12 | 0;
   };
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 3:
  {
   i7 = i11 + 24 | 0;
   i5 = i10 + -24 | 0;
   f4 = Math_fround(HEAPF32[i7 >> 2]);
   f3 = Math_fround(HEAPF32[i11 >> 2]);
   if (f4 != f3) i2 = f4 < f3; else i2 = (HEAP32[i11 + 28 >> 2] | 0) < (HEAP32[i11 + 4 >> 2] | 0);
   f3 = Math_fround(HEAPF32[i5 >> 2]);
   if (f3 != f4) i1 = f3 < f4; else i1 = (HEAP32[i10 + -20 >> 2] | 0) < (HEAP32[i11 + 28 >> 2] | 0);
   if (!i2) {
    if (!i1) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    };
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    f4 = Math_fround(HEAPF32[i11 >> 2]);
    if (f3 != f4) {
     if (!(f3 < f4)) {
      i12 = 1;
      STACKTOP = i13;
      return i12 | 0;
     }
    } else if ((HEAP32[i11 + 28 >> 2] | 0) >= (HEAP32[i11 + 4 >> 2] | 0)) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    };
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    i12 = 1;
    STACKTOP = i13;
    return i12 | 0;
   }
   if (i1) {
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    i12 = 1;
    STACKTOP = i13;
    return i12 | 0;
   };
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   f3 = Math_fround(HEAPF32[i5 >> 2]);
   f4 = Math_fround(HEAPF32[i7 >> 2]);
   if (f3 != f4) {
    if (!(f3 < f4)) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    }
   } else if ((HEAP32[i10 + -20 >> 2] | 0) >= (HEAP32[i11 + 28 >> 2] | 0)) {
    i12 = 1;
    STACKTOP = i13;
    return i12 | 0;
   };
   HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_(i11, i11 + 24 | 0, i11 + 48 | 0, i10 + -24 | 0, i1) | 0;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i11, i11 + 24 | 0, i11 + 48 | 0, i11 + 72 | 0, i10 + -24 | 0, i1) | 0;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 default:
  {
   i5 = i11 + 48 | 0;
   i7 = i11 + 24 | 0;
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   f4 = Math_fround(HEAPF32[i11 >> 2]);
   if (f3 != f4) i2 = f3 < f4; else i2 = (HEAP32[i11 + 28 >> 2] | 0) < (HEAP32[i11 + 4 >> 2] | 0);
   f6 = Math_fround(HEAPF32[i5 >> 2]);
   if (f6 != f3) i1 = f6 < f3; else i1 = (HEAP32[i11 + 52 >> 2] | 0) < (HEAP32[i11 + 28 >> 2] | 0);
   do if (i2) {
    if (i1) {
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i11 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
     HEAP32[i11 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
     break;
    };
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    if (f6 != f3) {
     if (!(f6 < f3)) break;
    } else if ((HEAP32[i11 + 52 >> 2] | 0) >= (HEAP32[i11 + 28 >> 2] | 0)) break;
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   } else if (i1) {
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    if (f3 != f4) {
     if (!(f3 < f4)) break;
    } else if ((HEAP32[i11 + 28 >> 2] | 0) >= (HEAP32[i11 + 4 >> 2] | 0)) break;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   } while (0);
   i1 = i11 + 72 | 0;
   L27 : do if ((i1 | 0) == (i10 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i8 = i1;
    i1 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i8 >> 2]);
     f3 = Math_fround(HEAPF32[i5 >> 2]);
     if (f4 != f3) {
      if (f4 < f3) {
       i7 = HEAP32[i8 + 4 >> 2] | 0;
       i9 = 50;
      }
     } else {
      i2 = HEAP32[i8 + 4 >> 2] | 0;
      if ((i2 | 0) < (HEAP32[i5 + 4 >> 2] | 0)) {
       i7 = i2;
       i9 = 50;
      }
     }
     if ((i9 | 0) == 50) {
      i9 = 0;
      i2 = i8 + 8 | 0;
      HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
      HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
      HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
      L37 : do if ((i5 | 0) == (i11 | 0)) i2 = i11; else while (1) {
       i2 = i5;
       i5 = i5 + -24 | 0;
       f3 = Math_fround(HEAPF32[i5 >> 2]);
       if (f4 != f3) {
        if (!(f4 < f3)) break L37;
       } else if ((i7 | 0) >= (HEAP32[i2 + -20 >> 2] | 0)) break L37;
       HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       if ((i5 | 0) == (i11 | 0)) {
        i2 = i11;
        break;
       }
      } while (0);
      HEAPF32[i2 >> 2] = f4;
      HEAP32[i2 + 4 >> 2] = i7;
      i7 = i2 + 8 | 0;
      HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i8 + 24 | 0) == (i10 | 0);
       break L27;
      }
     }
     i2 = i8 + 24 | 0;
     if ((i2 | 0) == (i10 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i5 = i8;
      i8 = i2;
     }
    }
   } while (0);
   i12 = i1 | i2;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZNK16MemoryFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag(i8, i2, i27, i28, i1, i29) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33 + 48 | 0;
 i32 = i33 + 32 | 0;
 i30 = i33 + 16 | 0;
 i25 = i33;
 i24 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0, i8 | 0, i2 | 0) | 0;
 HEAP32[i32 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i8, i2, i32);
 i26 = i32 + 11 | 0;
 i21 = HEAP8[i26 >> 0] | 0;
 i1 = i21 << 24 >> 24 < 0;
 i23 = i32 + 4 | 0;
 i5 = i8 + 4 | 0;
 if (!((i1 ? HEAP32[i23 >> 2] | 0 : i21 & 255) | 0)) i1 = HEAP32[i5 >> 2] | 0; else {
  i3 = i1 ? HEAP32[i32 >> 2] | 0 : i32;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i30 + 12 >> 2] = i1;
  i4 = _strlen(i3) | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i30);
   i1 = HEAP32[i30 + 12 >> 2] | 0;
   i22 = 6;
  } else if (i4 >>> 0 < 11) {
   i2 = i30 + 11 | 0;
   HEAP8[i2 >> 0] = i4;
   if (!i4) i1 = i30; else {
    i1 = i30;
    i22 = 8;
   }
  } else i22 = 6;
  if ((i22 | 0) == 6) {
   i2 = i4 + 16 & -16;
   HEAP32[i31 >> 2] = 54;
   HEAP32[i31 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i30 >> 2] = i1;
   HEAP32[i30 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i30 + 4 >> 2] = i4;
   i2 = i30 + 11 | 0;
   i22 = 8;
  }
  if ((i22 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i5, i30) | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   i21 = HEAP32[i30 >> 2] | 0;
   i20 = HEAP32[i30 + 12 >> 2] | 0;
   HEAP32[i31 >> 2] = 54;
   HEAP32[i31 + 4 >> 2] = i20;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i31);
  }
 }
 i21 = i8 + 8 | 0;
 if ((i1 | 0) == (i21 | 0)) i1 = 0; else {
  i7 = HEAP8[i26 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i23 >> 2] | 0 : i7 & 255;
  i4 = (i7 | 0) == 0;
  i20 = i4 ? 0 : i7 + 1 | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  L26 : do if (i4 | (i1 | 0) == (i21 | 0)) i2 = i1; else {
   i5 = i3 ? HEAP32[i32 >> 2] | 0 : i32;
   i6 = i5 + (i7 + -1) | 0;
   i2 = i1;
   while (1) {
    i1 = i2 + 16 | 0;
    i4 = HEAP8[i1 + 11 >> 0] | 0;
    i3 = i4 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
    L30 : do if (i4 >>> 0 >= i7 >>> 0) {
     i3 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
     i1 = 0;
     do {
      i16 = HEAP8[i3 + i1 >> 0] | 0;
      i17 = i16 << 24 >> 24;
      i18 = HEAP8[i5 + i1 >> 0] | 0;
      i19 = i18 << 24 >> 24;
      i1 = i1 + 1 | 0;
      if ((((i16 + -65 & 255) < 26 ? i17 + 32 | 0 : i17) & 255) << 24 >> 24 != (((i18 + -65 & 255) < 26 ? i19 + 32 | 0 : i19) & 255) << 24 >> 24) break L30;
     } while (i1 >>> 0 < i7 >>> 0);
     if ((i4 | 0) == (i7 | 0)) break L26;
     if ((HEAP8[i3 + i7 >> 0] | 0) == 47) break L26;
     if ((HEAP8[i6 >> 0] | 0) == 47) break L26;
    } while (0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i21 | 0)) {
     i2 = i1;
     break;
    } else i2 = i1;
   }
  } while (0);
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  HEAP32[i30 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  L47 : do if ((i2 | 0) == (i21 | 0)) i1 = i30 + 11 | 0; else {
   i17 = i27 + 12 | 0;
   i18 = i27 + 16 | 0;
   i19 = i27 + 4 | 0;
   i13 = i8 + 24 | 0;
   i14 = i13 + 11 | 0;
   i1 = i30 + 11 | 0;
   i15 = i30 + 8 | 0;
   i16 = i30 + 4 | 0;
   do {
    i7 = HEAP8[i26 >> 0] | 0;
    i5 = i7 << 24 >> 24 < 0;
    i7 = i5 ? HEAP32[i23 >> 2] | 0 : i7 & 255;
    if (i7 | 0) {
     i3 = i2 + 16 | 0;
     i8 = HEAP8[i3 + 11 >> 0] | 0;
     i4 = i8 << 24 >> 24 < 0;
     i8 = i4 ? HEAP32[i2 + 20 >> 2] | 0 : i8 & 255;
     if (i8 >>> 0 < i7 >>> 0) break L47;
     i6 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
     i4 = i5 ? HEAP32[i32 >> 2] | 0 : i32;
     i3 = 0;
     do {
      i9 = HEAP8[i6 + i3 >> 0] | 0;
      i10 = i9 << 24 >> 24;
      i11 = HEAP8[i4 + i3 >> 0] | 0;
      i12 = i11 << 24 >> 24;
      i3 = i3 + 1 | 0;
      if ((((i9 + -65 & 255) < 26 ? i10 + 32 | 0 : i10) & 255) << 24 >> 24 != (((i11 + -65 & 255) < 26 ? i12 + 32 | 0 : i12) & 255) << 24 >> 24) break L47;
     } while (i3 >>> 0 < i7 >>> 0);
     if ((i8 | 0) != (i7 | 0)) if ((HEAP8[i6 + i7 >> 0] | 0) != 47) if ((HEAP8[i4 + (i7 + -1) >> 0] | 0) != 47) break L47;
    }
    if (i28) i22 = 49; else {
     i4 = i2 + 16 | 0;
     i3 = HEAP8[i4 + 11 >> 0] | 0;
     if (i3 << 24 >> 24 < 0) {
      i3 = HEAP32[i2 + 20 >> 2] | 0;
      i4 = HEAP32[i4 >> 2] | 0;
     } else i3 = i3 & 255;
     if (i3 >>> 0 > i20 >>> 0) {
      i3 = i3 - i20 | 0;
      if (!i3) i22 = 49; else {
       i12 = _memchr(i4 + i20 | 0, 47, i3) | 0;
       if ((i12 | 0) == 0 | (i12 - i4 | 0) == -1) i22 = 49;
      }
     } else i22 = 49;
    }
    if ((i22 | 0) == 49) {
     i22 = 0;
     i12 = HEAP32[i17 >> 2] | 0;
     i4 = i12 + 1 | 0;
     i5 = HEAP32[i18 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i3 = i5 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i6 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i18 >> 2] = i3;
       HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i3 * 1088 | 0, 8, i19, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 1088 | 0, 8, i19, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i27 >> 2] | 0, (HEAP32[i17 >> 2] | 0) * 1088 | 0) | 0;
       HEAP32[i18 >> 2] = i3;
       HEAP32[i27 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i17 >> 2] = i4;
     i10 = HEAP32[i27 >> 2] | 0;
     i11 = i10 + (i12 * 1088 | 0) | 0;
     do if (i24) {
      if ((HEAP8[i14 >> 0] | 0) < 0) i6 = HEAP32[i13 >> 2] | 0; else i6 = i13;
      i7 = _strlen(i6) | 0;
      i3 = HEAP8[i1 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i5 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
      do if (i7 >>> 0 > i5 >>> 0) {
       i3 = i4 ? HEAP32[i16 >> 2] | 0 : i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i30, i5, i7 - i5 | 0, i3, 0, i3, i7, i6);
       i3 = HEAP8[i1 >> 0] | 0;
       i22 = 66;
      } else {
       i3 = i4 ? HEAP32[i30 >> 2] | 0 : i30;
       if (i7 | 0) _memmove(i3 | 0, i6 | 0, i7 | 0) | 0;
       HEAP8[i3 + i7 >> 0] = 0;
       if ((HEAP8[i1 >> 0] | 0) < 0) {
        HEAP32[i16 >> 2] = i7;
        i22 = 68;
        break;
       } else {
        i3 = i7 & 255;
        HEAP8[i1 >> 0] = i3;
        i22 = 66;
        break;
       }
      } while (0);
      if ((i22 | 0) == 66) {
       i22 = 0;
       if (i3 << 24 >> 24 < 0) i22 = 68; else {
        i5 = i3 & 255;
        i3 = 10;
        i4 = 0;
       }
      }
      if ((i22 | 0) == 68) {
       i5 = HEAP32[i16 >> 2] | 0;
       i3 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
       i4 = 1;
      }
      if ((i5 | 0) == (i3 | 0)) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i30, i3, 1, i3, i3, 0, 0);
       if ((HEAP8[i1 >> 0] | 0) > -1) i22 = 72; else i22 = 73;
      } else if (i4) i22 = 73; else i22 = 72;
      if ((i22 | 0) == 72) {
       i22 = 0;
       HEAP8[i1 >> 0] = i5 + 1;
       i3 = i30;
      } else if ((i22 | 0) == 73) {
       i22 = 0;
       i3 = HEAP32[i30 >> 2] | 0;
       HEAP32[i16 >> 2] = i5 + 1;
      }
      i3 = i3 + i5 | 0;
      HEAP8[i3 >> 0] = 47;
      HEAP8[i3 + 1 >> 0] = 0;
      i3 = i2 + 32 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i6 = i4 + 24 | 0;
      i5 = HEAP8[i6 + 11 >> 0] | 0;
      i7 = i5 << 24 >> 24 < 0;
      if (i7) i4 = HEAP32[i4 + 28 >> 2] | 0; else i4 = i5 & 255;
      if (!i4) {
       i4 = i2 + 16 | 0;
       if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i4 = HEAP32[i4 >> 2] | 0;
       i9 = _strlen(i4) | 0;
       i5 = HEAP8[i1 >> 0] | 0;
       i6 = i5 << 24 >> 24 < 0;
       if (i6) {
        i7 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
        i8 = HEAP32[i16 >> 2] | 0;
       } else {
        i7 = 10;
        i8 = i5 & 255;
       }
       if ((i7 - i8 | 0) >>> 0 < i9 >>> 0) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i30, i7, i9 - i7 + i8 | 0, i8, i8, 0, i9, i4);
        break;
       }
       if (!i9) break;
       i5 = i6 ? HEAP32[i30 >> 2] | 0 : i30;
       _memcpy(i5 + i8 | 0, i4 | 0, i9 | 0) | 0;
       i4 = i8 + i9 | 0;
       if ((HEAP8[i1 >> 0] | 0) < 0) HEAP32[i16 >> 2] = i4; else HEAP8[i1 >> 0] = i4;
       HEAP8[i5 + i4 >> 0] = 0;
       break;
      } else {
       if (i7) i6 = HEAP32[i6 >> 2] | 0;
       i8 = _strlen(i6) | 0;
       i4 = HEAP8[i1 >> 0] | 0;
       i5 = i4 << 24 >> 24 < 0;
       if (i5) {
        i7 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
        i4 = HEAP32[i16 >> 2] | 0;
       } else {
        i7 = 10;
        i4 = i4 & 255;
       }
       if ((i7 - i4 | 0) >>> 0 < i8 >>> 0) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i30, i7, i8 - i7 + i4 | 0, i4, i4, 0, i8, i6);
        break;
       }
       if (!i8) break;
       i5 = i5 ? HEAP32[i30 >> 2] | 0 : i30;
       _memcpy(i5 + i4 | 0, i6 | 0, i8 | 0) | 0;
       i4 = i4 + i8 | 0;
       if ((HEAP8[i1 >> 0] | 0) < 0) HEAP32[i16 >> 2] = i4; else HEAP8[i1 >> 0] = i4;
       HEAP8[i5 + i4 >> 0] = 0;
       break;
      }
     } else {
      i3 = i2 + 32 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i6 = i4 + 24 | 0;
      i5 = HEAP8[i6 + 11 >> 0] | 0;
      i7 = i5 << 24 >> 24 < 0;
      if (i7) i4 = HEAP32[i4 + 28 >> 2] | 0; else i4 = i5 & 255;
      if (!i4) {
       i4 = i2 + 16 | 0;
       if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i4 = HEAP32[i4 >> 2] | 0;
       i8 = _strlen(i4) | 0;
       i5 = HEAP8[i1 >> 0] | 0;
       i6 = i5 << 24 >> 24 < 0;
       if (i6) i7 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
       if (i8 >>> 0 > i7 >>> 0) {
        i9 = i6 ? HEAP32[i16 >> 2] | 0 : i5 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i30, i7, i8 - i7 | 0, i9, 0, i9, i8, i4);
        break;
       }
       i5 = i6 ? HEAP32[i30 >> 2] | 0 : i30;
       if (i8 | 0) _memmove(i5 | 0, i4 | 0, i8 | 0) | 0;
       HEAP8[i5 + i8 >> 0] = 0;
       if ((HEAP8[i1 >> 0] | 0) < 0) {
        HEAP32[i16 >> 2] = i8;
        break;
       } else {
        HEAP8[i1 >> 0] = i8;
        break;
       }
      } else {
       if (i7) i6 = HEAP32[i6 >> 2] | 0;
       i8 = _strlen(i6) | 0;
       i4 = HEAP8[i1 >> 0] | 0;
       i5 = i4 << 24 >> 24 < 0;
       if (i5) i7 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
       if (i8 >>> 0 > i7 >>> 0) {
        i9 = i5 ? HEAP32[i16 >> 2] | 0 : i4 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i30, i7, i8 - i7 | 0, i9, 0, i9, i8, i6);
        break;
       }
       i4 = i5 ? HEAP32[i30 >> 2] | 0 : i30;
       if (i8 | 0) _memmove(i4 | 0, i6 | 0, i8 | 0) | 0;
       HEAP8[i4 + i8 >> 0] = 0;
       if ((HEAP8[i1 >> 0] | 0) < 0) {
        HEAP32[i16 >> 2] = i8;
        break;
       } else {
        HEAP8[i1 >> 0] = i8;
        break;
       }
      }
     } while (0);
     _strncpy(i11, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 1040) | 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1039 >> 0] = 0;
     i7 = HEAP32[i3 >> 2] | 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1080 >> 0] = (HEAP32[i7 >> 2] | 0) == 0 & 1;
     i7 = i7 + 4 | 0;
     i8 = HEAP32[i7 + 4 >> 2] | 0;
     i9 = i10 + (i12 * 1088 | 0) + 1072 | 0;
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = i8;
     HEAP8[i10 + (i12 * 1088 | 0) + 1081 >> 0] = 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1082 >> 0] = 0;
     i12 = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i25 + 4 >> 2] = 0;
     HEAP32[i25 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, i12, _strlen(i12) | 0);
     __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i31, i25);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
     if (__Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i11, i31, i29) | 0) HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
    }
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i3) while (1) {
     i3 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
      i2 = i3;
      break;
     } else i2 = i3;
    } else {
     i2 = i3;
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) break; else i2 = i3;
     }
    }
   } while ((i2 | 0) != (i21 | 0));
  } while (0);
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i29 = HEAP32[i30 >> 2] | 0;
   i30 = HEAP32[i30 + 12 >> 2] | 0;
   HEAP32[i31 >> 2] = 1;
   HEAP32[i31 + 4 >> 2] = i30;
   __Z19free_alloc_internalPvRK10MemLabelId(i29, i31);
  }
  i1 = 1;
 }
 if ((HEAP8[i26 >> 0] | 0) >= 0) {
  STACKTOP = i33;
  return i1 | 0;
 }
 i30 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 12 >> 2] | 0;
 HEAP32[i31 >> 2] = 54;
 HEAP32[i31 + 4 >> 2] = i32;
 __Z19free_alloc_internalPvRK10MemLabelId(i30, i31);
 STACKTOP = i33;
 return i1 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE(i25, i20, i22, i6, f27, i8, i18) {
 i25 = i25 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i6 = i6 | 0;
 f27 = Math_fround(f27);
 i8 = i8 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37 + 248 | 0;
 i30 = i37 + 8 | 0;
 i31 = i37;
 i33 = i37 + 328 | 0;
 i32 = i37 + 308 | 0;
 i21 = i25 + 32 | 0;
 if ((HEAP32[i21 >> 2] | 0) != -2) {
  i36 = 1;
  STACKTOP = i37;
  return i36 | 0;
 }
 if ((HEAP16[gb + 1467836 + 6 >> 1] | 0) > -1) {
  HEAP32[i30 >> 2] = 0;
  HEAP32[i35 >> 2] = HEAP32[i30 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467836 | 0, i35);
  i36 = gb + 1467836 | 0;
 } else i36 = 0;
 i26 = i25 + 76 | 0;
 i4 = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[i26 >> 2] | 0) | 0;
 do if (!i4) i34 = 13; else {
  HEAP32[i30 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i34 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i35, i1, i30);
    i2 = HEAP32[i35 >> 2] | 0;
    i29 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i29 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i29 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i34 = 10; else if (HEAP32[i1 + 4 >> 2] | 0) {
    i34 = 14;
    break;
   }
  }
  if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) i34 = 13; else i34 = 14;
 } while (0);
 if ((i34 | 0) == 13) if (__ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i25) | 0) i34 = 14; else i1 = 0;
 if ((i34 | 0) == 14) {
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i33 >> 2] = 0;
  i28 = i33 + 4 | 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  i29 = i33 + 12 | 0;
  HEAP32[i29 >> 2] = i1;
  i5 = i33 + 8 | 0;
  if (i22 | 0) {
   HEAP32[i35 >> 2] = 1;
   HEAP32[i35 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22 * 60 | 0, 16, i35, 0, gb + 1049224 | 0, 75) | 0;
   i1 = HEAP32[i33 >> 2] | 0;
   i2 = (HEAP32[i28 >> 2] | 0) - i1 | 0;
   i4 = i3 + (((i2 | 0) / -60 | 0) * 60 | 0) | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
    i1 = HEAP32[i33 >> 2] | 0;
   }
   HEAP32[i33 >> 2] = i4;
   HEAP32[i28 >> 2] = i3;
   HEAP32[i5 >> 2] = i3 + (i22 * 60 | 0);
   if (i1 | 0) {
    i24 = HEAP32[i29 >> 2] | 0;
    HEAP32[i35 >> 2] = 1;
    HEAP32[i35 + 4 >> 2] = i24;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i35);
   }
  }
  HEAP32[i32 >> 2] = 0;
  i19 = i32 + 12 | 0;
  HEAP32[i19 >> 2] = 0;
  i23 = i32 + 16 | 0;
  HEAP32[i23 >> 2] = 0;
  i24 = i32 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, gb + 63664 | 0);
  i4 = i35;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i24;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = HEAP32[i19 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i23 >> 2] = i1;
    HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 5, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i17 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i19 >> 2] << 5 | 0) | 0;
    HEAP32[i23 >> 2] = i1;
    HEAP32[i32 >> 2] = i17;
    break;
   }
  } while (0);
  HEAP32[i19 >> 2] = i3;
  i16 = HEAP32[i32 >> 2] | 0;
  HEAP32[i16 + (i2 << 5) >> 2] = 0;
  HEAP32[i16 + (i2 << 5) + 4 >> 2] = -1;
  i17 = i16 + (i2 << 5) + 8 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAPF32[i16 + (i2 << 5) + 24 >> 2] = Math_fround(1.0);
  HEAPF32[i16 + (i2 << 5) + 28 >> 2] = Math_fround(1.0);
  i16 = HEAP32[i32 >> 2] | 0;
  HEAP32[i16 + ((HEAP32[i19 >> 2] | 0) + -1 << 5) + 4 >> 2] = -1;
  i17 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
  HEAP32[i16 + (i17 << 5) + 8 >> 2] = i6;
  HEAP32[i16 + (i17 << 5) >> 2] = i8;
  L37 : do if ((i22 | 0) > 0) {
   i10 = i35 + 4 | 0;
   i11 = i35 + 48 | 0;
   i12 = i35 + 52 | 0;
   i13 = i35 + 56 | 0;
   i17 = i25 + 28 | 0;
   i14 = i35 + 40 | 0;
   i15 = i35 + 44 | 0;
   i16 = i30 + 4 | 0;
   i9 = i18 + 12 | 0;
   if (!i18) {
    i4 = 0;
    i1 = 0;
    i6 = 0;
    while (1) {
     HEAP32[i35 >> 2] = -1;
     i3 = i10;
     i5 = i3 + 44 | 0;
     do {
      HEAP32[i3 >> 2] = 0;
      i3 = i3 + 4 | 0;
     } while ((i3 | 0) < (i5 | 0));
     HEAPF32[i11 >> 2] = Math_fround(1.0);
     HEAP32[i12 >> 2] = 0;
     HEAP8[i13 >> 0] = 0;
     i2 = HEAP16[i20 + (i6 << 1) >> 1] | 0;
     i3 = i2 & 65535;
     switch (HEAP32[i21 >> 2] | 0) {
     case 1:
      {
       i18 = i3 << 24 >> 24;
       i2 = ((((i2 & 255) + -97 & 255) < 26 ? i18 + 224 | 0 : i18) << 24 >> 24) - (HEAP32[i17 >> 2] | 0) | 0;
       break;
      }
     case 2:
      {
       i18 = i3 << 24 >> 24;
       i2 = ((((i2 & 255) + -65 & 255) < 26 ? i18 + 32 | 0 : i18) << 24 >> 24) - (HEAP32[i17 >> 2] | 0) | 0;
       break;
      }
     default:
      i2 = i3 - (HEAP32[i17 >> 2] | 0) | 0;
     }
     HEAP32[i35 >> 2] = i2;
     i3 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
     i5 = HEAP32[i32 >> 2] | 0;
     i2 = HEAP32[i5 + (i3 << 5) + 8 >> 2] | 0;
     if (!i2) i2 = HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0;
     HEAP32[i14 >> 2] = (i2 | 0) > 500 ? 500 : i2;
     HEAP32[i15 >> 2] = HEAP32[i5 + (i3 << 5) >> 2];
     HEAPF32[i11 >> 2] = f27;
     __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_(i30, i33, i35);
     if (HEAP8[i16 >> 0] | 0) {
      i18 = HEAP32[i14 >> 2] | 0;
      i1 = (Math_imul(i18, i18) | 0) + i1 | 0;
      i4 = (i4 | 0) < (i18 | 0) ? i18 : i4;
     }
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i22 | 0)) {
      i16 = i33;
      break L37;
     }
    }
   } else {
    i4 = 0;
    i1 = 0;
    i2 = 0;
    i5 = 0;
   }
   while (1) {
    L55 : do if (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) while (1) {
     i3 = HEAP32[i18 >> 2] | 0;
     i6 = i3 + (i2 * 44 | 0) | 0;
     if ((i5 | 0) < (HEAP32[i6 >> 2] | 0)) {
      i8 = i5;
      break L55;
     }
     i5 = (HEAP32[i3 + (i2 * 44 | 0) + 4 >> 2] | 0) + i5 | 0;
     __ZN20TextRenderingPrivate11FormatStack10PushFormatERKNS_16TextFormatChangeE(i32, i6);
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
      i8 = i5;
      break;
     }
    } else i8 = i5; while (0);
    if ((i8 | 0) >= (i22 | 0)) {
     i16 = i33;
     break L37;
    }
    HEAP32[i35 >> 2] = -1;
    i3 = i10;
    i5 = i3 + 44 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    HEAPF32[i11 >> 2] = Math_fround(1.0);
    HEAP32[i12 >> 2] = 0;
    HEAP8[i13 >> 0] = 0;
    i3 = HEAP16[i20 + (i8 << 1) >> 1] | 0;
    i5 = i3 & 65535;
    switch (HEAP32[i21 >> 2] | 0) {
    case 1:
     {
      i6 = i5 << 24 >> 24;
      i3 = ((((i3 & 255) + -97 & 255) < 26 ? i6 + 224 | 0 : i6) << 24 >> 24) - (HEAP32[i17 >> 2] | 0) | 0;
      break;
     }
    case 2:
     {
      i6 = i5 << 24 >> 24;
      i3 = ((((i3 & 255) + -65 & 255) < 26 ? i6 + 32 | 0 : i6) << 24 >> 24) - (HEAP32[i17 >> 2] | 0) | 0;
      break;
     }
    default:
     i3 = i5 - (HEAP32[i17 >> 2] | 0) | 0;
    }
    HEAP32[i35 >> 2] = i3;
    i5 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
    i6 = HEAP32[i32 >> 2] | 0;
    i3 = HEAP32[i6 + (i5 << 5) + 8 >> 2] | 0;
    if (!i3) i3 = HEAP32[(HEAP32[i26 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i14 >> 2] = (i3 | 0) > 500 ? 500 : i3;
    HEAP32[i15 >> 2] = HEAP32[i6 + (i5 << 5) >> 2];
    HEAPF32[i11 >> 2] = f27;
    __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_(i30, i33, i35);
    if (HEAP8[i16 >> 0] | 0) {
     i6 = HEAP32[i14 >> 2] | 0;
     i1 = (Math_imul(i6, i6) | 0) + i1 | 0;
     i4 = (i4 | 0) < (i6 | 0) ? i6 : i4;
    }
    i5 = i8 + 1 | 0;
    if ((i5 | 0) >= (i22 | 0)) {
     i16 = i33;
     break L37;
    }
   }
  } else {
   i4 = 0;
   i1 = 0;
   i16 = i33;
   i17 = i25 + 28 | 0;
  } while (0);
  i11 = i25 + 168 | 0;
  i12 = i25 + 172 | 0;
  i13 = i25 + 180 | 0;
  i14 = i25 + 60 | 0;
  i15 = i25 + 64 | 0;
  i2 = 0;
  i3 = 0;
  L74 : while (1) {
   i5 = HEAP32[i33 >> 2] | 0;
   L76 : do if ((i5 | 0) == (HEAP32[i28 >> 2] | 0)) {
    i6 = 9;
    i5 = 0;
   } else {
    while (1) {
     i6 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) & 65535;
     if (__ZN20TextRenderingPrivate8FontImpl19HasCharacterDynamicEj(i25, i6) | 0) {
      i8 = i5 + 40 | 0;
      i9 = i5 + 44 | 0;
      if (!(__ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj(i25, i6, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, f27, 0) | 0)) if (__ZN20TextRenderingPrivate8FontImpl21AddCharacterToTextureEjifj(i25, i6, HEAP32[i8 >> 2] | 0, f27, HEAP32[i9 >> 2] | 0) | 0) i3 = 1; else break;
     }
     i5 = i5 + 60 | 0;
     if ((i5 | 0) == (HEAP32[i28 >> 2] | 0)) {
      i6 = 9;
      i5 = 0;
      break L76;
     }
    }
    if (i2) {
     i8 = ~~Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(i4 | 0) * f27) + Math_fround(.5))));
     i5 = HEAP32[i11 >> 2] | 0;
     i6 = HEAP32[i12 >> 2] | 0;
     if (i5 >>> 0 < i6 >>> 0) {
      i5 = i5 << 1;
      HEAP32[i11 >> 2] = i5;
     } else HEAP32[i12 >> 2] = i6 << 1;
     i21 = (i8 << 2) + -1 | 0;
     i21 = i21 >>> 16 | i21;
     i21 = i21 >>> 8 | i21;
     i21 = i21 >>> 4 | i21;
     i21 = i21 >>> 2 | i21;
     i21 = (i21 >>> 1 | i21) + 1 | 0;
     i22 = HEAP32[i13 >> 2] | 0;
     i22 = i22 >>> 0 < i21 >>> 0 ? i21 : i22;
     HEAP32[i13 >> 2] = i5 >>> 0 < i22 >>> 0 ? i5 : i22;
    } else {
     i5 = HEAP32[i14 >> 2] | 0;
     if ((i5 | 0) == (HEAP32[i15 >> 2] | 0)) i34 = 61; else {
      i8 = 0;
      i6 = i5;
      do {
       i5 = i6 + 40 | 0;
       i22 = HEAP32[i5 >> 2] | 0;
       i8 = (Math_imul(i22, i22) | 0) + i8 | 0;
       i22 = HEAP32[i6 + 52 >> 2] | 0;
       if ((i22 | 0) == (HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0)) {
        i22 = __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE4findIS2_EENS3_11__wrap_iterIPS2_EERKT_(i16, i6) | 0;
        if ((i22 | 0) == (HEAP32[i28 >> 2] | 0)) {
         i22 = HEAP32[i5 >> 2] | 0;
         i1 = (Math_imul(i22, i22) | 0) + i1 | 0;
         __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_(i35, i16, i6);
         i4 = (i4 | 0) < (i22 | 0) ? i22 : i4;
        }
       }
       i6 = i6 + 60 | 0;
      } while ((i6 | 0) != (HEAP32[i15 >> 2] | 0));
      if ((i8 | 0) > 0) {
       f7 = Math_fround(i8 | 0);
       i5 = HEAP32[i11 >> 2] | 0;
       i6 = HEAP32[i12 >> 2] | 0;
       f7 = Math_fround(f7 / Math_fround((Math_imul(i6, i5) | 0) >>> 0));
      } else i34 = 61;
     }
     if ((i34 | 0) == 61) {
      i34 = 0;
      f7 = Math_fround(2.0);
      i6 = HEAP32[i12 >> 2] | 0;
      i5 = HEAP32[i11 >> 2] | 0;
     }
     f38 = Math_fround(Math_fround(Math_fround(Math_fround(i1 | 0) / f7) * Math_fround(1.10000002)) + Math_fround(.5));
     i9 = f38 >= Math_fround(0.0);
     f7 = Math_fround(f38 + Math_fround(-.99999994));
     i9 = ~~(i9 ? f38 : f7);
     if (i9 >>> 0 > (Math_imul(i6, i5) | 0) >>> 0) {
      i10 = (~~Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(i4 | 0) * f27) + Math_fround(.5)))) << 2) + -1 | 0;
      i10 = i10 >>> 16 | i10;
      i10 = i10 >>> 8 | i10;
      i10 = i10 >>> 4 | i10;
      i10 = i10 >>> 2 | i10;
      i10 = (i10 >>> 1 | i10) + 1 | 0;
      i8 = HEAP32[i13 >> 2] | 0;
      do {
       if (i5 >>> 0 < i6 >>> 0) {
        i5 = i5 << 1;
        HEAP32[i11 >> 2] = i5;
       } else {
        i6 = i6 << 1;
        HEAP32[i12 >> 2] = i6;
       }
       i22 = i8 >>> 0 < i10 >>> 0 ? i10 : i8;
       i8 = i5 >>> 0 < i22 >>> 0 ? i5 : i22;
      } while (i9 >>> 0 > (Math_imul(i6, i5) | 0) >>> 0);
      HEAP32[i13 >> 2] = i8;
     }
    }
    i6 = __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i25) | 0;
    i6 = i6 ? 9 : 1;
    i5 = 1;
   } while (0);
   i22 = (i6 | 0) == 9;
   i2 = i2 | i5 & i22;
   switch ((i22 ? (i5 ? 7 : 8) : i6) & 15) {
   case 7:
    break;
   case 8:
    {
     i34 = 77;
     break L74;
    }
   default:
    {
     i1 = 0;
     break L74;
    }
   }
  }
  if ((i34 | 0) == 77) {
   if (i3) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0) {
    i34 = __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E((HEAP32[i26 >> 2] | 0) + 44 | 0) | 0;
    mftCall_vi(HEAP32[(HEAP32[i34 >> 2] | 0) + 192 >> 2] | 0, i34 | 0);
   }
   if (i2) {
    HEAP32[gb + 1467848 >> 2] = (HEAP32[gb + 1467848 >> 2] | 0) + 1;
    __ZN20TextRenderingPrivate13ApplyToMeshesEv();
    i34 = (HEAP32[gb + 1467848 >> 2] | 0) + -1 | 0;
    HEAP32[gb + 1467848 >> 2] = i34;
    if (!i34) {
     i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i26 >> 2] | 0) | 0;
     if (i1 | 0) {
      i25 = (__Z32GetTextRenderingScriptingClassesv() | 0) + 4 | 0;
      i26 = HEAP32[i25 + 4 >> 2] | 0;
      i34 = i31;
      HEAP32[i34 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i34 + 4 >> 2] = i26;
      HEAP32[i35 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i35 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
      __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i30, i35);
      __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i30, i1);
      HEAP32[i35 >> 2] = 0;
      __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i30, i35, 0) | 0;
     }
     i1 = 1;
    } else i1 = 1;
   } else i1 = 1;
  }
  if ((HEAP32[i23 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i24);
   HEAP32[i32 >> 2] = 0;
  }
  i2 = HEAP32[i33 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = HEAP32[i28 >> 2] | 0;
   if ((i4 | 0) != (i2 | 0)) HEAP32[i28 >> 2] = i4 + (~(((i4 + -60 - i3 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i34 = HEAP32[i29 >> 2] | 0;
   HEAP32[i35 >> 2] = 1;
   HEAP32[i35 + 4 >> 2] = i34;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i35);
  }
 }
 if (!i36) {
  i36 = i1;
  STACKTOP = i37;
  return i36 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i36);
 i36 = i1;
 STACKTOP = i37;
 return i36 | 0;
}

function __ZN13SpeedTreeWind10SWindGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485284 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485305 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485326 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485347 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485368 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485389 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485410 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485431 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485452 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485473 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485494 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485511 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485528 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485545 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485562 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485579 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485596 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485613 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485630 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485647 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485664 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485682 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485700 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485718 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485736 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485754 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485772 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485790 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485808 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485826 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485844 | 0, i5, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485875 | 0, i5, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485906 | 0, i5, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485937 | 0, i5, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485968 | 0, i5, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 485999 | 0, i5, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486030 | 0, i5, i1 + 144 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486061 | 0, i5, i1 + 148 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486092 | 0, i5, i1 + 152 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486123 | 0, i5, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486154 | 0, i5, i1 + 160 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486172 | 0, i5, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486190 | 0, i5, i1 + 168 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486208 | 0, i5, i1 + 172 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486226 | 0, i5, i1 + 176 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486244 | 0, i5, i1 + 180 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486262 | 0, i5, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486280 | 0, i5, i1 + 188 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486298 | 0, i5, i1 + 192 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486316 | 0, i5, i1 + 196 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486334 | 0, i5, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486353 | 0, i5, i1 + 204 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486369 | 0, i5, i1 + 208 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486385 | 0, i5, i1 + 212 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486398 | 0, i5, i1 + 216 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486416 | 0, i5, i1 + 220 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx2Sc9ClothCore14updateBulkDataERNS0_13ClothBulkDataE(i24, i27) {
 i24 = i24 | 0;
 i27 = i27 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i29 + 312 | 0;
 i25 = i29 + 16 | 0;
 i1 = i29 + 8 | 0;
 i3 = i29;
 i28 = i29 + 280 | 0;
 i30 = i29 + 264 | 0;
 i5 = i29 + 260 | 0;
 i6 = i29 + 248 | 0;
 i7 = i29 + 232 | 0;
 i8 = i29 + 224 | 0;
 i9 = i29 + 208 | 0;
 i10 = i29 + 204 | 0;
 i11 = i29 + 168 | 0;
 i4 = i29 + 152 | 0;
 i13 = i29 + 136 | 0;
 i14 = i29 + 120 | 0;
 i16 = i29 + 112 | 0;
 i17 = i29 + 96 | 0;
 i18 = i29 + 84 | 0;
 i19 = i29 + 72 | 0;
 i20 = i29 + 60 | 0;
 i21 = i29 + 48 | 0;
 i22 = i29 + 36 | 0;
 i23 = i29 + 24 | 0;
 i26 = i24 + 28 | 0;
 i31 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i31 >> 2] | 0) + 36 >> 2] | 0, i28 | 0, i31 | 0);
 i31 = HEAP32[i26 >> 2] | 0;
 i31 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 20 >> 2] | 0, i31 | 0) | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i27, i31, i30);
 i30 = HEAP32[i28 >> 2] | 0;
 _memcpy(HEAP32[i27 >> 2] | 0, i30 | 0, (HEAP32[i28 + 4 >> 2] | 0) - i30 | 0) | 0;
 i30 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 236 >> 2] | 0, i30 | 0) | 0) {
  i33 = i27 + 12 | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  i32 = (mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 236 >> 2] | 0, i32 | 0) | 0) << 2;
  HEAP32[i5 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i33, i32, i5);
  i32 = i27 + 24 | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  i31 = mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 240 >> 2] | 0, i31 | 0) | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i32, i31, i6);
  i33 = HEAP32[i33 >> 2] | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  i31 = i33 + ((mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 236 >> 2] | 0, i31 | 0) | 0) << 4) | 0;
  i30 = HEAP32[i26 >> 2] | 0;
  i30 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] | 0, i30 | 0) | 0;
  i6 = HEAP32[(HEAP32[i30 >> 2] | 0) + 44 >> 2] | 0;
  i5 = HEAP32[i26 >> 2] | 0;
  HEAP32[i1 >> 2] = i33;
  HEAP32[i1 + 4 >> 2] = i31;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  mftCall_viiii(i6 | 0, i30 | 0, i5 | 0, i25 | 0, i15 | 0);
  i32 = HEAP32[i32 >> 2] | 0;
  i5 = HEAP32[i26 >> 2] | 0;
  i5 = i32 + ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 240 >> 2] | 0, i5 | 0) | 0) * 12 | 0) | 0;
  i30 = HEAP32[i26 >> 2] | 0;
  i30 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] | 0, i30 | 0) | 0;
  i6 = HEAP32[(HEAP32[i30 >> 2] | 0) + 44 >> 2] | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = i32;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  mftCall_viiii(i6 | 0, i30 | 0, i31 | 0, i25 | 0, i15 | 0);
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 168 >> 2] | 0, i33 | 0) | 0)) {
  i33 = HEAP32[i26 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 192 >> 2] | 0, i33 | 0) | 0)) {
   i33 = HEAP32[i26 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 204 >> 2] | 0, i33 | 0) | 0) i12 = 6;
  } else i12 = 6;
 } else i12 = 6;
 if ((i12 | 0) == 6) {
  i12 = i27 + 36 | 0;
  i30 = HEAP32[i26 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i12, mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 168 >> 2] | 0, i30 | 0) | 0, i7);
  i30 = i27 + 48 | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  i31 = (mftCall_ii(HEAP32[(HEAP32[i31 >> 2] | 0) + 176 >> 2] | 0, i31 | 0) | 0) << 1;
  HEAP32[i8 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i31, i8);
  i31 = i27 + 60 | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i31, mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 184 >> 2] | 0, i32 | 0) | 0, i9);
  i32 = i27 + 72 | 0;
  i33 = HEAP32[i26 >> 2] | 0;
  i33 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 192 >> 2] | 0, i33 | 0) | 0;
  HEAP32[i10 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i32, i33, i10);
  i33 = i27 + 84 | 0;
  i10 = HEAP32[i26 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i33, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 204 >> 2] | 0, i10 | 0) | 0, i11);
  __ZNK5physx2Sc9ClothCore16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES4_PNS_24PxClothCollisionTriangleE(i24, HEAP32[i12 >> 2] | 0, HEAP32[i30 >> 2] | 0, HEAP32[i31 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0);
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 268 >> 2] | 0, i33 | 0) | 0) {
  i1 = i27 + 96 | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 268 >> 2] | 0, i3 | 0) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i3, i4);
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 268 >> 2] | 0, i3 | 0) | 0;
  if (i3 | 0) {
   i32 = HEAP32[i26 >> 2] | 0;
   i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 16 >> 2] | 0, i32 | 0) | 0;
   i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 32 >> 2] | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i25 + 4 >> 2] = i1 + (i3 << 4);
   HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   mftCall_viii(i31 | 0, i32 | 0, i33 | 0, i15 | 0);
  }
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 300 >> 2] | 0, i33 | 0) | 0) {
  i1 = i27 + 108 | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 300 >> 2] | 0, i3 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i3, i13);
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 300 >> 2] | 0, i3 | 0) | 0;
  if (i3 | 0) {
   i32 = HEAP32[i26 >> 2] | 0;
   i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 16 >> 2] | 0, i32 | 0) | 0;
   i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i25 + 4 >> 2] = i1 + (i3 << 4);
   HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   mftCall_viii(i31 | 0, i32 | 0, i33 | 0, i15 | 0);
  }
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 316 >> 2] | 0, i33 | 0) | 0) {
  i1 = i27 + 120 | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 316 >> 2] | 0, i3 | 0) | 0, i14);
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 316 >> 2] | 0, i3 | 0) | 0;
  if (i3 | 0) {
   i32 = HEAP32[i26 >> 2] | 0;
   i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 16 >> 2] | 0, i32 | 0) | 0;
   i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 40 >> 2] | 0;
   i33 = HEAP32[i26 >> 2] | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i25 + 4 >> 2] = i1 + (i3 << 4);
   HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   mftCall_viii(i31 | 0, i32 | 0, i33 | 0, i15 | 0);
  }
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 340 >> 2] | 0, i33 | 0) | 0) {
  i30 = i27 + 132 | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 340 >> 2] | 0, i32 | 0) | 0;
  HEAP32[i16 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i30, i32, i16);
  i16 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i26 >> 2] | 0;
  i30 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 340 >> 2] | 0, i30 | 0) | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 16 >> 2] | 0, i32 | 0) | 0;
  i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 48 >> 2] | 0;
  i33 = HEAP32[i26 >> 2] | 0;
  HEAP32[i25 >> 2] = i16;
  HEAP32[i25 + 4 >> 2] = i16 + (i30 << 2);
  HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  mftCall_viii(i31 | 0, i32 | 0, i33 | 0, i15 | 0);
 }
 i33 = HEAP32[i26 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 348 >> 2] | 0, i33 | 0) | 0) {
  i30 = i27 + 144 | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 348 >> 2] | 0, i32 | 0) | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i30, i32, i17);
  i17 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i26 >> 2] | 0;
  i30 = mftCall_ii(HEAP32[(HEAP32[i30 >> 2] | 0) + 348 >> 2] | 0, i30 | 0) | 0;
  i32 = HEAP32[i26 >> 2] | 0;
  i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 16 >> 2] | 0, i32 | 0) | 0;
  i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 52 >> 2] | 0;
  i33 = HEAP32[i26 >> 2] | 0;
  HEAP32[i25 >> 2] = i17;
  HEAP32[i25 + 4 >> 2] = i17 + (i30 << 4);
  HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  mftCall_viii(i31 | 0, i32 | 0, i33 | 0, i15 | 0);
 }
 i25 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 156 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i25 >> 2] | 0) + 248 >> 2] | 0, i25 | 0));
 i25 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 160 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i25 >> 2] | 0) + 256 >> 2] | 0, i25 | 0));
 i25 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i25 >> 2] | 0) + 276 >> 2] | 0, i25 | 0));
 i25 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 168 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i25 >> 2] | 0) + 280 >> 2] | 0, i25 | 0));
 i25 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 172 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i25 >> 2] | 0) + 288 >> 2] | 0, i25 | 0));
 i25 = HEAP32[i24 + 20 >> 2] | 0;
 i3 = HEAP32[i24 + 24 >> 2] | 0;
 HEAP32[i27 + 176 >> 2] = HEAP32[i24 + 16 >> 2];
 HEAP32[i27 + 180 >> 2] = i25;
 HEAP32[i27 + 184 >> 2] = i3;
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i18 | 0, i3 | 0);
 HEAP32[i27 + 188 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i27 + 192 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i27 + 196 >> 2] = HEAP32[i18 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 200 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 228 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 204 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 216 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i19 | 0, i3 | 0);
 HEAP32[i27 + 208 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i27 + 212 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i27 + 216 >> 2] = HEAP32[i19 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i20 | 0, i3 | 0);
 HEAP32[i27 + 220 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i27 + 224 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i27 + 228 >> 2] = HEAP32[i20 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i21 | 0, i3 | 0);
 HEAP32[i27 + 232 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i27 + 236 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i27 + 240 >> 2] = HEAP32[i21 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i22 | 0, i3 | 0);
 HEAP32[i27 + 244 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i27 + 248 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i27 + 252 >> 2] = HEAP32[i22 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i23 | 0, i3 | 0);
 HEAP32[i27 + 256 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i27 + 260 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i27 + 264 >> 2] = HEAP32[i23 + 8 >> 2];
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 268 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 272 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 276 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 324 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 280 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 332 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0) | 0;
 i24 = HEAP32[i26 >> 2] | 0;
 i24 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 64 >> 2] | 0, i24 | 0) | 0;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i30 = HEAP32[i24 + 8 >> 2] | 0;
 i31 = HEAP32[i24 + 12 >> 2] | 0;
 i32 = HEAP32[i3 >> 2] | 0;
 i33 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i27 + 284 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i27 + 288 >> 2] = i25;
 HEAP32[i27 + 292 >> 2] = i30;
 HEAP32[i27 + 296 >> 2] = i31;
 HEAP32[i27 + 300 >> 2] = i32;
 HEAP32[i27 + 304 >> 2] = i33;
 HEAP32[i27 + 308 >> 2] = i3;
 i3 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i27 + 312 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 364 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i26 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 372 >> 2] | 0, i3 | 0) | 0;
 if ((i3 | 0) == -1) f2 = Math_fround(3402823469999999843913219.0e14); else {
  i4 = HEAP32[i26 >> 2] | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 380 >> 2] | 0, i4 | 0) | 0;
  i1 = HEAP32[i26 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0) | 0;
  if (i4 >>> 0 > i1 >>> 0) f2 = Math_fround(Math_fround((Math_imul(i4 - i1 | 0, i3) | 0) >>> 0) / Math_fround(1.0e3)); else f2 = Math_fround(0.0);
 }
 HEAPF32[i27 + 316 >> 2] = f2;
 i3 = HEAP32[i28 + 20 >> 2] | 0;
 i33 = HEAP32[i28 + 24 >> 2] | 0;
 i1 = (HEAP32[i28 + 8 >> 2] | 0) + (i33 >> 1) | 0;
 if (!(i33 & 1)) {
  i33 = i3;
  mftCall_vi(i33 | 0, i1 | 0);
  STACKTOP = i29;
  return;
 } else {
  i33 = HEAP32[(HEAP32[i1 >> 2] | 0) + i3 >> 2] | 0;
  mftCall_vi(i33 | 0, i1 | 0);
  STACKTOP = i29;
  return;
 }
}

function __ZNK5physx36PxVehicleSuspensionDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 36 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj587ENS_22PxRepXPropertyAccessorILj587ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 52 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj588ENS_22PxRepXPropertyAccessorILj588ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 68 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj589ENS_22PxRepXPropertyAccessorILj589ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 84 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj590ENS_22PxRepXPropertyAccessorILj590ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 100 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj591ENS_22PxRepXPropertyAccessorILj591ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj592ENS_22PxRepXPropertyAccessorILj592ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj593ENS_22PxRepXPropertyAccessorILj593ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 do if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0) break;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj594ENS_22PxRepXPropertyAccessorILj594ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 11 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 11 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE(i40, i41, i1, i27, i24, i28, i29, f26, i43, i36, i32, i39, i31, i46) {
 i40 = i40 | 0;
 i41 = i41 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i24 = i24 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 f26 = Math_fround(f26);
 i43 = i43 | 0;
 i36 = i36 | 0;
 i32 = i32 | 0;
 i39 = i39 | 0;
 i31 = i31 | 0;
 i46 = i46 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i25 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i42 = 0, i44 = 0, i45 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 5808 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i47 + 5616 | 0;
 i33 = i47 + 5536 | 0;
 i34 = i47 + 5504 | 0;
 i45 = i47 + 5472 | 0;
 i15 = i47 + 5552 | 0;
 i35 = i47 + 5456 | 0;
 i16 = i47;
 i30 = i47 + 5752 | 0;
 i38 = i47 + 5692 | 0;
 i37 = i47 + 5680 | 0;
 i44 = i47 + 5664 | 0;
 i42 = i47 + 16 | 0;
 i10 = HEAP32[i28 >> 2] | 0;
 i9 = HEAP32[i28 + 4 >> 2] | 0;
 i7 = HEAP32[i28 + 8 >> 2] | 0;
 i6 = HEAP32[i28 + 12 >> 2] | 0;
 i14 = i28 + 16 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = HEAP32[i14 + 4 >> 2] | 0;
 i14 = HEAP32[i14 + 8 >> 2] | 0;
 i60 = HEAP32[i29 >> 2] | 0;
 i59 = HEAP32[i29 + 4 >> 2] | 0;
 i2 = HEAP32[i29 + 8 >> 2] | 0;
 i3 = HEAP32[i29 + 12 >> 2] | 0;
 i11 = i29 + 16 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i11 = HEAP32[i11 + 8 >> 2] | 0;
 HEAPF32[i33 >> 2] = f26;
 HEAP32[i34 >> 2] = i10;
 HEAP32[i34 + 4 >> 2] = i9;
 HEAP32[i34 + 8 >> 2] = i7;
 HEAP32[i34 + 12 >> 2] = i6;
 HEAP32[i34 + 16 >> 2] = i4;
 HEAP32[i34 + 20 >> 2] = i5;
 HEAP32[i34 + 24 >> 2] = i14;
 HEAPF32[i34 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i45 >> 2] = i60;
 HEAP32[i45 + 4 >> 2] = i59;
 HEAP32[i45 + 8 >> 2] = i2;
 HEAP32[i45 + 12 >> 2] = i3;
 HEAP32[i45 + 16 >> 2] = i13;
 HEAP32[i45 + 20 >> 2] = i12;
 HEAP32[i45 + 24 >> 2] = i11;
 HEAPF32[i45 + 28 >> 2] = Math_fround(0.0);
 f49 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f56 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = Math_fround(-f49);
 f56 = Math_fround(-f56);
 f20 = Math_fround(-f20);
 f23 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f55 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f58 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f55 = Math_fround(f23 - f55);
 f58 = Math_fround(f8 - f58);
 f54 = Math_fround(f54 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(Math_fround(f52 * f52) + Math_fround(-.5));
 f23 = Math_fround(Math_fround(Math_fround(f55 * f49) + Math_fround(f58 * f56)) + Math_fround(f54 * f20));
 f21 = Math_fround(Math_fround(Math_fround(f23 * f49) + Math_fround(Math_fround(f8 * f55) + Math_fround(f52 * Math_fround(Math_fround(f54 * f56) - Math_fround(f58 * f20))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(f23 * f56) + Math_fround(Math_fround(f8 * f58) + Math_fround(f52 * Math_fround(Math_fround(f55 * f20) - Math_fround(f54 * f49))))) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f54) + Math_fround(f52 * Math_fround(Math_fround(f58 * f49) - Math_fround(f55 * f56)))) + Math_fround(f23 * f20)) * Math_fround(2.0));
 f55 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f58 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f54 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(Math_fround(f52 * f8) - Math_fround(Math_fround(Math_fround(f55 * f49) + Math_fround(f58 * f56)) + Math_fround(f54 * f20)));
 f18 = Math_fround(Math_fround(Math_fround(f54 * f56) - Math_fround(f58 * f20)) + Math_fround(Math_fround(f52 * f55) + Math_fround(f8 * f49)));
 f19 = Math_fround(Math_fround(Math_fround(f55 * f20) - Math_fround(f54 * f49)) + Math_fround(Math_fround(f52 * f58) + Math_fround(f8 * f56)));
 f20 = Math_fround(Math_fround(Math_fround(f58 * f49) - Math_fround(f55 * f56)) + Math_fround(Math_fround(f52 * f54) + Math_fround(f8 * f20)));
 HEAPF32[i15 + 48 >> 2] = f21;
 HEAPF32[i15 + 52 >> 2] = f22;
 HEAPF32[i15 + 56 >> 2] = f23;
 HEAPF32[i15 + 60 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f18 + f18);
 f54 = Math_fround(f19 + f19);
 f52 = Math_fround(f20 + f20);
 f56 = Math_fround(f19 * f54);
 f55 = Math_fround(f20 * f52);
 f49 = Math_fround(f19 * f8);
 f58 = Math_fround(f20 * f8);
 f51 = Math_fround(f17 * f8);
 f57 = Math_fround(f20 * f54);
 f54 = Math_fround(f17 * f54);
 f52 = Math_fround(f17 * f52);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f8));
 f50 = Math_fround(f49 + f52);
 f53 = Math_fround(f58 - f54);
 f52 = Math_fround(f49 - f52);
 f49 = Math_fround(f8 - f55);
 f48 = Math_fround(f57 + f51);
 f54 = Math_fround(f58 + f54);
 f51 = Math_fround(f57 - f51);
 f8 = Math_fround(f8 - f56);
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f56) - f55);
 HEAPF32[i15 + 4 >> 2] = f50;
 HEAPF32[i15 + 8 >> 2] = f53;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 16 >> 2] = f52;
 HEAPF32[i15 + 20 >> 2] = f49;
 HEAPF32[i15 + 24 >> 2] = f48;
 HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 32 >> 2] = f54;
 HEAPF32[i15 + 36 >> 2] = f51;
 HEAPF32[i15 + 40 >> 2] = f8;
 HEAPF32[i15 + 44 >> 2] = Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i35 >> 2] = Math_fround(f8 * Math_fround(.0500000007));
 i6 = i46 + 53 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 f51 = Math_fround(f8 * Math_fround(.200000003));
 i9 = i46 + 16 | 0;
 f54 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i46 + 20 | 0;
 f48 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i46 + 24 | 0;
 f54 = Math_fround(f21 - f54);
 f48 = Math_fround(f22 - f48);
 f49 = Math_fround(f23 - Math_fround(HEAPF32[i11 >> 2]));
 f52 = Math_fround(-f54);
 f53 = Math_fround(-f48);
 f50 = Math_fround(-f49);
 f52 = f54 > f52 ? f54 : f52;
 f53 = f48 > f53 ? f48 : f53;
 f53 = f52 >= f53 ? f52 : f53;
 i12 = (f49 > f50 ? f49 : f50) >= Math_fround(0.0);
 f52 = i12 ? f52 : Math_fround(0.0);
 f50 = Math_fround(HEAPF32[i46 >> 2]);
 i12 = i46 + 4 | 0;
 f49 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i46 + 8 | 0;
 f48 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i46 + 12 | 0;
 if ((f53 >= f52 ? f53 : f52) > f51 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f18 * f50) + Math_fround(f19 * f49)) + Math_fround(f20 * f48)) + Math_fround(f17 * Math_fround(HEAPF32[i14 >> 2]))) < Math_fround(.999800026)) i1 = i46 + 52 | 0; else {
  HEAPF32[i16 >> 2] = Math_fround(f8 * Math_fround(.800000011));
  i1 = i46 + 52 | 0;
  i60 = HEAP8[i1 >> 0] | 0;
  if (!(i60 << 24 >> 24)) {
   i60 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i46, i43, i45) | 0;
   STACKTOP = i47;
   return i60 | 0;
  }
  i2 = 0;
  do {
   i3 = i46 + 48 + i2 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   i5 = i4 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i25, i46 + 64 + (i5 * 400 | 0) | 0, i15, i16, i33);
   if (!(HEAP32[i46 + 64 + (i5 * 400 | 0) + 384 >> 2] | 0)) {
    i59 = (HEAP8[i1 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i1 >> 0] = i59;
    i59 = (i59 & 255) + (i46 + 48) | 0;
    i60 = HEAP8[i59 >> 0] | 0;
    HEAP8[i59 >> 0] = i4;
    HEAP8[i3 >> 0] = i60;
    i2 = i2 + -1 | 0;
   } else HEAP32[i46 + 32 + (i5 << 2) >> 2] = HEAP32[i25 >> 2];
   i2 = i2 + 1 | 0;
   i60 = HEAPU8[i1 >> 0] | 0;
  } while (i2 >>> 0 < i60 >>> 0);
  if ((HEAP8[i6 >> 0] | 0) == i7 << 24 >> 24) {
   i60 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i46, i43, i45) | 0;
   STACKTOP = i47;
   return i60 | 0;
  }
 }
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i46 >> 2] = f18;
 HEAPF32[i12 >> 2] = f19;
 HEAPF32[i13 >> 2] = f20;
 HEAPF32[i14 >> 2] = f17;
 HEAPF32[i9 >> 2] = f21;
 HEAPF32[i10 >> 2] = f22;
 HEAPF32[i11 >> 2] = f23;
 HEAPF32[i46 + 28 >> 2] = Math_fround(0.0);
 i2 = HEAP32[i24 + 40 >> 2] | 0;
 f52 = Math_fround(HEAPF32[i28 >> 2]);
 f57 = Math_fround(f52 + f52);
 f58 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f53 = Math_fround(f58 + f58);
 f50 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f51 = Math_fround(f50 + f50);
 f56 = Math_fround(HEAPF32[i28 + 12 >> 2]);
 f55 = Math_fround(f57 * f56);
 f49 = Math_fround(f53 * f56);
 f56 = Math_fround(f56 * f51);
 f57 = Math_fround(f52 * f57);
 f54 = Math_fround(f52 * f53);
 f52 = Math_fround(f52 * f51);
 f53 = Math_fround(f58 * f53);
 f58 = Math_fround(f58 * f51);
 f51 = Math_fround(f50 * f51);
 HEAPF32[i25 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f53) - f51);
 HEAPF32[i25 + 4 >> 2] = Math_fround(f54 + f56);
 HEAPF32[i25 + 8 >> 2] = Math_fround(f52 - f49);
 HEAPF32[i25 + 12 >> 2] = Math_fround(f54 - f56);
 f57 = Math_fround(Math_fround(1.0) - f57);
 HEAPF32[i25 + 16 >> 2] = Math_fround(f57 - f51);
 HEAPF32[i25 + 20 >> 2] = Math_fround(f58 + f55);
 HEAPF32[i25 + 24 >> 2] = Math_fround(f52 + f49);
 HEAPF32[i25 + 28 >> 2] = Math_fround(f58 - f55);
 HEAPF32[i25 + 32 >> 2] = Math_fround(f57 - f53);
 HEAP32[i25 + 36 >> 2] = HEAP32[i28 + 16 >> 2];
 HEAP32[i25 + 40 >> 2] = HEAP32[i28 + 20 >> 2];
 HEAP32[i25 + 44 >> 2] = HEAP32[i28 + 24 >> 2];
 f53 = Math_fround(HEAPF32[i29 >> 2]);
 f57 = Math_fround(f53 + f53);
 f55 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f58 = Math_fround(f55 + f55);
 f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 f52 = Math_fround(f49 + f49);
 f51 = Math_fround(HEAPF32[i29 + 12 >> 2]);
 f56 = Math_fround(f57 * f51);
 f54 = Math_fround(f58 * f51);
 f51 = Math_fround(f51 * f52);
 f57 = Math_fround(f53 * f57);
 f50 = Math_fround(f53 * f58);
 f53 = Math_fround(f53 * f52);
 f58 = Math_fround(f55 * f58);
 f55 = Math_fround(f55 * f52);
 f52 = Math_fround(f49 * f52);
 HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f58) - f52);
 HEAPF32[i30 + 4 >> 2] = Math_fround(f50 + f51);
 HEAPF32[i30 + 8 >> 2] = Math_fround(f53 - f54);
 HEAPF32[i30 + 12 >> 2] = Math_fround(f50 - f51);
 f57 = Math_fround(Math_fround(1.0) - f57);
 HEAPF32[i30 + 16 >> 2] = Math_fround(f57 - f52);
 HEAPF32[i30 + 20 >> 2] = Math_fround(f55 + f56);
 HEAPF32[i30 + 24 >> 2] = Math_fround(f53 + f54);
 HEAPF32[i30 + 28 >> 2] = Math_fround(f55 - f56);
 HEAPF32[i30 + 32 >> 2] = Math_fround(f57 - f58);
 HEAP32[i30 + 36 >> 2] = HEAP32[i29 + 16 >> 2];
 HEAP32[i30 + 40 >> 2] = HEAP32[i29 + 20 >> 2];
 HEAP32[i30 + 44 >> 2] = HEAP32[i29 + 24 >> 2];
 __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb(i38, i27, f26, i28, i25, i30, i32, i31);
 HEAP32[i37 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i37 + 4 >> 2] = i2 + 32;
 HEAP32[i37 + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 __ZN5physx2Gu9ContainerC2Ev(i44);
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 4352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i44, 1088, i1, 1);
 i7 = HEAP32[i2 + 152 >> 2] | 0;
 HEAP32[i42 + 4 >> 2] = 2;
 HEAP32[i42 + 8 >> 2] = i32;
 HEAP32[i42 + 12 >> 2] = i7;
 HEAP8[i42 + 16 >> 0] = i31 & 1;
 i7 = i42 + 868 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i42 >> 2] = gb + 105412 + 8;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i42 + 880 | 0, i33, i35, i34, i45, i46, i43);
 HEAP32[i42 + 4496 >> 2] = 0;
 i1 = i42 + 4368 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i42 + 5268 >> 2] = 0;
 i1 = i42 + 5140 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i42 + 5296 >> 2] = i44;
 HEAP32[i42 + 5300 >> 2] = i40;
 HEAP32[i42 + 5304 >> 2] = i41;
 HEAP32[i42 + 5308 >> 2] = i36;
 HEAP8[i42 + 5312 >> 0] = i39 & 1;
 f57 = Math_fround(HEAPF32[i40 >> 2]);
 f56 = Math_fround(HEAPF32[i40 + 4 >> 2]);
 f58 = Math_fround(HEAPF32[i40 + 8 >> 2]);
 f54 = Math_fround(HEAPF32[i42 + 3184 >> 2]);
 f55 = Math_fround(HEAPF32[i42 + 3188 >> 2]);
 f54 = Math_fround(f57 - f54);
 f55 = Math_fround(f56 - f55);
 f58 = Math_fround(f58 - Math_fround(HEAPF32[i42 + 3192 >> 2]));
 f56 = Math_fround(f54 * Math_fround(HEAPF32[i42 + 3136 >> 2]));
 f56 = Math_fround(f56 + Math_fround(f55 * Math_fround(HEAPF32[i42 + 3140 >> 2])));
 f56 = Math_fround(f56 + Math_fround(f58 * Math_fround(HEAPF32[i42 + 3144 >> 2])));
 f57 = Math_fround(f54 * Math_fround(HEAPF32[i42 + 3152 >> 2]));
 f57 = Math_fround(f57 + Math_fround(f55 * Math_fround(HEAPF32[i42 + 3156 >> 2])));
 f57 = Math_fround(f57 + Math_fround(f58 * Math_fround(HEAPF32[i42 + 3160 >> 2])));
 f54 = Math_fround(f54 * Math_fround(HEAPF32[i42 + 3168 >> 2]));
 f55 = Math_fround(f54 + Math_fround(f55 * Math_fround(HEAPF32[i42 + 3172 >> 2])));
 f58 = Math_fround(f55 + Math_fround(f58 * Math_fround(HEAPF32[i42 + 3176 >> 2])));
 HEAPF32[i42 + 5280 >> 2] = f56;
 HEAPF32[i42 + 5284 >> 2] = f57;
 HEAPF32[i42 + 5288 >> 2] = f58;
 HEAPF32[i42 + 5292 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu15OBBTriangleTestC2ERKNS0_3BoxE(i42 + 5328 | 0, i38);
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i38, 1, i37, i42, 1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i6 = i42 + 880 | 0;
  i2 = i42 + 852 | 0;
  i3 = i42 + 788 | 0;
  i4 = i42 + 596 | 0;
  i5 = i42 + 20 | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i6, i5, HEAP32[i3 >> 2] | 0, HEAP8[i2 >> 0] | 0, i4) | 0;
   if (!i1) break; else {
    i2 = i2 + 1 | 0;
    i3 = i3 + 4 | 0;
    i4 = i4 + 12 | 0;
    i5 = i5 + 36 | 0;
   }
  }
  HEAP32[i7 >> 2] = 0;
 }
 i60 = i42 + 880 | 0;
 __ZN5physx2Gu32PCMConvexVsMeshContactGeneration20generateLastContactsEv(i60);
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i60, 6, 0);
 __ZN5physx2Gu9ContainerD2Ev(i44);
 i60 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i46, i43, i45) | 0;
 STACKTOP = i47;
 return i60 | 0;
}

function __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i1, i2, i31) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i50;
 i34 = i50 + 12 | 0;
 i35 = i49 + 8 | 0;
 i36 = i34 + 8 | 0;
 i37 = i49 + 8 | 0;
 i38 = i34 + 8 | 0;
 i39 = i49 + 8 | 0;
 i40 = i34 + 8 | 0;
 i21 = i49 + 8 | 0;
 i22 = i34 + 8 | 0;
 i23 = i49 + 8 | 0;
 i24 = i34 + 8 | 0;
 i25 = i49 + 8 | 0;
 i26 = i34 + 8 | 0;
 i27 = i49 + 8 | 0;
 i28 = i34 + 8 | 0;
 i29 = i49 + 8 | 0;
 i30 = i34 + 8 | 0;
 i32 = i49 + 8 | 0;
 i33 = i34 + 8 | 0;
 L1 : while (1) {
  i19 = i2;
  i48 = i2 + -36 | 0;
  i20 = i2 + -4 | 0;
  i42 = i2 + -32 | 0;
  i43 = i2 + -28 | 0;
  i44 = i2 + -24 | 0;
  i45 = i2 + -20 | 0;
  i46 = i2 + -16 | 0;
  i47 = i2 + -12 | 0;
  while (1) {
   i15 = i1;
   L5 : while (1) {
    i14 = i15;
    i1 = i19 - i14 | 0;
    switch ((i1 | 0) / 36 | 0 | 0) {
    case 2:
     {
      i41 = 5;
      break L1;
     }
    case 3:
     {
      i41 = 7;
      break L1;
     }
    case 4:
     {
      i41 = 8;
      break L1;
     }
    case 5:
     {
      i41 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i41 = 46;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 252) {
     i41 = 11;
     break L1;
    }
    i3 = (i1 >>> 0) / 72 | 0;
    i11 = i15 + (i3 * 36 | 0) | 0;
    if ((i1 | 0) > 35964) {
     i1 = (i1 >>> 0) / 144 | 0;
     i1 = __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i15, i15 + (i1 * 36 | 0) | 0, i11, i11 + (i1 * 36 | 0) | 0, i48, i31) | 0;
    } else i1 = __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i15, i11, i48, i31) | 0;
    i12 = i15 + 32 | 0;
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i35 >> 2]);
    i4 = i15 + (i3 * 36 | 0) + 32 | 0;
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f51 > Math_fround(HEAPF32[i36 >> 2])) {
     i3 = i48;
     break;
    } else i10 = i48;
    while (1) {
     i3 = i10 + -36 | 0;
     if ((i15 | 0) == (i3 | 0)) break;
     __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i10 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f51 = Math_fround(HEAPF32[i37 >> 2]);
     __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f51 > Math_fround(HEAPF32[i38 >> 2])) {
      i41 = 29;
      break L5;
     } else i10 = i3;
    }
    i1 = i15 + 36 | 0;
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i39 >> 2]);
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (!(f51 > Math_fround(HEAPF32[i40 >> 2]))) {
     if ((i1 | 0) == (i48 | 0)) {
      i41 = 46;
      break L1;
     }
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i25 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 > Math_fround(HEAPF32[i26 >> 2])) break;
      i1 = i1 + 36 | 0;
      if ((i1 | 0) == (i48 | 0)) {
       i41 = 46;
       break L1;
      }
     }
     i3 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i5 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i1 + 12 >> 2] | 0;
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = HEAP32[i1 + 20 >> 2] | 0;
     i16 = i1 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i1;
     i17 = i48;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i48 >> 2] = i3;
     HEAP32[i42 >> 2] = i4;
     HEAP32[i43 >> 2] = i5;
     HEAP32[i44 >> 2] = i6;
     HEAP32[i45 >> 2] = i7;
     HEAP32[i46 >> 2] = i8;
     HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i1 = i1 + 36 | 0;
    }
    if ((i1 | 0) == (i48 | 0)) {
     i41 = 46;
     break L1;
    } else i3 = i48;
    while (1) {
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i21 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i11 = i1 + 36 | 0;
      if (f51 > Math_fround(HEAPF32[i22 >> 2])) break; else i1 = i11;
     }
     while (1) {
      i4 = i3 + -36 | 0;
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i23 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 > Math_fround(HEAPF32[i24 >> 2])) i3 = i4; else break;
     }
     if (i1 >>> 0 >= i4 >>> 0) {
      i15 = i1;
      continue L5;
     }
     i5 = HEAP32[i1 >> 2] | 0;
     i6 = HEAP32[i1 + 4 >> 2] | 0;
     i7 = HEAP32[i1 + 8 >> 2] | 0;
     i8 = HEAP32[i1 + 12 >> 2] | 0;
     i9 = HEAP32[i1 + 16 >> 2] | 0;
     i10 = HEAP32[i1 + 20 >> 2] | 0;
     i16 = i1 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i1;
     i17 = i4;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i4 >> 2] = i5;
     HEAP32[i3 + -32 >> 2] = i6;
     HEAP32[i3 + -28 >> 2] = i7;
     HEAP32[i3 + -24 >> 2] = i8;
     HEAP32[i3 + -20 >> 2] = i9;
     HEAP32[i3 + -16 >> 2] = i10;
     i3 = i3 + -12 | 0;
     HEAP32[i3 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i3 = i4;
     i1 = i11;
    }
   }
   if ((i41 | 0) == 29) {
    i41 = 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = HEAP32[i15 + 4 >> 2] | 0;
    i6 = HEAP32[i15 + 8 >> 2] | 0;
    i7 = HEAP32[i15 + 12 >> 2] | 0;
    i8 = HEAP32[i15 + 16 >> 2] | 0;
    i9 = HEAP32[i15 + 20 >> 2] | 0;
    i16 = i15 + 24 | 0;
    HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    i16 = i15;
    i17 = i3;
    i18 = i16 + 36 | 0;
    do {
     HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
     i16 = i16 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i16 | 0) < (i18 | 0));
    HEAP32[i3 >> 2] = i4;
    HEAP32[i10 + -32 >> 2] = i5;
    HEAP32[i10 + -28 >> 2] = i6;
    HEAP32[i10 + -24 >> 2] = i7;
    HEAP32[i10 + -20 >> 2] = i8;
    HEAP32[i10 + -16 >> 2] = i9;
    i18 = i10 + -12 | 0;
    HEAP32[i18 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   i4 = i15 + 36 | 0;
   L35 : do if (i4 >>> 0 < i3 >>> 0) {
    i13 = i11;
    while (1) {
     i5 = i13 + 32 | 0;
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i29 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i12 = i4 + 36 | 0;
      if (f51 > Math_fround(HEAPF32[i30 >> 2])) i4 = i12; else break;
     }
     while (1) {
      i11 = i3 + -36 | 0;
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i32 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 > Math_fround(HEAPF32[i33 >> 2])) break; else i3 = i11;
     }
     if (i4 >>> 0 > i11 >>> 0) {
      i10 = i13;
      break L35;
     }
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i4 + 4 >> 2] | 0;
     i7 = HEAP32[i4 + 8 >> 2] | 0;
     i8 = HEAP32[i4 + 12 >> 2] | 0;
     i9 = HEAP32[i4 + 16 >> 2] | 0;
     i10 = HEAP32[i4 + 20 >> 2] | 0;
     i16 = i4 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i4;
     i17 = i11;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i11 >> 2] = i5;
     HEAP32[i3 + -32 >> 2] = i6;
     HEAP32[i3 + -28 >> 2] = i7;
     HEAP32[i3 + -24 >> 2] = i8;
     HEAP32[i3 + -20 >> 2] = i9;
     HEAP32[i3 + -16 >> 2] = i10;
     i3 = i3 + -12 | 0;
     HEAP32[i3 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i13 = (i13 | 0) == (i4 | 0) ? i11 : i13;
     i3 = i11;
     i4 = i12;
     i1 = i1 + 1 | 0;
    }
   } else i10 = i11; while (0);
   if ((i4 | 0) != (i10 | 0)) {
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i10 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i27 >> 2]);
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f51 > Math_fround(HEAPF32[i28 >> 2])) {
     i3 = HEAP32[i4 >> 2] | 0;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i6 = HEAP32[i4 + 8 >> 2] | 0;
     i7 = HEAP32[i4 + 12 >> 2] | 0;
     i8 = HEAP32[i4 + 16 >> 2] | 0;
     i9 = HEAP32[i4 + 20 >> 2] | 0;
     i16 = i4 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i4;
     i17 = i10;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i3;
     HEAP32[i10 + 4 >> 2] = i5;
     HEAP32[i10 + 8 >> 2] = i6;
     HEAP32[i10 + 12 >> 2] = i7;
     HEAP32[i10 + 16 >> 2] = i8;
     HEAP32[i10 + 20 >> 2] = i9;
     i18 = i10 + 24 | 0;
     HEAP32[i18 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i15, i4, i31) | 0;
    i1 = i4 + 36 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i1, i2, i31) | 0) {
     i41 = 45;
     break;
    }
    if (i3) continue;
   }
   i18 = i4;
   if ((i18 - i14 | 0) >= (i19 - i18 | 0)) {
    i41 = 44;
    break;
   }
   __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i15, i4, i31);
   i1 = i4 + 36 | 0;
  }
  if ((i41 | 0) == 44) {
   i41 = 0;
   __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i4 + 36 | 0, i2, i31);
   i1 = i15;
   i2 = i4;
   continue;
  } else if ((i41 | 0) == 45) {
   i41 = 0;
   if (i3) {
    i41 = 46;
    break;
   } else {
    i1 = i15;
    i2 = i4;
    continue;
   }
  }
 }
 if ((i41 | 0) == 5) {
  __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f51 = Math_fround(HEAPF32[i49 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f51 > Math_fround(HEAPF32[i34 + 8 >> 2]))) {
   STACKTOP = i50;
   return;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  i3 = HEAP32[i15 + 8 >> 2] | 0;
  i4 = HEAP32[i15 + 12 >> 2] | 0;
  i5 = HEAP32[i15 + 16 >> 2] | 0;
  i6 = HEAP32[i15 + 20 >> 2] | 0;
  i16 = i15 + 24 | 0;
  HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i16 = i15;
  i17 = i48;
  i18 = i16 + 36 | 0;
  do {
   HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
   i16 = i16 + 4 | 0;
   i17 = i17 + 4 | 0;
  } while ((i16 | 0) < (i18 | 0));
  HEAP32[i48 >> 2] = i1;
  HEAP32[i42 >> 2] = i2;
  HEAP32[i43 >> 2] = i3;
  HEAP32[i44 >> 2] = i4;
  HEAP32[i45 >> 2] = i5;
  HEAP32[i46 >> 2] = i6;
  HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 7) {
  __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i15, i15 + 36 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 8) {
  __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i15, i15 + 36 | 0, i15 + 72 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 9) {
  __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i15, i15 + 36 | 0, i15 + 72 | 0, i15 + 108 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 11) {
  __ZNSt3__218__insertion_sort_3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i15, i2, i31);
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 46) {
  STACKTOP = i50;
  return;
 }
}

function __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf(i1, i2, i23, i3, i11, i5, f17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 f17 = Math_fround(f17);
 var f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0;
 i39 = i1 + 4 | 0;
 i39 = (HEAP32[i39 >> 2] | 0) + i39 | 0;
 i29 = HEAP32[i39 + (i3 << 3) >> 2] | 0;
 i39 = HEAP32[i39 + (i3 << 3) + 4 >> 2] | 0;
 if ((i39 | 0) == -1) return;
 i38 = i1 + 16 | 0;
 i38 = (HEAP32[i38 >> 2] | 0) + i38 | 0;
 i28 = i2 + 4 | 0;
 i28 = (HEAP32[i28 >> 2] | 0) + i28 | 0;
 f4 = Math_fround(HEAPF32[i28 + (i3 * 40 | 0) >> 2]);
 f6 = Math_fround(HEAPF32[i28 + (i3 * 40 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i28 + (i3 * 40 | 0) + 8 >> 2]);
 i35 = HEAP32[i28 + (i3 * 40 | 0) + 12 >> 2] | 0;
 i36 = HEAP32[i28 + (i3 * 40 | 0) + 16 >> 2] | 0;
 i37 = HEAP32[i28 + (i3 * 40 | 0) + 20 >> 2] | 0;
 f34 = Math_fround(HEAPF32[i28 + (i3 * 40 | 0) + 24 >> 2]);
 f14 = Math_fround(HEAPF32[i23 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i23 + 36 >> 2]);
 f15 = Math_fround(f15 * Math_fround(.0174532924));
 f33 = Math_fround(Math_fround(HEAPF32[i23 + 40 >> 2]) * Math_fround(.0174532924));
 HEAPF32[i38 + (i39 * 76 | 0) + 44 >> 2] = Math_fround(f14 * Math_fround(.0174532924));
 HEAPF32[i38 + (i39 * 76 | 0) + 48 >> 2] = f15;
 HEAPF32[i38 + (i39 * 76 | 0) + 52 >> 2] = f33;
 f33 = Math_fround(HEAPF32[i23 + 48 >> 2]);
 f15 = Math_fround(HEAPF32[i23 + 52 >> 2]);
 f15 = Math_fround(f15 * Math_fround(.0174532924));
 f14 = Math_fround(Math_fround(HEAPF32[i23 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[i38 + (i39 * 76 | 0) + 56 >> 2] = Math_fround(f33 * Math_fround(.0174532924));
 HEAPF32[i38 + (i39 * 76 | 0) + 60 >> 2] = f15;
 HEAPF32[i38 + (i39 * 76 | 0) + 64 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i23 + 64 >> 2]);
 i27 = HEAP32[i23 + 68 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i23 + 72 >> 2]);
 f33 = i5 ? Math_fround(1.0) : Math_fround(-1.0);
 f15 = Math_fround(f33 * f15);
 HEAPF32[i38 + (i39 * 76 | 0) + 32 >> 2] = Math_fround(f33 * f14);
 HEAP32[i38 + (i39 * 76 | 0) + 36 >> 2] = i27;
 HEAPF32[i38 + (i39 * 76 | 0) + 40 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i23 + 24 >> 2]);
 f30 = Math_fround(HEAPF32[i23 >> 2]);
 f31 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f33 = Math_fround(f33 * Math_fround(HEAPF32[i23 + 12 >> 2]));
 HEAP32[i38 + (i39 * 76 | 0) + 72 >> 2] = HEAP32[i23 + 80 >> 2];
 i27 = i38 + (i39 * 76 | 0) + 68 | 0;
 HEAPF32[i27 >> 2] = Math_fround(1.0);
 if ((i11 | 0) == -1) {
  i11 = 0;
  i19 = 0;
  i21 = 1065353216;
  i22 = 0;
  i20 = 1065353216;
  i2 = 0;
  i18 = 1065353216;
  i3 = 0;
  i24 = 0;
  f13 = Math_fround(1.0);
 } else {
  f12 = Math_fround(HEAPF32[i28 + (i11 * 40 | 0) >> 2]);
  f10 = Math_fround(HEAPF32[i28 + (i11 * 40 | 0) + 4 >> 2]);
  f12 = Math_fround(Math_fround(f12 - f4) * f17);
  f10 = Math_fround(Math_fround(f10 - f6) * f17);
  f4 = Math_fround(Math_fround(Math_fround(HEAPF32[i28 + (i11 * 40 | 0) + 8 >> 2]) - f7) * f17);
  f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f4 * f4) + Math_fround(0.0)))));
  f6 = Math_fround(Math_fround(f15 * f10) - Math_fround(f14 * f12));
  f7 = Math_fround(Math_fround(f14 * f4) - Math_fround(f16 * f10));
  f8 = Math_fround(Math_fround(f16 * f12) - Math_fround(f15 * f4));
  f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)))));
  if (f13 > Math_fround(1.0e-30) & f9 > Math_fround(1.0e-30)) {
   f40 = Math_fround(f12 / f13);
   f41 = Math_fround(f10 / f13);
   f4 = Math_fround(f4 / f13);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   i24 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = Math_fround(f7 / f9);
   f8 = Math_fround(f8 / f9);
   f10 = Math_fround(f6 / f9);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   f12 = Math_fround(Math_fround(f40 * f8) - Math_fround(f41 * f7));
   f9 = Math_fround(Math_fround(f41 * f10) - Math_fround(f4 * f8));
   f10 = Math_fround(Math_fround(f4 * f7) - Math_fround(f40 * f10));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   HEAPF32[i27 >> 2] = f13;
  } else {
   i11 = 0;
   i19 = 0;
   i21 = 1065353216;
   i22 = 0;
   i20 = 1065353216;
   i2 = 0;
   i18 = 1065353216;
   i3 = 0;
   i24 = 0;
   f13 = Math_fround(1.0);
  }
 }
 switch (HEAP32[i23 + 84 >> 2] | 0) {
 case 0:
  {
   i5 = i21;
   i25 = i22;
   i1 = i24;
   break;
  }
 case 1:
  {
   i5 = 1065353216;
   i1 = 0;
   i23 = 0;
   i26 = 11;
   break;
  }
 case -1:
  {
   i5 = -1082130432;
   i1 = 0;
   i23 = 0;
   i26 = 11;
   break;
  }
 case 2:
  {
   i5 = 0;
   i1 = 1065353216;
   i23 = 0;
   i26 = 11;
   break;
  }
 case -2:
  {
   i5 = 0;
   i1 = -1082130432;
   i23 = 0;
   i26 = 11;
   break;
  }
 case 3:
  {
   i5 = 0;
   i1 = 0;
   i23 = 1065353216;
   i26 = 11;
   break;
  }
 default:
  {
   i5 = 0;
   i1 = 0;
   i23 = -1082130432;
   i26 = 11;
  }
 }
 if ((i26 | 0) == 11) {
  f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = Math_fround(Math_fround(f15 * f9) - Math_fround(f14 * f8));
  f7 = Math_fround(Math_fround(f14 * f10) - Math_fround(f16 * f9));
  f4 = Math_fround(Math_fround(f16 * f8) - Math_fround(f15 * f10));
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(0.0)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)))));
  if (f6 > Math_fround(1.0e-30)) {
   f15 = Math_fround(f7 / f6);
   f16 = Math_fround(f4 / f6);
   f40 = Math_fround(f12 / f6);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i20 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   f41 = Math_fround(Math_fround(f8 * f16) - Math_fround(f9 * f15));
   f16 = Math_fround(Math_fround(f9 * f40) - Math_fround(f10 * f16));
   f40 = Math_fround(Math_fround(f10 * f15) - Math_fround(f8 * f40));
   i19 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = i23;
  } else {
   i5 = i21;
   i25 = i22;
   i1 = i24;
  }
 }
 HEAPF32[i27 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f17))) * f13);
 i21 = (i29 | 0) != -1;
 i22 = HEAP32[i28 + (i29 * 40 | 0) + 12 >> 2] | 0;
 i23 = HEAP32[i28 + (i29 * 40 | 0) + 16 >> 2] | 0;
 i24 = HEAP32[i28 + (i29 * 40 | 0) + 20 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i28 + (i29 * 40 | 0) + 24 >> 2]);
 f16 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (!(f16 >= Math_fround(0.0))) {
  f4 = Math_fround(f6 - f4);
  if (!(f4 >= Math_fround(0.0))) {
   f7 = Math_fround(f10 + f14);
   f8 = Math_fround(Math_fround(Math_fround(1.0) - f16) - f4);
   f6 = Math_fround(f15 - f13);
   f4 = Math_fround(f12 + f9);
   break;
  } else {
   f7 = Math_fround(f13 + f15);
   f8 = Math_fround(f12 + f9);
   f6 = Math_fround(f10 - f14);
   f4 = Math_fround(f4 + Math_fround(Math_fround(1.0) - f16));
   break;
  }
 } else {
  f4 = Math_fround(f6 + f4);
  if (!(f4 >= Math_fround(0.0))) {
   f7 = Math_fround(Math_fround(f16 + Math_fround(1.0)) - f4);
   f8 = Math_fround(f10 + f14);
   f6 = Math_fround(f12 - f9);
   f4 = Math_fround(f13 + f15);
   break;
  } else {
   f7 = Math_fround(f12 - f9);
   f8 = Math_fround(f15 - f13);
   f6 = Math_fround(f4 + Math_fround(f16 + Math_fround(1.0)));
   f4 = Math_fround(f10 - f14);
   break;
  }
 } while (0);
 f41 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f8 * f8) + Math_fround(f6 * f6))))));
 f15 = Math_fround(f7 * f41);
 f14 = Math_fround(f4 * f41);
 f13 = Math_fround(f8 * f41);
 f41 = Math_fround(f6 * f41);
 i26 = i38 + (i39 * 76 | 0) | 0;
 HEAPF32[i26 >> 2] = f15;
 i27 = i38 + (i39 * 76 | 0) + 4 | 0;
 HEAPF32[i27 >> 2] = f14;
 i28 = i38 + (i39 * 76 | 0) + 8 | 0;
 HEAPF32[i28 >> 2] = f13;
 i29 = i38 + (i39 * 76 | 0) + 12 | 0;
 HEAPF32[i29 >> 2] = f41;
 f12 = (HEAP32[tempDoublePtr >> 2] = i36 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f12 * f15);
 f9 = Math_fround(f34 * f41);
 f40 = (HEAP32[tempDoublePtr >> 2] = i37 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f40 * f14);
 f8 = (HEAP32[tempDoublePtr >> 2] = i35 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f34 * f13)) - Math_fround(f40 * f41)) - Math_fround(f8 * f14));
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f8 * f15)) - Math_fround(f40 * f13)) - Math_fround(f12 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f12 * f13)) - Math_fround(f34 * f15)) - Math_fround(f8 * f41));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f13) - Math_fround(f40 * f15)) - Math_fround(f34 * f14)) - Math_fround(f12 * f41));
 i37 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i36 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f12 = (HEAP32[tempDoublePtr >> 2] = i35 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f12 * f12);
 f16 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f16 * f16);
 f40 = (HEAP32[tempDoublePtr >> 2] = i37 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f34 + f10) + Math_fround(Math_fround(f9 * f9) + Math_fround(f40 * f40))))));
 f16 = Math_fround(f10 * f16);
 f40 = Math_fround(f10 * f40);
 f34 = Math_fround(f10 * f9);
 HEAPF32[i38 + (i39 * 76 | 0) + 16 >> 2] = Math_fround(f10 * f12);
 HEAPF32[i38 + (i39 * 76 | 0) + 20 >> 2] = f16;
 HEAPF32[i38 + (i39 * 76 | 0) + 24 >> 2] = f40;
 HEAPF32[i38 + (i39 * 76 | 0) + 28 >> 2] = f34;
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f15) - Math_fround(f33 * f13)) - Math_fround(f32 * f41)) - Math_fround(f30 * f14));
 f40 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f41) - Math_fround(f30 * f15)) - Math_fround(f32 * f13)) - Math_fround(f31 * f14));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f14) - Math_fround(f31 * f13)) - Math_fround(f33 * f15)) - Math_fround(f30 * f41));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f13) - Math_fround(f32 * f15)) - Math_fround(f33 * f14)) - Math_fround(f31 * f41));
 i39 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
 i38 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i37 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f33 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = i21 ? f33 : Math_fround(-0.0);
 f16 = (HEAP32[tempDoublePtr >> 2] = i38 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f33 * f16);
 f30 = i21 ? f17 : Math_fround(1.0);
 f41 = Math_fround(f30 * f40);
 f17 = (HEAP32[tempDoublePtr >> 2] = i24 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = i21 ? f17 : Math_fround(-0.0);
 f32 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f17 * f32);
 f14 = (HEAP32[tempDoublePtr >> 2] = i22 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = i21 ? f14 : Math_fround(-0.0);
 f15 = (HEAP32[tempDoublePtr >> 2] = i39 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(Math_fround(Math_fround(f34 - Math_fround(f30 * f15)) - Math_fround(f17 * f40)) - Math_fround(f14 * f32));
 f41 = Math_fround(Math_fround(Math_fround(f41 - Math_fround(f14 * f16)) - Math_fround(f17 * f15)) - Math_fround(f33 * f32));
 f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f33 * f15)) - Math_fround(f30 * f16)) - Math_fround(f14 * f40));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f17 * f16)) - Math_fround(f30 * f32)) - Math_fround(f33 * f40));
 i39 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
 i37 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i38 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f33 = (HEAP32[tempDoublePtr >> 2] = i37 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f33 * f33);
 f34 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(f34 * f34);
 f40 = (HEAP32[tempDoublePtr >> 2] = i39 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f31 + f32) + Math_fround(Math_fround(f41 * f41) + Math_fround(f40 * f40))))));
 f34 = Math_fround(f32 * f34);
 f40 = Math_fround(f32 * f40);
 f41 = Math_fround(f32 * f41);
 HEAPF32[i26 >> 2] = Math_fround(f32 * f33);
 HEAPF32[i27 >> 2] = f34;
 HEAPF32[i28 >> 2] = f40;
 HEAPF32[i29 >> 2] = f41;
 return;
}

function __ZN17AudioReverbFilter8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i4 = i6 + 44 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863992 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864003 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864010 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864019 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864033 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864045 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864060 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864079 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864093 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864107 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864119 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864129 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864143 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864152 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864166 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864185 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 171; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 171;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx2Sq16BucketPrunerCore7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE(i8, i7, i6) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 320 | 0;
 i5 = i9 + 464 | 0;
 i1 = i9 + 176 | 0;
 i2 = i9 + 144 | 0;
 i3 = i9;
 switch (HEAP32[HEAP32[i7 + 144 >> 2] >> 2] | 0) {
 case 3:
  {
   i1 = i7 + 120 | 0;
   if (Math_fround(Math_abs(Math_fround(HEAPF32[i7 + 68 >> 2]))) < Math_fround(.999998986)) {
    f16 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) * Math_fround(1.00999999));
    f14 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * Math_fround(1.00999999));
    f12 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) * Math_fround(1.00999999));
    i5 = HEAP32[i7 + 76 >> 2] | 0;
    i3 = HEAP32[i7 + 80 >> 2] | 0;
    HEAP32[i4 + 16 >> 2] = HEAP32[i7 + 72 >> 2];
    HEAP32[i4 + 20 >> 2] = i5;
    HEAP32[i4 + 24 >> 2] = i3;
    HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i4 >> 2] = f16;
    i3 = i4 + 4 | 0;
    HEAPF32[i3 >> 2] = f14;
    i5 = i4 + 8 | 0;
    HEAPF32[i5 >> 2] = f12;
    HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
    i28 = HEAP32[i7 + 84 >> 2] | 0;
    i27 = HEAP32[i7 + 96 >> 2] | 0;
    i26 = HEAP32[i7 + 108 >> 2] | 0;
    i25 = HEAP32[i7 + 88 >> 2] | 0;
    i24 = HEAP32[i7 + 100 >> 2] | 0;
    i23 = HEAP32[i7 + 112 >> 2] | 0;
    i22 = HEAP32[i7 + 92 >> 2] | 0;
    i2 = HEAP32[i7 + 104 >> 2] | 0;
    i7 = HEAP32[i7 + 116 >> 2] | 0;
    HEAP32[i4 + 32 >> 2] = i28;
    HEAP32[i4 + 36 >> 2] = i27;
    HEAP32[i4 + 40 >> 2] = i26;
    HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
    HEAP32[i4 + 48 >> 2] = i25;
    HEAP32[i4 + 52 >> 2] = i24;
    HEAP32[i4 + 56 >> 2] = i23;
    HEAPF32[i4 + 60 >> 2] = Math_fround(0.0);
    HEAP32[i4 + 64 >> 2] = i22;
    HEAP32[i4 + 68 >> 2] = i2;
    HEAP32[i4 + 72 >> 2] = i7;
    HEAPF32[i4 + 76 >> 2] = Math_fround(0.0);
    f12 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = Math_fround(-f12);
    f15 = Math_fround(-f14);
    f13 = Math_fround(-f16);
    f17 = Math_fround((f12 > f17 ? f12 : f17) + Math_fround(9.99999997e-07));
    f15 = Math_fround((f14 > f15 ? f14 : f15) + Math_fround(9.99999997e-07));
    f13 = Math_fround((f16 > f13 ? f16 : f13) + Math_fround(9.99999997e-07));
    f16 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(-f16);
    f20 = Math_fround(-f14);
    f11 = Math_fround(-f12);
    f21 = Math_fround((f16 > f21 ? f16 : f21) + Math_fround(9.99999997e-07));
    f20 = Math_fround((f14 > f20 ? f14 : f20) + Math_fround(9.99999997e-07));
    f11 = Math_fround((f12 > f11 ? f12 : f11) + Math_fround(9.99999997e-07));
    f12 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = Math_fround(-f12);
    f18 = Math_fround(-f14);
    f10 = Math_fround(-f16);
    f19 = Math_fround((f12 > f19 ? f12 : f19) + Math_fround(9.99999997e-07));
    f18 = Math_fround((f14 > f18 ? f14 : f18) + Math_fround(9.99999997e-07));
    f10 = Math_fround((f16 > f10 ? f16 : f10) + Math_fround(9.99999997e-07));
    HEAPF32[i4 + 80 >> 2] = f17;
    HEAPF32[i4 + 84 >> 2] = f15;
    HEAPF32[i4 + 88 >> 2] = f13;
    HEAPF32[i4 + 92 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + 96 >> 2] = f21;
    HEAPF32[i4 + 100 >> 2] = f20;
    HEAPF32[i4 + 104 >> 2] = f11;
    HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + 112 >> 2] = f19;
    HEAPF32[i4 + 116 >> 2] = f18;
    HEAPF32[i4 + 120 >> 2] = f10;
    HEAPF32[i4 + 124 >> 2] = Math_fround(0.0);
    f16 = Math_fround(HEAPF32[i4 >> 2]);
    f14 = Math_fround(HEAPF32[i3 >> 2]);
    f12 = Math_fround(HEAPF32[i5 >> 2]);
    f11 = Math_fround(Math_fround(Math_fround(f21 * f16) + Math_fround(f20 * f14)) + Math_fround(f11 * f12));
    f10 = Math_fround(Math_fround(Math_fround(f16 * f19) + Math_fround(f14 * f18)) + Math_fround(f12 * f10));
    HEAPF32[i4 + 128 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14)) + Math_fround(f13 * f12));
    HEAPF32[i4 + 132 >> 2] = f11;
    HEAPF32[i4 + 136 >> 2] = f10;
    HEAPF32[i4 + 140 >> 2] = Math_fround(0.0);
    i8 = __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i9 + 492 | 0, i8, i4, i6, i1) | 0;
    STACKTOP = i9;
    return i8 | 0;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 124 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 128 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 132 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 136 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 140 >> 2];
    i28 = __ZN28BucketPrunerOverlapTraversalI24BucketPrunerAABBAABBTestLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i9 + 491 | 0, i8, i5, i6, i1) | 0;
    STACKTOP = i9;
    return i28 | 0;
   }
  }
 case 2:
  {
   f15 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) * Math_fround(1.00999999));
   f17 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * Math_fround(1.00999999));
   f19 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) * Math_fround(1.00999999));
   i28 = HEAP32[i7 + 76 >> 2] | 0;
   i27 = HEAP32[i7 + 80 >> 2] | 0;
   HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 72 >> 2];
   HEAP32[i1 + 20 >> 2] = i28;
   HEAP32[i1 + 24 >> 2] = i27;
   HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
   HEAPF32[i1 >> 2] = f15;
   i27 = i1 + 4 | 0;
   HEAPF32[i27 >> 2] = f17;
   i28 = i1 + 8 | 0;
   HEAPF32[i28 >> 2] = f19;
   HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
   i2 = HEAP32[i7 + 84 >> 2] | 0;
   i3 = HEAP32[i7 + 96 >> 2] | 0;
   i4 = HEAP32[i7 + 108 >> 2] | 0;
   i5 = HEAP32[i7 + 88 >> 2] | 0;
   i22 = HEAP32[i7 + 100 >> 2] | 0;
   i23 = HEAP32[i7 + 112 >> 2] | 0;
   i24 = HEAP32[i7 + 92 >> 2] | 0;
   i25 = HEAP32[i7 + 104 >> 2] | 0;
   i26 = HEAP32[i7 + 116 >> 2] | 0;
   HEAP32[i1 + 32 >> 2] = i2;
   HEAP32[i1 + 36 >> 2] = i3;
   HEAP32[i1 + 40 >> 2] = i4;
   HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
   HEAP32[i1 + 48 >> 2] = i5;
   HEAP32[i1 + 52 >> 2] = i22;
   HEAP32[i1 + 56 >> 2] = i23;
   HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
   HEAP32[i1 + 64 >> 2] = i24;
   HEAP32[i1 + 68 >> 2] = i25;
   HEAP32[i1 + 72 >> 2] = i26;
   HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
   f19 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(-f19);
   f16 = Math_fround(-f17);
   f18 = Math_fround(-f15);
   f14 = Math_fround((f19 > f14 ? f19 : f14) + Math_fround(9.99999997e-07));
   f16 = Math_fround((f17 > f16 ? f17 : f16) + Math_fround(9.99999997e-07));
   f18 = Math_fround((f15 > f18 ? f15 : f18) + Math_fround(9.99999997e-07));
   f15 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = Math_fround(-f15);
   f11 = Math_fround(-f17);
   f20 = Math_fround(-f19);
   f10 = Math_fround((f15 > f10 ? f15 : f10) + Math_fround(9.99999997e-07));
   f11 = Math_fround((f17 > f11 ? f17 : f11) + Math_fround(9.99999997e-07));
   f20 = Math_fround((f19 > f20 ? f19 : f20) + Math_fround(9.99999997e-07));
   f19 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(-f19);
   f13 = Math_fround(-f17);
   f21 = Math_fround(-f15);
   f12 = Math_fround((f19 > f12 ? f19 : f12) + Math_fround(9.99999997e-07));
   f13 = Math_fround((f17 > f13 ? f17 : f13) + Math_fround(9.99999997e-07));
   f21 = Math_fround((f15 > f21 ? f15 : f21) + Math_fround(9.99999997e-07));
   HEAPF32[i1 + 80 >> 2] = f14;
   HEAPF32[i1 + 84 >> 2] = f16;
   HEAPF32[i1 + 88 >> 2] = f18;
   HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 96 >> 2] = f10;
   HEAPF32[i1 + 100 >> 2] = f11;
   HEAPF32[i1 + 104 >> 2] = f20;
   HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 112 >> 2] = f12;
   HEAPF32[i1 + 116 >> 2] = f13;
   HEAPF32[i1 + 120 >> 2] = f21;
   HEAPF32[i1 + 124 >> 2] = Math_fround(0.0);
   f15 = Math_fround(HEAPF32[i1 >> 2]);
   f17 = Math_fround(HEAPF32[i27 >> 2]);
   f19 = Math_fround(HEAPF32[i28 >> 2]);
   f20 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(f11 * f17)) + Math_fround(f20 * f19));
   f21 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(f17 * f13)) + Math_fround(f19 * f21));
   HEAPF32[i1 + 128 >> 2] = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(f16 * f17)) + Math_fround(f18 * f19));
   HEAPF32[i1 + 132 >> 2] = f20;
   HEAPF32[i1 + 136 >> 2] = f21;
   HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
   i28 = __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i9 + 490 | 0, i8, i1, i6, i7 + 120 | 0) | 0;
   STACKTOP = i9;
   return i28 | 0;
  }
 case 0:
  {
   i27 = HEAP32[i7 + 152 >> 2] | 0;
   i28 = HEAP32[i7 + 156 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i7 + 148 >> 2];
   HEAP32[i2 + 4 >> 2] = i27;
   HEAP32[i2 + 8 >> 2] = i28;
   HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
   f21 = Math_fround(HEAPF32[i7 + 160 >> 2]);
   HEAPF32[i2 + 16 >> 2] = Math_fround(f21 * f21);
   i28 = __ZN28BucketPrunerOverlapTraversalI19SphereAABBTest_SIMDLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i9 + 489 | 0, i8, i2, i6, i7 + 120 | 0) | 0;
   STACKTOP = i9;
   return i28 | 0;
  }
 case 4:
  {
   f15 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) * Math_fround(1.00999999));
   f17 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * Math_fround(1.00999999));
   f19 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) * Math_fround(1.00999999));
   i28 = HEAP32[i7 + 76 >> 2] | 0;
   i27 = HEAP32[i7 + 80 >> 2] | 0;
   HEAP32[i3 + 16 >> 2] = HEAP32[i7 + 72 >> 2];
   HEAP32[i3 + 20 >> 2] = i28;
   HEAP32[i3 + 24 >> 2] = i27;
   HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = f15;
   i27 = i3 + 4 | 0;
   HEAPF32[i27 >> 2] = f17;
   i28 = i3 + 8 | 0;
   HEAPF32[i28 >> 2] = f19;
   HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
   i1 = HEAP32[i7 + 84 >> 2] | 0;
   i2 = HEAP32[i7 + 96 >> 2] | 0;
   i4 = HEAP32[i7 + 108 >> 2] | 0;
   i5 = HEAP32[i7 + 88 >> 2] | 0;
   i22 = HEAP32[i7 + 100 >> 2] | 0;
   i23 = HEAP32[i7 + 112 >> 2] | 0;
   i24 = HEAP32[i7 + 92 >> 2] | 0;
   i25 = HEAP32[i7 + 104 >> 2] | 0;
   i26 = HEAP32[i7 + 116 >> 2] | 0;
   HEAP32[i3 + 32 >> 2] = i1;
   HEAP32[i3 + 36 >> 2] = i2;
   HEAP32[i3 + 40 >> 2] = i4;
   HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 48 >> 2] = i5;
   HEAP32[i3 + 52 >> 2] = i22;
   HEAP32[i3 + 56 >> 2] = i23;
   HEAPF32[i3 + 60 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 64 >> 2] = i24;
   HEAP32[i3 + 68 >> 2] = i25;
   HEAP32[i3 + 72 >> 2] = i26;
   HEAPF32[i3 + 76 >> 2] = Math_fround(0.0);
   f19 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(-f19);
   f16 = Math_fround(-f17);
   f18 = Math_fround(-f15);
   f14 = Math_fround((f19 > f14 ? f19 : f14) + Math_fround(9.99999997e-07));
   f16 = Math_fround((f17 > f16 ? f17 : f16) + Math_fround(9.99999997e-07));
   f18 = Math_fround((f15 > f18 ? f15 : f18) + Math_fround(9.99999997e-07));
   f15 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = Math_fround(-f15);
   f11 = Math_fround(-f17);
   f20 = Math_fround(-f19);
   f10 = Math_fround((f15 > f10 ? f15 : f10) + Math_fround(9.99999997e-07));
   f11 = Math_fround((f17 > f11 ? f17 : f11) + Math_fround(9.99999997e-07));
   f20 = Math_fround((f19 > f20 ? f19 : f20) + Math_fround(9.99999997e-07));
   f19 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(-f19);
   f13 = Math_fround(-f17);
   f21 = Math_fround(-f15);
   f12 = Math_fround((f19 > f12 ? f19 : f12) + Math_fround(9.99999997e-07));
   f13 = Math_fround((f17 > f13 ? f17 : f13) + Math_fround(9.99999997e-07));
   f21 = Math_fround((f15 > f21 ? f15 : f21) + Math_fround(9.99999997e-07));
   HEAPF32[i3 + 80 >> 2] = f14;
   HEAPF32[i3 + 84 >> 2] = f16;
   HEAPF32[i3 + 88 >> 2] = f18;
   HEAPF32[i3 + 92 >> 2] = Math_fround(0.0);
   HEAPF32[i3 + 96 >> 2] = f10;
   HEAPF32[i3 + 100 >> 2] = f11;
   HEAPF32[i3 + 104 >> 2] = f20;
   HEAPF32[i3 + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i3 + 112 >> 2] = f12;
   HEAPF32[i3 + 116 >> 2] = f13;
   HEAPF32[i3 + 120 >> 2] = f21;
   HEAPF32[i3 + 124 >> 2] = Math_fround(0.0);
   f15 = Math_fround(HEAPF32[i3 >> 2]);
   f17 = Math_fround(HEAPF32[i27 >> 2]);
   f19 = Math_fround(HEAPF32[i28 >> 2]);
   f20 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(f11 * f17)) + Math_fround(f20 * f19));
   f21 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(f17 * f13)) + Math_fround(f19 * f21));
   HEAPF32[i3 + 128 >> 2] = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(f16 * f17)) + Math_fround(f18 * f19));
   HEAPF32[i3 + 132 >> 2] = f20;
   HEAPF32[i3 + 136 >> 2] = f21;
   HEAPF32[i3 + 140 >> 2] = Math_fround(0.0);
   i28 = __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i9 + 488 | 0, i8, i3, i6, i7 + 120 | 0) | 0;
   STACKTOP = i9;
   return i28 | 0;
  }
 default:
  {
   i28 = 1;
   STACKTOP = i9;
   return i28 | 0;
  }
 }
 return 0;
}

function __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i1, i2, i31) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i50;
 i34 = i50 + 12 | 0;
 i35 = i49 + 8 | 0;
 i36 = i34 + 8 | 0;
 i37 = i49 + 8 | 0;
 i38 = i34 + 8 | 0;
 i39 = i49 + 8 | 0;
 i40 = i34 + 8 | 0;
 i21 = i49 + 8 | 0;
 i22 = i34 + 8 | 0;
 i23 = i49 + 8 | 0;
 i24 = i34 + 8 | 0;
 i25 = i49 + 8 | 0;
 i26 = i34 + 8 | 0;
 i27 = i49 + 8 | 0;
 i28 = i34 + 8 | 0;
 i29 = i49 + 8 | 0;
 i30 = i34 + 8 | 0;
 i32 = i49 + 8 | 0;
 i33 = i34 + 8 | 0;
 L1 : while (1) {
  i19 = i2;
  i48 = i2 + -36 | 0;
  i20 = i2 + -4 | 0;
  i42 = i2 + -32 | 0;
  i43 = i2 + -28 | 0;
  i44 = i2 + -24 | 0;
  i45 = i2 + -20 | 0;
  i46 = i2 + -16 | 0;
  i47 = i2 + -12 | 0;
  while (1) {
   i15 = i1;
   L5 : while (1) {
    i14 = i15;
    i1 = i19 - i14 | 0;
    switch ((i1 | 0) / 36 | 0 | 0) {
    case 2:
     {
      i41 = 5;
      break L1;
     }
    case 3:
     {
      i41 = 7;
      break L1;
     }
    case 4:
     {
      i41 = 8;
      break L1;
     }
    case 5:
     {
      i41 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i41 = 46;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 252) {
     i41 = 11;
     break L1;
    }
    i3 = (i1 >>> 0) / 72 | 0;
    i11 = i15 + (i3 * 36 | 0) | 0;
    if ((i1 | 0) > 35964) {
     i1 = (i1 >>> 0) / 144 | 0;
     i1 = __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i15, i15 + (i1 * 36 | 0) | 0, i11, i11 + (i1 * 36 | 0) | 0, i48, i31) | 0;
    } else i1 = __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i15, i11, i48, i31) | 0;
    i12 = i15 + 32 | 0;
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i35 >> 2]);
    i4 = i15 + (i3 * 36 | 0) + 32 | 0;
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f51 < Math_fround(HEAPF32[i36 >> 2])) {
     i3 = i48;
     break;
    } else i10 = i48;
    while (1) {
     i3 = i10 + -36 | 0;
     if ((i15 | 0) == (i3 | 0)) break;
     __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i10 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f51 = Math_fround(HEAPF32[i37 >> 2]);
     __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f51 < Math_fround(HEAPF32[i38 >> 2])) {
      i41 = 29;
      break L5;
     } else i10 = i3;
    }
    i1 = i15 + 36 | 0;
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i39 >> 2]);
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (!(f51 < Math_fround(HEAPF32[i40 >> 2]))) {
     if ((i1 | 0) == (i48 | 0)) {
      i41 = 46;
      break L1;
     }
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i25 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 < Math_fround(HEAPF32[i26 >> 2])) break;
      i1 = i1 + 36 | 0;
      if ((i1 | 0) == (i48 | 0)) {
       i41 = 46;
       break L1;
      }
     }
     i3 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i5 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i1 + 12 >> 2] | 0;
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = HEAP32[i1 + 20 >> 2] | 0;
     i16 = i1 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i1;
     i17 = i48;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i48 >> 2] = i3;
     HEAP32[i42 >> 2] = i4;
     HEAP32[i43 >> 2] = i5;
     HEAP32[i44 >> 2] = i6;
     HEAP32[i45 >> 2] = i7;
     HEAP32[i46 >> 2] = i8;
     HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i1 = i1 + 36 | 0;
    }
    if ((i1 | 0) == (i48 | 0)) {
     i41 = 46;
     break L1;
    } else i3 = i48;
    while (1) {
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i21 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i11 = i1 + 36 | 0;
      if (f51 < Math_fround(HEAPF32[i22 >> 2])) break; else i1 = i11;
     }
     while (1) {
      i4 = i3 + -36 | 0;
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i23 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 < Math_fround(HEAPF32[i24 >> 2])) i3 = i4; else break;
     }
     if (i1 >>> 0 >= i4 >>> 0) {
      i15 = i1;
      continue L5;
     }
     i5 = HEAP32[i1 >> 2] | 0;
     i6 = HEAP32[i1 + 4 >> 2] | 0;
     i7 = HEAP32[i1 + 8 >> 2] | 0;
     i8 = HEAP32[i1 + 12 >> 2] | 0;
     i9 = HEAP32[i1 + 16 >> 2] | 0;
     i10 = HEAP32[i1 + 20 >> 2] | 0;
     i16 = i1 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i1;
     i17 = i4;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i4 >> 2] = i5;
     HEAP32[i3 + -32 >> 2] = i6;
     HEAP32[i3 + -28 >> 2] = i7;
     HEAP32[i3 + -24 >> 2] = i8;
     HEAP32[i3 + -20 >> 2] = i9;
     HEAP32[i3 + -16 >> 2] = i10;
     i3 = i3 + -12 | 0;
     HEAP32[i3 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i3 = i4;
     i1 = i11;
    }
   }
   if ((i41 | 0) == 29) {
    i41 = 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = HEAP32[i15 + 4 >> 2] | 0;
    i6 = HEAP32[i15 + 8 >> 2] | 0;
    i7 = HEAP32[i15 + 12 >> 2] | 0;
    i8 = HEAP32[i15 + 16 >> 2] | 0;
    i9 = HEAP32[i15 + 20 >> 2] | 0;
    i16 = i15 + 24 | 0;
    HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    i16 = i15;
    i17 = i3;
    i18 = i16 + 36 | 0;
    do {
     HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
     i16 = i16 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i16 | 0) < (i18 | 0));
    HEAP32[i3 >> 2] = i4;
    HEAP32[i10 + -32 >> 2] = i5;
    HEAP32[i10 + -28 >> 2] = i6;
    HEAP32[i10 + -24 >> 2] = i7;
    HEAP32[i10 + -20 >> 2] = i8;
    HEAP32[i10 + -16 >> 2] = i9;
    i18 = i10 + -12 | 0;
    HEAP32[i18 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   i4 = i15 + 36 | 0;
   L35 : do if (i4 >>> 0 < i3 >>> 0) {
    i13 = i11;
    while (1) {
     i5 = i13 + 32 | 0;
     while (1) {
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i29 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i12 = i4 + 36 | 0;
      if (f51 < Math_fround(HEAPF32[i30 >> 2])) i4 = i12; else break;
     }
     while (1) {
      i11 = i3 + -36 | 0;
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f51 = Math_fround(HEAPF32[i32 >> 2]);
      __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f51 < Math_fround(HEAPF32[i33 >> 2])) break; else i3 = i11;
     }
     if (i4 >>> 0 > i11 >>> 0) {
      i10 = i13;
      break L35;
     }
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i4 + 4 >> 2] | 0;
     i7 = HEAP32[i4 + 8 >> 2] | 0;
     i8 = HEAP32[i4 + 12 >> 2] | 0;
     i9 = HEAP32[i4 + 16 >> 2] | 0;
     i10 = HEAP32[i4 + 20 >> 2] | 0;
     i16 = i4 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i4;
     i17 = i11;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i11 >> 2] = i5;
     HEAP32[i3 + -32 >> 2] = i6;
     HEAP32[i3 + -28 >> 2] = i7;
     HEAP32[i3 + -24 >> 2] = i8;
     HEAP32[i3 + -20 >> 2] = i9;
     HEAP32[i3 + -16 >> 2] = i10;
     i3 = i3 + -12 | 0;
     HEAP32[i3 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i13 = (i13 | 0) == (i4 | 0) ? i11 : i13;
     i3 = i11;
     i4 = i12;
     i1 = i1 + 1 | 0;
    }
   } else i10 = i11; while (0);
   if ((i4 | 0) != (i10 | 0)) {
    __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i10 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f51 = Math_fround(HEAPF32[i27 >> 2]);
    __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f51 < Math_fround(HEAPF32[i28 >> 2])) {
     i3 = HEAP32[i4 >> 2] | 0;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i6 = HEAP32[i4 + 8 >> 2] | 0;
     i7 = HEAP32[i4 + 12 >> 2] | 0;
     i8 = HEAP32[i4 + 16 >> 2] | 0;
     i9 = HEAP32[i4 + 20 >> 2] | 0;
     i16 = i4 + 24 | 0;
     HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     i16 = i4;
     i17 = i10;
     i18 = i16 + 36 | 0;
     do {
      HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
      i16 = i16 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i16 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i3;
     HEAP32[i10 + 4 >> 2] = i5;
     HEAP32[i10 + 8 >> 2] = i6;
     HEAP32[i10 + 12 >> 2] = i7;
     HEAP32[i10 + 16 >> 2] = i8;
     HEAP32[i10 + 20 >> 2] = i9;
     i18 = i10 + 24 | 0;
     HEAP32[i18 >> 2] = HEAP32[i49 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR24RayHitsByDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i15, i4, i31) | 0;
    i1 = i4 + 36 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR24RayHitsByDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i1, i2, i31) | 0) {
     i41 = 45;
     break;
    }
    if (i3) continue;
   }
   i18 = i4;
   if ((i18 - i14 | 0) >= (i19 - i18 | 0)) {
    i41 = 44;
    break;
   }
   __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i15, i4, i31);
   i1 = i4 + 36 | 0;
  }
  if ((i41 | 0) == 44) {
   i41 = 0;
   __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i4 + 36 | 0, i2, i31);
   i1 = i15;
   i2 = i4;
   continue;
  } else if ((i41 | 0) == 45) {
   i41 = 0;
   if (i3) {
    i41 = 46;
    break;
   } else {
    i1 = i15;
    i2 = i4;
    continue;
   }
  }
 }
 if ((i41 | 0) == 5) {
  __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f51 = Math_fround(HEAPF32[i49 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i34, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f51 < Math_fround(HEAPF32[i34 + 8 >> 2]))) {
   STACKTOP = i50;
   return;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  i3 = HEAP32[i15 + 8 >> 2] | 0;
  i4 = HEAP32[i15 + 12 >> 2] | 0;
  i5 = HEAP32[i15 + 16 >> 2] | 0;
  i6 = HEAP32[i15 + 20 >> 2] | 0;
  i16 = i15 + 24 | 0;
  HEAP32[i49 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i16 = i15;
  i17 = i48;
  i18 = i16 + 36 | 0;
  do {
   HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
   i16 = i16 + 4 | 0;
   i17 = i17 + 4 | 0;
  } while ((i16 | 0) < (i18 | 0));
  HEAP32[i48 >> 2] = i1;
  HEAP32[i42 >> 2] = i2;
  HEAP32[i43 >> 2] = i3;
  HEAP32[i44 >> 2] = i4;
  HEAP32[i45 >> 2] = i5;
  HEAP32[i46 >> 2] = i6;
  HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 7) {
  __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i15, i15 + 36 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 8) {
  __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i15, i15 + 36 | 0, i15 + 72 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 9) {
  __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i15, i15 + 36 | 0, i15 + 72 | 0, i15 + 108 | 0, i48, i31) | 0;
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 11) {
  __ZNSt3__218__insertion_sort_3IR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i15, i2, i31);
  STACKTOP = i50;
  return;
 } else if ((i41 | 0) == 46) {
  STACKTOP = i50;
  return;
 }
}

function __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader(i40, i43, i44) {
 i40 = i40 | 0;
 i43 = i43 | 0;
 i44 = i44 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i45 = 0, i46 = 0, i47 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i46 + 168 | 0;
 i42 = i46 + 152 | 0;
 i37 = i46 + 136 | 0;
 i38 = i46 + 120 | 0;
 i34 = i46 + 104 | 0;
 i33 = i46 + 88 | 0;
 i32 = i46 + 72 | 0;
 i31 = i46 + 56 | 0;
 i30 = i46 + 40 | 0;
 i35 = i46 + 24 | 0;
 i4 = i46 + 16 | 0;
 i6 = i46 + 8 | 0;
 i5 = i46;
 i45 = i46 + 180 | 0;
 i1 = HEAP32[i40 >> 2] | 0;
 if ((i1 | 0) < 3) if ((i1 | 0) != (HEAP32[(HEAP32[gb + 1166136 >> 2] | 0) + 92 >> 2] | 0)) {
  i45 = 0;
  STACKTOP = i46;
  return i45 | 0;
 }
 i1 = i40 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i40 + 4 | 0;
 do if ((i2 | 0) != -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  do if (i3) if (__ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader(i3, i44) | 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   break;
  } else {
   i45 = 0;
   STACKTOP = i46;
   return i45 | 0;
  } while (0);
  if (HEAP32[i44 + 72 >> 2] | 0) {
   i1 = HEAP32[i44 + 60 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 > i2 >>> 0) {
    i2 = i1 + 4 + (i2 << 1 << 2) | 0;
    i1 = i1 + (HEAP32[i2 >> 2] | 0) | 0;
    i2 = i1 + (HEAP32[i2 + 4 >> 2] | 0) | 0;
    i3 = __Z25GetGpuProgramTypeFromDataPKhS0_(i1, i2) | 0;
    if (i3 | 0) if (!(__ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader(i3, i44) | 0)) {
     i45 = 0;
     STACKTOP = i46;
     return i45 | 0;
    }
    i1 = __Z22LoadGpuProgramFromDataPKhS0_(i1, i2) | 0;
    if (i1 | 0) {
     i45 = __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader(i1, i43, i44) | 0;
     __ZN9ShaderLab20SerializedSubProgramD2Ev(i1);
     __ZdlPv(i1);
     STACKTOP = i46;
     return i45 | 0;
    }
    if (!i44) {
     HEAP32[i5 >> 2] = gb + 475787;
     __Z6FormatPKcz(i45, gb + 475728 | 0, i5);
     i1 = 0;
    } else {
     i1 = HEAP32[i44 + 28 >> 2] | 0;
     if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     __Z6FormatPKcz(i45, gb + 475728 | 0, i6);
     i1 = HEAP32[i44 + 4 >> 2] | 0;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i45 + 11 >> 0] | 0) < 0 ? HEAP32[i45 >> 2] | 0 : i45, 0, gb + 472212 | 0, 555, 512, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
    break;
   }
  }
  if ((HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0) != 4) {
   i1 = HEAP32[i44 + 28 >> 2] | 0;
   if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   __Z6FormatPKcz(i45, gb + 475804 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i45 + 11 >> 0] | 0) < 0 ? HEAP32[i45 >> 2] | 0 : i45, 0, gb + 472212 | 0, 564, 512, HEAP32[i44 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
  }
 } while (0);
 if (!(__ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader(HEAP32[i7 >> 2] | 0, i44) | 0)) {
  i45 = 0;
  STACKTOP = i46;
  return i45 | 0;
 }
 i41 = __Znwj(88) | 0;
 i29 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
 __ZN9ShaderLab10SubProgramC2EPKc20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EEP16PropertyNamesSetRK16ShaderKeywordSet(i41, i29, HEAP32[i7 >> 2] | 0, i40 + 8 | 0, i43, i40 + 76 | 0);
 i29 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
 if ((i29 | 0) == 15) {
  i45 = i41;
  STACKTOP = i46;
  return i45 | 0;
 }
 i1 = i41 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i28 = HEAP32[i40 + 52 >> 2] | 0;
  HEAP32[i1 >> 2] = (i28 | 0) == 0 ? 1 : i28;
 }
 __ZL23AddGpuProgramParametersR20GpuProgramParametersRKNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEERKNS2_INS4_15VectorParameterENS6_ISB_EEEEiP16PropertyNamesSet(HEAP32[i41 >> 2] | 0, i40 + 120 | 0, i40 + 108 | 0, -1, i43);
 i28 = i40 + 168 | 0;
 i2 = HEAP32[i28 >> 2] | 0;
 i1 = HEAP32[i40 + 172 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i1 - i2 | 0;
  i27 = (i7 | 0) / 48 | 0;
  i6 = HEAP32[i41 >> 2] | 0;
  i1 = i6 + 80 | 0;
  i6 = i6 + 84 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = (i4 - i3 | 0) / 52 | 0;
  if (i27 >>> 0 > i2 >>> 0) __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE8__appendEj(i1, i27 - i2 | 0); else if (i27 >>> 0 < i2 >>> 0) {
   i5 = i3 + (i27 * 52 | 0) | 0;
   if ((i4 | 0) != (i5 | 0)) {
    i2 = i4;
    while (1) {
     i1 = i2 + -52 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i2 + -48 | 0;
     if ((HEAP32[i2 + -32 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -44 | 0);
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
   }
  }
  i26 = __Z12GetGfxDevicev() | 0;
  if (i7 | 0) {
   i15 = i40 + 180 | 0;
   i16 = i40 + 184 | 0;
   i17 = (i44 | 0) == 0;
   i18 = i45 + 11 | 0;
   i19 = i44 + 28 | 0;
   i20 = i44 + 4 | 0;
   i21 = i45 + 11 | 0;
   i22 = i45 + 11 | 0;
   i14 = 0;
   do {
    i23 = HEAP32[(HEAP32[i41 >> 2] | 0) + 80 >> 2] | 0;
    i24 = (HEAP32[i28 >> 2] | 0) + (i14 * 48 | 0) | 0;
    HEAP32[i45 >> 2] = -1;
    __ZN9ShaderLab16FastPropertyName4InitEPKc(i45, (HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24);
    i24 = i23 + (i14 * 52 | 0) | 0;
    HEAP32[i24 >> 2] = HEAP32[i45 >> 2];
    i1 = HEAP32[i28 >> 2] | 0;
    i13 = (HEAP32[i1 + (i14 * 48 | 0) + 44 >> 2] | 0) + 15 & -16;
    i25 = i23 + (i14 * 52 | 0) + 24 | 0;
    HEAP32[i25 >> 2] = i13;
    i9 = i23 + (i14 * 52 | 0) + 28 | 0;
    HEAP32[i9 >> 2] = -1;
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i15 >> 2] | 0;
    i10 = i3;
    if ((i2 | 0) != (i3 | 0)) {
     i11 = i1 + (i14 * 48 | 0) | 0;
     i12 = i11 + 11 | 0;
     i8 = i1 + (i14 * 48 | 0) + 4 | 0;
     i7 = (i2 - i3 | 0) / 24 | 0;
     i6 = 0;
     do {
      i2 = i10 + (i6 * 24 | 0) | 0;
      i5 = HEAP8[i2 + 11 >> 0] | 0;
      i3 = i5 << 24 >> 24 < 0;
      if (i3) i1 = HEAP32[i10 + (i6 * 24 | 0) + 4 >> 2] | 0; else i1 = i5 & 255;
      i47 = HEAP8[i12 >> 0] | 0;
      i4 = i47 << 24 >> 24 < 0;
      if ((i1 | 0) == ((i4 ? HEAP32[i8 >> 2] | 0 : i47 & 255) | 0)) {
       i1 = HEAP32[i11 >> 2] | 0;
       if (i3) {
        i3 = HEAP32[i2 >> 2] | 0;
        i2 = i4 ? i1 : i11;
        i1 = HEAP32[i10 + (i6 * 24 | 0) + 4 >> 2] | 0;
       } else {
        i3 = i2;
        i2 = i4 ? i1 : i11;
        i1 = i5 & 255;
       }
       if (!(_strncmp(i3, i2, i1) | 0)) HEAP32[i9 >> 2] = HEAP32[i10 + (i6 * 24 | 0) + 20 >> 2];
      }
      i6 = i6 + 1 | 0;
     } while (i6 >>> 0 < i7 >>> 0);
    }
    i1 = HEAP32[i24 >> 2] | 0;
    do if ((HEAP32[gb + 1166216 >> 2] | 0) == (i1 | 0)) if ((i13 | 0) == 1088) i36 = 64; else {
     if (i17) {
      HEAP32[i35 >> 2] = 1088;
      HEAP32[i35 + 4 >> 2] = i13;
      HEAP32[i35 + 8 >> 2] = gb + 475787;
      __Z6FormatPKcz(i45, gb + 475856 | 0, i35);
      i1 = 0;
     } else {
      i1 = HEAP32[i19 >> 2] | 0;
      if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
      HEAP32[i30 >> 2] = 1088;
      HEAP32[i30 + 4 >> 2] = i13;
      HEAP32[i30 + 8 >> 2] = i1;
      __Z6FormatPKcz(i45, gb + 475856 | 0, i30);
      i1 = HEAP32[i20 >> 2] | 0;
     }
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i45 >> 2] | 0 : i45, 0, gb + 472212 | 0, 449, 512, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
     i1 = 0;
    } else {
     if ((HEAP32[gb + 1166224 >> 2] | 0) == (i1 | 0)) {
      if ((i13 | 0) == 16) {
       i36 = 64;
       break;
      }
      if (i17) {
       HEAP32[i31 >> 2] = 16;
       HEAP32[i31 + 4 >> 2] = i13;
       HEAP32[i31 + 8 >> 2] = gb + 475787;
       __Z6FormatPKcz(i45, gb + 475975 | 0, i31);
       i1 = 0;
      } else {
       i1 = HEAP32[i19 >> 2] | 0;
       if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
       HEAP32[i32 >> 2] = 16;
       HEAP32[i32 + 4 >> 2] = i13;
       HEAP32[i32 + 8 >> 2] = i1;
       __Z6FormatPKcz(i45, gb + 475975 | 0, i32);
       i1 = HEAP32[i20 >> 2] | 0;
      }
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 >> 0] | 0) < 0 ? HEAP32[i45 >> 2] | 0 : i45, 0, gb + 472212 | 0, 458, 512, i1, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
      i1 = 0;
      break;
     }
     if ((HEAP32[gb + 1166236 >> 2] | 0) == (i1 | 0)) if ((i13 | 0) == 16) i36 = 64; else {
      if (i17) {
       HEAP32[i33 >> 2] = 16;
       HEAP32[i33 + 4 >> 2] = i13;
       HEAP32[i33 + 8 >> 2] = gb + 475787;
       __Z6FormatPKcz(i45, gb + 476095 | 0, i33);
       i1 = 0;
      } else {
       i1 = HEAP32[i19 >> 2] | 0;
       if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
       HEAP32[i34 >> 2] = 16;
       HEAP32[i34 + 4 >> 2] = i13;
       HEAP32[i34 + 8 >> 2] = i1;
       __Z6FormatPKcz(i45, gb + 476095 | 0, i34);
       i1 = HEAP32[i20 >> 2] | 0;
      }
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i45 >> 2] | 0 : i45, 0, gb + 472212 | 0, 467, 512, i1, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
      i1 = 0;
     } else i1 = 0;
    } while (0);
    L109 : do if ((i36 | 0) == 64) {
     i36 = 0;
     switch (i29 | 0) {
     case 13:
     case 2:
      break;
     default:
      {
       i1 = 0;
       break L109;
      }
     }
     i1 = 2;
    } while (0);
    HEAP32[i23 + (i14 * 52 | 0) + 32 >> 2] = i1;
    mftCall_viiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 212 >> 2] | 0, i26 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i25 >> 2] | 0, 0);
    i47 = HEAP32[i28 >> 2] | 0;
    __ZL23AddGpuProgramParametersR20GpuProgramParametersRKNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEERKNS2_INS4_15VectorParameterENS6_ISB_EEEEiP16PropertyNamesSet(HEAP32[i41 >> 2] | 0, i47 + (i14 * 48 | 0) + 20 | 0, i47 + (i14 * 48 | 0) + 32 | 0, i14, i43);
    i14 = i14 + 1 | 0;
   } while (i14 >>> 0 < i27 >>> 0);
  }
 }
 i4 = i40 + 132 | 0;
 i5 = i40 + 136 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i2 = i1 + (i3 << 5) | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(HEAP32[i41 >> 2] | 0, i2, HEAP32[i1 + (i3 << 5) + 20 >> 2] | 0, HEAP32[i1 + (i3 << 5) + 24 >> 2] | 0, HEAP32[i1 + (i3 << 5) + 28 >> 2] | 0, i43);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) - i1 >> 5 >>> 0);
 }
 i1 = HEAP32[i41 >> 2] | 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i5 = i4 - i3 >> 4;
 i2 = HEAP32[gb + 1166136 >> 2] | 0;
 i6 = HEAP32[i2 + 120 >> 2] | 0;
 if ((i5 | 0) > (i6 | 0)) {
  if (!i44) {
   HEAP32[i37 >> 2] = gb + 475787;
   HEAP32[i37 + 4 >> 2] = i5;
   HEAP32[i37 + 8 >> 2] = i6;
   __Z6FormatPKcz(i45, gb + 476213 | 0, i37);
   i1 = 0;
  } else {
   i2 = HEAP32[i44 + 28 >> 2] | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
    i3 = HEAP32[i41 >> 2] | 0;
    i4 = HEAP32[i3 + 40 >> 2] | 0;
    i3 = HEAP32[i3 + 36 >> 2] | 0;
    i1 = HEAP32[(HEAP32[gb + 1166136 >> 2] | 0) + 120 >> 2] | 0;
   } else i1 = i6;
   HEAP32[i38 >> 2] = i2;
   HEAP32[i38 + 4 >> 2] = i4 - i3 >> 4;
   HEAP32[i38 + 8 >> 2] = i1;
   __Z6FormatPKcz(i45, gb + 476213 | 0, i38);
   i1 = HEAP32[i44 + 4 >> 2] | 0;
  }
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i45, 512, i1);
  __ZN9ShaderLab10SubProgramD2Ev(i41);
  __ZdlPv(i41);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
  i47 = 0;
  STACKTOP = i46;
  return i47 | 0;
 }
 i5 = i40 + 144 | 0;
 i6 = i40 + 148 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) != (i3 | 0)) {
  i4 = 0;
  i2 = i3;
  do {
   i3 = i2 + (i4 * 28 | 0) | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
   __ZN20GpuProgramParameters11AddUAVParamEPKciiP16PropertyNamesSet(i1, i3, HEAP32[i2 + (i4 * 28 | 0) + 20 >> 2] | 0, HEAP32[i2 + (i4 * 28 | 0) + 24 >> 2] | 0, i43);
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i41 >> 2] | 0;
  } while (i4 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i2 | 0) / 28 | 0) >>> 0);
  i2 = HEAP32[gb + 1166136 >> 2] | 0;
 }
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 i5 = (i4 - i3 | 0) / 12 | 0;
 i6 = HEAP32[i2 + 148 >> 2] | 0;
 if ((i5 | 0) > (i6 | 0)) {
  if (!i44) {
   HEAP32[i39 >> 2] = gb + 475787;
   HEAP32[i39 + 4 >> 2] = i5;
   HEAP32[i39 + 8 >> 2] = i6;
   __Z6FormatPKcz(i45, gb + 476312 | 0, i39);
   i1 = 0;
  } else {
   i2 = HEAP32[i44 + 28 >> 2] | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 36 >> 2] | 0, i44 | 0) | 0;
    i3 = HEAP32[i41 >> 2] | 0;
    i4 = HEAP32[i3 + 52 >> 2] | 0;
    i3 = HEAP32[i3 + 48 >> 2] | 0;
    i1 = HEAP32[(HEAP32[gb + 1166136 >> 2] | 0) + 148 >> 2] | 0;
   } else i1 = i6;
   HEAP32[i42 >> 2] = i2;
   HEAP32[i42 + 4 >> 2] = (i4 - i3 | 0) / 12 | 0;
   HEAP32[i42 + 8 >> 2] = i1;
   __Z6FormatPKcz(i45, gb + 476312 | 0, i42);
   i1 = HEAP32[i44 + 4 >> 2] | 0;
  }
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i45, 512, i1);
  __ZN9ShaderLab10SubProgramD2Ev(i41);
  __ZdlPv(i41);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i45);
  i47 = 0;
  STACKTOP = i46;
  return i47 | 0;
 } else {
  i6 = i40 + 156 | 0;
  i5 = i40 + 160 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) {
   i4 = 0;
   do {
    i3 = i2 + (i4 * 24 | 0) | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
    __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii(i1, i3, HEAP32[i2 + (i4 * 24 | 0) + 20 >> 2] | 0, i43, -1, -1);
    i4 = i4 + 1 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i41 >> 2] | 0;
   } while (i4 >>> 0 < (((HEAP32[i5 >> 2] | 0) - i2 | 0) / 24 | 0) >>> 0);
  }
  __ZN20GpuProgramParameters21UpdateParamBufferSizeEv(i1);
  i47 = i41;
  STACKTOP = i46;
  return i47 | 0;
 }
 return 0;
}

function __ZN5physx13PxsCCDContext23runCCDModifiableContactEPNS_19PxModifiableContactEjPKNS_12PxsShapeCoreES5_PKNS_12PxsRigidCoreES8_PKNS_12PxsRigidBodyESB_(i1, i17, i16, i12, i14, i11, i13, i9, i10) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i15 = i1 + 84 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i21 = HEAP32[gb + 1457360 >> 2] | 0;
 HEAP32[i18 + 8 >> 2] = i12 + i21;
 HEAP32[i18 + 12 >> 2] = i14 + i21;
 i9 = (i9 | 0) != 0;
 i21 = HEAP32[gb + 1457360 + 4 >> 2] | 0;
 i20 = HEAP32[gb + 1457360 + 8 >> 2] | 0;
 HEAP32[i18 >> 2] = i11 + (i9 ? i21 : i20);
 i1 = (i10 | 0) != 0;
 HEAP32[i18 + 4 >> 2] = i13 + (i1 ? i21 : i20);
 if (i9) {
  f2 = Math_fround(HEAPF32[i11 + 48 >> 2]);
  f26 = Math_fround(HEAPF32[i11 + 52 >> 2]);
  f2 = Math_fround(f2 * Math_fround(-2.0));
  f26 = Math_fround(f26 * Math_fround(-2.0));
  f4 = Math_fround(Math_fround(HEAPF32[i11 + 56 >> 2]) * Math_fround(-2.0));
  f6 = Math_fround(HEAPF32[i11 + 44 >> 2]);
  f28 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
  f8 = Math_fround(HEAPF32[i11 + 32 >> 2]);
  f22 = Math_fround(f2 * f8);
  f29 = Math_fround(HEAPF32[i11 + 36 >> 2]);
  f22 = Math_fround(f22 + Math_fround(f26 * f29));
  f5 = Math_fround(HEAPF32[i11 + 40 >> 2]);
  f22 = Math_fround(f22 + Math_fround(f4 * f5));
  f7 = Math_fround(-f8);
  f23 = Math_fround(-f29);
  f25 = Math_fround(-f5);
  f24 = Math_fround(Math_fround(Math_fround(f8 * f22) + Math_fround(Math_fround(f2 * f28) - Math_fround(f6 * Math_fround(Math_fround(f4 * f29) - Math_fround(f26 * f5))))) * Math_fround(2.0));
  f27 = Math_fround(Math_fround(Math_fround(f29 * f22) + Math_fround(Math_fround(f26 * f28) - Math_fround(f6 * Math_fround(Math_fround(f2 * f5) - Math_fround(f4 * f8))))) * Math_fround(2.0));
  f22 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f28) - Math_fround(f6 * Math_fround(Math_fround(f26 * f8) - Math_fround(f2 * f29)))) + Math_fround(f5 * f22)) * Math_fround(2.0));
  f5 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f29 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
  f2 = Math_fround(HEAPF32[i11 >> 2]);
  f8 = Math_fround(f2 * f24);
  f26 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f26 * f27));
  f28 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f8 = Math_fround(Math_fround(f28 * f22) + f8);
  f4 = Math_fround(Math_fround(f2 * f8) + Math_fround(Math_fround(f29 * f24) + Math_fround(f5 * Math_fround(Math_fround(f26 * f22) - Math_fround(f28 * f27)))));
  f3 = Math_fround(Math_fround(f26 * f8) + Math_fround(Math_fround(f29 * f27) + Math_fround(f5 * Math_fround(Math_fround(f28 * f24) - Math_fround(f2 * f22)))));
  f8 = Math_fround(Math_fround(Math_fround(f29 * f22) + Math_fround(f5 * Math_fround(Math_fround(f2 * f27) - Math_fround(f26 * f24)))) + Math_fround(f28 * f8));
  f4 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) + f4);
  f3 = Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) + f3);
  f8 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) + f8);
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f7) + Math_fround(f6 * f2)) + Math_fround(f26 * f25)) - Math_fround(f28 * f23));
  f27 = Math_fround(Math_fround(Math_fround(f28 * f7) + Math_fround(Math_fround(f5 * f23) + Math_fround(f6 * f26))) - Math_fround(f2 * f25));
  f22 = Math_fround(Math_fround(Math_fround(f2 * f23) + Math_fround(Math_fround(f5 * f25) + Math_fround(f6 * f28))) - Math_fround(f26 * f7));
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f5) - Math_fround(f2 * f7)) - Math_fround(f26 * f23)) - Math_fround(f28 * f25));
  f28 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) * Math_fround(2.0));
  f23 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) * Math_fround(2.0));
  f26 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
  f2 = Math_fround(Math_fround(Math_fround(f24 * f28) + Math_fround(f27 * f23)) + Math_fround(f22 * f26));
  f4 = Math_fround(f4 + Math_fround(Math_fround(f24 * f2) + Math_fround(Math_fround(f7 * f28) + Math_fround(f25 * Math_fround(Math_fround(f27 * f26) - Math_fround(f22 * f23))))));
  f3 = Math_fround(f3 + Math_fround(Math_fround(f27 * f2) + Math_fround(Math_fround(f7 * f23) + Math_fround(f25 * Math_fround(Math_fround(f22 * f28) - Math_fround(f24 * f26))))));
  f2 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f7 * f26) + Math_fround(f25 * Math_fround(Math_fround(f24 * f23) - Math_fround(f27 * f28)))) + Math_fround(f22 * f2)));
  f28 = Math_fround(HEAPF32[i12 >> 2]);
  f23 = Math_fround(f25 * f28);
  f26 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f24 * f26));
  f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f27 * f7));
  f8 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f26) - Math_fround(f24 * f28)) - Math_fround(f27 * f8)) - Math_fround(f22 * f7));
  f6 = Math_fround(Math_fround(Math_fround(f24 * f8) + Math_fround(Math_fround(f22 * f26) + Math_fround(f25 * f7))) - Math_fround(f27 * f28));
  f7 = Math_fround(Math_fround(Math_fround(f22 * f28) + Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f8))) - Math_fround(f24 * f7));
  f8 = Math_fround(f23 - Math_fround(f22 * f8));
 } else {
  f23 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) * Math_fround(2.0));
  f26 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f25 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
  f27 = Math_fround(HEAPF32[i11 >> 2]);
  f2 = Math_fround(f23 * f27);
  f24 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f28 * f24));
  f29 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f7 * f29));
  f4 = Math_fround(Math_fround(f27 * f2) + Math_fround(Math_fround(f23 * f25) + Math_fround(f26 * Math_fround(Math_fround(f7 * f24) - Math_fround(f28 * f29)))));
  f3 = Math_fround(Math_fround(f24 * f2) + Math_fround(Math_fround(f28 * f25) + Math_fround(f26 * Math_fround(Math_fround(f23 * f29) - Math_fround(f7 * f27)))));
  f2 = Math_fround(Math_fround(Math_fround(f7 * f25) + Math_fround(f26 * Math_fround(Math_fround(f28 * f27) - Math_fround(f23 * f24)))) + Math_fround(f29 * f2));
  f4 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) + f4);
  f3 = Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) + f3);
  f2 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) + f2);
  f23 = Math_fround(HEAPF32[i12 >> 2]);
  f28 = Math_fround(f26 * f23);
  f25 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f27 * f25));
  f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f24 * f7));
  f8 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f27 * f23)) - Math_fround(f24 * f8)) - Math_fround(f29 * f7));
  f6 = Math_fround(Math_fround(Math_fround(f27 * f8) + Math_fround(Math_fround(f29 * f25) + Math_fround(f26 * f7))) - Math_fround(f24 * f23));
  f7 = Math_fround(Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f8))) - Math_fround(f27 * f7));
  f8 = Math_fround(f28 - Math_fround(f29 * f8));
 }
 HEAPF32[i18 + 16 >> 2] = f8;
 HEAPF32[i18 + 20 >> 2] = f7;
 HEAPF32[i18 + 24 >> 2] = f6;
 HEAPF32[i18 + 28 >> 2] = f5;
 HEAPF32[i18 + 32 >> 2] = f4;
 HEAPF32[i18 + 36 >> 2] = f3;
 HEAPF32[i18 + 40 >> 2] = f2;
 if (i1) {
  f2 = Math_fround(HEAPF32[i13 + 48 >> 2]);
  f25 = Math_fround(HEAPF32[i13 + 52 >> 2]);
  f2 = Math_fround(f2 * Math_fround(-2.0));
  f25 = Math_fround(f25 * Math_fround(-2.0));
  f4 = Math_fround(Math_fround(HEAPF32[i13 + 56 >> 2]) * Math_fround(-2.0));
  f6 = Math_fround(HEAPF32[i13 + 44 >> 2]);
  f23 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
  f8 = Math_fround(HEAPF32[i13 + 32 >> 2]);
  f29 = Math_fround(f2 * f8);
  f22 = Math_fround(HEAPF32[i13 + 36 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f25 * f22));
  f5 = Math_fround(HEAPF32[i13 + 40 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f4 * f5));
  f7 = Math_fround(-f8);
  f28 = Math_fround(-f22);
  f26 = Math_fround(-f5);
  f27 = Math_fround(Math_fround(Math_fround(f8 * f29) + Math_fround(Math_fround(f2 * f23) - Math_fround(f6 * Math_fround(Math_fround(f4 * f22) - Math_fround(f25 * f5))))) * Math_fround(2.0));
  f24 = Math_fround(Math_fround(Math_fround(f22 * f29) + Math_fround(Math_fround(f25 * f23) - Math_fround(f6 * Math_fround(Math_fround(f2 * f5) - Math_fround(f4 * f8))))) * Math_fround(2.0));
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f23) - Math_fround(f6 * Math_fround(Math_fround(f25 * f8) - Math_fround(f2 * f22)))) + Math_fround(f5 * f29)) * Math_fround(2.0));
  f5 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f22 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  f8 = Math_fround(f2 * f27);
  f25 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f25 * f24));
  f23 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f8 = Math_fround(Math_fround(f23 * f29) + f8);
  f4 = Math_fround(Math_fround(f2 * f8) + Math_fround(Math_fround(f22 * f27) + Math_fround(f5 * Math_fround(Math_fround(f25 * f29) - Math_fround(f23 * f24)))));
  f3 = Math_fround(Math_fround(f25 * f8) + Math_fround(Math_fround(f22 * f24) + Math_fround(f5 * Math_fround(Math_fround(f23 * f27) - Math_fround(f2 * f29)))));
  f8 = Math_fround(Math_fround(Math_fround(f22 * f29) + Math_fround(f5 * Math_fround(Math_fround(f2 * f24) - Math_fround(f25 * f27)))) + Math_fround(f23 * f8));
  f4 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) + f4);
  f3 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) + f3);
  f8 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) + f8);
  f27 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f7) + Math_fround(f6 * f2)) + Math_fround(f25 * f26)) - Math_fround(f23 * f28));
  f24 = Math_fround(Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f5 * f28) + Math_fround(f6 * f25))) - Math_fround(f2 * f26));
  f29 = Math_fround(Math_fround(Math_fround(f2 * f28) + Math_fround(Math_fround(f5 * f26) + Math_fround(f6 * f23))) - Math_fround(f25 * f7));
  f26 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f5) - Math_fround(f2 * f7)) - Math_fround(f25 * f28)) - Math_fround(f23 * f26));
  f23 = Math_fround(Math_fround(HEAPF32[i14 + 16 >> 2]) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(HEAPF32[i14 + 20 >> 2]) * Math_fround(2.0));
  f25 = Math_fround(Math_fround(HEAPF32[i14 + 24 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
  f2 = Math_fround(Math_fround(Math_fround(f27 * f23) + Math_fround(f24 * f28)) + Math_fround(f29 * f25));
  f4 = Math_fround(f4 + Math_fround(Math_fround(f27 * f2) + Math_fround(Math_fround(f7 * f23) + Math_fround(f26 * Math_fround(Math_fround(f24 * f25) - Math_fround(f29 * f28))))));
  f3 = Math_fround(f3 + Math_fround(Math_fround(f24 * f2) + Math_fround(Math_fround(f7 * f28) + Math_fround(f26 * Math_fround(Math_fround(f29 * f23) - Math_fround(f27 * f25))))));
  f2 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f7 * f25) + Math_fround(f26 * Math_fround(Math_fround(f27 * f28) - Math_fround(f24 * f23)))) + Math_fround(f29 * f2)));
  f23 = Math_fround(HEAPF32[i14 >> 2]);
  f28 = Math_fround(f26 * f23);
  f25 = Math_fround(HEAPF32[i14 + 12 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f27 * f25));
  f7 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f24 * f7));
  f8 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f27 * f23)) - Math_fround(f24 * f8)) - Math_fround(f29 * f7));
  f6 = Math_fround(Math_fround(Math_fround(f27 * f8) + Math_fround(Math_fround(f29 * f25) + Math_fround(f26 * f7))) - Math_fround(f24 * f23));
  f7 = Math_fround(Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f8))) - Math_fround(f27 * f7));
  f8 = Math_fround(f28 - Math_fround(f29 * f8));
 } else {
  f23 = Math_fround(Math_fround(HEAPF32[i14 + 16 >> 2]) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(HEAPF32[i14 + 20 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(HEAPF32[i14 + 24 >> 2]) * Math_fround(2.0));
  f26 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f25 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
  f27 = Math_fround(HEAPF32[i13 >> 2]);
  f2 = Math_fround(f23 * f27);
  f24 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f28 * f24));
  f29 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f7 * f29));
  f4 = Math_fround(Math_fround(f27 * f2) + Math_fround(Math_fround(f23 * f25) + Math_fround(f26 * Math_fround(Math_fround(f7 * f24) - Math_fround(f28 * f29)))));
  f3 = Math_fround(Math_fround(f24 * f2) + Math_fround(Math_fround(f28 * f25) + Math_fround(f26 * Math_fround(Math_fround(f23 * f29) - Math_fround(f7 * f27)))));
  f2 = Math_fround(Math_fround(Math_fround(f7 * f25) + Math_fround(f26 * Math_fround(Math_fround(f28 * f27) - Math_fround(f23 * f24)))) + Math_fround(f29 * f2));
  f4 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) + f4);
  f3 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) + f3);
  f2 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) + f2);
  f23 = Math_fround(HEAPF32[i14 >> 2]);
  f28 = Math_fround(f26 * f23);
  f25 = Math_fround(HEAPF32[i14 + 12 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f27 * f25));
  f7 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f24 * f7));
  f8 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f27 * f23)) - Math_fround(f24 * f8)) - Math_fround(f29 * f7));
  f6 = Math_fround(Math_fround(Math_fround(f27 * f8) + Math_fround(Math_fround(f29 * f25) + Math_fround(f26 * f7))) - Math_fround(f24 * f23));
  f7 = Math_fround(Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f8))) - Math_fround(f27 * f7));
  f8 = Math_fround(f28 - Math_fround(f29 * f8));
 }
 HEAPF32[i18 + 44 >> 2] = f8;
 HEAPF32[i18 + 48 >> 2] = f7;
 HEAPF32[i18 + 52 >> 2] = f6;
 HEAPF32[i18 + 56 >> 2] = f5;
 HEAPF32[i18 + 60 >> 2] = f4;
 HEAPF32[i18 + 64 >> 2] = f3;
 HEAPF32[i18 + 68 >> 2] = f2;
 HEAP32[i18 + 72 >> 2] = i16;
 HEAP32[i18 + 76 >> 2] = i17;
 i21 = HEAP32[i15 >> 2] | 0;
 mftCall_viii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, i18 | 0, 1);
 STACKTOP = i19;
 return;
}

function __ZN6prcore15ClearImageFloatER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE(i1, i14, i20) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25;
 if (!(__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i1 >> 2] | 0) | 0)) {
  if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i1 >> 2] | 0) | 0)) {
   STACKTOP = i25;
   return;
  }
  i16 = HEAP32[i1 + 4 >> 2] | 0;
  i17 = HEAP32[i1 + 8 >> 2] | 0;
  i18 = (HEAP32[i1 + 12 >> 2] | 0) >>> 2;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  i2 = __Z20GetTextureFormatInfo13TextureFormat(HEAP32[i1 >> 2] | 0) | 0;
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  i10 = HEAP32[i2 + 60 >> 2] | 0;
  i11 = HEAP32[i2 + 24 >> 2] | 0;
  i12 = HEAP32[i2 + 12 >> 2] | 0;
  i23 = HEAP32[i14 >> 2] | 0;
  f6 = Math_fround(Math_fround(i23 & 255) / Math_fround(255.0));
  f7 = Math_fround(Math_fround((i23 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f8 = Math_fround(Math_fround(i23 >>> 16 & 255) / Math_fround(255.0));
  f9 = Math_fround(Math_fround(i23 >>> 24 & 255) / Math_fround(255.0));
  i2 = (HEAP32[i2 + 8 >> 2] | 0) == 0;
  if (i2) i1 = 0; else {
   f26 = Math_fround(Math_fround(f6 * Math_fround(.298999995)) + Math_fround(Math_fround(f8 * Math_fround(.114)) + Math_fround(f7 * Math_fround(.587000012))));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  }
  HEAPF32[i24 + (i3 << 2) >> 2] = f6;
  HEAPF32[i24 + (i5 << 2) >> 2] = f7;
  HEAPF32[i24 + (i10 << 2) >> 2] = f8;
  HEAPF32[i24 + (i11 << 2) >> 2] = f9;
  HEAP32[i24 + (i12 << 2) >> 2] = i1;
  L9 : do if (i2) switch (i20 | 0) {
  case 1:
   {
    i1 = 1 << i5 | 1 << i3 | 1 << i10;
    break L9;
   }
  case 2:
   {
    i1 = 1 << i11;
    break L9;
   }
  case 3:
   {
    i1 = 1 << i5 | 1 << i3 | 1 << i10 | 1 << i11;
    break L9;
   }
  default:
   {
    i1 = 0;
    break L9;
   }
  } else switch (i20 | 0) {
  case 1:
   {
    i1 = 1 << i12;
    break L9;
   }
  case 2:
   {
    i1 = 1 << i11;
    break L9;
   }
  case 3:
   {
    i1 = 1 << i12 | 1 << i11;
    break L9;
   }
  default:
   {
    i1 = 0;
    break L9;
   }
  } while (0);
  i13 = (i18 >>> 0) / (i16 >>> 0) | 0;
  L21 : do if (i17 | 0) {
   i2 = (i1 & 2 | 0) == 0;
   i10 = (i1 & 4 | 0) == 0;
   i14 = (i1 & 8 | 0) == 0;
   i15 = i24 + 12 | 0;
   i12 = i24 + 8 | 0;
   i11 = i24 + 4 | 0;
   if (i16 | 0) {
    if (i1 & 1 | 0) {
     if (i2) {
      i5 = 0;
      while (1) {
       i3 = HEAP32[i24 >> 2] | 0;
       i1 = i4;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
       if (!i10) {
        i3 = HEAP32[i12 >> 2] | 0;
        i1 = i4 + 8 | 0;
        i2 = i16;
        while (1) {
         i2 = i2 + -1 | 0;
         HEAP32[i1 >> 2] = i3;
         if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
        }
       }
       if (!i14) {
        i3 = HEAP32[i15 >> 2] | 0;
        i1 = i4 + 12 | 0;
        i2 = i16;
        while (1) {
         i2 = i2 + -1 | 0;
         HEAP32[i1 >> 2] = i3;
         if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
        }
       }
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i17 | 0)) break L21; else i4 = i4 + (i18 << 2) | 0;
      }
     } else i5 = 0;
     while (1) {
      i3 = HEAP32[i24 >> 2] | 0;
      i1 = i4;
      i2 = i16;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP32[i1 >> 2] = i3;
       if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
      }
      i3 = HEAP32[i11 >> 2] | 0;
      i1 = i4 + 4 | 0;
      i2 = i16;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP32[i1 >> 2] = i3;
       if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
      }
      if (!i10) {
       i3 = HEAP32[i12 >> 2] | 0;
       i1 = i4 + 8 | 0;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
      }
      if (!i14) {
       i3 = HEAP32[i15 >> 2] | 0;
       i1 = i4 + 12 | 0;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
      }
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i17 | 0)) break L21; else i4 = i4 + (i18 << 2) | 0;
     }
    }
    if (i2) {
     i5 = 0;
     while (1) {
      if (!i10) {
       i3 = HEAP32[i12 >> 2] | 0;
       i1 = i4 + 8 | 0;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
      }
      if (!i14) {
       i3 = HEAP32[i15 >> 2] | 0;
       i1 = i4 + 12 | 0;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
      }
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i17 | 0)) break L21; else i4 = i4 + (i18 << 2) | 0;
     }
    }
    if (i10) {
     i5 = 0;
     while (1) {
      i3 = HEAP32[i11 >> 2] | 0;
      i1 = i4 + 4 | 0;
      i2 = i16;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP32[i1 >> 2] = i3;
       if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
      }
      if (!i14) {
       i3 = HEAP32[i15 >> 2] | 0;
       i1 = i4 + 12 | 0;
       i2 = i16;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP32[i1 >> 2] = i3;
        if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
       }
      }
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i17 | 0)) break L21; else i4 = i4 + (i18 << 2) | 0;
     }
    } else i5 = 0;
    while (1) {
     i3 = HEAP32[i11 >> 2] | 0;
     i1 = i4 + 4 | 0;
     i2 = i16;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP32[i1 >> 2] = i3;
      if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
     }
     i3 = HEAP32[i12 >> 2] | 0;
     i1 = i4 + 8 | 0;
     i2 = i16;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP32[i1 >> 2] = i3;
      if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
     }
     if (!i14) {
      i3 = HEAP32[i15 >> 2] | 0;
      i1 = i4 + 12 | 0;
      i2 = i16;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP32[i1 >> 2] = i3;
       if (!i2) break; else i1 = i1 + (i13 << 2) | 0;
      }
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i17 | 0)) break; else i4 = i4 + (i18 << 2) | 0;
    }
   }
  } while (0);
  STACKTOP = i25;
  return;
 }
 i22 = HEAP32[i1 + 4 >> 2] | 0;
 i23 = HEAP32[i1 + 8 >> 2] | 0;
 i21 = (HEAP32[i1 + 12 >> 2] | 0) >>> 1;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = __Z20GetTextureFormatInfo13TextureFormat(HEAP32[i1 >> 2] | 0) | 0;
 i15 = HEAP32[i5 + 36 >> 2] | 0;
 i16 = HEAP32[i5 + 48 >> 2] | 0;
 i17 = HEAP32[i5 + 60 >> 2] | 0;
 i18 = HEAP32[i5 + 24 >> 2] | 0;
 i19 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP16[i14 >> 1] | 0;
 f6 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 i1 = (i1 & 65535) >>> 8 & 255;
 do if (f6 == Math_fround(0.0)) i13 = 0; else {
  i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
  if (!(i4 << 16 >> 16)) {
   i13 = __ZN11prophecysdk4half7convertEi(i2) | 0;
   i1 = HEAP8[i14 + 1 >> 0] | 0;
   break;
  } else {
   i13 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
   break;
  }
 } while (0);
 f6 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 do if (f6 == Math_fround(0.0)) i12 = 0; else {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i1 >>> 23 << 1) >> 1] | 0;
  if (!(i2 << 16 >> 16)) {
   i12 = __ZN11prophecysdk4half7convertEi(i1) | 0;
   break;
  } else {
   i12 = (i2 & 65535) + (((i1 & 8388607) + 4096 | 0) >>> 13) & 65535;
   break;
  }
 } while (0);
 i1 = HEAP16[i14 + 2 >> 1] | 0;
 f6 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 i1 = (i1 & 65535) >>> 8 & 255;
 do if (f6 == Math_fround(0.0)) i11 = 0; else {
  i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
  if (!(i4 << 16 >> 16)) {
   i11 = __ZN11prophecysdk4half7convertEi(i2) | 0;
   i1 = HEAP8[i14 + 3 >> 0] | 0;
   break;
  } else {
   i11 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
   break;
  }
 } while (0);
 f6 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 do if (f6 == Math_fround(0.0)) i10 = 0; else {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i1 >>> 23 << 1) >> 1] | 0;
  if (!(i2 << 16 >> 16)) {
   i10 = __ZN11prophecysdk4half7convertEi(i1) | 0;
   break;
  } else {
   i10 = (i2 & 65535) + (((i1 & 8388607) + 4096 | 0) >>> 13) & 65535;
   break;
  }
 } while (0);
 i5 = i5 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i14 = HEAP32[gb + 73456 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i14 + ((i13 & 65535) << 2) >> 2]);
  f6 = Math_fround(HEAPF32[i14 + ((i12 & 65535) << 2) >> 2]);
  f6 = Math_fround(Math_fround(f26 * Math_fround(.298999995)) + Math_fround(Math_fround(f6 * Math_fround(.587000012)) + Math_fround(Math_fround(HEAPF32[i14 + ((i11 & 65535) << 2) >> 2]) * Math_fround(.114))));
  if (f6 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  }
 } while (0);
 HEAP16[i24 + (i15 << 1) >> 1] = i13;
 HEAP16[i24 + (i16 << 1) >> 1] = i12;
 HEAP16[i24 + (i17 << 1) >> 1] = i11;
 HEAP16[i24 + (i18 << 1) >> 1] = i10;
 HEAP16[i24 + (i19 << 1) >> 1] = i2;
 L133 : do if (!i1) switch (i20 | 0) {
 case 1:
  {
   i1 = 1 << i16 | 1 << i15 | 1 << i17;
   break L133;
  }
 case 2:
  {
   i1 = 1 << i18;
   break L133;
  }
 case 3:
  {
   i1 = 1 << i16 | 1 << i15 | 1 << i17 | 1 << i18;
   break L133;
  }
 default:
  {
   i1 = 0;
   break L133;
  }
 } else switch (i20 | 0) {
 case 1:
  {
   i1 = 1 << i19;
   break L133;
  }
 case 2:
  {
   i1 = 1 << i18;
   break L133;
  }
 case 3:
  {
   i1 = 1 << i19 | 1 << i18;
   break L133;
  }
 default:
  {
   i1 = 0;
   break L133;
  }
 } while (0);
 i13 = (i21 >>> 0) / (i22 >>> 0) | 0;
 L145 : do if (i23 | 0) {
  i2 = (i1 & 2 | 0) == 0;
  i10 = (i1 & 4 | 0) == 0;
  i14 = (i1 & 8 | 0) == 0;
  i15 = i24 + 6 | 0;
  i12 = i24 + 4 | 0;
  i11 = i24 + 2 | 0;
  if (i22 | 0) {
   if (i1 & 1 | 0) {
    if (i2) {
     i5 = 0;
     while (1) {
      i4 = HEAP16[i24 >> 1] | 0;
      i1 = i3;
      i2 = i22;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP16[i1 >> 1] = i4;
       if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
      }
      if (!i10) {
       i4 = HEAP16[i12 >> 1] | 0;
       i1 = i3 + 4 | 0;
       i2 = i22;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP16[i1 >> 1] = i4;
        if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
       }
      }
      if (!i14) {
       i4 = HEAP16[i15 >> 1] | 0;
       i1 = i3 + 6 | 0;
       i2 = i22;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP16[i1 >> 1] = i4;
        if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
       }
      }
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i23 | 0)) break L145; else i3 = i3 + (i21 << 1) | 0;
     }
    } else i5 = 0;
    while (1) {
     i4 = HEAP16[i24 >> 1] | 0;
     i1 = i3;
     i2 = i22;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP16[i1 >> 1] = i4;
      if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
     }
     i4 = HEAP16[i11 >> 1] | 0;
     i1 = i3 + 2 | 0;
     i2 = i22;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP16[i1 >> 1] = i4;
      if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
     }
     if (!i10) {
      i4 = HEAP16[i12 >> 1] | 0;
      i1 = i3 + 4 | 0;
      i2 = i22;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP16[i1 >> 1] = i4;
       if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
      }
     }
     if (!i14) {
      i4 = HEAP16[i15 >> 1] | 0;
      i1 = i3 + 6 | 0;
      i2 = i22;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP16[i1 >> 1] = i4;
       if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
      }
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i23 | 0)) break L145; else i3 = i3 + (i21 << 1) | 0;
    }
   }
   if (i2) {
    if (i10) {
     i4 = 0;
     while (1) {
      if (!i14) {
       i5 = HEAP16[i15 >> 1] | 0;
       i1 = i3 + 6 | 0;
       i2 = i22;
       while (1) {
        i2 = i2 + -1 | 0;
        HEAP16[i1 >> 1] = i5;
        if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
       }
      }
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i23 | 0)) break L145; else i3 = i3 + (i21 << 1) | 0;
     }
    } else i5 = 0;
    while (1) {
     i4 = HEAP16[i12 >> 1] | 0;
     i1 = i3 + 4 | 0;
     i2 = i22;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP16[i1 >> 1] = i4;
      if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
     }
     if (!i14) {
      i4 = HEAP16[i15 >> 1] | 0;
      i1 = i3 + 6 | 0;
      i2 = i22;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP16[i1 >> 1] = i4;
       if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
      }
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i23 | 0)) break L145; else i3 = i3 + (i21 << 1) | 0;
    }
   }
   if (i10) {
    i5 = 0;
    while (1) {
     i4 = HEAP16[i11 >> 1] | 0;
     i1 = i3 + 2 | 0;
     i2 = i22;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP16[i1 >> 1] = i4;
      if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
     }
     if (!i14) {
      i4 = HEAP16[i15 >> 1] | 0;
      i1 = i3 + 6 | 0;
      i2 = i22;
      while (1) {
       i2 = i2 + -1 | 0;
       HEAP16[i1 >> 1] = i4;
       if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
      }
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i23 | 0)) break L145; else i3 = i3 + (i21 << 1) | 0;
    }
   } else i5 = 0;
   while (1) {
    i4 = HEAP16[i11 >> 1] | 0;
    i1 = i3 + 2 | 0;
    i2 = i22;
    while (1) {
     i2 = i2 + -1 | 0;
     HEAP16[i1 >> 1] = i4;
     if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
    }
    i4 = HEAP16[i12 >> 1] | 0;
    i1 = i3 + 4 | 0;
    i2 = i22;
    while (1) {
     i2 = i2 + -1 | 0;
     HEAP16[i1 >> 1] = i4;
     if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
    }
    if (!i14) {
     i4 = HEAP16[i15 >> 1] | 0;
     i1 = i3 + 6 | 0;
     i2 = i22;
     while (1) {
      i2 = i2 + -1 | 0;
      HEAP16[i1 >> 1] = i4;
      if (!i2) break; else i1 = i1 + (i13 << 1) | 0;
     }
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i23 | 0)) break; else i3 = i3 + (i21 << 1) | 0;
   }
  }
 } while (0);
 STACKTOP = i25;
 return;
}

function __ZNK11DynamicMesh8SubtractERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEERKS4_RS4_SC_PKhRKS2_I5PlaneLj4EE(i13, i29, i32, i33, i34, i22, i23) {
 i13 = i13 | 0;
 i29 = i29 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i35 = 0, i36 = 0, f37 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i36;
 i35 = i36 + 48 | 0;
 i28 = i36 + 28 | 0;
 i26 = i36 + 8 | 0;
 i27 = HEAP32[i33 + 12 >> 2] | 0;
 i21 = i32 + 12 | 0;
 i30 = HEAP32[i21 >> 2] | 0;
 i3 = HEAP32[i29 >> 2] | 0;
 i31 = i29 + 4 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  HEAP32[i31 >> 2] = i2;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i31 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 i1 = i34 + 12 | 0;
 HEAP32[i1 >> 2] = 3;
 i2 = i34 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < 3) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 3;
  HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, 36, 4, i34 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 4, i34 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i25 | 0, HEAP32[i34 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = 3;
  HEAP32[i34 >> 2] = i25;
  break;
 } while (0);
 HEAP32[i35 + 12 >> 2] = i30;
 i24 = i35 + 16 | 0;
 HEAP32[i24 >> 2] = i30;
 i25 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 64016 | 0);
 i20 = i12;
 i4 = HEAP32[i20 + 4 >> 2] | 0;
 i1 = i25;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i30, 1, i25, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i35 >> 2] = i1;
 i4 = (i30 | 0) == 0;
 if (!i4) _memset(i1 | 0, 0, i30 | 0) | 0;
 i16 = (i27 | 0) == 0;
 if (i16) i5 = 25; else {
  i2 = HEAP32[i35 >> 2] | 0;
  i1 = 0;
  do {
   i3 = HEAPU8[i22 + i1 >> 0] | 0;
   if (!(i3 & 128)) HEAP8[i2 + i3 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i27 | 0));
  if ((i27 | 0) == 1) {
   if (!i4) {
    i3 = i29 + 8 | 0;
    i2 = 0;
    do {
     i1 = i2;
     i2 = i2 + 1 | 0;
     do if (!(HEAP8[(HEAP32[i35 >> 2] | 0) + i1 >> 0] | 0)) {
      i28 = HEAP32[i34 >> 2] | 0;
      i27 = HEAP32[i33 >> 2] | 0;
      HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      i28 = (HEAP32[i34 >> 2] | 0) + 12 | 0;
      i27 = (HEAP32[i32 >> 2] | 0) + (i1 * 12 | 0) | 0;
      HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      i28 = (HEAP32[i34 >> 2] | 0) + 24 | 0;
      i27 = (HEAP32[i32 >> 2] | 0) + (((i2 | 0) == (i30 | 0) ? 0 : i2) * 12 | 0) | 0;
      HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      i28 = HEAP32[i34 >> 2] | 0;
      f6 = Math_fround(HEAPF32[i28 + 12 >> 2]);
      f9 = Math_fround(HEAPF32[i28 >> 2]);
      f6 = Math_fround(f6 - f9);
      f8 = Math_fround(HEAPF32[i28 + 16 >> 2]);
      f7 = Math_fround(HEAPF32[i28 + 4 >> 2]);
      f8 = Math_fround(f8 - f7);
      f37 = Math_fround(HEAPF32[i28 + 20 >> 2]);
      f11 = Math_fround(HEAPF32[i28 + 8 >> 2]);
      f37 = Math_fround(f37 - f11);
      f9 = Math_fround(Math_fround(HEAPF32[i28 + 24 >> 2]) - f9);
      f7 = Math_fround(Math_fround(HEAPF32[i28 + 28 >> 2]) - f7);
      f11 = Math_fround(Math_fround(HEAPF32[i28 + 32 >> 2]) - f11);
      f10 = Math_fround(Math_fround(f8 * f11) - Math_fround(f37 * f7));
      f11 = Math_fround(Math_fround(f37 * f9) - Math_fround(f6 * f11));
      f9 = Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * f9));
      if (!(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11))) == Math_fround(0.0))) {
       i1 = HEAP32[i31 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
        __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i29, i34);
        break;
       } else {
        __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i1, i34);
        HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 20;
        break;
       }
      }
     } while (0);
    } while ((i2 | 0) != (i30 | 0));
   }
  } else i5 = 25;
 }
 if ((i5 | 0) == 25) {
  HEAP32[i28 + 12 >> 2] = i27;
  i19 = i28 + 16 | 0;
  HEAP32[i19 >> 2] = i27;
  i20 = i28 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 64016 | 0);
  i18 = i12;
  i1 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = i20;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  i2 = i27 << 2;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i28 >> 2] = i1;
  if (!i16) _memset(i1 | 0, -1, i2 | 0) | 0;
  HEAP32[i26 + 12 >> 2] = i27;
  i17 = i26 + 16 | 0;
  HEAP32[i17 >> 2] = i27;
  i18 = i26 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 64016 | 0);
  i14 = i12;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i1 = i18;
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i26 >> 2] = i1;
  if (!i16) {
   _memset(i1 | 0, -1, i2 | 0) | 0;
   i14 = i13 + 8280 | 0;
   i15 = i29 + 8 | 0;
   i12 = i27 + -1 | 0;
   i13 = 0;
   while (1) {
    i1 = HEAPU8[i22 + i13 >> 0] | 0;
    do if (i1 & 128 | 0) {
     i1 = i1 & 127;
     i2 = HEAP32[i23 >> 2] | 0;
     i4 = HEAP32[i32 >> 2] | 0;
     i5 = HEAP32[i21 >> 2] | 0;
     if (i5 | 0) {
      f6 = Math_fround(HEAPF32[i14 >> 2]);
      f9 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
      f10 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
      f11 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
      f7 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
      i1 = 0;
      i2 = -1;
      while (1) {
       f8 = Math_fround(f9 * Math_fround(HEAPF32[i4 + (i1 * 12 | 0) >> 2]));
       f8 = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i4 + (i1 * 12 | 0) + 4 >> 2])));
       f8 = Math_fround(f7 + Math_fround(f8 + Math_fround(f11 * Math_fround(HEAPF32[i4 + (i1 * 12 | 0) + 8 >> 2]))));
       i3 = f8 > f6;
       i2 = i3 ? i1 : i2;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i5 | 0)) break; else f6 = i3 ? f8 : f6;
      }
      if ((i2 | 0) != -1) {
       HEAP32[(HEAP32[i28 >> 2] | 0) + (i13 << 2) >> 2] = i2;
       HEAP32[(HEAP32[i26 >> 2] | 0) + (i12 << 2) >> 2] = i2;
       i5 = HEAP32[i34 >> 2] | 0;
       i4 = (HEAP32[i33 >> 2] | 0) + (i13 * 12 | 0) | 0;
       HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       i5 = (HEAP32[i34 >> 2] | 0) + 12 | 0;
       i12 = (HEAP32[i33 >> 2] | 0) + (i12 * 12 | 0) | 0;
       HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       i12 = (HEAP32[i34 >> 2] | 0) + 24 | 0;
       i5 = (HEAP32[i32 >> 2] | 0) + (i2 * 12 | 0) | 0;
       HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       i12 = HEAP32[i34 >> 2] | 0;
       f7 = Math_fround(HEAPF32[i12 + 12 >> 2]);
       f10 = Math_fround(HEAPF32[i12 >> 2]);
       f7 = Math_fround(f7 - f10);
       f9 = Math_fround(HEAPF32[i12 + 16 >> 2]);
       f8 = Math_fround(HEAPF32[i12 + 4 >> 2]);
       f9 = Math_fround(f9 - f8);
       f6 = Math_fround(HEAPF32[i12 + 20 >> 2]);
       f37 = Math_fround(HEAPF32[i12 + 8 >> 2]);
       f6 = Math_fround(f6 - f37);
       f10 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) - f10);
       f8 = Math_fround(Math_fround(HEAPF32[i12 + 28 >> 2]) - f8);
       f37 = Math_fround(Math_fround(HEAPF32[i12 + 32 >> 2]) - f37);
       f11 = Math_fround(Math_fround(f9 * f37) - Math_fround(f6 * f8));
       f37 = Math_fround(Math_fround(f6 * f10) - Math_fround(f7 * f37));
       f10 = Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10));
       if (!(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f37 * f37))) == Math_fround(0.0))) {
        i1 = HEAP32[i31 >> 2] | 0;
        if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
         __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i29, i34);
         break;
        } else {
         __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i1, i34);
         HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 20;
         break;
        }
       }
      }
     }
    } while (0);
    i1 = i13 + 1 | 0;
    if ((i1 | 0) == (i27 | 0)) break; else {
     i12 = i13;
     i13 = i1;
    }
   }
   if (!i16) {
    i5 = i29 + 8 | 0;
    i4 = 0;
    do {
     i1 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     L61 : do if ((i1 | 0) != -1) if ((i1 | 0) != (HEAP32[(HEAP32[i26 >> 2] | 0) + (i4 << 2) >> 2] | 0)) do {
      i23 = i1 + 1 | 0;
      i2 = i1;
      i1 = (i23 | 0) == (i30 | 0) ? 0 : i23;
      if (HEAP8[(HEAP32[i35 >> 2] | 0) + i1 >> 0] | 0) break L61;
      i23 = HEAP32[i34 >> 2] | 0;
      i22 = (HEAP32[i33 >> 2] | 0) + (i4 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = (HEAP32[i34 >> 2] | 0) + 12 | 0;
      i22 = (HEAP32[i32 >> 2] | 0) + (i2 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = (HEAP32[i34 >> 2] | 0) + 24 | 0;
      i22 = (HEAP32[i32 >> 2] | 0) + (i1 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = HEAP32[i34 >> 2] | 0;
      f7 = Math_fround(HEAPF32[i23 + 12 >> 2]);
      f10 = Math_fround(HEAPF32[i23 >> 2]);
      f7 = Math_fround(f7 - f10);
      f9 = Math_fround(HEAPF32[i23 + 16 >> 2]);
      f8 = Math_fround(HEAPF32[i23 + 4 >> 2]);
      f9 = Math_fround(f9 - f8);
      f6 = Math_fround(HEAPF32[i23 + 20 >> 2]);
      f37 = Math_fround(HEAPF32[i23 + 8 >> 2]);
      f6 = Math_fround(f6 - f37);
      f10 = Math_fround(Math_fround(HEAPF32[i23 + 24 >> 2]) - f10);
      f8 = Math_fround(Math_fround(HEAPF32[i23 + 28 >> 2]) - f8);
      f37 = Math_fround(Math_fround(HEAPF32[i23 + 32 >> 2]) - f37);
      f11 = Math_fround(Math_fround(f9 * f37) - Math_fround(f6 * f8));
      f37 = Math_fround(Math_fround(f6 * f10) - Math_fround(f7 * f37));
      f10 = Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10));
      if (Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f37 * f37))) == Math_fround(0.0)) break L61;
      i2 = HEAP32[i31 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i29, i34); else {
       __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2, i34);
       HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 20;
      }
      HEAP8[(HEAP32[i35 >> 2] | 0) + i1 >> 0] = 1;
     } while ((i1 | 0) != (HEAP32[(HEAP32[i26 >> 2] | 0) + (i4 << 2) >> 2] | 0)); while (0);
     i1 = HEAP32[(HEAP32[i26 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     L72 : do if ((i1 | 0) != -1) if ((i1 | 0) != (HEAP32[(HEAP32[i28 >> 2] | 0) + (i4 << 2) >> 2] | 0)) do {
      i2 = i1;
      i1 = ((i1 | 0) == 0 ? i30 : i1) + -1 | 0;
      if (HEAP8[(HEAP32[i35 >> 2] | 0) + i2 >> 0] | 0) break L72;
      i23 = HEAP32[i34 >> 2] | 0;
      i22 = (HEAP32[i33 >> 2] | 0) + (i4 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = (HEAP32[i34 >> 2] | 0) + 12 | 0;
      i22 = (HEAP32[i32 >> 2] | 0) + (i1 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = (HEAP32[i34 >> 2] | 0) + 24 | 0;
      i22 = (HEAP32[i32 >> 2] | 0) + (i2 * 12 | 0) | 0;
      HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      i23 = HEAP32[i34 >> 2] | 0;
      f7 = Math_fround(HEAPF32[i23 + 12 >> 2]);
      f10 = Math_fround(HEAPF32[i23 >> 2]);
      f7 = Math_fround(f7 - f10);
      f9 = Math_fround(HEAPF32[i23 + 16 >> 2]);
      f8 = Math_fround(HEAPF32[i23 + 4 >> 2]);
      f9 = Math_fround(f9 - f8);
      f6 = Math_fround(HEAPF32[i23 + 20 >> 2]);
      f37 = Math_fround(HEAPF32[i23 + 8 >> 2]);
      f6 = Math_fround(f6 - f37);
      f10 = Math_fround(Math_fround(HEAPF32[i23 + 24 >> 2]) - f10);
      f8 = Math_fround(Math_fround(HEAPF32[i23 + 28 >> 2]) - f8);
      f37 = Math_fround(Math_fround(HEAPF32[i23 + 32 >> 2]) - f37);
      f11 = Math_fround(Math_fround(f9 * f37) - Math_fround(f6 * f8));
      f37 = Math_fround(Math_fround(f6 * f10) - Math_fround(f7 * f37));
      f10 = Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10));
      if (Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f37 * f37))) == Math_fround(0.0)) break L72;
      i3 = HEAP32[i31 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i29, i34); else {
       __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i3, i34);
       HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 20;
      }
      HEAP8[(HEAP32[i35 >> 2] | 0) + i2 >> 0] = 1;
     } while ((i1 | 0) != (HEAP32[(HEAP32[i28 >> 2] | 0) + (i4 << 2) >> 2] | 0)); while (0);
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i27 | 0));
   }
  }
  if ((HEAP32[i17 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i18);
   HEAP32[i26 >> 2] = 0;
  }
  if ((HEAP32[i19 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i20);
   HEAP32[i28 >> 2] = 0;
  }
 }
 if ((HEAP32[i24 >> 2] | 0) <= -1) {
  STACKTOP = i36;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i25);
 HEAP32[i35 >> 2] = 0;
 STACKTOP = i36;
 return;
}

function __ZL19sweepBoxVsTrianglesjPKN5physx10PxTriangleERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEbPKj(i34, i51, i75, i52, f33, i76, i63, i61, i1) {
 i34 = i34 | 0;
 i51 = i51 | 0;
 i75 = i75 | 0;
 i52 = i52 | 0;
 f33 = Math_fround(f33);
 i76 = i76 | 0;
 i63 = i63 | 0;
 i61 = i61 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, f50 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i62 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i77 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i62 = i77 + 28 | 0;
 i56 = i77 + 16 | 0;
 i57 = i77 + 4 | 0;
 i55 = i77 + 40 | 0;
 i35 = i77;
 if (!i34) {
  i76 = 0;
  STACKTOP = i77;
  return i76 | 0;
 }
 i58 = (HEAP16[i63 >> 1] & 128) == 0;
 i29 = i58 & (i61 ^ 1);
 f44 = Math_fround(HEAPF32[i75 >> 2]);
 i72 = i75 + 4 | 0;
 f48 = Math_fround(HEAPF32[i72 >> 2]);
 i73 = i75 + 8 | 0;
 f50 = Math_fround(HEAPF32[i73 >> 2]);
 i74 = i75 + 12 | 0;
 f36 = Math_fround(HEAPF32[i74 >> 2]);
 i64 = i75 + 16 | 0;
 f37 = Math_fround(HEAPF32[i64 >> 2]);
 i65 = i75 + 20 | 0;
 f38 = Math_fround(HEAPF32[i65 >> 2]);
 i66 = i75 + 24 | 0;
 f39 = Math_fround(HEAPF32[i66 >> 2]);
 i67 = i75 + 28 | 0;
 f40 = Math_fround(HEAPF32[i67 >> 2]);
 i68 = i75 + 32 | 0;
 f41 = Math_fround(HEAPF32[i68 >> 2]);
 i69 = i75 + 36 | 0;
 f17 = Math_fround(HEAPF32[i69 >> 2]);
 i70 = i75 + 40 | 0;
 f19 = Math_fround(HEAPF32[i70 >> 2]);
 i71 = i75 + 44 | 0;
 f21 = Math_fround(HEAPF32[i71 >> 2]);
 f15 = Math_fround(-f17);
 f18 = Math_fround(-f19);
 f45 = Math_fround(-f21);
 f42 = Math_fround(Math_fround(Math_fround(f44 * f15) + Math_fround(f48 * f18)) + Math_fround(f50 * f45));
 f43 = Math_fround(Math_fround(Math_fround(f36 * f15) + Math_fround(f37 * f18)) + Math_fround(f38 * f45));
 f45 = Math_fround(Math_fround(Math_fround(f39 * f15) + Math_fround(f40 * f18)) + Math_fround(f41 * f45));
 f18 = Math_fround(HEAPF32[i52 >> 2]);
 f15 = Math_fround(f44 * f18);
 f16 = Math_fround(f36 * f18);
 f31 = Math_fround(f39 * f18);
 i46 = i52 + 4 | 0;
 f20 = Math_fround(HEAPF32[i46 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f48 * f20));
 f16 = Math_fround(f16 + Math_fround(f37 * f20));
 f31 = Math_fround(f31 + Math_fround(f40 * f20));
 i47 = i52 + 8 | 0;
 f32 = Math_fround(HEAPF32[i47 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f50 * f32));
 f16 = Math_fround(f16 + Math_fround(f38 * f32));
 f31 = Math_fround(f31 + Math_fround(f41 * f32));
 HEAPF32[i62 >> 2] = f15;
 i59 = i62 + 4 | 0;
 HEAPF32[i59 >> 2] = f16;
 i60 = i62 + 8 | 0;
 HEAPF32[i60 >> 2] = f31;
 f12 = Math_fround(f15 * f33);
 f13 = Math_fround(f16 * f33);
 f14 = Math_fround(f31 * f33);
 HEAPF32[i56 >> 2] = f12;
 HEAPF32[i56 + 4 >> 2] = f13;
 HEAPF32[i56 + 8 >> 2] = f14;
 i49 = i76 + 40 | 0;
 HEAPF32[i49 >> 2] = f33;
 i54 = f15 != Math_fround(0.0);
 f12 = Math_fround(Math_fround(1.0) / f12);
 f12 = i54 ? f12 : Math_fround(0.0);
 i54 = f16 != Math_fround(0.0);
 f13 = Math_fround(Math_fround(1.0) / f13);
 f13 = i54 ? f13 : Math_fround(0.0);
 i54 = f31 != Math_fround(0.0);
 f14 = Math_fround(Math_fround(1.0) / f14);
 f14 = i54 ? f14 : Math_fround(0.0);
 HEAPF32[i57 >> 2] = f12;
 HEAPF32[i57 + 4 >> 2] = f13;
 HEAPF32[i57 + 8 >> 2] = f14;
 f15 = Math_fround(Math_abs(Math_fround(f15)));
 i54 = i75 + 48 | 0;
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i54 >> 2]));
 f16 = Math_fround(Math_abs(Math_fround(f16)));
 f16 = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i75 + 52 >> 2])));
 f31 = Math_fround(Math_abs(Math_fround(f31)));
 f31 = Math_fround(f16 + Math_fround(f31 * Math_fround(HEAPF32[i75 + 56 >> 2])));
 f32 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(f19 * f20)) + Math_fround(f21 * f32));
 if (!i1) i27 = 0; else i27 = HEAP32[i1 >> 2] | 0;
 i7 = i55 + 4 | 0;
 i8 = i55 + 8 | 0;
 i9 = i55 + 12 | 0;
 i22 = i55 + 16 | 0;
 i23 = i55 + 20 | 0;
 i24 = i55 + 24 | 0;
 i25 = i55 + 28 | 0;
 i26 = i55 + 32 | 0;
 i30 = i76 + 8 | 0;
 f2 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 i28 = 0;
 f21 = Math_fround(1.0);
 i6 = 0;
 while (1) {
  i1 = (i28 | 0) == 0 ? i27 : (i28 | 0) == (i27 | 0) ? 0 : i28;
  f78 = Math_fround(f21 * f33);
  f3 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) >> 2]);
  f19 = Math_fround(HEAPF32[i52 >> 2]);
  f12 = Math_fround(f3 * f19);
  f10 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 4 >> 2]);
  f79 = Math_fround(HEAPF32[i46 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f10 * f79));
  f11 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i47 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f11 * f20));
  f13 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 12 >> 2]);
  f16 = Math_fround(f19 * f13);
  f14 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 16 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f79 * f14));
  f15 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 20 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f20 * f15));
  f17 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 24 >> 2]);
  f19 = Math_fround(f19 * f17);
  f18 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 28 >> 2]);
  f79 = Math_fround(f19 + Math_fround(f79 * f18));
  f19 = Math_fround(HEAPF32[i51 + (i1 * 36 | 0) + 32 >> 2]);
  f20 = Math_fround(f79 + Math_fround(f20 * f19));
  f79 = f12 < f16 ? f12 : f16;
  if ((f79 < f20 ? f79 : f20) > Math_fround(Math_fround(f31 + Math_fround(f32 + f78)) + Math_fround(.00999999977))) {
   f12 = f2;
   f11 = f4;
   f10 = f5;
   f3 = f21;
   i1 = i6;
  } else if (f12 < f32 & f16 < f32 & f20 < f32) {
   f12 = f2;
   f11 = f4;
   f10 = f5;
   f3 = f21;
   i1 = i6;
  } else {
   f82 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f36 * f3) + Math_fround(f37 * f10)) + Math_fround(f38 * f11)));
   f81 = Math_fround(f45 + Math_fround(Math_fround(Math_fround(f39 * f3) + Math_fround(f40 * f10)) + Math_fround(f41 * f11)));
   f80 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f44 * f13) + Math_fround(f48 * f14)) + Math_fround(f50 * f15)));
   f12 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f36 * f13) + Math_fround(f37 * f14)) + Math_fround(f38 * f15)));
   f16 = Math_fround(f45 + Math_fround(Math_fround(Math_fround(f39 * f13) + Math_fround(f40 * f14)) + Math_fround(f41 * f15)));
   f20 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f44 * f17) + Math_fround(f48 * f18)) + Math_fround(f50 * f19)));
   f78 = Math_fround(f43 + Math_fround(Math_fround(Math_fround(f36 * f17) + Math_fround(f37 * f18)) + Math_fround(f38 * f19)));
   f79 = Math_fround(f45 + Math_fround(Math_fround(Math_fround(f39 * f17) + Math_fround(f40 * f18)) + Math_fround(f41 * f19)));
   HEAPF32[i55 >> 2] = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f44 * f3) + Math_fround(f48 * f10)) + Math_fround(f50 * f11)));
   HEAPF32[i7 >> 2] = f82;
   HEAPF32[i8 >> 2] = f81;
   HEAPF32[i9 >> 2] = f80;
   HEAPF32[i22 >> 2] = f12;
   HEAPF32[i23 >> 2] = f16;
   HEAPF32[i24 >> 2] = f20;
   HEAPF32[i25 >> 2] = f78;
   HEAPF32[i26 >> 2] = f79;
   HEAPF32[i35 >> 2] = Math_fround(3402823469999999843913219.0e14);
   if (!(__ZN5physx2Gu23triBoxSweepTestBoxSpaceERKNS_10PxTriangleERKNS_6PxVec3ES6_S6_fRfb(i55, i54, i56, i57, f21, i35, i29) | 0)) {
    f3 = f21;
    i1 = i6;
   } else {
    f3 = Math_fround(HEAPF32[i35 >> 2]);
    if (!(f3 <= f21)) {
     f3 = f21;
     i1 = i6;
    } else {
     if (f3 == Math_fround(0.0)) {
      i53 = 12;
      break;
     }
     HEAPF32[i49 >> 2] = Math_fround(f3 * f33);
     HEAP32[i30 >> 2] = i1;
     f4 = Math_fround(HEAPF32[i9 >> 2]);
     f79 = Math_fround(HEAPF32[i55 >> 2]);
     f4 = Math_fround(f4 - f79);
     f80 = Math_fround(HEAPF32[i22 >> 2]);
     f2 = Math_fround(HEAPF32[i7 >> 2]);
     f80 = Math_fround(f80 - f2);
     f82 = Math_fround(HEAPF32[i23 >> 2]);
     f81 = Math_fround(HEAPF32[i8 >> 2]);
     f82 = Math_fround(f82 - f81);
     f79 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f79);
     f2 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f2);
     f81 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f81);
     f5 = Math_fround(Math_fround(f4 * f2) - Math_fround(f80 * f79));
     f4 = Math_fround(Math_fround(f82 * f79) - Math_fround(f4 * f81));
     f2 = Math_fround(Math_fround(f80 * f81) - Math_fround(f82 * f2));
     i1 = 1;
    }
   }
   f12 = f2;
   f11 = f4;
   f10 = f5;
  }
  i28 = i28 + 1 | 0;
  if (i28 >>> 0 >= i34 >>> 0) break; else {
   f2 = f12;
   f4 = f11;
   f5 = f10;
   f21 = f3;
   i6 = i1;
  }
 }
 if ((i53 | 0) == 12) {
  HEAP16[i76 + 12 >> 1] = 6;
  HEAPF32[i49 >> 2] = Math_fround(0.0);
  HEAP32[i30 >> 2] = i1;
  f80 = Math_fround(-Math_fround(HEAPF32[i52 >> 2]));
  f81 = Math_fround(-Math_fround(HEAPF32[i46 >> 2]));
  f82 = Math_fround(-Math_fround(HEAPF32[i47 >> 2]));
  HEAPF32[i76 + 28 >> 2] = f80;
  HEAPF32[i76 + 32 >> 2] = f81;
  HEAPF32[i76 + 36 >> 2] = f82;
  i76 = 1;
  STACKTOP = i77;
  return i76 | 0;
 }
 if (!i1) {
  i76 = 0;
  STACKTOP = i77;
  return i76 | 0;
 }
 i9 = i76 + 12 | 0;
 HEAP16[i9 >> 1] = 4;
 if (!(HEAP16[i63 >> 1] & 3)) {
  i76 = 1;
  STACKTOP = i77;
  return i76 | 0;
 }
 i8 = HEAP32[i76 + 8 >> 2] | 0;
 f32 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) >> 2]);
 f21 = Math_fround(f44 * f32);
 f31 = Math_fround(f36 * f32);
 f32 = Math_fround(f39 * f32);
 f79 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 4 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f48 * f79));
 f31 = Math_fround(f31 + Math_fround(f37 * f79));
 f79 = Math_fround(f32 + Math_fround(f40 * f79));
 f32 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 8 >> 2]);
 f21 = Math_fround(f42 + Math_fround(f21 + Math_fround(f50 * f32)));
 f31 = Math_fround(f43 + Math_fround(f31 + Math_fround(f38 * f32)));
 f32 = Math_fround(f45 + Math_fround(f79 + Math_fround(f41 * f32)));
 f79 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 12 >> 2]);
 f33 = Math_fround(f44 * f79);
 f78 = Math_fround(f36 * f79);
 f79 = Math_fround(f39 * f79);
 f82 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 16 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f48 * f82));
 f78 = Math_fround(f78 + Math_fround(f37 * f82));
 f82 = Math_fround(f79 + Math_fround(f40 * f82));
 f79 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 20 >> 2]);
 f33 = Math_fround(f42 + Math_fround(f33 + Math_fround(f50 * f79)));
 f78 = Math_fround(f43 + Math_fround(f78 + Math_fround(f38 * f79)));
 f79 = Math_fround(f45 + Math_fround(f82 + Math_fround(f41 * f79)));
 f82 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 24 >> 2]);
 f80 = Math_fround(f44 * f82);
 f81 = Math_fround(f36 * f82);
 f44 = Math_fround(f39 * f82);
 f82 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 28 >> 2]);
 f80 = Math_fround(f80 + Math_fround(f48 * f82));
 f81 = Math_fround(f81 + Math_fround(f37 * f82));
 f48 = Math_fround(f44 + Math_fround(f40 * f82));
 f82 = Math_fround(HEAPF32[i51 + (i8 * 36 | 0) + 32 >> 2]);
 f80 = Math_fround(f42 + Math_fround(f80 + Math_fround(f50 * f82)));
 f81 = Math_fround(f43 + Math_fround(f81 + Math_fround(f38 * f82)));
 f82 = Math_fround(f45 + Math_fround(f48 + Math_fround(f41 * f82)));
 HEAPF32[i55 >> 2] = f21;
 HEAPF32[i55 + 4 >> 2] = f31;
 HEAPF32[i55 + 8 >> 2] = f32;
 HEAPF32[i55 + 12 >> 2] = f33;
 HEAPF32[i55 + 16 >> 2] = f78;
 HEAPF32[i55 + 20 >> 2] = f79;
 HEAPF32[i55 + 24 >> 2] = f80;
 HEAPF32[i55 + 28 >> 2] = f81;
 HEAPF32[i55 + 32 >> 2] = f82;
 i8 = i76 + 16 | 0;
 i7 = i76 + 28 | 0;
 __ZN5physx2Gu23computeBoxTriImpactDataERNS_6PxVec3ES2_RKS1_S4_S4_S4_RKNS_10PxTriangleE(i8, i7, i54, i62, i56, i57, i55);
 i1 = HEAP16[i63 >> 1] | 0;
 if (i1 & 2) {
  f4 = Math_fround(HEAPF32[i7 >> 2]);
  f5 = Math_fround(f4 * f4);
  i1 = i76 + 32 | 0;
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f3 * f3));
  i6 = i76 + 36 | 0;
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f2 * f2))));
  if (f5 > Math_fround(0.0)) {
   f82 = Math_fround(Math_fround(1.0) / f5);
   f4 = Math_fround(f4 * f82);
   HEAPF32[i7 >> 2] = f4;
   f3 = Math_fround(f3 * f82);
   HEAPF32[i1 >> 2] = f3;
   f2 = Math_fround(f2 * f82);
   HEAPF32[i6 >> 2] = f2;
  }
  if (!(i58 | i61)) {
   f82 = Math_fround(f12 * Math_fround(HEAPF32[i62 >> 2]));
   f82 = Math_fround(f82 + Math_fround(f11 * Math_fround(HEAPF32[i59 >> 2])));
   if (Math_fround(f82 + Math_fround(f10 * Math_fround(HEAPF32[i60 >> 2]))) > Math_fround(0.0)) {
    f4 = Math_fround(-f4);
    f3 = Math_fround(-f3);
    f2 = Math_fround(-f2);
    HEAPF32[i7 >> 2] = f4;
    HEAPF32[i1 >> 2] = f3;
    HEAPF32[i6 >> 2] = f2;
   }
  }
  f81 = Math_fround(f4 * Math_fround(HEAPF32[i75 >> 2]));
  f80 = Math_fround(f4 * Math_fround(HEAPF32[i72 >> 2]));
  f82 = Math_fround(f4 * Math_fround(HEAPF32[i73 >> 2]));
  f79 = Math_fround(f3 * Math_fround(HEAPF32[i74 >> 2]));
  f78 = Math_fround(f3 * Math_fround(HEAPF32[i64 >> 2]));
  f79 = Math_fround(f81 + f79);
  f78 = Math_fround(f80 + f78);
  f82 = Math_fround(f82 + Math_fround(f3 * Math_fround(HEAPF32[i65 >> 2])));
  f80 = Math_fround(f2 * Math_fround(HEAPF32[i66 >> 2]));
  f81 = Math_fround(f2 * Math_fround(HEAPF32[i67 >> 2]));
  f81 = Math_fround(f78 + f81);
  f82 = Math_fround(f82 + Math_fround(f2 * Math_fround(HEAPF32[i68 >> 2])));
  HEAPF32[i7 >> 2] = Math_fround(f79 + f80);
  HEAPF32[i1 >> 2] = f81;
  HEAPF32[i6 >> 2] = f82;
  HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 2;
  i1 = HEAP16[i63 >> 1] | 0;
 }
 if (i1 & 1) {
  f82 = Math_fround(HEAPF32[i8 >> 2]);
  f81 = Math_fround(f82 * Math_fround(HEAPF32[i75 >> 2]));
  f80 = Math_fround(f82 * Math_fround(HEAPF32[i72 >> 2]));
  f82 = Math_fround(f82 * Math_fround(HEAPF32[i73 >> 2]));
  i75 = i76 + 20 | 0;
  f79 = Math_fround(HEAPF32[i75 >> 2]);
  f50 = Math_fround(f79 * Math_fround(HEAPF32[i74 >> 2]));
  f78 = Math_fround(f79 * Math_fround(HEAPF32[i64 >> 2]));
  f50 = Math_fround(f81 + f50);
  f78 = Math_fround(f80 + f78);
  f79 = Math_fround(f82 + Math_fround(f79 * Math_fround(HEAPF32[i65 >> 2])));
  i76 = i76 + 24 | 0;
  f82 = Math_fround(HEAPF32[i76 >> 2]);
  f80 = Math_fround(f82 * Math_fround(HEAPF32[i66 >> 2]));
  f81 = Math_fround(f82 * Math_fround(HEAPF32[i67 >> 2]));
  f80 = Math_fround(f50 + f80);
  f81 = Math_fround(f78 + f81);
  f82 = Math_fround(f79 + Math_fround(f82 * Math_fround(HEAPF32[i68 >> 2])));
  f80 = Math_fround(f80 + Math_fround(HEAPF32[i69 >> 2]));
  f81 = Math_fround(f81 + Math_fround(HEAPF32[i70 >> 2]));
  f82 = Math_fround(f82 + Math_fround(HEAPF32[i71 >> 2]));
  HEAPF32[i8 >> 2] = f80;
  HEAPF32[i75 >> 2] = f81;
  HEAPF32[i76 >> 2] = f82;
  HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 1;
 }
 i76 = 1;
 STACKTOP = i77;
 return i76 | 0;
}

function __ZN9ShaderLab21SerializedShaderState8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i5 = i11 + 4 | 0;
 i6 = i11 + 8 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i10, i8, 1); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 11 | 0;
 i2 = 0;
 do {
  i4 = i8 + 64 + (i2 * 56 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  __Z6FormatPKcz(i6, gb + 471386 | 0, i9);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, gb + 471396 | 0, i5, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI14SafeBinaryReadEEvRT_(i4, i10); else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 8);
 i3 = i8 + 717 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471370 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i10, 1) | 0) {
  i2 = i8 + 64 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471425 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 72 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471461 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 80 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471471 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 88 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471485 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 96 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471500 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 104 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471508 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i2 = i8 + 112 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471521 | 0, gb + 471434 | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471529 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471535 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471542 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471550 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471563 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471575 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 512 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471587 | 0, gb + 471597 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 544 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471617 | 0, gb + 471597 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 576 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471632 | 0, gb + 471597 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 608 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471646 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 616 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471662 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 624 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471679 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 632 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471690 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 640 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471699 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 648 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471706 | 0, gb + 471434 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 656 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471717 | 0, gb + 471726 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN9ShaderLab27SerializedShaderVectorValue8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead7FogModeEvRT_RT0_PKc17TransferMetaFlags(i10, i8 + 692 | 0, gb + 471754 | 0, 0);
 i4 = i8 + 696 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471762 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i7 = 169; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 169;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 169) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 700 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 470710 | 0, gb + 470717 | 0, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 712 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 470734 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 186; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 186;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 186) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i10 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 716 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471775 | 0, i6, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 L260 : do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i9 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L260;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function _write_file_header(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i4 + 332 >> 2] | 0;
 i3 = i4 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = -1;
 i6 = i1 + 4 | 0;
 i5 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i5;
 if (!i5) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = -40;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 HEAP32[i2 + 28 >> 2] = 0;
 do if (HEAP8[i4 + 196 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -1;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -32;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 16;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 74;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 70;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 73;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 70;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i6 = HEAP8[i4 + 197 >> 0] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i6;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i6 = HEAP8[i4 + 198 >> 0] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i6;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i6 = HEAP8[i4 + 199 >> 0] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i6;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i2 = HEAP16[i4 + 200 >> 1] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = (i2 & 65535) >>> 8;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i2;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  }
  i2 = HEAP16[i4 + 202 >> 1] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = (i2 & 65535) >>> 8;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  do if (!i6) {
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) break;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  } while (0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = i2;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  do if (!i6) {
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) break;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  } while (0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  do if (!i6) {
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) break;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  } while (0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 4 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  if (i6 | 0) break;
  if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) break;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 } while (0);
 if (!(HEAP8[i4 + 204 >> 0] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = -1;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = -18;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 14;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 65;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 100;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 111;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 98;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 101;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 100;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = 0;
 i5 = i1 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 do if (!i6) {
  if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) break;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
 } while (0);
 switch (HEAP32[i4 + 64 >> 2] | 0) {
 case 3:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i5 + 1;
   HEAP8[i5 >> 0] = 1;
   i5 = i1 + 4 | 0;
   i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   HEAP32[i5 >> 2] = i6;
   if (i6 | 0) return;
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) return;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
   return;
  }
 case 5:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i5 + 1;
   HEAP8[i5 >> 0] = 2;
   i5 = i1 + 4 | 0;
   i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   HEAP32[i5 >> 2] = i6;
   if (i6 | 0) return;
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) return;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
   return;
  }
 default:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i5 + 1;
   HEAP8[i5 >> 0] = 0;
   i5 = i1 + 4 | 0;
   i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   HEAP32[i5 >> 2] = i6;
   if (i6 | 0) return;
   if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) return;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
   return;
  }
 }
}

function __ZN15b2ContactSolver24SolveVelocityConstraintsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0, f33 = f0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0;
 i45 = i1 + 48 | 0;
 if ((HEAP32[i45 >> 2] | 0) <= 0) return;
 i46 = i1 + 40 | 0;
 i43 = i1 + 28 | 0;
 i39 = 0;
 i7 = HEAP32[i43 >> 2] | 0;
 do {
  i34 = HEAP32[i46 >> 2] | 0;
  i31 = i34 + (i39 * 156 | 0) | 0;
  i44 = HEAP32[i34 + (i39 * 156 | 0) + 112 >> 2] | 0;
  i41 = HEAP32[i34 + (i39 * 156 | 0) + 116 >> 2] | 0;
  f35 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 120 >> 2]);
  f36 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 128 >> 2]);
  f37 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 124 >> 2]);
  f38 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 132 >> 2]);
  i15 = i34 + (i39 * 156 | 0) + 148 | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  i42 = i7 + (i44 * 12 | 0) | 0;
  i3 = HEAP32[i42 >> 2] | 0;
  i40 = i7 + (i44 * 12 | 0) + 4 | 0;
  i1 = HEAP32[i40 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i7 + (i44 * 12 | 0) + 8 >> 2]);
  i4 = HEAP32[i7 + (i41 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i7 + (i41 * 12 | 0) + 4 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i7 + (i41 * 12 | 0) + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 72 >> 2]);
  f33 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 76 >> 2]);
  f12 = Math_fround(-f32);
  f13 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 136 >> 2]);
  if ((i16 | 0) > 0) {
   i14 = i34 + (i39 * 156 | 0) + 144 | 0;
   i7 = 0;
   do {
    f29 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 12 >> 2]);
    f28 = Math_fround(f5 * f29);
    f27 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 8 >> 2]);
    f23 = Math_fround(f5 * f27);
    f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f28 = Math_fround(f11 - f28);
    f26 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f26 + f23);
    f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f28 = Math_fround(f28 - f9);
    f24 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f23 - f24);
    f8 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 4 >> 2]);
    f30 = Math_fround(f6 * f8);
    f25 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) >> 2]);
    f23 = Math_fround(Math_fround(f33 * Math_fround(f28 + f30)) + Math_fround(Math_fround(f23 - Math_fround(f6 * f25)) * f12));
    f23 = Math_fround(f23 - Math_fround(HEAPF32[i14 >> 2]));
    f23 = Math_fround(Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 28 >> 2]) * f23);
    f30 = Math_fround(f13 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 16 >> 2]));
    i48 = i34 + (i39 * 156 | 0) + (i7 * 36 | 0) + 20 | 0;
    f28 = Math_fround(HEAPF32[i48 >> 2]);
    f23 = Math_fround(f28 - f23);
    f10 = Math_fround(-f30);
    f30 = f23 < f30 ? f23 : f30;
    f30 = f30 < f10 ? f10 : f30;
    f28 = Math_fround(f30 - f28);
    HEAPF32[i48 >> 2] = f30;
    f30 = Math_fround(f33 * f28);
    f28 = Math_fround(f28 * f12);
    f10 = Math_fround(f35 * f28);
    f9 = Math_fround(f9 - Math_fround(f35 * f30));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
    f10 = Math_fround(f24 - f10);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(f25 * f28) - Math_fround(f8 * f30))));
    f8 = Math_fround(f37 * f28);
    f11 = Math_fround(f11 + Math_fround(f37 * f30));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    f8 = Math_fround(f26 + f8);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(f27 * f28) - Math_fround(f29 * f30))));
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i16 | 0));
   if ((HEAP32[i15 >> 2] | 0) == 1) {
    f30 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 12 >> 2]);
    f24 = Math_fround(f5 * f30);
    f29 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 8 >> 2]);
    f24 = Math_fround(Math_fround(f11 - f24) - f9);
    f25 = Math_fround(Math_fround(f8 + Math_fround(f5 * f29)) - f10);
    f28 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 4 >> 2]);
    f26 = Math_fround(f6 * f28);
    f27 = Math_fround(HEAPF32[i31 >> 2]);
    f25 = Math_fround(Math_fround(f32 * Math_fround(f24 + f26)) + Math_fround(f33 * Math_fround(f25 - Math_fround(f6 * f27))));
    f26 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 24 >> 2]);
    f25 = Math_fround(f26 * Math_fround(f25 - Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 32 >> 2])));
    i3 = i34 + (i39 * 156 | 0) + 16 | 0;
    f26 = Math_fround(HEAPF32[i3 >> 2]);
    f25 = Math_fround(f26 - f25);
    i1 = f25 > Math_fround(0.0);
    f25 = i1 ? f25 : Math_fround(0.0);
    f26 = Math_fround(f25 - f26);
    HEAPF32[i3 >> 2] = f25;
    f32 = Math_fround(f32 * f26);
    f33 = Math_fround(f33 * f26);
    f26 = Math_fround(f35 * f33);
    f35 = Math_fround(f9 - Math_fround(f35 * f32));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f10 - f26);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(f27 * f33) - Math_fround(f28 * f32))));
    f36 = Math_fround(f37 * f33);
    f37 = Math_fround(f11 + Math_fround(f37 * f32));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f8 + f36);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(f29 * f33) - Math_fround(f30 * f32))));
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   } else i47 = 9;
  } else i47 = 9;
  do if ((i47 | 0) == 9) {
   i47 = 0;
   i7 = i34 + (i39 * 156 | 0) + 16 | 0;
   f22 = Math_fround(HEAPF32[i7 >> 2]);
   i14 = i34 + (i39 * 156 | 0) + 52 | 0;
   f23 = Math_fround(HEAPF32[i14 >> 2]);
   f24 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 12 >> 2]);
   f12 = Math_fround(f5 * f24);
   f25 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 8 >> 2]);
   f49 = Math_fround(f5 * f25);
   f26 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(f26 - f12);
   f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f49 = Math_fround(f27 + f49);
   f28 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(f12 - f28);
   f29 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f49 = Math_fround(f49 - f29);
   f30 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 4 >> 2]);
   f10 = Math_fround(f6 * f30);
   f11 = Math_fround(HEAPF32[i31 >> 2]);
   f10 = Math_fround(f12 + f10);
   f49 = Math_fround(f49 - Math_fround(f6 * f11));
   f12 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 48 >> 2]);
   f19 = Math_fround(f5 * f12);
   f13 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 44 >> 2]);
   f19 = Math_fround(Math_fround(f26 - f19) - f28);
   f50 = Math_fround(Math_fround(f27 + Math_fround(f5 * f13)) - f29);
   f17 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 40 >> 2]);
   f20 = Math_fround(f6 * f17);
   f18 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 36 >> 2]);
   f49 = Math_fround(Math_fround(f32 * f10) + Math_fround(f33 * f49));
   f50 = Math_fround(Math_fround(f32 * Math_fround(f19 + f20)) + Math_fround(f33 * Math_fround(f50 - Math_fround(f6 * f18))));
   f49 = Math_fround(f49 - Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 32 >> 2]));
   f50 = Math_fround(f50 - Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 68 >> 2]));
   f20 = Math_fround(f22 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 96 >> 2]));
   f19 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 104 >> 2]);
   f20 = Math_fround(f20 + Math_fround(f23 * f19));
   f10 = Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 100 >> 2]);
   f21 = Math_fround(f22 * f10);
   f20 = Math_fround(f49 - f20);
   f21 = Math_fround(f50 - Math_fround(f21 + Math_fround(f23 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 108 >> 2]))));
   f50 = Math_fround(Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 80 >> 2]) * f20);
   f50 = Math_fround(f50 + Math_fround(Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 88 >> 2]) * f21));
   f49 = Math_fround(f20 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 84 >> 2]));
   f49 = Math_fround(f49 + Math_fround(f21 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 92 >> 2])));
   f8 = Math_fround(-f50);
   f9 = Math_fround(-f49);
   if (!(!(f50 <= Math_fround(-0.0)) | !(f49 <= Math_fround(-0.0)))) {
    f22 = Math_fround(f8 - f22);
    f49 = Math_fround(f9 - f23);
    f23 = Math_fround(f32 * f22);
    f22 = Math_fround(f33 * f22);
    f50 = Math_fround(f32 * f49);
    f49 = Math_fround(f33 * f49);
    f33 = Math_fround(f23 + f50);
    f32 = Math_fround(f22 + f49);
    f21 = Math_fround(f35 * f32);
    f35 = Math_fround(f28 - Math_fround(f35 * f33));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f29 - f21);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(Math_fround(f11 * f22) - Math_fround(f30 * f23)) + Math_fround(Math_fround(f18 * f49) - Math_fround(f17 * f50)))));
    f36 = Math_fround(f37 * f32);
    f37 = Math_fround(f26 + Math_fround(f37 * f33));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f27 + f36);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f25 * f22) - Math_fround(f24 * f23)) + Math_fround(Math_fround(f13 * f49) - Math_fround(f12 * f50)))));
    HEAPF32[i7 >> 2] = f8;
    HEAPF32[i14 >> 2] = f9;
    break;
   }
   f50 = Math_fround(f20 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 24 >> 2]));
   f8 = Math_fround(-f50);
   if (f50 <= Math_fround(-0.0) ? Math_fround(f21 + Math_fround(f10 * f8)) >= Math_fround(0.0) : 0) {
    f22 = Math_fround(f8 - f22);
    f49 = Math_fround(Math_fround(0.0) - f23);
    f23 = Math_fround(f32 * f22);
    f22 = Math_fround(f33 * f22);
    f50 = Math_fround(f32 * f49);
    f49 = Math_fround(f33 * f49);
    f33 = Math_fround(f50 + f23);
    f32 = Math_fround(f49 + f22);
    f21 = Math_fround(f35 * f32);
    f35 = Math_fround(f28 - Math_fround(f35 * f33));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f29 - f21);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(Math_fround(f22 * f11) - Math_fround(f23 * f30)) + Math_fround(Math_fround(f49 * f18) - Math_fround(f50 * f17)))));
    f36 = Math_fround(f37 * f32);
    f37 = Math_fround(f26 + Math_fround(f37 * f33));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f27 + f36);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f22 * f25) - Math_fround(f23 * f24)) + Math_fround(Math_fround(f49 * f13) - Math_fround(f50 * f12)))));
    HEAPF32[i7 >> 2] = f8;
    HEAP32[i14 >> 2] = 0;
    break;
   }
   f50 = Math_fround(f21 * Math_fround(HEAPF32[i34 + (i39 * 156 | 0) + 60 >> 2]));
   f8 = Math_fround(-f50);
   if (f50 <= Math_fround(-0.0) ? Math_fround(f20 + Math_fround(f19 * f8)) >= Math_fround(0.0) : 0) {
    f22 = Math_fround(Math_fround(0.0) - f22);
    f49 = Math_fround(f8 - f23);
    f23 = Math_fround(f32 * f22);
    f22 = Math_fround(f33 * f22);
    f50 = Math_fround(f32 * f49);
    f49 = Math_fround(f33 * f49);
    f33 = Math_fround(f23 + f50);
    f32 = Math_fround(f22 + f49);
    f21 = Math_fround(f35 * f32);
    f35 = Math_fround(f28 - Math_fround(f35 * f33));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f29 - f21);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(Math_fround(f22 * f11) - Math_fround(f23 * f30)) + Math_fround(Math_fround(f49 * f18) - Math_fround(f50 * f17)))));
    f36 = Math_fround(f37 * f32);
    f37 = Math_fround(f26 + Math_fround(f37 * f33));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f27 + f36);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f22 * f25) - Math_fround(f23 * f24)) + Math_fround(Math_fround(f49 * f13) - Math_fround(f50 * f12)))));
    HEAP32[i7 >> 2] = 0;
    HEAPF32[i14 >> 2] = f8;
    break;
   }
   if (f20 >= Math_fround(0.0) & f21 >= Math_fround(0.0)) {
    f22 = Math_fround(Math_fround(0.0) - f22);
    f49 = Math_fround(Math_fround(0.0) - f23);
    f23 = Math_fround(f32 * f22);
    f22 = Math_fround(f33 * f22);
    f50 = Math_fround(f32 * f49);
    f49 = Math_fround(f33 * f49);
    f33 = Math_fround(f23 + f50);
    f32 = Math_fround(f22 + f49);
    f21 = Math_fround(f35 * f32);
    f35 = Math_fround(f28 - Math_fround(f35 * f33));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f35 = Math_fround(f29 - f21);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround(f6 - Math_fround(f36 * Math_fround(Math_fround(Math_fround(f22 * f11) - Math_fround(f23 * f30)) + Math_fround(Math_fround(f49 * f18) - Math_fround(f50 * f17)))));
    f36 = Math_fround(f37 * f32);
    f37 = Math_fround(f26 + Math_fround(f37 * f33));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f27 + f36);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f5 + Math_fround(f38 * Math_fround(Math_fround(Math_fround(f22 * f25) - Math_fround(f23 * f24)) + Math_fround(Math_fround(f49 * f13) - Math_fround(f50 * f12)))));
    HEAP32[i7 >> 2] = 0;
    HEAP32[i14 >> 2] = 0;
   }
  } while (0);
  HEAP32[i42 >> 2] = i3;
  HEAP32[i40 >> 2] = i1;
  i7 = HEAP32[i43 >> 2] | 0;
  HEAPF32[i7 + (i44 * 12 | 0) + 8 >> 2] = f6;
  HEAP32[i7 + (i41 * 12 | 0) >> 2] = i4;
  HEAP32[i7 + (i41 * 12 | 0) + 4 >> 2] = i2;
  i7 = HEAP32[i43 >> 2] | 0;
  HEAPF32[i7 + (i41 * 12 | 0) + 8 >> 2] = f5;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) < (HEAP32[i45 >> 2] | 0));
 return;
}

function __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext(i17, i4, i20, i23, i1, i24) {
 i17 = i17 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i27 + 16 | 0;
 i25 = i27;
 i26 = i27 + 32912 | 0;
 i2 = i27 + 32896 | 0;
 i3 = i27 + 32924 | 0;
 i18 = i27 + 80 | 0;
 i19 = __Z22GetRenderBufferManagerv() | 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(__ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 3) | 0, gb + 1113156 | 0, 1);
 if (!(HEAP32[gb + 1113156 >> 2] | 0)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 384285 | 0, 72);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i15, 512, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  if (__ZNK6Camera16GetStereoEnabledEv(i17) | 0) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i19, i20);
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 if ((HEAP16[gb + 1113012 + 6 >> 1] | 0) > -1) {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i25 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113012 | 0, i15);
  i16 = gb + 1113012 | 0;
 } else i16 = 0;
 i21 = HEAP32[gb + 1113012 >> 2] | 0;
 i22 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 648 >> 2] | 0, i22 | 0, i21 | 0);
 i21 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 3;
 i22 = i24 + 4 | 0;
 i12 = HEAP32[i22 >> 2] & -993;
 i14 = (i23 | 0) != 0 & (i1 | 0) == 1;
 HEAP32[i22 >> 2] = (i14 ? i12 | 512 : i12) | 32;
 i12 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i19, -1, -1, 0, 0, 0, 1, 0, 1) | 0;
 if (i12 | 0) mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 40 >> 2] | 0, i12 | 0, gb + 384358 | 0);
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i12, 0, -1, 0, 0);
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 i13 = __Z12GetGfxDevicev() | 0;
 mftCall_viiifi(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, 1, i2 | 0, 1.0, 0);
 __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
 i10 = HEAP32[gb + 1113156 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1113008 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i10, i15, i20);
 i10 = gb + 64016 | 0;
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i25;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i6 = i18 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i25);
 i10 = i15;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i18 + 20 | 0;
 __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId(i8, gb + 383829 | 0, gb + 64016 | 0);
 HEAP32[i18 + 32804 >> 2] = 0;
 HEAP32[i18 + 32808 >> 2] = 0;
 i9 = i24 + 144 | 0;
 i10 = HEAP8[i9 >> 0] | 0;
 HEAP8[i9 >> 0] = 1;
 i11 = i4 + 208 | 0;
 i5 = i4 + 16 | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i11, 2, i24, i18, gb + 1160140 | 0, HEAP32[i5 >> 2] | 0);
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i11, 2, i24, i18, gb + 1160140 | 0, HEAP32[i5 >> 2] | 0);
 HEAP8[i9 >> 0] = i10;
 i4 = __Z16GetBuildSettingsv() | 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i4 = HEAP16[i4 + 116 >> 1] | 0;
 if ((i4 & 255) << 24 >> 24 != 0 & (i4 & 65535) > 255) {
  f28 = Math_fround(HEAPF32[i2 + (i1 * 108 | 0) + 36 >> 2]);
  i4 = HEAP32[i2 + (i1 * 108 | 0) + 20 >> 2] | 0;
  if ((i23 | 0) != 2 | f28 > Math_fround(0.0) & ((i4 | 0) > 1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 532 >> 0] | 0) == 0) ^ 1) i4 = 0; else i4 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0) > 29;
 } else i4 = 0;
 if (!(HEAP8[i17 + 1081 >> 0] | 0)) {
  i1 = __ZNK6Camera19GetProjectionMatrixEv(i17) | 0;
  if (Math_fround(HEAPF32[i1 + 12 >> 2]) != Math_fround(0.0)) i1 = 1; else if (Math_fround(HEAPF32[i1 + 28 >> 2]) != Math_fround(0.0)) i1 = 1; else if (Math_fround(HEAPF32[i1 + 44 >> 2]) != Math_fround(0.0)) i1 = 1; else i1 = Math_fround(HEAPF32[i1 + 60 >> 2]) != Math_fround(1.0);
 } else i1 = 0;
 i2 = __ZN8Material9GetShaderEv(HEAP32[gb + 1113156 >> 2] | 0) | 0;
 do if (!i2) i1 = -1; else {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 384380 | 0, 15);
  i3 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i15) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  if (!i4) {
   if (!i1) {
    i1 = -1;
    break;
   };
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 384439 | 0, 37);
   i1 = __ZNK6Shader24GetSubShaderWithTagValueEii(i2, i3, __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i15) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   break;
  }
  if (i1) {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 384396 | 0, 34);
   i1 = __ZNK6Shader24GetSubShaderWithTagValueEii(i2, i3, __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i15) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   if ((i1 | 0) != -1) break;
  };
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 384431 | 0, 7);
  i1 = __ZNK6Shader24GetSubShaderWithTagValueEii(i2, i3, __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i15) | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 } while (0);
 i4 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1113156 >> 2] | 0, 0, i24, (i1 | 0) > 0 ? i1 : 0, 1) | 0;
 i49 = i15 + 16 | 0;
 i48 = i15 + 32 | 0;
 i47 = i15 + 48 | 0;
 i46 = i15 + 4 | 0;
 i45 = i15 + 20 | 0;
 i44 = i15 + 36 | 0;
 i43 = i15 + 52 | 0;
 i42 = i15 + 8 | 0;
 i1 = i15 + 24 | 0;
 i2 = i15 + 40 | 0;
 i3 = i15 + 56 | 0;
 f30 = Math_fround(__ZNK6Camera16GetProjectionFarEv(i17));
 HEAPF32[i25 >> 2] = Math_fround(1.0);
 HEAPF32[i25 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i25 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i15, i25) | 0;
 __ZN10Matrix4x4fmLERKS_(i15, __ZNK6Camera22GetWorldToCameraMatrixEv(i17) | 0) | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 8 >> 2] = f30;
 __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i25, i17, i26);
 f39 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 f39 = Math_fround(f39 * f29);
 f38 = Math_fround(HEAPF32[i49 >> 2]);
 f36 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f38 = Math_fround(f39 + Math_fround(f38 * f36));
 f39 = Math_fround(HEAPF32[i48 >> 2]);
 f37 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f39 = Math_fround(f38 + Math_fround(f39 * f37));
 f39 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + f39);
 f38 = Math_fround(f29 * Math_fround(HEAPF32[i46 >> 2]));
 f38 = Math_fround(f38 + Math_fround(f36 * Math_fround(HEAPF32[i45 >> 2])));
 f38 = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i44 >> 2])));
 f38 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f38);
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i42 >> 2]));
 f36 = Math_fround(f29 + Math_fround(f36 * Math_fround(HEAPF32[i1 >> 2])));
 f37 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i2 >> 2])));
 f37 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f37);
 HEAPF32[i26 >> 2] = Math_fround(1.0);
 HEAPF32[i26 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 8 >> 2] = f30;
 __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i25, i17, i26);
 f36 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 f36 = Math_fround(f36 * f29);
 f35 = Math_fround(HEAPF32[i49 >> 2]);
 f33 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f35 = Math_fround(f36 + Math_fround(f35 * f33));
 f36 = Math_fround(HEAPF32[i48 >> 2]);
 f34 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f36 = Math_fround(f35 + Math_fround(f36 * f34));
 f36 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + f36);
 f35 = Math_fround(f29 * Math_fround(HEAPF32[i46 >> 2]));
 f35 = Math_fround(f35 + Math_fround(f33 * Math_fround(HEAPF32[i45 >> 2])));
 f35 = Math_fround(f35 + Math_fround(f34 * Math_fround(HEAPF32[i44 >> 2])));
 f35 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f35);
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i42 >> 2]));
 f33 = Math_fround(f29 + Math_fround(f33 * Math_fround(HEAPF32[i1 >> 2])));
 f34 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i2 >> 2])));
 f34 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f34);
 HEAPF32[i26 >> 2] = Math_fround(1.0);
 HEAPF32[i26 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i26 + 8 >> 2] = f30;
 __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i25, i17, i26);
 f33 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 f33 = Math_fround(f33 * f29);
 f32 = Math_fround(HEAPF32[i49 >> 2]);
 f41 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f32 = Math_fround(f33 + Math_fround(f32 * f41));
 f33 = Math_fround(HEAPF32[i48 >> 2]);
 f31 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f33 = Math_fround(f32 + Math_fround(f33 * f31));
 f33 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + f33);
 f32 = Math_fround(f29 * Math_fround(HEAPF32[i46 >> 2]));
 f32 = Math_fround(f32 + Math_fround(f41 * Math_fround(HEAPF32[i45 >> 2])));
 f32 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i44 >> 2])));
 f32 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f32);
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i42 >> 2]));
 f41 = Math_fround(f29 + Math_fround(f41 * Math_fround(HEAPF32[i1 >> 2])));
 f31 = Math_fround(f41 + Math_fround(f31 * Math_fround(HEAPF32[i2 >> 2])));
 f31 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f31);
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i26 + 8 >> 2] = f30;
 __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i25, i17, i26);
 f30 = Math_fround(HEAPF32[i15 >> 2]);
 f41 = Math_fround(HEAPF32[i25 >> 2]);
 f30 = Math_fround(f30 * f41);
 f29 = Math_fround(HEAPF32[i49 >> 2]);
 f40 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f29 = Math_fround(f30 + Math_fround(f29 * f40));
 f30 = Math_fround(HEAPF32[i48 >> 2]);
 f28 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f30 = Math_fround(f29 + Math_fround(f30 * f28));
 f30 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) + f30);
 f29 = Math_fround(f41 * Math_fround(HEAPF32[i46 >> 2]));
 f29 = Math_fround(f29 + Math_fround(f40 * Math_fround(HEAPF32[i45 >> 2])));
 f29 = Math_fround(f29 + Math_fround(f28 * Math_fround(HEAPF32[i44 >> 2])));
 f29 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f29);
 f41 = Math_fround(f41 * Math_fround(HEAPF32[i42 >> 2]));
 f40 = Math_fround(f41 + Math_fround(f40 * Math_fround(HEAPF32[i1 >> 2])));
 f28 = Math_fround(f40 + Math_fround(f28 * Math_fround(HEAPF32[i2 >> 2])));
 f28 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f28);
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 580 >> 2] | 0, i13 | 0, 2, i4 | 0);
 mftCall_viifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 576 >> 2] | 0, i13 | 0, 0, 0.0, 0.0, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 564 >> 2] | 0, i13 | 0, +f39, +f38, +f37);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 560 >> 2] | 0, i13 | 0, 0.0, 0.0, .100000001);
 mftCall_viifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 576 >> 2] | 0, i13 | 0, 0, 1.0, 0.0, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 564 >> 2] | 0, i13 | 0, +f36, +f35, +f34);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 560 >> 2] | 0, i13 | 0, 1.0, 0.0, .100000001);
 mftCall_viifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 576 >> 2] | 0, i13 | 0, 0, 1.0, 1.0, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 564 >> 2] | 0, i13 | 0, +f33, +f32, +f31);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 560 >> 2] | 0, i13 | 0, 1.0, 1.0, .100000001);
 mftCall_viifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 576 >> 2] | 0, i13 | 0, 0, 0.0, 1.0, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 564 >> 2] | 0, i13 | 0, +f30, +f29, +f28);
 mftCall_vifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 560 >> 2] | 0, i13 | 0, 0.0, 1.0, .100000001);
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 584 >> 2] | 0, i13 | 0);
 __Z15gpu_time_samplev();
 if (!(__ZNK6Camera16GetStereoEnabledEv(i17) | 0)) __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i19, i20);
 i49 = HEAP32[i22 >> 2] | 0;
 i49 = (i23 | 0) != 2 ? i49 & -257 : i49 | 256;
 HEAP32[i22 >> 2] = (i14 ? i49 | 512 : i49 & -737) & -225 | 64;
 HEAP8[i9 >> 0] = 1;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i11, 3, i24, i18, gb + 1160140 | 0, HEAP32[i5 >> 2] | 0);
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i11, 3, i24, i18, gb + 1160140 | 0, HEAP32[i5 >> 2] | 0);
 HEAP8[i9 >> 0] = i10;
 __ZN15RenderNodeQueue7CleanupEv(i18);
 __ZN19AtomicPageAllocatorD2Ev(i8);
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i7);
  HEAP32[i18 >> 2] = 0;
 }
 HEAP32[gb + 1163232 >> 2] = i21;
 i49 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i49 >> 2] | 0) + 652 >> 2] | 0, i49 | 0);
 if (!i16) {
  i49 = i12;
  STACKTOP = i27;
  return i49 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 i49 = i12;
 STACKTOP = i27;
 return i49 | 0;
}

function __ZN10SpookyHash5ShortEPKvjPyS2_(i2, i15, i16, i17) {
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i14 = i15 & 31;
 i9 = i16;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i17;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 if (i15 >>> 0 > 15) {
  i1 = i15 >>> 5;
  i3 = i2 + (i1 << 2 << 3) | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   i5 = i2 + (i1 << 5) | 0;
   i4 = -559038737;
   i1 = -559038737;
   i6 = -559038737;
   i7 = -559038737;
   do {
    i12 = i2;
    i12 = _i64Add(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i4 | 0, i1 | 0) | 0;
    i19 = getTempRet0() | 0;
    i13 = i2 + 8 | 0;
    i13 = _i64Add(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, i6 | 0, i7 | 0) | 0;
    i22 = getTempRet0() | 0;
    i20 = _bitshift64Shl(i12 | 0, i19 | 0, 50) | 0;
    i21 = getTempRet0() | 0;
    i19 = _bitshift64Lshr(i12 | 0, i19 | 0, 14) | 0;
    i21 = _i64Add(i19 | i20 | 0, getTempRet0() | 0 | i21 | 0, i13 | 0, i22 | 0) | 0;
    i20 = getTempRet0() | 0;
    i19 = i21 ^ i8;
    i12 = i20 ^ i9;
    i25 = _bitshift64Shl(i13 | 0, i22 | 0, 52) | 0;
    i26 = getTempRet0() | 0;
    i22 = _bitshift64Lshr(i13 | 0, i22 | 0, 12) | 0;
    i26 = _i64Add(i19 | 0, i12 | 0, i22 | i25 | 0, getTempRet0() | 0 | i26 | 0) | 0;
    i25 = getTempRet0() | 0;
    i22 = i26 ^ i10;
    i13 = i25 ^ i11;
    i23 = _bitshift64Shl(i19 | 0, i12 | 0, 30) | 0;
    i24 = getTempRet0() | 0;
    i12 = _bitshift64Lshr(i19 | 0, i12 | 0, 34) | 0;
    i24 = _i64Add(i12 | i23 | 0, getTempRet0() | 0 | i24 | 0, i22 | 0, i13 | 0) | 0;
    i23 = getTempRet0() | 0;
    i21 = i24 ^ i21;
    i20 = i23 ^ i20;
    i12 = _bitshift64Shl(i22 | 0, i13 | 0, 41) | 0;
    i19 = getTempRet0() | 0;
    i13 = _bitshift64Lshr(i22 | 0, i13 | 0, 23) | 0;
    i19 = _i64Add(i13 | i12 | 0, getTempRet0() | 0 | i19 | 0, i21 | 0, i20 | 0) | 0;
    i12 = getTempRet0() | 0;
    i26 = i19 ^ i26;
    i25 = i12 ^ i25;
    i13 = _bitshift64Shl(i21 | 0, i20 | 0, 54) | 0;
    i22 = getTempRet0() | 0;
    i20 = _bitshift64Lshr(i21 | 0, i20 | 0, 10) | 0;
    i22 = _i64Add(i20 | i13 | 0, getTempRet0() | 0 | i22 | 0, i26 | 0, i25 | 0) | 0;
    i13 = getTempRet0() | 0;
    i24 = i22 ^ i24;
    i23 = i13 ^ i23;
    i20 = _bitshift64Shl(i26 | 0, i25 | 0, 48) | 0;
    i21 = getTempRet0() | 0;
    i25 = _bitshift64Lshr(i26 | 0, i25 | 0, 16) | 0;
    i21 = _i64Add(i25 | i20 | 0, getTempRet0() | 0 | i21 | 0, i24 | 0, i23 | 0) | 0;
    i20 = getTempRet0() | 0;
    i19 = i21 ^ i19;
    i12 = i20 ^ i12;
    i25 = _bitshift64Shl(i24 | 0, i23 | 0, 38) | 0;
    i26 = getTempRet0() | 0;
    i23 = _bitshift64Lshr(i24 | 0, i23 | 0, 26) | 0;
    i26 = _i64Add(i23 | i25 | 0, getTempRet0() | 0 | i26 | 0, i19 | 0, i12 | 0) | 0;
    i25 = getTempRet0() | 0;
    i22 = i26 ^ i22;
    i13 = i25 ^ i13;
    i23 = _bitshift64Shl(i19 | 0, i12 | 0, 37) | 0;
    i24 = getTempRet0() | 0;
    i12 = _bitshift64Lshr(i19 | 0, i12 | 0, 27) | 0;
    i24 = _i64Add(i12 | i23 | 0, getTempRet0() | 0 | i24 | 0, i22 | 0, i13 | 0) | 0;
    i23 = getTempRet0() | 0;
    i21 = i24 ^ i21;
    i20 = i23 ^ i20;
    i12 = _bitshift64Shl(i22 | 0, i13 | 0, 62) | 0;
    i19 = getTempRet0() | 0;
    i13 = _bitshift64Lshr(i22 | 0, i13 | 0, 2) | 0;
    i19 = _i64Add(i13 | i12 | 0, getTempRet0() | 0 | i19 | 0, i21 | 0, i20 | 0) | 0;
    i12 = getTempRet0() | 0;
    i26 = i19 ^ i26;
    i25 = i12 ^ i25;
    i13 = _bitshift64Shl(i21 | 0, i20 | 0, 34) | 0;
    i22 = getTempRet0() | 0;
    i20 = _bitshift64Lshr(i21 | 0, i20 | 0, 30) | 0;
    i22 = _i64Add(i20 | i13 | 0, getTempRet0() | 0 | i22 | 0, i26 | 0, i25 | 0) | 0;
    i13 = getTempRet0() | 0;
    i24 = i22 ^ i24;
    i23 = i13 ^ i23;
    i20 = _bitshift64Shl(i26 | 0, i25 | 0, 5) | 0;
    i21 = getTempRet0() | 0;
    i25 = _bitshift64Lshr(i26 | 0, i25 | 0, 59) | 0;
    i21 = _i64Add(i25 | i20 | 0, getTempRet0() | 0 | i21 | 0, i24 | 0, i23 | 0) | 0;
    i20 = getTempRet0() | 0;
    i4 = i21 ^ i19;
    i1 = i20 ^ i12;
    i12 = _bitshift64Shl(i24 | 0, i23 | 0, 36) | 0;
    i19 = getTempRet0() | 0;
    i23 = _bitshift64Lshr(i24 | 0, i23 | 0, 28) | 0;
    i19 = _i64Add(i23 | i12 | 0, getTempRet0() | 0 | i19 | 0, i4 | 0, i1 | 0) | 0;
    i12 = getTempRet0() | 0;
    i6 = i19 ^ i22;
    i7 = i12 ^ i13;
    i13 = i2 + 16 | 0;
    i8 = _i64Add(i21 | 0, i20 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0) | 0;
    i9 = getTempRet0() | 0;
    i13 = i2 + 24 | 0;
    i10 = _i64Add(i19 | 0, i12 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0) | 0;
    i11 = getTempRet0() | 0;
    i2 = i2 + 32 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
   i13 = i5;
   i12 = i5;
   i3 = i7;
   i5 = i10;
   i2 = i11;
  } else {
   i13 = i2;
   i12 = i2;
   i4 = -559038737;
   i1 = -559038737;
   i6 = -559038737;
   i3 = -559038737;
   i5 = i10;
   i2 = i11;
  }
  if (i14 >>> 0 > 15) {
   i11 = i13;
   i11 = _i64Add(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   i25 = getTempRet0() | 0;
   i7 = i12 + 8 | 0;
   i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, i6 | 0, i3 | 0) | 0;
   i6 = getTempRet0() | 0;
   i1 = _bitshift64Shl(i11 | 0, i25 | 0, 50) | 0;
   i4 = getTempRet0() | 0;
   i25 = _bitshift64Lshr(i11 | 0, i25 | 0, 14) | 0;
   i4 = _i64Add(i25 | i1 | 0, getTempRet0() | 0 | i4 | 0, i7 | 0, i6 | 0) | 0;
   i1 = getTempRet0() | 0;
   i25 = i4 ^ i8;
   i8 = i1 ^ i9;
   i11 = _bitshift64Shl(i7 | 0, i6 | 0, 52) | 0;
   i3 = getTempRet0() | 0;
   i6 = _bitshift64Lshr(i7 | 0, i6 | 0, 12) | 0;
   i3 = _i64Add(i25 | 0, i8 | 0, i6 | i11 | 0, getTempRet0() | 0 | i3 | 0) | 0;
   i11 = getTempRet0() | 0;
   i6 = i3 ^ i5;
   i5 = i11 ^ i2;
   i7 = _bitshift64Shl(i25 | 0, i8 | 0, 30) | 0;
   i26 = getTempRet0() | 0;
   i8 = _bitshift64Lshr(i25 | 0, i8 | 0, 34) | 0;
   i26 = _i64Add(i8 | i7 | 0, getTempRet0() | 0 | i26 | 0, i6 | 0, i5 | 0) | 0;
   i7 = getTempRet0() | 0;
   i8 = i26 ^ i4;
   i9 = i7 ^ i1;
   i1 = _bitshift64Shl(i6 | 0, i5 | 0, 41) | 0;
   i4 = getTempRet0() | 0;
   i5 = _bitshift64Lshr(i6 | 0, i5 | 0, 23) | 0;
   i4 = _i64Add(i5 | i1 | 0, getTempRet0() | 0 | i4 | 0, i8 | 0, i9 | 0) | 0;
   i1 = getTempRet0() | 0;
   i5 = i4 ^ i3;
   i11 = i1 ^ i11;
   i3 = _bitshift64Shl(i8 | 0, i9 | 0, 54) | 0;
   i6 = getTempRet0() | 0;
   i9 = _bitshift64Lshr(i8 | 0, i9 | 0, 10) | 0;
   i6 = _i64Add(i9 | i3 | 0, getTempRet0() | 0 | i6 | 0, i5 | 0, i11 | 0) | 0;
   i3 = getTempRet0() | 0;
   i26 = i6 ^ i26;
   i7 = i3 ^ i7;
   i9 = _bitshift64Shl(i5 | 0, i11 | 0, 48) | 0;
   i8 = getTempRet0() | 0;
   i11 = _bitshift64Lshr(i5 | 0, i11 | 0, 16) | 0;
   i8 = _i64Add(i11 | i9 | 0, getTempRet0() | 0 | i8 | 0, i26 | 0, i7 | 0) | 0;
   i9 = getTempRet0() | 0;
   i4 = i8 ^ i4;
   i1 = i9 ^ i1;
   i11 = _bitshift64Shl(i26 | 0, i7 | 0, 38) | 0;
   i5 = getTempRet0() | 0;
   i7 = _bitshift64Lshr(i26 | 0, i7 | 0, 26) | 0;
   i5 = _i64Add(i7 | i11 | 0, getTempRet0() | 0 | i5 | 0, i4 | 0, i1 | 0) | 0;
   i11 = getTempRet0() | 0;
   i6 = i5 ^ i6;
   i3 = i11 ^ i3;
   i7 = _bitshift64Shl(i4 | 0, i1 | 0, 37) | 0;
   i26 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i4 | 0, i1 | 0, 27) | 0;
   i26 = _i64Add(i1 | i7 | 0, getTempRet0() | 0 | i26 | 0, i6 | 0, i3 | 0) | 0;
   i7 = getTempRet0() | 0;
   i8 = i26 ^ i8;
   i9 = i7 ^ i9;
   i1 = _bitshift64Shl(i6 | 0, i3 | 0, 62) | 0;
   i4 = getTempRet0() | 0;
   i3 = _bitshift64Lshr(i6 | 0, i3 | 0, 2) | 0;
   i4 = _i64Add(i3 | i1 | 0, getTempRet0() | 0 | i4 | 0, i8 | 0, i9 | 0) | 0;
   i1 = getTempRet0() | 0;
   i5 = i4 ^ i5;
   i11 = i1 ^ i11;
   i3 = _bitshift64Shl(i8 | 0, i9 | 0, 34) | 0;
   i6 = getTempRet0() | 0;
   i9 = _bitshift64Lshr(i8 | 0, i9 | 0, 30) | 0;
   i6 = _i64Add(i9 | i3 | 0, getTempRet0() | 0 | i6 | 0, i5 | 0, i11 | 0) | 0;
   i3 = getTempRet0() | 0;
   i26 = i6 ^ i26;
   i7 = i3 ^ i7;
   i9 = _bitshift64Shl(i5 | 0, i11 | 0, 5) | 0;
   i8 = getTempRet0() | 0;
   i11 = _bitshift64Lshr(i5 | 0, i11 | 0, 59) | 0;
   i8 = _i64Add(i11 | i9 | 0, getTempRet0() | 0 | i8 | 0, i26 | 0, i7 | 0) | 0;
   i9 = getTempRet0() | 0;
   i4 = i8 ^ i4;
   i1 = i9 ^ i1;
   i11 = _bitshift64Shl(i26 | 0, i7 | 0, 36) | 0;
   i5 = getTempRet0() | 0;
   i7 = _bitshift64Lshr(i26 | 0, i7 | 0, 28) | 0;
   i5 = _i64Add(i7 | i11 | 0, getTempRet0() | 0 | i5 | 0, i4 | 0, i1 | 0) | 0;
   i11 = getTempRet0() | 0;
   i7 = i14 + -16 | 0;
   i12 = i12 + 16 | 0;
   i6 = i5 ^ i6;
   i3 = i11 ^ i3;
  } else {
   i7 = i14;
   i11 = i2;
  }
 } else {
  i7 = i14;
  i12 = i2;
  i6 = -559038737;
  i3 = -559038737;
  i4 = -559038737;
  i1 = -559038737;
  i5 = i10;
 }
 i2 = _bitshift64Shl(i15 | 0, 0, 56) | 0;
 i3 = _i64Add(i6 | 0, i3 | 0, i2 | 0, getTempRet0() | 0) | 0;
 i2 = getTempRet0() | 0;
 switch (i7 | 0) {
 case 15:
  {
   i3 = _i64Add(_bitshift64Shl(HEAPU8[i12 + 14 >> 0] | 0 | 0, 0, 48) | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   i18 = 10;
   break;
  }
 case 14:
  {
   i18 = 10;
   break;
  }
 case 13:
  {
   i18 = 11;
   break;
  }
 case 12:
  {
   i18 = 12;
   break;
  }
 case 11:
  {
   i3 = _i64Add(_bitshift64Shl(HEAPU8[i12 + 10 >> 0] | 0 | 0, 0, 16) | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   i18 = 14;
   break;
  }
 case 10:
  {
   i18 = 14;
   break;
  }
 case 9:
  {
   i18 = 15;
   break;
  }
 case 8:
  {
   i18 = 16;
   break;
  }
 case 7:
  {
   i4 = _i64Add(_bitshift64Shl(HEAPU8[i12 + 6 >> 0] | 0 | 0, 0, 48) | 0, getTempRet0() | 0, i4 | 0, i1 | 0) | 0;
   i1 = getTempRet0() | 0;
   i18 = 18;
   break;
  }
 case 6:
  {
   i18 = 18;
   break;
  }
 case 5:
  {
   i18 = 19;
   break;
  }
 case 4:
  {
   i18 = 20;
   break;
  }
 case 3:
  {
   i4 = _i64Add(_bitshift64Shl(HEAPU8[i12 + 2 >> 0] | 0 | 0, 0, 16) | 0, getTempRet0() | 0, i4 | 0, i1 | 0) | 0;
   i1 = getTempRet0() | 0;
   i18 = 22;
   break;
  }
 case 2:
  {
   i18 = 22;
   break;
  }
 case 1:
  {
   i18 = 23;
   break;
  }
 case 0:
  {
   i4 = _i64Add(i4 | 0, i1 | 0, -559038737, -559038737) | 0;
   i1 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, i2 | 0, -559038737, -559038737) | 0;
   i2 = getTempRet0() | 0;
   break;
  }
 default:
  {}
 }
 if ((i18 | 0) == 10) {
  i26 = _bitshift64Shl(HEAPU8[i12 + 13 >> 0] | 0 | 0, 0, 40) | 0;
  i3 = _i64Add(i26 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i18 = 11;
 } else if ((i18 | 0) == 14) {
  i26 = _bitshift64Shl(HEAPU8[i12 + 9 >> 0] | 0 | 0, 0, 8) | 0;
  i3 = _i64Add(i26 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i18 = 15;
 } else if ((i18 | 0) == 18) {
  i26 = _bitshift64Shl(HEAPU8[i12 + 5 >> 0] | 0 | 0, 0, 40) | 0;
  i4 = _i64Add(i26 | 0, getTempRet0() | 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
  i18 = 19;
 } else if ((i18 | 0) == 22) {
  i26 = _bitshift64Shl(HEAPU8[i12 + 1 >> 0] | 0 | 0, 0, 8) | 0;
  i4 = _i64Add(i26 | 0, getTempRet0() | 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
  i18 = 23;
 }
 if ((i18 | 0) == 11) {
  i3 = _i64Add(0, HEAPU8[i12 + 12 >> 0] | 0 | 0, i3 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i18 = 12;
 } else if ((i18 | 0) == 15) {
  i3 = _i64Add(HEAPU8[i12 + 8 >> 0] | 0 | 0, 0, i3 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i18 = 16;
 } else if ((i18 | 0) == 19) {
  i4 = _i64Add(0, HEAPU8[i12 + 4 >> 0] | 0 | 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
  i18 = 20;
 } else if ((i18 | 0) == 23) {
  i4 = _i64Add(HEAPU8[i12 >> 0] | 0 | 0, 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
 }
 if ((i18 | 0) == 12) {
  i3 = _i64Add(HEAP32[i12 + 8 >> 2] | 0, 0, i3 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i26 = i12;
  i4 = _i64Add(HEAP32[i26 >> 2] | 0, HEAP32[i26 + 4 >> 2] | 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
 } else if ((i18 | 0) == 16) {
  i26 = i12;
  i4 = _i64Add(HEAP32[i26 >> 2] | 0, HEAP32[i26 + 4 >> 2] | 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
 } else if ((i18 | 0) == 20) {
  i4 = _i64Add(HEAP32[i12 >> 2] | 0, 0, i4 | 0, i1 | 0) | 0;
  i1 = getTempRet0() | 0;
 }
 i18 = _bitshift64Shl(i4 | 0, i1 | 0, 15) | 0;
 i23 = getTempRet0() | 0;
 i20 = _bitshift64Lshr(i4 | 0, i1 | 0, 49) | 0;
 i18 = i20 | i18;
 i23 = getTempRet0() | 0 | i23;
 i20 = _i64Add(i3 ^ i4 | 0, i2 ^ i1 | 0, i18 | 0, i23 | 0) | 0;
 i25 = getTempRet0() | 0;
 i19 = _bitshift64Shl(i20 | 0, i25 | 0, 52) | 0;
 i21 = getTempRet0() | 0;
 i22 = _bitshift64Lshr(i20 | 0, i25 | 0, 12) | 0;
 i19 = i22 | i19;
 i21 = getTempRet0() | 0 | i21;
 i25 = _i64Add(i19 | 0, i21 | 0, i20 ^ i8 | 0, i25 ^ i9 | 0) | 0;
 i20 = getTempRet0() | 0;
 i22 = _bitshift64Shl(i25 | 0, i20 | 0, 26) | 0;
 i24 = getTempRet0() | 0;
 i26 = _bitshift64Lshr(i25 | 0, i20 | 0, 38) | 0;
 i22 = i26 | i22;
 i24 = getTempRet0() | 0 | i24;
 i20 = _i64Add(i22 | 0, i24 | 0, i25 ^ i5 | 0, i20 ^ i11 | 0) | 0;
 i25 = getTempRet0() | 0;
 i26 = _bitshift64Shl(i20 | 0, i25 | 0, 51) | 0;
 i15 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i20 | 0, i25 | 0, 13) | 0;
 i26 = i14 | i26;
 i15 = getTempRet0() | 0 | i15;
 i23 = _i64Add(i26 | 0, i15 | 0, i20 ^ i18 | 0, i25 ^ i23 | 0) | 0;
 i25 = getTempRet0() | 0;
 i18 = _bitshift64Shl(i23 | 0, i25 | 0, 28) | 0;
 i20 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i23 | 0, i25 | 0, 36) | 0;
 i18 = i14 | i18;
 i20 = getTempRet0() | 0 | i20;
 i21 = _i64Add(i18 | 0, i20 | 0, i23 ^ i19 | 0, i25 ^ i21 | 0) | 0;
 i25 = getTempRet0() | 0;
 i19 = _bitshift64Shl(i21 | 0, i25 | 0, 9) | 0;
 i23 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i21 | 0, i25 | 0, 55) | 0;
 i19 = i14 | i19;
 i23 = getTempRet0() | 0 | i23;
 i24 = _i64Add(i19 | 0, i23 | 0, i21 ^ i22 | 0, i25 ^ i24 | 0) | 0;
 i25 = getTempRet0() | 0;
 i22 = _bitshift64Shl(i24 | 0, i25 | 0, 47) | 0;
 i21 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i24 | 0, i25 | 0, 17) | 0;
 i22 = i14 | i22;
 i21 = getTempRet0() | 0 | i21;
 i15 = _i64Add(i22 | 0, i21 | 0, i24 ^ i26 | 0, i25 ^ i15 | 0) | 0;
 i25 = getTempRet0() | 0;
 i26 = _bitshift64Shl(i15 | 0, i25 | 0, 54) | 0;
 i24 = getTempRet0() | 0;
 i14 = _bitshift64Lshr(i15 | 0, i25 | 0, 10) | 0;
 i26 = i14 | i26;
 i24 = getTempRet0() | 0 | i24;
 i20 = _i64Add(i26 | 0, i24 | 0, i15 ^ i18 | 0, i25 ^ i20 | 0) | 0;
 i25 = getTempRet0() | 0;
 i23 = _i64Add(i25 | 0, i20 | 0, i20 ^ i19 | 0, i25 ^ i23 | 0) | 0;
 i25 = getTempRet0() | 0;
 i19 = _bitshift64Shl(i23 | 0, i25 | 0, 25) | 0;
 i20 = getTempRet0() | 0;
 i18 = _bitshift64Lshr(i23 | 0, i25 | 0, 39) | 0;
 i21 = _i64Add(i18 | i19 | 0, getTempRet0() | 0 | i20 | 0, i23 ^ i22 | 0, i25 ^ i21 | 0) | 0;
 i25 = getTempRet0() | 0;
 i22 = _bitshift64Shl(i21 | 0, i25 | 0, 63) | 0;
 i23 = getTempRet0() | 0;
 i20 = _bitshift64Lshr(i21 | 0, i25 | 0, 1) | 0;
 i22 = i20 | i22;
 i23 = getTempRet0() | 0 | i23;
 i24 = _i64Add(i22 | 0, i23 | 0, i21 ^ i26 | 0, i25 ^ i24 | 0) | 0;
 i25 = getTempRet0() | 0;
 i26 = i16;
 HEAP32[i26 >> 2] = i22;
 HEAP32[i26 + 4 >> 2] = i23;
 i26 = i17;
 HEAP32[i26 >> 2] = i24;
 HEAP32[i26 + 4 >> 2] = i25;
 return;
}

function __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034440 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034444 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034448 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034452 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034456 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034460 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034464 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034468 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034472 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034476 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034480 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034484 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034488 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 138; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034492 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 149; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 149; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 149) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034496 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i3 >>> 0) i8 = 160; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     i8 = 160;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i8 | 0) == 160) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034500 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i7 >>> 0) i8 = 171; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    i8 = 171;
    break;
   }
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i8 | 0) == 171) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb(i49, i43, i50, i4, i6) {
 i49 = i49 | 0;
 i43 = i43 | 0;
 i50 = i50 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i54 = i55 + 8 | 0;
 i48 = i55;
 i51 = i55 + 172 | 0;
 i52 = i55 + 168 | 0;
 i53 = i55 + 176 | 0;
 i45 = i55 + 148 | 0;
 i3 = i50 + 1308 | 0;
 _memcpy((HEAP32[i49 >> 2] | 0) + 12 | 0, HEAP32[i3 >> 2] | 0, 952) | 0;
 i2 = HEAP32[i49 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i3 >> 2] | 0) + 952 >> 2] | 0;
 _memcpy(i2 + 976 | 0, i3 | 0, 340) | 0;
 i1 = 0;
 do {
  i44 = HEAP32[i3 + 352 + (i1 << 4) + 4 >> 2] | 0;
  i46 = HEAP32[i3 + 352 + (i1 << 4) + 8 >> 2] | 0;
  i47 = HEAP32[i3 + 352 + (i1 << 4) + 12 >> 2] | 0;
  HEAP32[i2 + 1328 + (i1 << 4) >> 2] = HEAP32[i3 + 352 + (i1 << 4) >> 2];
  HEAP32[i2 + 1328 + (i1 << 4) + 4 >> 2] = i44;
  HEAP32[i2 + 1328 + (i1 << 4) + 8 >> 2] = i46;
  HEAP32[i2 + 1328 + (i1 << 4) + 12 >> 2] = i47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 12);
 _memcpy(i2 + 1520 | 0, i3 + 544 | 0, 208) | 0;
 HEAP32[(HEAP32[i49 >> 2] | 0) + 1728 >> 2] = i4;
 i46 = __Z12GetGfxDevicev() | 0;
 i46 = mftCall_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 100 >> 2] | 0, i46 | 0) | 0;
 i1 = HEAP32[i49 >> 2] | 0;
 i47 = HEAP32[i1 + 8 >> 2] | 0;
 i44 = i47;
 if ((HEAP16[gb + 1115160 + 6 >> 1] | 0) > -1) {
  HEAP32[i48 >> 2] = i44;
  HEAP32[i54 >> 2] = HEAP32[i48 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115160 | 0, i54);
  i3 = HEAP32[i49 >> 2] | 0;
  i41 = gb + 1115160 | 0;
  i1 = i3;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
 } else {
  i41 = 0;
  i3 = i47;
 }
 i40 = i50 + 1360 | 0;
 i2 = (HEAP32[i40 >> 2] | 0) != 0;
 i7 = i1 + 1732 | 0;
 i4 = __ZNK6Camera22GetWorldToCameraMatrixEv(i3) | 0;
 i5 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  i7 = i7 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i39 = i1 + 1812 | 0;
 __ZNK9Transform11GetPositionEv(i54, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i39 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
 i39 = i1 + 1796 | 0;
 __ZNK6Camera18GetRenderRectangleEv(i54, i3);
 HEAP32[i39 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
 switch (HEAP32[i3 + 1068 >> 2] | 0) {
 case 1:
  {
   HEAP8[i1 + 1824 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i1 + 1824 >> 0] = 1;
   break;
  }
 default:
  HEAP8[i1 + 1824 >> 0] = HEAP8[i3 + 1088 >> 0] | 0;
 }
 HEAP8[i1 + 1825 >> 0] = i6 & 1;
 HEAP8[i1 + 1826 >> 0] = i2 & 1;
 i7 = i49 + 4 | 0;
 i5 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i1 = HEAP32[i49 >> 2] | 0;
 i28 = i1 + 1840 | 0;
 i29 = i1 + 1860 | 0;
 i30 = HEAP32[i1 + 1832 >> 2] | 0;
 i31 = HEAP32[i40 >> 2] | 0;
 i32 = i30 + 32804 | 0;
 i2 = HEAP32[i32 >> 2] | 0;
 if (i2 | 0) {
  i33 = i1 + 1824 | 0;
  i34 = i1 + 1740 | 0;
  i35 = i1 + 1756 | 0;
  i36 = i1 + 1772 | 0;
  i37 = i1 + 1788 | 0;
  i38 = i1 + 1812 | 0;
  i39 = i1 + 1816 | 0;
  i24 = i1 + 1820 | 0;
  i25 = (i31 | 0) != 0;
  i26 = (i31 | 0) == 0;
  i27 = i31 + 32 | 0;
  i23 = 0;
  i1 = i2;
  do {
   i2 = HEAP32[i30 >> 2] | 0;
   i22 = i2 + (i23 * 360 | 0) + 232 | 0;
   if (((HEAPU16[i22 >> 1] | HEAPU8[i22 + 2 >> 0] << 16) & 192 | 0) != 192) {
    f9 = Math_fround(HEAPF32[i2 + (i23 * 360 | 0) + 128 >> 2]);
    f10 = Math_fround(HEAPF32[i2 + (i23 * 360 | 0) + 132 >> 2]);
    f8 = Math_fround(HEAPF32[i2 + (i23 * 360 | 0) + 136 >> 2]);
    f11 = Math_fround(f9 * Math_fround(HEAPF32[i34 >> 2]));
    f11 = Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i35 >> 2])));
    f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i36 >> 2])));
    f11 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f11);
    if (!(HEAP8[i33 >> 0] | 0)) {
     f9 = Math_fround(f9 - Math_fround(HEAPF32[i38 >> 2]));
     f10 = Math_fround(f10 - Math_fround(HEAPF32[i39 >> 2]));
     f8 = Math_fround(f8 - Math_fround(HEAPF32[i24 >> 2]));
     f8 = Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f8 * f8)));
    } else f8 = f11;
    f9 = Math_fround(f8 - Math_fround(HEAPF32[i2 + (i23 * 360 | 0) + 256 >> 2]));
    f8 = Math_fround(-f11);
    i21 = HEAP32[i2 + (i23 * 360 | 0) + 324 >> 2] | 0;
    i22 = i2 + (i23 * 360 | 0) + 244 | 0;
    if ((HEAP32[i22 >> 2] | 0) > 0) {
     i19 = i2 + (i23 * 360 | 0) + 182 | 0;
     i20 = i2 + (i23 * 360 | 0) + 180 | 0;
     i16 = i2 + (i23 * 360 | 0) + 248 | 0;
     i15 = 0;
     do {
      i17 = i21 + (i15 << 3) | 0;
      i1 = HEAP32[i17 >> 2] | 0;
      i18 = HEAP32[i1 + 8 >> 2] | 0;
      if (i25) {
       i1 = __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(i18, i40, i1) | 0;
       if ((i1 | 0) >= 0) i42 = 18;
      } else {
       i1 = -1;
       i42 = 18;
      }
      if ((i42 | 0) == 18) {
       i42 = 0;
       i2 = HEAP32[i21 + (i15 << 3) + 4 >> 2] | 0;
       do if ((i2 | 0) < 0) if (i26) {
        i2 = HEAP32[(HEAP32[i18 + 32 >> 2] | 0) + 52 >> 2] | 0;
        break;
       } else {
        i2 = __ZNK9ShaderLab9IntShader14GetRenderQueueEi(HEAP32[i27 >> 2] | 0, i1) | 0;
        break;
       } while (0);
       i4 = (i2 | 0) < 2501 ? i28 : i29;
       i5 = i4 + 12 | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       i7 = i6 + 1 | 0;
       i12 = i4 + 16 | 0;
       i13 = HEAP32[i12 >> 2] | 0;
       i14 = i13 & 2147483647;
       do if (i7 >>> 0 > i14 >>> 0) {
        i3 = i13 << 1;
        i3 = (i3 | 0) == 0 ? 1 : i3;
        if (i14 >>> 0 < i3 >>> 0) if ((i13 | 0) > -1) {
         HEAP32[i12 >> 2] = i3;
         HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3 << 5, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 5, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i14 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 5 | 0) | 0;
         HEAP32[i12 >> 2] = i3;
         HEAP32[i4 >> 2] = i14;
         break;
        }
       } while (0);
       HEAP32[i5 >> 2] = i7;
       i14 = HEAP32[i4 >> 2] | 0;
       HEAP32[i14 + (i6 << 5) >> 2] = i25 ? i31 : i18;
       HEAP32[i14 + (i6 << 5) + 4 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + 168 >> 2];
       HEAP32[i14 + (i6 << 5) + 8 >> 2] = i23;
       HEAP16[i14 + (i6 << 5) + 12 >> 1] = i2;
       i17 = HEAP16[i19 >> 1] | 0;
       i18 = i17 & 65535;
       i18 = (i17 << 16 >> 16 == 0 | (i18 | 0) > (i15 | 0) ? i15 : i18 + 65535 | 0) + (HEAPU16[i20 >> 1] | 0) | 0;
       HEAP16[i14 + (i6 << 5) + 14 >> 1] = i18;
       HEAP16[i14 + (i6 << 5) + 16 >> 1] = i1;
       HEAP16[i14 + (i6 << 5) + 18 >> 1] = i15;
       HEAPF32[i14 + (i6 << 5) + 20 >> 2] = f9;
       HEAPF32[i14 + (i6 << 5) + 24 >> 2] = f8;
       HEAP32[i14 + (i6 << 5) + 28 >> 2] = HEAP32[i16 >> 2] << 16 | i18 & 65535;
      }
      i15 = i15 + 1 | 0;
     } while ((i15 | 0) < (HEAP32[i22 >> 2] | 0));
     i1 = HEAP32[i32 >> 2] | 0;
    }
   }
   i23 = i23 + 1 | 0;
  } while (i23 >>> 0 < i1 >>> 0);
 }
 if (i41 | 0) __Z12profiler_endP19ProfilerInformation(i41);
 i42 = (__Z19GetActiveColorSpacev() | 0) == 1;
 i41 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 80 >> 2] | 0, i41 | 0, i42 | 0);
 HEAP32[i51 >> 2] = 0;
 HEAP32[i52 >> 2] = 0;
 HEAP8[i53 >> 0] = 0;
 if ((HEAP16[gb + 1115172 + 6 >> 1] | 0) > -1) {
  HEAP32[i48 >> 2] = i44;
  HEAP32[i54 >> 2] = HEAP32[i48 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115172 | 0, i54);
  i2 = gb + 1115172 | 0;
 } else i2 = 0;
 i42 = HEAP32[gb + 1115172 >> 2] | 0;
 i41 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 648 >> 2] | 0, i41 | 0, i42 | 0);
 switch (i43 | 0) {
 case 2:
  {
   i40 = gb + 64016 | 0;
   i1 = HEAP32[i40 + 4 >> 2] | 0;
   i43 = i48;
   HEAP32[i43 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i43 + 4 >> 2] = i1;
   HEAP32[i45 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   i43 = i45 + 16 | 0;
   HEAP32[i43 >> 2] = 0;
   i1 = i45 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i54, i48);
   i40 = i54;
   i41 = HEAP32[i40 + 4 >> 2] | 0;
   i42 = i1;
   HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i42 + 4 >> 2] = i41;
   i42 = HEAP32[i49 >> 2] | 0;
   __Z19DoPrePassRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb(i42, i42 + 1840 | 0, i45, i50, i51, i52, i53);
   __ZL44RenderRemainingObjectsThatCantHandleDeferred13RenderingPathR17RenderLoopContextRK11CullResultsbP13RenderTextureS6_R13dynamic_arrayI16RenderObjectDataLj4EE(2, HEAP32[i49 >> 2] | 0, i50, (HEAP8[i53 >> 0] | 0) != 0, HEAP32[i51 >> 2] | 0, HEAP32[i52 >> 2] | 0, i45);
   if ((HEAP32[i43 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i1);
    HEAP32[i45 >> 2] = 0;
   }
   break;
  }
 case 3:
  {
   i40 = gb + 64024 | 0;
   i1 = HEAP32[i40 + 4 >> 2] | 0;
   i43 = i48;
   HEAP32[i43 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i43 + 4 >> 2] = i1;
   HEAP32[i45 >> 2] = 0;
   HEAP32[i45 + 12 >> 2] = 0;
   i43 = i45 + 16 | 0;
   HEAP32[i43 >> 2] = 0;
   i1 = i45 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i54, i48);
   i40 = i54;
   i41 = HEAP32[i40 + 4 >> 2] | 0;
   i42 = i1;
   HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i42 + 4 >> 2] = i41;
   i42 = HEAP32[i49 >> 2] | 0;
   __Z20DoDeferredRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb(i42, i42 + 1840 | 0, i45, i50, i51, i52, i53);
   __ZL44RenderRemainingObjectsThatCantHandleDeferred13RenderingPathR17RenderLoopContextRK11CullResultsbP13RenderTextureS6_R13dynamic_arrayI16RenderObjectDataLj4EE(3, HEAP32[i49 >> 2] | 0, i50, (HEAP8[i53 >> 0] | 0) != 0, HEAP32[i51 >> 2] | 0, HEAP32[i52 >> 2] | 0, i45);
   if ((HEAP32[i43 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i1);
    HEAP32[i45 >> 2] = 0;
   }
   break;
  }
 default:
  {
   i45 = HEAP32[i49 >> 2] | 0;
   __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE(i45, i45 + 1840 | 0, i50, 1, 0, 1, 0);
  }
 }
 i45 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i45 >> 2] | 0) + 652 >> 2] | 0, i45 | 0);
 if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 __ZN6Camera12RenderSkyboxEv(i47);
 if ((HEAP16[gb + 1115196 + 6 >> 1] | 0) > -1) {
  HEAP32[i48 >> 2] = i44;
  HEAP32[i54 >> 2] = HEAP32[i48 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115196 | 0, i54);
  i1 = gb + 1115196 | 0;
 } else i1 = 0;
 i45 = HEAP32[gb + 1115196 >> 2] | 0;
 i43 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 648 >> 2] | 0, i43 | 0, i45 | 0);
 __Z24DoMotionVectorRenderLoopR17RenderLoopContext(HEAP32[i49 >> 2] | 0);
 i45 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i45 >> 2] | 0) + 652 >> 2] | 0, i45 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 __Z18RenderImageFiltersR10RenderLoopP13RenderTextureb(i49, __ZNK6Camera16GetTargetTextureEv(i47) | 0, 1);
 i45 = (HEAP8[i47 + 1120 >> 0] | 0) == 0;
 i2 = __Z12GetGfxDevicev() | 0;
 __ZNK6Camera28ExtractCameraRenderingParamsEv(i54, i47);
 i3 = i54 + 64 | 0;
 if (i45) i1 = __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i47) | 0; else i1 = __ZNK6Camera19GetProjectionMatrixEv(i47) | 0;
 i7 = i3;
 i4 = i1;
 i5 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  i7 = i7 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i54 | 0);
 if ((HEAP16[gb + 1115184 + 6 >> 1] | 0) > -1) {
  HEAP32[i48 >> 2] = i44;
  HEAP32[i54 >> 2] = HEAP32[i48 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115184 | 0, i54);
  i1 = gb + 1115184 | 0;
 } else i1 = 0;
 i48 = HEAP32[gb + 1115184 >> 2] | 0;
 i45 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 648 >> 2] | 0, i45 | 0, i48 | 0);
 i48 = HEAP32[i49 >> 2] | 0;
 __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE(i48, i48 + 1860 | 0, i50, 0, 0, 0, 0);
 i50 = HEAP32[i49 >> 2] | 0;
 __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext(i50, HEAP32[i51 >> 2] | 0, HEAP32[i52 >> 2] | 0, i50 + 1860 | 0, (HEAP8[i53 >> 0] | 0) != 0, 0, 0, HEAP32[gb + 1166248 >> 2] | 0);
 i53 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i53 >> 2] | 0) + 652 >> 2] | 0, i53 | 0);
 if (!i1) {
  i1 = __Z12GetGfxDevicev() | 0;
  __ZNK6Camera28ExtractCameraRenderingParamsEv(i54, i47);
  i2 = i54 + 64 | 0;
  i4 = __ZNK6Camera19GetProjectionMatrixEv(i47) | 0;
  i7 = i2;
  i5 = i7 + 64 | 0;
  do {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   i7 = i7 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i7 | 0) < (i5 | 0));
  i53 = HEAP32[i1 >> 2] | 0;
  i53 = i53 + 116 | 0;
  i53 = HEAP32[i53 >> 2] | 0;
  mftCall_vii(i53 | 0, i1 | 0, i2 | 0);
  i53 = HEAP32[i1 >> 2] | 0;
  i53 = i53 + 112 | 0;
  i53 = HEAP32[i53 >> 2] | 0;
  mftCall_vii(i53 | 0, i1 | 0, i54 | 0);
  i54 = __Z12GetGfxDevicev() | 0;
  i53 = HEAP32[i54 >> 2] | 0;
  i53 = i53 + 96 | 0;
  i53 = HEAP32[i53 >> 2] | 0;
  mftCall_vii(i53 | 0, i54 | 0, i46 | 0);
  STACKTOP = i55;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 i1 = __Z12GetGfxDevicev() | 0;
 __ZNK6Camera28ExtractCameraRenderingParamsEv(i54, i47);
 i2 = i54 + 64 | 0;
 i4 = __ZNK6Camera19GetProjectionMatrixEv(i47) | 0;
 i7 = i2;
 i5 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  i7 = i7 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i53 = HEAP32[i1 >> 2] | 0;
 i53 = i53 + 116 | 0;
 i53 = HEAP32[i53 >> 2] | 0;
 mftCall_vii(i53 | 0, i1 | 0, i2 | 0);
 i53 = HEAP32[i1 >> 2] | 0;
 i53 = i53 + 112 | 0;
 i53 = HEAP32[i53 >> 2] | 0;
 mftCall_vii(i53 | 0, i1 | 0, i54 | 0);
 i54 = __Z12GetGfxDevicev() | 0;
 i53 = HEAP32[i54 >> 2] | 0;
 i53 = i53 + 96 | 0;
 i53 = HEAP32[i53 >> 2] | 0;
 mftCall_vii(i53 | 0, i54 | 0, i46 | 0);
 STACKTOP = i55;
 return;
}

function __ZN13AnimationClip8GetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfE(i2, i3, i12, i1, i14, i15) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i28;
 i25 = i28 + 304 | 0;
 i22 = i28 + 216 | 0;
 i19 = i28 + 128 | 0;
 i16 = i28 + 40 | 0;
 i8 = i28 + 28 | 0;
 i9 = i28 + 16 | 0;
 HEAPF32[i25 + 4 >> 2] = Math_fround(inf);
 HEAP32[i25 >> 2] = 0;
 i24 = i25 + 8 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP32[i24 + 16 >> 2] = 0;
 HEAPF32[i25 + 32 >> 2] = Math_fround(inf);
 HEAP32[i25 + 28 >> 2] = 0;
 i24 = i25 + 36 | 0;
 HEAP32[i25 + 68 >> 2] = 0;
 i26 = i25 + 72 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i25 + 60 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP32[i24 + 16 >> 2] = 0;
 HEAP32[i24 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i24 = i10;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i21 = i27;
 HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i21 + 4 >> 2] = i23;
 HEAP32[i25 + 80 >> 2] = 2;
 HEAP32[i25 + 76 >> 2] = 2;
 HEAP32[i25 + 84 >> 2] = 4;
 HEAPF32[i22 + 4 >> 2] = Math_fround(inf);
 HEAP32[i22 >> 2] = 0;
 i21 = i22 + 8 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAPF32[i22 + 32 >> 2] = Math_fround(inf);
 HEAP32[i22 + 28 >> 2] = 0;
 i21 = i22 + 36 | 0;
 HEAP32[i22 + 68 >> 2] = 0;
 i23 = i22 + 72 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i22 + 60 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i21 = i10;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i18 = i24;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i22 + 80 >> 2] = 2;
 HEAP32[i22 + 76 >> 2] = 2;
 HEAP32[i22 + 84 >> 2] = 4;
 HEAPF32[i19 + 4 >> 2] = Math_fround(inf);
 HEAP32[i19 >> 2] = 0;
 i18 = i19 + 8 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAPF32[i19 + 32 >> 2] = Math_fround(inf);
 HEAP32[i19 + 28 >> 2] = 0;
 i18 = i19 + 36 | 0;
 HEAP32[i19 + 68 >> 2] = 0;
 i20 = i19 + 72 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i19 + 60 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i18 = i10;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i6 = i21;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 4 >> 2] = i17;
 HEAP32[i19 + 80 >> 2] = 2;
 HEAP32[i19 + 76 >> 2] = 2;
 HEAP32[i19 + 84 >> 2] = 4;
 HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
 HEAP32[i16 >> 2] = 0;
 i6 = i16 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
 HEAP32[i16 + 28 >> 2] = 0;
 i6 = i16 + 36 | 0;
 HEAP32[i16 + 68 >> 2] = 0;
 i17 = i16 + 72 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i16 + 60 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i6 = i10;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i18;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i16 + 80 >> 2] = 2;
 HEAP32[i16 + 76 >> 2] = 2;
 HEAP32[i16 + 84 >> 2] = 4;
 L1 : do if ((i12 | 0) == 4) {
  i11 = i14 + 11 | 0;
  if (__Z10BeginsWithPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, gb + 896768 | 0) | 0) {
   i5 = HEAP32[i2 + 100 >> 2] | 0;
   i7 = HEAP32[i2 + 104 >> 2] | 0;
   L5 : do if ((i5 | 0) != (i7 | 0)) {
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i6 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
    i4 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
    while (1) {
     i3 = HEAP8[i5 + 11 >> 0] | 0;
     i1 = i3 << 24 >> 24 < 0;
     if (i1) i2 = HEAP32[i5 + 4 >> 2] | 0; else i2 = i3 & 255;
     if ((i2 | 0) == (i6 | 0)) {
      if (i1) {
       i2 = HEAP32[i5 >> 2] | 0;
       i1 = HEAP32[i5 + 4 >> 2] | 0;
      } else {
       i2 = i5;
       i1 = i3 & 255;
      }
      if (!(_strncmp(i2, i4, i1) | 0)) break L5;
     }
     i5 = i5 + 204 | 0;
     if ((i5 | 0) == (i7 | 0)) {
      i2 = 0;
      break L1;
     }
    }
   } while (0);
   if ((i5 | 0) == (i7 | 0)) {
    i2 = 0;
    break;
   }
   HEAP32[i10 >> 2] = i25;
   i1 = i10 + 4 | 0;
   HEAP32[i1 >> 2] = i22;
   i2 = i10 + 8 | 0;
   HEAP32[i2 >> 2] = i19;
   i3 = i10 + 12 | 0;
   HEAP32[i3 >> 2] = i16;
   i4 = HEAP8[i11 >> 0] | 0;
   i12 = i4 << 24 >> 24 < 0;
   i4 = i12 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
   switch (HEAP8[(i12 ? HEAP32[i14 >> 2] | 0 : i14) + (i4 + -1) >> 0] | 0) {
   case 120:
    {
     HEAP32[i10 >> 2] = i15;
     i13 = 21;
     break;
    }
   case 121:
    {
     HEAP32[i1 >> 2] = i15;
     i13 = 21;
     break;
    }
   case 122:
    {
     HEAP32[i2 >> 2] = i15;
     i13 = 21;
     break;
    }
   case 119:
    {
     HEAP32[i3 >> 2] = i15;
     i13 = 21;
     break;
    }
   default:
    {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, gb + 907286 | 0, 24, i4 + 24 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, i4) | 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     i1 = HEAP8[i9 + 11 >> 0] | 0;
     i15 = i1 << 24 >> 24 < 0;
     i1 = i15 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i15 ? HEAP32[i9 >> 2] | 0 : i9, i1, i1 + 35 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 907311 | 0, 35) | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 899654 | 0, 951, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     i1 = 0;
    }
   }
   if ((i13 | 0) == 21) {
    __Z21ExpandQuaternionCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE(i5 + 16 | 0, i10);
    i1 = 1;
   }
   i2 = i1;
   break;
  }
  if (!(__Z10BeginsWithPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, gb + 896797 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, gb + 896813 | 0) | 0)) {
   i13 = 57;
   break;
  }
  if (__Z10BeginsWithPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, gb + 896797 | 0) | 0) {
   i1 = HEAP32[i2 + 132 >> 2] | 0;
   i7 = HEAP32[i2 + 136 >> 2] | 0;
   L37 : do if ((i1 | 0) != (i7 | 0)) {
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
    i5 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
    while (1) {
     i4 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     if (i2) i3 = HEAP32[i1 + 4 >> 2] | 0; else i3 = i4 & 255;
     if ((i3 | 0) == (i6 | 0)) {
      if (i2) {
       i3 = HEAP32[i1 >> 2] | 0;
       i2 = HEAP32[i1 + 4 >> 2] | 0;
      } else {
       i3 = i1;
       i2 = i4 & 255;
      }
      if (!(_strncmp(i3, i5, i2) | 0)) break L37;
     }
     i1 = i1 + 172 | 0;
     if ((i1 | 0) == (i7 | 0)) {
      i2 = 0;
      break L1;
     }
    }
   } while (0);
   if ((i1 | 0) == (i7 | 0)) {
    i2 = 0;
    break;
   }
  } else {
   i1 = HEAP32[i2 + 148 >> 2] | 0;
   i7 = HEAP32[i2 + 152 >> 2] | 0;
   L54 : do if ((i1 | 0) != (i7 | 0)) {
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
    i5 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
    while (1) {
     i4 = HEAP8[i1 + 11 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     if (i2) i3 = HEAP32[i1 + 4 >> 2] | 0; else i3 = i4 & 255;
     if ((i3 | 0) == (i6 | 0)) {
      if (i2) {
       i3 = HEAP32[i1 >> 2] | 0;
       i2 = HEAP32[i1 + 4 >> 2] | 0;
      } else {
       i3 = i1;
       i2 = i4 & 255;
      }
      if (!(_strncmp(i3, i5, i2) | 0)) break L54;
     }
     i1 = i1 + 172 | 0;
     if ((i1 | 0) == (i7 | 0)) {
      i2 = 0;
      break L1;
     }
    }
   } while (0);
   if ((i1 | 0) == (i7 | 0)) {
    i2 = 0;
    break;
   }
  }
  HEAP32[i10 >> 2] = i25;
  i2 = i10 + 4 | 0;
  HEAP32[i2 >> 2] = i22;
  i3 = i10 + 8 | 0;
  HEAP32[i3 >> 2] = i19;
  i4 = HEAP8[i11 >> 0] | 0;
  i12 = i4 << 24 >> 24 < 0;
  i4 = i12 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
  switch (HEAP8[(i12 ? HEAP32[i14 >> 2] | 0 : i14) + (i4 + -1) >> 0] | 0) {
  case 120:
   {
    HEAP32[i10 >> 2] = i15;
    i13 = 55;
    break;
   }
  case 121:
   {
    HEAP32[i2 >> 2] = i15;
    i13 = 55;
    break;
   }
  case 122:
   {
    HEAP32[i3 >> 2] = i15;
    i13 = 55;
    break;
   }
  default:
   {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, gb + 907286 | 0, 24, i4 + 24 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, i4) | 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    HEAP32[i8 + 8 >> 2] = 0;
    i1 = HEAP8[i9 + 11 >> 0] | 0;
    i15 = i1 << 24 >> 24 < 0;
    i1 = i15 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i15 ? HEAP32[i9 >> 2] | 0 : i9, i1, i1 + 35 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 907311 | 0, 35) | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 899654 | 0, 999, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i1 = 0;
   }
  }
  if ((i13 | 0) == 55) {
   __Z18ExpandVector3CurveR17AnimationCurveTplI8Vector3fEPPS_IfE(i1 + 16 | 0, i10);
   i1 = 1;
  }
  i2 = i1;
 } else i13 = 57; while (0);
 L79 : do if ((i13 | 0) == 57) {
  i8 = HEAP32[i2 + 164 >> 2] | 0;
  i11 = HEAP32[i2 + 168 >> 2] | 0;
  L81 : do if ((i8 | 0) != (i11 | 0)) {
   i10 = HEAP8[i3 + 11 >> 0] | 0;
   i7 = i10 << 24 >> 24 < 0;
   i10 = i7 ? HEAP32[i3 + 4 >> 2] | 0 : i10 & 255;
   i7 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
   i9 = HEAP8[i14 + 11 >> 0] | 0;
   i6 = i9 << 24 >> 24 < 0;
   i9 = i6 ? HEAP32[i14 + 4 >> 2] | 0 : i9 & 255;
   i6 = i6 ? HEAP32[i14 >> 2] | 0 : i14;
   i5 = HEAP32[i1 >> 2] | 0;
   while (1) {
    if ((HEAP32[i8 + 32 >> 2] | 0) == (i12 | 0)) {
     i3 = HEAP8[i8 + 11 >> 0] | 0;
     i1 = i3 << 24 >> 24 < 0;
     if (i1) i2 = HEAP32[i8 + 4 >> 2] | 0; else i2 = i3 & 255;
     if ((i2 | 0) == (i10 | 0)) {
      if (i1) {
       i2 = HEAP32[i8 >> 2] | 0;
       i1 = HEAP32[i8 + 4 >> 2] | 0;
      } else {
       i2 = i8;
       i1 = i3 & 255;
      }
      if (!(_strncmp(i2, i7, i1) | 0)) {
       i2 = i8 + 16 | 0;
       i4 = HEAP8[i2 + 11 >> 0] | 0;
       i1 = i4 << 24 >> 24 < 0;
       if (i1) i3 = HEAP32[i8 + 20 >> 2] | 0; else i3 = i4 & 255;
       if ((i3 | 0) == (i9 | 0)) {
        if (i1) {
         i2 = HEAP32[i2 >> 2] | 0;
         i1 = HEAP32[i8 + 20 >> 2] | 0;
        } else i1 = i4 & 255;
        if (!(_strncmp(i2, i6, i1) | 0)) if ((HEAP32[i8 + 36 >> 2] | 0) == (i5 | 0)) break L81;
       }
      }
     }
    }
    i8 = i8 + 132 | 0;
    if ((i8 | 0) == (i11 | 0)) {
     i2 = 0;
     break L79;
    }
   }
  } while (0);
  if ((i8 | 0) == (i11 | 0)) i2 = 0; else {
   i14 = i8 + 40 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i15 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i15 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
   i2 = i15 + 28 | 0;
   i13 = i8 + 68 | 0;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
   i2 = i15 + 56 | 0;
   if ((i14 | 0) != (i15 | 0)) {
    i6 = HEAP32[i8 + 96 >> 2] | 0;
    i7 = i15 + 68 | 0;
    i1 = HEAP32[i8 + 108 >> 2] << 4;
    i3 = i1 >> 4;
    HEAP32[i7 >> 2] = i3;
    i4 = i15 + 72 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i4 >> 2] = i3;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i15 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i2 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i15 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = i1;
     break;
    } else i1 = HEAP32[i2 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
   }
   i2 = i15 + 76 | 0;
   i15 = i8 + 116 | 0;
   HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   i2 = 1;
  }
 } while (0);
 i1 = i16 + 56 | 0;
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i18);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i19 + 56 | 0;
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i21);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 56 | 0;
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i24);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i25 + 56 | 0;
 if ((HEAP32[i26 >> 2] | 0) <= -1) {
  STACKTOP = i28;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i27);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i28;
 return i2 | 0;
}

function __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i38, i40, i39, i1, i62, i63, i64, i65, i67, i69, i55) {
 i38 = i38 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i65 = i65 | 0;
 i67 = i67 | 0;
 i69 = i69 | 0;
 i55 = i55 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i66 = 0, i68 = 0, i70 = 0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i70 + 432 | 0;
 i49 = i70 + 548 | 0;
 i48 = i70 + 536 | 0;
 i60 = i70 + 368 | 0;
 i58 = i70 + 304 | 0;
 i59 = i70 + 240 | 0;
 i66 = i70 + 520 | 0;
 i68 = i70 + 504 | 0;
 i41 = i70 + 496 | 0;
 i61 = i70 + 224 | 0;
 i30 = i70 + 208 | 0;
 i28 = i70 + 192 | 0;
 i31 = i70 + 176 | 0;
 i29 = i70 + 160 | 0;
 i32 = i70 + 484 | 0;
 i33 = i70 + 144 | 0;
 i43 = i70 + 128 | 0;
 i36 = i70 + 112 | 0;
 i44 = i70 + 96 | 0;
 i42 = i70 + 80 | 0;
 i51 = i70 + 64 | 0;
 i52 = i70 + 48 | 0;
 i50 = i70 + 472 | 0;
 i37 = i70 + 32 | 0;
 i35 = i70 + 460 | 0;
 i46 = i70 + 16 | 0;
 i47 = i70;
 i45 = i70 + 448 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f56 = Math_fround(HEAPF32[i38 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i40 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(HEAPF32[i38 + 32 >> 2]);
 f54 = Math_fround(HEAPF32[i40 + 32 >> 2]);
 f34 = Math_fround((f34 > f54 ? f54 : f34) * Math_fround(.100000001));
 f34 = Math_fround(f34 * f34);
 f54 = Math_fround(f56 + f57);
 HEAP32[i41 >> 2] = 0;
 if (!(HEAP8[i55 >> 0] | 0)) {
  f5 = Math_fround(HEAPF32[i39 + 48 >> 2]);
  f6 = Math_fround(HEAPF32[i39 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i39 + 56 >> 2]);
  i23 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)) > Math_fround(0.0);
  f5 = i23 ? f5 : Math_fround(1.0);
  f6 = i23 ? f6 : Math_fround(0.0);
  f7 = i23 ? f7 : Math_fround(0.0);
  HEAPF32[i61 >> 2] = f5;
  HEAPF32[i61 + 4 >> 2] = f6;
  HEAPF32[i61 + 8 >> 2] = f7;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i33 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  i23 = i61;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i53 = 7;
 } else {
  HEAP32[i30 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i38 + 16 | 0;
  i2 = i39 + 48 | 0;
  i3 = i39 + 52 | 0;
  i9 = i39 + 56 | 0;
  i10 = i28 + 4 | 0;
  i11 = i28 + 8 | 0;
  i12 = i39 + 16 | 0;
  i13 = i39 + 32 | 0;
  i14 = i39 + 4 | 0;
  i15 = i39 + 20 | 0;
  i16 = i39 + 36 | 0;
  i17 = i39 + 8 | 0;
  i18 = i39 + 24 | 0;
  i19 = i39 + 40 | 0;
  i20 = i40 + 16 | 0;
  i21 = i31 + 4 | 0;
  i22 = i31 + 8 | 0;
  i23 = i30 + 4 | 0;
  i24 = i30 + 8 | 0;
  i25 = i30 + 12 | 0;
  i26 = 0;
  do {
   i72 = HEAPU8[i67 + i26 >> 0] | 0;
   HEAP32[i66 + (i26 << 2) >> 2] = i72;
   i71 = HEAPU8[i69 + i26 >> 0] | 0;
   HEAP32[i68 + (i26 << 2) >> 2] = i71;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i28, i38, i72, i1);
   f74 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(HEAPF32[i3 >> 2]);
   f4 = Math_fround(HEAPF32[i9 >> 2]);
   f75 = Math_fround(HEAPF32[i28 >> 2]);
   f73 = Math_fround(HEAPF32[i10 >> 2]);
   f8 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(f75 * Math_fround(HEAPF32[i39 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f73 * Math_fround(HEAPF32[i12 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2])));
   f7 = Math_fround(f75 * Math_fround(HEAPF32[i14 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f73 * Math_fround(HEAPF32[i15 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
   f75 = Math_fround(f75 * Math_fround(HEAPF32[i17 >> 2]));
   f73 = Math_fround(f75 + Math_fround(f73 * Math_fround(HEAPF32[i18 >> 2])));
   f6 = Math_fround(f74 + f6);
   f7 = Math_fround(f5 + f7);
   f8 = Math_fround(f4 + Math_fround(f73 + Math_fround(f8 * Math_fround(HEAPF32[i19 >> 2]))));
   __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i31, i40, i71, i20);
   f73 = Math_fround(HEAPF32[i31 >> 2]);
   f4 = Math_fround(HEAPF32[i21 >> 2]);
   f4 = Math_fround(f7 - f4);
   f5 = Math_fround(f8 - Math_fround(HEAPF32[i22 >> 2]));
   HEAPF32[i30 >> 2] = Math_fround(f6 - f73);
   HEAPF32[i23 >> 2] = f4;
   HEAPF32[i24 >> 2] = f5;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i71 = HEAP32[i41 >> 2] | 0;
   HEAPF32[i58 + (i71 << 4) >> 2] = f6;
   HEAPF32[i58 + (i71 << 4) + 4 >> 2] = f7;
   HEAPF32[i58 + (i71 << 4) + 8 >> 2] = f8;
   HEAPF32[i58 + (i71 << 4) + 12 >> 2] = Math_fround(0.0);
   i72 = i59 + (i71 << 4) | 0;
   HEAP32[i72 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i72 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
   HEAP32[i41 >> 2] = i71 + 1;
   i71 = i60 + (i71 << 4) | 0;
   HEAP32[i71 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i71 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i71 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i71 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   i26 = i26 + 1 | 0;
  } while (i26 >>> 0 < (HEAPU8[i55 >> 0] | 0) >>> 0);
  __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i29, i60, i58, i59, i66, i68, i30, i41);
  HEAP32[i61 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i61 >> 2]);
  f6 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i61 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i49 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i48 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i33 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
  if (f4 > f34) {
   i23 = i61;
   i53 = 7;
  } else i2 = HEAP32[i41 >> 2] | 0;
 }
 do if ((i53 | 0) == 7) {
  i21 = i61 + 4 | 0;
  i22 = i61 + 8 | 0;
  i9 = i36 + 4 | 0;
  i10 = i36 + 8 | 0;
  i11 = i36 + 12 | 0;
  i12 = i43 + 4 | 0;
  i13 = i43 + 8 | 0;
  i14 = i44 + 4 | 0;
  i15 = i44 + 8 | 0;
  i16 = i42 + 4 | 0;
  i17 = i42 + 8 | 0;
  i18 = i42 + 12 | 0;
  i19 = i38 + 48 | 0;
  i20 = i40 + 48 | 0;
  while (1) {
   HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
   HEAP32[i33 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i33 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   f6 = Math_fround(-f6);
   f74 = Math_fround(-f7);
   HEAPF32[i36 >> 2] = Math_fround(-f5);
   HEAPF32[i9 >> 2] = f6;
   HEAPF32[i10 >> 2] = f74;
   HEAPF32[i11 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i41 >> 2] | 0;
   __ZNK5physx2Gu24ShrunkConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVERS4_Ri(i43, i38, i36, i39, i58 + (i3 << 4) | 0, i66 + (i3 << 2) | 0);
   i3 = HEAP32[i41 >> 2] | 0;
   __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i44, i40, i61, i59 + (i3 << 4) | 0, i68 + (i3 << 2) | 0);
   f74 = Math_fround(HEAPF32[i43 >> 2]);
   f6 = Math_fround(HEAPF32[i12 >> 2]);
   f75 = Math_fround(HEAPF32[i13 >> 2]);
   f7 = Math_fround(HEAPF32[i44 >> 2]);
   f73 = Math_fround(HEAPF32[i14 >> 2]);
   f7 = Math_fround(f74 - f7);
   f73 = Math_fround(f6 - f73);
   f75 = Math_fround(f75 - Math_fround(HEAPF32[i15 >> 2]));
   HEAPF32[i42 >> 2] = f7;
   HEAPF32[i16 >> 2] = f73;
   HEAPF32[i17 >> 2] = f75;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i41 >> 2] | 0;
   i2 = i60 + (i3 << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   f6 = Math_fround(HEAPF32[i19 >> 2]);
   f74 = Math_fround(HEAPF32[i20 >> 2]);
   f74 = f6 > f74 ? f6 : f74;
   f27 = f27 > f74 ? f27 : f74;
   f74 = Math_fround(f54 + f27);
   f74 = Math_fround(f4 * Math_fround(f74 * f74));
   f6 = Math_fround(HEAPF32[i61 >> 2]);
   f8 = Math_fround(HEAPF32[i21 >> 2]);
   f75 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f73)) + Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f75));
   i2 = f75 > Math_fround(0.0) & Math_fround(f75 * f75) > f74;
   if (Math_fround(f4 * Math_fround(.00039999999)) >= Math_fround(f4 - f75) | i2) {
    i53 = 9;
    break;
   }
   HEAP32[i41 >> 2] = i3 + 1;
   __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i37, i60, i58, i59, i66, i68, i42, i41);
   HEAP32[i23 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   f5 = Math_fround(HEAPF32[i61 >> 2]);
   f6 = Math_fround(HEAPF32[i21 >> 2]);
   f7 = Math_fround(HEAPF32[i22 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
   HEAP32[i49 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   i1 = f4 > f8;
   if (!(f8 > f34 & i1)) break; else f4 = f8;
  }
  if ((i53 | 0) == 9) {
   if (i67 | 0) {
    HEAP8[i55 >> 0] = i3;
    if (i3 | 0) {
     i1 = 0;
     do {
      HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
      HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
   }
   if (i2) {
    i72 = 0;
    STACKTOP = i70;
    return i72 | 0;
   }
   __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i51, i52, i3);
   f34 = Math_fround(Math_sqrt(Math_fround(f4)));
   f73 = Math_fround(HEAPF32[i61 >> 2]);
   f74 = Math_fround(HEAPF32[i21 >> 2]);
   f75 = Math_fround(Math_fround(1.0) / f34);
   f73 = Math_fround(f73 * f75);
   f74 = Math_fround(f74 * f75);
   f75 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f75);
   f7 = Math_fround(HEAPF32[i51 >> 2]);
   f27 = Math_fround(HEAPF32[i51 + 4 >> 2]);
   f27 = Math_fround(f27 - Math_fround(f56 * f74));
   f8 = Math_fround(Math_fround(HEAPF32[i51 + 8 >> 2]) - Math_fround(f56 * f75));
   HEAPF32[i62 >> 2] = Math_fround(f7 - Math_fround(f56 * f73));
   HEAPF32[i62 + 4 >> 2] = f27;
   HEAPF32[i62 + 8 >> 2] = f8;
   HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
   f8 = Math_fround(HEAPF32[i52 >> 2]);
   f27 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f27 = Math_fround(Math_fround(f57 * f74) + f27);
   f56 = Math_fround(Math_fround(f57 * f75) + Math_fround(HEAPF32[i52 + 8 >> 2]));
   HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f73) + f8);
   HEAPF32[i63 + 4 >> 2] = f27;
   HEAPF32[i63 + 8 >> 2] = f56;
   HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i65 >> 2] = Math_fround(f34 - f54);
   i72 = i65 + 4 | 0;
   HEAP32[i72 >> 2] = HEAP32[i50 >> 2];
   HEAP32[i72 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
   HEAP32[i72 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
   HEAPF32[i64 >> 2] = f73;
   HEAPF32[i64 + 4 >> 2] = f74;
   HEAPF32[i64 + 8 >> 2] = f75;
   HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
   i72 = 1;
   STACKTOP = i70;
   return i72 | 0;
  }
  i2 = HEAP32[i41 >> 2] | 0;
  if (i1) {
   if (!i67) i1 = 6; else break;
   STACKTOP = i70;
   return i1 | 0;
  }
  i3 = i2 + -1 | 0;
  if (i67 | 0) {
   HEAP8[i55 >> 0] = i3;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
     HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  };
  HEAP32[i23 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i60, i58, i59, i61, i46, i47, i2);
  HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  f34 = Math_fround(Math_sqrt(Math_fround(f4)));
  f73 = Math_fround(HEAPF32[i61 >> 2]);
  f74 = Math_fround(HEAPF32[i61 + 4 >> 2]);
  f75 = Math_fround(Math_fround(1.0) / f34);
  f73 = Math_fround(f73 * f75);
  f74 = Math_fround(f74 * f75);
  f75 = Math_fround(Math_fround(HEAPF32[i61 + 8 >> 2]) * f75);
  f7 = Math_fround(HEAPF32[i46 >> 2]);
  f27 = Math_fround(HEAPF32[i46 + 4 >> 2]);
  f27 = Math_fround(f27 - Math_fround(f56 * f74));
  f8 = Math_fround(Math_fround(HEAPF32[i46 + 8 >> 2]) - Math_fround(f56 * f75));
  HEAPF32[i62 >> 2] = Math_fround(f7 - Math_fround(f56 * f73));
  HEAPF32[i62 + 4 >> 2] = f27;
  HEAPF32[i62 + 8 >> 2] = f8;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  f8 = Math_fround(HEAPF32[i47 >> 2]);
  f27 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f27 = Math_fround(Math_fround(f57 * f74) + f27);
  f56 = Math_fround(Math_fround(f57 * f75) + Math_fround(HEAPF32[i47 + 8 >> 2]));
  HEAPF32[i63 >> 2] = Math_fround(Math_fround(f57 * f73) + f8);
  HEAPF32[i63 + 4 >> 2] = f27;
  HEAPF32[i63 + 8 >> 2] = f56;
  HEAPF32[i63 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i65 >> 2] = Math_fround(f34 - f54);
  i72 = i65 + 4 | 0;
  HEAP32[i72 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i72 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i72 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAPF32[i64 >> 2] = f73;
  HEAPF32[i64 + 4 >> 2] = f74;
  HEAPF32[i64 + 8 >> 2] = f75;
  HEAPF32[i64 + 12 >> 2] = Math_fround(0.0);
  i72 = 3;
  STACKTOP = i70;
  return i72 | 0;
 } while (0);
 HEAP8[i55 >> 0] = i2;
 if (!i2) {
  i72 = 6;
  STACKTOP = i70;
  return i72 | 0;
 } else i1 = 0;
 do {
  HEAP8[i67 + i1 >> 0] = HEAP32[i66 + (i1 << 2) >> 2];
  HEAP8[i69 + i1 >> 0] = HEAP32[i68 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 6;
 STACKTOP = i70;
 return i1 | 0;
}

function __ZN20SpeedTreeWindManager7GetWindERK4AABBRP18SpeedTreeLocalWindRK18SpeedTreeWindAsset(i25, i23, i26, i16) {
 i25 = i25 | 0;
 i23 = i23 | 0;
 i26 = i26 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i27 = 0, f28 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i27 + 8 | 0;
 i22 = i27;
 i11 = i25 + 48 | 0;
 f15 = Math_fround(HEAPF32[i11 >> 2]);
 i19 = i25 + 52 | 0;
 f9 = Math_fround(HEAPF32[i19 >> 2]);
 if (f15 != f9) {
  i10 = HEAP32[gb + 1170608 >> 2] | 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i10 | 0)) {
   f7 = Math_fround(0.0);
   f6 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i3 = i21 + 4 | 0;
   i4 = i21 + 8 | 0;
   i5 = i21 + 12 | 0;
   f7 = Math_fround(0.0);
   f6 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f15 = Math_fround(0.0);
   f14 = Math_fround(0.0);
   do {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (!(HEAP32[i1 + 36 >> 2] | 0)) if (__ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, gb + 1155204 | 0, i21) | 0) {
     f28 = Math_fround(HEAPF32[i21 >> 2]);
     f8 = Math_fround(HEAPF32[i3 >> 2]);
     f6 = Math_fround(HEAPF32[i4 >> 2]);
     f7 = Math_fround(HEAPF32[i5 >> 2]);
     f9 = Math_fround(f9 + Math_fround(f28 * f7));
     f15 = Math_fround(f15 + Math_fround(f8 * f7));
     f14 = Math_fround(f14 + Math_fround(f6 * f7));
     f7 = f9;
     f6 = f15;
     f8 = f14;
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i10 | 0));
   i1 = HEAP32[i19 >> 2] | 0;
  }
  HEAPF32[i25 + 36 >> 2] = f7;
  HEAPF32[i25 + 40 >> 2] = f6;
  HEAPF32[i25 + 44 >> 2] = f8;
  HEAP32[i11 >> 2] = i1;
  i17 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i17 = HEAP32[i25 + 36 >> 2] | 0;
  i18 = HEAP32[i25 + 40 >> 2] | 0;
  i13 = HEAP32[i25 + 44 >> 2] | 0;
 }
 i2 = HEAP32[i25 + 12 >> 2] | 0;
 L17 : do if (!i2) i20 = 0; else {
  i5 = HEAP32[i25 >> 2] | 0;
  i3 = i16 + 32 | 0;
  i1 = 0;
  while (1) {
   i4 = i5 + (i1 << 3) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    i20 = 0;
    break L17;
   }
  }
  if (!i4) i20 = 0; else {
   f6 = Math_fround(HEAPF32[i16 + 1488 >> 2]);
   if (f6 == Math_fround(0.0)) {
    f28 = Math_fround(HEAPF32[i16 + 1412 >> 2]);
    if (!(f28 != Math_fround(HEAPF32[i16 + 1516 >> 2]))) {
     f28 = Math_fround(HEAPF32[i16 + 1416 >> 2]);
     if (!(f28 != Math_fround(HEAPF32[i16 + 1520 >> 2]))) {
      f28 = Math_fround(HEAPF32[i16 + 1420 >> 2]);
      if (!(f28 != Math_fround(HEAPF32[i16 + 1524 >> 2]))) if (!(Math_fround(HEAPF32[i16 + 1408 >> 2]) != f6)) {
       f28 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f28 == Math_fround(HEAPF32[gb + 1162364 >> 2])) {
        f28 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        if (f28 == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) {
         f28 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         if (f28 == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
          i20 = 0;
          break;
         }
        }
       }
      }
     }
    }
   }
   HEAP8[i5 + (i1 << 3) + 4 >> 0] = 1;
   i20 = i4;
  }
 } while (0);
 i3 = HEAP32[gb + 1170608 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  f7 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 } else {
  i4 = i21 + 4 | 0;
  i5 = i21 + 8 | 0;
  i10 = i21 + 12 | 0;
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 36 >> 2] | 0) == 1) if (__ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, i23, i21) | 0) {
    f28 = Math_fround(HEAPF32[i21 >> 2]);
    f9 = Math_fround(HEAPF32[i4 >> 2]);
    f8 = Math_fround(HEAPF32[i5 >> 2]);
    f7 = Math_fround(HEAPF32[i10 >> 2]);
    f6 = Math_fround(f6 + Math_fround(f28 * f7));
    f15 = Math_fround(f15 + Math_fround(f9 * f7));
    f14 = Math_fround(f14 + Math_fround(f8 * f7));
    f7 = f6;
    f8 = f14;
    f9 = f15;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  f14 = f8;
  f6 = f9;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  i12 = f7 != Math_fround(HEAPF32[gb + 1162364 >> 2]);
  i12 = i12 | f6 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  if (i12 | f14 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
   i5 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1170604 >> 2] | 0, 1904) | 0;
   _memset(i5 | 0, 0, 1904) | 0;
   i10 = i5 + 24 | 0;
   HEAPF32[i10 >> 2] = Math_fround(5.0);
   HEAPF32[i5 + 28 >> 2] = Math_fround(2.5);
   HEAPF32[i5 + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 36 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 440 >> 2] = Math_fround(50.0);
   HEAPF32[i5 + 444 >> 2] = Math_fround(2.0);
   HEAPF32[i5 + 648 >> 2] = Math_fround(.300000012);
   HEAPF32[i5 + 652 >> 2] = Math_fround(.75);
   HEAPF32[i5 + 656 >> 2] = Math_fround(.300000012);
   i11 = i5 + 528 | 0;
   i12 = i11 + 120 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   HEAPF32[i5 + 780 >> 2] = Math_fround(.300000012);
   HEAPF32[i5 + 784 >> 2] = Math_fround(.75);
   HEAPF32[i5 + 788 >> 2] = Math_fround(.300000012);
   i11 = i5 + 660 | 0;
   i12 = i11 + 120 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   HEAPF32[i5 + 992 >> 2] = Math_fround(20.0);
   HEAPF32[i5 + 996 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1e3 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1004 >> 2] = Math_fround(.300000012);
   HEAPF32[i5 + 1008 >> 2] = Math_fround(.00499999989);
   HEAPF32[i5 + 1012 >> 2] = Math_fround(1.0);
   _memset(i5 + 792 | 0, 0, 200) | 0;
   HEAPF32[i5 + 1216 >> 2] = Math_fround(20.0);
   HEAPF32[i5 + 1220 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1224 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1228 >> 2] = Math_fround(.300000012);
   HEAPF32[i5 + 1232 >> 2] = Math_fround(.00499999989);
   HEAPF32[i5 + 1236 >> 2] = Math_fround(1.0);
   _memset(i5 + 1016 | 0, 0, 200) | 0;
   HEAPF32[i5 + 1280 >> 2] = Math_fround(10.0);
   HEAPF32[i5 + 1284 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1288 >> 2] = Math_fround(.00499999989);
   HEAPF32[i5 + 1292 >> 2] = Math_fround(9.0);
   HEAPF32[i5 + 1296 >> 2] = Math_fround(32.0);
   HEAPF32[i5 + 1300 >> 2] = Math_fround(.400000006);
   HEAPF32[i5 + 1304 >> 2] = Math_fround(.0500000007);
   HEAPF32[i5 + 1308 >> 2] = Math_fround(.5);
   HEAPF32[i5 + 1312 >> 2] = Math_fround(.5);
   HEAPF32[i5 + 1316 >> 2] = Math_fround(-.5);
   HEAPF32[i5 + 1320 >> 2] = Math_fround(.5);
   HEAPF32[i5 + 1324 >> 2] = Math_fround(.5);
   HEAPF32[i5 + 1328 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1332 >> 2] = Math_fround(.5);
   HEAPF32[i5 + 1336 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1340 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1344 >> 2] = Math_fround(4.0);
   HEAPF32[i5 + 1348 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1352 >> 2] = Math_fround(1.0);
   _memset(i5 + 40 | 0, 0, 400) | 0;
   i1 = i5 + 1240 | 0;
   i11 = i5 + 448 | 0;
   i12 = i11 + 80 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   i11 = i1;
   i12 = i11 + 40 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   HEAPF32[i5 + 1368 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1400 >> 2] = Math_fround(0.0);
   HEAPF64[i5 + 1416 >> 3] = -1.0;
   HEAP8[i5 + 1424 >> 0] = 0;
   i1 = i5 + 1464 | 0;
   i11 = i5 + 1428 | 0;
   i12 = i11 + 36 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   HEAPF64[i1 >> 3] = 1.0;
   HEAPF64[i5 + 1472 >> 3] = 0.0;
   HEAPF32[i5 + 1480 >> 2] = Math_fround(0.0);
   i1 = i5 + 1488 | 0;
   i2 = i5 + 1536 | 0;
   i3 = i5 + 1572 | 0;
   i11 = i5 + 1372 | 0;
   i12 = i11 + 28 | 0;
   do {
    HEAP8[i11 >> 0] = 0;
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) < (i12 | 0));
   i4 = i5 + 1404 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i11 = i3;
   i12 = i11 + 80 | 0;
   do {
    HEAP32[i11 >> 2] = 0;
    i11 = i11 + 4 | 0;
   } while ((i11 | 0) < (i12 | 0));
   HEAPF32[i4 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1520 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1552 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1508 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 1408 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1524 >> 2] = Math_fround(0.0);
   i12 = i5 + 1556 | 0;
   HEAPF32[i5 + 1512 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1412 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1528 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1516 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1364 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1360 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 1356 >> 2] = Math_fround(0.0);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i26 >> 2] = i5;
   if (!i20) {
    _memcpy(i10 | 0, i16 + 32 | 0, 1376) | 0;
    __ZN13SpeedTreeWind7AdvanceEbd((HEAP32[i26 >> 2] | 0) + 24 | 0, 1, +Math_fround(HEAPF32[i19 >> 2]));
   } else _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, 1868) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = i1 + 24 | 0;
   f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f7);
   f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f14);
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f6 * f6))));
   i19 = f7 < Math_fround(0.0);
   f28 = Math_fround(-f7);
   if (!((i19 ? f28 : f7) <= Math_fround(9.99999997e-07))) {
    f15 = Math_fround(f8 / f7);
    f28 = Math_fround(f6 / f7);
    HEAPF32[i21 >> 2] = Math_fround(f9 / f7);
    HEAPF32[i21 + 4 >> 2] = f15;
    HEAPF32[i21 + 8 >> 2] = f28;
    HEAPF32[i21 + 12 >> 2] = f7;
    __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i2, i21);
   } else {
    i16 = HEAP32[i1 + 1512 >> 2] | 0;
    i19 = HEAP32[i1 + 1516 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i1 + 1508 >> 2];
    HEAP32[i21 + 4 >> 2] = i16;
    HEAP32[i21 + 8 >> 2] = i19;
    HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
    __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i2, i21);
   }
   i12 = i25 + 20 | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i11 = HEAP32[i25 + 24 >> 2] | 0;
   i1 = i11 - i3 >> 2;
   if (!i1) i2 = i3; else {
    i10 = HEAP32[i26 >> 2] | 0;
    i2 = i3;
    while (1) {
     i19 = (i1 | 0) / 2 | 0;
     i5 = i3 + (i19 << 2) | 0;
     i4 = (HEAP32[i5 >> 2] | 0) >>> 0 < i10 >>> 0;
     i5 = i5 + 4 | 0;
     i2 = i4 ? i5 : i2;
     i1 = i4 ? i1 + -1 - i19 | 0 : i19;
     if (!i1) break; else i3 = i4 ? i5 : i3;
    }
   }
   i3 = i2;
   if ((i2 | 0) == (i11 | 0)) i24 = 46; else {
    i1 = HEAP32[i26 >> 2] | 0;
    if (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i24 = 46;
   }
   if ((i24 | 0) == 46) {
    HEAP32[i22 >> 2] = i3;
    HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
    __ZNSt3__26vectorIP18SpeedTreeLocalWind13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i12, i21, i26) | 0;
    i1 = HEAP32[i26 >> 2] | 0;
   }
   if (i1 | 0) i24 = 48;
  }
 } else i24 = 48;
 do if ((i24 | 0) == 48) {
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
  i16 = HEAP32[i26 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i16 + 1404 >> 2]);
  f6 = Math_fround(HEAPF32[i16 + 1508 >> 2]);
  if (f28 != f6) {
   HEAP8[i16 + 1896 >> 0] = 1;
   if (!i16) break;
  } else {
   f28 = Math_fround(HEAPF32[i16 + 1408 >> 2]);
   f7 = Math_fround(HEAPF32[i16 + 1512 >> 2]);
   if (!(f28 != f7)) {
    f28 = Math_fround(HEAPF32[i16 + 1412 >> 2]);
    f8 = Math_fround(HEAPF32[i16 + 1516 >> 2]);
    if (!(f28 != f8)) {
     f28 = Math_fround(HEAPF32[i16 + 1400 >> 2]);
     f9 = Math_fround(HEAPF32[i16 + 1480 >> 2]);
     if (!(f28 != f9)) {
      f14 = Math_fround(f6 * f9);
      f15 = Math_fround(f7 * f9);
      f9 = Math_fround(f8 * f9);
      f28 = Math_fround(HEAPF32[gb + 62452 >> 2]);
      f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
      f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
      f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
      if (Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))) <= Math_fround(f28 * f28)) {
       i3 = HEAP32[i25 + 20 >> 2] | 0;
       i13 = i25 + 24 | 0;
       i12 = HEAP32[i13 >> 2] | 0;
       i1 = i12 - i3 >> 2;
       i2 = i12;
       if (i1) {
        i4 = i3;
        i5 = i3;
        while (1) {
         i25 = (i1 | 0) / 2 | 0;
         i11 = i5 + (i25 << 2) | 0;
         i10 = (HEAP32[i11 >> 2] | 0) >>> 0 < i16 >>> 0;
         i11 = i11 + 4 | 0;
         i3 = i10 ? i11 : i4;
         i1 = i10 ? i1 + -1 - i25 | 0 : i25;
         if (!i1) break; else {
          i4 = i3;
          i5 = i10 ? i11 : i5;
         }
        }
       }
       if ((i3 | 0) != (i2 | 0)) if ((HEAP32[i3 >> 2] | 0) >>> 0 <= i16 >>> 0) {
        i4 = i3 + 4 | 0;
        i1 = i12 - i4 | 0;
        i5 = i1 >> 2;
        if (i5) {
         _memmove(i3 | 0, i4 | 0, i1 | 0) | 0;
         i2 = HEAP32[i13 >> 2] | 0;
        }
        i1 = i3 + (i5 << 2) | 0;
        if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
       }
       __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1170604 >> 2] | 0, i16);
       HEAP32[i26 >> 2] = 0;
       break;
      }
     }
    }
   }
   HEAP8[i16 + 1896 >> 0] = 1;
  }
  i26 = i16 + 24 | 0;
  STACKTOP = i27;
  return i26 | 0;
 } while (0);
 if (!i20) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i26 = HEAP32[i20 >> 2] | 0;
 STACKTOP = i27;
 return i26 | 0;
}

function __ZN5physx12NpBatchQuery7executeEv(i101) {
 i101 = i101 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i102 = 0, i103 = 0;
 i102 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i99 = i102 + 176 | 0;
 i100 = i102 + 12 | 0;
 i95 = i102 + 196 | 0;
 i96 = i102 + 194 | 0;
 i97 = i102 + 192 | 0;
 i98 = i101 + 40 | 0;
 switch (__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i98, 1, 0) | 0) {
 case 1:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 324, gb + 688119 | 0, i102);
   STACKTOP = i102;
   return;
  }
 case -1:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 329, gb + 688174 | 0, i102 + 8 | 0);
   STACKTOP = i102;
   return;
  }
 default:
  {
   i2 = HEAP32[i101 + 28 >> 2] | 0;
   if (i2 | 0) {
    i1 = HEAP32[i101 + 80 >> 2] | 0;
    i3 = 0;
    do {
     i94 = i1 + (i3 * 80 | 0) + 64 | 0;
     i3 = i3 + 1 | 0;
     HEAP32[i94 >> 2] = 0;
     HEAP32[i94 + 4 >> 2] = 0;
     HEAP32[i94 + 8 >> 2] = 0;
     HEAP16[i94 + 12 >> 1] = 0;
    } while ((i3 | 0) != (i2 | 0));
   }
   i1 = HEAP32[i101 + 32 >> 2] | 0;
   if (i1 | 0) {
    i2 = HEAP32[i101 + 96 >> 2] | 0;
    i3 = 0;
    do {
     i94 = i2 + (i3 << 5) + 16 | 0;
     i3 = i3 + 1 | 0;
     HEAP32[i94 >> 2] = 0;
     HEAP32[i94 + 4 >> 2] = 0;
     HEAP32[i94 + 8 >> 2] = 0;
     HEAP16[i94 + 12 >> 1] = 0;
    } while ((i3 | 0) != (i1 | 0));
   }
   i1 = HEAP32[i101 + 36 >> 2] | 0;
   i4 = i101 + 88 | 0;
   if (i1 | 0) {
    i2 = HEAP32[i4 >> 2] | 0;
    i3 = 0;
    do {
     i94 = i2 + (i3 << 6) + 48 | 0;
     i3 = i3 + 1 | 0;
     HEAP32[i94 >> 2] = 0;
     HEAP32[i94 + 4 >> 2] = 0;
     HEAP32[i94 + 8 >> 2] = 0;
     HEAP16[i94 + 12 >> 1] = 0;
    } while ((i3 | 0) != (i1 | 0));
   }
   i88 = i101 + 8 | 0;
   i89 = HEAP8[i101 + 76 >> 0] | 0;
   i90 = i101 + 84 | 0;
   i1 = HEAP32[i90 >> 2] | 0;
   i2 = HEAP32[i101 + 80 >> 2] | 0;
   i91 = HEAP32[i101 + 104 >> 2] | 0;
   i92 = i101 + 100 | 0;
   i3 = HEAP32[i92 >> 2] | 0;
   i5 = HEAP32[i101 + 96 >> 2] | 0;
   i93 = HEAP32[i101 + 112 >> 2] | 0;
   i94 = i101 + 92 | 0;
   i6 = HEAP32[i94 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
   i49 = HEAP32[i101 + 108 >> 2] | 0;
   i86 = HEAP32[i101 + 48 >> 2] | 0;
   i87 = HEAP32[i101 + 52 >> 2] | 0;
   i50 = HEAP32[i101 + 56 >> 2] | 0;
   HEAP32[i99 >> 2] = HEAP32[i101 + 44 >> 2];
   HEAP32[i99 + 4 >> 2] = i86;
   HEAP32[i99 + 8 >> 2] = i87;
   HEAP32[i99 + 12 >> 2] = i50;
   i50 = i101 + 144 | 0;
   if ((HEAP32[i50 >> 2] | 0) == -16) {
    HEAP32[i50 >> 2] = -16;
    i100 = i101 + 24 | 0;
    HEAP8[i101 + 148 >> 0] = 0;
    HEAP32[i100 >> 2] = 0;
    HEAP32[i100 + 4 >> 2] = 0;
    HEAP32[i100 + 8 >> 2] = 0;
    HEAP32[i100 + 12 >> 2] = 0;
    __ZN5physx6shdfnd14atomicExchangeEPVii(i98, 0) | 0;
    STACKTOP = i102;
    return;
   }
   i51 = i101 + 12 | 0;
   i52 = i100 + 4 | 0;
   i53 = i100 + 8 | 0;
   i54 = i100 + 12 | 0;
   i55 = i100 + 16 | 0;
   i56 = i100 + 20 | 0;
   i57 = i100 + 44 | 0;
   i58 = i100 + 48 | 0;
   i59 = i100 + 52 | 0;
   i60 = i100 + 68 | 0;
   i61 = i100 + 72 | 0;
   i62 = i100 + 76 | 0;
   i63 = i100 + 80 | 0;
   i64 = i100 + 84 | 0;
   i65 = i100 + 92 | 0;
   i66 = i100 + 96 | 0;
   i67 = i100 + 100 | 0;
   i68 = i100 + 104 | 0;
   i69 = i100 + 108 | 0;
   i70 = i100 + 132 | 0;
   i71 = i100 + 136 | 0;
   i72 = i100 + 140 | 0;
   i73 = i100 + 160 | 0;
   i74 = i100 + 4 | 0;
   i75 = i100 + 20 | 0;
   i76 = i100 + 24 | 0;
   i77 = i100 + 28 | 0;
   i78 = i100 + 32 | 0;
   i79 = i100 + 36 | 0;
   i80 = i100 + 40 | 0;
   i81 = i100 + 4 | 0;
   i82 = i100 + 8 | 0;
   i83 = i100 + 12 | 0;
   i84 = i100 + 20 | 0;
   i85 = i100 + 24 | 0;
   i86 = i100 + 28 | 0;
   i87 = i100 + 32 | 0;
   i17 = i100 + 36 | 0;
   i18 = i100 + 44 | 0;
   i19 = i100 + 48 | 0;
   i20 = i100 + 52 | 0;
   i21 = i100 + 64 | 0;
   i22 = i100 + 4 | 0;
   i23 = i100 + 4 | 0;
   i24 = i100 + 8 | 0;
   i25 = i100 + 12 | 0;
   i26 = i100 + 16 | 0;
   i27 = i100 + 20 | 0;
   i28 = i100 + 44 | 0;
   i29 = i100 + 52 | 0;
   i30 = i100 + 56 | 0;
   i31 = i100 + 60 | 0;
   i32 = i100 + 64 | 0;
   i33 = i100 + 68 | 0;
   i34 = i100 + 76 | 0;
   i35 = i100 + 80 | 0;
   i36 = i100 + 84 | 0;
   i37 = i100 + 88 | 0;
   i38 = i100 + 92 | 0;
   i39 = i100 + 116 | 0;
   i40 = i100 + 128 | 0;
   i41 = i100 + 4 | 0;
   i42 = i100 + 20 | 0;
   i43 = i100 + 24 | 0;
   i44 = i100 + 28 | 0;
   i45 = i100 + 32 | 0;
   i46 = i100 + 36 | 0;
   i47 = i100 + 40 | 0;
   i48 = i100 + 48 | 0;
   i15 = 0;
   i16 = 0;
   do {
    i13 = HEAP32[i51 >> 2] | 0;
    i14 = i13 + i15 | 0;
    i11 = i13 + (i15 + 8) | 0;
    i7 = i13 + (i15 + 26) | 0;
    if (!(HEAP8[i7 >> 0] | 0)) HEAP8[i7 >> 0] = i89;
    i12 = i15;
    i15 = HEAP32[i14 >> 2] | 0;
    i10 = i13 + (i12 + 40) | 0;
    if (!(HEAP32[i10 >> 2] | 0)) i8 = 64; else {
     HEAP32[i10 >> 2] = i13 + (i12 + 64);
     i8 = 76;
    }
    i7 = i13 + (i12 + 44) | 0;
    if (HEAP32[i7 >> 2] | 0) {
     HEAP32[i7 >> 2] = i13 + (i8 + i12);
     i8 = i8 + 12 | 0;
    }
    i7 = i13 + (i12 + 56) | 0;
    if (HEAP32[i7 >> 2] | 0) {
     HEAP32[i7 >> 2] = i13 + (i8 + i12);
     i8 = i8 + 28 | 0;
    }
    i9 = i13 + (i12 + 52) | 0;
    if (HEAP32[i9 >> 2] | 0) {
     i7 = i8 + 4 | 0;
     switch (HEAP32[i13 + (i8 + i12) >> 2] | 0) {
     case 2:
      {
       i7 = i13 + (i7 + i12) | 0;
       break;
      }
     case 0:
      {
       i7 = i13 + (i7 + i12) | 0;
       break;
      }
     case 4:
      {
       i7 = i13 + (i7 + i12) | 0;
       break;
      }
     case 3:
      {
       i7 = i13 + (i7 + i12) | 0;
       break;
      }
     default:
      i7 = 0;
     }
     HEAP32[i9 >> 2] = i7;
    }
    switch (HEAP8[i13 + (i12 + 38) >> 0] | 0) {
    case 0:
     {
      i7 = i1;
      i9 = i1 - (HEAP32[i90 >> 2] | 0) >> 6;
      i8 = i91 - i9 | 0;
      i1 = i13 + (i12 + 36) | 0;
      i103 = HEAPU16[i1 >> 1] | 0;
      HEAP32[i52 >> 2] = 0;
      HEAP32[i53 >> 2] = 0;
      HEAP32[i54 >> 2] = -1;
      HEAP16[i55 >> 1] = 0;
      HEAP32[i56 >> 2] = 0;
      HEAP32[i56 + 4 >> 2] = 0;
      HEAP32[i56 + 8 >> 2] = 0;
      HEAP32[i56 + 12 >> 2] = 0;
      HEAP32[i56 + 16 >> 2] = 0;
      HEAP32[i56 + 20 >> 2] = 0;
      HEAPF32[i57 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAPF32[i58 >> 2] = Math_fround(0.0);
      HEAPF32[i59 >> 2] = Math_fround(0.0);
      HEAP8[i60 >> 0] = 0;
      HEAP32[i61 >> 2] = i7;
      HEAP32[i62 >> 2] = i103 >>> 0 < i8 >>> 0 ? i103 : i8;
      HEAP32[i63 >> 2] = 0;
      HEAP32[i100 >> 2] = gb + 92992 + 8;
      HEAP8[i64 >> 0] = 0;
      HEAP32[i65 >> 2] = 0;
      HEAP32[i66 >> 2] = 0;
      HEAP32[i67 >> 2] = -1;
      HEAP16[i68 >> 1] = 0;
      HEAP32[i69 >> 2] = 0;
      HEAP32[i69 + 4 >> 2] = 0;
      HEAP32[i69 + 8 >> 2] = 0;
      HEAP32[i69 + 12 >> 2] = 0;
      HEAP32[i69 + 16 >> 2] = 0;
      HEAP32[i69 + 20 >> 2] = 0;
      HEAPF32[i70 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAPF32[i71 >> 2] = Math_fround(0.0);
      HEAPF32[i72 >> 2] = Math_fround(0.0);
      HEAP8[i73 >> 0] = 0;
      i8 = HEAP32[i88 >> 2] | 0;
      HEAP16[i95 >> 1] = HEAP16[i13 + (i12 + 4) >> 1] | 0;
      __ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i8, i10, i100, i95, HEAP32[i13 + (i12 + 32) >> 2] | 0, i11, 0, i99) | 0;
      if ((i91 | 0) == (i9 | 0)) i1 = (HEAP16[i1 >> 1] | 0) != 0; else i1 = 0;
      i11 = (HEAPU8[i64 >> 0] | i1 & 1) & 255;
      HEAP8[i64 >> 0] = i11;
      i103 = i2;
      i11 = i11 << 24 >> 24 != 0;
      HEAP32[i103 + 72 >> 2] = HEAP32[i13 + (i12 + 28) >> 2];
      i1 = i2;
      HEAP32[i1 >> 2] = HEAP32[i74 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i74 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i74 + 8 >> 2];
      HEAP16[i103 + 12 >> 1] = HEAP16[i55 >> 1] | 0;
      HEAP32[i103 + 16 >> 2] = HEAP32[i75 >> 2];
      HEAP32[i103 + 20 >> 2] = HEAP32[i76 >> 2];
      HEAP32[i103 + 24 >> 2] = HEAP32[i77 >> 2];
      HEAP32[i103 + 28 >> 2] = HEAP32[i78 >> 2];
      HEAP32[i103 + 32 >> 2] = HEAP32[i79 >> 2];
      HEAP32[i103 + 36 >> 2] = HEAP32[i80 >> 2];
      HEAP32[i103 + 40 >> 2] = HEAP32[i57 >> 2];
      i1 = i103 + 44 | 0;
      HEAP32[i1 >> 2] = HEAP32[i58 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i58 + 16 >> 2];
      HEAP8[i103 + 77 >> 0] = HEAP8[i60 >> 0] | 0;
      i1 = HEAP32[i63 >> 2] | 0;
      HEAP32[i103 + 68 >> 2] = i1;
      HEAP8[i103 + 76 >> 0] = i11 ? 2 : 1;
      HEAP32[i103 + 64 >> 2] = i11 & (i1 | 0) == 0 ? 0 : HEAP32[i61 >> 2] | 0;
      i1 = i7 + (i1 << 6) | 0;
      i2 = i103 + 80 | 0;
      break;
     }
    case 1:
     {
      i7 = i3;
      i103 = i3 - (HEAP32[i92 >> 2] | 0) >> 4;
      i9 = i93 - i103 | 0;
      i3 = i13 + (i12 + 36) | 0;
      i8 = HEAPU16[i3 >> 1] | 0;
      HEAP32[i81 >> 2] = 0;
      HEAP32[i82 >> 2] = 0;
      HEAP32[i83 >> 2] = -1;
      HEAP8[i84 >> 0] = 0;
      HEAP32[i85 >> 2] = i7;
      HEAP32[i86 >> 2] = i8 >>> 0 < i9 >>> 0 ? i8 : i9;
      HEAP32[i87 >> 2] = 0;
      HEAP32[i100 >> 2] = gb + 93016 + 8;
      HEAP8[i17 >> 0] = 0;
      HEAP32[i18 >> 2] = 0;
      HEAP32[i19 >> 2] = 0;
      HEAP32[i20 >> 2] = -1;
      HEAP8[i21 >> 0] = 0;
      i9 = HEAP32[i88 >> 2] | 0;
      HEAP16[i96 >> 1] = HEAP16[i13 + (i12 + 4) >> 1] | 0;
      __ZNK5physx14NpSceneQueries10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i9, i10, i100, i96, HEAP32[i13 + (i12 + 32) >> 2] | 0, i11, 0, i99) | 0;
      if ((i93 | 0) == (i103 | 0)) i3 = (HEAP16[i3 >> 1] | 0) != 0; else i3 = 0;
      i11 = (HEAPU8[i17 >> 0] | i3 & 1) & 255;
      HEAP8[i17 >> 0] = i11;
      i103 = i5;
      i11 = i11 << 24 >> 24 != 0;
      HEAP32[i103 + 24 >> 2] = HEAP32[i13 + (i12 + 28) >> 2];
      i3 = i5;
      HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
      HEAP8[i103 + 29 >> 0] = HEAP8[i84 >> 0] | 0;
      i3 = HEAP32[i87 >> 2] | 0;
      HEAP32[i103 + 20 >> 2] = i3;
      HEAP8[i103 + 28 >> 0] = i11 ? 2 : 1;
      HEAP32[i103 + 16 >> 2] = i11 & (i3 | 0) == 0 ? 0 : HEAP32[i85 >> 2] | 0;
      i3 = i7 + (i3 << 4) | 0;
      i5 = i103 + 32 | 0;
      break;
     }
    case 2:
     {
      i7 = i6;
      i103 = (i6 - (HEAP32[i94 >> 2] | 0) | 0) / 48 | 0;
      i9 = i49 - i103 | 0;
      i6 = i13 + (i12 + 36) | 0;
      i8 = HEAPU16[i6 >> 1] | 0;
      HEAP32[i23 >> 2] = 0;
      HEAP32[i24 >> 2] = 0;
      HEAP32[i25 >> 2] = -1;
      HEAP16[i26 >> 1] = 0;
      HEAP32[i27 >> 2] = 0;
      HEAP32[i27 + 4 >> 2] = 0;
      HEAP32[i27 + 8 >> 2] = 0;
      HEAP32[i27 + 12 >> 2] = 0;
      HEAP32[i27 + 16 >> 2] = 0;
      HEAP32[i27 + 20 >> 2] = 0;
      HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAP8[i29 >> 0] = 0;
      HEAP32[i30 >> 2] = i7;
      HEAP32[i31 >> 2] = i8 >>> 0 < i9 >>> 0 ? i8 : i9;
      HEAP32[i32 >> 2] = 0;
      HEAP32[i100 >> 2] = gb + 93040 + 8;
      HEAP8[i33 >> 0] = 0;
      HEAP32[i34 >> 2] = 0;
      HEAP32[i35 >> 2] = 0;
      HEAP32[i36 >> 2] = -1;
      HEAP16[i37 >> 1] = 0;
      HEAP32[i38 >> 2] = 0;
      HEAP32[i38 + 4 >> 2] = 0;
      HEAP32[i38 + 8 >> 2] = 0;
      HEAP32[i38 + 12 >> 2] = 0;
      HEAP32[i38 + 16 >> 2] = 0;
      HEAP32[i38 + 20 >> 2] = 0;
      HEAPF32[i39 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAP8[i40 >> 0] = 0;
      i9 = HEAP32[i88 >> 2] | 0;
      HEAP16[i97 >> 1] = HEAP16[i13 + (i12 + 4) >> 1] | 0;
      __ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i9, i10, i100, i97, HEAP32[i13 + (i12 + 32) >> 2] | 0, i11, 0, i99) | 0;
      if ((i49 | 0) == (i103 | 0)) i6 = (HEAP16[i6 >> 1] | 0) != 0; else i6 = 0;
      i11 = (HEAPU8[i33 >> 0] | i6 & 1) & 255;
      HEAP8[i33 >> 0] = i11;
      i103 = i4;
      i11 = i11 << 24 >> 24 != 0;
      HEAP32[i103 + 56 >> 2] = HEAP32[i13 + (i12 + 28) >> 2];
      i6 = i4;
      HEAP32[i6 >> 2] = HEAP32[i41 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
      HEAP16[i103 + 12 >> 1] = HEAP16[i26 >> 1] | 0;
      HEAP32[i103 + 16 >> 2] = HEAP32[i42 >> 2];
      HEAP32[i103 + 20 >> 2] = HEAP32[i43 >> 2];
      HEAP32[i103 + 24 >> 2] = HEAP32[i44 >> 2];
      HEAP32[i103 + 28 >> 2] = HEAP32[i45 >> 2];
      HEAP32[i103 + 32 >> 2] = HEAP32[i46 >> 2];
      HEAP32[i103 + 36 >> 2] = HEAP32[i47 >> 2];
      HEAP32[i103 + 40 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i103 + 44 >> 2] = HEAP32[i48 >> 2];
      HEAP8[i103 + 61 >> 0] = HEAP8[i29 >> 0] | 0;
      i6 = HEAP32[i32 >> 2] | 0;
      HEAP32[i103 + 52 >> 2] = i6;
      HEAP8[i103 + 60 >> 0] = i11 ? 2 : 1;
      HEAP32[i103 + 48 >> 2] = i11 & (i6 | 0) == 0 ? 0 : HEAP32[i30 >> 2] | 0;
      i6 = i7 + (i6 * 48 | 0) | 0;
      i4 = i103 + 64 | 0;
      break;
     }
    default:
     {}
    }
    if ((HEAP32[i14 >> 2] | 0) == -16) break;
    i16 = i16 + 1 | 0;
   } while (i16 >>> 0 < 1e6);
   HEAP32[i50 >> 2] = -16;
   i103 = i101 + 24 | 0;
   HEAP8[i101 + 148 >> 0] = 0;
   HEAP32[i103 >> 2] = 0;
   HEAP32[i103 + 4 >> 2] = 0;
   HEAP32[i103 + 8 >> 2] = 0;
   HEAP32[i103 + 12 >> 2] = 0;
   __ZN5physx6shdfnd14atomicExchangeEPVii(i98, 0) | 0;
   STACKTOP = i102;
   return;
  }
 }
}

function __Z10b2DistanceP16b2DistanceOutputP14b2SimplexCachePK15b2DistanceInput(i39, i44, i46) {
 i39 = i39 | 0;
 i44 = i44 | 0;
 i46 = i46 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i45 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i47 + 152 | 0;
 i33 = i47 + 136 | 0;
 i45 = i47;
 i34 = i47 + 124 | 0;
 i35 = i47 + 112 | 0;
 HEAP32[gb + 1457464 >> 2] = (HEAP32[gb + 1457464 >> 2] | 0) + 1;
 i36 = i46 + 56 | 0;
 HEAP32[i32 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 i36 = i46 + 72 | 0;
 HEAP32[i33 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i33 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 __ZN9b2Simplex9ReadCacheEPK14b2SimplexCachePK15b2DistanceProxyRK11b2TransformS5_S8_(i45, i44, i46, i32, i46 + 28 | 0, i33);
 i36 = i45 + 108 | 0;
 i21 = i32 + 12 | 0;
 i22 = i32 + 8 | 0;
 i23 = i46 + 16 | 0;
 i24 = i46 + 20 | 0;
 i25 = i32 + 4 | 0;
 i26 = i33 + 12 | 0;
 i27 = i33 + 8 | 0;
 i28 = i46 + 44 | 0;
 i29 = i46 + 48 | 0;
 i30 = i33 + 4 | 0;
 i40 = i45 + 16 | 0;
 i41 = i45 + 20 | 0;
 i42 = i45 + 52 | 0;
 i43 = i45 + 56 | 0;
 i31 = i45 + 36 | 0;
 i37 = i45 + 24 | 0;
 i38 = i45 + 60 | 0;
 i3 = 0;
 i20 = HEAP32[i36 >> 2] | 0;
 L1 : while (1) {
  i19 = (i20 | 0) > 0;
  if (i19) {
   i11 = 0;
   do {
    HEAP32[i34 + (i11 << 2) >> 2] = HEAP32[i45 + (i11 * 36 | 0) + 28 >> 2];
    HEAP32[i35 + (i11 << 2) >> 2] = HEAP32[i45 + (i11 * 36 | 0) + 32 >> 2];
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i20 | 0));
  }
  L7 : do switch (i20 | 0) {
  case 3:
   {
    __ZN9b2Simplex6Solve3Ev(i45);
    i11 = HEAP32[i36 >> 2] | 0;
    if ((i11 | 0) == 3) {
     i18 = 11;
     break L1;
    } else i18 = 12;
    break;
   }
  case 2:
   {
    f17 = Math_fround(HEAPF32[i40 >> 2]);
    f6 = Math_fround(HEAPF32[i41 >> 2]);
    f1 = Math_fround(HEAPF32[i42 >> 2]);
    f2 = Math_fround(HEAPF32[i43 >> 2]);
    f4 = Math_fround(f1 - f17);
    f5 = Math_fround(f2 - f6);
    f6 = Math_fround(Math_fround(f17 * f4) + Math_fround(f6 * f5));
    if (f6 >= Math_fround(-0.0)) {
     HEAPF32[i37 >> 2] = Math_fround(1.0);
     HEAP32[i36 >> 2] = 1;
     i18 = 13;
     break L7;
    }
    f1 = Math_fround(Math_fround(f1 * f4) + Math_fround(f2 * f5));
    if (!(f1 <= Math_fround(0.0))) {
     f17 = Math_fround(Math_fround(1.0) / Math_fround(f1 - f6));
     HEAPF32[i37 >> 2] = Math_fround(f1 * f17);
     HEAPF32[i38 >> 2] = Math_fround(-Math_fround(f6 * f17));
     HEAP32[i36 >> 2] = 2;
     i18 = 14;
     break L7;
    } else {
     HEAPF32[i38 >> 2] = Math_fround(1.0);
     HEAP32[i36 >> 2] = 1;
     i11 = i45;
     i12 = i31;
     i13 = i11 + 36 | 0;
     do {
      HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
      i11 = i11 + 4 | 0;
      i12 = i12 + 4 | 0;
     } while ((i11 | 0) < (i13 | 0));
     i18 = 13;
     break L7;
    }
   }
  default:
   {
    i11 = i20;
    i18 = 12;
   }
  } while (0);
  L16 : do if ((i18 | 0) == 12) {
   i18 = 0;
   switch (i11 | 0) {
   case 1:
    {
     i18 = 13;
     break L16;
    }
   case 2:
    {
     i18 = 14;
     break L16;
    }
   default:
    {}
   }
   i12 = HEAP32[gb + 1457504 >> 2] | 0;
   i13 = HEAP32[gb + 1457504 + 4 >> 2] | 0;
  } while (0);
  do if ((i18 | 0) == 13) {
   f10 = Math_fround(-Math_fround(HEAPF32[i40 >> 2]));
   f17 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
   i12 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = 1;
  } else if ((i18 | 0) == 14) {
   f2 = Math_fround(HEAPF32[i42 >> 2]);
   f10 = Math_fround(HEAPF32[i40 >> 2]);
   f2 = Math_fround(f2 - f10);
   f1 = Math_fround(HEAPF32[i43 >> 2]);
   f17 = Math_fround(HEAPF32[i41 >> 2]);
   f1 = Math_fround(f1 - f17);
   if (Math_fround(Math_fround(f10 * f1) - Math_fround(f2 * f17)) > Math_fround(0.0)) {
    f17 = Math_fround(-f1);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = 2;
    break;
   } else {
    f17 = Math_fround(-f2);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = 2;
    break;
   }
  } while (0);
  f17 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = Math_fround(f17 * f17);
  f10 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(f9 + Math_fround(f10 * f10)) < Math_fround(1.42108547e-14)) {
   i18 = 31;
   break;
  }
  f4 = Math_fround(-f17);
  f9 = Math_fround(-f10);
  f6 = Math_fround(HEAPF32[i21 >> 2]);
  f2 = Math_fround(f6 * f4);
  f7 = Math_fround(HEAPF32[i22 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f7 * f9));
  f4 = Math_fround(Math_fround(f6 * f9) - Math_fround(f7 * f4));
  i16 = HEAP32[i23 >> 2] | 0;
  i14 = HEAP32[i24 >> 2] | 0;
  if ((i14 | 0) > 1) {
   f1 = Math_fround(f2 * Math_fround(HEAPF32[i16 >> 2]));
   i13 = 1;
   f1 = Math_fround(f1 + Math_fround(f4 * Math_fround(HEAPF32[i16 + 4 >> 2])));
   i12 = 0;
   while (1) {
    f5 = Math_fround(f2 * Math_fround(HEAPF32[i16 + (i13 << 3) >> 2]));
    f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i16 + (i13 << 3) + 4 >> 2])));
    i15 = f5 > f1;
    i12 = i15 ? i13 : i12;
    i13 = i13 + 1 | 0;
    if ((i13 | 0) == (i14 | 0)) {
     i18 = i12;
     break;
    } else f1 = i15 ? f5 : f1;
   }
  } else i18 = 0;
  HEAP32[i45 + (i11 * 36 | 0) + 28 >> 2] = i18;
  f8 = Math_fround(HEAPF32[i16 + (i18 << 3) >> 2]);
  f9 = Math_fround(f6 * f8);
  f5 = Math_fround(HEAPF32[i16 + (i18 << 3) + 4 >> 2]);
  f9 = Math_fround(f9 - Math_fround(f7 * f5));
  f9 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + f9);
  f6 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f5));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i45 + (i11 * 36 | 0) >> 2] = f9;
  HEAPF32[i45 + (i11 * 36 | 0) + 4 >> 2] = f6;
  f7 = Math_fround(HEAPF32[i26 >> 2]);
  f5 = Math_fround(f17 * f7);
  f8 = Math_fround(HEAPF32[i27 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f10 * f8));
  f2 = Math_fround(Math_fround(f10 * f7) - Math_fround(f17 * f8));
  i16 = HEAP32[i28 >> 2] | 0;
  i14 = HEAP32[i29 >> 2] | 0;
  if ((i14 | 0) > 1) {
   f1 = Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2]));
   i13 = 1;
   f1 = Math_fround(f1 + Math_fround(f2 * Math_fround(HEAPF32[i16 + 4 >> 2])));
   i12 = 0;
   while (1) {
    f4 = Math_fround(f5 * Math_fround(HEAPF32[i16 + (i13 << 3) >> 2]));
    f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i16 + (i13 << 3) + 4 >> 2])));
    i15 = f4 > f1;
    i12 = i15 ? i13 : i12;
    i13 = i13 + 1 | 0;
    if ((i13 | 0) == (i14 | 0)) break; else f1 = i15 ? f4 : f1;
   }
  } else i12 = 0;
  HEAP32[i45 + (i11 * 36 | 0) + 32 >> 2] = i12;
  f5 = Math_fround(HEAPF32[i16 + (i12 << 3) >> 2]);
  f10 = Math_fround(f7 * f5);
  f17 = Math_fround(HEAPF32[i16 + (i12 << 3) + 4 >> 2]);
  f10 = Math_fround(f10 - Math_fround(f8 * f17));
  f10 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) + f10);
  f17 = Math_fround(Math_fround(f5 * f8) + Math_fround(f7 * f17));
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i30 >> 2]));
  HEAPF32[i45 + (i11 * 36 | 0) + 8 >> 2] = f10;
  HEAPF32[i45 + (i11 * 36 | 0) + 12 >> 2] = f17;
  f17 = Math_fround(f17 - f6);
  HEAPF32[i45 + (i11 * 36 | 0) + 16 >> 2] = Math_fround(f10 - f9);
  HEAPF32[i45 + (i11 * 36 | 0) + 20 >> 2] = f17;
  i3 = i3 + 1 | 0;
  HEAP32[gb + 1457468 >> 2] = (HEAP32[gb + 1457468 >> 2] | 0) + 1;
  if (i19) {
   i11 = 0;
   do {
    if ((i18 | 0) == (HEAP32[i34 + (i11 << 2) >> 2] | 0)) if ((i12 | 0) == (HEAP32[i35 + (i11 << 2) >> 2] | 0)) {
     i18 = 30;
     break L1;
    }
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) < (i20 | 0));
  }
  i11 = (HEAP32[i36 >> 2] | 0) + 1 | 0;
  HEAP32[i36 >> 2] = i11;
  if ((i3 | 0) < 20) i20 = i11; else {
   i18 = 31;
   break;
  }
 }
 if ((i18 | 0) == 11) {
  i12 = HEAP32[gb + 1457472 >> 2] | 0;
  HEAP32[gb + 1457472 >> 2] = (i12 | 0) > (i3 | 0) ? i12 : i3;
  i12 = i39 + 8 | 0;
  i18 = 35;
 } else if ((i18 | 0) == 30) {
  i11 = HEAP32[i36 >> 2] | 0;
  i18 = 31;
 }
 L47 : do if ((i18 | 0) == 31) {
  i12 = HEAP32[gb + 1457472 >> 2] | 0;
  HEAP32[gb + 1457472 >> 2] = (i12 | 0) > (i3 | 0) ? i12 : i3;
  i12 = i39 + 8 | 0;
  switch (i11 | 0) {
  case 3:
   {
    i18 = 35;
    break L47;
   }
  case 1:
   {
    i38 = i45;
    i16 = HEAP32[i38 >> 2] | 0;
    i38 = HEAP32[i38 + 4 >> 2] | 0;
    i11 = i39;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i11 + 4 >> 2] = i38;
    i11 = i45 + 8 | 0;
    i15 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i37 = i12;
    HEAP32[i37 >> 2] = i15;
    HEAP32[i37 + 4 >> 2] = i11;
    f1 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f2 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i15 = i39 + 4 | 0;
    i16 = i39;
    f4 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i11 = 1;
    break L47;
   }
  case 2:
   {
    f17 = Math_fround(HEAPF32[i37 >> 2]);
    f1 = Math_fround(f17 * Math_fround(HEAPF32[i45 >> 2]));
    f4 = Math_fround(f17 * Math_fround(HEAPF32[i45 + 4 >> 2]));
    f5 = Math_fround(HEAPF32[i38 >> 2]);
    f1 = Math_fround(f1 + Math_fround(f5 * Math_fround(HEAPF32[i45 + 36 >> 2])));
    f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i45 + 40 >> 2])));
    HEAPF32[i39 >> 2] = f1;
    i15 = i39 + 4 | 0;
    HEAPF32[i15 >> 2] = f4;
    f2 = Math_fround(f17 * Math_fround(HEAPF32[i45 + 8 >> 2]));
    f17 = Math_fround(f17 * Math_fround(HEAPF32[i45 + 12 >> 2]));
    f2 = Math_fround(f2 + Math_fround(f5 * Math_fround(HEAPF32[i45 + 44 >> 2])));
    f5 = Math_fround(f17 + Math_fround(f5 * Math_fround(HEAPF32[i45 + 48 >> 2])));
    HEAPF32[i12 >> 2] = f2;
    HEAPF32[i39 + 12 >> 2] = f5;
    i16 = i39;
    i11 = 2;
    break L47;
   }
  default:
   {
    f1 = Math_fround(HEAPF32[i39 >> 2]);
    f2 = Math_fround(HEAPF32[i12 >> 2]);
    i38 = i39 + 4 | 0;
    i15 = i38;
    i16 = i39;
    f4 = Math_fround(HEAPF32[i38 >> 2]);
    f5 = Math_fround(HEAPF32[i39 + 12 >> 2]);
    break L47;
   }
  }
 } while (0);
 if ((i18 | 0) == 35) {
  f4 = Math_fround(HEAPF32[i37 >> 2]);
  f2 = Math_fround(f4 * Math_fround(HEAPF32[i45 >> 2]));
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i45 + 4 >> 2]));
  f5 = Math_fround(HEAPF32[i38 >> 2]);
  f1 = Math_fround(f5 * Math_fround(HEAPF32[i45 + 36 >> 2]));
  f1 = Math_fround(f2 + f1);
  f5 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i45 + 40 >> 2])));
  f4 = Math_fround(HEAPF32[i45 + 96 >> 2]);
  f2 = Math_fround(f4 * Math_fround(HEAPF32[i45 + 72 >> 2]));
  f4 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i45 + 76 >> 2])));
  HEAPF32[i39 >> 2] = Math_fround(f1 + f2);
  i15 = i39 + 4 | 0;
  HEAPF32[i15 >> 2] = f4;
  i11 = i39;
  i16 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i38 = i12;
  HEAP32[i38 >> 2] = i16;
  HEAP32[i38 + 4 >> 2] = i11;
  f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i16 = i39;
  f1 = f2;
  f5 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i11 = 3;
 }
 f10 = Math_fround(f1 - f2);
 i14 = i39 + 12 | 0;
 f17 = Math_fround(f4 - f5);
 i13 = i39 + 16 | 0;
 HEAPF32[i13 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f17 * f17))));
 HEAP32[i39 + 20 >> 2] = i3;
 switch (i11 | 0) {
 case 3:
  {
   f9 = Math_fround(HEAPF32[i42 >> 2]);
   f1 = Math_fround(HEAPF32[i40 >> 2]);
   f9 = Math_fround(f9 - f1);
   f17 = Math_fround(HEAPF32[i43 >> 2]);
   f10 = Math_fround(HEAPF32[i41 >> 2]);
   f17 = Math_fround(f17 - f10);
   f1 = Math_fround(Math_fround(HEAPF32[i45 + 88 >> 2]) - f1);
   f1 = Math_fround(Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i45 + 92 >> 2]) - f10)) - Math_fround(f17 * f1));
   i18 = 39;
   break;
  }
 case 2:
  {
   f17 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - Math_fround(HEAPF32[i42 >> 2]));
   f1 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) - Math_fround(HEAPF32[i43 >> 2]));
   f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f1 * f1))));
   i18 = 39;
   break;
  }
 default:
  {
   HEAPF32[i44 >> 2] = Math_fround(0.0);
   HEAP16[i44 + 4 >> 1] = i11;
   if ((i11 | 0) > 0) {
    i3 = 0;
    i18 = 41;
   }
  }
 }
 if ((i18 | 0) == 39) {
  HEAPF32[i44 >> 2] = f1;
  HEAP16[i44 + 4 >> 1] = i11;
  i3 = 0;
  i18 = 41;
 }
 if ((i18 | 0) == 41) while (1) {
  HEAP8[i44 + 6 + i3 >> 0] = HEAP32[i45 + (i3 * 36 | 0) + 28 >> 2];
  HEAP8[i44 + 9 + i3 >> 0] = HEAP32[i45 + (i3 * 36 | 0) + 32 >> 2];
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (i11 | 0)) break; else i18 = 41;
 }
 if (!(HEAP8[i46 + 88 >> 0] | 0)) {
  STACKTOP = i47;
  return;
 }
 f10 = Math_fround(HEAPF32[i46 + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i46 + 52 >> 2]);
 f1 = Math_fround(HEAPF32[i13 >> 2]);
 f2 = Math_fround(f10 + f9);
 if (!(f1 > f2 & f1 > Math_fround(1.1920929e-07))) {
  f10 = Math_fround(HEAPF32[i16 >> 2]);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i12 >> 2]));
  f17 = Math_fround(HEAPF32[i15 >> 2]);
  f10 = Math_fround(f10 * Math_fround(.5));
  f17 = Math_fround(Math_fround(f17 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
  HEAPF32[i16 >> 2] = f10;
  HEAPF32[i15 >> 2] = f17;
  HEAPF32[i12 >> 2] = f10;
  HEAPF32[i14 >> 2] = f17;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  STACKTOP = i47;
  return;
 }
 HEAPF32[i13 >> 2] = Math_fround(f1 - f2);
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(HEAPF32[i16 >> 2]);
 f2 = Math_fround(f5 - f6);
 f7 = Math_fround(HEAPF32[i14 >> 2]);
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f1 = Math_fround(f7 - f8);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1))));
 if (!(f4 < Math_fround(1.1920929e-07))) {
  f17 = Math_fround(Math_fround(1.0) / f4);
  f2 = Math_fround(f2 * f17);
  f1 = Math_fround(f1 * f17);
 }
 f17 = Math_fround(f10 * f1);
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(f10 * f2) + f6);
 HEAPF32[i15 >> 2] = Math_fround(f17 + f8);
 f17 = Math_fround(f9 * f1);
 HEAPF32[i12 >> 2] = Math_fround(f5 - Math_fround(f9 * f2));
 HEAPF32[i14 >> 2] = Math_fround(f7 - f17);
 STACKTOP = i47;
 return;
}

function __Z16DrawSplashScreenb(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f5 = f0, d6 = 0.0, d7 = 0.0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 280 | 0;
 i25 = i27;
 i12 = i27 + 264 | 0;
 i18 = i27 + 248 | 0;
 i20 = i27 + 232 | 0;
 i8 = i27 + 216 | 0;
 i26 = i27 + 16 | 0;
 if (__Z12GetIVRDevicev() | 0) {
  i23 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 160 >> 2] | 0, i23 | 0) | 0) {
   STACKTOP = i27;
   return;
  }
 }
 i1 = HEAP32[gb + 1157848 >> 2] | 0;
 if (!i1) {
  __Z17BeginSplashScreenv();
  i1 = HEAP32[gb + 1157848 >> 2] | 0;
 }
 do if ((i1 | 0) != 3) {
  d7 = +__Z19GetTimeSinceStartupv();
  d7 = +Math_fround(d7 - +HEAPF64[gb + 1098064 >> 3]);
  if (d7 >= +HEAPF64[gb + 1098080 >> 3]) {
   if ((HEAP32[gb + 1157848 >> 2] | 0) == 1) {
    i23 = (HEAP32[gb + 1157872 >> 2] | 0) + 1 | 0;
    HEAP32[gb + 1157872 >> 2] = i23;
    if (!(__ZL17CreateLogoPresetsj(i23) | 0)) {
     HEAP32[gb + 1157848 >> 2] = 2;
     HEAPF64[gb + 1098080 >> 3] = .5;
     d7 = +__Z19GetTimeSinceStartupv();
     HEAPF64[gb + 1098064 >> 3] = d7;
     break;
    }
   } else HEAP32[gb + 1157848 >> 2] = 3;
   d7 = +__Z19GetTimeSinceStartupv();
   HEAPF64[gb + 1098064 >> 3] = d7;
  }
 } while (0);
 i22 = __Z12GetGfxDevicev() | 0;
 i23 = (HEAP8[i22 + 4192 >> 0] | 0) != 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 516 >> 2] | 0, i22 | 0) | 0)) {
  mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 520 >> 2] | 0, i22 | 0) | 0;
  STACKTOP = i27;
  return;
 }
 if (!i23) mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 496 >> 2] | 0, i22 | 0);
 if (i4) {
  i4 = (__Z17GetPlayerSettingsv() | 0) + 244 | 0;
  HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(7, i24, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
 }
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i26, __Z12GetGfxDevicev() | 0);
 __Z28SetupPixelCorrectCoordinatesv();
 f2 = Math_fround(Math_fround(HEAPF32[gb + 1157852 >> 2]) * Math_fround(.0500000007));
 d7 = +__Z19GetTimeSinceStartupv();
 f5 = Math_fround(d7 - +HEAPF64[gb + 1098072 >> 3]);
 f3 = Math_fround(HEAPF32[gb + 1157868 >> 2]);
 f5 = Math_fround(f3 - f5);
 do if ((HEAP32[gb + 1157848 >> 2] | 0) != 3) {
  __Z30GetSplashScreenBackgroundColorv(i24);
  if ((HEAP32[gb + 1157848 >> 2] | 0) == 2) {
   d7 = +__Z19GetTimeSinceStartupv();
   f21 = Math_fround(d7 - +HEAPF64[gb + 1098064 >> 3]);
   i4 = f21 > Math_fround(.5);
   f21 = Math_fround((i4 ? Math_fround(.5) : f21) * Math_fround(2.0));
   i4 = f21 < Math_fround(0.0);
   i1 = f21 > Math_fround(1.0);
   f21 = i1 ? Math_fround(1.0) : f21;
   f21 = i4 ? Math_fround(0.0) : f21;
   f21 = Math_fround(Math_fround(f21 * Math_fround(f21 * Math_fround(3.0))) + Math_fround(f21 * Math_fround(f21 * Math_fround(f21 * Math_fround(-2.0)))));
   HEAPF32[i24 + 12 >> 2] = Math_fround(Math_fround(f21 * Math_fround(0.0)) + Math_fround(Math_fround(1.0) - f21));
  }
  i1 = __Z16GetScreenManagerv() | 0;
  f19 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0);
  f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0);
  HEAPF32[i25 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 8 >> 2] = f19;
  HEAPF32[i25 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 12 >> 2] = f21;
  i1 = __Z25GetSplashScreenBackgroundRK5RectTIfE(i25) | 0;
  if (!i1) {
   i4 = __Z16GetScreenManagerv() | 0;
   f19 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 80 >> 2] | 0, i4 | 0) | 0);
   f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0) | 0);
   HEAPF32[i12 >> 2] = Math_fround(0.0);
   HEAPF32[i12 + 8 >> 2] = f19;
   HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i12 + 12 >> 2] = f21;
   i4 = __ZN10builtintex15GetWhiteTextureEv() | 0;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + 12 >> 2] = Math_fround(1.0);
   __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i12, i4, i24, i18);
  } else {
   __Z28GetSplashScreenBackgroundUvsRK5RectTIfE(i12, i25);
   f21 = Math_fround(Math_fround(Math_fround(f2 * f5) + Math_fround(1.0)) / Math_fround(Math_fround(f2 * f3) + Math_fround(1.0)));
   i28 = i12 + 8 | 0;
   f15 = Math_fround(HEAPF32[i28 >> 2]);
   f19 = Math_fround(f21 * f15);
   i4 = i12 + 12 | 0;
   f16 = Math_fround(HEAPF32[i4 >> 2]);
   f21 = Math_fround(f21 * f16);
   f15 = Math_fround(Math_fround(f15 - f19) * Math_fround(.5));
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f15);
   f16 = Math_fround(Math_fround(f16 - f21) * Math_fround(.5));
   i29 = i12 + 4 | 0;
   HEAPF32[i29 >> 2] = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + f16);
   HEAPF32[i28 >> 2] = f19;
   HEAPF32[i4 >> 2] = f21;
   __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i25, i1, i24, i12);
  }
  if ((HEAP32[gb + 1157848 >> 2] | 0) == 1) {
   i4 = __Z17GetPlayerSettingsv() | 0;
   i29 = __Z16GetScreenManagerv() | 0;
   f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 80 >> 2] | 0, i29 | 0) | 0);
   f14 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 84 >> 2] | 0, i29 | 0) | 0);
   f16 = f14 < f21 ? f14 : f21;
   f19 = Math_fround(Math_fround(Math_fround(f21 - f16) * Math_fround(.25)) + Math_fround(0.0));
   f15 = Math_fround(Math_fround(Math_fround(f14 - f16) * Math_fround(.25)) + Math_fround(0.0));
   f21 = Math_fround(Math_fround(f21 + f16) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f14 + f16) * Math_fround(.5));
   if (!(HEAP8[gb + 1545905 >> 0] | 0)) {
    i1 = HEAP32[gb + 1157880 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[gb + 1157884 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1157884 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1157884 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[gb + 1157884 + 12 >> 2];
    f13 = Math_fround(HEAPF32[gb + 1157876 >> 2]);
    f2 = Math_fround(+__Z19GetTimeSinceStartupv());
    d6 = +HEAPF64[gb + 1098064 >> 3];
    d7 = +HEAPF64[gb + 1098080 >> 3];
    HEAP32[i25 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i25 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i25 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i25 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    if (i1 | 0) {
     f11 = Math_fround(d6 + d7);
     f14 = Math_fround(d6);
     f3 = Math_fround(HEAPF32[gb + 1157856 >> 2]);
     f14 = Math_fround(f2 - f14);
     f2 = Math_fround(f11 - f2);
     f14 = Math_fround((f2 < f14 ? f2 : f14) / Math_fround(.800000011));
     i29 = f14 < Math_fround(0.0);
     i28 = f14 > Math_fround(1.0);
     f14 = i28 ? Math_fround(1.0) : f14;
     f14 = i29 ? Math_fround(0.0) : f14;
     HEAPF32[i25 + 12 >> 2] = f14;
     if (f14 > Math_fround(0.0)) {
      f11 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f2 * Math_fround(f3 * Math_fround(.0500000007))) + Math_fround(1.0))) * Math_fround(.800000011));
      f10 = Math_fround(f21 * f11);
      f11 = Math_fround(f16 * f11);
      f9 = Math_fround(f19 + Math_fround(Math_fround(f21 - f10) * Math_fround(.5)));
      f5 = Math_fround(f15 + Math_fround(Math_fround(f16 - f11) * Math_fround(.5)));
      f2 = Math_fround(f13 * f11);
      if (f2 < f10) {
       f3 = Math_fround(0.0);
       f2 = Math_fround(Math_abs(Math_fround(f2 - f10)));
      } else {
       f3 = Math_fround(Math_abs(Math_fround(Math_fround(f10 / f13) - f11)));
       f2 = Math_fround(0.0);
      }
      f16 = Math_fround(f10 - f2);
      f21 = Math_fround(f11 - f3);
      f19 = Math_fround(Math_fround(Math_fround(f11 * Math_fround(.5)) + f5) - Math_fround(f21 * Math_fround(.5)));
      HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f10 * Math_fround(.5)) + f9) - Math_fround(f16 * Math_fround(.5)));
      HEAPF32[i24 + 8 >> 2] = f16;
      HEAPF32[i24 + 4 >> 2] = f19;
      HEAPF32[i24 + 12 >> 2] = f21;
      __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i24, i1, i25, gb + 1157900 | 0);
     }
    }
    break;
   }
   f5 = Math_fround(f15 + Math_fround(f16 * Math_fround(.25)));
   f13 = Math_fround(f16 * Math_fround(.75));
   i1 = HEAP32[gb + 1157880 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[gb + 1157884 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1157884 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1157884 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[gb + 1157884 + 12 >> 2];
   f14 = Math_fround(HEAPF32[gb + 1157876 >> 2]);
   f2 = Math_fround(+__Z19GetTimeSinceStartupv());
   d6 = +HEAPF64[gb + 1098064 >> 3];
   d7 = +HEAPF64[gb + 1098080 >> 3];
   HEAP32[i25 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   if (i1 | 0) {
    f10 = Math_fround(d6 + d7);
    f11 = Math_fround(d6);
    f3 = Math_fround(HEAPF32[gb + 1157856 >> 2]);
    f11 = Math_fround(f2 - f11);
    f2 = Math_fround(f10 - f2);
    f11 = Math_fround((f2 < f11 ? f2 : f11) / Math_fround(.800000011));
    i29 = f11 < Math_fround(0.0);
    i28 = f11 > Math_fround(1.0);
    f11 = i28 ? Math_fround(1.0) : f11;
    f11 = i29 ? Math_fround(0.0) : f11;
    HEAPF32[i25 + 12 >> 2] = f11;
    if (f11 > Math_fround(0.0)) {
     f10 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f2 * Math_fround(f3 * Math_fround(.0500000007))) + Math_fround(1.0))) * Math_fround(.800000011));
     f9 = Math_fround(f21 * f10);
     f10 = Math_fround(f13 * f10);
     f11 = Math_fround(f19 + Math_fround(Math_fround(f21 - f9) * Math_fround(.5)));
     f5 = Math_fround(f5 + Math_fround(Math_fround(f13 - f10) * Math_fround(.5)));
     f2 = Math_fround(f14 * f10);
     if (f2 < f9) {
      f3 = Math_fround(0.0);
      f2 = Math_fround(Math_abs(Math_fround(f2 - f9)));
     } else {
      f3 = Math_fround(Math_abs(Math_fround(Math_fround(f9 / f14) - f10)));
      f2 = Math_fround(0.0);
     }
     f2 = Math_fround(f9 - f2);
     f14 = Math_fround(f10 - f3);
     f13 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(.5)) + f5) - Math_fround(f14 * Math_fround(.5)));
     HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f9 * Math_fround(.5)) + f11) - Math_fround(f2 * Math_fround(.5)));
     HEAPF32[i24 + 8 >> 2] = f2;
     HEAPF32[i24 + 4 >> 2] = f13;
     HEAPF32[i24 + 12 >> 2] = f14;
     __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i24, i1, i25, gb + 1157900 | 0);
    }
   }
   i12 = (HEAP32[i4 + 152 >> 2] | 0) == 0 ? gb + 43052 | 0 : gb + 62560 | 0;
   HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   f5 = Math_fround(f15 + Math_fround(f16 * Math_fround(.150000006)));
   f11 = Math_fround(f16 * Math_fround(.100000001));
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   HEAP32[i20 + 12 >> 2] = 0;
   __ZL9SetUvRectP6SpriteR5RectTIfE(HEAP32[gb + 1157860 >> 2] | 0, i20);
   i12 = __ZNK6Sprite24GetRenderDataForPlayModeEv(HEAP32[gb + 1157860 >> 2] | 0) | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i25 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i17 = 39; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i8 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i4 + (i8 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i24, i1, i25);
      i4 = HEAP32[i24 >> 2] | 0;
      i29 = HEAP32[i1 + 28 >> 2] | 0;
      i8 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i4 | 0) == -1 ? i29 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i29 + (i4 << 3) | 0;
      i4 = HEAP32[i8 + 28 >> 2] | 0;
      i8 = HEAP32[i8 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 + (i8 << 3) | 0)) i17 = 39; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i17 = 41;
     }
    }
    if ((i17 | 0) == 39) i17 = 41;
    if ((i17 | 0) == 41) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0;
   }
   f10 = Math_fround(HEAPF32[gb + 1157864 >> 2]);
   f2 = Math_fround(+__Z19GetTimeSinceStartupv());
   d6 = +HEAPF64[gb + 1098072 >> 3];
   f3 = Math_fround(HEAPF32[gb + 1157868 >> 2]);
   HEAP32[i25 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   if (i1 | 0) {
    f16 = Math_fround(f2 - Math_fround(d6));
    f15 = Math_fround(Math_fround(d6 + +f3) - f2);
    f16 = Math_fround((f15 < f16 ? f15 : f16) / Math_fround(.800000011));
    i29 = f16 < Math_fround(0.0);
    i28 = f16 > Math_fround(1.0);
    f16 = i28 ? Math_fround(1.0) : f16;
    f16 = i29 ? Math_fround(0.0) : f16;
    HEAPF32[i25 + 12 >> 2] = f16;
    if (f16 > Math_fround(0.0)) {
     f9 = Math_fround(f19 + Math_fround(Math_fround(f21 - f21) * Math_fround(.5)));
     f5 = Math_fround(f5 + Math_fround(Math_fround(f11 - f11) * Math_fround(.5)));
     f2 = Math_fround(f11 * f10);
     if (f2 < f21) {
      f3 = Math_fround(0.0);
      f2 = Math_fround(Math_abs(Math_fround(f2 - f21)));
     } else {
      f3 = Math_fround(Math_abs(Math_fround(Math_fround(f21 / f10) - f11)));
      f2 = Math_fround(0.0);
     }
     f15 = Math_fround(f21 - f2);
     f19 = Math_fround(f11 - f3);
     f16 = Math_fround(Math_fround(Math_fround(f11 * Math_fround(.5)) + f5) - Math_fround(f19 * Math_fround(.5)));
     HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f21 * Math_fround(.5)) + f9) - Math_fround(f15 * Math_fround(.5)));
     HEAPF32[i24 + 8 >> 2] = f15;
     HEAPF32[i24 + 4 >> 2] = f16;
     HEAPF32[i24 + 12 >> 2] = f19;
     __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i24, i1, i25, i20);
    }
   }
  }
 } while (0);
 if (!i23) mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 500 >> 2] | 0, i22 | 0);
 i29 = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 84 >> 2] | 0, i22 | 0) | 0;
 i28 = (__Z19GetActiveColorSpacev() | 0) == 1;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 80 >> 2] | 0, i22 | 0, i28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 508 >> 2] | 0, i22 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 80 >> 2] | 0, i22 | 0, i29 | 0);
 __ZN22DeviceMVPMatricesStateD2Ev(i26);
 STACKTOP = i27;
 return;
}

function __Z9ReadCacheR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjRKjRKf(i64, i2, i1, i78, i3, i4, i83, i84) {
 i64 = i64 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i78 = i78 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i83 = i83 | 0;
 i84 = i84 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, f89 = f0, i90 = 0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, i101 = 0, i102 = 0, i103 = 0;
 i87 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i85 = i87 + 104 | 0;
 i86 = i87 + 56 | 0;
 i65 = i87 + 44 | 0;
 i66 = i87 + 32 | 0;
 i67 = i87 + 20 | 0;
 i68 = i87 + 8 | 0;
 i69 = i87 + 4 | 0;
 i70 = i87;
 f71 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f72 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f73 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f74 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f75 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f76 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f77 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f79 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f80 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f81 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f82 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f51 = Math_fround(HEAPF32[i1 + 108 >> 2]);
 if ((HEAP32[i83 >> 2] | 0) >>> 0 <= i4 >>> 0) {
  STACKTOP = i87;
  return;
 }
 i52 = i78 + 20 | 0;
 i53 = i78 + 40 | 0;
 i36 = i85 + 4 | 0;
 i42 = i85 + 8 | 0;
 i48 = i85 + 12 | 0;
 i32 = i85 + 16 | 0;
 i35 = i85 + 20 | 0;
 i41 = i85 + 24 | 0;
 i47 = i85 + 28 | 0;
 i31 = i85 + 32 | 0;
 i33 = i85 + 36 | 0;
 i40 = i85 + 40 | 0;
 i45 = i85 + 44 | 0;
 i54 = i78 + 60 | 0;
 i55 = i78 + 80 | 0;
 i56 = i78 + 100 | 0;
 i57 = i78 + 120 | 0;
 i58 = i78 + 140 | 0;
 i59 = i78 + 160 | 0;
 i60 = i85 + 16 | 0;
 i61 = i85 + 32 | 0;
 i38 = i86 + 4 | 0;
 i44 = i86 + 8 | 0;
 i50 = i86 + 12 | 0;
 i62 = i86 + 16 | 0;
 i37 = i86 + 20 | 0;
 i43 = i86 + 24 | 0;
 i49 = i86 + 28 | 0;
 i63 = i86 + 32 | 0;
 i34 = i86 + 36 | 0;
 i39 = i86 + 40 | 0;
 i46 = i86 + 44 | 0;
 i25 = i2 + 280 | 0;
 i26 = i65 + 4 | 0;
 i27 = i65 + 8 | 0;
 i28 = i66 + 4 | 0;
 i29 = i66 + 8 | 0;
 i30 = i3 + 24 | 0;
 i21 = i3 + 44 | 0;
 i22 = i64 + 12 | 0;
 i23 = i64 + 16 | 0;
 i24 = i64 + 4 | 0;
 do {
  i3 = (HEAP32[i78 >> 2] | 0) + (i4 << 2) | 0;
  i88 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  i8 = (HEAP32[i52 >> 2] | 0) + (i4 << 2) | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i8 + 4 >> 2] | 0;
  i7 = HEAP32[i8 + 8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  i90 = (HEAP32[i53 >> 2] | 0) + (i4 << 2) | 0;
  i103 = HEAP32[i90 >> 2] | 0;
  i102 = HEAP32[i90 + 4 >> 2] | 0;
  i101 = HEAP32[i90 + 8 >> 2] | 0;
  i90 = HEAP32[i90 + 12 >> 2] | 0;
  HEAP32[i85 >> 2] = i88;
  HEAP32[i36 >> 2] = i1;
  HEAP32[i42 >> 2] = i2;
  HEAP32[i48 >> 2] = i3;
  HEAP32[i32 >> 2] = i5;
  HEAP32[i35 >> 2] = i6;
  HEAP32[i41 >> 2] = i7;
  HEAP32[i47 >> 2] = i8;
  HEAP32[i31 >> 2] = i103;
  HEAP32[i33 >> 2] = i102;
  HEAP32[i40 >> 2] = i101;
  HEAP32[i45 >> 2] = i90;
  i90 = (HEAP32[i54 >> 2] | 0) + (i4 << 2) | 0;
  f100 = Math_fround(HEAPF32[i90 >> 2]);
  f99 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f98 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f97 = Math_fround(HEAPF32[i90 + 12 >> 2]);
  i90 = (HEAP32[i55 >> 2] | 0) + (i4 << 2) | 0;
  f96 = Math_fround(HEAPF32[i90 >> 2]);
  f95 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f94 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f93 = Math_fround(HEAPF32[i90 + 12 >> 2]);
  i90 = (HEAP32[i56 >> 2] | 0) + (i4 << 2) | 0;
  f92 = Math_fround(HEAPF32[i90 >> 2]);
  f91 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f89 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i90 + 12 >> 2]);
  i90 = (HEAP32[i57 >> 2] | 0) + (i4 << 2) | 0;
  f9 = Math_fround(HEAPF32[i90 >> 2]);
  f10 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i90 + 12 >> 2]);
  i90 = (HEAP32[i58 >> 2] | 0) + (i4 << 2) | 0;
  f13 = Math_fround(HEAPF32[i90 >> 2]);
  f14 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i90 + 12 >> 2]);
  i90 = (HEAP32[i59 >> 2] | 0) + (i4 << 2) | 0;
  f17 = Math_fround(HEAPF32[i90 >> 2]);
  f18 = Math_fround(HEAPF32[i90 + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i90 + 8 >> 2]);
  f9 = Math_fround(f100 + f9);
  f10 = Math_fround(f99 + f10);
  f11 = Math_fround(f98 + f11);
  f12 = Math_fround(f97 + f12);
  f13 = Math_fround(f96 + f13);
  f14 = Math_fround(f95 + f14);
  f15 = Math_fround(f94 + f15);
  f16 = Math_fround(f93 + f16);
  f17 = Math_fround(f92 + f17);
  f18 = Math_fround(f91 + f18);
  f19 = Math_fround(f89 + f19);
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i90 + 12 >> 2]));
  f89 = Math_fround(HEAPF32[i84 >> 2]);
  f9 = Math_fround(f9 * f89);
  f10 = Math_fround(f10 * f89);
  f11 = Math_fround(f11 * f89);
  f12 = Math_fround(f12 * f89);
  f13 = Math_fround(f13 * f89);
  f14 = Math_fround(f14 * f89);
  f15 = Math_fround(f15 * f89);
  f16 = Math_fround(f16 * f89);
  f17 = Math_fround(f17 * f89);
  f18 = Math_fround(f18 * f89);
  f19 = Math_fround(f19 * f89);
  f20 = Math_fround(f89 * f20);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f10);
  f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f12);
  f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
  f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
  f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f16);
  f17 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f17);
  f18 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f18);
  f19 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f19);
  f20 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f20);
  HEAPF32[i86 >> 2] = f9;
  HEAPF32[i38 >> 2] = f10;
  HEAPF32[i44 >> 2] = f11;
  HEAPF32[i50 >> 2] = f12;
  HEAPF32[i62 >> 2] = f13;
  HEAPF32[i37 >> 2] = f14;
  HEAPF32[i43 >> 2] = f15;
  HEAPF32[i49 >> 2] = f16;
  HEAPF32[i63 >> 2] = f17;
  HEAPF32[i34 >> 2] = f18;
  HEAPF32[i39 >> 2] = f19;
  HEAPF32[i46 >> 2] = f20;
  if ((HEAP32[i25 >> 2] | 0) == 1) i1 = 0; else {
   f95 = Math_fround(f81 + Math_fround(Math_fround(Math_fround(f71 * f10) + Math_fround(f74 * f14)) + Math_fround(f77 * f18)));
   f100 = Math_fround(f81 + Math_fround(Math_fround(Math_fround(f71 * f11) + Math_fround(f74 * f15)) + Math_fround(f77 * f19)));
   f91 = Math_fround(f81 + Math_fround(Math_fround(f77 * f20) + Math_fround(Math_fround(f71 * f12) + Math_fround(f74 * f16))));
   f99 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f9) + Math_fround(f75 * f13)) + Math_fround(f79 * f17)));
   f89 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f10) + Math_fround(f75 * f14)) + Math_fround(f79 * f18)));
   f93 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f11) + Math_fround(f75 * f15)) + Math_fround(f79 * f19)));
   f94 = Math_fround(f82 + Math_fround(Math_fround(f79 * f20) + Math_fround(Math_fround(f72 * f12) + Math_fround(f75 * f16))));
   f92 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f9) + Math_fround(f76 * f13)) + Math_fround(f80 * f17)));
   f97 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f10) + Math_fround(f76 * f14)) + Math_fround(f80 * f18)));
   f98 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f11) + Math_fround(f76 * f15)) + Math_fround(f80 * f19)));
   f11 = Math_fround(f51 + Math_fround(Math_fround(f80 * f20) + Math_fround(Math_fround(f73 * f12) + Math_fround(f76 * f16))));
   HEAPF32[i86 >> 2] = Math_fround(f81 + Math_fround(Math_fround(Math_fround(f71 * f9) + Math_fround(f74 * f13)) + Math_fround(f77 * f17)));
   HEAPF32[i38 >> 2] = f95;
   HEAPF32[i44 >> 2] = f100;
   HEAPF32[i50 >> 2] = f91;
   HEAPF32[i62 >> 2] = f99;
   HEAPF32[i37 >> 2] = f89;
   HEAPF32[i43 >> 2] = f93;
   HEAPF32[i49 >> 2] = f94;
   HEAPF32[i63 >> 2] = f92;
   HEAPF32[i34 >> 2] = f97;
   HEAPF32[i39 >> 2] = f98;
   HEAPF32[i46 >> 2] = f11;
   f11 = Math_fround(HEAPF32[i85 >> 2]);
   f98 = Math_fround(f71 * f11);
   f13 = Math_fround(HEAPF32[i36 >> 2]);
   f20 = Math_fround(f71 * f13);
   f15 = Math_fround(HEAPF32[i42 >> 2]);
   f97 = Math_fround(f71 * f15);
   f17 = Math_fround(HEAPF32[i48 >> 2]);
   f92 = Math_fround(f71 * f17);
   f12 = Math_fround(HEAPF32[i60 >> 2]);
   f19 = Math_fround(f74 * f12);
   f14 = Math_fround(HEAPF32[i35 >> 2]);
   f94 = Math_fround(f74 * f14);
   f16 = Math_fround(HEAPF32[i41 >> 2]);
   f93 = Math_fround(f74 * f16);
   f18 = Math_fround(HEAPF32[i47 >> 2]);
   f19 = Math_fround(f98 + f19);
   f94 = Math_fround(f20 + f94);
   f93 = Math_fround(f97 + f93);
   f92 = Math_fround(f92 + Math_fround(f74 * f18));
   f97 = Math_fround(HEAPF32[i61 >> 2]);
   f20 = Math_fround(f77 * f97);
   f98 = Math_fround(HEAPF32[i33 >> 2]);
   f89 = Math_fround(f77 * f98);
   f99 = Math_fround(HEAPF32[i40 >> 2]);
   f91 = Math_fround(f77 * f99);
   f100 = Math_fround(HEAPF32[i45 >> 2]);
   f89 = Math_fround(f81 + Math_fround(f94 + f89));
   f91 = Math_fround(f81 + Math_fround(f93 + f91));
   f92 = Math_fround(f81 + Math_fround(f92 + Math_fround(f77 * f100)));
   f93 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f11) + Math_fround(f75 * f12)) + Math_fround(f79 * f97)));
   f94 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f13) + Math_fround(f75 * f14)) + Math_fround(f79 * f98)));
   f95 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f15) + Math_fround(f75 * f16)) + Math_fround(f79 * f99)));
   f96 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f72 * f17) + Math_fround(f75 * f18)) + Math_fround(f79 * f100)));
   f97 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f11) + Math_fround(f76 * f12)) + Math_fround(f80 * f97)));
   f98 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f13) + Math_fround(f76 * f14)) + Math_fround(f80 * f98)));
   f99 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f15) + Math_fround(f76 * f16)) + Math_fround(f80 * f99)));
   f100 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f73 * f17) + Math_fround(f76 * f18)) + Math_fround(f80 * f100)));
   HEAPF32[i85 >> 2] = Math_fround(f81 + Math_fround(f19 + f20));
   HEAPF32[i36 >> 2] = f89;
   HEAPF32[i42 >> 2] = f91;
   HEAPF32[i48 >> 2] = f92;
   HEAPF32[i32 >> 2] = f93;
   HEAPF32[i35 >> 2] = f94;
   HEAPF32[i41 >> 2] = f95;
   HEAPF32[i47 >> 2] = f96;
   HEAPF32[i31 >> 2] = f97;
   HEAPF32[i33 >> 2] = f98;
   HEAPF32[i40 >> 2] = f99;
   HEAPF32[i45 >> 2] = f100;
   i1 = 0;
  }
  do {
   i3 = i1 + i4 | 0;
   if (i3 >>> 0 < (HEAP32[i83 >> 2] | 0) >>> 0) {
    i101 = HEAP32[i86 + (i1 << 2) >> 2] | 0;
    i102 = HEAP32[i62 + (i1 << 2) >> 2] | 0;
    i103 = HEAP32[i63 + (i1 << 2) >> 2] | 0;
    HEAP32[i65 >> 2] = i101;
    HEAP32[i26 >> 2] = i102;
    HEAP32[i27 >> 2] = i103;
    f98 = Math_fround(HEAPF32[i85 + (i1 << 2) >> 2]);
    f99 = Math_fround(HEAPF32[i60 + (i1 << 2) >> 2]);
    f100 = Math_fround(HEAPF32[i61 + (i1 << 2) >> 2]);
    f98 = Math_fround(f98 - (HEAP32[tempDoublePtr >> 2] = i101, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f99 = Math_fround(f99 - (HEAP32[tempDoublePtr >> 2] = i102, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f100 = Math_fround(f100 - (HEAP32[tempDoublePtr >> 2] = i103, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i66 >> 2] = f98;
    HEAPF32[i28 >> 2] = f99;
    HEAPF32[i29 >> 2] = f100;
    if (__ZNK32PlaneColliderCache_dense_hashmap4FindERK8Vector3fS2_RS0_S3_RiS4_f(HEAP32[i30 >> 2] | 0, i65, i66, i67, i68, i69, i70, Math_fround(HEAPF32[i21 >> 2])) | 0) {
     i5 = HEAP32[i22 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i23 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i23 >> 2] = i2;
       HEAP32[i64 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i64 >> 2] | 0, i2 * 60 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i103 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 60 | 0, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i103 | 0, HEAP32[i64 >> 2] | 0, (HEAP32[i22 >> 2] | 0) * 60 | 0) | 0;
       HEAP32[i23 >> 2] = i2;
       HEAP32[i64 >> 2] = i103;
       break;
      }
     } while (0);
     HEAP32[i22 >> 2] = i6;
     i103 = HEAP32[i64 >> 2] | 0;
     HEAP32[i103 + (i5 * 60 | 0) >> 2] = i3;
     i102 = i103 + (i5 * 60 | 0) + 4 | 0;
     HEAP32[i102 >> 2] = HEAP32[i65 >> 2];
     HEAP32[i102 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
     HEAP32[i102 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
     i102 = i103 + (i5 * 60 | 0) + 16 | 0;
     HEAP32[i102 >> 2] = HEAP32[i66 >> 2];
     HEAP32[i102 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
     HEAP32[i102 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
     i102 = i103 + (i5 * 60 | 0) + 28 | 0;
     HEAP32[i102 >> 2] = HEAP32[i67 >> 2];
     HEAP32[i102 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
     HEAP32[i102 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
     i102 = i103 + (i5 * 60 | 0) + 40 | 0;
     HEAP32[i102 >> 2] = HEAP32[i68 >> 2];
     HEAP32[i102 + 4 >> 2] = HEAP32[i68 + 4 >> 2];
     HEAP32[i102 + 8 >> 2] = HEAP32[i68 + 8 >> 2];
     HEAP32[i103 + (i5 * 60 | 0) + 52 >> 2] = HEAP32[i69 >> 2];
     HEAP32[i103 + (i5 * 60 | 0) + 56 >> 2] = HEAP32[i70 >> 2];
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4);
  i4 = i4 + 4 | 0;
 } while (i4 >>> 0 < (HEAP32[i83 >> 2] | 0) >>> 0);
 STACKTOP = i87;
 return;
}

function __ZN5physx27PxcPCMContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i2, i3, i11, i1, i53) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i53 = i53 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0;
 i22 = i2 + 16 | 0;
 f43 = Math_fround(HEAPF32[i22 >> 2]);
 f42 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f41 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f35 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i22 = i3 + 16 | 0;
 f32 = Math_fround(HEAPF32[i22 >> 2]);
 f30 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f52 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f51 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f48 = Math_fround(Math_fround(f43 + f32) * Math_fround(.5));
 f49 = Math_fround(Math_fround(f42 + f30) * Math_fround(.5));
 f50 = Math_fround(Math_fround(f41 + f28) * Math_fround(.5));
 f43 = Math_fround(f43 - f48);
 f42 = Math_fround(f42 - f49);
 f41 = Math_fround(f41 - f50);
 f32 = Math_fround(f32 - f48);
 f30 = Math_fround(f30 - f49);
 f28 = Math_fround(f28 - f50);
 f33 = Math_fround(f35 * Math_fround(2.0));
 f24 = Math_fround(f34 * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f33) + Math_fround(f34 * f24)) + Math_fround(-1.0)) * f36);
 f35 = Math_fround(Math_fround(Math_fround(f33 * f25) + Math_fround(f26 * f24)) * f36);
 f36 = Math_fround(Math_fround(Math_fround(f33 * f26) - Math_fround(f25 * f24)) * f36);
 f24 = Math_fround(f43 + f34);
 f25 = Math_fround(f42 + f35);
 f26 = Math_fround(f41 + f36);
 f34 = Math_fround(f43 - f34);
 f35 = Math_fround(f42 - f35);
 f36 = Math_fround(f41 - f36);
 f41 = Math_fround(f34 - f24);
 f42 = Math_fround(f35 - f25);
 f43 = Math_fround(f36 - f26);
 f33 = Math_fround(f18 * Math_fround(2.0));
 f27 = Math_fround(f17 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f33) + Math_fround(f17 * f27)) + Math_fround(-1.0)) * f19);
 f18 = Math_fround(Math_fround(Math_fround(f33 * f29) + Math_fround(f31 * f27)) * f19);
 f19 = Math_fround(Math_fround(Math_fround(f33 * f31) - Math_fround(f29 * f27)) * f19);
 f27 = Math_fround(f32 + f17);
 f29 = Math_fround(f30 + f18);
 f31 = Math_fround(f28 + f19);
 f17 = Math_fround(f32 - f17);
 f18 = Math_fround(f30 - f18);
 f19 = Math_fround(f28 - f19);
 f28 = Math_fround(f17 - f27);
 f30 = Math_fround(f18 - f29);
 f32 = Math_fround(f19 - f31);
 f51 = Math_fround(f52 + f51);
 f33 = Math_fround(f51 + Math_fround(HEAPF32[i11 >> 2]));
 f33 = Math_fround(f33 * f33);
 f37 = Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42)));
 f6 = Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f28 * f28) + Math_fround(f30 * f30)));
 f39 = Math_fround(f24 - f27);
 f7 = Math_fround(f25 - f29);
 f40 = Math_fround(f26 - f31);
 f45 = Math_fround(Math_fround(f43 * f32) + Math_fround(Math_fround(f41 * f28) + Math_fround(f42 * f30)));
 f46 = Math_fround(Math_fround(f43 * f40) + Math_fround(Math_fround(f41 * f39) + Math_fround(f42 * f7)));
 i22 = f37 > Math_fround(1.1920929e-07);
 i21 = f6 > Math_fround(1.1920929e-07);
 f44 = Math_fround(Math_fround(1.0) / f37);
 f38 = Math_fround(Math_fround(1.0) / f6);
 f7 = Math_fround(Math_fround(f40 * f32) + Math_fround(Math_fround(f39 * f28) + Math_fround(f7 * f30)));
 f39 = Math_fround(Math_fround(f37 * f6) - Math_fround(f45 * f45));
 f40 = Math_fround(Math_fround(Math_fround(f45 * f7) - Math_fround(f46 * f6)) / f39);
 i11 = f40 > Math_fround(1.0);
 f40 = i11 ? Math_fround(1.0) : f40;
 i11 = f40 > Math_fround(0.0);
 f40 = i11 ? f40 : Math_fround(0.0);
 i11 = f39 < Math_fround(1.1920929e-07);
 f40 = Math_fround(f7 + Math_fround(f45 * (i11 ? Math_fround(.5) : f40)));
 f40 = Math_fround((i21 ? f38 : Math_fround(0.0)) * f40);
 i21 = f40 > Math_fround(1.0);
 f40 = i21 ? Math_fround(1.0) : f40;
 i21 = f40 > Math_fround(0.0);
 f40 = i21 ? f40 : Math_fround(0.0);
 f46 = Math_fround(Math_fround(f45 * f40) - f46);
 f46 = Math_fround((i22 ? f44 : Math_fround(0.0)) * f46);
 i22 = f46 > Math_fround(1.0);
 f46 = i22 ? Math_fround(1.0) : f46;
 i22 = f46 > Math_fround(0.0);
 f46 = i22 ? f46 : Math_fround(0.0);
 f44 = Math_fround(f24 + Math_fround(f41 * f46));
 f45 = Math_fround(f25 + Math_fround(f42 * f46));
 f46 = Math_fround(f26 + Math_fround(f43 * f46));
 f38 = Math_fround(f44 - Math_fround(f27 + Math_fround(f28 * f40)));
 f39 = Math_fround(f45 - Math_fround(f29 + Math_fround(f30 * f40)));
 f40 = Math_fround(f46 - Math_fround(f31 + Math_fround(f32 * f40)));
 f47 = Math_fround(Math_fround(f40 * f40) + Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39)));
 if (!(f33 >= f47)) {
  i53 = 0;
  return i53 | 0;
 }
 i21 = f37 < Math_fround(9.99999997e-07);
 i22 = f6 < Math_fround(9.99999997e-07);
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f37))));
 f15 = Math_fround(f41 * f13);
 f20 = Math_fround(f42 * f13);
 f13 = Math_fround(f43 * f13);
 f15 = i21 ? Math_fround(0.0) : f15;
 f20 = i21 ? Math_fround(0.0) : f20;
 f13 = i21 ? Math_fround(0.0) : f13;
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
 f16 = Math_fround(f28 * f14);
 f23 = Math_fround(f30 * f14);
 f14 = Math_fround(f32 * f14);
 f16 = i22 ? Math_fround(0.0) : f16;
 f23 = i22 ? Math_fround(0.0) : f23;
 if (Math_fround(Math_abs(Math_fround(Math_fround(f13 * (i22 ? Math_fround(0.0) : f14)) + Math_fround(Math_fround(f15 * f16) + Math_fround(f20 * f23))))) > Math_fround(.999800026)) {
  f15 = Math_fround(Math_fround(Math_fround(f43 * Math_fround(f31 - f26)) + Math_fround(Math_fround(f41 * Math_fround(f27 - f24)) + Math_fround(f42 * Math_fround(f29 - f25)))) / f37);
  f16 = Math_fround(Math_fround(Math_fround(f43 * Math_fround(f19 - f26)) + Math_fround(Math_fround(f41 * Math_fround(f17 - f24)) + Math_fround(f42 * Math_fround(f18 - f25)))) / f37);
  f20 = Math_fround(f7 / f6);
  f23 = Math_fround(Math_fround(Math_fround(Math_fround(f36 - f31) * f32) + Math_fround(Math_fround(Math_fround(f34 - f27) * f28) + Math_fround(Math_fround(f35 - f29) * f30))) / f6);
  i5 = f37 == Math_fround(0.0);
  i3 = f6 == Math_fround(0.0);
  f6 = i5 ? Math_fround(0.0) : f15;
  f16 = i5 ? Math_fround(0.0) : f16;
  f20 = i3 ? Math_fround(0.0) : f20;
  f23 = i3 ? Math_fround(0.0) : f23;
  i3 = f16 >= Math_fround(0.0);
  i5 = f20 >= Math_fround(0.0);
  i21 = f23 >= Math_fround(0.0);
  i4 = f16 <= Math_fround(1.0);
  i11 = f20 <= Math_fround(1.0);
  i22 = f23 <= Math_fround(1.0);
  if (f6 >= Math_fround(0.0) & f6 <= Math_fround(1.0)) {
   f14 = Math_fround(f24 + Math_fround(f41 * f6));
   f15 = Math_fround(f25 + Math_fround(f42 * f6));
   f13 = Math_fround(f26 + Math_fround(f43 * f6));
   f7 = Math_fround(f14 - f27);
   f8 = Math_fround(f15 - f29);
   f9 = Math_fround(f13 - f31);
   f6 = Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)));
   if (f6 > Math_fround(9.99999997e-07) & f33 > f6) {
    f12 = Math_fround(Math_sqrt(Math_fround(f6)));
    f6 = Math_fround(Math_fround(1.0) / f12);
    f10 = Math_fround(f7 * f6);
    f7 = Math_fround(f8 * f6);
    f6 = Math_fround(f9 * f6);
    i1 = i53 + 4096 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 >>> 0 > 63) i1 = 1; else {
     f12 = Math_fround(f12 - f51);
     f13 = Math_fround(f50 + Math_fround(f13 - Math_fround(f52 * f6)));
     f15 = Math_fround(f49 + Math_fround(f15 - Math_fround(f52 * f7)));
     f14 = Math_fround(f48 + Math_fround(f14 - Math_fround(f52 * f10)));
     HEAP32[i1 >> 2] = i2 + 1;
     i1 = i53 + (i2 << 6) | 0;
     HEAPF32[i1 >> 2] = f10;
     HEAPF32[i1 + 4 >> 2] = f7;
     HEAPF32[i1 + 8 >> 2] = f6;
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     i1 = i53 + (i2 << 6) + 16 | 0;
     HEAPF32[i1 >> 2] = f14;
     HEAPF32[i1 + 4 >> 2] = f15;
     HEAPF32[i1 + 8 >> 2] = f13;
     HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
     HEAPF32[i53 + (i2 << 6) + 12 >> 2] = f12;
     HEAP32[i53 + (i2 << 6) + 48 >> 2] = -1;
     HEAP32[i53 + (i2 << 6) + 52 >> 2] = -1;
     i1 = 1;
    }
   } else i1 = 0;
  } else i1 = 0;
  if (i3 & i4) {
   f14 = Math_fround(f24 + Math_fround(f41 * f16));
   f15 = Math_fround(f25 + Math_fround(f42 * f16));
   f13 = Math_fround(f26 + Math_fround(f43 * f16));
   f7 = Math_fround(f14 - f17);
   f8 = Math_fround(f15 - f18);
   f9 = Math_fround(f13 - f19);
   f6 = Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)));
   if (f6 > Math_fround(9.99999997e-07) & f33 > f6) {
    f12 = Math_fround(Math_sqrt(Math_fround(f6)));
    f6 = Math_fround(Math_fround(1.0) / f12);
    f10 = Math_fround(f7 * f6);
    f7 = Math_fround(f8 * f6);
    f6 = Math_fround(f9 * f6);
    i2 = i53 + 4096 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 <= 63) {
     f19 = Math_fround(f12 - f51);
     f18 = Math_fround(f50 + Math_fround(f13 - Math_fround(f52 * f6)));
     f17 = Math_fround(f49 + Math_fround(f15 - Math_fround(f52 * f7)));
     f16 = Math_fround(f48 + Math_fround(f14 - Math_fround(f52 * f10)));
     HEAP32[i2 >> 2] = i3 + 1;
     i4 = i53 + (i3 << 6) | 0;
     HEAPF32[i4 >> 2] = f10;
     HEAPF32[i4 + 4 >> 2] = f7;
     HEAPF32[i4 + 8 >> 2] = f6;
     HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
     i4 = i53 + (i3 << 6) + 16 | 0;
     HEAPF32[i4 >> 2] = f16;
     HEAPF32[i4 + 4 >> 2] = f17;
     HEAPF32[i4 + 8 >> 2] = f18;
     HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
     HEAPF32[i53 + (i3 << 6) + 12 >> 2] = f19;
     HEAP32[i53 + (i3 << 6) + 48 >> 2] = -1;
     HEAP32[i53 + (i3 << 6) + 52 >> 2] = -1;
    }
    i1 = i1 + 1 | 0;
   }
  }
  if (i5 & i11) {
   f7 = Math_fround(f24 - Math_fround(f27 + Math_fround(f28 * f20)));
   f8 = Math_fround(f25 - Math_fround(f29 + Math_fround(f30 * f20)));
   f9 = Math_fround(f26 - Math_fround(f31 + Math_fround(f32 * f20)));
   f6 = Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)));
   if (f6 > Math_fround(9.99999997e-07) & f33 > f6) {
    f12 = Math_fround(Math_sqrt(Math_fround(f6)));
    f6 = Math_fround(Math_fround(1.0) / f12);
    f10 = Math_fround(f7 * f6);
    f7 = Math_fround(f8 * f6);
    f6 = Math_fround(f9 * f6);
    i2 = i53 + 4096 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 <= 63) {
     f20 = Math_fround(f12 - f51);
     f26 = Math_fround(f50 + Math_fround(f26 - Math_fround(f52 * f6)));
     f25 = Math_fround(f49 + Math_fround(f25 - Math_fround(f52 * f7)));
     f24 = Math_fround(f48 + Math_fround(f24 - Math_fround(f52 * f10)));
     HEAP32[i2 >> 2] = i3 + 1;
     i11 = i53 + (i3 << 6) | 0;
     HEAPF32[i11 >> 2] = f10;
     HEAPF32[i11 + 4 >> 2] = f7;
     HEAPF32[i11 + 8 >> 2] = f6;
     HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
     i11 = i53 + (i3 << 6) + 16 | 0;
     HEAPF32[i11 >> 2] = f24;
     HEAPF32[i11 + 4 >> 2] = f25;
     HEAPF32[i11 + 8 >> 2] = f26;
     HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
     HEAPF32[i53 + (i3 << 6) + 12 >> 2] = f20;
     HEAP32[i53 + (i3 << 6) + 48 >> 2] = -1;
     HEAP32[i53 + (i3 << 6) + 52 >> 2] = -1;
    }
    i1 = i1 + 1 | 0;
   }
  }
  if (i21 & i22) {
   f9 = Math_fround(f34 - Math_fround(f27 + Math_fround(f28 * f23)));
   f7 = Math_fround(f35 - Math_fround(f29 + Math_fround(f30 * f23)));
   f8 = Math_fround(f36 - Math_fround(f31 + Math_fround(f32 * f23)));
   f6 = Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f9 * f9) + Math_fround(f7 * f7)));
   if (f6 > Math_fround(9.99999997e-07) & f33 > f6) {
    f10 = Math_fround(Math_sqrt(Math_fround(f6)));
    f6 = Math_fround(Math_fround(1.0) / f10);
    f9 = Math_fround(f9 * f6);
    f7 = Math_fround(f7 * f6);
    f6 = Math_fround(f8 * f6);
    i2 = i53 + 4096 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 <= 63) {
     f33 = Math_fround(f10 - f51);
     f36 = Math_fround(f50 + Math_fround(f36 - Math_fround(f52 * f6)));
     f35 = Math_fround(f49 + Math_fround(f35 - Math_fround(f52 * f7)));
     f34 = Math_fround(f48 + Math_fround(f34 - Math_fround(f52 * f9)));
     HEAP32[i2 >> 2] = i3 + 1;
     i22 = i53 + (i3 << 6) | 0;
     HEAPF32[i22 >> 2] = f9;
     HEAPF32[i22 + 4 >> 2] = f7;
     HEAPF32[i22 + 8 >> 2] = f6;
     HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
     i22 = i53 + (i3 << 6) + 16 | 0;
     HEAPF32[i22 >> 2] = f34;
     HEAPF32[i22 + 4 >> 2] = f35;
     HEAPF32[i22 + 8 >> 2] = f36;
     HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
     HEAPF32[i53 + (i3 << 6) + 12 >> 2] = f33;
     HEAP32[i53 + (i3 << 6) + 48 >> 2] = -1;
     HEAP32[i53 + (i3 << 6) + 52 >> 2] = -1;
    }
    i1 = i1 + 1 | 0;
   }
  }
  if (i1 | 0) {
   i53 = 1;
   return i53 | 0;
  }
 }
 i3 = f47 < Math_fround(9.99999997e-07);
 i1 = f37 > Math_fround(9.99999997e-07);
 f6 = i1 ? f41 : Math_fround(1.0);
 f7 = i1 ? f42 : Math_fround(0.0);
 f43 = i1 ? f43 : Math_fround(0.0);
 f6 = i3 ? f6 : f38;
 f7 = i3 ? f7 : f39;
 f43 = i3 ? f43 : f40;
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f43 * f43) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))))));
 f6 = Math_fround(f6 * f8);
 f7 = Math_fround(f7 * f8);
 f8 = Math_fround(f43 * f8);
 i1 = i53 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i53 = 1;
  return i53 | 0;
 }
 f47 = Math_fround(Math_sqrt(Math_fround(f47)));
 f51 = Math_fround((i3 ? Math_fround(0.0) : f47) - f51);
 f50 = Math_fround(f50 + Math_fround(f46 - Math_fround(f52 * f8)));
 f49 = Math_fround(f49 + Math_fround(f45 - Math_fround(f52 * f7)));
 f52 = Math_fround(f48 + Math_fround(f44 - Math_fround(f52 * f6)));
 HEAP32[i1 >> 2] = i2 + 1;
 i22 = i53 + (i2 << 6) | 0;
 HEAPF32[i22 >> 2] = f6;
 HEAPF32[i22 + 4 >> 2] = f7;
 HEAPF32[i22 + 8 >> 2] = f8;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 i22 = i53 + (i2 << 6) + 16 | 0;
 HEAPF32[i22 >> 2] = f52;
 HEAPF32[i22 + 4 >> 2] = f49;
 HEAPF32[i22 + 8 >> 2] = f50;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i53 + (i2 << 6) + 12 >> 2] = f51;
 HEAP32[i53 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i53 + (i2 << 6) + 52 >> 2] = -1;
 i53 = 1;
 return i53 | 0;
}

function __ZN5Umbra15PortalRayTracer7executeERNS_16VisibilityResultE(i106, i1) {
 i106 = i106 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, f115 = f0, f116 = f0, f117 = f0;
 i114 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i108 = i114 + 60 | 0;
 i109 = i114 + 48 | 0;
 i110 = i114 + 32 | 0;
 i111 = i114 + 16 | 0;
 i112 = i114;
 i113 = i106 + 16 | 0;
 if (HEAP8[(HEAP32[i113 >> 2] | 0) + 1365 >> 0] | 0) {
  i113 = 7;
  STACKTOP = i114;
  return i113 | 0;
 }
 i107 = i106 + 88 | 0;
 HEAP32[i107 >> 2] = i1;
 HEAP32[i108 >> 2] = -1;
 i24 = __ZN5Umbra15PortalRayTracer4initERNS_10PortalNodeE(i106, i108) | 0;
 if (!i24) {
  i25 = i106 + 240 | 0;
  i26 = i106 + 20 | 0;
  i27 = i106 + 24 | 0;
  i28 = i106 + 28 | 0;
  i29 = i106 + 32 | 0;
  i30 = i106 + 36 | 0;
  i31 = i106 + 40 | 0;
  i32 = i106 + 44 | 0;
  i33 = i106 + 48 | 0;
  i34 = i106 + 52 | 0;
  i35 = i106 + 56 | 0;
  i36 = i106 + 60 | 0;
  i37 = i106 + 64 | 0;
  i38 = i106 + 68 | 0;
  i39 = i106 + 72 | 0;
  i40 = i106 + 76 | 0;
  i41 = i106 + 80 | 0;
  i42 = i106 + 4 | 0;
  i43 = i106 + 8 | 0;
  i44 = i106 + 12 | 0;
  i16 = i106 + 208 | 0;
  i18 = i106 + 212 | 0;
  i20 = i106 + 216 | 0;
  i15 = i106 + 220 | 0;
  i17 = i106 + 224 | 0;
  i19 = i106 + 228 | 0;
  i45 = i106 + 232 | 0;
  i46 = i106 + 236 | 0;
  i47 = i106 + 148 | 0;
  i48 = i106 + 152 | 0;
  i49 = i106 + 156 | 0;
  i50 = i106 + 132 | 0;
  i51 = i106 + 136 | 0;
  i52 = i106 + 140 | 0;
  i53 = i106 + 164 | 0;
  i54 = i106 + 168 | 0;
  i55 = i106 + 172 | 0;
  i56 = i106 + 180 | 0;
  i57 = i106 + 184 | 0;
  i58 = i106 + 188 | 0;
  i59 = i106 + 4364 | 0;
  i60 = i106 + 272 | 0;
  i61 = i106 + 268 | 0;
  i62 = i106 + 84 | 0;
  i63 = i109 + 4 | 0;
  i64 = i109 + 8 | 0;
  i65 = i110 + 4 | 0;
  i66 = i110 + 8 | 0;
  i67 = i110 + 12 | 0;
  i68 = i106 + 92 | 0;
  i69 = i106 + 96 | 0;
  i70 = i106 + 100 | 0;
  i71 = i110 + 4 | 0;
  i72 = i110 + 8 | 0;
  i73 = i106 + 104 | 0;
  i74 = i106 + 108 | 0;
  i75 = i106 + 112 | 0;
  i76 = i111 + 4 | 0;
  i77 = i111 + 8 | 0;
  i78 = i112 + 4 | 0;
  i79 = i112 + 8 | 0;
  i80 = i112 + 12 | 0;
  i81 = i110 + 4 | 0;
  i82 = i110 + 8 | 0;
  i83 = i111 + 4 | 0;
  i84 = i111 + 8 | 0;
  i85 = i112 + 4 | 0;
  i86 = i112 + 8 | 0;
  i87 = i112 + 12 | 0;
  i88 = i110 + 4 | 0;
  i89 = i110 + 8 | 0;
  i90 = i111 + 4 | 0;
  i91 = i111 + 8 | 0;
  i92 = i112 + 4 | 0;
  i93 = i112 + 8 | 0;
  i94 = i112 + 12 | 0;
  i95 = i110 + 4 | 0;
  i96 = i110 + 8 | 0;
  i97 = i111 + 4 | 0;
  i98 = i111 + 8 | 0;
  i99 = i112 + 4 | 0;
  i100 = i112 + 8 | 0;
  i101 = i112 + 12 | 0;
  i102 = i106 + 144 | 0;
  i103 = i106 + 128 | 0;
  i104 = i106 + 160 | 0;
  i105 = i106 + 176 | 0;
  i14 = 0;
  do {
   f21 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i14 | 0) + Math_fround(.5)) * Math_fround(.015625)) * Math_fround(2.0)) + Math_fround(-1.0));
   i22 = i14 >>> 2 << 8;
   i23 = i14 << 2 & 12;
   i13 = 0;
   do {
    f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i13 | 0) + Math_fround(.5)) * Math_fround(.015625)) * Math_fround(2.0)) + Math_fround(-1.0));
    f5 = Math_fround(HEAPF32[i25 >> 2]);
    f2 = Math_fround(f7 * Math_fround(HEAPF32[i26 >> 2]));
    f2 = Math_fround(f2 + Math_fround(f21 * Math_fround(HEAPF32[i27 >> 2])));
    f2 = Math_fround(f2 + Math_fround(f5 * Math_fround(HEAPF32[i28 >> 2])));
    f2 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + f2);
    f4 = Math_fround(f7 * Math_fround(HEAPF32[i30 >> 2]));
    f4 = Math_fround(f4 + Math_fround(f21 * Math_fround(HEAPF32[i31 >> 2])));
    f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i32 >> 2])));
    f4 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) + f4);
    f6 = Math_fround(f7 * Math_fround(HEAPF32[i34 >> 2]));
    f6 = Math_fround(f6 + Math_fround(f21 * Math_fround(HEAPF32[i35 >> 2])));
    f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i36 >> 2])));
    f6 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f6);
    f7 = Math_fround(f7 * Math_fround(HEAPF32[i38 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f21 * Math_fround(HEAPF32[i39 >> 2])));
    f5 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i40 >> 2])));
    f5 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f5);
    f2 = Math_fround(f2 / f5);
    f4 = Math_fround(f4 / f5);
    f5 = Math_fround(f6 / f5);
    f6 = Math_fround(HEAPF32[i42 >> 2]);
    f2 = Math_fround(f2 - f6);
    f7 = Math_fround(HEAPF32[i43 >> 2]);
    f4 = Math_fround(f4 - f7);
    f8 = Math_fround(HEAPF32[i44 >> 2]);
    f5 = Math_fround(f5 - f8);
    HEAPF32[i16 >> 2] = f2;
    HEAPF32[i18 >> 2] = f4;
    HEAPF32[i20 >> 2] = f5;
    f9 = Math_fround(Math_fround(1.0) / f2);
    f10 = Math_fround(Math_fround(1.0) / f4);
    f11 = Math_fround(Math_fround(1.0) / f5);
    HEAPF32[i15 >> 2] = f9;
    HEAPF32[i17 >> 2] = f10;
    HEAPF32[i19 >> 2] = f11;
    f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(f5 * f5)));
    HEAPF32[i45 >> 2] = f12;
    HEAPF32[i46 >> 2] = Math_fround(0.0);
    HEAPF32[i102 >> 2] = f2;
    HEAPF32[i47 >> 2] = f4;
    HEAPF32[i48 >> 2] = f5;
    HEAPF32[i49 >> 2] = Math_fround(1.0);
    HEAPF32[i103 >> 2] = f6;
    HEAPF32[i50 >> 2] = f7;
    HEAPF32[i51 >> 2] = f8;
    HEAPF32[i52 >> 2] = Math_fround(1.0);
    HEAPF32[i104 >> 2] = f9;
    HEAPF32[i53 >> 2] = f10;
    HEAPF32[i54 >> 2] = f11;
    HEAPF32[i55 >> 2] = Math_fround(1.0);
    HEAPF32[i105 >> 2] = f12;
    HEAPF32[i56 >> 2] = f12;
    HEAPF32[i57 >> 2] = f12;
    HEAPF32[i58 >> 2] = Math_fround(1.0);
    HEAP32[i59 >> 2] = 1;
    HEAP32[i60 >> 2] = HEAP32[i108 >> 2];
    HEAP32[i60 + 4 >> 2] = HEAP32[i108 + 4 >> 2];
    HEAP32[i60 + 8 >> 2] = HEAP32[i108 + 8 >> 2];
    HEAPF32[i61 >> 2] = Math_fround(0.0);
    i1 = HEAP32[HEAP32[HEAP32[i106 >> 2] >> 2] >> 2] | 0;
    i3 = HEAP32[i1 + 136 >> 2] | 0;
    if (!i3) i1 = 0; else i1 = (HEAP32[i1 + i3 + (HEAP32[i1 + 144 >> 2] << 2) >> 2] | 0) + 31 >> 5 << 2;
    _memset(HEAP32[i62 >> 2] | 0, 0, i1 | 0) | 0;
    __ZN5Umbra15PortalRayTracer5traceEv(i106);
    i1 = HEAP32[(HEAP32[i107 >> 2] | 0) + 24 >> 2] | 0;
    if (i1 | 0) {
     f2 = Math_fround(HEAPF32[i46 >> 2]);
     if (!(f2 >= Math_fround(1.0))) {
      i3 = HEAP32[i113 >> 2] | 0;
      f10 = Math_fround(f2 * Math_fround(HEAPF32[i16 >> 2]));
      f11 = Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2]));
      f2 = Math_fround(f2 * Math_fround(HEAPF32[i20 >> 2]));
      f10 = Math_fround(f10 + Math_fround(HEAPF32[i42 >> 2]));
      f11 = Math_fround(f11 + Math_fround(HEAPF32[i43 >> 2]));
      f2 = Math_fround(f2 + Math_fround(HEAPF32[i44 >> 2]));
      f12 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 32 >> 2]));
      f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i3 + 36 >> 2])));
      f12 = Math_fround(f12 + Math_fround(f2 * Math_fround(HEAPF32[i3 + 40 >> 2])));
      f12 = Math_fround(Math_fround(HEAPF32[i3 + 44 >> 2]) + f12);
      f10 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 48 >> 2]));
      f11 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i3 + 52 >> 2])));
      f2 = Math_fround(f11 + Math_fround(f2 * Math_fround(HEAPF32[i3 + 56 >> 2])));
      f2 = Math_fround(f12 / Math_fround(Math_fround(HEAPF32[i3 + 60 >> 2]) + f2));
      i3 = f2 <= Math_fround(0.0);
      f2 = i3 ? Math_fround(0.0) : f2;
     } else f2 = Math_fround(1.0);
     HEAPF32[(HEAP32[i1 + 1408 >> 2] | 0) + ((i13 & 3 | i23 | (i13 >>> 2 << 4) + i22) << 2) >> 2] = f2;
    }
    i1 = HEAP32[i106 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) if (HEAP32[i1 + 32 >> 2] & 64 | 0) {
     f2 = Math_fround(HEAPF32[i46 >> 2]);
     f12 = Math_fround(f2 * Math_fround(HEAPF32[i16 >> 2]));
     f11 = Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2]));
     f2 = Math_fround(f2 * Math_fround(HEAPF32[i20 >> 2]));
     f12 = Math_fround(f12 + Math_fround(HEAPF32[i42 >> 2]));
     f11 = Math_fround(f11 + Math_fround(HEAPF32[i43 >> 2]));
     f2 = Math_fround(f2 + Math_fround(HEAPF32[i44 >> 2]));
     HEAPF32[i109 >> 2] = f12;
     HEAPF32[i63 >> 2] = f11;
     HEAPF32[i64 >> 2] = f2;
     HEAPF32[i110 >> 2] = Math_fround(1.0);
     HEAPF32[i65 >> 2] = Math_fround(1.0);
     HEAPF32[i66 >> 2] = Math_fround(1.0);
     HEAPF32[i67 >> 2] = Math_fround(1.0);
     mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i42 | 0, i109 | 0, i110 | 0);
     i1 = HEAP32[i106 >> 2] | 0;
     f2 = Math_fround(HEAPF32[i46 >> 2]);
     f11 = Math_fround(HEAPF32[i109 >> 2]);
     f12 = Math_fround(HEAPF32[i63 >> 2]);
     f10 = Math_fround(HEAPF32[i64 >> 2]);
     f5 = Math_fround(HEAPF32[i68 >> 2]);
     f6 = Math_fround(f2 * f5);
     f7 = Math_fround(HEAPF32[i69 >> 2]);
     f117 = Math_fround(f2 * f7);
     f9 = Math_fround(HEAPF32[i70 >> 2]);
     f117 = Math_fround(f117 + f12);
     f8 = Math_fround(Math_fround(f2 * f9) + f10);
     HEAPF32[i110 >> 2] = Math_fround(f6 + f11);
     HEAPF32[i71 >> 2] = f117;
     HEAPF32[i72 >> 2] = f8;
     f8 = Math_fround(HEAPF32[i73 >> 2]);
     f117 = Math_fround(f2 * f8);
     f6 = Math_fround(HEAPF32[i74 >> 2]);
     f116 = Math_fround(f2 * f6);
     f4 = Math_fround(HEAPF32[i75 >> 2]);
     f116 = Math_fround(f116 + f12);
     f115 = Math_fround(Math_fround(f2 * f4) + f10);
     HEAPF32[i111 >> 2] = Math_fround(f117 + f11);
     HEAPF32[i76 >> 2] = f116;
     HEAPF32[i77 >> 2] = f115;
     HEAPF32[i112 >> 2] = Math_fround(.5);
     HEAPF32[i78 >> 2] = Math_fround(1.0);
     HEAPF32[i79 >> 2] = Math_fround(.5);
     HEAPF32[i80 >> 2] = Math_fround(1.0);
     i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
     if (i3) {
      mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i110 | 0, i111 | 0, i112 | 0);
      f2 = Math_fround(HEAPF32[i46 >> 2]);
      f5 = Math_fround(HEAPF32[i68 >> 2]);
      f7 = Math_fround(HEAPF32[i69 >> 2]);
      f9 = Math_fround(HEAPF32[i70 >> 2]);
      f11 = Math_fround(HEAPF32[i109 >> 2]);
      f12 = Math_fround(HEAPF32[i63 >> 2]);
      f10 = Math_fround(HEAPF32[i64 >> 2]);
      f8 = Math_fround(HEAPF32[i73 >> 2]);
      f6 = Math_fround(HEAPF32[i74 >> 2]);
      f4 = Math_fround(HEAPF32[i75 >> 2]);
      i1 = HEAP32[i106 >> 2] | 0;
     }
     f117 = Math_fround(f12 - Math_fround(f2 * f7));
     f116 = Math_fround(f10 - Math_fround(f2 * f9));
     HEAPF32[i110 >> 2] = Math_fround(f11 - Math_fround(f2 * f5));
     HEAPF32[i81 >> 2] = f117;
     HEAPF32[i82 >> 2] = f116;
     f116 = Math_fround(f12 - Math_fround(f2 * f6));
     f117 = Math_fround(f10 - Math_fround(f2 * f4));
     HEAPF32[i111 >> 2] = Math_fround(f11 - Math_fround(f2 * f8));
     HEAPF32[i83 >> 2] = f116;
     HEAPF32[i84 >> 2] = f117;
     HEAPF32[i112 >> 2] = Math_fround(.5);
     HEAPF32[i85 >> 2] = Math_fround(1.0);
     HEAPF32[i86 >> 2] = Math_fround(.5);
     HEAPF32[i87 >> 2] = Math_fround(1.0);
     i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
     if (i3) {
      mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i110 | 0, i111 | 0, i112 | 0);
      f2 = Math_fround(HEAPF32[i46 >> 2]);
      f5 = Math_fround(HEAPF32[i68 >> 2]);
      f7 = Math_fround(HEAPF32[i69 >> 2]);
      f9 = Math_fround(HEAPF32[i70 >> 2]);
      f11 = Math_fround(HEAPF32[i109 >> 2]);
      f12 = Math_fround(HEAPF32[i63 >> 2]);
      f10 = Math_fround(HEAPF32[i64 >> 2]);
      f8 = Math_fround(HEAPF32[i73 >> 2]);
      f6 = Math_fround(HEAPF32[i74 >> 2]);
      f4 = Math_fround(HEAPF32[i75 >> 2]);
      i1 = HEAP32[i106 >> 2] | 0;
     }
     f117 = Math_fround(Math_fround(f2 * f7) + f12);
     f116 = Math_fround(Math_fround(f2 * f9) + f10);
     HEAPF32[i110 >> 2] = Math_fround(Math_fround(f2 * f5) + f11);
     HEAPF32[i88 >> 2] = f117;
     HEAPF32[i89 >> 2] = f116;
     f116 = Math_fround(f12 - Math_fround(f2 * f6));
     f117 = Math_fround(f10 - Math_fround(f2 * f4));
     HEAPF32[i111 >> 2] = Math_fround(f11 - Math_fround(f2 * f8));
     HEAPF32[i90 >> 2] = f116;
     HEAPF32[i91 >> 2] = f117;
     HEAPF32[i112 >> 2] = Math_fround(.5);
     HEAPF32[i92 >> 2] = Math_fround(1.0);
     HEAPF32[i93 >> 2] = Math_fround(.5);
     HEAPF32[i94 >> 2] = Math_fround(1.0);
     i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
     if (i3) {
      mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i110 | 0, i111 | 0, i112 | 0);
      f2 = Math_fround(HEAPF32[i46 >> 2]);
      f5 = Math_fround(HEAPF32[i68 >> 2]);
      f7 = Math_fround(HEAPF32[i69 >> 2]);
      f9 = Math_fround(HEAPF32[i70 >> 2]);
      f11 = Math_fround(HEAPF32[i109 >> 2]);
      f12 = Math_fround(HEAPF32[i63 >> 2]);
      f10 = Math_fround(HEAPF32[i64 >> 2]);
      f8 = Math_fround(HEAPF32[i73 >> 2]);
      f6 = Math_fround(HEAPF32[i74 >> 2]);
      f4 = Math_fround(HEAPF32[i75 >> 2]);
      i1 = HEAP32[i106 >> 2] | 0;
     }
     f117 = Math_fround(f12 - Math_fround(f2 * f7));
     f116 = Math_fround(f10 - Math_fround(f2 * f9));
     HEAPF32[i110 >> 2] = Math_fround(f11 - Math_fround(f2 * f5));
     HEAPF32[i95 >> 2] = f117;
     HEAPF32[i96 >> 2] = f116;
     f116 = Math_fround(Math_fround(f2 * f6) + f12);
     f117 = Math_fround(Math_fround(f2 * f4) + f10);
     HEAPF32[i111 >> 2] = Math_fround(Math_fround(f2 * f8) + f11);
     HEAPF32[i97 >> 2] = f116;
     HEAPF32[i98 >> 2] = f117;
     HEAPF32[i112 >> 2] = Math_fround(.5);
     HEAPF32[i99 >> 2] = Math_fround(1.0);
     HEAPF32[i100 >> 2] = Math_fround(.5);
     HEAPF32[i101 >> 2] = Math_fround(1.0);
     i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i110 | 0, i111 | 0, i112 | 0);
    }
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) != 64);
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != 64);
 }
 i113 = i24;
 STACKTOP = i114;
 return i113 | 0;
}

function __ZN7mecanim13ValueArrayAddEPKNS_10ValueArrayES2_PKNS_14ValueArrayMaskEfbPS0_PS3_(i26, i25, i24, f23, i22, i27, i28) {
 i26 = i26 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 f23 = Math_fround(f23);
 i22 = i22 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i20 = HEAP32[i25 >> 2] | 0;
 L1 : do if (i20 | 0) {
  i19 = i24 + 4 | 0;
  i8 = i25 + 4 | 0;
  i9 = i8;
  i10 = i28 + 4 | 0;
  i11 = i10;
  i15 = i27 + 4 | 0;
  i16 = i15;
  i17 = i26 + 4 | 0;
  i18 = i17;
  i6 = f23 < Math_fround(1.0);
  i19 = (HEAP32[i19 >> 2] | 0) + i19 | 0;
  if (i22) {
   i1 = 0;
   while (1) {
    if (HEAP8[i19 + i1 >> 0] | 0) {
     i3 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
     f12 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
     f13 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
     i3 = (HEAP32[i10 >> 2] | 0) + i11 + i1 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      i4 = HEAP32[i15 >> 2] | 0;
      i2 = i4 + i16 | 0;
     } else {
      i2 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
      i4 = HEAP32[i15 >> 2] | 0;
     }
     i7 = i2;
     f29 = Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 8 >> 2]);
     f30 = Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 4 >> 2]);
     f13 = Math_fround(Math_fround(f13 * f23) + f30);
     f14 = Math_fround(Math_fround(f14 * f23) + f29);
     i21 = i4 + i16 | 0;
     HEAPF32[i21 + (i1 * 12 | 0) >> 2] = Math_fround(Math_fround(f12 * f23) + Math_fround(HEAPF32[i7 + (i1 * 12 | 0) >> 2]));
     HEAPF32[i21 + (i1 * 12 | 0) + 4 >> 2] = f13;
     HEAPF32[i21 + (i1 * 12 | 0) + 8 >> 2] = f14;
     HEAP8[i3 >> 0] = 0;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i20 | 0)) break L1;
   }
  } else i5 = 0;
  do {
   if (HEAP8[i19 + i5 >> 0] | 0) {
    i1 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
    i3 = HEAP32[i1 + (i5 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] | 0;
    i1 = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    if (i6) {
     if (!(HEAP8[i7 + i11 + i5 >> 0] | 0)) i2 = (HEAP32[i15 >> 2] | 0) + i16 | 0; else i2 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
     f30 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
     f29 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
     f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = Math_fround(f14 + Math_fround(Math_fround(f12 - f14) * f23));
     f29 = Math_fround(f29 + Math_fround(Math_fround(f13 - f29) * f23));
     f30 = Math_fround(f30 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30) * f23));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    } else i2 = i4;
    i21 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
    HEAP32[i21 + (i5 * 12 | 0) >> 2] = i3;
    HEAP32[i21 + (i5 * 12 | 0) + 4 >> 2] = i2;
    HEAP32[i21 + (i5 * 12 | 0) + 8 >> 2] = i1;
    HEAP8[i7 + i11 + i5 >> 0] = 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i20 | 0));
 } while (0);
 i8 = HEAP32[i25 + 8 >> 2] | 0;
 if (i8 | 0) {
  i21 = i24 + 12 | 0;
  i9 = i25 + 12 | 0;
  i10 = i9;
  i11 = i28 + 12 | 0;
  i15 = i11;
  i16 = i27 + 12 | 0;
  i17 = i16;
  i18 = i26 + 12 | 0;
  i19 = i18;
  i20 = f23 < Math_fround(1.0);
  i21 = (HEAP32[i21 >> 2] | 0) + i21 | 0;
  i6 = 0;
  do {
   if (HEAP8[i21 + i6 >> 0] | 0) {
    i5 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    i3 = HEAP32[i5 + (i6 << 4) >> 2] | 0;
    i1 = HEAP32[i5 + (i6 << 4) + 4 >> 2] | 0;
    i4 = HEAP32[i5 + (i6 << 4) + 8 >> 2] | 0;
    i5 = HEAP32[i5 + (i6 << 4) + 12 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    if (i22) {
     if (!(HEAP8[i7 + i15 + i6 >> 0] | 0)) i2 = (HEAP32[i16 >> 2] | 0) + i17 | 0; else i2 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
     f32 = Math_fround(HEAPF32[i2 + (i6 << 4) + 12 >> 2]);
     f34 = Math_fround(HEAPF32[i2 + (i6 << 4) + 8 >> 2]);
     f12 = Math_fround(HEAPF32[i2 + (i6 << 4) + 4 >> 2]);
     f36 = Math_fround(HEAPF32[i2 + (i6 << 4) >> 2]);
     f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
     f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
     f35 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
     f13 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f31 * f31)) + Math_fround(Math_fround(f35 * f35) + Math_fround(f13 * f13))))));
     f33 = Math_fround(f33 * f29);
     f31 = Math_fround(f31 * f29);
     f35 = Math_fround(f35 * f29);
     f29 = Math_fround(f13 * f29);
     f13 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f33) - Math_fround(f32 * f35)) - Math_fround(f34 * f29)) - Math_fround(f36 * f31));
     f30 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f29) - Math_fround(f36 * f33)) - Math_fround(f34 * f35)) - Math_fround(f12 * f31));
     f14 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f31) - Math_fround(f12 * f35)) - Math_fround(f32 * f33)) - Math_fround(f36 * f29));
     f29 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33)) - Math_fround(f32 * f31)) - Math_fround(f12 * f29));
     i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
     i3 = i3 ^ -2147483648;
     i4 = i4 ^ -2147483648;
     i2 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    } else if (i20) {
     if (!(HEAP8[i7 + i15 + i6 >> 0] | 0)) i2 = (HEAP32[i16 >> 2] | 0) + i17 | 0; else i2 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
     f36 = Math_fround(HEAPF32[i2 + (i6 << 4) + 12 >> 2]);
     f32 = Math_fround(HEAPF32[i2 + (i6 << 4) + 8 >> 2]);
     f31 = Math_fround(HEAPF32[i2 + (i6 << 4) + 4 >> 2]);
     f30 = Math_fround(HEAPF32[i2 + (i6 << 4) >> 2]);
     f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f30);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f31);
     f35 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f32);
     f33 = Math_fround(Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f36) + f35) + Math_fround(f34 + f33));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
     f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ^ i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
     f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ^ i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f31);
     f35 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f32);
     f33 = Math_fround(f30 + Math_fround(f33 * f23));
     f34 = Math_fround(f31 + Math_fround(f34 * f23));
     f35 = Math_fround(f32 + Math_fround(f35 * f23));
     f36 = Math_fround(f36 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i2 ^ i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f36) * f23));
     f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36))))));
     f33 = Math_fround(f32 * f33);
     f34 = Math_fround(f32 * f34);
     f35 = Math_fround(f32 * f35);
     f36 = Math_fround(f32 * f36);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    } else i2 = i5;
    i5 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
    HEAP32[i5 + (i6 << 4) >> 2] = i3;
    HEAP32[i5 + (i6 << 4) + 4 >> 2] = i1;
    HEAP32[i5 + (i6 << 4) + 8 >> 2] = i4;
    HEAP32[i5 + (i6 << 4) + 12 >> 2] = i2;
    HEAP8[i7 + i15 + i6 >> 0] = 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 }
 i8 = HEAP32[i25 + 16 >> 2] | 0;
 L47 : do if (i8 | 0) {
  i20 = i24 + 20 | 0;
  i9 = i25 + 20 | 0;
  i10 = i9;
  i11 = i28 + 20 | 0;
  i15 = i11;
  i16 = i27 + 20 | 0;
  i17 = i16;
  i18 = i26 + 20 | 0;
  i19 = i18;
  i6 = f23 < Math_fround(1.0);
  i20 = (HEAP32[i20 >> 2] | 0) + i20 | 0;
  if (i22) {
   i1 = 0;
   while (1) {
    if (HEAP8[i20 + i1 >> 0] | 0) {
     i3 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
     f12 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
     f13 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
     i3 = (HEAP32[i11 >> 2] | 0) + i15 + i1 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      i4 = HEAP32[i16 >> 2] | 0;
      i2 = i4 + i17 | 0;
     } else {
      i2 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
      i4 = HEAP32[i16 >> 2] | 0;
     }
     i7 = i2;
     f36 = Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 8 >> 2]);
     f35 = Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 4 >> 2]);
     f35 = Math_fround(Math_fround(f13 * f23) + f35);
     f36 = Math_fround(Math_fround(f14 * f23) + f36);
     i21 = i4 + i17 | 0;
     HEAPF32[i21 + (i1 * 12 | 0) >> 2] = Math_fround(Math_fround(f12 * f23) + Math_fround(HEAPF32[i7 + (i1 * 12 | 0) >> 2]));
     HEAPF32[i21 + (i1 * 12 | 0) + 4 >> 2] = f35;
     HEAPF32[i21 + (i1 * 12 | 0) + 8 >> 2] = f36;
     HEAP8[i3 >> 0] = 0;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i8 | 0)) break L47;
   }
  } else i5 = 0;
  do {
   if (HEAP8[i20 + i5 >> 0] | 0) {
    i1 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    i3 = HEAP32[i1 + (i5 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] | 0;
    i1 = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    if (i6) {
     if (!(HEAP8[i7 + i15 + i5 >> 0] | 0)) i2 = (HEAP32[i16 >> 2] | 0) + i17 | 0; else i2 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
     f36 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
     f35 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
     f34 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
     f32 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f33 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f34 = Math_fround(f34 + Math_fround(Math_fround(f32 - f34) * f23));
     f35 = Math_fround(f35 + Math_fround(Math_fround(f33 - f35) * f23));
     f36 = Math_fround(f36 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f36) * f23));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    } else i2 = i4;
    i21 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
    HEAP32[i21 + (i5 * 12 | 0) >> 2] = i3;
    HEAP32[i21 + (i5 * 12 | 0) + 4 >> 2] = i2;
    HEAP32[i21 + (i5 * 12 | 0) + 8 >> 2] = i1;
    HEAP8[i7 + i15 + i5 >> 0] = 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 } while (0);
 i6 = HEAP32[i25 + 24 >> 2] | 0;
 L72 : do if (i6 | 0) {
  i7 = i24 + 28 | 0;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i8 = i25 + 28 | 0;
  i9 = i8;
  i10 = i28 + 28 | 0;
  i11 = i10;
  i15 = i27 + 28 | 0;
  i16 = i15;
  i17 = i26 + 28 | 0;
  i18 = i17;
  i5 = f23 < Math_fround(1.0);
  f12 = Math_fround(Math_fround(1.0) - f23);
  if (i22) {
   i1 = 0;
   while (1) {
    if (HEAP8[i7 + i1 >> 0] | 0) {
     f12 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + i9 + (i1 << 2) >> 2]);
     i3 = (HEAP32[i10 >> 2] | 0) + i11 + i1 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      i4 = HEAP32[i15 >> 2] | 0;
      i2 = i4 + i16 | 0;
     } else {
      i2 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
      i4 = HEAP32[i15 >> 2] | 0;
     }
     HEAPF32[i4 + i16 + (i1 << 2) >> 2] = Math_fround(Math_fround(f12 * f23) + Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]));
     HEAP8[i3 >> 0] = 0;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i6 | 0)) break L72;
   }
  } else i3 = 0;
  do {
   if (HEAP8[i7 + i3 >> 0] | 0) {
    i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i3 << 2) >> 2] | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    if (i5) {
     if (!(HEAP8[i4 + i11 + i3 >> 0] | 0)) i2 = (HEAP32[i15 >> 2] | 0) + i16 | 0; else i2 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
     f36 = Math_fround(f12 * Math_fround(HEAPF32[i2 + (i3 << 2) >> 2]));
     f36 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23) + f36);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    }
    HEAP32[(HEAP32[i15 >> 2] | 0) + i16 + (i3 << 2) >> 2] = i1;
    HEAP8[i4 + i11 + i3 >> 0] = 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i6 | 0));
 } while (0);
 i22 = f23 > Math_fround(.5);
 i15 = HEAP32[i25 + 32 >> 2] | 0;
 i1 = (i15 | 0) != 0;
 if (i22) {
  if (!i1) return;
  i8 = i24 + 36 | 0;
  i9 = i8;
  i6 = i25 + 36 | 0;
  i7 = i6;
  i4 = i27 + 36 | 0;
  i5 = i4;
  i2 = i28 + 36 | 0;
  i3 = i2;
  i1 = 0;
  do {
   if (HEAP8[(HEAP32[i8 >> 2] | 0) + i9 + i1 >> 0] | 0) {
    HEAP32[(HEAP32[i4 >> 2] | 0) + i5 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + i7 + (i1 << 2) >> 2];
    HEAP8[(HEAP32[i2 >> 2] | 0) + i3 + i1 >> 0] = 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
  return;
 }
 if (!i1) return;
 i10 = i24 + 36 | 0;
 i11 = i10;
 i8 = i28 + 36 | 0;
 i9 = i8;
 i6 = i27 + 36 | 0;
 i7 = i6;
 i3 = i26 + 36 | 0;
 i4 = i3;
 i1 = 0;
 do {
  if (HEAP8[(HEAP32[i10 >> 2] | 0) + i11 + i1 >> 0] | 0) {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + i9 + i1 >> 0] | 0)) {
    i5 = HEAP32[i6 >> 2] | 0;
    i2 = i5 + i7 | 0;
   } else {
    i2 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i5 + i7 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
   HEAP8[(HEAP32[i8 >> 2] | 0) + i9 + i1 >> 0] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i15 | 0));
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i20, i21, i18, i14, i8, i1) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 16 | 0;
 i24 = i25;
 i22 = __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_(i20, i21, i18, i14, i1) | 0;
 i9 = i8 + 11 | 0;
 i3 = HEAP8[i9 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i7 = i8 + 4 | 0;
 i3 = i2 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
 i12 = i14 + 11 | 0;
 i6 = HEAP8[i12 >> 0] | 0;
 i5 = i6 << 24 >> 24 < 0;
 i13 = i14 + 4 | 0;
 i6 = i5 ? HEAP32[i13 >> 2] | 0 : i6 & 255;
 i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 if (!i1) i19 = 3; else {
  i4 = HEAP32[i14 >> 2] | 0;
  i1 = _memcmp(i2 ? HEAP32[i8 >> 2] | 0 : i8, i5 ? i4 : i14, i1) | 0;
  if (!i1) i19 = 3; else if ((i1 | 0) < 0) {
   i10 = i14;
   i11 = i14;
   i1 = i4;
  } else {
   i24 = i22;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 3) if (i3 >>> 0 < i6 >>> 0) {
  i10 = i14;
  i11 = i14;
  i1 = HEAP32[i14 >> 2] | 0;
  break;
 } else {
  i24 = i22;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i5 ? i1 : i10;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 9;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i6;
  if (!i6) i1 = i24; else {
   i1 = i24;
   i19 = 11;
  }
 } else i19 = 9;
 if ((i19 | 0) == 9) {
  i17 = i6 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i17 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i6;
  i19 = 11;
 }
 if ((i19 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 do if ((i14 | 0) != (i8 | 0)) {
  i5 = HEAP8[i9 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  i5 = i1 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i12 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i14 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i17 = i2 ? HEAP32[i13 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i14, i3, i5 - i3 | 0, i17, 0, i17, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i11 >> 2] | 0 : i10;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   HEAP32[i13 >> 2] = i5;
   break;
  } else {
   HEAP8[i12 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i8 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i9 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i17 = i2 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i6 - i3 | 0, i17, 0, i17, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   HEAP32[i7 >> 2] = i6;
   break;
  } else {
   HEAP8[i9 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i17 = HEAP32[i24 >> 2] | 0;
  i16 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i23);
 }
 i4 = i22 + 1 | 0;
 i5 = HEAP8[i12 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i13 >> 2] | 0 : i5 & 255;
 i16 = i18 + 11 | 0;
 i7 = HEAP8[i16 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i17 = i18 + 4 | 0;
 i7 = i6 ? HEAP32[i17 >> 2] | 0 : i7 & 255;
 i2 = i7 >>> 0 < i5 >>> 0 ? i7 : i5;
 if (!i2) i19 = 36; else {
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = _memcmp(i3 ? HEAP32[i11 >> 2] | 0 : i10, i6 ? i1 : i18, i2) | 0;
  if (!i2) i19 = 36; else if ((i2 | 0) < 0) {
   i8 = i18;
   i9 = i18;
  } else {
   i24 = i4;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 36) if (i5 >>> 0 < i7 >>> 0) {
  i8 = i18;
  i9 = i18;
  i1 = HEAP32[i18 >> 2] | 0;
  break;
 } else {
  i24 = i4;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i6 ? i1 : i9;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i7 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 42;
 } else if (i7 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i7;
  if (!i7) i1 = i24; else {
   i1 = i24;
   i19 = 44;
  }
 } else i19 = 42;
 if ((i19 | 0) == 42) {
  i15 = i7 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i7;
  i19 = 44;
 }
 if ((i19 | 0) == 44) _memcpy(i1 | 0, i2 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 do if ((i18 | 0) != (i14 | 0)) {
  i5 = HEAP8[i12 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i11 >> 2] | 0 : i10;
  i5 = i1 ? HEAP32[i13 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i16 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i18 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i15 = i2 ? HEAP32[i17 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i18, i3, i5 - i3 | 0, i15, 0, i15, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i9;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i16 >> 0] | 0) < 0) {
   HEAP32[i17 >> 2] = i5;
   break;
  } else {
   HEAP8[i16 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i14 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i12 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i14 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i15 = i2 ? HEAP32[i13 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i14, i3, i6 - i3 | 0, i15, 0, i15, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i11 >> 2] | 0 : i10;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   HEAP32[i13 >> 2] = i6;
   break;
  } else {
   HEAP8[i12 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i15 = HEAP32[i24 >> 2] | 0;
  i14 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i23);
 }
 i4 = i22 + 2 | 0;
 i5 = HEAP8[i16 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i17 >> 2] | 0 : i5 & 255;
 i14 = i21 + 11 | 0;
 i7 = HEAP8[i14 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i15 = i21 + 4 | 0;
 i7 = i6 ? HEAP32[i15 >> 2] | 0 : i7 & 255;
 i2 = i7 >>> 0 < i5 >>> 0 ? i7 : i5;
 if (!i2) i19 = 69; else {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = _memcmp(i3 ? HEAP32[i8 >> 2] | 0 : i9, i6 ? i1 : i21, i2) | 0;
  if (!i2) i19 = 69; else if ((i2 | 0) < 0) {
   i12 = i21;
   i13 = i21;
  } else {
   i24 = i4;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 69) if (i5 >>> 0 < i7 >>> 0) {
  i12 = i21;
  i13 = i21;
  i1 = HEAP32[i21 >> 2] | 0;
  break;
 } else {
  i24 = i4;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i6 ? i1 : i13;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i7 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 75;
 } else if (i7 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i7;
  if (!i7) i1 = i24; else {
   i1 = i24;
   i19 = 77;
  }
 } else i19 = 75;
 if ((i19 | 0) == 75) {
  i11 = i7 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i7;
  i19 = 77;
 }
 if ((i19 | 0) == 77) _memcpy(i1 | 0, i2 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 do if ((i21 | 0) != (i18 | 0)) {
  i5 = HEAP8[i16 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i8 >> 2] | 0 : i9;
  i5 = i1 ? HEAP32[i17 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i13;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i14 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = i5;
   break;
  } else {
   HEAP8[i14 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i18 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i16 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i18 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i17 = i2 ? HEAP32[i17 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i18, i3, i6 - i3 | 0, i17, 0, i17, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i9;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i16 >> 0] | 0) < 0) {
   HEAP32[i17 >> 2] = i6;
   break;
  } else {
   HEAP8[i16 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i18 = HEAP32[i24 >> 2] | 0;
  i17 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i17;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i23);
 }
 i4 = i22 + 3 | 0;
 i5 = HEAP8[i14 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
 i10 = i20 + 11 | 0;
 i9 = HEAP8[i10 >> 0] | 0;
 i6 = i9 << 24 >> 24 < 0;
 i11 = i20 + 4 | 0;
 i9 = i6 ? HEAP32[i11 >> 2] | 0 : i9 & 255;
 i2 = i9 >>> 0 < i5 >>> 0 ? i9 : i5;
 if (!i2) i19 = 102; else {
  i1 = HEAP32[i20 >> 2] | 0;
  i2 = _memcmp(i3 ? HEAP32[i12 >> 2] | 0 : i13, i6 ? i1 : i20, i2) | 0;
  if (!i2) i19 = 102; else if ((i2 | 0) < 0) {
   i7 = i20;
   i8 = i20;
  } else {
   i24 = i4;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 102) if (i5 >>> 0 < i9 >>> 0) {
  i7 = i20;
  i8 = i20;
  i1 = HEAP32[i20 >> 2] | 0;
  break;
 } else {
  i24 = i4;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i6 ? i1 : i8;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i9 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 108;
 } else if (i9 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i9;
  if (!i9) i1 = i24; else {
   i1 = i24;
   i19 = 110;
  }
 } else i19 = 108;
 if ((i19 | 0) == 108) {
  i18 = i9 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i18 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i9;
  i19 = 110;
 }
 if ((i19 | 0) == 110) _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
 HEAP8[i1 + i9 >> 0] = 0;
 do if ((i20 | 0) != (i21 | 0)) {
  i5 = HEAP8[i14 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i12 >> 2] | 0 : i13;
  i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i10 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i20 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i19 = i2 ? HEAP32[i11 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i3, i5 - i3 | 0, i19, 0, i19, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i7 >> 2] | 0 : i8;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i11 >> 2] = i5;
   break;
  } else {
   HEAP8[i10 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i21 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i20 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i3, i6 - i3 | 0, i20, 0, i20, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i13;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i14 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = i6;
   break;
  } else {
   HEAP8[i14 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i21 = HEAP32[i24 >> 2] | 0;
  i24 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i23);
 }
 i24 = i22 + 4 | 0;
 STACKTOP = i25;
 return i24 | 0;
}

function _LZ4_compress_generic(i24, i33, i37, i1, i35, i36, i32, i5, i6) {
 i24 = i24 | 0;
 i33 = i33 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i32 = i32 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0;
 i27 = HEAP32[i24 + 16400 >> 2] | 0;
 i25 = i33 + (0 - i27) | 0;
 i26 = HEAP32[i24 + 16392 >> 2] | 0;
 i27 = i26 + i27 | 0;
 i4 = i33;
 i28 = i27 - i4 | 0;
 i3 = i33 + i1 | 0;
 i2 = i1 + -12 | 0;
 i23 = i33 + i2 | 0;
 i29 = i3 + -5 | 0;
 i30 = i37 + i35 | 0;
 if (i1 >>> 0 > 2113929216) {
  i37 = 0;
  return i37 | 0;
 }
 switch (i5 | 0) {
 case 2:
  {
   i22 = i33 + (0 - (HEAP32[i24 + 16384 >> 2] | 0)) | 0;
   i7 = i33;
   break;
  }
 case 1:
  {
   i22 = i33 + (0 - (HEAP32[i24 + 16384 >> 2] | 0)) | 0;
   i7 = i25;
   break;
  }
 default:
  {
   i22 = i33;
   i7 = i33;
  }
 }
 i31 = (i32 | 0) == 2;
 if ((i1 | 0) > 65546 & i31) {
  i37 = 0;
  return i37 | 0;
 }
 L11 : do if ((i1 | 0) < 13) {
  i1 = i37;
  i6 = i33;
 } else {
  i1 = Math_imul(HEAPU8[i33 >> 0] | HEAPU8[i33 + 1 >> 0] << 8 | HEAPU8[i33 + 2 >> 0] << 16 | HEAPU8[i33 + 3 >> 0] << 24, -1640531535) | 0;
  i21 = i31 ? 19 : 20;
  i1 = i1 >>> i21;
  switch (i32 | 0) {
  case 0:
   {
    HEAP32[i24 + (i1 << 2) >> 2] = i33;
    break;
   }
  case 1:
   {
    HEAP32[i24 + (i1 << 2) >> 2] = i4 - i22;
    break;
   }
  case 2:
   {
    HEAP16[i24 + (i1 << 1) >> 1] = i4 - i22;
    break;
   }
  default:
   {}
  }
  if ((i2 | 0) < 2) {
   i1 = i37;
   i6 = i33;
  } else {
   i20 = (i5 | 0) == 2;
   i15 = (i6 | 0) == 1;
   i14 = i31 ^ 1;
   i16 = i22;
   i17 = (i36 | 0) != 0;
   i18 = i29 + -3 | 0;
   i19 = i29 + -1 | 0;
   i5 = 0;
   i1 = i37;
   i2 = i33;
   i10 = i33 + 2 | 0;
   L19 : while (1) {
    i6 = i2 + 1 | 0;
    i4 = (Math_imul(HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24, -1640531535) | 0) >>> i21;
    L21 : do switch (i32 | 0) {
    case 0:
     {
      i12 = i4;
      i9 = 1;
      i11 = 65;
      while (1) {
       i8 = i24 + (i12 << 2) | 0;
       i4 = HEAP32[i8 >> 2] | 0;
       if (i20) {
        i7 = i4 >>> 0 < i33 >>> 0;
        i5 = i7 ? i28 : 0;
        i7 = i7 ? i26 : i33;
       }
       i12 = (Math_imul(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24, -1640531535) | 0) >>> i21;
       HEAP32[i8 >> 2] = i6;
       if (!(i15 & i4 >>> 0 < i25 >>> 0)) if (!((i4 + 65535 | 0) >>> 0 < i6 >>> 0 & i14)) {
        i13 = i4 + i5 | 0;
        if ((HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24 | 0) == (HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0)) {
         i12 = i5;
         break L21;
        }
       }
       i4 = i10 + i9 | 0;
       if (i4 >>> 0 > i23 >>> 0) {
        i6 = i2;
        break L11;
       } else {
        i6 = i10;
        i10 = i4;
        i9 = i11 >>> 6;
        i11 = i11 + 1 | 0;
       }
      }
     }
    case 1:
     {
      i12 = i4;
      i9 = 1;
      i11 = 65;
      while (1) {
       i8 = i24 + (i12 << 2) | 0;
       i4 = i22 + (HEAP32[i8 >> 2] | 0) | 0;
       if (i20) {
        i7 = i4 >>> 0 < i33 >>> 0;
        i5 = i7 ? i28 : 0;
        i7 = i7 ? i26 : i33;
       }
       i12 = (Math_imul(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24, -1640531535) | 0) >>> i21;
       HEAP32[i8 >> 2] = i6 - i16;
       if (!(i15 & i4 >>> 0 < i25 >>> 0)) if (!((i4 + 65535 | 0) >>> 0 < i6 >>> 0 & i14)) {
        i13 = i4 + i5 | 0;
        if ((HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24 | 0) == (HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0)) {
         i12 = i5;
         break L21;
        }
       }
       i4 = i10 + i9 | 0;
       if (i4 >>> 0 > i23 >>> 0) {
        i6 = i2;
        break L11;
       } else {
        i6 = i10;
        i10 = i4;
        i9 = i11 >>> 6;
        i11 = i11 + 1 | 0;
       }
      }
     }
    default:
     {
      i12 = i4;
      i9 = 1;
      i11 = 65;
      while (1) {
       i8 = i24 + (i12 << 1) | 0;
       i4 = i22 + (HEAPU16[i8 >> 1] | 0) | 0;
       if (i20) {
        i7 = i4 >>> 0 < i33 >>> 0;
        i5 = i7 ? i28 : 0;
        i7 = i7 ? i26 : i33;
       }
       i12 = (Math_imul(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24, -1640531535) | 0) >>> i21;
       if (i31) HEAP16[i8 >> 1] = i6 - i16;
       if (!(i15 & i4 >>> 0 < i25 >>> 0)) if (!((i4 + 65535 | 0) >>> 0 < i6 >>> 0 & i14)) {
        i13 = i4 + i5 | 0;
        if ((HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24 | 0) == (HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24 | 0)) {
         i12 = i5;
         break L21;
        }
       }
       i4 = i10 + i9 | 0;
       if (i4 >>> 0 > i23 >>> 0) {
        i6 = i2;
        break L11;
       } else {
        i6 = i10;
        i9 = i11 >>> 6;
        i11 = i11 + 1 | 0;
        i10 = i4;
       }
      }
     }
    } while (0);
    L53 : do if (i6 >>> 0 > i2 >>> 0 & (i4 + i12 | 0) >>> 0 > i7 >>> 0) {
     i8 = i12 + -1 | 0;
     while (1) {
      i5 = i6 + -1 | 0;
      if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i4 + i8 >> 0] | 0)) {
       i11 = i4;
       break L53;
      }
      i4 = i4 + -1 | 0;
      if (i5 >>> 0 > i2 >>> 0 & (i4 + i12 | 0) >>> 0 > i7 >>> 0) i6 = i5; else {
       i6 = i5;
       i11 = i4;
       break;
      }
     }
    } else i11 = i4; while (0);
    i8 = i6;
    i9 = i2;
    i10 = i8 - i9 | 0;
    i4 = i1 + 1 | 0;
    if (i17) if ((i4 + i10 + 8 + ((i10 >>> 0) / 255 | 0) | 0) >>> 0 > i30 >>> 0) {
     i1 = 0;
     i34 = 117;
     break;
    }
    if (i10 >>> 0 > 14) {
     i5 = i10 + -15 | 0;
     HEAP8[i1 >> 0] = -16;
     if ((i5 | 0) > 254) {
      _memset(i4 | 0, -1, (((i8 + -270 - i9 | 0) >>> 0) / 255 | 0) + 1 | 0) | 0;
      do {
       i4 = i4 + 1 | 0;
       i5 = i5 + -255 | 0;
      } while ((i5 | 0) > 254);
     }
     HEAP8[i4 >> 0] = i5;
     i4 = i4 + 1 | 0;
    } else HEAP8[i1 >> 0] = i10 << 4;
    i5 = i4 + i10 | 0;
    while (1) {
     i10 = i2;
     i8 = i10;
     i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
     i10 = i10 + 4 | 0;
     i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
     i13 = i4;
     i9 = i13;
     HEAP8[i9 >> 0] = i8;
     HEAP8[i9 + 1 >> 0] = i8 >> 8;
     HEAP8[i9 + 2 >> 0] = i8 >> 16;
     HEAP8[i9 + 3 >> 0] = i8 >> 24;
     i13 = i13 + 4 | 0;
     HEAP8[i13 >> 0] = i10;
     HEAP8[i13 + 1 >> 0] = i10 >> 8;
     HEAP8[i13 + 2 >> 0] = i10 >> 16;
     HEAP8[i13 + 3 >> 0] = i10 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i5 >>> 0) {
      i4 = i11;
      i11 = i5;
      break;
     } else i2 = i2 + 8 | 0;
    }
    while (1) {
     i13 = i6 - i4 | 0;
     HEAP8[i11 >> 0] = i13;
     HEAP8[i11 + 1 >> 0] = (i13 & 65535) >>> 8;
     i13 = i11 + 2 | 0;
     if (i20 & (i7 | 0) == (i26 | 0)) {
      i4 = i4 + i12 | 0;
      i10 = i6 + (i27 - i4) | 0;
      i10 = i10 >>> 0 > i29 >>> 0 ? i29 : i10;
      i9 = i6 + 4 | 0;
      i4 = i4 + 4 | 0;
      i8 = i10 + -3 | 0;
      L77 : do if (i8 >>> 0 > i9 >>> 0) {
       i2 = i9;
       while (1) {
        i5 = (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24) ^ (HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24);
        if (i5 | 0) break;
        i2 = i2 + 4 | 0;
        i4 = i4 + 4 | 0;
        if (i2 >>> 0 >= i8 >>> 0) {
         i34 = 54;
         break L77;
        }
       }
       i8 = i2 + ((_llvm_cttz_i32(i5 | 0) | 0) >>> 3) - i9 | 0;
      } else {
       i2 = i9;
       i34 = 54;
      } while (0);
      if ((i34 | 0) == 54) {
       i34 = 0;
       if (i2 >>> 0 < (i10 + -1 | 0) >>> 0) if ((HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8) << 16 >> 16 == (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8) << 16 >> 16) {
        i2 = i2 + 2 | 0;
        i4 = i4 + 2 | 0;
       }
       if (i2 >>> 0 < i10 >>> 0) i2 = (HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0) ? i2 + 1 | 0 : i2;
       i8 = i2 - i9 | 0;
      }
      i6 = i6 + (i8 + 4) | 0;
      if ((i6 | 0) == (i10 | 0)) {
       L93 : do if (i18 >>> 0 > i10 >>> 0) {
        i2 = i10;
        i4 = i33;
        while (1) {
         i5 = (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24) ^ (HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24);
         if (i5 | 0) break;
         i2 = i2 + 4 | 0;
         i4 = i4 + 4 | 0;
         if (i2 >>> 0 >= i18 >>> 0) {
          i34 = 65;
          break L93;
         }
        }
        i2 = i2 + ((_llvm_cttz_i32(i5 | 0) | 0) >>> 3) - i10 | 0;
       } else {
        i2 = i10;
        i4 = i33;
        i34 = 65;
       } while (0);
       if ((i34 | 0) == 65) {
        i34 = 0;
        if (i2 >>> 0 < i19 >>> 0) if ((HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8) << 16 >> 16 == (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8) << 16 >> 16) {
         i2 = i2 + 2 | 0;
         i4 = i4 + 2 | 0;
        }
        if (i2 >>> 0 < i29 >>> 0) i2 = (HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0) ? i2 + 1 | 0 : i2;
        i2 = i2 - i10 | 0;
       }
       i4 = i2 + i8 | 0;
       i6 = i10 + i2 | 0;
      } else i4 = i8;
     } else {
      i8 = i6 + 4 | 0;
      i4 = i4 + 4 | 0;
      L109 : do if (i18 >>> 0 > i8 >>> 0) {
       i2 = i8;
       while (1) {
        i5 = (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24) ^ (HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24);
        if (i5 | 0) break;
        i2 = i2 + 4 | 0;
        i4 = i4 + 4 | 0;
        if (i2 >>> 0 >= i18 >>> 0) {
         i34 = 76;
         break L109;
        }
       }
       i2 = i2 + ((_llvm_cttz_i32(i5 | 0) | 0) >>> 3) - i8 | 0;
      } else {
       i2 = i8;
       i34 = 76;
      } while (0);
      if ((i34 | 0) == 76) {
       i34 = 0;
       if (i2 >>> 0 < i19 >>> 0) if ((HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8) << 16 >> 16 == (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8) << 16 >> 16) {
        i2 = i2 + 2 | 0;
        i4 = i4 + 2 | 0;
       }
       if (i2 >>> 0 < i29 >>> 0) i2 = (HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0) ? i2 + 1 | 0 : i2;
       i2 = i2 - i8 | 0;
      }
      i4 = i2;
      i6 = i6 + (i2 + 4) | 0;
     }
     if (i17) if ((i11 + 8 + (i4 >>> 8) | 0) >>> 0 > i30 >>> 0) {
      i1 = 0;
      i34 = 117;
      break L19;
     }
     i2 = HEAPU8[i1 >> 0] | 0;
     if (i4 >>> 0 > 14) {
      HEAP8[i1 >> 0] = i2 + 15;
      i2 = i4 + -15 | 0;
      if (i2 >>> 0 > 509) {
       _memset(i13 | 0, -1, ((((i4 + -525 | 0) >>> 0) / 510 | 0) << 1) + 2 | 0) | 0;
       i1 = i13;
       do {
        i1 = i1 + 2 | 0;
        i2 = i2 + -510 | 0;
       } while (i2 >>> 0 > 509);
      } else i1 = i13;
      if (i2 >>> 0 > 254) {
       HEAP8[i1 >> 0] = -1;
       i2 = i2 + -255 | 0;
       i1 = i1 + 1 | 0;
      }
      HEAP8[i1 >> 0] = i2;
      i8 = i1 + 1 | 0;
     } else {
      HEAP8[i1 >> 0] = i2 + i4;
      i8 = i13;
     }
     if (i6 >>> 0 > i23 >>> 0) {
      i1 = i8;
      break L11;
     }
     i2 = i6 + -2 | 0;
     i1 = (Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, -1640531535) | 0) >>> i21;
     switch (i32 | 0) {
     case 0:
      {
       HEAP32[i24 + (i1 << 2) >> 2] = i2;
       i4 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
       i2 = i6;
       i1 = i4;
       i4 = HEAP32[i24 + ((Math_imul(i4, -1640531535) | 0) >>> i21 << 2) >> 2] | 0;
       break;
      }
     case 1:
      {
       HEAP32[i24 + (i1 << 2) >> 2] = i2 - i16;
       i4 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
       i2 = i6;
       i1 = i4;
       i4 = i22 + (HEAP32[i24 + ((Math_imul(i4, -1640531535) | 0) >>> i21 << 2) >> 2] | 0) | 0;
       break;
      }
     case 2:
      {
       HEAP16[i24 + (i1 << 1) >> 1] = i2 - i16;
       i34 = 98;
       break;
      }
     default:
      i34 = 98;
     }
     if ((i34 | 0) == 98) {
      i34 = 0;
      i4 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
      i2 = i6;
      i1 = i4;
      i4 = i22 + (HEAPU16[i24 + ((Math_imul(i4, -1640531535) | 0) >>> i21 << 1) >> 1] | 0) | 0;
     }
     if (i20) {
      i7 = i4 >>> 0 < i33 >>> 0;
      i5 = i7 ? i28 : 0;
      i7 = i7 ? i26 : i33;
     } else i5 = i12;
     i1 = (Math_imul(i1, -1640531535) | 0) >>> i21;
     switch (i32 | 0) {
     case 0:
      {
       HEAP32[i24 + (i1 << 2) >> 2] = i6;
       break;
      }
     case 1:
      {
       HEAP32[i24 + (i1 << 2) >> 2] = i6 - i16;
       break;
      }
     case 2:
      {
       HEAP16[i24 + (i1 << 1) >> 1] = i6 - i16;
       break;
      }
     default:
      {}
     }
     if (i15 & i4 >>> 0 < i25 >>> 0 | (i4 + 65535 | 0) >>> 0 < i6 >>> 0) break;
     i13 = i4 + i5 | 0;
     if ((HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24 | 0) != (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0)) break;
     HEAP8[i8 >> 0] = 0;
     i1 = i8;
     i12 = i5;
     i11 = i8 + 1 | 0;
    }
    i10 = i6 + 2 | 0;
    if (i10 >>> 0 > i23 >>> 0) {
     i1 = i8;
     break L11;
    } else {
     i1 = i8;
     i2 = i6;
    }
   }
   if ((i34 | 0) == 117) return i1 | 0;
  }
 } while (0);
 i4 = i6;
 i5 = i3 - i4 | 0;
 if (i36 | 0) if ((1 - i37 + i1 + i5 + (((i5 + 240 | 0) >>> 0) / 255 | 0) | 0) >>> 0 > i35 >>> 0) {
  i37 = 0;
  return i37 | 0;
 }
 if ((i5 | 0) > 14) {
  HEAP8[i1 >> 0] = -16;
  i2 = i5 + -15 | 0;
  i1 = i1 + 1 | 0;
  if ((i2 | 0) > 254) {
   _memset(i1 | 0, -1, (((i3 + -270 - i4 | 0) >>> 0) / 255 | 0) + 1 | 0) | 0;
   do {
    i2 = i2 + -255 | 0;
    i1 = i1 + 1 | 0;
   } while ((i2 | 0) > 254);
  }
  HEAP8[i1 >> 0] = i2;
 } else HEAP8[i1 >> 0] = i5 << 4;
 i36 = i1 + 1 | 0;
 _memcpy(i36 | 0, i6 | 0, i5 | 0) | 0;
 i37 = i36 + i5 - i37 | 0;
 return i37 | 0;
}

function __ZN5Umbra20RuntimeTomeGenerator15generatePortalsEiRNS_5ArrayIiEEPKNS0_6ResultERi(i65, i66, i11, i8, i67) {
 i65 = i65 | 0;
 i66 = i66 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i67 = i67 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i74 + 184 | 0;
 i69 = i74 + 104 | 0;
 i70 = i74 + 16 | 0;
 i71 = i74;
 HEAP32[i67 >> 2] = 0;
 i72 = i65 + 76 | 0;
 i9 = HEAP32[i72 >> 2] | 0;
 i10 = (i9 | 0) > (i66 | 0);
 if (i10) {
  i1 = HEAP32[i65 + 68 >> 2] | 0;
  i5 = HEAP32[i1 + (i66 << 5) >> 2] | 0;
  i1 = i1 + (i66 << 5) + 4 | 0;
  i7 = i5;
  i4 = i5 + 12 | 0;
  i3 = i5 + 16 | 0;
  i2 = i5 + 20 | 0;
  i6 = i5 + 4 | 0;
  i5 = i5 + 8 | 0;
 } else {
  i64 = HEAP32[i65 + 164 >> 2] | 0;
  i5 = i66 - i9 | 0;
  i1 = i64 + ((i66 - i9 | 0) * 40 | 0) + 24 | 0;
  i7 = i64 + (i5 * 40 | 0) | 0;
  i4 = i64 + (i5 * 40 | 0) + 12 | 0;
  i3 = i64 + (i5 * 40 | 0) + 16 | 0;
  i2 = i64 + (i5 * 40 | 0) + 20 | 0;
  i6 = i64 + (i5 * 40 | 0) + 4 | 0;
  i5 = i64 + (i5 * 40 | 0) + 8 | 0;
 }
 i64 = HEAP32[i1 >> 2] | 0;
 f63 = Math_fround(HEAPF32[i2 >> 2]);
 f62 = Math_fround(HEAPF32[i3 >> 2]);
 f61 = Math_fround(HEAPF32[i4 >> 2]);
 f60 = Math_fround(HEAPF32[i5 >> 2]);
 f59 = Math_fround(HEAPF32[i6 >> 2]);
 f58 = Math_fround(HEAPF32[i7 >> 2]);
 do if (!(HEAP32[i65 + 256 >> 2] | 0)) {
  i4 = -1;
  i1 = 0;
 } else {
  i2 = HEAP32[(HEAP32[i65 + 248 >> 2] | 0) + (i64 << 2) >> 2] | 0;
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 0 : (HEAP32[i8 + 4 >> 2] | 0) + i1 | 0;
  if ((i2 | 0) != -1) if (!(HEAP32[i1 + (i2 << 5) + 8 >> 2] | 0)) {
   i4 = -1;
   i1 = 0;
   break;
  }
  i4 = i2;
  i1 = i1 + (i2 << 5) | 0;
 } while (0);
 if (!i10) {
  i2 = HEAP32[(HEAP32[i65 + 164 >> 2] | 0) + ((i66 - i9 | 0) * 40 | 0) + 28 >> 2] | 0;
  if (i2 | 0) {
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i67 >> 2] = i2 & i1;
   i1 = i2 & ~i1;
   i2 = i65 + 268 | 0;
   i3 = i65 + 284 | 0;
   if (i1 & 1 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 0);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 0);
   }
   if (i1 & 2 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 1);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 1);
   }
   if (i1 & 4 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 2);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 2);
   }
   if (i1 & 8 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 3);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 3);
   }
   if (i1 & 16 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 4);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 4);
   }
   if (i1 & 32 | 0) {
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, 5);
    __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i69, i2, i3, i68, 5);
   }
  }
 }
 i57 = i11 + 12 | 0;
 i2 = HEAP32[i57 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i74;
  return;
 }
 i55 = i11 + 4 | 0;
 i56 = i65 + 148 | 0;
 i18 = (i4 | 0) == -1;
 i19 = i65 + 264 | 0;
 i20 = i65 + 68 | 0;
 i21 = i69 + 12 | 0;
 i22 = i70 + 12 | 0;
 i23 = i69 + 12 | 0;
 i24 = i70 + 12 | 0;
 i25 = i70 + 16 | 0;
 i26 = i70 + 4 | 0;
 i27 = i70 + 20 | 0;
 i28 = i70 + 8 | 0;
 i29 = i68 + 4 | 0;
 i30 = i68 + 8 | 0;
 i31 = i68 + 4 | 0;
 i32 = i68 + 8 | 0;
 i33 = i68 + 12 | 0;
 i34 = i71 + 4 | 0;
 i35 = i71 + 8 | 0;
 i36 = i71 + 12 | 0;
 i37 = i65 + 268 | 0;
 i38 = i65 + 288 | 0;
 i39 = i69 + 4 | 0;
 i40 = i24 + 4 | 0;
 i41 = i23 + 4 | 0;
 i42 = i70 + 4 | 0;
 i43 = i69 + 8 | 0;
 i44 = i24 + 8 | 0;
 i45 = i23 + 8 | 0;
 i46 = i70 + 8 | 0;
 i47 = i65 + 164 | 0;
 i48 = i69 + 4 | 0;
 i49 = i69 + 8 | 0;
 i50 = i69 + 16 | 0;
 i51 = i69 + 20 | 0;
 i52 = i65 + 260 | 0;
 i53 = i65 + 284 | 0;
 i54 = i65 + 248 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i55 >> 2] | 0;
  i4 = i3 + (i1 << 2) | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i56 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  do if (i18) i73 = 30; else if ((HEAP32[(HEAP32[i54 >> 2] | 0) + (i9 << 2) >> 2] | 0) == -1) i73 = 30; else {
   i2 = HEAP32[i72 >> 2] | 0;
   if ((i8 | 0) < (i2 | 0)) {
    i5 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i8 << 5) >> 2] | 0;
    i7 = i5;
    i3 = i5 + 16 | 0;
    i2 = i5 + 20 | 0;
    i6 = i5 + 4 | 0;
    i4 = i5 + 8 | 0;
    i5 = i5 + 12 | 0;
   } else {
    i5 = i8 - i2 | 0;
    i17 = HEAP32[i47 >> 2] | 0;
    i7 = i17 + (i5 * 40 | 0) | 0;
    i3 = i17 + (i5 * 40 | 0) + 16 | 0;
    i2 = i17 + (i5 * 40 | 0) + 20 | 0;
    i6 = i17 + (i5 * 40 | 0) + 4 | 0;
    i4 = i17 + (i5 * 40 | 0) + 8 | 0;
    i5 = i17 + (i5 * 40 | 0) + 12 | 0;
   }
   f15 = Math_fround(HEAPF32[i2 >> 2]);
   f14 = Math_fround(HEAPF32[i3 >> 2]);
   f75 = Math_fround(HEAPF32[i5 >> 2]);
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   f12 = Math_fround(HEAPF32[i6 >> 2]);
   if (f58 == f75) i2 = 0; else if (f61 == Math_fround(HEAPF32[i7 >> 2])) i2 = 1; else if (f59 == f14) i2 = 2; else if (f62 == f12) i2 = 3; else if (f60 == f15) i2 = 4; else if (f63 == f13) i2 = 5; else break;
   HEAP32[i67 >> 2] = HEAP32[i67 >> 2] | 1 << i2;
  } while (0);
  do if ((i73 | 0) == 30) {
   i73 = 0;
   HEAP32[i4 >> 2] = HEAP32[i3 + (i2 + -1 << 2) >> 2];
   HEAP32[i57 >> 2] = (HEAP32[i57 >> 2] | 0) + -1;
   i1 = i1 + -1 | 0;
   if ((i9 | 0) >= (i64 | 0)) {
    i2 = HEAP32[i72 >> 2] | 0;
    if ((i8 | 0) < (i2 | 0)) {
     i3 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i8 << 5) >> 2] | 0;
     i7 = i3;
     i4 = i3 + 12 | 0;
     i5 = i3 + 16 | 0;
     i6 = i3 + 20 | 0;
     i2 = i3 + 4 | 0;
     i3 = i3 + 8 | 0;
    } else {
     i3 = i8 - i2 | 0;
     i17 = HEAP32[i47 >> 2] | 0;
     i7 = i17 + (i3 * 40 | 0) | 0;
     i4 = i17 + (i3 * 40 | 0) + 12 | 0;
     i5 = i17 + (i3 * 40 | 0) + 16 | 0;
     i6 = i17 + (i3 * 40 | 0) + 20 | 0;
     i2 = i17 + (i3 * 40 | 0) + 4 | 0;
     i3 = i17 + (i3 * 40 | 0) + 8 | 0;
    }
    f15 = Math_fround(HEAPF32[i2 >> 2]);
    f14 = Math_fround(HEAPF32[i3 >> 2]);
    f75 = Math_fround(HEAPF32[i4 >> 2]);
    f13 = Math_fround(HEAPF32[i5 >> 2]);
    f12 = Math_fround(HEAPF32[i6 >> 2]);
    if (f58 == f75) i2 = 0; else if (f61 == Math_fround(HEAPF32[i7 >> 2])) i2 = 1; else if (f59 == f13) i2 = 2; else if (f62 == f15) i2 = 3; else if (f60 == f12) i2 = 4; else if (f63 == f14) i2 = 5; else break;
    HEAP32[i52 >> 2] = (HEAP32[i52 >> 2] | 0) + 1;
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i68, i65, i66, i2);
    __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i69, i65, i8, i2 ^ 1);
    __ZN5Umbra11TileMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeES9_ii(i70, i37, i53, i68, i69, i2, i9);
    break;
   }
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
   i4 = HEAP32[i72 >> 2] | 0;
   i5 = (i8 | 0) < (i4 | 0);
   if (i5) {
    i3 = HEAP32[i20 >> 2] | 0;
    i17 = HEAP32[(HEAP32[i3 + (i8 << 5) >> 2] | 0) + 52 >> 2] & 65535;
    i2 = i3 + (i8 << 5) + 24 | 0;
    i3 = i3 + (i8 << 5) + 28 | 0;
   } else {
    i3 = i8 - i4 | 0;
    i16 = HEAP32[i47 >> 2] | 0;
    i17 = 1;
    i2 = i16 + (i3 * 40 | 0) + 32 | 0;
    i3 = i16 + (i3 * 40 | 0) + 36 | 0;
   }
   i16 = HEAP32[i2 >> 2] | 0;
   i11 = HEAP32[i3 >> 2] | 0;
   if ((i16 | 0) != 0 & (i11 | 0) != 0) {
    if ((i4 | 0) > (i66 | 0)) {
     i7 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i66 << 5) >> 2] | 0;
     i10 = i7 + 12 | 0;
     HEAP32[i69 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i69 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i69 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    } else {
     i10 = i66 - i4 | 0;
     i7 = HEAP32[i47 >> 2] | 0;
     HEAP32[i69 >> 2] = HEAP32[i7 + (i10 * 40 | 0) >> 2];
     HEAP32[i48 >> 2] = HEAP32[i7 + (i10 * 40 | 0) + 4 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i7 + (i10 * 40 | 0) + 8 >> 2];
     HEAP32[i21 >> 2] = HEAP32[i7 + (i10 * 40 | 0) + 12 >> 2];
     HEAP32[i50 >> 2] = HEAP32[i7 + (i10 * 40 | 0) + 16 >> 2];
     HEAP32[i51 >> 2] = HEAP32[i7 + (i10 * 40 | 0) + 20 >> 2];
    }
    if (i5) {
     i8 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i8 << 5) >> 2] | 0;
     i10 = i8 + 12 | 0;
     HEAP32[i70 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i70 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i70 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i22 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i22 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     f13 = Math_fround(HEAPF32[i24 >> 2]);
    } else {
     i8 = i8 - i4 | 0;
     i7 = HEAP32[i47 >> 2] | 0;
     HEAP32[i70 >> 2] = HEAP32[i7 + (i8 * 40 | 0) >> 2];
     HEAP32[i26 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 4 >> 2];
     HEAP32[i28 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 8 >> 2];
     i10 = HEAP32[i7 + (i8 * 40 | 0) + 12 >> 2] | 0;
     HEAP32[i22 >> 2] = i10;
     HEAP32[i25 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 16 >> 2];
     HEAP32[i27 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 20 >> 2];
     f13 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    }
    if (Math_fround(HEAPF32[i69 >> 2]) == f13) {
     i2 = 0;
     f12 = Math_fround(HEAPF32[i70 >> 2]);
    } else {
     f75 = Math_fround(HEAPF32[i23 >> 2]);
     f12 = Math_fround(HEAPF32[i70 >> 2]);
     if (f75 == f12) i2 = 1; else {
      f75 = Math_fround(HEAPF32[i39 >> 2]);
      if (f75 == Math_fround(HEAPF32[i40 >> 2])) i2 = 2; else {
       f75 = Math_fround(HEAPF32[i41 >> 2]);
       if (f75 == Math_fround(HEAPF32[i42 >> 2])) i2 = 3; else {
        f75 = Math_fround(HEAPF32[i43 >> 2]);
        if (f75 == Math_fround(HEAPF32[i44 >> 2])) i2 = 4; else {
         f75 = Math_fround(HEAPF32[i45 >> 2]);
         if (f75 == Math_fround(HEAPF32[i46 >> 2])) i2 = 5; else i2 = -1;
        }
       }
      }
     }
    }
    i10 = 0 - (i2 & 1) & 65535;
    i8 = (((i2 >>> 1 & 3) + 1 | 0) >>> 0) % 3 | 0;
    i7 = ((i8 + 1 | 0) >>> 0) % 3 | 0;
    i6 = i2 >> 1;
    i5 = (i6 + 1 | 0) % 3 | 0;
    f76 = Math_fround(HEAPF32[i69 + (i5 << 2) >> 2]);
    i6 = (i6 + 2 | 0) % 3 | 0;
    f75 = Math_fround(HEAPF32[i69 + (i6 << 2) >> 2]);
    f77 = Math_fround(HEAPF32[i23 + (i5 << 2) >> 2]);
    f15 = Math_fround(HEAPF32[i23 + (i6 << 2) >> 2]);
    f13 = Math_fround(f13 - f12);
    f12 = Math_fround(HEAPF32[i25 >> 2]);
    f12 = Math_fround(f12 - Math_fround(HEAPF32[i26 >> 2]));
    f14 = Math_fround(HEAPF32[i27 >> 2]);
    f14 = Math_fround(f14 - Math_fround(HEAPF32[i28 >> 2]));
    HEAPF32[i68 >> 2] = f13;
    HEAPF32[i29 >> 2] = f12;
    HEAPF32[i30 >> 2] = f14;
    f14 = Math_fround(HEAPF32[i70 + (i8 << 2) >> 2]);
    f76 = Math_fround(f76 - f14);
    f12 = Math_fround(HEAPF32[i68 + (i8 << 2) >> 2]);
    f76 = Math_fround(f76 / f12);
    f12 = Math_fround(Math_fround(f77 - f14) / f12);
    f14 = Math_fround(HEAPF32[i70 + (i7 << 2) >> 2]);
    f75 = Math_fround(f75 - f14);
    f13 = Math_fround(HEAPF32[i68 + (i7 << 2) >> 2]);
    i7 = ~~Math_fround(f76 * Math_fround(65535.0));
    i8 = ~~Math_fround(Math_fround(f75 / f13) * Math_fround(65535.0));
    f12 = Math_fround(Math_fround(65535.0) / Math_fround(~~Math_fround(f12 * Math_fround(65535.0)) - i7 | 0));
    f13 = Math_fround(Math_fround(65535.0) / Math_fround(~~Math_fround(Math_fround(Math_fround(f15 - f14) / f13) * Math_fround(65535.0)) - i8 | 0));
    f14 = Math_fround(Math_fround(i7 | 0) * f12);
    f15 = Math_fround(Math_fround(i8 | 0) * f13);
    if (i17 | 0) {
     i6 = i2 << 29 | i9;
     i5 = 0;
     do {
      i7 = i11 + (HEAP32[i16 + (i5 << 3) >> 2] << 4) | 0;
      i8 = i16 + (i5 << 3) + 4 | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      if ((i2 | 0) > 0) {
       i9 = i5 << 16 | i10;
       i4 = 0;
       do {
        i3 = i7 + (i4 << 4) | 0;
        i78 = HEAP32[i3 >> 2] | 0;
        if ((i78 & 268435456 | 0) == 0 & (i78 & 67108863 | 0) == (i64 | 0)) {
         i82 = i3 + 8 | 0;
         i79 = (HEAP32[i82 >> 2] | 0) >>> 16;
         i80 = i3 + 12 | 0;
         i81 = (HEAP32[i80 >> 2] | 0) >>> 16;
         HEAP32[i32 >> 2] = 0;
         HEAP32[i33 >> 2] = 0;
         i79 = ~~Math_fround(Math_fround(f12 * Math_fround(i79 | 0)) - f14);
         i81 = ~~Math_fround(Math_fround(f13 * Math_fround(i81 | 0)) - f15);
         i82 = ~~Math_fround(Math_fround(f12 * Math_fround(HEAP32[i82 >> 2] & 65535 | 0)) - f14);
         i80 = ~~Math_fround(Math_fround(f13 * Math_fround(HEAP32[i80 >> 2] & 65535 | 0)) - f15);
         HEAP32[i68 >> 2] = (i79 | 0) < 0 ? 0 : i79;
         HEAP32[i31 >> 2] = (i81 | 0) < 0 ? 0 : i81;
         HEAP32[i32 >> 2] = 0;
         HEAP32[i33 >> 2] = 0;
         i81 = HEAP32[gb + 1451576 >> 2] | 0;
         i79 = HEAP32[gb + 1451576 + 4 >> 2] | 0;
         i78 = HEAP32[gb + 1451576 + 8 >> 2] | 0;
         i2 = HEAP32[gb + 1451576 + 12 >> 2] | 0;
         HEAP32[i71 >> 2] = (i82 | 0) <= (i81 | 0) ? i82 : i81;
         HEAP32[i34 >> 2] = (i80 | 0) <= (i79 | 0) ? i80 : i79;
         HEAP32[i35 >> 2] = (i78 | 0) < 0 ? i78 : 0;
         HEAP32[i36 >> 2] = (i2 | 0) < 0 ? i2 : 0;
         __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_(i37, (HEAP32[i38 >> 2] | 0) + ((HEAP32[i3 + 4 >> 2] | 0) >>> 16 << 2) | 0, 0, i6, i9, i68, i71);
         i2 = HEAP32[i8 >> 2] | 0;
        }
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) < (i2 | 0));
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i17 | 0));
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i57 >> 2] | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i74;
 return;
}

function __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i8, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i3 = i8 + 204 | 0;
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047713 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 205 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047723 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 116 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047730 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047738 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i7 = 35; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047746 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 46; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047756 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047766 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 68; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 68; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047778 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 79; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 79; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 79) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 144 | 0;
 i5 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047790 | 0, i5, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047804 | 0, i5, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047818 | 0, i5, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047830 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 108; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 108; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 108) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i11, 1) | 0) HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) / Math_fround(40.0));
 i2 = i8 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047851 | 0, i5, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047867 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i5 >>> 0) i7 = 127; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 127;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 196 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047883 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 138; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i7 = 138;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 138) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 193 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047902 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  L197 : do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L197;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047914 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  L209 : do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i7 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L209;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i8 + 206 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047938 | 0, i9, i10, 0) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 L222 : do if ((i1 | 0) > 0) {
  i1 = i11 + 16 | 0;
  i10 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i10 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L222;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN5physx17PxsCCDAdvanceTask11runInternalEv(i64) {
 i64 = i64 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i62 = i66 + 32 | 0;
 i60 = i66;
 i61 = i66 + 104 | 0;
 i63 = i64 + 28 | 0;
 i2 = HEAP32[i63 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i59 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i58 = HEAP32[(HEAP32[i59 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i58 | 0, i59 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i59 = i1 + 19 & -16;
   HEAP32[i59 + -4 >> 2] = i59 - i1;
   i1 = i59;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
  i59 = i1;
 } else i59 = i1;
 i1 = HEAP32[i64 + 48 >> 2] | 0;
 i24 = (HEAP32[i64 + 52 >> 2] | 0) + i1 | 0;
 i23 = HEAP32[i64 + 56 >> 2] | 0;
 i23 = i24 >>> 0 < i23 >>> 0 ? i24 : i23;
 i24 = i64 + 24 | 0;
 if (i1 >>> 0 >= i23 >>> 0) {
  i65 = 0;
  i64 = i64 + 72 | 0;
  i64 = HEAP32[i64 >> 2] | 0;
  __ZN5physx6shdfnd9atomicAddEPVii(i64, i65) | 0;
  i65 = HEAP32[i63 >> 2] | 0;
  i65 = i65 + 224 | 0;
  i65 = HEAP32[i65 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i65, i59);
  STACKTOP = i66;
  return;
 }
 i25 = i64 + 20 | 0;
 i26 = i64 + 36 | 0;
 i27 = i64 + 76 | 0;
 i28 = i64 + 68 | 0;
 i29 = i64 + 77 | 0;
 i30 = i64 + 64 | 0;
 i31 = i60 + 4 | 0;
 i32 = i60 + 8 | 0;
 i33 = i60 + 12 | 0;
 i34 = i60 + 16 | 0;
 i35 = i60 + 20 | 0;
 i36 = i60 + 24 | 0;
 i37 = i62 + 4 | 0;
 i38 = i62 + 8 | 0;
 i39 = i62 + 12 | 0;
 i40 = i62 + 4 | 0;
 i41 = i62 + 8 | 0;
 i42 = i62 + 24 | 0;
 i43 = i62 + 28 | 0;
 i44 = i62 + 32 | 0;
 i45 = i62 + 16 | 0;
 i46 = i62 + 20 | 0;
 i47 = i62 + 64 | 0;
 i48 = i62 + 66 | 0;
 i49 = i62 + 56 | 0;
 i50 = i62 + 52 | 0;
 i51 = i62 + 60 | 0;
 i52 = i62 + 12 | 0;
 i53 = i62 + 48 | 0;
 i54 = i62 + 68 | 0;
 i55 = i62 + 36 | 0;
 i56 = i62 + 40 | 0;
 i57 = i62 + 44 | 0;
 i58 = i64 + 32 | 0;
 i22 = i1;
 i7 = HEAP32[i64 + 60 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i24 >> 2] | 0;
  if (i7 >>> 0 >= i3 >>> 0) {
   i65 = 87;
   break;
  }
  i5 = i7 + 1 | 0;
  if (i5 >>> 0 < i3 >>> 0) {
   i4 = HEAP32[i25 >> 2] | 0;
   i2 = i5;
   do {
    if ((HEAP32[(HEAP32[i4 + (i2 << 2) >> 2] | 0) + 56 >> 2] | 0) != (i22 | 0)) break;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
   if (i2 >>> 0 > i5 >>> 0) __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_13ToiPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j((HEAP32[i25 >> 2] | 0) + (i7 << 2) | 0, i2 - i7 | 0, i61, i62, 32);
  } else i2 = i5;
  L21 : do if (i2 >>> 0 > i7 >>> 0) {
   i20 = (i22 | 0) == 0;
   i21 = i22 + -1 | 0;
   f10 = Math_fround(HEAPF32[i26 >> 2]);
   i19 = 1;
   i3 = i7;
   while (1) {
    i18 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i16 = i18 + 28 | 0;
    f6 = Math_fround(HEAPF32[i16 >> 2]);
    if (f6 > Math_fround(1.0)) break L21;
    i4 = HEAP32[i18 >> 2] | 0;
    if (!i4) i5 = 0; else i5 = (HEAP16[(HEAP32[i4 + 60 >> 2] | 0) + 2 >> 1] | 0) == 0;
    i17 = i18 + 4 | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    if (!i4) i4 = 0; else i4 = (HEAP16[(HEAP32[i4 + 60 >> 2] | 0) + 2 >> 1] | 0) == 0;
    L32 : do if (i5 | i4) {
     do if (!(HEAP32[i18 + 100 >> 2] | 0)) {
      Math_fround(__ZN5physx10PxsCCDPair12sweepFindToiERNS_16PxsThreadContextEfj(i18, i59, f10, 0));
      i4 = i3 + 1 | 0;
      if (i4 >>> 0 >= i2 >>> 0) {
       f6 = Math_fround(HEAPF32[i16 >> 2]);
       break;
      }
      i5 = HEAP32[i25 >> 2] | 0;
      i7 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
      f8 = Math_fround(HEAPF32[i7 + 28 >> 2]);
      f6 = Math_fround(HEAPF32[i16 >> 2]);
      if (f8 < f6) {
       L40 : do if (f8 < f6) {
        i9 = i7;
        i7 = i3;
        while (1) {
         HEAP32[i5 + (i7 << 2) >> 2] = i9;
         i7 = i4 + 1 | 0;
         i5 = HEAP32[i25 >> 2] | 0;
         if (i7 >>> 0 >= i2 >>> 0) break L40;
         i9 = HEAP32[i5 + (i7 << 2) >> 2] | 0;
         if (!(Math_fround(HEAPF32[i9 + 28 >> 2]) < f6)) break; else {
          i17 = i4;
          i4 = i7;
          i7 = i17;
         }
        }
       } else i4 = i3; while (0);
       HEAP32[i5 + (i4 << 2) >> 2] = i18;
       f6 = f10;
       i4 = i19;
       i3 = i3 + -1 | 0;
       break L32;
      }
     } while (0);
     do if (f6 <= Math_fround(3402823469999999843913219.0e14)) if (HEAP8[i18 + 69 >> 0] | 0) if (__ZNK5physx10PxsContext27getCCDContactModifyCallbackEv(HEAP32[i63 >> 2] | 0) | 0) {
      i4 = i18 + 36 | 0;
      HEAP32[i62 >> 2] = HEAP32[i4 >> 2];
      i5 = i18 + 40 | 0;
      HEAP32[i40 >> 2] = HEAP32[i5 >> 2];
      i7 = i18 + 44 | 0;
      HEAP32[i41 >> 2] = HEAP32[i7 >> 2];
      i9 = i18 + 16 | 0;
      HEAP32[i42 >> 2] = HEAP32[i9 >> 2];
      i11 = i18 + 20 | 0;
      HEAP32[i43 >> 2] = HEAP32[i11 >> 2];
      i12 = i18 + 24 | 0;
      HEAP32[i44 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i45 >> 2] = -1;
      HEAP32[i46 >> 2] = HEAP32[i18 + 72 >> 2];
      HEAP16[i47 >> 1] = HEAP16[i18 + 76 >> 1] | 0;
      HEAP16[i48 >> 1] = HEAP16[i18 + 78 >> 1] | 0;
      i13 = i18 + 80 | 0;
      HEAP32[i49 >> 2] = HEAP32[i13 >> 2];
      i14 = i18 + 84 | 0;
      HEAP32[i50 >> 2] = HEAP32[i14 >> 2];
      i15 = i18 + 88 | 0;
      HEAP32[i51 >> 2] = HEAP32[i15 >> 2];
      HEAPF32[i52 >> 2] = Math_fround(0.0);
      HEAPF32[i53 >> 2] = Math_fround(3402823469999999843913219.0e14);
      HEAP32[i54 >> 2] = 0;
      HEAP32[i55 >> 2] = 0;
      HEAP32[i56 >> 2] = 0;
      HEAP32[i57 >> 2] = 0;
      i68 = HEAP32[i18 + 8 >> 2] | 0;
      i67 = HEAP32[i18 + 12 >> 2] | 0;
      __ZN5physx13PxsCCDContext23runCCDModifiableContactEPNS_19PxModifiableContactEjPKNS_12PxsShapeCoreES5_PKNS_12PxsRigidCoreES8_PKNS_12PxsRigidBodyESB_(HEAP32[i58 >> 2] | 0, i62, 1, HEAP32[i68 >> 2] | 0, HEAP32[i67 >> 2] | 0, HEAP32[i68 + 4 >> 2] | 0, HEAP32[i67 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i17 >> 2] | 0);
      if (Math_fround(HEAPF32[i53 >> 2]) == Math_fround(0.0)) {
       HEAPF32[i16 >> 2] = Math_fround(3402823469999999843913219.0e14);
       f6 = f10;
       i4 = i19;
       break L32;
      } else {
       HEAP32[i13 >> 2] = HEAP32[i49 >> 2];
       HEAP32[i14 >> 2] = HEAP32[i50 >> 2];
       HEAP32[i15 >> 2] = HEAP32[i51 >> 2];
       HEAP32[i4 >> 2] = HEAP32[i62 >> 2];
       HEAP32[i5 >> 2] = HEAP32[i40 >> 2];
       HEAP32[i7 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i9 >> 2] = HEAP32[i42 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i43 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i44 >> 2];
       break;
      }
     } while (0);
     i4 = HEAP32[i18 >> 2] | 0;
     i5 = (i4 | 0) == 0;
     if (i5) i65 = 38; else if (!(HEAP16[(HEAP32[i4 + 60 >> 2] | 0) + 2 >> 1] | 0)) i5 = 1; else i65 = 38;
     if ((i65 | 0) == 38) i65 = 0;
     i7 = HEAP32[i17 >> 2] | 0;
     i4 = (i7 | 0) == 0;
     if (i4) i65 = 41; else if (!(HEAP16[(HEAP32[i7 + 60 >> 2] | 0) + 2 >> 1] | 0)) i4 = 1; else i65 = 41;
     if ((i65 | 0) == 41) i65 = 0;
     if (!(!(Math_fround(HEAPF32[i16 >> 2]) <= Math_fround(1.0)) | i5 ^ 1 | i4 ^ 1)) HEAP8[i18 + 68 >> 0] = 1;
     i4 = __ZN5physx10PxsCCDPair17sweepAdvanceToToiEfb(i18, f10, (HEAP8[i27 >> 0] | 0) != 0) | 0;
     f6 = Math_fround(HEAPF32[i16 >> 2]);
     if (f6 < Math_fround(0.0)) {
      HEAPF32[i16 >> 2] = Math_fround(0.0);
      f6 = Math_fround(0.0);
     }
     if (!(f6 <= Math_fround(1.0)) | i4 ^ 1) {
      f6 = f10;
      i4 = i19;
     } else {
      i1 = i1 + 1 | 0;
      i4 = HEAP32[i28 >> 2] | 0;
      if (i20) i5 = 0; else i5 = HEAPU16[i4 + (i21 << 1) >> 1] | 0;
      i9 = HEAPU16[i4 + (i22 << 1) >> 1] | 0;
      do if (f6 > Math_fround(0.0)) {
       if (i5 >>> 0 < i9 >>> 0) {
        do {
         i4 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i5 << 2) >> 2] | 0;
         if (!(HEAP16[i4 + 2 >> 1] | 0)) {
          i4 = HEAP32[i4 + 8 >> 2] | 0;
          i7 = HEAP32[i4 + 64 >> 2] | 0;
          if (!(Math_fround(HEAPF32[i7 + 124 >> 2]) == Math_fround(0.0))) {
           f8 = Math_fround(Math_fround(1.0) - f6);
           i68 = i4 + 48 | 0;
           f72 = Math_fround(f8 * Math_fround(HEAPF32[i68 >> 2]));
           i67 = i4 + 52 | 0;
           f71 = Math_fround(f8 * Math_fround(HEAPF32[i67 >> 2]));
           i15 = i4 + 56 | 0;
           f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
           f70 = Math_fround(f6 * Math_fround(HEAPF32[i7 + 16 >> 2]));
           f69 = Math_fround(f6 * Math_fround(HEAPF32[i7 + 20 >> 2]));
           f70 = Math_fround(f72 + f70);
           f69 = Math_fround(f71 + f69);
           f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 + 24 >> 2])));
           HEAPF32[i68 >> 2] = f70;
           HEAPF32[i67 >> 2] = f69;
           HEAPF32[i15 >> 2] = f8;
           HEAP32[i60 >> 2] = HEAP32[i4 + 32 >> 2];
           i15 = i4 + 36 | 0;
           HEAP32[i31 >> 2] = HEAP32[i15 >> 2];
           i67 = i4 + 40 | 0;
           HEAP32[i32 >> 2] = HEAP32[i67 >> 2];
           i68 = i4 + 44 | 0;
           HEAP32[i33 >> 2] = HEAP32[i68 >> 2];
           HEAPF32[i34 >> 2] = f70;
           HEAPF32[i35 >> 2] = f69;
           HEAPF32[i36 >> 2] = f8;
           __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i62, f6, i60, i7);
           HEAP32[i4 + 32 >> 2] = HEAP32[i62 >> 2];
           HEAP32[i15 >> 2] = HEAP32[i37 >> 2];
           HEAP32[i67 >> 2] = HEAP32[i38 >> 2];
           HEAP32[i68 >> 2] = HEAP32[i39 >> 2];
          }
          i68 = HEAP32[i4 + 60 >> 2] | 0;
          i67 = i68 + 4 | 0;
          f72 = Math_fround(HEAPF32[i67 >> 2]);
          f6 = Math_fround(HEAPF32[i16 >> 2]);
          f72 = Math_fround(f72 * Math_fround(Math_fround(1.0) - f6));
          i15 = f72 > Math_fround(.00999999977);
          HEAPF32[i67 >> 2] = i15 ? f72 : Math_fround(.00999999977);
          i68 = i68 + 16 | 0;
          HEAP32[i68 >> 2] = (HEAP32[i68 >> 2] | 0) + 1;
         }
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i9 | 0));
        f8 = f6;
       } else f8 = f6;
       f6 = Math_fround(f10 - Math_fround(f10 * f8));
       f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(1.0) - f8));
       i4 = i3 + 1 | 0;
       if (i4 >>> 0 >= i2 >>> 0) break;
       i5 = HEAP32[i25 >> 2] | 0;
       i4 = (HEAP32[i5 + (i4 << 2) >> 2] | 0) + 28 | 0;
       HEAPF32[i4 >> 2] = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8));
       i4 = i3 + 2 | 0;
       if ((i4 | 0) == (i2 | 0)) break;
       do {
        f72 = Math_fround(HEAPF32[i16 >> 2]);
        i68 = (HEAP32[i5 + (i4 << 2) >> 2] | 0) + 28 | 0;
        HEAPF32[i68 >> 2] = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i68 >> 2]) - f72));
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i2 | 0));
      } else f6 = f10; while (0);
      do if (!(HEAP8[i29 >> 0] | 0)) {
       if (HEAP8[(HEAP32[i18 + 52 >> 2] | 0) + 34 >> 0] | 0) break;
       i15 = HEAP32[i18 >> 2] | 0;
       i14 = HEAP32[i17 >> 2] | 0;
       i4 = i3 + 1 | 0;
       if (i4 >>> 0 >= i2 >>> 0) break;
       do {
        i12 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i4 << 2) >> 2] | 0;
        i5 = HEAP32[i12 >> 2] | 0;
        i11 = (i5 | 0) == 0;
        if (i11) i5 = HEAP32[i12 + 8 >> 2] | 0;
        i7 = HEAP32[i12 + 4 >> 2] | 0;
        i9 = (i7 | 0) == 0;
        if (i9) i7 = HEAP32[i12 + 12 >> 2] | 0;
        L103 : do if (!(i11 | i9)) {
         do if ((i5 | 0) != (i15 | 0) | (i7 | 0) == (i14 | 0)) {
          if (!((i5 | 0) == (i14 | 0) | (i7 | 0) != (i15 | 0))) break;
          if (!((i5 | 0) != (i14 | 0) | (i7 | 0) == (i15 | 0))) break;
          if ((i5 | 0) == (i15 | 0) | (i7 | 0) != (i14 | 0)) break L103;
         } while (0);
         i5 = i12 + 92 | 0;
         if ((i19 | 0) == (HEAP32[i5 >> 2] | 0)) break;
         HEAP32[i5 >> 2] = i19;
         f8 = Math_fround(HEAPF32[i12 + 28 >> 2]);
         f10 = Math_fround(__ZN5physx10PxsCCDPair16sweepEstimateToiEv(i12));
         if (f10 < f8) {
          i5 = i4 + -1 | 0;
          if (i5 >>> 0 > i3 >>> 0) i12 = i4; else break;
          while (1) {
           i7 = HEAP32[i25 >> 2] | 0;
           i9 = i7 + (i5 << 2) | 0;
           i11 = HEAP32[i9 >> 2] | 0;
           if (!(Math_fround(HEAPF32[i11 + 28 >> 2]) > f10)) break L103;
           HEAP32[i9 >> 2] = HEAP32[i7 + (i12 << 2) >> 2];
           HEAP32[(HEAP32[i25 >> 2] | 0) + (i12 << 2) >> 2] = i11;
           i7 = i5 + -1 | 0;
           if (i7 >>> 0 > i3 >>> 0) {
            i12 = i5;
            i5 = i7;
           } else break L103;
          }
         }
         if (!(f10 > f8)) break;
         i5 = i4 + 1 | 0;
         L118 : do if (i5 >>> 0 < i2 >>> 0) {
          i13 = i5;
          i12 = i4;
          i5 = 0;
          while (1) {
           i7 = HEAP32[i25 >> 2] | 0;
           i9 = i7 + (i13 << 2) | 0;
           i11 = HEAP32[i9 >> 2] | 0;
           if (!(Math_fround(HEAPF32[i11 + 28 >> 2]) < f10)) break L118;
           HEAP32[i9 >> 2] = HEAP32[i7 + (i12 << 2) >> 2];
           HEAP32[(HEAP32[i25 >> 2] | 0) + (i12 << 2) >> 2] = i11;
           i5 = i13 + 1 | 0;
           if (i5 >>> 0 < i2 >>> 0) {
            i12 = i13;
            i13 = i5;
            i5 = 1;
           } else {
            i5 = 1;
            break;
           }
          }
         } else i5 = 0; while (0);
         i4 = i4 - i5 | 0;
        } while (0);
        i4 = i4 + 1 | 0;
       } while (i4 >>> 0 < i2 >>> 0);
      } while (0);
      i4 = i19 + 1 | 0;
     }
    } else {
     f6 = f10;
     i4 = i19;
    } while (0);
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i2 >>> 0) break; else {
     f10 = f6;
     i19 = i4;
    }
   }
  } while (0);
  i22 = i22 + 1 | 0;
  if (i22 >>> 0 >= i23 >>> 0) {
   i65 = 87;
   break;
  } else i7 = i2;
 }
 if ((i65 | 0) == 87) {
  i68 = i64 + 72 | 0;
  i68 = HEAP32[i68 >> 2] | 0;
  __ZN5physx6shdfnd9atomicAddEPVii(i68, i1) | 0;
  i68 = HEAP32[i63 >> 2] | 0;
  i68 = i68 + 224 | 0;
  i68 = HEAP32[i68 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i68, i59);
  STACKTOP = i66;
  return;
 }
}

function __ZN5physx36createFinalizeSolverContacts4CoulombEPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE(i49, i67, i45, i40, i41, i42, i43, i38, i39, f66, f65, f3, f2, i44, i1) {
 i49 = i49 | 0;
 i67 = i67 | 0;
 i45 = i45 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 f66 = Math_fround(f66);
 f65 = Math_fround(f65);
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 i44 = i44 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i68 = 0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 2288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i64 + 2064 | 0;
 i36 = i64 + 2032 | 0;
 i53 = i64 + 128 | 0;
 i60 = i64 + 112 | 0;
 i61 = i64 + 96 | 0;
 i58 = i64 + 80 | 0;
 i59 = i64 + 64 | 0;
 i37 = i64 + 1964 | 0;
 i63 = i64 + 1960 | 0;
 i48 = i64 + 1944 | 0;
 i62 = i64 + 1936 | 0;
 i56 = i64 + 48 | 0;
 i54 = i64 + 32 | 0;
 i57 = i64 + 16 | 0;
 i55 = i64;
 HEAP16[(HEAP32[i45 >> 2] | 0) + 26 >> 1] = 0;
 i46 = i45 + 4 | 0;
 HEAP16[(HEAP32[i46 >> 2] | 0) + 26 >> 1] = 0;
 i47 = i45 + 8 | 0;
 HEAP16[(HEAP32[i47 >> 2] | 0) + 26 >> 1] = 0;
 i51 = i45 + 12 | 0;
 HEAP16[(HEAP32[i51 >> 2] | 0) + 26 >> 1] = 0;
 i32 = i67 + 384 | 0;
 i33 = i67 + 4480 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAPF32[i36 >> 2] = Math_fround(0.0);
 HEAPF32[i36 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i36 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i36 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i36 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i36 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i36 + 24 >> 2] = Math_fround(0.0);
 i34 = i53 + 1792 | 0;
 i35 = i53 + 1796 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i34 >> 2] = 0;
 i50 = (i1 | 0) == 1 ? 1 : 2;
 i16 = i37 + 4 | 0;
 i17 = i37 + 8 | 0;
 i18 = i37 + 36 | 0;
 i19 = i37 + 40 | 0;
 i20 = i37 + 44 | 0;
 i21 = i37 + 12 | 0;
 i22 = i37 + 60 | 0;
 i23 = i37 + 56 | 0;
 i24 = i37 + 64 | 0;
 i25 = i37 + 48 | 0;
 i26 = i37 + 52 | 0;
 i27 = i37 + 24 | 0;
 i28 = i37 + 28 | 0;
 i29 = i37 + 16 | 0;
 i30 = i37 + 32 | 0;
 i31 = 0;
 i6 = 0;
 while (1) {
  i5 = i49 + (i31 << 2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!(HEAP16[i1 + 22 >> 1] & 32)) i4 = i36; else {
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i38 + (i31 << 2) >> 2] | 0;
  }
  i15 = i52 + (i31 * 56 | 0) + 28 | 0;
  HEAP32[i15 >> 2] = i4;
  if (!(HEAP16[i1 + 22 >> 1] & 64)) i4 = i36; else {
   i4 = HEAP32[i39 + (i31 << 2) >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i14 = i52 + (i31 * 56 | 0) + 32 | 0;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i52 + (i31 * 56 | 0) >> 2] = i1;
  i13 = i52 + (i31 * 56 | 0) + 12 | 0;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i52 + (i31 * 56 | 0) + 36 >> 2] = HEAP32[i40 + (i31 << 2) >> 2];
  HEAP32[i52 + (i31 * 56 | 0) + 40 >> 2] = HEAP32[i41 + (i31 << 2) >> 2];
  HEAP32[i52 + (i31 * 56 | 0) + 44 >> 2] = HEAP32[i42 + (i31 << 2) >> 2];
  HEAP32[i52 + (i31 * 56 | 0) + 48 >> 2] = HEAP32[i43 + (i31 << 2) >> 2];
  i1 = HEAP32[i5 >> 2] | 0;
  if (((HEAPU16[i1 + 20 >> 1] | 0) + i6 | 0) >>> 0 > 64) {
   i1 = 1;
   i10 = 51;
   break;
  }
  i11 = HEAP32[i1 + 28 >> 2] | 0;
  i12 = HEAP32[i1 + 32 >> 2] | 0;
  HEAPF32[i37 >> 2] = Math_fround(0.0);
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  HEAPF32[i17 >> 2] = Math_fround(0.0);
  HEAP32[i18 >> 2] = i12;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i21 >> 2] = i11;
  i10 = i11;
  if (!i12) {
   i9 = 0;
   i1 = 0;
   i4 = 0;
   i5 = 0;
   i7 = 0;
   i8 = 1;
  } else {
   i8 = HEAP16[i11 + 2 >> 1] | 0;
   i7 = i8 & 65535;
   i9 = i7 & 2;
   i68 = (i9 | 0) != 0;
   i7 = i7 & 1;
   i9 = i11 + (i9 << 3 | 4) | 0;
   i1 = (i7 | 0) != 0;
   i4 = i68;
   i5 = i68 ? 4 : 32;
   i7 = i68 ? 72 : i7 << 3 | 16;
   i8 = (i8 & 4) != 0;
  }
  HEAP32[i22 >> 2] = i4 & 1;
  HEAP32[i23 >> 2] = i1 & 1;
  HEAP32[i24 >> 2] = i8 & 1;
  HEAP32[i25 >> 2] = i5;
  HEAP32[i26 >> 2] = i7;
  HEAP32[i27 >> 2] = i9;
  HEAP32[i28 >> 2] = i9;
  HEAP32[i29 >> 2] = i9;
  if (i8) {
   i4 = 0;
   i1 = 0;
  } else {
   if (i4) {
    HEAP32[i60 + (i31 << 2) >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i61 + (i31 << 2) >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i58 + (i31 << 2) >> 2] = HEAP32[i11 + 12 >> 2];
    f2 = Math_fround(HEAPF32[i11 + 16 >> 2]);
   } else {
    HEAPF32[i60 + (i31 << 2) >> 2] = Math_fround(1.0);
    HEAPF32[i61 + (i31 << 2) >> 2] = Math_fround(1.0);
    HEAPF32[i58 + (i31 << 2) >> 2] = Math_fround(1.0);
    f2 = Math_fround(1.0);
   }
   HEAPF32[i59 + (i31 << 2) >> 2] = f2;
   i1 = i9;
   if ((i1 - i10 | 0) >>> 0 < i12 >>> 0) {
    i8 = i11;
    i7 = i1;
    i5 = i12;
    i4 = 0;
    i1 = 0;
    do {
     HEAP32[i27 >> 2] = i9;
     if ((i7 - i8 | 0) >>> 0 < i5 >>> 0) {
      i12 = HEAPU16[i9 >> 1] | 0;
      HEAP32[i19 >> 2] = i12;
      i11 = HEAP32[i25 >> 2] | 0;
      HEAP32[i28 >> 2] = i9 + ((Math_imul(HEAP32[i26 >> 2] | 0, i12) | 0) + i11);
      HEAP32[i29 >> 2] = i9 + i11;
      HEAP32[i20 >> 2] = 0;
      i11 = i4;
      i12 = i1;
     } else {
      HEAP32[i28 >> 2] = i9;
      i11 = i4;
      i12 = i1;
     }
     L25 : while (1) {
      while (1) {
       i1 = HEAP32[i20 >> 2] | 0;
       if (i1 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) {
        i4 = i11;
        i1 = i12;
        break L25;
       }
       HEAP32[i20 >> 2] = i1 + 1;
       i1 = HEAP32[i29 >> 2] | 0;
       HEAP32[i30 >> 2] = i1;
       HEAP32[i29 >> 2] = i1 + (HEAP32[i26 >> 2] | 0);
       i1 = (HEAP32[i22 >> 2] | 0) == 0;
       if (i1) {
        i10 = 24;
        break;
       }
       i4 = HEAP32[i30 >> 2] | 0;
       f2 = Math_fround(HEAPF32[i4 + 48 >> 2]);
       if (f2 != Math_fround(0.0)) {
        i10 = 23;
        break;
       }
      }
      if ((i10 | 0) == 23) {
       i5 = i4 + 24 | 0;
       i7 = i4;
       i8 = i4;
       i9 = HEAP32[i27 >> 2] | 0;
      } else if ((i10 | 0) == 24) {
       i8 = HEAP32[i30 >> 2] | 0;
       i9 = HEAP32[i27 >> 2] | 0;
       i5 = i9 + 4 | 0;
       i7 = i8;
       f2 = Math_fround(3402823469999999843913219.0e14);
      }
      HEAP32[i67 + 384 + (i6 << 6) >> 2] = HEAP32[i5 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 16 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 20 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 24 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 48 >> 2] = (HEAPU16[(i1 ? i9 + 30 | 0 : i8 + 66 | 0) >> 1] | 0) << 16 | (HEAPU16[(i1 ? i9 + 28 | 0 : i8 + 64 | 0) >> 1] | 0);
      if (i1) i4 = HEAPU16[i9 + 2 >> 1] | 0; else i4 = HEAP32[i8 + 68 >> 2] | 0;
      HEAP32[i67 + 384 + (i6 << 6) + 52 >> 2] = i4;
      HEAPF32[i67 + 384 + (i6 << 6) + 28 >> 2] = f2;
      HEAP32[i67 + 384 + (i6 << 6) + 44 >> 2] = HEAP32[(i1 ? i9 + 16 | 0 : i8 + 52 | 0) >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 56 >> 2] = HEAP32[(i1 ? i9 + 20 | 0 : i8 + 56 | 0) >> 2];
      HEAP32[i67 + 384 + (i6 << 6) + 60 >> 2] = HEAP32[(i1 ? i9 + 24 | 0 : i8 + 60 | 0) >> 2];
      i4 = i1 ? i37 : i8 + 36 | 0;
      HEAP32[i67 + 384 + (i6 << 6) + 32 >> 2] = HEAP32[i4 >> 2];
      i5 = i4 + 4 | 0;
      HEAP32[i67 + 384 + (i6 << 6) + 36 >> 2] = HEAP32[i5 >> 2];
      i7 = i4 + 8 | 0;
      HEAP32[i67 + 384 + (i6 << 6) + 40 >> 2] = HEAP32[i7 >> 2];
      if (i1) i1 = 0; else {
       if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i7 >> 2]) == Math_fround(0.0); else i1 = 0; else i1 = 0;
       i1 = i1 ^ 1;
      }
      i11 = i11 | f2 != Math_fround(3402823469999999843913219.0e14);
      i6 = i6 + 1 | 0;
      i12 = i12 | i1;
     }
     i9 = HEAP32[i28 >> 2] | 0;
     i8 = HEAP32[i21 >> 2] | 0;
     i7 = i9;
     i5 = HEAP32[i18 >> 2] | 0;
    } while ((i7 - i8 | 0) >>> 0 < i5 >>> 0);
   } else {
    i4 = 0;
    i1 = 0;
   }
  }
  i5 = HEAP32[i13 >> 2] | 0;
  HEAP32[i33 >> 2] = i6;
  if ((i6 | 0) == (i5 | 0)) {
   i10 = 37;
   break;
  }
  HEAP32[i52 + (i31 * 56 | 0) + 16 >> 2] = i6 - i5;
  HEAP8[i52 + (i31 * 56 | 0) + 52 >> 0] = i1 & 1;
  HEAP8[i52 + (i31 * 56 | 0) + 53 >> 0] = i4 & 1;
  i1 = HEAP32[i35 >> 2] | 0;
  HEAP32[i52 + (i31 * 56 | 0) + 4 >> 2] = i1;
  i4 = HEAP32[i34 >> 2] | 0;
  HEAP32[i52 + (i31 * 56 | 0) + 20 >> 2] = i4;
  __ZN5physx27createContactPatchesCoulombERNS_27PxcCorrelationBufferCoulombERNS_2Gu13ContactBufferEfj(i53, i32, Math_fround(.999000012), i5) | 0;
  if (__ZN5physx23correlatePatchesCoulombERNS_27PxcCorrelationBufferCoulombERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjjj(i53, i32, HEAP32[i15 >> 2] | 0, HEAP32[i14 >> 2] | 0, Math_fround(.999000012), i50, i4, i1) | 0) {
   i10 = 37;
   break;
  }
  HEAP32[i52 + (i31 * 56 | 0) + 24 >> 2] = (HEAP32[i34 >> 2] | 0) - i4;
  HEAP32[i52 + (i31 * 56 | 0) + 8 >> 2] = (HEAP32[i35 >> 2] | 0) - i1;
  i31 = i31 + 1 | 0;
  if (i31 >>> 0 >= 4) {
   i10 = 38;
   break;
  }
 }
 if ((i10 | 0) == 37) {
  i68 = 1;
  STACKTOP = i64;
  return i68 | 0;
 } else if ((i10 | 0) == 38) {
  HEAP32[i63 >> 2] = 0;
  HEAP32[i62 >> 2] = 0;
  i4 = i67 + 316 | 0;
  __Z35computeBlockStreamByteSizesCoulomb4PN5physx21PxcSolverContact4DescERNS_18PxcNpThreadContextERKNS_27PxcCorrelationBufferCoulombERjPjS7_(i52, i67, i53, i63, i48, i62);
  i10 = HEAP32[i63 >> 2] | 0;
  do if (!i10) i7 = 0; else {
   if ((i10 + 16 | 0) >>> 0 > 16384) {
    i68 = 1;
    STACKTOP = i64;
    return i68 | 0;
   }
   i5 = i10 + 31 & -16;
   do if (i5 >>> 0 > 16384) i1 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i4 >> 2] | 0, i5) | 0; else {
    i6 = i67 + 320 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i1 = i67 + 324 | 0;
    if (i7 | 0) {
     i8 = HEAP32[i1 >> 2] | 0;
     i9 = i8 + i5 | 0;
     if (i9 >>> 0 <= 16384) {
      HEAP32[i1 >> 2] = i9;
      i1 = i7 + i8 | 0;
      break;
     }
    }
    i68 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i4 >> 2] | 0, i44) | 0;
    HEAP32[i6 >> 2] = i68;
    HEAP32[i1 >> 2] = i5;
    i1 = i68;
   } while (0);
   if ((i1 | 0) == 0 | (i1 | 0) == (-1 | 0) & (i1 | 0) != 0) {
    i68 = 0;
    STACKTOP = i64;
    return i68 | 0;
   } else {
    i7 = i1;
    break;
   }
  } while (0);
  i6 = i10 >>> 4 & 65535;
  HEAP32[HEAP32[i49 >> 2] >> 2] = i7;
  HEAP32[(HEAP32[i45 >> 2] | 0) + 16 >> 2] = i7;
  i1 = HEAP32[i49 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i10;
  i5 = i1 + 16 | 0;
  HEAP16[i5 >> 1] = (HEAPU16[i5 >> 1] | 0) + (HEAP32[i48 >> 2] | 0);
  i5 = HEAP32[i45 >> 2] | 0;
  HEAP16[i5 + 26 >> 1] = i6;
  if (!(HEAP16[i1 + 98 >> 1] & 16)) {
   i4 = 0;
   i1 = 0;
  } else {
   i4 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 32 >> 2] | 0) + 15 & -16) | 0;
   i1 = HEAP16[i1 + 20 >> 1] | 0;
  }
  HEAP32[i5 + 20 >> 2] = i4;
  HEAP16[(HEAP32[i45 >> 2] | 0) + 24 >> 1] = i1;
  i1 = i49 + 4 | 0;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
  HEAP32[(HEAP32[i46 >> 2] | 0) + 16 >> 2] = i7;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i10;
  i5 = i1 + 16 | 0;
  HEAP16[i5 >> 1] = (HEAPU16[i5 >> 1] | 0) + (HEAP32[i48 + 4 >> 2] | 0);
  i5 = HEAP32[i46 >> 2] | 0;
  HEAP16[i5 + 26 >> 1] = i6;
  if (!(HEAP16[i1 + 98 >> 1] & 16)) {
   i4 = 0;
   i1 = 0;
  } else {
   i4 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 32 >> 2] | 0) + 15 & -16) | 0;
   i1 = HEAP16[i1 + 20 >> 1] | 0;
  }
  HEAP32[i5 + 20 >> 2] = i4;
  HEAP16[(HEAP32[i46 >> 2] | 0) + 24 >> 1] = i1;
  i1 = i49 + 8 | 0;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
  HEAP32[(HEAP32[i47 >> 2] | 0) + 16 >> 2] = i7;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i10;
  i5 = i1 + 16 | 0;
  HEAP16[i5 >> 1] = (HEAPU16[i5 >> 1] | 0) + (HEAP32[i48 + 8 >> 2] | 0);
  i5 = HEAP32[i47 >> 2] | 0;
  HEAP16[i5 + 26 >> 1] = i6;
  if (!(HEAP16[i1 + 98 >> 1] & 16)) {
   i4 = 0;
   i1 = 0;
  } else {
   i4 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 32 >> 2] | 0) + 15 & -16) | 0;
   i1 = HEAP16[i1 + 20 >> 1] | 0;
  }
  HEAP32[i5 + 20 >> 2] = i4;
  HEAP16[(HEAP32[i47 >> 2] | 0) + 24 >> 1] = i1;
  i1 = i49 + 12 | 0;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
  HEAP32[(HEAP32[i51 >> 2] | 0) + 16 >> 2] = i7;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i10;
  i5 = i1 + 16 | 0;
  HEAP16[i5 >> 1] = (HEAPU16[i5 >> 1] | 0) + (HEAP32[i48 + 12 >> 2] | 0);
  i5 = HEAP32[i51 >> 2] | 0;
  HEAP16[i5 + 26 >> 1] = i6;
  if (!(HEAP16[i1 + 98 >> 1] & 16)) {
   i4 = 0;
   i1 = 0;
  } else {
   i4 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 32 >> 2] | 0) + 15 & -16) | 0;
   i1 = HEAP16[i1 + 20 >> 1] | 0;
  }
  HEAP32[i5 + 20 >> 2] = i4;
  HEAP16[(HEAP32[i51 >> 2] | 0) + 24 >> 1] = i1;
  i49 = HEAP32[i60 + 4 >> 2] | 0;
  i68 = HEAP32[i60 + 8 >> 2] | 0;
  i51 = HEAP32[i60 + 12 >> 2] | 0;
  HEAP32[i56 >> 2] = HEAP32[i60 >> 2];
  HEAP32[i56 + 4 >> 2] = i49;
  HEAP32[i56 + 8 >> 2] = i68;
  HEAP32[i56 + 12 >> 2] = i51;
  i51 = HEAP32[i58 + 4 >> 2] | 0;
  i60 = HEAP32[i58 + 8 >> 2] | 0;
  i68 = HEAP32[i58 + 12 >> 2] | 0;
  HEAP32[i54 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i54 + 4 >> 2] = i51;
  HEAP32[i54 + 8 >> 2] = i60;
  HEAP32[i54 + 12 >> 2] = i68;
  i58 = HEAP32[i61 + 4 >> 2] | 0;
  i68 = HEAP32[i61 + 8 >> 2] | 0;
  i60 = HEAP32[i61 + 12 >> 2] | 0;
  HEAP32[i57 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i57 + 4 >> 2] = i58;
  HEAP32[i57 + 8 >> 2] = i68;
  HEAP32[i57 + 12 >> 2] = i60;
  i60 = HEAP32[i59 + 4 >> 2] | 0;
  i61 = HEAP32[i59 + 8 >> 2] | 0;
  i68 = HEAP32[i59 + 12 >> 2] | 0;
  HEAP32[i55 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i55 + 4 >> 2] = i60;
  HEAP32[i55 + 8 >> 2] = i61;
  HEAP32[i55 + 12 >> 2] = i68;
  i68 = i7;
  i67 = __ZN5physx38setupFinalizeSolverConstraintsCoulomb4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRNS_27PxcCorrelationBufferCoulombEjjjRKNS_6shdfnd3aos5Vec4VESB_SB_SB_(i52, i67, i68, f66, f65, i53, i50, HEAP32[i62 >> 2] | 0, i10, i56, i54, i57, i55) | 0;
  HEAP32[i68 + (HEAP32[i63 >> 2] | 0) >> 2] = 0;
  HEAP32[i68 + ((HEAP32[i63 >> 2] | 0) + 4) >> 2] = i67 << 31 >> 31;
  i68 = 2;
  STACKTOP = i64;
  return i68 | 0;
 } else if ((i10 | 0) == 51) {
  STACKTOP = i64;
  return i1 | 0;
 }
 return 0;
}

function __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i18, i19, i28, i39, i1, i2, i70, i73, i74, i75) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i28 = i28 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i70 = i70 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i71 = 0, i72 = 0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0;
 if (i2 >>> 0 >= i70 >>> 0) return;
 i20 = HEAP32[i1 + 520 >> 2] | 0;
 i21 = i39 + 4 | 0;
 i22 = i39 + 8 | 0;
 i23 = i39 + 12 | 0;
 i24 = i39 + 16 | 0;
 i25 = i39 + 20 | 0;
 i26 = i39 + 24 | 0;
 i27 = i39 + 28 | 0;
 i29 = i39 + 32 | 0;
 i30 = i39 + 36 | 0;
 i31 = i39 + 40 | 0;
 i32 = i39 + 44 | 0;
 i33 = i39 + 48 | 0;
 i34 = i39 + 52 | 0;
 i35 = i39 + 56 | 0;
 i36 = i39 + 60 | 0;
 i37 = i18 + 32 | 0;
 i38 = i18 + 4 | 0;
 i40 = i18 + 8 | 0;
 i41 = i18 + 12 | 0;
 i42 = i18 + 16 | 0;
 i43 = i18 + 20 | 0;
 i44 = i18 + 24 | 0;
 i45 = i18 + 28 | 0;
 i46 = i19 + 32 | 0;
 i47 = i19 + 4 | 0;
 i48 = i19 + 8 | 0;
 i49 = i19 + 12 | 0;
 i50 = i19 + 16 | 0;
 i51 = i19 + 20 | 0;
 i52 = i19 + 24 | 0;
 i53 = i19 + 28 | 0;
 i54 = i28 + 32 | 0;
 i55 = i28 + 4 | 0;
 i56 = i28 + 8 | 0;
 i57 = i28 + 12 | 0;
 i58 = i28 + 16 | 0;
 i59 = i28 + 20 | 0;
 i60 = i28 + 24 | 0;
 i61 = i28 + 28 | 0;
 i62 = i74 + 12 | 0;
 i63 = i74 + 24 | 0;
 i64 = i74 + 4 | 0;
 i65 = i74 + 16 | 0;
 i66 = i74 + 28 | 0;
 i67 = i74 + 8 | 0;
 i68 = i74 + 20 | 0;
 i69 = i74 + 32 | 0;
 i71 = i1 + 60 | 0;
 i72 = i1 + 80 | 0;
 i1 = i1 + 100 | 0;
 i15 = i75 + 4 | 0;
 i16 = i75 + 8 | 0;
 i17 = i75 + 12 | 0;
 do {
  i100 = i20 + (i2 << 2) | 0;
  f84 = Math_fround(HEAPF32[i100 >> 2]);
  f82 = Math_fround(HEAPF32[i100 + 4 >> 2]);
  f80 = Math_fround(HEAPF32[i100 + 8 >> 2]);
  f84 = Math_fround(f84 * Math_fround(.00999999977));
  f82 = Math_fround(f82 * Math_fround(.00999999977));
  f80 = Math_fround(f80 * Math_fround(.00999999977));
  f78 = Math_fround(Math_fround(HEAPF32[i100 + 12 >> 2]) * Math_fround(.00999999977));
  i100 = HEAP32[i39 >> 2] | 0;
  i97 = HEAP32[i21 >> 2] | 0;
  i94 = HEAP32[i22 >> 2] | 0;
  i91 = HEAP32[i23 >> 2] | 0;
  i100 = i100 << 11 ^ i100;
  i97 = i97 << 11 ^ i97;
  i94 = i94 << 11 ^ i94;
  i91 = i91 << 11 ^ i91;
  i99 = HEAP32[i24 >> 2] | 0;
  i96 = HEAP32[i25 >> 2] | 0;
  i93 = HEAP32[i26 >> 2] | 0;
  i90 = HEAP32[i27 >> 2] | 0;
  i101 = HEAP32[i29 >> 2] | 0;
  i98 = HEAP32[i30 >> 2] | 0;
  i95 = HEAP32[i31 >> 2] | 0;
  i92 = HEAP32[i32 >> 2] | 0;
  i109 = HEAP32[i33 >> 2] | 0;
  i108 = HEAP32[i34 >> 2] | 0;
  i107 = HEAP32[i35 >> 2] | 0;
  i106 = HEAP32[i36 >> 2] | 0;
  i100 = i100 >>> 8 ^ i100 ^ i109;
  i105 = i100 ^ i109 >>> 19;
  i97 = i97 >>> 8 ^ i97 ^ i108;
  i104 = i97 ^ i108 >>> 19;
  i94 = i94 >>> 8 ^ i94 ^ i107;
  i103 = i94 ^ i107 >>> 19;
  i91 = i91 >>> 8 ^ i91 ^ i106;
  i102 = i91 ^ i106 >>> 19;
  i99 = i99 << 11 ^ i99;
  i96 = i96 << 11 ^ i96;
  i93 = i93 << 11 ^ i93;
  i90 = i90 << 11 ^ i90;
  i99 = i99 >>> 8 ^ i99 ^ i105;
  i100 = i99 ^ i100 >>> 19;
  i96 = i96 >>> 8 ^ i96 ^ i104;
  i97 = i96 ^ i97 >>> 19;
  i93 = i93 >>> 8 ^ i93 ^ i103;
  i94 = i93 ^ i94 >>> 19;
  i90 = i90 >>> 8 ^ i90 ^ i102;
  i91 = i90 ^ i91 >>> 19;
  i101 = i101 << 11 ^ i101;
  i98 = i98 << 11 ^ i98;
  i95 = i95 << 11 ^ i95;
  i92 = i92 << 11 ^ i92;
  HEAP32[i39 >> 2] = i109;
  HEAP32[i21 >> 2] = i108;
  HEAP32[i22 >> 2] = i107;
  HEAP32[i23 >> 2] = i106;
  HEAP32[i24 >> 2] = i105;
  HEAP32[i25 >> 2] = i104;
  HEAP32[i26 >> 2] = i103;
  HEAP32[i27 >> 2] = i102;
  HEAP32[i29 >> 2] = i100;
  HEAP32[i30 >> 2] = i97;
  HEAP32[i31 >> 2] = i94;
  HEAP32[i32 >> 2] = i91;
  HEAP32[i33 >> 2] = i101 >>> 8 ^ i101 ^ i100 ^ i99 >>> 19;
  HEAP32[i34 >> 2] = i98 >>> 8 ^ i98 ^ i97 ^ i96 >>> 19;
  HEAP32[i35 >> 2] = i95 >>> 8 ^ i95 ^ i94 ^ i93 >>> 19;
  HEAP32[i36 >> 2] = i92 >>> 8 ^ i92 ^ i91 ^ i90 >>> 19;
  f85 = Math_fround(HEAPF32[i37 >> 2]);
  f5 = Math_fround(HEAPF32[i18 >> 2]);
  f4 = Math_fround(f84 * f5);
  f3 = Math_fround(f82 * f5);
  f6 = Math_fround(f80 * f5);
  f5 = Math_fround(f78 * f5);
  f8 = Math_fround(HEAPF32[i38 >> 2]);
  f4 = Math_fround(f84 * Math_fround(f4 + f8));
  f3 = Math_fround(f82 * Math_fround(f3 + f8));
  f6 = Math_fround(f80 * Math_fround(f6 + f8));
  f8 = Math_fround(f78 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i40 >> 2]);
  f4 = Math_fround(f84 * Math_fround(f5 + f4));
  f3 = Math_fround(f82 * Math_fround(f5 + f3));
  f6 = Math_fround(f80 * Math_fround(f5 + f6));
  f8 = Math_fround(f78 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i41 >> 2]);
  f4 = Math_fround(f5 + f4);
  f3 = Math_fround(f5 + f3);
  f6 = Math_fround(f5 + f6);
  f8 = Math_fround(f5 + f8);
  f5 = Math_fround(f84 - f85);
  f88 = Math_fround(f82 - f85);
  f87 = Math_fround(f80 - f85);
  f86 = Math_fround(f78 - f85);
  f13 = Math_fround(HEAPF32[i42 >> 2]);
  f14 = Math_fround(f5 * f13);
  f12 = Math_fround(f88 * f13);
  f10 = Math_fround(f87 * f13);
  f13 = Math_fround(f86 * f13);
  f89 = Math_fround(HEAPF32[i43 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f14 + f89));
  f12 = Math_fround(f88 * Math_fround(f12 + f89));
  f10 = Math_fround(f87 * Math_fround(f10 + f89));
  f89 = Math_fround(f86 * Math_fround(f13 + f89));
  f13 = Math_fround(HEAPF32[i44 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f13 + f14));
  f12 = Math_fround(f88 * Math_fround(f13 + f12));
  f10 = Math_fround(f87 * Math_fround(f13 + f10));
  f89 = Math_fround(f86 * Math_fround(f13 + f89));
  f13 = Math_fround(HEAPF32[i45 >> 2]);
  f14 = Math_fround(f13 + f14);
  f12 = Math_fround(f13 + f12);
  f10 = Math_fround(f13 + f10);
  f89 = Math_fround(f13 + f89);
  f4 = f84 > f85 ? f14 : f4;
  f3 = f82 > f85 ? f12 : f3;
  f6 = f80 > f85 ? f10 : f6;
  f8 = f78 > f85 ? f89 : f8;
  f89 = Math_fround(HEAPF32[i46 >> 2]);
  f85 = Math_fround(HEAPF32[i19 >> 2]);
  f10 = Math_fround(f84 * f85);
  f12 = Math_fround(f82 * f85);
  f14 = Math_fround(f80 * f85);
  f85 = Math_fround(f78 * f85);
  f13 = Math_fround(HEAPF32[i47 >> 2]);
  f10 = Math_fround(f84 * Math_fround(f10 + f13));
  f12 = Math_fround(f82 * Math_fround(f12 + f13));
  f14 = Math_fround(f80 * Math_fround(f14 + f13));
  f13 = Math_fround(f78 * Math_fround(f85 + f13));
  f85 = Math_fround(HEAPF32[i48 >> 2]);
  f10 = Math_fround(f84 * Math_fround(f85 + f10));
  f12 = Math_fround(f82 * Math_fround(f85 + f12));
  f14 = Math_fround(f80 * Math_fround(f85 + f14));
  f13 = Math_fround(f78 * Math_fround(f85 + f13));
  f85 = Math_fround(HEAPF32[i49 >> 2]);
  f10 = Math_fround(f85 + f10);
  f12 = Math_fround(f85 + f12);
  f14 = Math_fround(f85 + f14);
  f13 = Math_fround(f85 + f13);
  f85 = Math_fround(f84 - f89);
  f86 = Math_fround(f82 - f89);
  f87 = Math_fround(f80 - f89);
  f88 = Math_fround(f78 - f89);
  f5 = Math_fround(HEAPF32[i50 >> 2]);
  f7 = Math_fround(f85 * f5);
  f9 = Math_fround(f86 * f5);
  f11 = Math_fround(f87 * f5);
  f5 = Math_fround(f88 * f5);
  f77 = Math_fround(HEAPF32[i51 >> 2]);
  f7 = Math_fround(f85 * Math_fround(f7 + f77));
  f9 = Math_fround(f86 * Math_fround(f9 + f77));
  f11 = Math_fround(f87 * Math_fround(f11 + f77));
  f77 = Math_fround(f88 * Math_fround(f5 + f77));
  f5 = Math_fround(HEAPF32[i52 >> 2]);
  f7 = Math_fround(f85 * Math_fround(f5 + f7));
  f9 = Math_fround(f86 * Math_fround(f5 + f9));
  f11 = Math_fround(f87 * Math_fround(f5 + f11));
  f77 = Math_fround(f88 * Math_fround(f5 + f77));
  f5 = Math_fround(HEAPF32[i53 >> 2]);
  f7 = Math_fround(f5 + f7);
  f9 = Math_fround(f5 + f9);
  f11 = Math_fround(f5 + f11);
  f77 = Math_fround(f5 + f77);
  f10 = f84 > f89 ? f7 : f10;
  f12 = f82 > f89 ? f9 : f12;
  f14 = f80 > f89 ? f11 : f14;
  f13 = f78 > f89 ? f77 : f13;
  f77 = Math_fround(HEAPF32[i54 >> 2]);
  f89 = Math_fround(HEAPF32[i28 >> 2]);
  f11 = Math_fround(f84 * f89);
  f9 = Math_fround(f82 * f89);
  f7 = Math_fround(f80 * f89);
  f89 = Math_fround(f78 * f89);
  f5 = Math_fround(HEAPF32[i55 >> 2]);
  f11 = Math_fround(f84 * Math_fround(f11 + f5));
  f9 = Math_fround(f82 * Math_fround(f9 + f5));
  f7 = Math_fround(f80 * Math_fround(f7 + f5));
  f5 = Math_fround(f78 * Math_fround(f89 + f5));
  f89 = Math_fround(HEAPF32[i56 >> 2]);
  f11 = Math_fround(f84 * Math_fround(f89 + f11));
  f9 = Math_fround(f82 * Math_fround(f89 + f9));
  f7 = Math_fround(f80 * Math_fround(f89 + f7));
  f5 = Math_fround(f78 * Math_fround(f89 + f5));
  f89 = Math_fround(HEAPF32[i57 >> 2]);
  f11 = Math_fround(f89 + f11);
  f9 = Math_fround(f89 + f9);
  f7 = Math_fround(f89 + f7);
  f5 = Math_fround(f89 + f5);
  f89 = Math_fround(f84 - f77);
  f88 = Math_fround(f82 - f77);
  f87 = Math_fround(f80 - f77);
  f86 = Math_fround(f78 - f77);
  f85 = Math_fround(HEAPF32[i58 >> 2]);
  f83 = Math_fround(f89 * f85);
  f81 = Math_fround(f88 * f85);
  f79 = Math_fround(f87 * f85);
  f85 = Math_fround(f86 * f85);
  f76 = Math_fround(HEAPF32[i59 >> 2]);
  f83 = Math_fround(f89 * Math_fround(f83 + f76));
  f81 = Math_fround(f88 * Math_fround(f81 + f76));
  f79 = Math_fround(f87 * Math_fround(f79 + f76));
  f76 = Math_fround(f86 * Math_fround(f85 + f76));
  f85 = Math_fround(HEAPF32[i60 >> 2]);
  f83 = Math_fround(f89 * Math_fround(f85 + f83));
  f81 = Math_fround(f88 * Math_fround(f85 + f81));
  f79 = Math_fround(f87 * Math_fround(f85 + f79));
  f76 = Math_fround(f86 * Math_fround(f85 + f76));
  f85 = Math_fround(HEAPF32[i61 >> 2]);
  f83 = Math_fround(f85 + f83);
  f81 = Math_fround(f85 + f81);
  f79 = Math_fround(f85 + f79);
  f76 = Math_fround(f85 + f76);
  f11 = f84 > f77 ? f83 : f11;
  f9 = f82 > f77 ? f81 : f9;
  f7 = f80 > f77 ? f79 : f7;
  f5 = f78 > f77 ? f76 : f5;
  if (i73) {
   f80 = Math_fround(HEAPF32[i74 >> 2]);
   f78 = Math_fround(f4 * f80);
   f89 = Math_fround(f3 * f80);
   f79 = Math_fround(f6 * f80);
   f80 = Math_fround(f8 * f80);
   f84 = Math_fround(HEAPF32[i62 >> 2]);
   f78 = Math_fround(f78 + Math_fround(f10 * f84));
   f89 = Math_fround(f89 + Math_fround(f12 * f84));
   f79 = Math_fround(f79 + Math_fround(f14 * f84));
   f84 = Math_fround(f80 + Math_fround(f13 * f84));
   f80 = Math_fround(HEAPF32[i63 >> 2]);
   f78 = Math_fround(f78 + Math_fround(f11 * f80));
   f89 = Math_fround(f89 + Math_fround(f9 * f80));
   f79 = Math_fround(f79 + Math_fround(f7 * f80));
   f80 = Math_fround(f84 + Math_fround(f5 * f80));
   f84 = Math_fround(HEAPF32[i64 >> 2]);
   f81 = Math_fround(f4 * f84);
   f82 = Math_fround(f3 * f84);
   f83 = Math_fround(f6 * f84);
   f84 = Math_fround(f8 * f84);
   f88 = Math_fround(HEAPF32[i65 >> 2]);
   f81 = Math_fround(f81 + Math_fround(f10 * f88));
   f82 = Math_fround(f82 + Math_fround(f12 * f88));
   f83 = Math_fround(f83 + Math_fround(f14 * f88));
   f88 = Math_fround(f84 + Math_fround(f13 * f88));
   f84 = Math_fround(HEAPF32[i66 >> 2]);
   f81 = Math_fround(f81 + Math_fround(f11 * f84));
   f82 = Math_fround(f82 + Math_fround(f9 * f84));
   f83 = Math_fround(f83 + Math_fround(f7 * f84));
   f84 = Math_fround(f88 + Math_fround(f5 * f84));
   f88 = Math_fround(HEAPF32[i67 >> 2]);
   f85 = Math_fround(f4 * f88);
   f86 = Math_fround(f3 * f88);
   f87 = Math_fround(f6 * f88);
   f3 = Math_fround(f8 * f88);
   f88 = Math_fround(HEAPF32[i68 >> 2]);
   f85 = Math_fround(f85 + Math_fround(f10 * f88));
   f86 = Math_fround(f86 + Math_fround(f12 * f88));
   f87 = Math_fround(f87 + Math_fround(f14 * f88));
   f88 = Math_fround(f3 + Math_fround(f13 * f88));
   f3 = Math_fround(HEAPF32[i69 >> 2]);
   f4 = f78;
   f6 = f79;
   f8 = f80;
   f10 = f81;
   f12 = f82;
   f14 = f83;
   f13 = f84;
   f11 = Math_fround(f85 + Math_fround(f11 * f3));
   f9 = Math_fround(f86 + Math_fround(f9 * f3));
   f7 = Math_fround(f87 + Math_fround(f7 * f3));
   f5 = Math_fround(f88 + Math_fround(f5 * f3));
   f3 = f89;
  }
  i98 = (HEAP32[i71 >> 2] | 0) + (i2 << 2) | 0;
  f77 = Math_fround(HEAPF32[i98 >> 2]);
  i99 = i98 + 4 | 0;
  f114 = Math_fround(HEAPF32[i99 >> 2]);
  i100 = i98 + 8 | 0;
  f113 = Math_fround(HEAPF32[i100 >> 2]);
  i101 = i98 + 12 | 0;
  f81 = Math_fround(HEAPF32[i101 >> 2]);
  i102 = (HEAP32[i72 >> 2] | 0) + (i2 << 2) | 0;
  f82 = Math_fround(HEAPF32[i102 >> 2]);
  i103 = i102 + 4 | 0;
  f83 = Math_fround(HEAPF32[i103 >> 2]);
  i104 = i102 + 8 | 0;
  f84 = Math_fround(HEAPF32[i104 >> 2]);
  i105 = i102 + 12 | 0;
  f85 = Math_fround(HEAPF32[i105 >> 2]);
  i106 = (HEAP32[i1 >> 2] | 0) + (i2 << 2) | 0;
  f112 = Math_fround(HEAPF32[i106 >> 2]);
  i107 = i106 + 4 | 0;
  f111 = Math_fround(HEAPF32[i107 >> 2]);
  i108 = i106 + 8 | 0;
  f110 = Math_fround(HEAPF32[i108 >> 2]);
  i109 = i106 + 12 | 0;
  f76 = Math_fround(HEAPF32[i109 >> 2]);
  f86 = Math_fround(HEAPF32[i75 >> 2]);
  f78 = Math_fround(f4 * f86);
  f87 = Math_fround(HEAPF32[i15 >> 2]);
  f79 = Math_fround(f3 * f87);
  f88 = Math_fround(HEAPF32[i16 >> 2]);
  f80 = Math_fround(f6 * f88);
  f89 = Math_fround(HEAPF32[i17 >> 2]);
  f79 = Math_fround(f114 + f79);
  f80 = Math_fround(f113 + f80);
  f81 = Math_fround(f81 + Math_fround(f8 * f89));
  f82 = Math_fround(f82 + Math_fround(f10 * f86));
  f83 = Math_fround(f83 + Math_fround(f12 * f87));
  f84 = Math_fround(f84 + Math_fround(f14 * f88));
  f85 = Math_fround(f85 + Math_fround(f13 * f89));
  f86 = Math_fround(f112 + Math_fround(f11 * f86));
  f87 = Math_fround(f111 + Math_fround(f9 * f87));
  f88 = Math_fround(f110 + Math_fround(f7 * f88));
  f89 = Math_fround(f76 + Math_fround(f5 * f89));
  HEAPF32[i98 >> 2] = Math_fround(f77 + f78);
  HEAPF32[i99 >> 2] = f79;
  HEAPF32[i100 >> 2] = f80;
  HEAPF32[i101 >> 2] = f81;
  HEAPF32[i102 >> 2] = f82;
  HEAPF32[i103 >> 2] = f83;
  HEAPF32[i104 >> 2] = f84;
  HEAPF32[i105 >> 2] = f85;
  HEAPF32[i106 >> 2] = f86;
  HEAPF32[i107 >> 2] = f87;
  HEAPF32[i108 >> 2] = f88;
  HEAPF32[i109 >> 2] = f89;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i70 >>> 0);
 return;
}

function __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv(i28) {
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 10352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 10240 | 0;
 i10 = i29 + 8192 | 0;
 i9 = i29;
 i7 = i29 + 10340 | 0;
 i8 = i29 + 10339 | 0;
 i22 = i29 + 10338 | 0;
 i23 = i29 + 10337 | 0;
 i26 = i29 + 10336 | 0;
 i1 = i28 + 7584 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i29;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 i25 = HEAP32[i28 >> 2] | 0;
 if (!i25) {
  HEAP32[i28 + 584 >> 2] = 0;
  STACKTOP = i29;
  return;
 }
 i24 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i29 + 10341 | 0, i25 << 2, gb + 710466 | 0, 998) | 0;
 i1 = HEAP32[i28 + 12 >> 2] | 0;
 i2 = 0;
 do {
  i21 = i1 + (i2 << 3) | 0;
  HEAP32[i24 + (i2 << 2) >> 2] = HEAP32[i21 >> 2];
  HEAP32[i21 >> 2] = i2;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i25 | 0));
 i21 = i25 >>> 0 > 256;
 if (i21) {
  i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i25 << 3, gb + 710466 | 0, 1013) | 0;
  i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, i25 << 5, gb + 710466 | 0, 1014) | 0;
 }
 i15 = HEAP32[i28 + 8 >> 2] | 0;
 i20 = i28 + 12 | 0;
 i16 = HEAP32[i20 >> 2] | 0;
 i14 = i25 + -1 | 0;
 i11 = i15 + (i14 * 24 | 0) | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i11 = HEAP32[i11 + 8 >> 2] | 0;
 i12 = i15 + (i14 * 24 | 0) + 12 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i12 = HEAP32[i12 + 8 >> 2] | 0;
 if (i14) {
  i13 = 0;
  do {
   i19 = i15 + (i13 * 24 | 0) | 0;
   f5 = Math_fround(HEAPF32[i19 >> 2]);
   f31 = Math_fround(HEAPF32[i19 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i19 + 8 >> 2]);
   f30 = Math_fround(HEAPF32[i19 + 12 >> 2]);
   f32 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = (HEAPF32[tempDoublePtr >> 2] = f32 < f5 ? f32 : f5, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f3 < f31 ? f3 : f31, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f6 < f4 ? f6 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = i15 + (i13 * 24 | 0) + 12 | 0;
   f4 = Math_fround(HEAPF32[i19 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i19 + 8 >> 2]);
   f31 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f31 > f30 ? f31 : f30, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3 > f4 ? f3 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f5 > f6 ? f5 : f6, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i14 | 0));
 }
 f34 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f34 + f30);
 f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f33 + f31);
 f3 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 * Math_fround(.5));
 f6 = Math_fround(Math_fround(f3 + f32) * Math_fround(.5));
 f30 = Math_fround(Math_fround(f34 - f30) * Math_fround(.5));
 f31 = Math_fround(Math_fround(f33 - f31) * Math_fround(.5));
 f32 = Math_fround(Math_fround(f3 - f32) * Math_fround(.5));
 i8 = i28 + 608 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f4 * Math_fround(.5));
 HEAPF32[i28 + 612 >> 2] = f5;
 HEAPF32[i28 + 616 >> 2] = f6;
 HEAPF32[i28 + 624 >> 2] = f30;
 HEAPF32[i28 + 628 >> 2] = f31;
 HEAPF32[i28 + 632 >> 2] = f32;
 i7 = Math_fround(Math_abs(Math_fround(f31))) < Math_fround(Math_abs(Math_fround(f32)));
 i7 = i7 ? 1 : 2;
 i1 = 0;
 do {
  HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[i15 + (i1 * 24 | 0) + (i7 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i25 | 0));
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i27);
 i1 = 0;
 i2 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKfj(i27, i10, i25) | 0) + 8 >> 2] | 0;
 while (1) {
  i17 = HEAP32[i2 >> 2] | 0;
  i18 = i15 + (i17 * 24 | 0) | 0;
  f3 = Math_fround(HEAPF32[i18 >> 2]);
  f32 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  i18 = i15 + (i17 * 24 | 0) + 12 | 0;
  f35 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f5 = Math_fround(Math_fround(f32 + f35) * Math_fround(.5));
  f6 = Math_fround(Math_fround(f33 + f34) * Math_fround(.5));
  f30 = Math_fround(Math_fround(f4 + Math_fround(0.0)) * Math_fround(.5));
  f31 = Math_fround(Math_fround(f4 - f3) * Math_fround(.5));
  f32 = Math_fround(Math_fround(f35 - f32) * Math_fround(.5));
  f33 = Math_fround(Math_fround(f34 - f33) * Math_fround(.5));
  f34 = Math_fround(Math_fround(Math_fround(0.0) - f4) * Math_fround(.5));
  i18 = i9 + (i1 << 5) | 0;
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(f3 + f4) * Math_fround(.5));
  HEAPF32[i18 + 4 >> 2] = f5;
  HEAPF32[i18 + 8 >> 2] = f6;
  HEAPF32[i18 + 12 >> 2] = f30;
  i18 = i9 + (i1 << 5) + 16 | 0;
  HEAPF32[i18 >> 2] = f31;
  HEAPF32[i18 + 4 >> 2] = f32;
  HEAPF32[i18 + 8 >> 2] = f33;
  HEAPF32[i18 + 12 >> 2] = f34;
  i17 = i16 + (i17 << 3) | 0;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i19 = i10 + (i1 << 3) | 0;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = i18;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i25 | 0)) break; else i2 = i2 + 4 | 0;
 }
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i27);
 i17 = i28 + 592 | 0;
 HEAP32[i17 >> 2] = i7;
 __ZN5physx2Sq16BucketPrunerCore20allocateSortedMemoryEj(i28, i25);
 i16 = i28 + 20 | 0;
 i18 = i28 + 24 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 f35 = Math_fround(HEAPF32[i8 >> 2]);
 i19 = i28 + 640 | 0;
 __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj(i19, f35, Math_fround(HEAPF32[i8 + (((i2 | 0) == 1 ? 2 : 1) << 2) >> 2]), i25, i9, i10, HEAP32[i16 >> 2] | 0, HEAP32[i18 >> 2] | 0, 0, i2);
 i2 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i11 = (i8 | 0) == 1 ? 2 : 1;
 i12 = 0;
 do {
  i1 = HEAP32[i28 + 640 + (i12 << 2) >> 2] | 0;
  if (!i1) {
   i1 = i28 + 864 + (i12 * 224 | 0) | 0;
   i15 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i15 | 0));
  } else {
   i15 = HEAP32[i28 + 660 + (i12 << 2) >> 2] | 0;
   i14 = i2 + (i15 << 5) | 0;
   i15 = i7 + (i15 << 3) | 0;
   i13 = i28 + 688 + (i12 << 5) | 0;
   f35 = Math_fround(HEAPF32[i13 >> 2]);
   __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj(i28 + 864 + (i12 * 224 | 0) | 0, f35, Math_fround(HEAPF32[i13 + (i11 << 2) >> 2]), i1, i14, i15, i9, i10, (i12 | 0) == 4, i8);
   _memcpy(i14 | 0, i9 | 0, i1 << 5 | 0) | 0;
   _memcpy(i15 | 0, i10 | 0, i1 << 3 | 0) | 0;
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 5);
 i14 = 0;
 do {
  i2 = HEAP32[i16 >> 2] | 0;
  i7 = HEAP32[i28 + 660 + (i14 << 2) >> 2] | 0;
  i8 = HEAP32[i18 >> 2] | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  i12 = (i11 | 0) == 1 ? 2 : 1;
  i13 = 0;
  do {
   i1 = HEAP32[i28 + 864 + (i14 * 224 | 0) + (i13 << 2) >> 2] | 0;
   if (!i1) {
    i1 = i28 + 1984 + (i14 * 1120 | 0) + (i13 * 224 | 0) | 0;
    i15 = i1 + 40 | 0;
    do {
     HEAP32[i1 >> 2] = 0;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) < (i15 | 0));
   } else {
    i15 = (HEAP32[i28 + 864 + (i14 * 224 | 0) + 20 + (i13 << 2) >> 2] | 0) + i7 | 0;
    i36 = i2 + (i15 << 5) | 0;
    i15 = i8 + (i15 << 3) | 0;
    i37 = i28 + 864 + (i14 * 224 | 0) + 48 + (i13 << 5) | 0;
    f35 = Math_fround(HEAPF32[i37 >> 2]);
    __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj(i28 + 1984 + (i14 * 1120 | 0) + (i13 * 224 | 0) | 0, f35, Math_fround(HEAPF32[i37 + (i12 << 2) >> 2]), i1, i36, i15, i9, i10, (i13 | 0) == 4, i11);
    _memcpy(i36 | 0, i9 | 0, i1 << 5 | 0) | 0;
    _memcpy(i15 | 0, i10 | 0, i1 << 3 | 0) | 0;
   }
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != 5);
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != 5);
 i7 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = 0;
 do {
  f34 = Math_fround(HEAPF32[i7 + (i2 << 5) + (i1 << 2) >> 2]);
  f35 = Math_fround(HEAPF32[i7 + (i2 << 5) + 16 + (i1 << 2) >> 2]);
  f33 = Math_fround(f34 - f35);
  i36 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  f35 = Math_fround(f34 + f35);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
  HEAP32[i7 + (i2 << 5) + 12 >> 2] = (i36 | 0) < 0 ? ~i36 : i36 | -2147483648;
  HEAP32[i7 + (i2 << 5) + 28 >> 2] = (i37 | 0) < 0 ? ~i37 : i37 | -2147483648;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i25 | 0));
 if (i21) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i9);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i23, i10);
 }
 i8 = HEAP32[i18 >> 2] | 0;
 i7 = HEAP32[i20 >> 2] | 0;
 i1 = HEAP32[i28 + 16 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  do {
   i23 = i8 + (i1 << 3) | 0;
   i37 = HEAP32[i23 >> 2] | 0;
   i36 = HEAP32[i24 + (i37 << 2) >> 2] | 0;
   HEAP32[i23 >> 2] = i36;
   HEAP32[i7 + (i37 << 3) >> 2] = i36;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i25 | 0));
 } else {
  i2 = 0;
  do {
   i23 = i8 + (i2 << 3) | 0;
   i37 = HEAP32[i23 >> 2] | 0;
   i36 = HEAP32[i24 + (i37 << 2) >> 2] | 0;
   HEAP32[i23 >> 2] = i36;
   HEAP32[i7 + (i37 << 3) >> 2] = i36;
   HEAP32[i1 + (i37 << 2) >> 2] = i2;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i25 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i24);
 HEAP32[i27 >> 2] = 1065353216;
 HEAP32[i27 + 4 >> 2] = 1065353216;
 HEAP32[i27 + 8 >> 2] = 1065353216;
 HEAP32[i27 + 12 >> 2] = 1065353216;
 HEAP32[i27 + 16 >> 2] = 1065353216;
 HEAP32[i27 + 20 >> 2] = -1082130432;
 HEAP32[i27 + 24 >> 2] = 1065353216;
 HEAP32[i27 + 28 >> 2] = -1082130432;
 HEAP32[i27 + 32 >> 2] = 1065353216;
 HEAP32[i27 + 36 >> 2] = 1065353216;
 HEAP32[i27 + 40 >> 2] = -1082130432;
 HEAP32[i27 + 44 >> 2] = -1082130432;
 HEAP32[i27 + 48 >> 2] = -1082130432;
 HEAP32[i27 + 52 >> 2] = 1065353216;
 HEAP32[i27 + 56 >> 2] = 1065353216;
 HEAP32[i27 + 60 >> 2] = -1082130432;
 HEAP32[i27 + 64 >> 2] = 1065353216;
 HEAP32[i27 + 68 >> 2] = -1082130432;
 HEAP32[i27 + 72 >> 2] = -1082130432;
 HEAP32[i27 + 76 >> 2] = -1082130432;
 HEAP32[i27 + 80 >> 2] = 1065353216;
 HEAP32[i27 + 84 >> 2] = -1082130432;
 HEAP32[i27 + 88 >> 2] = -1082130432;
 HEAP32[i27 + 92 >> 2] = -1082130432;
 f5 = Math_fround(1.0);
 f6 = Math_fround(1.0);
 i1 = 0;
 while (1) {
  i2 = i27 + (i1 * 12 | 0) | 0;
  f3 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
  if (f4 > Math_fround(0.0)) {
   f35 = Math_fround(Math_fround(1.0) / f4);
   HEAPF32[i2 >> 2] = Math_fround(f3 * f35);
   HEAPF32[i27 + (i1 * 12 | 0) + 4 >> 2] = Math_fround(f5 * f35);
   HEAPF32[i27 + (i1 * 12 | 0) + 8 >> 2] = Math_fround(f6 * f35);
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 8) break;
  f5 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 8 >> 2]);
 }
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i19, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 864 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 1088 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 1312 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 1536 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 1760 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 1984 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 2208 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 2432 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 2656 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 2880 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 3104 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 3328 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 3552 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 3776 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 4e3 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 4224 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 4448 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 4672 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 4896 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 5120 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 5344 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 5568 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 5792 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 6016 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 6240 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 6464 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 6688 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 6912 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 7136 | 0, i27);
 __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i28 + 7360 | 0, i27);
 STACKTOP = i29;
 return;
}

function __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i9, i10, i11, i12, i15, i16, i18, i19, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i17 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20 + 32 | 0;
 i7 = i20 + 16 | 0;
 i6 = i20 + 8 | 0;
 i5 = i20;
 i14 = i20 + 44 | 0;
 if ((i18 | 0) < 1 | (i19 | 0) < 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 404561 | 0, 0, gb + 404494 | 0, 1772, 1, 0, 0, 0);
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i1 = (i15 | 0) < 0;
 i3 = (i16 | 0) < 0;
 if ((i16 | i15 | 0) >= 0) {
  i4 = i18 + i15 | 0;
  if ((i4 | 0) >= 0) {
   i17 = i19 + i16 | 0;
   if (!((i17 | 0) > (i11 | 0) | ((i4 | 0) > (i10 | 0) | (i17 | 0) < 0))) {
    do if ((i12 + -10 | 0) >>> 0 < 3) i13 = 20; else if (((i12 | 1) + -25 | 0) >>> 0 < 5) i13 = 20; else {
     i1 = i12 + -30 | 0;
     if (i1 >>> 0 < 15) if ((i12 + -48 | 0) >>> 0 < 12 | ((i12 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
      i13 = 20;
      break;
     } else break; else if ((i12 + -45 | 0) >>> 0 < 3 | (i12 + -48 | 0) >>> 0 < 12) {
      i13 = 20;
      break;
     } else break;
    } while (0);
    L15 : do if ((i13 | 0) == 20) {
     switch (i12 | 0) {
     case 10:
     case 11:
     case 12:
     case 26:
     case 27:
      break;
     default:
      if ((i12 | 1 | 0) != 25) break L15;
     }
     __ZL19HandleDecompressionPKhii13TextureFormatiiii(i14, i9, i10, i11, i12, i15, i16, i18, i19);
     i8 = HEAP32[i14 >> 2] | 0;
     i3 = HEAP32[i14 + 4 >> 2] | 0;
     i4 = HEAP32[i14 + 8 >> 2] | 0;
     i1 = (i19 | 0) > 0;
     if (!(HEAP8[i14 + 12 >> 0] | 0)) {
      if (i1) {
       i7 = i4 << 2;
       if ((i18 | 0) > 0) {
        i6 = 0;
        i5 = i8 + (((i15 | 0) % (i3 | 0) | 0) << 2) + ((Math_imul((i16 | 0) % (i3 | 0) | 0, i4) | 0) << 2) | 0;
        while (1) {
         i1 = i5;
         i3 = 0;
         i4 = i2;
         while (1) {
          f23 = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
          f22 = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
          f21 = Math_fround(Math_fround(HEAPU8[i1 + 3 >> 0] | 0) / Math_fround(255.0));
          HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
          HEAPF32[i4 + 4 >> 2] = f23;
          HEAPF32[i4 + 8 >> 2] = f22;
          HEAPF32[i4 + 12 >> 2] = f21;
          i3 = i3 + 1 | 0;
          if ((i3 | 0) == (i18 | 0)) break; else {
           i1 = i1 + 4 | 0;
           i4 = i4 + 16 | 0;
          }
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i19 | 0)) break; else {
          i5 = i5 + i7 | 0;
          i2 = i2 + (i18 << 4) | 0;
         }
        }
       }
      }
     } else if (i1) {
      i7 = i4 << 2;
      if ((i18 | 0) > 0) {
       i6 = 0;
       i5 = i8 + (((i15 | 0) % (i3 | 0) | 0) << 2) + ((Math_imul((i16 | 0) % (i3 | 0) | 0, i4) | 0) << 2) | 0;
       while (1) {
        i1 = i5;
        i3 = 0;
        i4 = i2;
        while (1) {
         i15 = HEAP32[i1 + 4 >> 2] | 0;
         i16 = HEAP32[i1 + 8 >> 2] | 0;
         i17 = HEAP32[i1 + 12 >> 2] | 0;
         HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
         HEAP32[i4 + 4 >> 2] = i15;
         HEAP32[i4 + 8 >> 2] = i16;
         HEAP32[i4 + 12 >> 2] = i17;
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i18 | 0)) break; else {
          i1 = i1 + 16 | 0;
          i4 = i4 + 16 | 0;
         }
        }
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i19 | 0)) break; else {
         i5 = i5 + (i7 << 2) | 0;
         i2 = i2 + (i18 << 4) | 0;
        }
       }
      }
     }
     __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
     i19 = 1;
     STACKTOP = i20;
     return i19 | 0;
    } while (0);
    i17 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i10, i12) | 0;
    if (!i9) i13 = 40; else {
     if ((i12 | 0) < 9) i1 = 1; else i1 = (i12 | 0) == 1e3 | ((i12 | 0) == 23 | (i12 + -13 | 0) >>> 0 < 9);
     if ((i10 | 0) > 0 & (i11 | 0) > 0 & (i12 | 0) > 0 & i1) i1 = i9; else i13 = 40;
    }
    if ((i13 | 0) == 40) i1 = 0;
    switch (i12 | 0) {
    case 5:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(5) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f21 = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
        f22 = Math_fround(Math_fround(HEAPU8[i1 + 3 >> 0] | 0) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 + 4 >> 2] = f21;
        HEAPF32[i4 + 8 >> 2] = f22;
        HEAPF32[i4 + 12 >> 2] = f23;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 4:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(4) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f21 = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
        f22 = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(HEAPU8[i1 + 3 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 + 4 >> 2] = f21;
        HEAPF32[i4 + 8 >> 2] = f22;
        HEAPF32[i4 + 12 >> 2] = f23;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 14:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(14) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f21 = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
        f22 = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(HEAPU8[i1 + 3 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 + 4 >> 2] = f21;
        HEAPF32[i4 + 8 >> 2] = f22;
        HEAPF32[i4 + 12 >> 2] = f23;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 3:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(3) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f22 = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
        f23 = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
        HEAPF32[i4 + 4 >> 2] = f22;
        HEAPF32[i4 + 8 >> 2] = f23;
        HEAP32[i4 + 12 >> 2] = 1065353216;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 1:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(1) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        f23 = Math_fround(Math_fround(HEAPU8[i1 >> 0] | 0) / Math_fround(255.0));
        HEAP32[i4 >> 2] = 1065353216;
        HEAP32[i4 + 4 >> 2] = 1065353216;
        HEAP32[i4 + 8 >> 2] = 1065353216;
        HEAPF32[i4 + 12 >> 2] = f23;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 7:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(7) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        i16 = HEAP16[i1 >> 1] | 0;
        i15 = i16 & 65535;
        f22 = Math_fround(Math_fround(i15 >>> 5 & 63 | 0) * Math_fround(.0158730168));
        f23 = Math_fround(Math_fround(i15 & 31 | 0) * Math_fround(.0322580636));
        HEAPF32[i4 >> 2] = Math_fround(Math_fround((i16 & 65535) >>> 11 & 65535) * Math_fround(.0322580636));
        HEAPF32[i4 + 4 >> 2] = f22;
        HEAPF32[i4 + 8 >> 2] = f23;
        HEAP32[i4 + 12 >> 2] = 1065353216;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 20:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(20) | 0;
      if (!((i18 | 0) > 0 & (i19 | 0) > 0)) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        i14 = HEAP32[i1 + 4 >> 2] | 0;
        i15 = HEAP32[i1 + 8 >> 2] | 0;
        i16 = HEAP32[i1 + 12 >> 2] | 0;
        HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i4 + 4 >> 2] = i14;
        HEAP32[i4 + 8 >> 2] = i15;
        HEAP32[i4 + 12 >> 2] = i16;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    case 17:
     {
      i7 = __Z25GetBytesFromTextureFormat13TextureFormat(17) | 0;
      if ((i19 | 0) <= 0) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i8 = i14 + 4 | 0;
      i9 = i14 + 8 | 0;
      i10 = i14 + 12 | 0;
      if ((i18 | 0) <= 0) {
       i19 = 1;
       STACKTOP = i20;
       return i19 | 0;
      }
      i6 = 0;
      i5 = i1 + (Math_imul(i17, i16) | 0) + (Math_imul(i7, i15) | 0) | 0;
      while (1) {
       i1 = i5;
       i3 = 0;
       i4 = i2;
       while (1) {
        __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i1, 17, i14);
        i13 = HEAP32[i8 >> 2] | 0;
        i15 = HEAP32[i9 >> 2] | 0;
        i16 = HEAP32[i10 >> 2] | 0;
        HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i4 + 4 >> 2] = i13;
        HEAP32[i4 + 8 >> 2] = i15;
        HEAP32[i4 + 12 >> 2] = i16;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i1 = i1 + i7 | 0;
         i4 = i4 + 16 | 0;
        }
       }
       i6 = i6 + 1 | 0;
       if ((i6 | 0) == (i19 | 0)) {
        i1 = 1;
        break;
       } else {
        i5 = i5 + i17 | 0;
        i2 = i2 + (i18 << 4) | 0;
       }
      }
      STACKTOP = i20;
      return i1 | 0;
     }
    default:
     {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1823, 1, 0, 0, 0);
      i19 = 0;
      STACKTOP = i20;
      return i19 | 0;
     }
    }
   }
  }
 }
 if (i1) {
  HEAP32[i5 >> 2] = i15;
  _snprintf(i14, 255, gb + 404595 | 0, i5) | 0;
 }
 if (i3) {
  HEAP32[i6 >> 2] = i16;
  _snprintf(i14, 255, gb + 404595 | 0, i6) | 0;
 }
 if ((i18 + i15 | 0) > (i10 | 0)) {
  HEAP32[i7 >> 2] = i15;
  HEAP32[i7 + 4 >> 2] = i18;
  HEAP32[i7 + 8 >> 2] = i10;
  _snprintf(i14, 255, gb + 404639 | 0, i7) | 0;
 }
 if ((i19 + i16 | 0) > (i11 | 0)) {
  HEAP32[i8 >> 2] = i16;
  HEAP32[i8 + 4 >> 2] = i19;
  HEAP32[i8 + 8 >> 2] = i11;
  _snprintf(i14, 255, gb + 404639 | 0, i8) | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i14, 0, gb + 404494 | 0, 1790, 1, 0, 0, 0);
 i19 = 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN5Unity5Cloth14SetupCollidersEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i29 + 8 | 0;
 i22 = i29;
 i27 = i29 + 16 | 0;
 i28 = i20 + 228 | 0;
 if (!(HEAP32[i28 >> 2] | 0)) {
  STACKTOP = i29;
  return;
 }
 i26 = gb + 64016 | 0;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i22;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i27 >> 2] = 0;
 i24 = i27 + 12 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i27 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i22);
 i17 = i21;
 i19 = HEAP32[i17 + 4 >> 2] | 0;
 i16 = i26;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = i19;
 i16 = i20 + 188 | 0;
 i19 = i20 + 200 | 0;
 HEAP32[i19 >> 2] = 0;
 i17 = i20 + 204 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = i20 + 180 | 0;
 i18 = i20 + 160 | 0;
 i2 = (HEAP32[i18 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0;
 i3 = i2 << 1;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i17 >> 2] = i3;
  i15 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 3, 4, i20 + 192 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i16 >> 2] = i15;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i20 + 192 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
  HEAP32[i17 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  break;
 } else i15 = HEAP32[i16 >> 2] | 0; while (0);
 i1 = HEAP32[i20 + 168 >> 2] | 0;
 i14 = HEAP32[i4 >> 2] | 0;
 i12 = i1 + (i14 << 3) | 0;
 L11 : do if (i14 | 0) {
  i13 = i15;
  i14 = i20 + 192 | 0;
  i2 = i15;
  while (1) {
   i9 = HEAP32[i1 >> 2] | 0;
   i10 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = i2 + (HEAP32[i19 >> 2] << 2) | 0;
   L15 : do if ((i15 | 0) == (i3 | 0)) i2 = i15; else {
    i2 = i15;
    while (1) {
     if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) break L15;
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i3 | 0)) {
      i2 = i3;
      break;
     }
    }
   } while (0);
   i11 = i2 - i13 >> 2;
   i7 = (i9 | 0) == 0;
   do if (!i7) {
    HEAP32[i22 >> 2] = i9;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i23 = 18; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i2, i22);
      i3 = HEAP32[i21 >> 2] | 0;
      i8 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i8 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i23 = 18; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i23 = 20;
    }
    if ((i23 | 0) == 18) i23 = 20;
    if ((i23 | 0) == 20) {
     i23 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i9) | 0)) break;
    }
    if ((i11 | 0) == (HEAP32[i19 >> 2] | 0)) {
     i3 = i11 + 1 | 0;
     i4 = HEAP32[i17 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i2 = i4 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i17 >> 2] = i2;
       HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
       HEAP32[i17 >> 2] = i2;
       HEAP32[i16 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i19 >> 2] = i3;
     HEAP32[(HEAP32[i16 >> 2] | 0) + (i11 << 2) >> 2] = i9;
    }
   } while (0);
   i3 = (HEAP32[i16 >> 2] | 0) + (HEAP32[i19 >> 2] << 2) | 0;
   L43 : do if ((i15 | 0) == (i3 | 0)) i2 = i15; else {
    i2 = i15;
    while (1) {
     if ((HEAP32[i2 >> 2] | 0) == (i10 | 0)) break L43;
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i3 | 0)) {
      i2 = i3;
      break;
     }
    }
   } while (0);
   i8 = i2 - i13 >> 2;
   i6 = (i10 | 0) == 0;
   do if (!i6) {
    HEAP32[i22 >> 2] = i10;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i23 = 37; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i2, i22);
      i3 = HEAP32[i21 >> 2] | 0;
      i5 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i23 = 37; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i23 = 39;
    }
    if ((i23 | 0) == 37) i23 = 39;
    if ((i23 | 0) == 39) {
     i23 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i10) | 0)) break;
    }
    if ((i8 | 0) == (HEAP32[i19 >> 2] | 0)) {
     i3 = i8 + 1 | 0;
     i4 = HEAP32[i17 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i2 = i4 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i17 >> 2] = i2;
       HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
       HEAP32[i17 >> 2] = i2;
       HEAP32[i16 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i19 >> 2] = i3;
     HEAP32[(HEAP32[i16 >> 2] | 0) + (i8 << 2) >> 2] = i10;
    }
   } while (0);
   if (!i7) {
    HEAP32[i22 >> 2] = i9;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i23 = 53; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i2, i22);
      i3 = HEAP32[i21 >> 2] | 0;
      i7 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i23 = 53; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i23 = 55;
     }
    }
    if ((i23 | 0) == 53) i23 = 55;
    if ((i23 | 0) == 55) {
     i23 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
    }
    if (!(i6 | (i2 | 0) == 0)) {
     HEAP32[i22 >> 2] = i10;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i23 = 62; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i2, i22);
       i3 = HEAP32[i21 >> 2] | 0;
       i7 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i23 = 62; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i23 = 64;
      }
     }
     if ((i23 | 0) == 62) i23 = 64;
     if ((i23 | 0) == 64) {
      i23 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(i10) | 0;
     }
     if ((i9 | 0) != (i10 | 0) & (i2 | 0) != 0) {
      i6 = HEAP32[i24 >> 2] | 0;
      i3 = i6 + 1 | 0;
      i4 = HEAP32[i25 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i2 = i4 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i25 >> 2] = i2;
        HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i2 << 2, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i10 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i24 >> 2] << 2 | 0) | 0;
        HEAP32[i25 >> 2] = i2;
        HEAP32[i27 >> 2] = i10;
        break;
       }
      } while (0);
      HEAP32[i24 >> 2] = i3;
      i2 = HEAP32[i27 >> 2] | 0;
      HEAP32[i2 + (i6 << 2) >> 2] = i11;
      i6 = HEAP32[i24 >> 2] | 0;
      i7 = i6 + 1 | 0;
      i4 = HEAP32[i25 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i7 >>> 0 > i5 >>> 0) {
       i3 = i4 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i25 >> 2] = i3;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i27 >> 2] = i2;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i24 >> 2] << 2 | 0) | 0;
        HEAP32[i25 >> 2] = i3;
        HEAP32[i27 >> 2] = i2;
        break;
       }
      } while (0);
      HEAP32[i24 >> 2] = i7;
      HEAP32[i2 + (i6 << 2) >> 2] = i8;
     }
    }
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i12 | 0)) break L11;
   i2 = HEAP32[i16 >> 2] | 0;
  }
 } while (0);
 i1 = HEAP32[i20 + 148 >> 2] | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i10 = i1 + (i18 << 2) | 0;
 if (i18 | 0) {
  i9 = i1;
  i1 = HEAP32[i19 >> 2] | 0;
  do {
   i2 = HEAP32[i9 >> 2] | 0;
   do if (i2) {
    HEAP32[i22 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i23 = 87; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i2, i22);
      i3 = HEAP32[i21 >> 2] | 0;
      i19 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i23 = 87; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i23 = 89;
    }
    if ((i23 | 0) == 87) i23 = 89;
    if ((i23 | 0) == 89) {
     i23 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0)) break;
    }
    i8 = i1 + 1 | 0;
    i6 = HEAP32[i24 >> 2] | 0;
    i3 = i6 + 1 | 0;
    i4 = HEAP32[i25 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i25 >> 2] = i2;
      HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i2 << 2, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i19 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i24 >> 2] << 2 | 0) | 0;
      HEAP32[i25 >> 2] = i2;
      HEAP32[i27 >> 2] = i19;
      break;
     }
    } while (0);
    HEAP32[i24 >> 2] = i3;
    i2 = HEAP32[i27 >> 2] | 0;
    HEAP32[i2 + (i6 << 2) >> 2] = i1;
    i1 = i1 + 2 | 0;
    i6 = HEAP32[i24 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i4 = HEAP32[i25 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i7 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i25 >> 2] = i3;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i27 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i24 >> 2] << 2 | 0) | 0;
      HEAP32[i25 >> 2] = i3;
      HEAP32[i27 >> 2] = i2;
      break;
     }
    } while (0);
    HEAP32[i24 >> 2] = i7;
    HEAP32[i2 + (i6 << 2) >> 2] = i8;
   } while (0);
   i9 = i9 + 4 | 0;
  } while ((i9 | 0) != (i10 | 0));
 }
 __ZN5Unity5Cloth15UpdateCollidersEv(i20);
 i23 = HEAP32[i28 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i23 >> 2] | 0) + 284 >> 2] | 0, i23 | 0, HEAP32[i20 + 208 >> 2] | 0, HEAP32[i20 + 220 >> 2] | 0);
 if ((HEAP32[i24 >> 2] | 0) >>> 0 > 1) {
  i1 = 0;
  do {
   i21 = HEAP32[i28 >> 2] | 0;
   i23 = i1 << 1;
   i22 = HEAP32[i27 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 292 >> 2] | 0, i21 | 0, HEAP32[i22 + (i23 << 2) >> 2] | 0, HEAP32[i22 + ((i23 | 1) << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 1 >>> 0);
 }
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i26);
  HEAP32[i27 >> 2] = 0;
 }
 STACKTOP = i29;
 return;
}

function _ft_stroker_outside(i22, i23, i18) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 16 | 0;
 i20 = i25 + 8 | 0;
 i17 = i25;
 i24 = i22 + 64 + (i23 << 5) | 0;
 i1 = HEAP32[i22 + 48 >> 2] | 0;
 if (!i1) {
  i24 = _ft_stroker_arcto(i22, i23) | 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i10 = i22 + 60 | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i19 = (Math_imul(i23, -11796480) | 0) + 5898240 | 0;
 i3 = (i1 | 0) == 2;
 do if ((i1 | 0) == 1) i1 = i22 + 4 | 0; else {
  i13 = i22 + 4 | 0;
  i1 = _UNITY_FT_Angle_Diff(HEAP32[i22 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
  if ((i1 | 0) == 11796480) {
   i9 = HEAP32[i22 >> 2] | 0;
   i4 = i19;
  } else {
   i4 = (i1 | 0) / 2 | 0;
   i9 = i4 + i19 + (HEAP32[i22 >> 2] | 0) | 0;
  }
  i1 = _UNITY_FT_Cos(i4) | 0;
  i2 = i22 + 56 | 0;
  i5 = _UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i1) | 0;
  if ((i5 | 0) < 65536) {
   if (!i3) {
    i1 = i13;
    break;
   }
   if ((((i4 | 0) > -1 ? i4 : 0 - i4 | 0) | 0) > 57) {
    _UNITY_FT_Vector_From_Polar(i20, _UNITY_FT_MulFix(i14, HEAP32[i2 >> 2] | 0) | 0, i9);
    i10 = i22 + 8 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
    i12 = i22 + 12 | 0;
    i8 = i20 + 4 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (HEAP32[i12 >> 2] | 0);
    i7 = _UNITY_FT_Sin(i4) | 0;
    i7 = _UNITY_FT_MulDiv(i14, 65536 - i5 | 0, (i7 | 0) > -1 ? i7 : 0 - i7 | 0) | 0;
    _UNITY_FT_Vector_From_Polar(i17, i7, i9 + i19 | 0);
    i1 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i17 >> 2] = i1;
    i11 = i17 + 4 | 0;
    i3 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i3;
    i16 = i22 + 64 + (i23 << 5) + 16 | 0;
    i2 = HEAP32[i24 >> 2] | 0;
    do if (!(HEAP8[i16 >> 0] | 0)) {
     if (i2 | 0) {
      i4 = i2 + -1 | 0;
      i5 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
      if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) if ((1 - i3 + (HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) break;
     }
     i6 = i22 + 64 + (i23 << 5) + 4 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i21 >> 2] = 0;
     do if (i1 >>> 0 > i4 >>> 0) {
      i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
      i1 = HEAP32[i21 >> 2] | 0;
      if (!i1) {
       i1 = i22 + 64 + (i23 << 5) + 12 | 0;
       i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i21 >> 2] | 0;
       if (!i1) {
        HEAP32[i6 >> 2] = i5;
        i2 = HEAP32[i24 >> 2] | 0;
        i1 = i4;
        break;
       }
      }
      HEAP8[i16 >> 0] = 0;
      i24 = i1;
      STACKTOP = i25;
      return i24 | 0;
     } else {
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
     } while (0);
     i5 = i17;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i15 + 4 >> 2] = i6;
     HEAP8[i1 + i2 >> 0] = 1;
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
     i15 = 38;
    } else {
     i5 = i17;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i15 = (HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
     HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i15 + 4 >> 2] = i6;
     i15 = 38;
    } while (0);
    if ((i15 | 0) == 38) HEAP8[i16 >> 0] = 0;
    _UNITY_FT_Vector_From_Polar(i17, i7, i9 - i19 | 0);
    i5 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i17 >> 2] = i5;
    i1 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    i2 = HEAP32[i24 >> 2] | 0;
    L38 : do if (!(HEAP8[i16 >> 0] | 0)) {
     if (i2 | 0) {
      i3 = i2 + -1 | 0;
      i4 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
      if (((HEAP32[i4 + (i3 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if ((1 - i1 + (HEAP32[i4 + (i3 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
       i1 = 0;
       break;
      }
     }
     i6 = i22 + 64 + (i23 << 5) + 4 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i21 >> 2] = 0;
     do if (i1 >>> 0 > i4 >>> 0) {
      i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
      i1 = HEAP32[i21 >> 2] | 0;
      if (!i1) {
       i1 = i22 + 64 + (i23 << 5) + 12 | 0;
       i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i21 >> 2] | 0;
       if (!i1) {
        HEAP32[i6 >> 2] = i5;
        i2 = HEAP32[i24 >> 2] | 0;
        i1 = i4;
        break;
       }
      }
      i15 = 54;
      break L38;
     } else {
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
     } while (0);
     i9 = i17;
     i20 = HEAP32[i9 + 4 >> 2] | 0;
     i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i15 + 4 >> 2] = i20;
     HEAP8[i1 + i2 >> 0] = 1;
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
     i1 = 0;
     i15 = 54;
    } else {
     i20 = i17;
     i15 = HEAP32[i20 + 4 >> 2] | 0;
     i1 = (HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
     HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i1 + 4 >> 2] = i15;
     i1 = 0;
     i15 = 54;
    } while (0);
    if ((i15 | 0) == 54) HEAP8[i16 >> 0] = 0;
    if (i1 | i18 | 0) {
     i24 = i1;
     STACKTOP = i25;
     return i24 | 0;
    }
    _UNITY_FT_Vector_From_Polar(i17, i14, (HEAP32[i13 >> 2] | 0) + i19 | 0);
    i5 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) | 0;
    HEAP32[i17 >> 2] = i5;
    i4 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i4;
    i2 = HEAP32[i24 >> 2] | 0;
    L62 : do if (!(HEAP8[i16 >> 0] | 0)) {
     if (i2 | 0) {
      i1 = i2 + -1 | 0;
      i3 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
      if (((HEAP32[i3 + (i1 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if ((1 - i4 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
       i24 = 0;
       STACKTOP = i25;
       return i24 | 0;
      }
     }
     i6 = i22 + 64 + (i23 << 5) + 4 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i21 >> 2] = 0;
     do if (i1 >>> 0 > i4 >>> 0) {
      i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
      i1 = HEAP32[i21 >> 2] | 0;
      if (!i1) {
       i1 = i22 + 64 + (i23 << 5) + 12 | 0;
       i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i21 >> 2] | 0;
       if (!i1) {
        HEAP32[i6 >> 2] = i5;
        i2 = HEAP32[i24 >> 2] | 0;
        i1 = i4;
        break;
       }
      }
      break L62;
     } else {
      i3 = i22 + 64 + (i23 << 5) + 8 | 0;
      i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
     } while (0);
     i21 = i17;
     i22 = HEAP32[i21 + 4 >> 2] | 0;
     i23 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i23 + 4 >> 2] = i22;
     HEAP8[i1 + i2 >> 0] = 1;
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
     i1 = 0;
    } else {
     i21 = i17;
     i24 = HEAP32[i21 + 4 >> 2] | 0;
     i1 = (HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
     HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i1 + 4 >> 2] = i24;
     i1 = 0;
    } while (0);
    HEAP8[i16 >> 0] = 0;
    i24 = i1;
    STACKTOP = i25;
    return i24 | 0;
   }
  }
  _UNITY_FT_Vector_From_Polar(i20, _UNITY_FT_DivFix(HEAP32[i10 >> 2] | 0, i1) | 0, i9);
  i7 = i22 + 8 | 0;
  i1 = (HEAP32[i20 >> 2] | 0) + (HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i20 >> 2] = i1;
  i8 = i22 + 12 | 0;
  i9 = i20 + 4 | 0;
  i3 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = i3;
  i11 = i22 + 64 + (i23 << 5) + 16 | 0;
  i2 = HEAP32[i24 >> 2] | 0;
  L84 : do if (!(HEAP8[i11 >> 0] | 0)) {
   if (i2 | 0) {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
    if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) if ((1 - i3 + (HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
     i1 = 0;
     break;
    }
   }
   i6 = i22 + 64 + (i23 << 5) + 4 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i1 = i2 + 1 | 0;
   HEAP32[i21 >> 2] = 0;
   do if (i1 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
    i5 = i4;
    do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
    i3 = i22 + 64 + (i23 << 5) + 8 | 0;
    HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
    i1 = HEAP32[i21 >> 2] | 0;
    if (!i1) {
     i1 = i22 + 64 + (i23 << 5) + 12 | 0;
     i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
     HEAP32[i1 >> 2] = i4;
     i1 = HEAP32[i21 >> 2] | 0;
     if (!i1) {
      HEAP32[i6 >> 2] = i5;
      i2 = HEAP32[i24 >> 2] | 0;
      i1 = i4;
      break;
     }
    }
    i15 = 86;
    break L84;
   } else {
    i3 = i22 + 64 + (i23 << 5) + 8 | 0;
    i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
   } while (0);
   i16 = i20;
   i17 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = i17;
   HEAP8[i1 + i2 >> 0] = 1;
   HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
   i1 = 0;
   i15 = 86;
  } else {
   i17 = i20;
   i15 = HEAP32[i17 + 4 >> 2] | 0;
   i1 = (HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
   HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i1 + 4 >> 2] = i15;
   i1 = 0;
   i15 = 86;
  } while (0);
  if ((i15 | 0) == 86) HEAP8[i11 >> 0] = 0;
  L105 : do if (!(i1 | i18)) {
   _UNITY_FT_Vector_From_Polar(i20, HEAP32[i10 >> 2] | 0, (HEAP32[i22 + 4 >> 2] | 0) + i19 | 0);
   i5 = (HEAP32[i20 >> 2] | 0) + (HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i20 >> 2] = i5;
   i4 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = i4;
   i2 = HEAP32[i24 >> 2] | 0;
   L107 : do if (!(HEAP8[i11 >> 0] | 0)) {
    if (i2 | 0) {
     i1 = i2 + -1 | 0;
     i3 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
     if (((HEAP32[i3 + (i1 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if ((1 - i4 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
      i1 = 0;
      break L105;
     }
    }
    i6 = i22 + 64 + (i23 << 5) + 4 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i1 = i2 + 1 | 0;
    HEAP32[i21 >> 2] = 0;
    do if (i1 >>> 0 > i4 >>> 0) {
     i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
     i5 = i4;
     do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
     i3 = i22 + 64 + (i23 << 5) + 8 | 0;
     HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
     i1 = HEAP32[i21 >> 2] | 0;
     if (!i1) {
      i1 = i22 + 64 + (i23 << 5) + 12 | 0;
      i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
      HEAP32[i1 >> 2] = i4;
      i1 = HEAP32[i21 >> 2] | 0;
      if (!i1) {
       HEAP32[i6 >> 2] = i5;
       i2 = HEAP32[i24 >> 2] | 0;
       i1 = i4;
       break;
      }
     }
     break L107;
    } else {
     i3 = i22 + 64 + (i23 << 5) + 8 | 0;
     i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
    } while (0);
    i21 = i20;
    i22 = HEAP32[i21 + 4 >> 2] | 0;
    i23 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i23 + 4 >> 2] = i22;
    HEAP8[i1 + i2 >> 0] = 1;
    HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
    i1 = 0;
   } else {
    i21 = i20;
    i24 = HEAP32[i21 + 4 >> 2] | 0;
    i1 = (HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i1 + 4 >> 2] = i24;
    i1 = 0;
   } while (0);
   HEAP8[i11 >> 0] = 0;
  } while (0);
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 _UNITY_FT_Vector_From_Polar(i20, i14, (HEAP32[i1 >> 2] | 0) + i19 | 0);
 i1 = (HEAP32[i20 >> 2] | 0) + (HEAP32[i22 + 8 >> 2] | 0) | 0;
 HEAP32[i20 >> 2] = i1;
 i7 = i20 + 4 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i22 + 12 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 i7 = i22 + 64 + (i23 << 5) + 16 | 0;
 HEAP8[i7 >> 0] = 0;
 i2 = HEAP32[i24 >> 2] | 0;
 if (!i2) i15 = 14; else {
  i4 = i2 + -1 | 0;
  i5 = HEAP32[i22 + 64 + (i23 << 5) + 8 >> 2] | 0;
  if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) if (((HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) + 1 - i3 | 0) >>> 0 < 3) i1 = 0; else i15 = 14; else i15 = 14;
 }
 if ((i15 | 0) == 14) {
  i6 = i22 + 64 + (i23 << 5) + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = i2 + 1 | 0;
  HEAP32[i21 >> 2] = 0;
  do if (i1 >>> 0 > i4 >>> 0) {
   i2 = HEAP32[i22 + 64 + (i23 << 5) + 24 >> 2] | 0;
   i5 = i4;
   do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
   i3 = i22 + 64 + (i23 << 5) + 8 | 0;
   HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i21) | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   if (!i1) {
    i1 = i22 + 64 + (i23 << 5) + 12 | 0;
    i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i21) | 0;
    HEAP32[i1 >> 2] = i4;
    i1 = HEAP32[i21 >> 2] | 0;
    if (!i1) {
     HEAP32[i6 >> 2] = i5;
     i2 = HEAP32[i24 >> 2] | 0;
     i1 = i4;
     i15 = 22;
     break;
    }
   }
  } else {
   i3 = i22 + 64 + (i23 << 5) + 8 | 0;
   i1 = HEAP32[i22 + 64 + (i23 << 5) + 12 >> 2] | 0;
   i15 = 22;
  } while (0);
  if ((i15 | 0) == 22) {
   i21 = i20;
   i22 = HEAP32[i21 + 4 >> 2] | 0;
   i23 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i23 + 4 >> 2] = i22;
   HEAP8[i1 + i2 >> 0] = 1;
   HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
   i1 = 0;
  }
  HEAP8[i7 >> 0] = 0;
 }
 i24 = i1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEbT0_S6_T_(i7, i6, i2) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 switch ((i6 - i7 | 0) / 20 | 0 | 0) {
 case 2:
  {
   i1 = i6 + -20 | 0;
   if ((HEAP32[i1 >> 2] | 0) >= (HEAP32[i7 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 3:
  {
   i3 = i7 + 20 | 0;
   i1 = i6 + -20 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i2 = (HEAP32[i1 >> 2] | 0) < (i6 | 0);
   if ((i6 | 0) >= (HEAP32[i7 >> 2] | 0)) {
    if (!i2) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    if ((HEAP32[i3 >> 2] | 0) >= (HEAP32[i7 >> 2] | 0)) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   if ((HEAP32[i1 >> 2] | 0) >= (HEAP32[i3 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i7, i7 + 20 | 0, i7 + 40 | 0, i6 + -20 | 0, i2) | 0;
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 5:
  {
   i3 = i7 + 20 | 0;
   i4 = i7 + 40 | 0;
   i5 = i7 + 60 | 0;
   i1 = i6 + -20 | 0;
   __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i7, i3, i4, i5, i2) | 0;
   if ((HEAP32[i1 >> 2] | 0) >= (HEAP32[i5 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   if ((HEAP32[i5 >> 2] | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   if ((HEAP32[i4 >> 2] | 0) >= (HEAP32[i3 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   if ((HEAP32[i3 >> 2] | 0) >= (HEAP32[i7 >> 2] | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 1:
 case 0:
  {
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i3 = i7 + 40 | 0;
   i1 = i7 + 20 | 0;
   i10 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = (i4 | 0) < (i10 | 0);
   do if ((i10 | 0) < (i2 | 0)) {
    if (i5) {
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     break;
    };
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    if ((i4 | 0) < (HEAP32[i1 >> 2] | 0)) {
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    }
   } else if (i5) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    if ((HEAP32[i1 >> 2] | 0) < (i2 | 0)) {
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    }
   } while (0);
   i1 = i7 + 60 | 0;
   L13 : do if ((i1 | 0) == (i6 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i5 = HEAP32[i1 >> 2] | 0;
     if ((i5 | 0) < (HEAP32[i3 >> 2] | 0)) {
      i4 = i1 + 4 | 0;
      HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       if ((i3 | 0) == (i7 | 0)) {
        i3 = i7;
        break;
       }
       i4 = i3 + -20 | 0;
       if ((i5 | 0) < (HEAP32[i4 >> 2] | 0)) {
        i10 = i3;
        i3 = i4;
        i4 = i10;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      i10 = i3 + 4 | 0;
      HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 20 | 0) == (i6 | 0);
       break L13;
      }
     }
     i3 = i1 + 20 | 0;
     if ((i3 | 0) == (i6 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i9;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN20ArchiveStorageHeader7ReadAllER12FileAccessorRNS_6HeaderERNS_10BlocksInfoERNS_13DirectoryInfoE(i17, i18, i9, i8) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 24 | 0;
 i2 = i19 + 16 | 0;
 i3 = i19 + 64 | 0;
 i4 = i19 + 60 | 0;
 i5 = i19 + 56 | 0;
 i6 = i19 + 52 | 0;
 i10 = i19 + 48 | 0;
 i7 = i19 + 44 | 0;
 i11 = i19 + 40 | 0;
 i12 = i19 + 8 | 0;
 i13 = i19;
 i14 = i19 + 36 | 0;
 i15 = i19 + 32 | 0;
 i20 = HEAP8[i18 + 11 >> 0] | 0;
 i1 = i20 << 24 >> 24 < 0;
 switch ((i1 ? HEAP32[i18 + 4 >> 2] | 0 : i20 & 255) | 0) {
 case 12:
  {
   if (_memcmp(i1 ? HEAP32[i18 >> 2] | 0 : i18, gb + 489819 | 0, 12) | 0) {
    i20 = -1;
    STACKTOP = i19;
    return i20 | 0;
   }
   i20 = i16;
   if ((__ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i2, i16) | 0) & ((HEAP32[i20 >> 2] | 0) == 8 & (HEAP32[i20 + 4 >> 2] | 0) == 0)) {
    i1 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
    i20 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i20 >> 2] | 0) | 0;
    HEAP32[i20 >> 2] = i1;
    i20 = i2;
    if (__ZN12FileAccessor4SeekEx10FileOrigin(i17, HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, 1) | 0) {
     i1 = i18 + 16 | 0;
     i21 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i1, i16) | 0;
     i20 = i16;
     if (i21 & ((HEAP32[i20 >> 2] | 0) == 4 & (HEAP32[i20 + 4 >> 2] | 0) == 0)) {
      i21 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = _llvm_bswap_i32(i21 | 0) | 0;
      if ((i21 | 0) == 83886080) if (__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i17, i18 + 20 | 0) | 0) if (__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i17, i18 + 36 | 0) | 0) {
       i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 16, 0, i3, i16) | 0;
       i21 = i16;
       if (i20 & ((HEAP32[i21 >> 2] | 0) == 16 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
        i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i4, i16) | 0;
        i21 = i16;
        if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
         HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
         i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i5, i16) | 0;
         i21 = i16;
         if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
          HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
          i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i6, i16) | 0;
          i21 = i16;
          if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
           i21 = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
           HEAP32[i6 >> 2] = i21;
           i20 = i2;
           i21 = _i64Add(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, i21 | 0, 0) | 0;
           if (__ZN12FileAccessor4SeekEx10FileOrigin(i17, i21, getTempRet0() | 0, 1) | 0) {
            i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i10, i16) | 0;
            i21 = i16;
            if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
             HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
             i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i7, i16) | 0;
             i21 = i16;
             L24 : do if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
              i4 = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
              HEAP32[i7 >> 2] = i4;
              i7 = i8 + 4 | 0;
              i2 = HEAP32[i7 >> 2] | 0;
              i3 = HEAP32[i8 >> 2] | 0;
              i1 = (i2 - i3 | 0) / 40 | 0;
              i5 = i2;
              do if (i4 >>> 0 > i1 >>> 0) {
               __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i8, i4 - i1 | 0);
               i2 = HEAP32[i7 >> 2] | 0;
              } else {
               if (i4 >>> 0 >= i1 >>> 0) break;
               i6 = i3 + (i4 * 40 | 0) | 0;
               if ((i5 | 0) == (i6 | 0)) break;
               i4 = i16 + 4 | 0;
               i2 = i5;
               while (1) {
                i1 = i2 + -40 | 0;
                HEAP32[i7 >> 2] = i1;
                i3 = i2 + -20 | 0;
                if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
                 i1 = HEAP32[i3 >> 2] | 0;
                 i21 = HEAP32[i2 + -8 >> 2] | 0;
                 HEAP32[i16 >> 2] = 54;
                 HEAP32[i4 >> 2] = i21;
                 __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
                 i1 = HEAP32[i7 >> 2] | 0;
                }
                if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
               }
               i2 = i6;
              } while (0);
              i1 = HEAP32[i8 >> 2] | 0;
              if ((i2 | 0) != (i1 | 0)) {
               i3 = 0;
               do {
                i2 = i1 + (i3 * 40 | 0) | 0;
                i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i2, i16) | 0;
                i21 = i16;
                if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 8 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                 i1 = 1;
                 break L24;
                }
                i21 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
                i20 = i2 + 4 | 0;
                HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i20 >> 2] | 0) | 0;
                HEAP32[i20 >> 2] = i21;
                i2 = i1 + (i3 * 40 | 0) + 8 | 0;
                i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i2, i16) | 0;
                i21 = i16;
                if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 8 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                 i1 = 1;
                 break L24;
                }
                i21 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
                i20 = i2 + 4 | 0;
                HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i20 >> 2] | 0) | 0;
                HEAP32[i20 >> 2] = i21;
                i2 = i1 + (i3 * 40 | 0) + 16 | 0;
                i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i2, i16) | 0;
                i21 = i16;
                if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                 i1 = 1;
                 break L24;
                }
                HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
                if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i17, i1 + (i3 * 40 | 0) + 20 | 0) | 0)) {
                 i1 = 1;
                 break L24;
                }
                i3 = i3 + 1 | 0;
                i1 = HEAP32[i8 >> 2] | 0;
               } while (i3 >>> 0 < (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0);
              }
              i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i11, i16) | 0;
              i21 = i16;
              L47 : do if (i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
               i21 = HEAP32[i11 >> 2] | 0;
               i3 = _llvm_bswap_i32(i21 | 0) | 0;
               HEAP32[i11 >> 2] = i3;
               L49 : do if (i21 | 0) {
                i5 = i9 + 16 | 0;
                i4 = i9 + 20 | 0;
                i6 = HEAP32[i4 >> 2] | 0;
                i2 = HEAP32[i5 >> 2] | 0;
                i1 = (i6 - i2 | 0) / 12 | 0;
                do if (i3 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i5, i3 - i1 | 0); else {
                 if (i3 >>> 0 >= i1 >>> 0) break;
                 i1 = i2 + (i3 * 12 | 0) | 0;
                 if ((i6 | 0) == (i1 | 0)) break;
                 HEAP32[i4 >> 2] = i6 + (~(((i6 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
                } while (0);
                i20 = i12;
                HEAP32[i20 >> 2] = 0;
                HEAP32[i20 + 4 >> 2] = 0;
                i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i12, i16) | 0;
                i21 = i16;
                L57 : do if (i20 & ((HEAP32[i21 >> 2] | 0) == 8 & (HEAP32[i21 + 4 >> 2] | 0) == 0)) {
                 i20 = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
                 i21 = i12 + 4 | 0;
                 HEAP32[i12 >> 2] = _llvm_bswap_i32(HEAP32[i21 >> 2] | 0) | 0;
                 HEAP32[i21 >> 2] = i20;
                 do if (!(HEAP32[i11 >> 2] | 0)) {
                  i1 = i12;
                  HEAP32[i1 >> 2] = 0;
                  HEAP32[i1 + 4 >> 2] = 0;
                  i1 = 47;
                 } else {
                  i2 = i13 + 4 | 0;
                  i1 = 0;
                  while (1) {
                   i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i13, i16) | 0;
                   i21 = i16;
                   if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 8 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                    i1 = 45;
                    break;
                   }
                   i21 = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
                   HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
                   HEAP32[i2 >> 2] = i21;
                   i21 = i13;
                   i20 = HEAP32[i21 >> 2] | 0;
                   i21 = HEAP32[i21 + 4 >> 2] | 0;
                   i3 = i12;
                   i3 = _i64Subtract(i20 | 0, i21 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
                   getTempRet0() | 0;
                   HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 * 12 | 0) >> 2] = i3;
                   i3 = i12;
                   HEAP32[i3 >> 2] = i20;
                   HEAP32[i3 + 4 >> 2] = i21;
                   i1 = i1 + 1 | 0;
                   i3 = HEAP32[i11 >> 2] | 0;
                   if (i1 >>> 0 >= i3 >>> 0) {
                    i1 = 46;
                    break;
                   }
                  }
                  if ((i1 | 0) == 45) break L57; else if ((i1 | 0) == 46) {
                   i21 = i12;
                   HEAP32[i21 >> 2] = 0;
                   HEAP32[i21 + 4 >> 2] = 0;
                   if ((i3 | 0) == -1) break; else {
                    i1 = 47;
                    break;
                   }
                  }
                 } while (0);
                 L68 : do if ((i1 | 0) == 47) {
                  i2 = i13 + 4 | 0;
                  i1 = 0;
                  while (1) {
                   i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 8, 0, i13, i16) | 0;
                   i21 = i16;
                   if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 8 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                    i1 = 49;
                    break;
                   }
                   i20 = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
                   HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
                   HEAP32[i2 >> 2] = i20;
                   i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i14, i16) | 0;
                   i21 = i16;
                   if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                    i1 = 51;
                    break;
                   }
                   HEAP32[i14 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
                   i20 = __ZN12FileAccessor4ReadEyPvPy(i17, 4, 0, i15, i16) | 0;
                   i21 = i16;
                   if (!(i20 & ((HEAP32[i21 >> 2] | 0) == 4 & (HEAP32[i21 + 4 >> 2] | 0) == 0))) {
                    i1 = 58;
                    break;
                   }
                   i3 = _llvm_bswap_i32(HEAP32[i15 >> 2] | 0) | 0;
                   HEAP32[i15 >> 2] = i3;
                   if (i1 | 0) {
                    i20 = i13;
                    i21 = i12;
                    i21 = _i64Subtract(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, HEAP32[i21 >> 2] | 0, HEAP32[i21 + 4 >> 2] | 0) | 0;
                    getTempRet0() | 0;
                    HEAP32[(HEAP32[i5 >> 2] | 0) + ((i1 + -1 | 0) * 12 | 0) + 4 >> 2] = i21;
                   }
                   i4 = HEAP32[i11 >> 2] | 0;
                   if ((i1 | 0) != (i4 | 0)) HEAP16[(HEAP32[i5 >> 2] | 0) + (i1 * 12 | 0) + 8 >> 1] = HEAP32[i14 >> 2] & 63 | i3 << 6 & 64;
                   i9 = i13;
                   i20 = HEAP32[i9 + 4 >> 2] | 0;
                   i21 = i12;
                   HEAP32[i21 >> 2] = HEAP32[i9 >> 2];
                   HEAP32[i21 + 4 >> 2] = i20;
                   i1 = i1 + 1 | 0;
                   if (i1 >>> 0 >= (i4 + 1 | 0) >>> 0) break L68;
                  }
                  if ((i1 | 0) == 49) break L57; else if ((i1 | 0) == 51) break L57; else if ((i1 | 0) == 58) break L57;
                 } while (0);
                 break L49;
                } while (0);
                i1 = 1;
                break L47;
               } while (0);
               i1 = HEAP32[i10 >> 2] | 0;
               HEAP32[i18 + 68 >> 2] = i1;
               HEAP32[i18 + 64 >> 2] = i1;
               HEAP32[i18 + 72 >> 2] = 64;
               i1 = 0;
              } else i1 = 1; while (0);
             } else i1 = 1; while (0);
            } else i1 = 1;
           } else i1 = 1;
          } else i1 = 1;
         } else i1 = 1;
        } else i1 = 1;
       } else i1 = 1;
      } else i1 = 1; else i1 = 1; else i1 = -1;
     } else i1 = 1;
    } else i1 = 1;
   } else i1 = 1;
   i21 = i1;
   STACKTOP = i19;
   return i21 | 0;
  }
 case 8:
  {
   if (_memcmp(i1 ? HEAP32[i18 >> 2] | 0 : i18, gb + 489801 | 0, 8) | 0) {
    i21 = -1;
    STACKTOP = i19;
    return i21 | 0;
   }
   i1 = __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE(i17, i18, i9) | 0;
   if (i1 | 0) {
    i21 = i1;
    STACKTOP = i19;
    return i21 | 0;
   }
   if (!(__ZN12FileAccessor4SeekEx10FileOrigin(i17, __ZN20ArchiveStorageHeader13GetDataOffsetERKNS_6HeaderE(i18) | 0, getTempRet0() | 0, 1) | 0)) {
    i21 = 1;
    STACKTOP = i19;
    return i21 | 0;
   }
   i21 = __Z37ReadDirectoryInfo_UnityWebAndUnityRawR12FileAccessorRKN20ArchiveStorageHeader6HeaderERNS1_13DirectoryInfoE(i17, 0, i8) | 0;
   STACKTOP = i19;
   return i21 | 0;
  }
 default:
  {
   i21 = -1;
   STACKTOP = i19;
   return i21 | 0;
  }
 }
 return 0;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj(i80, i79, i3, i77, i65, i69) {
 i80 = i80 | 0;
 i79 = i79 | 0;
 i3 = i3 | 0;
 i77 = i77 | 0;
 i65 = i65 | 0;
 i69 = i69 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i66 = 0, i67 = 0, i68 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i78 = 0, i81 = 0;
 i81 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i67 = i81 + 224 | 0;
 i75 = i81 + 220 | 0;
 i66 = i81 + 200 | 0;
 i61 = i81 + 196 | 0;
 i71 = i81 + 120 | 0;
 i62 = i81 + 116 | 0;
 i70 = i81 + 40 | 0;
 i60 = i81;
 i68 = i81 + 24 | 0;
 i63 = i81 + 16 | 0;
 i64 = i81 + 12 | 0;
 i78 = i77 + 4 | 0;
 if (__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl23findPropertyMessageImplERKN5physx8debugger14NamespacedNameE(i79, HEAP32[i77 >> 2] | 0, HEAP32[i78 >> 2] | 0) | 0) {
  HEAP32[i80 >> 2] = gb + 148944 + 8;
  HEAP32[i80 + 4 >> 2] = gb + 1576256;
  HEAP32[i80 + 8 >> 2] = gb + 1576256;
  HEAP32[i80 + 12 >> 2] = -1;
  HEAP32[i80 + 16 >> 2] = gb + 1576256;
  HEAP32[i80 + 20 >> 2] = gb + 1576256;
  HEAP32[i80 + 24 >> 2] = -1;
  i80 = i80 + 28 | 0;
  HEAP32[i80 >> 2] = 0;
  HEAP32[i80 + 4 >> 2] = 0;
  HEAP32[i80 + 8 >> 2] = 0;
  HEAP32[i80 + 12 >> 2] = 0;
  HEAP32[i80 + 16 >> 2] = 0;
  HEAP8[i80 + 20 >> 0] = 0;
  STACKTOP = i81;
  return;
 }
 i4 = i3 + 4 | 0;
 i2 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i79, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!i2) {
  HEAP32[i80 >> 2] = gb + 148944 + 8;
  HEAP32[i80 + 4 >> 2] = gb + 1576256;
  HEAP32[i80 + 8 >> 2] = gb + 1576256;
  HEAP32[i80 + 12 >> 2] = -1;
  HEAP32[i80 + 16 >> 2] = gb + 1576256;
  HEAP32[i80 + 20 >> 2] = gb + 1576256;
  HEAP32[i80 + 24 >> 2] = -1;
  i80 = i80 + 28 | 0;
  HEAP32[i80 >> 2] = 0;
  HEAP32[i80 + 4 >> 2] = 0;
  HEAP32[i80 + 8 >> 2] = 0;
  HEAP32[i80 + 12 >> 2] = 0;
  HEAP32[i80 + 16 >> 2] = 0;
  HEAP8[i80 + 20 >> 0] = 0;
  STACKTOP = i81;
  return;
 }
 i74 = i79 + 216 | 0;
 i73 = i79 + 232 | 0;
 i59 = HEAP32[i73 >> 2] | 0;
 i72 = i79 + 4 | 0;
 i1 = HEAP32[i72 >> 2] | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 124, gb + 775088 | 0, gb + 774188 | 0, 1023) | 0;
 i56 = i79 + 160 | 0;
 i53 = HEAP32[i56 >> 2] | 0;
 i52 = mftCall_iiii(HEAP32[(HEAP32[i53 >> 2] | 0) + 16 >> 2] | 0, i53 | 0, HEAP32[i3 >> 2] | 0, i67 | 0) | 0;
 i53 = mftCall_iiii(HEAP32[(HEAP32[i53 >> 2] | 0) + 16 >> 2] | 0, i53 | 0, HEAP32[i4 >> 2] | 0, i67 | 0) | 0;
 i57 = i2 + 12 | 0;
 i2 = HEAP32[i57 >> 2] | 0;
 i56 = HEAP32[i56 >> 2] | 0;
 i55 = mftCall_iiii(HEAP32[(HEAP32[i56 >> 2] | 0) + 16 >> 2] | 0, i56 | 0, HEAP32[i77 >> 2] | 0, i67 | 0) | 0;
 i56 = mftCall_iiii(HEAP32[(HEAP32[i56 >> 2] | 0) + 16 >> 2] | 0, i56 | 0, HEAP32[i78 >> 2] | 0, i67 | 0) | 0;
 i58 = HEAP32[i72 >> 2] | 0;
 i54 = i1 + 4 | 0;
 HEAP32[i54 >> 2] = i52;
 HEAP32[i54 + 4 >> 2] = i53;
 HEAP32[i1 + 12 >> 2] = i2;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i55;
 HEAP32[i2 + 4 >> 2] = i56;
 HEAP32[i1 + 24 >> 2] = i59;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = i69;
 HEAP32[i1 >> 2] = gb + 148800 + 8;
 HEAP32[i1 + 48 >> 2] = i58;
 HEAP32[i1 + 56 >> 2] = i58;
 HEAP32[i1 + 60 >> 2] = gb + 774956;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = gb + 148816 + 8;
 HEAP32[i1 + 80 >> 2] = i58;
 HEAP32[i1 + 84 >> 2] = gb + 775e3;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = gb + 148832 + 8;
 HEAP32[i1 + 104 >> 2] = i58;
 HEAP32[i1 + 108 >> 2] = gb + 775041;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = gb + 148848 + 8;
 HEAP32[i75 >> 2] = i1;
 i58 = i65 + 4 | 0;
 i2 = HEAP32[i65 >> 2] | 0;
 do if ((HEAP32[i58 >> 2] | 0) == (i2 | 0)) i76 = 29; else {
  i19 = i66 + 4 | 0;
  i20 = i66 + 8 | 0;
  i21 = i66 + 16 | 0;
  i22 = i66 + 12 | 0;
  i23 = i67 + 52 | 0;
  i24 = i67 + 24 | 0;
  i25 = i71 + 72 | 0;
  i26 = i67 + 4 | 0;
  i27 = i67 + 12 | 0;
  i28 = i67 + 16 | 0;
  i29 = i67 + 28 | 0;
  i30 = i67 + 40 | 0;
  i31 = i67 + 44 | 0;
  i32 = i70 + 4 | 0;
  i33 = i70 + 12 | 0;
  i34 = i70 + 16 | 0;
  i35 = i70 + 24 | 0;
  i36 = i70 + 28 | 0;
  i37 = i70 + 40 | 0;
  i38 = i70 + 44 | 0;
  i39 = i70 + 52 | 0;
  i40 = i70 + 60 | 0;
  i41 = i70 + 64 | 0;
  i42 = i70 + 68 | 0;
  i43 = i70 + 72 | 0;
  i59 = i1 + 72 | 0;
  i44 = i1 + 68 | 0;
  i45 = i1 + 64 | 0;
  i46 = i1 + 96 | 0;
  i47 = i1 + 92 | 0;
  i48 = i1 + 88 | 0;
  i49 = i1 + 28 | 0;
  i50 = i1 + 32 | 0;
  i51 = i1 + 120 | 0;
  i52 = i1 + 116 | 0;
  i53 = i1 + 112 | 0;
  i54 = i1 + 100 | 0;
  i55 = i68 + 9 | 0;
  i56 = i1 + 76 | 0;
  i18 = i1 + 52 | 0;
  i16 = 0;
  i17 = 0;
  while (1) {
   i2 = i2 + (i17 * 20 | 0) | 0;
   HEAP32[i66 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i66 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i66 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i66 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i66 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i2 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i79, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
   if (!i2) break;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 >>> 0 < i3 >>> 0) break;
   i4 = HEAP32[i22 >> 2] | 0;
   i15 = i4 + i1 | 0;
   i16 = i16 >>> 0 < i15 >>> 0 ? i15 : i16;
   if (i16 >>> 0 > i69 >>> 0) break;
   i15 = HEAP32[(HEAP32[i79 >> 2] | 0) + 48 >> 2] | 0;
   HEAP32[i61 >> 2] = HEAP32[i57 >> 2];
   mftCall_viiii(i15 | 0, i67 | 0, i79 | 0, i61 | 0, HEAP32[i66 >> 2] | 0);
   if (!(HEAP8[i23 >> 0] | 0)) {
    i76 = 11;
    break;
   }
   i15 = HEAP32[(HEAP32[i79 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i62 >> 2] = HEAP32[i24 >> 2];
   mftCall_viii(i15 | 0, i71 | 0, i79 | 0, i62 | 0);
   if (!(HEAP8[i25 >> 0] | 0)) {
    i76 = 13;
    break;
   }
   i6 = i26;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i7 = HEAP32[i27 >> 2] | 0;
   i9 = i28;
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i10 = HEAP32[i24 >> 2] | 0;
   HEAP32[i60 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i60 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i60 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   i11 = HEAP32[i30 >> 2] | 0;
   i13 = i31;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = i2 + 4 | 0;
   i14 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 4 >> 2] | 0;
   i2 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i70 >> 2] = gb + 148864 + 8;
   i1 = i32;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i33 >> 2] = i7;
   i1 = i34;
   HEAP32[i1 >> 2] = i8;
   HEAP32[i1 + 4 >> 2] = i9;
   HEAP32[i35 >> 2] = i10;
   HEAP32[i36 >> 2] = HEAP32[i60 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
   HEAP32[i37 >> 2] = i11;
   i1 = i38;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = i39;
   HEAP32[i1 >> 2] = i14;
   HEAP32[i1 + 4 >> 2] = i15;
   HEAP32[i40 >> 2] = i2;
   HEAP32[i41 >> 2] = i4;
   HEAP32[i42 >> 2] = i3;
   HEAP32[i43 >> 2] = i3;
   i1 = HEAP32[i44 >> 2] | 0;
   if ((HEAP32[i59 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i4 = HEAP32[i45 >> 2] | 0;
    HEAP32[i4 + (i1 * 76 | 0) >> 2] = gb + 148864 + 8;
    i3 = i4 + (i1 * 76 | 0) + 4 | 0;
    HEAP32[i3 >> 2] = i5;
    HEAP32[i3 + 4 >> 2] = i6;
    HEAP32[i4 + (i1 * 76 | 0) + 12 >> 2] = i7;
    i7 = i4 + (i1 * 76 | 0) + 16 | 0;
    HEAP32[i7 >> 2] = i8;
    HEAP32[i7 + 4 >> 2] = i9;
    HEAP32[i4 + (i1 * 76 | 0) + 24 >> 2] = i10;
    i10 = i4 + (i1 * 76 | 0) + 28 | 0;
    HEAP32[i10 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    HEAP32[i4 + (i1 * 76 | 0) + 40 >> 2] = i11;
    i11 = i4 + (i1 * 76 | 0) + 44 | 0;
    HEAP32[i11 >> 2] = i12;
    HEAP32[i11 + 4 >> 2] = i13;
    i13 = i4 + (i1 * 76 | 0) + 52 | 0;
    HEAP32[i13 >> 2] = i14;
    HEAP32[i13 + 4 >> 2] = i15;
    HEAP32[i4 + (i1 * 76 | 0) + 60 >> 2] = i2;
    i15 = i4 + (i1 * 76 | 0) + 64 | 0;
    HEAP32[i15 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_(i18, i70) | 0;
   i1 = HEAP32[i47 >> 2] | 0;
   if ((HEAP32[i46 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i2 = HEAP32[i48 >> 2] | 0;
    HEAP32[i2 + (i1 * 76 | 0) >> 2] = gb + 148864 + 8;
    i15 = i32;
    i14 = HEAP32[i15 + 4 >> 2] | 0;
    i13 = i2 + (i1 * 76 | 0) + 4 | 0;
    HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i13 + 4 >> 2] = i14;
    HEAP32[i2 + (i1 * 76 | 0) + 12 >> 2] = HEAP32[i33 >> 2];
    i13 = i34;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i15 = i2 + (i1 * 76 | 0) + 16 | 0;
    HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    HEAP32[i2 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i35 >> 2];
    i15 = i2 + (i1 * 76 | 0) + 28 | 0;
    HEAP32[i15 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    HEAP32[i2 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i37 >> 2];
    i15 = i38;
    i14 = HEAP32[i15 + 4 >> 2] | 0;
    i13 = i2 + (i1 * 76 | 0) + 44 | 0;
    HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i13 + 4 >> 2] = i14;
    i13 = i39;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i15 = i2 + (i1 * 76 | 0) + 52 | 0;
    HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    i15 = HEAP32[i40 >> 2] | 0;
    HEAP32[i2 + (i1 * 76 | 0) + 60 >> 2] = i15;
    i2 = i2 + (i1 * 76 | 0) + 64 | 0;
    HEAP32[i2 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    i2 = (HEAP32[i47 >> 2] | 0) + 1 | 0;
    HEAP32[i47 >> 2] = i2;
    i1 = i15;
   } else {
    __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i56, i70) | 0;
    i2 = HEAP32[i47 >> 2] | 0;
    i1 = HEAP32[i40 >> 2] | 0;
   }
   i15 = HEAP32[i48 >> 2] | 0;
   HEAP32[i49 >> 2] = i15;
   HEAP32[i50 >> 2] = i15 + (i2 * 76 | 0);
   do if ((i1 | 0) == 77) {
    i1 = HEAP32[i52 >> 2] | 0;
    if ((HEAP32[i51 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i53 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i22 >> 2];
     HEAP32[i52 >> 2] = (HEAP32[i52 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj(i54, i22) | 0;
     i1 = HEAP32[i40 >> 2] | 0;
     if ((i1 | 0) == 77) break; else {
      i76 = 24;
      break;
     }
    }
   } else i76 = 24; while (0);
   if ((i76 | 0) == 24) {
    i76 = 0;
    if ((i1 | 0) != 80) {
     i15 = HEAP32[(HEAP32[i79 >> 2] | 0) + 72 >> 2] | 0;
     HEAP32[i63 >> 2] = i1;
     HEAP32[i64 >> 2] = HEAP32[i35 >> 2];
     mftCall_viiii(i15 | 0, i68 | 0, i79 | 0, i63 | 0, i64 | 0);
     if (HEAP8[i55 >> 0] | 0) {
      i76 = 26;
      break;
     }
    }
   }
   i17 = i17 + 1 | 0;
   i2 = HEAP32[i65 >> 2] | 0;
   if (i17 >>> 0 >= (((HEAP32[i58 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0) {
    i76 = 28;
    break;
   }
  }
  if ((i76 | 0) != 11) if ((i76 | 0) != 13) if ((i76 | 0) != 26) if ((i76 | 0) == 28) {
   i1 = HEAP32[i75 >> 2] | 0;
   i76 = 29;
   break;
  }
  i1 = HEAP32[i75 >> 2] | 0;
  if (i1 | 0) {
   i79 = HEAP32[i72 >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   mftCall_vii(HEAP32[(HEAP32[i79 >> 2] | 0) + 12 >> 2] | 0, i79 | 0, i1 | 0);
  }
 } while (0);
 if ((i76 | 0) == 29) if (i1 | 0) {
  i72 = HEAP32[i1 + 112 >> 2] | 0;
  i76 = i72 + (HEAP32[i1 + 116 >> 2] << 2) | 0;
  HEAP32[i1 + 40 >> 2] = i72;
  HEAP32[i1 + 44 >> 2] = i76;
  i1 = HEAP32[i73 >> 2] | 0;
  if ((HEAP32[i79 + 236 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i2 = HEAP32[i75 >> 2] | 0;
   HEAP32[(HEAP32[i79 + 228 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   HEAP32[i73 >> 2] = i1 + 1;
   i1 = i2;
  } else {
   __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i74, i75) | 0;
   i2 = HEAP32[i75 >> 2] | 0;
   i1 = i2;
  }
  __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i79 + 164 | 0, HEAP32[i77 >> 2] | 0, HEAP32[i78 >> 2] | 0, i1);
  HEAP32[i80 >> 2] = gb + 148944 + 8;
  i79 = i2 + 4 | 0;
  i78 = HEAP32[i79 + 4 >> 2] | 0;
  i77 = i80 + 4 | 0;
  HEAP32[i77 >> 2] = HEAP32[i79 >> 2];
  HEAP32[i77 + 4 >> 2] = i78;
  HEAP32[i80 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i77 = i2 + 16 | 0;
  i78 = HEAP32[i77 + 4 >> 2] | 0;
  i79 = i80 + 16 | 0;
  HEAP32[i79 >> 2] = HEAP32[i77 >> 2];
  HEAP32[i79 + 4 >> 2] = i78;
  HEAP32[i80 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i80 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i80 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  i79 = i80 + 36 | 0;
  i78 = i2 + 36 | 0;
  HEAP32[i79 >> 2] = HEAP32[i78 >> 2];
  HEAP32[i80 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
  HEAP32[i80 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
  HEAP32[i79 >> 2] = HEAP32[i78 >> 2];
  HEAP8[i80 + 48 >> 0] = 1;
  STACKTOP = i81;
  return;
 }
 HEAP32[i80 >> 2] = gb + 148944 + 8;
 HEAP32[i80 + 4 >> 2] = gb + 1576256;
 HEAP32[i80 + 8 >> 2] = gb + 1576256;
 HEAP32[i80 + 12 >> 2] = -1;
 HEAP32[i80 + 16 >> 2] = gb + 1576256;
 HEAP32[i80 + 20 >> 2] = gb + 1576256;
 HEAP32[i80 + 24 >> 2] = -1;
 i80 = i80 + 28 | 0;
 HEAP32[i80 >> 2] = 0;
 HEAP32[i80 + 4 >> 2] = 0;
 HEAP32[i80 + 8 >> 2] = 0;
 HEAP32[i80 + 12 >> 2] = 0;
 HEAP32[i80 + 16 >> 2] = 0;
 HEAP8[i80 + 20 >> 0] = 0;
 STACKTOP = i81;
 return;
}

function __ZN9GfxDevice14ImmediateShapeEffffNS_18ImmediateShapeTypeE(i1, f2, f3, f4, f5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 switch (i6 | 0) {
 case 0:
  {
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 580 >> 2] | 0, i1 | 0, 2, 0);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 564 >> 2] | 0, i1 | 0, 0.0, 0.0, 0.0);
   f7 = Math_fround(f2 + f5);
   f9 = Math_fround(f3 - f5);
   f8 = Math_fround(f4 - f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f8);
   f2 = Math_fround(f2 - f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f8);
   f3 = Math_fround(f3 + f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f8);
   f5 = Math_fround(f4 + f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f9, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f8);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f2, +f3, +f5);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f3, +f5);
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 584 >> 2] | 0, i1 | 0);
   return;
  }
 case 1:
  {
   f9 = Math_fround(f5 * Math_fround(1.25840795));
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 580 >> 2] | 0, i1 | 0, 0, 0);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 564 >> 2] | 0, i1 | 0, 0.0, 0.0, 0.0);
   f23 = Math_fround(f9 * Math_fround(.606999993));
   f26 = Math_fround(f23 + f2);
   f5 = Math_fround(Math_fround(f9 * Math_fround(0.0)) + f3);
   f14 = Math_fround(f9 * Math_fround(.795000016));
   f25 = Math_fround(f14 + f4);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   f15 = Math_fround(f9 * Math_fround(.187999994));
   f27 = Math_fround(f15 + f2);
   f11 = Math_fround(f9 * Math_fround(.577000022));
   f8 = Math_fround(f11 + f3);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f8, +f25);
   f24 = Math_fround(f9 * Math_fround(.490999997));
   f28 = Math_fround(f2 - f24);
   f12 = Math_fround(f9 * Math_fround(.356999993));
   f10 = Math_fround(f12 + f3);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   f12 = Math_fround(f3 - f12);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   f11 = Math_fround(f3 - f11);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f11, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   f20 = Math_fround(f9 * Math_fround(.981999993));
   f16 = Math_fround(f20 + f2);
   f15 = Math_fround(f15 + f4);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f16, +f5, +f15);
   f14 = Math_fround(f14 + f2);
   f7 = Math_fround(f9 * Math_fround(-.187999994));
   f13 = Math_fround(f7 + f4);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f8, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f8, +f13);
   f18 = Math_fround(f9 * Math_fround(.30399999));
   f19 = Math_fround(f18 + f2);
   f17 = Math_fround(f9 * Math_fround(.934000015));
   f22 = Math_fround(f17 + f3);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f22, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f22, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f8, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f8, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f22, +f15);
   f18 = Math_fround(f2 - f18);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f22, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f8, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f22, +f13);
   f9 = Math_fround(f9 * Math_fround(-.795000016));
   f21 = Math_fround(f9 + f2);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f8, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f8, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f8, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f8, +f15);
   f20 = Math_fround(f2 - f20);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f20, +f5, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f20, +f5, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f11, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f10, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f11, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f11, +f15);
   f17 = Math_fround(f3 - f17);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f17, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f17, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f17, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f28, +f12, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f17, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f11, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f11, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f17, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f11, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f11, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f11, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f16, +f5, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f27, +f11, +f25);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f16, +f5, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f26, +f5, +f25);
   f3 = Math_fround(f24 + f2);
   f9 = Math_fround(f9 + f4);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   f7 = Math_fround(f7 + f2);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f8, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f22, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f22, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f22, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f22, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f8, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f8, +f9);
   f4 = Math_fround(f2 - f23);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f20, +f5, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f8, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f20, +f5, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f8, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f8, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f8, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f22, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f17, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f17, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f11, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f21, +f11, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f20, +f5, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f12, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f11, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f11, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f17, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f19, +f17, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f18, +f17, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f12, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f8, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f12, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f8, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f16, +f5, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f12, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f16, +f5, +f15);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f14, +f11, +f13);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f12, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f11, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f3, +f10, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f4, +f5, +f9);
   mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, +f7, +f8, +f9);
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 584 >> 2] | 0, i1 | 0);
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 392020 | 0, 0, gb + 392043 | 0, 1184, 32785, 0, 0, 0);
   return;
  }
 }
}

function __ZN5physx2Gu36closestPtPointTetrahedronTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_RjRS3_S6_(i52, i48, i46, i47, i53, i35, i36) {
 i52 = i52 | 0;
 i48 = i48 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 i53 = i53 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i49 = 0, i50 = 0, i51 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i54 + 352 | 0;
 i51 = i54 + 224 | 0;
 i49 = i54 + 160 | 0;
 i50 = i54 + 96 | 0;
 i38 = i54 + 80 | 0;
 i39 = i54 + 64 | 0;
 i24 = i54 + 340 | 0;
 i23 = i54 + 336 | 0;
 i5 = i54 + 48 | 0;
 i26 = i54 + 324 | 0;
 i27 = i54 + 320 | 0;
 i28 = i54 + 32 | 0;
 i30 = i54 + 308 | 0;
 i31 = i54 + 304 | 0;
 i32 = i54 + 16 | 0;
 i33 = i54 + 292 | 0;
 i34 = i54 + 288 | 0;
 i37 = i54;
 i1 = HEAP32[i53 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i48 >> 2]);
 f20 = Math_fround(HEAPF32[i48 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i48 + 8 >> 2]);
 i45 = i48 + 16 | 0;
 f22 = Math_fround(HEAPF32[i48 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i48 + 20 >> 2]);
 f18 = Math_fround(HEAPF32[i48 + 24 >> 2]);
 i44 = i48 + 32 | 0;
 f14 = Math_fround(HEAPF32[i48 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i48 + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i48 + 40 >> 2]);
 f4 = Math_fround(HEAPF32[i48 + 48 >> 2]);
 f6 = Math_fround(HEAPF32[i48 + 52 >> 2]);
 f7 = Math_fround(HEAPF32[i48 + 56 >> 2]);
 f8 = Math_fround(f4 - f19);
 f9 = Math_fround(f6 - f20);
 f10 = Math_fround(f7 - f21);
 f11 = Math_fround(f4 - f22);
 f12 = Math_fround(f6 - f17);
 f13 = Math_fround(f7 - f18);
 f59 = Math_fround(f4 - f14);
 f58 = Math_fround(f6 - f15);
 f57 = Math_fround(f7 - f16);
 f55 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
 f56 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
 f57 = Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f57 * f57));
 f56 = f56 > f57 ? f57 : f56;
 if ((f55 > f56 ? f56 : f55) < Math_fround(1.1920929e-07)) {
  HEAP32[i53 >> 2] = 3;
  HEAP32[i2 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i52, i48, i46, i47, i2, i53, i35, i36);
  STACKTOP = i54;
  return;
 }
 i40 = i48 + 48 | 0;
 HEAP32[i51 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
 i2 = i51 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i2 = i51 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 i2 = i51 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 HEAP32[i49 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
 i2 = i49 + 16 | 0;
 i40 = i46 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 i2 = i49 + 32 | 0;
 i41 = i46 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
 i2 = i49 + 48 | 0;
 i42 = i46 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
 HEAP32[i50 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
 i2 = i50 + 16 | 0;
 i42 = i47 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
 i2 = i50 + 32 | 0;
 i43 = i47 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
 i2 = i50 + 48 | 0;
 i3 = i47 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 f58 = Math_fround(f22 - f19);
 f67 = Math_fround(f17 - f20);
 f56 = Math_fround(f18 - f21);
 f55 = Math_fround(f14 - f19);
 f62 = Math_fround(f15 - f20);
 f60 = Math_fround(f16 - f21);
 f57 = Math_fround(f14 - f22);
 f66 = Math_fround(f15 - f17);
 f59 = Math_fround(f16 - f18);
 f64 = Math_fround(Math_fround(f67 * f60) - Math_fround(f56 * f62));
 f63 = Math_fround(Math_fround(f56 * f55) - Math_fround(f58 * f60));
 f65 = Math_fround(Math_fround(f58 * f62) - Math_fround(f67 * f55));
 f61 = Math_fround(Math_fround(f62 * f10) - Math_fround(f60 * f9));
 f60 = Math_fround(Math_fround(f60 * f8) - Math_fround(f55 * f10));
 f62 = Math_fround(Math_fround(f55 * f9) - Math_fround(f62 * f8));
 f55 = Math_fround(Math_fround(f56 * f9) - Math_fround(f67 * f10));
 f56 = Math_fround(Math_fround(f58 * f10) - Math_fround(f56 * f8));
 f10 = Math_fround(Math_fround(f67 * f8) - Math_fround(f58 * f9));
 f58 = Math_fround(Math_fround(f59 * f12) - Math_fround(f66 * f13));
 f59 = Math_fround(Math_fround(f57 * f13) - Math_fround(f59 * f11));
 f57 = Math_fround(Math_fround(f66 * f11) - Math_fround(f57 * f12));
 i2 = Math_fround(Math_fround(Math_fround(f21 * f65) + Math_fround(Math_fround(f19 * f64) + Math_fround(f20 * f63))) * Math_fround(Math_fround(f65 * f7) + Math_fround(Math_fround(f4 * f64) + Math_fround(f6 * f63)))) >= Math_fround(-9.99999997e-07);
 i3 = Math_fround(Math_fround(Math_fround(f21 * f62) + Math_fround(Math_fround(f19 * f61) + Math_fround(f20 * f60))) * Math_fround(Math_fround(f18 * f62) + Math_fround(Math_fround(f22 * f61) + Math_fround(f17 * f60)))) >= Math_fround(-9.99999997e-07);
 i25 = Math_fround(Math_fround(Math_fround(f21 * f10) + Math_fround(Math_fround(f19 * f55) + Math_fround(f20 * f56))) * Math_fround(Math_fround(f16 * f10) + Math_fround(Math_fround(f14 * f55) + Math_fround(f15 * f56)))) >= Math_fround(-9.99999997e-07);
 i29 = Math_fround(Math_fround(Math_fround(f18 * f57) + Math_fround(Math_fround(f22 * f58) + Math_fround(f17 * f59))) * Math_fround(Math_fround(f21 * f57) + Math_fround(Math_fround(f19 * f58) + Math_fround(f20 * f59)))) >= Math_fround(-9.99999997e-07);
 if (i25 | (i2 | i3) | i29) {
  if (i2) {
   HEAP32[i24 >> 2] = HEAP32[gb + 101572 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
   HEAP32[i23 >> 2] = 3;
   __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i5, i51, i49, i50, i24, i23, i38, i39);
   f13 = Math_fround(HEAPF32[i5 >> 2]);
   f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f4 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f11 * f11));
   i1 = HEAP32[i23 >> 2] | 0;
   HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i35 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i35 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i35 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   HEAP32[i36 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  } else {
   f8 = Math_fround(3402823469999999843913219.0e14);
   f4 = Math_fround(0.0);
   f11 = Math_fround(0.0);
   f14 = Math_fround(0.0);
   f13 = Math_fround(0.0);
  }
  if (i3) {
   HEAP32[i26 >> 2] = HEAP32[gb + 90604 >> 2];
   HEAP32[i26 + 4 >> 2] = HEAP32[gb + 90604 + 4 >> 2];
   HEAP32[i26 + 8 >> 2] = HEAP32[gb + 90604 + 8 >> 2];
   HEAP32[i27 >> 2] = 3;
   __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i28, i51, i49, i50, i26, i27, i38, i39);
   f9 = Math_fround(HEAPF32[i28 >> 2]);
   f10 = Math_fround(HEAPF32[i28 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i28 + 8 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f7 * f7));
   if (f8 > f6) {
    f4 = Math_fround(HEAPF32[i28 + 12 >> 2]);
    i1 = HEAP32[i27 >> 2] | 0;
    HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i36 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    f12 = f6;
    f11 = f7;
    f13 = f9;
    i3 = 3;
    i2 = 2;
   } else {
    f12 = f8;
    f10 = f14;
    i3 = 2;
    i2 = 1;
   }
  } else {
   f12 = f8;
   f10 = f14;
   i3 = 2;
   i2 = 1;
  }
  if (i25) {
   HEAP32[i30 >> 2] = HEAP32[gb + 90616 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[gb + 90616 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[gb + 90616 + 8 >> 2];
   HEAP32[i31 >> 2] = 3;
   __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i32, i51, i49, i50, i30, i31, i38, i39);
   f9 = Math_fround(HEAPF32[i32 >> 2]);
   f8 = Math_fround(HEAPF32[i32 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i32 + 8 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f7 * f7));
   if (f12 > f6) {
    f4 = Math_fround(HEAPF32[i32 + 12 >> 2]);
    i1 = HEAP32[i31 >> 2] | 0;
    HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i36 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    f12 = f6;
    f11 = f7;
    f10 = f8;
    i3 = 1;
    i2 = 3;
   } else f9 = f13;
  } else f9 = f13;
  if (i29) {
   HEAP32[i33 >> 2] = HEAP32[gb + 90628 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[gb + 90628 + 4 >> 2];
   HEAP32[i33 + 8 >> 2] = HEAP32[gb + 90628 + 8 >> 2];
   HEAP32[i34 >> 2] = 3;
   __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i37, i51, i49, i50, i33, i34, i38, i39);
   f8 = Math_fround(HEAPF32[i37 >> 2]);
   f7 = Math_fround(HEAPF32[i37 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i37 + 8 >> 2]);
   if (f12 > Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6))) {
    f4 = Math_fround(HEAPF32[i37 + 12 >> 2]);
    i1 = HEAP32[i34 >> 2] | 0;
    HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i36 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    i5 = 1;
    i3 = 2;
    i2 = 3;
   } else {
    f8 = f9;
    f7 = f10;
    f6 = f11;
    i5 = 0;
   }
  } else {
   f8 = f9;
   f7 = f10;
   f6 = f11;
   i5 = 0;
  }
  i39 = i49 + (i5 << 4) | 0;
  HEAP32[i46 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAP32[i46 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  i46 = i49 + (i2 << 4) | 0;
  HEAP32[i40 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
  i49 = i49 + (i3 << 4) | 0;
  HEAP32[i41 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i41 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  i49 = i50 + (i5 << 4) | 0;
  HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i47 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  i49 = i50 + (i2 << 4) | 0;
  HEAP32[i42 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  i50 = i50 + (i3 << 4) | 0;
  HEAP32[i43 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  i50 = i51 + (i5 << 4) | 0;
  HEAP32[i48 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  i50 = i51 + (i2 << 4) | 0;
  HEAP32[i45 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i45 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i45 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i45 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  i51 = i51 + (i3 << 4) | 0;
  HEAP32[i44 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i44 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  HEAP32[i53 >> 2] = i1;
  HEAPF32[i52 >> 2] = f8;
  HEAPF32[i52 + 4 >> 2] = f7;
  HEAPF32[i52 + 8 >> 2] = f6;
  HEAPF32[i52 + 12 >> 2] = f4;
 } else {
  HEAP32[i52 >> 2] = 0;
  HEAP32[i52 + 4 >> 2] = 0;
  HEAP32[i52 + 8 >> 2] = 0;
  HEAP32[i52 + 12 >> 2] = 0;
 }
 STACKTOP = i54;
 return;
}

function __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE(i36, i37, i9, i33, i21, i22, i39, f3, i28, i29, i34, i35) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i9 = i9 | 0;
 i33 = i33 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i39 = i39 | 0;
 f3 = Math_fround(f3);
 i28 = i28 | 0;
 i29 = i29 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i38 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 4736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i40 + 176 | 0;
 i23 = i40 + 96 | 0;
 i24 = i40 + 64 | 0;
 i31 = i40 + 32 | 0;
 i8 = i40 + 112 | 0;
 i10 = i40 + 16 | 0;
 i25 = i40;
 i38 = i40 + 4700 | 0;
 i32 = i40 + 4680 | 0;
 i30 = i40 + 4664 | 0;
 i26 = i40 + 4640 | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i15 = HEAP32[i22 + 4 >> 2] | 0;
 i7 = HEAP32[i22 + 8 >> 2] | 0;
 i6 = HEAP32[i22 + 12 >> 2] | 0;
 i20 = i22 + 16 | 0;
 i55 = HEAP32[i20 >> 2] | 0;
 i54 = HEAP32[i20 + 4 >> 2] | 0;
 i53 = HEAP32[i20 + 8 >> 2] | 0;
 i59 = HEAP32[i39 >> 2] | 0;
 i58 = HEAP32[i39 + 4 >> 2] | 0;
 i57 = HEAP32[i39 + 8 >> 2] | 0;
 i56 = HEAP32[i39 + 12 >> 2] | 0;
 i19 = i39 + 16 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i2 = HEAP32[i19 + 4 >> 2] | 0;
 i4 = HEAP32[i19 + 8 >> 2] | 0;
 HEAPF32[i23 >> 2] = f3;
 HEAP32[i24 >> 2] = i5;
 HEAP32[i24 + 4 >> 2] = i15;
 HEAP32[i24 + 8 >> 2] = i7;
 HEAP32[i24 + 12 >> 2] = i6;
 HEAP32[i24 + 16 >> 2] = i55;
 HEAP32[i24 + 20 >> 2] = i54;
 HEAP32[i24 + 24 >> 2] = i53;
 HEAPF32[i24 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i31 >> 2] = i59;
 HEAP32[i31 + 4 >> 2] = i58;
 HEAP32[i31 + 8 >> 2] = i57;
 HEAP32[i31 + 12 >> 2] = i56;
 HEAP32[i31 + 16 >> 2] = i1;
 HEAP32[i31 + 20 >> 2] = i2;
 HEAP32[i31 + 24 >> 2] = i4;
 HEAPF32[i31 + 28 >> 2] = Math_fround(0.0);
 f45 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = Math_fround(-f45);
 f50 = Math_fround(-f50);
 f14 = Math_fround(-f14);
 f18 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = Math_fround(f18 - f49);
 f52 = Math_fround(f41 - f52);
 f43 = Math_fround(f43 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f41 = Math_fround(Math_fround(f46 * f46) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(f52 * f50)) + Math_fround(f43 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f18 * f45) + Math_fround(Math_fround(f41 * f49) + Math_fround(f46 * Math_fround(Math_fround(f43 * f50) - Math_fround(f52 * f14))))) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(f18 * f50) + Math_fround(Math_fround(f41 * f52) + Math_fround(f46 * Math_fround(Math_fround(f49 * f14) - Math_fround(f43 * f45))))) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f43) + Math_fround(f46 * Math_fround(Math_fround(f52 * f45) - Math_fround(f49 * f50)))) + Math_fround(f18 * f14)) * Math_fround(2.0));
 f49 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_fround(f46 * f41) - Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(f52 * f50)) + Math_fround(f43 * f14)));
 f12 = Math_fround(Math_fround(Math_fround(f43 * f50) - Math_fround(f52 * f14)) + Math_fround(Math_fround(f46 * f49) + Math_fround(f41 * f45)));
 f13 = Math_fround(Math_fround(Math_fround(f49 * f14) - Math_fround(f43 * f45)) + Math_fround(Math_fround(f46 * f52) + Math_fround(f41 * f50)));
 f14 = Math_fround(Math_fround(Math_fround(f52 * f45) - Math_fround(f49 * f50)) + Math_fround(Math_fround(f46 * f43) + Math_fround(f41 * f14)));
 HEAPF32[i8 + 48 >> 2] = f16;
 HEAPF32[i8 + 52 >> 2] = f17;
 HEAPF32[i8 + 56 >> 2] = f18;
 HEAPF32[i8 + 60 >> 2] = Math_fround(0.0);
 f41 = Math_fround(f12 + f12);
 f43 = Math_fround(f13 + f13);
 f46 = Math_fround(f14 + f14);
 f50 = Math_fround(f13 * f43);
 f49 = Math_fround(f14 * f46);
 f45 = Math_fround(f13 * f41);
 f52 = Math_fround(f14 * f41);
 f42 = Math_fround(f3 * f41);
 f51 = Math_fround(f14 * f43);
 f43 = Math_fround(f3 * f43);
 f46 = Math_fround(f3 * f46);
 f41 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f41));
 f48 = Math_fround(f45 + f46);
 f47 = Math_fround(f52 - f43);
 f46 = Math_fround(f45 - f46);
 f45 = Math_fround(f41 - f49);
 f44 = Math_fround(f51 + f42);
 f43 = Math_fround(f52 + f43);
 f42 = Math_fround(f51 - f42);
 f41 = Math_fround(f41 - f50);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f50) - f49);
 HEAPF32[i8 + 4 >> 2] = f48;
 HEAPF32[i8 + 8 >> 2] = f47;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = f46;
 HEAPF32[i8 + 20 >> 2] = f45;
 HEAPF32[i8 + 24 >> 2] = f44;
 HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 32 >> 2] = f43;
 HEAPF32[i8 + 36 >> 2] = f42;
 HEAPF32[i8 + 40 >> 2] = f41;
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 f41 = Math_fround(HEAPF32[i9 >> 2]);
 HEAPF32[i10 >> 2] = Math_fround(f41 * Math_fround(.600000024));
 HEAPF32[i25 >> 2] = Math_fround(f41 * Math_fround(.0500000007));
 i6 = i35 + 53 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 i15 = i35 + 52 | 0;
 i5 = HEAP8[i15 >> 0] | 0;
 if (!(i5 << 24 >> 24)) i11 = 10; else {
  i1 = 0;
  do {
   i2 = i35 + 48 + i1 | 0;
   i4 = HEAP8[i2 >> 0] | 0;
   i5 = i4 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i27, i35 + 64 + (i5 * 400 | 0) | 0, i8, i10, i23);
   if (!(HEAP32[i35 + 64 + (i5 * 400 | 0) + 384 >> 2] | 0)) {
    i58 = (HEAP8[i15 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i15 >> 0] = i58;
    i58 = (i58 & 255) + (i35 + 48) | 0;
    i59 = HEAP8[i58 >> 0] | 0;
    HEAP8[i58 >> 0] = i4;
    HEAP8[i2 >> 0] = i59;
    i1 = i1 + -1 | 0;
   } else HEAP32[i35 + 32 + (i5 << 2) >> 2] = HEAP32[i27 >> 2];
   i1 = i1 + 1 | 0;
   i59 = HEAPU8[i15 >> 0] | 0;
  } while (i1 >>> 0 < i59 >>> 0);
  if ((HEAP8[i6 >> 0] | 0) == i7 << 24 >> 24) i11 = 10; else {
   i1 = i35 + 4 | 0;
   i2 = i35 + 8 | 0;
   i8 = i35 + 12 | 0;
   i7 = i35 + 16 | 0;
   i6 = i35 + 20 | 0;
   i4 = i35 + 24 | 0;
   i5 = i35;
  }
 }
 if ((i11 | 0) == 10) {
  f49 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(.200000003));
  i7 = i35 + 16 | 0;
  f46 = Math_fround(HEAPF32[i7 >> 2]);
  i6 = i35 + 20 | 0;
  f52 = Math_fround(HEAPF32[i6 >> 2]);
  i4 = i35 + 24 | 0;
  f46 = Math_fround(f16 - f46);
  f52 = Math_fround(f17 - f52);
  f51 = Math_fround(f18 - Math_fround(HEAPF32[i4 >> 2]));
  f48 = Math_fround(-f46);
  f47 = Math_fround(-f52);
  f50 = Math_fround(-f51);
  f48 = f46 > f48 ? f46 : f48;
  f47 = f52 > f47 ? f52 : f47;
  f47 = f48 >= f47 ? f48 : f47;
  i1 = (f51 > f50 ? f51 : f50) >= Math_fround(0.0);
  f48 = i1 ? f48 : Math_fround(0.0);
  f50 = Math_fround(HEAPF32[i35 >> 2]);
  i1 = i35 + 4 | 0;
  f51 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i35 + 8 | 0;
  f52 = Math_fround(HEAPF32[i2 >> 2]);
  i5 = i35 + 12 | 0;
  if ((f47 >= f48 ? f47 : f48) > f49 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f12 * f50) + Math_fround(f13 * f51)) + Math_fround(f14 * f52)) + Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]))) < Math_fround(.999800026)) {
   i8 = i5;
   i5 = i35;
  } else {
   i59 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i35, i28, i31) | 0;
   STACKTOP = i40;
   return i59 | 0;
  }
 }
 HEAP8[i15 >> 0] = 0;
 HEAPF32[i5 >> 2] = f12;
 HEAPF32[i1 >> 2] = f13;
 HEAPF32[i2 >> 2] = f14;
 HEAPF32[i8 >> 2] = f3;
 HEAPF32[i7 >> 2] = f16;
 HEAPF32[i6 >> 2] = f17;
 HEAPF32[i4 >> 2] = f18;
 HEAPF32[i35 + 28 >> 2] = Math_fround(0.0);
 f42 = Math_fround(-Math_fround(HEAPF32[i39 >> 2]));
 f43 = Math_fround(-Math_fround(HEAPF32[i39 + 4 >> 2]));
 f46 = Math_fround(-Math_fround(HEAPF32[i39 + 8 >> 2]));
 f17 = Math_fround(HEAPF32[i39 + 12 >> 2]);
 f41 = Math_fround(HEAPF32[i20 >> 2]);
 f41 = Math_fround(f41 - Math_fround(HEAPF32[i19 >> 2]));
 f44 = Math_fround(HEAPF32[i22 + 20 >> 2]);
 f44 = Math_fround(f44 - Math_fround(HEAPF32[i39 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i22 + 24 >> 2]);
 f41 = Math_fround(f41 * Math_fround(2.0));
 f44 = Math_fround(f44 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i39 + 24 >> 2])) * Math_fround(2.0));
 f49 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f52 = Math_fround(Math_fround(Math_fround(f41 * f42) + Math_fround(f44 * f43)) + Math_fround(f18 * f46));
 f50 = Math_fround(Math_fround(f52 * f42) + Math_fround(Math_fround(f49 * f41) + Math_fround(f17 * Math_fround(Math_fround(f18 * f43) - Math_fround(f44 * f46)))));
 f51 = Math_fround(Math_fround(f52 * f43) + Math_fround(Math_fround(f49 * f44) + Math_fround(f17 * Math_fround(Math_fround(f41 * f46) - Math_fround(f18 * f42)))));
 f52 = Math_fround(Math_fround(Math_fround(f49 * f18) + Math_fround(f17 * Math_fround(Math_fround(f44 * f42) - Math_fround(f41 * f43)))) + Math_fround(f52 * f46));
 f41 = Math_fround(HEAPF32[i22 >> 2]);
 f44 = Math_fround(f17 * f41);
 f18 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f44 = Math_fround(f44 + Math_fround(f18 * f42));
 f49 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f44 = Math_fround(f44 + Math_fround(f49 * f43));
 f45 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f47 = Math_fround(Math_fround(Math_fround(f41 * f46) + Math_fround(Math_fround(f18 * f43) + Math_fround(f17 * f45))) - Math_fround(f49 * f42));
 f48 = Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(Math_fround(f18 * f46) + Math_fround(f17 * f49))) - Math_fround(f41 * f43));
 f49 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f18) - Math_fround(f41 * f42)) - Math_fround(f45 * f43)) - Math_fround(f49 * f46));
 HEAPF32[i38 >> 2] = Math_fround(f44 - Math_fround(f45 * f46));
 HEAPF32[i38 + 4 >> 2] = f47;
 HEAPF32[i38 + 8 >> 2] = f48;
 HEAPF32[i38 + 12 >> 2] = f49;
 HEAPF32[i38 + 16 >> 2] = f50;
 HEAPF32[i38 + 20 >> 2] = f51;
 HEAPF32[i38 + 24 >> 2] = f52;
 HEAP32[i32 + 12 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i32 + 16 >> 2] = i21;
 HEAPF32[i32 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i21 + 8 >> 2]));
 HEAPF32[i32 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i21 + 12 >> 2]));
 HEAPF32[i32 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i21 + 16 >> 2]));
 __ZN5physx2Gu9ContainerC2Ev(i30);
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 4352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i30, 1088, i1, 1);
 HEAP32[i27 + 4 >> 2] = i32;
 HEAP32[i27 + 8 >> 2] = i39;
 HEAP32[i27 >> 2] = gb + 146984 + 8;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i27 + 16 | 0, i23, i25, i24, i31, i35, i28);
 HEAP32[i27 + 3632 >> 2] = 0;
 i1 = i27 + 3504 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i27 + 4404 >> 2] = 0;
 i1 = i27 + 4276 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i27 + 4432 >> 2] = i30;
 HEAP32[i27 + 4436 >> 2] = i36;
 HEAP32[i27 + 4440 >> 2] = i37;
 HEAP32[i27 + 4444 >> 2] = i29;
 HEAP8[i27 + 4448 >> 0] = i34 & 1;
 f51 = Math_fround(HEAPF32[i36 >> 2]);
 f50 = Math_fround(HEAPF32[i36 + 4 >> 2]);
 f52 = Math_fround(HEAPF32[i36 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i27 + 2320 >> 2]);
 f49 = Math_fround(HEAPF32[i27 + 2324 >> 2]);
 f48 = Math_fround(f51 - f48);
 f49 = Math_fround(f50 - f49);
 f52 = Math_fround(f52 - Math_fround(HEAPF32[i27 + 2328 >> 2]));
 f50 = Math_fround(f48 * Math_fround(HEAPF32[i27 + 2272 >> 2]));
 f50 = Math_fround(f50 + Math_fround(f49 * Math_fround(HEAPF32[i27 + 2276 >> 2])));
 f50 = Math_fround(f50 + Math_fround(f52 * Math_fround(HEAPF32[i27 + 2280 >> 2])));
 f51 = Math_fround(f48 * Math_fround(HEAPF32[i27 + 2288 >> 2]));
 f51 = Math_fround(f51 + Math_fround(f49 * Math_fround(HEAPF32[i27 + 2292 >> 2])));
 f51 = Math_fround(f51 + Math_fround(f52 * Math_fround(HEAPF32[i27 + 2296 >> 2])));
 f48 = Math_fround(f48 * Math_fround(HEAPF32[i27 + 2304 >> 2]));
 f49 = Math_fround(f48 + Math_fround(f49 * Math_fround(HEAPF32[i27 + 2308 >> 2])));
 f52 = Math_fround(f49 + Math_fround(f52 * Math_fround(HEAPF32[i27 + 2312 >> 2])));
 HEAPF32[i27 + 4416 >> 2] = f50;
 HEAPF32[i27 + 4420 >> 2] = f51;
 HEAPF32[i27 + 4424 >> 2] = f52;
 HEAPF32[i27 + 4428 >> 2] = Math_fround(0.0);
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i26, i38, i33);
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i32, i39, i26, 0, i27) | 0;
 i59 = i27 + 16 | 0;
 __ZN5physx2Gu32PCMConvexVsMeshContactGeneration20generateLastContactsEv(i59);
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i59, 6, 0);
 __ZN5physx2Gu9ContainerD2Ev(i30);
 i59 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i35, i28, i31) | 0;
 STACKTOP = i40;
 return i59 | 0;
}

function __ZN21BillboardBatchManager15BatchBillboardsERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i1, i62, i63, i64) {
 i1 = i1 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, d75 = 0.0, i76 = 0, i77 = 0, i78 = 0, f79 = f0, f80 = f0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 704 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i74 + 16 | 0;
 i61 = i74;
 i55 = i74 + 172 | 0;
 i57 = i74 + 168 | 0;
 i58 = i74 + 152 | 0;
 i59 = i74 + 696 | 0;
 i60 = i74 + 40 | 0;
 d75 = +_emscripten_get_now() * 1.0e6;
 i66 = ~~d75 >>> 0;
 i67 = +Math_abs(d75) >= 1.0 ? (d75 > 0.0 ? ~~+Math_min(+Math_floor(d75 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d75 - +(~~d75 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i68 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i68 >> 2] | 0) + 104 >> 2] | 0, i68 | 0, gb + 1162292 | 0, 0);
 i53 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(HEAP32[gb + 1159920 >> 2] | 0, HEAP32[i64 >> 2] | 0, 0) | 0;
 i54 = HEAP32[(HEAP32[gb + 1159920 >> 2] | 0) + 4 >> 2] | 0;
 i69 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64024 | 0, 16, gb + 422286 | 0, 274) | 0;
 HEAP32[i69 >> 2] = 1;
 i72 = gb + 64024 | 0;
 i71 = HEAP32[i72 + 4 >> 2] | 0;
 i70 = i61;
 HEAP32[i70 >> 2] = HEAP32[i72 >> 2];
 HEAP32[i70 + 4 >> 2] = i71;
 i70 = i69 + 4 | 0;
 HEAP32[i70 >> 2] = 0;
 i71 = i69 + 16 | 0;
 HEAP32[i71 >> 2] = 0;
 i72 = i69 + 20 | 0;
 HEAP32[i72 >> 2] = 0;
 i73 = i69 + 8 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i61);
 i2 = i52;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i56 = i73;
 HEAP32[i56 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i56 + 4 >> 2] = i1;
 i56 = i63 + 4 | 0;
 i1 = HEAP32[i56 >> 2] | 0;
 HEAP32[i71 >> 2] = i1;
 i2 = HEAP32[i72 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i72 >> 2] = i1;
  HEAP32[i70 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i70 >> 2] | 0, i1 << 5, 4, i73, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i51 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i73, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i51 | 0, HEAP32[i70 >> 2] | 0, HEAP32[i71 >> 2] << 5 | 0) | 0;
  HEAP32[i72 >> 2] = i1;
  HEAP32[i70 >> 2] = i51;
  break;
 } while (0);
 i3 = HEAP32[i56 >> 2] | 0;
 L7 : do if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  i18 = i68 + 4448 | 0;
  i19 = i58 + 4 | 0;
  i20 = i58 + 8 | 0;
  i21 = i58 + 12 | 0;
  i22 = i60 + 4 | 0;
  i23 = i60 + 32 | 0;
  i24 = i60 + 44 | 0;
  i25 = i60 + 48 | 0;
  i26 = i60 + 36 | 0;
  i27 = i60 + 52 | 0;
  i28 = i60 + 64 | 0;
  i29 = i60 + 68 | 0;
  i30 = i60 + 56 | 0;
  i31 = i60 + 72 | 0;
  i32 = i60 + 84 | 0;
  i33 = i60 + 88 | 0;
  i34 = i60 + 76 | 0;
  i35 = i60 + 92 | 0;
  i36 = i60 + 96 | 0;
  i37 = i60 + 100 | 0;
  i38 = i60 + 108 | 0;
  i39 = i60 + 8 | 0;
  i40 = i52 + 4 | 0;
  i41 = i52 + 8 | 0;
  i42 = i52 + 12 | 0;
  i43 = i61 + 4 | 0;
  i44 = i61 + 8 | 0;
  i45 = i61 + 12 | 0;
  i46 = i52 + 4 | 0;
  i47 = i52 + 8 | 0;
  i48 = i52 + 12 | 0;
  i49 = i52 + 16 | 0;
  i50 = i60 + 52 | 0;
  i51 = i60 + 32 | 0;
  i2 = 0;
  i1 = 0;
  i4 = 0;
  while (1) {
   i8 = HEAP32[i63 >> 2] | 0;
   i9 = HEAP32[i62 >> 2] | 0;
   while (1) {
    i5 = HEAP32[i8 + (i4 << 3) >> 2] | 0;
    i6 = HEAP32[i9 + (i5 * 360 | 0) + 328 >> 2] | 0;
    i7 = i6 + 4 | 0;
    if (!(Math_fround(HEAPF32[i7 >> 2]) <= Math_fround(0.0))) if (!(Math_fround(HEAPF32[i6 + 8 >> 2]) <= Math_fround(0.0))) break;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= i3 >>> 0) break L7;
   }
   i15 = HEAP32[i70 >> 2] | 0;
   HEAP32[i15 + (i4 << 5) >> 2] = HEAP32[i6 >> 2];
   i16 = HEAP32[i9 + (i5 * 360 | 0) + 52 >> 2] | 0;
   i6 = HEAP32[i9 + (i5 * 360 | 0) + 56 >> 2] | 0;
   HEAP32[i15 + (i4 << 5) + 4 >> 2] = HEAP32[i9 + (i5 * 360 | 0) + 48 >> 2];
   HEAP32[i15 + (i4 << 5) + 8 >> 2] = i16;
   HEAP32[i15 + (i4 << 5) + 12 >> 2] = i6;
   i6 = i15 + (i4 << 5) + 16 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = HEAP32[i70 >> 2] | 0;
   i15 = HEAP32[i6 + (i4 << 5) >> 2] | 0;
   i16 = HEAP32[i15 + 60 >> 2] | 0;
   i17 = HEAP32[i15 + 80 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i12 = (65535 / (i16 >>> 0) | 0) + i4 | 0;
   L17 : do if (i5 >>> 0 < (HEAP32[i56 >> 2] | 0) >>> 0) {
    i3 = i5;
    while (1) {
     i7 = i6 + (i5 << 5) | 0;
     i8 = HEAP32[(HEAP32[i63 >> 2] | 0) + (i5 << 3) >> 2] | 0;
     i9 = HEAP32[i62 >> 2] | 0;
     i10 = HEAP32[i9 + (i8 * 360 | 0) + 328 >> 2] | 0;
     i11 = i10 + 4 | 0;
     if (!(Math_fround(HEAPF32[i11 >> 2]) <= Math_fround(0.0))) if (!(Math_fround(HEAPF32[i10 + 8 >> 2]) <= Math_fround(0.0))) {
      HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
      i14 = HEAP32[i9 + (i8 * 360 | 0) + 52 >> 2] | 0;
      i7 = HEAP32[i9 + (i8 * 360 | 0) + 56 >> 2] | 0;
      HEAP32[i6 + (i5 << 5) + 4 >> 2] = HEAP32[i9 + (i8 * 360 | 0) + 48 >> 2];
      HEAP32[i6 + (i5 << 5) + 8 >> 2] = i14;
      HEAP32[i6 + (i5 << 5) + 12 >> 2] = i7;
      i6 = i6 + (i5 << 5) + 16 | 0;
      HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i6 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      i6 = HEAP32[i70 >> 2] | 0;
      i7 = i6 + (i5 << 5) | 0;
      if ((HEAP32[i7 >> 2] | 0) == (i15 | 0)) {
       if ((i5 | 0) != (i3 | 0)) {
        i78 = i6 + (i3 << 5) | 0;
        i77 = HEAP32[i78 >> 2] | 0;
        i76 = HEAP32[i6 + (i3 << 5) + 4 >> 2] | 0;
        i8 = HEAP32[i6 + (i3 << 5) + 8 >> 2] | 0;
        i9 = HEAP32[i6 + (i3 << 5) + 12 >> 2] | 0;
        i10 = HEAP32[i6 + (i3 << 5) + 16 >> 2] | 0;
        i11 = HEAP32[i6 + (i3 << 5) + 20 >> 2] | 0;
        i13 = HEAP32[i6 + (i3 << 5) + 24 >> 2] | 0;
        i14 = HEAP32[i6 + (i3 << 5) + 28 >> 2] | 0;
        HEAP32[i78 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i78 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
        HEAP32[i78 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
        HEAP32[i78 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
        HEAP32[i78 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
        HEAP32[i78 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
        HEAP32[i78 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
        HEAP32[i78 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
        HEAP32[i7 >> 2] = i77;
        HEAP32[i6 + (i5 << 5) + 4 >> 2] = i76;
        HEAP32[i6 + (i5 << 5) + 8 >> 2] = i8;
        HEAP32[i6 + (i5 << 5) + 12 >> 2] = i9;
        HEAP32[i6 + (i5 << 5) + 16 >> 2] = i10;
        HEAP32[i6 + (i5 << 5) + 20 >> 2] = i11;
        HEAP32[i6 + (i5 << 5) + 24 >> 2] = i13;
        HEAP32[i6 + (i5 << 5) + 28 >> 2] = i14;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i12 | 0)) {
        i5 = i12;
        break L17;
       }
      }
     } else i65 = 14; else i65 = 14;
     if ((i65 | 0) == 14) {
      i65 = 0;
      i3 = i3 + 1 | 0;
     }
     i5 = i5 + 1 | 0;
     if (i5 >>> 0 >= (HEAP32[i56 >> 2] | 0) >>> 0) {
      i5 = i3;
      break L17;
     }
     i6 = HEAP32[i70 >> 2] | 0;
    }
   } while (0);
   i10 = i5 - i4 | 0;
   i9 = i10 >>> 9;
   i9 = (i9 | 0) == 0 ? 1 : i9;
   __ZN14BatchAllocatorC2Ev(i55);
   HEAP32[i57 >> 2] = 0;
   __ZN14BatchAllocator16AllocateInternalEPPvijjj(i55, i57, -1, 24, 1, 4);
   HEAP32[i57 >> 2] = 0;
   __ZN14BatchAllocator16AllocateInternalEPPvijjj(i55, 0, 0, 20, i9, 4);
   __ZN14BatchAllocator16AllocateInternalEPPvijjj(i55, (HEAP32[i57 >> 2] | 0) + 4 | 0, 0, 20, i9, 4);
   __ZN14BatchAllocator6CommitERK10MemLabelId(i55, gb + 64024 | 0);
   i11 = HEAP32[i57 >> 2] | 0;
   __ZN17UniqueIDGenerator8CreateIDEv(i52, i18);
   HEAP32[i11 + 8 >> 2] = HEAP32[i52 >> 2];
   i11 = (i10 >>> 0) / (i9 >>> 0) | 0;
   i12 = i9 + -1 | 0;
   i13 = i15 + 4 | 0;
   i14 = HEAP32[gb + 1159904 >> 2] | 0;
   i7 = 0;
   i8 = i4;
   i3 = HEAP32[i57 >> 2] | 0;
   do {
    i78 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i78 + (i7 * 20 | 0) >> 2] = i15;
    HEAP32[i78 + (i7 * 20 | 0) + 4 >> 2] = i69;
    i3 = i78 + (i7 * 20 | 0) + 8 | 0;
    HEAP32[i3 >> 2] = i8;
    i6 = i78 + (i7 * 20 | 0) + 12 | 0;
    HEAP32[i6 >> 2] = i11 + i8;
    HEAP32[i78 + (i7 * 20 | 0) + 16 >> 2] = Math_imul(i8 - i4 | 0, i16) | 0;
    if ((i7 | 0) == (i12 | 0)) HEAP32[i6 >> 2] = i5;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    HEAP32[i69 >> 2] = (HEAP32[i69 >> 2] | 0) + 1;
    i8 = HEAP32[i6 >> 2] | 0;
    i77 = i8 - (HEAP32[i3 >> 2] | 0) | 0;
    i76 = Math_imul(i77, i16) | 0;
    i77 = Math_imul(i77, i17) | 0;
    i3 = HEAP32[i57 >> 2] | 0;
    i78 = HEAP32[i3 >> 2] | 0;
    HEAP32[i78 + (i7 * 20 | 0) + 8 >> 2] = i76;
    HEAP32[i78 + (i7 * 20 | 0) + 12 >> 2] = i77;
    HEAP32[i78 + (i7 * 20 | 0) + 16 >> 2] = i14;
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i9 >>> 0);
   HEAP32[i58 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i20 >> 2] = -1;
   HEAP32[i21 >> 2] = 0;
   i76 = HEAP32[i3 + 8 >> 2] | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i68 >> 2] | 0) + 252 >> 2] | 0, i68 | 0, fb + 2415 | 0, fb + 3382 | 0, i3 | 0, i9 | 0, 0, i58 | 0);
   HEAP32[i57 >> 2] = 0;
   i78 = HEAP32[(HEAP32[i68 >> 2] | 0) + 256 >> 2] | 0;
   HEAP32[i59 >> 2] = i76;
   HEAP32[i52 >> 2] = HEAP32[i59 >> 2];
   mftCall_vii(i78 | 0, i68 | 0, i52 | 0);
   HEAP32[i22 >> 2] = 1;
   HEAP32[i60 >> 2] = gb + 33952 + 8;
   i78 = gb + 64016 | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = i61;
   HEAP32[i77 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i77 + 4 >> 2] = i76;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i25 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i61);
   i77 = i52;
   i76 = HEAP32[i77 + 4 >> 2] | 0;
   i78 = i26;
   HEAP32[i78 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i78 + 4 >> 2] = i76;
   i78 = gb + 64016 | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = i61;
   HEAP32[i77 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i77 + 4 >> 2] = i76;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i29 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i61);
   i77 = i52;
   i76 = HEAP32[i77 + 4 >> 2] | 0;
   i78 = i30;
   HEAP32[i78 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i78 + 4 >> 2] = i76;
   i78 = gb + 64016 | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = i61;
   HEAP32[i77 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i77 + 4 >> 2] = i76;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i32 >> 2] = 0;
   HEAP32[i33 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i61);
   i77 = i52;
   i76 = HEAP32[i77 + 4 >> 2] | 0;
   i78 = i34;
   HEAP32[i78 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i78 + 4 >> 2] = i76;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i36 >> 2] = 0;
   i78 = gb + 64016 | 0;
   i76 = HEAP32[i78 + 4 >> 2] | 0;
   i77 = i37;
   HEAP32[i77 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i77 + 4 >> 2] = i76;
   HEAP8[i38 >> 0] = 1;
   HEAP32[i39 >> 2] = 0;
   HEAP32[i39 + 4 >> 2] = 0;
   HEAP32[i39 + 8 >> 2] = 0;
   HEAP32[i39 + 12 >> 2] = 0;
   HEAP32[i39 + 16 >> 2] = 0;
   HEAP32[i39 + 20 >> 2] = 0;
   i77 = i15 + 40 | 0;
   i76 = HEAP32[i77 >> 2] | 0;
   __ZN19ShaderPropertySheet20ReservePropertyCountEj(i60, i76 + 2 | 0);
   f80 = Math_fround(i76 >>> 0);
   f79 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(6.28318548) / f80));
   HEAPF32[i52 >> 2] = f80;
   HEAPF32[i40 >> 2] = f79;
   HEAPF32[i41 >> 2] = Math_fround(0.0);
   HEAPF32[i42 >> 2] = Math_fround(0.0);
   __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i60, gb + 1159908 | 0, i52, 0);
   i76 = HEAP32[i15 + 20 >> 2] | 0;
   i78 = HEAP32[i15 + 24 >> 2] | 0;
   HEAP32[i61 >> 2] = HEAP32[i15 + 16 >> 2];
   HEAP32[i43 >> 2] = i76;
   HEAP32[i44 >> 2] = i78;
   HEAPF32[i45 >> 2] = Math_fround(0.0);
   __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i60, gb + 1159912 | 0, i61, 0);
   __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i60, gb + 1159916 | 0, 1, HEAP32[i15 + 28 >> 2] | 0, 16, HEAP32[i77 >> 2] | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i68 >> 2] | 0) + 184 >> 2] | 0, i68 | 0, i60 | 0);
   i77 = Math_imul(i10, i16) | 0;
   i78 = Math_imul(i10, i17) | 0;
   HEAP32[i52 >> 2] = HEAP32[gb + 1159904 >> 2];
   HEAP32[i46 >> 2] = 0;
   HEAP32[i47 >> 2] = i77;
   HEAP32[i48 >> 2] = 0;
   HEAP32[i49 >> 2] = i78;
   i76 = __ZN9GfxDevice13GetDynamicVBOEv(i68) | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i76 >> 2] | 0) + 16 >> 2] | 0, i76 | 0, i58 | 0, i64 | 0, i54 | 0, i53 | 0, i52 | 0, 1);
   __Z15gpu_time_samplev();
   i2 = i77 + i2 | 0;
   i1 = i78 + i1 | 0;
   HEAP32[i60 >> 2] = gb + 33952 + 8;
   if ((HEAP32[i33 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i34);
    HEAP32[i31 >> 2] = 0;
   }
   if ((HEAP32[i29 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i50 >> 2] | 0, i30);
    HEAP32[i50 >> 2] = 0;
   }
   if ((HEAP32[i25 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i51 >> 2] | 0, i26);
    HEAP32[i51 >> 2] = 0;
   }
   i3 = HEAP32[i56 >> 2] | 0;
   if (i5 >>> 0 >= i3 >>> 0) break; else i4 = i5;
  }
 } while (0);
 d75 = +_emscripten_get_now() * 1.0e6;
 i78 = +Math_abs(d75) >= 1.0 ? (d75 > 0.0 ? ~~+Math_min(+Math_floor(d75 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d75 - +(~~d75 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i76 = HEAP32[(HEAP32[i68 >> 2] | 0) + 268 >> 2] | 0;
 i77 = HEAP32[i71 >> 2] | 0;
 i78 = _i64Subtract(~~d75 >>> 0 | 0, i78 | 0, i66 | 0, i67 | 0) | 0;
 mftCall_viiiiiii(i76 | 0, i68 | 0, 1, (i1 >>> 0) / 3 | 0 | 0, i2 | 0, i77 | 0, i78 | 0, getTempRet0() | 0);
 HEAP32[i69 >> 2] = (HEAP32[i69 >> 2] | 0) + -1;
 if (HEAP32[i69 >> 2] | 0) {
  STACKTOP = i74;
  return;
 }
 if ((HEAP32[i72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i70 >> 2] | 0, i73);
  HEAP32[i70 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i69, gb + 64024 | 0);
 STACKTOP = i74;
 return;
}

function __Z15BuildMuscleClipRK18MecanimClipBuilderRK21AnimationClipSettingsbRN11UnityEngine9Animation28AnimationClipBindingConstantERN7mecanim6memory9AllocatorE(i35, i1, i2, i32, i33) {
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, f36 = f0, f37 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34;
 i4 = i32 + 16 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i32 + 4 | 0);
  HEAP32[i32 >> 2] = 0;
 }
 HEAP32[i32 >> 2] = 0;
 i5 = i32 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i35 + 1064 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
 }
 i1 = i32 + 20 | 0;
 i2 = i32 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i32 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i32 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i4 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i32 >> 2] = i1;
  break;
 } else {
  i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i32 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i29 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i32 >> 2] = i29;
  i1 = i29;
  break;
 } else i1 = HEAP32[i32 >> 2] | 0; while (0);
 i14 = HEAP32[i35 + 748 >> 2] | 0;
 __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_(i32, i1 + (HEAP32[i5 >> 2] << 4) | 0, i14, i14 + (HEAP32[i35 + 760 >> 2] << 4) | 0) | 0;
 i14 = HEAP32[i35 + 896 >> 2] | 0;
 __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_(i32, (HEAP32[i32 >> 2] | 0) + (HEAP32[i5 >> 2] << 4) | 0, i14, i14 + (HEAP32[i35 + 908 >> 2] << 4) | 0) | 0;
 i14 = HEAP32[i35 + 1044 >> 2] | 0;
 __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_(i32, (HEAP32[i32 >> 2] | 0) + (HEAP32[i5 >> 2] << 4) | 0, i14, i14 + (HEAP32[i35 + 1056 >> 2] << 4) | 0) | 0;
 i14 = __ZN7mecanim9animation16CreateClipSimpleEjRNS_6memory9AllocatorE(HEAP32[i35 + 1068 >> 2] | 0, i33) | 0;
 i15 = __Z25CreateStreamedClipBuilderjj(HEAP32[i35 + 740 >> 2] | 0, HEAP32[i35 + 744 >> 2] | 0) | 0;
 __ZN7mecanim9animation18CreateConstantClipERNS0_12ConstantClipEjRNS_6memory9AllocatorE(i14 + 36 | 0, HEAP32[i35 + 1036 >> 2] | 0, i33);
 i16 = i14 + 12 | 0;
 f37 = Math_fround(HEAPF32[i35 + 1076 >> 2]);
 f36 = Math_fround(HEAPF32[i35 + 1080 >> 2]);
 __Z15CreateDenseClipRN7mecanim9animation9DenseClipEjfffRNS_6memory9AllocatorE(i16, HEAP32[i35 + 888 >> 2] | 0, f37, f36, Math_fround(HEAPF32[i35 + 1084 >> 2]), i33);
 i17 = i14 + 40 | 0;
 i18 = i17;
 i19 = i30 + 4 | 0;
 i20 = i30 + 8 | 0;
 i21 = i30 + 12 | 0;
 i22 = i30 + 60 | 0;
 i23 = i35 + 720 | 0;
 i24 = i30 + 4 | 0;
 i25 = i30 + 8 | 0;
 i26 = i30 + 20 | 0;
 i27 = i30 + 16 | 0;
 i28 = i30 + 12 | 0;
 i29 = i30 + 24 | 0;
 i13 = 0;
 do {
  i6 = i35 + 620 + (i13 * 148 | 0) + 12 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) i1 = 0; else {
   i5 = i35 + 620 + (i13 * 148 | 0) | 0;
   switch (i13 | 0) {
   case 0:
    {
     i2 = 0;
     i1 = 0;
     do {
      __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i15, i1, HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
     break;
    }
   case 1:
    {
     i2 = 0;
     i1 = 0;
     do {
      __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i16, i1, HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
     break;
    }
   default:
    {
     i4 = (i13 | 0) == 2;
     i3 = 0;
     i1 = 0;
     do {
      if (i4) {
       i2 = (HEAP32[i17 >> 2] | 0) + i18 + (i1 << 2) | 0;
       i12 = (HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 120 >> 2] | 0) + 4 | 0;
       HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       i2 = HEAP32[i6 >> 2] | 0;
      }
      i3 = i3 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
   }
  }
  i11 = i35 + 620 + (i13 * 148 | 0) + 52 | 0;
  L33 : do if (HEAP32[i11 >> 2] | 0) {
   i12 = i35 + 620 + (i13 * 148 | 0) + 40 | 0;
   i10 = 0;
   while (1) {
    switch (i13 | 0) {
    case 0:
     {
      i7 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i10 << 2) >> 2] | 0;
      i8 = i7 + 164 | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      if ((i2 | 0) > -1) {
       i9 = i7 + 152 | 0;
       i6 = -1;
       do {
        HEAPF32[i19 >> 2] = Math_fround(inf);
        HEAP32[i30 >> 2] = 0;
        i4 = i20;
        i5 = i4 + 68 | 0;
        do {
         HEAP32[i4 >> 2] = 0;
         i4 = i4 + 4 | 0;
        } while ((i4 | 0) < (i5 | 0));
        do if ((i6 | 0) == (i2 + -1 | 0)) {
         i2 = HEAP32[i9 >> 2] | 0;
         HEAP32[i19 >> 2] = HEAP32[i2 + (i6 * 52 | 0) >> 2];
         i4 = i21;
         i5 = i4 + 48 | 0;
         do {
          HEAP32[i4 >> 2] = 0;
          i4 = i4 + 4 | 0;
         } while ((i4 | 0) < (i5 | 0));
         i31 = i2 + (i6 * 52 | 0) + 4 | 0;
         HEAP32[i22 >> 2] = HEAP32[i31 >> 2];
         HEAP32[i22 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
         HEAP32[i22 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
         HEAP32[i22 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
         i31 = 38;
        } else {
         if ((i6 | 0) != -1) {
          __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i7, i30, i6, i6 + 1 | 0, Math_fround(0.0));
          i31 = 38;
          break;
         }
         i3 = HEAP32[i9 >> 2] | 0;
         if (!(Math_fround(HEAPF32[i3 >> 2]) == Math_fround(-3402823469999999843913219.0e14))) {
          HEAPF32[i19 >> 2] = Math_fround(-3402823469999999843913219.0e14);
          i4 = i21;
          i5 = i4 + 48 | 0;
          do {
           HEAP32[i4 >> 2] = 0;
           i4 = i4 + 4 | 0;
          } while ((i4 | 0) < (i5 | 0));
          i31 = i3 + 4 | 0;
          HEAP32[i22 >> 2] = HEAP32[i31 >> 2];
          HEAP32[i22 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
          HEAP32[i22 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
          HEAP32[i22 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
          i31 = 38;
         }
        } while (0);
        if ((i31 | 0) == 38) {
         i31 = 0;
         __Z23ConvertCacheToBuildKeysI11QuaternionfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i30, i1, i15);
         i2 = HEAP32[i8 >> 2] | 0;
        }
        i6 = i6 + 1 | 0;
       } while ((i6 | 0) < (i2 | 0));
      }
      break;
     }
    case 1:
     {
      __Z19AddCurveToDenseClipI11QuaternionfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i16, i1, HEAP32[(HEAP32[i12 >> 2] | 0) + (i10 << 2) >> 2] | 0);
      break;
     }
    case 2:
     {
      i9 = (HEAP32[i17 >> 2] | 0) + i18 + (i1 << 2) | 0;
      i8 = (HEAP32[(HEAP32[(HEAP32[i12 >> 2] | 0) + (i10 << 2) >> 2] | 0) + 152 >> 2] | 0) + 4 | 0;
      HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      break;
     }
    default:
     {}
    }
    i10 = i10 + 1 | 0;
    i1 = i1 + 4 | 0;
    if (i10 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break L33;
   }
  } while (0);
  i5 = i35 + 620 + (i13 * 148 | 0) + 32 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2) {
   i6 = i35 + 620 + (i13 * 148 | 0) + 20 | 0;
   switch (i13 | 0) {
   case 0:
    {
     i2 = 0;
     do {
      __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i15, i1, HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
     break;
    }
   case 1:
    {
     i2 = 0;
     do {
      __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i16, i1, HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
     break;
    }
   default:
    {
     i4 = (i13 | 0) == 2;
     i3 = 0;
     do {
      if (i4) {
       i2 = (HEAP32[i17 >> 2] | 0) + i18 + (i1 << 2) | 0;
       i12 = (HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 120 >> 2] | 0) + 4 | 0;
       HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       i2 = HEAP32[i5 >> 2] | 0;
      }
      i3 = i3 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
   }
  }
  i5 = i35 + 620 + (i13 * 148 | 0) + 72 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2) {
   i6 = i35 + 620 + (i13 * 148 | 0) + 60 | 0;
   switch (i13 | 0) {
   case 0:
    {
     i2 = 0;
     do {
      __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i15, i1, HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
     break;
    }
   case 1:
    {
     i2 = 0;
     do {
      __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i16, i1, HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0);
      i2 = i2 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
     break;
    }
   default:
    {
     i4 = (i13 | 0) == 2;
     i3 = 0;
     do {
      if (i4) {
       i2 = (HEAP32[i17 >> 2] | 0) + i18 + (i1 << 2) | 0;
       i12 = (HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 120 >> 2] | 0) + 4 | 0;
       HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       i2 = HEAP32[i5 >> 2] | 0;
      }
      i3 = i3 + 1 | 0;
      i1 = i1 + 3 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
   }
  }
  i9 = i35 + 620 + (i13 * 148 | 0) + 92 | 0;
  L84 : do if (HEAP32[i9 >> 2] | 0) {
   i10 = i35 + 620 + (i13 * 148 | 0) + 80 | 0;
   i8 = 0;
   while (1) {
    switch (i13 | 0) {
    case 0:
     {
      i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
      i6 = i5 + 68 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      if ((i2 | 0) > -1) {
       i7 = i5 + 56 | 0;
       i4 = -1;
       do {
        HEAPF32[i24 >> 2] = Math_fround(inf);
        HEAP32[i30 >> 2] = 0;
        HEAP32[i25 >> 2] = 0;
        HEAP32[i25 + 4 >> 2] = 0;
        HEAP32[i25 + 8 >> 2] = 0;
        HEAP32[i25 + 12 >> 2] = 0;
        HEAP32[i25 + 16 >> 2] = 0;
        do if ((i4 | 0) == (i2 + -1 | 0)) {
         i31 = HEAP32[i7 >> 2] | 0;
         HEAP32[i24 >> 2] = HEAP32[i31 + (i4 << 4) >> 2];
         HEAPF32[i26 >> 2] = Math_fround(0.0);
         HEAPF32[i27 >> 2] = Math_fround(0.0);
         HEAPF32[i28 >> 2] = Math_fround(0.0);
         HEAP32[i29 >> 2] = HEAP32[i31 + (i4 << 4) + 4 >> 2];
         i31 = 66;
        } else {
         if ((i4 | 0) != -1) {
          __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i5, i30, i4, i4 + 1 | 0, Math_fround(0.0));
          i31 = 66;
          break;
         }
         i3 = HEAP32[i7 >> 2] | 0;
         if (!(Math_fround(HEAPF32[i3 >> 2]) == Math_fround(-3402823469999999843913219.0e14))) {
          HEAPF32[i24 >> 2] = Math_fround(-3402823469999999843913219.0e14);
          HEAPF32[i26 >> 2] = Math_fround(0.0);
          HEAPF32[i27 >> 2] = Math_fround(0.0);
          HEAPF32[i28 >> 2] = Math_fround(0.0);
          HEAP32[i29 >> 2] = HEAP32[i3 + 4 >> 2];
          i31 = 66;
         }
        } while (0);
        if ((i31 | 0) == 66) {
         i31 = 0;
         __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i30, i1, i15);
         i2 = HEAP32[i6 >> 2] | 0;
        }
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) < (i2 | 0));
      }
      break;
     }
    case 1:
     {
      __Z19AddCurveToDenseClipIfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i16, i1, HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0);
      break;
     }
    case 2:
     {
      HEAP32[(HEAP32[i17 >> 2] | 0) + i18 + (i1 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 56 >> 2] | 0) + 4 >> 2];
      break;
     }
    default:
     {}
    }
    i8 = i8 + 1 | 0;
    i1 = i1 + 1 | 0;
    if (i8 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break L84;
   }
  } while (0);
  i3 = i35 + 620 + (i13 * 148 | 0) + 112 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i2 = 0;
   while (1) {
    __ZL32AddMappedPPtrCurveToStreamedClipP19StreamedClipBuilderiRN11UnityEngine9Animation28AnimationClipBindingConstantERK13dynamic_arrayI12PPtrKeyframeLj4EE(i15, i1, i32, HEAP32[(HEAP32[i23 >> 2] | 0) + (i2 << 2) >> 2] | 0);
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break; else i1 = i1 + 1 | 0;
   }
  }
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 3);
 if (i15 | 0) {
  __Z24CreateStreamClipConstantP19StreamedClipBuilderRN7mecanim9animation12StreamedClipERNS1_6memory9AllocatorE(i15, i14, i33);
  if ((HEAP32[i15 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i15 + 4 | 0);
   HEAP32[i15 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i15, gb + 64016 | 0);
 }
 i2 = __ZN7mecanim9animation24CreateClipMuscleConstantEPNS0_4ClipERNS_6memory9AllocatorE(i14, i33) | 0;
 i1 = 0;
 do {
  HEAP32[i2 + 1088 + (i1 << 2) >> 2] = HEAP32[i35 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 155);
 STACKTOP = i34;
 return i2 | 0;
}

function __ZN5physx7NpCloth9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i29, i33, i26) {
 i29 = i29 | 0;
 i33 = i33 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i43 + 144 | 0;
 i1 = i43 + 140 | 0;
 i40 = i43 + 128 | 0;
 i2 = i43 + 120 | 0;
 i39 = i43 + 108 | 0;
 i3 = i43 + 104 | 0;
 i35 = i43 + 76 | 0;
 i23 = i43 + 64 | 0;
 i24 = i43 + 52 | 0;
 i36 = i43 + 40 | 0;
 i27 = i43 + 36 | 0;
 i34 = i43 + 24 | 0;
 i28 = i43 + 12 | 0;
 i32 = i43;
 i37 = mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 96 >> 2] | 0, i29 | 0) | 0;
 if (!i37) {
  STACKTOP = i43;
  return;
 }
 i21 = mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 84 >> 2] | 0, i29 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
 i22 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0, i21 | 0) | 0;
 i30 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 40 >> 2] | 0, i21 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i42 >> 2] = 0;
 HEAP32[i42 + 4 >> 2] = 0;
 i41 = i42 + 8 | 0;
 HEAP32[i41 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i42, i6, i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 i38 = i40 + 8 | 0;
 HEAP32[i38 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i40, i22, i2);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 i31 = i39 + 8 | 0;
 HEAP32[i31 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i39, i30, i3);
 i5 = HEAP32[i42 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 52 >> 2] | 0, i21 | 0, i5 | 0, i6 | 0) | 0;
 i6 = HEAP32[i40 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 48 >> 2] | 0, i21 | 0, i6 | 0, i22 | 0) | 0;
 i7 = HEAP32[i39 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 56 >> 2] | 0, i21 | 0, i7 | 0, i30 | 0) | 0;
 i30 = i37 + 4 | 0;
 i8 = HEAP32[i30 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 124 >> 2] | 0, i35 | 0, i29 | 0);
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i33, 1) | 0;
 L4 : do if (!i22) i1 = i26; else {
  i9 = i35 + 12 | 0;
  i10 = i35 + 4 | 0;
  i11 = i35 + 8 | 0;
  i12 = i35 + 16 | 0;
  i13 = i35 + 20 | 0;
  i14 = i35 + 24 | 0;
  i16 = i23 + 4 | 0;
  i17 = i23 + 8 | 0;
  i18 = i24 + 4 | 0;
  i19 = i24 + 8 | 0;
  i1 = 0;
  i20 = 0;
  while (1) {
   switch (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 72 >> 2] | 0, i21 | 0, i20 | 0) | 0) {
   case 1:
    {
     f15 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i26 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, 31));
     i25 = 10;
     break;
    }
   case 2:
    {
     f15 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i26 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, 32));
     i25 = 10;
     break;
    }
   case 3:
    {
     f15 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i26 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, 33));
     i25 = 10;
     break;
    }
   case 4:
    {
     f15 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i26 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, 34));
     i25 = 10;
     break;
    }
   default:
    {}
   }
   if ((i25 | 0) == 10) {
    i25 = 0;
    if (!(f15 == Math_fround(0.0))) {
     __ZN5physx2Cm12RenderOutputlsEj(i33, HEAP32[gb + 95116 + (i1 << 2) >> 2] | 0) | 0;
     i2 = HEAP32[i6 + (i20 << 3) + 4 >> 2] | 0;
     if (!i2) i4 = 0; else i4 = HEAP32[i5 + (i2 + -1 << 2) >> 2] << 1;
     i3 = HEAP32[i5 + (i2 << 2) >> 2] << 1;
     if (i4 >>> 0 < i3 >>> 0) {
      i2 = i4;
      do {
       i54 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
       i4 = HEAP32[i7 + ((i2 | 1) << 2) >> 2] | 0;
       i2 = i2 + 2 | 0;
       f49 = Math_fround(Math_fround(HEAPF32[i8 + (i54 << 4) >> 2]) * Math_fround(2.0));
       f47 = Math_fround(Math_fround(HEAPF32[i8 + (i54 << 4) + 4 >> 2]) * Math_fround(2.0));
       f44 = Math_fround(Math_fround(HEAPF32[i8 + (i54 << 4) + 8 >> 2]) * Math_fround(2.0));
       f46 = Math_fround(HEAPF32[i9 >> 2]);
       f45 = Math_fround(Math_fround(f46 * f46) + Math_fround(-.5));
       f15 = Math_fround(HEAPF32[i35 >> 2]);
       f48 = Math_fround(f49 * f15);
       f52 = Math_fround(HEAPF32[i10 >> 2]);
       f48 = Math_fround(f48 + Math_fround(f47 * f52));
       f51 = Math_fround(HEAPF32[i11 >> 2]);
       f48 = Math_fround(f48 + Math_fround(f44 * f51));
       f53 = Math_fround(Math_fround(f15 * f48) + Math_fround(Math_fround(f49 * f45) + Math_fround(f46 * Math_fround(Math_fround(f44 * f52) - Math_fround(f47 * f51)))));
       f50 = Math_fround(Math_fround(f52 * f48) + Math_fround(Math_fround(f47 * f45) + Math_fround(f46 * Math_fround(Math_fround(f49 * f51) - Math_fround(f44 * f15)))));
       f48 = Math_fround(Math_fround(Math_fround(f44 * f45) + Math_fround(f46 * Math_fround(Math_fround(f47 * f15) - Math_fround(f49 * f52)))) + Math_fround(f51 * f48));
       f53 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f53);
       f50 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f50);
       f48 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f48);
       HEAPF32[i23 >> 2] = f53;
       HEAPF32[i16 >> 2] = f50;
       HEAPF32[i17 >> 2] = f48;
       __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i33, i23) | 0;
       f48 = Math_fround(Math_fround(HEAPF32[i8 + (i4 << 4) >> 2]) * Math_fround(2.0));
       f50 = Math_fround(Math_fround(HEAPF32[i8 + (i4 << 4) + 4 >> 2]) * Math_fround(2.0));
       f53 = Math_fround(Math_fround(HEAPF32[i8 + (i4 << 4) + 8 >> 2]) * Math_fround(2.0));
       f51 = Math_fround(HEAPF32[i9 >> 2]);
       f52 = Math_fround(Math_fround(f51 * f51) + Math_fround(-.5));
       f49 = Math_fround(HEAPF32[i35 >> 2]);
       f15 = Math_fround(f48 * f49);
       f47 = Math_fround(HEAPF32[i10 >> 2]);
       f15 = Math_fround(f15 + Math_fround(f50 * f47));
       f46 = Math_fround(HEAPF32[i11 >> 2]);
       f15 = Math_fround(f15 + Math_fround(f53 * f46));
       f45 = Math_fround(Math_fround(f49 * f15) + Math_fround(Math_fround(f48 * f52) + Math_fround(f51 * Math_fround(Math_fround(f53 * f47) - Math_fround(f50 * f46)))));
       f44 = Math_fround(Math_fround(f47 * f15) + Math_fround(Math_fround(f50 * f52) + Math_fround(f51 * Math_fround(Math_fround(f48 * f46) - Math_fround(f53 * f49)))));
       f15 = Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(f51 * Math_fround(Math_fround(f50 * f49) - Math_fround(f48 * f47)))) + Math_fround(f46 * f15));
       f45 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f45);
       f44 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f44);
       f15 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f15);
       HEAPF32[i24 >> 2] = f45;
       HEAPF32[i18 >> 2] = f44;
       HEAPF32[i19 >> 2] = f15;
       __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i33, i24) | 0;
      } while (i2 >>> 0 < i3 >>> 0);
     }
     i1 = ((i1 + 1 | 0) >>> 0) % 5 | 0;
    }
   }
   i20 = i20 + 1 | 0;
   if ((i20 | 0) == (i22 | 0)) {
    i1 = i26;
    break L4;
   }
  }
 } while (0);
 if (Math_fround(+mftCall_fii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, 35)) > Math_fround(0.0)) {
  i13 = mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 356 >> 2] | 0, i29 | 0) | 0;
  if (i13 | 0) {
   __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i33, 0) | 0;
   __ZN5physx2Cm12RenderOutputlsEj(i33, -1) | 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   i14 = i36 + 8 | 0;
   HEAP32[i14 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i36, i13 << 2, i27);
   i11 = HEAP32[i36 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 360 >> 2] | 0, i29 | 0, i11 | 0);
   i10 = mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 364 >> 2] | 0, i29 | 0) | 0;
   HEAP32[i34 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   i12 = i34 + 8 | 0;
   HEAP32[i12 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i34, i10, i28);
   i10 = HEAP32[i34 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 368 >> 2] | 0, i29 | 0, i10 | 0);
   i1 = i35 + 12 | 0;
   i2 = i35 + 4 | 0;
   i3 = i35 + 8 | 0;
   i4 = i35 + 16 | 0;
   i5 = i35 + 20 | 0;
   i6 = i35 + 24 | 0;
   i7 = i32 + 4 | 0;
   i8 = i32 + 8 | 0;
   i9 = 0;
   do {
    i54 = i9 << 2;
    i26 = HEAP32[i11 + (i54 << 2) >> 2] | 0;
    i27 = HEAP32[i11 + ((i54 | 1) << 2) >> 2] | 0;
    i29 = HEAP32[i11 + ((i54 | 2) << 2) >> 2] | 0;
    i28 = HEAP32[i30 >> 2] | 0;
    f51 = Math_fround(Math_fround(HEAPF32[i28 + (i26 << 4) >> 2]) * Math_fround(2.0));
    f52 = Math_fround(Math_fround(HEAPF32[i28 + (i26 << 4) + 4 >> 2]) * Math_fround(2.0));
    f61 = Math_fround(Math_fround(HEAPF32[i28 + (i26 << 4) + 8 >> 2]) * Math_fround(2.0));
    f58 = Math_fround(HEAPF32[i1 >> 2]);
    f60 = Math_fround(Math_fround(f58 * f58) + Math_fround(-.5));
    f57 = Math_fround(HEAPF32[i35 >> 2]);
    f44 = Math_fround(f51 * f57);
    f50 = Math_fround(HEAPF32[i2 >> 2]);
    f44 = Math_fround(f44 + Math_fround(f52 * f50));
    f47 = Math_fround(HEAPF32[i3 >> 2]);
    f44 = Math_fround(f44 + Math_fround(f61 * f47));
    f46 = Math_fround(Math_fround(f57 * f44) + Math_fround(Math_fround(f51 * f60) + Math_fround(f58 * Math_fround(Math_fround(f61 * f50) - Math_fround(f52 * f47)))));
    f55 = Math_fround(Math_fround(f50 * f44) + Math_fround(Math_fround(f52 * f60) + Math_fround(f58 * Math_fround(Math_fround(f51 * f47) - Math_fround(f61 * f57)))));
    f44 = Math_fround(Math_fround(Math_fround(f61 * f60) + Math_fround(f58 * Math_fround(Math_fround(f52 * f57) - Math_fround(f51 * f50)))) + Math_fround(f47 * f44));
    f51 = Math_fround(HEAPF32[i4 >> 2]);
    f46 = Math_fround(f51 + f46);
    f52 = Math_fround(HEAPF32[i5 >> 2]);
    f55 = Math_fround(f52 + f55);
    f61 = Math_fround(HEAPF32[i6 >> 2]);
    f44 = Math_fround(f61 + f44);
    f49 = Math_fround(Math_fround(HEAPF32[i28 + (i27 << 4) >> 2]) * Math_fround(2.0));
    f56 = Math_fround(Math_fround(HEAPF32[i28 + (i27 << 4) + 4 >> 2]) * Math_fround(2.0));
    f59 = Math_fround(Math_fround(HEAPF32[i28 + (i27 << 4) + 8 >> 2]) * Math_fround(2.0));
    f45 = Math_fround(Math_fround(Math_fround(f57 * f49) + Math_fround(f50 * f56)) + Math_fround(f47 * f59));
    f48 = Math_fround(f51 + Math_fround(Math_fround(f57 * f45) + Math_fround(Math_fround(f60 * f49) + Math_fround(f58 * Math_fround(Math_fround(f50 * f59) - Math_fround(f47 * f56))))));
    f15 = Math_fround(f52 + Math_fround(Math_fround(f50 * f45) + Math_fround(Math_fround(f60 * f56) + Math_fround(f58 * Math_fround(Math_fround(f47 * f49) - Math_fround(f57 * f59))))));
    f45 = Math_fround(f61 + Math_fround(Math_fround(Math_fround(f60 * f59) + Math_fround(f58 * Math_fround(Math_fround(f57 * f56) - Math_fround(f50 * f49)))) + Math_fround(f47 * f45)));
    f49 = Math_fround(Math_fround(HEAPF32[i28 + (i29 << 4) >> 2]) * Math_fround(2.0));
    f56 = Math_fround(Math_fround(HEAPF32[i28 + (i29 << 4) + 4 >> 2]) * Math_fround(2.0));
    f59 = Math_fround(Math_fround(HEAPF32[i28 + (i29 << 4) + 8 >> 2]) * Math_fround(2.0));
    f53 = Math_fround(Math_fround(Math_fround(f57 * f49) + Math_fround(f50 * f56)) + Math_fround(f47 * f59));
    f51 = Math_fround(f51 + Math_fround(Math_fround(f57 * f53) + Math_fround(Math_fround(f60 * f49) + Math_fround(f58 * Math_fround(Math_fround(f50 * f59) - Math_fround(f47 * f56))))));
    f52 = Math_fround(f52 + Math_fround(Math_fround(f50 * f53) + Math_fround(Math_fround(f60 * f56) + Math_fround(f58 * Math_fround(Math_fround(f47 * f49) - Math_fround(f57 * f59))))));
    f53 = Math_fround(f61 + Math_fround(Math_fround(Math_fround(f60 * f59) + Math_fround(f58 * Math_fround(Math_fround(f57 * f56) - Math_fround(f50 * f49)))) + Math_fround(f47 * f53)));
    i54 = HEAP32[i11 + ((i54 | 3) << 2) >> 2] | 0;
    f47 = Math_fround(HEAPF32[i10 + (i54 * 12 | 0) >> 2]);
    f49 = Math_fround(HEAPF32[i10 + (i54 * 12 | 0) + 4 >> 2]);
    f50 = Math_fround(HEAPF32[i10 + (i54 * 12 | 0) + 8 >> 2]);
    f52 = Math_fround(Math_fround(Math_fround(f55 * f47) + Math_fround(f15 * f49)) + Math_fround(f50 * f52));
    f53 = Math_fround(Math_fround(Math_fround(f44 * f47) + Math_fround(f45 * f49)) + Math_fround(f50 * f53));
    HEAPF32[i32 >> 2] = Math_fround(Math_fround(Math_fround(f46 * f47) + Math_fround(f48 * f49)) + Math_fround(f50 * f51));
    HEAPF32[i7 >> 2] = f52;
    HEAPF32[i8 >> 2] = f53;
    __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i33, i32) | 0;
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i13 | 0));
   i54 = HEAP32[i12 >> 2] | 0;
   if ((i54 | 0) > -1 & (i54 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i34 >> 2] | 0;
    if (i1 | 0) {
     i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 12 >> 2] | 0, i54 | 0, i1 | 0);
    }
   }
   i54 = HEAP32[i14 >> 2] | 0;
   if ((i54 | 0) > -1 & (i54 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i36 >> 2] | 0;
    if (i1 | 0) {
     i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 12 >> 2] | 0, i54 | 0, i1 | 0);
    }
   }
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i37 >> 2] | 0) + 4 >> 2] | 0, i37 | 0);
 i54 = HEAP32[i31 >> 2] | 0;
 if ((i54 | 0) > -1 & (i54 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i39 >> 2] | 0;
  if (i1 | 0) {
   i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 12 >> 2] | 0, i54 | 0, i1 | 0);
  }
 }
 i54 = HEAP32[i38 >> 2] | 0;
 if ((i54 | 0) > -1 & (i54 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i40 >> 2] | 0;
  if (i1 | 0) {
   i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 12 >> 2] | 0, i54 | 0, i1 | 0);
  }
 }
 i54 = HEAP32[i41 >> 2] | 0;
 if (!((i54 | 0) > -1 & (i54 & 2147483647 | 0) != 0)) {
  STACKTOP = i43;
  return;
 }
 i1 = HEAP32[i42 >> 2] | 0;
 if (!i1) {
  STACKTOP = i43;
  return;
 }
 i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 12 >> 2] | 0, i54 | 0, i1 | 0);
 STACKTOP = i43;
 return;
}

function __ZN10PngDecoder16DecodePixelsImplEPhjb13TextureFormat(i8, i9, i11, i12, i13) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = 4;
 i21 = _malloc(40) | 0;
 HEAP32[i21 >> 2] = 0;
 i14 = i22 + 20 | 0;
 i15 = i22 + 16 | 0;
 i16 = i22 + 12 | 0;
 i17 = i22 + 8 | 0;
 i18 = i22;
 i10 = i8 + 4 | 0;
 if (HEAP8[i10 >> 0] | 0) {
  _free(i21 | 0);
  STACKTOP = i22;
  return;
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i20 = i8 + 32 | 0;
 __THREW__ = 0;
 i2 = invoke_iiii(fb + 347 | 0, HEAP32[i20 >> 2] | 0, fb + 2356 | 0, 156) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
  if (!i3) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i3 = -1;
 i1 = getTempRet0() | 0;
 if ((i3 | 0) != 1) {
  i21 = _saveSetjmp(i2, 1, i21 | 0, i19 | 0) | 0;
  i19 = getTempRet0() | 0;
  __THREW__ = 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) i1 = 0;
 }
 L7 : while (1) {
  if (i1 | 0) {
   HEAP8[i10 >> 0] = 1;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   i3 = i8 + 36 | 0;
   if (!(HEAP32[i20 >> 2] | 0)) {
    i1 = 9;
    break;
   }
   __THREW__ = 0;
   invoke_viii(fb + 498 | 0, i20 | 0, i3 | 0, 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue; else {
    i1 = 8;
    break;
   }
  }
  i7 = i8 + 36 | 0;
  __THREW__ = 0;
  invoke_iiiiiiiiii(fb + 3 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, 0, 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  i2 = (HEAP32[i16 >> 2] | 0) >>> 2;
  switch (i13 | 0) {
  case 4:
   {
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_viii(fb + 501 | 0, HEAP32[i20 >> 2] | 0, 255, 1);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue L7;
    }
    break;
   }
  case 5:
   {
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_viii(fb + 501 | 0, HEAP32[i20 >> 2] | 0, 255, 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue L7;
    }
    __THREW__ = 0;
    invoke_vi(fb + 3361 | 0, HEAP32[i20 >> 2] | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue L7;
    break;
   }
  case 14:
   {
    __THREW__ = 0;
    invoke_vi(fb + 3362 | 0, HEAP32[i20 >> 2] | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
     if (!i3) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i3 = -1;
    i1 = getTempRet0() | 0;
    if ((i3 | 0) == 1) continue L7;
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_viii(fb + 501 | 0, HEAP32[i20 >> 2] | 0, 255, 1);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue L7;
    }
    break;
   }
  default:
   {
    HEAP8[i10 >> 0] = 1;
    HEAP32[i8 + 8 >> 2] = 0;
    HEAP32[i8 + 12 >> 2] = 0;
    if (!(HEAP32[i20 >> 2] | 0)) {
     i1 = 27;
     break L7;
    }
    __THREW__ = 0;
    invoke_viii(fb + 498 | 0, i20 | 0, i7 | 0, 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue L7; else {
     i1 = 26;
     break L7;
    }
   }
  }
  __THREW__ = 0;
  invoke_vi(fb + 3363 | 0, HEAP32[i20 >> 2] | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  __THREW__ = 0;
  invoke_vi(fb + 3364 | 0, HEAP32[i20 >> 2] | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  if (!(HEAP8[i8 + 40 >> 0] | 0)) {
   __THREW__ = 0;
   invoke_viii(fb + 502 | 0, HEAP32[i20 >> 2] | 0, 4, 4);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
  }
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i1 | 0) == 3) {
   __THREW__ = 0;
   invoke_vi(fb + 3365 | 0, HEAP32[i20 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
   i1 = HEAP32[i16 >> 2] | 0;
  }
  if ((i1 & 2 | 0) == 0 & (HEAP32[i15 >> 2] | 0) < 8) {
   __THREW__ = 0;
   invoke_vi(fb + 3365 | 0, HEAP32[i20 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
  }
  __THREW__ = 0;
  i2 = invoke_iiii(fb + 348 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i7 >> 2] | 0, 16) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i3) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i3 = -1;
  i1 = getTempRet0() | 0;
  if ((i3 | 0) == 1) continue;
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_vi(fb + 3365 | 0, HEAP32[i20 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
  }
  if ((HEAP32[i16 >> 2] | 4 | 0) == 4) {
   __THREW__ = 0;
   invoke_vi(fb + 3366 | 0, HEAP32[i20 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
  }
  HEAPF64[i18 >> 3] = 0.0;
  __THREW__ = 0;
  i2 = invoke_iiii(fb + 349 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i7 >> 2] | 0, i18 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i3) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i3 = -1;
  i1 = getTempRet0() | 0;
  if ((i3 | 0) == 1) continue;
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_vidd(fb + 1 | 0, HEAP32[i20 >> 2] | 0, 2.0, +(+HEAPF64[i18 >> 3]));
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
  }
  __THREW__ = 0;
  i6 = invoke_ii(fb + 1567 | 0, HEAP32[i20 >> 2] | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  __THREW__ = 0;
  invoke_vii(fb + 2399 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i7 >> 2] | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  i4 = i8 + 12 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i3 & 1073741823 | 0)) {
   HEAP8[i10 >> 0] = 1;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   if (!(HEAP32[i20 >> 2] | 0)) {
    i1 = 56;
    break;
   }
   __THREW__ = 0;
   invoke_viii(fb + 498 | 0, i20 | 0, i7 | 0, 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue; else {
    i1 = 55;
    break;
   }
  }
  __THREW__ = 0;
  i5 = invoke_ii(fb + 1568 | 0, (i3 >>> 0 > 1073741823 ? -1 : i3 << 2) | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  i1 = (i3 | 0) != 0;
  do if (i12) {
   if (i1) i1 = 0; else break;
   do {
    HEAP32[i5 + (i1 << 2) >> 2] = i9 + (Math_imul(i3 + ~i1 | 0, i11) | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  } else {
   if (i1) i1 = 0; else break;
   do {
    HEAP32[i5 + (i1 << 2) >> 2] = i9 + (Math_imul(i1, i11) | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  } while (0);
  do if ((i6 | 0) > 0) {
   __THREW__ = 0;
   invoke_viiii(fb + 214 | 0, HEAP32[i20 >> 2] | 0, i5 | 0, 0, i3 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue L7;
   if ((i6 | 0) == 1) break; else i2 = 1;
   while (1) {
    __THREW__ = 0;
    invoke_viiii(fb + 214 | 0, HEAP32[i20 >> 2] | 0, i5 | 0, 0, HEAP32[i4 >> 2] | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
     if (!i3) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i3 = -1;
    i1 = getTempRet0() | 0;
    if ((i3 | 0) == 1) continue L7;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i6 | 0)) break;
   }
  } while (0);
  __THREW__ = 0;
  invoke_vi(fb + 3367 | 0, i5 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  __THREW__ = 0;
  i2 = invoke_ii(fb + 1569 | 0, HEAP32[i20 >> 2] | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i3) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i3 = -1;
  i1 = getTempRet0() | 0;
  if ((i3 | 0) == 1) continue;
  HEAP32[i8 + 44 >> 2] = i2;
  __THREW__ = 0;
  invoke_vii(fb + 2400 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i7 >> 2] | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i21 | 0, i19 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i1 = 71;
   break;
  }
 }
 if ((i1 | 0) == 8) i1 = 9; else if ((i1 | 0) == 26) i1 = 27; else if ((i1 | 0) == 55) i1 = 56; else if ((i1 | 0) == 71) i1 = 72;
 if ((i1 | 0) == 9) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 } else if ((i1 | 0) == 27) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 } else if ((i1 | 0) == 56) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 72;
 }
 _free(i21 | 0);
 STACKTOP = i22;
 return;
}

function __Z31DoCalculateAnimatorSkinMatricesP25CalculateSkinMatricesTask(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i22 + 8 | 0;
 i19 = i22;
 if ((HEAP16[gb + 1467028 + 6 >> 1] | 0) > -1) {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467028 | 0, i1);
  i20 = gb + 1467028 | 0;
 } else i20 = 0;
 i3 = HEAP32[i21 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 i2 = i21 + 8 | 0;
 i3 = __ZNK8Animator26GetGlobalSpaceSkeletonPoseEPPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEEiRKNS3_7_float4E(i3, i19, HEAP32[i2 >> 2] | 0, i1) | 0;
 L4 : do if (!i3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 910385 | 0, 0, gb + 910419 | 0, 76, 1, 0, 0, 0);
  i2 = i21 + 12 | 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i3 = i21 + 24 | 0;
   i1 = 0;
   do {
    __ZN10Matrix4x4f11SetIdentityEv((HEAP32[i3 >> 2] | 0) + (i1 << 6) | 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
  }
 } else {
  f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f6 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i1 + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i1 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i1 + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f6 * Math_fround(-2.0));
  f15 = Math_fround(f6 * Math_fround(2.0));
  f16 = Math_fround(f6 * f10);
  f11 = Math_fround(f7 * Math_fround(-2.0));
  f13 = Math_fround(f7 * Math_fround(2.0));
  f12 = Math_fround(f7 * f11);
  f8 = Math_fround(Math_fround(f16 + f12) + Math_fround(1.0));
  f9 = Math_fround(Math_fround(Math_fround(f24 * f15) + Math_fround(f5 * f13)) + Math_fround(0.0));
  f10 = Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(f24 * f13)) + Math_fround(0.0));
  f14 = Math_fround(f24 * Math_fround(2.0));
  f23 = Math_fround(f24 * Math_fround(-2.0));
  f24 = Math_fround(f24 * f23);
  f11 = Math_fround(Math_fround(Math_fround(f6 * f14) + Math_fround(f5 * f11)) + Math_fround(0.0));
  f12 = Math_fround(Math_fround(f24 + f12) + Math_fround(1.0));
  f13 = Math_fround(Math_fround(Math_fround(f5 * f14) + Math_fround(f6 * f13)) + Math_fround(0.0));
  f14 = Math_fround(Math_fround(Math_fround(f14 * f7) + Math_fround(f5 * f15)) + Math_fround(0.0));
  f15 = Math_fround(Math_fround(Math_fround(f5 * f23) + Math_fround(f7 * f15)) + Math_fround(0.0));
  f16 = Math_fround(Math_fround(f24 + f16) + Math_fround(1.0));
  i17 = i3 + 4 | 0;
  i18 = HEAP32[i2 >> 2] | 0;
  i17 = (HEAP32[i17 >> 2] | 0) + i17 | 0;
  f24 = Math_fround(HEAPF32[i17 + (i18 * 48 | 0) + 36 >> 2]);
  f7 = Math_fround(HEAPF32[i17 + (i18 * 48 | 0) + 40 >> 2]);
  f24 = Math_fround(-f24);
  f7 = Math_fround(-f7);
  f23 = Math_fround(-Math_fround(HEAPF32[i17 + (i18 * 48 | 0) + 44 >> 2]));
  f5 = Math_fround(Math_fround(f8 * f24) + Math_fround(Math_fround(f14 * f23) + Math_fround(f11 * f7)));
  f6 = Math_fround(Math_fround(f9 * f24) + Math_fround(Math_fround(f15 * f23) + Math_fround(f12 * f7)));
  f7 = Math_fround(Math_fround(f10 * f24) + Math_fround(Math_fround(f16 * f23) + Math_fround(f13 * f7)));
  i18 = HEAP32[i21 + 24 >> 2] | 0;
  if (HEAP8[i21 + 20 >> 0] | 0) {
   i2 = HEAP32[i21 + 12 >> 2] | 0;
   if ((i2 | 0) <= 0) break;
   i3 = HEAP32[i21 + 4 >> 2] | 0;
   i1 = 0;
   while (1) {
    i35 = HEAPU16[i3 + (i1 << 1) >> 1] | 0;
    i34 = HEAP32[i17 + (i35 * 48 | 0) + 4 >> 2] | 0;
    i33 = HEAP32[i17 + (i35 * 48 | 0) + 8 >> 2] | 0;
    i32 = HEAP32[i17 + (i35 * 48 | 0) + 12 >> 2] | 0;
    i31 = HEAP32[i17 + (i35 * 48 | 0) + 16 >> 2] | 0;
    i30 = HEAP32[i17 + (i35 * 48 | 0) + 20 >> 2] | 0;
    i29 = HEAP32[i17 + (i35 * 48 | 0) + 24 >> 2] | 0;
    i28 = HEAP32[i17 + (i35 * 48 | 0) + 28 >> 2] | 0;
    i27 = HEAP32[i17 + (i35 * 48 | 0) + 32 >> 2] | 0;
    i26 = HEAP32[i17 + (i35 * 48 | 0) + 36 >> 2] | 0;
    i25 = HEAP32[i17 + (i35 * 48 | 0) + 40 >> 2] | 0;
    i4 = HEAP32[i17 + (i35 * 48 | 0) + 44 >> 2] | 0;
    HEAP32[i18 + (i1 << 6) >> 2] = HEAP32[i17 + (i35 * 48 | 0) >> 2];
    HEAP32[i18 + (i1 << 6) + 4 >> 2] = i34;
    HEAP32[i18 + (i1 << 6) + 8 >> 2] = i33;
    HEAP32[i18 + (i1 << 6) + 12 >> 2] = 0;
    HEAP32[i18 + (i1 << 6) + 16 >> 2] = i32;
    HEAP32[i18 + (i1 << 6) + 20 >> 2] = i31;
    HEAP32[i18 + (i1 << 6) + 24 >> 2] = i30;
    HEAP32[i18 + (i1 << 6) + 28 >> 2] = 0;
    HEAP32[i18 + (i1 << 6) + 32 >> 2] = i29;
    HEAP32[i18 + (i1 << 6) + 36 >> 2] = i28;
    HEAP32[i18 + (i1 << 6) + 40 >> 2] = i27;
    HEAP32[i18 + (i1 << 6) + 44 >> 2] = 0;
    HEAP32[i18 + (i1 << 6) + 48 >> 2] = i26;
    HEAP32[i18 + (i1 << 6) + 52 >> 2] = i25;
    HEAP32[i18 + (i1 << 6) + 56 >> 2] = i4;
    HEAP32[i18 + (i1 << 6) + 60 >> 2] = 1065353216;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) break L4;
   }
  }
  i1 = HEAP32[i21 + 16 >> 2] | 0;
  if (!i1) {
   i2 = HEAP32[i21 + 12 >> 2] | 0;
   if ((i2 | 0) <= 0) break;
   i3 = HEAP32[i21 + 4 >> 2] | 0;
   i1 = 0;
   do {
    i35 = HEAPU16[i3 + (i1 << 1) >> 1] | 0;
    f46 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 36 >> 2]);
    f47 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 40 >> 2]);
    f24 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 44 >> 2]);
    f36 = Math_fround(f5 + Math_fround(Math_fround(f8 * f46) + Math_fround(Math_fround(f11 * f47) + Math_fround(f14 * f24))));
    f23 = Math_fround(f6 + Math_fround(Math_fround(f9 * f46) + Math_fround(Math_fround(f12 * f47) + Math_fround(f15 * f24))));
    f24 = Math_fround(f7 + Math_fround(Math_fround(f10 * f46) + Math_fround(Math_fround(f13 * f47) + Math_fround(f16 * f24))));
    f47 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) >> 2]);
    f46 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 4 >> 2]);
    f43 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 8 >> 2]);
    f45 = Math_fround(Math_fround(f8 * f47) + Math_fround(Math_fround(f11 * f46) + Math_fround(f14 * f43)));
    f44 = Math_fround(Math_fround(f9 * f47) + Math_fround(Math_fround(f12 * f46) + Math_fround(f15 * f43)));
    f43 = Math_fround(Math_fround(f10 * f47) + Math_fround(Math_fround(f13 * f46) + Math_fround(f16 * f43)));
    f46 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 12 >> 2]);
    f47 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 16 >> 2]);
    f40 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 20 >> 2]);
    f42 = Math_fround(Math_fround(f8 * f46) + Math_fround(Math_fround(f11 * f47) + Math_fround(f14 * f40)));
    f41 = Math_fround(Math_fround(f9 * f46) + Math_fround(Math_fround(f12 * f47) + Math_fround(f15 * f40)));
    f40 = Math_fround(Math_fround(f10 * f46) + Math_fround(Math_fround(f13 * f47) + Math_fround(f16 * f40)));
    f47 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 24 >> 2]);
    f46 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 28 >> 2]);
    f37 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 32 >> 2]);
    f39 = Math_fround(Math_fround(f8 * f47) + Math_fround(Math_fround(f11 * f46) + Math_fround(f14 * f37)));
    f38 = Math_fround(Math_fround(f9 * f47) + Math_fround(Math_fround(f12 * f46) + Math_fround(f15 * f37)));
    f37 = Math_fround(Math_fround(f10 * f47) + Math_fround(Math_fround(f13 * f46) + Math_fround(f16 * f37)));
    HEAPF32[i18 + (i1 << 6) >> 2] = f45;
    HEAPF32[i18 + (i1 << 6) + 4 >> 2] = f44;
    HEAPF32[i18 + (i1 << 6) + 8 >> 2] = f43;
    HEAP32[i18 + (i1 << 6) + 12 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 16 >> 2] = f42;
    HEAPF32[i18 + (i1 << 6) + 20 >> 2] = f41;
    HEAPF32[i18 + (i1 << 6) + 24 >> 2] = f40;
    HEAP32[i18 + (i1 << 6) + 28 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 32 >> 2] = f39;
    HEAPF32[i18 + (i1 << 6) + 36 >> 2] = f38;
    HEAPF32[i18 + (i1 << 6) + 40 >> 2] = f37;
    HEAP32[i18 + (i1 << 6) + 44 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 48 >> 2] = f36;
    HEAPF32[i18 + (i1 << 6) + 52 >> 2] = f23;
    HEAPF32[i18 + (i1 << 6) + 56 >> 2] = f24;
    HEAP32[i18 + (i1 << 6) + 60 >> 2] = 1065353216;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
  } else {
   i2 = HEAP32[i1 + 144 >> 2] | 0;
   i3 = HEAP32[i21 + 12 >> 2] | 0;
   if ((i3 | 0) <= 0) break;
   i4 = HEAP32[i21 + 4 >> 2] | 0;
   i1 = 0;
   do {
    i35 = HEAPU16[i4 + (i1 << 1) >> 1] | 0;
    f38 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 36 >> 2]);
    f37 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 40 >> 2]);
    f39 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 44 >> 2]);
    f45 = Math_fround(f5 + Math_fround(Math_fround(f8 * f38) + Math_fround(Math_fround(f11 * f37) + Math_fround(f14 * f39))));
    f46 = Math_fround(f6 + Math_fround(Math_fround(f9 * f38) + Math_fround(Math_fround(f12 * f37) + Math_fround(f15 * f39))));
    f39 = Math_fround(f7 + Math_fround(Math_fround(f10 * f38) + Math_fround(Math_fround(f13 * f37) + Math_fround(f16 * f39))));
    f37 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) >> 2]);
    f38 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 4 >> 2]);
    f55 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 8 >> 2]);
    f50 = Math_fround(Math_fround(f8 * f37) + Math_fround(Math_fround(f11 * f38) + Math_fround(f14 * f55)));
    f57 = Math_fround(Math_fround(f9 * f37) + Math_fround(Math_fround(f12 * f38) + Math_fround(f15 * f55)));
    f55 = Math_fround(Math_fround(f10 * f37) + Math_fround(Math_fround(f13 * f38) + Math_fround(f16 * f55)));
    f38 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 12 >> 2]);
    f37 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 16 >> 2]);
    f53 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 20 >> 2]);
    f48 = Math_fround(Math_fround(f8 * f38) + Math_fround(Math_fround(f11 * f37) + Math_fround(f14 * f53)));
    f56 = Math_fround(Math_fround(f9 * f38) + Math_fround(Math_fround(f12 * f37) + Math_fround(f15 * f53)));
    f53 = Math_fround(Math_fround(f10 * f38) + Math_fround(Math_fround(f13 * f37) + Math_fround(f16 * f53)));
    f37 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 24 >> 2]);
    f38 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 28 >> 2]);
    f51 = Math_fround(HEAPF32[i17 + (i35 * 48 | 0) + 32 >> 2]);
    f24 = Math_fround(Math_fround(f8 * f37) + Math_fround(Math_fround(f11 * f38) + Math_fround(f14 * f51)));
    f43 = Math_fround(Math_fround(f9 * f37) + Math_fround(Math_fround(f12 * f38) + Math_fround(f15 * f51)));
    f51 = Math_fround(Math_fround(f10 * f37) + Math_fround(Math_fround(f13 * f38) + Math_fround(f16 * f51)));
    f38 = Math_fround(HEAPF32[i2 + (i1 << 6) + 48 >> 2]);
    f37 = Math_fround(HEAPF32[i2 + (i1 << 6) + 52 >> 2]);
    f47 = Math_fround(HEAPF32[i2 + (i1 << 6) + 56 >> 2]);
    f49 = Math_fround(HEAPF32[i2 + (i1 << 6) >> 2]);
    f23 = Math_fround(HEAPF32[i2 + (i1 << 6) + 4 >> 2]);
    f36 = Math_fround(HEAPF32[i2 + (i1 << 6) + 8 >> 2]);
    f58 = Math_fround(HEAPF32[i2 + (i1 << 6) + 16 >> 2]);
    f42 = Math_fround(HEAPF32[i2 + (i1 << 6) + 20 >> 2]);
    f41 = Math_fround(HEAPF32[i2 + (i1 << 6) + 24 >> 2]);
    f54 = Math_fround(HEAPF32[i2 + (i1 << 6) + 32 >> 2]);
    f52 = Math_fround(HEAPF32[i2 + (i1 << 6) + 36 >> 2]);
    f44 = Math_fround(HEAPF32[i2 + (i1 << 6) + 40 >> 2]);
    f45 = Math_fround(f45 + Math_fround(Math_fround(f50 * f38) + Math_fround(Math_fround(f48 * f37) + Math_fround(f47 * f24))));
    f46 = Math_fround(f46 + Math_fround(Math_fround(f57 * f38) + Math_fround(Math_fround(f56 * f37) + Math_fround(f47 * f43))));
    f47 = Math_fround(f39 + Math_fround(Math_fround(f55 * f38) + Math_fround(Math_fround(f53 * f37) + Math_fround(f47 * f51))));
    f37 = Math_fround(Math_fround(f57 * f49) + Math_fround(Math_fround(f56 * f23) + Math_fround(f43 * f36)));
    f38 = Math_fround(Math_fround(f55 * f49) + Math_fround(Math_fround(f53 * f23) + Math_fround(f51 * f36)));
    f39 = Math_fround(Math_fround(f50 * f58) + Math_fround(Math_fround(f48 * f42) + Math_fround(f24 * f41)));
    f40 = Math_fround(Math_fround(f57 * f58) + Math_fround(Math_fround(f56 * f42) + Math_fround(f43 * f41)));
    f41 = Math_fround(Math_fround(f55 * f58) + Math_fround(Math_fround(f53 * f42) + Math_fround(f51 * f41)));
    f42 = Math_fround(Math_fround(f50 * f54) + Math_fround(Math_fround(f48 * f52) + Math_fround(f24 * f44)));
    f43 = Math_fround(Math_fround(f57 * f54) + Math_fround(Math_fround(f56 * f52) + Math_fround(f43 * f44)));
    f44 = Math_fround(Math_fround(f55 * f54) + Math_fround(Math_fround(f53 * f52) + Math_fround(f51 * f44)));
    HEAPF32[i18 + (i1 << 6) >> 2] = Math_fround(Math_fround(f50 * f49) + Math_fround(Math_fround(f48 * f23) + Math_fround(f24 * f36)));
    HEAPF32[i18 + (i1 << 6) + 4 >> 2] = f37;
    HEAPF32[i18 + (i1 << 6) + 8 >> 2] = f38;
    HEAP32[i18 + (i1 << 6) + 12 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 16 >> 2] = f39;
    HEAPF32[i18 + (i1 << 6) + 20 >> 2] = f40;
    HEAPF32[i18 + (i1 << 6) + 24 >> 2] = f41;
    HEAP32[i18 + (i1 << 6) + 28 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 32 >> 2] = f42;
    HEAPF32[i18 + (i1 << 6) + 36 >> 2] = f43;
    HEAPF32[i18 + (i1 << 6) + 40 >> 2] = f44;
    HEAP32[i18 + (i1 << 6) + 44 >> 2] = 0;
    HEAPF32[i18 + (i1 << 6) + 48 >> 2] = f45;
    HEAPF32[i18 + (i1 << 6) + 52 >> 2] = f46;
    HEAPF32[i18 + (i1 << 6) + 56 >> 2] = f47;
    HEAP32[i18 + (i1 << 6) + 60 >> 2] = 1065353216;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
 } while (0);
 __ZN8Animator27FreeGlobalSpaceSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEE(HEAP32[i19 >> 2] | 0);
 i1 = HEAP32[i21 + 16 >> 2] | 0;
 if (i1 | 0) {
  i35 = i1 + 4 | 0;
  HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + -1;
  if (!(HEAP32[i35 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i21, gb + 64024 | 0);
 if (!i20) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i20);
 STACKTOP = i22;
 return;
}

function __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i8, i9, i7, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0;
 i10 = i8 + 8 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 i11 = i8 + 4 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 do switch (i1 | 0) {
 case 0:
  {
   i7 = i7 + 4 | 0;
   i2 = HEAP32[i9 + 76 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i3 = HEAP32[i9 + 80 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 8 >> 2]);
   f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]));
   f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]));
   f6 = Math_fround(f6 + Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]));
   i9 = HEAP32[i9 + 100 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i7 + (i9 * 40 | 0) >> 2]);
   f5 = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i7 + (i9 * 40 | 0) + 4 >> 2])) * Math_fround(.333333343));
   f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i7 + (i9 * 40 | 0) + 8 >> 2])) * Math_fround(.333333343));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f12 + f4) * Math_fround(.333333343));
   HEAPF32[i11 >> 2] = f5;
   HEAPF32[i10 >> 2] = f6;
   return;
  }
 case 7:
  {
   i2 = HEAP32[i9 + 104 >> 2] | 0;
   i1 = i7 + 4 | 0;
   i7 = HEAP32[i9 + 100 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   f4 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 8 >> 2]);
   if ((i2 | 0) > -1) {
    f13 = Math_fround(HEAPF32[i1 + (i2 * 40 | 0) >> 2]);
    f12 = Math_fround(HEAPF32[i1 + (i2 * 40 | 0) + 4 >> 2]);
    f5 = Math_fround(Math_fround(f5 + f12) * Math_fround(.5));
    f12 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i1 + (i2 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
    HEAPF32[i8 >> 2] = Math_fround(Math_fround(f4 + f13) * Math_fround(.5));
    HEAPF32[i11 >> 2] = f5;
    HEAPF32[i10 >> 2] = f12;
    return;
   } else {
    f4 = Math_fround(f4 * Math_fround(.100000001));
    f16 = Math_fround(f5 * Math_fround(.100000001));
    f14 = Math_fround(f6 * Math_fround(.100000001));
    i7 = HEAP32[i9 + 124 >> 2] | 0;
    i9 = HEAP32[i9 + 128 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) >> 2]);
    f15 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 4 >> 2]);
    f13 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 8 >> 2]);
    f6 = Math_fround(HEAPF32[i1 + (i9 * 40 | 0) >> 2]);
    f12 = Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 4 >> 2]);
    f12 = Math_fround(f16 + Math_fround(Math_fround(f15 + f12) * Math_fround(.449999988)));
    f13 = Math_fround(f14 + Math_fround(Math_fround(f13 + Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 8 >> 2])) * Math_fround(.449999988)));
    HEAPF32[i8 >> 2] = Math_fround(f4 + Math_fround(Math_fround(f5 + f6) * Math_fround(.449999988)));
    HEAPF32[i11 >> 2] = f12;
    HEAPF32[i10 >> 2] = f13;
    return;
   }
  }
 case 8:
  {
   i1 = HEAP32[i9 + 108 >> 2] | 0;
   if ((i1 | 0) > -1) {
    i2 = HEAP32[i9 + 116 >> 2] | 0;
    if ((i2 | 0) > -1) {
     i3 = HEAP32[i9 + 120 >> 2] | 0;
     if ((i3 | 0) > -1) {
      i17 = i7 + 4 | 0;
      i7 = HEAP32[i9 + 104 >> 2] | 0;
      i9 = (HEAP32[i17 >> 2] | 0) + i17 | 0;
      f12 = Math_fround(HEAPF32[i9 + (i7 * 40 | 0) >> 2]);
      f13 = Math_fround(HEAPF32[i9 + (i7 * 40 | 0) + 4 >> 2]);
      f16 = Math_fround(HEAPF32[i9 + (i7 * 40 | 0) + 8 >> 2]);
      f15 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) >> 2]);
      f14 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 4 >> 2]);
      f15 = Math_fround(f12 + f15);
      f14 = Math_fround(f13 + f14);
      f16 = Math_fround(f16 + Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 8 >> 2]));
      f13 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) >> 2]);
      f12 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 4 >> 2]);
      f13 = Math_fround(f15 + f13);
      f12 = Math_fround(f14 + f12);
      f16 = Math_fround(f16 + Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 8 >> 2]));
      f14 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) >> 2]);
      f15 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 4 >> 2]);
      f15 = Math_fround(Math_fround(f12 + f15) * Math_fround(.25));
      f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 8 >> 2])) * Math_fround(.25));
      HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.25));
      HEAPF32[i11 >> 2] = f15;
      HEAPF32[i10 >> 2] = f16;
      return;
     }
    }
   }
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 104 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 124 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f13 = Math_fround(f13 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]));
   f15 = Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2]));
   f16 = Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2]));
   i17 = HEAP32[i9 + 128 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.333333343));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.333333343));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.333333343));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 9:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 108 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 112 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 1:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 76 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 84 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 3:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 84 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 92 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 11:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 116 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 124 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 13:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 124 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 132 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 15:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 124 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 140 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 2:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 80 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 88 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 4:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 88 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 96 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 12:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 120 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 128 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 14:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 128 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 136 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 case 16:
  {
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i9 + 136 >> 2] | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i17 = HEAP32[i9 + 144 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + (i17 * 40 | 0) >> 2]);
   f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 4 >> 2])) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i7 + (i17 * 40 | 0) + 8 >> 2])) * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
   HEAPF32[i11 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   return;
  }
 default:
  {
   i3 = i7 + 4 | 0;
   i7 = HEAP32[i9 + 72 + (i1 << 2) >> 2] | 0;
   i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
   i9 = HEAP32[i3 + (i7 * 40 | 0) + 4 >> 2] | 0;
   i17 = HEAP32[i3 + (i7 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i3 + (i7 * 40 | 0) >> 2];
   HEAP32[i11 >> 2] = i9;
   HEAP32[i10 >> 2] = i17;
   return;
  }
 } while (0);
}

function __ZN5physx2Gu5Debug9visualizeERKNS_21PxHeightFieldGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i20, i53, i22, i10, i8, i1, f2, i3) {
 i20 = i20 | 0;
 i53 = i53 | 0;
 i22 = i22 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i55 + 188 | 0;
 i3 = i55 + 96 | 0;
 i7 = i55 + 160 | 0;
 i5 = i55 + 80 | 0;
 i4 = i55 + 64 | 0;
 i19 = i55 + 36 | 0;
 i1 = i55 + 228 | 0;
 i6 = i55 + 227 | 0;
 i18 = i55;
 i17 = i55 + 226 | 0;
 i52 = i55 + 224 | 0;
 i54 = HEAP32[i20 + 4 >> 2] | 0;
 if ((i8 & 8192 | 0) == 0 & 0 == 0) {
  STACKTOP = i55;
  return;
 }
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i11 = i3 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAPF32[i3 + 20 >> 2] = Math_fround(1.0);
 i11 = i3 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAPF32[i3 + 40 >> 2] = Math_fround(1.0);
 i11 = i3 + 44 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 i11 = i20 + 8 | 0;
 i9 = i20 + 12 | 0;
 i12 = i20 + 16 | 0;
 i49 = i54 + 16 | 0;
 i50 = i54 + 20 | 0;
 i23 = Math_imul(HEAP32[i50 >> 2] | 0, HEAP32[i49 >> 2] | 0) | 0;
 i21 = i23 << 1;
 __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i53, i3) | 0, -256) | 0;
 if ((i8 & 1073741824 | 0) == 0 & 0 == 0) {
  i48 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i55 + 225 | 0, i23 * 12 | 0, gb + 689385 | 0, 328) | 0;
  if (i23 | 0) {
   i14 = HEAP32[i50 >> 2] | 0;
   i17 = HEAP32[i54 + 36 >> 2] | 0;
   f16 = Math_fround(HEAPF32[i9 >> 2]);
   f15 = Math_fround(HEAPF32[i11 >> 2]);
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   i1 = i22 + 4 | 0;
   i3 = i22 + 8 | 0;
   i4 = i22 + 12 | 0;
   i5 = i22 + 16 | 0;
   i6 = i22 + 20 | 0;
   i7 = i22 + 24 | 0;
   i8 = i22 + 28 | 0;
   i9 = i22 + 32 | 0;
   i10 = i22 + 36 | 0;
   i11 = i22 + 40 | 0;
   i12 = i22 + 44 | 0;
   i13 = 0;
   do {
    f58 = Math_fround(((i13 >>> 0) / (i14 >>> 0) | 0) >>> 0);
    f58 = Math_fround(f58 * f16);
    f59 = Math_fround(Math_fround(HEAP16[i17 + (i13 << 2) >> 1] | 0) * f15);
    f56 = Math_fround(Math_fround(((i13 >>> 0) % (i14 >>> 0) | 0) >>> 0) * f2);
    f62 = Math_fround(f58 * Math_fround(HEAPF32[i22 >> 2]));
    f57 = Math_fround(f58 * Math_fround(HEAPF32[i1 >> 2]));
    f58 = Math_fround(f58 * Math_fround(HEAPF32[i3 >> 2]));
    f61 = Math_fround(f59 * Math_fround(HEAPF32[i4 >> 2]));
    f60 = Math_fround(f59 * Math_fround(HEAPF32[i5 >> 2]));
    f61 = Math_fround(f62 + f61);
    f60 = Math_fround(f57 + f60);
    f59 = Math_fround(f58 + Math_fround(f59 * Math_fround(HEAPF32[i6 >> 2])));
    f58 = Math_fround(f56 * Math_fround(HEAPF32[i7 >> 2]));
    f57 = Math_fround(f56 * Math_fround(HEAPF32[i8 >> 2]));
    f58 = Math_fround(f61 + f58);
    f57 = Math_fround(f60 + f57);
    f56 = Math_fround(f59 + Math_fround(f56 * Math_fround(HEAPF32[i9 >> 2])));
    f58 = Math_fround(f58 + Math_fround(HEAPF32[i10 >> 2]));
    f57 = Math_fround(f57 + Math_fround(HEAPF32[i11 >> 2]));
    f56 = Math_fround(f56 + Math_fround(HEAPF32[i12 >> 2]));
    HEAPF32[i48 + (i13 * 12 | 0) >> 2] = f58;
    HEAPF32[i48 + (i13 * 12 | 0) + 4 >> 2] = f57;
    HEAPF32[i48 + (i13 * 12 | 0) + 8 >> 2] = f56;
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) != (i23 | 0));
  }
  if (i21 | 0) {
   i24 = i54 + 36 | 0;
   i25 = i53 + 100 | 0;
   i26 = i53 + 4 | 0;
   i27 = i51 + 4 | 0;
   i28 = i51 + 8 | 0;
   i29 = i51 + 12 | 0;
   i30 = i51 + 16 | 0;
   i31 = i51 + 20 | 0;
   i32 = i51 + 24 | 0;
   i33 = i51 + 28 | 0;
   i34 = i51 + 4 | 0;
   i35 = i51 + 8 | 0;
   i36 = i51 + 12 | 0;
   i37 = i51 + 16 | 0;
   i38 = i51 + 20 | 0;
   i39 = i51 + 24 | 0;
   i40 = i51 + 28 | 0;
   i41 = i51 + 4 | 0;
   i42 = i51 + 8 | 0;
   i43 = i51 + 12 | 0;
   i44 = i51 + 16 | 0;
   i45 = i51 + 20 | 0;
   i46 = i51 + 24 | 0;
   i47 = i51 + 28 | 0;
   i22 = i23 << 1;
   i23 = 0;
   do {
    i4 = i23 >>> 1;
    i5 = HEAP32[i50 >> 2] | 0;
    if (((i4 >>> 0) / (i5 >>> 0) | 0) >>> 0 < ((HEAP32[i49 >> 2] | 0) + -1 | 0) >>> 0) if (((i4 >>> 0) % (i5 >>> 0) | 0) >>> 0 < (i5 + -1 | 0) >>> 0) {
     i3 = (i23 & 1 | 0) == 0;
     i21 = HEAP32[i24 >> 2] | 0;
     i1 = i21 + (i4 << 2) + 2 | 0;
     if ((HEAP8[(i3 ? i1 : i21 + (i4 << 2) + 3 | 0) >> 0] & 127) != 127) {
      do if ((HEAP8[i1 >> 0] | 0) < 0) if (i3) {
       i3 = i5 + i4 | 0;
       i6 = i4;
       i1 = i4 + 1 + i5 | 0;
       break;
      } else {
       i6 = i4 + 1 | 0;
       i3 = i6;
       i6 = i5 + i6 | 0;
       i1 = i4;
       break;
      } else {
       i1 = i4 + 1 | 0;
       if (i3) {
        i3 = i4;
        i6 = i1;
        i1 = i5 + i4 | 0;
        break;
       } else {
        i3 = i5 + i1 | 0;
        i6 = i5 + i4 | 0;
        break;
       }
      } while (0);
      i19 = (((mftCall_iii(HEAP32[(HEAP32[i54 >> 2] | 0) + 68 >> 2] | 0, i54 | 0, i23 | 0) | 0) & 65535) % 48 | 0) & 65535;
      __ZN5physx2Cm12RenderOutputlsEj(i53, HEAP32[gb + 94052 + (i19 << 2) >> 2] | 0) | 0;
      i19 = i48 + (i3 * 12 | 0) | 0;
      i14 = i48 + (i6 * 12 | 0) | 0;
      i18 = i48 + (i1 * 12 | 0) | 0;
      i63 = HEAP32[i25 >> 2] | 0;
      i11 = i63 + 16 | 0;
      i12 = HEAP32[i19 >> 2] | 0;
      HEAP32[i51 >> 2] = i12;
      i20 = i48 + (i3 * 12 | 0) + 4 | 0;
      i13 = HEAP32[i20 >> 2] | 0;
      HEAP32[i27 >> 2] = i13;
      i21 = i48 + (i3 * 12 | 0) + 8 | 0;
      i7 = HEAP32[i21 >> 2] | 0;
      HEAP32[i28 >> 2] = i7;
      i8 = HEAP32[i26 >> 2] | 0;
      HEAP32[i29 >> 2] = i8;
      i9 = HEAP32[i14 >> 2] | 0;
      HEAP32[i30 >> 2] = i9;
      i17 = i48 + (i6 * 12 | 0) + 4 | 0;
      i10 = HEAP32[i17 >> 2] | 0;
      HEAP32[i31 >> 2] = i10;
      i6 = i48 + (i6 * 12 | 0) + 8 | 0;
      i3 = HEAP32[i6 >> 2] | 0;
      HEAP32[i32 >> 2] = i3;
      HEAP32[i33 >> 2] = i8;
      i4 = i63 + 20 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if ((HEAP32[i63 + 24 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
       i63 = HEAP32[i11 >> 2] | 0;
       HEAP32[i63 + (i5 << 5) >> 2] = i12;
       HEAP32[i63 + (i5 << 5) + 4 >> 2] = i13;
       HEAP32[i63 + (i5 << 5) + 8 >> 2] = i7;
       HEAP32[i63 + (i5 << 5) + 12 >> 2] = i8;
       HEAP32[i63 + (i5 << 5) + 16 >> 2] = i9;
       HEAP32[i63 + (i5 << 5) + 20 >> 2] = i10;
       HEAP32[i63 + (i5 << 5) + 24 >> 2] = i3;
       HEAP32[i63 + (i5 << 5) + 28 >> 2] = i8;
       HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11, i51) | 0;
      i63 = HEAP32[i25 >> 2] | 0;
      i11 = i63 + 16 | 0;
      i10 = HEAP32[i14 >> 2] | 0;
      HEAP32[i51 >> 2] = i10;
      i9 = HEAP32[i17 >> 2] | 0;
      HEAP32[i34 >> 2] = i9;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i35 >> 2] = i5;
      i6 = HEAP32[i26 >> 2] | 0;
      HEAP32[i36 >> 2] = i6;
      i7 = HEAP32[i18 >> 2] | 0;
      HEAP32[i37 >> 2] = i7;
      i12 = i48 + (i1 * 12 | 0) + 4 | 0;
      i8 = HEAP32[i12 >> 2] | 0;
      HEAP32[i38 >> 2] = i8;
      i13 = i48 + (i1 * 12 | 0) + 8 | 0;
      i1 = HEAP32[i13 >> 2] | 0;
      HEAP32[i39 >> 2] = i1;
      HEAP32[i40 >> 2] = i6;
      i3 = i63 + 20 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((HEAP32[i63 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       i63 = HEAP32[i11 >> 2] | 0;
       HEAP32[i63 + (i4 << 5) >> 2] = i10;
       HEAP32[i63 + (i4 << 5) + 4 >> 2] = i9;
       HEAP32[i63 + (i4 << 5) + 8 >> 2] = i5;
       HEAP32[i63 + (i4 << 5) + 12 >> 2] = i6;
       HEAP32[i63 + (i4 << 5) + 16 >> 2] = i7;
       HEAP32[i63 + (i4 << 5) + 20 >> 2] = i8;
       HEAP32[i63 + (i4 << 5) + 24 >> 2] = i1;
       HEAP32[i63 + (i4 << 5) + 28 >> 2] = i6;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11, i51) | 0;
      i63 = HEAP32[i25 >> 2] | 0;
      i11 = i63 + 16 | 0;
      i10 = HEAP32[i18 >> 2] | 0;
      HEAP32[i51 >> 2] = i10;
      i9 = HEAP32[i12 >> 2] | 0;
      HEAP32[i41 >> 2] = i9;
      i7 = HEAP32[i13 >> 2] | 0;
      HEAP32[i42 >> 2] = i7;
      i8 = HEAP32[i26 >> 2] | 0;
      HEAP32[i43 >> 2] = i8;
      i6 = HEAP32[i19 >> 2] | 0;
      HEAP32[i44 >> 2] = i6;
      i5 = HEAP32[i20 >> 2] | 0;
      HEAP32[i45 >> 2] = i5;
      i1 = HEAP32[i21 >> 2] | 0;
      HEAP32[i46 >> 2] = i1;
      HEAP32[i47 >> 2] = i8;
      i3 = i63 + 20 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((HEAP32[i63 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       i63 = HEAP32[i11 >> 2] | 0;
       HEAP32[i63 + (i4 << 5) >> 2] = i10;
       HEAP32[i63 + (i4 << 5) + 4 >> 2] = i9;
       HEAP32[i63 + (i4 << 5) + 8 >> 2] = i7;
       HEAP32[i63 + (i4 << 5) + 12 >> 2] = i8;
       HEAP32[i63 + (i4 << 5) + 16 >> 2] = i6;
       HEAP32[i63 + (i4 << 5) + 20 >> 2] = i5;
       HEAP32[i63 + (i4 << 5) + 24 >> 2] = i1;
       HEAP32[i63 + (i4 << 5) + 28 >> 2] = i8;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11, i51) | 0;
     }
    }
    i23 = i23 + 1 | 0;
   } while ((i23 | 0) != (i22 | 0));
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i52, i48);
 } else {
  f15 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f60 = Math_fround(HEAPF32[i10 >> 2]);
  f57 = Math_fround(f15 + f60);
  f16 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f61 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f58 = Math_fround(f16 + f61);
  f56 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  f62 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f57 = Math_fround(f57 * Math_fround(.5));
  f58 = Math_fround(f58 * Math_fround(.5));
  f59 = Math_fround(Math_fround(f56 + f62) * Math_fround(.5));
  f60 = Math_fround(Math_fround(f15 - f60) * Math_fround(.5));
  f61 = Math_fround(Math_fround(f16 - f61) * Math_fround(.5));
  f62 = Math_fround(Math_fround(f56 - f62) * Math_fround(.5));
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 16 >> 2] = f57;
  HEAPF32[i7 + 20 >> 2] = f58;
  HEAPF32[i7 + 24 >> 2] = f59;
  HEAP32[i5 >> 2] = 3;
  HEAPF32[i5 + 4 >> 2] = f60;
  HEAPF32[i5 + 8 >> 2] = f61;
  HEAPF32[i5 + 12 >> 2] = f62;
  HEAP32[i51 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  HEAP32[i51 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
  HEAP32[i51 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
  HEAP32[i51 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
  HEAP32[i51 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
  HEAP32[i51 + 32 >> 2] = HEAP32[i22 + 32 >> 2];
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i4, i51);
  HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i22 + 36 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i22 + 40 >> 2];
  HEAP32[i19 + 24 >> 2] = HEAP32[i22 + 44 >> 2];
  i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i23 << 3, gb + 689385 | 0, 297) | 0;
  HEAP8[i6 >> 0] = 0;
  i13 = __ZN5physx11PxMeshQuery22findOverlapHeightFieldERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_PjjjRb(i5, i7, i20, i19, i14, i21, 0, i6) | 0;
  i1 = i53 + 100 | 0;
  i63 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i63 + 20 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i63 + 16 | 0, i3 + (i13 * 3 | 0) | 0);
  if (i13 | 0) {
   i4 = i18 + 12 | 0;
   i5 = i18 + 4 | 0;
   i6 = i18 + 8 | 0;
   i7 = i18 + 16 | 0;
   i8 = i18 + 20 | 0;
   i9 = i18 + 24 | 0;
   i10 = i18 + 28 | 0;
   i11 = i18 + 32 | 0;
   i12 = 0;
   i1 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0) + (i3 << 5) | 0;
   while (1) {
    i63 = HEAP32[i14 + (i12 << 2) >> 2] | 0;
    __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i20, i19, i63, i18, 0, 0);
    i63 = (((mftCall_iii(HEAP32[(HEAP32[i54 >> 2] | 0) + 68 >> 2] | 0, i54 | 0, i63 | 0) | 0) & 65535) % 48 | 0) & 65535;
    i63 = HEAP32[gb + 94052 + (i63 << 2) >> 2] | 0;
    i49 = HEAP32[i5 >> 2] | 0;
    i50 = HEAP32[i6 >> 2] | 0;
    i51 = HEAP32[i4 >> 2] | 0;
    i52 = HEAP32[i7 >> 2] | 0;
    i53 = HEAP32[i8 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i1 + 4 >> 2] = i49;
    HEAP32[i1 + 8 >> 2] = i50;
    HEAP32[i1 + 12 >> 2] = i63;
    HEAP32[i1 + 16 >> 2] = i51;
    HEAP32[i1 + 20 >> 2] = i52;
    HEAP32[i1 + 24 >> 2] = i53;
    HEAP32[i1 + 28 >> 2] = i63;
    i53 = HEAP32[i7 >> 2] | 0;
    i52 = HEAP32[i8 >> 2] | 0;
    i51 = HEAP32[i9 >> 2] | 0;
    i50 = HEAP32[i10 >> 2] | 0;
    i49 = HEAP32[i11 >> 2] | 0;
    HEAP32[i1 + 32 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 36 >> 2] = i53;
    HEAP32[i1 + 40 >> 2] = i52;
    HEAP32[i1 + 44 >> 2] = i63;
    HEAP32[i1 + 48 >> 2] = i51;
    HEAP32[i1 + 52 >> 2] = i50;
    HEAP32[i1 + 56 >> 2] = i49;
    HEAP32[i1 + 60 >> 2] = i63;
    i49 = HEAP32[i10 >> 2] | 0;
    i50 = HEAP32[i11 >> 2] | 0;
    i51 = HEAP32[i18 >> 2] | 0;
    i52 = HEAP32[i5 >> 2] | 0;
    i53 = HEAP32[i6 >> 2] | 0;
    HEAP32[i1 + 64 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i1 + 68 >> 2] = i49;
    HEAP32[i1 + 72 >> 2] = i50;
    HEAP32[i1 + 76 >> 2] = i63;
    HEAP32[i1 + 80 >> 2] = i51;
    HEAP32[i1 + 84 >> 2] = i52;
    HEAP32[i1 + 88 >> 2] = i53;
    HEAP32[i1 + 92 >> 2] = i63;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == (i13 | 0)) break; else i1 = i1 + 96 | 0;
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i14);
 }
 STACKTOP = i55;
 return;
}

function __GLOBAL__sub_I_runtime_baseclasses2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1104736 >> 2] = gb + 371248;
 HEAP32[gb + 1104736 + 12 >> 2] = gb + 32548;
 HEAP32[gb + 1104736 + 4 >> 2] = 0;
 HEAP32[gb + 1104736 + 8 >> 2] = -1;
 HEAP32[gb + 1104736 + 16 >> 2] = 1;
 HEAP32[gb + 1104756 >> 2] = gb + 371263;
 HEAP32[gb + 1104756 + 12 >> 2] = gb + 32548;
 HEAP32[gb + 1104756 + 4 >> 2] = 0;
 HEAP32[gb + 1104756 + 8 >> 2] = -1;
 HEAP32[gb + 1104756 + 16 >> 2] = 1;
 HEAP32[gb + 1104776 >> 2] = gb + 371277;
 HEAP32[gb + 1104776 + 12 >> 2] = gb + 32548;
 HEAP32[gb + 1104776 + 4 >> 2] = 0;
 HEAP32[gb + 1104776 + 8 >> 2] = -1;
 HEAP32[gb + 1104776 + 16 >> 2] = 1;
 HEAP32[gb + 1104796 >> 2] = gb + 371291;
 HEAP32[gb + 1104796 + 12 >> 2] = gb + 29512;
 HEAP32[gb + 1104796 + 4 >> 2] = 0;
 HEAP32[gb + 1104796 + 8 >> 2] = -1;
 HEAP32[gb + 1104796 + 16 >> 2] = 1;
 HEAP32[gb + 1104816 >> 2] = gb + 371308;
 HEAP32[gb + 1104816 + 12 >> 2] = gb + 29512;
 HEAP32[gb + 1104816 + 4 >> 2] = 0;
 HEAP32[gb + 1104816 + 8 >> 2] = -1;
 HEAP32[gb + 1104816 + 16 >> 2] = 1;
 HEAP32[gb + 1104836 >> 2] = gb + 371324;
 HEAP32[gb + 1104836 + 12 >> 2] = gb + 29512;
 HEAP32[gb + 1104836 + 4 >> 2] = 0;
 HEAP32[gb + 1104836 + 8 >> 2] = -1;
 HEAP32[gb + 1104836 + 16 >> 2] = 1;
 HEAP32[gb + 1104856 >> 2] = gb + 371340;
 HEAP32[gb + 1104856 + 12 >> 2] = gb + 29552;
 HEAP32[gb + 1104856 + 4 >> 2] = 0;
 HEAP32[gb + 1104856 + 8 >> 2] = -1;
 HEAP32[gb + 1104856 + 16 >> 2] = 1;
 HEAP32[gb + 1104876 >> 2] = gb + 371359;
 HEAP32[gb + 1104876 + 12 >> 2] = gb + 29552;
 HEAP32[gb + 1104876 + 4 >> 2] = 0;
 HEAP32[gb + 1104876 + 8 >> 2] = -1;
 HEAP32[gb + 1104876 + 16 >> 2] = 1;
 HEAP32[gb + 1104896 >> 2] = gb + 371377;
 HEAP32[gb + 1104896 + 12 >> 2] = gb + 29552;
 HEAP32[gb + 1104896 + 4 >> 2] = 0;
 HEAP32[gb + 1104896 + 8 >> 2] = -1;
 HEAP32[gb + 1104896 + 16 >> 2] = 1;
 HEAP32[gb + 1104916 >> 2] = gb + 371395;
 HEAP32[gb + 1104916 + 12 >> 2] = gb + 32588;
 HEAP32[gb + 1104916 + 4 >> 2] = 0;
 HEAP32[gb + 1104916 + 8 >> 2] = -1;
 HEAP32[gb + 1104916 + 16 >> 2] = 1;
 HEAP32[gb + 1104936 >> 2] = gb + 371412;
 HEAP32[gb + 1104936 + 12 >> 2] = gb + 32588;
 HEAP32[gb + 1104936 + 4 >> 2] = 0;
 HEAP32[gb + 1104936 + 8 >> 2] = -1;
 HEAP32[gb + 1104936 + 16 >> 2] = 1;
 HEAP32[gb + 1104956 >> 2] = gb + 371428;
 HEAP32[gb + 1104956 + 12 >> 2] = gb + 32588;
 HEAP32[gb + 1104956 + 4 >> 2] = 0;
 HEAP32[gb + 1104956 + 8 >> 2] = -1;
 HEAP32[gb + 1104956 + 16 >> 2] = 1;
 HEAP32[gb + 1104976 >> 2] = gb + 371444;
 HEAP32[gb + 1104976 + 12 >> 2] = gb + 32628;
 HEAP32[gb + 1104976 + 4 >> 2] = 0;
 HEAP32[gb + 1104976 + 8 >> 2] = -1;
 HEAP32[gb + 1104976 + 16 >> 2] = 1;
 HEAP32[gb + 1104996 >> 2] = gb + 371459;
 HEAP32[gb + 1104996 + 12 >> 2] = gb + 29272;
 HEAP32[gb + 1104996 + 4 >> 2] = 0;
 HEAP32[gb + 1104996 + 8 >> 2] = -1;
 HEAP32[gb + 1104996 + 16 >> 2] = 1;
 HEAP32[gb + 1105016 >> 2] = gb + 371472;
 HEAP32[gb + 1105016 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105016 + 4 >> 2] = 0;
 HEAP32[gb + 1105016 + 8 >> 2] = -1;
 HEAP32[gb + 1105016 + 16 >> 2] = 0;
 HEAP32[gb + 1105036 >> 2] = gb + 371491;
 HEAP32[gb + 1105036 + 12 >> 2] = 0;
 HEAP32[gb + 1105036 + 4 >> 2] = 0;
 HEAP32[gb + 1105036 + 8 >> 2] = -1;
 HEAP32[gb + 1105036 + 16 >> 2] = 1;
 HEAP32[gb + 1105056 >> 2] = gb + 371522;
 HEAP32[gb + 1105056 + 12 >> 2] = 0;
 HEAP32[gb + 1105056 + 4 >> 2] = 0;
 HEAP32[gb + 1105056 + 8 >> 2] = -1;
 HEAP32[gb + 1105056 + 16 >> 2] = 1;
 HEAP32[gb + 1105076 >> 2] = gb + 371547;
 HEAP32[gb + 1105076 + 12 >> 2] = 0;
 HEAP32[gb + 1105076 + 4 >> 2] = 0;
 HEAP32[gb + 1105076 + 8 >> 2] = -1;
 HEAP32[gb + 1105076 + 16 >> 2] = 1;
 HEAP32[gb + 1105096 >> 2] = gb + 371574;
 HEAP32[gb + 1105096 + 12 >> 2] = gb + 28900;
 HEAP32[gb + 1105096 + 4 >> 2] = 0;
 HEAP32[gb + 1105096 + 8 >> 2] = -1;
 HEAP32[gb + 1105096 + 16 >> 2] = 1;
 HEAP32[gb + 1105116 >> 2] = gb + 371594;
 HEAP32[gb + 1105116 + 12 >> 2] = 0;
 HEAP32[gb + 1105116 + 4 >> 2] = 0;
 HEAP32[gb + 1105116 + 8 >> 2] = -1;
 HEAP32[gb + 1105116 + 16 >> 2] = 1;
 HEAP32[gb + 1105136 >> 2] = gb + 371612;
 HEAP32[gb + 1105136 + 12 >> 2] = 0;
 HEAP32[gb + 1105136 + 4 >> 2] = 0;
 HEAP32[gb + 1105136 + 8 >> 2] = -1;
 HEAP32[gb + 1105136 + 16 >> 2] = 0;
 HEAP32[gb + 1105156 >> 2] = gb + 371636;
 HEAP32[gb + 1105156 + 12 >> 2] = gb + 30832;
 HEAP32[gb + 1105156 + 4 >> 2] = 0;
 HEAP32[gb + 1105156 + 8 >> 2] = -1;
 HEAP32[gb + 1105156 + 16 >> 2] = 0;
 HEAP32[gb + 1105176 >> 2] = gb + 371658;
 HEAP32[gb + 1105176 + 12 >> 2] = 0;
 HEAP32[gb + 1105176 + 4 >> 2] = 0;
 HEAP32[gb + 1105176 + 8 >> 2] = -1;
 HEAP32[gb + 1105176 + 16 >> 2] = 0;
 HEAP32[gb + 1105196 >> 2] = gb + 371680;
 HEAP32[gb + 1105196 + 12 >> 2] = 0;
 HEAP32[gb + 1105196 + 4 >> 2] = 0;
 HEAP32[gb + 1105196 + 8 >> 2] = -1;
 HEAP32[gb + 1105196 + 16 >> 2] = 0;
 HEAP32[gb + 1105216 >> 2] = gb + 371696;
 HEAP32[gb + 1105216 + 12 >> 2] = 0;
 HEAP32[gb + 1105216 + 4 >> 2] = 0;
 HEAP32[gb + 1105216 + 8 >> 2] = -1;
 HEAP32[gb + 1105216 + 16 >> 2] = 0;
 HEAP32[gb + 1105236 >> 2] = gb + 371712;
 HEAP32[gb + 1105236 + 12 >> 2] = 0;
 HEAP32[gb + 1105236 + 4 >> 2] = 0;
 HEAP32[gb + 1105236 + 8 >> 2] = -1;
 HEAP32[gb + 1105236 + 16 >> 2] = 2;
 HEAP32[gb + 1105256 >> 2] = gb + 371733;
 HEAP32[gb + 1105256 + 12 >> 2] = gb + 29020;
 HEAP32[gb + 1105256 + 4 >> 2] = 0;
 HEAP32[gb + 1105256 + 8 >> 2] = -1;
 HEAP32[gb + 1105256 + 16 >> 2] = 0;
 HEAP32[gb + 1105276 >> 2] = gb + 371751;
 HEAP32[gb + 1105276 + 12 >> 2] = gb + 29020;
 HEAP32[gb + 1105276 + 4 >> 2] = 0;
 HEAP32[gb + 1105276 + 8 >> 2] = -1;
 HEAP32[gb + 1105276 + 16 >> 2] = 0;
 HEAP32[gb + 1105296 >> 2] = gb + 371772;
 HEAP32[gb + 1105296 + 12 >> 2] = 0;
 HEAP32[gb + 1105296 + 4 >> 2] = 0;
 HEAP32[gb + 1105296 + 8 >> 2] = -1;
 HEAP32[gb + 1105296 + 16 >> 2] = 1;
 HEAP32[gb + 1105316 >> 2] = gb + 371788;
 HEAP32[gb + 1105316 + 12 >> 2] = 0;
 HEAP32[gb + 1105316 + 4 >> 2] = 0;
 HEAP32[gb + 1105316 + 8 >> 2] = -1;
 HEAP32[gb + 1105316 + 16 >> 2] = 1;
 HEAP32[gb + 1105336 >> 2] = gb + 371806;
 HEAP32[gb + 1105336 + 12 >> 2] = 0;
 HEAP32[gb + 1105336 + 4 >> 2] = 0;
 HEAP32[gb + 1105336 + 8 >> 2] = -1;
 HEAP32[gb + 1105336 + 16 >> 2] = 5;
 HEAP32[gb + 1105356 >> 2] = gb + 371825;
 HEAP32[gb + 1105356 + 12 >> 2] = 0;
 HEAP32[gb + 1105356 + 4 >> 2] = 0;
 HEAP32[gb + 1105356 + 8 >> 2] = -1;
 HEAP32[gb + 1105356 + 16 >> 2] = 5;
 HEAP32[gb + 1105376 >> 2] = gb + 371835;
 HEAP32[gb + 1105376 + 12 >> 2] = 0;
 HEAP32[gb + 1105376 + 4 >> 2] = 0;
 HEAP32[gb + 1105376 + 8 >> 2] = -1;
 HEAP32[gb + 1105376 + 16 >> 2] = 5;
 HEAP32[gb + 1105396 >> 2] = gb + 371848;
 HEAP32[gb + 1105396 + 12 >> 2] = 0;
 HEAP32[gb + 1105396 + 4 >> 2] = 0;
 HEAP32[gb + 1105396 + 8 >> 2] = -1;
 HEAP32[gb + 1105396 + 16 >> 2] = 5;
 HEAP32[gb + 1105416 >> 2] = gb + 371860;
 HEAP32[gb + 1105416 + 12 >> 2] = gb + 29592;
 HEAP32[gb + 1105416 + 4 >> 2] = 0;
 HEAP32[gb + 1105416 + 8 >> 2] = -1;
 HEAP32[gb + 1105416 + 16 >> 2] = 1;
 HEAP32[gb + 1105436 >> 2] = gb + 371884;
 HEAP32[gb + 1105436 + 12 >> 2] = 0;
 HEAP32[gb + 1105436 + 4 >> 2] = 0;
 HEAP32[gb + 1105436 + 8 >> 2] = -1;
 HEAP32[gb + 1105436 + 16 >> 2] = 5;
 HEAP32[gb + 1105456 >> 2] = gb + 371899;
 HEAP32[gb + 1105456 + 12 >> 2] = gb + 29632;
 HEAP32[gb + 1105456 + 4 >> 2] = 0;
 HEAP32[gb + 1105456 + 8 >> 2] = -1;
 HEAP32[gb + 1105456 + 16 >> 2] = 0;
 HEAP32[gb + 1105476 >> 2] = gb + 371921;
 HEAP32[gb + 1105476 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105476 + 4 >> 2] = 0;
 HEAP32[gb + 1105476 + 8 >> 2] = -1;
 HEAP32[gb + 1105476 + 16 >> 2] = 5;
 HEAP32[gb + 1105496 >> 2] = gb + 371934;
 HEAP32[gb + 1105496 + 12 >> 2] = 0;
 HEAP32[gb + 1105496 + 4 >> 2] = 0;
 HEAP32[gb + 1105496 + 8 >> 2] = -1;
 HEAP32[gb + 1105496 + 16 >> 2] = 0;
 HEAP32[gb + 1105516 >> 2] = gb + 371956;
 HEAP32[gb + 1105516 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105516 + 4 >> 2] = gb + 371976;
 HEAP32[gb + 1105516 + 8 >> 2] = -1;
 HEAP32[gb + 1105516 + 16 >> 2] = 1;
 HEAP32[gb + 1105536 >> 2] = gb + 371990;
 HEAP32[gb + 1105536 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105536 + 4 >> 2] = gb + 371976;
 HEAP32[gb + 1105536 + 8 >> 2] = -1;
 HEAP32[gb + 1105536 + 16 >> 2] = 1;
 HEAP32[gb + 1105556 >> 2] = gb + 372008;
 HEAP32[gb + 1105556 + 12 >> 2] = 0;
 HEAP32[gb + 1105556 + 4 >> 2] = 0;
 HEAP32[gb + 1105556 + 8 >> 2] = -1;
 HEAP32[gb + 1105556 + 16 >> 2] = 1;
 HEAP32[gb + 1105576 >> 2] = gb + 372028;
 HEAP32[gb + 1105576 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105576 + 4 >> 2] = gb + 371976;
 HEAP32[gb + 1105576 + 8 >> 2] = -1;
 HEAP32[gb + 1105576 + 16 >> 2] = 1;
 HEAP32[gb + 1105596 >> 2] = gb + 372049;
 HEAP32[gb + 1105596 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105596 + 4 >> 2] = gb + 372074;
 HEAP32[gb + 1105596 + 8 >> 2] = -1;
 HEAP32[gb + 1105596 + 16 >> 2] = 1;
 HEAP32[gb + 1105616 >> 2] = gb + 372095;
 HEAP32[gb + 1105616 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105616 + 4 >> 2] = gb + 372113;
 HEAP32[gb + 1105616 + 8 >> 2] = -1;
 HEAP32[gb + 1105616 + 16 >> 2] = 1;
 HEAP32[gb + 1105636 >> 2] = gb + 372136;
 HEAP32[gb + 1105636 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105636 + 4 >> 2] = gb + 372113;
 HEAP32[gb + 1105636 + 8 >> 2] = -1;
 HEAP32[gb + 1105636 + 16 >> 2] = 1;
 HEAP32[gb + 1105656 >> 2] = gb + 372168;
 HEAP32[gb + 1105656 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105656 + 4 >> 2] = gb + 372074;
 HEAP32[gb + 1105656 + 8 >> 2] = -1;
 HEAP32[gb + 1105656 + 16 >> 2] = 1;
 HEAP32[gb + 1105676 >> 2] = gb + 372199;
 HEAP32[gb + 1105676 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105676 + 4 >> 2] = gb + 372219;
 HEAP32[gb + 1105676 + 8 >> 2] = -1;
 HEAP32[gb + 1105676 + 16 >> 2] = 1;
 HEAP32[gb + 1105696 >> 2] = gb + 456191;
 HEAP32[gb + 1105696 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105696 + 4 >> 2] = 0;
 HEAP32[gb + 1105696 + 8 >> 2] = -1;
 HEAP32[gb + 1105696 + 16 >> 2] = 1;
 HEAP32[gb + 1105716 >> 2] = gb + 372237;
 HEAP32[gb + 1105716 + 12 >> 2] = gb + 29232;
 HEAP32[gb + 1105716 + 4 >> 2] = 0;
 HEAP32[gb + 1105716 + 8 >> 2] = -1;
 HEAP32[gb + 1105716 + 16 >> 2] = 1;
 HEAP32[gb + 1105736 >> 2] = gb + 372256;
 HEAP32[gb + 1105736 + 12 >> 2] = gb + 29232;
 HEAP32[gb + 1105736 + 4 >> 2] = 0;
 HEAP32[gb + 1105736 + 8 >> 2] = -1;
 HEAP32[gb + 1105736 + 16 >> 2] = 1;
 HEAP32[gb + 1105756 >> 2] = gb + 372275;
 HEAP32[gb + 1105756 + 12 >> 2] = 0;
 HEAP32[gb + 1105756 + 4 >> 2] = 0;
 HEAP32[gb + 1105756 + 8 >> 2] = -1;
 HEAP32[gb + 1105756 + 16 >> 2] = 1;
 HEAP32[gb + 1105776 >> 2] = gb + 372293;
 HEAP32[gb + 1105776 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1105776 + 4 >> 2] = gb + 372310;
 HEAP32[gb + 1105776 + 8 >> 2] = -1;
 HEAP32[gb + 1105776 + 16 >> 2] = 1;
 HEAP32[gb + 1105796 >> 2] = gb + 372330;
 HEAP32[gb + 1105796 + 12 >> 2] = 0;
 HEAP32[gb + 1105796 + 4 >> 2] = 0;
 HEAP32[gb + 1105796 + 8 >> 2] = -1;
 HEAP32[gb + 1105796 + 16 >> 2] = 0;
 HEAP32[gb + 1105816 >> 2] = gb + 372360;
 HEAP32[gb + 1105816 + 12 >> 2] = 0;
 HEAP32[gb + 1105816 + 4 >> 2] = 0;
 HEAP32[gb + 1105816 + 8 >> 2] = -1;
 HEAP32[gb + 1105816 + 16 >> 2] = 0;
 HEAP32[gb + 1105836 >> 2] = gb + 372378;
 HEAP32[gb + 1105836 + 12 >> 2] = 0;
 HEAP32[gb + 1105836 + 4 >> 2] = 0;
 HEAP32[gb + 1105836 + 8 >> 2] = -1;
 HEAP32[gb + 1105836 + 16 >> 2] = 0;
 HEAP32[gb + 1105856 >> 2] = gb + 372396;
 HEAP32[gb + 1105856 + 12 >> 2] = gb + 29392;
 HEAP32[gb + 1105856 + 4 >> 2] = 0;
 HEAP32[gb + 1105856 + 8 >> 2] = -1;
 HEAP32[gb + 1105856 + 16 >> 2] = 4;
 HEAP32[gb + 1105876 >> 2] = gb + 372416;
 HEAP32[gb + 1105876 + 12 >> 2] = 0;
 HEAP32[gb + 1105876 + 4 >> 2] = 0;
 HEAP32[gb + 1105876 + 8 >> 2] = -1;
 HEAP32[gb + 1105876 + 16 >> 2] = 0;
 HEAP32[gb + 1105896 >> 2] = gb + 372434;
 HEAP32[gb + 1105896 + 12 >> 2] = 0;
 HEAP32[gb + 1105896 + 4 >> 2] = 0;
 HEAP32[gb + 1105896 + 8 >> 2] = -1;
 HEAP32[gb + 1105896 + 16 >> 2] = 1;
 HEAP32[gb + 1105916 >> 2] = gb + 372457;
 HEAP32[gb + 1105916 + 12 >> 2] = 0;
 HEAP32[gb + 1105916 + 4 >> 2] = 0;
 HEAP32[gb + 1105916 + 8 >> 2] = -1;
 HEAP32[gb + 1105916 + 16 >> 2] = 0;
 HEAP32[gb + 1105936 >> 2] = gb + 372479;
 HEAP32[gb + 1105936 + 12 >> 2] = gb + 29472;
 HEAP32[gb + 1105936 + 4 >> 2] = 0;
 HEAP32[gb + 1105936 + 8 >> 2] = -1;
 HEAP32[gb + 1105936 + 16 >> 2] = 0;
 HEAP32[gb + 1105956 >> 2] = gb + 372503;
 HEAP32[gb + 1105956 + 12 >> 2] = gb + 29432;
 HEAP32[gb + 1105956 + 4 >> 2] = 0;
 HEAP32[gb + 1105956 + 8 >> 2] = -1;
 HEAP32[gb + 1105956 + 16 >> 2] = 0;
 HEAP32[gb + 1105976 >> 2] = gb + 372526;
 HEAP32[gb + 1105976 + 12 >> 2] = gb + 29432;
 HEAP32[gb + 1105976 + 4 >> 2] = 0;
 HEAP32[gb + 1105976 + 8 >> 2] = -1;
 HEAP32[gb + 1105976 + 16 >> 2] = 0;
 HEAP32[gb + 1105996 >> 2] = gb + 372549;
 HEAP32[gb + 1105996 + 12 >> 2] = gb + 29432;
 HEAP32[gb + 1105996 + 4 >> 2] = 0;
 HEAP32[gb + 1105996 + 8 >> 2] = -1;
 HEAP32[gb + 1105996 + 16 >> 2] = 0;
 HEAP32[gb + 1106016 >> 2] = gb + 372586;
 HEAP32[gb + 1106016 + 12 >> 2] = gb + 29432;
 HEAP32[gb + 1106016 + 4 >> 2] = 0;
 HEAP32[gb + 1106016 + 8 >> 2] = -1;
 HEAP32[gb + 1106016 + 16 >> 2] = 0;
 HEAP32[gb + 1106036 >> 2] = gb + 372623;
 HEAP32[gb + 1106036 + 12 >> 2] = 0;
 HEAP32[gb + 1106036 + 4 >> 2] = 0;
 HEAP32[gb + 1106036 + 8 >> 2] = -1;
 HEAP32[gb + 1106036 + 16 >> 2] = 1;
 HEAP32[gb + 1106056 >> 2] = gb + 372655;
 HEAP32[gb + 1106056 + 12 >> 2] = gb + 29192;
 HEAP32[gb + 1106056 + 4 >> 2] = 0;
 HEAP32[gb + 1106056 + 8 >> 2] = -1;
 HEAP32[gb + 1106056 + 16 >> 2] = 1;
 HEAP32[gb + 1106076 >> 2] = gb + 372668;
 HEAP32[gb + 1106076 + 12 >> 2] = 0;
 HEAP32[gb + 1106076 + 4 >> 2] = 0;
 HEAP32[gb + 1106076 + 8 >> 2] = -1;
 HEAP32[gb + 1106076 + 16 >> 2] = 1;
 HEAP32[gb + 1106096 >> 2] = gb + 372689;
 HEAP32[gb + 1106096 + 12 >> 2] = 0;
 HEAP32[gb + 1106096 + 4 >> 2] = 0;
 HEAP32[gb + 1106096 + 8 >> 2] = -1;
 HEAP32[gb + 1106096 + 16 >> 2] = 1;
 HEAP32[gb + 1106116 >> 2] = gb + 372714;
 HEAP32[gb + 1106116 + 12 >> 2] = gb + 29352;
 HEAP32[gb + 1106116 + 4 >> 2] = 0;
 HEAP32[gb + 1106116 + 8 >> 2] = -1;
 HEAP32[gb + 1106116 + 16 >> 2] = 0;
 HEAP32[gb + 1106136 >> 2] = gb + 372729;
 HEAP32[gb + 1106136 + 12 >> 2] = 0;
 HEAP32[gb + 1106136 + 4 >> 2] = 0;
 HEAP32[gb + 1106136 + 8 >> 2] = -1;
 HEAP32[gb + 1106136 + 16 >> 2] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544212 | 0, fb + 3313 | 0, fb + 3314 | 0, 0, 0);
 HEAP32[gb + 1110264 >> 2] = 0;
 HEAP32[gb + 1110264 + 20 >> 2] = 0;
 i3 = gb + 63648 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1110264 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP8[gb + 1110264 + 4 >> 0] = 0;
 return;
}

function __ZN18AsyncUploadManager19AsyncResourceUploadER9GfxDeviceii9TextureID(i89, i90, i1, i93, i2) {
 i89 = i89 | 0;
 i90 = i90 | 0;
 i1 = i1 | 0;
 i93 = i93 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, f77 = f0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i91 = 0, i92 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, d100 = 0.0, i101 = 0;
 i99 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i88 = i99 + 48 | 0;
 i94 = i99 + 36 | 0;
 i95 = i99 + 32 | 0;
 i96 = i99;
 i97 = i99 + 28 | 0;
 i98 = i99 + 24 | 0;
 i91 = i99 + 8 | 0;
 i92 = i99 + 40 | 0;
 f77 = Math_fround(Math_fround(i1 | 0) / Math_fround(1.0e3));
 d100 = +_emscripten_get_now() * 1.0e6;
 i78 = ~~d100 >>> 0;
 i79 = +Math_abs(d100) >= 1.0 ? (d100 > 0.0 ? ~~+Math_min(+Math_floor(d100 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d100 - +(~~d100 >>> 0)) / 4294967296.0) >>> 0) : 0;
 __ZN18AsyncUploadManager23HandleAsyncReadCommandsEv(i89);
 i80 = i89 + 36 | 0;
 i81 = i91 + 4 | 0;
 i82 = i91 + 8 | 0;
 i83 = i91 + 12 | 0;
 i84 = i89 + 4 | 0;
 i85 = i89 + 1324 | 0;
 i86 = i89 + 1352 | 0;
 i87 = i89 + 1340 | 0;
 i20 = HEAP32[i2 >> 2] | 0;
 i21 = i88 + 4 | 0;
 i22 = i88 + 8 | 0;
 i23 = i88 + 12 | 0;
 i24 = i88 + 16 | 0;
 i25 = i88 + 20 | 0;
 i26 = i88 + 24 | 0;
 i27 = i88 + 28 | 0;
 i28 = i88 + 32 | 0;
 i29 = i88 + 36 | 0;
 i30 = i88 + 40 | 0;
 i31 = i88 + 44 | 0;
 i32 = i88 + 4 | 0;
 i33 = i88 + 8 | 0;
 i34 = i88 + 12 | 0;
 i35 = i88 + 16 | 0;
 i36 = i88 + 20 | 0;
 i37 = i88 + 24 | 0;
 i38 = i88 + 28 | 0;
 i39 = i88 + 32 | 0;
 i40 = i88 + 36 | 0;
 i41 = i88 + 40 | 0;
 i42 = i88 + 44 | 0;
 i43 = i88 + 4 | 0;
 i44 = i88 + 8 | 0;
 i45 = i88 + 12 | 0;
 i46 = i88 + 16 | 0;
 i47 = i88 + 20 | 0;
 i48 = i88 + 24 | 0;
 i49 = i88 + 28 | 0;
 i50 = i88 + 32 | 0;
 i51 = i88 + 36 | 0;
 i52 = i88 + 40 | 0;
 i53 = i88 + 44 | 0;
 i54 = i88 + 4 | 0;
 i55 = i88 + 8 | 0;
 i56 = i88 + 12 | 0;
 i57 = i88 + 16 | 0;
 i58 = i88 + 20 | 0;
 i59 = i88 + 24 | 0;
 i60 = i88 + 28 | 0;
 i61 = i88 + 32 | 0;
 i62 = i88 + 36 | 0;
 i63 = i88 + 40 | 0;
 i64 = i88 + 44 | 0;
 i65 = i88 + 4 | 0;
 i66 = i88 + 8 | 0;
 i67 = i88 + 12 | 0;
 i68 = i88 + 16 | 0;
 i69 = i88 + 20 | 0;
 i70 = i88 + 24 | 0;
 i71 = i88 + 28 | 0;
 i72 = i88 + 32 | 0;
 i73 = i88 + 36 | 0;
 i74 = i88 + 40 | 0;
 i75 = i88 + 44 | 0;
 while (1) {
  d100 = +_emscripten_get_now() * 1.0e6;
  i76 = _i64Subtract(~~d100 >>> 0 | 0, (+Math_abs(d100) >= 1.0 ? (d100 > 0.0 ? ~~+Math_min(+Math_floor(d100 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d100 - +(~~d100 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i78 | 0, i79 | 0) | 0;
  i76 = __Z17TimeToNanosecondsy(i76, getTempRet0() | 0) | 0;
  if (!(Math_fround((+(i76 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) < f77)) {
   i15 = 48;
   break;
  }
  i1 = (HEAP32[i80 >> 2] | 0) + 4 | 0;
  i76 = HEAP32[i1 >> 2] | 0;
  i19 = HEAP32[i76 >> 2] | 0;
  i2 = i19;
  if (!i19) {
   i15 = 4;
   break;
  }
  HEAP32[i76 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i76 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i76 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 >> 2] = i2;
  if (!i76) {
   i15 = 48;
   break;
  }
  i18 = HEAP32[i76 + 4 >> 2] | 0;
  i17 = i18 + 16 | 0;
  i19 = HEAP32[i17 >> 2] | 0;
  i1 = i18 + 148 | 0;
  if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
  __ZN15TextureSettings5ResetEv(i91);
  i16 = i18 + 64 | 0;
  i14 = HEAP32[i16 >> 2] | 0;
  HEAP32[i91 >> 2] = i14 >>> 22 & 7;
  HEAP32[i81 >> 2] = i14 >>> 8 & 63;
  HEAP32[i82 >> 2] = HEAP32[i18 + 56 >> 2];
  HEAP32[i83 >> 2] = i14 >>> 25 & 3;
  i14 = i18 + 60 | 0;
  __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE13TextureFormat(i91, HEAP32[i14 >> 2] | 0);
  i13 = HEAP32[i16 >> 2] | 0;
  switch (i13 >>> 14 & 15) {
  case 2:
   {
    i3 = (i13 & 3932160 | 0) == 1572864;
    i2 = i18 + 72 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) i9 = HEAP32[i18 + 68 >> 2] | 0; else i9 = i1;
    do if (!(i13 & 536870912)) {
     i4 = i18 + 36 | 0;
     i11 = HEAP32[i4 >> 2] | 0;
     i5 = i18 + 40 | 0;
     i12 = HEAP32[i5 >> 2] | 0;
     i6 = (i12 + -1 & i12 | i11 + -1 & i11 | 0) != 0;
     i101 = HEAP32[i17 >> 2] | 0;
     i7 = i18 + 24 | 0;
     i10 = HEAP32[i7 >> 2] | 0;
     i15 = HEAP32[i14 >> 2] | 0;
     i8 = i18 + 52 | 0;
     i3 = HEAP32[i8 >> 2] | 0;
     i1 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
     HEAP32[i88 >> 2] = i101;
     HEAP32[i21 >> 2] = i9;
     HEAP32[i22 >> 2] = i10;
     HEAP32[i23 >> 2] = i11;
     HEAP32[i24 >> 2] = i12;
     HEAP32[i25 >> 2] = i13 & 255;
     HEAP32[i26 >> 2] = i15;
     HEAP32[i27 >> 2] = i3;
     HEAP32[i28 >> 2] = i13 >>> 18 & 15;
     HEAP32[i29 >> 2] = i13 >>> 27 & 3;
     HEAP32[i30 >> 2] = i1;
     HEAP32[i31 >> 2] = i90;
     i1 = __Z19UploadTexture2DDataRK23UploadTextureDataParams(i88) | 0;
     HEAP32[i94 >> 2] = HEAP32[i17 >> 2];
     i3 = HEAP32[i16 >> 2] | 0;
     HEAP32[i88 >> 2] = HEAP32[i94 >> 2];
     __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 2, (i3 | 0) < 0, i3 >>> 27 & 3, 2, i6);
     i3 = HEAP32[i16 >> 2] | 0;
     if (i3 & 1073741824) {
      i101 = i18 + 20 | 0;
      i10 = HEAP32[i101 >> 2] | 0;
      i11 = HEAP32[i7 >> 2] | 0;
      i12 = HEAP32[i4 >> 2] | 0;
      i13 = HEAP32[i5 >> 2] | 0;
      i14 = HEAP32[i14 >> 2] | 0;
      i15 = HEAP32[i8 >> 2] | 0;
      i1 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
      HEAP32[i88 >> 2] = i10;
      HEAP32[i32 >> 2] = i9;
      HEAP32[i33 >> 2] = i11;
      HEAP32[i34 >> 2] = i12;
      HEAP32[i35 >> 2] = i13;
      HEAP32[i36 >> 2] = i3 & 255;
      HEAP32[i37 >> 2] = i14;
      HEAP32[i38 >> 2] = i15;
      HEAP32[i39 >> 2] = i3 >>> 18 & 15;
      HEAP32[i40 >> 2] = i3 >>> 27 & 3;
      HEAP32[i41 >> 2] = i1;
      HEAP32[i42 >> 2] = i90;
      i1 = __Z19UploadTexture2DDataRK23UploadTextureDataParams(i88) | 0;
      HEAP32[i95 >> 2] = HEAP32[i101 >> 2];
      i101 = HEAP32[i16 >> 2] | 0;
      HEAP32[i88 >> 2] = HEAP32[i95 >> 2];
      __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 2, (i101 | 0) < 0, i101 >>> 27 & 3, 2, i6);
     }
    } else {
     if (i3) {
      i8 = HEAP32[i17 >> 2] | 0;
      i9 = HEAP32[i18 + 76 >> 2] | 0;
      i10 = HEAP32[i18 + 80 >> 2] | 0;
      i11 = HEAP32[i18 + 84 >> 2] | 0;
      i12 = HEAP32[i18 + 88 >> 2] | 0;
      i15 = HEAP32[i14 >> 2] | 0;
      i101 = HEAP32[i18 + 52 >> 2] | 0;
      i1 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
      HEAP32[i88 >> 2] = i8;
      HEAP32[i43 >> 2] = i9;
      HEAP32[i44 >> 2] = i10;
      HEAP32[i45 >> 2] = i11;
      HEAP32[i46 >> 2] = i12;
      HEAP32[i47 >> 2] = i13 & 255;
      HEAP32[i48 >> 2] = i15;
      HEAP32[i49 >> 2] = i101;
      HEAP32[i50 >> 2] = i13 >>> 18 & 15;
      HEAP32[i51 >> 2] = i13 >>> 27 & 3;
      HEAP32[i52 >> 2] = i1;
      HEAP32[i53 >> 2] = i90;
      i1 = __Z19UploadTexture2DDataRK23UploadTextureDataParams(i88) | 0;
      HEAP32[i96 >> 2] = HEAP32[i17 >> 2];
      i101 = HEAP32[i16 >> 2] | 0;
      HEAP32[i88 >> 2] = HEAP32[i96 >> 2];
      __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 2, (i101 | 0) < 0, i101 >>> 27 & 3, 2, 0);
      break;
     }
     i9 = HEAP32[i17 >> 2] | 0;
     i10 = HEAP32[i18 + 104 >> 2] | 0;
     i11 = HEAP32[i18 + 108 >> 2] | 0;
     i12 = HEAP32[i18 + 112 >> 2] | 0;
     i15 = HEAP32[i18 + 116 >> 2] | 0;
     i101 = HEAP32[i14 >> 2] | 0;
     i4 = i18 + 52 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i1 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
     HEAP32[i88 >> 2] = i9;
     HEAP32[i54 >> 2] = i10;
     HEAP32[i55 >> 2] = i11;
     HEAP32[i56 >> 2] = i12;
     HEAP32[i57 >> 2] = i15;
     HEAP32[i58 >> 2] = i13 & 255;
     HEAP32[i59 >> 2] = i101;
     HEAP32[i60 >> 2] = i3;
     HEAP32[i61 >> 2] = i13 >>> 18 & 15;
     HEAP32[i62 >> 2] = i13 >>> 27 & 3;
     HEAP32[i63 >> 2] = i1;
     HEAP32[i64 >> 2] = i90;
     i1 = __Z19UploadTexture2DDataRK23UploadTextureDataParams(i88) | 0;
     HEAP32[i97 >> 2] = HEAP32[i17 >> 2];
     i3 = HEAP32[i16 >> 2] | 0;
     HEAP32[i88 >> 2] = HEAP32[i97 >> 2];
     __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 2, (i3 | 0) < 0, i3 >>> 27 & 3, 2, 0);
     i3 = HEAP32[i16 >> 2] | 0;
     if (i3 & 1073741824) {
      i101 = i18 + 20 | 0;
      i9 = HEAP32[i101 >> 2] | 0;
      i10 = HEAP32[i18 + 76 >> 2] | 0;
      i11 = HEAP32[i18 + 80 >> 2] | 0;
      i12 = HEAP32[i18 + 84 >> 2] | 0;
      i13 = HEAP32[i18 + 88 >> 2] | 0;
      i14 = HEAP32[i14 >> 2] | 0;
      i15 = HEAP32[i4 >> 2] | 0;
      i1 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
      HEAP32[i88 >> 2] = i9;
      HEAP32[i65 >> 2] = i10;
      HEAP32[i66 >> 2] = i11;
      HEAP32[i67 >> 2] = i12;
      HEAP32[i68 >> 2] = i13;
      HEAP32[i69 >> 2] = i3 & 255;
      HEAP32[i70 >> 2] = i14;
      HEAP32[i71 >> 2] = i15;
      HEAP32[i72 >> 2] = i3 >>> 18 & 15;
      HEAP32[i73 >> 2] = i3 >>> 27 & 3;
      HEAP32[i74 >> 2] = i1;
      HEAP32[i75 >> 2] = i90;
      i1 = __Z19UploadTexture2DDataRK23UploadTextureDataParams(i88) | 0;
      HEAP32[i98 >> 2] = HEAP32[i101 >> 2];
      i101 = HEAP32[i16 >> 2] | 0;
      HEAP32[i88 >> 2] = HEAP32[i98 >> 2];
      __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 2, (i101 | 0) < 0, i101 >>> 27 & 3, 2, 0);
     }
    } while (0);
    break;
   }
  case 4:
   {
    i2 = i18 + 72 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) i1 = HEAP32[i18 + 68 >> 2] | 0;
    i10 = HEAP32[i17 >> 2] | 0;
    i4 = HEAP32[i18 + 24 >> 2] | 0;
    i5 = HEAP32[i18 + 28 >> 2] | 0;
    i11 = HEAP32[i18 + 36 >> 2] | 0;
    i6 = HEAP32[i18 + 40 >> 2] | 0;
    i12 = i13 & 255;
    i3 = HEAP32[i14 >> 2] | 0;
    i7 = HEAP32[i18 + 52 >> 2] | 0;
    i9 = i13 >>> 27 & 3;
    HEAP32[i94 >> 2] = i4;
    HEAP32[i95 >> 2] = i3;
    if ((i3 | 1 | 0) == 29) {
     i13 = gb + 64016 | 0;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i101 = i96;
     HEAP32[i101 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i101 + 4 >> 2] = i14;
     HEAP32[i88 >> 2] = HEAP32[i96 >> 2];
     HEAP32[i88 + 4 >> 2] = HEAP32[i96 + 4 >> 2];
     i1 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i1, i94, i95, i12, i11, i6, 6, i88) | 0;
     if (!i1) i1 = 0; else {
      i4 = HEAP32[i94 >> 2] | 0;
      i8 = i1;
      i6 = i7 & -2;
      i5 = (i4 >>> 0) / 6 | 0;
      i3 = HEAP32[i95 >> 2] | 0;
      i15 = 25;
     }
    } else {
     i8 = 0;
     i6 = i7;
     i15 = 25;
    }
    if ((i15 | 0) == 25) {
     i101 = HEAP32[(HEAP32[i90 >> 2] | 0) + 444 >> 2] | 0;
     HEAP32[i97 >> 2] = i10;
     HEAP32[i88 >> 2] = HEAP32[i97 >> 2];
     mftCall_viiiiiiiiii(i101 | 0, i90 | 0, i88 | 0, i1 | 0, i4 | 0, i5 | 0, i11 | 0, i3 | 0, i12 | 0, i6 | 0, i9 | 0);
     if (!i8) i1 = 1; else {
      __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
      i1 = 1;
     }
    }
    HEAP32[i98 >> 2] = HEAP32[i17 >> 2];
    i101 = HEAP32[i16 >> 2] | 0;
    HEAP32[i88 >> 2] = HEAP32[i98 >> 2];
    __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i91, i90, i88, 4, (i101 | 0) < 0, i101 >>> 27 & 3, 2, 0);
    break;
   }
  default:
   {
    i1 = 0;
    i2 = i18 + 72 | 0;
   }
  }
  i2 = HEAP32[i2 >> 2] | 0;
  if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  if (!i1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 398036 | 0, 0, gb + 397649 | 0, 477, 1, 0, 0, 0);
  i1 = i18 + 168 | 0;
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i2 = HEAP32[i18 + 172 >> 2] | 0; else i2 = i2 & 255;
  if (i2 | 0) {
   i2 = HEAP32[(HEAP32[i90 >> 2] | 0) + 680 >> 2] | 0;
   HEAP32[i92 >> 2] = HEAP32[i17 >> 2];
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i88 >> 2] = HEAP32[i92 >> 2];
   mftCall_viii(i2 | 0, i90 | 0, i88 | 0, i1 | 0);
  }
  HEAP32[i84 >> 2] = (HEAP32[i84 >> 2] | 0) + 1;
  i4 = i18 + 140 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = HEAP32[i18 + 144 >> 2] | 0;
  i1 = HEAP32[i85 >> 2] | 0;
  i3 = HEAP32[i1 + 24 >> 2] | 0;
  i7 = i1 + 20 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i6 = i1 + 28 | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
  if ((HEAP32[i6 >> 2] | 0) == 1) {
   i2 = i1 >>> 0 < i5 >>> 0 ? 0 : i1 - i5 | 0;
   i101 = (i3 | 0) != 0 & (i2 | 0) == 0;
   i1 = i101 ? i3 : i2;
   if (i101) {
    i1 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
    i15 = 45;
   } else {
    i1 = i2;
    i15 = 44;
   }
  } else {
   i1 = i3 >>> 0 > i5 >>> 0 ? i3 - i5 | 0 : 0;
   i15 = 44;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   i1 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
   if (!i5) i15 = 45;
  }
  if ((i15 | 0) == 45) {
   i15 = 0;
   if (HEAP32[i7 >> 2] | 0) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   }
  }
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
  i101 = HEAP32[i86 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i101 >> 2];
  HEAP32[i101 >> 2] = i18;
  i101 = HEAP32[i87 >> 2] | 0;
  HEAP32[i76 >> 2] = HEAP32[i101 >> 2];
  HEAP32[i101 >> 2] = i76;
  if ((i19 | 0) == (i20 | 0)) {
   i15 = 48;
   break;
  }
 }
 if ((i15 | 0) == 4) {
  __ZN18AsyncUploadManager35ManageTextureUploadRingBufferMemoryEi(i89, i93);
  __ZN18AsyncUploadManager18ScheduleAsyncReadsEv(i89);
  STACKTOP = i99;
  return;
 } else if ((i15 | 0) == 48) {
  __ZN18AsyncUploadManager35ManageTextureUploadRingBufferMemoryEi(i89, i93);
  __ZN18AsyncUploadManager18ScheduleAsyncReadsEv(i89);
  STACKTOP = i99;
  return;
 }
}

function __ZN13SpeedTreeWind10SWindGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 108 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 116 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 120 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 124 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 128 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 132 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 136 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 140 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 144 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 148 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 152 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 156 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 160 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 164 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 172 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 176 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 180 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 184 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 188 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 192 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 196 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 200 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 204 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 208 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 212 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 216 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 220 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN5physx2Sc8BodyCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i2 + 832 | 0;
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i29 >> 2] = HEAP32[gb + 131460 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[gb + 131460 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[gb + 131460 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[gb + 131460 + 12 >> 2];
 HEAP32[i29 + 16 >> 2] = HEAP32[gb + 131460 + 16 >> 2];
 HEAP32[i29 + 20 >> 2] = HEAP32[gb + 131460 + 20 >> 2];
 HEAP32[i29 + 24 >> 2] = HEAP32[gb + 131460 + 24 >> 2];
 HEAP32[i29 + 28 >> 2] = HEAP32[gb + 131460 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i29 | 0, 32) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 131492 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 131492 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 131492 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 131492 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 131492 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 131492 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 131492 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 131492 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 131524 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 131524 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 131524 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 131524 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 131524 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 131524 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 131524 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 131524 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = HEAP32[gb + 131556 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[gb + 131556 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[gb + 131556 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[gb + 131556 + 12 >> 2];
 HEAP32[i26 + 16 >> 2] = HEAP32[gb + 131556 + 16 >> 2];
 HEAP32[i26 + 20 >> 2] = HEAP32[gb + 131556 + 20 >> 2];
 HEAP32[i26 + 24 >> 2] = HEAP32[gb + 131556 + 24 >> 2];
 HEAP32[i26 + 28 >> 2] = HEAP32[gb + 131556 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = HEAP32[gb + 131588 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 131588 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 131588 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[gb + 131588 + 12 >> 2];
 HEAP32[i25 + 16 >> 2] = HEAP32[gb + 131588 + 16 >> 2];
 HEAP32[i25 + 20 >> 2] = HEAP32[gb + 131588 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[gb + 131588 + 24 >> 2];
 HEAP32[i25 + 28 >> 2] = HEAP32[gb + 131588 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = HEAP32[gb + 131620 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 131620 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 131620 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 131620 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 131620 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 131620 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 131620 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 131620 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = gb + 751673;
 HEAP32[i23 + 4 >> 2] = gb + 751685;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 128;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 1;
 HEAP32[i23 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 131652 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 131652 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 131652 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 131652 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 131652 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 131652 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 131652 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 131652 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 131684 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 131684 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 131684 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 131684 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 131684 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 131684 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 131684 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 131684 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 131716 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 131716 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 131716 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 131716 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 131716 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 131716 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 131716 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 131716 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 131748 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 131748 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 131748 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 131748 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 131748 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 131748 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 131748 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 131748 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 131780 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 131780 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 131780 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 131780 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 131780 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 131780 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 131780 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 131780 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 131812 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 131812 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 131812 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 131812 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 131812 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 131812 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 131812 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 131812 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 131844 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 131844 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 131844 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 131844 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 131844 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 131844 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 131844 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 131844 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 131876 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 131876 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 131876 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 131876 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 131876 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 131876 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 131876 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 131876 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 131908 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 131908 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 131908 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 131908 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 131908 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 131908 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 131908 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 131908 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 131940 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 131940 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 131940 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 131940 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 131940 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 131940 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 131940 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 131940 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 131972 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 131972 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 131972 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 131972 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 131972 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 131972 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 131972 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 131972 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 132004 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 132004 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 132004 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 132004 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 132004 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 132004 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 132004 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 132004 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 132036 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 132036 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 132036 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 132036 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 132036 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 132036 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 132036 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 132036 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 132068 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 132068 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 132068 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 132068 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 132068 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 132068 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 132068 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 132068 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = gb + 751698;
 HEAP32[i8 + 4 >> 2] = gb + 751711;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 160;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 1;
 HEAP32[i8 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 132100 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 132100 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 132100 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 132100 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 132100 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 132100 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 132100 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 132100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 132132 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 132132 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 132132 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 132132 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 132132 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 132132 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 132132 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 132132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 132164 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 132164 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 132164 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 132164 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 132164 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 132164 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 132164 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 132164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 132196 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 132196 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 132196 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 132196 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 132196 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 132196 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 132196 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 132196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 132228 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 132228 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 132228 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 132228 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 132228 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 132228 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 132228 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 132228 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function _sfnt_init_face(i4, i40, i39, i1, i2) {
 i4 = i4 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i41 + 52 | 0;
 i32 = i41 + 8 | 0;
 i34 = i41 + 4 | 0;
 i38 = i41;
 i2 = i40 + 532 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i40 + 96 | 0;
 do if (!i1) {
  i1 = _UNITY_FT_Get_Module_Interface(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, gb + 1007772 | 0) | 0;
  if (!i1) {
   i40 = 11;
   STACKTOP = i41;
   return i40 | 0;
  } else {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i40 + 508 >> 2] = HEAP32[i1 >> 2];
   i35 = i1;
   break;
  }
 } else i35 = i1; while (0);
 HEAP32[i40 + 536 >> 2] = _UNITY_ft_module_get_service(HEAP32[i3 >> 2] | 0, gb + 1006980 | 0) | 0;
 i31 = HEAP32[i4 + 28 >> 2] | 0;
 i29 = i40 + 132 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i40 + 136 | 0;
 HEAP32[i30 >> 2] = 0;
 i37 = i40 + 140 | 0;
 HEAP32[i37 >> 2] = 0;
 i3 = _UNITY_FT_Stream_Pos(i4) | 0;
 i2 = _UNITY_FT_Stream_ReadULong(i4, i34) | 0;
 i1 = HEAP32[i34 >> 2] | 0;
 L7 : do if (!i1) {
  i19 = i32 + 4 | 0;
  i20 = i32 + 8 | 0;
  i21 = i32 + 12 | 0;
  i22 = i32 + 16 | 0;
  i23 = i32 + 24 | 0;
  i24 = i32 + 28 | 0;
  i25 = i32 + 32 | 0;
  i26 = i32 + 36 | 0;
  i27 = i32 + 40 | 0;
  i33 = i40 + 104 | 0;
  i28 = i40 + 8 | 0;
  i18 = i4;
  L9 : while (1) {
   if ((i2 | 0) < 1953658213) {
    i6 = 89;
    break;
   }
   if ((i2 | 0) < 1954115633) {
    i6 = 95;
    break;
   }
   if ((i2 | 0) < 2001684038) {
    i6 = 101;
    break;
   }
   switch (i2 | 0) {
   case 2001684038:
    break;
   default:
    {
     i1 = 2;
     break L7;
    }
   }
   i1 = _UNITY_FT_Stream_Seek(i18, i3) | 0;
   HEAP32[i34 >> 2] = i1;
   if (i1 | 0) break L7;
   i16 = i18 + 28 | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   HEAP32[i36 >> 2] = 0;
   i1 = _UNITY_FT_Stream_ReadFields(i18, gb + 223896 | 0, i32) | 0;
   HEAP32[i36 >> 2] = i1;
   if (i1 | 0) {
    i6 = 60;
    break;
   }
   i1 = HEAP32[i19 >> 2] | 0;
   if ((i1 | 0) < 2001684038) switch (i1 | 0) {
   case 1953784678:
    {
     i1 = 8;
     i6 = 60;
     break L9;
    }
   default:
    {}
   } else switch (i1 | 0) {
   case 2001684038:
    {
     i1 = 8;
     i6 = 60;
     break L9;
    }
   default:
    {}
   }
   i1 = HEAP32[i20 >> 2] | 0;
   if ((i1 | 0) != (HEAP32[i18 + 4 >> 2] | 0)) {
    i1 = 8;
    i6 = 60;
    break;
   }
   i15 = HEAP16[i21 >> 1] | 0;
   i2 = i15 & 65535;
   if (!(i15 << 16 >> 16)) {
    i1 = 8;
    i6 = 60;
    break;
   }
   if (((i2 * 20 | 0) + 44 | 0) >>> 0 >= i1 >>> 0) {
    i1 = 8;
    i6 = 60;
    break;
   }
   i3 = HEAP32[i22 >> 2] | 0;
   if (!((i2 << 4 | 12) >>> 0 < i3 >>> 0 & (i3 & 3 | 0) == 0)) {
    i1 = 8;
    i6 = 60;
    break;
   }
   i1 = HEAP32[i24 >> 2] | 0;
   if (!(HEAP32[i23 >> 2] | 0)) {
    if (HEAP32[i25 >> 2] | i1 | 0) {
     i1 = 8;
     i6 = 60;
     break;
    }
   } else if ((i1 | 0) != 0 & (HEAP32[i25 >> 2] | 0) == 0) {
    i1 = 8;
    i6 = 60;
    break;
   }
   if (!((HEAP32[i26 >> 2] | 0) != 0 | (HEAP32[i27 >> 2] | 0) == 0)) {
    i1 = 8;
    i6 = 60;
    break;
   }
   i15 = _UNITY_ft_mem_alloc(i17, i3, i36) | 0;
   L30 : do if (!(HEAP32[i36 >> 2] | 0)) {
    i1 = _UNITY_ft_mem_alloc(i17, 40, i36) | 0;
    if (!(HEAP32[i36 >> 2] | 0)) {
     i14 = HEAP16[i21 >> 1] | 0;
     i4 = i14 & 65535;
     if (!(i14 << 16 >> 16)) i2 = 0; else {
      i3 = i4;
      i2 = 0;
      do {
       i3 = i3 >>> 1;
       i2 = i2 + 1 | 0;
      } while ((i3 | 0) != 0);
     }
     i7 = i2 + -1 | 0;
     i14 = 16 << i7;
     i3 = (i4 << 4) - i14 | 0;
     HEAP8[i15 >> 0] = (HEAP32[i19 >> 2] | 0) >>> 24;
     HEAP8[i15 + 1 >> 0] = (HEAP32[i19 >> 2] | 0) >>> 16;
     HEAP8[i15 + 2 >> 0] = (HEAP32[i19 >> 2] | 0) >>> 8;
     HEAP8[i15 + 3 >> 0] = HEAP32[i19 >> 2];
     HEAP8[i15 + 4 >> 0] = (HEAPU16[i21 >> 1] | 0) >>> 8;
     HEAP8[i15 + 5 >> 0] = HEAP16[i21 >> 1];
     HEAP8[i15 + 6 >> 0] = i14 >>> 8;
     HEAP8[i15 + 7 >> 0] = i14;
     HEAP8[i15 + 8 >> 0] = i7 >>> 8;
     HEAP8[i15 + 9 >> 0] = i7;
     HEAP8[i15 + 10 >> 0] = i3 >>> 8;
     i7 = i15 + 12 | 0;
     HEAP8[i15 + 11 >> 0] = i3;
     i3 = _UNITY_ft_mem_realloc(i17, 24, 0, HEAPU16[i21 >> 1] | 0, 0, i36) | 0;
     if (HEAP32[i36 >> 2] | 0) {
      i2 = 0;
      break;
     }
     i2 = _UNITY_ft_mem_realloc(i17, 4, 0, HEAPU16[i21 >> 1] | 0, 0, i36) | 0;
     if (HEAP32[i36 >> 2] | 0) break;
     i14 = _UNITY_FT_Stream_EnterFrame(i18, (HEAPU16[i21 >> 1] | 0) * 20 | 0) | 0;
     HEAP32[i36 >> 2] = i14;
     if (i14 | 0) break;
     L40 : do if (HEAP16[i21 >> 1] | 0) {
      i4 = 0;
      i5 = 0;
      while (1) {
       i6 = i3 + (i5 * 24 | 0) | 0;
       HEAP32[i6 >> 2] = _UNITY_FT_Stream_GetULong(i18) | 0;
       HEAP32[i3 + (i5 * 24 | 0) + 4 >> 2] = _UNITY_FT_Stream_GetULong(i18) | 0;
       HEAP32[i3 + (i5 * 24 | 0) + 8 >> 2] = _UNITY_FT_Stream_GetULong(i18) | 0;
       HEAP32[i3 + (i5 * 24 | 0) + 12 >> 2] = _UNITY_FT_Stream_GetULong(i18) | 0;
       HEAP32[i3 + (i5 * 24 | 0) + 16 >> 2] = _UNITY_FT_Stream_GetULong(i18) | 0;
       i14 = i4;
       i4 = HEAP32[i6 >> 2] | 0;
       if (i4 >>> 0 <= i14 >>> 0) break;
       HEAP32[i2 + (i5 << 2) >> 2] = i6;
       i5 = i5 + 1 | 0;
       if ((i5 | 0) >= (HEAPU16[i21 >> 1] | 0)) break L40;
      }
      _UNITY_FT_Stream_ExitFrame(i18);
      HEAP32[i36 >> 2] = 8;
      break L30;
     } while (0);
     _UNITY_FT_Stream_ExitFrame(i18);
     _qsort(i2, HEAPU16[i21 >> 1] | 0, 4, fb + 1077 | 0);
     i14 = HEAP16[i21 >> 1] | 0;
     i11 = i14 & 65535;
     i5 = (i11 * 20 | 0) + 44 | 0;
     i4 = i11 << 4 | 12;
     i14 = i14 << 16 >> 16 == 0;
     L46 : do if (!i14) {
      i12 = HEAP32[i20 >> 2] | 0;
      i13 = HEAP32[i22 >> 2] | 0;
      i10 = 0;
      while (1) {
       i6 = HEAP32[i2 + (i10 << 2) >> 2] | 0;
       if ((HEAP32[i6 + 4 >> 2] | 0) != (i5 | 0)) break;
       i8 = HEAP32[i6 + 8 >> 2] | 0;
       if (i12 >>> 0 < i8 >>> 0 | i5 >>> 0 > (i12 - i8 | 0) >>> 0) break;
       i9 = HEAP32[i6 + 12 >> 2] | 0;
       if (i8 >>> 0 > i9 >>> 0 | (i13 >>> 0 < i9 >>> 0 | i4 >>> 0 > (i13 - i9 | 0) >>> 0)) break;
       HEAP32[i6 + 20 >> 2] = i4;
       i5 = (i8 + 3 & -4) + i5 | 0;
       i4 = (i9 + 3 & -4) + i4 | 0;
       i10 = i10 + 1 | 0;
       if ((i10 | 0) >= (i11 | 0)) break L46;
      }
      HEAP32[i36 >> 2] = 8;
      break L30;
     } while (0);
     i6 = HEAP32[i23 >> 2] | 0;
     do if (i6) {
      if ((i6 | 0) == (i5 | 0)) {
       i5 = (HEAP32[i24 >> 2] | 0) + i5 | 0;
       if (i5 >>> 0 <= (HEAP32[i20 >> 2] | 0) >>> 0) break;
      }
      HEAP32[i36 >> 2] = 8;
      break L30;
     } while (0);
     i6 = HEAP32[i26 >> 2] | 0;
     do if (!i6) i6 = HEAP32[i20 >> 2] | 0; else {
      if ((i6 | 0) == (i5 + 3 & -4 | 0)) {
       i5 = (HEAP32[i27 >> 2] | 0) + i6 | 0;
       i6 = HEAP32[i20 >> 2] | 0;
       if (i5 >>> 0 <= i6 >>> 0) break;
      }
      HEAP32[i36 >> 2] = 8;
      break L30;
     } while (0);
     if (!((i5 | 0) == (i6 | 0) ? (i4 | 0) == (HEAP32[i22 >> 2] | 0) : 0)) {
      HEAP32[i36 >> 2] = 8;
      break;
     }
     do if (!i14) {
      i9 = i18 + 32 | 0;
      i8 = 0;
      while (1) {
       i5 = i3 + (i8 * 24 | 0) | 0;
       HEAP8[i7 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 24;
       HEAP8[i7 + 1 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 16;
       HEAP8[i7 + 2 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 8;
       HEAP8[i7 + 3 >> 0] = HEAP32[i5 >> 2];
       i5 = i3 + (i8 * 24 | 0) + 16 | 0;
       HEAP8[i7 + 4 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 24;
       HEAP8[i7 + 5 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 16;
       HEAP8[i7 + 6 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 8;
       HEAP8[i7 + 7 >> 0] = HEAP32[i5 >> 2];
       i5 = i3 + (i8 * 24 | 0) + 20 | 0;
       HEAP8[i7 + 8 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 24;
       HEAP8[i7 + 9 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 16;
       HEAP8[i7 + 10 >> 0] = (HEAP32[i5 >> 2] | 0) >>> 8;
       HEAP8[i7 + 11 >> 0] = HEAP32[i5 >> 2];
       i6 = i3 + (i8 * 24 | 0) + 12 | 0;
       HEAP8[i7 + 12 >> 0] = (HEAP32[i6 >> 2] | 0) >>> 24;
       HEAP8[i7 + 13 >> 0] = (HEAP32[i6 >> 2] | 0) >>> 16;
       HEAP8[i7 + 14 >> 0] = (HEAP32[i6 >> 2] | 0) >>> 8;
       HEAP8[i7 + 15 >> 0] = HEAP32[i6 >> 2];
       i7 = i7 + 16 | 0;
       i14 = _UNITY_FT_Stream_Seek(i18, HEAP32[i3 + (i8 * 24 | 0) + 4 >> 2] | 0) | 0;
       HEAP32[i36 >> 2] = i14;
       if (i14 | 0) break L30;
       i4 = i3 + (i8 * 24 | 0) + 8 | 0;
       i14 = _UNITY_FT_Stream_EnterFrame(i18, HEAP32[i4 >> 2] | 0) | 0;
       HEAP32[i36 >> 2] = i14;
       if (i14 | 0) break L30;
       i4 = HEAP32[i4 >> 2] | 0;
       if ((i4 | 0) != (HEAP32[i6 >> 2] | 0)) {
        i6 = 53;
        break;
       }
       _memcpy(i15 + (HEAP32[i5 >> 2] | 0) | 0, HEAP32[i9 >> 2] | 0, i4 | 0) | 0;
       _UNITY_FT_Stream_ExitFrame(i18);
       i4 = (HEAP32[i6 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0;
       if (i4 & 3 | 0) do {
        HEAP8[i15 + i4 >> 0] = 0;
        i4 = i4 + 1 | 0;
       } while ((i4 & 3 | 0) != 0);
       i8 = i8 + 1 | 0;
       if ((i8 | 0) >= (HEAPU16[i21 >> 1] | 0)) {
        i6 = 56;
        break;
       }
      }
      if ((i6 | 0) == 53) {
       HEAP32[i36 >> 2] = 7;
       break L30;
      } else if ((i6 | 0) == 56) {
       i4 = HEAP32[i22 >> 2] | 0;
       break;
      }
     } while (0);
     _UNITY_FT_Stream_OpenMemory(i1, i15, i4);
     HEAP32[i1 + 28 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i1 + 24 >> 2] = fb + 3853;
     _UNITY_FT_Stream_Free(HEAP32[i33 >> 2] | 0, (HEAP32[i28 >> 2] | 0) >>> 10 & 1);
     HEAP32[i33 >> 2] = i1;
     HEAP32[i28 >> 2] = HEAP32[i28 >> 2] & -1025;
    } else {
     i3 = 0;
     i2 = 0;
    }
   } else {
    i3 = 0;
    i2 = 0;
    i1 = 0;
   } while (0);
   _UNITY_ft_mem_free(i17, i3);
   _UNITY_ft_mem_free(i17, i2);
   if (!(HEAP32[i36 >> 2] | 0)) HEAP32[i34 >> 2] = 0; else {
    _UNITY_ft_mem_free(i17, i15);
    _UNITY_FT_Stream_Close(i1);
    _UNITY_ft_mem_free(i17, i1);
    i1 = HEAP32[i36 >> 2] | 0;
    HEAP32[i34 >> 2] = i1;
    if (i1 | 0) break L7;
   }
   i2 = HEAP32[i33 >> 2] | 0;
   i4 = _UNITY_FT_Stream_Pos(i2) | 0;
   i3 = _UNITY_FT_Stream_ReadULong(i2, i34) | 0;
   i1 = HEAP32[i34 >> 2] | 0;
   if (!i1) {
    i18 = i2;
    i2 = i3;
    i3 = i4;
   } else break L7;
  }
  L91 : do if ((i6 | 0) == 60) {
   HEAP32[i34 >> 2] = i1;
   break L7;
  } else if ((i6 | 0) == 89) {
   if ((i2 | 0) < 131072) switch (i2 | 0) {
   case 65536:
    break L91;
   default:
    {
     i1 = 2;
     break L7;
    }
   }
   if ((i2 | 0) < 1330926671) switch (i2 | 0) {
   case 131072:
    break L91;
   default:
    {
     i1 = 2;
     break L7;
    }
   } else switch (i2 | 0) {
   case 1330926671:
    break L91;
   default:
    {
     i1 = 2;
     break L7;
    }
   }
  } else if ((i6 | 0) == 95) if ((i2 | 0) < 1953784678) switch (i2 | 0) {
  case 1953658213:
   break L91;
  default:
   {
    i1 = 2;
    break L7;
   }
  } else switch (i2 | 0) {
  case 1953784678:
   break L91;
  default:
   {
    i1 = 2;
    break L7;
   }
  } else if ((i6 | 0) == 101) switch (i2 | 0) {
  case 1954115633:
   break;
  default:
   {
    i1 = 2;
    break L7;
   }
  } while (0);
  HEAP32[i29 >> 2] = 1953784678;
  if ((i2 | 0) == 1953784678) {
   i1 = _UNITY_FT_Stream_ReadFields(i18, gb + 223956 | 0, i29) | 0;
   HEAP32[i34 >> 2] = i1;
   if (i1 | 0) break;
   i1 = HEAP32[i37 >> 2] | 0;
   if (!i1) {
    i1 = 8;
    break;
   }
   if (i1 >>> 0 > (HEAP32[i18 + 4 >> 2] | 0) >>> 5 >>> 0) {
    i1 = 10;
    break;
   }
   i2 = i40 + 144 | 0;
   HEAP32[i2 >> 2] = _UNITY_ft_mem_realloc(i31, 4, 0, i1, 0, i34) | 0;
   i1 = HEAP32[i34 >> 2] | 0;
   if (i1 | 0) break;
   i1 = _UNITY_FT_Stream_EnterFrame(i18, HEAP32[i37 >> 2] << 2) | 0;
   HEAP32[i34 >> 2] = i1;
   if (i1 | 0) break;
   if ((HEAP32[i37 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     i32 = _UNITY_FT_Stream_GetULong(i18) | 0;
     HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i32;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i37 >> 2] | 0));
   }
   _UNITY_FT_Stream_ExitFrame(i18);
   i1 = HEAP32[i34 >> 2] | 0;
   HEAP32[i38 >> 2] = i1;
   if (i1 | 0) {
    i40 = i1;
    STACKTOP = i41;
    return i40 | 0;
   }
  } else {
   HEAP32[i30 >> 2] = 65536;
   HEAP32[i37 >> 2] = 1;
   i2 = _UNITY_ft_mem_alloc(i31, 4, i34) | 0;
   HEAP32[i40 + 144 >> 2] = i2;
   i1 = HEAP32[i34 >> 2] | 0;
   if (i1 | 0) break;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i38 >> 2] = 0;
  }
  i4 = HEAP32[i33 >> 2] | 0;
  i2 = (i39 | 0) < 0 ? 0 - i39 | 0 : i39;
  i1 = i2 & 65535;
  if ((i1 | 0) < (HEAP32[i37 >> 2] | 0)) i5 = i1; else if ((i39 | 0) > -1) {
   i40 = 6;
   STACKTOP = i41;
   return i40 | 0;
  } else i5 = 0;
  i1 = _UNITY_FT_Stream_Seek(i4, HEAP32[(HEAP32[i40 + 144 >> 2] | 0) + (i5 << 2) >> 2] | 0) | 0;
  HEAP32[i38 >> 2] = i1;
  if (i1 | 0) {
   i40 = i1;
   STACKTOP = i41;
   return i40 | 0;
  }
  i1 = mftCall_iii(HEAP32[i35 + 88 >> 2] | 0, i40 | 0, i4 | 0) | 0;
  HEAP32[i38 >> 2] = i1;
  if (i1 | 0) {
   i40 = i1;
   STACKTOP = i41;
   return i40 | 0;
  }
  i3 = i2 >> 16;
  i35 = (mftCall_iiiii(HEAP32[i40 + 508 >> 2] | 0, i40 | 0, 1719034226, i4 | 0, i36 | 0) | 0) != 0;
  if (i35 | (HEAP32[i36 >> 2] | 0) >>> 0 < 20) {
   i1 = 0;
   i2 = 0;
   i6 = 84;
  } else {
   i2 = _UNITY_FT_Stream_Skip(i4, 12) | 0;
   HEAP32[i38 >> 2] = i2;
   if (!i2) {
    i1 = _UNITY_FT_Stream_ReadUShort(i4, i38) | 0;
    i2 = HEAP32[i38 >> 2] | 0;
    if (!i2) if ((i1 & 65535) > 32766) {
     if ((i39 | 0) <= -1) {
      i1 = 0;
      i2 = 0;
      i6 = 84;
     }
    } else {
     i2 = 0;
     i6 = 84;
    } else {
     i1 = 0;
     i6 = 84;
    }
   } else {
    i1 = 0;
    i6 = 84;
   }
  }
  do if ((i6 | 0) == 84) {
   if ((i3 | 0) > (i1 & 65535 | 0)) if ((i39 | 0) > -1) break; else i1 = 0;
   HEAP32[i40 + 12 >> 2] = (i1 & 65535) << 16;
   HEAP32[i40 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i40 + 4 >> 2] = i5;
   i40 = i2;
   STACKTOP = i41;
   return i40 | 0;
  } while (0);
  i40 = 6;
  STACKTOP = i41;
  return i40 | 0;
 } while (0);
 HEAP32[i38 >> 2] = i1;
 i40 = i1;
 STACKTOP = i41;
 return i40 | 0;
}

function __ZN9ShaderLab21SerializedShaderState8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i9 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i9 + 16 | 0, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i9 + 32 | 0, 0);
 i7 = i3 + 16 | 0;
 i4 = i3 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i5 = i6 + 11 | 0;
 i1 = 0;
 do {
  i10 = i2 + 64 + (i1 * 56 | 0) | 0;
  HEAP32[i8 >> 2] = i1;
  __Z6FormatPKcz(i6, gb + 471386 | 0, i8);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, gb + 471396 | 0, i10, 0);
  __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i3);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471370 | 0, HEAP32[gb + 36972 >> 2] | 0, i2 + 717 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 i6 = i2 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471529 | 0, gb + 471434 | 0, i6, 0);
 i10 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471535 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471542 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471550 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471563 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471575 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 512 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471587 | 0, gb + 471597 | 0, i6, 0);
 __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 544 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471617 | 0, gb + 471597 | 0, i6, 0);
 __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 576 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471632 | 0, gb + 471597 | 0, i6, 0);
 __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 608 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471646 | 0, gb + 471434 | 0, i6, 0);
 i10 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 612 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 616 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471662 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 620 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 624 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471679 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 628 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 632 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471690 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 636 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 640 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471699 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 644 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 648 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471706 | 0, gb + 471434 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471805 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 652 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1037646 | 0, gb + 469407 | 0, i6, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 656 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471717 | 0, gb + 471726 | 0, i6, 0);
 __ZN9ShaderLab27SerializedShaderVectorValue8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i6 = i2 + 692 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471754 | 0, i10, i8, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471762 | 0, i10, i2 + 696 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 470710 | 0, gb + 470717 | 0, i2 + 700 | 0, 0);
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i6 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 470740 | 0, HEAP32[gb + 37052 >> 2] | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i8, HEAP32[i6 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 470734 | 0, i10, i2 + 712 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 471775 | 0, HEAP32[gb + 36972 >> 2] | 0, i2 + 716 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 STACKTOP = i9;
 return;
}

function __ZN5Light8TransferI14SafeBinaryReadEEvRT_(i9, i12) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i6 = i14 + 4 | 0;
 __ZNK5Light16UnshareLightDataEv(i9);
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i9, i12);
 __ZN14SafeBinaryRead10SetVersionEi(i12, 7);
 i13 = i9 + 44 | 0;
 i5 = (HEAP32[i13 >> 2] | 0) + 40 | 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 913271 | 0, i8, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i11 = 6; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i11 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = (HEAP32[i13 >> 2] | 0) + 20 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i12); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = (HEAP32[i13 >> 2] | 0) + 44 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374199 | 0, i7, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i4 >>> 0) i11 = 23; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 23; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i11 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = (HEAP32[i13 >> 2] | 0) + 48 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 426256 | 0, i7, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i4 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i11 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 34; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = (HEAP32[i13 >> 2] | 0) + 60 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374211 | 0, i7, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i4 >>> 0) i11 = 45; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 45; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i11 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 2) | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i5) HEAPF32[i2 + 64 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 60 >> 2]) * Math_fround(2.0)); else {
  i5 = i2 + 64 | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374223 | 0, i7, i10, 0) | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 0) {
    i2 = i12 + 16 | 0;
    i4 = HEAP32[i12 + 20 >> 2] | 0;
    i3 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    if (i3 >>> 0 < i4 >>> 0) i11 = 58; else {
     i4 = i3 + 4 | 0;
     if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 58; else {
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i2 >> 2] = i4;
     }
    }
    if ((i11 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
    if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i2 = HEAP32[i10 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i3 = i2 + 96 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374236 | 0, gb + 374246 | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14ShadowSettings8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = (HEAP32[i13 >> 2] | 0) + 92 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374261 | 0, gb + 944590 | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = (HEAP32[i13 >> 2] | 0) + 85 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374270 | 0, i5, i10, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i15 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 >= i15 >>> 0) if ((i3 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 6) | 0) {
  HEAP8[i6 >> 0] = (HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] | 0) >>> 31 & 255 ^ 1;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374281 | 0, i5, i10, 0) | 0;
  if (i2 | 0) {
   do if ((i2 | 0) > 0) {
    i2 = i12 + 16 | 0;
    i15 = HEAP32[i12 + 20 >> 2] | 0;
    i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    if (i3 >>> 0 >= i15 >>> 0) {
     i4 = i3 + 1 | 0;
     if (i4 >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i6 >> 0] = HEAP8[i3 >> 0] | 0;
      HEAP32[i2 >> 2] = i4;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 1);
   } else {
    i2 = HEAP32[i10 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i6 | 0, i12 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] = HEAP8[i6 >> 0] | 0 ? -1 : -2;
 } else {
  i5 = (HEAP32[i13 >> 2] | 0) + 88 | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374303 | 0, i8, i10, 0) | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 0) {
    i2 = i12 + 16 | 0;
    i15 = HEAP32[i12 + 20 >> 2] | 0;
    i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    if (i3 >>> 0 < i15 >>> 0) i11 = 102; else {
     i4 = i3 + 4 | 0;
     if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 102; else {
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i2 >> 2] = i4;
     }
    }
    if ((i11 | 0) == 102) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
    if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i2 = HEAP32[i10 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 }
 i3 = i9 + 48 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 373697 | 0, gb + 373705 | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4PPtrI5FlareE8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = (HEAP32[i13 >> 2] | 0) + 76 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1011343 | 0, i8, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i15 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i15 >>> 0) i11 = 120; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 120; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i11 | 0) == 120) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i12, (HEAP32[i13 >> 2] | 0) + 36 | 0, gb + 381098 | 0, 0);
 i5 = (HEAP32[i13 >> 2] | 0) + 80 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374316 | 0, i8, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i15 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i15 >>> 0) i11 = 131; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 131; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i11 | 0) == 131) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = (HEAP32[i13 >> 2] | 0) + 52 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374331 | 0, HEAP32[gb + 37320 >> 2] | 0, i10, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i3, i12); else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i9 + 52 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 374342 | 0, i7, i10, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i12 + 16 | 0;
   i15 = HEAP32[i12 + 20 >> 2] | 0;
   i3 = i15 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i15 >>> 0) i11 = 148; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     i11 = 148;
     break;
    }
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i11 | 0) == 148) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 5) | 0)) {
  STACKTOP = i14;
  return;
 }
 i15 = (__Z19GetActiveColorSpacev() | 0) == 1;
 i2 = (HEAP32[i13 >> 2] | 0) + 44 | 0;
 f1 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
 if (!i15) {
  HEAPF32[i2 >> 2] = f1;
  STACKTOP = i14;
  return;
 }
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) {
   f1 = Math_fround(1.0);
   break;
  }
  f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 HEAPF32[i2 >> 2] = f1;
 STACKTOP = i14;
 return;
}

function __ZN5physx28createFinalizeSolverContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE(i53, i49, i1, i3, i51, i54, i55, i56, i57, i4, i5, f52, f50, f34, f33, i35, i2) {
 i53 = i53 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i51 = i51 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f52 = Math_fround(f52);
 f50 = Math_fround(f50);
 f34 = Math_fround(f34);
 f33 = Math_fround(f33);
 i35 = i35 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i48 + 24 | 0;
 i31 = i48 + 52 | 0;
 i46 = i48 + 12 | 0;
 i47 = i48;
 i1 = i3 & 1;
 i44 = i49 + 384 | 0;
 HEAP16[i51 + 26 >> 1] = 0;
 i32 = i49 + 4480 | 0;
 HEAP32[i32 >> 2] = 0;
 i37 = i53 + 40 | 0;
 HEAPF32[i42 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i42 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i42 + 24 >> 2] = Math_fround(0.0);
 i45 = i53 + 22 | 0;
 i30 = HEAP16[i45 >> 1] | 0;
 i43 = (i30 & 32) == 0 ? i42 : i4;
 i42 = (i30 & 64) == 0 ? i42 : i5;
 i4 = HEAP32[i53 + 28 >> 2] | 0;
 do if (i4 | 0) {
  i24 = HEAP32[i53 + 32 >> 2] | 0;
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i31 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i31 + 36 >> 2] = i24;
  i25 = i31 + 40 | 0;
  HEAP32[i25 >> 2] = 0;
  i26 = i31 + 44 | 0;
  HEAP32[i26 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = i4;
  i27 = i4;
  if (!i24) {
   i28 = 0;
   i29 = 0;
   i5 = 0;
   i2 = 0;
   i30 = 0;
   i3 = 1;
  } else {
   i3 = HEAP16[i4 + 2 >> 1] | 0;
   i2 = i3 & 65535;
   i5 = i2 & 2;
   i30 = (i5 | 0) != 0;
   i2 = i2 & 1;
   i28 = i30 ? 4 : 32;
   i29 = i30 ? 72 : i2 << 3 | 16;
   i5 = i4 + (i5 << 3 | 4) | 0;
   i2 = (i2 | 0) != 0;
   i3 = (i3 & 4) != 0;
  }
  HEAP32[i31 + 60 >> 2] = i30 & 1;
  HEAP32[i31 + 56 >> 2] = i2 & 1;
  HEAP32[i31 + 64 >> 2] = i3 & 1;
  HEAP32[i31 + 48 >> 2] = i28;
  HEAP32[i31 + 52 >> 2] = i29;
  i21 = i31 + 24 | 0;
  HEAP32[i21 >> 2] = i5;
  i22 = i31 + 28 | 0;
  HEAP32[i22 >> 2] = i5;
  i23 = i31 + 16 | 0;
  HEAP32[i23 >> 2] = i5;
  i2 = i5;
  if (i3) break;
  if (i30) {
   f39 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f41 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f40 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f38 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  } else {
   f39 = Math_fround(1.0);
   f40 = Math_fround(1.0);
   f41 = Math_fround(1.0);
   f38 = Math_fround(1.0);
  }
  if ((i2 - i27 | 0) >>> 0 >= i24 >>> 0) {
   HEAP32[i32 >> 2] = 0;
   break;
  }
  i20 = i31 + 32 | 0;
  i4 = i2;
  i6 = 0;
  i3 = i2;
  i7 = 0;
  i8 = 0;
  i9 = i2;
  i10 = 0;
  while (1) {
   HEAP32[i21 >> 2] = i5;
   if ((i9 - i27 | 0) >>> 0 < i24 >>> 0) {
    i8 = HEAPU16[i5 >> 1] | 0;
    HEAP32[i25 >> 2] = i8;
    i19 = i5 + ((Math_imul(i29, i8) | 0) + i28) | 0;
    HEAP32[i22 >> 2] = i19;
    i3 = i5 + i28 | 0;
    HEAP32[i23 >> 2] = i3;
    HEAP32[i26 >> 2] = 0;
    i4 = i3;
    i6 = 0;
    i2 = 0;
   } else {
    HEAP32[i22 >> 2] = i5;
    i2 = i7;
    i19 = i5;
   }
   i13 = i5 + 4 | 0;
   i14 = i5 + 28 | 0;
   i15 = i5 + 30 | 0;
   i16 = i5 + 2 | 0;
   i17 = i5 + 16 | 0;
   i18 = i5 + 20 | 0;
   i11 = i5 + 24 | 0;
   L21 : while (1) {
    if (i30) {
     i5 = i6;
     while (1) {
      if (i2 >>> 0 >= i8 >>> 0) break L21;
      i2 = i2 + 1 | 0;
      HEAP32[i26 >> 2] = i2;
      HEAP32[i20 >> 2] = i3;
      i4 = i3 + i29 | 0;
      HEAP32[i23 >> 2] = i4;
      i5 = i3;
      f12 = Math_fround(HEAPF32[i5 + 48 >> 2]);
      if (f12 != Math_fround(0.0)) break; else {
       i3 = i4;
       i5 = i2;
      }
     }
     i6 = i30 ? i5 + 24 | 0 : i13;
     i7 = i4;
     i9 = i2;
    } else {
     if (i6 >>> 0 >= i8 >>> 0) {
      i5 = i6;
      i2 = i6;
      break;
     }
     i9 = i6 + 1 | 0;
     HEAP32[i26 >> 2] = i9;
     HEAP32[i20 >> 2] = i4;
     i7 = i4 + i29 | 0;
     HEAP32[i23 >> 2] = i7;
     i3 = i4;
     i6 = i13;
     i5 = i4;
     f12 = Math_fround(3402823469999999843913219.0e14);
    }
    i4 = i3;
    HEAP32[i49 + 384 + (i10 << 6) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 16 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 20 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 24 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 48 >> 2] = (HEAPU16[(i30 ? i5 + 66 | 0 : i15) >> 1] | 0) << 16 | (HEAPU16[(i30 ? i5 + 64 | 0 : i14) >> 1] | 0);
    if (i30) i2 = HEAP32[i5 + 68 >> 2] | 0; else i2 = HEAPU16[i16 >> 1] | 0;
    HEAP32[i49 + 384 + (i10 << 6) + 52 >> 2] = i2;
    HEAPF32[i49 + 384 + (i10 << 6) + 28 >> 2] = f12;
    HEAP32[i49 + 384 + (i10 << 6) + 44 >> 2] = HEAP32[(i30 ? i5 + 52 | 0 : i17) >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 56 >> 2] = HEAP32[(i30 ? i5 + 56 | 0 : i18) >> 2];
    HEAP32[i49 + 384 + (i10 << 6) + 60 >> 2] = HEAP32[(i30 ? i5 + 60 | 0 : i11) >> 2];
    i2 = i30 ? i5 + 36 | 0 : i31;
    HEAP32[i49 + 384 + (i10 << 6) + 32 >> 2] = HEAP32[i2 >> 2];
    i3 = i2 + 4 | 0;
    HEAP32[i49 + 384 + (i10 << 6) + 36 >> 2] = HEAP32[i3 >> 2];
    i4 = i2 + 8 | 0;
    HEAP32[i49 + 384 + (i10 << 6) + 40 >> 2] = HEAP32[i4 >> 2];
    if (i30) {
     if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) i2 = Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0); else i2 = 0; else i2 = 0;
     i2 = i2 ^ 1;
    } else i2 = 0;
    i1 = (i2 & 1 | i1 & 1) & 255;
    i4 = i7;
    i3 = i7;
    i2 = i9;
    i6 = i9;
    i10 = i10 + 1 | 0;
   }
   i9 = i19;
   if ((i9 - i27 | 0) >>> 0 >= i24 >>> 0) {
    i16 = i10;
    break;
   } else {
    i6 = i5;
    i7 = i2;
    i5 = i19;
   }
  }
  HEAP32[i32 >> 2] = i16;
  i19 = (i1 & 1) != 0;
  if (i16 | 0) {
   i18 = i49 + 4496 | 0;
   i17 = i49 + 8728 | 0;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i49 + 8724 >> 2] = 0;
   if (!i19) if (!(HEAP16[i45 >> 1] & 4)) __ZL18getFrictionPatchesRN5physx26PxcFrictionPatchStreamPairERNS_20PxcCorrelationBufferEPKhjRKNS_11PxTransformES8_f(i18, HEAP32[i37 >> 2] | 0, HEAP32[i53 + 36 >> 2] | 0, i43, i42, f33) | 0;
   __ZN5physx20createContactPatchesERNS_18PxcNpThreadContextEjf(i49, 0, Math_fround(.999000012)) | 0;
   __ZN5physx16correlatePatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjj(i18, i44, i43, i42, Math_fround(.999000012), 0, 0) | 0;
   __ZN5physx11growPatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjf(i18, i44, i43, i42, f33, 0, f34);
   i8 = HEAP16[i45 >> 1] | 0;
   i1 = (i8 & 24) != 0;
   i7 = HEAP32[i17 >> 2] | 0;
   if (!i7) {
    i14 = 0;
    i13 = 0;
    i1 = 0;
   } else {
    i6 = i1 ? 112 : 80;
    if (i1) {
     i2 = 0;
     i5 = 0;
     i3 = 0;
     i1 = 0;
     do {
      i3 = ((HEAP32[i49 + 8464 + (i5 << 2) >> 2] | 0) != 65535 & 1) + i3 | 0;
      i4 = HEAP32[i49 + 8336 + (i5 << 2) >> 2] | 0;
      if (i4) {
       i1 = i1 + 32 + (Math_imul(i4, i6) | 0) | 0;
       i2 = i4 + i2 | 0;
       if (!(HEAP16[i49 + 5264 + (i5 * 96 | 0) + 22 >> 1] & 1)) {
        i32 = HEAPU16[i49 + 5264 + (i5 * 96 | 0) + 16 >> 1] | 0;
        i2 = (i32 << 1) + i2 | 0;
        i1 = (i32 << 8) + i1 | 0;
       }
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i7 | 0));
     i14 = i2;
     i13 = i3;
    } else {
     i2 = 0;
     i5 = 0;
     i3 = 0;
     i1 = 0;
     do {
      i3 = ((HEAP32[i49 + 8464 + (i5 << 2) >> 2] | 0) != 65535 & 1) + i3 | 0;
      i4 = HEAP32[i49 + 8336 + (i5 << 2) >> 2] | 0;
      if (i4) {
       i1 = i1 + 32 + (Math_imul(i4, i6) | 0) | 0;
       i2 = i4 + i2 | 0;
       if (!(HEAP16[i49 + 5264 + (i5 * 96 | 0) + 22 >> 1] & 1)) {
        i32 = HEAPU16[i49 + 5264 + (i5 * 96 | 0) + 16 >> 1] | 0;
        i2 = (i32 << 1) + i2 | 0;
        i1 = (i32 * 192 | 0) + i1 | 0;
       }
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i7 | 0));
     i14 = i2;
     i13 = i3;
    }
   }
   i10 = i13 * 96 | 0;
   i15 = (i8 & 130) == 0 ? 0 : i1 + 15 & -16;
   i11 = (i15 | 0) == 0;
   if (i11) i7 = 0; else {
    i2 = i49 + 316 | 0;
    i3 = i15 + 31 & -16;
    do if (i3 >>> 0 > 16384) i1 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i2 >> 2] | 0, i3) | 0; else {
     i4 = i49 + 320 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i1 = i49 + 324 | 0;
     if (i5 | 0) {
      i6 = HEAP32[i1 >> 2] | 0;
      i7 = i6 + i3 | 0;
      if (i7 >>> 0 <= 16384) {
       HEAP32[i1 >> 2] = i7;
       i1 = i5 + i6 | 0;
       break;
      }
     }
     i35 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i2 >> 2] | 0, i35) | 0;
     HEAP32[i4 >> 2] = i35;
     HEAP32[i1 >> 2] = i3;
     i1 = i35;
    } while (0);
    i7 = (i1 | 0) == 0 | (i1 | 0) != (-1 | 0) ? i1 : 0;
   }
   i8 = (i10 | 0) == 0;
   i5 = (i7 | 0) != 0;
   i9 = i11 | i5;
   if (i9 & (i8 ^ 1)) {
    do if (i10 >>> 0 > 16384) i1 = -1; else {
     i3 = i49 + 348 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     i4 = i49 + 352 | 0;
     if (!i1) i36 = 58; else {
      i2 = HEAP32[i4 >> 2] | 0;
      if ((i2 + i10 | 0) >>> 0 > 16384) i36 = 58;
     }
     if ((i36 | 0) == 58) {
      i1 = __ZN5physx17PxcNpMemBlockPool20acquireFrictionBlockEv(HEAP32[i49 + 344 >> 2] | 0) | 0;
      HEAP32[i3 >> 2] = i1;
      HEAP32[i4 >> 2] = 0;
      if (!i1) {
       i1 = 0;
       break;
      } else i2 = 0;
     }
     HEAP32[i4 >> 2] = i2 + i10;
     i1 = i1 + i2 | 0;
    } while (0);
    i6 = (i1 | 0) == 0 | (i1 | 0) != (-1 | 0) ? i1 : 0;
   } else i6 = 0;
   i2 = i6;
   i7 = i11 | i5 ^ 1 ? 0 : i7;
   i36 = i49 + 8764 | 0;
   HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + i15;
   if (i9) i5 = i8 | (i6 | 0) != 0; else i5 = 0;
   HEAP32[i37 >> 2] = 0;
   HEAP32[i53 >> 2] = 0;
   i1 = i53 + 20 | 0;
   HEAP16[i1 >> 1] = 0;
   i3 = i53 + 36 | 0;
   HEAP32[i3 >> 2] = 0;
   i4 = i53 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   i36 = i53 + 16 | 0;
   HEAP16[i36 >> 1] = (HEAPU16[i36 >> 1] | 0) + i14;
   if (!i5) {
    i57 = 0;
    STACKTOP = i48;
    return i57 | 0;
   }
   HEAP32[i37 >> 2] = i2;
   HEAP32[i53 >> 2] = i7;
   HEAP16[i1 >> 1] = i16;
   HEAP32[i3 >> 2] = i13;
   HEAP32[i4 >> 2] = i15;
   if (i6 | 0) {
    i1 = HEAP32[i17 >> 2] | 0;
    if (i1 | 0) {
     i3 = 0;
     do {
      if (HEAP32[i49 + 8336 + (i3 << 2) >> 2] | 0) {
       HEAP8[i2 >> 0] = HEAP8[i49 + 5264 + (i3 * 96 | 0) >> 0] | 0;
       HEAP16[i2 + 16 >> 1] = HEAP16[i49 + 5264 + (i3 * 96 | 0) + 16 >> 1] | 0;
       HEAP32[i2 + 24 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 24 >> 2];
       HEAP32[i2 + 28 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 28 >> 2];
       HEAP32[i2 + 32 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 32 >> 2];
       HEAP32[i2 + 36 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 36 >> 2];
       HEAP32[i2 + 40 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 40 >> 2];
       HEAP32[i2 + 44 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 44 >> 2];
       HEAP32[i2 + 48 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 48 >> 2];
       HEAP32[i2 + 52 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 52 >> 2];
       HEAP32[i2 + 56 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 56 >> 2];
       HEAP32[i2 + 60 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 60 >> 2];
       HEAP32[i2 + 64 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 64 >> 2];
       HEAP32[i2 + 68 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 68 >> 2];
       HEAP32[i2 + 72 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 72 >> 2];
       HEAP32[i2 + 76 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 76 >> 2];
       HEAP32[i2 + 80 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 80 >> 2];
       HEAP32[i2 + 84 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 84 >> 2];
       HEAP32[i2 + 88 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 88 >> 2];
       HEAP32[i2 + 92 >> 2] = HEAP32[i49 + 5264 + (i3 * 96 | 0) + 92 >> 2];
       HEAP16[i2 + 20 >> 1] = HEAP16[i49 + 5264 + (i3 * 96 | 0) + 20 >> 1] | 0;
       HEAP16[i2 + 18 >> 1] = HEAP16[i49 + 5264 + (i3 * 96 | 0) + 18 >> 1] | 0;
       HEAP16[i2 + 22 >> 1] = HEAP16[i49 + 5264 + (i3 * 96 | 0) + 22 >> 1] | 0;
       i1 = HEAP32[i17 >> 2] | 0;
       i2 = i2 + 96 | 0;
      }
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i1 >>> 0);
    }
   }
   i1 = i7;
   if (!i7) {
    i57 = 1;
    STACKTOP = i48;
    return i57 | 0;
   }
   if (!(HEAP16[i45 >> 1] & 24)) __ZN5physx30setupFinalizeSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff(i53, i44, i18, i43, i42, i19, i1, i54, i55, i56, i57, f52, f50, f39, f40, f41, f38); else {
    i49 = HEAP16[i51 + 8 >> 1] | 0;
    HEAP32[i46 >> 2] = i54;
    HEAP32[i46 + 4 >> 2] = i56;
    HEAP16[i46 + 8 >> 1] = i49;
    i54 = HEAP16[i51 + 12 >> 1] | 0;
    HEAP32[i47 >> 2] = i55;
    HEAP32[i47 + 4 >> 2] = i57;
    HEAP16[i47 + 8 >> 1] = i54;
    __ZN5physx33setupFinalizeExtSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_16PxsSolverExtBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff(i53, i44, i18, i43, i42, i19, i1, i46, i47, i56, i57, f52, f50, f39, f40, f41, f38);
   }
   HEAP32[i1 + i15 >> 2] = 0;
   i57 = 1;
   STACKTOP = i48;
   return i57 | 0;
  }
 } while (0);
 HEAP32[i37 >> 2] = 0;
 HEAP32[i53 + 36 >> 2] = 0;
 HEAP16[i53 + 20 >> 1] = 0;
 HEAP32[i51 + 16 >> 2] = 0;
 i57 = 1;
 STACKTOP = i48;
 return i57 | 0;
}

function __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 108 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 116 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 120 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 124 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 128 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 132 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 136 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 140 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 144 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 148 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 152 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 156 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 160 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 164 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 172 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 176 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 180 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 184 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 188 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 192 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 196 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 200 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 204 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 208 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 212 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 216 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 220 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i27, i28, i38, i49, i1, i2, i76, i77, i78, i79) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i38 = i38 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i76 = i76 | 0;
 i77 = i77 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i80 = 0, f81 = f0, f82 = f0, f83 = f0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, f113 = f0, f114 = f0, f115 = f0, f116 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i80 + 96 | 0;
 i30 = i80 + 80 | 0;
 i31 = i80 + 64 | 0;
 i32 = i80 + 48 | 0;
 i33 = i80 + 32 | 0;
 i34 = i80 + 16 | 0;
 i35 = i80;
 if (i2 >>> 0 >= i76 >>> 0) {
  STACKTOP = i80;
  return;
 }
 i36 = i1 + 520 | 0;
 i37 = i29 + 4 | 0;
 i39 = i29 + 8 | 0;
 i40 = i29 + 12 | 0;
 i41 = i49 + 4 | 0;
 i42 = i49 + 8 | 0;
 i43 = i49 + 12 | 0;
 i44 = i49 + 16 | 0;
 i45 = i49 + 20 | 0;
 i46 = i49 + 24 | 0;
 i47 = i49 + 28 | 0;
 i48 = i49 + 32 | 0;
 i50 = i49 + 36 | 0;
 i51 = i49 + 40 | 0;
 i52 = i49 + 44 | 0;
 i53 = i49 + 48 | 0;
 i54 = i49 + 52 | 0;
 i55 = i49 + 56 | 0;
 i56 = i49 + 60 | 0;
 i57 = i30 + 4 | 0;
 i58 = i30 + 8 | 0;
 i59 = i30 + 12 | 0;
 i60 = i31 + 4 | 0;
 i61 = i31 + 8 | 0;
 i62 = i31 + 12 | 0;
 i63 = i32 + 4 | 0;
 i64 = i32 + 8 | 0;
 i65 = i32 + 12 | 0;
 i25 = i33 + 4 | 0;
 i26 = i33 + 8 | 0;
 i18 = i33 + 12 | 0;
 i19 = i34 + 4 | 0;
 i20 = i34 + 8 | 0;
 i21 = i34 + 12 | 0;
 i22 = i35 + 4 | 0;
 i23 = i35 + 8 | 0;
 i24 = i35 + 12 | 0;
 i66 = i78 + 12 | 0;
 i67 = i78 + 24 | 0;
 i68 = i78 + 4 | 0;
 i69 = i78 + 16 | 0;
 i70 = i78 + 28 | 0;
 i71 = i78 + 8 | 0;
 i72 = i78 + 20 | 0;
 i73 = i78 + 32 | 0;
 i74 = i1 + 60 | 0;
 i75 = i1 + 80 | 0;
 i14 = i1 + 100 | 0;
 i15 = i79 + 4 | 0;
 i16 = i79 + 8 | 0;
 i17 = i79 + 12 | 0;
 do {
  i9 = (HEAP32[i36 >> 2] | 0) + (i2 << 2) | 0;
  f92 = Math_fround(HEAPF32[i9 >> 2]);
  f81 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f82 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f81 = Math_fround(f81 * Math_fround(.00999999977));
  f82 = Math_fround(f82 * Math_fround(.00999999977));
  f83 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i29 >> 2] = Math_fround(f92 * Math_fround(.00999999977));
  HEAPF32[i37 >> 2] = f81;
  HEAPF32[i39 >> 2] = f82;
  HEAPF32[i40 >> 2] = f83;
  i9 = HEAP32[i49 >> 2] | 0;
  i13 = HEAP32[i41 >> 2] | 0;
  i10 = HEAP32[i42 >> 2] | 0;
  i6 = HEAP32[i43 >> 2] | 0;
  i9 = i9 << 11 ^ i9;
  i13 = i13 << 11 ^ i13;
  i10 = i10 << 11 ^ i10;
  i6 = i6 << 11 ^ i6;
  i1 = HEAP32[i44 >> 2] | 0;
  i4 = HEAP32[i45 >> 2] | 0;
  i3 = HEAP32[i46 >> 2] | 0;
  i5 = HEAP32[i47 >> 2] | 0;
  i7 = HEAP32[i48 >> 2] | 0;
  i11 = HEAP32[i50 >> 2] | 0;
  i12 = HEAP32[i51 >> 2] | 0;
  i8 = HEAP32[i52 >> 2] | 0;
  i91 = HEAP32[i53 >> 2] | 0;
  i90 = HEAP32[i54 >> 2] | 0;
  i89 = HEAP32[i55 >> 2] | 0;
  i88 = HEAP32[i56 >> 2] | 0;
  i9 = i9 >>> 8 ^ i9 ^ i91;
  i87 = i9 ^ i91 >>> 19;
  i13 = i13 >>> 8 ^ i13 ^ i90;
  i86 = i13 ^ i90 >>> 19;
  i10 = i10 >>> 8 ^ i10 ^ i89;
  i85 = i10 ^ i89 >>> 19;
  i6 = i6 >>> 8 ^ i6 ^ i88;
  i84 = i6 ^ i88 >>> 19;
  f83 = Math_fround(Math_fround(i86 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i85 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f81 = Math_fround(Math_fround(i84 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(i87 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i57 >> 2] = f83;
  HEAPF32[i58 >> 2] = f82;
  HEAPF32[i59 >> 2] = f81;
  i1 = i1 << 11 ^ i1;
  i4 = i4 << 11 ^ i4;
  i3 = i3 << 11 ^ i3;
  i5 = i5 << 11 ^ i5;
  i1 = i1 >>> 8 ^ i1 ^ i87;
  i9 = i1 ^ i9 >>> 19;
  i4 = i4 >>> 8 ^ i4 ^ i86;
  i13 = i4 ^ i13 >>> 19;
  i3 = i3 >>> 8 ^ i3 ^ i85;
  i10 = i3 ^ i10 >>> 19;
  i5 = i5 >>> 8 ^ i5 ^ i84;
  i6 = i5 ^ i6 >>> 19;
  f81 = Math_fround(Math_fround(i13 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i10 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f83 = Math_fround(Math_fround(i6 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i31 >> 2] = Math_fround(Math_fround(i9 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i60 >> 2] = f81;
  HEAPF32[i61 >> 2] = f82;
  HEAPF32[i62 >> 2] = f83;
  i7 = i7 << 11 ^ i7;
  i11 = i11 << 11 ^ i11;
  i12 = i12 << 11 ^ i12;
  i8 = i8 << 11 ^ i8;
  HEAP32[i49 >> 2] = i91;
  HEAP32[i41 >> 2] = i90;
  HEAP32[i42 >> 2] = i89;
  HEAP32[i43 >> 2] = i88;
  HEAP32[i44 >> 2] = i87;
  HEAP32[i45 >> 2] = i86;
  HEAP32[i46 >> 2] = i85;
  HEAP32[i47 >> 2] = i84;
  HEAP32[i48 >> 2] = i9;
  HEAP32[i50 >> 2] = i13;
  HEAP32[i51 >> 2] = i10;
  HEAP32[i52 >> 2] = i6;
  i1 = i7 >>> 8 ^ i7 ^ i9 ^ i1 >>> 19;
  i4 = i11 >>> 8 ^ i11 ^ i13 ^ i4 >>> 19;
  i3 = i12 >>> 8 ^ i12 ^ i10 ^ i3 >>> 19;
  i5 = i8 >>> 8 ^ i8 ^ i6 ^ i5 >>> 19;
  HEAP32[i53 >> 2] = i1;
  HEAP32[i54 >> 2] = i4;
  HEAP32[i55 >> 2] = i3;
  HEAP32[i56 >> 2] = i5;
  f83 = Math_fround(Math_fround(i4 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f81 = Math_fround(Math_fround(i5 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i63 >> 2] = f83;
  HEAPF32[i64 >> 2] = f82;
  HEAPF32[i65 >> 2] = f81;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i33, i27, i29, i30);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i34, i28, i29, i31);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i35, i38, i29, i32);
  i1 = HEAP32[i33 >> 2] | 0;
  i5 = HEAP32[i25 >> 2] | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i6 = HEAP32[i34 >> 2] | 0;
  i8 = HEAP32[i19 >> 2] | 0;
  i10 = HEAP32[i20 >> 2] | 0;
  i12 = HEAP32[i21 >> 2] | 0;
  i13 = HEAP32[i35 >> 2] | 0;
  i11 = HEAP32[i22 >> 2] | 0;
  i9 = HEAP32[i23 >> 2] | 0;
  i7 = HEAP32[i24 >> 2] | 0;
  if (i77) {
   f98 = Math_fround(HEAPF32[i78 >> 2]);
   f101 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f82 = Math_fround(f101 * f98);
   f100 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f100 * f98);
   f99 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f81 = Math_fround(f99 * f98);
   f94 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f98 = Math_fround(f94 * f98);
   f105 = Math_fround(HEAPF32[i66 >> 2]);
   f97 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f108 = Math_fround(f97 * f105);
   f96 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f107 = Math_fround(f96 * f105);
   f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f106 = Math_fround(f95 * f105);
   f92 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f108 = Math_fround(f82 + f108);
   f107 = Math_fround(f102 + f107);
   f106 = Math_fround(f81 + f106);
   f105 = Math_fround(f98 + Math_fround(f92 * f105));
   f98 = Math_fround(HEAPF32[i67 >> 2]);
   f81 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f81 * f98);
   f82 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f103 = Math_fround(f82 * f98);
   f83 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f104 = Math_fround(f83 * f98);
   f93 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f108 + f102);
   f103 = Math_fround(f107 + f103);
   f104 = Math_fround(f106 + f104);
   f98 = Math_fround(f105 + Math_fround(f93 * f98));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
   f98 = Math_fround(HEAPF32[i68 >> 2]);
   f104 = Math_fround(f101 * f98);
   f103 = Math_fround(f100 * f98);
   f102 = Math_fround(f99 * f98);
   f98 = Math_fround(f94 * f98);
   f105 = Math_fround(HEAPF32[i69 >> 2]);
   f104 = Math_fround(f104 + Math_fround(f97 * f105));
   f103 = Math_fround(f103 + Math_fround(f96 * f105));
   f102 = Math_fround(f102 + Math_fround(f95 * f105));
   f105 = Math_fround(f98 + Math_fround(f92 * f105));
   f98 = Math_fround(HEAPF32[i70 >> 2]);
   f104 = Math_fround(f104 + Math_fround(f81 * f98));
   f103 = Math_fround(f103 + Math_fround(f82 * f98));
   f102 = Math_fround(f102 + Math_fround(f83 * f98));
   f98 = Math_fround(f105 + Math_fround(f93 * f98));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
   f98 = Math_fround(HEAPF32[i71 >> 2]);
   f101 = Math_fround(f101 * f98);
   f100 = Math_fround(f100 * f98);
   f99 = Math_fround(f99 * f98);
   f98 = Math_fround(f94 * f98);
   f94 = Math_fround(HEAPF32[i72 >> 2]);
   f97 = Math_fround(f101 + Math_fround(f97 * f94));
   f96 = Math_fround(f100 + Math_fround(f96 * f94));
   f95 = Math_fround(f99 + Math_fround(f95 * f94));
   f94 = Math_fround(f98 + Math_fround(f92 * f94));
   f92 = Math_fround(HEAPF32[i73 >> 2]);
   f81 = Math_fround(f97 + Math_fround(f81 * f92));
   f82 = Math_fround(f96 + Math_fround(f82 * f92));
   f83 = Math_fround(f95 + Math_fround(f83 * f92));
   f92 = Math_fround(f94 + Math_fround(f93 * f92));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i112 = (HEAP32[i74 >> 2] | 0) + (i2 << 2) | 0;
  f96 = Math_fround(HEAPF32[i112 >> 2]);
  i111 = i112 + 4 | 0;
  f116 = Math_fround(HEAPF32[i111 >> 2]);
  i110 = i112 + 8 | 0;
  f115 = Math_fround(HEAPF32[i110 >> 2]);
  i109 = i112 + 12 | 0;
  f114 = Math_fround(HEAPF32[i109 >> 2]);
  i84 = (HEAP32[i75 >> 2] | 0) + (i2 << 2) | 0;
  f113 = Math_fround(HEAPF32[i84 >> 2]);
  i85 = i84 + 4 | 0;
  f81 = Math_fround(HEAPF32[i85 >> 2]);
  i86 = i84 + 8 | 0;
  f82 = Math_fround(HEAPF32[i86 >> 2]);
  i87 = i84 + 12 | 0;
  f83 = Math_fround(HEAPF32[i87 >> 2]);
  i88 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f92 = Math_fround(HEAPF32[i88 >> 2]);
  i89 = i88 + 4 | 0;
  f93 = Math_fround(HEAPF32[i89 >> 2]);
  i90 = i88 + 8 | 0;
  f94 = Math_fround(HEAPF32[i90 >> 2]);
  i91 = i88 + 12 | 0;
  f95 = Math_fround(HEAPF32[i91 >> 2]);
  f97 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f105 = Math_fround(HEAPF32[i79 >> 2]);
  f97 = Math_fround(f97 * f105);
  f98 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f106 = Math_fround(HEAPF32[i15 >> 2]);
  f98 = Math_fround(f98 * f106);
  f99 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f107 = Math_fround(HEAPF32[i16 >> 2]);
  f99 = Math_fround(f99 * f107);
  f100 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f108 = Math_fround(HEAPF32[i17 >> 2]);
  f100 = Math_fround(f100 * f108);
  f101 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f105);
  f102 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
  f103 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f107);
  f104 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f108);
  f105 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f105);
  f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
  f107 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f107);
  f98 = Math_fround(f116 + f98);
  f99 = Math_fround(f115 + f99);
  f100 = Math_fround(f114 + f100);
  f101 = Math_fround(f113 + f101);
  f102 = Math_fround(f81 + f102);
  f103 = Math_fround(f82 + f103);
  f104 = Math_fround(f83 + f104);
  f105 = Math_fround(f92 + f105);
  f106 = Math_fround(f93 + f106);
  f107 = Math_fround(f94 + f107);
  f108 = Math_fround(f95 + Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f108));
  HEAPF32[i112 >> 2] = Math_fround(f96 + f97);
  HEAPF32[i111 >> 2] = f98;
  HEAPF32[i110 >> 2] = f99;
  HEAPF32[i109 >> 2] = f100;
  HEAPF32[i84 >> 2] = f101;
  HEAPF32[i85 >> 2] = f102;
  HEAPF32[i86 >> 2] = f103;
  HEAPF32[i87 >> 2] = f104;
  HEAPF32[i88 >> 2] = f105;
  HEAPF32[i89 >> 2] = f106;
  HEAPF32[i90 >> 2] = f107;
  HEAPF32[i91 >> 2] = f108;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i76 >>> 0);
 STACKTOP = i80;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 128 | 0;
 i12 = i14;
 i13 = i10 + 116 | 0;
 if (HEAP8[i13 >> 0] | 0) {
  i7 = i10 + 104 | 0;
  i4 = i10 + 4 | 0;
  i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = i10 + 108 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   i6 = i10 + 100 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 > 32) {
    f2 = Math_fround(i3 >>> 0);
    do {
     i3 = i1;
     i1 = i1 >>> 1;
     if (i3 >>> 0 < 66) break;
    } while (f2 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
    i51 = i12 + 4 | 0;
    HEAP32[i51 >> 2] = 0;
    i48 = i12 + 8 | 0;
    i24 = i10 + 8 | 0;
    i49 = HEAP16[i24 >> 1] | 0;
    HEAP8[i48 >> 0] = i49;
    i50 = i12 + 9 | 0;
    HEAP8[i50 >> 0] = (i49 & 65535) >>> 8;
    i49 = i12 + 16 | 0;
    i59 = i10 + 16 | 0;
    i44 = i59;
    i58 = HEAP32[i44 + 4 >> 2] | 0;
    i47 = i49;
    HEAP32[i47 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i47 + 4 >> 2] = i58;
    i47 = i12 + 24 | 0;
    i58 = i10 + 24 | 0;
    HEAP32[i47 >> 2] = HEAP32[i58 >> 2];
    i44 = i12 + 28 | 0;
    i57 = i10 + 28 | 0;
    HEAP32[i44 >> 2] = HEAP32[i57 >> 2];
    i45 = i12 + 32 | 0;
    i56 = i10 + 32 | 0;
    HEAP32[i45 >> 2] = HEAP32[i56 >> 2];
    i20 = i12 + 36 | 0;
    i55 = i10 + 36 | 0;
    HEAP32[i20 >> 2] = HEAP32[i55 >> 2];
    i26 = i12 + 40 | 0;
    i53 = i10 + 40 | 0;
    HEAP32[i26 >> 2] = HEAP32[i53 >> 2];
    i30 = i12 + 44 | 0;
    i54 = i10 + 44 | 0;
    HEAP32[i30 >> 2] = HEAP32[i54 >> 2];
    i34 = i12 + 48 | 0;
    i52 = i10 + 48 | 0;
    i29 = i52;
    i43 = HEAP32[i29 + 4 >> 2] | 0;
    i33 = i34;
    HEAP32[i33 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i33 + 4 >> 2] = i43;
    i33 = i12 + 56 | 0;
    i43 = i10 + 56 | 0;
    i29 = i43;
    i42 = HEAP32[i29 + 4 >> 2] | 0;
    i31 = i33;
    HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i31 + 4 >> 2] = i42;
    i31 = i12 + 64 | 0;
    i42 = i10 + 64 | 0;
    HEAP32[i31 >> 2] = HEAP32[i42 >> 2];
    i29 = i12 + 68 | 0;
    i41 = i10 + 68 | 0;
    HEAP32[i29 >> 2] = HEAP32[i41 >> 2];
    i27 = i12 + 72 | 0;
    i40 = i10 + 72 | 0;
    HEAP32[i27 >> 2] = HEAP32[i40 >> 2];
    i25 = i12 + 76 | 0;
    i39 = i10 + 76 | 0;
    HEAP32[i25 >> 2] = HEAP32[i39 >> 2];
    i23 = i12 + 80 | 0;
    i37 = i10 + 80 | 0;
    HEAP32[i23 >> 2] = HEAP32[i37 >> 2];
    i22 = i12 + 84 | 0;
    i38 = i10 + 84 | 0;
    HEAP32[i22 >> 2] = HEAP32[i38 >> 2];
    i21 = i12 + 88 | 0;
    i36 = i10 + 88 | 0;
    i18 = i36;
    i19 = HEAP32[i18 + 4 >> 2] | 0;
    i17 = i21;
    HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i17 + 4 >> 2] = i19;
    i17 = i12 + 96 | 0;
    HEAP32[i17 >> 2] = 0;
    i19 = i12 + 100 | 0;
    HEAP32[i19 >> 2] = 0;
    i18 = i12 + 104 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i12 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    i16 = i12 + 112 | 0;
    HEAP32[i16 >> 2] = 0;
    i15 = i12 + 108 | 0;
    HEAP32[i15 >> 2] = 0;
    i3 = i12 + 116 | 0;
    HEAP8[i3 >> 0] = 0;
    __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i12, i10, i1);
    i46 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i51 >> 2];
    HEAP32[i51 >> 2] = i46;
    i51 = HEAP8[i24 >> 0] | 0;
    i46 = HEAP16[i48 >> 1] | 0;
    HEAP8[i24 >> 0] = i46;
    HEAP8[i48 >> 0] = i51;
    i48 = i10 + 9 | 0;
    i51 = HEAP8[i48 >> 0] | 0;
    HEAP8[i48 >> 0] = (i46 & 65535) >>> 8;
    HEAP8[i50 >> 0] = i51;
    i50 = i59;
    i51 = HEAP32[i50 >> 2] | 0;
    i50 = HEAP32[i50 + 4 >> 2] | 0;
    i48 = HEAP32[i58 >> 2] | 0;
    i46 = HEAP32[i57 >> 2] | 0;
    i1 = HEAP32[i56 >> 2] | 0;
    i4 = HEAP32[i55 >> 2] | 0;
    i24 = HEAP32[i53 >> 2] | 0;
    i28 = HEAP32[i54 >> 2] | 0;
    i35 = i52;
    i32 = HEAP32[i35 >> 2] | 0;
    i35 = HEAP32[i35 + 4 >> 2] | 0;
    i61 = i49;
    i60 = HEAP32[i61 + 4 >> 2] | 0;
    HEAP32[i59 >> 2] = HEAP32[i61 >> 2];
    HEAP32[i59 + 4 >> 2] = i60;
    HEAP32[i58 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i57 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i56 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i55 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i53 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i54 >> 2] = HEAP32[i30 >> 2];
    i54 = i34;
    i53 = HEAP32[i54 + 4 >> 2] | 0;
    HEAP32[i52 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i52 + 4 >> 2] = i53;
    HEAP32[i49 >> 2] = i51;
    HEAP32[i49 + 4 >> 2] = i50;
    HEAP32[i47 >> 2] = i48;
    HEAP32[i44 >> 2] = i46;
    HEAP32[i45 >> 2] = i1;
    HEAP32[i20 >> 2] = i4;
    HEAP32[i26 >> 2] = i24;
    HEAP32[i30 >> 2] = i28;
    HEAP32[i34 >> 2] = i32;
    HEAP32[i34 + 4 >> 2] = i35;
    i34 = i43;
    i35 = HEAP32[i34 >> 2] | 0;
    i34 = HEAP32[i34 + 4 >> 2] | 0;
    i32 = HEAP32[i42 >> 2] | 0;
    i30 = HEAP32[i41 >> 2] | 0;
    i28 = HEAP32[i40 >> 2] | 0;
    i26 = HEAP32[i39 >> 2] | 0;
    i24 = HEAP32[i37 >> 2] | 0;
    i4 = HEAP32[i38 >> 2] | 0;
    i1 = i36;
    i20 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i45 = i33;
    i44 = HEAP32[i45 + 4 >> 2] | 0;
    HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
    HEAP32[i43 + 4 >> 2] = i44;
    HEAP32[i42 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i41 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i39 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i37 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i38 >> 2] = HEAP32[i22 >> 2];
    i38 = i21;
    i37 = HEAP32[i38 + 4 >> 2] | 0;
    HEAP32[i36 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i36 + 4 >> 2] = i37;
    HEAP32[i33 >> 2] = i35;
    HEAP32[i33 + 4 >> 2] = i34;
    HEAP32[i31 >> 2] = i32;
    HEAP32[i29 >> 2] = i30;
    HEAP32[i27 >> 2] = i28;
    HEAP32[i25 >> 2] = i26;
    HEAP32[i23 >> 2] = i24;
    HEAP32[i22 >> 2] = i4;
    i4 = i21;
    HEAP32[i4 >> 2] = i20;
    HEAP32[i4 + 4 >> 2] = i1;
    i4 = i10 + 96 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i17 >> 2] = i1;
    i4 = HEAP32[i6 >> 2] | 0;
    i17 = HEAP32[i19 >> 2] | 0;
    HEAP32[i6 >> 2] = i17;
    HEAP32[i19 >> 2] = i4;
    i6 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i18 >> 2] = i6;
    f2 = Math_fround(i17 >>> 0);
    HEAP32[i10 + 112 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
    HEAP32[i5 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
    HEAP8[i13 >> 0] = 0;
    f2 = Math_fround(i4 >>> 0);
    HEAP32[i16 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
    HEAP32[i15 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
    HEAP8[i3 >> 0] = 0;
    if (i1 | 0) {
     i61 = HEAP32[i12 + 120 >> 2] | 0;
     HEAP32[i11 >> 2] = 65;
     HEAP32[i11 + 4 >> 2] = i61;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
    }
   }
  }
  HEAP8[i13 >> 0] = 0;
 }
 i5 = i10 + 100 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 104 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i9 >>> 0) if ((i1 + i8 | 0) >>> 0 <= (HEAP32[i10 + 112 >> 2] | 0) >>> 0) {
  STACKTOP = i14;
  return;
 }
 i4 = i1 + i8 | 0;
 f2 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i9 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i3 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i3 = i10 + 4 | 0;
 f2 = Math_fround((i4 - (HEAP32[i3 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i9 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i23 = i12 + 4 | 0;
 HEAP32[i23 >> 2] = 0;
 i26 = i12 + 8 | 0;
 i29 = i10 + 8 | 0;
 i25 = HEAP16[i29 >> 1] | 0;
 HEAP8[i26 >> 0] = i25;
 i24 = i12 + 9 | 0;
 HEAP8[i24 >> 0] = (i25 & 65535) >>> 8;
 i25 = i12 + 16 | 0;
 i15 = i10 + 16 | 0;
 i30 = i15;
 i16 = HEAP32[i30 + 4 >> 2] | 0;
 i27 = i25;
 HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i27 + 4 >> 2] = i16;
 i27 = i12 + 24 | 0;
 i16 = i10 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i16 >> 2];
 i30 = i12 + 28 | 0;
 i17 = i10 + 28 | 0;
 HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
 i54 = i12 + 32 | 0;
 i18 = i10 + 32 | 0;
 HEAP32[i54 >> 2] = HEAP32[i18 >> 2];
 i52 = i12 + 36 | 0;
 i19 = i10 + 36 | 0;
 HEAP32[i52 >> 2] = HEAP32[i19 >> 2];
 i48 = i12 + 40 | 0;
 i21 = i10 + 40 | 0;
 HEAP32[i48 >> 2] = HEAP32[i21 >> 2];
 i44 = i12 + 44 | 0;
 i20 = i10 + 44 | 0;
 HEAP32[i44 >> 2] = HEAP32[i20 >> 2];
 i40 = i12 + 48 | 0;
 i22 = i10 + 48 | 0;
 i45 = i22;
 i31 = HEAP32[i45 + 4 >> 2] | 0;
 i41 = i40;
 HEAP32[i41 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i41 + 4 >> 2] = i31;
 i41 = i12 + 56 | 0;
 i31 = i10 + 56 | 0;
 i45 = i31;
 i32 = HEAP32[i45 + 4 >> 2] | 0;
 i43 = i41;
 HEAP32[i43 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i43 + 4 >> 2] = i32;
 i43 = i12 + 64 | 0;
 i32 = i10 + 64 | 0;
 HEAP32[i43 >> 2] = HEAP32[i32 >> 2];
 i45 = i12 + 68 | 0;
 i33 = i10 + 68 | 0;
 HEAP32[i45 >> 2] = HEAP32[i33 >> 2];
 i47 = i12 + 72 | 0;
 i34 = i10 + 72 | 0;
 HEAP32[i47 >> 2] = HEAP32[i34 >> 2];
 i49 = i12 + 76 | 0;
 i35 = i10 + 76 | 0;
 HEAP32[i49 >> 2] = HEAP32[i35 >> 2];
 i51 = i12 + 80 | 0;
 i37 = i10 + 80 | 0;
 HEAP32[i51 >> 2] = HEAP32[i37 >> 2];
 i53 = i12 + 84 | 0;
 i36 = i10 + 84 | 0;
 HEAP32[i53 >> 2] = HEAP32[i36 >> 2];
 i57 = i12 + 88 | 0;
 i38 = i10 + 88 | 0;
 i56 = i38;
 i55 = HEAP32[i56 + 4 >> 2] | 0;
 i58 = i57;
 HEAP32[i58 >> 2] = HEAP32[i56 >> 2];
 HEAP32[i58 + 4 >> 2] = i55;
 i58 = i12 + 96 | 0;
 HEAP32[i58 >> 2] = 0;
 i55 = i12 + 100 | 0;
 HEAP32[i55 >> 2] = 0;
 i56 = i12 + 104 | 0;
 HEAP32[i56 >> 2] = 0;
 HEAP32[i12 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f2 = Math_fround((HEAP32[i55 >> 2] | 0) >>> 0);
 i59 = i12 + 112 | 0;
 HEAP32[i59 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
 i60 = i12 + 108 | 0;
 HEAP32[i60 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
 i61 = i12 + 116 | 0;
 HEAP8[i61 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i12, i10, i1);
 i28 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i23 >> 2] = i28;
 i23 = HEAP8[i29 >> 0] | 0;
 i28 = HEAP16[i26 >> 1] | 0;
 HEAP8[i29 >> 0] = i28;
 HEAP8[i26 >> 0] = i23;
 i26 = i10 + 9 | 0;
 i23 = HEAP8[i26 >> 0] | 0;
 HEAP8[i26 >> 0] = (i28 & 65535) >>> 8;
 HEAP8[i24 >> 0] = i23;
 i24 = i15;
 i23 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = HEAP32[i16 >> 2] | 0;
 i28 = HEAP32[i17 >> 2] | 0;
 i29 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i50 = HEAP32[i21 >> 2] | 0;
 i46 = HEAP32[i20 >> 2] | 0;
 i39 = i22;
 i42 = HEAP32[i39 >> 2] | 0;
 i39 = HEAP32[i39 + 4 >> 2] | 0;
 i8 = i25;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = i9;
 HEAP32[i16 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i52 >> 2];
 HEAP32[i21 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i44 >> 2];
 i20 = i40;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 HEAP32[i25 >> 2] = i23;
 HEAP32[i25 + 4 >> 2] = i24;
 HEAP32[i27 >> 2] = i26;
 HEAP32[i30 >> 2] = i28;
 HEAP32[i54 >> 2] = i29;
 HEAP32[i52 >> 2] = i1;
 HEAP32[i48 >> 2] = i50;
 HEAP32[i44 >> 2] = i46;
 HEAP32[i40 >> 2] = i42;
 HEAP32[i40 + 4 >> 2] = i39;
 i40 = i31;
 i39 = HEAP32[i40 >> 2] | 0;
 i40 = HEAP32[i40 + 4 >> 2] | 0;
 i42 = HEAP32[i32 >> 2] | 0;
 i44 = HEAP32[i33 >> 2] | 0;
 i46 = HEAP32[i34 >> 2] | 0;
 i48 = HEAP32[i35 >> 2] | 0;
 i50 = HEAP32[i37 >> 2] | 0;
 i52 = HEAP32[i36 >> 2] | 0;
 i1 = i38;
 i54 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i29 = i41;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i31 + 4 >> 2] = i30;
 HEAP32[i32 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i33 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i34 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i35 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i37 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i36 >> 2] = HEAP32[i53 >> 2];
 i36 = i57;
 i37 = HEAP32[i36 + 4 >> 2] | 0;
 HEAP32[i38 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i38 + 4 >> 2] = i37;
 HEAP32[i41 >> 2] = i39;
 HEAP32[i41 + 4 >> 2] = i40;
 HEAP32[i43 >> 2] = i42;
 HEAP32[i45 >> 2] = i44;
 HEAP32[i47 >> 2] = i46;
 HEAP32[i49 >> 2] = i48;
 HEAP32[i51 >> 2] = i50;
 HEAP32[i53 >> 2] = i52;
 HEAP32[i57 >> 2] = i54;
 HEAP32[i57 + 4 >> 2] = i1;
 i57 = i10 + 96 | 0;
 i1 = HEAP32[i57 >> 2] | 0;
 HEAP32[i57 >> 2] = HEAP32[i58 >> 2];
 HEAP32[i58 >> 2] = i1;
 i58 = HEAP32[i5 >> 2] | 0;
 i57 = HEAP32[i55 >> 2] | 0;
 HEAP32[i5 >> 2] = i57;
 HEAP32[i55 >> 2] = i58;
 i55 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i56 >> 2];
 HEAP32[i56 >> 2] = i55;
 f2 = Math_fround(i57 >>> 0);
 HEAP32[i10 + 112 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
 HEAP32[i10 + 108 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
 HEAP8[i13 >> 0] = 0;
 f2 = Math_fround(i58 >>> 0);
 HEAP32[i59 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
 HEAP32[i60 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
 HEAP8[i61 >> 0] = 0;
 if (i1 | 0) {
  i61 = HEAP32[i12 + 120 >> 2] | 0;
  HEAP32[i11 >> 2] = 65;
  HEAP32[i11 + 4 >> 2] = i61;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 STACKTOP = i14;
 return;
}

function __ZN16DeveloperConsole13InitGUIStylesEv(i25) {
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27;
 i2 = __Znwj(296) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = i2 + 32 | 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i2 + 52 | 0;
 i3 = i2 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i2 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i2 + 72 >> 2] = Math_fround(1.0);
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i2 + 92 >> 2] = Math_fround(1.0);
 i3 = i2 + 112 | 0;
 i4 = i2 + 96 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i2 + 116 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i2 + 132 >> 2] = Math_fround(1.0);
 i4 = i2 + 136 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i2 + 152 >> 2] = Math_fround(1.0);
 i4 = i2 + 156 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i2 + 172 >> 2] = Math_fround(1.0);
 i4 = i2 + 249 | 0;
 i8 = i2 + 176 | 0;
 i9 = i8 + 68 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 i20 = i2 + 260 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 24 >> 2] = 0;
 HEAP32[i20 + 28 >> 2] = 0;
 HEAP8[i2 + 292 >> 0] = 1;
 HEAP8[i2 + 293 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 1065353216;
 HEAP32[i2 + 24 >> 2] = 1065353216;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i5 >> 2] = 1065353216;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i3 >> 2] = 1065353216;
 HEAP32[i2 + 208 >> 2] = 3;
 HEAP32[i2 + 212 >> 2] = 0;
 HEAP32[i2 + 216 >> 2] = 3;
 HEAP32[i2 + 220 >> 2] = 3;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i2 + 244 >> 2] = 0;
 HEAP32[i2 + 252 >> 2] = 0;
 HEAP32[i2 + 256 >> 2] = 3;
 HEAP8[i2 + 248 >> 0] = 1;
 HEAP32[i25 + 120 >> 2] = i2;
 i20 = __Znwj(296) | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i2 = i20 + 16 | 0;
 i16 = i20 + 32 | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = i20 + 36 | 0;
 i12 = i20 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i7 = i20 + 56 | 0;
 i6 = i20 + 72 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 i13 = i20 + 76 | 0;
 i10 = i20 + 92 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0);
 i13 = i20 + 96 | 0;
 i11 = i20 + 112 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 i17 = i20 + 116 | 0;
 i14 = i20 + 132 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i21 = i20 + 136 | 0;
 i18 = i20 + 152 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 i22 = i20 + 156 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAPF32[i20 + 172 >> 2] = Math_fround(1.0);
 i22 = i20 + 176 | 0;
 i23 = i20 + 249 | 0;
 i8 = i22;
 i9 = i8 + 72 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP8[i22 + 72 >> 0] = 0;
 HEAP8[i23 >> 0] = 1;
 i24 = i20 + 292 | 0;
 i8 = i20 + 252 | 0;
 i9 = i8 + 40 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP8[i24 >> 0] = 1;
 i19 = i20 + 293 | 0;
 HEAP8[i19 >> 0] = 0;
 i8 = i20 + 20 | 0;
 HEAP32[i8 >> 2] = 1063708391;
 i9 = i20 + 24 | 0;
 HEAP32[i9 >> 2] = 1063708391;
 i15 = i20 + 28 | 0;
 HEAP32[i15 >> 2] = 1063708391;
 HEAP32[i16 >> 2] = 1065353216;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017665 | 0, 19);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = i20 + 40 | 0;
 HEAP32[i2 >> 2] = 1065353216;
 i3 = i20 + 44 | 0;
 HEAP32[i3 >> 2] = 1065353216;
 i4 = i20 + 48 | 0;
 HEAP32[i4 >> 2] = 1065353216;
 HEAP32[i12 >> 2] = 1065353216;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017685 | 0, 25);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i28 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i20 + 60 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i20 + 64 >> 2] = i28;
 HEAP32[i20 + 68 >> 2] = i5;
 HEAP32[i6 >> 2] = i1;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017711 | 0, 26);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i7 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i28 = HEAP32[i12 >> 2] | 0;
 HEAP32[i20 + 80 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i20 + 84 >> 2] = i7;
 HEAP32[i20 + 88 >> 2] = i1;
 HEAP32[i10 >> 2] = i28;
 i10 = HEAP32[i9 >> 2] | 0;
 i28 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i20 + 100 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i20 + 104 >> 2] = i10;
 HEAP32[i20 + 108 >> 2] = i28;
 HEAP32[i11 >> 2] = i1;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017738 | 0, 22);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 i13 = HEAP32[i3 >> 2] | 0;
 i28 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i20 + 120 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i20 + 124 >> 2] = i13;
 HEAP32[i20 + 128 >> 2] = i28;
 HEAP32[i14 >> 2] = i1;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017761 | 0, 28);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = i1;
 i17 = HEAP32[i9 >> 2] | 0;
 i28 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i20 + 140 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i20 + 144 >> 2] = i17;
 HEAP32[i20 + 148 >> 2] = i28;
 HEAP32[i18 >> 2] = i1;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017711 | 0, 26);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = i1;
 HEAP32[i22 >> 2] = 6;
 HEAP32[i20 + 180 >> 2] = 6;
 HEAP32[i20 + 184 >> 2] = 6;
 HEAP32[i20 + 188 >> 2] = 4;
 HEAP32[i20 + 192 >> 2] = 4;
 HEAP32[i20 + 196 >> 2] = 4;
 HEAP32[i20 + 200 >> 2] = 4;
 HEAP32[i20 + 204 >> 2] = 4;
 HEAP32[i20 + 208 >> 2] = 6;
 HEAP32[i20 + 212 >> 2] = 6;
 HEAP32[i20 + 216 >> 2] = 3;
 HEAP32[i20 + 220 >> 2] = 3;
 HEAP8[i23 >> 0] = 0;
 HEAP32[i20 + 284 >> 2] = 10;
 HEAP32[i20 + 244 >> 2] = 4;
 HEAP8[i24 >> 0] = 1;
 HEAP8[i19 >> 0] = 0;
 HEAP32[i25 + 124 >> 2] = i20;
 i3 = __Znwj(296) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = i3 + 16 | 0;
 i1 = i3 + 32 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 52 >> 2] = Math_fround(1.0);
 i5 = i3 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 72 >> 2] = Math_fround(1.0);
 i5 = i3 + 76 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 92 >> 2] = Math_fround(1.0);
 i5 = i3 + 96 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 112 >> 2] = Math_fround(1.0);
 i5 = i3 + 116 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 132 >> 2] = Math_fround(1.0);
 i5 = i3 + 136 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 152 >> 2] = Math_fround(1.0);
 i5 = i3 + 156 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i3 + 172 >> 2] = Math_fround(1.0);
 i5 = i3 + 176 | 0;
 i6 = i3 + 249 | 0;
 i8 = i5;
 i9 = i8 + 72 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP8[i5 + 72 >> 0] = 0;
 HEAP8[i6 >> 0] = 1;
 i7 = i3 + 292 | 0;
 i8 = i3 + 252 | 0;
 i9 = i8 + 40 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP8[i7 >> 0] = 1;
 i2 = i3 + 293 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i3 + 20 >> 2] = 1061997773;
 HEAP32[i3 + 24 >> 2] = 1061997773;
 HEAP32[i3 + 28 >> 2] = 1061997773;
 HEAP32[i1 >> 2] = 1065353216;
 i1 = __Z25GetBuiltinResourceManagerv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, gb + 1017790 | 0, 16);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 32032 | 0, i26) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 if (!i1) {
  i28 = 0;
  HEAP32[i4 >> 2] = i28;
  HEAP32[i5 >> 2] = 6;
  i28 = i3 + 180 | 0;
  HEAP32[i28 >> 2] = 6;
  i28 = i3 + 184 | 0;
  HEAP32[i28 >> 2] = 6;
  i28 = i3 + 188 | 0;
  HEAP32[i28 >> 2] = 6;
  i28 = i3 + 192 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 196 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 200 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 204 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 208 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 212 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 216 | 0;
  HEAP32[i28 >> 2] = 4;
  i28 = i3 + 220 | 0;
  HEAP32[i28 >> 2] = 4;
  HEAP8[i6 >> 0] = 0;
  i28 = i3 + 288 | 0;
  HEAP32[i28 >> 2] = 1;
  i28 = i3 + 244 | 0;
  HEAP32[i28 >> 2] = 1;
  HEAP8[i7 >> 0] = 1;
  HEAP8[i2 >> 0] = 0;
  i28 = i25 + 128 | 0;
  HEAP32[i28 >> 2] = i3;
  STACKTOP = i27;
  return;
 }
 i28 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i28;
 HEAP32[i5 >> 2] = 6;
 i28 = i3 + 180 | 0;
 HEAP32[i28 >> 2] = 6;
 i28 = i3 + 184 | 0;
 HEAP32[i28 >> 2] = 6;
 i28 = i3 + 188 | 0;
 HEAP32[i28 >> 2] = 6;
 i28 = i3 + 192 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 196 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 200 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 204 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 208 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 212 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 216 | 0;
 HEAP32[i28 >> 2] = 4;
 i28 = i3 + 220 | 0;
 HEAP32[i28 >> 2] = 4;
 HEAP8[i6 >> 0] = 0;
 i28 = i3 + 288 | 0;
 HEAP32[i28 >> 2] = 1;
 i28 = i3 + 244 | 0;
 HEAP32[i28 >> 2] = 1;
 HEAP8[i7 >> 0] = 1;
 HEAP8[i2 >> 0] = 0;
 i28 = i25 + 128 | 0;
 HEAP32[i28 >> 2] = i3;
 STACKTOP = i27;
 return;
}

function __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i1, i2, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 L1 : while (1) {
  i10 = i2;
  i12 = i2 + -16 | 0;
  i13 = i2 + -12 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i10 - i9 | 0;
    i4 = i3 >> 4;
    switch (i4 | 0) {
    case 2:
     {
      i11 = 5;
      break L1;
     }
    case 3:
     {
      i11 = 7;
      break L1;
     }
    case 4:
     {
      i11 = 15;
      break L1;
     }
    case 5:
     {
      i11 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i11 = 60;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 112) {
     i11 = 18;
     break L1;
    }
    i6 = (i4 | 0) / 2 | 0;
    i8 = i1 + (i6 << 4) | 0;
    do if ((i3 | 0) > 15984) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + (i3 << 4) | 0, i8, i8 + (i3 << 4) | 0, i12, i15) | 0;
    } else {
     i7 = mftCall_iii(HEAP32[i15 >> 2] | 0, i8 | 0, i1 | 0) | 0;
     i3 = mftCall_iii(HEAP32[i15 >> 2] | 0, i12 | 0, i8 | 0) | 0;
     if (!i7) {
      if (!i3) {
       i3 = 0;
       break;
      }
      i7 = HEAP32[i8 >> 2] | 0;
      i3 = i1 + (i6 << 4) + 4 | 0;
      HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP16[i14 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
      HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP16[i3 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
      HEAP32[i12 >> 2] = i7;
      HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
      if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i8 | 0, i1 | 0) | 0)) {
       i3 = 1;
       break;
      }
      i7 = HEAP32[i1 >> 2] | 0;
      i6 = i1 + 4 | 0;
      HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
      HEAP16[i14 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP16[i6 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
      HEAP32[i8 >> 2] = i7;
      HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP16[i3 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
      i3 = 2;
      break;
     }
     i4 = HEAP32[i1 >> 2] | 0;
     i5 = i1 + 4 | 0;
     HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP16[i14 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
     if (i3) {
      HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP16[i5 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
      HEAP32[i12 >> 2] = i4;
      HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
      i3 = 1;
      break;
     }
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     i3 = i1 + (i6 << 4) + 4 | 0;
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP16[i5 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
     HEAP32[i8 >> 2] = i4;
     HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP16[i3 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i12 | 0, i8 | 0) | 0) {
      i7 = HEAP32[i8 >> 2] | 0;
      HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP16[i14 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
      HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      HEAP16[i3 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
      HEAP32[i12 >> 2] = i7;
      HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i8 | 0) | 0) {
     i5 = i12;
     break;
    } else i4 = i12;
    while (1) {
     i5 = i4 + -16 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i8 | 0) | 0) {
      i11 = 43;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 16 | 0;
    if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i12 | 0) | 0)) {
     if ((i3 | 0) == (i12 | 0)) {
      i11 = 60;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 16 | 0;
      if ((i3 | 0) == (i12 | 0)) {
       i11 = 60;
       break L1;
      }
     }
     i9 = HEAP32[i3 >> 2] | 0;
     i8 = i3 + 4 | 0;
     HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP16[i14 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
     HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP16[i8 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
     HEAP32[i12 >> 2] = i9;
     HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
     i3 = i3 + 16 | 0;
    }
    if ((i3 | 0) == (i12 | 0)) {
     i11 = 60;
     break L1;
    } else i4 = i12;
    while (1) {
     while (1) {
      i6 = i3 + 16 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i6;
     }
     while (1) {
      i5 = i4 + -16 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i5 | 0) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i9 = HEAP32[i3 >> 2] | 0;
     i8 = i3 + 4 | 0;
     HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP16[i14 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
     HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + -12 | 0;
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP16[i8 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
     HEAP32[i5 >> 2] = i9;
     HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP16[i4 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
     i4 = i5;
     i3 = i6;
    }
   }
   if ((i11 | 0) == 43) {
    i11 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i17 = i1 + 4 | 0;
    HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP16[i14 + 8 >> 1] = HEAP16[i17 + 8 >> 1] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    i7 = i4 + -12 | 0;
    HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP16[i17 + 8 >> 1] = HEAP16[i7 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP16[i7 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 16 | 0;
   L44 : do if (i4 >>> 0 < i5 >>> 0) while (1) {
    while (1) {
     i7 = i4 + 16 | 0;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i4 | 0, i8 | 0) | 0) i4 = i7; else break;
    }
    while (1) {
     i6 = i5 + -16 | 0;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0) | 0) break; else i5 = i6;
    }
    if (i4 >>> 0 > i6 >>> 0) {
     i5 = i8;
     i6 = i4;
     break L44;
    }
    i17 = HEAP32[i4 >> 2] | 0;
    i18 = i4 + 4 | 0;
    HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP16[i14 + 8 >> 1] = HEAP16[i18 + 8 >> 1] | 0;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + -12 | 0;
    HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP16[i18 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
    HEAP32[i6 >> 2] = i17;
    HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP16[i5 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
    i8 = (i8 | 0) == (i4 | 0) ? i6 : i8;
    i5 = i6;
    i4 = i7;
    i3 = i3 + 1 | 0;
   } else {
    i5 = i8;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) if (mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
    i17 = HEAP32[i6 >> 2] | 0;
    i8 = i6 + 4 | 0;
    HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i14 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    i18 = i5 + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP16[i8 + 8 >> 1] = HEAP16[i18 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = i17;
    HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP16[i18 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRK16MeshTriangleDataS3_EPS1_EEbT0_S8_T_(i1, i6, i15) | 0;
    i4 = i6 + 16 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRK16MeshTriangleDataS3_EPS1_EEbT0_S8_T_(i4, i2, i15) | 0) {
     i11 = 59;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i18 = i6;
   if ((i18 - i9 | 0) >= (i10 - i18 | 0)) {
    i11 = 58;
    break;
   }
   __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i1, i6, i15);
   i1 = i6 + 16 | 0;
  }
  if ((i11 | 0) == 58) {
   i11 = 0;
   __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i6 + 16 | 0, i2, i15);
   i2 = i6;
   continue;
  } else if ((i11 | 0) == 59) {
   i11 = 0;
   if (i3) {
    i11 = 60;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i11 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i12 | 0, i1 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i18 = HEAP32[i1 >> 2] | 0;
  i17 = i1 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP16[i14 + 8 >> 1] = HEAP16[i17 + 8 >> 1] | 0;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP16[i17 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
  HEAP32[i12 >> 2] = i18;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 7) {
  i5 = i1 + 16 | 0;
  i18 = mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i1 | 0) | 0;
  i2 = mftCall_iii(HEAP32[i15 >> 2] | 0, i12 | 0, i5 | 0) | 0;
  if (!i18) {
   if (!i2) {
    STACKTOP = i16;
    return;
   }
   i18 = HEAP32[i5 >> 2] | 0;
   i2 = i1 + 20 | 0;
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP16[i14 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP16[i2 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
   HEAP32[i12 >> 2] = i18;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
   if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i1 | 0) | 0)) {
    STACKTOP = i16;
    return;
   }
   i18 = HEAP32[i1 >> 2] | 0;
   i17 = i1 + 4 | 0;
   HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP16[i14 + 8 >> 1] = HEAP16[i17 + 8 >> 1] | 0;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP16[i17 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
   HEAP32[i5 >> 2] = i18;
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP16[i2 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
   STACKTOP = i16;
   return;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i1 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP16[i14 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
  if (i2) {
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP16[i4 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
   STACKTOP = i16;
   return;
  }
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP16[i4 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP16[i1 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i12 | 0, i5 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i18 = HEAP32[i5 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP16[i14 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP16[i1 + 8 >> 1] = HEAP16[i13 + 8 >> 1] | 0;
  HEAP32[i12 >> 2] = i18;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP16[i13 + 8 >> 1] = HEAP16[i14 + 8 >> 1] | 0;
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i12, i15) | 0;
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 16) {
  __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + 16 | 0, i1 + 32 | 0, i1 + 48 | 0, i12, i15) | 0;
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 18) {
  __ZNSt3__218__insertion_sort_3IRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i1, i2, i15);
  STACKTOP = i16;
  return;
 } else if ((i11 | 0) == 60) {
  STACKTOP = i16;
  return;
 }
}

function __GLOBAL__sub_I_runtime_camera4_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113452 | 0, gb + 384566 | 0, 0, 0);
 HEAPF32[gb + 1113232 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 8 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 16 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 24 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113232 + 28 >> 2] = 0;
 HEAP32[gb + 1113232 + 28 + 4 >> 2] = 0;
 HEAP32[gb + 1113232 + 28 + 8 >> 2] = 0;
 HEAP32[gb + 1113232 + 28 + 12 >> 2] = 0;
 HEAPF32[gb + 1113232 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113232 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 52 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113232 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 72 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113232 + 76 >> 2] = 0;
 HEAP32[gb + 1113232 + 76 + 4 >> 2] = 0;
 HEAP32[gb + 1113232 + 76 + 8 >> 2] = 0;
 HEAP32[gb + 1113232 + 76 + 12 >> 2] = 0;
 HEAPF32[gb + 1113232 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113232 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 100 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 108 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113232 + 112 >> 2] = 0;
 HEAP32[gb + 1113232 + 112 + 4 >> 2] = 0;
 HEAP32[gb + 1113232 + 112 + 8 >> 2] = 0;
 HEAP32[gb + 1113232 + 112 + 12 >> 2] = 0;
 HEAPF32[gb + 1113232 + 128 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113232 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113232 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 152 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 160 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 176 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 180 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 184 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 188 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 192 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 196 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113232 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113232 + 212 >> 2] = Math_fround(1.0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1113464 | 0, 13);
 HEAPF32[gb + 1113472 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 8 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 12 >> 2] = -1;
 HEAPF32[gb + 1113472 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 32 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 36 >> 2] = -1;
 HEAPF32[gb + 1113472 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 52 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 56 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 60 >> 2] = -1;
 HEAPF32[gb + 1113472 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 72 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 80 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 84 >> 2] = -1;
 HEAPF32[gb + 1113472 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 100 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 104 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 108 >> 2] = -1;
 HEAPF32[gb + 1113472 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 116 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 120 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 124 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 128 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 132 >> 2] = -1;
 HEAPF32[gb + 1113472 + 136 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 152 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 156 >> 2] = -1;
 HEAPF32[gb + 1113472 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 164 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 168 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 176 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 180 >> 2] = -1;
 HEAPF32[gb + 1113472 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 188 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 192 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 196 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 200 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 204 >> 2] = -1;
 HEAPF32[gb + 1113472 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 212 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 224 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 228 >> 2] = -1;
 HEAPF32[gb + 1113472 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 240 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 244 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 248 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 252 >> 2] = -1;
 HEAPF32[gb + 1113472 + 256 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 260 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 264 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 268 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 272 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 276 >> 2] = -1;
 HEAPF32[gb + 1113472 + 280 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 284 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 288 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 292 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 296 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 300 >> 2] = -1;
 HEAPF32[gb + 1113472 + 304 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 308 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 312 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 316 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 320 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 324 >> 2] = -1;
 HEAPF32[gb + 1113472 + 328 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 332 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 336 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 340 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 344 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 348 >> 2] = -1;
 HEAPF32[gb + 1113472 + 352 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 360 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 368 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 372 >> 2] = -1;
 HEAPF32[gb + 1113472 + 376 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 380 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 384 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 388 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 392 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 396 >> 2] = -1;
 HEAPF32[gb + 1113472 + 400 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 404 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 408 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 412 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 416 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 420 >> 2] = -1;
 HEAPF32[gb + 1113472 + 424 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 428 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 432 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 436 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 440 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 444 >> 2] = -1;
 HEAPF32[gb + 1113472 + 448 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 452 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 456 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 460 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 464 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 468 >> 2] = -1;
 HEAPF32[gb + 1113472 + 472 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 476 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 480 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 484 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 488 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 492 >> 2] = -1;
 HEAPF32[gb + 1113472 + 496 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 500 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 504 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 508 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 512 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 516 >> 2] = -1;
 HEAPF32[gb + 1113472 + 520 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 524 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 528 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 532 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 536 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 540 >> 2] = -1;
 HEAPF32[gb + 1113472 + 544 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 548 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 552 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 556 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 560 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 564 >> 2] = -1;
 HEAPF32[gb + 1113472 + 568 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 572 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 576 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 580 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 584 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 588 >> 2] = -1;
 HEAPF32[gb + 1113472 + 592 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 596 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 600 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 604 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 608 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 612 >> 2] = -1;
 HEAPF32[gb + 1113472 + 616 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 620 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 624 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 628 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 632 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 636 >> 2] = -1;
 HEAPF32[gb + 1113472 + 640 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 644 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 648 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 652 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 656 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 660 >> 2] = -1;
 HEAPF32[gb + 1113472 + 664 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 668 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 672 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 676 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 680 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 684 >> 2] = -1;
 HEAPF32[gb + 1113472 + 688 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 692 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 696 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 700 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 704 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 708 >> 2] = -1;
 HEAPF32[gb + 1113472 + 712 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 716 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 720 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 724 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 728 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 732 >> 2] = -1;
 HEAPF32[gb + 1113472 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 740 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 744 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 748 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 752 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 756 >> 2] = -1;
 HEAPF32[gb + 1113472 + 760 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 764 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 768 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 772 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 776 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 780 >> 2] = -1;
 HEAPF32[gb + 1113472 + 784 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 788 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 792 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 796 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 800 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1113472 + 804 >> 2] = -1;
 HEAPF32[gb + 1113472 + 808 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 812 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 816 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 820 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 824 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 828 >> 2] = -1;
 HEAPF32[gb + 1113472 + 832 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1113472 + 836 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 840 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 844 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1113472 + 848 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1113472 + 852 >> 2] = -1;
 HEAPF32[gb + 1113472 + 856 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1113472 + 860 >> 2] = Math_fround(0.0);
 return;
}

function _cf2_hintmap_build(i30, i31, i2, i32, i24, i1) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i33 + 48 | 0;
 i21 = i33 + 20 | 0;
 i25 = i33;
 i22 = HEAP32[i30 >> 2] | 0;
 i28 = i1 << 24 >> 24 != 0;
 if (!i28) {
  i1 = i30 + 4 | 0;
  if (!(HEAP8[(HEAP32[i1 >> 2] | 0) + 12 >> 0] | 0)) {
   _cf2_hintmask_init(i21, HEAP32[i32 >> 2] | 0);
   _cf2_hintmap_build(HEAP32[i1 >> 2] | 0, i31, i2, i21, i24, 1);
  }
 }
 if (!((_cf2_hintmask_isValid(i32) | 0) << 24 >> 24)) {
  i29 = _cf2_arrstack_size(i31) | 0;
  _cf2_hintmask_setAll(i32, (_cf2_arrstack_size(i2) | 0) + i29 | 0);
  if (!((_cf2_hintmask_isValid(i32) | 0) << 24 >> 24)) {
   STACKTOP = i33;
   return;
  }
 }
 i29 = i30 + 20 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 + 24 >> 2] = 0;
 HEAP32[i21 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i32 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i32 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i32 + 24 >> 2];
 i1 = _cf2_hintmask_getMaskPtr(i21) | 0;
 i23 = _cf2_arrstack_size(i31) | 0;
 if (i23 >>> 0 > (HEAP32[i32 + 8 >> 2] | 0) >>> 0) {
  STACKTOP = i33;
  return;
 }
 i9 = i22 + 196 | 0;
 if (HEAP8[i22 + 205 >> 0] | 0) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  HEAP32[i26 + 12 >> 2] = 0;
  HEAP32[i26 + 16 >> 2] = 0;
  _cf2_hintmap_insertHint(i30, i22 + 244 | 0, i26);
  _cf2_hintmap_insertHint(i30, i26, i22 + 224 | 0);
 }
 i20 = (i23 | 0) == 0;
 if (!i20) {
  i10 = i30 + 16 | 0;
  i11 = i26 + 8 | 0;
  i12 = i26 + 16 | 0;
  i13 = i26 + 4 | 0;
  i14 = i26 + 12 | 0;
  i15 = i25 + 8 | 0;
  i16 = i22 + 188 | 0;
  i17 = i25 + 16 | 0;
  i18 = i25 + 4 | 0;
  i19 = i25 + 12 | 0;
  i8 = 0;
  i7 = 128;
  while (1) {
   if (HEAPU8[i1 >> 0] & i7 | 0) {
    i6 = HEAP32[i10 >> 2] | 0;
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i26 + 8 >> 2] = 0;
    HEAP32[i26 + 12 >> 2] = 0;
    HEAP32[i26 + 16 >> 2] = 0;
    i5 = _cf2_arrstack_getPointer(i31, i8) | 0;
    i2 = HEAP32[i5 + 8 >> 2] | 0;
    i4 = HEAP32[i5 + 4 >> 2] | 0;
    i3 = i2 - i4 | 0;
    L21 : do if ((i3 | 0) < -1310720) {
     switch (i3 | 0) {
     case -1376256:
      break;
     default:
      {
       i27 = 14;
       break L21;
      }
     }
     HEAP32[i11 >> 2] = i2;
     HEAP32[i26 >> 2] = 1;
     i3 = 17;
     i27 = 18;
    } else {
     switch (i3 | 0) {
     case -1310720:
      break;
     default:
      {
       i27 = 14;
       break L21;
      }
     }
     HEAP32[i26 >> 2] = 0;
     i2 = (HEAP32[i11 >> 2] | 0) + i24 | 0;
     HEAP32[i11 >> 2] = i2;
     HEAP32[i12 >> 2] = i6;
     HEAP32[i13 >> 2] = i8;
     i27 = 20;
    } while (0);
    do if ((i27 | 0) == 14) if ((i3 | 0) < 0) {
     HEAP32[i11 >> 2] = i2;
     HEAP32[i26 >> 2] = 4;
     i3 = 20;
     i27 = 18;
     break;
    } else {
     HEAP32[i11 >> 2] = i4;
     HEAP32[i26 >> 2] = 4;
     i3 = 20;
     i2 = i4;
     i27 = 18;
     break;
    } while (0);
    if ((i27 | 0) == 18) {
     i27 = 0;
     i2 = i2 + i24 | 0;
     HEAP32[i11 >> 2] = i2;
     HEAP32[i12 >> 2] = i6;
     HEAP32[i13 >> 2] = i8;
     if (!(HEAP8[i5 >> 0] | 0)) i27 = 20; else {
      HEAP32[i14 >> 2] = HEAP32[i5 + 12 >> 2];
      HEAP32[i26 >> 2] = i3;
     }
    }
    if ((i27 | 0) == 20) HEAP32[i14 >> 2] = _UNITY_FT_MulFix(i2, i6) | 0;
    i6 = HEAP32[i10 >> 2] | 0;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    HEAP32[i25 + 12 >> 2] = 0;
    HEAP32[i25 + 16 >> 2] = 0;
    i5 = _cf2_arrstack_getPointer(i31, i8) | 0;
    i2 = HEAP32[i5 + 8 >> 2] | 0;
    i4 = HEAP32[i5 + 4 >> 2] | 0;
    i3 = i2 - i4 | 0;
    L37 : do if ((i3 | 0) < -1310720) {
     switch (i3 | 0) {
     case -1376256:
      break;
     default:
      {
       i27 = 24;
       break L37;
      }
     }
     HEAP32[i25 >> 2] = 0;
     i2 = (HEAP32[i15 >> 2] | 0) + i24 | 0;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i17 >> 2] = i6;
     HEAP32[i18 >> 2] = i8;
     i27 = 29;
    } else {
     switch (i3 | 0) {
     case -1310720:
      break;
     default:
      {
       i27 = 24;
       break L37;
      }
     }
     HEAP32[i15 >> 2] = i4;
     HEAP32[i25 >> 2] = 2;
     i3 = 18;
     i2 = i4;
     i27 = 27;
    } while (0);
    do if ((i27 | 0) == 24) if ((i3 | 0) < 0) {
     HEAP32[i15 >> 2] = i4;
     HEAP32[i25 >> 2] = 8;
     i3 = 24;
     i2 = i4;
     i27 = 27;
     break;
    } else {
     HEAP32[i15 >> 2] = i2;
     HEAP32[i25 >> 2] = 8;
     i3 = 24;
     i27 = 27;
     break;
    } while (0);
    if ((i27 | 0) == 27) {
     i27 = 0;
     i2 = i2 + (HEAP32[i16 >> 2] << 1) + i24 | 0;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i17 >> 2] = i6;
     HEAP32[i18 >> 2] = i8;
     if (!(HEAP8[i5 >> 0] | 0)) i27 = 29; else {
      HEAP32[i19 >> 2] = HEAP32[i5 + 16 >> 2];
      HEAP32[i25 >> 2] = i3;
     }
    }
    if ((i27 | 0) == 29) {
     i27 = 0;
     HEAP32[i19 >> 2] = _UNITY_FT_MulFix(i2, i6) | 0;
    }
    if (!(HEAP32[i26 >> 2] & 16)) if (!(HEAP32[i25 >> 2] & 16)) {
     if ((_cf2_blues_capture(i9, i26, i25) | 0) << 24 >> 24) i27 = 33;
    } else i27 = 33; else i27 = 33;
    if ((i27 | 0) == 33) {
     i27 = 0;
     _cf2_hintmap_insertHint(i30, i26, i25);
     HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & (i7 ^ 255);
    }
   }
   i2 = (i8 & 7 | 0) == 7;
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i23 | 0)) break; else {
    i1 = i2 ? i1 + 1 | 0 : i1;
    i7 = i2 ? 128 : i7 >>> 1 & 127;
   }
  }
 }
 do if (i28) {
  i1 = HEAP32[i29 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i30 + 36 >> 2] | 0) <= 0) if ((HEAP32[i30 + 28 + ((i1 + -1 | 0) * 20 | 0) + 8 >> 2] | 0) >= 0) break;
  i24 = i26 + 4 | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i26 >> 2] = 49;
  HEAP32[i26 + 16 >> 2] = HEAP32[i30 + 16 >> 2];
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
  HEAP32[i25 + 16 >> 2] = 0;
  _cf2_hintmap_insertHint(i30, i26, i25);
 } else {
  i1 = _cf2_hintmask_getMaskPtr(i21) | 0;
  if (!i20) {
   i13 = i30 + 16 | 0;
   i14 = i26 + 8 | 0;
   i15 = i26 + 16 | 0;
   i16 = i26 + 4 | 0;
   i17 = i26 + 12 | 0;
   i18 = i25 + 8 | 0;
   i9 = i22 + 188 | 0;
   i10 = i25 + 16 | 0;
   i11 = i25 + 4 | 0;
   i12 = i25 + 12 | 0;
   i7 = 0;
   i8 = 128;
   i6 = i1;
   while (1) {
    if (HEAPU8[i6 >> 0] & i8 | 0) {
     i5 = HEAP32[i13 >> 2] | 0;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     HEAP32[i26 + 12 >> 2] = 0;
     HEAP32[i26 + 16 >> 2] = 0;
     i4 = _cf2_arrstack_getPointer(i31, i7) | 0;
     i1 = HEAP32[i4 + 8 >> 2] | 0;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
     i2 = i1 - i3 | 0;
     L73 : do if ((i2 | 0) < -1310720) {
      switch (i2 | 0) {
      case -1376256:
       break;
      default:
       {
        i27 = 46;
        break L73;
       }
      }
      HEAP32[i14 >> 2] = i1;
      HEAP32[i26 >> 2] = 1;
      i2 = 17;
      i27 = 50;
     } else {
      switch (i2 | 0) {
      case -1310720:
       break;
      default:
       {
        i27 = 46;
        break L73;
       }
      }
      HEAP32[i26 >> 2] = 0;
      HEAP32[i14 >> 2] = i24;
      HEAP32[i15 >> 2] = i5;
      HEAP32[i16 >> 2] = i7;
      i1 = i24;
      i27 = 52;
     } while (0);
     do if ((i27 | 0) == 46) if ((i2 | 0) < 0) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i26 >> 2] = 4;
      i2 = 20;
      i27 = 50;
      break;
     } else {
      HEAP32[i14 >> 2] = i3;
      HEAP32[i26 >> 2] = 4;
      i2 = 20;
      i1 = i3;
      i27 = 50;
      break;
     } while (0);
     if ((i27 | 0) == 50) {
      i27 = 0;
      i1 = i1 + i24 | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i15 >> 2] = i5;
      HEAP32[i16 >> 2] = i7;
      if (!(HEAP8[i4 >> 0] | 0)) i27 = 52; else {
       HEAP32[i17 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i26 >> 2] = i2;
      }
     }
     if ((i27 | 0) == 52) HEAP32[i17 >> 2] = _UNITY_FT_MulFix(i1, i5) | 0;
     i5 = HEAP32[i13 >> 2] | 0;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i25 + 4 >> 2] = 0;
     HEAP32[i25 + 8 >> 2] = 0;
     HEAP32[i25 + 12 >> 2] = 0;
     HEAP32[i25 + 16 >> 2] = 0;
     i4 = _cf2_arrstack_getPointer(i31, i7) | 0;
     i1 = HEAP32[i4 + 8 >> 2] | 0;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
     i2 = i1 - i3 | 0;
     L89 : do if ((i2 | 0) < -1310720) {
      switch (i2 | 0) {
      case -1376256:
       break;
      default:
       {
        i27 = 56;
        break L89;
       }
      }
      HEAP32[i25 >> 2] = 0;
      HEAP32[i18 >> 2] = i24;
      HEAP32[i10 >> 2] = i5;
      HEAP32[i11 >> 2] = i7;
      i1 = i24;
      i27 = 61;
     } else {
      switch (i2 | 0) {
      case -1310720:
       break;
      default:
       {
        i27 = 56;
        break L89;
       }
      }
      HEAP32[i18 >> 2] = i3;
      HEAP32[i25 >> 2] = 2;
      i2 = 18;
      i1 = i3;
      i27 = 59;
     } while (0);
     do if ((i27 | 0) == 56) if ((i2 | 0) < 0) {
      HEAP32[i18 >> 2] = i3;
      HEAP32[i25 >> 2] = 8;
      i2 = 24;
      i1 = i3;
      i27 = 59;
      break;
     } else {
      HEAP32[i18 >> 2] = i1;
      HEAP32[i25 >> 2] = 8;
      i2 = 24;
      i27 = 59;
      break;
     } while (0);
     if ((i27 | 0) == 59) {
      i27 = 0;
      i1 = i1 + (HEAP32[i9 >> 2] << 1) + i24 | 0;
      HEAP32[i18 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      HEAP32[i11 >> 2] = i7;
      if (!(HEAP8[i4 >> 0] | 0)) i27 = 61; else {
       HEAP32[i12 >> 2] = HEAP32[i4 + 16 >> 2];
       HEAP32[i25 >> 2] = i2;
      }
     }
     if ((i27 | 0) == 61) {
      i27 = 0;
      HEAP32[i12 >> 2] = _UNITY_FT_MulFix(i1, i5) | 0;
     }
     _cf2_hintmap_insertHint(i30, i26, i25);
    }
    i1 = (i7 & 7 | 0) == 7;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i23 | 0)) break; else {
     i8 = i1 ? 128 : i8 >>> 1 & 127;
     i6 = i1 ? i6 + 1 | 0 : i6;
    }
   }
  }
 } while (0);
 i13 = i30 + 8 | 0;
 _cf2_arrstack_clear(HEAP32[i13 >> 2] | 0);
 i2 = HEAP32[i29 >> 2] | 0;
 if (i2 | 0) {
  i12 = i26 + 4 | 0;
  i1 = 0;
  do {
   i25 = HEAP32[i30 + 28 + (i1 * 20 | 0) >> 2] | 0;
   i9 = (i25 & 12 | 0) != 0;
   i10 = i1 + 1 | 0;
   i11 = i9 ? i10 : i1;
   if (!(i25 & 16)) {
    i7 = i30 + 28 + (i1 * 20 | 0) + 12 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i24 = i6 & 65535;
    i8 = i30 + 28 + (i11 * 20 | 0) + 12 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i5 = i4 & 65535;
    i25 = 0 - i24 | 0;
    i3 = 0 - i5 | 0;
    i24 = (i24 | 0) == 0 ? 0 : 65536 - i24 | 0;
    i5 = (i5 | 0) == 0 ? 0 : 65536 - i5 | 0;
    i5 = i24 >>> 0 < i5 >>> 0 ? i24 : i5;
    i3 = (i25 | 0) > (i3 | 0) ? i25 : i3;
    do if (i11 >>> 0 < (i2 + -1 | 0) >>> 0) {
     i2 = i11 + 1 | 0;
     if ((HEAP32[i30 + 28 + (i2 * 20 | 0) + 12 >> 2] | 0) < (i4 + 32768 + i5 | 0)) {
      if (!i1) i27 = 74; else if ((HEAP32[i30 + 28 + ((i1 + -1 | 0) * 20 | 0) + 12 >> 2] | 0) > (i6 + -32768 + i3 | 0)) i3 = 0; else i27 = 74;
      if ((i27 | 0) == 74) {
       i27 = 0;
       if ((i5 | 0) >= (0 - i3 | 0)) {
        i2 = i6;
        break;
       }
      }
      if (!(HEAP32[i30 + 28 + (i2 * 20 | 0) >> 2] & 16)) {
       HEAP32[i26 >> 2] = i11;
       HEAP32[i12 >> 2] = i5 - i3;
       _cf2_arrstack_push(HEAP32[i13 >> 2] | 0, i26);
       i2 = HEAP32[i7 >> 2] | 0;
      } else i2 = i6;
     } else i27 = 69;
    } else i27 = 69; while (0);
    do if ((i27 | 0) == 69) {
     i27 = 0;
     if (i1 | 0) if ((HEAP32[i30 + 28 + ((i1 + -1 | 0) * 20 | 0) + 12 >> 2] | 0) > (i6 + -32768 + i3 | 0)) {
      i3 = i5;
      i2 = i6;
      break;
     }
     i3 = (i5 | 0) > (0 - i3 | 0) ? i3 : i5;
     i2 = i6;
    } while (0);
    HEAP32[i7 >> 2] = i3 + i2;
    if (i9) HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i3;
   }
   if (i1 | 0) {
    i2 = HEAP32[i30 + 28 + (i1 * 20 | 0) + 8 >> 2] | 0;
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i30 + 28 + (i3 * 20 | 0) + 8 >> 2] | 0;
    if ((i2 | 0) != (i4 | 0)) HEAP32[i30 + 28 + (i3 * 20 | 0) + 16 >> 2] = _UNITY_FT_DivFix((HEAP32[i30 + 28 + (i1 * 20 | 0) + 12 >> 2] | 0) - (HEAP32[i30 + 28 + (i3 * 20 | 0) + 12 >> 2] | 0) | 0, i2 - i4 | 0) | 0;
   }
   if (i9) {
    i1 = HEAP32[i30 + 28 + (i11 * 20 | 0) + 8 >> 2] | 0;
    i2 = i11 + -1 | 0;
    i3 = HEAP32[i30 + 28 + (i2 * 20 | 0) + 8 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) i1 = i10; else {
     HEAP32[i30 + 28 + (i2 * 20 | 0) + 16 >> 2] = _UNITY_FT_DivFix((HEAP32[i30 + 28 + (i11 * 20 | 0) + 12 >> 2] | 0) - (HEAP32[i30 + 28 + (i2 * 20 | 0) + 12 >> 2] | 0) | 0, i1 - i3 | 0) | 0;
     i1 = i10;
    }
   }
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i29 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = _cf2_arrstack_size(HEAP32[i13 >> 2] | 0) | 0;
 if (i1 | 0) do {
  i1 = i1 + -1 | 0;
  i5 = _cf2_arrstack_getPointer(HEAP32[i13 >> 2] | 0, i1) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = i30 + 28 + (i4 * 20 | 0) + 12 | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i5 + (HEAP32[i2 >> 2] | 0) | 0;
  if ((HEAP32[i30 + 28 + ((i4 + 1 | 0) * 20 | 0) + 12 >> 2] | 0) >= (i3 + 32768 | 0)) {
   HEAP32[i2 >> 2] = i3;
   i2 = i30 + 28 + ((i4 + -1 | 0) * 20 | 0) + 12 | 0;
   if (HEAP32[i30 + 28 + (i4 * 20 | 0) >> 2] & 12 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
  }
 } while ((i1 | 0) != 0);
 if (!i28) {
  i1 = HEAP32[i29 >> 2] | 0;
  if (i1 | 0) {
   i4 = 0;
   do {
    i3 = i30 + 28 + (i4 * 20 | 0) | 0;
    if (!(HEAP32[i3 >> 2] & 32)) {
     i1 = _cf2_arrstack_getPointer(i31, HEAP32[i30 + 28 + (i4 * 20 | 0) + 4 >> 2] | 0) | 0;
     i2 = HEAP32[i30 + 28 + (i4 * 20 | 0) + 12 >> 2] | 0;
     if (!(HEAP32[i3 >> 2] & 10)) HEAP32[i1 + 12 >> 2] = i2; else HEAP32[i1 + 16 >> 2] = i2;
     HEAP8[i1 >> 0] = 1;
     i1 = HEAP32[i29 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i1 >>> 0);
  }
 }
 HEAP8[i30 + 12 >> 0] = 1;
 _cf2_hintmask_setNew(i32, 0);
 STACKTOP = i33;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i4, i12, i2, i1) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i4 + (i2 >> 1 << 4) | 0;
 if ((i2 | 0) < 65) {
  i1 = i10;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0 : 0)) {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  i8 = i12;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i7 >>> 0 < i1 >>> 0 | ((i7 | 0) == (i1 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
   HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (!(i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0 : 0))) {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   STACKTOP = i11;
   return;
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  STACKTOP = i11;
  return;
 }
 i6 = i2 >> 3;
 i7 = i6 << 1;
 i8 = i4 + (i6 << 4) | 0;
 i3 = i4 + (i7 << 4) | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 if (i2 >>> 0 < i13 >>> 0 | ((i2 | 0) == (i13 | 0) ? i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i8;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i3;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 if (i5 >>> 0 < i2 >>> 0 | ((i5 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i8;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i5 >>> 0 | ((i2 | 0) == (i5 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 }
 i5 = 0 - i6 | 0;
 i4 = i10 + (i5 << 4) | 0;
 i3 = i10 + (i6 << 4) | 0;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i4;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0 | ((i2 | 0) == (i6 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i3;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i6 >>> 0 < i2 >>> 0 | ((i6 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0 | ((i2 | 0) == (i6 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 }
 i3 = i12 + (0 - i7 << 4) | 0;
 i4 = i12 + (i5 << 4) | 0;
 i1 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = i3;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i2 = i4;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i13 = i12;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i7 >>> 0 < i1 >>> 0 | ((i7 | 0) == (i1 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i2 = i4;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i13 = i3;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 }
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i8;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i2 >>> 0 < i7 >>> 0 | ((i2 | 0) == (i7 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i4;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (i7 >>> 0 < i2 >>> 0 | ((i7 | 0) == (i2 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0 : 0)) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i10;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i13 = i8;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 if (!(i2 >>> 0 < i7 >>> 0 | ((i2 | 0) == (i7 | 0) ? i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  STACKTOP = i11;
  return;
 };
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 STACKTOP = i11;
 return;
}

function __ZNK14dtNavMeshQuery22findLocalNeighbourhoodEyPKffPK13dtQueryFilterPyS5_Pii(i47, i6, i7, i53, f5, i8, i54, i55, i56, i57) {
 i47 = i47 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i53 = i53 | 0;
 f5 = Math_fround(f5);
 i8 = i8 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i58 = 0, f59 = f0, i60 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i58 + 168 | 0;
 i49 = i58 + 96 | 0;
 i50 = i58 + 24 | 0;
 i51 = i58 + 12 | 0;
 i52 = i58;
 HEAP32[i56 >> 2] = 0;
 if ((i6 | 0) == 0 & (i7 | 0) == 0) {
  i57 = -2147483640;
  STACKTOP = i58;
  return i57 | 0;
 }
 i1 = HEAP32[i47 >> 2] | 0;
 i2 = _bitshift64Lshr(i6 | 0, i7 | 0, 48) | 0;
 getTempRet0() | 0;
 i3 = _bitshift64Lshr(i6 | 0, i7 | 0, 20) | 0;
 getTempRet0() | 0;
 i3 = i3 & 268435455;
 i4 = i6 & 65535;
 if ((i6 & 983040 | 0) == 65536 & 0 == 0) {
  if (i4 >>> 0 >= (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
  if ((HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + (i4 * 104 | 0) + 92 >> 2] | 0) != (i2 | 0)) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
 } else {
  if (i3 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
  i1 = HEAP32[i1 + 20 >> 2] | 0;
  if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) != (i2 | 0)) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
  i1 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
  if (i4 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i57 = -2147483640;
   STACKTOP = i58;
   return i57 | 0;
  }
 }
 i45 = i47 + 72 | 0;
 i4 = HEAP32[i45 >> 2] | 0;
 _memset(HEAP32[i4 + 4 >> 2] | 0, -1, HEAP32[i4 + 16 >> 2] << 1 | 0) | 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i4 = __ZN10dtNodePool7getNodeEy(HEAP32[i45 >> 2] | 0, i6, i7) | 0;
 i43 = i4 + 24 | 0;
 HEAP32[i43 >> 2] = i6;
 HEAP32[i43 + 4 >> 2] = i7;
 HEAP32[i4 + 20 >> 2] = -2147483648;
 HEAP32[i48 >> 2] = i4;
 f44 = Math_fround(f5 * f5);
 if ((i57 | 0) > 0) {
  i43 = i54;
  HEAP32[i43 >> 2] = i6;
  HEAP32[i43 + 4 >> 2] = i7;
  if (!i55) {
   i1 = 1073741824;
   i2 = 1;
  } else {
   i1 = i55;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 1073741824;
   i2 = 1;
  }
 } else {
  i1 = 1073741840;
  i2 = 0;
 }
 i39 = i8 + 128 | 0;
 i40 = i52 + 8 | 0;
 i41 = i51 + 8 | 0;
 i42 = i53 + 8 | 0;
 i43 = (i55 | 0) == 0;
 i3 = 1;
 i14 = i2;
 while (1) {
  i13 = i3 + -1 | 0;
  if ((i3 | 0) > 1) {
   i2 = 0;
   do {
    i38 = i2;
    i2 = i2 + 1 | 0;
    HEAP32[i48 + (i38 << 2) >> 2] = HEAP32[i48 + (i2 << 2) >> 2];
   } while ((i2 | 0) != (i13 | 0));
  }
  i37 = i4 + 24 | 0;
  i36 = HEAP32[i37 >> 2] | 0;
  i37 = HEAP32[i37 + 4 >> 2] | 0;
  i8 = HEAP32[i47 >> 2] | 0;
  i38 = (i36 & 983040 | 0) == 65536 & 0 == 0;
  if (i38) {
   i3 = i36 & 65535;
   if (i3 >>> 0 > (HEAP32[i8 + 44 >> 2] | 0) >>> 0) {
    i3 = i13;
    i2 = i14;
   } else {
    i35 = _bitshift64Lshr(i36 | 0, i37 | 0, 48) | 0;
    getTempRet0() | 0;
    i2 = HEAP32[i8 + 48 >> 2] | 0;
    if ((i2 + (i3 * 104 | 0) | 0) == 0 ? 1 : (i35 | 0) != (HEAP32[i2 + (i3 * 104 | 0) + 92 >> 2] | 0)) {
     i3 = i13;
     i2 = i14;
    } else {
     i2 = HEAP32[i2 + (i3 * 104 | 0) + 88 >> 2] | 0;
     if ((i2 | 0) == -1) {
      i3 = i13;
      i2 = i14;
     } else {
      i2 = (HEAP32[i8 + 36 >> 2] | 0) + (i2 << 4) | 0;
      i46 = 28;
     }
    }
   }
  } else if ((i36 | 0) == 0 & (i37 | 0) == 0) {
   i3 = i13;
   i2 = i14;
  } else {
   i2 = _bitshift64Lshr(i36 | 0, i37 | 0, 20) | 0;
   getTempRet0() | 0;
   i2 = i2 & 268435455;
   i3 = i36 & 65535;
   if (i2 >>> 0 < (HEAP32[i8 + 16 >> 2] | 0) >>> 0) {
    i35 = _bitshift64Lshr(i36 | 0, i37 | 0, 48) | 0;
    getTempRet0() | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    if ((HEAP32[i6 + (i2 * 56 | 0) + 4 >> 2] | 0) == (i35 | 0)) {
     i7 = HEAP32[i6 + (i2 * 56 | 0) + 8 >> 2] | 0;
     if (!i7) {
      i3 = i13;
      i2 = i14;
     } else if (i3 >>> 0 < (HEAP32[i7 + 20 >> 2] | 0) >>> 0) {
      i2 = HEAP32[(HEAP32[i6 + (i2 * 56 | 0) + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      if ((i2 | 0) == -1) {
       i3 = i13;
       i2 = i14;
      } else {
       i2 = (HEAP32[i8 + 36 >> 2] | 0) + (i2 << 4) | 0;
       i46 = 28;
      }
     } else {
      i3 = i13;
      i2 = i14;
     }
    } else {
     i3 = i13;
     i2 = i14;
    }
   } else {
    i3 = i13;
    i2 = i14;
   }
  }
  L44 : do if ((i46 | 0) == 28) {
   i46 = 0;
   if (!i2) {
    i3 = i13;
    i2 = i14;
   } else {
    i32 = i36 & 65535;
    i33 = _bitshift64Lshr(i36 | 0, i37 | 0, 48) | 0;
    getTempRet0() | 0;
    i34 = (i36 | 0) == 0 & (i37 | 0) == 0;
    i35 = _bitshift64Lshr(i36 | 0, i37 | 0, 20) | 0;
    getTempRet0() | 0;
    i35 = i35 & 268435455;
    i31 = i2;
    i2 = i14;
    i3 = i13;
    do {
     i29 = i31;
     i28 = HEAP32[i29 >> 2] | 0;
     i29 = HEAP32[i29 + 4 >> 2] | 0;
     if (!((i28 | 0) == 0 & (i29 | 0) == 0 | (i28 & 983040 | 0) == 65536 & 0 == 0)) {
      i30 = __ZN10dtNodePool7getNodeEy(HEAP32[i45 >> 2] | 0, i28, i29) | 0;
      if (i30) {
       i6 = i30 + 20 | 0;
       if ((HEAP32[i6 >> 2] | 0) >= 0) {
        i27 = HEAP32[i47 >> 2] | 0;
        i14 = _bitshift64Lshr(i28 | 0, i29 | 0, 20) | 0;
        getTempRet0() | 0;
        i14 = i14 & 268435455;
        i15 = i28 & 65535;
        if (HEAP32[i39 >> 2] & HEAP32[(HEAP32[(HEAP32[i27 + 20 >> 2] | 0) + (i14 * 56 | 0) + 16 >> 2] | 0) + (i15 << 5) + 24 >> 2]) do if (__ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_(i47, i36, i37, i28, i29, i51, i52) | 0) {
         f5 = Math_fround(HEAPF32[i52 >> 2]);
         f10 = Math_fround(HEAPF32[i51 >> 2]);
         f5 = Math_fround(f5 - f10);
         f9 = Math_fround(HEAPF32[i40 >> 2]);
         f11 = Math_fround(HEAPF32[i41 >> 2]);
         f9 = Math_fround(f9 - f11);
         f10 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) - f10);
         f11 = Math_fround(Math_fround(HEAPF32[i42 >> 2]) - f11);
         f12 = Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9));
         if (f12 == Math_fround(0.0)) f5 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)); else {
          f59 = Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(f9 * f11)) / f12);
          i27 = f59 < Math_fround(0.0);
          i26 = f59 > Math_fround(1.0);
          f59 = i26 ? Math_fround(1.0) : f59;
          f59 = i27 ? Math_fround(0.0) : f59;
          f12 = Math_fround(Math_fround(f5 * f59) - f10);
          f5 = Math_fround(Math_fround(f9 * f59) - f11);
          f5 = Math_fround(Math_fround(f12 * f12) + Math_fround(f5 * f5));
         }
         if (!(f5 > f44)) {
          i16 = HEAP32[i6 >> 2] | -2147483648;
          HEAP32[i6 >> 2] = i16;
          HEAP32[i6 >> 2] = i16 & -1073741824 | (i4 - (HEAP32[HEAP32[i45 >> 2] >> 2] | 0) >> 5) + 1 & 1073741823;
          i16 = HEAP32[i47 >> 2] | 0;
          do if (i14 >>> 0 < (HEAP32[i16 + 16 >> 2] | 0) >>> 0) {
           i27 = _bitshift64Lshr(i28 | 0, i29 | 0, 48) | 0;
           getTempRet0() | 0;
           i7 = HEAP32[i16 + 20 >> 2] | 0;
           if ((HEAP32[i7 + (i14 * 56 | 0) + 4 >> 2] | 0) != (i27 | 0)) {
            i13 = 0;
            break;
           }
           i6 = HEAP32[i7 + (i14 * 56 | 0) + 8 >> 2] | 0;
           if (!i6) {
            i13 = 0;
            break;
           }
           if (i15 >>> 0 >= (HEAP32[i6 + 20 >> 2] | 0) >>> 0) {
            i13 = 0;
            break;
           }
           i8 = HEAP32[i7 + (i14 * 56 | 0) + 16 >> 2] | 0;
           i27 = HEAP8[i8 + (i15 << 5) + 28 >> 0] | 0;
           i13 = i27 & 255;
           if (!(i27 << 24 >> 24)) break;
           i7 = HEAP32[i7 + (i14 * 56 | 0) + 20 >> 2] | 0;
           i6 = 0;
           do {
            i27 = i49 + (i6 * 3 << 2) | 0;
            i26 = i7 + ((HEAPU16[i8 + (i15 << 5) + (i6 << 1) >> 1] | 0) * 3 << 2) | 0;
            HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
            HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
            HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
            i6 = i6 + 1 | 0;
           } while ((i6 | 0) != (i13 | 0));
          } else i13 = 0; while (0);
          if ((i2 | 0) > 0) {
           i20 = i16 + 44 | 0;
           i21 = i16 + 48 | 0;
           i22 = i16 + 36 | 0;
           i23 = i16 + 16 | 0;
           i24 = i16 + 20 | 0;
           i25 = i16 + 36 | 0;
           i26 = i16 + 16 | 0;
           i27 = i16 + 20 | 0;
           i19 = i16 + 36 | 0;
           i18 = 0;
           i6 = 0;
           do {
            i17 = i54 + (i18 << 3) | 0;
            i15 = HEAP32[i17 >> 2] | 0;
            i17 = HEAP32[i17 + 4 >> 2] | 0;
            do if (i38) {
             if (i32 >>> 0 > (HEAP32[i20 >> 2] | 0) >>> 0) {
              i46 = 65;
              break;
             }
             i7 = HEAP32[i21 >> 2] | 0;
             if ((i7 + (i32 * 104 | 0) | 0) == 0 ? 1 : (i33 | 0) != (HEAP32[i7 + (i32 * 104 | 0) + 92 >> 2] | 0)) {
              i46 = 65;
              break;
             }
             i7 = HEAP32[i7 + (i32 * 104 | 0) + 88 >> 2] | 0;
             if ((i7 | 0) == -1) {
              i46 = 65;
              break;
             }
             i7 = (HEAP32[i22 >> 2] | 0) + (i7 << 4) | 0;
             i46 = 61;
            } else {
             if (i34) {
              i46 = 65;
              break;
             }
             if (i35 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) {
              i46 = 65;
              break;
             }
             i7 = HEAP32[i27 >> 2] | 0;
             if ((HEAP32[i7 + (i35 * 56 | 0) + 4 >> 2] | 0) != (i33 | 0)) {
              i46 = 65;
              break;
             }
             i8 = HEAP32[i7 + (i35 * 56 | 0) + 8 >> 2] | 0;
             if (!i8) {
              i46 = 65;
              break;
             }
             if (i32 >>> 0 >= (HEAP32[i8 + 20 >> 2] | 0) >>> 0) {
              i46 = 65;
              break;
             }
             i7 = HEAP32[(HEAP32[i7 + (i35 * 56 | 0) + 12 >> 2] | 0) + (i32 << 2) >> 2] | 0;
             if ((i7 | 0) == -1) {
              i46 = 65;
              break;
             }
             i7 = (HEAP32[i19 >> 2] | 0) + (i7 << 4) | 0;
             i46 = 61;
            } while (0);
            L86 : do if ((i46 | 0) == 61) {
             i46 = 0;
             if (!i7) {
              i46 = 65;
              break;
             }
             while (1) {
              i16 = i7;
              if ((HEAP32[i16 >> 2] | 0) == (i15 | 0) ? (HEAP32[i16 + 4 >> 2] | 0) == (i17 | 0) : 0) break L86;
              i7 = HEAP32[i7 + 8 >> 2] | 0;
              if ((i7 | 0) == -1) {
               i46 = 65;
               break L86;
              }
              i7 = (HEAP32[i25 >> 2] | 0) + (i7 << 4) | 0;
              if (!i7) {
               i46 = 65;
               break;
              }
             }
            } while (0);
            if ((i46 | 0) == 65) {
             i46 = 0;
             do if ((i15 | 0) == 0 & (i17 | 0) == 0 | (i15 & 983040 | 0) == 65536 & 0 == 0) i7 = 0; else {
              i14 = _bitshift64Lshr(i15 | 0, i17 | 0, 20) | 0;
              getTempRet0() | 0;
              i14 = i14 & 268435455;
              i16 = i15 & 65535;
              if (i14 >>> 0 >= (HEAP32[i23 >> 2] | 0) >>> 0) {
               i7 = 0;
               break;
              }
              i17 = _bitshift64Lshr(i15 | 0, i17 | 0, 48) | 0;
              getTempRet0() | 0;
              i8 = HEAP32[i24 >> 2] | 0;
              if ((HEAP32[i8 + (i14 * 56 | 0) + 4 >> 2] | 0) != (i17 | 0)) {
               i7 = 0;
               break;
              }
              i7 = HEAP32[i8 + (i14 * 56 | 0) + 8 >> 2] | 0;
              if (!i7) {
               i7 = 0;
               break;
              }
              if (i16 >>> 0 >= (HEAP32[i7 + 20 >> 2] | 0) >>> 0) {
               i7 = 0;
               break;
              }
              i15 = HEAP32[i8 + (i14 * 56 | 0) + 16 >> 2] | 0;
              i17 = HEAP8[i15 + (i16 << 5) + 28 >> 0] | 0;
              i7 = i17 & 255;
              if (!(i17 << 24 >> 24)) break;
              i14 = HEAP32[i8 + (i14 * 56 | 0) + 20 >> 2] | 0;
              i8 = 0;
              do {
               i17 = i50 + (i8 * 3 << 2) | 0;
               i60 = i14 + ((HEAPU16[i15 + (i16 << 5) + (i8 << 1) >> 1] | 0) * 3 << 2) | 0;
               HEAP32[i17 >> 2] = HEAP32[i60 >> 2];
               HEAP32[i17 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
               HEAP32[i17 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
               i8 = i8 + 1 | 0;
              } while ((i8 | 0) != (i7 | 0));
             } while (0);
             i60 = __Z19dtOverlapPolyPoly2DPKfiS0_i(i49, i13, i50, i7) | 0;
             i6 = i6 | i60;
             if (i60) break;
            }
            i18 = i18 + 1 | 0;
           } while ((i18 | 0) < (i2 | 0));
           if (i6) break;
          }
          if ((i2 | 0) < (i57 | 0)) {
           i60 = i54 + (i2 << 3) | 0;
           HEAP32[i60 >> 2] = i28;
           HEAP32[i60 + 4 >> 2] = i29;
           if (!i43) {
            i60 = i55 + (i2 << 3) | 0;
            HEAP32[i60 >> 2] = i36;
            HEAP32[i60 + 4 >> 2] = i37;
           }
           i2 = i2 + 1 | 0;
          } else i1 = i1 | 16;
          if ((i3 | 0) >= 48) break;
          HEAP32[i48 + (i3 << 2) >> 2] = i30;
          i3 = i3 + 1 | 0;
         }
        } while (0);
       }
      }
     }
     i6 = HEAP32[i31 + 8 >> 2] | 0;
     if ((i6 | 0) == -1) break L44;
     i31 = (HEAP32[(HEAP32[i47 >> 2] | 0) + 36 >> 2] | 0) + (i6 << 4) | 0;
    } while ((i31 | 0) != 0);
   }
  } while (0);
  if (!i3) break;
  i14 = i2;
  i4 = HEAP32[i48 >> 2] | 0;
 }
 HEAP32[i56 >> 2] = i2;
 i60 = i1;
 STACKTOP = i58;
 return i60 | 0;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl14createPropertyEN5physx8debugger18NonNegativeIntegerEPKcS5_S3_NS2_12PropertyType4EnumE(i29, i26, i1, i18, i20, i30, i19) {
 i29 = i29 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i30 = i30 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31 + 16 | 0;
 i21 = i31 + 28 | 0;
 i24 = i31;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) {
  i6 = HEAP32[i26 + 128 >> 2] | 0;
  if ((i6 | 0) > (i1 | 0)) {
   i7 = HEAP32[i26 + 124 >> 2] | 0;
   i28 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
   if (i28 | 0) {
    if (HEAP8[i28 + 68 >> 0] | 0) {
     HEAP32[i29 >> 2] = gb + 148864 + 8;
     HEAP32[i29 + 4 >> 2] = gb + 1576256;
     HEAP32[i29 + 8 >> 2] = gb + 1576256;
     HEAP32[i29 + 12 >> 2] = -1;
     HEAP32[i29 + 16 >> 2] = gb + 1576256;
     HEAP32[i29 + 20 >> 2] = gb + 1576256;
     HEAP32[i29 + 24 >> 2] = -1;
     HEAP32[i29 + 28 >> 2] = gb + 1576256;
     HEAP32[i29 + 32 >> 2] = gb + 1576256;
     HEAP32[i29 + 36 >> 2] = 0;
     HEAP32[i29 + 40 >> 2] = -1;
     HEAP32[i29 + 44 >> 2] = 0;
     HEAP32[i29 + 48 >> 2] = 0;
     HEAP8[i29 + 52 >> 0] = 0;
     STACKTOP = i31;
     return;
    }
    i23 = i28 + 88 | 0;
    i2 = HEAP32[i23 >> 2] | 0;
    L9 : do if (i2 | 0) {
     i3 = HEAP32[i28 + 84 >> 2] | 0;
     i4 = i18 | 0 ? i18 : gb + 1576256 | 0;
     i5 = 0;
     while (1) {
      i1 = HEAP32[i3 + (i5 << 2) >> 2] | 0;
      i25 = HEAP32[i1 + 16 >> 2] | 0;
      i5 = i5 + 1 | 0;
      if (!(_strcmp(i25 | 0 ? i25 : gb + 1576256 | 0, i4) | 0)) break;
      if (i5 >>> 0 >= i2 >>> 0) break L9;
     }
     if (i1 | 0) {
      HEAP32[i29 >> 2] = gb + 148864 + 8;
      HEAP32[i29 + 4 >> 2] = gb + 1576256;
      HEAP32[i29 + 8 >> 2] = gb + 1576256;
      HEAP32[i29 + 12 >> 2] = -1;
      HEAP32[i29 + 16 >> 2] = gb + 1576256;
      HEAP32[i29 + 20 >> 2] = gb + 1576256;
      HEAP32[i29 + 24 >> 2] = -1;
      HEAP32[i29 + 28 >> 2] = gb + 1576256;
      HEAP32[i29 + 32 >> 2] = gb + 1576256;
      HEAP32[i29 + 36 >> 2] = 0;
      HEAP32[i29 + 40 >> 2] = -1;
      HEAP32[i29 + 44 >> 2] = 0;
      HEAP32[i29 + 48 >> 2] = 0;
      HEAP8[i29 + 52 >> 0] = 0;
      STACKTOP = i31;
      return;
     }
    } while (0);
    i1 = HEAP32[i30 >> 2] | 0;
    if ((i1 | 0) == 77) {
     HEAP32[i29 >> 2] = gb + 148864 + 8;
     HEAP32[i29 + 4 >> 2] = gb + 1576256;
     HEAP32[i29 + 8 >> 2] = gb + 1576256;
     HEAP32[i29 + 12 >> 2] = -1;
     HEAP32[i29 + 16 >> 2] = gb + 1576256;
     HEAP32[i29 + 20 >> 2] = gb + 1576256;
     HEAP32[i29 + 24 >> 2] = -1;
     HEAP32[i29 + 28 >> 2] = gb + 1576256;
     HEAP32[i29 + 32 >> 2] = gb + 1576256;
     HEAP32[i29 + 36 >> 2] = 0;
     HEAP32[i29 + 40 >> 2] = -1;
     HEAP32[i29 + 44 >> 2] = 0;
     HEAP32[i29 + 48 >> 2] = 0;
     HEAP8[i29 + 52 >> 0] = 0;
     STACKTOP = i31;
     return;
    }
    if ((i1 | 0) > -1 & (i6 | 0) > (i1 | 0)) {
     i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
     if (i1 | 0) {
      i16 = i1 + 4 | 0;
      i15 = HEAP32[i16 >> 2] | 0;
      i16 = HEAP32[i16 + 4 >> 2] | 0;
      i25 = HEAP32[i1 + 20 >> 2] | 0;
      i22 = HEAP32[i1 + 24 >> 2] | 0;
      if (HEAP8[i1 + 69 >> 0] | 0) {
       HEAP32[i29 >> 2] = gb + 148864 + 8;
       HEAP32[i29 + 4 >> 2] = gb + 1576256;
       HEAP32[i29 + 8 >> 2] = gb + 1576256;
       HEAP32[i29 + 12 >> 2] = -1;
       HEAP32[i29 + 16 >> 2] = gb + 1576256;
       HEAP32[i29 + 20 >> 2] = gb + 1576256;
       HEAP32[i29 + 24 >> 2] = -1;
       HEAP32[i29 + 28 >> 2] = gb + 1576256;
       HEAP32[i29 + 32 >> 2] = gb + 1576256;
       HEAP32[i29 + 36 >> 2] = 0;
       HEAP32[i29 + 40 >> 2] = -1;
       HEAP32[i29 + 44 >> 2] = 0;
       HEAP32[i29 + 48 >> 2] = 0;
       HEAP8[i29 + 52 >> 0] = 0;
       STACKTOP = i31;
       return;
      }
      i14 = i28 + 69 | 0;
      i2 = (HEAP8[i14 >> 0] | 0) != 0;
      do if ((i19 | 0) == 2) {
       if ((i6 | 0) > 1) {
        i1 = HEAP32[i7 + 4 >> 2] | 0;
        if (i1 | 0) {
         i2 = 1;
         break;
        }
       }
       HEAP32[i29 >> 2] = gb + 148864 + 8;
       HEAP32[i29 + 4 >> 2] = gb + 1576256;
       HEAP32[i29 + 8 >> 2] = gb + 1576256;
       HEAP32[i29 + 12 >> 2] = -1;
       HEAP32[i29 + 16 >> 2] = gb + 1576256;
       HEAP32[i29 + 20 >> 2] = gb + 1576256;
       HEAP32[i29 + 24 >> 2] = -1;
       HEAP32[i29 + 28 >> 2] = gb + 1576256;
       HEAP32[i29 + 32 >> 2] = gb + 1576256;
       HEAP32[i29 + 36 >> 2] = 0;
       HEAP32[i29 + 40 >> 2] = -1;
       HEAP32[i29 + 44 >> 2] = 0;
       HEAP32[i29 + 48 >> 2] = 0;
       HEAP8[i29 + 52 >> 0] = 0;
       STACKTOP = i31;
       return;
      } while (0);
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i12 = HEAP32[i1 + 36 >> 2] | 0;
      i17 = i28 + 36 | 0;
      i11 = HEAP32[i17 >> 2] | 0;
      i11 = i11 >>> 0 < i12 >>> 0 ? i12 : i11;
      HEAP32[i17 >> 2] = i11;
      i17 = i28 + 32 | 0;
      i12 = i12 + -1 + (HEAP32[i17 >> 2] | 0) & 0 - i12;
      i13 = i12 + i13 | 0;
      HEAP32[i17 >> 2] = i13;
      HEAP32[i28 + 28 >> 2] = i11 + -1 + i13 & 0 - i11;
      i11 = HEAP32[i1 + 48 >> 2] | 0;
      i13 = HEAP32[i1 + 56 >> 2] | 0;
      i10 = i28 + 56 | 0;
      i5 = HEAP32[i10 >> 2] | 0;
      i5 = i5 >>> 0 < i13 >>> 0 ? i13 : i5;
      HEAP32[i10 >> 2] = i5;
      i10 = i28 + 52 | 0;
      i13 = i13 + -1 + (HEAP32[i10 >> 2] | 0) & 0 - i13;
      i11 = i13 + i11 | 0;
      HEAP32[i10 >> 2] = i11;
      HEAP32[i28 + 48 >> 2] = i5 + -1 + i11 & 0 - i5;
      i5 = i1 + 112 | 0;
      if (!(HEAP32[i5 >> 2] | 0)) {
       i4 = i28 + 108 | 0;
       i3 = i28 + 112 | 0;
      } else {
       i6 = i1 + 108 | 0;
       i7 = i27 + 4 | 0;
       i8 = i28 + 116 | 0;
       i3 = i28 + 112 | 0;
       i4 = i28 + 108 | 0;
       i9 = i28 + 96 | 0;
       i11 = 0;
       do {
        i32 = HEAP32[i6 >> 2] | 0;
        i10 = (HEAP32[i32 + (i11 << 3) + 4 >> 2] | 0) + i12 | 0;
        HEAP32[i27 >> 2] = HEAP32[i32 + (i11 << 3) >> 2];
        HEAP32[i7 >> 2] = i10;
        i10 = HEAP32[i3 >> 2] | 0;
        if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i10 >>> 0) {
         i34 = i27;
         i33 = HEAP32[i34 + 4 >> 2] | 0;
         i32 = (HEAP32[i4 >> 2] | 0) + (i10 << 3) | 0;
         HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
         HEAP32[i32 + 4 >> 2] = i33;
         HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
        } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i9, i27) | 0;
        i11 = i11 + 1 | 0;
       } while (i11 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
      }
      i34 = HEAP32[i4 >> 2] | 0;
      i5 = i34 + (HEAP32[i3 >> 2] << 3) | 0;
      HEAP32[i28 + 40 >> 2] = i34;
      HEAP32[i28 + 44 >> 2] = i5;
      i5 = i1 + 136 | 0;
      if (!(HEAP32[i5 >> 2] | 0)) {
       i4 = i28 + 132 | 0;
       i3 = i28 + 136 | 0;
      } else {
       i6 = i1 + 132 | 0;
       i7 = i27 + 4 | 0;
       i8 = i28 + 140 | 0;
       i3 = i28 + 136 | 0;
       i4 = i28 + 132 | 0;
       i9 = i28 + 120 | 0;
       i11 = 0;
       do {
        i34 = HEAP32[i6 >> 2] | 0;
        i10 = (HEAP32[i34 + (i11 << 3) + 4 >> 2] | 0) + i13 | 0;
        HEAP32[i27 >> 2] = HEAP32[i34 + (i11 << 3) >> 2];
        HEAP32[i7 >> 2] = i10;
        i10 = HEAP32[i3 >> 2] | 0;
        if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i10 >>> 0) {
         i32 = i27;
         i33 = HEAP32[i32 + 4 >> 2] | 0;
         i34 = (HEAP32[i4 >> 2] | 0) + (i10 << 3) | 0;
         HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
         HEAP32[i34 + 4 >> 2] = i33;
         HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
        } else __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i9, i27) | 0;
        i11 = i11 + 1 | 0;
       } while (i11 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
      }
      i32 = HEAP32[i4 >> 2] | 0;
      i6 = i32 + (HEAP32[i3 >> 2] << 3) | 0;
      HEAP32[i28 + 60 >> 2] = i32;
      HEAP32[i28 + 64 >> 2] = i6;
      HEAP8[i1 + 68 >> 0] = 1;
      HEAP8[i14 >> 0] = i2 & 1;
      i6 = i26 + 152 | 0;
      i32 = HEAP32[i6 >> 2] | 0;
      i3 = i28 + 4 | 0;
      i1 = HEAP32[i28 + 12 >> 2] | 0;
      i14 = HEAP32[i30 >> 2] | 0;
      i10 = i3;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      i33 = i26 + 4 | 0;
      i2 = HEAP32[i33 >> 2] | 0;
      i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 76, gb + 775119 | 0, gb + 774188 | 0, 822) | 0;
      i33 = HEAP32[i33 >> 2] | 0;
      i34 = HEAP32[i26 + 160 >> 2] | 0;
      i11 = i2 + 4 | 0;
      HEAP32[i11 >> 2] = i9;
      HEAP32[i11 + 4 >> 2] = i10;
      HEAP32[i2 + 12 >> 2] = i1;
      i1 = i2 + 16 | 0;
      i11 = i1;
      HEAP32[i11 >> 2] = i18;
      HEAP32[i11 + 4 >> 2] = i20;
      HEAP32[i2 + 24 >> 2] = i14;
      i20 = i2 + 28 | 0;
      HEAP32[i20 >> 2] = i15;
      HEAP32[i20 + 4 >> 2] = i16;
      HEAP32[i2 + 36 >> 2] = i19;
      HEAP32[i2 + 40 >> 2] = i32;
      i32 = i2 + 44 | 0;
      HEAP32[i32 >> 2] = i12;
      HEAP32[i32 + 4 >> 2] = i13;
      HEAP32[i2 >> 2] = gb + 148768 + 8;
      HEAP32[i2 + 56 >> 2] = i33;
      HEAP32[i2 + 60 >> 2] = gb + 774945;
      HEAP32[i2 + 64 >> 2] = 0;
      HEAP32[i2 + 68 >> 2] = 0;
      HEAP32[i2 + 72 >> 2] = 0;
      HEAP32[i2 + 52 >> 2] = gb + 148784 + 8;
      HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[(HEAP32[i34 >> 2] | 0) + 16 >> 2] | 0, i34 | 0, i18 | 0, i27 | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      i1 = HEAP32[i6 >> 2] | 0;
      if ((HEAP32[i26 + 156 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i5 = i26 + 148 | 0;
       HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i2;
       i1 = i1 + 1 | 0;
       HEAP32[i6 >> 2] = i1;
      } else {
       __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i26 + 136 | 0, i21) | 0;
       i1 = HEAP32[i6 >> 2] | 0;
       i5 = i26 + 148 | 0;
      }
      i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
      i2 = HEAP32[i1 + 16 >> 2] | 0;
      i32 = i3;
      i33 = HEAP32[i32 + 4 >> 2] | 0;
      i34 = i24;
      HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
      HEAP32[i34 + 4 >> 2] = i33;
      HEAP32[i24 + 8 >> 2] = i2;
      HEAP32[i27 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
      __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_(i26 + 60 | 0, i27, i1);
      i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 2) >> 2] | 0;
      HEAP32[i27 >> 2] = i1;
      i2 = HEAP32[i23 >> 2] | 0;
      if ((HEAP32[i28 + 92 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
       HEAP32[(HEAP32[i28 + 84 >> 2] | 0) + (i2 << 2) >> 2] = i1;
       i1 = i2 + 1 | 0;
       HEAP32[i23 >> 2] = i1;
      } else {
       __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i28 + 72 | 0, i27) | 0;
       i1 = HEAP32[i23 >> 2] | 0;
      }
      do if ((i1 | 0) == 1) {
       HEAP32[i28 + 20 >> 2] = i25;
       HEAP32[i28 + 24 >> 2] = i22;
      } else {
       i4 = (i25 | 0) > -1;
       if (i4) i3 = (((HEAP32[i17 >> 2] | 0) >>> 0) % (i25 >>> 0) | 0 | 0) != 0; else i3 = 1;
       i1 = i28 + 24 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       do if ((i2 | 0) > -1) {
        if ((i22 | 0) > -1 & (i2 | 0) == (i22 | 0)) if (!(i3 | (HEAP32[i30 >> 2] & -2 | 0) == 78)) break;
        HEAP32[i1 >> 2] = -1;
       } while (0);
       i1 = i28 + 20 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       if ((i2 | 0) <= -1) break;
       if (i4 & (i2 | 0) == (i25 | 0)) if (!(i3 | (HEAP32[i30 >> 2] & -2 | 0) == 78)) break;
       HEAP32[i1 >> 2] = -1;
      } while (0);
      i32 = HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 2) >> 2] | 0;
      HEAP32[i29 >> 2] = gb + 148864 + 8;
      i33 = i32 + 4 | 0;
      i34 = HEAP32[i33 + 4 >> 2] | 0;
      i30 = i29 + 4 | 0;
      HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
      HEAP32[i30 + 4 >> 2] = i34;
      HEAP32[i29 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
      i30 = i32 + 16 | 0;
      i34 = HEAP32[i30 + 4 >> 2] | 0;
      i33 = i29 + 16 | 0;
      HEAP32[i33 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i33 + 4 >> 2] = i34;
      HEAP32[i29 + 24 >> 2] = HEAP32[i32 + 24 >> 2];
      i33 = i29 + 28 | 0;
      i34 = i32 + 28 | 0;
      HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
      HEAP32[i33 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
      HEAP32[i33 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
      HEAP32[i29 + 40 >> 2] = HEAP32[i32 + 40 >> 2];
      i32 = i32 + 44 | 0;
      i33 = HEAP32[i32 + 4 >> 2] | 0;
      i34 = i29 + 44 | 0;
      HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
      HEAP32[i34 + 4 >> 2] = i33;
      HEAP8[i29 + 52 >> 0] = 1;
      STACKTOP = i31;
      return;
     }
    }
    HEAP32[i29 >> 2] = gb + 148864 + 8;
    HEAP32[i29 + 4 >> 2] = gb + 1576256;
    HEAP32[i29 + 8 >> 2] = gb + 1576256;
    HEAP32[i29 + 12 >> 2] = -1;
    HEAP32[i29 + 16 >> 2] = gb + 1576256;
    HEAP32[i29 + 20 >> 2] = gb + 1576256;
    HEAP32[i29 + 24 >> 2] = -1;
    HEAP32[i29 + 28 >> 2] = gb + 1576256;
    HEAP32[i29 + 32 >> 2] = gb + 1576256;
    HEAP32[i29 + 36 >> 2] = 0;
    HEAP32[i29 + 40 >> 2] = -1;
    HEAP32[i29 + 44 >> 2] = 0;
    HEAP32[i29 + 48 >> 2] = 0;
    HEAP8[i29 + 52 >> 0] = 0;
    STACKTOP = i31;
    return;
   }
  }
 }
 HEAP32[i29 >> 2] = gb + 148864 + 8;
 HEAP32[i29 + 4 >> 2] = gb + 1576256;
 HEAP32[i29 + 8 >> 2] = gb + 1576256;
 HEAP32[i29 + 12 >> 2] = -1;
 HEAP32[i29 + 16 >> 2] = gb + 1576256;
 HEAP32[i29 + 20 >> 2] = gb + 1576256;
 HEAP32[i29 + 24 >> 2] = -1;
 HEAP32[i29 + 28 >> 2] = gb + 1576256;
 HEAP32[i29 + 32 >> 2] = gb + 1576256;
 HEAP32[i29 + 36 >> 2] = 0;
 HEAP32[i29 + 40 >> 2] = -1;
 HEAP32[i29 + 44 >> 2] = 0;
 HEAP32[i29 + 48 >> 2] = 0;
 HEAP8[i29 + 52 >> 0] = 0;
 STACKTOP = i31;
 return;
}

function __ZN5Unity5Cloth8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i8, i10);
 i4 = i8 + 40 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839016 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839038 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 44 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839057 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 45 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839070 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839083 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 46; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 52 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839093 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839116 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839137 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 69; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 69; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 69) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839158 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 80; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 80; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 80) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839183 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 91; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 91; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 91) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839194 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 102; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 102; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 102) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839215 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 93 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839240 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839262 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 131; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 131; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 131) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839280 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i6 >>> 0) i7 = 142; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     i7 = 142;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i7 | 0) == 142) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 128 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839297 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839312 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) break;
   mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839331 | 0, i3, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES6_EELj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) break;
  mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i27, i28, i38, i49, i1, i2, i76, i77, i78, i79) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i38 = i38 | 0;
 i49 = i49 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i76 = i76 | 0;
 i77 = i77 | 0;
 i78 = i78 | 0;
 i79 = i79 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i80 = 0, f81 = f0, f82 = f0, f83 = f0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0, f105 = f0, f106 = f0, f107 = f0, f108 = f0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, f113 = f0, f114 = f0, f115 = f0, f116 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i80 + 96 | 0;
 i30 = i80 + 80 | 0;
 i31 = i80 + 64 | 0;
 i32 = i80 + 48 | 0;
 i33 = i80 + 32 | 0;
 i34 = i80 + 16 | 0;
 i35 = i80;
 if (i2 >>> 0 >= i76 >>> 0) {
  STACKTOP = i80;
  return;
 }
 i36 = i1 + 520 | 0;
 i37 = i29 + 4 | 0;
 i39 = i29 + 8 | 0;
 i40 = i29 + 12 | 0;
 i41 = i49 + 4 | 0;
 i42 = i49 + 8 | 0;
 i43 = i49 + 12 | 0;
 i44 = i49 + 16 | 0;
 i45 = i49 + 20 | 0;
 i46 = i49 + 24 | 0;
 i47 = i49 + 28 | 0;
 i48 = i49 + 32 | 0;
 i50 = i49 + 36 | 0;
 i51 = i49 + 40 | 0;
 i52 = i49 + 44 | 0;
 i53 = i49 + 48 | 0;
 i54 = i49 + 52 | 0;
 i55 = i49 + 56 | 0;
 i56 = i49 + 60 | 0;
 i57 = i30 + 4 | 0;
 i58 = i30 + 8 | 0;
 i59 = i30 + 12 | 0;
 i60 = i31 + 4 | 0;
 i61 = i31 + 8 | 0;
 i62 = i31 + 12 | 0;
 i63 = i32 + 4 | 0;
 i64 = i32 + 8 | 0;
 i65 = i32 + 12 | 0;
 i25 = i33 + 4 | 0;
 i26 = i33 + 8 | 0;
 i18 = i33 + 12 | 0;
 i19 = i34 + 4 | 0;
 i20 = i34 + 8 | 0;
 i21 = i34 + 12 | 0;
 i22 = i35 + 4 | 0;
 i23 = i35 + 8 | 0;
 i24 = i35 + 12 | 0;
 i66 = i78 + 12 | 0;
 i67 = i78 + 24 | 0;
 i68 = i78 + 4 | 0;
 i69 = i78 + 16 | 0;
 i70 = i78 + 28 | 0;
 i71 = i78 + 8 | 0;
 i72 = i78 + 20 | 0;
 i73 = i78 + 32 | 0;
 i74 = i1 + 60 | 0;
 i75 = i1 + 80 | 0;
 i14 = i1 + 100 | 0;
 i15 = i79 + 4 | 0;
 i16 = i79 + 8 | 0;
 i17 = i79 + 12 | 0;
 do {
  i9 = (HEAP32[i36 >> 2] | 0) + (i2 << 2) | 0;
  f92 = Math_fround(HEAPF32[i9 >> 2]);
  f81 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f82 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f81 = Math_fround(f81 * Math_fround(.00999999977));
  f82 = Math_fround(f82 * Math_fround(.00999999977));
  f83 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i29 >> 2] = Math_fround(f92 * Math_fround(.00999999977));
  HEAPF32[i37 >> 2] = f81;
  HEAPF32[i39 >> 2] = f82;
  HEAPF32[i40 >> 2] = f83;
  i9 = HEAP32[i49 >> 2] | 0;
  i13 = HEAP32[i41 >> 2] | 0;
  i10 = HEAP32[i42 >> 2] | 0;
  i6 = HEAP32[i43 >> 2] | 0;
  i9 = i9 << 11 ^ i9;
  i13 = i13 << 11 ^ i13;
  i10 = i10 << 11 ^ i10;
  i6 = i6 << 11 ^ i6;
  i1 = HEAP32[i44 >> 2] | 0;
  i4 = HEAP32[i45 >> 2] | 0;
  i3 = HEAP32[i46 >> 2] | 0;
  i5 = HEAP32[i47 >> 2] | 0;
  i7 = HEAP32[i48 >> 2] | 0;
  i11 = HEAP32[i50 >> 2] | 0;
  i12 = HEAP32[i51 >> 2] | 0;
  i8 = HEAP32[i52 >> 2] | 0;
  i91 = HEAP32[i53 >> 2] | 0;
  i90 = HEAP32[i54 >> 2] | 0;
  i89 = HEAP32[i55 >> 2] | 0;
  i88 = HEAP32[i56 >> 2] | 0;
  i9 = i9 >>> 8 ^ i9 ^ i91;
  i87 = i9 ^ i91 >>> 19;
  i13 = i13 >>> 8 ^ i13 ^ i90;
  i86 = i13 ^ i90 >>> 19;
  i10 = i10 >>> 8 ^ i10 ^ i89;
  i85 = i10 ^ i89 >>> 19;
  i6 = i6 >>> 8 ^ i6 ^ i88;
  i84 = i6 ^ i88 >>> 19;
  f83 = Math_fround(Math_fround(i86 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i85 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f81 = Math_fround(Math_fround(i84 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(i87 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i57 >> 2] = f83;
  HEAPF32[i58 >> 2] = f82;
  HEAPF32[i59 >> 2] = f81;
  i1 = i1 << 11 ^ i1;
  i4 = i4 << 11 ^ i4;
  i3 = i3 << 11 ^ i3;
  i5 = i5 << 11 ^ i5;
  i1 = i1 >>> 8 ^ i1 ^ i87;
  i9 = i1 ^ i9 >>> 19;
  i4 = i4 >>> 8 ^ i4 ^ i86;
  i13 = i4 ^ i13 >>> 19;
  i3 = i3 >>> 8 ^ i3 ^ i85;
  i10 = i3 ^ i10 >>> 19;
  i5 = i5 >>> 8 ^ i5 ^ i84;
  i6 = i5 ^ i6 >>> 19;
  f81 = Math_fround(Math_fround(i13 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i10 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f83 = Math_fround(Math_fround(i6 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i31 >> 2] = Math_fround(Math_fround(i9 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i60 >> 2] = f81;
  HEAPF32[i61 >> 2] = f82;
  HEAPF32[i62 >> 2] = f83;
  i7 = i7 << 11 ^ i7;
  i11 = i11 << 11 ^ i11;
  i12 = i12 << 11 ^ i12;
  i8 = i8 << 11 ^ i8;
  HEAP32[i49 >> 2] = i91;
  HEAP32[i41 >> 2] = i90;
  HEAP32[i42 >> 2] = i89;
  HEAP32[i43 >> 2] = i88;
  HEAP32[i44 >> 2] = i87;
  HEAP32[i45 >> 2] = i86;
  HEAP32[i46 >> 2] = i85;
  HEAP32[i47 >> 2] = i84;
  HEAP32[i48 >> 2] = i9;
  HEAP32[i50 >> 2] = i13;
  HEAP32[i51 >> 2] = i10;
  HEAP32[i52 >> 2] = i6;
  i1 = i7 >>> 8 ^ i7 ^ i9 ^ i1 >>> 19;
  i4 = i11 >>> 8 ^ i11 ^ i13 ^ i4 >>> 19;
  i3 = i12 >>> 8 ^ i12 ^ i10 ^ i3 >>> 19;
  i5 = i8 >>> 8 ^ i8 ^ i6 ^ i5 >>> 19;
  HEAP32[i53 >> 2] = i1;
  HEAP32[i54 >> 2] = i4;
  HEAP32[i55 >> 2] = i3;
  HEAP32[i56 >> 2] = i5;
  f83 = Math_fround(Math_fround(i4 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f82 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
  f81 = Math_fround(Math_fround(i5 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(i1 & 8388607 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i63 >> 2] = f83;
  HEAPF32[i64 >> 2] = f82;
  HEAPF32[i65 >> 2] = f81;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i33, i27, i29, i30);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i34, i28, i29, i31);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i35, i38, i29, i32);
  i1 = HEAP32[i33 >> 2] | 0;
  i5 = HEAP32[i25 >> 2] | 0;
  i3 = HEAP32[i26 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i6 = HEAP32[i34 >> 2] | 0;
  i8 = HEAP32[i19 >> 2] | 0;
  i10 = HEAP32[i20 >> 2] | 0;
  i12 = HEAP32[i21 >> 2] | 0;
  i13 = HEAP32[i35 >> 2] | 0;
  i11 = HEAP32[i22 >> 2] | 0;
  i9 = HEAP32[i23 >> 2] | 0;
  i7 = HEAP32[i24 >> 2] | 0;
  if (i77) {
   f98 = Math_fround(HEAPF32[i78 >> 2]);
   f101 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f82 = Math_fround(f101 * f98);
   f100 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f100 * f98);
   f99 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f81 = Math_fround(f99 * f98);
   f94 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f98 = Math_fround(f94 * f98);
   f105 = Math_fround(HEAPF32[i66 >> 2]);
   f97 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f108 = Math_fround(f97 * f105);
   f96 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f107 = Math_fround(f96 * f105);
   f95 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f106 = Math_fround(f95 * f105);
   f92 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f108 = Math_fround(f82 + f108);
   f107 = Math_fround(f102 + f107);
   f106 = Math_fround(f81 + f106);
   f105 = Math_fround(f98 + Math_fround(f92 * f105));
   f98 = Math_fround(HEAPF32[i67 >> 2]);
   f81 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f81 * f98);
   f82 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f103 = Math_fround(f82 * f98);
   f83 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f104 = Math_fround(f83 * f98);
   f93 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f102 = Math_fround(f108 + f102);
   f103 = Math_fround(f107 + f103);
   f104 = Math_fround(f106 + f104);
   f98 = Math_fround(f105 + Math_fround(f93 * f98));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
   f98 = Math_fround(HEAPF32[i68 >> 2]);
   f104 = Math_fround(f101 * f98);
   f103 = Math_fround(f100 * f98);
   f102 = Math_fround(f99 * f98);
   f98 = Math_fround(f94 * f98);
   f105 = Math_fround(HEAPF32[i69 >> 2]);
   f104 = Math_fround(f104 + Math_fround(f97 * f105));
   f103 = Math_fround(f103 + Math_fround(f96 * f105));
   f102 = Math_fround(f102 + Math_fround(f95 * f105));
   f105 = Math_fround(f98 + Math_fround(f92 * f105));
   f98 = Math_fround(HEAPF32[i70 >> 2]);
   f104 = Math_fround(f104 + Math_fround(f81 * f98));
   f103 = Math_fround(f103 + Math_fround(f82 * f98));
   f102 = Math_fround(f102 + Math_fround(f83 * f98));
   f98 = Math_fround(f105 + Math_fround(f93 * f98));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f104, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f103, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f102, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f98, HEAP32[tempDoublePtr >> 2] | 0);
   f98 = Math_fround(HEAPF32[i71 >> 2]);
   f101 = Math_fround(f101 * f98);
   f100 = Math_fround(f100 * f98);
   f99 = Math_fround(f99 * f98);
   f98 = Math_fround(f94 * f98);
   f94 = Math_fround(HEAPF32[i72 >> 2]);
   f97 = Math_fround(f101 + Math_fround(f97 * f94));
   f96 = Math_fround(f100 + Math_fround(f96 * f94));
   f95 = Math_fround(f99 + Math_fround(f95 * f94));
   f94 = Math_fround(f98 + Math_fround(f92 * f94));
   f92 = Math_fround(HEAPF32[i73 >> 2]);
   f81 = Math_fround(f97 + Math_fround(f81 * f92));
   f82 = Math_fround(f96 + Math_fround(f82 * f92));
   f83 = Math_fround(f95 + Math_fround(f83 * f92));
   f92 = Math_fround(f94 + Math_fround(f93 * f92));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f81, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f83, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f92, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i112 = (HEAP32[i74 >> 2] | 0) + (i2 << 2) | 0;
  f96 = Math_fround(HEAPF32[i112 >> 2]);
  i111 = i112 + 4 | 0;
  f116 = Math_fround(HEAPF32[i111 >> 2]);
  i110 = i112 + 8 | 0;
  f115 = Math_fround(HEAPF32[i110 >> 2]);
  i109 = i112 + 12 | 0;
  f114 = Math_fround(HEAPF32[i109 >> 2]);
  i84 = (HEAP32[i75 >> 2] | 0) + (i2 << 2) | 0;
  f113 = Math_fround(HEAPF32[i84 >> 2]);
  i85 = i84 + 4 | 0;
  f81 = Math_fround(HEAPF32[i85 >> 2]);
  i86 = i84 + 8 | 0;
  f82 = Math_fround(HEAPF32[i86 >> 2]);
  i87 = i84 + 12 | 0;
  f83 = Math_fround(HEAPF32[i87 >> 2]);
  i88 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f92 = Math_fround(HEAPF32[i88 >> 2]);
  i89 = i88 + 4 | 0;
  f93 = Math_fround(HEAPF32[i89 >> 2]);
  i90 = i88 + 8 | 0;
  f94 = Math_fround(HEAPF32[i90 >> 2]);
  i91 = i88 + 12 | 0;
  f95 = Math_fround(HEAPF32[i91 >> 2]);
  f97 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f105 = Math_fround(HEAPF32[i79 >> 2]);
  f97 = Math_fround(f97 * f105);
  f98 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f106 = Math_fround(HEAPF32[i15 >> 2]);
  f98 = Math_fround(f98 * f106);
  f99 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f107 = Math_fround(HEAPF32[i16 >> 2]);
  f99 = Math_fround(f99 * f107);
  f100 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f108 = Math_fround(HEAPF32[i17 >> 2]);
  f100 = Math_fround(f100 * f108);
  f101 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f105);
  f102 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
  f103 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f107);
  f104 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f108);
  f105 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f105);
  f106 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f106);
  f107 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f107);
  f98 = Math_fround(f116 + f98);
  f99 = Math_fround(f115 + f99);
  f100 = Math_fround(f114 + f100);
  f101 = Math_fround(f113 + f101);
  f102 = Math_fround(f81 + f102);
  f103 = Math_fround(f82 + f103);
  f104 = Math_fround(f83 + f104);
  f105 = Math_fround(f92 + f105);
  f106 = Math_fround(f93 + f106);
  f107 = Math_fround(f94 + f107);
  f108 = Math_fround(f95 + Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f108));
  HEAPF32[i112 >> 2] = Math_fround(f96 + f97);
  HEAPF32[i111 >> 2] = f98;
  HEAPF32[i110 >> 2] = f99;
  HEAPF32[i109 >> 2] = f100;
  HEAPF32[i84 >> 2] = f101;
  HEAPF32[i85 >> 2] = f102;
  HEAPF32[i86 >> 2] = f103;
  HEAPF32[i87 >> 2] = f104;
  HEAPF32[i88 >> 2] = f105;
  HEAPF32[i89 >> 2] = f106;
  HEAPF32[i90 >> 2] = f107;
  HEAPF32[i91 >> 2] = f108;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i76 >>> 0);
 STACKTOP = i80;
 return;
}

function __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i20, i22, i12) {
 i20 = i20 | 0;
 i22 = i22 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, f64 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i61 = i63 + 56 | 0;
 i60 = i63 + 28 | 0;
 i62 = i63;
 if (!(HEAP8[gb + 1546311 >> 0] | 0)) {
  i1 = 0;
  do {
   f64 = Math_fround(i1 | 0);
   i59 = ~~Math_fround(f64 * Math_fround(.298999995)) & 255;
   HEAP8[gb + 1160176 + (i1 << 2) >> 0] = i59;
   i59 = ~~Math_fround(f64 * Math_fround(.587000012)) & 255;
   HEAP8[gb + 1160176 + (i1 << 2) + 1 >> 0] = i59;
   i59 = ~~Math_fround(f64 * Math_fround(.114)) & 255;
   HEAP8[gb + 1160176 + (i1 << 2) + 2 >> 0] = i59;
   HEAP8[gb + 1160176 + (i1 << 2) + 3 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  HEAP8[gb + 1546311 >> 0] = 1;
 }
 i19 = i22 + 4 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 if (!i6) {
  STACKTOP = i63;
  return;
 }
 i57 = i22 + 8 | 0;
 i1 = HEAP32[i57 >> 2] | 0;
 if (!i1) {
  STACKTOP = i63;
  return;
 }
 i21 = i22 + 16 | 0;
 if (!(HEAP32[i21 >> 2] | 0)) {
  STACKTOP = i63;
  return;
 }
 i13 = i20 + 4 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 if (!i8) {
  STACKTOP = i63;
  return;
 }
 i58 = i20 + 8 | 0;
 i2 = HEAP32[i58 >> 2] | 0;
 if (!i2) {
  STACKTOP = i63;
  return;
 }
 i59 = i20 + 16 | 0;
 if (!(HEAP32[i59 >> 2] | 0)) {
  STACKTOP = i63;
  return;
 }
 i9 = HEAP32[i20 >> 2] | 0;
 i3 = HEAP32[i22 >> 2] | 0;
 i4 = (i9 | 0) != (i3 | 0);
 i5 = (i12 + -1 | 0) >>> 0 < 2 & ((i6 | 0) != (i8 | 0) | (i1 | 0) != (i2 | 0));
 if (!(i5 | i4)) {
  i7 = (i2 | 0) < (i1 | 0) ? i2 : i1;
  i6 = Math_imul(HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(i9) | 0) + 4 >> 2] | 0, (i8 | 0) < (i6 | 0) ? i8 : i6) | 0;
  if (!i7) {
   STACKTOP = i63;
   return;
  }
  i5 = i20 + 12 | 0;
  i4 = i22 + 12 | 0;
  i3 = HEAP32[i59 >> 2] | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = 0;
  while (1) {
   _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break; else {
    i3 = i3 + (HEAP32[i5 >> 2] | 0) | 0;
    i1 = i1 + (HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  STACKTOP = i63;
  return;
 }
 if (!(__Z19IsHalfTextureFormat13TextureFormat(i3) | 0)) if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i22 >> 2] | 0) | 0)) if (!(__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i20 >> 2] | 0) | 0)) if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i20 >> 2] | 0) | 0)) {
  if (!(i5 | i4 ^ 1)) {
   __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_(i60, HEAP32[i20 >> 2] | 0, HEAP32[i22 >> 2] | 0);
   HEAP32[i62 >> 2] = HEAP32[i21 >> 2];
   i7 = HEAP32[i19 >> 2] | 0;
   i18 = HEAP32[i13 >> 2] | 0;
   i7 = (i18 | 0) < (i7 | 0) ? i18 : i7;
   i18 = HEAP32[i57 >> 2] | 0;
   i15 = HEAP32[i58 >> 2] | 0;
   i18 = (i15 | 0) < (i18 | 0) ? i15 : i18;
   i15 = i62 + 12 | 0;
   HEAP32[i15 >> 2] = i7;
   i3 = HEAP32[i59 >> 2] | 0;
   i17 = i62 + 4 | 0;
   HEAP32[i17 >> 2] = i3;
   L40 : do if (!i18) i1 = i60 + 12 | 0; else {
    i2 = i60 + 4 | 0;
    i16 = i22 + 12 | 0;
    i14 = i20 + 12 | 0;
    i10 = i60 + 16 | 0;
    i1 = i60 + 12 | 0;
    i11 = i61 + 4 | 0;
    i12 = i61 + 12 | 0;
    if (!(HEAP8[i60 >> 0] | 0)) {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = 0;
     while (1) {
      mftCall_vi(i3 | 0, i62 | 0);
      HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + (HEAP32[i16 >> 2] | 0);
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i14 >> 2] | 0);
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i18 >>> 0) break L40;
     }
    }
    i13 = HEAP32[i60 + 20 >> 2] | 0;
    i9 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i60 + 8 >> 2] | 0;
    i2 = 0;
    i5 = HEAP32[i10 >> 2] | 0;
    while (1) {
     if (i5 >>> 0 < i7 >>> 0) {
      i4 = HEAP32[i1 >> 2] | 0;
      if (!i4) i4 = i7; else {
       __ZdaPv(i4);
       i3 = HEAP32[i17 >> 2] | 0;
       i4 = HEAP32[i15 >> 2] | 0;
      }
      i6 = __Znaj(Math_imul(i13, i7 + 1 | 0) | 0) | 0;
      HEAP32[i1 >> 2] = i6;
      _memset(i6 + (Math_imul(i13, i7) | 0) | 0, 0, i13 | 0) | 0;
      HEAP32[i10 >> 2] = i7;
      i5 = i7;
     } else {
      i6 = HEAP32[i1 >> 2] | 0;
      i4 = i7;
     }
     HEAP32[i11 >> 2] = i3;
     HEAP32[i61 >> 2] = i6;
     HEAP32[i12 >> 2] = i4;
     mftCall_vi(i9 | 0, i61 | 0);
     HEAP32[i11 >> 2] = i6;
     HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
     mftCall_vi(i8 | 0, i61 | 0);
     HEAP32[i62 >> 2] = (HEAP32[i62 >> 2] | 0) + (HEAP32[i16 >> 2] | 0);
     i3 = (HEAP32[i17 >> 2] | 0) + (HEAP32[i14 >> 2] | 0) | 0;
     HEAP32[i17 >> 2] = i3;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i18 >>> 0) break L40;
     i7 = HEAP32[i15 >> 2] | 0;
    }
   } while (0);
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) __ZdaPv(i1);
   STACKTOP = i63;
   return;
  }
  i1 = HEAP32[i20 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i22 >> 2] | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  L64 : do if ((i1 | 0) != (i3 | 0)) {
   if ((i12 | 0) == 1) {
    i1 = (i2 | 0) > (i4 | 0) ? i1 : i3;
    break;
   }
   do if ((i1 | 0) == 5 | (i3 | 0) == 5) i1 = gb + 57720 | 0; else if ((i1 | 0) == 1e3 | (i3 | 0) == 1e3) i1 = gb + 57720 + 4 | 0; else {
    if ((i1 | 0) == 14 | (i3 | 0) == 14) {
     i1 = gb + 57720 + 8 | 0;
     break;
    }
    if ((i1 | 0) == 4 | (i3 | 0) == 4) {
     i1 = gb + 57720 + 12 | 0;
     break;
    }
    if ((i1 | 0) == 3 | (i3 | 0) == 3) {
     i1 = gb + 57720 + 16 | 0;
     break;
    }
    if ((i1 | 0) == 8 | (i3 | 0) == 8) {
     i1 = gb + 57720 + 20 | 0;
     break;
    }
    if ((i1 | 0) == 7 | (i3 | 0) == 7) {
     i1 = gb + 57720 + 24 | 0;
     break;
    }
    if ((i1 | 0) == 2 | (i3 | 0) == 2) {
     i1 = gb + 57720 + 28 | 0;
     break;
    }
    if ((i1 | 0) == 13 | (i3 | 0) == 13) {
     i1 = gb + 57720 + 32 | 0;
     break;
    }
    if ((i1 | 0) == 1 | (i3 | 0) == 1) {
     i1 = gb + 57720 + 36 | 0;
     break;
    }
    if ((i1 | 0) == 1001 | (i3 | 0) == 1001) i1 = gb + 57720 + 40 | 0; else {
     i1 = -1;
     break L64;
    }
   } while (0);
   i1 = HEAP32[i1 >> 2] | 0;
  } while (0);
  i2 = __ZN6prcore17GetIntegerBlitterE13TextureFormatS0_N14ImageReference8BlitModeE(i1, i1, i12) | 0;
  L82 : do if (!i2) switch (i12 | 0) {
  case 2:
   {
    i16 = 5;
    i56 = fb + 579 | 0;
    break L82;
   }
  case 1:
   {
    i56 = (HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(5) | 0) + 4 >> 2] | 0) + -1 | 0;
    i16 = 5;
    i56 = HEAP32[gb + 57636 + (i56 << 2) >> 2] | 0;
    break L82;
   }
  default:
   {
    i16 = 5;
    i56 = 0;
    break L82;
   }
  } else {
   i16 = i1;
   i56 = i2;
  } while (0);
  i1 = HEAP32[i20 >> 2] | 0;
  if ((i16 | 0) == (i1 | 0)) {
   i54 = 0;
   i55 = 0;
   i17 = 0;
   i3 = 0;
   i2 = 0;
   i4 = 0;
   i5 = 0;
   i6 = 0;
  } else {
   __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_(i61, i1, i16);
   i1 = HEAP8[i61 >> 0] | 0;
   i6 = HEAP32[i61 + 4 >> 2] | 0;
   i3 = HEAP32[i61 + 8 >> 2] | 0;
   i2 = HEAP32[i61 + 12 >> 2] | 0;
   i4 = HEAP32[i61 + 16 >> 2] | 0;
   i5 = HEAP32[i61 + 20 >> 2] | 0;
   if (i2 | 0) __ZdaPv(i2);
   i54 = 1;
   i55 = HEAP32[i13 >> 2] | 0;
   i17 = i1;
  }
  i1 = HEAP32[i22 >> 2] | 0;
  if ((i16 | 0) == (i1 | 0)) {
   i52 = 0;
   i53 = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   i7 = 0;
   i8 = 0;
   i9 = 0;
   i51 = 0;
   i50 = 0;
   i1 = 0;
  } else {
   __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_(i61, i16, i1);
   i7 = HEAP8[i61 >> 0] | 0;
   i10 = HEAP32[i61 + 4 >> 2] | 0;
   i11 = HEAP32[i61 + 8 >> 2] | 0;
   i1 = HEAP32[i61 + 12 >> 2] | 0;
   i8 = HEAP32[i61 + 16 >> 2] | 0;
   i9 = HEAP32[i61 + 20 >> 2] | 0;
   if (i1 | 0) __ZdaPv(i1);
   i15 = HEAP32[i19 >> 2] | 0;
   i52 = 1;
   i53 = i15;
   i51 = i10;
   i50 = i11;
  }
  i14 = (i12 | 0) == 2;
  i10 = HEAP32[i13 >> 2] | 0;
  i12 = HEAP32[i58 >> 2] | 0;
  i13 = HEAP32[i57 >> 2] | 0;
  do if (i14) {
   if ((i15 | 0) < (i10 | 0)) {
    i10 = (i10 << 16 | 0) / (i15 | 0) | 0;
    i11 = (i10 >>> 1) + -32768 | 0;
   } else {
    i49 = i15 + -1 | 0;
    i11 = 0;
    i10 = (((i10 << 16) + -65536 | 0) >>> 0) / ((i49 | 0 ? i49 : 1) >>> 0) | 0;
   }
   HEAP32[i60 + 20 >> 2] = i10;
   HEAP32[i60 + 16 >> 2] = i11;
   if ((i13 | 0) < (i12 | 0)) {
    i48 = (i12 << 16 | 0) / (i13 | 0) | 0;
    i18 = (i48 >>> 1) + -32768 | 0;
    break;
   } else {
    i48 = i13 + -1 | 0;
    i18 = 0;
    i48 = (((i12 << 16) + -65536 | 0) >>> 0) / ((i48 | 0 ? i48 : 1) >>> 0) | 0;
    break;
   }
  } else {
   i48 = (i10 << 16 | 0) / (i15 | 0) | 0;
   HEAP32[i60 + 20 >> 2] = i48;
   HEAP32[i60 + 16 >> 2] = i48 >>> 1;
   i48 = (i12 << 16 | 0) / (i13 | 0) | 0;
   i18 = i48 >>> 1;
  } while (0);
  if (i54 | i52) {
   i11 = i14 & i54;
   i47 = i11 ? (i54 ? 2 : 1) : i54 & 1;
   i12 = Math_imul(HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(i16) | 0) + 4 >> 2] | 0, ((i55 | 0) < (i53 | 0) ? i53 : i55) + 1 | 0) | 0;
   i16 = __Znaj(Math_imul(i12, (i52 & 1) + i47 | 0) | 0) | 0;
   i47 = i16 + (Math_imul(i12, i47) | 0) | 0;
   i49 = i16;
   i47 = i52 ? i47 : 0;
   i12 = i11 ? i16 + (i54 ? i12 : 0) | 0 : 0;
   i16 = i54 ? i16 : 0;
   i11 = HEAP32[i19 >> 2] | 0;
   i10 = HEAP32[i57 >> 2] | 0;
  } else {
   i49 = 0;
   i47 = 0;
   i12 = 0;
   i16 = 0;
   i11 = i15;
   i10 = i13;
  }
  HEAP32[i60 + 12 >> 2] = i11;
  if (i10) {
   i46 = i20 + 12 | 0;
   i43 = i14 ^ 1;
   i44 = i62 + 4 | 0;
   i45 = i62 + 12 | 0;
   i29 = i17 << 24 >> 24 == 0;
   i30 = Math_imul(i55 + 1 | 0, i5) | 0;
   i31 = Math_imul(i55, i5) | 0;
   i32 = i61 + 4 | 0;
   i33 = i61 + 12 | 0;
   i34 = i62 + 4 | 0;
   i35 = i62 + 12 | 0;
   i36 = i61 + 4 | 0;
   i37 = i61 + 12 | 0;
   i38 = i60 + 4 | 0;
   i39 = i60 + 8 | 0;
   i40 = i60 + 24 | 0;
   i41 = i62 + 4 | 0;
   i42 = i62 + 12 | 0;
   i24 = i7 << 24 >> 24 == 0;
   i25 = Math_imul(i53 + 1 | 0, i9) | 0;
   i26 = Math_imul(i53, i9) | 0;
   i27 = i61 + 4 | 0;
   i28 = i61 + 12 | 0;
   i22 = i22 + 12 | 0;
   i23 = i47;
   i20 = 0;
   i19 = HEAP32[i21 >> 2] | 0;
   i17 = -1;
   i14 = -1;
   while (1) {
    i13 = i18 >>> 16;
    i15 = i13 + 1 | 0;
    i15 = i15 >>> 0 < (HEAP32[i58 >> 2] | 0) >>> 0 ? i15 : i13;
    i21 = HEAP32[i59 >> 2] | 0;
    i7 = HEAP32[i46 >> 2] | 0;
    i10 = i21 + (Math_imul(i7, i13) | 0) | 0;
    i7 = i21 + (Math_imul(i15, i7) | 0) | 0;
    if (i54) {
     do if ((i13 | 0) == (i14 | 0)) {
      i11 = i17;
      i13 = i14;
      i14 = i12;
     } else {
      if ((i13 | 0) == (i17 | 0)) {
       i11 = i14;
       i13 = i17;
       i14 = i16;
       i16 = i12;
       break;
      }
      HEAP32[i34 >> 2] = i10;
      HEAP32[i62 >> 2] = i16;
      HEAP32[i35 >> 2] = i55;
      if (i29) mftCall_vi(i6 | 0, i62 | 0); else {
       if (i4 >>> 0 < i55 >>> 0) {
        if (!i2) i11 = i55; else {
         __ZdaPv(i2);
         i10 = HEAP32[i34 >> 2] | 0;
         i11 = HEAP32[i35 >> 2] | 0;
        }
        i2 = __Znaj(i30) | 0;
        _memset(i2 + i31 | 0, 0, i5 | 0) | 0;
        i4 = i55;
       } else i11 = i55;
       HEAP32[i36 >> 2] = i10;
       HEAP32[i61 >> 2] = i2;
       HEAP32[i37 >> 2] = i11;
       mftCall_vi(i6 | 0, i61 | 0);
       HEAP32[i36 >> 2] = i2;
       HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
       HEAP32[i37 >> 2] = HEAP32[i35 >> 2];
       mftCall_vi(i3 | 0, i61 | 0);
      }
      i11 = i17;
      i14 = i12;
     } while (0);
     if (!((i15 | 0) == (i11 | 0) | i43)) {
      HEAP32[i44 >> 2] = i7;
      HEAP32[i62 >> 2] = i14;
      HEAP32[i45 >> 2] = i55;
      if (i29) mftCall_vi(i6 | 0, i62 | 0); else {
       if (i4 >>> 0 < i55 >>> 0) {
        if (!i2) i10 = i55; else {
         __ZdaPv(i2);
         i7 = HEAP32[i44 >> 2] | 0;
         i10 = HEAP32[i45 >> 2] | 0;
        }
        i2 = __Znaj(i30) | 0;
        _memset(i2 + i31 | 0, 0, i5 | 0) | 0;
        i4 = i55;
       } else i10 = i55;
       HEAP32[i32 >> 2] = i7;
       HEAP32[i61 >> 2] = i2;
       HEAP32[i33 >> 2] = i10;
       mftCall_vi(i6 | 0, i61 | 0);
       HEAP32[i32 >> 2] = i2;
       HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
       HEAP32[i33 >> 2] = HEAP32[i45 >> 2];
       mftCall_vi(i3 | 0, i61 | 0);
      }
      i11 = i15;
     }
     i7 = i14;
     i10 = i16;
     i12 = i14;
    } else {
     i13 = i14;
     i11 = i17;
    }
    HEAP32[i38 >> 2] = i10;
    HEAP32[i39 >> 2] = i7;
    HEAP32[i40 >> 2] = i18 & 65535;
    if (i52) {
     HEAP32[i60 >> 2] = i47;
     mftCall_vi(i56 | 0, i60 | 0);
     HEAP32[i41 >> 2] = i47;
     HEAP32[i62 >> 2] = i19;
     HEAP32[i42 >> 2] = i53;
     if (i24) mftCall_vi(i51 | 0, i62 | 0); else {
      if (i8 >>> 0 < i53 >>> 0) {
       if (!i1) {
        i7 = i23;
        i10 = i53;
       } else {
        __ZdaPv(i1);
        i7 = HEAP32[i41 >> 2] | 0;
        i10 = HEAP32[i42 >> 2] | 0;
       }
       i1 = __Znaj(i25) | 0;
       _memset(i1 + i26 | 0, 0, i9 | 0) | 0;
       i8 = i53;
      } else {
       i7 = i23;
       i10 = i53;
      }
      HEAP32[i27 >> 2] = i7;
      HEAP32[i61 >> 2] = i1;
      HEAP32[i28 >> 2] = i10;
      mftCall_vi(i51 | 0, i61 | 0);
      HEAP32[i27 >> 2] = i1;
      HEAP32[i61 >> 2] = HEAP32[i62 >> 2];
      HEAP32[i28 >> 2] = HEAP32[i42 >> 2];
      mftCall_vi(i50 | 0, i61 | 0);
     }
    } else {
     HEAP32[i60 >> 2] = i19;
     mftCall_vi(i56 | 0, i60 | 0);
    }
    i20 = i20 + 1 | 0;
    if (i20 >>> 0 >= (HEAP32[i57 >> 2] | 0) >>> 0) break; else {
     i19 = i19 + (HEAP32[i22 >> 2] | 0) | 0;
     i17 = i11;
     i14 = i13;
     i18 = i18 + i48 | 0;
    }
   }
  }
  if (i49 | 0) __ZdaPv(i49);
  if (i1 | 0) __ZdaPv(i1);
  if (!i2) {
   STACKTOP = i63;
   return;
  }
  __ZdaPv(i2);
  STACKTOP = i63;
  return;
 }
 __ZN6prcore14BlitImageFloatERK14ImageReferenceRS0_NS0_8BlitModeE(i20, i22, i12);
 STACKTOP = i63;
 return;
}

function __Z13UpdatePathJobP9CrowdInfoj(i56, i57) {
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i59 + 1116 | 0;
 i28 = i59 + 1104 | 0;
 i31 = i59 + 1092 | 0;
 i42 = i59 + 1032 | 0;
 i48 = i59 + 1080 | 0;
 i50 = i59 + 1024 | 0;
 i51 = i59 + 1068 | 0;
 i52 = i59;
 i54 = i59 + 1064 | 0;
 i26 = i59 + 1052 | 0;
 i27 = i59 + 1040 | 0;
 i58 = HEAP32[i56 + 364 >> 2] | 0;
 HEAP32[i27 >> 2] = HEAP32[i58 + 432 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i58 + 436 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i58 + 440 >> 2];
 i58 = i56 + (i57 << 4) | 0;
 i29 = HEAP32[i56 + 256 + (i57 << 2) >> 2] | 0;
 if ((HEAP16[gb + 1459332 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459332 | 0, i24);
  i25 = gb + 1459332 | 0;
 } else i25 = 0;
 i55 = i56 + (i57 << 4) + 12 | 0;
 i30 = HEAP32[i55 >> 2] | 0;
 if ((i30 | 0) > 0) {
  i32 = i56 + (i57 << 4) + 8 | 0;
  i33 = i56 + 332 | 0;
  i34 = i28 + 4 | 0;
  i35 = i28 + 8 | 0;
  i36 = i31 + 4 | 0;
  i37 = i31 + 8 | 0;
  i38 = i26 + 4 | 0;
  i39 = i26 + 8 | 0;
  i40 = i48 + 4 | 0;
  i41 = i48 + 8 | 0;
  i43 = i51 + 4 | 0;
  i44 = i51 + 8 | 0;
  i45 = i52 + 8 | 0;
  i23 = 0;
  do {
   i46 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i23 << 2) >> 2] | 0;
   i47 = HEAP32[i58 >> 2] | 0;
   i19 = i47 + (i46 * 608 | 0) | 0;
   i17 = i47 + (i46 * 608 | 0) + 601 | 0;
   if ((HEAP8[i17 >> 0] | 0) != 2) {
    i7 = HEAP32[i33 >> 2] | 0;
    i10 = i7 + (i46 * 132 | 0) | 0;
    i6 = HEAP32[i29 >> 2] | 0;
    i18 = i47 + (i46 * 608 | 0) + 28 | 0;
    i12 = HEAP32[i18 >> 2] | 0;
    i49 = i47 + (i46 * 608 | 0) + 32 | 0;
    i11 = HEAP32[i49 >> 2] | 0;
    i3 = i47 + (i46 * 608 | 0) + 480 | 0;
    i15 = HEAP32[i3 >> 2] | 0;
    HEAP32[i28 >> 2] = i15;
    i4 = i47 + (i46 * 608 | 0) + 484 | 0;
    i16 = HEAP32[i4 >> 2] | 0;
    HEAP32[i34 >> 2] = i16;
    i5 = i47 + (i46 * 608 | 0) + 488 | 0;
    i53 = HEAP32[i5 >> 2] | 0;
    HEAP32[i35 >> 2] = i53;
    i20 = i47 + (i46 * 608 | 0) + 12 | 0;
    HEAP32[i31 >> 2] = HEAP32[i20 >> 2];
    i21 = i47 + (i46 * 608 | 0) + 16 | 0;
    HEAP32[i36 >> 2] = HEAP32[i21 >> 2];
    i22 = i47 + (i46 * 608 | 0) + 20 | 0;
    HEAP32[i37 >> 2] = HEAP32[i22 >> 2];
    i2 = i12;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i14 = i42;
    HEAP32[i14 >> 2] = i1;
    HEAP32[i14 + 4 >> 2] = i2;
    HEAP32[i26 >> 2] = i15;
    HEAP32[i38 >> 2] = i16;
    HEAP32[i39 >> 2] = i53;
    i53 = i47 + (i46 * 608 | 0) + 44 | 0;
    i16 = HEAP8[i53 >> 0] & 2;
    i15 = __ZNK9dtNavMesh12getPolyFlagsEy(i6, i1, i2) | 0;
    i7 = i7 + (i46 * 132 | 0) + 128 | 0;
    do if (!(HEAP32[i7 >> 2] & i15)) {
     __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i29, i28, i27, i10, i42, i26) | 0;
     i2 = i42;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if ((i1 | 0) == 0 & (i2 | 0) == 0) {
      i14 = 59;
      break;
     } else {
      HEAP32[i3 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i38 >> 2];
      HEAP32[i5 >> 2] = HEAP32[i39 >> 2];
      i15 = i1;
      i13 = i2;
      i14 = 12;
      break;
     }
    } else {
     i15 = i1;
     i13 = i2;
     i14 = 12;
    } while (0);
    do if ((i14 | 0) == 12) {
     i14 = 0;
     if (!(HEAP8[i17 >> 0] | 0)) {
      i1 = HEAP32[i18 >> 2] | 0;
      i2 = HEAP32[(HEAP32[i47 + (i46 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
      if ((i15 | 0) == 0 & (i13 | 0) == 0) {
       HEAP32[i1 >> 2] = 0;
       HEAP32[i1 + 4 >> 2] = 0;
       i1 = 0;
      } else {
       HEAP32[i1 >> 2] = i15;
       HEAP32[i1 + 4 >> 2] = i13;
       HEAP32[i19 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i47 + (i46 * 608 | 0) + 4 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i47 + (i46 * 608 | 0) + 8 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i20 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i21 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i22 >> 2] = HEAP32[i39 >> 2];
       i1 = 1;
      }
      HEAP32[i49 >> 2] = 1;
      HEAP8[i53 >> 0] = i1;
      HEAP32[i47 + (i46 * 608 | 0) + 48 >> 2] = i2;
     } else {
      i2 = (i11 | 0) > 8 ? 8 : i11;
      L24 : do if ((i11 | 0) > 0) {
       i1 = 0;
       do {
        i9 = i12 + (i1 << 3) | 0;
        i9 = __ZNK9dtNavMesh12getPolyFlagsEy(i6, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0) | 0;
        if (!(HEAP32[i7 >> 2] & i9)) break L24;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) < (i2 | 0));
      } else i1 = 0; while (0);
      if ((i1 | 0) != (i2 | 0)) {
       i9 = i1 + -1 | 0;
       i9 = (i9 | 0) < 0 ? 0 : i9;
       i3 = i1 + 21 | 0;
       i2 = (i3 | 0) < (i11 | 0);
       i3 = i2 ? i3 : i11;
       do {
        i1 = i1 + 1 | 0;
        if ((i1 | 0) >= (i3 | 0)) break;
        i8 = i12 + (i1 << 3) | 0;
        i8 = __ZNK9dtNavMesh12getPolyFlagsEy(i6, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
       } while (!(HEAP32[i7 >> 2] & i8 | 0));
       HEAP32[i48 >> 2] = HEAP32[i31 >> 2];
       HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
       HEAP32[i41 >> 2] = HEAP32[i37 >> 2];
       i8 = i50;
       HEAP32[i8 >> 2] = 0;
       HEAP32[i8 + 4 >> 2] = 0;
       do if ((i1 | 0) == (i3 | 0)) {
        if (i2) {
         i1 = (i9 | 0) != 0;
         break;
        }
        __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i29, i31, i27, i10, i50, i48) | 0;
        i2 = i50;
        i1 = HEAP32[i2 >> 2] | 0;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if ((i1 | 0) == 0 & (i2 | 0) == 0) {
         i1 = (i9 | 0) != 0;
         break;
        } else {
         i8 = i11 + -1 | 0;
         i14 = 31;
         break;
        }
       } else {
        i2 = i12 + (i1 << 3) | 0;
        i14 = HEAP32[i2 >> 2] | 0;
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        i8 = i50;
        HEAP32[i8 >> 2] = i14;
        HEAP32[i8 + 4 >> 2] = i2;
        i8 = i1;
        i1 = i14;
        i14 = 31;
       } while (0);
       if ((i14 | 0) == 31) {
        i14 = 0;
        HEAP32[i51 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i43 >> 2] = HEAP32[i34 >> 2];
        HEAP32[i44 >> 2] = HEAP32[i35 >> 2];
        i3 = i42;
        if (!i9) {
         i4 = HEAP32[i3 >> 2] | 0;
         i3 = HEAP32[i3 + 4 >> 2] | 0;
        } else {
         i3 = i12 + (i9 << 3) | 0;
         i4 = HEAP32[i3 >> 2] | 0;
         i3 = HEAP32[i3 + 4 >> 2] | 0;
         __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf(i29, i4, i3, i28, i51) | 0;
         i2 = i50;
         i1 = HEAP32[i2 >> 2] | 0;
         i2 = HEAP32[i2 + 4 >> 2] | 0;
        }
        HEAP32[i54 >> 2] = 0;
        i1 = __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter(i29, i4, i3, i1, i2, i51, i48, i10) | 0;
        if ((i1 | 0) >= 0) {
         i1 = __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi(i29, 128, 0) | 0;
         if ((i1 | 0) >= 0) i1 = __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi(i29, i54) | 0;
        }
        if (!(i1 & -2147483584)) if ((__ZN14dtNavMeshQuery7getPathEPyPii(i29, i52, i54, 128) | 0) < 0) i1 = 0; else {
         i3 = i11 + -1 - i8 | 0;
         i5 = i3 + i9 + (HEAP32[i54 >> 2] | 0) | 0;
         i6 = i5 << 3;
         i7 = __Z11dtAllocTempi(i6) | 0;
         i4 = i42;
         i10 = HEAP32[i4 + 4 >> 2] | 0;
         i11 = i7;
         HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i11 + 4 >> 2] = i10;
         if ((i9 | 0) > 0) {
          _memcpy(i7 + 8 | 0, i12 + 8 | 0, i9 << 3 | 0) | 0;
          i1 = i9 + 1 | 0;
         } else i1 = 1;
         i11 = HEAP32[i54 >> 2] | 0;
         i2 = i11 + -1 | 0;
         if ((i11 | 0) > 1) {
          _memcpy(i7 + (i1 << 3) | 0, i45 | 0, i2 << 3 | 0) | 0;
          i1 = i2 + i1 | 0;
         }
         if ((i3 | 0) > 0) _memcpy(i7 + (i1 << 3) | 0, i12 + (i8 << 3) + 8 | 0, i3 << 3 | 0) | 0;
         do if ((i5 | 0) < 8) {
          if (!(HEAP8[i47 + (i46 * 608 | 0) + 317 >> 0] & 8)) break;
          i4 = i7 + (i5 + -1 << 3) | 0;
          i1 = HEAP32[i49 >> 2] | 0;
          if (!i1) {
           i1 = 0;
           i2 = 0;
          } else {
           i2 = (HEAP32[i18 >> 2] | 0) + (i1 + -1 << 3) | 0;
           i1 = HEAP32[i2 >> 2] | 0;
           i2 = HEAP32[i2 + 4 >> 2] | 0;
          }
          i3 = i47 + (i46 * 608 | 0) + 602 | 0;
          if ((i1 | 0) == (HEAP32[i4 >> 2] | 0) ? (i2 | 0) == (HEAP32[i4 + 4 >> 2] | 0) : 0) break;
          HEAP8[i3 >> 0] = HEAP8[i3 >> 0] | 32;
         } while (0);
         i2 = i47 + (i46 * 608 | 0) + 36 | 0;
         do if ((HEAP32[i2 >> 2] | 0) < (i5 | 0)) {
          i3 = HEAP32[i47 + (i46 * 608 | 0) + 40 >> 2] | 0;
          i1 = i5 + -1 | 0;
          i4 = i3 + i1 | 0;
          i3 = i4 - ((i4 | 0) % (i3 | 0) | 0) | 0;
          i4 = __Z9dtReallocPvi(HEAP32[i18 >> 2] | 0, i3 << 3) | 0;
          if (!i4) {
           i2 = i18;
           break;
          }
          HEAP32[i18 >> 2] = i4;
          HEAP32[i2 >> 2] = i3;
          i2 = i18;
         } else {
          i2 = i18;
          i1 = i5 + -1 | 0;
         } while (0);
         HEAP32[i20 >> 2] = HEAP32[i48 >> 2];
         HEAP32[i21 >> 2] = HEAP32[i40 >> 2];
         HEAP32[i22 >> 2] = HEAP32[i41 >> 2];
         _memcpy(HEAP32[i2 >> 2] | 0, i7 | 0, i6 | 0) | 0;
         HEAP32[i49 >> 2] = i5;
         HEAP8[i53 >> 0] = (i5 | 0) != 0 | i16;
         HEAP32[i24 >> 2] = HEAP32[i40 >> 2];
         i1 = (HEAP32[i18 >> 2] | 0) + (i1 << 3) | 0;
         __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i29, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i48, i24) | 0;
         HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
         __Z10dtFreeTempPv(i7);
         i1 = 1;
        } else i1 = 0;
       }
       if (i1) break;
       if ((i15 | 0) == 0 & (i13 | 0) == 0) {
        i14 = 59;
        break;
       }
       i14 = HEAP32[(HEAP32[i47 + (i46 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
       i18 = HEAP32[i18 >> 2] | 0;
       HEAP32[i18 >> 2] = i15;
       HEAP32[i18 + 4 >> 2] = i13;
       HEAP32[i19 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i47 + (i46 * 608 | 0) + 4 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i47 + (i46 * 608 | 0) + 8 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i20 >> 2] = HEAP32[i26 >> 2];
       HEAP32[i21 >> 2] = HEAP32[i38 >> 2];
       HEAP32[i22 >> 2] = HEAP32[i39 >> 2];
       HEAP32[i49 >> 2] = 1;
       HEAP8[i53 >> 0] = 1;
       HEAP32[i47 + (i46 * 608 | 0) + 48 >> 2] = i14;
       i14 = 61;
       break;
      }
     }
    } while (0);
    if ((i14 | 0) == 59) {
     i22 = HEAP32[i18 >> 2] | 0;
     HEAP32[i22 >> 2] = 0;
     HEAP32[i22 + 4 >> 2] = 0;
     HEAP32[i49 >> 2] = 1;
     HEAP8[i53 >> 0] = 0;
     HEAP32[i47 + (i46 * 608 | 0) + 48 >> 2] = HEAP32[(HEAP32[i47 + (i46 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2];
     i14 = 61;
    }
    if ((i14 | 0) == 61) {
     i53 = i47 + (i46 * 608 | 0) + 602 | 0;
     i49 = HEAP8[i53 >> 0] | 0;
     HEAPF32[i47 + (i46 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i47 + (i46 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i47 + (i46 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP32[i47 + (i46 * 608 | 0) + 288 >> 2] = 0;
     HEAP32[i47 + (i46 * 608 | 0) + 476 >> 2] = 0;
     HEAP32[i47 + (i46 * 608 | 0) + 384 >> 2] = 0;
     HEAP8[i53 >> 0] = i49 & -37 | 32;
     i53 = i47 + (i46 * 608 | 0) + 592 | 0;
     HEAP32[i53 >> 2] = 0;
     HEAP32[i53 + 4 >> 2] = 0;
     HEAP8[i17 >> 0] = 0;
     HEAPF32[i47 + (i46 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
     HEAPF32[i47 + (i46 * 608 | 0) + 504 >> 2] = Math_fround(0.0);
     HEAPF32[i47 + (i46 * 608 | 0) + 508 >> 2] = Math_fround(0.0);
     HEAPF32[i47 + (i46 * 608 | 0) + 512 >> 2] = Math_fround(0.0);
    }
   }
   i23 = i23 + 1 | 0;
  } while ((i23 | 0) != (i30 | 0));
 }
 if (i25 | 0) __Z12profiler_endP19ProfilerInformation(i25);
 if ((HEAP16[gb + 1459344 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459344 | 0, i24);
  i9 = gb + 1459344 | 0;
 } else i9 = 0;
 i8 = HEAP32[i55 >> 2] | 0;
 if ((i8 | 0) > 0) {
  i3 = i56 + (i57 << 4) + 8 | 0;
  i2 = 0;
  do {
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i5 = HEAP32[i58 >> 2] | 0;
   do if ((HEAP8[i5 + (i4 * 608 | 0) + 601 >> 0] | 0) != 2) {
    i6 = i5 + (i4 * 608 | 0) + 602 | 0;
    i7 = HEAP8[i6 >> 0] | 0;
    if (i7 & 16) if (HEAP8[i5 + (i4 * 608 | 0) + 317 >> 0] & 8) {
     i1 = HEAP8[i5 + (i4 * 608 | 0) + 44 >> 0] | 0;
     if (!(i1 & 1)) {
      HEAP8[i6 >> 0] = i7 | 32;
      break;
     }
     if (i1 & 2) {
      i1 = HEAP32[i5 + (i4 * 608 | 0) + 48 >> 2] | 0;
      if (i1 | 0) if ((i1 | 0) == (HEAP32[(HEAP32[i5 + (i4 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0)) break;
      if (HEAP32[i5 + (i4 * 608 | 0) + 476 >> 2] | 0) if (HEAP8[i5 + (i4 * 608 | 0) + 472 >> 0] & 2) {
       f60 = Math_fround(HEAPF32[i5 + (i4 * 608 | 0) + 424 >> 2]);
       f60 = Math_fround(f60 - Math_fround(HEAPF32[i5 + (i4 * 608 | 0) + 480 >> 2]));
       f61 = Math_fround(HEAPF32[i5 + (i4 * 608 | 0) + 432 >> 2]);
       f61 = Math_fround(f61 - Math_fround(HEAPF32[i5 + (i4 * 608 | 0) + 488 >> 2]));
       f61 = Math_fround(Math_fround(f60 * f60) + Math_fround(f61 * f61));
       f60 = Math_fround(HEAPF32[i5 + (i4 * 608 | 0) + 292 >> 2]);
       if (f61 < Math_fround(f60 * f60)) HEAP8[i6 >> 0] = i7 | 32;
      }
     }
    }
   } while (0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
 }
 if (!i9) {
  STACKTOP = i59;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i59;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE19constrainSeparationEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i6) return;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i64 = i4 + (i5 << 4) | 0;
 i3 = HEAP32[i1 + 136 >> 2] | 0;
 if (!i3) {
  __ZN12_GLOBAL__N_119constrainSeparationI8Scalar4fPKS1_EEvPT_PKS4_RKT0_(i4, i64, i6);
  return;
 }
 i1 = HEAP32[i2 + 716 >> 2] | 0;
 if ((i1 | 0) == 1) {
  __ZN12_GLOBAL__N_119constrainSeparationI8Scalar4fPKS1_EEvPT_PKS4_RKT0_(i4, i64, i3);
  return;
 }
 f31 = Math_fround(i1 >>> 0);
 f63 = Math_fround(HEAPF32[i2 + 720 >> 2]);
 f63 = Math_fround(f63 + Math_fround(Math_fround(1.0) - Math_fround(f31 * f63)));
 if ((i5 | 0) <= 0) return;
 while (1) {
  i32 = HEAP32[i4 >> 2] | 0;
  i33 = i4 + 4 | 0;
  i34 = HEAP32[i33 >> 2] | 0;
  i35 = i4 + 8 | 0;
  i36 = HEAP32[i35 >> 2] | 0;
  i37 = i4 + 12 | 0;
  i38 = HEAP32[i37 >> 2] | 0;
  i39 = i4 + 16 | 0;
  i40 = HEAP32[i39 >> 2] | 0;
  i41 = i4 + 20 | 0;
  i42 = HEAP32[i41 >> 2] | 0;
  i43 = i4 + 24 | 0;
  i44 = HEAP32[i43 >> 2] | 0;
  i45 = i4 + 28 | 0;
  i46 = HEAP32[i45 >> 2] | 0;
  i47 = i4 + 32 | 0;
  i48 = HEAP32[i47 >> 2] | 0;
  i49 = i4 + 36 | 0;
  i50 = HEAP32[i49 >> 2] | 0;
  i51 = i4 + 40 | 0;
  i52 = HEAP32[i51 >> 2] | 0;
  i53 = i4 + 44 | 0;
  i54 = HEAP32[i53 >> 2] | 0;
  i55 = i4 + 48 | 0;
  i56 = HEAP32[i55 >> 2] | 0;
  i57 = i4 + 52 | 0;
  i58 = HEAP32[i57 >> 2] | 0;
  i59 = i4 + 56 | 0;
  i60 = HEAP32[i59 >> 2] | 0;
  i61 = i4 + 60 | 0;
  i62 = HEAP32[i61 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  f28 = Math_fround(f28 - f12);
  f29 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f29 = Math_fround(f29 - f8);
  f30 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f30 = Math_fround(f30 - f16);
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f31 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f28 = Math_fround(f12 + Math_fround(f63 * f28));
  f29 = Math_fround(f8 + Math_fround(f63 * f29));
  f30 = Math_fround(f16 + Math_fround(f63 * f30));
  f31 = Math_fround(f31 + Math_fround(f63 * Math_fround(f7 - f31)));
  i24 = HEAP32[gb + 1097472 >> 2] | 0;
  i25 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
  i26 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
  i27 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
  f28 = Math_fround(f28 - (HEAP32[tempDoublePtr >> 2] = i24 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f29 = Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i25 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f30 = Math_fround(f30 - (HEAP32[tempDoublePtr >> 2] = i26 & i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f31 = Math_fround(f31 - (HEAP32[tempDoublePtr >> 2] = i27 & i38, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f7 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f16 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f7 = Math_fround(f7 - f16);
  f8 = Math_fround(HEAPF32[i3 + 20 >> 2]);
  f12 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f8 = Math_fround(f8 - f12);
  f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  f9 = Math_fround(f9 - f21);
  f11 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f10 = Math_fround(HEAPF32[i6 + 28 >> 2]);
  f7 = Math_fround(f16 + Math_fround(f63 * f7));
  f8 = Math_fround(f12 + Math_fround(f63 * f8));
  f9 = Math_fround(f21 + Math_fround(f63 * f9));
  f10 = Math_fround(f10 + Math_fround(f63 * Math_fround(f11 - f10)));
  f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i24 & i40, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i25 & i42, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i26 & i44, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f10 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i27 & i46, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f21 = Math_fround(HEAPF32[i6 + 32 >> 2]);
  f11 = Math_fround(f11 - f21);
  f12 = Math_fround(HEAPF32[i3 + 36 >> 2]);
  f16 = Math_fround(HEAPF32[i6 + 36 >> 2]);
  f12 = Math_fround(f12 - f16);
  f13 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f22 = Math_fround(HEAPF32[i6 + 40 >> 2]);
  f13 = Math_fround(f13 - f22);
  f15 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f14 = Math_fround(HEAPF32[i6 + 44 >> 2]);
  f11 = Math_fround(f21 + Math_fround(f63 * f11));
  f12 = Math_fround(f16 + Math_fround(f63 * f12));
  f13 = Math_fround(f22 + Math_fround(f63 * f13));
  f14 = Math_fround(f14 + Math_fround(f63 * Math_fround(f15 - f14)));
  f11 = Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i24 & i48, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i25 & i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f13 = Math_fround(f13 - (HEAP32[tempDoublePtr >> 2] = i26 & i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f14 = Math_fround(f14 - (HEAP32[tempDoublePtr >> 2] = i27 & i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f15 = Math_fround(HEAPF32[i3 + 48 >> 2]);
  f22 = Math_fround(HEAPF32[i6 + 48 >> 2]);
  f15 = Math_fround(f15 - f22);
  f16 = Math_fround(HEAPF32[i3 + 52 >> 2]);
  f21 = Math_fround(HEAPF32[i6 + 52 >> 2]);
  f16 = Math_fround(f16 - f21);
  f17 = Math_fround(HEAPF32[i3 + 56 >> 2]);
  f20 = Math_fround(HEAPF32[i6 + 56 >> 2]);
  f17 = Math_fround(f17 - f20);
  f19 = Math_fround(HEAPF32[i3 + 60 >> 2]);
  f18 = Math_fround(HEAPF32[i6 + 60 >> 2]);
  f15 = Math_fround(f22 + Math_fround(f63 * f15));
  f16 = Math_fround(f21 + Math_fround(f63 * f16));
  f17 = Math_fround(f20 + Math_fround(f63 * f17));
  f18 = Math_fround(f18 + Math_fround(f63 * Math_fround(f19 - f18)));
  f15 = Math_fround(f15 - (HEAP32[tempDoublePtr >> 2] = i24 & i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f16 = Math_fround(f16 - (HEAP32[tempDoublePtr >> 2] = i25 & i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f17 = Math_fround(f17 - (HEAP32[tempDoublePtr >> 2] = i26 & i60, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f18 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i27 & i62, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
  f20 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
  f21 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
  f19 = Math_fround(Math_fround(1.0) - Math_fround(f31 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f30 * f30) + Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f28 * f28) + f19))))))));
  f20 = Math_fround(Math_fround(1.0) - Math_fround(f10 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f7 * f7) + f20))))))));
  f21 = Math_fround(Math_fround(1.0) - Math_fround(f14 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + f21))))))));
  f22 = Math_fround(Math_fround(1.0) - Math_fround(f18 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f16 * f16) + Math_fround(Math_fround(f15 * f15) + Math_fround(HEAPF32[gb + 1097504 + 12 >> 2])))))))));
  i1 = f19 < Math_fround(0.0);
  i2 = f20 < Math_fround(0.0);
  i5 = f21 < Math_fround(0.0);
  i23 = f22 < Math_fround(0.0);
  if (i1 | i2 | i5 | i23) {
   i66 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i70 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i74 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i77 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
   i67 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i71 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i75 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i78 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i68 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i72 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   i76 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i79 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   i65 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i73 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = i1 ? f19 : Math_fround(0.0);
   f28 = Math_fround(f28 * f31);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i79 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f31);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i78 & i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f31);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i77 & i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f31);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   HEAPF32[i4 >> 2] = f28;
   HEAPF32[i33 >> 2] = f29;
   HEAPF32[i35 >> 2] = f30;
   HEAPF32[i37 >> 2] = f31;
   i36 = HEAP32[gb + 1097472 + 4 >> 2] & i76;
   i37 = HEAP32[gb + 1097472 + 8 >> 2] & i75;
   i38 = HEAP32[gb + 1097472 + 12 >> 2] & i74;
   f31 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = i2 ? f20 : Math_fround(0.0);
   f31 = Math_fround(f30 * f31);
   f29 = Math_fround(f30 * (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f28 = Math_fround(f30 * (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f30 = Math_fround(f30 * (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   HEAPF32[i39 >> 2] = f31;
   HEAPF32[i41 >> 2] = f29;
   HEAPF32[i43 >> 2] = f28;
   HEAPF32[i45 >> 2] = f30;
   i44 = HEAP32[gb + 1097472 + 4 >> 2] & i72;
   i45 = HEAP32[gb + 1097472 + 8 >> 2] & i71;
   i46 = HEAP32[gb + 1097472 + 12 >> 2] & i70;
   f30 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = i5 ? f21 : Math_fround(0.0);
   f30 = Math_fround(f28 * f30);
   f29 = Math_fround(f28 * (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f31 = Math_fround(f28 * (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f28 = Math_fround(f28 * (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   HEAPF32[i47 >> 2] = f30;
   HEAPF32[i49 >> 2] = f29;
   HEAPF32[i51 >> 2] = f31;
   HEAPF32[i53 >> 2] = f28;
   i52 = HEAP32[gb + 1097472 + 4 >> 2] & i68;
   i53 = HEAP32[gb + 1097472 + 8 >> 2] & i67;
   i54 = HEAP32[gb + 1097472 + 12 >> 2] & i66;
   f28 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i65, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = i23 ? f22 : Math_fround(0.0);
   f28 = Math_fround(f31 * f28);
   f29 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f30 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f31 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   HEAPF32[i55 >> 2] = f28;
   HEAPF32[i57 >> 2] = f29;
   HEAPF32[i59 >> 2] = f30;
   HEAPF32[i61 >> 2] = f31;
  }
  i4 = i4 + 64 | 0;
  if (i4 >>> 0 >= i64 >>> 0) break; else {
   i3 = i3 + 64 | 0;
   i6 = i6 + 64 | 0;
  }
 }
 return;
}

function __Z21CalculateHullWireMeshR13dynamic_arrayI8Vector3fLj4EERK16NavMeshCarveDataff(i38, i5, f1, f2) {
 i38 = i38 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i45 + 8 | 0;
 i3 = i45;
 i41 = i45 + 60 | 0;
 i42 = i45 + 40 | 0;
 i43 = i45 + 20 | 0;
 HEAP32[i41 >> 2] = 0;
 i4 = i41 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i44 = i41 + 16 | 0;
 i39 = i41 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i40, gb + 63664 | 0);
 i35 = i40;
 i36 = HEAP32[i35 + 4 >> 2] | 0;
 i37 = i39;
 HEAP32[i37 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i37 + 4 >> 2] = i36;
 HEAP32[i44 >> 2] = 32;
 HEAP32[i41 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 512, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case 0:
  {
   if (__ZL20CalculateCapsuleHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i41, i5, gb + 1162364 | 0, f1, f2) | 0) i6 = 4;
   break;
  }
 case 1:
  {
   if (__ZL16CalculateBoxHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i41, i5, gb + 1162364 | 0, f1, f2) | 0) i6 = 4;
   break;
  }
 default:
  {}
 }
 if ((i6 | 0) == 4) {
  f16 = Math_fround(HEAPF32[i5 + 76 >> 2]);
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i5 + 64 >> 2]));
  f19 = Math_fround(HEAPF32[i5 + 80 >> 2]);
  f19 = Math_fround(f19 - Math_fround(HEAPF32[i5 + 68 >> 2]));
  f31 = Math_fround(HEAPF32[i5 + 84 >> 2]);
  f31 = Math_fround(f31 - Math_fround(HEAPF32[i5 + 72 >> 2]));
  f31 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f19 * f19)) + Math_fround(f31 * f31)))) * Math_fround(4.0));
  i34 = gb + 64016 | 0;
  i33 = HEAP32[i34 + 4 >> 2] | 0;
  i32 = i3;
  HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i32 + 4 >> 2] = i33;
  HEAP32[i42 >> 2] = 0;
  i32 = i42 + 12 | 0;
  HEAP32[i32 >> 2] = 0;
  i33 = i42 + 16 | 0;
  HEAP32[i33 >> 2] = 0;
  i34 = i42 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i40, i3);
  i35 = i40;
  i36 = HEAP32[i35 + 4 >> 2] | 0;
  i37 = i34;
  HEAP32[i37 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i37 + 4 >> 2] = i36;
  i37 = gb + 64016 | 0;
  i36 = HEAP32[i37 + 4 >> 2] | 0;
  i35 = i3;
  HEAP32[i35 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i35 + 4 >> 2] = i36;
  HEAP32[i43 >> 2] = 0;
  i35 = i43 + 12 | 0;
  HEAP32[i35 >> 2] = 0;
  i36 = i43 + 16 | 0;
  HEAP32[i36 >> 2] = 0;
  i37 = i43 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i40, i3);
  i29 = i40;
  i30 = HEAP32[i29 + 4 >> 2] | 0;
  i3 = i37;
  HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i3 + 4 >> 2] = i30;
  i3 = HEAP32[i33 >> 2] | 0;
  do if ((i3 & 2147483616) >>> 0 < 32) if ((i3 | 0) > -1) {
   HEAP32[i33 >> 2] = 32;
   HEAP32[i42 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, 384, 4, i34, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i34, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i30 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i32 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i33 >> 2] = 32;
   HEAP32[i42 >> 2] = i30;
   break;
  } while (0);
  i3 = HEAP32[i36 >> 2] | 0;
  do if ((i3 & 2147483616) >>> 0 < 32) if ((i3 | 0) > -1) {
   HEAP32[i36 >> 2] = 32;
   HEAP32[i43 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i43 >> 2] | 0, 384, 4, i37, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i37, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i30 | 0, HEAP32[i43 >> 2] | 0, (HEAP32[i35 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i36 >> 2] = 32;
   HEAP32[i43 >> 2] = i30;
   break;
  } while (0);
  i28 = HEAP32[i4 >> 2] | 0;
  if ((i28 | 0) > 0) {
   i29 = i5 + 4 | 0;
   i30 = i5 + 8 | 0;
   i18 = i5 + 12 | 0;
   f19 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i20 = i40 + 4 | 0;
   i21 = i40 + 8 | 0;
   i22 = i40 + 4 | 0;
   i23 = i40 + 8 | 0;
   i24 = i40 + 4 | 0;
   i25 = i40 + 8 | 0;
   i26 = i40 + 4 | 0;
   i27 = i40 + 8 | 0;
   i17 = 0;
   do {
    i7 = HEAP32[i41 >> 2] | 0;
    f12 = Math_fround(HEAPF32[i7 + (i17 << 4) >> 2]);
    f13 = Math_fround(HEAPF32[i7 + (i17 << 4) + 4 >> 2]);
    f11 = Math_fround(HEAPF32[i7 + (i17 << 4) + 8 >> 2]);
    f9 = Math_fround(HEAPF32[i7 + (i17 << 4) + 12 >> 2]);
    f14 = Math_fround(HEAPF32[i29 >> 2]);
    f16 = Math_fround(f12 * f14);
    f15 = Math_fround(HEAPF32[i30 >> 2]);
    f16 = Math_fround(f16 + Math_fround(f13 * f15));
    f8 = Math_fround(HEAPF32[i18 >> 2]);
    f16 = Math_fround(f9 + Math_fround(f16 + Math_fround(f11 * f8)));
    f14 = Math_fround(f14 - Math_fround(f12 * f16));
    f15 = Math_fround(f15 - Math_fround(f13 * f16));
    f16 = Math_fround(f8 - Math_fround(f11 * f16));
    i7 = f11 < Math_fround(0.0);
    f8 = Math_fround(-f11);
    i10 = f13 < Math_fround(0.0);
    f9 = Math_fround(-f13);
    if ((i7 ? f8 : f11) < (i10 ? f9 : f13)) {
     f47 = Math_fround(HEAPF32[gb + 62524 + 4 >> 2]);
     f1 = Math_fround(f11 * f47);
     f46 = Math_fround(HEAPF32[gb + 62524 + 8 >> 2]);
     f1 = Math_fround(f1 - Math_fround(f13 * f46));
     f2 = Math_fround(f12 * f46);
     f48 = Math_fround(HEAPF32[gb + 62524 >> 2]);
     f2 = Math_fround(f2 - Math_fround(f11 * f48));
     f8 = Math_fround(Math_fround(f13 * f48) - Math_fround(f12 * f47));
     f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)))));
     i10 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
     if (f9 > f19) {
      f48 = Math_fround(f1 / f9);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f2 / f9);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f8 / f9);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     } else {
      i7 = HEAP32[gb + 62548 >> 2] | 0;
      i4 = HEAP32[gb + 62548 + 4 >> 2] | 0;
      i6 = HEAP32[gb + 62548 + 8 >> 2] | 0;
     }
     f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround(f13 * f8);
     f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround(f9 - Math_fround(f11 * f2));
     f1 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f8 = Math_fround(Math_fround(f11 * f1) - Math_fround(f12 * f8));
     f1 = Math_fround(Math_fround(f12 * f2) - Math_fround(f13 * f1));
     f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)))));
     if (f2 > f19) {
      f48 = Math_fround(f9 / f2);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f8 / f2);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f1 / f2);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     }
    } else {
     f48 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
     f1 = Math_fround(f13 * f48);
     f47 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
     f1 = Math_fround(f1 - Math_fround(f11 * f47));
     f46 = Math_fround(HEAPF32[gb + 62548 >> 2]);
     f2 = Math_fround(Math_fround(f11 * f46) - Math_fround(f12 * f48));
     f8 = Math_fround(Math_fround(f12 * f47) - Math_fround(f13 * f46));
     f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)))));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     if (f9 > f19) {
      f48 = Math_fround(f1 / f9);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f2 / f9);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f8 / f9);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     } else {
      i10 = HEAP32[gb + 62524 >> 2] | 0;
      i3 = HEAP32[gb + 62524 + 4 >> 2] | 0;
      i5 = HEAP32[gb + 62524 + 8 >> 2] | 0;
     }
     f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround(f11 * f1);
     f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround(f9 - Math_fround(f13 * f8));
     f8 = Math_fround(f12 * f8);
     f2 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f8 = Math_fround(f8 - Math_fround(f11 * f2));
     f1 = Math_fround(Math_fround(f13 * f2) - Math_fround(f12 * f1));
     f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)))));
     if (f2 > f19) {
      f48 = Math_fround(f9 / f2);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f8 / f2);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
      f48 = Math_fround(f1 / f2);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
     }
    }
    HEAP32[i32 >> 2] = 0;
    f2 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f9 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f8 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f46 = Math_fround(f14 - f2);
    f47 = Math_fround(f15 - f9);
    f48 = Math_fround(f16 - f8);
    f13 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f11 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f12 = Math_fround(f31 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f49 = Math_fround(f47 - f11);
    f1 = Math_fround(f48 - f12);
    HEAPF32[i40 >> 2] = Math_fround(f46 - f13);
    HEAPF32[i20 >> 2] = f49;
    HEAPF32[i21 >> 2] = f1;
    __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i42, i40);
    f14 = Math_fround(f14 + f2);
    f15 = Math_fround(f15 + f9);
    f16 = Math_fround(f16 + f8);
    f8 = Math_fround(f15 - f11);
    f9 = Math_fround(f16 - f12);
    HEAPF32[i40 >> 2] = Math_fround(f14 - f13);
    HEAPF32[i22 >> 2] = f8;
    HEAPF32[i23 >> 2] = f9;
    __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i42, i40);
    f15 = Math_fround(f11 + f15);
    f16 = Math_fround(f12 + f16);
    HEAPF32[i40 >> 2] = Math_fround(f13 + f14);
    HEAPF32[i24 >> 2] = f15;
    HEAPF32[i25 >> 2] = f16;
    __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i42, i40);
    f47 = Math_fround(f11 + f47);
    f48 = Math_fround(f12 + f48);
    HEAPF32[i40 >> 2] = Math_fround(f13 + f46);
    HEAPF32[i26 >> 2] = f47;
    HEAPF32[i27 >> 2] = f48;
    __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i42, i40);
    i6 = 0;
    L36 : while (1) {
     L38 : do if ((i17 | 0) != (i6 | 0)) {
      switch (__ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i43, i42, (HEAP32[i41 >> 2] | 0) + (i6 << 4) | 0) | 0) {
      case 1:
       {
        i6 = 39;
        break L36;
       }
      case 0:
       break;
      default:
       break L38;
      }
      i7 = HEAP32[i43 >> 2] | 0;
      i3 = (HEAP32[i35 >> 2] | 0) * 12 | 0;
      i4 = (i3 | 0) / 12 | 0;
      HEAP32[i32 >> 2] = i4;
      i5 = HEAP32[i33 >> 2] | 0;
      do if ((i5 & 2147483647) >>> 0 < i4 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i33 >> 2] = i4;
       i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i42 >> 2] | 0, i3, 4, i34, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i42 >> 2] = i3;
       break;
      } else {
       i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i34, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i3 | 0, HEAP32[i42 >> 2] | 0, (HEAP32[i32 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i33 >> 2] = i4;
       HEAP32[i42 >> 2] = i3;
       break;
      } else i3 = HEAP32[i42 >> 2] | 0; while (0);
      _memcpy(i3 | 0, i7 | 0, (HEAP32[i32 >> 2] | 0) * 12 | 0) | 0;
     } while (0);
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i28 | 0)) {
      i6 = 41;
      break;
     }
    }
    if ((i6 | 0) == 39) HEAP32[i32 >> 2] = 0; else if ((i6 | 0) == 41) {
     i4 = HEAP32[i32 >> 2] | 0;
     if ((i4 | 0) > 0) {
      i3 = 0;
      do {
       __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i38, (HEAP32[i42 >> 2] | 0) + (i3 * 12 | 0) | 0);
       i3 = i3 + 1 | 0;
       __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i38, (HEAP32[i42 >> 2] | 0) + (((i3 | 0) == (i4 | 0) ? 0 : i3) * 12 | 0) | 0);
      } while ((i3 | 0) != (i4 | 0));
     }
    }
    i17 = i17 + 1 | 0;
   } while ((i17 | 0) != (i28 | 0));
  }
  if ((HEAP32[i36 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i43 >> 2] | 0, i37);
   HEAP32[i43 >> 2] = 0;
  }
  if ((HEAP32[i33 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i34);
   HEAP32[i42 >> 2] = 0;
  }
 }
 if ((HEAP32[i44 >> 2] | 0) <= -1) {
  STACKTOP = i45;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i39);
 HEAP32[i41 >> 2] = 0;
 STACKTOP = i45;
 return;
}

function __GLOBAL__sub_I_runtime_graphics5_lump_cpp() {
 var i1 = 0, i2 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158380 | 0, gb + 411446 | 0, 10, 0);
 HEAP8[gb + 1545909 >> 0] = 2;
 HEAP8[gb + 1545909 + 1 >> 0] = 4;
 HEAP8[gb + 1545909 + 2 >> 0] = 6;
 HEAP8[gb + 1545909 + 3 >> 0] = 0;
 HEAP8[gb + 1545909 + 4 >> 0] = 0;
 HEAP8[gb + 1545909 + 5 >> 0] = 3;
 HEAP8[gb + 1545909 + 6 >> 0] = 0;
 HEAP8[gb + 1545909 + 7 >> 0] = 4;
 HEAP8[gb + 1545909 + 8 >> 0] = 4;
 HEAP8[gb + 1545909 + 9 >> 0] = 4;
 HEAP8[gb + 1545909 + 10 >> 0] = 0;
 HEAP8[gb + 1545909 + 11 >> 0] = 5;
 HEAP8[gb + 1545909 + 12 >> 0] = 5;
 HEAP8[gb + 1545909 + 13 >> 0] = 5;
 HEAP8[gb + 1545909 + 14 >> 0] = 0;
 HEAP8[gb + 1545909 + 15 >> 0] = 1;
 HEAP8[gb + 1545909 + 16 >> 0] = 6;
 HEAP8[gb + 1545909 + 17 >> 0] = 2;
 HEAP8[gb + 1545909 + 18 >> 0] = 0;
 HEAP8[gb + 1545909 + 19 >> 0] = 0;
 HEAP8[gb + 1545909 + 20 >> 0] = 3;
 HEAP8[gb + 1545909 + 21 >> 0] = 0;
 HEAP8[gb + 1545909 + 22 >> 0] = 6;
 HEAP8[gb + 1545909 + 23 >> 0] = 6;
 HEAP8[gb + 1545909 + 24 >> 0] = 6;
 HEAP8[gb + 1545909 + 25 >> 0] = 0;
 HEAP8[gb + 1545909 + 26 >> 0] = 7;
 HEAP8[gb + 1545909 + 27 >> 0] = 7;
 HEAP8[gb + 1545909 + 28 >> 0] = 7;
 HEAP8[gb + 1545909 + 29 >> 0] = 0;
 HEAP8[gb + 1545909 + 30 >> 0] = 2;
 HEAP8[gb + 1545909 + 31 >> 0] = 6;
 HEAP8[gb + 1545909 + 32 >> 0] = 0;
 HEAP8[gb + 1545909 + 33 >> 0] = 0;
 HEAP8[gb + 1545909 + 34 >> 0] = 0;
 HEAP8[gb + 1545909 + 35 >> 0] = 2;
 HEAP8[gb + 1545909 + 36 >> 0] = 0;
 HEAP8[gb + 1545909 + 37 >> 0] = 5;
 HEAP8[gb + 1545909 + 38 >> 0] = 5;
 HEAP8[gb + 1545909 + 39 >> 0] = 5;
 HEAP8[gb + 1545909 + 40 >> 0] = 0;
 HEAP8[gb + 1545909 + 41 >> 0] = 5;
 HEAP8[gb + 1545909 + 42 >> 0] = 5;
 HEAP8[gb + 1545909 + 43 >> 0] = 5;
 HEAP8[gb + 1545909 + 44 >> 0] = 0;
 HEAP8[gb + 1545909 + 45 >> 0] = 1;
 HEAP8[gb + 1545909 + 46 >> 0] = 6;
 HEAP8[gb + 1545909 + 47 >> 0] = 4;
 HEAP8[gb + 1545909 + 48 >> 0] = 0;
 HEAP8[gb + 1545909 + 49 >> 0] = 0;
 HEAP8[gb + 1545909 + 50 >> 0] = 2;
 HEAP8[gb + 1545909 + 51 >> 0] = 0;
 HEAP8[gb + 1545909 + 52 >> 0] = 7;
 HEAP8[gb + 1545909 + 53 >> 0] = 7;
 HEAP8[gb + 1545909 + 54 >> 0] = 7;
 HEAP8[gb + 1545909 + 55 >> 0] = 0;
 HEAP8[gb + 1545909 + 56 >> 0] = 8;
 HEAP8[gb + 1545909 + 57 >> 0] = 8;
 HEAP8[gb + 1545909 + 58 >> 0] = 8;
 HEAP8[gb + 1545909 + 59 >> 0] = 0;
 HEAP8[gb + 1545909 + 59 + 1 >> 0] = 0;
 HEAP8[gb + 1545909 + 59 + 2 >> 0] = 0;
 HEAP8[gb + 1545909 + 59 + 3 >> 0] = 0;
 HEAP8[gb + 1545909 + 63 >> 0] = 2;
 HEAP8[gb + 1545909 + 64 >> 0] = 1;
 HEAP8[gb + 1545909 + 65 >> 0] = 2;
 HEAP8[gb + 1545909 + 66 >> 0] = 3;
 HEAP8[gb + 1545909 + 67 >> 0] = 5;
 HEAP8[gb + 1545909 + 68 >> 0] = 5;
 HEAP8[gb + 1545909 + 69 >> 0] = 5;
 HEAP8[gb + 1545909 + 70 >> 0] = 6;
 HEAP8[gb + 1545909 + 71 >> 0] = 5;
 HEAP8[gb + 1545909 + 72 >> 0] = 5;
 HEAP8[gb + 1545909 + 73 >> 0] = 5;
 HEAP8[gb + 1545909 + 74 >> 0] = 6;
 HEAP8[gb + 1545909 + 75 >> 0] = 0;
 HEAP8[gb + 1545909 + 76 >> 0] = 0;
 HEAP8[gb + 1545909 + 77 >> 0] = 0;
 HEAP8[gb + 1545909 + 78 >> 0] = 2;
 HEAP8[gb + 1545909 + 79 >> 0] = 0;
 HEAP8[gb + 1545909 + 80 >> 0] = 2;
 HEAP8[gb + 1545909 + 81 >> 0] = 2;
 HEAP8[gb + 1545909 + 82 >> 0] = 7;
 HEAP8[gb + 1545909 + 83 >> 0] = 7;
 HEAP8[gb + 1545909 + 84 >> 0] = 7;
 HEAP8[gb + 1545909 + 85 >> 0] = 8;
 HEAP8[gb + 1545909 + 86 >> 0] = 7;
 HEAP8[gb + 1545909 + 87 >> 0] = 7;
 HEAP8[gb + 1545909 + 88 >> 0] = 7;
 HEAP8[gb + 1545909 + 89 >> 0] = 8;
 HEAP8[gb + 1545909 + 90 >> 0] = 0;
 HEAP8[gb + 1545909 + 91 >> 0] = 0;
 HEAP8[gb + 1545909 + 92 >> 0] = 2;
 HEAP8[gb + 1545909 + 93 >> 0] = 0;
 HEAP8[gb + 1545909 + 94 >> 0] = 0;
 HEAP8[gb + 1545909 + 95 >> 0] = 4;
 HEAP8[gb + 1545909 + 96 >> 0] = 0;
 HEAP8[gb + 1545909 + 97 >> 0] = 7;
 HEAP8[gb + 1545909 + 97 + 1 >> 0] = 7;
 HEAP8[gb + 1545909 + 97 + 2 >> 0] = 7;
 HEAP8[gb + 1545909 + 97 + 3 >> 0] = 7;
 HEAP8[gb + 1545909 + 101 >> 0] = 8;
 HEAP8[gb + 1545909 + 101 + 1 >> 0] = 8;
 HEAP8[gb + 1545909 + 101 + 2 >> 0] = 8;
 HEAP8[gb + 1545909 + 101 + 3 >> 0] = 8;
 HEAP8[gb + 1545909 + 105 >> 0] = 1;
 HEAP8[gb + 1545909 + 106 >> 0] = 6;
 HEAP8[gb + 1545909 + 107 >> 0] = 4;
 HEAP8[gb + 1545909 + 108 >> 0] = 0;
 HEAP8[gb + 1545909 + 109 >> 0] = 0;
 HEAP8[gb + 1545909 + 110 >> 0] = 2;
 HEAP8[gb + 1545909 + 111 >> 0] = 0;
 HEAP8[gb + 1545909 + 112 >> 0] = 5;
 HEAP8[gb + 1545909 + 112 + 1 >> 0] = 5;
 HEAP8[gb + 1545909 + 112 + 2 >> 0] = 5;
 HEAP8[gb + 1545909 + 112 + 3 >> 0] = 5;
 HEAP8[gb + 1545909 + 116 >> 0] = 6;
 HEAP8[gb + 1545909 + 116 + 1 >> 0] = 6;
 HEAP8[gb + 1545909 + 116 + 2 >> 0] = 6;
 HEAP8[gb + 1545909 + 116 + 3 >> 0] = 6;
 HEAP8[gb + 1546029 >> 0] = 0;
 HEAP8[gb + 1546029 + 1 >> 0] = 1;
 HEAP8[gb + 1546029 + 2 >> 0] = 1;
 HEAP8[gb + 1546029 + 3 >> 0] = 3;
 HEAP8[gb + 1546029 + 4 >> 0] = 10;
 HEAP8[gb + 1546029 + 5 >> 0] = 10;
 HEAP8[gb + 1546029 + 6 >> 0] = 10;
 HEAP8[gb + 1546029 + 7 >> 0] = 0;
 HEAP8[gb + 1546029 + 8 >> 0] = 5;
 HEAP8[gb + 1546029 + 9 >> 0] = 5;
 HEAP8[gb + 1546029 + 10 >> 0] = 5;
 HEAP8[gb + 1546029 + 11 >> 0] = 0;
 HEAP8[gb + 1546029 + 12 >> 0] = 5;
 HEAP8[gb + 1546029 + 13 >> 0] = 5;
 HEAP8[gb + 1546029 + 14 >> 0] = 5;
 HEAP8[gb + 1546029 + 15 >> 0] = 0;
 HEAP8[gb + 1546029 + 16 >> 0] = 5;
 HEAP8[gb + 1546029 + 17 >> 0] = 5;
 HEAP8[gb + 1546029 + 18 >> 0] = 5;
 HEAP8[gb + 1546029 + 19 >> 0] = 0;
 HEAP8[gb + 1546029 + 20 >> 0] = 1;
 HEAP8[gb + 1546029 + 21 >> 0] = 1;
 HEAP8[gb + 1546029 + 22 >> 0] = 1;
 HEAP8[gb + 1546029 + 23 >> 0] = 3;
 HEAP8[gb + 1546029 + 24 >> 0] = 7;
 HEAP8[gb + 1546029 + 25 >> 0] = 7;
 HEAP8[gb + 1546029 + 26 >> 0] = 7;
 HEAP8[gb + 1546029 + 27 >> 0] = 0;
 HEAP8[gb + 1546029 + 28 >> 0] = 6;
 HEAP8[gb + 1546029 + 29 >> 0] = 6;
 HEAP8[gb + 1546029 + 30 >> 0] = 6;
 HEAP8[gb + 1546029 + 31 >> 0] = 0;
 HEAP8[gb + 1546029 + 32 >> 0] = 6;
 HEAP8[gb + 1546029 + 33 >> 0] = 6;
 HEAP8[gb + 1546029 + 34 >> 0] = 6;
 HEAP8[gb + 1546029 + 35 >> 0] = 0;
 HEAP8[gb + 1546029 + 36 >> 0] = 6;
 HEAP8[gb + 1546029 + 37 >> 0] = 6;
 HEAP8[gb + 1546029 + 38 >> 0] = 6;
 HEAP8[gb + 1546029 + 39 >> 0] = 0;
 HEAP8[gb + 1546029 + 40 >> 0] = 2;
 HEAP8[gb + 1546029 + 41 >> 0] = 1;
 HEAP8[gb + 1546029 + 42 >> 0] = 1;
 HEAP8[gb + 1546029 + 43 >> 0] = 3;
 HEAP8[gb + 1546029 + 44 >> 0] = 11;
 HEAP8[gb + 1546029 + 45 >> 0] = 11;
 HEAP8[gb + 1546029 + 46 >> 0] = 11;
 HEAP8[gb + 1546029 + 47 >> 0] = 0;
 HEAP8[gb + 1546029 + 48 >> 0] = 5;
 HEAP8[gb + 1546029 + 49 >> 0] = 4;
 HEAP8[gb + 1546029 + 50 >> 0] = 4;
 HEAP8[gb + 1546029 + 51 >> 0] = 0;
 HEAP8[gb + 1546029 + 52 >> 0] = 5;
 HEAP8[gb + 1546029 + 53 >> 0] = 4;
 HEAP8[gb + 1546029 + 54 >> 0] = 4;
 HEAP8[gb + 1546029 + 55 >> 0] = 0;
 HEAP8[gb + 1546029 + 56 >> 0] = 5;
 HEAP8[gb + 1546029 + 57 >> 0] = 4;
 HEAP8[gb + 1546029 + 58 >> 0] = 4;
 HEAP8[gb + 1546029 + 59 >> 0] = 0;
 HEAP8[gb + 1546029 + 60 >> 0] = 6;
 HEAP8[gb + 1546029 + 61 >> 0] = 1;
 HEAP8[gb + 1546029 + 62 >> 0] = 1;
 HEAP8[gb + 1546029 + 63 >> 0] = 3;
 HEAP8[gb + 1546029 + 64 >> 0] = 11;
 HEAP8[gb + 1546029 + 65 >> 0] = 11;
 HEAP8[gb + 1546029 + 66 >> 0] = 11;
 HEAP8[gb + 1546029 + 67 >> 0] = 0;
 HEAP8[gb + 1546029 + 68 >> 0] = 4;
 HEAP8[gb + 1546029 + 69 >> 0] = 5;
 HEAP8[gb + 1546029 + 70 >> 0] = 4;
 HEAP8[gb + 1546029 + 71 >> 0] = 0;
 HEAP8[gb + 1546029 + 72 >> 0] = 4;
 HEAP8[gb + 1546029 + 73 >> 0] = 5;
 HEAP8[gb + 1546029 + 74 >> 0] = 4;
 HEAP8[gb + 1546029 + 75 >> 0] = 0;
 HEAP8[gb + 1546029 + 76 >> 0] = 4;
 HEAP8[gb + 1546029 + 77 >> 0] = 5;
 HEAP8[gb + 1546029 + 78 >> 0] = 4;
 HEAP8[gb + 1546029 + 79 >> 0] = 0;
 HEAP8[gb + 1546029 + 80 >> 0] = 10;
 HEAP8[gb + 1546029 + 81 >> 0] = 1;
 HEAP8[gb + 1546029 + 82 >> 0] = 1;
 HEAP8[gb + 1546029 + 83 >> 0] = 3;
 HEAP8[gb + 1546029 + 84 >> 0] = 11;
 HEAP8[gb + 1546029 + 85 >> 0] = 11;
 HEAP8[gb + 1546029 + 86 >> 0] = 11;
 HEAP8[gb + 1546029 + 87 >> 0] = 0;
 HEAP8[gb + 1546029 + 88 >> 0] = 4;
 HEAP8[gb + 1546029 + 89 >> 0] = 4;
 HEAP8[gb + 1546029 + 90 >> 0] = 5;
 HEAP8[gb + 1546029 + 91 >> 0] = 0;
 HEAP8[gb + 1546029 + 92 >> 0] = 4;
 HEAP8[gb + 1546029 + 93 >> 0] = 4;
 HEAP8[gb + 1546029 + 94 >> 0] = 5;
 HEAP8[gb + 1546029 + 95 >> 0] = 0;
 HEAP8[gb + 1546029 + 96 >> 0] = 4;
 HEAP8[gb + 1546029 + 97 >> 0] = 4;
 HEAP8[gb + 1546029 + 98 >> 0] = 5;
 HEAP8[gb + 1546029 + 99 >> 0] = 0;
 HEAP8[gb + 1546029 + 100 >> 0] = 14;
 HEAP8[gb + 1546029 + 101 >> 0] = 1;
 HEAP8[gb + 1546029 + 102 >> 0] = 1;
 HEAP8[gb + 1546029 + 103 >> 0] = 3;
 HEAP8[gb + 1546029 + 104 >> 0] = 9;
 HEAP8[gb + 1546029 + 105 >> 0] = 9;
 HEAP8[gb + 1546029 + 106 >> 0] = 9;
 HEAP8[gb + 1546029 + 107 >> 0] = 0;
 HEAP8[gb + 1546029 + 108 >> 0] = 5;
 HEAP8[gb + 1546029 + 109 >> 0] = 5;
 HEAP8[gb + 1546029 + 110 >> 0] = 5;
 HEAP8[gb + 1546029 + 111 >> 0] = 0;
 HEAP8[gb + 1546029 + 112 >> 0] = 5;
 HEAP8[gb + 1546029 + 113 >> 0] = 5;
 HEAP8[gb + 1546029 + 114 >> 0] = 5;
 HEAP8[gb + 1546029 + 115 >> 0] = 0;
 HEAP8[gb + 1546029 + 116 >> 0] = 5;
 HEAP8[gb + 1546029 + 117 >> 0] = 5;
 HEAP8[gb + 1546029 + 118 >> 0] = 5;
 HEAP8[gb + 1546029 + 119 >> 0] = 0;
 HEAP8[gb + 1546029 + 120 >> 0] = 18;
 HEAP8[gb + 1546029 + 121 >> 0] = 1;
 HEAP8[gb + 1546029 + 122 >> 0] = 1;
 HEAP8[gb + 1546029 + 123 >> 0] = 3;
 HEAP8[gb + 1546029 + 124 >> 0] = 8;
 HEAP8[gb + 1546029 + 125 >> 0] = 8;
 HEAP8[gb + 1546029 + 126 >> 0] = 8;
 HEAP8[gb + 1546029 + 127 >> 0] = 0;
 HEAP8[gb + 1546029 + 128 >> 0] = 6;
 HEAP8[gb + 1546029 + 129 >> 0] = 5;
 HEAP8[gb + 1546029 + 130 >> 0] = 5;
 HEAP8[gb + 1546029 + 131 >> 0] = 0;
 HEAP8[gb + 1546029 + 132 >> 0] = 6;
 HEAP8[gb + 1546029 + 133 >> 0] = 5;
 HEAP8[gb + 1546029 + 134 >> 0] = 5;
 HEAP8[gb + 1546029 + 135 >> 0] = 0;
 HEAP8[gb + 1546029 + 136 >> 0] = 6;
 HEAP8[gb + 1546029 + 137 >> 0] = 5;
 HEAP8[gb + 1546029 + 138 >> 0] = 5;
 HEAP8[gb + 1546029 + 139 >> 0] = 0;
 HEAP8[gb + 1546029 + 140 >> 0] = 22;
 HEAP8[gb + 1546029 + 141 >> 0] = 1;
 HEAP8[gb + 1546029 + 142 >> 0] = 1;
 HEAP8[gb + 1546029 + 143 >> 0] = 3;
 HEAP8[gb + 1546029 + 144 >> 0] = 8;
 HEAP8[gb + 1546029 + 145 >> 0] = 8;
 HEAP8[gb + 1546029 + 146 >> 0] = 8;
 HEAP8[gb + 1546029 + 147 >> 0] = 0;
 HEAP8[gb + 1546029 + 148 >> 0] = 5;
 HEAP8[gb + 1546029 + 149 >> 0] = 6;
 HEAP8[gb + 1546029 + 150 >> 0] = 5;
 HEAP8[gb + 1546029 + 151 >> 0] = 0;
 HEAP8[gb + 1546029 + 152 >> 0] = 5;
 HEAP8[gb + 1546029 + 153 >> 0] = 6;
 HEAP8[gb + 1546029 + 154 >> 0] = 5;
 HEAP8[gb + 1546029 + 155 >> 0] = 0;
 HEAP8[gb + 1546029 + 156 >> 0] = 5;
 HEAP8[gb + 1546029 + 157 >> 0] = 6;
 HEAP8[gb + 1546029 + 158 >> 0] = 5;
 HEAP8[gb + 1546029 + 159 >> 0] = 0;
 HEAP8[gb + 1546029 + 160 >> 0] = 26;
 HEAP8[gb + 1546029 + 161 >> 0] = 1;
 HEAP8[gb + 1546029 + 162 >> 0] = 1;
 HEAP8[gb + 1546029 + 163 >> 0] = 3;
 HEAP8[gb + 1546029 + 164 >> 0] = 8;
 HEAP8[gb + 1546029 + 165 >> 0] = 8;
 HEAP8[gb + 1546029 + 166 >> 0] = 8;
 HEAP8[gb + 1546029 + 167 >> 0] = 0;
 HEAP8[gb + 1546029 + 168 >> 0] = 5;
 HEAP8[gb + 1546029 + 169 >> 0] = 5;
 HEAP8[gb + 1546029 + 170 >> 0] = 6;
 HEAP8[gb + 1546029 + 171 >> 0] = 0;
 HEAP8[gb + 1546029 + 172 >> 0] = 5;
 HEAP8[gb + 1546029 + 173 >> 0] = 5;
 HEAP8[gb + 1546029 + 174 >> 0] = 6;
 HEAP8[gb + 1546029 + 175 >> 0] = 0;
 HEAP8[gb + 1546029 + 176 >> 0] = 5;
 HEAP8[gb + 1546029 + 177 >> 0] = 5;
 HEAP8[gb + 1546029 + 178 >> 0] = 6;
 HEAP8[gb + 1546029 + 179 >> 0] = 0;
 HEAP8[gb + 1546029 + 180 >> 0] = 30;
 HEAP8[gb + 1546029 + 181 >> 0] = 1;
 HEAP8[gb + 1546029 + 182 >> 0] = 0;
 HEAP8[gb + 1546029 + 183 >> 0] = 3;
 HEAP8[gb + 1546029 + 184 >> 0] = 6;
 HEAP8[gb + 1546029 + 185 >> 0] = 6;
 HEAP8[gb + 1546029 + 186 >> 0] = 6;
 HEAP8[gb + 1546029 + 187 >> 0] = 0;
 HEAP8[gb + 1546029 + 188 >> 0] = 6;
 HEAP8[gb + 1546029 + 189 >> 0] = 6;
 HEAP8[gb + 1546029 + 190 >> 0] = 6;
 HEAP8[gb + 1546029 + 191 >> 0] = 0;
 HEAP8[gb + 1546029 + 192 >> 0] = 6;
 HEAP8[gb + 1546029 + 193 >> 0] = 6;
 HEAP8[gb + 1546029 + 194 >> 0] = 6;
 HEAP8[gb + 1546029 + 195 >> 0] = 0;
 HEAP8[gb + 1546029 + 196 >> 0] = 6;
 HEAP8[gb + 1546029 + 197 >> 0] = 6;
 HEAP8[gb + 1546029 + 198 >> 0] = 6;
 HEAP8[gb + 1546029 + 199 >> 0] = 0;
 HEAP8[gb + 1546029 + 200 >> 0] = 3;
 HEAP8[gb + 1546029 + 201 >> 0] = 0;
 HEAP8[gb + 1546029 + 202 >> 0] = 0;
 HEAP8[gb + 1546029 + 203 >> 0] = 4;
 HEAP8[gb + 1546029 + 204 >> 0] = 10;
 HEAP8[gb + 1546029 + 205 >> 0] = 10;
 HEAP8[gb + 1546029 + 206 >> 0] = 10;
 HEAP8[gb + 1546029 + 207 >> 0] = 0;
 HEAP8[gb + 1546029 + 208 >> 0] = 10;
 HEAP8[gb + 1546029 + 209 >> 0] = 10;
 HEAP8[gb + 1546029 + 210 >> 0] = 10;
 i1 = gb + 1546029 + 211 | 0;
 i2 = i1 + 9 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[gb + 1546029 + 220 >> 0] = 7;
 HEAP8[gb + 1546029 + 221 >> 0] = 0;
 HEAP8[gb + 1546029 + 222 >> 0] = 1;
 HEAP8[gb + 1546029 + 223 >> 0] = 4;
 HEAP8[gb + 1546029 + 224 >> 0] = 11;
 HEAP8[gb + 1546029 + 225 >> 0] = 11;
 HEAP8[gb + 1546029 + 226 >> 0] = 11;
 HEAP8[gb + 1546029 + 227 >> 0] = 0;
 HEAP8[gb + 1546029 + 228 >> 0] = 9;
 HEAP8[gb + 1546029 + 229 >> 0] = 9;
 HEAP8[gb + 1546029 + 230 >> 0] = 9;
 i1 = gb + 1546029 + 231 | 0;
 i2 = i1 + 9 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[gb + 1546029 + 240 >> 0] = 11;
 HEAP8[gb + 1546029 + 241 >> 0] = 0;
 HEAP8[gb + 1546029 + 242 >> 0] = 1;
 HEAP8[gb + 1546029 + 243 >> 0] = 4;
 HEAP8[gb + 1546029 + 244 >> 0] = 12;
 HEAP8[gb + 1546029 + 245 >> 0] = 12;
 HEAP8[gb + 1546029 + 246 >> 0] = 12;
 HEAP8[gb + 1546029 + 247 >> 0] = 0;
 HEAP8[gb + 1546029 + 248 >> 0] = 8;
 HEAP8[gb + 1546029 + 249 >> 0] = 8;
 HEAP8[gb + 1546029 + 250 >> 0] = 8;
 i1 = gb + 1546029 + 251 | 0;
 i2 = i1 + 9 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[gb + 1546029 + 260 >> 0] = 15;
 HEAP8[gb + 1546029 + 261 >> 0] = 0;
 HEAP8[gb + 1546029 + 262 >> 0] = 1;
 HEAP8[gb + 1546029 + 263 >> 0] = 4;
 HEAP8[gb + 1546029 + 264 >> 0] = 16;
 HEAP8[gb + 1546029 + 265 >> 0] = 16;
 HEAP8[gb + 1546029 + 266 >> 0] = 16;
 HEAP8[gb + 1546029 + 267 >> 0] = 0;
 HEAP8[gb + 1546029 + 268 >> 0] = 4;
 HEAP8[gb + 1546029 + 269 >> 0] = 4;
 HEAP8[gb + 1546029 + 270 >> 0] = 4;
 i1 = gb + 1546029 + 271 | 0;
 i2 = i1 + 9 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN13AnimationClip8TransferI14SafeBinaryReadEEvRT_(i12, i14) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 32 | 0;
 i10 = i15 + 16 | 0;
 i8 = i15;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i12, i14);
 __ZN14SafeBinaryRead10SetVersionEi(i14, 6);
 i11 = i12 + 212 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897930 | 0, i5, i13, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i7 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i11 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 1);
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i14 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i4 = i12 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897939 | 0, i5, i13, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i7 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i3 = i12 + 93 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897952 | 0, i5, i13, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i7 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i14 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i12 + 100 | 0;
  i3 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897974 | 0, i3, i13, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897991 | 0, i3, i13, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i10, 0); else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i10);
  i7 = i3;
 } else {
  HEAP32[i10 >> 2] = 0;
  i6 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i7 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897974 | 0, i7, i13, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i10, 0); else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i14 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i14);
  }
  if (!(HEAP32[i14 >> 2] & 33554432)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 897991 | 0, i7, i13, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i8, 0); else {
     i1 = HEAP32[i13 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i14 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i14);
   }
   if (HEAP8[i14 + 128 >> 0] | 0) __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i12, i8);
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i8);
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i13 + 4 | 0;
    do {
     i3 = i2 + -204 | 0;
     HEAP32[i6 >> 2] = i3;
     i4 = i2 + -36 | 0;
     if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
      HEAP32[i4 >> 2] = 0;
     }
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i8 = HEAP32[i3 >> 2] | 0;
      i4 = HEAP32[i2 + -192 >> 2] | 0;
      HEAP32[i13 >> 2] = 66;
      HEAP32[i5 >> 2] = i4;
      __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
     }
     i2 = HEAP32[i6 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i8 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 25;
   HEAP32[i13 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  }
 }
 i2 = i12 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898018 | 0, i7, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i2 = i12 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898032 | 0, i7, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i2 = i12 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898049 | 0, i7, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i6 = i12 + 164 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898063 | 0, i7, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i6, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i2 = i12 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898077 | 0, i7, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i4 = i12 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898090 | 0, HEAP32[gb + 37012 >> 2] | 0, i13, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i8 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 104; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 104; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 104) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i4 = i12 + 96 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 896261 | 0, i5, i13, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i8 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 115; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 115; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 115) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i2 = i12 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898103 | 0, gb + 1034406 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 4) | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 108 >> 2] | 0, i12 | 0) | 0)) __ZL51RenameMotionCurvesToRootCurvesBackwardCompatibilityRNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i6);
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 5) | 0) {
  HEAP32[i10 >> 2] = 1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898112 | 0, i5, i13, 0) | 0;
  if (!i1) i1 = 1; else {
   do if ((i1 | 0) > 0) {
    i1 = i14 + 16 | 0;
    i8 = HEAP32[i14 + 20 >> 2] | 0;
    i2 = i8 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 < i8 >>> 0) i9 = 136; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
      i9 = 136;
      break;
     }
     HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    } while (0);
    if ((i9 | 0) == 136) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
    if (!(HEAP32[i14 >> 2] & 512)) break;
    HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i14 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i14);
   i1 = (HEAP32[i10 >> 2] | 0) == 1 & 1;
  }
  HEAP8[i11 >> 0] = i1;
 }
 HEAP32[i14 + 4 >> 2] = i12 + 56;
 __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i12 + 216 | 0, gb + 898128 | 0, i12 + 220 | 0, gb + 898141 | 0, i14);
 i2 = i12 + 224 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898158 | 0, gb + 898180 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI14SafeBinaryReadEEvRT_(i2, i14); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i2 = i12 + 196 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 898209 | 0, i7, i13, 1) | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i2, 0); else {
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i14 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i14);
 STACKTOP = i15;
 return;
}

function _unzOpenCurrentFile3(i18, i10, i11, i12, i5) {
 i18 = i18 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i21 + 12 | 0;
 i20 = i21;
 if (!i18) {
  i20 = -102;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(HEAP32[i18 + 56 >> 2] | 0)) {
  i20 = -102;
  STACKTOP = i21;
  return i20 | 0;
 }
 i19 = i18 + 156 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) _free(i2);
  HEAP32[i1 >> 2] = 0;
  if (HEAP32[i1 + 64 >> 2] | 0) _unity_z_inflateEnd(i1 + 4 | 0) | 0;
  _free(i1);
  HEAP32[i19 >> 2] = 0;
 }
 i14 = i18 + 16 | 0;
 i15 = i18 + 28 | 0;
 i16 = i18 + 32 | 0;
 i13 = i18 + 152 | 0;
 i9 = i18 + 44 | 0;
 if (mftCall_iiiii(HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i9 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) | 0, 0) | 0) {
  i20 = -103;
  STACKTOP = i21;
  return i20 | 0;
 }
 i3 = HEAP32[i16 >> 2] | 0;
 i17 = i18 + 4 | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) {
  i2 = HEAPU8[i8 >> 0] | 0;
  i7 = 13;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) {
  i2 = 0;
  i7 = 13;
 } else i1 = -1;
 do if ((i7 | 0) == 13) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i1 = HEAPU8[i8 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i1 = i2; else {
   i1 = -1;
   break;
  }
  i2 = i1 << 8 | i2;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i1 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0) {
   i1 = -1;
   break;
  }
  i2 = (i1 << 16) + i2 | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i1 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0) {
   i1 = -1;
   break;
  }
  i1 = (i2 + (i1 << 24) | 0) == 67324752 ? 0 : -103;
 } while (0);
 i2 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i2 | 0, i8 | 0, 1) | 0) == 1) i7 = 26; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i2 | 0) | 0)) i7 = 26; else i1 = -1;
 do if ((i7 | 0) == 26) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i2 | 0, i8 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i2 | 0) | 0) {
  i1 = -1;
  break;
 } while (0);
 i3 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) {
  i2 = HEAPU8[i8 >> 0] | 0;
  i7 = 33;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) {
  i2 = 0;
  i7 = 33;
 } else {
  i1 = -1;
  i2 = 0;
 }
 do if ((i7 | 0) == 33) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) != 1) if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i2 = i2 * 257 | 0; else {
  i1 = -1;
  i2 = 0;
  break;
 } while (0);
 i4 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i4 | 0, i8 | 0, 1) | 0) == 1) {
  i3 = HEAPU8[i8 >> 0] | 0;
  i7 = 40;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i4 | 0) | 0)) {
  i3 = 0;
  i7 = 40;
 } else i1 = -1;
 L60 : do if ((i7 | 0) == 40) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i4 | 0, i8 | 0, 1) | 0) == 1) i3 = (HEAPU8[i8 >> 0] | 0) << 8 | i3; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i4 | 0) | 0)) i3 = i3 * 257 | 0; else {
   i1 = -1;
   break;
  }
  if (!i1) if ((i3 | 0) == (HEAP32[i18 + 84 >> 2] | 0)) {
   switch (i3 | 0) {
   case 8:
   case 0:
    {
     i1 = 0;
     break L60;
    }
   default:
    {}
   }
   i1 = -103;
  } else i1 = -103;
 } while (0);
 i3 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i7 = 50; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i7 = 50; else i1 = -1;
 do if ((i7 | 0) == 50) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0) {
   i1 = -1;
   break;
  }
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0) {
   i1 = -1;
   break;
  }
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0) {
   i1 = -1;
   break;
  }
 } while (0);
 i6 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i8 >> 0] | 0;
  i7 = 63;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) {
  i4 = 0;
  i7 = 63;
 } else i1 = -1;
 do if ((i7 | 0) == 63) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) i3 = i4; else {
   i1 = -1;
   break;
  }
  i4 = i3 << 8 | i4;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  i4 = (i3 << 16) + i4 | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  if (!i1) if ((i4 + (i3 << 24) | 0) == (HEAP32[i18 + 92 >> 2] | 0)) i1 = 0; else i1 = (i2 & 8 | 0) == 0 ? -103 : 0;
 } while (0);
 i6 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i8 >> 0] | 0;
  i7 = 78;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) {
  i4 = 0;
  i7 = 78;
 } else i1 = -1;
 do if ((i7 | 0) == 78) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) i3 = i4; else {
   i1 = -1;
   break;
  }
  i4 = i3 << 8 | i4;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  i4 = (i3 << 16) + i4 | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  if (!i1) if ((i4 + (i3 << 24) | 0) == (HEAP32[i18 + 96 >> 2] | 0)) i1 = 0; else i1 = (i2 & 8 | 0) == 0 ? -103 : 0;
 } while (0);
 i6 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i8 >> 0] | 0;
  i7 = 93;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) {
  i4 = 0;
  i7 = 93;
 } else i1 = -1;
 do if ((i7 | 0) == 93) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0)) i3 = i4; else {
   i1 = -1;
   break;
  }
  i4 = i3 << 8 | i4;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  i4 = (i3 << 16) + i4 | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0, 1) | 0) == 1) i3 = HEAPU8[i8 >> 0] | 0; else if (mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i6 | 0) | 0) {
   i1 = -1;
   break;
  }
  if (!i1) if ((i4 + (i3 << 24) | 0) == (HEAP32[i18 + 100 >> 2] | 0)) i1 = 0; else i1 = (i2 & 8 | 0) == 0 ? -103 : 0;
 } while (0);
 i3 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) {
  i2 = HEAPU8[i8 >> 0] | 0;
  i7 = 108;
 } else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) {
  i2 = 0;
  i7 = 108;
 } else {
  i4 = -1;
  i2 = 0;
 }
 do if ((i7 | 0) == 108) {
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i2 = (HEAPU8[i8 >> 0] | 0) << 8 | i2; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i2 = i2 * 257 | 0; else {
   i4 = -1;
   i2 = 0;
   break;
  }
  if (!i1) i4 = (i2 | 0) == (HEAP32[i18 + 104 >> 2] | 0) ? 0 : -103; else i4 = i1;
 } while (0);
 i3 = HEAP32[i16 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i1 = HEAPU8[i8 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i1 = 0; else {
  i20 = -103;
  STACKTOP = i21;
  return i20 | 0;
 }
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0, i8 | 0, 1) | 0) == 1) i8 = (HEAPU8[i8 >> 0] | 0) << 8 | i1; else if (!(mftCall_iii(HEAP32[i18 + 24 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3 | 0) | 0)) i8 = i1 * 257 | 0; else {
  i20 = -103;
  STACKTOP = i21;
  return i20 | 0;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 i7 = i2 + 30 | 0;
 if (i4 | 0) {
  i20 = -103;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = _malloc(144) | 0;
 if (!i6) {
  i20 = -104;
  STACKTOP = i21;
  return i20 | 0;
 }
 i4 = _malloc(16384) | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 68 >> 2] = i7 + i1;
 HEAP32[i6 + 72 >> 2] = i8;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 140 >> 2] = i12;
 if (!i4) {
  _free(i6);
  i20 = -104;
  STACKTOP = i21;
  return i20 | 0;
 }
 i4 = i6 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 if (i10 | 0) HEAP32[i10 >> 2] = HEAP32[i18 + 84 >> 2];
 L182 : do if (i11 | 0) {
  HEAP32[i11 >> 2] = 6;
  switch (HEAP32[i18 + 80 >> 2] & 6) {
  case 6:
   {
    HEAP32[i11 >> 2] = 1;
    break L182;
   }
  case 4:
   {
    HEAP32[i11 >> 2] = 2;
    break L182;
   }
  case 2:
   {
    HEAP32[i11 >> 2] = 9;
    break L182;
   }
  default:
   break L182;
  }
 } while (0);
 HEAP32[i6 + 84 >> 2] = HEAP32[i18 + 92 >> 2];
 HEAP32[i6 + 80 >> 2] = 0;
 i11 = HEAP32[i18 + 84 >> 2] | 0;
 HEAP32[i6 + 132 >> 2] = i11;
 HEAP32[i6 + 128 >> 2] = HEAP32[i16 >> 2];
 i3 = i6 + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 HEAP32[i6 + 136 >> 2] = HEAP32[i9 >> 2];
 i3 = i6 + 4 | 0;
 HEAP32[i6 + 24 >> 2] = 0;
 do if ((i12 | 0) != 0 | (i11 | 0) != 8) i2 = i6 + 8 | 0; else {
  HEAP32[i6 + 36 >> 2] = 0;
  HEAP32[i6 + 40 >> 2] = 0;
  HEAP32[i6 + 44 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i2 = i6 + 8 | 0;
  HEAP32[i2 >> 2] = 0;
  i1 = _unity_z_inflateInit2_(i3, -15, gb + 362978 | 0, 56) | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 1;
   i1 = HEAP32[i13 >> 2] | 0;
   break;
  }
  _free(i6);
  i20 = i1;
  STACKTOP = i21;
  return i20 | 0;
 } while (0);
 HEAP32[i6 + 88 >> 2] = HEAP32[i18 + 96 >> 2];
 HEAP32[i6 + 92 >> 2] = HEAP32[i18 + 100 >> 2];
 HEAP32[i6 + 60 >> 2] = i7 + i8 + i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i19 >> 2] = i6;
 if (!i5) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = _unity_z_get_crc_table() | 0;
 i7 = i18 + 176 | 0;
 HEAP32[i7 >> 2] = i6;
 i8 = i18 + 164 | 0;
 HEAP32[i8 >> 2] = 305419896;
 i9 = i18 + 168 | 0;
 HEAP32[i9 >> 2] = 591751049;
 i10 = i18 + 172 | 0;
 HEAP32[i10 >> 2] = 878082192;
 i1 = HEAP8[i5 >> 0] | 0;
 if (i1 << 24 >> 24) {
  i2 = 305419896;
  i3 = 591751049;
  i4 = 878082192;
  do {
   i2 = HEAP32[i6 + ((i1 & 255 ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   HEAP32[i8 >> 2] = i2;
   i3 = (Math_imul((i2 & 255) + i3 | 0, 134775813) | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i3;
   i4 = HEAP32[i6 + ((i3 >>> 24 ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
   HEAP32[i10 >> 2] = i4;
   i5 = i5 + 1 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i13 = HEAP32[i19 >> 2] | 0;
 if (mftCall_iiiii(HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i13 + 136 >> 2] | 0) + (HEAP32[i13 + 60 >> 2] | 0) | 0, 0) | 0) {
  i20 = -104;
  STACKTOP = i21;
  return i20 | 0;
 }
 if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] | 0, i20 | 0, 12) | 0) >>> 0 < 12) {
  i20 = -104;
  STACKTOP = i21;
  return i20 | 0;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 do {
  i17 = i3 & 65533;
  i17 = (Math_imul(i17 | 2, i17 ^ 3) | 0) >>> 8 & 255;
  i16 = i20 + i1 | 0;
  i17 = i17 ^ (HEAPU8[i16 >> 0] | 0);
  HEAP8[i16 >> 0] = i17;
  i4 = HEAP32[i2 + ((i17 ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
  HEAP32[i8 >> 2] = i4;
  i5 = (Math_imul(i5 + (i4 & 255) | 0, 134775813) | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i5;
  i3 = HEAP32[i2 + ((i5 >>> 24 ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  HEAP32[i10 >> 2] = i3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 12);
 i20 = (HEAP32[i19 >> 2] | 0) + 60 | 0;
 HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 12;
 HEAP32[i18 + 160 >> 2] = 1;
 i20 = 0;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN7mecanim9animation18PrecomputeFreeformEiRNS0_19Blend2dDataConstantERNS_6memory9AllocatorE(i25, i28, i33) {
 i25 = i25 | 0;
 i28 = i28 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i40;
 i35 = i40 + 80 | 0;
 i36 = i40 + 68 | 0;
 i37 = i40 + 56 | 0;
 i38 = i40 + 44 | 0;
 i14 = i40 + 40 | 0;
 i23 = i40 + 36 | 0;
 i22 = i40 + 32 | 0;
 i21 = i40 + 28 | 0;
 i39 = i40 + 8 | 0;
 i19 = i28 + 4 | 0;
 i32 = HEAP32[i19 >> 2] | 0;
 i19 = (i32 | 0) == 0 ? 0 : i32 + i19 | 0;
 i32 = HEAP32[i28 >> 2] | 0;
 i7 = i28 + 12 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 i7 = (i12 | 0) == 0 ? 0 : i12 + i7 | 0;
 i12 = i28 + 20 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i12 = (i13 | 0) == 0 ? 0 : i13 + i12 | 0;
 i13 = i28 + 28 | 0;
 i31 = HEAP32[i13 >> 2] | 0;
 i13 = (i31 | 0) == 0 ? 0 : i31 + i13 | 0;
 i31 = i28 + 36 | 0;
 i29 = HEAP32[i31 >> 2] | 0;
 i31 = (i29 | 0) == 0 ? 0 : i29 + i31 | 0;
 i29 = (i25 | 0) == 2;
 if (i29) {
  i2 = (i32 | 0) == 0;
  if (!i2) {
   i1 = 0;
   do {
    f10 = Math_fround(HEAPF32[i19 + (i1 << 3) >> 2]);
    f10 = Math_fround(f10 * f10);
    f11 = Math_fround(HEAPF32[i19 + (i1 << 3) + 4 >> 2]);
    HEAPF32[i7 + (i1 << 2) >> 2] = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f11 * f11))));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i32 | 0));
   if (!i2) {
    i1 = 0;
    do {
     i3 = i7 + (i1 << 2) | 0;
     i4 = i19 + (i1 << 3) | 0;
     i5 = i19 + (i1 << 3) + 4 | 0;
     i2 = 0;
     do {
      i6 = (Math_imul(i2, i32) | 0) + i1 | 0;
      i30 = i7 + (i2 << 2) | 0;
      f8 = Math_fround(HEAPF32[i30 >> 2]);
      f8 = Math_fround(Math_fround(2.0) / Math_fround(f8 + Math_fround(HEAPF32[i3 >> 2])));
      HEAPF32[i13 + (i6 << 2) >> 2] = f8;
      f10 = Math_fround(HEAPF32[i30 >> 2]);
      f11 = Math_fround(HEAPF32[i3 >> 2]);
      f8 = Math_fround(f8 * Math_fround(f10 - f11));
      if (f10 == Math_fround(0.0) | f11 == Math_fround(0.0)) HEAP32[i12 + (i6 << 3) >> 2] = 0; else {
       f42 = Math_fround(HEAPF32[i4 >> 2]);
       f9 = Math_fround(HEAPF32[i19 + (i2 << 3) >> 2]);
       f11 = Math_fround(f42 * f9);
       f10 = Math_fround(HEAPF32[i5 >> 2]);
       f41 = Math_fround(HEAPF32[i19 + (i2 << 3) + 4 >> 2]);
       f11 = Math_fround(Math_fround(f11 + Math_fround(f10 * f41)) / Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f42 * f42) + Math_fround(f10 * f10)))) * Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(f41 * f41))))));
       i30 = f11 > Math_fround(-1.0);
       f11 = i30 ? f11 : Math_fround(-1.0);
       i30 = f11 < Math_fround(1.0);
       f11 = Math_fround(+Math_acos(+(i30 ? f11 : Math_fround(1.0))));
       i30 = Math_fround(Math_fround(f42 * f41) - Math_fround(f9 * f10)) < Math_fround(0.0);
       f10 = Math_fround(-f11);
       HEAPF32[i12 + (i6 << 3) >> 2] = i30 ? f10 : f11;
      }
      HEAPF32[i12 + (i6 << 3) + 4 >> 2] = f8;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i32 | 0));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i32 | 0));
   }
  }
 } else if ((i25 | 0) == 3 & (i32 | 0) != 0) {
  i1 = 0;
  do {
   i3 = i19 + (i1 << 3) | 0;
   i4 = i19 + (i1 << 3) + 4 | 0;
   i2 = 0;
   do {
    i30 = (Math_imul(i2, i32) | 0) + i1 | 0;
    i26 = i19 + (i2 << 3) | 0;
    f42 = Math_fround(HEAPF32[i26 >> 2]);
    f42 = Math_fround(f42 - Math_fround(HEAPF32[i3 >> 2]));
    i27 = i19 + (i2 << 3) + 4 | 0;
    f41 = Math_fround(HEAPF32[i27 >> 2]);
    f41 = Math_fround(f41 - Math_fround(HEAPF32[i4 >> 2]));
    HEAPF32[i13 + (i30 << 2) >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f42 * f42) + Math_fround(f41 * f41)));
    f41 = Math_fround(HEAPF32[i26 >> 2]);
    f41 = Math_fround(f41 - Math_fround(HEAPF32[i3 >> 2]));
    f42 = Math_fround(HEAPF32[i27 >> 2]);
    f42 = Math_fround(f42 - Math_fround(HEAPF32[i4 >> 2]));
    HEAPF32[i12 + (i30 << 3) >> 2] = f41;
    HEAPF32[i12 + (i30 << 3) + 4 >> 2] = f42;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i32 | 0));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i32 | 0));
 }
 HEAP32[i35 >> 2] = 0;
 i30 = i35 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i30;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i32 << 2;
 i5 = (i6 | 0) != 0;
 do if (i5) {
  i1 = i6 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 913845 | 0, 78) | 0;
   i3 = gb + 64016 | 0;
   i27 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i35 >> 2] = i2;
   i4 = i30;
   HEAP32[i4 >> 2] = i27;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i2 = 0; while (0);
 i18 = i2 + 3 & -4;
 HEAP32[i36 >> 2] = 0;
 i27 = i36 + 4 | 0;
 i26 = i27;
 HEAP32[i26 >> 2] = i3;
 HEAP32[i26 + 4 >> 2] = i4;
 do if (i5) {
  i2 = i6 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 913845 | 0, 81) | 0;
   i3 = gb + 64016 | 0;
   i26 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i36 >> 2] = i1;
   i4 = i27;
   HEAP32[i4 >> 2] = i26;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } else i1 = 0; while (0);
 i17 = i1 + 3 & -4;
 HEAP32[i37 >> 2] = 0;
 i26 = i37 + 4 | 0;
 i1 = i26;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i32 << 3;
 do if (!i1) i1 = 0; else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 913845 | 0, 84) | 0;
   i3 = gb + 64016 | 0;
   i24 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i37 >> 2] = i1;
   i4 = i26;
   HEAP32[i4 >> 2] = i24;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = gb + 63160 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 i16 = i1 + 3 & -4;
 HEAP32[i38 >> 2] = 0;
 i24 = i38 + 4 | 0;
 i2 = i24;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = Math_imul(i32, i32) | 0;
 if (!i2) i20 = 0; else {
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 913845 | 0, 87) | 0;
   i15 = gb + 64016 | 0;
   i13 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 4 >> 2] | 0;
   HEAP32[i38 >> 2] = i1;
   i20 = i24;
   HEAP32[i20 >> 2] = i13;
   HEAP32[i20 + 4 >> 2] = i15;
  }
  _memset(i1 | 0, 0, i2 | 0) | 0;
  i20 = i1;
 }
 HEAP32[i14 >> 2] = 1176256512;
 HEAP32[i23 >> 2] = -971227136;
 HEAP32[i22 >> 2] = 1176256512;
 HEAP32[i21 >> 2] = -971227136;
 i15 = (i32 | 0) == 0;
 if (i15) {
  i13 = i21;
  i12 = i22;
  i7 = i23;
  f11 = Math_fround(-1.0e4);
  f10 = Math_fround(1.0e4);
  f9 = Math_fround(-1.0e4);
  f8 = Math_fround(1.0e4);
 } else {
  i1 = 0;
  f11 = Math_fround(-1.0e4);
  f10 = Math_fround(1.0e4);
  f9 = Math_fround(-1.0e4);
  f8 = Math_fround(1.0e4);
  do {
   i7 = i19 + (i1 << 3) | 0;
   i6 = Math_fround(HEAPF32[i7 >> 2]) < f8;
   i6 = HEAP32[(i6 ? i7 : i14) >> 2] | 0;
   HEAP32[i14 >> 2] = i6;
   i13 = f9 < Math_fround(HEAPF32[i7 >> 2]);
   i7 = HEAP32[(i13 ? i7 : i23) >> 2] | 0;
   HEAP32[i23 >> 2] = i7;
   i13 = i19 + (i1 << 3) + 4 | 0;
   f8 = Math_fround(HEAPF32[i13 >> 2]);
   i12 = HEAP32[(f8 < f10 ? i13 : i22) >> 2] | 0;
   HEAP32[i22 >> 2] = i12;
   i13 = HEAP32[(f11 < f8 ? i13 : i21) >> 2] | 0;
   HEAP32[i21 >> 2] = i13;
   i1 = i1 + 1 | 0;
   f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i1 | 0) != (i32 | 0));
  i13 = i21;
  i12 = i22;
  i7 = i23;
 }
 f41 = Math_fround(Math_fround(f9 - f8) * Math_fround(.5));
 f42 = Math_fround(Math_fround(f11 - f10) * Math_fround(.5));
 HEAPF32[i14 >> 2] = Math_fround(f8 - f41);
 HEAPF32[i7 >> 2] = Math_fround(f41 + f9);
 HEAPF32[i12 >> 2] = Math_fround(f10 - f42);
 HEAPF32[i13 >> 2] = Math_fround(f42 + f11);
 i5 = (i25 | 0) == 3;
 i6 = (i32 | 0) != 0;
 i4 = 0;
 do {
  f9 = Math_fround(Math_fround(i4 >>> 0) * Math_fround(.00999999977));
  f10 = Math_fround(Math_fround(1.0) - f9);
  if (i29) {
   i2 = 0;
   do {
    f42 = Math_fround(Math_fround(i2 >>> 0) * Math_fround(.00999999977));
    f11 = Math_fround(f10 * Math_fround(HEAPF32[i14 >> 2]));
    f11 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i7 >> 2])));
    f41 = Math_fround(Math_fround(Math_fround(1.0) - f42) * Math_fround(HEAPF32[i12 >> 2]));
    __ZN7mecanim9animation29GetWeightsFreeformDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb(i28, i18, i17, i16, f11, Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i13 >> 2]))), 1);
    if (i6) {
     i1 = 0;
     do {
      i3 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
      if ((i3 | 0) > -1) HEAP8[i20 + (i3 + (Math_imul(i1, i32) | 0)) >> 0] = 1;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i32 | 0));
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 101);
  } else {
   i3 = 0;
   do {
    f8 = Math_fround(Math_fround(i3 >>> 0) * Math_fround(.00999999977));
    if (i5) {
     f41 = Math_fround(f10 * Math_fround(HEAPF32[i14 >> 2]));
     f41 = Math_fround(f41 + Math_fround(f9 * Math_fround(HEAPF32[i7 >> 2])));
     f42 = Math_fround(Math_fround(Math_fround(1.0) - f8) * Math_fround(HEAPF32[i12 >> 2]));
     __ZN7mecanim9animation27GetWeightsFreeformCartesianERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb(i28, i18, i17, i16, f41, Math_fround(f42 + Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2]))), 1);
    }
    if (i6) {
     i1 = 0;
     do {
      i2 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
      if ((i2 | 0) > -1) HEAP8[i20 + (i2 + (Math_imul(i1, i32) | 0)) >> 0] = 1;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i32 | 0));
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != 101);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 101);
 if (i15) {
  i39 = HEAP32[i38 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i39, i24);
  i39 = HEAP32[i37 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i39, i26);
  i39 = HEAP32[i36 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i39, i27);
  i39 = HEAP32[i35 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i39, i30);
  STACKTOP = i40;
  return;
 }
 i13 = i39 + 12 | 0;
 i14 = i39 + 16 | 0;
 i15 = i39 + 4 | 0;
 i12 = 0;
 do {
  HEAP32[i39 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i34, gb + 63664 | 0);
  i29 = i34;
  i1 = HEAP32[i29 + 4 >> 2] | 0;
  i3 = i15;
  HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = Math_imul(i12, i32) | 0;
  i1 = 0;
  do {
   if (HEAP8[i20 + (i1 + i3) >> 0] | 0) {
    i4 = HEAP32[i13 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i14 >> 2] = i2;
      HEAP32[i39 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i39 >> 2] | 0, i2 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i39 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      HEAP32[i14 >> 2] = i2;
      HEAP32[i39 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i13 >> 2] = i5;
    HEAP32[(HEAP32[i39 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i32 | 0));
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i31 + (i12 << 3) >> 2] = i2;
  i4 = i31 + (i12 << 3) + 4 | 0;
  if (!i2) i1 = 0; else {
   i3 = i2 << 2;
   i1 = mftCall_iiii(HEAP32[HEAP32[i33 >> 2] >> 2] | 0, i33 | 0, i3 | 0, 4) | 0;
   if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  }
  i3 = i4;
  i1 = i1 | 0 ? i1 - i3 | 0 : 0;
  HEAP32[i4 >> 2] = i1;
  if (HEAP32[i13 >> 2] | 0) {
   i2 = HEAP32[i39 >> 2] | 0;
   HEAP32[i1 + i3 >> 2] = HEAP32[i2 >> 2];
   if ((HEAP32[i13 >> 2] | 0) >>> 0 > 1) {
    i1 = 1;
    do {
     HEAP32[(HEAP32[i4 >> 2] | 0) + i3 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
   }
  }
  if ((HEAP32[i14 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i15);
   HEAP32[i39 >> 2] = 0;
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i32 | 0));
 i39 = HEAP32[i38 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i39, i24);
 i39 = HEAP32[i37 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i39, i26);
 i39 = HEAP32[i36 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i39, i27);
 i39 = HEAP32[i35 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i39, i30);
 STACKTOP = i40;
 return;
}

function __ZN13AvatarBuilder12GetAllParentER9TransformS1_RNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb(i14, i15, i13, i11, i12) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 36 | 0;
 i18 = i19;
 i10 = HEAP32[i15 + 100 >> 2] | 0;
 do if (i10 | 0) {
  __ZN13AvatarBuilder12GetAllParentER9TransformS1_RNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb(i14, i10, i13, i11, 0);
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  i4 = i9;
  i8 = i7;
  if ((i7 | 0) != (i9 | 0)) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 + 12 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
    i1 = HEAP32[i18 + 12 >> 2] | 0;
    i16 = 6;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i18 + 11 >> 0] = i3;
    if (!i3) i1 = i18; else {
     i1 = i18;
     i16 = 8;
    }
   } else i16 = 6;
   if ((i16 | 0) == 6) {
    i9 = i3 + 16 & -16;
    HEAP32[i17 >> 2] = 66;
    HEAP32[i17 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i18 >> 2] = i1;
    HEAP32[i18 + 8 >> 2] = i9 | -2147483648;
    HEAP32[i18 + 4 >> 2] = i3;
    i16 = 8;
   }
   if ((i16 | 0) == 8) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   i7 = HEAP8[i18 + 11 >> 0] | 0;
   L14 : do if ((i4 | 0) == (i8 | 0)) i1 = 0; else {
    i6 = i7 << 24 >> 24 < 0;
    i5 = i6 ? HEAP32[i18 + 4 >> 2] | 0 : i7 & 255;
    i6 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
    while (1) {
     i3 = HEAP8[i4 + 11 >> 0] | 0;
     i1 = i3 << 24 >> 24 < 0;
     if (i1) i2 = HEAP32[i4 + 4 >> 2] | 0; else i2 = i3 & 255;
     if ((i2 | 0) == (i5 | 0)) {
      if (i1) {
       i2 = HEAP32[i4 >> 2] | 0;
       i1 = HEAP32[i4 + 4 >> 2] | 0;
      } else {
       i2 = i4;
       i1 = i3 & 255;
      }
      if (!(_strncmp(i2, i6, i1) | 0)) {
       i1 = 1;
       break L14;
      }
     }
     i4 = i4 + 16 | 0;
     if ((i4 | 0) == (i8 | 0)) {
      i1 = 0;
      break;
     }
    }
   } while (0);
   if (i7 << 24 >> 24 < 0) {
    i9 = HEAP32[i18 >> 2] | 0;
    i8 = HEAP32[i18 + 12 >> 2] | 0;
    HEAP32[i17 >> 2] = 66;
    HEAP32[i17 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i17);
   }
   if (!i1) break;
  }
  i1 = i18;
  i2 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i9 = i18 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i18 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i9 = i13 + 4 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i13 + 8 >> 2] | 0)) __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i13, i18); else {
   __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i1, i18);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 36;
  }
  i1 = i18 + 16 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i18 + 28 >> 2] | 0;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i17);
  }
  if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i18 >> 2] | 0;
   i7 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i17);
  }
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i6 + -4 >> 2] = i10;
  i1 = i6 + -20 | 0;
  __Z22CalculateTransformPathRK9TransformPS0_(i17, i10, i14);
  i8 = HEAP8[i17 + 11 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i17 >> 2] | 0 : i17;
  i8 = i4 ? HEAP32[i17 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i6 + -12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i6 + -16 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
   HEAP8[i1 + i8 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i6 + -16 >> 2] = i8;
    break;
   } else {
    HEAP8[i4 >> 0] = i8;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = i8 + -36 | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i18 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i18 + 12 >> 2] | 0;
   i16 = 48;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i18 + 11 >> 0] = i3;
   if (!i3) i1 = i18; else {
    i1 = i18;
    i16 = 50;
   }
  } else i16 = 48;
  if ((i16 | 0) == 48) {
   i10 = i3 + 16 & -16;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i18 + 8 >> 2] = i10 | -2147483648;
   HEAP32[i18 + 4 >> 2] = i3;
   i16 = 50;
  }
  if ((i16 | 0) == 50) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i5 = i18 + 11 | 0;
  do if ((i9 | 0) != (i18 | 0)) {
   i7 = HEAP8[i5 >> 0] | 0;
   i3 = i7 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i18 >> 2] | 0 : i18;
   i7 = i3 ? HEAP32[i18 + 4 >> 2] | 0 : i7 & 255;
   i3 = i9 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i8 + -28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i7 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i8 + -32 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
    break;
   }
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i8 + -32 >> 2] = i7;
    break;
   } else {
    HEAP8[i3 >> 0] = i7;
    break;
   }
  } while (0);
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   i10 = HEAP32[i18 >> 2] | 0;
   i9 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i17);
  }
 } while (0);
 if (!i12) {
  STACKTOP = i19;
  return;
 }
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i4 = i12;
 i8 = i10;
 if ((i10 | 0) != (i12 | 0)) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i18 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i18 + 12 >> 2] | 0;
   i16 = 75;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i18 + 11 >> 0] = i3;
   if (!i3) i1 = i18; else {
    i1 = i18;
    i16 = 77;
   }
  } else i16 = 75;
  if ((i16 | 0) == 75) {
   i12 = i3 + 16 & -16;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i18 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i18 + 4 >> 2] = i3;
   i16 = 77;
  }
  if ((i16 | 0) == 77) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i7 = HEAP8[i18 + 11 >> 0] | 0;
  L115 : do if ((i4 | 0) == (i8 | 0)) i1 = 0; else {
   i6 = i7 << 24 >> 24 < 0;
   i5 = i6 ? HEAP32[i18 + 4 >> 2] | 0 : i7 & 255;
   i6 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
   while (1) {
    i3 = HEAP8[i4 + 11 >> 0] | 0;
    i1 = i3 << 24 >> 24 < 0;
    if (i1) i2 = HEAP32[i4 + 4 >> 2] | 0; else i2 = i3 & 255;
    if ((i2 | 0) == (i5 | 0)) {
     if (i1) {
      i2 = HEAP32[i4 >> 2] | 0;
      i1 = HEAP32[i4 + 4 >> 2] | 0;
     } else {
      i2 = i4;
      i1 = i3 & 255;
     }
     if (!(_strncmp(i2, i6, i1) | 0)) {
      i1 = 1;
      break L115;
     }
    }
    i4 = i4 + 16 | 0;
    if ((i4 | 0) == (i8 | 0)) {
     i1 = 0;
     break;
    }
   }
  } while (0);
  if (i7 << 24 >> 24 < 0) {
   i12 = HEAP32[i18 >> 2] | 0;
   i11 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i17 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i17);
  }
  if (!i1) {
   STACKTOP = i19;
   return;
  }
 }
 i1 = i18;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i9 = i18 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i9 = i13 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i13 + 8 >> 2] | 0)) __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i13, i18); else {
  __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i1, i18);
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 36;
 }
 i1 = i18 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i1 >> 2] | 0;
  i12 = HEAP32[i18 + 28 >> 2] | 0;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i17);
 }
 if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i18 >> 2] | 0;
  i12 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i17);
 }
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 + -4 >> 2] = i15;
 i1 = i6 + -20 | 0;
 __Z22CalculateTransformPathRK9TransformPS0_(i17, i15, i14);
 i8 = HEAP8[i17 + 11 >> 0] | 0;
 i4 = i8 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i17 >> 2] | 0 : i17;
 i8 = i4 ? HEAP32[i17 + 4 >> 2] | 0 : i8 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + -12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i8 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + -16 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + -16 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = i8 + -36 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i16 = 117;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i18 + 11 >> 0] = i3;
  if (!i3) i1 = i18; else {
   i1 = i18;
   i16 = 119;
  }
 } else i16 = 117;
 if ((i16 | 0) == 117) {
  i15 = i3 + 16 & -16;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i18 + 4 >> 2] = i3;
  i16 = 119;
 }
 if ((i16 | 0) == 119) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i18 + 11 | 0;
 do if ((i9 | 0) != (i18 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i18 >> 2] | 0 : i18;
  i7 = i3 ? HEAP32[i18 + 4 >> 2] | 0 : i7 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + -28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + -32 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + -32 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i16 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i17);
 }
 STACKTOP = i19;
 return;
}

function __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE(i26, i20, i4, i23) {
 i26 = i26 | 0;
 i20 = i20 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i27 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i25 + 424 | 0;
 i2 = i25 + 472 | 0;
 i16 = i25 + 468 | 0;
 i18 = i25 + 24 | 0;
 i24 = i25 + 20 | 0;
 i3 = i25;
 i19 = i25 + 16 | 0;
 i21 = i25 + 12 | 0;
 i22 = i25 + 8 | 0;
 i15 = i17 + 4 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i17 >> 2] = 59;
 HEAP32[i17 + 4 >> 2] = 55;
 HEAP32[i17 + 8 >> 2] = 23;
 HEAP32[i17 + 12 >> 2] = 31;
 HEAP32[i17 + 16 >> 2] = 11;
 HEAP32[i17 + 20 >> 2] = 161;
 HEAP32[i17 + 24 >> 2] = 6;
 HEAP32[i17 + 28 >> 2] = 364;
 HEAP32[i17 + 32 >> 2] = -1;
 HEAP8[i16 + 2 >> 0] = 0;
 HEAP8[i16 >> 0] = 37;
 HEAP8[i16 + 1 >> 0] = i4;
 _strftime_l(i2 | 0, 100, i16 | 0, i17 | 0, HEAP32[i20 >> 2] | 0) | 0;
 HEAP32[i24 >> 2] = i18;
 i17 = i3;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i19 >> 2] = i2;
 i2 = _uselocale(HEAP32[i20 >> 2] | 0) | 0;
 __THREW__ = 0;
 i3 = invoke_iiiii(fb + 208 | 0, i18 | 0, i19 | 0, 100, i3 | 0) | 0;
 i19 = __THREW__;
 __THREW__ = 0;
 if (i19 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
   i26 = __THREW__;
   __THREW__ = 0;
   if (i26 & 1) {
    i26 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i26);
   }
  }
  ___resumeException(i1 | 0);
 }
 if (i2 | 0) {
  __THREW__ = 0;
  invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
  i19 = __THREW__;
  __THREW__ = 0;
  if (i19 & 1) {
   i19 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i19);
  }
 }
 if ((i3 | 0) == -1) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0);
 i2 = HEAP32[i24 >> 2] | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i26 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i13 = i2 + (i3 << 2) | 0;
 i14 = i20 + 4 | 0;
 i15 = i20 + 172 | 0;
 i16 = i14;
 i17 = i20 + 172 | 0;
 i18 = i20 + 460 | 0;
 i19 = i17;
 i3 = i4 << 24 >> 24 == 120;
 i4 = i26 + 8 + 3 | 0;
 i5 = i26 + 4 | 0;
 i6 = i20 + 460 | 0;
 i7 = i20 + 468 + 3 | 0;
 i8 = i20 + 464 | 0;
 i9 = i20 + 480 + 3 | 0;
 i10 = i20 + 476 | 0;
 i11 = i20 + 484 | 0;
 i12 = i6;
 i1 = i2;
 L19 : while (1) {
  if ((i1 | 0) == (i13 | 0)) {
   i2 = 104;
   break;
  }
  __THREW__ = 0;
  i1 = invoke_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, 8192, HEAP32[i1 >> 2] | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 23;
   break;
  }
  L23 : do if (i1) {
   __THREW__ = 0;
   invoke_vii(fb + 4513 | 0, i26 | 0, 32);
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) {
    i2 = 23;
    break L19;
   }
   do {
    i1 = (HEAP32[i24 >> 2] | 0) + 4 | 0;
    HEAP32[i24 >> 2] = i1;
    if ((i1 | 0) == (i13 | 0)) break L23;
    __THREW__ = 0;
    i1 = invoke_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, 8192, HEAP32[i1 >> 2] | 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (i2 & 1) {
     i2 = 22;
     break L19;
    }
   } while (i1);
  } else {
   HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i22 >> 2] = 0;
   __THREW__ = 0;
   i1 = invoke_iiiiiiii(fb + 102 | 0, i21 | 0, i13 | 0, i14 | 0, i15 | 0, i23 | 0, i22 | 0, 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) {
    i2 = 30;
    break L19;
   }
   i1 = i1 - i16 | 0;
   L31 : do if ((i1 | 0) < 168) {
    __THREW__ = 0;
    invoke_vii(fb + 4513 | 0, i26 | 0, 37);
    i2 = __THREW__;
    __THREW__ = 0;
    if (i2 & 1) {
     i2 = 32;
     break L19;
    }
    if ((i1 | 0) < 84) {
     __THREW__ = 0;
     invoke_vii(fb + 4513 | 0, i26 | 0, 65);
     i2 = __THREW__;
     __THREW__ = 0;
     if (i2 & 1) {
      i2 = 32;
      break L19;
     }
    } else {
     __THREW__ = 0;
     invoke_vii(fb + 4513 | 0, i26 | 0, 97);
     i2 = __THREW__;
     __THREW__ = 0;
     if (i2 & 1) {
      i2 = 32;
      break L19;
     }
    }
    HEAP32[i24 >> 2] = HEAP32[i21 >> 2];
   } else {
    HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
    __THREW__ = 0;
    i1 = invoke_iiiiiiii(fb + 102 | 0, i21 | 0, i13 | 0, i17 | 0, i18 | 0, i23 | 0, i22 | 0, 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (i2 & 1) {
     i2 = 32;
     break L19;
    }
    i1 = i1 - i19 | 0;
    i2 = (i1 | 0) / 12 | 0;
    if ((i1 | 0) < 288) {
     __THREW__ = 0;
     invoke_vii(fb + 4513 | 0, i26 | 0, 37);
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i2 = 32;
      break L19;
     }
     if ((i1 | 0) < 144) {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 66);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
     } else {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 98);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
     }
     do if (i3) {
      i1 = i20 + 172 + (i2 * 12 | 0) | 0;
      if ((HEAP8[i20 + 172 + (i2 * 12 | 0) + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
      __THREW__ = 0;
      i1 = invoke_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, 2048, HEAP32[i1 >> 2] | 0) | 0;
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      if (!i1) break;
      i1 = HEAP8[i4 >> 0] | 0;
      if (i1 << 24 >> 24 < 0) {
       i2 = HEAP32[i26 >> 2] | 0;
       i1 = HEAP32[i5 >> 2] | 0;
      } else {
       i2 = i26;
       i1 = i1 & 255;
      }
      HEAP32[i2 + (i1 << 2) + -4 >> 2] = 109;
     } while (0);
     HEAP32[i24 >> 2] = HEAP32[i21 >> 2];
     break;
    }
    i1 = HEAP8[i7 >> 0] | 0;
    if (i1 << 24 >> 24 < 0) i2 = HEAP32[i8 >> 2] | 0; else i2 = i1 & 255;
    i1 = HEAP8[i9 >> 0] | 0;
    if (i1 << 24 >> 24 < 0) i1 = HEAP32[i10 >> 2] | 0; else i1 = i1 & 255;
    if ((i2 | 0) != (0 - i1 | 0)) {
     HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
     __THREW__ = 0;
     i1 = invoke_iiiiiiii(fb + 102 | 0, i21 | 0, i13 | 0, i6 | 0, i11 | 0, i23 | 0, i22 | 0, 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i2 = 32;
      break L19;
     }
     if ((i1 - i12 | 0) < 24) {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 112);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      HEAP32[i24 >> 2] = HEAP32[i21 >> 2];
      break;
     }
    }
    i1 = HEAP32[i24 >> 2] | 0;
    HEAP32[i21 >> 2] = i1;
    __THREW__ = 0;
    i1 = invoke_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, 2048, HEAP32[i1 >> 2] | 0) | 0;
    i27 = __THREW__;
    __THREW__ = 0;
    if (i27 & 1) {
     i2 = 32;
     break L19;
    }
    if (!i1) {
     __THREW__ = 0;
     i1 = invoke_iiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 52 >> 2] | 0, i23 | 0, HEAP32[HEAP32[i24 >> 2] >> 2] | 0, 0) | 0;
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i2 = 32;
      break L19;
     }
     if (i1 << 24 >> 24 != 37) {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, HEAP32[HEAP32[i24 >> 2] >> 2] | 0);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 4;
      break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4513 | 0, i26 | 0, 37);
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i2 = 32;
      break L19;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4513 | 0, i26 | 0, 37);
     i27 = __THREW__;
     __THREW__ = 0;
     if (i27 & 1) {
      i2 = 32;
      break L19;
     }
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 4;
     break;
    }
    __THREW__ = 0;
    i1 = invoke_iiiiii(fb + 191 | 0, i24 | 0, i13 | 0, i22 | 0, i23 | 0, 4) | 0;
    i27 = __THREW__;
    __THREW__ = 0;
    if (i27 & 1) {
     i2 = 32;
     break L19;
    }
    do switch (i1 | 0) {
    case 6:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 119);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 7:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 117);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 11:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 73);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 12:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 109);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 23:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 72);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 31:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 100);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 55:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 77);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 59:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 83);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 61:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 121);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 364:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 106);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    case 2061:
     {
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 37);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i26 | 0, 89);
      i27 = __THREW__;
      __THREW__ = 0;
      if (i27 & 1) {
       i2 = 32;
       break L19;
      } else break L31;
     }
    default:
     {
      i1 = HEAP32[i21 >> 2] | 0;
      while (1) {
       if ((i1 | 0) == (HEAP32[i24 >> 2] | 0)) break L31;
       __THREW__ = 0;
       invoke_vii(fb + 4513 | 0, i26 | 0, HEAP32[i1 >> 2] | 0);
       i27 = __THREW__;
       __THREW__ = 0;
       if (i27 & 1) {
        i2 = 31;
        break L19;
       }
       i1 = (HEAP32[i21 >> 2] | 0) + 4 | 0;
       HEAP32[i21 >> 2] = i1;
      }
     }
    } while (0);
   } while (0);
  } while (0);
  i1 = HEAP32[i24 >> 2] | 0;
 }
 if ((i2 | 0) == 22) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i2 = 24;
 } else if ((i2 | 0) == 23) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i2 = 24;
 } else if ((i2 | 0) == 30) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i2 = 103;
 } else if ((i2 | 0) == 31) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i2 = 103;
 } else if ((i2 | 0) == 32) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i2 = 103;
 } else if ((i2 | 0) == 104) {
  STACKTOP = i25;
  return;
 }
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i26);
 ___resumeException(i1 | 0);
}

function __ZN7mecanim12statemachine13StateConstant8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 12 | 0;
 i4 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 3);
 i2 = i9 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 4;
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i3;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902998 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 12;
 HEAP32[i4 + 4 >> 2] = i8 + 8;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903370 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 20;
 HEAP32[i4 + 4 >> 2] = i8 + 16;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903400 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 24 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903425 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048102 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 35; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903024 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 46; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903434 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903442 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 68; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 68; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903457 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 79; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 79; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 79) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903473 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 90; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 90; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 90) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 52 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903494 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 101; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 101; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 101) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898587 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 112; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 112; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 112) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
 i3 = i8 + 60 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903502 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 61 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903513 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  L177 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L177;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 62 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903534 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  L189 : do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i6 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L189;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 63 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898680 | 0, i4, i7, 0) | 0;
 if (!i1) {
  __ZN7mecanim12statemachine13StateConstant39Transfer_Pre_5_2_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i8, i9);
  STACKTOP = i10;
  return;
 }
 L202 : do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i7 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L202;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN7mecanim12statemachine13StateConstant39Transfer_Pre_5_2_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEclEv(i46) {
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i47 + 136 | 0;
 i2 = i47 + 132 | 0;
 i4 = i47 + 128 | 0;
 i6 = i47 + 124 | 0;
 i8 = i47 + 120 | 0;
 i1 = i47 + 116 | 0;
 i3 = i47 + 112 | 0;
 i5 = i47 + 108 | 0;
 i7 = i47 + 104 | 0;
 i15 = i47 + 88 | 0;
 i12 = i47 + 84 | 0;
 i10 = i47 + 80 | 0;
 i11 = i47 + 76 | 0;
 i13 = i47 + 72 | 0;
 i28 = i47 + 68 | 0;
 i29 = i47 + 64 | 0;
 i30 = i47 + 60 | 0;
 i31 = i47 + 56 | 0;
 i24 = i47 + 40 | 0;
 i25 = i47 + 36 | 0;
 i26 = i47 + 32 | 0;
 i27 = i47 + 16 | 0;
 i44 = i47;
 HEAP32[i46 + 60 >> 2] = 0;
 HEAP32[i46 + 56 >> 2] = 0;
 i45 = i46 + 48 | 0;
 i9 = HEAP32[i45 >> 2] | 0;
 f37 = Math_fround(HEAPF32[i9 + 224 >> 2]);
 f38 = Math_fround(HEAPF32[i9 + 228 >> 2]);
 if (!((f37 < f38 ? f37 : f38) > Math_fround(0.0))) {
  STACKTOP = i47;
  return;
 }
 f20 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f38 = Math_fround(HEAPF32[i9 + 28 >> 2]);
 f35 = Math_fround(HEAPF32[i9 + 32 >> 2]);
 f37 = Math_fround(f23 - f20);
 f38 = Math_fround(f38 - f21);
 f35 = Math_fround(f35 - f22);
 f36 = Math_fround(Math_fround(HEAPF32[i9 + 36 >> 2]) - f23);
 HEAPF32[i2 >> 2] = f37;
 HEAPF32[i4 >> 2] = f38;
 HEAPF32[i6 >> 2] = f35;
 HEAPF32[i8 >> 2] = f36;
 i33 = HEAP32[gb + 1097584 >> 2] | 0;
 HEAP32[i1 >> 2] = i33;
 i43 = HEAP32[gb + 1097584 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i43;
 i42 = HEAP32[gb + 1097584 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i42;
 i39 = HEAP32[gb + 1097584 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = i39;
 i33 = f37 < (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i33 = HEAP32[(i33 ? i1 : i2) >> 2] | 0;
 i43 = f38 < (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i43 = HEAP32[(i43 ? i3 : i4) >> 2] | 0;
 i42 = f35 < (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i42 = HEAP32[(i42 ? i5 : i6) >> 2] | 0;
 i39 = f36 < (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i39 = HEAP32[(i39 ? i7 : i8) >> 2] | 0;
 HEAP32[i14 >> 2] = i33;
 HEAP32[i14 + 4 >> 2] = i43;
 HEAP32[i14 + 8 >> 2] = i42;
 HEAP32[i14 + 12 >> 2] = i39;
 f36 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i42 = f36 > f35 ? (f36 > f38 ? 0 : 2) : f35 > f38 ? 1 : 2;
 f36 = Math_fround(f36 * Math_fround(.00395256933));
 f35 = Math_fround(f35 * Math_fround(.00395256933));
 f38 = Math_fround(f38 * Math_fround(.00395256933));
 f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.00395256933));
 HEAPF32[i12 >> 2] = f36;
 HEAPF32[i10 >> 2] = f35;
 HEAPF32[i11 >> 2] = f38;
 HEAPF32[i13 >> 2] = f37;
 i39 = Math_fround(HEAPF32[i46 >> 2]) < f36;
 i43 = i46 + 4 | 0;
 i33 = Math_fround(HEAPF32[i43 >> 2]) < f35;
 i33 = HEAP32[(i33 ? i10 : i43) >> 2] | 0;
 i41 = i46 + 8 | 0;
 i3 = Math_fround(HEAPF32[i41 >> 2]) < f38;
 i3 = HEAP32[(i3 ? i11 : i41) >> 2] | 0;
 i40 = i46 + 12 | 0;
 i10 = Math_fround(HEAPF32[i40 >> 2]) < f37;
 i10 = HEAP32[(i10 ? i13 : i40) >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[(i39 ? i12 : i46) >> 2];
 i39 = i15 + 4 | 0;
 HEAP32[i39 >> 2] = i33;
 i33 = i15 + 8 | 0;
 HEAP32[i33 >> 2] = i3;
 i3 = i15 + 12 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAPF32[i15 + (i42 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i14 + (i42 << 2) >> 2]) / Math_fround(65533.0));
 HEAPF32[i28 >> 2] = Math_fround(1.0);
 HEAPF32[i29 >> 2] = Math_fround(1.0);
 HEAPF32[i30 >> 2] = Math_fround(1.0);
 HEAPF32[i31 >> 2] = Math_fround(1.0);
 HEAP32[i24 >> 2] = 1132331008;
 i10 = i24 + 4 | 0;
 HEAP32[i10 >> 2] = 1132331008;
 i11 = i24 + 8 | 0;
 HEAP32[i11 >> 2] = 1132331008;
 i12 = i24 + 12 | 0;
 HEAP32[i12 >> 2] = 1132331008;
 HEAPF32[i24 + (i42 << 2) >> 2] = Math_fround(65534.0);
 f37 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i15 >> 2]));
 f38 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i39 >> 2]));
 f35 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i33 >> 2]));
 f36 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 >> 2]));
 f20 = Math_fround(Math_fround(1.0) - Math_fround(f20 * f37));
 f21 = Math_fround(Math_fround(1.0) - Math_fround(f21 * f38));
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f22 * f35));
 f23 = Math_fround(Math_fround(1.0) - Math_fround(f23 * f36));
 i3 = HEAP32[i45 >> 2] | 0;
 i33 = HEAP32[i3 + 232 >> 2] | 0;
 i39 = i46 + 52 | 0;
 i1 = HEAP32[i39 >> 2] | 0;
 i32 = i33 << 2;
 i14 = i33 << 1;
 i2 = i14 + 2048 | 0;
 i34 = i32 + 4 | 0;
 i2 = (i14 + 2 & -4) + i32 + (i2 >>> 0 < i34 >>> 0 ? i34 : i2) | 0;
 if (!i2) i34 = 0; else {
  i3 = i1 + 8 | 0;
  i34 = (HEAP32[i3 >> 2] | 0) + 23 & -16;
  i15 = i34 + -8 | 0;
  i32 = i1 + 12 | 0;
  HEAP32[i15 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i34 + -4 >> 2] = i2 & 2147483646;
  HEAP32[i32 >> 2] = i15;
  HEAP32[i3 >> 2] = i34 + i2;
  i3 = HEAP32[i45 >> 2] | 0;
 }
 i15 = HEAP32[i3 + 236 >> 2] | 0;
 i2 = i34 + (i33 << 2) | 0;
 i32 = i2 + ((i33 + 1 & -2) << 1) | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = (i33 | 0) == 0;
 if (!i13) {
  i4 = i27 + 4 | 0;
  i5 = i27 + 8 | 0;
  i6 = i27 + 12 | 0;
  i7 = i27 + (i42 << 2) | 0;
  i8 = i27 + ((((i42 + 1 | 0) >>> 0) % 3 | 0) << 2) | 0;
  i9 = i27 + ((((i42 + 2 | 0) >>> 0) % 3 | 0) << 2) | 0;
  f19 = Math_fround(HEAPF32[i24 >> 2]);
  f18 = Math_fround(HEAPF32[i10 >> 2]);
  f17 = Math_fround(HEAPF32[i11 >> 2]);
  f16 = Math_fround(HEAPF32[i12 >> 2]);
  if (!i15) {
   i1 = 0;
   do {
    f49 = Math_fround(f37 * Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]));
    f55 = Math_fround(f38 * Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]));
    f51 = Math_fround(f35 * Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]));
    f49 = Math_fround(f20 + f49);
    f55 = Math_fround(f21 + f55);
    f51 = Math_fround(f22 + f51);
    f48 = Math_fround(f23 + Math_fround(f36 * Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2])));
    HEAPF32[i25 >> 2] = f51;
    HEAPF32[i26 >> 2] = f48;
    f49 = f19 < f49 ? f19 : f49;
    f55 = f18 < f55 ? f18 : f55;
    f53 = Math_fround(HEAPF32[i25 >> 2]);
    f53 = f17 < f51 ? f17 : f53;
    f51 = Math_fround(HEAPF32[i26 >> 2]);
    f51 = f16 < f48 ? f16 : f51;
    f48 = Math_fround(HEAPF32[i28 >> 2]);
    f54 = Math_fround(HEAPF32[i29 >> 2]);
    f52 = Math_fround(HEAPF32[i30 >> 2]);
    f50 = Math_fround(HEAPF32[i31 >> 2]);
    i11 = ~~Math_fround(Math_floor(Math_fround(f54 < f55 ? f55 : f54)));
    i12 = ~~Math_fround(Math_floor(Math_fround(f52 < f53 ? f53 : f52)));
    i24 = ~~Math_fround(Math_floor(Math_fround(f50 < f51 ? f51 : f50)));
    HEAP32[i27 >> 2] = ~~Math_fround(Math_floor(Math_fround(f48 < f49 ? f49 : f48)));
    HEAP32[i4 >> 2] = i11;
    HEAP32[i5 >> 2] = i12;
    HEAP32[i6 >> 2] = i24;
    HEAP32[i34 + (i1 << 2) >> 2] = HEAP32[i8 >> 2] << 16 | HEAP32[i7 >> 2] | HEAP32[i9 >> 2] << 24;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i33 | 0));
  } else {
   i1 = 0;
   do {
    i11 = HEAP32[i15 + (i1 << 2) >> 2] | 0;
    f54 = Math_fround(HEAPF32[i3 + (i11 << 4) >> 2]);
    f48 = Math_fround(HEAPF32[i3 + (i11 << 4) + 4 >> 2]);
    f52 = Math_fround(HEAPF32[i3 + (i11 << 4) + 8 >> 2]);
    f54 = Math_fround(f20 + Math_fround(f37 * f54));
    f48 = Math_fround(f21 + Math_fround(f38 * f48));
    f52 = Math_fround(f22 + Math_fround(f35 * f52));
    f55 = Math_fround(f23 + Math_fround(f36 * Math_fround(HEAPF32[i3 + (i11 << 4) + 12 >> 2])));
    HEAPF32[i25 >> 2] = f52;
    HEAPF32[i26 >> 2] = f55;
    f54 = f19 < f54 ? f19 : f54;
    f48 = f18 < f48 ? f18 : f48;
    f50 = Math_fround(HEAPF32[i25 >> 2]);
    f50 = f17 < f52 ? f17 : f50;
    f52 = Math_fround(HEAPF32[i26 >> 2]);
    f52 = f16 < f55 ? f16 : f52;
    f55 = Math_fround(HEAPF32[i28 >> 2]);
    f49 = Math_fround(HEAPF32[i29 >> 2]);
    f51 = Math_fround(HEAPF32[i30 >> 2]);
    f53 = Math_fround(HEAPF32[i31 >> 2]);
    i11 = ~~Math_fround(Math_floor(Math_fround(f49 < f48 ? f48 : f49)));
    i12 = ~~Math_fround(Math_floor(Math_fround(f51 < f50 ? f50 : f51)));
    i24 = ~~Math_fround(Math_floor(Math_fround(f53 < f52 ? f52 : f53)));
    HEAP32[i27 >> 2] = ~~Math_fround(Math_floor(Math_fround(f55 < f54 ? f54 : f55)));
    HEAP32[i4 >> 2] = i11;
    HEAP32[i5 >> 2] = i12;
    HEAP32[i6 >> 2] = i24;
    HEAP32[i34 + (i1 << 2) >> 2] = HEAP32[i8 >> 2] << 16 | HEAP32[i7 >> 2] | HEAP32[i9 >> 2] << 24;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i33 | 0));
  }
 }
 i11 = (i2 - i34 | 0) >>> 2 & 65535;
 i7 = i11 << 1;
 i8 = i7 + 256 | 0;
 i9 = i7 + 512 | 0;
 i10 = i7 + 768 | 0;
 _memset(i34 + (i11 + i33 << 2) | 0, 0, 2048) | 0;
 if ((i34 | 0) == (i2 | 0)) {
  i1 = 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
 } else {
  i1 = i34;
  do {
   i31 = HEAP32[i1 >> 2] | 0;
   i30 = i2 + ((i31 & 255) + i7 << 1) | 0;
   HEAP16[i30 >> 1] = (HEAP16[i30 >> 1] | 0) + 1 << 16 >> 16;
   i30 = i2 + ((i31 >>> 8 & 255) + i8 << 1) | 0;
   HEAP16[i30 >> 1] = (HEAP16[i30 >> 1] | 0) + 1 << 16 >> 16;
   i30 = i2 + ((i31 >>> 16 & 255) + i9 << 1) | 0;
   HEAP16[i30 >> 1] = (HEAP16[i30 >> 1] | 0) + 1 << 16 >> 16;
   i31 = i2 + ((i31 >>> 24) + i10 << 1) | 0;
   HEAP16[i31 >> 1] = (HEAP16[i31 >> 1] | 0) + 1 << 16 >> 16;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
 }
 do {
  i31 = i2 + (i1 + i7 << 1) | 0;
  i30 = i3;
  i3 = (HEAPU16[i31 >> 1] | 0) + (i3 & 65535) & 65535;
  HEAP16[i31 >> 1] = i30;
  i31 = i2 + (i1 + i8 << 1) | 0;
  i30 = i5;
  i5 = (HEAPU16[i31 >> 1] | 0) + (i5 & 65535) & 65535;
  HEAP16[i31 >> 1] = i30;
  i31 = i2 + (i1 + i9 << 1) | 0;
  i30 = i6;
  i6 = (HEAPU16[i31 >> 1] | 0) + (i6 & 65535) & 65535;
  HEAP16[i31 >> 1] = i30;
  i31 = i2 + (i1 + i10 << 1) | 0;
  i30 = i4;
  i4 = (HEAPU16[i31 >> 1] | 0) + (i4 & 65535) & 65535;
  HEAP16[i31 >> 1] = i30;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 if (i11 | 0) {
  i1 = 0;
  i3 = 0;
  do {
   i30 = i2 + ((HEAP32[i34 + (i1 << 2) >> 2] & 255) + i7 << 1) | 0;
   i31 = HEAP16[i30 >> 1] | 0;
   HEAP16[i30 >> 1] = i31 + 1 << 16 >> 16;
   HEAP16[i2 + ((i31 & 65535) + i11 << 1) >> 1] = i3;
   i3 = i3 + 1 << 16 >> 16;
   i1 = i3 & 65535;
  } while ((i1 | 0) != (i11 | 0));
  i1 = i11;
  i3 = 0;
  while (1) {
   i31 = HEAP16[i2 + (i1 << 1) >> 1] | 0;
   i30 = i2 + (((HEAP32[i34 + ((i31 & 65535) << 2) >> 2] | 0) >>> 8 & 255) + i8 << 1) | 0;
   i1 = HEAP16[i30 >> 1] | 0;
   HEAP16[i30 >> 1] = i1 + 1 << 16 >> 16;
   HEAP16[i2 + ((i1 & 65535) << 1) >> 1] = i31;
   i3 = i3 + 1 << 16 >> 16;
   i1 = i3 & 65535;
   if ((i1 | 0) == (i11 | 0)) {
    i1 = i2;
    i3 = 0;
    break;
   } else i1 = i1 + i11 | 0;
  }
  while (1) {
   i31 = HEAP16[i1 >> 1] | 0;
   i30 = i2 + (((HEAP32[i34 + ((i31 & 65535) << 2) >> 2] | 0) >>> 16 & 255) + i9 << 1) | 0;
   i1 = HEAP16[i30 >> 1] | 0;
   HEAP16[i30 >> 1] = i1 + 1 << 16 >> 16;
   HEAP16[i2 + ((i1 & 65535) + i11 << 1) >> 1] = i31;
   i3 = i3 + 1 << 16 >> 16;
   i1 = i3 & 65535;
   if ((i1 | 0) == (i11 | 0)) {
    i1 = i11;
    i3 = 0;
    break;
   } else i1 = i2 + (i1 << 1) | 0;
  }
  while (1) {
   i31 = HEAP16[i2 + (i1 << 1) >> 1] | 0;
   i30 = i2 + (((HEAP32[i34 + ((i31 & 65535) << 2) >> 2] | 0) >>> 24) + i10 << 1) | 0;
   i1 = HEAP16[i30 >> 1] | 0;
   HEAP16[i30 >> 1] = i1 + 1 << 16 >> 16;
   HEAP16[i2 + ((i1 & 65535) << 1) >> 1] = i31;
   i3 = i3 + 1 << 16 >> 16;
   i1 = i3 & 65535;
   if ((i1 | 0) == (i11 | 0)) break; else i1 = i1 + i11 | 0;
  }
 }
 i3 = HEAP16[i2 + (i14 + 769 << 1) >> 1] | 0;
 if (!i13) {
  i1 = 0;
  do {
   HEAP32[i32 + (i1 << 2) >> 2] = HEAP32[i34 + ((HEAPU16[i2 + (i1 << 1) >> 1] | 0) << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i33 | 0));
 }
 HEAP32[i32 + (i33 << 2) >> 2] = -1;
 if (i15) if (i13) i2 = i34; else {
  i1 = 0;
  do {
   HEAP16[i34 + (i1 << 1) >> 1] = HEAP32[i15 + ((HEAPU16[i2 + (i1 << 1) >> 1] | 0) << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i33 | 0));
  i2 = i34;
 }
 f55 = Math_fround(f37 * Math_fround(HEAPF32[i46 >> 2]));
 f53 = Math_fround(f38 * Math_fround(HEAPF32[i43 >> 2]));
 f54 = Math_fround(f35 * Math_fround(HEAPF32[i41 >> 2]));
 i41 = ~~Math_fround(Math_floor(Math_fround(f53)));
 i43 = ~~Math_fround(Math_floor(Math_fround(f54)));
 i1 = ~~Math_fround(Math_floor(Math_fround(f36 * Math_fround(HEAPF32[i40 >> 2]))));
 HEAP32[i44 >> 2] = ~~Math_fround(Math_floor(Math_fround(f55)));
 HEAP32[i44 + 4 >> 2] = i41;
 HEAP32[i44 + 8 >> 2] = i43;
 HEAP32[i44 + 12 >> 2] = i1;
 i1 = (HEAP32[i44 + (i42 << 2) >> 2] | 0) + 2 | 0;
 if (!(HEAP32[(HEAP32[i45 >> 2] | 0) + 240 >> 2] | 0)) __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvPKjtPKtj(i46, i32, i3, i2, i1); else __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvPKjtPKtj(i46, i32, i3, i2, i1);
 i1 = HEAP32[i39 >> 2] | 0;
 i5 = i34 + -4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | -2147483648;
 i5 = i1 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  STACKTOP = i47;
  return;
 }
 i3 = i1 + 8 | 0;
 i4 = i2;
 i1 = i2;
 while (1) {
  if ((HEAP32[i4 + 4 >> 2] | 0) >= 0) {
   i1 = 28;
   break;
  }
  HEAP32[i3 >> 2] = i4;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  if (!i1) {
   i1 = 28;
   break;
  } else i4 = i1;
 }
 if ((i1 | 0) == 28) {
  STACKTOP = i47;
  return;
 }
}

function __ZN5physx14PxsAABBManager12createVolumeEjjjPvRKNS_9PxBounds3E(i27, i26, i12, i23, i10, i11, i1) {
 i27 = i27 | 0;
 i26 = i26 | 0;
 i12 = i12 | 0;
 i23 = i23 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i28;
 i7 = i28 + 8 | 0;
 if ((i12 | 0) == -1) {
  i24 = i1 + 12 | 0;
  i18 = HEAP32[i1 >> 2] | 0;
  i19 = HEAP32[i1 + 4 >> 2] | 0;
  i20 = HEAP32[i1 + 8 >> 2] | 0;
  i21 = HEAP32[i24 >> 2] | 0;
  i22 = HEAP32[i24 + 4 >> 2] | 0;
  i24 = HEAP32[i24 + 8 >> 2] | 0;
  i5 = __ZN5physx14PxsAABBManager12createBPElemEv(i26) | 0;
  i25 = (HEAP32[i26 + 96 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
  HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i5 & 31);
  HEAP32[(HEAP32[i26 + 16 >> 2] | 0) + (i5 << 2) >> 2] = i11;
  HEAP32[(HEAP32[i26 + 20 >> 2] | 0) + (i5 << 2) >> 2] = i10;
  i25 = HEAP32[i26 + 12 >> 2] | 0;
  HEAP32[i25 + (i5 * 24 | 0) >> 2] = ((i18 | 0) < 0 ? ~i18 : i18 | -2147483648) + -16 & -16;
  HEAP32[i25 + (i5 * 24 | 0) + 4 >> 2] = ((i19 | 0) < 0 ? ~i19 : i19 | -2147483648) + -16 & -16;
  HEAP32[i25 + (i5 * 24 | 0) + 8 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
  HEAP32[i25 + (i5 * 24 | 0) + 12 >> 2] = ((i21 | 0) < 0 ? ~i21 : i21 | -2147483648) + 16 & -16 | 1;
  HEAP32[i25 + (i5 * 24 | 0) + 16 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + 16 & -16 | 1;
  HEAP32[i25 + (i5 * 24 | 0) + 20 >> 2] = ((i24 | 0) < 0 ? ~i24 : i24 | -2147483648) + 16 & -16 | 1;
  if ((i23 | 0) == 1073741823) {
   i4 = i26 + 152 | 0;
   i1 = i26 + 172 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if (!i2) {
    i2 = i26 + 160 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i26 + 164 >> 2] | 0;
    if (i1 >>> 0 < i3 >>> 0) {
     HEAP32[i2 >> 2] = i1 + 1;
     break;
    } else {
     __ZN5physx13SingleManager6resizeEj(i4, i3 + 32 | 0);
     i1 = HEAP32[i2 >> 2] | 0;
     HEAP32[i2 >> 2] = i1 + 1;
     break;
    }
   } else {
    i24 = i2 + -1 | 0;
    i25 = HEAP32[(HEAP32[i26 + 168 >> 2] | 0) + (i24 << 2) >> 2] | 0;
    HEAP32[i1 >> 2] = i24;
    i1 = i25;
   } while (0);
   i25 = HEAP32[i26 + 156 >> 2] | 0;
   HEAP32[(HEAP32[i26 + 24 >> 2] | 0) + (i5 << 2) >> 2] = i1 << 1;
   HEAP32[(HEAP32[i26 + 28 >> 2] | 0) + (i5 << 2) >> 2] = 1073741823;
   HEAP32[i25 + (i1 << 2) >> 2] = i5;
  } else {
   i1 = i23 >>> 1;
   i25 = HEAP32[i26 + 156 >> 2] | 0;
   HEAP32[(HEAP32[i26 + 24 >> 2] | 0) + (i5 << 2) >> 2] = i1 << 1;
   i25 = i25 + (i1 << 2) | 0;
   HEAP32[(HEAP32[i26 + 28 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i25 >> 2];
   HEAP32[i25 >> 2] = i5;
  }
  if (i5 >>> 0 < 536870911 & i1 >>> 0 < 536870911) {
   HEAP32[i27 >> 2] = i5 << 1;
   HEAP32[i27 + 4 >> 2] = i1 << 1;
   STACKTOP = i28;
   return;
  } else {
   HEAP32[i27 >> 2] = 1073741823;
   HEAP32[i27 + 4 >> 2] = 1073741823;
   STACKTOP = i28;
   return;
  }
 }
 i24 = i12 >>> 1;
 i25 = HEAP32[i26 + 180 >> 2] | 0;
 i5 = i25 + (i24 * 1048 | 0) | 0;
 i9 = i25 + (i24 * 1048 | 0) + 1032 | 0;
 i20 = i1 + 12 | 0;
 i21 = HEAP32[i1 >> 2] | 0;
 i21 = ((i21 | 0) < 0 ? ~i21 : i21 | -2147483648) + -16 & -16;
 i22 = HEAP32[i1 + 4 >> 2] | 0;
 i22 = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + -16 & -16;
 i17 = HEAP32[i1 + 8 >> 2] | 0;
 i17 = ((i17 | 0) < 0 ? ~i17 : i17 | -2147483648) + -16 & -16;
 i18 = HEAP32[i20 >> 2] | 0;
 i18 = ((i18 | 0) < 0 ? ~i18 : i18 | -2147483648) + 16 & -16 | 1;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i19 = ((i19 | 0) < 0 ? ~i19 : i19 | -2147483648) + 16 & -16 | 1;
 i20 = HEAP32[i20 + 8 >> 2] | 0;
 i20 = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
 if ((HEAP32[i9 >> 2] | 0) == 1073741823) {
  i1 = __ZN5physx14PxsAABBManager12createBPElemEv(i26) | 0;
  HEAP32[i25 + (i24 * 1048 | 0) + 1028 >> 2] = i1;
  HEAP32[(HEAP32[i26 + 24 >> 2] | 0) + (i1 << 2) >> 2] = i12 | 1;
  HEAP32[(HEAP32[i26 + 20 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i25 + (i24 * 1048 | 0) + 1036 >> 2];
  i6 = HEAP32[i26 + 12 >> 2] | 0;
  HEAP32[i6 + (i1 * 24 | 0) >> 2] = i21;
  HEAP32[i6 + (i1 * 24 | 0) + 4 >> 2] = i22;
  HEAP32[i6 + (i1 * 24 | 0) + 8 >> 2] = i17;
  HEAP32[i6 + (i1 * 24 | 0) + 12 >> 2] = i18;
  HEAP32[i6 + (i1 * 24 | 0) + 16 >> 2] = i19;
  HEAP32[i6 + (i1 * 24 | 0) + 20 >> 2] = i20;
  i6 = (HEAP32[i26 + 96 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i1 & 31);
  i6 = __ZN5physx14PxsAABBManager19createAggregateElemEv(i26) | 0;
  HEAP32[(HEAP32[i26 + 304 >> 2] | 0) + (i6 << 2) >> 2] = i11;
  HEAP32[(HEAP32[i26 + 308 >> 2] | 0) + (i6 << 2) >> 2] = i10;
  i1 = HEAP32[i26 + 300 >> 2] | 0;
  HEAP32[i1 + (i6 * 24 | 0) >> 2] = i21;
  HEAP32[i1 + (i6 * 24 | 0) + 4 >> 2] = i22;
  HEAP32[i1 + (i6 * 24 | 0) + 8 >> 2] = i17;
  HEAP32[i1 + (i6 * 24 | 0) + 12 >> 2] = i18;
  HEAP32[i1 + (i6 * 24 | 0) + 16 >> 2] = i19;
  HEAP32[i1 + (i6 * 24 | 0) + 20 >> 2] = i20;
  HEAP32[(HEAP32[i26 + 316 >> 2] | 0) + (i6 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i26 + 320 >> 2] | 0) + (i6 << 2) >> 2] = 1073741823;
  i1 = (HEAP32[i26 + 356 >> 2] | 0) + (i12 >>> 6 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = 1 << (i24 & 31);
  if (!(i2 & i3)) HEAP32[i1 >> 2] = i2 | i3;
  HEAP32[i9 >> 2] = i6;
  i22 = i25 + (i24 * 1048 | 0) + 1025 | 0;
  HEAP8[i22 >> 0] = (HEAP8[i22 >> 0] | 0) + 1 << 24 >> 24;
  i22 = i25 + (i24 * 1048 | 0) + 1026 | 0;
  HEAP8[i22 >> 0] = (HEAP8[i22 >> 0] | 0) + 1 << 24 >> 24;
  do if ((i23 | 0) == 1073741823) {
   i2 = i26 + 292 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == 1073741823) {
    i1 = HEAP32[i26 + 264 >> 2] << 1;
    __ZN5physx21AggregateActorManager6resizeEj(i26 + 244 | 0, i1 >>> 0 < 64 ? 64 : i1);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   i3 = HEAP32[i26 + 248 >> 2] | 0;
   i4 = i3 + (i1 * 24 | 0) | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = 2122317823;
   HEAP32[i3 + (i1 * 24 | 0) + 4 >> 2] = 2122317823;
   HEAP32[i3 + (i1 * 24 | 0) + 8 >> 2] = 2122317823;
   HEAP32[i3 + (i1 * 24 | 0) + 12 >> 2] = -25165825;
   HEAP32[i3 + (i1 * 24 | 0) + 16 >> 2] = -25165825;
   HEAP32[i3 + (i1 * 24 | 0) + 20 >> 2] = -25165825;
   i2 = i26 + 252 | 0;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = 0;
   HEAP32[(HEAP32[i26 + 260 >> 2] | 0) + (i1 << 2) >> 2] = i24;
   i3 = i25 + (i24 * 1048 | 0) + 1040 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = (HEAP32[i26 + 256 >> 2] | 0) + (i1 << 2) | 0;
   if ((i4 | 0) == 1073741823) {
    HEAP32[i5 >> 2] = 1073741823;
    HEAP32[i3 >> 2] = i1;
    break;
   } else {
    HEAP32[i5 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    break;
   }
  } else {
   i2 = i26 + 252 | 0;
   i1 = i23 >>> 1;
  } while (0);
  i4 = i1 << 1 | 1;
  HEAP32[(HEAP32[i26 + 312 >> 2] | 0) + (i6 << 2) >> 2] = i4;
  i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
  HEAP8[i2 >> 0] = (HEAP8[i2 >> 0] | 0) + 1 << 24 >> 24;
  i2 = 1 << (i1 & 31);
  i3 = i1 >>> 5;
  i23 = (HEAP32[i26 + 280 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[i23 >> 2] = HEAP32[i23 >> 2] & ~i2;
  if (!(HEAP8[i25 + (i24 * 1048 | 0) + 1024 >> 0] | 0)) {
   i26 = (HEAP32[i26 + 268 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i2;
  }
  if (i12 >>> 0 < 1073741822 & i1 >>> 0 < 536870911) {
   HEAP32[i27 >> 2] = i6 << 1 | 1;
   HEAP32[i27 + 4 >> 2] = i4;
   STACKTOP = i28;
   return;
  } else {
   HEAP32[i27 >> 2] = 1073741823;
   HEAP32[i27 + 4 >> 2] = 1073741823;
   STACKTOP = i28;
   return;
  }
 }
 i3 = HEAP32[i26 + 188 >> 2] | 0;
 i1 = 4;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i8 = 39;
   break;
  }
  i1 = HEAP32[i3 + (i24 << 4) + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i8 = 31;
   break;
  }
 }
 if ((i8 | 0) == 31) {
  i4 = i1 >>> 1 | i1;
  i4 = i4 >>> 2 | i4;
  i4 = i4 >>> 4 | i4;
  i4 = i4 >>> 8 | i4;
  i4 = (Math_imul(i4 >>> 16 | i4, 130329821) | 0) >>> 27;
  i4 = (HEAP32[gb + 85120 + (i4 << 2) >> 2] | 0) + (i2 << 5) | 0;
  if (!i4) i8 = 39; else {
   i16 = i3 + (i24 << 4) + (i4 >>> 5 << 2) | 0;
   HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & ~(1 << (i4 & 31));
   if ((i4 | 0) == 1073741823) i8 = 39; else {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) != 1073741823) {
     i3 = HEAP32[i26 + 316 >> 2] | 0;
     i2 = 0;
     while (1) {
      HEAP32[i7 + (i2 << 2) >> 2] = i1;
      i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
      if ((i1 | 0) == 1073741823) break; else i2 = i2 + 1 | 0;
     }
    }
    i4 = HEAP32[i7 + ((HEAPU8[i25 + (i24 * 1048 | 0) + 1025 >> 0] | 0) + ~i4 << 2) >> 2] | 0;
    HEAP32[(HEAP32[i26 + 304 >> 2] | 0) + (i4 << 2) >> 2] = i11;
    HEAP32[(HEAP32[i26 + 308 >> 2] | 0) + (i4 << 2) >> 2] = i10;
    i1 = HEAP32[i26 + 300 >> 2] | 0;
    HEAP32[i1 + (i4 * 24 | 0) >> 2] = i21;
    HEAP32[i1 + (i4 * 24 | 0) + 4 >> 2] = i22;
    HEAP32[i1 + (i4 * 24 | 0) + 8 >> 2] = i17;
    HEAP32[i1 + (i4 * 24 | 0) + 12 >> 2] = i18;
    HEAP32[i1 + (i4 * 24 | 0) + 16 >> 2] = i19;
    HEAP32[i1 + (i4 * 24 | 0) + 20 >> 2] = i20;
    HEAP32[(HEAP32[i26 + 320 >> 2] | 0) + (i4 << 2) >> 2] = 1073741823;
    i1 = i25 + (i24 * 1048 | 0) + 1026 | 0;
    HEAP8[i1 >> 0] = (HEAP8[i1 >> 0] | 0) + 1 << 24 >> 24;
    i1 = (HEAP32[i26 + 356 >> 2] | 0) + (i12 >>> 6 << 2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i3 = 1 << (i24 & 31);
    if (!(i2 & i3)) HEAP32[i1 >> 2] = i2 | i3;
    i16 = i4;
   }
  }
 }
 do if ((i8 | 0) == 39) {
  i1 = i25 + (i24 * 1048 | 0) + 1025 | 0;
  if ((HEAP8[i1 >> 0] | 0) > -1) {
   __ZN5physx14PxsAABBManager14promoteBitmapsEPNS_9AggregateE(i26, i5);
   i4 = __ZN5physx14PxsAABBManager19createAggregateElemEv(i26) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP32[(HEAP32[i26 + 304 >> 2] | 0) + (i4 << 2) >> 2] = i11;
   HEAP32[(HEAP32[i26 + 308 >> 2] | 0) + (i4 << 2) >> 2] = i10;
   i3 = HEAP32[i26 + 300 >> 2] | 0;
   HEAP32[i3 + (i4 * 24 | 0) >> 2] = i21;
   HEAP32[i3 + (i4 * 24 | 0) + 4 >> 2] = i22;
   HEAP32[i3 + (i4 * 24 | 0) + 8 >> 2] = i17;
   HEAP32[i3 + (i4 * 24 | 0) + 12 >> 2] = i18;
   HEAP32[i3 + (i4 * 24 | 0) + 16 >> 2] = i19;
   HEAP32[i3 + (i4 * 24 | 0) + 20 >> 2] = i20;
   HEAP32[(HEAP32[i26 + 316 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[(HEAP32[i26 + 320 >> 2] | 0) + (i4 << 2) >> 2] = 1073741823;
   HEAP32[i9 >> 2] = i4;
   HEAP8[i1 >> 0] = (HEAP8[i1 >> 0] | 0) + 1 << 24 >> 24;
   i1 = i25 + (i24 * 1048 | 0) + 1026 | 0;
   HEAP8[i1 >> 0] = (HEAP8[i1 >> 0] | 0) + 1 << 24 >> 24;
   i1 = (HEAP32[i26 + 356 >> 2] | 0) + (i12 >>> 6 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = 1 << (i24 & 31);
   if (i2 & i3 | 0) {
    i16 = i4;
    break;
   }
   HEAP32[i1 >> 2] = i2 | i3;
   i16 = i4;
   break;
  } else {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 676016 | 0, 541, gb + 676104 | 0, i6);
   HEAP32[i27 >> 2] = 1073741823;
   HEAP32[i27 + 4 >> 2] = 1073741823;
   STACKTOP = i28;
   return;
  }
 } while (0);
 i15 = HEAP32[i25 + (i24 * 1048 | 0) + 1028 >> 2] | 0;
 i11 = HEAP32[i26 + 12 >> 2] | 0;
 i1 = i11 + (i15 * 24 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i11 + (i15 * 24 | 0) + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i11 + (i15 * 24 | 0) + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i11 + (i15 * 24 | 0) + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i11 + (i15 * 24 | 0) + 16 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i11 + (i15 * 24 | 0) + 20 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i13 = i8 >>> 0 < i18 >>> 0;
 i14 = i10 >>> 0 < i19 >>> 0;
 if (!(i12 >>> 0 >= i20 >>> 0 & ((i2 >>> 0 > i21 >>> 0 | i4 >>> 0 > i22 >>> 0 | i6 >>> 0 > i17 >>> 0 | i13 | i14) ^ 1))) {
  HEAP32[i1 >> 2] = i2 >>> 0 < i21 >>> 0 ? i2 : i21;
  HEAP32[i3 >> 2] = i4 >>> 0 < i22 >>> 0 ? i4 : i22;
  HEAP32[i5 >> 2] = i6 >>> 0 < i17 >>> 0 ? i6 : i17;
  HEAP32[i7 >> 2] = i13 ? i18 : i8;
  HEAP32[i9 >> 2] = i14 ? i19 : i10;
  HEAP32[i11 >> 2] = i12 >>> 0 < i20 >>> 0 ? i20 : i12;
  i1 = i15 >>> 5;
  i3 = 1 << (i15 & 31);
  if (!(HEAP32[(HEAP32[i26 + 96 >> 2] | 0) + (i1 << 2) >> 2] & i3)) {
   i1 = (HEAP32[i26 + 68 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!(i2 & i3)) HEAP32[i1 >> 2] = i2 | i3;
  }
 }
 do if ((i23 | 0) == 1073741823) {
  i2 = i26 + 292 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == 1073741823) {
   i1 = HEAP32[i26 + 264 >> 2] << 1;
   __ZN5physx21AggregateActorManager6resizeEj(i26 + 244 | 0, i1 >>> 0 < 64 ? 64 : i1);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i3 = HEAP32[i26 + 248 >> 2] | 0;
  i4 = i3 + (i1 * 24 | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = 2122317823;
  HEAP32[i3 + (i1 * 24 | 0) + 4 >> 2] = 2122317823;
  HEAP32[i3 + (i1 * 24 | 0) + 8 >> 2] = 2122317823;
  HEAP32[i3 + (i1 * 24 | 0) + 12 >> 2] = -25165825;
  HEAP32[i3 + (i1 * 24 | 0) + 16 >> 2] = -25165825;
  HEAP32[i3 + (i1 * 24 | 0) + 20 >> 2] = -25165825;
  i2 = i26 + 252 | 0;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = 0;
  HEAP32[(HEAP32[i26 + 260 >> 2] | 0) + (i1 << 2) >> 2] = i24;
  i3 = i25 + (i24 * 1048 | 0) + 1040 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = (HEAP32[i26 + 256 >> 2] | 0) + (i1 << 2) | 0;
  if ((i4 | 0) == 1073741823) {
   HEAP32[i5 >> 2] = 1073741823;
   HEAP32[i3 >> 2] = i1;
   break;
  } else {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   break;
  }
 } else {
  i2 = i26 + 252 | 0;
  i1 = i23 >>> 1;
 } while (0);
 i4 = i1 << 1 | 1;
 HEAP32[(HEAP32[i26 + 312 >> 2] | 0) + (i16 << 2) >> 2] = i4;
 i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP8[i2 >> 0] = (HEAP8[i2 >> 0] | 0) + 1 << 24 >> 24;
 i2 = 1 << (i1 & 31);
 i3 = i1 >>> 5;
 i23 = (HEAP32[i26 + 280 >> 2] | 0) + (i3 << 2) | 0;
 HEAP32[i23 >> 2] = HEAP32[i23 >> 2] & ~i2;
 if (!(HEAP8[i25 + (i24 * 1048 | 0) + 1024 >> 0] | 0)) {
  i26 = (HEAP32[i26 + 268 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | i2;
 }
 if (i16 >>> 0 < 536870911 & i1 >>> 0 < 536870911) {
  HEAP32[i27 >> 2] = i16 << 1 | 1;
  HEAP32[i27 + 4 >> 2] = i4;
  STACKTOP = i28;
  return;
 } else {
  HEAP32[i27 >> 2] = 1073741823;
  HEAP32[i27 + 4 >> 2] = 1073741823;
  STACKTOP = i28;
  return;
 }
}

function __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo(i3, i4, i17) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19;
 i18 = i19 + 56 | 0;
 i13 = i19 + 40 | 0;
 i14 = i19 + 24 | 0;
 i10 = i19 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i13 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i13 >> 0] = 0;
 i1 = i17 + 11 | 0;
 HEAP8[((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17) >> 0] = 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) HEAP32[i17 + 4 >> 2] = 0; else HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i16 = HEAP32[i13 >> 2] | 0;
  i15 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
 }
 i15 = i17 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i13 + 11 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i13 >> 0] = 0;
 i2 = i15 + 11 | 0;
 HEAP8[((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15) >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) HEAP32[i17 + 20 >> 2] = 0; else HEAP8[i2 >> 0] = 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i16 = HEAP32[i13 >> 2] | 0;
  i11 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
 }
 i16 = i17 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i13 + 11 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i13 >> 0] = 0;
 i2 = i16 + 11 | 0;
 HEAP8[((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16) >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) HEAP32[i17 + 36 >> 2] = 0; else HEAP8[i2 >> 0] = 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i11 = HEAP32[i13 >> 2] | 0;
  i9 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i18);
 }
 i11 = i17 + 48 | 0;
 HEAP32[i11 >> 2] = -1;
 i9 = __Z16GetBuildSettingsv() | 0;
 do if ((i4 | 0) == -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  if (__ZNK18AssetBundleManager24GetAssetBundleScenePathsERK8UnityStrRS0_S3_(__Z21GetAssetBundleManagerv() | 0, i3, i13, i14) | 0) {
   i6 = __Z20GetPersistentManagerv() | 0;
   i8 = i14 + 11 | 0;
   i5 = HEAP8[i8 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i7 = i14 + 4 | 0;
   i4 = i2 ? HEAP32[i14 >> 2] | 0 : i14;
   i5 = i2 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i4, i5);
   i6 = __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i18) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   if (i6) {
    do if ((i17 | 0) != (i13 | 0)) {
     i5 = HEAP8[i13 + 11 >> 0] | 0;
     i6 = i5 << 24 >> 24 < 0;
     i4 = i6 ? HEAP32[i13 >> 2] | 0 : i13;
     i5 = i6 ? HEAP32[i13 + 4 >> 2] | 0 : i5 & 255;
     i6 = i17 + 11 | 0;
     i1 = HEAP8[i6 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i5 >>> 0 > i3 >>> 0) {
      i12 = i2 ? HEAP32[i17 + 4 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i5 - i3 | 0, i12, 0, i12, i5, i4);
      break;
     }
     i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
     if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
     HEAP8[i1 + i5 >> 0] = 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) {
      HEAP32[i17 + 4 >> 2] = i5;
      break;
     } else {
      HEAP8[i6 >> 0] = i5;
      break;
     }
    } while (0);
    do if ((i15 | 0) != (i14 | 0)) {
     i4 = HEAP8[i8 >> 0] | 0;
     i5 = i4 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i14 >> 2] | 0 : i14;
     i4 = i5 ? HEAP32[i7 >> 2] | 0 : i4 & 255;
     i5 = i15 + 11 | 0;
     i1 = HEAP8[i5 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i3 = (HEAP32[i17 + 24 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i4 >>> 0 > i3 >>> 0) {
      i12 = i2 ? HEAP32[i17 + 20 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i3, i4 - i3 | 0, i12, 0, i12, i4, i6);
      break;
     }
     i1 = i2 ? HEAP32[i15 >> 2] | 0 : i15;
     if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
     HEAP8[i1 + i4 >> 0] = 0;
     if ((HEAP8[i5 >> 0] | 0) < 0) {
      HEAP32[i17 + 20 >> 2] = i4;
      break;
     } else {
      HEAP8[i5 >> 0] = i4;
      break;
     }
    } while (0);
    __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i10, i14, gb + 463328 | 0);
    i4 = i10 + 11 | 0;
    i6 = HEAP8[i4 >> 0] | 0;
    i7 = i6 << 24 >> 24 < 0;
    i5 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
    i6 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
    i7 = i16 + 11 | 0;
    i1 = HEAP8[i7 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i17 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    do if (i6 >>> 0 > i3 >>> 0) {
     i17 = i2 ? HEAP32[i17 + 36 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i6 - i3 | 0, i17, 0, i17, i6, i5);
    } else {
     i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
     if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
     HEAP8[i1 + i6 >> 0] = 0;
     if ((HEAP8[i7 >> 0] | 0) < 0) {
      HEAP32[i17 + 36 >> 2] = i6;
      break;
     } else {
      HEAP8[i7 >> 0] = i6;
      break;
     }
    } while (0);
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     i17 = HEAP32[i10 >> 2] | 0;
     i16 = HEAP32[i10 + 12 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i18 + 4 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
    }
    if ((HEAP8[i8 >> 0] | 0) < 0) {
     i17 = HEAP32[i14 >> 2] | 0;
     i16 = HEAP32[i14 + 12 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i18 + 4 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
    }
    if ((HEAP8[i13 + 11 >> 0] | 0) < 0) {
     i17 = HEAP32[i13 >> 2] | 0;
     i16 = HEAP32[i13 + 12 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i18 + 4 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
    }
    i18 = 1;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i8 = i2 << 24 >> 24 < 0;
  i10 = i8 ? HEAP32[i3 >> 2] | 0 : i3;
  i2 = i8 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i10, i2);
  HEAP32[i11 >> 2] = __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i18) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i2 = HEAP32[i11 >> 2] | 0;
  do if ((i2 | 0) > -1) {
   i10 = HEAP32[i9 + 28 >> 2] | 0;
   i3 = i10;
   if (i2 >>> 0 < (HEAP32[i9 + 32 >> 2] | 0) - i10 >> 4 >>> 0) {
    i1 = i3 + (i2 << 4) | 0;
    do if ((i17 | 0) != (i1 | 0)) {
     i4 = HEAP8[i1 + 11 >> 0] | 0;
     i5 = i4 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
     i4 = i5 ? HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0 : i4 & 255;
     i5 = i17 + 11 | 0;
     i1 = HEAP8[i5 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i4 >>> 0 > i3 >>> 0) {
      i10 = i2 ? HEAP32[i17 + 4 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i4 - i3 | 0, i10, 0, i10, i4, i6);
      break;
     }
     i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
     if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
     HEAP8[i1 + i4 >> 0] = 0;
     if ((HEAP8[i5 >> 0] | 0) < 0) {
      HEAP32[i17 + 4 >> 2] = i4;
      break;
     } else {
      HEAP8[i5 >> 0] = i4;
      break;
     }
    } while (0);
    i3 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i9 + 40 >> 2] | 0;
    i1 = i2 + (i3 << 4) | 0;
    if ((i15 | 0) != (i1 | 0)) {
     i4 = HEAP8[i1 + 11 >> 0] | 0;
     i5 = i4 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
     i4 = i5 ? HEAP32[i2 + (i3 << 4) + 4 >> 2] | 0 : i4 & 255;
     i5 = i15 + 11 | 0;
     i1 = HEAP8[i5 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i3 = (HEAP32[i17 + 24 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i4 >>> 0 > i3 >>> 0) {
      i10 = i2 ? HEAP32[i17 + 20 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i3, i4 - i3 | 0, i10, 0, i10, i4, i6);
      break;
     }
     i1 = i2 ? HEAP32[i15 >> 2] | 0 : i15;
     if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
     HEAP8[i1 + i4 >> 0] = 0;
     if ((HEAP8[i5 >> 0] | 0) < 0) {
      HEAP32[i17 + 20 >> 2] = i4;
      break;
     } else {
      HEAP8[i5 >> 0] = i4;
      break;
     }
    }
   }
  } while (0);
  if ((HEAP8[i14 + 11 >> 0] | 0) < 0) {
   i10 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 12 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i18 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i18);
  }
  if ((HEAP8[i13 + 11 >> 0] | 0) < 0) {
   i14 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i18 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i14, i18);
  }
 } else {
  HEAP32[i11 >> 2] = i4;
  i14 = HEAP32[i9 + 28 >> 2] | 0;
  i2 = i14;
  if ((HEAP32[i9 + 32 >> 2] | 0) - i14 >> 4 >>> 0 <= i4 >>> 0) {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
  i1 = i2 + (i4 << 4) | 0;
  do if ((i17 | 0) != (i1 | 0)) {
   i5 = HEAP8[i1 + 11 >> 0] | 0;
   i14 = i5 << 24 >> 24 < 0;
   i6 = i14 ? HEAP32[i1 >> 2] | 0 : i1;
   i4 = i14 ? HEAP32[i2 + (i4 << 4) + 4 >> 2] | 0 : i5 & 255;
   i5 = i17 + 11 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i17 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i4 >>> 0 > i3 >>> 0) {
    i14 = i2 ? HEAP32[i17 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i17, i3, i4 - i3 | 0, i14, 0, i14, i4, i6);
    break;
   }
   i1 = i2 ? HEAP32[i17 >> 2] | 0 : i17;
   if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i17 + 4 >> 2] = i4;
    break;
   } else {
    HEAP8[i5 >> 0] = i4;
    break;
   }
  } while (0);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i9 + 40 >> 2] | 0;
  i1 = i2 + (i3 << 4) | 0;
  if ((i15 | 0) != (i1 | 0)) {
   i4 = HEAP8[i1 + 11 >> 0] | 0;
   i5 = i4 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
   i4 = i5 ? HEAP32[i2 + (i3 << 4) + 4 >> 2] | 0 : i4 & 255;
   i5 = i15 + 11 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i17 + 24 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i4 >>> 0 > i3 >>> 0) {
    i14 = i2 ? HEAP32[i17 + 20 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i3, i4 - i3 | 0, i14, 0, i14, i4, i6);
    break;
   }
   i1 = i2 ? HEAP32[i15 >> 2] | 0 : i15;
   if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i17 + 20 >> 2] = i4;
    break;
   } else {
    HEAP8[i5 >> 0] = i4;
    break;
   }
  }
 } while (0);
 i14 = HEAP8[i17 + 11 >> 0] | 0;
 if (!((i14 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i14 & 255) | 0)) {
  i15 = HEAP8[i15 + 11 >> 0] | 0;
  if (!((i15 << 24 >> 24 < 0 ? HEAP32[i17 + 20 >> 2] | 0 : i15 & 255) | 0)) {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 __Z6FormatPKcz(i18, gb + 463342 | 0, i12);
 i5 = HEAP8[i18 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i4 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
 i5 = i6 ? HEAP32[i18 + 4 >> 2] | 0 : i5 & 255;
 i6 = i16 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i17 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i17 = i2 ? HEAP32[i17 + 36 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i5 - i3 | 0, i17, 0, i17, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i17 + 36 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 i18 = 1;
 STACKTOP = i19;
 return i18 | 0;
}

function __Z23sweepCapsule_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i23, i25, i5, i27, f18, i26, i4, f1) {
 i23 = i23 | 0;
 i25 = i25 | 0;
 i5 = i5 | 0;
 i27 = i27 | 0;
 f18 = Math_fround(f18);
 i26 = i26 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, f54 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i28 + 272 | 0;
 i24 = i28 + 524 | 0;
 i29 = i28 + 520 | 0;
 i42 = i28 + 492 | 0;
 i31 = i28 + 112 | 0;
 i7 = i28 + 96 | 0;
 i43 = i28 + 480 | 0;
 i41 = i28 + 80 | 0;
 i40 = i28 + 64 | 0;
 i33 = i28 + 128 | 0;
 i30 = i28 + 48 | 0;
 i6 = i28 + 32 | 0;
 i17 = i28 + 16 | 0;
 i19 = i28;
 i22 = HEAP32[i23 + 32 >> 2] | 0;
 i21 = i22 + 16 | 0;
 HEAP32[i24 >> 2] = HEAPU8[i22 + 55 >> 0];
 HEAPF32[i29 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf(i42, i5, i29);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 f15 = Math_fround(HEAPF32[i27 >> 2]);
 i22 = i27 + 4 | 0;
 f16 = Math_fround(HEAPF32[i22 >> 2]);
 i20 = i27 + 8 | 0;
 f2 = Math_fround(HEAPF32[i20 >> 2]);
 f38 = Math_fround(HEAPF32[i42 >> 2]);
 f54 = Math_fround(HEAPF32[i42 + 4 >> 2]);
 f46 = Math_fround(HEAPF32[i42 + 8 >> 2]);
 f52 = Math_fround(HEAPF32[i42 + 12 >> 2]);
 i42 = i42 + 16 | 0;
 f49 = Math_fround(HEAPF32[i42 >> 2]);
 f37 = Math_fround(HEAPF32[i42 + 4 >> 2]);
 f45 = Math_fround(HEAPF32[i42 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i25 >> 2]);
 f8 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 i42 = i25 + 16 | 0;
 f11 = Math_fround(HEAPF32[i42 >> 2]);
 f12 = Math_fround(HEAPF32[i42 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i42 + 8 >> 2]);
 f36 = Math_fround(-f3);
 f51 = Math_fround(-f8);
 f48 = Math_fround(-f9);
 f49 = Math_fround(f49 - f11);
 f37 = Math_fround(f37 - f12);
 f45 = Math_fround(f45 - f13);
 f14 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f35 = Math_fround(Math_fround(Math_fround(f49 * f36) + Math_fround(f37 * f51)) + Math_fround(f45 * f48));
 f39 = Math_fround(Math_fround(Math_fround(f35 * f36) + Math_fround(Math_fround(f14 * f49) + Math_fround(f10 * Math_fround(Math_fround(f45 * f51) - Math_fround(f37 * f48))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(f35 * f51) + Math_fround(Math_fround(f14 * f37) + Math_fround(f10 * Math_fround(Math_fround(f49 * f48) - Math_fround(f45 * f36))))) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f45) + Math_fround(f10 * Math_fround(Math_fround(f37 * f36) - Math_fround(f49 * f51)))) + Math_fround(f35 * f48)) * Math_fround(2.0));
 f49 = Math_fround(Math_fround(f52 * f10) - Math_fround(Math_fround(Math_fround(f38 * f36) + Math_fround(f54 * f51)) + Math_fround(f46 * f48)));
 f37 = Math_fround(Math_fround(Math_fround(f46 * f51) - Math_fround(f54 * f48)) + Math_fround(Math_fround(f52 * f36) + Math_fround(f38 * f10)));
 f45 = Math_fround(Math_fround(Math_fround(f38 * f48) - Math_fround(f46 * f36)) + Math_fround(Math_fround(f52 * f51) + Math_fround(f54 * f10)));
 f46 = Math_fround(Math_fround(Math_fround(f54 * f36) - Math_fround(f38 * f51)) + Math_fround(Math_fround(f52 * f48) + Math_fround(f46 * f10)));
 f48 = Math_fround(f37 + f37);
 f52 = Math_fround(f45 + f45);
 f51 = Math_fround(f46 + f46);
 f38 = Math_fround(f45 * f52);
 f36 = Math_fround(f46 * f51);
 f45 = Math_fround(f45 * f48);
 f54 = Math_fround(f46 * f48);
 f50 = Math_fround(f49 * f48);
 f46 = Math_fround(f46 * f52);
 f52 = Math_fround(f49 * f52);
 f51 = Math_fround(f49 * f51);
 f48 = Math_fround(Math_fround(1.0) - Math_fround(f37 * f48));
 f37 = Math_fround(Math_fround(Math_fround(1.0) - f38) - f36);
 f49 = Math_fround(f45 + f51);
 f47 = Math_fround(f54 - f52);
 f51 = Math_fround(f45 - f51);
 f36 = Math_fround(f48 - f36);
 f45 = Math_fround(f46 + f50);
 f52 = Math_fround(f54 + f52);
 f50 = Math_fround(f46 - f50);
 f38 = Math_fround(f48 - f38);
 f48 = Math_fround(HEAPF32[i29 >> 2]);
 i29 = i5 + 24 | 0;
 i42 = HEAP32[i29 >> 2] | 0;
 i44 = HEAP32[i23 + 8 >> 2] | 0;
 i53 = HEAP32[i23 + 12 >> 2] | 0;
 HEAP32[i41 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i41 + 4 >> 2] = i44;
 HEAP32[i41 + 8 >> 2] = i53;
 HEAPF32[i41 + 12 >> 2] = Math_fround(0.0);
 i53 = HEAP32[i23 + 20 >> 2] | 0;
 i44 = HEAP32[i23 + 24 >> 2] | 0;
 i5 = HEAP32[i23 + 28 >> 2] | 0;
 HEAP32[i40 >> 2] = HEAP32[i23 + 16 >> 2];
 HEAP32[i40 + 4 >> 2] = i53;
 HEAP32[i40 + 8 >> 2] = i44;
 HEAP32[i40 + 12 >> 2] = i5;
 f46 = Math_fround(f48 * Math_fround(0.0));
 f37 = Math_fround(Math_fround(f46 * f52) + Math_fround(Math_fround(f46 * f51) + Math_fround(f48 * f37)));
 f36 = Math_fround(Math_fround(f46 * f50) + Math_fround(Math_fround(f48 * f49) + Math_fround(f46 * f36)));
 f38 = Math_fround(Math_fround(Math_fround(f48 * f47) + Math_fround(f46 * f45)) + Math_fround(f46 * f38));
 i5 = i33 + 64 | 0;
 HEAPF32[i33 >> 2] = f39;
 HEAPF32[i33 + 4 >> 2] = f34;
 HEAPF32[i33 + 8 >> 2] = f35;
 HEAPF32[i33 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i33 + 80 >> 2] = 4;
 HEAPF32[i33 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i33 + 128 >> 2] = i42;
 i44 = i33 + 132 | 0;
 HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 f46 = Math_fround(f34 + f36);
 f45 = Math_fround(f35 + f38);
 HEAPF32[i33 + 96 >> 2] = Math_fround(f39 + f37);
 HEAPF32[i33 + 100 >> 2] = f46;
 HEAPF32[i33 + 104 >> 2] = f45;
 HEAPF32[i33 + 108 >> 2] = Math_fround(0.0);
 f36 = Math_fround(f34 - f36);
 f38 = Math_fround(f35 - f38);
 HEAPF32[i33 + 112 >> 2] = Math_fround(f39 - f37);
 HEAPF32[i33 + 116 >> 2] = f36;
 HEAPF32[i33 + 120 >> 2] = f38;
 HEAPF32[i33 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i33 + 16 >> 2] = i42;
 i44 = i33 + 20 | 0;
 HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i33 + 32 >> 2] = i42;
 i42 = i33 + 36 | 0;
 HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i32 >> 2] = -1;
 HEAP32[i32 + 4 >> 2] = -1;
 HEAP32[i32 + 8 >> 2] = -1;
 HEAP32[i32 + 12 >> 2] = -1;
 HEAP32[i5 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i32, i21, i31, i41, i40);
 f38 = Math_fround(-Math_fround(f15 * f18));
 f36 = Math_fround(-Math_fround(f16 * f18));
 f37 = Math_fround(-Math_fround(f2 * f18));
 f39 = Math_fround(Math_fround(Math_fround(f3 * f38) + Math_fround(f8 * f36)) + Math_fround(f9 * f37));
 f35 = Math_fround(Math_fround(Math_fround(f8 * f39) + Math_fround(Math_fround(f14 * f36) - Math_fround(f10 * Math_fround(Math_fround(f9 * f38) - Math_fround(f3 * f37))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(f9 * f39) + Math_fround(Math_fround(f14 * f37) - Math_fround(f10 * Math_fround(Math_fround(f3 * f36) - Math_fround(f8 * f38))))) * Math_fround(2.0));
 HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(f3 * f39) + Math_fround(Math_fround(f14 * f38) - Math_fround(f10 * Math_fround(Math_fround(f8 * f37) - Math_fround(f9 * f36))))) * Math_fround(2.0));
 HEAPF32[i30 + 4 >> 2] = f35;
 HEAPF32[i30 + 8 >> 2] = f34;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 i5 = (HEAP16[i4 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i33, i32, i7, i31, i30, i6, i19, i17, Math_fround(Math_fround(HEAPF32[i29 >> 2]) + f1), i5) | 0)) {
  i53 = 0;
  STACKTOP = i28;
  return i53 | 0;
 }
 i4 = i26 + 12 | 0;
 HEAP16[i4 >> 1] = 6;
 f54 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 do if (!(f54 >= f1)) {
  HEAP16[i4 >> 1] = 7;
  f52 = Math_fround(HEAPF32[i17 >> 2]);
  f48 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f47 = Math_fround(Math_fround(Math_fround(f3 * f52) + Math_fround(f8 * f48)) + Math_fround(f9 * f45));
  f46 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f3 * f47) + Math_fround(Math_fround(f14 * f52) + Math_fround(f10 * Math_fround(Math_fround(f8 * f45) - Math_fround(f9 * f48))))) * Math_fround(2.0)));
  f54 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f8 * f47) + Math_fround(Math_fround(f14 * f48) + Math_fround(f10 * Math_fround(Math_fround(f9 * f52) - Math_fround(f3 * f45))))) * Math_fround(2.0)));
  f47 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f45) + Math_fround(f10 * Math_fround(Math_fround(f3 * f48) - Math_fround(f8 * f52)))) + Math_fround(f9 * f47)) * Math_fround(2.0)));
  f52 = Math_fround(f1 * f18);
  f48 = Math_fround(HEAPF32[i19 >> 2]);
  f1 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f51 = Math_fround(Math_fround(Math_fround(f3 * f48) + Math_fround(f8 * f1)) + Math_fround(f9 * f45));
  f49 = Math_fround(Math_fround(Math_fround(f3 * f51) + Math_fround(Math_fround(f14 * f48) + Math_fround(f10 * Math_fround(Math_fround(f8 * f45) - Math_fround(f9 * f1))))) * Math_fround(2.0));
  f50 = Math_fround(Math_fround(Math_fround(f8 * f51) + Math_fround(Math_fround(f14 * f1) + Math_fround(f10 * Math_fround(Math_fround(f9 * f48) - Math_fround(f3 * f45))))) * Math_fround(2.0));
  f51 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f45) + Math_fround(f10 * Math_fround(Math_fround(f3 * f1) - Math_fround(f8 * f48)))) + Math_fround(f9 * f51)) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f49 * f49) + Math_fround(f50 * f50))))));
  f50 = Math_fround(f48 * f50);
  f51 = Math_fround(f48 * f51);
  f1 = Math_fround(Math_fround(f15 * f52) + f46);
  f54 = Math_fround(Math_fround(f16 * f52) + f54);
  f3 = Math_fround(Math_fround(f2 * f52) + f47);
  HEAPF32[i26 + 28 >> 2] = Math_fround(f48 * f49);
  HEAPF32[i26 + 32 >> 2] = f50;
  HEAPF32[i26 + 36 >> 2] = f51;
  HEAPF32[i26 + 16 >> 2] = f1;
  HEAPF32[i26 + 20 >> 2] = f54;
  HEAPF32[i26 + 24 >> 2] = f3;
  HEAPF32[i26 + 40 >> 2] = f52;
  f2 = f54;
 } else if (i5) {
  HEAP16[i4 >> 1] = 7;
  f48 = Math_fround(HEAPF32[i19 >> 2]);
  f47 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f52 = Math_fround(Math_fround(Math_fround(f3 * f48) + Math_fround(f8 * f47)) + Math_fround(f9 * f46));
  f50 = Math_fround(Math_fround(Math_fround(f3 * f52) + Math_fround(Math_fround(f14 * f48) + Math_fround(f10 * Math_fround(Math_fround(f8 * f46) - Math_fround(f9 * f47))))) * Math_fround(2.0));
  f51 = Math_fround(Math_fround(Math_fround(f8 * f52) + Math_fround(Math_fround(f14 * f47) + Math_fround(f10 * Math_fround(Math_fround(f9 * f48) - Math_fround(f3 * f46))))) * Math_fround(2.0));
  f52 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f46) + Math_fround(f10 * Math_fround(Math_fround(f3 * f47) - Math_fround(f8 * f48)))) + Math_fround(f9 * f52)) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f52 * f52) + Math_fround(Math_fround(f50 * f50) + Math_fround(f51 * f51))))));
  f50 = Math_fround(f48 * f50);
  f51 = Math_fround(f48 * f51);
  f52 = Math_fround(f48 * f52);
  f48 = Math_fround(HEAPF32[i17 >> 2]);
  f47 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f3 * f48) + Math_fround(f8 * f47)) + Math_fround(f9 * f46));
  f54 = Math_fround(Math_fround(f11 + Math_fround(Math_fround(Math_fround(f3 * f49) + Math_fround(Math_fround(f14 * f48) + Math_fround(f10 * Math_fround(Math_fround(f8 * f46) - Math_fround(f9 * f47))))) * Math_fround(2.0))) - Math_fround(f1 * f50));
  f2 = Math_fround(Math_fround(f12 + Math_fround(Math_fround(Math_fround(f8 * f49) + Math_fround(Math_fround(f14 * f47) + Math_fround(f10 * Math_fround(Math_fround(f9 * f48) - Math_fround(f3 * f46))))) * Math_fround(2.0))) - Math_fround(f1 * f51));
  f3 = Math_fround(Math_fround(f13 + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f46) + Math_fround(f10 * Math_fround(Math_fround(f3 * f47) - Math_fround(f8 * f48)))) + Math_fround(f9 * f49)) * Math_fround(2.0))) - Math_fround(f1 * f52));
  HEAPF32[i26 + 28 >> 2] = f50;
  HEAPF32[i26 + 32 >> 2] = f51;
  HEAPF32[i26 + 36 >> 2] = f52;
  HEAPF32[i26 + 16 >> 2] = f54;
  HEAPF32[i26 + 20 >> 2] = f2;
  HEAPF32[i26 + 24 >> 2] = f3;
  HEAPF32[i26 + 40 >> 2] = f1;
  f1 = f54;
  break;
 } else {
  HEAPF32[i26 + 40 >> 2] = Math_fround(0.0);
  f3 = Math_fround(-Math_fround(HEAPF32[i27 >> 2]));
  f2 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  f1 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
  HEAPF32[i26 + 28 >> 2] = f3;
  HEAPF32[i26 + 32 >> 2] = f2;
  HEAPF32[i26 + 36 >> 2] = f1;
  f1 = Math_fround(HEAPF32[i26 + 16 >> 2]);
  f2 = Math_fround(HEAPF32[i26 + 20 >> 2]);
  f3 = Math_fround(HEAPF32[i26 + 24 >> 2]);
  break;
 } while (0);
 f52 = Math_fround(HEAPF32[i27 >> 2]);
 f54 = Math_fround(HEAPF32[i22 >> 2]);
 HEAP32[i26 + 8 >> 2] = __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_(i23, i21, i24, i25, f1, f2, f3, f52, f54, Math_fround(HEAPF32[i20 >> 2])) | 0;
 i53 = 1;
 STACKTOP = i28;
 return i53 | 0;
}

function __ZN5physx21collideWithStaticMeshEjPNS_19PxsParticleCollDataEPNS_27PxsFluidParticleOpcodeCacheERKNS_2Gu13GeometryUnionERKNS_11PxTransformESA_fff(i107, i105, i108, i106, i111, i110, f1, f3, f109) {
 i107 = i107 | 0;
 i105 = i105 | 0;
 i108 = i108 | 0;
 i106 = i106 | 0;
 i111 = i111 | 0;
 i110 = i110 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 f109 = Math_fround(f109);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0, f117 = f0, f118 = f0, f119 = f0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, f125 = f0, f126 = f0, f127 = f0, f128 = f0, f129 = f0, f130 = f0;
 i104 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i100 = i104 + 432 | 0;
 i102 = i104 + 424 | 0;
 i98 = i104 + 384 | 0;
 i99 = i104 + 56 | 0;
 i96 = i104 + 32 | 0;
 i101 = i104 + 24 | 0;
 i103 = i104 + 60 | 0;
 i97 = i104;
 i2 = i106 + 4 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i106 + 8 >> 2]) == Math_fround(1.0)) i95 = Math_fround(HEAPF32[i106 + 12 >> 2]) == Math_fround(1.0); else i95 = 0; else i95 = 0;
 i78 = i100 + 36 | 0;
 HEAP32[i100 >> 2] = 1065353216;
 i79 = i100 + 4 | 0;
 HEAP32[i79 >> 2] = 0;
 i80 = i100 + 8 | 0;
 HEAP32[i80 >> 2] = 0;
 i81 = i100 + 12 | 0;
 HEAP32[i81 >> 2] = 0;
 i82 = i100 + 16 | 0;
 HEAP32[i82 >> 2] = 1065353216;
 i83 = i100 + 20 | 0;
 HEAP32[i83 >> 2] = 0;
 i84 = i100 + 24 | 0;
 HEAP32[i84 >> 2] = 0;
 i85 = i100 + 28 | 0;
 HEAP32[i85 >> 2] = 0;
 i86 = i100 + 32 | 0;
 HEAP32[i86 >> 2] = 1065353216;
 HEAP32[i78 >> 2] = 1065353216;
 i87 = i100 + 40 | 0;
 HEAP32[i87 >> 2] = 0;
 i88 = i100 + 44 | 0;
 HEAP32[i88 >> 2] = 0;
 i89 = i100 + 48 | 0;
 HEAP32[i89 >> 2] = 0;
 i90 = i100 + 52 | 0;
 HEAP32[i90 >> 2] = 1065353216;
 i91 = i100 + 56 | 0;
 HEAP32[i91 >> 2] = 0;
 i92 = i100 + 60 | 0;
 HEAP32[i92 >> 2] = 0;
 i93 = i100 + 64 | 0;
 HEAP32[i93 >> 2] = 0;
 i94 = i100 + 68 | 0;
 HEAP32[i94 >> 2] = 1065353216;
 if (!i95) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i100, i2, i106 + 16 | 0);
 f3 = Math_fround(Math_fround(f3 * Math_fround(4.0)) + f109);
 HEAPF32[i102 + 4 >> 2] = Math_fround(Math_fround(Math_fround(1.0) / f3) * Math_fround(254.0));
 HEAPF32[i102 >> 2] = Math_fround(f3 * Math_fround(.00393700786));
 i17 = HEAP32[i106 + 40 >> 2] | 0;
 i18 = (HEAP32[i17 + 4 >> 2] | 0) >>> 0 < 65536;
 HEAP32[i99 >> 2] = 0;
 if (!i107) {
  STACKTOP = i104;
  return;
 }
 i19 = i96 + 4 | 0;
 i20 = i96 + 8 | 0;
 i21 = i96 + 12 | 0;
 i22 = i96 + 16 | 0;
 i23 = i96 + 20 | 0;
 i24 = i17 + 12 | 0;
 i25 = i17 + 8 | 0;
 i26 = i103 + 4 | 0;
 i27 = i103 + 8 | 0;
 i28 = i103 + 12 | 0;
 i29 = i103 + 16 | 0;
 i30 = i103 + 20 | 0;
 i31 = i103 + 24 | 0;
 i32 = i103 + 28 | 0;
 i33 = i103 + 32 | 0;
 i34 = i103 + 36 | 0;
 i35 = i103 + 40 | 0;
 i36 = i103 + 44 | 0;
 i37 = i103 + 48 | 0;
 i38 = i103 + 52 | 0;
 i39 = i103 + 56 | 0;
 i40 = i103 + 60 | 0;
 i41 = i103 + 64 | 0;
 i42 = i103 + 68 | 0;
 i43 = i103 + 72 | 0;
 i44 = i103 + 76 | 0;
 i45 = i103 + 80 | 0;
 i46 = i103 + 84 | 0;
 i47 = i103 + 88 | 0;
 i48 = i103 + 92 | 0;
 i49 = i103 + 96 | 0;
 i50 = i103 + 100 | 0;
 i51 = i103 + 104 | 0;
 f1 = Math_fround(f109 * Math_fround(1.5));
 i52 = i97 + 4 | 0;
 i53 = i97 + 8 | 0;
 i54 = i97 + 12 | 0;
 i55 = i97 + 16 | 0;
 i56 = i97 + 20 | 0;
 i57 = i103 + 4 | 0;
 i58 = i103 + 8 | 0;
 i59 = i103 + 12 | 0;
 i60 = i103 + 16 | 0;
 i61 = i103 + 20 | 0;
 i62 = i103 + 24 | 0;
 i63 = i103 + 28 | 0;
 i64 = i103 + 32 | 0;
 i65 = i103 + 36 | 0;
 i66 = i103 + 40 | 0;
 i67 = i103 + 44 | 0;
 i68 = i103 + 48 | 0;
 i69 = i103 + 52 | 0;
 i70 = i103 + 56 | 0;
 i71 = i103 + 60 | 0;
 i72 = i103 + 64 | 0;
 i73 = i103 + 68 | 0;
 i74 = i103 + 72 | 0;
 i75 = i103 + 76 | 0;
 i76 = i103 + 80 | 0;
 i77 = i103 + 84 | 0;
 i12 = i103 + 88 | 0;
 i13 = i103 + 92 | 0;
 i14 = i103 + 96 | 0;
 i15 = i103 + 100 | 0;
 i16 = i103 + 104 | 0;
 i11 = 0;
 do {
  i2 = i108 + (i11 << 5) | 0;
  i4 = i105 + (i11 * 176 | 0) + 64 | 0;
  f116 = Math_fround(HEAPF32[i4 >> 2]);
  f119 = Math_fround(f116 - f109);
  i5 = i105 + (i11 * 176 | 0) + 68 | 0;
  f114 = Math_fround(HEAPF32[i5 >> 2]);
  f118 = Math_fround(f114 - f109);
  i6 = i105 + (i11 * 176 | 0) + 72 | 0;
  f112 = Math_fround(HEAPF32[i6 >> 2]);
  f117 = Math_fround(f112 - f109);
  f116 = Math_fround(f116 + f109);
  f114 = Math_fround(f114 + f109);
  f112 = Math_fround(f112 + f109);
  i7 = i105 + (i11 * 176 | 0) + 48 | 0;
  f115 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i105 + (i11 * 176 | 0) + 52 | 0;
  f113 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i105 + (i11 * 176 | 0) + 56 | 0;
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  HEAPF32[i96 >> 2] = f119 < f115 ? f119 : f115;
  HEAPF32[i19 >> 2] = f118 < f113 ? f118 : f113;
  HEAPF32[i20 >> 2] = f117 < f3 ? f117 : f3;
  HEAPF32[i21 >> 2] = f116 > f115 ? f116 : f115;
  HEAPF32[i22 >> 2] = f114 > f113 ? f114 : f113;
  HEAPF32[i23 >> 2] = f112 > f3 ? f112 : f3;
  HEAP32[i101 >> 2] = 0;
  i10 = i105 + (i11 * 176 | 0) + 62 | 0;
  do if (__ZNK5physx27PxsFluidParticleOpcodeCache4readERtRjPjRKNS_9PxBounds3ERKNS0_18QuantizationParamsEPKNS_2Gu13GeometryUnionEb(i2, i10, i101, i98, i96, i102, i106, i18) | 0) {
   i5 = HEAP32[i101 >> 2] | 0;
   if (i5 | 0) {
    i6 = HEAP32[i24 >> 2] | 0;
    i7 = HEAP32[i25 >> 2] | 0;
    if (i18) {
     i2 = 0;
     i4 = i98;
     while (1) {
      i122 = i2 * 3 | 0;
      i8 = i122 + 1 | 0;
      i11 = i122 + 2 | 0;
      i9 = ((HEAP32[i4 >> 2] | 0) * 6 | 0) + i6 | 0;
      i124 = ((HEAPU16[i9 >> 1] | 0) * 12 | 0) + i7 | 0;
      i123 = i124;
      i121 = ((HEAPU16[i9 + 2 >> 1] | 0) * 12 | 0) + i7 | 0;
      i120 = i121;
      i9 = ((HEAPU16[i9 + 4 >> 1] | 0) * 12 | 0) + i7 | 0;
      i10 = i9;
      HEAP32[i103 + (i122 * 12 | 0) >> 2] = HEAP32[i124 >> 2];
      HEAP32[i103 + (i122 * 12 | 0) + 4 >> 2] = HEAP32[i123 + 4 >> 2];
      HEAP32[i103 + (i122 * 12 | 0) + 8 >> 2] = HEAP32[i123 + 8 >> 2];
      HEAP32[i103 + (i8 * 12 | 0) >> 2] = HEAP32[i121 >> 2];
      HEAP32[i103 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i120 + 4 >> 2];
      HEAP32[i103 + (i8 * 12 | 0) + 8 >> 2] = HEAP32[i120 + 8 >> 2];
      HEAP32[i103 + (i11 * 12 | 0) >> 2] = HEAP32[i9 >> 2];
      HEAP32[i103 + (i11 * 12 | 0) + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i103 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
     }
    } else {
     i2 = 0;
     i4 = i98;
     while (1) {
      i10 = i2 * 3 | 0;
      i121 = i10 + 1 | 0;
      i124 = i10 + 2 | 0;
      i122 = ((HEAP32[i4 >> 2] | 0) * 12 | 0) + i6 | 0;
      i8 = ((HEAP32[i122 >> 2] | 0) * 12 | 0) + i7 | 0;
      i9 = i8;
      i11 = ((HEAP32[i122 + 4 >> 2] | 0) * 12 | 0) + i7 | 0;
      i120 = i11;
      i122 = ((HEAP32[i122 + 8 >> 2] | 0) * 12 | 0) + i7 | 0;
      i123 = i122;
      HEAP32[i103 + (i10 * 12 | 0) >> 2] = HEAP32[i8 >> 2];
      HEAP32[i103 + (i10 * 12 | 0) + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i103 + (i10 * 12 | 0) + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i103 + (i121 * 12 | 0) >> 2] = HEAP32[i11 >> 2];
      HEAP32[i103 + (i121 * 12 | 0) + 4 >> 2] = HEAP32[i120 + 4 >> 2];
      HEAP32[i103 + (i121 * 12 | 0) + 8 >> 2] = HEAP32[i120 + 8 >> 2];
      HEAP32[i103 + (i124 * 12 | 0) >> 2] = HEAP32[i122 >> 2];
      HEAP32[i103 + (i124 * 12 | 0) + 4 >> 2] = HEAP32[i123 + 4 >> 2];
      HEAP32[i103 + (i124 * 12 | 0) + 8 >> 2] = HEAP32[i123 + 8 >> 2];
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
     }
    }
    i124 = HEAP32[i99 >> 2] | 0;
    HEAP32[i105 + (i124 * 176 | 0) + 144 >> 2] = 0;
    HEAP32[i105 + (i124 * 176 | 0) + 148 >> 2] = 0;
    HEAP32[i105 + (i124 * 176 | 0) + 152 >> 2] = 0;
    i123 = i105 + (i124 * 176 | 0) + 160 | 0;
    HEAP32[i123 >> 2] = 0;
    HEAP32[i123 + 4 >> 2] = 0;
    HEAP32[i123 + 8 >> 2] = 0;
    HEAP32[i123 + 12 >> 2] = 0;
    __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE(i105 + (i124 * 176 | 0) | 0, 0, i100, i103, i5, f109, i110);
   }
  } else if ((HEAP16[i10 >> 1] & 48) == 48) {
   HEAP32[i26 >> 2] = 2;
   HEAP32[i103 >> 2] = gb + 147476 + 8;
   HEAP32[i27 >> 2] = i105;
   HEAP32[i28 >> 2] = i99;
   HEAP32[i29 >> 2] = 1;
   HEAP32[i30 >> 2] = i17;
   HEAP32[i31 >> 2] = HEAP32[i100 >> 2];
   HEAP32[i32 >> 2] = HEAP32[i79 >> 2];
   HEAP32[i33 >> 2] = HEAP32[i80 >> 2];
   HEAP32[i34 >> 2] = HEAP32[i81 >> 2];
   HEAP32[i35 >> 2] = HEAP32[i82 >> 2];
   HEAP32[i36 >> 2] = HEAP32[i83 >> 2];
   HEAP32[i37 >> 2] = HEAP32[i84 >> 2];
   HEAP32[i38 >> 2] = HEAP32[i85 >> 2];
   HEAP32[i39 >> 2] = HEAP32[i86 >> 2];
   HEAP32[i40 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i41 >> 2] = HEAP32[i87 >> 2];
   HEAP32[i42 >> 2] = HEAP32[i88 >> 2];
   HEAP32[i43 >> 2] = HEAP32[i89 >> 2];
   HEAP32[i44 >> 2] = HEAP32[i90 >> 2];
   HEAP32[i45 >> 2] = HEAP32[i91 >> 2];
   HEAP32[i46 >> 2] = HEAP32[i92 >> 2];
   HEAP32[i47 >> 2] = HEAP32[i93 >> 2];
   HEAP32[i48 >> 2] = HEAP32[i94 >> 2];
   HEAPF32[i49 >> 2] = f109;
   HEAP32[i50 >> 2] = 0;
   HEAP32[i51 >> 2] = i110;
   i124 = HEAP32[i99 >> 2] | 0;
   HEAP32[i105 + (i124 * 176 | 0) + 144 >> 2] = 0;
   HEAP32[i105 + (i124 * 176 | 0) + 148 >> 2] = 0;
   HEAP32[i105 + (i124 * 176 | 0) + 152 >> 2] = 0;
   i124 = i105 + (i124 * 176 | 0) + 160 | 0;
   HEAP32[i124 >> 2] = 0;
   HEAP32[i124 + 4 >> 2] = 0;
   HEAP32[i124 + 8 >> 2] = 0;
   HEAP32[i124 + 12 >> 2] = 0;
   __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback(i17, i111, i110, i100, i95, i96, i103);
   break;
  } else {
   f114 = Math_fround(HEAPF32[i4 >> 2]);
   f115 = Math_fround(HEAPF32[i7 >> 2]);
   f127 = Math_fround(f114 - f115);
   f116 = Math_fround(HEAPF32[i5 >> 2]);
   f117 = Math_fround(HEAPF32[i8 >> 2]);
   f126 = Math_fround(f116 - f117);
   f118 = Math_fround(HEAPF32[i6 >> 2]);
   f119 = Math_fround(HEAPF32[i9 >> 2]);
   f127 = Math_fround(f114 + Math_fround(f127 * Math_fround(3.0)));
   f126 = Math_fround(f116 + Math_fround(f126 * Math_fround(3.0)));
   f125 = Math_fround(f118 + Math_fround(Math_fround(f118 - f119) * Math_fround(3.0)));
   f130 = Math_fround(f127 - f1);
   f129 = Math_fround(f126 - f1);
   f128 = Math_fround(f125 - f1);
   f127 = Math_fround(f1 + f127);
   f126 = Math_fround(f1 + f126);
   f125 = Math_fround(f1 + f125);
   f3 = Math_fround(f114 - f1);
   f112 = Math_fround(f116 - f1);
   f113 = Math_fround(f118 - f1);
   f114 = Math_fround(f1 + f114);
   f116 = Math_fround(f1 + f116);
   f118 = Math_fround(f1 + f118);
   f3 = f130 < f3 ? f130 : f3;
   f112 = f129 < f112 ? f129 : f112;
   f113 = f128 < f113 ? f128 : f113;
   f114 = f127 > f114 ? f127 : f114;
   f116 = f126 > f116 ? f126 : f116;
   f118 = f125 > f118 ? f125 : f118;
   HEAPF32[i97 >> 2] = f3 < f115 ? f3 : f115;
   HEAPF32[i52 >> 2] = f112 < f117 ? f112 : f117;
   HEAPF32[i53 >> 2] = f113 < f119 ? f113 : f119;
   HEAPF32[i54 >> 2] = f114 > f115 ? f114 : f115;
   HEAPF32[i55 >> 2] = f116 > f117 ? f116 : f117;
   HEAPF32[i56 >> 2] = f118 > f119 ? f118 : f119;
   HEAP8[i2 >> 0] = 0;
   HEAP32[i108 + (i11 << 5) + 28 >> 2] = i98;
   HEAP32[i57 >> 2] = 2;
   HEAP32[i103 >> 2] = gb + 147476 + 8;
   HEAP32[i58 >> 2] = i105;
   HEAP32[i59 >> 2] = i99;
   HEAP32[i60 >> 2] = 1;
   HEAP32[i61 >> 2] = i17;
   HEAP32[i62 >> 2] = HEAP32[i100 >> 2];
   HEAP32[i63 >> 2] = HEAP32[i79 >> 2];
   HEAP32[i64 >> 2] = HEAP32[i80 >> 2];
   HEAP32[i65 >> 2] = HEAP32[i81 >> 2];
   HEAP32[i66 >> 2] = HEAP32[i82 >> 2];
   HEAP32[i67 >> 2] = HEAP32[i83 >> 2];
   HEAP32[i68 >> 2] = HEAP32[i84 >> 2];
   HEAP32[i69 >> 2] = HEAP32[i85 >> 2];
   HEAP32[i70 >> 2] = HEAP32[i86 >> 2];
   HEAP32[i71 >> 2] = HEAP32[i78 >> 2];
   HEAP32[i72 >> 2] = HEAP32[i87 >> 2];
   HEAP32[i73 >> 2] = HEAP32[i88 >> 2];
   HEAP32[i74 >> 2] = HEAP32[i89 >> 2];
   HEAP32[i75 >> 2] = HEAP32[i90 >> 2];
   HEAP32[i76 >> 2] = HEAP32[i91 >> 2];
   HEAP32[i77 >> 2] = HEAP32[i92 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i93 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i94 >> 2];
   HEAPF32[i14 >> 2] = f109;
   HEAP32[i15 >> 2] = i2;
   HEAP32[i16 >> 2] = i110;
   i124 = HEAP32[i99 >> 2] | 0;
   HEAP32[i105 + (i124 * 176 | 0) + 144 >> 2] = 0;
   HEAP32[i105 + (i124 * 176 | 0) + 148 >> 2] = 0;
   HEAP32[i105 + (i124 * 176 | 0) + 152 >> 2] = 0;
   i124 = i105 + (i124 * 176 | 0) + 160 | 0;
   HEAP32[i124 >> 2] = 0;
   HEAP32[i124 + 4 >> 2] = 0;
   HEAP32[i124 + 8 >> 2] = 0;
   HEAP32[i124 + 12 >> 2] = 0;
   __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback(i17, i111, i110, i100, i95, i97, i103);
   __ZN5physx27PxsFluidParticleOpcodeCache5writeERtRKNS_9PxBounds3ERKNS0_18QuantizationParamsERKNS_2Gu13GeometryUnionEb(i2, i10, i97, i102, i106, i18);
   break;
  } while (0);
  i11 = (HEAP32[i99 >> 2] | 0) + 1 | 0;
  HEAP32[i99 >> 2] = i11;
 } while (i11 >>> 0 < i107 >>> 0);
 STACKTOP = i104;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator24ProcessFormatForPositionEv(i46) {
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f47 = f0, f48 = f0, f49 = f0;
 i25 = i46 + 256 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 i42 = i46 + 12 | 0;
 i45 = i46 + 260 | 0;
 L1 : do if ((i1 | 0) < (HEAP32[i42 >> 2] | 0)) {
  i43 = i46 + 332 | 0;
  i2 = i46 + 344 | 0;
  i44 = i46 + 229 | 0;
  i26 = i46 + 184 | 0;
  i27 = i46 + 248 | 0;
  i28 = i46 + 320 | 0;
  i29 = i46 + 324 | 0;
  i30 = i46 + 328 | 0;
  i31 = i46 + 436 | 0;
  i32 = i46 + 356 | 0;
  i33 = i46 + 376 | 0;
  i3 = i46 + 396 | 0;
  i34 = i46 + 312 | 0;
  i35 = i46 + 268 | 0;
  i36 = i46 + 308 | 0;
  i37 = i46 + 220 | 0;
  i38 = i46 + 304 | 0;
  i39 = i46 + 300 | 0;
  i40 = i46 + 264 | 0;
  i41 = i46 + 280 | 0;
  i7 = i1;
  i1 = HEAP32[i45 >> 2] | 0;
  while (1) {
   i4 = HEAP32[i46 >> 2] | 0;
   i6 = i4 + (i7 * 44 | 0) | 0;
   if ((i1 | 0) < (HEAP32[i6 >> 2] | 0)) break L1;
   i24 = (HEAP32[i4 + (i7 * 44 | 0) + 4 >> 2] | 0) + i1 | 0;
   __ZN20TextRenderingPrivate11FormatStack10PushFormatERKNS_16TextFormatChangeE(i43, i6);
   i8 = HEAP32[i25 >> 2] | 0;
   i9 = HEAP32[i46 >> 2] | 0;
   if ((HEAP32[i9 + (i8 * 44 | 0) + 40 >> 2] & 32800 | 0) == 32) {
    f5 = Math_fround(HEAP32[(HEAP32[i43 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) + -1 << 5) + 8 >> 2] | 0);
    i7 = (HEAP8[i44 >> 0] | 0) == 0;
    if (!i7) {
     f13 = Math_fround(HEAPF32[i27 >> 2]);
     f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f5 * f13) + Math_fround(.5)))) / f13);
    }
    do if (f5 == Math_fround(0.0)) {
     i1 = HEAP32[i26 >> 2] | 0;
     i4 = HEAP32[(HEAP32[i1 + 76 >> 2] | 0) + 36 >> 2] | 0;
     if (!i4) {
      f5 = Math_fround(HEAPF32[i1 + 192 >> 2]);
      if (i7) break;
      f13 = Math_fround(HEAPF32[i27 >> 2]);
      f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f5 * f13) + Math_fround(.5)))) / f13);
      break;
     } else {
      f5 = Math_fround(i4 | 0);
      if (i7) break;
      f13 = Math_fround(HEAPF32[i27 >> 2]);
      f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f5 * f13) + Math_fround(.5)))) / f13);
      break;
     }
    } while (0);
    f11 = Math_fround(HEAPF32[i28 >> 2]);
    f12 = Math_fround(HEAPF32[i29 >> 2]);
    f13 = Math_fround(HEAPF32[i30 >> 2]);
    i1 = i9 + (i8 * 44 | 0) + 24 | 0;
    i4 = i9 + (i8 * 44 | 0) + 32 | 0;
    f10 = Math_fround(HEAPF32[i4 >> 2]);
    i6 = i9 + (i8 * 44 | 0) + 36 | 0;
    f10 = Math_fround(f5 * Math_fround(f10 / Math_fround(HEAPF32[i6 >> 2])));
    if (!i7) {
     f47 = Math_fround(HEAPF32[i27 >> 2]);
     f10 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f10 * f47) + Math_fround(.5)))) / f47);
    }
    i23 = HEAP32[i31 >> 2] | 0;
    f48 = Math_fround(f11 + Math_fround(0.0));
    f49 = Math_fround(f12 - f5);
    f47 = Math_fround(f13 + Math_fround(0.0));
    HEAPF32[i23 >> 2] = f48;
    HEAPF32[i23 + 4 >> 2] = f49;
    HEAPF32[i23 + 8 >> 2] = f47;
    i23 = HEAP32[i31 >> 2] | 0;
    i9 = i9 + (i8 * 44 | 0) + 28 | 0;
    f13 = Math_fround(HEAPF32[i9 >> 2]);
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i6 >> 2]));
    HEAP32[i23 + 28 >> 2] = HEAP32[i1 >> 2];
    HEAPF32[i23 + 32 >> 2] = f13;
    i8 = HEAP32[i31 >> 2] | 0;
    f11 = Math_fround(f11 + f10);
    HEAPF32[i8 + 60 >> 2] = f11;
    HEAPF32[i8 + 64 >> 2] = f49;
    HEAPF32[i8 + 68 >> 2] = f47;
    i8 = HEAP32[i31 >> 2] | 0;
    f49 = Math_fround(HEAPF32[i1 >> 2]);
    f49 = Math_fround(f49 + Math_fround(HEAPF32[i4 >> 2]));
    f13 = Math_fround(HEAPF32[i9 >> 2]);
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i6 >> 2]));
    HEAPF32[i8 + 88 >> 2] = f49;
    HEAPF32[i8 + 92 >> 2] = f13;
    i8 = HEAP32[i31 >> 2] | 0;
    f13 = Math_fround(f12 + Math_fround(0.0));
    HEAPF32[i8 + 120 >> 2] = f11;
    HEAPF32[i8 + 124 >> 2] = f13;
    HEAPF32[i8 + 128 >> 2] = f47;
    i8 = HEAP32[i31 >> 2] | 0;
    f12 = Math_fround(HEAPF32[i1 >> 2]);
    f12 = Math_fround(f12 + Math_fround(HEAPF32[i4 >> 2]));
    i23 = HEAP32[i9 >> 2] | 0;
    HEAPF32[i8 + 148 >> 2] = f12;
    HEAP32[i8 + 152 >> 2] = i23;
    i8 = HEAP32[i31 >> 2] | 0;
    HEAPF32[i8 + 180 >> 2] = f48;
    HEAPF32[i8 + 184 >> 2] = f13;
    HEAPF32[i8 + 188 >> 2] = f47;
    i8 = HEAP32[i31 >> 2] | 0;
    i9 = HEAP32[i9 >> 2] | 0;
    HEAP32[i8 + 208 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 212 >> 2] = i9;
    i8 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
    i9 = HEAP32[i43 >> 2] | 0;
    i1 = i9 + (i8 << 5) + 4 | 0;
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
     i1 = HEAP32[i1 >> 2] | 0;
     i4 = i1 >>> 16;
     i6 = i1;
     i7 = i1 & 255;
     i1 = i1 >>> 8 & 255;
    } else {
     i6 = HEAP32[i1 >> 2] | 0;
     i4 = i6;
     i7 = HEAP8[i9 + (i8 << 5) + 6 >> 0] | 0;
     i1 = HEAP8[i9 + (i8 << 5) + 5 >> 0] | 0;
    }
    i17 = HEAP32[i31 >> 2] | 0;
    i20 = i6 & -16777216 | i4 << 16 & 16711680 | i7 & 255 | (i1 & 255) << 8;
    HEAP32[i17 + 204 >> 2] = i20;
    HEAP32[i17 + 144 >> 2] = i20;
    HEAP32[i17 + 84 >> 2] = i20;
    HEAP32[i17 + 24 >> 2] = i20;
    HEAP32[i31 >> 2] = i17 + 240;
    i17 = HEAP32[i45 >> 2] << 2;
    i20 = HEAP32[(HEAP32[i43 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) + -1 << 5) + 12 >> 2] | 0;
    i21 = i46 + 20 + (i20 * 20 | 0) | 0;
    i7 = (i17 | 1) & 65535;
    i23 = i46 + 20 + (i20 * 20 | 0) + 12 | 0;
    i19 = HEAP32[i23 >> 2] | 0;
    i14 = i19 + 1 | 0;
    i22 = i46 + 20 + (i20 * 20 | 0) + 16 | 0;
    i4 = HEAP32[i22 >> 2] | 0;
    i6 = i4 & 2147483647;
    do if (i14 >>> 0 > i6 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i1;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      i4 = HEAP32[i22 >> 2] | 0;
      break;
     } else {
      i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i4 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i1;
      HEAP32[i21 >> 2] = i4;
      i4 = i1;
      break;
     }
    } while (0);
    HEAP32[i23 >> 2] = i14;
    i8 = HEAP32[i21 >> 2] | 0;
    HEAP16[i8 + (i19 << 1) >> 1] = i7;
    i16 = (i17 | 2) & 65535;
    i15 = i19 + 2 | 0;
    i1 = i4 & 2147483647;
    do if (i15 >>> 0 > i1 >>> 0) {
     i6 = i4 << 1;
     i6 = (i6 | 0) == 0 ? 1 : i6;
     if (i1 >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i6;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i6 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = HEAP32[i22 >> 2] | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i6;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = i6;
      break;
     } else {
      i1 = i8;
      i9 = i8;
     }
    } else {
     i1 = i8;
     i9 = i8;
    } while (0);
    HEAP32[i23 >> 2] = i15;
    HEAP16[i1 + (i14 << 1) >> 1] = i16;
    i18 = i17 & 65535;
    i8 = i19 + 3 | 0;
    i6 = i4 & 2147483647;
    do if (i8 >>> 0 > i6 >>> 0) {
     i7 = i4 << 1;
     i7 = (i7 | 0) == 0 ? 1 : i7;
     if (i6 >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i7;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = HEAP32[i22 >> 2] | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i7;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = i7;
      break;
     }
    } while (0);
    HEAP32[i23 >> 2] = i8;
    HEAP16[i1 + (i15 << 1) >> 1] = i18;
    i15 = i19 + 4 | 0;
    i6 = i4 & 2147483647;
    do if (i15 >>> 0 > i6 >>> 0) {
     i7 = i4 << 1;
     i7 = (i7 | 0) == 0 ? 1 : i7;
     if (i6 >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i7;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = HEAP32[i22 >> 2] | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i7;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = i7;
      break;
     }
    } while (0);
    HEAP32[i23 >> 2] = i15;
    HEAP16[i1 + (i8 << 1) >> 1] = i16;
    i8 = (i17 | 3) & 65535;
    i14 = i19 + 5 | 0;
    i6 = i4 & 2147483647;
    do if (i14 >>> 0 > i6 >>> 0) {
     i7 = i4 << 1;
     i7 = (i7 | 0) == 0 ? 1 : i7;
     if (i6 >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i7;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = HEAP32[i22 >> 2] | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i7;
      HEAP32[i21 >> 2] = i9;
      i1 = i9;
      i4 = i7;
      break;
     }
    } while (0);
    HEAP32[i23 >> 2] = i14;
    HEAP16[i1 + (i15 << 1) >> 1] = i8;
    i8 = i19 + 6 | 0;
    i7 = i4 & 2147483647;
    do if (i8 >>> 0 > i7 >>> 0) {
     i6 = i4 << 1;
     i6 = (i6 | 0) == 0 ? 1 : i6;
     if (i7 >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i22 >> 2] = i6;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i6 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 1, 2, i46 + 20 + (i20 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i23 >> 2] << 1 | 0) | 0;
      HEAP32[i22 >> 2] = i6;
      HEAP32[i21 >> 2] = i1;
      break;
     }
    } while (0);
    HEAP32[i23 >> 2] = i8;
    HEAP16[i1 + (i14 << 1) >> 1] = i18;
    i1 = HEAP32[i45 >> 2] | 0;
    i23 = HEAP32[i32 >> 2] | 0;
    i22 = HEAP32[i29 >> 2] | 0;
    HEAP32[i23 + (i1 << 3) >> 2] = HEAP32[i28 >> 2];
    HEAP32[i23 + (i1 << 3) + 4 >> 2] = i22;
    i1 = HEAP32[i45 >> 2] | 0;
    HEAPF32[(HEAP32[i33 >> 2] | 0) + (i1 << 2) >> 2] = f10;
    HEAPF32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = f5;
    if ((HEAP32[i34 >> 2] | 0) > 0) {
     HEAP32[i34 >> 2] = 0;
     HEAP32[i35 >> 2] = i1;
     HEAP32[i36 >> 2] = HEAP32[i28 >> 2];
    }
    f5 = Math_fround(HEAPF32[i37 >> 2]);
    if (f5 > Math_fround(0.0)) if (Math_fround(f10 + Math_fround(HEAPF32[i28 >> 2])) > f5) {
     if (!(__ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv(i46) | 0)) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[i45 >> 2] | 0;
    }
    HEAPF32[i38 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i38 >> 2]));
    HEAPF32[i28 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i28 >> 2]));
    HEAPF32[i39 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i39 >> 2]));
    HEAP32[i40 >> 2] = 0;
    i1 = i1 + 1 | 0;
    HEAP32[i45 >> 2] = i1;
   } else i1 = HEAP32[i45 >> 2] | 0;
   L78 : do if ((i1 | 0) < (i24 | 0)) do {
    if ((i1 | 0) >= (HEAP32[i41 >> 2] | 0)) break L78;
    i1 = HEAP32[i31 >> 2] | 0;
    i22 = i1 + 60 | 0;
    i23 = i1 + 120 | 0;
    i21 = i1 + 180 | 0;
    HEAP32[i21 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
    _memmove(i23 | 0, i28 | 0, 12) | 0;
    HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 240;
    i1 = HEAP32[i45 >> 2] | 0;
    i23 = HEAP32[i32 >> 2] | 0;
    i22 = HEAP32[i29 >> 2] | 0;
    HEAP32[i23 + (i1 << 3) >> 2] = HEAP32[i28 >> 2];
    HEAP32[i23 + (i1 << 3) + 4 >> 2] = i22;
    i1 = HEAP32[i45 >> 2] | 0;
    HEAPF32[(HEAP32[i33 >> 2] | 0) + (i1 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = Math_fround(0.0);
    i1 = i1 + 1 | 0;
    HEAP32[i45 >> 2] = i1;
   } while ((i1 | 0) < (i24 | 0)); while (0);
   i7 = (HEAP32[i25 >> 2] | 0) + 1 | 0;
   HEAP32[i25 >> 2] = i7;
   if ((i7 | 0) >= (HEAP32[i42 >> 2] | 0)) break L1;
  }
  return i1 | 0;
 } else {
  i3 = i46 + 396 | 0;
  i2 = i46 + 344 | 0;
  i1 = HEAP32[i45 >> 2] | 0;
 } while (0);
 f49 = Math_fround(HEAP32[(HEAP32[i46 + 332 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) + -1 << 5) + 8 >> 2] | 0);
 HEAPF32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = f49;
 i46 = 1;
 return i46 | 0;
}

function __ZN13SpeedTreeWind7AdvanceEbd(i20, i2, d15) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 d15 = +d15;
 var f1 = f0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, d16 = 0.0, f17 = f0, i18 = 0, f19 = f0, i21 = 0;
 i18 = i20 + 1392 | 0;
 d16 = +HEAPF64[i18 >> 3];
 d16 = d16 == -1.0 ? 0.0 : d15 - d16;
 HEAPF64[i18 >> 3] = d15;
 if (!i2) {
  HEAPF32[i20 + 1628 >> 2] = Math_fround(1.0);
  i2 = i20 + 1632 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAPF32[i20 + 1652 >> 2] = Math_fround(1.0);
  HEAPF32[i20 + 1656 >> 2] = Math_fround(1.0);
  HEAPF32[i20 + 1724 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1708 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1712 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1716 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1740 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1744 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1728 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1732 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1756 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1760 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1804 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1808 >> 2] = Math_fround(0.0);
  i2 = i20 + 1772 | 0;
  i5 = i20 + 1820 | 0;
  i6 = i20 + 1764 | 0;
  i7 = i20 + 1660 | 0;
  i8 = i7 + 40 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  HEAPF32[i6 >> 2] = Math_fround(1.0);
  HEAPF32[i20 + 1812 >> 2] = Math_fround(1.0);
  HEAPF32[i20 + 1852 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1856 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1860 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 1864 >> 2] = Math_fround(1.0);
  return;
 }
 if (HEAP8[i20 + 1400 >> 0] | 0) __ZN13SpeedTreeWind4GustEdd(i20, d15, d16);
 d3 = +HEAPF64[i20 + 1520 >> 3];
 d4 = +HEAPF64[i20 + 1512 >> 3];
 if (d3 != d4) {
  d4 = (d15 - d4) / (d3 - d4);
  d4 = d4 > 0.0 ? d4 : 0.0;
  f1 = Math_fround(d4 < 1.0 ? d4 : 1.0);
 } else f1 = Math_fround(1.0);
 f1 = Math_fround(Math_fround(f1 * Math_fround(.5)) + Math_fround(Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(3.0) - Math_fround(f1 * Math_fround(2.0)))) * Math_fround(.5)));
 i18 = f1 < Math_fround(.5);
 f9 = Math_fround(HEAPF32[i20 + 1496 >> 2]);
 f10 = Math_fround(HEAPF32[i20 + 1500 >> 2]);
 f11 = Math_fround(HEAPF32[i20 + 1504 >> 2]);
 if (i18) {
  f19 = Math_fround(f1 * Math_fround(2.0));
  f17 = Math_fround(Math_fround(1.0) - f19);
  f9 = Math_fround(Math_fround(f17 * Math_fround(HEAPF32[i20 + 1528 >> 2])) + Math_fround(f19 * f9));
  f1 = Math_fround(Math_fround(f17 * Math_fround(HEAPF32[i20 + 1532 >> 2])) + Math_fround(f19 * f10));
  f10 = Math_fround(Math_fround(f17 * Math_fround(HEAPF32[i20 + 1536 >> 2])) + Math_fround(f19 * f11));
 } else {
  f19 = Math_fround(Math_fround(f1 + Math_fround(-.5)) * Math_fround(2.0));
  f17 = Math_fround(Math_fround(1.0) - f19);
  f9 = Math_fround(Math_fround(f17 * f9) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1484 >> 2])));
  f1 = Math_fround(Math_fround(f17 * f10) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1488 >> 2])));
  f10 = Math_fround(Math_fround(f17 * f11) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1492 >> 2])));
 }
 HEAPF32[i20 + 1380 >> 2] = f9;
 i6 = i20 + 1384 | 0;
 HEAPF32[i6 >> 2] = f1;
 i7 = i20 + 1388 | 0;
 HEAPF32[i7 >> 2] = f10;
 i8 = i20 + 1380 | 0;
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f1 * f1)) + Math_fround(f10 * f10))));
 if (f11 != Math_fround(0.0)) {
  f9 = Math_fround(f9 / f11);
  HEAPF32[i8 >> 2] = f9;
  f12 = Math_fround(f1 / f11);
  HEAPF32[i6 >> 2] = f12;
  f1 = Math_fround(f10 / f11);
 } else {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i7 >> 2] = f1;
 d3 = +HEAPF64[i20 + 1472 >> 3];
 d4 = +HEAPF64[i20 + 1464 >> 3];
 if (d3 != d4) {
  d15 = (d15 - d4) / (d3 - d4);
  d15 = d15 > 0.0 ? d15 : 0.0;
  f1 = Math_fround(d15 < 1.0 ? d15 : 1.0);
 } else f1 = Math_fround(0.0);
 f19 = Math_fround(HEAPF32[i20 + 1480 >> 2]);
 f10 = Math_fround(Math_fround(f1 * Math_fround(0.0)) + Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(3.0) - Math_fround(f1 * Math_fround(2.0)))));
 f10 = Math_fround(Math_fround(Math_fround(HEAPF32[i20 + 1456 >> 2]) * f10) + Math_fround(f19 * Math_fround(Math_fround(1.0) - f10)));
 HEAPF32[i20 + 1376 >> 2] = f10;
 f10 = Math_fround(Math_fround(HEAPF32[i20 + 1404 >> 2]) + f10);
 i5 = f10 < Math_fround(1.0);
 f10 = i5 ? f10 : Math_fround(1.0);
 i5 = f10 > Math_fround(0.0);
 f10 = i5 ? f10 : Math_fround(0.0);
 f19 = Math_fround(f9 * f10);
 f1 = Math_fround(HEAPF32[i20 + 1280 >> 2]);
 d15 = d16 * +Math_fround(f1 * f19);
 i5 = i20 + 1540 | 0;
 HEAPF32[i5 >> 2] = Math_fround(+Math_fround(HEAPF32[i5 >> 2]) + d15);
 d15 = d16 * +Math_fround(f1 * Math_fround(f12 * f10));
 i5 = i20 + 1544 | 0;
 HEAPF32[i5 >> 2] = Math_fround(+Math_fround(HEAPF32[i5 >> 2]) + d15);
 f1 = Math_fround(f10 * Math_fround(9.0));
 i5 = ~~f1;
 i2 = i5 + 1 | 0;
 if ((i5 | 0) > 8) {
  f19 = Math_fround(0.0);
  i18 = 9;
  i5 = 9;
 } else if ((i5 | 0) < 0) {
  f19 = Math_fround(0.0);
  i18 = 0;
  i5 = 0;
 } else {
  f19 = Math_fround(f1 - Math_fround(i5 | 0));
  i18 = i2;
 }
 f17 = Math_fround(Math_fround(1.0) - f19);
 i2 = 0;
 do {
  f14 = Math_fround(HEAPF32[i20 + 16 + (i2 * 40 | 0) + (i5 << 2) >> 2]);
  f14 = Math_fround(d16 * +Math_fround(Math_fround(f17 * f14) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 16 + (i2 * 40 | 0) + (i18 << 2) >> 2]))));
  HEAPF32[i20 + 1548 + (i2 << 2) >> 2] = f14;
  i21 = i20 + 1588 + (i2 << 2) | 0;
  HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f14);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 10);
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i20 + 1628 >> 2] = i2;
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i20 + 1632 >> 2] = i8;
 i21 = HEAP32[i7 >> 2] | 0;
 HEAP32[i20 + 1636 >> 2] = i21;
 HEAPF32[i20 + 1640 >> 2] = f10;
 f1 = Math_fround(HEAPF32[i20 + 424 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1648 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 424 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1644 >> 2] = HEAP32[i20 + 1588 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 416 >> 2]);
 i7 = f1 != Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 HEAPF32[i20 + 1652 >> 2] = i7 ? f1 : Math_fround(1.0);
 HEAP32[i20 + 1656 >> 2] = HEAP32[i20 + 420 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 464 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1724 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 464 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 504 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1664 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 504 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1660 >> 2] = HEAP32[i20 + 1592 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 636 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1672 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 636 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1668 >> 2] = HEAP32[i20 + 1596 >> 2];
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i20 + 8 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f1 * f1) + Math_fround(f9 * f9)))));
 if (f11 != Math_fround(0.0)) {
  f12 = Math_fround(f1 / f11);
  f9 = Math_fround(f9 / f11);
  f1 = Math_fround(f10 / f11);
 } else {
  f12 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f10 = Math_fround(HEAPF32[i20 + 1332 >> 2]);
 f14 = Math_fround(HEAPF32[i20 + 1344 >> 2]);
 f13 = Math_fround(f12 * f14);
 f11 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f13 = Math_fround(f10 + Math_fround(f13 * f11));
 f9 = Math_fround(Math_fround(HEAPF32[i20 + 1336 >> 2]) + Math_fround(Math_fround(f9 * f14) * f11));
 f1 = Math_fround(Math_fround(Math_fround(f1 * f14) * f11) + Math_fround(HEAPF32[i20 + 1340 >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f9 * f9)) + Math_fround(f1 * f1))));
 if (f11 == Math_fround(0.0)) {
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f12 = f11;
  f10 = Math_fround(f1 / f11);
  f9 = Math_fround(f9 / f11);
  f1 = Math_fround(f13 / f11);
 }
 HEAPF32[i20 + 1708 >> 2] = f1;
 HEAPF32[i20 + 1712 >> 2] = f9;
 HEAPF32[i20 + 1716 >> 2] = f10;
 HEAPF32[i20 + 1720 >> 2] = f12;
 f1 = Math_fround(HEAPF32[i20 + 544 + (i5 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 544 + (i18 << 2) >> 2])));
 i2 = i20 + 1728 | 0;
 HEAPF32[i2 >> 2] = f1;
 if (HEAP8[i20 + 1351 >> 0] | 0) HEAPF32[i2 >> 2] = Math_fround(f1 * f14);
 HEAP32[i20 + 1740 >> 2] = HEAP32[i20 + 624 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 676 + (i5 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 676 + (i18 << 2) >> 2])));
 i2 = i20 + 1732 | 0;
 HEAPF32[i2 >> 2] = f1;
 if (HEAP8[i20 + 1357 >> 0] | 0) HEAPF32[i2 >> 2] = Math_fround(f1 * f14);
 HEAP32[i20 + 1744 >> 2] = HEAP32[i20 + 756 >> 2];
 HEAP32[i20 + 1676 >> 2] = HEAP32[i20 + 628 >> 2];
 HEAP32[i20 + 1680 >> 2] = HEAP32[i20 + 632 >> 2];
 HEAP32[i20 + 1684 >> 2] = HEAP32[i20 + 760 >> 2];
 HEAP32[i20 + 1688 >> 2] = HEAP32[i20 + 764 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 584 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1692 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 584 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 716 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1696 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 716 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1756 >> 2] = HEAP32[i20 + 1600 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 768 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1760 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 768 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1804 >> 2] = HEAP32[i20 + 1612 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 992 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1808 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 992 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1772 >> 2] = HEAP32[i20 + 1604 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 808 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1776 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 808 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 848 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1780 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 848 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 888 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1784 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 888 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1820 >> 2] = HEAP32[i20 + 1616 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 1032 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1824 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1032 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 1072 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1828 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1072 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 1112 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1832 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1112 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 928 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1788 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 928 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 216 + (i5 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 216 + (i18 << 2) >> 2])));
 if (f1 < Math_fround(1.1920929e-07)) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(Math_fround(f1 * Math_fround(HEAPF32[i20 + 968 >> 2])) * Math_fround(10.0));
 }
 HEAPF32[i20 + 1792 >> 2] = f1;
 HEAP32[i20 + 1796 >> 2] = HEAP32[i20 + 1608 >> 2];
 f1 = Math_fround(HEAPF32[i20 + 1152 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1836 >> 2] = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1152 + (i18 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i20 + 336 + (i5 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 336 + (i18 << 2) >> 2])));
 if (f1 < Math_fround(1.1920929e-07)) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(Math_fround(f1 * Math_fround(HEAPF32[i20 + 1192 >> 2])) * Math_fround(10.0));
 }
 HEAPF32[i20 + 1840 >> 2] = f1;
 HEAP32[i20 + 1844 >> 2] = HEAP32[i20 + 1620 >> 2];
 HEAP32[i20 + 1764 >> 2] = HEAP32[i20 + 988 >> 2];
 HEAP32[i20 + 1812 >> 2] = HEAP32[i20 + 1212 >> 2];
 HEAP32[i20 + 1852 >> 2] = HEAP32[i20 + 1624 >> 2];
 f14 = Math_fround(HEAPF32[i20 + 1216 + (i5 << 2) >> 2]);
 HEAPF32[i20 + 1856 >> 2] = Math_fround(Math_fround(f17 * f14) + Math_fround(f19 * Math_fround(HEAPF32[i20 + 1216 + (i18 << 2) >> 2])));
 HEAP32[i20 + 1860 >> 2] = HEAP32[i20 + 1256 >> 2];
 HEAP32[i20 + 1864 >> 2] = HEAP32[i20 + 1260 >> 2];
 return;
}

function __ZN5physx2Gu31generatedCapsuleBoxFaceContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE(i3, i2, i7, i11, i40, i41, i43, i1, i42) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 i43 = i43 | 0;
 i1 = i1 | 0;
 i42 = i42 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i44;
 i35 = i44 + 16 | 0;
 f28 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f28 = Math_fround(f28 + Math_fround(HEAPF32[i1 >> 2]));
 i9 = HEAP32[i11 + 40 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f39 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f17 = Math_fround(f15 * Math_fround(HEAPF32[i9 >> 2]));
 f17 = Math_fround(f17 + Math_fround(f39 * Math_fround(HEAPF32[i9 + 4 >> 2])));
 f17 = Math_fround(f17 + Math_fround(f29 * Math_fround(HEAPF32[i9 + 8 >> 2])));
 f21 = Math_fround(f15 * Math_fround(HEAPF32[i9 + 16 >> 2]));
 f21 = Math_fround(f21 + Math_fround(f39 * Math_fround(HEAPF32[i9 + 20 >> 2])));
 f21 = Math_fround(f21 + Math_fround(f29 * Math_fround(HEAPF32[i9 + 24 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i9 + 32 >> 2]));
 f39 = Math_fround(f15 + Math_fround(f39 * Math_fround(HEAPF32[i9 + 36 >> 2])));
 f29 = Math_fround(f39 + Math_fround(f29 * Math_fround(HEAPF32[i9 + 40 >> 2])));
 f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f21 * f21)) + Math_fround(f29 * f29)))));
 f17 = Math_fround(f17 * f39);
 f21 = Math_fround(f21 * f39);
 f39 = Math_fround(f29 * f39);
 HEAPF32[i6 >> 2] = f17;
 HEAPF32[i6 + 4 >> 2] = f21;
 HEAPF32[i6 + 8 >> 2] = f39;
 HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
 i9 = (HEAP32[i2 + 32 >> 2] | 0) + (HEAPU16[i7 + 16 >> 1] | 0) | 0;
 i23 = HEAP32[i11 + 36 >> 2] | 0;
 i25 = HEAPU8[i9 >> 0] | 0;
 i8 = i2 + 28 | 0;
 i27 = HEAP32[i8 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i27 + (i25 * 12 | 0) >> 2]);
 f15 = Math_fround(HEAPF32[i27 + (i25 * 12 | 0) + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i27 + (i25 * 12 | 0) + 8 >> 2]);
 f16 = Math_fround(f29 * Math_fround(HEAPF32[i23 >> 2]));
 f16 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 16 >> 2])));
 f16 = Math_fround(f16 + Math_fround(f26 * Math_fround(HEAPF32[i23 + 32 >> 2])));
 f18 = Math_fround(f29 * Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(f18 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 20 >> 2])));
 f18 = Math_fround(f18 + Math_fround(f26 * Math_fround(HEAPF32[i23 + 36 >> 2])));
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i23 + 8 >> 2]));
 f15 = Math_fround(f29 + Math_fround(f15 * Math_fround(HEAPF32[i23 + 24 >> 2])));
 f26 = Math_fround(f15 + Math_fround(f26 * Math_fround(HEAPF32[i23 + 40 >> 2])));
 i23 = i3 + 96 | 0;
 f15 = Math_fround(HEAPF32[i23 >> 2]);
 i25 = i3 + 100 | 0;
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 i27 = i3 + 104 | 0;
 f29 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(f15 - f16)) + Math_fround(f21 * Math_fround(f29 - f18))) + Math_fround(f39 * Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f26)));
 i31 = i3 + 112 | 0;
 f15 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i3 + 116 | 0;
 f24 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i3 + 120 | 0;
 f26 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(f15 - f16)) + Math_fround(f21 * Math_fround(f24 - f18))) + Math_fround(f39 * Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f26)));
 f18 = Math_fround(HEAPF32[i42 >> 2]);
 i37 = i42 + 4 | 0;
 f24 = Math_fround(HEAPF32[i37 >> 2]);
 i38 = i42 + 8 | 0;
 f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(f21 * f24)) + Math_fround(f39 * Math_fround(HEAPF32[i38 >> 2]))));
 f29 = Math_fround(f29 * f39);
 f39 = Math_fround(f26 * f39);
 i22 = f28 >= f29;
 i30 = f28 >= f39;
 if (!(i30 | i22)) {
  STACKTOP = i44;
  return;
 }
 __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE(i35, i6);
 i34 = i7 + 18 | 0;
 i2 = HEAPU8[i34 >> 0] | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((i2 << 4) + 16 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i1 + 15 & -16;
 mftCall_viiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i9 | 0, i2 | 0, HEAP32[i8 >> 2] | 0, i36 | 0);
 if (!(HEAP8[i34 >> 0] | 0)) {
  f5 = Math_fround(3402823469999999843913219.0e14);
  f28 = Math_fround(3402823469999999843913219.0e14);
  f26 = Math_fround(-3402823469999999843913219.0e14);
  f24 = Math_fround(-3402823469999999843913219.0e14);
  i1 = 0;
 } else {
  i2 = i35 + 16 | 0;
  i3 = i35 + 32 | 0;
  i6 = i35 + 4 | 0;
  i7 = i35 + 20 | 0;
  i8 = i35 + 36 | 0;
  i9 = i35 + 8 | 0;
  i11 = i35 + 24 | 0;
  i19 = i35 + 40 | 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f12 = Math_fround(-3402823469999999843913219.0e14);
  i20 = 0;
  do {
   i46 = i36 + (i20 << 4) | 0;
   f18 = Math_fround(HEAPF32[i46 >> 2]);
   i45 = i36 + (i20 << 4) + 4 | 0;
   f21 = Math_fround(HEAPF32[i45 >> 2]);
   i1 = i36 + (i20 << 4) + 8 | 0;
   f24 = Math_fround(HEAPF32[i1 >> 2]);
   f26 = Math_fround(f18 * Math_fround(HEAPF32[i35 >> 2]));
   f26 = Math_fround(f26 + Math_fround(f21 * Math_fround(HEAPF32[i2 >> 2])));
   f26 = Math_fround(f26 + Math_fround(f24 * Math_fround(HEAPF32[i3 >> 2])));
   f28 = Math_fround(f18 * Math_fround(HEAPF32[i6 >> 2]));
   f28 = Math_fround(f28 + Math_fround(f21 * Math_fround(HEAPF32[i7 >> 2])));
   f28 = Math_fround(f28 + Math_fround(f24 * Math_fround(HEAPF32[i8 >> 2])));
   f18 = Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2]));
   f21 = Math_fround(f18 + Math_fround(f21 * Math_fround(HEAPF32[i11 >> 2])));
   f24 = Math_fround(f21 + Math_fround(f24 * Math_fround(HEAPF32[i19 >> 2])));
   HEAPF32[i46 >> 2] = f26;
   HEAPF32[i45 >> 2] = f28;
   HEAPF32[i1 >> 2] = f24;
   HEAPF32[i36 + (i20 << 4) + 12 >> 2] = Math_fround(0.0);
   f4 = f4 < f26 ? f4 : f26;
   f5 = f5 < f28 ? f5 : f28;
   f10 = f10 > f26 ? f10 : f26;
   f12 = f12 > f28 ? f12 : f28;
   i20 = i20 + 1 | 0;
   i1 = HEAP8[i34 >> 0] | 0;
  } while (i20 >>> 0 < (i1 & 255) >>> 0);
  f28 = f4;
  f26 = f12;
  f24 = f10;
 }
 L9 : do if (i22) {
  f15 = Math_fround(HEAPF32[i42 >> 2]);
  f16 = Math_fround(HEAPF32[i37 >> 2]);
  f17 = Math_fround(HEAPF32[i38 >> 2]);
  f21 = Math_fround(HEAPF32[i23 >> 2]);
  f18 = Math_fround(HEAPF32[i25 >> 2]);
  f14 = Math_fround(HEAPF32[i27 >> 2]);
  f15 = Math_fround(f21 - Math_fround(f29 * f15));
  f16 = Math_fround(f18 - Math_fround(f29 * f16));
  f17 = Math_fround(f14 - Math_fround(f29 * f17));
  f12 = Math_fround(f15 * Math_fround(HEAPF32[i35 >> 2]));
  f12 = Math_fround(f12 + Math_fround(f16 * Math_fround(HEAPF32[i35 + 16 >> 2])));
  f12 = Math_fround(f12 + Math_fround(f17 * Math_fround(HEAPF32[i35 + 32 >> 2])));
  f13 = Math_fround(f15 * Math_fround(HEAPF32[i35 + 4 >> 2]));
  f13 = Math_fround(f13 + Math_fround(f16 * Math_fround(HEAPF32[i35 + 20 >> 2])));
  f13 = Math_fround(f13 + Math_fround(f17 * Math_fround(HEAPF32[i35 + 36 >> 2])));
  i6 = i1 & 255;
  if (!(i1 << 24 >> 24 == 0 | (f28 > f12 | f12 > f24 | (f5 > f13 | f13 > f26)))) {
   i2 = i6 + -1 | 0;
   f10 = Math_fround(HEAPF32[i36 + (i2 << 4) + 4 >> 2]);
   i3 = 0;
   i1 = 0;
   while (1) {
    f4 = f10;
    f10 = Math_fround(HEAPF32[i36 + (i3 << 4) + 4 >> 2]);
    if (f4 > f13 ^ f10 > f13) {
     f48 = Math_fround(HEAPF32[i36 + (i2 << 4) >> 2]);
     f49 = Math_fround(f10 - f4);
     f47 = Math_fround(f12 * f49);
     i46 = f49 > Math_fround(0.0);
     f4 = Math_fround(Math_fround(f49 * Math_fround(f48 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f13 - f4) * Math_fround(Math_fround(HEAPF32[i36 + (i3 << 4) >> 2]) - f48)));
     if ((i46 ? f4 : f47) >= (i46 ? f47 : f4)) {
      if ((i1 | 0) == 1) break L9;
      i1 = i1 + 1 | 0;
     }
    }
    i2 = i3 + 1 | 0;
    if (i2 >>> 0 >= i6 >>> 0) break; else {
     i46 = i3;
     i3 = i2;
     i2 = i46;
    }
   }
   if (i1 | 0) {
    i46 = HEAP32[i43 >> 2] | 0;
    f13 = Math_fround(HEAPF32[i40 + 48 >> 2]);
    f49 = Math_fround(HEAPF32[i40 + 52 >> 2]);
    f13 = Math_fround(f21 - f13);
    f21 = Math_fround(f18 - f49);
    f49 = Math_fround(f14 - Math_fround(HEAPF32[i40 + 56 >> 2]));
    f47 = Math_fround(f13 * Math_fround(HEAPF32[i40 >> 2]));
    f47 = Math_fround(f47 + Math_fround(f21 * Math_fround(HEAPF32[i40 + 4 >> 2])));
    f47 = Math_fround(f47 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 8 >> 2])));
    f48 = Math_fround(f13 * Math_fround(HEAPF32[i40 + 16 >> 2]));
    f48 = Math_fround(f48 + Math_fround(f21 * Math_fround(HEAPF32[i40 + 20 >> 2])));
    f48 = Math_fround(f48 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 24 >> 2])));
    f18 = Math_fround(f13 * Math_fround(HEAPF32[i40 + 32 >> 2]));
    f21 = Math_fround(f18 + Math_fround(f21 * Math_fround(HEAPF32[i40 + 36 >> 2])));
    f49 = Math_fround(f21 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 40 >> 2])));
    HEAPF32[i41 + (i46 * 48 | 0) >> 2] = f47;
    HEAPF32[i41 + (i46 * 48 | 0) + 4 >> 2] = f48;
    HEAPF32[i41 + (i46 * 48 | 0) + 8 >> 2] = f49;
    HEAPF32[i41 + (i46 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
    i46 = HEAP32[i43 >> 2] | 0;
    HEAPF32[i41 + (i46 * 48 | 0) + 16 >> 2] = f15;
    HEAPF32[i41 + (i46 * 48 | 0) + 20 >> 2] = f16;
    HEAPF32[i41 + (i46 * 48 | 0) + 24 >> 2] = f17;
    HEAPF32[i41 + (i46 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
    i46 = HEAP32[i43 >> 2] | 0;
    HEAP32[i43 >> 2] = i46 + 1;
    i27 = HEAP32[i37 >> 2] | 0;
    i45 = HEAP32[i38 >> 2] | 0;
    HEAP32[i41 + (i46 * 48 | 0) + 32 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i41 + (i46 * 48 | 0) + 36 >> 2] = i27;
    HEAP32[i41 + (i46 * 48 | 0) + 40 >> 2] = i45;
    HEAPF32[i41 + (i46 * 48 | 0) + 44 >> 2] = f29;
   }
  }
 } while (0);
 L22 : do if (i30) {
  f14 = Math_fround(HEAPF32[i42 >> 2]);
  f15 = Math_fround(HEAPF32[i37 >> 2]);
  f16 = Math_fround(HEAPF32[i38 >> 2]);
  f18 = Math_fround(HEAPF32[i31 >> 2]);
  f17 = Math_fround(HEAPF32[i32 >> 2]);
  f13 = Math_fround(HEAPF32[i33 >> 2]);
  f14 = Math_fround(f18 - Math_fround(f39 * f14));
  f15 = Math_fround(f17 - Math_fround(f39 * f15));
  f16 = Math_fround(f13 - Math_fround(f39 * f16));
  f12 = Math_fround(f14 * Math_fround(HEAPF32[i35 >> 2]));
  f12 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i35 + 16 >> 2])));
  f12 = Math_fround(f12 + Math_fround(f16 * Math_fround(HEAPF32[i35 + 32 >> 2])));
  f10 = Math_fround(f14 * Math_fround(HEAPF32[i35 + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f15 * Math_fround(HEAPF32[i35 + 20 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f16 * Math_fround(HEAPF32[i35 + 36 >> 2])));
  i46 = HEAP8[i34 >> 0] | 0;
  i6 = i46 & 255;
  if (!(i46 << 24 >> 24 == 0 | (f28 > f12 | f12 > f24 | (f5 > f10 | f10 > f26)))) {
   i2 = i6 + -1 | 0;
   f5 = Math_fround(HEAPF32[i36 + (i2 << 4) + 4 >> 2]);
   i3 = 0;
   i1 = 0;
   while (1) {
    f4 = f5;
    f5 = Math_fround(HEAPF32[i36 + (i3 << 4) + 4 >> 2]);
    if (f4 > f10 ^ f5 > f10) {
     f49 = Math_fround(HEAPF32[i36 + (i2 << 4) >> 2]);
     f47 = Math_fround(f5 - f4);
     f48 = Math_fround(f12 * f47);
     i46 = f47 > Math_fround(0.0);
     f49 = Math_fround(Math_fround(f47 * Math_fround(f49 + Math_fround(1.1920929e-07))) + Math_fround(Math_fround(f10 - f4) * Math_fround(Math_fround(HEAPF32[i36 + (i3 << 4) >> 2]) - f49)));
     if ((i46 ? f49 : f48) >= (i46 ? f48 : f49)) {
      if ((i1 | 0) == 1) break L22;
      i1 = i1 + 1 | 0;
     }
    }
    i2 = i3 + 1 | 0;
    if (i2 >>> 0 >= i6 >>> 0) break; else {
     i46 = i3;
     i3 = i2;
     i2 = i46;
    }
   }
   if (i1 | 0) {
    i46 = HEAP32[i43 >> 2] | 0;
    f28 = Math_fround(HEAPF32[i40 + 48 >> 2]);
    f29 = Math_fround(HEAPF32[i40 + 52 >> 2]);
    f28 = Math_fround(f18 - f28);
    f29 = Math_fround(f17 - f29);
    f49 = Math_fround(f13 - Math_fround(HEAPF32[i40 + 56 >> 2]));
    f47 = Math_fround(f28 * Math_fround(HEAPF32[i40 >> 2]));
    f47 = Math_fround(f47 + Math_fround(f29 * Math_fround(HEAPF32[i40 + 4 >> 2])));
    f47 = Math_fround(f47 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 8 >> 2])));
    f48 = Math_fround(f28 * Math_fround(HEAPF32[i40 + 16 >> 2]));
    f48 = Math_fround(f48 + Math_fround(f29 * Math_fround(HEAPF32[i40 + 20 >> 2])));
    f48 = Math_fround(f48 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 24 >> 2])));
    f28 = Math_fround(f28 * Math_fround(HEAPF32[i40 + 32 >> 2]));
    f29 = Math_fround(f28 + Math_fround(f29 * Math_fround(HEAPF32[i40 + 36 >> 2])));
    f49 = Math_fround(f29 + Math_fround(f49 * Math_fround(HEAPF32[i40 + 40 >> 2])));
    HEAPF32[i41 + (i46 * 48 | 0) >> 2] = f47;
    HEAPF32[i41 + (i46 * 48 | 0) + 4 >> 2] = f48;
    HEAPF32[i41 + (i46 * 48 | 0) + 8 >> 2] = f49;
    HEAPF32[i41 + (i46 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
    i46 = HEAP32[i43 >> 2] | 0;
    HEAPF32[i41 + (i46 * 48 | 0) + 16 >> 2] = f14;
    HEAPF32[i41 + (i46 * 48 | 0) + 20 >> 2] = f15;
    HEAPF32[i41 + (i46 * 48 | 0) + 24 >> 2] = f16;
    HEAPF32[i41 + (i46 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
    i46 = HEAP32[i43 >> 2] | 0;
    HEAP32[i43 >> 2] = i46 + 1;
    i43 = HEAP32[i37 >> 2] | 0;
    i45 = HEAP32[i38 >> 2] | 0;
    HEAP32[i41 + (i46 * 48 | 0) + 32 >> 2] = HEAP32[i42 >> 2];
    HEAP32[i41 + (i46 * 48 | 0) + 36 >> 2] = i43;
    HEAP32[i41 + (i46 * 48 | 0) + 40 >> 2] = i45;
    HEAPF32[i41 + (i46 * 48 | 0) + 44 >> 2] = f39;
   }
  }
 } while (0);
 STACKTOP = i44;
 return;
}

function __ZN11ShapeModule16UpdateCachedMeshEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 L1 : do switch (HEAP32[i10 + 8 >> 2] | 0) {
 case 14:
  {
   i5 = i10 + 52 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i8 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 8; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 10;
    }
    if ((i9 | 0) == 8) i9 = 10;
    if ((i9 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 16; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 18;
     }
    }
    if ((i9 | 0) == 16) i9 = 18;
    if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i2 = i10 + 72 | 0;
    HEAP32[i2 >> 2] = __ZN19SkinnedMeshRenderer7GetMeshEv(i1) | 0;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 24; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i8 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 24; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 26;
     }
    }
    if ((i9 | 0) == 24) i9 = 26;
    if ((i9 | 0) == 26) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    __ZN12BaseRenderer12GetLocalAABBER4AABB(i1 + 32 | 0, i10 + 76 | 0);
    break L1;
   } while (0);
   i2 = i10 + 72 | 0;
   HEAP32[i2 >> 2] = 0;
   i9 = i10 + 76 | 0;
   HEAP32[i9 >> 2] = HEAP32[gb + 1155204 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
   break;
  }
 case 13:
  {
   i5 = i10 + 48 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i8 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 35; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 35; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 37;
    }
    if ((i9 | 0) == 35) i9 = 37;
    if ((i9 | 0) == 37) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 43; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 43; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 45;
     }
    }
    if ((i9 | 0) == 43) i9 = 45;
    if ((i9 | 0) == 45) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i4 = __ZNK12MeshRenderer13GetSharedMeshEv(i1) | 0;
    if (!i4) i1 = 0; else {
     HEAP32[i8 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i9 = 52; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
       i2 = HEAP32[i7 >> 2] | 0;
       i6 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 52; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i9 = 54;
      }
     }
     if ((i9 | 0) == 52) i9 = 54;
     if ((i9 | 0) == 54) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
    i2 = i10 + 72 | 0;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 61; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i8 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 61; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 63;
     }
    }
    if ((i9 | 0) == 61) i9 = 63;
    if ((i9 | 0) == 63) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    __ZN12BaseRenderer12GetLocalAABBER4AABB(i1 + 32 | 0, i10 + 76 | 0);
    break L1;
   } while (0);
   i2 = i10 + 72 | 0;
   HEAP32[i2 >> 2] = 0;
   i9 = i10 + 76 | 0;
   HEAP32[i9 >> 2] = HEAP32[gb + 1155204 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
   break;
  }
 default:
  {
   i6 = i10 + 44 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   do if (!i1) {
    i1 = i10 + 72 | 0;
    HEAP32[i1 >> 2] = 0;
    i3 = i10 + 76 | 0;
    i2 = gb + 1155204 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 73; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 73; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 75; else i2 = i1;
     }
    }
    if ((i9 | 0) == 73) i9 = 75;
    if ((i9 | 0) == 75) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i1 = i10 + 72 | 0;
    HEAP32[i1 >> 2] = i2;
    i3 = i10 + 76 | 0;
    if (!i4) i2 = gb + 1155204 | 0; else {
     HEAP32[i8 >> 2] = i4;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i9 = 82; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i4 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
       i4 = HEAP32[i7 >> 2] | 0;
       i12 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i4 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i9 = 82; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 84;
     }
     if ((i9 | 0) == 82) i9 = 84;
     if ((i9 | 0) == 84) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
      i2 = gb + 1155204 | 0;
      break;
     }
     HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i9 = 90; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i4 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
       i4 = HEAP32[i7 >> 2] | 0;
       i12 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i4 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i9 = 90; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i9 = 92;
      }
     }
     if ((i9 | 0) == 90) i9 = 92;
     if ((i9 | 0) == 92) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     i2 = (HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 128 >> 2] | 0) + 8 | 0;
    }
   } while (0);
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i2 = i1;
  }
 } while (0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN11ShapeModule17DidModifyMeshDataEv(i10);
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 124 | 0;
 i4 = i1 + 232 | 0;
 if ((i3 | 0) != (i4 | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i10 + 128 | 0; else {
   i12 = i10 + 128 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[HEAP32[i12 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = i12;
  }
  i12 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i12;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i12 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i12 = i10 + 56 | 0;
 i8 = (__ZNK4Mesh15GetSubMeshCountEv(i1) | 0) + -1 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i9 | 0) < 0 ? 0 : (i9 | 0) > (i8 | 0) ? i8 : i9;
 __ZN11ShapeModule17DidModifyMeshDataEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN13AvatarBuilder23IsValidHumanDescriptionERK16HumanDescriptionRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEEb(i34, i39, i1) {
 i34 = i34 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i41 + 32 | 0;
 i33 = i41 + 16 | 0;
 i31 = i41 + 8 | 0;
 i2 = i41;
 i40 = i41 + 136 | 0;
 i27 = i41 + 120 | 0;
 i28 = i41 + 56 | 0;
 i29 = i41 + 44 | 0;
 i30 = i41 + 104 | 0;
 i32 = i41 + 88 | 0;
 i36 = i41 + 72 | 0;
 i35 = i34 + 4 | 0;
 if (i1) if ((HEAP32[i35 >> 2] | 0) == (HEAP32[i34 >> 2] | 0)) {
  __Z6FormatPKcz(i40, gb + 913002 | 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i39, i40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i40);
  i40 = 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 i13 = i29 + 11 | 0;
 i14 = i29 + 4 | 0;
 i15 = i28 + 12 | 0;
 i11 = i28 + 12 | 0;
 i16 = i40 + 4 | 0;
 i17 = i28 + 8 | 0;
 i18 = i28 + 4 | 0;
 i19 = i28 + 11 | 0;
 i20 = i27 + 12 | 0;
 i12 = i27 + 12 | 0;
 i21 = i40 + 4 | 0;
 i22 = i27 + 8 | 0;
 i23 = i27 + 4 | 0;
 i24 = i27 + 11 | 0;
 i25 = i40 + 4 | 0;
 i26 = i40 + 4 | 0;
 i1 = 0;
 do {
  if (__ZN7mecanim5human12RequiredBoneEj(i1) | 0) {
   i2 = HEAP32[i34 >> 2] | 0;
   i10 = HEAP32[i35 >> 2] | 0;
   i5 = __ZN7mecanim5human8BoneNameEj(i1) | 0;
   HEAP32[i29 >> 2] = 0;
   HEAP32[i29 + 4 >> 2] = 0;
   HEAP32[i29 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i29, i5, _strlen(i5) | 0);
   i5 = HEAP8[i13 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i29 >> 2] | 0 : i29;
   i5 = i3 ? HEAP32[i14 >> 2] | 0 : i5 & 255;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i28 + 4 >> 2] = 0;
   HEAP32[i28 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i15 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i28);
    i3 = HEAP32[i11 >> 2] | 0;
    i37 = 11;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i19 >> 0] = i5;
    if (!i5) i3 = i28; else {
     i3 = i28;
     i37 = 13;
    }
   } else i37 = 11;
   if ((i37 | 0) == 11) {
    i9 = i5 + 16 & -16;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i16 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i40, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i28 >> 2] = i3;
    HEAP32[i17 >> 2] = i9 | -2147483648;
    HEAP32[i18 >> 2] = i5;
    i37 = 13;
   }
   if ((i37 | 0) == 13) {
    i37 = 0;
    _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i5 = HEAP8[i19 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i28 >> 2] | 0 : i28;
   i5 = i3 ? HEAP32[i18 >> 2] | 0 : i5 & 255;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 0;
   HEAP32[i27 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i20 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
    i3 = HEAP32[i12 >> 2] | 0;
    i37 = 17;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i24 >> 0] = i5;
    if (!i5) i3 = i27; else {
     i3 = i27;
     i37 = 19;
    }
   } else i37 = 17;
   if ((i37 | 0) == 17) {
    i9 = i5 + 16 & -16;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i21 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i40, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i27 >> 2] = i3;
    HEAP32[i22 >> 2] = i9 | -2147483648;
    HEAP32[i23 >> 2] = i5;
    i37 = 19;
   }
   if ((i37 | 0) == 19) {
    i37 = 0;
    _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i9 = HEAP8[i24 >> 0] | 0;
   L28 : do if ((i2 | 0) != (i10 | 0)) {
    i4 = i9 << 24 >> 24 < 0;
    i5 = i9 & 255;
    i6 = HEAP32[i23 >> 2] | 0;
    i8 = i4 ? i6 : i5;
    i7 = HEAP32[i27 >> 2] | 0;
    if (i4) while (1) {
     i3 = i2 + 16 | 0;
     i5 = HEAP8[i3 + 11 >> 0] | 0;
     i4 = i5 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i4 ? HEAP32[i2 + 20 >> 2] | 0 : i5 & 255) | 0)) if (!(_strncmp(i7, i4 ? HEAP32[i3 >> 2] | 0 : i3, i6) | 0)) break L28;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i10 | 0)) {
      i2 = i10;
      break;
     }
    } else while (1) {
     i3 = i2 + 16 | 0;
     i7 = HEAP8[i3 + 11 >> 0] | 0;
     i4 = i7 << 24 >> 24 < 0;
     if ((i8 | 0) == ((i4 ? HEAP32[i2 + 20 >> 2] | 0 : i7 & 255) | 0)) if (!(_strncmp(i27, i4 ? HEAP32[i3 >> 2] | 0 : i3, i5) | 0)) break L28;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i10 | 0)) {
      i2 = i10;
      break;
     }
    }
   } while (0);
   if (i9 << 24 >> 24 < 0) {
    i10 = HEAP32[i27 >> 2] | 0;
    i9 = HEAP32[i12 >> 2] | 0;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i25 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i40);
   }
   if ((HEAP8[i19 >> 0] | 0) < 0) {
    i10 = HEAP32[i28 >> 2] | 0;
    i9 = HEAP32[i11 >> 2] | 0;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i26 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i40);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
   if ((i2 | 0) == (HEAP32[i35 >> 2] | 0)) {
    i37 = 33;
    break;
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < 24);
 if ((i37 | 0) == 33) {
  i38 = __ZN7mecanim5human8BoneNameEj(i1) | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i30, i38, _strlen(i38) | 0);
  HEAP32[i31 >> 2] = (HEAP8[i30 + 11 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30;
  __Z6FormatPKcz(i40, gb + 913050 | 0, i31);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i39, i40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i40);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
  i40 = 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 i7 = HEAP32[i35 >> 2] | 0;
 i4 = HEAP32[i34 >> 2] | 0;
 i2 = i4;
 i6 = i7;
 L53 : do if ((i7 - i4 | 0) > 0) {
  i12 = i32 + 12 | 0;
  i11 = i32 + 12 | 0;
  i13 = i40 + 4 | 0;
  i14 = i32 + 8 | 0;
  i15 = i32 + 4 | 0;
  i16 = i32 + 11 | 0;
  i17 = i40 + 4 | 0;
  i18 = 0;
  i10 = i2;
  i3 = i6;
  i1 = i7;
  i8 = i6;
  i5 = i2;
  i9 = i7;
  while (1) {
   i6 = HEAP8[i10 + (i18 * 76 | 0) + 11 >> 0] | 0;
   if (i6 << 24 >> 24 < 0) i6 = HEAP32[i10 + (i18 * 76 | 0) + 4 >> 2] | 0; else i6 = i6 & 255;
   if (!i6) i6 = i9; else {
    i2 = i10 + (i18 * 76 | 0) + 76 | 0;
    i4 = i10 + (i18 * 76 | 0) + 16 | 0;
    i5 = HEAP8[i4 + 11 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i4 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
    i5 = i1 ? HEAP32[i10 + (i18 * 76 | 0) + 20 >> 2] | 0 : i5 & 255;
    HEAP32[i32 >> 2] = 0;
    HEAP32[i32 + 4 >> 2] = 0;
    HEAP32[i32 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i12 >> 2] = i1;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i32);
     i1 = HEAP32[i11 >> 2] | 0;
     i37 = 44;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i16 >> 0] = i5;
     if (!i5) i1 = i32; else {
      i1 = i32;
      i37 = 46;
     }
    } else i37 = 44;
    if ((i37 | 0) == 44) {
     i31 = i5 + 16 & -16;
     HEAP32[i40 >> 2] = 66;
     HEAP32[i13 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i31, 16, i40, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i32 >> 2] = i1;
     HEAP32[i14 >> 2] = i31 | -2147483648;
     HEAP32[i15 >> 2] = i5;
     i37 = 46;
    }
    if ((i37 | 0) == 46) {
     i37 = 0;
     _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i1 + i5 >> 0] = 0;
    i9 = HEAP8[i16 >> 0] | 0;
    L72 : do if ((i2 | 0) != (i3 | 0)) {
     i31 = i9 << 24 >> 24 < 0;
     i5 = i9 & 255;
     i6 = HEAP32[i15 >> 2] | 0;
     i8 = i31 ? i6 : i5;
     i7 = HEAP32[i32 >> 2] | 0;
     if (i31) do {
      i1 = i2 + 16 | 0;
      i31 = HEAP8[i1 + 11 >> 0] | 0;
      i4 = i31 << 24 >> 24 < 0;
      if ((i8 | 0) == ((i4 ? HEAP32[i2 + 20 >> 2] | 0 : i31 & 255) | 0)) if (!(_strncmp(i7, i4 ? HEAP32[i1 >> 2] | 0 : i1, i6) | 0)) {
       i3 = i2;
       break L72;
      }
      i2 = i2 + 76 | 0;
     } while ((i2 | 0) != (i3 | 0)); else do {
      i1 = i2 + 16 | 0;
      i31 = HEAP8[i1 + 11 >> 0] | 0;
      i4 = i31 << 24 >> 24 < 0;
      if ((i8 | 0) == ((i4 ? HEAP32[i2 + 20 >> 2] | 0 : i31 & 255) | 0)) if (!(_strncmp(i32, i4 ? HEAP32[i1 >> 2] | 0 : i1, i5) | 0)) {
       i3 = i2;
       break L72;
      }
      i2 = i2 + 76 | 0;
     } while ((i2 | 0) != (i3 | 0));
    } while (0);
    if (i9 << 24 >> 24 < 0) {
     i31 = HEAP32[i32 >> 2] | 0;
     i30 = HEAP32[i11 >> 2] | 0;
     HEAP32[i40 >> 2] = 66;
     HEAP32[i17 >> 2] = i30;
     __Z19free_alloc_internalPvRK10MemLabelId(i31, i40);
    }
    i31 = HEAP32[i35 >> 2] | 0;
    i6 = i31;
    if ((i3 | 0) != (i31 | 0)) break;
    i4 = HEAP32[i34 >> 2] | 0;
    i2 = i4;
    i7 = i6;
    i1 = i6;
    i8 = i3;
    i5 = i2;
   }
   i3 = i18 + 1 | 0;
   if ((i3 | 0) < ((i7 - i4 | 0) / 76 | 0 | 0)) {
    i18 = i3;
    i10 = i4;
    i3 = i7;
    i9 = i6;
   } else {
    i3 = i6;
    i6 = i8;
    break L53;
   }
  }
  i2 = HEAP32[i34 >> 2] | 0;
  i1 = i2 + (i18 * 76 | 0) + 16 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  i1 = i2 + (i18 * 76 | 0) | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i33 >> 2] = i4;
  HEAP32[i33 + 4 >> 2] = i3;
  HEAP32[i33 + 8 >> 2] = i1;
  __Z6FormatPKcz(i40, gb + 913085 | 0, i33);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i39, i40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i40);
  i40 = 0;
  STACKTOP = i41;
  return i40 | 0;
 } else {
  i3 = i7;
  i1 = i7;
  i5 = i2;
 } while (0);
 if ((i3 - i4 | 0) <= 0) {
  i40 = 1;
  STACKTOP = i41;
  return i40 | 0;
 }
 i9 = i36 + 12 | 0;
 i8 = i36 + 12 | 0;
 i10 = i40 + 4 | 0;
 i11 = i36 + 8 | 0;
 i12 = i36 + 4 | 0;
 i13 = i36 + 11 | 0;
 i14 = i40 + 4 | 0;
 i15 = 0;
 i7 = i2;
 while (1) {
  i2 = HEAP8[i7 + (i15 * 76 | 0) + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i7 + (i15 * 76 | 0) + 4 >> 2] | 0; else i2 = i2 & 255;
  if (i2) {
   i3 = i5 + (i15 * 76 | 0) | 0;
   i2 = i3 + 76 | 0;
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i1 ? HEAP32[i5 + (i15 * 76 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i36 >> 2] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   HEAP32[i36 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i9 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i36);
    i1 = HEAP32[i8 >> 2] | 0;
    i37 = 77;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i13 >> 0] = i4;
    if (!i4) i1 = i36; else {
     i1 = i36;
     i37 = 79;
    }
   } else i37 = 77;
   if ((i37 | 0) == 77) {
    i33 = i4 + 16 & -16;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i10 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i33, 16, i40, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i36 >> 2] = i1;
    HEAP32[i11 >> 2] = i33 | -2147483648;
    HEAP32[i12 >> 2] = i4;
    i37 = 79;
   }
   if ((i37 | 0) == 79) {
    i37 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i5 = HEAP8[i13 >> 0] | 0;
   L126 : do if ((i2 | 0) == (i6 | 0)) i2 = i6; else {
    i3 = i5 & 255;
    if (i5 << 24 >> 24 >= 0) {
     i1 = i2;
     while (1) {
      i33 = HEAP8[i1 + 11 >> 0] | 0;
      i2 = i33 << 24 >> 24 < 0;
      if ((i3 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i33 & 255) | 0)) if (!(_strncmp(i36, i2 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0)) {
       i2 = i1;
       break L126;
      }
      i1 = i1 + 76 | 0;
      if ((i1 | 0) == (i6 | 0)) {
       i2 = i6;
       break L126;
      }
     }
    }
    i3 = HEAP32[i12 >> 2] | 0;
    i4 = HEAP32[i36 >> 2] | 0;
    while (1) {
     i33 = HEAP8[i2 + 11 >> 0] | 0;
     i1 = i33 << 24 >> 24 < 0;
     if ((i3 | 0) == ((i1 ? HEAP32[i2 + 4 >> 2] | 0 : i33 & 255) | 0)) if (!(_strncmp(i4, i1 ? HEAP32[i2 >> 2] | 0 : i2, i3) | 0)) break L126;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i6 | 0)) {
      i2 = i6;
      break;
     }
    }
   } while (0);
   if (i5 << 24 >> 24 < 0) {
    i33 = HEAP32[i36 >> 2] | 0;
    i32 = HEAP32[i8 >> 2] | 0;
    HEAP32[i40 >> 2] = 66;
    HEAP32[i14 >> 2] = i32;
    __Z19free_alloc_internalPvRK10MemLabelId(i33, i40);
   }
   i1 = HEAP32[i35 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) break;
   i4 = HEAP32[i34 >> 2] | 0;
  }
  i2 = i15 + 1 | 0;
  i3 = i4;
  if ((i2 | 0) < ((i1 - i4 | 0) / 76 | 0 | 0)) {
   i15 = i2;
   i7 = i3;
   i5 = i3;
   i6 = i1;
  } else {
   i1 = 1;
   i37 = 104;
   break;
  }
 }
 if ((i37 | 0) == 104) {
  STACKTOP = i41;
  return i1 | 0;
 }
 i3 = HEAP32[i34 >> 2] | 0;
 i1 = i3 + (i15 * 76 | 0) | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
 i1 = i3 + (i15 * 76 | 0) + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i38 >> 2] = i4;
 HEAP32[i38 + 4 >> 2] = i2;
 HEAP32[i38 + 8 >> 2] = i1;
 __Z6FormatPKcz(i40, gb + 913146 | 0, i38);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i39, i40) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i40);
 i40 = 0;
 STACKTOP = i41;
 return i40 | 0;
}

function __ZN14CompressedMesh8CompressERK4MeshRK21CompressedMeshQuality(i22, i11, i12) {
 i22 = i22 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i26;
 i23 = i26 + 144 | 0;
 i24 = i26 + 124 | 0;
 i25 = i26 + 104 | 0;
 i13 = i11 + 32 | 0;
 i20 = HEAP32[i13 >> 2] | 0;
 i21 = HEAP32[i20 + 100 >> 2] | 0;
 i1 = i20 + 8 | 0;
 i4 = HEAP16[i1 >> 1] | 0;
 __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i22, (HEAP32[i20 + 92 >> 2] | 0) + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i1 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, 3, HEAPU8[i1 + 32 + ((i4 & 255) * 12 | 0) + 10 >> 0] | 0, i21, HEAP32[i12 >> 2] | 0, 0);
 i4 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i4 + 112 >> 2] | 0;
 i4 = (HEAP32[i4 + 116 >> 2] | 0) - i1 | 0;
 __ZN15PackedIntVector8PackIntsItEEvPT_i(i22 + 220 | 0, (i4 | 0) == 0 ? 0 : i1, (i4 | 0) / 2 | 0);
 i4 = i22 + 240 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!(HEAP8[i1 + 23 >> 0] | 0)) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = (HEAPU16[i1 + 22 >> 1] | 0) >>> 8 & 65535;
  i3 = i1 + -1 | 4;
  HEAP32[i4 >> 2] = i3;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 27 >> 0] | 0) {
  i20 = (HEAPU16[i2 + 26 >> 1] | 0) >>> 8 & 65535;
  i3 = (i20 << 4) + -16 | i3 | 64;
  HEAP32[i4 >> 2] = i3;
  i1 = i20 + i1 | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 31 >> 0] | 0) {
  i20 = (HEAPU16[i2 + 30 >> 1] | 0) >>> 8 & 65535;
  i3 = (i20 << 8) + -256 | i3 | 1024;
  HEAP32[i4 >> 2] = i3;
  i1 = i20 + i1 | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 35 >> 0] | 0) {
  i20 = (HEAPU16[i2 + 34 >> 1] | 0) >>> 8 & 65535;
  HEAP32[i4 >> 2] = (i20 << 12) + -4096 | i3 | 16384;
  i1 = i20 + i1 | 0;
 }
 i1 = Math_imul(i1, i21) | 0;
 i3 = i24 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = i1;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
 i2 = i14;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i20;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i24 >> 2] = i1;
 i4 = i23 + 1 | 0;
 i5 = i14 + 88 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!(HEAP8[i2 + 23 >> 0] | 0)) i1 = 0; else {
  i18 = (HEAPU16[i2 + 22 >> 1] | 0) >>> 8;
  i17 = HEAP32[i2 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i14);
  HEAP8[i23 >> 0] = 0;
  HEAP8[i4 >> 0] = i18;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i14, i1, i17, 3, i23);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i17, HEAP32[i5 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 8 | 0, i14);
  i1 = Math_imul(i18 & 65535, i21) | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 27 >> 0] | 0) {
  i18 = (HEAPU16[i2 + 26 >> 1] | 0) >>> 8;
  i16 = (HEAP32[i24 >> 2] | 0) + (i1 << 2) | 0;
  i17 = HEAP32[i2 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i14);
  HEAP8[i23 >> 0] = 0;
  HEAP8[i4 >> 0] = i18;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i14, i16, i17, 4, i23);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i17, HEAP32[i5 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 8 | 0, i14);
  i1 = (Math_imul(i18 & 65535, i21) | 0) + i1 | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 31 >> 0] | 0) {
  i18 = (HEAPU16[i2 + 30 >> 1] | 0) >>> 8;
  i16 = (HEAP32[i24 >> 2] | 0) + (i1 << 2) | 0;
  i17 = HEAP32[i2 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i14);
  HEAP8[i23 >> 0] = 0;
  HEAP8[i4 >> 0] = i18;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i14, i16, i17, 5, i23);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i17, HEAP32[i5 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 8 | 0, i14);
  i1 = (Math_imul(i18 & 65535, i21) | 0) + i1 | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i2 + 35 >> 0] | 0) {
  i16 = (HEAPU16[i2 + 34 >> 1] | 0) >>> 8;
  i17 = (HEAP32[i24 >> 2] | 0) + (i1 << 2) | 0;
  i18 = HEAP32[i2 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i14);
  HEAP8[i23 >> 0] = 0;
  HEAP8[i4 >> 0] = i16;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i14, i17, i18, 6, i23);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i18, HEAP32[i5 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 8 | 0, i14);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i22 + 28 | 0, HEAP32[i24 >> 2] | 0, i1, 1, 1, HEAP32[i12 + 8 >> 2] | 0, 1);
 i1 = HEAP32[i13 >> 2] | 0;
 if (HEAP8[i1 + 15 >> 0] | 0) {
  HEAP32[i23 + 12 >> 2] = i21;
  i8 = i23 + 16 | 0;
  HEAP32[i8 >> 2] = i21;
  i9 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i3 = i14;
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i9;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i23 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 << 3, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i25 + 12 >> 2] = i21;
  i5 = i25 + 16 | 0;
  HEAP32[i5 >> 2] = i21;
  i6 = i25 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i3 = i14;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = i6;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 << 2, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i25 >> 2] = i7;
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = i2 + 8 | 0;
  i18 = HEAP16[i2 + 14 >> 1] | 0;
  if ((i18 & 65535) < 768 | (i18 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
   } else if (!(HEAP8[i2 + 15 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i18 = HEAP16[i2 + 12 >> 1] | 0;
    i1 = i1 + (((i18 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i18 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  i4 = HEAP32[i23 >> 2] | 0;
  if ((i21 | 0) > 0) {
   i2 = 0;
   while (1) {
    HEAP32[i4 + (i2 << 3) >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + (i2 << 3) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + (i2 << 2) >> 2] = Math_fround(HEAPF32[i1 + 8 >> 2]) > Math_fround(0.0) & 1;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i21 | 0)) break; else i1 = i1 + i3 | 0;
   }
  }
  __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i22 + 56 | 0, i4, 2, 8, i21, HEAP32[i12 + 4 >> 2] | 0, 0);
  __ZN15PackedIntVector8PackIntsIjEEvPT_i(i22 + 84 | 0, HEAP32[i25 >> 2] | 0, i21);
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i6);
   HEAP32[i25 >> 2] = 0;
  }
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i9);
   HEAP32[i23 >> 2] = 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (HEAP8[i1 + 39 >> 0] | 0) {
  HEAP32[i23 + 12 >> 2] = i21;
  i5 = i23 + 16 | 0;
  HEAP32[i5 >> 2] = i21;
  i6 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i8 = i14;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i6;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i7;
  i10 = i21 << 3;
  HEAP32[i23 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  i7 = i21 << 1;
  HEAP32[i25 + 12 >> 2] = i7;
  i8 = i25 + 16 | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i25 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i18 = i14;
  i3 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = i9;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i25 >> 2] = i10;
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = i2 + 8 | 0;
  i18 = HEAP16[i2 + 38 >> 1] | 0;
  if ((i18 & 65535) < 1024 | (i18 & 255) != 0) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
   } else if (!(HEAP8[i2 + 39 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i18 = HEAP16[i2 + 36 >> 1] | 0;
    i1 = i1 + (((i18 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i18 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  i4 = HEAP32[i23 >> 2] | 0;
  if ((i21 | 0) > 0) {
   i2 = 0;
   while (1) {
    HEAP32[i4 + (i2 << 3) >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + (i2 << 3) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    i18 = i2 << 1;
    HEAP32[i10 + (i18 << 2) >> 2] = Math_fround(HEAPF32[i1 + 8 >> 2]) > Math_fround(0.0) & 1;
    HEAP32[i10 + ((i18 | 1) << 2) >> 2] = Math_fround(HEAPF32[i1 + 12 >> 2]) > Math_fround(0.0) & 1;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i21 | 0)) break; else i1 = i1 + i3 | 0;
   }
  }
  __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i22 + 104 | 0, i4, 2, 8, i21, HEAP32[i12 + 4 >> 2] | 0, 0);
  __ZN15PackedIntVector8PackIntsIjEEvPT_i(i22 + 132 | 0, HEAP32[i25 >> 2] | 0, i7);
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i9);
   HEAP32[i25 >> 2] = 0;
  }
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i6);
   HEAP32[i23 >> 2] = 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (HEAP8[i1 + 19 >> 0] | 0) {
  HEAP32[i23 + 12 >> 2] = i21;
  i18 = i23 + 16 | 0;
  HEAP32[i18 >> 2] = i21;
  i1 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i15 = i14;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 << 4, 4, i1, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i23 >> 2] = i17;
  __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf(i11, i17);
  __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i22 + 152 | 0, HEAP32[i23 >> 2] | 0, 4, 16, i21, HEAP32[i12 + 12 >> 2] | 0, 0);
  if ((HEAP32[i18 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i1);
   HEAP32[i23 >> 2] = 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i13 = HEAP32[i1 + 164 >> 2] | 0;
 if (!((HEAP32[i1 + 176 >> 2] | 0) == 0 | (i13 | 0) == 0)) {
  i16 = i21 * 3 | 0;
  HEAP32[i23 + 12 >> 2] = i16;
  i15 = i23 + 16 | 0;
  HEAP32[i15 >> 2] = i16;
  i16 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i11 = i14;
  i17 = HEAP32[i11 + 4 >> 2] | 0;
  i18 = i16;
  HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i23 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 * 12 | 0, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
  i18 = i21 << 2;
  HEAP32[i25 + 12 >> 2] = i18;
  i17 = i25 + 16 | 0;
  HEAP32[i17 >> 2] = i18;
  i18 = i25 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
  i11 = i14;
  i14 = HEAP32[i11 + 4 >> 2] | 0;
  i12 = i18;
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 4 >> 2] = i14;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 << 4, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i25 >> 2] = i12;
  i14 = HEAP32[i23 >> 2] | 0;
  if ((i21 | 0) > 0) {
   i11 = 0;
   i2 = 0;
   i1 = 0;
   do {
    do if (Math_fround(HEAPF32[i13 + (i11 << 5) + 12 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i13 + (i11 << 5) + 8 >> 2]) == Math_fround(0.0)) {
     if (!(Math_fround(HEAPF32[i13 + (i11 << 5) + 4 >> 2]) == Math_fround(0.0))) {
      i10 = 1;
      break;
     }
     i10 = 0;
    } else i10 = 2; else i10 = 3; while (0);
    i7 = i14 + (i1 << 2) | 0;
    HEAP32[i7 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i13 + (i11 << 5) >> 2]) * Math_fround(31.0)) >>> 0;
    i3 = i2 + 1 | 0;
    HEAP32[i12 + (i2 << 2) >> 2] = HEAP32[i13 + (i11 << 5) + 16 >> 2];
    i4 = i1 + 1 | 0;
    i7 = HEAP32[i7 >> 2] | 0;
    do if ((i10 | 0) != 0 & (i7 | 0) < 31) {
     i4 = i14 + (i4 << 2) | 0;
     HEAP32[i4 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i13 + (i11 << 5) + 4 >> 2]) * Math_fround(31.0)) >>> 0;
     i5 = i2 + 2 | 0;
     HEAP32[i12 + (i3 << 2) >> 2] = HEAP32[i13 + (i11 << 5) + 20 >> 2];
     i6 = i1 + 2 | 0;
     i4 = HEAP32[i4 >> 2] | 0;
     i3 = i4 + i7 | 0;
     if (!(i10 >>> 0 > 1 & (i3 | 0) < 31)) {
      i8 = i3;
      i9 = 2;
      i2 = i5;
      i1 = i6;
      break;
     }
     i4 = i14 + (i6 << 2) | 0;
     HEAP32[i4 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i13 + (i11 << 5) + 8 >> 2]) * Math_fround(31.0)) >>> 0;
     HEAP32[i12 + (i5 << 2) >> 2] = HEAP32[i13 + (i11 << 5) + 24 >> 2];
     i4 = HEAP32[i4 >> 2] | 0;
     i8 = i4 + i3 | 0;
     i9 = 3;
     i2 = i2 + 3 | 0;
     i1 = i1 + 3 | 0;
    } else {
     i8 = i7;
     i9 = 1;
     i2 = i3;
     i1 = i4;
     i4 = i7;
    } while (0);
    i3 = (i8 | 0) < 31;
    do if ((i10 | 0) == 3) {
     if (!i3) break;
     HEAP32[i12 + (i2 << 2) >> 2] = HEAP32[i13 + (i11 << 5) + 16 + (i9 << 2) >> 2];
     i2 = i2 + 1 | 0;
    } else {
     if (!i3) break;
     HEAP32[i14 + (i1 + -1 << 2) >> 2] = 31 - i8 + i4;
    } while (0);
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i21 | 0));
  } else {
   i2 = 0;
   i1 = 0;
  }
  __ZN15PackedIntVector8PackIntsIjEEvPT_i(i22 + 180 | 0, i14, i1);
  __ZN15PackedIntVector8PackIntsIjEEvPT_i(i22 + 200 | 0, HEAP32[i25 >> 2] | 0, i2);
  if ((HEAP32[i17 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i18);
   HEAP32[i25 >> 2] = 0;
  }
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i16);
   HEAP32[i23 >> 2] = 0;
  }
 }
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i26;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
 HEAP32[i24 >> 2] = 0;
 STACKTOP = i26;
 return;
}

function __Z27sweepConvex_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i35, i40, i32, i33, i41, f34, i43, i19, f39) {
 i35 = i35 | 0;
 i40 = i40 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i41 = i41 | 0;
 f34 = Math_fround(f34);
 i43 = i43 | 0;
 i19 = i19 | 0;
 f39 = Math_fround(f39);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i36 = 0, i37 = 0, i38 = 0, i42 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i44 + 568 | 0;
 i38 = i44 + 544 | 0;
 i36 = i44 + 524 | 0;
 i42 = i44;
 i20 = i44 + 512 | 0;
 i21 = i44 + 640 | 0;
 i37 = i44 + 488 | 0;
 i30 = i44 + 472 | 0;
 i31 = i44 + 460 | 0;
 i24 = i44 + 448 | 0;
 i25 = i40 + 4 | 0;
 i26 = i40 + 8 | 0;
 i27 = i40 + 12 | 0;
 i28 = i40 + 20 | 0;
 i29 = i40 + 24 | 0;
 i18 = HEAP32[i32 + 32 >> 2] | 0;
 i22 = i18 + 16 | 0;
 i23 = i32 + 4 | 0;
 if (Math_fround(HEAPF32[i23 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i32 + 8 >> 2]) == Math_fround(1.0)) i10 = Math_fround(HEAPF32[i32 + 12 >> 2]) == Math_fround(1.0); else i10 = 0; else i10 = 0;
 HEAP32[i11 >> 2] = 1065353216;
 i1 = i11 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i11 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i3 = i11 + 16 | 0;
 HEAP32[i3 >> 2] = 1065353216;
 i8 = i11 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 i9 = i11 + 28 | 0;
 HEAP32[i9 >> 2] = 0;
 i17 = i11 + 32 | 0;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 HEAP32[i11 + 40 >> 2] = 0;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 HEAP32[i11 + 52 >> 2] = 1065353216;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = 0;
 HEAP32[i11 + 64 >> 2] = 0;
 HEAP32[i11 + 68 >> 2] = 1065353216;
 if (i10) {
  f5 = Math_fround(1.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(1.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f4 = Math_fround(1.0);
 } else {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i11, i23, i32 + 16 | 0);
  f5 = Math_fround(HEAPF32[i11 >> 2]);
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  f12 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f14 = Math_fround(HEAPF32[i8 >> 2]);
  f15 = Math_fround(HEAPF32[i11 + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(HEAPF32[i17 >> 2]);
 }
 f48 = Math_fround(HEAPF32[i18 + 16 >> 2]);
 f53 = Math_fround(HEAPF32[i18 + 28 >> 2]);
 f54 = Math_fround(f48 + f53);
 f55 = Math_fround(HEAPF32[i18 + 20 >> 2]);
 f50 = Math_fround(HEAPF32[i18 + 32 >> 2]);
 f45 = Math_fround(f55 + f50);
 f52 = Math_fround(HEAPF32[i18 + 24 >> 2]);
 f49 = Math_fround(HEAPF32[i18 + 36 >> 2]);
 f54 = Math_fround(f54 * Math_fround(.5));
 f45 = Math_fround(f45 * Math_fround(.5));
 f46 = Math_fround(Math_fround(f52 + f49) * Math_fround(.5));
 f51 = Math_fround(Math_fround(Math_fround(f54 * f5) + Math_fround(f45 * f12)) + Math_fround(f46 * f15));
 f56 = Math_fround(Math_fround(Math_fround(f54 * f6) + Math_fround(f45 * f13)) + Math_fround(f46 * f16));
 f46 = Math_fround(Math_fround(Math_fround(f54 * f7) + Math_fround(f45 * f14)) + Math_fround(f46 * f4));
 f48 = Math_fround(Math_fround(f53 - f48) * Math_fround(.5));
 f55 = Math_fround(Math_fround(f50 - f55) * Math_fround(.5));
 f52 = Math_fround(Math_fround(f49 - f52) * Math_fround(.5));
 f49 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f5))) + Math_fround(Math_abs(Math_fround(f55 * f12)))) + Math_fround(Math_abs(Math_fround(f52 * f15))));
 f13 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f6))) + Math_fround(Math_abs(Math_fround(f55 * f13)))) + Math_fround(Math_abs(Math_fround(f52 * f16))));
 f52 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f48 * f7))) + Math_fround(Math_abs(Math_fround(f55 * f14)))) + Math_fround(Math_abs(Math_fround(f52 * f4))));
 f12 = Math_fround(f56 - f13);
 f6 = Math_fround(f46 - f52);
 f4 = Math_fround(f51 + f49);
 f13 = Math_fround(f56 + f13);
 f52 = Math_fround(f46 + f52);
 HEAPF32[i38 >> 2] = Math_fround(f51 - f49);
 HEAPF32[i38 + 4 >> 2] = f12;
 HEAPF32[i38 + 8 >> 2] = f6;
 HEAPF32[i38 + 12 >> 2] = f4;
 HEAPF32[i38 + 16 >> 2] = f13;
 HEAPF32[i38 + 20 >> 2] = f52;
 i19 = HEAP16[i19 >> 1] | 0;
 i2 = i19 & 65535;
 i1 = (i2 & 512 | 0) == 0;
 i2 = (HEAP8[i35 + 20 >> 0] & 2) != 0 | (i2 & 128 | 0) != 0;
 HEAP32[i36 + 12 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i36 + 16 >> 2] = i35;
 HEAPF32[i36 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i35 + 8 >> 2]));
 HEAPF32[i36 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i35 + 12 >> 2]));
 HEAPF32[i36 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i35 + 16 >> 2]));
 f52 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
 i3 = i41 + 4 | 0;
 f13 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 i8 = i41 + 8 | 0;
 f4 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i20 >> 2] = f52;
 HEAPF32[i20 + 4 >> 2] = f13;
 HEAPF32[i20 + 8 >> 2] = f4;
 HEAP16[i21 >> 1] = i19;
 __ZN24ConvexVsHeightfieldSweepC2ERN5physx2Gu15HeightFieldUtilERKNS1_14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_11PxTransformESC_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEfbb(i42, i36, i22, i23, i33, i40, i20, f34, i21, f39, (i19 & 64) != 0, i2);
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i37, i33, i38);
 f4 = Math_fround(HEAPF32[i37 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i37 >> 2]);
 f52 = Math_fround(f4 - f13);
 f6 = Math_fround(HEAPF32[i37 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f49 = Math_fround(f6 - f12);
 f5 = Math_fround(HEAPF32[i37 + 20 >> 2]);
 f51 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f52 = Math_fround(Math_fround(f52 * Math_fround(.5)) + f39);
 f49 = Math_fround(Math_fround(f49 * Math_fround(.5)) + f39);
 f46 = Math_fround(Math_fround(Math_fround(f5 - f51) * Math_fround(.5)) + f39);
 f14 = Math_fround(HEAPF32[i40 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i28 >> 2]);
 f14 = Math_fround(f14 * Math_fround(-2.0));
 f15 = Math_fround(f15 * Math_fround(-2.0));
 f56 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(-2.0));
 f55 = Math_fround(HEAPF32[i27 >> 2]);
 f48 = Math_fround(Math_fround(f55 * f55) + Math_fround(-.5));
 f7 = Math_fround(HEAPF32[i40 >> 2]);
 f16 = Math_fround(f14 * f7);
 f50 = Math_fround(HEAPF32[i25 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f15 * f50));
 f53 = Math_fround(HEAPF32[i26 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f56 * f53));
 f45 = Math_fround(-f7);
 f54 = Math_fround(-f50);
 f47 = Math_fround(-f53);
 f13 = Math_fround(Math_fround(Math_fround(f4 + f13) * Math_fround(.5)) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(Math_fround(f6 + f12) * Math_fround(.5)) * Math_fround(2.0));
 f51 = Math_fround(Math_fround(Math_fround(f5 + f51) * Math_fround(.5)) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(Math_fround(f13 * f45) + Math_fround(f12 * f54)) + Math_fround(f51 * f47));
 f6 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(Math_fround(f14 * f48) - Math_fround(f55 * Math_fround(Math_fround(f56 * f50) - Math_fround(f15 * f53))))) + Math_fround(Math_fround(f5 * f45) + Math_fround(Math_fround(f13 * f48) + Math_fround(f55 * Math_fround(Math_fround(f51 * f54) - Math_fround(f12 * f47))))));
 f4 = Math_fround(Math_fround(Math_fround(f50 * f16) + Math_fround(Math_fround(f15 * f48) - Math_fround(f55 * Math_fround(Math_fround(f14 * f53) - Math_fround(f56 * f7))))) + Math_fround(Math_fround(f5 * f54) + Math_fround(Math_fround(f12 * f48) + Math_fround(f55 * Math_fround(Math_fround(f13 * f47) - Math_fround(f51 * f45))))));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f56 * f48) - Math_fround(f55 * Math_fround(Math_fround(f15 * f7) - Math_fround(f14 * f50)))) + Math_fround(f53 * f16)) + Math_fround(Math_fround(Math_fround(f51 * f48) + Math_fround(f55 * Math_fround(Math_fround(f12 * f45) - Math_fround(f13 * f54)))) + Math_fround(f5 * f47)));
 HEAPF32[i30 >> 2] = f6;
 i37 = i30 + 4 | 0;
 HEAPF32[i37 >> 2] = f4;
 i38 = i30 + 8 | 0;
 HEAPF32[i38 >> 2] = f5;
 f13 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
 f51 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f45) + Math_fround(f12 * f54)) + Math_fround(f51 * f47));
 f14 = Math_fround(Math_fround(f16 * f45) + Math_fround(Math_fround(f48 * f13) + Math_fround(f55 * Math_fround(Math_fround(f51 * f54) - Math_fround(f12 * f47)))));
 f15 = Math_fround(Math_fround(f16 * f54) + Math_fround(Math_fround(f48 * f12) + Math_fround(f55 * Math_fround(Math_fround(f13 * f47) - Math_fround(f51 * f45)))));
 f16 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(f55 * Math_fround(Math_fround(f12 * f45) - Math_fround(f13 * f54)))) + Math_fround(f16 * f47));
 f7 = Math_fround(f45 - f7);
 f50 = Math_fround(f54 - f50);
 f53 = Math_fround(f47 - f53);
 f13 = Math_fround(f50 * f54);
 f12 = Math_fround(f53 * f47);
 f54 = Math_fround(f7 * f54);
 f51 = Math_fround(f7 * f47);
 f48 = Math_fround(f55 * f7);
 f47 = Math_fround(f50 * f47);
 f50 = Math_fround(f55 * f50);
 f53 = Math_fround(f55 * f53);
 f45 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f45));
 f7 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f52 * Math_fround(Math_fround(Math_fround(1.0) - f13) - f12)))) + Math_fround(Math_abs(Math_fround(f49 * Math_fround(f54 - f53))))) + Math_fround(Math_abs(Math_fround(f46 * Math_fround(f51 + f50)))));
 f12 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f52 * Math_fround(f54 + f53)))) + Math_fround(Math_abs(Math_fround(f49 * Math_fround(f45 - f12))))) + Math_fround(Math_abs(Math_fround(f46 * Math_fround(f47 - f48)))));
 f13 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f52 * Math_fround(f51 - f50)))) + Math_fround(Math_abs(Math_fround(f49 * Math_fround(f48 + f47))))) + Math_fround(Math_abs(Math_fround(f46 * Math_fround(f45 - f13)))));
 f12 = Math_fround(Math_fround(Math_fround(f12 + f4) - Math_fround(f4 - f12)) * Math_fround(.5));
 f13 = Math_fround(Math_fround(Math_fround(f5 + f13) - Math_fround(f5 - f13)) * Math_fround(.5));
 HEAPF32[i31 >> 2] = Math_fround(Math_fround(Math_fround(f7 + f6) - Math_fround(f6 - f7)) * Math_fround(.5));
 HEAPF32[i31 + 4 >> 2] = f12;
 HEAPF32[i31 + 8 >> 2] = f13;
 f14 = Math_fround(f14 * f34);
 f15 = Math_fround(f15 * f34);
 f16 = Math_fround(f16 * f34);
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i30 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i37 >> 2]));
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i38 >> 2]));
 HEAPF32[i24 >> 2] = f14;
 HEAPF32[i24 + 4 >> 2] = f15;
 HEAPF32[i24 + 8 >> 2] = f16;
 __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI24ConvexVsHeightfieldSweepLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i36, i30, i24, i42, i31);
 if (!(HEAP8[i42 + 435 >> 0] | 0)) {
  i43 = 0;
  STACKTOP = i44;
  return i43 | 0;
 }
 if (!(HEAP8[i42 + 434 >> 0] | 0)) {
  i1 = i42 + 320 | 0;
  HEAP32[i43 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP16[i43 + 12 >> 1] = HEAP16[i42 + 332 >> 1] | 0;
  HEAP32[i43 + 16 >> 2] = HEAP32[i42 + 336 >> 2];
  HEAP32[i43 + 20 >> 2] = HEAP32[i42 + 340 >> 2];
  HEAP32[i43 + 24 >> 2] = HEAP32[i42 + 344 >> 2];
  f56 = Math_fround(HEAPF32[i42 + 348 >> 2]);
  f7 = Math_fround(HEAPF32[i42 + 352 >> 2]);
  i1 = i43 + 32 | 0;
  f55 = Math_fround(HEAPF32[i42 + 356 >> 2]);
  i2 = i43 + 36 | 0;
  HEAP32[i43 + 40 >> 2] = HEAP32[i42 + 360 >> 2];
  HEAP32[i43 + 44 >> 2] = HEAP32[i42 + 364 >> 2];
  i3 = i43 + 28 | 0;
  f4 = Math_fround(-f56);
  f5 = Math_fround(-f7);
  f6 = Math_fround(-f55);
  HEAPF32[i3 >> 2] = f4;
  HEAPF32[i1 >> 2] = f5;
  HEAPF32[i2 >> 2] = f6;
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f56 * f56) + Math_fround(f7 * f7)))));
  if (f7 > Math_fround(0.0)) {
   f56 = Math_fround(Math_fround(1.0) / f7);
   HEAPF32[i3 >> 2] = Math_fround(f56 * f4);
   HEAPF32[i1 >> 2] = Math_fround(f56 * f5);
   HEAPF32[i2 >> 2] = Math_fround(f56 * f6);
  }
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 328 >> 2];
  i43 = 1;
  STACKTOP = i44;
  return i43 | 0;
 }
 if (i1) {
  HEAP16[i43 + 12 >> 1] = 6;
  HEAPF32[i43 + 40 >> 2] = Math_fround(0.0);
  f54 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
  f55 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  f56 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i43 + 28 >> 2] = f54;
  HEAPF32[i43 + 32 >> 2] = f55;
  HEAPF32[i43 + 36 >> 2] = f56;
  HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 328 >> 2];
  i43 = 1;
  STACKTOP = i44;
  return i43 | 0;
 }
 i42 = __ZN5physx2Gu28computeConvex_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbjRNS_10PxSweepHitE(i35, i40, i32, i33, f39, f34, i2, 1, i43) | 0;
 i1 = i43 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 if (i42) {
  HEAP16[i1 >> 1] = 7;
  i43 = 1;
  STACKTOP = i44;
  return i43 | 0;
 } else {
  HEAPF32[i43 + 40 >> 2] = Math_fround(0.0);
  f54 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
  f55 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  f56 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i43 + 28 >> 2] = f54;
  HEAPF32[i43 + 32 >> 2] = f55;
  HEAPF32[i43 + 36 >> 2] = f56;
  i43 = 1;
  STACKTOP = i44;
  return i43 | 0;
 }
 return 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i1, i26, i31) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 i31 = i31 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i35 + 88 | 0;
 i34 = i35 + 64 | 0;
 i28 = i35 + 44 | 0;
 i29 = i35 + 24 | 0;
 i36 = i35 + 12 | 0;
 i33 = i35;
 L1 : do if ((i26 - i1 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == 73) {
  i27 = i31 + 61 | 0;
  i25 = i31 + 36 | 0;
  L4 : do if (HEAP8[i27 >> 0] | 0) {
   i3 = HEAP32[i25 >> 2] | 0;
   i2 = HEAP32[i3 + -16 >> 2] | 0;
   i3 = i3 + -12 | 0;
   while (1) {
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) == (i2 | 0)) break L4;
    i30 = i4 + -16 | 0;
    HEAP32[i3 >> 2] = i30;
    __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i30);
   }
  } while (0);
  HEAP32[i36 >> 2] = 0;
  HEAP32[i36 + 4 >> 2] = 0;
  HEAP32[i36 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i36, gb + 1086445 | 0, 1);
  i30 = i31 + 4 | 0;
  i14 = i31 + 12 | 0;
  i15 = i28 + 8 | 0;
  i16 = i34 + 8 | 0;
  i23 = i36 + 11 | 0;
  i24 = i36 + 4 | 0;
  i17 = i32 + 11 | 0;
  i18 = i32 + 4 | 0;
  i22 = i31 + 32 | 0;
  i19 = i31 + 40 | 0;
  i20 = i31 + 44 | 0;
  i21 = i29 + 8 | 0;
  i7 = i1 + 1 | 0;
  L10 : while (1) {
   if ((HEAP8[i7 >> 0] | 0) == 69) {
    i6 = 60;
    break;
   }
   do if (HEAP8[i27 >> 0] | 0) {
    i4 = HEAP32[i14 >> 2] | 0;
    i2 = HEAP32[i25 >> 2] | 0;
    i5 = HEAP32[i19 >> 2] | 0;
    if (i2 >>> 0 < i5 >>> 0) {
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = 0;
     HEAP32[i2 + 12 >> 2] = i4;
     HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 16;
     break;
    }
    i6 = HEAP32[i22 >> 2] | 0;
    i2 = i2 - i6 >> 4;
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 > 268435455) {
     i6 = 13;
     break L10;
    }
    i12 = i5 - i6 | 0;
    i13 = i12 >> 3;
    __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEEC2EjjSB_(i29, i12 >> 4 >>> 0 < 134217727 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 268435455, i2, i20);
    i13 = HEAP32[i21 >> 2] | 0;
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    HEAP32[i13 + 12 >> 2] = i4;
    HEAP32[i21 >> 2] = i13 + 16;
    __ZNSt3__26vectorINS0_INS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEEENS4_IS8_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS8_RS9_EE(i22, i29);
    __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEED2Ev(i29);
   } while (0);
   i12 = ((HEAP32[i30 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
   __THREW__ = 0;
   i13 = invoke_iiii(fb + 526 | 0, i7 | 0, i26 | 0, i31 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) {
    i6 = 20;
    break;
   }
   i11 = ((HEAP32[i30 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0) / 24 | 0;
   L21 : do if (HEAP8[i27 >> 0] | 0) {
    i3 = HEAP32[i25 >> 2] | 0;
    i2 = i3 + -16 | 0;
    while (1) {
     if ((i3 | 0) == (i2 | 0)) break L21;
     i10 = i3 + -16 | 0;
     HEAP32[i25 >> 2] = i10;
     __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev(i10);
     i3 = HEAP32[i25 >> 2] | 0;
    }
   } while (0);
   if ((i13 | 0) == (i7 | 0) | (i13 | 0) == (i26 | 0)) {
    i6 = 73;
    break;
   }
   L28 : do if (!(HEAP8[i27 >> 0] | 0)) i2 = i12; else {
    i7 = HEAP32[i25 >> 2] | 0;
    i8 = i7 + -16 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    i2 = i7 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i10 = HEAP32[i7 + -8 >> 2] | 0;
    i6 = i10;
    if (i3 >>> 0 < i10 >>> 0) {
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     HEAP32[i3 + 12 >> 2] = i5;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
     i7 = i12;
    } else {
     i4 = HEAP32[i8 >> 2] | 0;
     i2 = i3 - i4 >> 4;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 268435455) {
      i6 = 26;
      break L10;
     }
     i9 = i6 - i4 | 0;
     i10 = i9 >> 3;
     __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i28, i9 >> 4 >>> 0 < 134217727 ? (i10 >>> 0 < i3 >>> 0 ? i3 : i10) : 268435455, i2, i7 + -4 | 0);
     i7 = HEAP32[i15 >> 2] | 0;
     HEAP32[i7 >> 2] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
     HEAP32[i7 + 8 >> 2] = 0;
     HEAP32[i7 + 12 >> 2] = i5;
     HEAP32[i15 >> 2] = i7 + 16;
     __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i8, i28);
     __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i28);
     i7 = i12;
    }
    while (1) {
     if (i7 >>> 0 >= i11 >>> 0) {
      i2 = i12;
      break L28;
     }
     i5 = HEAP32[(HEAP32[i25 >> 2] | 0) + -12 >> 2] | 0;
     i10 = i5 + -16 | 0;
     i8 = HEAP32[i31 >> 2] | 0;
     i9 = i8 + (i7 * 24 | 0) | 0;
     i2 = i5 + -12 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i4 = HEAP32[i5 + -8 >> 2] | 0;
     i6 = i4;
     if ((i3 | 0) == (i4 | 0)) {
      i4 = HEAP32[i10 >> 2] | 0;
      i2 = (i3 - i4 | 0) / 24 | 0;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 > 178956970) {
       i6 = 35;
       break L10;
      }
      i4 = (i6 - i4 | 0) / 24 | 0;
      i6 = i4 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i34, i4 >>> 0 < 89478485 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 178956970, i2, i5 + -4 | 0);
      i2 = HEAP32[i16 >> 2] | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i2 | 0, i9 | 0);
      i9 = __THREW__;
      __THREW__ = 0;
      if (i9 & 1) {
       i6 = 39;
       break L10;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i2 + 12 | 0, i8 + (i7 * 24 | 0) + 12 | 0);
      i9 = __THREW__;
      __THREW__ = 0;
      if (i9 & 1) {
       i6 = 38;
       break L10;
      }
      HEAP32[i16 >> 2] = i2 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i34);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i34);
     } else {
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i3 | 0, i9 | 0);
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i6 = 43;
       break L10;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i8 + (i7 * 24 | 0) + 12 | 0);
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i6 = 32;
       break L10;
      }
      HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
     }
     i7 = i7 + 1 | 0;
    }
   } while (0);
   while (1) {
    if (i2 >>> 0 >= i11 >>> 0) {
     i2 = i11;
     break;
    }
    i10 = HEAP8[i23 >> 0] | 0;
    if ((i10 << 24 >> 24 < 0 ? HEAP32[i24 >> 2] | 0 : i10 & 255) >>> 0 > 1) {
     __THREW__ = 0;
     invoke_iii(fb + 1152 | 0, i36 | 0, gb + 1086385 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i6 = 48;
      break L10;
     }
    }
    __THREW__ = 0;
    invoke_vii(fb + 4619 | 0, i32 | 0, (HEAP32[i31 >> 2] | 0) + (i2 * 24 | 0) | 0);
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i6 = 52;
     break L10;
    }
    i10 = HEAP8[i17 >> 0] | 0;
    i9 = i10 << 24 >> 24 < 0;
    __THREW__ = 0;
    invoke_iiii(fb + 519 | 0, i36 | 0, (i9 ? HEAP32[i32 >> 2] | 0 : i32) | 0, (i9 ? HEAP32[i18 >> 2] | 0 : i10 & 255) | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i6 = 53;
     break L10;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i32);
    i2 = i2 + 1 | 0;
   }
   while (1) {
    if ((i2 | 0) == (i12 | 0)) {
     i7 = i13;
     continue L10;
    }
    i4 = HEAP32[i30 >> 2] | 0;
    i3 = i4 + -24 | 0;
    while (1) {
     if ((i4 | 0) == (i3 | 0)) break;
     i11 = i4 + -24 | 0;
     HEAP32[i30 >> 2] = i11;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
     i4 = HEAP32[i30 >> 2] | 0;
    }
    i2 = i2 + -1 | 0;
   }
  }
  L61 : switch (i6 | 0) {
  case 13:
   {
    __THREW__ = 0;
    invoke_vi(fb + 4014 | 0, i22 | 0);
    __THREW__ = 0;
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  case 20:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  case 26:
   {
    __THREW__ = 0;
    invoke_vi(fb + 4014 | 0, i8 | 0);
    __THREW__ = 0;
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  case 32:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
    i6 = 44;
    break;
   }
  case 35:
   {
    __THREW__ = 0;
    invoke_vi(fb + 4014 | 0, i10 | 0);
    __THREW__ = 0;
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i6 = 44;
    break;
   }
  case 38:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
    i6 = 40;
    break;
   }
  case 39:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i6 = 40;
    break;
   }
  case 43:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i6 = 44;
    break;
   }
  case 48:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  case 52:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i6 = 54;
    break;
   }
  case 53:
   {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i32);
    i6 = 54;
    break;
   }
  case 60:
   {
    i1 = i7 + 1 | 0;
    i29 = HEAP8[i23 >> 0] | 0;
    i28 = i29 << 24 >> 24 < 0;
    if ((HEAP8[(i28 ? HEAP32[i36 >> 2] | 0 : i36) + (i28 ? HEAP32[i24 >> 2] | 0 : i29 & 255) + -1 >> 0] | 0) == 62) {
     __THREW__ = 0;
     invoke_iii(fb + 1152 | 0, i36 | 0, gb + 1087430 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) i6 = 62;
    } else {
     __THREW__ = 0;
     invoke_iii(fb + 1152 | 0, i36 | 0, gb + 1086447 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) i6 = 62;
    }
    if ((i6 | 0) == 62) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    };
    HEAP32[i33 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i33 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i33 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i36 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i34, i33);
    i2 = HEAP32[i30 >> 2] | 0;
    i29 = HEAP32[i31 + 8 >> 2] | 0;
    i5 = i29;
    do if (i2 >>> 0 < i29 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i34);
     HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i31 >> 2] | 0;
     i2 = (i2 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i31 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i34);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
      break L61;
     } else {
      i29 = (i5 - i4 | 0) / 24 | 0;
      i30 = i29 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i32, i29 >>> 0 < 89478485 ? (i30 >>> 0 < i3 >>> 0 ? i3 : i30) : 178956970, i2, i31 + 12 | 0);
      i30 = i32 + 8 | 0;
      i29 = HEAP32[i30 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i29, i34);
      HEAP32[i30 >> 2] = i29 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i31, i32);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i32);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i34);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i33);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i36);
    break L1;
   }
  case 73:
   {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i36);
    break L1;
   }
  }
  if ((i6 | 0) == 40) {
   __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i34);
   i6 = 44;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i36);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i35;
 return i1 | 0;
}

function _gray_raster_render(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 18032 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i48 + 18016 | 0;
 i41 = i48 + 17992 | 0;
 i42 = i48 + 17672 | 0;
 i43 = i48 + 17668 | 0;
 i44 = i48 + 17664 | 0;
 i45 = i48 + 17660 | 0;
 i46 = i48 + 17656 | 0;
 i47 = i48 + 17652 | 0;
 i38 = i48 + 17648 | 0;
 i39 = i48 + 16384 | 0;
 i4 = i48;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i47 = 6;
  STACKTOP = i48;
  return i47 | 0;
 }
 if (!i5) {
  i47 = 20;
  STACKTOP = i48;
  return i47 | 0;
 }
 i1 = HEAP16[i5 + 2 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i47 = 0;
  STACKTOP = i48;
  return i47 | 0;
 }
 i2 = HEAP16[i5 >> 1] | 0;
 if (i2 << 16 >> 16 < 1) {
  i47 = 0;
  STACKTOP = i48;
  return i47 | 0;
 }
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 if (!i3) {
  i47 = 20;
  STACKTOP = i48;
  return i47 | 0;
 }
 if (!(HEAP32[i5 + 4 >> 2] | 0)) {
  i47 = 20;
  STACKTOP = i48;
  return i47 | 0;
 }
 if ((i1 << 16 >> 16 | 0) != ((HEAP16[i3 + ((i2 << 16 >> 16) + -1 << 1) >> 1] | 0) + 1 | 0)) {
  i47 = 20;
  STACKTOP = i48;
  return i47 | 0;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i3 = (i1 & 2 | 0) == 0;
 if (i3) {
  if (!i7) {
   i47 = 6;
   STACKTOP = i48;
   return i47 | 0;
  }
  if (!(HEAP32[i7 + 4 >> 2] | 0)) {
   i47 = 0;
   STACKTOP = i48;
   return i47 | 0;
  }
  if (!(HEAP32[i7 >> 2] | 0)) {
   i47 = 0;
   STACKTOP = i48;
   return i47 | 0;
  }
  if (!(HEAP32[i7 + 12 >> 2] | 0)) {
   i47 = 6;
   STACKTOP = i48;
   return i47 | 0;
  }
 }
 if (!(i1 & 1)) {
  i47 = 19;
  STACKTOP = i48;
  return i47 | 0;
 }
 do if (i3) {
  HEAP32[i39 + 1016 >> 2] = 0;
  HEAP32[i39 + 1020 >> 2] = 0;
  HEAP32[i39 + 1024 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i39 + 1028 >> 2] = HEAP32[i7 >> 2];
 } else {
  i2 = i39 + 1016 | 0;
  if (!(i1 & 4)) {
   HEAP32[i2 >> 2] = -32768;
   HEAP32[i39 + 1020 >> 2] = -32768;
   HEAP32[i39 + 1024 >> 2] = 32767;
   HEAP32[i39 + 1028 >> 2] = 32767;
   break;
  } else {
   i36 = i6 + 32 | 0;
   HEAP32[i2 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   break;
  }
 } while (0);
 i34 = i39 + 1248 | 0;
 HEAP32[i34 >> 2] = i4;
 i35 = i39 + 1252 | 0;
 HEAP32[i35 >> 2] = 16384;
 i36 = i39 + 1256 | 0;
 HEAP32[i36 >> 2] = i4;
 i26 = i39 + 48 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i39 + 52 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i39 + 56 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i39 + 36 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i39 + 40 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i39 + 44 | 0;
 HEAP32[i31 >> 2] = 1;
 i32 = i39 + 972 | 0;
 HEAP32[i32 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i32 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i28 >> 2] = 0;
 HEAP32[i31 >> 2] = 1;
 i33 = i39 + 1240 | 0;
 HEAP32[i33 >> 2] = 128;
 i24 = i39 + 1224 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i39 + 1236 | 0;
 HEAP32[i25 >> 2] = 0;
 if (i3) {
  i23 = i39 + 992 | 0;
  HEAP32[i23 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i23 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i23 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i39 + 1228 >> 2] = fb + 313;
  HEAP32[i39 + 1232 >> 2] = i39;
 } else {
  HEAP32[i39 + 1228 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i39 + 1232 >> 2] = HEAP32[i6 + 28 >> 2];
 }
 i2 = HEAP32[i39 + 976 >> 2] | 0;
 i1 = HEAP16[i39 + 974 >> 1] | 0;
 i10 = i2 + (i1 << 16 >> 16 << 3) | 0;
 if (i1 << 16 >> 16 < 1) {
  i8 = i39 + 12 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i8 = i39 + 16 | 0;
  i1 = 0;
  i5 = 0;
  i2 = 0;
  i7 = 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  i8 = i39 + 16 | 0;
  HEAP32[i8 >> 2] = i5;
  i13 = i39 + 12 | 0;
  HEAP32[i13 >> 2] = i5;
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i11 = i39 + 24 | 0;
  HEAP32[i11 >> 2] = i6;
  i12 = i39 + 20 | 0;
  HEAP32[i12 >> 2] = i6;
  if (i1 << 16 >> 16 == 1) {
   i4 = i5;
   i3 = i6;
   i2 = i5;
   i1 = i6;
  } else {
   i9 = i2 + 8 | 0;
   i1 = i2;
   i4 = i5;
   i7 = i5;
   i5 = i6;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) < (i4 | 0)) {
     HEAP32[i13 >> 2] = i2;
     i4 = i2;
    }
    if ((i2 | 0) > (i7 | 0)) HEAP32[i8 >> 2] = i2; else i2 = i7;
    if ((i1 | 0) < (i5 | 0)) {
     HEAP32[i12 >> 2] = i1;
     i5 = i1;
    }
    if ((i1 | 0) > (i3 | 0)) HEAP32[i11 >> 2] = i1; else i1 = i3;
    i3 = i9 + 8 | 0;
    if (i3 >>> 0 < i10 >>> 0) {
     i23 = i9;
     i9 = i3;
     i7 = i2;
     i3 = i1;
     i1 = i23;
    } else {
     i3 = i5;
     break;
    }
   }
  }
  i5 = i4 >> 6;
  HEAP32[i13 >> 2] = i5;
  i7 = i3 >> 6;
  HEAP32[i12 >> 2] = i7;
  i23 = i2 + 63 >> 6;
  HEAP32[i8 >> 2] = i23;
  i2 = i1 + 63 >> 6;
  HEAP32[i11 >> 2] = i2;
  i1 = i23;
 }
 i3 = HEAP32[i39 + 1016 >> 2] | 0;
 L70 : do if ((i1 | 0) > (i3 | 0)) {
  i4 = i39 + 12 | 0;
  i9 = HEAP32[i39 + 1024 >> 2] | 0;
  if ((i5 | 0) < (i9 | 0)) {
   i22 = i39 + 24 | 0;
   i6 = HEAP32[i39 + 1020 >> 2] | 0;
   if ((i2 | 0) > (i6 | 0)) {
    i23 = i39 + 20 | 0;
    i10 = HEAP32[i39 + 1028 >> 2] | 0;
    if ((i7 | 0) < (i10 | 0)) {
     if ((i5 | 0) < (i3 | 0)) HEAP32[i4 >> 2] = i3; else i3 = i5;
     if ((i7 | 0) < (i6 | 0)) HEAP32[i23 >> 2] = i6; else i6 = i7;
     if ((i1 | 0) > (i9 | 0)) {
      HEAP32[i8 >> 2] = i9;
      i1 = i9;
     }
     if ((i2 | 0) > (i10 | 0)) {
      HEAP32[i22 >> 2] = i10;
      i2 = i10;
     }
     i21 = i39 + 28 | 0;
     HEAP32[i21 >> 2] = i1 - i3;
     i20 = i2 - i6 | 0;
     i19 = i39 + 32 | 0;
     HEAP32[i19 >> 2] = i20;
     i1 = HEAP32[i33 >> 2] | 0;
     HEAP32[i45 >> 2] = (i20 | 0) / (i1 | 0) | 0;
     if (!(HEAP32[i45 >> 2] | 0)) HEAP32[i45 >> 2] = 1;
     if ((HEAP32[i45 >> 2] | 0) > 38) HEAP32[i45 >> 2] = 39;
     i20 = i39 + 1244 | 0;
     HEAP32[i20 >> 2] = 0;
     HEAP32[i46 >> 2] = i6;
     HEAP32[i38 >> 2] = i2;
     HEAP32[i44 >> 2] = 0;
     if ((HEAP32[i44 >> 2] | 0) >= (HEAP32[i45 >> 2] | 0)) {
      i1 = 0;
      break;
     }
     i7 = i42 + 4 | 0;
     i8 = i39 + 1260 | 0;
     i9 = i41 + 4 | 0;
     i10 = i41 + 8 | 0;
     i11 = i41 + 12 | 0;
     i12 = i41 + 16 | 0;
     i13 = i41 + 20 | 0;
     i14 = i39 + 4 | 0;
     i15 = i39 + 8 | 0;
     i16 = i39 + 1228 | 0;
     i17 = i39 + 1032 | 0;
     i18 = i39 + 1232 | 0;
     while (1) {
      HEAP32[i47 >> 2] = (HEAP32[i46 >> 2] | 0) + i1;
      if ((HEAP32[i44 >> 2] | 0) == ((HEAP32[i45 >> 2] | 0) + -1 | 0)) i37 = 56; else if ((HEAP32[i47 >> 2] | 0) > (HEAP32[i38 >> 2] | 0)) i37 = 56;
      if ((i37 | 0) == 56) {
       i37 = 0;
       HEAP32[i47 >> 2] = HEAP32[i38 >> 2];
      }
      HEAP32[i42 >> 2] = HEAP32[i46 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i47 >> 2];
      HEAP32[i43 >> 2] = i42;
      do {
       i3 = HEAP32[i34 >> 2] | 0;
       HEAP32[i36 >> 2] = i3;
       i4 = (HEAP32[(HEAP32[i43 >> 2] | 0) + 4 >> 2] | 0) - (HEAP32[HEAP32[i43 >> 2] >> 2] | 0) | 0;
       HEAP32[i8 >> 2] = i4;
       i1 = i4 << 2;
       i2 = (i1 | 0) % 16 | 0;
       i1 = ((i2 | 0) > 0 ? 16 - i2 | 0 : 0) + i1 | 0;
       i2 = HEAP32[i35 >> 2] | 0;
       i2 = i2 - ((i2 | 0) % 16 | 0) | 0;
       HEAP32[i26 >> 2] = i3 + i1;
       L103 : do if ((i2 | 0) > (i1 | 0)) {
        i6 = i2 - i1 | 0;
        HEAP32[i27 >> 2] = i6 >> 4;
        if ((i6 | 0) < 32) {
         i37 = 92;
         break;
        }
        do if ((i4 | 0) > 0) {
         HEAP32[i3 >> 2] = 0;
         if ((i4 | 0) == 1) break; else i1 = 1;
         do {
          HEAP32[(HEAP32[i36 >> 2] | 0) + (i1 << 2) >> 2] = 0;
          i1 = i1 + 1 | 0;
         } while ((i1 | 0) < (i4 | 0));
        } while (0);
        HEAP32[i28 >> 2] = 0;
        HEAP32[i31 >> 2] = 1;
        HEAP32[i23 >> 2] = HEAP32[HEAP32[i43 >> 2] >> 2];
        HEAP32[i22 >> 2] = HEAP32[(HEAP32[i43 >> 2] | 0) + 4 >> 2];
        HEAP32[i19 >> 2] = (HEAP32[(HEAP32[i43 >> 2] | 0) + 4 >> 2] | 0) - (HEAP32[HEAP32[i43 >> 2] >> 2] | 0);
        HEAP32[i40 >> 2] = 0;
        HEAP32[i41 >> 2] = fb + 1019;
        HEAP32[i9 >> 2] = fb + 1020;
        HEAP32[i10 >> 2] = fb + 443;
        HEAP32[i11 >> 2] = fb + 184;
        HEAP32[i12 >> 2] = 0;
        HEAP32[i13 >> 2] = 0;
        HEAP32[i39 >> 2] = 0;
        HEAP32[i40 >> 2] = _UNITY_FT_Outline_Decompose(i32, i41, i39) | 0;
        L111 : do if (!(HEAP32[i31 >> 2] | 0)) {
         i5 = HEAP32[i29 >> 2] | 0;
         i6 = HEAP32[i30 >> 2] | 0;
         if (!(i6 | i5)) {
          i37 = 73;
          break;
         }
         i4 = HEAP32[i14 >> 2] | 0;
         i2 = HEAP32[i21 >> 2] | 0;
         i4 = (i4 | 0) > (i2 | 0) ? i2 : i4;
         i2 = (HEAP32[i36 >> 2] | 0) + (HEAP32[i15 >> 2] << 2) | 0;
         i1 = HEAP32[i2 >> 2] | 0;
         L114 : do if (!i1) i37 = 69; else while (1) {
          i3 = HEAP32[i1 >> 2] | 0;
          if ((i3 | 0) > (i4 | 0)) {
           i37 = 69;
           break L114;
          }
          if ((i3 | 0) == (i4 | 0)) break L114;
          i2 = i1 + 12 | 0;
          i1 = HEAP32[i2 >> 2] | 0;
          if (!i1) {
           i37 = 69;
           break;
          }
         } while (0);
         do if ((i37 | 0) == 69) {
          i3 = HEAP32[i28 >> 2] | 0;
          if ((i3 | 0) < (HEAP32[i27 >> 2] | 0)) {
           i37 = HEAP32[i26 >> 2] | 0;
           HEAP32[i28 >> 2] = i3 + 1;
           i1 = i37 + (i3 << 4) | 0;
           HEAP32[i1 >> 2] = i4;
           HEAP32[i37 + (i3 << 4) + 8 >> 2] = 0;
           HEAP32[i37 + (i3 << 4) + 4 >> 2] = 0;
           HEAP32[i37 + (i3 << 4) + 12 >> 2] = HEAP32[i2 >> 2];
           HEAP32[i2 >> 2] = i1;
           if (!i1) {
            i37 = 73;
            break L111;
           } else break;
          } else {
           HEAP32[i39 >> 2] = 64;
           i1 = 64;
           i37 = 74;
           break L111;
          }
         } while (0);
         i37 = i1 + 8 | 0;
         HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + i5;
         i37 = i1 + 4 | 0;
         HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + i6;
         i37 = 73;
        } else i37 = 73; while (0);
        if ((i37 | 0) == 73) {
         i37 = 0;
         i1 = HEAP32[i39 >> 2] | 0;
         if (i1 | 0) i37 = 74;
        }
        if ((i37 | 0) == 74) {
         i37 = 0;
         HEAP32[i40 >> 2] = i1;
         HEAP32[i39 >> 2] = 0;
        }
        switch (HEAP32[i40 >> 2] | 0) {
        case 64:
         {
          i37 = 92;
          break L103;
         }
        case 0:
         break;
        default:
         {
          i1 = 1;
          break L70;
         }
        }
        do if (HEAP32[i28 >> 2] | 0) {
         HEAP32[i24 >> 2] = 0;
         if ((HEAP32[i8 >> 2] | 0) > 0) {
          i6 = 0;
          do {
           i1 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i6 << 2) >> 2] | 0;
           do if (i1 | 0) {
            i3 = 0;
            i5 = 0;
            do {
             i2 = HEAP32[i1 >> 2] | 0;
             if ((i5 | 0) != 0 & (i2 | 0) > (i3 | 0)) _gray_hline(i39, i3, i6, i5 << 9, i2 - i3 | 0);
             i5 = (HEAP32[i1 + 4 >> 2] | 0) + i5 | 0;
             i4 = i5 << 9;
             i2 = i4 - (HEAP32[i1 + 8 >> 2] | 0) | 0;
             do if (i2 | 0) {
              i3 = HEAP32[i1 >> 2] | 0;
              if ((i3 | 0) <= -1) break;
              _gray_hline(i39, i3, i6, i2, 1);
             } while (0);
             i3 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
             i1 = HEAP32[i1 + 12 >> 2] | 0;
            } while ((i1 | 0) != 0);
            if (!i5) break;
            _gray_hline(i39, i3, i6, i4, (HEAP32[i21 >> 2] | 0) - i3 | 0);
           } while (0);
           i6 = i6 + 1 | 0;
          } while ((i6 | 0) < (HEAP32[i8 >> 2] | 0));
         }
         i1 = HEAP32[i16 >> 2] | 0;
         if (!i1) break;
         i2 = HEAP32[i24 >> 2] | 0;
         if ((i2 | 0) <= 0) break;
         mftCall_viiii(i1 | 0, HEAP32[i25 >> 2] | 0, i2 | 0, i17 | 0, HEAP32[i18 >> 2] | 0);
        } while (0);
        HEAP32[i43 >> 2] = (HEAP32[i43 >> 2] | 0) + -8;
       } else i37 = 92; while (0);
       if ((i37 | 0) == 92) {
        i37 = 0;
        i1 = HEAP32[HEAP32[i43 >> 2] >> 2] | 0;
        i2 = HEAP32[(HEAP32[i43 >> 2] | 0) + 4 >> 2] | 0;
        i6 = i2 - i1 >> 1;
        i3 = i6 + i1 | 0;
        if (!i6) {
         i1 = 1;
         break L70;
        }
        if ((i1 - i2 | 0) >= (HEAP32[i33 >> 2] | 0)) HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
        HEAP32[(HEAP32[i43 >> 2] | 0) + 8 >> 2] = i1;
        HEAP32[(HEAP32[i43 >> 2] | 0) + 12 >> 2] = i3;
        HEAP32[HEAP32[i43 >> 2] >> 2] = i3;
        HEAP32[(HEAP32[i43 >> 2] | 0) + 4 >> 2] = i2;
        HEAP32[i43 >> 2] = (HEAP32[i43 >> 2] | 0) + 8;
       }
      } while ((HEAP32[i43 >> 2] | 0) >>> 0 >= i42 >>> 0);
      HEAP32[i44 >> 2] = (HEAP32[i44 >> 2] | 0) + 1;
      HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
      if ((HEAP32[i44 >> 2] | 0) >= (HEAP32[i45 >> 2] | 0)) break;
      i1 = HEAP32[i33 >> 2] | 0;
     }
     if ((HEAP32[i20 >> 2] | 0) <= 8) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[i33 >> 2] | 0;
     if ((i1 | 0) <= 16) {
      i1 = 0;
      break;
     }
     HEAP32[i33 >> 2] = i1 >>> 1;
     i1 = 0;
    } else i1 = 0;
   } else i1 = 0;
  } else i1 = 0;
 } else i1 = 0; while (0);
 i47 = i1;
 STACKTOP = i48;
 return i47 | 0;
}

function __ZL10CullLightsRK22SceneCullingParametersR11CullResults(i31, i32) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i40 + 8 | 0;
 i30 = i40;
 i35 = i40 + 168 | 0;
 i36 = i40 + 148 | 0;
 i37 = i40 + 128 | 0;
 i38 = i40 + 108 | 0;
 i39 = i40 + 88 | 0;
 i27 = i40 + 76 | 0;
 i28 = i40 + 64 | 0;
 i33 = i40 + 44 | 0;
 i34 = i40 + 24 | 0;
 i26 = i40 + 16 | 0;
 i3 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) i2 = 0; else {
  i2 = 0;
  do {
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 if (!(HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 37824 >> 2] | i2)) {
  HEAP8[i32 + 332 >> 0] = 0;
  HEAP8[i32 + 356 >> 0] = 0;
  STACKTOP = i40;
  return;
 }
 if ((HEAP16[gb + 1110656 + 6 >> 1] | 0) > -1) {
  HEAP32[i30 >> 2] = 0;
  HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110656 | 0, i29);
  i15 = gb + 1110656 | 0;
 } else i15 = 0;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i6 = i30;
 HEAP32[i6 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i6 + 4 >> 2] = i20;
 HEAP32[i35 >> 2] = 0;
 i6 = i35 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i20 = i35 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i3 = i29;
 i22 = HEAP32[i3 + 4 >> 2] | 0;
 i23 = i21;
 HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i23 + 4 >> 2] = i22;
 i23 = gb + 64016 | 0;
 i22 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = i30;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 + 4 >> 2] = i22;
 HEAP32[i36 >> 2] = 0;
 i3 = i36 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i22 = i36 + 16 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i36 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i7 = i29;
 i24 = HEAP32[i7 + 4 >> 2] | 0;
 i25 = i23;
 HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i25 + 4 >> 2] = i24;
 i25 = gb + 64016 | 0;
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i7 = i30;
 HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i7 + 4 >> 2] = i24;
 HEAP32[i37 >> 2] = 0;
 i7 = i37 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i24 = i37 + 16 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i37 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i4 = i29;
 i16 = HEAP32[i4 + 4 >> 2] | 0;
 i17 = i25;
 HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i17 + 4 >> 2] = i16;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i4 = i30;
 HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i4 + 4 >> 2] = i16;
 HEAP32[i38 >> 2] = 0;
 i4 = i38 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i16 = i38 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i38 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i5 = i29;
 i18 = HEAP32[i5 + 4 >> 2] | 0;
 i19 = i17;
 HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i5 = i30;
 HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i5 + 4 >> 2] = i18;
 HEAP32[i39 >> 2] = 0;
 i5 = i39 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i18 = i39 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i39 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i13 = i29;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 i1 = HEAP32[i20 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i20 >> 2] = i2;
  HEAP32[i35 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2 << 2, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i20 >> 2] = i2;
  HEAP32[i35 >> 2] = i14;
  break;
 } while (0);
 i1 = HEAP32[i22 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i22 >> 2] = i2;
  HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i2 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i36 >> 2] = i14;
  break;
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i24 >> 2] = i2;
  HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i2 << 2, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i24 >> 2] = i2;
  HEAP32[i37 >> 2] = i14;
  break;
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i16 >> 2] = i2;
  HEAP32[i38 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i38 >> 2] | 0, i2 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i38 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i16 >> 2] = i2;
  HEAP32[i38 >> 2] = i14;
  break;
 } while (0);
 i1 = HEAP32[i18 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i18 >> 2] = i2;
  HEAP32[i39 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i39 >> 2] | 0, i2 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i39 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i39 >> 2] = i14;
  break;
 } while (0);
 i13 = i32 + 1308 | 0;
 __Z16FindActiveLightsR13dynamic_arrayIPK5LightLj4EES4_RS_I8Vector4fLj4EERS_IiLj4EERK14ShadowCullData(i37, i35, i36, i39, HEAP32[i13 >> 2] | 0);
 i11 = HEAP32[i6 >> 2] | 0;
 i3 = i11 + (HEAP32[i7 >> 2] | 0) | 0;
 i14 = i32 + 312 | 0;
 i1 = i32 + 328 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i3 * 180 | 0, 4, i32 + 316 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 180 | 0, 4, i32 + 316 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i32 + 324 >> 2] | 0) * 180 | 0) | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i14 >> 2] = i12;
  break;
 } while (0);
 __Z20AddDirectionalLightsPPK5LightjR12ActiveLights(HEAP32[i37 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14);
 i12 = i32 + 360 | 0;
 i1 = i32 + 376 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i3 * 960 | 0, 16, i32 + 364 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 960 | 0, 16, i32 + 364 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i32 + 372 >> 2] | 0) * 960 | 0) | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i12 >> 2] = i10;
  break;
 } while (0);
 if ((HEAP16[gb + 1110740 + 6 >> 1] | 0) > -1) {
  HEAP32[i30 >> 2] = 0;
  HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110740 | 0, i29);
  i1 = gb + 1110740 | 0;
 } else i1 = 0;
 i6 = i32 + 336 | 0;
 __ZL23FindShadowCastingLightsR12ActiveLightsR13dynamic_arrayI13ShadowedLightLj16EEjj(i14, i12, 0, HEAP32[i6 >> 2] | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i4 = i11 << 2;
 HEAP32[i27 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = i11;
 HEAP32[i28 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = i11;
 i2 = HEAP8[i31 + 818 >> 0] | 0 ? 2 : 1;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i30;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i33 >> 2] = 0;
 i1 = i33 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i33 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i33 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i5 = i29;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i30;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i34 >> 2] = 0;
 i5 = i34 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i9 = i34 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i34 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i42 = i29;
 i41 = HEAP32[i42 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i3 + 4 >> 2] = i41;
 i2 = Math_imul(i2, i11) | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i33 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i33 >> 2] | 0, i2 << 4, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i42 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i42 | 0, HEAP32[i33 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i33 >> 2] = i42;
  break;
 } while (0);
 HEAP32[i5 >> 2] = i11;
 i1 = HEAP32[i9 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i11 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i11;
  HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i4, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i42 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i42 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i11;
  HEAP32[i34 >> 2] = i42;
  break;
 } while (0);
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 __Z15CullLocalLightsR8JobFenceS0_RK22SceneCullingParametersRK13dynamic_arrayI8Vector4fLj4EERKS4_IiLj4EER9IndexListSD_RS4_IfLj4EERS4_I5RectTIfELj4EERS4_I13TargetEyeMaskLj4EEPPK5LightRK14ShadowCullData(i26, i32, i31, i36, i39, i27, i28, i38, i33, i34, HEAP32[i35 >> 2] | 0, HEAP32[i13 >> 2] | 0);
 i3 = i32 + 372 | 0;
 __Z28CullDirectionalShadowCastersiRK22SceneCullingParametersR11CullResults(HEAP32[i3 >> 2] | 0, i31, i32);
 if (HEAP32[i26 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i26);
 __Z20AddActiveLocalLightsR11CullResultsPPK5LightPK8Vector4fRK9IndexListPfRS8_R12ActiveLightsP5RectTIfEP13TargetEyeMask(i32, HEAP32[i35 >> 2] | 0, HEAP32[i36 >> 2] | 0, i27, HEAP32[i38 >> 2] | 0, i28, i14, HEAP32[i33 >> 2] | 0, HEAP32[i34 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i27 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i28 >> 2] = 0;
 i42 = __Z18GetQualitySettingsv() | 0;
 do if (HEAP32[(HEAP32[i42 + 28 >> 2] | 0) + ((HEAP32[i42 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0) if (HEAP32[i31 + 820 >> 2] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP16[gb + 1110752 + 6 >> 1] | 0) > -1) {
   HEAP32[i30 >> 2] = 0;
   HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110752 | 0, i29);
   i1 = gb + 1110752 | 0;
  } else i1 = 0;
  i42 = HEAP32[i6 >> 2] | 0;
  __ZL23FindShadowCastingLightsR12ActiveLightsR13dynamic_arrayI13ShadowedLightLj16EEjj(i14, i12, i42, (HEAP32[i32 + 340 >> 2] | 0) + i42 + (HEAP32[i32 + 344 >> 2] | 0) | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) break;
  __Z27CullLocalLightShadowCastersiibR11CullResults(i2, i1, (HEAP8[i31 + 816 >> 0] | 0) != 0, i32);
 } while (0);
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, i10);
  HEAP32[i34 >> 2] = 0;
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i8);
  HEAP32[i33 >> 2] = 0;
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i19);
  HEAP32[i39 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i17);
  HEAP32[i38 >> 2] = 0;
 }
 if ((HEAP32[i24 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i25);
  HEAP32[i37 >> 2] = 0;
 }
 if ((HEAP32[i22 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i23);
  HEAP32[i36 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i21);
  HEAP32[i35 >> 2] = 0;
 }
 if (!i15) {
  STACKTOP = i40;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i40;
 return;
}

function _UNITY_LZ4_decompress_safe_continue(i2, i24, i25, i4, i5) {
 i2 = i2 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0;
 i27 = i2 + 8 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 i26 = i2 + 12 | 0;
 i3 = HEAP32[i26 >> 2] | 0;
 do if ((i1 | 0) == (i25 | 0)) {
  i20 = i25 + (0 - i3) | 0;
  i18 = HEAP32[i2 + 4 >> 2] | 0;
  i22 = i24 + i4 | 0;
  i23 = i25 + i5 | 0;
  i21 = i20 + (0 - i18) | 0;
  i17 = (HEAP32[i2 >> 2] | 0) + i18 | 0;
  i18 = i18 >>> 0 < 65536;
  i19 = i23 + -12 | 0;
  if (!i5) {
   if ((i4 | 0) == 1) i1 = (HEAP8[i24 >> 0] | 0) != 0; else i1 = 1;
   i27 = i1 << 31 >> 31;
   return i27 | 0;
  }
  i10 = i22 + -15 | 0;
  i11 = i22 + -8 | 0;
  i12 = i22 + -5 | 0;
  i13 = i23 + -5 | 0;
  i14 = i20;
  i15 = i23 + -8 | 0;
  i16 = i15;
  i5 = i24;
  i4 = i25;
  L10 : while (1) {
   i1 = i5 + 1 | 0;
   i8 = HEAPU8[i5 >> 0] | 0;
   i2 = i8 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i9 = i1;
     i1 = i1 + 1 | 0;
     i9 = HEAP8[i9 >> 0] | 0;
     i2 = (i9 & 255) + i2 | 0;
    } while (i9 << 24 >> 24 == -1 & i1 >>> 0 < i10 >>> 0);
    if ((i2 | 0) < 0) {
     i3 = 38;
     break;
    }
   }
   i9 = i4 + i2 | 0;
   i5 = i1 + i2 | 0;
   if (i9 >>> 0 > i19 >>> 0 | i5 >>> 0 > i11 >>> 0) {
    i3 = 11;
    break;
   } else i2 = i4;
   while (1) {
    i6 = i1;
    i3 = i6;
    i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    i6 = i6 + 4 | 0;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i7 = i2;
    i4 = i7;
    HEAP8[i4 >> 0] = i3;
    HEAP8[i4 + 1 >> 0] = i3 >> 8;
    HEAP8[i4 + 2 >> 0] = i3 >> 16;
    HEAP8[i4 + 3 >> 0] = i3 >> 24;
    i7 = i7 + 4 | 0;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i3 = HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 >> 0];
   i6 = i3 & 65535;
   i7 = i9 + (0 - i3) | 0;
   i1 = i5 + 2 | 0;
   if (i18 & i7 >>> 0 < i21 >>> 0) {
    i3 = 38;
    break;
   }
   i2 = i8 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i12 >>> 0) {
      i3 = 38;
      break L10;
     }
     i8 = i1;
     i1 = i1 + 1 | 0;
     i8 = HEAP8[i8 >> 0] | 0;
     i2 = (i8 & 255) + i2 | 0;
    } while (i8 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) {
     i3 = 38;
     break;
    }
   }
   i4 = i2 + 4 | 0;
   i8 = i9 + i4 | 0;
   if (i7 >>> 0 < i20 >>> 0) {
    if (i8 >>> 0 > i13 >>> 0) {
     i3 = 38;
     break;
    }
    i3 = i14 - i7 | 0;
    i2 = i17 + (0 - i3) | 0;
    if (i4 >>> 0 <= i3 >>> 0) {
     _memcpy(i9 | 0, i2 | 0, i4 | 0) | 0;
     i5 = i1;
     i4 = i8;
     continue;
    }
    _memcpy(i9 | 0, i2 | 0, i3 | 0) | 0;
    i2 = i9 + i3 | 0;
    i3 = i4 - i3 | 0;
    if (i3 >>> 0 <= (i2 - i14 | 0) >>> 0) {
     _memcpy(i2 | 0, i20 | 0, i3 | 0) | 0;
     i5 = i1;
     i4 = i2 + i3 | 0;
     continue;
    }
    i5 = i2 + i3 | 0;
    if ((i3 | 0) > 0) i3 = i20; else {
     i5 = i1;
     i4 = i2;
     continue;
    }
    while (1) {
     i4 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     if (i4 >>> 0 < i5 >>> 0) {
      i3 = i3 + 1 | 0;
      i2 = i4;
     } else {
      i5 = i1;
      continue L10;
     }
    }
   }
   if ((i6 & 65535) < 8) {
    i6 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
    HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
    HEAP8[i9 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
    HEAP8[i9 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
    HEAP8[i9 + 3 >> 0] = HEAP8[i7 + 3 >> 0] | 0;
    i3 = i7 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
    i7 = i9 + 4 | 0;
    i5 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i7 >> 0] = i5;
    HEAP8[i7 + 1 >> 0] = i5 >> 8;
    HEAP8[i7 + 2 >> 0] = i5 >> 16;
    HEAP8[i7 + 3 >> 0] = i5 >> 24;
    i3 = i3 + (0 - i6) | 0;
   } else {
    i6 = i7;
    i4 = i6;
    i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
    i6 = i6 + 4 | 0;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i3 = i9;
    i5 = i3;
    HEAP8[i5 >> 0] = i4;
    HEAP8[i5 + 1 >> 0] = i4 >> 8;
    HEAP8[i5 + 2 >> 0] = i4 >> 16;
    HEAP8[i5 + 3 >> 0] = i4 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i6;
    HEAP8[i3 + 1 >> 0] = i6 >> 8;
    HEAP8[i3 + 2 >> 0] = i6 >> 16;
    HEAP8[i3 + 3 >> 0] = i6 >> 24;
    i3 = i7 + 8 | 0;
   }
   i2 = i9 + 8 | 0;
   if (i8 >>> 0 <= i19 >>> 0) while (1) {
    i7 = i3;
    i5 = i7;
    i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
    i7 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i9 = i2;
    i6 = i9;
    HEAP8[i6 >> 0] = i5;
    HEAP8[i6 + 1 >> 0] = i5 >> 8;
    HEAP8[i6 + 2 >> 0] = i5 >> 16;
    HEAP8[i6 + 3 >> 0] = i5 >> 24;
    i9 = i9 + 4 | 0;
    HEAP8[i9 >> 0] = i7;
    HEAP8[i9 + 1 >> 0] = i7 >> 8;
    HEAP8[i9 + 2 >> 0] = i7 >> 16;
    HEAP8[i9 + 3 >> 0] = i7 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i8 >>> 0) i3 = i3 + 8 | 0; else {
     i5 = i1;
     i4 = i8;
     continue L10;
    }
   }
   if (i8 >>> 0 > i13 >>> 0) {
    i3 = 38;
    break;
   }
   if (i2 >>> 0 < i15 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i7 = i5;
     i28 = i7;
     i28 = HEAPU8[i28 >> 0] | HEAPU8[i28 + 1 >> 0] << 8 | HEAPU8[i28 + 2 >> 0] << 16 | HEAPU8[i28 + 3 >> 0] << 24;
     i7 = i7 + 4 | 0;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i9 = i4;
     i6 = i9;
     HEAP8[i6 >> 0] = i28;
     HEAP8[i6 + 1 >> 0] = i28 >> 8;
     HEAP8[i6 + 2 >> 0] = i28 >> 16;
     HEAP8[i6 + 3 >> 0] = i28 >> 24;
     i9 = i9 + 4 | 0;
     HEAP8[i9 >> 0] = i7;
     HEAP8[i9 + 1 >> 0] = i7 >> 8;
     HEAP8[i9 + 2 >> 0] = i7 >> 16;
     HEAP8[i9 + 3 >> 0] = i7 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i15 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i16 - i2) | 0;
    i2 = i15;
   }
   if (i2 >>> 0 >= i8 >>> 0) {
    i5 = i1;
    i4 = i8;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i8 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i5 = i1;
     i4 = i8;
     continue L10;
    }
   }
  }
  if ((i3 | 0) == 11) if (i9 >>> 0 > i23 >>> 0 | (i5 | 0) != (i22 | 0)) i3 = 38; else {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = i9 - i25 | 0;
  }
  if ((i3 | 0) == 38) i1 = i24 + -1 - i1 | 0;
  if ((i1 | 0) < 1) {
   i28 = i1;
   return i28 | 0;
  } else {
   HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + i1;
   i2 = i1;
   i1 = (HEAP32[i27 >> 2] | 0) + i1 | 0;
   break;
  }
 } else {
  HEAP32[i2 + 4 >> 2] = i3;
  i19 = 0 - i3 | 0;
  i20 = i1 + i19 | 0;
  HEAP32[i2 >> 2] = i20;
  i21 = i24 + i4 | 0;
  i22 = i25 + i5 | 0;
  i19 = i25 + i19 | 0;
  i20 = i20 + i3 | 0;
  i17 = i3 >>> 0 < 65536;
  i18 = i22 + -12 | 0;
  if (!i5) {
   if ((i4 | 0) == 1) i1 = (HEAP8[i24 >> 0] | 0) != 0; else i1 = 1;
   i28 = i1 << 31 >> 31;
   return i28 | 0;
  }
  i10 = i21 + -15 | 0;
  i11 = i21 + -8 | 0;
  i12 = i21 + -5 | 0;
  i13 = i22 + -5 | 0;
  i16 = i25;
  i14 = i22 + -8 | 0;
  i15 = i14;
  i5 = i24;
  i4 = i25;
  L72 : while (1) {
   i1 = i5 + 1 | 0;
   i8 = HEAPU8[i5 >> 0] | 0;
   i2 = i8 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     i28 = i1;
     i1 = i1 + 1 | 0;
     i28 = HEAP8[i28 >> 0] | 0;
     i2 = (i28 & 255) + i2 | 0;
    } while (i28 << 24 >> 24 == -1 & i1 >>> 0 < i10 >>> 0);
    if ((i2 | 0) < 0) {
     i3 = 77;
     break;
    }
   }
   i9 = i4 + i2 | 0;
   i5 = i1 + i2 | 0;
   if (i9 >>> 0 > i18 >>> 0 | i5 >>> 0 > i11 >>> 0) {
    i3 = 50;
    break;
   } else i2 = i4;
   while (1) {
    i23 = i1;
    i6 = i23;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i23 = i23 + 4 | 0;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i28 = i2;
    i7 = i28;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i28 = i28 + 4 | 0;
    HEAP8[i28 >> 0] = i23;
    HEAP8[i28 + 1 >> 0] = i23 >> 8;
    HEAP8[i28 + 2 >> 0] = i23 >> 16;
    HEAP8[i28 + 3 >> 0] = i23 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i3 = HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 >> 0];
   i6 = i3 & 65535;
   i7 = i9 + (0 - i3) | 0;
   i1 = i5 + 2 | 0;
   if (i17 & i7 >>> 0 < i19 >>> 0) {
    i3 = 77;
    break;
   }
   i2 = i8 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    do {
     if (i1 >>> 0 > i12 >>> 0) {
      i3 = 77;
      break L72;
     }
     i28 = i1;
     i1 = i1 + 1 | 0;
     i28 = HEAP8[i28 >> 0] | 0;
     i2 = (i28 & 255) + i2 | 0;
    } while (i28 << 24 >> 24 == -1);
    if ((i2 | 0) < 0) {
     i3 = 77;
     break;
    }
   }
   i4 = i2 + 4 | 0;
   i8 = i9 + i4 | 0;
   if (i7 >>> 0 < i25 >>> 0) {
    if (i8 >>> 0 > i13 >>> 0) {
     i3 = 77;
     break;
    }
    i3 = i16 - i7 | 0;
    i2 = i20 + (0 - i3) | 0;
    if (i4 >>> 0 <= i3 >>> 0) {
     _memcpy(i9 | 0, i2 | 0, i4 | 0) | 0;
     i5 = i1;
     i4 = i8;
     continue;
    }
    _memcpy(i9 | 0, i2 | 0, i3 | 0) | 0;
    i2 = i9 + i3 | 0;
    i3 = i4 - i3 | 0;
    if (i3 >>> 0 <= (i2 - i16 | 0) >>> 0) {
     _memcpy(i2 | 0, i25 | 0, i3 | 0) | 0;
     i5 = i1;
     i4 = i2 + i3 | 0;
     continue;
    }
    i5 = i2 + i3 | 0;
    if ((i3 | 0) > 0) i3 = i25; else {
     i5 = i1;
     i4 = i2;
     continue;
    }
    while (1) {
     i4 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     if (i4 >>> 0 < i5 >>> 0) {
      i3 = i3 + 1 | 0;
      i2 = i4;
     } else {
      i5 = i1;
      continue L72;
     }
    }
   }
   if ((i6 & 65535) < 8) {
    i28 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
    HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
    HEAP8[i9 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
    HEAP8[i9 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
    HEAP8[i9 + 3 >> 0] = HEAP8[i7 + 3 >> 0] | 0;
    i3 = i7 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
    i23 = i9 + 4 | 0;
    i7 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i23 >> 0] = i7;
    HEAP8[i23 + 1 >> 0] = i7 >> 8;
    HEAP8[i23 + 2 >> 0] = i7 >> 16;
    HEAP8[i23 + 3 >> 0] = i7 >> 24;
    i3 = i3 + (0 - i28) | 0;
   } else {
    i28 = i7;
    i6 = i28;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i28 = i28 + 4 | 0;
    i28 = HEAPU8[i28 >> 0] | HEAPU8[i28 + 1 >> 0] << 8 | HEAPU8[i28 + 2 >> 0] << 16 | HEAPU8[i28 + 3 >> 0] << 24;
    i3 = i9;
    i23 = i3;
    HEAP8[i23 >> 0] = i6;
    HEAP8[i23 + 1 >> 0] = i6 >> 8;
    HEAP8[i23 + 2 >> 0] = i6 >> 16;
    HEAP8[i23 + 3 >> 0] = i6 >> 24;
    i3 = i3 + 4 | 0;
    HEAP8[i3 >> 0] = i28;
    HEAP8[i3 + 1 >> 0] = i28 >> 8;
    HEAP8[i3 + 2 >> 0] = i28 >> 16;
    HEAP8[i3 + 3 >> 0] = i28 >> 24;
    i3 = i7 + 8 | 0;
   }
   i2 = i9 + 8 | 0;
   if (i8 >>> 0 <= i18 >>> 0) while (1) {
    i23 = i3;
    i7 = i23;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i23 = i23 + 4 | 0;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i28 = i2;
    i9 = i28;
    HEAP8[i9 >> 0] = i7;
    HEAP8[i9 + 1 >> 0] = i7 >> 8;
    HEAP8[i9 + 2 >> 0] = i7 >> 16;
    HEAP8[i9 + 3 >> 0] = i7 >> 24;
    i28 = i28 + 4 | 0;
    HEAP8[i28 >> 0] = i23;
    HEAP8[i28 + 1 >> 0] = i23 >> 8;
    HEAP8[i28 + 2 >> 0] = i23 >> 16;
    HEAP8[i28 + 3 >> 0] = i23 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i8 >>> 0) i3 = i3 + 8 | 0; else {
     i5 = i1;
     i4 = i8;
     continue L72;
    }
   }
   if (i8 >>> 0 > i13 >>> 0) {
    i3 = 77;
    break;
   }
   if (i2 >>> 0 < i14 >>> 0) {
    i4 = i2;
    i5 = i3;
    while (1) {
     i23 = i5;
     i7 = i23;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i23 = i23 + 4 | 0;
     i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
     i28 = i4;
     i9 = i28;
     HEAP8[i9 >> 0] = i7;
     HEAP8[i9 + 1 >> 0] = i7 >> 8;
     HEAP8[i9 + 2 >> 0] = i7 >> 16;
     HEAP8[i9 + 3 >> 0] = i7 >> 24;
     i28 = i28 + 4 | 0;
     HEAP8[i28 >> 0] = i23;
     HEAP8[i28 + 1 >> 0] = i23 >> 8;
     HEAP8[i28 + 2 >> 0] = i23 >> 16;
     HEAP8[i28 + 3 >> 0] = i23 >> 24;
     i4 = i4 + 8 | 0;
     if (i4 >>> 0 >= i14 >>> 0) break; else i5 = i5 + 8 | 0;
    }
    i3 = i3 + (i15 - i2) | 0;
    i2 = i14;
   }
   if (i2 >>> 0 >= i8 >>> 0) {
    i5 = i1;
    i4 = i8;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i8 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i5 = i1;
     i4 = i8;
     continue L72;
    }
   }
  }
  if ((i3 | 0) == 50) if (i9 >>> 0 > i22 >>> 0 | (i5 | 0) != (i21 | 0)) i3 = 77; else {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = i9 - i16 | 0;
  }
  if ((i3 | 0) == 77) i1 = i24 + -1 - i1 | 0;
  if ((i1 | 0) < 1) {
   i28 = i1;
   return i28 | 0;
  } else {
   HEAP32[i26 >> 2] = i1;
   i2 = i1;
   i1 = i25 + i1 | 0;
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = i1;
 i28 = i2;
 return i28 | 0;
}

function __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i30) {
 i5 = i5 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, f72 = f0;
 i31 = HEAP32[i5 >> 2] | 0;
 i37 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = HEAP32[i31 >> 2] | 0;
 i40 = i31 + 4 | 0;
 i14 = HEAP32[i40 >> 2] | 0;
 i41 = i31 + 8 | 0;
 i12 = HEAP32[i41 >> 2] | 0;
 i7 = HEAP32[i37 >> 2] | 0;
 i42 = i37 + 4 | 0;
 i8 = HEAP32[i42 >> 2] | 0;
 i32 = i37 + 8 | 0;
 i9 = HEAP32[i32 >> 2] | 0;
 i33 = i31 + 16 | 0;
 i4 = HEAP32[i33 >> 2] | 0;
 i34 = i31 + 20 | 0;
 i11 = HEAP32[i34 >> 2] | 0;
 i35 = i31 + 24 | 0;
 i6 = HEAP32[i35 >> 2] | 0;
 i36 = i37 + 16 | 0;
 i1 = HEAP32[i36 >> 2] | 0;
 i38 = i37 + 20 | 0;
 i2 = HEAP32[i38 >> 2] | 0;
 i39 = i37 + 24 | 0;
 i3 = HEAP32[i39 >> 2] | 0;
 i15 = HEAP32[i5 + 16 >> 2] | 0;
 i29 = HEAP16[i5 + 26 >> 1] | 0;
 i28 = i15 + ((i29 & 65535) << 4) | 0;
 if (!(i29 << 16 >> 16)) {
  i21 = i12;
  i16 = i14;
  i15 = i10;
  i24 = i9;
  i23 = i8;
  i22 = i7;
  i27 = i6;
  i26 = i11;
  i25 = i4;
  i30 = i3;
  i29 = i2;
  i28 = i1;
  HEAP32[i31 >> 2] = i15;
  HEAP32[i40 >> 2] = i16;
  HEAP32[i41 >> 2] = i21;
  HEAP32[i37 >> 2] = i22;
  HEAP32[i42 >> 2] = i23;
  HEAP32[i32 >> 2] = i24;
  HEAP32[i33 >> 2] = i25;
  HEAP32[i34 >> 2] = i26;
  HEAP32[i35 >> 2] = i27;
  HEAP32[i36 >> 2] = i28;
  HEAP32[i38 >> 2] = i29;
  HEAP32[i39 >> 2] = i30;
  return;
 }
 i29 = i30 + 1 | 0;
 i5 = i11;
 i11 = i14;
 do {
  i16 = i15 + 32 | 0;
  i14 = HEAP8[i15 + 5 >> 0] | 0;
  i21 = i14 & 255;
  i22 = HEAP8[i15 + 6 >> 0] | 0;
  i27 = i22 & 255;
  i26 = (i21 * 80 | 0) + 32 | 0;
  i25 = i15 + i26 | 0;
  i23 = HEAP32[i15 + 24 >> 2] | 0;
  i24 = HEAP32[i15 + 28 >> 2] | 0;
  if (!(i14 << 24 >> 24)) f13 = Math_fround(0.0); else {
   f17 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = Math_fround(0.0);
   i14 = 0;
   do {
    i71 = i14;
    i14 = i14 + 1 | 0;
    f58 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) >> 2]);
    f57 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 4 >> 2]);
    f56 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 8 >> 2]);
    f20 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 12 >> 2]);
    f53 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 16 >> 2]);
    f61 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 20 >> 2]);
    f50 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 24 >> 2]);
    i43 = i16 + (i71 * 80 | 0) + 28 | 0;
    f19 = Math_fround(HEAPF32[i43 >> 2]);
    f47 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 32 >> 2]);
    f52 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 36 >> 2]);
    f69 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 40 >> 2]);
    f44 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 60 >> 2]);
    f70 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 44 >> 2]);
    f68 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 76 >> 2]);
    f67 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(f67 * f58);
    f66 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(f45 + Math_fround(f66 * f57));
    f65 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(f45 + Math_fround(f65 * f56));
    f55 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = Math_fround(f55 * f53);
    f54 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f53 + Math_fround(f54 * f61));
    f53 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f50 = Math_fround(f61 + Math_fround(f53 * f50));
    f61 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f51 = Math_fround(f61 * f58);
    f60 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f51 = Math_fround(f51 + Math_fround(f60 * f57));
    f59 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f51 = Math_fround(f51 + Math_fround(f59 * f56));
    f49 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f47 = Math_fround(f49 * f47);
    f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f52 = Math_fround(f47 + Math_fround(f48 * f52));
    f47 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f70 = Math_fround(Math_fround(f20 * f44) - f70);
    f69 = Math_fround(Math_fround(f45 + f50) - Math_fround(f51 + Math_fround(f52 + Math_fround(f47 * f69))));
    f52 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 48 >> 2]);
    f51 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 52 >> 2]);
    f50 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 56 >> 2]);
    f45 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 64 >> 2]);
    f44 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 68 >> 2]);
    f46 = Math_fround(HEAPF32[i16 + (i71 * 80 | 0) + 72 >> 2]);
    f64 = Math_fround(f17 * f58);
    f63 = Math_fround(f17 * f57);
    f62 = Math_fround(f17 * f56);
    f58 = Math_fround(f18 * f58);
    f57 = Math_fround(f18 * f57);
    f56 = Math_fround(f18 * f56);
    f69 = Math_fround(f70 - Math_fround(f20 * f69));
    f20 = Math_fround(-f19);
    f20 = Math_fround(f19 + (f69 > f20 ? f69 : f20));
    f20 = f20 > f68 ? f68 : f20;
    f19 = Math_fround(f20 - f19);
    f64 = Math_fround(f67 + Math_fround(f64 * f19));
    f63 = Math_fround(f66 + Math_fround(f63 * f19));
    f62 = Math_fround(f65 + Math_fround(f62 * f19));
    i10 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
    f58 = Math_fround(f61 + Math_fround(f58 * f19));
    f57 = Math_fround(f60 + Math_fround(f57 * f19));
    f56 = Math_fround(f59 + Math_fround(f56 * f19));
    i7 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
    f52 = Math_fround(f55 + Math_fround(f52 * f19));
    f51 = Math_fround(f54 + Math_fround(f51 * f19));
    f50 = Math_fround(f53 + Math_fround(f50 * f19));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
    f45 = Math_fround(f49 + Math_fround(f45 * f19));
    f44 = Math_fround(f48 + Math_fround(f44 * f19));
    f19 = Math_fround(f47 + Math_fround(f46 * f19));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i43 >> 2] = f20;
    f13 = Math_fround(f13 + f20);
   } while ((i14 | 0) != (i21 | 0));
  }
  if (i22 << 24 >> 24 != 0 & (HEAP8[i30 >> 0] | 0) != 0) {
   f20 = Math_fround(HEAPF32[i15 + 16 >> 2]);
   f20 = Math_fround(f13 * f20);
   f18 = Math_fround(f13 * Math_fround(HEAPF32[i15 + 20 >> 2]));
   f19 = Math_fround(-f18);
   f17 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i14 = 0;
   while (1) {
    i16 = i14 + 1 | 0;
    f54 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) >> 2]);
    f55 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 4 >> 2]);
    f56 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 8 >> 2]);
    i22 = i25 + (i14 * 96 | 0) + 12 | 0;
    f68 = Math_fround(HEAPF32[i22 >> 2]);
    f58 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 16 >> 2]);
    f51 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 20 >> 2]);
    f66 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 24 >> 2]);
    f44 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 28 >> 2]);
    f64 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 32 >> 2]);
    f60 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 36 >> 2]);
    f69 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 40 >> 2]);
    f70 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 44 >> 2]);
    i23 = i25 + (i14 * 96 | 0) + 48 | 0;
    i71 = i25 + (i14 * 96 | 0) + 60 | 0;
    i43 = HEAP32[i71 >> 2] | 0;
    f72 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 76 >> 2]);
    f45 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f67 = Math_fround(f45 * f54);
    f46 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f67 = Math_fround(f67 + Math_fround(f46 * f55));
    f47 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f67 = Math_fround(f67 + Math_fround(f47 * f56));
    f59 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f58 = Math_fround(f59 * f58);
    f57 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f51 = Math_fround(f58 + Math_fround(f57 * f51));
    f58 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f66 = Math_fround(f51 + Math_fround(f58 * f66));
    f51 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f51 * f54);
    f52 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f61 + Math_fround(f52 * f55));
    f53 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f61 + Math_fround(f53 * f56));
    f62 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f64 = Math_fround(f62 * f64);
    f63 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f60 = Math_fround(f64 + Math_fround(f63 * f60));
    f64 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f69 = Math_fround(Math_fround(f67 + f66) - Math_fround(f61 + Math_fround(f60 + Math_fround(f64 * f69))));
    f72 = Math_fround(f68 - Math_fround(f44 * Math_fround(f70 - f72)));
    f70 = Math_fround(HEAPF32[i23 >> 2]);
    f60 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 52 >> 2]);
    f61 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 56 >> 2]);
    f66 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 64 >> 2]);
    f67 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 68 >> 2]);
    f65 = Math_fround(HEAPF32[i25 + (i14 * 96 | 0) + 72 >> 2]);
    f48 = Math_fround(f17 * f54);
    f49 = Math_fround(f17 * f55);
    f50 = Math_fround(f17 * f56);
    f54 = Math_fround(f13 * f54);
    f55 = Math_fround(f13 * f55);
    f56 = Math_fround(f13 * f56);
    f69 = Math_fround(f72 - Math_fround(f44 * f69));
    i24 = Math_fround(Math_abs(Math_fround(f69))) > f20;
    f44 = f69 < f19 ? f19 : f69;
    f69 = i24 ? (f18 > f44 ? f44 : f18) : f69;
    f68 = Math_fround(f69 - f68);
    f48 = Math_fround(f45 + Math_fround(f48 * f68));
    f49 = Math_fround(f46 + Math_fround(f49 * f68));
    f50 = Math_fround(f47 + Math_fround(f50 * f68));
    i10 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
    f54 = Math_fround(f51 + Math_fround(f54 * f68));
    f55 = Math_fround(f52 + Math_fround(f55 * f68));
    f56 = Math_fround(f53 + Math_fround(f56 * f68));
    i7 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
    f59 = Math_fround(f59 + Math_fround(f70 * f68));
    f60 = Math_fround(f57 + Math_fround(f60 * f68));
    f61 = Math_fround(f58 + Math_fround(f61 * f68));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
    f66 = Math_fround(f62 + Math_fround(f66 * f68));
    f67 = Math_fround(f63 + Math_fround(f67 * f68));
    f68 = Math_fround(f64 + Math_fround(f65 * f68));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i22 >> 2] = f69;
    HEAPF32[i23 >> 2] = f70;
    HEAP32[i71 >> 2] = i24 ? 1065353216 : i43;
    if ((i16 | 0) == (i27 | 0)) break; else i14 = i16;
   }
  }
  i15 = i15 + (i26 + (i27 * 96 | 0)) | 0;
 } while (i15 >>> 0 < i28 >>> 0);
 HEAP32[i31 >> 2] = i10;
 HEAP32[i40 >> 2] = i11;
 HEAP32[i41 >> 2] = i12;
 HEAP32[i37 >> 2] = i7;
 HEAP32[i42 >> 2] = i8;
 HEAP32[i32 >> 2] = i9;
 HEAP32[i33 >> 2] = i4;
 HEAP32[i34 >> 2] = i5;
 HEAP32[i35 >> 2] = i6;
 HEAP32[i36 >> 2] = i1;
 HEAP32[i38 >> 2] = i2;
 HEAP32[i39 >> 2] = i3;
 return;
}

function __ZN5physx9NpFactoryC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5physx13GuMeshFactoryC2Ev(i2);
 HEAP32[i2 >> 2] = gb + 93248 + 8;
 HEAP32[i2 + 408 >> 2] = 0;
 HEAP8[i2 + 400 >> 0] = 1;
 HEAP32[i2 + 404 >> 2] = i2 + 144;
 HEAP32[i2 + 412 >> 2] = 64;
 HEAP32[i2 + 416 >> 2] = 32;
 HEAP32[i2 + 420 >> 2] = 0;
 HEAP32[i2 + 424 >> 2] = 0;
 HEAP32[i2 + 428 >> 2] = 1536;
 HEAP32[i2 + 432 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 436 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i4 | 0, i5 | 0, 896, (i1 ? gb + 767436 | 0 : gb + 837976 | 0) | 0, gb + 686195 | 0, 63) | 0;
 __ZN5physx24NpPtrTableStorageManagerC2Ev(i1);
 HEAP32[i2 + 440 >> 2] = i1;
 i1 = i2 + 444 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 468 >> 2] = Math_fround(.75);
 HEAP32[i2 + 472 >> 2] = -1;
 HEAP32[i2 + 476 >> 2] = 0;
 HEAP32[i2 + 480 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i1, 64);
 i1 = i2 + 484 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 508 >> 2] = Math_fround(.75);
 HEAP32[i2 + 512 >> 2] = -1;
 HEAP32[i2 + 516 >> 2] = 0;
 HEAP32[i2 + 520 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i1, 64);
 i1 = i2 + 524 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 548 >> 2] = Math_fround(.75);
 HEAP32[i2 + 552 >> 2] = -1;
 HEAP32[i2 + 556 >> 2] = 0;
 HEAP32[i2 + 560 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i1, 64);
 i1 = i2 + 564 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 588 >> 2] = Math_fround(.75);
 HEAP32[i2 + 592 >> 2] = -1;
 HEAP32[i2 + 596 >> 2] = 0;
 HEAP32[i2 + 600 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i1, 64);
 i1 = i2 + 604 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 628 >> 2] = Math_fround(.75);
 HEAP32[i2 + 632 >> 2] = -1;
 HEAP32[i2 + 636 >> 2] = 0;
 HEAP32[i2 + 640 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i2 + 912 >> 2] = 0;
 HEAP8[i2 + 904 >> 0] = 1;
 HEAP32[i2 + 908 >> 2] = i2 + 648;
 HEAP32[i2 + 916 >> 2] = 64;
 HEAP32[i2 + 920 >> 2] = 14;
 HEAP32[i2 + 924 >> 2] = 0;
 HEAP32[i2 + 928 >> 2] = 0;
 HEAP32[i2 + 932 >> 2] = 4096;
 HEAP32[i2 + 936 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 940 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 1212 >> 2] = 0;
 HEAP8[i2 + 1204 >> 0] = 1;
 HEAP32[i2 + 1208 >> 2] = i2 + 948;
 HEAP32[i2 + 1216 >> 2] = 64;
 HEAP32[i2 + 1220 >> 2] = 36;
 HEAP32[i2 + 1224 >> 2] = 0;
 HEAP32[i2 + 1228 >> 2] = 0;
 HEAP32[i2 + 1232 >> 2] = 4096;
 HEAP32[i2 + 1236 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 1240 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 1512 >> 2] = 0;
 HEAP8[i2 + 1504 >> 0] = 1;
 HEAP32[i2 + 1508 >> 2] = i2 + 1248;
 HEAP32[i2 + 1516 >> 2] = 64;
 HEAP32[i2 + 1520 >> 2] = 19;
 HEAP32[i2 + 1524 >> 2] = 0;
 HEAP32[i2 + 1528 >> 2] = 0;
 HEAP32[i2 + 1532 >> 2] = 4096;
 HEAP32[i2 + 1536 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 1540 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 1812 >> 2] = 0;
 HEAP8[i2 + 1804 >> 0] = 1;
 HEAP32[i2 + 1808 >> 2] = i2 + 1548;
 HEAP32[i2 + 1816 >> 2] = 64;
 HEAP32[i2 + 1820 >> 2] = 93;
 HEAP32[i2 + 1824 >> 2] = 0;
 HEAP32[i2 + 1828 >> 2] = 0;
 HEAP32[i2 + 1832 >> 2] = 4096;
 HEAP32[i2 + 1836 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 1840 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 2112 >> 2] = 0;
 HEAP8[i2 + 2104 >> 0] = 1;
 HEAP32[i2 + 2108 >> 2] = i2 + 1848;
 HEAP32[i2 + 2116 >> 2] = 64;
 HEAP32[i2 + 2120 >> 2] = 31;
 HEAP32[i2 + 2124 >> 2] = 0;
 HEAP32[i2 + 2128 >> 2] = 0;
 HEAP32[i2 + 2132 >> 2] = 4096;
 HEAP32[i2 + 2136 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 2140 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 2412 >> 2] = 0;
 HEAP8[i2 + 2404 >> 0] = 1;
 HEAP32[i2 + 2408 >> 2] = i2 + 2148;
 HEAP32[i2 + 2416 >> 2] = 64;
 HEAP32[i2 + 2420 >> 2] = 64;
 HEAP32[i2 + 2424 >> 2] = 0;
 HEAP32[i2 + 2428 >> 2] = 0;
 HEAP32[i2 + 2432 >> 2] = 4096;
 HEAP32[i2 + 2436 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 2440 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 2712 >> 2] = 0;
 HEAP8[i2 + 2704 >> 0] = 1;
 HEAP32[i2 + 2708 >> 2] = i2 + 2448;
 HEAP32[i2 + 2716 >> 2] = 64;
 HEAP32[i2 + 2720 >> 2] = 37;
 HEAP32[i2 + 2724 >> 2] = 0;
 HEAP32[i2 + 2728 >> 2] = 0;
 HEAP32[i2 + 2732 >> 2] = 4096;
 HEAP32[i2 + 2736 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 2740 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 3012 >> 2] = 0;
 HEAP8[i2 + 3004 >> 0] = 1;
 HEAP32[i2 + 3008 >> 2] = i2 + 2748;
 HEAP32[i2 + 3016 >> 2] = 64;
 HEAP32[i2 + 3020 >> 2] = 12;
 HEAP32[i2 + 3024 >> 2] = 0;
 HEAP32[i2 + 3028 >> 2] = 0;
 HEAP32[i2 + 3032 >> 2] = 4096;
 HEAP32[i2 + 3036 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 3040 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 3312 >> 2] = 0;
 HEAP8[i2 + 3304 >> 0] = 1;
 HEAP32[i2 + 3308 >> 2] = i2 + 3048;
 HEAP32[i2 + 3316 >> 2] = 64;
 HEAP32[i2 + 3320 >> 2] = 20;
 HEAP32[i2 + 3324 >> 2] = 0;
 HEAP32[i2 + 3328 >> 2] = 0;
 HEAP32[i2 + 3332 >> 2] = 4096;
 HEAP32[i2 + 3336 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 3340 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 3612 >> 2] = 0;
 HEAP8[i2 + 3604 >> 0] = 1;
 HEAP32[i2 + 3608 >> 2] = i2 + 3348;
 HEAP32[i2 + 3616 >> 2] = 64;
 HEAP32[i2 + 3620 >> 2] = 20;
 HEAP32[i2 + 3624 >> 2] = 0;
 HEAP32[i2 + 3628 >> 2] = 0;
 HEAP32[i2 + 3632 >> 2] = 4096;
 HEAP32[i2 + 3636 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 3640 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 3912 >> 2] = 0;
 HEAP8[i2 + 3904 >> 0] = 1;
 HEAP32[i2 + 3908 >> 2] = i2 + 3648;
 HEAP32[i2 + 3916 >> 2] = 64;
 HEAP32[i2 + 3920 >> 2] = 20;
 HEAP32[i2 + 3924 >> 2] = 0;
 HEAP32[i2 + 3928 >> 2] = 0;
 HEAP32[i2 + 3932 >> 2] = 4096;
 HEAP32[i2 + 3936 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 3940 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 3944 >> 2] = 0;
 HEAP32[i2 + 3948 >> 2] = 0;
 HEAP32[i2 + 3952 >> 2] = 0;
 HEAP32[i2 + 4224 >> 2] = 0;
 HEAP8[i2 + 4216 >> 0] = 1;
 HEAP32[i2 + 4220 >> 2] = i2 + 3960;
 HEAP32[i2 + 4228 >> 2] = 64;
 HEAP32[i2 + 4232 >> 2] = 26;
 HEAP32[i2 + 4236 >> 2] = 0;
 HEAP32[i2 + 4240 >> 2] = 0;
 HEAP32[i2 + 4244 >> 2] = 4096;
 HEAP32[i2 + 4248 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 4252 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 4524 >> 2] = 0;
 HEAP8[i2 + 4516 >> 0] = 1;
 HEAP32[i2 + 4520 >> 2] = i2 + 4260;
 HEAP32[i2 + 4528 >> 2] = 64;
 HEAP32[i2 + 4532 >> 2] = 113;
 HEAP32[i2 + 4536 >> 2] = 0;
 HEAP32[i2 + 4540 >> 2] = 0;
 HEAP32[i2 + 4544 >> 2] = 4096;
 HEAP32[i2 + 4548 >> 2] = 0;
 i1 = i2 + 4552 | 0;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i2) {
  i5 = 0;
  HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImplC2Ev(i5);
  return;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i5 = mftCall_iiiiii(i3 | 0, i4 | 0, i2 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i1 >> 2] = i5;
 __ZN5physx6shdfnd9MutexImplC2Ev(i5);
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i88, i7, i2, i87, i1) {
 i88 = i88 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i87 = i87 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, i74 = 0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i89 = 0, i90 = 0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i75 = i89 + 136 | 0;
 i5 = i89 + 120 | 0;
 i6 = i89 + 116 | 0;
 i8 = i89 + 112 | 0;
 i81 = i89 + 96 | 0;
 i82 = i89 + 84 | 0;
 i83 = i89 + 72 | 0;
 i84 = i89 + 60 | 0;
 i85 = i89 + 48 | 0;
 i86 = i89 + 24 | 0;
 i80 = i89 + 12 | 0;
 i79 = i89;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i88, i75);
 f76 = Math_fround(HEAPF32[i2 >> 2]);
 f76 = Math_fround(f76 - Math_fround(HEAPF32[i7 >> 2]));
 f77 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = i7 + 4 | 0;
 f77 = Math_fround(f77 - Math_fround(HEAPF32[i4 >> 2]));
 f78 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i3 = i7 + 8 | 0;
 f78 = Math_fround(f78 - Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i5 >> 2] = f76;
 i1 = i5 + 4 | 0;
 HEAPF32[i1 >> 2] = f77;
 i2 = i5 + 8 | 0;
 HEAPF32[i2 >> 2] = f78;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i75, i75 + 12 | 0, i7, i5, Math_fround(1.0), i6, i8) | 0)) {
  STACKTOP = i89;
  return;
 }
 f70 = Math_fround(HEAPF32[i6 >> 2]);
 f63 = Math_fround(HEAPF32[i5 >> 2]);
 f69 = Math_fround(f70 * f63);
 f71 = Math_fround(HEAPF32[i1 >> 2]);
 f78 = Math_fround(f70 * f71);
 f65 = Math_fround(HEAPF32[i2 >> 2]);
 f70 = Math_fround(f70 * f65);
 f73 = Math_fround(HEAPF32[i7 >> 2]);
 f69 = Math_fround(f69 + f73);
 f67 = Math_fround(HEAPF32[i4 >> 2]);
 f78 = Math_fround(f78 + f67);
 f66 = Math_fround(HEAPF32[i3 >> 2]);
 f70 = Math_fround(f70 + f66);
 f64 = Math_fround(HEAPF32[i8 >> 2]);
 f63 = Math_fround(f73 + Math_fround(f63 * f64));
 f71 = Math_fround(f67 + Math_fround(f71 * f64));
 f64 = Math_fround(f66 + Math_fround(f65 * f64));
 i3 = HEAP32[i88 + 16 >> 2] | 0;
 f65 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f66 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f67 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i3 = HEAP32[i88 + 12 >> 2] | 0;
 i68 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 f73 = Math_fround(HEAPF32[i88 >> 2]);
 f76 = Math_fround(Math_fround(i4 + -1 | 0) * Math_fround(.99999988));
 f77 = Math_fround(Math_fround(i68 + -1 | 0) * Math_fround(.99999988));
 f69 = Math_fround(f69 * f73);
 i74 = f69 > Math_fround(1.00000001e-07);
 f69 = i74 ? f69 : Math_fround(1.00000001e-07);
 f76 = Math_fround(f76 + Math_fround(0.0));
 f69 = f69 < f76 ? f69 : f76;
 f72 = Math_fround(HEAPF32[i88 + 8 >> 2]);
 f70 = Math_fround(f70 * f72);
 i74 = f70 > Math_fround(1.00000001e-07);
 f70 = i74 ? f70 : Math_fround(1.00000001e-07);
 f77 = Math_fround(f77 + Math_fround(0.0));
 f70 = f70 < f77 ? f70 : f77;
 f73 = Math_fround(f63 * f73);
 i74 = f73 > Math_fround(1.00000001e-07);
 f73 = i74 ? f73 : Math_fround(1.00000001e-07);
 f72 = Math_fround(f64 * f72);
 i74 = f72 > Math_fround(1.00000001e-07);
 f72 = i74 ? f72 : Math_fround(1.00000001e-07);
 f76 = Math_fround((f73 < f76 ? f73 : f76) - f69);
 f77 = Math_fround((f72 < f77 ? f72 : f77) - f70);
 f71 = Math_fround(f71 - f78);
 i74 = f76 >= Math_fround(0.0);
 f72 = i74 ? Math_fround(1.0) : Math_fround(-1.0);
 i74 = f77 >= Math_fround(0.0);
 f73 = i74 ? Math_fround(1.0) : Math_fround(-1.0);
 i74 = ~~f72;
 i75 = ~~f73;
 i2 = Math_fround(Math_abs(Math_fround(f76))) < Math_fround(1.00000001e-10);
 f64 = Math_fround(f72 * Math_fround(1.00000001e-10));
 f76 = i2 ? f64 : f76;
 i2 = Math_fround(Math_abs(Math_fround(f77))) < Math_fround(1.00000001e-10);
 f64 = Math_fround(f73 * Math_fround(1.00000001e-10));
 f77 = i2 ? f64 : f77;
 i2 = f76 > Math_fround(0.0);
 if (i2) f9 = Math_fround(Math_floor(Math_fround(f69))); else f9 = Math_fround(Math_ceil(Math_fround(f69)));
 i5 = ~~f9;
 i1 = f77 > Math_fround(0.0);
 if (i1) f9 = Math_fround(Math_floor(Math_fround(f70))); else f9 = Math_fround(Math_ceil(Math_fround(f70)));
 i6 = ~~f9;
 if (i2) {
  f9 = Math_fround(Math_ceil(Math_fround(f69)));
  f64 = Math_fround(f9 + Math_fround(1.0));
  f9 = f9 == f69 ? f64 : f9;
 } else {
  f9 = Math_fround(Math_floor(Math_fround(f69)));
  f64 = Math_fround(f9 + Math_fround(-1.0));
  f9 = f9 == f69 ? f64 : f9;
 }
 if (i1) {
  f10 = Math_fround(Math_ceil(Math_fround(f70)));
  f64 = Math_fround(f10 + Math_fround(1.0));
  f10 = f10 == f70 ? f64 : f10;
 } else {
  f10 = Math_fround(Math_floor(Math_fround(f70)));
  f64 = Math_fround(f10 + Math_fround(-1.0));
  f10 = f10 == f70 ? f64 : f10;
 }
 f63 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f76))));
 f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f77))));
 i42 = 1 - i74 | 0;
 i41 = (1 - i75 | 0) / 2 | 0;
 i34 = i3 + 36 | 0;
 i35 = i81 + 4 | 0;
 i36 = i81 + 8 | 0;
 i37 = i81 + 12 | 0;
 i38 = i81 + (i41 + i42 << 2) | 0;
 i39 = i81 + (i42 + 1 - i41 << 2) | 0;
 i40 = i81 + (2 - i42 + i41 << 2) | 0;
 i41 = i81 + (3 - i42 - i41 << 2) | 0;
 i42 = i82 + 4 | 0;
 i43 = i82 + 8 | 0;
 i44 = i83 + 4 | 0;
 i45 = i83 + 8 | 0;
 i46 = i84 + 4 | 0;
 i47 = i84 + 8 | 0;
 i48 = i85 + 4 | 0;
 i49 = i85 + 8 | 0;
 i50 = i86 + 4 | 0;
 i51 = i86 + 8 | 0;
 i52 = i86 + 12 | 0;
 i53 = i86 + 16 | 0;
 i54 = i86 + 20 | 0;
 f55 = Math_fround(f72 * Math_fround(.5));
 f56 = Math_fround(f73 * Math_fround(.5));
 f57 = Math_fround(f66 * f73);
 i58 = i80 + 4 | 0;
 i59 = i80 + 8 | 0;
 i60 = i79 + 4 | 0;
 i61 = i79 + 8 | 0;
 f62 = Math_fround(f65 * f72);
 f31 = Math_fround(i4 | 0);
 f32 = Math_fround(i68 | 0);
 f33 = Math_fround(f78 + Math_fround(f71 * Math_fround(0.0)));
 f11 = Math_fround(0.0);
 f12 = Math_fround(0.0);
 f13 = Math_fround(Math_fround(f9 - f69) / f76);
 f14 = Math_fround(Math_fround(f10 - f70) / f77);
 i30 = i5;
 f10 = Math_fround(i5 | 0);
 i28 = i6;
 f9 = Math_fround(i6 | 0);
 while (1) {
  i27 = f13 < f14;
  f29 = i27 ? f13 : f14;
  f25 = f33;
  f33 = Math_fround(f78 + Math_fround(f71 * f29));
  i7 = (Math_imul(i30, i68) | 0) + i28 | 0;
  i2 = i30 + i74 | 0;
  i8 = (Math_imul(i2, i68) | 0) + i28 | 0;
  i1 = HEAP32[i34 >> 2] | 0;
  f20 = Math_fround(f67 * Math_fround(HEAP16[i1 + (i7 << 2) >> 1] | 0));
  HEAPF32[i81 >> 2] = f20;
  f22 = Math_fround(f67 * Math_fround(HEAP16[i1 + (i7 + i75 << 2) >> 1] | 0));
  HEAPF32[i35 >> 2] = f22;
  f21 = Math_fround(f67 * Math_fround(HEAP16[i1 + (i8 << 2) >> 1] | 0));
  HEAPF32[i36 >> 2] = f21;
  f26 = Math_fround(f67 * Math_fround(HEAP16[i1 + (i8 + i75 << 2) >> 1] | 0));
  HEAPF32[i37 >> 2] = f26;
  f23 = f20 < f22 ? f20 : f22;
  f24 = f21 < f26 ? f21 : f26;
  f22 = f20 > f22 ? f20 : f22;
  f26 = f21 > f26 ? f21 : f26;
  f26 = f22 > f26 ? f22 : f26;
  f22 = f25 > f33 ? f25 : f33;
  if (f22 < f26 | (Math_fround(f22 + Math_fround(.0000999999974)) < (f23 < f24 ? f23 : f24) ? 0 : !(Math_fround((f25 < f33 ? f25 : f33) + Math_fround(-.0000999999974)) > f26))) {
   i8 = HEAP32[i38 >> 2] | 0;
   i7 = HEAP32[i39 >> 2] | 0;
   i90 = HEAP32[i40 >> 2] | 0;
   i5 = HEAP32[i41 >> 2] | 0;
   f93 = Math_fround(f72 + f10);
   f18 = f10 < f93 ? f10 : f93;
   f93 = f10 > f93 ? f10 : f93;
   f15 = Math_fround(f73 + f9);
   f26 = f9 < f15 ? f9 : f15;
   f15 = f9 > f15 ? f9 : f15;
   HEAPF32[i82 >> 2] = f18;
   HEAP32[i42 >> 2] = i8;
   HEAPF32[i43 >> 2] = f26;
   HEAPF32[i83 >> 2] = f18;
   HEAP32[i44 >> 2] = i7;
   HEAPF32[i45 >> 2] = f15;
   HEAPF32[i84 >> 2] = f93;
   HEAP32[i46 >> 2] = i90;
   HEAPF32[i47 >> 2] = f26;
   HEAPF32[i85 >> 2] = f93;
   HEAP32[i48 >> 2] = i5;
   HEAPF32[i49 >> 2] = f15;
   i5 = i28 + i75 | 0;
   i5 = (Math_imul((i2 | 0) < (i30 | 0) ? i2 : i30, i68) | 0) + ((i5 | 0) < (i28 | 0) ? i5 : i28) | 0;
   i90 = (HEAP8[i1 + (i5 << 2) + 2 >> 0] | 0) < 0;
   i1 = i90 ? i85 : i84;
   i7 = i90 ? i84 : i82;
   i8 = i90 ? i83 : i85;
   i3 = i90 ? i82 : i83;
   f15 = Math_fround(f65 * Math_fround(HEAPF32[i3 >> 2]));
   f93 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f26 = Math_fround(f66 * Math_fround(HEAPF32[i3 + 8 >> 2]));
   f18 = Math_fround(f65 * Math_fround(HEAPF32[i8 >> 2]));
   f19 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f20 = Math_fround(f66 * Math_fround(HEAPF32[i8 + 8 >> 2]));
   f21 = Math_fround(f65 * Math_fround(HEAPF32[i7 >> 2]));
   f22 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f23 = Math_fround(f66 * Math_fround(HEAPF32[i7 + 8 >> 2]));
   f92 = Math_fround(f65 * Math_fround(HEAPF32[i1 >> 2]));
   f24 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f94 = Math_fround(f66 * Math_fround(HEAPF32[i1 + 8 >> 2]));
   f96 = Math_fround(f15 - f21);
   f91 = Math_fround(f93 - f22);
   f97 = Math_fround(f26 - f23);
   f25 = Math_fround(f92 - f21);
   f95 = Math_fround(f24 - f22);
   f16 = Math_fround(f94 - f23);
   f17 = Math_fround(Math_fround(f91 * f16) - Math_fround(f97 * f95));
   f16 = Math_fround(Math_fround(f97 * f25) - Math_fround(f96 * f16));
   f25 = Math_fround(Math_fround(f96 * f95) - Math_fround(f91 * f25));
   f92 = Math_fround(f92 - f18);
   f24 = Math_fround(f24 - f19);
   f94 = Math_fround(f94 - f20);
   f15 = Math_fround(f15 - f18);
   f93 = Math_fround(f93 - f19);
   f26 = Math_fround(f26 - f20);
   f91 = Math_fround(Math_fround(f26 * f24) - Math_fround(f93 * f94));
   f26 = Math_fround(Math_fround(f15 * f94) - Math_fround(f26 * f92));
   f24 = Math_fround(Math_fround(f93 * f92) - Math_fround(f15 * f24));
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f25 * f25)))));
   HEAPF32[i86 >> 2] = Math_fround(f17 * f15);
   HEAPF32[i50 >> 2] = Math_fround(f15 * f16);
   HEAPF32[i51 >> 2] = Math_fround(f15 * f25);
   f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f91 * f91) + Math_fround(f26 * f26)) + Math_fround(f24 * f24)))));
   HEAPF32[i52 >> 2] = Math_fround(f91 * f25);
   HEAPF32[i53 >> 2] = Math_fround(f25 * f26);
   HEAPF32[i54 >> 2] = Math_fround(f25 * f24);
   f24 = i90 ? Math_fround(-1.0) : Math_fround(1.0);
   f25 = Math_fround(f55 + f10);
   f26 = Math_fround(f56 + f9);
   i90 = f29 < Math_fround(1.0);
   f91 = i90 ? f29 : Math_fround(1.0);
   i90 = f11 > f12;
   f15 = i90 ? f11 : f12;
   f16 = Math_fround(f69 + Math_fround(f76 * f15));
   f17 = Math_fround(f70 + Math_fround(f77 * f15));
   i1 = Math_fround(Math_fround(f17 - f26) + Math_fround(Math_fround(f16 - f25) * f24)) > Math_fround(0.0) & 1;
   i7 = Math_fround(Math_fround(Math_fround(f70 + Math_fround(f77 * f91)) - f26) + Math_fround(Math_fround(Math_fround(f69 + Math_fround(f76 * f91)) - f25) * f24)) > Math_fround(0.0) & 1;
   i8 = i5 << 1;
   i3 = i1 | i8;
   i8 = i7 | i8;
   i6 = HEAP32[i34 >> 2] | 0;
   i4 = (HEAP8[i6 + (i5 << 2) + 2 >> 0] & 127) == 127 & 1;
   i5 = (HEAP8[i6 + (i5 << 2) + 3 >> 0] & 127) == 127 & 1;
   i6 = i3 >>> 0 > i8 >>> 0;
   if (i90) {
    f97 = Math_fround(HEAPF32[i35 >> 2]);
    f97 = Math_fround(f97 - Math_fround(HEAPF32[i81 >> 2]));
    HEAP32[i80 >> 2] = 0;
    HEAPF32[i58 >> 2] = f97;
    HEAPF32[i59 >> 2] = f57;
   } else {
    f97 = Math_fround(HEAPF32[i36 >> 2]);
    f97 = Math_fround(f97 - Math_fround(HEAPF32[i81 >> 2]));
    HEAPF32[i80 >> 2] = f62;
    HEAPF32[i58 >> 2] = f97;
    HEAP32[i59 >> 2] = 0;
   }
   if (!((i6 ? i5 : i4) | 0)) __ZN5physx30PxcContactTraceSegmentCallback12underFaceHitERKNS_2Gu15HeightFieldUtilERKNS_6PxVec3ES7_fffj(i87, i88, i86 + (i1 * 12 | 0) | 0, i80, Math_fround(f65 * f16), Math_fround(f66 * f17), Math_fround(f78 + Math_fround(f71 * f15)), i3) | 0;
   if (!((i8 | 0) == (i3 | 0) | ((i6 ? i4 : i5) | 0) != 0)) {
    f15 = Math_fround(f77 + Math_fround(f76 * f24));
    if (Math_fround(Math_abs(Math_fround(f15))) > Math_fround(9.99999997e-07)) {
     f97 = Math_fround(Math_fround(Math_fround(f26 - f70) + Math_fround(Math_fround(f25 - f69) * f24)) / f15);
     f95 = Math_fround(f22 - f19);
     f96 = Math_fround(f23 - f20);
     HEAPF32[i79 >> 2] = Math_fround(f21 - f18);
     HEAPF32[i60 >> 2] = f95;
     HEAPF32[i61 >> 2] = f96;
     __ZN5physx30PxcContactTraceSegmentCallback12underFaceHitERKNS_2Gu15HeightFieldUtilERKNS_6PxVec3ES7_fffj(i87, i88, i86 + (i7 * 12 | 0) | 0, i79, Math_fround(f65 * Math_fround(f69 + Math_fround(f76 * f97))), Math_fround(f66 * Math_fround(f70 + Math_fround(f77 * f97))), Math_fround(f78 + Math_fround(f71 * f97)), i8) | 0;
    }
   }
  }
  if (i27) {
   i90 = i2 + i74 | 0;
   if (!((i90 | 0) > -1 & !(Math_fround(i90 | 0) >= f31))) {
    i1 = 30;
    break;
   }
   f11 = f13;
   f13 = Math_fround(f63 + f13);
   f10 = Math_fround(f72 + f10);
   i1 = i28;
  } else {
   i1 = i28 + i75 | 0;
   i90 = i1 + i75 | 0;
   if (!((i90 | 0) > -1 & !(Math_fround(i90 | 0) >= f32))) {
    i1 = 30;
    break;
   }
   f12 = f14;
   f14 = Math_fround(f64 + f14);
   i2 = i30;
   f9 = Math_fround(f73 + f9);
  }
  if (!(f29 < Math_fround(.999899983))) {
   i1 = 30;
   break;
  } else {
   i30 = i2;
   i28 = i1;
  }
 }
 if ((i1 | 0) == 30) {
  STACKTOP = i89;
  return;
 }
}

function __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i44, i46, i45, i40, i7) {
 i44 = i44 | 0;
 i46 = i46 | 0;
 i45 = i45 | 0;
 i40 = i40 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i47 = 0, f48 = f0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i47;
 i9 = i47 + 200 | 0;
 i14 = i47 + 188 | 0;
 i21 = i47 + 176 | 0;
 i22 = i47 + 164 | 0;
 i38 = i47 + 152 | 0;
 i41 = i47 + 140 | 0;
 i43 = i47 + 128 | 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i40 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i42 | 0, 0, i40 | 0) | 0;
 i2 = -8388609;
 i8 = i7;
 i1 = -1;
 do {
  i3 = HEAP32[i8 + 48 >> 2] | 0;
  i6 = HEAP32[i8 + 52 >> 2] | 0;
  if (i3 >>> 0 < i6 >>> 0) do {
   f35 = Math_fround(HEAPF32[i45 + (i3 << 6) + 16 >> 2]);
   f36 = Math_fround(HEAPF32[i45 + (i3 << 6) + 20 >> 2]);
   f5 = Math_fround(HEAPF32[i45 + (i3 << 6) + 24 >> 2]);
   f5 = Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36)) + Math_fround(f5 * f5));
   i4 = f5 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i2 = i4 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i2;
   i1 = i4 ? i3 : i1;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i6 >>> 0);
  i8 = HEAP32[i8 + 16 >> 2] | 0;
 } while ((i8 | 0) != 0);
 HEAP8[i42 + i1 >> 0] = 1;
 i37 = i39 + 16 | 0;
 HEAP32[i37 >> 2] = i1;
 HEAP32[i39 + 20 >> 2] = i1;
 HEAP32[i39 >> 2] = HEAP32[i45 + (i1 << 6) + 44 >> 2];
 i29 = i39 + 4 | 0;
 HEAP32[i29 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i29 = HEAP32[i7 + 48 >> 2] | 0;
 f30 = Math_fround(HEAPF32[i45 + (i29 << 6) + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i45 + (i29 << 6) + 20 >> 2]);
 f32 = Math_fround(HEAPF32[i45 + (i29 << 6) + 24 >> 2]);
 f34 = Math_fround(HEAPF32[i45 + (i1 << 6) + 16 >> 2]);
 f35 = Math_fround(HEAPF32[i45 + (i1 << 6) + 20 >> 2]);
 f36 = Math_fround(HEAPF32[i45 + (i1 << 6) + 24 >> 2]);
 f30 = Math_fround(f30 - f34);
 f31 = Math_fround(f31 - f35);
 f32 = Math_fround(f32 - f36);
 f32 = Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) + Math_fround(f32 * f32));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = i29;
 i3 = i7;
 i2 = i29;
 while (1) {
  i9 = HEAP32[i3 + 52 >> 2] | 0;
  if (i6 >>> 0 < i9 >>> 0) do {
   f31 = Math_fround(HEAPF32[i45 + (i6 << 6) + 16 >> 2]);
   f32 = Math_fround(HEAPF32[i45 + (i6 << 6) + 20 >> 2]);
   f31 = Math_fround(f31 - f34);
   f32 = Math_fround(f32 - f35);
   f5 = Math_fround(Math_fround(HEAPF32[i45 + (i6 << 6) + 24 >> 2]) - f36);
   f5 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f5 * f5));
   i8 = f5 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i4;
   i2 = i8 ? i6 : i2;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i9 >>> 0);
  i3 = HEAP32[i3 + 16 >> 2] | 0;
  if (!i3) break;
  i6 = HEAP32[i3 + 48 >> 2] | 0;
 }
 HEAP8[i42 + i2 >> 0] = 1;
 i33 = i39 + 48 | 0;
 HEAP32[i33 >> 2] = i2;
 HEAP32[i39 + 52 >> 2] = i2;
 HEAP32[i39 + 32 >> 2] = HEAP32[i45 + (i2 << 6) + 44 >> 2];
 i6 = i39 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i45 + (i2 << 6) + 16 >> 2]);
 f32 = Math_fround(HEAPF32[i45 + (i2 << 6) + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i45 + (i2 << 6) + 24 >> 2]);
 f19 = Math_fround(f31 - f34);
 f13 = Math_fround(f32 - f35);
 f18 = Math_fround(f30 - f36);
 f5 = Math_fround(HEAPF32[i45 + (i1 << 6) + 32 >> 2]);
 f20 = Math_fround(HEAPF32[i45 + (i1 << 6) + 36 >> 2]);
 f12 = Math_fround(HEAPF32[i45 + (i1 << 6) + 40 >> 2]);
 f11 = Math_fround(Math_fround(f13 * f12) - Math_fround(f18 * f20));
 f12 = Math_fround(Math_fround(f18 * f5) - Math_fround(f19 * f12));
 f5 = Math_fround(Math_fround(f19 * f20) - Math_fround(f13 * f5));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12))))));
 f11 = Math_fround(f11 * f13);
 f12 = Math_fround(f12 * f13);
 f13 = Math_fround(f5 * f13);
 i6 = i29;
 f5 = Math_fround(3402823469999999843913219.0e14);
 i3 = -8388609;
 i4 = i7;
 i1 = -1;
 i2 = -1;
 while (1) {
  i9 = HEAP32[i4 + 52 >> 2] | 0;
  if (i6 >>> 0 < i9 >>> 0) {
   i8 = i6;
   do {
    if (!(HEAP8[i42 + i8 >> 0] | 0)) {
     f20 = Math_fround(HEAPF32[i45 + (i8 << 6) + 16 >> 2]);
     f10 = Math_fround(HEAPF32[i45 + (i8 << 6) + 20 >> 2]);
     f10 = Math_fround(Math_fround(Math_fround(f11 * Math_fround(f20 - f34)) + Math_fround(f12 * Math_fround(f10 - f35))) + Math_fround(f13 * Math_fround(Math_fround(HEAPF32[i45 + (i8 << 6) + 24 >> 2]) - f36)));
     i6 = f10 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i3 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) : i3;
     i1 = i6 ? i8 : i1;
     if (f5 > f10) {
      f5 = f10;
      i2 = i8;
     }
    }
    i8 = i8 + 1 | 0;
   } while (i8 >>> 0 < i9 >>> 0);
  }
  i4 = HEAP32[i4 + 16 >> 2] | 0;
  if (!i4) break;
  i6 = HEAP32[i4 + 48 >> 2] | 0;
 }
 HEAP8[i42 + i1 >> 0] = 1;
 i28 = i39 + 80 | 0;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i39 + 84 >> 2] = i1;
 HEAP32[i39 + 64 >> 2] = HEAP32[i45 + (i1 << 6) + 44 >> 2];
 i27 = i39 + 68 | 0;
 HEAP32[i27 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 L28 : do if (Math_fround(f5 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) > Math_fround(0.0)) {
  i6 = i29;
  i4 = -8388609;
  i3 = i7;
  while (1) {
   i8 = HEAP32[i3 + 52 >> 2] | 0;
   if (i6 >>> 0 < i8 >>> 0) do {
    if (!(HEAP8[i42 + i6 >> 0] | 0)) {
     f20 = Math_fround(HEAPF32[i45 + (i6 << 6) + 16 >> 2]);
     f5 = Math_fround(HEAPF32[i45 + (i6 << 6) + 20 >> 2]);
     f5 = Math_fround(Math_fround(Math_fround(f11 * Math_fround(f20 - f34)) + Math_fround(f12 * Math_fround(f5 - f35))) + Math_fround(f13 * Math_fround(Math_fround(HEAPF32[i45 + (i6 << 6) + 24 >> 2]) - f36)));
     if (f5 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = i6;
     }
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i8 >>> 0);
   i3 = HEAP32[i3 + 16 >> 2] | 0;
   if (!i3) break L28;
   i6 = HEAP32[i3 + 48 >> 2] | 0;
  }
 } while (0);
 HEAP8[i42 + i2 >> 0] = 1;
 i27 = i39 + 112 | 0;
 HEAP32[i27 >> 2] = i2;
 HEAP32[i39 + 116 >> 2] = i2;
 HEAP32[i39 + 96 >> 2] = HEAP32[i45 + (i2 << 6) + 44 >> 2];
 i23 = i39 + 100 | 0;
 HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 i22 = i45 + (i1 << 6) + 16 | 0;
 i23 = i45 + (i1 << 6) + 20 | 0;
 i24 = i45 + (i1 << 6) + 24 | 0;
 i25 = i45 + (i2 << 6) + 16 | 0;
 i26 = i45 + (i2 << 6) + 20 | 0;
 i21 = i45 + (i2 << 6) + 24 | 0;
 i4 = i29;
 i2 = i7;
 while (1) {
  i14 = i2 + 52 | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  if (i4 >>> 0 < i3 >>> 0) {
   f15 = Math_fround(HEAPF32[i22 >> 2]);
   f16 = Math_fround(HEAPF32[i23 >> 2]);
   f17 = Math_fround(HEAPF32[i24 >> 2]);
   f18 = Math_fround(HEAPF32[i25 >> 2]);
   f19 = Math_fround(HEAPF32[i26 >> 2]);
   f20 = Math_fround(HEAPF32[i21 >> 2]);
   do {
    f11 = Math_fround(HEAPF32[i45 + (i4 << 6) + 16 >> 2]);
    f12 = Math_fround(HEAPF32[i45 + (i4 << 6) + 20 >> 2]);
    f13 = Math_fround(HEAPF32[i45 + (i4 << 6) + 24 >> 2]);
    f48 = Math_fround(f34 - f11);
    f10 = Math_fround(f35 - f12);
    f5 = Math_fround(f36 - f13);
    f5 = Math_fround(Math_fround(Math_fround(f48 * f48) + Math_fround(f10 * f10)) + Math_fround(f5 * f5));
    i29 = f5 < Math_fround(3402823469999999843913219.0e14);
    i6 = i29 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 2139095039;
    f10 = Math_fround(f31 - f11);
    f48 = Math_fround(f32 - f12);
    f5 = Math_fround(f30 - f13);
    f5 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f48 * f48)) + Math_fround(f5 * f5));
    i9 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f5;
    i6 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : i6;
    f5 = Math_fround(f15 - f11);
    f48 = Math_fround(f16 - f12);
    f10 = Math_fround(f17 - f13);
    f10 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f48 * f48)) + Math_fround(f10 * f10));
    i8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f10;
    f11 = Math_fround(f18 - f11);
    f48 = Math_fround(f19 - f12);
    f5 = Math_fround(f20 - f13);
    f5 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f48 * f48)) + Math_fround(f5 * f5));
    i6 = (HEAP32[tempDoublePtr >> 2] = i8 ? (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f5;
    i8 = i6 ? 3 : i8 ? 2 : i9 & 1;
    i6 = i39 + (i8 << 5) | 0;
    f48 = Math_fround(HEAPF32[i6 >> 2]);
    f5 = Math_fround(HEAPF32[i45 + (i4 << 6) + 44 >> 2]);
    if (f48 > f5) {
     i3 = i39 + (i8 << 5) + 4 | 0;
     HEAPF32[i6 >> 2] = f5;
     HEAP32[i3 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
     HEAP32[i39 + (i8 << 5) + 16 >> 2] = i4;
     i3 = HEAP32[i14 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i3 >>> 0);
  }
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  if (!i2) break;
  i4 = HEAP32[i2 + 48 >> 2] | 0;
 }
 i9 = i44 + 4 | 0;
 _memset(i42 | 0, 0, i40 | 0) | 0;
 i2 = HEAP32[i37 >> 2] | 0;
 HEAP8[i42 + i2 >> 0] = 1;
 i6 = i46;
 i3 = i45 + (i2 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f5 = Math_fround(HEAPF32[i45 + (i2 << 6) + 44 >> 2]);
 i2 = f5 < Math_fround(3402823469999999843913219.0e14);
 f5 = i2 ? f5 : Math_fround(3402823469999999843913219.0e14);
 i2 = HEAP32[i33 >> 2] | 0;
 HEAP8[i42 + i2 >> 0] = 1;
 i6 = i46 + 64 | 0;
 i3 = i45 + (i2 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f48 = Math_fround(HEAPF32[i45 + (i2 << 6) + 44 >> 2]);
 f5 = f5 > f48 ? f48 : f5;
 i2 = HEAP32[i28 >> 2] | 0;
 HEAP8[i42 + i2 >> 0] = 1;
 i6 = i46 + 128 | 0;
 i3 = i45 + (i2 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f48 = Math_fround(HEAPF32[i45 + (i2 << 6) + 44 >> 2]);
 f5 = f5 > f48 ? f48 : f5;
 i2 = HEAP32[i27 >> 2] | 0;
 HEAP8[i42 + i2 >> 0] = 1;
 i6 = i46 + 192 | 0;
 i3 = i45 + (i2 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f48 = Math_fround(HEAPF32[i45 + (i2 << 6) + 44 >> 2]);
 f5 = f5 > f48 ? f48 : f5;
 HEAP32[i9 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
 HEAPF32[i44 >> 2] = f5;
 i2 = 2139095039;
 i8 = i7;
 do {
  i3 = HEAP32[i8 + 48 >> 2] | 0;
  i6 = HEAP32[i8 + 52 >> 2] | 0;
  if (i3 >>> 0 < i6 >>> 0) do {
   if (!(HEAP8[i42 + i3 >> 0] | 0)) {
    i4 = HEAP32[i45 + (i3 << 6) + 44 >> 2] | 0;
    f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f48 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i2 = i4;
     i1 = i3;
    }
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i6 >>> 0);
  i8 = HEAP32[i8 + 16 >> 2] | 0;
 } while ((i8 | 0) != 0);
 i6 = i46 + 256 | 0;
 i3 = i45 + (i1 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = f5 > f48 ? f48 : f5;
 HEAP32[i9 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP8[i42 + i1 >> 0] = 1;
 i2 = 2139095039;
 do {
  i3 = HEAP32[i7 + 48 >> 2] | 0;
  i6 = HEAP32[i7 + 52 >> 2] | 0;
  if (i3 >>> 0 < i6 >>> 0) do {
   if (!(HEAP8[i42 + i3 >> 0] | 0)) {
    i4 = HEAP32[i45 + (i3 << 6) + 44 >> 2] | 0;
    f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f48 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i2 = i4;
     i1 = i3;
    }
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i6 >>> 0);
  i7 = HEAP32[i7 + 16 >> 2] | 0;
 } while ((i7 | 0) != 0);
 i6 = i46 + 320 | 0;
 i3 = i45 + (i1 << 6) | 0;
 i4 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  i6 = i6 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAP32[i9 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAPF32[i44 >> 2] = f5 > f48 ? f48 : f5;
 STACKTOP = i47;
 return;
}

function __Z20sweepCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i3, i5, i25, f22, i24, i4, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i25 = i25 | 0;
 f22 = Math_fround(f22);
 i24 = i24 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i26 + 400 | 0;
 i20 = i26 + 384 | 0;
 i28 = i26 + 368 | 0;
 i52 = i26 + 456 | 0;
 i53 = i26 + 428 | 0;
 i38 = i26 + 416 | 0;
 i29 = i26 + 208 | 0;
 i30 = i26 + 64 | 0;
 i27 = i26 + 48 | 0;
 i19 = i26 + 32 | 0;
 i21 = i26 + 16 | 0;
 i23 = i26;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i50 = HEAP32[i1 + 8 >> 2] | 0;
 i39 = HEAP32[i1 + 12 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i25 >> 2]);
 i17 = i25 + 4 | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 i10 = i25 + 8 | 0;
 f11 = Math_fround(HEAPF32[i10 >> 2]);
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf(i53, i5, i52);
 f35 = Math_fround(HEAPF32[i53 >> 2]);
 f48 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 f47 = Math_fround(HEAPF32[i53 + 12 >> 2]);
 i1 = i53 + 16 | 0;
 f44 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f40 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i1 = i3 + 16 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f33 = Math_fround(-f12);
 f46 = Math_fround(-f13);
 f43 = Math_fround(-f14);
 f44 = Math_fround(f44 - f6);
 f34 = Math_fround(f34 - f7);
 f40 = Math_fround(f40 - f8);
 f9 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f32 = Math_fround(Math_fround(Math_fround(f44 * f33) + Math_fround(f34 * f46)) + Math_fround(f40 * f43));
 f36 = Math_fround(Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f9 * f44) + Math_fround(f15 * Math_fround(Math_fround(f40 * f46) - Math_fround(f34 * f43))))) * Math_fround(2.0));
 f31 = Math_fround(Math_fround(Math_fround(f32 * f46) + Math_fround(Math_fround(f9 * f34) + Math_fround(f15 * Math_fround(Math_fround(f44 * f43) - Math_fround(f40 * f33))))) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f40) + Math_fround(f15 * Math_fround(Math_fround(f34 * f33) - Math_fround(f44 * f46)))) + Math_fround(f32 * f43)) * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f47 * f15) - Math_fround(Math_fround(Math_fround(f35 * f33) + Math_fround(f48 * f46)) + Math_fround(f49 * f43)));
 f34 = Math_fround(Math_fround(Math_fround(f49 * f46) - Math_fround(f48 * f43)) + Math_fround(Math_fround(f47 * f33) + Math_fround(f35 * f15)));
 f40 = Math_fround(Math_fround(Math_fround(f35 * f43) - Math_fround(f49 * f33)) + Math_fround(Math_fround(f47 * f46) + Math_fround(f48 * f15)));
 f49 = Math_fround(Math_fround(Math_fround(f48 * f33) - Math_fround(f35 * f46)) + Math_fround(Math_fround(f47 * f43) + Math_fround(f49 * f15)));
 f43 = Math_fround(f34 + f34);
 f47 = Math_fround(f40 + f40);
 f46 = Math_fround(f49 + f49);
 f35 = Math_fround(f40 * f47);
 f33 = Math_fround(f49 * f46);
 f40 = Math_fround(f40 * f43);
 f48 = Math_fround(f49 * f43);
 f45 = Math_fround(f44 * f43);
 f49 = Math_fround(f49 * f47);
 f47 = Math_fround(f44 * f47);
 f46 = Math_fround(f44 * f46);
 f43 = Math_fround(Math_fround(1.0) - Math_fround(f34 * f43));
 f34 = Math_fround(Math_fround(Math_fround(1.0) - f35) - f33);
 f44 = Math_fround(f40 + f46);
 f42 = Math_fround(f48 - f47);
 f46 = Math_fround(f40 - f46);
 f33 = Math_fround(f43 - f33);
 f40 = Math_fround(f49 + f45);
 f47 = Math_fround(f48 + f47);
 f45 = Math_fround(f49 - f45);
 f35 = Math_fround(f43 - f35);
 f43 = Math_fround(HEAPF32[i52 >> 2]);
 i5 = i5 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i29 + 64 | 0;
 HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i29 + 80 >> 2] = 3;
 HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
 HEAP32[i29 + 144 >> 2] = i51;
 HEAP32[i29 + 148 >> 2] = i50;
 HEAP32[i29 + 152 >> 2] = i39;
 HEAPF32[i29 + 156 >> 2] = Math_fround(0.0);
 f49 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = f49 <= f48 ? f49 : f48;
 f41 = f48 <= f41 ? f48 : f41;
 HEAPF32[i29 + 16 >> 2] = Math_fround(f41 * Math_fround(.150000006));
 HEAPF32[i29 + 32 >> 2] = Math_fround(f41 * Math_fround(.0500000007));
 f41 = Math_fround(f43 * Math_fround(0.0));
 f34 = Math_fround(Math_fround(f41 * f47) + Math_fround(Math_fround(f41 * f46) + Math_fround(f43 * f34)));
 f33 = Math_fround(Math_fround(f41 * f45) + Math_fround(Math_fround(f43 * f44) + Math_fround(f41 * f33)));
 f35 = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f41 * f40)) + Math_fround(f41 * f35));
 i3 = i30 + 64 | 0;
 HEAPF32[i30 >> 2] = f36;
 HEAPF32[i30 + 4 >> 2] = f31;
 HEAPF32[i30 + 8 >> 2] = f32;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i30 + 80 >> 2] = 4;
 HEAPF32[i30 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i30 + 128 >> 2] = i1;
 i39 = i30 + 132 | 0;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 f41 = Math_fround(f31 + f33);
 f40 = Math_fround(f32 + f35);
 HEAPF32[i30 + 96 >> 2] = Math_fround(f36 + f34);
 HEAPF32[i30 + 100 >> 2] = f41;
 HEAPF32[i30 + 104 >> 2] = f40;
 HEAPF32[i30 + 108 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f31 - f33);
 f35 = Math_fround(f32 - f35);
 HEAPF32[i30 + 112 >> 2] = Math_fround(f36 - f34);
 HEAPF32[i30 + 116 >> 2] = f33;
 HEAPF32[i30 + 120 >> 2] = f35;
 HEAPF32[i30 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i30 + 16 >> 2] = i1;
 i39 = i30 + 20 | 0;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i30 + 32 >> 2] = i1;
 i1 = i30 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i37 >> 2] = -1;
 HEAP32[i37 + 4 >> 2] = -1;
 HEAP32[i37 + 8 >> 2] = -1;
 HEAP32[i37 + 12 >> 2] = -1;
 HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
 f35 = Math_fround(-Math_fround(f16 * f22));
 f33 = Math_fround(-Math_fround(f18 * f22));
 f34 = Math_fround(-Math_fround(f11 * f22));
 f36 = Math_fround(Math_fround(Math_fround(f12 * f35) + Math_fround(f13 * f33)) + Math_fround(f14 * f34));
 f32 = Math_fround(Math_fround(Math_fround(f13 * f36) + Math_fround(Math_fround(f9 * f33) - Math_fround(f15 * Math_fround(Math_fround(f14 * f35) - Math_fround(f12 * f34))))) * Math_fround(2.0));
 f31 = Math_fround(Math_fround(Math_fround(f14 * f36) + Math_fround(Math_fround(f9 * f34) - Math_fround(f15 * Math_fround(Math_fround(f12 * f33) - Math_fround(f13 * f35))))) * Math_fround(2.0));
 HEAPF32[i27 >> 2] = Math_fround(Math_fround(Math_fround(f12 * f36) + Math_fround(Math_fround(f9 * f35) - Math_fround(f15 * Math_fround(Math_fround(f13 * f34) - Math_fround(f14 * f33))))) * Math_fround(2.0));
 HEAPF32[i27 + 4 >> 2] = f32;
 HEAPF32[i27 + 8 >> 2] = f31;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 i3 = (HEAP16[i4 >> 1] & 512) != 0;
 HEAPF32[i19 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (!(__ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i30, i29, i20, i28, i27, i19, i23, i21, Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f2), i3) | 0)) {
  i53 = 0;
  STACKTOP = i26;
  return i53 | 0;
 }
 i1 = i24 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 f49 = Math_fround(HEAPF32[i20 >> 2]);
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 if (!(f49 >= f2)) {
  HEAP16[i1 >> 1] = 7;
  f41 = Math_fround(HEAPF32[i21 >> 2]);
  f43 = Math_fround(HEAPF32[i21 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f48 = Math_fround(Math_fround(Math_fround(f12 * f41) + Math_fround(f13 * f43)) + Math_fround(f14 * f42));
  f46 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f12 * f48) + Math_fround(Math_fround(f9 * f41) + Math_fround(f15 * Math_fround(Math_fround(f13 * f42) - Math_fround(f14 * f43))))) * Math_fround(2.0)));
  f47 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f13 * f48) + Math_fround(Math_fround(f9 * f43) + Math_fround(f15 * Math_fround(Math_fround(f14 * f41) - Math_fround(f12 * f42))))) * Math_fround(2.0)));
  f48 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f42) + Math_fround(f15 * Math_fround(Math_fround(f12 * f43) - Math_fround(f13 * f41)))) + Math_fround(f14 * f48)) * Math_fround(2.0)));
  f41 = Math_fround(HEAPF32[i23 >> 2]);
  f43 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i23 + 8 >> 2]);
  f40 = Math_fround(Math_fround(Math_fround(f12 * f41) + Math_fround(f13 * f43)) + Math_fround(f14 * f42));
  f44 = Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(Math_fround(f9 * f43) + Math_fround(f15 * Math_fround(Math_fround(f14 * f41) - Math_fround(f12 * f42))))) * Math_fround(2.0));
  f45 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f42) + Math_fround(f15 * Math_fround(Math_fround(f12 * f43) - Math_fround(f13 * f41)))) + Math_fround(f14 * f40)) * Math_fround(2.0));
  f49 = Math_fround(f2 * f22);
  f46 = Math_fround(Math_fround(f16 * f49) + f46);
  f47 = Math_fround(Math_fround(f18 * f49) + f47);
  f48 = Math_fround(Math_fround(f11 * f49) + f48);
  HEAPF32[i24 + 28 >> 2] = Math_fround(Math_fround(Math_fround(f12 * f40) + Math_fround(Math_fround(f9 * f41) + Math_fround(f15 * Math_fround(Math_fround(f13 * f42) - Math_fround(f14 * f43))))) * Math_fround(2.0));
  HEAPF32[i24 + 32 >> 2] = f44;
  HEAPF32[i24 + 36 >> 2] = f45;
  HEAPF32[i24 + 16 >> 2] = f46;
  HEAPF32[i24 + 20 >> 2] = f47;
  HEAPF32[i24 + 24 >> 2] = f48;
  HEAPF32[i24 + 40 >> 2] = f49;
  i53 = 1;
  STACKTOP = i26;
  return i53 | 0;
 }
 if (i3) {
  HEAP16[i1 >> 1] = 7;
  f43 = Math_fround(HEAPF32[i21 >> 2]);
  f42 = Math_fround(HEAPF32[i21 + 4 >> 2]);
  f41 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f46 = Math_fround(Math_fround(Math_fround(f12 * f43) + Math_fround(f13 * f42)) + Math_fround(f14 * f41));
  f44 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f12 * f46) + Math_fround(Math_fround(f9 * f43) + Math_fround(f15 * Math_fround(Math_fround(f13 * f41) - Math_fround(f14 * f42))))) * Math_fround(2.0)));
  f45 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(f13 * f46) + Math_fround(Math_fround(f9 * f42) + Math_fround(f15 * Math_fround(Math_fround(f14 * f43) - Math_fround(f12 * f41))))) * Math_fround(2.0)));
  f46 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f41) + Math_fround(f15 * Math_fround(Math_fround(f12 * f42) - Math_fround(f13 * f43)))) + Math_fround(f14 * f46)) * Math_fround(2.0)));
  f43 = Math_fround(HEAPF32[i23 >> 2]);
  f42 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f41 = Math_fround(HEAPF32[i23 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f12 * f43) + Math_fround(f13 * f42)) + Math_fround(f14 * f41));
  f47 = Math_fround(Math_fround(Math_fround(f12 * f49) + Math_fround(Math_fround(f9 * f43) + Math_fround(f15 * Math_fround(Math_fround(f13 * f41) - Math_fround(f14 * f42))))) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(Math_fround(f13 * f49) + Math_fround(Math_fround(f9 * f42) + Math_fround(f15 * Math_fround(Math_fround(f14 * f43) - Math_fround(f12 * f41))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f41) + Math_fround(f15 * Math_fround(Math_fround(f12 * f42) - Math_fround(f13 * f43)))) + Math_fround(f14 * f49)) * Math_fround(2.0));
  f45 = Math_fround(f45 - Math_fround(f2 * f48));
  f46 = Math_fround(f46 - Math_fround(f2 * f49));
  HEAPF32[i24 + 16 >> 2] = Math_fround(f44 - Math_fround(f2 * f47));
  HEAPF32[i24 + 20 >> 2] = f45;
  HEAPF32[i24 + 24 >> 2] = f46;
  HEAPF32[i24 + 28 >> 2] = f47;
  HEAPF32[i24 + 32 >> 2] = f48;
  HEAPF32[i24 + 36 >> 2] = f49;
  HEAPF32[i24 + 40 >> 2] = f2;
  i53 = 1;
  STACKTOP = i26;
  return i53 | 0;
 } else {
  HEAPF32[i24 + 40 >> 2] = Math_fround(0.0);
  f47 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
  f48 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
  f49 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i24 + 28 >> 2] = f47;
  HEAPF32[i24 + 32 >> 2] = f48;
  HEAPF32[i24 + 36 >> 2] = f49;
  i53 = 1;
  STACKTOP = i26;
  return i53 | 0;
 }
 return 0;
}

function __ZN4Mesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19;
 i10 = i19 + 388 | 0;
 i6 = i19 + 368 | 0;
 i7 = i19 + 264 | 0;
 i8 = i19 + 248 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i17, i18);
 i13 = i17 + 32 | 0;
 if ((HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i13 >> 2] | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i16 = i2 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i13 >> 2] = i1;
 }
 i14 = i17 + 44 | 0;
 i11 = (HEAP8[i14 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i17, 1);
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 128 | 0;
 i15 = i18 + 16 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i16 = i18 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i12, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i15 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i3 + 132 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN7SubMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i18);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i17 + 72 | 0, i18);
 i4 = HEAP32[i13 >> 2] | 0;
 i3 = i4 + 144 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i15 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i20 = i18 + 8 | 0;
  i2 = HEAP32[i20 + 4 >> 2] | 0;
  i5 = i4 + 148 | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + 4 >> 2] = i2;
 }
 __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy(i3, i1, i12, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i20 = HEAP32[i4 + 156 >> 2] | 0;
 i2 = i1 + (i20 << 6) | 0;
 if (i20 | 0) do {
  __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i18);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i17 + 144 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i15 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = i18 + 8 | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i20 = i17 + 148 | 0;
  HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i20 + 4 >> 2] = i5;
 }
 HEAP32[i12 >> 2] = 0;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i3, i1, i12, 1);
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i18, HEAP32[i3 >> 2] | 0, i1 << 2);
 i3 = i17 + 184 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i2 = i4 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i3, 4);
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i15 >> 2] = i2;
 }
 i3 = i17 + 40 | 0;
 if ((i2 + 1 | 0) >>> 0 > i1 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i3, 1);
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
 }
 i1 = i17 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i1, 1);
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
 }
 i1 = i17 + 42 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i1, 1);
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
 }
 i1 = i17 + 43 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i15, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i18);
 if (!(HEAP8[i3 >> 0] | 0)) i9 = 41; else if (!(HEAP32[i18 >> 2] & 16384)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i3 = i6 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i6 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
  i2 = i12;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  __ZN14VertexDataInfoC2Ev(i7);
  HEAP32[i8 >> 2] = 0;
  i5 = i8 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i15, i12, 4);
   i1 = HEAP32[i12 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i15 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j(i8, i1);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i18, HEAP32[i8 >> 2] | 0, i1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i18);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i15, i10, 4);
   i1 = HEAP32[i10 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i15 >> 2] = i2;
  }
  if (!(HEAP32[i6 >> 2] | 0)) {
   i21 = i18 + 8 | 0;
   i2 = HEAP32[i21 + 4 >> 2] | 0;
   i20 = i4;
   HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i20 + 4 >> 2] = i2;
  };
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i6, i1, i12, 1);
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i18, HEAP32[i6 >> 2] | 0, i1 << 5);
  __ZN10VertexData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i18);
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i1;
   i21 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 14;
   HEAP32[i12 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
  }
  __ZN10VertexDataD2Ev(i7);
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4);
   HEAP32[i6 >> 2] = 0;
  }
  i1 = 1;
 } else i9 = 41;
 if ((i9 | 0) == 41) {
  i3 = (HEAP32[i13 >> 2] | 0) + 112 | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i15, i12, 4);
   i1 = HEAP32[i12 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i15 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j(i3, i1);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i18, HEAP32[i3 >> 2] | 0, i1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i18);
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 164 | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i15, i10, 4);
   i1 = HEAP32[i10 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i15 >> 2] = i2;
  }
  if (!(HEAP32[i4 >> 2] | 0)) {
   i9 = i18 + 8 | 0;
   i20 = HEAP32[i9 + 4 >> 2] | 0;
   i21 = i3 + 168 | 0;
   HEAP32[i21 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
  };
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i4, i1, i12, 1);
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i18, HEAP32[i4 >> 2] | 0, i1 << 5);
  __ZN10VertexData8TransferI18StreamedBinaryReadILb0EEEEvRT_((HEAP32[i13 >> 2] | 0) + 8 | 0, i18);
  i1 = 0;
 }
 i3 = i12 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP8[i12 + 12 >> 0] = 0;
 i4 = i12 + 44 | 0;
 i5 = i12 + 72 | 0;
 i6 = i12 + 92 | 0;
 i7 = i12 + 120 | 0;
 i8 = i12 + 140 | 0;
 i9 = i12 + 168 | 0;
 i10 = i12 + 188 | 0;
 i20 = i12 + 208 | 0;
 i21 = i12 + 228 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP8[i3 + 24 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i5 + 16 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP8[i6 + 24 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP8[i8 + 24 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i10 + 16 >> 0] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP8[i20 + 16 >> 0] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i18);
 __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i18);
 if (i1) __ZN14CompressedMesh10DecompressER4Mesh(i12, i17);
 __ZN14CompressedMeshD2Ev(i12);
 if (!i11) {
  i4 = HEAP32[i13 >> 2] | 0;
  i5 = i4 + 8 | 0;
  i2 = HEAP16[i4 + 18 >> 1] | 0;
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i3 = 0;
   i7 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i3 = 0;
    i7 = 1;
    break;
   }
   if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i3 = 0;
    i7 = 1;
    break;
   }
   i2 = HEAP32[i4 + 16 >> 2] | 0;
   i3 = i1 + ((i2 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i7 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i2 = i2 >>> 16 & 65535;
  } while (0);
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) i6 = 0; else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i6 = 0;
    break;
   }
   if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i6 = 0;
    break;
   }
   i2 = HEAP32[i4 + 16 >> 2] | 0;
   i6 = i1 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, HEAP32[i4 + 100 >> 2] | 0) | 0) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + (i2 >>> 8 & 255)) | 0;
   i2 = i2 >>> 16 & 65535;
  } while (0);
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i1 = 0;
   i5 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i5 = 1;
    break;
   }
   if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i1 = 0;
    i5 = 1;
    break;
   }
   i21 = HEAP16[i4 + 16 >> 1] | 0;
   i1 = i1 + (((i21 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i21 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if ((i3 | 0) != (i6 | 0)) {
   i4 = i1;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
    i1 = i3 + i7 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i6 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  }
  HEAP8[i14 >> 0] = HEAP8[i14 >> 0] | 16;
 }
 __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i17 + 48 | 0, i18);
 i1 = i17 + 224 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i15, i1, 4);
  i21 = i17 + 204 | 0;
  __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_R4Mesh(i21, i18, i17);
  STACKTOP = i19;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i15 >> 2] = i3;
  i21 = i17 + 204 | 0;
  __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_R4Mesh(i21, i18, i17);
  STACKTOP = i19;
  return;
 }
}

function __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE(i21, i22) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25 + 272 | 0;
 i20 = i25 + 256 | 0;
 i19 = i25 + 240 | 0;
 i18 = i25 + 224 | 0;
 i17 = i25 + 208 | 0;
 i16 = i25 + 192 | 0;
 i15 = i25 + 176 | 0;
 i14 = i25 + 160 | 0;
 i12 = i25 + 144 | 0;
 i11 = i25 + 128 | 0;
 i10 = i25 + 112 | 0;
 i9 = i25 + 96 | 0;
 i8 = i25 + 80 | 0;
 i7 = i25 + 64 | 0;
 i6 = i25 + 48 | 0;
 i5 = i25 + 32 | 0;
 i4 = i25 + 16 | 0;
 i3 = i25;
 i23 = i25 + 288 | 0;
 i13 = i21 + 144 | 0;
 i2 = HEAP16[i13 >> 1] | 0;
 if (i2 << 16 >> 16 >= 0) {
  STACKTOP = i25;
  return;
 }
 i1 = i2 & 32767;
 HEAP16[i13 >> 1] = i1;
 if (i2 & 8192) {
  i1 = __ZN4FMOD7Channel7setMuteEb(i22, (HEAP8[i21 + 140 >> 0] | 0) != 0) | 0;
  if (i1 | 0) {
   i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i3 >> 2] = gb + 853918;
   HEAP32[i3 + 4 >> 2] = 506;
   HEAP32[i3 + 8 >> 2] = gb + 857927;
   HEAP32[i3 + 12 >> 2] = i2;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i3);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -8193;
  HEAP16[i13 >> 1] = i1;
 }
 i2 = i21 + 142 | 0;
 if (HEAP16[i2 >> 1] & 2048) {
  i1 = __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E(i22, HEAP32[i21 + 68 >> 2] | 0) | 0;
  if (i1 | 0) {
   i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i4 >> 2] = gb + 853918;
   HEAP32[i4 + 4 >> 2] = 507;
   HEAP32[i4 + 8 >> 2] = gb + 857950;
   HEAP32[i4 + 12 >> 2] = i3;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  HEAP16[i2 >> 1] = HEAP16[i2 >> 1] & -2049;
  i1 = HEAP16[i13 >> 1] | 0;
 }
 if (i1 & 16384) {
  __ZN4FMOD7Channel7setModeEj(i22, HEAP8[i21 + 141 >> 0] | 0 ? 2 : 1) | 0;
  i1 = HEAP16[i13 >> 1] & -16385;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 512) {
  i1 = __ZN4FMOD7Channel11setPositionEjj(i22, HEAP32[i21 + 112 >> 2] | 0, 2) | 0;
  if (i1 | 0) {
   i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i5 >> 2] = gb + 853918;
   HEAP32[i5 + 4 >> 2] = 509;
   HEAP32[i5 + 8 >> 2] = gb + 857981;
   HEAP32[i5 + 12 >> 2] = i4;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -513;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 1024) {
  i1 = __ZN4FMOD7Channel11setPositionEjj(i22, HEAP32[i21 + 116 >> 2] | 0, 1) | 0;
  if (i1 | 0) {
   i5 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i6 >> 2] = gb + 853918;
   HEAP32[i6 + 4 >> 2] = 510;
   HEAP32[i6 + 8 >> 2] = gb + 858035;
   HEAP32[i6 + 12 >> 2] = i5;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -1025;
  HEAP16[i13 >> 1] = i1;
 }
 if (HEAP16[i2 >> 1] & 4096) {
  i1 = __ZN4FMOD7Channel15setChannelGroupEPNS_12ChannelGroupE(i22, HEAP32[i21 + 72 >> 2] | 0) | 0;
  if (i1 | 0) {
   i6 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i7 >> 2] = gb + 853918;
   HEAP32[i7 + 4 >> 2] = 511;
   HEAP32[i7 + 8 >> 2] = gb + 858087;
   HEAP32[i7 + 12 >> 2] = i6;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  HEAP16[i2 >> 1] = HEAP16[i2 >> 1] & -4097;
  i1 = HEAP16[i13 >> 1] | 0;
 }
 if (i1 & 2048) {
  i1 = __ZN4FMOD7Channel11setPriorityEi(i22, HEAP32[i21 + 120 >> 2] | 0) | 0;
  if (i1 | 0) {
   i7 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i8 >> 2] = gb + 853918;
   HEAP32[i8 + 4 >> 2] = 512;
   HEAP32[i8 + 8 >> 2] = gb + 858119;
   HEAP32[i8 + 12 >> 2] = i7;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -2049;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 4096) {
  i1 = __ZN4FMOD7Channel19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i22, i21 + 124 | 0) | 0;
  if (i1 | 0) {
   i8 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i9 >> 2] = gb + 853918;
   HEAP32[i9 + 4 >> 2] = 513;
   HEAP32[i9 + 8 >> 2] = gb + 858150;
   HEAP32[i9 + 12 >> 2] = i8;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -4097;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 2) {
  i1 = __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj(i22, 1, HEAP32[i21 + 80 >> 2] | 0, HEAP32[i21 + 96 >> 2] | 0) | 0;
  if (i1 | 0) {
   i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i10 >> 2] = gb + 853918;
   HEAP32[i10 + 4 >> 2] = 514;
   HEAP32[i10 + 8 >> 2] = gb + 858198;
   HEAP32[i10 + 12 >> 2] = i9;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i10);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -35;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 4) {
  i1 = __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj(i22, 2, HEAP32[i21 + 84 >> 2] | 0, HEAP32[i21 + 100 >> 2] | 0) | 0;
  if (i1 | 0) {
   i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i11 >> 2] = gb + 853918;
   HEAP32[i11 + 4 >> 2] = 515;
   HEAP32[i11 + 8 >> 2] = gb + 858327;
   HEAP32[i11 + 12 >> 2] = i10;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -69;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 8) {
  i1 = __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj(i22, 3, HEAP32[i21 + 88 >> 2] | 0, HEAP32[i21 + 104 >> 2] | 0) | 0;
  if (i1 | 0) {
   i11 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i12 >> 2] = gb + 853918;
   HEAP32[i12 + 4 >> 2] = 516;
   HEAP32[i12 + 8 >> 2] = gb + 858450;
   HEAP32[i12 + 12 >> 2] = i11;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i13 >> 1] & -137;
  HEAP16[i13 >> 1] = i1;
 }
 if (i1 & 256) {
  i1 = __ZN4FMOD7Channel6setPanEf(i22, Math_fround(HEAPF32[i21 + 108 >> 2])) | 0;
  if (i1 | 0) {
   i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i14 >> 2] = gb + 853918;
   HEAP32[i14 + 4 >> 2] = 517;
   HEAP32[i14 + 8 >> 2] = gb + 858579;
   HEAP32[i14 + 12 >> 2] = i12;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i14);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  HEAP16[i13 >> 1] = HEAP16[i13 >> 1] & -257;
 }
 i1 = HEAP16[i2 >> 1] | 0;
 if (i1 & 1) {
  i1 = __ZN4FMOD7Channel15set3DAttributesEPK11FMOD_VECTORS3_(i22, i21, i21 + 12 | 0) | 0;
  if (i1 | 0) {
   i14 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i15 >> 2] = gb + 853918;
   HEAP32[i15 + 4 >> 2] = 519;
   HEAP32[i15 + 8 >> 2] = gb + 858600;
   HEAP32[i15 + 12 >> 2] = i14;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i15);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -4;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 & 4) {
  i1 = __ZN4FMOD7Channel20set3DConeOrientationEP11FMOD_VECTOR(i22, i21 + 24 | 0) | 0;
  if (i1 | 0) {
   i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i16 >> 2] = gb + 853918;
   HEAP32[i16 + 4 >> 2] = 520;
   HEAP32[i16 + 8 >> 2] = gb + 858637;
   HEAP32[i16 + 12 >> 2] = i15;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i16);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -5;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 & 8) {
  f27 = Math_fround(HEAPF32[i21 + 36 >> 2]);
  f26 = Math_fround(HEAPF32[i21 + 40 >> 2]);
  i1 = __ZN4FMOD7Channel17set3DConeSettingsEfff(i22, f27, f26, Math_fround(HEAPF32[i21 + 44 >> 2])) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i17 >> 2] = gb + 853918;
   HEAP32[i17 + 4 >> 2] = 521;
   HEAP32[i17 + 8 >> 2] = gb + 858681;
   HEAP32[i17 + 12 >> 2] = i16;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i17);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -57;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 & 64) {
  i1 = __ZN4FMOD7Channel17set3DDopplerLevelEf(i22, Math_fround(HEAPF32[i21 + 48 >> 2])) | 0;
  if (i1 | 0) {
   i17 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i18 >> 2] = gb + 853918;
   HEAP32[i18 + 4 >> 2] = 522;
   HEAP32[i18 + 8 >> 2] = gb + 858758;
   HEAP32[i18 + 12 >> 2] = i17;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i18);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -65;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 & 128) {
  f27 = Math_fround(HEAPF32[i21 + 52 >> 2]);
  i1 = __ZN4FMOD7Channel19set3DMinMaxDistanceEff(i22, f27, Math_fround(HEAPF32[i21 + 56 >> 2])) | 0;
  if (i1 | 0) {
   i18 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i19 >> 2] = gb + 853918;
   HEAP32[i19 + 4 >> 2] = 523;
   HEAP32[i19 + 8 >> 2] = gb + 858799;
   HEAP32[i19 + 12 >> 2] = i18;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i19);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -385;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 & 512) {
  i1 = __ZN4FMOD7Channel13set3DPanLevelEf(i22, Math_fround(HEAPF32[i21 + 60 >> 2])) | 0;
  if (i1 | 0) {
   i19 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i20 >> 2] = gb + 853918;
   HEAP32[i20 + 4 >> 2] = 524;
   HEAP32[i20 + 8 >> 2] = gb + 858846;
   HEAP32[i20 + 12 >> 2] = i19;
   __Z6FormatPKcz(i23, gb + 883334 | 0, i20);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  }
  i1 = HEAP16[i2 >> 1] & -513;
  HEAP16[i2 >> 1] = i1;
 }
 if (!(i1 & 1024)) {
  STACKTOP = i25;
  return;
 }
 i1 = __ZN4FMOD7Channel11set3DSpreadEf(i22, Math_fround(HEAPF32[i21 + 64 >> 2])) | 0;
 if (i1 | 0) {
  i22 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i24 >> 2] = gb + 853918;
  HEAP32[i24 + 4 >> 2] = 525;
  HEAP32[i24 + 8 >> 2] = gb + 858879;
  HEAP32[i24 + 12 >> 2] = i22;
  __Z6FormatPKcz(i23, gb + 883334 | 0, i24);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 }
 HEAP16[i2 >> 1] = HEAP16[i2 >> 1] & -1025;
 STACKTOP = i25;
 return;
}

function __ZN5Umbra11ShadowUtils19getShadowClipPlanesERKNS_7Vector3EPNS_7Vector4ES5_Ri(i16, i5, i17, i18) {
 i16 = i16 | 0;
 i5 = i5 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25 + 360 | 0;
 i20 = i25 + 192 | 0;
 i21 = i25;
 HEAP32[i18 >> 2] = 0;
 i22 = i16 + 4 | 0;
 i23 = i16 + 8 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f4 = Math_fround(HEAPF32[i22 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 4 >> 2])));
 f7 = Math_fround(HEAPF32[i23 >> 2]);
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 8 >> 2]))) < Math_fround(0.0)) {
  HEAP32[i18 >> 2] = 1;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
 }
 i1 = i5 + 16 | 0;
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 20 >> 2])));
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 24 >> 2]))) < Math_fround(0.0)) {
  i6 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = i6 + 1;
  i6 = i17 + (i6 << 4) | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
 }
 i1 = i5 + 32 | 0;
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 36 >> 2])));
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 40 >> 2]))) < Math_fround(0.0)) {
  i6 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = i6 + 1;
  i6 = i17 + (i6 << 4) | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
 }
 i1 = i5 + 48 | 0;
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 52 >> 2])));
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 56 >> 2]))) < Math_fround(0.0)) {
  i6 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = i6 + 1;
  i6 = i17 + (i6 << 4) | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
 }
 i1 = i5 + 64 | 0;
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 68 >> 2])));
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 72 >> 2]))) < Math_fround(0.0)) {
  i6 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = i6 + 1;
  i6 = i17 + (i6 << 4) | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
 }
 i1 = i5 + 80 | 0;
 f15 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 84 >> 2])));
 if (Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 88 >> 2]))) < Math_fround(0.0)) {
  i6 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = i6 + 1;
  i6 = i17 + (i6 << 4) | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 i1 = i19;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5Umbra11ShadowUtils18getFrustumVerticesEPNS_7Vector3EPKNS_7Vector4E(i19, i5);
 HEAPF32[i20 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 1;
 HEAP32[i20 + 8 >> 2] = 2;
 HEAP32[i20 + 12 >> 2] = 3;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 52 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 28 >> 2] = 7;
 HEAP32[i20 + 32 >> 2] = 6;
 HEAP32[i20 + 36 >> 2] = 5;
 HEAP32[i20 + 40 >> 2] = 4;
 HEAPF32[i20 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 80 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 56 >> 2] = 4;
 HEAP32[i20 + 60 >> 2] = 5;
 HEAP32[i20 + 64 >> 2] = 1;
 HEAP32[i20 + 68 >> 2] = 0;
 HEAPF32[i20 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 84 >> 2] = 5;
 HEAP32[i20 + 88 >> 2] = 6;
 HEAP32[i20 + 92 >> 2] = 2;
 HEAP32[i20 + 96 >> 2] = 1;
 HEAPF32[i20 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 136 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 112 >> 2] = 6;
 HEAP32[i20 + 116 >> 2] = 7;
 HEAP32[i20 + 120 >> 2] = 3;
 HEAP32[i20 + 124 >> 2] = 2;
 HEAPF32[i20 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 164 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 140 >> 2] = 7;
 HEAP32[i20 + 144 >> 2] = 4;
 HEAP32[i20 + 148 >> 2] = 0;
 HEAP32[i20 + 152 >> 2] = 3;
 i2 = 0;
 i5 = 3;
 i6 = 2;
 i1 = 1;
 while (1) {
  f10 = Math_fround(HEAPF32[i19 + (i5 * 12 | 0) >> 2]);
  f15 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) >> 2]);
  f10 = Math_fround(f10 - f15);
  f12 = Math_fround(HEAPF32[i19 + (i5 * 12 | 0) + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 4 >> 2]);
  f12 = Math_fround(f12 - f11);
  f9 = Math_fround(HEAPF32[i19 + (i5 * 12 | 0) + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 8 >> 2]);
  f9 = Math_fround(f9 - f14);
  f15 = Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) >> 2]) - f15);
  f11 = Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) + 4 >> 2]) - f11);
  f14 = Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) + 8 >> 2]) - f14);
  f13 = Math_fround(Math_fround(f12 * f14) - Math_fround(f9 * f11));
  f14 = Math_fround(Math_fround(f9 * f15) - Math_fround(f10 * f14));
  f15 = Math_fround(Math_fround(f10 * f11) - Math_fround(f12 * f15));
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14))))));
  f14 = Math_fround(f12 * f14);
  f15 = Math_fround(f15 * f12);
  HEAPF32[i20 + (i2 * 28 | 0) + 16 >> 2] = Math_fround(f12 * f13);
  HEAPF32[i20 + (i2 * 28 | 0) + 20 >> 2] = f14;
  HEAPF32[i20 + (i2 * 28 | 0) + 24 >> 2] = f15;
  i1 = i2 + 1 | 0;
  if ((i1 | 0) == 6) break;
  i2 = i1;
  i5 = HEAP32[i20 + (i1 * 28 | 0) + 12 >> 2] | 0;
  i6 = HEAP32[i20 + (i1 * 28 | 0) + 8 >> 2] | 0;
  i1 = HEAP32[i20 + (i1 * 28 | 0) + 4 >> 2] | 0;
 }
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 1;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 2;
 HEAP32[i21 + 16 >> 2] = 1;
 HEAP32[i21 + 20 >> 2] = 2;
 HEAP32[i21 + 24 >> 2] = 0;
 HEAP32[i21 + 28 >> 2] = 3;
 HEAP32[i21 + 32 >> 2] = 2;
 HEAP32[i21 + 36 >> 2] = 3;
 HEAP32[i21 + 40 >> 2] = 0;
 HEAP32[i21 + 44 >> 2] = 4;
 HEAP32[i21 + 48 >> 2] = 3;
 HEAP32[i21 + 52 >> 2] = 0;
 HEAP32[i21 + 56 >> 2] = 0;
 HEAP32[i21 + 60 >> 2] = 5;
 HEAP32[i21 + 64 >> 2] = 7;
 HEAP32[i21 + 68 >> 2] = 6;
 HEAP32[i21 + 72 >> 2] = 1;
 HEAP32[i21 + 76 >> 2] = 4;
 HEAP32[i21 + 80 >> 2] = 6;
 HEAP32[i21 + 84 >> 2] = 5;
 HEAP32[i21 + 88 >> 2] = 1;
 HEAP32[i21 + 92 >> 2] = 3;
 HEAP32[i21 + 96 >> 2] = 5;
 HEAP32[i21 + 100 >> 2] = 4;
 HEAP32[i21 + 104 >> 2] = 1;
 HEAP32[i21 + 108 >> 2] = 2;
 HEAP32[i21 + 112 >> 2] = 4;
 HEAP32[i21 + 116 >> 2] = 7;
 HEAP32[i21 + 120 >> 2] = 1;
 HEAP32[i21 + 124 >> 2] = 5;
 HEAP32[i21 + 128 >> 2] = 7;
 HEAP32[i21 + 132 >> 2] = 3;
 HEAP32[i21 + 136 >> 2] = 4;
 HEAP32[i21 + 140 >> 2] = 5;
 HEAP32[i21 + 144 >> 2] = 5;
 HEAP32[i21 + 148 >> 2] = 1;
 HEAP32[i21 + 152 >> 2] = 2;
 HEAP32[i21 + 156 >> 2] = 3;
 HEAP32[i21 + 160 >> 2] = 2;
 HEAP32[i21 + 164 >> 2] = 6;
 HEAP32[i21 + 168 >> 2] = 4;
 HEAP32[i21 + 172 >> 2] = 3;
 HEAP32[i21 + 176 >> 2] = 0;
 HEAP32[i21 + 180 >> 2] = 4;
 HEAP32[i21 + 184 >> 2] = 2;
 HEAP32[i21 + 188 >> 2] = 5;
 f13 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + Math_fround(0.0));
 f14 = Math_fround(Math_fround(HEAPF32[i19 + 4 >> 2]) + Math_fround(0.0));
 f15 = Math_fround(Math_fround(HEAPF32[i19 + 8 >> 2]) + Math_fround(0.0));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 12 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 16 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 20 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 24 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 28 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 32 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 36 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 40 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 44 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 48 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 52 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 56 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 60 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 64 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 68 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 72 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 76 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i19 + 80 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i19 + 84 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i19 + 88 >> 2]));
 f13 = Math_fround(f13 * Math_fround(.125));
 f14 = Math_fround(f14 * Math_fround(.125));
 f15 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i19 + 92 >> 2])) * Math_fround(.125));
 i2 = 0;
 do {
  i6 = HEAP32[i21 + (i2 << 4) + 8 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 16 >> 2]);
  f7 = Math_fround(HEAPF32[i16 >> 2]);
  f3 = Math_fround(f3 * f7);
  f4 = Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 20 >> 2]);
  f8 = Math_fround(HEAPF32[i22 >> 2]);
  f4 = Math_fround(f3 + Math_fround(f4 * f8));
  f3 = Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 24 >> 2]);
  f9 = Math_fround(HEAPF32[i23 >> 2]);
  f3 = Math_fround(f4 + Math_fround(f3 * f9));
  i6 = HEAP32[i21 + (i2 << 4) + 12 >> 2] | 0;
  f4 = Math_fround(f7 * Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 16 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f8 * Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 20 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i20 + (i6 * 28 | 0) + 24 >> 2])));
  if (f3 > Math_fround(0.0) & f4 <= Math_fround(0.0)) i24 = 10; else if (f3 <= Math_fround(0.0) & f4 > Math_fround(0.0)) i24 = 10;
  if ((i24 | 0) == 10) {
   i24 = 0;
   i6 = HEAP32[i21 + (i2 << 4) >> 2] | 0;
   f10 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) >> 2]);
   f11 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 8 >> 2]);
   i6 = HEAP32[i21 + (i2 << 4) + 4 >> 2] | 0;
   f27 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 4 >> 2]);
   f27 = Math_fround(f27 - f10);
   f26 = Math_fround(f26 - f11);
   f3 = Math_fround(Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 8 >> 2]) - f12);
   f4 = Math_fround(Math_fround(f26 * f9) - Math_fround(f3 * f8));
   f3 = Math_fround(Math_fround(f3 * f7) - Math_fround(f27 * f9));
   f9 = Math_fround(Math_fround(f27 * f8) - Math_fround(f26 * f7));
   f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3))))));
   f4 = Math_fround(f4 * f7);
   f3 = Math_fround(f3 * f7);
   f7 = Math_fround(f9 * f7);
   if (Math_fround(Math_fround(Math_fround(f15 - f12) * f7) + Math_fround(Math_fround(Math_fround(f13 - f10) * f4) + Math_fround(Math_fround(f14 - f11) * f3))) < Math_fround(0.0)) {
    f8 = Math_fround(-f4);
    f9 = Math_fround(-f7);
    f3 = Math_fround(-f3);
   } else {
    f8 = f4;
    f9 = f7;
   }
   i1 = HEAP32[i18 >> 2] | 0;
   HEAP32[i18 >> 2] = i1 + 1;
   f7 = Math_fround(Math_fround(Math_fround(f10 * f8) + Math_fround(f11 * f3)) + Math_fround(f12 * f9));
   f4 = Math_fround(-f7);
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f3 * f3)) + Math_fround(f9 * f9)) + Math_fround(f7 * f7))));
   if (f7 != Math_fround(0.0)) {
    f27 = Math_fround(Math_fround(1.0) / f7);
    f8 = Math_fround(f8 * f27);
    f7 = Math_fround(f9 * f27);
    f4 = Math_fround(f27 * f4);
    f3 = Math_fround(f3 * f27);
   } else f7 = f9;
   HEAPF32[i17 + (i1 << 4) >> 2] = f8;
   HEAPF32[i17 + (i1 << 4) + 4 >> 2] = f3;
   HEAPF32[i17 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i17 + (i1 << 4) + 12 >> 2] = f4;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 12);
 STACKTOP = i25;
 return;
}

function __ZN23SweepBoxMeshHitCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i24, i23, i3, i4, i5, i26, i2) {
 i24 = i24 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var f1 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 384 | 0;
 i19 = i25 + 432 | 0;
 i21 = i25 + 368 | 0;
 i9 = i25 + 192 | 0;
 i2 = i25 + 208 | 0;
 i8 = i25 + 48 | 0;
 i7 = i25 + 32 | 0;
 i6 = i25 + 16 | 0;
 i20 = i25;
 i10 = i25 + 420 | 0;
 if (HEAP16[HEAP32[i24 + 72 >> 2] >> 1] & 256) {
  i2 = HEAP32[i24 + 8 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i3 >> 2]);
  f36 = Math_fround(HEAPF32[i2 >> 2]);
  f1 = Math_fround(f12 * f36);
  f35 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f16 = Math_fround(f12 * f35);
  f28 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f12 = Math_fround(f12 * f28);
  f33 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f29 = Math_fround(f33 * f32);
  f30 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f31 = Math_fround(f33 * f30);
  f18 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  f29 = Math_fround(f1 + f29);
  f31 = Math_fround(f16 + f31);
  f33 = Math_fround(f12 + Math_fround(f33 * f18));
  f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f1 = Math_fround(f12 * f16);
  f17 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f11 = Math_fround(f12 * f17);
  f27 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f1 = Math_fround(f29 + f1);
  f11 = Math_fround(f31 + f11);
  f12 = Math_fround(f33 + Math_fround(f12 * f27));
  f33 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f1 = Math_fround(f1 + f33);
  f31 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f11 = Math_fround(f11 + f31);
  f29 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f12 = Math_fround(f12 + f29);
  f15 = Math_fround(HEAPF32[i4 >> 2]);
  f13 = Math_fround(f36 * f15);
  f14 = Math_fround(f35 * f15);
  f15 = Math_fround(f28 * f15);
  f34 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f32 * f34));
  f14 = Math_fround(f14 + Math_fround(f30 * f34));
  f34 = Math_fround(f15 + Math_fround(f18 * f34));
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f13 = Math_fround(f33 + Math_fround(f13 + Math_fround(f16 * f15)));
  f14 = Math_fround(f31 + Math_fround(f14 + Math_fround(f17 * f15)));
  f15 = Math_fround(f29 + Math_fround(f34 + Math_fround(f27 * f15)));
  f34 = Math_fround(HEAPF32[i5 >> 2]);
  f36 = Math_fround(f36 * f34);
  f35 = Math_fround(f35 * f34);
  f34 = Math_fround(f28 * f34);
  f28 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f32 = Math_fround(f36 + Math_fround(f32 * f28));
  f30 = Math_fround(f35 + Math_fround(f30 * f28));
  f28 = Math_fround(f34 + Math_fround(f18 * f28));
  f18 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f16 = Math_fround(f33 + Math_fround(f32 + Math_fround(f16 * f18)));
  f17 = Math_fround(f31 + Math_fround(f30 + Math_fround(f17 * f18)));
  f18 = Math_fround(f29 + Math_fround(f28 + Math_fround(f27 * f18)));
  HEAPF32[i22 >> 2] = f1;
  i2 = i22 + 4 | 0;
  HEAPF32[i2 >> 2] = f11;
  i3 = i22 + 8 | 0;
  HEAPF32[i3 >> 2] = f12;
  i4 = i22 + 12 | 0;
  HEAPF32[i4 >> 2] = f13;
  i5 = i22 + 16 | 0;
  HEAPF32[i5 >> 2] = f14;
  i6 = i22 + 20 | 0;
  HEAPF32[i6 >> 2] = f15;
  i7 = i22 + 24 | 0;
  HEAPF32[i7 >> 2] = f16;
  i8 = i22 + 28 | 0;
  HEAPF32[i8 >> 2] = f17;
  i9 = i22 + 32 | 0;
  HEAPF32[i9 >> 2] = f18;
  HEAPF32[i19 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i10 = i24 + 12 | 0;
  f18 = Math_fround(HEAPF32[i10 >> 2]);
  if (__ZN5physx2Gu23triBoxSweepTestBoxSpaceERKNS_10PxTriangleERKNS_6PxVec3ES6_S6_fRfb(i22, (HEAP32[i24 + 52 >> 2] | 0) + 48 | 0, HEAP32[i24 + 64 >> 2] | 0, i24 + 196 | 0, f18, i19, (HEAP8[i24 + 48 >> 0] | 0) == 0) | 0) {
   f1 = Math_fround(HEAPF32[i19 >> 2]);
   if (f1 <= Math_fround(HEAPF32[i10 >> 2])) {
    HEAPF32[i10 >> 2] = f1;
    HEAPF32[i26 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i24 + 20 >> 2]));
    i21 = HEAP32[i22 >> 2] | 0;
    i22 = HEAP32[i2 >> 2] | 0;
    i26 = HEAP32[i3 >> 2] | 0;
    HEAP32[i24 + 128 >> 2] = i21;
    HEAP32[i24 + 132 >> 2] = i22;
    HEAP32[i24 + 136 >> 2] = i26;
    HEAPF32[i24 + 140 >> 2] = Math_fround(0.0);
    i20 = HEAP32[i24 + 68 >> 2] | 0;
    f34 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
    f35 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
    f36 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
    HEAPF32[i24 + 144 >> 2] = f34;
    HEAPF32[i24 + 148 >> 2] = f35;
    HEAPF32[i24 + 152 >> 2] = f36;
    HEAPF32[i24 + 156 >> 2] = Math_fround(0.0);
    HEAP8[i24 + 76 >> 0] = 1;
    HEAP32[i24 + 192 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i24 + 84 >> 2] = i21;
    HEAP32[i24 + 88 >> 2] = i22;
    HEAP32[i24 + 92 >> 2] = i26;
    HEAP32[i24 + 96 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i24 + 100 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i24 + 104 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i24 + 108 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i24 + 112 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i24 + 116 >> 2] = HEAP32[i9 >> 2];
    if (f1 == Math_fround(0.0)) {
     HEAP8[i24 + 77 >> 0] = 1;
     i26 = 0;
     STACKTOP = i25;
     return i26 | 0;
    }
   }
  }
  i26 = 1;
  STACKTOP = i25;
  return i26 | 0;
 }
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i19 = HEAP32[i24 + 8 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i19 >> 2]);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f1 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f16 = Math_fround(f29 * f27);
 f17 = Math_fround(f29 * f30);
 f29 = Math_fround(f29 * f34);
 i3 = i19 + 12 | 0;
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f28 * f1));
 f17 = Math_fround(f17 + Math_fround(f28 * f11));
 f28 = Math_fround(f29 + Math_fround(f28 * f36));
 i3 = i19 + 24 | 0;
 f29 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f38 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f18 * f37));
 f17 = Math_fround(f17 + Math_fround(f18 * f29));
 f18 = Math_fround(f28 + Math_fround(f18 * f32));
 i19 = i19 + 36 | 0;
 f28 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f16 = Math_fround(f16 + f38);
 f17 = Math_fround(f17 + f28);
 f18 = Math_fround(f18 + f31);
 f35 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(f38 + Math_fround(Math_fround(f37 * f12) + Math_fround(Math_fround(f27 * f35) + Math_fround(f1 * f15))));
 f14 = Math_fround(f28 + Math_fround(Math_fround(f29 * f12) + Math_fround(Math_fround(f30 * f35) + Math_fround(f11 * f15))));
 f15 = Math_fround(f31 + Math_fround(Math_fround(f32 * f12) + Math_fround(Math_fround(f34 * f35) + Math_fround(f36 * f15))));
 f35 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f1 = Math_fround(f38 + Math_fround(Math_fround(f37 * f33) + Math_fround(Math_fround(f27 * f35) + Math_fround(f1 * f12))));
 f11 = Math_fround(f28 + Math_fround(Math_fround(f29 * f33) + Math_fround(Math_fround(f30 * f35) + Math_fround(f11 * f12))));
 f12 = Math_fround(f31 + Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f34 * f35) + Math_fround(f36 * f12))));
 if (!(HEAP8[i24 + 48 >> 0] | 0)) {
  f37 = Math_fround(f1 - f13);
  f38 = Math_fround(f11 - f14);
  f32 = Math_fround(f12 - f15);
  f35 = Math_fround(f16 - f13);
  f33 = Math_fround(f17 - f14);
  f36 = Math_fround(f18 - f15);
  f34 = Math_fround(Math_fround(f36 * f38) - Math_fround(f33 * f32));
  f36 = Math_fround(Math_fround(f35 * f32) - Math_fround(f36 * f37));
  f38 = Math_fround(Math_fround(f33 * f37) - Math_fround(f35 * f38));
  f35 = Math_fround(HEAPF32[i24 + 176 >> 2]);
  f37 = Math_fround(HEAPF32[i24 + 180 >> 2]);
  if (Math_fround(Math_fround(Math_fround(f34 * f35) + Math_fround(f36 * f37)) + Math_fround(f38 * Math_fround(HEAPF32[i24 + 184 >> 2]))) >= Math_fround(0.0)) {
   i26 = 1;
   STACKTOP = i25;
   return i26 | 0;
  }
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i19 = HEAP32[i24 + 52 >> 2] | 0;
 i4 = HEAP32[i19 + 48 >> 2] | 0;
 i5 = HEAP32[i19 + 52 >> 2] | 0;
 i19 = HEAP32[i19 + 56 >> 2] | 0;
 i3 = i2 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i2 + 80 >> 2] = 3;
 HEAPF32[i2 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i2 + 144 >> 2] = i4;
 HEAP32[i2 + 148 >> 2] = i5;
 HEAP32[i2 + 152 >> 2] = i19;
 HEAPF32[i2 + 156 >> 2] = Math_fround(0.0);
 f36 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = f36 <= f38 ? f36 : f38;
 f37 = f38 <= f37 ? f38 : f37;
 HEAPF32[i2 + 16 >> 2] = Math_fround(f37 * Math_fround(.150000006));
 HEAPF32[i2 + 32 >> 2] = Math_fround(f37 * Math_fround(.0500000007));
 i19 = i8 + 64 | 0;
 HEAP32[i8 + 80 >> 2] = 7;
 HEAPF32[i8 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 f37 = Math_fround(Math_fround(Math_fround(f17 + f14) + f11) * Math_fround(.333332986));
 f38 = Math_fround(Math_fround(Math_fround(f18 + f15) + f12) * Math_fround(.333332986));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f16 + f13) + f1) * Math_fround(.333332986));
 HEAPF32[i8 + 4 >> 2] = f37;
 HEAPF32[i8 + 8 >> 2] = f38;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 96 >> 2] = f16;
 HEAPF32[i8 + 100 >> 2] = f17;
 HEAPF32[i8 + 104 >> 2] = f18;
 HEAPF32[i8 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 112 >> 2] = f13;
 HEAPF32[i8 + 116 >> 2] = f14;
 HEAPF32[i8 + 120 >> 2] = f15;
 HEAPF32[i8 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 128 >> 2] = f1;
 HEAPF32[i8 + 132 >> 2] = f11;
 HEAPF32[i8 + 136 >> 2] = f12;
 HEAPF32[i8 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 do if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i8, i2, i21, i9, i24 + 176 | 0, i7, i20, i6, Math_fround(HEAPF32[i24 + 80 >> 2]), 0) | 0) {
  HEAP8[i24 + 76 >> 0] = 1;
  i22 = i24 + 128 | 0;
  HEAP32[i22 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i24 + 192 >> 2] = HEAP32[i23 + 8 >> 2];
  f38 = Math_fround(HEAPF32[i21 >> 2]);
  f1 = Math_fround(HEAPF32[i7 >> 2]);
  if (!(f38 >= f1)) {
   i21 = i24 + 12 | 0;
   f38 = Math_fround(f1 * Math_fround(HEAPF32[i21 >> 2]));
   HEAPF32[i21 >> 2] = f38;
   i21 = i24 + 176 | 0;
   f35 = Math_fround(HEAPF32[i21 >> 2]);
   i23 = i24 + 180 | 0;
   f36 = Math_fround(HEAPF32[i23 >> 2]);
   i22 = i24 + 184 | 0;
   f36 = Math_fround(f36 * f1);
   f37 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f1);
   HEAPF32[i21 >> 2] = Math_fround(f35 * f1);
   HEAPF32[i23 >> 2] = f36;
   HEAPF32[i22 >> 2] = f37;
   HEAPF32[i24 + 188 >> 2] = Math_fround(0.0);
   i22 = i24 + 32 | 0;
   i23 = i24 + 36 | 0;
   HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f1);
   HEAP32[i23 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i23 = i24 + 144 | 0;
   HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   f1 = Math_fround(f38 * Math_fround(HEAPF32[i24 + 20 >> 2]));
   if (!(f1 < Math_fround(HEAPF32[i26 >> 2]))) break;
   HEAPF32[i26 >> 2] = f1;
   break;
  } else {
   HEAP8[i24 + 77 >> 0] = 1;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   i26 = i24 + 32 | 0;
   HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i26 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i26 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i26 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
   i26 = HEAP32[i24 + 68 >> 2] | 0;
   f36 = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
   f37 = Math_fround(-Math_fround(HEAPF32[i26 + 4 >> 2]));
   f38 = Math_fround(-Math_fround(HEAPF32[i26 + 8 >> 2]));
   HEAPF32[i24 + 144 >> 2] = f36;
   HEAPF32[i24 + 148 >> 2] = f37;
   HEAPF32[i24 + 152 >> 2] = f38;
   HEAPF32[i24 + 156 >> 2] = Math_fround(0.0);
   i26 = 0;
   STACKTOP = i25;
   return i26 | 0;
  }
 } while (0);
 i26 = 1;
 STACKTOP = i25;
 return i26 | 0;
}

function __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i49, i37, i7, i9) {
 i49 = i49 | 0;
 i37 = i37 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i50 + 64 | 0;
 i39 = i50 + 56 | 0;
 i38 = i50 + 40 | 0;
 i41 = i50 + 16 | 0;
 i45 = i50;
 i43 = i50 + 136 | 0;
 i47 = i50 + 100 | 0;
 i10 = i50 + 96 | 0;
 i48 = i50 + 88 | 0;
 i8 = i50 + 80 | 0;
 i46 = i50 + 72 | 0;
 i31 = i50 + 133 | 0;
 i32 = i50 + 132 | 0;
 i33 = i50 + 131 | 0;
 i34 = i50 + 130 | 0;
 i35 = i50 + 129 | 0;
 i36 = i50 + 128 | 0;
 HEAP8[i43 >> 0] = 0;
 i6 = i7 + 12 | 0;
 HEAP32[i45 >> 2] = HEAP32[i6 >> 2];
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 1076431 | 0, i45);
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 669191 | 0, i50 + 8 | 0);
 i45 = HEAP32[i6 >> 2] | 0;
 i30 = (_strcmp(i45, gb + 754608 | 0) | 0) == 0;
 if (!(_strcmp(i45, gb + 754632 | 0) | 0)) i42 = (HEAP32[(__ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i49, 2) | 0) + 56 >> 2] | 0) != 0; else i42 = 0;
 HEAP32[i10 >> 2] = 0;
 i44 = i48 + 4 | 0;
 HEAP8[i44 >> 0] = 1;
 i3 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i50 + 135 | 0, 11264, gb + 668920 | 0, 290) | 0;
 HEAP32[i48 >> 2] = i3;
 HEAP32[i8 >> 2] = 0;
 i45 = i46 + 4 | 0;
 HEAP8[i45 >> 0] = 1;
 i4 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i50 + 134 | 0, 11264, gb + 668920 | 0, 292) | 0;
 HEAP32[i46 >> 2] = i4;
 i5 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i49, HEAP32[i6 >> 2] | 0, 2) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if (!(i2 & 1 | i1)) {
  HEAP32[i10 >> 2] = 0;
  __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE(i49, i7, i3, i10, 0, 1);
  HEAP32[i8 >> 2] = 0;
  __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE(i49, i5, HEAP32[i46 >> 2] | 0, i8, 0, 2);
  i29 = HEAP32[i8 >> 2] | 0;
 } else {
  i28 = i3 + 36 | 0;
  HEAP32[i28 >> 2] = i1;
  HEAP32[i28 + 4 >> 2] = i2;
  HEAP32[i3 + 32 >> 2] = i9;
  i28 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 >> 2] = i28;
  HEAP32[i3 + 4 >> 2] = i28;
  HEAP32[i3 + 8 >> 2] = i9;
  HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i3 + 16 >> 2] = 1;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i10 >> 2] = 1;
  i28 = HEAP32[i5 + 4 >> 2] | 0;
  i29 = i4 + 36 | 0;
  HEAP32[i29 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i29 + 4 >> 2] = i28;
  HEAP32[i4 + 32 >> 2] = i9;
  i29 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = i29;
  HEAP32[i4 + 4 >> 2] = i29;
  HEAP32[i4 + 8 >> 2] = i9;
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i4 + 16 >> 2] = 1;
  HEAP32[i4 + 24 >> 2] = 0;
  HEAP32[i8 >> 2] = 1;
  i29 = 1;
 }
 i21 = HEAP32[i10 >> 2] | 0;
 i22 = (i21 | 0) > (i29 | 0) ? i21 : i29;
 L8 : do if ((i22 | 0) > 0) {
  i23 = i47 + 4 | 0;
  i24 = i47 + 8 | 0;
  i25 = i47 + 12 | 0;
  i26 = i47 + 16 | 0;
  i27 = i47 + 20 | 0;
  i28 = i47 + 24 | 0;
  i20 = i30 ^ 1;
  i18 = 0;
  i15 = -1;
  i16 = 0;
  i4 = 0;
  i1 = 0;
  i19 = -1;
  while (1) {
   i11 = (i16 | 0) < (i21 | 0);
   if (i11) {
    i13 = i37 + i1 | 0;
    i14 = HEAPU8[i13 >> 0] | 0;
    i2 = HEAP32[i48 >> 2] | 0;
    i17 = HEAP32[i2 + (i16 * 44 | 0) + 8 >> 2] | 0;
    i2 = HEAP32[i2 + (i16 * 44 | 0) + 4 >> 2] | 0;
    HEAP32[i41 >> 2] = i13;
    HEAP32[i41 + 4 >> 2] = i14;
    HEAP32[i41 + 8 >> 2] = i1;
    HEAP32[i41 + 12 >> 2] = i17;
    HEAP32[i41 + 16 >> 2] = i2;
    __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 669502 | 0, i41);
    i2 = HEAP32[i48 >> 2] | 0;
    if ((HEAP32[i2 + (i16 * 44 | 0) + 12 >> 2] | 0) > 1) {
     i3 = 1;
     do {
      i14 = i3 + i1 | 0;
      i12 = i37 + i14 | 0;
      i13 = HEAPU8[i12 >> 0] | 0;
      i17 = (HEAP32[i2 + (i16 * 44 | 0) + 8 >> 2] | 0) + i3 | 0;
      HEAP32[i38 >> 2] = i12;
      HEAP32[i38 + 4 >> 2] = i13;
      HEAP32[i38 + 8 >> 2] = i14;
      HEAP32[i38 + 12 >> 2] = i17;
      __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 669520 | 0, i38);
      i3 = i3 + 1 | 0;
      i2 = HEAP32[i48 >> 2] | 0;
     } while ((i3 | 0) < (HEAP32[i2 + (i16 * 44 | 0) + 12 >> 2] | 0));
    }
   }
   i7 = HEAP32[i46 >> 2] | 0;
   i8 = HEAP32[i48 >> 2] | 0;
   i10 = i7;
   i7 = i7 + (i4 * 44 | 0) + 24 | 0;
   i2 = i4;
   L17 : while (1) {
    i3 = (i2 | 0) < (i29 | 0);
    if (i11) {
     i4 = HEAP32[i8 + (i16 * 44 | 0) + 24 >> 2] & 512;
     i5 = (i4 | 0) == 0;
     do {
      if (i3) i6 = HEAP32[i7 >> 2] & 512; else i6 = 0;
      i9 = (i6 | 0) != 0;
      if (!(i6 | i4)) {
       i14 = 24;
       break L17;
      }
      if (!i5) {
       i14 = 22;
       break L17;
      }
     } while (!i9);
    } else {
     if (!i3) {
      i14 = 24;
      break;
     }
     if (!(HEAP32[i7 >> 2] & 512)) {
      i14 = 24;
      break;
     }
    }
    i5 = HEAP32[i10 + (i2 * 44 | 0) + 12 >> 2] | 0;
    i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i33, i5, gb + 668920 | 0, 441) | 0;
    _memset(i4 | 0, 0, i5 | 0) | 0;
    i5 = HEAP32[i46 >> 2] | 0;
    i17 = i5 + (i2 * 44 | 0) + 36 | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    i17 = HEAP32[i17 + 4 >> 2] | 0;
    i6 = i49 + (i17 >> 1) | 0;
    if (i17 & 1) i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + i3 >> 2] | 0;
    i17 = i5 + (i2 * 44 | 0) | 0;
    mftCall_viiii(i3 | 0, i6 | 0, i4 | 0, i17 | 0, i17 | 0);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i34, i4);
    i17 = i2 + 1 | 0;
    i7 = HEAP32[i46 >> 2] | 0;
    i8 = HEAP32[i48 >> 2] | 0;
    i10 = i7;
    i7 = i7 + (i17 * 44 | 0) + 24 | 0;
    i2 = i17;
   }
   do if ((i14 | 0) == 22) {
    i14 = 0;
    i4 = HEAP32[i8 + (i16 * 44 | 0) + 12 >> 2] | 0;
    if (i9) {
     i3 = HEAP32[i10 + (i2 * 44 | 0) + 12 >> 2] | 0;
     if ((i4 | 0) == (i3 | 0)) {
      i14 = 24;
      break;
     }
     i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i3, gb + 668920 | 0, 403) | 0;
     _memset(i6 | 0, 0, i3 | 0) | 0;
     i4 = HEAP32[i46 >> 2] | 0;
     i17 = i4 + (i2 * 44 | 0) + 36 | 0;
     i3 = HEAP32[i17 >> 2] | 0;
     i17 = HEAP32[i17 + 4 >> 2] | 0;
     i5 = i49 + (i17 >> 1) | 0;
     if (i17 & 1) i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + i3 >> 2] | 0;
     i4 = i4 + (i2 * 44 | 0) | 0;
     mftCall_viiii(i3 | 0, i5 | 0, i6 | 0, i4 | 0, i4 | 0);
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i6);
     i4 = HEAP32[(HEAP32[i48 >> 2] | 0) + (i16 * 44 | 0) + 12 >> 2] | 0;
     i2 = i2 + 1 | 0;
    }
    i3 = HEAP32[i48 >> 2] | 0;
    i12 = HEAP32[i46 >> 2] | 0;
    i17 = i2;
    i2 = 1;
    i1 = i4 + i1 | 0;
   } while (0);
   if ((i14 | 0) == 24) {
    i14 = 0;
    i3 = HEAP32[i48 >> 2] | 0;
    i12 = HEAP32[i46 >> 2] | 0;
    i17 = i2;
    i2 = 0;
   }
   i6 = (i17 | 0) < (i29 | 0);
   if (i2) {
    i6 = i18;
    i5 = i15;
    i2 = i16;
    i4 = i17;
    i3 = i19;
   } else {
    i8 = i3 + (i16 * 44 | 0) | 0;
    i13 = i12 + (i17 * 44 | 0) | 0;
    if (i11) {
     i2 = __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv(i8) | 0;
     if ((i15 | 0) != -1 & i2) {
      i2 = (HEAP32[i3 + (i16 * 44 | 0) + 12 >> 2] | 0) + i1 | 0;
      i3 = i16 + 1 | 0;
      if ((i3 | 0) < (i21 | 0)) {
       i5 = -1;
       i4 = __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv(i8) | 0;
       i7 = i2;
      } else {
       i5 = -1;
       i4 = 0;
       i7 = i2;
      }
     } else {
      i5 = i15;
      i3 = i16;
      i4 = i2;
      i7 = i1;
     }
    } else {
     i5 = i15;
     i3 = i16;
     i4 = 0;
     i7 = i1;
    }
    if (i6) {
     i2 = __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv(i13) | 0;
     if ((i19 | 0) != -1 & i2) {
      i9 = HEAP32[i48 >> 2] | 0;
      i2 = 1;
      i6 = 0;
      i3 = i3 + -1 | 0;
      i4 = 1;
      i1 = HEAP32[i9 + (i19 * 44 | 0) + 32 >> 2] | 0;
      i8 = i9 + (i19 * 44 | 0) | 0;
      i7 = i7 - (HEAP32[i9 + (i19 * 44 | 0) + 12 >> 2] | 0) | 0;
      i9 = -1;
     } else {
      i6 = i18;
      i9 = i19;
     }
    } else {
     i2 = 0;
     i6 = i18;
     i9 = i19;
    }
    if ((i3 | 0) == (i21 | 0) & (i17 | 0) == (i29 | 0)) break;
    do if (i2 | i4) {
     if (i4) {
      if (i2) {
       i10 = i3;
       i3 = i9;
       break;
      }
      i7 = (HEAP32[i8 + 12 >> 2] | 0) + i7 | 0;
      i8 = i3 + 1 | 0;
      i6 = 1;
      i10 = i8;
      i1 = i7;
      i8 = (HEAP32[i48 >> 2] | 0) + (i8 * 44 | 0) | 0;
      break;
     } else i1 = i3;
     while (1) {
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= (i21 | 0)) {
       i2 = i1;
       break;
      }
      if (__ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv((HEAP32[i48 >> 2] | 0) + (i1 * 44 | 0) | 0) | 0) {
       i2 = i1;
       break;
      }
     }
     i19 = HEAP32[i48 >> 2] | 0;
     i5 = i17;
     i10 = i3 + -1 | 0;
     i1 = HEAP32[i19 + (i2 * 44 | 0) + 32 >> 2] | 0;
     i8 = i19 + (i2 * 44 | 0) | 0;
     i7 = i7 - (HEAP32[i19 + (i2 * 44 | 0) + 12 >> 2] | 0) | 0;
     i3 = i9;
    } else {
     i10 = i3;
     i3 = i9;
    } while (0);
    if (!(HEAP32[i8 + 24 >> 2] & 256)) {
     do if (i42) {
      i2 = HEAP32[i8 + 4 >> 2] | 0;
      if (!(_strcmp(i2, gb + 752413 | 0) | 0)) HEAP32[i47 >> 2] = HEAP32[i37 + i1 >> 2];
      if (!(_strcmp(i2, gb + 752449 | 0) | 0)) HEAP32[i23 >> 2] = HEAP32[i37 + i1 >> 2];
      if (!(_strcmp(i2, gb + 752457 | 0) | 0)) HEAP32[i24 >> 2] = HEAP32[i37 + i1 >> 2];
      if (!(_strcmp(i2, gb + 752300 | 0) | 0)) HEAP32[i25 >> 2] = HEAP32[i37 + i1 >> 2];
      if (!(_strcmp(i2, gb + 752314 | 0) | 0)) HEAP32[i26 >> 2] = HEAP32[i37 + i1 >> 2];
      if (!(_strcmp(i2, gb + 752293 | 0) | 0)) HEAP32[i27 >> 2] = HEAP32[i37 + i1 >> 2];
      if (_strcmp(i2, gb + 752286 | 0) | 0) break;
      HEAP32[i28 >> 2] = HEAP32[i37 + i1 >> 2];
     } while (0);
     do if (i30) {
      if (!(_strcmp(HEAP32[i8 + 4 >> 2] | 0, gb + 753265 | 0) | 0)) {
       i19 = HEAP8[i37 + i1 >> 0] | 0;
       if ((i19 | 0) > (HEAP32[(__ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i49, 2) | 0) + 52 >> 2] | 0)) break;
       HEAP8[i43 >> 0] = 1;
       break;
      }
      if (HEAP8[i43 >> 0] | 0) {
       i2 = HEAP32[i8 >> 2] | 0;
       if (_strcmp(i2, gb + 753033 | 0) | 0) if (_strcmp(i2, gb + 753143 | 0) | 0) break;
       __ZN5physx2Sn5ConvX10setNullPtrEb(i49, 1);
      }
     } while (0);
     i19 = i8 + 36 | 0;
     i2 = HEAP32[i19 >> 2] | 0;
     i19 = HEAP32[i19 + 4 >> 2] | 0;
     i4 = i49 + (i19 >> 1) | 0;
     if (i19 & 1) i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + i2 >> 2] | 0;
     mftCall_viiii(i2 | 0, i4 | 0, i37 + i1 | 0, i8 | 0, i13 | 0);
     i1 = (HEAP32[i8 + 12 >> 2] | 0) + i7 | 0;
     if (!((HEAP8[i43 >> 0] | 0) == 0 | i20)) __ZN5physx2Sn5ConvX10setNullPtrEb(i49, 0);
    } else {
     i1 = i37 + i1 | 0;
     i19 = __ZN5physx2Sn5ConvX11getTypeNameEPKci(i49, HEAP32[i8 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i49, i1, __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i49, i19, 1) | 0, 0) | 0;
     i19 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i49, i19, 2) | 0;
     i19 = (HEAP32[i12 + (i17 * 44 | 0) + 12 >> 2] | 0) - (HEAP32[i19 + 16 >> 2] | 0) | 0;
     i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i35, i19, gb + 668920 | 0, 610) | 0;
     _memset(i1 | 0, 0, i19 | 0) | 0;
     __ZN5physx2Sn5ConvX6outputEPKci(i49, i1, i19);
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i36, i1);
     i1 = (HEAP32[i8 + 12 >> 2] | 0) + i7 | 0;
    }
    i2 = i10;
    i4 = i17 + 1 | 0;
   }
   i16 = i2 + 1 | 0;
   if ((i16 | 0) >= (i6 + i22 | 0)) {
    i14 = 82;
    break L8;
   } else {
    i18 = i6;
    i15 = i5;
    i19 = i3;
   }
  }
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 669100 | 0, i39);
 } else i14 = 82; while (0);
 if ((i14 | 0) == 82) __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i49, 1, gb + 669100 | 0, i40);
 do if (i30) {
  i1 = i49 + 12 | 0;
  i2 = i49 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i49 + 20 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP8[(HEAP32[i1 >> 2] | 0) + i3 >> 0] = HEAP8[i43 >> 0] | 0;
   HEAP32[i2 >> 2] = i3 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIbNS0_19ReflectionAllocatorIbEEE15growAndPushBackERKb(i1, i43) | 0;
   break;
  }
 } while (0);
 do if (i42) {
  i1 = i49 + 24 | 0;
  i2 = i49 + 28 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i49 + 32 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   i49 = (HEAP32[i1 >> 2] | 0) + (i3 * 28 | 0) | 0;
   HEAP32[i49 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
   HEAP32[i49 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
   HEAP32[i49 + 16 >> 2] = HEAP32[i47 + 16 >> 2];
   HEAP32[i49 + 20 >> 2] = HEAP32[i47 + 20 >> 2];
   HEAP32[i49 + 24 >> 2] = HEAP32[i47 + 24 >> 2];
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_2Sn15HeightFieldDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i47) | 0;
   break;
  }
 } while (0);
 if (HEAP8[i45 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i46, HEAP32[i46 >> 2] | 0);
 if (!(HEAP8[i44 >> 0] | 0)) {
  STACKTOP = i50;
  return 1;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i48, HEAP32[i48 >> 2] | 0);
 STACKTOP = i50;
 return 1;
}

function __ZN5physx2Gu21pcmContactPlaneConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i1, i22, i3, i4, i5, i2, i51) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i51 = i51 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i50 + 112 | 0;
 i48 = i50 + 96 | 0;
 i42 = i50 + 80 | 0;
 i12 = i50 + 64 | 0;
 i1 = i50;
 i47 = HEAP32[i2 >> 2] | 0;
 f41 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i53 = i4 + 16 | 0;
 f46 = Math_fround(HEAPF32[i53 >> 2]);
 f26 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 i53 = HEAP32[i3 >> 2] | 0;
 i52 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 i23 = i3 + 16 | 0;
 i14 = HEAP32[i23 >> 2] | 0;
 i43 = HEAP32[i23 + 4 >> 2] | 0;
 i23 = HEAP32[i23 + 8 >> 2] | 0;
 HEAP32[i49 >> 2] = i53;
 HEAP32[i49 + 4 >> 2] = i52;
 HEAP32[i49 + 8 >> 2] = i2;
 HEAP32[i49 + 12 >> 2] = i4;
 HEAP32[i49 + 16 >> 2] = i14;
 HEAP32[i49 + 20 >> 2] = i43;
 HEAP32[i49 + 24 >> 2] = i23;
 HEAPF32[i49 + 28 >> 2] = Math_fround(0.0);
 f40 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(-f40);
 f9 = Math_fround(-f35);
 f7 = Math_fround(-f33);
 f15 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f46 - f15);
 f10 = Math_fround(f26 - f10);
 f11 = Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f46 = Math_fround(Math_fround(Math_fround(f15 * f37) + Math_fround(f10 * f9)) + Math_fround(f11 * f7));
 f44 = Math_fround(Math_fround(Math_fround(f46 * f37) + Math_fround(Math_fround(f26 * f15) + Math_fround(f25 * Math_fround(Math_fround(f11 * f9) - Math_fround(f10 * f7))))) * Math_fround(2.0));
 f45 = Math_fround(Math_fround(Math_fround(f46 * f9) + Math_fround(Math_fround(f26 * f10) + Math_fround(f25 * Math_fround(Math_fround(f15 * f7) - Math_fround(f11 * f37))))) * Math_fround(2.0));
 f46 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f11) + Math_fround(f25 * Math_fround(Math_fround(f10 * f37) - Math_fround(f15 * f9)))) + Math_fround(f46 * f7)) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(f8 * f25) - Math_fround(Math_fround(Math_fround(f41 * f37) + Math_fround(f6 * f9)) + Math_fround(f13 * f7)));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f7)) + Math_fround(Math_fround(f8 * f37) + Math_fround(f41 * f25)));
 f11 = Math_fround(Math_fround(Math_fround(f41 * f7) - Math_fround(f13 * f37)) + Math_fround(Math_fround(f8 * f9) + Math_fround(f6 * f25)));
 f13 = Math_fround(Math_fround(Math_fround(f6 * f37) - Math_fround(f41 * f9)) + Math_fround(Math_fround(f8 * f7) + Math_fround(f13 * f25)));
 f7 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 i23 = HEAP32[i22 + 36 >> 2] | 0;
 f41 = Math_fround(HEAPF32[i23 + 52 >> 2]);
 f37 = Math_fround(HEAPF32[i23 + 56 >> 2]);
 f41 = Math_fround(f7 * f41);
 f37 = Math_fround(f8 * f37);
 f6 = Math_fround(f9 * Math_fround(HEAPF32[i23 + 60 >> 2]));
 f37 = f41 <= f37 ? f41 : f37;
 f6 = Math_fround((f37 <= f6 ? f37 : f6) * Math_fround(.25));
 f37 = Math_fround(f40 * Math_fround(2.0));
 f41 = Math_fround(f25 * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f37 * f35) + Math_fround(f33 * f41));
 f35 = Math_fround(Math_fround(f37 * f33) - Math_fround(f35 * f41));
 f41 = Math_fround(Math_fround(Math_fround(f40 * f37) + Math_fround(f25 * f41)) + Math_fround(-1.0));
 f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f35 * f35) + Math_fround(Math_fround(f26 * f26) + Math_fround(f41 * f41))))));
 f26 = Math_fround(-Math_fround(f26 * f25));
 f35 = Math_fround(-Math_fround(f35 * f25));
 HEAPF32[i48 >> 2] = Math_fround(-Math_fround(f41 * f25));
 HEAPF32[i48 + 4 >> 2] = f26;
 HEAPF32[i48 + 8 >> 2] = f35;
 HEAPF32[i48 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i42 >> 2] = HEAP32[i5 >> 2];
 f6 = Math_fround(f6 * Math_fround(.200000003));
 HEAPF32[i12 >> 2] = f6;
 i43 = i47 + 32 | 0;
 i14 = HEAP8[i43 >> 0] | 0;
 HEAPF32[i1 + 48 >> 2] = f44;
 HEAPF32[i1 + 52 >> 2] = f45;
 HEAPF32[i1 + 56 >> 2] = f46;
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 f35 = Math_fround(f10 + f10);
 f26 = Math_fround(f11 + f11);
 f25 = Math_fround(f13 + f13);
 f41 = Math_fround(f11 * f26);
 f37 = Math_fround(f13 * f25);
 f40 = Math_fround(f11 * f35);
 f33 = Math_fround(f13 * f35);
 f38 = Math_fround(f15 * f35);
 f34 = Math_fround(f13 * f26);
 f26 = Math_fround(f15 * f26);
 f25 = Math_fround(f15 * f25);
 f35 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f35));
 f24 = Math_fround(Math_fround(Math_fround(1.0) - f41) - f37);
 f36 = Math_fround(f40 + f25);
 f39 = Math_fround(f33 - f26);
 f25 = Math_fround(f40 - f25);
 f37 = Math_fround(f35 - f37);
 f40 = Math_fround(f34 + f38);
 f26 = Math_fround(f33 + f26);
 f38 = Math_fround(f34 - f38);
 f41 = Math_fround(f35 - f41);
 HEAPF32[i1 >> 2] = f24;
 HEAPF32[i1 + 4 >> 2] = f36;
 HEAPF32[i1 + 8 >> 2] = f39;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = f25;
 HEAPF32[i1 + 20 >> 2] = f37;
 HEAPF32[i1 + 24 >> 2] = f40;
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = f26;
 HEAPF32[i1 + 36 >> 2] = f38;
 HEAPF32[i1 + 40 >> 2] = f41;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i47, i1, i12, i42);
 if ((HEAP8[i43 >> 0] | 0) == i14 << 24 >> 24) {
  i4 = i47 + 16 | 0;
  f30 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i47 + 20 | 0;
  f35 = Math_fround(HEAPF32[i5 >> 2]);
  i12 = i47 + 24 | 0;
  f30 = Math_fround(f44 - f30);
  f35 = Math_fround(f45 - f35);
  f34 = Math_fround(f46 - Math_fround(HEAPF32[i12 >> 2]));
  f32 = Math_fround(-f30);
  f31 = Math_fround(-f35);
  f33 = Math_fround(-f34);
  f32 = f30 > f32 ? f30 : f32;
  f31 = f35 > f31 ? f35 : f31;
  f31 = f32 >= f31 ? f32 : f31;
  i1 = (f34 > f33 ? f34 : f33) >= Math_fround(0.0);
  f32 = i1 ? f32 : Math_fround(0.0);
  f33 = Math_fround(HEAPF32[i47 >> 2]);
  i1 = i47 + 4 | 0;
  f34 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i47 + 8 | 0;
  f35 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i47 + 12 | 0;
  if ((f31 >= f32 ? f31 : f32) > f6 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f10 * f33) + Math_fround(f11 * f34)) + Math_fround(f13 * f35)) + Math_fround(f15 * Math_fround(HEAPF32[i3 >> 2]))) < Math_fround(.999800026)) i14 = i47; else {
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i47, i51, i48, i49);
   i53 = HEAP8[i43 >> 0] | 0;
   i53 = i53 << 24 >> 24 != 0;
   STACKTOP = i50;
   return i53 | 0;
  }
 } else {
  i1 = i47 + 4 | 0;
  i2 = i47 + 8 | 0;
  i3 = i47 + 12 | 0;
  i4 = i47 + 16 | 0;
  i5 = i47 + 20 | 0;
  i12 = i47 + 24 | 0;
  i14 = i47;
 }
 f30 = Math_fround(HEAPF32[i22 + 16 >> 2]);
 f55 = Math_fround(HEAPF32[i22 + 20 >> 2]);
 f21 = Math_fround(HEAPF32[i22 + 24 >> 2]);
 f54 = Math_fround(HEAPF32[i22 + 28 >> 2]);
 f6 = Math_fround(f30 + f30);
 f18 = Math_fround(f55 + f55);
 f29 = Math_fround(f21 + f21);
 f20 = Math_fround(f55 * f18);
 f32 = Math_fround(f21 * f29);
 f55 = Math_fround(f6 * f55);
 f17 = Math_fround(f6 * f21);
 f16 = Math_fround(f6 * f54);
 f21 = Math_fround(f18 * f21);
 f18 = Math_fround(f18 * f54);
 f54 = Math_fround(f29 * f54);
 f6 = Math_fround(Math_fround(1.0) - Math_fround(f30 * f6));
 f30 = Math_fround(Math_fround(Math_fround(1.0) - f20) - f32);
 f29 = Math_fround(f55 + f54);
 f31 = Math_fround(f17 - f18);
 f54 = Math_fround(f55 - f54);
 f32 = Math_fround(f6 - f32);
 f55 = Math_fround(f21 + f16);
 f18 = Math_fround(f17 + f18);
 f16 = Math_fround(f21 - f16);
 f20 = Math_fround(f6 - f20);
 f6 = Math_fround(f7 * f30);
 f21 = Math_fround(f7 * f54);
 f17 = Math_fround(f7 * f18);
 f33 = Math_fround(f8 * f29);
 f34 = Math_fround(f8 * f32);
 f35 = Math_fround(f8 * f16);
 f7 = Math_fround(f9 * f31);
 f8 = Math_fround(f9 * f55);
 f19 = Math_fround(f9 * f20);
 f27 = Math_fround(Math_fround(f31 * f7) + Math_fround(Math_fround(f30 * f6) + Math_fround(f29 * f33)));
 f28 = Math_fround(Math_fround(f31 * f8) + Math_fround(Math_fround(f30 * f21) + Math_fround(f29 * f34)));
 f29 = Math_fround(Math_fround(f31 * f19) + Math_fround(Math_fround(f30 * f17) + Math_fround(f29 * f35)));
 f30 = Math_fround(Math_fround(f55 * f7) + Math_fround(Math_fround(f54 * f6) + Math_fround(f32 * f33)));
 f31 = Math_fround(Math_fround(f55 * f8) + Math_fround(Math_fround(f54 * f21) + Math_fround(f32 * f34)));
 f32 = Math_fround(Math_fround(f55 * f19) + Math_fround(Math_fround(f54 * f17) + Math_fround(f32 * f35)));
 f33 = Math_fround(Math_fround(f20 * f7) + Math_fround(Math_fround(f18 * f6) + Math_fround(f16 * f33)));
 f34 = Math_fround(Math_fround(f20 * f8) + Math_fround(Math_fround(f18 * f21) + Math_fround(f16 * f34)));
 f35 = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f35)));
 HEAP8[i43 >> 0] = 0;
 HEAPF32[i14 >> 2] = f10;
 HEAPF32[i1 >> 2] = f11;
 HEAPF32[i2 >> 2] = f13;
 HEAPF32[i3 >> 2] = f15;
 HEAPF32[i4 >> 2] = f44;
 HEAPF32[i5 >> 2] = f45;
 HEAPF32[i12 >> 2] = f46;
 HEAPF32[i47 + 28 >> 2] = Math_fround(0.0);
 i4 = (HEAP32[i23 + 40 >> 2] | 0) + ((HEAPU8[i23 + 39 >> 0] | 0) * 20 | 0) | 0;
 i3 = HEAP8[i23 + 38 >> 0] | 0;
 f16 = Math_fround(Math_fround(f26 * f29) + Math_fround(Math_fround(f24 * f27) + Math_fround(f25 * f28)));
 f17 = Math_fround(Math_fround(f38 * f29) + Math_fround(Math_fround(f36 * f27) + Math_fround(f37 * f28)));
 f18 = Math_fround(Math_fround(f41 * f29) + Math_fround(Math_fround(f39 * f27) + Math_fround(f40 * f28)));
 f19 = Math_fround(Math_fround(f26 * f32) + Math_fround(Math_fround(f24 * f30) + Math_fround(f25 * f31)));
 f20 = Math_fround(Math_fround(f38 * f32) + Math_fround(Math_fround(f36 * f30) + Math_fround(f37 * f31)));
 f21 = Math_fround(Math_fround(f41 * f32) + Math_fround(Math_fround(f39 * f30) + Math_fround(f40 * f31)));
 f15 = Math_fround(Math_fround(f26 * f35) + Math_fround(Math_fround(f24 * f33) + Math_fround(f25 * f34)));
 f13 = Math_fround(Math_fround(f38 * f35) + Math_fround(Math_fround(f36 * f33) + Math_fround(f37 * f34)));
 f11 = Math_fround(Math_fround(f41 * f35) + Math_fround(Math_fround(f39 * f33) + Math_fround(f40 * f34)));
 if (!(i3 << 24 >> 24)) i1 = 0; else {
  f10 = Math_fround(HEAPF32[i42 >> 2]);
  i2 = 0;
  i1 = 0;
  do {
   f6 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) >> 2]);
   f7 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 8 >> 2]);
   f9 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f16 * f6) + Math_fround(f19 * f7)) + Math_fround(f15 * f8)));
   if (f10 > f9) {
    f41 = Math_fround(f46 + Math_fround(Math_fround(Math_fround(f18 * f6) + Math_fround(f21 * f7)) + Math_fround(f11 * f8)));
    f54 = Math_fround(f45 + Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(f20 * f7)) + Math_fround(f13 * f8)));
    f40 = Math_fround(Math_fround(Math_fround(f28 * f6) + Math_fround(f31 * f7)) + Math_fround(f34 * f8));
    f55 = Math_fround(Math_fround(Math_fround(f29 * f6) + Math_fround(f32 * f7)) + Math_fround(f35 * f8));
    HEAPF32[i51 + (i1 * 48 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f27 * f6) + Math_fround(f30 * f7)) + Math_fround(f33 * f8));
    HEAPF32[i51 + (i1 * 48 | 0) + 4 >> 2] = f40;
    HEAPF32[i51 + (i1 * 48 | 0) + 8 >> 2] = f55;
    HEAPF32[i51 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
    f55 = Math_fround(f9 * Math_fround(0.0));
    f54 = Math_fround(f54 - f55);
    f55 = Math_fround(f41 - f55);
    HEAPF32[i51 + (i1 * 48 | 0) + 16 >> 2] = Math_fround(f9 - f9);
    HEAPF32[i51 + (i1 * 48 | 0) + 20 >> 2] = f54;
    HEAPF32[i51 + (i1 * 48 | 0) + 24 >> 2] = f55;
    HEAPF32[i51 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAP32[i51 + (i1 * 48 | 0) + 32 >> 2] = 1065353216;
    HEAP32[i51 + (i1 * 48 | 0) + 36 >> 2] = 0;
    HEAP32[i51 + (i1 * 48 | 0) + 40 >> 2] = 0;
    HEAPF32[i51 + (i1 * 48 | 0) + 44 >> 2] = f9;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 & 255) << 24 >> 24 != i3 << 24 >> 24);
 }
 __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj(i47, i51, i1);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i47, i51, i48, i49);
 i53 = HEAP8[i43 >> 0] | 0;
 i53 = i53 << 24 >> 24 != 0;
 STACKTOP = i50;
 return i53 | 0;
}

function __ZN9Animation12BlendGenericEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i54 + 48 | 0;
 i49 = i54 + 32 | 0;
 i50 = i54 + 16 | 0;
 i51 = i54;
 i52 = HEAP32[i3 + 96 >> 2] | 0;
 i53 = i3 + 104 | 0;
 i4 = (HEAP32[i3 + 108 >> 2] | 0) - (HEAP32[i53 >> 2] | 0) | 0;
 i47 = i4 >> 2;
 HEAP32[i46 >> 2] = 0;
 i48 = i46 + 4 | 0;
 i43 = gb + 63160 | 0;
 i44 = HEAP32[i43 + 4 >> 2] | 0;
 i45 = i48;
 HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i45 + 4 >> 2] = i44;
 do if (!i4) i1 = 0; else {
  i2 = i4 + 3 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 1218) | 0;
   i44 = gb + 64016 | 0;
   i43 = HEAP32[i44 >> 2] | 0;
   i44 = HEAP32[i44 + 4 >> 2] | 0;
   HEAP32[i46 >> 2] = i1;
   i45 = i48;
   HEAP32[i45 >> 2] = i43;
   HEAP32[i45 + 4 >> 2] = i44;
   break;
  }
 } while (0);
 i45 = i1 + 3 & -4;
 if ((i52 | 0) <= 0) {
  i53 = HEAP32[i46 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i53, i48);
  STACKTOP = i54;
  return;
 }
 i44 = i3 + 84 | 0;
 i27 = (i4 | 0) > 0;
 i23 = i49 + 4 | 0;
 i25 = i49 + 8 | 0;
 i21 = i49 + 12 | 0;
 i28 = i49 + 4 | 0;
 i29 = i49 + 8 | 0;
 i30 = i51 + 4 | 0;
 i31 = i51 + 8 | 0;
 i24 = i50 + 4 | 0;
 i26 = i50 + 8 | 0;
 i22 = i50 + 12 | 0;
 f32 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i33 = i49 + 4 | 0;
 i34 = i49 + 8 | 0;
 i35 = i49 + 12 | 0;
 i36 = i49 + 4 | 0;
 i37 = i49 + 8 | 0;
 i38 = i49 + 4 | 0;
 i39 = i49 + 8 | 0;
 i40 = i49 + 4 | 0;
 i41 = i49 + 8 | 0;
 i42 = i49 + 4 | 0;
 i43 = i49 + 8 | 0;
 i20 = i27 ^ 1;
 i19 = 0;
 i1 = 0;
 do {
  i18 = HEAP32[i44 >> 2] | 0;
  i10 = i18 + (i19 * 24 | 0) | 0;
  __Z16CalculateWeightsILb0EEvPP14AnimationStateiiPfi(HEAP32[i53 >> 2] | 0, i47, i19, i45, 0);
  i11 = i18 + (i19 * 24 | 0) + 4 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = (i2 | 0) == 2;
  switch (i2 | 0) {
  case 2:
  case 4:
   {
    if (i27) if (i3) {
     i10 = 0;
     i17 = 0;
     i11 = 0;
     i9 = 0;
     i15 = 0;
     i2 = 0;
     while (1) {
      i3 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i19 << 2) >> 2] | 0;
      if (!i4) {
       i3 = i10;
       i8 = i11;
       i4 = i15;
      } else {
       i8 = i45 + (i17 << 2) | 0;
       if (Math_fround(HEAPF32[i8 >> 2]) > Math_fround(.0000999999974)) {
        __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i49, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
        f55 = Math_fround(HEAPF32[i49 >> 2]);
        f7 = Math_fround(HEAPF32[i23 >> 2]);
        f13 = Math_fround(HEAPF32[i25 >> 2]);
        f16 = Math_fround(HEAPF32[i21 >> 2]);
        f5 = Math_fround(HEAPF32[i8 >> 2]);
        f56 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f57 = Math_fround(f56 * f55);
        f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f57 = Math_fround(f57 + Math_fround(f6 * f7));
        f12 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f57 = Math_fround(f57 + Math_fround(f12 * f13));
        f14 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i8 = Math_fround(f57 + Math_fround(f14 * f16)) < Math_fround(0.0);
        f57 = Math_fround(-f5);
        f5 = i8 ? f57 : f5;
        f7 = Math_fround(f7 * f5);
        f13 = Math_fround(f13 * f5);
        f16 = Math_fround(f16 * f5);
        f5 = Math_fround(f56 + Math_fround(f55 * f5));
        i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
        f7 = Math_fround(f6 + f7);
        i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
        f13 = Math_fround(f12 + f13);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
        f16 = Math_fround(f14 + f16);
        i3 = 1;
        i4 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        i3 = i10;
        i8 = i11;
        i4 = i15;
       }
      }
      i17 = i17 + 1 | 0;
      if ((i17 | 0) >= (i47 | 0)) break; else {
       i10 = i3;
       i11 = i8;
       i15 = i4;
      }
     }
    } else {
     i10 = 0;
     i17 = 0;
     i11 = 0;
     i9 = 0;
     i15 = 0;
     i2 = 0;
     while (1) {
      i3 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i19 << 2) >> 2] | 0;
      if (!i4) {
       i3 = i10;
       i8 = i11;
       i4 = i15;
      } else {
       i8 = i45 + (i17 << 2) | 0;
       if (Math_fround(HEAPF32[i8 >> 2]) > Math_fround(.0000999999974)) {
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i49, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
        f55 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * Math_fround(.0174532924));
        f14 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(.0174532924));
        f7 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(.0174532924));
        HEAPF32[i51 >> 2] = f55;
        HEAPF32[i30 >> 2] = f14;
        HEAPF32[i31 >> 2] = f7;
        __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i50, i51, 4);
        f7 = Math_fround(HEAPF32[i50 >> 2]);
        f14 = Math_fround(HEAPF32[i24 >> 2]);
        f55 = Math_fround(HEAPF32[i26 >> 2]);
        f57 = Math_fround(HEAPF32[i22 >> 2]);
        f12 = Math_fround(HEAPF32[i8 >> 2]);
        f6 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f5 = Math_fround(f6 * f7);
        f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f5 = Math_fround(f5 + Math_fround(f13 * f14));
        f16 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f5 = Math_fround(f5 + Math_fround(f16 * f55));
        f56 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i8 = Math_fround(f5 + Math_fround(f56 * f57)) < Math_fround(0.0);
        f5 = Math_fround(-f12);
        f12 = i8 ? f5 : f12;
        f14 = Math_fround(f14 * f12);
        f55 = Math_fround(f55 * f12);
        f57 = Math_fround(f57 * f12);
        f12 = Math_fround(f6 + Math_fround(f7 * f12));
        i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
        f14 = Math_fround(f13 + f14);
        i2 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
        f55 = Math_fround(f16 + f55);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
        f57 = Math_fround(f56 + f57);
        i3 = 1;
        i4 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
       } else {
        i3 = i10;
        i8 = i11;
        i4 = i15;
       }
      }
      i17 = i17 + 1 | 0;
      if ((i17 | 0) >= (i47 | 0)) break; else {
       i10 = i3;
       i11 = i8;
       i15 = i4;
      }
     }
    } else {
     i3 = 0;
     i8 = 0;
     i9 = 0;
     i4 = 0;
     i2 = 0;
    }
    f16 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f16 * f16);
    f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f13 + Math_fround(f14 * f14));
    f6 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f13 + Math_fround(f6 * f6));
    f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f5 * f5))));
    if (f13 < f32) {
     f12 = Math_fround(1.0);
     f7 = Math_fround(0.0);
     f6 = Math_fround(0.0);
     f5 = Math_fround(0.0);
    } else {
     f12 = Math_fround(f5 / f13);
     f7 = Math_fround(f6 / f13);
     f6 = Math_fround(f14 / f13);
     f5 = Math_fround(f16 / f13);
    }
    if (i3) {
     i18 = HEAP32[i18 + (i19 * 24 | 0) + 12 >> 2] | 0;
     HEAPF32[i49 >> 2] = f5;
     HEAPF32[i33 >> 2] = f6;
     HEAPF32[i34 >> 2] = f7;
     HEAPF32[i35 >> 2] = f12;
     __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i18, i49);
    }
    break;
   }
  case 1:
   {
    if (i27) {
     i15 = 0;
     i2 = 0;
     i3 = 0;
     i4 = 0;
     i8 = 0;
     do {
      i9 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i15 << 2) >> 2] | 0;
      i10 = HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + (i19 << 2) >> 2] | 0;
      if (i10) {
       i11 = i45 + (i15 << 2) | 0;
       if (Math_fround(HEAPF32[i11 >> 2]) > Math_fround(.0000999999974)) {
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i49, i10, Math_fround(HEAPF32[i9 + 12 >> 2]), 0);
        f57 = Math_fround(HEAPF32[i11 >> 2]);
        f55 = Math_fround(f57 * Math_fround(HEAPF32[i49 >> 2]));
        f56 = Math_fround(f57 * Math_fround(HEAPF32[i36 >> 2]));
        f57 = Math_fround(f57 * Math_fround(HEAPF32[i37 >> 2]));
        f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f55);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
        f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f56);
        i8 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
        f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
        i2 = 1;
        i4 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
       }
      }
      i15 = i15 + 1 | 0;
     } while ((i15 | 0) < (i47 | 0));
     if (i2) {
      i18 = HEAP32[i18 + (i19 * 24 | 0) + 12 >> 2] | 0;
      HEAP32[i49 >> 2] = i3;
      HEAP32[i38 >> 2] = i8;
      HEAP32[i39 >> 2] = i4;
      __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i18, i49);
     }
    }
    break;
   }
  case 3:
   {
    if (i27) {
     i15 = 0;
     i2 = 0;
     i3 = 0;
     i4 = 0;
     i8 = 0;
     do {
      i9 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i15 << 2) >> 2] | 0;
      i10 = HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + (i19 << 2) >> 2] | 0;
      if (i10) {
       i11 = i45 + (i15 << 2) | 0;
       if (Math_fround(HEAPF32[i11 >> 2]) > Math_fround(.0000999999974)) {
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i49, i10, Math_fround(HEAPF32[i9 + 12 >> 2]), 0);
        f57 = Math_fround(HEAPF32[i11 >> 2]);
        f55 = Math_fround(f57 * Math_fround(HEAPF32[i49 >> 2]));
        f56 = Math_fround(f57 * Math_fround(HEAPF32[i40 >> 2]));
        f57 = Math_fround(f57 * Math_fround(HEAPF32[i41 >> 2]));
        f55 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f55);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
        f56 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f56);
        i8 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
        f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
        i2 = 1;
        i4 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
       }
      }
      i15 = i15 + 1 | 0;
     } while ((i15 | 0) < (i47 | 0));
     if (i2) {
      i18 = HEAP32[i18 + (i19 * 24 | 0) + 12 >> 2] | 0;
      HEAP32[i49 >> 2] = i3;
      HEAP32[i42 >> 2] = i8;
      HEAP32[i43 >> 2] = i4;
      __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i18, i49);
     }
    }
    break;
   }
  default:
   if (!((i2 | 0) < 1 | i20)) {
    i9 = 0;
    f5 = Math_fround(0.0);
    i2 = 0;
    do {
     i3 = HEAP32[(HEAP32[i53 >> 2] | 0) + (i9 << 2) >> 2] | 0;
     i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i19 << 2) >> 2] | 0;
     if (i4) {
      i8 = i45 + (i9 << 2) | 0;
      if (Math_fround(HEAPF32[i8 >> 2]) > Math_fround(.0000999999974)) {
       f57 = Math_fround(__ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE(i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0));
       f5 = Math_fround(f5 + Math_fround(f57 * Math_fround(HEAPF32[i8 >> 2])));
       i2 = 1;
      }
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) < (i47 | 0));
    if (i2) {
     __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf(i10, f5) | 0;
     if (((HEAP32[i11 >> 2] | 0) + -5 | 0) >>> 0 < 2) {
      i2 = HEAP32[i18 + (i19 * 24 | 0) + 12 >> 2] | 0;
      if ((i1 | 0) != (i2 | 0)) if (!i1) i1 = i2; else {
       mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
       i1 = i2;
      }
     }
    }
   }
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != (i52 | 0));
 if (!i1) {
  i53 = HEAP32[i46 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i53, i48);
  STACKTOP = i54;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 i53 = HEAP32[i46 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i53, i48);
 STACKTOP = i54;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i1, i2, i21) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 L1 : while (1) {
  i19 = i2;
  i23 = i2 + -32 | 0;
  i20 = i2 + -64 | 0;
  i24 = i2 + -28 | 0;
  i25 = i2 + -24 | 0;
  i26 = i2 + -20 | 0;
  while (1) {
   L5 : while (1) {
    i18 = i1;
    i3 = i19 - i18 | 0;
    i4 = i3 >> 5;
    switch (i4 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 14;
      break L1;
     }
    case 4:
     {
      i22 = 15;
      break L1;
     }
    case 5:
     {
      i22 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 116;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 224) {
     i22 = 18;
     break L1;
    }
    i6 = (i4 | 0) / 2 | 0;
    i15 = i1 + (i6 << 5) | 0;
    if ((i3 | 0) > 31968) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + (i3 << 5) | 0, i15, i15 + (i3 << 5) | 0, i23, i21) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i1, i15, i23, i21) | 0;
    i17 = i1 + 4 | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i14 = HEAP32[i1 + (i6 << 5) + 4 >> 2] | 0;
    do if ((i16 | 0) == (i14 | 0)) {
     i4 = HEAP32[i1 + 8 >> 2] | 0;
     i5 = HEAP32[i1 + (i6 << 5) + 8 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) {
      i4 = i23;
      break L5;
     } else break;
     i4 = HEAP32[i1 + 12 >> 2] | 0;
     i5 = HEAP32[i1 + (i6 << 5) + 12 >> 2] | 0;
     if ((i4 | 0) == (i5 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i15 >> 2] | 0)) {
      i4 = i23;
      break L5;
     } else break; else if (i4 >>> 0 < i5 >>> 0) {
      i4 = i23;
      break L5;
     } else break;
    } else if ((i16 | 0) < (i14 | 0)) {
     i4 = i23;
     break L5;
    } while (0);
    if ((i1 | 0) != (i20 | 0)) {
     i13 = i1 + (i6 << 5) + 8 | 0;
     i9 = i1 + (i6 << 5) + 12 | 0;
     i10 = i23;
     i4 = i20;
     while (1) {
      i11 = i10 + -28 | 0;
      i12 = HEAP32[i11 >> 2] | 0;
      do if ((i12 | 0) == (i14 | 0)) {
       i6 = i10 + -24 | 0;
       i5 = HEAP32[i6 >> 2] | 0;
       i7 = HEAP32[i13 >> 2] | 0;
       if ((i5 | 0) != (i7 | 0)) if ((i5 | 0) < (i7 | 0)) {
        i22 = 79;
        break L5;
       } else break;
       i7 = HEAP32[i10 + -20 >> 2] | 0;
       i8 = HEAP32[i9 >> 2] | 0;
       if ((i7 | 0) == (i8 | 0)) if ((HEAP32[i4 >> 2] | 0) < (HEAP32[i15 >> 2] | 0)) {
        i22 = 79;
        break L5;
       } else break; else if (i7 >>> 0 < i8 >>> 0) {
        i22 = 79;
        break L5;
       } else break;
      } else if ((i12 | 0) < (i14 | 0)) {
       i22 = 72;
       break L5;
      } while (0);
      i5 = i4 + -32 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i10 = i4;
       i4 = i5;
      }
     }
    }
    i3 = i1 + 32 | 0;
    i12 = HEAP32[i24 >> 2] | 0;
    do if ((i16 | 0) == (i12 | 0)) {
     i4 = HEAP32[i1 + 8 >> 2] | 0;
     i5 = HEAP32[i25 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) break; else {
      i22 = 38;
      break;
     }
     i4 = HEAP32[i1 + 12 >> 2] | 0;
     i5 = HEAP32[i26 >> 2] | 0;
     if ((i4 | 0) == (i5 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i23 >> 2] | 0)) break; else {
      i22 = 38;
      break;
     } else if (i4 >>> 0 < i5 >>> 0) break; else {
      i22 = 38;
      break;
     }
    } else if ((i16 | 0) >= (i12 | 0)) i22 = 38; while (0);
    if ((i22 | 0) == 38) {
     i22 = 0;
     if ((i3 | 0) == (i23 | 0)) {
      i22 = 116;
      break L1;
     }
     i8 = i1 + 8 | 0;
     i9 = i1 + 12 | 0;
     L50 : while (1) {
      i10 = i3 + 4 | 0;
      i11 = HEAP32[i10 >> 2] | 0;
      do if ((i16 | 0) == (i11 | 0)) {
       i4 = HEAP32[i8 >> 2] | 0;
       i5 = i3 + 8 | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       if ((i4 | 0) != (i6 | 0)) if ((i4 | 0) < (i6 | 0)) {
        i4 = i6;
        break L50;
       } else break;
       i6 = HEAP32[i9 >> 2] | 0;
       i7 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i6 | 0) == (i7 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) break L50; else break; else if (i6 >>> 0 < i7 >>> 0) break L50; else break;
      } else if ((i16 | 0) < (i11 | 0)) {
       i22 = 42;
       break L50;
      } while (0);
      i3 = i3 + 32 | 0;
      if ((i3 | 0) == (i23 | 0)) {
       i22 = 116;
       break L1;
      }
     }
     if ((i22 | 0) == 42) {
      i22 = 0;
      i4 = i3 + 8 | 0;
      i5 = i4;
      i4 = HEAP32[i4 >> 2] | 0;
     }
     i16 = HEAP32[i3 >> 2] | 0;
     i15 = i3 + 12 | 0;
     i18 = HEAP32[i15 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i10 >> 2] = i12;
     HEAP32[i5 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i15 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i23 >> 2] = i16;
     HEAP32[i24 >> 2] = i11;
     HEAP32[i25 >> 2] = i4;
     HEAP32[i26 >> 2] = i18;
     i3 = i3 + 32 | 0;
    }
    if ((i3 | 0) == (i23 | 0)) {
     i22 = 116;
     break L1;
    }
    i13 = i1 + 8 | 0;
    i14 = i1 + 12 | 0;
    i6 = i23;
    while (1) {
     i12 = HEAP32[i17 >> 2] | 0;
     L69 : while (1) {
      i10 = i3 + 4 | 0;
      i11 = HEAP32[i10 >> 2] | 0;
      do if ((i12 | 0) == (i11 | 0)) {
       i4 = HEAP32[i13 >> 2] | 0;
       i5 = HEAP32[i3 + 8 >> 2] | 0;
       if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) break L69; else break;
       i4 = HEAP32[i14 >> 2] | 0;
       i5 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i4 | 0) == (i5 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) break L69; else break; else if (i4 >>> 0 < i5 >>> 0) break L69; else break;
      } else if ((i12 | 0) < (i11 | 0)) break L69; while (0);
      i3 = i3 + 32 | 0;
     }
     while (1) {
      i7 = i6 + -32 | 0;
      i8 = i6 + -28 | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      if ((i12 | 0) != (i9 | 0)) if ((i12 | 0) < (i9 | 0)) {
       i6 = i7;
       continue;
      } else break;
      i4 = HEAP32[i13 >> 2] | 0;
      i5 = HEAP32[i6 + -24 >> 2] | 0;
      if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) {
       i6 = i7;
       continue;
      } else break;
      i4 = HEAP32[i14 >> 2] | 0;
      i5 = HEAP32[i6 + -20 >> 2] | 0;
      if ((i4 | 0) == (i5 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i7 >> 2] | 0)) {
       i6 = i7;
       continue;
      } else break; else if (i4 >>> 0 < i5 >>> 0) {
       i6 = i7;
       continue;
      } else break;
     }
     if (i3 >>> 0 >= i7 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i12 = HEAP32[i3 >> 2] | 0;
     i4 = i3 + 8 | 0;
     i15 = HEAP32[i4 >> 2] | 0;
     i5 = i3 + 12 | 0;
     i18 = HEAP32[i5 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i10 >> 2] = i9;
     i16 = i6 + -24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
     i6 = i6 + -20 | 0;
     HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i7 >> 2] = i12;
     HEAP32[i8 >> 2] = i11;
     HEAP32[i16 >> 2] = i15;
     HEAP32[i6 >> 2] = i18;
     i6 = i7;
     i3 = i3 + 32 | 0;
    }
   }
   if ((i22 | 0) == 72) {
    i5 = i10 + -24 | 0;
    i6 = i5;
    i5 = HEAP32[i5 >> 2] | 0;
    i22 = 79;
   }
   if ((i22 | 0) == 79) {
    i22 = 0;
    i9 = HEAP32[i1 >> 2] | 0;
    i7 = i1 + 8 | 0;
    i13 = HEAP32[i7 >> 2] | 0;
    i8 = i1 + 12 | 0;
    i14 = HEAP32[i8 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i17 >> 2] = i12;
    HEAP32[i7 >> 2] = i5;
    i17 = i10 + -20 | 0;
    HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i4 >> 2] = i9;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i6 >> 2] = i13;
    HEAP32[i17 >> 2] = i14;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 32 | 0;
   L99 : do if (i5 >>> 0 < i4 >>> 0) {
    i13 = i15;
    while (1) {
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i15 = i13 + 8 | 0;
     i16 = i13 + 12 | 0;
     L102 : while (1) {
      i11 = i5 + 4 | 0;
      i12 = HEAP32[i11 >> 2] | 0;
      do if ((i12 | 0) == (i14 | 0)) {
       i6 = HEAP32[i5 + 8 >> 2] | 0;
       i7 = HEAP32[i15 >> 2] | 0;
       if ((i6 | 0) != (i7 | 0)) if ((i6 | 0) < (i7 | 0)) break; else break L102;
       i6 = HEAP32[i5 + 12 >> 2] | 0;
       i7 = HEAP32[i16 >> 2] | 0;
       if ((i6 | 0) == (i7 | 0)) if ((HEAP32[i5 >> 2] | 0) < (HEAP32[i13 >> 2] | 0)) break; else break L102; else if (i6 >>> 0 < i7 >>> 0) break; else break L102;
      } else if ((i12 | 0) >= (i14 | 0)) break L102; while (0);
      i5 = i5 + 32 | 0;
     }
     while (1) {
      i8 = i4 + -32 | 0;
      i9 = i4 + -28 | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      if ((i10 | 0) != (i14 | 0)) if ((i10 | 0) < (i14 | 0)) break; else {
       i4 = i8;
       continue;
      }
      i6 = HEAP32[i4 + -24 >> 2] | 0;
      i7 = HEAP32[i15 >> 2] | 0;
      if ((i6 | 0) != (i7 | 0)) if ((i6 | 0) < (i7 | 0)) break; else {
       i4 = i8;
       continue;
      }
      i6 = HEAP32[i4 + -20 >> 2] | 0;
      i7 = HEAP32[i16 >> 2] | 0;
      if ((i6 | 0) == (i7 | 0)) if ((HEAP32[i8 >> 2] | 0) < (HEAP32[i13 >> 2] | 0)) break; else {
       i4 = i8;
       continue;
      } else if (i6 >>> 0 < i7 >>> 0) break; else {
       i4 = i8;
       continue;
      }
     }
     if (i5 >>> 0 > i8 >>> 0) break L99;
     i14 = HEAP32[i5 >> 2] | 0;
     i6 = i5 + 8 | 0;
     i15 = HEAP32[i6 >> 2] | 0;
     i7 = i5 + 12 | 0;
     i17 = HEAP32[i7 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i11 >> 2] = i10;
     i16 = i4 + -24 | 0;
     HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
     i4 = i4 + -20 | 0;
     HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i8 >> 2] = i14;
     HEAP32[i9 >> 2] = i12;
     HEAP32[i16 >> 2] = i15;
     HEAP32[i4 >> 2] = i17;
     i13 = (i13 | 0) == (i5 | 0) ? i8 : i13;
     i4 = i8;
     i5 = i5 + 32 | 0;
     i3 = i3 + 1 | 0;
    }
   } else i13 = i15; while (0);
   L128 : do if ((i5 | 0) != (i13 | 0)) {
    i9 = i13 + 4 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    i11 = i5 + 4 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    do if ((i10 | 0) == (i12 | 0)) {
     i6 = i13 + 8 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i4 = i5 + 8 | 0;
     i8 = HEAP32[i4 >> 2] | 0;
     if ((i7 | 0) != (i8 | 0)) if ((i7 | 0) < (i8 | 0)) break; else break L128;
     i7 = HEAP32[i13 + 12 >> 2] | 0;
     i8 = HEAP32[i5 + 12 >> 2] | 0;
     if ((i7 | 0) == (i8 | 0)) if ((HEAP32[i13 >> 2] | 0) < (HEAP32[i5 >> 2] | 0)) break; else break L128; else if (i7 >>> 0 < i8 >>> 0) break; else break L128;
    } else {
     if ((i10 | 0) >= (i12 | 0)) break L128;
     i6 = i13 + 8 | 0;
     i4 = i5 + 8 | 0;
    } while (0);
    i14 = HEAP32[i5 >> 2] | 0;
    i15 = HEAP32[i4 >> 2] | 0;
    i8 = i5 + 12 | 0;
    i16 = HEAP32[i8 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i11 >> 2] = i10;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    i17 = i13 + 12 | 0;
    HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i13 >> 2] = i14;
    HEAP32[i9 >> 2] = i12;
    HEAP32[i6 >> 2] = i15;
    HEAP32[i17 >> 2] = i16;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEbT0_S7_T_(i1, i5, i21) | 0;
    i4 = i5 + 32 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEbT0_S7_T_(i4, i2, i21) | 0) {
     i22 = 115;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i17 = i5;
   if ((i17 - i18 | 0) >= (i19 - i17 | 0)) {
    i22 = 114;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i1, i5, i21);
   i1 = i5 + 32 | 0;
  }
  if ((i22 | 0) == 114) {
   i22 = 0;
   __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i5 + 32 | 0, i2, i21);
   i2 = i5;
   continue;
  } else if ((i22 | 0) == 115) {
   i22 = 0;
   if (i3) {
    i22 = 116;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  i6 = HEAP32[i24 >> 2] | 0;
  i7 = i1 + 4 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  do if ((i6 | 0) == (i8 | 0)) {
   i2 = HEAP32[i25 >> 2] | 0;
   i3 = i1 + 8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != (i4 | 0)) {
    if ((i2 | 0) < (i4 | 0)) {
     i2 = i4;
     break;
    }
    return;
   }
   i4 = HEAP32[i26 >> 2] | 0;
   i5 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i4 | 0) == (i5 | 0)) {
    if ((HEAP32[i23 >> 2] | 0) < (HEAP32[i1 >> 2] | 0)) break;
    return;
   } else {
    if (i4 >>> 0 < i5 >>> 0) break;
    return;
   }
  } else if ((i6 | 0) < (i8 | 0)) {
   i2 = i1 + 8 | 0;
   i3 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
   break;
  } else return; while (0);
  i21 = HEAP32[i1 >> 2] | 0;
  i20 = i1 + 12 | 0;
  i22 = HEAP32[i20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i7 >> 2] = i6;
  HEAP32[i3 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i23 >> 2] = i21;
  HEAP32[i24 >> 2] = i8;
  HEAP32[i25 >> 2] = i2;
  HEAP32[i26 >> 2] = i22;
  return;
 } else if ((i22 | 0) == 14) {
  __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 32 | 0, i23, i21) | 0;
  return;
 } else if ((i22 | 0) == 15) {
  __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i23, i21) | 0;
  return;
 } else if ((i22 | 0) == 16) {
  __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i1 + 96 | 0, i23, i21) | 0;
  return;
 } else if ((i22 | 0) == 18) {
  __ZNSt3__218__insertion_sort_3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i1, i2, i21);
  return;
 } else if ((i22 | 0) == 116) return;
}

function __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i2, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i25 = i2;
 L1 : while (1) {
  i15 = i25;
  i20 = i25 + -32 | 0;
  i21 = i25 + -24 | 0;
  i22 = i25 + -12 | 0;
  i16 = i25 + -28 | 0;
  i17 = i25 + -20 | 0;
  i18 = i25 + -16 | 0;
  i19 = i25 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i2 = i15 - i13 | 0;
    i3 = i2 >> 5;
    switch (i3 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 7;
      break L1;
     }
    case 4:
     {
      i23 = 8;
      break L1;
     }
    case 5:
     {
      i23 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 224) {
     i23 = 11;
     break L1;
    }
    i6 = (i3 | 0) / 2 | 0;
    i9 = i1 + (i6 << 5) | 0;
    if ((i2 | 0) > 31968) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 << 5) | 0, i9, i9 + (i2 << 5) | 0, i20, i24) | 0;
    } else i2 = __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i9, i20, i24) | 0;
    i11 = i1 + 8 | 0;
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    i12 = i1 + 20 | 0;
    f7 = Math_fround(HEAPF32[i12 >> 2]);
    f14 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i1 + (i6 << 5) + 8 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i6 << 5) + 20 >> 2])) * Math_fround(.5));
    if (f14 < f4) {
     i3 = i20;
     break;
    } else i6 = i20;
    while (1) {
     i3 = i6 + -32 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i8 = i6 + -24 | 0;
     f26 = Math_fround(HEAPF32[i8 >> 2]);
     i10 = i6 + -12 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5)) < f4) {
      i23 = 35;
      break L5;
     } else i6 = i3;
    }
    i1 = i1 + 32 | 0;
    f26 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f14 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5)))) {
     if ((i1 | 0) == (i20 | 0)) {
      i23 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
      if (f14 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i1 = i1 + 32 | 0;
      if ((i1 | 0) == (i20 | 0)) {
       i23 = 52;
       break L1;
      }
     }
     i3 = HEAP32[i1 >> 2] | 0;
     i6 = HEAP32[i1 + 4 >> 2] | 0;
     i8 = HEAP32[i1 + 12 >> 2] | 0;
     i13 = HEAP32[i1 + 16 >> 2] | 0;
     i10 = i1 + 24 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = i3;
     HEAP32[i16 >> 2] = i6;
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i17 >> 2] = i8;
     HEAP32[i18 >> 2] = i13;
     HEAPF32[i22 >> 2] = f5;
     i13 = i19;
     HEAP32[i13 >> 2] = i9;
     HEAP32[i13 + 4 >> 2] = i10;
     i1 = i1 + 32 | 0;
    }
    if ((i1 | 0) == (i20 | 0)) {
     i23 = 52;
     break L1;
    } else i2 = i20;
    while (1) {
     f7 = Math_fround(HEAPF32[i11 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i12 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
      i9 = i1 + 32 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i1 = i9;
     }
     while (1) {
      i3 = i2 + -32 | 0;
      i6 = i2 + -24 | 0;
      f26 = Math_fround(HEAPF32[i6 >> 2]);
      i8 = i2 + -12 | 0;
      if (f7 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5))) i2 = i3; else break;
     }
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     i30 = HEAP32[i1 >> 2] | 0;
     i29 = HEAP32[i1 + 4 >> 2] | 0;
     i28 = HEAP32[i1 + 12 >> 2] | 0;
     i27 = HEAP32[i1 + 16 >> 2] | 0;
     i13 = i1 + 24 | 0;
     i10 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i3 >> 2] = i30;
     HEAP32[i2 + -28 >> 2] = i29;
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i2 + -20 >> 2] = i28;
     HEAP32[i2 + -16 >> 2] = i27;
     HEAPF32[i8 >> 2] = f5;
     i2 = i2 + -8 | 0;
     HEAP32[i2 >> 2] = i10;
     HEAP32[i2 + 4 >> 2] = i13;
     i2 = i3;
     i1 = i9;
    }
   }
   if ((i23 | 0) == 35) {
    i23 = 0;
    i11 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i1 + 4 >> 2] | 0;
    i27 = HEAP32[i1 + 12 >> 2] | 0;
    i30 = HEAP32[i1 + 16 >> 2] | 0;
    i29 = i1 + 24 | 0;
    i28 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
    HEAP32[i3 >> 2] = i11;
    HEAP32[i6 + -28 >> 2] = i12;
    HEAPF32[i8 >> 2] = f5;
    HEAP32[i6 + -20 >> 2] = i27;
    HEAP32[i6 + -16 >> 2] = i30;
    HEAPF32[i10 >> 2] = f7;
    i30 = i6 + -8 | 0;
    HEAP32[i30 >> 2] = i28;
    HEAP32[i30 + 4 >> 2] = i29;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 32 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 + 20 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 20 >> 2]);
     i12 = i6 + 32 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i12; else break;
    }
    while (1) {
     i8 = i3 + -32 | 0;
     i10 = i3 + -24 | 0;
     f26 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = i3 + -12 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) break L35;
    i32 = HEAP32[i6 >> 2] | 0;
    i31 = HEAP32[i6 + 4 >> 2] | 0;
    i27 = HEAP32[i6 + 12 >> 2] | 0;
    i28 = HEAP32[i6 + 16 >> 2] | 0;
    i30 = i6 + 24 | 0;
    i29 = HEAP32[i30 >> 2] | 0;
    i30 = HEAP32[i30 + 4 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i6 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
    HEAP32[i8 >> 2] = i32;
    HEAP32[i3 + -28 >> 2] = i31;
    HEAPF32[i10 >> 2] = f4;
    HEAP32[i3 + -20 >> 2] = i27;
    HEAP32[i3 + -16 >> 2] = i28;
    HEAPF32[i11 >> 2] = f5;
    i3 = i3 + -8 | 0;
    HEAP32[i3 >> 2] = i29;
    HEAP32[i3 + 4 >> 2] = i30;
    i9 = (i9 | 0) == (i6 | 0) ? i8 : i9;
    i3 = i8;
    i6 = i12;
    i2 = i2 + 1 | 0;
   } while (0);
   if ((i6 | 0) != (i9 | 0)) {
    i3 = i9 + 8 | 0;
    f26 = Math_fround(HEAPF32[i3 >> 2]);
    i8 = i9 + 20 | 0;
    f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 20 >> 2]);
    if (f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i27 = HEAP32[i6 >> 2] | 0;
     i28 = HEAP32[i6 + 4 >> 2] | 0;
     i29 = HEAP32[i6 + 12 >> 2] | 0;
     i32 = HEAP32[i6 + 16 >> 2] | 0;
     i31 = i6 + 24 | 0;
     i30 = HEAP32[i31 >> 2] | 0;
     i31 = HEAP32[i31 + 4 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     HEAP32[i9 >> 2] = i27;
     HEAP32[i9 + 4 >> 2] = i28;
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i9 + 12 >> 2] = i29;
     HEAP32[i9 + 16 >> 2] = i32;
     HEAPF32[i8 >> 2] = f5;
     i32 = i9 + 24 | 0;
     HEAP32[i32 >> 2] = i30;
     HEAP32[i32 + 4 >> 2] = i31;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR11NodeZSorterP16HeightMeshBVNodeEEbT0_S5_T_(i1, i6, i24) | 0;
    i3 = i6 + 32 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR11NodeZSorterP16HeightMeshBVNodeEEbT0_S5_T_(i3, i25, i24) | 0) {
     i23 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i32 = i6;
   if ((i32 - i13 | 0) >= (i15 - i32 | 0)) {
    i23 = 50;
    break;
   }
   __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i6, i24);
   i1 = i6 + 32 | 0;
  }
  if ((i23 | 0) == 50) {
   i23 = 0;
   __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_(i6 + 32 | 0, i25, i24);
   i25 = i6;
   continue;
  } else if ((i23 | 0) == 51) {
   i23 = 0;
   if (i2) {
    i23 = 52;
    break;
   } else {
    i25 = i6;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  if (!(f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i27 = HEAP32[i1 >> 2] | 0;
  i28 = HEAP32[i1 + 4 >> 2] | 0;
  i29 = HEAP32[i1 + 12 >> 2] | 0;
  i32 = HEAP32[i1 + 16 >> 2] | 0;
  i31 = i1 + 24 | 0;
  i30 = HEAP32[i31 >> 2] | 0;
  i31 = HEAP32[i31 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
  HEAP32[i20 >> 2] = i27;
  HEAP32[i16 >> 2] = i28;
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i17 >> 2] = i29;
  HEAP32[i18 >> 2] = i32;
  HEAPF32[i22 >> 2] = f5;
  i32 = i19;
  HEAP32[i32 >> 2] = i30;
  HEAP32[i32 + 4 >> 2] = i31;
  return;
 } else if ((i23 | 0) == 7) {
  __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 8) {
  __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 9) {
  __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i1 + 96 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 11) {
  i3 = i1 + 64 | 0;
  __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i3, i24) | 0;
  i2 = i1 + 96 | 0;
  if ((i2 | 0) == (i25 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f26 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = HEAP32[i2 + 12 >> 2] | 0;
    i11 = HEAP32[i2 + 16 >> 2] | 0;
    i13 = i2 + 24 | 0;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     f26 = Math_fround(HEAPF32[i3 + -24 >> 2]);
     if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + -12 >> 2])) * Math_fround(.5))) {
      i6 = i3;
      i3 = i3 + -32 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i8;
    HEAP32[i3 + 4 >> 2] = i9;
    HEAPF32[i3 + 8 >> 2] = f5;
    HEAP32[i3 + 12 >> 2] = i10;
    HEAP32[i3 + 16 >> 2] = i11;
    HEAPF32[i3 + 20 >> 2] = f7;
    i32 = i3 + 24 | 0;
    HEAP32[i32 >> 2] = i12;
    HEAP32[i32 + 4 >> 2] = i13;
   }
   i3 = i2 + 32 | 0;
   if ((i3 | 0) == (i25 | 0)) break; else {
    i32 = i2;
    i2 = i3;
    i3 = i32;
   }
  }
  return;
 } else if ((i23 | 0) == 52) return;
}

function __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i2, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i25 = i2;
 L1 : while (1) {
  i15 = i25;
  i20 = i25 + -32 | 0;
  i21 = i25 + -28 | 0;
  i22 = i25 + -16 | 0;
  i16 = i25 + -24 | 0;
  i17 = i25 + -20 | 0;
  i18 = i25 + -12 | 0;
  i19 = i25 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i2 = i15 - i13 | 0;
    i3 = i2 >> 5;
    switch (i3 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 7;
      break L1;
     }
    case 4:
     {
      i23 = 8;
      break L1;
     }
    case 5:
     {
      i23 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 224) {
     i23 = 11;
     break L1;
    }
    i6 = (i3 | 0) / 2 | 0;
    i9 = i1 + (i6 << 5) | 0;
    if ((i2 | 0) > 31968) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 << 5) | 0, i9, i9 + (i2 << 5) | 0, i20, i24) | 0;
    } else i2 = __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i9, i20, i24) | 0;
    i11 = i1 + 4 | 0;
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    i12 = i1 + 16 | 0;
    f7 = Math_fround(HEAPF32[i12 >> 2]);
    f14 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i1 + (i6 << 5) + 4 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i6 << 5) + 16 >> 2])) * Math_fround(.5));
    if (f14 < f4) {
     i3 = i20;
     break;
    } else i6 = i20;
    while (1) {
     i3 = i6 + -32 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i8 = i6 + -28 | 0;
     f26 = Math_fround(HEAPF32[i8 >> 2]);
     i10 = i6 + -16 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5)) < f4) {
      i23 = 35;
      break L5;
     } else i6 = i3;
    }
    i1 = i1 + 32 | 0;
    f26 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f14 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5)))) {
     if ((i1 | 0) == (i20 | 0)) {
      i23 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
      if (f14 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i1 = i1 + 32 | 0;
      if ((i1 | 0) == (i20 | 0)) {
       i23 = 52;
       break L1;
      }
     }
     i3 = HEAP32[i1 >> 2] | 0;
     i6 = HEAP32[i1 + 8 >> 2] | 0;
     i8 = HEAP32[i1 + 12 >> 2] | 0;
     i13 = HEAP32[i1 + 20 >> 2] | 0;
     i10 = i1 + 24 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     HEAP32[i20 >> 2] = i3;
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i16 >> 2] = i6;
     HEAP32[i17 >> 2] = i8;
     HEAPF32[i22 >> 2] = f5;
     HEAP32[i18 >> 2] = i13;
     i13 = i19;
     HEAP32[i13 >> 2] = i9;
     HEAP32[i13 + 4 >> 2] = i10;
     i1 = i1 + 32 | 0;
    }
    if ((i1 | 0) == (i20 | 0)) {
     i23 = 52;
     break L1;
    } else i2 = i20;
    while (1) {
     f7 = Math_fround(HEAPF32[i11 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i12 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
      i9 = i1 + 32 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i1 = i9;
     }
     while (1) {
      i3 = i2 + -32 | 0;
      i6 = i2 + -28 | 0;
      f26 = Math_fround(HEAPF32[i6 >> 2]);
      i8 = i2 + -16 | 0;
      if (f7 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5))) i2 = i3; else break;
     }
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     i30 = HEAP32[i1 >> 2] | 0;
     i29 = HEAP32[i1 + 8 >> 2] | 0;
     i28 = HEAP32[i1 + 12 >> 2] | 0;
     i27 = HEAP32[i1 + 20 >> 2] | 0;
     i13 = i1 + 24 | 0;
     i10 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i3 >> 2] = i30;
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i2 + -24 >> 2] = i29;
     HEAP32[i2 + -20 >> 2] = i28;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i2 + -12 >> 2] = i27;
     i2 = i2 + -8 | 0;
     HEAP32[i2 >> 2] = i10;
     HEAP32[i2 + 4 >> 2] = i13;
     i2 = i3;
     i1 = i9;
    }
   }
   if ((i23 | 0) == 35) {
    i23 = 0;
    i11 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    i27 = HEAP32[i1 + 12 >> 2] | 0;
    i30 = HEAP32[i1 + 20 >> 2] | 0;
    i29 = i1 + 24 | 0;
    i28 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
    HEAP32[i3 >> 2] = i11;
    HEAPF32[i8 >> 2] = f5;
    HEAP32[i6 + -24 >> 2] = i12;
    HEAP32[i6 + -20 >> 2] = i27;
    HEAPF32[i10 >> 2] = f7;
    HEAP32[i6 + -12 >> 2] = i30;
    i30 = i6 + -8 | 0;
    HEAP32[i30 >> 2] = i28;
    HEAP32[i30 + 4 >> 2] = i29;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 32 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i9 + 4 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
     i12 = i6 + 32 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i12; else break;
    }
    while (1) {
     i8 = i3 + -32 | 0;
     i10 = i3 + -28 | 0;
     f26 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = i3 + -16 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) break L35;
    i32 = HEAP32[i6 >> 2] | 0;
    i31 = HEAP32[i6 + 8 >> 2] | 0;
    i27 = HEAP32[i6 + 12 >> 2] | 0;
    i28 = HEAP32[i6 + 20 >> 2] | 0;
    i30 = i6 + 24 | 0;
    i29 = HEAP32[i30 >> 2] | 0;
    i30 = HEAP32[i30 + 4 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i6 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
    HEAP32[i8 >> 2] = i32;
    HEAPF32[i10 >> 2] = f4;
    HEAP32[i3 + -24 >> 2] = i31;
    HEAP32[i3 + -20 >> 2] = i27;
    HEAPF32[i11 >> 2] = f5;
    HEAP32[i3 + -12 >> 2] = i28;
    i3 = i3 + -8 | 0;
    HEAP32[i3 >> 2] = i29;
    HEAP32[i3 + 4 >> 2] = i30;
    i9 = (i9 | 0) == (i6 | 0) ? i8 : i9;
    i3 = i8;
    i6 = i12;
    i2 = i2 + 1 | 0;
   } while (0);
   if ((i6 | 0) != (i9 | 0)) {
    i3 = i9 + 4 | 0;
    f26 = Math_fround(HEAPF32[i3 >> 2]);
    i8 = i9 + 16 | 0;
    f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
    if (f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i27 = HEAP32[i6 >> 2] | 0;
     i28 = HEAP32[i6 + 8 >> 2] | 0;
     i29 = HEAP32[i6 + 12 >> 2] | 0;
     i32 = HEAP32[i6 + 20 >> 2] | 0;
     i31 = i6 + 24 | 0;
     i30 = HEAP32[i31 >> 2] | 0;
     i31 = HEAP32[i31 + 4 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     HEAP32[i9 >> 2] = i27;
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i9 + 8 >> 2] = i28;
     HEAP32[i9 + 12 >> 2] = i29;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i9 + 20 >> 2] = i32;
     i32 = i9 + 24 | 0;
     HEAP32[i32 >> 2] = i30;
     HEAP32[i32 + 4 >> 2] = i31;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR11NodeYSorterP16HeightMeshBVNodeEEbT0_S5_T_(i1, i6, i24) | 0;
    i3 = i6 + 32 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR11NodeYSorterP16HeightMeshBVNodeEEbT0_S5_T_(i3, i25, i24) | 0) {
     i23 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i32 = i6;
   if ((i32 - i13 | 0) >= (i15 - i32 | 0)) {
    i23 = 50;
    break;
   }
   __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i6, i24);
   i1 = i6 + 32 | 0;
  }
  if ((i23 | 0) == 50) {
   i23 = 0;
   __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_(i6 + 32 | 0, i25, i24);
   i25 = i6;
   continue;
  } else if ((i23 | 0) == 51) {
   i23 = 0;
   if (i2) {
    i23 = 52;
    break;
   } else {
    i25 = i6;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  if (!(f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i27 = HEAP32[i1 >> 2] | 0;
  i28 = HEAP32[i1 + 8 >> 2] | 0;
  i29 = HEAP32[i1 + 12 >> 2] | 0;
  i32 = HEAP32[i1 + 20 >> 2] | 0;
  i31 = i1 + 24 | 0;
  i30 = HEAP32[i31 >> 2] | 0;
  i31 = HEAP32[i31 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
  HEAP32[i20 >> 2] = i27;
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i16 >> 2] = i28;
  HEAP32[i17 >> 2] = i29;
  HEAPF32[i22 >> 2] = f5;
  HEAP32[i18 >> 2] = i32;
  i32 = i19;
  HEAP32[i32 >> 2] = i30;
  HEAP32[i32 + 4 >> 2] = i31;
  return;
 } else if ((i23 | 0) == 7) {
  __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 8) {
  __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 9) {
  __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i1 + 96 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 11) {
  i3 = i1 + 64 | 0;
  __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i3, i24) | 0;
  i2 = i1 + 96 | 0;
  if ((i2 | 0) == (i25 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f26 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + 16 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i2 + 8 >> 2] | 0;
    i10 = HEAP32[i2 + 12 >> 2] | 0;
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    i13 = i2 + 24 | 0;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     f26 = Math_fround(HEAPF32[i3 + -28 >> 2]);
     if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + -16 >> 2])) * Math_fround(.5))) {
      i6 = i3;
      i3 = i3 + -32 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i8;
    HEAPF32[i3 + 4 >> 2] = f5;
    HEAP32[i3 + 8 >> 2] = i9;
    HEAP32[i3 + 12 >> 2] = i10;
    HEAPF32[i3 + 16 >> 2] = f7;
    HEAP32[i3 + 20 >> 2] = i11;
    i32 = i3 + 24 | 0;
    HEAP32[i32 >> 2] = i12;
    HEAP32[i32 + 4 >> 2] = i13;
   }
   i3 = i2 + 32 | 0;
   if ((i3 | 0) == (i25 | 0)) break; else {
    i32 = i2;
    i2 = i3;
    i3 = i32;
   }
  }
  return;
 } else if ((i23 | 0) == 52) return;
}

function __Z16sweepBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i4, i3, i22, f19, i21, i6, f2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i22 = i22 | 0;
 f19 = Math_fround(f19);
 i21 = i21 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var f5 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i23 + 480 | 0;
 i17 = i23 + 464 | 0;
 i25 = i23 + 448 | 0;
 i26 = i23 + 384 | 0;
 i28 = i23 + 224 | 0;
 i27 = i23 + 64 | 0;
 i24 = i23 + 48 | 0;
 i16 = i23 + 32 | 0;
 i18 = i23 + 16 | 0;
 i20 = i23;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i40 = HEAP32[i1 + 4 >> 2] | 0;
 i39 = HEAP32[i1 + 8 >> 2] | 0;
 i38 = HEAP32[i1 + 12 >> 2] | 0;
 i36 = HEAP32[i3 + 48 >> 2] | 0;
 i35 = HEAP32[i3 + 52 >> 2] | 0;
 i1 = HEAP32[i3 + 56 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i22 >> 2]);
 i8 = i22 + 4 | 0;
 f31 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i22 + 8 | 0;
 f32 = Math_fround(HEAPF32[i9 >> 2]);
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i37, i3);
 f10 = Math_fround(HEAPF32[i37 >> 2]);
 f11 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i37 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f52 = Math_fround(HEAPF32[i4 >> 2]);
 f53 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f51 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i3 = i4 + 16 | 0;
 f30 = Math_fround(HEAPF32[i3 >> 2]);
 f47 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f41 = Math_fround(-f10);
 f46 = Math_fround(-f11);
 f43 = Math_fround(-f12);
 f30 = Math_fround(f30 - f14);
 f47 = Math_fround(f47 - f15);
 f49 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f7);
 f5 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
 f50 = Math_fround(Math_fround(Math_fround(f30 * f41) + Math_fround(f47 * f46)) + Math_fround(f49 * f43));
 f29 = Math_fround(Math_fround(Math_fround(f50 * f46) + Math_fround(Math_fround(f5 * f47) + Math_fround(f13 * Math_fround(Math_fround(f30 * f43) - Math_fround(f49 * f41))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f49) + Math_fround(f13 * Math_fround(Math_fround(f47 * f41) - Math_fround(f30 * f46)))) + Math_fround(f50 * f43)) * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f13 * f48) - Math_fround(Math_fround(Math_fround(f52 * f41) + Math_fround(f53 * f46)) + Math_fround(f51 * f43)));
 f45 = Math_fround(Math_fround(Math_fround(f51 * f46) - Math_fround(f53 * f43)) + Math_fround(Math_fround(f13 * f52) + Math_fround(f48 * f41)));
 f42 = Math_fround(Math_fround(Math_fround(f52 * f43) - Math_fround(f51 * f41)) + Math_fround(Math_fround(f13 * f53) + Math_fround(f48 * f46)));
 f48 = Math_fround(Math_fround(Math_fround(f53 * f41) - Math_fround(f52 * f46)) + Math_fround(Math_fround(f13 * f51) + Math_fround(f48 * f43)));
 HEAPF32[i26 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f50 * f41) + Math_fround(Math_fround(f5 * f30) + Math_fround(f13 * Math_fround(Math_fround(f49 * f46) - Math_fround(f47 * f43))))) * Math_fround(2.0));
 HEAPF32[i26 + 52 >> 2] = f29;
 HEAPF32[i26 + 56 >> 2] = f34;
 HEAPF32[i26 + 60 >> 2] = Math_fround(0.0);
 f34 = Math_fround(f45 + f45);
 f29 = Math_fround(f42 + f42);
 f43 = Math_fround(f48 + f48);
 f47 = Math_fround(f42 * f29);
 f46 = Math_fround(f48 * f43);
 f42 = Math_fround(f42 * f34);
 f49 = Math_fround(f48 * f34);
 f30 = Math_fround(f44 * f34);
 f48 = Math_fround(f48 * f29);
 f29 = Math_fround(f44 * f29);
 f43 = Math_fround(f44 * f43);
 f34 = Math_fround(Math_fround(1.0) - Math_fround(f45 * f34));
 f45 = Math_fround(f42 + f43);
 f44 = Math_fround(f49 - f29);
 f43 = Math_fround(f42 - f43);
 f42 = Math_fround(f34 - f46);
 f41 = Math_fround(f48 + f30);
 f29 = Math_fround(f49 + f29);
 f30 = Math_fround(f48 - f30);
 f34 = Math_fround(f34 - f47);
 HEAPF32[i26 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f47) - f46);
 HEAPF32[i26 + 4 >> 2] = f45;
 HEAPF32[i26 + 8 >> 2] = f44;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 16 >> 2] = f43;
 HEAPF32[i26 + 20 >> 2] = f42;
 HEAPF32[i26 + 24 >> 2] = f41;
 HEAPF32[i26 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 32 >> 2] = f29;
 HEAPF32[i26 + 36 >> 2] = f30;
 HEAPF32[i26 + 40 >> 2] = f34;
 HEAPF32[i26 + 44 >> 2] = Math_fround(0.0);
 i3 = i28 + 64 | 0;
 HEAP32[i28 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 HEAP32[i28 + 80 >> 2] = 3;
 HEAPF32[i28 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
 HEAP32[i28 + 144 >> 2] = i40;
 HEAP32[i28 + 148 >> 2] = i39;
 HEAP32[i28 + 152 >> 2] = i38;
 HEAPF32[i28 + 156 >> 2] = Math_fround(0.0);
 f34 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = f34 <= f30 ? f34 : f30;
 f29 = f30 <= f29 ? f30 : f29;
 HEAPF32[i28 + 16 >> 2] = Math_fround(f29 * Math_fround(.150000006));
 HEAPF32[i28 + 32 >> 2] = Math_fround(f29 * Math_fround(.0500000007));
 i3 = i27 + 64 | 0;
 HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 HEAP32[i27 + 80 >> 2] = 3;
 HEAPF32[i27 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
 HEAP32[i27 + 144 >> 2] = i36;
 HEAP32[i27 + 148 >> 2] = i35;
 HEAP32[i27 + 152 >> 2] = i1;
 HEAPF32[i27 + 156 >> 2] = Math_fround(0.0);
 f29 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = f29 <= f30 ? f29 : f30;
 f34 = f30 <= f34 ? f30 : f34;
 HEAPF32[i27 + 16 >> 2] = Math_fround(f34 * Math_fround(.150000006));
 HEAPF32[i27 + 32 >> 2] = Math_fround(f34 * Math_fround(.0500000007));
 f33 = Math_fround(f33 * f19);
 f31 = Math_fround(f31 * f19);
 f32 = Math_fround(f32 * f19);
 f34 = Math_fround(Math_fround(Math_fround(f33 * f10) + Math_fround(f31 * f11)) + Math_fround(f32 * f12));
 f30 = Math_fround(Math_fround(Math_fround(f11 * f34) + Math_fround(Math_fround(f31 * f5) - Math_fround(f13 * Math_fround(Math_fround(f33 * f12) - Math_fround(f32 * f10))))) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(Math_fround(f12 * f34) + Math_fround(Math_fround(f32 * f5) - Math_fround(f13 * Math_fround(Math_fround(f31 * f10) - Math_fround(f33 * f11))))) * Math_fround(2.0));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f10 * f34) + Math_fround(Math_fround(f33 * f5) - Math_fround(f13 * Math_fround(Math_fround(f32 * f11) - Math_fround(f31 * f12))))) * Math_fround(2.0));
 HEAPF32[i24 + 4 >> 2] = f30;
 HEAPF32[i24 + 8 >> 2] = f29;
 HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
 i3 = (HEAP16[i6 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i28, i27, i26, i17, i25, i24, i16, i20, i18, f2, i3) | 0)) {
  i40 = 0;
  STACKTOP = i23;
  return i40 | 0;
 }
 i1 = i21 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 f53 = Math_fround(HEAPF32[i17 >> 2]);
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 if (!(f53 >= f2)) {
  HEAP16[i1 >> 1] = 7;
  f46 = Math_fround(HEAPF32[i18 >> 2]);
  f53 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f52 = Math_fround(Math_fround(Math_fround(f10 * f46) + Math_fround(f11 * f53)) + Math_fround(f12 * f45));
  f50 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f10 * f52) + Math_fround(Math_fround(f5 * f46) + Math_fround(f13 * Math_fround(Math_fround(f11 * f45) - Math_fround(f12 * f53))))) * Math_fround(2.0)));
  f51 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f11 * f52) + Math_fround(Math_fround(f5 * f53) + Math_fround(f13 * Math_fround(Math_fround(f12 * f46) - Math_fround(f10 * f45))))) * Math_fround(2.0)));
  f52 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f45) + Math_fround(f13 * Math_fround(Math_fround(f10 * f53) - Math_fround(f11 * f46)))) + Math_fround(f12 * f52)) * Math_fround(2.0)));
  f46 = Math_fround(HEAPF32[i20 >> 2]);
  f53 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f10 * f46) + Math_fround(f11 * f53)) + Math_fround(f12 * f45));
  f47 = Math_fround(Math_fround(Math_fround(f10 * f49) + Math_fround(Math_fround(f5 * f46) + Math_fround(f13 * Math_fround(Math_fround(f11 * f45) - Math_fround(f12 * f53))))) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(Math_fround(f11 * f49) + Math_fround(Math_fround(f5 * f53) + Math_fround(f13 * Math_fround(Math_fround(f12 * f46) - Math_fround(f10 * f45))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f45) + Math_fround(f13 * Math_fround(Math_fround(f10 * f53) - Math_fround(f11 * f46)))) + Math_fround(f12 * f49)) * Math_fround(2.0));
  f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f49 * f49) + Math_fround(Math_fround(f47 * f47) + Math_fround(f48 * f48))))));
  f53 = Math_fround(f2 * f19);
  f48 = Math_fround(-Math_fround(f46 * f48));
  f49 = Math_fround(-Math_fround(f46 * f49));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(f46 * f47));
  HEAPF32[i21 + 32 >> 2] = f48;
  HEAPF32[i21 + 36 >> 2] = f49;
  HEAPF32[i21 + 16 >> 2] = f50;
  HEAPF32[i21 + 20 >> 2] = f51;
  HEAPF32[i21 + 24 >> 2] = f52;
  HEAPF32[i21 + 40 >> 2] = f53;
  i40 = 1;
  STACKTOP = i23;
  return i40 | 0;
 }
 if (i3) {
  HEAP16[i1 >> 1] = 7;
  f47 = Math_fround(HEAPF32[i18 >> 2]);
  f46 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f53 = Math_fround(Math_fround(Math_fround(f10 * f47) + Math_fround(f11 * f46)) + Math_fround(f12 * f45));
  f51 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f10 * f53) + Math_fround(Math_fround(f5 * f47) + Math_fround(f13 * Math_fround(Math_fround(f11 * f45) - Math_fround(f12 * f46))))) * Math_fround(2.0)));
  f52 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f11 * f53) + Math_fround(Math_fround(f5 * f46) + Math_fround(f13 * Math_fround(Math_fround(f12 * f47) - Math_fround(f10 * f45))))) * Math_fround(2.0)));
  f53 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f45) + Math_fround(f13 * Math_fround(Math_fround(f10 * f46) - Math_fround(f11 * f47)))) + Math_fround(f12 * f53)) * Math_fround(2.0)));
  f47 = Math_fround(HEAPF32[i20 >> 2]);
  f46 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f50 = Math_fround(Math_fround(Math_fround(f10 * f47) + Math_fround(f11 * f46)) + Math_fround(f12 * f45));
  f48 = Math_fround(Math_fround(Math_fround(f10 * f50) + Math_fround(Math_fround(f5 * f47) + Math_fround(f13 * Math_fround(Math_fround(f11 * f45) - Math_fround(f12 * f46))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(f11 * f50) + Math_fround(Math_fround(f5 * f46) + Math_fround(f13 * Math_fround(Math_fround(f12 * f47) - Math_fround(f10 * f45))))) * Math_fround(2.0));
  f50 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f45) + Math_fround(f13 * Math_fround(Math_fround(f10 * f46) - Math_fround(f11 * f47)))) + Math_fround(f12 * f50)) * Math_fround(2.0));
  f47 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f50 * f50) + Math_fround(Math_fround(f48 * f48) + Math_fround(f49 * f49))))));
  f49 = Math_fround(-Math_fround(f47 * f49));
  f50 = Math_fround(-Math_fround(f47 * f50));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(f47 * f48));
  HEAPF32[i21 + 32 >> 2] = f49;
  HEAPF32[i21 + 36 >> 2] = f50;
  HEAPF32[i21 + 16 >> 2] = f51;
  HEAPF32[i21 + 20 >> 2] = f52;
  HEAPF32[i21 + 24 >> 2] = f53;
  HEAPF32[i21 + 40 >> 2] = f2;
  i40 = 1;
  STACKTOP = i23;
  return i40 | 0;
 } else {
  HEAPF32[i21 + 40 >> 2] = Math_fround(0.0);
  f51 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  f52 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  f53 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
  HEAPF32[i21 + 28 >> 2] = f51;
  HEAPF32[i21 + 32 >> 2] = f52;
  HEAPF32[i21 + 36 >> 2] = f53;
  i40 = 1;
  STACKTOP = i23;
  return i40 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_115constrainMotionI8Scalar4fPKS1_EEvPT_PKS4_RKT0_S4_(i2, i65, i3, i1) {
 i2 = i2 | 0;
 i65 = i65 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, f51 = f0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, f57 = f0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0;
 f63 = Math_fround(HEAPF32[i1 >> 2]);
 f64 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f62 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (i2 >>> 0 >= i65 >>> 0) return;
 while (1) {
  i50 = HEAP32[i2 >> 2] | 0;
  i52 = i2 + 4 | 0;
  i56 = HEAP32[i52 >> 2] | 0;
  i58 = i2 + 8 | 0;
  i1 = HEAP32[i58 >> 2] | 0;
  i5 = i2 + 12 | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i10 = i2 + 16 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i12 = i2 + 20 | 0;
  i14 = HEAP32[i12 >> 2] | 0;
  i18 = i2 + 24 | 0;
  i22 = HEAP32[i18 >> 2] | 0;
  i28 = i2 + 28 | 0;
  i29 = HEAP32[i28 >> 2] | 0;
  i30 = i2 + 32 | 0;
  i31 = HEAP32[i30 >> 2] | 0;
  i32 = i2 + 36 | 0;
  i33 = HEAP32[i32 >> 2] | 0;
  i34 = i2 + 40 | 0;
  i35 = HEAP32[i34 >> 2] | 0;
  i36 = i2 + 44 | 0;
  i37 = HEAP32[i36 >> 2] | 0;
  i38 = i2 + 48 | 0;
  i39 = HEAP32[i38 >> 2] | 0;
  i40 = i2 + 52 | 0;
  i41 = HEAP32[i40 >> 2] | 0;
  i42 = i2 + 56 | 0;
  i43 = HEAP32[i42 >> 2] | 0;
  i44 = i2 + 60 | 0;
  i45 = HEAP32[i44 >> 2] | 0;
  i27 = HEAP32[gb + 1097472 >> 2] | 0;
  i26 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
  i25 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
  i24 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
  f46 = Math_fround(HEAPF32[i3 >> 2]);
  f46 = Math_fround(f46 - (HEAP32[tempDoublePtr >> 2] = i27 & i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f47 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f47 = Math_fround(f47 - (HEAP32[tempDoublePtr >> 2] = i26 & i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f48 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f48 = Math_fround(f48 - (HEAP32[tempDoublePtr >> 2] = i25 & i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f49 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f49 = Math_fround(f49 - (HEAP32[tempDoublePtr >> 2] = i24 & i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f51 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f51 = Math_fround(f51 - (HEAP32[tempDoublePtr >> 2] = i27 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f53 = Math_fround(HEAPF32[i3 + 20 >> 2]);
  f53 = Math_fround(f53 - (HEAP32[tempDoublePtr >> 2] = i26 & i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f54 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  f54 = Math_fround(f54 - (HEAP32[tempDoublePtr >> 2] = i25 & i22, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f55 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f55 = Math_fround(f55 - (HEAP32[tempDoublePtr >> 2] = i24 & i29, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f57 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f57 = Math_fround(f57 - (HEAP32[tempDoublePtr >> 2] = i27 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f59 = Math_fround(HEAPF32[i3 + 36 >> 2]);
  f59 = Math_fround(f59 - (HEAP32[tempDoublePtr >> 2] = i26 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f60 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f60 = Math_fround(f60 - (HEAP32[tempDoublePtr >> 2] = i25 & i35, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f61 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f61 = Math_fround(f61 - (HEAP32[tempDoublePtr >> 2] = i24 & i37, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f4 = Math_fround(HEAPF32[i3 + 48 >> 2]);
  f4 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i27 & i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f6 = Math_fround(HEAPF32[i3 + 52 >> 2]);
  f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i26 & i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f7 = Math_fround(HEAPF32[i3 + 56 >> 2]);
  f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i25 & i43, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f8 = Math_fround(HEAPF32[i3 + 60 >> 2]);
  f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i24 & i45, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
  f20 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
  f21 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
  f19 = Math_fround(Math_fround(f48 * f48) + Math_fround(Math_fround(f47 * f47) + Math_fround(Math_fround(f46 * f46) + f19)));
  f20 = Math_fround(Math_fround(f54 * f54) + Math_fround(Math_fround(f53 * f53) + Math_fround(Math_fround(f51 * f51) + f20)));
  f21 = Math_fround(Math_fround(f60 * f60) + Math_fround(Math_fround(f59 * f59) + Math_fround(Math_fround(f57 * f57) + f21)));
  f23 = Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(HEAPF32[gb + 1097504 + 12 >> 2]))));
  f13 = Math_fround(f64 + Math_fround(f63 * f49));
  f15 = Math_fround(f64 + Math_fround(f63 * f55));
  f16 = Math_fround(f64 + Math_fround(f63 * f61));
  f17 = Math_fround(f64 + Math_fround(f63 * f8));
  i24 = f13 > Math_fround(0.0);
  f13 = i24 ? f13 : Math_fround(0.0);
  i24 = f15 > Math_fround(0.0);
  f15 = i24 ? f15 : Math_fround(0.0);
  i24 = f16 > Math_fround(0.0);
  f16 = i24 ? f16 : Math_fround(0.0);
  i24 = f17 > Math_fround(0.0);
  f17 = i24 ? f17 : Math_fround(0.0);
  f19 = Math_fround(Math_fround(1.0) - Math_fround(f13 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f19))))));
  f20 = Math_fround(Math_fround(1.0) - Math_fround(f15 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f20))))));
  f21 = Math_fround(Math_fround(1.0) - Math_fround(f16 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f21))))));
  f23 = Math_fround(Math_fround(1.0) - Math_fround(f17 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f23))))));
  i24 = f19 > Math_fround(0.0);
  i25 = f20 > Math_fround(0.0);
  i26 = f21 > Math_fround(0.0);
  i27 = f23 > Math_fround(0.0);
  if (i24 | i25 | i26 | i27) {
   i70 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i74 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
   i78 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
   i81 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
   i71 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i75 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
   i79 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
   i82 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
   i72 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i76 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
   i80 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
   i83 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i73 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
   i77 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
   f49 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f51 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f47 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f54 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   i68 = f13 > f49;
   i67 = f15 > f51;
   i66 = f16 > f47;
   f53 = Math_fround(f62 * f19);
   f55 = Math_fround(f62 * f20);
   f57 = Math_fround(f62 * f21);
   f61 = Math_fround(f62 * f23);
   i83 = HEAP32[gb + 1097472 + 4 >> 2] & i83;
   i82 = HEAP32[gb + 1097472 + 8 >> 2] & i82;
   i81 = HEAP32[gb + 1097472 + 12 >> 2] & i81;
   f48 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0), Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = i24 ? f53 : Math_fround(0.0);
   f48 = Math_fround(f53 * f48);
   f60 = Math_fround(f53 * (HEAP32[tempDoublePtr >> 2] = i83, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f59 = Math_fround(f53 * (HEAP32[tempDoublePtr >> 2] = i82, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f53 = Math_fround(f53 * (HEAP32[tempDoublePtr >> 2] = i81, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f46 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f48 = Math_fround((i68 ? f46 : Math_fround(0.0)) + f48);
   f46 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround((f13 > f51 ? f46 : Math_fround(0.0)) + f60);
   f46 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = Math_fround((f13 > f47 ? f46 : Math_fround(0.0)) + f59);
   f46 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = Math_fround((f13 > f54 ? f46 : Math_fround(0.0)) + f53);
   HEAPF32[i2 >> 2] = f48;
   HEAPF32[i52 >> 2] = f60;
   HEAPF32[i58 >> 2] = f59;
   HEAPF32[i5 >> 2] = f53;
   i52 = HEAP32[gb + 1097472 + 4 >> 2] & i80;
   i56 = HEAP32[gb + 1097472 + 8 >> 2] & i79;
   i58 = HEAP32[gb + 1097472 + 12 >> 2] & i78;
   f53 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i77, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f55 = i25 ? f55 : Math_fround(0.0);
   f53 = Math_fround(f55 * f53);
   f59 = Math_fround(f55 * (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f60 = Math_fround(f55 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f55 = Math_fround(f55 * (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f48 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f53 = Math_fround((f15 > f49 ? f48 : Math_fround(0.0)) + f53);
   f48 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = Math_fround((i67 ? f48 : Math_fround(0.0)) + f59);
   f48 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround((f15 > f47 ? f48 : Math_fround(0.0)) + f60);
   f48 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f55 = Math_fround((f15 > f54 ? f48 : Math_fround(0.0)) + f55);
   HEAPF32[i10 >> 2] = f53;
   HEAPF32[i12 >> 2] = f59;
   HEAPF32[i18 >> 2] = f60;
   HEAPF32[i28 >> 2] = f55;
   i58 = HEAP32[gb + 1097472 + 4 >> 2] & i76;
   i56 = HEAP32[gb + 1097472 + 8 >> 2] & i75;
   i52 = HEAP32[gb + 1097472 + 12 >> 2] & i74;
   f55 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i73, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = i26 ? f57 : Math_fround(0.0);
   f55 = Math_fround(f57 * f55);
   f60 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f59 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f57 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f53 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f55 = Math_fround((f16 > f49 ? f53 : Math_fround(0.0)) + f55);
   f53 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround((f16 > f51 ? f53 : Math_fround(0.0)) + f60);
   f53 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = Math_fround((i66 ? f53 : Math_fround(0.0)) + f59);
   f53 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround((f16 > f54 ? f53 : Math_fround(0.0)) + f57);
   HEAPF32[i30 >> 2] = f55;
   HEAPF32[i32 >> 2] = f60;
   HEAPF32[i34 >> 2] = f59;
   HEAPF32[i36 >> 2] = f57;
   i52 = HEAP32[gb + 1097472 + 4 >> 2] & i72;
   i56 = HEAP32[gb + 1097472 + 8 >> 2] & i71;
   i58 = HEAP32[gb + 1097472 + 12 >> 2] & i70;
   f57 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i69, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = i27 ? f61 : Math_fround(0.0);
   f57 = Math_fround(f61 * f57);
   f59 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f60 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f61 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f55 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround((i68 ? f55 : Math_fround(0.0)) + f57);
   f55 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = Math_fround((i67 ? f55 : Math_fround(0.0)) + f59);
   f55 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround((i66 ? f55 : Math_fround(0.0)) + f60);
   f55 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround((f17 > f54 ? f55 : Math_fround(0.0)) + f61);
   HEAPF32[i38 >> 2] = f57;
   HEAPF32[i40 >> 2] = f59;
   HEAPF32[i42 >> 2] = f60;
   HEAPF32[i44 >> 2] = f61;
  }
  i2 = i2 + 64 | 0;
  if (i2 >>> 0 >= i65 >>> 0) break; else i3 = i3 + 64 | 0;
 }
 return;
}

function __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i2, i23) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i24 = i2;
 L1 : while (1) {
  i12 = i24;
  i21 = i24 + -32 | 0;
  i13 = i24 + -20 | 0;
  i15 = i24 + -28 | 0;
  i16 = i24 + -24 | 0;
  i17 = i24 + -20 | 0;
  i18 = i24 + -16 | 0;
  i19 = i24 + -12 | 0;
  i20 = i24 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i2 = i12 - i11 | 0;
    i3 = i2 >> 5;
    switch (i3 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 7;
      break L1;
     }
    case 4:
     {
      i22 = 8;
      break L1;
     }
    case 5:
     {
      i22 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 224) {
     i22 = 11;
     break L1;
    }
    i6 = (i3 | 0) / 2 | 0;
    i10 = i1 + (i6 << 5) | 0;
    if ((i2 | 0) > 31968) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 << 5) | 0, i10, i10 + (i2 << 5) | 0, i21, i23) | 0;
    } else i2 = __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i10, i21, i23) | 0;
    f7 = Math_fround(HEAPF32[i1 >> 2]);
    i9 = i1 + 12 | 0;
    f5 = Math_fround(HEAPF32[i9 >> 2]);
    f14 = Math_fround(Math_fround(f7 + f5) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i6 << 5) + 12 >> 2])) * Math_fround(.5));
    if (f14 < f4) {
     i3 = i21;
     break;
    } else i6 = i21;
    while (1) {
     i3 = i6 + -32 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     f25 = Math_fround(HEAPF32[i3 >> 2]);
     if (Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i6 + -20 >> 2])) * Math_fround(.5)) < f4) {
      i22 = 35;
      break L5;
     } else i6 = i3;
    }
    i2 = i1 + 32 | 0;
    f25 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f14 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)))) {
     if ((i2 | 0) == (i21 | 0)) {
      i22 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      if (f14 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i2 = i2 + 32 | 0;
      if ((i2 | 0) == (i21 | 0)) {
       i22 = 52;
       break L1;
      }
     }
     i26 = HEAP32[i2 + 4 >> 2] | 0;
     i3 = HEAP32[i2 + 8 >> 2] | 0;
     i6 = HEAP32[i2 + 16 >> 2] | 0;
     i11 = HEAP32[i2 + 20 >> 2] | 0;
     i10 = i2 + 24 | 0;
     i8 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
     HEAP32[i2 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i15 >> 2] = i26;
     HEAP32[i16 >> 2] = i3;
     HEAPF32[i17 >> 2] = f5;
     HEAP32[i18 >> 2] = i6;
     HEAP32[i19 >> 2] = i11;
     i11 = i20;
     HEAP32[i11 >> 2] = i8;
     HEAP32[i11 + 4 >> 2] = i10;
     i2 = i2 + 32 | 0;
    }
    if ((i2 | 0) == (i21 | 0)) {
     i22 = 52;
     break L1;
    } else i3 = i21;
    while (1) {
     f7 = Math_fround(HEAPF32[i1 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      i8 = i2 + 32 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i2 = i8;
     }
     while (1) {
      i6 = i3 + -32 | 0;
      f25 = Math_fround(HEAPF32[i6 >> 2]);
      if (f7 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -20 >> 2])) * Math_fround(.5))) i3 = i6; else break;
     }
     if (i2 >>> 0 >= i6 >>> 0) {
      i1 = i2;
      continue L5;
     }
     i29 = HEAP32[i2 + 4 >> 2] | 0;
     i28 = HEAP32[i2 + 8 >> 2] | 0;
     i27 = HEAP32[i2 + 16 >> 2] | 0;
     i10 = HEAP32[i2 + 20 >> 2] | 0;
     i26 = i2 + 24 | 0;
     i11 = HEAP32[i26 >> 2] | 0;
     i26 = HEAP32[i26 + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
     HEAP32[i2 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i3 + -28 >> 2] = i29;
     HEAP32[i3 + -24 >> 2] = i28;
     HEAPF32[i3 + -20 >> 2] = f5;
     HEAP32[i3 + -16 >> 2] = i27;
     HEAP32[i3 + -12 >> 2] = i10;
     i3 = i3 + -8 | 0;
     HEAP32[i3 >> 2] = i11;
     HEAP32[i3 + 4 >> 2] = i26;
     i3 = i6;
     i2 = i8;
    }
   }
   if ((i22 | 0) == 35) {
    i22 = 0;
    i8 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i1 + 8 >> 2] | 0;
    i26 = HEAP32[i1 + 16 >> 2] | 0;
    i29 = HEAP32[i1 + 20 >> 2] | 0;
    i28 = i1 + 24 | 0;
    i27 = HEAP32[i28 >> 2] | 0;
    i28 = HEAP32[i28 + 4 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
    HEAPF32[i3 >> 2] = f7;
    HEAP32[i6 + -28 >> 2] = i8;
    HEAP32[i6 + -24 >> 2] = i9;
    HEAPF32[i6 + -20 >> 2] = f5;
    HEAP32[i6 + -16 >> 2] = i26;
    HEAP32[i6 + -12 >> 2] = i29;
    i29 = i6 + -8 | 0;
    HEAP32[i29 >> 2] = i27;
    HEAP32[i29 + 4 >> 2] = i28;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 32 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i10 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i10 + 12 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
     i9 = i6 + 32 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i9; else break;
    }
    while (1) {
     i8 = i3 + -32 | 0;
     f25 = Math_fround(HEAPF32[i8 >> 2]);
     if (Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -20 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) {
     i3 = i10;
     break L35;
    }
    i31 = HEAP32[i6 + 4 >> 2] | 0;
    i30 = HEAP32[i6 + 8 >> 2] | 0;
    i26 = HEAP32[i6 + 16 >> 2] | 0;
    i27 = HEAP32[i6 + 20 >> 2] | 0;
    i29 = i6 + 24 | 0;
    i28 = HEAP32[i29 >> 2] | 0;
    i29 = HEAP32[i29 + 4 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i6 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
    HEAPF32[i8 >> 2] = f4;
    HEAP32[i3 + -28 >> 2] = i31;
    HEAP32[i3 + -24 >> 2] = i30;
    HEAPF32[i3 + -20 >> 2] = f5;
    HEAP32[i3 + -16 >> 2] = i26;
    HEAP32[i3 + -12 >> 2] = i27;
    i3 = i3 + -8 | 0;
    HEAP32[i3 >> 2] = i28;
    HEAP32[i3 + 4 >> 2] = i29;
    i10 = (i10 | 0) == (i6 | 0) ? i8 : i10;
    i3 = i8;
    i6 = i9;
    i2 = i2 + 1 | 0;
   } else i3 = i10; while (0);
   if ((i6 | 0) != (i3 | 0)) {
    f25 = Math_fround(HEAPF32[i3 >> 2]);
    f25 = Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + 12 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
    if (f25 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i26 = HEAP32[i6 + 4 >> 2] | 0;
     i27 = HEAP32[i6 + 8 >> 2] | 0;
     i28 = HEAP32[i6 + 16 >> 2] | 0;
     i31 = HEAP32[i6 + 20 >> 2] | 0;
     i30 = i6 + 24 | 0;
     i29 = HEAP32[i30 >> 2] | 0;
     i30 = HEAP32[i30 + 4 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i3 + 4 >> 2] = i26;
     HEAP32[i3 + 8 >> 2] = i27;
     HEAPF32[i3 + 12 >> 2] = f5;
     HEAP32[i3 + 16 >> 2] = i28;
     HEAP32[i3 + 20 >> 2] = i31;
     i31 = i3 + 24 | 0;
     HEAP32[i31 >> 2] = i29;
     HEAP32[i31 + 4 >> 2] = i30;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR11NodeXSorterP16HeightMeshBVNodeEEbT0_S5_T_(i1, i6, i23) | 0;
    i3 = i6 + 32 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR11NodeXSorterP16HeightMeshBVNodeEEbT0_S5_T_(i3, i24, i23) | 0) {
     i22 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i31 = i6;
   if ((i31 - i11 | 0) >= (i12 - i31 | 0)) {
    i22 = 50;
    break;
   }
   __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_(i1, i6, i23);
   i1 = i6 + 32 | 0;
  }
  if ((i22 | 0) == 50) {
   i22 = 0;
   __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_(i6 + 32 | 0, i24, i23);
   i24 = i6;
   continue;
  } else if ((i22 | 0) == 51) {
   i22 = 0;
   if (i2) {
    i22 = 52;
    break;
   } else {
    i24 = i6;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  f25 = Math_fround(HEAPF32[i21 >> 2]);
  f25 = Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  if (!(f25 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i26 = HEAP32[i1 + 4 >> 2] | 0;
  i27 = HEAP32[i1 + 8 >> 2] | 0;
  i28 = HEAP32[i1 + 16 >> 2] | 0;
  i31 = HEAP32[i1 + 20 >> 2] | 0;
  i30 = i1 + 24 | 0;
  i29 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i30 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i15 >> 2] = i26;
  HEAP32[i16 >> 2] = i27;
  HEAPF32[i17 >> 2] = f5;
  HEAP32[i18 >> 2] = i28;
  HEAP32[i19 >> 2] = i31;
  i31 = i20;
  HEAP32[i31 >> 2] = i29;
  HEAP32[i31 + 4 >> 2] = i30;
  return;
 } else if ((i22 | 0) == 7) {
  __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 8) {
  __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 9) {
  __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 32 | 0, i1 + 64 | 0, i1 + 96 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 11) {
  i3 = i1 + 64 | 0;
  __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 32 | 0, i3, i23) | 0;
  i2 = i1 + 96 | 0;
  if ((i2 | 0) == (i24 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   if (f4 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + 12 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 + 4 >> 2] | 0;
    i9 = HEAP32[i2 + 8 >> 2] | 0;
    i10 = HEAP32[i2 + 16 >> 2] | 0;
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    i13 = i2 + 24 | 0;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i6 = i3 + -32 | 0;
     f25 = Math_fround(HEAPF32[i6 >> 2]);
     if (f4 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -20 >> 2])) * Math_fround(.5))) {
      i31 = i3;
      i3 = i6;
      i6 = i31;
     } else break;
    }
    HEAPF32[i3 >> 2] = f5;
    HEAP32[i3 + 4 >> 2] = i8;
    HEAP32[i3 + 8 >> 2] = i9;
    HEAPF32[i3 + 12 >> 2] = f7;
    HEAP32[i3 + 16 >> 2] = i10;
    HEAP32[i3 + 20 >> 2] = i11;
    i31 = i3 + 24 | 0;
    HEAP32[i31 >> 2] = i12;
    HEAP32[i31 + 4 >> 2] = i13;
   }
   i3 = i2 + 32 | 0;
   if ((i3 | 0) == (i24 | 0)) break; else {
    i31 = i2;
    i2 = i3;
    i3 = i31;
   }
  }
  return;
 } else if ((i22 | 0) == 52) return;
}

function __ZN4Mesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i7 = i19 + 368 | 0;
 i8 = i19 + 264 | 0;
 i9 = i19 + 248 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i16, i17);
 i12 = i16 + 32 | 0;
 if ((HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i12 >> 2] | 0);
  i2 = HEAP32[i12 >> 2] | 0;
  i15 = i2 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i12 >> 2] = i1;
 }
 i13 = i16 + 44 | 0;
 i11 = (HEAP8[i13 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i16, 1);
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 128 | 0;
 i14 = i17 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i15 = i17 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
  i1 = HEAP32[i18 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i3 + 132 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN7SubMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i17);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i16 + 72 | 0, i17);
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = i4 + 144 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
  i1 = HEAP32[i18 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = i17 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i4 + 148 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy(i3, i1, i18, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i4 + 156 >> 2] | 0;
 i2 = i1 + (i6 << 6) | 0;
 if (i6 | 0) do {
  __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i17);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i17, i16 + 144 | 0, 0);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 HEAP32[i16 + 184 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i16 + 40 | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 1);
  i1 = HEAP8[i18 >> 0] | 0;
 } else {
  i6 = HEAP8[i2 >> 0] | 0;
  HEAP8[i18 >> 0] = i6;
  HEAP32[i14 >> 2] = i1;
  i1 = i6;
 }
 HEAP8[i4 >> 0] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 1);
  i1 = HEAP8[i18 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i18 >> 0] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 HEAP8[i16 + 41 >> 0] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 1);
  i1 = HEAP8[i18 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i18 >> 0] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 HEAP8[i16 + 42 >> 0] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 1);
  i1 = HEAP8[i18 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i18 >> 0] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 HEAP8[i16 + 43 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i17);
 if (!(HEAP8[i4 >> 0] | 0)) i10 = 34; else if (!(HEAP32[i17 >> 2] & 16384)) {
  HEAP32[i7 >> 2] = 0;
  i3 = i7 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i7 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i7 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
  i2 = i18;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i5;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i1;
  __ZN14VertexDataInfoC2Ev(i8);
  HEAP32[i9 >> 2] = 0;
  i6 = i9 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_PKc17TransferMetaFlags(i17, i9, gb + 425870 | 0, 1);
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
   i1 = HEAP32[i18 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i14 >> 2] = i2;
  }
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   i21 = i17 + 8 | 0;
   i20 = HEAP32[i21 + 4 >> 2] | 0;
   i2 = i5;
   HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i2 + 4 >> 2] = i20;
  };
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i18 + 16 >> 2] = 0;
  HEAP32[i18 + 20 >> 2] = 0;
  HEAP32[i18 + 24 >> 2] = 0;
  HEAP32[i18 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i7, i1, i18, 1);
  i1 = HEAP32[i7 >> 2] | 0;
  i21 = HEAP32[i3 >> 2] | 0;
  i2 = i1 + (i21 << 5) | 0;
  if (i21 | 0) do {
   __ZN13BoneInfluence8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i17);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZN10VertexData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i17);
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i1;
   i21 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i18 >> 2] = 14;
   HEAP32[i18 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
  }
  __ZN10VertexDataD2Ev(i8);
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i5);
   HEAP32[i7 >> 2] = 0;
  }
  i1 = 1;
 } else i10 = 34;
 if ((i10 | 0) == 34) {
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_PKc17TransferMetaFlags(i17, (HEAP32[i12 >> 2] | 0) + 112 | 0, gb + 425870 | 0, 1);
  i4 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i4 + 112 >> 2] | 0;
  i3 = ((HEAP32[i4 + 116 >> 2] | 0) - i1 | 0) >>> 1;
  if (i3 | 0) {
   i2 = 0;
   while (1) {
    HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
   }
  }
  i3 = i4 + 164 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
   i1 = HEAP32[i18 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i14 >> 2] = i2;
  }
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i10 = i17 + 8 | 0;
   i20 = HEAP32[i10 + 4 >> 2] | 0;
   i21 = i4 + 168 | 0;
   HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
  };
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i18 + 16 >> 2] = 0;
  HEAP32[i18 + 20 >> 2] = 0;
  HEAP32[i18 + 24 >> 2] = 0;
  HEAP32[i18 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i3, i1, i18, 1);
  i1 = HEAP32[i3 >> 2] | 0;
  i21 = HEAP32[i4 + 176 >> 2] | 0;
  i2 = i1 + (i21 << 5) | 0;
  if (i21 | 0) do {
   __ZN13BoneInfluence8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i17);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZN10VertexData8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP32[i12 >> 2] | 0) + 8 | 0, i17);
  __ZN10VertexData13SwapEndianessEv((HEAP32[i12 >> 2] | 0) + 8 | 0);
  i1 = 0;
 }
 i3 = i18 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP8[i18 + 12 >> 0] = 0;
 i4 = i18 + 44 | 0;
 i5 = i18 + 72 | 0;
 i6 = i18 + 92 | 0;
 i7 = i18 + 120 | 0;
 i8 = i18 + 140 | 0;
 i9 = i18 + 168 | 0;
 i10 = i18 + 188 | 0;
 i20 = i18 + 208 | 0;
 i21 = i18 + 228 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP8[i3 + 24 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i5 + 16 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP8[i6 + 24 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP8[i8 + 24 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i10 + 16 >> 0] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP8[i20 + 16 >> 0] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i17);
 __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i18, i17);
 if (i1) __ZN14CompressedMesh10DecompressER4Mesh(i18, i16);
 __ZN14CompressedMeshD2Ev(i18);
 if (!i11) {
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = i4 + 8 | 0;
  i2 = HEAP16[i4 + 18 >> 1] | 0;
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i6 = 0;
   i8 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i6 = 0;
    i8 = 1;
   } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i6 = 0;
    i8 = 1;
   } else {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i6 = i1 + ((i2 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i8 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i2 = i2 >>> 16 & 65535;
   }
  }
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) i7 = 0; else {
   i1 = HEAP32[i4 + 100 >> 2] | 0;
   i3 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i3) i7 = 0; else if (!(HEAP8[i4 + 19 >> 0] | 0)) i7 = 0; else {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i7 = i3 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + (i2 >>> 8 & 255)) | 0;
    i2 = i2 >>> 16 & 65535;
   }
  }
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i1 = 0;
   i5 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i5 = 1;
   } else {
    if (!(HEAP8[i4 + 19 >> 0] | 0)) {
     i1 = 0;
     i5 = 1;
     break;
    }
    i21 = HEAP16[i4 + 16 >> 1] | 0;
    i1 = i1 + (((i21 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i21 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  } while (0);
  if ((i6 | 0) != (i7 | 0)) {
   i4 = i1;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
    i1 = i3 + i8 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  }
  HEAP8[i13 >> 0] = HEAP8[i13 >> 0] | 16;
 }
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i16 + 48 | 0, gb + 1034411 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i17, i16 + 60 | 0, gb + 1034420 | 0, 0);
 i1 = i16 + 224 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i18, 4);
  i21 = HEAP32[i18 >> 2] | 0;
  i21 = _llvm_bswap_i32(i21 | 0) | 0;
  HEAP32[i1 >> 2] = i21;
  i21 = i16 + 204 | 0;
  __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_R4Mesh(i21, i17, i16);
  STACKTOP = i19;
  return;
 } else {
  i21 = HEAP32[i2 >> 2] | 0;
  HEAP32[i18 >> 2] = i21;
  HEAP32[i14 >> 2] = i3;
  i21 = _llvm_bswap_i32(i21 | 0) | 0;
  HEAP32[i1 >> 2] = i21;
  i21 = i16 + 204 | 0;
  __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_R4Mesh(i21, i17, i16);
  STACKTOP = i19;
  return;
 }
}

function __ZN18AssetBundleManager17UnloadAssetBundleEP11AssetBundle(i3, i55) {
 i3 = i3 | 0;
 i55 = i55 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i63 + 60 | 0;
 i61 = i63 + 48 | 0;
 i56 = i63 + 32 | 0;
 i57 = i63 + 16 | 0;
 i58 = i63;
 if (!i55) {
  STACKTOP = i63;
  return;
 }
 HEAP32[i61 >> 2] = 0;
 i62 = i61 + 4 | 0;
 HEAP32[i62 >> 2] = 0;
 HEAP32[i61 + 8 >> 2] = 0;
 __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i55, i61);
 if (!(HEAP8[i55 + 184 >> 0] | 0)) __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E9erase_oneIS2_EEjRKT_(i3, i55 + 168 | 0) | 0;
 i2 = HEAP32[i62 >> 2] | 0;
 i54 = HEAP32[i61 >> 2] | 0;
 i1 = i54;
 if ((i2 | 0) != (i54 | 0)) {
  i14 = i56 + 12 | 0;
  i12 = i56 + 12 | 0;
  i15 = i60 + 4 | 0;
  i16 = i56 + 8 | 0;
  i17 = i56 + 4 | 0;
  i18 = i3 + 68 | 0;
  i19 = i3 + 128 | 0;
  i20 = i3 + 72 | 0;
  i21 = i3 + 120 | 0;
  i22 = i3 + 124 | 0;
  i23 = i56 + 11 | 0;
  i24 = i60 + 4 | 0;
  i25 = i57 + 11 | 0;
  i26 = i57 + 4 | 0;
  i27 = i56 + 12 | 0;
  i11 = i56 + 12 | 0;
  i28 = i60 + 4 | 0;
  i29 = i56 + 8 | 0;
  i30 = i56 + 4 | 0;
  i31 = i56 + 11 | 0;
  i32 = i57 + 12 | 0;
  i13 = i57 + 12 | 0;
  i33 = i60 + 4 | 0;
  i34 = i57 + 8 | 0;
  i35 = i57 + 4 | 0;
  i36 = i3 + 144 | 0;
  i37 = i3 + 204 | 0;
  i38 = i3 + 148 | 0;
  i39 = i3 + 196 | 0;
  i40 = i3 + 200 | 0;
  i41 = i57 + 11 | 0;
  i42 = i60 + 4 | 0;
  i43 = i60 + 4 | 0;
  i44 = i3 + 152 | 0;
  i45 = i3 + 156 | 0;
  i46 = i3 + 216 | 0;
  i47 = i3 + 156 | 0;
  i48 = i47 + 11 | 0;
  i49 = i3 + 160 | 0;
  i50 = i3 + 76 | 0;
  i51 = i3 + 80 | 0;
  i52 = i3 + 140 | 0;
  i53 = i3 + 80 | 0;
  i54 = i53 + 11 | 0;
  i10 = i3 + 84 | 0;
  i9 = 0;
  do {
   i1 = i1 + (i9 << 4) | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i56 >> 2] = 0;
   HEAP32[i56 + 4 >> 2] = 0;
   HEAP32[i56 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i14 >> 2] = i2;
   i3 = _strlen(i1) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i56);
    i2 = HEAP32[i12 >> 2] | 0;
    i59 = 21;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i23 >> 0] = i3;
    if (!i3) i1 = i56; else {
     i2 = i56;
     i59 = 23;
    }
   } else i59 = 21;
   if ((i59 | 0) == 21) {
    i8 = i3 + 16 & -16;
    HEAP32[i60 >> 2] = 54;
    HEAP32[i15 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i60, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i56 >> 2] = i2;
    HEAP32[i16 >> 2] = i8 | -2147483648;
    HEAP32[i17 >> 2] = i3;
    i59 = 23;
   }
   if ((i59 | 0) == 23) {
    i59 = 0;
    _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
    i1 = i2;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   if ((HEAP32[i19 >> 2] | 0) == (HEAP32[i20 >> 2] | 0)) {
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    i8 = i2 + (i1 * 20 | 0) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i60, i18, i56);
    i8 = HEAP32[i60 >> 2] | 0;
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    i8 = (i8 | 0) == -1 ? i2 + (i1 * 20 | 0) | 0 : i2 + (i8 * 20 | 0) | 0;
   }
   if ((HEAP8[i23 >> 0] | 0) < 0) {
    i2 = HEAP32[i56 >> 2] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    HEAP32[i60 >> 2] = 54;
    HEAP32[i24 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i60);
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i22 >> 2] | 0;
   }
   L31 : do if ((i8 | 0) != (i2 + (i1 * 20 | 0) | 0)) if ((HEAP32[i8 + 16 >> 2] | 0) == (i55 | 0)) {
    L34 : do if (!(HEAP8[i50 >> 0] | 0)) i59 = 40; else if (!(HEAP32[i20 >> 2] | 0)) i59 = 40; else {
     i2 = HEAP8[i54 >> 0] | 0;
     i4 = i2 << 24 >> 24 < 0;
     i2 = i2 & 255;
     i5 = i4 ? HEAP32[i10 >> 2] | 0 : i2;
     i7 = HEAP8[i8 + 11 >> 0] | 0;
     i1 = i7 << 24 >> 24 < 0;
     if ((i5 | 0) == ((i1 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255) | 0)) {
      i6 = HEAP32[i53 >> 2] | 0;
      i7 = i4 ? i6 : i53;
      i1 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
      i3 = (i5 | 0) == 0;
      L38 : do if (i4) {
       if (!i3) {
        i7 = (_memcmp(i7, i1, i5) | 0) == 0;
        __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i18, i8, i51);
        if (i7) break L31; else break L34;
       }
      } else if (!i3) {
       if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i3 = i53; else {
        i59 = 40;
        break L34;
       }
       while (1) {
        i2 = i2 + -1 | 0;
        i3 = i3 + 1 | 0;
        if (!i2) break L38;
        i1 = i1 + 1 | 0;
        if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
         i59 = 40;
         break L34;
        }
       }
      } while (0);
      __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i18, i8, i51);
      break L31;
     } else i59 = 40;
    } while (0);
    if ((i59 | 0) == 40) {
     i59 = 0;
     __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i18, i8, i51);
    }
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
    HEAP8[i52 >> 0] = 1;
   } while (0);
   i2 = HEAP32[i61 >> 2] | 0;
   i1 = i2 + (i9 << 4) | 0;
   i3 = HEAP8[i1 + 11 >> 0] | 0;
   if (i3 << 24 >> 24 < 0) {
    i4 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i2 + (i9 << 4) + 4 >> 2] | 0;
   } else {
    i4 = i1;
    i1 = i3 & 255;
   };
   HEAP32[i58 >> 2] = 0;
   HEAP32[i58 + 4 >> 2] = 0;
   HEAP32[i58 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i58, i4, i1);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i60, i58);
   __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i57, i60);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i60);
   i3 = HEAP8[i25 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i57 >> 2] | 0 : i57;
   i3 = i1 ? HEAP32[i26 >> 2] | 0 : i3 & 255;
   HEAP32[i56 >> 2] = 0;
   HEAP32[i56 + 4 >> 2] = 0;
   HEAP32[i56 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i27 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i56);
    i1 = HEAP32[i11 >> 2] | 0;
    i59 = 50;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i31 >> 0] = i3;
    if (!i3) i1 = i56; else {
     i1 = i56;
     i59 = 52;
    }
   } else i59 = 50;
   if ((i59 | 0) == 50) {
    i8 = i3 + 16 & -16;
    HEAP32[i60 >> 2] = 66;
    HEAP32[i28 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i60, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i56 >> 2] = i1;
    HEAP32[i29 >> 2] = i8 | -2147483648;
    HEAP32[i30 >> 2] = i3;
    i59 = 52;
   }
   if ((i59 | 0) == 52) {
    i59 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i57);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i58);
   i2 = (HEAP8[i31 >> 0] | 0) < 0 ? HEAP32[i56 >> 2] | 0 : i56;
   HEAP32[i57 >> 2] = 0;
   HEAP32[i57 + 4 >> 2] = 0;
   HEAP32[i57 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i32 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i57);
    i1 = HEAP32[i13 >> 2] | 0;
    i59 = 56;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i41 >> 0] = i3;
    if (!i3) i1 = i57; else {
     i1 = i57;
     i59 = 58;
    }
   } else i59 = 56;
   if ((i59 | 0) == 56) {
    i8 = i3 + 16 & -16;
    HEAP32[i60 >> 2] = 54;
    HEAP32[i33 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i60, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i57 >> 2] = i1;
    HEAP32[i34 >> 2] = i8 | -2147483648;
    HEAP32[i35 >> 2] = i3;
    i59 = 58;
   }
   if ((i59 | 0) == 58) {
    i59 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   if ((HEAP32[i37 >> 2] | 0) == (HEAP32[i38 >> 2] | 0)) {
    i2 = HEAP32[i39 >> 2] | 0;
    i1 = HEAP32[i40 >> 2] | 0;
    i8 = i2 + (i1 * 20 | 0) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i60, i36, i57);
    i8 = HEAP32[i60 >> 2] | 0;
    i2 = HEAP32[i39 >> 2] | 0;
    i1 = HEAP32[i40 >> 2] | 0;
    i8 = (i8 | 0) == -1 ? i2 + (i1 * 20 | 0) | 0 : i2 + (i8 * 20 | 0) | 0;
   }
   if ((HEAP8[i41 >> 0] | 0) < 0) {
    i2 = HEAP32[i57 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    HEAP32[i60 >> 2] = 54;
    HEAP32[i42 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i60);
    i2 = HEAP32[i39 >> 2] | 0;
    i1 = HEAP32[i40 >> 2] | 0;
   }
   L80 : do if ((i8 | 0) != (i2 + (i1 * 20 | 0) | 0)) if ((HEAP32[i8 + 16 >> 2] | 0) == (i55 | 0)) {
    L83 : do if (!(HEAP8[i44 >> 0] | 0)) i59 = 75; else {
     if (!(HEAP32[i38 >> 2] | 0)) {
      i59 = 75;
      break;
     }
     i2 = HEAP8[i48 >> 0] | 0;
     i4 = i2 << 24 >> 24 < 0;
     i2 = i2 & 255;
     i5 = i4 ? HEAP32[i49 >> 2] | 0 : i2;
     i7 = HEAP8[i8 + 11 >> 0] | 0;
     i1 = i7 << 24 >> 24 < 0;
     if ((i5 | 0) != ((i1 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255) | 0)) {
      i59 = 75;
      break;
     }
     i6 = HEAP32[i47 >> 2] | 0;
     i7 = i4 ? i6 : i47;
     i1 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
     i3 = (i5 | 0) == 0;
     L87 : do if (i4) {
      if (i3) break;
      i7 = (_memcmp(i7, i1, i5) | 0) == 0;
      __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i36, i8, i45);
      if (i7) break L80; else break L83;
     } else {
      if (i3) break;
      if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i3 = i47; else {
       i59 = 75;
       break L83;
      }
      while (1) {
       i2 = i2 + -1 | 0;
       i3 = i3 + 1 | 0;
       if (!i2) break L87;
       i1 = i1 + 1 | 0;
       if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
        i59 = 75;
        break L83;
       }
      }
     } while (0);
     __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i36, i8, i45);
     break L80;
    } while (0);
    if ((i59 | 0) == 75) {
     i59 = 0;
     __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i36, i8, i45);
    }
    HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + 1;
    HEAP8[i46 >> 0] = 1;
   } while (0);
   if ((HEAP8[i31 >> 0] | 0) < 0) {
    i8 = HEAP32[i56 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    HEAP32[i60 >> 2] = 66;
    HEAP32[i43 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i60);
   }
   i9 = i9 + 1 | 0;
   i2 = HEAP32[i62 >> 2] | 0;
   i8 = HEAP32[i61 >> 2] | 0;
   i1 = i8;
  } while (i9 >>> 0 < i2 - i8 >> 4 >>> 0);
 }
 if (i1 | 0) {
  if ((i2 | 0) != (i1 | 0)) {
   i4 = i60 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i62 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i59 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i60 >> 2] = 66;
     HEAP32[i4 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i59, i60);
     i2 = HEAP32[i62 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i61 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i63;
 return;
}

function __Z20sweepConvex_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i27, i30, i28, i29, i36, f2, i35, i20, f3) {
 i27 = i27 | 0;
 i30 = i30 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i36 = i36 | 0;
 f2 = Math_fround(f2);
 i35 = i35 | 0;
 i20 = i20 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i37 + 816 | 0;
 i31 = i37 + 744 | 0;
 i18 = i37 + 720 | 0;
 i21 = i37 + 660 | 0;
 i1 = i37 + 552 | 0;
 i6 = i37 + 504 | 0;
 i32 = i37 + 600 | 0;
 i19 = i37 + 488 | 0;
 i34 = i37;
 i23 = i37 + 476 | 0;
 i24 = i37 + 888 | 0;
 i33 = i37 + 464 | 0;
 i16 = HEAP32[i28 + 32 >> 2] | 0;
 i25 = i16 + 16 | 0;
 i26 = HEAP32[i27 + 36 >> 2] | 0;
 i22 = i28 + 4 | 0;
 if (Math_fround(HEAPF32[i22 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i28 + 8 >> 2]) == Math_fround(1.0)) i15 = Math_fround(HEAPF32[i28 + 12 >> 2]) == Math_fround(1.0); else i15 = 0; else i15 = 0;
 i7 = i27 + 4 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i27 + 8 >> 2]) == Math_fround(1.0)) i8 = Math_fround(HEAPF32[i27 + 12 >> 2]) == Math_fround(1.0); else i8 = 0; else i8 = 0;
 HEAP32[i17 >> 2] = 1065353216;
 i9 = i17 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i17 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 i11 = i17 + 16 | 0;
 HEAP32[i11 >> 2] = 1065353216;
 i12 = i17 + 20 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 i13 = i17 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i17 + 32 | 0;
 HEAP32[i14 >> 2] = 1065353216;
 HEAP32[i17 + 36 >> 2] = 1065353216;
 HEAP32[i17 + 40 >> 2] = 0;
 HEAP32[i17 + 44 >> 2] = 0;
 HEAP32[i17 + 48 >> 2] = 0;
 HEAP32[i17 + 52 >> 2] = 1065353216;
 HEAP32[i17 + 56 >> 2] = 0;
 HEAP32[i17 + 60 >> 2] = 0;
 HEAP32[i17 + 64 >> 2] = 0;
 HEAP32[i17 + 68 >> 2] = 1065353216;
 if (!i15) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i17, i22, i28 + 16 | 0);
 HEAP32[i31 >> 2] = 1065353216;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAP32[i31 + 16 >> 2] = 1065353216;
 HEAP32[i31 + 20 >> 2] = 0;
 HEAP32[i31 + 24 >> 2] = 0;
 HEAP32[i31 + 28 >> 2] = 0;
 HEAP32[i31 + 32 >> 2] = 1065353216;
 HEAP32[i31 + 36 >> 2] = 1065353216;
 HEAP32[i31 + 40 >> 2] = 0;
 HEAP32[i31 + 44 >> 2] = 0;
 HEAP32[i31 + 48 >> 2] = 0;
 HEAP32[i31 + 52 >> 2] = 1065353216;
 HEAP32[i31 + 56 >> 2] = 0;
 HEAP32[i31 + 60 >> 2] = 0;
 HEAP32[i31 + 64 >> 2] = 0;
 HEAP32[i31 + 68 >> 2] = 1065353216;
 if (!i8) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i31, i7, i27 + 16 | 0);
 f38 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f53 = Math_fround(HEAPF32[i16 + 28 >> 2]);
 f40 = Math_fround(f38 + f53);
 f44 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f52 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f54 = Math_fround(f44 + f52);
 f5 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f51 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f40 = Math_fround(f40 * Math_fround(.5));
 f54 = Math_fround(f54 * Math_fround(.5));
 f42 = Math_fround(Math_fround(f5 + f51) * Math_fround(.5));
 f50 = Math_fround(HEAPF32[i17 >> 2]);
 f39 = Math_fround(f40 * f50);
 f48 = Math_fround(HEAPF32[i9 >> 2]);
 f41 = Math_fround(f40 * f48);
 f43 = Math_fround(HEAPF32[i10 >> 2]);
 f40 = Math_fround(f40 * f43);
 f49 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f56 = Math_fround(f54 * f49);
 f47 = Math_fround(HEAPF32[i11 >> 2]);
 f55 = Math_fround(f54 * f47);
 f46 = Math_fround(HEAPF32[i12 >> 2]);
 f56 = Math_fround(f39 + f56);
 f55 = Math_fround(f41 + f55);
 f54 = Math_fround(f40 + Math_fround(f54 * f46));
 f40 = Math_fround(HEAPF32[i17 + 24 >> 2]);
 f41 = Math_fround(f42 * f40);
 f39 = Math_fround(HEAPF32[i13 >> 2]);
 f4 = Math_fround(f42 * f39);
 f45 = Math_fround(HEAPF32[i14 >> 2]);
 f41 = Math_fround(f56 + f41);
 f4 = Math_fround(f55 + f4);
 f42 = Math_fround(f54 + Math_fround(f42 * f45));
 f38 = Math_fround(Math_fround(f53 - f38) * Math_fround(.5));
 f44 = Math_fround(Math_fround(f52 - f44) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f51 - f5) * Math_fround(.5));
 f40 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f38 * f50))) + Math_fround(Math_abs(Math_fround(f44 * f49)))) + Math_fround(Math_abs(Math_fround(f5 * f40))));
 f39 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f38 * f48))) + Math_fround(Math_abs(Math_fround(f44 * f47)))) + Math_fround(Math_abs(Math_fround(f5 * f39))));
 f45 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f38 * f43))) + Math_fround(Math_abs(Math_fround(f44 * f46)))) + Math_fround(Math_abs(Math_fround(f5 * f45))));
 f5 = Math_fround(f4 - f39);
 f46 = Math_fround(f42 - f45);
 f44 = Math_fround(f41 + f40);
 f39 = Math_fround(f4 + f39);
 f45 = Math_fround(f42 + f45);
 HEAPF32[i18 >> 2] = Math_fround(f41 - f40);
 HEAPF32[i18 + 4 >> 2] = f5;
 HEAPF32[i18 + 8 >> 2] = f46;
 HEAPF32[i18 + 12 >> 2] = f44;
 HEAPF32[i18 + 16 >> 2] = f39;
 HEAPF32[i18 + 20 >> 2] = f45;
 f45 = Math_fround(HEAPF32[i29 >> 2]);
 f39 = Math_fround(f45 + f45);
 f44 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f46 = Math_fround(f44 + f44);
 f5 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 f40 = Math_fround(f5 + f5);
 f41 = Math_fround(HEAPF32[i29 + 12 >> 2]);
 f42 = Math_fround(f39 * f41);
 f4 = Math_fround(f46 * f41);
 f41 = Math_fround(f41 * f40);
 f39 = Math_fround(f45 * f39);
 f43 = Math_fround(f45 * f46);
 f45 = Math_fround(f45 * f40);
 f46 = Math_fround(f44 * f46);
 f44 = Math_fround(f44 * f40);
 f40 = Math_fround(f5 * f40);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f46) - f40);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f43 + f41);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f45 - f4);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f43 - f41);
 f39 = Math_fround(Math_fround(1.0) - f39);
 HEAPF32[i1 + 16 >> 2] = Math_fround(f39 - f40);
 HEAPF32[i1 + 20 >> 2] = Math_fround(f44 + f42);
 HEAPF32[i1 + 24 >> 2] = Math_fround(f45 + f4);
 HEAPF32[i1 + 28 >> 2] = Math_fround(f44 - f42);
 HEAPF32[i1 + 32 >> 2] = Math_fround(f39 - f46);
 HEAP32[i1 + 36 >> 2] = HEAP32[i29 + 16 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i29 + 20 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i29 + 24 >> 2];
 f46 = Math_fround(HEAPF32[i30 >> 2]);
 f39 = Math_fround(f46 + f46);
 i16 = i30 + 4 | 0;
 f42 = Math_fround(HEAPF32[i16 >> 2]);
 f44 = Math_fround(f42 + f42);
 i17 = i30 + 8 | 0;
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 f45 = Math_fround(f4 + f4);
 i15 = i30 + 12 | 0;
 f40 = Math_fround(HEAPF32[i15 >> 2]);
 f41 = Math_fround(f39 * f40);
 f43 = Math_fround(f44 * f40);
 f40 = Math_fround(f40 * f45);
 f39 = Math_fround(f46 * f39);
 f5 = Math_fround(f46 * f44);
 f46 = Math_fround(f46 * f45);
 f44 = Math_fround(f42 * f44);
 f42 = Math_fround(f42 * f45);
 f45 = Math_fround(f4 * f45);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f44) - f45);
 HEAPF32[i6 + 4 >> 2] = Math_fround(f5 + f40);
 HEAPF32[i6 + 8 >> 2] = Math_fround(f46 - f43);
 HEAPF32[i6 + 12 >> 2] = Math_fround(f5 - f40);
 f39 = Math_fround(Math_fround(1.0) - f39);
 HEAPF32[i6 + 16 >> 2] = Math_fround(f39 - f45);
 HEAPF32[i6 + 20 >> 2] = Math_fround(f42 + f41);
 HEAPF32[i6 + 24 >> 2] = Math_fround(f46 + f43);
 HEAPF32[i6 + 28 >> 2] = Math_fround(f42 - f41);
 HEAPF32[i6 + 32 >> 2] = Math_fround(f39 - f44);
 HEAP32[i6 + 36 >> 2] = HEAP32[i30 + 16 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i30 + 20 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i30 + 24 >> 2];
 __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb(i21, i18, Math_fround(0.0), i29, i1, i6, i31, i8);
 i1 = i21 + 48 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f3);
 i9 = i21 + 52 | 0;
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f3);
 i9 = i21 + 56 | 0;
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f3);
 f44 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(2.0));
 i9 = i36 + 4 | 0;
 f39 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
 i10 = i36 + 8 | 0;
 f41 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
 f42 = Math_fround(HEAPF32[i15 >> 2]);
 f43 = Math_fround(Math_fround(f42 * f42) + Math_fround(-.5));
 f46 = Math_fround(HEAPF32[i30 >> 2]);
 f45 = Math_fround(f44 * f46);
 f40 = Math_fround(HEAPF32[i16 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f39 * f40));
 f5 = Math_fround(HEAPF32[i17 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f41 * f5));
 f4 = Math_fround(Math_fround(f40 * f45) + Math_fround(Math_fround(f39 * f43) - Math_fround(f42 * Math_fround(Math_fround(f44 * f5) - Math_fround(f41 * f46)))));
 f38 = Math_fround(Math_fround(Math_fround(f41 * f43) - Math_fround(f42 * Math_fround(Math_fround(f39 * f46) - Math_fround(f44 * f40)))) + Math_fround(f5 * f45));
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(f46 * f45) + Math_fround(Math_fround(f44 * f43) - Math_fround(f42 * Math_fround(Math_fround(f41 * f40) - Math_fround(f39 * f5)))));
 HEAPF32[i19 + 4 >> 2] = f4;
 HEAPF32[i19 + 8 >> 2] = f38;
 __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i32, i1, i21 + 36 | 0, i21, i19, f2);
 i21 = HEAP16[i20 >> 1] | 0;
 i1 = i21 & 65535;
 i8 = (HEAP8[i27 + 32 >> 0] & 2) != 0 | (i1 & 128 | 0) != 0;
 i1 = (i1 & 512 | 0) == 0;
 f38 = Math_fround(-Math_fround(HEAPF32[i36 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i23 >> 2] = f38;
 HEAPF32[i23 + 4 >> 2] = f4;
 HEAPF32[i23 + 8 >> 2] = f5;
 HEAP16[i24 >> 1] = i21;
 __ZN25ConvexVsMeshSweepCallbackC2ERKN5physx2Gu14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEbfb(i34, i25, i22, i31, i29, i30, i23, f2, i24, i8, f3, (i21 & 64) != 0);
 HEAP32[i33 >> 2] = HEAP32[i26 + 32 >> 2];
 HEAP32[i33 + 4 >> 2] = i26 + 48;
 HEAP32[i33 + 8 >> 2] = HEAP32[i26 + 36 >> 2];
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i32, 1, i33, i34, 1);
 if (!(HEAP8[i34 + 449 >> 0] | 0)) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 if (HEAP8[i34 + 448 >> 0] | 0) {
  do if (i1) {
   HEAP16[i35 + 12 >> 1] = 6;
   HEAPF32[i35 + 40 >> 2] = Math_fround(0.0);
   f54 = Math_fround(-Math_fround(HEAPF32[i36 >> 2]));
   f55 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
   f56 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
   HEAPF32[i35 + 28 >> 2] = f54;
   HEAPF32[i35 + 32 >> 2] = f55;
   HEAPF32[i35 + 36 >> 2] = f56;
  } else {
   i33 = __ZN5physx2Gu29computeConvex_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbRNS_10PxSweepHitE(i27, i30, i28, i29, f3, f2, i8, i35) | 0;
   i1 = i35 + 12 | 0;
   HEAP16[i1 >> 1] = 6;
   if (i33) {
    HEAP16[i1 >> 1] = 7;
    break;
   } else {
    HEAPF32[i35 + 40 >> 2] = Math_fround(0.0);
    f54 = Math_fround(-Math_fround(HEAPF32[i36 >> 2]));
    f55 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
    f56 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
    HEAPF32[i35 + 28 >> 2] = f54;
    HEAPF32[i35 + 32 >> 2] = f55;
    HEAPF32[i35 + 36 >> 2] = f56;
    break;
   }
  } while (0);
  HEAP32[i35 + 8 >> 2] = HEAP32[i34 + 332 >> 2];
  i36 = 1;
  STACKTOP = i37;
  return i36 | 0;
 }
 i6 = i34 + 324 | 0;
 HEAP32[i35 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP16[i35 + 12 >> 1] = HEAP16[i34 + 336 >> 1] | 0;
 HEAP32[i35 + 16 >> 2] = HEAP32[i34 + 340 >> 2];
 HEAP32[i35 + 20 >> 2] = HEAP32[i34 + 344 >> 2];
 HEAP32[i35 + 24 >> 2] = HEAP32[i34 + 348 >> 2];
 f56 = Math_fround(HEAPF32[i34 + 352 >> 2]);
 f4 = Math_fround(HEAPF32[i34 + 356 >> 2]);
 i6 = i35 + 32 | 0;
 f55 = Math_fround(HEAPF32[i34 + 360 >> 2]);
 i7 = i35 + 36 | 0;
 HEAP32[i35 + 40 >> 2] = HEAP32[i34 + 364 >> 2];
 HEAP32[i35 + 44 >> 2] = HEAP32[i34 + 368 >> 2];
 i1 = i35 + 28 | 0;
 f3 = Math_fround(-f56);
 f5 = Math_fround(-f4);
 f2 = Math_fround(-f55);
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i6 >> 2] = f5;
 HEAPF32[i7 >> 2] = f2;
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f56 * f56) + Math_fround(f4 * f4)))));
 if (f4 > Math_fround(0.0)) {
  f56 = Math_fround(Math_fround(1.0) / f4);
  f3 = Math_fround(f56 * f3);
  HEAPF32[i1 >> 2] = f3;
  f4 = Math_fround(f56 * f5);
  HEAPF32[i6 >> 2] = f4;
  f2 = Math_fround(f56 * f2);
  HEAPF32[i7 >> 2] = f2;
 } else f4 = f5;
 if (!i8) {
  i36 = 1;
  STACKTOP = i37;
  return i36 | 0;
 }
 f56 = Math_fround(f3 * Math_fround(HEAPF32[i36 >> 2]));
 f56 = Math_fround(f56 + Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2])));
 if (!(Math_fround(f56 + Math_fround(f2 * Math_fround(HEAPF32[i10 >> 2]))) > Math_fround(0.0))) {
  i36 = 1;
  STACKTOP = i37;
  return i36 | 0;
 }
 f55 = Math_fround(-f4);
 f56 = Math_fround(-f2);
 HEAPF32[i1 >> 2] = Math_fround(-f3);
 HEAPF32[i6 >> 2] = f55;
 HEAPF32[i7 >> 2] = f56;
 i36 = 1;
 STACKTOP = i37;
 return i36 | 0;
}

function __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i46, i44, i37, i45, i43, i40, i1) {
 i46 = i46 | 0;
 i44 = i44 | 0;
 i37 = i37 | 0;
 i45 = i45 | 0;
 i43 = i43 | 0;
 i40 = i40 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i42 + 24 | 0;
 i28 = i42 + 152 | 0;
 i31 = i42 + 136 | 0;
 i2 = i42 + 16 | 0;
 i24 = i42 + 8 | 0;
 i25 = i42;
 i41 = i42 + 120 | 0;
 i39 = i42 + 104 | 0;
 i38 = i42 + 72 | 0;
 if (!i40) i1 = 1; else {
  i1 = HEAP32[i43 >> 2] | 0;
  i36 = i40 + 1 | 0;
  i1 = i1 >>> 0 < i36 >>> 0 ? i36 : i1;
 }
 HEAP32[i43 >> 2] = i1;
 HEAP32[i31 >> 2] = 1;
 i29 = i31 + 4 | 0;
 HEAP32[i29 >> 2] = 2;
 i30 = i31 + 8 | 0;
 HEAP32[i30 >> 2] = 3;
 i26 = i31 + 12 | 0;
 HEAP32[i26 >> 2] = 4;
 if (i37 >>> 0 > 3) {
  i23 = i27 + 32 | 0;
  i19 = i27 + 36 | 0;
  i20 = i27 + 40 | 0;
  HEAP32[i20 >> 2] = 0;
  i21 = i27 + 44 | 0;
  HEAP8[i23 >> 0] = 1;
  HEAP32[i19 >> 2] = i27;
  HEAP32[i21 >> 2] = 4;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = i37;
  i18 = i2;
  i16 = HEAP32[i18 + 4 >> 2] | 0;
  i10 = i27;
  HEAP32[i10 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i10 + 4 >> 2] = i16;
  i10 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
  HEAP32[i20 >> 2] = i10;
  i16 = i24 + 4 | 0;
  i18 = i25 + 4 | 0;
  i22 = i46 + 8 | 0;
  i1 = 0;
  while (1) {
   i12 = HEAP32[i19 >> 2] | 0;
   if (!i10) i7 = -1; else {
    i9 = 0;
    f17 = Math_fround(-3402823469999999843913219.0e14);
    i2 = -1;
    while (1) {
     i7 = HEAP32[i12 + (i9 << 3) + 4 >> 2] | 0;
     if ((i7 | 0) == 1) f5 = f17; else {
      i4 = HEAP32[i12 + (i9 << 3) >> 2] | 0;
      i36 = HEAP32[i44 + (i4 << 2) >> 2] | 0;
      i6 = HEAP32[i22 >> 2] | 0;
      f13 = Math_fround(HEAPF32[i6 + (i36 << 5) >> 2]);
      f14 = Math_fround(HEAPF32[i6 + (i36 << 5) + 4 >> 2]);
      f15 = Math_fround(HEAPF32[i6 + (i36 << 5) + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i6 + (i36 << 5) + 16 >> 2]);
      f8 = Math_fround(HEAPF32[i6 + (i36 << 5) + 20 >> 2]);
      f11 = Math_fround(HEAPF32[i6 + (i36 << 5) + 24 >> 2]);
      if (i7 >>> 0 > 1) {
       i3 = 1;
       do {
        i36 = HEAP32[i44 + (i3 + i4 << 2) >> 2] | 0;
        f47 = Math_fround(HEAPF32[i6 + (i36 << 5) >> 2]);
        f48 = Math_fround(HEAPF32[i6 + (i36 << 5) + 4 >> 2]);
        f49 = Math_fround(HEAPF32[i6 + (i36 << 5) + 8 >> 2]);
        f13 = f13 < f47 ? f13 : f47;
        f14 = f14 < f48 ? f14 : f48;
        f15 = f15 < f49 ? f15 : f49;
        f49 = Math_fround(HEAPF32[i6 + (i36 << 5) + 16 >> 2]);
        f48 = Math_fround(HEAPF32[i6 + (i36 << 5) + 20 >> 2]);
        f47 = Math_fround(HEAPF32[i6 + (i36 << 5) + 24 >> 2]);
        f5 = f5 > f49 ? f5 : f49;
        f8 = f8 > f48 ? f8 : f48;
        f11 = f11 > f47 ? f11 : f47;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      f49 = Math_fround(f5 - f13);
      f48 = Math_fround(f8 - f14);
      f5 = Math_fround(f11 - f15);
      f5 = Math_fround(Math_fround(i7 >>> 0) * Math_fround(Math_fround(f48 * f5) + Math_fround(Math_fround(f49 * f48) + Math_fround(f49 * f5))));
      if (f5 > f17) i2 = i9; else f5 = f17;
     }
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= i10 >>> 0) {
      i7 = i2;
      break;
     } else f17 = f5;
    }
   }
   i3 = HEAP32[i12 + (i7 << 3) >> 2] | 0;
   i4 = HEAP32[i12 + (i7 << 3) + 4 >> 2] | 0;
   i6 = __ZN5physx10SubSortSAH5splitEPjj(i46, i44 + (i3 << 2) | 0, i4) | 0;
   HEAP32[i24 >> 2] = i3;
   HEAP32[i16 >> 2] = i6;
   i2 = HEAP32[i20 >> 2] | 0;
   if ((HEAP32[i21 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i35 = i24;
    i36 = HEAP32[i35 + 4 >> 2] | 0;
    i2 = (HEAP32[i19 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i2 + 4 >> 2] = i36;
    i2 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
    HEAP32[i20 >> 2] = i2;
   } else {
    __ZN5physx6shdfnd5ArrayINS_8IntervalENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i27, i24) | 0;
    i2 = HEAP32[i20 >> 2] | 0;
   }
   i3 = i6 + i3 | 0;
   HEAP32[i25 >> 2] = i3;
   HEAP32[i18 >> 2] = i4 - i6;
   if ((HEAP32[i21 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i35 = i25;
    i36 = HEAP32[i35 + 4 >> 2] | 0;
    i2 = (HEAP32[i19 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i2 + 4 >> 2] = i36;
    i2 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
    HEAP32[i20 >> 2] = i2;
   } else {
    __ZN5physx6shdfnd5ArrayINS_8IntervalENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i27, i25) | 0;
    i2 = HEAP32[i20 >> 2] | 0;
   }
   i36 = HEAP32[i19 >> 2] | 0;
   i34 = i2 + -1 | 0;
   HEAP32[i20 >> 2] = i34;
   i34 = i36 + (i34 << 3) | 0;
   i35 = HEAP32[i34 + 4 >> 2] | 0;
   i36 = i36 + (i7 << 3) | 0;
   HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i36 + 4 >> 2] = i35;
   HEAP32[i31 + (i1 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 3) break;
   i10 = HEAP32[i20 >> 2] | 0;
  }
  i36 = HEAP32[i21 >> 2] | 0;
  do if ((i36 | 0) > -1 & (i36 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i19 >> 2] | 0;
   if ((i27 | 0) == (i1 | 0)) {
    HEAP8[i23 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i36 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 | 0);
   }
  } while (0);
 } else {
  if (i37 >>> 0 < 3) {
   i1 = i37;
   do {
    HEAP32[i31 + (i1 << 2) >> 2] = i37;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 3);
  }
  i22 = i46 + 8 | 0;
 }
 __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i31, 3, i27, i28, 32);
 HEAP32[i26 >> 2] = i37;
 HEAP32[i41 >> 2] = 0;
 i32 = HEAP32[i31 >> 2] | 0;
 HEAP32[i39 >> 2] = i32;
 i34 = i41 + 4 | 0;
 HEAP32[i34 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i18 = HEAP32[i29 >> 2] | 0;
 i31 = i18 - i32 | 0;
 HEAP32[i39 + 4 >> 2] = i31;
 i4 = HEAP32[i30 >> 2] | 0;
 i18 = i4 - i18 | 0;
 i33 = i39 + 8 | 0;
 HEAP32[i33 >> 2] = i18;
 i4 = i37 - i4 | 0;
 i35 = i39 + 12 | 0;
 HEAP32[i35 >> 2] = i4;
 i20 = i46 + 52 | 0;
 i21 = i38 + 4 | 0;
 i23 = i38 + 8 | 0;
 i24 = i38 + 12 | 0;
 i25 = i38 + 16 | 0;
 i26 = i38 + 20 | 0;
 i27 = i38 + 24 | 0;
 i28 = i38 + 28 | 0;
 i29 = i45 + 8 | 0;
 i36 = i45 + 4 | 0;
 i30 = i44;
 i19 = i32;
 i1 = 0;
 i4 = (i32 >>> 0 < 17 ? (HEAP32[gb + 110332 + (HEAP32[i20 >> 2] << 2) >> 2] | 0) >>> 0 >= i37 >>> 0 : 0) & i31 >>> 0 < 17 & i18 >>> 0 < 17 & i4 >>> 0 < 17;
 while (1) {
  HEAP32[i38 >> 2] = 2122317823;
  HEAP32[i21 >> 2] = 2122317823;
  HEAP32[i23 >> 2] = 2122317823;
  HEAP32[i24 >> 2] = -25165825;
  HEAP32[i25 >> 2] = -25165825;
  HEAP32[i26 >> 2] = -25165825;
  HEAP32[i27 >> 2] = -1;
  HEAP32[i28 >> 2] = 0;
  do if (!i19) {
   HEAP32[i38 >> 2] = 2122317823;
   HEAP32[i21 >> 2] = 2122317823;
   HEAP32[i23 >> 2] = 2122317823;
   HEAP32[i24 >> 2] = -25165825;
   HEAP32[i25 >> 2] = -25165825;
   HEAP32[i26 >> 2] = -25165825;
   HEAP32[i27 >> 2] = -1;
   HEAP32[i28 >> 2] = -1;
   i12 = 2122317823;
   i10 = 2122317823;
   i9 = 2122317823;
   i7 = -25165825;
   i6 = -25165825;
   i3 = -25165825;
  } else {
   i18 = HEAP32[i41 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i44 + (i18 << 2) >> 2] | 0;
   i16 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i16 + (i3 << 5) >> 2] | 0;
   i10 = HEAP32[i16 + (i3 << 5) + 4 >> 2] | 0;
   i9 = HEAP32[i16 + (i3 << 5) + 8 >> 2] | 0;
   i7 = HEAP32[i16 + (i3 << 5) + 16 >> 2] | 0;
   i6 = HEAP32[i16 + (i3 << 5) + 20 >> 2] | 0;
   i3 = HEAP32[i16 + (i3 << 5) + 24 >> 2] | 0;
   f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f47 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f49 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f48 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f49 = Math_fround(f17 - f49);
   f48 = Math_fround(f47 - f48);
   f5 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f5 = Math_fround(Math_fround(f48 * f5) + Math_fround(Math_fround(f49 * f48) + Math_fround(f49 * f5)));
   if (i19 >>> 0 > 1) {
    f8 = f5;
    i12 = 1;
    do {
     i37 = HEAP32[i44 + (i18 + i12 << 2) >> 2] | 0;
     f15 = Math_fround(HEAPF32[i16 + (i37 << 5) + 16 >> 2]);
     f47 = Math_fround(HEAPF32[i16 + (i37 << 5) + 20 >> 2]);
     f49 = Math_fround(HEAPF32[i16 + (i37 << 5) + 24 >> 2]);
     f11 = Math_fround(HEAPF32[i16 + (i37 << 5) >> 2]);
     f48 = Math_fround(HEAPF32[i16 + (i37 << 5) + 4 >> 2]);
     f14 = Math_fround(HEAPF32[i16 + (i37 << 5) + 8 >> 2]);
     f13 = Math_fround(f15 - f11);
     f17 = Math_fround(f47 - f48);
     f50 = Math_fround(f49 - f14);
     f50 = Math_fround(Math_fround(f17 * f50) + Math_fround(Math_fround(f13 * f17) + Math_fround(f13 * f50)));
     f8 = f8 < f50 ? f8 : f50;
     f5 = f5 > f50 ? f5 : f50;
     f50 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f50 < f11 ? f50 : f11, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = (HEAPF32[tempDoublePtr >> 2] = f13 < f48 ? f13 : f48, HEAP32[tempDoublePtr >> 2] | 0);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f17 < f14 ? f17 : f14, HEAP32[tempDoublePtr >> 2] | 0);
     f14 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f17 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f48 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f14 > f15 ? f14 : f15, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f17 > f47 ? f17 : f47, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f48 > f49 ? f48 : f49, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = i12 + 1 | 0;
    } while ((i12 | 0) != (i19 | 0));
   } else f8 = f5;
   HEAP32[i38 >> 2] = i2;
   HEAP32[i21 >> 2] = i10;
   HEAP32[i23 >> 2] = i9;
   HEAP32[i24 >> 2] = i7;
   HEAP32[i25 >> 2] = i6;
   HEAP32[i26 >> 2] = i3;
   i37 = Math_fround(f5 / f8) < Math_fround(40.0);
   i4 = i4 & i37;
   if (!(i4 | (i19 >>> 0 < 3 | i19 >>> 0 < 4 & i37))) if (i19 >>> 0 > (HEAP32[gb + 110392 + (HEAP32[i20 >> 2] << 2) >> 2] | 0) >>> 0) {
    HEAP32[i27 >> 2] = -1;
    HEAP32[i28 >> 2] = 0;
    i12 = i2;
    i4 = 0;
    break;
   }
   HEAP32[i27 >> 2] = (i30 - (HEAP32[i46 >> 2] | 0) >> 2) + i18;
   HEAP32[i28 >> 2] = i19;
   i12 = i2;
  } while (0);
  i2 = HEAP32[i36 >> 2] | 0;
  if ((HEAP32[i29 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i37 = HEAP32[i45 >> 2] | 0;
   HEAP32[i37 + (i2 << 5) >> 2] = i12;
   HEAP32[i37 + (i2 << 5) + 4 >> 2] = i10;
   HEAP32[i37 + (i2 << 5) + 8 >> 2] = i9;
   HEAP32[i37 + (i2 << 5) + 12 >> 2] = i7;
   HEAP32[i37 + (i2 << 5) + 16 >> 2] = i6;
   HEAP32[i37 + (i2 << 5) + 20 >> 2] = i3;
   i18 = i27;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i37 = i37 + (i2 << 5) + 24 | 0;
   HEAP32[i37 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i37 + 4 >> 2] = i19;
   HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i45, i38) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 4) break;
  i19 = HEAP32[i39 + (i1 << 2) >> 2] | 0;
 }
 if (i4) {
  STACKTOP = i42;
  return;
 }
 i3 = HEAP32[i36 >> 2] | 0;
 i1 = i3 + -4 | 0;
 i4 = i40 + 1 | 0;
 i2 = HEAP32[i45 >> 2] | 0;
 if (!(HEAP32[i2 + (i1 << 5) + 28 >> 2] | 0)) {
  HEAP32[i2 + (i1 << 5) + 24 >> 2] = i3;
  __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i46, i44, i32, i45, i43, i4, i2 + (i1 << 5) | 0);
  i2 = HEAP32[i45 >> 2] | 0;
 }
 i1 = i3 + -3 | 0;
 if (!(HEAP32[i2 + (i1 << 5) + 28 >> 2] | 0)) {
  HEAP32[i2 + (i1 << 5) + 24 >> 2] = HEAP32[i36 >> 2];
  __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i46, i44 + (HEAP32[i34 >> 2] << 2) | 0, i31, i45, i43, i4, i2 + (i1 << 5) | 0);
  i2 = HEAP32[i45 >> 2] | 0;
 }
 i1 = i3 + -2 | 0;
 if (!(HEAP32[i2 + (i1 << 5) + 28 >> 2] | 0)) {
  HEAP32[i2 + (i1 << 5) + 24 >> 2] = HEAP32[i36 >> 2];
  __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i46, i44 + (HEAP32[i41 + 8 >> 2] << 2) | 0, HEAP32[i33 >> 2] | 0, i45, i43, i4, i2 + (i1 << 5) | 0);
  i2 = HEAP32[i45 >> 2] | 0;
 }
 i1 = i3 + -1 | 0;
 if (HEAP32[i2 + (i1 << 5) + 28 >> 2] | 0) {
  STACKTOP = i42;
  return;
 }
 HEAP32[i2 + (i1 << 5) + 24 >> 2] = HEAP32[i36 >> 2];
 __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_(i46, i44 + (HEAP32[i41 + 12 >> 2] << 2) | 0, HEAP32[i35 >> 2] | 0, i45, i43, i4, i2 + (i1 << 5) | 0);
 STACKTOP = i42;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN15Cast2DQueryBase14FixtureContactEPS2_EEbT0_S5_T_(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 64 | 0;
 i6 = i15;
 switch ((i12 - i13 | 0) / 92 | 0 | 0) {
 case 2:
  {
   if (!(Math_fround(HEAPF32[i12 + -64 >> 2]) < Math_fround(HEAPF32[i13 + 28 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i1 = i12 + -92 | 0;
   i3 = i14;
   i10 = i13;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i13;
   i10 = i1;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i1;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 3:
  {
   i4 = i13 + 92 | 0;
   i5 = i12 + -92 | 0;
   i6 = i13 + 120 | 0;
   f9 = Math_fround(HEAPF32[i6 >> 2]);
   i7 = i13 + 28 | 0;
   i11 = f9 < Math_fround(HEAPF32[i7 >> 2]);
   i2 = i12 + -64 | 0;
   i1 = Math_fround(HEAPF32[i2 >> 2]) < f9;
   if (!i11) {
    if (!i1) {
     i14 = 1;
     STACKTOP = i15;
     return i14 | 0;
    }
    i3 = i14;
    i10 = i4;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i4;
    i10 = i5;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i5;
    i10 = i14;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    f9 = Math_fround(HEAPF32[i6 >> 2]);
    if (!(f9 < Math_fround(HEAPF32[i7 >> 2]))) {
     i14 = 1;
     STACKTOP = i15;
     return i14 | 0;
    }
    i3 = i14;
    i10 = i13;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i13;
    i10 = i4;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i4;
    i10 = i14;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   if (i1) {
    i3 = i14;
    i10 = i13;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i13;
    i10 = i5;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i5;
    i10 = i14;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i3 = i14;
   i10 = i13;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i13;
   i10 = i4;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i4;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   if (!(Math_fround(HEAPF32[i2 >> 2]) < Math_fround(HEAPF32[i6 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i3 = i14;
   i10 = i4;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i4;
   i10 = i5;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i5;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i13, i13 + 92 | 0, i13 + 184 | 0, i12 + -92 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 5:
  {
   i6 = i13 + 92 | 0;
   i7 = i13 + 184 | 0;
   i5 = i13 + 276 | 0;
   __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i13, i6, i7, i5, i1) | 0;
   i4 = i13 + 304 | 0;
   if (!(Math_fround(HEAPF32[i12 + -64 >> 2]) < Math_fround(HEAPF32[i4 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i1 = i12 + -92 | 0;
   i3 = i14;
   i10 = i5;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i5;
   i10 = i1;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i1;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i2 = i13 + 212 | 0;
   if (!(Math_fround(HEAPF32[i4 >> 2]) < Math_fround(HEAPF32[i2 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i3 = i14;
   i10 = i7;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i7;
   i10 = i5;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i5;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i1 = i13 + 120 | 0;
   if (!(Math_fround(HEAPF32[i2 >> 2]) < Math_fround(HEAPF32[i1 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i3 = i14;
   i10 = i6;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i6;
   i10 = i7;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i7;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i13 + 28 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i3 = i14;
   i10 = i13;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i13;
   i10 = i6;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i3 = i6;
   i10 = i14;
   i11 = i3 + 92 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    i3 = i3 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i3 | 0) < (i11 | 0));
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i4 = i13 + 184 | 0;
   i2 = i13 + 92 | 0;
   i5 = i13 + 120 | 0;
   f16 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f9 = Math_fround(HEAPF32[i13 + 212 >> 2]);
   i1 = f9 < f16;
   do if (f16 < f8) {
    if (i1) {
     i3 = i14;
     i10 = i13;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i13;
     i10 = i4;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i4;
     i10 = i14;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     break;
    }
    i3 = i14;
    i10 = i13;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i13;
    i10 = i2;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i2;
    i10 = i14;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    if (f9 < Math_fround(HEAPF32[i5 >> 2])) {
     i3 = i14;
     i10 = i2;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i2;
     i10 = i4;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i4;
     i10 = i14;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
    }
   } else if (i1) {
    i3 = i14;
    i10 = i2;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i2;
    i10 = i4;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    i3 = i4;
    i10 = i14;
    i11 = i3 + 92 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i3 | 0) < (i11 | 0));
    if (Math_fround(HEAPF32[i5 >> 2]) < f8) {
     i3 = i14;
     i10 = i13;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i13;
     i10 = i2;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
     i3 = i2;
     i10 = i14;
     i11 = i3 + 92 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
      i3 = i3 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i3 | 0) < (i11 | 0));
    }
   } while (0);
   i1 = i13 + 276 | 0;
   L13 : do if ((i1 | 0) == (i12 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f8 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     if (f8 < Math_fround(HEAPF32[i4 + 28 >> 2])) {
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i14 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i14 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
      i3 = i6;
      i10 = i1 + 32 | 0;
      i11 = i3 + 60 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
       i3 = i3 + 4 | 0;
       i10 = i10 + 4 | 0;
      } while ((i3 | 0) < (i11 | 0));
      i3 = i1;
      while (1) {
       i10 = i4;
       i11 = i3 + 92 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
        i3 = i3 + 4 | 0;
        i10 = i10 + 4 | 0;
       } while ((i3 | 0) < (i11 | 0));
       if ((i4 | 0) == (i13 | 0)) {
        i3 = i13;
        break;
       }
       if (f8 < Math_fround(HEAPF32[i4 + -64 >> 2])) {
        i3 = i4;
        i4 = i4 + -92 | 0;
       } else {
        i3 = i4;
        break;
       }
      }
      HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      HEAP32[i4 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
      HEAP32[i4 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
      HEAPF32[i3 + 28 >> 2] = f8;
      i3 = i3 + 32 | 0;
      i10 = i6;
      i11 = i3 + 60 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
       i3 = i3 + 4 | 0;
       i10 = i10 + 4 | 0;
      } while ((i3 | 0) < (i11 | 0));
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 92 | 0) == (i12 | 0);
       break L13;
      }
     }
     i3 = i1 + 92 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i4 = i1;
      i1 = i3;
     }
    }
   } while (0);
   i14 = i1 | i2;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZN7b2Joint6CreateEPK10b2JointDefP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 do switch (HEAP32[i1 >> 2] | 0) {
 case 3:
  {
   i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 176) | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 56 >> 2] = 0;
   HEAP8[i2 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i2 + 60 >> 0] = 0;
   HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i3 = i2 + 16 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i3 + 28 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 152164 + 8;
   i3 = i1 + 20 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i2 + 80 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = i4;
   i5 = i1 + 28 | 0;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i2 + 88 | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   HEAP32[i2 + 104 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAPF32[i2 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 76 >> 2] = Math_fround(0.0);
   return i2 | 0;
  }
 case 5:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 168) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i4 = i5 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152372 + 8;
   i4 = i1 + 20 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i5 + 76 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 68 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 + 104 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAPF32[i5 + 96 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 100 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 84 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i5 + 88 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 108 >> 2] = Math_fround(0.0);
   return i5 | 0;
  }
 case 2:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 256) | 0;
   __ZN16b2PrismaticJointC2EPK19b2PrismaticJointDef(i5, i1);
   return i5 | 0;
  }
 case 1:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 228) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i4 = i5 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152528 + 8;
   i4 = i1 + 20 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i5 + 68 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 76 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 + 116 >> 2] = HEAP32[i1 + 36 >> 2];
   i4 = i5 + 84 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i5 + 120 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAP32[i5 + 124 >> 2] = HEAP32[i1 + 48 >> 2];
   HEAP32[i5 + 104 >> 2] = HEAP32[i1 + 60 >> 2];
   HEAP32[i5 + 108 >> 2] = HEAP32[i1 + 56 >> 2];
   HEAP8[i5 + 112 >> 0] = HEAP8[i1 + 40 >> 0] | 0;
   HEAP8[i5 + 100 >> 0] = HEAP8[i1 + 52 >> 0] | 0;
   HEAP32[i5 + 224 >> 2] = 0;
   return i5 | 0;
  }
 case 4:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 196) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i3 = i5 + 16 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i3 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152476 + 8;
   i3 = i1 + 20 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i5 + 68 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i1 + 28 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i5 + 76 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i1 + 36 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i5 + 92 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i1 + 44 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i5 + 100 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = HEAP32[i1 + 52 >> 2] | 0;
   HEAP32[i5 + 84 >> 2] = i3;
   i4 = HEAP32[i1 + 56 >> 2] | 0;
   HEAP32[i5 + 88 >> 2] = i4;
   f6 = Math_fround(HEAPF32[i1 + 60 >> 2]);
   HEAPF32[i5 + 112 >> 2] = f6;
   HEAPF32[i5 + 108 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f6));
   HEAPF32[i5 + 116 >> 2] = Math_fround(0.0);
   return i5 | 0;
  }
 case 6:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 276) | 0;
   __ZN11b2GearJointC2EPK14b2GearJointDef(i5, i1);
   return i5 | 0;
  }
 case 7:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 224) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i3 = i5 + 16 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i3 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152684 + 8;
   i3 = i1 + 20 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i5 + 76 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = i1 + 28 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i5 + 84 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i1 + 36 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i5 + 92 | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i3;
   HEAPF32[i5 + 100 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAP32[i5 + 104 >> 2] = i4;
   HEAPF32[i5 + 204 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 208 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 112 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 212 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 116 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 120 >> 2] = HEAP32[i1 + 48 >> 2];
   HEAP32[i5 + 124 >> 2] = HEAP32[i1 + 52 >> 2];
   HEAP8[i5 + 128 >> 0] = HEAP8[i1 + 44 >> 0] | 0;
   HEAP32[i5 + 68 >> 2] = HEAP32[i1 + 56 >> 2];
   HEAP32[i5 + 72 >> 2] = HEAP32[i1 + 60 >> 2];
   HEAPF32[i5 + 216 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 220 >> 2] = Math_fround(0.0);
   i4 = i5 + 172 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   return i5 | 0;
  }
 case 8:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 208) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i4 = i5 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152632 + 8;
   i4 = i1 + 20 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i5 + 80 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 88 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 + 96 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i5 + 68 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i5 + 72 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAPF32[i5 + 104 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 108 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 112 >> 2] = Math_fround(0.0);
   return i5 | 0;
  }
 case 9:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 180) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i4 = i5 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152216 + 8;
   i4 = i1 + 20 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i5 + 68 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 76 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAPF32[i5 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 96 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i5 + 100 >> 2] = HEAP32[i1 + 40 >> 2];
   return i5 | 0;
  }
 case 10:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 168) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i4 = i5 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152580 + 8;
   i4 = i1 + 20 | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i5 + 68 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 76 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 + 84 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAPF32[i5 + 160 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 164 >> 2] = 0;
   HEAPF32[i5 + 88 >> 2] = Math_fround(0.0);
   return i5 | 0;
  }
 case 11:
  {
   i5 = __ZN16b2BlockAllocator8AllocateEi(i2, 192) | 0;
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 56 >> 2] = 0;
   HEAP8[i5 + 61 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
   HEAP8[i5 + 60 >> 0] = 0;
   HEAP32[i5 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
   i2 = i5 + 16 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 152320 + 8;
   i2 = i1 + 20 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i5 + 68 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 + 76 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAPF32[i5 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 88 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 92 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i5 + 96 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i5 + 100 >> 2] = HEAP32[i1 + 40 >> 2];
   return i5 | 0;
  }
 default:
  {
   i5 = 0;
   return i5 | 0;
  }
 } while (0);
 return 0;
}

function __ZNK5physx27PxRigidDynamicGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 348 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj42ENS_22PxRepXPropertyAccessorILj42ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 364 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj43ENS_22PxRepXPropertyAccessorILj43ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 380 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj44ENS_22PxRepXPropertyAccessorILj44ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 408 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj46ENS_22PxRepXPropertyAccessorILj46ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 424 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj47ENS_22PxRepXPropertyAccessorILj47ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 440 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj48ENS_22PxRepXPropertyAccessorILj48ES4_ffEEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 456 | 0, i10 + 8 | 0);
 i5 = i6 + 480 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) {
   i3 = i1;
   break;
  }
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while (0);
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj50ENS_22PxRepXPropertyAccessorILj50ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 11 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 11 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEbT0_S6_T_(i15, i14, i1) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 16 | 0;
 i12 = i17;
 switch ((i14 - i15 | 0) / 40 | 0 | 0) {
 case 2:
  {
   i3 = i14 + -40 | 0;
   i1 = HEAP32[i14 + -24 >> 2] | 0;
   i2 = HEAP32[i15 + 16 >> 2] | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    if ((i1 | 0) != (i2 | 0)) {
     i16 = 1;
     STACKTOP = i17;
     return i16 | 0;
    }
    if ((HEAP32[i14 + -16 >> 2] | 0) >>> 0 >= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
     i16 = 1;
     STACKTOP = i17;
     return i16 | 0;
    }
   }
   i9 = i16;
   i10 = i15;
   i11 = i9 + 40 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   i9 = i15;
   i10 = i3;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i15 + 36 >> 0] = HEAP8[i3 + 36 >> 0] | 0;
   i9 = i3;
   i10 = i16;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i3 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 3:
  {
   i8 = i15 + 40 | 0;
   i7 = i14 + -40 | 0;
   i5 = i15 + 56 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i6 = i15 + 16 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i3 >>> 0 < i1 >>> 0) i2 = 1; else if ((i3 | 0) == (i1 | 0)) i2 = (HEAP32[i15 + 64 >> 2] | 0) >>> 0 < (HEAP32[i15 + 24 >> 2] | 0) >>> 0; else i2 = 0;
   i4 = i14 + -24 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 >>> 0 < i3 >>> 0) i1 = 1; else if ((i1 | 0) == (i3 | 0)) i1 = (HEAP32[i14 + -16 >> 2] | 0) >>> 0 < (HEAP32[i15 + 64 >> 2] | 0) >>> 0; else i1 = 0;
   if (!i2) {
    if (!i1) {
     i16 = 1;
     STACKTOP = i17;
     return i16 | 0;
    }
    i9 = i16;
    i10 = i8;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    i9 = i8;
    i10 = i7;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i8 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
    i9 = i7;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    if (i2 >>> 0 >= i1 >>> 0) {
     if ((i2 | 0) != (i1 | 0)) {
      i16 = 1;
      STACKTOP = i17;
      return i16 | 0;
     }
     if ((HEAP32[i15 + 64 >> 2] | 0) >>> 0 >= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
      i16 = 1;
      STACKTOP = i17;
      return i16 | 0;
     }
    }
    i9 = i16;
    i10 = i15;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    i9 = i15;
    i10 = i8;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i15 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
    i9 = i8;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i8 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
    i16 = 1;
    STACKTOP = i17;
    return i16 | 0;
   }
   i9 = i16;
   i10 = i15;
   i11 = i9 + 40 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   if (i1) {
    i9 = i15;
    i10 = i7;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i15 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
    i9 = i7;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
    i16 = 1;
    STACKTOP = i17;
    return i16 | 0;
   }
   i9 = i15;
   i10 = i8;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i15 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
   i9 = i8;
   i10 = i16;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i8 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    if ((i2 | 0) != (i1 | 0)) {
     i16 = 1;
     STACKTOP = i17;
     return i16 | 0;
    }
    if ((HEAP32[i14 + -16 >> 2] | 0) >>> 0 >= (HEAP32[i15 + 64 >> 2] | 0) >>> 0) {
     i16 = 1;
     STACKTOP = i17;
     return i16 | 0;
    }
   }
   i9 = i16;
   i10 = i8;
   i11 = i9 + 40 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   i9 = i8;
   i10 = i7;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i8 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
   i9 = i7;
   i10 = i16;
   i11 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP8[i7 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_(i15, i15 + 40 | 0, i15 + 80 | 0, i14 + -40 | 0, i1) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_(i15, i15 + 40 | 0, i15 + 80 | 0, i15 + 120 | 0, i14 + -40 | 0, i1) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 1:
 case 0:
  {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 default:
  {
   i4 = i15 + 80 | 0;
   i7 = i15 + 40 | 0;
   i3 = i15 + 56 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i15 + 16 >> 2] | 0;
   if (i1 >>> 0 < i5 >>> 0) i2 = 1; else if ((i1 | 0) == (i5 | 0)) i2 = (HEAP32[i15 + 64 >> 2] | 0) >>> 0 < (HEAP32[i15 + 24 >> 2] | 0) >>> 0; else i2 = 0;
   i6 = HEAP32[i15 + 96 >> 2] | 0;
   if (i6 >>> 0 < i1 >>> 0) i1 = 1; else if ((i6 | 0) == (i1 | 0)) i1 = (HEAP32[i15 + 104 >> 2] | 0) >>> 0 < (HEAP32[i15 + 64 >> 2] | 0) >>> 0; else i1 = 0;
   do if (i2) {
    i9 = i16;
    i10 = i15;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    if (i1) {
     i9 = i15;
     i10 = i4;
     i11 = i9 + 36 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
      i9 = i9 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i9 | 0) < (i11 | 0));
     HEAP8[i15 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
     i9 = i4;
     i10 = i16;
     i11 = i9 + 36 | 0;
     do {
      HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
      i9 = i9 + 4 | 0;
      i10 = i10 + 4 | 0;
     } while ((i9 | 0) < (i11 | 0));
     HEAP8[i4 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
     break;
    }
    i9 = i15;
    i10 = i7;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i15 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
    i9 = i7;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (i6 >>> 0 >= i1 >>> 0) {
     if ((i6 | 0) != (i1 | 0)) break;
     if ((HEAP32[i15 + 104 >> 2] | 0) >>> 0 >= (HEAP32[i15 + 64 >> 2] | 0) >>> 0) break;
    }
    i9 = i16;
    i10 = i7;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    i9 = i7;
    i10 = i4;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
    i9 = i4;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i4 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
   } else if (i1) {
    i9 = i16;
    i10 = i7;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    i9 = i7;
    i10 = i4;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
    i9 = i4;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i4 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 >>> 0 >= i5 >>> 0) {
     if ((i1 | 0) != (i5 | 0)) break;
     if ((HEAP32[i15 + 64 >> 2] | 0) >>> 0 >= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) break;
    }
    i9 = i16;
    i10 = i15;
    i11 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    i9 = i15;
    i10 = i7;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i15 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
    i9 = i7;
    i10 = i16;
    i11 = i9 + 36 | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     i9 = i9 + 4 | 0;
     i10 = i10 + 4 | 0;
    } while ((i9 | 0) < (i11 | 0));
    HEAP8[i7 + 36 >> 0] = HEAP8[i16 + 36 >> 0] | 0;
   } while (0);
   i1 = i15 + 120 | 0;
   L27 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i8 = HEAP32[i1 + 16 >> 2] | 0;
     i3 = HEAP32[i4 + 16 >> 2] | 0;
     if (i8 >>> 0 < i3 >>> 0) {
      i3 = HEAP32[i1 + 24 >> 2] | 0;
      i13 = 49;
     } else if ((i8 | 0) == (i3 | 0)) {
      i3 = HEAP32[i1 + 24 >> 2] | 0;
      if (i3 >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) i13 = 49;
     }
     if ((i13 | 0) == 49) {
      i13 = 0;
      HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      i7 = HEAP32[i1 + 20 >> 2] | 0;
      i9 = i1 + 28 | 0;
      HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      i9 = i1;
      i10 = i4;
      i11 = i9 + 36 | 0;
      do {
       HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
       i9 = i9 + 4 | 0;
       i10 = i10 + 4 | 0;
      } while ((i9 | 0) < (i11 | 0));
      HEAP8[i1 + 36 >> 0] = HEAP8[i4 + 36 >> 0] | 0;
      L36 : do if ((i4 | 0) == (i15 | 0)) i5 = i15; else while (1) {
       i6 = i4 + -40 | 0;
       i5 = HEAP32[i4 + -24 >> 2] | 0;
       if (i8 >>> 0 >= i5 >>> 0) {
        if ((i8 | 0) != (i5 | 0)) {
         i5 = i4;
         break L36;
        }
        if (i3 >>> 0 >= (HEAP32[i4 + -16 >> 2] | 0) >>> 0) {
         i5 = i4;
         break L36;
        }
       }
       i9 = i4;
       i10 = i6;
       i11 = i9 + 36 | 0;
       do {
        HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
        i9 = i9 + 4 | 0;
        i10 = i10 + 4 | 0;
       } while ((i9 | 0) < (i11 | 0));
       HEAP8[i4 + 36 >> 0] = HEAP8[i6 + 36 >> 0] | 0;
       if ((i6 | 0) == (i15 | 0)) {
        i5 = i15;
        i4 = i6;
        break;
       } else i4 = i6;
      } while (0);
      HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      HEAP32[i5 + 16 >> 2] = i8;
      HEAP32[i5 + 20 >> 2] = i7;
      HEAP32[i5 + 24 >> 2] = i3;
      i11 = i5 + 28 | 0;
      HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP8[i11 + 8 >> 0] = HEAP8[i12 + 8 >> 0] | 0;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 40 | 0) == (i14 | 0);
       break L27;
      }
     }
     i3 = i1 + 40 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i4 = i1;
      i1 = i3;
     }
    }
   } while (0);
   i16 = i1 | i2;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 return 0;
}

function __ZN9Animation13BlendAdditiveEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i66 + 64 | 0;
 i62 = i66 + 48 | 0;
 i63 = i66 + 32 | 0;
 i64 = i66 + 16 | 0;
 i65 = i66;
 i5 = i6 + 104 | 0;
 i3 = (HEAP32[i6 + 108 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i4 = i3 >> 2;
 HEAP32[i60 >> 2] = 0;
 i61 = i60 + 4 | 0;
 i57 = gb + 63160 | 0;
 i58 = HEAP32[i57 + 4 >> 2] | 0;
 i59 = i61;
 HEAP32[i59 >> 2] = HEAP32[i57 >> 2];
 HEAP32[i59 + 4 >> 2] = i58;
 if (!i3) {
  i65 = HEAP32[i60 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i61);
  STACKTOP = i66;
  return;
 }
 i2 = i3 + 3 | 0;
 if (i2 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 1374) | 0;
  i58 = gb + 64016 | 0;
  i57 = HEAP32[i58 >> 2] | 0;
  i58 = HEAP32[i58 + 4 >> 2] | 0;
  HEAP32[i60 >> 2] = i1;
  i59 = i61;
  HEAP32[i59 >> 2] = i57;
  HEAP32[i59 + 4 >> 2] = i58;
 }
 i59 = i1 + 3 & -4;
 if ((i3 | 0) <= 0) {
  i65 = HEAP32[i60 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i61);
  STACKTOP = i66;
  return;
 }
 i1 = 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((HEAP32[i2 + 72 >> 2] | 0) == 1) if (HEAP32[i2 + 96 >> 2] | 0) if (HEAP16[i2 + 56 >> 1] & 2) if (Math_fround(HEAPF32[i2 + 8 >> 2]) > Math_fround(.0000999999974)) {
   HEAP32[i59 + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 if (!i1) {
  i65 = HEAP32[i60 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i61);
  STACKTOP = i66;
  return;
 }
 i58 = HEAP32[i6 + 96 >> 2] | 0;
 i31 = HEAP32[i6 + 84 >> 2] | 0;
 if ((i58 | 0) <= 0) {
  i65 = HEAP32[i60 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i65, i61);
  STACKTOP = i66;
  return;
 }
 i32 = (i1 | 0) > 0;
 i33 = i62 + 4 | 0;
 i34 = i62 + 8 | 0;
 i35 = i62 + 12 | 0;
 f36 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i37 = i63 + 4 | 0;
 i38 = i63 + 8 | 0;
 i39 = i63 + 12 | 0;
 i29 = i63 + 4 | 0;
 i22 = i63 + 8 | 0;
 i24 = i63 + 12 | 0;
 i40 = i63 + 4 | 0;
 i41 = i63 + 8 | 0;
 i42 = i65 + 4 | 0;
 i43 = i65 + 8 | 0;
 i30 = i64 + 4 | 0;
 i23 = i64 + 8 | 0;
 i25 = i64 + 12 | 0;
 i44 = i65 + 4 | 0;
 i45 = i65 + 8 | 0;
 i26 = i64 + 4 | 0;
 i27 = i64 + 8 | 0;
 i28 = i64 + 12 | 0;
 i19 = i62 + 4 | 0;
 i21 = i62 + 8 | 0;
 i46 = i63 + 4 | 0;
 i47 = i63 + 8 | 0;
 i48 = i63 + 4 | 0;
 i49 = i63 + 8 | 0;
 i50 = i62 + 4 | 0;
 i51 = i62 + 8 | 0;
 i18 = i62 + 4 | 0;
 i20 = i62 + 8 | 0;
 i52 = i63 + 4 | 0;
 i53 = i63 + 8 | 0;
 i54 = i63 + 4 | 0;
 i55 = i63 + 8 | 0;
 i56 = i62 + 4 | 0;
 i57 = i62 + 8 | 0;
 i17 = 0;
 do {
  i16 = HEAP32[i31 + (i17 * 24 | 0) + 4 >> 2] | 0;
  i6 = (i16 | 0) == 2;
  switch (i16 | 0) {
  case 2:
  case 4:
   {
    i16 = HEAP32[i31 + (i17 * 24 | 0) + 12 >> 2] | 0;
    __ZNK9Transform16GetLocalRotationEv(i62, i16);
    if (i32) {
     i5 = 0;
     i2 = 0;
     do {
      i3 = HEAP32[i59 + (i5 << 2) >> 2] | 0;
      f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
      i4 = f15 < Math_fround(0.0);
      i67 = f15 > Math_fround(1.0);
      f15 = i67 ? Math_fround(1.0) : f15;
      f15 = i4 ? Math_fround(0.0) : f15;
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      if (i4) {
       if (i6) {
        __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i63, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
        f11 = Math_fround(HEAPF32[i63 >> 2]);
        f14 = Math_fround(HEAPF32[i29 >> 2]);
        f12 = Math_fround(HEAPF32[i22 >> 2]);
        f13 = Math_fround(HEAPF32[i24 >> 2]);
        i2 = HEAP32[i4 + 152 >> 2] | 0;
        f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
        f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
        f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
        i2 = HEAP32[i2 + 16 >> 2] | 0;
       } else {
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i63, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
        f12 = Math_fround(Math_fround(HEAPF32[i63 >> 2]) * Math_fround(.0174532924));
        f14 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) * Math_fround(.0174532924));
        f11 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * Math_fround(.0174532924));
        HEAPF32[i65 >> 2] = f12;
        HEAPF32[i42 >> 2] = f14;
        HEAPF32[i43 >> 2] = f11;
        __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i64, i65, 4);
        f11 = Math_fround(HEAPF32[i64 >> 2]);
        f14 = Math_fround(HEAPF32[i30 >> 2]);
        f12 = Math_fround(HEAPF32[i23 >> 2]);
        f13 = Math_fround(HEAPF32[i25 >> 2]);
        i2 = HEAP32[i4 + 120 >> 2] | 0;
        f9 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(.0174532924));
        f8 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(.0174532924));
        f7 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(.0174532924));
        HEAPF32[i65 >> 2] = f9;
        HEAPF32[i44 >> 2] = f8;
        HEAPF32[i45 >> 2] = f7;
        __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i64, i65, 4);
        f7 = Math_fround(HEAPF32[i64 >> 2]);
        f8 = Math_fround(HEAPF32[i26 >> 2]);
        f9 = Math_fround(HEAPF32[i27 >> 2]);
        i2 = HEAP32[i28 >> 2] | 0;
       }
       f69 = Math_fround(-f7);
       f68 = Math_fround(-f8);
       f7 = Math_fround(-f9);
       f70 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f8 = Math_fround(Math_fround(Math_fround(f12 * f68) + Math_fround(Math_fround(f70 * f11) + Math_fround(f13 * f69))) - Math_fround(f14 * f7));
       f9 = Math_fround(Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f70 * f14) + Math_fround(f13 * f68))) - Math_fround(f12 * f69));
       f10 = Math_fround(Math_fround(Math_fround(f14 * f69) + Math_fround(Math_fround(f70 * f12) + Math_fround(f13 * f7))) - Math_fround(f11 * f68));
       f7 = Math_fround(Math_fround(Math_fround(Math_fround(f70 * f13) - Math_fround(f11 * f69)) - Math_fround(f14 * f68)) - Math_fround(f12 * f7));
       if (Math_fround(f7 + Math_fround(Math_fround(f10 * Math_fround(0.0)) + Math_fround(Math_fround(f8 * Math_fround(0.0)) + Math_fround(f9 * Math_fround(0.0))))) < Math_fround(0.0)) {
        f10 = Math_fround(-f10);
        f9 = Math_fround(-f9);
        f8 = Math_fround(-f8);
        f7 = Math_fround(-f7);
       }
       f13 = Math_fround(Math_fround(f15 * f8) + Math_fround(0.0));
       f14 = Math_fround(Math_fround(f15 * f9) + Math_fround(0.0));
       f70 = Math_fround(Math_fround(f15 * f10) + Math_fround(0.0));
       f8 = Math_fround(Math_fround(f15 * Math_fround(f7 + Math_fround(-1.0))) + Math_fround(1.0));
       f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f70 * f70) + Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13))))));
       f10 = Math_fround(f13 / f9);
       f14 = Math_fround(f14 / f9);
       f70 = Math_fround(f70 / f9);
       f9 = Math_fround(f8 / f9);
       f8 = Math_fround(HEAPF32[i35 >> 2]);
       f13 = Math_fround(f8 * f10);
       f11 = Math_fround(HEAPF32[i62 >> 2]);
       f13 = Math_fround(f13 + Math_fround(f9 * f11));
       f12 = Math_fround(HEAPF32[i33 >> 2]);
       f13 = Math_fround(f13 + Math_fround(f70 * f12));
       f15 = Math_fround(HEAPF32[i34 >> 2]);
       f68 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(Math_fround(f8 * f14) + Math_fround(f9 * f12))) - Math_fround(f70 * f11));
       f69 = Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(Math_fround(f8 * f70) + Math_fround(f9 * f15))) - Math_fround(f10 * f12));
       f70 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * f11)) - Math_fround(f14 * f12)) - Math_fround(f70 * f15));
       HEAPF32[i62 >> 2] = Math_fround(f13 - Math_fround(f14 * f15));
       HEAPF32[i33 >> 2] = f68;
       HEAPF32[i34 >> 2] = f69;
       HEAPF32[i35 >> 2] = f70;
       i2 = 1;
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i1 | 0));
    } else i2 = 0;
    f12 = Math_fround(HEAPF32[i62 >> 2]);
    f13 = Math_fround(f12 * f12);
    f10 = Math_fround(HEAPF32[i33 >> 2]);
    f13 = Math_fround(f13 + Math_fround(f10 * f10));
    f8 = Math_fround(HEAPF32[i34 >> 2]);
    f13 = Math_fround(f13 + Math_fround(f8 * f8));
    f7 = Math_fround(HEAPF32[i35 >> 2]);
    f13 = Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f7 * f7))));
    if (f13 < f36) {
     f11 = Math_fround(1.0);
     f9 = Math_fround(0.0);
     f8 = Math_fround(0.0);
     f7 = Math_fround(0.0);
    } else {
     f11 = Math_fround(f7 / f13);
     f9 = Math_fround(f8 / f13);
     f8 = Math_fround(f10 / f13);
     f7 = Math_fround(f12 / f13);
    }
    HEAPF32[i62 >> 2] = f7;
    HEAPF32[i33 >> 2] = f8;
    HEAPF32[i34 >> 2] = f9;
    HEAPF32[i35 >> 2] = f11;
    if (i2) {
     HEAPF32[i63 >> 2] = f7;
     HEAPF32[i37 >> 2] = f8;
     HEAPF32[i38 >> 2] = f9;
     HEAPF32[i39 >> 2] = f11;
     __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i16, i63);
    }
    break;
   }
  case 1:
   {
    i6 = HEAP32[i31 + (i17 * 24 | 0) + 12 >> 2] | 0;
    __ZNK9Transform16GetLocalPositionEv(i62, i6);
    if (i32) {
     i5 = 0;
     i2 = 0;
     do {
      i3 = HEAP32[i59 + (i5 << 2) >> 2] | 0;
      f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
      i4 = f7 < Math_fround(0.0);
      i67 = f7 > Math_fround(1.0);
      f7 = i67 ? Math_fround(1.0) : f7;
      f7 = i4 ? Math_fround(0.0) : f7;
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      if (i4) {
       __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i63, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
       i2 = HEAP32[i4 + 120 >> 2] | 0;
       f68 = Math_fround(HEAPF32[i63 >> 2]);
       f68 = Math_fround(f68 - Math_fround(HEAPF32[i2 + 4 >> 2]));
       f69 = Math_fround(HEAPF32[i48 >> 2]);
       f69 = Math_fround(f69 - Math_fround(HEAPF32[i2 + 8 >> 2]));
       f70 = Math_fround(HEAPF32[i49 >> 2]);
       f68 = Math_fround(f7 * f68);
       f69 = Math_fround(f7 * f69);
       f70 = Math_fround(f7 * Math_fround(f70 - Math_fround(HEAPF32[i2 + 12 >> 2])));
       HEAPF32[i62 >> 2] = Math_fround(f68 + Math_fround(HEAPF32[i62 >> 2]));
       HEAPF32[i50 >> 2] = Math_fround(f69 + Math_fround(HEAPF32[i50 >> 2]));
       HEAPF32[i51 >> 2] = Math_fround(f70 + Math_fround(HEAPF32[i51 >> 2]));
       i2 = 1;
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i1 | 0));
     if (i2) {
      i16 = HEAP32[i19 >> 2] | 0;
      i67 = HEAP32[i21 >> 2] | 0;
      HEAP32[i63 >> 2] = HEAP32[i62 >> 2];
      HEAP32[i46 >> 2] = i16;
      HEAP32[i47 >> 2] = i67;
      __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i6, i63);
     }
    }
    break;
   }
  case 3:
   {
    i6 = HEAP32[i31 + (i17 * 24 | 0) + 12 >> 2] | 0;
    __ZNK9Transform13GetLocalScaleEv(i62, i6);
    if (i32) {
     i5 = 0;
     i2 = 0;
     do {
      i3 = HEAP32[i59 + (i5 << 2) >> 2] | 0;
      f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
      i4 = f7 < Math_fround(0.0);
      i67 = f7 > Math_fround(1.0);
      f7 = i67 ? Math_fround(1.0) : f7;
      f7 = i4 ? Math_fround(0.0) : f7;
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i17 << 2) >> 2] | 0;
      if (i4) {
       __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i63, i4, Math_fround(HEAPF32[i3 + 12 >> 2]), 0);
       i2 = HEAP32[i4 + 120 >> 2] | 0;
       f68 = Math_fround(HEAPF32[i63 >> 2]);
       f68 = Math_fround(f68 - Math_fround(HEAPF32[i2 + 4 >> 2]));
       f69 = Math_fround(HEAPF32[i54 >> 2]);
       f69 = Math_fround(f69 - Math_fround(HEAPF32[i2 + 8 >> 2]));
       f70 = Math_fround(HEAPF32[i55 >> 2]);
       f68 = Math_fround(f7 * f68);
       f69 = Math_fround(f7 * f69);
       f70 = Math_fround(f7 * Math_fround(f70 - Math_fround(HEAPF32[i2 + 12 >> 2])));
       HEAPF32[i62 >> 2] = Math_fround(f68 + Math_fround(HEAPF32[i62 >> 2]));
       HEAPF32[i56 >> 2] = Math_fround(f69 + Math_fround(HEAPF32[i56 >> 2]));
       HEAPF32[i57 >> 2] = Math_fround(f70 + Math_fround(HEAPF32[i57 >> 2]));
       i2 = 1;
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i1 | 0));
     if (i2) {
      i16 = HEAP32[i18 >> 2] | 0;
      i67 = HEAP32[i20 >> 2] | 0;
      HEAP32[i63 >> 2] = HEAP32[i62 >> 2];
      HEAP32[i52 >> 2] = i16;
      HEAP32[i53 >> 2] = i67;
      __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i6, i63);
     }
    }
    break;
   }
  default:
   {}
  }
  i17 = i17 + 1 | 0;
 } while ((i17 | 0) != (i58 | 0));
 i67 = HEAP32[i60 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i67, i61);
 STACKTOP = i66;
 return;
}

function __ZN11AssetBundle8TransferI14SafeBinaryReadEEvRT_(i47, i6) {
 i47 = i47 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i48 + 88 | 0;
 i40 = i48 + 60 | 0;
 i41 = i48 + 56 | 0;
 i42 = i48 + 28 | 0;
 i43 = i48;
 i44 = i48 + 72 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i47, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 3);
 i5 = i47 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i6, 1) | 0)) {
  i2 = i47 + 48 | 0;
  i4 = HEAP32[gb + 37316 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 365509 | 0, i4, i46, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
    i1 = HEAP32[i46 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i2 = i47 + 68 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450717 | 0, HEAP32[gb + 37052 >> 2] | 0, i46, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
    i1 = HEAP32[i46 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i2 = i47 + 36 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 365497 | 0, gb + 365524 | 0, i46, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11AssetBundle9AssetInfo8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
    i1 = HEAP32[i46 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i6, 2) | 0)) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 365534 | 0, HEAP32[gb + 37304 >> 2] | 0, i46, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i6 + 16 | 0;
     i44 = HEAP32[i6 + 20 >> 2] | 0;
     i2 = i44 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i44 >>> 0) i45 = 83; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i45 = 83; else {
       HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i45 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
     if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i46 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i6);
   }
  }
  __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags(i6, i47 + 168 | 0, gb + 365557 | 0, 0);
  i2 = i47 + 172 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 470499 | 0, i4, i46, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
    i1 = HEAP32[i46 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i3 = i47 + 184 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 365575 | 0, HEAP32[gb + 36972 >> 2] | 0, i46, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i6 + 16 | 0;
    i46 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = i46 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i46 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break;
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
   } else {
    i1 = HEAP32[i46 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i47);
  STACKTOP = i48;
  return;
 }
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 i39 = i40 + 4 | 0;
 HEAP32[i40 >> 2] = i39;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450717 | 0, HEAP32[gb + 37052 >> 2] | 0, i46, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S6_EEEEEEEEvRT_17TransferMetaFlags(i6, i40, 0); else {
   i1 = HEAP32[i46 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i40 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 HEAP32[i41 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 365497 | 0, HEAP32[gb + 37176 >> 2] | 0, i46, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i41, i6); else {
   i1 = HEAP32[i46 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i41 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i15 = i47 + 68 | 0;
 i16 = i47 + 72 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i15, HEAP32[i16 >> 2] | 0);
 i17 = i47 + 76 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i16 >> 2] = 0;
 i1 = HEAP32[i40 >> 2] | 0;
 if ((i1 | 0) != (i39 | 0)) {
  i18 = i44 + 12 | 0;
  i9 = i44 + 12 | 0;
  i19 = i46 + 4 | 0;
  i20 = i44 + 8 | 0;
  i21 = i44 + 4 | 0;
  i22 = i44 + 11 | 0;
  i23 = i43 + 12 | 0;
  i11 = i43 + 12 | 0;
  i24 = i46 + 4 | 0;
  i25 = i43 + 8 | 0;
  i26 = i43 + 4 | 0;
  i12 = i43 + 16 | 0;
  i13 = i43 + 20 | 0;
  i14 = i43 + 24 | 0;
  i27 = i43 + 11 | 0;
  i28 = i42 + 12 | 0;
  i10 = i42 + 12 | 0;
  i29 = i46 + 4 | 0;
  i30 = i42 + 8 | 0;
  i31 = i42 + 4 | 0;
  i32 = i42 + 16 | 0;
  i33 = i43 + 16 | 0;
  i34 = i47 + 72 | 0;
  i35 = i42 + 11 | 0;
  i36 = i46 + 4 | 0;
  i37 = i46 + 4 | 0;
  i38 = i46 + 4 | 0;
  i2 = i1;
  while (1) {
   i5 = HEAP32[i2 + 32 >> 2] | 0;
   i3 = i2 + 16 | 0;
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i1 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
   HEAP32[i44 >> 2] = 0;
   HEAP32[i44 + 4 >> 2] = 0;
   HEAP32[i44 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i44);
    i1 = HEAP32[i9 >> 2] | 0;
    i45 = 20;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i22 >> 0] = i4;
    if (!i4) i1 = i44; else {
     i1 = i44;
     i45 = 22;
    }
   } else i45 = 20;
   if ((i45 | 0) == 20) {
    i8 = i4 + 16 & -16;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i19 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i46, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i44 >> 2] = i1;
    HEAP32[i20 >> 2] = i8 | -2147483648;
    HEAP32[i21 >> 2] = i4;
    i45 = 22;
   }
   if ((i45 | 0) == 22) {
    i45 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i4 = HEAP8[i22 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i44 >> 2] | 0 : i44;
   i4 = i1 ? HEAP32[i21 >> 2] | 0 : i4 & 255;
   HEAP32[i43 >> 2] = 0;
   HEAP32[i43 + 4 >> 2] = 0;
   HEAP32[i43 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i23 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i43);
    i1 = HEAP32[i11 >> 2] | 0;
    i45 = 26;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i27 >> 0] = i4;
    if (!i4) i1 = i43; else {
     i1 = i43;
     i45 = 28;
    }
   } else i45 = 26;
   if ((i45 | 0) == 26) {
    i8 = i4 + 16 & -16;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i24 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i46, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i43 >> 2] = i1;
    HEAP32[i25 >> 2] = i8 | -2147483648;
    HEAP32[i26 >> 2] = i4;
    i45 = 28;
   }
   if ((i45 | 0) == 28) {
    i45 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i14 >> 2] = i5;
   i4 = HEAP8[i27 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i43 >> 2] | 0 : i43;
   i4 = i1 ? HEAP32[i26 >> 2] | 0 : i4 & 255;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i28 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i42);
    i1 = HEAP32[i10 >> 2] | 0;
    i45 = 32;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i35 >> 0] = i4;
    if (!i4) i1 = i42; else {
     i1 = i42;
     i45 = 34;
    }
   } else i45 = 32;
   if ((i45 | 0) == 32) {
    i8 = i4 + 16 & -16;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i29 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i46, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i42 >> 2] = i1;
    HEAP32[i30 >> 2] = i8 | -2147483648;
    HEAP32[i31 >> 2] = i4;
    i45 = 34;
   }
   if ((i45 | 0) == 34) {
    i45 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   i1 = HEAP32[i16 >> 2] | 0;
   do if (!i1) {
    i3 = i16;
    i4 = i16;
   } else {
    i7 = HEAP8[i35 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i31 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i42 >> 2] | 0 : i42;
    while (1) {
     i4 = i1 + 16 | 0;
     i6 = HEAP8[i4 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i6 & 255;
     i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
     if (!i3) i45 = 39; else {
      i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
      if (!i3) i45 = 39; else if ((i3 | 0) < 0) i45 = 41; else i45 = 43;
     }
     if ((i45 | 0) == 39) if (i7 >>> 0 < i6 >>> 0) i45 = 41; else i45 = 43;
     if ((i45 | 0) == 41) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) {
       i45 = 42;
       break;
      } else i1 = i3;
     } else if ((i45 | 0) == 43) {
      i4 = i1 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i45 = 45;
       break;
      } else i1 = i3;
     }
    }
    if ((i45 | 0) == 42) {
     i45 = 0;
     i3 = i1;
     i4 = i1;
     break;
    } else if ((i45 | 0) == 45) {
     i45 = 0;
     i3 = i1;
     break;
    }
   } while (0);
   __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i46, i15, i42);
   i1 = HEAP32[i46 >> 2] | 0;
   HEAP32[i46 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i15 >> 2] = i3;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i34 >> 2] | 0, i1);
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
   if ((HEAP8[i35 >> 0] | 0) < 0) {
    i8 = HEAP32[i42 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i36 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i46);
   }
   if ((HEAP8[i27 >> 0] | 0) < 0) {
    i8 = HEAP32[i43 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i37 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i46);
   }
   if ((HEAP8[i22 >> 0] | 0) < 0) {
    i8 = HEAP32[i44 >> 2] | 0;
    i7 = HEAP32[i9 >> 2] | 0;
    HEAP32[i46 >> 2] = 66;
    HEAP32[i38 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i46);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i39 | 0)) break; else i2 = i1;
  }
 }
 HEAP32[i47 + 36 >> 2] = 0;
 HEAP32[i47 + 40 >> 2] = 0;
 HEAP32[i47 + 44 >> 2] = HEAP32[i41 >> 2];
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i40, HEAP32[i39 >> 2] | 0);
 __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i47);
 STACKTOP = i48;
 return;
}

function __ZN5Unity17ConfigurableJoint7SetupD6Ev(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 12 | 0;
 i15 = i17;
 i16 = i13 + 32 | 0;
 i18 = HEAP32[i16 >> 2] | 0;
 i4 = i13 + 96 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 0, HEAP32[i4 >> 2] | 0);
 i18 = HEAP32[i16 >> 2] | 0;
 i1 = i13 + 100 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 1, HEAP32[i1 >> 2] | 0);
 i18 = HEAP32[i16 >> 2] | 0;
 i2 = i13 + 104 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 2, HEAP32[i2 >> 2] | 0);
 i18 = HEAP32[i16 >> 2] | 0;
 i10 = i13 + 112 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 4, HEAP32[i10 >> 2] | 0);
 i18 = HEAP32[i16 >> 2] | 0;
 i11 = i13 + 116 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 5, HEAP32[i11 >> 2] | 0);
 i18 = HEAP32[i16 >> 2] | 0;
 i12 = i13 + 108 | 0;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 3, HEAP32[i12 >> 2] | 0);
 f3 = Math_fround(HEAPF32[i13 + 128 >> 2]);
 if (f3 == Math_fround(0.0)) {
  if ((HEAP32[i4 >> 2] | 0) == 1) {
   i18 = HEAP32[i16 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 0, 0);
  }
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   i18 = HEAP32[i16 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 1, 0);
  }
  if ((HEAP32[i2 >> 2] | 0) == 1) {
   i18 = HEAP32[i16 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, 2, 0);
  }
 } else {
  i18 = HEAP32[i16 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i18 >> 2] | 0) + 140 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i13 + 136 >> 2]);
  i2 = f8 > Math_fround(0.0);
  f8 = i2 ? f8 : Math_fround(-1.0);
  i2 = i14 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAPF32[i14 + 20 >> 2] = f3;
  i2 = f8 == Math_fround(-1.0);
  f8 = i2 ? Math_fround(.00999999977) : f8;
  f9 = Math_fround(HEAPF32[i13 + 132 >> 2]);
  i2 = f9 > Math_fround(0.0);
  i1 = f8 < Math_fround(.200000003);
  f8 = i1 ? Math_fround(.200000003) : f8;
  HEAPF32[i14 + 16 >> 2] = i2 ? Math_fround(9.99999974e-06) : f8;
  HEAPF32[i14 >> 2] = f9;
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 120 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 124 >> 2];
  mftCall_vii(i4 | 0, i18 | 0, i14 | 0);
 }
 i4 = i13 + 180 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (f3 == Math_fround(0.0)) f9 = Math_fround(1.57079637); else f9 = Math_fround(Math_fround(Math_fround(f3 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i2 = i13 + 192 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 if (f3 == Math_fround(0.0)) f7 = Math_fround(1.57079637); else f7 = Math_fround(Math_fround(Math_fround(f3 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f5 = Math_fround(HEAPF32[i13 + 188 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f5 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = f9;
 HEAPF32[i14 + 24 >> 2] = f7;
 if (f6 == Math_fround(-1.0)) {
  f3 = Math_fround((f9 < f7 ? f9 : f7) * Math_fround(.49000001));
  i18 = f3 > Math_fround(.100000001);
  f3 = i18 ? Math_fround(.100000001) : f3;
 } else f3 = f6;
 i1 = i14 + 16 | 0;
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i14 + 4 >> 2] = Math_fround(.5);
 i18 = HEAP32[i13 + 184 >> 2] | 0;
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 172 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 176 >> 2];
 f8 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = f5 > Math_fround(0.0);
 f3 = i18 ? f6 : Math_fround(-1.0);
 if (f3 == Math_fround(-1.0)) {
  f3 = Math_fround((f9 < f7 ? f9 : f7) * Math_fround(.49000001));
  i18 = f3 > Math_fround(.100000001);
  f3 = i18 ? Math_fround(.100000001) : f3;
 }
 i18 = f8 > Math_fround(0.0);
 i19 = f3 < Math_fround(.200000003);
 f9 = i19 ? Math_fround(.200000003) : f3;
 HEAPF32[i1 >> 2] = i18 ? Math_fround(9.99999974e-06) : f9;
 i18 = HEAP32[i16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 156 >> 2] | 0, i18 | 0, i14 | 0);
 if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0)) if ((HEAP32[i10 >> 2] | 0) == 1) {
  i19 = HEAP32[i16 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 120 >> 2] | 0, i19 | 0, 4, 0);
 }
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) if ((HEAP32[i11 >> 2] | 0) == 1) {
  i19 = HEAP32[i16 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 120 >> 2] | 0, i19 | 0, 5, 0);
 }
 i1 = i13 + 148 | 0;
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i2 = i13 + 160 | 0;
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f6 = Math_fround(HEAPF32[i13 + 156 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f6 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f7 = Math_fround(f8 - f9);
 i19 = f5 < Math_fround(0.0);
 f5 = i19 ? Math_fround(0.0) : f5 > f7 ? f7 : f5;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = f8;
 HEAPF32[i14 + 24 >> 2] = f9;
 if (f5 == Math_fround(-1.0)) {
  f3 = Math_fround(f7 * Math_fround(.49000001));
  i19 = f3 > Math_fround(.100000001);
  f3 = i19 ? Math_fround(.100000001) : f3;
 } else f3 = f5;
 i4 = i14 + 16 | 0;
 HEAPF32[i4 >> 2] = f3;
 HEAPF32[i14 + 4 >> 2] = Math_fround(.5);
 i19 = HEAP32[i13 + 152 >> 2] | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 140 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 144 >> 2];
 f8 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i19 = f6 > Math_fround(0.0);
 f3 = i19 ? f5 : Math_fround(-1.0);
 if (f3 == Math_fround(-1.0)) {
  f3 = Math_fround(f7 * Math_fround(.49000001));
  i19 = f3 > Math_fround(.100000001);
  f3 = i19 ? Math_fround(.100000001) : f3;
 }
 i19 = f8 > Math_fround(0.0);
 i18 = f3 < Math_fround(.200000003);
 f9 = i18 ? Math_fround(.200000003) : f3;
 HEAPF32[i4 >> 2] = i19 ? Math_fround(9.99999974e-06) : f9;
 i19 = HEAP32[i16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 148 >> 2] | 0, i19 | 0, i14 | 0);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 if (f9 == Math_fround(HEAPF32[i2 >> 2])) if ((HEAP32[i12 >> 2] | 0) == 1) {
  i19 = HEAP32[i16 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 120 >> 2] | 0, i19 | 0, 3, 0);
 }
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i13 + 204 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 208 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 212 >> 2];
 mftCall_viii(i2 | 0, i1 | 0, 0, i14 | 0);
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i13 + 216 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 220 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 224 >> 2];
 mftCall_viii(i2 | 0, i1 | 0, 1, i14 | 0);
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i13 + 228 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 232 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 236 >> 2];
 mftCall_viii(i2 | 0, i1 | 0, 2, i14 | 0);
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 if (!(HEAP32[i13 + 288 >> 2] | 0)) {
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 + 252 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 256 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 260 >> 2];
  mftCall_viii(i2 | 0, i1 | 0, 4, i14 | 0);
  i18 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[(HEAP32[i18 >> 2] | 0) + 164 >> 2] | 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 + 240 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 244 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 248 >> 2];
  mftCall_viii(i19 | 0, i18 | 0, 3, i14 | 0);
  i18 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i19 = i19 + 172 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i4 = i13 + 296 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i10 = i13 + 300 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i13 + 304 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i13 + 308 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i20 = i13 + 312 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i1 = i13 + 316 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i13 + 320 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  i12 = i14 + 4 | 0;
  HEAP32[i12 >> 2] = i20;
  i12 = i14 + 8 | 0;
  HEAP32[i12 >> 2] = i1;
  i12 = i14 + 12 | 0;
  HEAP32[i12 >> 2] = i2;
  i12 = i14 + 16 | 0;
  HEAP32[i12 >> 2] = i4;
  i12 = i14 + 20 | 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i14 + 24 | 0;
  HEAP32[i12 >> 2] = i11;
  mftCall_vii(i19 | 0, i18 | 0, i14 | 0);
  i18 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i19 = i19 + 180 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i12 = i13 + 324 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i13 + 328 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i10 = i13 + 332 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  i12 = i14 + 4 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i14 + 8 | 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i13 + 336 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i10 = i13 + 340 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i13 + 344 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i15 >> 2] = i12;
  i12 = i15 + 4 | 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i15 + 8 | 0;
  HEAP32[i12 >> 2] = i11;
  mftCall_viii(i19 | 0, i18 | 0, i14 | 0, i15 | 0);
  i18 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i19 = i19 + 188 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i15 = i13 + 280 | 0;
  f9 = Math_fround(HEAPF32[i15 >> 2]);
  mftCall_vif(i19 | 0, i18 | 0, +f9);
  i18 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i19 = i19 + 196 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i15 = i13 + 284 | 0;
  f9 = Math_fround(HEAPF32[i15 >> 2]);
  f9 = Math_fround(f9 / Math_fround(360.0));
  f9 = Math_fround(f9 * Math_fround(2.0));
  f9 = Math_fround(f9 * Math_fround(3.14159274));
  mftCall_vif(i19 | 0, i18 | 0, +f9);
  i18 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i18 >> 2] | 0;
  i16 = i16 + 64 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i19 = i13 + 276 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i19 = (i19 | 0) == 1;
  mftCall_viii(i16 | 0, i18 | 0, 6, i19 | 0);
  STACKTOP = i17;
  return;
 } else {
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 + 264 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 268 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 272 >> 2];
  mftCall_viii(i2 | 0, i1 | 0, 5, i14 | 0);
  i19 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 172 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i10 = i13 + 296 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i13 + 300 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i13 + 304 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i20 = i13 + 308 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i1 = i13 + 312 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i13 + 316 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i4 = i13 + 320 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i14 >> 2] = i20;
  i20 = i14 + 4 | 0;
  HEAP32[i20 >> 2] = i1;
  i20 = i14 + 8 | 0;
  HEAP32[i20 >> 2] = i2;
  i20 = i14 + 12 | 0;
  HEAP32[i20 >> 2] = i4;
  i20 = i14 + 16 | 0;
  HEAP32[i20 >> 2] = i10;
  i20 = i14 + 20 | 0;
  HEAP32[i20 >> 2] = i11;
  i20 = i14 + 24 | 0;
  HEAP32[i20 >> 2] = i12;
  mftCall_vii(i18 | 0, i19 | 0, i14 | 0);
  i19 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 180 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i20 = i13 + 324 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i12 = i13 + 328 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i13 + 332 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i14 >> 2] = i20;
  i20 = i14 + 4 | 0;
  HEAP32[i20 >> 2] = i12;
  i20 = i14 + 8 | 0;
  HEAP32[i20 >> 2] = i11;
  i20 = i13 + 336 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i11 = i13 + 340 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i13 + 344 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i15 >> 2] = i20;
  i20 = i15 + 4 | 0;
  HEAP32[i20 >> 2] = i11;
  i20 = i15 + 8 | 0;
  HEAP32[i20 >> 2] = i12;
  mftCall_viii(i18 | 0, i19 | 0, i14 | 0, i15 | 0);
  i19 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 188 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i20 = i13 + 280 | 0;
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  mftCall_vif(i18 | 0, i19 | 0, +f9);
  i19 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 196 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i20 = i13 + 284 | 0;
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  f9 = Math_fround(f9 / Math_fround(360.0));
  f9 = Math_fround(f9 * Math_fround(2.0));
  f9 = Math_fround(f9 * Math_fround(3.14159274));
  mftCall_vif(i18 | 0, i19 | 0, +f9);
  i19 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 64 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i20 = i13 + 276 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i20 = (i20 | 0) == 1;
  mftCall_viii(i18 | 0, i19 | 0, 6, i20 | 0);
  STACKTOP = i17;
  return;
 }
}

function __ZN5physx18PxcContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i2, i8, i4, i3, i38, i1, i37) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 i37 = i37 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f39 = f0, f40 = f0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f7 * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f25 = Math_fround(f10 * Math_fround(2.0));
 f23 = Math_fround(Math_fround(f7 * f5) + Math_fround(Math_fround(f10 * f25) + Math_fround(-1.0)));
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f24 = Math_fround(f6 * f25);
 f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f23 = Math_fround(-f23);
 f24 = Math_fround(-Math_fround(f24 + Math_fround(f5 * f18)));
 f25 = Math_fround(-Math_fround(Math_fround(f5 * f6) - Math_fround(f25 * f18)));
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f35 = Math_fround(f5 + f5);
 f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f34 = Math_fround(f20 + f20);
 f39 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f30 = Math_fround(f39 + f39);
 f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f33 = Math_fround(f35 * f9);
 f32 = Math_fround(f34 * f9);
 f29 = Math_fround(f9 * f30);
 f31 = Math_fround(f5 * f34);
 f22 = Math_fround(f5 * f30);
 f34 = Math_fround(f20 * f34);
 f36 = Math_fround(f20 * f30);
 f30 = Math_fround(f39 * f30);
 f26 = Math_fround(Math_fround(Math_fround(1.0) - f34) - f30);
 f27 = Math_fround(f31 + f29);
 f28 = Math_fround(f22 - f32);
 f29 = Math_fround(f31 - f29);
 f35 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f35));
 f30 = Math_fround(f35 - f30);
 f31 = Math_fround(f36 + f33);
 f32 = Math_fround(f22 + f32);
 f33 = Math_fround(f36 - f33);
 f34 = Math_fround(f35 - f34);
 f35 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f7 = Math_fround(-f7);
 f18 = Math_fround(-f18);
 f6 = Math_fround(-f6);
 f40 = Math_fround(f35 - Math_fround(HEAPF32[i4 + 16 >> 2]));
 f21 = Math_fround(f36 - Math_fround(HEAPF32[i4 + 20 >> 2]));
 f40 = Math_fround(f40 * Math_fround(2.0));
 f21 = Math_fround(f21 * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i4 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f40 * f7) + Math_fround(f21 * f18)) + Math_fround(f19 * f6)) * f7) + Math_fround(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(-.5)) * f40) + Math_fround(f10 * Math_fround(Math_fround(f19 * f18) - Math_fround(f21 * f6)))));
 f19 = Math_fround(Math_fround(Math_fround(f39 * f18) + Math_fround(Math_fround(f9 * f7) + Math_fround(f5 * f10))) - Math_fround(f20 * f6));
 f40 = Math_fround(Math_fround(Math_fround(f5 * f6) + Math_fround(Math_fround(f9 * f18) + Math_fround(f20 * f10))) - Math_fround(f39 * f7));
 f14 = Math_fround(Math_fround(Math_fround(f20 * f7) + Math_fround(Math_fround(f9 * f6) + Math_fround(f39 * f10))) - Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f10) - Math_fround(f5 * f7)) - Math_fround(f20 * f18)) - Math_fround(f39 * f6));
 f39 = Math_fround(f40 + f40);
 f18 = Math_fround(f14 + f14);
 f14 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f40 * f39)) - Math_fround(f14 * f18));
 f40 = Math_fround(Math_fround(f19 * f39) - Math_fround(f6 * f18));
 f39 = Math_fround(Math_fround(f19 * f18) + Math_fround(f6 * f39));
 f6 = Math_fround(HEAPF32[i38 >> 2]);
 f21 = Math_fround(f6 - f21);
 f18 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f14 = Math_fround(f14 * f18);
 f40 = Math_fround(f40 * f19);
 f39 = Math_fround(f39 * f20);
 f7 = Math_fround(f14 + f40);
 f5 = Math_fround(Math_fround(f7 + f39) - f21);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 f7 = Math_fround(Math_fround(f7 - f39) - f21);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 f10 = Math_fround(f14 - f40);
 f9 = Math_fround(Math_fround(f10 + f39) - f21);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 f10 = Math_fround(Math_fround(f10 - f39) - f21);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 f16 = Math_fround(-f14);
 f14 = Math_fround(f40 - f14);
 f12 = Math_fround(Math_fround(f14 + f39) - f21);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f14 = Math_fround(Math_fround(f14 - f39) - f21);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 f40 = Math_fround(f16 - f40);
 f16 = Math_fround(Math_fround(f40 + f39) - f21);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 f21 = Math_fround(Math_fround(f40 - f39) - f21);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i3 | 0) < 0) {
  i2 = i37 + 4096 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 <= 63) {
   f40 = Math_fround(f6 + f5);
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f18) + Math_fround(f31 * f19)) + Math_fround(f34 * f20)));
   f6 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f18) + Math_fround(f30 * f19)) + Math_fround(f33 * f20)));
   f5 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f29 * f19)) + Math_fround(f32 * f20)));
   HEAP32[i2 >> 2] = i3 + 1;
   HEAPF32[i37 + (i3 << 6) >> 2] = f23;
   HEAPF32[i37 + (i3 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i3 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i3 << 6) + 16 >> 2] = f5;
   HEAPF32[i37 + (i3 << 6) + 20 >> 2] = f6;
   HEAPF32[i37 + (i3 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i3 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i3 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i3 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i1 | 0) < 0) {
  f5 = Math_fround(-f20);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f7 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f18) + Math_fround(f31 * f19)) + Math_fround(f34 * f5)));
   f7 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f18) + Math_fround(f30 * f19)) + Math_fround(f33 * f5)));
   f6 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f29 * f19)) + Math_fround(f32 * f5)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f6;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f7;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i4 | 0) < 0) {
  f5 = Math_fround(-f19);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f9 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f18) + Math_fround(f31 * f5)) + Math_fround(f34 * f20)));
   f9 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f18) + Math_fround(f30 * f5)) + Math_fround(f33 * f20)));
   f7 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f29 * f5)) + Math_fround(f32 * f20)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f7;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f9;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i8 | 0) < 0) {
  f5 = Math_fround(-f19);
  f6 = Math_fround(-f20);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f10 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f18) + Math_fround(f31 * f5)) + Math_fround(f34 * f6)));
   f10 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f18) + Math_fround(f30 * f5)) + Math_fround(f33 * f6)));
   f9 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f29 * f5)) + Math_fround(f32 * f6)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f9;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f10;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i11 | 0) < 0) {
  f5 = Math_fround(-f18);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f12 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f31 * f19)) + Math_fround(f34 * f20)));
   f12 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f5) + Math_fround(f30 * f19)) + Math_fround(f33 * f20)));
   f10 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f5) + Math_fround(f29 * f19)) + Math_fround(f32 * f20)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f10;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f12;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i13 | 0) < 0) {
  f5 = Math_fround(-f18);
  f6 = Math_fround(-f20);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f14 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f31 * f19)) + Math_fround(f34 * f6)));
   f14 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f5) + Math_fround(f30 * f19)) + Math_fround(f33 * f6)));
   f12 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f5) + Math_fround(f29 * f19)) + Math_fround(f32 * f6)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f12;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f14;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i15 | 0) < 0) {
  f5 = Math_fround(-f18);
  f6 = Math_fround(-f19);
  i1 = i37 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 <= 63) {
   f40 = Math_fround(f16 + Math_fround(HEAPF32[i38 >> 2]));
   f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f31 * f6)) + Math_fround(f34 * f20)));
   f16 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f5) + Math_fround(f30 * f6)) + Math_fround(f33 * f20)));
   f14 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f5) + Math_fround(f29 * f6)) + Math_fround(f32 * f20)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i37 + (i2 << 6) >> 2] = f23;
   HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
   HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
   HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f14;
   HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f16;
   HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
   HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
   HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
  }
 }
 if ((i17 | 0) >= 0) {
  i38 = i37 + 4096 | 0;
  i38 = HEAP32[i38 >> 2] | 0;
  i38 = (i38 | 0) != 0;
  return i38 | 0;
 }
 f7 = Math_fround(-f18);
 f6 = Math_fround(-f19);
 f5 = Math_fround(-f20);
 i1 = i37 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i38 = i1;
  i38 = HEAP32[i38 >> 2] | 0;
  i38 = (i38 | 0) != 0;
  return i38 | 0;
 }
 f40 = Math_fround(f21 + Math_fround(HEAPF32[i38 >> 2]));
 f39 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f7) + Math_fround(f31 * f6)) + Math_fround(f34 * f5)));
 f36 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f27 * f7) + Math_fround(f30 * f6)) + Math_fround(f33 * f5)));
 f35 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f26 * f7) + Math_fround(f29 * f6)) + Math_fround(f32 * f5)));
 HEAP32[i1 >> 2] = i2 + 1;
 HEAPF32[i37 + (i2 << 6) >> 2] = f23;
 HEAPF32[i37 + (i2 << 6) + 4 >> 2] = f24;
 HEAPF32[i37 + (i2 << 6) + 8 >> 2] = f25;
 HEAPF32[i37 + (i2 << 6) + 16 >> 2] = f35;
 HEAPF32[i37 + (i2 << 6) + 20 >> 2] = f36;
 HEAPF32[i37 + (i2 << 6) + 24 >> 2] = f39;
 HEAPF32[i37 + (i2 << 6) + 12 >> 2] = f40;
 HEAP32[i37 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i37 + (i2 << 6) + 52 >> 2] = -1;
 i38 = i1;
 i38 = HEAP32[i38 >> 2] | 0;
 i38 = (i38 | 0) != 0;
 return i38 | 0;
}

function __ZN9Animation14BlendOptimizedEv(i42) {
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, i54 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i51 + 48 | 0;
 i45 = i51 + 32 | 0;
 i46 = i51 + 16 | 0;
 i47 = i51;
 i48 = HEAP32[i42 + 96 >> 2] | 0;
 i49 = i42 + 120 | 0;
 i50 = HEAP32[i42 + 248 >> 2] | 0;
 HEAP32[i43 >> 2] = 0;
 i44 = i43 + 4 | 0;
 i40 = gb + 63160 | 0;
 i41 = HEAP32[i40 + 4 >> 2] | 0;
 i1 = i44;
 HEAP32[i1 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i1 + 4 >> 2] = i41;
 i1 = i50 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 1048) | 0;
   i40 = gb + 64016 | 0;
   i39 = HEAP32[i40 >> 2] | 0;
   i40 = HEAP32[i40 + 4 >> 2] | 0;
   HEAP32[i43 >> 2] = i1;
   i41 = i44;
   HEAP32[i41 >> 2] = i39;
   HEAP32[i41 + 4 >> 2] = i40;
   break;
  }
 } while (0);
 i23 = i1 + 3 & -4;
 i24 = i42 + 84 | 0;
 i1 = HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] | 0;
 __Z16CalculateWeightsILb1EEvPP14AnimationStateiiPfi(i49, i50, 0, i23, i1);
 i24 = HEAP32[i24 >> 2] | 0;
 if ((i48 | 0) <= 0) {
  i50 = HEAP32[i43 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i50, i44);
  STACKTOP = i51;
  return;
 }
 i25 = (i50 | 0) > 0;
 i19 = i45 + 4 | 0;
 i21 = i45 + 8 | 0;
 i17 = i45 + 12 | 0;
 i26 = i45 + 4 | 0;
 i27 = i45 + 8 | 0;
 i28 = i47 + 4 | 0;
 i29 = i47 + 8 | 0;
 i20 = i46 + 4 | 0;
 i22 = i46 + 8 | 0;
 i18 = i46 + 12 | 0;
 f30 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i31 = i45 + 4 | 0;
 i32 = i45 + 8 | 0;
 i33 = i45 + 12 | 0;
 i34 = i45 + 4 | 0;
 i35 = i45 + 8 | 0;
 i36 = i45 + 4 | 0;
 i37 = i45 + 8 | 0;
 i38 = i45 + 4 | 0;
 i39 = i45 + 8 | 0;
 i40 = i45 + 4 | 0;
 i41 = i45 + 8 | 0;
 i16 = 0;
 i2 = 0;
 do {
  i9 = i24 + (i16 * 24 | 0) | 0;
  i3 = HEAP32[i24 + (i16 * 24 | 0) + 20 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   __Z16CalculateWeightsILb1EEvPP14AnimationStateiiPfi(i49, i50, i16, i23, i3);
   i1 = i3;
  }
  L15 : do if (i1) {
   i6 = i24 + (i16 * 24 | 0) + 4 | 0;
   i14 = HEAP32[i6 >> 2] | 0;
   i3 = (i14 | 0) == 2;
   switch (i14 | 0) {
   case 0:
    break L15;
   case 2:
   case 4:
    {
     if (i25) if (i3) {
      i10 = 0;
      i14 = 1;
      i5 = 0;
      i6 = 0;
      i9 = 0;
      i3 = 0;
      while (1) {
       if (i14 & i1) {
        i54 = HEAP32[i42 + 120 + (i10 << 2) >> 2] | 0;
        __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i45, HEAP32[(HEAP32[i54 + 4 >> 2] | 0) + (i16 << 2) >> 2] | 0, Math_fround(HEAPF32[i54 + 12 >> 2]), 0);
        f4 = Math_fround(HEAPF32[i45 >> 2]);
        f8 = Math_fround(HEAPF32[i19 >> 2]);
        f12 = Math_fround(HEAPF32[i21 >> 2]);
        f52 = Math_fround(HEAPF32[i17 >> 2]);
        f53 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f15 = Math_fround(f53 * f4);
        f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f15 = Math_fround(f15 + Math_fround(f7 * f8));
        f11 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f15 = Math_fround(f15 + Math_fround(f11 * f12));
        f13 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i5 = Math_fround(f15 + Math_fround(f13 * f52)) < Math_fround(0.0);
        f15 = i5 ? Math_fround(-1.0) : Math_fround(1.0);
        f4 = Math_fround(f4 * f15);
        f8 = Math_fround(f8 * f15);
        f12 = Math_fround(f12 * f15);
        f15 = Math_fround(f52 * f15);
        f52 = Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f8 = Math_fround(f52 * f8);
        f12 = Math_fround(f52 * f12);
        f15 = Math_fround(f52 * f15);
        f4 = Math_fround(f53 + Math_fround(f52 * f4));
        i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
        f8 = Math_fround(f7 + f8);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
        f12 = Math_fround(f11 + f12);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
        f15 = Math_fround(f13 + f15);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
       }
       i10 = i10 + 1 | 0;
       if ((i10 | 0) == (i50 | 0)) break; else i14 = i14 << 1;
      }
     } else {
      i10 = 0;
      i14 = 1;
      i5 = 0;
      i6 = 0;
      i9 = 0;
      i3 = 0;
      while (1) {
       if (i14 & i1) {
        i54 = HEAP32[i42 + 120 + (i10 << 2) >> 2] | 0;
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i45, HEAP32[(HEAP32[i54 + 4 >> 2] | 0) + (i16 << 2) >> 2] | 0, Math_fround(HEAPF32[i54 + 12 >> 2]), 0);
        f15 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) * Math_fround(.0174532924));
        f12 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * Math_fround(.0174532924));
        f8 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(.0174532924));
        HEAPF32[i47 >> 2] = f15;
        HEAPF32[i28 >> 2] = f12;
        HEAPF32[i29 >> 2] = f8;
        __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i46, i47, 4);
        f8 = Math_fround(HEAPF32[i46 >> 2]);
        f12 = Math_fround(HEAPF32[i20 >> 2]);
        f15 = Math_fround(HEAPF32[i22 >> 2]);
        f7 = Math_fround(HEAPF32[i18 >> 2]);
        f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = Math_fround(f4 * f8);
        f11 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = Math_fround(f53 + Math_fround(f11 * f12));
        f13 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f53 = Math_fround(f53 + Math_fround(f13 * f15));
        f52 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        i5 = Math_fround(f53 + Math_fround(f52 * f7)) < Math_fround(0.0);
        f53 = i5 ? Math_fround(-1.0) : Math_fround(1.0);
        f8 = Math_fround(f8 * f53);
        f12 = Math_fround(f12 * f53);
        f15 = Math_fround(f15 * f53);
        f53 = Math_fround(f7 * f53);
        f7 = Math_fround(HEAPF32[i23 + (i10 << 2) >> 2]);
        f12 = Math_fround(f7 * f12);
        f15 = Math_fround(f7 * f15);
        f53 = Math_fround(f7 * f53);
        f8 = Math_fround(f4 + Math_fround(f7 * f8));
        i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
        f12 = Math_fround(f11 + f12);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
        f15 = Math_fround(f13 + f15);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
        f53 = Math_fround(f52 + f53);
        i9 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
       }
       i10 = i10 + 1 | 0;
       if ((i10 | 0) == (i50 | 0)) break; else i14 = i14 << 1;
      }
     } else {
      i5 = 0;
      i6 = 0;
      i9 = 0;
      i3 = 0;
     }
     f15 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f15 * f15);
     f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 + Math_fround(f13 * f13));
     f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(f12 + Math_fround(f7 * f7));
     f4 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f4 * f4))));
     if (f12 < f30) {
      f11 = Math_fround(1.0);
      f8 = Math_fround(0.0);
      f7 = Math_fround(0.0);
      f4 = Math_fround(0.0);
     } else {
      f11 = Math_fround(f4 / f12);
      f8 = Math_fround(f7 / f12);
      f7 = Math_fround(f13 / f12);
      f4 = Math_fround(f15 / f12);
     }
     i54 = HEAP32[i24 + (i16 * 24 | 0) + 12 >> 2] | 0;
     HEAPF32[i45 >> 2] = f4;
     HEAPF32[i31 >> 2] = f7;
     HEAPF32[i32 >> 2] = f8;
     HEAPF32[i33 >> 2] = f11;
     __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i54, i45);
     break L15;
    }
   case 1:
    {
     if (i25) {
      i9 = 0;
      i10 = 1;
      i6 = 0;
      i5 = 0;
      i3 = 0;
      while (1) {
       if (i10 & i1) {
        i54 = HEAP32[i42 + 120 + (i9 << 2) >> 2] | 0;
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i45, HEAP32[(HEAP32[i54 + 4 >> 2] | 0) + (i16 << 2) >> 2] | 0, Math_fround(HEAPF32[i54 + 12 >> 2]), 0);
        f53 = Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
        f15 = Math_fround(f53 * Math_fround(HEAPF32[i45 >> 2]));
        f52 = Math_fround(f53 * Math_fround(HEAPF32[i34 >> 2]));
        f53 = Math_fround(f53 * Math_fround(HEAPF32[i35 >> 2]));
        f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f15);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
        f52 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f52);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
        f53 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f53);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
       }
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i50 | 0)) break; else i10 = i10 << 1;
      }
     } else {
      i6 = 0;
      i5 = 0;
      i3 = 0;
     }
     i54 = HEAP32[i24 + (i16 * 24 | 0) + 12 >> 2] | 0;
     HEAP32[i45 >> 2] = i6;
     HEAP32[i36 >> 2] = i3;
     HEAP32[i37 >> 2] = i5;
     __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i54, i45);
     break L15;
    }
   case 3:
    {
     if (i25) {
      i9 = 0;
      i10 = 1;
      i6 = 0;
      i5 = 0;
      i3 = 0;
      while (1) {
       if (i10 & i1) {
        i54 = HEAP32[i42 + 120 + (i9 << 2) >> 2] | 0;
        __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i45, HEAP32[(HEAP32[i54 + 4 >> 2] | 0) + (i16 << 2) >> 2] | 0, Math_fround(HEAPF32[i54 + 12 >> 2]), 0);
        f53 = Math_fround(HEAPF32[i23 + (i9 << 2) >> 2]);
        f15 = Math_fround(f53 * Math_fround(HEAPF32[i45 >> 2]));
        f52 = Math_fround(f53 * Math_fround(HEAPF32[i38 >> 2]));
        f53 = Math_fround(f53 * Math_fround(HEAPF32[i39 >> 2]));
        f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f15);
        i6 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
        f52 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f52);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
        f53 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f53);
        i5 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
       }
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == (i50 | 0)) break; else i10 = i10 << 1;
      }
     } else {
      i6 = 0;
      i5 = 0;
      i3 = 0;
     }
     i54 = HEAP32[i24 + (i16 * 24 | 0) + 12 >> 2] | 0;
     HEAP32[i45 >> 2] = i6;
     HEAP32[i40 >> 2] = i3;
     HEAP32[i41 >> 2] = i5;
     __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i54, i45);
     break L15;
    }
   default:
    {
     if (i25) {
      i3 = 0;
      i5 = 1;
      f4 = Math_fround(0.0);
      while (1) {
       if (i5 & i1) {
        i54 = HEAP32[i42 + 120 + (i3 << 2) >> 2] | 0;
        f53 = Math_fround(__ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE(HEAP32[(HEAP32[i54 + 4 >> 2] | 0) + (i16 << 2) >> 2] | 0, Math_fround(HEAPF32[i54 + 12 >> 2]), 0));
        f4 = Math_fround(f4 + Math_fround(f53 * Math_fround(HEAPF32[i23 + (i3 << 2) >> 2])));
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i50 | 0)) break; else i5 = i5 << 1;
      }
     } else f4 = Math_fround(0.0);
     __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf(i9, f4) | 0;
     if (((HEAP32[i6 >> 2] | 0) + -5 | 0) >>> 0 >= 2) break L15;
     i3 = HEAP32[i24 + (i16 * 24 | 0) + 12 >> 2] | 0;
     if ((i2 | 0) == (i3 | 0)) break L15;
     if (!i2) {
      i2 = i3;
      break L15;
     }
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
     i2 = i3;
     break L15;
    }
   }
  } while (0);
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) != (i48 | 0));
 if (!i2) {
  i54 = HEAP32[i43 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i54, i44);
  STACKTOP = i51;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 i54 = HEAP32[i43 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i54, i44);
 STACKTOP = i51;
 return;
}
function __ZN5Unity5Cloth19SetUpSkinnedBuffersEPvS1_S1_j(i25, i20, i21, i1, i22) {
 i25 = i25 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 8 | 0;
 i16 = i24;
 i11 = i24 + 56 | 0;
 i14 = i24 + 36 | 0;
 i23 = i24 + 16 | 0;
 if ((HEAP16[gb + 1458920 + 6 >> 1] | 0) > -1) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458920 | 0, i15);
  i19 = gb + 1458920 | 0;
 } else i19 = 0;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i25 + 28 >> 2] | 0, gb + 31632 | 0) | 0;
 i4 = __ZN19SkinnedMeshRenderer7GetMeshEv(i13) | 0;
 i18 = i25 + 236 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i16 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
    i2 = HEAP32[i15 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 11;
   }
  }
  if ((i8 | 0) == 9) i8 = 11;
  if ((i8 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i18 >> 2] | 0) | 0;
 }
 if ((i4 | 0) == (i1 | 0)) {
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
    i2 = HEAP32[i15 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 21;
   }
  }
  if ((i8 | 0) == 19) i8 = 21;
  if ((i8 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i18 >> 2] | 0) | 0;
  if ((HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i25 + 244 >> 2] | 0)) i8 = 23;
 } else i8 = 23;
 if ((i8 | 0) == 23) __ZN5Unity5Cloth6CreateEv(i25);
 i17 = i25 + 228 | 0;
 if (HEAP32[i17 >> 2] | 0) {
  __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(__ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i13) | 0, i11 + 16 | 0, i11);
  i1 = HEAP32[i17 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i11 | 0);
  i1 = i25 + 358 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) if (__Z14IsWorldPlayingv() | 0) i10 = i25 + 240 | 0; else i8 = 28; else i8 = 28;
  if ((i8 | 0) == 28) {
   HEAP8[i1 >> 0] = 0;
   i6 = HEAP32[i17 >> 2] | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0) | 0;
   i9 = gb + 64016 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i4 = i16;
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = i8;
   HEAP32[i14 >> 2] = 0;
   i4 = i14 + 12 | 0;
   HEAP32[i4 >> 2] = 0;
   i8 = i14 + 16 | 0;
   HEAP32[i8 >> 2] = 0;
   i9 = i14 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i16);
   i1 = i15;
   i10 = HEAP32[i1 + 4 >> 2] | 0;
   i5 = i9;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = i10;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   i10 = i25 + 240 | 0;
   i1 = HEAP32[i10 >> 2] << 4;
   i2 = i1 >> 4;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[i8 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i8 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i14 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i4 >> 2] << 4 | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i14 >> 2] = i1;
    break;
   } else i1 = HEAP32[i14 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i5 | 0, HEAP32[i4 >> 2] << 4 | 0) | 0;
   i2 = HEAP32[i25 + 244 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i25 + 248 >> 2] | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    i1 = 0;
    do {
     i5 = HEAPU16[i3 + (i1 << 1) >> 1] | 0;
     i28 = i20 + (Math_imul(i1, i22) | 0) | 0;
     i27 = HEAP32[i28 + 4 >> 2] | 0;
     i26 = HEAP32[i28 + 8 >> 2] | 0;
     HEAP32[i4 + (i5 << 4) >> 2] = HEAP32[i28 >> 2];
     HEAP32[i4 + (i5 << 4) + 4 >> 2] = i27;
     HEAP32[i4 + (i5 << 4) + 8 >> 2] = i26;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0);
   i27 = HEAP32[i17 >> 2] | 0;
   i28 = HEAP32[i14 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 100 >> 2] | 0, i27 | 0, i28 | 0, i28 | 0);
   i28 = HEAP32[i17 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 120 >> 2] | 0, i28 | 0, i11 | 0);
   i28 = HEAP32[i17 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i28 >> 2] | 0) + 256 >> 2] | 0, i28 | 0);
   if ((HEAP32[i8 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i9);
    HEAP32[i14 >> 2] = 0;
   }
  }
  __ZNK9Transform18GetWorldScaleLossyEv(i14, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i13) | 0);
  f12 = Math_fround(HEAPF32[i14 >> 2]);
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i14 + 4 >> 2]));
  f12 = Math_fround(Math_fround(f12 + Math_fround(HEAPF32[i14 + 8 >> 2])) / Math_fround(3.0));
  i14 = gb + 64016 | 0;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i11 = i16;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i11 + 4 >> 2] = i13;
  HEAP32[i23 >> 2] = 0;
  i11 = i23 + 12 | 0;
  HEAP32[i11 >> 2] = 0;
  i13 = i23 + 16 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i16);
  i28 = i15;
  i2 = HEAP32[i28 + 4 >> 2] | 0;
  i1 = i14;
  HEAP32[i1 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = HEAP32[i13 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 4, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i28 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i11 >> 2] << 4 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i23 >> 2] = i28;
   break;
  } while (0);
  i9 = i25 + 244 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (!i4) i8 = 49; else {
   i5 = HEAP32[i25 + 248 >> 2] | 0;
   i6 = HEAP32[i23 >> 2] | 0;
   i8 = HEAP32[i25 + 128 >> 2] | 0;
   i1 = 0;
   i3 = 0;
   do {
    i2 = HEAPU16[i5 + (i3 << 1) >> 1] | 0;
    i26 = i20 + (Math_imul(i3, i22) | 0) | 0;
    i27 = HEAP32[i26 + 4 >> 2] | 0;
    i28 = HEAP32[i26 + 8 >> 2] | 0;
    HEAP32[i6 + (i2 << 4) >> 2] = HEAP32[i26 >> 2];
    HEAP32[i6 + (i2 << 4) + 4 >> 2] = i27;
    HEAP32[i6 + (i2 << 4) + 8 >> 2] = i28;
    i28 = HEAP32[i8 + (i2 << 3) >> 2] | 0;
    i2 = i6 + (i2 << 4) + 12 | 0;
    HEAP32[i2 >> 2] = i28;
    f7 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f7 < Math_fround(3402823469999999843913219.0e14)) {
     HEAPF32[i2 >> 2] = Math_fround(f12 * f7);
     i1 = 1;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i4 >>> 0);
   if (i1) i8 = 50; else i8 = 49;
  }
  if ((i8 | 0) == 49) if (Math_fround(HEAPF32[i25 + 340 >> 2]) != Math_fround(1.0)) i8 = 50; else {
   i28 = HEAP32[i17 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 232 >> 2] | 0, i28 | 0) | 0) {
    i28 = HEAP32[i17 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 224 >> 2] | 0, i28 | 0, 0);
   }
  }
  if ((i8 | 0) == 50) {
   i28 = HEAP32[i17 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 224 >> 2] | 0, i28 | 0, HEAP32[i23 >> 2] | 0);
  }
  if (!i21) i8 = 71; else {
   HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 59; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
     i2 = HEAP32[i15 >> 2] | 0;
     i28 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i28 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i28 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 59; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 61;
    }
   }
   if ((i8 | 0) == 59) i8 = 61;
   if ((i8 | 0) == 61) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i18 >> 2] | 0) | 0;
   i1 = i1 + 48 | 0;
   f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f7 = Math_fround(f7 * f7);
   f29 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f29 = Math_fround(f7 + Math_fround(f29 * f29));
   f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   f7 = Math_fround(Math_sqrt(Math_fround(f29 + Math_fround(f7 * f7))));
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = HEAP32[i13 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i13 >> 2] = i1;
    HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 4, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i28 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i11 >> 2] << 4 | 0) | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i23 >> 2] = i28;
    break;
   } while (0);
   i3 = HEAP32[i9 >> 2] | 0;
   if (!i3) i8 = 71; else {
    i4 = HEAP32[i25 + 248 >> 2] | 0;
    i5 = HEAP32[i25 + 128 >> 2] | 0;
    i6 = HEAP32[i23 >> 2] | 0;
    i1 = 0;
    i2 = 0;
    do {
     i28 = HEAPU16[i4 + (i2 << 1) >> 1] | 0;
     i27 = i21 + (Math_imul(i2, i22) | 0) | 0;
     f33 = Math_fround(HEAPF32[i27 >> 2]);
     f32 = Math_fround(HEAPF32[i27 + 4 >> 2]);
     f31 = Math_fround(HEAPF32[i27 + 8 >> 2]);
     f29 = Math_fround(Math_fround(HEAPF32[i5 + (i28 << 3) >> 2]) * Math_fround(2.0));
     f29 = f7 < f29 ? f7 : f29;
     f30 = Math_fround(Math_fround(HEAPF32[i5 + (i28 << 3) + 4 >> 2]) + f29);
     f33 = Math_fround(f33 * f30);
     f32 = Math_fround(f32 * f30);
     f31 = Math_fround(f31 * f30);
     i27 = i6 + (i28 << 4) | 0;
     HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f33);
     i27 = i6 + (i28 << 4) + 4 | 0;
     HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f32);
     i27 = i6 + (i28 << 4) + 8 | 0;
     HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f31);
     i27 = f30 < Math_fround(3402823469999999843913219.0e14);
     f30 = Math_fround(f12 * f29);
     i1 = i27 ? 1 : i1;
     HEAPF32[i6 + (i28 << 4) + 12 >> 2] = i27 ? f30 : f29;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i3 >>> 0);
    if (!(i1 & 1)) i8 = 71; else {
     i28 = HEAP32[i17 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 244 >> 2] | 0, i28 | 0, HEAP32[i23 >> 2] | 0);
    }
   }
  }
  if ((i8 | 0) == 71) {
   i28 = HEAP32[i17 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 252 >> 2] | 0, i28 | 0) | 0) {
    i28 = HEAP32[i17 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 244 >> 2] | 0, i28 | 0, 0);
   }
  }
  HEAP32[i25 + 328 >> 2] = i20;
  HEAP32[i25 + 332 >> 2] = i21;
  HEAP32[i25 + 336 >> 2] = i22;
  __ZN5Unity5Cloth15UpdateCollidersEv(i25);
  i1 = HEAP32[i25 + 220 >> 2] | 0;
  if (i1 | 0) {
   i28 = HEAP32[i17 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 284 >> 2] | 0, i28 | 0, HEAP32[i25 + 208 >> 2] | 0, i1 | 0);
  }
  if ((HEAP32[i13 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i14);
   HEAP32[i23 >> 2] = 0;
  }
 }
 if (!i19) {
  STACKTOP = i24;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i24;
 return;
}

function __Z15SampleAnimationR10GameObjectR13AnimationClipfi(i4, i31, f5, i3) {
 i4 = i4 | 0;
 i31 = i31 | 0;
 f5 = Math_fround(f5);
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i40 + 80 | 0;
 i36 = i40 + 64 | 0;
 i37 = i40 + 40 | 0;
 i38 = i40 + 16 | 0;
 i30 = i40;
 if ((HEAP16[gb + 1467100 + 6 >> 1] | 0) > -1) {
  HEAP32[i36 >> 2] = i4;
  HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467100 | 0, i34);
  i35 = gb + 1467100 | 0;
 } else i35 = 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 HEAP32[i38 + 16 >> 2] = 0;
 HEAP32[i38 + 20 >> 2] = 0;
 __ZN13AnimationClip8GetRangeEv(i34, i31);
 f1 = Math_fround(HEAPF32[i34 >> 2]);
 f2 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 L4 : do if (!(f2 <= f5)) if (f1 > f5) {
  switch (i3 | 0) {
  case 1:
  case 8:
   break L4;
  case 2:
   {
    f28 = Math_fround(f5 - f1);
    f29 = Math_fround(f2 - f1);
    f1 = Math_fround(f1 + Math_fround(f28 - Math_fround(f29 * Math_fround(Math_floor(Math_fround(f28 / f29))))));
    break L4;
   }
  default:
   {}
  }
  if ((i3 | 0) == 4) {
   f28 = Math_fround(f5 - f1);
   f27 = Math_fround(f2 - f1);
   f29 = Math_fround(f27 * Math_fround(2.0));
   f29 = Math_fround(Math_fround(f28 - Math_fround(f29 * Math_fround(Math_floor(Math_fround(f28 / f29))))) - f27);
   i33 = f29 < Math_fround(0.0);
   f28 = Math_fround(-f29);
   f1 = Math_fround(f1 + Math_fround(f27 - (i33 ? f28 : f29)));
  } else f1 = f5;
 } else f1 = f5; else {
  switch (i3 | 0) {
  case 1:
  case 8:
   {
    f1 = f2;
    break L4;
   }
  case 2:
   {
    f28 = Math_fround(f5 - f1);
    f29 = Math_fround(f2 - f1);
    f1 = Math_fround(f1 + Math_fround(f28 - Math_fround(f29 * Math_fround(Math_floor(Math_fround(f28 / f29))))));
    break L4;
   }
  default:
   {}
  }
  if ((i3 | 0) == 4) {
   f28 = Math_fround(f5 - f1);
   f27 = Math_fround(f2 - f1);
   f29 = Math_fround(f27 * Math_fround(2.0));
   f29 = Math_fround(Math_fround(f28 - Math_fround(f29 * Math_fround(Math_floor(Math_fround(f28 / f29))))) - f27);
   i33 = f29 < Math_fround(0.0);
   f28 = Math_fround(-f29);
   f1 = Math_fround(f1 + Math_fround(f27 - (i33 ? f28 : f29)));
  } else f1 = f5;
 } while (0);
 i32 = HEAP32[gb + 1465224 >> 2] | 0;
 i33 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 67008 | 0) | 0;
 if (!i3) i39 = 15; else if (!(__ZN8Animator6SampleER13AnimationClipf(i3, i31, f5) | 0)) i39 = 15;
 if ((i39 | 0) == 15) {
  i3 = HEAP32[i31 + 100 >> 2] | 0;
  i11 = i31 + 104 | 0;
  if ((i3 | 0) != (HEAP32[i11 >> 2] | 0)) {
   i12 = i36 + 4 | 0;
   i7 = i37 + 4 | 0;
   i8 = i37 + 8 | 0;
   i9 = i37 + 12 | 0;
   i10 = i37 + 16 | 0;
   i13 = i34 + 4 | 0;
   i14 = i34 + 8 | 0;
   i15 = i34 + 12 | 0;
   f29 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i16 = i38 + 12 | 0;
   i17 = i34 + 4 | 0;
   i18 = i34 + 8 | 0;
   i19 = i34 + 12 | 0;
   do {
    i6 = i3 + 16 | 0;
    do if (HEAP32[i3 + 180 >> 2] | 0) {
     __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i34, i6);
     if ((HEAP32[i34 >> 2] & 2139095040 | 0) == 2139095040) break;
     __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i36, i6);
     if ((HEAP32[i12 >> 2] & 2139095040 | 0) != 2139095040) {
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i4 = HEAP32[i3 >> 2] | 0; else i4 = i3;
      HEAP32[i37 >> 2] = i4;
      HEAP32[i7 >> 2] = 4;
      HEAP32[i8 >> 2] = gb + 896768;
      HEAP32[i9 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      if (__ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i32, i37, i38, i33) | 0) {
       __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i34, i6, f1, 0);
       f27 = Math_fround(HEAPF32[i34 >> 2]);
       f28 = Math_fround(f27 * f27);
       f25 = Math_fround(HEAPF32[i13 >> 2]);
       f28 = Math_fround(f28 + Math_fround(f25 * f25));
       f5 = Math_fround(HEAPF32[i14 >> 2]);
       f28 = Math_fround(f28 + Math_fround(f5 * f5));
       f2 = Math_fround(HEAPF32[i15 >> 2]);
       f28 = Math_fround(Math_sqrt(Math_fround(f28 + Math_fround(f2 * f2))));
       if (f28 < f29) {
        f26 = Math_fround(1.0);
        f24 = Math_fround(0.0);
        f5 = Math_fround(0.0);
        f2 = Math_fround(0.0);
       } else {
        f26 = Math_fround(f2 / f28);
        f24 = Math_fround(f5 / f28);
        f5 = Math_fround(f25 / f28);
        f2 = Math_fround(f27 / f28);
       }
       i23 = HEAP32[i16 >> 2] | 0;
       HEAPF32[i34 >> 2] = f2;
       HEAPF32[i17 >> 2] = f5;
       HEAPF32[i18 >> 2] = f24;
       HEAPF32[i19 >> 2] = f26;
       __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i23, i34);
      }
     }
    } while (0);
    i3 = i3 + 204 | 0;
   } while ((i3 | 0) != (HEAP32[i11 >> 2] | 0));
  }
  i3 = HEAP32[i31 + 116 >> 2] | 0;
  i11 = i31 + 120 | 0;
  if ((i3 | 0) != (HEAP32[i11 >> 2] | 0)) {
   i12 = i36 + 4 | 0;
   i7 = i37 + 4 | 0;
   i8 = i37 + 8 | 0;
   i9 = i37 + 12 | 0;
   i10 = i37 + 16 | 0;
   i13 = i34 + 4 | 0;
   i14 = i34 + 8 | 0;
   i15 = i30 + 4 | 0;
   i16 = i30 + 8 | 0;
   i17 = i38 + 12 | 0;
   i18 = i36 + 4 | 0;
   i19 = i36 + 8 | 0;
   i20 = i36 + 12 | 0;
   i21 = i30 + 4 | 0;
   i22 = i30 + 8 | 0;
   i23 = i30 + 12 | 0;
   do {
    i4 = i3 + 16 | 0;
    do if (HEAP32[i3 + 148 >> 2] | 0) {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i34, i4);
     if ((HEAP32[i34 >> 2] & 2139095040 | 0) == 2139095040) break;
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i36, i4);
     if ((HEAP32[i12 >> 2] & 2139095040 | 0) != 2139095040) {
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i6 = HEAP32[i3 >> 2] | 0; else i6 = i3;
      HEAP32[i37 >> 2] = i6;
      HEAP32[i7 >> 2] = 4;
      HEAP32[i8 >> 2] = gb + 896768;
      HEAP32[i9 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      if (__ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i32, i37, i38, i33) | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i34, i4, f1, 0);
       f27 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) * Math_fround(.0174532942));
       f28 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(.0174532942));
       f29 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(.0174532942));
       HEAPF32[i30 >> 2] = f27;
       HEAPF32[i15 >> 2] = f28;
       HEAPF32[i16 >> 2] = f29;
       __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i36, i30, HEAP32[i3 + 164 >> 2] | 0);
       i6 = HEAP32[i17 >> 2] | 0;
       i42 = HEAP32[i18 >> 2] | 0;
       i41 = HEAP32[i19 >> 2] | 0;
       i4 = HEAP32[i20 >> 2] | 0;
       HEAP32[i30 >> 2] = HEAP32[i36 >> 2];
       HEAP32[i21 >> 2] = i42;
       HEAP32[i22 >> 2] = i41;
       HEAP32[i23 >> 2] = i4;
       __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i6, i30);
      }
     }
    } while (0);
    i3 = i3 + 172 | 0;
   } while ((i3 | 0) != (HEAP32[i11 >> 2] | 0));
  }
  i3 = HEAP32[i31 + 132 >> 2] | 0;
  i13 = i31 + 136 | 0;
  if ((i3 | 0) != (HEAP32[i13 >> 2] | 0)) {
   i14 = i36 + 4 | 0;
   i9 = i37 + 4 | 0;
   i10 = i37 + 8 | 0;
   i11 = i37 + 12 | 0;
   i12 = i37 + 16 | 0;
   i15 = i38 + 12 | 0;
   i7 = i34 + 4 | 0;
   i8 = i34 + 8 | 0;
   i16 = i36 + 4 | 0;
   i17 = i36 + 8 | 0;
   do {
    i4 = i3 + 16 | 0;
    do if (HEAP32[i3 + 148 >> 2] | 0) {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i34, i4);
     if ((HEAP32[i34 >> 2] & 2139095040 | 0) == 2139095040) break;
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i36, i4);
     if ((HEAP32[i14 >> 2] & 2139095040 | 0) != 2139095040) {
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i6 = HEAP32[i3 >> 2] | 0; else i6 = i3;
      HEAP32[i37 >> 2] = i6;
      HEAP32[i9 >> 2] = 4;
      HEAP32[i10 >> 2] = gb + 896797;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i12 >> 2] = 0;
      if (__ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i32, i37, i38, i33) | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i34, i4, f1, 0);
       i42 = HEAP32[i15 >> 2] | 0;
       i30 = HEAP32[i7 >> 2] | 0;
       i41 = HEAP32[i8 >> 2] | 0;
       HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i16 >> 2] = i30;
       HEAP32[i17 >> 2] = i41;
       __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i42, i36);
      }
     }
    } while (0);
    i3 = i3 + 172 | 0;
   } while ((i3 | 0) != (HEAP32[i13 >> 2] | 0));
  }
  i3 = HEAP32[i31 + 148 >> 2] | 0;
  i13 = i31 + 152 | 0;
  if ((i3 | 0) != (HEAP32[i13 >> 2] | 0)) {
   i14 = i36 + 4 | 0;
   i9 = i37 + 4 | 0;
   i10 = i37 + 8 | 0;
   i11 = i37 + 12 | 0;
   i12 = i37 + 16 | 0;
   i15 = i38 + 12 | 0;
   i7 = i34 + 4 | 0;
   i8 = i34 + 8 | 0;
   i16 = i36 + 4 | 0;
   i17 = i36 + 8 | 0;
   do {
    i4 = i3 + 16 | 0;
    do if (HEAP32[i3 + 148 >> 2] | 0) {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i34, i4);
     if ((HEAP32[i34 >> 2] & 2139095040 | 0) == 2139095040) break;
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i36, i4);
     if ((HEAP32[i14 >> 2] & 2139095040 | 0) != 2139095040) {
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i6 = HEAP32[i3 >> 2] | 0; else i6 = i3;
      HEAP32[i37 >> 2] = i6;
      HEAP32[i9 >> 2] = 4;
      HEAP32[i10 >> 2] = gb + 896813;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i12 >> 2] = 0;
      if (__ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i32, i37, i38, i33) | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i34, i4, f1, 0);
       i42 = HEAP32[i15 >> 2] | 0;
       i30 = HEAP32[i7 >> 2] | 0;
       i41 = HEAP32[i8 >> 2] | 0;
       HEAP32[i36 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i16 >> 2] = i30;
       HEAP32[i17 >> 2] = i41;
       __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i42, i36);
      }
     }
    } while (0);
    i3 = i3 + 172 | 0;
   } while ((i3 | 0) != (HEAP32[i13 >> 2] | 0));
  }
  i3 = HEAP32[i31 + 164 >> 2] | 0;
  i16 = i31 + 168 | 0;
  if ((i3 | 0) != (HEAP32[i16 >> 2] | 0)) {
   i17 = i36 + 4 | 0;
   i12 = i37 + 4 | 0;
   i13 = i37 + 8 | 0;
   i14 = i37 + 12 | 0;
   i15 = i37 + 16 | 0;
   i18 = i38 + 4 | 0;
   i19 = i38 + 12 | 0;
   do {
    i9 = i3 + 40 | 0;
    do if (HEAP32[i3 + 108 >> 2] | 0) {
     __ZNK17AnimationCurveTplIfE8GetRangeEv(i34, i9);
     if ((HEAP32[i34 >> 2] & 2139095040 | 0) == 2139095040) break;
     __ZNK17AnimationCurveTplIfE8GetRangeEv(i36, i9);
     if ((HEAP32[i17 >> 2] & 2139095040 | 0) != 2139095040) {
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i11 = HEAP32[i3 >> 2] | 0; else i11 = i3;
      i10 = HEAP32[i3 + 32 >> 2] | 0;
      i8 = i3 + 36 | 0;
      i4 = HEAP32[i8 >> 2] | 0;
      if (!i4) i4 = 0; else {
       HEAP32[i36 >> 2] = i4;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       do if (!i4) i39 = 81; else {
        if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
         i6 = HEAP32[i4 + 28 >> 2] | 0;
         i7 = HEAP32[i4 + 32 >> 2] | 0;
         i4 = i6 + (i7 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i34, i4, i36);
         i6 = HEAP32[i34 >> 2] | 0;
         i42 = HEAP32[i4 + 28 >> 2] | 0;
         i7 = HEAP32[gb + 1104264 >> 2] | 0;
         i4 = (i6 | 0) == -1 ? i42 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i42 + (i6 << 3) | 0;
         i6 = HEAP32[i7 + 28 >> 2] | 0;
         i7 = HEAP32[i7 + 32 >> 2] | 0;
        }
        if ((i4 | 0) == (i6 + (i7 << 3) | 0)) {
         i39 = 81;
         break;
        }
        i4 = HEAP32[i4 + 4 >> 2] | 0;
        if (!i4) i39 = 83;
       } while (0);
       if ((i39 | 0) == 81) i39 = 83;
       if ((i39 | 0) == 83) {
        i39 = 0;
        i4 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
       }
      }
      i6 = i3 + 16 | 0;
      if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i6 = HEAP32[i6 >> 2] | 0;
      HEAP32[i37 >> 2] = i11;
      HEAP32[i12 >> 2] = i10;
      HEAP32[i13 >> 2] = i6;
      HEAP32[i14 >> 2] = i4;
      HEAP32[i15 >> 2] = 0;
      if (__ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i32, i37, i38, i33) | 0) {
       __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf(i38, Math_fround(__ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE(i9, f1, 0))) | 0;
       if (((HEAP32[i18 >> 2] | 0) + -5 | 0) >>> 0 < 2) __ZN11UnityEngine9Animation27BoundCurveValueAwakeGenericER6Object(HEAP32[i19 >> 2] | 0);
      }
     }
    } while (0);
    i3 = i3 + 132 | 0;
   } while ((i3 | 0) != (HEAP32[i16 >> 2] | 0));
  }
  __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i33);
 }
 if (!i35) {
  STACKTOP = i40;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i35);
 STACKTOP = i40;
 return;
}

function __ZN5physxL23updateStreamForceTwoWayEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i100, i101, i107, i108, i104, i105, i1, i110) {
 i100 = i100 | 0;
 i101 = i101 | 0;
 i107 = i107 | 0;
 i108 = i108 | 0;
 i104 = i104 | 0;
 i105 = i105 | 0;
 i1 = i1 | 0;
 i110 = i110 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i102 = 0, i103 = 0, i106 = 0, i109 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, f129 = f0, f130 = f0, f131 = f0, f132 = f0, f133 = f0, f134 = f0, f135 = f0, f136 = f0;
 i112 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i109 = i112 + 256 | 0;
 i102 = i112 + 192 | 0;
 i91 = i112 + 112 | 0;
 i92 = i112 + 96 | 0;
 i93 = i112 + 16 | 0;
 i111 = i112 + 128 | 0;
 i106 = i112;
 i103 = i112 + 32 | 0;
 if (!i105) {
  STACKTOP = i112;
  return;
 }
 i94 = i1 + 52 | 0;
 i95 = i1 + 24 | 0;
 i96 = i1 + 44 | 0;
 i97 = i1 + 28 | 0;
 i98 = i1 + 36 | 0;
 i99 = i1 + 48 | 0;
 i31 = i1 + 40 | 0;
 i32 = i109 + 4 | 0;
 i33 = i109 + 8 | 0;
 i34 = i109 + 12 | 0;
 i35 = i109 + 16 | 0;
 i36 = i109 + 20 | 0;
 i37 = i109 + 24 | 0;
 i38 = i109 + 28 | 0;
 i39 = i109 + 32 | 0;
 i40 = i109 + 36 | 0;
 i41 = i109 + 40 | 0;
 i42 = i109 + 44 | 0;
 i43 = i109 + 48 | 0;
 i44 = i109 + 52 | 0;
 i45 = i109 + 56 | 0;
 i46 = i109 + 60 | 0;
 i47 = i102 + 16 | 0;
 i48 = i102 + 32 | 0;
 i49 = i102 + 48 | 0;
 i50 = i111 + 4 | 0;
 i51 = i111 + 8 | 0;
 i52 = i111 + 12 | 0;
 i53 = i111 + 16 | 0;
 i54 = i111 + 20 | 0;
 i55 = i111 + 24 | 0;
 i56 = i111 + 28 | 0;
 i57 = i111 + 32 | 0;
 i58 = i111 + 36 | 0;
 i59 = i111 + 40 | 0;
 i60 = i111 + 44 | 0;
 i61 = i111 + 48 | 0;
 i62 = i111 + 52 | 0;
 i63 = i111 + 56 | 0;
 i64 = i111 + 60 | 0;
 i65 = i106 + 4 | 0;
 i66 = i106 + 8 | 0;
 i67 = i106 + 12 | 0;
 i68 = i102 + 16 | 0;
 i69 = i102 + 32 | 0;
 i70 = i102 + 4 | 0;
 i71 = i102 + 20 | 0;
 i72 = i102 + 36 | 0;
 i73 = i102 + 8 | 0;
 i74 = i102 + 24 | 0;
 i75 = i102 + 40 | 0;
 i76 = i102 + 12 | 0;
 i77 = i102 + 28 | 0;
 i78 = i102 + 44 | 0;
 i79 = i103 + 4 | 0;
 i80 = i103 + 8 | 0;
 i81 = i103 + 12 | 0;
 i82 = i103 + 16 | 0;
 i83 = i103 + 20 | 0;
 i84 = i103 + 24 | 0;
 i85 = i103 + 28 | 0;
 i86 = i103 + 32 | 0;
 i87 = i103 + 36 | 0;
 i88 = i103 + 40 | 0;
 i89 = i103 + 44 | 0;
 i90 = i103 + 48 | 0;
 i1 = 0;
 do {
  i9 = HEAP32[i104 + (i1 << 2) >> 2] | 0;
  i8 = i107 + (i9 << 5) | 0;
  i6 = i1 + 2 | 0;
  i10 = HEAP32[i104 + (i1 + 1 << 2) >> 2] | 0;
  i11 = i10 >>> 2;
  if (!i11) i1 = i6; else {
   i30 = HEAP32[i8 >> 2] | 0;
   i29 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = HEAP32[i8 + 8 >> 2] | 0;
   i1 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i109 >> 2] = i30;
   HEAP32[i32 >> 2] = i30;
   HEAP32[i33 >> 2] = i30;
   HEAP32[i34 >> 2] = i30;
   HEAP32[i35 >> 2] = i29;
   HEAP32[i36 >> 2] = i29;
   HEAP32[i37 >> 2] = i29;
   HEAP32[i38 >> 2] = i29;
   HEAP32[i39 >> 2] = i3;
   HEAP32[i40 >> 2] = i3;
   HEAP32[i41 >> 2] = i3;
   HEAP32[i42 >> 2] = i3;
   HEAP32[i43 >> 2] = i1;
   HEAP32[i44 >> 2] = i1;
   HEAP32[i45 >> 2] = i1;
   HEAP32[i46 >> 2] = i1;
   HEAP32[i102 >> 2] = 0;
   HEAP32[i102 + 4 >> 2] = 0;
   HEAP32[i102 + 8 >> 2] = 0;
   HEAP32[i102 + 12 >> 2] = 0;
   HEAP32[i91 >> 2] = 0;
   HEAP32[i91 + 4 >> 2] = 0;
   HEAP32[i91 + 8 >> 2] = 0;
   HEAP32[i91 + 12 >> 2] = 0;
   HEAP32[i92 >> 2] = 0;
   HEAP32[i92 + 4 >> 2] = 0;
   HEAP32[i92 + 8 >> 2] = 0;
   HEAP32[i92 + 12 >> 2] = 0;
   HEAP32[i93 >> 2] = 0;
   HEAP32[i93 + 4 >> 2] = 0;
   HEAP32[i93 + 8 >> 2] = 0;
   HEAP32[i93 + 12 >> 2] = 0;
   HEAP32[i47 >> 2] = HEAP32[i91 >> 2];
   HEAP32[i47 + 4 >> 2] = HEAP32[i91 + 4 >> 2];
   HEAP32[i47 + 8 >> 2] = HEAP32[i91 + 8 >> 2];
   HEAP32[i47 + 12 >> 2] = HEAP32[i91 + 12 >> 2];
   HEAP32[i48 >> 2] = HEAP32[i92 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i92 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i92 + 8 >> 2];
   HEAP32[i48 + 12 >> 2] = HEAP32[i92 + 12 >> 2];
   HEAP32[i49 >> 2] = HEAP32[i93 >> 2];
   HEAP32[i49 + 4 >> 2] = HEAP32[i93 + 4 >> 2];
   HEAP32[i49 + 8 >> 2] = HEAP32[i93 + 8 >> 2];
   HEAP32[i49 + 12 >> 2] = HEAP32[i93 + 12 >> 2];
   i3 = i107 + (i9 << 5) + 16 | 0;
   i29 = HEAP32[i3 >> 2] | 0;
   i30 = HEAP32[i3 + 4 >> 2] | 0;
   i4 = HEAP32[i3 + 8 >> 2] | 0;
   i3 = HEAP32[i3 + 12 >> 2] | 0;
   HEAP32[i111 >> 2] = i29;
   HEAP32[i50 >> 2] = i29;
   HEAP32[i51 >> 2] = i29;
   HEAP32[i52 >> 2] = i29;
   HEAP32[i53 >> 2] = i30;
   HEAP32[i54 >> 2] = i30;
   HEAP32[i55 >> 2] = i30;
   HEAP32[i56 >> 2] = i30;
   HEAP32[i57 >> 2] = i4;
   HEAP32[i58 >> 2] = i4;
   HEAP32[i59 >> 2] = i4;
   HEAP32[i60 >> 2] = i4;
   HEAP32[i61 >> 2] = i3;
   HEAP32[i62 >> 2] = i3;
   HEAP32[i63 >> 2] = i3;
   HEAP32[i64 >> 2] = i3;
   f27 = Math_fround(Math_fround(1.0) / (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i106 >> 2] = f27;
   HEAPF32[i65 >> 2] = f27;
   HEAPF32[i66 >> 2] = f27;
   HEAPF32[i67 >> 2] = f27;
   i1 = i11 << 2;
   i3 = 0;
   i4 = i6;
   while (1) {
    i125 = HEAP32[i104 + (i4 << 2) >> 2] | 0;
    i120 = HEAP32[i104 + (i4 + 1 << 2) >> 2] | 0;
    i115 = HEAP32[i104 + (i4 + 2 << 2) >> 2] | 0;
    i30 = HEAP32[i104 + (i4 + 3 << 2) >> 2] | 0;
    i128 = i101 + (i125 * 12 | 0) | 0;
    i116 = HEAP32[i128 + 4 >> 2] | 0;
    i122 = HEAP32[i128 + 8 >> 2] | 0;
    i123 = i101 + (i120 * 12 | 0) | 0;
    i29 = HEAP32[i123 >> 2] | 0;
    i117 = HEAP32[i123 + 4 >> 2] | 0;
    i124 = HEAP32[i123 + 8 >> 2] | 0;
    i118 = i101 + (i115 * 12 | 0) | 0;
    i28 = HEAP32[i118 >> 2] | 0;
    i119 = HEAP32[i118 + 4 >> 2] | 0;
    i126 = HEAP32[i118 + 8 >> 2] | 0;
    i113 = i101 + (i30 * 12 | 0) | 0;
    i114 = HEAP32[i113 >> 2] | 0;
    i121 = HEAP32[i113 + 4 >> 2] | 0;
    i127 = HEAP32[i113 + 8 >> 2] | 0;
    HEAP32[i103 >> 2] = HEAP32[i128 >> 2];
    HEAP32[i79 >> 2] = i29;
    HEAP32[i80 >> 2] = i28;
    HEAP32[i81 >> 2] = i114;
    HEAP32[i82 >> 2] = i116;
    HEAP32[i83 >> 2] = i117;
    HEAP32[i84 >> 2] = i119;
    HEAP32[i85 >> 2] = i121;
    HEAP32[i86 >> 2] = i122;
    HEAP32[i87 >> 2] = i124;
    HEAP32[i88 >> 2] = i126;
    HEAP32[i89 >> 2] = i127;
    HEAP32[i90 >> 2] = 0;
    HEAP32[i90 + 4 >> 2] = 0;
    HEAP32[i90 + 8 >> 2] = 0;
    HEAP32[i90 + 12 >> 2] = 0;
    __ZN5physx26calcForce4_twoWay_onlyPtrsERNS_6shdfnd3aos6Mat44VES3_PNS_16PxsFluidParticleES5_S5_S5_RKS2_S7_RKNS1_5Vec4VERKNS_30PxsFluidDynamicsParametersSIMDE(i102, i103, i108 + (i125 << 5) | 0, i108 + (i120 << 5) | 0, i108 + (i115 << 5) | 0, i108 + (i30 << 5) | 0, i109, i111, i106, i110);
    i127 = HEAP32[i82 >> 2] | 0;
    i126 = HEAP32[i86 >> 2] | 0;
    i124 = HEAP32[i79 >> 2] | 0;
    i122 = HEAP32[i83 >> 2] | 0;
    i121 = HEAP32[i87 >> 2] | 0;
    i119 = HEAP32[i80 >> 2] | 0;
    i117 = HEAP32[i84 >> 2] | 0;
    i116 = HEAP32[i88 >> 2] | 0;
    i114 = HEAP32[i81 >> 2] | 0;
    i28 = HEAP32[i85 >> 2] | 0;
    i29 = HEAP32[i89 >> 2] | 0;
    HEAP32[i128 >> 2] = HEAP32[i103 >> 2];
    HEAP32[i101 + (i125 * 12 | 0) + 4 >> 2] = i127;
    HEAP32[i101 + (i125 * 12 | 0) + 8 >> 2] = i126;
    HEAP32[i123 >> 2] = i124;
    HEAP32[i101 + (i120 * 12 | 0) + 4 >> 2] = i122;
    HEAP32[i101 + (i120 * 12 | 0) + 8 >> 2] = i121;
    HEAP32[i118 >> 2] = i119;
    HEAP32[i101 + (i115 * 12 | 0) + 4 >> 2] = i117;
    HEAP32[i101 + (i115 * 12 | 0) + 8 >> 2] = i116;
    HEAP32[i113 >> 2] = i114;
    HEAP32[i101 + (i30 * 12 | 0) + 4 >> 2] = i28;
    HEAP32[i101 + (i30 * 12 | 0) + 8 >> 2] = i29;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i4 = i4 + 4 | 0;
   }
   f17 = Math_fround(HEAPF32[i102 >> 2]);
   f20 = Math_fround(HEAPF32[i68 >> 2]);
   f23 = Math_fround(HEAPF32[i69 >> 2]);
   f18 = Math_fround(HEAPF32[i70 >> 2]);
   f21 = Math_fround(HEAPF32[i71 >> 2]);
   f24 = Math_fround(HEAPF32[i72 >> 2]);
   f19 = Math_fround(HEAPF32[i73 >> 2]);
   f22 = Math_fround(HEAPF32[i74 >> 2]);
   f27 = Math_fround(HEAPF32[i75 >> 2]);
   f25 = Math_fround(HEAPF32[i76 >> 2]);
   f26 = Math_fround(HEAPF32[i77 >> 2]);
   f25 = Math_fround(Math_fround(f17 + f18) + Math_fround(f19 + f25));
   f26 = Math_fround(Math_fround(f20 + f21) + Math_fround(f22 + f26));
   f27 = Math_fround(Math_fround(f23 + f24) + Math_fround(f27 + Math_fround(HEAPF32[i78 >> 2])));
   i128 = i100 + (i9 * 12 | 0) | 0;
   HEAPF32[i128 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i128 >> 2]));
   i128 = i100 + (i9 * 12 | 0) + 4 | 0;
   HEAPF32[i128 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i128 >> 2]));
   i128 = i100 + (i9 * 12 | 0) + 8 | 0;
   HEAPF32[i128 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i128 >> 2]));
   i1 = i6 + i1 | 0;
  }
  i128 = i11 << 2;
  i28 = i10 - i128 | 0;
  if ((i10 | 0) != (i128 | 0)) {
   f13 = Math_fround(HEAPF32[i8 >> 2]);
   f14 = Math_fround(HEAPF32[i107 + (i9 << 5) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i107 + (i9 << 5) + 8 >> 2]);
   f16 = Math_fround(HEAPF32[i94 >> 2]);
   f17 = Math_fround(HEAPF32[i95 >> 2]);
   f12 = Math_fround(HEAPF32[i107 + (i9 << 5) + 12 >> 2]);
   f18 = Math_fround(HEAPF32[i96 >> 2]);
   f19 = Math_fround(f12 - f18);
   i29 = f19 > Math_fround(0.0);
   f19 = i29 ? f19 : Math_fround(0.0);
   f20 = Math_fround(HEAPF32[i97 >> 2]);
   f21 = Math_fround(f17 * Math_fround(2.0));
   f22 = Math_fround(HEAPF32[i98 >> 2]);
   f23 = Math_fround(HEAPF32[i99 >> 2]);
   f24 = Math_fround(HEAPF32[i31 >> 2]);
   f25 = Math_fround(HEAPF32[i107 + (i9 << 5) + 16 >> 2]);
   f26 = Math_fround(HEAPF32[i107 + (i9 << 5) + 20 >> 2]);
   f27 = Math_fround(HEAPF32[i107 + (i9 << 5) + 24 >> 2]);
   i29 = i100 + (i9 * 12 | 0) | 0;
   i30 = i100 + (i9 * 12 | 0) + 4 | 0;
   i8 = i100 + (i9 * 12 | 0) + 8 | 0;
   f12 = Math_fround(Math_fround(1.0) / f12);
   f7 = Math_fround(HEAPF32[i29 >> 2]);
   f5 = Math_fround(HEAPF32[i30 >> 2]);
   f2 = Math_fround(HEAPF32[i8 >> 2]);
   i6 = i10 - (i11 << 2) | 0;
   i6 = i6 >>> 0 > 1 ? i6 : 1;
   i3 = 0;
   i4 = i1;
   while (1) {
    i128 = HEAP32[i104 + (i4 << 2) >> 2] | 0;
    f135 = Math_fround(f13 - Math_fround(HEAPF32[i108 + (i128 << 5) >> 2]));
    f134 = Math_fround(f14 - Math_fround(HEAPF32[i108 + (i128 << 5) + 4 >> 2]));
    f131 = Math_fround(f15 - Math_fround(HEAPF32[i108 + (i128 << 5) + 8 >> 2]));
    f130 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f135 * f135) + Math_fround(f134 * f134)) + Math_fround(f131 * f131)));
    f133 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f130))));
    f130 = Math_fround(f133 * f130);
    f129 = Math_fround(f17 - f130);
    f132 = Math_fround(HEAPF32[i108 + (i128 << 5) + 12 >> 2]);
    f136 = Math_fround(f132 - f18);
    i127 = f136 > Math_fround(0.0);
    f133 = Math_fround(Math_fround(f19 + (i127 ? f136 : Math_fround(0.0))) * Math_fround(f22 * Math_fround(f130 + Math_fround(Math_fround(f133 * f20) - f21))));
    f135 = Math_fround(f23 * Math_fround(f135 * f133));
    f134 = Math_fround(f23 * Math_fround(f134 * f133));
    f133 = Math_fround(f23 * Math_fround(f131 * f133));
    f129 = Math_fround(f129 * f24);
    f131 = Math_fround(Math_fround(HEAPF32[i108 + (i128 << 5) + 16 >> 2]) - f25);
    f130 = Math_fround(Math_fround(HEAPF32[i108 + (i128 << 5) + 20 >> 2]) - f26);
    f131 = Math_fround(f135 + Math_fround(f129 * Math_fround(f23 * f131)));
    f130 = Math_fround(f134 + Math_fround(f129 * Math_fround(f23 * f130)));
    f129 = Math_fround(f133 + Math_fround(f129 * Math_fround(f23 * Math_fround(Math_fround(HEAPF32[i108 + (i128 << 5) + 24 >> 2]) - f27))));
    f132 = Math_fround(Math_fround(1.0) / f132);
    f7 = Math_fround(Math_fround(f131 * f132) + f7);
    f5 = Math_fround(Math_fround(f132 * f130) + f5);
    f2 = Math_fround(f2 + Math_fround(f132 * f129));
    f131 = Math_fround(f131 * f12);
    f130 = Math_fround(f130 * f12);
    f129 = Math_fround(f129 * f12);
    i127 = i101 + (i128 * 12 | 0) | 0;
    HEAPF32[i127 >> 2] = Math_fround(Math_fround(HEAPF32[i127 >> 2]) - f131);
    i127 = i101 + (i128 * 12 | 0) + 4 | 0;
    HEAPF32[i127 >> 2] = Math_fround(Math_fround(HEAPF32[i127 >> 2]) - f130);
    i128 = i101 + (i128 * 12 | 0) + 8 | 0;
    HEAPF32[i128 >> 2] = Math_fround(Math_fround(HEAPF32[i128 >> 2]) - f129);
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i28 >>> 0) break; else i4 = i4 + 1 | 0;
   }
   HEAPF32[i29 >> 2] = f7;
   HEAPF32[i30 >> 2] = f5;
   HEAPF32[i8 >> 2] = f2;
   i1 = i1 + i6 | 0;
  }
 } while (i1 >>> 0 < i105 >>> 0);
 STACKTOP = i112;
 return;
}

function __ZN10MonoScript8TransferI14SafeBinaryReadEEvRT_(i11, i6) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 32 | 0;
 i13 = i14 + 16 | 0;
 i7 = i14;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i11, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 4);
 i5 = i11 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455664 | 0, HEAP32[gb + 37040 >> 2] | 0, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i10 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i10 >>> 0) i4 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i11 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455681 | 0, gb + 455698 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i11 + 92 | 0;
 i5 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455706 | 0, i5, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i2, 1); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = i11 + 108 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455718 | 0, i5, i12, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i1, 1); else {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i10 = i11 + 124 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455730 | 0, i5, i12, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i10, 1); else {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i10 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i11 + 140 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455745 | 0, HEAP32[gb + 36972 >> 2] | 0, i12, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i6 + 16 | 0;
   i9 = HEAP32[i6 + 20 >> 2] | 0;
   i3 = i9 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 >= i9 >>> 0) if ((i3 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i6 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 1) | 0)) {
  STACKTOP = i14;
  return;
 }
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 455762 | 0, i5, i12, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i10, 1); else {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i10 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i9 = i10 + 11 | 0;
 i6 = HEAP8[i9 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i8 = i11 + 128 | 0;
 if (((i2 ? HEAP32[i8 >> 2] | 0 : i6 & 255) | 0) == 20) {
  if (!(_memcmp(i2 ? HEAP32[i10 >> 2] | 0 : i10, gb + 455783 | 0, 20) | 0)) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 + 12 >> 2] = i2;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = -2147483632;
   i3 = i13 + 4 | 0;
   HEAP32[i3 >> 2] = 15;
   i4 = i2;
   i5 = gb + 1049781 | 0;
   i6 = i4 + 15 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP8[i2 + 15 >> 0] = 0;
   i6 = i13 + 11 | 0;
   do if ((i10 | 0) != (i13 | 0)) {
    i5 = HEAP8[i6 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    i7 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
    i5 = i2 ? HEAP32[i3 >> 2] | 0 : i5 & 255;
    i2 = HEAP8[i9 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i4 = (HEAP32[i11 + 132 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i5 >>> 0 > i4 >>> 0) {
     if (i3) i2 = HEAP32[i8 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i5 - i4 | 0, i2, 0, i2, i5, i7);
     break;
    }
    if (i3) i2 = HEAP32[i10 >> 2] | 0; else i2 = i10;
    if (i5 | 0) _memmove(i2 | 0, i7 | 0, i5 | 0) | 0;
    HEAP8[i2 + i5 >> 0] = 0;
    if ((HEAP8[i9 >> 0] | 0) < 0) {
     HEAP32[i8 >> 2] = i5;
     break;
    } else {
     HEAP8[i9 >> 0] = i5;
     break;
    }
   } while (0);
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    i10 = HEAP32[i13 >> 2] | 0;
    i9 = HEAP32[i13 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 + 12 >> 2] = i2;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = -2147483632;
   i3 = i13 + 4 | 0;
   HEAP32[i3 >> 2] = 11;
   i4 = i2;
   i5 = gb + 1049797 | 0;
   i6 = i4 + 11 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP8[i2 + 11 >> 0] = 0;
   i7 = i13 + 11 | 0;
   do if ((i1 | 0) != (i13 | 0)) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = i6 << 24 >> 24 < 0;
    i8 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
    i6 = i4 ? HEAP32[i3 >> 2] | 0 : i6 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i11 + 116 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i6 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i11 + 112 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
     break;
    }
    if (i3) i1 = HEAP32[i1 >> 2] | 0;
    if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
    HEAP8[i1 + i6 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i11 + 112 >> 2] = i6;
     break;
    } else {
     HEAP8[i4 >> 0] = i6;
     break;
    }
   } while (0);
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    i11 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i13;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   STACKTOP = i14;
   return;
  }
  if (!(_memcmp(i2 ? HEAP32[i10 >> 2] | 0 : i10, gb + 455804 | 0, 20) | 0)) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 + 12 >> 2] = i2;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = -2147483632;
   i3 = i13 + 4 | 0;
   HEAP32[i3 >> 2] = 15;
   i4 = i2;
   i5 = gb + 464431 | 0;
   i6 = i4 + 15 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP8[i2 + 15 >> 0] = 0;
   i6 = i13 + 11 | 0;
   do if ((i10 | 0) != (i13 | 0)) {
    i5 = HEAP8[i6 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    i7 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
    i5 = i2 ? HEAP32[i3 >> 2] | 0 : i5 & 255;
    i2 = HEAP8[i9 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i4 = (HEAP32[i11 + 132 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i5 >>> 0 > i4 >>> 0) {
     if (i3) i2 = HEAP32[i8 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i5 - i4 | 0, i2, 0, i2, i5, i7);
     break;
    }
    if (i3) i2 = HEAP32[i10 >> 2] | 0; else i2 = i10;
    if (i5 | 0) _memmove(i2 | 0, i7 | 0, i5 | 0) | 0;
    HEAP8[i2 + i5 >> 0] = 0;
    if ((HEAP8[i9 >> 0] | 0) < 0) {
     HEAP32[i8 >> 2] = i5;
     break;
    } else {
     HEAP8[i9 >> 0] = i5;
     break;
    }
   } while (0);
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    i10 = HEAP32[i13 >> 2] | 0;
    i9 = HEAP32[i13 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 + 12 >> 2] = i2;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = -2147483632;
   i3 = i13 + 4 | 0;
   HEAP32[i3 >> 2] = 11;
   i4 = i2;
   i5 = gb + 464535 | 0;
   i6 = i4 + 11 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP8[i2 + 11 >> 0] = 0;
   i7 = i13 + 11 | 0;
   do if ((i1 | 0) != (i13 | 0)) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = i6 << 24 >> 24 < 0;
    i8 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
    i6 = i4 ? HEAP32[i3 >> 2] | 0 : i6 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i11 + 116 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i6 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i11 + 112 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
     break;
    }
    if (i3) i1 = HEAP32[i1 >> 2] | 0;
    if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
    HEAP8[i1 + i6 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i11 + 112 >> 2] = i6;
     break;
    } else {
     HEAP8[i4 >> 0] = i6;
     break;
    }
   } while (0);
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    i11 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i12 + 4 >> 2] = i13;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   STACKTOP = i14;
   return;
  }
 }
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_(i7, gb + 455825 | 0, i10);
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i13, i7, gb + 465904 | 0);
 i4 = i13 + 11 | 0;
 i6 = HEAP8[i4 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i6 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
 i1 = HEAP8[i9 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i11 + 132 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i6 >>> 0 > i3 >>> 0) {
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   HEAP32[i8 >> 2] = i6;
   break;
  } else {
   HEAP8[i9 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i11 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx18PxsDynamicsContext10solveGroupERNS_16PxsThreadContextERKNS_16PxsIslandObjectsERKNS_16PxsIslandIndicesERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjj(i39, i40, i23, i37, i1, i38, i2) {
 i39 = i39 | 0;
 i40 = i40 | 0;
 i23 = i23 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 i38 = i38 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i43 + 80 | 0;
 i11 = i43 + 48 | 0;
 i14 = i43 + 40 | 0;
 i12 = i43 + 8 | 0;
 i34 = i43;
 i35 = HEAP32[i39 + 100 >> 2] | 0;
 i32 = i35 + (i38 << 5) | 0;
 i33 = i39 + 112 | 0;
 i36 = HEAP32[i33 >> 2] | 0;
 i30 = i36 + (i38 << 6) | 0;
 i15 = i39 + 96 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i42 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i41 = HEAP32[(HEAP32[i42 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i41 | 0, i42 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i42 = i1 + 19 & -16;
   HEAP32[i42 + -4 >> 2] = i42 - i1;
   i1 = i42;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
 }
 i31 = HEAP32[i1 + 8880 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i39 + 32 >> 2];
 HEAP32[i36 + (i38 << 6) + 4 >> 2] = HEAP32[i39 + 36 >> 2];
 HEAP32[i36 + (i38 << 6) + 8 >> 2] = HEAP32[i39 + 40 >> 2];
 HEAP32[i36 + (i38 << 6) + 12 >> 2] = HEAP32[i39 + 44 >> 2];
 HEAP32[i36 + (i38 << 6) + 16 >> 2] = HEAP32[i39 + 48 >> 2];
 HEAP32[i36 + (i38 << 6) + 20 >> 2] = HEAP32[i39 + 52 >> 2];
 HEAP32[i36 + (i38 << 6) + 24 >> 2] = HEAP32[i39 + 56 >> 2];
 HEAP32[i36 + (i38 << 6) + 28 >> 2] = HEAP32[i39 + 60 >> 2];
 HEAP32[i36 + (i38 << 6) + 32 >> 2] = HEAP32[i39 + 64 >> 2];
 i42 = i36 + (i38 << 6) + 36 | 0;
 i41 = i39 + 68 | 0;
 HEAP32[i42 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
 HEAP32[i42 + 16 >> 2] = HEAP32[i41 + 16 >> 2];
 HEAP32[i42 + 20 >> 2] = HEAP32[i41 + 20 >> 2];
 HEAP32[i42 + 24 >> 2] = HEAP32[i41 + 24 >> 2];
 if (!(HEAP32[i37 >> 2] | 0)) i1 = 0; else {
  i2 = i39 + 124 | 0;
  i3 = 0;
  i1 = 0;
  do {
   i42 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   i41 = i42 + 64 | 0;
   i29 = HEAP32[i41 >> 2] | 0;
   i28 = HEAPU16[i29 + 30 >> 1] | 0;
   i1 = i28 >>> 0 < i1 >>> 0 ? i1 : i28;
   __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(i29, i42, i42 + 16 | 0, Math_fround(HEAPF32[i2 >> 2]));
   i29 = i3;
   i3 = i3 + 1 | 0;
   __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i35 + (i29 + i38 << 5) | 0, i36 + (i3 + i38 << 6) | 0, HEAP32[i41 >> 2] | 0, i42);
  } while (i3 >>> 0 < (HEAP32[i37 >> 2] | 0) >>> 0);
 }
 i22 = i40 + 16 | 0;
 i24 = i40 + 332 | 0;
 i27 = i40 + 8892 | 0;
 i28 = i40 + 8896 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i40 + 8920 | 0;
 HEAP32[i29 >> 2] = 0;
 i41 = i40 + 9124 | 0;
 i42 = i37 + 4 | 0;
 i2 = HEAP32[i42 >> 2] & 2147483647;
 i4 = i6;
 i5 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i41, i2, i6);
 if (!(HEAP32[i42 >> 2] & 2147483647)) {
  i20 = i40 + 316 | 0;
  i2 = 0;
 } else {
  i7 = i23 + 4 | 0;
  i8 = i40 + 316 | 0;
  i9 = i39 + 124 | 0;
  i2 = 0;
  i10 = 0;
  do {
   i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i4 = (HEAP32[i41 >> 2] | 0) + (i10 * 40 | 0) | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i5 = i4 + 40 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    i4 = i4 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   i4 = HEAP32[i28 >> 2] | 0;
   i3 = (HEAPU16[(HEAP32[i6 >> 2] | 0) + 36 >> 1] | 0) + i4 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i11 + 24 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i27, i3, i11);
   i3 = HEAP32[gb + 1457380 >> 2] | 0;
   if (!i3) i3 = 0; else {
    f13 = Math_fround(HEAPF32[i9 >> 2]);
    i3 = mftCall_iifiiiii(i3 | 0, (HEAP32[i41 >> 2] | 0) + (i10 * 40 | 0) | 0, +f13, i24 | 0, (HEAP32[i27 >> 2] | 0) + (i4 << 5) | 0, i14 | 0, HEAP32[(HEAP32[i15 >> 2] | 0) + 6964 >> 2] | 0, i8 | 0) | 0;
   }
   i2 = (HEAP32[i14 >> 2] | 0) + i2 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
   HEAP32[i12 + 24 >> 2] = 0;
   HEAP32[i12 + 28 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i27, i3 + i4 | 0, i12);
   i26 = HEAPU16[(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0) + 12 >> 1] | 0;
   i1 = i26 >>> 0 < i1 >>> 0 ? i1 : i26;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i42 >> 2] & 2147483647) >>> 0);
  i20 = i8;
 }
 i12 = HEAP32[(HEAP32[i15 >> 2] | 0) + 7600 >> 2] | 0;
 i25 = i40 + 328 | 0;
 i26 = i40 + 316 | 0;
 __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i25 >> 2] | 0, i26);
 HEAP32[i40 + 336 >> 2] = 0;
 HEAP32[i40 + 340 >> 2] = 0;
 i21 = i37 + 8 | 0;
 if (!(HEAP32[i21 >> 2] | 0)) {
  i4 = i39 + 128 | 0;
  i3 = 0;
 } else {
  i14 = i23 + 12 | 0;
  i15 = i40 + 8900 | 0;
  i16 = gb + 106280 + (i12 << 2) | 0;
  i4 = i39 + 128 | 0;
  i17 = i39 + 140 | 0;
  i18 = i39 + 144 | 0;
  i19 = i40 + 8788 | 0;
  i11 = 0;
  do {
   i7 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   i5 = i3 & 2147483647;
   i6 = HEAP32[i28 >> 2] | 0;
   if (i5 >>> 0 <= i6 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i27, (i5 | 0) == 0 ? 1 : i3 << 1);
    i6 = HEAP32[i28 >> 2] | 0;
   }
   i10 = HEAP32[i27 >> 2] | 0;
   HEAP32[i28 >> 2] = i6 + 1;
   i9 = i10 + (i6 << 5) | 0;
   __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(i39, i9, i7 + (i11 << 4) | 0);
   i3 = i7 + (i11 << 4) + 12 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   if ((HEAP16[i10 + (i6 << 5) + 8 >> 1] | 0) == -1) i7 = i36 + ((HEAPU16[i10 + (i6 << 5) + 10 >> 1] | 0) + i38 << 6) | 0; else i7 = i30;
   if ((HEAP16[i10 + (i6 << 5) + 12 >> 1] | 0) == -1) i8 = i36 + ((HEAPU16[i10 + (i6 << 5) + 14 >> 1] | 0) + i38 << 6) | 0; else i8 = i30;
   f45 = Math_fround(HEAPF32[i4 >> 2]);
   f44 = Math_fround(HEAPF32[i17 >> 2]);
   f13 = Math_fround(HEAPF32[i18 >> 2]);
   mftCall_iiiiiiiiiiiiffffii(HEAP32[i16 >> 2] | 0, i5 + 16 | 0, i22 | 0, 0, 0, i9 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 + (i6 << 5) + 4 >> 2] | 0, i7 | 0, i8 | 0, HEAP32[i5 + 80 >> 2] | 0, HEAP32[i5 + 84 >> 2] | 0, +f45, +f44, +f13, +Math_fround(HEAPF32[i19 >> 2]), i20 | 0, i12 | 0) | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP16[i10 + (i6 << 5) + 26 >> 1] = (HEAP32[i5 + 20 >> 2] | 0) >>> 4;
   HEAP32[i10 + (i6 << 5) + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   if (!(HEAP16[i5 + 114 >> 1] & 16)) {
    i3 = 0;
    i7 = 0;
   } else {
    i3 = (HEAP32[i5 + 44 >> 2] | 0) + ((HEAP32[i5 + 48 >> 2] | 0) + 15 & -16) | 0;
    i7 = HEAP16[i5 + 36 >> 1] | 0;
   }
   HEAP32[i10 + (i6 << 5) + 20 >> 2] = i3;
   HEAP16[i10 + (i6 << 5) + 24 >> 1] = i7;
   i3 = HEAP16[i5 + 32 >> 1] | 0;
   if (!(i3 << 16 >> 16)) HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + -1;
   i2 = (i3 & 65535) + i2 | 0;
   i11 = i11 + 1 | 0;
   i3 = HEAP32[i21 >> 2] | 0;
  } while (i11 >>> 0 < i3 >>> 0);
 }
 f13 = Math_fround(HEAPF32[i4 >> 2]);
 i11 = i37 + 12 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i8 = i23 + 16 | 0;
  i9 = i40 + 8900 | 0;
  i10 = i39 + 124 | 0;
  i7 = 0;
  do {
   i6 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i4 & 2147483647;
   i3 = HEAP32[i28 >> 2] | 0;
   if (i5 >>> 0 <= i3 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i27, (i5 | 0) == 0 ? 1 : i4 << 1);
    i3 = HEAP32[i28 >> 2] | 0;
   }
   i23 = HEAP32[i27 >> 2] | 0;
   HEAP32[i28 >> 2] = i3 + 1;
   i3 = i23 + (i3 << 5) | 0;
   __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(i39, i3, i6 + (i7 << 4) | 0);
   i3 = __ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(HEAP32[i6 + (i7 << 4) + 12 >> 2] | 0, i30, i24, Math_fround(HEAPF32[i10 >> 2]), f13, i3, i20) | 0;
   if (!i3) HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + -1;
   i2 = i3 + i2 | 0;
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
  i3 = HEAP32[i21 >> 2] | 0;
 }
 i30 = i40 + 9180 | 0;
 HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + i2;
 i2 = i40 + 9112 | 0;
 HEAP32[i40 + 9116 >> 2] = 0;
 if ((HEAP32[i40 + 9120 >> 2] & 2147483647) >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, i3);
 i30 = i39 + 136 | 0;
 i24 = HEAP32[i30 >> 2] | 0;
 i14 = i39 + 124 | 0;
 f45 = Math_fround(HEAPF32[i14 >> 2]);
 mftCall_vifiiiiiiiiiiiii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, +f45, ((i1 | 0) == 0 ? 1 : i1) | 0, 1, i32 | 0, HEAP32[i33 >> 2] | 0, i38 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i41 >> 2] | 0, HEAP32[i40 + 9128 >> 2] | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] | 0, HEAP32[i40 + 8916 >> 2] | 0, HEAP32[i29 >> 2] | 0, i31 | 0);
 i32 = HEAP32[i30 >> 2] | 0;
 mftCall_viiiiiiii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, i34 | 0, HEAP32[i33 >> 2] | 0, gb + 147672 | 0);
 HEAP32[i40 + 9060 >> 2] = HEAP32[i34 >> 2];
 if (HEAP32[i37 >> 2] | 0) {
  i1 = i40 + 9156 | 0;
  i2 = 0;
  do {
   i29 = i2 + i38 | 0;
   i34 = i2;
   i2 = i2 + 1 | 0;
   i32 = i36 + (i2 + i38 << 6) + 40 | 0;
   i33 = HEAP32[i32 >> 2] | 0;
   i30 = HEAP32[i33 + 64 >> 2] | 0;
   HEAP32[i30 + 64 >> 2] = HEAP32[i35 + (i29 << 5) >> 2];
   HEAP32[i30 + 68 >> 2] = HEAP32[i35 + (i29 << 5) + 4 >> 2];
   HEAP32[i30 + 72 >> 2] = HEAP32[i35 + (i29 << 5) + 8 >> 2];
   HEAP32[i30 + 80 >> 2] = HEAP32[i35 + (i29 << 5) + 16 >> 2];
   HEAP32[i30 + 84 >> 2] = HEAP32[i35 + (i29 << 5) + 20 >> 2];
   HEAP32[i30 + 88 >> 2] = HEAP32[i35 + (i29 << 5) + 24 >> 2];
   HEAP32[i32 >> 2] = 0;
   __ZNK5physx18PxsDynamicsContext17integrateAtomPoseEPNS_12PxsRigidBodyERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERKNS_6PxVec3ESB_(i39, i33, i1, i31 + (i34 << 5) | 0, i31 + (i34 << 5) + 16 | 0);
  } while (i2 >>> 0 < (HEAP32[i37 >> 2] | 0) >>> 0);
 }
 if (!(HEAP32[i42 >> 2] & 2147483647)) {
  i42 = HEAP32[i25 >> 2] | 0;
  __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(i42, i26);
  STACKTOP = i43;
  return;
 }
 i11 = i40 + 9156 | 0;
 i12 = i40 + 9160 | 0;
 i9 = i40 + 9164 | 0;
 i10 = 0;
 do {
  i2 = HEAP32[i41 >> 2] | 0;
  i1 = HEAP32[gb + 1457376 >> 2] | 0;
  if (i1 | 0) mftCall_vif(i1 | 0, i2 + (i10 * 40 | 0) | 0, +Math_fround(HEAPF32[i14 >> 2]));
  i8 = i2 + (i10 * 40 | 0) + 36 | 0;
  i1 = HEAP16[i8 >> 1] | 0;
  if (i1 << 16 >> 16) {
   i7 = i2 + (i10 * 40 | 0) + 4 | 0;
   i6 = 0;
   do {
    i5 = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 5) + 16 >> 2] | 0) + 68 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if ((i5 | 0) != 1073741823) {
     i3 = (i5 + 32 | 0) >>> 5;
     if (i3 >>> 0 > (HEAP32[i12 >> 2] & 2147483647) >>> 0) {
      i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i3 << 2, gb + 769739 | 0, 329) | 0;
      i1 = HEAP32[i11 >> 2] | 0;
      if (i1 | 0) {
       _memcpy(i2 | 0, i1 | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
       if ((HEAP32[i12 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i11 >> 2] | 0);
      }
      i1 = HEAP32[i12 >> 2] | 0;
      _memset(i2 + ((i1 & 2147483647) << 2) | 0, 0, i3 - i1 << 2 | 0) | 0;
      HEAP32[i11 >> 2] = i2;
      HEAP32[i12 >> 2] = i3;
      i1 = HEAP16[i8 >> 1] | 0;
     } else i2 = HEAP32[i11 >> 2] | 0;
     i40 = _bitshift64Lshr(i4 | 0, i5 | 0, 37) | 0;
     getTempRet0() | 0;
     i40 = i2 + (i40 << 2) | 0;
     HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 1 << (i5 & 31);
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < (i1 & 65535) >>> 0);
  }
  i10 = i10 + 1 | 0;
 } while (i10 >>> 0 < (HEAP32[i42 >> 2] & 2147483647) >>> 0);
 i42 = HEAP32[i25 >> 2] | 0;
 __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(i42, i26);
 STACKTOP = i43;
 return;
}

function _cff_face_init(i6, i20, i8, i3, i4) {
 i6 = i6 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 4 | 0;
 i23 = i24;
 i1 = i20 + 96 | 0;
 i21 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
 i2 = _UNITY_FT_Get_Module_Interface(i21, gb + 1007772 | 0) | 0;
 if (!i2) {
  HEAP32[i23 >> 2] = 11;
  i23 = 11;
  STACKTOP = i24;
  return i23 | 0;
 }
 i9 = _UNITY_ft_module_get_service(HEAP32[i1 >> 2] | 0, gb + 1006980 | 0) | 0;
 i7 = _UNITY_FT_Get_Module_Interface(i21, gb + 1006904 | 0) | 0;
 i1 = _UNITY_FT_Stream_Seek(i6, 0) | 0;
 HEAP32[i23 >> 2] = i1;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i24;
  return i23 | 0;
 }
 i19 = mftCall_iiiiii(HEAP32[i2 + 4 >> 2] | 0, i6 | 0, i20 | 0, i8 | 0, i3 | 0, i4 | 0) | 0;
 HEAP32[i23 >> 2] = i19;
 do if (!i19) {
  if ((HEAP32[i20 + 148 >> 2] | 0) != 1330926671) {
   HEAP32[i23 >> 2] = 2;
   i23 = 2;
   STACKTOP = i24;
   return i23 | 0;
  }
  if ((i8 | 0) < 0) {
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  }
  i5 = i20 + 508 | 0;
  i19 = mftCall_iiiii(HEAP32[i5 >> 2] | 0, i20 | 0, 1751474532, i6 | 0, 0) | 0;
  HEAP32[i23 >> 2] = i19;
  if (!i19) {
   i1 = mftCall_iiiiii(HEAP32[i2 + 8 >> 2] | 0, i6 | 0, i20 | 0, i8 | 0, i3 | 0, i4 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   if (!i1) i2 = 0; else {
    i23 = i1;
    STACKTOP = i24;
    return i23 | 0;
   }
  } else {
   i1 = mftCall_iii(HEAP32[i2 + 32 >> 2] | 0, i20 | 0, i6 | 0) | 0;
   HEAP32[i23 >> 2] = i1;
   if (!i1) i2 = 1; else {
    i23 = i1;
    STACKTOP = i24;
    return i23 | 0;
   }
  }
  i1 = mftCall_iiiii(HEAP32[i5 >> 2] | 0, i20 | 0, 1128678944, i6 | 0, 0) | 0;
  HEAP32[i23 >> 2] = i1;
  if (!i1) i16 = 1; else {
   i23 = i1;
   STACKTOP = i24;
   return i23 | 0;
  }
 } else {
  i1 = _UNITY_FT_Stream_Seek(i6, 0) | 0;
  HEAP32[i23 >> 2] = i1;
  if (!i1) {
   HEAP32[i23 >> 2] = 0;
   i16 = 0;
   i2 = 1;
   break;
  } else {
   i23 = i1;
   STACKTOP = i24;
   return i23 | 0;
  }
 } while (0);
 i15 = HEAP32[i20 + 100 >> 2] | 0;
 i19 = _UNITY_ft_mem_alloc(i15, 2980, i23) | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i24;
  return i23 | 0;
 }
 HEAP32[i20 + 656 >> 2] = i19;
 i1 = _cff_font_load(i21, i6, i8, i19, i2) | 0;
 HEAP32[i23 >> 2] = i1;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i24;
  return i23 | 0;
 }
 if ((i8 | 0) < 0) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 HEAP32[i19 + 2952 >> 2] = i7;
 HEAP32[i19 + 2956 >> 2] = i9;
 i12 = i8 & 65535;
 HEAP32[i20 + 4 >> 2] = i12;
 i13 = i20 + 16 | 0;
 HEAP32[i13 >> 2] = HEAP32[i19 + 12 >> 2];
 i17 = i19 + 1456 | 0;
 if (!((i9 | 0) != 0 | (HEAP32[i17 >> 2] | 0) != 65535)) {
  HEAP32[i23 >> 2] = 11;
  i23 = 11;
  STACKTOP = i24;
  return i23 | 0;
 }
 i10 = i19 + 1388 | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  if (!(i2 << 24 >> 24)) i1 = HEAPU16[i20 + 68 >> 1] | 0; else i1 = 1e3;
  i11 = i19 + 1392 | 0;
  HEAP32[i11 >> 2] = i1;
 } else i11 = i19 + 1392 | 0;
 i8 = i19 + 1372 | 0;
 i9 = i19 + 1396 | 0;
 i1 = i19 + 1384 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = (i3 | 0) < 0 ? 0 - i3 | 0 : i3;
 if ((i3 | 0) == 65536) {
  i4 = i19 + 1400 | 0;
  i1 = i4;
  i3 = i9;
  i4 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i11 >> 2] = _UNITY_FT_DivFix(HEAP32[i11 >> 2] | 0, i3) | 0;
  HEAP32[i8 >> 2] = _UNITY_FT_DivFix(HEAP32[i8 >> 2] | 0, i3) | 0;
  i4 = i19 + 1380 | 0;
  HEAP32[i4 >> 2] = _UNITY_FT_DivFix(HEAP32[i4 >> 2] | 0, i3) | 0;
  i4 = i19 + 1376 | 0;
  HEAP32[i4 >> 2] = _UNITY_FT_DivFix(HEAP32[i4 >> 2] | 0, i3) | 0;
  HEAP32[i1 >> 2] = _UNITY_FT_DivFix(HEAP32[i1 >> 2] | 0, i3) | 0;
  HEAP32[i9 >> 2] = _UNITY_FT_DivFix(HEAP32[i9 >> 2] | 0, i3) | 0;
  i1 = i19 + 1400 | 0;
  i4 = _UNITY_FT_DivFix(HEAP32[i1 >> 2] | 0, i3) | 0;
  HEAP32[i1 >> 2] = i4;
  i3 = i9;
 }
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] >> 16;
 HEAP32[i1 >> 2] = i4 >> 16;
 i1 = HEAP32[i19 + 1896 >> 2] | 0;
 if (i1 | 0) {
  i7 = i19 + 1900 | 0;
  do {
   i1 = i1 + -1 | 0;
   i6 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
   do if (!(HEAP8[i6 + 64 >> 0] | 0)) {
    i5 = i6 + 48 | 0;
    HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    i5 = i9;
    i14 = HEAP32[i5 + 4 >> 2] | 0;
    i3 = i6 + 72 | 0;
    HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 + 4 >> 2] = i14;
    i3 = i6 + 68 | 0;
    HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
   } else {
    if (!(HEAP8[i10 >> 0] | 0)) {
     i3 = i6 + 68 | 0;
     break;
    }
    i3 = HEAP32[i11 >> 2] | 0;
    i5 = i6 + 68 | 0;
    if (i3 >>> 0 > 1) {
     i4 = HEAP32[i5 >> 2] | 0;
     if (i4 >>> 0 > 1) i3 = i3 >>> 0 < i4 >>> 0 ? i3 : i4; else i3 = 1;
    } else i3 = 1;
    _UNITY_FT_Matrix_Multiply_Scaled(i8, i6 + 48 | 0, i3);
    _UNITY_FT_Vector_Transform_Scaled(i6 + 72 | 0, i8, i3);
    HEAP32[i5 >> 2] = _UNITY_FT_MulDiv(HEAP32[i5 >> 2] | 0, HEAP32[i11 >> 2] | 0, i3) | 0;
    i3 = i5;
   } while (0);
   i4 = i6 + 60 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i5 = (i5 | 0) < 0 ? 0 - i5 | 0 : i5;
   if ((i5 | 0) == 65536) {
    i5 = i6 + 76 | 0;
    i3 = i6 + 72 | 0;
    i4 = i5;
    i5 = HEAP32[i5 >> 2] | 0;
   } else {
    HEAP32[i3 >> 2] = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, i5) | 0;
    i3 = i6 + 48 | 0;
    HEAP32[i3 >> 2] = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, i5) | 0;
    i3 = i6 + 56 | 0;
    HEAP32[i3 >> 2] = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, i5) | 0;
    i3 = i6 + 52 | 0;
    HEAP32[i3 >> 2] = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, i5) | 0;
    HEAP32[i4 >> 2] = _UNITY_FT_DivFix(HEAP32[i4 >> 2] | 0, i5) | 0;
    i3 = i6 + 72 | 0;
    HEAP32[i3 >> 2] = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, i5) | 0;
    i4 = i6 + 76 | 0;
    i5 = _UNITY_FT_DivFix(HEAP32[i4 >> 2] | 0, i5) | 0;
    HEAP32[i4 >> 2] = i5;
   }
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] >> 16;
   HEAP32[i4 >> 2] = i5 >> 16;
  } while ((i1 | 0) != 0);
 }
 i14 = i2 << 24 >> 24 == 0;
 if (!i14) {
  HEAP32[i20 >> 2] = HEAP32[i19 + 8 >> 2];
  if ((HEAP32[i17 >> 2] | 0) == 65535) i1 = HEAP32[i19 + 1184 >> 2] | 0; else i1 = (HEAP32[i19 + 1168 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i20 + 52 >> 2] = HEAP32[i19 + 1408 >> 2] >> 16;
  i10 = HEAP32[i19 + 1412 >> 2] >> 16;
  HEAP32[i20 + 56 >> 2] = i10;
  HEAP32[i20 + 60 >> 2] = (HEAP32[i19 + 1416 >> 2] | 0) + 65535 >> 16;
  i9 = (HEAP32[i19 + 1420 >> 2] | 0) + 65535 >> 16;
  HEAP32[i20 + 64 >> 2] = i9;
  i13 = HEAP32[i11 >> 2] | 0;
  HEAP16[i20 + 68 >> 1] = i13;
  HEAP16[i20 + 70 >> 1] = i9;
  HEAP16[i20 + 72 >> 1] = i10;
  i13 = (((i13 & 65535) * 12 | 0) >>> 0) / 10 | 0;
  i11 = i9 - i10 | 0;
  HEAP16[i20 + 74 >> 1] = (i13 << 16 >> 16 | 0) < (i11 | 0) ? i11 : i13;
  HEAP16[i20 + 80 >> 1] = (HEAP32[i19 + 1356 >> 2] | 0) >>> 16;
  HEAP16[i20 + 82 >> 1] = (HEAP32[i19 + 1360 >> 2] | 0) >>> 16;
  i13 = _cff_index_get_name(i19, i12) | 0;
  i12 = i20 + 20 | 0;
  HEAP32[i12 >> 2] = i13;
  L79 : do if (!i13) {
   i1 = _cff_index_get_sid_string(i19, HEAP32[i19 + 1496 >> 2] | 0) | 0;
   if (!i1) i18 = 76; else {
    HEAP32[i12 >> 2] = _UNITY_ft_mem_strdup(i15, i1, i22) | 0;
    i18 = 76;
   }
  } else {
   i11 = _cff_index_get_sid_string(i19, HEAP32[i19 + 1336 >> 2] | 0) | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = _strlen(i2) | 0;
   i5 = i2 + 6 | 0;
   i6 = i2 + 1 | 0;
   i7 = i2 + 2 | 0;
   i8 = i2 + 3 | 0;
   i9 = i2 + 4 | 0;
   i10 = i2 + 5 | 0;
   L83 : do if ((i1 | 0) > 5) {
    i4 = 1;
    i3 = i1 + 1 | 0;
    do {
     if ((HEAP8[i5 >> 0] | 0) != 43) break L83;
     i4 = ((HEAP8[i10 >> 0] | 0) + -65 & 255) < 26 & (((HEAP8[i9 >> 0] | 0) + -65 & 255) < 26 & (((HEAP8[i8 >> 0] | 0) + -65 & 255) < 26 & (((HEAP8[i7 >> 0] | 0) + -65 & 255) < 26 & (((HEAP8[i2 >> 0] | 0) + -65 & 255) < 26 ? ((HEAP8[i6 >> 0] | 0) + -65 & 255) < 26 : 0)))) ? i4 : 0;
     if (!(i4 << 24 >> 24)) break L83;
     if ((i3 | 0) > 7) {
      i1 = 7;
      do {
       HEAP8[i2 + (i1 + -7) >> 0] = HEAP8[i2 + i1 >> 0] | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i3 | 0));
     }
     i3 = i3 + -7 | 0;
    } while ((i3 | 0) > 6);
   } while (0);
   i1 = HEAP32[i19 + 1340 >> 2] | 0;
   if (i1) {
    i13 = _cff_index_get_sid_string(i19, i1) | 0;
    i2 = (i13 | 0) == 0 ? i2 : i13;
   }
   if ((i11 | 0) != 0 & (i2 | 0) != 0) {
    i3 = HEAP8[i11 >> 0] | 0;
    if (!(i3 << 24 >> 24)) i18 = 76; else {
     i1 = i11;
     L98 : while (1) {
      i5 = i3 << 24 >> 24 == 0;
      L100 : while (1) {
       i4 = HEAP8[i2 >> 0] | 0;
       if (i3 << 24 >> 24 == i4 << 24 >> 24) {
        i18 = 59;
        break;
       }
       switch (i3 << 24 >> 24) {
       case 45:
       case 32:
        break L100;
       default:
        {}
       }
       switch (i4 << 24 >> 24) {
       case 0:
        break L98;
       case 45:
       case 32:
        break;
       default:
        {
         i18 = 76;
         break L79;
        }
       }
       if (i5) {
        i18 = 76;
        break L79;
       } else i2 = i2 + 1 | 0;
      }
      if ((i18 | 0) == 59) {
       i18 = 0;
       i2 = i2 + 1 | 0;
      }
      i1 = i1 + 1 | 0;
      i3 = HEAP8[i1 >> 0] | 0;
      if (!(i3 << 24 >> 24)) {
       i18 = 76;
       break L79;
      }
     }
     i5 = _UNITY_ft_mem_strdup(i15, i1, i22) | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i2 = _strlen(i4) | 0;
     i3 = _strlen(i5) | 0;
     L109 : do if ((i2 | 0) > (i3 | 0)) {
      if ((i3 | 0) >= 1) {
       i1 = 1;
       while (1) {
        if ((HEAP8[i4 + (i2 - i1) >> 0] | 0) != (HEAP8[i5 + (i3 - i1) >> 0] | 0)) break L109;
        if ((i3 | 0) > (i1 | 0)) i1 = i1 + 1 | 0; else break;
       }
      }
      i1 = i2 - i3 | 0;
      if ((i1 | 0) <= 1) {
       i18 = 74;
       break;
      }
      L116 : while (1) {
       i2 = i1 + -1 | 0;
       switch (HEAP8[i4 + i2 >> 0] | 0) {
       case 43:
       case 95:
       case 32:
       case 45:
        break;
       default:
        break L116;
       }
       if ((i2 | 0) > 1) i1 = i2; else {
        i18 = 74;
        break L109;
       }
      }
      HEAP8[i4 + i1 >> 0] = 0;
      i18 = 74;
     } else i18 = 74; while (0);
     if ((i18 | 0) == 74) if (!i5) {
      i18 = 76;
      break;
     }
     HEAP32[i20 + 24 >> 2] = i5;
    }
   } else i18 = 76;
  } while (0);
  if ((i18 | 0) == 76) HEAP32[i20 + 24 >> 2] = _UNITY_ft_mem_strdup(i15, gb + 1006961 | 0, i22) | 0;
  i2 = i16 << 24 >> 24 == 0 ? 2065 : 2073;
  i1 = i20 + 8 | 0;
  HEAP32[i1 >> 2] = ((HEAP8[i19 + 1348 >> 0] | 0) == 0 ? i2 : i2 | 4) | HEAP32[i1 >> 2];
  i1 = (HEAP32[i19 + 1352 >> 2] | 0) != 0 & 1;
  i2 = _cff_index_get_sid_string(i19, HEAP32[i19 + 1344 >> 2] | 0) | 0;
  do if (i2) {
   if (_strcmp(i2, gb + 1006969 | 0) | 0) if (_strcmp(i2, gb + 1006974 | 0) | 0) break;
   i1 = i1 | 2;
  } while (0);
  do if (!(i1 & 2)) {
   i2 = HEAP32[i20 + 24 >> 2] | 0;
   if (i2) {
    if (_strncmp(i2, gb + 1006969 | 0, 4) | 0) if (_strncmp(i2, gb + 1006974 | 0, 5) | 0) break;
    i1 = i1 | 2;
   }
  } while (0);
  HEAP32[i20 + 12 >> 2] = i1;
 }
 i1 = (HEAP32[i17 >> 2] | 0) == 65535;
 if (i1) {
  i18 = i20 + 8 | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 512;
 } else if (!(i14 | i1)) {
  i18 = i20 + 8 | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 4096;
 }
 i4 = i20 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L145 : do if (!i5) i18 = 96; else {
  i2 = HEAP32[i20 + 40 >> 2] | 0;
  i1 = 0;
  while (1) {
   i3 = HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0;
   switch ((i3 & 65535) << 16 >> 16) {
   case 0:
    {
     i18 = 102;
     break L145;
    }
   case 3:
    {
     if ((i3 & -65536 | 0) == 65536) {
      i18 = 102;
      break L145;
     }
     break;
    }
   default:
    {}
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i18 = 96;
    break L145;
   }
  }
 } while (0);
 do if ((i18 | 0) == 96) {
  if (!i14) if ((HEAP32[i17 >> 2] | 0) != 65535) break;
  HEAP32[i22 >> 2] = i20;
  HEAP16[i22 + 8 >> 1] = 3;
  HEAP16[i22 + 10 >> 1] = 1;
  HEAP32[i22 + 4 >> 2] = 1970170211;
  i17 = _UNITY_FT_CMap_New((HEAP32[i21 + 196 >> 2] | 0) + 104 | 0, 0, i22, 0) | 0;
  HEAP32[i23 >> 2] = i17;
  if ((i17 | 0) == 0 | (i17 & 255 | 0) == 163) {
   HEAP32[i23 >> 2] = 0;
   i1 = i20 + 92 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) if ((i5 | 0) == (HEAP32[i4 >> 2] | 0)) i18 = 102; else {
    HEAP32[i1 >> 2] = HEAP32[(HEAP32[i20 + 40 >> 2] | 0) + (i5 << 2) >> 2];
    i18 = 102;
   } else i18 = 102;
  }
 } while (0);
 if ((i18 | 0) == 102) if (HEAP32[i19 + 124 >> 2] | 0) {
  HEAP32[i22 >> 2] = i20;
  HEAP16[i22 + 8 >> 1] = 7;
  i1 = HEAP32[i19 + 120 >> 2] | 0;
  do if (!i1) {
   HEAP16[i22 + 10 >> 1] = 0;
   HEAP32[i22 + 4 >> 2] = 1094995778;
   i1 = (HEAP32[i21 + 196 >> 2] | 0) + 64 | 0;
  } else {
   i2 = i22 + 10 | 0;
   if ((i1 | 0) == 1) {
    HEAP16[i2 >> 1] = 1;
    HEAP32[i22 + 4 >> 2] = 1094992453;
    i1 = (HEAP32[i21 + 196 >> 2] | 0) + 64 | 0;
    break;
   } else {
    HEAP16[i2 >> 1] = 2;
    HEAP32[i22 + 4 >> 2] = 1094992451;
    i1 = (HEAP32[i21 + 196 >> 2] | 0) + 64 | 0;
    break;
   }
  } while (0);
  HEAP32[i23 >> 2] = _UNITY_FT_CMap_New(i1, 0, i22, 0) | 0;
 }
 i23 = HEAP32[i23 >> 2] | 0;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN7Cubemap10FixupEdgesEi(i36, i29) {
 i36 = i36 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i39 + 216 | 0;
 i32 = i39 + 120 | 0;
 i33 = i39;
 __ZN9Texture2D18UnshareTextureDataEv(i36);
 if ((i29 | 0) == 0 | (mftCall_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 112 >> 2] | 0, i36 | 0) | 0) ^ 1) {
  STACKTOP = i39;
  return;
 }
 i6 = mftCall_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 136 >> 2] | 0, i36 | 0) | 0;
 i2 = i32;
 i3 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i5 = Math_imul(i6 << 4, i6) | 0;
 i37 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
 HEAP32[i32 + 12 >> 2] = i37;
 if (!i37) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
  i38 = 5;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
  i31 = i32 + 28 | 0;
  HEAP32[i31 >> 2] = i4;
  if (!i4) {
   i4 = 0;
   i3 = 0;
   i2 = 0;
   i1 = 0;
   i38 = 5;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
   i34 = i32 + 44 | 0;
   HEAP32[i34 >> 2] = i3;
   if (!i3) {
    i3 = 0;
    i2 = 0;
    i1 = 0;
    i38 = 5;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
    i35 = i32 + 60 | 0;
    HEAP32[i35 >> 2] = i2;
    if (!i2) {
     i2 = 0;
     i1 = 0;
     i38 = 5;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
     HEAP32[i32 + 76 >> 2] = i1;
     if (!i1) {
      i1 = 0;
      i38 = 5;
     } else {
      i28 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63160 | 0, 1, gb + 397213 | 0, 257) | 0;
      HEAP32[i32 + 92 >> 2] = i28;
      if (!i28) i38 = 5; else {
       i16 = i36 + 76 | 0;
       if ((HEAP32[i16 >> 2] | 0) > 0) {
        i17 = i36 + 60 | 0;
        i18 = i30 + 4 | 0;
        i19 = i30 + 8 | 0;
        i20 = i30 + 12 | 0;
        i21 = i30 + 4 | 0;
        i22 = i30 + 8 | 0;
        i23 = i30 + 12 | 0;
        i24 = i36 + 4 | 0;
        i25 = i30 + 4 | 0;
        i26 = i30 + 8 | 0;
        i27 = i30 + 12 | 0;
        i15 = 0;
        while (1) {
         i2 = i33;
         i3 = i2 + 120 | 0;
         do {
          HEAP32[i2 >> 2] = 0;
          i2 = i2 + 4 | 0;
         } while ((i2 | 0) < (i3 | 0));
         i13 = 0;
         do {
          HEAP32[i32 + (i13 << 4) + 4 >> 2] = i6;
          HEAP32[i32 + (i13 << 4) >> 2] = i6;
          HEAP32[i32 + (i13 << 4) + 8 >> 2] = 4;
          i14 = i33 + (i13 * 20 | 0) | 0;
          if (!(__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i36, i14, i13, i15) | 0)) {
           i38 = 9;
           break;
          }
          i2 = HEAP32[i32 + (i13 << 4) + 12 >> 2] | 0;
          switch (HEAP32[i17 >> 2] | 0) {
          case 0:
           {
            i7 = HEAP32[i33 + (i13 * 20 | 0) + 4 >> 2] | 0;
            i8 = HEAP32[i33 + (i13 * 20 | 0) + 8 >> 2] | 0;
            if ((i7 | 0) > 0) {
             i10 = i33 + (i13 * 20 | 0) + 16 | 0;
             if ((i8 | 0) > 0) {
              i5 = 0;
              while (1) {
               i3 = 0;
               i4 = i2;
               while (1) {
                __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i30, HEAP32[i10 >> 2] | 0, i7, i8, HEAP32[i14 >> 2] | 0, 1, i3, i5);
                i42 = HEAP32[i18 >> 2] | 0;
                i41 = HEAP32[i19 >> 2] | 0;
                i40 = HEAP32[i20 >> 2] | 0;
                HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
                HEAP32[i4 + 4 >> 2] = i42;
                HEAP32[i4 + 8 >> 2] = i41;
                HEAP32[i4 + 12 >> 2] = i40;
                i3 = i3 + 1 | 0;
                if ((i3 | 0) == (i8 | 0)) break; else i4 = i4 + 16 | 0;
               }
               i5 = i5 + 1 | 0;
               if ((i5 | 0) == (i7 | 0)) break; else i2 = i2 + (i8 << 4) | 0;
              }
             }
            }
            break;
           }
          case 1:
           {
            i7 = HEAP32[i33 + (i13 * 20 | 0) + 4 >> 2] | 0;
            i8 = HEAP32[i33 + (i13 * 20 | 0) + 8 >> 2] | 0;
            if ((i7 | 0) > 0) {
             i10 = i33 + (i13 * 20 | 0) + 16 | 0;
             if ((i8 | 0) > 0) {
              i5 = 0;
              while (1) {
               i3 = 0;
               i4 = i2;
               do {
                __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i30, HEAP32[i10 >> 2] | 0, i7, i8, HEAP32[i14 >> 2] | 0, 1, i3, i5);
                f9 = Math_fround(HEAPF32[i30 >> 2]);
                do if (!(f9 <= Math_fround(.0404499993))) {
                 if (f9 < Math_fround(1.0)) {
                  f12 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
                  break;
                 }
                 if (f9 == Math_fround(1.0)) {
                  f12 = Math_fround(1.0);
                  break;
                 }
                 f12 = Math_fround(+Math_pow(+f9, 2.20000005));
                } else f12 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
                f9 = Math_fround(HEAPF32[i21 >> 2]);
                do if (!(f9 <= Math_fround(.0404499993))) {
                 if (f9 < Math_fround(1.0)) {
                  f11 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
                  break;
                 }
                 if (f9 == Math_fround(1.0)) {
                  f11 = Math_fround(1.0);
                  break;
                 }
                 f11 = Math_fround(+Math_pow(+f9, 2.20000005));
                } else f11 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
                f9 = Math_fround(HEAPF32[i22 >> 2]);
                do if (!(f9 <= Math_fround(.0404499993))) {
                 if (f9 < Math_fround(1.0)) {
                  f9 = Math_fround(+Math_pow(+Math_fround(Math_fround(f9 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
                  break;
                 }
                 if (f9 == Math_fround(1.0)) {
                  f9 = Math_fround(1.0);
                  break;
                 }
                 f9 = Math_fround(+Math_pow(+f9, 2.20000005));
                } else f9 = Math_fround(f9 / Math_fround(12.9200001)); while (0);
                i42 = HEAP32[i23 >> 2] | 0;
                HEAPF32[i4 >> 2] = f12;
                HEAPF32[i4 + 4 >> 2] = f11;
                HEAPF32[i4 + 8 >> 2] = f9;
                HEAP32[i4 + 12 >> 2] = i42;
                i4 = i4 + 16 | 0;
                i3 = i3 + 1 | 0;
               } while ((i3 | 0) != (i8 | 0));
               i5 = i5 + 1 | 0;
               if ((i5 | 0) == (i7 | 0)) break; else i2 = i2 + (i8 << 4) | 0;
              }
             }
            }
            break;
           }
          default:
           {}
          }
          i13 = i13 + 1 | 0;
         } while ((i13 | 0) < 6);
         if ((i38 | 0) == 9) {
          i38 = 0;
          __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400839 | 0, 0, gb + 397213 | 0, 279, 1, HEAP32[i24 >> 2] | 0, 0, 0);
         }
         __Z14FixupCubeEdgesP13CImageSurfaceii(i32, 2, i29);
         i10 = 0;
         do {
          i13 = i33 + (i10 * 20 | 0) | 0;
          i2 = HEAP32[i32 + (i10 << 4) + 12 >> 2] | 0;
          switch (HEAP32[i17 >> 2] | 0) {
          case 0:
           {
            i7 = HEAP32[i33 + (i10 * 20 | 0) + 4 >> 2] | 0;
            i8 = HEAP32[i33 + (i10 * 20 | 0) + 8 >> 2] | 0;
            if ((i7 | 0) > 0 & (i8 | 0) > 0) {
             i5 = 0;
             while (1) {
              i3 = 0;
              i4 = i2;
              while (1) {
               __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf(i13, i3, i5, 1, i4);
               i3 = i3 + 1 | 0;
               if ((i3 | 0) == (i8 | 0)) break; else i4 = i4 + 16 | 0;
              }
              i5 = i5 + 1 | 0;
              if ((i5 | 0) == (i7 | 0)) break; else i2 = i2 + (i8 << 4) | 0;
             }
            }
            break;
           }
          case 1:
           {
            i7 = HEAP32[i33 + (i10 * 20 | 0) + 4 >> 2] | 0;
            i8 = HEAP32[i33 + (i10 * 20 | 0) + 8 >> 2] | 0;
            if ((i7 | 0) > 0 & (i8 | 0) > 0) {
             i5 = 0;
             while (1) {
              i3 = 0;
              i4 = i2;
              do {
               f9 = Math_fround(HEAPF32[i4 >> 2]);
               do if (!(f9 <= Math_fround(0.0))) {
                if (f9 <= Math_fround(.00313080009)) {
                 f12 = Math_fround(f9 * Math_fround(12.9200001));
                 break;
                }
                if (f9 < Math_fround(1.0)) {
                 f12 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
                 break;
                }
                if (f9 == Math_fround(1.0)) {
                 f12 = Math_fround(1.0);
                 break;
                }
                f12 = Math_fround(+Math_pow(+f9, .454545468));
               } else f12 = Math_fround(0.0); while (0);
               f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
               do if (!(f9 <= Math_fround(0.0))) {
                if (f9 <= Math_fround(.00313080009)) {
                 f11 = Math_fround(f9 * Math_fround(12.9200001));
                 break;
                }
                if (f9 < Math_fround(1.0)) {
                 f11 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
                 break;
                }
                if (f9 == Math_fround(1.0)) {
                 f11 = Math_fround(1.0);
                 break;
                }
                f11 = Math_fround(+Math_pow(+f9, .454545468));
               } else f11 = Math_fround(0.0); while (0);
               f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
               do if (!(f9 <= Math_fround(0.0))) {
                if (f9 <= Math_fround(.00313080009)) {
                 f9 = Math_fround(f9 * Math_fround(12.9200001));
                 break;
                }
                if (f9 < Math_fround(1.0)) {
                 f9 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
                 break;
                }
                if (f9 == Math_fround(1.0)) {
                 f9 = Math_fround(1.0);
                 break;
                }
                f9 = Math_fround(+Math_pow(+f9, .454545468));
               } else f9 = Math_fround(0.0); while (0);
               i42 = HEAP32[i4 + 12 >> 2] | 0;
               i4 = i4 + 16 | 0;
               HEAPF32[i30 >> 2] = f12;
               HEAPF32[i25 >> 2] = f11;
               HEAPF32[i26 >> 2] = f9;
               HEAP32[i27 >> 2] = i42;
               __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf(i13, i3, i5, 1, i30);
               i3 = i3 + 1 | 0;
              } while ((i3 | 0) != (i8 | 0));
              i5 = i5 + 1 | 0;
              if ((i5 | 0) == (i7 | 0)) break; else i2 = i2 + (i8 << 4) | 0;
             }
            }
            break;
           }
          default:
           {}
          }
          i10 = i10 + 1 | 0;
         } while ((i10 | 0) != 6);
         i2 = (i6 | 0) / 2 | 0;
         i15 = i15 + 1 | 0;
         if ((i15 | 0) >= (HEAP32[i16 >> 2] | 0)) break; else i6 = (i2 | 0) < 1 ? 1 : i2;
        }
       }
       __Z19free_alloc_internalPvRK10MemLabelId(i37, gb + 63160 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, gb + 63160 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, gb + 63160 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, gb + 63160 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(i28, gb + 63160 | 0);
      }
     }
    }
   }
  }
 }
 if ((i38 | 0) == 5) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400763 | 0, 0, gb + 397213 | 0, 260, 1, HEAP32[i36 + 4 >> 2] | 0, 0, 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i37, gb + 63160 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63160 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63160 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63160 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(0, gb + 63160 | 0);
 }
 STACKTOP = i39;
 return;
}

function __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i22, i21, i13) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23 + 72 | 0;
 i19 = i23 + 64 | 0;
 i12 = i23;
 HEAP8[i22 + 500 >> 0] = 0;
 i16 = i22 + 356 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 if (!(__ZNK4Mesh15GetSubMeshCountEv(i1) | 0)) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i3 = HEAP32[i16 >> 2] | 0;
 if (!i3) i5 = 0; else i5 = HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 156 >> 2] | 0;
 i4 = i22 + 412 | 0;
 i20 = HEAP32[i22 + 428 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i15 = i22 + 416 | 0;
 i2 = i20 >>> 0 < i2 >>> 0 ? i20 : i2;
 while (1) {
  i1 = i2 + -1 | 0;
  if ((i1 | 0) <= -1) {
   i2 = 0;
   break;
  }
  if (Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2]) > Math_fround(.0000999999974)) break; else i2 = i1;
 }
 do if ((i5 | 0) > 0) {
  if (!(__ZN4Mesh17VerifyBoneIndicesEj(i3, i5) | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429e3 | 0, 0, gb + 429036 | 0, 377, 1, HEAP32[i22 + 4 >> 2] | 0, 0, 0);
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i16 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  if (!(HEAP32[i3 + 176 >> 2] | 0)) i17 = 16; else {
   if (!((i1 | 0) == 0 | (HEAP32[i22 + 372 >> 2] | 0) != 0)) if ((HEAP32[i3 + 156 >> 2] | 0) > 0) {
    i1 = i22 + 396 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i22);
     if (!(HEAP32[i1 >> 2] | 0)) {
      i17 = 16;
      break;
     }
    }
   }
   i1 = (i2 | 0) > 0;
   if ((i21 & 8 | 0) == 0 | i1) {
    i10 = 0;
    i11 = 1;
   } else if (!(HEAP32[i22 + 504 >> 2] | 0)) if (!(HEAP32[i22 + 508 >> 2] | 0)) {
    i1 = 0;
    i10 = 0;
    i11 = 1;
   } else if (!(HEAP8[(__Z17GetPlayerSettingsv() | 0) + 414 >> 0] | 0)) {
    i1 = 0;
    i10 = 0;
    i11 = 1;
   } else {
    i1 = 0;
    i10 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 511 >> 0] | 0) != 0;
    i11 = 1;
   } else {
    i1 = 0;
    i10 = 0;
    i11 = 1;
   }
  }
 } else i17 = 16; while (0);
 if ((i17 | 0) == 16) {
  i1 = (HEAP32[i4 >> 2] | 0) != 0;
  i5 = 0;
  i10 = 0;
  i11 = 0;
 }
 HEAP32[i22 + 496 >> 2] = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0) + 96 >> 2];
 i9 = (i2 | 0) == 0;
 if (i9) i3 = 1; else i3 = (HEAP32[i22 + 504 >> 2] | 0) != 0;
 i7 = (i5 | 0) == 0 & i3 ? 1 : i5;
 i8 = i7 << 6;
 i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i2 << 2) + 128 + i8 | 0, 64, gb + 64024 | 0, 0, gb + 428921 | 0, 170) | 0;
 i3 = i20 + 92 | 0;
 i4 = i20;
 i6 = i4 + 128 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i3 >> 0] = 1;
 i4 = i20 + 128 | 0;
 if (!i7) {
  i3 = i4;
  i6 = 0;
 } else {
  HEAP32[i20 + 68 >> 2] = i4;
  i3 = i4 + i8 | 0;
  i6 = i4;
 }
 if (!i9) HEAP32[i20 + 72 >> 2] = i3;
 HEAP32[i20 + 28 >> 2] = i5;
 i8 = i20 + 76 | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i16 >> 2] | 0;
 i14 = i20 + 60 | 0;
 HEAP32[i14 >> 2] = HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 100 >> 2];
 i9 = i20 + 93 | 0;
 HEAP8[i9 >> 0] = i10 & 1;
 do if (i11) {
  i2 = HEAP32[i22 + 460 >> 2] | 0;
  if (!i2) {
   i2 = __Z18GetQualitySettingsv() | 0;
   i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 44 >> 2] | 0) * 108 | 0) + 60 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
  }
  HEAP32[i20 + 20 >> 2] = i2;
  HEAP32[i20 + 24 >> 2] = __ZN4Mesh16GetSkinInfluenceEi(i3, i2) | 0;
  HEAP32[i19 >> 2] = HEAP32[i22 + 380 >> 2];
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i17 = 36; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i2, i19);
    i3 = HEAP32[i18 >> 2] | 0;
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i17 = 36; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i17 = 39;
   }
  }
  if ((i17 | 0) == 36) i17 = 39;
  if ((i17 | 0) == 39) i2 = __ZN8Renderer12GetTransformEv(i22) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i12, i2);
  L60 : do if (!(HEAP32[i22 + 372 >> 2] | 0)) {
   i3 = HEAP32[i16 >> 2] | 0;
   if (!i3) i17 = 42; else {
    i2 = HEAP32[i20 + 68 >> 2] | 0;
    if ((HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 156 >> 2] | 0) > 0) {
     i6 = i22 + 384 | 0;
     i4 = i22 + 396 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i22);
      i3 = HEAP32[i4 >> 2] | 0;
     }
     do if (!((i3 | 0) == 0 | (HEAP32[gb + 1162104 >> 2] | 0) == 0)) {
      i7 = __ZnwjRK10MemLabelIdiPKci(28, gb + 64024 | 0, 16, gb + 429036 | 0, 351) | 0;
      i4 = i22 + 408 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i22);
       i3 = HEAP32[i4 >> 2] | 0;
      }
      HEAP32[i7 >> 2] = i3;
      HEAP32[i7 + 4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i7 + 8 >> 2] = HEAPU16[i22 + 404 >> 1];
      HEAP32[i7 + 12 >> 2] = i5;
      HEAP32[i7 + 16 >> 2] = __ZN4Mesh21AcquireSharedMeshDataEv(HEAP32[i16 >> 2] | 0) | 0;
      HEAP8[i7 + 20 >> 0] = 0;
      HEAP32[i7 + 24 >> 2] = i2;
      if (!i7) if (!i20) break L60; else break;
      i2 = __Z13GetIAnimationv() | 0;
      i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i4 >> 2] | 0) | 0;
      i3 = i22 + 340 | 0;
      i4 = HEAP32[gb + 1162104 >> 2] | 0;
      if (!i13) __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i3, i4, i7, i2, 0); else __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i13, i3, i4, i7, i2);
      __Z21ClearFenceWithoutSyncR8JobFence(i2);
      i17 = i3;
      i13 = HEAP32[i17 + 4 >> 2] | 0;
      i12 = i2;
      HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i12 + 4 >> 2] = i13;
      i12 = i3;
      i13 = HEAP32[i12 + 4 >> 2] | 0;
      i17 = i20 + 84 | 0;
      HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i17 + 4 >> 2] = i13;
      i17 = 76;
      break L60;
     } while (0);
     i1 = i20 + 84 | 0;
     if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
     i1 = HEAP32[i20 + 100 >> 2] | 0;
     do if (i1 | 0) {
      i22 = i1 + 4 | 0;
      HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
      if (HEAP32[i22 >> 2] | 0) break;
      mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
      __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
     } while (0);
     __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
    } else i17 = 61;
   }
  } else i17 = 42; while (0);
  if ((i17 | 0) == 42) {
   i2 = HEAP32[i20 + 68 >> 2] | 0;
   i17 = 61;
  }
  if ((i17 | 0) == 61) {
   if ((HEAP16[gb + 1161604 + 6 >> 1] | 0) > -1) {
    HEAP32[i19 >> 2] = i22;
    HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161604 | 0, i18);
    i3 = gb + 1161604 | 0;
   } else i3 = 0;
   if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i22, i2, i5) | 0) {
    i13 = HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0;
    __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j(i12, i2, (HEAP32[i13 + 156 >> 2] | 0) == 0 ? 0 : HEAP32[i13 + 144 >> 2] | 0, i2, i5);
    i2 = 1;
   } else i2 = 0;
   if (i3 | 0) __Z12profiler_endP19ProfilerInformation(i3);
   if (i2) i17 = 76; else if (i20 | 0) {
    i1 = i20 + 84 | 0;
    if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
    i1 = HEAP32[i20 + 100 >> 2] | 0;
    do if (i1 | 0) {
     i22 = i1 + 4 | 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
     if (HEAP32[i22 >> 2] | 0) break;
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
    } while (0);
    __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
   }
  }
  if ((i17 | 0) == 76) break;
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 } else {
  if (!(HEAP32[i22 + 504 >> 2] | 0)) HEAP32[i20 + 68 >> 2] = 0; else {
   HEAP32[i19 >> 2] = HEAP32[i22 + 380 >> 2];
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i17 = 83; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i2, i19);
     i3 = HEAP32[i18 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i17 = 83; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i17 = 86;
    }
   }
   if ((i17 | 0) == 83) i17 = 86;
   if ((i17 | 0) == 86) i2 = __ZN8Renderer12GetTransformEv(i22) | 0;
   __ZNK9Transform13GetWorldScaleEv(i12, i2);
   __ZN10Matrix4x4faSERK10Matrix3x3f(i6, i12) | 0;
  }
  HEAP32[i20 + 24 >> 2] = 0;
 } while (0);
 if (i1) {
  _memcpy(HEAP32[i20 + 72 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  i1 = HEAP32[i16 >> 2] | 0;
  HEAP32[i20 + 80 >> 2] = i1 + 72;
 } else i1 = HEAP32[i16 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP8[i4 + 50 >> 0] | 0;
 HEAP32[i20 + 32 >> 2] = (HEAP32[i4 + 92 >> 2] | 0) + (HEAP32[i4 + 44 >> 2] | 0);
 i2 = i2 & 255;
 HEAP32[i20 + 40 >> 2] = i2;
 i7 = i20 + 44 | 0;
 HEAP32[i7 >> 2] = i2;
 do if (!(i21 & 1)) {
  i5 = __Z12GetGfxDevicev() | 0;
  i6 = i22 + 468 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i17 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 220 >> 2] | 0, i5 | 0) | 0;
   i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63248 | 0, 16, gb + 1012378 | 0, 14) | 0;
   HEAP32[i1 + 4 >> 2] = 1;
   HEAP32[i1 >> 2] = gb + 58920 + 8;
   HEAP32[i1 + 8 >> 2] = i17;
  }
  HEAP32[i6 >> 2] = i1;
  if (!(HEAP8[i9 >> 0] | 0)) {
   i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
   if (i1 >>> 0 < 10) if (!(521 >>> (i1 & 1023) & 1)) i3 = 1; else {
    i3 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 694 >> 0] | 0) == 0;
    i3 = i3 ? 1 : 2;
   } else i3 = 1;
  } else i3 = 3;
  i2 = Math_imul(HEAP32[i4 + 100 >> 2] | 0, i2) | 0;
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) == (i3 | 0)) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) if ((HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) == (i2 | 0)) break;
  if ((HEAP16[gb + 1161616 + 6 >> 1] | 0) > -1) {
   HEAP32[i19 >> 2] = i22;
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161616 | 0, i18);
   i1 = gb + 1161616 | 0;
  } else i1 = 0;
  i19 = HEAP32[gb + 1161616 >> 2] | 0;
  i18 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 648 >> 2] | 0, i18 | 0, i19 | 0);
  mftCall_viiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 0, i2 | 0, 0, 0);
  i19 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 652 >> 2] | 0, i19 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 } while (0);
 if (HEAP8[i9 >> 0] | 0) {
  i22 = i20;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP8[i20 + 56 >> 0] = (HEAP8[i4 + 15 >> 0] | 0) != 0 & 1;
 HEAP32[i20 + 48 >> 2] = HEAPU8[i4 + 13 >> 0];
 HEAP8[i20 + 57 >> 0] = (HEAP8[i4 + 39 >> 0] | 0) != 0 & 1;
 HEAP32[i20 + 52 >> 2] = HEAPU8[i4 + 37 >> 0];
 if (!(i21 & 2)) {
  i22 = i20;
  STACKTOP = i23;
  return i22 | 0;
 }
 i5 = i22 + 476 | 0;
 i1 = Math_imul(HEAP32[i14 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i2 = i22 + 488 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i22 + 492 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 1, i22 + 480 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i22 + 480 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i22;
  i1 = i22;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 HEAP32[i20 + 36 >> 2] = i1;
 i22 = i20;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN6Shader8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i31 + 24 | 0;
 i5 = i31 + 16 | 0;
 i16 = i31 + 8 | 0;
 i19 = i31 + 120 | 0;
 i20 = i31 + 100 | 0;
 i23 = i31 + 80 | 0;
 i24 = i31 + 60 | 0;
 i27 = i31 + 40 | 0;
 i1 = i31;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i10);
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i2 = i16;
 HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i2 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i2 = i19 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i16);
 i21 = i30;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i25 = i18;
 HEAP32[i25 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i25 + 4 >> 2] = i22;
 i25 = gb + 64016 | 0;
 i22 = HEAP32[i25 + 4 >> 2] | 0;
 i21 = i16;
 HEAP32[i21 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i21 + 4 >> 2] = i22;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 i21 = i20 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i16);
 i25 = i30;
 i26 = HEAP32[i25 + 4 >> 2] | 0;
 i6 = i22;
 HEAP32[i6 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i6 + 4 >> 2] = i26;
 i6 = gb + 64016 | 0;
 i26 = HEAP32[i6 + 4 >> 2] | 0;
 i25 = i16;
 HEAP32[i25 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i25 = i23 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i16);
 i6 = i30;
 i28 = HEAP32[i6 + 4 >> 2] | 0;
 i29 = i26;
 HEAP32[i29 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i29 + 4 >> 2] = i28;
 i29 = gb + 64016 | 0;
 i28 = HEAP32[i29 + 4 >> 2] | 0;
 i6 = i16;
 HEAP32[i6 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i6 + 4 >> 2] = i28;
 HEAP32[i24 >> 2] = 0;
 i6 = i24 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i28 = i24 + 16 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i16);
 i7 = i30;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = i29;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i7 = i16;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i27 >> 2] = 0;
 i7 = i27 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i11 = i27 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i16);
 i14 = i30;
 i8 = HEAP32[i14 + 4 >> 2] | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = i8;
 i13 = HEAP32[i9 + 96 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470263 | 0, gb + 470276 | 0, i13, 0);
 __ZN9ShaderLab16SerializedShader8TransferI24GenerateTypeTreeTransferEEvRT_(i13, i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 i13 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470293 | 0, i13, i19, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i30, 0);
 i8 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, i8, i16, 0);
 i14 = i10 + 16 | 0;
 i15 = i10 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470303 | 0, i13, i20, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i30, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, i8, i16, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470311 | 0, i13, i23, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i30, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, i8, i16, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470329 | 0, i13, i24, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i30, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, i8, i16, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470349 | 0, i13, i27, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i30, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i16, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 if (HEAP32[i2 >> 2] | 0) {
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i3;
  HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i8 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i30) | 0;
  i3 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i3 << 2) >> 2] | 0;
  L3 : do if ((i3 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i2 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i19 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L3;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i5 >> 2] = i4;
   __Z6FormatPKcz(i30, gb + 470364 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i30 + 11 >> 0] | 0) < 0 ? HEAP32[i30 >> 2] | 0 : i30, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i4 = i9 + 60 | 0;
   i5 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i30 >> 2] = i5;
   HEAP32[i16 >> 2] = i3;
   if ((i3 | 0) != 0 & (i5 | 0 ? (HEAP32[i7 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i9 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i9 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i9 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i9 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i7;
     i1 = i7;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, (HEAP32[i27 >> 2] | 0) + i6 | 0, i16 | 0, i1 | 0, i30 | 0) | 0;
   }
  }
  if (i8 | 0) mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i12);
  HEAP32[i27 >> 2] = 0;
 }
 if ((HEAP32[i28 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i29);
  HEAP32[i24 >> 2] = 0;
 }
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i26);
  HEAP32[i23 >> 2] = 0;
 }
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i22);
  HEAP32[i20 >> 2] = 0;
 }
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  i29 = i9 + 80 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470499 | 0, i13, i29, 0);
  HEAP32[i19 >> 2] = 0;
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i16, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, gb + 479385 | 0, i19, 0);
  i29 = i30 + 8 | 0;
  i28 = i29;
  i27 = i28;
  HEAP32[i27 >> 2] = 0;
  i28 = i28 + 4 | 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i30 >> 2] = 0;
  i28 = HEAP32[gb + 37040 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1048093 | 0, i28, i19, 1);
  i28 = HEAP32[i14 >> 2] | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  i30 = HEAP32[i15 >> 2] | 0;
  i30 = i28 + (i30 * 24 | 0) + 12 | 0;
  HEAP32[i30 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  i30 = HEAP32[gb + 37248 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1048102 | 0, i30, i29, 1);
  i30 = HEAP32[i14 >> 2] | 0;
  i30 = HEAP32[i30 >> 2] | 0;
  i29 = HEAP32[i15 >> 2] | 0;
  i29 = i30 + (i29 * 24 | 0) + 12 | 0;
  HEAP32[i29 >> 2] = 8;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  i29 = i9 + 92 | 0;
  i30 = HEAP32[gb + 36972 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470514 | 0, i30, i29, 0);
  i29 = HEAP32[i14 >> 2] | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  i30 = HEAP32[i15 >> 2] | 0;
  i30 = i29 + (i30 * 24 | 0) + 12 | 0;
  HEAP32[i30 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i10);
  STACKTOP = i31;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
 HEAP32[i19 >> 2] = 0;
 i29 = i9 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470499 | 0, i13, i29, 0);
 HEAP32[i19 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i16, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, gb + 479385 | 0, i19, 0);
 i29 = i30 + 8 | 0;
 i28 = i29;
 i27 = i28;
 HEAP32[i27 >> 2] = 0;
 i28 = i28 + 4 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 i28 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1048093 | 0, i28, i19, 1);
 i28 = HEAP32[i14 >> 2] | 0;
 i28 = HEAP32[i28 >> 2] | 0;
 i30 = HEAP32[i15 >> 2] | 0;
 i30 = i28 + (i30 * 24 | 0) + 12 | 0;
 HEAP32[i30 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 i30 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1048102 | 0, i30, i29, 1);
 i30 = HEAP32[i14 >> 2] | 0;
 i30 = HEAP32[i30 >> 2] | 0;
 i29 = HEAP32[i15 >> 2] | 0;
 i29 = i30 + (i29 * 24 | 0) + 12 | 0;
 HEAP32[i29 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 i29 = i9 + 92 | 0;
 i30 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 470514 | 0, i30, i29, 0);
 i29 = HEAP32[i14 >> 2] | 0;
 i29 = HEAP32[i29 >> 2] | 0;
 i30 = HEAP32[i15 >> 2] | 0;
 i30 = i29 + (i30 * 24 | 0) + 12 | 0;
 HEAP32[i30 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i10);
 STACKTOP = i31;
 return;
}

function __ZN8Animator6SampleER13AnimationClipf(i19, i8, f15) {
 i19 = i19 | 0;
 i8 = i8 | 0;
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 40 | 0;
 i9 = i21;
 i20 = i21 + 940 | 0;
 i17 = i21 + 928 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 116 >> 2] | 0, i8 | 0) | 0) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = i19 + 108 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i18 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i9);
   i2 = HEAP32[i16 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i18 = 10;
 }
 if ((i18 | 0) == 8) i18 = 10;
 if ((i18 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i14 = i19 + 196 | 0;
 __ZN8Animator18AutoMecanimDataSet5ResetEv(i14);
 i5 = i19 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i18 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i9);
    i4 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i18 = 17; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i18 = 19;
  }
  if ((i18 | 0) == 17) i18 = 19;
  if ((i18 | 0) == 19) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  if (!i1) i18 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i9);
    i2 = HEAP32[i16 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 26; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i18 = 28;
   }
  }
  if ((i18 | 0) == 26) i18 = 28;
  if ((i18 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i1 = __ZN6Avatar8GetAssetEv(i1) | 0;
 } while (0);
 __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb(i19, i1, i14, 1);
 HEAP32[i20 >> 2] = 0;
 i10 = i20 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i12 = i20 + 16 | 0;
 i13 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i7 = i16;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 i11 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i18 = 35; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i9);
   i2 = HEAP32[i16 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 35; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i18 = 37;
  }
 }
 if ((i18 | 0) == 35) i18 = 37;
 if ((i18 | 0) == 37) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i7 = i19 + 228 | 0;
 i6 = __ZN25RuntimeAnimatorController21BuildCustomControllerERK13AnimationClipPKN7mecanim9animation18ControllerConstantERNS3_6memory9AllocatorE(i8, mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0, i7) | 0;
 i4 = i19 + 260 | 0;
 HEAP32[i4 >> 2] = i6;
 i5 = i19 + 264 | 0;
 HEAP32[i5 >> 2] = __ZN7mecanim9animation22CreateControllerMemoryEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(i6, i7) | 0;
 i7 = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE(HEAP32[i4 >> 2] | 0, i20, i7) | 0;
 i6 = i19 + 268 | 0;
 HEAP32[i6 >> 2] = i7;
 i11 = i19 + 240 | 0;
 __ZN8Animator20SetupBindingsDataSetEPKN7mecanim9animation18ControllerConstantEPN11UnityEngine9Animation20AnimationSetBindingsERNS_15BindingsDataSetERNS_13AvatarDataSetE(i19, HEAP32[i4 >> 2] | 0, i7, i11, i14);
 i7 = HEAP32[i8 + 216 >> 2] | 0;
 if (!i7) i18 = 40; else if (!(HEAP32[i8 + 220 >> 2] | 0)) i18 = 40; else {
  i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0;
  i22 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i10 = i19 + 204 | 0;
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0;
  i2 = HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0) + 8 >> 2] | 0;
  i24 = gb + 64016 | 0;
  i8 = HEAP32[i24 + 4 >> 2] | 0;
  i23 = i9;
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i23 + 4 >> 2] = i8;
  HEAP32[i17 >> 2] = gb + 175924 + 8;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i9);
  i23 = i16;
  i8 = HEAP32[i23 + 4 >> 2] | 0;
  i24 = i17 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i24 + 4 >> 2] = i8;
  i24 = i7 + 1060 | 0;
  i8 = HEAP32[i24 >> 2] | 0;
  i23 = i24;
  i8 = __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipERNS_6memory9AllocatorE((i8 | 0) == 0 ? 0 : i8 + i23 | 0, i17) | 0;
  i9 = HEAP32[i24 >> 2] | 0;
  i9 = __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE((i9 | 0) == 0 ? 0 : i9 + i23 | 0, i17) | 0;
  HEAPF32[i16 >> 2] = f15;
  i24 = HEAP32[i24 >> 2] | 0;
  __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i24 | 0) == 0 ? 0 : i24 + i23 | 0, i16, i8, i9);
  __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(i1, 0);
  __ZN7mecanim9animation14ValuesFromClipERKNS_10ValueArrayERKNS0_18ClipMuscleConstantERKNS0_10ClipOutputERKNS0_12ClipBindingsEiRS1_RNS_14ValueArrayMaskEb(i22, i7, i9, i2 + 8 | 0, HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0) + 32 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i1, 0);
  i1 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i24 = i1 + i2 + 40 | 0;
   if (HEAP32[(HEAP32[i24 >> 2] | 0) + i24 >> 2] | 0) {
    __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKfRNS_5human9HumanPoseE(i7, HEAP32[i9 >> 2] | 0, HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0);
    i22 = HEAP32[i10 >> 2] | 0;
    __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(HEAP32[i22 + 24 >> 2] | 0, HEAP32[i22 + 20 >> 2] | 0, 0);
    i22 = i19 + 200 | 0;
    i23 = i19 + 208 | 0;
    i24 = i19 + 212 | 0;
    __ZN7mecanim9animation22EvaluateAvatarRetargetEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb(HEAP32[i14 >> 2] | 0, HEAP32[i22 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i24 >> 2] | 0, 1);
    __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(HEAP32[i14 >> 2] | 0, HEAP32[i22 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i24 >> 2] | 0);
   }
  }
  i23 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
  i24 = HEAP32[i23 >> 2] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  __ZN7mecanim14ValueArrayCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi(i3, HEAP32[HEAP32[i10 >> 2] >> 2] | 0, (i24 | 0) == 0 ? 0 : i23 + i24 | 0, (i1 | 0) == 0 ? 0 : i2 + i1 | 0, HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
  __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(HEAP32[i11 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0);
  __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(HEAP32[i11 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0);
  i1 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i24 = i1 + i2 + 40 | 0;
   if (HEAP32[(HEAP32[i24 >> 2] | 0) + i24 >> 2] | 0) __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb(HEAP32[i19 + 216 >> 2] | 0, HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, 1);
  }
  __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform(HEAP32[i11 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0, 0);
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i19 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE(i1, HEAP32[i11 >> 2] | 0, HEAP32[i19 + 216 >> 2] | 0);
  __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE(i8, i17);
  __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE(i9, i17);
  i1 = 1;
 }
 if ((i18 | 0) == 40) {
  i1 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 0; else {
   i24 = i1 + i2 + 40 | 0;
   if (!(HEAP32[(HEAP32[i24 >> 2] | 0) + i24 >> 2] | 0)) i1 = 0; else {
    __ZN7mecanim5human9HumanPoseC2Ev(i16);
    i18 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
    i22 = HEAP32[i18 >> 2] | 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    HEAP32[i9 + 16 >> 2] = 0;
    HEAP32[i9 + 20 >> 2] = 0;
    HEAP32[i9 + 24 >> 2] = 1065353216;
    HEAP32[i9 + 28 >> 2] = 1065353216;
    HEAP32[i9 + 32 >> 2] = 1065353216;
    HEAP32[i9 + 36 >> 2] = 1065353216;
    i24 = i19 + 204 | 0;
    i1 = i19 + 212 | 0;
    i23 = HEAP32[i1 >> 2] | 0;
    __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_((i22 | 0) == 0 ? 0 : i18 + i22 | 0, i16, 0, i9, HEAP32[(HEAP32[i24 >> 2] | 0) + 24 >> 2] | 0, HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0);
    __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(HEAP32[i14 >> 2] | 0, HEAP32[i19 + 200 >> 2] | 0, HEAP32[i24 >> 2] | 0, HEAP32[i19 + 208 >> 2] | 0, HEAP32[i1 >> 2] | 0);
    i1 = i19 + 216 | 0;
    __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb(HEAP32[i1 >> 2] | 0, HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0, 1);
    i24 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i19 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
    __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE(i24, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0);
    i1 = 0;
   }
  }
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i13);
  HEAP32[i20 >> 2] = 0;
 }
 i24 = i1;
 STACKTOP = i21;
 return i24 | 0;
}

function __ZN5physx2GuL14testEdgeNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RNS7_5Vec3VENS0_13FeatureStatusERSH_(i1, i3, i63, i64, i73, i74, i59, i76, i60, i71) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 i59 = i59 | 0;
 i76 = i76 | 0;
 i60 = i60 | 0;
 i71 = i71 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i61 = 0, i62 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i75 = 0, i77 = 0, i78 = 0, f79 = f0, i80 = 0, i81 = 0, i82 = 0, f83 = f0;
 i78 = STACKTOP;
 STACKTOP = STACKTOP + 6400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i77 = i78 + 6380 | 0;
 i67 = i78 + 176 | 0;
 i65 = i78 + 160 | 0;
 i68 = i78 + 144 | 0;
 i66 = i78 + 128 | 0;
 i19 = i78 + 112 | 0;
 i13 = i78 + 96 | 0;
 i20 = i78 + 80 | 0;
 i17 = i78 + 64 | 0;
 i11 = i78 + 48 | 0;
 i18 = i78 + 32 | 0;
 i61 = i78 + 3304 | 0;
 i62 = i78 + 228 | 0;
 i69 = i78 + 16 | 0;
 i70 = i78;
 i22 = i78 + 216 | 0;
 i21 = i78 + 204 | 0;
 i72 = i78 + 192 | 0;
 f2 = Math_fround(HEAPF32[i76 >> 2]);
 i75 = i76 + 4 | 0;
 HEAP32[i77 >> 2] = HEAP32[i75 >> 2];
 HEAP32[i77 + 4 >> 2] = HEAP32[i75 + 4 >> 2];
 HEAP32[i77 + 8 >> 2] = HEAP32[i75 + 8 >> 2];
 f40 = Math_fround(HEAPF32[i1 >> 2]);
 f41 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f42 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f47 = Math_fround(HEAPF32[i3 >> 2]);
 f44 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f43 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i14 = i74 + 48 | 0;
 f29 = Math_fround(HEAPF32[i14 >> 2]);
 i15 = i74 + 52 | 0;
 f30 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i74 + 56 | 0;
 f31 = Math_fround(HEAPF32[i16 >> 2]);
 f46 = Math_fround(f47 * Math_fround(HEAPF32[i74 >> 2]));
 i32 = i74 + 16 | 0;
 f46 = Math_fround(f46 + Math_fround(f44 * Math_fround(HEAPF32[i32 >> 2])));
 i33 = i74 + 32 | 0;
 f46 = Math_fround(f46 + Math_fround(f43 * Math_fround(HEAPF32[i33 >> 2])));
 i34 = i74 + 4 | 0;
 f45 = Math_fround(f47 * Math_fround(HEAPF32[i34 >> 2]));
 i35 = i74 + 20 | 0;
 f45 = Math_fround(f45 + Math_fround(f44 * Math_fround(HEAPF32[i35 >> 2])));
 i36 = i74 + 36 | 0;
 f45 = Math_fround(f45 + Math_fround(f43 * Math_fround(HEAPF32[i36 >> 2])));
 i37 = i74 + 8 | 0;
 f47 = Math_fround(f47 * Math_fround(HEAPF32[i37 >> 2]));
 i38 = i74 + 24 | 0;
 f44 = Math_fround(f47 + Math_fround(f44 * Math_fround(HEAPF32[i38 >> 2])));
 i39 = i74 + 40 | 0;
 f40 = Math_fround(Math_fround(f29 + f46) - f40);
 f41 = Math_fround(Math_fround(f30 + f45) - f41);
 f42 = Math_fround(Math_fround(f31 + Math_fround(f44 + Math_fround(f43 * Math_fround(HEAPF32[i39 >> 2])))) - f42);
 f43 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f44 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f45 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f46 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f47 = Math_fround(-f44);
 f48 = Math_fround(-f45);
 f49 = Math_fround(-f46);
 f50 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f51 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f52 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f53 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f54 = Math_fround(-f51);
 f55 = Math_fround(-f52);
 f56 = Math_fround(-f53);
 HEAPF32[i19 >> 2] = f40;
 i58 = i19 + 4 | 0;
 HEAPF32[i58 >> 2] = f41;
 i57 = i19 + 8 | 0;
 HEAPF32[i57 >> 2] = f42;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 mftCall_viii(HEAP32[(HEAP32[i63 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i63 | 0, i19 | 0);
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 f9 = Math_fround(HEAPF32[i58 >> 2]);
 f6 = Math_fround(-f6);
 f9 = Math_fround(-f9);
 f79 = Math_fround(-Math_fround(HEAPF32[i57 >> 2]));
 f10 = Math_fround(Math_fround(HEAPF32[i73 >> 2]) * f6);
 i57 = i73 + 16 | 0;
 f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i57 >> 2]) * f9));
 i58 = i73 + 32 | 0;
 f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f79));
 i23 = i73 + 4 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * f6);
 i24 = i73 + 20 | 0;
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f9));
 i25 = i73 + 36 | 0;
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f79));
 i26 = i73 + 8 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f6);
 i27 = i73 + 24 | 0;
 f9 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f9));
 i28 = i73 + 40 | 0;
 f79 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f79));
 HEAPF32[i20 >> 2] = f10;
 HEAPF32[i20 + 4 >> 2] = f8;
 HEAPF32[i20 + 8 >> 2] = f79;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 mftCall_viii(HEAP32[(HEAP32[i64 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i64 | 0, i20 | 0);
 f79 = Math_fround(HEAPF32[i73 + 48 >> 2]);
 f8 = Math_fround(HEAPF32[i73 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i73 + 56 >> 2]);
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f5 = Math_fround(f9 * Math_fround(HEAPF32[i73 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i57 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i58 >> 2])));
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i24 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f7 * Math_fround(HEAPF32[i25 >> 2])));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i26 >> 2]));
 f6 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i27 >> 2])));
 f4 = Math_fround(f8 + f4);
 f7 = Math_fround(f10 + Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i28 >> 2]))));
 HEAPF32[i11 >> 2] = Math_fround(f79 + f5);
 HEAPF32[i11 + 4 >> 2] = f4;
 HEAPF32[i11 + 8 >> 2] = f7;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f5 = Math_fround(HEAPF32[i16 >> 2]);
 f79 = Math_fround(HEAPF32[i17 >> 2]);
 f6 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f8 = Math_fround(f79 * Math_fround(HEAPF32[i74 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i32 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i33 >> 2])));
 f9 = Math_fround(f79 * Math_fround(HEAPF32[i34 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i35 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i36 >> 2])));
 f79 = Math_fround(f79 * Math_fround(HEAPF32[i37 >> 2]));
 f6 = Math_fround(f79 + Math_fround(f6 * Math_fround(HEAPF32[i38 >> 2])));
 f9 = Math_fround(f4 + f9);
 f10 = Math_fround(f5 + Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i39 >> 2]))));
 HEAPF32[i18 >> 2] = Math_fround(f7 + f8);
 HEAPF32[i18 + 4 >> 2] = f9;
 HEAPF32[i18 + 8 >> 2] = f10;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i61 >> 2] = 0;
 HEAP32[i62 >> 2] = 0;
 __ZN5physx2Gu16buildPartialHullERKNS0_13PolygonalDataEPNS0_12SupportLocalERNS0_14SeparatingAxesERKNS_6shdfnd3aos5Vec3VESC_(i1, i63, i61, i18, i19);
 __ZN5physx2Gu16buildPartialHullERKNS0_13PolygonalDataEPNS0_12SupportLocalERNS0_14SeparatingAxesERKNS_6shdfnd3aos5Vec3VESC_(i3, i64, i62, i11, i20);
 i20 = HEAP32[i61 >> 2] | 0;
 i11 = HEAP32[i62 >> 2] | 0;
 L1 : do if (i20) {
  i12 = i69 + 4 | 0;
  i13 = i69 + 8 | 0;
  i14 = i69 + 12 | 0;
  i15 = i70 + 4 | 0;
  i16 = i70 + 8 | 0;
  i17 = i70 + 12 | 0;
  i18 = i68 + 4 | 0;
  i19 = i66 + 4 | 0;
  if (!i11) {
   i1 = 0;
   while (1) {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i20 >>> 0) break L1;
   }
  } else i3 = 0;
  L6 : while (1) {
   f10 = Math_fround(HEAPF32[i61 + 4 + (i3 * 12 | 0) >> 2]);
   f8 = Math_fround(HEAPF32[i61 + 4 + (i3 * 12 | 0) + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i61 + 4 + (i3 * 12 | 0) + 8 >> 2]);
   i1 = 0;
   do {
    f79 = Math_fround(HEAPF32[i62 + 4 + (i1 * 12 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i62 + 4 + (i1 * 12 | 0) + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i62 + 4 + (i1 * 12 | 0) + 8 >> 2]);
    f6 = Math_fround(f79 * Math_fround(HEAPF32[i74 >> 2]));
    f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i32 >> 2])));
    f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i33 >> 2])));
    f7 = Math_fround(f79 * Math_fround(HEAPF32[i34 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i35 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i36 >> 2])));
    f79 = Math_fround(f79 * Math_fround(HEAPF32[i37 >> 2]));
    f4 = Math_fround(f79 + Math_fround(f4 * Math_fround(HEAPF32[i38 >> 2])));
    f5 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i39 >> 2])));
    f4 = Math_fround(Math_fround(f8 * f5) - Math_fround(f9 * f7));
    f5 = Math_fround(Math_fround(f9 * f6) - Math_fround(f10 * f5));
    f6 = Math_fround(Math_fround(f10 * f7) - Math_fround(f8 * f6));
    f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)));
    if (!(f7 < Math_fround(1.1920929e-07))) {
     f79 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
     f4 = Math_fround(f4 * f79);
     f7 = Math_fround(f5 * f79);
     f6 = Math_fround(f6 * f79);
     HEAPF32[i69 >> 2] = f4;
     HEAPF32[i12 >> 2] = f7;
     HEAPF32[i13 >> 2] = f6;
     HEAPF32[i14 >> 2] = Math_fround(0.0);
     f79 = Math_fround(f4 * Math_fround(HEAPF32[i73 >> 2]));
     f79 = Math_fround(f79 + Math_fround(f7 * Math_fround(HEAPF32[i57 >> 2])));
     f79 = Math_fround(f79 + Math_fround(f6 * Math_fround(HEAPF32[i58 >> 2])));
     f83 = Math_fround(f4 * Math_fround(HEAPF32[i23 >> 2]));
     f83 = Math_fround(f83 + Math_fround(f7 * Math_fround(HEAPF32[i24 >> 2])));
     f83 = Math_fround(f83 + Math_fround(f6 * Math_fround(HEAPF32[i25 >> 2])));
     f5 = Math_fround(f4 * Math_fround(HEAPF32[i26 >> 2]));
     f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i27 >> 2])));
     f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i28 >> 2])));
     HEAPF32[i70 >> 2] = f79;
     HEAPF32[i15 >> 2] = f83;
     HEAPF32[i16 >> 2] = f5;
     HEAPF32[i17 >> 2] = Math_fround(0.0);
     i80 = f79 > Math_fround(0.0);
     i81 = f83 > Math_fround(0.0);
     i82 = f5 > Math_fround(0.0);
     f5 = Math_fround(Math_fround(Math_fround(f79 * (i80 ? f44 : f47)) + Math_fround(f83 * (i81 ? f45 : f48))) + Math_fround(f5 * (i82 ? f46 : f49)));
     f5 = f5 > f43 ? f5 : f43;
     f83 = Math_fround(Math_fround(Math_fround(f40 * f4) + Math_fround(f41 * f7)) + Math_fround(f42 * f6));
     f79 = Math_fround(f83 - f5);
     f5 = Math_fround(f83 + f5);
     i82 = f4 > Math_fround(0.0);
     i81 = f7 > Math_fround(0.0);
     i80 = f6 > Math_fround(0.0);
     f6 = Math_fround(Math_fround(Math_fround(f4 * (i82 ? f51 : f54)) + Math_fround(f7 * (i81 ? f52 : f55))) + Math_fround(f6 * (i80 ? f53 : f56)));
     f6 = f6 > f50 ? f6 : f50;
     f7 = Math_fround(-f6);
     if (!(Math_fround((f6 > f5 ? f5 : f6) - (f79 < f7 ? f7 : f79)) > f2)) {
      mftCall_viiii(HEAP32[(HEAP32[i63 >> 2] | 0) + 12 >> 2] | 0, i63 | 0, i69 | 0, i67 | 0, i65 | 0);
      f4 = Math_fround(HEAPF32[i69 >> 2]);
      f83 = Math_fround(HEAPF32[i12 >> 2]);
      f83 = Math_fround(Math_fround(Math_fround(f29 * f4) + Math_fround(f30 * f83)) + Math_fround(f31 * Math_fround(HEAPF32[i13 >> 2])));
      mftCall_viiii(HEAP32[(HEAP32[i64 >> 2] | 0) + 12 >> 2] | 0, i64 | 0, i70 | 0, i68 | 0, i66 | 0);
      f4 = Math_fround(f83 + Math_fround(HEAPF32[i68 >> 2]));
      HEAPF32[i68 >> 2] = f4;
      HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i18 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i18 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      f83 = Math_fround(f83 + Math_fround(HEAPF32[i66 >> 2]));
      HEAPF32[i66 >> 2] = f83;
      HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
      f5 = Math_fround(HEAPF32[i65 >> 2]);
      f79 = Math_fround(HEAPF32[i59 >> 2]);
      i82 = f4 > Math_fround(f5 + f79);
      if (i82 | Math_fround(HEAPF32[i67 >> 2]) > Math_fround(f79 + f83)) {
       i1 = 0;
       break L6;
      }
      f4 = Math_fround(f5 - f4);
      if (f2 > f4) {
       HEAP32[i77 >> 2] = HEAP32[i72 >> 2];
       HEAP32[i77 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
       HEAP32[i77 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
       HEAP32[i60 >> 2] = HEAP32[i69 >> 2];
       HEAP32[i60 + 4 >> 2] = HEAP32[i69 + 4 >> 2];
       HEAP32[i60 + 8 >> 2] = HEAP32[i69 + 8 >> 2];
       HEAP32[i60 + 12 >> 2] = HEAP32[i69 + 12 >> 2];
       HEAP32[i71 >> 2] = 2;
       f2 = f4;
      }
     }
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i11 >>> 0);
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i20 >>> 0) break L1;
  }
  STACKTOP = i78;
  return i1 | 0;
 } while (0);
 HEAPF32[i76 >> 2] = f2;
 HEAP32[i75 >> 2] = HEAP32[i77 >> 2];
 HEAP32[i75 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
 HEAP32[i75 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
 i82 = 1;
 STACKTOP = i78;
 return i82 | 0;
}

function __Z20sweepBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i4, i3, i22, f19, i21, i6, f2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i22 = i22 | 0;
 f19 = Math_fround(f19);
 i21 = i21 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var f5 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, i52 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i23 + 400 | 0;
 i35 = i23 + 416 | 0;
 i17 = i23 + 384 | 0;
 i25 = i23 + 368 | 0;
 i26 = i23 + 208 | 0;
 i27 = i23 + 64 | 0;
 i24 = i23 + 48 | 0;
 i16 = i23 + 32 | 0;
 i18 = i23 + 16 | 0;
 i20 = i23;
 f43 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = i1 + 4 | 0;
 i36 = HEAP32[i1 >> 2] | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i52 = HEAP32[i3 + 48 >> 2] | 0;
 i51 = HEAP32[i3 + 52 >> 2] | 0;
 i50 = HEAP32[i3 + 56 >> 2] | 0;
 f32 = Math_fround(HEAPF32[i22 >> 2]);
 i8 = i22 + 4 | 0;
 f30 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i22 + 8 | 0;
 f31 = Math_fround(HEAPF32[i9 >> 2]);
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i34, i3);
 f10 = Math_fround(HEAPF32[i34 >> 2]);
 f11 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i34 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i34 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f41 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f47 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f49 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i3 = i4 + 16 | 0;
 f44 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f29 = Math_fround(-f10);
 f46 = Math_fround(-f11);
 f48 = Math_fround(-f12);
 f44 = Math_fround(f44 - f14);
 f28 = Math_fround(f28 - f15);
 f40 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f7);
 f5 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
 f38 = Math_fround(Math_fround(Math_fround(f44 * f29) + Math_fround(f28 * f46)) + Math_fround(f40 * f48));
 f37 = Math_fround(Math_fround(Math_fround(f38 * f29) + Math_fround(Math_fround(f5 * f44) + Math_fround(f13 * Math_fround(Math_fround(f40 * f46) - Math_fround(f28 * f48))))) * Math_fround(2.0));
 f39 = Math_fround(Math_fround(Math_fround(f38 * f46) + Math_fround(Math_fround(f5 * f28) + Math_fround(f13 * Math_fround(Math_fround(f44 * f48) - Math_fround(f40 * f29))))) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f40) + Math_fround(f13 * Math_fround(Math_fround(f28 * f29) - Math_fround(f44 * f46)))) + Math_fround(f38 * f48)) * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f13 * f49) - Math_fround(Math_fround(Math_fround(f33 * f29) + Math_fround(f41 * f46)) + Math_fround(f47 * f48)));
 f28 = Math_fround(Math_fround(Math_fround(f47 * f46) - Math_fround(f41 * f48)) + Math_fround(Math_fround(f13 * f33) + Math_fround(f49 * f29)));
 f40 = Math_fround(Math_fround(Math_fround(f33 * f48) - Math_fround(f47 * f29)) + Math_fround(Math_fround(f13 * f41) + Math_fround(f49 * f46)));
 f48 = Math_fround(Math_fround(Math_fround(f41 * f29) - Math_fround(f33 * f46)) + Math_fround(Math_fround(f13 * f47) + Math_fround(f49 * f48)));
 f49 = Math_fround(f28 + f28);
 f47 = Math_fround(f40 + f40);
 f46 = Math_fround(f48 + f48);
 f33 = Math_fround(f40 * f47);
 f29 = Math_fround(f48 * f46);
 f40 = Math_fround(f40 * f49);
 f41 = Math_fround(f48 * f49);
 f45 = Math_fround(f44 * f49);
 f48 = Math_fround(f48 * f47);
 f47 = Math_fround(f44 * f47);
 f46 = Math_fround(f44 * f46);
 f49 = Math_fround(Math_fround(1.0) - Math_fround(f28 * f49));
 f28 = Math_fround(Math_fround(Math_fround(1.0) - f33) - f29);
 f44 = Math_fround(f40 + f46);
 f42 = Math_fround(f41 - f47);
 f46 = Math_fround(f40 - f46);
 f29 = Math_fround(f49 - f29);
 f40 = Math_fround(f48 + f45);
 f47 = Math_fround(f41 + f47);
 f45 = Math_fround(f48 - f45);
 f33 = Math_fround(f49 - f33);
 i3 = i26 + 64 | 0;
 HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 HEAP32[i26 + 80 >> 2] = 3;
 HEAPF32[i26 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i26 + 144 >> 2] = i52;
 HEAP32[i26 + 148 >> 2] = i51;
 HEAP32[i26 + 152 >> 2] = i50;
 HEAPF32[i26 + 156 >> 2] = Math_fround(0.0);
 f49 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = f49 <= f48 ? f49 : f48;
 f41 = f48 <= f41 ? f48 : f41;
 HEAPF32[i26 + 16 >> 2] = Math_fround(f41 * Math_fround(.150000006));
 HEAPF32[i26 + 32 >> 2] = Math_fround(f41 * Math_fround(.0500000007));
 f41 = Math_fround(f43 * Math_fround(0.0));
 f28 = Math_fround(Math_fround(f41 * f47) + Math_fround(Math_fround(f41 * f46) + Math_fround(f43 * f28)));
 f29 = Math_fround(Math_fround(f41 * f45) + Math_fround(Math_fround(f43 * f44) + Math_fround(f41 * f29)));
 f33 = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f41 * f40)) + Math_fround(f41 * f33));
 i3 = i27 + 64 | 0;
 HEAPF32[i27 >> 2] = f37;
 HEAPF32[i27 + 4 >> 2] = f39;
 HEAPF32[i27 + 8 >> 2] = f38;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 80 >> 2] = 4;
 HEAPF32[i27 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 128 >> 2] = i36;
 i4 = i27 + 132 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 f41 = Math_fround(f39 + f29);
 f40 = Math_fround(f38 + f33);
 HEAPF32[i27 + 96 >> 2] = Math_fround(f37 + f28);
 HEAPF32[i27 + 100 >> 2] = f41;
 HEAPF32[i27 + 104 >> 2] = f40;
 HEAPF32[i27 + 108 >> 2] = Math_fround(0.0);
 f29 = Math_fround(f39 - f29);
 f33 = Math_fround(f38 - f33);
 HEAPF32[i27 + 112 >> 2] = Math_fround(f37 - f28);
 HEAPF32[i27 + 116 >> 2] = f29;
 HEAPF32[i27 + 120 >> 2] = f33;
 HEAPF32[i27 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 16 >> 2] = i36;
 i4 = i27 + 20 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i27 + 32 >> 2] = i36;
 i4 = i27 + 36 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i34 >> 2] = -1;
 HEAP32[i34 + 4 >> 2] = -1;
 HEAP32[i34 + 8 >> 2] = -1;
 HEAP32[i34 + 12 >> 2] = -1;
 HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 f32 = Math_fround(f32 * f19);
 f30 = Math_fround(f30 * f19);
 f31 = Math_fround(f31 * f19);
 f33 = Math_fround(Math_fround(Math_fround(f32 * f10) + Math_fround(f30 * f11)) + Math_fround(f31 * f12));
 f29 = Math_fround(Math_fround(Math_fround(f11 * f33) + Math_fround(Math_fround(f30 * f5) - Math_fround(f13 * Math_fround(Math_fround(f32 * f12) - Math_fround(f31 * f10))))) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(Math_fround(f12 * f33) + Math_fround(Math_fround(f31 * f5) - Math_fround(f13 * Math_fround(Math_fround(f30 * f10) - Math_fround(f32 * f11))))) * Math_fround(2.0));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f10 * f33) + Math_fround(Math_fround(f32 * f5) - Math_fround(f13 * Math_fround(Math_fround(f31 * f11) - Math_fround(f30 * f12))))) * Math_fround(2.0));
 HEAPF32[i24 + 4 >> 2] = f29;
 HEAPF32[i24 + 8 >> 2] = f28;
 HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
 i3 = (HEAP16[i6 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i27, i26, i17, i25, i24, i16, i20, i18, Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f2), i3) | 0)) {
  i52 = 0;
  STACKTOP = i23;
  return i52 | 0;
 }
 i1 = i21 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 f49 = Math_fround(HEAPF32[i17 >> 2]);
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 if (!(f49 >= f2)) {
  HEAP16[i1 >> 1] = 7;
  f41 = Math_fround(HEAPF32[i18 >> 2]);
  f43 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f48 = Math_fround(Math_fround(Math_fround(f10 * f41) + Math_fround(f11 * f43)) + Math_fround(f12 * f42));
  f46 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f10 * f48) + Math_fround(Math_fround(f5 * f41) + Math_fround(f13 * Math_fround(Math_fround(f11 * f42) - Math_fround(f12 * f43))))) * Math_fround(2.0)));
  f47 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f11 * f48) + Math_fround(Math_fround(f5 * f43) + Math_fround(f13 * Math_fround(Math_fround(f12 * f41) - Math_fround(f10 * f42))))) * Math_fround(2.0)));
  f48 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f42) + Math_fround(f13 * Math_fround(Math_fround(f10 * f43) - Math_fround(f11 * f41)))) + Math_fround(f12 * f48)) * Math_fround(2.0)));
  f41 = Math_fround(HEAPF32[i20 >> 2]);
  f43 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f40 = Math_fround(Math_fround(Math_fround(f10 * f41) + Math_fround(f11 * f43)) + Math_fround(f12 * f42));
  f49 = Math_fround(f2 * f19);
  f44 = Math_fround(-Math_fround(Math_fround(Math_fround(f11 * f40) + Math_fround(Math_fround(f5 * f43) + Math_fround(f13 * Math_fround(Math_fround(f12 * f41) - Math_fround(f10 * f42))))) * Math_fround(2.0)));
  f45 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f5 * f42) + Math_fround(f13 * Math_fround(Math_fround(f10 * f43) - Math_fround(f11 * f41)))) + Math_fround(f12 * f40)) * Math_fround(2.0)));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f10 * f40) + Math_fround(Math_fround(f5 * f41) + Math_fround(f13 * Math_fround(Math_fround(f11 * f42) - Math_fround(f12 * f43))))) * Math_fround(2.0)));
  HEAPF32[i21 + 32 >> 2] = f44;
  HEAPF32[i21 + 36 >> 2] = f45;
  HEAPF32[i21 + 16 >> 2] = f46;
  HEAPF32[i21 + 20 >> 2] = f47;
  HEAPF32[i21 + 24 >> 2] = f48;
  HEAPF32[i21 + 40 >> 2] = f49;
  i52 = 1;
  STACKTOP = i23;
  return i52 | 0;
 }
 if (i3) {
  HEAP16[i1 >> 1] = 7;
  f42 = Math_fround(HEAPF32[i18 >> 2]);
  f44 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f43 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f10 * f42) + Math_fround(f11 * f44)) + Math_fround(f12 * f43));
  f47 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f10 * f49) + Math_fround(Math_fround(f5 * f42) + Math_fround(f13 * Math_fround(Math_fround(f11 * f43) - Math_fround(f12 * f44))))) * Math_fround(2.0)));
  f48 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f11 * f49) + Math_fround(Math_fround(f5 * f44) + Math_fround(f13 * Math_fround(Math_fround(f12 * f42) - Math_fround(f10 * f43))))) * Math_fround(2.0)));
  f49 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f43) + Math_fround(f13 * Math_fround(Math_fround(f10 * f44) - Math_fround(f11 * f42)))) + Math_fround(f12 * f49)) * Math_fround(2.0)));
  f42 = Math_fround(HEAPF32[i20 >> 2]);
  f44 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f43 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f41 = Math_fround(Math_fround(Math_fround(f10 * f42) + Math_fround(f11 * f44)) + Math_fround(f12 * f43));
  f45 = Math_fround(-Math_fround(Math_fround(Math_fround(f11 * f41) + Math_fround(Math_fround(f5 * f44) + Math_fround(f13 * Math_fround(Math_fround(f12 * f42) - Math_fround(f10 * f43))))) * Math_fround(2.0)));
  f46 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f5 * f43) + Math_fround(f13 * Math_fround(Math_fround(f10 * f44) - Math_fround(f11 * f42)))) + Math_fround(f12 * f41)) * Math_fround(2.0)));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f10 * f41) + Math_fround(Math_fround(f5 * f42) + Math_fround(f13 * Math_fround(Math_fround(f11 * f43) - Math_fround(f12 * f44))))) * Math_fround(2.0)));
  HEAPF32[i21 + 32 >> 2] = f45;
  HEAPF32[i21 + 36 >> 2] = f46;
  HEAPF32[i21 + 16 >> 2] = f47;
  HEAPF32[i21 + 20 >> 2] = f48;
  HEAPF32[i21 + 24 >> 2] = f49;
  HEAPF32[i21 + 40 >> 2] = f2;
  i52 = 1;
  STACKTOP = i23;
  return i52 | 0;
 } else {
  HEAPF32[i21 + 40 >> 2] = Math_fround(0.0);
  f47 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  f48 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
  f49 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
  HEAPF32[i21 + 28 >> 2] = f47;
  HEAPF32[i21 + 32 >> 2] = f48;
  HEAPF32[i21 + 36 >> 2] = f49;
  i52 = 1;
  STACKTOP = i23;
  return i52 | 0;
 }
 return 0;
}

function __ZN5physx17collideWithConvexEPNS_7PxPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i44, i42, i40, i1, f43) {
 i44 = i44 | 0;
 i42 = i42 | 0;
 i40 = i40 | 0;
 i1 = i1 | 0;
 f43 = Math_fround(f43);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, i41 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, i67 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 1008 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i46 + 688 | 0;
 i39 = i46 + 512 | 0;
 i41 = i46;
 i16 = HEAP32[i1 + 36 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f3 = Math_fround(f12 + f12);
 f2 = Math_fround(f5 + f5);
 f11 = Math_fround(f34 + f34);
 f4 = Math_fround(f5 * f2);
 f33 = Math_fround(f34 * f11);
 f5 = Math_fround(f3 * f5);
 f36 = Math_fround(f3 * f34);
 f6 = Math_fround(f3 * f32);
 f34 = Math_fround(f2 * f34);
 f2 = Math_fround(f2 * f32);
 f32 = Math_fround(f11 * f32);
 f11 = Math_fround(Math_fround(Math_fround(1.0) - f4) - f33);
 f10 = Math_fround(f5 + f32);
 f9 = Math_fround(f36 - f2);
 f32 = Math_fround(f5 - f32);
 f3 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f3));
 f33 = Math_fround(f3 - f33);
 f12 = Math_fround(f34 + f6);
 f2 = Math_fround(f36 + f2);
 f6 = Math_fround(f34 - f6);
 f4 = Math_fround(f3 - f4);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f34 = Math_fround(f3 * f11);
 f36 = Math_fround(f3 * f32);
 f3 = Math_fround(f3 * f2);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f35 = Math_fround(f10 * f5);
 f37 = Math_fround(f33 * f5);
 f5 = Math_fround(f6 * f5);
 f15 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(f9 * f15);
 f14 = Math_fround(f12 * f15);
 f15 = Math_fround(f4 * f15);
 f7 = Math_fround(Math_fround(Math_fround(f11 * f34) + Math_fround(f10 * f35)) + Math_fround(f9 * f13));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f36) + Math_fround(f10 * f37)) + Math_fround(f9 * f14));
 f9 = Math_fround(Math_fround(Math_fround(f11 * f3) + Math_fround(f10 * f5)) + Math_fround(f9 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f32 * f34) + Math_fround(f33 * f35)) + Math_fround(f12 * f13));
 f11 = Math_fround(Math_fround(Math_fround(f32 * f36) + Math_fround(f33 * f37)) + Math_fround(f12 * f14));
 f12 = Math_fround(Math_fround(Math_fround(f32 * f3) + Math_fround(f33 * f5)) + Math_fround(f12 * f15));
 f13 = Math_fround(Math_fround(Math_fround(f2 * f34) + Math_fround(f6 * f35)) + Math_fround(f4 * f13));
 f14 = Math_fround(Math_fround(Math_fround(f2 * f36) + Math_fround(f6 * f37)) + Math_fround(f4 * f14));
 f15 = Math_fround(Math_fround(Math_fround(f2 * f3) + Math_fround(f6 * f5)) + Math_fround(f4 * f15));
 f4 = Math_fround(Math_fround(f11 * f15) - Math_fround(f12 * f14));
 f5 = Math_fround(f12 * f13);
 f6 = Math_fround(f15 * f10);
 f3 = Math_fround(Math_fround(f14 * f10) - Math_fround(f11 * f13));
 f2 = Math_fround(Math_fround(f9 * f3) + Math_fround(Math_fround(f7 * f4) + Math_fround(f8 * Math_fround(f5 - f6))));
 if (f2 != Math_fround(0.0)) {
  f31 = Math_fround(Math_fround(1.0) / f2);
  f36 = Math_fround(Math_fround(Math_fround(f11 * f7) - Math_fround(f8 * f10)) * f31);
  f37 = Math_fround(-Math_fround(Math_fround(Math_fround(f14 * f7) - Math_fround(f8 * f13)) * f31));
  f35 = Math_fround(f3 * f31);
  f32 = Math_fround(f4 * f31);
  f33 = Math_fround(-Math_fround(Math_fround(Math_fround(f15 * f8) - Math_fround(f14 * f9)) * f31));
  f34 = Math_fround(Math_fround(Math_fround(f12 * f8) - Math_fround(f11 * f9)) * f31);
  f29 = Math_fround(-Math_fround(Math_fround(f6 - f5) * f31));
  f30 = Math_fround(Math_fround(Math_fround(f15 * f7) - Math_fround(f9 * f13)) * f31);
  f31 = Math_fround(-Math_fround(Math_fround(Math_fround(f12 * f7) - Math_fround(f9 * f10)) * f31));
 } else {
  f36 = Math_fround(1.0);
  f37 = Math_fround(0.0);
  f35 = Math_fround(0.0);
  f32 = Math_fround(1.0);
  f33 = Math_fround(0.0);
  f34 = Math_fround(0.0);
  f29 = Math_fround(0.0);
  f30 = Math_fround(1.0);
  f31 = Math_fround(0.0);
 }
 f47 = Math_fround(HEAPF32[i16 >> 2]);
 f50 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f52 = Math_fround(f47 + f50);
 f2 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f51 = Math_fround(f2 + f49);
 f3 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f52 = Math_fround(f52 * Math_fround(.5));
 f51 = Math_fround(f51 * Math_fround(.5));
 f6 = Math_fround(Math_fround(f3 + f48) * Math_fround(.5));
 f4 = Math_fround(Math_fround(Math_fround(f7 * f52) + Math_fround(f10 * f51)) + Math_fround(f13 * f6));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f52) + Math_fround(f11 * f51)) + Math_fround(f14 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f52) + Math_fround(f12 * f51)) + Math_fround(f15 * f6));
 f47 = Math_fround(Math_fround(f50 - f47) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f49 - f2) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f48 - f3) * Math_fround(.5));
 f10 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f7 * f47))) + Math_fround(Math_abs(Math_fround(f10 * f2)))) + Math_fround(Math_abs(Math_fround(f13 * f3))));
 f11 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f8 * f47))) + Math_fround(Math_abs(Math_fround(f11 * f2)))) + Math_fround(Math_abs(Math_fround(f14 * f3))));
 f12 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f9 * f47))) + Math_fround(Math_abs(Math_fround(f12 * f2)))) + Math_fround(Math_abs(Math_fround(f15 * f3))));
 f7 = Math_fround(Math_fround(f4 - f10) - f43);
 f8 = Math_fround(Math_fround(f5 - f11) - f43);
 f9 = Math_fround(Math_fround(f6 - f12) - f43);
 f10 = Math_fround(Math_fround(f4 + f10) + f43);
 f11 = Math_fround(Math_fround(f5 + f11) + f43);
 f12 = Math_fround(Math_fround(f6 + f12) + f43);
 HEAP32[i39 + 112 >> 2] = 2139095039;
 HEAP32[i39 + 116 >> 2] = 2139095039;
 HEAP32[i39 + 120 >> 2] = 2139095039;
 HEAP32[i39 + 128 >> 2] = 2139095039;
 HEAP32[i39 + 132 >> 2] = 2139095039;
 HEAP32[i39 + 136 >> 2] = 2139095039;
 if (!i40) {
  STACKTOP = i46;
  return;
 }
 i28 = i16 + 39 | 0;
 i24 = i16 + 40 | 0;
 i25 = ~i40;
 i1 = 0;
 i27 = 0;
 do {
  i26 = i40 - i27 | 0;
  i26 = i26 >>> 0 < 128 ? i26 : 128;
  i21 = i42 + (i27 * 176 | 0) | 0;
  i16 = (i26 | 0) == 0;
  L9 : do if (!i16) {
   i18 = 0;
   i19 = i21;
   while (1) {
    i20 = i19 + 176 | 0;
    i53 = i18 | 1;
    i17 = i53 >>> 0 < i40 >>> 0;
    i65 = i17 ? i19 + 352 | 0 : i20;
    i66 = i17 ? i20 : i39;
    i22 = i18 | 2;
    i23 = i22 >>> 0 < i40 >>> 0;
    i20 = i23 ? (i17 ? i20 : i19) + 352 | 0 : i65;
    i65 = i23 ? i65 : i39;
    i23 = i18 | 3;
    i17 = i23 >>> 0 < i40 >>> 0;
    i64 = i17 ? i20 : i39;
    i67 = i19 + 112 | 0;
    f61 = Math_fround(HEAPF32[i67 >> 2]);
    f59 = Math_fround(HEAPF32[i67 + 4 >> 2]);
    f63 = Math_fround(HEAPF32[i67 + 8 >> 2]);
    i19 = i19 + 128 | 0;
    f60 = Math_fround(HEAPF32[i19 >> 2]);
    f58 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f62 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i66 + 112 | 0;
    f55 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f57 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i66 + 128 | 0;
    f54 = Math_fround(HEAPF32[i19 >> 2]);
    f3 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f56 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i65 + 112 | 0;
    f6 = Math_fround(HEAPF32[i19 >> 2]);
    f14 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i65 + 128 | 0;
    f13 = Math_fround(HEAPF32[i19 >> 2]);
    f15 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i64 + 112 | 0;
    f49 = Math_fround(HEAPF32[i19 >> 2]);
    f51 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f47 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    i19 = i64 + 128 | 0;
    f50 = Math_fround(HEAPF32[i19 >> 2]);
    f52 = Math_fround(HEAPF32[i19 + 4 >> 2]);
    f48 = Math_fround(HEAPF32[i19 + 8 >> 2]);
    HEAP32[i41 + (i18 << 2) >> 2] = (f63 > f62 ? f63 : f62) > f9 & ((f59 > f58 ? f59 : f58) > f8 & ((f61 > f60 ? f61 : f60) > f7 & (f12 > (f63 < f62 ? f63 : f62) & (f10 > (f61 < f60 ? f61 : f60) ? f11 > (f59 < f58 ? f59 : f58) : 0)))) & 1;
    HEAP32[i41 + (i53 << 2) >> 2] = (f57 > f56 ? f57 : f56) > f9 & ((f2 > f3 ? f2 : f3) > f8 & ((f55 > f54 ? f55 : f54) > f7 & (f12 > (f57 < f56 ? f57 : f56) & (f10 > (f55 < f54 ? f55 : f54) ? f11 > (f2 < f3 ? f2 : f3) : 0)))) & 1;
    HEAP32[i41 + (i22 << 2) >> 2] = (f4 > f5 ? f4 : f5) > f9 & ((f14 > f15 ? f14 : f15) > f8 & ((f6 > f13 ? f6 : f13) > f7 & (f12 > (f4 < f5 ? f4 : f5) & (f10 > (f6 < f13 ? f6 : f13) ? f11 > (f14 < f15 ? f14 : f15) : 0)))) & 1;
    HEAP32[i41 + (i23 << 2) >> 2] = (f47 > f48 ? f47 : f48) > f9 & ((f51 > f52 ? f51 : f52) > f8 & ((f49 > f50 ? f49 : f50) > f7 & (f12 > (f47 < f48 ? f47 : f48) & (f10 > (f49 < f50 ? f49 : f50) ? f11 > (f51 < f52 ? f51 : f52) : 0)))) & 1;
    i18 = i18 + 4 | 0;
    if (i18 >>> 0 >= i26 >>> 0) break; else i19 = i17 ? i20 + 176 | 0 : i20;
   }
   if (!i16) {
    i20 = i26 + -1 | 0;
    i22 = i27 + i25 | 0;
    i22 = i22 >>> 0 > 4294967167 ? ~i22 : 128;
    i23 = 0;
    i16 = 0;
    while (1) {
     if (HEAP32[i41 + (i23 << 2) >> 2] | 0) {
      if (!i1) {
       i1 = HEAP8[i28 >> 0] | 0;
       if (i1 << 24 >> 24) {
        i1 = i1 & 255;
        i17 = i44;
        i18 = HEAP32[i24 >> 2] | 0;
        while (1) {
         f63 = Math_fround(HEAPF32[i18 >> 2]);
         f6 = Math_fround(HEAPF32[i18 + 4 >> 2]);
         f3 = Math_fround(HEAPF32[i18 + 8 >> 2]);
         f5 = Math_fround(HEAPF32[i18 + 12 >> 2]);
         f2 = Math_fround(Math_fround(Math_fround(f32 * f63) + Math_fround(f33 * f6)) + Math_fround(f34 * f3));
         f4 = Math_fround(Math_fround(Math_fround(f29 * f63) + Math_fround(f30 * f6)) + Math_fround(f31 * f3));
         f3 = Math_fround(Math_fround(Math_fround(f35 * f63) + Math_fround(f37 * f6)) + Math_fround(f36 * f3));
         f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)))));
         if (f6 > Math_fround(0.0)) {
          f63 = Math_fround(Math_fround(1.0) / f6);
          f3 = Math_fround(f3 * f63);
          f4 = Math_fround(f4 * f63);
          f2 = Math_fround(f2 * f63);
         }
         f63 = Math_fround(f5 / f6);
         HEAPF32[i17 >> 2] = f2;
         HEAPF32[i17 + 4 >> 2] = f4;
         HEAPF32[i17 + 8 >> 2] = f3;
         HEAPF32[i17 + 12 >> 2] = f63;
         i1 = i1 + -1 | 0;
         if (!i1) break; else {
          i17 = i17 + 16 | 0;
          i18 = i18 + 20 | 0;
         }
        }
       }
      }
      HEAP32[i38 + 16 + (i16 << 4) >> 2] = HEAP32[i21 + 112 >> 2];
      HEAP32[i38 + 16 + (i16 << 4) + 4 >> 2] = HEAP32[i21 + 116 >> 2];
      HEAP32[i38 + 16 + (i16 << 4) + 8 >> 2] = HEAP32[i21 + 120 >> 2];
      HEAP32[i38 + 80 + (i16 << 4) >> 2] = HEAP32[i21 + 128 >> 2];
      HEAP32[i38 + 80 + (i16 << 4) + 4 >> 2] = HEAP32[i21 + 132 >> 2];
      HEAP32[i38 + 80 + (i16 << 4) + 8 >> 2] = HEAP32[i21 + 136 >> 2];
      HEAP32[i38 + 160 + (i16 << 2) >> 2] = HEAP32[i21 + 124 >> 2];
      HEAP32[i38 + 144 + (i16 << 2) >> 2] = HEAP32[i21 + 92 >> 2];
      HEAP32[i38 + 176 + (i16 << 2) >> 2] = HEAP32[i21 + 44 >> 2];
      HEAP32[i38 + (i16 << 2) >> 2] = i21;
      i1 = 1;
      i16 = i16 + 1 | 0;
     }
     switch (i16 | 0) {
     case 4:
      {
       i45 = 19;
       break;
      }
     case 0:
      {
       i16 = 0;
       break;
      }
     default:
      if ((i23 | 0) == (i20 | 0)) i45 = 19;
     }
     if ((i45 | 0) == 19) {
      i45 = 0;
      __ZN5physx27collideWithConvexPlanesSIMDERNS_21PxsParticleCollDataV4EPKNS_7PxPlaneEjf(i38, i44, HEAPU8[i28 >> 0] | 0, f43);
      i19 = 0;
      do {
       i17 = HEAP32[i38 + (i19 << 2) >> 2] | 0;
       i18 = HEAP32[i38 + 160 + (i19 << 2) >> 2] | 0;
       if (i18 | 0) {
        i67 = i17 + 124 | 0;
        HEAP32[i67 >> 2] = HEAP32[i67 >> 2] | i18;
        HEAP32[i17 + 44 >> 2] = HEAP32[i38 + 176 + (i19 << 2) >> 2];
        HEAP32[i17 + 144 >> 2] = HEAP32[i38 + 192 + (i19 << 4) >> 2];
        HEAP32[i17 + 148 >> 2] = HEAP32[i38 + 192 + (i19 << 4) + 4 >> 2];
        HEAP32[i17 + 152 >> 2] = HEAP32[i38 + 192 + (i19 << 4) + 8 >> 2];
        HEAP32[i17 + 160 >> 2] = HEAP32[i38 + 256 + (i19 << 4) >> 2];
        HEAP32[i17 + 164 >> 2] = HEAP32[i38 + 256 + (i19 << 4) + 4 >> 2];
        HEAP32[i17 + 168 >> 2] = HEAP32[i38 + 256 + (i19 << 4) + 8 >> 2];
       }
       i19 = i19 + 1 | 0;
      } while ((i19 | 0) != (i16 | 0));
      i16 = 0;
     }
     i23 = i23 + 1 | 0;
     if ((i23 | 0) == (i22 | 0)) break L9; else i21 = i21 + 176 | 0;
    }
   }
  } while (0);
  i27 = i26 + i27 | 0;
 } while (i27 >>> 0 < i40 >>> 0);
 STACKTOP = i46;
 return;
}

function __ZN16ReflectionProbes11RemoveProbeE4PPtrI15ReflectionProbeE(i22, i19) {
 i22 = i22 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28;
 i24 = i28 + 52 | 0;
 i26 = i28 + 32 | 0;
 i27 = i28 + 8 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 HEAP32[i24 >> 2] = i8;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i25 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
   i2 = HEAP32[i23 >> 2] | 0;
   i21 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i25 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i25 = 8;
  }
 }
 if ((i25 | 0) == 6) i25 = 8;
 if ((i25 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
 HEAP32[i1 + 156 >> 2] = -1;
 i6 = i22 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i22 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 L13 : do if (i4 | 0) {
  L15 : do if (!i8) {
   i3 = i1 + (i4 << 2) | 0;
   i2 = i1;
   while (1) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i3 = i4;
     break L15;
    }
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i3 | 0)) break L13;
   }
  } else {
   while (1) {
    i5 = HEAP32[i1 >> 2] | 0;
    HEAP32[i24 >> 2] = i8;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i25 = 19; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i2, i24);
      i3 = HEAP32[i23 >> 2] | 0;
      i21 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i21 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i21 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i25 = 19; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i25 = 21;
     }
    }
    if ((i25 | 0) == 19) i25 = 21;
    if ((i25 | 0) == 21) {
     i25 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
    }
    if ((i5 | 0) == (i2 | 0)) break;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == ((HEAP32[i6 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0)) break L13;
   }
   i2 = i1;
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (0);
  i21 = i3 + -1 | 0;
  i20 = i1 + (i21 << 2) | 0;
  i18 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i20 >> 2] = i18;
  HEAP32[i7 >> 2] = i21;
 } while (0);
 i9 = i22 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i26 >> 2] = 0;
 i10 = i26 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i20 = i26 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i26 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i23, gb + 63664 | 0);
 i2 = i23;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i21;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i22 + 72 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L38 : do if ((i3 | 0) != (i1 + (i2 * 12 | 0) | 0)) {
  i7 = HEAP32[i19 >> 2] | 0;
  if (!i7) while (1) {
   if (HEAP32[i3 >> 2] | 0) {
    i2 = HEAP32[i10 >> 2] | 0;
    i4 = i2 + 1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i20 >> 2] = i1;
      HEAP32[i26 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i26 >> 2] | 0, i1 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i18 | 0, HEAP32[i26 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i20 >> 2] = i1;
      HEAP32[i26 >> 2] = i18;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    i1 = (HEAP32[i26 >> 2] | 0) + (i2 * 12 | 0) | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
   }
   i3 = i3 + 12 | 0;
   if ((i3 | 0) == (i1 + (i2 * 12 | 0) | 0)) break L38;
  }
  do {
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i24 >> 2] = i7;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i25 = 41; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
     i2 = HEAP32[i23 >> 2] | 0;
     i18 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i25 = 41; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i25 = 43;
    }
   }
   if ((i25 | 0) == 41) i25 = 43;
   if ((i25 | 0) == 43) {
    i25 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
   }
   if ((i5 | 0) != (i1 | 0)) {
    i2 = HEAP32[i10 >> 2] | 0;
    i4 = i2 + 1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i20 >> 2] = i1;
      HEAP32[i26 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i26 >> 2] | 0, i1 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i18 | 0, HEAP32[i26 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i20 >> 2] = i1;
      HEAP32[i26 >> 2] = i18;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    i18 = (HEAP32[i26 >> 2] | 0) + (i2 * 12 | 0) | 0;
    HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   }
   i3 = i3 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } while ((i3 | 0) != (i1 + ((HEAP32[i8 >> 2] | 0) * 12 | 0) | 0));
 } while (0);
 if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i22 + 64 | 0, HEAP32[i26 + 8 >> 2] | 0);
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  i1 = i26;
  i2 = 0;
 } else {
  __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i21, HEAP32[i22 + 68 >> 2] | 0);
  i1 = i26;
  i2 = HEAP32[i26 >> 2] | 0;
 }
 i16 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i1 >> 2] = i16;
 i16 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i16;
 i16 = i22 + 76 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i15;
 i15 = i22 + 64 | 0;
 i16 = i15;
 i14 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i21;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = i17;
 i15 = i21;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i15 + 4 >> 2] = i16;
 i15 = i22 + 80 | 0;
 i16 = i22 + 84 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 i17 = i22 + 96 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = i14 + (((i1 >>> 0) / 341 | 0) << 2) | 0;
 i18 = i22 + 88 | 0;
 if ((HEAP32[i18 >> 2] | 0) == (i14 | 0)) i1 = 0; else i1 = (HEAP32[i2 >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = 0;
 HEAP32[i27 + 20 >> 2] = 0;
 i10 = i22 + 100 | 0;
 i11 = i27 + 8 | 0;
 i12 = i27 + 4 | 0;
 i13 = i27 + 16 | 0;
 i14 = i27 + 20 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i9 = (i19 | 0) == 0;
 L88 : while (1) {
  do {
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i17 >> 2] | 0;
   i3 = i5 + i4 | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i7 = HEAP32[i18 >> 2] | 0;
   if ((i7 | 0) == (i6 | 0)) i3 = 0; else i3 = (HEAP32[i6 + (((i3 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i3 >>> 0) % 341 | 0) * 12 | 0) | 0;
   i8 = i1;
   if ((i8 | 0) == (i3 | 0)) break L88;
   i6 = HEAP32[i8 >> 2] | 0;
   if (i9) i3 = 0; else {
    HEAP32[i24 >> 2] = i19;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i25 = 70; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i3, i24);
      i4 = HEAP32[i23 >> 2] | 0;
      i7 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i7 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i7 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i25 = 70; else {
      i3 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i3) i25 = 72;
     }
    }
    if ((i25 | 0) == 70) i25 = 72;
    if ((i25 | 0) == 72) {
     i25 = 0;
     i3 = __Z31ReadObjectFromPersistentManageri(i19) | 0;
    }
   }
   if ((i6 | 0) != (i3 | 0)) {
    i6 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i7 = i6 - i5 >> 2;
    i4 = HEAP32[i13 >> 2] | 0;
    i3 = HEAP32[i14 >> 2] | 0;
    if ((((i7 | 0) == 0 ? 0 : (i7 * 341 | 0) + -1 | 0) | 0) == (i3 + i4 | 0)) {
     __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i27);
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = HEAP32[i13 >> 2] | 0;
     i6 = HEAP32[i11 >> 2] | 0;
     i5 = HEAP32[i12 >> 2] | 0;
    }
    i3 = i3 + i4 | 0;
    if ((i6 | 0) == (i5 | 0)) i3 = 0; else i3 = (HEAP32[i5 + (((i3 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i3 >>> 0) % 341 | 0) * 12 | 0) | 0;
    i7 = i1;
    HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   }
   i1 = i8 + 12 | 0;
  } while ((i1 - (HEAP32[i2 >> 2] | 0) | 0) != 4092);
  i1 = i2 + 4 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i27 >> 2] = i1;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i6;
 HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i7;
 i18 = i22 + 92 | 0;
 i1 = i27 + 12 | 0;
 i22 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i22;
 HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i5;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i4;
 HEAP32[i24 >> 2] = i19;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i25 = 87; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
   i2 = HEAP32[i23 >> 2] | 0;
   i24 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i24 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i24 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i25 = 87; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i25 = 89;
  }
 }
 if ((i25 | 0) == 87) i25 = 89;
 if ((i25 | 0) == 89) i1 = __Z31ReadObjectFromPersistentManageri(i19) | 0;
 i2 = i1 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + 16 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   HEAP8[i1 >> 0] = 1;
   HEAP32[i2 >> 2] = 0;
  }
 }
 __ZNSt3__212__deque_baseI18ReflectionProbeJobNS_9allocatorIS1_EEED2Ev(i27);
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i28;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i21);
 HEAP32[i26 >> 2] = 0;
 STACKTOP = i28;
 return;
}

function _zipOpen2(i2, i3, i27, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i29 + 16568 | 0;
 i28 = i29;
 if (!i1) _fill_fopen_filefunc(i28); else {
  HEAP32[i28 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i28 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i28 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i28 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i28 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 }
 i26 = i28 + 28 | 0;
 i1 = mftCall_iiii(HEAP32[i28 >> 2] | 0, HEAP32[i26 >> 2] | 0, i2 | 0, ((i3 | 0) == 0 ? 11 : 7) | 0) | 0;
 i22 = i28 + 32 | 0;
 HEAP32[i22 >> 2] = i1;
 if (!i1) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i2 = i28 + 12 | 0;
 i23 = i28 + 16552 | 0;
 HEAP32[i23 >> 2] = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i26 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i28 + 44 >> 2] = 0;
 HEAP32[i28 + 104 >> 2] = 0;
 i21 = i28 + 16560 | 0;
 HEAP32[i21 >> 2] = 0;
 i11 = i28 + 16556 | 0;
 HEAP32[i11 >> 2] = 0;
 i18 = i28 + 40 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i28 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 i25 = _malloc(16568) | 0;
 if (!i25) {
  mftCall_iii(HEAP32[i28 + 20 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0) | 0;
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i24 = i28 + 16564 | 0;
 HEAP32[i24 >> 2] = 0;
 L12 : do if ((i3 | 0) == 2) {
  i8 = HEAP32[i22 >> 2] | 0;
  i20 = i28 + 16 | 0;
  if (!(mftCall_iiiii(HEAP32[i20 >> 2] | 0, HEAP32[i26 >> 2] | 0, i8 | 0, 0, 2) | 0)) {
   i6 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i26 >> 2] | 0, i8 | 0) | 0;
   i4 = i6 >>> 0 < 65535 ? i6 : 65535;
   i9 = _malloc(1028) | 0;
   if (!i9) i1 = 0; else {
    i7 = i28 + 4 | 0;
    L17 : do if (i4 >>> 0 > 4) {
     i5 = 4;
     while (1) {
      i3 = i5 + 1024 | 0;
      i5 = i3 >>> 0 > i4 >>> 0 ? i4 : i3;
      i3 = i6 - i5 | 0;
      i1 = i5 >>> 0 > 1028 ? 1028 : i5;
      if (mftCall_iiiii(HEAP32[i20 >> 2] | 0, HEAP32[i26 >> 2] | 0, i8 | 0, i3 | 0, 0) | 0) {
       i1 = 0;
       break L17;
      }
      if ((mftCall_iiiii(HEAP32[i7 >> 2] | 0, HEAP32[i26 >> 2] | 0, i8 | 0, i9 | 0, i1 | 0) | 0) != (i1 | 0)) {
       i1 = 0;
       break L17;
      }
      L22 : do if ((i1 | 0) > 3) {
       i2 = i1 + -4 | 0;
       while (1) {
        i1 = i9 + i2 | 0;
        if ((HEAP8[i1 >> 0] | 0) == 80) if ((HEAP8[i1 + 1 >> 0] | 0) == 75) if ((HEAP8[i1 + 2 >> 0] | 0) == 5) if ((HEAP8[i1 + 3 >> 0] | 0) == 6) break;
        if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break L22;
       }
       i1 = i2 + i3 | 0;
       if (i1 | 0) break L17;
      } while (0);
      if (i5 >>> 0 >= i4 >>> 0) {
       i1 = 0;
       break;
      }
     }
    } else i1 = 0; while (0);
    _free(i9);
   }
  } else i1 = 0;
  i2 = (mftCall_iiiii(HEAP32[i20 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0, i1 | 0, 0) | 0) == 0;
  i2 = i2 ? ((i1 | 0) == 0) << 31 >> 31 : -1;
  i3 = HEAP32[i22 >> 2] | 0;
  i17 = i28 + 4 | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) == 1) i16 = 26; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0)) i16 = 26; else i2 = -1;
  do if ((i16 | 0) == 26) {
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0) {
    i2 = -1;
    break;
   }
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0) {
    i2 = -1;
    break;
   }
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0) {
    i2 = -1;
    break;
   }
  } while (0);
  i4 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i4 | 0, i10 | 0, 1) | 0) == 1) {
   i3 = HEAPU8[i10 >> 0] | 0;
   i16 = 39;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i4 | 0) | 0)) {
   i3 = 0;
   i16 = 39;
  } else {
   i2 = -1;
   i3 = 0;
  }
  do if ((i16 | 0) == 39) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i4 | 0, i10 | 0, 1) | 0) == 1) i3 = HEAPU8[i10 >> 0] << 8 | i3; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i4 | 0) | 0)) i3 = i3 * 257 | 0; else {
   i2 = -1;
   i3 = 0;
   break;
  } while (0);
  i5 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) {
   i4 = HEAPU8[i10 >> 0] | 0;
   i16 = 46;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) {
   i4 = 0;
   i16 = 46;
  } else {
   i2 = -1;
   i4 = 0;
  }
  do if ((i16 | 0) == 46) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i4 = HEAPU8[i10 >> 0] << 8 | i4; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) i4 = i4 * 257 | 0; else {
   i2 = -1;
   i4 = 0;
   break;
  } while (0);
  i6 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i6 | 0, i10 | 0, 1) | 0) == 1) {
   i5 = HEAPU8[i10 >> 0] | 0;
   i16 = 53;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i6 | 0) | 0)) {
   i5 = 0;
   i16 = 53;
  } else {
   i2 = -1;
   i5 = 0;
  }
  do if ((i16 | 0) == 53) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i6 | 0, i10 | 0, 1) | 0) == 1) i5 = HEAPU8[i10 >> 0] << 8 | i5; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i6 | 0) | 0)) i5 = i5 * 257 | 0; else {
   i2 = -1;
   i5 = 0;
   break;
  } while (0);
  i7 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i7 | 0, i10 | 0, 1) | 0) == 1) {
   i6 = HEAPU8[i10 >> 0] | 0;
   i16 = 60;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i7 | 0) | 0)) {
   i6 = 0;
   i16 = 60;
  } else {
   i2 = -1;
   i6 = 0;
  }
  do if ((i16 | 0) == 60) if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i7 | 0, i10 | 0, 1) | 0) == 1) i6 = HEAPU8[i10 >> 0] << 8 | i6; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i7 | 0) | 0)) i6 = i6 * 257 | 0; else {
   i2 = -1;
   i6 = 0;
   break;
  } while (0);
  i7 = (i4 | i3 | 0) != 0 | (i6 | 0) != (i5 | 0) ? -103 : i2;
  i5 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) {
   i2 = HEAPU8[i10 >> 0] | 0;
   i16 = 67;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) {
   i2 = 0;
   i16 = 67;
  } else {
   i7 = -1;
   i12 = 0;
  }
  do if ((i16 | 0) == 67) {
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i3 = HEAPU8[i10 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) i3 = i2; else {
    i7 = -1;
    i12 = 0;
    break;
   }
   i4 = i3 << 8 | i2;
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i2 = HEAPU8[i10 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) i2 = i3; else {
    i7 = -1;
    i12 = 0;
    break;
   }
   i3 = (i2 << 16) + i4 | 0;
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i2 = HEAPU8[i10 >> 0] | 0; else if (mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0) {
    i7 = -1;
    i12 = 0;
    break;
   }
   i12 = i3 + (i2 << 24) | 0;
  } while (0);
  i5 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) {
   i2 = HEAPU8[i10 >> 0] | 0;
   i16 = 80;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) {
   i2 = 0;
   i16 = 80;
  } else {
   i7 = -1;
   i5 = 0;
  }
  do if ((i16 | 0) == 80) {
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i3 = HEAPU8[i10 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) i3 = i2; else {
    i7 = -1;
    i5 = 0;
    break;
   }
   i4 = i3 << 8 | i2;
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i2 = HEAPU8[i10 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0)) i2 = i3; else {
    i7 = -1;
    i5 = 0;
    break;
   }
   i3 = (i2 << 16) + i4 | 0;
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0, i10 | 0, 1) | 0) == 1) i2 = HEAPU8[i10 >> 0] | 0; else if (mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i5 | 0) | 0) {
    i7 = -1;
    i5 = 0;
    break;
   }
   i5 = i3 + (i2 << 24) | 0;
  } while (0);
  i3 = HEAP32[i22 >> 2] | 0;
  if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) == 1) {
   i2 = HEAPU8[i10 >> 0] | 0;
   i16 = 93;
  } else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0)) {
   i2 = 0;
   i16 = 93;
  }
  do if ((i16 | 0) == 93) {
   if ((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0, i10 | 0, 1) | 0) == 1) i4 = HEAPU8[i10 >> 0] << 8 | i2; else if (!(mftCall_iii(HEAP32[i28 + 24 >> 2] | 0, HEAP32[i26 >> 2] | 0, i3 | 0) | 0)) i4 = i2 * 257 | 0; else break;
   i3 = i5 + i12 | 0;
   if ((i7 | 0) == 0 & ((i7 | 0) != 0 | i1 >>> 0 >= i3 >>> 0)) {
    if (i4 | 0) {
     i2 = _malloc(i4 + 1 | 0) | 0;
     HEAP32[i24 >> 2] = i2;
     if (i2 | 0) {
      i16 = mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0, i2 | 0, i4 | 0) | 0;
      HEAP8[(HEAP32[i24 >> 2] | 0) + i16 >> 0] = 0;
     }
    }
    i15 = i1 - i3 | 0;
    HEAP32[i11 >> 2] = i15;
    i14 = _malloc(4080) | 0;
    i13 = i15 + i5 | 0;
    i2 = (mftCall_iiiii(HEAP32[i20 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0, i13 | 0, 0) | 0) == 0;
    i1 = (i2 ^ 1) << 31 >> 31;
    L143 : do if ((i12 | 0) != 0 & i2) {
     i1 = i2;
     L145 : while (1) {
      i11 = i12 >>> 0 < 4080 ? i12 : 4080;
      if (!((mftCall_iiiii(HEAP32[i17 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0, i14 | 0, i11 | 0) | 0) == (i11 | 0) & i1)) {
       i1 = -1;
       break L143;
      }
      i1 = HEAP32[i18 >> 2] | 0;
      if (!i1) {
       i1 = _malloc(4096) | 0;
       if (!i1) {
        i16 = 106;
        break;
       }
       HEAP32[i1 >> 2] = 0;
       HEAP32[i1 + 8 >> 2] = 0;
       HEAP32[i1 + 4 >> 2] = 4080;
       HEAP32[i18 >> 2] = i1;
       HEAP32[i19 >> 2] = i1;
      }
      if (i11 | 0) {
       i9 = i14;
       i2 = i1;
       i10 = i11;
       i3 = HEAP32[i1 + 4 >> 2] | 0;
       while (1) {
        if (!i3) {
         i1 = _malloc(4096) | 0;
         if (!i1) {
          i16 = 112;
          break L145;
         }
         HEAP32[i1 >> 2] = 0;
         HEAP32[i1 + 8 >> 2] = 0;
         HEAP32[i1 + 4 >> 2] = 4080;
         HEAP32[i2 >> 2] = i1;
         HEAP32[i18 >> 2] = i1;
         i3 = 4080;
        } else i1 = i2;
        i8 = i1 + 4 | 0;
        i7 = i3 >>> 0 < i10 >>> 0 ? i3 : i10;
        i5 = i1 + 8 | 0;
        i2 = HEAP32[i5 >> 2] | 0;
        i4 = i1 + 16 + i2 | 0;
        if (i7) {
         i2 = 0;
         do {
          HEAP8[i4 + i2 >> 0] = HEAP8[i9 + i2 >> 0] | 0;
          i2 = i2 + 1 | 0;
         } while (i2 >>> 0 < i7 >>> 0);
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = HEAP32[i8 >> 2] | 0;
        }
        HEAP32[i5 >> 2] = i2 + i7;
        i3 = i3 - i7 | 0;
        HEAP32[i8 >> 2] = i3;
        i10 = i10 - i7 | 0;
        if (!i10) break; else {
         i9 = i9 + i7 | 0;
         i2 = i1;
        }
       }
      }
      i12 = i12 - i11 | 0;
      if (!i12) {
       i1 = 0;
       break L143;
      } else i1 = 1;
     }
     if ((i16 | 0) == 106) {
      HEAP32[i18 >> 2] = 0;
      HEAP32[i19 >> 2] = 0;
      i1 = -104;
      break;
     } else if ((i16 | 0) == 112) {
      HEAP32[i2 >> 2] = 0;
      i1 = -104;
      break;
     }
    } while (0);
    if (i14 | 0) _free(i14);
    HEAP32[i23 >> 2] = i15;
    HEAP32[i21 >> 2] = i6;
    i26 = (mftCall_iiiii(HEAP32[i20 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0, i13 | 0, 0) | 0) == 0;
    i1 = i26 ? i1 : -1;
    break L12;
   }
  } while (0);
  mftCall_iii(HEAP32[i28 + 20 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i22 >> 2] | 0) | 0;
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 } else i1 = 0; while (0);
 if (i27 | 0) HEAP32[i27 >> 2] = HEAP32[i24 >> 2];
 if (!i1) {
  _memcpy(i25 | 0, i28 | 0, 16568) | 0;
  i28 = i25;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) _free(i1);
 _free(i25);
 i28 = 0;
 STACKTOP = i29;
 return i28 | 0;
}

function __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i1, i2, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 L1 : while (1) {
  i13 = i2;
  i18 = i2 + -24 | 0;
  i14 = i2 + -48 | 0;
  i16 = i2 + -20 | 0;
  while (1) {
   L5 : while (1) {
    i12 = i1;
    i3 = i13 - i12 | 0;
    switch ((i3 | 0) / 24 | 0 | 0) {
    case 2:
     {
      i17 = 5;
      break L1;
     }
    case 3:
     {
      i17 = 11;
      break L1;
     }
    case 4:
     {
      i17 = 12;
      break L1;
     }
    case 5:
     {
      i17 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i17 = 92;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 744) {
     i17 = 15;
     break L1;
    }
    i6 = (i3 >>> 0) / 48 | 0;
    i11 = i1 + (i6 * 24 | 0) | 0;
    if ((i3 | 0) > 23976) {
     i3 = (i3 >>> 0) / 96 | 0;
     i3 = __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + (i3 * 24 | 0) | 0, i11, i11 + (i3 * 24 | 0) | 0, i18, i15) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i1, i11, i18, i15) | 0;
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i11 >> 2] | 0;
    i4 = _strcmp(i10, i9) | 0;
    if (!i4) {
     i4 = HEAP32[i1 + (i6 * 24 | 0) + 4 >> 2] | 0;
     if (i4 | 0) {
      i5 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i5) {
       i4 = i18;
       break;
      }
      if ((HEAP32[i5 + 16 >> 2] | 0) < (HEAP32[i4 + 16 >> 2] | 0)) {
       i4 = i18;
       break;
      }
     }
    } else if ((i4 | 0) < 0) {
     i4 = i18;
     break;
    }
    if ((i1 | 0) != (i14 | 0)) {
     i8 = i1 + (i6 * 24 | 0) + 4 | 0;
     i6 = i18;
     i4 = i14;
     while (1) {
      i5 = _strcmp(HEAP32[i4 >> 2] | 0, i9) | 0;
      if (!i5) {
       i7 = HEAP32[i8 >> 2] | 0;
       if (i7 | 0) {
        i5 = HEAP32[i6 + -20 >> 2] | 0;
        if (!i5) {
         i17 = 62;
         break L5;
        }
        if ((HEAP32[i5 + 16 >> 2] | 0) < (HEAP32[i7 + 16 >> 2] | 0)) {
         i17 = 62;
         break L5;
        }
       }
      } else if ((i5 | 0) < 0) {
       i17 = 62;
       break L5;
      }
      i5 = i4 + -24 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i6 = i4;
       i4 = i5;
      }
     }
    }
    i3 = i1 + 24 | 0;
    i4 = _strcmp(i10, HEAP32[i18 >> 2] | 0) | 0;
    if (!i4) {
     i4 = HEAP32[i16 >> 2] | 0;
     if (!i4) i17 = 31; else {
      i5 = HEAP32[i1 + 4 >> 2] | 0;
      if (i5) if ((HEAP32[i5 + 16 >> 2] | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) i17 = 31;
     }
    } else if ((i4 | 0) >= 0) i17 = 31;
    if ((i17 | 0) == 31) {
     i17 = 0;
     if ((i3 | 0) == (i18 | 0)) {
      i17 = 92;
      break L1;
     }
     i6 = i1 + 4 | 0;
     while (1) {
      i4 = _strcmp(i10, HEAP32[i3 >> 2] | 0) | 0;
      if (!i4) {
       i4 = HEAP32[i3 + 4 >> 2] | 0;
       if (i4 | 0) {
        i5 = HEAP32[i6 >> 2] | 0;
        if (!i5) break;
        if ((HEAP32[i5 + 16 >> 2] | 0) < (HEAP32[i4 + 16 >> 2] | 0)) break;
       }
      } else if ((i4 | 0) < 0) break;
      i3 = i3 + 24 | 0;
      if ((i3 | 0) == (i18 | 0)) {
       i17 = 92;
       break L1;
      }
     }
     HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i18 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i18 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     i3 = i3 + 24 | 0;
    }
    if ((i3 | 0) == (i18 | 0)) {
     i17 = 92;
     break L1;
    }
    i8 = i1 + 4 | 0;
    i6 = i18;
    while (1) {
     i7 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i4 = _strcmp(i7, HEAP32[i3 >> 2] | 0) | 0;
      if (!i4) {
       i4 = HEAP32[i3 + 4 >> 2] | 0;
       if (i4 | 0) {
        i5 = HEAP32[i8 >> 2] | 0;
        if (!i5) break;
        if ((HEAP32[i5 + 16 >> 2] | 0) < (HEAP32[i4 + 16 >> 2] | 0)) break;
       }
      } else if ((i4 | 0) < 0) break;
      i3 = i3 + 24 | 0;
     }
     while (1) {
      i4 = i6;
      i6 = i6 + -24 | 0;
      i5 = _strcmp(i7, HEAP32[i6 >> 2] | 0) | 0;
      if (i5 | 0) if ((i5 | 0) < 0) continue; else break;
      i4 = HEAP32[i4 + -20 >> 2] | 0;
      if (!i4) break;
      i5 = HEAP32[i8 >> 2] | 0;
      if (!i5) continue;
      if ((HEAP32[i5 + 16 >> 2] | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) break;
     }
     if (i3 >>> 0 >= i6 >>> 0) {
      i1 = i3;
      continue L5;
     };
     HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i19 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i19 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i19 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i19 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i19 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
     i3 = i3 + 24 | 0;
    }
   }
   if ((i17 | 0) == 62) {
    i17 = 0;
    HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 24 | 0;
   L71 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i9 = i11 + 4 | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    while (1) {
     i6 = _strcmp(HEAP32[i5 >> 2] | 0, i10) | 0;
     if (!i6) {
      i6 = HEAP32[i9 >> 2] | 0;
      if (!i6) break;
      i7 = HEAP32[i5 + 4 >> 2] | 0;
      if (i7 | 0) if ((HEAP32[i7 + 16 >> 2] | 0) >= (HEAP32[i6 + 16 >> 2] | 0)) break;
     } else if ((i6 | 0) >= 0) break;
     i5 = i5 + 24 | 0;
    }
    while (1) {
     i7 = i4;
     i4 = i4 + -24 | 0;
     i6 = _strcmp(HEAP32[i4 >> 2] | 0, i10) | 0;
     if (i6 | 0) if ((i6 | 0) < 0) break; else continue;
     i8 = HEAP32[i9 >> 2] | 0;
     if (!i8) continue;
     i6 = HEAP32[i7 + -20 >> 2] | 0;
     if (!i6) break;
     if ((HEAP32[i6 + 16 >> 2] | 0) < (HEAP32[i8 + 16 >> 2] | 0)) break;
    }
    if (i5 >>> 0 > i4 >>> 0) {
     i6 = i11;
     i7 = i5;
     break L71;
    };
    HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i11 = (i11 | 0) == (i5 | 0) ? i4 : i11;
    i5 = i5 + 24 | 0;
    i3 = i3 + 1 | 0;
   } else {
    i6 = i11;
    i7 = i5;
   } while (0);
   do if ((i7 | 0) != (i6 | 0)) {
    i4 = _strcmp(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
    if (!i4) {
     i4 = HEAP32[i7 + 4 >> 2] | 0;
     if (!i4) break;
     i5 = HEAP32[i6 + 4 >> 2] | 0;
     if (i5 | 0) if ((HEAP32[i5 + 16 >> 2] | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) break;
    } else if ((i4 | 0) >= 0) break;
    HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i19 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i19 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEbT0_S7_T_(i1, i7, i15) | 0;
    i4 = i7 + 24 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEbT0_S7_T_(i4, i2, i15) | 0) {
     i17 = 91;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i11 = i7;
   if ((i11 - i12 | 0) >= (i13 - i11 | 0)) {
    i17 = 90;
    break;
   }
   __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i1, i7, i15);
   i1 = i7 + 24 | 0;
  }
  if ((i17 | 0) == 90) {
   i17 = 0;
   __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i7 + 24 | 0, i2, i15);
   i2 = i7;
   continue;
  } else if ((i17 | 0) == 91) {
   i17 = 0;
   if (i3) {
    i17 = 92;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i17 | 0) == 5) {
  i2 = _strcmp(HEAP32[i18 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  if (!i2) {
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i3) {
    STACKTOP = i20;
    return;
   }
   i2 = HEAP32[i16 >> 2] | 0;
   if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i3 + 16 >> 2] | 0)) {
    STACKTOP = i20;
    return;
   }
  } else if ((i2 | 0) >= 0) {
   STACKTOP = i20;
   return;
  };
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 11) {
  __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i1, i1 + 24 | 0, i18, i15) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 12) {
  __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i18, i15) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 13) {
  __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i1 + 72 | 0, i18, i15) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i1, i2, i15);
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 92) {
  STACKTOP = i20;
  return;
 }
}

function __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i59, i1) {
 i59 = i59 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i60 + 144 | 0;
 i55 = i60 + 128 | 0;
 i2 = i60 + 96 | 0;
 i8 = i60 + 64 | 0;
 i53 = i60 + 48 | 0;
 i54 = i60 + 32 | 0;
 i57 = i60 + 16 | 0;
 i58 = i60;
 i52 = i59 + 8 | 0;
 i1 = HEAP16[i52 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i59 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i6 = i1 + 4 | 0;
  i5 = i1;
  i4 = i1 + 24 | 0;
  i3 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i2, HEAP32[i59 >> 2] | 0, i1 & 65535);
  i7 = i2 + 8 | 0;
  i6 = i2 + 4 | 0;
  i5 = i2;
  i4 = i2 + 24 | 0;
  i3 = i2 + 20 | 0;
  i1 = i2 + 16 | 0;
 }
 i36 = HEAP32[i1 >> 2] | 0;
 i33 = HEAP32[i3 >> 2] | 0;
 i31 = HEAP32[i4 >> 2] | 0;
 i23 = HEAP32[i5 >> 2] | 0;
 i21 = HEAP32[i6 >> 2] | 0;
 i27 = HEAP32[i7 >> 2] | 0;
 i50 = i59 + 12 | 0;
 i1 = HEAP16[i50 >> 1] | 0;
 i51 = i59 + 4 | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i51 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i5 = i1 + 4 | 0;
  i4 = i1;
  i3 = i1 + 24 | 0;
  i2 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i8, HEAP32[i51 >> 2] | 0, i1 & 65535);
  i6 = i8 + 8 | 0;
  i5 = i8 + 4 | 0;
  i4 = i8;
  i3 = i8 + 24 | 0;
  i2 = i8 + 20 | 0;
  i1 = i8 + 16 | 0;
 }
 i25 = HEAP32[i1 >> 2] | 0;
 i24 = HEAP32[i2 >> 2] | 0;
 i22 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i59 + 16 >> 2] | 0;
 i1 = HEAP16[i8 + 2 >> 1] | 0;
 i49 = i8 + (i1 & 65535) | 0;
 L9 : do if (!(i1 << 16 >> 16)) {
  i6 = i27;
  i8 = i36;
  i5 = i24;
  i2 = i25;
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  f17 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  i2 = i25;
  i5 = i24;
  i25 = i36;
  i24 = i31;
  i6 = i27;
  while (1) {
   i45 = i8 + 48 | 0;
   i31 = HEAP8[i8 + 1 >> 0] | 0;
   i46 = i31 & 255;
   i36 = i8 + ((i1 & 65535) + 32) | 0;
   i47 = i46 * 112 | 0;
   i48 = i8 + (i47 + 48) | 0;
   f42 = Math_fround(HEAPF32[i8 + 16 >> 2]);
   f43 = Math_fround(HEAPF32[i8 + 20 >> 2]);
   f44 = Math_fround(HEAPF32[i8 + 24 >> 2]);
   if (!(i31 << 24 >> 24)) {
    i1 = i33;
    f38 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f28 = Math_fround(0.0);
    f26 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f30 = Math_fround(0.0);
   } else {
    f29 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f38 = Math_fround(0.0);
    f26 = Math_fround(0.0);
    f28 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f37 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f30 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    i1 = i33;
    i31 = 0;
    while (1) {
     i27 = i31 + 1 | 0;
     f65 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 16 >> 2]);
     f64 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 20 >> 2]);
     f63 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 24 >> 2]);
     f86 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 28 >> 2]);
     f71 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) >> 2]);
     f70 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 4 >> 2]);
     f69 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 8 >> 2]);
     i33 = i45 + (i31 * 112 | 0) + 12 | 0;
     f62 = Math_fround(HEAPF32[i33 >> 2]);
     f88 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 36 >> 2]);
     f87 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 32 >> 2]);
     f79 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f79 * f71);
     f78 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f78 * f70);
     f74 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f61 = Math_fround(f74 * f69);
     f82 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f81 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f77 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(Math_fround(f42 * f82) + f85);
     f83 = Math_fround(Math_fround(f43 * f81) + f83);
     f61 = Math_fround(Math_fround(f44 * f77) + f61);
     f73 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f73 * f65);
     f72 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f67 = Math_fround(f72 * f64);
     f68 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(f68 * f63);
     f76 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f75 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f66 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(Math_fround(Math_fround(f86 * f88) - f87) - Math_fround(f86 * Math_fround(Math_fround(Math_fround(f85 - Math_fround(Math_fround(f42 * f76) + f84)) + Math_fround(f83 - Math_fround(Math_fround(f43 * f75) + f67))) + Math_fround(f61 - Math_fround(Math_fround(f44 * f66) + f80)))));
     f61 = Math_fround(-f62);
     f61 = f80 > f61 ? f80 : f61;
     f80 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 80 >> 2]);
     f67 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 84 >> 2]);
     f80 = Math_fround(f82 + Math_fround(f80 * f61));
     f67 = Math_fround(f81 + Math_fround(f67 * f61));
     f77 = Math_fround(f77 + Math_fround(Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 88 >> 2]) * f61));
     i23 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i6 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     f77 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 48 >> 2]);
     f67 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 52 >> 2]);
     f77 = Math_fround(f79 + Math_fround(f77 * f61));
     f67 = Math_fround(f78 + Math_fround(f67 * f61));
     f74 = Math_fround(f74 + Math_fround(f61 * Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 56 >> 2])));
     i25 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i24 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
     f74 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 96 >> 2]);
     f67 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 100 >> 2]);
     f74 = Math_fround(f76 + Math_fround(f61 * f74));
     f67 = Math_fround(f75 + Math_fround(f61 * f67));
     f66 = Math_fround(f66 + Math_fround(f61 * Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 104 >> 2])));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
     f66 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 64 >> 2]);
     f67 = Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 68 >> 2]);
     f66 = Math_fround(f73 + Math_fround(f61 * f66));
     f67 = Math_fround(f72 + Math_fround(f61 * f67));
     f68 = Math_fround(f68 + Math_fround(f61 * Math_fround(HEAPF32[i45 + (i31 * 112 | 0) + 72 >> 2])));
     i2 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     i22 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
     f68 = Math_fround(f42 * f61);
     f67 = Math_fround(f43 * f61);
     f66 = Math_fround(f44 * f61);
     f29 = Math_fround(f29 + f68);
     f34 = Math_fround(f34 + f67);
     f38 = Math_fround(f38 + f66);
     f26 = Math_fround(f26 + Math_fround(f71 * f61));
     f28 = Math_fround(f28 + Math_fround(f70 * f61));
     f32 = Math_fround(f32 + Math_fround(f69 * f61));
     f37 = Math_fround(f37 + f68);
     f40 = Math_fround(f40 + f67);
     f41 = Math_fround(f41 + f66);
     f30 = Math_fround(f30 + Math_fround(f65 * f61));
     f35 = Math_fround(f35 + Math_fround(f64 * f61));
     f39 = Math_fround(f39 + Math_fround(f63 * f61));
     f61 = Math_fround(f62 + f61);
     HEAPF32[i33 >> 2] = f61;
     HEAPF32[i36 + (i31 << 2) >> 2] = f61;
     if ((i27 | 0) == (i46 | 0)) break; else i31 = i27;
    }
   }
   f88 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f29 * f88));
   f19 = Math_fround(f19 + Math_fround(f34 * f88));
   f20 = Math_fround(f20 + Math_fround(f38 * f88));
   f88 = Math_fround(HEAPF32[i8 + 28 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f26 * f88));
   f13 = Math_fround(f13 + Math_fround(f28 * f88));
   f14 = Math_fround(f14 + Math_fround(f32 * f88));
   f88 = Math_fround(HEAPF32[i8 + 12 >> 2]);
   f15 = Math_fround(f15 - Math_fround(f37 * f88));
   f16 = Math_fround(f16 - Math_fround(f40 * f88));
   f18 = Math_fround(f18 - Math_fround(f41 * f88));
   f88 = Math_fround(HEAPF32[i8 + 32 >> 2]);
   f9 = Math_fround(f9 - Math_fround(f30 * f88));
   f10 = Math_fround(f10 - Math_fround(f35 * f88));
   f12 = Math_fround(f12 - Math_fround(f39 * f88));
   if (i48 >>> 0 >= i49 >>> 0) {
    i31 = i24;
    i33 = i1;
    i8 = i25;
    break L9;
   }
   i33 = i1;
   i1 = HEAP16[i8 + (i47 + 50) >> 1] | 0;
   i8 = i48;
  }
 } while (0);
 i1 = HEAP16[i52 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i59 = HEAP32[i59 >> 2] | 0;
  HEAP32[i59 >> 2] = i23;
  HEAP32[i59 + 4 >> 2] = i21;
  HEAP32[i59 + 8 >> 2] = i6;
  HEAP32[i59 + 16 >> 2] = i8;
  HEAP32[i59 + 20 >> 2] = i33;
  HEAP32[i59 + 24 >> 2] = i31;
 } else {
  i59 = HEAP32[i59 >> 2] | 0;
  HEAPF32[i53 >> 2] = f17;
  HEAPF32[i53 + 4 >> 2] = f19;
  HEAPF32[i53 + 8 >> 2] = f20;
  HEAPF32[i53 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i54 >> 2] = f11;
  HEAPF32[i54 + 4 >> 2] = f13;
  HEAPF32[i54 + 8 >> 2] = f14;
  HEAPF32[i54 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i55 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  HEAP32[i56 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i56 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i56 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i56 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i59, i1 & 65535, i55, i56);
 }
 i1 = HEAP16[i50 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i59 = HEAP32[i51 >> 2] | 0;
  HEAP32[i59 >> 2] = i7;
  HEAP32[i59 + 4 >> 2] = i4;
  HEAP32[i59 + 8 >> 2] = i3;
  HEAP32[i59 + 16 >> 2] = i2;
  HEAP32[i59 + 20 >> 2] = i5;
  HEAP32[i59 + 24 >> 2] = i22;
  STACKTOP = i60;
  return;
 } else {
  i59 = HEAP32[i51 >> 2] | 0;
  HEAPF32[i57 >> 2] = f15;
  HEAPF32[i57 + 4 >> 2] = f16;
  HEAPF32[i57 + 8 >> 2] = f18;
  HEAPF32[i57 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i58 >> 2] = f9;
  HEAPF32[i58 + 4 >> 2] = f10;
  HEAPF32[i58 + 8 >> 2] = f12;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i55 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i57 + 12 >> 2];
  HEAP32[i56 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i56 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i56 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i56 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i59, i1 & 65535, i55, i56);
  STACKTOP = i60;
  return;
 }
}

function __ZN18GfxFramebufferGLES21GrabIntoRenderTextureEP17RenderSurfaceGLESiiii(i32, i20, i25, i26, i27, i28) {
 i32 = i32 | 0;
 i20 = i20 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34 + 136 | 0;
 i31 = i34 + 80 | 0;
 i30 = i34 + 128 | 0;
 i18 = i34 + 40 | 0;
 i1 = i34 + 16 | 0;
 i29 = i34 + 8 | 0;
 i5 = i34 + 72 | 0;
 i6 = i34 + 64 | 0;
 i7 = i34 + 88 | 0;
 i11 = i34 + 56 | 0;
 i12 = i34 + 48 | 0;
 i13 = i34 + 120 | 0;
 i14 = i34 + 32 | 0;
 i21 = i34 + 24 | 0;
 i22 = i34 + 112 | 0;
 i23 = i34 + 104 | 0;
 i24 = i34;
 i17 = __Z16GetRealGfxDevicev() | 0;
 HEAP32[i31 >> 2] = HEAP32[i20 >> 2];
 i2 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = HEAP32[i2 + 32 >> 2] | 0;
  i2 = i3 + (i4 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i33, i2, i31);
  i3 = HEAP32[i33 >> 2] | 0;
  i16 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = HEAP32[gb + 1157724 >> 2] | 0;
  i2 = (i3 | 0) == -1 ? i16 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
  i3 = HEAP32[i4 + 28 >> 2] | 0;
  i4 = HEAP32[i4 + 32 >> 2] | 0;
 }
 if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
 i15 = i2;
 i4 = HEAP32[i32 + 92 >> 2] | 0;
 i16 = i32 + 336 | 0;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i1, HEAP32[i16 >> 2] | 0, 0);
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i29, HEAP32[i16 >> 2] | 0, 1);
 i2 = HEAP32[i16 >> 2] | 0;
 i8 = i1;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i5;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i33 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i2, 1, i33);
 i2 = HEAP32[i16 >> 2] | 0;
 L8 : do if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) i10 = 0; else if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0)) {
  if (!i20) i19 = 11; else if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 125 >> 0] | 0)) i19 = 11; else {
   i10 = __ZN2gl15IsFormatIEEE754ENS_9TexFormatE(HEAP32[i4 + 40 >> 2] | 0) | 0;
   if (!(i10 ^ (__ZN2gl15IsFormatIEEE754ENS_9TexFormatE(HEAP32[i20 + 40 >> 2] | 0) | 0))) i19 = 11;
  }
  do if ((i19 | 0) == 11) if (!(HEAP8[i4 + 31 >> 0] | 0)) if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 > 1) break; else {
   i10 = 0;
   break L8;
  } else if ((__ZNK7ApiGLES3GetEj(i2, 32937) | 0) > 0) break; else {
   i10 = 0;
   break L8;
  } while (0);
  i2 = i15 + 8 | 0;
  __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE(i17, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 9);
  i2 = HEAP32[i16 >> 2] | 0;
  do if (!(i26 | i25)) if ((HEAP32[i4 + 4 >> 2] | 0) == (i27 | 0)) if ((HEAP32[i4 + 8 >> 2] | 0) == (i28 | 0)) {
   if (!(HEAP8[i4 + 31 >> 0] | 0)) i3 = HEAP32[i4 + 40 >> 2] | 0; else {
    i3 = (HEAP32[i4 + 20 >> 2] | 0) >>> 2 & 1;
    i10 = HEAP32[i2 + 860 >> 2] | 0;
    i3 = __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i10, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0, i3) | 0;
   }
   if (!(HEAP8[i20 + 31 >> 0] | 0)) i2 = HEAP32[i20 + 40 >> 2] | 0; else {
    i10 = (HEAP32[i20 + 20 >> 2] | 0) >>> 2 & 1;
    i2 = HEAP32[i2 + 860 >> 2] | 0;
    i2 = __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i2, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0, i10) | 0;
   }
   if ((i3 | 0) != (i2 | 0)) {
    i2 = HEAP32[i16 >> 2] | 0;
    break;
   }
   __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_(i32, i20, i4);
   i32 = HEAP32[i16 >> 2] | 0;
   i29 = i1;
   i30 = HEAP32[i29 + 4 >> 2] | 0;
   i31 = i6;
   HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i31 + 4 >> 2] = i30;
   HEAP32[i33 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i33 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i32, 0, i33);
   STACKTOP = i34;
   return;
  } while (0);
  i10 = __ZN12_GLOBAL__N_127PrepareReadback_ResolveMSAAER18GfxFramebufferGLESR7ApiGLESP17RenderSurfaceGLESS5_(i32, i2, i4, i20) | 0;
 } else i10 = 0; while (0);
 i8 = HEAP32[i20 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = i8;
 mftCall_viiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 176 >> 2] | 0, i17 | 0, 2, 1, i7 | 0);
 i8 = i15 + 8 | 0;
 i9 = i8;
 __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE(i17, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, 7);
 i9 = (i10 | 0) != 0;
 i2 = i9 ? i10 : i4;
 if (!(HEAP8[i2 + 31 >> 0] | 0)) i6 = HEAP32[i2 + 40 >> 2] | 0; else {
  i6 = (HEAP32[i2 + 20 >> 2] | 0) >>> 2 & 1;
  i7 = HEAP32[(HEAP32[i16 >> 2] | 0) + 860 >> 2] | 0;
  i6 = __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i7, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0, i6) | 0;
 }
 if (!(HEAP8[i20 + 31 >> 0] | 0)) i7 = HEAP32[i20 + 40 >> 2] | 0; else {
  i7 = (HEAP32[i20 + 20 >> 2] | 0) >>> 2 & 1;
  i5 = HEAP32[(HEAP32[i16 >> 2] | 0) + 860 >> 2] | 0;
  i7 = __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i5, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0, i7) | 0;
 }
 if (!(HEAP32[i2 >> 2] | 0)) i19 = 36; else if (__ZN2gl15IsFormatIntegerENS_9TexFormatE(i6) | 0) i19 = 36; else {
  __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i31, i32, i20);
  i22 = HEAP32[i16 >> 2] | 0;
  i23 = i31;
  i30 = HEAP32[i23 + 4 >> 2] | 0;
  i21 = i11;
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = i30;
  HEAP32[i33 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i22, 0, i33);
  i22 = HEAP32[i16 >> 2] | 0;
  i21 = i31;
  i30 = HEAP32[i21 + 4 >> 2] | 0;
  i23 = i12;
  HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i23 + 4 >> 2] = i30;
  HEAP32[i33 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i22, 1, i33);
  i22 = __ZN18GfxFramebufferGLES8BlitQuadEv(i32) | 0;
  i23 = HEAP32[i2 + 4 >> 2] | 0;
  i30 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i33 >> 2] = HEAP32[i13 >> 2];
  __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDeviceii9TextureIDiiiiiiii(i22, i17, i23, i30, i33, i25, i26, i27, i28, 0, 0, i27, i28);
  i30 = HEAP32[i16 >> 2] | 0;
  i26 = i1;
  i27 = HEAP32[i26 + 4 >> 2] | 0;
  i28 = i14;
  HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i28 + 4 >> 2] = i27;
  HEAP32[i33 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i30, 0, i33);
 }
 L49 : do if ((i19 | 0) == 36) {
  L51 : do if ((i6 | 0) != (i7 | 0)) {
   i14 = __ZN2gl15IsFormatIntegerENS_9TexFormatE(i6) | 0;
   L53 : do if (!(i14 ^ (__ZN2gl15IsFormatIntegerENS_9TexFormatE(i7) | 0))) {
    if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -5 | 0) >>> 0 < 8) break L51;
    if (!(__ZN2gl15IsFormatIEEE754ENS_9TexFormatE(i6) | 0)) {
     i2 = HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i6) | 0) + 4 >> 2] | 0;
     if ((i2 | 0) < 33319) switch (i2 | 0) {
     case 6408:
      {
       i4 = 1;
       i5 = 3;
       break;
      }
     case 6407:
      {
       i19 = 41;
       break;
      }
     case 6406:
     case 6403:
      {
       i19 = 42;
       break;
      }
     case 6402:
      {
       i19 = 43;
       break;
      }
     default:
      break L53;
     } else switch (i2 | 0) {
     case 36249:
      {
       i4 = 1;
       i5 = 3;
       break;
      }
     case 36248:
      {
       i19 = 41;
       break;
      }
     case 36244:
     case 33320:
     case 33319:
      {
       i19 = 42;
       break;
      }
     case 34041:
      {
       i19 = 43;
       break;
      }
     default:
      break L53;
     }
     if ((i19 | 0) == 41) {
      i4 = 0;
      i5 = 3;
     } else if ((i19 | 0) == 42) {
      i4 = 1;
      i5 = 0;
     } else if ((i19 | 0) == 43) {
      i4 = 0;
      i5 = 0;
     }
     i2 = HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i7) | 0) + 4 >> 2] | 0;
     if ((i2 | 0) < 33319) switch (i2 | 0) {
     case 6408:
      {
       i2 = 1;
       i3 = 3;
       break;
      }
     case 6407:
      {
       i19 = 45;
       break;
      }
     case 6406:
     case 6403:
      {
       i19 = 46;
       break;
      }
     case 6402:
      {
       i19 = 47;
       break;
      }
     default:
      break L53;
     } else switch (i2 | 0) {
     case 36249:
      {
       i2 = 1;
       i3 = 3;
       break;
      }
     case 36248:
      {
       i19 = 45;
       break;
      }
     case 36244:
     case 33320:
     case 33319:
      {
       i19 = 46;
       break;
      }
     case 34041:
      {
       i19 = 47;
       break;
      }
     default:
      break L53;
     }
     if ((i19 | 0) == 45) {
      i2 = 0;
      i3 = 3;
     } else if ((i19 | 0) == 46) {
      i2 = 1;
      i3 = 0;
     } else if ((i19 | 0) == 47) {
      i2 = 0;
      i3 = 0;
     }
     if (!((i4 | i5 | 0) == 0 | (i2 | i3 | 0) == 0)) if (i5 >>> 0 >= i3 >>> 0 & i4 >>> 0 >= i2 >>> 0) break L51;
    }
   } while (0);
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 665 >> 0] | 0) {
    i19 = __ZN2gl15IsFormatIntegerENS_9TexFormatE(i6) | 0;
    if (!(i19 ^ (__ZN2gl15IsFormatIntegerENS_9TexFormatE(i7) | 0))) {
     i2 = HEAP32[i16 >> 2] | 0;
     if (i9) __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i21, i32, i10); else {
      i17 = i32 + 168 | 0;
      i18 = HEAP32[i17 + 4 >> 2] | 0;
      i19 = i21;
      HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i19 + 4 >> 2] = i18;
     }
     __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i22, i32, i20);
     HEAP32[i23 >> 2] = 0;
     HEAP32[i23 + 4 >> 2] = -1;
     HEAP32[i30 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i30 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i31 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
     HEAP32[i33 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i33 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_S3_iiiiiiiiNS0_15FramebufferMaskE(i2, i30, 3, i31, i33, i25, i26, i27, i28, 0, 0, i27, i28, 0);
     break L49;
    }
   }
   i30 = i8;
   __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE(i17, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0, 6);
   if ((i7 | 0) == 3) {
    i30 = Math_imul(i28, i27) | 0;
    i30 = __Znaj((i30 | 0) < 0 ? -1 : i30 << 2) | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 116 >> 2] | 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0, 6408, 5121, i30 | 0);
    __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(HEAP32[i16 >> 2] | 0, HEAP32[i15 >> 2] | 0, 2, 0, 3, 0, i27, i28, 1, 0, i30);
    __ZdaPv(i30);
    break L49;
   } else {
    HEAP32[i18 >> 2] = i7;
    __Z6FormatPKcz(i33, gb + 609474 | 0, i18);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i33 + 11 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33, 0, gb + 609512 | 0, 308, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
    break L49;
   }
  } while (0);
  mftCall_viiiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 192 >> 2] | 0, 3553, 0, 0, 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0);
 } while (0);
 i3 = HEAP32[i16 >> 2] | 0;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 i2 = i24;
 HEAP32[i2 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i2 + 4 >> 2] = i30;
 HEAP32[i33 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i3, 1, i33);
 i3 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i10 | 0) {
  i30 = i31;
  HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i30 + 4 >> 2] = i2;
  HEAP32[i33 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i3, 0, i33);
  __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES(i32, i10, 0);
  i33 = __Z16GetRealGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 388 >> 2] | 0, i33 | 0, i10 | 0);
 }
 STACKTOP = i34;
 return;
}

function __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii(i16, i4, i1, i17, i18, i5) {
 i16 = i16 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 HEAP32[i16 + 1392 >> 2] = i17;
 HEAP32[i16 + 1396 >> 2] = i18;
 HEAP32[i16 + 1400 >> 2] = i5;
 if (HEAP8[i4 + 436 >> 0] | 0) __ZN5Umbra18ImpCameraTransform6updateEv(i4);
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f41 = Math_fround(f22 * f22);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f13 * f13));
 f43 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 HEAP8[i16 + 1224 >> 0] = Math_fround(f41 + Math_fround(f43 * f43)) > Math_fround(0.0) & 1;
 HEAPF32[i16 + 1208 >> 2] = f22;
 HEAPF32[i16 + 1212 >> 2] = f13;
 HEAPF32[i16 + 1216 >> 2] = f43;
 HEAPF32[i16 + 1220 >> 2] = Math_fround(0.0);
 HEAP32[i16 + 1200 >> 2] = HEAP32[i4 + 336 >> 2];
 i2 = i16 + 1184 | 0;
 i56 = i4 + 320 | 0;
 HEAP32[i2 >> 2] = HEAP32[i56 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
 i56 = HEAP32[i4 >> 2] | 0;
 HEAP32[i16 >> 2] = i56;
 i34 = i4 + 4 | 0;
 i46 = i16 + 4 | 0;
 HEAP32[i46 >> 2] = HEAP32[i34 >> 2];
 i31 = i4 + 8 | 0;
 i35 = i16 + 8 | 0;
 HEAP32[i35 >> 2] = HEAP32[i31 >> 2];
 i28 = i4 + 12 | 0;
 i3 = i16 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
 i36 = i4 + 16 | 0;
 HEAP32[i16 + 16 >> 2] = HEAP32[i36 >> 2];
 i39 = i4 + 20 | 0;
 i55 = HEAP32[i39 >> 2] | 0;
 HEAP32[i16 + 20 >> 2] = i55;
 i26 = i4 + 24 | 0;
 i52 = HEAP32[i26 >> 2] | 0;
 HEAP32[i16 + 24 >> 2] = i52;
 i24 = i4 + 28 | 0;
 i49 = HEAP32[i24 >> 2] | 0;
 HEAP32[i16 + 28 >> 2] = i49;
 i33 = i4 + 32 | 0;
 i29 = HEAP32[i33 >> 2] | 0;
 HEAP32[i16 + 32 >> 2] = i29;
 i27 = i4 + 36 | 0;
 i54 = HEAP32[i27 >> 2] | 0;
 HEAP32[i16 + 36 >> 2] = i54;
 i38 = i4 + 40 | 0;
 i51 = HEAP32[i38 >> 2] | 0;
 HEAP32[i16 + 40 >> 2] = i51;
 i1 = i4 + 44 | 0;
 i48 = HEAP32[i1 >> 2] | 0;
 HEAP32[i16 + 44 >> 2] = i48;
 i30 = i4 + 48 | 0;
 i32 = HEAP32[i30 >> 2] | 0;
 HEAP32[i16 + 48 >> 2] = i32;
 i25 = i4 + 52 | 0;
 i53 = HEAP32[i25 >> 2] | 0;
 HEAP32[i16 + 52 >> 2] = i53;
 i23 = i4 + 56 | 0;
 i50 = HEAP32[i23 >> 2] | 0;
 HEAP32[i16 + 56 >> 2] = i50;
 i37 = i4 + 60 | 0;
 i47 = HEAP32[i37 >> 2] | 0;
 HEAP32[i16 + 60 >> 2] = i47;
 f43 = (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(Math_fround(f12 * f45) - Math_fround(f44 * f6));
 f7 = Math_fround(Math_fround(f22 * f45) - Math_fround(f41 * f6));
 f21 = Math_fround(Math_fround(f22 * f44) - Math_fround(f41 * f12));
 f43 = Math_fround(f43 * Math_fround(Math_fround(f8 * f21) + Math_fround(Math_fround(f13 * f11) - Math_fround(f10 * f7))));
 f42 = Math_fround(HEAPF32[i46 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f40 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(Math_fround(f45 * f40) - Math_fround(f6 * f9));
 f12 = Math_fround(Math_fround(f44 * f40) - Math_fround(f12 * f9));
 f11 = Math_fround(f43 - Math_fround(f42 * Math_fround(Math_fround(f8 * f12) + Math_fround(Math_fround(f11 * f14) - Math_fround(f10 * f6)))));
 f9 = Math_fround(Math_fround(f41 * f40) - Math_fround(f22 * f9));
 f11 = Math_fround(Math_fround(Math_fround(HEAPF32[i35 >> 2]) * Math_fround(Math_fround(f8 * f9) + Math_fround(Math_fround(f7 * f14) - Math_fround(f13 * f6)))) + f11);
 HEAP8[i16 + 1204 >> 0] = Math_fround(f11 - Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(Math_fround(f10 * f9) + Math_fround(Math_fround(f21 * f14) - Math_fround(f13 * f12))))) < Math_fround(0.0) & 1;
 i3 = i4 + 332 | 0;
 HEAP32[i16 + 1196 >> 2] = (HEAP32[i3 >> 2] | 0) + 6;
 HEAP32[i16 + 64 >> 2] = HEAP32[i4 >> 2];
 i34 = HEAP32[i34 >> 2] | 0;
 i35 = i16 + 68 | 0;
 HEAP32[i35 >> 2] = i34;
 i31 = HEAP32[i31 >> 2] | 0;
 i32 = i16 + 72 | 0;
 HEAP32[i32 >> 2] = i31;
 i28 = HEAP32[i28 >> 2] | 0;
 i29 = i16 + 76 | 0;
 HEAP32[i29 >> 2] = i28;
 i36 = HEAP32[i36 >> 2] | 0;
 HEAP32[i16 + 80 >> 2] = i36;
 HEAP32[i16 + 84 >> 2] = HEAP32[i39 >> 2];
 i26 = HEAP32[i26 >> 2] | 0;
 HEAP32[i16 + 88 >> 2] = i26;
 i24 = HEAP32[i24 >> 2] | 0;
 HEAP32[i16 + 92 >> 2] = i24;
 i33 = HEAP32[i33 >> 2] | 0;
 HEAP32[i16 + 96 >> 2] = i33;
 i27 = HEAP32[i27 >> 2] | 0;
 HEAP32[i16 + 100 >> 2] = i27;
 HEAP32[i16 + 104 >> 2] = HEAP32[i38 >> 2];
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i16 + 108 >> 2] = i1;
 i30 = HEAP32[i30 >> 2] | 0;
 HEAP32[i16 + 112 >> 2] = i30;
 i25 = HEAP32[i25 >> 2] | 0;
 HEAP32[i16 + 116 >> 2] = i25;
 i23 = HEAP32[i23 >> 2] | 0;
 HEAP32[i16 + 120 >> 2] = i23;
 HEAP32[i16 + 124 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i35 >> 2] = i36;
 HEAP32[i16 + 80 >> 2] = i34;
 HEAP32[i32 >> 2] = i33;
 HEAP32[i16 + 96 >> 2] = i31;
 HEAP32[i29 >> 2] = i30;
 HEAP32[i16 + 112 >> 2] = i28;
 HEAP32[i16 + 88 >> 2] = i27;
 HEAP32[i16 + 100 >> 2] = i26;
 HEAP32[i16 + 92 >> 2] = i25;
 HEAP32[i16 + 116 >> 2] = i24;
 HEAP32[i16 + 108 >> 2] = i23;
 HEAP32[i16 + 120 >> 2] = i1;
 f12 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f21 = Math_fround(HEAPF32[i16 + 44 >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 f6 = Math_fround(f9 - f12);
 f7 = Math_fround(f10 - f13);
 f8 = Math_fround(f11 - f14);
 f22 = Math_fround(Math_fround(HEAPF32[i16 + 60 >> 2]) - f21);
 HEAPF32[i16 + 144 >> 2] = f6;
 HEAPF32[i16 + 148 >> 2] = f7;
 HEAPF32[i16 + 152 >> 2] = f8;
 HEAPF32[i16 + 156 >> 2] = f22;
 f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14)))));
 f12 = Math_fround(f12 * f22);
 HEAPF32[i16 + 128 >> 2] = f12;
 f13 = Math_fround(f22 * f13);
 HEAPF32[i16 + 132 >> 2] = f13;
 f14 = Math_fround(f22 * f14);
 HEAPF32[i16 + 136 >> 2] = f14;
 HEAPF32[i16 + 140 >> 2] = Math_fround(f22 * f21);
 if (Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)))) > Math_fround(0.0)) i1 = Math_fround(Math_fround(Math_fround(f6 * f12) + Math_fround(f7 * f13)) + Math_fround(f8 * f14)) < Math_fround(0.0) & 1; else i1 = 0;
 HEAP8[i16 + 1364 >> 0] = i1;
 i55 = f9 == Math_fround(0.0) & f10 == Math_fround(0.0);
 i56 = f11 == Math_fround(0.0) & 1;
 HEAP8[i16 + 1365 >> 0] = i55 ? i56 : 0;
 f45 = Math_fround(f12 * Math_fround(HEAPF32[i2 >> 2]));
 f45 = Math_fround(f45 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 1188 >> 2])));
 f45 = Math_fround(-Math_fround(f45 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 1192 >> 2]))));
 HEAPF32[i16 + 1348 >> 2] = f12;
 HEAPF32[i16 + 1352 >> 2] = f13;
 HEAPF32[i16 + 1356 >> 2] = f14;
 HEAPF32[i16 + 1360 >> 2] = f45;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i56 = i16 + 128 + (i1 + 6 << 4) | 0;
   i55 = i4 + 64 + (i1 << 4) | 0;
   HEAP32[i56 >> 2] = HEAP32[i55 >> 2];
   HEAP32[i56 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
   HEAP32[i56 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
   HEAP32[i56 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 if (i5 | 0) {
  i50 = (i5 | 0) <= (i18 | 0) ? i5 : i18;
  i56 = i50;
  i50 = (i18 + -1 + i50 | 0) / (i50 | 0) | 0;
  i54 = 4 / (i56 | 0) | 0;
  i49 = 4 % (i56 | 0) | 0;
  i55 = 4 / (i50 | 0) | 0;
  i51 = 4 % (i50 | 0) | 0;
  i48 = (i17 | 0) % (i50 | 0) | 0;
  i53 = (i17 | 0) / (i50 | 0) | 0;
  i52 = i48 + 1 | 0;
  i56 = Math_imul(i50, i56) | 0;
  i50 = i50 + i17 | 0;
  i56 = (i50 | 0) >= (i56 | 0);
  i50 = (i50 | 0) < (i18 | 0);
  i50 = i56 | i50;
  i50 = i50 ? 1 : 2;
  i50 = i53 + i50 | 0;
  i56 = Math_imul(i53, i54) | 0;
  i47 = (i49 | 0) <= (i53 | 0);
  i53 = i47 ? i49 : i53;
  i56 = i53 + i56 | 0;
  i56 = i56 << 4;
  i53 = Math_imul(i48, i55) | 0;
  i47 = (i51 | 0) <= (i48 | 0);
  i48 = i47 ? i51 : i48;
  i53 = i48 + i53 | 0;
  i53 = i53 << 4;
  i54 = Math_imul(i50, i54) | 0;
  i48 = (i49 | 0) <= (i50 | 0);
  i50 = i48 ? i49 : i50;
  i54 = i50 + i54 | 0;
  i54 = i54 << 4;
  i55 = Math_imul(i52, i55) | 0;
  i50 = (i51 | 0) <= (i52 | 0);
  i52 = i50 ? i51 : i52;
  i55 = i52 + i55 | 0;
  i55 = i55 << 4;
  HEAP32[i19 >> 2] = i56;
  i56 = i19 + 4 | 0;
  HEAP32[i56 >> 2] = i53;
  i56 = i19 + 8 | 0;
  HEAP32[i56 >> 2] = i54;
  i56 = i19 + 12 | 0;
  HEAP32[i56 >> 2] = i55;
  __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE(i16, i19);
  STACKTOP = i20;
  return;
 }
 i1 = Math_imul(i18, i18) | 0;
 i2 = ~i18;
 if ((i18 | 0) < 0 & (i1 | 0) > (i2 | 0)) if ((i18 | 0) == -1) {
  i5 = 0;
  i4 = 1;
  i1 = -1;
  i2 = 0;
 } else {
  i1 = i2;
  i3 = -1;
  i15 = 11;
 } else {
  i3 = 1;
  i15 = 11;
 }
 do if ((i15 | 0) == 11) {
  i4 = 0 - i18 | 0;
  i5 = (i18 | 0) < 1;
  if (i5 & (i1 | 0) > (i4 | 0)) if (!i18) {
   i5 = 0;
   i4 = 1;
   i1 = 0;
   i2 = 0;
   break;
  } else {
   i1 = i4;
   i3 = 0;
  }
  i2 = 1 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 1;
   i1 = 1;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i3 = 1;
  }
  if (i5 & (i1 | 0) > (i4 | 0)) if (!i18) {
   i5 = 0;
   i4 = 2;
   i1 = 0;
   i2 = 0;
   break;
  } else {
   i1 = i4;
   i4 = 2;
   i3 = 0;
  } else i4 = 1;
  i2 = 2 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 2;
   i1 = 1;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 2;
   i3 = 1;
  }
  i2 = 4 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 2;
   i1 = 2;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 2;
   i3 = 2;
  }
  i2 = 3 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 3;
   i1 = 1;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 3;
   i3 = 1;
  }
  i2 = 6 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 3;
   i1 = 2;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 3;
   i3 = 2;
  }
  i2 = 9 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 3;
   i1 = 3;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 3;
   i3 = 3;
  }
  i2 = 8 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 4;
   i1 = 2;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i4 = 4;
   i3 = 2;
  }
  i2 = 12 - i18 | 0;
  if ((i2 | 0) > -1 & (i2 | 0) < (i1 | 0)) if (!i2) {
   i5 = 0;
   i4 = 4;
   i1 = 3;
   i2 = 0;
   break;
  } else {
   i1 = i2;
   i2 = 4;
   i3 = 3;
  } else i2 = i4;
  i56 = 16 - i18 | 0;
  i56 = (i56 | 0) > -1 & (i56 | 0) < (i1 | 0);
  i5 = i56 ? 0 : 0;
  i4 = i56 ? 4 : i2;
  i1 = i56 ? 4 : i3;
  i2 = i56 ? 0 : 0;
 } while (0);
 i56 = i5 | i4;
 i50 = i1 | i2;
 i54 = 4 / (i56 | 0) | 0;
 i49 = 4 % (i56 | 0) | 0;
 i55 = 4 / (i50 | 0) | 0;
 i51 = 4 % (i50 | 0) | 0;
 i48 = (i17 | 0) % (i50 | 0) | 0;
 i53 = (i17 | 0) / (i50 | 0) | 0;
 i52 = i48 + 1 | 0;
 i56 = Math_imul(i50, i56) | 0;
 i50 = i50 + i17 | 0;
 i56 = (i50 | 0) >= (i56 | 0);
 i50 = (i50 | 0) < (i18 | 0);
 i50 = i56 | i50;
 i50 = i50 ? 1 : 2;
 i50 = i53 + i50 | 0;
 i56 = Math_imul(i53, i54) | 0;
 i47 = (i49 | 0) <= (i53 | 0);
 i53 = i47 ? i49 : i53;
 i56 = i53 + i56 | 0;
 i56 = i56 << 4;
 i53 = Math_imul(i48, i55) | 0;
 i47 = (i51 | 0) <= (i48 | 0);
 i48 = i47 ? i51 : i48;
 i53 = i48 + i53 | 0;
 i53 = i53 << 4;
 i54 = Math_imul(i50, i54) | 0;
 i48 = (i49 | 0) <= (i50 | 0);
 i50 = i48 ? i49 : i50;
 i54 = i50 + i54 | 0;
 i54 = i54 << 4;
 i55 = Math_imul(i52, i55) | 0;
 i50 = (i51 | 0) <= (i52 | 0);
 i52 = i50 ? i51 : i52;
 i55 = i52 + i55 | 0;
 i55 = i55 << 4;
 HEAP32[i19 >> 2] = i56;
 i56 = i19 + 4 | 0;
 HEAP32[i56 >> 2] = i53;
 i56 = i19 + 8 | 0;
 HEAP32[i56 >> 2] = i54;
 i56 = i19 + 12 | 0;
 HEAP32[i56 >> 2] = i55;
 __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE(i16, i19);
 STACKTOP = i20;
 return;
}

function _UNITY_LZ4_decompress_fast_continue(i1, i18, i3, i19) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i1 + 8 | 0;
 i21 = i1 + 12 | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 do if ((HEAP32[i20 >> 2] | 0) == (i3 | 0)) {
  i15 = i3 + (0 - i2) | 0;
  i16 = i3 + i19 | 0;
  i13 = (HEAP32[i1 >> 2] | 0) + (HEAP32[i1 + 4 >> 2] | 0) | 0;
  i14 = i16 + -12 | 0;
  do if (!i19) if (!(HEAP8[i18 >> 0] | 0)) i1 = 1; else {
   i21 = -1;
   return i21 | 0;
  } else {
   i9 = i16 + -5 | 0;
   i10 = i15;
   i11 = i16 + -8 | 0;
   i12 = i11;
   i5 = i18;
   L7 : while (1) {
    i1 = i5 + 1 | 0;
    i5 = HEAPU8[i5 >> 0] | 0;
    i2 = i5 >>> 4;
    if ((i2 | 0) == 15) {
     i2 = 15;
     while (1) {
      i4 = i1 + 1 | 0;
      i17 = HEAP8[i1 >> 0] | 0;
      i2 = (i17 & 255) + i2 | 0;
      if (i17 << 24 >> 24 == -1) i1 = i4; else {
       i1 = i4;
       break;
      }
     }
    }
    i8 = i3 + i2 | 0;
    if (i8 >>> 0 > i11 >>> 0) {
     i5 = 8;
     break;
    } else i4 = i1;
    while (1) {
     i7 = i4;
     i22 = i7;
     i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
     i7 = i7 + 4 | 0;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i17 = i3;
     i6 = i17;
     HEAP8[i6 >> 0] = i22;
     HEAP8[i6 + 1 >> 0] = i22 >> 8;
     HEAP8[i6 + 2 >> 0] = i22 >> 16;
     HEAP8[i6 + 3 >> 0] = i22 >> 24;
     i17 = i17 + 4 | 0;
     HEAP8[i17 >> 0] = i7;
     HEAP8[i17 + 1 >> 0] = i7 >> 8;
     HEAP8[i17 + 2 >> 0] = i7 >> 16;
     HEAP8[i17 + 3 >> 0] = i7 >> 24;
     i3 = i3 + 8 | 0;
     if (i3 >>> 0 >= i8 >>> 0) break; else i4 = i4 + 8 | 0;
    }
    i1 = i1 + i2 | 0;
    i4 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
    i6 = i4 & 65535;
    i7 = i8 + (0 - i4) | 0;
    i1 = i1 + 2 | 0;
    i2 = i5 & 15;
    if ((i2 | 0) == 15) {
     i2 = 15;
     while (1) {
      i3 = i1 + 1 | 0;
      i22 = HEAP8[i1 >> 0] | 0;
      i2 = (i22 & 255) + i2 | 0;
      if (i22 << 24 >> 24 == -1) i1 = i3; else {
       i1 = i3;
       break;
      }
     }
    }
    i5 = i2 + 4 | 0;
    i3 = i8 + i5 | 0;
    if (i7 >>> 0 < i15 >>> 0) {
     if (i3 >>> 0 > i9 >>> 0) {
      i5 = 32;
      break;
     }
     i4 = i10 - i7 | 0;
     i2 = i13 + (0 - i4) | 0;
     if (i5 >>> 0 <= i4 >>> 0) {
      _memcpy(i8 | 0, i2 | 0, i5 | 0) | 0;
      i5 = i1;
      continue;
     }
     _memcpy(i8 | 0, i2 | 0, i4 | 0) | 0;
     i3 = i8 + i4 | 0;
     i2 = i5 - i4 | 0;
     if (i2 >>> 0 <= (i3 - i10 | 0) >>> 0) {
      _memcpy(i3 | 0, i15 | 0, i2 | 0) | 0;
      i5 = i1;
      i3 = i3 + i2 | 0;
      continue;
     }
     i5 = i3 + i2 | 0;
     if ((i2 | 0) > 0) i2 = i15; else {
      i5 = i1;
      continue;
     }
     while (1) {
      i4 = i3 + 1 | 0;
      HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
      if (i4 >>> 0 < i5 >>> 0) {
       i2 = i2 + 1 | 0;
       i3 = i4;
      } else {
       i5 = i1;
       i3 = i4;
       continue L7;
      }
     }
    }
    if ((i6 & 65535) < 8) {
     i22 = HEAP32[gb + 74112 + (i4 << 2) >> 2] | 0;
     HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i8 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
     HEAP8[i8 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
     HEAP8[i8 + 3 >> 0] = HEAP8[i7 + 3 >> 0] | 0;
     i4 = i7 + (HEAP32[gb + 74144 + (i4 << 2) >> 2] | 0) | 0;
     i17 = i8 + 4 | 0;
     i7 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
     HEAP8[i17 >> 0] = i7;
     HEAP8[i17 + 1 >> 0] = i7 >> 8;
     HEAP8[i17 + 2 >> 0] = i7 >> 16;
     HEAP8[i17 + 3 >> 0] = i7 >> 24;
     i4 = i4 + (0 - i22) | 0;
    } else {
     i22 = i7;
     i6 = i22;
     i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
     i22 = i22 + 4 | 0;
     i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
     i4 = i8;
     i17 = i4;
     HEAP8[i17 >> 0] = i6;
     HEAP8[i17 + 1 >> 0] = i6 >> 8;
     HEAP8[i17 + 2 >> 0] = i6 >> 16;
     HEAP8[i17 + 3 >> 0] = i6 >> 24;
     i4 = i4 + 4 | 0;
     HEAP8[i4 >> 0] = i22;
     HEAP8[i4 + 1 >> 0] = i22 >> 8;
     HEAP8[i4 + 2 >> 0] = i22 >> 16;
     HEAP8[i4 + 3 >> 0] = i22 >> 24;
     i4 = i7 + 8 | 0;
    }
    i2 = i8 + 8 | 0;
    if (i3 >>> 0 <= i14 >>> 0) while (1) {
     i17 = i4;
     i7 = i17;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i17 = i17 + 4 | 0;
     i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
     i22 = i2;
     i8 = i22;
     HEAP8[i8 >> 0] = i7;
     HEAP8[i8 + 1 >> 0] = i7 >> 8;
     HEAP8[i8 + 2 >> 0] = i7 >> 16;
     HEAP8[i8 + 3 >> 0] = i7 >> 24;
     i22 = i22 + 4 | 0;
     HEAP8[i22 >> 0] = i17;
     HEAP8[i22 + 1 >> 0] = i17 >> 8;
     HEAP8[i22 + 2 >> 0] = i17 >> 16;
     HEAP8[i22 + 3 >> 0] = i17 >> 24;
     i2 = i2 + 8 | 0;
     if (i2 >>> 0 < i3 >>> 0) i4 = i4 + 8 | 0; else {
      i5 = i1;
      continue L7;
     }
    }
    if (i3 >>> 0 > i9 >>> 0) {
     i5 = 32;
     break;
    }
    if (i2 >>> 0 < i11 >>> 0) {
     i5 = i2;
     i6 = i4;
     while (1) {
      i17 = i6;
      i7 = i17;
      i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
      i17 = i17 + 4 | 0;
      i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
      i22 = i5;
      i8 = i22;
      HEAP8[i8 >> 0] = i7;
      HEAP8[i8 + 1 >> 0] = i7 >> 8;
      HEAP8[i8 + 2 >> 0] = i7 >> 16;
      HEAP8[i8 + 3 >> 0] = i7 >> 24;
      i22 = i22 + 4 | 0;
      HEAP8[i22 >> 0] = i17;
      HEAP8[i22 + 1 >> 0] = i17 >> 8;
      HEAP8[i22 + 2 >> 0] = i17 >> 16;
      HEAP8[i22 + 3 >> 0] = i17 >> 24;
      i5 = i5 + 8 | 0;
      if (i5 >>> 0 >= i11 >>> 0) break; else i6 = i6 + 8 | 0;
     }
     i4 = i4 + (i12 - i2) | 0;
     i2 = i11;
    }
    if (i2 >>> 0 >= i3 >>> 0) {
     i5 = i1;
     continue;
    }
    while (1) {
     i5 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
     if (i5 >>> 0 < i3 >>> 0) {
      i4 = i4 + 1 | 0;
      i2 = i5;
     } else {
      i5 = i1;
      continue L7;
     }
    }
   }
   if ((i5 | 0) == 8) if ((i8 | 0) == (i16 | 0)) {
    _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
    i1 = i1 + i2 - i18 | 0;
   } else i5 = 32;
   if ((i5 | 0) == 32) i1 = i18 + -1 - i1 | 0;
   if ((i1 | 0) < 1) {
    i22 = i1;
    return i22 | 0;
   } else {
    i2 = HEAP32[i21 >> 2] | 0;
    i3 = HEAP32[i20 >> 2] | 0;
    break;
   }
  } while (0);
  i2 = i2 + i19 | 0;
 } else {
  HEAP32[i1 + 4 >> 2] = i2;
  i11 = i3 + (0 - i2) | 0;
  HEAP32[i1 >> 2] = i11;
  i17 = i3 + i19 | 0;
  i11 = i11 + i2 | 0;
  i12 = i17 + -12 | 0;
  if (!i19) {
   if (!(HEAP8[i18 >> 0] | 0)) {
    i1 = 1;
    i2 = 0;
    break;
   } else i1 = -1;
   return i1 | 0;
  }
  i13 = i17 + -5 | 0;
  i14 = i3;
  i15 = i17 + -8 | 0;
  i16 = i15;
  i5 = i18;
  i4 = i3;
  L63 : while (1) {
   i1 = i5 + 1 | 0;
   i9 = HEAPU8[i5 >> 0] | 0;
   i2 = i9 >>> 4;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i5 = i1 + 1 | 0;
     i22 = HEAP8[i1 >> 0] | 0;
     i2 = (i22 & 255) + i2 | 0;
     if (i22 << 24 >> 24 == -1) i1 = i5; else {
      i1 = i5;
      break;
     }
    }
   }
   i10 = i4 + i2 | 0;
   if (i10 >>> 0 > i15 >>> 0) {
    i5 = 42;
    break;
   } else i5 = i1;
   while (1) {
    i8 = i5;
    i6 = i8;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i8 = i8 + 4 | 0;
    i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
    i22 = i4;
    i7 = i22;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i22 = i22 + 4 | 0;
    HEAP8[i22 >> 0] = i8;
    HEAP8[i22 + 1 >> 0] = i8 >> 8;
    HEAP8[i22 + 2 >> 0] = i8 >> 16;
    HEAP8[i22 + 3 >> 0] = i8 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i10 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i1 = i1 + i2 | 0;
   i6 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i7 = i6 & 65535;
   i8 = i10 + (0 - i6) | 0;
   i1 = i1 + 2 | 0;
   i2 = i9 & 15;
   if ((i2 | 0) == 15) {
    i2 = 15;
    while (1) {
     i4 = i1 + 1 | 0;
     i22 = HEAP8[i1 >> 0] | 0;
     i2 = (i22 & 255) + i2 | 0;
     if (i22 << 24 >> 24 == -1) i1 = i4; else {
      i1 = i4;
      break;
     }
    }
   }
   i5 = i2 + 4 | 0;
   i9 = i10 + i5 | 0;
   if (i8 >>> 0 < i3 >>> 0) {
    if (i9 >>> 0 > i13 >>> 0) {
     i5 = 66;
     break;
    }
    i4 = i14 - i8 | 0;
    i2 = i11 + (0 - i4) | 0;
    if (i5 >>> 0 <= i4 >>> 0) {
     _memcpy(i10 | 0, i2 | 0, i5 | 0) | 0;
     i5 = i1;
     i4 = i9;
     continue;
    }
    _memcpy(i10 | 0, i2 | 0, i4 | 0) | 0;
    i2 = i10 + i4 | 0;
    i4 = i5 - i4 | 0;
    if (i4 >>> 0 <= (i2 - i14 | 0) >>> 0) {
     _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
     i5 = i1;
     i4 = i2 + i4 | 0;
     continue;
    }
    i6 = i2 + i4 | 0;
    if ((i4 | 0) > 0) i5 = i3; else {
     i5 = i1;
     i4 = i2;
     continue;
    }
    while (1) {
     i4 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
     if (i4 >>> 0 < i6 >>> 0) {
      i5 = i5 + 1 | 0;
      i2 = i4;
     } else {
      i5 = i1;
      continue L63;
     }
    }
   }
   if ((i7 & 65535) < 8) {
    i4 = HEAP32[gb + 74112 + (i6 << 2) >> 2] | 0;
    HEAP8[i10 >> 0] = HEAP8[i8 >> 0] | 0;
    HEAP8[i10 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
    HEAP8[i10 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
    HEAP8[i10 + 3 >> 0] = HEAP8[i8 + 3 >> 0] | 0;
    i22 = i8 + (HEAP32[gb + 74144 + (i6 << 2) >> 2] | 0) | 0;
    i8 = i10 + 4 | 0;
    i7 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i4 = i22 + (0 - i4) | 0;
   } else {
    i22 = i8;
    i6 = i22;
    i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
    i22 = i22 + 4 | 0;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i4 = i10;
    i7 = i4;
    HEAP8[i7 >> 0] = i6;
    HEAP8[i7 + 1 >> 0] = i6 >> 8;
    HEAP8[i7 + 2 >> 0] = i6 >> 16;
    HEAP8[i7 + 3 >> 0] = i6 >> 24;
    i4 = i4 + 4 | 0;
    HEAP8[i4 >> 0] = i22;
    HEAP8[i4 + 1 >> 0] = i22 >> 8;
    HEAP8[i4 + 2 >> 0] = i22 >> 16;
    HEAP8[i4 + 3 >> 0] = i22 >> 24;
    i4 = i8 + 8 | 0;
   }
   i2 = i10 + 8 | 0;
   if (i9 >>> 0 <= i12 >>> 0) while (1) {
    i10 = i4;
    i7 = i10;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i10 = i10 + 4 | 0;
    i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
    i22 = i2;
    i8 = i22;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i22 = i22 + 4 | 0;
    HEAP8[i22 >> 0] = i10;
    HEAP8[i22 + 1 >> 0] = i10 >> 8;
    HEAP8[i22 + 2 >> 0] = i10 >> 16;
    HEAP8[i22 + 3 >> 0] = i10 >> 24;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 < i9 >>> 0) i4 = i4 + 8 | 0; else {
     i5 = i1;
     i4 = i9;
     continue L63;
    }
   }
   if (i9 >>> 0 > i13 >>> 0) {
    i5 = 66;
    break;
   }
   if (i2 >>> 0 < i15 >>> 0) {
    i5 = i2;
    i6 = i4;
    while (1) {
     i10 = i6;
     i7 = i10;
     i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
     i10 = i10 + 4 | 0;
     i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
     i22 = i5;
     i8 = i22;
     HEAP8[i8 >> 0] = i7;
     HEAP8[i8 + 1 >> 0] = i7 >> 8;
     HEAP8[i8 + 2 >> 0] = i7 >> 16;
     HEAP8[i8 + 3 >> 0] = i7 >> 24;
     i22 = i22 + 4 | 0;
     HEAP8[i22 >> 0] = i10;
     HEAP8[i22 + 1 >> 0] = i10 >> 8;
     HEAP8[i22 + 2 >> 0] = i10 >> 16;
     HEAP8[i22 + 3 >> 0] = i10 >> 24;
     i5 = i5 + 8 | 0;
     if (i5 >>> 0 >= i15 >>> 0) break; else i6 = i6 + 8 | 0;
    }
    i4 = i4 + (i16 - i2) | 0;
    i2 = i15;
   }
   if (i2 >>> 0 >= i9 >>> 0) {
    i5 = i1;
    i4 = i9;
    continue;
   }
   while (1) {
    i5 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
    if (i5 >>> 0 < i9 >>> 0) {
     i4 = i4 + 1 | 0;
     i2 = i5;
    } else {
     i5 = i1;
     i4 = i9;
     continue L63;
    }
   }
  }
  if ((i5 | 0) == 42) if ((i10 | 0) == (i17 | 0)) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = i1 + i2 - i18 | 0;
  } else i5 = 66;
  if ((i5 | 0) == 66) i1 = i18 + -1 - i1 | 0;
  if ((i1 | 0) < 1) {
   i22 = i1;
   return i22 | 0;
  } else i2 = i19;
 } while (0);
 HEAP32[i21 >> 2] = i2;
 HEAP32[i20 >> 2] = i3 + i19;
 i22 = i1;
 return i22 | 0;
}

function __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367306 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i3 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 1 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367315 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367324 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 3 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367333 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367342 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 5 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367351 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 6 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367360 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 7 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367369 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367378 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 9 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367387 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 10 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367396 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 11 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367406 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367416 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 13 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367426 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 14 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367436 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  L171 : do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i9 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L171;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 15 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 367446 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 L184 : do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 >= i9 >>> 0) {
   if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break L184;
  } while (0);
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sq8AABBTree16progressiveBuildEPNS0_15AABBTreeBuilderEjj(i36, i35, i1, i34) {
 i36 = i36 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i34 = i34 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i38;
 i33 = i38 + 8 | 0;
 switch (i1 | 0) {
 case 0:
  {
   if (!i35) {
    i37 = -1;
    STACKTOP = i38;
    return i37 | 0;
   }
   i5 = i35 + 8 | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i37 = -1;
    STACKTOP = i38;
    return i37 | 0;
   }
   __ZN5physx2Sq8AABBTree7releaseEv(i36);
   HEAP32[i35 + 24 >> 2] = 1;
   HEAP32[i35 + 28 >> 2] = 0;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i38 + 32 | 0, HEAP32[i5 >> 2] << 2, gb + 706818 | 0, 539) | 0;
   HEAP32[i36 >> 2] = i2;
   if (!(HEAP32[i5 >> 2] | 0)) i1 = -1; else {
    i3 = 0;
    do {
     HEAP32[i2 + (i3 << 2) >> 2] = i3;
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    } while (i3 >>> 0 < i1 >>> 0);
    i1 = (i1 << 1) + -1 | 0;
   }
   i4 = i1 * 24 | 0;
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i34 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
   i3 = _PxGetFoundation() | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
   i3 = mftCall_iiiiii(i34 | 0, i2 | 0, (i1 >>> 0 > 178956970 | i4 >>> 0 > 4294967287 ? -1 : i4 + 8 | 0) | 0, (i3 ? gb + 706891 | 0 : gb + 837976 | 0) | 0, gb + 706818 | 0, 546) | 0;
   HEAP32[i3 + 4 >> 2] = i1;
   i4 = i3 + 8 | 0;
   i1 = i4 + (i1 * 24 | 0) | 0;
   i2 = i4;
   do {
    i34 = i2 + 16 | 0;
    HEAP32[i34 >> 2] = 0;
    HEAP32[i34 + 4 >> 2] = 0;
    i2 = i2 + 24 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i34 = i36 + 4 | 0;
   HEAP32[i34 >> 2] = i4;
   HEAP32[i35 + 12 >> 2] = i4;
   i33 = i3 + 24 | 0;
   i32 = i33;
   i31 = HEAP32[i32 >> 2] & 2;
   i32 = HEAP32[i32 + 4 >> 2] & -256;
   i35 = _bitshift64Shl(HEAP32[i5 >> 2] | 0, 0, 2) | 0;
   i32 = i32 | (getTempRet0() | 0);
   HEAP32[i33 >> 2] = i31 | i35 | 1;
   HEAP32[i33 + 4 >> 2] = i32;
   i33 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i32 = HEAP32[(HEAP32[i33 >> 2] | 0) + 8 >> 2] | 0;
   i35 = _PxGetFoundation() | 0;
   i35 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 24 >> 2] | 0, i35 | 0) | 0;
   i35 = mftCall_iiiiii(i32 | 0, i33 | 0, 16, (i35 ? gb + 707011 | 0 : gb + 837976 | 0) | 0, gb + 706818 | 0, 554) | 0;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   HEAP32[i35 + 8 >> 2] = 0;
   HEAP32[i35 + 12 >> 2] = 0;
   HEAP32[i36 + 544 >> 2] = i35;
   i36 = HEAP32[i34 >> 2] | 0;
   HEAP32[i37 >> 2] = i36;
   HEAP32[i37 + 4 >> 2] = i36;
   __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i35, i37) | 0;
   i37 = 0;
   STACKTOP = i38;
   return i37 | 0;
  }
 case 1:
  {
   i32 = i36 + 544 | 0;
   i2 = HEAP32[i32 >> 2] | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    HEAP32[i36 + 536 >> 2] = HEAP32[i35 + 24 >> 2];
    HEAP32[i36 + 540 >> 2] = HEAP32[i35 + 16 >> 2];
    if (i2 | 0) {
     i36 = HEAP32[i2 + 8 >> 2] | 0;
     if ((i36 | 0) > -1 & (i36 & 2147483647 | 0) != 0) {
      i1 = HEAP32[i2 >> 2] | 0;
      if (i1 | 0) {
       i36 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i1 | 0);
      }
     }
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i37, i2);
    }
    HEAP32[i32 >> 2] = 0;
    i37 = 0;
    STACKTOP = i38;
    return i37 | 0;
   }
   if (!i34) {
    i37 = 1;
    STACKTOP = i38;
    return i37 | 0;
   }
   i22 = i35 + 20 | 0;
   i23 = i33 + 4 | 0;
   i24 = i33 + 8 | 0;
   i25 = i33 + 12 | 0;
   i26 = i33 + 16 | 0;
   i27 = i33 + 20 | 0;
   i28 = i35 + 12 | 0;
   i29 = i37 + 4 | 0;
   i30 = i37 + 4 | 0;
   i31 = i35 + 16 | 0;
   if (!i1) {
    i37 = 1;
    STACKTOP = i38;
    return i37 | 0;
   } else i21 = 0;
   while (1) {
    i19 = i2 + 4 | 0;
    i3 = i2 + 12 | 0;
    i20 = HEAP32[i3 >> 2] | 0;
    i17 = HEAP32[i2 >> 2] | 0;
    i16 = HEAP32[i17 + (i20 << 3) >> 2] | 0;
    i18 = i20 + 1 | 0;
    HEAP32[i3 >> 2] = i18;
    i20 = HEAP32[i17 + (i20 << 3) + 4 >> 2] | 0;
    if ((i18 | 0) == (i1 | 0)) {
     HEAP32[i19 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
    }
    i17 = i16;
    i13 = HEAP32[i36 >> 2] | 0;
    i18 = i17 + 16 | 0;
    i15 = i18;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i10 = _bitshift64Lshr(i14 | 0, i15 | 0, 21) | 0;
    getTempRet0() | 0;
    i10 = i10 & 524287;
    i11 = _bitshift64Lshr(i14 | 0, i15 | 0, 2) | 0;
    getTempRet0() | 0;
    i11 = i11 & 524287;
    i4 = HEAP32[i13 + (i10 << 2) >> 2] | 0;
    i12 = HEAP32[i22 >> 2] | 0;
    i5 = HEAP32[i12 + (i4 * 24 | 0) >> 2] | 0;
    i7 = HEAP32[i12 + (i4 * 24 | 0) + 4 >> 2] | 0;
    i8 = HEAP32[i12 + (i4 * 24 | 0) + 8 >> 2] | 0;
    i1 = HEAP32[i12 + (i4 * 24 | 0) + 12 >> 2] | 0;
    i3 = HEAP32[i12 + (i4 * 24 | 0) + 16 >> 2] | 0;
    i4 = HEAP32[i12 + (i4 * 24 | 0) + 20 >> 2] | 0;
    if (i11 >>> 0 > 1) {
     i9 = 1;
     do {
      i44 = HEAP32[i13 + (i9 + i10 << 2) >> 2] | 0;
      f41 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) >> 2]);
      f6 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) + 4 >> 2]);
      f42 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) + 8 >> 2]);
      f39 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f43 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i5 = (HEAPF32[tempDoublePtr >> 2] = f39 < f41 ? f39 : f41, HEAP32[tempDoublePtr >> 2] | 0);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f43 < f6 ? f43 : f6, HEAP32[tempDoublePtr >> 2] | 0);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f40 < f42 ? f40 : f42, HEAP32[tempDoublePtr >> 2] | 0);
      f42 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) + 12 >> 2]);
      f40 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) + 16 >> 2]);
      f6 = Math_fround(HEAPF32[i12 + (i44 * 24 | 0) + 20 >> 2]);
      f43 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f39 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f43 > f42 ? f43 : f42, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f41 > f40 ? f41 : f40, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f39 > f6 ? f39 : f6, HEAP32[tempDoublePtr >> 2] | 0);
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i11 | 0));
    }
    HEAP32[i33 >> 2] = i5;
    HEAP32[i23 >> 2] = i7;
    HEAP32[i24 >> 2] = i8;
    HEAP32[i25 >> 2] = i1;
    HEAP32[i26 >> 2] = i3;
    HEAP32[i27 >> 2] = i4;
    i9 = i18;
    HEAP32[i9 >> 2] = i14 | 1;
    HEAP32[i9 + 4 >> 2] = i15;
    __ZN5physx2Sq12AABBTreeNode9subdivideERKNS_9PxBounds3EPNS0_15AABBTreeBuilderEPj(i17, i33, i35, i13) | 0;
    f50 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f48 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f46 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i9 = f50 > Math_fround(-9999999940000000065998519.0e8);
    f50 = i9 ? f50 : Math_fround(-9999999940000000065998519.0e8);
    i9 = f48 > Math_fround(-9999999940000000065998519.0e8);
    f48 = i9 ? f48 : Math_fround(-9999999940000000065998519.0e8);
    i9 = f46 > Math_fround(-9999999940000000065998519.0e8);
    f46 = i9 ? f46 : Math_fround(-9999999940000000065998519.0e8);
    f40 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f47 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f49 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i9 = f40 < Math_fround(9999999940000000065998519.0e8);
    f40 = i9 ? f40 : Math_fround(9999999940000000065998519.0e8);
    i9 = f47 < Math_fround(9999999940000000065998519.0e8);
    f47 = i9 ? f47 : Math_fround(9999999940000000065998519.0e8);
    i9 = f49 < Math_fround(9999999940000000065998519.0e8);
    f49 = i9 ? f49 : Math_fround(9999999940000000065998519.0e8);
    f42 = Math_fround(Math_fround(f40 + f50) * Math_fround(.5));
    f43 = Math_fround(Math_fround(f47 + f48) * Math_fround(.5));
    f6 = Math_fround(Math_fround(f49 + f46) * Math_fround(.5));
    f50 = Math_fround(Math_fround(f40 - f50) * Math_fround(.5));
    f48 = Math_fround(Math_fround(f47 - f48) * Math_fround(.5));
    f46 = Math_fround(Math_fround(f49 - f46) * Math_fround(.5));
    f49 = Math_fround(f42 * Math_fround(.0000999999974));
    f47 = Math_fround(f43 * Math_fround(.0000999999974));
    f40 = Math_fround(f6 * Math_fround(.0000999999974));
    f45 = Math_fround(-f49);
    f39 = Math_fround(-f47);
    f41 = Math_fround(-f40);
    f45 = Math_fround(f50 + Math_fround((f49 > f45 ? f49 : f45) + Math_fround(.0000999999974)));
    f39 = Math_fround(f48 + Math_fround((f47 > f39 ? f47 : f39) + Math_fround(.0000999999974)));
    f41 = Math_fround(f46 + Math_fround((f40 > f41 ? f40 : f41) + Math_fround(.0000999999974)));
    f40 = f39 > f41 ? f39 : f41;
    f40 = Math_fround((f45 > f40 ? f45 : f40) * Math_fround(.00392158423));
    f46 = Math_fround(Math_fround(f40 + Math_fround(f40 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
    i9 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
    f40 = Math_fround(Math_fround(1.0) / f40);
    i1 = ~~Math_fround(Math_fround(f40 * f45) + Math_fround(1.0));
    i3 = ~~Math_fround(Math_fround(f40 * f39) + Math_fround(1.0));
    i15 = ~~Math_fround(Math_fround(f40 * f41) + Math_fround(1.0));
    i4 = f42 == Math_fround(0.0);
    i5 = f43 == Math_fround(0.0);
    i44 = f6 == Math_fround(0.0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
    i44 = i15 | (i44 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -256);
    HEAP32[i16 >> 2] = i1 | (i4 ? 16777216 : i7 & -256);
    HEAP32[i17 + 4 >> 2] = i3 | (i5 ? 16777216 : i8 & -256);
    HEAP32[i17 + 8 >> 2] = i44;
    i3 = i18;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i16 = _bitshift64Shl(i9 >>> 8 | 0, 0, 40) | 0;
    i44 = getTempRet0() | 0 | i3 & 255;
    i4 = i18;
    HEAP32[i4 >> 2] = i16 | i1;
    HEAP32[i4 + 4 >> 2] = i44;
    i4 = HEAP32[i28 >> 2] | 0;
    if ((i1 & 1 | 0) == 0 & 0 == 0) {
     i1 = _bitshift64Lshr(i1 | 0, i3 | 0, 21) | 0;
     getTempRet0() | 0;
     i1 = i1 & 524287;
     i3 = i1 | 0 ? i4 + ((i1 + 1 | 0) * 24 | 0) | 0 : i4;
     if (i1 | 0) {
      HEAP32[i37 >> 2] = i4 + (i1 * 24 | 0);
      HEAP32[i30 >> 2] = i17;
      i1 = HEAP32[i19 >> 2] | 0;
      if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i15 = i37;
       i16 = HEAP32[i15 + 4 >> 2] | 0;
       i44 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
       HEAP32[i44 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i44 + 4 >> 2] = i16;
       HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i37) | 0;
     }
     if ((i3 | 0) != (i4 | 0)) {
      HEAP32[i37 >> 2] = i3;
      HEAP32[i29 >> 2] = i17;
      i1 = HEAP32[i19 >> 2] | 0;
      if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i16 = i37;
       i17 = HEAP32[i16 + 4 >> 2] | 0;
       i44 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
       HEAP32[i44 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i44 + 4 >> 2] = i17;
       HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i37) | 0;
     }
    }
    i19 = i18;
    i17 = HEAP32[i19 >> 2] | 0;
    i19 = HEAP32[i19 + 4 >> 2] | 0;
    i44 = _bitshift64Lshr(i17 | 0, i19 | 0, 2) | 0;
    getTempRet0() | 0;
    i44 = i44 & 524287;
    HEAP32[i31 >> 2] = i44 + (HEAP32[i31 >> 2] | 0);
    i16 = _bitshift64Shl((i20 - i4 | 0) / 24 | 0 | 0, 0, 2) | 0;
    i19 = getTempRet0() | 0 | i19;
    i20 = i18;
    HEAP32[i20 >> 2] = i16 | i17 & -2097149;
    HEAP32[i20 + 4 >> 2] = i19;
    i21 = i44 + i21 | 0;
    if (i21 >>> 0 >= i34 >>> 0) {
     i1 = 1;
     i2 = 36;
     break;
    }
    i2 = HEAP32[i32 >> 2] | 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) {
     i1 = 1;
     i2 = 36;
     break;
    }
   }
   if ((i2 | 0) == 36) {
    STACKTOP = i38;
    return i1 | 0;
   }
   break;
  }
 default:
  {
   i44 = -1;
   STACKTOP = i38;
   return i44 | 0;
  }
 }
 return 0;
}

function __ZN14ParticleSystem16SetupSubEmittersERS_R19ParticleSystemState(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 672 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i50 + 656 | 0;
 i46 = i50 + 644 | 0;
 i47 = i50 + 640 | 0;
 i48 = i50 + 636 | 0;
 i49 = i50 + 632 | 0;
 i38 = i50 + 32 | 0;
 i40 = i50 + 16 | 0;
 i41 = i50;
 HEAP32[i45 >> 2] = 0;
 i44 = i45 + 4 | 0;
 i42 = gb + 63160 | 0;
 i43 = HEAP32[i42 + 4 >> 2] | 0;
 i3 = i44;
 HEAP32[i3 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i3 + 4 >> 2] = i43;
 i3 = i1 + 916 | 0;
 i1 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i3 >> 2] | 0) | 0) << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 2285) | 0;
   i42 = gb + 64016 | 0;
   i39 = HEAP32[i42 >> 2] | 0;
   i42 = HEAP32[i42 + 4 >> 2] | 0;
   HEAP32[i45 >> 2] = i1;
   i43 = i44;
   HEAP32[i43 >> 2] = i39;
   HEAP32[i43 + 4 >> 2] = i42;
   break;
  }
 } while (0);
 i42 = i1 + 3 & -4;
 HEAP32[i46 >> 2] = 0;
 i43 = i46 + 4 | 0;
 i37 = gb + 63160 | 0;
 i39 = HEAP32[i37 + 4 >> 2] | 0;
 i1 = i43;
 HEAP32[i1 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i1 + 4 >> 2] = i39;
 i1 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i3 >> 2] | 0) | 0) << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 2288) | 0;
   i37 = gb + 64016 | 0;
   i36 = HEAP32[i37 >> 2] | 0;
   i37 = HEAP32[i37 + 4 >> 2] | 0;
   HEAP32[i46 >> 2] = i1;
   i39 = i43;
   HEAP32[i39 >> 2] = i36;
   HEAP32[i39 + 4 >> 2] = i37;
   break;
  }
 } while (0);
 i39 = i1 + 3 & -4;
 i37 = __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_(HEAP32[i3 >> 2] | 0, i42, i39, i47, i48, i49) | 0;
 i35 = HEAP32[i47 >> 2] | 0;
 i33 = HEAP32[i48 >> 2] | 0;
 i34 = HEAP32[i49 >> 2] | 0;
 i2 = i33 + i35 + i34 | 0;
 i32 = i4 + 404 | 0;
 HEAP32[i32 >> 2] = i2;
 HEAP32[i4 + 412 >> 2] = i35;
 HEAP32[i4 + 420 >> 2] = i33;
 HEAP32[i4 + 428 >> 2] = i34;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 600 | 0, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 2298) | 0;
 HEAP32[i4 + 400 >> 2] = i2;
 i34 = i4 + 408 | 0;
 HEAP32[i34 >> 2] = i2;
 i33 = i2 + ((HEAP32[i47 >> 2] | 0) * 600 | 0) | 0;
 i35 = i4 + 416 | 0;
 HEAP32[i35 >> 2] = i33;
 i36 = i4 + 424 | 0;
 HEAP32[i36 >> 2] = i33 + ((HEAP32[i48 >> 2] | 0) * 600 | 0);
 i32 = HEAP32[i32 >> 2] | 0;
 i33 = i2 + (i32 * 600 | 0) | 0;
 __ZN28ParticleSystemSubEmitterDataC2Ev(i38);
 if (!i32) i1 = i38 + 496 | 0; else {
  i7 = i38 + 16 | 0;
  i8 = i38 + 32 | 0;
  i9 = i38 + 40 | 0;
  i10 = i38 + 56 | 0;
  i11 = i38 + 72 | 0;
  i12 = i38 + 80 | 0;
  i13 = i38 + 88 | 0;
  i14 = i38 + 144 | 0;
  i15 = i38 + 164 | 0;
  i16 = i38 + 176 | 0;
  i17 = i38 + 232 | 0;
  i18 = i38 + 252 | 0;
  i19 = i38 + 264 | 0;
  i20 = i38 + 280 | 0;
  i21 = i38 + 296 | 0;
  i22 = i38 + 304 | 0;
  i23 = i38 + 320 | 0;
  i24 = i38 + 336 | 0;
  i25 = i38 + 344 | 0;
  i26 = i38 + 352 | 0;
  i27 = i38 + 408 | 0;
  i28 = i38 + 428 | 0;
  i29 = i38 + 440 | 0;
  i1 = i38 + 496 | 0;
  i30 = i38 + 516 | 0;
  i31 = i38 + 528 | 0;
  i32 = i38 + 580 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   i3 = i2 + 16 | 0;
   HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i3 = i8;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = i2 + 32 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = i4;
   i6 = i2 + 40 | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i6 = i2 + 56 | 0;
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i6 = i11;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i2 + 72 | 0;
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i2 + 80 | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP16[i3 + 4 >> 1] = HEAP16[i12 + 4 >> 1] | 0;
   HEAP8[i3 + 6 >> 0] = HEAP8[i12 + 6 >> 0] | 0;
   i3 = i2 + 88 | 0;
   i4 = i13;
   i6 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 144 | 0, i14);
   i3 = i2 + 164 | 0;
   HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   i3 = i2 + 176 | 0;
   i4 = i16;
   i6 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 232 | 0, i17);
   i3 = i2 + 252 | 0;
   HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   i3 = i2 + 264 | 0;
   HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   i3 = i2 + 280 | 0;
   HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i3 = i21;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = i2 + 296 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = i4;
   i6 = i2 + 304 | 0;
   HEAP32[i6 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   i6 = i2 + 320 | 0;
   HEAP32[i6 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   i6 = i24;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i2 + 336 | 0;
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i2 + 344 | 0;
   HEAP32[i3 >> 2] = HEAP32[i25 >> 2];
   HEAP16[i3 + 4 >> 1] = HEAP16[i25 + 4 >> 1] | 0;
   HEAP8[i3 + 6 >> 0] = HEAP8[i25 + 6 >> 0] | 0;
   i3 = i2 + 352 | 0;
   i4 = i26;
   i6 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 408 | 0, i27);
   i3 = i2 + 428 | 0;
   HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   i3 = i2 + 440 | 0;
   i4 = i29;
   i6 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 496 | 0, i1);
   i3 = i2 + 516 | 0;
   HEAP32[i3 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   i3 = i2 + 528 | 0;
   i4 = i31;
   i6 = i3 + 52 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   i6 = i2 + 580 | 0;
   HEAP32[i6 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i32 + 16 >> 2];
   i2 = i2 + 600 | 0;
  } while ((i2 | 0) != (i33 | 0));
 }
 if ((HEAP32[i38 + 512 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i38 + 500 | 0);
  HEAP32[i38 + 496 >> 2] = 0;
 }
 i1 = i38 + 408 | 0;
 if ((HEAP32[i38 + 424 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i38 + 412 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i38 + 232 | 0;
 if ((HEAP32[i38 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i38 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i38 + 144 | 0;
 if ((HEAP32[i38 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i38 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i47 >> 2] | 0;
 L31 : do if ((i1 | 0) > 0) {
  i9 = i40 + 12 | 0;
  i10 = i40 + 8 | 0;
  i11 = i40 + 4 | 0;
  i12 = i41 + 12 | 0;
  i13 = i41 + 8 | 0;
  i14 = i41 + 4 | 0;
  i8 = 0;
  while (1) {
   i4 = HEAP32[i42 + (i8 << 2) >> 2] | 0;
   i6 = HEAP32[i34 >> 2] | 0;
   i7 = i6 + (i8 * 600 | 0) | 0;
   i1 = i4 + 36 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i38 + 12 >> 2] = 0;
   i33 = HEAP32[i2 + 272 >> 2] | 0;
   i3 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
   i33 = i33 << 11 ^ i33;
   f5 = Math_fround(Math_fround(((i3 ^ i33 ^ i33 >>> 8) & 8388607 ^ i3 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i9 >> 2] = f5;
   HEAPF32[i10 >> 2] = f5;
   HEAPF32[i11 >> 2] = f5;
   HEAPF32[i40 >> 2] = f5;
   i3 = HEAP32[i2 + 84 >> 2] | 0;
   L35 : do switch ((i3 & 65535) << 16 >> 16) {
   case 0:
    {
     i33 = HEAP32[i2 + 80 >> 2] | 0;
     HEAP32[i12 >> 2] = i33;
     HEAP32[i13 >> 2] = i33;
     HEAP32[i14 >> 2] = i33;
     HEAP32[i41 >> 2] = i33;
     break;
    }
   case 3:
    {
     f51 = Math_fround(HEAPF32[(HEAP32[i2 + 232 >> 2] | 0) + 4 >> 2]);
     f52 = Math_fround(HEAPF32[i2 + 80 >> 2]);
     f51 = Math_fround(f51 * f52);
     f5 = Math_fround(f51 + Math_fround(f5 * Math_fround(Math_fround(f52 * Math_fround(HEAPF32[(HEAP32[i2 + 144 >> 2] | 0) + 4 >> 2])) - f51)));
     HEAPF32[i41 >> 2] = f5;
     HEAPF32[i14 >> 2] = f5;
     HEAPF32[i13 >> 2] = f5;
     HEAPF32[i12 >> 2] = f5;
     break;
    }
   default:
    if (!(i3 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i41, i2, i38, i40);
     break L35;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i41, i2, i38, i40);
     break L35;
    }
   } while (0);
   HEAP32[i6 + (i8 * 600 | 0) + 584 >> 2] = HEAP32[i41 >> 2];
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP8[i1 + 277 >> 0] | 0)) f5 = Math_fround(HEAPF32[i1 + 264 >> 2]); else f5 = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i6 + (i8 * 600 | 0) + 588 >> 2] = f5;
   HEAP32[i6 + (i8 * 600 | 0) + 580 >> 2] = HEAP32[(HEAP32[i4 + 44 >> 2] | 0) + 88 >> 2];
   __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi(i7, i4, HEAP32[i39 + (i8 << 2) >> 2] | 0);
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i47 >> 2] | 0;
   if ((i8 | 0) >= (i1 | 0)) break L31;
  }
 } while (0);
 i2 = HEAP32[i48 >> 2] | 0;
 if ((i2 | 0) > 0) {
  __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi(HEAP32[i35 >> 2] | 0, HEAP32[i42 + (i1 << 2) >> 2] | 0, HEAP32[i39 + (i1 << 2) >> 2] | 0);
  i1 = HEAP32[i48 >> 2] | 0;
  if ((i1 | 0) > 1) {
   i1 = 1;
   do {
    i2 = (HEAP32[i47 >> 2] | 0) + i1 | 0;
    __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi((HEAP32[i35 >> 2] | 0) + (i1 * 600 | 0) | 0, HEAP32[i42 + (i2 << 2) >> 2] | 0, HEAP32[i39 + (i2 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i48 >> 2] | 0;
   } while ((i1 | 0) < (i2 | 0));
  } else i2 = i1;
 }
 if ((HEAP32[i49 >> 2] | 0) > 0) i1 = 0; else {
  i49 = HEAP32[i46 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i49, i43);
  i49 = HEAP32[i45 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i49, i44);
  STACKTOP = i50;
  return i37 | 0;
 }
 while (1) {
  i41 = (HEAP32[i47 >> 2] | 0) + i1 + i2 | 0;
  __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi((HEAP32[i36 >> 2] | 0) + (i1 * 600 | 0) | 0, HEAP32[i42 + (i41 << 2) >> 2] | 0, HEAP32[i39 + (i41 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i49 >> 2] | 0)) break;
  i2 = HEAP32[i48 >> 2] | 0;
 }
 i49 = HEAP32[i46 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i49, i43);
 i49 = HEAP32[i45 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i49, i44);
 STACKTOP = i50;
 return i37 | 0;
}

function __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i55, i1) {
 i55 = i55 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, i71 = 0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i56 + 144 | 0;
 i51 = i56 + 128 | 0;
 i2 = i56 + 96 | 0;
 i8 = i56 + 64 | 0;
 i49 = i56 + 48 | 0;
 i50 = i56 + 32 | 0;
 i53 = i56 + 16 | 0;
 i54 = i56;
 i48 = i55 + 8 | 0;
 i1 = HEAP16[i48 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i55 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i6 = i1 + 4 | 0;
  i5 = i1;
  i4 = i1 + 24 | 0;
  i3 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i2, HEAP32[i55 >> 2] | 0, i1 & 65535);
  i7 = i2 + 8 | 0;
  i6 = i2 + 4 | 0;
  i5 = i2;
  i4 = i2 + 24 | 0;
  i3 = i2 + 20 | 0;
  i1 = i2 + 16 | 0;
 }
 i25 = HEAP32[i1 >> 2] | 0;
 i23 = HEAP32[i3 >> 2] | 0;
 i30 = HEAP32[i4 >> 2] | 0;
 i28 = HEAP32[i5 >> 2] | 0;
 i27 = HEAP32[i6 >> 2] | 0;
 i24 = HEAP32[i7 >> 2] | 0;
 i46 = i55 + 12 | 0;
 i1 = HEAP16[i46 >> 1] | 0;
 i47 = i55 + 4 | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i47 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i5 = i1 + 4 | 0;
  i4 = i1;
  i3 = i1 + 24 | 0;
  i2 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i8, HEAP32[i47 >> 2] | 0, i1 & 65535);
  i6 = i8 + 8 | 0;
  i5 = i8 + 4 | 0;
  i4 = i8;
  i3 = i8 + 24 | 0;
  i2 = i8 + 20 | 0;
  i1 = i8 + 16 | 0;
 }
 i22 = HEAP32[i1 >> 2] | 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i55 + 16 >> 2] | 0;
 i44 = HEAP16[i55 + 26 >> 1] | 0;
 i45 = i6 + ((i44 & 65535) << 4) | 0;
 if (!(i44 << 16 >> 16)) {
  i2 = i27;
  i3 = i28;
  i27 = i1;
  i6 = i21;
  i4 = i22;
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  f17 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  i4 = i22;
  i37 = i1;
  i22 = i30;
  i3 = i28;
  i2 = i27;
  i1 = i24;
  while (1) {
   i28 = i6 + 32 | 0;
   i43 = (((HEAPU8[i6 + 1 >> 0] | 0) << 2) + 12 & 2032) + 32 | 0;
   i30 = i6 + i43 | 0;
   i27 = HEAP8[i6 + 2 >> 0] | 0;
   i44 = i27 & 255;
   f42 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   if (!(i27 << 24 >> 24)) {
    i27 = i37;
    f38 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f31 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f33 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    f26 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f32 = Math_fround(0.0);
   } else {
    i27 = i37;
    f31 = Math_fround(0.0);
    f34 = Math_fround(0.0);
    f38 = Math_fround(0.0);
    f26 = Math_fround(0.0);
    f29 = Math_fround(0.0);
    f33 = Math_fround(0.0);
    f36 = Math_fround(0.0);
    f40 = Math_fround(0.0);
    f41 = Math_fround(0.0);
    f32 = Math_fround(0.0);
    f35 = Math_fround(0.0);
    f39 = Math_fround(0.0);
    i24 = 0;
    do {
     i71 = i24;
     i24 = i24 + 1 | 0;
     f64 = Math_fround(HEAPF32[i30 + (i71 << 7) >> 2]);
     f63 = Math_fround(HEAPF32[i30 + (i71 << 7) + 4 >> 2]);
     f62 = Math_fround(HEAPF32[i30 + (i71 << 7) + 8 >> 2]);
     i37 = i30 + (i71 << 7) + 12 | 0;
     f67 = Math_fround(HEAPF32[i30 + (i71 << 7) + 16 >> 2]);
     f66 = Math_fround(HEAPF32[i30 + (i71 << 7) + 20 >> 2]);
     f65 = Math_fround(HEAPF32[i30 + (i71 << 7) + 24 >> 2]);
     f61 = Math_fround(HEAPF32[i30 + (i71 << 7) + 32 >> 2]);
     f60 = Math_fround(HEAPF32[i30 + (i71 << 7) + 36 >> 2]);
     f59 = Math_fround(HEAPF32[i30 + (i71 << 7) + 40 >> 2]);
     f58 = Math_fround(HEAPF32[i37 >> 2]);
     f86 = Math_fround(HEAPF32[i30 + (i71 << 7) + 28 >> 2]);
     f69 = Math_fround(f42 * Math_fround(HEAPF32[i28 + (HEAP32[i30 + (i71 << 7) + 80 >> 2] << 2) >> 2]));
     f57 = Math_fround(-f69);
     f82 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f82 * f64);
     f81 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f85 + Math_fround(f81 * f63));
     f77 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f85 = Math_fround(f85 + Math_fround(f77 * f62));
     f79 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f79 * f67);
     f78 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f84 + Math_fround(f78 * f66));
     f74 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f84 = Math_fround(f84 + Math_fround(f74 * f65));
     f76 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f76 * f64);
     f75 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f83 + Math_fround(f75 * f63));
     f70 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f83 = Math_fround(f83 + Math_fround(f70 * f62));
     f73 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(f73 * f61);
     f72 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(f80 + Math_fround(f72 * f60));
     f68 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f80 = Math_fround(f58 - Math_fround(f86 * Math_fround(Math_fround(f85 + f84) - Math_fround(f83 + Math_fround(f80 + Math_fround(f68 * f59))))));
     f80 = f80 > f69 ? f69 : f80;
     f57 = f80 > f57 ? f80 : f57;
     f58 = Math_fround(f57 - f58);
     f80 = Math_fround(HEAPF32[i30 + (i71 << 7) + 96 >> 2]);
     f69 = Math_fround(HEAPF32[i30 + (i71 << 7) + 100 >> 2]);
     f80 = Math_fround(f82 + Math_fround(f80 * f58));
     f69 = Math_fround(f81 + Math_fround(f69 * f58));
     f77 = Math_fround(f77 + Math_fround(Math_fround(HEAPF32[i30 + (i71 << 7) + 104 >> 2]) * f58));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     f77 = Math_fround(HEAPF32[i30 + (i71 << 7) + 48 >> 2]);
     f69 = Math_fround(HEAPF32[i30 + (i71 << 7) + 52 >> 2]);
     f77 = Math_fround(f79 + Math_fround(f77 * f58));
     f69 = Math_fround(f78 + Math_fround(f69 * f58));
     f74 = Math_fround(f74 + Math_fround(Math_fround(HEAPF32[i30 + (i71 << 7) + 56 >> 2]) * f58));
     i25 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
     i23 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
     i22 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
     f74 = Math_fround(HEAPF32[i30 + (i71 << 7) + 112 >> 2]);
     f69 = Math_fround(HEAPF32[i30 + (i71 << 7) + 116 >> 2]);
     f74 = Math_fround(f76 + Math_fround(f74 * f58));
     f69 = Math_fround(f75 + Math_fround(f58 * f69));
     f70 = Math_fround(f70 + Math_fround(f58 * Math_fround(HEAPF32[i30 + (i71 << 7) + 120 >> 2])));
     i7 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
     i27 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     f70 = Math_fround(HEAPF32[i30 + (i71 << 7) + 64 >> 2]);
     f69 = Math_fround(HEAPF32[i30 + (i71 << 7) + 68 >> 2]);
     f70 = Math_fround(f73 + Math_fround(f58 * f70));
     f69 = Math_fround(f72 + Math_fround(f58 * f69));
     f68 = Math_fround(f68 + Math_fround(f58 * Math_fround(HEAPF32[i30 + (i71 << 7) + 72 >> 2])));
     i4 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
     f64 = Math_fround(f64 * f58);
     f63 = Math_fround(f63 * f58);
     f62 = Math_fround(f62 * f58);
     f31 = Math_fround(f31 + f64);
     f34 = Math_fround(f34 + f63);
     f38 = Math_fround(f38 + f62);
     f26 = Math_fround(f26 + Math_fround(f67 * f58));
     f29 = Math_fround(f29 + Math_fround(f66 * f58));
     f33 = Math_fround(f33 + Math_fround(f65 * f58));
     f36 = Math_fround(f36 + f64);
     f40 = Math_fround(f40 + f63);
     f41 = Math_fround(f41 + f62);
     f32 = Math_fround(f32 + Math_fround(f61 * f58));
     f35 = Math_fround(f35 + Math_fround(f60 * f58));
     f39 = Math_fround(f39 + Math_fround(f59 * f58));
     HEAPF32[i37 >> 2] = f57;
    } while ((i24 | 0) != (i44 | 0));
   }
   f86 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f17 = Math_fround(f17 + Math_fround(f31 * f86));
   f19 = Math_fround(f19 + Math_fround(f34 * f86));
   f20 = Math_fround(f20 + Math_fround(f38 * f86));
   f86 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f26 * f86));
   f13 = Math_fround(f13 + Math_fround(f29 * f86));
   f14 = Math_fround(f14 + Math_fround(f33 * f86));
   f86 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f15 = Math_fround(f15 - Math_fround(f36 * f86));
   f16 = Math_fround(f16 - Math_fround(f40 * f86));
   f18 = Math_fround(f18 - Math_fround(f41 * f86));
   f86 = Math_fround(HEAPF32[i6 + 20 >> 2]);
   i6 = i6 + (i43 + (i44 << 7)) | 0;
   f9 = Math_fround(f9 - Math_fround(f32 * f86));
   f10 = Math_fround(f10 - Math_fround(f35 * f86));
   f12 = Math_fround(f12 - Math_fround(f39 * f86));
   if (i6 >>> 0 >= i45 >>> 0) {
    i24 = i1;
    i30 = i22;
    i6 = i21;
    break;
   } else i37 = i27;
  }
 }
 i1 = HEAP16[i48 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i71 = HEAP32[i55 >> 2] | 0;
  HEAP32[i71 >> 2] = i3;
  HEAP32[i71 + 4 >> 2] = i2;
  HEAP32[i71 + 8 >> 2] = i24;
  HEAP32[i71 + 16 >> 2] = i25;
  HEAP32[i71 + 20 >> 2] = i23;
  HEAP32[i71 + 24 >> 2] = i30;
 } else {
  i71 = HEAP32[i55 >> 2] | 0;
  HEAPF32[i49 >> 2] = f17;
  HEAPF32[i49 + 4 >> 2] = f19;
  HEAPF32[i49 + 8 >> 2] = f20;
  HEAPF32[i49 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i50 >> 2] = f11;
  HEAPF32[i50 + 4 >> 2] = f13;
  HEAPF32[i50 + 8 >> 2] = f14;
  HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i51 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  HEAP32[i52 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i71, i1 & 65535, i51, i52);
 }
 i1 = HEAP16[i46 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i71 = HEAP32[i47 >> 2] | 0;
  HEAP32[i71 >> 2] = i7;
  HEAP32[i71 + 4 >> 2] = i5;
  HEAP32[i71 + 8 >> 2] = i27;
  HEAP32[i71 + 16 >> 2] = i4;
  HEAP32[i71 + 20 >> 2] = i6;
  HEAP32[i71 + 24 >> 2] = i8;
  STACKTOP = i56;
  return;
 } else {
  i71 = HEAP32[i47 >> 2] | 0;
  HEAPF32[i53 >> 2] = f15;
  HEAPF32[i53 + 4 >> 2] = f16;
  HEAPF32[i53 + 8 >> 2] = f18;
  HEAPF32[i53 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i54 >> 2] = f9;
  HEAPF32[i54 + 4 >> 2] = f10;
  HEAPF32[i54 + 8 >> 2] = f12;
  HEAPF32[i54 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i51 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  HEAP32[i52 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i71, i1 & 65535, i51, i52);
  STACKTOP = i56;
  return;
 }
}

function __ZL8Perlin2DRKN4math8floatNx3ERKf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f68 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f63 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f58 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f53 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f48 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f39 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f19 = Math_fround(f19 * f1);
 f68 = Math_fround(f68 * f1);
 f63 = Math_fround(f63 * f1);
 f58 = Math_fround(f58 * f1);
 f53 = Math_fround(f53 * f1);
 f48 = Math_fround(f48 * f1);
 f39 = Math_fround(f39 * f1);
 f30 = Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) * f1);
 f24 = Math_fround(Math_floor(Math_fround(f19)));
 f56 = Math_fround(Math_floor(Math_fround(f68)));
 f33 = Math_fround(Math_floor(Math_fround(f63)));
 f61 = Math_fround(Math_floor(Math_fround(f58)));
 f42 = Math_fround(Math_floor(Math_fround(f53)));
 f66 = Math_fround(Math_floor(Math_fround(f48)));
 f51 = Math_fround(Math_floor(Math_fround(f39)));
 f13 = Math_fround(Math_floor(Math_fround(f30)));
 f19 = Math_fround(f19 - f24);
 f68 = Math_fround(f68 - f56);
 f63 = Math_fround(f63 - f33);
 f58 = Math_fround(f58 - f61);
 f53 = Math_fround(f53 - f42);
 f48 = Math_fround(f48 - f66);
 f39 = Math_fround(f39 - f51);
 f30 = Math_fround(f30 - f13);
 f71 = Math_fround(f19 + Math_fround(-1.0));
 f70 = Math_fround(f68 + Math_fround(-1.0));
 f69 = Math_fround(f63 + Math_fround(-1.0));
 f20 = Math_fround(f58 + Math_fround(-1.0));
 f16 = Math_fround(f53 + Math_fround(-1.0));
 f45 = Math_fround(f48 + Math_fround(-1.0));
 f36 = Math_fround(f39 + Math_fround(-1.0));
 f27 = Math_fround(f30 + Math_fround(-1.0));
 i78 = ~~f24 & 255;
 i76 = ~~f56 & 255;
 i74 = ~~f33 & 255;
 i72 = ~~f61 & 255;
 i86 = ~~f42 & 255;
 i85 = ~~f66 & 255;
 i84 = ~~f51 & 255;
 i83 = ~~f13 & 255;
 i77 = i86 + 1 | 0;
 i75 = i85 + 1 | 0;
 i73 = i84 + 1 | 0;
 i3 = i83 + 1 | 0;
 i82 = HEAP32[gb + 80356 + (i78 << 2) >> 2] | 0;
 i81 = HEAP32[gb + 80356 + (i76 << 2) >> 2] | 0;
 i80 = HEAP32[gb + 80356 + (i74 << 2) >> 2] | 0;
 i79 = HEAP32[gb + 80356 + (i72 << 2) >> 2] | 0;
 i78 = HEAP32[gb + 80356 + (i78 + 1 << 2) >> 2] | 0;
 i76 = HEAP32[gb + 80356 + (i76 + 1 << 2) >> 2] | 0;
 i74 = HEAP32[gb + 80356 + (i74 + 1 << 2) >> 2] | 0;
 i72 = HEAP32[gb + 80356 + (i72 + 1 << 2) >> 2] | 0;
 i87 = HEAP32[gb + 80356 + (i82 + i86 << 2) >> 2] & 7;
 f13 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) >> 2]);
 f51 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) + 4 >> 2]);
 i87 = HEAP32[gb + 80356 + (i81 + i85 << 2) >> 2] & 7;
 f66 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) >> 2]);
 f42 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) + 4 >> 2]);
 i87 = HEAP32[gb + 80356 + (i80 + i84 << 2) >> 2] & 7;
 f61 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) >> 2]);
 f33 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) + 4 >> 2]);
 i87 = HEAP32[gb + 80356 + (i79 + i83 << 2) >> 2] & 7;
 f56 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) >> 2]);
 f24 = Math_fround(HEAPF32[gb + 1452040 + (i87 << 3) + 4 >> 2]);
 i86 = HEAP32[gb + 80356 + (i78 + i86 << 2) >> 2] & 7;
 f10 = Math_fround(HEAPF32[gb + 1452040 + (i86 << 3) >> 2]);
 f6 = Math_fround(HEAPF32[gb + 1452040 + (i86 << 3) + 4 >> 2]);
 i85 = HEAP32[gb + 80356 + (i76 + i85 << 2) >> 2] & 7;
 f9 = Math_fround(HEAPF32[gb + 1452040 + (i85 << 3) >> 2]);
 f5 = Math_fround(HEAPF32[gb + 1452040 + (i85 << 3) + 4 >> 2]);
 i84 = HEAP32[gb + 80356 + (i74 + i84 << 2) >> 2] & 7;
 f8 = Math_fround(HEAPF32[gb + 1452040 + (i84 << 3) >> 2]);
 f4 = Math_fround(HEAPF32[gb + 1452040 + (i84 << 3) + 4 >> 2]);
 i83 = HEAP32[gb + 80356 + (i72 + i83 << 2) >> 2] & 7;
 f7 = Math_fround(HEAPF32[gb + 1452040 + (i83 << 3) >> 2]);
 f21 = Math_fround(HEAPF32[gb + 1452040 + (i83 << 3) + 4 >> 2]);
 i82 = HEAP32[gb + 80356 + (i82 + i77 << 2) >> 2] & 7;
 f11 = Math_fround(HEAPF32[gb + 1452040 + (i82 << 3) >> 2]);
 f49 = Math_fround(HEAPF32[gb + 1452040 + (i82 << 3) + 4 >> 2]);
 i81 = HEAP32[gb + 80356 + (i81 + i75 << 2) >> 2] & 7;
 f64 = Math_fround(HEAPF32[gb + 1452040 + (i81 << 3) >> 2]);
 f40 = Math_fround(HEAPF32[gb + 1452040 + (i81 << 3) + 4 >> 2]);
 i80 = HEAP32[gb + 80356 + (i80 + i73 << 2) >> 2] & 7;
 f59 = Math_fround(HEAPF32[gb + 1452040 + (i80 << 3) >> 2]);
 f31 = Math_fround(HEAPF32[gb + 1452040 + (i80 << 3) + 4 >> 2]);
 i79 = HEAP32[gb + 80356 + (i79 + i3 << 2) >> 2] & 7;
 f54 = Math_fround(HEAPF32[gb + 1452040 + (i79 << 3) >> 2]);
 f22 = Math_fround(HEAPF32[gb + 1452040 + (i79 << 3) + 4 >> 2]);
 i77 = HEAP32[gb + 80356 + (i78 + i77 << 2) >> 2] & 7;
 f12 = Math_fround(HEAPF32[gb + 1452040 + (i77 << 3) >> 2]);
 f50 = Math_fround(HEAPF32[gb + 1452040 + (i77 << 3) + 4 >> 2]);
 i75 = HEAP32[gb + 80356 + (i76 + i75 << 2) >> 2] & 7;
 f65 = Math_fround(HEAPF32[gb + 1452040 + (i75 << 3) >> 2]);
 f41 = Math_fround(HEAPF32[gb + 1452040 + (i75 << 3) + 4 >> 2]);
 i73 = HEAP32[gb + 80356 + (i74 + i73 << 2) >> 2] & 7;
 f60 = Math_fround(HEAPF32[gb + 1452040 + (i73 << 3) >> 2]);
 f32 = Math_fround(HEAPF32[gb + 1452040 + (i73 << 3) + 4 >> 2]);
 i3 = HEAP32[gb + 80356 + (i72 + i3 << 2) >> 2] & 7;
 f55 = Math_fround(HEAPF32[gb + 1452040 + (i3 << 3) >> 2]);
 f23 = Math_fround(HEAPF32[gb + 1452040 + (i3 << 3) + 4 >> 2]);
 f17 = Math_fround(Math_fround(f19 * f13) + Math_fround(f53 * f51));
 f46 = Math_fround(Math_fround(f68 * f66) + Math_fround(f48 * f42));
 f37 = Math_fround(Math_fround(f63 * f61) + Math_fround(f39 * f33));
 f28 = Math_fround(Math_fround(f58 * f56) + Math_fround(f30 * f24));
 f18 = Math_fround(Math_fround(f71 * f10) + Math_fround(f53 * f6));
 f67 = Math_fround(Math_fround(f70 * f9) + Math_fround(f48 * f5));
 f62 = Math_fround(Math_fround(f69 * f8) + Math_fround(f39 * f4));
 f57 = Math_fround(Math_fround(f20 * f7) + Math_fround(f30 * f21));
 f52 = Math_fround(Math_fround(f19 * f11) + Math_fround(f16 * f49));
 f47 = Math_fround(Math_fround(f68 * f64) + Math_fround(f45 * f40));
 f38 = Math_fround(Math_fround(f63 * f59) + Math_fround(f36 * f31));
 f29 = Math_fround(Math_fround(f58 * f54) + Math_fround(f27 * f22));
 f14 = Math_fround(Math_fround(f19 * Math_fround(f19 * f19)) * Math_fround(Math_fround(f19 * Math_fround(Math_fround(f19 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f43 = Math_fround(Math_fround(f68 * Math_fround(f68 * f68)) * Math_fround(Math_fround(f68 * Math_fround(Math_fround(f68 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f34 = Math_fround(Math_fround(f63 * Math_fround(f63 * f63)) * Math_fround(Math_fround(f63 * Math_fround(Math_fround(f63 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f25 = Math_fround(Math_fround(f58 * Math_fround(f58 * f58)) * Math_fround(Math_fround(f58 * Math_fround(Math_fround(f58 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f15 = Math_fround(Math_fround(f53 * Math_fround(f53 * f53)) * Math_fround(Math_fround(f53 * Math_fround(Math_fround(f53 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f44 = Math_fround(Math_fround(f48 * Math_fround(f48 * f48)) * Math_fround(Math_fround(f48 * Math_fround(Math_fround(f48 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f35 = Math_fround(Math_fround(f39 * Math_fround(f39 * f39)) * Math_fround(Math_fround(f39 * Math_fround(Math_fround(f39 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f26 = Math_fround(Math_fround(f30 * Math_fround(f30 * f30)) * Math_fround(Math_fround(f30 * Math_fround(Math_fround(f30 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 f16 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(Math_fround(f71 * f12) + Math_fround(f16 * f50)) - f52) - f18));
 f45 = Math_fround(f46 + Math_fround(Math_fround(Math_fround(Math_fround(f70 * f65) + Math_fround(f45 * f41)) - f47) - f67));
 f36 = Math_fround(f37 + Math_fround(Math_fround(Math_fround(Math_fround(f69 * f60) + Math_fround(f36 * f32)) - f38) - f62));
 f27 = Math_fround(f28 + Math_fround(Math_fround(Math_fround(Math_fround(f20 * f55) + Math_fround(f27 * f23)) - f29) - f57));
 f20 = Math_fround(f1 * Math_fround(1.41421354));
 f9 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f68 * Math_fround(f68 * Math_fround(30.0))) * Math_fround(Math_fround(f68 * Math_fround(f68 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f67 - f46) + Math_fround(f44 * f45))) + Math_fround(Math_fround(f66 + Math_fround(f43 * Math_fround(f9 - f66))) + Math_fround(f44 * Math_fround(Math_fround(f64 - f66) + Math_fround(f43 * Math_fround(f66 + Math_fround(Math_fround(f65 - f64) - f9))))))));
 f8 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f63 * Math_fround(f63 * Math_fround(30.0))) * Math_fround(Math_fround(f63 * Math_fround(f63 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f62 - f37) + Math_fround(f35 * f36))) + Math_fround(Math_fround(f61 + Math_fround(f34 * Math_fround(f8 - f61))) + Math_fround(f35 * Math_fround(Math_fround(f59 - f61) + Math_fround(f34 * Math_fround(f61 + Math_fround(Math_fround(f60 - f59) - f8))))))));
 f7 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f58 * Math_fround(f58 * Math_fround(30.0))) * Math_fround(Math_fround(f58 * Math_fround(f58 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f57 - f28) + Math_fround(f26 * f27))) + Math_fround(Math_fround(f56 + Math_fround(f25 * Math_fround(f7 - f56))) + Math_fround(f26 * Math_fround(Math_fround(f54 - f56) + Math_fround(f25 * Math_fround(f56 + Math_fround(Math_fround(f55 - f54) - f7))))))));
 f6 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f53 * Math_fround(f53 * Math_fround(30.0))) * Math_fround(Math_fround(f53 * Math_fround(f53 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f52 - f17) + Math_fround(f14 * f16))) + Math_fround(Math_fround(f51 + Math_fround(f14 * Math_fround(f6 - f51))) + Math_fround(f15 * Math_fround(Math_fround(f49 - f51) + Math_fround(f14 * Math_fround(f51 + Math_fround(Math_fround(f50 - f49) - f6))))))));
 f5 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f48 * Math_fround(f48 * Math_fround(30.0))) * Math_fround(Math_fround(f48 * Math_fround(f48 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f47 - f46) + Math_fround(f43 * f45))) + Math_fround(Math_fround(f42 + Math_fround(f43 * Math_fround(f5 - f42))) + Math_fround(f44 * Math_fround(Math_fround(f40 - f42) + Math_fround(f43 * Math_fround(f42 + Math_fround(Math_fround(f41 - f40) - f5))))))));
 f4 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f39 * Math_fround(f39 * Math_fround(30.0))) * Math_fround(Math_fround(f39 * Math_fround(f39 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f38 - f37) + Math_fround(f34 * f36))) + Math_fround(Math_fround(f33 + Math_fround(f34 * Math_fround(f4 - f33))) + Math_fround(f35 * Math_fround(Math_fround(f31 - f33) + Math_fround(f34 * Math_fround(f33 + Math_fround(Math_fround(f32 - f31) - f4))))))));
 f1 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f30 * Math_fround(f30 * Math_fround(30.0))) * Math_fround(Math_fround(f30 * Math_fround(f30 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f29 - f28) + Math_fround(f25 * f27))) + Math_fround(Math_fround(f24 + Math_fround(f25 * Math_fround(f21 - f24))) + Math_fround(f26 * Math_fround(Math_fround(f22 - f24) + Math_fround(f25 * Math_fround(f24 + Math_fround(Math_fround(f23 - f22) - f21))))))));
 HEAPF32[i2 >> 2] = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f19 * Math_fround(f19 * Math_fround(30.0))) * Math_fround(Math_fround(f19 * Math_fround(f19 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f18 - f17) + Math_fround(f15 * f16))) + Math_fround(Math_fround(f13 + Math_fround(f14 * Math_fround(f10 - f13))) + Math_fround(f15 * Math_fround(Math_fround(f11 - f13) + Math_fround(f14 * Math_fround(f13 + Math_fround(Math_fround(f12 - f11) - f10))))))));
 HEAPF32[i2 + 4 >> 2] = f9;
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f7;
 HEAPF32[i2 + 16 >> 2] = f6;
 HEAPF32[i2 + 20 >> 2] = f5;
 HEAPF32[i2 + 24 >> 2] = f4;
 HEAPF32[i2 + 28 >> 2] = f1;
 return;
}

function _PrismaticJointSolverPrep(i23, i21, i1, i2, i31, i3, i7) {
 i23 = i23 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f22 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i33 + 72 | 0;
 i28 = i33 + 44 | 0;
 i26 = i33 + 32 | 0;
 i32 = i33;
 i16 = i31 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 f6 = Math_fround(Math_fround(HEAPF32[i31 + 16 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i31 + 20 >> 2]) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(HEAPF32[i31 + 24 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f34 = Math_fround(f6 * f19);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f34 = Math_fround(f34 + Math_fround(f18 * f5));
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f34 = Math_fround(f34 + Math_fround(f37 * f8));
 f29 = Math_fround(Math_fround(f19 * f34) + Math_fround(Math_fround(f6 * f20) + Math_fround(f22 * Math_fround(Math_fround(f37 * f5) - Math_fround(f18 * f8)))));
 f11 = Math_fround(Math_fround(f5 * f34) + Math_fround(Math_fround(f18 * f20) + Math_fround(f22 * Math_fround(Math_fround(f6 * f8) - Math_fround(f37 * f19)))));
 f34 = Math_fround(Math_fround(Math_fround(f37 * f20) + Math_fround(f22 * Math_fround(Math_fround(f18 * f19) - Math_fround(f6 * f5)))) + Math_fround(f8 * f34));
 i16 = i3 + 16 | 0;
 f29 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f29);
 i17 = i3 + 20 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f11);
 i15 = i3 + 24 | 0;
 f34 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f34);
 f6 = Math_fround(HEAPF32[i31 >> 2]);
 f18 = Math_fround(f22 * f6);
 f20 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f19 * f20));
 f37 = Math_fround(HEAPF32[i31 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f5 * f37));
 f4 = Math_fround(HEAPF32[i31 + 4 >> 2]);
 f35 = Math_fround(Math_fround(Math_fround(f8 * f6) + Math_fround(Math_fround(f5 * f20) + Math_fround(f22 * f4))) - Math_fround(f19 * f37));
 f36 = Math_fround(Math_fround(Math_fround(f19 * f4) + Math_fround(Math_fround(f8 * f20) + Math_fround(f22 * f37))) - Math_fround(f5 * f6));
 f37 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f20) - Math_fround(f19 * f6)) - Math_fround(f5 * f4)) - Math_fround(f8 * f37));
 HEAPF32[i27 >> 2] = Math_fround(f18 - Math_fround(f8 * f4));
 i10 = i27 + 4 | 0;
 HEAPF32[i10 >> 2] = f35;
 i12 = i27 + 8 | 0;
 HEAPF32[i12 >> 2] = f36;
 i1 = i27 + 12 | 0;
 HEAPF32[i1 >> 2] = f37;
 i2 = i27 + 16 | 0;
 HEAPF32[i2 >> 2] = f29;
 i3 = i27 + 20 | 0;
 HEAPF32[i3 >> 2] = f11;
 i9 = i27 + 24 | 0;
 HEAPF32[i9 >> 2] = f34;
 f34 = Math_fround(Math_fround(HEAPF32[i31 + 44 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i31 + 48 >> 2]) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(HEAPF32[i31 + 52 >> 2]) * Math_fround(2.0));
 f37 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f36 = Math_fround(Math_fround(f37 * f37) + Math_fround(-.5));
 f35 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(f34 * f35);
 f8 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f11 * f8));
 f18 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f29 * f18));
 f5 = Math_fround(Math_fround(f35 * f4) + Math_fround(Math_fround(f34 * f36) + Math_fround(f37 * Math_fround(Math_fround(f29 * f8) - Math_fround(f11 * f18)))));
 f6 = Math_fround(Math_fround(f8 * f4) + Math_fround(Math_fround(f11 * f36) + Math_fround(f37 * Math_fround(Math_fround(f34 * f18) - Math_fround(f29 * f35)))));
 f4 = Math_fround(Math_fround(Math_fround(f29 * f36) + Math_fround(f37 * Math_fround(Math_fround(f11 * f35) - Math_fround(f34 * f8)))) + Math_fround(f18 * f4));
 i13 = i7 + 16 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f5);
 i14 = i7 + 20 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f6);
 i7 = i7 + 24 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f4);
 f34 = Math_fround(HEAPF32[i31 + 28 >> 2]);
 f11 = Math_fround(f37 * f34);
 f36 = Math_fround(HEAPF32[i31 + 40 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f35 * f36));
 f29 = Math_fround(HEAPF32[i31 + 36 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f8 * f29));
 f19 = Math_fround(HEAPF32[i31 + 32 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f18 * f34) + Math_fround(Math_fround(f8 * f36) + Math_fround(f37 * f19))) - Math_fround(f35 * f29));
 f22 = Math_fround(Math_fround(Math_fround(f35 * f19) + Math_fround(Math_fround(f18 * f36) + Math_fround(f37 * f29))) - Math_fround(f8 * f34));
 f29 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f36) - Math_fround(f35 * f34)) - Math_fround(f8 * f19)) - Math_fround(f18 * f29));
 HEAPF32[i28 >> 2] = Math_fround(f11 - Math_fround(f18 * f19));
 HEAPF32[i28 + 4 >> 2] = f20;
 HEAPF32[i28 + 8 >> 2] = f22;
 HEAPF32[i28 + 12 >> 2] = f29;
 HEAPF32[i28 + 16 >> 2] = f5;
 HEAPF32[i28 + 20 >> 2] = f6;
 HEAPF32[i28 + 24 >> 2] = f4;
 i24 = (HEAP16[i31 + 108 >> 1] & 2) != 0;
 i30 = i31 + 72 | 0;
 if (i24) {
  f37 = Math_fround(HEAPF32[i31 + 96 >> 2]);
  i25 = f37 >= Math_fround(HEAPF32[i31 + 92 >> 2]);
 } else i25 = 0;
 f38 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
 f35 = Math_fround(f6 - Math_fround(HEAPF32[i3 >> 2]));
 f38 = Math_fround(f38 * Math_fround(2.0));
 f35 = Math_fround(f35 * Math_fround(2.0));
 f36 = Math_fround(Math_fround(f4 - Math_fround(HEAPF32[i9 >> 2])) * Math_fround(2.0));
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i27 >> 2]);
 f34 = Math_fround(f38 * f19);
 f20 = Math_fround(HEAPF32[i10 >> 2]);
 f34 = Math_fround(f34 + Math_fround(f35 * f20));
 f11 = Math_fround(HEAPF32[i12 >> 2]);
 f34 = Math_fround(f34 + Math_fround(f36 * f11));
 f29 = Math_fround(Math_fround(f19 * f34) + Math_fround(Math_fround(f38 * f18) - Math_fround(f22 * Math_fround(Math_fround(f36 * f20) - Math_fround(f35 * f11)))));
 f8 = Math_fround(Math_fround(f20 * f34) + Math_fround(Math_fround(f35 * f18) - Math_fround(f22 * Math_fround(Math_fround(f38 * f11) - Math_fround(f36 * f19)))));
 f34 = Math_fround(Math_fround(Math_fround(f36 * f18) - Math_fround(f22 * Math_fround(Math_fround(f35 * f19) - Math_fround(f38 * f20)))) + Math_fround(f11 * f34));
 HEAPF32[i26 >> 2] = f29;
 HEAPF32[i26 + 4 >> 2] = f8;
 HEAPF32[i26 + 8 >> 2] = f34;
 f34 = Math_fround(f5 - Math_fround(HEAPF32[i16 >> 2]));
 f8 = Math_fround(f6 - Math_fround(HEAPF32[i17 >> 2]));
 f38 = Math_fround(f4 - Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i21 >> 2] = f34;
 HEAPF32[i21 + 4 >> 2] = f8;
 HEAPF32[i21 + 8 >> 2] = f38;
 f38 = Math_fround(f5 - Math_fround(HEAPF32[i16 >> 2]));
 f8 = Math_fround(f6 - Math_fround(HEAPF32[i17 >> 2]));
 f34 = Math_fround(f4 - Math_fround(HEAPF32[i15 >> 2]));
 f35 = Math_fround(f5 - Math_fround(HEAPF32[i13 >> 2]));
 f36 = Math_fround(f6 - Math_fround(HEAPF32[i14 >> 2]));
 f37 = Math_fround(f4 - Math_fround(HEAPF32[i7 >> 2]));
 HEAP32[i32 >> 2] = i23;
 i17 = i32 + 4 | 0;
 HEAP32[i17 >> 2] = i23;
 i10 = i32 + 8 | 0;
 HEAPF32[i10 >> 2] = f38;
 i12 = i32 + 12 | 0;
 HEAPF32[i12 >> 2] = f8;
 i13 = i32 + 16 | 0;
 HEAPF32[i13 >> 2] = f34;
 i14 = i32 + 20 | 0;
 HEAPF32[i14 >> 2] = f35;
 i15 = i32 + 24 | 0;
 HEAPF32[i15 >> 2] = f36;
 i16 = i32 + 28 | 0;
 HEAPF32[i16 >> 2] = f37;
 __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i32, i27, i28, i26, i25 ? 7 : 6, 7);
 if (i25 | i24 ^ 1) {
  i31 = HEAP32[i17 >> 2] | 0;
  i32 = HEAP32[i32 >> 2] | 0;
  i32 = i31 - i32 | 0;
  i32 = (i32 | 0) / 80 | 0;
  STACKTOP = i33;
  return i32 | 0;
 }
 f4 = Math_fround(f20 * Math_fround(0.0));
 f8 = Math_fround(f11 * Math_fround(0.0));
 f5 = Math_fround(Math_fround(Math_fround(f19 * Math_fround(2.0)) + f4) + f8);
 f8 = Math_fround(Math_fround(f19 * f5) + Math_fround(Math_fround(f18 * Math_fround(2.0)) + Math_fround(f22 * Math_fround(f4 - f8))));
 f18 = Math_fround(f18 * Math_fround(0.0));
 f4 = Math_fround(f19 * Math_fround(0.0));
 f6 = Math_fround(Math_fround(f20 * f5) + Math_fround(f18 + Math_fround(f22 * Math_fround(Math_fround(f11 * Math_fround(2.0)) - f4))));
 f5 = Math_fround(Math_fround(f18 + Math_fround(f22 * Math_fround(f4 - Math_fround(f20 * Math_fround(2.0))))) + Math_fround(f11 * f5));
 f4 = Math_fround(HEAPF32[i31 + 92 >> 2]);
 f18 = Math_fround(HEAPF32[i31 + 84 >> 2]);
 i9 = f18 > Math_fround(0.0);
 f19 = Math_fround(HEAPF32[i31 + 80 >> 2]);
 i9 = i9 | f19 > Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i31 + 88 >> 2]);
 f11 = i9 ? Math_fround(0.0) : f11;
 if (Math_fround(f29 + f11) > f4) {
  f4 = Math_fround(f4 - f29);
  i3 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = i3 + 80;
  i1 = i3 + 78 | 0;
  HEAP16[i1 >> 1] = 0;
  HEAPF32[i3 >> 2] = f8;
  HEAPF32[i3 + 4 >> 2] = f6;
  HEAPF32[i3 + 8 >> 2] = f5;
  f38 = Math_fround(HEAPF32[i12 >> 2]);
  f37 = Math_fround(f5 * f38);
  f36 = Math_fround(HEAPF32[i13 >> 2]);
  f37 = Math_fround(f37 - Math_fround(f6 * f36));
  f36 = Math_fround(f8 * f36);
  f35 = Math_fround(HEAPF32[i10 >> 2]);
  f36 = Math_fround(f36 - Math_fround(f5 * f35));
  f38 = Math_fround(Math_fround(f6 * f35) - Math_fround(f8 * f38));
  HEAPF32[i3 + 16 >> 2] = f37;
  HEAPF32[i3 + 20 >> 2] = f36;
  HEAPF32[i3 + 24 >> 2] = f38;
  HEAPF32[i3 + 32 >> 2] = f8;
  HEAPF32[i3 + 36 >> 2] = f6;
  HEAPF32[i3 + 40 >> 2] = f5;
  f38 = Math_fround(HEAPF32[i15 >> 2]);
  f36 = Math_fround(f5 * f38);
  f37 = Math_fround(HEAPF32[i16 >> 2]);
  f36 = Math_fround(f36 - Math_fround(f6 * f37));
  f37 = Math_fround(f8 * f37);
  f35 = Math_fround(HEAPF32[i14 >> 2]);
  f37 = Math_fround(f37 - Math_fround(f5 * f35));
  f38 = Math_fround(Math_fround(f6 * f35) - Math_fround(f8 * f38));
  HEAPF32[i3 + 48 >> 2] = f36;
  HEAPF32[i3 + 52 >> 2] = f37;
  HEAPF32[i3 + 56 >> 2] = f38;
  HEAPF32[i3 + 12 >> 2] = f4;
  i7 = i3 + 76 | 0;
  i2 = HEAPU16[i7 >> 1] | 0;
  if (i9) {
   HEAPF32[i3 + 64 >> 2] = f19;
   HEAPF32[i3 + 68 >> 2] = f18;
   i1 = i2 | 17;
  } else {
   HEAP16[i1 >> 1] = 1025;
   i28 = HEAP32[i30 >> 2] | 0;
   HEAP32[i3 + 64 >> 2] = i28;
   HEAP32[i3 + 68 >> 2] = HEAP32[i31 + 76 >> 2];
   i1 = f4 > Math_fround(0.0);
   i1 = i2 | (i1 ? 24 : 16);
   if ((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
  }
  HEAP16[i7 >> 1] = i1;
  HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 }
 f8 = Math_fround(-f8);
 f6 = Math_fround(-f6);
 f5 = Math_fround(-f5);
 f4 = Math_fround(HEAPF32[i31 + 96 >> 2]);
 if (!(Math_fround(f11 - f29) > Math_fround(-f4))) {
  i31 = HEAP32[i17 >> 2] | 0;
  i32 = HEAP32[i32 >> 2] | 0;
  i32 = i31 - i32 | 0;
  i32 = (i32 | 0) / 80 | 0;
  STACKTOP = i33;
  return i32 | 0;
 }
 f4 = Math_fround(f29 - f4);
 i7 = HEAP32[i17 >> 2] | 0;
 HEAP32[i17 >> 2] = i7 + 80;
 i3 = i7 + 78 | 0;
 HEAP16[i3 >> 1] = 0;
 HEAPF32[i7 >> 2] = f8;
 HEAPF32[i7 + 4 >> 2] = f6;
 HEAPF32[i7 + 8 >> 2] = f5;
 f38 = Math_fround(HEAPF32[i12 >> 2]);
 f37 = Math_fround(f38 * f5);
 f36 = Math_fround(HEAPF32[i13 >> 2]);
 f37 = Math_fround(f37 - Math_fround(f36 * f6));
 f36 = Math_fround(f36 * f8);
 f35 = Math_fround(HEAPF32[i10 >> 2]);
 f36 = Math_fround(f36 - Math_fround(f35 * f5));
 f38 = Math_fround(Math_fround(f35 * f6) - Math_fround(f38 * f8));
 HEAPF32[i7 + 16 >> 2] = f37;
 HEAPF32[i7 + 20 >> 2] = f36;
 HEAPF32[i7 + 24 >> 2] = f38;
 HEAPF32[i7 + 32 >> 2] = f8;
 HEAPF32[i7 + 36 >> 2] = f6;
 HEAPF32[i7 + 40 >> 2] = f5;
 f38 = Math_fround(HEAPF32[i15 >> 2]);
 f36 = Math_fround(f38 * f5);
 f37 = Math_fround(HEAPF32[i16 >> 2]);
 f36 = Math_fround(f36 - Math_fround(f37 * f6));
 f37 = Math_fround(f37 * f8);
 f35 = Math_fround(HEAPF32[i14 >> 2]);
 f37 = Math_fround(f37 - Math_fround(f35 * f5));
 f38 = Math_fround(Math_fround(f35 * f6) - Math_fround(f38 * f8));
 HEAPF32[i7 + 48 >> 2] = f36;
 HEAPF32[i7 + 52 >> 2] = f37;
 HEAPF32[i7 + 56 >> 2] = f38;
 HEAPF32[i7 + 12 >> 2] = f4;
 i2 = i7 + 76 | 0;
 i1 = HEAPU16[i2 >> 1] | 0;
 if (i9) {
  HEAPF32[i7 + 64 >> 2] = f19;
  HEAPF32[i7 + 68 >> 2] = f18;
  i1 = i1 | 17;
 } else {
  HEAP16[i3 >> 1] = 1025;
  i30 = HEAP32[i30 >> 2] | 0;
  HEAP32[i7 + 64 >> 2] = i30;
  HEAP32[i7 + 68 >> 2] = HEAP32[i31 + 76 >> 2];
  i31 = f4 > Math_fround(0.0);
  i1 = i1 | (i31 ? 24 : 16);
  if ((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
 }
 HEAP16[i2 >> 1] = i1;
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 i31 = HEAP32[i17 >> 2] | 0;
 i32 = HEAP32[i32 >> 2] | 0;
 i32 = i31 - i32 | 0;
 i32 = (i32 | 0) / 80 | 0;
 STACKTOP = i33;
 return i32 | 0;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i30, i25, i7) {
 i30 = i30 | 0;
 i25 = i25 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i32 + 208 | 0;
 i29 = i32 + 192 | 0;
 i28 = i32 + 80 | 0;
 i27 = i32;
 i31 = i32 + 160 | 0;
 i26 = i30 + 32 | 0;
 HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
 HEAP32[i31 >> 2] = 0;
 i2 = i31 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i22 = i31 + 24 | 0;
 i5 = gb + 63648 | 0;
 i8 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i22;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 i4 = i31 + 4 | 0;
 HEAP8[i4 >> 0] = 0;
 i8 = _strlen(i25) | 0;
 i5 = i8 >>> 0 > 15;
 i23 = i31 + 4 | 0;
 if (i5) {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 + 1 | 0, 16, i22, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i31 >> 2] = i1;
  HEAP32[i23 >> 2] = i8;
  i1 = (i1 | 0) == 0 ? i4 : i1;
 } else i1 = i4;
 _memcpy(i1 | 0, i25 | 0, i8 | 0) | 0;
 HEAP8[i1 + i8 >> 0] = 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i27 >> 2] = 0;
 i6 = i27 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 i21 = i27 + 24 | 0;
 i19 = i22;
 i2 = HEAP32[i19 + 4 >> 2] | 0;
 i10 = i21;
 HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i10 + 4 >> 2] = i2;
 i10 = i27 + 4 | 0;
 HEAP8[i10 >> 0] = 0;
 i2 = HEAP32[i31 >> 2] | 0;
 i19 = (i2 | 0) == 0;
 i2 = i19 ? i4 : i2;
 i20 = i27 + 4 | 0;
 if ((HEAP32[i23 >> 2] | 0) != 0 | i19) {
  if (i5) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 + 1 | 0, 16, i21, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i27 >> 2] = i1;
   HEAP32[i20 >> 2] = i8;
   i1 = (i1 | 0) == 0 ? i10 : i1;
  } else i1 = i10;
  _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  HEAP32[i6 >> 2] = i8;
 } else {
  HEAP32[i27 >> 2] = i2;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i20 >> 2] = 0;
 }
 i11 = i27 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i18 = i27 + 48 | 0;
 HEAP32[i18 >> 2] = 0;
 i9 = i27 + 68 | 0;
 HEAP32[i9 >> 2] = 0;
 i19 = i27 + 72 | 0;
 i16 = i7 + 40 | 0;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i12 = i19;
 HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i12 + 4 >> 2] = i17;
 i12 = i27 + 52 | 0;
 HEAP8[i12 >> 0] = 0;
 do if ((i11 | 0) == (i7 | 0)) {
  i5 = i8;
  i1 = 0;
 } else {
  i2 = HEAP32[i7 + 16 >> 2] | 0;
  i17 = (i2 | 0) == 0;
  i2 = i17 ? i7 + 20 | 0 : i2;
  i4 = HEAP32[i7 + 36 >> 2] | 0;
  i1 = i27 + 52 | 0;
  if (!((HEAP32[i7 + 20 >> 2] | 0) != 0 | i17)) {
   HEAP32[i18 >> 2] = i2;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i1 >> 2] = 0;
   i5 = i8;
   i1 = i4;
   break;
  }
  if (i4 >>> 0 > 15) {
   i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i19, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i18 >> 2] = i17;
   HEAP32[i1 >> 2] = i4;
   i1 = (i17 | 0) == 0 ? i12 : i17;
  } else i1 = i12;
  _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i9 >> 2] = i4;
  i5 = HEAP32[i6 >> 2] | 0;
  i1 = i4;
 } while (0);
 HEAP32[i28 >> 2] = 0;
 i6 = i28 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 i17 = i28 + 24 | 0;
 i15 = i21;
 i2 = HEAP32[i15 + 4 >> 2] | 0;
 i7 = i17;
 HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 i7 = i28 + 4 | 0;
 HEAP8[i7 >> 0] = 0;
 i2 = HEAP32[i27 >> 2] | 0;
 i15 = (i2 | 0) == 0;
 i2 = i15 ? i10 : i2;
 i16 = i28 + 4 | 0;
 if ((HEAP32[i20 >> 2] | 0) != 0 | i15) {
  if (i5 >>> 0 > 15) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i17, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i16 >> 2] = i5;
   i1 = (i1 | 0) == 0 ? i7 : i1;
  } else i1 = i7;
  _memcpy(i1 | 0, i2 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i6 >> 2] = i5;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i28 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i16 >> 2] = 0;
 }
 i13 = i28 + 32 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i13 = i28 + 48 | 0;
 HEAP32[i13 >> 2] = 0;
 i5 = i28 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 i14 = i28 + 72 | 0;
 i4 = i19;
 i15 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i14;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i15;
 i2 = i28 + 52 | 0;
 HEAP8[i2 >> 0] = 0;
 i15 = i27 + 52 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i11 = (i4 | 0) == 0;
 i4 = i11 ? i12 : i4;
 i12 = i28 + 52 | 0;
 if ((HEAP32[i15 >> 2] | 0) != 0 | i11) {
  if (i1 >>> 0 > 15) {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + 1 | 0, 16, i14, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i12 >> 2] = i1;
   i2 = (i11 | 0) == 0 ? i2 : i11;
  }
  _memcpy(i2 | 0, i4 | 0, i1 | 0) | 0;
  HEAP8[i2 + i1 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
 } else {
  HEAP32[i13 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i12 >> 2] = 0;
 }
 i2 = i30 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i29 >> 2] = i2;
  i5 = i2;
  i4 = i2;
 } else {
  i11 = HEAP32[i6 >> 2] | 0;
  i10 = HEAP32[i28 >> 2] | 0;
  i10 = (i10 | 0) == 0 ? i7 : i10;
  while (1) {
   i8 = HEAP32[i1 + 16 >> 2] | 0;
   i9 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = i11 >>> 0 > i9 >>> 0 ? i9 : i11;
   L39 : do if (!i2) i24 = 28; else {
    i4 = (i8 | 0) == 0 ? i1 + 20 | 0 : i8;
    i5 = i10;
    while (1) {
     i6 = HEAP8[i5 >> 0] | 0;
     i7 = HEAP8[i4 >> 0] | 0;
     if (i6 << 24 >> 24 != i7 << 24 >> 24) break;
     i2 = i2 + -1 | 0;
     if (!i2) {
      i24 = 28;
      break L39;
     } else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 1 | 0;
     }
    }
    i2 = (i6 & 255) - (i7 & 255) | 0;
   } while (0);
   if ((i24 | 0) == 28) {
    i24 = 0;
    i2 = i11 - i9 | 0;
   }
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i24 = 34;
     break;
    } else i1 = i2;
   } else {
    i2 = i9 >>> 0 > i11 >>> 0 ? i11 : i9;
    L51 : do if (!i2) i24 = 37; else {
     i7 = i10;
     i4 = (i8 | 0) == 0 ? i1 + 20 | 0 : i8;
     while (1) {
      i5 = HEAP8[i4 >> 0] | 0;
      i6 = HEAP8[i7 >> 0] | 0;
      if (i5 << 24 >> 24 != i6 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i24 = 37;
       break L51;
      } else {
       i7 = i7 + 1 | 0;
       i4 = i4 + 1 | 0;
      }
     }
     i2 = (i5 & 255) - (i6 & 255) | 0;
    } while (0);
    if ((i24 | 0) == 37) {
     i24 = 0;
     i2 = i9 - i11 | 0;
    }
    if ((i2 | 0) >= 0) {
     i24 = 45;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i24 = 44;
     break;
    } else i1 = i2;
   }
  }
  if ((i24 | 0) == 34) {
   HEAP32[i29 >> 2] = i1;
   i5 = i1;
   i4 = i1;
   break;
  } else if ((i24 | 0) == 44) {
   HEAP32[i29 >> 2] = i1;
   i5 = i1;
   break;
  } else if ((i24 | 0) == 45) {
   HEAP32[i29 >> 2] = i1;
   i5 = i1;
   i4 = i29;
   break;
  }
 } while (0);
 if (!(HEAP32[i4 >> 2] | 0)) {
  i1 = HEAP32[i30 + 8 >> 2] | 0;
  HEAP32[i3 >> 2] = 5;
  HEAP32[i3 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEC2ERKSB_(i1 + 16 | 0, i28);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i30 >> 2] = i2;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i30 + 4 >> 2] | 0, i1);
  i24 = i30 + 12 | 0;
  HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i12 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 i1 = HEAP32[i28 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i16 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i15 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
 i1 = HEAP32[i27 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i20 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
 i1 = HEAP32[i31 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i23 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
 i16 = i30 + 16 | 0;
 HEAP32[i31 >> 2] = 0;
 i2 = i31 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i17 = i31 + 24 | 0;
 i9 = gb + 63648 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i17;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 i5 = i31 + 4 | 0;
 HEAP8[i5 >> 0] = 0;
 i10 = _strlen(i25) | 0;
 i9 = i10 >>> 0 > 15;
 i18 = i31 + 4 | 0;
 if (i9) {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 + 1 | 0, 16, i17, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i31 >> 2] = i1;
  HEAP32[i18 >> 2] = i10;
  i1 = (i1 | 0) == 0 ? i5 : i1;
 } else i1 = i5;
 _memcpy(i1 | 0, i25 | 0, i10 | 0) | 0;
 HEAP8[i1 + i10 >> 0] = 0;
 HEAP32[i2 >> 2] = i10;
 i1 = HEAP32[i26 >> 2] | 0;
 HEAP32[i27 >> 2] = i1;
 i13 = i27 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i2 = i27 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 i15 = i27 + 28 | 0;
 i6 = i17;
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i15;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i8 + 4 >> 2] = i6;
 i8 = i27 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i14 = HEAP32[i31 >> 2] | 0;
 i26 = (i14 | 0) == 0;
 i5 = i26 ? i5 : i14;
 i14 = i27 + 8 | 0;
 if ((HEAP32[i18 >> 2] | 0) != 0 | i26) {
  if (i9) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 + 1 | 0, 16, i15, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = i10;
   i1 = (i1 | 0) == 0 ? i8 : i1;
  } else i1 = i8;
  _memcpy(i1 | 0, i5 | 0, i10 | 0) | 0;
  HEAP8[i1 + i10 >> 0] = 0;
  HEAP32[i2 >> 2] = i10;
  i6 = i15;
  i1 = HEAP32[i27 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i7 = (HEAP32[i14 >> 2] | 0) != 0;
 } else {
  HEAP32[i13 >> 2] = i5;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i14 >> 2] = 0;
  i2 = i5;
  i7 = 0;
 }
 HEAP32[i28 >> 2] = i1;
 i11 = i28 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i5 = i28 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 i12 = i28 + 28 | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i28 + 8 | 0;
 HEAP8[i1 >> 0] = 0;
 i27 = (i2 | 0) == 0;
 i2 = i27 ? i8 : i2;
 i6 = i28 + 8 | 0;
 if (i7 | i27) {
  if (i9) {
   i27 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 + 1 | 0, 16, i12, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i11 >> 2] = i27;
   HEAP32[i6 >> 2] = i10;
   i1 = (i27 | 0) == 0 ? i1 : i27;
  }
  _memcpy(i1 | 0, i2 | 0, i10 | 0) | 0;
  HEAP8[i1 + i10 >> 0] = 0;
  HEAP32[i5 >> 2] = i10;
 } else {
  HEAP32[i11 >> 2] = i2;
  HEAP32[i5 >> 2] = i10;
  HEAP32[i6 >> 2] = 0;
 }
 i2 = i30 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  i5 = HEAP32[i28 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i24 = 77;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i24 = 82;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i24 = 81;
     break;
    } else i1 = i2;
   }
  }
  if ((i24 | 0) == 77) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i24 | 0) == 81) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i24 | 0) == 82) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIKjS6_EE(i29, i16, i28);
  i1 = HEAP32[i29 >> 2] | 0;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i16 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i30 + 20 >> 2] | 0, i1);
  i30 = i30 + 28 | 0;
  HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i6 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i14 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 i1 = HEAP32[i31 >> 2] | 0;
 if ((i1 | 0) == 0 | (HEAP32[i18 >> 2] | 0) == 0) {
  STACKTOP = i32;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
 STACKTOP = i32;
 return;
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERiPjPfPNS_5ArrayIiEERKNS_4AABBE(i4, i57, i62, i5, i63, i3) {
 i4 = i4 | 0;
 i57 = i57 | 0;
 i62 = i62 | 0;
 i5 = i5 | 0;
 i63 = i63 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, f68 = f0, f69 = f0, f70 = f0;
 i67 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i64 = i67 + 72 | 0;
 i65 = i67 + 64 | 0;
 i1 = i67 + 60 | 0;
 i66 = i67 + 24 | 0;
 i58 = i67 + 48 | 0;
 i59 = i67 + 12 | 0;
 i60 = i67;
 HEAP32[i65 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_(i4, 0, i65, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i65 >> 2] | 0;
 i6 = i2 + 1 | 0;
 i61 = (i6 | 0) / 2 | 0;
 if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
  i1 = gb + 1451688 | 0;
 } else i1 = gb + 1451688 | 0;
 i55 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i61 * 28 | 0) + 16 | 0, 0) | 0;
 if (!i55) {
  i66 = 0;
  STACKTOP = i67;
  return i66 | 0;
 }
 HEAP32[i55 >> 2] = i61;
 i56 = i55 + 16 | 0;
 if ((i2 | 0) > 0) {
  i2 = 0;
  do {
   HEAPF32[i56 + (i2 * 28 | 0) + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i56 + (i2 * 28 | 0) + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i56 + (i2 * 28 | 0) + 12 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i56 + (i2 * 28 | 0) + 16 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i56 + (i2 * 28 | 0) + 20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i56 + (i2 * 28 | 0) + 24 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i61 | 0));
 }
 i38 = HEAP32[i3 >> 2] | 0;
 i33 = HEAP32[i3 + 4 >> 2] | 0;
 i37 = HEAP32[i3 + 8 >> 2] | 0;
 i36 = HEAP32[i3 + 12 >> 2] | 0;
 i35 = HEAP32[i3 + 16 >> 2] | 0;
 i34 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i56 >> 2] = 0;
 HEAP32[i55 + 20 >> 2] = i38;
 HEAP32[i55 + 24 >> 2] = i33;
 HEAP32[i55 + 28 >> 2] = i37;
 HEAP32[i55 + 32 >> 2] = i36;
 HEAP32[i55 + 36 >> 2] = i35;
 HEAP32[i55 + 40 >> 2] = i34;
 i34 = i4 + 8 | 0;
 i35 = (i63 | 0) == 0;
 i36 = i63 + 12 | 0;
 i37 = i63 + 8 | 0;
 i33 = i63 + 4 | 0;
 i38 = i64 + 4 | 0;
 i39 = i64 + 8 | 0;
 i40 = i64 + 12 | 0;
 i41 = i64 + 16 | 0;
 i42 = i64 + 20 | 0;
 i43 = i66 + 4 | 0;
 i44 = i66 + 8 | 0;
 i45 = i66 + 12 | 0;
 i46 = i66 + 16 | 0;
 i47 = i66 + 20 | 0;
 i48 = i58 + 4 | 0;
 i49 = i58 + 8 | 0;
 i50 = i64 + 12 | 0;
 i51 = i59 + 4 | 0;
 i52 = i59 + 8 | 0;
 i53 = i60 + 4 | 0;
 i54 = i60 + 8 | 0;
 i21 = i4 + 24 | 0;
 i22 = i64 + 4 | 0;
 i23 = i64 + 8 | 0;
 i24 = i64 + 12 | 0;
 i25 = i64 + 16 | 0;
 i26 = i64 + 20 | 0;
 i27 = i66 + 4 | 0;
 i28 = i66 + 8 | 0;
 i29 = i66 + 12 | 0;
 i30 = i66 + 16 | 0;
 i31 = i66 + 20 | 0;
 i32 = i64 + 12 | 0;
 i19 = 0;
 i20 = 0;
 i3 = (i6 & -2 | 0) != 2 & 1;
 i2 = 1;
 do {
  i12 = i20 + 1 | 0;
  i11 = i2 + -1 | 0;
  i18 = i20;
  i20 = (i12 | 0) == (i61 | 0) ? 0 : i12;
  i12 = HEAP32[i56 + (i18 * 28 | 0) >> 2] | 0;
  i13 = HEAP32[i56 + (i18 * 28 | 0) + 4 >> 2] | 0;
  i14 = HEAP32[i56 + (i18 * 28 | 0) + 8 >> 2] | 0;
  i15 = HEAP32[i56 + (i18 * 28 | 0) + 12 >> 2] | 0;
  i16 = HEAP32[i56 + (i18 * 28 | 0) + 16 >> 2] | 0;
  i17 = HEAP32[i56 + (i18 * 28 | 0) + 20 >> 2] | 0;
  i18 = HEAP32[i56 + (i18 * 28 | 0) + 24 >> 2] | 0;
  i4 = HEAP32[i34 >> 2] | 0;
  switch (HEAP32[i4 + (i12 << 3) >> 2] & 3) {
  case 2:
   {
    do if (!i35) {
     i8 = HEAP32[i4 + (i12 << 3) + 4 >> 2] | 0;
     i9 = HEAP32[i36 >> 2] | 0;
     i10 = i9 + 1 | 0;
     if ((HEAP32[i37 >> 2] | 0) > (i9 | 0)) i2 = HEAP32[i33 >> 2] | 0; else {
      i4 = i10 << 1;
      i4 = (i4 | 0) > 16 ? i4 : 16;
      i2 = HEAP32[i63 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, (i4 << 2) + 16 | 0, 0) | 0;
      if (!i2) break;
      HEAP32[i2 >> 2] = i4;
      i2 = i2 + 16 | 0;
      HEAP32[i37 >> 2] = i4;
      i7 = HEAP32[i33 >> 2] | 0;
      if (i7 | 0) {
       i4 = HEAP32[i36 >> 2] | 0;
       if (i4 | 0) {
        i6 = (i4 | 0) <= (i10 | 0) ? i4 : i10;
        if ((i6 | 0) > 0) {
         i4 = 0;
         do {
          HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[i7 + (i4 << 2) >> 2];
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i6 | 0));
        }
       }
       i18 = HEAP32[i63 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i7 + -16 | 0);
      }
      HEAP32[i33 >> 2] = i2;
     }
     HEAP32[i36 >> 2] = i10;
     HEAP32[i2 + (i9 << 2) >> 2] = i8;
    } while (0);
    i18 = 3 << (i19 << 1 & 30);
    i2 = i62 + (i19 >> 4 << 2) | 0;
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~i18 | i18;
    HEAPF32[i5 >> 2] = Math_fround(0.0);
    i5 = i5 + 4 | 0;
    i2 = i11;
    break;
   }
  case 1:
   {
    do if (!i35) {
     i9 = HEAP32[i4 + (i12 << 3) + 4 >> 2] | 0;
     i10 = HEAP32[i36 >> 2] | 0;
     i11 = i10 + 1 | 0;
     if ((HEAP32[i37 >> 2] | 0) > (i10 | 0)) i4 = HEAP32[i33 >> 2] | 0; else {
      i6 = i11 << 1;
      i6 = (i6 | 0) > 16 ? i6 : 16;
      i4 = HEAP32[i63 >> 2] | 0;
      i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, (i6 << 2) + 16 | 0, 0) | 0;
      if (!i4) break;
      HEAP32[i4 >> 2] = i6;
      i4 = i4 + 16 | 0;
      HEAP32[i37 >> 2] = i6;
      i8 = HEAP32[i33 >> 2] | 0;
      if (i8 | 0) {
       i6 = HEAP32[i36 >> 2] | 0;
       if (i6 | 0) {
        i7 = (i6 | 0) <= (i11 | 0) ? i6 : i11;
        if ((i7 | 0) > 0) {
         i6 = 0;
         do {
          HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i8 + (i6 << 2) >> 2];
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i7 | 0));
        }
       }
       i7 = HEAP32[i63 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i8 + -16 | 0);
      }
      HEAP32[i33 >> 2] = i4;
     }
     HEAP32[i36 >> 2] = i11;
     HEAP32[i4 + (i10 << 2) >> 2] = i9;
    } while (0);
    i10 = (HEAP32[i34 >> 2] | 0) + (i12 << 3) | 0;
    i11 = (HEAP32[i10 >> 2] | 0) >>> 2 & 3;
    i8 = i19 << 1 & 30;
    i9 = i62 + (i19 >> 4 << 2) | 0;
    HEAP32[i9 >> 2] = i11 << i8 | HEAP32[i9 >> 2] & ~(3 << i8);
    i9 = i12 + 1 | 0;
    i10 = ((HEAP32[i10 >> 2] | 0) >>> 4) + i9 | 0;
    HEAP32[i64 >> 2] = i13;
    HEAP32[i38 >> 2] = i14;
    HEAP32[i39 >> 2] = i15;
    HEAP32[i40 >> 2] = i16;
    HEAP32[i41 >> 2] = i17;
    HEAP32[i42 >> 2] = i18;
    HEAP32[i66 >> 2] = i13;
    HEAP32[i43 >> 2] = i14;
    HEAP32[i44 >> 2] = i15;
    HEAP32[i45 >> 2] = i16;
    HEAP32[i46 >> 2] = i17;
    HEAP32[i47 >> 2] = i18;
    f70 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) + (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
    f69 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) + (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
    f68 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
    HEAPF32[i58 >> 2] = f70;
    HEAPF32[i48 >> 2] = f69;
    HEAPF32[i49 >> 2] = f68;
    HEAP32[i50 + (i11 << 2) >> 2] = HEAP32[i58 + (i11 << 2) >> 2];
    HEAPF32[i59 >> 2] = f70;
    HEAPF32[i51 >> 2] = f69;
    HEAPF32[i52 >> 2] = f68;
    HEAP32[i66 + (i11 << 2) >> 2] = HEAP32[i59 + (i11 << 2) >> 2];
    i17 = HEAP32[i40 >> 2] | 0;
    i16 = HEAP32[i41 >> 2] | 0;
    i12 = HEAP32[i42 >> 2] | 0;
    i18 = i3 + 1 | 0;
    HEAP32[i56 + (i3 * 28 | 0) >> 2] = i9;
    HEAP32[i56 + (i3 * 28 | 0) + 4 >> 2] = i13;
    HEAP32[i56 + (i3 * 28 | 0) + 8 >> 2] = i14;
    HEAP32[i56 + (i3 * 28 | 0) + 12 >> 2] = i15;
    HEAP32[i56 + (i3 * 28 | 0) + 16 >> 2] = i17;
    HEAP32[i56 + (i3 * 28 | 0) + 20 >> 2] = i16;
    HEAP32[i56 + (i3 * 28 | 0) + 24 >> 2] = i12;
    i18 = (i18 | 0) == (i61 | 0) ? 0 : i18;
    i12 = HEAP32[i66 >> 2] | 0;
    i13 = HEAP32[i43 >> 2] | 0;
    i14 = HEAP32[i44 >> 2] | 0;
    i15 = HEAP32[i45 >> 2] | 0;
    i16 = HEAP32[i46 >> 2] | 0;
    i17 = HEAP32[i47 >> 2] | 0;
    i3 = i18 + 1 | 0;
    HEAP32[i56 + (i18 * 28 | 0) >> 2] = i10;
    HEAP32[i56 + (i18 * 28 | 0) + 4 >> 2] = i12;
    HEAP32[i56 + (i18 * 28 | 0) + 8 >> 2] = i13;
    HEAP32[i56 + (i18 * 28 | 0) + 12 >> 2] = i14;
    HEAP32[i56 + (i18 * 28 | 0) + 16 >> 2] = i15;
    HEAP32[i56 + (i18 * 28 | 0) + 20 >> 2] = i16;
    HEAP32[i56 + (i18 * 28 | 0) + 24 >> 2] = i17;
    HEAPF32[i60 >> 2] = f70;
    HEAPF32[i53 >> 2] = f69;
    HEAPF32[i54 >> 2] = f68;
    HEAP32[i5 >> 2] = HEAP32[i60 + (i11 << 2) >> 2];
    i5 = i5 + 4 | 0;
    i3 = (i3 | 0) == (i61 | 0) ? 0 : i3;
    i2 = i2 + 1 | 0;
    break;
   }
  case 0:
   {
    do if (!i35) {
     i9 = HEAP32[i4 + (i12 << 3) + 4 >> 2] | 0;
     i10 = HEAP32[i36 >> 2] | 0;
     i11 = i10 + 1 | 0;
     if ((HEAP32[i37 >> 2] | 0) > (i10 | 0)) i4 = HEAP32[i33 >> 2] | 0; else {
      i6 = i11 << 1;
      i6 = (i6 | 0) > 16 ? i6 : 16;
      i4 = HEAP32[i63 >> 2] | 0;
      i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, (i6 << 2) + 16 | 0, 0) | 0;
      if (!i4) break;
      HEAP32[i4 >> 2] = i6;
      i4 = i4 + 16 | 0;
      HEAP32[i37 >> 2] = i6;
      i8 = HEAP32[i33 >> 2] | 0;
      if (i8 | 0) {
       i6 = HEAP32[i36 >> 2] | 0;
       if (i6 | 0) {
        i7 = (i6 | 0) <= (i11 | 0) ? i6 : i11;
        if ((i7 | 0) > 0) {
         i6 = 0;
         do {
          HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i8 + (i6 << 2) >> 2];
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) != (i7 | 0));
        }
       }
       i7 = HEAP32[i63 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i8 + -16 | 0);
      }
      HEAP32[i33 >> 2] = i4;
     }
     HEAP32[i36 >> 2] = i11;
     HEAP32[i4 + (i10 << 2) >> 2] = i9;
    } while (0);
    i8 = (HEAP32[i34 >> 2] | 0) + (i12 << 3) | 0;
    i7 = HEAP32[i21 >> 2] | 0;
    i11 = HEAP32[i7 + ((HEAP32[i8 >> 2] | 0) >>> 2 << 3) >> 2] & 3;
    i10 = i19 << 1 & 30;
    i9 = i62 + (i19 >> 4 << 2) | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(3 << i10) | i11 << i10;
    i9 = i12 + 1 | 0;
    i8 = (HEAP32[i8 >> 2] | 0) >>> 2;
    i10 = ((HEAP32[i7 + (i8 << 3) >> 2] | 0) >>> 2) + i9 | 0;
    HEAP32[i64 >> 2] = i13;
    HEAP32[i22 >> 2] = i14;
    HEAP32[i23 >> 2] = i15;
    HEAP32[i24 >> 2] = i16;
    HEAP32[i25 >> 2] = i17;
    HEAP32[i26 >> 2] = i18;
    HEAP32[i66 >> 2] = i13;
    HEAP32[i27 >> 2] = i14;
    HEAP32[i28 >> 2] = i15;
    HEAP32[i29 >> 2] = i16;
    HEAP32[i30 >> 2] = i17;
    HEAP32[i31 >> 2] = i18;
    i17 = HEAP32[i7 + (i8 << 3) + 4 >> 2] | 0;
    HEAP32[i32 + (i11 << 2) >> 2] = i17;
    HEAP32[i66 + (i11 << 2) >> 2] = i17;
    i17 = HEAP32[i24 >> 2] | 0;
    i16 = HEAP32[i25 >> 2] | 0;
    i11 = HEAP32[i26 >> 2] | 0;
    i18 = i3 + 1 | 0;
    HEAP32[i56 + (i3 * 28 | 0) >> 2] = i9;
    HEAP32[i56 + (i3 * 28 | 0) + 4 >> 2] = i13;
    HEAP32[i56 + (i3 * 28 | 0) + 8 >> 2] = i14;
    HEAP32[i56 + (i3 * 28 | 0) + 12 >> 2] = i15;
    HEAP32[i56 + (i3 * 28 | 0) + 16 >> 2] = i17;
    HEAP32[i56 + (i3 * 28 | 0) + 20 >> 2] = i16;
    HEAP32[i56 + (i3 * 28 | 0) + 24 >> 2] = i11;
    i18 = (i18 | 0) == (i61 | 0) ? 0 : i18;
    i11 = HEAP32[i66 >> 2] | 0;
    i13 = HEAP32[i27 >> 2] | 0;
    i14 = HEAP32[i28 >> 2] | 0;
    i15 = HEAP32[i29 >> 2] | 0;
    i16 = HEAP32[i30 >> 2] | 0;
    i17 = HEAP32[i31 >> 2] | 0;
    i3 = i18 + 1 | 0;
    HEAP32[i56 + (i18 * 28 | 0) >> 2] = i10;
    HEAP32[i56 + (i18 * 28 | 0) + 4 >> 2] = i11;
    HEAP32[i56 + (i18 * 28 | 0) + 8 >> 2] = i13;
    HEAP32[i56 + (i18 * 28 | 0) + 12 >> 2] = i14;
    HEAP32[i56 + (i18 * 28 | 0) + 16 >> 2] = i15;
    HEAP32[i56 + (i18 * 28 | 0) + 20 >> 2] = i16;
    HEAP32[i56 + (i18 * 28 | 0) + 24 >> 2] = i17;
    HEAP32[i5 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + ((HEAP32[(HEAP32[i34 >> 2] | 0) + (i12 << 3) >> 2] | 0) >>> 2 << 3) + 4 >> 2];
    i5 = i5 + 4 | 0;
    i3 = (i3 | 0) == (i61 | 0) ? 0 : i3;
    i2 = i2 + 1 | 0;
    break;
   }
  default:
   i2 = i11;
  }
  i19 = i19 + 1 | 0;
 } while ((i2 | 0) != 0);
 HEAP32[i57 >> 2] = i19;
 i66 = HEAP32[i65 >> 2] | 0;
 HEAP32[i64 >> 2] = i62 + ((i66 << 1) + 31 >> 5 << 2);
 HEAP32[i64 + 4 >> 2] = i66;
 __ZN5Umbra9KDRankLUT9constructEPKj(i64, i62);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i55 | 0);
 i66 = 1;
 STACKTOP = i67;
 return i66 | 0;
}

function __ZN5physx31PxClothGeodesicTetherCookerImpl16findTriNeighborsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i27 + 60 | 0;
 i22 = i27;
 i1 = i27 + 72 | 0;
 i19 = i27 + 48 | 0;
 i8 = i27 + 44 | 0;
 i16 = i27 + 32 | 0;
 i17 = i27 + 20 | 0;
 i18 = i27 + 8 | 0;
 HEAP32[i19 >> 2] = 0;
 i21 = i19 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i26 = i19 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 i24 = i2 + 68 | 0;
 i23 = i2 + 20 | 0;
 i15 = i2 + 24 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i8 >> 2] = -1;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i24, i14, i8);
 i15 = HEAP32[i15 >> 2] | 0;
 i8 = (i15 >>> 0) / 3 | 0;
 if (i15 >>> 0 > 2) {
  i9 = i16 + 4 | 0;
  i10 = i16 + 8 | 0;
  i11 = i17 + 4 | 0;
  i12 = i17 + 8 | 0;
  i13 = i18 + 4 | 0;
  i14 = i18 + 8 | 0;
  i15 = 0;
  do {
   i4 = i15 * 3 | 0;
   i7 = HEAP32[i23 >> 2] | 0;
   i5 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
   i2 = i4 + 1 | 0;
   i3 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
   i6 = i4 + 2 | 0;
   i7 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
   HEAP32[i16 >> 2] = i5;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i10 >> 2] = i4;
   if ((i5 | 0) > (i3 | 0)) {
    HEAP32[i16 >> 2] = i3;
    HEAP32[i9 >> 2] = i5;
   }
   i4 = HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    i28 = (HEAP32[i19 >> 2] | 0) + (i4 * 12 | 0) | 0;
    HEAP32[i28 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i28 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i28 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAP32[i21 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i19, i16) | 0;
   HEAP32[i17 >> 2] = i3;
   HEAP32[i11 >> 2] = i7;
   HEAP32[i12 >> 2] = i2;
   if ((i3 | 0) > (i7 | 0)) {
    HEAP32[i17 >> 2] = i7;
    HEAP32[i11 >> 2] = i3;
   }
   i2 = HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = (HEAP32[i19 >> 2] | 0) + (i2 * 12 | 0) | 0;
    HEAP32[i28 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i28 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i28 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i21 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i19, i17) | 0;
   HEAP32[i18 >> 2] = i7;
   HEAP32[i13 >> 2] = i5;
   HEAP32[i14 >> 2] = i6;
   if ((i7 | 0) > (i5 | 0)) {
    HEAP32[i18 >> 2] = i5;
    HEAP32[i13 >> 2] = i7;
   }
   i2 = HEAP32[i21 >> 2] | 0;
   if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = (HEAP32[i19 >> 2] | 0) + (i2 * 12 | 0) | 0;
    HEAP32[i28 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i28 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i28 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i21 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i19, i18) | 0;
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < i8 >>> 0);
  i17 = HEAP32[i19 >> 2] | 0;
  i18 = i17;
  i2 = HEAP32[i21 >> 2] | 0;
 } else {
  i18 = 0;
  i2 = 0;
  i17 = 0;
 }
 i16 = i22 + 4 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i22 >> 2] = i1;
 i3 = i2 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i15 = 32;
  i5 = 0;
  i4 = 0;
  L30 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i14 = i4;
      break;
     }
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i19 = HEAP32[i17 + (i6 * 12 | 0) >> 2] | 0;
       i28 = HEAP32[i17 + (i5 * 12 | 0) >> 2] | 0;
       i5 = ((i19 | 0) == (i28 | 0) ? (HEAP32[i17 + (i6 * 12 | 0) + 4 >> 2] | 0) < (HEAP32[i17 + (i5 * 12 | 0) + 4 >> 2] | 0) : (i19 | 0) < (i28 | 0)) ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i19 = i17 + (i5 * 12 | 0) | 0;
       i28 = i17 + (i7 * 12 | 0) | 0;
       HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
       HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
       HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
       HEAP32[i19 >> 2] = HEAP32[i28 >> 2];
       HEAP32[i19 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
       HEAP32[i19 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
       HEAP32[i28 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i28 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
       HEAP32[i28 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L30;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = i8 + -2 | 0;
    i8 = i4;
    i4 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   }
   i13 = (i3 + i14 | 0) / 2 | 0;
   i4 = i17 + (i13 * 12 | 0) | 0;
   i12 = i17 + (i14 * 12 | 0) | 0;
   i28 = HEAP32[i4 >> 2] | 0;
   i13 = i17 + (i13 * 12 | 0) + 4 | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i6 = i17 + (i14 * 12 | 0) + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i28 | 0) == (i5 | 0) ? (HEAP32[i13 >> 2] | 0) < (i7 | 0) : (i28 | 0) < (i5 | 0)) {
    HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i10 = HEAP32[i12 >> 2] | 0;
    i7 = HEAP32[i6 >> 2] | 0;
   } else i10 = i5;
   i11 = i17 + (i3 * 12 | 0) | 0;
   i6 = HEAP32[i11 >> 2] | 0;
   i9 = i17 + (i3 * 12 | 0) + 4 | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   if ((i6 | 0) == (i10 | 0) ? (i5 | 0) < (i7 | 0) : (i6 | 0) < (i10 | 0)) {
    HEAP32[i20 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i6 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
   }
   i28 = HEAP32[i4 >> 2] | 0;
   if ((i6 | 0) == (i28 | 0) ? (i5 | 0) < (HEAP32[i13 >> 2] | 0) : (i6 | 0) < (i28 | 0)) {
    HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   }
   i6 = i3 + -1 | 0;
   i13 = i17 + (i6 * 12 | 0) | 0;
   HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   i12 = i17 + (i6 * 12 | 0) + 4 | 0;
   i5 = i14;
   while (1) {
    i9 = HEAP32[i13 >> 2] | 0;
    i10 = HEAP32[i12 >> 2] | 0;
    i7 = i5;
    while (1) {
     i5 = i7 + 1 | 0;
     i4 = i17 + (i5 * 12 | 0) | 0;
     i28 = HEAP32[i4 >> 2] | 0;
     if ((i28 | 0) == (i9 | 0) ? (HEAP32[i17 + (i5 * 12 | 0) + 4 >> 2] | 0) < (i10 | 0) : (i28 | 0) < (i9 | 0)) i7 = i5; else {
      i11 = i7;
      break;
     }
    }
    while (1) {
     i7 = i6 + -1 | 0;
     i6 = i17 + (i7 * 12 | 0) | 0;
     i28 = HEAP32[i6 >> 2] | 0;
     if ((i9 | 0) == (i28 | 0) ? (i10 | 0) < (HEAP32[i17 + (i7 * 12 | 0) + 4 >> 2] | 0) : (i9 | 0) < (i28 | 0)) i6 = i7; else break;
    }
    if ((i5 | 0) >= (i7 | 0)) break;
    HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i6 = i7;
   }
   HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   if ((i5 - i14 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i15 + -1 | 0) >>> 0) i4 = i15; else {
     i4 = i15 << 3;
     if (!i4) i4 = 0; else {
      i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
      i28 = _PxGetFoundation() | 0;
      i28 = mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 24 >> 2] | 0, i28 | 0) | 0;
      i4 = mftCall_iiiiii(i13 | 0, i19 | 0, i4 | 0, (i28 ? gb + 738666 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i15 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i14;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i11;
    i5 = i4;
    i4 = i11 + 2 | 0;
   } else {
    i5 = i11 + 2 | 0;
    if (i8 >>> 0 < (i15 + -1 | 0) >>> 0) i4 = i15; else {
     i4 = i15 << 3;
     if (!i4) i4 = 0; else {
      i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
      i28 = _PxGetFoundation() | 0;
      i28 = mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 24 >> 2] | 0, i28 | 0) | 0;
      i4 = mftCall_iiiiii(i13 | 0, i19 | 0, i4 | 0, (i28 ? gb + 738666 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i15 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i5;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i14;
    i3 = i11;
   }
   i15 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
  }
 }
 if (HEAP8[i16 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i22, HEAP32[i22 >> 2] | 0);
 i10 = HEAP32[i21 >> 2] | 0;
 L95 : do if ((i10 | 0) > 0) {
  i9 = HEAP32[i23 >> 2] | 0;
  i5 = 0;
  while (1) {
   i4 = HEAP32[i17 + (i5 * 12 | 0) >> 2] | 0;
   i3 = i17 + (i5 * 12 | 0) + 4 | 0;
   i8 = i17 + (i5 * 12 | 0) + 8 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i9 + (i1 << 2) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i9 + ((((i1 | 0) % 3 | 0 | 0) < 2 ? 1 : -2) + i1 << 2) >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i7 = 1; else i25 = 71; else i25 = 71;
   if ((i25 | 0) == 71) {
    i25 = 0;
    i7 = 0;
   }
   i1 = i5;
   while (1) {
    i1 = i1 + 1 | 0;
    i2 = (i1 | 0) < (i10 | 0);
    if (!i2) {
     i6 = i2;
     break;
    }
    if (!((HEAP32[i17 + (i1 * 12 | 0) >> 2] | 0) == (i4 | 0) ? (HEAP32[i17 + (i1 * 12 | 0) + 4 >> 2] | 0) == (HEAP32[i3 >> 2] | 0) : 0)) {
     i6 = i2;
     break;
    }
   }
   if ((i1 - i5 | 0) > 2) {
    i1 = 1;
    break L95;
   }
   while (1) {
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i1 | 0)) break;
    i3 = i17 + (i5 * 12 | 0) + 8 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i9 + (i4 << 2) >> 2] | 0) == (HEAP32[i17 + (i5 * 12 | 0) >> 2] | 0)) if ((HEAP32[i9 + ((((i4 | 0) % 3 | 0 | 0) < 2 ? 1 : -2) + i4 << 2) >> 2] | 0) == (HEAP32[i17 + (i5 * 12 | 0) + 4 >> 2] | 0)) i2 = 1; else i25 = 79; else i25 = 79;
    if ((i25 | 0) == 79) {
     i25 = 0;
     i2 = 0;
    }
    i28 = HEAP32[i24 >> 2] | 0;
    HEAP32[i28 + (HEAP32[i8 >> 2] << 2) >> 2] = (i4 >>> 0) / 3 | 0;
    HEAP32[i28 + (HEAP32[i3 >> 2] << 2) >> 2] = ((HEAP32[i8 >> 2] | 0) >>> 0) / 3 | 0;
    if (!(i7 ^ i2)) {
     i1 = 2;
     break L95;
    }
   }
   if (i6) i5 = i1; else {
    i1 = 0;
    break;
   }
  }
 } else i1 = 0; while (0);
 i28 = HEAP32[i26 >> 2] | 0;
 if ((i28 & 2147483647 | 0) == 0 | (i28 | 0) < 0 | (i18 | 0) == 0) {
  STACKTOP = i27;
  return i1 | 0;
 }
 i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i18 | 0);
 STACKTOP = i27;
 return i1 | 0;
}

function __Z28SetExposedSkeletonTransformsRKN11UnityEngine9Animation30AnimatorGenericBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNS6_INS7_7affineXEEERNS0_21AvatarBindingConstantE(i3, i33, i2, i1) {
 i3 = i3 | 0;
 i33 = i33 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i39 + 48 | 0;
 i35 = i39 + 32 | 0;
 i36 = i39 + 16 | 0;
 i37 = i39;
 i38 = i1 + 16 | 0;
 i4 = HEAP32[i38 >> 2] | 0;
 if (!i4) {
  STACKTOP = i39;
  return;
 }
 i29 = i1 + 20 | 0;
 i30 = i3 + 32 | 0;
 i31 = i33 + 4 | 0;
 i32 = i31;
 i20 = i2 + 4 | 0;
 i21 = i20;
 i13 = i34 + 4 | 0;
 i15 = i34 + 8 | 0;
 i17 = i34 + 12 | 0;
 i18 = i34 + 16 | 0;
 i19 = i34 + 20 | 0;
 i10 = i34 + 24 | 0;
 i11 = i34 + 28 | 0;
 i12 = i34 + 32 | 0;
 i9 = i34 + 36 | 0;
 i14 = i34 + 40 | 0;
 i16 = i34 + 44 | 0;
 i22 = i35 + 12 | 0;
 i23 = i35 + 4 | 0;
 i24 = i35 + 8 | 0;
 i25 = i36 + 4 | 0;
 i26 = i36 + 8 | 0;
 i27 = i36 + 12 | 0;
 i28 = i34 + 36 | 0;
 i6 = i3 + 24 | 0;
 i7 = i37 + 4 | 0;
 i8 = i37 + 8 | 0;
 i5 = 0;
 i1 = i4;
 do {
  i2 = HEAP32[i29 >> 2] | 0;
  i3 = i2 + (i5 * 12 | 0) | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i56 = HEAP32[(HEAP32[i30 >> 2] | 0) + 16 >> 2] | 0;
   i57 = HEAP32[i56 >> 2] | 0;
   i47 = (HEAP32[i31 >> 2] | 0) + i32 | 0;
   i55 = i2 + (i5 * 12 | 0) + 8 | 0;
   i68 = HEAP32[i55 >> 2] | 0;
   i69 = (HEAP32[i20 >> 2] | 0) + i21 | 0;
   i4 = i47 + 12 | 0;
   i2 = i47 + 16 | 0;
   i41 = i47 + 20 | 0;
   i54 = i47 + 24 | 0;
   f51 = Math_fround(HEAPF32[i54 >> 2]);
   f45 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i2 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f46 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i41 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f45 * Math_fround(-2.0));
   f53 = Math_fround(f45 * Math_fround(2.0));
   f62 = Math_fround(f45 * f63);
   f66 = Math_fround(f46 * Math_fround(-2.0));
   f61 = Math_fround(f46 * Math_fround(2.0));
   f64 = Math_fround(f46 * f66);
   f67 = Math_fround(Math_fround(f62 + f64) + Math_fround(1.0));
   f65 = Math_fround(Math_fround(Math_fround(f60 * f53) + Math_fround(f51 * f61)) + Math_fround(0.0));
   f63 = Math_fround(Math_fround(Math_fround(f51 * f63) + Math_fround(f60 * f61)) + Math_fround(0.0));
   f40 = Math_fround(f60 * Math_fround(2.0));
   f59 = Math_fround(f60 * Math_fround(-2.0));
   f60 = Math_fround(f60 * f59);
   f66 = Math_fround(Math_fround(Math_fround(f45 * f40) + Math_fround(f51 * f66)) + Math_fround(0.0));
   f64 = Math_fround(Math_fround(f60 + f64) + Math_fround(1.0));
   f61 = Math_fround(Math_fround(Math_fround(f51 * f40) + Math_fround(f45 * f61)) + Math_fround(0.0));
   f40 = Math_fround(Math_fround(Math_fround(f40 * f46) + Math_fround(f51 * f53)) + Math_fround(0.0));
   f53 = Math_fround(Math_fround(Math_fround(f51 * f59) + Math_fround(f46 * f53)) + Math_fround(0.0));
   f62 = Math_fround(Math_fround(f60 + f62) + Math_fround(1.0));
   f60 = Math_fround(HEAPF32[i47 + 28 >> 2]);
   i1 = i47 + 32 | 0;
   f46 = Math_fround(HEAPF32[i1 >> 2]);
   i42 = i47 + 36 | 0;
   f59 = Math_fround(HEAPF32[i42 >> 2]);
   i72 = Math_fround(Math_abs(Math_fround(f60))) < Math_fround(9.99999971e-10);
   i71 = Math_fround(Math_abs(Math_fround(f46))) < Math_fround(9.99999971e-10);
   i70 = Math_fround(Math_abs(Math_fround(f59))) < Math_fround(9.99999971e-10);
   f60 = Math_fround(Math_fround(1.0) / f60);
   f60 = i72 ? Math_fround(1.0) : f60;
   f46 = Math_fround(Math_fround(1.0) / f46);
   f46 = i71 ? Math_fround(1.0) : f46;
   f59 = Math_fround(Math_fround(1.0) / f59);
   f59 = i70 ? Math_fround(1.0) : f59;
   f67 = Math_fround(f60 * f67);
   f65 = Math_fround(f65 * f46);
   f63 = Math_fround(f63 * f59);
   f66 = Math_fround(f60 * f66);
   f64 = Math_fround(f46 * f64);
   f61 = Math_fround(f61 * f59);
   f40 = Math_fround(f60 * f40);
   f46 = Math_fround(f53 * f46);
   f59 = Math_fround(f62 * f59);
   f62 = Math_fround(HEAPF32[i47 >> 2]);
   f53 = Math_fround(HEAPF32[i47 + 4 >> 2]);
   f62 = Math_fround(-f62);
   f53 = Math_fround(-f53);
   f60 = Math_fround(-Math_fround(HEAPF32[i47 + 8 >> 2]));
   f51 = Math_fround(Math_fround(f67 * f62) + Math_fround(Math_fround(f40 * f60) + Math_fround(f66 * f53)));
   f45 = Math_fround(Math_fround(f65 * f62) + Math_fround(Math_fround(f46 * f60) + Math_fround(f64 * f53)));
   f53 = Math_fround(Math_fround(f63 * f62) + Math_fround(Math_fround(f59 * f60) + Math_fround(f61 * f53)));
   f60 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 36 >> 2]);
   f62 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 40 >> 2]);
   f49 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 44 >> 2]);
   f51 = Math_fround(f51 + Math_fround(Math_fround(f67 * f60) + Math_fround(Math_fround(f66 * f62) + Math_fround(f40 * f49))));
   f45 = Math_fround(f45 + Math_fround(Math_fround(f65 * f60) + Math_fround(Math_fround(f64 * f62) + Math_fround(f46 * f49))));
   f49 = Math_fround(f53 + Math_fround(Math_fround(f63 * f60) + Math_fround(Math_fround(f61 * f62) + Math_fround(f59 * f49))));
   f62 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) >> 2]);
   f60 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 8 >> 2]);
   f58 = Math_fround(Math_fround(f67 * f62) + Math_fround(Math_fround(f66 * f60) + Math_fround(f40 * f53)));
   f52 = Math_fround(Math_fround(f65 * f62) + Math_fround(Math_fround(f64 * f60) + Math_fround(f46 * f53)));
   f53 = Math_fround(Math_fround(f63 * f62) + Math_fround(Math_fround(f61 * f60) + Math_fround(f59 * f53)));
   f60 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 12 >> 2]);
   f62 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 16 >> 2]);
   f50 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 20 >> 2]);
   f43 = Math_fround(Math_fround(f67 * f60) + Math_fround(Math_fround(f66 * f62) + Math_fround(f40 * f50)));
   f48 = Math_fround(Math_fround(f65 * f60) + Math_fround(Math_fround(f64 * f62) + Math_fround(f46 * f50)));
   f50 = Math_fround(Math_fround(f63 * f60) + Math_fround(Math_fround(f61 * f62) + Math_fround(f59 * f50)));
   f62 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 24 >> 2]);
   f60 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 28 >> 2]);
   f44 = Math_fround(HEAPF32[i69 + (i68 * 48 | 0) + 32 >> 2]);
   f40 = Math_fround(Math_fround(f67 * f62) + Math_fround(Math_fround(f66 * f60) + Math_fround(f40 * f44)));
   f46 = Math_fround(Math_fround(f65 * f62) + Math_fround(Math_fround(f64 * f60) + Math_fround(f46 * f44)));
   f44 = Math_fround(Math_fround(f63 * f62) + Math_fround(Math_fround(f61 * f60) + Math_fround(f59 * f44)));
   HEAPF32[i34 >> 2] = f58;
   HEAPF32[i13 >> 2] = f52;
   HEAPF32[i15 >> 2] = f53;
   HEAPF32[i17 >> 2] = f43;
   HEAPF32[i18 >> 2] = f48;
   HEAPF32[i19 >> 2] = f50;
   HEAPF32[i10 >> 2] = f40;
   HEAPF32[i11 >> 2] = f46;
   HEAPF32[i12 >> 2] = f44;
   HEAPF32[i9 >> 2] = f51;
   HEAPF32[i14 >> 2] = f45;
   HEAPF32[i16 >> 2] = f49;
   __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i35, (i57 | 0) == 0 ? 0 : i57 + i56 | 0, i33, HEAP32[i55 >> 2] | 0);
   f49 = Math_fround(HEAPF32[i54 >> 2]);
   f45 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i2 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f51 = Math_fround(HEAPF32[i35 >> 2]);
   f44 = Math_fround(f45 * f51);
   f46 = Math_fround(HEAPF32[i22 >> 2]);
   f40 = Math_fround(f49 * f46);
   f50 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i41 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f48 = Math_fround(HEAPF32[i23 >> 2]);
   f43 = Math_fround(f50 * f48);
   f53 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f52 = Math_fround(HEAPF32[i24 >> 2]);
   f44 = Math_fround(Math_fround(Math_fround(f44 - Math_fround(f49 * f52)) - Math_fround(f50 * f46)) - Math_fround(f53 * f48));
   f40 = Math_fround(Math_fround(Math_fround(f40 - Math_fround(f53 * f51)) - Math_fround(f50 * f52)) - Math_fround(f45 * f48));
   f43 = Math_fround(Math_fround(Math_fround(f43 - Math_fround(f45 * f52)) - Math_fround(f49 * f51)) - Math_fround(f53 * f46));
   f46 = Math_fround(Math_fround(Math_fround(Math_fround(f53 * f52) - Math_fround(f51 * f50)) - Math_fround(f49 * f48)) - Math_fround(f45 * f46));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
   i41 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f46 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i47 + 28 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f43 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i1 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f44 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i42 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f45 = Math_fround(f43 * f44);
   f44 = Math_fround(f46 * f44);
   f43 = Math_fround(f46 * f43);
   i42 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ (i4 ^ -2147483648);
   HEAP32[i36 >> 2] = i42 & -2147483648 ^ (i41 ^ -2147483648);
   HEAP32[i25 >> 2] = i1 & -2147483648 ^ i2;
   HEAP32[i26 >> 2] = i4;
   HEAPF32[i27 >> 2] = f40;
   __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(HEAP32[i3 >> 2] | 0, i28);
   __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(HEAP32[i3 >> 2] | 0, i36);
   if (HEAP8[(HEAP32[i6 >> 2] | 0) + i5 >> 0] | 0) {
    f51 = Math_fround(HEAPF32[i27 >> 2]);
    f50 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i25 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i36 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f59 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i26 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f50 * Math_fround(-2.0));
    f66 = Math_fround(f50 * Math_fround(2.0));
    f67 = Math_fround(f50 * f61);
    f65 = Math_fround(f59 * Math_fround(-2.0));
    f63 = Math_fround(f59 * Math_fround(2.0));
    f64 = Math_fround(f59 * f65);
    f58 = Math_fround(Math_fround(f67 + f64) + Math_fround(1.0));
    f60 = Math_fround(Math_fround(Math_fround(f53 * f66) + Math_fround(f51 * f63)) + Math_fround(0.0));
    f61 = Math_fround(Math_fround(Math_fround(f51 * f61) + Math_fround(f53 * f63)) + Math_fround(0.0));
    f62 = Math_fround(f53 * Math_fround(2.0));
    f52 = Math_fround(f53 * Math_fround(-2.0));
    f53 = Math_fround(f53 * f52);
    f65 = Math_fround(Math_fround(Math_fround(f50 * f62) + Math_fround(f51 * f65)) + Math_fround(0.0));
    f64 = Math_fround(Math_fround(f53 + f64) + Math_fround(1.0));
    f63 = Math_fround(Math_fround(Math_fround(f51 * f62) + Math_fround(f50 * f63)) + Math_fround(0.0));
    f62 = Math_fround(Math_fround(Math_fround(f62 * f59) + Math_fround(f51 * f66)) + Math_fround(0.0));
    f66 = Math_fround(Math_fround(Math_fround(f51 * f52) + Math_fround(f59 * f66)) + Math_fround(0.0));
    f67 = Math_fround(Math_fround(f53 + f67) + Math_fround(1.0));
    f53 = Math_fround(HEAPF32[i34 >> 2]);
    f59 = Math_fround(HEAPF32[i13 >> 2]);
    f65 = Math_fround(Math_fround(f53 * f58) + Math_fround(Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f62) + Math_fround(f59 * f65)));
    f59 = Math_fround(HEAPF32[i17 >> 2]);
    f62 = Math_fround(HEAPF32[i18 >> 2]);
    f66 = Math_fround(Math_fround(f59 * f60) + Math_fround(Math_fround(f64 * f62) + Math_fround(f66 * Math_fround(HEAPF32[i19 >> 2]))));
    f62 = Math_fround(HEAPF32[i10 >> 2]);
    f64 = Math_fround(HEAPF32[i11 >> 2]);
    f67 = Math_fround(Math_fround(f61 * f62) + Math_fround(Math_fround(f63 * f64) + Math_fround(f67 * Math_fround(HEAPF32[i12 >> 2]))));
    HEAPF32[i37 >> 2] = f65;
    HEAPF32[i7 >> 2] = f66;
    HEAPF32[i8 >> 2] = f67;
    __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(HEAP32[i3 >> 2] | 0, i37);
   }
   i1 = HEAP32[i38 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i1 >>> 0);
 STACKTOP = i39;
 return;
}

function _zipOpenNewFileInZip3(i30, i1, i10, i24, i25, i12, i13, i15, i3, i29, i4, i26, i27, i28, i31, i34) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i29 = i29 | 0;
 i4 = i4 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i31 = i31 | 0;
 i34 = i34 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i38;
 i36 = i38 + 12 | 0;
 if (!i30) {
  i37 = -102;
  STACKTOP = i38;
  return i37 | 0;
 }
 switch (i3 | 0) {
 case 0:
 case 8:
  break;
 default:
  {
   i37 = -102;
   STACKTOP = i38;
   return i37 | 0;
  }
 }
 i37 = i30 + 44 | 0;
 if ((HEAP32[i37 >> 2] | 0) == 1) {
  i2 = _zipCloseFileInZipRaw(i30, 0, 0) | 0;
  if (i2 | 0) {
   i37 = i2;
   STACKTOP = i38;
   return i37 | 0;
  }
 }
 i21 = (i1 | 0) == 0 ? gb + 1087656 | 0 : i1;
 if (!i15) i11 = 0; else i11 = _strlen(i15) | 0;
 i22 = _strlen(i21) | 0;
 i6 = (i10 | 0) == 0;
 do if (i6) HEAP32[i30 + 16520 >> 2] = 0; else {
  i1 = HEAP32[i10 + 24 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i30 + 16520 >> 2] = i1;
   break;
  }
  i1 = HEAP32[i10 + 20 >> 2] | 0;
  if (i1 >>> 0 > 1980) i1 = i1 + -1980 | 0; else i1 = i1 >>> 0 > 80 ? i1 + -80 | 0 : i1;
  HEAP32[i30 + 16520 >> 2] = (HEAP32[i10 + 4 >> 2] << 5) + ((HEAP32[i10 >> 2] | 0) >>> 1) + (HEAP32[i10 + 8 >> 2] << 11) | (HEAP32[i10 + 12 >> 2] | 0) + 32 + (i1 << 9) + (HEAP32[i10 + 16 >> 2] << 5) << 16;
 } while (0);
 i20 = i30 + 48 | 0;
 i14 = i30 + 124 | 0;
 i1 = (i29 | 1 | 0) == 9 ? 2 : 0;
 HEAP32[i14 >> 2] = i1;
 switch (i29 | 0) {
 case 2:
  {
   i1 = i1 | 4;
   HEAP32[i14 >> 2] = i1;
   break;
  }
 case 1:
  {
   HEAP32[i14 >> 2] = 6;
   i1 = 6;
   break;
  }
 default:
  {}
 }
 i23 = (i31 | 0) != 0;
 if (i23) HEAP32[i14 >> 2] = i1 | 1;
 HEAP32[i30 + 16524 >> 2] = 0;
 i17 = i30 + 128 | 0;
 HEAP32[i17 >> 2] = i3;
 i19 = i30 + 16528 | 0;
 HEAP32[i19 >> 2] = 0;
 i18 = i30 + 104 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i30 + 108 >> 2] = 0;
 i16 = i30 + 132 | 0;
 HEAP32[i16 >> 2] = i4;
 i32 = i30 + 28 | 0;
 i33 = i30 + 32 | 0;
 i2 = mftCall_iii(HEAP32[i30 + 12 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0) | 0;
 HEAP32[i30 + 112 >> 2] = i2;
 i3 = i13 + 46 + i11 + i22 | 0;
 HEAP32[i30 + 120 >> 2] = i3;
 i3 = _malloc(i3) | 0;
 i4 = i30 + 116 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP8[i3 >> 0] = 80;
 HEAP8[i3 + 1 >> 0] = 75;
 HEAP8[i3 + 2 >> 0] = 1;
 HEAP8[i3 + 3 >> 0] = 2;
 HEAP8[i3 + 4 >> 0] = 0;
 HEAP8[i3 + 5 >> 0] = 0;
 HEAP8[i3 + 6 >> 0] = 20;
 HEAP8[i3 + 7 >> 0] = 0;
 i1 = i3 + 8 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 HEAP8[i1 >> 0] = i9;
 HEAP8[i3 + 9 >> 0] = i9 >>> 8;
 if (i9 >>> 0 >= 65536) {
  HEAP8[i1 >> 0] = -1;
  HEAP8[i1 + 1 >> 0] = -1 >> 8;
 }
 i1 = i3 + 10 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 HEAP8[i1 >> 0] = i9;
 HEAP8[i3 + 11 >> 0] = i9 >>> 8;
 if (i9 >>> 0 >= 65536) {
  HEAP8[i1 >> 0] = -1;
  HEAP8[i1 + 1 >> 0] = -1 >> 8;
 }
 i5 = i30 + 16520 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP8[i3 + 12 >> 0] = i1;
 HEAP8[i3 + 13 >> 0] = i1 >>> 8;
 HEAP8[i3 + 14 >> 0] = i1 >>> 16;
 HEAP8[i3 + 15 >> 0] = i1 >>> 24;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP8[i3 + 17 >> 0] = 0;
 HEAP8[i3 + 18 >> 0] = 0;
 HEAP8[i3 + 19 >> 0] = 0;
 HEAP8[i3 + 20 >> 0] = 0;
 HEAP8[i3 + 21 >> 0] = 0;
 HEAP8[i3 + 22 >> 0] = 0;
 HEAP8[i3 + 23 >> 0] = 0;
 HEAP8[i3 + 24 >> 0] = 0;
 HEAP8[i3 + 25 >> 0] = 0;
 HEAP8[i3 + 26 >> 0] = 0;
 HEAP8[i3 + 27 >> 0] = 0;
 i1 = i3 + 28 | 0;
 i7 = i22 & 255;
 HEAP8[i1 >> 0] = i7;
 i8 = i22 >>> 8 & 255;
 HEAP8[i3 + 29 >> 0] = i8;
 i9 = i22 >>> 0 < 65536;
 if (!i9) {
  HEAP8[i1 >> 0] = -1;
  HEAP8[i1 + 1 >> 0] = -1 >> 8;
 }
 i1 = i3 + 30 | 0;
 HEAP8[i1 >> 0] = i13;
 HEAP8[i3 + 31 >> 0] = i13 >>> 8;
 if (i13 >>> 0 >= 65536) {
  HEAP8[i1 >> 0] = -1;
  HEAP8[i1 + 1 >> 0] = -1 >> 8;
 }
 i1 = i3 + 32 | 0;
 HEAP8[i1 >> 0] = i11;
 HEAP8[i3 + 33 >> 0] = i11 >>> 8;
 if (i11 >>> 0 >= 65536) {
  HEAP8[i1 >> 0] = -1;
  HEAP8[i1 + 1 >> 0] = -1 >> 8;
 }
 HEAP8[i3 + 34 >> 0] = 0;
 HEAP8[i3 + 35 >> 0] = 0;
 i1 = i3 + 36 | 0;
 if (i6) {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i3 + 37 >> 0] = 0;
  HEAP8[i3 + 38 >> 0] = 0;
  HEAP8[i3 + 39 >> 0] = 0;
  HEAP8[i3 + 40 >> 0] = 0;
  HEAP8[i3 + 41 >> 0] = 0;
 } else {
  i6 = HEAP32[i10 + 28 >> 2] | 0;
  HEAP8[i1 >> 0] = i6;
  HEAP8[i3 + 37 >> 0] = i6 >>> 8;
  if (i6 >>> 0 >= 65536) {
   HEAP8[i1 >> 0] = -1;
   HEAP8[i1 + 1 >> 0] = -1 >> 8;
  }
  i10 = HEAP32[i10 + 32 >> 2] | 0;
  HEAP8[i3 + 38 >> 0] = i10;
  HEAP8[i3 + 39 >> 0] = i10 >>> 8;
  HEAP8[i3 + 40 >> 0] = i10 >>> 16;
  HEAP8[i3 + 41 >> 0] = i10 >>> 24;
 }
 i10 = i2 - (HEAP32[i30 + 16556 >> 2] | 0) | 0;
 HEAP8[i3 + 42 >> 0] = i10;
 HEAP8[i3 + 43 >> 0] = i10 >>> 8;
 HEAP8[i3 + 44 >> 0] = i10 >>> 16;
 HEAP8[i3 + 45 >> 0] = i10 >>> 24;
 if (i22 | 0) {
  HEAP8[i3 + 46 >> 0] = HEAP8[i21 >> 0] | 0;
  if ((i22 | 0) != 1) {
   i1 = 1;
   do {
    HEAP8[(HEAP32[i4 >> 2] | 0) + 46 + i1 >> 0] = HEAP8[i21 + i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i22 | 0));
  }
 }
 if (i13 | 0) {
  i1 = 0;
  do {
   HEAP8[(HEAP32[i4 >> 2] | 0) + 46 + i22 + i1 >> 0] = HEAP8[i12 + i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 if (i11 | 0) {
  i1 = 0;
  do {
   HEAP8[(HEAP32[i4 >> 2] | 0) + 46 + i22 + i13 + i1 >> 0] = HEAP8[i15 + i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i37 = -104;
  STACKTOP = i38;
  return i37 | 0;
 }
 i15 = HEAP32[i33 >> 2] | 0;
 HEAP8[i35 >> 0] = 80;
 i4 = i35 + 1 | 0;
 HEAP8[i4 >> 0] = 75;
 i2 = i35 + 2 | 0;
 HEAP8[i2 >> 0] = 3;
 i3 = i35 + 3 | 0;
 HEAP8[i3 >> 0] = 4;
 i11 = i30 + 8 | 0;
 do if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 4) | 0) == 4) {
  i15 = HEAP32[i33 >> 2] | 0;
  HEAP8[i35 >> 0] = 20;
  HEAP8[i4 >> 0] = 0;
  if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 2) | 0) == 2) {
   i1 = HEAP32[i33 >> 2] | 0;
   i15 = HEAP32[i14 >> 2] | 0;
   HEAP8[i35 >> 0] = i15;
   HEAP8[i4 >> 0] = i15 >>> 8;
   if (i15 >>> 0 >= 65536) HEAP16[i35 >> 1] = -1;
   if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i1 | 0, i35 | 0, 2) | 0) == 2) {
    i1 = HEAP32[i33 >> 2] | 0;
    i15 = HEAP32[i17 >> 2] | 0;
    HEAP8[i35 >> 0] = i15;
    HEAP8[i4 >> 0] = i15 >>> 8;
    if (i15 >>> 0 >= 65536) HEAP16[i35 >> 1] = -1;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i1 | 0, i35 | 0, 2) | 0) != 2) {
     i1 = -1;
     break;
    }
    i15 = HEAP32[i33 >> 2] | 0;
    i14 = HEAP32[i5 >> 2] | 0;
    HEAP8[i35 >> 0] = i14;
    HEAP8[i4 >> 0] = i14 >>> 8;
    HEAP8[i2 >> 0] = i14 >>> 16;
    HEAP8[i3 >> 0] = i14 >>> 24;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 4) | 0) != 4) {
     i1 = -1;
     break;
    }
    i15 = HEAP32[i33 >> 2] | 0;
    HEAP32[i35 >> 2] = 0;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 4) | 0) != 4) {
     i1 = -1;
     break;
    }
    i15 = HEAP32[i33 >> 2] | 0;
    HEAP32[i35 >> 2] = 0;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 4) | 0) != 4) {
     i1 = -1;
     break;
    }
    i15 = HEAP32[i33 >> 2] | 0;
    HEAP32[i35 >> 2] = 0;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i15 | 0, i35 | 0, 4) | 0) != 4) {
     i1 = -1;
     break;
    }
    i1 = HEAP32[i33 >> 2] | 0;
    HEAP8[i35 >> 0] = i7;
    HEAP8[i4 >> 0] = i8;
    if (!i9) HEAP16[i35 >> 1] = -1;
    if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i1 | 0, i35 | 0, 2) | 0) != 2) {
     i1 = -1;
     break;
    }
    i1 = HEAP32[i33 >> 2] | 0;
    HEAP8[i35 >> 0] = i25;
    HEAP8[i4 >> 0] = i25 >>> 8;
    if (i25 >>> 0 >= 65536) HEAP16[i35 >> 1] = -1;
    i15 = (mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, i1 | 0, i35 | 0, 2) | 0) != 2;
    i1 = i15 << 31 >> 31;
    if ((i22 | 0) != 0 & (i15 ^ 1)) {
     i22 = (mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0, i21 | 0, i22 | 0) | 0) == (i22 | 0);
     i1 = i22 ? i1 : -1;
    }
    if (!((i25 | 0) != 0 & (i1 | 0) == 0)) break;
    i1 = ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0, i24 | 0, i25 | 0) | 0) != (i25 | 0)) << 31 >> 31;
   } else i1 = -1;
  } else i1 = -1;
 } else i1 = -1; while (0);
 HEAP32[i30 + 52 >> 2] = 0;
 HEAP32[i30 + 64 >> 2] = 16384;
 HEAP32[i30 + 60 >> 2] = i30 + 136;
 HEAP32[i30 + 56 >> 2] = 0;
 HEAP32[i30 + 68 >> 2] = 0;
 L97 : do if (!i1) {
  do if ((HEAP32[i17 >> 2] | 0) == 8) {
   if (HEAP32[i16 >> 2] | 0) break;
   HEAP32[i30 + 80 >> 2] = 0;
   HEAP32[i30 + 84 >> 2] = 0;
   HEAP32[i30 + 88 >> 2] = 0;
   i1 = _unity_z_deflateInit2_(i20, i29, 8, (i26 | 0) > 0 ? 0 - i26 | 0 : i26, i27, i28, gb + 362978 | 0, 56) | 0;
   if (i1 | 0) break L97;
   HEAP32[i18 >> 2] = 1;
  } while (0);
  i10 = i30 + 16548 | 0;
  HEAP32[i10 >> 2] = 0;
  do if (i23) {
   HEAP32[i19 >> 2] = 1;
   i7 = _unity_z_get_crc_table() | 0;
   HEAP32[i30 + 16544 >> 2] = i7;
   i8 = i30 + 16532 | 0;
   i29 = HEAP32[gb + 1100508 >> 2] | 0;
   HEAP32[gb + 1100508 >> 2] = i29 + 1;
   if (!i29) _srand((_time(0) | 0) ^ -1153374642);
   HEAP32[i8 >> 2] = 305419896;
   i9 = i30 + 16536 | 0;
   HEAP32[i9 >> 2] = 591751049;
   i6 = i30 + 16540 | 0;
   HEAP32[i6 >> 2] = 878082192;
   i1 = HEAP8[i31 >> 0] | 0;
   if (!(i1 << 24 >> 24)) i1 = 0; else {
    i5 = i31;
    i2 = 305419896;
    i3 = 591751049;
    i4 = 878082192;
    do {
     i2 = HEAP32[i7 + ((i1 & 255 ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
     HEAP32[i8 >> 2] = i2;
     i3 = (Math_imul((i2 & 255) + i3 | 0, 134775813) | 0) + 1 | 0;
     HEAP32[i9 >> 2] = i3;
     i4 = HEAP32[i7 + ((i3 >>> 24 ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
     HEAP32[i6 >> 2] = i4;
     i5 = i5 + 1 | 0;
     i1 = HEAP8[i5 >> 0] | 0;
    } while (i1 << 24 >> 24 != 0);
    i1 = 0;
   }
   do {
    i30 = (_rand() | 0) >>> 7;
    i28 = HEAP32[i6 >> 2] | 0;
    i29 = i28 & 65533;
    i29 = (Math_imul(i29 | 2, i29 ^ 3) | 0) >>> 8;
    i27 = HEAP32[i8 >> 2] | 0;
    i27 = HEAP32[i7 + (((i27 ^ i30) & 255) << 2) >> 2] ^ i27 >>> 8;
    HEAP32[i8 >> 2] = i27;
    i27 = (Math_imul((HEAP32[i9 >> 2] | 0) + (i27 & 255) | 0, 134775813) | 0) + 1 | 0;
    HEAP32[i9 >> 2] = i27;
    HEAP32[i6 >> 2] = HEAP32[i7 + ((i27 >>> 24 ^ i28 & 255) << 2) >> 2] ^ i28 >>> 8;
    HEAP8[i35 + i1 >> 0] = i29 ^ i30;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 10);
   HEAP32[i8 >> 2] = 305419896;
   HEAP32[i9 >> 2] = 591751049;
   HEAP32[i6 >> 2] = 878082192;
   i1 = HEAP8[i31 >> 0] | 0;
   if (!(i1 << 24 >> 24)) {
    i2 = 878082192;
    i4 = 591751049;
    i1 = 305419896;
   } else {
    i5 = i31;
    i3 = 305419896;
    i4 = 591751049;
    i2 = 878082192;
    do {
     i3 = HEAP32[i7 + ((i1 & 255 ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
     HEAP32[i8 >> 2] = i3;
     i4 = (Math_imul((i3 & 255) + i4 | 0, 134775813) | 0) + 1 | 0;
     HEAP32[i9 >> 2] = i4;
     i2 = HEAP32[i7 + ((i4 >>> 24 ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
     HEAP32[i6 >> 2] = i2;
     i5 = i5 + 1 | 0;
     i1 = HEAP8[i5 >> 0] | 0;
    } while (i1 << 24 >> 24 != 0);
    i1 = i3;
   }
   i3 = i2 & 65533;
   i5 = 0;
   i3 = (Math_imul(i3 | 2, i3 ^ 3) | 0) >>> 8;
   do {
    i31 = HEAPU8[i35 + i5 >> 0] | 0;
    i1 = HEAP32[i7 + ((i31 ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
    HEAP32[i8 >> 2] = i1;
    i4 = (Math_imul((i1 & 255) + i4 | 0, 134775813) | 0) + 1 | 0;
    HEAP32[i9 >> 2] = i4;
    i2 = HEAP32[i7 + ((i4 >>> 24 ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
    HEAP32[i6 >> 2] = i2;
    HEAP8[i36 + i5 >> 0] = i31 ^ i3;
    i5 = i5 + 1 | 0;
    i31 = i2 & 65533;
    i3 = (Math_imul(i31 | 2, i31 ^ 3) | 0) >>> 8;
   } while ((i5 | 0) != 10);
   i31 = i34 >>> 16;
   i28 = HEAP32[i7 + (((i1 ^ i31) & 255) << 2) >> 2] ^ i1 >>> 8;
   HEAP32[i8 >> 2] = i28;
   i27 = i28 & 255;
   i29 = (Math_imul(i4 + i27 | 0, 134775813) | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i29;
   i30 = HEAP32[i7 + ((i29 >>> 24 ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   HEAP32[i6 >> 2] = i30;
   HEAP8[i36 + 10 >> 0] = i3 ^ i31;
   i31 = i30 & 65533;
   i31 = (Math_imul(i31 | 2, i31 ^ 3) | 0) >>> 8;
   i35 = i34 >>> 24;
   i34 = HEAP32[i7 + ((i27 ^ i35) << 2) >> 2] ^ i28 >>> 8;
   HEAP32[i8 >> 2] = i34;
   i34 = (Math_imul(i29 + (i34 & 255) | 0, 134775813) | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i34;
   HEAP32[i6 >> 2] = HEAP32[i7 + ((i34 >>> 24 ^ i30 & 255) << 2) >> 2] ^ i30 >>> 8;
   HEAP8[i36 + 11 >> 0] = i31 ^ i35;
   HEAP32[i10 >> 2] = 12;
   if ((mftCall_iiiii(HEAP32[i11 >> 2] | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] | 0, i36 | 0, 12) | 0) == 12) break; else i1 = -1;
   STACKTOP = i38;
   return i1 | 0;
  } while (0);
  HEAP32[i37 >> 2] = 1;
  i37 = 0;
  STACKTOP = i38;
  return i37 | 0;
 } else i1 = -1; while (0);
 HEAP32[i30 + 16548 >> 2] = 0;
 i37 = i1;
 STACKTOP = i38;
 return i37 | 0;
}

function __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_(i16, i3, i17, i14, i2, i18, i5, f15, i1, i4) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i5 = i5 | 0;
 f15 = Math_fround(f15);
 i1 = i1 | 0;
 i4 = i4 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 f11 = Math_fround(HEAPF32[i16 + 124 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 128 >> 2]);
 i20 = HEAP32[gb + 1477044 >> 2] | 0;
 i20 = i20 << 11 ^ i20;
 HEAP32[gb + 1477044 >> 2] = HEAP32[gb + 1477048 >> 2];
 HEAP32[gb + 1477048 >> 2] = HEAP32[gb + 1477052 >> 2];
 i19 = HEAP32[gb + 1477056 >> 2] | 0;
 HEAP32[gb + 1477052 >> 2] = i19;
 i19 = i20 >>> 8 ^ i20 ^ i19 ^ i19 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i19;
 f9 = Math_fround(Math_fround((i19 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(f11 * f9) + Math_fround(f10 * Math_fround(Math_fround(1.0) - f9)));
 i19 = f9 < Math_fround(0.0);
 i20 = f9 > Math_fround(100000001999999991808.0);
 f9 = i20 ? Math_fround(100000001999999991808.0) : f9;
 f9 = i19 ? Math_fround(0.0) : f9;
 HEAPF32[i17 + 40 >> 2] = f9;
 HEAPF32[i17 + 36 >> 2] = Math_fround(Math_fround(f9 + f15) + Math_fround(.00100000005));
 i1 = (HEAP32[i1 >> 2] | 0) + (Math_imul(HEAP32[i1 + 4 >> 2] | 0, i3) | 0) | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i2 + 16 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i2 + 32 >> 2])));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) + f12);
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i2 + 20 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i2 + 36 >> 2])));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 52 >> 2]) + f13);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i2 + 24 >> 2])));
 f11 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i2 + 40 >> 2])));
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) + f11);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 } else {
  i20 = i1 + (Math_imul(HEAP32[i4 + 4 >> 2] | 0, i3) | 0) | 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  f8 = Math_fround(HEAPF32[i20 >> 2]);
  f7 = Math_fround(f7 * f8);
  f10 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f10 = Math_fround(f7 + Math_fround(f10 * f6));
  f7 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f9 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f7 = Math_fround(f10 + Math_fround(f7 * f9));
  f10 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i5 + 16 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i5 + 28 >> 2])));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 8 >> 2]));
  f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i5 + 20 >> 2])));
  f9 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i5 + 32 >> 2])));
  f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f10 * f10)) + Math_fround(f9 * f9));
  if (!(f6 == Math_fround(0.0))) f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
  f8 = Math_fround(f7 * f6);
  f7 = Math_fround(f9 * f6);
  f6 = Math_fround(f10 * f6);
 }
 i28 = i16 + 44 | 0;
 HEAP32[i17 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 i4 = HEAP32[gb + 1477044 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 i1 = HEAP32[gb + 1477048 >> 2] | 0;
 i2 = HEAP32[gb + 1477052 >> 2] | 0;
 i3 = HEAP32[gb + 1477056 >> 2] | 0;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i3 >>> 19;
 f10 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f10 = Math_fround(Math_fround(f10 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f10) * f15));
 f34 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f10);
 i20 = i14 + 4 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f10);
 i19 = i14 + 8 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f10);
 f34 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f34);
 HEAPF32[i17 >> 2] = f34;
 i30 = i17 + 4 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f9);
 HEAPF32[i30 >> 2] = f9;
 i29 = i17 + 8 | 0;
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i29 >> 2]));
 HEAPF32[i29 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f33 = Math_fround(f33 - Math_fround(HEAPF32[i28 >> 2]));
 f15 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i16 + 48 >> 2]));
 f32 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 i1 = i1 << 11 ^ i1;
 i1 = i1 >>> 8 ^ i1 ^ i5;
 i4 = i1 ^ i4 >>> 19;
 f31 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(f15 * f31);
 f32 = Math_fround(Math_fround(f32 - Math_fround(HEAPF32[i16 + 52 >> 2])) * f31);
 f31 = Math_fround(f34 + Math_fround(f33 * f31));
 HEAPF32[i17 >> 2] = f31;
 f15 = Math_fround(f9 + f15);
 HEAPF32[i30 >> 2] = f15;
 f10 = Math_fround(f32 + f10);
 HEAPF32[i29 >> 2] = f10;
 f32 = Math_fround(f12 * Math_fround(HEAPF32[i18 >> 2]));
 i28 = i18 + 12 | 0;
 f32 = Math_fround(f32 + Math_fround(f13 * Math_fround(HEAPF32[i28 >> 2])));
 i27 = i18 + 24 | 0;
 f32 = Math_fround(f32 + Math_fround(f11 * Math_fround(HEAPF32[i27 >> 2])));
 i26 = i18 + 4 | 0;
 f9 = Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2]));
 i25 = i18 + 16 | 0;
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i25 >> 2])));
 i24 = i18 + 28 | 0;
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i24 >> 2])));
 i23 = i18 + 8 | 0;
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i18 + 20 | 0;
 f12 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i22 >> 2])));
 i21 = i18 + 32 | 0;
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2])));
 HEAPF32[i17 >> 2] = Math_fround(f32 + f31);
 HEAPF32[i30 >> 2] = Math_fround(f9 + f15);
 HEAPF32[i29 >> 2] = Math_fround(f12 + f10);
 f12 = Math_fround(HEAPF32[i16 + 224 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 228 >> 2]);
 i2 = i2 << 11 ^ i2;
 i1 = i2 >>> 8 ^ i2 ^ i4 ^ i1 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i1;
 f15 = Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(Math_fround(f12 * f15) + Math_fround(f10 * Math_fround(Math_fround(1.0) - f15)));
 f10 = Math_fround(f8 * f15);
 f12 = Math_fround(f6 * f15);
 f15 = Math_fround(f7 * f15);
 f10 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f10);
 f12 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f12);
 f15 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f15);
 i14 = i17 + 12 | 0;
 HEAPF32[i14 >> 2] = f10;
 i19 = i17 + 16 | 0;
 HEAPF32[i19 >> 2] = f12;
 i20 = i17 + 20 | 0;
 HEAPF32[i20 >> 2] = f15;
 i3 = i3 << 11 ^ i3;
 i1 = HEAP32[gb + 1477056 >> 2] | 0;
 i3 = i3 >>> 8 ^ i3 ^ i1;
 i2 = i3 ^ i1 >>> 19;
 f13 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f13 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f13);
 i5 = i5 << 11 ^ i5;
 i5 = i5 >>> 8 ^ i5 ^ i2;
 i3 = i5 ^ i3 >>> 19;
 f8 = Math_fround(Math_fround((i3 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f8) * Math_fround(6.28318548)));
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f13 * f13))));
 f7 = Math_fround(f9 * Math_fround(+Math_cos(+f8)));
 f8 = Math_fround(f9 * Math_fround(+Math_sin(+f8)));
 i4 = i4 << 11 ^ i4;
 HEAP32[gb + 1477044 >> 2] = i1;
 HEAP32[gb + 1477048 >> 2] = i2;
 HEAP32[gb + 1477052 >> 2] = i3;
 i4 = i4 >>> 8 ^ i4 ^ i3;
 i5 = i4 ^ i5 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i5;
 f9 = Math_fround(+Math_pow(+Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07)), .333333343));
 f7 = Math_fround(f7 * f9);
 f8 = Math_fround(f8 * f9);
 f13 = Math_fround(f9 * f13);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 180 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 184 >> 2]));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i16 + 188 >> 2]));
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i18 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i28 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i27 >> 2])));
 f11 = Math_fround(f7 * Math_fround(HEAPF32[i26 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i25 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f13 * Math_fround(HEAPF32[i24 >> 2])));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i22 >> 2])));
 f13 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i21 >> 2])));
 HEAPF32[i14 >> 2] = Math_fround(f9 + f10);
 HEAPF32[i19 >> 2] = Math_fround(f11 + f12);
 HEAPF32[i20 >> 2] = Math_fround(f13 + f15);
 if (!(HEAP8[i16 + 193 >> 0] | 0)) {
  f32 = Math_fround(0.0);
  i30 = i1;
  i27 = i5;
  i28 = i2;
  i26 = i3;
  i29 = i17 + 28 | 0;
  HEAPF32[i29 >> 2] = f32;
  i29 = i16 + 200 | 0;
  f32 = Math_fround(HEAPF32[i29 >> 2]);
  i29 = i16 + 196 | 0;
  f31 = Math_fround(HEAPF32[i29 >> 2]);
  i29 = i30 << 11;
  i30 = i29 ^ i30;
  i29 = i27 >>> 19;
  i25 = i30 >>> 8;
  i30 = i25 ^ i30;
  i30 = i30 ^ i27;
  i29 = i30 ^ i29;
  i25 = i29 & 8388607;
  f34 = Math_fround(i25 >>> 0);
  f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
  f33 = Math_fround(f31 * f34);
  f34 = Math_fround(Math_fround(1.0) - f34);
  f34 = Math_fround(f31 * f34);
  f33 = Math_fround(f34 - f33);
  f33 = Math_fround(f32 + f33);
  f33 = Math_fround(f33 / Math_fround(360.0));
  f33 = Math_fround(f33 * Math_fround(2.0));
  f33 = Math_fround(f33 * Math_fround(3.14159274));
  i25 = i17 + 32 | 0;
  HEAPF32[i25 >> 2] = f33;
  i25 = i17 + 44 | 0;
  HEAP32[i25 >> 2] = -1;
  i25 = i16 + 116 | 0;
  f33 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i16 + 120 | 0;
  f32 = Math_fround(HEAPF32[i25 >> 2]);
  i25 = i28 << 11;
  i28 = i25 ^ i28;
  HEAP32[gb + 1477044 >> 2] = i26;
  HEAP32[gb + 1477048 >> 2] = i27;
  HEAP32[gb + 1477052 >> 2] = i29;
  i30 = i30 >>> 19;
  i27 = i28 >>> 8;
  i28 = i27 ^ i28;
  i29 = i28 ^ i29;
  i30 = i29 ^ i30;
  HEAP32[gb + 1477056 >> 2] = i30;
  i30 = i30 & 8388607;
  f34 = Math_fround(i30 >>> 0);
  f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
  f33 = Math_fround(f33 * f34);
  f34 = Math_fround(Math_fround(1.0) - f34);
  f34 = Math_fround(f32 * f34);
  f34 = Math_fround(f33 + f34);
  i30 = i17 + 24 | 0;
  HEAPF32[i30 >> 2] = f34;
  return;
 }
 i27 = i1 << 11 ^ i1;
 HEAP32[gb + 1477044 >> 2] = i2;
 HEAP32[gb + 1477048 >> 2] = i3;
 HEAP32[gb + 1477052 >> 2] = i5;
 i27 = i27 >>> 8 ^ i27 ^ i5 ^ i4 >>> 19;
 HEAP32[gb + 1477056 >> 2] = i27;
 f32 = Math_fround(Math_fround((i27 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f32 = Math_fround(Math_fround(f32 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f32) * Math_fround(6.28318548)));
 i30 = i2;
 i28 = i3;
 i26 = i5;
 i29 = i17 + 28 | 0;
 HEAPF32[i29 >> 2] = f32;
 i29 = i16 + 200 | 0;
 f32 = Math_fround(HEAPF32[i29 >> 2]);
 i29 = i16 + 196 | 0;
 f31 = Math_fround(HEAPF32[i29 >> 2]);
 i29 = i30 << 11;
 i30 = i29 ^ i30;
 i29 = i27 >>> 19;
 i25 = i30 >>> 8;
 i30 = i25 ^ i30;
 i30 = i30 ^ i27;
 i29 = i30 ^ i29;
 i25 = i29 & 8388607;
 f34 = Math_fround(i25 >>> 0);
 f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
 f33 = Math_fround(f31 * f34);
 f34 = Math_fround(Math_fround(1.0) - f34);
 f34 = Math_fround(f31 * f34);
 f33 = Math_fround(f34 - f33);
 f33 = Math_fround(f32 + f33);
 f33 = Math_fround(f33 / Math_fround(360.0));
 f33 = Math_fround(f33 * Math_fround(2.0));
 f33 = Math_fround(f33 * Math_fround(3.14159274));
 i25 = i17 + 32 | 0;
 HEAPF32[i25 >> 2] = f33;
 i25 = i17 + 44 | 0;
 HEAP32[i25 >> 2] = -1;
 i25 = i16 + 116 | 0;
 f33 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i16 + 120 | 0;
 f32 = Math_fround(HEAPF32[i25 >> 2]);
 i25 = i28 << 11;
 i28 = i25 ^ i28;
 HEAP32[gb + 1477044 >> 2] = i26;
 HEAP32[gb + 1477048 >> 2] = i27;
 HEAP32[gb + 1477052 >> 2] = i29;
 i30 = i30 >>> 19;
 i27 = i28 >>> 8;
 i28 = i27 ^ i28;
 i29 = i28 ^ i29;
 i30 = i29 ^ i30;
 HEAP32[gb + 1477056 >> 2] = i30;
 i30 = i30 & 8388607;
 f34 = Math_fround(i30 >>> 0);
 f34 = Math_fround(f34 * Math_fround(1.19209304e-07));
 f33 = Math_fround(f33 * f34);
 f34 = Math_fround(Math_fround(1.0) - f34);
 f34 = Math_fround(f32 * f34);
 f34 = Math_fround(f33 + f34);
 i30 = i17 + 24 | 0;
 HEAPF32[i30 >> 2] = f34;
 return;
}

function __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i4 = i12 + 5 | 0;
 i7 = i12 + 4 | 0;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i8, i11);
 i3 = i8 + 328 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1047713 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i6 = i8 + 268 | 0;
 HEAP8[i4 >> 0] = ((HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3;
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931774 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i1 = HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16;
 i3 = (HEAPU8[i4 >> 0] | 0) << 6 & 192 | i1 & 16777023;
 HEAP16[i6 >> 1] = i3;
 HEAP8[i6 + 2 >> 0] = i3 >>> 16;
 HEAP8[i4 >> 0] = (i1 & 16777215) >>> 8 & 1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 404998 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i1 = HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16;
 i3 = (HEAPU8[i4 >> 0] | 0) << 8 & 256 | i1 & 16776959;
 HEAP16[i6 >> 1] = i3;
 HEAP8[i6 + 2 >> 0] = i3 >>> 16;
 HEAP8[i4 >> 0] = (i1 & 16777215) >>> 10 & 3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405015 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i1 = HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16;
 i4 = (HEAPU8[i4 >> 0] | 0) << 10 & 3072 | i1 & 16774143;
 HEAP16[i6 >> 1] = i4;
 HEAP8[i6 + 2 >> 0] = i4 >>> 16;
 HEAP8[i7 >> 0] = (i1 & 16777215) >>> 16 & 3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405031 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i4 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i1 = HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16;
 i4 = (HEAPU8[i7 >> 0] | 0) << 16 & 196608 | i1 & 16580607;
 HEAP16[i6 >> 1] = i4;
 HEAP8[i6 + 2 >> 0] = i4 >>> 16;
 HEAP8[i7 >> 0] = (i1 & 16777215) >>> 14 & 3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931826 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = (HEAPU8[i7 >> 0] | 0) << 14 & 49152 | (HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16) & 16728063;
 HEAP16[i6 >> 1] = i4;
 HEAP8[i6 + 2 >> 0] = i4 >>> 16;
 i4 = i8 + 260 | 0;
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931918 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 60; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 60; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 60) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931934 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 71; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 71; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 71) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 228 | 0;
 i3 = HEAP32[gb + 37328 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931957 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 244 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 931980 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405049 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8MaterialELj4EEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 216 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405061 | 0, gb + 405079 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15StaticBatchInfo8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 308 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405095 | 0, gb + 842702 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405113 | 0, gb + 842702 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 405127 | 0, gb + 932544 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 332 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1011497 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 < i7 >>> 0) i10 = 124; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i10 = 124;
     break;
    }
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   } while (0);
   if ((i10 | 0) == 124) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 336 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1011514 | 0, HEAP32[gb + 37240 >> 2] | 0, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i11 + 16 | 0;
  i9 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  do if (i2 >>> 0 < i9 >>> 0) i10 = 135; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    i10 = 135;
    break;
   }
   HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP32[i1 >> 2] = i3;
  } while (0);
  if ((i10 | 0) == 135) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (!(HEAP32[i11 >> 2] & 512)) break;
  HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function __ZNSt3__218__time_get_storageIwE4initERKNS_5ctypeIwEE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 424 | 0;
 i6 = i13 + 468 | 0;
 i9 = i13 + 24 | 0;
 i7 = i13;
 i8 = i13 + 20 | 0;
 i12 = i13 + 8 | 0;
 i1 = i5;
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i3 = i7;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i5 + 24 | 0;
 i2 = 0;
 while (1) {
  if ((i2 | 0) >= 7) {
   i1 = 3;
   break;
  }
  HEAP32[i3 >> 2] = i2;
  _strftime_l(i6 | 0, 100, gb + 1081538 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
  i4 = i7;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = i6;
  i4 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i1 = 8;
   break;
  }
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = 7;
    break;
   }
  }
  if ((i1 | 0) == -1) {
   i1 = 13;
   break;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 4 + (i2 * 12 | 0) | 0, i9, i9 + (i1 << 2) | 0) | 0;
  _strftime_l(i6 | 0, 100, gb + 1087547 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
  i4 = i7;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = i6;
  i4 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i1 = 18;
   break;
  }
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = 17;
    break;
   }
  }
  if ((i1 | 0) == -1) {
   i1 = 23;
   break;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 4 + ((i2 + 7 | 0) * 12 | 0) | 0, i9, i9 + (i1 << 2) | 0) | 0;
  i2 = i2 + 1 | 0;
 }
 if ((i1 | 0) == 3) {
  i4 = i5 + 16 | 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) >= 12) {
    i1 = 26;
    break;
   }
   HEAP32[i4 >> 2] = i2;
   _strftime_l(i6 | 0, 100, gb + 1081541 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
   i3 = i7;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i8 >> 2] = i6;
   i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = 39;
    break;
   }
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = 38;
     break;
    }
   }
   if ((i1 | 0) == -1) {
    i1 = 44;
    break;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 172 + (i2 * 12 | 0) | 0, i9, i9 + (i1 << 2) | 0) | 0;
   _strftime_l(i6 | 0, 100, gb + 1081544 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
   i3 = i7;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i8 >> 2] = i6;
   i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = 49;
    break;
   }
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = 48;
     break;
    }
   }
   if ((i1 | 0) == -1) {
    i1 = 54;
    break;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 172 + ((i2 + 12 | 0) * 12 | 0) | 0, i9, i9 + (i1 << 2) | 0) | 0;
   i2 = i2 + 1 | 0;
  }
  if ((i1 | 0) == 26) {
   i1 = i5 + 8 | 0;
   HEAP32[i1 >> 2] = 1;
   _strftime_l(i6 | 0, 100, gb + 1078024 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
   i3 = i7;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i8 >> 2] = i6;
   i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (i3 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (i14 & 1) {
      i14 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i14);
     }
    }
    ___resumeException(i1 | 0);
   }
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i14 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i14);
    }
   }
   if ((i2 | 0) == -1) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 460 | 0, i9, i9 + (i2 << 2) | 0) | 0;
   HEAP32[i1 >> 2] = 13;
   _strftime_l(i6 | 0, 100, gb + 1078024 | 0, i5 | 0, HEAP32[i11 >> 2] | 0) | 0;
   i2 = i7;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i8 >> 2] = i6;
   i2 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 208 | 0, i9 | 0, i8 | 0, 100, i7 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (i2 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (i14 & 1) {
      i14 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i14);
     }
    }
    ___resumeException(i1 | 0);
   }
   if (i2 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i14 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i14);
    }
   }
   if ((i1 | 0) == -1) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i11 + 472 | 0, i9, i9 + (i1 << 2) | 0) | 0;
   i1 = i11 + 484 | 0;
   __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE(i12, i11, 99, i10);
   i2 = i11 + 492 + 3 | 0;
   if ((HEAP8[i2 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i1 >> 2] >> 2] = 0;
    HEAP32[i11 + 488 >> 2] = 0;
   } else {
    HEAP32[i1 >> 2] = 0;
    HEAP8[i2 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i1 | 0, 0);
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   };
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i12 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i12);
   i1 = i11 + 496 | 0;
   __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE(i12, i11, 114, i10);
   i2 = i11 + 504 + 3 | 0;
   if ((HEAP8[i2 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i1 >> 2] >> 2] = 0;
    HEAP32[i11 + 500 >> 2] = 0;
   } else {
    HEAP32[i1 >> 2] = 0;
    HEAP8[i2 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i1 | 0, 0);
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   };
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i12 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i12);
   i1 = i11 + 508 | 0;
   __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE(i12, i11, 120, i10);
   i2 = i11 + 516 + 3 | 0;
   if ((HEAP8[i2 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i1 >> 2] >> 2] = 0;
    HEAP32[i11 + 512 >> 2] = 0;
   } else {
    HEAP32[i1 >> 2] = 0;
    HEAP8[i2 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i1 | 0, 0);
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   };
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i12 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i12);
   i2 = i11 + 520 | 0;
   __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE(i12, i11, 88, i10);
   i1 = i11 + 528 + 3 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
    HEAP32[i11 + 524 >> 2] = 0;
   } else {
    HEAP32[i2 >> 2] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i2 | 0, 0);
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   };
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i12 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i12);
   STACKTOP = i13;
   return;
  } else if ((i1 | 0) == 38) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else if ((i1 | 0) == 39) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i14 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i14);
    }
   }
   ___resumeException(i1 | 0);
  } else if ((i1 | 0) == 44) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0); else if ((i1 | 0) == 48) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else if ((i1 | 0) == 49) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i14 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i14);
    }
   }
   ___resumeException(i1 | 0);
  } else if ((i1 | 0) == 54) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0);
 } else if ((i1 | 0) == 7) {
  i14 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i14);
 } else if ((i1 | 0) == 8) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i1 | 0) == 13) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0); else if ((i1 | 0) == 17) {
  i14 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i14);
 } else if ((i1 | 0) == 18) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i14 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i14);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i1 | 0) == 23) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0);
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i15, i16, i26, i1, i2, i57, i62, i63, i64) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i57 = i57 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i65 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, f93 = f0;
 i66 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i65 = i66 + 16 | 0;
 i17 = i66;
 if (i2 >>> 0 >= i57 >>> 0) {
  STACKTOP = i66;
  return;
 }
 i18 = i1 + 500 | 0;
 i19 = i17 + 4 | 0;
 i20 = i17 + 8 | 0;
 i21 = i17 + 12 | 0;
 i22 = i1 + 520 | 0;
 i23 = i15 + 32 | 0;
 i24 = i15 + 4 | 0;
 i25 = i15 + 8 | 0;
 i27 = i15 + 12 | 0;
 i28 = i15 + 16 | 0;
 i29 = i15 + 20 | 0;
 i30 = i15 + 24 | 0;
 i31 = i15 + 28 | 0;
 i32 = i16 + 32 | 0;
 i33 = i16 + 4 | 0;
 i34 = i16 + 8 | 0;
 i35 = i16 + 12 | 0;
 i36 = i16 + 16 | 0;
 i37 = i16 + 20 | 0;
 i38 = i16 + 24 | 0;
 i39 = i16 + 28 | 0;
 i40 = i26 + 32 | 0;
 i41 = i26 + 4 | 0;
 i42 = i26 + 8 | 0;
 i43 = i26 + 12 | 0;
 i44 = i26 + 16 | 0;
 i45 = i26 + 20 | 0;
 i46 = i26 + 24 | 0;
 i47 = i26 + 28 | 0;
 i48 = i63 + 12 | 0;
 i49 = i63 + 24 | 0;
 i50 = i63 + 4 | 0;
 i51 = i63 + 16 | 0;
 i52 = i63 + 28 | 0;
 i53 = i63 + 8 | 0;
 i54 = i63 + 20 | 0;
 i55 = i63 + 32 | 0;
 i56 = i64 + 4 | 0;
 i58 = i64 + 8 | 0;
 i59 = i64 + 12 | 0;
 i60 = i1 + 60 | 0;
 i61 = i1 + 80 | 0;
 i1 = i1 + 100 | 0;
 do {
  i84 = (HEAP32[i18 >> 2] | 0) + (i2 << 2) | 0;
  i83 = (HEAP32[i84 + 4 >> 2] | 0) + 306581307 | 0;
  i82 = (HEAP32[i84 + 8 >> 2] | 0) + 306581307 | 0;
  i81 = (HEAP32[i84 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i84 >> 2] | 0) + 306581307;
  HEAP32[i19 >> 2] = i83;
  HEAP32[i20 >> 2] = i82;
  HEAP32[i21 >> 2] = i81;
  __Z17GenerateRandomNx3RKN4math5_int4E(i65, i17);
  i81 = (HEAP32[i22 >> 2] | 0) + (i2 << 2) | 0;
  f75 = Math_fround(HEAPF32[i81 >> 2]);
  f73 = Math_fround(HEAPF32[i81 + 4 >> 2]);
  f71 = Math_fround(HEAPF32[i81 + 8 >> 2]);
  f75 = Math_fround(f75 * Math_fround(.00999999977));
  f73 = Math_fround(f73 * Math_fround(.00999999977));
  f71 = Math_fround(f71 * Math_fround(.00999999977));
  f69 = Math_fround(Math_fround(HEAPF32[i81 + 12 >> 2]) * Math_fround(.00999999977));
  f76 = Math_fround(HEAPF32[i23 >> 2]);
  f5 = Math_fround(HEAPF32[i15 >> 2]);
  f4 = Math_fround(f75 * f5);
  f3 = Math_fround(f73 * f5);
  f6 = Math_fround(f71 * f5);
  f5 = Math_fround(f69 * f5);
  f8 = Math_fround(HEAPF32[i24 >> 2]);
  f4 = Math_fround(f75 * Math_fround(f4 + f8));
  f3 = Math_fround(f73 * Math_fround(f3 + f8));
  f6 = Math_fround(f71 * Math_fround(f6 + f8));
  f8 = Math_fround(f69 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i25 >> 2]);
  f4 = Math_fround(f75 * Math_fround(f5 + f4));
  f3 = Math_fround(f73 * Math_fround(f5 + f3));
  f6 = Math_fround(f71 * Math_fround(f5 + f6));
  f8 = Math_fround(f69 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i27 >> 2]);
  f4 = Math_fround(f5 + f4);
  f3 = Math_fround(f5 + f3);
  f6 = Math_fround(f5 + f6);
  f8 = Math_fround(f5 + f8);
  f5 = Math_fround(f75 - f76);
  f79 = Math_fround(f73 - f76);
  f78 = Math_fround(f71 - f76);
  f77 = Math_fround(f69 - f76);
  f13 = Math_fround(HEAPF32[i28 >> 2]);
  f14 = Math_fround(f5 * f13);
  f12 = Math_fround(f79 * f13);
  f10 = Math_fround(f78 * f13);
  f13 = Math_fround(f77 * f13);
  f80 = Math_fround(HEAPF32[i29 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f14 + f80));
  f12 = Math_fround(f79 * Math_fround(f12 + f80));
  f10 = Math_fround(f78 * Math_fround(f10 + f80));
  f80 = Math_fround(f77 * Math_fround(f13 + f80));
  f13 = Math_fround(HEAPF32[i30 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f13 + f14));
  f12 = Math_fround(f79 * Math_fround(f13 + f12));
  f10 = Math_fround(f78 * Math_fround(f13 + f10));
  f80 = Math_fround(f77 * Math_fround(f13 + f80));
  f13 = Math_fround(HEAPF32[i31 >> 2]);
  f14 = Math_fround(f13 + f14);
  f12 = Math_fround(f13 + f12);
  f10 = Math_fround(f13 + f10);
  f80 = Math_fround(f13 + f80);
  f4 = f75 > f76 ? f14 : f4;
  f3 = f73 > f76 ? f12 : f3;
  f6 = f71 > f76 ? f10 : f6;
  f8 = f69 > f76 ? f80 : f8;
  f80 = Math_fround(HEAPF32[i32 >> 2]);
  f76 = Math_fround(HEAPF32[i16 >> 2]);
  f10 = Math_fround(f75 * f76);
  f12 = Math_fround(f73 * f76);
  f14 = Math_fround(f71 * f76);
  f76 = Math_fround(f69 * f76);
  f13 = Math_fround(HEAPF32[i33 >> 2]);
  f10 = Math_fround(f75 * Math_fround(f10 + f13));
  f12 = Math_fround(f73 * Math_fround(f12 + f13));
  f14 = Math_fround(f71 * Math_fround(f14 + f13));
  f13 = Math_fround(f69 * Math_fround(f76 + f13));
  f76 = Math_fround(HEAPF32[i34 >> 2]);
  f10 = Math_fround(f75 * Math_fround(f76 + f10));
  f12 = Math_fround(f73 * Math_fround(f76 + f12));
  f14 = Math_fround(f71 * Math_fround(f76 + f14));
  f13 = Math_fround(f69 * Math_fround(f76 + f13));
  f76 = Math_fround(HEAPF32[i35 >> 2]);
  f10 = Math_fround(f76 + f10);
  f12 = Math_fround(f76 + f12);
  f14 = Math_fround(f76 + f14);
  f13 = Math_fround(f76 + f13);
  f76 = Math_fround(f75 - f80);
  f77 = Math_fround(f73 - f80);
  f78 = Math_fround(f71 - f80);
  f79 = Math_fround(f69 - f80);
  f5 = Math_fround(HEAPF32[i36 >> 2]);
  f7 = Math_fround(f76 * f5);
  f9 = Math_fround(f77 * f5);
  f11 = Math_fround(f78 * f5);
  f5 = Math_fround(f79 * f5);
  f68 = Math_fround(HEAPF32[i37 >> 2]);
  f7 = Math_fround(f76 * Math_fround(f7 + f68));
  f9 = Math_fround(f77 * Math_fround(f9 + f68));
  f11 = Math_fround(f78 * Math_fround(f11 + f68));
  f68 = Math_fround(f79 * Math_fround(f5 + f68));
  f5 = Math_fround(HEAPF32[i38 >> 2]);
  f7 = Math_fround(f76 * Math_fround(f5 + f7));
  f9 = Math_fround(f77 * Math_fround(f5 + f9));
  f11 = Math_fround(f78 * Math_fround(f5 + f11));
  f68 = Math_fround(f79 * Math_fround(f5 + f68));
  f5 = Math_fround(HEAPF32[i39 >> 2]);
  f7 = Math_fround(f5 + f7);
  f9 = Math_fround(f5 + f9);
  f11 = Math_fround(f5 + f11);
  f68 = Math_fround(f5 + f68);
  f10 = f75 > f80 ? f7 : f10;
  f12 = f73 > f80 ? f9 : f12;
  f14 = f71 > f80 ? f11 : f14;
  f13 = f69 > f80 ? f68 : f13;
  f68 = Math_fround(HEAPF32[i40 >> 2]);
  f80 = Math_fround(HEAPF32[i26 >> 2]);
  f11 = Math_fround(f75 * f80);
  f9 = Math_fround(f73 * f80);
  f7 = Math_fround(f71 * f80);
  f80 = Math_fround(f69 * f80);
  f5 = Math_fround(HEAPF32[i41 >> 2]);
  f11 = Math_fround(f75 * Math_fround(f11 + f5));
  f9 = Math_fround(f73 * Math_fround(f9 + f5));
  f7 = Math_fround(f71 * Math_fround(f7 + f5));
  f5 = Math_fround(f69 * Math_fround(f80 + f5));
  f80 = Math_fround(HEAPF32[i42 >> 2]);
  f11 = Math_fround(f75 * Math_fround(f80 + f11));
  f9 = Math_fround(f73 * Math_fround(f80 + f9));
  f7 = Math_fround(f71 * Math_fround(f80 + f7));
  f5 = Math_fround(f69 * Math_fround(f80 + f5));
  f80 = Math_fround(HEAPF32[i43 >> 2]);
  f11 = Math_fround(f80 + f11);
  f9 = Math_fround(f80 + f9);
  f7 = Math_fround(f80 + f7);
  f5 = Math_fround(f80 + f5);
  f80 = Math_fround(f75 - f68);
  f79 = Math_fround(f73 - f68);
  f78 = Math_fround(f71 - f68);
  f77 = Math_fround(f69 - f68);
  f76 = Math_fround(HEAPF32[i44 >> 2]);
  f74 = Math_fround(f80 * f76);
  f72 = Math_fround(f79 * f76);
  f70 = Math_fround(f78 * f76);
  f76 = Math_fround(f77 * f76);
  f67 = Math_fround(HEAPF32[i45 >> 2]);
  f74 = Math_fround(f80 * Math_fround(f74 + f67));
  f72 = Math_fround(f79 * Math_fround(f72 + f67));
  f70 = Math_fround(f78 * Math_fround(f70 + f67));
  f67 = Math_fround(f77 * Math_fround(f76 + f67));
  f76 = Math_fround(HEAPF32[i46 >> 2]);
  f74 = Math_fround(f80 * Math_fround(f76 + f74));
  f72 = Math_fround(f79 * Math_fround(f76 + f72));
  f70 = Math_fround(f78 * Math_fround(f76 + f70));
  f67 = Math_fround(f77 * Math_fround(f76 + f67));
  f76 = Math_fround(HEAPF32[i47 >> 2]);
  f74 = Math_fround(f76 + f74);
  f72 = Math_fround(f76 + f72);
  f70 = Math_fround(f76 + f70);
  f67 = Math_fround(f76 + f67);
  f11 = f75 > f68 ? f74 : f11;
  f9 = f73 > f68 ? f72 : f9;
  f7 = f71 > f68 ? f70 : f7;
  f5 = f69 > f68 ? f67 : f5;
  if (i62) {
   f71 = Math_fround(HEAPF32[i63 >> 2]);
   f69 = Math_fround(f4 * f71);
   f80 = Math_fround(f3 * f71);
   f70 = Math_fround(f6 * f71);
   f71 = Math_fround(f8 * f71);
   f75 = Math_fround(HEAPF32[i48 >> 2]);
   f69 = Math_fround(f69 + Math_fround(f10 * f75));
   f80 = Math_fround(f80 + Math_fround(f12 * f75));
   f70 = Math_fround(f70 + Math_fround(f14 * f75));
   f75 = Math_fround(f71 + Math_fround(f13 * f75));
   f71 = Math_fround(HEAPF32[i49 >> 2]);
   f69 = Math_fround(f69 + Math_fround(f11 * f71));
   f80 = Math_fround(f80 + Math_fround(f9 * f71));
   f70 = Math_fround(f70 + Math_fround(f7 * f71));
   f71 = Math_fround(f75 + Math_fround(f5 * f71));
   f75 = Math_fround(HEAPF32[i50 >> 2]);
   f72 = Math_fround(f4 * f75);
   f73 = Math_fround(f3 * f75);
   f74 = Math_fround(f6 * f75);
   f75 = Math_fround(f8 * f75);
   f79 = Math_fround(HEAPF32[i51 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f10 * f79));
   f73 = Math_fround(f73 + Math_fround(f12 * f79));
   f74 = Math_fround(f74 + Math_fround(f14 * f79));
   f79 = Math_fround(f75 + Math_fround(f13 * f79));
   f75 = Math_fround(HEAPF32[i52 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f11 * f75));
   f73 = Math_fround(f73 + Math_fround(f9 * f75));
   f74 = Math_fround(f74 + Math_fround(f7 * f75));
   f75 = Math_fround(f79 + Math_fround(f5 * f75));
   f79 = Math_fround(HEAPF32[i53 >> 2]);
   f76 = Math_fround(f4 * f79);
   f77 = Math_fround(f3 * f79);
   f78 = Math_fround(f6 * f79);
   f3 = Math_fround(f8 * f79);
   f79 = Math_fround(HEAPF32[i54 >> 2]);
   f76 = Math_fround(f76 + Math_fround(f10 * f79));
   f77 = Math_fround(f77 + Math_fround(f12 * f79));
   f78 = Math_fround(f78 + Math_fround(f14 * f79));
   f79 = Math_fround(f3 + Math_fround(f13 * f79));
   f3 = Math_fround(HEAPF32[i55 >> 2]);
   f4 = f69;
   f6 = f70;
   f8 = f71;
   f10 = f72;
   f12 = f73;
   f14 = f74;
   f13 = f75;
   f11 = Math_fround(f76 + Math_fround(f11 * f3));
   f9 = Math_fround(f77 + Math_fround(f9 * f3));
   f7 = Math_fround(f78 + Math_fround(f7 * f3));
   f5 = Math_fround(f79 + Math_fround(f5 * f3));
   f3 = f80;
  }
  f70 = Math_fround(HEAPF32[i64 >> 2]);
  f68 = Math_fround(f4 * f70);
  f69 = Math_fround(HEAPF32[i56 >> 2]);
  f93 = Math_fround(f3 * f69);
  f67 = Math_fround(HEAPF32[i58 >> 2]);
  f3 = Math_fround(f6 * f67);
  f80 = Math_fround(HEAPF32[i59 >> 2]);
  f4 = Math_fround(f8 * f80);
  f6 = Math_fround(f10 * f70);
  f8 = Math_fround(f12 * f69);
  f10 = Math_fround(f14 * f67);
  f12 = Math_fround(f13 * f80);
  f13 = Math_fround(f11 * f70);
  f14 = Math_fround(f9 * f69);
  f67 = Math_fround(f7 * f67);
  f80 = Math_fround(f5 * f80);
  i92 = (HEAP32[i60 >> 2] | 0) + (i2 << 2) | 0;
  f69 = Math_fround(HEAPF32[i92 >> 2]);
  i91 = i92 + 4 | 0;
  f70 = Math_fround(HEAPF32[i91 >> 2]);
  i90 = i92 + 8 | 0;
  f71 = Math_fround(HEAPF32[i90 >> 2]);
  i89 = i92 + 12 | 0;
  f72 = Math_fround(HEAPF32[i89 >> 2]);
  i88 = (HEAP32[i61 >> 2] | 0) + (i2 << 2) | 0;
  f73 = Math_fround(HEAPF32[i88 >> 2]);
  i87 = i88 + 4 | 0;
  f74 = Math_fround(HEAPF32[i87 >> 2]);
  i86 = i88 + 8 | 0;
  f75 = Math_fround(HEAPF32[i86 >> 2]);
  i85 = i88 + 12 | 0;
  f76 = Math_fround(HEAPF32[i85 >> 2]);
  i81 = (HEAP32[i1 >> 2] | 0) + (i2 << 2) | 0;
  f77 = Math_fround(HEAPF32[i81 >> 2]);
  i82 = i81 + 4 | 0;
  f78 = Math_fround(HEAPF32[i82 >> 2]);
  i83 = i81 + 8 | 0;
  f79 = Math_fround(HEAPF32[i83 >> 2]);
  i84 = i81 + 12 | 0;
  f70 = Math_fround(f93 + f70);
  f71 = Math_fround(f3 + f71);
  f72 = Math_fround(f4 + f72);
  f73 = Math_fround(f6 + f73);
  f74 = Math_fround(f8 + f74);
  f75 = Math_fround(f10 + f75);
  f76 = Math_fround(f12 + f76);
  f77 = Math_fround(f13 + f77);
  f78 = Math_fround(f14 + f78);
  f79 = Math_fround(f67 + f79);
  f80 = Math_fround(f80 + Math_fround(HEAPF32[i84 >> 2]));
  HEAPF32[i92 >> 2] = Math_fround(f68 + f69);
  HEAPF32[i91 >> 2] = f70;
  HEAPF32[i90 >> 2] = f71;
  HEAPF32[i89 >> 2] = f72;
  HEAPF32[i88 >> 2] = f73;
  HEAPF32[i87 >> 2] = f74;
  HEAPF32[i86 >> 2] = f75;
  HEAPF32[i85 >> 2] = f76;
  HEAPF32[i81 >> 2] = f77;
  HEAPF32[i82 >> 2] = f78;
  HEAPF32[i83 >> 2] = f79;
  HEAPF32[i84 >> 2] = f80;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i57 >>> 0);
 STACKTOP = i66;
 return;
}

function __ZN7dtCrowd17UpdateMoveRequestEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i71 + 24 | 0;
 i28 = i71 + 12 | 0;
 i39 = i71;
 if ((HEAP16[gb + 1459284 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459284 | 0, i26);
  i27 = gb + 1459284 | 0;
 } else i27 = 0;
 i69 = i1 + 460 | 0;
 L4 : do if ((HEAP32[i69 >> 2] | 0) > 0) {
  i29 = i1 + 456 | 0;
  i30 = i1 + 16 | 0;
  i31 = i1 + 24 | 0;
  i32 = i1 + 464 | 0;
  i33 = i1 + 432 | 0;
  i34 = i39 + 4 | 0;
  i35 = i39 + 8 | 0;
  i36 = i1 + 452 | 0;
  i37 = i1 + 32 | 0;
  i38 = i1 + 420 | 0;
  i40 = i1 + 248 | 0;
  i41 = i1 + 36 | 0;
  i42 = i1 + 40 | 0;
  i43 = i1 + 44 | 0;
  i44 = i1 + 64 | 0;
  i45 = i1 + 48 | 0;
  i46 = i28 + 4 | 0;
  i47 = i1 + 52 | 0;
  i48 = i28 + 8 | 0;
  i49 = i1 + 56 | 0;
  i50 = i1 + 72 | 0;
  i51 = i1 + 92 | 0;
  i52 = i1 + 84 | 0;
  i53 = i1 + 104 | 0;
  i54 = i1 + 96 | 0;
  i55 = i1 + 236 | 0;
  i56 = i1 + 240 | 0;
  i57 = i1 + 32 | 0;
  i58 = i1 + 376 | 0;
  i59 = i1 + 372 | 0;
  i60 = i1 + 80 | 0;
  i61 = i39 + 4 | 0;
  i62 = i39 + 8 | 0;
  i63 = i1 + 100 | 0;
  i64 = i26 + 4 | 0;
  i65 = i26 + 8 | 0;
  i66 = i1 + 428 | 0;
  i67 = i1 + 424 | 0;
  i68 = i1 + 256 | 0;
  i1 = HEAP32[i1 + 448 >> 2] | 0;
  i25 = 0;
  do {
   i22 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i25 << 2) >> 2] | 0;
   i23 = HEAP32[i30 >> 2] | 0;
   i24 = i23 + (i22 * 608 | 0) + 602 | 0;
   i21 = i23 + (i22 * 608 | 0) + 600 | 0;
   i2 = HEAP8[i21 >> 0] | 0;
   if ((HEAP8[i24 >> 0] & 5) == 5) {
    if (i2 << 24 >> 24 == 1) {
     i3 = (HEAP32[i31 >> 2] | 0) + (i22 * 132 | 0) | 0;
     i5 = i23 + (i22 * 608 | 0) + 592 | 0;
     __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i32 >> 2] | 0, i23 + (i22 * 608 | 0) + 564 | 0, i33, i3, i5, i28) | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     if ((i4 | 0) == 0 & (i5 | 0) == 0) {
      HEAP8[i21 >> 0] = 0;
      i2 = 0;
     } else {
      i6 = HEAP32[i23 + (i22 * 608 | 0) >> 2] | 0;
      HEAP32[i39 >> 2] = i6;
      i7 = HEAP32[i23 + (i22 * 608 | 0) + 4 >> 2] | 0;
      HEAP32[i34 >> 2] = i7;
      i8 = HEAP32[i23 + (i22 * 608 | 0) + 8 >> 2] | 0;
      HEAP32[i35 >> 2] = i8;
      i9 = i23 + (i22 * 608 | 0) + 28 | 0;
      i11 = HEAP32[i9 >> 2] | 0;
      i10 = HEAP32[i11 >> 2] | 0;
      i11 = HEAP32[i11 + 4 >> 2] | 0;
      if ((i10 | 0) == 0 & (i11 | 0) == 0) i2 = HEAP32[i36 >> 2] | 0; else {
       if (!(HEAP32[i37 >> 2] | 0)) {
        i20 = HEAP8[i38 >> 0] | 0;
        i2 = HEAP32[i40 >> 2] | 0;
        i19 = i2 + 1 | 0;
        HEAP32[i40 >> 2] = (i19 | 0) == 0 ? i2 + 2 | 0 : i19;
        HEAP32[i37 >> 2] = i2;
        HEAP32[i41 >> 2] = i6;
        HEAP32[i42 >> 2] = i7;
        HEAP32[i43 >> 2] = i8;
        i19 = i44;
        HEAP32[i19 >> 2] = i10;
        HEAP32[i19 + 4 >> 2] = i11;
        HEAP32[i45 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
        i19 = i50;
        HEAP32[i19 >> 2] = i4;
        HEAP32[i19 + 4 >> 2] = i5;
        HEAP32[i51 >> 2] = 0;
        HEAP32[i52 >> 2] = 0;
        _memcpy(i53 | 0, i3 | 0, 132) | 0;
        HEAP32[i54 >> 2] = 0;
        HEAP8[i55 >> 0] = i20;
        i3 = HEAP32[i56 >> 2] | 0;
        if (i3 | 0) {
         __Z6dtFreePv(HEAP32[i3 + 48 >> 2] | 0);
         __Z6dtFreePv(HEAP32[(HEAP32[i56 >> 2] | 0) + 52 >> 2] | 0);
         __Z6dtFreePv(HEAP32[i56 >> 2] | 0);
        }
        HEAP32[i56 >> 2] = 0;
       } else i2 = 0;
       HEAP32[i36 >> 2] = i2;
      }
      if (!i2) {
       HEAP8[i21 >> 0] = 0;
       i2 = 0;
      } else {
       HEAP8[i21 >> 0] = 2;
       i5 = HEAP32[i32 >> 2] | 0;
       i2 = i23 + (i22 * 608 | 0) + 36 | 0;
       if ((HEAP32[i2 >> 2] | 0) < 1) {
        i3 = HEAP32[i23 + (i22 * 608 | 0) + 40 >> 2] | 0;
        i4 = __Z9dtReallocPvi(HEAP32[i9 >> 2] | 0, i3 << 3) | 0;
        if (!i4) i2 = i9; else {
         HEAP32[i9 >> 2] = i4;
         HEAP32[i2 >> 2] = i3;
         i2 = i9;
        }
       } else i2 = i9;
       HEAP32[i23 + (i22 * 608 | 0) + 12 >> 2] = HEAP32[i39 >> 2];
       i20 = i23 + (i22 * 608 | 0) + 16 | 0;
       HEAP32[i20 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i23 + (i22 * 608 | 0) + 20 >> 2] = HEAP32[i35 >> 2];
       i2 = HEAP32[i2 >> 2] | 0;
       HEAP32[i2 >> 2] = i10;
       HEAP32[i2 + 4 >> 2] = i11;
       HEAP32[i23 + (i22 * 608 | 0) + 32 >> 2] = 1;
       HEAP8[i23 + (i22 * 608 | 0) + 44 >> 0] = 1;
       HEAP32[i26 >> 2] = HEAP32[i34 >> 2];
       i2 = HEAP32[i9 >> 2] | 0;
       __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i5, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i39, i26) | 0;
       HEAP32[i20 >> 2] = HEAP32[i26 >> 2];
       i2 = HEAP8[i21 >> 0] | 0;
      }
     }
    }
    if (i2 << 24 >> 24 == 2) {
     HEAP32[i28 >> 2] = 0;
     __ZN11dtPathQueue6updateEiPi(i57, i1, i28);
     i1 = i1 - (HEAP32[i28 >> 2] | 0) | 0;
     do if ((HEAP32[i57 >> 2] | 0) == (HEAP32[i36 >> 2] | 0)) {
      i18 = HEAP32[i51 >> 2] | 0;
      if ((i18 | 0) < 0) i70 = 32; else {
       if (!(i18 & 1073741824)) {
        i2 = HEAP8[i21 >> 0] | 0;
        break;
       }
       i19 = i23 + (i22 * 608 | 0) + 28 | 0;
       i15 = HEAP32[i19 >> 2] | 0;
       i20 = i23 + (i22 * 608 | 0) + 32 | 0;
       i16 = HEAP32[i20 >> 2] | 0;
       i2 = HEAP32[i52 >> 2] | 0;
       i3 = HEAP32[i58 >> 2] | 0;
       do if ((i2 | 0) > (i3 | 0)) {
        i2 = (i2 + 31 | 0) / 32 | 0;
        i3 = __Z9dtReallocPvi(HEAP32[i59 >> 2] | 0, i2 << 8) | 0;
        if (!i3) {
         i3 = HEAP32[i58 >> 2] | 0;
         break;
        } else {
         i17 = i2 << 5;
         HEAP32[i59 >> 2] = i3;
         HEAP32[i58 >> 2] = i17;
         i3 = i17;
         break;
        }
       } while (0);
       i17 = HEAP32[i59 >> 2] | 0;
       if (!(HEAP8[i38 >> 0] | 0)) i2 = 0; else {
        i2 = __Z7dtAlloci(4) | 0;
        if (!i2) i2 = 0; else HEAP32[i2 >> 2] = 0;
       }
       if ((HEAP32[i57 >> 2] | 0) == (HEAP32[i36 >> 2] | 0)) {
        i14 = HEAP32[i51 >> 2] | 0;
        i7 = i14 & 16777215;
        HEAP32[i57 >> 2] = 0;
        HEAP32[i51 >> 2] = 0;
        i6 = HEAP32[i52 >> 2] | 0;
        i6 = (i6 | 0) < (i3 | 0) ? i6 : i3;
        _memcpy(i17 | 0, HEAP32[i60 >> 2] | 0, i6 << 3 | 0) | 0;
        HEAP32[i39 >> 2] = HEAP32[i45 >> 2];
        HEAP32[i61 >> 2] = HEAP32[i47 >> 2];
        HEAP32[i62 >> 2] = HEAP32[i49 >> 2];
        if (!(i14 & 32)) i5 = HEAP32[i63 >> 2] | 0; else i5 = 0;
        if (i2 | 0) {
         __ZN15dtPathQueryInfo8copyFromERS_(i2, i56);
         i4 = HEAP32[i56 >> 2] | 0;
         if (i4 | 0) {
          __Z6dtFreePv(HEAP32[i4 + 48 >> 2] | 0);
          __Z6dtFreePv(HEAP32[(HEAP32[i56 >> 2] | 0) + 52 >> 2] | 0);
          __Z6dtFreePv(HEAP32[i56 >> 2] | 0);
         }
         HEAP32[i56 >> 2] = 0;
        }
        i4 = i7 | 1073741824;
       } else {
        i5 = 0;
        i6 = 0;
        i4 = -2147483648;
       }
       i14 = (i6 | 0) != 0 & (i4 | 0) > -1;
       do if (i2 | 0) {
        i4 = HEAP32[i2 >> 2] | 0;
        if (i4 | 0) HEAP32[i4 >> 2] = i22;
        i4 = HEAP32[i66 >> 2] | 0;
        if ((i4 | 0) > 0) {
         i13 = 0;
         i12 = 0;
         while (1) {
          i7 = HEAP32[i67 >> 2] | 0;
          i8 = HEAP32[i7 + (i13 << 2) >> 2] | 0;
          i9 = HEAP32[i8 >> 2] | 0;
          i10 = (i9 | 0) == 0;
          if (i10) i11 = -1; else i11 = HEAP32[i9 >> 2] | 0;
          if ((i11 | 0) == (i22 | 0)) {
           if (i8) {
            if (!i10) {
             __Z6dtFreePv(HEAP32[i9 + 48 >> 2] | 0);
             __Z6dtFreePv(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0);
             __Z6dtFreePv(HEAP32[i8 >> 2] | 0);
            }
            HEAP32[i8 >> 2] = 0;
            __Z6dtFreePv(i8);
            i4 = HEAP32[i66 >> 2] | 0;
            i7 = HEAP32[i67 >> 2] | 0;
           }
           HEAP32[i7 + (i13 << 2) >> 2] = i2;
           i7 = 1;
          } else i7 = i12;
          i13 = i13 + 1 | 0;
          if ((i13 | 0) >= (i4 | 0)) break; else i12 = i7;
         }
         if (i7) break;
        }
        i7 = __Z7dtAlloci((i4 << 2) + 4 | 0) | 0;
        i8 = HEAP32[i66 >> 2] | 0;
        if ((i8 | 0) > 0) {
         i4 = 0;
         do {
          HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[(HEAP32[i67 >> 2] | 0) + (i4 << 2) >> 2];
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) < (i8 | 0));
        }
        __Z6dtFreePv(HEAP32[i67 >> 2] | 0);
        HEAP32[i67 >> 2] = i7;
        i13 = HEAP32[i66 >> 2] | 0;
        HEAP32[i7 + (i13 << 2) >> 2] = i2;
        HEAP32[i66 >> 2] = i13 + 1;
       } while (0);
       HEAP32[i23 + (i22 * 608 | 0) + 48 >> 2] = i5;
       L93 : do if (i14) {
        i2 = i16 + -1 | 0;
        i13 = i15 + (i2 << 3) | 0;
        i14 = i17;
        if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i14 >> 2] | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (HEAP32[i14 + 4 >> 2] | 0) : 0) {
         if ((i16 | 0) > 1) {
          i6 = (i6 + i2 | 0) > (i3 | 0) ? i3 - i2 | 0 : i6;
          _memmove(i17 + (i16 << 3) + -8 | 0, i17 | 0, i6 << 3 | 0) | 0;
          _memcpy(i17 | 0, i15 | 0, i2 << 3 | 0) | 0;
          i6 = i6 + i2 | 0;
         }
         i7 = i6 + -1 | 0;
         i3 = i17 + (i7 << 3) | 0;
         i2 = HEAP32[i3 >> 2] | 0;
         i3 = HEAP32[i3 + 4 >> 2] | 0;
         i16 = i23 + (i22 * 608 | 0) + 592 | 0;
         do if (!((i2 | 0) == (HEAP32[i16 >> 2] | 0) ? (i3 | 0) == (HEAP32[i16 + 4 >> 2] | 0) : 0)) if (!((__ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf(HEAP32[i32 >> 2] | 0, i2, i3, i39, i26) | 0) & 1073741824)) break L93; else {
          HEAP32[i39 >> 2] = HEAP32[i26 >> 2];
          HEAP32[i61 >> 2] = HEAP32[i64 >> 2];
          HEAP32[i62 >> 2] = HEAP32[i65 >> 2];
          break;
         } while (0);
         i5 = HEAP32[i32 >> 2] | 0;
         i2 = i23 + (i22 * 608 | 0) + 36 | 0;
         do if ((HEAP32[i2 >> 2] | 0) < (i6 | 0)) {
          i3 = HEAP32[i23 + (i22 * 608 | 0) + 40 >> 2] | 0;
          i4 = i3 + i7 | 0;
          i3 = i4 - ((i4 | 0) % (i3 | 0) | 0) | 0;
          i4 = __Z9dtReallocPvi(HEAP32[i19 >> 2] | 0, i3 << 3) | 0;
          if (!i4) {
           i2 = i19;
           break;
          }
          HEAP32[i19 >> 2] = i4;
          HEAP32[i2 >> 2] = i3;
          i2 = i19;
         } else i2 = i19; while (0);
         HEAP32[i23 + (i22 * 608 | 0) + 12 >> 2] = HEAP32[i39 >> 2];
         i16 = i23 + (i22 * 608 | 0) + 16 | 0;
         HEAP32[i16 >> 2] = HEAP32[i61 >> 2];
         HEAP32[i23 + (i22 * 608 | 0) + 20 >> 2] = HEAP32[i62 >> 2];
         _memcpy(HEAP32[i2 >> 2] | 0, i17 | 0, i6 << 3 | 0) | 0;
         HEAP32[i20 >> 2] = i6;
         HEAP8[i23 + (i22 * 608 | 0) + 44 >> 0] = (i6 | 0) != 0 | i18 >>> 5 & 2;
         HEAP32[i26 >> 2] = HEAP32[i61 >> 2];
         i23 = (HEAP32[i19 >> 2] | 0) + (i7 << 3) | 0;
         __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i5, HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0, i39, i26) | 0;
         HEAP32[i16 >> 2] = HEAP32[i26 >> 2];
        }
       } while (0);
       HEAP8[i21 >> 0] = 0;
       i2 = 0;
      }
     } else i70 = 32; while (0);
     if ((i70 | 0) == 32) {
      i70 = 0;
      i2 = i23 + (i22 * 608 | 0) + 44 | 0;
      HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] & 254;
      HEAP8[i21 >> 0] = 0;
      i2 = 0;
     }
    }
    if (!(i2 << 24 >> 24)) i70 = 83; else i2 = i25;
   } else {
    if (i2 << 24 >> 24 == 2) {
     HEAP32[i37 >> 2] = 0;
     HEAP32[i51 >> 2] = 0;
     HEAP32[i68 >> 2] = 0;
     HEAP32[i36 >> 2] = 0;
    }
    HEAP8[i21 >> 0] = 0;
    i70 = 83;
   }
   if ((i70 | 0) == 83) {
    i70 = 0;
    HEAP8[i24 >> 0] = HEAP8[i24 >> 0] & -5;
    HEAP32[i37 >> 2] = 0;
    HEAP32[i51 >> 2] = 0;
    HEAP32[i68 >> 2] = 0;
    HEAP32[i36 >> 2] = 0;
    i2 = (HEAP32[i69 >> 2] | 0) + -1 | 0;
    HEAP32[i69 >> 2] = i2;
    if ((i2 | 0) != (i25 | 0)) {
     i24 = HEAP32[i29 >> 2] | 0;
     _memmove(i24 + (i25 << 2) | 0, i24 + (i25 + 1 << 2) | 0, i2 - i25 << 2 | 0) | 0;
    }
    i2 = i25 + -1 | 0;
   }
   i25 = i2 + 1 | 0;
   if ((i1 | 0) <= 0) break L4;
  } while ((i25 | 0) < (HEAP32[i69 >> 2] | 0));
 } while (0);
 if (!i27) {
  STACKTOP = i71;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i27);
 STACKTOP = i71;
 return;
}

function _PxSetJointGlobalFrame(i43, i28, i35) {
 i43 = i43 | 0;
 i28 = i28 | 0;
 i35 = i35 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i46 + 120 | 0;
 i44 = i46 + 128 | 0;
 i19 = i46 + 52 | 0;
 i9 = i46 + 48 | 0;
 i8 = i46 + 44 | 0;
 i39 = i46 + 16 | 0;
 i45 = i46 + 80 | 0;
 i41 = i46;
 i18 = i42 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i43 >> 2] | 0) + 28 >> 2] | 0, i43 | 0, i42 | 0, i18 | 0);
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 1065353216;
 i15 = i44 + 16 | 0;
 i16 = i44 + 20 | 0;
 i17 = i44 + 24 | 0;
 i40 = i44 + 28 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i44 + 40 >> 2] = 1065353216;
 i29 = i44 + 44 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i44 + 48 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i44 + 52 | 0;
 HEAP32[i31 >> 2] = 0;
 if (i28 | 0) {
  i20 = i28 + 4 | 0;
  i21 = i28 + 8 | 0;
  i22 = i19 + 16 | 0;
  i23 = i19 + 20 | 0;
  i24 = i19 + 24 | 0;
  i25 = i19 + 12 | 0;
  i26 = i19 + 4 | 0;
  i27 = i19 + 8 | 0;
  i4 = HEAP32[i42 >> 2] | 0;
  if (!i4) {
   i12 = HEAP32[i28 >> 2] | 0;
   i13 = HEAP32[i20 >> 2] | 0;
   i14 = HEAP32[i21 >> 2] | 0;
   i4 = i14;
   i6 = i13;
   i7 = i12;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i19 | 0, i4 | 0);
   f36 = Math_fround(HEAPF32[i28 >> 2]);
   f5 = Math_fround(f36 - Math_fround(HEAPF32[i22 >> 2]));
   f37 = Math_fround(HEAPF32[i20 >> 2]);
   f2 = Math_fround(f37 - Math_fround(HEAPF32[i23 >> 2]));
   f38 = Math_fround(HEAPF32[i21 >> 2]);
   f5 = Math_fround(f5 * Math_fround(2.0));
   f2 = Math_fround(f2 * Math_fround(2.0));
   f48 = Math_fround(Math_fround(f38 - Math_fround(HEAPF32[i24 >> 2])) * Math_fround(2.0));
   f1 = Math_fround(HEAPF32[i25 >> 2]);
   f47 = Math_fround(Math_fround(f1 * f1) + Math_fround(-.5));
   f3 = Math_fround(HEAPF32[i19 >> 2]);
   f34 = Math_fround(f5 * f3);
   f10 = Math_fround(HEAPF32[i26 >> 2]);
   f34 = Math_fround(f34 + Math_fround(f2 * f10));
   f11 = Math_fround(HEAPF32[i27 >> 2]);
   f34 = Math_fround(f34 + Math_fround(f48 * f11));
   f32 = Math_fround(Math_fround(f3 * f34) + Math_fround(Math_fround(f5 * f47) - Math_fround(f1 * Math_fround(Math_fround(f48 * f10) - Math_fround(f2 * f11)))));
   f33 = Math_fround(Math_fround(f10 * f34) + Math_fround(Math_fround(f2 * f47) - Math_fround(f1 * Math_fround(Math_fround(f5 * f11) - Math_fround(f48 * f3)))));
   f34 = Math_fround(Math_fround(Math_fround(f48 * f47) - Math_fround(f1 * Math_fround(Math_fround(f2 * f3) - Math_fround(f5 * f10)))) + Math_fround(f11 * f34));
   i12 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i14 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  }
  HEAP32[i15 >> 2] = i12;
  HEAP32[i16 >> 2] = i13;
  HEAP32[i17 >> 2] = i14;
  i12 = HEAP32[i18 >> 2] | 0;
  if (i12) {
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i19 | 0, i12 | 0);
   f34 = Math_fround(HEAPF32[i28 >> 2]);
   f34 = Math_fround(f34 - Math_fround(HEAPF32[i22 >> 2]));
   f32 = Math_fround(HEAPF32[i20 >> 2]);
   f32 = Math_fround(f32 - Math_fround(HEAPF32[i23 >> 2]));
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   f34 = Math_fround(f34 * Math_fround(2.0));
   f32 = Math_fround(f32 * Math_fround(2.0));
   f5 = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i24 >> 2])) * Math_fround(2.0));
   f11 = Math_fround(HEAPF32[i25 >> 2]);
   f10 = Math_fround(Math_fround(f11 * f11) + Math_fround(-.5));
   f33 = Math_fround(HEAPF32[i19 >> 2]);
   f48 = Math_fround(f34 * f33);
   f36 = Math_fround(HEAPF32[i26 >> 2]);
   f48 = Math_fround(f48 + Math_fround(f32 * f36));
   f37 = Math_fround(HEAPF32[i27 >> 2]);
   f48 = Math_fround(f48 + Math_fround(f5 * f37));
   f38 = Math_fround(Math_fround(f33 * f48) + Math_fround(Math_fround(f34 * f10) - Math_fround(f11 * Math_fround(Math_fround(f5 * f36) - Math_fround(f32 * f37)))));
   f47 = Math_fround(Math_fround(f36 * f48) + Math_fround(Math_fround(f32 * f10) - Math_fround(f11 * Math_fround(Math_fround(f34 * f37) - Math_fround(f5 * f33)))));
   f48 = Math_fround(Math_fround(Math_fround(f5 * f10) - Math_fround(f11 * Math_fround(Math_fround(f32 * f33) - Math_fround(f34 * f36)))) + Math_fround(f37 * f48));
   i7 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
  }
  HEAP32[i29 >> 2] = i7;
  HEAP32[i30 >> 2] = i6;
  HEAP32[i31 >> 2] = i4;
 }
 if (!i35) {
  i45 = HEAP32[i43 >> 2] | 0;
  i45 = i45 + 32 | 0;
  i45 = HEAP32[i45 >> 2] | 0;
  mftCall_viii(i45 | 0, i43 | 0, 0, i44 | 0);
  i45 = HEAP32[i43 >> 2] | 0;
  i45 = i45 + 32 | 0;
  i45 = HEAP32[i45 >> 2] | 0;
  mftCall_viii(i45 | 0, i43 | 0, 1, i40 | 0);
  STACKTOP = i46;
  return;
 }
 i7 = HEAP32[i35 >> 2] | 0;
 i6 = HEAP32[i35 + 4 >> 2] | 0;
 i4 = HEAP32[i35 + 8 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f5 * f5);
 f1 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f3 + Math_fround(f1 * f1));
 f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (f3 > Math_fround(0.0)) {
  f48 = Math_fround(Math_fround(1.0) / f3);
  f47 = Math_fround(f5 * f48);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  f47 = Math_fround(f1 * f48);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
  f48 = Math_fround(f2 * f48);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f37 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i35 = Math_fround(Math_abs(Math_fround(f37))) > Math_fround(.707106769);
 f38 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i35) {
  f10 = Math_fround(Math_fround(f37 * f37) + Math_fround(f38 * f38));
  f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f10))));
  f1 = Math_fround(-Math_fround(f37 * f11));
  f3 = Math_fround(f38 * f11);
  HEAP32[i9 >> 2] = 0;
  HEAPF32[i8 >> 2] = f3;
  f11 = Math_fround(f10 * f11);
  f10 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f10 * f1);
  f10 = Math_fround(-Math_fround(f10 * f3));
  f2 = Math_fround(0.0);
 } else {
  f1 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(Math_fround(f38 * f38) + Math_fround(f1 * f1));
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f10))));
  f2 = Math_fround(-Math_fround(f38 * f5));
  f1 = Math_fround(f1 * f5);
  HEAPF32[i9 >> 2] = f2;
  HEAP32[i8 >> 2] = 0;
  f5 = Math_fround(f10 * f5);
  f10 = Math_fround(f37 * f2);
  f11 = Math_fround(-Math_fround(f37 * f1));
  f3 = Math_fround(0.0);
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(f3 * f3))));
 if (f1 > Math_fround(0.0)) {
  f48 = Math_fround(Math_fround(1.0) / f1);
  HEAPF32[i9 >> 2] = Math_fround(f2 * f48);
  HEAPF32[i8 >> 2] = Math_fround(f3 * f48);
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f5 * f5))));
 if (f1 > Math_fround(0.0)) {
  f48 = Math_fround(Math_fround(1.0) / f1);
  f5 = Math_fround(f5 * f48);
  f10 = Math_fround(f10 * f48);
  f11 = Math_fround(f11 * f48);
 }
 i14 = i45 + 4 | 0;
 i15 = i45 + 8 | 0;
 i16 = i45 + 16 | 0;
 i17 = i45 + 20 | 0;
 i18 = i45 + 24 | 0;
 i19 = i45 + 28 | 0;
 i20 = i45 + 32 | 0;
 i21 = i41 + 4 | 0;
 i22 = i41 + 8 | 0;
 i23 = i41 + 12 | 0;
 i24 = i39 + 4 | 0;
 i25 = i39 + 8 | 0;
 i26 = i39 + 12 | 0;
 f36 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i27 = i45 + 12 | 0;
 i28 = 0;
 do {
  i8 = HEAP32[i42 + (i28 << 2) >> 2] | 0;
  if (!i8) {
   f1 = f5;
   f2 = f10;
   f3 = f11;
   f32 = f38;
   f33 = f37;
   f34 = f36;
   i8 = i7;
   i9 = i6;
   i12 = i4;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 84 >> 2] | 0, i39 | 0, i8 | 0);
   f50 = Math_fround(HEAPF32[i39 >> 2]);
   f53 = Math_fround(HEAPF32[i24 >> 2]);
   f32 = Math_fround(HEAPF32[i25 >> 2]);
   f49 = Math_fround(HEAPF32[i26 >> 2]);
   f34 = Math_fround(f50 + f50);
   f33 = Math_fround(f53 + f53);
   f51 = Math_fround(f32 + f32);
   f47 = Math_fround(f53 * f33);
   f2 = Math_fround(f32 * f51);
   f53 = Math_fround(f34 * f53);
   f48 = Math_fround(f34 * f32);
   f1 = Math_fround(f34 * f49);
   f32 = Math_fround(f33 * f32);
   f33 = Math_fround(f33 * f49);
   f49 = Math_fround(f51 * f49);
   f51 = Math_fround(Math_fround(Math_fround(1.0) - f47) - f2);
   f3 = Math_fround(f53 + f49);
   f52 = Math_fround(f48 - f33);
   f49 = Math_fround(f53 - f49);
   f34 = Math_fround(Math_fround(1.0) - Math_fround(f50 * f34));
   f2 = Math_fround(f34 - f2);
   f50 = Math_fround(f32 + f1);
   f33 = Math_fround(f48 + f33);
   f1 = Math_fround(f32 - f1);
   f47 = Math_fround(f34 - f47);
   f34 = Math_fround(Math_fround(f37 * f52) + Math_fround(Math_fround(f36 * f51) + Math_fround(f38 * f3)));
   f32 = Math_fround(Math_fround(f37 * f50) + Math_fround(Math_fround(f36 * f49) + Math_fround(f38 * f2)));
   f48 = Math_fround(Math_fround(f37 * f47) + Math_fround(Math_fround(f36 * f33) + Math_fround(f38 * f1)));
   f3 = Math_fround(Math_fround(f5 * f52) + Math_fround(Math_fround(f11 * f51) + Math_fround(f10 * f3)));
   f2 = Math_fround(Math_fround(f5 * f50) + Math_fround(Math_fround(f11 * f49) + Math_fround(f10 * f2)));
   f1 = Math_fround(Math_fround(f5 * f47) + Math_fround(Math_fround(f11 * f33) + Math_fround(f10 * f1)));
   i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   f33 = f48;
   i12 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f52 = Math_fround(Math_fround(f32 * f1) - Math_fround(f33 * f2));
  f53 = Math_fround(Math_fround(f33 * f3) - Math_fround(f1 * f34));
  f33 = Math_fround(Math_fround(f2 * f34) - Math_fround(f32 * f3));
  HEAP32[i45 >> 2] = i8;
  HEAP32[i14 >> 2] = i9;
  HEAP32[i15 >> 2] = i12;
  HEAPF32[i27 >> 2] = f3;
  HEAPF32[i16 >> 2] = f2;
  HEAPF32[i17 >> 2] = f1;
  HEAPF32[i18 >> 2] = f52;
  HEAPF32[i19 >> 2] = f53;
  HEAPF32[i20 >> 2] = f33;
  i8 = i44 + (i28 * 28 | 0) | 0;
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i41, i45);
  i29 = HEAP32[i41 >> 2] | 0;
  HEAP32[i8 >> 2] = i29;
  i30 = HEAP32[i21 >> 2] | 0;
  i9 = i44 + (i28 * 28 | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i30;
  i31 = HEAP32[i22 >> 2] | 0;
  i12 = i44 + (i28 * 28 | 0) + 8 | 0;
  HEAP32[i12 >> 2] = i31;
  i35 = HEAP32[i23 >> 2] | 0;
  i13 = i44 + (i28 * 28 | 0) + 12 | 0;
  HEAP32[i13 >> 2] = i35;
  f1 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f1 * f1);
  f2 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f33 + Math_fround(f2 * f2));
  f3 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f33 + Math_fround(f3 * f3));
  f32 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(Math_sqrt(Math_fround(f33 + Math_fround(f32 * f32))));
  if (f33 != Math_fround(0.0)) {
   f53 = Math_fround(Math_fround(1.0) / f33);
   HEAPF32[i8 >> 2] = Math_fround(f1 * f53);
   HEAPF32[i9 >> 2] = Math_fround(f2 * f53);
   HEAPF32[i12 >> 2] = Math_fround(f3 * f53);
   HEAPF32[i13 >> 2] = Math_fround(f32 * f53);
  }
  i28 = i28 + 1 | 0;
 } while ((i28 | 0) != 2);
 i45 = HEAP32[i43 >> 2] | 0;
 i45 = i45 + 32 | 0;
 i45 = HEAP32[i45 >> 2] | 0;
 mftCall_viii(i45 | 0, i43 | 0, 0, i44 | 0);
 i45 = HEAP32[i43 >> 2] | 0;
 i45 = i45 + 32 | 0;
 i45 = HEAP32[i45 >> 2] | 0;
 mftCall_viii(i45 | 0, i43 | 0, 1, i40 | 0);
 STACKTOP = i46;
 return;
}

function __ZN12ImageFilters12BlitMultiTapER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiPK8Vector2f11CubemapFace(i28, i5, i2, i32, i33, i34, i3) {
 i28 = i28 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i38 + 96 | 0;
 i35 = i38;
 i37 = i38 + 360 | 0;
 i4 = i38 + 480 | 0;
 i29 = i38 + 160 | 0;
 i30 = i38 + 476 | 0;
 i31 = i38 + 472 | 0;
 i1 = __ZN8Material9GetShaderEv(i32) | 0;
 if ((HEAP16[gb + 1110880 + 6 >> 1] | 0) > -1) {
  HEAP32[i35 >> 2] = i1;
  HEAP32[i27 >> 2] = HEAP32[i35 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110880 | 0, i27);
  i36 = gb + 1110880 | 0;
 } else i36 = 0;
 i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 1 ? 2 : 0;
 __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace(i2, i1, i3);
 HEAP32[i37 + 4 >> 2] = 1;
 HEAP32[i37 >> 2] = gb + 33952 + 8;
 i23 = gb + 64016 | 0;
 i26 = HEAP32[i23 + 4 >> 2] | 0;
 i25 = i35;
 HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 HEAP32[i37 + 32 >> 2] = 0;
 HEAP32[i37 + 44 >> 2] = 0;
 i25 = i37 + 48 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i37 + 36 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i35);
 i23 = i27;
 i24 = HEAP32[i23 + 4 >> 2] | 0;
 i20 = i26;
 HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i20 + 4 >> 2] = i24;
 i20 = gb + 64016 | 0;
 i24 = HEAP32[i20 + 4 >> 2] | 0;
 i23 = i35;
 HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i37 + 52 >> 2] = 0;
 HEAP32[i37 + 64 >> 2] = 0;
 i23 = i37 + 68 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i37 + 56 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i35);
 i20 = i27;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i22 = i24;
 HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 i22 = gb + 64016 | 0;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i20 = i35;
 HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 i20 = i37 + 72 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i37 + 84 >> 2] = 0;
 i21 = i37 + 88 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i37 + 76 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i35);
 i8 = i27;
 i19 = HEAP32[i8 + 4 >> 2] | 0;
 i18 = i22;
 HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i37 + 92 >> 2] = 0;
 HEAP32[i37 + 96 >> 2] = 0;
 i18 = gb + 64016 | 0;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i8 = i37 + 100 | 0;
 HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i8 + 4 >> 2] = i19;
 HEAP8[i37 + 108 >> 0] = 1;
 i8 = i37 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i8 = (i5 | 0) != 0;
 if (i8) {
  HEAP32[i4 >> 2] = HEAP32[gb + 1110892 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i4 >> 2];
  i1 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i32, i27) | 0;
  if (i1) __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i37, gb + 1110892 | 0, i5);
  i19 = Math_fround(HEAPF32[i5 + 72 >> 2]) < Math_fround(0.0);
  i18 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0, i5 | 0) | 0;
  f6 = Math_fround(i18 | 0);
  f7 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0, i5 | 0) | 0);
 } else {
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  i19 = 0;
  i1 = 0;
 }
 i15 = __Z12GetGfxDevicev() | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 HEAP32[i29 >> 2] = i2;
 i16 = i29 + 4 | 0;
 i17 = i29 + 68 | 0;
 i18 = i29 + 132 | 0;
 i3 = i17;
 i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i16;
 i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i18;
 i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 __ZN10Matrix4x4f8SetOrthoEffffff(i27, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(100.0)) | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 116 >> 2] | 0, i15 | 0, i27 | 0);
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0, gb + 1162292 | 0);
 i2 = HEAP32[i32 + 100 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i9 = 11; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i9 = 11;
 if ((i9 | 0) == 11) __ZN8Material15BuildPropertiesEv(i32);
 f13 = i19 ? Math_fround(1.0) : Math_fround(0.0);
 f14 = i19 ? Math_fround(0.0) : Math_fround(1.0);
 f12 = Math_fround(Math_fround(1.0) / f6);
 f12 = i8 ? f12 : Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / f7);
 f6 = i8 ? f6 : Math_fround(0.0);
 i4 = i34 + 4 | 0;
 i5 = i35 + 4 | 0;
 i8 = i35 + 8 | 0;
 i9 = i35 + 12 | 0;
 i10 = (i33 | 0) > 0;
 i11 = __ZNK8Material12GetPassCountEv(i32) | 0;
 if ((i11 | 0) > 0) {
  i3 = 0;
  do {
   HEAP32[i30 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(i30, gb + 378118 | 0);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i5 >> 2] = i2;
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAPF32[i9 >> 2] = f13;
   HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
   __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i32, i27, i35);
   i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i32, i3, i28, 0, 1) | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 184 >> 2] | 0, i15 | 0, i37 | 0);
   mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 580 >> 2] | 0, i15 | 0, 2, i2 | 0);
   if (i10) {
    if (i19) {
     i2 = 0;
     do {
      f39 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f39 = Math_fround(f12 * f39);
      f7 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f39 + Math_fround(0.0)), +Math_fround(f13 - f7), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    } else {
     i2 = 0;
     do {
      f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f7 = Math_fround(f12 * f7);
      f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(0.0)), +Math_fround(f13 + f39), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    }
    mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 0.0, 0.0, .100000001);
    if (i19) {
     i2 = 0;
     do {
      f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f7 = Math_fround(f12 * f7);
      f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(0.0)), +Math_fround(f14 - f39), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    } else {
     i2 = 0;
     do {
      f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f7 = Math_fround(f12 * f7);
      f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(0.0)), +Math_fround(f14 + f39), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    }
    mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 0.0, 1.0, .100000001);
    if (i19) {
     i2 = 0;
     do {
      f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f7 = Math_fround(f12 * f7);
      f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(1.0)), +Math_fround(f14 - f39), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    } else {
     i2 = 0;
     do {
      f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
      f7 = Math_fround(f12 * f7);
      f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
      mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(1.0)), +Math_fround(f14 + f39), 0.0);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i33 | 0));
    }
   } else {
    mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 0.0, 0.0, .100000001);
    mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 0.0, 1.0, .100000001);
   }
   mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 1.0, 1.0, .100000001);
   if (i10) if (i19) {
    i2 = 0;
    do {
     f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
     f7 = Math_fround(f12 * f7);
     f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
     mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(1.0)), +Math_fround(f13 - f39), 0.0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i33 | 0));
   } else {
    i2 = 0;
    do {
     f7 = Math_fround(HEAPF32[i34 + (i2 << 3) >> 2]);
     f7 = Math_fround(f12 * f7);
     f39 = Math_fround(f6 * Math_fround(HEAPF32[i34 + (i2 << 3) + 4 >> 2]));
     mftCall_viifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 576 >> 2] | 0, i15 | 0, i2 | 0, +Math_fround(f7 + Math_fround(1.0)), +Math_fround(f13 + f39), 0.0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i33 | 0));
   }
   mftCall_vifff(HEAP32[(HEAP32[i15 >> 2] | 0) + 560 >> 2] | 0, i15 | 0, 1.0, 0.0, .100000001);
   mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 584 >> 2] | 0, i15 | 0);
   __Z15gpu_time_samplev();
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i11 | 0));
 }
 if (i1) {
  HEAP32[i31 >> 2] = HEAP32[gb + 1110892 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i31 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i32, i27, 0);
 }
 i33 = HEAP32[i29 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 116 >> 2] | 0, i33 | 0, i18 | 0);
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 112 >> 2] | 0, i33 | 0, i17 | 0);
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 108 >> 2] | 0, i33 | 0, i16 | 0);
 i33 = HEAP32[i29 >> 2] | 0;
 i34 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 132 >> 2] | 0, i33 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 140 >> 2] | 0, i33 | 0) | 0, i34, i27);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i27, i35);
 i34 = i33 + 1364 | 0;
 HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
 i34 = i35 + 16 | 0;
 i32 = i33 + 1380 | 0;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 i32 = i35 + 32 | 0;
 i34 = i33 + 1396 | 0;
 HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 i34 = i35 + 48 | 0;
 i32 = i33 + 1412 | 0;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i32 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 i32 = i35 + 64 | 0;
 i34 = i33 + 1428 | 0;
 HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 i34 = i35 + 80 | 0;
 i35 = i33 + 1444 | 0;
 HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i37 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i22);
  HEAP32[i20 >> 2] = 0;
 }
 i1 = i37 + 52 | 0;
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i24);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i37 + 32 | 0;
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i26);
  HEAP32[i1 >> 2] = 0;
 }
 if (!i36) {
  STACKTOP = i38;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i36);
 STACKTOP = i38;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 64 | 0;
 i11 = i15;
 i12 = i15 + 96 | 0;
 i13 = i15 + 80 | 0;
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944604 | 0, i4, i7 + 28 | 0, 0);
 i14 = i8 + 16 | 0;
 i9 = i8 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944623 | 0, i6, i7 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944634 | 0, i4, i7 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944653 | 0, i4, i7 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i5 = i7 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944672 | 0, i4, i5, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 if ((HEAP32[i5 >> 2] | 0) == -2) {
  HEAP32[i12 >> 2] = 0;
  i5 = i12 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944686 | 0, i1, i12, 0);
  HEAP32[i11 >> 2] = -1;
  i2 = i11 + 48 | 0;
  i3 = i11 + 4 | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAP32[i11 + 52 >> 2] = 0;
  HEAP8[i11 + 56 >> 0] = 0;
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, gb + 946881 | 0, i11, 0);
  __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i11, i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i4 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i4 + (~(((i4 + -60 - i3 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i5 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 1;
   HEAP32[i10 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
  }
 } else {
  i1 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944686 | 0, i1, i7 + 40 | 0, 0);
  HEAP32[i11 >> 2] = -1;
  i2 = i11 + 48 | 0;
  i3 = i11 + 4 | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAP32[i11 + 52 >> 2] = 0;
  HEAP8[i11 + 56 >> 0] = 0;
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, gb + 946881 | 0, i11, 0);
  __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i11, i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944703 | 0, HEAP32[gb + 37052 >> 2] | 0, i7, 1);
 i4 = i11;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
 i4 = HEAP32[gb + 37152 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, i4, i11, 0);
 i5 = HEAP32[gb + 37008 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, i5, i4, i11, 0);
 i4 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, i5, i4, i11, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i5 = HEAP32[gb + 37224 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, i5, i4, i11 + 2 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, i5, i6, i11 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944719 | 0, i6, i7 + 36 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944732 | 0, i1, i7 + 80 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
 i5 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, i5, i11, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944743 | 0, i6, i7 + 192 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944752 | 0, i6, i7 + 196 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944762 | 0, HEAP32[gb + 37304 >> 2] | 0, i7 + 188 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i1 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944777 | 0, i1, i7 + 100 | 0, 1);
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i12, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i13, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i10, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, i5, i11, 0);
 HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 if ((HEAP8[i13 + 11 >> 0] | 0) >= 0) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  i13 = i7 + 116 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944789 | 0, i1, i13, 1);
  HEAP32[i12 >> 2] = 0;
  __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i11, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, gb + 1034708 | 0, i12, 0);
  i13 = i10 + 8 | 0;
  i11 = i13;
  i6 = i11;
  HEAP32[i6 >> 2] = 0;
  i11 = i11 + 4 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i11 = HEAP32[gb + 37040 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1048093 | 0, i11, i12, 1);
  i10 = HEAP32[i14 >> 2] | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i12 = i10 + (i12 * 24 | 0) + 12 | 0;
  HEAP32[i12 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  i12 = HEAP32[gb + 37248 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1048102 | 0, i12, i13, 1);
  i12 = HEAP32[i14 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i13 = HEAP32[i9 >> 2] | 0;
  i13 = i12 + (i13 * 24 | 0) + 12 | 0;
  HEAP32[i13 >> 2] = 8;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i8);
  i13 = i7 + 200 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944805 | 0, i11, i13, 0);
  i13 = HEAP32[i14 >> 2] | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = HEAP32[i9 >> 2] | 0;
  i14 = i13 + (i14 * 24 | 0) + 12 | 0;
  HEAP32[i14 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
  STACKTOP = i15;
  return;
 }
 i6 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i13 = i7 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944789 | 0, i1, i13, 1);
 HEAP32[i12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i11, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, gb + 1034708 | 0, i12, 0);
 i13 = i10 + 8 | 0;
 i11 = i13;
 i6 = i11;
 HEAP32[i6 >> 2] = 0;
 i11 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i11 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1048093 | 0, i11, i12, 1);
 i10 = HEAP32[i14 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i12 = i10 + (i12 * 24 | 0) + 12 | 0;
 HEAP32[i12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 i12 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1048102 | 0, i12, i13, 1);
 i12 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 i13 = i12 + (i13 * 24 | 0) + 12 | 0;
 HEAP32[i13 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i8);
 i13 = i7 + 200 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 944805 | 0, i11, i13, 0);
 i13 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 i14 = i13 + (i14 * 24 | 0) + 12 | 0;
 HEAP32[i14 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 STACKTOP = i15;
 return;
}

function __ZN13AnimationClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 32 | 0;
 i7 = i13 + 16 | 0;
 i4 = i13;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12);
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i11 + 212 >> 0] = i1;
 i3 = i11 + 92 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i3 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i11 + 93 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
 if (!(HEAP8[i3 >> 0] | 0)) {
  i3 = i11 + 100 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
  i2 = HEAP32[i11 + 104 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i12);
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i7 >> 2] = 0;
  i3 = i7 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i7, _llvm_bswap_i32(i1 | 0) | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i7);
 } else {
  HEAP32[i7 >> 2] = 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i7, _llvm_bswap_i32(i1 | 0) | 0);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i12);
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i2 | 0));
  if (!(HEAP32[i12 >> 2] & 33554432)) {
   HEAP32[i4 >> 2] = 0;
   i3 = i4 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
    i1 = HEAP32[i8 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i9 >> 2] = i2;
   }
   __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) do {
    __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
    i1 = i1 + 88 | 0;
   } while ((i1 | 0) != (i2 | 0));
   __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i11, i4);
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i4);
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i8 + 4 | 0;
    do {
     i3 = i2 + -204 | 0;
     HEAP32[i6 >> 2] = i3;
     i4 = i2 + -36 | 0;
     if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
      HEAP32[i4 >> 2] = 0;
     }
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i4 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i2 + -192 >> 2] | 0;
      HEAP32[i8 >> 2] = 66;
      HEAP32[i5 >> 2] = i3;
      __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
     }
     i2 = HEAP32[i6 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i7 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 25;
   HEAP32[i8 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
  }
 }
 i3 = i11 + 116 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 120 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 132 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 136 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 148 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 152 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 164 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 168 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 132 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 180 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 184 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 60 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i11 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i1;
  i1 = i7;
 }
 HEAP32[i11 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i12, i11 + 272 | 0, gb + 1034411 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i12, i11 + 284 | 0, gb + 1034420 | 0, 0);
 HEAP32[i12 + 4 >> 2] = i11 + 56;
 __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb1EEEvRPT_PKcRjS9_RT0_(i11 + 216 | 0, gb + 898128 | 0, i11 + 220 | 0, gb + 898141 | 0, i12);
 i3 = i11 + 224 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i12 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i11 + 236 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i12, i11 + 244 | 0, 0);
 i3 = i11 + 196 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 200 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i13;
 return;
}

function __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali(i8, i29, i16, i18, i24, i28, i27, f7, i1, i4, i32) {
 i8 = i8 | 0;
 i29 = i29 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i24 = i24 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 f7 = Math_fround(f7);
 i1 = i1 | 0;
 i4 = i4 | 0;
 i32 = i32 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f17 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f25 = f0, f26 = f0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36 + 36 | 0;
 i31 = i36;
 i34 = i36 + 16 | 0;
 i35 = i36 + 32 | 0;
 if (!(HEAP32[gb + 1114516 >> 2] | 0)) {
  i30 = __Z15GetScriptMapperv() | 0;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i33, gb + 1046327 | 0, 26);
  i30 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i30, i33) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
  i30 = __ZN8Material14CreateMaterialER6Shaderib(i30, 61, 0) | 0;
  HEAP32[gb + 1114516 >> 2] = i30;
  i30 = __ZN8Material9GetShaderEv(i30) | 0;
  HEAP32[gb + 1114520 >> 2] = i30;
 }
 if (!i29) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 385956 | 0, 0, gb + 385988 | 0, 496, 1, 0, 0, 0);
  STACKTOP = i36;
  return;
 }
 i30 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
  i37 = HEAP32[i1 >> 2] | 0;
  i6 = i1;
  i2 = i37 >>> 16;
  i3 = i37;
  i5 = i37 & 255;
  i1 = i37 >>> 8 & 255;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i6 = i1;
  i2 = i3;
  i5 = HEAP8[i1 + 2 >> 0] | 0;
  i1 = HEAP8[i1 + 1 >> 0] | 0;
 }
 i2 = i3 & -16777216 | i2 << 16 & 16711680 | (i1 & 255) << 8 | i5 & 255;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i34 >> 2] = 0;
 i1 = i34 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = -1;
 HEAP32[i34 + 12 >> 2] = 0;
 mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 108 >> 2] | 0, i33 | 0, i29 | 0);
 f17 = Math_fround(HEAPF32[i33 >> 2]);
 f9 = Math_fround(f17 * f7);
 i5 = i33 + 4 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f7);
 f17 = Math_fround(f17 * Math_fround(mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 136 >> 2] | 0, i29 | 0) | 0));
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f15 * Math_fround(mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 140 >> 2] | 0, i29 | 0) | 0));
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f26 = Math_fround(f22 + Math_fround(.5));
 i5 = f26 >= Math_fround(0.0);
 f25 = Math_fround(f26 + Math_fround(-.99999994));
 f25 = Math_fround(~~(i5 ? f26 : f25) | 0);
 f22 = Math_fround(Math_fround(f22 + Math_fround(HEAPF32[i8 + 8 >> 2])) + Math_fround(.5));
 i5 = f22 >= Math_fround(0.0);
 f26 = Math_fround(f22 + Math_fround(-.99999994));
 f26 = Math_fround(~~(i5 ? f22 : f26) | 0);
 f22 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f20 = Math_fround(Math_fround(f22 + Math_fround(HEAPF32[i8 + 12 >> 2])) + Math_fround(.5));
 i5 = f20 >= Math_fround(0.0);
 f19 = Math_fround(f20 + Math_fround(-.99999994));
 f19 = Math_fround(~~(i5 ? f20 : f19) | 0);
 f22 = Math_fround(f22 + Math_fround(.5));
 i5 = f22 >= Math_fround(0.0);
 f20 = Math_fround(f22 + Math_fround(-.99999994));
 f20 = Math_fround(~~(i5 ? f22 : f20) | 0);
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f21 = Math_fround(f17 * f22);
 f22 = Math_fround(f17 * Math_fround(f22 + Math_fround(HEAPF32[i16 + 8 >> 2])));
 f17 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f23 = Math_fround(f15 * f17);
 f17 = Math_fround(f15 * Math_fround(f17 + Math_fround(HEAPF32[i16 + 12 >> 2])));
 i5 = __ZN9GfxDevice13GetDynamicVBOEv(__Z12GetGfxDevicev() | 0) | 0;
 if (!(i24 | i18 | i28 | i27)) if (mftCall_iiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 24, 4, 6, 0, i34 | 0) | 0) {
  i37 = HEAP32[i34 >> 2] | 0;
  HEAPF32[i37 >> 2] = f25;
  HEAPF32[i37 + 4 >> 2] = f19;
  HEAPF32[i37 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i37 + 12 >> 2] = i2;
  HEAPF32[i37 + 16 >> 2] = f21;
  HEAPF32[i37 + 20 >> 2] = f23;
  HEAPF32[i37 + 24 >> 2] = f26;
  HEAPF32[i37 + 28 >> 2] = f19;
  HEAPF32[i37 + 32 >> 2] = Math_fround(0.0);
  HEAP32[i37 + 36 >> 2] = i2;
  HEAPF32[i37 + 40 >> 2] = f22;
  HEAPF32[i37 + 44 >> 2] = f23;
  HEAPF32[i37 + 48 >> 2] = f25;
  HEAPF32[i37 + 52 >> 2] = f20;
  HEAPF32[i37 + 56 >> 2] = Math_fround(0.0);
  HEAP32[i37 + 60 >> 2] = i2;
  HEAPF32[i37 + 64 >> 2] = f21;
  HEAPF32[i37 + 68 >> 2] = f17;
  HEAPF32[i37 + 72 >> 2] = f26;
  HEAPF32[i37 + 76 >> 2] = f20;
  HEAPF32[i37 + 80 >> 2] = Math_fround(0.0);
  HEAP32[i37 + 84 >> 2] = i2;
  HEAPF32[i37 + 88 >> 2] = f22;
  HEAPF32[i37 + 92 >> 2] = f17;
  i37 = HEAP32[i1 >> 2] | 0;
  HEAP16[i37 >> 1] = HEAP16[gb + 222934 >> 1] | 0;
  HEAP16[i37 + 2 >> 1] = HEAP16[gb + 222934 + 2 >> 1] | 0;
  HEAP16[i37 + 4 >> 1] = HEAP16[gb + 222934 + 4 >> 1] | 0;
  HEAP16[i37 + 6 >> 1] = HEAP16[gb + 222934 + 6 >> 1] | 0;
  HEAP16[i37 + 8 >> 1] = HEAP16[gb + 222934 + 8 >> 1] | 0;
  HEAP16[i37 + 10 >> 1] = HEAP16[gb + 222934 + 10 >> 1] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i34 | 0, 4, 6);
  i5 = 14;
 } else i5 = 13; else {
  f12 = Math_fround(i18 | 0);
  f15 = Math_fround(f12 + f25);
  f39 = Math_fround(i24 | 0);
  f14 = Math_fround(f26 - f39);
  f10 = Math_fround(i27 | 0);
  f13 = Math_fround(f19 - f10);
  f38 = Math_fround(i28 | 0);
  f11 = Math_fround(f38 + f20);
  f12 = Math_fround(Math_fround(f12 * f9) + f21);
  f9 = Math_fround(f22 - Math_fround(f39 * f9));
  f10 = Math_fround(Math_fround(f10 * f7) + f23);
  f7 = Math_fround(f17 - Math_fround(f38 * f7));
  if (mftCall_iiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 24, 16, 54, 0, i34 | 0) | 0) {
   i3 = HEAP32[i34 >> 2] | 0;
   HEAPF32[i3 >> 2] = f25;
   HEAPF32[i3 + 4 >> 2] = f19;
   HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 12 >> 2] = i2;
   HEAPF32[i3 + 16 >> 2] = f21;
   HEAPF32[i3 + 20 >> 2] = f23;
   HEAPF32[i3 + 24 >> 2] = f15;
   HEAPF32[i3 + 28 >> 2] = f19;
   HEAPF32[i3 + 32 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 36 >> 2] = i2;
   HEAPF32[i3 + 40 >> 2] = f12;
   HEAPF32[i3 + 44 >> 2] = f23;
   HEAPF32[i3 + 48 >> 2] = f14;
   HEAPF32[i3 + 52 >> 2] = f19;
   HEAPF32[i3 + 56 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 60 >> 2] = i2;
   HEAPF32[i3 + 64 >> 2] = f9;
   HEAPF32[i3 + 68 >> 2] = f23;
   HEAPF32[i3 + 72 >> 2] = f26;
   HEAPF32[i3 + 76 >> 2] = f19;
   HEAPF32[i3 + 80 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 84 >> 2] = i2;
   HEAPF32[i3 + 88 >> 2] = f22;
   HEAPF32[i3 + 92 >> 2] = f23;
   HEAPF32[i3 + 96 >> 2] = f25;
   HEAPF32[i3 + 100 >> 2] = f13;
   HEAPF32[i3 + 104 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 108 >> 2] = i2;
   HEAPF32[i3 + 112 >> 2] = f21;
   HEAPF32[i3 + 116 >> 2] = f10;
   HEAPF32[i3 + 120 >> 2] = f15;
   HEAPF32[i3 + 124 >> 2] = f13;
   HEAPF32[i3 + 128 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 132 >> 2] = i2;
   HEAPF32[i3 + 136 >> 2] = f12;
   HEAPF32[i3 + 140 >> 2] = f10;
   HEAPF32[i3 + 144 >> 2] = f14;
   HEAPF32[i3 + 148 >> 2] = f13;
   HEAPF32[i3 + 152 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 156 >> 2] = i2;
   HEAPF32[i3 + 160 >> 2] = f9;
   HEAPF32[i3 + 164 >> 2] = f10;
   HEAPF32[i3 + 168 >> 2] = f26;
   HEAPF32[i3 + 172 >> 2] = f13;
   HEAPF32[i3 + 176 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 180 >> 2] = i2;
   HEAPF32[i3 + 184 >> 2] = f22;
   HEAPF32[i3 + 188 >> 2] = f10;
   HEAPF32[i3 + 192 >> 2] = f25;
   HEAPF32[i3 + 196 >> 2] = f11;
   HEAPF32[i3 + 200 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 204 >> 2] = i2;
   HEAPF32[i3 + 208 >> 2] = f21;
   HEAPF32[i3 + 212 >> 2] = f7;
   HEAPF32[i3 + 216 >> 2] = f15;
   HEAPF32[i3 + 220 >> 2] = f11;
   HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 228 >> 2] = i2;
   HEAPF32[i3 + 232 >> 2] = f12;
   HEAPF32[i3 + 236 >> 2] = f7;
   HEAPF32[i3 + 240 >> 2] = f14;
   HEAPF32[i3 + 244 >> 2] = f11;
   HEAPF32[i3 + 248 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 252 >> 2] = i2;
   HEAPF32[i3 + 256 >> 2] = f9;
   HEAPF32[i3 + 260 >> 2] = f7;
   HEAPF32[i3 + 264 >> 2] = f26;
   HEAPF32[i3 + 268 >> 2] = f11;
   HEAPF32[i3 + 272 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 276 >> 2] = i2;
   HEAPF32[i3 + 280 >> 2] = f22;
   HEAPF32[i3 + 284 >> 2] = f7;
   HEAPF32[i3 + 288 >> 2] = f25;
   HEAPF32[i3 + 292 >> 2] = f20;
   HEAPF32[i3 + 296 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 300 >> 2] = i2;
   HEAPF32[i3 + 304 >> 2] = f21;
   HEAPF32[i3 + 308 >> 2] = f17;
   HEAPF32[i3 + 312 >> 2] = f15;
   HEAPF32[i3 + 316 >> 2] = f20;
   HEAPF32[i3 + 320 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 324 >> 2] = i2;
   HEAPF32[i3 + 328 >> 2] = f12;
   HEAPF32[i3 + 332 >> 2] = f17;
   HEAPF32[i3 + 336 >> 2] = f14;
   HEAPF32[i3 + 340 >> 2] = f20;
   HEAPF32[i3 + 344 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 348 >> 2] = i2;
   HEAPF32[i3 + 352 >> 2] = f9;
   HEAPF32[i3 + 356 >> 2] = f17;
   HEAPF32[i3 + 360 >> 2] = f26;
   HEAPF32[i3 + 364 >> 2] = f20;
   HEAPF32[i3 + 368 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 372 >> 2] = i2;
   HEAPF32[i3 + 376 >> 2] = f22;
   HEAPF32[i3 + 380 >> 2] = f17;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = gb + 222826 | 0;
   i3 = i1 + 108 | 0;
   do {
    HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
    i1 = i1 + 2 | 0;
    i2 = i2 + 2 | 0;
   } while ((i1 | 0) < (i3 | 0));
   mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i34 | 0, 16, 54);
   i5 = 14;
  } else i5 = 13;
 }
 L17 : do if ((i5 | 0) != 13) if ((i5 | 0) == 14) {
  if (!i4) {
   i1 = HEAP32[gb + 1114516 >> 2] | 0;
   i2 = i1 + 100 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!(HEAP8[i3 + 164 >> 0] & 1)) i5 = 21; else if (!(HEAP32[i3 + 8 >> 2] | 0)) i5 = 21;
   if ((i5 | 0) == 21) __ZN8Material15BuildPropertiesEv(i1);
   __ZN8Material19UnshareMaterialDataEv(i1);
   i4 = HEAP32[i2 >> 2] | 0;
   __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i4);
   __Z21HandleGUITexturePropsP19ShaderPropertySheetP7Texture(i4 + 12 | 0, i29);
   i4 = HEAP32[gb + 1114516 >> 2] | 0;
  } else {
   i1 = i4 + 100 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP8[i2 + 164 >> 0] & 1)) i5 = 17; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i5 = 17;
   if ((i5 | 0) == 17) __ZN8Material15BuildPropertiesEv(i4);
   __ZN8Material19UnshareMaterialDataEv(i4);
   i37 = HEAP32[i1 >> 2] | 0;
   __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i37);
   __Z21HandleGUITexturePropsP19ShaderPropertySheetP7Texture(i37 + 12 | 0, i29);
  }
  i5 = __ZNK8Material12GetPassCountEv(i4) | 0;
  if ((i5 | 0) <= (i32 | 0)) {
   i37 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i31 >> 2] = i32;
   HEAP32[i31 + 4 >> 2] = i37;
   HEAP32[i31 + 8 >> 2] = i5;
   __Z6FormatPKcz(i33, gb + 386071 | 0, i31);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i33 + 11 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33, 0, gb + 385988 | 0, 522, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
  }
  i3 = __ZN9GfxDevice13GetDynamicVBOEv(i30) | 0;
  if ((i5 | 0) > 0) {
   if ((i32 | 0) < 0) {
    i1 = 0;
    while (1) {
     i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i4, i1, HEAP32[gb + 1166248 >> 2] | 0, 0, 0) | 0;
     if (i2 | 0) {
      HEAP32[i35 >> 2] = 0;
      HEAP32[i33 >> 2] = HEAP32[i35 >> 2];
      __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114524 | 0, i33);
      i31 = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0;
      i37 = HEAP32[gb + 1114536 + 4 >> 2] | 0;
      i32 = HEAP32[i37 + 4 >> 2] | 0;
      mftCall_viiiiiii(i31 | 0, i3 | 0, i34 | 0, i2 | 0, i32 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i37, HEAP32[i2 >> 2] | 0, 0) | 0, 0, 0);
      __Z15gpu_time_samplev();
      __Z12profiler_endP19ProfilerInformation(gb + 1114524 | 0);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i5 | 0)) break L17;
    }
   } else i1 = 0;
   do {
    if ((i1 | 0) == (i32 | 0)) {
     i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i4, i32, HEAP32[gb + 1166248 >> 2] | 0, 0, 0) | 0;
     if (i2 | 0) {
      HEAP32[i35 >> 2] = 0;
      HEAP32[i33 >> 2] = HEAP32[i35 >> 2];
      __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114524 | 0, i33);
      i30 = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0;
      i37 = HEAP32[gb + 1114536 + 4 >> 2] | 0;
      i31 = HEAP32[i37 + 4 >> 2] | 0;
      mftCall_viiiiiii(i30 | 0, i3 | 0, i34 | 0, i2 | 0, i31 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i37, HEAP32[i2 >> 2] | 0, 0) | 0, 0, 0);
      __Z15gpu_time_samplev();
      __Z12profiler_endP19ProfilerInformation(gb + 1114524 | 0);
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 } while (0);
 STACKTOP = i36;
 return;
}

function __ZN5physx18PxsSolverStartTask13setupDescTaskEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i26 + 10 | 0;
 i8 = i26 + 9 | 0;
 i13 = i26;
 i15 = i26 + 8 | 0;
 i25 = HEAP32[HEAP32[i23 + 24 >> 2] >> 2] | 0;
 i7 = i25 + 9068 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i24 = i23 + 48 | 0;
 i6 = i23 + 60 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) i2 = i1; else {
  i3 = i23 + 20 | 0;
  i4 = i23 + 44 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = 0;
  do {
   __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(HEAP32[i3 >> 2] | 0, i1, i5 + (i2 << 4) | 0);
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + 16 >> 2] = HEAP32[i5 + (i2 << 4) + 12 >> 2];
   HEAP16[i1 + 26 >> 1] = 2;
   i1 = i1 + 32 | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortINS_23PxcSolverConstraintDescENS_14ConstraintLessENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j(i2, i1 - i2 >> 5, i8, i14, 32);
 i4 = i25 + 8976 | 0;
 i3 = i25 + 8980 | 0;
 HEAP32[i3 >> 2] = 0;
 i16 = i23 + 56 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if ((HEAP32[i25 + 8984 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
  __ZN5physx6shdfnd5ArrayIPKNS_24PxsIndexedContactManagerENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i4, i2);
  i2 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 i12 = i25 + 8988 | 0;
 i3 = i25 + 8992 | 0;
 HEAP32[i3 >> 2] = 0;
 if ((HEAP32[i25 + 8996 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
  __ZN5physx6shdfnd5ArrayIPKNS_24PxsIndexedContactManagerENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i12, i2);
  i2 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 i17 = HEAP32[i4 >> 2] | 0;
 i18 = i25 + 8964 | 0;
 i19 = i25 + 8968 | 0;
 HEAP32[i19 >> 2] = 0;
 if (!i2) {
  i23 = i1;
  i24 = i25 + 8892 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i24 = i23 - i24 | 0;
  i24 = i24 >> 5;
  i23 = i25 + 8896 | 0;
  HEAP32[i23 >> 2] = i24;
  i25 = i25 + 8932 | 0;
  HEAP32[i25 >> 2] = i24;
  STACKTOP = i26;
  return;
 }
 i11 = i25 + 9e3 | 0;
 i10 = i25 + 9004 | 0;
 HEAP32[i10 >> 2] = 0;
 i21 = i23 + 20 | 0;
 i2 = HEAP32[(HEAP32[i21 >> 2] | 0) + 152 >> 2] | 0;
 i22 = i23 + 64 | 0;
 HEAP32[i13 >> 2] = 1 - (HEAP32[i22 >> 2] | 0) + (i2 << 1);
 HEAP32[i13 + 4 >> 2] = 1;
 i2 = i2 + 1 + (HEAP32[i24 >> 2] | 0) | 0;
 if ((HEAP32[i25 + 9008 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i11, i2);
 HEAP32[i10 >> 2] = i2;
 i9 = i2 << 2;
 _memset(HEAP32[i11 >> 2] | 0, 0, i9 | 0) | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i5 = HEAP32[i23 + 40 >> 2] | 0;
  i4 = 0;
  do {
   i8 = HEAP8[i5 + (i4 << 4) + 8 >> 0] | 0;
   i3 = i8 & 255;
   if (i8 << 24 >> 24 != 2) if ((HEAP8[i5 + (i4 << 4) + 9 >> 0] | 0) != 2) {
    i2 = (HEAP32[i11 >> 2] | 0) + ((HEAP32[i13 + (i3 << 2) >> 2] | 0) + (HEAP32[i5 + (i4 << 4) >> 2] | 0) << 2) | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = HEAP32[i16 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) {
  i3 = i2;
  i2 = 0;
 } else {
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = 0;
  do {
   i3 = i3 + -1 | 0;
   i7 = i4 + (i3 << 2) | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   i2 = i8 + i2 | 0;
  } while ((i3 | 0) != 0);
  i3 = HEAP32[i16 >> 2] | 0;
 }
 if (i3 | 0) {
  i8 = i23 + 40 | 0;
  i7 = 0;
  do {
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = i4 + (i7 << 4) | 0;
   i27 = HEAP8[i4 + (i7 << 4) + 8 >> 0] | 0;
   i6 = i27 & 255;
   if (i27 << 24 >> 24 == 2) i20 = 27; else if ((HEAP8[i4 + (i7 << 4) + 9 >> 0] | 0) == 2) i20 = 27; else {
    i27 = (HEAP32[i11 >> 2] | 0) + ((HEAP32[i13 + (i6 << 2) >> 2] | 0) + (HEAP32[i5 >> 2] | 0) << 2) | 0;
    i3 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = i3 + 1;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    i3 = HEAP32[i16 >> 2] | 0;
   }
   if ((i20 | 0) == 27) {
    i20 = 0;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] = i5;
    i2 = i2 + 1 | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i3 >>> 0);
 }
 _memset(HEAP32[i11 >> 2] | 0, 0, i9 | 0) | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = i23 + 40 | 0;
  i6 = 0;
  do {
   i2 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
   i4 = HEAP8[i2 + 9 >> 0] | 0;
   i5 = i4 & 255;
   if (i4 << 24 >> 24 != 2) if ((HEAP8[(HEAP32[i8 >> 2] | 0) + (i6 << 4) + 8 >> 0] | 0) != 2) {
    if (i4 << 24 >> 24 == 3) i2 = 0; else i2 = (HEAP32[i13 + (i5 << 2) >> 2] | 0) + (HEAP32[i2 + 4 >> 2] | 0) | 0;
    i3 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i16 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i3 >>> 0);
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) i10 = 0; else {
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
  i2 = 0;
  do {
   i3 = i3 + -1 | 0;
   i10 = i4 + (i3 << 2) | 0;
   i27 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i2;
   i2 = i27 + i2 | 0;
  } while ((i3 | 0) != 0);
  i3 = HEAP32[i16 >> 2] | 0;
  i10 = i2;
 }
 if (!i3) i2 = i10; else {
  i9 = i23 + 40 | 0;
  i8 = 0;
  i2 = i10;
  do {
   i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i5 = HEAP8[i4 + 9 >> 0] | 0;
   i6 = i5 & 255;
   i7 = i4;
   if (i5 << 24 >> 24 == 2) i20 = 48; else if ((HEAP8[(HEAP32[i9 >> 2] | 0) + (i8 << 4) + 8 >> 0] | 0) == 2) i20 = 48; else {
    if (i5 << 24 >> 24 == 3) i3 = 0; else i3 = (HEAP32[i13 + (i6 << 2) >> 2] | 0) + (HEAP32[i4 + 4 >> 2] | 0) | 0;
    i27 = (HEAP32[i11 >> 2] | 0) + (i3 << 2) | 0;
    i3 = HEAP32[i27 >> 2] | 0;
    HEAP32[i27 >> 2] = i3 + 1;
    HEAP32[i17 + (i3 << 2) >> 2] = i7;
    i3 = HEAP32[i16 >> 2] | 0;
   }
   if ((i20 | 0) == 48) {
    i20 = 0;
    HEAP32[i17 + (i2 << 2) >> 2] = i7;
    i2 = i2 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i3 >>> 0);
 }
 __ZN5physx6shdfnd4sortIPKNS_24PxsIndexedContactManagerENS_25ArticulationSortPredicateENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i17 + (i10 << 2) | 0, i2 - i10 | 0, i15, i14, 32);
 HEAP32[i25 + 9072 >> 2] = i1;
 i12 = i25 + 8972 | 0;
 if ((HEAP32[i12 >> 2] & 2147482624) >>> 0 < 1024) __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i18, 1024);
 HEAP32[i19 >> 2] = 0;
 __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(HEAP32[i21 >> 2] | 0, i1, HEAP32[i17 >> 2] | 0);
 HEAP32[i1 + 16 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2];
 HEAP16[i1 + 26 >> 1] = 1;
 i3 = HEAPU16[(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0) + 36 >> 1] | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if (i2 >>> 0 > 1) {
  i11 = 1;
  i8 = i1;
  i2 = 0;
  i4 = i1;
  i7 = 0;
  while (1) {
   i9 = i8 + 32 | 0;
   i10 = i17 + (i11 << 2) | 0;
   __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(HEAP32[i21 >> 2] | 0, i9, HEAP32[i10 >> 2] | 0);
   i10 = HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i8 + 48 >> 2] = i10;
   HEAP16[i8 + 58 >> 1] = 1;
   do if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i8 + 36 >> 2] | 0)) if ((HEAP16[i4 + 8 >> 1] | 0) == -1) if ((HEAP16[i4 + 12 >> 1] | 0) == -1) {
    if (((HEAPU16[i10 + 36 >> 1] | 0) + i3 | 0) >>> 0 > 64) {
     i20 = 60;
     break;
    }
    if (!(HEAP32[i10 + 8 >> 2] & 1)) {
     i1 = i8;
     i5 = i4;
    } else i20 = 60;
   } else i20 = 60; else i20 = 60; else i20 = 60; else i20 = 60; while (0);
   do if ((i20 | 0) == 60) {
    i20 = 0;
    i6 = i11 - i7 | 0;
    if (!i3) {
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i4 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i4 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     i3 = 0;
     i1 = i8;
     i5 = i4;
     i7 = i11;
     break;
    }
    if (i6 >>> 0 > 1) {
     i4 = HEAP32[i12 >> 2] | 0;
     i5 = i4 & 2147483647;
     i1 = HEAP32[i19 >> 2] | 0;
     if (i5 >>> 0 <= i1 >>> 0) {
      __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i18, (i5 | 0) == 0 ? 1 : i4 << 1);
      i1 = HEAP32[i19 >> 2] | 0;
     }
     i5 = HEAP32[i18 >> 2] | 0;
     HEAP32[i19 >> 2] = i1 + 1;
     HEAP32[i5 + (i1 << 5) >> 2] = i7;
     HEAP16[i5 + (i1 << 5) + 4 >> 1] = i6;
     HEAP16[i5 + (i1 << 5) + 6 >> 1] = i3;
     i27 = HEAP32[(HEAP32[i17 + (i7 << 2) >> 2] | 0) + 12 >> 2] | 0;
     HEAP32[i5 + (i1 << 5) + 8 >> 2] = i27 + 16;
     i7 = HEAP32[i27 + 44 >> 2] | 0;
     HEAP32[i5 + (i1 << 5) + 12 >> 2] = i7;
     i3 = HEAP32[i27 + 48 >> 2] | 0;
     HEAP32[i5 + (i1 << 5) + 16 >> 2] = i3;
     HEAP16[i5 + (i1 << 5) + 20 >> 1] = HEAP16[i27 + 36 >> 1] | 0;
     HEAP32[i5 + (i1 << 5) + 24 >> 2] = (HEAP16[i27 + 114 >> 1] & 16) == 0 ? 0 : i7 + (i3 + 15 & -16) | 0;
     i3 = 0;
     i1 = i9;
     i2 = i2 + 1 | 0;
     i5 = i9;
     i7 = i11;
    } else {
     i3 = 0;
     i1 = i9;
     i5 = i9;
     i7 = i11;
    }
   } while (0);
   i3 = (HEAPU16[i10 + 36 >> 1] | 0) + i3 | 0;
   i11 = i11 + 1 | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   if (i11 >>> 0 >= i4 >>> 0) {
    i8 = i3;
    break;
   } else {
    i8 = i1;
    i4 = i5;
   }
  }
 } else {
  i4 = i2;
  i8 = i3;
  i2 = 0;
  i7 = 0;
 }
 i6 = i4 - i7 | 0;
 if (i8) {
  if (i6 >>> 0 > 1) {
   i4 = HEAP32[i12 >> 2] | 0;
   i5 = i4 & 2147483647;
   i3 = HEAP32[i19 >> 2] | 0;
   if (i5 >>> 0 <= i3 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i18, (i5 | 0) == 0 ? 1 : i4 << 1);
    i3 = HEAP32[i19 >> 2] | 0;
   }
   i27 = HEAP32[i18 >> 2] | 0;
   HEAP32[i19 >> 2] = i3 + 1;
   HEAP32[i27 + (i3 << 5) >> 2] = i7;
   HEAP16[i27 + (i3 << 5) + 4 >> 1] = i6;
   HEAP16[i27 + (i3 << 5) + 6 >> 1] = i8;
   i18 = HEAP32[(HEAP32[i17 + (i7 << 2) >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i27 + (i3 << 5) + 8 >> 2] = i18 + 16;
   i19 = HEAP32[i18 + 44 >> 2] | 0;
   HEAP32[i27 + (i3 << 5) + 12 >> 2] = i19;
   i20 = HEAP32[i18 + 48 >> 2] | 0;
   HEAP32[i27 + (i3 << 5) + 16 >> 2] = i20;
   HEAP16[i27 + (i3 << 5) + 20 >> 1] = HEAP16[i18 + 36 >> 1] | 0;
   HEAP32[i27 + (i3 << 5) + 24 >> 2] = (HEAP16[i18 + 114 >> 1] & 16) == 0 ? 0 : i19 + (i20 + 15 & -16) | 0;
   i2 = i2 + 1 | 0;
  }
  i1 = i1 + 32 | 0;
 }
 if (!i2) {
  i27 = i1;
  i24 = i25 + 8892 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i24 = i27 - i24 | 0;
  i24 = i24 >> 5;
  i27 = i25 + 8896 | 0;
  HEAP32[i27 >> 2] = i24;
  i27 = i25 + 8932 | 0;
  HEAP32[i27 >> 2] = i24;
  STACKTOP = i26;
  return;
 }
 i9 = i23 + 28 | 0;
 i3 = i23 + 12 | 0;
 i8 = 0;
 do {
  i20 = HEAP32[(HEAP32[(HEAP32[i21 >> 2] | 0) + 96 >> 2] | 0) + 6960 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i20 >> 2] | 0);
  i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i20, 76, 16) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i20 >> 2] | 0);
  i20 = HEAP32[i21 >> 2] | 0;
  i23 = HEAP32[i22 >> 2] | 0;
  i7 = i2 - i8 | 0;
  HEAP16[i4 + 4 >> 1] = -1;
  HEAP16[i4 + 6 >> 1] = 0;
  i5 = i4 + 8 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = gb + 87404 + 8;
  i6 = i4 + 12 | 0;
  HEAP32[i6 >> 2] = 0;
  i27 = i4 + 16 | 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i4 >> 2] = gb + 106356 + 8;
  HEAP32[i4 + 20 >> 2] = i20;
  HEAP32[i4 + 24 >> 2] = i25;
  i20 = i4 + 28 | 0;
  HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i20 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  i20 = i4 + 48 | 0;
  HEAP32[i20 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  HEAP32[i4 + 64 >> 2] = i23;
  HEAP32[i4 + 68 >> 2] = i8;
  HEAP32[i4 + 72 >> 2] = i7 >>> 0 > 8 ? 8 : i7;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i27 >> 2] = 1;
  HEAP32[i6 >> 2] = i7;
  if (i7 | 0) {
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
  }
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  i8 = i8 + 8 | 0;
 } while (i2 >>> 0 > i8 >>> 0);
 i24 = i25 + 8892 | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 i27 = i1;
 i24 = i27 - i24 | 0;
 i24 = i24 >> 5;
 i27 = i25 + 8896 | 0;
 HEAP32[i27 >> 2] = i24;
 i27 = i25 + 8932 | 0;
 HEAP32[i27 >> 2] = i24;
 STACKTOP = i26;
 return;
}

function __Z22sweepConvex_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i4, i23, i21, i5, i25, f16, i24, i6, f1) {
 i4 = i4 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i5 = i5 | 0;
 i25 = i25 | 0;
 f16 = Math_fround(f16);
 i24 = i24 | 0;
 i6 = i6 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26 + 640 | 0;
 i28 = i26 + 352 | 0;
 i14 = i26 + 336 | 0;
 i35 = i26 + 112 | 0;
 i34 = i26 + 96 | 0;
 i33 = i26 + 80 | 0;
 i32 = i26 + 64 | 0;
 i27 = i26 + 48 | 0;
 i29 = i26 + 576 | 0;
 i31 = i26 + 368 | 0;
 i30 = i26 + 128 | 0;
 i13 = i26 + 32 | 0;
 i15 = i26 + 16 | 0;
 i17 = i26;
 i36 = HEAP32[i4 + 32 >> 2] | 0;
 i53 = HEAP32[i21 + 32 >> 2] | 0;
 i20 = i53 + 16 | 0;
 HEAP32[i22 >> 2] = HEAPU8[i53 + 55 >> 0];
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 i53 = HEAP32[i4 + 8 >> 2] | 0;
 i18 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i35 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i35 + 4 >> 2] = i53;
 HEAP32[i35 + 8 >> 2] = i18;
 HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
 i18 = HEAP32[i4 + 20 >> 2] | 0;
 i53 = HEAP32[i4 + 24 >> 2] | 0;
 i19 = HEAP32[i4 + 28 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i34 + 4 >> 2] = i18;
 HEAP32[i34 + 8 >> 2] = i53;
 HEAP32[i34 + 12 >> 2] = i19;
 i19 = i21 + 4 | 0;
 i4 = HEAP32[i19 + 4 >> 2] | 0;
 i53 = HEAP32[i19 + 8 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i33 + 4 >> 2] = i4;
 HEAP32[i33 + 8 >> 2] = i53;
 HEAPF32[i33 + 12 >> 2] = Math_fround(0.0);
 i53 = i21 + 16 | 0;
 i4 = HEAP32[i53 + 4 >> 2] | 0;
 i19 = HEAP32[i53 + 8 >> 2] | 0;
 i18 = HEAP32[i53 + 12 >> 2] | 0;
 HEAP32[i32 >> 2] = HEAP32[i53 >> 2];
 HEAP32[i32 + 4 >> 2] = i4;
 HEAP32[i32 + 8 >> 2] = i19;
 HEAP32[i32 + 12 >> 2] = i18;
 f51 = Math_fround(HEAPF32[i23 >> 2]);
 f52 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f47 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f50 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 i18 = i23 + 16 | 0;
 f38 = Math_fround(HEAPF32[i18 >> 2]);
 f46 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f48 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 i18 = i5 + 16 | 0;
 f2 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i25 >> 2]);
 i18 = i25 + 4 | 0;
 f42 = Math_fround(HEAPF32[i18 >> 2]);
 i19 = i25 + 8 | 0;
 f39 = Math_fround(f39 * f16);
 f42 = Math_fround(f42 * f16);
 f49 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f16);
 f8 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f37 = Math_fround(Math_fround(Math_fround(f9 * f39) + Math_fround(f10 * f42)) + Math_fround(f11 * f49));
 f45 = Math_fround(Math_fround(Math_fround(f10 * f37) + Math_fround(Math_fround(f8 * f42) - Math_fround(f12 * Math_fround(Math_fround(f11 * f39) - Math_fround(f9 * f49))))) * Math_fround(2.0));
 f40 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f49) - Math_fround(f12 * Math_fround(Math_fround(f9 * f42) - Math_fround(f10 * f39)))) + Math_fround(f11 * f37)) * Math_fround(2.0));
 HEAPF32[i27 >> 2] = Math_fround(Math_fround(Math_fround(f9 * f37) + Math_fround(Math_fround(f8 * f39) - Math_fround(f12 * Math_fround(Math_fround(f10 * f49) - Math_fround(f11 * f42))))) * Math_fround(2.0));
 HEAPF32[i27 + 4 >> 2] = f45;
 HEAPF32[i27 + 8 >> 2] = f40;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 f40 = Math_fround(-f9);
 f45 = Math_fround(-f10);
 f42 = Math_fround(-f11);
 f38 = Math_fround(f38 - f2);
 f46 = Math_fround(f46 - f3);
 f48 = Math_fround(f48 - f7);
 f49 = Math_fround(Math_fround(Math_fround(f38 * f40) + Math_fround(f46 * f45)) + Math_fround(f48 * f42));
 f39 = Math_fround(Math_fround(Math_fround(f49 * f45) + Math_fround(Math_fround(f8 * f46) + Math_fround(f12 * Math_fround(Math_fround(f38 * f42) - Math_fround(f48 * f40))))) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f48) + Math_fround(f12 * Math_fround(Math_fround(f46 * f40) - Math_fround(f38 * f45)))) + Math_fround(f49 * f42)) * Math_fround(2.0));
 f43 = Math_fround(Math_fround(f50 * f12) - Math_fround(Math_fround(Math_fround(f51 * f40) + Math_fround(f52 * f45)) + Math_fround(f47 * f42)));
 f44 = Math_fround(Math_fround(Math_fround(f47 * f45) - Math_fround(f52 * f42)) + Math_fround(Math_fround(f50 * f40) + Math_fround(f51 * f12)));
 f41 = Math_fround(Math_fround(Math_fround(f51 * f42) - Math_fround(f47 * f40)) + Math_fround(Math_fround(f50 * f45) + Math_fround(f52 * f12)));
 f47 = Math_fround(Math_fround(Math_fround(f52 * f40) - Math_fround(f51 * f45)) + Math_fround(Math_fround(f50 * f42) + Math_fround(f47 * f12)));
 HEAPF32[i29 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f49 * f40) + Math_fround(Math_fround(f8 * f38) + Math_fround(f12 * Math_fround(Math_fround(f48 * f45) - Math_fround(f46 * f42))))) * Math_fround(2.0));
 HEAPF32[i29 + 52 >> 2] = f39;
 HEAPF32[i29 + 56 >> 2] = f37;
 HEAPF32[i29 + 60 >> 2] = Math_fround(0.0);
 f37 = Math_fround(f44 + f44);
 f39 = Math_fround(f41 + f41);
 f42 = Math_fround(f47 + f47);
 f46 = Math_fround(f41 * f39);
 f45 = Math_fround(f47 * f42);
 f41 = Math_fround(f41 * f37);
 f48 = Math_fround(f47 * f37);
 f38 = Math_fround(f43 * f37);
 f47 = Math_fround(f47 * f39);
 f39 = Math_fround(f43 * f39);
 f42 = Math_fround(f43 * f42);
 f37 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f37));
 f44 = Math_fround(f41 + f42);
 f43 = Math_fround(f48 - f39);
 f42 = Math_fround(f41 - f42);
 f41 = Math_fround(f37 - f45);
 f40 = Math_fround(f47 + f38);
 f39 = Math_fround(f48 + f39);
 f38 = Math_fround(f47 - f38);
 f37 = Math_fround(f37 - f46);
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f46) - f45);
 HEAPF32[i29 + 4 >> 2] = f44;
 HEAPF32[i29 + 8 >> 2] = f43;
 HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 16 >> 2] = f42;
 HEAPF32[i29 + 20 >> 2] = f41;
 HEAPF32[i29 + 24 >> 2] = f40;
 HEAPF32[i29 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 32 >> 2] = f39;
 HEAPF32[i29 + 36 >> 2] = f38;
 HEAPF32[i29 + 40 >> 2] = f37;
 HEAPF32[i29 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i31, i36 + 16 | 0, i28, i35, i34);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i30, i20, i28, i33, i32);
 i5 = (HEAP16[i6 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_11ConvexHullVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i31, i30, i29, i14, i28, i27, i13, i17, i15, f1, i5) | 0)) {
  i53 = 0;
  STACKTOP = i26;
  return i53 | 0;
 }
 i4 = i24 + 12 | 0;
 HEAP16[i4 >> 1] = 6;
 f52 = Math_fround(HEAPF32[i14 >> 2]);
 f1 = Math_fround(HEAPF32[i13 >> 2]);
 do if (!(f52 >= f1)) {
  HEAP16[i4 >> 1] = 7;
  f47 = Math_fround(HEAPF32[i15 >> 2]);
  f46 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f48 = Math_fround(Math_fround(Math_fround(f9 * f47) + Math_fround(f10 * f46)) + Math_fround(f11 * f51));
  f52 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f9 * f48) + Math_fround(Math_fround(f8 * f47) + Math_fround(f12 * Math_fround(Math_fround(f10 * f51) - Math_fround(f11 * f46))))) * Math_fround(2.0)));
  f2 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f10 * f48) + Math_fround(Math_fround(f8 * f46) + Math_fround(f12 * Math_fround(Math_fround(f11 * f47) - Math_fround(f9 * f51))))) * Math_fround(2.0)));
  f3 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f51) + Math_fround(f12 * Math_fround(Math_fround(f9 * f46) - Math_fround(f10 * f47)))) + Math_fround(f11 * f48)) * Math_fround(2.0)));
  f48 = Math_fround(HEAPF32[i17 >> 2]);
  f47 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f51 = Math_fround(Math_fround(Math_fround(f9 * f48) + Math_fround(f10 * f47)) + Math_fround(f11 * f46));
  f49 = Math_fround(Math_fround(Math_fround(f9 * f51) + Math_fround(Math_fround(f8 * f48) + Math_fround(f12 * Math_fround(Math_fround(f10 * f46) - Math_fround(f11 * f47))))) * Math_fround(2.0));
  f50 = Math_fround(Math_fround(Math_fround(f10 * f51) + Math_fround(Math_fround(f8 * f47) + Math_fround(f12 * Math_fround(Math_fround(f11 * f48) - Math_fround(f9 * f46))))) * Math_fround(2.0));
  f51 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f46) + Math_fround(f12 * Math_fround(Math_fround(f9 * f47) - Math_fround(f10 * f48)))) + Math_fround(f11 * f51)) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f49 * f49) + Math_fround(f50 * f50))))));
  f50 = Math_fround(-Math_fround(f48 * f50));
  f51 = Math_fround(-Math_fround(f48 * f51));
  f1 = Math_fround(f1 * f16);
  HEAPF32[i24 + 28 >> 2] = Math_fround(-Math_fround(f48 * f49));
  HEAPF32[i24 + 32 >> 2] = f50;
  HEAPF32[i24 + 36 >> 2] = f51;
  HEAPF32[i24 + 16 >> 2] = f52;
  HEAPF32[i24 + 20 >> 2] = f2;
  HEAPF32[i24 + 24 >> 2] = f3;
  HEAPF32[i24 + 40 >> 2] = f1;
  f1 = f52;
 } else if (i5) {
  HEAP16[i4 >> 1] = 7;
  f47 = Math_fround(HEAPF32[i15 >> 2]);
  f46 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f48 = Math_fround(Math_fround(Math_fround(f9 * f47) + Math_fround(f10 * f46)) + Math_fround(f11 * f51));
  f52 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f9 * f48) + Math_fround(Math_fround(f8 * f47) + Math_fround(f12 * Math_fround(Math_fround(f10 * f51) - Math_fround(f11 * f46))))) * Math_fround(2.0)));
  f2 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f10 * f48) + Math_fround(Math_fround(f8 * f46) + Math_fround(f12 * Math_fround(Math_fround(f11 * f47) - Math_fround(f9 * f51))))) * Math_fround(2.0)));
  f3 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f51) + Math_fround(f12 * Math_fround(Math_fround(f9 * f46) - Math_fround(f10 * f47)))) + Math_fround(f11 * f48)) * Math_fround(2.0)));
  f48 = Math_fround(HEAPF32[i17 >> 2]);
  f47 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f51 = Math_fround(Math_fround(Math_fround(f9 * f48) + Math_fround(f10 * f47)) + Math_fround(f11 * f46));
  f49 = Math_fround(Math_fround(Math_fround(f9 * f51) + Math_fround(Math_fround(f8 * f48) + Math_fround(f12 * Math_fround(Math_fround(f10 * f46) - Math_fround(f11 * f47))))) * Math_fround(2.0));
  f50 = Math_fround(Math_fround(Math_fround(f10 * f51) + Math_fround(Math_fround(f8 * f47) + Math_fround(f12 * Math_fround(Math_fround(f11 * f48) - Math_fround(f9 * f46))))) * Math_fround(2.0));
  f51 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f46) + Math_fround(f12 * Math_fround(Math_fround(f9 * f47) - Math_fround(f10 * f48)))) + Math_fround(f11 * f51)) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f49 * f49) + Math_fround(f50 * f50))))));
  f50 = Math_fround(-Math_fround(f48 * f50));
  f51 = Math_fround(-Math_fround(f48 * f51));
  HEAPF32[i24 + 28 >> 2] = Math_fround(-Math_fround(f48 * f49));
  HEAPF32[i24 + 32 >> 2] = f50;
  HEAPF32[i24 + 36 >> 2] = f51;
  HEAPF32[i24 + 16 >> 2] = f52;
  HEAPF32[i24 + 20 >> 2] = f2;
  HEAPF32[i24 + 24 >> 2] = f3;
  HEAPF32[i24 + 40 >> 2] = f1;
  f1 = f52;
  break;
 } else {
  HEAPF32[i24 + 40 >> 2] = Math_fround(0.0);
  f3 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
  f2 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
  f1 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
  HEAPF32[i24 + 28 >> 2] = f3;
  HEAPF32[i24 + 32 >> 2] = f2;
  HEAPF32[i24 + 36 >> 2] = f1;
  f1 = Math_fround(HEAPF32[i24 + 16 >> 2]);
  f2 = Math_fround(HEAPF32[i24 + 20 >> 2]);
  f3 = Math_fround(HEAPF32[i24 + 24 >> 2]);
  break;
 } while (0);
 f51 = Math_fround(HEAPF32[i25 >> 2]);
 f52 = Math_fround(HEAPF32[i18 >> 2]);
 HEAP32[i24 + 8 >> 2] = __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_(i21, i20, i22, i23, f1, f2, f3, f51, f52, Math_fround(HEAPF32[i19 >> 2])) | 0;
 i53 = 1;
 STACKTOP = i26;
 return i53 | 0;
}

function __Z18raycast_convexMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i39, i41, i9, i10, f38, i40, i5, i53, i1, i4, i6) {
 i39 = i39 | 0;
 i41 = i41 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f38 = Math_fround(f38);
 i40 = i40 | 0;
 i5 = i5 | 0;
 i53 = i53 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, f7 = f0, f8 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i52 + 56 | 0;
 i43 = i52 + 28 | 0;
 i1 = i52;
 i4 = HEAP32[i39 + 32 >> 2] | 0;
 i34 = i39 + 4 | 0;
 f7 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i34 >> 2]));
 i37 = i39 + 8 | 0;
 f3 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i37 >> 2]));
 i26 = i39 + 12 | 0;
 f25 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i26 >> 2]));
 HEAPF32[i43 >> 2] = f7;
 HEAPF32[i43 + 4 >> 2] = f3;
 HEAPF32[i43 + 8 >> 2] = f25;
 HEAP32[i43 + 12 >> 2] = HEAP32[i39 + 16 >> 2];
 i27 = i39 + 20 | 0;
 HEAP32[i43 + 16 >> 2] = HEAP32[i27 >> 2];
 i28 = i39 + 24 | 0;
 HEAP32[i43 + 20 >> 2] = HEAP32[i28 >> 2];
 i29 = i39 + 28 | 0;
 HEAP32[i43 + 24 >> 2] = HEAP32[i29 >> 2];
 i30 = i41 + 16 | 0;
 f25 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i41 + 20 | 0;
 f3 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i41 + 24 | 0;
 f25 = Math_fround(f25 * Math_fround(-2.0));
 f3 = Math_fround(f3 * Math_fround(-2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * Math_fround(-2.0));
 i33 = i41 + 12 | 0;
 f2 = Math_fround(HEAPF32[i33 >> 2]);
 f16 = Math_fround(Math_fround(f2 * f2) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i41 >> 2]);
 f24 = Math_fround(f25 * f23);
 i35 = i41 + 4 | 0;
 f13 = Math_fround(HEAPF32[i35 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f3 * f13));
 i36 = i41 + 8 | 0;
 f14 = Math_fround(HEAPF32[i36 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f7 * f14));
 f17 = Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f25 * f16) - Math_fround(f2 * Math_fround(Math_fround(f7 * f13) - Math_fround(f3 * f14)))));
 f54 = Math_fround(Math_fround(f13 * f24) + Math_fround(Math_fround(f3 * f16) - Math_fround(f2 * Math_fround(Math_fround(f25 * f14) - Math_fround(f7 * f23)))));
 f24 = Math_fround(Math_fround(Math_fround(f7 * f16) - Math_fround(f2 * Math_fround(Math_fround(f3 * f23) - Math_fround(f25 * f13)))) + Math_fround(f14 * f24));
 f13 = Math_fround(-f13);
 f14 = Math_fround(-f14);
 HEAPF32[i1 >> 2] = Math_fround(-f23);
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f14;
 HEAPF32[i1 + 12 >> 2] = f2;
 HEAPF32[i1 + 16 >> 2] = f17;
 HEAPF32[i1 + 20 >> 2] = f54;
 HEAPF32[i1 + 24 >> 2] = f24;
 __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE(i45, i43, i1);
 i1 = HEAP8[i4 + 55 >> 0] | 0;
 f24 = Math_fround(HEAPF32[i9 >> 2]);
 f54 = Math_fround(HEAPF32[i45 >> 2]);
 f17 = Math_fround(f24 * f54);
 i43 = i45 + 4 | 0;
 f2 = Math_fround(HEAPF32[i43 >> 2]);
 f14 = Math_fround(f24 * f2);
 i44 = i45 + 8 | 0;
 f13 = Math_fround(HEAPF32[i44 >> 2]);
 f23 = Math_fround(f24 * f13);
 f25 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i50 = i45 + 12 | 0;
 f3 = Math_fround(HEAPF32[i50 >> 2]);
 f16 = Math_fround(f25 * f3);
 i51 = i45 + 16 | 0;
 f7 = Math_fround(HEAPF32[i51 >> 2]);
 f15 = Math_fround(f25 * f7);
 i46 = i45 + 20 | 0;
 f8 = Math_fround(HEAPF32[i46 >> 2]);
 f16 = Math_fround(f17 + f16);
 f15 = Math_fround(f14 + f15);
 f23 = Math_fround(f23 + Math_fround(f25 * f8));
 f14 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i47 = i45 + 24 | 0;
 f17 = Math_fround(HEAPF32[i47 >> 2]);
 f21 = Math_fround(f14 * f17);
 i48 = i45 + 28 | 0;
 f18 = Math_fround(HEAPF32[i48 >> 2]);
 f22 = Math_fround(f14 * f18);
 i49 = i45 + 32 | 0;
 f19 = Math_fround(HEAPF32[i49 >> 2]);
 f21 = Math_fround(f16 + f21);
 f22 = Math_fround(f15 + f22);
 f23 = Math_fround(f23 + Math_fround(f14 * f19));
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i45 + 36 >> 2]));
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i45 + 40 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i45 + 44 >> 2]));
 f15 = Math_fround(HEAPF32[i10 >> 2]);
 f54 = Math_fround(f54 * f15);
 f2 = Math_fround(f2 * f15);
 f13 = Math_fround(f13 * f15);
 f16 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f3 = Math_fround(f54 + Math_fround(f3 * f16));
 f7 = Math_fround(f2 + Math_fround(f7 * f16));
 f8 = Math_fround(f13 + Math_fround(f8 * f16));
 f13 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f17 = Math_fround(f3 + Math_fround(f17 * f13));
 f18 = Math_fround(f7 + Math_fround(f18 * f13));
 f19 = Math_fround(f8 + Math_fround(f19 * f13));
 if (i1 << 24 >> 24) {
  i10 = i1 & 255;
  i5 = 0;
  i6 = 0;
  i11 = 0;
  f7 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  i12 = 1;
  i9 = HEAP32[i4 + 56 >> 2] | 0;
  L3 : while (1) {
   i10 = i10 + -1 | 0;
   i4 = i9;
   i9 = i9 + 20 | 0;
   f55 = Math_fround(HEAPF32[i4 >> 2]);
   f54 = Math_fround(f21 * f55);
   f3 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f54 = Math_fround(f54 + Math_fround(f22 * f3));
   f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f54 = Math_fround(f54 + Math_fround(f23 * f2));
   f54 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) + f54);
   f2 = Math_fround(Math_fround(Math_fround(f17 * f55) + Math_fround(f18 * f3)) + Math_fround(f19 * f2));
   f3 = Math_fround(Math_fround(-f54) / f2);
   i1 = f54 > Math_fround(0.0);
   i12 = i12 & (i1 ^ 1);
   do if (f2 > Math_fround(1.00000001e-07)) {
    i20 = i6;
    f2 = f7 < f3 ? f7 : f3;
    f3 = f8;
   } else {
    if (!(f2 < Math_fround(-1.00000001e-07))) if (i1) {
     i1 = 0;
     i42 = 19;
     break L3;
    } else {
     i20 = i6;
     f2 = f7;
     f3 = f8;
     break;
    }
    if (f3 > f8) {
     i5 = i11;
     i20 = i4;
     f2 = f7;
    } else {
     i20 = i6;
     f2 = f7;
     f3 = f8;
    }
   } while (0);
   if (!i10) break; else {
    i6 = i20;
    i11 = i11 + 1 | 0;
    f7 = f2;
    f8 = f3;
   }
  }
  if ((i42 | 0) == 19) {
   STACKTOP = i52;
   return i1 | 0;
  }
  if (!i12) {
   if (!(f3 < Math_fround(f38 + Math_fround(-9.99999974e-06)) & (f3 < f2 & f3 > Math_fround(0.0)))) {
    i53 = 0;
    STACKTOP = i52;
    return i53 | 0;
   }
   i4 = HEAP16[i40 >> 1] | 0;
   if (!(i4 & 1)) i1 = 4; else {
    f15 = Math_fround(f21 + Math_fround(f17 * f3));
    f25 = Math_fround(f22 + Math_fround(f18 * f3));
    f7 = Math_fround(f23 + Math_fround(f19 * f3));
    f19 = Math_fround(HEAPF32[i39 + 16 >> 2]);
    f17 = Math_fround(HEAPF32[i27 >> 2]);
    f58 = Math_fround(HEAPF32[i28 >> 2]);
    f23 = Math_fround(HEAPF32[i29 >> 2]);
    f55 = Math_fround(f19 + f19);
    f8 = Math_fround(f17 + f17);
    f16 = Math_fround(f58 + f58);
    f14 = Math_fround(f17 * f8);
    f21 = Math_fround(f58 * f16);
    f17 = Math_fround(f55 * f17);
    f56 = Math_fround(f55 * f58);
    f13 = Math_fround(f55 * f23);
    f58 = Math_fround(f8 * f58);
    f8 = Math_fround(f8 * f23);
    f23 = Math_fround(f16 * f23);
    f16 = Math_fround(Math_fround(Math_fround(1.0) - f14) - f21);
    f54 = Math_fround(f17 + f23);
    f38 = Math_fround(f56 - f8);
    f23 = Math_fround(f17 - f23);
    f55 = Math_fround(Math_fround(1.0) - Math_fround(f19 * f55));
    f21 = Math_fround(f55 - f21);
    f19 = Math_fround(f58 + f13);
    f8 = Math_fround(f56 + f8);
    f13 = Math_fround(f58 - f13);
    f14 = Math_fround(f55 - f14);
    f55 = Math_fround(HEAPF32[i34 >> 2]);
    f58 = Math_fround(f55 * f16);
    f56 = Math_fround(f55 * f23);
    f55 = Math_fround(f55 * f8);
    f17 = Math_fround(HEAPF32[i37 >> 2]);
    f57 = Math_fround(f54 * f17);
    f2 = Math_fround(f21 * f17);
    f17 = Math_fround(f13 * f17);
    f18 = Math_fround(HEAPF32[i26 >> 2]);
    f24 = Math_fround(f38 * f18);
    f22 = Math_fround(f19 * f18);
    f18 = Math_fround(f14 * f18);
    f24 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(Math_fround(Math_fround(f8 * f58) + Math_fround(f13 * f57)) + Math_fround(f14 * f24))) + Math_fround(Math_fround(f15 * Math_fround(Math_fround(Math_fround(f16 * f58) + Math_fround(f54 * f57)) + Math_fround(f38 * f24))) + Math_fround(f25 * Math_fround(Math_fround(Math_fround(f23 * f58) + Math_fround(f21 * f57)) + Math_fround(f19 * f24))))) * Math_fround(2.0));
    f22 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(Math_fround(Math_fround(f8 * f56) + Math_fround(f13 * f2)) + Math_fround(f14 * f22))) + Math_fround(Math_fround(f15 * Math_fround(Math_fround(Math_fround(f16 * f56) + Math_fround(f54 * f2)) + Math_fround(f38 * f22))) + Math_fround(f25 * Math_fround(Math_fround(Math_fround(f23 * f56) + Math_fround(f21 * f2)) + Math_fround(f19 * f22))))) * Math_fround(2.0));
    f18 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(Math_fround(Math_fround(f8 * f55) + Math_fround(f13 * f17)) + Math_fround(f14 * f18))) + Math_fround(Math_fround(f15 * Math_fround(Math_fround(Math_fround(f16 * f55) + Math_fround(f54 * f17)) + Math_fround(f38 * f18))) + Math_fround(f25 * Math_fround(Math_fround(Math_fround(f23 * f55) + Math_fround(f21 * f17)) + Math_fround(f19 * f18))))) * Math_fround(2.0));
    f19 = Math_fround(HEAPF32[i33 >> 2]);
    f17 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
    f21 = Math_fround(HEAPF32[i41 >> 2]);
    f55 = Math_fround(f21 * f24);
    f23 = Math_fround(HEAPF32[i35 >> 2]);
    f55 = Math_fround(f55 + Math_fround(f23 * f22));
    f25 = Math_fround(HEAPF32[i36 >> 2]);
    f55 = Math_fround(Math_fround(f25 * f18) + f55);
    f38 = Math_fround(Math_fround(f21 * f55) + Math_fround(Math_fround(f17 * f24) + Math_fround(f19 * Math_fround(Math_fround(f23 * f18) - Math_fround(f25 * f22)))));
    f54 = Math_fround(Math_fround(f23 * f55) + Math_fround(Math_fround(f17 * f22) + Math_fround(f19 * Math_fround(Math_fround(f25 * f24) - Math_fround(f21 * f18)))));
    f55 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(f19 * Math_fround(Math_fround(f21 * f22) - Math_fround(f23 * f24)))) + Math_fround(f25 * f55));
    f38 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f38);
    f54 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f54);
    f55 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + f55);
    HEAPF32[i53 + 16 >> 2] = f38;
    HEAPF32[i53 + 20 >> 2] = f54;
    HEAPF32[i53 + 24 >> 2] = f55;
    i4 = HEAP16[i40 >> 1] | 0;
    i1 = 5;
   }
   HEAPF32[i53 + 40 >> 2] = f3;
   HEAP32[i53 + 8 >> 2] = i5;
   HEAPF32[i53 + 44 >> 2] = Math_fround(0.0);
   HEAPF32[i53 + 48 >> 2] = Math_fround(0.0);
   i5 = i53 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   i6 = i53 + 32 | 0;
   HEAP32[i6 >> 2] = 0;
   i9 = i53 + 36 | 0;
   HEAP32[i9 >> 2] = 0;
   if (i4 & 2) {
    i1 = (i1 & 65535 | 2) & 65535;
    f8 = Math_fround(HEAPF32[i45 >> 2]);
    f58 = Math_fround(HEAPF32[i20 >> 2]);
    f8 = Math_fround(f8 * f58);
    f7 = Math_fround(HEAPF32[i43 >> 2]);
    f3 = Math_fround(HEAPF32[i20 + 4 >> 2]);
    f7 = Math_fround(f8 + Math_fround(f7 * f3));
    f8 = Math_fround(HEAPF32[i44 >> 2]);
    f2 = Math_fround(HEAPF32[i20 + 8 >> 2]);
    f8 = Math_fround(f7 + Math_fround(f8 * f2));
    f7 = Math_fround(f58 * Math_fround(HEAPF32[i50 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i51 >> 2])));
    f7 = Math_fround(f7 + Math_fround(f2 * Math_fround(HEAPF32[i46 >> 2])));
    f58 = Math_fround(f58 * Math_fround(HEAPF32[i47 >> 2]));
    f3 = Math_fround(f58 + Math_fround(f3 * Math_fround(HEAPF32[i48 >> 2])));
    f2 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i49 >> 2])));
    HEAPF32[i5 >> 2] = f8;
    HEAPF32[i6 >> 2] = f7;
    HEAPF32[i9 >> 2] = f2;
    f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f2 * f2))));
    if (f3 > Math_fround(0.0)) {
     f58 = Math_fround(Math_fround(1.0) / f3);
     HEAPF32[i5 >> 2] = Math_fround(f8 * f58);
     HEAPF32[i6 >> 2] = Math_fround(f7 * f58);
     HEAPF32[i9 >> 2] = Math_fround(f2 * f58);
    }
   }
   HEAP16[i53 + 12 >> 1] = i1;
   i53 = 1;
   STACKTOP = i52;
   return i53 | 0;
  }
 }
 HEAPF32[i53 + 40 >> 2] = Math_fround(0.0);
 HEAP32[i53 + 8 >> 2] = -1;
 HEAPF32[i53 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i53 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i53 + 16 >> 2] = f24;
 HEAPF32[i53 + 20 >> 2] = f25;
 HEAPF32[i53 + 24 >> 2] = f14;
 f57 = Math_fround(-f16);
 f58 = Math_fround(-f13);
 HEAPF32[i53 + 28 >> 2] = Math_fround(-f15);
 HEAPF32[i53 + 32 >> 2] = f57;
 HEAPF32[i53 + 36 >> 2] = f58;
 HEAP16[i53 + 12 >> 1] = 7;
 i53 = 1;
 STACKTOP = i52;
 return i53 | 0;
}

function __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext(i26, i27) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i32 + 8 | 0;
 i14 = i32;
 i16 = i32 + 40 | 0;
 i17 = i32 + 36 | 0;
 i29 = i32 + 24 | 0;
 i3 = HEAP32[i26 + 8 >> 2] | 0;
 i28 = i3 + 16 | 0;
 if ((HEAP16[gb + 1113036 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1113036 | 0, HEAP32[i28 >> 2] | 0);
  i30 = gb + 1113036 | 0;
 } else i30 = 0;
 i31 = HEAP32[gb + 1113036 >> 2] | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 648 >> 2] | 0, i1 | 0, i31 | 0);
 i31 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 3;
 i1 = HEAPU8[i26 + 28 >> 0] | 0;
 i25 = __Z22GetRenderBufferManagerv() | 0;
 i2 = i26 + 44 | 0;
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i25, HEAP32[i26 + 20 >> 2] | 0, HEAP32[i26 + 24 >> 2] | 0, 1, HEAP32[i2 >> 2] | 0, i1, 1, 0, 1) | 0;
 do if (!i1) i1 = 0; else {
  i2 = (HEAP32[i2 >> 2] | 0) == 3;
  if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 539 >> 0] | 0)) {
   i25 = __Z19GetGraphicsSettingsv() | 0;
   if (!(HEAP8[i25 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0)) i2 = i2 & (HEAP32[i3 + 96 >> 2] | 0) > 1;
  }
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 424513 | 0);
  HEAP32[i1 + 32 >> 2] = i2 & 1;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
  if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) if (!(__ZN13RenderTexture6CreateEv(i1) | 0)) {
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i1);
   i1 = 0;
   break;
  }
  i25 = i27 + 144 | 0;
  i24 = HEAP8[i25 >> 0] | 0;
  HEAP8[i25 >> 0] = 1;
  i4 = i26 + 1228 | 0;
  i23 = i3 + 208 | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i23, 0, i27, i4, gb + 1160140 | 0, HEAP32[i28 >> 2] | 0);
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i23, 1, i27, i4, gb + 1160140 | 0, HEAP32[i28 >> 2] | 0);
  HEAP8[i25 >> 0] = i24;
  i24 = i26 + 34296 | 0;
  if (HEAP32[i24 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i24);
  i2 = __Z12GetGfxDevicev() | 0;
  i13 = i26 + 1184 | 0;
  switch (HEAP32[i13 >> 2] | 0) {
  case 2:
   {
    i20 = i26 + 1204 | 0;
    i21 = i26 + 1208 | 0;
    i18 = HEAP32[i21 >> 2] | 0;
    i22 = i26 + 1212 | 0;
    i19 = HEAP32[i22 >> 2] | 0;
    f33 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i26 + 1188 >> 2]));
    HEAP32[i2 + 676 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i2 + 680 >> 2] = i18;
    HEAP32[i2 + 684 >> 2] = i19;
    HEAPF32[i2 + 688 >> 2] = f33;
    i21 = HEAP32[i21 >> 2] | 0;
    i22 = HEAP32[i22 >> 2] | 0;
    HEAP32[i2 + 548 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i2 + 552 >> 2] = i21;
    HEAP32[i2 + 556 >> 2] = i22;
    HEAPF32[i2 + 560 >> 2] = Math_fround(1.0);
    i22 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
    f33 = Math_fround(HEAPF32[i26 + 1196 >> 2]);
    f34 = Math_fround(f33 * Math_fround(2.0));
    HEAPF32[i2 + 804 >> 2] = i22 ? f34 : f33;
    HEAPF32[i2 + 808 >> 2] = Math_fround(0.0);
    HEAPF32[i2 + 812 >> 2] = Math_fround(0.0);
    HEAPF32[i2 + 816 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    i21 = HEAP32[i26 + 1220 >> 2] | 0;
    i22 = HEAP32[i26 + 1224 >> 2] | 0;
    HEAP32[i2 + 548 >> 2] = HEAP32[i26 + 1216 >> 2];
    HEAP32[i2 + 552 >> 2] = i21;
    HEAP32[i2 + 556 >> 2] = i22;
    HEAPF32[i2 + 560 >> 2] = Math_fround(0.0);
    break;
   }
  default:
   {
    i21 = HEAP32[i26 + 1208 >> 2] | 0;
    i22 = HEAP32[i26 + 1212 >> 2] | 0;
    HEAP32[i2 + 548 >> 2] = HEAP32[i26 + 1204 >> 2];
    HEAP32[i2 + 552 >> 2] = i21;
    HEAP32[i2 + 556 >> 2] = i22;
    HEAPF32[i2 + 560 >> 2] = Math_fround(1.0);
   }
  }
  if ((HEAP32[i13 >> 2] | 0) != 2) {
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 12);
   HEAPF32[i15 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
   __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(7, i15, Math_fround(1.0), 0, i27);
   __Z15gpu_time_samplev();
  }
  i22 = HEAP8[i25 >> 0] | 0;
  HEAP8[i25 >> 0] = 1;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i23, 0, i27, i4, gb + 1160140 | 0, HEAP32[i28 >> 2] | 0);
  HEAP8[i25 >> 0] = i22;
  if (!(HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] | 0)) i3 = 1; else i3 = __Z22GetJobQueueThreadCountv() | 0;
  i11 = i26 + 1152 | 0;
  i12 = i26 + 1156 | 0;
  i2 = ((HEAP32[i12 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) / 24 | 0;
  if ((HEAP32[i13 >> 2] | 0) == 2) if ((i3 | 0) > 5 & i2 >>> 0 > 768) i22 = 6; else if ((i3 | 0) > 2 & i2 >>> 0 > 384) i22 = 3; else i22 = (i3 | 0) > 1 & i2 >>> 0 > 256 ? 2 : 1; else {
   i22 = (i2 >>> 7) + 1 | 0;
   i22 = (i3 | 0) < (i22 | 0) ? i3 : i22;
  }
  HEAP32[i29 >> 2] = 0;
  i21 = i29 + 4 | 0;
  i19 = gb + 63160 | 0;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i2 = i21;
  HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i2 + 4 >> 2] = i20;
  i2 = i22 << 2;
  do if (!i2) i2 = 0; else {
   i3 = i2 | 3;
   if (i3 >>> 0 < 2e3) {
    i2 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, gb + 64016 | 0, 0, gb + 384477 | 0, 1946) | 0;
    i19 = gb + 64016 | 0;
    i18 = HEAP32[i19 >> 2] | 0;
    i19 = HEAP32[i19 + 4 >> 2] | 0;
    HEAP32[i29 >> 2] = i2;
    i20 = i21;
    HEAP32[i20 >> 2] = i18;
    HEAP32[i20 + 4 >> 2] = i19;
    break;
   }
  } while (0);
  i18 = i2 + 3 & -4;
  i20 = i18;
  i19 = (i22 | 0) > 0;
  if (i19) {
   i3 = i27 + 149 | 0;
   i2 = 0;
   do {
    i4 = i20 + (i2 << 2) | 0;
    i5 = __ZnwjRK10MemLabelIdiPKci(196, gb + 64024 | 0, 16, gb + 384477 | 0, 1828) | 0;
    HEAP32[i5 + 4 >> 2] = 1;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 >> 2] = gb + 35804 + 8;
    i6 = i5 + 12 | 0;
    i7 = i5 + 52 | 0;
    i8 = i5 + 56 | 0;
    i9 = i6;
    i10 = i9 + 40 | 0;
    do {
     HEAP32[i9 >> 2] = 0;
     i9 = i9 + 4 | 0;
    } while ((i9 | 0) < (i10 | 0));
    HEAP32[i8 >> 2] = 1;
    HEAP32[i7 >> 2] = gb + 33952 + 8;
    i8 = gb + 64024 | 0;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i9 = i14;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    HEAP32[i5 + 84 >> 2] = 0;
    HEAP32[i5 + 96 >> 2] = 0;
    HEAP32[i5 + 100 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
    i9 = i15;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i8 = i5 + 88 | 0;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = i10;
    i8 = gb + 64024 | 0;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i9 = i14;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    HEAP32[i5 + 104 >> 2] = 0;
    HEAP32[i5 + 116 >> 2] = 0;
    HEAP32[i5 + 120 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
    i9 = i15;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i8 = i5 + 108 | 0;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = i10;
    i8 = gb + 64024 | 0;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i9 = i14;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    HEAP32[i5 + 124 >> 2] = 0;
    HEAP32[i5 + 136 >> 2] = 0;
    HEAP32[i5 + 140 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
    i9 = i15;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i8 = i5 + 128 | 0;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = i10;
    HEAP32[i5 + 144 >> 2] = 0;
    HEAP32[i5 + 148 >> 2] = 0;
    i8 = gb + 64024 | 0;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i9 = i5 + 152 | 0;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    HEAP8[i5 + 160 >> 0] = 1;
    i9 = i5 + 60 | 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    HEAP32[i9 + 16 >> 2] = 0;
    HEAP32[i9 + 20 >> 2] = 0;
    HEAP8[i5 + 164 >> 0] = 1;
    HEAP8[i5 + 165 >> 0] = 0;
    HEAP32[i5 + 168 >> 2] = 0;
    HEAP32[i5 + 172 >> 2] = 0;
    HEAP32[i5 + 176 >> 2] = 0;
    HEAP32[i5 + 180 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP8[i5 + 184 >> 0] = 1;
    HEAP32[i5 + 188 >> 2] = 0;
    HEAP32[i5 + 192 >> 2] = 5;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i6 >> 2] = i1;
    i9 = HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0;
    i10 = HEAP32[i4 >> 2] | 0;
    HEAP8[i10 + 184 >> 0] = i9 << 24 >> 24 != 0 & (HEAP8[i3 >> 0] | 0) == 0 & 1;
    __ZN17ShaderPassContext8CopyFromERKS_(i10 + 16 | 0, i27);
    i10 = HEAP32[i4 >> 2] | 0;
    HEAP8[i10 + 160 >> 0] = 0;
    i10 = i10 + 20 | 0;
    HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -134217729;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i22 | 0));
  }
  if ((HEAP32[i13 >> 2] | 0) == 2) {
   if (i19) {
    i2 = 0;
    do {
     i13 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
     HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
     __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13 + 168 | 0, i14, i15);
     i9 = 6 / (i22 | 0) | 0;
     i10 = Math_imul(i9, i2) | 0;
     HEAP32[i13 + 188 >> 2] = i10;
     HEAP32[i13 + 192 >> 2] = i9 + -1 + i10;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i22 | 0));
   }
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   i12 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 24 | 0;
   i11 = (i12 >>> 0) / (i22 >>> 0) | 0;
   i12 = i12 - (Math_imul(i11, i22 + -1 | 0) | 0) | 0;
   if (i19) {
    i10 = 0;
    do {
     i5 = HEAP32[i20 + (i10 << 2) >> 2] | 0;
     i10 = i10 + 1 | 0;
     i9 = (i10 | 0) == (i22 | 0);
     i7 = i9 ? i12 : i11;
     i8 = i5 + 168 | 0;
     i5 = i5 + 172 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i4 = HEAP32[i8 >> 2] | 0;
     i3 = (i6 - i4 | 0) / 24 | 0;
     if (i7 >>> 0 > i3 >>> 0) __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE8__appendEj(i8, i7 - i3 | 0); else if (i7 >>> 0 < i3 >>> 0) {
      i3 = i4 + (i7 * 24 | 0) | 0;
      if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~(((i6 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
     }
     if (i7) {
      i4 = 0;
      while (1) {
       i17 = (HEAP32[i8 >> 2] | 0) + (i4 * 24 | 0) | 0;
       i3 = i2 + 24 | 0;
       i16 = i2;
       HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i17 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
       HEAP32[i17 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
       HEAP32[i17 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
       HEAP32[i17 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
       HEAP32[i17 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i7 | 0)) {
        i2 = i3;
        break;
       } else i2 = i3;
      }
     }
    } while (!i9);
   }
  }
  i17 = __Z12GetGfxDevicev() | 0;
  mftCall_viiiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 892 >> 2] | 0, i17 | 0, i22 | 0, fb + 2388 | 0, i18 | 0, i26 | 0, i24 | 0);
  i26 = HEAP8[i25 >> 0] | 0;
  HEAP8[i25 >> 0] = 1;
  __ZNK19RenderEventsContext25PostExecuteCommandBuffersEiR17ShaderPassContextP13RenderTextureP19ProfilerInformationi(i23, 1, i27, i1, gb + 1160140 | 0, HEAP32[i28 >> 2] | 0);
  HEAP8[i25 >> 0] = i26;
  if (i19) {
   i2 = 0;
   do {
    i3 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
    i28 = i3 + 4 | 0;
    HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + -1;
    if (!(HEAP32[i28 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i22 | 0));
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i21);
 } while (0);
 HEAP32[gb + 1163232 >> 2] = i31;
 i31 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i31 >> 2] | 0) + 652 >> 2] | 0, i31 | 0);
 if (!i30) {
  STACKTOP = i32;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i30);
 STACKTOP = i32;
 return i1 | 0;
}

function __ZN5physx2Sc7BodySim17updateWakeCounterEffffb(i28, f25, f24, f11, f10, i1) {
 i28 = i28 | 0;
 f25 = Math_fround(f25);
 f24 = Math_fround(f24);
 f11 = Math_fround(f11);
 f10 = Math_fround(f10);
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i26 = 0, f27 = f0, f29 = f0, f30 = f0, i31 = 0;
 i2 = i28 + 52 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 f27 = Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i26));
 if (i1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i26) | 0;
  f18 = Math_fround(HEAPF32[i7 >> 2]);
  f19 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i7 = f18 > Math_fround(0.0);
  f18 = Math_fround(Math_fround(1.0) / f18);
  f18 = i7 ? f18 : Math_fround(1.0);
  i7 = f19 > Math_fround(0.0);
  f19 = Math_fround(Math_fround(1.0) / f19);
  f19 = i7 ? f19 : Math_fround(1.0);
  i7 = f20 > Math_fround(0.0);
  f20 = Math_fround(Math_fround(1.0) / f20);
  f20 = i7 ? f20 : Math_fround(1.0);
  f12 = Math_fround(HEAPF32[i28 + 64 >> 2]);
  f13 = Math_fround(HEAPF32[i28 + 68 >> 2]);
  f14 = Math_fround(HEAPF32[i28 + 72 >> 2]);
  f23 = Math_fround(Math_fround(HEAPF32[i28 + 80 >> 2]) * Math_fround(2.0));
  f3 = Math_fround(Math_fround(HEAPF32[i28 + 84 >> 2]) * Math_fround(2.0));
  f30 = Math_fround(Math_fround(HEAPF32[i28 + 88 >> 2]) * Math_fround(2.0));
  f8 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  f29 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f17 = Math_fround(f23 * f9);
  f21 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f3 * f21));
  f22 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f30 * f22));
  f15 = Math_fround(Math_fround(f9 * f17) + Math_fround(Math_fround(f23 * f29) - Math_fround(f8 * Math_fround(Math_fround(f30 * f21) - Math_fround(f3 * f22)))));
  f16 = Math_fround(Math_fround(f21 * f17) + Math_fround(Math_fround(f3 * f29) - Math_fround(f8 * Math_fround(Math_fround(f23 * f22) - Math_fround(f30 * f9)))));
  f17 = Math_fround(Math_fround(Math_fround(f30 * f29) - Math_fround(f8 * Math_fround(Math_fround(f3 * f9) - Math_fround(f23 * f21)))) + Math_fround(f22 * f17));
  i1 = HEAP16[i28 + 46 >> 1] | 0;
  f22 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i26));
  i7 = f22 == Math_fround(0.0);
  f22 = i7 ? Math_fround(1.0) : f22;
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14)) + Math_fround(f22 * Math_fround(Math_fround(f20 * Math_fround(f17 * f17)) + Math_fround(Math_fround(f18 * Math_fround(f15 * f15)) + Math_fround(f19 * Math_fround(f16 * f16)))))) * Math_fround(.5));
  f23 = Math_fround(i1 & 65535);
  f9 = ((i1 & 65535) > 1 ? (HEAP16[i28 + 144 >> 1] & 2) != 0 : 0) ? f23 : Math_fround(0.0);
  f3 = Math_fround(f9 * f11);
  i1 = i28 + 168 | 0;
  f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f25);
  i7 = f8 > Math_fround(0.0);
  f8 = i7 ? f8 : Math_fround(0.0);
  HEAPF32[i1 >> 2] = f8;
  do if (!(f21 >= f3)) {
   i1 = i28 + 184 | 0;
   i4 = f8 == Math_fround(0.0);
   i5 = 8;
  } else {
   HEAPF32[i1 >> 2] = Math_fround(1.0);
   i1 = i28 + 184 | 0;
   if (!(f21 >= Math_fround(f9 * f3))) {
    if (Math_fround(HEAPF32[i1 >> 2]) > Math_fround(0.0)) {
     i4 = 0;
     i5 = 8;
     break;
    }
   } else HEAPF32[i1 >> 2] = Math_fround(0.0);
   i1 = (HEAP32[i2 >> 2] | 0) + 45 | 0;
   i2 = HEAPU8[i1 >> 0] | 0;
   i5 = 10;
  } while (0);
  if ((i5 | 0) == 8) {
   f30 = Math_fround(Math_fround(1.0) - Math_fround(f25 * Math_fround(.5)));
   i7 = i26 + 80 | 0;
   f8 = Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2]));
   i6 = i26 + 84 | 0;
   f29 = Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]));
   i31 = i26 + 88 | 0;
   f9 = Math_fround(f30 * Math_fround(HEAPF32[i31 >> 2]));
   HEAPF32[i7 >> 2] = f8;
   HEAPF32[i6 >> 2] = f29;
   HEAPF32[i31 >> 2] = f9;
   i31 = i26 + 96 | 0;
   f9 = Math_fround(f30 * Math_fround(HEAPF32[i31 >> 2]));
   i6 = i26 + 100 | 0;
   f29 = Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]));
   i7 = i26 + 104 | 0;
   f30 = Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2]));
   HEAPF32[i31 >> 2] = f9;
   HEAPF32[i6 >> 2] = f29;
   HEAPF32[i7 >> 2] = f30;
   HEAPF32[i1 >> 2] = Math_fround(f10 * Math_fround(.899999976));
   i1 = (HEAP32[i2 >> 2] | 0) + 45 | 0;
   i2 = HEAPU8[i1 >> 0] | 0;
   if (f21 < f11 & i4) {
    HEAP8[i1 >> 0] = i2 | 1;
    i1 = HEAP32[i28 + 100 >> 2] | 0;
    i2 = HEAP32[i28 + 104 >> 2] | 0;
    i4 = HEAP32[i28 + 108 >> 2] | 0;
    i6 = HEAP32[i28 + 112 >> 2] | 0;
    i7 = HEAP32[i28 + 116 >> 2] | 0;
    i31 = HEAP32[i28 + 120 >> 2] | 0;
    HEAP32[i26 + 16 >> 2] = HEAP32[i28 + 96 >> 2];
    HEAP32[i26 + 20 >> 2] = i1;
    HEAP32[i26 + 24 >> 2] = i2;
    HEAP32[i26 + 28 >> 2] = i4;
    HEAP32[i26 + 32 >> 2] = i6;
    HEAP32[i26 + 36 >> 2] = i7;
    HEAP32[i26 + 40 >> 2] = i31;
   } else i5 = 10;
  }
  if ((i5 | 0) == 10) HEAP8[i1 >> 0] = i2 & 254;
  if (f27 < Math_fround(.199999988) | f27 < f25) {
   i7 = i28 + 156 | 0;
   f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 >> 2]));
   HEAPF32[i7 >> 2] = f12;
   i6 = i28 + 160 | 0;
   f11 = Math_fround(f13 + Math_fround(HEAPF32[i6 >> 2]));
   HEAPF32[i6 >> 2] = f11;
   i5 = i28 + 164 | 0;
   f10 = Math_fround(f14 + Math_fround(HEAPF32[i5 >> 2]));
   HEAPF32[i5 >> 2] = f10;
   i4 = i28 + 172 | 0;
   f9 = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
   HEAPF32[i4 >> 2] = f9;
   i2 = i28 + 176 | 0;
   f8 = Math_fround(f16 + Math_fround(HEAPF32[i2 >> 2]));
   HEAPF32[i2 >> 2] = f8;
   i1 = i28 + 180 | 0;
   f3 = Math_fround(f17 + Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i1 >> 2] = f3;
   if (f21 >= f24) {
    f8 = Math_fround(Math_fround(Math_fround(f22 * Math_fround(Math_fround(f20 * Math_fround(f3 * f3)) + Math_fround(Math_fround(f18 * Math_fround(f9 * f9)) + Math_fround(f19 * Math_fround(f8 * f8))))) + Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(f10 * f10))) * Math_fround(.5));
    f9 = Math_fround(f23 + Math_fround(1.0));
    f3 = Math_fround(f9 * f24);
    if (f8 >= f3) {
     HEAP32[i7 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i1 >> 2] = 0;
     if (f24 == Math_fround(0.0)) f3 = Math_fround(.399999976); else {
      f3 = Math_fround(f8 / f3);
      i31 = f3 < Math_fround(2.0);
      f3 = Math_fround(Math_fround(f3 * Math_fround(.5)) * Math_fround(.399999976));
      f3 = i31 ? f3 : Math_fround(.399999976);
     }
     f3 = Math_fround(Math_fround(Math_fround(f9 + Math_fround(-1.0)) * f25) + f3);
     HEAPF32[i26 + 152 >> 2] = f3;
     if (!(f27 == Math_fround(0.0))) {
      f30 = f3;
      return Math_fround(f30);
     }
     i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i28 + 36 >> 2] | 0) | 0;
     i1 = i28 + 188 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i5 + 16 >> 2] | 0;
     i28 = i4 + (i2 * 12 | 0) + 8 | 0;
     i31 = HEAP8[i28 >> 0] | 0;
     HEAP8[i28 >> 0] = i31 & 255 | 8;
     do if (!(i31 & 8)) {
      i31 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
      HEAP32[i31 >> 2] = HEAP32[i31 >> 2] | 1 << (i2 & 31);
      i1 = HEAP32[i1 >> 2] | 0;
      if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
       i2 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
       i4 = HEAP32[i2 >> 2] | 0;
       i1 = 1 << (i1 & 31);
       if (!(i4 & i1)) {
        HEAP32[i2 >> 2] = i4 | i1;
        break;
       } else {
        HEAP32[i2 >> 2] = i4 & ~i1;
        break;
       }
      }
     } while (0);
     HEAP8[i5 + 477 >> 0] = 1;
     f30 = f3;
     return Math_fround(f30);
    }
   }
  }
 } else if (f27 < Math_fround(.199999988) | f27 < f25) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i26) | 0;
  f23 = Math_fround(HEAPF32[i2 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i2 = f23 > Math_fround(0.0);
  f23 = Math_fround(Math_fround(1.0) / f23);
  f23 = i2 ? f23 : Math_fround(1.0);
  i2 = f30 > Math_fround(0.0);
  f30 = Math_fround(Math_fround(1.0) / f30);
  f30 = i2 ? f30 : Math_fround(1.0);
  i2 = f8 > Math_fround(0.0);
  f8 = Math_fround(Math_fround(1.0) / f8);
  f8 = i2 ? f8 : Math_fround(1.0);
  f20 = Math_fround(HEAPF32[i28 + 64 >> 2]);
  f21 = Math_fround(HEAPF32[i28 + 68 >> 2]);
  f3 = Math_fround(HEAPF32[i28 + 72 >> 2]);
  f17 = Math_fround(Math_fround(HEAPF32[i28 + 80 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i28 + 84 >> 2]) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(HEAPF32[i28 + 88 >> 2]) * Math_fround(2.0));
  f14 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  f13 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
  f16 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f22 = Math_fround(f17 * f16);
  f18 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f22 = Math_fround(f22 + Math_fround(f15 * f18));
  f19 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f22 = Math_fround(f22 + Math_fround(f12 * f19));
  f9 = Math_fround(Math_fround(f16 * f22) + Math_fround(Math_fround(f17 * f13) - Math_fround(f14 * Math_fround(Math_fround(f12 * f18) - Math_fround(f15 * f19)))));
  f29 = Math_fround(Math_fround(f18 * f22) + Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * Math_fround(Math_fround(f17 * f19) - Math_fround(f12 * f16)))));
  f22 = Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f18)))) + Math_fround(f19 * f22));
  i1 = i28 + 156 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2]));
  i2 = i28 + 160 | 0;
  HEAPF32[i2 >> 2] = Math_fround(f21 + Math_fround(HEAPF32[i2 >> 2]));
  i4 = i28 + 164 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
  i5 = i28 + 172 | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f9);
  i6 = i28 + 176 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f29 + Math_fround(HEAPF32[i6 >> 2]));
  i7 = i28 + 180 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i7 >> 2]));
  f22 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i26));
  i31 = f22 == Math_fround(0.0);
  f22 = i31 ? Math_fround(1.0) : f22;
  f29 = Math_fround(HEAPF32[i5 >> 2]);
  f29 = Math_fround(f29 * f29);
  f9 = Math_fround(HEAPF32[i6 >> 2]);
  f9 = Math_fround(f9 * f9);
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f3 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(f23 * f29) + Math_fround(f30 * f9)) + Math_fround(f8 * Math_fround(f3 * f3))));
  f8 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(f8 * f8);
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f9 = Math_fround(f8 + Math_fround(f9 * f9));
  f8 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(Math_fround(f3 + Math_fround(f9 + Math_fround(f8 * f8))) * Math_fround(.5));
  f9 = Math_fround(((HEAPU16[i28 + 48 >> 1] | 0) + 1 | 0) >>> 0);
  f3 = Math_fround(f9 * f24);
  if (f8 >= f3) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   if (f3 == Math_fround(0.0)) f3 = Math_fround(.399999976); else {
    f3 = Math_fround(f8 / f3);
    i31 = f3 < Math_fround(2.0);
    f3 = Math_fround(Math_fround(f3 * Math_fround(.5)) * Math_fround(.399999976));
    f3 = i31 ? f3 : Math_fround(.399999976);
   }
   f3 = Math_fround(Math_fround(Math_fround(f9 + Math_fround(-1.0)) * f25) + f3);
   HEAPF32[i26 + 152 >> 2] = f3;
   if (!(f27 == Math_fround(0.0))) {
    f30 = f3;
    return Math_fround(f30);
   }
   i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i28 + 36 >> 2] | 0) | 0;
   i1 = i28 + 188 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i5 + 16 >> 2] | 0;
   i28 = i4 + (i2 * 12 | 0) + 8 | 0;
   i31 = HEAP8[i28 >> 0] | 0;
   HEAP8[i28 >> 0] = i31 & 255 | 8;
   do if (!(i31 & 8)) {
    i31 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i31 >> 2] = HEAP32[i31 >> 2] | 1 << (i2 & 31);
    i1 = HEAP32[i1 >> 2] | 0;
    if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
     i2 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
     i4 = HEAP32[i2 >> 2] | 0;
     i1 = 1 << (i1 & 31);
     if (!(i4 & i1)) {
      HEAP32[i2 >> 2] = i4 | i1;
      break;
     } else {
      HEAP32[i2 >> 2] = i4 & ~i1;
      break;
     }
    }
   } while (0);
   HEAP8[i5 + 477 >> 0] = 1;
   f30 = f3;
   return Math_fround(f30);
  }
 }
 f30 = Math_fround(f27 - f25);
 i31 = f30 > Math_fround(0.0);
 f30 = i31 ? f30 : Math_fround(0.0);
 HEAPF32[i26 + 152 >> 2] = f30;
 return Math_fround(f30);
}

function __Z19sweepBox_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i24, i26, i4, i28, f19, i27, i5, f2) {
 i24 = i24 | 0;
 i26 = i26 | 0;
 i4 = i4 | 0;
 i28 = i28 | 0;
 f19 = Math_fround(f19);
 i27 = i27 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var f1 = f0, f3 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i29 + 352 | 0;
 i25 = i29 + 560 | 0;
 i31 = i29 + 336 | 0;
 i13 = i29 + 96 | 0;
 i32 = i29 + 272 | 0;
 i22 = i29 + 80 | 0;
 i21 = i29 + 64 | 0;
 i34 = i29 + 112 | 0;
 i30 = i29 + 48 | 0;
 i12 = i29 + 32 | 0;
 i7 = i29 + 16 | 0;
 i20 = i29;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i33, i4);
 f50 = Math_fround(HEAPF32[i33 >> 2]);
 f51 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f46 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f49 = Math_fround(HEAPF32[i33 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f45 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f47 = Math_fround(HEAPF32[i4 + 44 >> 2]);
 i41 = HEAP32[i24 + 32 >> 2] | 0;
 i23 = i41 + 16 | 0;
 HEAP32[i25 >> 2] = HEAPU8[i41 + 55 >> 0];
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i26 >> 2]);
 f15 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 i41 = i26 + 16 | 0;
 f1 = Math_fround(HEAPF32[i41 >> 2]);
 f3 = Math_fround(HEAPF32[i41 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i41 + 8 >> 2]);
 f38 = Math_fround(-f14);
 f6 = Math_fround(-f15);
 f37 = Math_fround(-f16);
 f10 = Math_fround(f10 - f1);
 f45 = Math_fround(f45 - f3);
 f47 = Math_fround(f47 - f8);
 f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f48 = Math_fround(Math_fround(Math_fround(f10 * f38) + Math_fround(f45 * f6)) + Math_fround(f47 * f37));
 f9 = Math_fround(Math_fround(Math_fround(f48 * f6) + Math_fround(Math_fround(f18 * f45) + Math_fround(f17 * Math_fround(Math_fround(f10 * f37) - Math_fround(f47 * f38))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f47) + Math_fround(f17 * Math_fround(Math_fround(f45 * f38) - Math_fround(f10 * f6)))) + Math_fround(f48 * f37)) * Math_fround(2.0));
 f39 = Math_fround(Math_fround(f49 * f17) - Math_fround(Math_fround(Math_fround(f50 * f38) + Math_fround(f51 * f6)) + Math_fround(f46 * f37)));
 f35 = Math_fround(Math_fround(Math_fround(f46 * f6) - Math_fround(f51 * f37)) + Math_fround(Math_fround(f49 * f38) + Math_fround(f50 * f17)));
 f36 = Math_fround(Math_fround(Math_fround(f50 * f37) - Math_fround(f46 * f38)) + Math_fround(Math_fround(f49 * f6) + Math_fround(f51 * f17)));
 f46 = Math_fround(Math_fround(Math_fround(f51 * f38) - Math_fround(f50 * f6)) + Math_fround(Math_fround(f49 * f37) + Math_fround(f46 * f17)));
 HEAPF32[i32 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f48 * f38) + Math_fround(Math_fround(f18 * f10) + Math_fround(f17 * Math_fround(Math_fround(f47 * f6) - Math_fround(f45 * f37))))) * Math_fround(2.0));
 HEAPF32[i32 + 52 >> 2] = f9;
 HEAPF32[i32 + 56 >> 2] = f11;
 HEAPF32[i32 + 60 >> 2] = Math_fround(0.0);
 f11 = Math_fround(f35 + f35);
 f9 = Math_fround(f36 + f36);
 f37 = Math_fround(f46 + f46);
 f45 = Math_fround(f36 * f9);
 f6 = Math_fround(f46 * f37);
 f36 = Math_fround(f36 * f11);
 f47 = Math_fround(f46 * f11);
 f10 = Math_fround(f39 * f11);
 f46 = Math_fround(f46 * f9);
 f9 = Math_fround(f39 * f9);
 f37 = Math_fround(f39 * f37);
 f11 = Math_fround(Math_fround(1.0) - Math_fround(f35 * f11));
 f35 = Math_fround(f36 + f37);
 f39 = Math_fround(f47 - f9);
 f37 = Math_fround(f36 - f37);
 f36 = Math_fround(f11 - f6);
 f38 = Math_fround(f46 + f10);
 f9 = Math_fround(f47 + f9);
 f10 = Math_fround(f46 - f10);
 f11 = Math_fround(f11 - f45);
 HEAPF32[i32 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f45) - f6);
 HEAPF32[i32 + 4 >> 2] = f35;
 HEAPF32[i32 + 8 >> 2] = f39;
 HEAPF32[i32 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i32 + 16 >> 2] = f37;
 HEAPF32[i32 + 20 >> 2] = f36;
 HEAPF32[i32 + 24 >> 2] = f38;
 HEAPF32[i32 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i32 + 32 >> 2] = f9;
 HEAPF32[i32 + 36 >> 2] = f10;
 HEAPF32[i32 + 40 >> 2] = f11;
 HEAPF32[i32 + 44 >> 2] = Math_fround(0.0);
 i41 = HEAP32[i4 + 48 >> 2] | 0;
 i40 = HEAP32[i4 + 52 >> 2] | 0;
 i4 = HEAP32[i4 + 56 >> 2] | 0;
 i43 = HEAP32[i24 + 8 >> 2] | 0;
 i44 = HEAP32[i24 + 12 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 4 >> 2] = i43;
 HEAP32[i22 + 8 >> 2] = i44;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 i44 = HEAP32[i24 + 20 >> 2] | 0;
 i43 = HEAP32[i24 + 24 >> 2] | 0;
 i42 = HEAP32[i24 + 28 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i24 + 16 >> 2];
 HEAP32[i21 + 4 >> 2] = i44;
 HEAP32[i21 + 8 >> 2] = i43;
 HEAP32[i21 + 12 >> 2] = i42;
 i42 = i34 + 64 | 0;
 HEAP32[i34 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
 HEAP32[i34 + 80 >> 2] = 3;
 HEAPF32[i34 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i33 >> 2] = 0;
 HEAP32[i33 + 4 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 HEAP32[i33 + 12 >> 2] = 0;
 HEAP32[i42 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
 HEAP32[i34 + 144 >> 2] = i41;
 HEAP32[i34 + 148 >> 2] = i40;
 HEAP32[i34 + 152 >> 2] = i4;
 HEAPF32[i34 + 156 >> 2] = Math_fround(0.0);
 f11 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = f11 <= f10 ? f11 : f10;
 f9 = f10 <= f9 ? f10 : f9;
 HEAPF32[i34 + 16 >> 2] = Math_fround(f9 * Math_fround(.150000006));
 HEAPF32[i34 + 32 >> 2] = Math_fround(f9 * Math_fround(.0500000007));
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i33, i23, i31, i22, i21);
 f9 = Math_fround(HEAPF32[i28 >> 2]);
 i21 = i28 + 4 | 0;
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 i22 = i28 + 8 | 0;
 f11 = Math_fround(HEAPF32[i22 >> 2]);
 f38 = Math_fround(-Math_fround(f9 * f19));
 f36 = Math_fround(-Math_fround(f10 * f19));
 f37 = Math_fround(-Math_fround(f11 * f19));
 f39 = Math_fround(Math_fround(Math_fround(f14 * f38) + Math_fround(f15 * f36)) + Math_fround(f16 * f37));
 f35 = Math_fround(Math_fround(Math_fround(f15 * f39) + Math_fround(Math_fround(f18 * f36) - Math_fround(f17 * Math_fround(Math_fround(f16 * f38) - Math_fround(f14 * f37))))) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f37) - Math_fround(f17 * Math_fround(Math_fround(f14 * f36) - Math_fround(f15 * f38)))) + Math_fround(f16 * f39)) * Math_fround(2.0));
 HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(f14 * f39) + Math_fround(Math_fround(f18 * f38) - Math_fround(f17 * Math_fround(Math_fround(f15 * f37) - Math_fround(f16 * f36))))) * Math_fround(2.0));
 HEAPF32[i30 + 4 >> 2] = f35;
 HEAPF32[i30 + 8 >> 2] = f6;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 i5 = (HEAP16[i5 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i34, i33, i32, i13, i31, i30, i12, i20, i7, f2, i5) | 0)) {
  i44 = 0;
  STACKTOP = i29;
  return i44 | 0;
 }
 f51 = Math_fround(HEAPF32[i7 >> 2]);
 f50 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f14 * f51) + Math_fround(f15 * f50)) + Math_fround(f16 * f49));
 f6 = Math_fround(f1 + Math_fround(Math_fround(Math_fround(f14 * f2) + Math_fround(Math_fround(f18 * f51) + Math_fround(f17 * Math_fround(Math_fround(f15 * f49) - Math_fround(f16 * f50))))) * Math_fround(2.0)));
 f3 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f15 * f2) + Math_fround(Math_fround(f18 * f50) + Math_fround(f17 * Math_fround(Math_fround(f16 * f51) - Math_fround(f14 * f49))))) * Math_fround(2.0)));
 f2 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(Math_fround(f18 * f49) + Math_fround(f17 * Math_fround(Math_fround(f14 * f50) - Math_fround(f15 * f51)))) + Math_fround(f16 * f2)) * Math_fround(2.0)));
 i4 = i27 + 12 | 0;
 HEAP16[i4 >> 1] = 6;
 f51 = Math_fround(HEAPF32[i13 >> 2]);
 f1 = Math_fround(HEAPF32[i12 >> 2]);
 do if (!(f51 >= f1)) {
  HEAP16[i4 >> 1] = 7;
  f46 = Math_fround(HEAPF32[i20 >> 2]);
  f50 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f14 * f46) + Math_fround(f15 * f50)) + Math_fround(f16 * f51));
  f47 = Math_fround(Math_fround(Math_fround(f14 * f49) + Math_fround(Math_fround(f18 * f46) + Math_fround(f17 * Math_fround(Math_fround(f15 * f51) - Math_fround(f16 * f50))))) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(Math_fround(f15 * f49) + Math_fround(Math_fround(f18 * f50) + Math_fround(f17 * Math_fround(Math_fround(f16 * f46) - Math_fround(f14 * f51))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f51) + Math_fround(f17 * Math_fround(Math_fround(f14 * f50) - Math_fround(f15 * f46)))) + Math_fround(f16 * f49)) * Math_fround(2.0));
  f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f49 * f49) + Math_fround(Math_fround(f47 * f47) + Math_fround(f48 * f48))))));
  f48 = Math_fround(f46 * f48);
  f49 = Math_fround(f46 * f49);
  f50 = Math_fround(f1 * f19);
  f1 = Math_fround(f6 + Math_fround(f9 * f50));
  f51 = Math_fround(f3 + Math_fround(f10 * f50));
  f3 = Math_fround(f2 + Math_fround(f11 * f50));
  HEAPF32[i27 + 28 >> 2] = Math_fround(f46 * f47);
  HEAPF32[i27 + 32 >> 2] = f48;
  HEAPF32[i27 + 36 >> 2] = f49;
  HEAPF32[i27 + 16 >> 2] = f1;
  HEAPF32[i27 + 20 >> 2] = f51;
  HEAPF32[i27 + 24 >> 2] = f3;
  HEAPF32[i27 + 40 >> 2] = f50;
  f2 = f51;
 } else if (i5) {
  HEAP16[i4 >> 1] = 7;
  f50 = Math_fround(HEAPF32[i20 >> 2]);
  f51 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f49 = Math_fround(Math_fround(Math_fround(f14 * f50) + Math_fround(f15 * f51)) + Math_fround(f16 * f46));
  f47 = Math_fround(Math_fround(Math_fround(f14 * f49) + Math_fround(Math_fround(f18 * f50) + Math_fround(f17 * Math_fround(Math_fround(f15 * f46) - Math_fround(f16 * f51))))) * Math_fround(2.0));
  f48 = Math_fround(Math_fround(Math_fround(f15 * f49) + Math_fround(Math_fround(f18 * f51) + Math_fround(f17 * Math_fround(Math_fround(f16 * f50) - Math_fround(f14 * f46))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f46) + Math_fround(f17 * Math_fround(Math_fround(f14 * f51) - Math_fround(f15 * f50)))) + Math_fround(f16 * f49)) * Math_fround(2.0));
  f50 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f49 * f49) + Math_fround(Math_fround(f47 * f47) + Math_fround(f48 * f48))))));
  f47 = Math_fround(f50 * f47);
  f48 = Math_fround(f50 * f48);
  f49 = Math_fround(f50 * f49);
  f50 = Math_fround(f6 - Math_fround(f1 * f47));
  f51 = Math_fround(f3 - Math_fround(f1 * f48));
  f3 = Math_fround(f2 - Math_fround(f1 * f49));
  HEAPF32[i27 + 28 >> 2] = f47;
  HEAPF32[i27 + 32 >> 2] = f48;
  HEAPF32[i27 + 36 >> 2] = f49;
  HEAPF32[i27 + 16 >> 2] = f50;
  HEAPF32[i27 + 20 >> 2] = f51;
  HEAPF32[i27 + 24 >> 2] = f3;
  HEAPF32[i27 + 40 >> 2] = f1;
  f1 = f50;
  f2 = f51;
  break;
 } else {
  HEAPF32[i27 + 40 >> 2] = Math_fround(0.0);
  f3 = Math_fround(-Math_fround(HEAPF32[i28 >> 2]));
  f2 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
  f1 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  HEAPF32[i27 + 28 >> 2] = f3;
  HEAPF32[i27 + 32 >> 2] = f2;
  HEAPF32[i27 + 36 >> 2] = f1;
  f1 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  f2 = Math_fround(HEAPF32[i27 + 20 >> 2]);
  f3 = Math_fround(HEAPF32[i27 + 24 >> 2]);
  break;
 } while (0);
 f50 = Math_fround(HEAPF32[i28 >> 2]);
 f51 = Math_fround(HEAPF32[i21 >> 2]);
 HEAP32[i27 + 8 >> 2] = __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_(i24, i23, i25, i26, f1, f2, f3, f50, f51, Math_fround(HEAPF32[i22 >> 2])) | 0;
 i44 = 1;
 STACKTOP = i29;
 return i44 | 0;
}

function _SphericalJointSolverPrep(i38, i17, i1, i2, i32, i3, i6) {
 i38 = i38 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var f4 = f0, f5 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i37 + 116 | 0;
 i35 = i37 + 88 | 0;
 i36 = i37 + 56 | 0;
 i21 = i37 + 40 | 0;
 i19 = i37 + 28 | 0;
 i18 = i37 + 16 | 0;
 i20 = i37 + 12 | 0;
 i33 = i37;
 i15 = i32 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 f28 = Math_fround(Math_fround(HEAPF32[i32 + 16 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i32 + 20 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i32 + 24 >> 2]) * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f7 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f25 = Math_fround(f28 * f12);
 f27 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f23 * f27));
 f24 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f10 * f24));
 f5 = Math_fround(Math_fround(f12 * f25) + Math_fround(Math_fround(f28 * f7) + Math_fround(f8 * Math_fround(Math_fround(f10 * f27) - Math_fround(f23 * f24)))));
 f4 = Math_fround(Math_fround(f27 * f25) + Math_fround(Math_fround(f23 * f7) + Math_fround(f8 * Math_fround(Math_fround(f28 * f24) - Math_fround(f10 * f12)))));
 f25 = Math_fround(Math_fround(Math_fround(f10 * f7) + Math_fround(f8 * Math_fround(Math_fround(f23 * f12) - Math_fround(f28 * f27)))) + Math_fround(f24 * f25));
 i15 = i3 + 16 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f5);
 i16 = i3 + 20 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f4);
 i14 = i3 + 24 | 0;
 f25 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f25);
 f28 = Math_fround(HEAPF32[i32 >> 2]);
 f23 = Math_fround(f8 * f28);
 f7 = Math_fround(HEAPF32[i32 + 12 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f12 * f7));
 f10 = Math_fround(HEAPF32[i32 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f27 * f10));
 f22 = Math_fround(HEAPF32[i32 + 4 >> 2]);
 f26 = Math_fround(Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f27 * f7) + Math_fround(f8 * f22))) - Math_fround(f12 * f10));
 f11 = Math_fround(Math_fround(Math_fround(f12 * f22) + Math_fround(Math_fround(f24 * f7) + Math_fround(f8 * f10))) - Math_fround(f27 * f28));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f7) - Math_fround(f12 * f28)) - Math_fround(f27 * f22)) - Math_fround(f24 * f10));
 HEAPF32[i34 >> 2] = Math_fround(f23 - Math_fround(f24 * f22));
 i42 = i34 + 4 | 0;
 HEAPF32[i42 >> 2] = f26;
 i41 = i34 + 8 | 0;
 HEAPF32[i41 >> 2] = f11;
 i40 = i34 + 12 | 0;
 HEAPF32[i40 >> 2] = f10;
 i29 = i34 + 16 | 0;
 HEAPF32[i29 >> 2] = f5;
 i30 = i34 + 20 | 0;
 HEAPF32[i30 >> 2] = f4;
 i31 = i34 + 24 | 0;
 HEAPF32[i31 >> 2] = f25;
 f25 = Math_fround(Math_fround(HEAPF32[i32 + 44 >> 2]) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(HEAPF32[i32 + 48 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i32 + 52 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f22 = Math_fround(f25 * f26);
 f24 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f4 * f24));
 f23 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f5 * f23));
 f27 = Math_fround(Math_fround(f26 * f22) + Math_fround(Math_fround(f25 * f11) + Math_fround(f10 * Math_fround(Math_fround(f5 * f24) - Math_fround(f4 * f23)))));
 f28 = Math_fround(Math_fround(f24 * f22) + Math_fround(Math_fround(f4 * f11) + Math_fround(f10 * Math_fround(Math_fround(f25 * f23) - Math_fround(f5 * f26)))));
 f22 = Math_fround(Math_fround(Math_fround(f5 * f11) + Math_fround(f10 * Math_fround(Math_fround(f4 * f26) - Math_fround(f25 * f24)))) + Math_fround(f23 * f22));
 i9 = i6 + 16 | 0;
 f27 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f27);
 i13 = i6 + 20 | 0;
 f28 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f28);
 i6 = i6 + 24 | 0;
 f22 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f22);
 f25 = Math_fround(HEAPF32[i32 + 28 >> 2]);
 f4 = Math_fround(f10 * f25);
 f11 = Math_fround(HEAPF32[i32 + 40 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f26 * f11));
 f5 = Math_fround(HEAPF32[i32 + 36 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f24 * f5));
 f12 = Math_fround(HEAPF32[i32 + 32 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f23 * f12));
 f7 = Math_fround(Math_fround(Math_fround(f23 * f25) + Math_fround(Math_fround(f24 * f11) + Math_fround(f10 * f12))) - Math_fround(f26 * f5));
 f8 = Math_fround(Math_fround(Math_fround(f26 * f12) + Math_fround(Math_fround(f23 * f11) + Math_fround(f10 * f5))) - Math_fround(f24 * f25));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f26 * f25)) - Math_fround(f24 * f12)) - Math_fround(f23 * f5));
 HEAPF32[i35 >> 2] = f4;
 i1 = i35 + 4 | 0;
 HEAPF32[i1 >> 2] = f7;
 i2 = i35 + 8 | 0;
 HEAPF32[i2 >> 2] = f8;
 i3 = i35 + 12 | 0;
 HEAPF32[i3 >> 2] = f5;
 HEAPF32[i35 + 16 >> 2] = f27;
 HEAPF32[i35 + 20 >> 2] = f28;
 HEAPF32[i35 + 24 >> 2] = f22;
 f23 = Math_fround(HEAPF32[i34 >> 2]);
 f12 = Math_fround(f4 * f23);
 f24 = Math_fround(HEAPF32[i42 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f7 * f24));
 f25 = Math_fround(HEAPF32[i41 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f8 * f25));
 f26 = Math_fround(HEAPF32[i40 >> 2]);
 if (Math_fround(f12 + Math_fround(f5 * f26)) < Math_fround(0.0)) {
  f4 = Math_fround(-f4);
  f7 = Math_fround(-f7);
  f8 = Math_fround(-f8);
  f5 = Math_fround(-f5);
  HEAPF32[i35 >> 2] = f4;
  HEAPF32[i1 >> 2] = f7;
  HEAPF32[i2 >> 2] = f8;
  HEAPF32[i3 >> 2] = f5;
 }
 f43 = Math_fround(f27 - Math_fround(HEAPF32[i15 >> 2]));
 f44 = Math_fround(f28 - Math_fround(HEAPF32[i16 >> 2]));
 f45 = Math_fround(f22 - Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i17 >> 2] = f43;
 HEAPF32[i17 + 4 >> 2] = f44;
 HEAPF32[i17 + 8 >> 2] = f45;
 f45 = Math_fround(f27 - Math_fround(HEAPF32[i15 >> 2]));
 f44 = Math_fround(f28 - Math_fround(HEAPF32[i16 >> 2]));
 f43 = Math_fround(f22 - Math_fround(HEAPF32[i14 >> 2]));
 f10 = Math_fround(f27 - Math_fround(HEAPF32[i9 >> 2]));
 f11 = Math_fround(f28 - Math_fround(HEAPF32[i13 >> 2]));
 f12 = Math_fround(f22 - Math_fround(HEAPF32[i6 >> 2]));
 HEAP32[i36 >> 2] = i38;
 i13 = i36 + 4 | 0;
 HEAP32[i13 >> 2] = i38;
 HEAPF32[i36 + 8 >> 2] = f45;
 HEAPF32[i36 + 12 >> 2] = f44;
 HEAPF32[i36 + 16 >> 2] = f43;
 HEAPF32[i36 + 20 >> 2] = f10;
 HEAPF32[i36 + 24 >> 2] = f11;
 HEAPF32[i36 + 28 >> 2] = f12;
 if (HEAP16[i32 + 116 >> 1] & 2) {
  f43 = Math_fround(-f23);
  f44 = Math_fround(-f24);
  f45 = Math_fround(-f25);
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f4) + Math_fround(f5 * f43)) + Math_fround(f8 * f44)) - Math_fround(f7 * f45));
  f11 = Math_fround(Math_fround(Math_fround(f4 * f45) + Math_fround(Math_fround(f5 * f44) + Math_fround(f26 * f7))) - Math_fround(f8 * f43));
  f12 = Math_fround(Math_fround(Math_fround(f7 * f43) + Math_fround(Math_fround(f5 * f45) + Math_fround(f26 * f8))) - Math_fround(f4 * f44));
  f4 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f5) - Math_fround(f4 * f43)) - Math_fround(f7 * f44)) - Math_fround(f8 * f45));
  if (f10 != Math_fround(0.0)) {
   f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)) + Math_fround(f4 * f4)))));
   f5 = Math_fround(f10 * f8);
   f7 = Math_fround(f8 * Math_fround(0.0));
   f8 = Math_fround(f4 * f8);
  } else {
   f5 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(1.0);
  }
  f5 = Math_fround(-f5);
  f45 = Math_fround(-f7);
  f46 = Math_fround(f11 * f45);
  f7 = Math_fround(f12 * f45);
  f44 = Math_fround(f4 * f45);
  f45 = Math_fround(f10 * f45);
  f43 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f8) + f44) + Math_fround(f12 * f5)) - f45);
  f44 = Math_fround(Math_fround(f45 + Math_fround(Math_fround(f12 * f8) + f44)) - Math_fround(f11 * f5));
  f45 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f8) - Math_fround(f10 * f5)) - f46) - f7);
  HEAPF32[i21 >> 2] = Math_fround(Math_fround(f46 + Math_fround(Math_fround(f10 * f8) + Math_fround(f4 * f5))) - f7);
  HEAPF32[i21 + 4 >> 2] = f43;
  HEAPF32[i21 + 8 >> 2] = f44;
  HEAPF32[i21 + 12 >> 2] = f45;
  i41 = HEAP32[i32 + 100 >> 2] | 0;
  i42 = HEAP32[i32 + 108 >> 2] | 0;
  HEAP32[i19 >> 2] = HEAP32[i32 + 104 >> 2];
  HEAP32[i19 + 4 >> 2] = i41;
  HEAP32[i19 + 8 >> 2] = i42;
  if (__ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf(i19, i21, i18, i20) | 0) {
   f5 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(2.0));
   f44 = Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) * Math_fround(2.0));
   f43 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
   f7 = Math_fround(Math_fround(Math_fround(f5 * f23) + Math_fround(f44 * f24)) + Math_fround(f12 * f25));
   f45 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f5 * f43) + Math_fround(f26 * Math_fround(Math_fround(f12 * f24) - Math_fround(f44 * f25)))));
   f46 = Math_fround(Math_fround(f24 * f7) + Math_fround(Math_fround(f44 * f43) + Math_fround(f26 * Math_fround(Math_fround(f5 * f25) - Math_fround(f12 * f23)))));
   f7 = Math_fround(Math_fround(Math_fround(f12 * f43) + Math_fround(f26 * Math_fround(Math_fround(f44 * f23) - Math_fround(f5 * f24)))) + Math_fround(f25 * f7));
   f5 = Math_fround(HEAPF32[i20 >> 2]);
   i2 = i32 + 72 | 0;
   HEAP32[i13 >> 2] = i38 + 80;
   i3 = i38 + 78 | 0;
   HEAP16[i3 >> 1] = 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAPF32[i38 + 16 >> 2] = f45;
   HEAPF32[i38 + 20 >> 2] = f46;
   HEAPF32[i38 + 24 >> 2] = f7;
   HEAP32[i38 + 32 >> 2] = 0;
   HEAP32[i38 + 36 >> 2] = 0;
   HEAP32[i38 + 40 >> 2] = 0;
   HEAPF32[i38 + 48 >> 2] = f45;
   HEAPF32[i38 + 52 >> 2] = f46;
   HEAPF32[i38 + 56 >> 2] = f7;
   HEAPF32[i38 + 12 >> 2] = f5;
   i9 = i38 + 76 | 0;
   i6 = HEAPU16[i9 >> 1] | 0;
   f7 = Math_fround(HEAPF32[i32 + 84 >> 2]);
   i1 = i32 + 80 | 0;
   do if (f7 > Math_fround(0.0)) {
    i1 = HEAP32[i1 >> 2] | 0;
    i39 = 11;
   } else {
    f4 = Math_fround(HEAPF32[i1 >> 2]);
    if (f4 > Math_fround(0.0)) {
     i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
     i39 = 11;
     break;
    }
    HEAP16[i3 >> 1] = 1025;
    i42 = HEAP32[i2 >> 2] | 0;
    HEAP32[i38 + 64 >> 2] = i42;
    HEAP32[i38 + 68 >> 2] = HEAP32[i32 + 76 >> 2];
    i1 = f5 > Math_fround(0.0);
    i1 = i6 | (i1 ? 24 : 16);
    if ((HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
   } while (0);
   if ((i39 | 0) == 11) {
    HEAP32[i38 + 64 >> 2] = i1;
    HEAPF32[i38 + 68 >> 2] = f7;
    i1 = i6 | 17;
   }
   HEAP16[i9 >> 1] = i1;
   HEAPF32[i38 + 44 >> 2] = Math_fround(0.0);
  }
 }
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i29 >> 2]));
 f44 = Math_fround(f28 - Math_fround(HEAPF32[i30 >> 2]));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f44 = Math_fround(f44 * Math_fround(2.0));
 f43 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i31 >> 2])) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f22 = Math_fround(Math_fround(Math_fround(f27 * f23) + Math_fround(f44 * f24)) + Math_fround(f43 * f25));
 f45 = Math_fround(Math_fround(f24 * f22) + Math_fround(Math_fround(f44 * f28) - Math_fround(f26 * Math_fround(Math_fround(f27 * f25) - Math_fround(f43 * f23)))));
 f46 = Math_fround(Math_fround(Math_fround(f43 * f28) - Math_fround(f26 * Math_fround(Math_fround(f44 * f23) - Math_fround(f27 * f24)))) + Math_fround(f25 * f22));
 HEAPF32[i33 >> 2] = Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f27 * f28) - Math_fround(f26 * Math_fround(Math_fround(f43 * f24) - Math_fround(f44 * f25)))));
 HEAPF32[i33 + 4 >> 2] = f45;
 HEAPF32[i33 + 8 >> 2] = f46;
 __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i36, i34, i35, i33, 7, 0);
 STACKTOP = i37;
 return ((HEAP32[i13 >> 2] | 0) - (HEAP32[i36 >> 2] | 0) | 0) / 80 | 0 | 0;
}

function __ZNK5physx20PxsSolverCoreGeneral26solveVParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RKNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESJ_RKNSD_IjNSF_IjEEEEPNS_2Cm13SpatialVectorERij(i4, f5, i26, i34, i28, i6, i1, i32, i27, i31, i43, i2, i45, i46, i30, i33, i51, i47, i49, i42, i3, i44, i29, i50, i41) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i26 = i26 | 0;
 i34 = i34 | 0;
 i28 = i28 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 i31 = i31 | 0;
 i43 = i43 | 0;
 i2 = i2 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 i30 = i30 | 0;
 i33 = i33 | 0;
 i51 = i51 | 0;
 i47 = i47 | 0;
 i49 = i49 | 0;
 i42 = i42 | 0;
 i3 = i3 | 0;
 i44 = i44 | 0;
 i29 = i29 | 0;
 i50 = i50 | 0;
 i41 = i41 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i48 = 0, i52 = 0, i53 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i48;
 HEAP32[i38 + 16 >> 2] = i6;
 i36 = HEAP32[i42 + 4 >> 2] | 0;
 i39 = i38 + 4 | 0;
 HEAP32[i39 >> 2] = i48 + 24;
 HEAP32[i38 + 12 >> 2] = 32;
 i40 = i38 + 8 | 0;
 HEAP32[i40 >> 2] = 0;
 i35 = i38 + 1 | 0;
 HEAP8[i35 >> 0] = 0;
 i22 = i26 + -1 | 0;
 i37 = i44 + 4 | 0;
 i23 = 0;
 i2 = i41;
 i24 = 0;
 i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i45, i41) | 0) - i41 | 0;
 i25 = i22;
 i4 = 0;
 i8 = 0;
 i1 = 0;
 while (1) {
  i19 = (i24 | 0) == 0 ? gb + 103620 | 0 : gb + 103580 | 0;
  if (i23 >>> 0 < (i22 + i24 | 0) >>> 0) {
   i21 = i8 + i25 | 0;
   i6 = HEAP32[i37 >> 2] | 0;
   i20 = i23;
   while (1) {
    HEAP8[i38 >> 0] = (i26 - i20 | 0) >>> 0 < 4 & 1;
    if (!i6) i6 = 0; else {
     i17 = Math_imul(i8, i36) | 0;
     i18 = 0;
     do {
      if ((HEAP32[i46 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i1 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i1 | 0)) {
       i6 = 3e4;
       do {
        i6 = i6 + -1 | 0;
        if (!i6) {
         __ZN5physx6shdfnd10ThreadImpl5yieldEv();
         i6 = 1e4;
        }
       } while ((HEAP32[i46 >> 2] | 0) < (i1 | 0));
      }
      i4 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i18 << 2) >> 2] | 0) + i4 | 0;
      if ((i4 | 0) > (i3 | 0)) {
       i6 = 0;
       do {
        i16 = i4 - i3 | 0;
        i16 = (i16 | 0) < (i2 | 0) ? i16 : i2;
        i7 = i3 - i17 | 0;
        i14 = HEAP32[i42 >> 2] | 0;
        i15 = i16 + i7 | 0;
        if ((i16 | 0) > 0) do {
         i13 = HEAP16[i14 + (i7 << 3) + 4 >> 1] | 0;
         i12 = HEAP32[i14 + (i7 << 3) >> 2] | 0;
         i11 = HEAP32[i43 + (i12 << 5) + 16 >> 2] | 0;
         i10 = i11;
         i53 = _bitshift64Lshr(i10 | 0, 0, 6) | 0;
         i52 = getTempRet0() | 0;
         i10 = _i64Add(i10 | 0, 0, 383, 0) | 0;
         i10 = _bitshift64Lshr(i10 | 0, getTempRet0() | 0, 6) | 0;
         i9 = getTempRet0() | 0;
         i52 = _i64Subtract(1, 0, i53 | 0, i52 | 0) | 0;
         i9 = _i64Add(i52 | 0, getTempRet0() | 0, i10 | 0, i9 | 0) | 0;
         i10 = getTempRet0() | 0;
         while (1) {
          i9 = _i64Add(i9 | 0, i10 | 0, -1, -1) | 0;
          i10 = getTempRet0() | 0;
          if ((i9 | 0) == 0 & (i10 | 0) == 0) break; else i11 = i11 + 64 | 0;
         }
         i11 = i13 & 65535;
         i10 = i43 + (i12 << 5) | 0;
         if (i13 << 16 >> 16) {
          i9 = 0;
          do i9 = i9 + 1 | 0; while ((i9 | 0) != (i11 | 0));
         }
         mftCall_viii(HEAP32[i19 + ((HEAPU16[i14 + (i7 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i10 | 0, i11 | 0, i38 | 0);
         i7 = i7 + 1 | 0;
        } while ((i7 | 0) < (i15 | 0));
        i6 = i16 + i6 | 0;
        if ((i2 | 0) == (i16 | 0)) {
         i2 = i41;
         i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i45, i41) | 0) - i41 | 0;
        } else {
         i2 = i2 - i16 | 0;
         i3 = i16 + i3 | 0;
        }
       } while ((i4 | 0) > (i3 | 0));
       if (i6) __ZN5physx6shdfnd9atomicAddEPVii(i46, i6) | 0;
      }
      i1 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i18 << 2) >> 2] | 0) + i1 | 0;
      i18 = i18 + 1 | 0;
      i6 = HEAP32[i37 >> 2] | 0;
     } while (i18 >>> 0 < i6 >>> 0);
    }
    i20 = i20 + 1 | 0;
    if ((i20 | 0) == (i25 | 0)) break; else i8 = i8 + 1 | 0;
   }
   i7 = i25;
   i6 = i21 - i23 | 0;
  } else {
   i7 = i23;
   i6 = i8;
  }
  i24 = i24 + 1 | 0;
  if ((i24 | 0) == 2) {
   i18 = i6;
   i16 = i1;
   break;
  } else {
   i23 = i7;
   i25 = i25 + 1 | 0;
   i8 = i6;
  }
 }
 i6 = (__ZN5physx6shdfnd9atomicAddEPVii(i30, 32) | 0) + -32 | 0;
 if ((HEAP32[i46 >> 2] | 0) < (i16 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i16 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i16 | 0)) {
  i1 = 3e4;
  do {
   i1 = i1 + -1 | 0;
   if (!i1) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i1 = 1e4;
   }
  } while ((HEAP32[i46 >> 2] | 0) < (i16 | 0));
 }
 if ((i6 | 0) < (i31 | 0)) {
  i15 = ~i31;
  i14 = 32;
  i1 = 0;
  while (1) {
   i13 = i31 - i6 | 0;
   i13 = (i13 | 0) > 32 ? 32 : i13;
   i7 = i14 - i13 | 0;
   if ((i13 | 0) > 0) {
    i12 = i6 + i15 | 0;
    i12 = (i12 | 0) > -33 ? i12 : -33;
    i8 = ~i12;
    i10 = 0;
    i11 = i6;
    while (1) {
     i9 = HEAP32[gb + 1457372 >> 2] | 0;
     if (i9 | 0) mftCall_vi(i9 | 0, i27 + (i11 * 40 | 0) | 0);
     i10 = i10 + 1 | 0;
     if ((i10 | 0) == (i8 | 0)) break; else i11 = i11 + 1 | 0;
    }
    i6 = i6 + -1 - i12 | 0;
   }
   if ((i14 | 0) == (i13 | 0)) {
    i7 = 32;
    i6 = (__ZN5physx6shdfnd9atomicAddEPVii(i30, 32) | 0) + -32 | 0;
   }
   i1 = i13 + i1 | 0;
   if ((i6 | 0) < (i31 | 0)) i14 = i7; else break;
  }
 } else {
  i7 = 32;
  i1 = 0;
 }
 i6 = i6 - i31 | 0;
 if ((i6 | 0) < (i32 | 0)) {
  i10 = ~i32;
  while (1) {
   i9 = i32 - i6 | 0;
   i9 = (i7 | 0) < (i9 | 0) ? i7 : i9;
   if ((i9 | 0) > 0) {
    i8 = i6 + i10 | 0;
    i7 = ~i7;
    i7 = ~((i8 | 0) > (i7 | 0) ? i8 : i7);
    i8 = 0;
    while (1) {
     HEAP32[i29 + (i6 << 5) >> 2] = HEAP32[i28 + (i6 << 5) >> 2];
     HEAP32[i29 + (i6 << 5) + 4 >> 2] = HEAP32[i28 + (i6 << 5) + 4 >> 2];
     HEAP32[i29 + (i6 << 5) + 8 >> 2] = HEAP32[i28 + (i6 << 5) + 8 >> 2];
     HEAP32[i29 + (i6 << 5) + 16 >> 2] = HEAP32[i28 + (i6 << 5) + 16 >> 2];
     HEAP32[i29 + (i6 << 5) + 20 >> 2] = HEAP32[i28 + (i6 << 5) + 20 >> 2];
     HEAP32[i29 + (i6 << 5) + 24 >> 2] = HEAP32[i28 + (i6 << 5) + 24 >> 2];
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i7 | 0)) break; else i6 = i6 + 1 | 0;
    }
   }
   i1 = i9 + i1 | 0;
   i6 = (__ZN5physx6shdfnd9atomicAddEPVii(i30, 32) | 0) + -32 - i31 | 0;
   if ((i6 | 0) >= (i32 | 0)) break; else i7 = 32;
  }
 }
 if (i1 | 0) __ZN5physx6shdfnd9atomicAddEPVii(i33, i1) | 0;
 i6 = i31 + i32 | 0;
 if ((HEAP32[i33 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i33 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i33 >> 2] | 0) < (i6 | 0)) {
  i1 = 3e4;
  do {
   i1 = i1 + -1 | 0;
   if (!i1) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i1 = 1e4;
   }
  } while ((HEAP32[i33 >> 2] | 0) < (i6 | 0));
 }
 if (i34 >>> 0 > 1) {
  i20 = i18 + i34 | 0;
  i1 = HEAP32[i37 >> 2] | 0;
  i7 = i1;
  i19 = 1;
  i6 = i16;
  while (1) {
   if (!i7) i7 = 0; else {
    i16 = Math_imul(i18, i36) | 0;
    i17 = 0;
    do {
     if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) {
      i1 = 3e4;
      do {
       i1 = i1 + -1 | 0;
       if (!i1) {
        __ZN5physx6shdfnd10ThreadImpl5yieldEv();
        i1 = 1e4;
       }
      } while ((HEAP32[i46 >> 2] | 0) < (i6 | 0));
     }
     i4 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i17 << 2) >> 2] | 0) + i4 | 0;
     if ((i4 | 0) > (i3 | 0)) {
      i1 = 0;
      do {
       i15 = i4 - i3 | 0;
       i15 = (i15 | 0) < (i2 | 0) ? i15 : i2;
       i7 = i3 - i16 | 0;
       i13 = HEAP32[i42 >> 2] | 0;
       i14 = i15 + i7 | 0;
       if ((i15 | 0) > 0) do {
        i12 = HEAP16[i13 + (i7 << 3) + 4 >> 1] | 0;
        i11 = HEAP32[i13 + (i7 << 3) >> 2] | 0;
        i10 = HEAP32[i43 + (i11 << 5) + 16 >> 2] | 0;
        i9 = i10;
        i52 = _bitshift64Lshr(i9 | 0, 0, 6) | 0;
        i53 = getTempRet0() | 0;
        i9 = _i64Add(i9 | 0, 0, 383, 0) | 0;
        i9 = _bitshift64Lshr(i9 | 0, getTempRet0() | 0, 6) | 0;
        i8 = getTempRet0() | 0;
        i53 = _i64Subtract(1, 0, i52 | 0, i53 | 0) | 0;
        i8 = _i64Add(i53 | 0, getTempRet0() | 0, i9 | 0, i8 | 0) | 0;
        i9 = getTempRet0() | 0;
        while (1) {
         i8 = _i64Add(i8 | 0, i9 | 0, -1, -1) | 0;
         i9 = getTempRet0() | 0;
         if ((i8 | 0) == 0 & (i9 | 0) == 0) break; else i10 = i10 + 64 | 0;
        }
        i10 = i12 & 65535;
        i9 = i43 + (i11 << 5) | 0;
        if (i12 << 16 >> 16) {
         i8 = 0;
         do i8 = i8 + 1 | 0; while ((i8 | 0) != (i10 | 0));
        }
        mftCall_viii(HEAP32[gb + 103620 + ((HEAPU16[i13 + (i7 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i9 | 0, i10 | 0, i38 | 0);
        i7 = i7 + 1 | 0;
       } while ((i7 | 0) < (i14 | 0));
       i1 = i15 + i1 | 0;
       if ((i2 | 0) == (i15 | 0)) {
        i2 = i41;
        i3 = (__ZN5physx6shdfnd9atomicAddEPVii(i45, i41) | 0) - i41 | 0;
       } else {
        i2 = i2 - i15 | 0;
        i3 = i15 + i3 | 0;
       }
      } while ((i4 | 0) > (i3 | 0));
      if (i1) __ZN5physx6shdfnd9atomicAddEPVii(i46, i1) | 0;
     }
     i6 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i17 << 2) >> 2] | 0) + i6 | 0;
     i17 = i17 + 1 | 0;
     i7 = HEAP32[i37 >> 2] | 0;
    } while (i17 >>> 0 < i7 >>> 0);
    i1 = i7;
   }
   i19 = i19 + 1 | 0;
   if ((i19 | 0) == (i34 | 0)) break; else i18 = i18 + 1 | 0;
  }
  i18 = i20 + -1 | 0;
 } else {
  i1 = HEAP32[i37 >> 2] | 0;
  i6 = i16;
 }
 HEAP8[i35 >> 0] = 1;
 if (i1 | 0) {
  i16 = Math_imul(i18, i36) | 0;
  i17 = 0;
  i15 = i4;
  while (1) {
   if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) if ((HEAP32[i46 >> 2] | 0) < (i6 | 0)) {
    i1 = 3e4;
    do {
     i1 = i1 + -1 | 0;
     if (!i1) {
      __ZN5physx6shdfnd10ThreadImpl5yieldEv();
      i1 = 1e4;
     }
    } while ((HEAP32[i46 >> 2] | 0) < (i6 | 0));
   }
   i15 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i17 << 2) >> 2] | 0) + i15 | 0;
   if ((i15 | 0) > (i3 | 0)) {
    i1 = i3;
    i3 = 0;
    do {
     i14 = i15 - i1 | 0;
     i14 = (i14 | 0) < (i2 | 0) ? i14 : i2;
     i4 = i1 - i16 | 0;
     i12 = HEAP32[i42 >> 2] | 0;
     i13 = i14 + i4 | 0;
     if ((i14 | 0) > 0) do {
      i11 = HEAP16[i12 + (i4 << 3) + 4 >> 1] | 0;
      i10 = HEAP32[i12 + (i4 << 3) >> 2] | 0;
      i9 = HEAP32[i43 + (i10 << 5) + 16 >> 2] | 0;
      i8 = i9;
      i52 = _bitshift64Lshr(i8 | 0, 0, 6) | 0;
      i53 = getTempRet0() | 0;
      i8 = _i64Add(i8 | 0, 0, 383, 0) | 0;
      i8 = _bitshift64Lshr(i8 | 0, getTempRet0() | 0, 6) | 0;
      i7 = getTempRet0() | 0;
      i53 = _i64Subtract(1, 0, i52 | 0, i53 | 0) | 0;
      i7 = _i64Add(i53 | 0, getTempRet0() | 0, i8 | 0, i7 | 0) | 0;
      i8 = getTempRet0() | 0;
      while (1) {
       i7 = _i64Add(i7 | 0, i8 | 0, -1, -1) | 0;
       i8 = getTempRet0() | 0;
       if ((i7 | 0) == 0 & (i8 | 0) == 0) break; else i9 = i9 + 64 | 0;
      }
      i9 = i11 & 65535;
      i8 = i43 + (i10 << 5) | 0;
      if (i11 << 16 >> 16) {
       i7 = 0;
       do i7 = i7 + 1 | 0; while ((i7 | 0) != (i9 | 0));
      }
      mftCall_viiiiii(HEAP32[gb + 103660 + ((HEAPU16[i12 + (i4 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i8 | 0, i9 | 0, i38 | 0, i51 | 0, i47 | 0, i49 | 0);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i13 | 0));
     i3 = i14 + i3 | 0;
     if ((i2 | 0) == (i14 | 0)) {
      i2 = i41;
      i1 = (__ZN5physx6shdfnd9atomicAddEPVii(i45, i41) | 0) - i41 | 0;
     } else {
      i2 = i2 - i14 | 0;
      i1 = i14 + i1 | 0;
     }
    } while ((i15 | 0) > (i1 | 0));
    if (i3) __ZN5physx6shdfnd9atomicAddEPVii(i46, i3) | 0;
   } else i1 = i3;
   i6 = (HEAP32[(HEAP32[i44 >> 2] | 0) + (i17 << 2) >> 2] | 0) + i6 | 0;
   i17 = i17 + 1 | 0;
   if (i17 >>> 0 >= (HEAP32[i37 >> 2] | 0) >>> 0) break; else i3 = i1;
  }
 }
 i1 = HEAP32[i40 >> 2] | 0;
 if (!i1) {
  i53 = i18 + 1 | 0;
  HEAP32[i50 >> 2] = i53;
  STACKTOP = i48;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i49, i1) | 0;
 i3 = HEAP32[i40 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i39 >> 2] | 0;
  i2 = 0;
  do {
   i53 = i51 + (i4 + i2 << 4) | 0;
   i52 = i1 + (i2 << 4) | 0;
   HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
   HEAP32[i53 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
   HEAP32[i53 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
   HEAP32[i53 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i40 >> 2] = 0;
 i53 = i18 + 1 | 0;
 HEAP32[i50 >> 2] = i53;
 STACKTOP = i48;
 return;
}

function __Z18computeSweptBoundsRKN5physx18PxcAABBDataDynamicERNS_9PxBounds3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 76 | 0;
 i9 = i3 + 64 | 0;
 i53 = i3 + 52 | 0;
 i23 = i3 + 24 | 0;
 i21 = i3;
 i20 = HEAP32[i1 >> 2] | 0;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i37 = HEAP32[i1 + 8 >> 2] | 0;
 i22 = HEAP32[i1 + 12 >> 2] | 0;
 i51 = i37 + 48 | 0;
 f4 = Math_fround(HEAPF32[i51 >> 2]);
 i50 = i37 + 52 | 0;
 f11 = Math_fround(HEAPF32[i50 >> 2]);
 i49 = i37 + 56 | 0;
 f4 = Math_fround(f4 * Math_fround(-2.0));
 f11 = Math_fround(f11 * Math_fround(-2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * Math_fround(-2.0));
 i48 = i37 + 44 | 0;
 f15 = Math_fround(HEAPF32[i48 >> 2]);
 f6 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 i47 = i37 + 32 | 0;
 f18 = Math_fround(HEAPF32[i47 >> 2]);
 f28 = Math_fround(f4 * f18);
 i46 = i37 + 36 | 0;
 f40 = Math_fround(HEAPF32[i46 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f11 * f40));
 i45 = i37 + 40 | 0;
 f14 = Math_fround(HEAPF32[i45 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f16 * f14));
 f19 = Math_fround(-f18);
 f13 = Math_fround(-f40);
 f39 = Math_fround(-f14);
 f10 = Math_fround(Math_fround(Math_fround(f18 * f28) + Math_fround(Math_fround(f4 * f6) - Math_fround(f15 * Math_fround(Math_fround(f16 * f40) - Math_fround(f11 * f14))))) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(f40 * f28) + Math_fround(Math_fround(f11 * f6) - Math_fround(f15 * Math_fround(Math_fround(f4 * f14) - Math_fround(f16 * f18))))) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f6) - Math_fround(f15 * Math_fround(Math_fround(f11 * f18) - Math_fround(f4 * f40)))) + Math_fround(f14 * f28)) * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i37 + 12 >> 2]);
 f40 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f4 = Math_fround(HEAPF32[i37 >> 2]);
 f18 = Math_fround(f4 * f10);
 f11 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f11 * f17));
 f6 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f18 = Math_fround(Math_fround(f6 * f28) + f18);
 f16 = Math_fround(Math_fround(f4 * f18) + Math_fround(Math_fround(f40 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f28) - Math_fround(f6 * f17)))));
 f26 = Math_fround(Math_fround(f11 * f18) + Math_fround(Math_fround(f40 * f17) + Math_fround(f14 * Math_fround(Math_fround(f6 * f10) - Math_fround(f4 * f28)))));
 f18 = Math_fround(Math_fround(Math_fround(f40 * f28) + Math_fround(f14 * Math_fround(Math_fround(f4 * f17) - Math_fround(f11 * f10)))) + Math_fround(f6 * f18));
 f16 = Math_fround(Math_fround(HEAPF32[i37 + 16 >> 2]) + f16);
 f26 = Math_fround(Math_fround(HEAPF32[i37 + 20 >> 2]) + f26);
 f18 = Math_fround(Math_fround(HEAPF32[i37 + 24 >> 2]) + f18);
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f19) + Math_fround(f15 * f4)) + Math_fround(f11 * f39)) - Math_fround(f6 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f6 * f19) + Math_fround(Math_fround(f14 * f13) + Math_fround(f15 * f11))) - Math_fround(f4 * f39));
 f28 = Math_fround(Math_fround(Math_fround(f4 * f13) + Math_fround(Math_fround(f14 * f39) + Math_fround(f15 * f6))) - Math_fround(f11 * f19));
 f39 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f4 * f19)) - Math_fround(f11 * f13)) - Math_fround(f6 * f39));
 i37 = i20 + 16 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) * Math_fround(2.0));
 i36 = i20 + 20 | 0;
 f13 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(2.0));
 i35 = i20 + 24 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f10 * f6) + Math_fround(f17 * f13)) + Math_fround(f28 * f11));
 f16 = Math_fround(f16 + Math_fround(Math_fround(f10 * f4) + Math_fround(Math_fround(f19 * f6) + Math_fround(f39 * Math_fround(Math_fround(f17 * f11) - Math_fround(f28 * f13))))));
 f26 = Math_fround(f26 + Math_fround(Math_fround(f17 * f4) + Math_fround(Math_fround(f19 * f13) + Math_fround(f39 * Math_fround(Math_fround(f28 * f6) - Math_fround(f10 * f11))))));
 f4 = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f39 * Math_fround(Math_fround(f10 * f13) - Math_fround(f17 * f6)))) + Math_fround(f28 * f4)));
 f6 = Math_fround(HEAPF32[i20 >> 2]);
 f13 = Math_fround(f39 * f6);
 i34 = i20 + 12 | 0;
 f11 = Math_fround(HEAPF32[i34 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f10 * f11));
 i33 = i20 + 8 | 0;
 f19 = Math_fround(HEAPF32[i33 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f19));
 i32 = i20 + 4 | 0;
 f18 = Math_fround(HEAPF32[i32 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f28 * f6) + Math_fround(Math_fround(f17 * f11) + Math_fround(f39 * f18))) - Math_fround(f10 * f19));
 f15 = Math_fround(Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f28 * f11) + Math_fround(f39 * f19))) - Math_fround(f17 * f6));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f11) - Math_fround(f10 * f6)) - Math_fround(f17 * f18)) - Math_fround(f28 * f19));
 HEAPF32[i8 >> 2] = Math_fround(f13 - Math_fround(f28 * f18));
 HEAPF32[i8 + 4 >> 2] = f14;
 HEAPF32[i8 + 8 >> 2] = f15;
 HEAPF32[i8 + 12 >> 2] = f19;
 HEAPF32[i8 + 16 >> 2] = f16;
 HEAPF32[i8 + 20 >> 2] = f26;
 HEAPF32[i8 + 24 >> 2] = f4;
 i24 = i20 + 36 | 0;
 f4 = Math_fround(__ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E(i24, i9, i53, i8, i22));
 f26 = Math_fround(HEAPF32[i9 >> 2]);
 f16 = Math_fround(HEAPF32[i53 >> 2]);
 f19 = Math_fround(f26 - f16);
 i8 = i9 + 4 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 f14 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f18 = Math_fround(f15 - f14);
 i1 = i9 + 8 | 0;
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 f17 = Math_fround(f28 - f13);
 f16 = Math_fround(f26 + f16);
 f14 = Math_fround(f15 + f14);
 f13 = Math_fround(f28 + f13);
 f28 = Math_fround(HEAPF32[i52 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i52 + 36 >> 2]);
 f26 = Math_fround(HEAPF32[i52 + 40 >> 2]);
 f6 = Math_fround(HEAPF32[i52 + 44 >> 2]);
 f10 = Math_fround(HEAPF32[i52 + 48 >> 2]);
 f11 = Math_fround(HEAPF32[i52 + 52 >> 2]);
 f39 = Math_fround(HEAPF32[i52 + 56 >> 2]);
 f40 = Math_fround(HEAPF32[i51 >> 2]);
 f42 = Math_fround(HEAPF32[i50 >> 2]);
 f40 = Math_fround(f40 * Math_fround(-2.0));
 f42 = Math_fround(f42 * Math_fround(-2.0));
 f44 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * Math_fround(-2.0));
 f5 = Math_fround(HEAPF32[i48 >> 2]);
 f43 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
 f41 = Math_fround(HEAPF32[i47 >> 2]);
 f25 = Math_fround(f40 * f41);
 f12 = Math_fround(HEAPF32[i46 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f42 * f12));
 f38 = Math_fround(HEAPF32[i45 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f44 * f38));
 f7 = Math_fround(-f41);
 f30 = Math_fround(-f12);
 f31 = Math_fround(-f38);
 f29 = Math_fround(Math_fround(Math_fround(f41 * f25) + Math_fround(Math_fround(f40 * f43) - Math_fround(f5 * Math_fround(Math_fround(f44 * f12) - Math_fround(f42 * f38))))) * Math_fround(2.0));
 f27 = Math_fround(Math_fround(Math_fround(f12 * f25) + Math_fround(Math_fround(f42 * f43) - Math_fround(f5 * Math_fround(Math_fround(f40 * f38) - Math_fround(f44 * f41))))) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f44 * f43) - Math_fround(f5 * Math_fround(Math_fround(f42 * f41) - Math_fround(f40 * f12)))) + Math_fround(f38 * f25)) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
 f12 = Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f28 * f29) + Math_fround(f15 * f27)));
 f10 = Math_fround(f10 + Math_fround(Math_fround(f28 * f12) + Math_fround(Math_fround(f38 * f29) + Math_fround(f6 * Math_fround(Math_fround(f15 * f25) - Math_fround(f26 * f27))))));
 f11 = Math_fround(f11 + Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f38 * f27) + Math_fround(f6 * Math_fround(Math_fround(f26 * f29) - Math_fround(f28 * f25))))));
 f12 = Math_fround(f39 + Math_fround(Math_fround(Math_fround(f38 * f25) + Math_fround(f6 * Math_fround(Math_fround(f28 * f27) - Math_fround(f15 * f29)))) + Math_fround(f26 * f12)));
 f29 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f6 * f7)) + Math_fround(f15 * f31)) - Math_fround(f26 * f30));
 f27 = Math_fround(Math_fround(Math_fround(f26 * f7) + Math_fround(Math_fround(f15 * f5) + Math_fround(f6 * f30))) - Math_fround(f28 * f31));
 f25 = Math_fround(Math_fround(Math_fround(f28 * f30) + Math_fround(Math_fround(f26 * f5) + Math_fround(f6 * f31))) - Math_fround(f15 * f7));
 f31 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f5) - Math_fround(f28 * f7)) - Math_fround(f15 * f30)) - Math_fround(f26 * f31));
 f26 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
 f28 = Math_fround(Math_fround(Math_fround(f26 * f29) + Math_fround(f30 * f27)) + Math_fround(f15 * f25));
 f10 = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f26 * f7) + Math_fround(f31 * Math_fround(Math_fround(f27 * f15) - Math_fround(f30 * f25))))) + f10);
 f11 = Math_fround(Math_fround(Math_fround(f27 * f28) + Math_fround(Math_fround(f30 * f7) + Math_fround(f31 * Math_fround(Math_fround(f26 * f25) - Math_fround(f29 * f15))))) + f11);
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f7) + Math_fround(f31 * Math_fround(Math_fround(f30 * f29) - Math_fround(f26 * f27)))) + Math_fround(f25 * f28)) + f12);
 f28 = Math_fround(HEAPF32[i20 >> 2]);
 f26 = Math_fround(f31 * f28);
 f30 = Math_fround(HEAPF32[i34 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f29 * f30));
 f7 = Math_fround(HEAPF32[i33 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f27 * f7));
 f15 = Math_fround(HEAPF32[i32 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f25 * f28) + Math_fround(Math_fround(f27 * f30) + Math_fround(f31 * f15))) - Math_fround(f29 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f29 * f15) + Math_fround(Math_fround(f25 * f30) + Math_fround(f31 * f7))) - Math_fround(f27 * f28));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f30) - Math_fround(f29 * f28)) - Math_fround(f27 * f15)) - Math_fround(f25 * f7));
 HEAPF32[i23 >> 2] = Math_fround(f26 - Math_fround(f25 * f15));
 HEAPF32[i23 + 4 >> 2] = f5;
 HEAPF32[i23 + 8 >> 2] = f6;
 HEAPF32[i23 + 12 >> 2] = f7;
 HEAPF32[i23 + 16 >> 2] = f10;
 HEAPF32[i23 + 20 >> 2] = f11;
 HEAPF32[i23 + 24 >> 2] = f12;
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i24, i21, i23, Math_fround(0.0), i22);
 f12 = Math_fround(HEAPF32[i21 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i20 + 28 >> 2]);
 f18 = Math_fround((f18 < f11 ? f18 : f11) - f15);
 f17 = Math_fround((f17 < f10 ? f17 : f10) - f15);
 HEAPF32[i2 >> 2] = Math_fround((f19 < f12 ? f19 : f12) - f15);
 HEAPF32[i2 + 4 >> 2] = f18;
 HEAPF32[i2 + 8 >> 2] = f17;
 f14 = Math_fround((f14 > f6 ? f14 : f6) + f15);
 f13 = Math_fround(f15 + (f13 > f5 ? f13 : f5));
 HEAPF32[i2 + 12 >> 2] = Math_fround((f16 > f7 ? f16 : f7) + f15);
 HEAPF32[i2 + 16 >> 2] = f14;
 HEAPF32[i2 + 20 >> 2] = f13;
 f7 = Math_fround(Math_fround(f12 + f7) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f11 + f6) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f10 + f5) * Math_fround(.5));
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i8 >> 2]));
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
 i2 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)) - Math_fround(f4 * f4)) >= Math_fround(0.0);
 f4 = i2 ? Math_fround(1.0) : Math_fround(0.0);
 STACKTOP = i3;
 return Math_fround(f4);
}

function __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i2 = i8 + 132 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj139ENS_22PxRepXPropertyAccessorILj139ES4_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESC_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 160 | 0, i7 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj142ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 176 | 0, i7 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj144ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 204 | 0, i7 + 6 | 0);
 i2 = i8 + 220 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 236 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 252 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 280 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 296 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 312 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 340 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj154ES3_RKNS_29PxClothMotionConstraintConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 356 | 0, i7 + 16 | 0);
 i1 = i8 + 372 | 0;
 i2 = i7 + 17 | 0;
 i3 = i5;
 i4 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev(i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i6, i2, i1, gb + 90072 | 0, i5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj156ES3_RKNS_19PxClothTetherConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 388 | 0, i7 + 18 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj157ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 404 | 0, i7 + 19 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj158ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 420 | 0, i7 + 20 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj159ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 436 | 0, i7 + 21 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj160ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 452 | 0, i7 + 22 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj161ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 468 | 0, i7 + 23 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj162ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 484 | 0, i7 + 24 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj163ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 500 | 0, i7 + 25 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj164ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 516 | 0, i7 + 26 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj165ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 532 | 0, i7 + 27 | 0);
 STACKTOP = i9;
 return i7 + 30 | 0;
}

function __ZN5physx2Sn12readPropertyERNS0_21RepXVisitorReaderBaseINS_14PxArticulationEEEPS2_RKNS_32PxArticulationLinkCollectionPropE(i84, i82, i1) {
 i84 = i84 | 0;
 i82 = i82 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i83 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0;
 i88 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i67 = i88 + 64 | 0;
 i70 = i88 + 672 | 0;
 i71 = i88 + 620 | 0;
 i77 = i88 + 724 | 0;
 i80 = i88 + 48 | 0;
 i66 = i88 + 32 | 0;
 i72 = i88 + 568 | 0;
 i73 = i88 + 16 | 0;
 i78 = i88 + 192 | 0;
 i86 = i88 + 188 | 0;
 i87 = i88 + 116 | 0;
 i81 = i88 + 8 | 0;
 i74 = i88 + 160 | 0;
 i79 = i88;
 i75 = i84 + 28 | 0;
 i68 = HEAP32[i75 >> 2] | 0;
 HEAP32[i86 >> 2] = mftCall_ii(HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] | 0, i68 | 0) | 0;
 i68 = i84 + 32 | 0;
 i69 = HEAP32[i68 >> 2] | 0;
 HEAP32[i87 >> 2] = i86;
 i86 = i87 + 4 | 0;
 HEAP32[i86 >> 2] = 0;
 HEAP32[i86 + 4 >> 2] = 0;
 HEAP32[i86 + 8 >> 2] = 0;
 HEAP32[i86 + 12 >> 2] = 0;
 HEAP32[i86 + 16 >> 2] = 0;
 HEAP32[i86 + 20 >> 2] = 0;
 HEAPF32[i87 + 28 >> 2] = Math_fround(.75);
 HEAP32[i87 + 32 >> 2] = -1;
 HEAP32[i87 + 36 >> 2] = 0;
 HEAP32[i87 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj(i87, 64);
 i83 = i84 + 4 | 0;
 i1 = HEAP32[i83 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i84 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i67 >> 2] = i2;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i67) | 0;
 i1 = HEAP32[i84 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i84 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i76 = HEAP32[i84 + 20 >> 2] | 0;
    i76 = (mftCall_iii(HEAP32[(HEAP32[i76 >> 2] | 0) + 16 >> 2] | 0, i76 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i76;
    i1 = HEAP32[i84 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i76;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i76 = HEAP32[i84 >> 2] | 0;
   HEAP8[(HEAP32[i76 + 4 >> 2] | 0) + ((HEAP32[i76 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i76 = i84 + 36 | 0;
 L12 : do if (HEAP8[i76 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i84, gb + 830924 | 0);
  if (!(HEAP8[i76 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i84 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i76 >> 0] = i1;
  }
  i65 = HEAP32[i84 >> 2] | 0;
  HEAP8[(HEAP32[i65 + 4 >> 2] | 0) + ((HEAP32[i65 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i65 = HEAP32[i84 >> 2] | 0;
  HEAP8[(HEAP32[i65 + 4 >> 2] | 0) + ((HEAP32[i65 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i65 = i84 + 20 | 0;
   i11 = i87 + 24 | 0;
   i12 = i87 + 16 | 0;
   i13 = i87 + 8 | 0;
   i14 = i87 + 12 | 0;
   i15 = i74 + 4 | 0;
   i16 = i74 + 8 | 0;
   i17 = i74 + 12 | 0;
   i18 = i74 + 16 | 0;
   i19 = i74 + 20 | 0;
   i20 = i74 + 24 | 0;
   i21 = i84 + 8 | 0;
   i22 = i77;
   i23 = i67 + 4 | 0;
   i24 = i67 + 8 | 0;
   i25 = i67 + 20 | 0;
   i26 = i67 + 24 | 0;
   i27 = i67 + 28 | 0;
   i28 = i67 + 32 | 0;
   i29 = i67 + 36 | 0;
   i30 = i67 + 40 | 0;
   i31 = i67 + 44 | 0;
   i32 = i67 + 48 | 0;
   i33 = i70 + 4 | 0;
   i34 = i70 + 8 | 0;
   i35 = i70 + 20 | 0;
   i36 = i70 + 24 | 0;
   i37 = i70 + 28 | 0;
   i38 = i70 + 32 | 0;
   i39 = i70 + 36 | 0;
   i40 = i70 + 40 | 0;
   i41 = i70 + 44 | 0;
   i42 = i70 + 48 | 0;
   i43 = i71 + 4 | 0;
   i44 = i71 + 8 | 0;
   i45 = i71 + 20 | 0;
   i46 = i71 + 24 | 0;
   i47 = i71 + 28 | 0;
   i48 = i71 + 32 | 0;
   i49 = i71 + 36 | 0;
   i50 = i71 + 40 | 0;
   i51 = i71 + 44 | 0;
   i52 = i71 + 48 | 0;
   i53 = i72 + 4 | 0;
   i54 = i72 + 8 | 0;
   i55 = i72 + 20 | 0;
   i56 = i72 + 24 | 0;
   i57 = i72 + 28 | 0;
   i58 = i72 + 32 | 0;
   i59 = i72 + 36 | 0;
   i60 = i72 + 40 | 0;
   i61 = i72 + 44 | 0;
   i62 = i72 + 48 | 0;
   i63 = i78 + 336 | 0;
   i64 = i84 + 40 | 0;
   do {
    i10 = i81;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    i10 = HEAP32[i65 >> 2] | 0;
    if (mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, gb + 673980 | 0, i81 | 0) | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     i3 = i81;
     i2 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     i10 = _i64Add(i2 | 0, i3 | 0, -1, ~i2 | 0) | 0;
     i9 = getTempRet0() | 0;
     i5 = _bitshift64Lshr(i10 | 0, i9 | 0, 22) | 0;
     i10 = i5 ^ i10;
     i9 = (getTempRet0() | 0) ^ i9;
     i5 = _bitshift64Shl(i10 | 0, i9 | 0, 13) | 0;
     i5 = _i64Add(i10 | 0, i9 | 0, ~i5 | 0, ~(getTempRet0() | 0) | 0) | 0;
     i9 = getTempRet0() | 0;
     i10 = _bitshift64Lshr(i5 | 0, i9 | 0, 8) | 0;
     i9 = ___muldi3(i10 ^ i5 | 0, (getTempRet0() | 0) ^ i9 | 0, 9, 0) | 0;
     i5 = getTempRet0() | 0;
     i10 = _bitshift64Lshr(i9 | 0, i5 | 0, 15) | 0;
     i9 = i10 ^ i9;
     i5 = (getTempRet0() | 0) ^ i5;
     i10 = _bitshift64Shl(i9 | 0, i5 | 0, 27) | 0;
     i10 = _i64Add(i9 | 0, i5 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
     i5 = getTempRet0() | 0;
     i9 = _bitshift64Lshr(i10 | 0, i5 | 0, 31) | 0;
     (getTempRet0() | 0) ^ i5;
     i5 = HEAP32[i13 >> 2] | 0;
     i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (((i9 ^ i10) & i1 + -1) << 2) >> 2] | 0;
     i10 = i5 + (i1 << 4) | 0;
     if (!((HEAP32[i10 >> 2] | 0) == (i2 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i3 | 0) : 0)) {
      i4 = HEAP32[i14 >> 2] | 0;
      do {
       i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
       i10 = i5 + (i1 << 4) | 0;
      } while (!((HEAP32[i10 >> 2] | 0) == (i2 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i3 | 0) : 0));
     }
     i1 = HEAP32[i5 + (i1 << 4) + 8 >> 2] | 0;
    } else i1 = 0;
    i9 = HEAP32[(HEAP32[i82 >> 2] | 0) + 104 >> 2] | 0;
    HEAPF32[i74 >> 2] = Math_fround(0.0);
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    HEAPF32[i16 >> 2] = Math_fround(0.0);
    HEAPF32[i17 >> 2] = Math_fround(1.0);
    HEAPF32[i18 >> 2] = Math_fround(0.0);
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    HEAPF32[i20 >> 2] = Math_fround(0.0);
    i9 = mftCall_iiii(i9 | 0, i82 | 0, i1 | 0, i74 | 0) | 0;
    i2 = i79;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    i2 = HEAP32[i65 >> 2] | 0;
    mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, gb + 766945 | 0, i79 | 0) | 0;
    i2 = i79;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i67;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i3 + 4 >> 2] = i2;
    i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE6createERS4_Rb(i87, i67, i70) | 0;
    i10 = i9;
    if (!(HEAP8[i70 >> 0] | 0)) {
     i8 = i3;
     HEAP32[i8 >> 2] = i1;
     HEAP32[i8 + 4 >> 2] = i2;
     HEAP32[i3 + 8 >> 2] = i10;
    }
    __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev(i78);
    i1 = HEAP32[i84 >> 2] | 0;
    i3 = HEAP32[i83 >> 2] | 0;
    i5 = HEAP32[i65 >> 2] | 0;
    i4 = HEAP32[i75 >> 2] | 0;
    i2 = HEAP32[i68 >> 2] | 0;
    i6 = i73;
    i7 = i21;
    i8 = i6 + 12 | 0;
    do {
     HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
     i6 = i6 + 1 | 0;
     i7 = i7 + 1 | 0;
    } while ((i6 | 0) < (i8 | 0));
    HEAP8[i77 >> 0] = 0;
    i6 = i80;
    i7 = i21;
    i8 = i6 + 12 | 0;
    do {
     HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
     i6 = i6 + 1 | 0;
     i7 = i7 + 1 | 0;
    } while ((i6 | 0) < (i8 | 0));
    HEAP32[i66 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i66 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
    HEAP32[i66 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
    HEAP32[i67 >> 2] = i1;
    HEAP32[i23 >> 2] = i3;
    HEAP32[i24 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i24 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
    HEAP32[i24 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
    HEAP32[i25 >> 2] = i5;
    HEAP32[i26 >> 2] = i10;
    HEAP32[i27 >> 2] = i4;
    HEAP32[i28 >> 2] = i2;
    HEAP8[i29 >> 0] = 1;
    HEAP32[i30 >> 2] = i22;
    HEAP32[i31 >> 2] = 0;
    HEAP32[i32 >> 2] = 0;
    i8 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i78, i67, 0) | 0;
    HEAP32[i70 >> 2] = i1;
    HEAP32[i33 >> 2] = i3;
    HEAP32[i34 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i34 + 4 >> 2] = HEAP32[i73 + 4 >> 2];
    HEAP32[i34 + 8 >> 2] = HEAP32[i73 + 8 >> 2];
    HEAP32[i35 >> 2] = i5;
    HEAP32[i36 >> 2] = i10;
    HEAP32[i37 >> 2] = i4;
    HEAP32[i38 >> 2] = i2;
    HEAP8[i39 >> 0] = 1;
    HEAP32[i40 >> 2] = i22;
    HEAP32[i41 >> 2] = 0;
    HEAP32[i42 >> 2] = 0;
    i8 = __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i78, i70, i8) | 0;
    HEAP32[i71 >> 2] = i1;
    HEAP32[i43 >> 2] = i3;
    HEAP32[i44 >> 2] = HEAP32[i66 >> 2];
    HEAP32[i44 + 4 >> 2] = HEAP32[i66 + 4 >> 2];
    HEAP32[i44 + 8 >> 2] = HEAP32[i66 + 8 >> 2];
    HEAP32[i45 >> 2] = i5;
    HEAP32[i46 >> 2] = i10;
    HEAP32[i47 >> 2] = i4;
    HEAP32[i48 >> 2] = i2;
    HEAP8[i49 >> 0] = 1;
    HEAP32[i50 >> 2] = i22;
    HEAP32[i51 >> 2] = 0;
    HEAP32[i52 >> 2] = 0;
    __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i78, i71, i8) | 0;
    HEAP32[i72 >> 2] = i1;
    HEAP32[i53 >> 2] = i3;
    HEAP32[i54 >> 2] = HEAP32[i80 >> 2];
    HEAP32[i54 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
    HEAP32[i54 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
    HEAP32[i55 >> 2] = i5;
    HEAP32[i56 >> 2] = i10;
    HEAP32[i57 >> 2] = i4;
    HEAP32[i58 >> 2] = i2;
    HEAP8[i59 >> 0] = 1;
    HEAP32[i60 >> 2] = i22;
    HEAP32[i61 >> 2] = 0;
    HEAP32[i62 >> 2] = 0;
    __ZN5physx2Sn17RepXVisitorReaderINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE(i72, i63);
    if (HEAP8[i77 >> 0] | 0) HEAP8[HEAP32[i64 >> 2] >> 0] = 1;
    i10 = i79;
    mftCall_viiii(HEAP32[HEAP32[i69 >> 2] >> 2] | 0, i69 | 0, i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0);
    if (!(HEAP8[i76 >> 0] | 0)) break L12;
    i10 = HEAP32[i65 >> 2] | 0;
   } while (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0);
  }
 } while (0);
 i2 = HEAP32[i83 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
  i4 = HEAP32[i84 >> 2] | 0;
  i3 = HEAP32[i4 + 8 >> 2] | 0;
  if (i3 >>> 0 > i6 >>> 0) {
   i5 = i84 + 20 | 0;
   i1 = i3;
   i2 = i4;
   do {
    if (!i1) {
     i85 = 29;
     break;
    }
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i5 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i84 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i2 = HEAP32[i84 >> 2] | 0;
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP8[i76 >> 0] = 1;
    if (!i1) break;
    if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i76 >> 0] = 0;
   } while (i1 >>> 0 > i6 >>> 0);
   if ((i85 | 0) == 29) HEAP8[i76 >> 0] = 1;
   i1 = HEAP32[i83 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
 }
 i1 = HEAP32[i86 >> 2] | 0;
 if (!i1) {
  STACKTOP = i88;
  return;
 }
 i87 = HEAP32[HEAP32[i87 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i87 >> 2] | 0) + 12 >> 2] | 0, i87 | 0, i1 | 0);
 STACKTOP = i88;
 return;
}

function __ZN5physx12_GLOBAL__N_122getImpulseResponseSimdERKNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES6_(i27, i22, i10, i21, i20) {
 i27 = i27 | 0;
 i22 = i22 | 0;
 i10 = i10 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 1280 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28;
 i26 = i28 + 1024 | 0;
 i13 = i22 + 26 | 0;
 i7 = HEAP16[i13 >> 1] | 0;
 i23 = i22 + ((i7 & 65535) + 144) | 0;
 i24 = i22 + (HEAPU16[i22 + 10 >> 1] | 0) | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 i19 = i21 + 4 | 0;
 f4 = Math_fround(HEAPF32[i19 >> 2]);
 i14 = i21 + 8 | 0;
 i15 = i21 + 12 | 0;
 f5 = Math_fround(-f5);
 f4 = Math_fround(-f4);
 f8 = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i21 >> 2] = f5;
 HEAPF32[i19 >> 2] = f4;
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 f2 = Math_fround(HEAPF32[i20 >> 2]);
 i16 = i20 + 4 | 0;
 f1 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i20 + 8 | 0;
 i18 = i20 + 12 | 0;
 f2 = Math_fround(-f2);
 f1 = Math_fround(-f1);
 f3 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i20 >> 2] = f2;
 HEAPF32[i16 >> 2] = f1;
 HEAPF32[i17 >> 2] = f3;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 if (!i10) {
  i10 = i7;
  f11 = f5;
  f9 = f4;
  i7 = 0;
 } else {
  i12 = 0;
  while (1) {
   f31 = Math_fround(HEAPF32[i24 + (i10 << 5) + 16 >> 2]);
   f29 = Math_fround(HEAPF32[i24 + (i10 << 5) + 20 >> 2]);
   f30 = Math_fround(HEAPF32[i24 + (i10 << 5) + 24 >> 2]);
   f11 = Math_fround(f2 + Math_fround(Math_fround(f4 * f30) - Math_fround(f8 * f29)));
   f30 = Math_fround(f1 + Math_fround(Math_fround(f8 * f31) - Math_fround(f5 * f30)));
   f31 = Math_fround(f3 + Math_fround(Math_fround(f5 * f29) - Math_fround(f4 * f31)));
   HEAPF32[i25 + (i12 << 4) >> 2] = f11;
   HEAPF32[i25 + (i12 << 4) + 4 >> 2] = f30;
   HEAPF32[i25 + (i12 << 4) + 8 >> 2] = f31;
   HEAPF32[i25 + (i12 << 4) + 12 >> 2] = Math_fround(0.0);
   f29 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) >> 2]);
   f9 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 4 >> 2]);
   f34 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 8 >> 2]);
   f36 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 32 >> 2]);
   f35 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 36 >> 2]);
   f6 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 40 >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 64 >> 2]);
   f32 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 68 >> 2]);
   f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f31 * f33)) - Math_fround(f30 * f36)) - Math_fround(f29 * f11));
   f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f31 * f32)) - Math_fround(f30 * f35)) - Math_fround(f9 * f11));
   f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f31 * Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 72 >> 2]))) - Math_fround(f30 * f6)) - Math_fround(f34 * f11));
   f34 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 16 >> 2]);
   f6 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 20 >> 2]);
   f9 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 24 >> 2]);
   f35 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 48 >> 2]);
   f32 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 52 >> 2]);
   f29 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 56 >> 2]);
   f36 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 80 >> 2]);
   f33 = Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 84 >> 2]);
   f2 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f31 * f36)) - Math_fround(f30 * f35)) - Math_fround(f11 * f34));
   f6 = Math_fround(Math_fround(Math_fround(f1 - Math_fround(f31 * f33)) - Math_fround(f30 * f32)) - Math_fround(f11 * f6));
   f9 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f31 * Math_fround(HEAPF32[i23 + (i10 * 160 | 0) + 88 >> 2]))) - Math_fround(f30 * f29)) - Math_fround(f11 * f9));
   f11 = Math_fround(HEAPF32[i24 + (i10 << 5) >> 2]);
   f3 = Math_fround(HEAPF32[i24 + (i10 << 5) + 4 >> 2]);
   f1 = Math_fround(HEAPF32[i24 + (i10 << 5) + 8 >> 2]);
   f2 = Math_fround(f2 + Math_fround(Math_fround(f3 * f8) - Math_fround(f1 * f4)));
   f1 = Math_fround(f6 + Math_fround(Math_fround(f1 * f5) - Math_fround(f11 * f8)));
   f3 = Math_fround(f9 + Math_fround(Math_fround(f11 * f4) - Math_fround(f3 * f5)));
   i7 = i12 + 1 | 0;
   HEAP32[i26 + (i12 << 2) >> 2] = i10;
   i10 = HEAP8[i22 + 64 + i10 >> 0] | 0;
   if (!(i10 << 24 >> 24)) break; else {
    i10 = i10 & 255;
    i12 = i7;
   }
  }
  HEAPF32[i20 >> 2] = f2;
  HEAPF32[i16 >> 2] = f1;
  HEAPF32[i17 >> 2] = f3;
  HEAPF32[i21 >> 2] = f5;
  HEAPF32[i19 >> 2] = f4;
  HEAPF32[i14 >> 2] = f8;
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  i10 = HEAP16[i13 >> 1] | 0;
  f11 = f5;
  f9 = f4;
 }
 i21 = i10 & 65535;
 f40 = Math_fround(f11 * Math_fround(HEAPF32[i22 + i21 >> 2]));
 f40 = Math_fround(f40 + Math_fround(f9 * Math_fround(HEAPF32[i22 + (i21 + 16) >> 2])));
 f40 = Math_fround(f40 + Math_fround(f8 * Math_fround(HEAPF32[i22 + (i21 + 32) >> 2])));
 f39 = Math_fround(f11 * Math_fround(HEAPF32[i22 + (i21 + 4) >> 2]));
 f39 = Math_fround(f39 + Math_fround(f9 * Math_fround(HEAPF32[i22 + (i21 + 20) >> 2])));
 f39 = Math_fround(f39 + Math_fround(f8 * Math_fround(HEAPF32[i22 + (i21 + 36) >> 2])));
 f38 = Math_fround(f11 * Math_fround(HEAPF32[i22 + (i21 + 8) >> 2]));
 f38 = Math_fround(f38 + Math_fround(f9 * Math_fround(HEAPF32[i22 + (i21 + 24) >> 2])));
 f38 = Math_fround(f38 + Math_fround(f8 * Math_fround(HEAPF32[i22 + (i21 + 40) >> 2])));
 f37 = Math_fround(HEAPF32[i22 + (i21 + 48) >> 2]);
 f4 = Math_fround(f2 * f37);
 f30 = Math_fround(HEAPF32[i22 + (i21 + 64) >> 2]);
 f4 = Math_fround(f4 + Math_fround(f1 * f30));
 f34 = Math_fround(HEAPF32[i22 + (i21 + 80) >> 2]);
 f4 = Math_fround(f4 + Math_fround(f3 * f34));
 f29 = Math_fround(HEAPF32[i22 + (i21 + 52) >> 2]);
 f5 = Math_fround(f2 * f29);
 f36 = Math_fround(HEAPF32[i22 + (i21 + 68) >> 2]);
 f5 = Math_fround(f5 + Math_fround(f1 * f36));
 f32 = Math_fround(HEAPF32[i22 + (i21 + 84) >> 2]);
 f5 = Math_fround(f5 + Math_fround(f3 * f32));
 f31 = Math_fround(HEAPF32[i22 + (i21 + 56) >> 2]);
 f6 = Math_fround(f2 * f31);
 f33 = Math_fround(HEAPF32[i22 + (i21 + 72) >> 2]);
 f6 = Math_fround(f6 + Math_fround(f1 * f33));
 f35 = Math_fround(HEAPF32[i22 + (i21 + 88) >> 2]);
 f4 = Math_fround(-Math_fround(f40 + f4));
 f5 = Math_fround(-Math_fround(f39 + f5));
 f6 = Math_fround(-Math_fround(f38 + Math_fround(f6 + Math_fround(f3 * f35))));
 f31 = Math_fround(Math_fround(Math_fround(f11 * f37) + Math_fround(f9 * f29)) + Math_fround(f8 * f31));
 f33 = Math_fround(Math_fround(Math_fround(f11 * f30) + Math_fround(f9 * f36)) + Math_fround(f8 * f33));
 f35 = Math_fround(Math_fround(Math_fround(f11 * f34) + Math_fround(f9 * f32)) + Math_fround(f8 * f35));
 f32 = Math_fround(f2 * Math_fround(HEAPF32[i22 + (i21 + 96) >> 2]));
 f32 = Math_fround(f32 + Math_fround(f1 * Math_fround(HEAPF32[i22 + (i21 + 112) >> 2])));
 f32 = Math_fround(f32 + Math_fround(f3 * Math_fround(HEAPF32[i22 + (i21 + 128) >> 2])));
 f34 = Math_fround(f2 * Math_fround(HEAPF32[i22 + (i21 + 100) >> 2]));
 f34 = Math_fround(f34 + Math_fround(f1 * Math_fround(HEAPF32[i22 + (i21 + 116) >> 2])));
 f34 = Math_fround(f34 + Math_fround(f3 * Math_fround(HEAPF32[i22 + (i21 + 132) >> 2])));
 f36 = Math_fround(f2 * Math_fround(HEAPF32[i22 + (i21 + 104) >> 2]));
 f36 = Math_fround(f36 + Math_fround(f1 * Math_fround(HEAPF32[i22 + (i21 + 120) >> 2])));
 f1 = Math_fround(-Math_fround(f31 + f32));
 f2 = Math_fround(-Math_fround(f33 + f34));
 f3 = Math_fround(-Math_fround(f35 + Math_fround(f36 + Math_fround(f3 * Math_fround(HEAPF32[i22 + (i21 + 136) >> 2])))));
 if (!i7) {
  f37 = f6;
  f36 = f5;
  f35 = f4;
  f40 = f3;
  f39 = f2;
  f38 = f1;
  HEAPF32[i27 >> 2] = f35;
  i26 = i27 + 4 | 0;
  HEAPF32[i26 >> 2] = f36;
  i26 = i27 + 8 | 0;
  HEAPF32[i26 >> 2] = f37;
  i26 = i27 + 12 | 0;
  HEAPF32[i26 >> 2] = Math_fround(0.0);
  i26 = i27 + 16 | 0;
  HEAPF32[i26 >> 2] = f38;
  i26 = i27 + 20 | 0;
  HEAPF32[i26 >> 2] = f39;
  i26 = i27 + 24 | 0;
  HEAPF32[i26 >> 2] = f40;
  i27 = i27 + 28 | 0;
  HEAPF32[i27 >> 2] = Math_fround(0.0);
  STACKTOP = i28;
  return;
 }
 do {
  i7 = i7 + -1 | 0;
  i22 = HEAP32[i26 + (i7 << 2) >> 2] | 0;
  f33 = Math_fround(HEAPF32[i24 + (i22 << 5) >> 2]);
  f36 = Math_fround(HEAPF32[i24 + (i22 << 5) + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i24 + (i22 << 5) + 8 >> 2]);
  f4 = Math_fround(f4 - Math_fround(Math_fround(f3 * f36) - Math_fround(f2 * f35)));
  f35 = Math_fround(f5 - Math_fround(Math_fround(f1 * f35) - Math_fround(f3 * f33)));
  f36 = Math_fround(f6 - Math_fround(Math_fround(f2 * f33) - Math_fround(f1 * f36)));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) >> 2]);
  f38 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 4 >> 2]);
  f38 = Math_fround(Math_fround(f36 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 8 >> 2])) + Math_fround(Math_fround(f33 * f4) + Math_fround(f38 * f35)));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 32 >> 2]);
  f40 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 36 >> 2]);
  f40 = Math_fround(Math_fround(Math_fround(f4 * f33) + Math_fround(f35 * f40)) + Math_fround(f36 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 40 >> 2])));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 64 >> 2]);
  f37 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 68 >> 2]);
  f37 = Math_fround(Math_fround(Math_fround(f4 * f33) + Math_fround(f35 * f37)) + Math_fround(f36 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 72 >> 2])));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 16 >> 2]);
  f34 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 20 >> 2]);
  f34 = Math_fround(Math_fround(Math_fround(f1 * f33) + Math_fround(f2 * f34)) + Math_fround(f3 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 24 >> 2])));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 52 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(f1 * f33) + Math_fround(f2 * f5)) + Math_fround(f3 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 56 >> 2])));
  f33 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 80 >> 2]);
  f6 = Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 84 >> 2]);
  f34 = Math_fround(f38 + f34);
  f5 = Math_fround(f40 + f5);
  f6 = Math_fround(f37 + Math_fround(Math_fround(Math_fround(f1 * f33) + Math_fround(f2 * f6)) + Math_fround(f3 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 88 >> 2]))));
  f33 = Math_fround(HEAPF32[i25 + (i7 << 4) >> 2]);
  f37 = Math_fround(HEAPF32[i25 + (i7 << 4) + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i25 + (i7 << 4) + 8 >> 2]);
  f38 = Math_fround(f33 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 96 >> 2]));
  f38 = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 112 >> 2])));
  f38 = Math_fround(f38 + Math_fround(f40 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 128 >> 2])));
  f39 = Math_fround(f33 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 100 >> 2]));
  f39 = Math_fround(f39 + Math_fround(f37 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 116 >> 2])));
  f39 = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 132 >> 2])));
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 104 >> 2]));
  f37 = Math_fround(f33 + Math_fround(f37 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 120 >> 2])));
  f38 = Math_fround(f34 + f38);
  f39 = Math_fround(f5 + f39);
  f40 = Math_fround(f6 + Math_fround(f37 + Math_fround(f40 * Math_fround(HEAPF32[i23 + (i22 * 160 | 0) + 136 >> 2]))));
  f37 = Math_fround(HEAPF32[i24 + (i22 << 5) + 16 >> 2]);
  f6 = Math_fround(HEAPF32[i24 + (i22 << 5) + 20 >> 2]);
  f5 = Math_fround(HEAPF32[i24 + (i22 << 5) + 24 >> 2]);
  f4 = Math_fround(f4 - Math_fround(Math_fround(f6 * f40) - Math_fround(f39 * f5)));
  f5 = Math_fround(f35 - Math_fround(Math_fround(f38 * f5) - Math_fround(f37 * f40)));
  f6 = Math_fround(f36 - Math_fround(Math_fround(f39 * f37) - Math_fround(f38 * f6)));
  f1 = Math_fround(f1 - f38);
  f2 = Math_fround(f2 - f39);
  f3 = Math_fround(f3 - f40);
 } while ((i7 | 0) != 0);
 HEAPF32[i27 >> 2] = f4;
 i26 = i27 + 4 | 0;
 HEAPF32[i26 >> 2] = f5;
 i26 = i27 + 8 | 0;
 HEAPF32[i26 >> 2] = f6;
 i26 = i27 + 12 | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 i26 = i27 + 16 | 0;
 HEAPF32[i26 >> 2] = f1;
 i26 = i27 + 20 | 0;
 HEAPF32[i26 >> 2] = f2;
 i26 = i27 + 24 | 0;
 HEAPF32[i26 >> 2] = f3;
 i27 = i27 + 28 | 0;
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 STACKTOP = i28;
 return;
}

function __ZN21ArchiveStorageCreator8FinalizeEPj(i1, i24) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 1232 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 120 | 0;
 i25 = i28 + 96 | 0;
 i23 = i28 + 88 | 0;
 i22 = i28 + 80 | 0;
 i17 = i28 + 72 | 0;
 i12 = i28 + 64 | 0;
 i9 = i28 + 56 | 0;
 i8 = i28 + 48 | 0;
 i7 = i28 + 40 | 0;
 i6 = i28 + 32 | 0;
 i2 = i28 + 24 | 0;
 i27 = i28 + 8 | 0;
 i14 = i28;
 i20 = i28 + 1216 | 0;
 i21 = i28 + 144 | 0;
 i18 = i28 + 124 | 0;
 if (!(__ZN21ArchiveStorageCreator17StoreCurrentBlockEb(i1, 1) | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 490843 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 72, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i19 = i1 + 1096 | 0;
 i2 = HEAP8[i1 + 1116 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i3 = HEAP32[i1 + 1120 >> 2] | 0; else i3 = i2 & 255;
 i2 = HEAP8[i1 + 1132 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i2 = HEAP32[i1 + 1136 >> 2] | 0; else i2 = i2 & 255;
 i4 = i3 + 5 + i2 | 0;
 i5 = i1 + 1168 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!(i2 & 256)) {
  i3 = HEAP8[i19 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) i3 = HEAP32[i1 + 1100 >> 2] | 0; else i3 = i3 & 255;
  i15 = i4 + 22 + i3 | 0;
 } else i15 = i4 + 31 | 0;
 do if (!(i2 & 128)) {
  i4 = i1 + 12 | 0;
  if (!(__ZN12FileAccessor5CloseEv(i4) | 0)) {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   __Z6FormatPKcz(i27, gb + 490898 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 82, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   i27 = 0;
   STACKTOP = i28;
   return i27 | 0;
  }
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  if (!(__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i4, i3, 1, 0) | 0)) {
   if ((HEAP8[i2 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   __Z6FormatPKcz(i27, gb + 490943 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 89, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   i27 = 0;
   STACKTOP = i28;
   return i27 | 0;
  }
  if (__ZN12FileAccessor9SetLengthEy(i4, i15, 0) | 0) if (__ZN12FileAccessor4SeekEx10FileOrigin(i4, 0, 0, 3) | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   break;
  }
  if ((HEAP8[i2 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 490648 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 96, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 } while (0);
 if (!(i2 & 128)) {
  i13 = i1 + 1248 | 0;
  HEAP32[i13 >> 2] = __Z7CRCDonej(HEAP32[i13 >> 2] | 0) | 0;
 }
 if (!(__ZN21ArchiveStorageCreator14StoreDirectoryEv(i1) | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 490993 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 108, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 if (!(HEAP32[i5 >> 2] & 128)) {
  i13 = i1 + 11 | 0;
  if ((HEAP8[i13 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i20 + 12 >> 2] = i2;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i20);
   i2 = HEAP32[i20 + 12 >> 2] | 0;
   i16 = 53;
  } else if (i5 >>> 0 < 11) {
   i3 = i20 + 11 | 0;
   HEAP8[i3 >> 0] = i5;
   if (!i5) {
    i2 = i20;
    i11 = i3;
   } else {
    i2 = i20;
    i16 = 55;
   }
  } else i16 = 53;
  if ((i16 | 0) == 53) {
   i3 = i5 + 16 & -16;
   HEAP32[i27 >> 2] = 1;
   HEAP32[i27 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i20 >> 2] = i2;
   HEAP32[i20 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i20 + 4 >> 2] = i5;
   i3 = i20 + 11 | 0;
   i16 = 55;
  }
  if ((i16 | 0) == 55) {
   _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   i11 = i3;
  }
  HEAP8[i2 + i5 >> 0] = 0;
  i2 = HEAP8[i11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) {
   i4 = (HEAP32[i20 + 8 >> 2] & 2147483647) + -1 | 0;
   i2 = HEAP32[i20 + 4 >> 2] | 0;
  } else {
   i4 = 10;
   i2 = i2 & 255;
  }
  if ((i4 - i2 | 0) >>> 0 < 4) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i4, 4 - i4 + i2 | 0, i2, i2, 0, 4, gb + 491584 | 0);
   i10 = i20;
  } else {
   i3 = i3 ? HEAP32[i20 >> 2] | 0 : i20;
   i10 = i3 + i2 | 0;
   HEAP8[i10 >> 0] = 46;
   HEAP8[i10 + 1 >> 0] = 116;
   HEAP8[i10 + 2 >> 0] = 109;
   HEAP8[i10 + 3 >> 0] = 112;
   i2 = i2 + 4 | 0;
   if ((HEAP8[i11 >> 0] | 0) < 0) HEAP32[i20 + 4 >> 2] = i2; else HEAP8[i11 >> 0] = i2;
   HEAP8[i3 + i2 >> 0] = 0;
   i10 = i20;
  }
  __ZN12FileAccessorC2Ev(i21);
  if (__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i21, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i20, 0, 0) | 0) {
   i9 = gb + 64016 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i14;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i18 >> 2] = 0;
   i7 = i18 + 12 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i18 + 16 | 0;
   HEAP32[i8 >> 2] = 0;
   i9 = i18 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i14);
   i6 = i27;
   i12 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i9;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = i12;
   HEAP32[i7 >> 2] = 32768;
   i2 = HEAP32[i8 >> 2] | 0;
   do if ((i2 & 2147450880) >>> 0 < 32768) if ((i2 | 0) > -1) {
    HEAP32[i8 >> 2] = 32768;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, 32768, 1, i9, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i18 >> 2] = i2;
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32768, 1, i9, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i2 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = 32768;
    HEAP32[i18 >> 2] = i2;
    break;
   } else i2 = HEAP32[i18 >> 2] | 0; while (0);
   i12 = (__ZN12FileAccessor4ReadEyPvPy(i21, HEAP32[i7 >> 2] | 0, 0, i2, i27) | 0) ^ 1;
   i3 = i27;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   L104 : do if ((i2 | 0) == 0 & (i3 | 0) == 0 | i12) {
    i3 = 0;
    i2 = 0;
    i16 = 74;
   } else {
    i6 = i1 + 12 | 0;
    i5 = i2;
    i4 = i3;
    i3 = 0;
    i2 = 0;
    while (1) {
     if (!(__ZN12FileAccessor5WriteEyPKvPy(i6, i5, i4, HEAP32[i18 >> 2] | 0, i14) | 0)) break;
     i5 = i14;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     i12 = i27;
     if (!((i4 | 0) == (HEAP32[i12 >> 2] | 0) ? (i5 | 0) == (HEAP32[i12 + 4 >> 2] | 0) : 0)) break;
     i3 = _i64Add(i4 | 0, i5 | 0, i3 | 0, i2 | 0) | 0;
     i2 = getTempRet0() | 0;
     i12 = (__ZN12FileAccessor4ReadEyPvPy(i21, HEAP32[i7 >> 2] | 0, 0, HEAP32[i18 >> 2] | 0, i27) | 0) ^ 1;
     i4 = i27;
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i5 | 0) == 0 & (i4 | 0) == 0 | i12) {
      i16 = 74;
      break L104;
     }
    }
   } while (0);
   i16 = i1 + 1232 | 0;
   if ((i3 | 0) == (HEAP32[i16 >> 2] | 0) ? (i2 | 0) == (HEAP32[i16 + 4 >> 2] | 0) : 0) {
    __ZN12FileAccessor5CloseEv(i21) | 0;
    i2 = __Z13GetFileSystemv() | 0;
    __ZNK10FileSystem6DeleteEPKcb(i2, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i20, 1) | 0;
    i2 = 0;
   } else {
    if ((HEAP8[i13 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    HEAP32[i17 >> 2] = i2;
    __Z6FormatPKcz(i27, gb + 491097 | 0, i17);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 145, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
    i2 = 1;
   }
   if ((HEAP32[i8 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i9);
    HEAP32[i18 >> 2] = 0;
   }
  } else {
   HEAP32[i12 >> 2] = (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i20;
   __Z6FormatPKcz(i27, gb + 491041 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 123, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   i2 = 1;
  }
  __ZN12FileAccessorD2Ev(i21);
  if ((HEAP8[i11 >> 0] | 0) < 0) {
   i21 = HEAP32[i10 >> 2] | 0;
   i20 = HEAP32[i20 + 12 >> 2] | 0;
   HEAP32[i27 >> 2] = 1;
   HEAP32[i27 + 4 >> 2] = i20;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i27);
  }
  if (i2 | 0) {
   i27 = 0;
   STACKTOP = i28;
   return i27 | 0;
  }
 }
 i5 = i1 + 12 | 0;
 if (!(__ZN12FileAccessor4SeekEx10FileOrigin(i5, 0, 0, 1) | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i22 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 491150 | 0, i22);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 156, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 if (!(__ZN20ArchiveStorageHeader11WriteHeaderER12FileAccessorRKNS_6HeaderE(i5, i19) | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i23 >> 2] = i1;
  __Z6FormatPKcz(i27, gb + 491184 | 0, i23);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 161, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i4 = i1 + 1232 | 0;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i15 | 0, 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = i1 + 1160 | 0;
 i3 = _i64Add(i4 | 0, i3 | 0, HEAP32[i2 >> 2] | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 i23 = __ZNK12FileAccessor4SizeEv(i5) | 0;
 if (!((i23 | 0) == (i3 | 0) & (getTempRet0() | 0) == (i4 | 0))) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i23 = __ZNK12FileAccessor4SizeEv(i5) | 0;
  i24 = getTempRet0() | 0;
  HEAP32[i25 >> 2] = i1;
  i26 = i25 + 8 | 0;
  HEAP32[i26 >> 2] = i3;
  HEAP32[i26 + 4 >> 2] = i4;
  i26 = i25 + 16 | 0;
  HEAP32[i26 >> 2] = i23;
  HEAP32[i26 + 4 >> 2] = i24;
  __Z6FormatPKcz(i27, gb + 491229 | 0, i25);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 169, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 if (__ZN12FileAccessor5CloseEv(i5) | 0) {
  i25 = _i64Add(HEAP32[i2 >> 2] | 0, 0, i15 | 0, 0) | 0;
  i26 = getTempRet0() | 0;
  i27 = i1 + 1240 | 0;
  HEAP32[i27 >> 2] = i25;
  HEAP32[i27 + 4 >> 2] = i26;
  if (!i24) {
   i27 = 1;
   STACKTOP = i28;
   return i27 | 0;
  }
  HEAP32[i24 >> 2] = HEAP32[i1 + 1248 >> 2];
  i27 = 1;
  STACKTOP = i28;
  return i27 | 0;
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i26 >> 2] = i1;
 __Z6FormatPKcz(i27, gb + 491285 | 0, i26);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 490375 | 0, 175, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 i27 = 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 L1 : while (1) {
  i9 = i2;
  i11 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 68;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 248) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    do if ((i3 | 0) > 7992) {
     i4 = (i4 | 0) / 4 | 0;
     i6 = i1 + (i4 << 3) | 0;
     i4 = i7 + (i4 << 3) | 0;
     i3 = __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i6, i7, i4, i12) | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i4 | 0) | 0) {
      i13 = i4;
      i14 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      i16 = i11;
      i15 = HEAP32[i16 + 4 >> 2] | 0;
      i5 = i4;
      HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i5 + 4 >> 2] = i15;
      i5 = i11;
      HEAP32[i5 >> 2] = i14;
      HEAP32[i5 + 4 >> 2] = i13;
      i5 = i3 + 1 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0) {
       i16 = i7;
       i15 = HEAP32[i16 >> 2] | 0;
       i16 = HEAP32[i16 + 4 >> 2] | 0;
       i5 = i4;
       i13 = HEAP32[i5 + 4 >> 2] | 0;
       i14 = i7;
       HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i14 + 4 >> 2] = i13;
       HEAP32[i4 >> 2] = i15;
       HEAP32[i4 + 4 >> 2] = i16;
       i4 = i3 + 2 | 0;
       if (mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i6 | 0) | 0) {
        i15 = i6;
        i14 = HEAP32[i15 >> 2] | 0;
        i15 = HEAP32[i15 + 4 >> 2] | 0;
        i5 = i7;
        i13 = HEAP32[i5 + 4 >> 2] | 0;
        i16 = i6;
        HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i16 + 4 >> 2] = i13;
        i16 = i7;
        HEAP32[i16 >> 2] = i14;
        HEAP32[i16 + 4 >> 2] = i15;
        if (mftCall_iii(HEAP32[i12 >> 2] | 0, i6 | 0, i1 | 0) | 0) {
         i15 = i1;
         i14 = HEAP32[i15 >> 2] | 0;
         i15 = HEAP32[i15 + 4 >> 2] | 0;
         i5 = i6;
         i13 = HEAP32[i5 + 4 >> 2] | 0;
         i16 = i1;
         HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
         HEAP32[i16 + 4 >> 2] = i13;
         i16 = i6;
         HEAP32[i16 >> 2] = i14;
         HEAP32[i16 + 4 >> 2] = i15;
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i4;
      } else i3 = i5;
     }
    } else {
     i16 = mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i1 | 0) | 0;
     i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i7 | 0) | 0;
     if (!i16) {
      if (!i3) {
       i3 = 0;
       break;
      }
      i15 = i7;
      i14 = HEAP32[i15 >> 2] | 0;
      i15 = HEAP32[i15 + 4 >> 2] | 0;
      i6 = i11;
      i13 = HEAP32[i6 + 4 >> 2] | 0;
      i16 = i7;
      HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i16 + 4 >> 2] = i13;
      i16 = i11;
      HEAP32[i16 >> 2] = i14;
      HEAP32[i16 + 4 >> 2] = i15;
      if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i7 | 0, i1 | 0) | 0)) {
       i3 = 1;
       break;
      }
      i16 = i1;
      i15 = HEAP32[i16 >> 2] | 0;
      i16 = HEAP32[i16 + 4 >> 2] | 0;
      i13 = i7;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i3 = i1;
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i3 + 4 >> 2] = i14;
      i3 = i7;
      HEAP32[i3 >> 2] = i15;
      HEAP32[i3 + 4 >> 2] = i16;
      i3 = 2;
      break;
     }
     i5 = i1;
     i4 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     if (i3) {
      i15 = i11;
      i16 = HEAP32[i15 + 4 >> 2] | 0;
      i3 = i1;
      HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i3 + 4 >> 2] = i16;
      i3 = i11;
      HEAP32[i3 >> 2] = i4;
      HEAP32[i3 + 4 >> 2] = i5;
      i3 = 1;
      break;
     }
     i14 = i7;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i1;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i16 = i7;
     HEAP32[i16 >> 2] = i4;
     HEAP32[i16 + 4 >> 2] = i5;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i7 | 0) | 0) {
      i16 = i7;
      i15 = HEAP32[i16 >> 2] | 0;
      i16 = HEAP32[i16 + 4 >> 2] | 0;
      i13 = i11;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i3 = i7;
      HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i3 + 4 >> 2] = i14;
      i3 = i11;
      HEAP32[i3 >> 2] = i15;
      HEAP32[i3 + 4 >> 2] = i16;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i7 | 0) | 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0) {
      i10 = 51;
      break L5;
     }
    }
    i3 = i1 + 8 | 0;
    if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i11 | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i10 = 68;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i10 = 68;
       break L1;
      }
     }
     i15 = i3;
     i14 = HEAP32[i15 >> 2] | 0;
     i15 = HEAP32[i15 + 4 >> 2] | 0;
     i8 = i11;
     i13 = HEAP32[i8 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i16 + 4 >> 2] = i13;
     i16 = i11;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i16 + 4 >> 2] = i15;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i10 = 68;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i5 = i3 + 8 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -8 | 0; while (mftCall_iii(HEAP32[i12 >> 2] | 0, i1 | 0, i4 | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i16 = i3;
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i13 = i4;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i14;
     i3 = i4;
     HEAP32[i3 >> 2] = i15;
     HEAP32[i3 + 4 >> 2] = i16;
     i3 = i5;
    }
   }
   if ((i10 | 0) == 51) {
    i10 = 0;
    i15 = i1;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i6 = i4;
    i13 = HEAP32[i6 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i16 + 4 >> 2] = i13;
    i16 = i4;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i16 + 4 >> 2] = i15;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L48 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    while (1) {
     i6 = i5 + 8 | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, i5 | 0, i7 | 0) | 0) i5 = i6; else break;
    }
    do i4 = i4 + -8 | 0; while (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i7 | 0) | 0));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i7;
     break L48;
    }
    i15 = i5;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i17 = i4;
    i13 = HEAP32[i17 + 4 >> 2] | 0;
    i16 = i5;
    HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i16 + 4 >> 2] = i13;
    i16 = i4;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i16 + 4 >> 2] = i15;
    i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
    i5 = i6;
    i3 = i3 + 1 | 0;
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i5 | 0) | 0) {
    i16 = i5;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = HEAP32[i16 + 4 >> 2] | 0;
    i13 = i4;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i17 = i5;
    HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i17 + 4 >> 2] = i14;
    i17 = i4;
    HEAP32[i17 >> 2] = i15;
    HEAP32[i17 + 4 >> 2] = i16;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRK6b2PairS3_EPS1_EEbT0_S8_T_(i1, i5, i12) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRK6b2PairS3_EPS1_EEbT0_S8_T_(i4, i2, i12) | 0) {
     i10 = 67;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i17 = i5;
   if ((i17 - i8 | 0) >= (i9 - i17 | 0)) {
    i10 = 66;
    break;
   }
   __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i1, i5, i12);
   i1 = i5 + 8 | 0;
  }
  if ((i10 | 0) == 66) {
   i10 = 0;
   __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i5 + 8 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i10 | 0) == 67) {
   i10 = 0;
   if (i3) {
    i10 = 68;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i1 | 0) | 0)) return;
  i16 = i1;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i11;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i11;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 8 | 0;
  i17 = mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
  i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i2 | 0) | 0;
  if (!i17) {
   if (!i3) return;
   i16 = i2;
   i15 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i13 = i11;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i17 = i2;
   HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i17 + 4 >> 2] = i14;
   i17 = i11;
   HEAP32[i17 >> 2] = i15;
   HEAP32[i17 + 4 >> 2] = i16;
   if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return;
   i16 = i1;
   i15 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i13 = i2;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i17 = i1;
   HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i17 + 4 >> 2] = i14;
   i17 = i2;
   HEAP32[i17 >> 2] = i15;
   HEAP32[i17 + 4 >> 2] = i16;
   return;
  }
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i3) {
   i15 = i11;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i1;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   i17 = i11;
   HEAP32[i17 >> 2] = i4;
   HEAP32[i17 + 4 >> 2] = i5;
   return;
  }
  i15 = i2;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i17 = i2;
  HEAP32[i17 >> 2] = i4;
  HEAP32[i17 + 4 >> 2] = i5;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i2 | 0) | 0)) return;
  i16 = i2;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i11;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i2;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i11;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i11, i12) | 0;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 8 | 0;
  i3 = i1 + 16 | 0;
  i4 = i1 + 24 | 0;
  __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i2, i3, i4, i12) | 0;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i11 | 0, i4 | 0) | 0)) return;
  i16 = i4;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i11;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i4;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i11;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i4 | 0, i3 | 0) | 0)) return;
  i16 = i3;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i4;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i3;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i4;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i3 | 0, i2 | 0) | 0)) return;
  i16 = i2;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i3;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i2;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i3;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return;
  i16 = i1;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i13 = i2;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  i17 = i2;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i17 + 4 >> 2] = i16;
  return;
 } else if ((i10 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i1, i2, i12);
  return;
 } else if ((i10 | 0) == 68) return;
}

function __ZN5physx26calcForce4_twoWay_onlyPtrsERNS_6shdfnd3aos6Mat44VES3_PNS_16PxsFluidParticleES5_S5_S5_RKS2_S7_RKNS1_5Vec4VERKNS_30PxsFluidDynamicsParametersSIMDE(i1, i2, i4, i5, i6, i7, i9, i10, i3, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0;
 f45 = Math_fround(HEAPF32[i4 >> 2]);
 f41 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f50 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f44 = Math_fround(HEAPF32[i5 >> 2]);
 f40 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f43 = Math_fround(HEAPF32[i6 >> 2]);
 f39 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f42 = Math_fround(HEAPF32[i7 >> 2]);
 f38 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f60 = Math_fround(HEAPF32[i9 >> 2]);
 f57 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f54 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f45 = Math_fround(f60 - f45);
 f44 = Math_fround(f57 - f44);
 f43 = Math_fround(f54 - f43);
 f42 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) - f42);
 f54 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f60 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f41 = Math_fround(f54 - f41);
 f40 = Math_fround(f57 - f40);
 f39 = Math_fround(f60 - f39);
 f38 = Math_fround(Math_fround(HEAPF32[i9 + 28 >> 2]) - f38);
 f60 = Math_fround(HEAPF32[i9 + 32 >> 2]);
 f57 = Math_fround(HEAPF32[i9 + 36 >> 2]);
 f54 = Math_fround(HEAPF32[i9 + 40 >> 2]);
 f50 = Math_fround(f60 - f50);
 f26 = Math_fround(f57 - f26);
 f32 = Math_fround(f54 - f32);
 f36 = Math_fround(Math_fround(HEAPF32[i9 + 44 >> 2]) - f36);
 f54 = Math_fround(Math_fround(Math_fround(f45 * f45) + Math_fround(f41 * f41)) + Math_fround(f50 * f50));
 f57 = Math_fround(Math_fround(Math_fround(f44 * f44) + Math_fround(f40 * f40)) + Math_fround(f26 * f26));
 f60 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f39 * f39)) + Math_fround(f32 * f32));
 f34 = Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f38 * f38)) + Math_fround(f36 * f36));
 f61 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f58 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f55 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 f61 = Math_fround(f54 * f61);
 f58 = Math_fround(f57 * f58);
 f55 = Math_fround(f60 * f55);
 f34 = Math_fround(f34 * Math_fround(HEAPF32[i8 + 28 >> 2]));
 f60 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f61))));
 f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f58))));
 f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f55))));
 f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f34))));
 f61 = Math_fround(f61 * f60);
 f58 = Math_fround(f58 * f57);
 f55 = Math_fround(f55 * f54);
 f34 = Math_fround(f34 * f37);
 f52 = Math_fround(HEAPF32[i8 + 32 >> 2]);
 f27 = Math_fround(HEAPF32[i8 + 36 >> 2]);
 f47 = Math_fround(HEAPF32[i8 + 40 >> 2]);
 f12 = Math_fround(HEAPF32[i8 + 44 >> 2]);
 f48 = Math_fround(f52 - f61);
 f46 = Math_fround(f27 - f58);
 f29 = Math_fround(f47 - f55);
 f30 = Math_fround(f12 - f34);
 i4 = i4 + 16 | 0;
 f24 = Math_fround(HEAPF32[i4 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i5 = i5 + 16 | 0;
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f21 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i6 = i6 + 16 | 0;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i7 = i7 + 16 | 0;
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f62 = Math_fround(HEAPF32[i9 + 48 >> 2]);
 f31 = Math_fround(HEAPF32[i9 + 52 >> 2]);
 f56 = Math_fround(HEAPF32[i9 + 56 >> 2]);
 f59 = Math_fround(HEAPF32[i9 + 60 >> 2]);
 f53 = Math_fround(HEAPF32[i8 + 112 >> 2]);
 f51 = Math_fround(HEAPF32[i8 + 116 >> 2]);
 f28 = Math_fround(HEAPF32[i8 + 120 >> 2]);
 f49 = Math_fround(HEAPF32[i8 + 124 >> 2]);
 f62 = Math_fround(f62 - f53);
 f31 = Math_fround(f31 - f51);
 f56 = Math_fround(f56 - f28);
 f59 = Math_fround(f59 - f49);
 f53 = Math_fround(f15 - f53);
 f51 = Math_fround(f20 - f51);
 f28 = Math_fround(f18 - f28);
 f49 = Math_fround(f11 - f49);
 i9 = f62 > Math_fround(0.0);
 f62 = i9 ? f62 : Math_fround(0.0);
 i9 = f31 > Math_fround(0.0);
 f31 = i9 ? f31 : Math_fround(0.0);
 i9 = f56 > Math_fround(0.0);
 f56 = i9 ? f56 : Math_fround(0.0);
 i9 = f59 > Math_fround(0.0);
 f59 = i9 ? f59 : Math_fround(0.0);
 i9 = f53 > Math_fround(0.0);
 f53 = i9 ? f53 : Math_fround(0.0);
 i9 = f51 > Math_fround(0.0);
 f51 = i9 ? f51 : Math_fround(0.0);
 i9 = f28 > Math_fround(0.0);
 f28 = i9 ? f28 : Math_fround(0.0);
 i9 = f49 > Math_fround(0.0);
 f53 = Math_fround(f62 + f53);
 f51 = Math_fround(f31 + f51);
 f28 = Math_fround(f56 + f28);
 f49 = Math_fround(f59 + (i9 ? f49 : Math_fround(0.0)));
 f52 = Math_fround(f52 + f52);
 f27 = Math_fround(f27 + f27);
 f47 = Math_fround(f47 + f47);
 f12 = Math_fround(f12 + f12);
 f59 = Math_fround(HEAPF32[i8 + 48 >> 2]);
 f56 = Math_fround(HEAPF32[i8 + 52 >> 2]);
 f31 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f52 = Math_fround(Math_fround(f61 + Math_fround(f60 * f59)) - f52);
 f27 = Math_fround(Math_fround(f58 + Math_fround(f57 * f56)) - f27);
 f47 = Math_fround(Math_fround(f55 + Math_fround(f54 * f31)) - f47);
 f12 = Math_fround(Math_fround(f34 + Math_fround(f37 * Math_fround(HEAPF32[i8 + 60 >> 2]))) - f12);
 f37 = Math_fround(HEAPF32[i8 + 80 >> 2]);
 f34 = Math_fround(HEAPF32[i8 + 84 >> 2]);
 f31 = Math_fround(HEAPF32[i8 + 88 >> 2]);
 f37 = Math_fround(f53 * Math_fround(f52 * f37));
 f34 = Math_fround(f51 * Math_fround(f27 * f34));
 f31 = Math_fround(f28 * Math_fround(f47 * f31));
 f12 = Math_fround(f49 * Math_fround(f12 * Math_fround(HEAPF32[i8 + 92 >> 2])));
 f49 = Math_fround(HEAPF32[i8 >> 2]);
 f47 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f27 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f37 = Math_fround(f37 * f49);
 f34 = Math_fround(f34 * f47);
 f31 = Math_fround(f31 * f28);
 f12 = Math_fround(f12 * f27);
 f45 = Math_fround(f45 * f37);
 f44 = Math_fround(f44 * f34);
 f43 = Math_fround(f43 * f31);
 f42 = Math_fround(f42 * f12);
 f41 = Math_fround(f41 * f37);
 f40 = Math_fround(f40 * f34);
 f39 = Math_fround(f39 * f31);
 f38 = Math_fround(f38 * f12);
 f37 = Math_fround(f50 * f37);
 f34 = Math_fround(f26 * f34);
 f31 = Math_fround(f32 * f31);
 f12 = Math_fround(f36 * f12);
 f36 = Math_fround(HEAPF32[i8 + 96 >> 2]);
 f32 = Math_fround(HEAPF32[i8 + 100 >> 2]);
 f26 = Math_fround(HEAPF32[i8 + 104 >> 2]);
 f36 = Math_fround(f49 * Math_fround(f48 * f36));
 f32 = Math_fround(f47 * Math_fround(f46 * f32));
 f26 = Math_fround(f28 * Math_fround(f29 * f26));
 f30 = Math_fround(f27 * Math_fround(f30 * Math_fround(HEAPF32[i8 + 108 >> 2])));
 f27 = Math_fround(HEAPF32[i10 >> 2]);
 f29 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f27 = Math_fround(f24 - f27);
 f29 = Math_fround(f25 - f29);
 f28 = Math_fround(f23 - f28);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i10 + 12 >> 2]));
 f23 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f24 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f23 = Math_fround(f19 - f23);
 f25 = Math_fround(f21 - f25);
 f24 = Math_fround(f16 - f24);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i10 + 28 >> 2]));
 f16 = Math_fround(HEAPF32[i10 + 32 >> 2]);
 f21 = Math_fround(HEAPF32[i10 + 36 >> 2]);
 f19 = Math_fround(HEAPF32[i10 + 40 >> 2]);
 f27 = Math_fround(f45 + Math_fround(f36 * f27));
 f29 = Math_fround(f44 + Math_fround(f32 * f29));
 f28 = Math_fround(f43 + Math_fround(f26 * f28));
 f22 = Math_fround(f42 + Math_fround(f30 * f22));
 f23 = Math_fround(f41 + Math_fround(f36 * f23));
 f25 = Math_fround(f40 + Math_fround(f32 * f25));
 f24 = Math_fround(f39 + Math_fround(f26 * f24));
 f14 = Math_fround(f38 + Math_fround(f30 * f14));
 f16 = Math_fround(f37 + Math_fround(f36 * Math_fround(f35 - f16)));
 f21 = Math_fround(f34 + Math_fround(f32 * Math_fround(f33 - f21)));
 f19 = Math_fround(f31 + Math_fround(f26 * Math_fround(f13 - f19)));
 f17 = Math_fround(f12 + Math_fround(f30 * Math_fround(f17 - Math_fround(HEAPF32[i10 + 44 >> 2]))));
 f30 = Math_fround(HEAPF32[i3 >> 2]);
 i9 = i3 + 4 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i3 + 8 | 0;
 f13 = Math_fround(HEAPF32[i10 >> 2]);
 i7 = i3 + 12 | 0;
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 f31 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i2 + 4 | 0;
 f33 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = i2 + 8 | 0;
 f32 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i2 + 12 | 0;
 f12 = Math_fround(f33 - Math_fround(f29 * f12));
 f13 = Math_fround(f32 - Math_fround(f28 * f13));
 f26 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - Math_fround(f22 * f26));
 HEAPF32[i2 >> 2] = Math_fround(f31 - Math_fround(f27 * f30));
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i4 >> 2] = f26;
 f26 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(HEAPF32[i7 >> 2]);
 i4 = i2 + 16 | 0;
 f31 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i2 + 20 | 0;
 f32 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i2 + 24 | 0;
 f33 = Math_fround(HEAPF32[i6 >> 2]);
 i8 = i2 + 28 | 0;
 f13 = Math_fround(f32 - Math_fround(f25 * f13));
 f12 = Math_fround(f33 - Math_fround(f24 * f12));
 f30 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f14 * f30));
 HEAPF32[i4 >> 2] = Math_fround(f31 - Math_fround(f23 * f26));
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i8 >> 2] = f30;
 f30 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(HEAPF32[i10 >> 2]);
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 i7 = i2 + 32 | 0;
 f31 = Math_fround(HEAPF32[i7 >> 2]);
 i10 = i2 + 36 | 0;
 f33 = Math_fround(HEAPF32[i10 >> 2]);
 i9 = i2 + 40 | 0;
 f32 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = i2 + 44 | 0;
 f12 = Math_fround(f33 - Math_fround(f21 * f12));
 f13 = Math_fround(f32 - Math_fround(f19 * f13));
 f26 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - Math_fround(f17 * f26));
 HEAPF32[i7 >> 2] = Math_fround(f31 - Math_fround(f16 * f30));
 HEAPF32[i10 >> 2] = f12;
 HEAPF32[i9 >> 2] = f13;
 HEAPF32[i8 >> 2] = f26;
 f15 = Math_fround(Math_fround(1.0) / f15);
 f20 = Math_fround(Math_fround(1.0) / f20);
 f18 = Math_fround(Math_fround(1.0) / f18);
 f11 = Math_fround(Math_fround(1.0) / f11);
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 i8 = i1 + 4 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i1 + 8 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i1 + 12 | 0;
 f13 = Math_fround(Math_fround(f29 * f20) + f13);
 f12 = Math_fround(Math_fround(f28 * f18) + f12);
 f22 = Math_fround(Math_fround(f22 * f11) + Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f27 * f15) + f26);
 HEAPF32[i8 >> 2] = f13;
 HEAPF32[i9 >> 2] = f12;
 HEAPF32[i10 >> 2] = f22;
 i10 = i1 + 16 | 0;
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 i9 = i1 + 20 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = i1 + 24 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = i1 + 28 | 0;
 f12 = Math_fround(Math_fround(f25 * f20) + f12);
 f13 = Math_fround(Math_fround(f24 * f18) + f13);
 f14 = Math_fround(Math_fround(f14 * f11) + Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(f23 * f15) + f22);
 HEAPF32[i9 >> 2] = f12;
 HEAPF32[i8 >> 2] = f13;
 HEAPF32[i7 >> 2] = f14;
 i7 = i1 + 32 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i1 + 36 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i1 + 40 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i1 + 44 | 0;
 f13 = Math_fround(Math_fround(f21 * f20) + f13);
 f12 = Math_fround(Math_fround(f19 * f18) + f12);
 f11 = Math_fround(Math_fround(f17 * f11) + Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f16 * f15) + f14);
 HEAPF32[i8 >> 2] = f13;
 HEAPF32[i9 >> 2] = f12;
 HEAPF32[i10 >> 2] = f11;
 return;
}

function __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i7, i2, i6, i3, i4, i5, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i8;
 i19 = i8 + 56 | 0;
 i30 = i8 + 16 | 0;
 i10 = i8 + 44 | 0;
 i9 = i8 + 32 | 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = i7;
 HEAPF32[i7 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 80 >> 2] = 0;
 HEAP32[i7 + 84 >> 2] = 0;
 HEAP32[i7 + 88 >> 2] = i7 + 64;
 HEAPF32[i7 + 96 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 144 >> 2] = 0;
 HEAP32[i7 + 148 >> 2] = 0;
 HEAP32[i7 + 152 >> 2] = i7 + 128;
 HEAPF32[i7 + 160 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 208 >> 2] = 0;
 HEAP32[i7 + 212 >> 2] = 0;
 HEAP32[i7 + 216 >> 2] = i7 + 192;
 HEAPF32[i7 + 224 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 272 >> 2] = 0;
 HEAP32[i7 + 276 >> 2] = 0;
 HEAP32[i7 + 280 >> 2] = i7 + 256;
 HEAPF32[i7 + 288 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 336 >> 2] = 0;
 HEAP32[i7 + 340 >> 2] = 0;
 HEAP32[i7 + 344 >> 2] = i7 + 320;
 HEAPF32[i7 + 352 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 400 >> 2] = 0;
 HEAP32[i7 + 404 >> 2] = 0;
 HEAP32[i7 + 408 >> 2] = i7 + 384;
 HEAPF32[i7 + 416 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 464 >> 2] = 0;
 HEAP32[i7 + 468 >> 2] = 0;
 HEAP32[i7 + 472 >> 2] = i7 + 448;
 HEAPF32[i7 + 480 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 528 >> 2] = 0;
 HEAP32[i7 + 532 >> 2] = 0;
 HEAP32[i7 + 536 >> 2] = i7 + 512;
 HEAPF32[i7 + 544 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 592 >> 2] = 0;
 HEAP32[i7 + 596 >> 2] = 0;
 HEAP32[i7 + 600 >> 2] = i7 + 576;
 HEAPF32[i7 + 608 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 656 >> 2] = 0;
 HEAP32[i7 + 660 >> 2] = 0;
 HEAP32[i7 + 664 >> 2] = i7 + 640;
 HEAPF32[i7 + 672 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 720 >> 2] = 0;
 HEAP32[i7 + 724 >> 2] = 0;
 HEAP32[i7 + 728 >> 2] = i7 + 704;
 HEAPF32[i7 + 736 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 784 >> 2] = 0;
 HEAP32[i7 + 788 >> 2] = 0;
 HEAP32[i7 + 792 >> 2] = i7 + 768;
 HEAPF32[i7 + 800 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 848 >> 2] = 0;
 HEAP32[i7 + 852 >> 2] = 0;
 HEAP32[i7 + 856 >> 2] = i7 + 832;
 HEAPF32[i7 + 864 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 912 >> 2] = 0;
 HEAP32[i7 + 916 >> 2] = 0;
 HEAP32[i7 + 920 >> 2] = i7 + 896;
 HEAPF32[i7 + 928 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 976 >> 2] = 0;
 HEAP32[i7 + 980 >> 2] = 0;
 HEAP32[i7 + 984 >> 2] = i7 + 960;
 HEAPF32[i7 + 992 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1040 >> 2] = 0;
 HEAP32[i7 + 1044 >> 2] = 0;
 HEAP32[i7 + 1048 >> 2] = i7 + 1024;
 HEAPF32[i7 + 1056 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1104 >> 2] = 0;
 HEAP32[i7 + 1108 >> 2] = 0;
 HEAP32[i7 + 1112 >> 2] = i7 + 1088;
 HEAPF32[i7 + 1120 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1168 >> 2] = 0;
 HEAP32[i7 + 1172 >> 2] = 0;
 HEAP32[i7 + 1176 >> 2] = i7 + 1152;
 HEAPF32[i7 + 1184 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1232 >> 2] = 0;
 HEAP32[i7 + 1236 >> 2] = 0;
 HEAP32[i7 + 1240 >> 2] = i7 + 1216;
 HEAPF32[i7 + 1248 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1296 >> 2] = 0;
 HEAP32[i7 + 1300 >> 2] = 0;
 HEAP32[i7 + 1304 >> 2] = i7 + 1280;
 HEAPF32[i7 + 1312 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1360 >> 2] = 0;
 HEAP32[i7 + 1364 >> 2] = 0;
 HEAP32[i7 + 1368 >> 2] = i7 + 1344;
 HEAPF32[i7 + 1376 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1424 >> 2] = 0;
 HEAP32[i7 + 1428 >> 2] = 0;
 HEAP32[i7 + 1432 >> 2] = i7 + 1408;
 HEAPF32[i7 + 1440 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1488 >> 2] = 0;
 HEAP32[i7 + 1492 >> 2] = 0;
 HEAP32[i7 + 1496 >> 2] = i7 + 1472;
 HEAPF32[i7 + 1504 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1552 >> 2] = 0;
 HEAP32[i7 + 1556 >> 2] = 0;
 HEAP32[i7 + 1560 >> 2] = i7 + 1536;
 HEAPF32[i7 + 1568 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1616 >> 2] = 0;
 HEAP32[i7 + 1620 >> 2] = 0;
 HEAP32[i7 + 1624 >> 2] = i7 + 1600;
 HEAPF32[i7 + 1632 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1680 >> 2] = 0;
 HEAP32[i7 + 1684 >> 2] = 0;
 HEAP32[i7 + 1688 >> 2] = i7 + 1664;
 HEAPF32[i7 + 1696 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1744 >> 2] = 0;
 HEAP32[i7 + 1748 >> 2] = 0;
 HEAP32[i7 + 1752 >> 2] = i7 + 1728;
 HEAPF32[i7 + 1760 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1808 >> 2] = 0;
 HEAP32[i7 + 1812 >> 2] = 0;
 HEAP32[i7 + 1816 >> 2] = i7 + 1792;
 HEAPF32[i7 + 1824 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1872 >> 2] = 0;
 HEAP32[i7 + 1876 >> 2] = 0;
 HEAP32[i7 + 1880 >> 2] = i7 + 1856;
 HEAPF32[i7 + 1888 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 1936 >> 2] = 0;
 HEAP32[i7 + 1940 >> 2] = 0;
 HEAP32[i7 + 1944 >> 2] = i7 + 1920;
 HEAPF32[i7 + 1952 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 2e3 >> 2] = 0;
 HEAP32[i7 + 2004 >> 2] = 0;
 HEAP32[i7 + 2008 >> 2] = i7 + 1984;
 HEAPF32[i7 + 2016 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i25 = i7 + 2176 | 0;
 HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i25 = i7 + 2192 | 0;
 HEAP32[i25 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i7 + 2208 >> 2] = i3;
 HEAP32[i7 + 2212 >> 2] = i4;
 HEAP32[i7 + 2216 >> 2] = i5;
 HEAP32[i7 + 2220 >> 2] = i1;
 i25 = i7 + 2304 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 i25 = i7 + 2256 | 0;
 HEAPF32[i25 >> 2] = Math_fround(1.0);
 i23 = i7 + 2260 | 0;
 HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 i19 = i7 + 2276 | 0;
 HEAPF32[i19 >> 2] = Math_fround(1.0);
 i17 = i7 + 2280 | 0;
 HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 i2 = i7 + 2296 | 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i5 = i7 + 2300 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 2328 >> 2] = 0;
 HEAP32[i7 + 2324 >> 2] = 0;
 HEAP32[i7 + 2332 >> 2] = 0;
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f29 = Math_fround(-f29);
 f27 = Math_fround(-f27);
 f28 = Math_fround(-f28);
 f11 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f26 = Math_fround(f11 - f26);
 f15 = Math_fround(f14 - f15);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i3 + 24 >> 2]));
 f14 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f11 = Math_fround(Math_fround(Math_fround(f26 * f29) + Math_fround(f15 * f27)) + Math_fround(f16 * f28));
 f13 = Math_fround(Math_fround(Math_fround(f11 * f29) + Math_fround(Math_fround(f14 * f26) + Math_fround(f21 * Math_fround(Math_fround(f16 * f27) - Math_fround(f15 * f28))))) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(Math_fround(f11 * f27) + Math_fround(Math_fround(f14 * f15) + Math_fround(f21 * Math_fround(Math_fround(f26 * f28) - Math_fround(f16 * f29))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) + Math_fround(f21 * Math_fround(Math_fround(f15 * f29) - Math_fround(f26 * f27)))) + Math_fround(f11 * f28)) * Math_fround(2.0));
 f26 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f21 * f14) - Math_fround(Math_fround(Math_fround(f26 * f29) + Math_fround(f15 * f27)) + Math_fround(f16 * f28)));
 f24 = Math_fround(Math_fround(Math_fround(f16 * f27) - Math_fround(f15 * f28)) + Math_fround(Math_fround(f21 * f26) + Math_fround(f14 * f29)));
 f20 = Math_fround(Math_fround(Math_fround(f26 * f28) - Math_fround(f16 * f29)) + Math_fround(Math_fround(f21 * f15) + Math_fround(f14 * f27)));
 f28 = Math_fround(Math_fround(Math_fround(f15 * f29) - Math_fround(f26 * f27)) + Math_fround(Math_fround(f21 * f16) + Math_fround(f14 * f28)));
 f14 = Math_fround(f24 + f24);
 f16 = Math_fround(f20 + f20);
 f21 = Math_fround(f28 + f28);
 f27 = Math_fround(f20 * f16);
 f26 = Math_fround(f28 * f21);
 f20 = Math_fround(f20 * f14);
 f29 = Math_fround(f28 * f14);
 f15 = Math_fround(f22 * f14);
 f28 = Math_fround(f28 * f16);
 f16 = Math_fround(f22 * f16);
 f21 = Math_fround(f22 * f21);
 f14 = Math_fround(Math_fround(1.0) - Math_fround(f24 * f14));
 f24 = Math_fround(f20 + f21);
 f22 = Math_fround(f29 - f16);
 f21 = Math_fround(f20 - f21);
 f20 = Math_fround(f14 - f26);
 f18 = Math_fround(f28 + f15);
 f16 = Math_fround(f29 + f16);
 f15 = Math_fround(f28 - f15);
 f14 = Math_fround(f14 - f27);
 HEAPF32[i25 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f27) - f26);
 HEAPF32[i23 >> 2] = f24;
 HEAPF32[i7 + 2264 >> 2] = f22;
 HEAPF32[i7 + 2268 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 2272 >> 2] = f21;
 HEAPF32[i19 >> 2] = f20;
 HEAPF32[i17 >> 2] = f18;
 HEAPF32[i7 + 2284 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 2288 >> 2] = f16;
 HEAPF32[i7 + 2292 >> 2] = f15;
 HEAPF32[i2 >> 2] = f14;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 2304 >> 2] = f13;
 HEAPF32[i7 + 2308 >> 2] = f12;
 HEAPF32[i7 + 2312 >> 2] = f11;
 HEAPF32[i7 + 2316 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 2048 >> 2] = i7;
 HEAP32[i7 + 2052 >> 2] = i7 + 64;
 HEAP32[i7 + 2056 >> 2] = i7 + 128;
 HEAP32[i7 + 2060 >> 2] = i7 + 192;
 HEAP32[i7 + 2064 >> 2] = i7 + 256;
 HEAP32[i7 + 2068 >> 2] = i7 + 320;
 HEAP32[i7 + 2072 >> 2] = i7 + 384;
 HEAP32[i7 + 2076 >> 2] = i7 + 448;
 HEAP32[i7 + 2080 >> 2] = i7 + 512;
 HEAP32[i7 + 2084 >> 2] = i7 + 576;
 HEAP32[i7 + 2088 >> 2] = i7 + 640;
 HEAP32[i7 + 2092 >> 2] = i7 + 704;
 HEAP32[i7 + 2096 >> 2] = i7 + 768;
 HEAP32[i7 + 2100 >> 2] = i7 + 832;
 HEAP32[i7 + 2104 >> 2] = i7 + 896;
 HEAP32[i7 + 2108 >> 2] = i7 + 960;
 HEAP32[i7 + 2112 >> 2] = i7 + 1024;
 HEAP32[i7 + 2116 >> 2] = i7 + 1088;
 HEAP32[i7 + 2120 >> 2] = i7 + 1152;
 HEAP32[i7 + 2124 >> 2] = i7 + 1216;
 HEAP32[i7 + 2128 >> 2] = i7 + 1280;
 HEAP32[i7 + 2132 >> 2] = i7 + 1344;
 HEAP32[i7 + 2136 >> 2] = i7 + 1408;
 HEAP32[i7 + 2140 >> 2] = i7 + 1472;
 HEAP32[i7 + 2144 >> 2] = i7 + 1536;
 HEAP32[i7 + 2148 >> 2] = i7 + 1600;
 HEAP32[i7 + 2152 >> 2] = i7 + 1664;
 HEAP32[i7 + 2156 >> 2] = i7 + 1728;
 HEAP32[i7 + 2160 >> 2] = i7 + 1792;
 HEAP32[i7 + 2164 >> 2] = i7 + 1856;
 HEAP32[i7 + 2168 >> 2] = i7 + 1920;
 HEAP32[i7 + 2172 >> 2] = i7 + 1984;
 HEAP32[i7 + 2320 >> 2] = i1;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i7 + 2240 >> 2] = Math_fround(f11 * f11);
 i6 = i7 + 2244 | 0;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAPF32[i7 + 2224 >> 2] = Math_fround(.995999991);
 i7 = i7 + 2228 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i8;
 return;
}

function __ZN22ParticleSystemRenderer8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 340 | 0;
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011343 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 2 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 342 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621597 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 344 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621608 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 348 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048520 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048449 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 356 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048504 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 360 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048490 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 364 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621626 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621641 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621659 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 376 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902162 | 0, HEAP32[gb + 37324 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 388 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621677 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 392 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31ParticleSystemVertexStreamFlagsEvRT_RT0_PKc17TransferMetaFlags(i9, i3, gb + 621702 | 0, 0);
 i2 = i7 + 552 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048075 | 0, gb + 1048082 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 556 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621721 | 0, gb + 1048082 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 560 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621729 | 0, gb + 1048082 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 564 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 621737 | 0, gb + 1048082 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0)) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i3 >> 2] | 0) == 27) {
  STACKTOP = i10;
  return;
 }
 HEAP8[i4 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN27ParticleSystemReadOnlyState8TransferI14SafeBinaryReadEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i8 = i12;
 i4 = i9 + 264 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621138 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i6 >>> 0) i10 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i10 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 268 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621751 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i10 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 277 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621150 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 278 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621158 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 279 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621166 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i6 = i9 + 276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621178 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621193 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i10 = 65; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 65; else {
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i10 | 0) == 65) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
    if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  HEAP16[i9 + 84 >> 1] = 0;
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i9 + 80 >> 2] = f13;
  HEAP8[i9 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i9, i9 + 88 | 0, f13, 0) | 0) & 1;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621193 | 0, gb + 620173 | 0, i7, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i9, i11); else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 4) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621204 | 0, i4, i7, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i8 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 1);
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i11 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  HEAP32[i9 + 280 >> 2] = (HEAP8[i8 >> 0] ^ 1) & 255;
 } else {
  i4 = i9 + 280 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621204 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i10 = 95; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 95; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i10 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
 }
 i2 = i9 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621222 | 0, gb + 842702 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 284 | 0;
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0) HEAP32[i4 >> 2] = 2; else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621246 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i10 = 115; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 115; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i10 | 0) == 115) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 3) | 0)) {
  i4 = i9 + 272 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621258 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i9 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i9 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i9 >>> 0) i10 = 141; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 141; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i10 | 0) == 141) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  STACKTOP = i12;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621258 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  i1 = 0;
  i2 = 1;
 } else {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i10 = 129; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i10 = 129; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 129) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = (i2 | 0) == 0 & 1;
 }
 HEAP8[i6 >> 0] = i2;
 HEAP32[i9 + 272 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN11b2GearJoint23InitVelocityConstraintsERK12b2SolverData(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0;
 i49 = HEAP32[i18 + 48 >> 2] | 0;
 i23 = HEAP32[i49 + 8 >> 2] | 0;
 i42 = i18 + 160 | 0;
 HEAP32[i42 >> 2] = i23;
 i46 = HEAP32[i18 + 52 >> 2] | 0;
 i33 = HEAP32[i46 + 8 >> 2] | 0;
 i25 = i18 + 164 | 0;
 HEAP32[i25 >> 2] = i33;
 i50 = HEAP32[i18 + 84 >> 2] | 0;
 i40 = i18 + 168 | 0;
 HEAP32[i40 >> 2] = HEAP32[i50 + 8 >> 2];
 i47 = HEAP32[i18 + 88 >> 2] | 0;
 i41 = i18 + 172 | 0;
 HEAP32[i41 >> 2] = HEAP32[i47 + 8 >> 2];
 i6 = i18 + 176 | 0;
 i44 = i49 + 28 | 0;
 i51 = HEAP32[i44 + 4 >> 2] | 0;
 i16 = i6;
 HEAP32[i16 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i16 + 4 >> 2] = i51;
 i16 = i18 + 184 | 0;
 i51 = i46 + 28 | 0;
 i44 = HEAP32[i51 + 4 >> 2] | 0;
 i7 = i16;
 HEAP32[i7 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i7 + 4 >> 2] = i44;
 i7 = i18 + 192 | 0;
 i44 = i50 + 28 | 0;
 i51 = HEAP32[i44 + 4 >> 2] | 0;
 i17 = i7;
 HEAP32[i17 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i17 + 4 >> 2] = i51;
 i17 = i18 + 200 | 0;
 i51 = i47 + 28 | 0;
 i44 = HEAP32[i51 + 4 >> 2] | 0;
 i43 = i17;
 HEAP32[i43 >> 2] = HEAP32[i51 >> 2];
 HEAP32[i43 + 4 >> 2] = i44;
 i43 = i18 + 208 | 0;
 HEAP32[i43 >> 2] = HEAP32[i49 + 120 >> 2];
 i44 = i18 + 212 | 0;
 HEAP32[i44 >> 2] = HEAP32[i46 + 120 >> 2];
 i51 = HEAP32[i50 + 120 >> 2] | 0;
 HEAP32[i18 + 216 >> 2] = i51;
 i48 = HEAP32[i47 + 120 >> 2] | 0;
 HEAP32[i18 + 220 >> 2] = i48;
 i49 = HEAP32[i49 + 128 >> 2] | 0;
 HEAP32[i18 + 224 >> 2] = i49;
 i46 = HEAP32[i46 + 128 >> 2] | 0;
 HEAP32[i18 + 228 >> 2] = i46;
 i50 = HEAP32[i50 + 128 >> 2] | 0;
 HEAP32[i18 + 232 >> 2] = i50;
 i47 = HEAP32[i47 + 128 >> 2] | 0;
 HEAP32[i18 + 236 >> 2] = i47;
 i30 = HEAP32[i19 + 24 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i30 + (i23 * 12 | 0) + 8 >> 2]);
 i45 = i19 + 28 | 0;
 i52 = HEAP32[i45 >> 2] | 0;
 i20 = HEAP32[i52 + (i23 * 12 | 0) >> 2] | 0;
 i21 = HEAP32[i52 + (i23 * 12 | 0) + 4 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i52 + (i23 * 12 | 0) + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i30 + (i33 * 12 | 0) + 8 >> 2]);
 i23 = HEAP32[i52 + (i33 * 12 | 0) >> 2] | 0;
 i24 = HEAP32[i52 + (i33 * 12 | 0) + 4 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i52 + (i33 * 12 | 0) + 8 >> 2]);
 i33 = HEAP32[i40 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i30 + (i33 * 12 | 0) + 8 >> 2]);
 i27 = HEAP32[i52 + (i33 * 12 | 0) >> 2] | 0;
 i28 = HEAP32[i52 + (i33 * 12 | 0) + 4 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i52 + (i33 * 12 | 0) + 8 >> 2]);
 i33 = HEAP32[i41 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i30 + (i33 * 12 | 0) + 8 >> 2]);
 i30 = HEAP32[i52 + (i33 * 12 | 0) >> 2] | 0;
 i31 = HEAP32[i52 + (i33 * 12 | 0) + 4 >> 2] | 0;
 f32 = Math_fround(HEAPF32[i52 + (i33 * 12 | 0) + 8 >> 2]);
 f1 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 f5 = Math_fround(+Math_sin(+f13));
 f13 = Math_fround(+Math_cos(+f13));
 f3 = Math_fround(+Math_sin(+f4));
 f4 = Math_fround(+Math_cos(+f4));
 f14 = Math_fround(+Math_sin(+f15));
 f15 = Math_fround(+Math_cos(+f15));
 i33 = i18 + 272 | 0;
 HEAPF32[i33 >> 2] = Math_fround(0.0);
 f34 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((HEAP32[i18 + 76 >> 2] | 0) == 1) {
  HEAPF32[i18 + 264 >> 2] = Math_fround(1.0);
  f1 = Math_fround(f36 + f35);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(1.0);
  f12 = Math_fround(1.0);
 } else {
  f11 = Math_fround(HEAPF32[i18 + 124 >> 2]);
  f9 = Math_fround(f4 * f11);
  f10 = Math_fround(HEAPF32[i18 + 128 >> 2]);
  f9 = Math_fround(f9 - Math_fround(f3 * f10));
  f10 = Math_fround(Math_fround(f3 * f11) + Math_fround(f4 * f10));
  f11 = Math_fround(HEAPF32[i18 + 108 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i7 >> 2]));
  f12 = Math_fround(HEAPF32[i18 + 112 >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i18 + 196 >> 2]));
  f53 = Math_fround(Math_fround(f4 * f11) - Math_fround(f3 * f12));
  f12 = Math_fround(Math_fround(f3 * f11) + Math_fround(f4 * f12));
  f4 = Math_fround(HEAPF32[i18 + 92 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i6 >> 2]));
  f11 = Math_fround(HEAPF32[i18 + 96 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i18 + 180 >> 2]));
  f8 = Math_fround(Math_fround(f2 * f4) - Math_fround(f1 * f11));
  f11 = Math_fround(Math_fround(f1 * f4) + Math_fround(f2 * f11));
  f12 = Math_fround(Math_fround(f10 * f53) - Math_fround(f9 * f12));
  HEAPF32[i18 + 264 >> 2] = f12;
  f11 = Math_fround(Math_fround(f10 * f8) - Math_fround(f9 * f11));
  f1 = Math_fround(Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i43 >> 2])) + Math_fround(f12 * Math_fround(f35 * f12))) + Math_fround(f11 * Math_fround(f11 * f36)));
 }
 f8 = Math_fround(f1 + Math_fround(0.0));
 HEAPF32[i18 + 240 >> 2] = f9;
 HEAPF32[i18 + 244 >> 2] = f10;
 HEAPF32[i18 + 256 >> 2] = f11;
 HEAPF32[i33 >> 2] = f8;
 if ((HEAP32[i18 + 80 >> 2] | 0) == 1) {
  i52 = HEAP32[i18 + 152 >> 2] | 0;
  HEAP32[i18 + 260 >> 2] = i52;
  HEAP32[i18 + 268 >> 2] = i52;
  f5 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(Math_fround(f5 * f5) * Math_fround(f39 + f38));
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = f5;
 } else {
  f4 = Math_fround(HEAPF32[i18 + 132 >> 2]);
  f53 = Math_fround(f15 * f4);
  f54 = Math_fround(HEAPF32[i18 + 136 >> 2]);
  f53 = Math_fround(f53 - Math_fround(f14 * f54));
  f54 = Math_fround(Math_fround(f14 * f4) + Math_fround(f15 * f54));
  f4 = Math_fround(HEAPF32[i18 + 116 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i17 >> 2]));
  f1 = Math_fround(HEAPF32[i18 + 120 >> 2]);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i18 + 204 >> 2]));
  f55 = Math_fround(Math_fround(f15 * f4) - Math_fround(f14 * f1));
  f14 = Math_fround(Math_fround(f14 * f4) + Math_fround(f15 * f1));
  f1 = Math_fround(HEAPF32[i18 + 100 >> 2]);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i16 >> 2]));
  f4 = Math_fround(HEAPF32[i18 + 104 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i18 + 188 >> 2]));
  f15 = Math_fround(Math_fround(f13 * f1) - Math_fround(f5 * f4));
  f4 = Math_fround(Math_fround(f5 * f1) + Math_fround(f13 * f4));
  f1 = Math_fround(HEAPF32[i18 + 152 >> 2]);
  f2 = Math_fround(f53 * f1);
  f3 = Math_fround(f54 * f1);
  f5 = Math_fround(Math_fround(Math_fround(f54 * f55) - Math_fround(f53 * f14)) * f1);
  HEAPF32[i18 + 268 >> 2] = f5;
  f4 = Math_fround(Math_fround(Math_fround(f54 * f15) - Math_fround(f53 * f4)) * f1);
  HEAPF32[i18 + 260 >> 2] = f4;
  f1 = Math_fround(f1 * f1);
  f1 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(f37 + Math_fround(HEAPF32[i44 >> 2]))) + Math_fround(f5 * Math_fround(f38 * f5))) + Math_fround(f4 * Math_fround(f4 * f39)));
 }
 f55 = Math_fround(f8 + f1);
 HEAPF32[i18 + 248 >> 2] = f2;
 HEAPF32[i18 + 252 >> 2] = f3;
 i52 = f55 > Math_fround(0.0);
 f55 = Math_fround(Math_fround(1.0) / f55);
 HEAPF32[i33 >> 2] = i52 ? f55 : Math_fround(0.0);
 if (!(HEAP8[i19 + 20 >> 0] | 0)) {
  HEAPF32[i18 + 156 >> 2] = Math_fround(0.0);
  f55 = f32;
  f39 = f22;
  f54 = f29;
  f53 = f26;
  i48 = i30;
  i46 = i27;
  i43 = i23;
  i30 = i20;
  i51 = i31;
  i50 = i28;
  i49 = i24;
  i47 = i21;
  i52 = HEAP32[i42 >> 2] | 0;
  i44 = HEAP32[i45 >> 2] | 0;
  i33 = i44 + (i52 * 12 | 0) | 0;
  HEAP32[i33 >> 2] = i30;
  i52 = i44 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i47;
  i52 = HEAP32[i42 >> 2] | 0;
  i47 = HEAP32[i45 >> 2] | 0;
  i52 = i47 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f39;
  i52 = HEAP32[i25 >> 2] | 0;
  i44 = i47 + (i52 * 12 | 0) | 0;
  HEAP32[i44 >> 2] = i43;
  i52 = i47 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i49;
  i52 = HEAP32[i25 >> 2] | 0;
  i49 = HEAP32[i45 >> 2] | 0;
  i52 = i49 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f53;
  i52 = HEAP32[i40 >> 2] | 0;
  i47 = i49 + (i52 * 12 | 0) | 0;
  HEAP32[i47 >> 2] = i46;
  i52 = i49 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i50;
  i52 = HEAP32[i40 >> 2] | 0;
  i50 = HEAP32[i45 >> 2] | 0;
  i52 = i50 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f54;
  i52 = HEAP32[i41 >> 2] | 0;
  i49 = i50 + (i52 * 12 | 0) | 0;
  HEAP32[i49 >> 2] = i48;
  i52 = i50 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i51;
  i52 = HEAP32[i41 >> 2] | 0;
  i51 = HEAP32[i45 >> 2] | 0;
  i52 = i51 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f55;
  return;
 } else {
  f53 = Math_fround(HEAPF32[i43 >> 2]);
  f55 = Math_fround(HEAPF32[i18 + 156 >> 2]);
  f53 = Math_fround(f53 * f55);
  f54 = Math_fround(f9 * f53);
  f53 = Math_fround(f53 * f10);
  f54 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f54);
  i51 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  f53 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f53);
  i47 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(f22 + Math_fround(Math_fround(f55 * f36) * f11));
  f53 = Math_fround(f55 * Math_fround(HEAPF32[i44 >> 2]));
  f54 = Math_fround(f2 * f53);
  f53 = Math_fround(f53 * f3);
  f54 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f54);
  i43 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  f53 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f53);
  i49 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  f53 = Math_fround(f26 + Math_fround(Math_fround(f55 * f39) * f4));
  f54 = Math_fround(f55 * f34);
  f39 = Math_fround(f9 * f54);
  f54 = Math_fround(f10 * f54);
  f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f39);
  i46 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  f54 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f54);
  i50 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
  f54 = Math_fround(f29 - Math_fround(Math_fround(f55 * f35) * f12));
  f37 = Math_fround(f55 * f37);
  f39 = Math_fround(f2 * f37);
  f37 = Math_fround(f3 * f37);
  f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f39);
  i48 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f37);
  f55 = Math_fround(f32 - Math_fround(Math_fround(f55 * f38) * f5));
  f39 = f36;
  i31 = i51;
  i51 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
  i52 = HEAP32[i42 >> 2] | 0;
  i44 = HEAP32[i45 >> 2] | 0;
  i33 = i44 + (i52 * 12 | 0) | 0;
  HEAP32[i33 >> 2] = i31;
  i52 = i44 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i47;
  i52 = HEAP32[i42 >> 2] | 0;
  i47 = HEAP32[i45 >> 2] | 0;
  i52 = i47 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f39;
  i52 = HEAP32[i25 >> 2] | 0;
  i44 = i47 + (i52 * 12 | 0) | 0;
  HEAP32[i44 >> 2] = i43;
  i52 = i47 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i49;
  i52 = HEAP32[i25 >> 2] | 0;
  i49 = HEAP32[i45 >> 2] | 0;
  i52 = i49 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f53;
  i52 = HEAP32[i40 >> 2] | 0;
  i47 = i49 + (i52 * 12 | 0) | 0;
  HEAP32[i47 >> 2] = i46;
  i52 = i49 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i50;
  i52 = HEAP32[i40 >> 2] | 0;
  i50 = HEAP32[i45 >> 2] | 0;
  i52 = i50 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f54;
  i52 = HEAP32[i41 >> 2] | 0;
  i49 = i50 + (i52 * 12 | 0) | 0;
  HEAP32[i49 >> 2] = i48;
  i52 = i50 + (i52 * 12 | 0) + 4 | 0;
  HEAP32[i52 >> 2] = i51;
  i52 = HEAP32[i41 >> 2] | 0;
  i51 = HEAP32[i45 >> 2] | 0;
  i52 = i51 + (i52 * 12 | 0) + 8 | 0;
  HEAPF32[i52 >> 2] = f55;
  return;
 }
}

function __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph(i20, i21, i22, i23, i24, i25, i26, i27) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i28 + 4 | 0;
 i2 = i28;
 if ((HEAP16[gb + 1161920 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161920 | 0, i1);
  i18 = gb + 1161920 | 0;
 } else i18 = 0;
 if (i21 | 0) {
  i17 = 0;
  i19 = 1;
  do {
   L7 : do if (i19 & i21 | 0) {
    i5 = HEAP16[i23 + (i17 << 2) >> 1] | 0;
    i1 = i24 + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i22 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i9 = HEAP16[i26 + (i17 << 2) >> 1] | 0;
    i2 = i27 + (((i9 & 65535) >>> 8 & 65535) + (HEAP32[i25 + ((i9 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAP8[i22 + ((i5 & 255) * 12 | 0) + 10 >> 0] | 0;
    i9 = HEAP8[i25 + ((i9 & 255) * 12 | 0) + 10 >> 0] | 0;
    i3 = i23 + (i17 << 2) + 2 | 0;
    i6 = HEAP8[i3 >> 0] | 0;
    i4 = i26 + (i17 << 2) + 2 | 0;
    i7 = HEAP8[i4 >> 0] | 0;
    if (i6 << 24 >> 24 == i7 << 24 >> 24) {
     i6 = HEAP16[i3 >> 1] | 0;
     i6 = Math_imul((i6 & 65535) >>> 8 & 65535, HEAPU8[(i6 & 255) + (gb + 430676) >> 0] | 0) | 0;
     i4 = HEAP16[i4 >> 1] | 0;
     i4 = Math_imul((i4 & 65535) >>> 8 & 65535, HEAPU8[(i4 & 255) + (gb + 430676) >> 0] | 0) | 0;
     i6 = i4 >>> 0 < i6 >>> 0 ? i4 : i6;
     i4 = i4 - i6 | 0;
     i5 = i5 & 255;
     i3 = Math_imul(i5, i20) | 0;
     i7 = i1 + i3 | 0;
     if (i4 | 0) {
      if (!i3) break;
      i3 = i9 & 255;
      while (1) {
       _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
       _memset(i2 + i6 | 0, 0, i4 | 0) | 0;
       i1 = i1 + i5 | 0;
       if ((i1 | 0) == (i7 | 0)) break L7; else i2 = i2 + i3 | 0;
      }
     }
     switch ((i6 & 65535) << 16 >> 16) {
     case 4:
      {
       if (!i3) break L7;
       i3 = i9 & 255;
       while (1) {
        HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
        i1 = i1 + i5 | 0;
        if ((i1 | 0) == (i7 | 0)) break L7; else i2 = i2 + i3 | 0;
       }
      }
     case 8:
      {
       if (!i3) break L7;
       i3 = i9 & 255;
       while (1) {
        HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        i1 = i1 + i5 | 0;
        if ((i1 | 0) == (i7 | 0)) break L7; else i2 = i2 + i3 | 0;
       }
      }
     case 12:
      {
       if (!i3) break L7;
       i3 = i9 & 255;
       while (1) {
        HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
        i1 = i1 + i5 | 0;
        if ((i1 | 0) == (i7 | 0)) break L7; else i2 = i2 + i3 | 0;
       }
      }
     default:
      {
       if (!i3) break L7;
       i3 = i9 & 255;
       while (1) {
        _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
        i1 = i1 + i5 | 0;
        if ((i1 | 0) == (i7 | 0)) break L7; else i2 = i2 + i3 | 0;
       }
      }
     }
    }
    f14 = (i17 | 0) == 0 ? Math_fround(1.0) : Math_fround(0.0);
    i12 = HEAP8[i23 + (i17 << 2) + 3 >> 0] | 0;
    i13 = HEAP8[i26 + (i17 << 2) + 3 >> 0] | 0;
    i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (i13 & 255) < (i12 & 255) ? i13 : i12;
    i15 = i5 & 255;
    i5 = Math_imul(i15, i20) | 0;
    i16 = i1 + i5 | 0;
    i3 = i7 << 24 >> 24 == 0;
    if (i6 << 24 >> 24 == 1 & i3) {
     if (!i5) break;
     i11 = i13 & 255;
     i10 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i11 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i10 | 0;
      }
     }
     i9 = i12 & 255;
     i8 = (i12 & 255) < (i13 & 255);
     while (1) {
      i7 = 0;
      do {
       i5 = i2 + (i7 << 2) | 0;
       i6 = HEAPU16[i1 + (i7 << 1) >> 1] | 0;
       i3 = i6 & 32767;
       L53 : do if (!i3) i3 = 0; else {
        i3 = i3 << 13;
        i4 = i3 & 260046848;
        L55 : do if ((i4 | 0) < 260046848) {
         switch (i4 | 0) {
         case 0:
          break;
         default:
          break L55;
         }
         f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
         i3 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
         break L53;
        } else {
         switch (i4 | 0) {
         case 260046848:
          break;
         default:
          break L55;
         }
         i3 = i3 | 1879048192;
         break L53;
        } while (0);
        i3 = i3 + 939524096 | 0;
       } while (0);
       HEAP32[i5 >> 2] = i3 | i6 << 16 & -2147483648;
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i9 >>> 0);
      if (i8) {
       i3 = i9;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i11 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i10 | 0;
     }
    }
    if (i6 << 24 >> 24 == 2 & i3) {
     if (!i5) break;
     i7 = i13 & 255;
     i6 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
      }
     }
     i5 = i12 & 255;
     i4 = (i12 & 255) < (i13 & 255);
     while (1) {
      i3 = 0;
      do {
       HEAPF32[i2 + (i3 << 2) >> 2] = Math_fround(Math_fround(HEAPU8[i1 + i3 >> 0] | 0) / Math_fround(255.0));
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i5 >>> 0);
      if (i4) {
       i3 = i5;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
     }
    }
    if (i6 << 24 >> 24 == 3 & i3) {
     if (!i5) break;
     i7 = i13 & 255;
     i6 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
      }
     }
     i5 = i12 & 255;
     i4 = (i12 & 255) < (i13 & 255);
     while (1) {
      i3 = 0;
      do {
       HEAPF32[i2 + (i3 << 2) >> 2] = Math_fround(Math_fround(HEAP8[i1 + i3 >> 0] | 0) * Math_fround(.00787401571));
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i5 >>> 0);
      if (i4) {
       i3 = i5;
       do {
        HEAPF32[i2 + (i3 << 2) >> 2] = (i3 | 0) == 3 ? f14 : Math_fround(0.0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
     }
    }
    i3 = i6 << 24 >> 24 == 0;
    if (i3 & i7 << 24 >> 24 == 1) {
     i8 = i4 >>> 23 & 255;
     i8 = (HEAPU16[gb + 1477124 + (i8 << 1) >> 1] | i4 >>> 16 & 32768 | (i4 & 8388607) >>> (HEAPU8[gb + 1546331 + i8 >> 0] | 0)) & 65535;
     if (!i5) break;
     i7 = i13 & 255;
     i6 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAP16[i2 + (i3 << 1) >> 1] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
      }
     }
     i5 = i12 & 255;
     i4 = (i12 & 255) < (i13 & 255);
     while (1) {
      i3 = 0;
      do {
       i12 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
       i13 = i12 >>> 23 & 255;
       HEAP16[i2 + (i3 << 1) >> 1] = i12 >>> 16 & 32768 | HEAPU16[gb + 1477124 + (i13 << 1) >> 1] | (i12 & 8388607) >>> (HEAPU8[gb + 1546331 + i13 >> 0] | 0);
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i5 >>> 0);
      if (i4) {
       i3 = i5;
       do {
        HEAP16[i2 + (i3 << 1) >> 1] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
     }
    }
    if (i3 & i7 << 24 >> 24 == 2) {
     i8 = ~~Math_fround(Math_fround(f14 * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
     if (!i5) break;
     i7 = i13 & 255;
     i6 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAP8[i2 + i3 >> 0] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
      }
     }
     i5 = i12 & 255;
     i4 = (i12 & 255) < (i13 & 255);
     while (1) {
      i3 = 0;
      do {
       f29 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
       i13 = f29 < Math_fround(0.0);
       f29 = i13 ? Math_fround(0.0) : f29;
       i13 = f29 > Math_fround(1.0);
       HEAP8[i2 + i3 >> 0] = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f29) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i5 >>> 0);
      if (i4) {
       i3 = i5;
       do {
        HEAP8[i2 + i3 >> 0] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
     }
    }
    if (!(i3 & i7 << 24 >> 24 == 3)) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430710 | 0, 0, gb + 430527 | 0, 366, 1, 0, 0, 0);
     break;
    }
    f14 = Math_fround(Math_fround(f14 * Math_fround(127.0)) + Math_fround(.5));
    i8 = f14 >= Math_fround(0.0);
    f29 = Math_fround(f14 + Math_fround(-.99999994));
    i8 = ~~(i8 ? f14 : f29) & 255;
    if (i5 | 0) {
     i7 = i13 & 255;
     i6 = i9 & 255;
     if (!(i12 << 24 >> 24)) {
      if (!(i13 << 24 >> 24)) while (1) {
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7;
      }
      while (1) {
       i3 = 0;
       do {
        HEAP8[i2 + i3 >> 0] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
       i1 = i1 + i15 | 0;
       if ((i1 | 0) == (i16 | 0)) break L7; else i2 = i2 + i6 | 0;
      }
     }
     i5 = i12 & 255;
     i4 = (i12 & 255) < (i13 & 255);
     while (1) {
      i3 = 0;
      do {
       f14 = Math_fround(HEAPF32[i1 + (i3 << 2) >> 2]);
       i13 = f14 < Math_fround(-1.0);
       f14 = i13 ? Math_fround(-1.0) : f14;
       i13 = f14 > Math_fround(1.0);
       f14 = Math_fround(Math_fround((i13 ? Math_fround(1.0) : f14) * Math_fround(127.0)) + Math_fround(.5));
       i13 = f14 >= Math_fround(0.0);
       f29 = Math_fround(f14 + Math_fround(-.99999994));
       HEAP8[i2 + i3 >> 0] = ~~(i13 ? f14 : f29);
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i5 >>> 0);
      if (i4) {
       i3 = i5;
       do {
        HEAP8[i2 + i3 >> 0] = (i3 | 0) == 3 ? i8 : 0;
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i7 | 0));
      }
      i1 = i1 + i15 | 0;
      if ((i1 | 0) == (i16 | 0)) break; else i2 = i2 + i6 | 0;
     }
    }
   } while (0);
   i17 = i17 + 1 | 0;
   i19 = i19 << 1;
  } while ((i17 | 0) < 8 & i19 >>> 0 <= i21 >>> 0);
 }
 if (!i18) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i28;
 return;
}

function __Z22LoadGpuProgramFromDataPKhS0_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 16 | 0;
 i16 = i20;
 i1 = __Znwj(192) | 0;
 i11 = i1 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 i14 = i1 + 20 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i1 + 24 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i1 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, gb + 63664 | 0);
 i6 = i19;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i15 = i13;
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i15 + 4 >> 2] = i10;
 i15 = i1 + 32 | 0;
 __ZN9ShaderLab22SerializedBindChannelsC2Ev(i15);
 i10 = gb + 63280 | 0;
 i6 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i16;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i16);
 i7 = i19;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i1 + 60 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = i1 + 76 | 0;
 i6 = i1 + 108 | 0;
 i7 = i1 + 120 | 0;
 i8 = i1 + 132 | 0;
 i2 = i1 + 28 | 0;
 i3 = i10;
 i4 = i3 + 116 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i6, 8);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i7, 4);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i8, 4);
 i18 = i5;
 L1 : do if ((i18 - i9 | 0) >>> 0 >= 4) {
  i2 = i9 + 4 | 0;
  if ((HEAP32[i9 >> 2] | 0) == 201608170) if ((i18 - i2 | 0) >>> 0 >= 4) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   if ((i18 - (i9 + 8) | 0) >>> 0 >= 4) if ((i18 - (i9 + 12) | 0) >>> 0 >= 4) if ((i18 - (i9 + 16) | 0) >>> 0 >= 4) if ((i18 - (i9 + 20) | 0) >>> 0 >= 4) {
    i2 = i9 + 24 | 0;
    if ((i18 - i2 | 0) >>> 0 >= 4) {
     i7 = HEAP32[i2 >> 2] | 0;
     i2 = i9 + 28 | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     HEAP32[i10 + 8 >> 2] = 0;
     HEAP32[i10 + 12 >> 2] = 0;
     HEAP32[i10 + 16 >> 2] = 0;
     HEAP32[i10 + 20 >> 2] = 0;
     HEAP32[i10 + 24 >> 2] = 0;
     HEAP32[i10 + 28 >> 2] = 0;
     if (i7) {
      i6 = i19 + 11 | 0;
      i5 = 0;
      do {
       HEAP32[i19 >> 2] = 0;
       HEAP32[i19 + 4 >> 2] = 0;
       HEAP32[i19 + 8 >> 2] = 0;
       if ((i18 - i2 | 0) >>> 0 < 4) i4 = 0; else {
        i3 = HEAP32[i2 >> 2] | 0;
        i2 = i2 + 4 | 0;
        if ((i18 - i2 | 0) >>> 0 < (i3 + 3 & -4) >>> 0) i4 = 0; else {
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i19, i2, i3) | 0;
         i9 = __ZN8keywords6CreateEPKc((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19) | 0;
         i4 = i10 + (i9 >>> 5 << 2) | 0;
         HEAP32[i4 >> 2] = 1 << (i9 & 31) | HEAP32[i4 >> 2];
         i4 = 1;
         i2 = i2 + i3 + 3 & -4;
        }
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
       i5 = i5 + 1 | 0;
       if (!i4) break L1;
      } while (i5 >>> 0 < i7 >>> 0);
     }
     if ((i18 - i2 | 0) >>> 0 >= 4) {
      i4 = HEAP32[i2 >> 2] | 0;
      i3 = i2 + 4 | 0;
      if ((i18 - i3 | 0) >>> 0 >= i4 >>> 0) {
       HEAP32[i14 >> 2] = i4;
       i2 = HEAP32[i12 >> 2] | 0;
       do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
        HEAP32[i12 >> 2] = i4;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i4, 1, i13, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i11 >> 2] = i2;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i13, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
        HEAP32[i12 >> 2] = i4;
        HEAP32[i11 >> 2] = i2;
        break;
       } else i2 = HEAP32[i11 >> 2] | 0; while (0);
       _memcpy(i2 | 0, i3 | 0, HEAP32[i14 >> 2] | 0) | 0;
       i4 = i3 + (i4 + 3 & -4) | 0;
       if ((i18 - i4 | 0) >>> 0 >= 4) {
        i7 = HEAP32[i4 >> 2] | 0;
        i2 = i4 + 4 | 0;
        if ((i18 - i2 | 0) >>> 0 >= 4) {
         i6 = HEAP32[i2 >> 2] | 0;
         i2 = i4 + 8 | 0;
         if (!i6) {
          i3 = i2;
          i2 = i4;
         } else {
          i5 = 0;
          i3 = i4;
          while (1) {
           if ((i18 - i2 | 0) >>> 0 < 4) break L1;
           i3 = i3 + 12 | 0;
           if ((i18 - i3 | 0) >>> 0 < 4) break L1;
           __ZN9ShaderLab22SerializedBindChannels4BindE13ShaderChannel15VertexComponentbP12ShaderErrors(i15, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
           i5 = i5 + 1 | 0;
           i3 = i2 + 8 | 0;
           if (i5 >>> 0 >= i6 >>> 0) break; else {
            i14 = i2;
            i2 = i3;
            i3 = i14;
           }
          }
         }
         i15 = i1 + 52 | 0;
         HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | i7;
         if ((i18 - i3 | 0) >>> 0 >= 4) {
          i15 = HEAP32[i3 >> 2] | 0;
          i2 = i2 + 12 | 0;
          L38 : do if (i15) {
           i13 = i16 + 11 | 0;
           i14 = i19 + 11 | 0;
           i12 = 0;
           L40 : while (1) {
            HEAP32[i19 >> 2] = 0;
            HEAP32[i19 + 4 >> 2] = 0;
            HEAP32[i19 + 8 >> 2] = 0;
            if ((i18 - i2 | 0) >>> 0 < 4) {
             i17 = 52;
             break;
            }
            i3 = HEAP32[i2 >> 2] | 0;
            i2 = i2 + 4 | 0;
            if ((i18 - i2 | 0) >>> 0 < (i3 + 3 & -4) >>> 0) {
             i17 = 52;
             break;
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i19, i2, i3) | 0;
            i2 = i2 + i3 + 3 & -4;
            i4 = i2;
            if ((i18 - i2 | 0) >>> 0 < 4) {
             i17 = 52;
             break;
            }
            i3 = i4 + 4 | 0;
            if (i12 | 0) __ZN9ShaderLab20SerializedSubProgram14SetConstBufferEPKci(i1, (HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, HEAP32[i2 >> 2] | 0);
            if ((i18 - i3 | 0) >>> 0 < 4) {
             i17 = 52;
             break;
            }
            i11 = HEAP32[i3 >> 2] | 0;
            i2 = i4 + 8 | 0;
            if (i11) {
             i10 = 0;
             do {
              HEAP32[i16 >> 2] = 0;
              HEAP32[i16 + 4 >> 2] = 0;
              HEAP32[i16 + 8 >> 2] = 0;
              do if ((i18 - i2 | 0) >>> 0 < 4) i3 = 2; else {
               i3 = HEAP32[i2 >> 2] | 0;
               i2 = i2 + 4 | 0;
               if ((i18 - i2 | 0) >>> 0 < (i3 + 3 & -4) >>> 0) {
                i3 = 2;
                break;
               }
               __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i16, i2, i3) | 0;
               i3 = i2 + i3 + 3 & -4;
               i2 = i3;
               if ((i18 - i3 | 0) >>> 0 < 4) {
                i3 = 2;
                break;
               }
               i9 = HEAP32[i3 >> 2] | 0;
               i3 = i2 + 4 | 0;
               if ((i18 - i3 | 0) >>> 0 < 4) {
                i2 = i3;
                i3 = 2;
                break;
               }
               i6 = HEAP32[i3 >> 2] | 0;
               i7 = i2 + 8 | 0;
               if ((i18 - i7 | 0) >>> 0 < 4) {
                i2 = i7;
                i3 = 2;
                break;
               }
               i8 = i2 + 12 | 0;
               if ((i18 - i8 | 0) >>> 0 < 4) {
                i2 = i8;
                i3 = 2;
                break;
               }
               i3 = i2 + 16 | 0;
               if ((i18 - i3 | 0) >>> 0 < 4) {
                i2 = i3;
                i3 = 2;
                break;
               }
               i5 = HEAP32[i3 >> 2] | 0;
               i3 = i2 + 20 | 0;
               if ((i18 - i3 | 0) >>> 0 < 4) {
                i2 = i3;
                i3 = 2;
                break;
               }
               i4 = HEAP32[i3 >> 2] | 0;
               i2 = i2 + 24 | 0;
               i3 = (HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16;
               if (!(HEAP32[i8 >> 2] | 0)) {
                __ZN9ShaderLab20SerializedSubProgram14AddVectorParamEPKcii15ShaderParamTypei(i1, i3, i4, i5, i9, HEAP32[i7 >> 2] | 0);
                i3 = 0;
                break;
               } else {
                __ZN9ShaderLab20SerializedSubProgram14AddMatrixParamEPKcii15ShaderParamTypei(i1, i3, i4, i5, i9, i6);
                i3 = 0;
                break;
               }
              } while (0);
              __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
              i10 = i10 + 1 | 0;
              if (i3 | 0) break L40;
             } while (i10 >>> 0 < i11 >>> 0);
            }
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
            i12 = i12 + 1 | 0;
            if (i12 >>> 0 >= i15 >>> 0) break L38;
           }
           if ((i17 | 0) == 52) {
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
            break L1;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
           if ((i3 | 0) == 2) break L1; else i1 = 0;
           STACKTOP = i20;
           return i1 | 0;
          } while (0);
          if ((i18 - i2 | 0) >>> 0 >= 4) {
           i7 = HEAP32[i2 >> 2] | 0;
           if (!i7) {
            i19 = i1;
            STACKTOP = i20;
            return i19 | 0;
           }
           i8 = i19 + 11 | 0;
           i6 = 0;
           i2 = i2 + 4 | 0;
           do {
            HEAP32[i19 >> 2] = 0;
            HEAP32[i19 + 4 >> 2] = 0;
            HEAP32[i19 + 8 >> 2] = 0;
            L78 : do if ((i18 - i2 | 0) >>> 0 < 4) i4 = 0; else {
             i3 = HEAP32[i2 >> 2] | 0;
             i2 = i2 + 4 | 0;
             if ((i18 - i2 | 0) >>> 0 < (i3 + 3 & -4) >>> 0) {
              i4 = 0;
              break;
             }
             __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i19, i2, i3) | 0;
             i5 = i2 + i3 + 3 & -4;
             i2 = i5;
             if ((i18 - i5 | 0) >>> 0 < 4) {
              i4 = 0;
              break;
             }
             i3 = i2 + 4 | 0;
             if ((i18 - i3 | 0) >>> 0 < 4) {
              i4 = 0;
              i2 = i3;
              break;
             }
             i4 = HEAP32[i3 >> 2] | 0;
             i3 = i2 + 8 | 0;
             if ((i18 - i3 | 0) >>> 0 < 4) {
              i4 = 0;
              i2 = i3;
              break;
             }
             i3 = HEAP32[i3 >> 2] | 0;
             i2 = i2 + 12 | 0;
             switch (HEAP32[i5 >> 2] | 0) {
             case 0:
              {
               i17 = i3 >>> 8;
               __ZN9ShaderLab20SerializedSubProgram15AddTextureParamEPKcii16TextureDimension(i1, (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, i4, (i17 | 0) == 16777215 ? -1 : i17, i3 & 255);
               i4 = 1;
               break L78;
              }
             case 1:
              {
               __ZN9ShaderLab20SerializedSubProgram6BindCBEPKci(i1, (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, i4);
               i4 = 1;
               break L78;
              }
             case 2:
              {
               __ZN9ShaderLab20SerializedSubProgram14AddBufferParamEPKci(i1, (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, i4);
               i4 = 1;
               break L78;
              }
             case 3:
              {
               __ZN9ShaderLab20SerializedSubProgram11AddUAVParamEPKcii(i1, (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, i4, i3);
               i4 = 1;
               break L78;
              }
             default:
              {
               i4 = 1;
               break L78;
              }
             }
            } while (0);
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
            i6 = i6 + 1 | 0;
            if (!i4) break L1;
           } while (i6 >>> 0 < i7 >>> 0);
           STACKTOP = i20;
           return i1 | 0;
          }
         }
        }
       }
      }
     }
    }
   }
  }
 } while (0);
 __ZN9ShaderLab20SerializedSubProgramD2Ev(i1);
 __ZdlPv(i1);
 i19 = 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState(i29, i23, i15, i3, i1) {
 i29 = i29 | 0;
 i23 = i23 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i42 + 104 | 0;
 i40 = i42 + 96 | 0;
 i2 = i42 + 100 | 0;
 i41 = i42 + 56 | 0;
 i37 = i42 + 40 | 0;
 i25 = i42 + 20 | 0;
 i24 = i42 + 16 | 0;
 i18 = i42;
 i19 = i42 + 88 | 0;
 i20 = i42 + 80 | 0;
 i21 = i42 + 72 | 0;
 i30 = i42 + 24 | 0;
 f31 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i23 + 44 >> 2]));
 f32 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f32 = Math_fround(f32 * Math_fround(HEAPF32[i23 + 48 >> 2]));
 f33 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f33 = Math_fround(f33 * Math_fround(HEAPF32[i23 + 52 >> 2]));
 f27 = Math_fround(HEAPF32[i23 + 24 >> 2]);
 f27 = Math_fround(f27 * Math_fround(HEAPF32[i23 + 56 >> 2]));
 f34 = Math_fround(f31 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f35 = Math_fround(f32 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f36 = Math_fround(f33 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f28 = Math_fround(f27 * Math_fround(HEAPF32[i1 + 16 >> 2]));
 i16 = (HEAP32[i23 + 60 >> 2] | 0) == 0;
 f11 = Math_fround(f28 * Math_fround(.5));
 f12 = Math_fround(f27 * Math_fround(.5));
 f28 = i16 ? f11 : f28;
 f27 = i16 ? f12 : f27;
 i16 = i29 + 256 | 0;
 if ((HEAP32[i16 >> 2] | 0) == 2) {
  i26 = 0;
  i14 = 0;
  i13 = 0;
 } else if (!(HEAP32[i3 + 4 >> 2] | 0)) {
  i26 = 0;
  i14 = 0;
  i13 = 0;
 } else {
  i1 = f34 < Math_fround(0.0);
  f12 = i1 ? Math_fround(0.0) : f34;
  i1 = f12 > Math_fround(1.0);
  HEAP8[i2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f35 < Math_fround(0.0);
  f12 = i1 ? Math_fround(0.0) : f35;
  i1 = f12 > Math_fround(1.0);
  HEAP8[i2 + 1 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f36 < Math_fround(0.0);
  f12 = i1 ? Math_fround(0.0) : f36;
  i1 = f12 > Math_fround(1.0);
  HEAP8[i2 + 2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f28 < Math_fround(0.0);
  f12 = i1 ? Math_fround(0.0) : f28;
  i1 = f12 > Math_fround(1.0);
  HEAP8[i2 + 3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  HEAP32[i39 >> 2] = HEAP32[i2 >> 2];
  i1 = __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent11ColorRGBA32(i29, i15, i3, i39) | 0;
  if (!i1) {
   i26 = 0;
   i14 = 0;
   i13 = 0;
  } else {
   i26 = i1;
   i14 = HEAP32[i1 + 16 >> 2] | 0;
   i13 = HEAP32[i1 + 20 >> 2] | 0;
  }
 }
 i8 = i3 + 40 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if (!i1) {
  i22 = 0;
  i1 = 0;
  i2 = 0;
 } else {
  HEAP32[i40 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i38 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i39, i1, i40);
    i2 = HEAP32[i39 >> 2] | 0;
    i22 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i38 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i38 = 13;
   }
  }
  if ((i38 | 0) == 11) i38 = 13;
  if ((i38 | 0) == 13) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
   if (!i1) {
    i22 = 0;
    i1 = 0;
    i2 = 0;
    break;
   }
  }
  if ((HEAP32[i16 >> 2] | 0) == 3) {
   i22 = i1;
   i1 = 0;
   i2 = 0;
  } else {
   f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
   f12 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = i1;
   i1 = i2;
   i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  }
 } while (0);
 i8 = i41 + 8 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 i17 = i37 + 8 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f6 = Math_fround(f4 + Math_fround(HEAP32[i29 + 208 >> 2] | 0));
 f5 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f7 = Math_fround(f5 + Math_fround(HEAP32[i29 + 216 >> 2] | 0));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i15 + 8 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAP32[i29 + 212 >> 2] | 0));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i15 + 12 >> 2]));
 f4 = Math_fround(f4 - f6);
 f5 = Math_fround(Math_fround(f5 - Math_fround(HEAP32[i29 + 220 >> 2] | 0)) - f7);
 HEAPF32[i18 >> 2] = f6;
 HEAPF32[i18 + 8 >> 2] = f4;
 HEAPF32[i18 + 4 >> 2] = f7;
 HEAPF32[i18 + 12 >> 2] = f5;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i19 + 4 >> 2] = i2;
 HEAP32[i20 >> 2] = i14;
 HEAP32[i20 + 4 >> 2] = i13;
 i15 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i29 + 244 >> 2] | 0;
 i1 = i29 + 260 | 0;
 HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
 i2 = i29 + 264 | 0;
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 >> 2];
 __ZN8GUIStyle16CalcContentRectsERK5RectTIfE8Vector2fS4_RS1_S5_RfS6_iiS4_(i18, i19, i20, i41, i37, i25, i24, i15, i16, i21);
 f10 = Math_fround(HEAPF32[i23 + 252 >> 2]);
 f12 = Math_fround(HEAPF32[i23 + 256 >> 2]);
 f11 = Math_fround(HEAPF32[i23 + 260 >> 2]);
 f9 = Math_fround(HEAPF32[i23 + 264 >> 2]);
 do if (!(HEAP32[i29 + 252 >> 2] | 0)) i38 = 20; else {
  i25 = Math_fround(HEAPF32[i25 >> 2]) > f4;
  if (i25 | Math_fround(HEAPF32[i24 >> 2]) > f5) {
   f46 = Math_fround(HEAPF32[i1 >> 2]);
   f46 = Math_fround(f6 + Math_fround(f46 + Math_fround(HEAPF32[i29 + 268 >> 2])));
   f45 = Math_fround(HEAPF32[i2 >> 2]);
   f45 = Math_fround(f7 + Math_fround(f45 + Math_fround(HEAPF32[i29 + 272 >> 2])));
   f7 = Math_fround(f4 + f46);
   f6 = Math_fround(f5 + f45);
   f44 = Math_fround(f10 + f11);
   f43 = Math_fround(f12 + f9);
   f4 = f46 < f10 ? f10 : f46;
   f5 = f45 < f12 ? f12 : f45;
   f7 = Math_fround((f7 > f44 ? f44 : f7) - f4);
   i25 = f7 < Math_fround(0.0);
   f7 = i25 ? Math_fround(0.0) : f7;
   f6 = Math_fround((f6 > f43 ? f43 : f6) - f5);
   i25 = f6 < Math_fround(0.0);
   f6 = i25 ? Math_fround(0.0) : f6;
   if (f7 == Math_fround(0.0) | f6 == Math_fround(0.0)) {
    STACKTOP = i42;
    return;
   } else {
    HEAPF32[gb + 1468288 >> 2] = f4;
    HEAPF32[gb + 1468288 + 4 >> 2] = f5;
    HEAPF32[gb + 1468288 + 8 >> 2] = f7;
    HEAPF32[gb + 1468288 + 12 >> 2] = f6;
    __ZN10Matrix4x4f11SetIdentityEv(i39) | 0;
    i1 = f7 > Math_fround(0.0);
    f45 = Math_fround(Math_fround(.875) / f7);
    f45 = i1 ? f45 : Math_fround(inf);
    HEAPF32[i39 >> 2] = f45;
    i1 = f6 > Math_fround(0.0);
    f46 = Math_fround(Math_fround(.875) / f6);
    f46 = i1 ? f46 : Math_fround(inf);
    HEAPF32[i39 + 20 >> 2] = f46;
    HEAPF32[i39 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f4 * f45));
    HEAPF32[i39 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f5 * f46));
    HEAPF32[i39 + 40 >> 2] = Math_fround(0.0);
    HEAPF32[i39 + 60 >> 2] = Math_fround(1.0);
    HEAPF32[i39 + 56 >> 2] = Math_fround(1.0);
    i1 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
    i2 = i39;
    i3 = i1 + 64 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    i2 = 1;
    break;
   }
  } else i38 = 20;
 } while (0);
 if ((i38 | 0) == 20) {
  HEAPF32[gb + 1468288 >> 2] = f10;
  HEAPF32[gb + 1468288 + 4 >> 2] = f12;
  HEAPF32[gb + 1468288 + 8 >> 2] = f11;
  HEAPF32[gb + 1468288 + 12 >> 2] = f9;
  __ZN10Matrix4x4f11SetIdentityEv(i39) | 0;
  i1 = f11 > Math_fround(0.0);
  f45 = Math_fround(Math_fround(.875) / f11);
  f45 = i1 ? f45 : Math_fround(inf);
  HEAPF32[i39 >> 2] = f45;
  i1 = f9 > Math_fround(0.0);
  f46 = Math_fround(Math_fround(.875) / f9);
  f46 = i1 ? f46 : Math_fround(inf);
  HEAPF32[i39 + 20 >> 2] = f46;
  HEAPF32[i39 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f10 * f45));
  HEAPF32[i39 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f12 * f46));
  HEAPF32[i39 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i39 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i39 + 56 >> 2] = Math_fround(1.0);
  i1 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
  i2 = i39;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i2 = 0;
 }
 if (i26 | 0 ? Math_fround(HEAPF32[i17 >> 2]) != Math_fround(0.0) : 0) {
  HEAPF32[i30 >> 2] = f34;
  HEAPF32[i30 + 4 >> 2] = f35;
  HEAPF32[i30 + 8 >> 2] = f36;
  HEAPF32[i30 + 12 >> 2] = f28;
  HEAP32[i39 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i39 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  __ZNK8GUIStyle10RenderTextERK5RectTIfERN13TextRendering17TextMeshGeneratorE10ColorRGBAf(i29, i37, i26, i39);
 }
 if (Math_fround(HEAPF32[i8 >> 2]) != Math_fround(0.0)) {
  i1 = f31 < Math_fround(0.0);
  f46 = i1 ? Math_fround(0.0) : f31;
  i1 = f46 > Math_fround(1.0);
  HEAP8[i40 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f46) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f32 < Math_fround(0.0);
  f46 = i1 ? Math_fround(0.0) : f32;
  i1 = f46 > Math_fround(1.0);
  HEAP8[i40 + 1 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f46) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f33 < Math_fround(0.0);
  f46 = i1 ? Math_fround(0.0) : f33;
  i1 = f46 > Math_fround(1.0);
  HEAP8[i40 + 2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f46) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f27 < Math_fround(0.0);
  f46 = i1 ? Math_fround(0.0) : f27;
  i1 = f46 > Math_fround(1.0);
  HEAP8[i40 + 3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f46) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = HEAP32[gb + 1468864 >> 2] | 0;
  if (!i1) {
   i1 = __Z15GetScriptMapperv() | 0;
   HEAP32[i39 >> 2] = 0;
   HEAP32[i39 + 4 >> 2] = 0;
   HEAP32[i39 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i39, gb + 1017441 | 0, 30);
   i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i39) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
   i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
   HEAP32[gb + 1468864 >> 2] = i1;
   __Z24InitializeGUIClipTexturev();
   i1 = HEAP32[gb + 1468864 >> 2] | 0;
  };
  HEAP32[i39 >> 2] = HEAP32[i40 >> 2];
  __Z14DrawGUITextureRK5RectTIfEP7Textureiiii11ColorRGBA32P8Materiali(i41, i22, 0, 0, 0, 0, i39, i1, -1);
 }
 if (!i2) {
  STACKTOP = i42;
  return;
 }
 HEAPF32[gb + 1468288 >> 2] = f10;
 HEAPF32[gb + 1468288 + 4 >> 2] = f12;
 HEAPF32[gb + 1468288 + 8 >> 2] = f11;
 HEAPF32[gb + 1468288 + 12 >> 2] = f9;
 __ZN10Matrix4x4f11SetIdentityEv(i39) | 0;
 i1 = f11 > Math_fround(0.0);
 f45 = Math_fround(Math_fround(.875) / f11);
 f45 = i1 ? f45 : Math_fround(inf);
 HEAPF32[i39 >> 2] = f45;
 i1 = f9 > Math_fround(0.0);
 f46 = Math_fround(Math_fround(.875) / f9);
 f46 = i1 ? f46 : Math_fround(inf);
 HEAPF32[i39 + 20 >> 2] = f46;
 HEAPF32[i39 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f10 * f45));
 HEAPF32[i39 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f12 * f46));
 HEAPF32[i39 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i39 + 56 >> 2] = Math_fround(1.0);
 i1 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i2 = i39;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i42;
 return;
}

function __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i2, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i25 = i2;
 L1 : while (1) {
  i15 = i25;
  i20 = i25 + -28 | 0;
  i21 = i25 + -24 | 0;
  i22 = i25 + -12 | 0;
  i16 = i25 + -20 | 0;
  i17 = i25 + -16 | 0;
  i18 = i25 + -8 | 0;
  i19 = i25 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i2 = i15 - i14 | 0;
    switch ((i2 | 0) / 28 | 0 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 7;
      break L1;
     }
    case 4:
     {
      i23 = 8;
      break L1;
     }
    case 5:
     {
      i23 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 196) {
     i23 = 11;
     break L1;
    }
    i3 = (i2 >>> 0) / 56 | 0;
    i9 = i1 + (i3 * 28 | 0) | 0;
    if ((i2 | 0) > 27972) {
     i2 = (i2 >>> 0) / 112 | 0;
     i2 = __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 * 28 | 0) | 0, i9, i9 + (i2 * 28 | 0) | 0, i20, i24) | 0;
    } else i2 = __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i9, i20, i24) | 0;
    i11 = i1 + 4 | 0;
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    i12 = i1 + 16 | 0;
    f7 = Math_fround(HEAPF32[i12 >> 2]);
    f13 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i1 + (i3 * 28 | 0) + 4 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i3 * 28 | 0) + 16 >> 2])) * Math_fround(.5));
    if (f13 < f4) {
     i3 = i20;
     break;
    } else i6 = i20;
    while (1) {
     i3 = i6 + -28 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i8 = i6 + -24 | 0;
     f26 = Math_fround(HEAPF32[i8 >> 2]);
     i10 = i6 + -12 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5)) < f4) {
      i23 = 35;
      break L5;
     } else i6 = i3;
    }
    i1 = i1 + 28 | 0;
    f26 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f13 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5)))) {
     if ((i1 | 0) == (i20 | 0)) {
      i23 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
      if (f13 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i1 = i1 + 28 | 0;
      if ((i1 | 0) == (i20 | 0)) {
       i23 = 52;
       break L1;
      }
     }
     i6 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i1 + 8 >> 2] | 0;
     i9 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = HEAP32[i1 + 20 >> 2] | 0;
     i14 = HEAP32[i1 + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i20 >> 2] = i6;
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i16 >> 2] = i8;
     HEAP32[i17 >> 2] = i9;
     HEAPF32[i22 >> 2] = f5;
     HEAP32[i18 >> 2] = i10;
     HEAP32[i19 >> 2] = i14;
     i1 = i1 + 28 | 0;
    }
    if ((i1 | 0) == (i20 | 0)) {
     i23 = 52;
     break L1;
    } else i2 = i20;
    while (1) {
     f7 = Math_fround(HEAPF32[i11 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i12 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
      i9 = i1 + 28 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i1 = i9;
     }
     while (1) {
      i3 = i2 + -28 | 0;
      i6 = i2 + -24 | 0;
      f26 = Math_fround(HEAPF32[i6 >> 2]);
      i8 = i2 + -12 | 0;
      if (f7 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5))) i2 = i3; else break;
     }
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     i29 = HEAP32[i1 >> 2] | 0;
     i28 = HEAP32[i1 + 8 >> 2] | 0;
     i27 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = HEAP32[i1 + 20 >> 2] | 0;
     i14 = HEAP32[i1 + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i3 >> 2] = i29;
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i2 + -20 >> 2] = i28;
     HEAP32[i2 + -16 >> 2] = i27;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i2 + -8 >> 2] = i10;
     HEAP32[i2 + -4 >> 2] = i14;
     i2 = i3;
     i1 = i9;
    }
   }
   if ((i23 | 0) == 35) {
    i23 = 0;
    i11 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    i27 = HEAP32[i1 + 12 >> 2] | 0;
    i28 = HEAP32[i1 + 20 >> 2] | 0;
    i29 = HEAP32[i1 + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i3 >> 2] = i11;
    HEAPF32[i8 >> 2] = f5;
    HEAP32[i6 + -20 >> 2] = i12;
    HEAP32[i6 + -16 >> 2] = i27;
    HEAPF32[i10 >> 2] = f7;
    HEAP32[i6 + -8 >> 2] = i28;
    HEAP32[i6 + -4 >> 2] = i29;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 28 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i9 + 4 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
     i12 = i6 + 28 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i12; else break;
    }
    while (1) {
     i8 = i3 + -28 | 0;
     i10 = i3 + -24 | 0;
     f26 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = i3 + -12 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) break L35;
    i31 = HEAP32[i6 >> 2] | 0;
    i30 = HEAP32[i6 + 8 >> 2] | 0;
    i27 = HEAP32[i6 + 12 >> 2] | 0;
    i28 = HEAP32[i6 + 20 >> 2] | 0;
    i29 = HEAP32[i6 + 24 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i8 >> 2] = i31;
    HEAPF32[i10 >> 2] = f4;
    HEAP32[i3 + -20 >> 2] = i30;
    HEAP32[i3 + -16 >> 2] = i27;
    HEAPF32[i11 >> 2] = f5;
    HEAP32[i3 + -8 >> 2] = i28;
    HEAP32[i3 + -4 >> 2] = i29;
    i9 = (i9 | 0) == (i6 | 0) ? i8 : i9;
    i3 = i8;
    i6 = i12;
    i2 = i2 + 1 | 0;
   } while (0);
   if ((i6 | 0) != (i9 | 0)) {
    i3 = i9 + 4 | 0;
    f26 = Math_fround(HEAPF32[i3 >> 2]);
    i8 = i9 + 16 | 0;
    f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
    if (f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i27 = HEAP32[i6 >> 2] | 0;
     i28 = HEAP32[i6 + 8 >> 2] | 0;
     i29 = HEAP32[i6 + 12 >> 2] | 0;
     i30 = HEAP32[i6 + 20 >> 2] | 0;
     i31 = HEAP32[i6 + 24 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i9 >> 2] = i27;
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i9 + 8 >> 2] = i28;
     HEAP32[i9 + 12 >> 2] = i29;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i9 + 20 >> 2] = i30;
     HEAP32[i9 + 24 >> 2] = i31;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeYSorterP16DetailMeshBVNodeEEbT0_S5_T_(i1, i6, i24) | 0;
    i3 = i6 + 28 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR17DetailNodeYSorterP16DetailMeshBVNodeEEbT0_S5_T_(i3, i25, i24) | 0) {
     i23 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i31 = i6;
   if ((i31 - i14 | 0) >= (i15 - i31 | 0)) {
    i23 = 50;
    break;
   }
   __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i6, i24);
   i1 = i6 + 28 | 0;
  }
  if ((i23 | 0) == 50) {
   i23 = 0;
   __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_(i6 + 28 | 0, i25, i24);
   i25 = i6;
   continue;
  } else if ((i23 | 0) == 51) {
   i23 = 0;
   if (i2) {
    i23 = 52;
    break;
   } else {
    i25 = i6;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  if (!(f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i27 = HEAP32[i1 >> 2] | 0;
  i28 = HEAP32[i1 + 8 >> 2] | 0;
  i29 = HEAP32[i1 + 12 >> 2] | 0;
  i30 = HEAP32[i1 + 20 >> 2] | 0;
  i31 = HEAP32[i1 + 24 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i20 >> 2] = i27;
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i16 >> 2] = i28;
  HEAP32[i17 >> 2] = i29;
  HEAPF32[i22 >> 2] = f5;
  HEAP32[i18 >> 2] = i30;
  HEAP32[i19 >> 2] = i31;
  return;
 } else if ((i23 | 0) == 7) {
  __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 8) {
  __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 9) {
  __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i1 + 84 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 11) {
  i3 = i1 + 56 | 0;
  __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i3, i24) | 0;
  i2 = i1 + 84 | 0;
  if ((i2 | 0) == (i25 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f26 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + 16 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i2 + 8 >> 2] | 0;
    i10 = HEAP32[i2 + 12 >> 2] | 0;
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    i12 = HEAP32[i2 + 24 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     f26 = Math_fround(HEAPF32[i3 + -24 >> 2]);
     if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + -12 >> 2])) * Math_fround(.5))) {
      i6 = i3;
      i3 = i3 + -28 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i8;
    HEAPF32[i3 + 4 >> 2] = f5;
    HEAP32[i3 + 8 >> 2] = i9;
    HEAP32[i3 + 12 >> 2] = i10;
    HEAPF32[i3 + 16 >> 2] = f7;
    HEAP32[i3 + 20 >> 2] = i11;
    HEAP32[i3 + 24 >> 2] = i12;
   }
   i3 = i2 + 28 | 0;
   if ((i3 | 0) == (i25 | 0)) break; else {
    i31 = i2;
    i2 = i3;
    i3 = i31;
   }
  }
  return;
 } else if ((i23 | 0) == 52) return;
}

function __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i2, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i25 = i2;
 L1 : while (1) {
  i15 = i25;
  i20 = i25 + -28 | 0;
  i21 = i25 + -20 | 0;
  i22 = i25 + -8 | 0;
  i16 = i25 + -24 | 0;
  i17 = i25 + -16 | 0;
  i18 = i25 + -12 | 0;
  i19 = i25 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i2 = i15 - i14 | 0;
    switch ((i2 | 0) / 28 | 0 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 7;
      break L1;
     }
    case 4:
     {
      i23 = 8;
      break L1;
     }
    case 5:
     {
      i23 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 196) {
     i23 = 11;
     break L1;
    }
    i3 = (i2 >>> 0) / 56 | 0;
    i9 = i1 + (i3 * 28 | 0) | 0;
    if ((i2 | 0) > 27972) {
     i2 = (i2 >>> 0) / 112 | 0;
     i2 = __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 * 28 | 0) | 0, i9, i9 + (i2 * 28 | 0) | 0, i20, i24) | 0;
    } else i2 = __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i9, i20, i24) | 0;
    i11 = i1 + 8 | 0;
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    i12 = i1 + 20 | 0;
    f7 = Math_fround(HEAPF32[i12 >> 2]);
    f13 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i1 + (i3 * 28 | 0) + 8 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i3 * 28 | 0) + 20 >> 2])) * Math_fround(.5));
    if (f13 < f4) {
     i3 = i20;
     break;
    } else i6 = i20;
    while (1) {
     i3 = i6 + -28 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i8 = i6 + -20 | 0;
     f26 = Math_fround(HEAPF32[i8 >> 2]);
     i10 = i6 + -8 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5)) < f4) {
      i23 = 35;
      break L5;
     } else i6 = i3;
    }
    i1 = i1 + 28 | 0;
    f26 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f13 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5)))) {
     if ((i1 | 0) == (i20 | 0)) {
      i23 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
      if (f13 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i1 = i1 + 28 | 0;
      if ((i1 | 0) == (i20 | 0)) {
       i23 = 52;
       break L1;
      }
     }
     i6 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i1 + 4 >> 2] | 0;
     i9 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = HEAP32[i1 + 16 >> 2] | 0;
     i14 = HEAP32[i1 + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i20 >> 2] = i6;
     HEAP32[i16 >> 2] = i8;
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i17 >> 2] = i9;
     HEAP32[i18 >> 2] = i10;
     HEAPF32[i22 >> 2] = f5;
     HEAP32[i19 >> 2] = i14;
     i1 = i1 + 28 | 0;
    }
    if ((i1 | 0) == (i20 | 0)) {
     i23 = 52;
     break L1;
    } else i2 = i20;
    while (1) {
     f7 = Math_fround(HEAPF32[i11 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i12 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
      f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
      i9 = i1 + 28 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i1 = i9;
     }
     while (1) {
      i3 = i2 + -28 | 0;
      i6 = i2 + -20 | 0;
      f26 = Math_fround(HEAPF32[i6 >> 2]);
      i8 = i2 + -8 | 0;
      if (f7 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5))) i2 = i3; else break;
     }
     if (i1 >>> 0 >= i3 >>> 0) continue L5;
     i29 = HEAP32[i1 >> 2] | 0;
     i28 = HEAP32[i1 + 4 >> 2] | 0;
     i27 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = HEAP32[i1 + 16 >> 2] | 0;
     i14 = HEAP32[i1 + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i3 >> 2] = i29;
     HEAP32[i2 + -24 >> 2] = i28;
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i2 + -16 >> 2] = i27;
     HEAP32[i2 + -12 >> 2] = i10;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i2 + -4 >> 2] = i14;
     i2 = i3;
     i1 = i9;
    }
   }
   if ((i23 | 0) == 35) {
    i23 = 0;
    i11 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i1 + 4 >> 2] | 0;
    i27 = HEAP32[i1 + 12 >> 2] | 0;
    i28 = HEAP32[i1 + 16 >> 2] | 0;
    i29 = HEAP32[i1 + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i3 >> 2] = i11;
    HEAP32[i6 + -24 >> 2] = i12;
    HEAPF32[i8 >> 2] = f5;
    HEAP32[i6 + -16 >> 2] = i27;
    HEAP32[i6 + -12 >> 2] = i28;
    HEAPF32[i10 >> 2] = f7;
    HEAP32[i6 + -4 >> 2] = i29;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 28 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 + 20 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 20 >> 2]);
     i12 = i6 + 28 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i12; else break;
    }
    while (1) {
     i8 = i3 + -28 | 0;
     i10 = i3 + -20 | 0;
     f26 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = i3 + -8 | 0;
     if (Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) break L35;
    i31 = HEAP32[i6 >> 2] | 0;
    i30 = HEAP32[i6 + 4 >> 2] | 0;
    i27 = HEAP32[i6 + 12 >> 2] | 0;
    i28 = HEAP32[i6 + 16 >> 2] | 0;
    i29 = HEAP32[i6 + 24 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i8 >> 2] = i31;
    HEAP32[i3 + -24 >> 2] = i30;
    HEAPF32[i10 >> 2] = f4;
    HEAP32[i3 + -16 >> 2] = i27;
    HEAP32[i3 + -12 >> 2] = i28;
    HEAPF32[i11 >> 2] = f5;
    HEAP32[i3 + -4 >> 2] = i29;
    i9 = (i9 | 0) == (i6 | 0) ? i8 : i9;
    i3 = i8;
    i6 = i12;
    i2 = i2 + 1 | 0;
   } while (0);
   if ((i6 | 0) != (i9 | 0)) {
    i3 = i9 + 8 | 0;
    f26 = Math_fround(HEAPF32[i3 >> 2]);
    i8 = i9 + 20 | 0;
    f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 20 >> 2]);
    if (f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i27 = HEAP32[i6 >> 2] | 0;
     i28 = HEAP32[i6 + 4 >> 2] | 0;
     i29 = HEAP32[i6 + 12 >> 2] | 0;
     i30 = HEAP32[i6 + 16 >> 2] | 0;
     i31 = HEAP32[i6 + 24 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i9 >> 2] = i27;
     HEAP32[i9 + 4 >> 2] = i28;
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i9 + 12 >> 2] = i29;
     HEAP32[i9 + 16 >> 2] = i30;
     HEAPF32[i8 >> 2] = f5;
     HEAP32[i9 + 24 >> 2] = i31;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeZSorterP16DetailMeshBVNodeEEbT0_S5_T_(i1, i6, i24) | 0;
    i3 = i6 + 28 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR17DetailNodeZSorterP16DetailMeshBVNodeEEbT0_S5_T_(i3, i25, i24) | 0) {
     i23 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i31 = i6;
   if ((i31 - i14 | 0) >= (i15 - i31 | 0)) {
    i23 = 50;
    break;
   }
   __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i6, i24);
   i1 = i6 + 28 | 0;
  }
  if ((i23 | 0) == 50) {
   i23 = 0;
   __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_(i6 + 28 | 0, i25, i24);
   i25 = i6;
   continue;
  } else if ((i23 | 0) == 51) {
   i23 = 0;
   if (i2) {
    i23 = 52;
    break;
   } else {
    i25 = i6;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  f26 = Math_fround(HEAPF32[i21 >> 2]);
  f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i22 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  if (!(f26 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i27 = HEAP32[i1 >> 2] | 0;
  i28 = HEAP32[i1 + 4 >> 2] | 0;
  i29 = HEAP32[i1 + 12 >> 2] | 0;
  i30 = HEAP32[i1 + 16 >> 2] | 0;
  i31 = HEAP32[i1 + 24 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i20 >> 2] = i27;
  HEAP32[i16 >> 2] = i28;
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i17 >> 2] = i29;
  HEAP32[i18 >> 2] = i30;
  HEAPF32[i22 >> 2] = f5;
  HEAP32[i19 >> 2] = i31;
  return;
 } else if ((i23 | 0) == 7) {
  __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 8) {
  __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 9) {
  __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i1 + 84 | 0, i20, i24) | 0;
  return;
 } else if ((i23 | 0) == 11) {
  i3 = i1 + 56 | 0;
  __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i3, i24) | 0;
  i2 = i1 + 84 | 0;
  if ((i2 | 0) == (i25 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f26 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = HEAP32[i2 + 12 >> 2] | 0;
    i11 = HEAP32[i2 + 16 >> 2] | 0;
    i12 = HEAP32[i2 + 24 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     f26 = Math_fround(HEAPF32[i3 + -20 >> 2]);
     if (f4 < Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i3 + -8 >> 2])) * Math_fround(.5))) {
      i6 = i3;
      i3 = i3 + -28 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i8;
    HEAP32[i3 + 4 >> 2] = i9;
    HEAPF32[i3 + 8 >> 2] = f5;
    HEAP32[i3 + 12 >> 2] = i10;
    HEAP32[i3 + 16 >> 2] = i11;
    HEAPF32[i3 + 20 >> 2] = f7;
    HEAP32[i3 + 24 >> 2] = i12;
   }
   i3 = i2 + 28 | 0;
   if ((i3 | 0) == (i25 | 0)) break; else {
    i31 = i2;
    i2 = i3;
    i3 = i31;
   }
  }
  return;
 } else if ((i23 | 0) == 52) return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_17ScaleBiasIteratorIS2_PKS2_EEEEvRT_RS6_(i5, i32, i42) {
 i5 = i5 | 0;
 i32 = i32 | 0;
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i31 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i41 = i31 + (i1 << 4) | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 i2 = i5 + 604 | 0;
 f33 = Math_fround(HEAPF32[i32 >> 2]);
 f34 = Math_fround(HEAPF32[i32 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i32 + 8 >> 2]);
 f36 = Math_fround(HEAPF32[i32 + 12 >> 2]);
 f37 = Math_fround(HEAPF32[i32 + 16 >> 2]);
 f38 = Math_fround(HEAPF32[i32 + 20 >> 2]);
 f39 = Math_fround(HEAPF32[i32 + 24 >> 2]);
 f40 = Math_fround(HEAPF32[i32 + 28 >> 2]);
 i1 = (i1 | 0) == 0;
 if (!(HEAP8[i5 + 728 >> 0] | 0)) {
  if (i1) return;
  f9 = Math_fround(HEAPF32[i5 + 616 >> 2]);
  f10 = Math_fround(HEAPF32[i5 + 612 >> 2]);
  f8 = Math_fround(HEAPF32[i5 + 608 >> 2]);
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  i5 = i42 + 4 | 0;
  i6 = i42 + 8 | 0;
  i7 = i42 + 12 | 0;
  i2 = i31;
  i1 = HEAP32[i32 + 32 >> 2] | 0;
  while (1) {
   i52 = HEAP32[i2 >> 2] | 0;
   i58 = i2 + 4 | 0;
   i55 = HEAP32[i58 >> 2] | 0;
   i57 = i2 + 8 | 0;
   i54 = HEAP32[i57 >> 2] | 0;
   i56 = i2 + 12 | 0;
   i53 = HEAP32[i56 >> 2] | 0;
   i61 = HEAP32[i3 >> 2] | 0;
   i43 = i3 + 4 | 0;
   i60 = HEAP32[i43 >> 2] | 0;
   i31 = i3 + 8 | 0;
   i59 = HEAP32[i31 >> 2] | 0;
   i32 = i3 + 12 | 0;
   i50 = HEAP32[i32 >> 2] | 0;
   f27 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f20 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f21 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f22 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   f25 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i51 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f22;
   i52 = f25 > f27 ? i61 ^ i52 : 0;
   i55 = f23 > f20 ? i60 ^ i55 : 0;
   i54 = f24 > f21 ? i59 ^ i54 : 0;
   i53 = i51 ? i50 ^ i53 : 0;
   i51 = i52 ^ i61;
   i49 = i55 ^ i60;
   i47 = i54 ^ i59;
   i45 = i53 ^ i50;
   f21 = Math_fround(HEAPF32[gb + 1097536 >> 2]);
   f24 = Math_fround(HEAPF32[gb + 1097536 + 4 >> 2]);
   f20 = Math_fround(HEAPF32[gb + 1097536 + 8 >> 2]);
   f23 = Math_fround(HEAPF32[gb + 1097536 + 12 >> 2]);
   f27 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i50 = f27 > f21;
   i48 = f27 > f24;
   i46 = f27 > f20;
   i44 = f27 > f23;
   f23 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f24 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f25 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(f25 - (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f26 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f4 * f20);
   f21 = Math_fround(f8 * f21);
   f22 = Math_fround(f10 * f22);
   f27 = Math_fround(f9 * Math_fround(f26 - f27));
   f30 = Math_fround(f33 * Math_fround(HEAPF32[i1 >> 2]));
   f29 = Math_fround(f34 * Math_fround(HEAPF32[i1 + 4 >> 2]));
   f28 = Math_fround(f35 * Math_fround(HEAPF32[i1 + 8 >> 2]));
   f30 = Math_fround(f20 + Math_fround(f37 + f30));
   f29 = Math_fround(f21 + Math_fround(f38 + f29));
   f28 = Math_fround(f22 + Math_fround(f39 + f28));
   f27 = Math_fround(f27 + Math_fround(f40 + Math_fround(f36 * Math_fround(HEAPF32[i1 + 12 >> 2]))));
   f30 = Math_fround(f23 + (i50 ? f30 : Math_fround(0.0)));
   f29 = Math_fround(f24 + (i48 ? f29 : Math_fround(0.0)));
   f28 = Math_fround(f25 + (i46 ? f28 : Math_fround(0.0)));
   f27 = Math_fround(f26 + (i44 ? f27 : Math_fround(0.0)));
   HEAPF32[i2 >> 2] = f30;
   HEAPF32[i58 >> 2] = f29;
   HEAPF32[i57 >> 2] = f28;
   HEAPF32[i56 >> 2] = f27;
   i49 = HEAP32[gb + 1097440 + 4 >> 2] & i55 ^ i49;
   i47 = HEAP32[gb + 1097440 + 8 >> 2] & i54 ^ i47;
   i45 = HEAP32[gb + 1097440 + 12 >> 2] & i53 ^ i45;
   f27 = Math_fround(HEAPF32[i42 >> 2]);
   f28 = Math_fround(HEAPF32[i5 >> 2]);
   f29 = Math_fround(HEAPF32[i6 >> 2]);
   f30 = Math_fround(HEAPF32[i7 >> 2]);
   f26 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097440 >> 2] & i52 ^ i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f26 + (i50 ? f27 : Math_fround(0.0)));
   f26 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f26 + (i48 ? f28 : Math_fround(0.0)));
   f26 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f26 + (i46 ? f29 : Math_fround(0.0)));
   f26 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(f26 + (i44 ? f30 : Math_fround(0.0)));
   HEAPF32[i3 >> 2] = f27;
   HEAPF32[i43 >> 2] = f28;
   HEAPF32[i31 >> 2] = f29;
   HEAPF32[i32 >> 2] = f30;
   i2 = i2 + 16 | 0;
   if ((i2 | 0) == (i41 | 0)) break; else {
    i3 = i3 + 16 | 0;
    i1 = i1 + 16 | 0;
   }
  }
  return;
 } else {
  if (i1) return;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + 608 >> 2]);
  f10 = Math_fround(HEAPF32[i5 + 612 >> 2]);
  f11 = Math_fround(HEAPF32[i5 + 616 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + 620 >> 2]);
  f13 = Math_fround(HEAPF32[i5 + 624 >> 2]);
  f14 = Math_fround(HEAPF32[i5 + 628 >> 2]);
  f15 = Math_fround(HEAPF32[i5 + 632 >> 2]);
  f16 = Math_fround(HEAPF32[i5 + 636 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 640 >> 2]);
  f18 = Math_fround(HEAPF32[i5 + 644 >> 2]);
  f19 = Math_fround(HEAPF32[i5 + 648 >> 2]);
  f20 = Math_fround(HEAPF32[i5 + 652 >> 2]);
  f21 = Math_fround(HEAPF32[i5 + 656 >> 2]);
  f22 = Math_fround(HEAPF32[i5 + 660 >> 2]);
  f23 = Math_fround(HEAPF32[i5 + 664 >> 2]);
  f24 = Math_fround(HEAPF32[i5 + 668 >> 2]);
  f25 = Math_fround(HEAPF32[i5 + 672 >> 2]);
  f26 = Math_fround(HEAPF32[i5 + 676 >> 2]);
  f27 = Math_fround(HEAPF32[i5 + 680 >> 2]);
  f28 = Math_fround(HEAPF32[i5 + 684 >> 2]);
  f29 = Math_fround(HEAPF32[i5 + 688 >> 2]);
  f30 = Math_fround(HEAPF32[i5 + 692 >> 2]);
  f4 = Math_fround(HEAPF32[i5 + 696 >> 2]);
  i5 = i42 + 4 | 0;
  i6 = i42 + 8 | 0;
  i7 = i42 + 12 | 0;
  i2 = i31;
  i1 = HEAP32[i32 + 32 >> 2] | 0;
  while (1) {
   i50 = HEAP32[i2 >> 2] | 0;
   i44 = i2 + 4 | 0;
   i47 = HEAP32[i44 >> 2] | 0;
   i45 = i2 + 8 | 0;
   i48 = HEAP32[i45 >> 2] | 0;
   i46 = i2 + 12 | 0;
   i49 = HEAP32[i46 >> 2] | 0;
   i31 = HEAP32[i3 >> 2] | 0;
   i59 = i3 + 4 | 0;
   i32 = HEAP32[i59 >> 2] | 0;
   i60 = i3 + 8 | 0;
   i43 = HEAP32[i60 >> 2] | 0;
   i61 = i3 + 12 | 0;
   i52 = HEAP32[i61 >> 2] | 0;
   f63 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f64 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f68 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f66 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   f67 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i51 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f66;
   i50 = f67 > f63 ? i31 ^ i50 : 0;
   i47 = f62 > f64 ? i32 ^ i47 : 0;
   i48 = f65 > f68 ? i43 ^ i48 : 0;
   i49 = i51 ? i52 ^ i49 : 0;
   i51 = i50 ^ i31;
   i53 = i47 ^ i32;
   i55 = i48 ^ i43;
   i57 = i49 ^ i52;
   f68 = Math_fround(HEAPF32[gb + 1097536 >> 2]);
   f65 = Math_fround(HEAPF32[gb + 1097536 + 4 >> 2]);
   f64 = Math_fround(HEAPF32[gb + 1097536 + 8 >> 2]);
   f62 = Math_fround(HEAPF32[gb + 1097536 + 12 >> 2]);
   f63 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i52 = f63 > f68;
   i54 = f63 > f65;
   i56 = f63 > f64;
   i58 = f63 > f62;
   f62 = Math_fround(f33 * Math_fround(HEAPF32[i1 >> 2]));
   f63 = Math_fround(f34 * Math_fround(HEAPF32[i1 + 4 >> 2]));
   f64 = Math_fround(f35 * Math_fround(HEAPF32[i1 + 8 >> 2]));
   f62 = Math_fround(f37 + f62);
   f63 = Math_fround(f38 + f63);
   f64 = Math_fround(f39 + f64);
   f65 = Math_fround(f40 + Math_fround(f36 * Math_fround(HEAPF32[i1 + 12 >> 2])));
   f68 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f8 * f68) + f62);
   f63 = Math_fround(Math_fround(f9 * f68) + f63);
   f64 = Math_fround(Math_fround(f10 * f68) + f64);
   f65 = Math_fround(Math_fround(f11 * f68) + f65);
   f68 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f12 * f68) + f62);
   f63 = Math_fround(Math_fround(f13 * f68) + f63);
   f64 = Math_fround(Math_fround(f14 * f68) + f64);
   f65 = Math_fround(Math_fround(f15 * f68) + f65);
   f68 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f16 * f68) + f62);
   f63 = Math_fround(Math_fround(f17 * f68) + f63);
   f64 = Math_fround(Math_fround(f18 * f68) + f64);
   f65 = Math_fround(Math_fround(f19 * f68) + f65);
   f68 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f20 * f68) + f62);
   f63 = Math_fround(Math_fround(f21 * f68) + f63);
   f64 = Math_fround(Math_fround(f22 * f68) + f64);
   f65 = Math_fround(Math_fround(f23 * f68) + f65);
   f67 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f24 * f67) + f62);
   f63 = Math_fround(Math_fround(f25 * f67) + f63);
   f64 = Math_fround(Math_fround(f26 * f67) + f64);
   f65 = Math_fround(Math_fround(f27 * f67) + f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(Math_fround(f28 * f66) + f62);
   f63 = Math_fround(Math_fround(f29 * f66) + f63);
   f64 = Math_fround(Math_fround(f30 * f66) + f64);
   f65 = Math_fround(Math_fround(f4 * f66) + f65);
   f62 = Math_fround(f68 + (i52 ? f62 : Math_fround(0.0)));
   f63 = Math_fround(f67 + (i54 ? f63 : Math_fround(0.0)));
   f64 = Math_fround(f66 + (i56 ? f64 : Math_fround(0.0)));
   f66 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f66 + (i58 ? f65 : Math_fround(0.0)));
   HEAPF32[i2 >> 2] = f62;
   HEAPF32[i44 >> 2] = f63;
   HEAPF32[i45 >> 2] = f64;
   HEAPF32[i46 >> 2] = f65;
   i53 = HEAP32[gb + 1097440 + 4 >> 2] & i47 ^ i53;
   i55 = HEAP32[gb + 1097440 + 8 >> 2] & i48 ^ i55;
   i57 = HEAP32[gb + 1097440 + 12 >> 2] & i49 ^ i57;
   f65 = Math_fround(HEAPF32[i42 >> 2]);
   f64 = Math_fround(HEAPF32[i5 >> 2]);
   f63 = Math_fround(HEAPF32[i6 >> 2]);
   f62 = Math_fround(HEAPF32[i7 >> 2]);
   f66 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097440 >> 2] & i50 ^ i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f66 + (i52 ? f65 : Math_fround(0.0)));
   f66 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f66 + (i54 ? f64 : Math_fround(0.0)));
   f66 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f66 + (i56 ? f63 : Math_fround(0.0)));
   f66 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f62 = Math_fround(f66 + (i58 ? f62 : Math_fround(0.0)));
   HEAPF32[i3 >> 2] = f65;
   HEAPF32[i59 >> 2] = f64;
   HEAPF32[i60 >> 2] = f63;
   HEAPF32[i61 >> 2] = f62;
   i2 = i2 + 16 | 0;
   if ((i2 | 0) == (i41 | 0)) break; else {
    i3 = i3 + 16 | 0;
    i1 = i1 + 16 | 0;
   }
  }
  return;
 }
}

function __ZNK17ArchiveFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag(i7, i5, i27, i28, i1, i29) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i32;
 i31 = i32 + 40 | 0;
 i25 = i32 + 24 | 0;
 i26 = i32 + 12 | 0;
 i23 = i7 + 4 | 0;
 i24 = i23 + 11 | 0;
 i1 = HEAP8[i24 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = HEAP32[i23 >> 2] | 0;
  i4 = HEAP32[i7 + 8 >> 2] | 0;
 } else {
  i3 = i23;
  i4 = i1 & 255;
 }
 if (!(_strncmp(i5, i3, i4) | 0)) {
  if (i2) i1 = HEAP32[i7 + 8 >> 2] | 0; else i1 = i1 & 255;
  i1 = i5 + i1 | 0;
 } else i1 = i5;
 i3 = (HEAP8[i1 >> 0] | 0) == 47 ? i1 + 1 | 0 : i1;
 i21 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 56 >> 2] | 0, i7 | 0, i5 | 0) | 0;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i31 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i31);
  i1 = HEAP32[i31 + 12 >> 2] | 0;
  i22 = 12;
 } else if (i4 >>> 0 < 11) {
  i2 = i31 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i31; else {
   i1 = i31;
   i22 = 14;
  }
 } else i22 = 12;
 if ((i22 | 0) == 12) {
  i2 = i4 + 16 & -16;
  HEAP32[i30 >> 2] = 1;
  HEAP32[i30 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i31 >> 2] = i1;
  HEAP32[i31 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i31 + 4 >> 2] = i4;
  i2 = i31 + 11 | 0;
  i22 = 14;
 }
 if ((i22 | 0) == 14) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i20 = i31 + 4 | 0;
 i1 = i4 ? HEAP32[i20 >> 2] | 0 : i1 & 255;
 do if (i1 | 0) {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[i31 >> 2] | 0;
  if ((HEAP8[(i4 ? i3 : i31) + i1 >> 0] | 0) == 47) if (i4) {
   HEAP8[i3 + i1 >> 0] = 0;
   HEAP32[i20 >> 2] = i1;
   break;
  } else {
   HEAP8[i31 + i1 >> 0] = 0;
   HEAP8[i2 >> 0] = i1;
   break;
  }
 } while (0);
 i19 = HEAP8[i2 >> 0] | 0;
 i1 = i19 << 24 >> 24 < 0;
 i6 = i7 + 136 | 0;
 if (!((i1 ? HEAP32[i20 >> 2] | 0 : i19 & 255) | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i4 = i1 ? HEAP32[i31 >> 2] | 0 : i31;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i25 + 12 >> 2] = i1;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i25);
   i1 = HEAP32[i25 + 12 >> 2] | 0;
   i22 = 25;
  } else if (i5 >>> 0 < 11) {
   i3 = i25 + 11 | 0;
   HEAP8[i3 >> 0] = i5;
   if (!i5) i1 = i25; else {
    i1 = i25;
    i22 = 27;
   }
  } else i22 = 25;
  if ((i22 | 0) == 25) {
   i3 = i5 + 16 & -16;
   HEAP32[i30 >> 2] = 54;
   HEAP32[i30 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i30, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i25 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i25 + 4 >> 2] = i5;
   i3 = i25 + 11 | 0;
   i22 = 27;
  }
  if ((i22 | 0) == 27) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i6, i25) | 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i19 = HEAP32[i25 >> 2] | 0;
   i18 = HEAP32[i25 + 12 >> 2] | 0;
   HEAP32[i30 >> 2] = 54;
   HEAP32[i30 + 4 >> 2] = i18;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i30);
  }
 }
 i19 = i7 + 140 | 0;
 if ((i1 | 0) == (i19 | 0)) i1 = 0; else {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  i5 = HEAP8[i2 >> 0] | 0;
  i7 = HEAP32[i20 >> 2] | 0;
  i3 = i5 << 24 >> 24 < 0 ? i7 : i5 & 255;
  if (!i3) i4 = 0; else {
   i4 = i3 + 1 | 0;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
     i1 = i3;
     break;
    } else i1 = i3;
   } else {
    i1 = i3;
    while (1) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) break; else i1 = i3;
    }
   }
  }
  if ((i1 | 0) != (i19 | 0)) {
   i13 = i27 + 12 | 0;
   i14 = i27 + 16 | 0;
   i15 = i27 + 4 | 0;
   i16 = i25 + 11 | 0;
   i17 = i25 + 8 | 0;
   i18 = i25 + 4 | 0;
   i3 = i5;
   while (1) {
    i6 = i3 << 24 >> 24 < 0;
    i5 = i3 & 255;
    if ((i6 ? i7 : i5) | 0) {
     i3 = i1 + 16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
     if (_strncmp(i3, i6 ? HEAP32[i31 >> 2] | 0 : i31, i6 ? i7 : i5) | 0) break;
    }
    if (i28) i22 = 52; else {
     i5 = i1 + 16 | 0;
     i3 = HEAP8[i5 + 11 >> 0] | 0;
     if (i3 << 24 >> 24 < 0) {
      i3 = HEAP32[i1 + 20 >> 2] | 0;
      i5 = HEAP32[i5 >> 2] | 0;
     } else i3 = i3 & 255;
     if (i3 >>> 0 > i4 >>> 0) {
      i3 = i3 - i4 | 0;
      if (!i3) i22 = 52; else {
       i12 = _memchr(i5 + i4 | 0, 47, i3) | 0;
       if ((i12 | 0) == 0 | (i12 - i5 | 0) == -1) i22 = 52;
      }
     } else i22 = 52;
    }
    if ((i22 | 0) == 52) {
     i22 = 0;
     i12 = HEAP32[i13 >> 2] | 0;
     i5 = i12 + 1 | 0;
     i6 = HEAP32[i14 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i3 = i6 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i14 >> 2] = i3;
       HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i3 * 1088 | 0, 8, i15, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 1088 | 0, 8, i15, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i27 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 1088 | 0) | 0;
       HEAP32[i14 >> 2] = i3;
       HEAP32[i27 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i13 >> 2] = i5;
     i10 = HEAP32[i27 >> 2] | 0;
     i11 = i10 + (i12 * 1088 | 0) | 0;
     do if (i21) {
      if ((HEAP8[i24 >> 0] | 0) < 0) i7 = HEAP32[i23 >> 2] | 0; else i7 = i23;
      i8 = _strlen(i7) | 0;
      i3 = HEAP8[i16 >> 0] | 0;
      i5 = i3 << 24 >> 24 < 0;
      if (i5) i6 = (HEAP32[i17 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
      do if (i8 >>> 0 > i6 >>> 0) {
       i3 = i5 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i25, i6, i8 - i6 | 0, i3, 0, i3, i8, i7);
       i3 = HEAP8[i16 >> 0] | 0;
       i22 = 69;
      } else {
       i3 = i5 ? HEAP32[i25 >> 2] | 0 : i25;
       if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
       HEAP8[i3 + i8 >> 0] = 0;
       if ((HEAP8[i16 >> 0] | 0) < 0) {
        HEAP32[i18 >> 2] = i8;
        i22 = 71;
        break;
       } else {
        i3 = i8 & 255;
        HEAP8[i16 >> 0] = i3;
        i22 = 69;
        break;
       }
      } while (0);
      do if ((i22 | 0) == 69) {
       i22 = 0;
       if (i3 << 24 >> 24 < 0) {
        i22 = 71;
        break;
       }
       i6 = i3 & 255;
       i3 = 10;
       i5 = 0;
      } while (0);
      if ((i22 | 0) == 71) {
       i6 = HEAP32[i18 >> 2] | 0;
       i3 = (HEAP32[i17 >> 2] & 2147483647) + -1 | 0;
       i5 = 1;
      }
      if ((i6 | 0) == (i3 | 0)) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i25, i3, 1, i3, i3, 0, 0);
       if ((HEAP8[i16 >> 0] | 0) > -1) i22 = 75; else i22 = 76;
      } else if (i5) i22 = 76; else i22 = 75;
      if ((i22 | 0) == 75) {
       i22 = 0;
       HEAP8[i16 >> 0] = i6 + 1;
       i3 = i25;
      } else if ((i22 | 0) == 76) {
       i22 = 0;
       i3 = HEAP32[i25 >> 2] | 0;
       HEAP32[i18 >> 2] = i6 + 1;
      }
      i3 = i3 + i6 | 0;
      HEAP8[i3 >> 0] = 47;
      HEAP8[i3 + 1 >> 0] = 0;
      i3 = i1 + 16 | 0;
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
      i9 = _strlen(i3) | 0;
      i5 = HEAP8[i16 >> 0] | 0;
      i6 = i5 << 24 >> 24 < 0;
      if (i6) {
       i7 = (HEAP32[i17 >> 2] & 2147483647) + -1 | 0;
       i8 = HEAP32[i18 >> 2] | 0;
      } else {
       i7 = 10;
       i8 = i5 & 255;
      }
      if ((i7 - i8 | 0) >>> 0 < i9 >>> 0) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i25, i7, i9 - i7 + i8 | 0, i8, i8, 0, i9, i3);
       break;
      }
      if (!i9) break;
      i5 = i6 ? HEAP32[i25 >> 2] | 0 : i25;
      _memcpy(i5 + i8 | 0, i3 | 0, i9 | 0) | 0;
      i3 = i8 + i9 | 0;
      if ((HEAP8[i16 >> 0] | 0) < 0) HEAP32[i18 >> 2] = i3; else HEAP8[i16 >> 0] = i3;
      HEAP8[i5 + i3 >> 0] = 0;
     } else {
      i3 = i1 + 16 | 0;
      if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
      i8 = _strlen(i3) | 0;
      i5 = HEAP8[i16 >> 0] | 0;
      i6 = i5 << 24 >> 24 < 0;
      if (i6) i7 = (HEAP32[i17 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
      if (i8 >>> 0 > i7 >>> 0) {
       i9 = i6 ? HEAP32[i18 >> 2] | 0 : i5 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i25, i7, i8 - i7 | 0, i9, 0, i9, i8, i3);
       break;
      }
      i5 = i6 ? HEAP32[i25 >> 2] | 0 : i25;
      if (i8 | 0) _memmove(i5 | 0, i3 | 0, i8 | 0) | 0;
      HEAP8[i5 + i8 >> 0] = 0;
      if ((HEAP8[i16 >> 0] | 0) < 0) {
       HEAP32[i18 >> 2] = i8;
       break;
      } else {
       HEAP8[i16 >> 0] = i8;
       break;
      }
     } while (0);
     _strncpy(i11, (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25, 1040) | 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1039 >> 0] = 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1080 >> 0] = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 16 >> 2] & 1;
     __ZN8DateTimeC2Ev(i30);
     i7 = i30;
     i8 = HEAP32[i7 + 4 >> 2] | 0;
     i9 = i10 + (i12 * 1088 | 0) + 1072 | 0;
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = i8;
     HEAP8[i10 + (i12 * 1088 | 0) + 1081 >> 0] = 0;
     HEAP8[i10 + (i12 * 1088 | 0) + 1082 >> 0] = 0;
     i12 = (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i12, _strlen(i12) | 0);
     __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i30, i26);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     if (__Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i11, i30, i29) | 0) HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
    }
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i3) while (1) {
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
      i1 = i3;
      break;
     } else i1 = i3;
    } else {
     i1 = i3;
     while (1) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) break; else i1 = i3;
     }
    }
    if ((i1 | 0) == (i19 | 0)) break;
    i3 = HEAP8[i2 >> 0] | 0;
    i7 = HEAP32[i20 >> 2] | 0;
   }
   if ((HEAP8[i16 >> 0] | 0) < 0) {
    i29 = HEAP32[i25 >> 2] | 0;
    i28 = HEAP32[i25 + 12 >> 2] | 0;
    HEAP32[i30 >> 2] = 1;
    HEAP32[i30 + 4 >> 2] = i28;
    __Z19free_alloc_internalPvRK10MemLabelId(i29, i30);
   }
  }
  i1 = 1;
 }
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i32;
  return i1 | 0;
 }
 i29 = HEAP32[i31 >> 2] | 0;
 i31 = HEAP32[i31 + 12 >> 2] | 0;
 HEAP32[i30 >> 2] = 1;
 HEAP32[i30 + 4 >> 2] = i31;
 __Z19free_alloc_internalPvRK10MemLabelId(i29, i30);
 STACKTOP = i32;
 return i1 | 0;
}

function __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_(i1, i2, i26) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i26 = i26 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i37 = i2;
 L1 : while (1) {
  i21 = i37;
  i36 = i37 + -44 | 0;
  i22 = i37 + -4 | 0;
  i30 = i37 + -40 | 0;
  i31 = i37 + -36 | 0;
  i32 = i37 + -32 | 0;
  i33 = i37 + -28 | 0;
  i34 = i37 + -24 | 0;
  i35 = i37 + -20 | 0;
  i27 = i37 + -16 | 0;
  i28 = i37 + -12 | 0;
  i29 = i37 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i20 = i1;
    i2 = i21 - i20 | 0;
    switch ((i2 | 0) / 44 | 0 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 7;
      break L1;
     }
    case 4:
     {
      i23 = 8;
      break L1;
     }
    case 5:
     {
      i23 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 308) {
     i23 = 11;
     break L1;
    }
    i3 = (i2 >>> 0) / 88 | 0;
    i19 = i1 + (i3 * 44 | 0) | 0;
    if ((i2 | 0) > 43956) {
     i2 = (i2 >>> 0) / 176 | 0;
     i2 = __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 * 44 | 0) | 0, i19, i19 + (i2 * 44 | 0) | 0, i36, i26) | 0;
    } else i2 = __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i1, i19, i36, i26) | 0;
    i17 = i1 + 40 | 0;
    i5 = HEAP32[i17 >> 2] | 0;
    i4 = HEAP32[i1 + (i3 * 44 | 0) + 40 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i36;
     break;
    } else i16 = i36;
    while (1) {
     i3 = i16 + -44 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if ((HEAP32[i16 + -4 >> 2] | 0) < (i4 | 0)) {
      i23 = 35;
      break L5;
     } else i16 = i3;
    }
    i1 = i1 + 44 | 0;
    if ((i5 | 0) >= (HEAP32[i22 >> 2] | 0)) {
     if ((i1 | 0) == (i36 | 0)) {
      i23 = 52;
      break L1;
     }
     while (1) {
      if ((i5 | 0) < (HEAP32[i1 + 40 >> 2] | 0)) break;
      i1 = i1 + 44 | 0;
      if ((i1 | 0) == (i36 | 0)) {
       i23 = 52;
       break L1;
      }
     }
     i2 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i1 + 4 >> 2] | 0;
     i5 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i1 + 12 >> 2] | 0;
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = HEAP32[i1 + 20 >> 2] | 0;
     i9 = HEAP32[i1 + 24 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i11 = HEAP32[i1 + 32 >> 2] | 0;
     i13 = i1 + 36 | 0;
     i12 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i1;
     i24 = i36;
     i25 = i4 + 44 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
      i4 = i4 + 4 | 0;
      i24 = i24 + 4 | 0;
     } while ((i4 | 0) < (i25 | 0));
     HEAP32[i36 >> 2] = i2;
     HEAP32[i30 >> 2] = i3;
     HEAP32[i31 >> 2] = i5;
     HEAP32[i32 >> 2] = i6;
     HEAP32[i33 >> 2] = i7;
     HEAP32[i34 >> 2] = i8;
     HEAP32[i35 >> 2] = i9;
     HEAP32[i27 >> 2] = i10;
     HEAP32[i28 >> 2] = i11;
     i25 = i29;
     HEAP32[i25 >> 2] = i12;
     HEAP32[i25 + 4 >> 2] = i13;
     i1 = i1 + 44 | 0;
    }
    if ((i1 | 0) == (i36 | 0)) {
     i23 = 52;
     break L1;
    } else i2 = i36;
    while (1) {
     i3 = HEAP32[i17 >> 2] | 0;
     while (1) {
      i16 = i1 + 44 | 0;
      if ((i3 | 0) < (HEAP32[i1 + 40 >> 2] | 0)) break; else i1 = i16;
     }
     while (1) {
      i15 = i2 + -44 | 0;
      if ((i3 | 0) < (HEAP32[i2 + -4 >> 2] | 0)) i2 = i15; else break;
     }
     if (i1 >>> 0 >= i15 >>> 0) continue L5;
     i3 = HEAP32[i1 >> 2] | 0;
     i5 = HEAP32[i1 + 4 >> 2] | 0;
     i6 = HEAP32[i1 + 8 >> 2] | 0;
     i7 = HEAP32[i1 + 12 >> 2] | 0;
     i8 = HEAP32[i1 + 16 >> 2] | 0;
     i9 = HEAP32[i1 + 20 >> 2] | 0;
     i10 = HEAP32[i1 + 24 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i12 = HEAP32[i1 + 32 >> 2] | 0;
     i14 = i1 + 36 | 0;
     i13 = HEAP32[i14 >> 2] | 0;
     i14 = HEAP32[i14 + 4 >> 2] | 0;
     i4 = i1;
     i24 = i15;
     i25 = i4 + 44 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
      i4 = i4 + 4 | 0;
      i24 = i24 + 4 | 0;
     } while ((i4 | 0) < (i25 | 0));
     HEAP32[i15 >> 2] = i3;
     HEAP32[i2 + -40 >> 2] = i5;
     HEAP32[i2 + -36 >> 2] = i6;
     HEAP32[i2 + -32 >> 2] = i7;
     HEAP32[i2 + -28 >> 2] = i8;
     HEAP32[i2 + -24 >> 2] = i9;
     HEAP32[i2 + -20 >> 2] = i10;
     HEAP32[i2 + -16 >> 2] = i11;
     HEAP32[i2 + -12 >> 2] = i12;
     i2 = i2 + -8 | 0;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i2 + 4 >> 2] = i14;
     i2 = i15;
     i1 = i16;
    }
   }
   if ((i23 | 0) == 35) {
    i23 = 0;
    i5 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i1 + 4 >> 2] | 0;
    i7 = HEAP32[i1 + 8 >> 2] | 0;
    i8 = HEAP32[i1 + 12 >> 2] | 0;
    i9 = HEAP32[i1 + 16 >> 2] | 0;
    i10 = HEAP32[i1 + 20 >> 2] | 0;
    i11 = HEAP32[i1 + 24 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i13 = HEAP32[i1 + 32 >> 2] | 0;
    i15 = i1 + 36 | 0;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i4 = i1;
    i24 = i3;
    i25 = i4 + 44 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
     i4 = i4 + 4 | 0;
     i24 = i24 + 4 | 0;
    } while ((i4 | 0) < (i25 | 0));
    HEAP32[i3 >> 2] = i5;
    HEAP32[i16 + -40 >> 2] = i6;
    HEAP32[i16 + -36 >> 2] = i7;
    HEAP32[i16 + -32 >> 2] = i8;
    HEAP32[i16 + -28 >> 2] = i9;
    HEAP32[i16 + -24 >> 2] = i10;
    HEAP32[i16 + -20 >> 2] = i11;
    HEAP32[i16 + -16 >> 2] = i12;
    HEAP32[i16 + -12 >> 2] = i13;
    i25 = i16 + -8 | 0;
    HEAP32[i25 >> 2] = i14;
    HEAP32[i25 + 4 >> 2] = i15;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 44 | 0;
   L35 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i5 = HEAP32[i19 + 40 >> 2] | 0;
    i16 = i4;
    while (1) {
     i18 = i16 + 44 | 0;
     if ((HEAP32[i16 + 40 >> 2] | 0) < (i5 | 0)) i16 = i18; else break;
    }
    while (1) {
     i17 = i3 + -44 | 0;
     if ((HEAP32[i3 + -4 >> 2] | 0) < (i5 | 0)) break; else i3 = i17;
    }
    if (i16 >>> 0 > i17 >>> 0) {
     i15 = i19;
     break L35;
    }
    i5 = HEAP32[i16 >> 2] | 0;
    i6 = HEAP32[i16 + 4 >> 2] | 0;
    i7 = HEAP32[i16 + 8 >> 2] | 0;
    i8 = HEAP32[i16 + 12 >> 2] | 0;
    i9 = HEAP32[i16 + 16 >> 2] | 0;
    i10 = HEAP32[i16 + 20 >> 2] | 0;
    i11 = HEAP32[i16 + 24 >> 2] | 0;
    i12 = HEAP32[i16 + 28 >> 2] | 0;
    i13 = HEAP32[i16 + 32 >> 2] | 0;
    i15 = i16 + 36 | 0;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i4 = i16;
    i24 = i17;
    i25 = i4 + 44 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
     i4 = i4 + 4 | 0;
     i24 = i24 + 4 | 0;
    } while ((i4 | 0) < (i25 | 0));
    HEAP32[i17 >> 2] = i5;
    HEAP32[i3 + -40 >> 2] = i6;
    HEAP32[i3 + -36 >> 2] = i7;
    HEAP32[i3 + -32 >> 2] = i8;
    HEAP32[i3 + -28 >> 2] = i9;
    HEAP32[i3 + -24 >> 2] = i10;
    HEAP32[i3 + -20 >> 2] = i11;
    HEAP32[i3 + -16 >> 2] = i12;
    HEAP32[i3 + -12 >> 2] = i13;
    i3 = i3 + -8 | 0;
    HEAP32[i3 >> 2] = i14;
    HEAP32[i3 + 4 >> 2] = i15;
    i19 = (i19 | 0) == (i16 | 0) ? i17 : i19;
    i3 = i17;
    i4 = i18;
    i2 = i2 + 1 | 0;
   } else {
    i15 = i19;
    i16 = i4;
   } while (0);
   if ((i16 | 0) != (i15 | 0)) if ((HEAP32[i15 + 40 >> 2] | 0) < (HEAP32[i16 + 40 >> 2] | 0)) {
    i3 = HEAP32[i16 >> 2] | 0;
    i5 = HEAP32[i16 + 4 >> 2] | 0;
    i6 = HEAP32[i16 + 8 >> 2] | 0;
    i7 = HEAP32[i16 + 12 >> 2] | 0;
    i8 = HEAP32[i16 + 16 >> 2] | 0;
    i9 = HEAP32[i16 + 20 >> 2] | 0;
    i10 = HEAP32[i16 + 24 >> 2] | 0;
    i11 = HEAP32[i16 + 28 >> 2] | 0;
    i12 = HEAP32[i16 + 32 >> 2] | 0;
    i14 = i16 + 36 | 0;
    i13 = HEAP32[i14 >> 2] | 0;
    i14 = HEAP32[i14 + 4 >> 2] | 0;
    i4 = i16;
    i24 = i15;
    i25 = i4 + 44 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
     i4 = i4 + 4 | 0;
     i24 = i24 + 4 | 0;
    } while ((i4 | 0) < (i25 | 0));
    HEAP32[i15 >> 2] = i3;
    HEAP32[i15 + 4 >> 2] = i5;
    HEAP32[i15 + 8 >> 2] = i6;
    HEAP32[i15 + 12 >> 2] = i7;
    HEAP32[i15 + 16 >> 2] = i8;
    HEAP32[i15 + 20 >> 2] = i9;
    HEAP32[i15 + 24 >> 2] = i10;
    HEAP32[i15 + 28 >> 2] = i11;
    HEAP32[i15 + 32 >> 2] = i12;
    i25 = i15 + 36 | 0;
    HEAP32[i25 >> 2] = i13;
    HEAP32[i25 + 4 >> 2] = i14;
    i2 = i2 + 1 | 0;
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEbT0_S5_T_(i1, i16, i26) | 0;
    i3 = i16 + 44 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEbT0_S5_T_(i3, i37, i26) | 0) {
     i23 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i25 = i16;
   if ((i25 - i20 | 0) >= (i21 - i25 | 0)) {
    i23 = 50;
    break;
   }
   __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_(i1, i16, i26);
   i1 = i16 + 44 | 0;
  }
  if ((i23 | 0) == 50) {
   i23 = 0;
   __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_(i16 + 44 | 0, i37, i26);
   i37 = i16;
   continue;
  } else if ((i23 | 0) == 51) {
   i23 = 0;
   if (i2) {
    i23 = 52;
    break;
   } else {
    i37 = i16;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  if ((HEAP32[i22 >> 2] | 0) >= (HEAP32[i1 + 40 >> 2] | 0)) return;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = HEAP32[i1 + 16 >> 2] | 0;
  i8 = HEAP32[i1 + 20 >> 2] | 0;
  i9 = HEAP32[i1 + 24 >> 2] | 0;
  i10 = HEAP32[i1 + 28 >> 2] | 0;
  i11 = HEAP32[i1 + 32 >> 2] | 0;
  i13 = i1 + 36 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i4 = i1;
  i24 = i36;
  i25 = i4 + 44 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
   i4 = i4 + 4 | 0;
   i24 = i24 + 4 | 0;
  } while ((i4 | 0) < (i25 | 0));
  HEAP32[i36 >> 2] = i2;
  HEAP32[i30 >> 2] = i3;
  HEAP32[i31 >> 2] = i5;
  HEAP32[i32 >> 2] = i6;
  HEAP32[i33 >> 2] = i7;
  HEAP32[i34 >> 2] = i8;
  HEAP32[i35 >> 2] = i9;
  HEAP32[i27 >> 2] = i10;
  HEAP32[i28 >> 2] = i11;
  i37 = i29;
  HEAP32[i37 >> 2] = i12;
  HEAP32[i37 + 4 >> 2] = i13;
  return;
 } else if ((i23 | 0) == 7) {
  __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i1, i1 + 44 | 0, i36, i26) | 0;
  return;
 } else if ((i23 | 0) == 8) {
  __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_(i1, i1 + 44 | 0, i1 + 88 | 0, i36, i26) | 0;
  return;
 } else if ((i23 | 0) == 9) {
  __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_(i1, i1 + 44 | 0, i1 + 88 | 0, i1 + 132 | 0, i36, i26) | 0;
  return;
 } else if ((i23 | 0) == 11) {
  i3 = i1 + 88 | 0;
  __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i1, i1 + 44 | 0, i3, i26) | 0;
  i2 = i1 + 132 | 0;
  if ((i2 | 0) == (i37 | 0)) return;
  while (1) {
   if ((HEAP32[i2 + 40 >> 2] | 0) < (HEAP32[i3 + 40 >> 2] | 0)) {
    i5 = HEAP32[i2 >> 2] | 0;
    i6 = HEAP32[i2 + 4 >> 2] | 0;
    i7 = HEAP32[i2 + 8 >> 2] | 0;
    i8 = HEAP32[i2 + 12 >> 2] | 0;
    i9 = HEAP32[i2 + 16 >> 2] | 0;
    i10 = HEAP32[i2 + 20 >> 2] | 0;
    i11 = HEAP32[i2 + 24 >> 2] | 0;
    i12 = HEAP32[i2 + 28 >> 2] | 0;
    i13 = HEAP32[i2 + 32 >> 2] | 0;
    i15 = i2 + 36 | 0;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i4 = i2;
    while (1) {
     i24 = i3;
     i25 = i4 + 44 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
      i4 = i4 + 4 | 0;
      i24 = i24 + 4 | 0;
     } while ((i4 | 0) < (i25 | 0));
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     if ((i15 | 0) < (HEAP32[i3 + -4 >> 2] | 0)) {
      i4 = i3;
      i3 = i3 + -44 | 0;
     } else break;
    }
    HEAP32[i3 >> 2] = i5;
    HEAP32[i3 + 4 >> 2] = i6;
    HEAP32[i3 + 8 >> 2] = i7;
    HEAP32[i3 + 12 >> 2] = i8;
    HEAP32[i3 + 16 >> 2] = i9;
    HEAP32[i3 + 20 >> 2] = i10;
    HEAP32[i3 + 24 >> 2] = i11;
    HEAP32[i3 + 28 >> 2] = i12;
    HEAP32[i3 + 32 >> 2] = i13;
    i36 = i3 + 36 | 0;
    HEAP32[i36 >> 2] = i14;
    HEAP32[i36 + 4 >> 2] = i15;
   }
   i3 = i2 + 44 | 0;
   if ((i3 | 0) == (i37 | 0)) break; else {
    i36 = i2;
    i2 = i3;
    i3 = i36;
   }
  }
  return;
 } else if ((i23 | 0) == 52) return;
}

function __ZN12TreeRenderer21GenerateBillboardMeshER4MeshRK13dynamic_arrayIjLj4EEb(i34, i43, i38, i39) {
 i34 = i34 | 0;
 i43 = i43 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i46 + 40 | 0;
 i40 = i46 + 16 | 0;
 i45 = i46;
 i1 = HEAP32[i34 >> 2] | 0;
 i42 = i38 + 12 | 0;
 i41 = HEAP32[i42 >> 2] | 0;
 __ZN4Mesh14ResizeVerticesEjj(i43, i41 << 2, 29);
 i35 = i43 + 32 | 0;
 i36 = HEAP32[(HEAP32[i35 >> 2] | 0) + 92 >> 2] | 0;
 i37 = (HEAP8[i43 + 44 >> 0] & 16) == 0;
 if (i41 | 0) {
  i26 = i1 + 16 | 0;
  i27 = i34 + 120 | 0;
  i28 = i34 + 124 | 0;
  i29 = i34 + 128 | 0;
  i30 = i34 + 136 | 0;
  i31 = i34 + 140 | 0;
  i32 = i34 + 144 | 0;
  i33 = i34 + 196 | 0;
  i22 = i40 + 4 | 0;
  i24 = i40 + 8 | 0;
  i21 = i40 + 12 | 0;
  i23 = i40 + 16 | 0;
  i25 = i40 + 20 | 0;
  i20 = 0;
  do {
   i1 = HEAP32[(HEAP32[i38 >> 2] | 0) + (i20 << 2) >> 2] | 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i14 = i2 + (i1 * 40 | 0) + 32 | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[(HEAP32[i34 >> 2] | 0) + 28 >> 2] | 0;
   f17 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) >> 2]);
   f17 = Math_fround(f17 * Math_fround(HEAPF32[i27 >> 2]));
   f18 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 4 >> 2]);
   f18 = Math_fround(f18 * Math_fround(HEAPF32[i28 >> 2]));
   f19 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 8 >> 2]);
   f19 = Math_fround(f19 * Math_fround(HEAPF32[i29 >> 2]));
   f17 = Math_fround(f17 + Math_fround(HEAPF32[i30 >> 2]));
   f18 = Math_fround(f18 + Math_fround(HEAPF32[i31 >> 2]));
   f19 = Math_fround(f19 + Math_fround(HEAPF32[i32 >> 2]));
   i12 = HEAP32[i2 + (i1 * 40 | 0) + 24 >> 2] | 0;
   f6 = Math_fround(Math_fround(i12 & 255) / Math_fround(255.0));
   f7 = Math_fround(Math_fround((i12 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f8 = Math_fround(Math_fround(i12 >>> 16 & 255) / Math_fround(255.0));
   f15 = Math_fround(Math_fround(i12 >>> 24 & 255) / Math_fround(255.0));
   i12 = HEAP32[i2 + (i1 * 40 | 0) + 28 >> 2] | 0;
   f6 = Math_fround(f6 * Math_fround(Math_fround(i12 & 255) / Math_fround(255.0)));
   f7 = Math_fround(f7 * Math_fround(Math_fround((i12 & 65535) >>> 8 & 255) / Math_fround(255.0)));
   f8 = Math_fround(f8 * Math_fround(Math_fround(i12 >>> 16 & 255) / Math_fround(255.0)));
   f15 = Math_fround(f15 * Math_fround(Math_fround(i12 >>> 24 & 255) / Math_fround(255.0)));
   do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
    do if (!(f6 <= Math_fround(.0404499993))) {
     if (f6 < Math_fround(1.0)) {
      f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f6 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f6 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f6, 2.20000005));
    } else f6 = Math_fround(f6 / Math_fround(12.9200001)); while (0);
    do if (!(f7 <= Math_fround(.0404499993))) {
     if (f7 < Math_fround(1.0)) {
      f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
    } else f7 = Math_fround(f7 / Math_fround(12.9200001)); while (0);
    if (f8 <= Math_fround(.0404499993)) {
     f9 = f7;
     f8 = Math_fround(f8 / Math_fround(12.9200001));
     break;
    }
    if (f8 < Math_fround(1.0)) {
     f9 = f7;
     f8 = Math_fround(+Math_pow(+Math_fround(Math_fround(f8 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f8 == Math_fround(1.0)) {
     f9 = f7;
     f8 = Math_fround(1.0);
    } else {
     f9 = f7;
     f8 = Math_fround(+Math_pow(+f8, 2.20000005));
    }
   } else f9 = f7; while (0);
   f51 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 12 >> 2]);
   f51 = Math_fround(f51 * Math_fround(HEAPF32[i4 + (i3 * 156 | 0) + 44 >> 2]));
   f53 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 16 >> 2]);
   f53 = Math_fround(f53 * Math_fround(HEAPF32[i4 + (i3 * 156 | 0) + 48 >> 2]));
   f48 = Math_fround(HEAPF32[i4 + (i3 * 156 | 0) + 144 >> 2]);
   f16 = Math_fround(Math_fround(f51 * f48) * Math_fround(.5));
   f52 = Math_fround(HEAPF32[i4 + (i3 * 156 | 0) + 136 >> 2]);
   f7 = Math_fround(Math_fround(f53 * f52) * Math_fround(.5));
   f50 = Math_fround(HEAPF32[i4 + (i3 * 156 | 0) + 140 >> 2]);
   f13 = Math_fround(f53 * Math_fround(f50 - Math_fround(f52 * Math_fround(.5))));
   f48 = f52 < f48 ? f48 : f52;
   f49 = Math_fround(Math_fround(f48 - f52) * Math_fround(.5));
   f47 = Math_fround(f53 * Math_fround(f50 + f49));
   f49 = Math_fround(f53 * Math_fround(Math_fround(f52 - f50) + f49));
   f48 = Math_fround(Math_fround(f51 * f48) * Math_fround(.5));
   i5 = i20 << 2;
   HEAPF32[i36 + (i5 << 5) >> 2] = f17;
   HEAPF32[i36 + (i5 << 5) + 4 >> 2] = f18;
   HEAPF32[i36 + (i5 << 5) + 8 >> 2] = f19;
   i10 = i5 | 1;
   HEAPF32[i36 + (i10 << 5) >> 2] = f17;
   HEAPF32[i36 + (i10 << 5) + 4 >> 2] = f18;
   HEAPF32[i36 + (i10 << 5) + 8 >> 2] = f19;
   i11 = i5 | 2;
   HEAPF32[i36 + (i11 << 5) >> 2] = f17;
   HEAPF32[i36 + (i11 << 5) + 4 >> 2] = f18;
   HEAPF32[i36 + (i11 << 5) + 8 >> 2] = f19;
   i12 = i5 | 3;
   HEAPF32[i36 + (i12 << 5) >> 2] = f17;
   HEAPF32[i36 + (i12 << 5) + 4 >> 2] = f18;
   HEAPF32[i36 + (i12 << 5) + 8 >> 2] = f19;
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i33 >> 2] | 0) + 4 >> 2] | 0;
   i4 = HEAP32[i1 + (i2 << 4) >> 2] | 0;
   f51 = Math_fround(-f48);
   HEAP32[i36 + (i5 << 5) + 16 >> 2] = i4;
   HEAPF32[i36 + (i5 << 5) + 20 >> 2] = f51;
   f50 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f50 = Math_fround(f50 + Math_fround(HEAPF32[i1 + (i2 << 4) + 8 >> 2]));
   HEAPF32[i36 + (i10 << 5) + 16 >> 2] = f50;
   HEAPF32[i36 + (i10 << 5) + 20 >> 2] = f51;
   HEAP32[i36 + (i11 << 5) + 16 >> 2] = i4;
   HEAPF32[i36 + (i11 << 5) + 20 >> 2] = f48;
   HEAPF32[i36 + (i12 << 5) + 16 >> 2] = f50;
   HEAPF32[i36 + (i12 << 5) + 20 >> 2] = f48;
   f48 = Math_fround(-f16);
   f49 = Math_fround(-f49);
   HEAPF32[i36 + (i5 << 5) + 24 >> 2] = f48;
   HEAPF32[i36 + (i5 << 5) + 28 >> 2] = f49;
   HEAPF32[i36 + (i10 << 5) + 24 >> 2] = f16;
   HEAPF32[i36 + (i10 << 5) + 28 >> 2] = f49;
   HEAPF32[i36 + (i11 << 5) + 24 >> 2] = f48;
   HEAPF32[i36 + (i11 << 5) + 28 >> 2] = f47;
   HEAPF32[i36 + (i12 << 5) + 24 >> 2] = f16;
   HEAPF32[i36 + (i12 << 5) + 28 >> 2] = f47;
   i4 = f6 < Math_fround(0.0);
   f6 = i4 ? Math_fround(0.0) : f6;
   i4 = f6 > Math_fround(1.0);
   i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i2 = f9 < Math_fround(0.0);
   f9 = i2 ? Math_fround(0.0) : f9;
   i2 = f9 > Math_fround(1.0);
   i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i1 = f8 < Math_fround(0.0);
   f9 = i1 ? Math_fround(0.0) : f8;
   i1 = f9 > Math_fround(1.0);
   i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i3 = f15 > Math_fround(1.0);
   i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   if (!i37) {
    i14 = i4 << 16 & 16711680 | i3 << 24;
    i2 = i14 | i2 << 8 & 65280;
    i4 = i2 | i1 & 255;
    i3 = i3 & 255;
    i2 = i2 >>> 8;
    i1 = i14 >>> 16;
   }
   i14 = i2 << 8 & 65280 | i4 & 255 | i1 << 16 & 16711680 | i3 << 24;
   HEAP32[i36 + (i12 << 5) + 12 >> 2] = i14;
   HEAP32[i36 + (i11 << 5) + 12 >> 2] = i14;
   HEAP32[i36 + (i10 << 5) + 12 >> 2] = i14;
   HEAP32[i36 + (i5 << 5) + 12 >> 2] = i14;
   f9 = Math_fround(f17 + Math_fround(0.0));
   f8 = Math_fround(f18 + f13);
   f6 = Math_fround(f19 + Math_fround(0.0));
   if (!i20) {
    HEAPF32[i40 >> 2] = f9;
    HEAPF32[i22 >> 2] = f8;
    HEAPF32[i24 >> 2] = f6;
    f8 = f16;
    f6 = f16;
   } else {
    f51 = Math_fround(f9 + f16);
    f19 = Math_fround(f7 + f8);
    f18 = Math_fround(f6 + f16);
    f13 = Math_fround(HEAPF32[i40 >> 2]);
    f49 = Math_fround(HEAPF32[i21 >> 2]);
    f53 = Math_fround(f13 - f49);
    f15 = Math_fround(HEAPF32[i22 >> 2]);
    f50 = Math_fround(HEAPF32[i23 >> 2]);
    f52 = Math_fround(f15 - f50);
    f17 = Math_fround(HEAPF32[i24 >> 2]);
    f48 = Math_fround(HEAPF32[i25 >> 2]);
    f47 = Math_fround(f17 - f48);
    f53 = f51 < f53 ? f51 : f53;
    f52 = f19 < f52 ? f19 : f52;
    f47 = f18 < f47 ? f18 : f47;
    f49 = Math_fround(f13 + f49);
    f50 = Math_fround(f15 + f50);
    f48 = Math_fround(f17 + f48);
    f49 = f49 < f51 ? f51 : f49;
    f50 = f50 < f19 ? f19 : f50;
    f48 = f48 < f18 ? f18 : f48;
    f18 = Math_fround(Math_fround(f53 + f49) * Math_fround(.5));
    f19 = Math_fround(Math_fround(f52 + f50) * Math_fround(.5));
    f51 = Math_fround(Math_fround(f47 + f48) * Math_fround(.5));
    f53 = Math_fround(Math_fround(f49 - f53) * Math_fround(.5));
    f52 = Math_fround(Math_fround(f50 - f52) * Math_fround(.5));
    f47 = Math_fround(Math_fround(f48 - f47) * Math_fround(.5));
    HEAPF32[i21 >> 2] = f53;
    HEAPF32[i23 >> 2] = f52;
    HEAPF32[i25 >> 2] = f47;
    f48 = Math_fround(f9 - f16);
    f50 = Math_fround(f8 - f7);
    f49 = Math_fround(f6 - f16);
    f6 = Math_fround(f18 - f53);
    f7 = Math_fround(f19 - f52);
    f8 = Math_fround(f51 - f47);
    f6 = f48 < f6 ? f48 : f6;
    f7 = f50 < f7 ? f50 : f7;
    f8 = f49 < f8 ? f49 : f8;
    f53 = Math_fround(f18 + f53);
    f52 = Math_fround(f19 + f52);
    f51 = Math_fround(f47 + f51);
    f53 = f53 < f48 ? f48 : f53;
    f52 = f52 < f50 ? f50 : f52;
    f51 = f51 < f49 ? f49 : f51;
    f49 = Math_fround(Math_fround(f7 + f52) * Math_fround(.5));
    f50 = Math_fround(Math_fround(f8 + f51) * Math_fround(.5));
    HEAPF32[i40 >> 2] = Math_fround(Math_fround(f6 + f53) * Math_fround(.5));
    HEAPF32[i22 >> 2] = f49;
    HEAPF32[i24 >> 2] = f50;
    f8 = Math_fround(Math_fround(f51 - f8) * Math_fround(.5));
    f7 = Math_fround(Math_fround(f52 - f7) * Math_fround(.5));
    f6 = Math_fround(Math_fround(f53 - f6) * Math_fround(.5));
   }
   HEAPF32[i21 >> 2] = f6;
   HEAPF32[i23 >> 2] = f7;
   HEAPF32[i25 >> 2] = f8;
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i41 | 0));
 }
 __ZN4Mesh9SetBoundsERK4AABB(i43, i40);
 __ZN4Mesh16SetChannelsDirtyEjb(i43, HEAP32[(HEAP32[i35 >> 2] | 0) + 96 >> 2] | 0, 0);
 if (!i39) {
  STACKTOP = i46;
  return;
 }
 i2 = HEAP32[i42 >> 2] | 0;
 i3 = i2 * 6 | 0;
 HEAP32[i45 >> 2] = 0;
 i5 = i45 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i45 + 12 >> 2] = i1;
 if (!i3) i4 = 0; else {
  if ((i3 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i45);
   i1 = HEAP32[i45 + 12 >> 2] | 0;
  }
  i41 = i2 * 12 | 0;
  HEAP32[i44 >> 2] = 1;
  HEAP32[i44 + 4 >> 2] = i1;
  i40 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i44, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i45 >> 2] = i40;
  i4 = i40 + (i3 << 1) | 0;
  HEAP32[i45 + 8 >> 2] = i4;
  _memset(i40 | 0, 0, i41 | 0) | 0;
  HEAP32[i5 >> 2] = i4;
 }
 i3 = HEAP32[i42 >> 2] | 0;
 i2 = HEAP32[i45 >> 2] | 0;
 if (i3 | 0) {
  i1 = 0;
  do {
   i42 = i1 * 6 | 0;
   i41 = i1 << 2;
   HEAP16[i2 + (i42 << 1) >> 1] = i41;
   i40 = (i41 | 1) & 65535;
   HEAP16[i2 + ((i42 | 1) << 1) >> 1] = i40;
   i39 = (i41 | 2) & 65535;
   HEAP16[i2 + (i42 + 2 << 1) >> 1] = i39;
   HEAP16[i2 + (i42 + 3 << 1) >> 1] = i39;
   HEAP16[i2 + (i42 + 4 << 1) >> 1] = i40;
   HEAP16[i2 + (i42 + 5 << 1) >> 1] = i41 | 3;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i43, (i2 | 0) == (i4 | 0) ? 0 : i2, i4 - i2 >> 1, 0, 0, 17) | 0;
 i1 = HEAP32[i45 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -2 - i2 | 0) >>> 1) << 1);
  i45 = HEAP32[i45 + 12 >> 2] | 0;
  HEAP32[i44 >> 2] = 1;
  HEAP32[i44 + 4 >> 2] = i45;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i44);
 }
 STACKTOP = i46;
 return;
}

function __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i2, i23) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i24 = i2;
 L1 : while (1) {
  i12 = i24;
  i21 = i24 + -28 | 0;
  i14 = i24 + -16 | 0;
  i15 = i24 + -24 | 0;
  i16 = i24 + -20 | 0;
  i17 = i24 + -16 | 0;
  i18 = i24 + -12 | 0;
  i19 = i24 + -8 | 0;
  i20 = i24 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i2 = i12 - i11 | 0;
    switch ((i2 | 0) / 28 | 0 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 7;
      break L1;
     }
    case 4:
     {
      i22 = 8;
      break L1;
     }
    case 5:
     {
      i22 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 196) {
     i22 = 11;
     break L1;
    }
    i3 = (i2 >>> 0) / 56 | 0;
    i10 = i1 + (i3 * 28 | 0) | 0;
    if ((i2 | 0) > 27972) {
     i2 = (i2 >>> 0) / 112 | 0;
     i2 = __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 * 28 | 0) | 0, i10, i10 + (i2 * 28 | 0) | 0, i21, i23) | 0;
    } else i2 = __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i10, i21, i23) | 0;
    f5 = Math_fround(HEAPF32[i1 >> 2]);
    i9 = i1 + 12 | 0;
    f7 = Math_fround(HEAPF32[i9 >> 2]);
    f13 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i1 + (i3 * 28 | 0) + 12 >> 2])) * Math_fround(.5));
    if (f13 < f4) {
     i3 = i21;
     break;
    } else i6 = i21;
    while (1) {
     i3 = i6 + -28 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     f25 = Math_fround(HEAPF32[i3 >> 2]);
     if (Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i6 + -16 >> 2])) * Math_fround(.5)) < f4) {
      i22 = 35;
      break L5;
     } else i6 = i3;
    }
    i2 = i1 + 28 | 0;
    f25 = Math_fround(HEAPF32[i21 >> 2]);
    if (!(f13 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5)))) {
     if ((i2 | 0) == (i21 | 0)) {
      i22 = 52;
      break L1;
     }
     while (1) {
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      if (f13 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break;
      i2 = i2 + 28 | 0;
      if ((i2 | 0) == (i21 | 0)) {
       i22 = 52;
       break L1;
      }
     }
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     i6 = HEAP32[i2 + 8 >> 2] | 0;
     i8 = HEAP32[i2 + 16 >> 2] | 0;
     i10 = HEAP32[i2 + 20 >> 2] | 0;
     i11 = HEAP32[i2 + 24 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
     HEAPF32[i21 >> 2] = f4;
     HEAP32[i15 >> 2] = i3;
     HEAP32[i16 >> 2] = i6;
     HEAPF32[i17 >> 2] = f5;
     HEAP32[i18 >> 2] = i8;
     HEAP32[i19 >> 2] = i10;
     HEAP32[i20 >> 2] = i11;
     i2 = i2 + 28 | 0;
    }
    if ((i2 | 0) == (i21 | 0)) {
     i22 = 52;
     break L1;
    } else i3 = i21;
    while (1) {
     f7 = Math_fround(HEAPF32[i1 >> 2]);
     f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i9 >> 2])) * Math_fround(.5));
     while (1) {
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
      i8 = i2 + 28 | 0;
      if (f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) break; else i2 = i8;
     }
     while (1) {
      i6 = i3 + -28 | 0;
      f25 = Math_fround(HEAPF32[i6 >> 2]);
      if (f7 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -16 >> 2])) * Math_fround(.5))) i3 = i6; else break;
     }
     if (i2 >>> 0 >= i6 >>> 0) {
      i1 = i2;
      continue L5;
     }
     i28 = HEAP32[i2 + 4 >> 2] | 0;
     i27 = HEAP32[i2 + 8 >> 2] | 0;
     i26 = HEAP32[i2 + 16 >> 2] | 0;
     i10 = HEAP32[i2 + 20 >> 2] | 0;
     i11 = HEAP32[i2 + 24 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
     HEAPF32[i6 >> 2] = f4;
     HEAP32[i3 + -24 >> 2] = i28;
     HEAP32[i3 + -20 >> 2] = i27;
     HEAPF32[i3 + -16 >> 2] = f5;
     HEAP32[i3 + -12 >> 2] = i26;
     HEAP32[i3 + -8 >> 2] = i10;
     HEAP32[i3 + -4 >> 2] = i11;
     i3 = i6;
     i2 = i8;
    }
   }
   if ((i22 | 0) == 35) {
    i22 = 0;
    i8 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i1 + 8 >> 2] | 0;
    i26 = HEAP32[i1 + 16 >> 2] | 0;
    i27 = HEAP32[i1 + 20 >> 2] | 0;
    i28 = HEAP32[i1 + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAPF32[i3 >> 2] = f5;
    HEAP32[i6 + -24 >> 2] = i8;
    HEAP32[i6 + -20 >> 2] = i9;
    HEAPF32[i6 + -16 >> 2] = f7;
    HEAP32[i6 + -12 >> 2] = i26;
    HEAP32[i6 + -8 >> 2] = i27;
    HEAP32[i6 + -4 >> 2] = i28;
    i2 = i2 + 1 | 0;
   }
   i6 = i1 + 28 | 0;
   L35 : do if (i6 >>> 0 < i3 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i10 >> 2]);
    f7 = Math_fround(Math_fround(f7 + Math_fround(HEAPF32[i10 + 12 >> 2])) * Math_fround(.5));
    while (1) {
     f4 = Math_fround(HEAPF32[i6 >> 2]);
     f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
     i9 = i6 + 28 | 0;
     if (Math_fround(Math_fround(f4 + f5) * Math_fround(.5)) < f7) i6 = i9; else break;
    }
    while (1) {
     i8 = i3 + -28 | 0;
     f25 = Math_fround(HEAPF32[i8 >> 2]);
     if (Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -16 >> 2])) * Math_fround(.5)) < f7) break; else i3 = i8;
    }
    if (i6 >>> 0 > i8 >>> 0) {
     i3 = i10;
     break L35;
    }
    i30 = HEAP32[i6 + 4 >> 2] | 0;
    i29 = HEAP32[i6 + 8 >> 2] | 0;
    i26 = HEAP32[i6 + 16 >> 2] | 0;
    i27 = HEAP32[i6 + 20 >> 2] | 0;
    i28 = HEAP32[i6 + 24 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAPF32[i8 >> 2] = f4;
    HEAP32[i3 + -24 >> 2] = i30;
    HEAP32[i3 + -20 >> 2] = i29;
    HEAPF32[i3 + -16 >> 2] = f5;
    HEAP32[i3 + -12 >> 2] = i26;
    HEAP32[i3 + -8 >> 2] = i27;
    HEAP32[i3 + -4 >> 2] = i28;
    i10 = (i10 | 0) == (i6 | 0) ? i8 : i10;
    i3 = i8;
    i6 = i9;
    i2 = i2 + 1 | 0;
   } else i3 = i10; while (0);
   if ((i6 | 0) != (i3 | 0)) {
    f25 = Math_fround(HEAPF32[i3 >> 2]);
    f25 = Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + 12 >> 2])) * Math_fround(.5));
    f4 = Math_fround(HEAPF32[i6 >> 2]);
    f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
    if (f25 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5))) {
     i26 = HEAP32[i6 + 4 >> 2] | 0;
     i27 = HEAP32[i6 + 8 >> 2] | 0;
     i28 = HEAP32[i6 + 16 >> 2] | 0;
     i29 = HEAP32[i6 + 20 >> 2] | 0;
     i30 = HEAP32[i6 + 24 >> 2] | 0;
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAPF32[i3 >> 2] = f4;
     HEAP32[i3 + 4 >> 2] = i26;
     HEAP32[i3 + 8 >> 2] = i27;
     HEAPF32[i3 + 12 >> 2] = f5;
     HEAP32[i3 + 16 >> 2] = i28;
     HEAP32[i3 + 20 >> 2] = i29;
     HEAP32[i3 + 24 >> 2] = i30;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeXSorterP16DetailMeshBVNodeEEbT0_S5_T_(i1, i6, i23) | 0;
    i3 = i6 + 28 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR17DetailNodeXSorterP16DetailMeshBVNodeEEbT0_S5_T_(i3, i24, i23) | 0) {
     i22 = 51;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i30 = i6;
   if ((i30 - i11 | 0) >= (i12 - i30 | 0)) {
    i22 = 50;
    break;
   }
   __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_(i1, i6, i23);
   i1 = i6 + 28 | 0;
  }
  if ((i22 | 0) == 50) {
   i22 = 0;
   __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_(i6 + 28 | 0, i24, i23);
   i24 = i6;
   continue;
  } else if ((i22 | 0) == 51) {
   i22 = 0;
   if (i2) {
    i22 = 52;
    break;
   } else {
    i24 = i6;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  f25 = Math_fround(HEAPF32[i21 >> 2]);
  f25 = Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  if (!(f25 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) return;
  i26 = HEAP32[i1 + 4 >> 2] | 0;
  i27 = HEAP32[i1 + 8 >> 2] | 0;
  i28 = HEAP32[i1 + 16 >> 2] | 0;
  i29 = HEAP32[i1 + 20 >> 2] | 0;
  i30 = HEAP32[i1 + 24 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
  HEAPF32[i21 >> 2] = f4;
  HEAP32[i15 >> 2] = i26;
  HEAP32[i16 >> 2] = i27;
  HEAPF32[i17 >> 2] = f5;
  HEAP32[i18 >> 2] = i28;
  HEAP32[i19 >> 2] = i29;
  HEAP32[i20 >> 2] = i30;
  return;
 } else if ((i22 | 0) == 7) {
  __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 8) {
  __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 9) {
  __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 28 | 0, i1 + 56 | 0, i1 + 84 | 0, i21, i23) | 0;
  return;
 } else if ((i22 | 0) == 11) {
  i3 = i1 + 56 | 0;
  __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i1, i1 + 28 | 0, i3, i23) | 0;
  i2 = i1 + 84 | 0;
  if ((i2 | 0) == (i24 | 0)) return;
  while (1) {
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   if (f4 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + 12 >> 2])) * Math_fround(.5))) {
    i8 = HEAP32[i2 + 4 >> 2] | 0;
    i9 = HEAP32[i2 + 8 >> 2] | 0;
    i10 = HEAP32[i2 + 16 >> 2] | 0;
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    i12 = HEAP32[i2 + 24 >> 2] | 0;
    i6 = i2;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i6 = i3 + -28 | 0;
     f25 = Math_fround(HEAPF32[i6 >> 2]);
     if (f4 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i3 + -16 >> 2])) * Math_fround(.5))) {
      i30 = i3;
      i3 = i6;
      i6 = i30;
     } else break;
    }
    HEAPF32[i3 >> 2] = f5;
    HEAP32[i3 + 4 >> 2] = i8;
    HEAP32[i3 + 8 >> 2] = i9;
    HEAPF32[i3 + 12 >> 2] = f7;
    HEAP32[i3 + 16 >> 2] = i10;
    HEAP32[i3 + 20 >> 2] = i11;
    HEAP32[i3 + 24 >> 2] = i12;
   }
   i3 = i2 + 28 | 0;
   if ((i3 | 0) == (i24 | 0)) break; else {
    i30 = i2;
    i2 = i3;
    i3 = i30;
   }
  }
  return;
 } else if ((i22 | 0) == 52) return;
}

function __ZN5physx31PxClothGeodesicTetherCookerImpl23computeGeodesicDistanceEjjRi(i51, i2, i49, i52) {
 i51 = i51 | 0;
 i2 = i2 | 0;
 i49 = i49 | 0;
 i52 = i52 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i53 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i53;
 if ((i2 | 0) == (i49 | 0)) {
  f41 = Math_fround(0.0);
  STACKTOP = i53;
  return Math_fround(f41);
 }
 HEAP32[i52 >> 2] = 0;
 i2 = __ZN5physx31PxClothGeodesicTetherCookerImpl25computeVertexIntersectionEjjRN12_GLOBAL__N_116PathIntersectionE(i51, i49, i2, i50) | 0;
 if ((i2 | 0) < 0) {
  HEAP32[i52 >> 2] = -1;
  f41 = Math_fround(0.0);
  STACKTOP = i53;
  return Math_fround(f41);
 }
 if ((i2 | 0) <= 0) {
  f41 = Math_fround(0.0);
  STACKTOP = i53;
  return Math_fround(f41);
 }
 i42 = i50 + 12 | 0;
 i43 = i50 + 4 | 0;
 i44 = i50 + 8 | 0;
 i45 = i51 + 20 | 0;
 i46 = i51 + 8 | 0;
 i47 = i51 + 68 | 0;
 f1 = Math_fround(0.0);
 i48 = 0;
 L11 : while (1) {
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i42 >> 2]));
  i2 = HEAP32[i43 >> 2] | 0;
  do if (!(HEAP32[i50 >> 2] | 0)) {
   f41 = Math_fround(HEAPF32[i44 >> 2]);
   i8 = (i2 | 0) % 3 | 0;
   i3 = HEAP32[i45 >> 2] | 0;
   i32 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   i33 = HEAP32[i3 + (i2 - i8 + ((i8 + 1 | 0) % 3 | 0) << 2) >> 2] | 0;
   i38 = HEAP32[i46 >> 2] | 0;
   f39 = Math_fround(HEAPF32[i38 + (i32 * 12 | 0) >> 2]);
   f40 = Math_fround(HEAPF32[i38 + (i32 * 12 | 0) + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i38 + (i32 * 12 | 0) + 8 >> 2]);
   f34 = Math_fround(HEAPF32[i38 + (i33 * 12 | 0) >> 2]);
   f35 = Math_fround(HEAPF32[i38 + (i33 * 12 | 0) + 4 >> 2]);
   f34 = Math_fround(f34 - f39);
   f35 = Math_fround(f35 - f40);
   f36 = Math_fround(Math_fround(HEAPF32[i38 + (i33 * 12 | 0) + 8 >> 2]) - f17);
   f39 = Math_fround(f39 + Math_fround(f41 * f34));
   f40 = Math_fround(f40 + Math_fround(f41 * f35));
   f41 = Math_fround(f17 + Math_fround(f41 * f36));
   f17 = Math_fround(Math_fround(HEAPF32[i38 + (i49 * 12 | 0) >> 2]) - f39);
   f18 = Math_fround(Math_fround(HEAPF32[i38 + (i49 * 12 | 0) + 4 >> 2]) - f40);
   f20 = Math_fround(Math_fround(HEAPF32[i38 + (i49 * 12 | 0) + 8 >> 2]) - f41);
   i2 = HEAP32[(HEAP32[i47 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i2 | 0) == -1) {
    i2 = Math_fround(Math_fround(Math_fround(f34 * f17) + Math_fround(f35 * f18)) + Math_fround(f36 * f20)) > Math_fround(0.0);
    i2 = i2 ? i33 : i32;
    f39 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) >> 2]) - f39);
    f40 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 4 >> 2]) - f40);
    f41 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 8 >> 2]) - f41);
    f41 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)) + Math_fround(f41 * f41))));
    HEAP32[i50 >> 2] = 1;
    HEAP32[i43 >> 2] = i2;
    HEAPF32[i44 >> 2] = Math_fround(0.0);
    HEAPF32[i42 >> 2] = f41;
    i2 = 1;
    break;
   }
   i37 = i2 * 3 | 0;
   i12 = HEAP32[i3 + (i37 << 2) >> 2] | 0;
   i13 = HEAP32[i3 + (i37 + 1 << 2) >> 2] | 0;
   i9 = HEAP32[i3 + (i37 + 2 << 2) >> 2] | 0;
   i2 = (i12 | 0) == (i32 | 0);
   i3 = (i13 | 0) == (i33 | 0);
   if (i2 & i3) {
    i5 = 0;
    i3 = i32;
    i4 = i33;
   } else {
    i4 = (i12 | 0) == (i33 | 0);
    i5 = (i13 | 0) == (i32 | 0);
    if (i4 & i5) {
     i5 = 0;
     i3 = i33;
     i4 = i32;
    } else {
     i6 = (i9 | 0) == (i33 | 0);
     i7 = (i9 | 0) == (i32 | 0);
     if (i5 & i6 | i3 & i7) {
      i5 = 1;
      i3 = i13;
      i4 = i9;
      i9 = i12;
     } else {
      i7 = i4 & i7 | i2 & i6;
      i5 = i7 ? 2 : i8;
      i3 = i7 ? i9 : i12;
      i4 = i7 ? i12 : i13;
      i9 = i7 ? i13 : i9;
     }
    }
   }
   if ((i9 | 0) == (i49 | 0)) {
    f41 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f20 * f20))));
    HEAP32[i50 >> 2] = 1;
    HEAP32[i43 >> 2] = i49;
    HEAPF32[i44 >> 2] = Math_fround(0.0);
    HEAPF32[i42 >> 2] = f41;
    i2 = 1;
    break;
   }
   f24 = Math_fround(HEAPF32[i38 + (i3 * 12 | 0) >> 2]);
   f25 = Math_fround(HEAPF32[i38 + (i3 * 12 | 0) + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i38 + (i3 * 12 | 0) + 8 >> 2]);
   f29 = Math_fround(HEAPF32[i38 + (i4 * 12 | 0) >> 2]);
   f30 = Math_fround(HEAPF32[i38 + (i4 * 12 | 0) + 4 >> 2]);
   f31 = Math_fround(HEAPF32[i38 + (i4 * 12 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i38 + (i9 * 12 | 0) >> 2]);
   f27 = Math_fround(HEAPF32[i38 + (i9 * 12 | 0) + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i38 + (i9 * 12 | 0) + 8 >> 2]);
   f24 = Math_fround(f24 - f19);
   f25 = Math_fround(f25 - f27);
   f26 = Math_fround(f26 - f28);
   f10 = Math_fround(f29 - f19);
   f11 = Math_fround(f30 - f27);
   f14 = Math_fround(f31 - f28);
   f15 = Math_fround(Math_fround(f25 * f14) - Math_fround(f11 * f26));
   f14 = Math_fround(Math_fround(f10 * f26) - Math_fround(f24 * f14));
   f10 = Math_fround(Math_fround(f24 * f11) - Math_fround(f10 * f25));
   f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)));
   if (f11 > Math_fround(0.0)) {
    f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f11))));
    f16 = Math_fround(f10 * f23);
    f11 = Math_fround(f14 * f23);
    f10 = Math_fround(f15 * f23);
   } else {
    f16 = Math_fround(0.0);
    f11 = Math_fround(0.0);
    f10 = Math_fround(0.0);
   }
   f23 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f18 * f11)) + Math_fround(f20 * f16));
   f15 = Math_fround(f17 - Math_fround(f10 * f23));
   f14 = Math_fround(f18 - Math_fround(f11 * f23));
   f10 = Math_fround(f20 - Math_fround(f16 * f23));
   f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)));
   if (f11 > Math_fround(0.0)) {
    f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f11))));
    f23 = Math_fround(f10 * f21);
    f22 = Math_fround(f14 * f21);
    f21 = Math_fround(f15 * f21);
   } else {
    f23 = Math_fround(0.0);
    f22 = Math_fround(0.0);
    f21 = Math_fround(0.0);
   }
   f18 = Math_fround(f39 - f19);
   f11 = Math_fround(f40 - f27);
   f16 = Math_fround(f41 - f28);
   f14 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
   f10 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f25 * f22)) + Math_fround(f26 * f23));
   f20 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f23 * f23));
   f15 = Math_fround(Math_fround(Math_fround(f18 * f24) + Math_fround(f11 * f25)) + Math_fround(f16 * f26));
   f16 = Math_fround(-Math_fround(Math_fround(Math_fround(f18 * f21) + Math_fround(f11 * f22)) + Math_fround(f16 * f23)));
   f11 = Math_fround(Math_fround(f14 * f20) - Math_fround(f10 * f10));
   if (!(Math_fround(Math_abs(Math_fround(f11))) < Math_fround(.0000999999974))) {
    f18 = Math_fround(Math_fround(1.0) / f11);
    f17 = Math_fround(f10 * f18);
    f10 = Math_fround(Math_fround(f15 * Math_fround(f20 * f18)) + Math_fround(f17 * f16));
    if (Math_fround(Math_fround(f15 * f17) + Math_fround(Math_fround(f14 * f18) * f16)) > Math_fround(-9.99999974e-06) & (f10 >= Math_fround(-9.99999974e-06) & f10 <= Math_fround(1.00001001))) {
     i2 = f10 < Math_fround(9.99999974e-06);
     if (i2 | f10 > Math_fround(.999989986)) {
      HEAP32[i50 >> 2] = 1;
      i2 = i2 ? i9 : i3;
      HEAP32[i43 >> 2] = i2;
      f39 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) >> 2]) - f39);
      f40 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 4 >> 2]) - f40);
      f41 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 8 >> 2]) - f41);
      HEAPF32[i42 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)) + Math_fround(f41 * f41))));
      i2 = 1;
      break;
     } else {
      f39 = Math_fround(Math_fround(f19 + Math_fround(f24 * f10)) - f39);
      f40 = Math_fround(Math_fround(f27 + Math_fround(f25 * f10)) - f40);
      f41 = Math_fround(Math_fround(f28 + Math_fround(f26 * f10)) - f41);
      f41 = Math_fround(Math_sqrt(Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)))));
      HEAP32[i50 >> 2] = 0;
      HEAP32[i43 >> 2] = ((i5 + 2 | 0) % 3 | 0) + i37;
      HEAPF32[i44 >> 2] = f10;
      HEAPF32[i42 >> 2] = f41;
      i2 = 1;
      break;
     }
    }
   }
   f26 = Math_fround(f39 - f29);
   f11 = Math_fround(f40 - f30);
   f16 = Math_fround(f41 - f31);
   f19 = Math_fround(f19 - f29);
   f18 = Math_fround(f27 - f30);
   f17 = Math_fround(f28 - f31);
   f14 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)) + Math_fround(f17 * f17));
   f10 = Math_fround(Math_fround(Math_fround(f19 * f21) + Math_fround(f18 * f22)) + Math_fround(f17 * f23));
   f15 = Math_fround(Math_fround(Math_fround(f26 * f19) + Math_fround(f11 * f18)) + Math_fround(f16 * f17));
   f16 = Math_fround(-Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(f11 * f22)) + Math_fround(f16 * f23)));
   f11 = Math_fround(Math_fround(f14 * f20) - Math_fround(f10 * f10));
   if (!(Math_fround(Math_abs(Math_fround(f11))) < Math_fround(.0000999999974))) {
    f28 = Math_fround(Math_fround(1.0) / f11);
    f27 = Math_fround(f10 * f28);
    f10 = Math_fround(Math_fround(f15 * Math_fround(f20 * f28)) + Math_fround(f27 * f16));
    if (Math_fround(Math_fround(f15 * f27) + Math_fround(Math_fround(f14 * f28) * f16)) > Math_fround(-9.99999974e-06) & (f10 >= Math_fround(-9.99999974e-06) & f10 <= Math_fround(1.00001001))) {
     i2 = f10 < Math_fround(9.99999974e-06);
     if (i2 | f10 > Math_fround(.999989986)) {
      HEAP32[i50 >> 2] = 1;
      i2 = i2 ? i4 : i9;
      HEAP32[i43 >> 2] = i2;
      f39 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) >> 2]) - f39);
      f40 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 4 >> 2]) - f40);
      f41 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 8 >> 2]) - f41);
      HEAPF32[i42 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)) + Math_fround(f41 * f41))));
      i2 = 1;
      break;
     } else {
      f39 = Math_fround(Math_fround(f29 + Math_fround(f19 * f10)) - f39);
      f40 = Math_fround(Math_fround(f30 + Math_fround(f18 * f10)) - f40);
      f41 = Math_fround(Math_fround(f31 + Math_fround(f17 * f10)) - f41);
      f41 = Math_fround(Math_sqrt(Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)))));
      HEAP32[i50 >> 2] = 0;
      HEAP32[i43 >> 2] = ((i5 + 1 | 0) % 3 | 0) + i37;
      HEAPF32[i44 >> 2] = f10;
      HEAPF32[i42 >> 2] = f41;
      i2 = 1;
      break;
     }
    }
   }
   f36 = Math_fround(Math_fround(Math_fround(f34 * f21) + Math_fround(f35 * f22)) + Math_fround(f36 * f23));
   HEAP32[i50 >> 2] = 1;
   i2 = f36 > Math_fround(0.0);
   i2 = i2 ? i33 : i32;
   HEAP32[i43 >> 2] = i2;
   f39 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) >> 2]) - f39);
   f40 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 4 >> 2]) - f40);
   f41 = Math_fround(Math_fround(HEAPF32[i38 + (i2 * 12 | 0) + 8 >> 2]) - f41);
   HEAPF32[i42 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)) + Math_fround(f41 * f41))));
   i2 = 1;
  } else {
   i2 = __ZN5physx31PxClothGeodesicTetherCookerImpl25computeVertexIntersectionEjjRN12_GLOBAL__N_116PathIntersectionE(i51, i49, i2, i50) | 0;
   if ((i2 | 0) < 0) {
    i2 = 32;
    break L11;
   }
  } while (0);
  if ((i48 | 0) > 1e3) {
   i2 = 34;
   break;
  }
  if ((i2 | 0) > 0) i48 = i48 + 1 | 0; else {
   i2 = 35;
   break;
  }
 }
 if ((i2 | 0) == 32) {
  HEAP32[i52 >> 2] = -2;
  f41 = Math_fround(0.0);
  STACKTOP = i53;
  return Math_fround(f41);
 } else if ((i2 | 0) == 34) {
  HEAP32[i52 >> 2] = -3;
  f41 = Math_fround(0.0);
  STACKTOP = i53;
  return Math_fround(f41);
 } else if ((i2 | 0) == 35) {
  STACKTOP = i53;
  return Math_fround(f1);
 }
 return Math_fround(0.0);
}

function __ZL21DeferredRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i54 = i73 + 952 | 0;
 i61 = i73 + 944 | 0;
 i65 = i73 + 940 | 0;
 i3 = i73 + 976 | 0;
 i72 = i73 + 744 | 0;
 i66 = i73 + 520 | 0;
 i67 = i73 + 504 | 0;
 i68 = i73 + 492 | 0;
 i69 = i73 + 392 | 0;
 i55 = i73 + 380 | 0;
 i56 = i73 + 256 | 0;
 i57 = i73 + 124 | 0;
 i58 = i73;
 if ((HEAP16[gb + 1114600 + 6 >> 1] | 0) > -1) {
  HEAP32[i61 >> 2] = 0;
  HEAP32[i54 >> 2] = HEAP32[i61 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114600 | 0, i54);
  i71 = gb + 1114600 | 0;
 } else i71 = 0;
 i59 = i5 + 12 | 0;
 i60 = HEAP32[i5 + 8 >> 2] | 0;
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 i62 = HEAP32[i6 + 1832 >> 2] | 0;
 i6 = HEAP32[i6 + 1828 >> 2] | 0;
 i63 = i6 + 65728 | 0;
 __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext(i4 + 244 | 0, i4 + 260 | 0, i59);
 i64 = i4 + 408 | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i72, i3, i62, (HEAP8[i64 >> 0] & 2) != 0, 1);
 __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats(i66, i72, i3);
 HEAP32[i67 + 4 >> 2] = i72;
 HEAP32[i67 + 8 >> 2] = i3;
 HEAP8[i67 >> 0] = 1;
 i19 = __Z12GetGfxDevicev() | 0;
 HEAPF32[i19 + 980 >> 2] = Math_fround(1.0);
 HEAPF32[i19 + 984 >> 2] = Math_fround(1.0);
 HEAPF32[i19 + 988 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 992 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 996 >> 2] = Math_fround(1.0);
 HEAPF32[i19 + 1e3 >> 2] = Math_fround(1.0);
 HEAPF32[i19 + 1004 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 1008 >> 2] = Math_fround(0.0);
 __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats(i68, i72, i3);
 HEAP32[i69 >> 2] = 0;
 HEAP32[i69 >> 2] = HEAP32[(__ZN10builtintex16GetDefaultTexEnvE16TextureDimension(3) | 0) >> 2];
 HEAPF32[i69 + 4 >> 2] = Math_fround(1.0);
 i19 = i69 + 8 | 0;
 i20 = i54 + 12 | 0;
 HEAP32[i54 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i20 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i54 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i54 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i54 + 20 >> 2];
 i19 = i69 + 32 | 0;
 i20 = gb + 1162292 | 0;
 i21 = i19 + 64 | 0;
 do {
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  i19 = i19 + 4 | 0;
  i20 = i20 + 4 | 0;
 } while ((i19 | 0) < (i21 | 0));
 HEAP8[i69 + 96 >> 0] = 1;
 HEAP32[i55 >> 2] = i72;
 i53 = __Z12GetGfxDevicev() | 0;
 HEAP32[i55 + 4 >> 2] = i53 + 4;
 HEAPF32[i55 + 8 >> 2] = Math_fround(0.0);
 i53 = i53 + 964 | 0;
 HEAP32[i53 >> 2] = 0;
 HEAP32[i53 + 4 >> 2] = 0;
 HEAP32[i53 + 8 >> 2] = 0;
 HEAP32[i53 + 12 >> 2] = 0;
 __ZN16ReflectionSampleC2Ev(i56);
 if (!(HEAP8[i64 >> 0] & 1)) {
  i19 = i56;
  i20 = i6 + 65816 | 0;
  i21 = i19 + 124 | 0;
  do {
   HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
   i19 = i19 + 4 | 0;
   i20 = i20 + 4 | 0;
  } while ((i19 | 0) < (i21 | 0));
 } else {
  i1 = i56 + 24 | 0;
  HEAP32[i1 >> 2] = __ZN10builtintex21GetBlackCubeTextureIDEv() | 0;
  i2 = i56 + 28 | 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i54, 0, 0);
  HEAP32[i2 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  i2 = i56 + 84 | 0;
  HEAP32[i2 >> 2] = __ZN10builtintex21GetBlackCubeTextureIDEv() | 0;
  i53 = i56 + 88 | 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i54, 0, 0);
  HEAP32[i53 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  if (HEAP32[i72 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i72);
  __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i72, i56);
  HEAP32[i61 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i54 >> 2] = HEAP32[i61 >> 2];
  __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i72, 19, 4, 0, i54);
  HEAP32[i65 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i54 >> 2] = HEAP32[i65 >> 2];
  __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i72, 20, 4, 0, i54);
 }
 __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats(i57, i72, i3);
 i2 = HEAP32[i5 + 176 >> 2] | 0;
 i41 = i5 + 180 | 0;
 i3 = HEAP32[i41 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i1 = i5 + 16 | 0; else {
  i42 = i4 + 88 | 0;
  i43 = i4 + 16 | 0;
  i44 = i4 + 36 | 0;
  i45 = i4 + 276 | 0;
  i46 = i45 + 128 | 0;
  i47 = i57 + 128 | 0;
  i48 = i58 + 24 | 0;
  i49 = i58 + 84 | 0;
  i50 = i61 + 4 | 0;
  i51 = i4 + 108 + 4 | 0;
  i52 = i72 + 192 | 0;
  i1 = i5 + 16 | 0;
  i53 = i60 + 608 | 0;
  i38 = i4 + 12 | 0;
  i39 = i72 + 184 | 0;
  i40 = i72 + 188 | 0;
  i35 = i5 + 168 | 0;
  i36 = i60 + 4376 | 0;
  i37 = HEAP32[i68 + 4 >> 2] | 0;
  i34 = i6 + 65940 | 0;
  i10 = 0;
  i9 = -1;
  i8 = -1;
  i7 = -1;
  i5 = 0;
  i4 = 0;
  i6 = 0;
  do {
   i15 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i16 = HEAP32[i43 >> 2] | 0;
   i32 = HEAP32[i16 + (i15 << 5) >> 2] | 0;
   i11 = HEAP16[i16 + (i15 << 5) + 16 >> 1] | 0;
   i33 = i32;
   if (i11 << 16 >> 16 == -1) i14 = HEAP32[(HEAP32[i32 + 32 >> 2] | 0) + 40 >> 2] | 0; else i14 = i11 << 16 >> 16;
   if ((i14 | 0) != -1) if (!(HEAP8[(HEAP32[i44 >> 2] | 0) + i2 >> 0] & 2)) {
    i13 = i16 + (i15 << 5) + 8 | 0;
    i22 = HEAP32[i13 >> 2] | 0;
    i23 = HEAP32[i62 >> 2] | 0;
    i12 = i23 + (i22 * 360 | 0) | 0;
    i25 = HEAP32[i23 + (i22 * 360 | 0) + 176 >> 2] << 13 & 32768;
    i3 = i23 + (i22 * 360 | 0) + 252 | 0;
    i24 = HEAP32[i3 >> 2] | 0;
    i24 = (i24 & 2147483647 | 0) == 0 ? 0 : i24 >> 15 & 131072 | 65536;
    i27 = i25 | i11 & 32767 | i24;
    i28 = HEAP32[i23 + (i22 * 360 | 0) + 224 >> 2] | 0;
    i29 = HEAP32[(HEAP32[i23 + (i22 * 360 | 0) + 324 >> 2] | 0) + (HEAPU16[i16 + (i15 << 5) + 18 >> 1] << 3) >> 2] | 0;
    i30 = i23 + (i22 * 360 | 0) + 224 | 0;
    i31 = i28 & 65535;
    i17 = HEAP8[i46 >> 0] | 0;
    i17 = __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i12, (i17 & 2) != 0, (i17 & 1) != 0) | 0;
    i18 = HEAP8[(HEAP32[i44 >> 2] | 0) + i2 >> 0] & 1;
    __ZN15LightmapSTCache5ApplyERK10RenderNode(i67, i12);
    __ZN12LODFadeCache14ApplyValueOnlyEf(i55, Math_fround(HEAPF32[i3 >> 2]));
    __Z7ApplySHR15SHConstantCacheRK17LightProbeContextRK10RenderNodeb(i66, i45, i12, i17);
    i3 = HEAP16[i23 + (i22 * 360 | 0) + 268 >> 1] | 0;
    if (i3 << 16 >> 16 != -1) {
     i11 = (HEAP32[i34 >> 2] | 0) + ((i3 << 16 >> 16) * 100 | 0) | 0;
     i19 = i69;
     i20 = i11;
     i21 = i19 + 96 | 0;
     do {
      HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
      i19 = i19 + 4 | 0;
      i20 = i20 + 4 | 0;
     } while ((i19 | 0) < (i21 | 0));
     HEAP8[i69 + 96 >> 0] = HEAP8[i11 + 96 >> 0] | 0;
    }
    if ((HEAP16[i68 >> 1] | 0) != i3 << 16 >> 16) {
     HEAP16[i68 >> 1] = i3;
     __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb(i37, i69, i3 << 16 >> 16 != -1);
    }
    if (!(HEAP8[i64 >> 0] & 1)) {
     __ZN16ReflectionSampleC2Ev(i58);
     __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_(i63, i12, i56, i58);
     if (_memcmp(i57, i58, 124) | 0) {
      i19 = i57;
      i20 = i58;
      i21 = i19 + 124 | 0;
      do {
       HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
       i19 = i19 + 4 | 0;
       i20 = i20 + 4 | 0;
      } while ((i19 | 0) < (i21 | 0));
      i3 = HEAP32[i47 >> 2] | 0;
      if (HEAP32[i3 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i3);
      __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i3, i58);
      HEAP32[i61 >> 2] = HEAP32[i48 >> 2];
      HEAP32[i54 >> 2] = HEAP32[i61 >> 2];
      __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i3, 19, 4, 0, i54);
      HEAP32[i65 >> 2] = HEAP32[i49 >> 2];
      HEAP32[i54 >> 2] = HEAP32[i65 >> 2];
      __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i3, 20, 4, 0, i54);
     }
    }
    HEAP32[i61 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i50 >> 2] = HEAPU16[i16 + (i15 << 5) + 14 >> 1];
    i19 = HEAP32[(HEAP32[HEAP32[i32 + 32 >> 2] >> 2] | 0) + (i14 << 2) >> 2] | 0;
    i20 = HEAP32[i19 + 20 >> 2] | 0;
    if ((i20 | 0) > 0) {
     i21 = i23 + (i22 * 360 | 0) + 240 | 0;
     i17 = ((i18 & 255) << 5 | ((i31 & 65535) > 65533 & (i17 ^ 1) ? 192 : 128)) ^ 32;
     i18 = i29;
     i16 = i23 + (i22 * 360 | 0) + 260 | 0;
     i15 = i28 >>> 16 & 65535;
     i14 = i24 << 14 >> 30;
     f26 = i25 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
     i13 = i32 + 32 | 0;
     i12 = 0;
     i3 = i6;
     do {
      i11 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i12 << 2) >> 2] | 0;
      if ((HEAP32[i11 + 696 >> 2] | 0) == 10) {
       i6 = HEAP32[i51 + (HEAP32[i21 >> 2] << 2) >> 2] | 0;
       i6 = ((i6 | 0) == -1 ? 0 : 1 << i6) | i17;
       do if ((i18 | 0) == (i10 | 0)) if ((i27 | 0) == (i9 | 0) & ((i32 | 0) == (i4 | 0) & (i11 | 0) == (i3 | 0))) {
        if ((i6 | 0) != (i5 | 0) ? 1 : (i28 | 0) != ((i7 & 65535) << 16 | i8 & 65535 | 0)) {
         i70 = 36;
         break;
        }
        if ((HEAP32[i16 >> 2] | 0) != (HEAP32[i52 >> 2] | 0)) i70 = 36;
       } else i70 = 36; else i70 = 36; while (0);
       if ((i70 | 0) == 36) {
        i70 = 0;
        __ZN13BatchRenderer5FlushEv(i72);
        switch (i14 | 0) {
        case 1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 8388608;
          break;
         }
        case -1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 4194304;
          break;
         }
        default:
         HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913;
        }
        HEAPF32[i53 >> 2] = f26;
        __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext(HEAP32[i38 >> 2] | 0, i30, i59);
        HEAP32[i54 >> 2] = 0;
        HEAP32[i54 + 4 >> 2] = 0;
        HEAP32[i54 + 8 >> 2] = 0;
        HEAP32[i54 + 12 >> 2] = 0;
        HEAP32[i54 + 16 >> 2] = 0;
        HEAP32[i54 + 20 >> 2] = 0;
        i3 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i18, i59, i32, i11, i12, (HEAP32[i11 + 744 >> 2] | 0) == 0, 0, i54) | 0;
        HEAP32[i39 >> 2] = i3;
        if (!i3) i3 = 0; else i3 = HEAP32[i3 >> 2] & 1;
        i10 = HEAP8[i40 >> 0] & -4 | i3;
        HEAP8[i40 >> 0] = i10;
        HEAP8[i40 >> 0] = (HEAP32[(HEAP32[i13 >> 2] | 0) + 64 >> 2] & 255) << 2 & 12 | i10 & -13;
        mftCall_viii(HEAP32[(HEAP32[i60 >> 2] | 0) + 72 >> 2] | 0, i60 | 0, HEAP32[i35 >> 2] | 0, HEAP32[i36 >> 2] | i6 | 0);
        i10 = i29;
        i8 = i31;
        i7 = i15;
        i5 = i6;
        i4 = i33;
        i3 = i11;
       }
       __ZN13BatchRenderer3AddERK17BatchInstanceData(i72, i61);
       i9 = i27;
      }
      i12 = i12 + 1 | 0;
     } while ((i12 | 0) != (i20 | 0));
    } else i3 = i6;
    i6 = i3;
    i3 = HEAP32[i41 >> 2] | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 __ZN13BatchRenderer5FlushEv(i72);
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 __ZN13BatchRendererD2Ev(i72);
 if (!i71) {
  STACKTOP = i73;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i71);
 STACKTOP = i73;
 return;
}
function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEbT0_S7_T_(i9, i8, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i10 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 switch (i8 - i9 >> 4 | 0) {
 case 2:
  {
   i1 = i8 + -16 | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i9 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 3:
  {
   i3 = i9 + 16 | 0;
   i1 = i8 + -16 | 0;
   f7 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = f7 < Math_fround(HEAPF32[i9 >> 2]);
   i2 = Math_fround(HEAPF32[i1 >> 2]) < f7;
   if (!i8) {
    if (!i2) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    };
    HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    f7 = Math_fround(HEAPF32[i3 >> 2]);
    if (!(f7 < Math_fround(HEAPF32[i9 >> 2]))) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    };
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   if (i2) {
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i3 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i9, i9 + 16 | 0, i9 + 32 | 0, i8 + -16 | 0, i2) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 5:
  {
   i3 = i9 + 16 | 0;
   i4 = i9 + 32 | 0;
   i5 = i9 + 48 | 0;
   i1 = i8 + -16 | 0;
   __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i9, i3, i4, i5, i2) | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i5 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   if (!(Math_fround(HEAPF32[i5 >> 2]) < Math_fround(HEAPF32[i4 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   if (!(Math_fround(HEAPF32[i4 >> 2]) < Math_fround(HEAPF32[i3 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   if (!(Math_fround(HEAPF32[i3 >> 2]) < Math_fround(HEAPF32[i9 >> 2]))) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i3 = i9 + 32 | 0;
   i1 = i9 + 16 | 0;
   f12 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(HEAPF32[i9 >> 2]);
   f7 = Math_fround(HEAPF32[i3 >> 2]);
   i2 = f7 < f12;
   do if (f12 < f6) {
    if (i2) {
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break;
    };
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    if (f7 < Math_fround(HEAPF32[i1 >> 2])) {
     HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    }
   } else if (i2) {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    if (Math_fround(HEAPF32[i1 >> 2]) < f6) {
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    }
   } while (0);
   i1 = i9 + 48 | 0;
   L13 : do if ((i1 | 0) == (i8 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     if (f6 < Math_fround(HEAPF32[i3 >> 2])) {
      i4 = i1 + 4 | 0;
      HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       if ((i3 | 0) == (i9 | 0)) {
        i3 = i9;
        break;
       }
       i4 = i3 + -16 | 0;
       if (f6 < Math_fround(HEAPF32[i4 >> 2])) {
        i5 = i3;
        i3 = i4;
        i4 = i5;
       } else break;
      }
      HEAPF32[i3 >> 2] = f6;
      i5 = i3 + 4 | 0;
      HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 16 | 0) == (i8 | 0);
       break L13;
      }
     }
     i3 = i1 + 16 | 0;
     if ((i3 | 0) == (i8 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i5 = i1;
      i1 = i3;
      i3 = i5;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN18GlslGpuProgramGLES14CompileProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_S8_S8_S8_R14ChannelAssigns(i26, i3, i4, i16, i21, i17, i23) {
 i26 = i26 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 48 | 0;
 i14 = i29 + 36 | 0;
 i28 = i29 + 24 | 0;
 i24 = i29 + 12 | 0;
 i25 = i29;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 i1 = HEAP32[gb + 1451148 >> 2] | 0;
 do if (!(HEAP8[i1 + 117 >> 0] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  if (HEAP8[i1 + 170 >> 0] | 0) {
   i22 = HEAP8[i16 + 11 >> 0] | 0;
   if ((i22 << 24 >> 24 < 0 ? HEAP32[i16 + 4 >> 2] | 0 : i22 & 255) | 0) {
    i1 = 0;
    i2 = 0;
    break;
   }
  }
  i1 = i27;
  i2 = i1 + 33 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  __Z19GetCachedBinaryNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_S7_S7_R11fixed_arrayIcLj33EE(i3, i4, i16, i21, i17, i27);
  i22 = __Z22GetShaderCachePathGLESv() | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  i2 = HEAP8[i22 + 11 >> 0] | 0;
  i19 = i2 << 24 >> 24 < 0;
  i2 = i19 ? HEAP32[i22 + 4 >> 2] | 0 : i2 & 255;
  i1 = _strlen(i27) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i19 ? HEAP32[i22 >> 2] | 0 : i22, i2, i2 + i1 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, i27, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i28, i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i1 = HEAP8[i28 + 11 >> 0] | 0;
  i2 = HEAP32[i28 + 4 >> 2] | 0;
 } while (0);
 i18 = i28 + 11 | 0;
 i22 = i28 + 4 | 0;
 if (!((i1 << 24 >> 24 < 0 ? i2 : i1 & 255) | 0)) i20 = 8; else if (__ZN18GlslGpuProgramGLES25LoadFromBinaryShaderCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER14ChannelAssignsPKc(i26, i3, i23, (HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i28 >> 2] | 0 : i28) | 0) {
  i6 = i17 + 11 | 0;
  i5 = i17 + 4 | 0;
  i4 = i16 + 11 | 0;
  i3 = i16 + 4 | 0;
  i2 = i21 + 11 | 0;
  i1 = i21 + 4 | 0;
 } else i20 = 8;
 if ((i20 | 0) == 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i24, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i25, i4);
  i4 = i16 + 11 | 0;
  i15 = HEAP8[i4 >> 0] | 0;
  i19 = i16 + 4 | 0;
  if ((i15 << 24 >> 24 < 0 ? HEAP32[i19 >> 2] | 0 : i15 & 255) | 0) if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 119 >> 0] | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
  i2 = i21 + 11 | 0;
  i15 = HEAP8[i2 >> 0] | 0;
  i1 = i21 + 4 | 0;
  if ((i15 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i15 & 255) | 0) if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 120 >> 0] | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
  i15 = i17 + 11 | 0;
  i13 = HEAP8[i15 >> 0] | 0;
  i5 = i17 + 4 | 0;
  if ((i13 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i13 & 255) | 0) if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 120 >> 0] | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
  i13 = HEAP8[i24 + 11 >> 0] | 0;
  i3 = i13 << 24 >> 24 < 0;
  i13 = i3 ? HEAP32[i24 + 4 >> 2] | 0 : i13 & 255;
  if (i13 | 0) {
   do if (!(HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 16 >> 2] | 0)) {
    i3 = i3 ? HEAP32[i24 >> 2] | 0 : i24;
    if (i13 >>> 0 < 9) i20 = 27; else {
     i11 = i3 + i13 | 0;
     i9 = i11;
     i12 = i3;
     L33 : do if ((i13 | 0) < 9) i6 = i9; else {
      i10 = i11 + -8 | 0;
      if ((i10 | 0) == (i3 | 0)) i6 = i9; else {
       i6 = i3;
       L35 : while (1) {
        while (1) {
         if ((HEAP8[i6 >> 0] | 0) == 116) {
          i7 = gb + 604653 | 0;
          i8 = i6;
          break;
         }
         i6 = i6 + 1 | 0;
         if ((i6 | 0) == (i10 | 0)) {
          i6 = i9;
          break L33;
         }
        }
        do {
         i7 = i7 + 1 | 0;
         if ((i7 | 0) == (gb + 604653 + 9 | 0)) break L35;
         i8 = i8 + 1 | 0;
        } while ((HEAP8[i8 >> 0] | 0) == (HEAP8[i7 >> 0] | 0));
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (i10 | 0)) {
         i6 = i9;
         break L33;
        }
       }
      }
     } while (0);
     if ((i6 | 0) == (i11 | 0) | (i6 - i12 | 0) == -1) i20 = 27;
    }
    if ((i20 | 0) == 27) {
     if (i13 >>> 0 < 5) {
      i20 = 39;
      break;
     }
     i10 = i3 + i13 | 0;
     i9 = i10;
     i11 = i3;
     L49 : do if ((i13 | 0) < 5) i3 = i9; else {
      i8 = i10 + -4 | 0;
      if ((i8 | 0) == (i3 | 0)) i3 = i9; else L51 : while (1) {
       while (1) {
        if ((HEAP8[i3 >> 0] | 0) == 116) {
         i6 = gb + 604663 | 0;
         i7 = i3;
         break;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i8 | 0)) {
         i3 = i9;
         break L49;
        }
       }
       do {
        i6 = i6 + 1 | 0;
        if ((i6 | 0) == (gb + 604663 + 5 | 0)) break L51;
        i7 = i7 + 1 | 0;
       } while ((HEAP8[i7 >> 0] | 0) == (HEAP8[i6 >> 0] | 0));
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i8 | 0)) {
        i3 = i9;
        break L49;
       }
      }
     } while (0);
     if ((i3 | 0) == (i10 | 0) | (i3 - i11 | 0) == -1) {
      i20 = 39;
      break;
     }
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 604669 | 0, 0, gb + 604722 | 0, 795, 1, 0, 0, 0);
    i3 = 0;
   } else i20 = 39; while (0);
   if ((i20 | 0) == 39) {
    HEAP32[i27 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i27, i24) | 0; else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i24);
     __ZL39PatchShaderSourceForAdrenoES3WorkaroundNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPS5_(i14, i27);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    }
    i3 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 0, (HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   }
   HEAP32[i26 + 60 >> 2] = i3;
  }
  i20 = HEAP8[i25 + 11 >> 0] | 0;
  if ((i20 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i20 & 255) | 0) HEAP32[i26 + 64 >> 2] = __ZL21CompileFragmentShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i25, 0) | 0;
  i20 = HEAP8[i4 >> 0] | 0;
  i3 = i20 << 24 >> 24 < 0;
  if ((i3 ? HEAP32[i19 >> 2] | 0 : i20 & 255) | 0) if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 119 >> 0] | 0) HEAP32[i26 + 68 >> 2] = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 3, i3 ? HEAP32[i16 >> 2] | 0 : i16) | 0;
  i20 = HEAP8[i2 >> 0] | 0;
  i3 = i20 << 24 >> 24 < 0;
  if ((i3 ? HEAP32[i1 >> 2] | 0 : i20 & 255) | 0) if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 120 >> 0] | 0) HEAP32[i26 + 72 >> 2] = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 1, i3 ? HEAP32[i21 >> 2] | 0 : i21) | 0;
  i21 = HEAP8[i15 >> 0] | 0;
  i3 = i21 << 24 >> 24 < 0;
  if (!((i3 ? HEAP32[i5 >> 2] | 0 : i21 & 255) | 0)) {
   i7 = 0;
   i3 = 0;
  } else if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 120 >> 0] | 0)) {
   i7 = 0;
   i3 = 0;
  } else {
   HEAP32[i26 + 76 >> 2] = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 2, i3 ? HEAP32[i17 >> 2] | 0 : i17) | 0;
   i7 = 0;
   i3 = 0;
  }
  do {
   i6 = i26 + 56 + (i7 << 2) | 0;
   if (HEAP32[i6 >> 2] | 0) {
    if (__ZN7ApiGLES11CheckShaderERjb(HEAP32[gb + 1451080 >> 2] | 0, i6, 0) | 0) i6 = 1; else if ((i7 | 0) == 2 ? (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 165 >> 0] | 0) != 0 : 0) {
     HEAP32[i6 >> 2] = __ZL21CompileFragmentShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i25, 1) | 0;
     i6 = __ZN7ApiGLES11CheckShaderERjb(HEAP32[gb + 1451080 >> 2] | 0, i6, 0) | 0;
    } else i6 = 0;
    i3 = i3 | i6 ^ 1;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 6);
  if (i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
  i21 = __ZN7ApiGLES21CreateGraphicsProgramEjjjjj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i26 + 60 >> 2] | 0, HEAP32[i26 + 72 >> 2] | 0, HEAP32[i26 + 76 >> 2] | 0, HEAP32[i26 + 68 >> 2] | 0, HEAP32[i26 + 64 >> 2] | 0) | 0;
  i3 = i26 + 88 | 0;
  HEAP32[i3 >> 2] = i21;
  __ZL27BindVertexProgramAttributesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER14ChannelAssignsj(i24, i23, i21) | 0;
  __ZN7ApiGLES11LinkProgramEj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i3 >> 2] | 0);
  if (!(__ZN7ApiGLES12CheckProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i3) | 0)) {
   __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
  i23 = HEAP8[i18 >> 0] | 0;
  i3 = i23 << 24 >> 24 < 0;
  if ((i3 ? HEAP32[i22 >> 2] | 0 : i23 & 255) | 0) __ZN18GlslGpuProgramGLES24StoreInBinaryShaderCacheEPKc(i26, i3 ? HEAP32[i28 >> 2] | 0 : i28) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  i6 = i15;
  i3 = i19;
 }
 HEAP8[i26 + 81 >> 0] = 1;
 HEAP8[i26 + 82 >> 0] = 1;
 i25 = HEAP8[i2 >> 0] | 0;
 i25 = ((i25 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i25 & 255) | 0) != 0;
 HEAP8[i26 + 84 >> 0] = i25 & 1;
 i1 = HEAP8[i6 >> 0] | 0;
 HEAP8[i26 + 85 >> 0] = ((i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i1 & 255) | 0) != 0 & 1;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i26 + 83 | 0;
 i1 = ((i1 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i1 & 255) | 0) != 0 & 1;
 HEAP8[i2 >> 0] = i1;
 if (i25) {
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 92 >> 2] | 0, HEAP32[i26 + 88 >> 2] | 0, 36469, i26 + 96 | 0);
  i1 = HEAP8[i2 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  i27 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
  STACKTOP = i29;
  return i27 | 0;
 }
 HEAP32[i27 >> 2] = 0;
 i1 = i26 + 88 | 0;
 mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 92 >> 2] | 0, HEAP32[i1 >> 2] | 0, 35095, i27 | 0);
 switch (HEAP32[i27 >> 2] | 0) {
 case 4:
  {
   HEAP32[i26 + 92 >> 2] = 0;
   break;
  }
 case 5:
  {
   HEAP32[i26 + 92 >> 2] = 1;
   break;
  }
 case 1:
  {
   HEAP32[i26 + 92 >> 2] = 3;
   break;
  }
 case 3:
  {
   HEAP32[i26 + 92 >> 2] = 4;
   break;
  }
 case 0:
  {
   HEAP32[i26 + 92 >> 2] = 5;
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 604812 | 0, 0, gb + 604722 | 0, 501, 262145, 0, 0, 0);
   __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
   i27 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   STACKTOP = i29;
   return i27 | 0;
  }
 }
 i27 = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
 STACKTOP = i29;
 return i27 | 0;
}

function __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_(i1, i2, i23) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33;
 i32 = i2;
 L1 : while (1) {
  i20 = i32;
  i30 = i32 + -36 | 0;
  i21 = i32 + -8 | 0;
  i24 = i32 + -32 | 0;
  i25 = i32 + -28 | 0;
  i26 = i32 + -24 | 0;
  i27 = i32 + -20 | 0;
  i28 = i32 + -16 | 0;
  i29 = i32 + -12 | 0;
  while (1) {
   i19 = i1;
   L5 : while (1) {
    i16 = i19;
    i1 = i20 - i16 | 0;
    switch ((i1 | 0) / 36 | 0 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 7;
      break L1;
     }
    case 4:
     {
      i22 = 8;
      break L1;
     }
    case 5:
     {
      i22 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 252) {
     i22 = 11;
     break L1;
    }
    i2 = (i1 >>> 0) / 72 | 0;
    i15 = i19 + (i2 * 36 | 0) | 0;
    if ((i1 | 0) > 35964) {
     i1 = (i1 >>> 0) / 144 | 0;
     i1 = __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_(i19, i19 + (i1 * 36 | 0) | 0, i15, i15 + (i1 * 36 | 0) | 0, i30, i23) | 0;
    } else i1 = __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i19, i15, i30, i23) | 0;
    i12 = i19 + 28 | 0;
    f13 = Math_fround(HEAPF32[i12 >> 2]);
    f8 = Math_fround(HEAPF32[i19 + (i2 * 36 | 0) + 28 >> 2]);
    if (f13 < f8) {
     i2 = i30;
     break;
    } else i11 = i30;
    while (1) {
     i2 = i11 + -36 | 0;
     if ((i19 | 0) == (i2 | 0)) break;
     if (Math_fround(HEAPF32[i11 + -8 >> 2]) < f8) {
      i22 = 35;
      break L5;
     } else i11 = i2;
    }
    i3 = i19 + 36 | 0;
    if (!(f13 < Math_fround(HEAPF32[i21 >> 2]))) {
     if ((i3 | 0) == (i30 | 0)) {
      i22 = 52;
      break L1;
     } else i1 = i3;
     while (1) {
      if (f13 < Math_fround(HEAPF32[i1 + 28 >> 2])) break;
      i1 = i1 + 36 | 0;
      if ((i1 | 0) == (i30 | 0)) {
       i22 = 52;
       break L1;
      }
     }
     i2 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i5 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i1 + 12 >> 2] | 0;
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i9 = HEAP32[i1 + 20 >> 2] | 0;
     i3 = i1 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i3 = i1;
     i17 = i30;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i30 >> 2] = i2;
     HEAP32[i24 >> 2] = i4;
     HEAP32[i25 >> 2] = i5;
     HEAP32[i26 >> 2] = i6;
     HEAP32[i27 >> 2] = i7;
     HEAP32[i28 >> 2] = i9;
     HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i29 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i29 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i3 = i1 + 36 | 0;
    }
    if ((i3 | 0) == (i30 | 0)) {
     i22 = 52;
     break L1;
    } else i1 = i30;
    while (1) {
     f8 = Math_fround(HEAPF32[i12 >> 2]);
     while (1) {
      i11 = i3 + 36 | 0;
      if (f8 < Math_fround(HEAPF32[i3 + 28 >> 2])) break; else i3 = i11;
     }
     while (1) {
      i10 = i1 + -36 | 0;
      if (f8 < Math_fround(HEAPF32[i1 + -8 >> 2])) i1 = i10; else break;
     }
     if (i3 >>> 0 >= i10 >>> 0) {
      i19 = i3;
      continue L5;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i3 + 4 >> 2] | 0;
     i5 = HEAP32[i3 + 8 >> 2] | 0;
     i6 = HEAP32[i3 + 12 >> 2] | 0;
     i7 = HEAP32[i3 + 16 >> 2] | 0;
     i9 = HEAP32[i3 + 20 >> 2] | 0;
     i17 = i3 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     i17 = i10;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i2;
     HEAP32[i1 + -32 >> 2] = i4;
     HEAP32[i1 + -28 >> 2] = i5;
     HEAP32[i1 + -24 >> 2] = i6;
     HEAP32[i1 + -20 >> 2] = i7;
     HEAP32[i1 + -16 >> 2] = i9;
     i1 = i1 + -12 | 0;
     HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i1 = i10;
     i3 = i11;
    }
   }
   if ((i22 | 0) == 35) {
    i22 = 0;
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = HEAP32[i19 + 8 >> 2] | 0;
    i7 = HEAP32[i19 + 12 >> 2] | 0;
    i9 = HEAP32[i19 + 16 >> 2] | 0;
    i10 = HEAP32[i19 + 20 >> 2] | 0;
    i3 = i19 + 24 | 0;
    HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i3 = i19;
    i17 = i2;
    i18 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
     i3 = i3 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i3 | 0) < (i18 | 0));
    HEAP32[i2 >> 2] = i4;
    HEAP32[i11 + -32 >> 2] = i5;
    HEAP32[i11 + -28 >> 2] = i6;
    HEAP32[i11 + -24 >> 2] = i7;
    HEAP32[i11 + -20 >> 2] = i9;
    HEAP32[i11 + -16 >> 2] = i10;
    i18 = i11 + -12 | 0;
    HEAP32[i18 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   i3 = i19 + 36 | 0;
   L35 : do if (i3 >>> 0 < i2 >>> 0) while (1) {
    f8 = Math_fround(HEAPF32[i15 + 28 >> 2]);
    i11 = i3;
    while (1) {
     i14 = i11 + 36 | 0;
     if (Math_fround(HEAPF32[i11 + 28 >> 2]) < f8) i11 = i14; else break;
    }
    while (1) {
     i12 = i2 + -36 | 0;
     if (Math_fround(HEAPF32[i2 + -8 >> 2]) < f8) break; else i2 = i12;
    }
    if (i11 >>> 0 > i12 >>> 0) {
     i10 = i15;
     break L35;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i11 + 4 >> 2] | 0;
    i6 = HEAP32[i11 + 8 >> 2] | 0;
    i7 = HEAP32[i11 + 12 >> 2] | 0;
    i9 = HEAP32[i11 + 16 >> 2] | 0;
    i10 = HEAP32[i11 + 20 >> 2] | 0;
    i3 = i11 + 24 | 0;
    HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i3 = i11;
    i17 = i12;
    i18 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
     i3 = i3 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i3 | 0) < (i18 | 0));
    HEAP32[i12 >> 2] = i4;
    HEAP32[i2 + -32 >> 2] = i5;
    HEAP32[i2 + -28 >> 2] = i6;
    HEAP32[i2 + -24 >> 2] = i7;
    HEAP32[i2 + -20 >> 2] = i9;
    HEAP32[i2 + -16 >> 2] = i10;
    i2 = i2 + -12 | 0;
    HEAP32[i2 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    i15 = (i15 | 0) == (i11 | 0) ? i12 : i15;
    i2 = i12;
    i3 = i14;
    i1 = i1 + 1 | 0;
   } else {
    i10 = i15;
    i11 = i3;
   } while (0);
   if ((i11 | 0) != (i10 | 0)) {
    f13 = Math_fround(HEAPF32[i10 + 28 >> 2]);
    if (f13 < Math_fround(HEAPF32[i11 + 28 >> 2])) {
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i11 + 4 >> 2] | 0;
     i5 = HEAP32[i11 + 8 >> 2] | 0;
     i6 = HEAP32[i11 + 12 >> 2] | 0;
     i7 = HEAP32[i11 + 16 >> 2] | 0;
     i9 = HEAP32[i11 + 20 >> 2] | 0;
     i3 = i11 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i3 = i11;
     i17 = i10;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i2;
     HEAP32[i10 + 4 >> 2] = i4;
     HEAP32[i10 + 8 >> 2] = i5;
     HEAP32[i10 + 12 >> 2] = i6;
     HEAP32[i10 + 16 >> 2] = i7;
     HEAP32[i10 + 20 >> 2] = i9;
     i18 = i10 + 24 | 0;
     HEAP32[i18 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEbT0_S6_T_(i19, i11, i23) | 0;
    i1 = i11 + 36 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEbT0_S6_T_(i1, i32, i23) | 0) {
     i22 = 51;
     break;
    }
    if (i2) continue;
   }
   i18 = i11;
   if ((i18 - i16 | 0) >= (i20 - i18 | 0)) {
    i22 = 50;
    break;
   }
   __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_(i19, i11, i23);
   i1 = i11 + 36 | 0;
  }
  if ((i22 | 0) == 50) {
   i22 = 0;
   __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_(i11 + 36 | 0, i32, i23);
   i1 = i19;
   i32 = i11;
   continue;
  } else if ((i22 | 0) == 51) {
   i22 = 0;
   if (i2) {
    i22 = 52;
    break;
   } else {
    i1 = i19;
    i32 = i11;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  f13 = Math_fround(HEAPF32[i21 >> 2]);
  if (!(f13 < Math_fround(HEAPF32[i19 + 28 >> 2]))) {
   STACKTOP = i33;
   return;
  }
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = HEAP32[i19 + 4 >> 2] | 0;
  i4 = HEAP32[i19 + 8 >> 2] | 0;
  i5 = HEAP32[i19 + 12 >> 2] | 0;
  i6 = HEAP32[i19 + 16 >> 2] | 0;
  i7 = HEAP32[i19 + 20 >> 2] | 0;
  i3 = i19 + 24 | 0;
  HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = i19;
  i17 = i30;
  i18 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
   i3 = i3 + 4 | 0;
   i17 = i17 + 4 | 0;
  } while ((i3 | 0) < (i18 | 0));
  HEAP32[i30 >> 2] = i1;
  HEAP32[i24 >> 2] = i2;
  HEAP32[i25 >> 2] = i4;
  HEAP32[i26 >> 2] = i5;
  HEAP32[i27 >> 2] = i6;
  HEAP32[i28 >> 2] = i7;
  HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 7) {
  __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i19, i19 + 36 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 8) {
  __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_(i19, i19 + 36 | 0, i19 + 72 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 9) {
  __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_(i19, i19 + 36 | 0, i19 + 72 | 0, i19 + 108 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 11) {
  i2 = i19 + 72 | 0;
  __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i19, i19 + 36 | 0, i2, i23) | 0;
  i1 = i19 + 108 | 0;
  if ((i1 | 0) == (i32 | 0)) {
   STACKTOP = i33;
   return;
  }
  while (1) {
   f8 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (f8 < Math_fround(HEAPF32[i2 + 28 >> 2])) {
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i1 + 8 >> 2] | 0;
    i10 = HEAP32[i1 + 12 >> 2] | 0;
    i11 = HEAP32[i1 + 16 >> 2] | 0;
    i12 = HEAP32[i1 + 20 >> 2] | 0;
    i5 = HEAP32[i1 + 24 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i3 = i1;
    while (1) {
     i17 = i2;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     if ((i2 | 0) == (i19 | 0)) {
      i2 = i19;
      break;
     }
     if (f8 < Math_fround(HEAPF32[i2 + -8 >> 2])) {
      i3 = i2;
      i2 = i2 + -36 | 0;
     } else break;
    }
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 4 >> 2] = i7;
    HEAP32[i2 + 8 >> 2] = i9;
    HEAP32[i2 + 12 >> 2] = i10;
    HEAP32[i2 + 16 >> 2] = i11;
    HEAP32[i2 + 20 >> 2] = i12;
    HEAP32[i2 + 24 >> 2] = i5;
    HEAPF32[i2 + 28 >> 2] = f8;
    HEAP32[i2 + 32 >> 2] = i4;
   }
   i2 = i1 + 36 | 0;
   if ((i2 | 0) == (i32 | 0)) break; else {
    i31 = i1;
    i1 = i2;
    i2 = i31;
   }
  }
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 52) {
  STACKTOP = i33;
  return;
 }
}

function __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE(i30, i24, i3, i25) {
 i30 = i30 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i29 + 12 | 0;
 i4 = i29 + 60 | 0;
 i5 = i29 + 56 | 0;
 i26 = i29 + 8 | 0;
 i27 = i29 + 4 | 0;
 i28 = i29;
 i1 = i2 + 4 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = 59;
 HEAP32[i2 + 4 >> 2] = 55;
 HEAP32[i2 + 8 >> 2] = 23;
 HEAP32[i2 + 12 >> 2] = 31;
 HEAP32[i2 + 16 >> 2] = 11;
 HEAP32[i2 + 20 >> 2] = 161;
 HEAP32[i2 + 24 >> 2] = 6;
 HEAP32[i2 + 28 >> 2] = 364;
 HEAP32[i2 + 32 >> 2] = -1;
 HEAP8[i5 + 2 >> 0] = 0;
 HEAP8[i5 >> 0] = 37;
 HEAP8[i5 + 1 >> 0] = i3;
 i2 = _strftime_l(i4 | 0, 100, i5 | 0, i2 | 0, HEAP32[i24 >> 2] | 0) | 0;
 HEAP32[i26 >> 2] = i4;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 i5 = i4;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i30 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i16 = i4 + i2 | 0;
 i17 = i25 + 8 | 0;
 i18 = i24 + 4 | 0;
 i19 = i24 + 172 | 0;
 i20 = i18;
 i21 = i24 + 172 | 0;
 i22 = i24 + 460 | 0;
 i23 = i21;
 i6 = i3 << 24 >> 24 == 120;
 i7 = i30 + 11 | 0;
 i8 = i30 + 4 | 0;
 i9 = i24 + 460 | 0;
 i10 = i9 + 11 | 0;
 i11 = i24 + 464 | 0;
 i12 = i24 + 472 + 11 | 0;
 i13 = i24 + 476 | 0;
 i14 = i24 + 484 | 0;
 i15 = i9;
 i3 = i4;
 i2 = i5;
 L5 : while (1) {
  if ((i3 | 0) == (i16 | 0)) {
   i31 = 92;
   break;
  }
  i1 = HEAP8[i3 >> 0] | 0;
  L8 : do if (i1 << 24 >> 24 > -1) if (!(HEAP16[(HEAP32[i17 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) i31 = 14; else {
   __THREW__ = 0;
   invoke_vii(fb + 4511 | 0, i30 | 0, 32);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i31 = 13;
    break L5;
   }
   i1 = HEAP32[i26 >> 2] | 0;
   do {
    i1 = i1 + 1 | 0;
    HEAP32[i26 >> 2] = i1;
    if ((i1 | 0) == (i16 | 0)) break L8;
    i2 = HEAP8[i1 >> 0] | 0;
    if (i2 << 24 >> 24 <= -1) break L8;
   } while ((HEAP16[(HEAP32[i17 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 8192) != 0);
  } else i31 = 14; while (0);
  if ((i31 | 0) == 14) {
   i31 = 0;
   HEAP32[i27 >> 2] = i2;
   HEAP32[i28 >> 2] = 0;
   __THREW__ = 0;
   i1 = invoke_iiiiiiii(fb + 101 | 0, i27 | 0, i16 | 0, i18 | 0, i19 | 0, i25 | 0, i28 | 0, 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i31 = 19;
    break;
   }
   i1 = i1 - i20 | 0;
   L19 : do if ((i1 | 0) < 168) {
    __THREW__ = 0;
    invoke_vii(fb + 4511 | 0, i30 | 0, 37);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i31 = 21;
     break L5;
    }
    if ((i1 | 0) < 84) {
     __THREW__ = 0;
     invoke_vii(fb + 4511 | 0, i30 | 0, 65);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i31 = 21;
      break L5;
     }
    } else {
     __THREW__ = 0;
     invoke_vii(fb + 4511 | 0, i30 | 0, 97);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i31 = 21;
      break L5;
     }
    }
    HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
   } else {
    HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
    __THREW__ = 0;
    i1 = invoke_iiiiiiii(fb + 101 | 0, i27 | 0, i16 | 0, i21 | 0, i22 | 0, i25 | 0, i28 | 0, 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i31 = 21;
     break L5;
    }
    i1 = i1 - i23 | 0;
    i2 = (i1 | 0) / 12 | 0;
    if ((i1 | 0) < 288) {
     __THREW__ = 0;
     invoke_vii(fb + 4511 | 0, i30 | 0, 37);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i31 = 21;
      break L5;
     }
     if ((i1 | 0) < 144) {
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 66);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
     } else {
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 98);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
     }
     if (i6) {
      i1 = i24 + 172 + (i2 * 12 | 0) | 0;
      if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP8[i1 >> 0] | 0;
      if (i1 << 24 >> 24 > -1) if (HEAP16[(HEAP32[i17 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048) {
       i1 = HEAP8[i7 >> 0] | 0;
       if (i1 << 24 >> 24 < 0) {
        i2 = HEAP32[i30 >> 2] | 0;
        i1 = HEAP32[i8 >> 2] | 0;
       } else {
        i2 = i30;
        i1 = i1 & 255;
       }
       HEAP8[i2 + i1 + -1 >> 0] = 109;
      }
     }
     HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
     break;
    }
    i1 = HEAP8[i10 >> 0] | 0;
    if (i1 << 24 >> 24 < 0) i2 = HEAP32[i11 >> 2] | 0; else i2 = i1 & 255;
    i1 = HEAP8[i12 >> 0] | 0;
    if (i1 << 24 >> 24 < 0) i1 = HEAP32[i13 >> 2] | 0; else i1 = i1 & 255;
    if ((i2 | 0) != (0 - i1 | 0)) {
     HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
     __THREW__ = 0;
     i1 = invoke_iiiiiiii(fb + 101 | 0, i27 | 0, i16 | 0, i9 | 0, i14 | 0, i25 | 0, i28 | 0, 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i31 = 21;
      break L5;
     }
     if ((i1 - i15 | 0) < 24) {
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 37);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 112);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
      HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
      break;
     }
    }
    i1 = HEAP32[i26 >> 2] | 0;
    HEAP32[i27 >> 2] = i1;
    i1 = HEAP8[i1 >> 0] | 0;
    do if (i1 << 24 >> 24 > -1) {
     if (!(HEAP16[(HEAP32[i17 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048)) {
      if (i1 << 24 >> 24 != 37) break;
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 37);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i30 | 0, 37);
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i31 = 21;
       break L5;
      }
      HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
      break L19;
     }
     __THREW__ = 0;
     i1 = invoke_iiiiii(fb + 190 | 0, i26 | 0, i16 | 0, i28 | 0, i25 | 0, 4) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i31 = 21;
      break L5;
     }
     do switch (i1 | 0) {
     case 6:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 119);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 7:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 117);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 11:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 73);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 12:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 109);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 23:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 72);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 31:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 100);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 55:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 77);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 59:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 83);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 61:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 121);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 364:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 106);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     case 2061:
      {
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 37);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       }
       __THREW__ = 0;
       invoke_vii(fb + 4511 | 0, i30 | 0, 89);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i31 = 21;
        break L5;
       } else break L19;
      }
     default:
      {
       i1 = HEAP32[i27 >> 2] | 0;
       while (1) {
        if ((i1 | 0) == (HEAP32[i26 >> 2] | 0)) break L19;
        __THREW__ = 0;
        invoke_vii(fb + 4511 | 0, i30 | 0, HEAP8[i1 >> 0] | 0);
        i5 = __THREW__;
        __THREW__ = 0;
        if (i5 & 1) {
         i31 = 20;
         break L5;
        }
        i1 = (HEAP32[i27 >> 2] | 0) + 1 | 0;
        HEAP32[i27 >> 2] = i1;
       }
      }
     } while (0);
    } while (0);
    __THREW__ = 0;
    invoke_vii(fb + 4511 | 0, i30 | 0, i1 | 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i31 = 21;
     break L5;
    }
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
   } while (0);
   i1 = HEAP32[i26 >> 2] | 0;
  }
  i3 = i1;
  i2 = i1;
 }
 if ((i31 | 0) == 13) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else if ((i31 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i31 = 91;
 } else if ((i31 | 0) == 20) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i31 = 91;
 } else if ((i31 | 0) == 21) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i31 = 91;
 } else if ((i31 | 0) == 92) {
  STACKTOP = i29;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i30);
 ___resumeException(i1 | 0);
}

function __ZN28LightProbeProxyVolumeManager16BlendLightProbesER21LightProbeProxyVolume(i1, i19) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i57 + 64 | 0;
 i54 = i57;
 i56 = i57 + 264 | 0;
 i14 = i57 + 132 | 0;
 i6 = i57 + 128 | 0;
 i16 = i19 + 140 | 0;
 i52 = HEAP32[i16 >> 2] | 0;
 i17 = i19 + 144 | 0;
 i53 = HEAP32[i17 >> 2] | 0;
 i15 = i19 + 148 | 0;
 i47 = HEAP32[i15 >> 2] | 0;
 f48 = Math_fround(Math_fround(1.0) / Math_fround(i52 >>> 0));
 f49 = Math_fround(Math_fround(1.0) / Math_fround(i53 >>> 0));
 f50 = Math_fround(Math_fround(1.0) / Math_fround(i47 >>> 0));
 i1 = i19 + 164 | 0;
 i4 = HEAP32[i1 >> 2] & 1 ^ 1;
 HEAP32[i1 >> 2] = i4;
 i4 = i19 + 156 + (i4 << 2) | 0;
 HEAP32[i54 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i51, i1, i54);
   i2 = HEAP32[i51 >> 2] | 0;
   i55 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i55 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i55 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i8 = HEAP32[i1 + 96 >> 2] | 0;
 i44 = ~~Math_fround(Math_ceil(Math_fround(Math_fround((Math_imul(Math_imul(i53, i52) | 0, i47) | 0) >>> 0) * Math_fround(.015625)))) >>> 0;
 i55 = gb + 64016 | 0;
 i45 = HEAP32[i55 + 4 >> 2] | 0;
 i46 = i54;
 HEAP32[i46 >> 2] = HEAP32[i55 >> 2];
 HEAP32[i46 + 4 >> 2] = i45;
 HEAP32[i56 >> 2] = 0;
 i46 = i56 + 12 | 0;
 HEAP32[i46 >> 2] = 0;
 i45 = i56 + 16 | 0;
 HEAP32[i45 >> 2] = 0;
 i55 = i56 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i54);
 i39 = i51;
 i43 = HEAP32[i39 + 4 >> 2] | 0;
 i18 = i55;
 HEAP32[i18 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i18 + 4 >> 2] = i43;
 i18 = __Z19GetLightmapSettingsv() | 0;
 __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings(i14, i18, __Z17GetRenderSettingsv() | 0);
 HEAP32[i6 >> 2] = -1;
 i18 = i19 + 28 | 0;
 __ZN26LightProbeProxyVolumeUtilsL20FindTetrahedronIndexER9TransformRi(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i18 >> 2] | 0, gb + 28940 | 0) | 0, i6);
 i43 = (i44 | 0) == 0;
 if (!i43) {
  i7 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   i3 = HEAP32[i46 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i45 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i2 = i5 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i45 >> 2] = i2;
     HEAP32[i56 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i56 >> 2] | 0, i2 * 160 | 0, 4, i55, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i39 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 160 | 0, 4, i55, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i39 | 0, HEAP32[i56 >> 2] | 0, (HEAP32[i46 >> 2] | 0) * 160 | 0) | 0;
     HEAP32[i45 >> 2] = i2;
     HEAP32[i56 >> 2] = i39;
     break;
    }
   } while (0);
   HEAP32[i46 >> 2] = i4;
   i39 = HEAP32[i56 >> 2] | 0;
   i38 = i39 + (i3 * 160 | 0) + 132 | 0;
   HEAP32[i38 >> 2] = -1;
   i37 = gb + 64016 | 0;
   i34 = HEAP32[i37 + 4 >> 2] | 0;
   i33 = i54;
   HEAP32[i33 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i33 + 4 >> 2] = i34;
   HEAP32[i39 + (i3 * 160 | 0) + 136 >> 2] = 0;
   HEAP32[i39 + (i3 * 160 | 0) + 148 >> 2] = 0;
   HEAP32[i39 + (i3 * 160 | 0) + 152 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i51, i54);
   i33 = i51;
   i34 = HEAP32[i33 + 4 >> 2] | 0;
   i37 = i39 + (i3 * 160 | 0) + 140 | 0;
   HEAP32[i37 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i37 + 4 >> 2] = i34;
   HEAP32[i38 >> 2] = i7;
   _memcpy(i39 + (i3 * 160 | 0) | 0, i14 | 0, 132) | 0;
   HEAP32[i39 + (i3 * 160 | 0) + 156 >> 2] = i8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i44 | 0));
 }
 f9 = Math_fround(HEAPF32[i19 + 92 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 96 >> 2]);
 f12 = Math_fround(HEAPF32[i19 + 100 >> 2]);
 i1 = HEAP32[i19 + 104 >> 2] | 0;
 i2 = HEAP32[i19 + 108 >> 2] | 0;
 i3 = HEAP32[i19 + 112 >> 2] | 0;
 if (!(HEAP32[i19 + 88 >> 2] | 0)) {
  f40 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  f41 = Math_fround(i1 >>> 0);
  i1 = i1 + -1 | 0;
  f42 = Math_fround(i1 >>> 0);
  f42 = Math_fround(f35 * Math_fround(f41 / ((i1 | 0) == 0 ? Math_fround(1.0) : f42)));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  f42 = Math_fround(i2 >>> 0);
  i2 = i2 + -1 | 0;
  f41 = Math_fround(i2 >>> 0);
  f41 = Math_fround(f36 * Math_fround(f42 / ((i2 | 0) == 0 ? Math_fround(1.0) : f41)));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
  f41 = Math_fround(i3 >>> 0);
  i3 = i3 + -1 | 0;
  f42 = Math_fround(i3 >>> 0);
  f42 = Math_fround(f40 * Math_fround(f41 / ((i3 | 0) == 0 ? Math_fround(1.0) : f42)));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(f9 - f13);
 f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = Math_fround(f10 - f11);
 f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(f12 - f9);
 i4 = i19 + 36 | 0;
 switch (HEAP32[i4 >> 2] | 0) {
 case 2:
 case 0:
  {
   __ZNK9Transform21GetLocalToWorldMatrixEv(i51, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i18 >> 2] | 0, gb + 28940 | 0) | 0);
   i1 = i54;
   i2 = i51;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   if ((HEAP32[i4 >> 2] | 0) == 2) {
    __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i51, i19 + 76 | 0) | 0;
    __ZN10Matrix4x4fmLERKS_(i54, i51) | 0;
    i37 = 1;
   } else i37 = 1;
   break;
  }
 default:
  {
   i1 = i54;
   i2 = gb + 1162292 | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i37 = 0;
  }
 }
 if (i47 | 0) {
  i38 = (i53 | 0) == 0;
  i39 = (i52 | 0) == 0;
  f36 = Math_fround(f13 * Math_fround(2.0));
  f35 = Math_fround(f11 * Math_fround(2.0));
  f21 = Math_fround(f9 * Math_fround(2.0));
  i22 = i54 + 16 | 0;
  i23 = i54 + 32 | 0;
  i24 = i54 + 48 | 0;
  i25 = i54 + 4 | 0;
  i26 = i54 + 20 | 0;
  i27 = i54 + 36 | 0;
  i28 = i54 + 52 | 0;
  i29 = i54 + 8 | 0;
  i30 = i54 + 24 | 0;
  i31 = i54 + 40 | 0;
  i32 = i54 + 56 | 0;
  i33 = i52 << 2;
  i34 = i52 << 1;
  i1 = 0;
  i20 = 0;
  do {
   if (!i38) {
    f13 = Math_fround(f40 + Math_fround(f50 * Math_fround(f21 * Math_fround(Math_fround(i20 >>> 0) + Math_fround(.5)))));
    i19 = Math_imul(i20, i53) | 0;
    i18 = 0;
    do {
     if (!i39) {
      f12 = Math_fround(f41 + Math_fround(f49 * Math_fround(f35 * Math_fround(Math_fround(i18 >>> 0) + Math_fround(.5)))));
      i17 = Math_imul(i33, i18 + i19 | 0) | 0;
      i16 = 0;
      i14 = HEAP32[i56 >> 2] | 0;
      do {
       f9 = Math_fround(f42 + Math_fround(f48 * Math_fround(f36 * Math_fround(Math_fround(i16 >>> 0) + Math_fround(.5)))));
       i3 = i14 + (i1 * 160 | 0) + 136 | 0;
       i4 = i14 + (i1 * 160 | 0) + 148 | 0;
       i15 = HEAP32[i4 >> 2] | 0;
       i5 = i15 + 1 | 0;
       i6 = i14 + (i1 * 160 | 0) + 152 | 0;
       i7 = HEAP32[i6 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i5 >>> 0 > i8 >>> 0) {
        i2 = i7 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i6 >> 2] = i2;
         HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 * 24 | 0, 4, i14 + (i1 * 160 | 0) + 140 | 0, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i14 + (i1 * 160 | 0) + 140 | 0, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i14 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
         HEAP32[i6 >> 2] = i2;
         HEAP32[i3 >> 2] = i14;
         break;
        }
       } while (0);
       HEAP32[i4 >> 2] = i5;
       i2 = HEAP32[i3 >> 2] | 0;
       if (i37) {
        f58 = Math_fround(f9 * Math_fround(HEAPF32[i54 >> 2]));
        f58 = Math_fround(f58 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
        f58 = Math_fround(f58 + Math_fround(f13 * Math_fround(HEAPF32[i23 >> 2])));
        f58 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f58);
        f10 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
        f10 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2])));
        f10 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i27 >> 2])));
        f10 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f10);
        f11 = Math_fround(f9 * Math_fround(HEAPF32[i29 >> 2]));
        f11 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i30 >> 2])));
        f11 = Math_fround(f11 + Math_fround(f13 * Math_fround(HEAPF32[i31 >> 2])));
        f9 = f58;
        f11 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + f11);
       } else {
        f10 = f12;
        f11 = f13;
       }
       HEAPF32[i2 + (i15 * 24 | 0) >> 2] = f9;
       HEAPF32[i2 + (i15 * 24 | 0) + 4 >> 2] = f10;
       HEAPF32[i2 + (i15 * 24 | 0) + 8 >> 2] = f11;
       i14 = i17 + i16 | 0;
       HEAP32[i2 + (i15 * 24 | 0) + 12 >> 2] = i14;
       HEAP32[i2 + (i15 * 24 | 0) + 16 >> 2] = i14 + i52;
       HEAP32[i2 + (i15 * 24 | 0) + 20 >> 2] = i14 + i34;
       i14 = HEAP32[i56 >> 2] | 0;
       i1 = ((HEAP32[i14 + (i1 * 160 | 0) + 148 >> 2] | 0) == 64 & 1) + i1 | 0;
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) != (i52 | 0));
     }
     i18 = i18 + 1 | 0;
    } while ((i18 | 0) != (i53 | 0));
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i47 | 0));
 }
 HEAP32[i51 >> 2] = 0;
 HEAP32[i51 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i51, fb + 2378 | 0, HEAP32[i56 >> 2] | 0, i44, 0, 0);
 if (HEAP32[i51 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i51);
 if (!i43) {
  i1 = 0;
  do {
   i2 = HEAP32[i56 >> 2] | 0;
   i3 = i2 + (i1 * 160 | 0) + 136 | 0;
   i4 = i2 + (i1 * 160 | 0) + 152 | 0;
   if ((HEAP32[i4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + (i1 * 160 | 0) + 140 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 + (i1 * 160 | 0) + 148 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i44 | 0));
 }
 if ((HEAP32[i45 >> 2] | 0) <= -1) {
  STACKTOP = i57;
  return;
 }
 i1 = HEAP32[i56 >> 2] | 0;
 i3 = HEAP32[i46 >> 2] | 0;
 if (i3) {
  i2 = 0;
  do {
   i4 = i1 + (i2 * 160 | 0) + 136 | 0;
   if ((HEAP32[i1 + (i2 * 160 | 0) + 152 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + (i2 * 160 | 0) + 140 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i56 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i55);
 HEAP32[i56 >> 2] = 0;
 STACKTOP = i57;
 return;
}

function __ZN14ParticleSystem13StartVelocityERS_RK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjRKN4math7_float3ERKfbb(i29, i2, i38, i1, i28, i3, i5, i4) {
 i29 = i29 | 0;
 i2 = i2 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, f47 = f0, i48 = 0, f49 = f0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i39 + 32 | 0;
 i36 = i39 + 16 | 0;
 i34 = i39;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f32 = Math_fround(f32 / Math_fround(HEAPF32[i2 + 264 >> 2]));
 if (i4) i24 = (HEAP8[(HEAP32[i29 + 872 >> 2] | 0) + 4 >> 0] | 0) != 0; else i24 = 0;
 i37 = HEAP32[i38 + 12 >> 2] | 0;
 i33 = i37 >>> 0 > i1 >>> 0;
 L4 : do if (i33 & i5) {
  i3 = i38 + 500 | 0;
  i4 = i35 + 4 | 0;
  i5 = i35 + 8 | 0;
  i6 = i35 + 12 | 0;
  i7 = i29 + 44 | 0;
  i8 = i34 + 12 | 0;
  i9 = i34 + 8 | 0;
  i10 = i34 + 4 | 0;
  i11 = i38 + 60 | 0;
  i12 = i38 + 80 | 0;
  i13 = i38 + 100 | 0;
  i14 = i36 + 4 | 0;
  i15 = i36 + 8 | 0;
  i16 = i36 + 12 | 0;
  i2 = i1;
  while (1) {
   i22 = (HEAP32[i3 >> 2] | 0) + (i2 << 2) | 0;
   i42 = (HEAP32[i22 >> 2] | 0) + -1767223837 | 0;
   i40 = (HEAP32[i22 + 4 >> 2] | 0) + -1767223837 | 0;
   i31 = (HEAP32[i22 + 8 >> 2] | 0) + -1767223837 | 0;
   i22 = (HEAP32[i22 + 12 >> 2] | 0) + -1767223837 | 0;
   i41 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
   i30 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
   i23 = (Math_imul(i31, 1790253981) | 0) + 1900727103 | 0;
   i21 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
   i42 = i42 << 11 ^ i42;
   i40 = i40 << 11 ^ i40;
   i31 = i31 << 11 ^ i31;
   i22 = i22 << 11 ^ i22;
   f17 = Math_fround(Math_fround((i41 ^ i42 ^ i42 >>> 8) & 8388607 ^ i41 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f18 = Math_fround(Math_fround((i30 ^ i40 ^ i40 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f19 = Math_fround(Math_fround((i23 ^ i31 ^ i31 >>> 8) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
   f20 = Math_fround(Math_fround((i21 ^ i22 ^ i22 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07));
   HEAPF32[i35 >> 2] = f17;
   HEAPF32[i4 >> 2] = f18;
   HEAPF32[i5 >> 2] = f19;
   HEAPF32[i6 >> 2] = f20;
   i21 = HEAP32[i7 >> 2] | 0;
   i22 = i21 + 272 | 0;
   HEAPF32[i8 >> 2] = f32;
   HEAPF32[i9 >> 2] = f32;
   HEAPF32[i10 >> 2] = f32;
   HEAPF32[i34 >> 2] = f32;
   i23 = HEAP32[i21 + 356 >> 2] | 0;
   L8 : do switch ((i23 & 65535) << 16 >> 16) {
   case 0:
    {
     i42 = HEAP32[i21 + 352 >> 2] | 0;
     HEAP32[i16 >> 2] = i42;
     HEAP32[i15 >> 2] = i42;
     HEAP32[i14 >> 2] = i42;
     HEAP32[i36 >> 2] = i42;
     break;
    }
   case 3:
    {
     f44 = Math_fround(HEAPF32[(HEAP32[i21 + 504 >> 2] | 0) + 4 >> 2]);
     f43 = Math_fround(HEAPF32[i21 + 352 >> 2]);
     f44 = Math_fround(f44 * f43);
     f43 = Math_fround(Math_fround(f43 * Math_fround(HEAPF32[(HEAP32[i21 + 416 >> 2] | 0) + 4 >> 2])) - f44);
     f25 = Math_fround(f44 + Math_fround(f43 * f18));
     f26 = Math_fround(f44 + Math_fround(f43 * f19));
     f27 = Math_fround(f44 + Math_fround(f43 * f20));
     HEAPF32[i36 >> 2] = Math_fround(f44 + Math_fround(f17 * f43));
     HEAPF32[i14 >> 2] = f25;
     HEAPF32[i15 >> 2] = f26;
     HEAPF32[i16 >> 2] = f27;
     break;
    }
   default:
    if (!(i23 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i36, i22, i34, i35);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i36, i22, i34, i35);
     break L8;
    }
   } while (0);
   i50 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
   f51 = Math_fround(HEAPF32[i50 >> 2]);
   i48 = i50 + 4 | 0;
   f49 = Math_fround(HEAPF32[i48 >> 2]);
   i46 = i50 + 8 | 0;
   f47 = Math_fround(HEAPF32[i46 >> 2]);
   i45 = i50 + 12 | 0;
   f17 = Math_fround(HEAPF32[i45 >> 2]);
   i21 = (HEAP32[i12 >> 2] | 0) + (i2 << 2) | 0;
   f18 = Math_fround(HEAPF32[i21 >> 2]);
   i22 = i21 + 4 | 0;
   f19 = Math_fround(HEAPF32[i22 >> 2]);
   i23 = i21 + 8 | 0;
   f20 = Math_fround(HEAPF32[i23 >> 2]);
   i30 = i21 + 12 | 0;
   f25 = Math_fround(HEAPF32[i30 >> 2]);
   i31 = (HEAP32[i13 >> 2] | 0) + (i2 << 2) | 0;
   f55 = Math_fround(HEAPF32[i31 >> 2]);
   i40 = i31 + 4 | 0;
   f54 = Math_fround(HEAPF32[i40 >> 2]);
   i41 = i31 + 8 | 0;
   f53 = Math_fround(HEAPF32[i41 >> 2]);
   i42 = i31 + 12 | 0;
   f52 = Math_fround(HEAPF32[i42 >> 2]);
   f26 = Math_fround(HEAPF32[i36 >> 2]);
   f51 = Math_fround(f51 * f26);
   f27 = Math_fround(HEAPF32[i14 >> 2]);
   f49 = Math_fround(f49 * f27);
   f43 = Math_fround(HEAPF32[i15 >> 2]);
   f47 = Math_fround(f47 * f43);
   f44 = Math_fround(HEAPF32[i16 >> 2]);
   f17 = Math_fround(f17 * f44);
   f18 = Math_fround(f18 * f26);
   f19 = Math_fround(f19 * f27);
   f20 = Math_fround(f20 * f43);
   f25 = Math_fround(f25 * f44);
   f26 = Math_fround(f55 * f26);
   f27 = Math_fround(f54 * f27);
   f43 = Math_fround(f53 * f43);
   f44 = Math_fround(f52 * f44);
   HEAPF32[i50 >> 2] = f51;
   HEAPF32[i48 >> 2] = f49;
   HEAPF32[i46 >> 2] = f47;
   HEAPF32[i45 >> 2] = f17;
   HEAPF32[i21 >> 2] = f18;
   HEAPF32[i22 >> 2] = f19;
   HEAPF32[i23 >> 2] = f20;
   HEAPF32[i30 >> 2] = f25;
   HEAPF32[i31 >> 2] = f26;
   HEAPF32[i40 >> 2] = f27;
   HEAPF32[i41 >> 2] = f43;
   HEAPF32[i42 >> 2] = f44;
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i37 >>> 0) break L4;
  }
 } while (0);
 if (!i24) {
  STACKTOP = i39;
  return;
 }
 i30 = HEAP32[i28 >> 2] | 0;
 i31 = HEAP32[i28 + 4 >> 2] | 0;
 i24 = HEAP32[i28 + 8 >> 2] | 0;
 i6 = i29 + 872 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (HEAP32[i2 + 8 >> 2] | 0) {
  STACKTOP = i39;
  return;
 }
 switch (HEAP16[i2 + 96 >> 1] | 0) {
 case 0:
 case 3:
  {
   if (!i33) {
    STACKTOP = i39;
    return;
   }
   i7 = i38 + 500 | 0;
   i8 = i35 + 4 | 0;
   i9 = i35 + 8 | 0;
   i10 = i35 + 12 | 0;
   i11 = i34 + 12 | 0;
   i12 = i34 + 8 | 0;
   i13 = i34 + 4 | 0;
   f25 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i14 = i36 + 4 | 0;
   i15 = i36 + 8 | 0;
   i16 = i36 + 12 | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i21 = i38 + 60 | 0;
   i22 = i38 + 80 | 0;
   i23 = i38 + 100 | 0;
   i5 = i1;
   do {
    i4 = (HEAP32[i7 >> 2] | 0) + (i5 << 2) | 0;
    i41 = (HEAP32[i4 >> 2] | 0) + 3401255 | 0;
    i45 = (HEAP32[i4 + 4 >> 2] | 0) + 3401255 | 0;
    i48 = (HEAP32[i4 + 8 >> 2] | 0) + 3401255 | 0;
    i4 = (HEAP32[i4 + 12 >> 2] | 0) + 3401255 | 0;
    i42 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
    i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
    i50 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
    i3 = (Math_imul(i4, 1790253981) | 0) + 1900727103 | 0;
    i41 = i41 << 11 ^ i41;
    i45 = i45 << 11 ^ i45;
    i48 = i48 << 11 ^ i48;
    i4 = i4 << 11 ^ i4;
    f17 = Math_fround(Math_fround((i42 ^ i41 ^ i41 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f18 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f19 = Math_fround(Math_fround((i50 ^ i48 ^ i48 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
    f20 = Math_fround(Math_fround((i3 ^ i4 ^ i4 >>> 8) & 8388607 ^ i3 >>> 19 | 0) * Math_fround(1.19209304e-07));
    HEAPF32[i35 >> 2] = f17;
    HEAPF32[i8 >> 2] = f18;
    HEAPF32[i9 >> 2] = f19;
    HEAPF32[i10 >> 2] = f20;
    i3 = i2 + 12 | 0;
    HEAPF32[i11 >> 2] = f32;
    HEAPF32[i12 >> 2] = f32;
    HEAPF32[i13 >> 2] = f32;
    HEAPF32[i34 >> 2] = f32;
    i4 = HEAP32[i2 + 96 >> 2] | 0;
    L30 : do switch ((i4 & 65535) << 16 >> 16) {
    case 0:
     {
      i50 = HEAP32[i2 + 92 >> 2] | 0;
      HEAP32[i16 >> 2] = i50;
      HEAP32[i15 >> 2] = i50;
      HEAP32[i14 >> 2] = i50;
      HEAP32[i36 >> 2] = i50;
      break;
     }
    case 3:
     {
      f51 = Math_fround(HEAPF32[(HEAP32[i2 + 244 >> 2] | 0) + 4 >> 2]);
      f52 = Math_fround(HEAPF32[i2 + 92 >> 2]);
      f51 = Math_fround(f51 * f52);
      f52 = Math_fround(Math_fround(f52 * Math_fround(HEAPF32[(HEAP32[i2 + 156 >> 2] | 0) + 4 >> 2])) - f51);
      f53 = Math_fround(f51 + Math_fround(f52 * f18));
      f54 = Math_fround(f51 + Math_fround(f52 * f19));
      f55 = Math_fround(f51 + Math_fround(f52 * f20));
      HEAPF32[i36 >> 2] = Math_fround(f51 + Math_fround(f17 * f52));
      HEAPF32[i14 >> 2] = f53;
      HEAPF32[i15 >> 2] = f54;
      HEAPF32[i16 >> 2] = f55;
      break;
     }
    default:
     if (!(i4 & 16711680)) {
      __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i36, i3, i34, i35);
      break L30;
     } else {
      __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i36, i3, i34, i35);
      break L30;
     }
    } while (0);
    f58 = Math_fround(HEAPF32[i36 >> 2]);
    f17 = Math_fround(f25 * f58);
    f57 = Math_fround(HEAPF32[i14 >> 2]);
    f65 = Math_fround(f25 * f57);
    f56 = Math_fround(HEAPF32[i15 >> 2]);
    f64 = Math_fround(f25 * f56);
    f55 = Math_fround(HEAPF32[i16 >> 2]);
    f63 = Math_fround(f25 * f55);
    f62 = Math_fround(f26 * f58);
    f61 = Math_fround(f26 * f57);
    f60 = Math_fround(f26 * f56);
    f59 = Math_fround(f26 * f55);
    f58 = Math_fround(f27 * f58);
    f57 = Math_fround(f27 * f57);
    f56 = Math_fround(f27 * f56);
    f55 = Math_fround(f27 * f55);
    i3 = (HEAP32[i21 >> 2] | 0) + (i5 << 2) | 0;
    f18 = Math_fround(HEAPF32[i3 >> 2]);
    i4 = i3 + 4 | 0;
    f19 = Math_fround(HEAPF32[i4 >> 2]);
    i28 = i3 + 8 | 0;
    f20 = Math_fround(HEAPF32[i28 >> 2]);
    i29 = i3 + 12 | 0;
    f43 = Math_fround(HEAPF32[i29 >> 2]);
    i40 = (HEAP32[i22 >> 2] | 0) + (i5 << 2) | 0;
    f44 = Math_fround(HEAPF32[i40 >> 2]);
    i41 = i40 + 4 | 0;
    f47 = Math_fround(HEAPF32[i41 >> 2]);
    i42 = i40 + 8 | 0;
    f49 = Math_fround(HEAPF32[i42 >> 2]);
    i45 = i40 + 12 | 0;
    f51 = Math_fround(HEAPF32[i45 >> 2]);
    i46 = (HEAP32[i23 >> 2] | 0) + (i5 << 2) | 0;
    f52 = Math_fround(HEAPF32[i46 >> 2]);
    i48 = i46 + 4 | 0;
    f53 = Math_fround(HEAPF32[i48 >> 2]);
    i50 = i46 + 8 | 0;
    f54 = Math_fround(HEAPF32[i50 >> 2]);
    i2 = i46 + 12 | 0;
    f19 = Math_fround(f65 + f19);
    f20 = Math_fround(f64 + f20);
    f43 = Math_fround(f63 + f43);
    f44 = Math_fround(f62 + f44);
    f47 = Math_fround(f61 + f47);
    f49 = Math_fround(f60 + f49);
    f51 = Math_fround(f59 + f51);
    f52 = Math_fround(f58 + f52);
    f53 = Math_fround(f57 + f53);
    f54 = Math_fround(f56 + f54);
    f55 = Math_fround(f55 + Math_fround(HEAPF32[i2 >> 2]));
    HEAPF32[i3 >> 2] = Math_fround(f17 + f18);
    HEAPF32[i4 >> 2] = f19;
    HEAPF32[i28 >> 2] = f20;
    HEAPF32[i29 >> 2] = f43;
    HEAPF32[i40 >> 2] = f44;
    HEAPF32[i41 >> 2] = f47;
    HEAPF32[i42 >> 2] = f49;
    HEAPF32[i45 >> 2] = f51;
    HEAPF32[i46 >> 2] = f52;
    HEAPF32[i48 >> 2] = f53;
    HEAPF32[i50 >> 2] = f54;
    HEAPF32[i2 >> 2] = f55;
    i5 = i5 + 4 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   } while (i5 >>> 0 < i37 >>> 0);
   if (HEAP32[i2 + 8 >> 2] | 0) {
    STACKTOP = i39;
    return;
   }
   break;
  }
 default:
  {}
 }
 if (!(((HEAP16[i2 + 96 >> 1] | 0) + -1 & 65535) < 2 & i33)) {
  STACKTOP = i39;
  return;
 }
 i3 = HEAP32[i38 + 180 >> 2] | 0;
 i4 = HEAP32[i38 + 200 >> 2] | 0;
 i2 = HEAP32[i38 + 220 >> 2] | 0;
 do {
  i50 = i3 + (i1 << 2) | 0;
  HEAP32[i50 >> 2] = i30;
  HEAP32[i50 + 4 >> 2] = i30;
  HEAP32[i50 + 8 >> 2] = i30;
  HEAP32[i50 + 12 >> 2] = i30;
  i50 = i4 + (i1 << 2) | 0;
  HEAP32[i50 >> 2] = i31;
  HEAP32[i50 + 4 >> 2] = i31;
  HEAP32[i50 + 8 >> 2] = i31;
  HEAP32[i50 + 12 >> 2] = i31;
  i50 = i2 + (i1 << 2) | 0;
  HEAP32[i50 >> 2] = i24;
  HEAP32[i50 + 4 >> 2] = i24;
  HEAP32[i50 + 8 >> 2] = i24;
  HEAP32[i50 + 12 >> 2] = i24;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i37 >>> 0);
 STACKTOP = i39;
 return;
}

function __Z22SampleReflectionProbesRK23ReflectionProbesContextRK4AABBji20ReflectionProbeUsageR16ReflectionSample(i17, i18, i7, i8, i4, i21) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i21 = i21 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i23 + 8 | 0;
 i3 = i23;
 i22 = i23 + 44 | 0;
 i14 = i23 + 16 | 0;
 i12 = i17 + 12 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  i4 = i21;
  i1 = i17 + 88 | 0;
  i3 = i4 + 124 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  STACKTOP = i23;
  return;
 }
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i13 = i3;
 HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i13 + 4 >> 2] = i19;
 HEAP32[i22 >> 2] = 0;
 i13 = i22 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i19 = i22 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i3);
 i16 = i1;
 i3 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i22 >> 2] = i16;
  break;
 } while (0);
 if ((i7 | 0) == -1) i16 = i4; else {
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i19 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i19 >> 2] = i1;
    HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i19 >> 2] = i1;
    HEAP32[i22 >> 2] = i16;
    break;
   }
  } while (0);
  HEAP32[i13 >> 2] = i4;
  i16 = HEAP32[i22 >> 2] | 0;
  HEAP32[i16 + (i3 * 12 | 0) >> 2] = i7;
  HEAPF32[i16 + (i3 * 12 | 0) + 4 >> 2] = Math_fround(1.0);
  HEAP32[i16 + (i3 * 12 | 0) + 8 >> 2] = i8;
  i16 = 3;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i12 >> 2] | 0)) i1 = 0; else {
   i4 = i17 + 20 | 0;
   i1 = 0;
   do {
    f2 = Math_fround(__ZL23CalculateProbeInfluenceRK4AABBS1_(i18, (HEAP32[i17 >> 2] | 0) + (i1 * 24 | 0) | 0));
    if (f2 > Math_fround(0.0)) {
     i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 * 40 | 0) + 36 >> 2] | 0;
     i6 = HEAP32[i13 >> 2] | 0;
     i7 = i6 + 1 | 0;
     i8 = HEAP32[i19 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i7 >>> 0 > i9 >>> 0) {
      i3 = i8 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i9 >>> 0 < i3 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i19 >> 2] = i3;
       HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i3 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i9 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i19 >> 2] = i3;
       HEAP32[i22 >> 2] = i9;
       break;
      }
     } while (0);
     HEAP32[i13 >> 2] = i7;
     i9 = HEAP32[i22 >> 2] | 0;
     HEAP32[i9 + (i6 * 12 | 0) >> 2] = i1;
     HEAPF32[i9 + (i6 * 12 | 0) + 4 >> 2] = f2;
     HEAP32[i9 + (i6 * 12 | 0) + 8 >> 2] = i5;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i12 = HEAP32[i22 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i14 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i14 + 24 >> 2] = i17;
  __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i12, i12 + (i1 * 12 | 0) | 0, i14);
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) {
   i4 = i21;
   i1 = i17 + 88 | 0;
   i3 = i4 + 124 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    i4 = i4 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i4 | 0) < (i3 | 0));
  } else i15 = 27;
 } else i15 = 27;
 if ((i15 | 0) == 27) {
  i6 = HEAP32[i22 >> 2] | 0;
  i3 = i17 + 20 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i15 = HEAP32[i3 >> 2] | 0;
  i4 = i21 + 44 | 0;
  i14 = i15 + (i5 * 40 | 0) + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  i4 = (HEAP32[i17 >> 2] | 0) + (i5 * 24 | 0) | 0;
  HEAP32[i21 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i21 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i21 + 24 >> 2] = HEAP32[i15 + (i5 * 40 | 0) >> 2];
  i4 = i21 + 28 | 0;
  i5 = i15 + (i5 * 40 | 0) + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i4 = i21 + 60 | 0;
  i5 = i1 >>> 0 > 1;
  if (i5) {
   i14 = HEAP32[i6 + 12 >> 2] | 0;
   i13 = HEAP32[i3 >> 2] | 0;
   i15 = i21 + 104 | 0;
   i12 = i13 + (i14 * 40 | 0) + 20 | 0;
   HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i15 = (HEAP32[i17 >> 2] | 0) + (i14 * 24 | 0) | 0;
   HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
   HEAP32[i21 + 84 >> 2] = HEAP32[i13 + (i14 * 40 | 0) >> 2];
   i15 = i21 + 88 | 0;
   i14 = i13 + (i14 * 40 | 0) + 4 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  } else {
   i1 = i17 + 148 | 0;
   i3 = i4 + 60 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    i4 = i4 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i4 | 0) < (i3 | 0));
  }
  do if ((i16 | 0) == 3) {
   i7 = i18 + 16 | 0;
   i6 = i18 + 20 | 0;
   i5 = i18 + 12 | 0;
   f2 = Math_fround(1.0);
  } else {
   f11 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   i8 = HEAP32[i6 + 8 >> 2] | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i7 = i1 + ((HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
   if (i5) {
    f10 = Math_fround(HEAPF32[i6 + 16 >> 2]);
    i4 = HEAP32[i6 + 20 >> 2] | 0;
    i3 = i1 + ((HEAP32[i6 + 12 >> 2] | 0) * 24 | 0) | 0;
   } else {
    f10 = Math_fround(0.0);
    i4 = -1;
    i3 = gb + 1155204 | 0;
   }
   i5 = i18 + 12 | 0;
   f2 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
   i1 = i18 + 16 | 0;
   f24 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(2.0));
   i6 = i18 + 20 | 0;
   f24 = Math_fround(Math_fround(f2 * f24) * Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(2.0)));
   f2 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   f2 = f2 < f24 ? f24 : f2;
   if (!(f10 > Math_fround(0.0))) {
    if ((i16 | 0) != 2) {
     i7 = i1;
     f2 = Math_fround(1.0);
     break;
    }
    f2 = Math_fround(f11 / f2);
    i17 = f2 < Math_fround(0.0);
    i7 = f2 > Math_fround(1.0);
    f2 = i7 ? Math_fround(1.0) : f2;
    i7 = i1;
    f2 = i17 ? Math_fround(0.0) : f2;
    break;
   }
   if ((i8 | 0) > (i4 | 0)) {
    i7 = i1;
    f2 = Math_fround(f11 / f2);
    break;
   }
   if ((i4 | 0) > (i8 | 0)) {
    i7 = i1;
    f2 = Math_fround(Math_fround(1.0) - Math_fround(f10 / f2));
    break;
   }
   if (__Z17IsContainedInAABBRK4AABBS1_(i7, i3) | 0) {
    i7 = i1;
    f2 = Math_fround(f11 / f2);
    break;
   }
   if (__Z17IsContainedInAABBRK4AABBS1_(i3, i7) | 0) {
    i7 = i1;
    f2 = Math_fround(Math_fround(1.0) - Math_fround(f10 / f2));
    break;
   } else {
    i7 = i1;
    f2 = Math_fround(f11 / Math_fround(f11 + f10));
    break;
   }
  } while (0);
  HEAPF32[i21 + 120 >> 2] = f2;
  i3 = i18 + 4 | 0;
  i4 = i18 + 8 | 0;
  i1 = 0;
  do {
   if (Math_fround(HEAPF32[i21 + (i1 * 60 | 0) + 56 >> 2]) > Math_fround(0.0)) {
    f25 = Math_fround(HEAPF32[i18 >> 2]);
    f25 = Math_fround(f25 - Math_fround(HEAPF32[i5 >> 2]));
    f31 = Math_fround(HEAPF32[i3 >> 2]);
    f31 = Math_fround(f31 - Math_fround(HEAPF32[i7 >> 2]));
    f32 = Math_fround(HEAPF32[i4 >> 2]);
    f32 = Math_fround(f32 - Math_fround(HEAPF32[i6 >> 2]));
    i12 = i21 + (i1 * 60 | 0) | 0;
    f24 = Math_fround(HEAPF32[i12 >> 2]);
    i15 = i21 + (i1 * 60 | 0) + 12 | 0;
    f28 = Math_fround(HEAPF32[i15 >> 2]);
    f2 = Math_fround(f24 - f28);
    i13 = i21 + (i1 * 60 | 0) + 4 | 0;
    f11 = Math_fround(HEAPF32[i13 >> 2]);
    i16 = i21 + (i1 * 60 | 0) + 16 | 0;
    f27 = Math_fround(HEAPF32[i16 >> 2]);
    f26 = Math_fround(f11 - f27);
    i14 = i21 + (i1 * 60 | 0) + 8 | 0;
    f10 = Math_fround(HEAPF32[i14 >> 2]);
    i17 = i21 + (i1 * 60 | 0) + 20 | 0;
    f29 = Math_fround(HEAPF32[i17 >> 2]);
    f30 = Math_fround(f10 - f29);
    f2 = f25 < f2 ? f25 : f2;
    f26 = f31 < f26 ? f31 : f26;
    f30 = f32 < f30 ? f32 : f30;
    f28 = Math_fround(f24 + f28);
    f27 = Math_fround(f11 + f27);
    f29 = Math_fround(f10 + f29);
    f28 = f28 < f25 ? f25 : f28;
    f27 = f27 < f31 ? f31 : f27;
    f29 = f29 < f32 ? f32 : f29;
    f32 = Math_fround(Math_fround(f2 + f28) * Math_fround(.5));
    f31 = Math_fround(Math_fround(f26 + f27) * Math_fround(.5));
    f25 = Math_fround(Math_fround(f30 + f29) * Math_fround(.5));
    HEAPF32[i12 >> 2] = f32;
    HEAPF32[i13 >> 2] = f31;
    HEAPF32[i14 >> 2] = f25;
    f2 = Math_fround(Math_fround(f28 - f2) * Math_fround(.5));
    f26 = Math_fround(Math_fround(f27 - f26) * Math_fround(.5));
    f30 = Math_fround(Math_fround(f29 - f30) * Math_fround(.5));
    HEAPF32[i15 >> 2] = f2;
    HEAPF32[i16 >> 2] = f26;
    HEAPF32[i17 >> 2] = f30;
    f29 = Math_fround(HEAPF32[i18 >> 2]);
    f29 = Math_fround(f29 + Math_fround(HEAPF32[i5 >> 2]));
    f27 = Math_fround(HEAPF32[i3 >> 2]);
    f27 = Math_fround(f27 + Math_fround(HEAPF32[i7 >> 2]));
    f28 = Math_fround(HEAPF32[i4 >> 2]);
    f28 = Math_fround(f28 + Math_fround(HEAPF32[i6 >> 2]));
    f10 = Math_fround(f32 - f2);
    f11 = Math_fround(f31 - f26);
    f24 = Math_fround(f25 - f30);
    f10 = f29 < f10 ? f29 : f10;
    f11 = f27 < f11 ? f27 : f11;
    f24 = f28 < f24 ? f28 : f24;
    f2 = Math_fround(f32 + f2);
    f26 = Math_fround(f31 + f26);
    f25 = Math_fround(f30 + f25);
    f2 = f2 < f29 ? f29 : f2;
    f26 = f26 < f27 ? f27 : f26;
    f25 = f25 < f28 ? f28 : f25;
    f28 = Math_fround(Math_fround(f11 + f26) * Math_fround(.5));
    f27 = Math_fround(Math_fround(f24 + f25) * Math_fround(.5));
    HEAPF32[i12 >> 2] = Math_fround(Math_fround(f10 + f2) * Math_fround(.5));
    HEAPF32[i13 >> 2] = f28;
    HEAPF32[i14 >> 2] = f27;
    f11 = Math_fround(Math_fround(f26 - f11) * Math_fround(.5));
    f24 = Math_fround(Math_fround(f25 - f24) * Math_fround(.5));
    HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 - f10) * Math_fround(.5));
    HEAPF32[i16 >> 2] = f11;
    HEAPF32[i17 >> 2] = f24;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 2);
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i20);
  HEAP32[i22 >> 2] = 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN22UnityAnalyticsSettings12GetOldUserIdEv(i24, i1) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 3360 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i23 + 24 | 0;
 i22 = i23 + 8 | 0;
 i18 = i23 + 3288 | 0;
 i19 = i23 + 2220 | 0;
 i6 = i23 + 3340 | 0;
 i7 = i23 + 3328 | 0;
 i20 = i23 + 1136 | 0;
 i8 = i23 + 3316 | 0;
 i21 = i23 + 1120 | 0;
 i12 = i23 + 3304 | 0;
 i10 = i23 + 2208 | 0;
 i11 = i23 + 2196 | 0;
 i14 = i23;
 i16 = i23 + 1104 | 0;
 i17 = i23 + 1088 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 __Z40GetPersistentDataPathApplicationSpecificv(i6);
 i5 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i1 = i2 + 44 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, i1);
 i4 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 HEAP32[i22 >> 2] = i5;
 HEAP32[i22 + 4 >> 2] = i4;
 __Z6FormatPKcz(i19, gb + 1041240 | 0, i22);
 i4 = HEAP8[i19 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i19 >> 2] | 0 : i19;
 i4 = i1 ? HEAP32[i19 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i18 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i18;
   i15 = i2;
  } else {
   i1 = i18;
   i9 = 9;
  }
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i22 >> 2] = 66;
  HEAP32[i22 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i18 + 4 >> 2] = i4;
  i2 = i18 + 11 | 0;
  i9 = 9;
 }
 if ((i9 | 0) == 9) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i15 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZN12FileAccessorC2Ev(i19);
 i9 = HEAP8[i15 >> 0] | 0;
 i5 = i9 << 24 >> 24 < 0;
 i6 = i18 + 4 | 0;
 i7 = i5 ? HEAP32[i18 >> 2] | 0 : i18;
 i9 = i5 ? HEAP32[i6 >> 2] | 0 : i9 & 255;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i7, i9);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 1041262 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i22, i21);
 __ZN15FileSystemEntryC2EPKc(i20, (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i19, i20, 0, 1) | 0)) {
  __Z40GetPersistentDataPathApplicationSpecificv(i12);
  i5 = (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  i2 = __Z17GetPlayerSettingsv() | 0;
  i1 = i2 + 44 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 48 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i4, i1);
  i1 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i13 + 4 >> 2] = i1;
  __Z6FormatPKcz(i22, gb + 1041269 | 0, i13);
  i5 = HEAP8[i22 + 11 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i22 >> 2] | 0 : i22;
  i5 = i1 ? HEAP32[i22 + 4 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i15 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i18 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i9 = i2 ? HEAP32[i6 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i18, i3, i5 - i3 | 0, i9, 0, i9, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i18 >> 2] | 0 : i18;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    HEAP32[i6 >> 2] = i5;
    break;
   } else {
    HEAP8[i15 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i12 = HEAP8[i15 >> 0] | 0;
  i9 = i12 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i18 >> 2] | 0 : i18;
  i12 = i9 ? HEAP32[i6 >> 2] | 0 : i12 & 255;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i10, i12);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 1041262 | 0, 6);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i22, i21);
  __ZN15FileSystemEntryC2EPKc(i13, (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  i12 = __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i19, i20, 0, 1) | 0;
  __ZN13FileEntryDataD2Ev(i13);
  if (!i12) {
   __ZN13FileEntryDataD2Ev(i20);
   __ZN12FileAccessorD2Ev(i19);
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i24 = HEAP32[i18 >> 2] | 0;
    i22 = HEAP32[i18 + 12 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i13 + 4 >> 2] = i22;
    __Z19free_alloc_internalPvRK10MemLabelId(i24, i13);
   }
   STACKTOP = i23;
   return;
  }
 }
 i3 = __ZNK12FileAccessor4SizeEv(i19) | 0;
 i4 = getTempRet0() | 0;
 if ((i3 | 0) == 0 & (i4 | 0) == 0) {
  __ZN12FileAccessor5CloseEv(i19) | 0;
  __ZN13FileEntryDataD2Ev(i20);
  __ZN12FileAccessorD2Ev(i19);
  if ((HEAP8[i15 >> 0] | 0) < 0) {
   i24 = HEAP32[i18 >> 2] | 0;
   i21 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i22 >> 2] = 66;
   HEAP32[i22 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
  }
  STACKTOP = i23;
  return;
 };
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i12 = i14;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i12 = i21 + 11 | 0;
 i5 = i21 + 4 | 0;
 if (!i3) {
  HEAP8[i21 + i3 >> 0] = 0;
  i1 = i3 & 255;
  HEAP8[i12 >> 0] = i1;
 } else {
  if (i3 >>> 0 > 10) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i21, 10, i3 + -10 | 0, 0, 0, 0, 0);
   i1 = HEAP8[i12 >> 0] | 0;
   i2 = HEAP32[i21 >> 2] | 0;
  } else {
   i1 = 0;
   i2 = 0;
  }
  i1 = i1 << 24 >> 24 < 0 ? i2 : i21;
  _memset(i1 | 0, 0, i3 | 0) | 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i5 >> 2] = i3; else HEAP8[i12 >> 0] = i3;
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP8[i12 >> 0] | 0;
 }
 __ZN12FileAccessor4ReadEyPvPy(i19, i3, i4, i1 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i21, i14) | 0;
 __ZN12FileAccessor5CloseEv(i19) | 0;
 HEAP32[i16 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i11 = i16 + 11 | 0;
 HEAP8[i11 >> 0] = 10;
 i1 = i16;
 i2 = gb + 1041297 | 0;
 i3 = i1 + 10 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i16 + 10 >> 0] = 0;
 i9 = HEAP8[i12 >> 0] | 0;
 i4 = i9 << 24 >> 24 < 0;
 i10 = i4 ? HEAP32[i21 >> 2] | 0 : i21;
 i9 = i4 ? HEAP32[i5 >> 2] | 0 : i9 & 255;
 i4 = HEAP32[i16 >> 2] & 255;
 if (i9 >>> 0 >= 10) {
  i8 = i10 + i9 | 0;
  i5 = i8;
  i7 = i10;
  L59 : do if ((i9 | 0) < 10) i2 = i5; else {
   i6 = i8 + -9 | 0;
   if ((i6 | 0) == (i10 | 0)) i2 = i5; else {
    i2 = i10;
    L61 : while (1) {
     while (1) {
      if ((HEAP8[i2 >> 0] | 0) == i4 << 24 >> 24) {
       i1 = 0;
       i3 = i2;
       break;
      }
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i6 | 0)) {
       i2 = i5;
       break L59;
      }
     }
     do {
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 10) break L61;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i16 + i1 >> 0] | 0));
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i6 | 0)) {
      i2 = i5;
      break L59;
     }
    }
   }
  } while (0);
  i1 = i2 - i7 | 0;
  if (!((i2 | 0) == (i8 | 0) | (i1 | 0) == -1)) {
   i3 = i1 + 10 | 0;
   if (i9 >>> 0 > i3 >>> 0) {
    i1 = i10 + i3 | 0;
    i4 = i10 + i9 | 0;
    i2 = i4;
    L74 : do if (!((i9 | 0) == (i3 | 0) | (i2 - i1 | 0) < 1)) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == 34) break;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) break L74;
     }
     i2 = i1;
    } while (0);
    i1 = i2 - i10 | 0;
    if (!((i2 | 0) == (i4 | 0) | (i1 | 0) == -1)) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_(i17, i21, i3, i1 - i3 | 0, i21 + 12 | 0);
     i5 = i17 + 11 | 0;
     i7 = HEAP8[i5 >> 0] | 0;
     i3 = i7 << 24 >> 24 < 0;
     i6 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
     i7 = i3 ? HEAP32[i17 + 4 >> 2] | 0 : i7 & 255;
     i3 = i24 + 11 | 0;
     i1 = HEAP8[i3 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i4 = (HEAP32[i24 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     do if (i7 >>> 0 > i4 >>> 0) {
      if (i2) i1 = HEAP32[i24 + 4 >> 2] | 0; else i1 = i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i24, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
     } else {
      if (i2) i1 = HEAP32[i24 >> 2] | 0; else i1 = i24;
      if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i1 + i7 >> 0] = 0;
      if ((HEAP8[i3 >> 0] | 0) < 0) {
       HEAP32[i24 + 4 >> 2] = i7;
       break;
      } else {
       HEAP8[i3 >> 0] = i7;
       break;
      }
     } while (0);
     if ((HEAP8[i5 >> 0] | 0) < 0) {
      i24 = HEAP32[i17 >> 2] | 0;
      i17 = HEAP32[i17 + 12 >> 2] | 0;
      HEAP32[i22 >> 2] = 66;
      HEAP32[i22 + 4 >> 2] = i17;
      __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
     }
     if ((HEAP8[i11 >> 0] | 0) < 0) {
      i24 = HEAP32[i16 >> 2] | 0;
      i17 = HEAP32[i16 + 12 >> 2] | 0;
      HEAP32[i22 >> 2] = 66;
      HEAP32[i22 + 4 >> 2] = i17;
      __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
     }
    }
   }
  }
 }
 if ((HEAP8[i12 >> 0] | 0) < 0) {
  i24 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i22 >> 2] = 66;
  HEAP32[i22 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
 }
 __ZN13FileEntryDataD2Ev(i20);
 __ZN12FileAccessorD2Ev(i19);
 if ((HEAP8[i15 >> 0] | 0) < 0) {
  i24 = HEAP32[i18 >> 2] | 0;
  i21 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i22 >> 2] = 66;
  HEAP32[i22 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i22);
 }
 STACKTOP = i23;
 return;
}

function __ZN22ParticleSystemRenderer24PrepareForRenderThreadedERK32ParticleSystemGeometryJobModulesR31ParticleSystemParticlesTempDataP23ParticleSystemParticlesR22ParticleSystemTempDataRK26ParticleSystemRendererData(i41, i38, i42, i40, i39) {
 i41 = i41 | 0;
 i38 = i38 | 0;
 i42 = i42 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, i43 = 0, i44 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i44;
 f34 = Math_fround(HEAPF32[i40 >> 2]);
 i35 = i40 + 320 | 0;
 f26 = Math_fround(HEAPF32[i35 >> 2]);
 f34 = Math_fround(f34 * f26);
 i3 = i40 + 16 | 0;
 f36 = Math_fround(HEAPF32[i3 >> 2]);
 i43 = i40 + 324 | 0;
 f30 = Math_fround(HEAPF32[i43 >> 2]);
 f36 = Math_fround(f34 + Math_fround(f36 * f30));
 i8 = i40 + 32 | 0;
 f34 = Math_fround(HEAPF32[i8 >> 2]);
 i1 = i40 + 328 | 0;
 f37 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(f36 + Math_fround(f34 * f37));
 i9 = i40 + 4 | 0;
 f36 = Math_fround(f26 * Math_fround(HEAPF32[i9 >> 2]));
 i10 = i40 + 20 | 0;
 f36 = Math_fround(f36 + Math_fround(f30 * Math_fround(HEAPF32[i10 >> 2])));
 i11 = i40 + 36 | 0;
 f36 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i11 >> 2])));
 i12 = i40 + 8 | 0;
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i12 >> 2]));
 i13 = i40 + 24 | 0;
 f30 = Math_fround(f26 + Math_fround(f30 * Math_fround(HEAPF32[i13 >> 2])));
 i24 = i40 + 40 | 0;
 f37 = Math_fround(f30 + Math_fround(f37 * Math_fround(HEAPF32[i24 >> 2])));
 HEAPF32[i35 >> 2] = f34;
 HEAPF32[i43 >> 2] = f36;
 HEAPF32[i1 >> 2] = f37;
 i1 = i39 + 2 | 0;
 if (HEAP16[i1 >> 1] | 0) {
  i43 = i40 + 192 | 0;
  __Z25InvertMatrix4x4_General3DPKfPf(i43, i2) | 0;
  __Z4SortRK10Matrix4x4fS1_R23ParticleSystemParticles22ParticleSystemSortModeR31ParticleSystemParticlesTempData(i43, i2, i42, HEAPU16[i1 >> 1] | 0, i38);
 }
 __ZN14ParticleSystem27UpdateModulesNonIncrementalERK32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesR31ParticleSystemParticlesTempData(i41, i42, i38);
 i43 = i40 + 332 | 0;
 i35 = HEAP32[i43 >> 2] | 0;
 i27 = i35 & 4095;
 i16 = i35 >>> 12 & 4095;
 HEAPF32[i40 + 368 >> 2] = Math_fround(Math_imul(i16, i27) | 0);
 HEAPF32[i40 + 372 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i27 >>> 0));
 HEAPF32[i40 + 376 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i16 >>> 0));
 i16 = i40 + 380 | 0;
 i27 = i40 + 380 | 0;
 HEAPF32[i27 >> 2] = Math_fround(-1.0);
 i28 = i40 + 384 | 0;
 i29 = i40 + 388 | 0;
 i31 = i40 + 392 | 0;
 i32 = i40 + 396 | 0;
 i33 = i40 + 400 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAPF32[i33 >> 2] = Math_fround(1.0);
 if ((HEAP16[i39 >> 1] | 0) == 3) {
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i32 >> 2] = Math_fround(1.0);
  HEAPF32[i33 >> 2] = Math_fround(0.0);
  f14 = Math_fround(HEAPF32[i40 >> 2]);
  f23 = Math_fround(HEAPF32[gb + 62548 >> 2]);
  f7 = Math_fround(f14 * f23);
  f15 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f5));
  f17 = Math_fround(HEAPF32[i8 >> 2]);
  f6 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f17 * f6));
  f18 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(f23 * f18);
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f5 * f19));
  f20 = Math_fround(HEAPF32[i11 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f6 * f20));
  f21 = Math_fround(HEAPF32[i12 >> 2]);
  f23 = Math_fround(f23 * f21);
  f22 = Math_fround(HEAPF32[i13 >> 2]);
  f5 = Math_fround(f23 + Math_fround(f5 * f22));
  f23 = Math_fround(HEAPF32[i24 >> 2]);
  f6 = Math_fround(f5 + Math_fround(f6 * f23));
  f4 = Math_fround(f4 * Math_fround(0.0));
  f5 = Math_fround(f6 - f4);
  f6 = Math_fround(Math_fround(f7 * Math_fround(0.0)) - Math_fround(f6 * Math_fround(0.0)));
  f7 = Math_fround(f4 - f7);
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)))));
  if (f4 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   f37 = Math_fround(f5 / f4);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   f37 = Math_fround(f6 / f4);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   f37 = Math_fround(f7 / f4);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = HEAP32[gb + 1162364 >> 2] | 0;
   i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = i1;
  HEAP32[i28 >> 2] = i2;
  HEAP32[i29 >> 2] = i3;
  f36 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = f14;
  f14 = f36;
  f36 = f15;
  f34 = f17;
  f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = f18;
  f4 = Math_fround(1.0);
  f5 = Math_fround(0.0);
 } else {
  f37 = Math_fround(HEAPF32[i40 >> 2]);
  f36 = Math_fround(HEAPF32[i3 >> 2]);
  f34 = Math_fround(HEAPF32[i8 >> 2]);
  f30 = Math_fround(HEAPF32[i9 >> 2]);
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  f20 = Math_fround(HEAPF32[i11 >> 2]);
  f21 = Math_fround(HEAPF32[i12 >> 2]);
  f22 = Math_fround(HEAPF32[i13 >> 2]);
  f14 = Math_fround(-1.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f23 = Math_fround(HEAPF32[i24 >> 2]);
  f4 = Math_fround(0.0);
  f5 = Math_fround(1.0);
 }
 f25 = Math_fround(Math_fround(Math_fround(f37 * f14) + Math_fround(f36 * f7)) + Math_fround(f34 * f6));
 f26 = Math_fround(Math_fround(Math_fround(f14 * f30) + Math_fround(f7 * f19)) + Math_fround(f6 * f20));
 f6 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f7 * f22)) + Math_fround(f6 * f23));
 HEAPF32[i27 >> 2] = f25;
 HEAPF32[i28 >> 2] = f26;
 HEAPF32[i29 >> 2] = f6;
 f17 = Math_fround(Math_fround(Math_fround(f37 * Math_fround(0.0)) + Math_fround(f36 * f4)) + Math_fround(f34 * f5));
 f18 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(0.0)) + Math_fround(f4 * f19)) + Math_fround(f5 * f20));
 f4 = Math_fround(Math_fround(Math_fround(f21 * Math_fround(0.0)) + Math_fround(f4 * f22)) + Math_fround(f5 * f23));
 HEAPF32[i31 >> 2] = f17;
 HEAPF32[i32 >> 2] = f18;
 HEAPF32[i33 >> 2] = f4;
 i3 = i41 + 32 | 0;
 i33 = HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] << 24 & 251658240;
 i1 = i35 & -251658241 | i33;
 HEAP32[i43 >> 2] = i1;
 if (!i33) i9 = i1 & -805306369; else {
  i2 = ((HEAP32[i38 + 16 >> 2] | 0) != 0 & 1) << 28 | i1 & -268435457;
  HEAP32[i43 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i1 + 4 >> 0] | 0)) i1 = 0; else if (Math_fround(HEAPF32[i1 + 564 >> 2]) > Math_fround(0.0)) i1 = 1; else i1 = Math_fround(HEAPF32[i1 + 568 >> 2]) > Math_fround(0.0);
  i9 = i2 & -536870913 | (i1 & 1) << 29;
 }
 HEAP32[i43 >> 2] = i9;
 f15 = Math_fround(Math_fround(Math_fround(HEAPF32[i39 + 28 >> 2]) * Math_fround(90.0)) * Math_fround(.0174532924));
 i39 = HEAP16[i39 >> 1] | 0;
 f14 = i39 << 16 >> 16 == 0 ? Math_fround(.707106769) : Math_fround(1.0);
 i3 = HEAP32[gb + 62548 >> 2] | 0;
 i2 = HEAP32[gb + 62548 + 4 >> 2] | 0;
 i1 = HEAP32[gb + 62548 + 8 >> 2] | 0;
 if ((i39 & -2) << 16 >> 16 == 2) {
  f7 = Math_fround(Math_fround(f26 * f4) - Math_fround(f6 * f18));
  f6 = Math_fround(Math_fround(f6 * f17) - Math_fround(f4 * f25));
  f4 = Math_fround(Math_fround(f18 * f25) - Math_fround(f26 * f17));
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)))));
  if (f5 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   f26 = Math_fround(f7 / f5);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   f26 = Math_fround(f6 / f5);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   f26 = Math_fround(f4 / f5);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = HEAP32[gb + 1162364 >> 2] | 0;
   i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  }
  f25 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f37 = Math_fround(f25 * f37);
  f26 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = Math_fround(f37 + Math_fround(f26 * f36));
  f37 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f36 + Math_fround(f37 * f34));
  f36 = Math_fround(Math_fround(Math_fround(f25 * f30) + Math_fround(f26 * f19)) + Math_fround(f37 * f20));
  f37 = Math_fround(Math_fround(Math_fround(f25 * f21) + Math_fround(f26 * f22)) + Math_fround(f37 * f23));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f37 = Math_fround(+Math_sin(+f15));
 f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f37);
 f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f37);
 f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f37);
 f34 = Math_fround(Math_fround(HEAPF32[i40 + 64 >> 2]) * f26);
 f34 = Math_fround(f34 + Math_fround(f30 * Math_fround(HEAPF32[i40 + 80 >> 2])));
 f34 = Math_fround(f34 + Math_fround(f37 * Math_fround(HEAPF32[i40 + 96 >> 2])));
 f36 = Math_fround(f26 * Math_fround(HEAPF32[i40 + 68 >> 2]));
 f36 = Math_fround(f36 + Math_fround(f30 * Math_fround(HEAPF32[i40 + 84 >> 2])));
 f36 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i40 + 100 >> 2])));
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i40 + 72 >> 2]));
 f30 = Math_fround(f26 + Math_fround(f30 * Math_fround(HEAPF32[i40 + 88 >> 2])));
 f37 = Math_fround(f30 + Math_fround(f37 * Math_fround(HEAPF32[i40 + 104 >> 2])));
 HEAPF32[i40 + 408 >> 2] = f34;
 HEAPF32[i40 + 412 >> 2] = f36;
 HEAPF32[i40 + 416 >> 2] = f37;
 HEAPF32[i40 + 404 >> 2] = Math_fround(f14 * Math_fround(+Math_cos(+f15)));
 i1 = HEAP32[i41 + 8 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) i1 = 1; else {
  i2 = HEAP16[i1 + 2096 >> 1] | 0;
  if (!(HEAP8[i1 + 2553 >> 0] | 0)) i1 = i2 << 16 >> 16 == 0; else i1 = (HEAP16[i1 + 1568 >> 1] | i2 | HEAP16[i1 + 1832 >> 1]) << 16 >> 16 == 0;
 }
 if (!(i1 & (HEAP8[(HEAP32[i41 + 16 >> 2] | 0) + 4 >> 0] | HEAP8[(HEAP32[i41 + 12 >> 2] | 0) + 4 >> 0]) << 24 >> 24 == 0)) {
  i42 = 0;
  i42 = i42 & 1;
  i42 = i42 << 30;
  i41 = i9 & -1073741825;
  i42 = i41 | i42;
  HEAP32[i43 >> 2] = i42;
  STACKTOP = i44;
  return;
 }
 i8 = HEAP32[i42 + 12 >> 2] | 0;
 i2 = HEAP8[i42 + 870 >> 0] | 0 ? 0 : 2;
 if (i8 >>> 0 <= 4) {
  do {
   i1 = HEAP32[i42 + 300 + (i2 * 20 | 0) >> 2] | 0;
   f37 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f34 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f30 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f36 = Math_fround(HEAPF32[i1 >> 2]);
   i1 = (f36 != f30 | f36 != f34 | f36 != f37) ^ 1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < 3 & i1);
  i42 = i1 & 1;
  i42 = i42 << 30;
  i41 = i9 & -1073741825;
  i42 = i41 | i42;
  HEAP32[i43 >> 2] = i42;
  STACKTOP = i44;
  return;
 }
 L38 : while (1) {
  i3 = HEAP32[i42 + 300 + (i2 * 20 | 0) >> 2] | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  i1 = 4;
  do {
   i41 = i3 + (i1 << 2) | 0;
   f34 = Math_fround(HEAPF32[i41 >> 2]);
   f36 = Math_fround(HEAPF32[i41 + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i41 + 8 >> 2]);
   i1 = i1 + 4 | 0;
   if (f34 != f4 | f36 != f5 | f37 != f6 | Math_fround(HEAPF32[i41 + 12 >> 2]) != f7) {
    i1 = 0;
    i2 = 30;
    break L38;
   }
  } while (i1 >>> 0 < i8 >>> 0);
  i1 = (f4 != f5 | f4 != f6 | f4 != f7) ^ 1;
  i2 = i2 + 1 | 0;
  if (!(i2 >>> 0 < 3 & i1)) {
   i2 = 30;
   break;
  }
 }
 if ((i2 | 0) == 30) {
  i42 = i1 & 1;
  i42 = i42 << 30;
  i41 = i9 & -1073741825;
  i42 = i41 | i42;
  HEAP32[i43 >> 2] = i42;
  STACKTOP = i44;
  return;
 }
}

function __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight(i31, i32, i5, i4, i38, i1, f12, i39) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 f12 = Math_fround(f12);
 i39 = i39 | 0;
 var f2 = f0, i3 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i40 + 12 | 0;
 i30 = i40 + 8 | 0;
 i28 = i40 + 4 | 0;
 i27 = i40;
 f33 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f34 = Math_fround(HEAPF32[i5 >> 2]);
 f35 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i32 + 792 >> 2]);
 f7 = Math_fround(HEAPF32[i32 + 796 >> 2]);
 f8 = Math_fround(HEAPF32[i31 >> 2]);
 i18 = i31 + 4 | 0;
 f9 = Math_fround(f35 * Math_fround(HEAPF32[i18 >> 2]));
 i19 = i31 + 8 | 0;
 f10 = Math_fround(f36 * Math_fround(HEAPF32[i19 >> 2]));
 i20 = i31 + 12 | 0;
 f11 = Math_fround(HEAPF32[i20 >> 2]);
 HEAP32[i28 >> 2] = 2139095040;
 HEAP32[i27 >> 2] = -8388608;
 i21 = HEAP32[i39 >> 2] | 0;
 HEAP32[i39 + 4 >> 2] = -1;
 i37 = i39 + 9 | 0;
 i6 = i1 & 1;
 HEAP8[i37 >> 0] = i6;
 HEAP8[i39 + 80 >> 0] = i38 & 1;
 i3 = i38 ? 2 : 1;
 i1 = 0;
 do {
  i23 = i39 + 48 + (i1 << 4) | 0;
  i17 = i4 + (i1 << 4) | 0;
  HEAP32[i23 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 f26 = Math_fround(f2 * Math_fround(1.00100005));
 f25 = Math_fround(f7 * Math_fround(.999000012));
 f24 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f34 * f8) + f9) + f10));
 i17 = i21 + 216 | 0;
 HEAPF32[i39 + 176 >> 2] = f12;
 i4 = i39 + 136 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = HEAP32[i21 + 268 >> 2] | 0;
 i5 = HEAP32[i21 + 272 >> 2] | 0;
 i15 = i21 + 40 | 0;
 i16 = i21 + 48 | 0;
 i23 = HEAP32[((HEAP32[i15 >> 2] | 0) == 3 ? i21 + 204 | 0 : i16) >> 2] | 0;
 HEAP32[i39 + 152 >> 2] = HEAP32[i21 + 264 >> 2];
 HEAP32[i39 + 156 >> 2] = i4;
 HEAP32[i39 + 160 >> 2] = i5;
 HEAP32[i39 + 164 >> 2] = i23;
 f14 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(.300000012));
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(.589999974)));
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i21 + 28 >> 2]) * Math_fround(.109999999)));
 HEAPF32[i39 + 168 >> 2] = Math_fround(Math_fround(HEAPF32[i21 + 44 >> 2]) * f14);
 HEAP8[i39 + 172 >> 0] = i6 ^ 1;
 if ((HEAP32[i15 >> 2] | 0) == 3) i23 = 2; else if ((HEAP32[i21 + 88 >> 2] | 0) > -1) i23 = (HEAP32[i21 + 80 >> 2] | 0) == 1 ? 1 : 2; else i23 = 0;
 HEAP32[i39 + 12 >> 2] = i23;
 HEAP32[i39 + 16 >> 2] = HEAP32[i21 + 36 >> 2];
 HEAP8[i39 + 81 >> 0] = HEAP8[i21 + 84 >> 0] | 0;
 i6 = i39 + 84 | 0;
 i5 = HEAP32[i21 + 92 >> 2] | 0;
 do if (!i5) i22 = 14; else {
  HEAP32[i30 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i22 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i1, i30);
    i3 = HEAP32[i29 >> 2] | 0;
    i41 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i41 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i41 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i22 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i22 = 13;
   }
  }
  if ((i22 | 0) == 11) i22 = 13;
  if ((i22 | 0) == 13) {
   i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   if (!i1) {
    i22 = 14;
    break;
   }
  }
  HEAP32[i6 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i39 + 88 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i39 + 92 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i4 = HEAP32[i1 + 68 >> 2] | 0;
  i3 = HEAP32[i1 + 72 >> 2] | 0;
  i41 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f13 = Math_fround(i41 | 0);
  f14 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i39 + 96 >> 2] = i4;
  HEAP32[i39 + 100 >> 2] = i3;
  HEAPF32[i39 + 104 >> 2] = f13;
  HEAPF32[i39 + 108 >> 2] = f14;
  i3 = i39 + 112 | 0;
  i4 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i29, i4, i1);
  HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
 } while (0);
 if ((i22 | 0) == 14) HEAP32[i6 >> 2] = 0;
 HEAP32[i39 + 128 >> 2] = HEAP32[i21 + 76 >> 2];
 i41 = HEAP32[i15 >> 2] | 0;
 HEAP32[i39 + 132 >> 2] = i41;
 if (!i41) {
  f14 = Math_fround(HEAPF32[i16 >> 2]);
  __Z24CalculateSpotLightBoundsffRK10Matrix4x4fR15SpotLightBounds(f14, Math_fround(HEAPF32[i21 + 68 >> 2]), i17, i29);
  f14 = Math_fround(HEAPF32[i31 >> 2]);
  f42 = Math_fround(HEAPF32[i18 >> 2]);
  f43 = Math_fround(HEAPF32[i19 >> 2]);
  f44 = Math_fround(HEAPF32[i20 >> 2]);
  f2 = Math_fround(f14 * Math_fround(HEAPF32[i29 >> 2]));
  i1 = i29 + 4 | 0;
  f2 = Math_fround(f2 + Math_fround(f42 * Math_fround(HEAPF32[i1 >> 2])));
  i3 = i29 + 8 | 0;
  f2 = Math_fround(f44 + Math_fround(f2 + Math_fround(f43 * Math_fround(HEAPF32[i3 >> 2]))));
  HEAPF32[i30 >> 2] = f2;
  i22 = f2 < Math_fround(inf);
  i22 = HEAP32[(i22 ? i30 : i28) >> 2] | 0;
  HEAP32[i28 >> 2] = i22;
  i41 = f2 > Math_fround(-inf);
  i41 = HEAP32[(i41 ? i30 : i27) >> 2] | 0;
  HEAP32[i27 >> 2] = i41;
  i4 = i29 + 12 | 0;
  f2 = Math_fround(f14 * Math_fround(HEAPF32[i4 >> 2]));
  i5 = i29 + 16 | 0;
  f2 = Math_fround(f2 + Math_fround(f42 * Math_fround(HEAPF32[i5 >> 2])));
  i6 = i29 + 20 | 0;
  f2 = Math_fround(f44 + Math_fround(f2 + Math_fround(f43 * Math_fround(HEAPF32[i6 >> 2]))));
  HEAPF32[i30 >> 2] = f2;
  i22 = f2 < (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i22 = HEAP32[(i22 ? i30 : i28) >> 2] | 0;
  HEAP32[i28 >> 2] = i22;
  i41 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f2;
  i41 = HEAP32[(i41 ? i30 : i27) >> 2] | 0;
  HEAP32[i27 >> 2] = i41;
  f2 = Math_fround(HEAPF32[i29 + 24 >> 2]);
  f9 = Math_fround(f14 * f2);
  f7 = Math_fround(HEAPF32[i29 + 28 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f42 * f7));
  f8 = Math_fround(HEAPF32[i29 + 32 >> 2]);
  f9 = Math_fround(f44 + Math_fround(f9 + Math_fround(f43 * f8)));
  HEAPF32[i30 >> 2] = f9;
  i22 = f9 < (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i22 = HEAP32[(i22 ? i30 : i28) >> 2] | 0;
  HEAP32[i28 >> 2] = i22;
  i41 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f9;
  i41 = HEAP32[(i41 ? i30 : i27) >> 2] | 0;
  HEAP32[i27 >> 2] = i41;
  f9 = Math_fround(HEAPF32[i29 + 36 >> 2]);
  f12 = Math_fround(f14 * f9);
  f10 = Math_fround(HEAPF32[i29 + 40 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f42 * f10));
  f11 = Math_fround(HEAPF32[i29 + 44 >> 2]);
  f12 = Math_fround(f44 + Math_fround(f12 + Math_fround(f43 * f11)));
  HEAPF32[i30 >> 2] = f12;
  i22 = f12 < (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i22 = HEAP32[(i22 ? i30 : i28) >> 2] | 0;
  HEAP32[i28 >> 2] = i22;
  i41 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f12;
  i41 = HEAP32[(i41 ? i30 : i27) >> 2] | 0;
  HEAP32[i27 >> 2] = i41;
  f12 = Math_fround(HEAPF32[i29 + 48 >> 2]);
  f14 = Math_fround(f14 * f12);
  f13 = Math_fround(HEAPF32[i29 + 52 >> 2]);
  f42 = Math_fround(f14 + Math_fround(f42 * f13));
  f14 = Math_fround(HEAPF32[i29 + 56 >> 2]);
  f43 = Math_fround(f44 + Math_fround(f42 + Math_fround(f43 * f14)));
  HEAPF32[i30 >> 2] = f43;
  i22 = f43 < (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f42 = Math_fround(HEAPF32[i28 >> 2]);
  f42 = i22 ? f43 : f42;
  i41 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f43;
  i41 = HEAP32[(i41 ? i30 : i27) >> 2] | 0;
  HEAP32[i27 >> 2] = i41;
  HEAP8[i39 + 20 >> 0] = f42 <= f26 & 1;
  HEAP8[i39 + 21 >> 0] = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f25 & 1;
  f26 = Math_fround(f24 - f33);
  f26 = f42 < f26 ? f26 : f42;
  HEAPF32[i28 >> 2] = f26;
  if (f26 > Math_fround(HEAPF32[i31 + 16 >> 2])) {
   HEAP8[i37 >> 0] = 0;
   _memset(i39 + 48 | 0, 0, (i38 ? 32 : 16) | 0) | 0;
  }
  f25 = Math_fround(HEAPF32[i29 >> 2]);
  f42 = Math_fround(HEAPF32[i1 >> 2]);
  f26 = Math_fround(HEAPF32[i3 >> 2]);
  f47 = Math_fround(HEAPF32[i4 >> 2]);
  f24 = f47 < f25 ? f47 : f25;
  f46 = Math_fround(HEAPF32[i5 >> 2]);
  f44 = f46 < f42 ? f46 : f42;
  f45 = Math_fround(HEAPF32[i6 >> 2]);
  f43 = f45 < f26 ? f45 : f26;
  f25 = f25 < f47 ? f47 : f25;
  f42 = f42 < f46 ? f46 : f42;
  f26 = f26 < f45 ? f45 : f26;
  f24 = f2 < f24 ? f2 : f24;
  f44 = f7 < f44 ? f7 : f44;
  f43 = f8 < f43 ? f8 : f43;
  f25 = f25 < f2 ? f2 : f25;
  f42 = f42 < f7 ? f7 : f42;
  f26 = f26 < f8 ? f8 : f26;
  f24 = f9 < f24 ? f9 : f24;
  f44 = f10 < f44 ? f10 : f44;
  f2 = f11 < f43 ? f11 : f43;
  f25 = f25 < f9 ? f9 : f25;
  f42 = f42 < f10 ? f10 : f42;
  f26 = f26 < f11 ? f11 : f26;
  f24 = f12 < f24 ? f12 : f24;
  f44 = f13 < f44 ? f13 : f44;
  f2 = f14 < f2 ? f14 : f2;
  f25 = f25 < f12 ? f12 : f25;
  f13 = f42 < f13 ? f13 : f42;
  f14 = f26 < f14 ? f14 : f26;
  f26 = Math_fround(Math_fround(f44 + f13) * Math_fround(.5));
  f42 = Math_fround(Math_fround(f2 + f14) * Math_fround(.5));
  f43 = Math_fround(Math_fround(f25 - f24) * Math_fround(.5));
  f44 = Math_fround(Math_fround(f13 - f44) * Math_fround(.5));
  f2 = Math_fround(Math_fround(f14 - f2) * Math_fround(.5));
  HEAPF32[i39 + 24 >> 2] = Math_fround(Math_fround(f24 + f25) * Math_fround(.5));
  HEAPF32[i39 + 28 >> 2] = f26;
  HEAPF32[i39 + 32 >> 2] = f42;
  HEAPF32[i39 + 36 >> 2] = f43;
  HEAPF32[i39 + 40 >> 2] = f44;
  HEAPF32[i39 + 44 >> 2] = f2;
  f2 = Math_fround(HEAPF32[i28 >> 2]);
 } else {
  f2 = Math_fround(f24 - f33);
  HEAPF32[i28 >> 2] = f2;
  HEAPF32[i39 + 24 >> 2] = f34;
  HEAPF32[i39 + 28 >> 2] = f35;
  HEAPF32[i39 + 32 >> 2] = f36;
  HEAPF32[i39 + 36 >> 2] = f33;
  HEAPF32[i39 + 40 >> 2] = f33;
  HEAPF32[i39 + 44 >> 2] = f33;
  f47 = Math_fround(f33 * Math_fround(1.26999998));
  HEAP8[i39 + 20 >> 0] = Math_fround(f24 - f47) <= f26 & 1;
  HEAP8[i39 + 21 >> 0] = Math_fround(f47 + f24) >= f25 & 1;
 }
 i41 = f2 < Math_fround(HEAPF32[i32 + 780 >> 2]);
 i41 = i41 ? HEAP8[i31 + 20 >> 0] | 0 : 0;
 i1 = i39 + 8 | 0;
 HEAP8[i1 >> 0] = i41;
 do if (!(i41 << 24 >> 24)) i1 = 1; else {
  if (!(HEAP8[i32 + 776 >> 0] | 0)) {
   STACKTOP = i40;
   return;
  }
  f47 = Math_fround(f33 + Math_fround(HEAPF32[i32 + 768 >> 2]));
  f44 = Math_fround(f34 - Math_fround(HEAPF32[i32 + 756 >> 2]));
  f45 = Math_fround(f35 - Math_fround(HEAPF32[i32 + 760 >> 2]));
  f46 = Math_fround(f36 - Math_fround(HEAPF32[i32 + 764 >> 2]));
  if (Math_fround(Math_fround(Math_fround(f44 * f44) + Math_fround(f45 * f45)) + Math_fround(f46 * f46)) > Math_fround(f47 * f47)) {
   HEAP8[i1 >> 0] = 0;
   i1 = 1;
   break;
  }
  if (__Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB(i32, i39 + 24 | 0) | 0) {
   i1 = (HEAP8[i1 >> 0] | 0) == 0;
   break;
  } else {
   HEAP8[i1 >> 0] = 0;
   i1 = 1;
   break;
  }
 } while (0);
 if (!((i23 | 0) == 1 & i1)) {
  STACKTOP = i40;
  return;
 }
 HEAP8[i37 >> 0] = 0;
 _memset(i39 + 48 | 0, 0, (i38 ? 32 : 16) | 0) | 0;
 STACKTOP = i40;
 return;
}

function __ZL12ShadowMapJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i3, i42) {
 i3 = i3 | 0;
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i50 + 160 | 0;
 i39 = i50 + 96 | 0;
 i15 = i50;
 if ((HEAP16[gb + 1113072 + 6 >> 1] | 0) > -1) {
  HEAP32[i39 >> 2] = 0;
  HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113072 | 0, i40);
  i41 = gb + 1113072 | 0;
 } else i41 = 0;
 i17 = HEAP32[gb + 1113072 >> 2] | 0;
 i43 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 648 >> 2] | 0, i43 | 0, i17 | 0);
 i17 = HEAP32[i3 + 12 >> 2] | 0;
 i43 = i3 + 16 | 0;
 i44 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i42 + 1184 >> 2] | 0;
 i45 = i42 + 200 | 0;
 i2 = HEAP32[i42 + 1192 >> 2] | 0;
 f38 = Math_fround(HEAPF32[i42 + 1196 >> 2]);
 f37 = Math_fround(HEAPF32[i42 + 1200 >> 2]);
 i47 = __Z12GetGfxDevicev() | 0;
 i46 = mftCall_ii(HEAP32[(HEAP32[i47 >> 2] | 0) + 100 >> 2] | 0, i47 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i47 >> 2] | 0) + 96 >> 2] | 0, i47 | 0, 0);
 i47 = (HEAP8[i44 + 4381 >> 0] | 0) != 0;
 i36 = (i1 | 0) == 2;
 mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 88 >> 2] | 0, i44 | 0, i36 | 0);
 i48 = i3 + 168 | 0;
 i49 = i42 + 1168 | 0;
 do if (i36) {
  if ((HEAP16[gb + 1113084 + 6 >> 1] | 0) > -1) {
   HEAP32[i39 >> 2] = 0;
   HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113084 | 0, i40);
   i6 = gb + 1113084 | 0;
  } else i6 = 0;
  i7 = HEAP32[gb + 1113084 >> 2] | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 648 >> 2] | 0, i1 | 0, i7 | 0);
  __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues(i40, i43 + 4 | 0, i44 + 4 | 0);
  __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f(i40, 1, gb + 1162292 | 0, i42 + 1204 | 0);
  i7 = i3 + 188 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i7 = i7 + 4 | 0;
  if ((i1 | 0) <= (HEAP32[i7 >> 2] | 0)) {
   i8 = i42 + 35888 | 0;
   i9 = i42 + 36272 | 0;
   i10 = i39 + 4 | 0;
   i11 = i39 + 8 | 0;
   i12 = i39 + 12 | 0;
   i13 = i3 + 172 | 0;
   i14 = i42 + 1228 | 0;
   i5 = i3 + 184 | 0;
   while (1) {
    i2 = i8 + (i1 << 6) | 0;
    i3 = i9 + (i1 << 6) | 0;
    __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i17, 0, i1, 0, 12);
    HEAPF32[i39 >> 2] = Math_fround(1.0);
    HEAPF32[i10 >> 2] = Math_fround(1.0);
    HEAPF32[i11 >> 2] = Math_fround(1.0);
    HEAPF32[i12 >> 2] = Math_fround(1.0);
    __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(7, i39, Math_fround(1.0), 0, i43);
    __Z15gpu_time_samplev();
    if (!i3) {
     if (i2 | 0) i16 = 14;
    } else {
     mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 116 >> 2] | 0, i44 | 0, i3 | 0);
     if (!i2) mftCall_vi(HEAP32[(HEAP32[i44 >> 2] | 0) + 120 >> 2] | 0, i44 | 0); else i16 = 14;
    }
    if ((i16 | 0) == 14) {
     i16 = 0;
     mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 112 >> 2] | 0, i44 | 0, i2 | 0);
    }
    __Z27SetClippingPlaneShaderPropsR9GfxDevice(__Z12GetGfxDevicev() | 0);
    __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, i2, i39);
    __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i39, i15);
    i2 = HEAP32[i48 >> 2] | 0;
    i3 = (HEAP32[i13 >> 2] | 0) - i2 | 0;
    i4 = (i3 | 0) / 24 | 0;
    if ((i3 | 0) > 0) {
     i36 = i2;
     HEAP32[i36 + 12 >> 2] = (__Z20IntersectAABBFrustumRK4AABBPK5Planej(HEAP32[i36 + 4 >> 2] | 0, i15, 15) | 0) & 1;
     if ((i3 | 0) > 24) {
      i2 = 1;
      do {
       i36 = HEAP32[i48 >> 2] | 0;
       HEAP32[i36 + (i2 * 24 | 0) + 12 >> 2] = (__Z20IntersectAABBFrustumRK4AABBPK5Planej(HEAP32[i36 + (i2 * 24 | 0) + 4 >> 2] | 0, i15, 15) | 0) & 1;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (i4 | 0));
     }
    }
    __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb(0, i45, i43, i48, i49, i14, (HEAP8[i5 >> 0] | 0) != 0);
    if ((i1 | 0) < (HEAP32[i7 >> 2] | 0)) i1 = i1 + 1 | 0; else break;
   }
  }
  __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev(i40);
  i49 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i49 >> 2] | 0) + 652 >> 2] | 0, i49 | 0);
  if (i6 | 0) __Z12profiler_endP19ProfilerInformation(i6);
 } else {
  if ((i1 | 0) != 1) {
   if ((HEAP16[gb + 1113096 + 6 >> 1] | 0) > -1) {
    HEAP32[i39 >> 2] = 0;
    HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113096 | 0, i40);
    i1 = gb + 1113096 | 0;
   } else i1 = 0;
   i39 = HEAP32[gb + 1113096 >> 2] | 0;
   i36 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 648 >> 2] | 0, i36 | 0, i39 | 0);
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i17, 0, -1, 0, 12);
   __Z15gpu_time_samplev();
   i39 = i42 + 36728 | 0;
   mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 116 >> 2] | 0, i44 | 0, i42 + 36792 | 0);
   mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 112 >> 2] | 0, i44 | 0, i39 | 0);
   __Z27SetClippingPlaneShaderPropsR9GfxDevice(__Z12GetGfxDevicev() | 0);
   __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues(i40, i43 + 4 | 0, i44 + 4 | 0);
   __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f(i40, 0, i39, gb + 1162364 | 0);
   i39 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
   f37 = Math_fround(f38 * Math_fround(2.0));
   HEAPF32[i44 + 804 >> 2] = Math_fround((i39 ? f37 : f38) * (HEAP8[i42 + 36859 >> 0] | 0 ? Math_fround(-1.0) : Math_fround(1.0)));
   HEAPF32[i44 + 808 >> 2] = Math_fround(0.0);
   HEAPF32[i44 + 812 >> 2] = Math_fround(0.0);
   HEAPF32[i44 + 816 >> 2] = Math_fround(0.0);
   __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb(0, i45, i43, i48, i49, i42 + 1228 | 0, (HEAP8[i3 + 184 >> 0] | 0) != 0);
   __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev(i40);
   i49 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i49 >> 2] | 0) + 652 >> 2] | 0, i49 | 0);
   if (!i1) break;
   __Z12profiler_endP19ProfilerInformation(i1);
   break;
  }
  if ((HEAP16[gb + 1113108 + 6 >> 1] | 0) > -1) {
   HEAP32[i39 >> 2] = 0;
   HEAP32[i40 >> 2] = HEAP32[i39 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113108 | 0, i40);
   i31 = gb + 1113108 | 0;
  } else i31 = 0;
  i32 = HEAP32[gb + 1113108 >> 2] | 0;
  i33 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 648 >> 2] | 0, i33 | 0, i32 | 0);
  i32 = i42 + 34304 | 0;
  i33 = HEAP32[i42 + 35864 >> 2] | 0;
  i34 = HEAP32[i42 + 35868 >> 2] | 0;
  i35 = HEAP32[i42 + 35872 >> 2] | 0;
  i36 = HEAP32[i42 + 35876 >> 2] | 0;
  i1 = HEAP32[i42 + 35884 >> 2] | 0;
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i17, 0, -1, 0, 12);
  __Z15gpu_time_samplev();
  __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues(i40, i43 + 4 | 0, i44 + 4 | 0);
  if ((i34 | 0) > 0) {
   i30 = (i33 | 0) > 0;
   i22 = (i2 | 0) == 2;
   i23 = i42 + 36856 | 0;
   i24 = i42 + 36864 | 0;
   i25 = i42 + 36860 | 0;
   f26 = Math_fround(f37 * Math_fround(2.5));
   i16 = i44 + 804 | 0;
   i17 = i44 + 808 | 0;
   i20 = i44 + 812 | 0;
   i21 = i44 + 816 | 0;
   i27 = i39 + 8 | 0;
   i28 = i39 + 4 | 0;
   i29 = i39 + 12 | 0;
   i9 = (i1 | 0) == 1;
   i10 = i35 + -2 | 0;
   i11 = i36 + -2 | 0;
   i12 = i39 + 8 | 0;
   i13 = i39 + 4 | 0;
   i14 = i39 + 12 | 0;
   i15 = i42 + 1228 | 0;
   i8 = i3 + 184 | 0;
   i1 = 0;
   i7 = 0;
   do {
    if (i30) {
     i5 = Math_imul(i7, i36) | 0;
     i6 = i5 + 1 | 0;
     i3 = 0;
     i4 = i1;
     while (1) {
      do if (HEAP8[i32 + (i4 * 364 | 0) >> 0] | 0) {
       i2 = i32 + (i4 * 364 | 0) + 68 | 0;
       mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 116 >> 2] | 0, i44 | 0, i32 + (i4 * 364 | 0) + 132 | 0);
       mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 112 >> 2] | 0, i44 | 0, i2 | 0);
       __Z27SetClippingPlaneShaderPropsR9GfxDevice(__Z12GetGfxDevicev() | 0);
       __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f(i40, 0, i2, gb + 1162364 | 0);
       f19 = Math_fround(-Math_fround(f38 * Math_fround(HEAPF32[(mftCall_ii(HEAP32[(HEAP32[i44 >> 2] | 0) + 140 >> 2] | 0, i44 | 0) | 0) + 40 >> 2])));
       if (i22) if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0) < 30) f18 = f37; else {
        i2 = HEAP32[i23 >> 2] | 0;
        if (!((i2 & 255) << 24 >> 24)) f18 = f37; else if ((i2 & 65280 | 0) != 0 & (i2 & 16711680 | 0) != 0) {
         f18 = Math_fround(HEAPF32[i24 >> 2]);
         i2 = HEAP32[i25 >> 2] | 0;
         i2 = f18 > Math_fround(0.0) & ((i2 | 0) > 1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 532 >> 0] | 0) == 0);
         f18 = i2 ? f26 : f37;
        } else f18 = f37;
       } else f18 = f37;
       f52 = Math_fround(HEAPF32[i32 + (i4 * 364 | 0) + 340 >> 2]);
       f53 = Math_fround(HEAPF32[i32 + (i4 * 364 | 0) + 344 >> 2]);
       f18 = Math_fround(f18 * (f52 < f53 ? f53 : f52));
       HEAPF32[i16 >> 2] = f19;
       HEAPF32[i17 >> 2] = Math_fround(1.0);
       HEAPF32[i20 >> 2] = f18;
       HEAPF32[i21 >> 2] = Math_fround(0.0);
       i51 = HEAP32[(HEAP32[i44 >> 2] | 0) + 152 >> 2] | 0;
       i2 = Math_imul(i3, i35) | 0;
       HEAP32[i39 >> 2] = i2;
       HEAP32[i27 >> 2] = i35;
       HEAP32[i28 >> 2] = i5;
       HEAP32[i29 >> 2] = i36;
       mftCall_vii(i51 | 0, i44 | 0, i39 | 0);
       if (i9) {
        i51 = HEAP32[(HEAP32[i44 >> 2] | 0) + 160 >> 2] | 0;
        HEAP32[i39 >> 2] = i2 + 1;
        HEAP32[i12 >> 2] = i10;
        HEAP32[i13 >> 2] = i6;
        HEAP32[i14 >> 2] = i11;
        mftCall_vii(i51 | 0, i44 | 0, i39 | 0);
        __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb(i4, i45, i43, i48, i49, i15, (HEAP8[i8 >> 0] | 0) != 0);
        mftCall_vi(HEAP32[(HEAP32[i44 >> 2] | 0) + 164 >> 2] | 0, i44 | 0);
        break;
       } else {
        __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb(i4, i45, i43, i48, i49, i15, (HEAP8[i8 >> 0] | 0) != 0);
        break;
       }
      } while (0);
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i33 | 0)) break; else i4 = i4 + 1 | 0;
     }
     i1 = i33 + i1 | 0;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i34 | 0));
  }
  __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev(i40);
  i51 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i51 >> 2] | 0) + 652 >> 2] | 0, i51 | 0);
  if (i31 | 0) __Z12profiler_endP19ProfilerInformation(i31);
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i44 >> 2] | 0) + 88 >> 2] | 0, i44 | 0, i47 | 0);
 i48 = HEAP32[i42 + 8 >> 2] | 0;
 i51 = i43 + 144 | 0;
 i49 = HEAP8[i51 >> 0] | 0;
 HEAP8[i51 >> 0] = 1;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i48 + 208 | 0, 1, i43, i42 + 1228 | 0, gb + 1160140 | 0, HEAP32[i48 + 16 >> 2] | 0);
 HEAP8[i51 >> 0] = i49;
 i51 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i51 >> 2] | 0) + 96 >> 2] | 0, i51 | 0, i46 | 0);
 i51 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i51 >> 2] | 0) + 652 >> 2] | 0, i51 | 0);
 if (!i41) {
  STACKTOP = i50;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i41);
 STACKTOP = i50;
 return;
}

function __ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i2, i6, i21, i22) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f23 = f0, i24 = 0;
 f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(f1 - f14);
 f4 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 - f15);
 f3 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(f3 - f16);
 f14 = Math_fround(Math_fround(f1 * Math_fround(.5)) + f14);
 f15 = Math_fround(Math_fround(f4 * Math_fround(.5)) + f15);
 f16 = Math_fround(Math_fround(f3 * Math_fround(.5)) + f16);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4)) + Math_fround(f3 * f3))));
 i20 = f5 != Math_fround(0.0);
 if (i20) {
  f19 = Math_fround(Math_fround(1.0) / f5);
  f1 = Math_fround(f1 * f19);
  f4 = Math_fround(f4 * f19);
  f3 = Math_fround(f3 * f19);
  f5 = Math_fround(f5 * Math_fround(.5));
 } else f19 = Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f7 = Math_fround(f7 - f11);
 f8 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f8 = Math_fround(f8 - f12);
 f9 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f9 = Math_fround(f9 - f13);
 f11 = Math_fround(Math_fround(f7 * Math_fround(.5)) + f11);
 f12 = Math_fround(Math_fround(f8 * Math_fround(.5)) + f12);
 f13 = Math_fround(Math_fround(f9 * Math_fround(.5)) + f13);
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9))));
 i18 = f10 != Math_fround(0.0);
 if (i18) {
  f17 = Math_fround(Math_fround(1.0) / f10);
  f7 = Math_fround(f7 * f17);
  f8 = Math_fround(f8 * f17);
  f9 = Math_fround(f9 * f17);
  f10 = Math_fround(f10 * Math_fround(.5));
 } else f17 = Math_fround(0.0);
 f23 = Math_fround(f14 - f11);
 f15 = Math_fround(f15 - f12);
 f14 = Math_fround(f16 - f13);
 f12 = Math_fround(Math_fround(f3 * f9) + Math_fround(Math_fround(f4 * f8) + Math_fround(f1 * f7)));
 f11 = Math_fround(-f12);
 f13 = Math_fround(Math_fround(Math_fround(f1 * f23) + Math_fround(f4 * f15)) + Math_fround(f3 * f14));
 f9 = Math_fround(Math_fround(f14 * f9) + Math_fround(Math_fround(f15 * f8) + Math_fround(f23 * f7)));
 f14 = Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f15 * f15)) + Math_fround(f14 * f14));
 f8 = Math_fround(Math_abs(Math_fround(Math_fround(1.0) - Math_fround(f12 * f12))));
 do if (!(f8 >= Math_fround(9.99999997e-07))) {
  f4 = Math_fround(f5 + f10);
  i6 = f12 < Math_fround(-0.0);
  f7 = i6 ? Math_fround(-1.0) : Math_fround(1.0);
  f3 = Math_fround(Math_fround(f13 + Math_fround(f9 * f7)) * Math_fround(.5));
  f1 = Math_fround(-f3);
  if (f3 > f4) f1 = Math_fround(-f4); else if (f4 < f1) f1 = f4;
  f4 = Math_fround(Math_fround(-Math_fround(f10 * Math_fround(f7 * f1))) / f4);
  f9 = Math_fround(f1 * Math_fround(Math_fround(f3 * Math_fround(2.0)) + f1));
  f3 = Math_fround(f1 + Math_fround(f7 * f4));
 } else {
  f7 = Math_fround(Math_fround(f12 * f9) - f13);
  f1 = Math_fround(f9 + Math_fround(f13 * f11));
  f3 = Math_fround(f5 * f8);
  f4 = Math_fround(f10 * f8);
  if (!(f7 >= Math_fround(-f3))) {
   if (!(f1 >= Math_fround(-f4))) {
    f4 = Math_fround(-f10);
    f1 = Math_fround(f13 + Math_fround(f10 * f12));
    f3 = Math_fround(-f1);
    if (f5 < f3) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f4) + Math_fround(f5 * Math_fround(f5 + Math_fround(f1 * Math_fround(2.0)))));
     f3 = f5;
     break;
    }
    f8 = Math_fround(-f5);
    if (f1 <= f5) {
     f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f4));
     break;
    }
    f1 = Math_fround(Math_fround(f5 * f12) - f9);
    f7 = Math_fround(-f1);
    if (f1 > f10) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f4));
     f3 = f8;
     break;
    }
    if (!(f10 >= f7)) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
     f3 = f8;
     f4 = f10;
     break;
    } else {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(f1 * f7));
     f3 = f8;
     f4 = f7;
     break;
    }
   }
   if (f1 <= f4) {
    f3 = Math_fround(-f5);
    f1 = Math_fround(Math_fround(f5 * f12) - f9);
    f4 = Math_fround(-f1);
    f7 = Math_fround(-f10);
    if (f1 > f10) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f3) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f7));
     f4 = f7;
     break;
    }
    if (!(f10 >= f4)) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f3) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
     f4 = f10;
     break;
    } else {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f3) + Math_fround(f1 * f4));
     break;
    }
   }
   f1 = Math_fround(f13 + Math_fround(f10 * f11));
   f3 = Math_fround(-f1);
   if (f5 < f3) {
    f9 = Math_fround(Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))) + Math_fround(f5 * Math_fround(f5 + Math_fround(f1 * Math_fround(2.0)))));
    f3 = f5;
    f4 = f10;
    break;
   }
   f8 = Math_fround(-f5);
   if (f1 <= f5) {
    f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))));
    f4 = f10;
    break;
   }
   f1 = Math_fround(Math_fround(f5 * f12) - f9);
   f4 = Math_fround(-f1);
   f7 = Math_fround(-f10);
   if (f1 > f10) {
    f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f7));
    f3 = f8;
    f4 = f7;
    break;
   }
   if (!(f10 >= f4)) {
    f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
    f3 = f8;
    f4 = f10;
    break;
   } else {
    f9 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * Math_fround(2.0)) - f5) * f8) + Math_fround(f1 * f4));
    f3 = f8;
    break;
   }
  }
  i2 = f1 >= Math_fround(-f4);
  if (f7 <= f3) {
   if (!i2) {
    f7 = Math_fround(-f10);
    f1 = Math_fround(f13 + Math_fround(f10 * f12));
    f3 = Math_fround(-f1);
    f4 = Math_fround(-f5);
    if (f1 > f5) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f7) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f5) * f4));
     f3 = f4;
     f4 = f7;
     break;
    }
    if (!(f5 >= f3)) {
     f9 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f7) + Math_fround(f5 * Math_fround(f5 + Math_fround(f1 * Math_fround(2.0)))));
     f3 = f5;
     f4 = f7;
     break;
    } else {
     f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f7));
     f4 = f7;
     break;
    }
   }
   if (f1 <= f4) {
    f4 = Math_fround(Math_fround(1.0) / f8);
    f3 = Math_fround(f7 * f4);
    f4 = Math_fround(f1 * f4);
    f9 = Math_fround(Math_fround(f3 * Math_fround(Math_fround(f13 * Math_fround(2.0)) + Math_fround(f3 + Math_fround(f4 * f11)))) + Math_fround(f4 * Math_fround(Math_fround(f4 + Math_fround(f3 * f11)) - Math_fround(f9 * Math_fround(2.0)))));
    break;
   }
   f1 = Math_fround(f13 + Math_fround(f10 * f11));
   f3 = Math_fround(-f1);
   f4 = Math_fround(-f5);
   if (f1 > f5) {
    f9 = Math_fround(Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f5) * f4));
    f3 = f4;
    f4 = f10;
    break;
   }
   if (!(f5 >= f3)) {
    f9 = Math_fround(Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))) + Math_fround(f5 * Math_fround(f5 + Math_fround(f1 * Math_fround(2.0)))));
    f3 = f5;
    f4 = f10;
    break;
   } else {
    f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))));
    f4 = f10;
    break;
   }
  }
  if (!i2) {
   f4 = Math_fround(-f10);
   f1 = Math_fround(f13 + Math_fround(f10 * f12));
   f3 = Math_fround(-f1);
   f7 = Math_fround(-f5);
   if (f1 > f5) {
    f9 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f4) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f5) * f7));
    f3 = f7;
    break;
   }
   if (f5 >= f3) {
    f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(Math_fround(Math_fround(f9 * Math_fround(-2.0)) - f10) * f4));
    break;
   }
   f1 = Math_fround(Math_fround(f5 * f11) - f9);
   f7 = Math_fround(-f1);
   if (f10 < f7) {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
    f3 = f5;
    f4 = f10;
    break;
   }
   if (!(f1 <= f10)) {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f4));
    f3 = f5;
    break;
   } else {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f1 * f7));
    f3 = f5;
    f4 = f7;
    break;
   }
  }
  if (f1 <= f4) {
   f1 = Math_fround(Math_fround(f5 * f11) - f9);
   f4 = Math_fround(-f1);
   f7 = Math_fround(-f10);
   if (f1 > f10) {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f7));
    f3 = f5;
    f4 = f7;
    break;
   }
   if (!(f10 >= f4)) {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
    f3 = f5;
    f4 = f10;
    break;
   } else {
    f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f1 * f4));
    f3 = f5;
    break;
   }
  }
  f1 = Math_fround(f13 + Math_fround(f10 * f11));
  f3 = Math_fround(-f1);
  f4 = Math_fround(-f5);
  if (f1 > f5) {
   f9 = Math_fround(Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f5) * f4));
   f3 = f4;
   f4 = f10;
   break;
  }
  if (f5 >= f3) {
   f9 = Math_fround(Math_fround(f1 * f3) + Math_fround(f10 * Math_fround(f10 - Math_fround(f9 * Math_fround(2.0)))));
   f4 = f10;
   break;
  }
  f1 = Math_fround(Math_fround(f5 * f11) - f9);
  f4 = Math_fround(-f1);
  f7 = Math_fround(-f10);
  if (f1 > f10) {
   f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(Math_fround(Math_fround(f1 * Math_fround(2.0)) - f10) * f7));
   f3 = f5;
   f4 = f7;
   break;
  }
  if (!(f10 >= f4)) {
   f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f10 * Math_fround(f10 + Math_fround(f1 * Math_fround(2.0)))));
   f3 = f5;
   f4 = f10;
   break;
  } else {
   f9 = Math_fround(Math_fround(f5 * Math_fround(f5 + Math_fround(f13 * Math_fround(2.0)))) + Math_fround(f1 * f4));
   f3 = f5;
   break;
  }
 } while (0);
 f1 = Math_fround(f14 + f9);
 i2 = (i21 | 0) == 0;
 if (!i2) HEAPF32[i21 >> 2] = f3;
 i6 = (i22 | 0) == 0;
 if (!i6) HEAPF32[i22 >> 2] = f4;
 i24 = f1 < Math_fround(0.0);
 f3 = i24 ? Math_fround(0.0) : f1;
 if (!i2) {
  if (i20) f1 = Math_fround(f19 * Math_fround(f5 + Math_fround(HEAPF32[i21 >> 2]))); else f1 = Math_fround(0.0);
  HEAPF32[i21 >> 2] = f1;
 }
 if (i6) return Math_fround(f3);
 if (i18) f1 = Math_fround(f17 * Math_fround(f10 + Math_fround(HEAPF32[i22 >> 2]))); else f1 = Math_fround(0.0);
 HEAPF32[i22 >> 2] = f1;
 return Math_fround(f3);
}

function __ZN5physx28PxTriangleMeshRepXSerializer16objectToFileImplEPKNS_14PxTriangleMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i18, i16, i1, i26, i25, i17) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i29 + 56 | 0;
 i10 = i29 + 48 | 0;
 i6 = i29 + 40 | 0;
 i5 = i29 + 32 | 0;
 i8 = i29 + 24 | 0;
 i7 = i29 + 16 | 0;
 i4 = i29 + 8 | 0;
 i3 = i29;
 i23 = i29 + 208 | 0;
 i21 = i29 + 136 | 0;
 i28 = i29 + 64 | 0;
 i27 = i29 + 176 | 0;
 i15 = (mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 48 >> 2] | 0, i16 | 0, 0) | 0) << 16 >> 16 != -1;
 i13 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] | 0, i16 | 0) | 0;
 if ((i13 | 0) != 0 & (i12 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 1 | 0) == 0) mftCall_iiii(i1 | 0, i25 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i25, i12 + (i2 * 12 | 0) | 0) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  HEAP8[i23 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i23 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, gb + 673161 | 0, HEAP32[i25 + 20 >> 2] | 0);
  HEAP32[i25 + 16 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
 }
 i11 = ((mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 40 >> 2] | 0, i16 | 0) | 0) & 2) != 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0, i16 | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0, i16 | 0) | 0;
 if (i11) {
  if ((i14 | 0) != 0 & (i9 | 0) != 0) {
   i2 = 0;
   do {
    i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    if ((i2 | 0) != 0 & (i2 & 1 | 0) == 0) mftCall_iiii(i1 | 0, i25 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
    i1 = HEAPU16[i9 + (i2 * 6 | 0) >> 1] | 0;
    i19 = i23;
    i20 = i19 + 128 | 0;
    do {
     HEAP8[i19 >> 0] = 0;
     i19 = i19 + 1 | 0;
    } while ((i19 | 0) < (i20 | 0));
    HEAP32[i3 >> 2] = i1;
    __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i3) | 0;
    if (HEAP8[i23 >> 0] | 0) {
     i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
     mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
    }
    mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
    i1 = HEAPU16[i9 + (i2 * 6 | 0) + 2 >> 1] | 0;
    i19 = i23;
    i20 = i19 + 128 | 0;
    do {
     HEAP8[i19 >> 0] = 0;
     i19 = i19 + 1 | 0;
    } while ((i19 | 0) < (i20 | 0));
    HEAP32[i4 >> 2] = i1;
    __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i4) | 0;
    if (HEAP8[i23 >> 0] | 0) {
     i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
     mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
    }
    mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
    i1 = HEAPU16[i9 + (i2 * 6 | 0) + 4 >> 1] | 0;
    i19 = i23;
    i20 = i19 + 128 | 0;
    do {
     HEAP8[i19 >> 0] = 0;
     i19 = i19 + 1 | 0;
    } while ((i19 | 0) < (i20 | 0));
    HEAP32[i7 >> 2] = i1;
    __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i7) | 0;
    if (HEAP8[i23 >> 0] | 0) {
     i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
     mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
   HEAP8[i7 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i7 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, gb + 673168 | 0, HEAP32[i25 + 20 >> 2] | 0);
   HEAP32[i25 + 16 >> 2] = 0;
   HEAP32[i25 + 12 >> 2] = 0;
  }
 } else if ((i14 | 0) != 0 & (i9 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & (i2 & 1 | 0) == 0) mftCall_iiii(i1 | 0, i25 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i9 + (i2 * 12 | 0) >> 2] | 0;
   i19 = i23;
   i20 = i19 + 128 | 0;
   do {
    HEAP8[i19 >> 0] = 0;
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   HEAP32[i8 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i8) | 0;
   if (HEAP8[i23 >> 0] | 0) {
    i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
   }
   mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i9 + (i2 * 12 | 0) + 4 >> 2] | 0;
   i19 = i23;
   i20 = i19 + 128 | 0;
   do {
    HEAP8[i19 >> 0] = 0;
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   HEAP32[i5 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i5) | 0;
   if (HEAP8[i23 >> 0] | 0) {
    i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
   }
   mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i9 + (i2 * 12 | 0) + 8 >> 2] | 0;
   i19 = i23;
   i20 = i19 + 128 | 0;
   do {
    HEAP8[i19 >> 0] = 0;
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   HEAP32[i6 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i6) | 0;
   if (HEAP8[i23 >> 0] | 0) {
    i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i14 | 0));
  HEAP8[i6 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i6 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, gb + 673168 | 0, HEAP32[i25 + 20 >> 2] | 0);
  HEAP32[i25 + 16 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
 }
 if (i15) if ((i16 | 0) != 0 & (i14 | 0) != 0) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i25 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = (mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 48 >> 2] | 0, i16 | 0, i2 | 0) | 0) & 65535;
   i19 = i23;
   i20 = i19 + 128 | 0;
   do {
    HEAP8[i19 >> 0] = 0;
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) < (i20 | 0));
   HEAP32[i10 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i10) | 0;
   if (HEAP8[i23 >> 0] | 0) {
    i22 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    mftCall_iiii(i22 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i14 | 0));
  HEAP8[i10 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i10 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, gb + 753833 | 0, HEAP32[i25 + 20 >> 2] | 0);
  HEAP32[i25 + 16 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
 }
 i3 = i21 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 i22 = i21 + 32 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 20 >> 2] = 0;
 HEAP16[i21 + 24 >> 1] = 0;
 HEAPF32[i21 + 36 >> 2] = Math_fround(.00100000005);
 HEAP32[i21 + 8 >> 2] = i13;
 HEAP32[i21 + 4 >> 2] = i12;
 HEAP32[i21 >> 2] = 12;
 HEAP32[i21 + 20 >> 2] = i14;
 HEAP32[i21 + 16 >> 2] = i9;
 i1 = i21 + 12 | 0;
 HEAP32[i1 >> 2] = i11 ? 6 : 12;
 if (i11) {
  HEAP32[i1 >> 2] = 6;
  HEAP16[i21 + 24 >> 1] = 2;
 } else HEAP32[i1 >> 2] = 12;
 if (i15) {
  i1 = __Znaj(i14 >>> 0 > 2147483647 ? -1 : i14 << 1) | 0;
  if (i14 | 0) {
   i2 = 0;
   do {
    HEAP16[i1 + (i2 << 1) >> 1] = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 48 >> 2] | 0, i16 | 0, i2 | 0) | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
  }
  HEAP32[i22 >> 2] = i1;
  HEAP32[i3 >> 2] = 2;
 } else i1 = 0;
 i2 = i17 + 4 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  HEAP32[i28 >> 2] = HEAP32[i18 + 4 >> 2];
  i8 = i28 + 4 | 0;
  HEAP32[i8 >> 2] = i28;
  i10 = i28;
  HEAP32[i28 + 8 >> 2] = i10;
  i13 = i28 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  i9 = i28 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  i14 = i28 + 20 | 0;
  HEAP32[i14 >> 2] = 0;
  i6 = i28 + 24 | 0;
  HEAP32[i6 >> 2] = i10;
  i10 = i28 + 28 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 20 >> 2] = 0;
  HEAPF32[i28 + 52 >> 2] = Math_fround(.75);
  i11 = i28 + 56 | 0;
  HEAP32[i11 >> 2] = -1;
  HEAP32[i28 + 60 >> 2] = 0;
  i12 = i28 + 64 | 0;
  HEAP32[i12 >> 2] = 0;
  __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i6, 64);
  HEAP32[i28 + 68 >> 2] = 32;
  i6 = i27 + 4 | 0;
  i7 = i27 + 8 | 0;
  HEAP32[i7 >> 2] = i28;
  i4 = i27 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i27 >> 2] = gb + 89528 + 8;
  HEAP32[i6 >> 2] = gb + 89528 + 32;
  HEAP32[i27 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i3 = HEAP32[i2 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i21 | 0, i27 | 0) | 0;
  i3 = i27 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != 0 & (i4 | 0) != 0) {
   i5 = 0;
   do {
    i2 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    if ((i5 | 0) != 0 & (i5 & 15 | 0) == 0) mftCall_iiii(i2 | 0, i25 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i2 | 0, i25 | 0, gb + 1086395 | 0, 1) | 0;
    i2 = HEAPU8[i1 + i5 >> 0] | 0;
    i19 = i23;
    i20 = i19 + 128 | 0;
    do {
     HEAP8[i19 >> 0] = 0;
     i19 = i19 + 1 | 0;
    } while ((i19 | 0) < (i20 | 0));
    HEAP32[i24 >> 2] = i2;
    __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 1084495 | 0, i24) | 0;
    if (HEAP8[i23 >> 0] | 0) {
     i21 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
     mftCall_iiii(i21 | 0, i25 | 0, i23 | 0, _strlen(i23) | 0) | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i4 | 0));
   HEAP8[i24 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i24 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, gb + 673178 | 0, HEAP32[i25 + 20 >> 2] | 0);
   HEAP32[i25 + 16 >> 2] = 0;
   HEAP32[i25 + 12 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i27 >> 2] = gb + 89572 + 8;
  HEAP32[i6 >> 2] = gb + 89572 + 32;
  if (i1 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i7 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i27 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + (i27 << 2) | 0;
  if (i27 | 0) do {
   i27 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i9 >> 2] = 0;
  i1 = HEAP32[i28 + 48 >> 2] | 0;
  if (!((i1 | 0) == 0 | (HEAP32[i12 >> 2] | 0) == 0)) {
   _memset(HEAP32[i28 + 40 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i28 + 44 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i28 + 36 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i27 = HEAP32[HEAP32[i28 + 24 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, i1 | 0);
  }
  i27 = HEAP32[i14 >> 2] | 0;
  if ((i27 | 0) > -1 & (i27 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) {
    i28 = HEAP32[HEAP32[i28 + 8 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
   }
  }
  i1 = HEAP32[i22 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i29;
  return;
 }
 __ZdaPv(i1);
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i24, i1, i5, i6, i22) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i25 + 208 | 0;
 i2 = i25 + 160 | 0;
 i4 = i25 + 16 | 0;
 i23 = i25;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i20 = i2 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAPF32[i2 + 20 >> 2] = Math_fround(1.0);
 i20 = i2 + 24 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAPF32[i2 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f29 = Math_fround(f11 - f16);
 f27 = Math_fround(f12 - f17);
 f32 = Math_fround(f13 - f10);
 f26 = Math_fround(f14 - f16);
 f31 = Math_fround(f15 - f17);
 f28 = Math_fround(f9 - f10);
 f30 = Math_fround(Math_fround(f27 * f28) - Math_fround(f32 * f31));
 f28 = Math_fround(Math_fround(f32 * f26) - Math_fround(f29 * f28));
 f26 = Math_fround(Math_fround(f29 * f31) - Math_fround(f27 * f26));
 f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f30 * f30) + Math_fround(f28 * f28))))));
 f30 = Math_fround(f27 * f30);
 f28 = Math_fround(f27 * f28);
 f27 = Math_fround(f26 * f27);
 f26 = Math_fround(Math_fround(f10 * f27) + Math_fround(Math_fround(f16 * f30) + Math_fround(f17 * f28)));
 f31 = Math_fround(HEAPF32[i24 + 4400 >> 2]);
 f29 = Math_fround(HEAPF32[i24 + 4404 >> 2]);
 if (Math_fround(Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f29 * f28)) + Math_fround(f27 * Math_fround(HEAPF32[i24 + 4408 >> 2]))) - f26) < Math_fround(0.0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 f41 = Math_fround(HEAPF32[i24 + 2304 >> 2]);
 f38 = Math_fround(HEAPF32[i24 + 2308 >> 2]);
 f35 = Math_fround(HEAPF32[i24 + 2312 >> 2]);
 f40 = Math_fround(HEAPF32[i24 + 2256 >> 2]);
 f28 = Math_fround(f16 * f40);
 f39 = Math_fround(HEAPF32[i24 + 2272 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f17 * f39));
 f30 = Math_fround(HEAPF32[i24 + 2288 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f10 * f30));
 f37 = Math_fround(HEAPF32[i24 + 2260 >> 2]);
 f27 = Math_fround(f16 * f37);
 f36 = Math_fround(HEAPF32[i24 + 2276 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f17 * f36));
 f31 = Math_fround(HEAPF32[i24 + 2292 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f10 * f31));
 f34 = Math_fround(HEAPF32[i24 + 2264 >> 2]);
 f26 = Math_fround(f16 * f34);
 f33 = Math_fround(HEAPF32[i24 + 2280 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f17 * f33));
 f32 = Math_fround(HEAPF32[i24 + 2296 >> 2]);
 f16 = Math_fround(f41 + f28);
 f17 = Math_fround(f38 + f27);
 f26 = Math_fround(f35 + Math_fround(f26 + Math_fround(f10 * f32)));
 f27 = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f11 * f40) + Math_fround(f12 * f39)) + Math_fround(f13 * f30)));
 f28 = Math_fround(f38 + Math_fround(Math_fround(Math_fround(f11 * f37) + Math_fround(f12 * f36)) + Math_fround(f13 * f31)));
 f29 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f11 * f34) + Math_fround(f12 * f33)) + Math_fround(f13 * f32)));
 f30 = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f14 * f40) + Math_fround(f15 * f39)) + Math_fround(f9 * f30)));
 f31 = Math_fround(f38 + Math_fround(Math_fround(Math_fround(f14 * f37) + Math_fround(f15 * f36)) + Math_fround(f9 * f31)));
 f32 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(f14 * f34) + Math_fround(f15 * f33)) + Math_fround(f9 * f32)));
 i18 = i4 + 64 | 0;
 HEAP32[i4 + 80 >> 2] = 7;
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 f14 = Math_fround(Math_fround(f31 + Math_fround(f17 + f28)) * Math_fround(.333332986));
 f15 = Math_fround(Math_fround(f32 + Math_fround(f26 + f29)) * Math_fround(.333332986));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(f30 + Math_fround(f16 + f27)) * Math_fround(.333332986));
 HEAPF32[i4 + 4 >> 2] = f14;
 HEAPF32[i4 + 8 >> 2] = f15;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 96 >> 2] = f16;
 HEAPF32[i4 + 100 >> 2] = f17;
 HEAPF32[i4 + 104 >> 2] = f26;
 HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 112 >> 2] = f27;
 HEAPF32[i4 + 116 >> 2] = f28;
 HEAPF32[i4 + 120 >> 2] = f29;
 HEAPF32[i4 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 128 >> 2] = f30;
 HEAPF32[i4 + 132 >> 2] = f31;
 HEAPF32[i4 + 136 >> 2] = f32;
 HEAPF32[i4 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i3 + 32 >> 2] = HEAP32[i24 + 2208 >> 2];
 HEAP32[i3 + 36 >> 2] = i2;
 HEAP32[i3 + 40 >> 2] = i2;
 HEAP8[i3 + 44 >> 0] = 1;
 HEAP32[i3 >> 2] = gb + 84676 + 8;
 HEAP32[i3 + 48 >> 2] = i4;
 i18 = i24 + 2324 | 0;
 i20 = HEAP32[i18 >> 2] | 0;
 __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjPKjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSI_5Vec3VE(i24, i4, i5, i22, i6, HEAP32[i24 + 4420 >> 2] | 0, i3, HEAP32[i24 + 4424 >> 2] | 0, HEAP32[i24 + 2320 >> 2] | 0, i18, i24 + 2176 | 0, i23) | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = i18 - i20 | 0;
 if ((i18 | 0) != (i20 | 0)) {
  i8 = i6 & 255;
  i4 = (i8 & 16 | 0) == 0;
  i18 = (i8 & 32 | 0) == 0;
  L6 : do if (!(i8 & 8)) {
   i6 = HEAP32[i22 >> 2] | 0;
   i7 = HEAP32[i22 + 4 >> 2] | 0;
   i8 = i6 >>> 0 < i7 >>> 0;
   i5 = i8 ? i6 : i7;
   i6 = i8 ? i7 : i6;
   i7 = i24 + 3616 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   if ((i8 | 0) != 128) {
    i2 = i5 << 16 | i6;
    i2 = i2 + ~(i2 << 15) | 0;
    i2 = (i2 >>> 10 ^ i2) * 9 | 0;
    i2 = i2 >>> 6 ^ i2;
    i2 = i2 + ~(i2 << 11) | 0;
    i2 = ((i2 >>> 16 ^ i2) & 127) + (i24 + 3488) | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    if (i1 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i8; else {
     i3 = i1 & 255;
     while (1) {
      if ((HEAP32[i24 + 2336 + (i3 << 3) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i24 + 2336 + (i3 << 3) + 4 >> 2] | 0) == (i6 | 0)) break L6;
      i2 = HEAP8[i24 + 3360 + i3 >> 0] | 0;
      if (i2 << 24 >> 24 == -1) break; else {
       i3 = i2 & 255;
       i1 = i2;
      }
     }
     HEAP8[(i1 & 255) + (i24 + 3360) >> 0] = i8;
    }
    HEAP8[(HEAP32[i7 >> 2] | 0) + (i24 + 3360) >> 0] = -1;
    i8 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = i8 + 1;
    i8 = i24 + 2336 + (i8 << 3) | 0;
    HEAP32[i8 >> 2] = i5;
    HEAP32[i8 + 4 >> 2] = i6;
   }
  } while (0);
  L20 : do if (i4) {
   i5 = HEAP32[i22 + 4 >> 2] | 0;
   i6 = HEAP32[i22 + 8 >> 2] | 0;
   i7 = i5 >>> 0 < i6 >>> 0;
   i4 = i7 ? i5 : i6;
   i5 = i7 ? i6 : i5;
   i6 = i24 + 3616 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != 128) {
    i2 = i4 << 16 | i5;
    i2 = i2 + ~(i2 << 15) | 0;
    i2 = (i2 >>> 10 ^ i2) * 9 | 0;
    i2 = i2 >>> 6 ^ i2;
    i2 = i2 + ~(i2 << 11) | 0;
    i2 = ((i2 >>> 16 ^ i2) & 127) + (i24 + 3488) | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    if (i1 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i7; else {
     i3 = i1 & 255;
     while (1) {
      if ((HEAP32[i24 + 2336 + (i3 << 3) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i24 + 2336 + (i3 << 3) + 4 >> 2] | 0) == (i5 | 0)) break L20;
      i2 = HEAP8[i24 + 3360 + i3 >> 0] | 0;
      if (i2 << 24 >> 24 == -1) break; else {
       i3 = i2 & 255;
       i1 = i2;
      }
     }
     HEAP8[(i1 & 255) + (i24 + 3360) >> 0] = i7;
    }
    HEAP8[(HEAP32[i6 >> 2] | 0) + (i24 + 3360) >> 0] = -1;
    i8 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i8 + 1;
    i8 = i24 + 2336 + (i8 << 3) | 0;
    HEAP32[i8 >> 2] = i4;
    HEAP32[i8 + 4 >> 2] = i5;
   }
  } while (0);
  L34 : do if (i18) {
   i5 = HEAP32[i22 + 8 >> 2] | 0;
   i6 = HEAP32[i22 >> 2] | 0;
   i7 = i5 >>> 0 < i6 >>> 0;
   i4 = i7 ? i5 : i6;
   i5 = i7 ? i6 : i5;
   i6 = i24 + 3616 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != 128) {
    i2 = i4 << 16 | i5;
    i2 = i2 + ~(i2 << 15) | 0;
    i2 = (i2 >>> 10 ^ i2) * 9 | 0;
    i2 = i2 >>> 6 ^ i2;
    i2 = i2 + ~(i2 << 11) | 0;
    i2 = ((i2 >>> 16 ^ i2) & 127) + (i24 + 3488) | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    if (i1 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i7; else {
     i3 = i1 & 255;
     while (1) {
      if ((HEAP32[i24 + 2336 + (i3 << 3) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i24 + 2336 + (i3 << 3) + 4 >> 2] | 0) == (i5 | 0)) break L34;
      i2 = HEAP8[i24 + 3360 + i3 >> 0] | 0;
      if (i2 << 24 >> 24 == -1) break; else {
       i3 = i2 & 255;
       i1 = i2;
      }
     }
     HEAP8[(i1 & 255) + (i24 + 3360) >> 0] = i7;
    }
    HEAP8[(HEAP32[i6 >> 2] | 0) + (i24 + 3360) >> 0] = -1;
    i18 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i18 + 1;
    i18 = i24 + 2336 + (i18 << 3) | 0;
    HEAP32[i18 >> 2] = i4;
    HEAP32[i18 + 4 >> 2] = i5;
   }
  } while (0);
  i5 = HEAP32[i22 >> 2] | 0;
  i6 = i24 + 4388 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  L48 : do if ((i4 | 0) != 128) {
   i2 = (i5 & 127) + (i24 + 4260) | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   L50 : do if (i1 << 24 >> 24 == -1) {
    HEAP8[i2 >> 0] = i4;
    i21 = 40;
   } else {
    i3 = i1 & 255;
    while (1) {
     if ((HEAP32[i24 + 3620 + (i3 << 2) >> 2] | 0) == (i5 | 0)) break L50;
     i2 = HEAP8[i24 + 4132 + i3 >> 0] | 0;
     if (i2 << 24 >> 24 == -1) break; else {
      i3 = i2 & 255;
      i1 = i2;
     }
    }
    HEAP8[(i1 & 255) + (i24 + 4132) >> 0] = i4;
    i21 = 40;
   } while (0);
   if ((i21 | 0) == 40) {
    HEAP8[(HEAP32[i6 >> 2] | 0) + (i24 + 4132) >> 0] = -1;
    i4 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i4 + 1;
    HEAP32[i24 + 3620 + (i4 << 2) >> 2] = i5;
    i4 = HEAP32[i6 >> 2] | 0;
   }
   i5 = HEAP32[i22 + 4 >> 2] | 0;
   if ((i4 | 0) != 128) {
    i2 = (i5 & 127) + (i24 + 4260) | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    L61 : do if (i1 << 24 >> 24 == -1) {
     HEAP8[i2 >> 0] = i4;
     i21 = 48;
    } else {
     i3 = i1 & 255;
     while (1) {
      if ((HEAP32[i24 + 3620 + (i3 << 2) >> 2] | 0) == (i5 | 0)) {
       i5 = i4;
       break L61;
      }
      i2 = HEAP8[i24 + 4132 + i3 >> 0] | 0;
      if (i2 << 24 >> 24 == -1) break; else {
       i3 = i2 & 255;
       i1 = i2;
      }
     }
     HEAP8[(i1 & 255) + (i24 + 4132) >> 0] = i4;
     i21 = 48;
    } while (0);
    if ((i21 | 0) == 48) {
     HEAP8[(HEAP32[i6 >> 2] | 0) + (i24 + 4132) >> 0] = -1;
     i21 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i21 + 1;
     HEAP32[i24 + 3620 + (i21 << 2) >> 2] = i5;
     i5 = HEAP32[i6 >> 2] | 0;
    }
    i4 = HEAP32[i22 + 8 >> 2] | 0;
    if ((i5 | 0) != 128) {
     i2 = (i4 & 127) + (i24 + 4260) | 0;
     i1 = HEAP8[i2 >> 0] | 0;
     if (i1 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i5; else {
      i3 = i1 & 255;
      while (1) {
       if ((HEAP32[i24 + 3620 + (i3 << 2) >> 2] | 0) == (i4 | 0)) break L48;
       i2 = HEAP8[i24 + 4132 + i3 >> 0] | 0;
       if (i2 << 24 >> 24 == -1) break; else {
        i3 = i2 & 255;
        i1 = i2;
       }
      }
      HEAP8[(i1 & 255) + (i24 + 4132) >> 0] = i5;
     }
     HEAP8[(HEAP32[i6 >> 2] | 0) + (i24 + 4132) >> 0] = -1;
     i22 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i22 + 1;
     HEAP32[i24 + 3620 + (i22 << 2) >> 2] = i4;
    }
   }
  } while (0);
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration18addContactsToPatchERKNS_6shdfnd3aos5Vec3VEjj(i24, i23, i20, i19);
 }
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function _gzread(i38, i2, i39) {
 i38 = i38 | 0;
 i2 = i2 | 0;
 i39 = i39 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 if (!i38) {
  i39 = -2;
  return i39 | 0;
 }
 if ((HEAP8[i38 + 92 >> 0] | 0) != 114) {
  i39 = -2;
  return i39 | 0;
 }
 i35 = i38 + 56 | 0;
 switch (HEAP32[i35 >> 2] | 0) {
 case 1:
  {
   i39 = 0;
   return i39 | 0;
  }
 case -1:
 case -3:
  {
   i39 = -1;
   return i39 | 0;
  }
 default:
  {
   i36 = i38 + 12 | 0;
   HEAP32[i36 >> 2] = i2;
   i37 = i38 + 16 | 0;
   HEAP32[i37 >> 2] = i39;
   if (!i39) i1 = 0; else {
    i3 = i38 + 108 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i39; else {
     HEAP8[i2 >> 0] = i1;
     HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + 1;
     i1 = (HEAP32[i37 >> 2] | 0) + -1 | 0;
     HEAP32[i37 >> 2] = i1;
     HEAP32[i3 >> 2] = -1;
     i34 = i38 + 104 | 0;
     HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
     if (!(HEAP32[i38 + 112 >> 2] | 0)) i2 = i2 + 1 | 0; else {
      HEAP32[i35 >> 2] = 1;
      i39 = 1;
      return i39 | 0;
     }
    }
   }
   i9 = i38 + 88 | 0;
   i34 = i38 + 4 | 0;
   i10 = i38 + 60 | 0;
   i11 = i38 + 68 | 0;
   i12 = i38 + 64 | 0;
   i13 = i38 + 100 | 0;
   i14 = i38 + 104 | 0;
   i15 = i38 + 76 | 0;
   i16 = i38 + 60 | 0;
   i17 = i38 + 68 | 0;
   i18 = i38 + 64 | 0;
   i19 = i38 + 68 | 0;
   i20 = i38 + 64 | 0;
   i21 = i38 + 68 | 0;
   i22 = i38 + 64 | 0;
   i23 = i38 + 68 | 0;
   i24 = i38 + 64 | 0;
   i25 = i38 + 68 | 0;
   i26 = i38 + 64 | 0;
   i27 = i38 + 68 | 0;
   i28 = i38 + 64 | 0;
   i29 = i38 + 68 | 0;
   i30 = i38 + 64 | 0;
   i31 = i38 + 68 | 0;
   i32 = i38 + 64 | 0;
   i33 = i38 + 60 | 0;
   L15 : do if (i1) {
    i3 = i2;
    while (1) {
     i4 = HEAP32[i34 >> 2] | 0;
     if (HEAP32[i9 >> 2] | 0) {
      i8 = 12;
      break;
     }
     if (!i4) if (!(HEAP32[i10 >> 2] | 0)) {
      HEAP32[(___errno_location() | 0) >> 2] = 0;
      i1 = _fread(HEAP32[i11 >> 2] | 0, 1, 16384, HEAP32[i12 >> 2] | 0) | 0;
      HEAP32[i34 >> 2] = i1;
      if (!i1) {
       HEAP32[i10 >> 2] = 1;
       if (_ferror(HEAP32[i12 >> 2] | 0) | 0) {
        i8 = 22;
        break;
       }
      }
      HEAP32[i38 >> 2] = HEAP32[i11 >> 2];
      i4 = i1;
      i1 = HEAP32[i37 >> 2] | 0;
     } else i4 = 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i4;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i1;
     i1 = _unity_z_inflate(i38, 0) | 0;
     HEAP32[i35 >> 2] = i1;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) - (HEAP32[i34 >> 2] | 0);
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) - (HEAP32[i37 >> 2] | 0);
     if ((i1 | 0) == 1) {
      HEAP32[i15 >> 2] = _unity_z_crc32(HEAP32[i15 >> 2] | 0, i3, (HEAP32[i36 >> 2] | 0) - i3 | 0) | 0;
      i3 = HEAP32[i36 >> 2] | 0;
      L29 : do if (!(HEAP32[i16 >> 2] | 0)) {
       i1 = HEAP32[i34 >> 2] | 0;
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i17 >> 2] | 0, 1, 16384, HEAP32[i18 >> 2] | 0) | 0;
        HEAP32[i34 >> 2] = i1;
        if (i1 | 0) {
         i5 = HEAP32[i17 >> 2] | 0;
         HEAP32[i38 >> 2] = i5;
         i7 = HEAP32[i16 >> 2] | 0;
         i6 = i38;
         i8 = 32;
         break;
        }
        HEAP32[i16 >> 2] = 1;
        if (!(_ferror(HEAP32[i18 >> 2] | 0) | 0)) {
         i1 = -257;
         i8 = 47;
         break L29;
        }
        HEAP32[i35 >> 2] = -1;
        i1 = -1;
        i8 = 39;
       } else {
        i7 = 0;
        i6 = i38;
        i5 = HEAP32[i38 >> 2] | 0;
        i8 = 32;
       } while (0);
       L38 : do if ((i8 | 0) == 32) {
        i8 = 0;
        i4 = i1 + -1 | 0;
        HEAP32[i34 >> 2] = i4;
        HEAP32[i6 >> 2] = i5 + 1;
        i1 = HEAPU8[i5 >> 0] | 0;
        if (!i7) {
         do if (!i4) {
          HEAP32[(___errno_location() | 0) >> 2] = 0;
          i4 = _fread(HEAP32[i19 >> 2] | 0, 1, 16384, HEAP32[i20 >> 2] | 0) | 0;
          HEAP32[i34 >> 2] = i4;
          if (i4 | 0) {
           i5 = HEAP32[i19 >> 2] | 0;
           HEAP32[i38 >> 2] = i5;
           i7 = HEAP32[i16 >> 2] | 0;
           i6 = i38;
           break;
          }
          HEAP32[i16 >> 2] = 1;
          if (!(_ferror(HEAP32[i20 >> 2] | 0) | 0)) {
           i8 = 39;
           break L38;
          }
          HEAP32[i35 >> 2] = -1;
          i1 = i1 | -256;
          i8 = 47;
          break L29;
         } else {
          i7 = 0;
          i6 = i38;
          i5 = HEAP32[i38 >> 2] | 0;
         } while (0);
         i4 = i4 + -1 | 0;
         HEAP32[i34 >> 2] = i4;
         HEAP32[i6 >> 2] = i5 + 1;
         i1 = HEAPU8[i5 >> 0] << 8 | i1;
         if (i7 | 0) {
          i8 = 47;
          break L29;
         }
         do if (!i4) {
          HEAP32[(___errno_location() | 0) >> 2] = 0;
          i4 = _fread(HEAP32[i21 >> 2] | 0, 1, 16384, HEAP32[i22 >> 2] | 0) | 0;
          HEAP32[i34 >> 2] = i4;
          if (i4 | 0) {
           i5 = HEAP32[i21 >> 2] | 0;
           HEAP32[i38 >> 2] = i5;
           i7 = HEAP32[i16 >> 2] | 0;
           i6 = i38;
           break;
          }
          HEAP32[i16 >> 2] = 1;
          if (!(_ferror(HEAP32[i22 >> 2] | 0) | 0)) {
           i8 = 47;
           break L29;
          }
          HEAP32[i35 >> 2] = -1;
          break L38;
         } else {
          i7 = 0;
          i6 = i38;
          i5 = HEAP32[i38 >> 2] | 0;
         } while (0);
         i4 = i4 + -1 | 0;
         HEAP32[i34 >> 2] = i4;
         HEAP32[i6 >> 2] = i5 + 1;
         i1 = HEAPU8[i5 >> 0] << 16 | i1;
         if (i7 | 0) {
          i8 = 57;
          break L29;
         }
         do if (!i4) {
          HEAP32[(___errno_location() | 0) >> 2] = 0;
          i4 = _fread(HEAP32[i23 >> 2] | 0, 1, 16384, HEAP32[i24 >> 2] | 0) | 0;
          HEAP32[i34 >> 2] = i4;
          if (i4 | 0) {
           i5 = HEAP32[i23 >> 2] | 0;
           HEAP32[i38 >> 2] = i5;
           i6 = i38;
           break;
          }
          HEAP32[i16 >> 2] = 1;
          if (!(_ferror(HEAP32[i24 >> 2] | 0) | 0)) {
           i8 = 57;
           break L29;
          }
          HEAP32[i35 >> 2] = -1;
          i8 = 57;
          break L29;
         } else {
          i6 = i38;
          i5 = HEAP32[i38 >> 2] | 0;
         } while (0);
         HEAP32[i34 >> 2] = i4 + -1;
         HEAP32[i6 >> 2] = i5 + 1;
         i4 = HEAPU8[i5 >> 0] | 0;
         break L29;
        } else i8 = 39;
       } while (0);
       if ((i8 | 0) == 39) i1 = i1 + -256 | 0;
       i1 = i1 + -65536 | 0;
       i8 = 57;
      } else {
       i1 = -257;
       i8 = 47;
      } while (0);
      if ((i8 | 0) == 47) {
       i1 = i1 + -65536 | 0;
       i8 = 57;
      }
      if ((i8 | 0) == 57) {
       i8 = 0;
       HEAP32[i35 >> 2] = -3;
       i4 = -1;
      }
      if ((i1 + (i4 << 24) | 0) != (HEAP32[i15 >> 2] | 0)) {
       i8 = 59;
       break;
      }
      L76 : do if (!(HEAP32[i16 >> 2] | 0)) {
       i1 = HEAP32[i34 >> 2] | 0;
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i25 >> 2] | 0, 1, 16384, HEAP32[i26 >> 2] | 0) | 0;
        HEAP32[i34 >> 2] = i1;
        if (i1 | 0) {
         i6 = HEAP32[i25 >> 2] | 0;
         i7 = HEAP32[i16 >> 2] | 0;
         i1 = i1 + -1 | 0;
         HEAP32[i34 >> 2] = i1;
         HEAP32[i38 >> 2] = i6 + 1;
         if (!i7) break; else {
          i8 = 86;
          break L76;
         }
        }
        HEAP32[i16 >> 2] = 1;
        if (!(_ferror(HEAP32[i26 >> 2] | 0) | 0)) {
         i8 = 86;
         break L76;
        }
        HEAP32[i35 >> 2] = -1;
        i8 = 86;
        break L76;
       } else {
        i7 = HEAP32[i38 >> 2] | 0;
        i1 = i1 + -1 | 0;
        HEAP32[i34 >> 2] = i1;
        HEAP32[i38 >> 2] = i7 + 1;
       } while (0);
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i27 >> 2] | 0, 1, 16384, HEAP32[i28 >> 2] | 0) | 0;
        HEAP32[i34 >> 2] = i1;
        if (i1 | 0) {
         i6 = HEAP32[i27 >> 2] | 0;
         i7 = HEAP32[i16 >> 2] | 0;
         i1 = i1 + -1 | 0;
         HEAP32[i34 >> 2] = i1;
         HEAP32[i38 >> 2] = i6 + 1;
         if (!i7) break; else {
          i8 = 86;
          break L76;
         }
        }
        HEAP32[i16 >> 2] = 1;
        if (!(_ferror(HEAP32[i28 >> 2] | 0) | 0)) {
         i8 = 86;
         break L76;
        }
        HEAP32[i35 >> 2] = -1;
        i8 = 86;
        break L76;
       } else {
        i7 = HEAP32[i38 >> 2] | 0;
        i1 = i1 + -1 | 0;
        HEAP32[i34 >> 2] = i1;
        HEAP32[i38 >> 2] = i7 + 1;
       } while (0);
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i29 >> 2] | 0, 1, 16384, HEAP32[i30 >> 2] | 0) | 0;
        HEAP32[i34 >> 2] = i1;
        if (i1 | 0) {
         i6 = HEAP32[i29 >> 2] | 0;
         i7 = HEAP32[i16 >> 2] | 0;
         i1 = i1 + -1 | 0;
         HEAP32[i34 >> 2] = i1;
         HEAP32[i38 >> 2] = i6 + 1;
         if (!i7) break; else {
          i8 = 86;
          break L76;
         }
        }
        HEAP32[i16 >> 2] = 1;
        if (!(_ferror(HEAP32[i30 >> 2] | 0) | 0)) {
         i8 = 86;
         break L76;
        }
        HEAP32[i35 >> 2] = -1;
        i8 = 86;
        break L76;
       } else {
        i7 = HEAP32[i38 >> 2] | 0;
        i1 = i1 + -1 | 0;
        HEAP32[i34 >> 2] = i1;
        HEAP32[i38 >> 2] = i7 + 1;
       } while (0);
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i31 >> 2] | 0, 1, 16384, HEAP32[i32 >> 2] | 0) | 0;
        HEAP32[i34 >> 2] = i1;
        if (i1 | 0) {
         i4 = HEAP32[i31 >> 2] | 0;
         HEAP32[i38 >> 2] = i4;
         i5 = i38;
         break;
        }
        HEAP32[i16 >> 2] = 1;
        if (!(_ferror(HEAP32[i32 >> 2] | 0) | 0)) {
         i8 = 86;
         break L76;
        }
        HEAP32[i35 >> 2] = -1;
        i8 = 86;
        break L76;
       } else {
        i5 = i38;
        i4 = HEAP32[i38 >> 2] | 0;
       } while (0);
       HEAP32[i34 >> 2] = i1 + -1;
       HEAP32[i5 >> 2] = i4 + 1;
      } else i8 = 86; while (0);
      if ((i8 | 0) == 86) HEAP32[i35 >> 2] = -3;
      _check_header(i38);
      if (HEAP32[i35 >> 2] | 0) {
       i2 = i3;
       break L15;
      }
      _unity_z_inflateReset(i38) | 0;
      HEAP32[i15 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
      i1 = HEAP32[i35 >> 2] | 0;
     }
     if (i1 | 0) {
      i2 = i3;
      break L15;
     }
     if (HEAP32[i33 >> 2] | 0) {
      i2 = i3;
      break L15;
     }
     i1 = HEAP32[i37 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      break L15;
     }
    }
    if ((i8 | 0) == 12) {
     i3 = i4 >>> 0 > i1 >>> 0 ? i1 : i4;
     if (i3) {
      _memcpy(HEAP32[i36 >> 2] | 0, HEAP32[i38 >> 2] | 0, i3 | 0) | 0;
      i2 = i2 + i3 | 0;
      HEAP32[i36 >> 2] = i2;
      HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i3;
      i1 = (HEAP32[i37 >> 2] | 0) - i3 | 0;
      HEAP32[i37 >> 2] = i1;
      HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) - i3;
     }
     if (!i1) i1 = 0; else {
      i1 = _fread(i2, 1, i1, HEAP32[i38 + 64 >> 2] | 0) | 0;
      i1 = (HEAP32[i37 >> 2] | 0) - i1 | 0;
      HEAP32[i37 >> 2] = i1;
     }
     i1 = i39 - i1 | 0;
     i39 = i38 + 100 | 0;
     HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) + i1;
     i39 = i38 + 104 | 0;
     HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) + i1;
     if (i1 | 0) {
      i39 = i1;
      return i39 | 0;
     }
     HEAP32[i38 + 60 >> 2] = 1;
     i39 = 0;
     return i39 | 0;
    } else if ((i8 | 0) == 22) {
     HEAP32[i35 >> 2] = -1;
     i2 = i3;
     break;
    } else if ((i8 | 0) == 59) {
     HEAP32[i35 >> 2] = -3;
     i2 = i3;
     break;
    }
   } while (0);
   i1 = i38 + 76 | 0;
   HEAP32[i1 >> 2] = _unity_z_crc32(HEAP32[i1 >> 2] | 0, i2, (HEAP32[i36 >> 2] | 0) - i2 | 0) | 0;
   i1 = HEAP32[i37 >> 2] | 0;
   L132 : do if ((i1 | 0) == (i39 | 0)) {
    switch (HEAP32[i35 >> 2] | 0) {
    case -1:
    case -3:
     {
      i1 = -1;
      break;
     }
    default:
     break L132;
    }
    return i1 | 0;
   } while (0);
   i39 = i39 - i1 | 0;
   return i39 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i18, i19, i1, i17) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i20 + 80 | 0;
 i8 = i20 + 64 | 0;
 i9 = i20 + 32 | 0;
 i11 = i20 + 8 | 0;
 i3 = i20 + 4 | 0;
 i7 = i20;
 i16 = i20 + 56 | 0;
 i5 = i20 + 48 | 0;
 i4 = i20 + 24 | 0;
 i14 = i19 + 28 | 0;
 i15 = HEAPU8[i14 >> 0] | 0;
 switch (i15 | 0) {
 case 0:
 case 3:
 case 2:
  {
   HEAP16[i16 >> 1] = 0;
   i12 = i16 + 2 | 0;
   HEAP16[i12 >> 1] = 0;
   i13 = i16 + 4 | 0;
   HEAP32[i13 >> 2] = 0;
   if (!i1) {
    i4 = i19 + 6 | 0;
    if (!(HEAP16[i4 >> 1] & 4)) {
     i1 = i19 + 32 | 0;
     i2 = i19 + 36 | 0;
     i3 = 0;
    } else {
     i6 = __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv(i18, i19) | 0;
     i1 = i19 + 32 | 0;
     i24 = HEAP32[i1 >> 2] | 0;
     i2 = i19 + 36 | 0;
     i23 = HEAP32[i2 >> 2] | 0;
     i22 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i11 + 4 >> 2] = 0;
     HEAP32[i11 + 8 >> 2] = 0;
     HEAP32[i11 + 12 >> 2] = 0;
     mftCall_viii(HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0, i24 | 0, i3 | 0, i9 | 0);
     mftCall_viii(HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0, i23 | 0, i7 | 0, i11 | 0);
     i23 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
     i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 4 >> 2] | 0;
     i21 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     mftCall_viiiiiii(i24 | 0, i23 | 0, i22 | 0, i21 | 0, i8 | 0, i3 | 0, i10 | 0, 0);
     i3 = i6;
    }
    __ZN5physx2Sc10NPhaseCore21filterRbCollisionPairERKNS0_8ShapeSimES4_PNS0_10FilterPairE(i5, i18, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3);
    i24 = HEAP32[i5 >> 2] | 0;
    i23 = i24 & 65535;
    HEAP16[i16 >> 1] = i23;
    i24 = i24 >>> 16 & 65535;
    HEAP16[i12 >> 1] = i24;
    i2 = HEAP32[i5 + 4 >> 2] | 0;
    HEAP32[i13 >> 2] = i2;
    i3 = i4;
    i4 = i23;
    i5 = i24;
   } else {
    i6 = HEAP16[i1 >> 1] | 0;
    HEAP16[i16 >> 1] = i6;
    i5 = HEAP16[i1 + 2 >> 1] | 0;
    HEAP16[i12 >> 1] = i5;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i13 >> 2] = i1;
    i2 = i1;
    if ((i6 & 13) == 13) {
     i24 = i19 + 32 | 0;
     i25 = HEAP32[i24 >> 2] | 0;
     i4 = i19 + 36 | 0;
     i21 = HEAP32[i4 >> 2] | 0;
     i22 = HEAP32[i1 >> 2] | 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i11 + 4 >> 2] = 0;
     HEAP32[i11 + 8 >> 2] = 0;
     HEAP32[i11 + 12 >> 2] = 0;
     mftCall_viii(HEAP32[(HEAP32[i25 >> 2] | 0) + 8 >> 2] | 0, i25 | 0, i3 | 0, i9 | 0);
     mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, i7 | 0, i11 | 0);
     i21 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
     i25 = HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0;
     i23 = HEAP32[i3 >> 2] | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     mftCall_viiiiiii(i25 | 0, i21 | 0, i22 | 0, i23 | 0, i8 | 0, i1 | 0, i10 | 0, 0);
     __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i18, i2);
     HEAP32[i13 >> 2] = 0;
     i1 = i24;
     i2 = 0;
    } else {
     i1 = i19 + 32 | 0;
     i4 = i19 + 36 | 0;
    }
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!(i6 & 3)) if (!(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i3) | 0)) i1 = i5; else if (!(HEAP8[(HEAP32[(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i3) | 0) + 52 >> 2] | 0) + 44 >> 0] & 1)) i1 = i5; else if (!(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i1) | 0)) i1 = i5; else if (!(HEAP8[(HEAP32[(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i1) | 0) + 52 >> 2] | 0) + 44 >> 0] & 1)) i1 = i5; else {
     i1 = i5 & 65535;
     if (!(i1 & 1)) i1 = i5; else i1 = i1 & 65534;
    } else i1 = i5;
    HEAP16[i12 >> 1] = i1;
    i3 = i19 + 6 | 0;
    i4 = i6;
    i5 = i1;
   }
   i1 = HEAPU16[i3 >> 1] | 0;
   if (!((i1 & 4 | 0) == 0 | (i4 & 12) == 12)) {
    HEAP16[i3 >> 1] = i1 & 65531;
    if (i2 | 0) {
     __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i18, i2);
     HEAP32[i13 >> 2] = 0;
    }
   }
   i2 = HEAP32[i19 + 32 >> 2] | 0;
   i3 = HEAP32[i19 + 36 >> 2] | 0;
   i1 = i4 & 65535;
   if (!(i1 & 1)) if (!(i1 & 2)) if (!(HEAP8[(HEAP32[i2 + 28 >> 2] | 0) + 64 >> 0] & 4)) i1 = (HEAP8[(HEAP32[i3 + 28 >> 2] | 0) + 64 >> 0] & 4) >>> 1; else i1 = 2; else i1 = 3; else i1 = 6;
   if ((HEAPU8[i14 >> 0] | 0) != (i1 | 0)) {
    i25 = __ZN5physx2Sc10NPhaseCore7convertEPNS0_21ElementSimInteractionENS0_15InteractionTypeERNS0_10FilterInfoEb(i18, i19, i1, i16, i17) | 0;
    STACKTOP = i20;
    return i25 | 0;
   }
   switch (i15 | 0) {
   case 0:
    {
     i9 = i5 & 65535;
     i10 = i19 + 44 | 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i9 ^ i1) & 32767) {
      do if ((i1 & 6291456 | 0) != 0 & (i9 & 8 | 0) == 0) {
       if (!(i1 & 2097152)) {
        i2 = i1 & -4194305;
        HEAP32[i10 >> 2] = i2;
        break;
       }
       i8 = i19 + 52 | 0;
       i4 = HEAP32[i8 >> 2] | 0;
       i3 = i18 + 28 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if (i4 >>> 0 < i2 >>> 0) {
        i6 = i2 + -1 | 0;
        i5 = i18 + 20 | 0;
        i7 = HEAP32[i5 >> 2] | 0;
        if (!((i4 | 0) == (i6 | 0) | i2 >>> 0 >= i7 >>> 0)) {
         i24 = HEAP32[i18 + 16 >> 2] | 0;
         i25 = HEAP32[i24 + (i6 << 2) >> 2] | 0;
         HEAP32[i24 + (i4 << 2) >> 2] = i25;
         HEAP32[i25 + 52 >> 2] = i4;
         i4 = i6;
        }
        HEAP32[i3 >> 2] = i6;
        i2 = i7;
       } else {
        i2 = i18 + 20 | 0;
        i5 = i2;
        i2 = HEAP32[i2 >> 2] | 0;
       }
       i3 = i1 & -2097153;
       HEAP32[i10 >> 2] = i3;
       HEAP32[i8 >> 2] = -1;
       i25 = i2 + -1 | 0;
       HEAP32[i5 >> 2] = i25;
       i2 = i18 + 16 | 0;
       i24 = HEAP32[i2 >> 2] | 0;
       HEAP32[i24 + (i4 << 2) >> 2] = HEAP32[i24 + (i25 << 2) >> 2];
       if (i4 >>> 0 < i25 >>> 0) {
        HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 52 >> 2] = i4;
        i2 = i3;
       } else i2 = i3;
      } else i2 = i1; while (0);
      if ((i1 & 448 | 0) != 0 & (i9 & 448 | 0) == 0) {
       i1 = i2 & -1572865;
       HEAP32[i10 >> 2] = i1;
       if (i2 & 8388608) {
        i25 = i19 + 52 | 0;
        i3 = HEAP32[i25 >> 2] | 0;
        i1 = i2 & -9961473;
        HEAP32[i10 >> 2] = i1;
        HEAP32[i25 >> 2] = -1;
        i2 = i18 + 36 | 0;
        i25 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
        HEAP32[i2 >> 2] = i25;
        i2 = i18 + 32 | 0;
        i24 = HEAP32[i2 >> 2] | 0;
        HEAP32[i24 + (i3 << 2) >> 2] = HEAP32[i24 + (i25 << 2) >> 2];
        if (i3 >>> 0 < i25 >>> 0) HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 52 >> 2] = i3;
       }
      } else i1 = i2;
     }
     HEAP32[i10 >> 2] = i9 & 32767 | i1 & -32768;
     i25 = i19;
     STACKTOP = i20;
     return i25 | 0;
    }
   case 2:
    {
     i25 = i19 + 56 | 0;
     HEAP16[i25 >> 1] = HEAPU16[i25 >> 1] & 65504 | i5 & 20;
     i25 = i19;
     STACKTOP = i20;
     return i25 | 0;
    }
   default:
    {
     i25 = i19;
     STACKTOP = i20;
     return i25 | 0;
    }
   }
  }
 case 4:
  {
   i5 = HEAP32[i19 + 40 >> 2] | 0;
   do if (!i1) {
    i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + 76 >> 2] | 0;
    i2 = i5 + 12 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) {
     HEAP32[i2 >> 2] = i1;
     if (!(HEAP16[i19 + 6 >> 1] & 4)) {
      i1 = i19 + 32 | 0;
      i2 = i19 + 36 | 0;
      i3 = 0;
     } else {
      i25 = __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv(i18, i5) | 0;
      i1 = i19 + 32 | 0;
      i21 = HEAP32[i1 >> 2] | 0;
      i2 = i19 + 36 | 0;
      i22 = HEAP32[i2 >> 2] | 0;
      i23 = HEAP32[i25 >> 2] | 0;
      HEAP32[i9 >> 2] = 0;
      HEAP32[i9 + 4 >> 2] = 0;
      HEAP32[i9 + 8 >> 2] = 0;
      HEAP32[i9 + 12 >> 2] = 0;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i11 + 4 >> 2] = 0;
      HEAP32[i11 + 8 >> 2] = 0;
      HEAP32[i11 + 12 >> 2] = 0;
      mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, i3 | 0, i9 | 0);
      mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i7 | 0, i11 | 0);
      i22 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
      i21 = HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0;
      i24 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i7 >> 2] | 0;
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      mftCall_viiiiiii(i21 | 0, i22 | 0, i23 | 0, i24 | 0, i8 | 0, i3 | 0, i10 | 0, 0);
      i3 = i25;
     }
     __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE(i4, i18, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3);
     i2 = HEAP32[i4 >> 2] | 0;
     HEAP8[i5 + 18 >> 0] = (HEAP32[i4 + 4 >> 2] | 0) != 0 & 1;
     HEAP16[i5 + 8 >> 1] = i2 >>> 16;
     if (i2 & 1 | 0) {
      HEAP8[i5 + 20 >> 0] = 1;
      break;
     }
     i1 = i5 + 19 | 0;
     if (!(i2 & 2)) {
      HEAP8[i1 >> 0] = 0;
      break;
     } else {
      HEAP8[i1 >> 0] = 1;
      break;
     }
    }
   } else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) if (HEAP8[i5 + 20 >> 0] | 0) if (mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 16 >> 2] | 0, i19 | 0) | 0) {
     i21 = HEAP32[i19 + 32 >> 2] | 0;
     i22 = HEAP32[i19 + 36 >> 2] | 0;
     i23 = HEAP32[i1 >> 2] | 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i11 + 4 >> 2] = 0;
     HEAP32[i11 + 8 >> 2] = 0;
     HEAP32[i11 + 12 >> 2] = 0;
     mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, i3 | 0, i9 | 0);
     mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i7 | 0, i11 | 0);
     i22 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
     i21 = HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0;
     i24 = HEAP32[i3 >> 2] | 0;
     i25 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     mftCall_viiiiiii(i21 | 0, i22 | 0, i23 | 0, i24 | 0, i8 | 0, i25 | 0, i10 | 0, 0);
     __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i18, i2);
    }
   } while (0);
   i1 = i19 + 6 | 0;
   i2 = HEAPU16[i1 >> 1] | 0;
   if (!(HEAP8[i5 + 18 >> 0] | 0)) {
    if (i2 & 4 | 0) HEAP16[i1 >> 1] = i2 & 65531;
   } else HEAP16[i1 >> 1] = i2 | 4;
   if (!(HEAP8[i5 + 20 >> 0] | 0)) {
    i25 = i19;
    STACKTOP = i20;
    return i25 | 0;
   }
   __ZN5physx2Sc10NPhaseCore39pool_deleteParticleElementRbElementPairEPNS0_35ParticleElementRbElementInteractionEjj(i18, i19, 0, 0);
   i25 = 0;
   STACKTOP = i20;
   return i25 | 0;
  }
 default:
  {
   i25 = 0;
   STACKTOP = i20;
   return i25 | 0;
  }
 }
 return 0;
}

function __ZN5Unity5Joint9SetupAxesEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 172 | 0;
 i14 = i20 + 144 | 0;
 i8 = i20 + 112 | 0;
 i15 = i20 + 84 | 0;
 i16 = i20 + 72 | 0;
 i17 = i20 + 40 | 0;
 i18 = i20 + 12 | 0;
 i19 = i20 + 128 | 0;
 i9 = i20;
 i10 = i20 + 96 | 0;
 i11 = i20 + 56 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] | 0, i6 | 0, i8 | 0, i15 | 0, i16 | 0);
 __ZN5Unity5Joint30CalculateGlobalConnectedAnchorEb(i17, i6, (HEAP8[i6 + 36 >> 0] | 0) != 0);
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i4 = i6 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i4 = 0; else {
  HEAP32[i14 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i14);
    i2 = HEAP32[i12 >> 2] | 0;
    i21 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 9;
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
   i4 = 0;
   break;
  }
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i14);
    i2 = HEAP32[i12 >> 2] | 0;
    i21 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 17;
   }
  }
  if ((i5 | 0) == 15) i5 = 17;
  if ((i5 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 } while (0);
 i2 = i6 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i14 | 0, i3 | 0, 0);
 i3 = (i7 & 2 | 0) != 0;
 if (i3) {
  __ZNK9Transform11GetPositionEv(i12, i13);
  f24 = Math_fround(HEAPF32[i8 >> 2]);
  f24 = Math_fround(f24 - Math_fround(HEAPF32[i12 >> 2]));
  f23 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f23 = Math_fround(f23 - Math_fround(HEAPF32[i12 + 4 >> 2]));
  f22 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f22 = Math_fround(f22 - Math_fround(HEAPF32[i12 + 8 >> 2]));
  HEAPF32[i18 >> 2] = f24;
  i8 = i18 + 4 | 0;
  HEAPF32[i8 >> 2] = f23;
  i21 = i18 + 8 | 0;
  HEAPF32[i21 >> 2] = f22;
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i13, i18);
  HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  i8 = HEAP32[i8 >> 2] | 0;
  i21 = HEAP32[i21 >> 2] | 0;
  HEAP32[i14 + 16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i14 + 20 >> 2] = i8;
  HEAP32[i14 + 24 >> 2] = i21;
 }
 i1 = (i7 & 1 | 0) != 0;
 if (i1) {
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i13, i16);
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i12 + 4 >> 2] | 0;
  i21 = HEAP32[i12 + 8 >> 2] | 0;
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i13, i15);
  i5 = HEAP32[i12 >> 2] | 0;
  i6 = HEAP32[i12 + 4 >> 2] | 0;
  i13 = HEAP32[i12 + 8 >> 2] | 0;
  f26 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f25 * f26);
  f28 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f22 - Math_fround(f27 * f28));
  f23 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f23 * f28);
  f24 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f28 - Math_fround(f25 * f24));
  f26 = Math_fround(Math_fround(f27 * f24) - Math_fround(f23 * f26));
  HEAP32[i12 >> 2] = i5;
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i12 + 8 >> 2] = i13;
  HEAP32[i12 + 12 >> 2] = i7;
  HEAP32[i12 + 16 >> 2] = i8;
  HEAP32[i12 + 20 >> 2] = i21;
  HEAPF32[i12 + 24 >> 2] = f22;
  HEAPF32[i12 + 28 >> 2] = f25;
  HEAPF32[i12 + 32 >> 2] = f26;
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i19, i12);
  f26 = Math_fround(HEAPF32[i19 >> 2]);
  f25 = Math_fround(f26 * f26);
  f22 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f22 * f22));
  f23 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f23 * f23));
  f24 = Math_fround(HEAPF32[i19 + 12 >> 2]);
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25 + Math_fround(f24 * f24)))));
  f22 = Math_fround(f22 * f25);
  f23 = Math_fround(f23 * f25);
  f24 = Math_fround(f24 * f25);
  HEAPF32[i14 >> 2] = Math_fround(f26 * f25);
  HEAPF32[i14 + 4 >> 2] = f22;
  HEAPF32[i14 + 8 >> 2] = f23;
  HEAPF32[i14 + 12 >> 2] = f24;
 }
 i21 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, 0, i14 | 0);
 i21 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i18 | 0, i21 | 0, 1);
 if (!i4) {
  if (i3) {
   i19 = HEAP32[i17 + 4 >> 2] | 0;
   i21 = HEAP32[i17 + 8 >> 2] | 0;
   HEAP32[i18 + 16 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i18 + 20 >> 2] = i19;
   HEAP32[i18 + 24 >> 2] = i21;
  }
  if (!i1) {
   i21 = HEAP32[i2 >> 2] | 0;
   i19 = HEAP32[i21 >> 2] | 0;
   i19 = i19 + 32 | 0;
   i19 = HEAP32[i19 >> 2] | 0;
   mftCall_viii(i19 | 0, i21 | 0, 1, i18 | 0);
   STACKTOP = i20;
   return;
  }
  i13 = HEAP32[i15 >> 2] | 0;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i15 = HEAP32[i15 + 8 >> 2] | 0;
  i17 = HEAP32[i16 >> 2] | 0;
  i19 = HEAP32[i16 + 4 >> 2] | 0;
  i21 = HEAP32[i16 + 8 >> 2] | 0;
  f27 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f27 * f25);
  f22 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 - Math_fround(f22 * f28));
  f24 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f22 * f24);
  f23 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f22 - Math_fround(f23 * f25));
  f24 = Math_fround(Math_fround(f23 * f28) - Math_fround(f27 * f24));
  HEAP32[i12 >> 2] = i13;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 + 8 >> 2] = i15;
  HEAP32[i12 + 12 >> 2] = i17;
  HEAP32[i12 + 16 >> 2] = i19;
  HEAP32[i12 + 20 >> 2] = i21;
  HEAPF32[i12 + 24 >> 2] = f26;
  HEAPF32[i12 + 28 >> 2] = f25;
  HEAPF32[i12 + 32 >> 2] = f24;
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i11, i12);
  f24 = Math_fround(HEAPF32[i11 >> 2]);
  f25 = Math_fround(f24 * f24);
  f26 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f26 * f26));
  f27 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f27 * f27));
  f28 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25 + Math_fround(f28 * f28)))));
  f26 = Math_fround(f26 * f25);
  f27 = Math_fround(f27 * f25);
  f28 = Math_fround(f28 * f25);
  HEAPF32[i18 >> 2] = Math_fround(f24 * f25);
  HEAPF32[i18 + 4 >> 2] = f26;
  HEAPF32[i18 + 8 >> 2] = f27;
  HEAPF32[i18 + 12 >> 2] = f28;
  i21 = HEAP32[i2 >> 2] | 0;
  i19 = HEAP32[i21 >> 2] | 0;
  i19 = i19 + 32 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_viii(i19 | 0, i21 | 0, 1, i18 | 0);
  STACKTOP = i20;
  return;
 } else {
  if (i3) {
   __ZNK9Transform11GetPositionEv(i12, i4);
   f26 = Math_fround(HEAPF32[i17 >> 2]);
   f26 = Math_fround(f26 - Math_fround(HEAPF32[i12 >> 2]));
   f27 = Math_fround(HEAPF32[i17 + 4 >> 2]);
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i12 + 4 >> 2]));
   f28 = Math_fround(HEAPF32[i17 + 8 >> 2]);
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i12 + 8 >> 2]));
   HEAPF32[i9 >> 2] = f26;
   i19 = i9 + 4 | 0;
   HEAPF32[i19 >> 2] = f27;
   i21 = i9 + 8 | 0;
   HEAPF32[i21 >> 2] = f28;
   __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i4, i9);
   HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i19 = HEAP32[i19 >> 2] | 0;
   i21 = HEAP32[i21 >> 2] | 0;
   HEAP32[i18 + 16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i18 + 20 >> 2] = i19;
   HEAP32[i18 + 24 >> 2] = i21;
  }
  if (!i1) {
   i21 = HEAP32[i2 >> 2] | 0;
   i19 = HEAP32[i21 >> 2] | 0;
   i19 = i19 + 32 | 0;
   i19 = HEAP32[i19 >> 2] | 0;
   mftCall_viii(i19 | 0, i21 | 0, 1, i18 | 0);
   STACKTOP = i20;
   return;
  }
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i4, i15);
  i13 = HEAP32[i12 >> 2] | 0;
  i14 = HEAP32[i12 + 4 >> 2] | 0;
  i15 = HEAP32[i12 + 8 >> 2] | 0;
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i12, i4, i16);
  i17 = HEAP32[i12 >> 2] | 0;
  i19 = HEAP32[i12 + 4 >> 2] | 0;
  i21 = HEAP32[i12 + 8 >> 2] | 0;
  f27 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f27 * f25);
  f22 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 - Math_fround(f22 * f28));
  f24 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = Math_fround(f22 * f24);
  f23 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f22 - Math_fround(f23 * f25));
  f24 = Math_fround(Math_fround(f23 * f28) - Math_fround(f27 * f24));
  HEAP32[i12 >> 2] = i13;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 + 8 >> 2] = i15;
  HEAP32[i12 + 12 >> 2] = i17;
  HEAP32[i12 + 16 >> 2] = i19;
  HEAP32[i12 + 20 >> 2] = i21;
  HEAPF32[i12 + 24 >> 2] = f26;
  HEAPF32[i12 + 28 >> 2] = f25;
  HEAPF32[i12 + 32 >> 2] = f24;
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i10, i12);
  f24 = Math_fround(HEAPF32[i10 >> 2]);
  f25 = Math_fround(f24 * f24);
  f26 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f26 * f26));
  f27 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f27 * f27));
  f28 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f25 + Math_fround(f28 * f28)))));
  f26 = Math_fround(f26 * f25);
  f27 = Math_fround(f27 * f25);
  f28 = Math_fround(f28 * f25);
  HEAPF32[i18 >> 2] = Math_fround(f24 * f25);
  HEAPF32[i18 + 4 >> 2] = f26;
  HEAPF32[i18 + 8 >> 2] = f27;
  HEAPF32[i18 + 12 >> 2] = f28;
  i21 = HEAP32[i2 >> 2] | 0;
  i19 = HEAP32[i21 >> 2] | 0;
  i19 = i19 + 32 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_viii(i19 | 0, i21 | 0, 1, i18 | 0);
  STACKTOP = i20;
  return;
 }
}

function __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i39, i1, i27, i26, i21, i22) {
 i39 = i39 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i42 + 100 | 0;
 i9 = i42;
 i28 = i42 + 96 | 0;
 i7 = i42 + 92 | 0;
 i6 = i42 + 88 | 0;
 i2 = i42 + 84 | 0;
 i3 = i42 + 80 | 0;
 i4 = i42 + 76 | 0;
 i5 = i42 + 72 | 0;
 i8 = i42 + 68 | 0;
 i35 = i42 + 56 | 0;
 i36 = i42 + 44 | 0;
 i41 = i42 + 32 | 0;
 i40 = i42 + 20 | 0;
 i38 = i42 + 8 | 0;
 i20 = i42 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674663 | 0, i28 | 0) | 0) {
  i1 = HEAP32[i28 >> 2] | 0;
  HEAP32[i37 >> 2] = i1;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
  i31 = i1;
 } else i31 = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 773144 | 0, i28 | 0) | 0) {
  i1 = HEAP32[i28 >> 2] | 0;
  HEAP32[i37 >> 2] = i1;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
 } else i1 = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i27, gb + 773163 | 0, i2, i7, i6, i26);
 i19 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i27, gb + 765025 | 0, i3, i7, i6, i26);
 i18 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i27, gb + 765035 | 0, i4, i7, i6, i26);
 i17 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i27, gb + 765046 | 0, i5, i7, i6, i26);
 i16 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx2Sn24readStridedFlagsPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorEPKNS_11PxU32ToNameE(i27, gb + 743223 | 0, i8, i7, i6, i26, gb + 115968 | 0);
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i35 >> 2] = 0;
 i11 = i35 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i33 = i35 + 8 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 i12 = i36 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i34 = i36 + 8 | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i41 >> 2] = 0;
 i13 = i41 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i32 = i41 + 8 | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 i14 = i40 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i30 = i40 + 8 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 i15 = i38 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i29 = i38 + 8 | 0;
 HEAP32[i29 >> 2] = 0;
 i23 = (i16 | 0) != 0;
 i24 = (i17 | 0) != 0;
 i25 = (i10 | 0) != 0;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 743680 | 0, 983, gb + 743790 | 0, i9);
  HEAP32[i39 >> 2] = gb + 1576256;
  HEAP32[i39 + 4 >> 2] = 0;
  i3 = i39 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i6 = (i1 + -1 | 0) >>> 5;
  i8 = 0;
  while (1) {
   i1 = HEAP32[i19 + (i8 << 2) >> 2] | 0;
   L20 : do if (i1 | 0) {
    i7 = i8 << 5;
    if (!i24) while (1) {
     i5 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
     i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i7;
     HEAP32[i20 >> 2] = i5;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((HEAP32[i33 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i35 >> 2] | 0) + (i2 << 2) >> 2] = i5;
      HEAP32[i11 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i35, i20) | 0;
     i2 = i5 * 12 | 0;
     i3 = i18 + i2 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i9 = HEAP32[i36 >> 2] | 0;
      HEAP32[i9 + (i4 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
      HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i18 + (i2 + 4) >> 2];
      HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i18 + (i2 + 8) >> 2];
      HEAP32[i12 >> 2] = i4 + 1;
     } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i36, i3) | 0;
     do if (i23) {
      i2 = i16 + (i5 << 2) | 0;
      i3 = HEAP32[i14 >> 2] | 0;
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i40 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i14 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf(i40, i2) | 0;
       break;
      }
     } while (0);
     do if (i25) {
      i2 = i10 + (i5 << 2) | 0;
      i3 = HEAP32[i15 >> 2] | 0;
      if ((HEAP32[i29 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i38 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i15 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i38, i2) | 0;
       break;
      }
     } while (0);
     i1 = i1 + -1 & i1;
     if (!i1) break L20;
    }
    do {
     i5 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
     i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i7;
     HEAP32[i20 >> 2] = i5;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((HEAP32[i33 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i35 >> 2] | 0) + (i2 << 2) >> 2] = i5;
      HEAP32[i11 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i35, i20) | 0;
     i4 = i5 * 12 | 0;
     i2 = i18 + i4 | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      i9 = HEAP32[i36 >> 2] | 0;
      HEAP32[i9 + (i3 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i18 + (i4 + 4) >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i18 + (i4 + 8) >> 2];
      HEAP32[i12 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i36, i2) | 0;
     i2 = i17 + i4 | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     if ((HEAP32[i32 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      i9 = HEAP32[i41 >> 2] | 0;
      HEAP32[i9 + (i3 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i17 + (i4 + 4) >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i17 + (i4 + 8) >> 2];
      HEAP32[i13 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i41, i2) | 0;
     do if (i23) {
      i2 = i16 + (i5 << 2) | 0;
      i3 = HEAP32[i14 >> 2] | 0;
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i40 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i14 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf(i40, i2) | 0;
       break;
      }
     } while (0);
     do if (i25) {
      i2 = i10 + (i5 << 2) | 0;
      i3 = HEAP32[i15 >> 2] | 0;
      if ((HEAP32[i29 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i38 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i15 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i38, i2) | 0;
       break;
      }
     } while (0);
     i1 = i1 + -1 & i1;
    } while ((i1 | 0) != 0);
   } while (0);
   if ((i8 | 0) == (i6 | 0)) break; else i8 = i8 + 1 | 0;
  }
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743229 | 0, i28 | 0) | 0) {
   i1 = HEAP32[i28 >> 2] | 0;
   HEAP32[i37 >> 2] = i1;
   if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
   i2 = 1;
  } else {
   i2 = 0;
   i1 = 0;
  }
  i6 = HEAP32[i21 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 112 >> 2] | 0, i6 | 0, i1 | 0, i23 | 0) | 0;
  HEAP32[i37 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  i6 = i2 & (__ZN5physx2Sn17readAllPropertiesINS_16PxParticleSystemEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i37, i27, i1, i26, i22) | 0);
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743242 | 0, i37 | 0) | 0) {
   HEAP32[i28 >> 2] = 0;
   __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(HEAP32[i37 >> 2] | 0, i26, i28, gb + 116016 | 0);
   i5 = 1;
   i2 = HEAP32[i28 >> 2] | 0;
  } else {
   i5 = 0;
   i2 = 0;
  }
  i2 = i2 & 65535;
  i4 = 0;
  while (1) {
   i3 = 1 << i4;
   if ((i4 | 0) == 4) {
    i4 = 5;
    continue;
   }
   if (i2 & i3 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i3 | 0, 1);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == 16) break;
  }
  i11 = i6 & i5;
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743260 | 0, i37 | 0) | 0) {
   HEAP32[i28 >> 2] = 0;
   __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(HEAP32[i37 >> 2] | 0, i26, i28, gb + 116080 | 0);
   i10 = 1;
   i3 = HEAP32[i28 >> 2] & 65535;
  } else {
   i10 = 0;
   i3 = 0;
  }
  i4 = 0;
  do {
   i2 = 1 << i4;
   if (i2 & i3 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, i2 | 0, 1);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != 16);
  i4 = i37 + 20 | 0;
  i5 = i37 + 24 | 0;
  i6 = i37 + 28 | 0;
  i7 = i37 + 32 | 0;
  i8 = i37 + 36 | 0;
  i9 = i37 + 40 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 12;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 4;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 4;
  HEAP32[i37 >> 2] = i31;
  i2 = HEAP32[i35 >> 2] | 0;
  HEAP32[i37 + 4 >> 2] = i2;
  HEAP32[i37 + 8 >> 2] = 4;
  i3 = HEAP32[i36 >> 2] | 0;
  HEAP32[i37 + 12 >> 2] = i3;
  HEAP32[i37 + 16 >> 2] = 12;
  if (i24) {
   HEAP32[i4 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i5 >> 2] = 12;
  }
  if (i23) {
   HEAP32[i6 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i7 >> 2] = 4;
  }
  if (i25) {
   HEAP32[i8 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i9 >> 2] = 4;
  }
  mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i37 | 0) | 0;
  if (i11 & i10) {
   HEAP32[i39 + 4 >> 2] = i1;
   i5 = gb + 764992 | 0;
   i4 = 0;
  } else {
   HEAP32[i39 + 4 >> 2] = 0;
   i5 = gb + 1576256 | 0;
   i1 = 0;
   i4 = 0;
  }
  HEAP32[i39 >> 2] = i5;
  i39 = i39 + 8 | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i39 + 4 >> 2] = i4;
  i39 = HEAP32[i29 >> 2] | 0;
  if ((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i38 >> 2] | 0;
   if (i1) {
    i39 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 12 >> 2] | 0, i39 | 0, i1 | 0);
   }
  }
 }
 i39 = HEAP32[i30 >> 2] | 0;
 if ((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i40 >> 2] | 0;
  if (i1 | 0) {
   i40 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i40 >> 2] | 0) + 12 >> 2] | 0, i40 | 0, i1 | 0);
  }
 }
 i40 = HEAP32[i32 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i41 >> 2] | 0;
  if (i1 | 0) {
   i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
  }
 }
 i41 = HEAP32[i34 >> 2] | 0;
 if (!((i41 & 2147483647 | 0) == 0 | (i41 | 0) < 0 | (i3 | 0) == 0)) {
  i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i3 | 0);
 }
 i41 = HEAP32[i33 >> 2] | 0;
 if ((i41 & 2147483647 | 0) == 0 | (i41 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i42;
  return;
 }
 i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i2 | 0);
 STACKTOP = i42;
 return;
}

function __ZNK5Umbra11Transformer16frustumShrinkBoxEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_RS4_S5_(i12, i1, i2, i3, i31, i32) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 2976 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36 + 2848 | 0;
 i34 = i36 + 32 | 0;
 i35 = i36;
 i29 = (i1 | 0) == 0;
 i30 = HEAP32[(i29 ? i12 + 1196 | 0 : i1) >> 2] | 0;
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(HEAPF32[i12 + 1316 >> 2]);
 i40 = i2 + 4 | 0;
 f23 = Math_fround(HEAPF32[i40 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 1320 >> 2]);
 i39 = i2 + 8 | 0;
 f27 = Math_fround(HEAPF32[i39 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 1324 >> 2]);
 i37 = i2 + 12 | 0;
 f25 = Math_fround(HEAPF32[i37 >> 2]);
 f24 = Math_fround(HEAPF32[i12 + 1328 >> 2]);
 HEAPF32[i2 >> 2] = f21 >= f22 ? f21 : f22;
 HEAPF32[i40 >> 2] = f23 >= f28 ? f23 : f28;
 HEAPF32[i39 >> 2] = f27 >= f26 ? f27 : f26;
 HEAPF32[i37 >> 2] = f25 >= f24 ? f25 : f24;
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f25 = Math_fround(HEAPF32[i12 + 1332 >> 2]);
 f25 = f24 <= f25 ? f24 : f25;
 i6 = i3 + 4 | 0;
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 1336 >> 2]);
 f26 = f24 <= f26 ? f24 : f26;
 i7 = i3 + 8 | 0;
 f24 = Math_fround(HEAPF32[i7 >> 2]);
 f27 = Math_fround(HEAPF32[i12 + 1340 >> 2]);
 f27 = f24 <= f27 ? f24 : f27;
 i38 = i3 + 12 | 0;
 f24 = Math_fround(HEAPF32[i38 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 1344 >> 2]);
 f28 = f24 <= f28 ? f24 : f28;
 HEAPF32[i3 >> 2] = f25;
 HEAPF32[i6 >> 2] = f26;
 HEAPF32[i7 >> 2] = f27;
 HEAPF32[i38 >> 2] = f28;
 i44 = HEAP32[i2 >> 2] | 0;
 HEAP32[i33 >> 2] = i44;
 i41 = HEAP32[i40 >> 2] | 0;
 HEAP32[i33 + 4 >> 2] = i41;
 i43 = HEAP32[i39 >> 2] | 0;
 HEAP32[i33 + 8 >> 2] = i43;
 i45 = HEAP32[i37 >> 2] | 0;
 HEAP32[i33 + 12 >> 2] = i45;
 i4 = HEAP32[gb + 1451592 >> 2] | 0;
 i47 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i33 + 16 >> 2] = i44 & ~i4 | i47 & i4;
 i4 = HEAP32[gb + 1451592 + 4 >> 2] | 0;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i33 + 20 >> 2] = i41 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451592 + 8 >> 2] | 0;
 i42 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i33 + 24 >> 2] = i43 & ~i4 | i42 & i4;
 i4 = HEAP32[gb + 1451592 + 12 >> 2] | 0;
 i46 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i33 + 28 >> 2] = i45 & ~i4 | i46 & i4;
 i4 = HEAP32[gb + 1451608 >> 2] | 0;
 HEAP32[i33 + 32 >> 2] = i44 & ~i4 | i47 & i4;
 i4 = HEAP32[gb + 1451608 + 4 >> 2] | 0;
 HEAP32[i33 + 36 >> 2] = i41 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451608 + 8 >> 2] | 0;
 HEAP32[i33 + 40 >> 2] = i43 & ~i4 | i42 & i4;
 i4 = HEAP32[gb + 1451608 + 12 >> 2] | 0;
 HEAP32[i33 + 44 >> 2] = i45 & ~i4 | i46 & i4;
 i4 = HEAP32[gb + 1451624 >> 2] | 0;
 i46 = HEAP32[i3 >> 2] | 0;
 HEAP32[i33 + 48 >> 2] = i44 & ~i4 | i46 & i4;
 i4 = HEAP32[gb + 1451624 + 4 >> 2] | 0;
 i44 = HEAP32[i6 >> 2] | 0;
 i45 = HEAP32[i40 >> 2] | 0;
 HEAP32[i33 + 52 >> 2] = i45 & ~i4 | i44 & i4;
 i4 = HEAP32[gb + 1451624 + 8 >> 2] | 0;
 i42 = HEAP32[i7 >> 2] | 0;
 i43 = HEAP32[i39 >> 2] | 0;
 HEAP32[i33 + 56 >> 2] = i43 & ~i4 | i42 & i4;
 i4 = HEAP32[gb + 1451624 + 12 >> 2] | 0;
 i5 = HEAP32[i38 >> 2] | 0;
 i41 = HEAP32[i37 >> 2] | 0;
 HEAP32[i33 + 60 >> 2] = i41 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451640 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i33 + 64 >> 2] = i2 & ~i4 | i46 & i4;
 i4 = HEAP32[gb + 1451640 + 4 >> 2] | 0;
 HEAP32[i33 + 68 >> 2] = i45 & ~i4 | i44 & i4;
 i4 = HEAP32[gb + 1451640 + 8 >> 2] | 0;
 HEAP32[i33 + 72 >> 2] = i43 & ~i4 | i42 & i4;
 i4 = HEAP32[gb + 1451640 + 12 >> 2] | 0;
 HEAP32[i33 + 76 >> 2] = i41 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451656 >> 2] | 0;
 HEAP32[i33 + 80 >> 2] = i2 & ~i4 | i46 & i4;
 i4 = HEAP32[gb + 1451656 + 4 >> 2] | 0;
 HEAP32[i33 + 84 >> 2] = i45 & ~i4 | i44 & i4;
 i4 = HEAP32[gb + 1451656 + 8 >> 2] | 0;
 HEAP32[i33 + 88 >> 2] = i43 & ~i4 | i42 & i4;
 i4 = HEAP32[gb + 1451656 + 12 >> 2] | 0;
 HEAP32[i33 + 92 >> 2] = i41 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451672 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i33 + 96 >> 2] = i2 & ~i4 | i5 & i4;
 i4 = HEAP32[gb + 1451672 + 4 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i33 + 100 >> 2] = HEAP32[i40 >> 2] & ~i4 | i6 & i4;
 i4 = HEAP32[gb + 1451672 + 8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i33 + 104 >> 2] = HEAP32[i39 >> 2] & ~i4 | i7 & i4;
 i4 = HEAP32[gb + 1451672 + 12 >> 2] | 0;
 i3 = HEAP32[i38 >> 2] | 0;
 HEAP32[i33 + 108 >> 2] = HEAP32[i37 >> 2] & ~i4 | i3 & i4;
 HEAP32[i33 + 112 >> 2] = i5;
 HEAP32[i33 + 116 >> 2] = i6;
 HEAP32[i33 + 120 >> 2] = i7;
 HEAP32[i33 + 124 >> 2] = i3;
 _memset(i34 | 0, 0, 2816) | 0;
 i3 = i29 ? i12 + 1228 | 0 : i1 + 4 | 0;
 i29 = (i30 | 0) > 0;
 if (i29) {
  i2 = 0;
  do {
   f8 = Math_fround(HEAPF32[i33 + (i2 << 4) >> 2]);
   f9 = Math_fround(HEAPF32[i33 + (i2 << 4) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i33 + (i2 << 4) + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i33 + (i2 << 4) + 12 >> 2]);
   i1 = 0;
   i4 = 0;
   i5 = 0;
   i6 = 0;
   i7 = 0;
   do {
    i47 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    f26 = Math_fround(f8 * Math_fround(HEAPF32[i12 + 480 + (i47 << 4) >> 2]));
    f27 = Math_fround(f9 * Math_fround(HEAPF32[i12 + 480 + (i47 << 4) + 4 >> 2]));
    f28 = Math_fround(f10 * Math_fround(HEAPF32[i12 + 480 + (i47 << 4) + 8 >> 2]));
    f28 = Math_fround(Math_fround(Math_fround(f26 + f27) + f28) + Math_fround(f11 * Math_fround(HEAPF32[i12 + 480 + (i47 << 4) + 12 >> 2])));
    HEAPF32[i34 + (i1 << 7) + (i2 << 4) >> 2] = f28;
    HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 4 >> 2] = f28;
    HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 8 >> 2] = f28;
    HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 12 >> 2] = f28;
    i47 = (f28 < Math_fround(0.0)) << 31 >> 31;
    i4 = i47 | i4;
    i6 = i47 | i6;
    i7 = i47 | i7;
    i5 = i47 | i5;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i30 | 0));
   HEAP32[i35 + (i2 << 2) >> 2] = i6 >> 31 & 2 | i4 >>> 31 | i7 >> 31 & 4 | i5 >> 31 & 8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 8);
  i12 = 0;
  f14 = Math_fround(-3402823469999999843913219.0e14);
  f16 = Math_fround(3402823469999999843913219.0e14);
  f15 = Math_fround(-3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f10 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(3402823469999999843913219.0e14);
 } else {
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  HEAP32[i35 + 12 >> 2] = 0;
  HEAP32[i35 + 16 >> 2] = 0;
  HEAP32[i35 + 20 >> 2] = 0;
  HEAP32[i35 + 24 >> 2] = 0;
  HEAP32[i35 + 28 >> 2] = 0;
  i12 = 0;
  f14 = Math_fround(-3402823469999999843913219.0e14);
  f16 = Math_fround(3402823469999999843913219.0e14);
  f15 = Math_fround(-3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f10 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(3402823469999999843913219.0e14);
 }
 do {
  i4 = i33 + (i12 << 4) | 0;
  if (!(HEAP32[i35 + (i12 << 2) >> 2] | 0)) {
   f25 = Math_fround(HEAPF32[i4 >> 2]);
   f28 = Math_fround(HEAPF32[i33 + (i12 << 4) + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i33 + (i12 << 4) + 8 >> 2]);
   f27 = Math_fround(HEAPF32[i33 + (i12 << 4) + 12 >> 2]);
   f14 = f14 >= f25 ? f14 : f25;
   f16 = f16 <= f25 ? f16 : f25;
   f15 = f15 >= f26 ? f15 : f26;
   f13 = f13 <= f26 ? f13 : f26;
   f11 = f11 >= f27 ? f11 : f27;
   f10 = f10 <= f27 ? f10 : f27;
   f9 = f9 >= f28 ? f9 : f28;
   f8 = f8 <= f28 ? f8 : f28;
  } else {
   i5 = i33 + (i12 << 4) + 4 | 0;
   i6 = i33 + (i12 << 4) + 8 | 0;
   i7 = i33 + (i12 << 4) + 12 | 0;
   i3 = 0;
   f28 = f14;
   f27 = f16;
   f26 = f15;
   f25 = f13;
   while (1) {
    i2 = 1 << i3 ^ i12;
    if (i29) {
     i1 = 0;
     f16 = Math_fround(1.0);
     f15 = Math_fround(1.0);
     f14 = Math_fround(1.0);
     f13 = Math_fround(1.0);
     do {
      f17 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i12 << 4) >> 2]);
      f18 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i12 << 4) + 4 >> 2]);
      f19 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i12 << 4) + 8 >> 2]);
      f20 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i12 << 4) + 12 >> 2]);
      f21 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i2 << 4) >> 2]);
      f22 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 4 >> 2]);
      f23 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 8 >> 2]);
      f24 = Math_fround(HEAPF32[i34 + (i1 << 7) + (i2 << 4) + 12 >> 2]);
      i44 = !(f18 > Math_fround(0.0)) & f22 > Math_fround(0.0);
      i46 = !(f19 > Math_fround(0.0)) & f23 > Math_fround(0.0);
      i47 = !(f20 > Math_fround(0.0)) & f24 > Math_fround(0.0);
      i45 = (!(f17 > Math_fround(0.0)) & f21 > Math_fround(0.0)) << 31 >> 31 >>> 31;
      if ((i44 ? 2 : 0) | i45 | (i46 ? 4 : 0) | (i47 ? 8 : 0)) {
       f17 = Math_fround(f21 - f17);
       f18 = Math_fround(f22 - f18);
       f19 = Math_fround(f23 - f19);
       f20 = Math_fround(f24 - f20);
       i47 = f17 == Math_fround(0.0);
       f17 = Math_fround(Math_fround(1.0) / f17);
       f17 = i47 ? Math_fround(1.0) : f17;
       i47 = f18 == Math_fround(0.0);
       f18 = Math_fround(Math_fround(1.0) / f18);
       f18 = i47 ? Math_fround(1.0) : f18;
       i47 = f19 == Math_fround(0.0);
       f19 = Math_fround(Math_fround(1.0) / f19);
       f19 = i47 ? Math_fround(1.0) : f19;
       i47 = f20 == Math_fround(0.0);
       f20 = Math_fround(Math_fround(1.0) / f20);
       f21 = Math_fround(f21 * f17);
       f22 = Math_fround(f22 * f18);
       f23 = Math_fround(f23 * f19);
       f24 = Math_fround(f24 * (i47 ? Math_fround(1.0) : f20));
       f16 = f16 <= f21 ? f16 : f21;
       f15 = f15 <= f23 ? f15 : f23;
       f14 = f14 <= f24 ? f14 : f24;
       f13 = f13 <= f22 ? f13 : f22;
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i30 | 0));
    } else {
     f16 = Math_fround(1.0);
     f15 = Math_fround(1.0);
     f14 = Math_fround(1.0);
     f13 = Math_fround(1.0);
    }
    if (f14 < Math_fround(1.0) | !(f16 < Math_fround(1.0)) & !(f13 < Math_fround(1.0)) & !(f15 < Math_fround(1.0)) ^ 1) {
     f18 = Math_fround(HEAPF32[i4 >> 2]);
     f17 = Math_fround(HEAPF32[i33 + (i2 << 4) >> 2]);
     f18 = Math_fround(f18 - f17);
     f24 = Math_fround(HEAPF32[i5 >> 2]);
     f19 = Math_fround(HEAPF32[i33 + (i2 << 4) + 4 >> 2]);
     f24 = Math_fround(f24 - f19);
     f21 = Math_fround(HEAPF32[i6 >> 2]);
     f20 = Math_fround(HEAPF32[i33 + (i2 << 4) + 8 >> 2]);
     f21 = Math_fround(f21 - f20);
     f22 = Math_fround(HEAPF32[i7 >> 2]);
     f23 = Math_fround(HEAPF32[i33 + (i2 << 4) + 12 >> 2]);
     f16 = Math_fround(f17 + Math_fround(f16 * f18));
     f24 = Math_fround(f19 + Math_fround(f13 * f24));
     f13 = Math_fround(f20 + Math_fround(f15 * f21));
     f23 = Math_fround(f23 + Math_fround(f14 * Math_fround(f22 - f23)));
     f14 = f28 >= f16 ? f28 : f16;
     f16 = f27 <= f16 ? f27 : f16;
     f15 = f26 >= f13 ? f26 : f13;
     f13 = f25 <= f13 ? f25 : f13;
     f11 = f11 >= f23 ? f11 : f23;
     f10 = f10 <= f23 ? f10 : f23;
     f9 = f9 >= f24 ? f9 : f24;
     f8 = f8 <= f24 ? f8 : f24;
    } else {
     f14 = f28;
     f16 = f27;
     f15 = f26;
     f13 = f25;
    }
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == 3) break; else {
     f28 = f14;
     f27 = f16;
     f26 = f15;
     f25 = f13;
    }
   }
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 8);
 HEAPF32[i31 >> 2] = f16;
 HEAPF32[i31 + 4 >> 2] = f8;
 HEAPF32[i31 + 8 >> 2] = f13;
 HEAPF32[i31 + 12 >> 2] = f10;
 HEAPF32[i32 >> 2] = f14;
 HEAPF32[i32 + 4 >> 2] = f9;
 HEAPF32[i32 + 8 >> 2] = f15;
 HEAPF32[i32 + 12 >> 2] = f11;
 STACKTOP = i36;
 return;
}

function __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i26, i9, i29, i23, i24) {
 i26 = i26 | 0;
 i9 = i9 | 0;
 i29 = i29 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i31 + 16 | 0;
 i14 = i31 + 8 | 0;
 i19 = i31 + 24 | 0;
 i20 = i31;
 i25 = (i23 | 0) != 0;
 if (i25) HEAP32[i23 >> 2] = 0;
 HEAP8[i26 + 128 >> 0] = 0;
 i27 = i26 + 88 | 0;
 i28 = i26 + 100 | 0;
 if (!(HEAP32[i28 >> 2] | 0)) {
  i7 = i26 + 72 | 0;
  i1 = __ZNK16TypeTreeIterator4NameEv(i7) | 0;
  do if (!i9) i22 = 6; else if (!i1) {
   i1 = 0;
   i22 = 6;
  } else {
   i24 = HEAP32[gb + 36932 >> 2] | 0;
   i25 = HEAP32[gb + 36936 >> 2] | 0;
   if (i25 >>> 0 > i9 >>> 0 & ((i24 >>> 0 > i9 >>> 0 | (i24 >>> 0 > i1 >>> 0 | i25 >>> 0 <= i1 >>> 0)) ^ 1)) if ((i1 | 0) == (i9 | 0)) break; else {
    i22 = 10;
    break;
   } else if (!(_strcmp(i9, i1) | 0)) break; else {
    i22 = 10;
    break;
   }
  } while (0);
  if ((i22 | 0) == 6) if ((i1 | 0) != (i9 | 0)) i22 = 10;
  if ((i22 | 0) == 10) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 469162 | 0, 0, gb + 469192 | 0, 163, 1, 0, 0, 0);
  i2 = HEAP32[i28 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = i26 + 104 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i3 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i1;
    HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i1 << 5, 4, i26 + 92 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i26 + 92 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] << 5 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i27 >> 2] = i25;
    break;
   }
  } while (0);
  HEAP32[i28 >> 2] = i3;
  i27 = HEAP32[i27 >> 2] | 0;
  i28 = i27 + (i2 << 5) | 0;
  i23 = i7;
  i24 = HEAP32[i23 + 4 >> 2] | 0;
  i25 = i28;
  HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i25 + 4 >> 2] = i24;
  i25 = i26 + 64 | 0;
  HEAP32[i27 + (i2 << 5) + 12 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i27 + (i2 << 5) + 16 >> 2] = 1;
  HEAP32[i27 + (i2 << 5) + 8 >> 2] = i29;
  __ZNK16TypeTreeIterator8ChildrenEv(i30, i28);
  i24 = i30;
  i29 = HEAP32[i24 + 4 >> 2] | 0;
  i30 = i27 + (i2 << 5) + 24 | 0;
  HEAP32[i30 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i30 + 4 >> 2] = i29;
  HEAP32[i27 + (i2 << 5) + 20 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i26 + 80 >> 2] = i28;
  i30 = 1;
  STACKTOP = i31;
  return i30 | 0;
 }
 HEAP32[i30 >> 2] = 0;
 i15 = i30 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i21 = i26 + 80 | 0;
 i16 = HEAP32[i21 >> 2] | 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i14, i16);
 i17 = i16 + 20 | 0;
 HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
 i18 = i16 + 24 | 0;
 i12 = i18;
 i22 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i30;
 HEAP32[i13 >> 2] = i22;
 HEAP32[i13 + 4 >> 2] = i12;
 L26 : do if (!i22) i22 = 31; else {
  i5 = i26 + 16 | 0;
  i3 = HEAP32[gb + 36932 >> 2] | 0;
  i4 = HEAP32[gb + 36936 >> 2] | 0;
  i1 = i3 >>> 0 > i9 >>> 0;
  L28 : do if (!i9) while (1) {
   if (!(__ZNK16TypeTreeIterator4NameEv(i30) | 0)) break L28;
   __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i5, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
   __ZNK16TypeTreeIterator4NextEv(i20, i30);
   i12 = i20;
   i22 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i30;
   HEAP32[i13 >> 2] = i22;
   HEAP32[i13 + 4 >> 2] = i12;
   if (!i22) {
    i22 = 31;
    break L26;
   }
  } else {
   if (i4 >>> 0 <= i9 >>> 0) while (1) {
    i1 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    if (i1 | 0) if (!(_strcmp(i9, i1) | 0)) break L28;
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i5, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
    __ZNK16TypeTreeIterator4NextEv(i20, i30);
    i12 = i20;
    i22 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i30;
    HEAP32[i13 >> 2] = i22;
    HEAP32[i13 + 4 >> 2] = i12;
    if (!i22) {
     i22 = 31;
     break L26;
    }
   }
   while (1) {
    i2 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    do if (i2 | 0) if (i1 | (i3 >>> 0 > i2 >>> 0 | i4 >>> 0 <= i2 >>> 0)) if (!(_strcmp(i9, i2) | 0)) break L28; else break; else if ((i2 | 0) == (i9 | 0)) break L28; else break; while (0);
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i5, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
    __ZNK16TypeTreeIterator4NextEv(i20, i30);
    i12 = i20;
    i22 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i30;
    HEAP32[i13 >> 2] = i22;
    HEAP32[i13 + 4 >> 2] = i12;
    if (!i22) {
     i22 = 31;
     break L26;
    }
   }
  } while (0);
  if (!(HEAP32[i30 >> 2] | 0)) i22 = 31; else i22 = 69;
 } while (0);
 if ((i22 | 0) == 31) {
  i2 = i16 + 8 | 0;
  i1 = __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_(HEAP32[gb + 1166132 >> 2] | 0, HEAP32[i2 >> 2] | 0, i9) | 0;
  i2 = __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_(HEAP32[i26 + 132 >> 2] | 0, HEAP32[i2 >> 2] | 0, i9) | 0;
  HEAP32[i19 >> 2] = HEAP32[i16 + 12 >> 2];
  i11 = i14;
  i13 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i12 = i30;
  HEAP32[i12 >> 2] = i13;
  HEAP32[i12 + 4 >> 2] = i11;
  L50 : do if (i13 | 0) {
   i11 = (i2 | 0) == 0;
   i12 = (i1 | 0) == 0;
   i13 = i26 + 16 | 0;
   i10 = i1 + 4 | 0;
   i8 = i2 + 4 | 0;
   i4 = HEAP32[gb + 36932 >> 2] | 0;
   i5 = HEAP32[gb + 36936 >> 2] | 0;
   i6 = i4 >>> 0 > i9 >>> 0;
   i7 = i5 >>> 0 > i9 >>> 0;
   if (!i9) while (1) {
    if (!(__ZNK16TypeTreeIterator4NameEv(i30) | 0)) break L50;
    i3 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    if (!i11) {
     i1 = HEAP32[i8 >> 2] | 0;
     if (i1 | 0) do {
      i2 = i1 + 16 | 0;
      if ((__Z6StrCmpPKcS0_(i3, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
       if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i3) | 0) >= 0) break L50;
       i1 = i1 + 4 | 0;
      }
      i1 = HEAP32[i1 >> 2] | 0;
     } while ((i1 | 0) != 0);
    }
    i3 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    if (!i12) {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) do {
      i2 = i1 + 16 | 0;
      if ((__Z6StrCmpPKcS0_(i3, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
       if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i3) | 0) >= 0) break L50;
       i1 = i1 + 4 | 0;
      }
      i1 = HEAP32[i1 >> 2] | 0;
     } while ((i1 | 0) != 0);
    }
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i13, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
    __ZNK16TypeTreeIterator4NextEv(i20, i30);
    i6 = i20;
    i9 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i7 = i30;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i7 + 4 >> 2] = i6;
    if (!i9) break L50;
   }
   do {
    i1 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    do if (i1 | 0) if (i7 & ((i6 | (i4 >>> 0 > i1 >>> 0 | i5 >>> 0 <= i1 >>> 0)) ^ 1)) if ((i1 | 0) == (i9 | 0)) break L50; else break; else if (!(_strcmp(i9, i1) | 0)) break L50; else break; while (0);
    i3 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    if (!i11) {
     i1 = HEAP32[i8 >> 2] | 0;
     if (i1 | 0) do {
      i2 = i1 + 16 | 0;
      if ((__Z6StrCmpPKcS0_(i3, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
       if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i3) | 0) >= 0) break L50;
       i1 = i1 + 4 | 0;
      }
      i1 = HEAP32[i1 >> 2] | 0;
     } while ((i1 | 0) != 0);
    }
    i3 = __ZNK16TypeTreeIterator4NameEv(i30) | 0;
    if (!i12) {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) do {
      i2 = i1 + 16 | 0;
      if ((__Z6StrCmpPKcS0_(i3, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
       if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i3) | 0) >= 0) break L50;
       i1 = i1 + 4 | 0;
      }
      i1 = HEAP32[i1 >> 2] | 0;
     } while ((i1 | 0) != 0);
    }
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i13, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
    __ZNK16TypeTreeIterator4NextEv(i20, i30);
    i1 = i20;
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i30;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i2 + 4 >> 2] = i1;
   } while ((i3 | 0) != 0);
  } while (0);
  if (!(HEAP32[i30 >> 2] | 0)) i1 = 0; else i22 = 69;
 }
 do if ((i22 | 0) == 69) {
  i12 = i30;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i18 + 4 >> 2] = i13;
  HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
  do if (HEAP8[(__ZNK16TypeTreeIterator7GetNodeEv(i16) | 0) + 3 >> 0] | 0) {
   if ((HEAP32[i30 >> 2] | 0) == (HEAP32[i14 >> 2] | 0)) if ((HEAP32[i15 >> 2] | 0) == (HEAP32[i14 + 4 >> 2] | 0)) break;
   i3 = i26 + 84 | 0;
   i4 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
   if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i30) | 0) + 12 >> 2] | 0) == -1) i22 = 75; else if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i30) | 0) + 20 >> 2] & 49152)) {
    i18 = Math_imul(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i30) | 0) + 12 >> 2] | 0, i4) | 0;
    HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i18;
   } else i22 = 75;
   if ((i22 | 0) == 75) {
    i5 = (HEAP32[i26 + 120 >> 2] | 0) + -1 | 0;
    i6 = HEAP32[i26 + 108 >> 2] | 0;
    i7 = i6 + (i5 * 12 | 0) + 8 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) > (i4 | 0)) i1 = 0; else HEAP32[i19 >> 2] = HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2];
    if ((i1 | 0) < (i4 | 0)) {
     i2 = i26 + 16 | 0;
     do {
      __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i30, i2, i19, (HEAP32[i26 >> 2] & 512 | 0) != 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i4 | 0));
    }
    HEAP32[i7 >> 2] = i4;
    HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i19 >> 2];
   }
   i18 = HEAP32[i3 >> 2] | 0;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  } while (0);
  i2 = HEAP32[i28 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = i26 + 104 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i3 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i1;
    HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i1 << 5, 4, i26 + 92 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i26 + 92 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i26 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] << 5 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i27 >> 2] = i26;
    break;
   }
  } while (0);
  HEAP32[i28 >> 2] = i3;
  i27 = HEAP32[i27 >> 2] | 0;
  i1 = i27 + (i2 << 5) | 0;
  i17 = i30;
  i26 = HEAP32[i17 + 4 >> 2] | 0;
  i18 = i1;
  HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i18 + 4 >> 2] = i26;
  HEAP32[i27 + (i2 << 5) + 12 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i27 + (i2 << 5) + 16 >> 2] = 1;
  __ZNK16TypeTreeIterator8ChildrenEv(i20, i1);
  i18 = i20;
  i20 = HEAP32[i18 + 4 >> 2] | 0;
  i26 = i27 + (i2 << 5) + 24 | 0;
  HEAP32[i26 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i26 + 4 >> 2] = i20;
  HEAP32[i27 + (i2 << 5) + 20 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i27 + (i2 << 5) + 8 >> 2] = i29;
  HEAP32[i21 >> 2] = i1;
  i1 = __ZNK16TypeTreeIterator4TypeEv(i30) | 0;
  do if (!i29) i22 = 89; else if (!i1) {
   i1 = 0;
   i22 = 89;
  } else {
   i26 = HEAP32[gb + 36932 >> 2] | 0;
   i27 = HEAP32[gb + 36936 >> 2] | 0;
   if (i27 >>> 0 > i29 >>> 0 & ((i26 >>> 0 > i29 >>> 0 | (i26 >>> 0 > i1 >>> 0 | i27 >>> 0 <= i1 >>> 0)) ^ 1)) {
    i1 = (i1 | 0) == (i29 | 0);
    break;
   } else {
    i1 = (_strcmp(i29, i1) | 0) == 0;
    break;
   }
  } while (0);
  if ((i22 | 0) == 89) i1 = (i1 | 0) == (i29 | 0);
  if (!(i1 | i24)) if ((HEAP32[i28 >> 2] | 0) != 1) {
   if (!i25) {
    i1 = -1;
    break;
   }
   HEAP32[i23 >> 2] = __Z13FindConverterPKcS0_(__ZNK16TypeTreeIterator4TypeEv(i30) | 0, i29) | 0;
   i1 = -1;
   break;
  }
  if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i30) | 0) + 12 >> 2] | 0) == -1) i1 = 1; else {
   i1 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i30) | 0) + 20 >> 2] & 49152 | 0) == 0;
   i1 = i1 ? 2 : 1;
  }
 } while (0);
 i30 = i1;
 STACKTOP = i31;
 return i30 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEbT0_S8_T_(i7, i6, i2) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 switch (i6 - i7 >> 4 | 0) {
 case 2:
  {
   i1 = i6 + -16 | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 3:
  {
   i3 = i7 + 16 | 0;
   i1 = i6 + -16 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i2 = (HEAP32[i1 >> 2] | 0) >>> 0 < i6 >>> 0;
   if (i6 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    if (!i2) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    if ((HEAP32[i3 >> 2] | 0) >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i7, i7 + 16 | 0, i7 + 32 | 0, i6 + -16 | 0, i2) | 0;
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 5:
  {
   i3 = i7 + 16 | 0;
   i4 = i7 + 32 | 0;
   i5 = i7 + 48 | 0;
   i1 = i6 + -16 | 0;
   __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i7, i3, i4, i5, i2) | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   if ((HEAP32[i5 >> 2] | 0) >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   if ((HEAP32[i4 >> 2] | 0) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   if ((HEAP32[i3 >> 2] | 0) >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 1:
 case 0:
  {
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i3 = i7 + 32 | 0;
   i1 = i7 + 16 | 0;
   i10 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 >>> 0 < i10 >>> 0;
   do if (i10 >>> 0 < i2 >>> 0) {
    if (i5) {
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     break;
    };
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    if (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0) {
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    }
   } else if (i5) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    }
   } while (0);
   i1 = i7 + 48 | 0;
   L13 : do if ((i1 | 0) == (i6 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i5 = HEAP32[i1 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
      i4 = i1 + 4 | 0;
      HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       if ((i3 | 0) == (i7 | 0)) {
        i3 = i7;
        break;
       }
       i4 = i3 + -16 | 0;
       if (i5 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
        i10 = i3;
        i3 = i4;
        i4 = i10;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      i10 = i3 + 4 | 0;
      HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 16 | 0) == (i6 | 0);
       break L13;
      }
     }
     i3 = i1 + 16 | 0;
     if ((i3 | 0) == (i6 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i9;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZNK8GUIStyle16GetGUIStyleStateER8GUIStatebbbb(i11, i8, i6, i7, i1, i5) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 do if (i1) {
  if (i6) {
   i4 = i11 + 116 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 52; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 52; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 54;
     }
    }
    if ((i12 | 0) == 52) i12 = 54;
    if ((i12 | 0) == 54) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i1 = i1 | 0 ? i4 : 0;
  } else i1 = 0;
  do if (i5) {
   i5 = i11 + 156 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 | 0) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 64; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 64; else if (HEAP32[i2 + 4 >> 2] | 0) {
      i1 = i5;
      break;
     }
    }
    if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) {
     i1 = i5;
     break;
    }
   }
   i5 = i11 + 116 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 73; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 73; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 75;
     }
    }
    if ((i12 | 0) == 73) i12 = 75;
    if ((i12 | 0) == 75) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
   i1 = i2 | 0 ? i5 : i1;
  } while (0);
  if (i6 & i7) {
   i5 = i11 + 136 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 85; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 85; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 87;
     }
    }
    if ((i12 | 0) == 85) i12 = 87;
    if ((i12 | 0) == 87) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i1 = i2 | 0 ? i5 : i1;
   }
  }
  i5 = i8 + 60 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) == 0 ? i11 + 16 | 0 : i1;
  if (i1 | 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 96; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 96; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 98;
     }
    }
    if ((i12 | 0) == 96) i12 = 98;
    if ((i12 | 0) == 98) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
    if (!((i2 | 0) == 0 | (HEAP32[i5 >> 2] | 0) == 0)) {
     i12 = 102;
     break;
    }
   }
  }
  i1 = i11 + 96 | 0;
  i12 = 102;
 } else {
  if (i6) {
   i4 = i11 + 36 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 9; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 9; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 11;
     }
    }
    if ((i12 | 0) == 9) i12 = 11;
    if ((i12 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i1 = i1 | 0 ? i4 : 0;
  } else i1 = 0;
  do if (i5) {
   i5 = i11 + 76 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 | 0) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 21; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 21; else if (HEAP32[i2 + 4 >> 2] | 0) {
      i1 = i5;
      break;
     }
    }
    if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) {
     i1 = i5;
     break;
    }
   }
   i5 = i11 + 36 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 30; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i4 = HEAP32[i2 + 28 >> 2] | 0;
      i3 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i4 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 32 >> 2] | 0;
      i4 = HEAP32[i4 + 28 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 + (i3 << 3) | 0)) i12 = 30; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 32;
     }
    }
    if ((i12 | 0) == 30) i12 = 32;
    if ((i12 | 0) == 32) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i1 = i2 | 0 ? i5 : i1;
   }
  } while (0);
  if (i6 & i7) {
   i5 = i11 + 56 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 41; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 41; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 43;
     }
    }
    if ((i12 | 0) == 41) i12 = 43;
    if ((i12 | 0) == 43) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i1 = i2 | 0 ? i5 : i1;
   }
  }
  i1 = (HEAP32[i8 + 60 >> 2] | 0) == 0 ? i11 + 16 | 0 : i1;
  if (i1 | 0) i12 = 102;
 } while (0);
 if ((i12 | 0) == 102) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i10 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i12 = 108; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 108; else if (HEAP32[i2 + 4 >> 2] | 0) {
     i14 = i1;
     STACKTOP = i13;
     return i14 | 0;
    }
   }
   if (__Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0) {
    i14 = i1;
    STACKTOP = i13;
    return i14 | 0;
   }
  }
 }
 i14 = i11 + 16 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i1, i11, i12, i44, i45, i34, i46, i35, i47, i36) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i44 = i44 | 0;
 i45 = i45 | 0;
 i34 = i34 | 0;
 i46 = i46 | 0;
 i35 = i35 | 0;
 i47 = i47 | 0;
 i36 = i36 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i48 = 0, f49 = f0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i48;
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 + 4 >> 2] = 0;
 HEAP32[i46 + 8 >> 2] = 0;
 HEAP32[i46 + 12 >> 2] = 0;
 HEAP32[i46 + 16 >> 2] = 0;
 HEAP32[i46 + 20 >> 2] = 0;
 HEAP32[i46 + 24 >> 2] = 0;
 HEAP32[i46 + 28 >> 2] = 0;
 i43 = (i47 | 0) != 0;
 if (i43) HEAP32[i47 >> 2] = 0;
 if ((i11 | 0) == 0 & (i12 | 0) == 0) {
  i47 = -2147483640;
  STACKTOP = i48;
  return i47 | 0;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 i1 = _bitshift64Lshr(i11 | 0, i12 | 0, 48) | 0;
 getTempRet0() | 0;
 i5 = _bitshift64Lshr(i11 | 0, i12 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i7 = i11 & 65535;
 do if ((i11 & 983040 | 0) == 65536 & 0 == 0) {
  if (i7 >>> 0 >= (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
  if ((HEAP32[(HEAP32[i10 + 48 >> 2] | 0) + (i7 * 104 | 0) + 92 >> 2] | 0) == (i1 | 0)) {
   i8 = i10 + 16 | 0;
   i9 = i10 + 20 | 0;
   break;
  } else {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
 } else {
  i8 = i10 + 16 | 0;
  if (i5 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
  i9 = i10 + 20 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i6 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i1 | 0)) {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
  i1 = HEAP32[i6 + (i5 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
  if (i7 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i47 = -2147483640;
   STACKTOP = i48;
   return i47 | 0;
  }
 } while (0);
 i40 = i45 + 8 | 0;
 i41 = i44 + 8 | 0;
 i30 = i34 + 128 | 0;
 i31 = i10 + 36 | 0;
 i32 = i10 + 36 | 0;
 i33 = i10 + 44 | 0;
 i29 = i10 + 48 | 0;
 f3 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 i23 = 0;
 i24 = 1073741824;
 i7 = i11;
 i6 = i12;
 i37 = i11;
 i38 = i12;
 L27 : while (1) {
  if ((i37 | 0) == 0 & (i38 | 0) == 0 | (i37 & 983040 | 0) == 65536 & 0 == 0) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  i13 = _bitshift64Lshr(i37 | 0, i38 | 0, 20) | 0;
  getTempRet0() | 0;
  i13 = i13 & 268435455;
  i22 = i37 & 65535;
  i26 = HEAP32[i8 >> 2] | 0;
  if (i13 >>> 0 >= i26 >>> 0) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  i28 = _bitshift64Lshr(i37 | 0, i38 | 0, 48) | 0;
  getTempRet0() | 0;
  i27 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i27 + (i13 * 56 | 0) + 4 >> 2] | 0) != (i28 | 0)) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  i1 = HEAP32[i27 + (i13 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  if (i22 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  i12 = HEAP32[i27 + (i13 * 56 | 0) + 16 >> 2] | 0;
  i25 = HEAP8[i12 + (i22 << 5) + 28 >> 0] | 0;
  i28 = i25 & 255;
  if (!(i25 << 24 >> 24)) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  i5 = HEAP32[i27 + (i13 * 56 | 0) + 20 >> 2] | 0;
  i1 = 0;
  do {
   i25 = i39 + (i1 * 3 << 2) | 0;
   i11 = i5 + ((HEAPU16[i12 + (i22 << 5) + (i1 << 1) >> 1] | 0) * 3 << 2) | 0;
   HEAP32[i25 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i28 | 0));
  f21 = Math_fround(HEAPF32[i45 >> 2]);
  f20 = Math_fround(HEAPF32[i44 >> 2]);
  f21 = Math_fround(f21 - f20);
  f19 = Math_fround(HEAPF32[i40 >> 2]);
  f18 = Math_fround(HEAPF32[i41 >> 2]);
  f19 = Math_fround(f19 - f18);
  f4 = Math_fround(0.0);
  f17 = Math_fround(1.0);
  i5 = i28 + -1 | 0;
  i11 = 0;
  i10 = -1;
  L38 : while (1) {
   i1 = i39 + (i11 * 3 << 2) | 0;
   i25 = i39 + (i5 * 3 << 2) | 0;
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f49 = Math_fround(HEAPF32[i25 >> 2]);
   f16 = Math_fround(f16 - f49);
   f15 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i25 + 8 >> 2]);
   f15 = Math_fround(f15 - f14);
   f14 = Math_fround(Math_fround(Math_fround(f20 - f49) * f15) - Math_fround(f16 * Math_fround(f18 - f14)));
   f15 = Math_fround(Math_fround(f19 * f16) - Math_fround(f21 * f15));
   do if (Math_fround(Math_abs(Math_fround(f15))) < Math_fround(9.99999993e-09)) if (f14 < Math_fround(0.0)) {
    i1 = i11;
    f14 = f17;
    i25 = i10;
    break L38;
   } else {
    f14 = f17;
    i5 = i10;
   } else {
    f16 = Math_fround(f14 / f15);
    if (f15 < Math_fround(0.0)) {
     if (!(f16 > f4)) {
      f14 = f17;
      i5 = i10;
      break;
     }
     if (f16 > f17) {
      i1 = i11;
      f14 = f17;
      i25 = i10;
      break L38;
     } else {
      f14 = f17;
      i5 = i10;
      f4 = f16;
      break;
     }
    } else {
     if (!(f16 < f17)) {
      f14 = f17;
      i5 = i10;
      break;
     }
     if (f16 < f4) {
      i1 = i11;
      f14 = f16;
      i25 = i5;
      break L38;
     } else {
      f14 = f16;
      break;
     }
    }
   } while (0);
   i1 = i11 + 1 | 0;
   if ((i1 | 0) < (i28 | 0)) {
    i25 = i11;
    f17 = f14;
    i11 = i1;
    i10 = i5;
    i5 = i25;
   } else {
    i25 = i5;
    break;
   }
  }
  if ((i1 | 0) != (i28 | 0) & (i25 | 0) != -1) {
   i9 = i23;
   i8 = i24;
   i5 = i37;
   i1 = i38;
   break;
  }
  if (f14 > f3) {
   f16 = Math_fround(f14 - f3);
   f15 = f14;
   f16 = Math_fround(f2 + Math_fround(f16 * Math_fround(HEAPF32[i34 + ((HEAPU8[i12 + (i22 << 5) + 29 >> 0] | 0) << 2) >> 2])));
  } else {
   f15 = f3;
   f16 = f2;
  }
  if ((i23 | 0) < (i36 | 0)) {
   i12 = i35 + (i23 << 3) | 0;
   HEAP32[i12 >> 2] = i37;
   HEAP32[i12 + 4 >> 2] = i38;
   i23 = i23 + 1 | 0;
  } else i24 = i24 | 16;
  if ((i25 | 0) == -1) {
   f3 = Math_fround(1.0);
   f2 = f16;
   i9 = i23;
   i8 = i24;
   i7 = i37;
   i6 = i38;
   i5 = i37;
   i1 = i38;
   break;
  }
  i1 = HEAP32[(HEAP32[i27 + (i13 * 56 | 0) + 12 >> 2] | 0) + (i22 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i5 = 0;
   i1 = 0;
   i42 = 60;
   break;
  }
  i1 = (HEAP32[i31 >> 2] | 0) + (i1 << 4) | 0;
  if (!i1) {
   i5 = 0;
   i1 = 0;
   i42 = 60;
   break;
  }
  f3 = Math_fround(f18 + Math_fround(f14 * f19));
  f2 = Math_fround(f20 + Math_fround(f14 * f21));
  i10 = i1;
  L61 : while (1) {
   i1 = i10;
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   L63 : do if (!((i5 & 983040 | 0) == 65536 & 0 == 0)) {
    i13 = i10 + 12 | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i11 = i6 >>> 16 & 255;
    i12 = i6 >>> 24 & 255;
    i13 = (HEAPU16[i13 >> 1] | 0) >>> 8 & 255;
    if ((i6 & 255 | 0) == (i25 | 0)) {
     if ((i6 & 65280 | 0) == 65280) break L61;
     if (i11 << 24 >> 24 == 0 & i12 << 24 >> 24 == -1) break L61;
     i6 = i6 & 255;
     i7 = i6 + 1 | 0;
     i6 = i39 + (i6 * 3 << 2) | 0;
     i7 = i39 + (((i7 | 0) == (i28 | 0) ? 0 : i7 * 3 | 0) << 2) | 0;
     switch (i13 << 24 >> 24) {
     case 4:
     case 0:
      {
       f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
       f49 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) - f20);
       f21 = Math_fround(f20 + Math_fround(f49 * Math_fround(Math_fround(i11 & 255) * Math_fround(.00392156886))));
       i13 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
       f49 = Math_fround(f20 + Math_fround(f49 * Math_fround(Math_fround(i12 & 255) * Math_fround(.00392156886))));
       i22 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
       i12 = f21 > f49;
       if (!(f3 >= (HEAP32[tempDoublePtr >> 2] = i12 ? i22 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2]))) | !(f3 <= (HEAP32[tempDoublePtr >> 2] = i12 ? i13 : i22, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break L63; else break L61;
      }
     case 6:
     case 2:
      {
       f20 = Math_fround(HEAPF32[i6 >> 2]);
       f49 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f20);
       f21 = Math_fround(f20 + Math_fround(f49 * Math_fround(Math_fround(i11 & 255) * Math_fround(.00392156886))));
       i13 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
       f49 = Math_fround(f20 + Math_fround(f49 * Math_fround(Math_fround(i12 & 255) * Math_fround(.00392156886))));
       i22 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
       i12 = f21 > f49;
       if (!(f2 >= (HEAP32[tempDoublePtr >> 2] = i12 ? i22 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2]))) | !(f2 <= (HEAP32[tempDoublePtr >> 2] = i12 ? i13 : i22, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break L63; else break L61;
      }
     default:
      break L63;
     }
    }
   } while (0);
   i1 = HEAP32[i10 + 8 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i5 = 0;
    i1 = 0;
    i42 = 60;
    break L27;
   }
   i10 = (HEAP32[i32 >> 2] | 0) + (i1 << 4) | 0;
   if (!i10) {
    i5 = 0;
    i1 = 0;
    i42 = 60;
    break L27;
   }
  }
  if ((i5 | 0) == 0 & (i1 | 0) == 0) {
   i5 = 0;
   i1 = 0;
   i42 = 60;
   break;
  }
  do if ((i5 & 983040 | 0) == 65536 & 0 == 0) {
   i6 = i5 & 65535;
   if (i6 >>> 0 > (HEAP32[i33 >> 2] | 0) >>> 0) i6 = 0; else {
    i27 = _bitshift64Lshr(i5 | 0, i1 | 0, 48) | 0;
    getTempRet0() | 0;
    i7 = HEAP32[i29 >> 2] | 0;
    if ((i7 + (i6 * 104 | 0) | 0) == 0 ? 1 : (i27 | 0) != (HEAP32[i7 + (i6 * 104 | 0) + 92 >> 2] | 0)) {
     i6 = 0;
     break;
    }
    i6 = HEAP32[i7 + (i6 * 104 | 0) + 76 >> 2] | 0;
   }
  } else {
   i7 = _bitshift64Lshr(i5 | 0, i1 | 0, 20) | 0;
   getTempRet0() | 0;
   i7 = i7 & 268435455;
   i10 = i5 & 65535;
   if (i7 >>> 0 < i26 >>> 0) {
    i26 = _bitshift64Lshr(i5 | 0, i1 | 0, 48) | 0;
    getTempRet0() | 0;
    if ((HEAP32[i27 + (i7 * 56 | 0) + 4 >> 2] | 0) != (i26 | 0)) {
     i6 = 0;
     break;
    }
    i6 = HEAP32[i27 + (i7 * 56 | 0) + 8 >> 2] | 0;
    if (!i6) {
     i6 = 0;
     break;
    }
    if (i10 >>> 0 >= (HEAP32[i6 + 20 >> 2] | 0) >>> 0) {
     i6 = 0;
     break;
    }
    i6 = HEAP32[(HEAP32[i27 + (i7 * 56 | 0) + 16 >> 2] | 0) + (i10 << 5) + 24 >> 2] | 0;
   } else i6 = 0;
  } while (0);
  if (!(HEAP32[i30 >> 2] & i6)) {
   i42 = 60;
   break;
  } else {
   i6 = i38;
   i7 = i37;
   f3 = f15;
   f2 = f16;
   i37 = i5;
   i38 = i1;
  }
 }
 if ((i42 | 0) == 60) {
  i36 = i25 + 1 | 0;
  i42 = i39 + (i25 * 3 << 2) | 0;
  i39 = i39 + (((i36 | 0) < (i28 | 0) ? i36 * 3 | 0 : 0) << 2) | 0;
  f2 = Math_fround(HEAPF32[i39 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i42 >> 2]));
  f3 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i42 + 8 >> 2]));
  f4 = Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3));
  if (f4 > Math_fround(0.0)) {
   f49 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
   HEAPF32[i46 + 4 >> 2] = Math_fround(f3 * f49);
   HEAPF32[i46 + 8 >> 2] = Math_fround(-Math_fround(f2 * f49));
   f3 = f15;
   f2 = f16;
   i9 = i23;
   i8 = i24;
   i7 = i37;
   i6 = i38;
  } else {
   f3 = f15;
   f2 = f16;
   i9 = i23;
   i8 = i24;
   i7 = i37;
   i6 = i38;
  }
 }
 HEAPF32[i46 >> 2] = f3;
 f20 = Math_fround(HEAPF32[i45 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i44 >> 2]));
 f21 = Math_fround(HEAPF32[i45 + 4 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i44 + 4 >> 2]));
 f49 = Math_fround(HEAPF32[i40 >> 2]);
 f49 = Math_fround(f49 - Math_fround(HEAPF32[i41 >> 2]));
 HEAPF32[i46 + 12 >> 2] = Math_fround(f2 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f49 * f49)))));
 i45 = i46 + 16 | 0;
 HEAP32[i45 >> 2] = i7;
 HEAP32[i45 + 4 >> 2] = i6;
 i46 = i46 + 24 | 0;
 HEAP32[i46 >> 2] = i5;
 HEAP32[i46 + 4 >> 2] = i1;
 if (i43) HEAP32[i47 >> 2] = i9;
 i47 = i8;
 STACKTOP = i48;
 return i47 | 0;
}

function __ZNK6Avatar9GetZYRollEiRK8Vector3f(i20, i5, i10, i12) {
 i20 = i20 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i11 = HEAP32[i5 + 56 >> 2] | 0;
 L1 : do if ((i10 | 0) < 0) {
  f1 = Math_fround(0.0);
  f2 = Math_fround(1.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else {
  do if ((i10 | 0) < 24) {
   i5 = i11 + 20 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if (!i6) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break L1;
   }
   i7 = i6 + i5 | 0;
   i19 = i7 + 40 | 0;
   if (!(HEAP32[(HEAP32[i19 >> 2] | 0) + i19 >> 2] | 0)) i9 = 8; else {
    i7 = i7 + 72 + (i10 << 2) | 0;
    i5 = i6;
   }
  } else {
   if ((i10 | 0) < 39) {
    i5 = i11 + 20 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if (!i6) {
     f1 = Math_fround(0.0);
     f2 = Math_fround(1.0);
     f3 = Math_fround(0.0);
     f4 = Math_fround(0.0);
     break L1;
    } else {
     i9 = 8;
     break;
    }
   }
   if ((i10 | 0) >= 54) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break L1;
   }
   i5 = i11 + 20 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if (!i6) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break L1;
   } else i9 = 13;
  } while (0);
  if ((i9 | 0) == 8) {
   i7 = i5 + i6 | 0;
   i19 = i7 + 40 | 0;
   if (!(HEAP32[i19 + (HEAP32[i19 >> 2] | 0) >> 2] | 0)) i9 = 13; else {
    i7 = i7 + 48 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    if (!i8) i9 = 13; else {
     i7 = i8 + i7 + (i10 + -24 << 2) | 0;
     i5 = i6;
    }
   }
  }
  if ((i9 | 0) == 13) {
   i5 = i5 + i6 | 0;
   i19 = i5 + 40 | 0;
   if (!(HEAP32[i19 + (HEAP32[i19 >> 2] | 0) >> 2] | 0)) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break;
   }
   i5 = i5 + 52 | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   if (!i7) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break;
   }
   i7 = i7 + i5 + (i10 + -39 << 2) | 0;
   i5 = i6;
  }
  i6 = HEAP32[i7 >> 2] | 0;
  if ((i6 | 0) == -1) {
   f1 = Math_fround(0.0);
   f2 = Math_fround(1.0);
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
  } else {
   i5 = i5 + (i11 + 20) + 40 | 0;
   i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
   i19 = i5 + 4 | 0;
   i19 = HEAP32[i19 + (HEAP32[i19 >> 2] | 0) + (i6 << 3) + 4 >> 2] | 0;
   if ((i19 | 0) == -1) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
   } else {
    i18 = i5 + 16 | 0;
    i18 = (HEAP32[i18 >> 2] | 0) + i18 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    i16 = HEAP32[i12 + 4 >> 2] | 0;
    i17 = HEAP32[i12 + 8 >> 2] | 0;
    f23 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 44 >> 2]);
    f22 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 48 >> 2]);
    f21 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 52 >> 2]);
    i5 = f23 > Math_fround(0.0);
    i7 = f22 > Math_fround(0.0);
    i9 = f21 > Math_fround(0.0);
    f14 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(-Math_fround(f14 * f23));
    f2 = Math_fround(-Math_fround(f15 * f22));
    f3 = Math_fround(-Math_fround(f4 * f21));
    i12 = f23 < Math_fround(0.0);
    i6 = f22 < Math_fround(0.0);
    i8 = f21 < Math_fround(0.0);
    i12 = i12 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i13 : 0;
    i11 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i7 ? i16 : 0;
    i8 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i17 : 0;
    f21 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 56 >> 2]);
    f22 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 60 >> 2]);
    f23 = Math_fround(HEAPF32[i18 + (i19 * 76 | 0) + 64 >> 2]);
    i5 = f21 < Math_fround(0.0);
    i6 = f22 < Math_fround(0.0);
    i9 = f23 < Math_fround(0.0);
    f1 = Math_fround(f14 * f21);
    f2 = Math_fround(f15 * f22);
    f3 = Math_fround(f4 * f23);
    i24 = f21 > Math_fround(0.0);
    i7 = f22 > Math_fround(0.0);
    i10 = f23 > Math_fround(0.0);
    i5 = i24 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i5 ? i13 : 0;
    i16 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i6 ? i16 : 0;
    i6 = f14 < Math_fround(0.0);
    i13 = f15 < Math_fround(0.0);
    i24 = f4 < Math_fround(0.0);
    i6 = i6 ? i12 : i5;
    i5 = i13 ? i11 : i16;
    i16 = i24 ? i8 : i10 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i9 ? i17 : 0;
    f14 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = Math_fround(Math_fround(Math_abs(Math_fround(f14))) + Math_fround(3.14159274));
    f26 = Math_fround(Math_fround(Math_abs(Math_fround(f26))) + Math_fround(3.14159274));
    f2 = Math_fround(Math_fround(Math_abs(Math_fround((HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]))))) + Math_fround(3.14159274));
    f25 = Math_fround(f26 / Math_fround(6.28318548));
    f21 = Math_fround(f2 / Math_fround(6.28318548));
    f22 = Math_fround(_truncf(Math_fround(f14 / Math_fround(6.28318548))));
    f25 = Math_fround(_truncf(f25));
    f22 = Math_fround(Math_fround(f14 - Math_fround(f22 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
    f25 = Math_fround(Math_fround(f26 - Math_fround(f25 * Math_fround(6.28318548))) + Math_fround(-3.14159274));
    f21 = Math_fround(Math_fround(f2 - Math_fround(Math_fround(_truncf(f21)) * Math_fround(6.28318548))) + Math_fround(-3.14159274));
    i24 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) ^ i6 & -2147483648;
    i17 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) ^ i5 & -2147483648;
    i16 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) ^ i16 & -2147483648;
    f21 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = Math_fround(f25 * Math_fround(.5));
    f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
    f21 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f21 * Math_fround(.5)), Math_fround(-1.57079542))), Math_fround(1.57079542)));
    f25 = Math_fround(_fminf(Math_fround(_fmaxf(f25, Math_fround(-1.57079542))), Math_fround(1.57079542)));
    f21 = Math_fround(f21 * Math_fround(.159154937));
    f25 = Math_fround(f25 * Math_fround(.159154937));
    f22 = Math_fround(Math_fround(_fminf(Math_fround(_fmaxf(f22, Math_fround(-1.57079542))), Math_fround(1.57079542))) * Math_fround(.159154937));
    f2 = Math_fround(+_roundf(+f21));
    f26 = Math_fround(+_roundf(+f25));
    f2 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f21 - f2))));
    f26 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f25 - f26))));
    f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f22 - Math_fround(+_roundf(+f22))))));
    f23 = Math_fround(f2 * f2);
    f4 = Math_fround(f26 * f26);
    f1 = Math_fround(f14 * f14);
    f15 = Math_fround(f23 * f23);
    f3 = Math_fround(f4 * f4);
    f27 = Math_fround(f1 * f1);
    f23 = Math_fround(f2 * Math_fround(Math_fround(Math_fround(f15 * f15) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f23 * Math_fround(41.3416595))) + Math_fround(f15 * Math_fround(Math_fround(81.6018218) - Math_fround(f23 * Math_fround(76.5686187)))))));
    f4 = Math_fround(f26 * Math_fround(Math_fround(Math_fround(f3 * f3) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f3 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
    f1 = Math_fround(f14 * Math_fround(Math_fround(Math_fround(f27 * f27) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f1 * Math_fround(41.3416595))) + Math_fround(f27 * Math_fround(Math_fround(81.6018218) - Math_fround(f1 * Math_fround(76.5686187)))))));
    f21 = Math_fround(f21 + Math_fround(-.25));
    f25 = Math_fround(f25 + Math_fround(-.25));
    f22 = Math_fround(f22 + Math_fround(-.25));
    f27 = Math_fround(+_roundf(+f21));
    f14 = Math_fround(+_roundf(+f25));
    f27 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f21 - f27))));
    f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f25 - f14))));
    f22 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f22 - Math_fround(+_roundf(+f22))))));
    f25 = Math_fround(f27 * f27);
    f21 = Math_fround(f14 * f14);
    f3 = Math_fround(f22 * f22);
    f26 = Math_fround(f25 * f25);
    f15 = Math_fround(f21 * f21);
    f2 = Math_fround(f3 * f3);
    f23 = Math_fround(Math_fround(f27 * Math_fround(Math_fround(Math_fround(f26 * f26) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f25 * Math_fround(41.3416595))) + Math_fround(f26 * Math_fround(Math_fround(81.6018218) - Math_fround(f25 * Math_fround(76.5686187))))))) / f23);
    f4 = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f15 * f15) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f21 * Math_fround(41.3416595))) + Math_fround(f15 * Math_fround(Math_fround(81.6018218) - Math_fround(f21 * Math_fround(76.5686187))))))) / f4);
    f1 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f2 * f2) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f2 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187))))))) / f1);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i19 * 76 | 0) + 32 >> 2] & -2147483648;
    i17 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i19 * 76 | 0) + 36 >> 2] & -2147483648;
    i24 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) ^ HEAP32[i18 + (i19 * 76 | 0) + 40 >> 2] & -2147483648;
    f1 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(f4 + Math_fround(f1 * f23));
    f4 = Math_fround(f23 - Math_fround(f1 * f4));
    f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(1.0)) + Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3))))));
    f1 = Math_fround(f23 * f1);
    f2 = f23;
    f3 = Math_fround(f23 * f3);
    f4 = Math_fround(f23 * f4);
   }
  }
 } while (0);
 f27 = Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2)));
 f22 = Math_fround(Math_sqrt(Math_fround(f27)));
 f23 = Math_fround(f1 / f22);
 f25 = Math_fround(f3 / f22);
 f26 = Math_fround(f4 / f22);
 f1 = Math_fround(f2 / f22);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f27 > Math_fround(1.0e-30);
 i24 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i20 >> 2] = i8 ? i5 : 0;
 HEAP32[i20 + 4 >> 2] = i8 ? i6 : 0;
 HEAP32[i20 + 8 >> 2] = i8 ? i7 : 0;
 HEAP32[i20 + 12 >> 2] = i24;
 return;
}

function _sfnt_load_face(i8, i19, i1, i4, i5) {
 i8 = i8 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 28 | 0;
 i16 = i18;
 i15 = HEAP32[i19 + 532 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i2 = 0;
  i1 = 0;
  i3 = 0;
  do {
   i13 = HEAP32[i5 + (i3 << 3) >> 2] | 0;
   i14 = (i13 | 0) == 1768386662;
   i1 = i14 ? i1 : (i13 | 0) == 1768386675 ? 1 : i1;
   i2 = i14 ? 1 : i2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
  i6 = i1;
 } else {
  i2 = 0;
  i6 = 0;
 }
 if (!(_UNITY_tt_face_lookup_table(i19, 1735162214) | 0)) i1 = (_UNITY_tt_face_lookup_table(i19, 1128678944) | 0) != 0; else i1 = 1;
 i3 = (mftCall_iiiii(HEAP32[i19 + 508 >> 2] | 0, i19 | 0, 1935829368, i8 | 0, 0) | 0) == 0;
 i4 = i3 ? 0 : i1 & 1;
 if (!(i4 << 24 >> 24)) {
  i1 = HEAP32[i15 + 68 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i9 = 8;
  } else {
   i1 = mftCall_iii(i1 | 0, i19 | 0, i8 | 0) | 0;
   HEAP32[i17 >> 2] = i1;
   i1 = (i1 | 0) == 0;
   if (i3 | i1 ^ 1) i9 = 8;
  }
 } else {
  i1 = 0;
  i9 = 8;
 }
 if ((i9 | 0) == 8) {
  i14 = mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, i19 | 0, i8 | 0) | 0;
  HEAP32[i17 >> 2] = i14;
  if (i14) {
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
 }
 i14 = i19 + 178 | 0;
 if (!(HEAP16[i14 >> 1] | 0)) {
  HEAP32[i17 >> 2] = 8;
  i19 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 mftCall_iii(HEAP32[i15 + 36 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 mftCall_iii(HEAP32[i15 + 32 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 mftCall_iii(HEAP32[i15 + 48 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 i7 = mftCall_iii(HEAP32[i15 + 44 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 HEAP32[i17 >> 2] = i7;
 if (!i1) {
  i3 = i15 + 28 | 0;
  i1 = mftCall_iiii(HEAP32[i3 >> 2] | 0, i19 | 0, i8 | 0, 0) | 0;
  HEAP32[i17 >> 2] = i1;
  do if (!i1) {
   i13 = mftCall_iiii(HEAP32[i15 + 92 >> 2] | 0, i19 | 0, i8 | 0, 0) | 0;
   i13 = (i13 & 255 | 0) == 142 ? 147 : i13;
   HEAP32[i17 >> 2] = i13;
   if (i13) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  } else {
   if ((i1 & 255 | 0) != 142) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
   if ((HEAP32[i19 + 148 >> 2] | 0) == 1953658213) {
    HEAP32[i17 >> 2] = 0;
    i4 = 0;
    break;
   }
   HEAP32[i17 >> 2] = 143;
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  } while (0);
  i1 = mftCall_iiii(HEAP32[i3 >> 2] | 0, i19 | 0, i8 | 0, 1) | 0;
  HEAP32[i17 >> 2] = i1;
  if (!i1) {
   i1 = mftCall_iiii(HEAP32[i15 + 92 >> 2] | 0, i19 | 0, i8 | 0, 1) | 0;
   HEAP32[i17 >> 2] = i1;
   if (!i1) HEAP8[i19 + 292 >> 0] = 1; else i9 = 21;
  } else i9 = 21;
  if ((i9 | 0) == 21) if (!((i1 | 0) == 0 | (i1 & 255 | 0) == 142)) {
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
  i13 = mftCall_iii(HEAP32[i15 + 40 >> 2] | 0, i19 | 0, i8 | 0) | 0;
  HEAP32[i17 >> 2] = i13;
  if (i13) HEAP16[i19 + 364 >> 1] = -1;
 }
 i1 = HEAP32[i15 + 96 >> 2] | 0;
 do if (i1 | 0) {
  i1 = mftCall_iii(i1 | 0, i19 | 0, i8 | 0) | 0;
  HEAP32[i17 >> 2] = i1;
  if (i1 | 0) if ((i1 & 255 | 0) == 142) {
   HEAP32[i17 >> 2] = 0;
   break;
  } else {
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
 } while (0);
 i1 = mftCall_iii(HEAP32[i15 + 64 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 HEAP32[i17 >> 2] = i1;
 do if (i1 | 0) if ((i1 & 255 | 0) == 142) {
  HEAP32[i19 + 548 >> 2] = 0;
  break;
 } else {
  i19 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i18;
  return i19 | 0;
 } while (0);
 mftCall_iii(HEAP32[i15 + 60 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 HEAP32[i17 >> 2] = mftCall_iii(HEAP32[i15 + 56 >> 2] | 0, i19 | 0, i8 | 0) | 0;
 HEAP32[i19 + 16 >> 2] = HEAPU16[i19 + 264 >> 1];
 i3 = i19 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i19 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 i13 = i19 + 364 | 0;
 if ((HEAP16[i13 >> 1] | 0) == -1) i9 = 41; else if (!(HEAP16[i19 + 428 >> 1] & 256)) i9 = 41; else {
  do if (!(i2 << 24 >> 24)) {
   i12 = _UNITY_tt_face_get_name(i19, 16, i3) | 0;
   HEAP32[i17 >> 2] = i12;
   if (!i12) if (!(HEAP32[i3 >> 2] | 0)) {
    i9 = 36;
    break;
   } else break; else {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  } else i9 = 36; while (0);
  if ((i9 | 0) == 36) {
   i12 = _UNITY_tt_face_get_name(i19, 1, i3) | 0;
   HEAP32[i17 >> 2] = i12;
   if (i12 | 0) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
  if (!(i6 << 24 >> 24)) {
   i12 = _UNITY_tt_face_get_name(i19, 17, i5) | 0;
   HEAP32[i17 >> 2] = i12;
   if (i12 | 0) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
  if (!(HEAP32[i5 >> 2] | 0)) {
   i12 = _UNITY_tt_face_get_name(i19, 2, i5) | 0;
   HEAP32[i17 >> 2] = i12;
   if (i12 | 0) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
 }
 if ((i9 | 0) == 41) {
  i12 = _UNITY_tt_face_get_name(i19, 21, i3) | 0;
  HEAP32[i17 >> 2] = i12;
  if (i12 | 0) {
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  do if (!(i2 << 24 >> 24 != 0 | (i1 | 0) != 0)) {
   i12 = _UNITY_tt_face_get_name(i19, 16, i3) | 0;
   HEAP32[i17 >> 2] = i12;
   if (!i12) {
    i1 = HEAP32[i3 >> 2] | 0;
    break;
   } else {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  } while (0);
  if (!i1) {
   i12 = _UNITY_tt_face_get_name(i19, 1, i3) | 0;
   HEAP32[i17 >> 2] = i12;
   if (i12 | 0) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
  i12 = _UNITY_tt_face_get_name(i19, 22, i5) | 0;
  HEAP32[i17 >> 2] = i12;
  if (i12 | 0) {
   i19 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  do if (!(i6 << 24 >> 24 != 0 | (i1 | 0) != 0)) {
   i12 = _UNITY_tt_face_get_name(i19, 17, i5) | 0;
   HEAP32[i17 >> 2] = i12;
   if (!i12) {
    i1 = HEAP32[i5 >> 2] | 0;
    break;
   } else {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  } while (0);
  if (!i1) {
   i12 = _UNITY_tt_face_get_name(i19, 2, i5) | 0;
   HEAP32[i17 >> 2] = i12;
   if (i12 | 0) {
    i19 = HEAP32[i17 >> 2] | 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
 }
 i11 = i19 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i4 << 24 >> 24 == 1;
 i2 = ((HEAP32[i19 + 732 >> 2] & -2 | 0) == 2 ? i2 | 16384 : i2) | i3 & 1;
 i1 = i2 | 24;
 if (!i7) i1 = (HEAP32[i19 + 468 >> 2] | 0) == 196608 ? i1 : i2 | 536;
 i1 = (HEAP32[i19 + 480 >> 2] | 0) == 0 ? i1 : i1 | 4;
 i12 = i19 + 292 | 0;
 i1 = (HEAP8[i12 >> 0] | 0) == 0 ? i1 : i1 | 32;
 i1 = (HEAP32[i19 + 752 >> 2] | 0) == 0 ? i1 : i1 | 64;
 if (_UNITY_tt_face_lookup_table(i19, 1735162214) | 0) if (_UNITY_tt_face_lookup_table(i19, 1719034226) | 0) {
  i10 = (_UNITY_tt_face_lookup_table(i19, 1735811442) | 0) == 0;
  i1 = i10 ? i1 : i1 | 256;
 }
 HEAP32[i11 >> 2] = i1;
 if (i3) if ((HEAP16[i13 >> 1] | 0) == -1) i9 = 61; else {
  i1 = HEAP16[i19 + 428 >> 1] | 0;
  i10 = i1 & 65535;
  i1 = ((i10 & 512 | 0) == 0 ? i10 & 1 : 1) | (i1 & 65535) >>> 4 & 2;
 } else i9 = 61;
 if ((i9 | 0) == 61) {
  i1 = HEAP16[i19 + 204 >> 1] | 0;
  i1 = (i1 & 65535) >>> 1 & 1 | (i1 & 1) << 1;
 }
 i4 = i19 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i1;
 _UNITY_tt_face_build_cmaps(i19) | 0;
 i4 = HEAP32[i19 + 36 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i19 + 40 >> 2] | 0;
  i3 = 0;
  do {
   i6 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[i6 + 8 >> 2] | 0;
   i1 = i2 & 65535;
   i2 = i2 >>> 16 & 65535;
   L117 : do if (i1 << 16 >> 16 == 2) {
    i1 = gb + 185880 | 0;
    i9 = 65;
   } else {
    switch (i1 << 16 >> 16) {
    case 0:
     {
      i1 = gb + 185880 + 12 | 0;
      i9 = 65;
      break L117;
     }
    case 1:
     if (!(i2 << 16 >> 16)) {
      i1 = gb + 185880 + 24 | 0;
      i9 = 65;
      break L117;
     } else {
      i1 = 0;
      break L117;
     }
    case 3:
     break;
    default:
     {
      i1 = 0;
      break L117;
     }
    }
    if (!(i2 << 16 >> 16)) {
     i1 = gb + 185880 + 36 | 0;
     i9 = 65;
    } else if (i2 << 16 >> 16 == 10) {
     i1 = gb + 185880 + 48 | 0;
     i9 = 65;
    } else if (i2 << 16 >> 16 == 1) {
     i1 = gb + 185880 + 60 | 0;
     i9 = 65;
    } else if (i2 << 16 >> 16 == 2) {
     i1 = gb + 185880 + 72 | 0;
     i9 = 65;
    } else {
     if (i2 << 16 >> 16 == 3) {
      i1 = gb + 185880 + 84 | 0;
      i9 = 65;
      break;
     }
     if (i2 << 16 >> 16 == 4) {
      i1 = gb + 185880 + 96 | 0;
      i9 = 65;
      break;
     }
     if (i2 << 16 >> 16 == 5) {
      i1 = gb + 185880 + 108 | 0;
      i9 = 65;
      break;
     }
     if (i2 << 16 >> 16 == 6) {
      i1 = gb + 185880 + 120 | 0;
      i9 = 65;
     } else i1 = 0;
    }
   } while (0);
   if ((i9 | 0) == 65) {
    i9 = 0;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i6 + 4 >> 2] = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i4 | 0));
 }
 i10 = HEAP32[i19 + 736 >> 2] | 0;
 L133 : do if (!i10) i1 = HEAP32[i11 >> 2] | 0; else {
  i3 = HEAP32[(HEAP32[i19 + 104 >> 2] | 0) + 28 >> 2] | 0;
  i2 = HEAP16[i14 >> 1] | 0;
  i1 = HEAP16[i19 + 366 >> 1] | 0;
  if (!(i2 << 16 >> 16)) i9 = 81; else if ((HEAP16[i13 >> 1] | 0) == -1) i9 = 81;
  if ((i9 | 0) == 81) {
   i1 = 1;
   i2 = 1;
  }
  i6 = _UNITY_ft_mem_realloc(i3, 16, 0, i10, 0, i17) | 0;
  i9 = i19 + 32 | 0;
  HEAP32[i9 >> 2] = i6;
  L141 : do if (!(HEAP32[i17 >> 2] | 0)) {
   i7 = i15 + 108 | 0;
   i8 = i16 + 20 | 0;
   i4 = i1 << 16 >> 16;
   i5 = i2 & 65535;
   i3 = (i2 & 65535) >>> 1 & 65535;
   i15 = mftCall_iiii(HEAP32[i7 >> 2] | 0, i19 | 0, 0, i16 | 0) | 0;
   HEAP32[i17 >> 2] = i15;
   if (!i15) {
    i2 = 0;
    i1 = i6;
    while (1) {
     HEAP16[i1 + (i2 << 4) >> 1] = (HEAP32[i8 >> 2] | 0) >>> 6;
     i15 = HEAP32[i16 >> 2] | 0;
     i6 = i15 & 65535;
     HEAP16[i1 + (i2 << 4) + 2 >> 1] = ((Math_imul(i6, i4) | 0) + i3 | 0) / (i5 | 0) | 0;
     HEAP32[i1 + (i2 << 4) + 8 >> 2] = i6 << 6;
     i15 = i15 >>> 16 << 6;
     HEAP32[i1 + (i2 << 4) + 12 >> 2] = i15;
     HEAP32[i1 + (i2 << 4) + 4 >> 2] = i15;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i10 >>> 0) break;
     i1 = HEAP32[i9 >> 2] | 0;
     i15 = mftCall_iiii(HEAP32[i7 >> 2] | 0, i19 | 0, i2 | 0, i16 | 0) | 0;
     HEAP32[i17 >> 2] = i15;
     if (i15 | 0) break L141;
    }
    i1 = HEAP32[i11 >> 2] | 2;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i19 + 28 >> 2] = i10;
    break L133;
   }
  } while (0);
  i19 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i18;
  return i19 | 0;
 } while (0);
 if (!(i1 & 3)) {
  i1 = i1 | 1;
  HEAP32[i11 >> 2] = i1;
 }
 if (!(i1 & 1)) {
  i19 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 i15 = HEAP32[i19 + 196 >> 2] | 0;
 HEAP32[i19 + 52 >> 2] = i15 << 16 >> 16;
 HEAP32[i19 + 56 >> 2] = i15 >> 16;
 i15 = HEAP32[i19 + 200 >> 2] | 0;
 HEAP32[i19 + 60 >> 2] = i15 << 16 >> 16;
 HEAP32[i19 + 64 >> 2] = i15 >> 16;
 HEAP16[i19 + 68 >> 1] = HEAP16[i14 >> 1] | 0;
 i15 = HEAP32[i19 + 220 >> 2] | 0;
 i4 = i19 + 70 | 0;
 HEAP16[i4 >> 1] = i15;
 i16 = i15 >>> 16;
 i5 = i19 + 72 | 0;
 HEAP16[i5 >> 1] = i16;
 i7 = HEAP32[i19 + 224 >> 2] | 0;
 i1 = i15 - i16 + i7 | 0;
 i6 = i19 + 74 | 0;
 HEAP16[i6 >> 1] = i1;
 i7 = i7 >>> 16 & 65535;
 do if (!(((i15 | i16) & 65535) << 16 >> 16)) if ((HEAP16[i13 >> 1] | 0) != -1) {
  i1 = HEAP16[i19 + 434 >> 1] | 0;
  i2 = HEAP32[i19 + 436 >> 2] | 0;
  i3 = i2 & 65535;
  if (!((i1 | i3) << 16 >> 16)) {
   i16 = HEAP32[i19 + 440 >> 2] | 0;
   HEAP16[i4 >> 1] = i16;
   i1 = i16 >>> 16;
   HEAP16[i5 >> 1] = 0 - i1;
   i1 = (i16 & 65535) + i1 | 0;
   HEAP16[i6 >> 1] = i1;
   break;
  } else {
   HEAP16[i4 >> 1] = i1;
   HEAP16[i5 >> 1] = i3;
   i1 = (i1 & 65535) - (i2 & 65535) + (i2 >>> 16) | 0;
   HEAP16[i6 >> 1] = i1;
   break;
  }
 } while (0);
 HEAP16[i19 + 76 >> 1] = i7;
 if (!(HEAP8[i12 >> 0] | 0)) i1 = i1 << 16 >> 16; else i1 = HEAPU16[i19 + 306 >> 1] | 0;
 HEAP16[i19 + 78 >> 1] = i1;
 i15 = HEAP32[i19 + 476 >> 2] | 0;
 i16 = i15 >>> 16 & 65535;
 HEAP16[i19 + 80 >> 1] = i15 - (((i16 << 16 >> 16) / 2 | 0) & 65535);
 HEAP16[i19 + 82 >> 1] = i16;
 i19 = HEAP32[i17 >> 2] | 0;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN15MemorySnapshots21CaptureMemorySnapshotER13dynamic_arrayIhLj1EE(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i35 + 16 | 0;
 i32 = i35;
 i19 = i35 + 120 | 0;
 i22 = i35 + 100 | 0;
 i23 = i35 + 80 | 0;
 i26 = i35 + 60 | 0;
 i27 = i35 + 40 | 0;
 i33 = i35 + 24 | 0;
 i34 = __Z33scripting_capture_memory_snapshotv() | 0;
 i13 = i34 + 56 | 0;
 HEAP32[i13 >> 2] = i33;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i4 = i32;
 HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i4 + 4 >> 2] = i20;
 HEAP32[i19 >> 2] = 0;
 i4 = i19 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i20 = i19 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i32);
 i24 = i2;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i28 = i21;
 HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i28 + 4 >> 2] = i25;
 i28 = gb + 64016 | 0;
 i25 = HEAP32[i28 + 4 >> 2] | 0;
 i24 = i32;
 HEAP32[i24 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 i24 = i22 + 16 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i32);
 i28 = i2;
 i29 = HEAP32[i28 + 4 >> 2] | 0;
 i30 = i25;
 HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i30 + 4 >> 2] = i29;
 i30 = gb + 64016 | 0;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i32;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i28 = i23 + 16 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i32);
 i30 = i2;
 i31 = HEAP32[i30 + 4 >> 2] | 0;
 i11 = i29;
 HEAP32[i11 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i11 + 4 >> 2] = i31;
 i11 = gb + 64016 | 0;
 i31 = HEAP32[i11 + 4 >> 2] | 0;
 i30 = i32;
 HEAP32[i30 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i30 + 4 >> 2] = i31;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 i30 = i26 + 16 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i26 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i32);
 i11 = i2;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i16 = i31;
 HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i16 + 4 >> 2] = i10;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 i16 = i32 + 4 | 0;
 HEAP32[i32 >> 2] = i16;
 __Z28CalculateAllObjectReferencesR13dynamic_arrayIP6ObjectLj4EERS_IPKcLj4EERS_IjLj4EES9_b(i19, i22, i23, i26, 1);
 __ZN19RuntimeSceneManager31CollectDontDestroyOnLoadObjectsERNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(__Z15GetSceneManagerv() | 0, i32);
 i10 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i11 = i10 + 4 | 0;
 HEAP32[i11 >> 2] = __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci(i4, 48, 16, gb + 64016 | 0, 0, gb + 462200 | 0, 436) | 0;
 i4 = i34 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i12 = i27 + 12 | 0;
 HEAP32[i12 >> 2] = i3;
 i17 = i27 + 16 | 0;
 HEAP32[i17 >> 2] = i3;
 i18 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 64016 | 0);
 i7 = i2;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i18;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 8, i18, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i27 >> 2] = i3;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  i5 = HEAP32[i34 + 28 >> 2] | 0;
  i1 = 0;
  do {
   i7 = i5 + (i1 << 3) | 0;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3 + (i1 << 4) | 0;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i3 + (i1 << 4) + 8 >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i3, i3 + (HEAP32[i12 >> 2] << 4) | 0, i2);
 if (HEAP32[i10 >> 2] | 0) {
  i7 = 0;
  i8 = 0;
  while (1) {
   i9 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   HEAP32[i9 + (i8 * 48 | 0) + 12 >> 2] = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i5 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2];
   i4 = i9 + (i8 * 48 | 0) + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i9 + (i8 * 48 | 0) + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0;
   HEAP32[i9 + (i8 * 48 | 0) + 36 >> 2] = HEAP32[(HEAP32[i23 >> 2] | 0) + (i8 << 2) >> 2];
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   HEAP32[i9 + (i8 * 48 | 0) >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i6 = i5 + 8 | 0;
   HEAP32[i9 + (i8 * 48 | 0) + 16 >> 2] = (HEAP32[i6 >> 2] | 0) >>> 13 & 127;
   i2 = i9 + (i8 * 48 | 0) + 24 | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = 0;
   i4 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   if (i2 | 0) {
    i1 = i16;
    L11 : while (1) {
     i3 = i2;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >= (i4 | 0)) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L11; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) != (i16 | 0)) {
     i2 = i9 + (i8 * 48 | 0) + 20 | 0;
     if ((i4 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
    }
   }
   i1 = i9 + (i8 * 48 | 0) + 20 | 0;
   if (HEAP32[i6 >> 2] & 1048576 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 2;
   do if ((__Z24GetManagerPtrFromContexti(0) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(1) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(2) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(3) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(4) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(5) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(6) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(7) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(8) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(9) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(10) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(11) | 0) == (i5 | 0)) i14 = 45; else if ((__Z24GetManagerPtrFromContexti(12) | 0) == (i5 | 0)) i14 = 45; else {
    if ((__Z24GetManagerPtrFromContexti(13) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(14) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(15) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(16) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(17) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(18) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(19) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(20) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(21) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(22) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(23) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(24) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(25) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(26) | 0) == (i5 | 0)) {
     i14 = 45;
     break;
    }
    if ((__Z24GetManagerPtrFromContexti(27) | 0) == (i5 | 0)) i14 = 45;
   } while (0);
   if ((i14 | 0) == 45) {
    i14 = 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 4;
   }
   i1 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   if (!i1) i2 = i7; else {
    i4 = __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci(i1, 4, 16, gb + 64016 | 0, 0, gb + 462200 | 0, 479) | 0;
    HEAP32[i9 + (i8 * 48 | 0) + 40 >> 2] = i4;
    i5 = (HEAP32[i23 >> 2] | 0) + (i8 << 2) | 0;
    if (!(HEAP32[i5 >> 2] | 0)) i2 = i7; else {
     i6 = HEAP32[i26 >> 2] | 0;
     i3 = 0;
     i1 = i7;
     while (1) {
      i2 = i1 + 1 | 0;
      HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) break; else i1 = i2;
     }
    }
   }
   i1 = HEAP32[(HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 16 >> 2] | 0;
   if (!i1) HEAP32[i9 + (i8 * 48 | 0) + 32 >> 2] = -1; else {
    i4 = __Z29scripting_gchandle_get_targetj(i1) | 0;
    i5 = HEAP32[i27 >> 2] | 0;
    i6 = HEAP32[i12 >> 2] | 0;
    i1 = i6 << 4 >> 4;
    if (!i1) i1 = i5; else {
     i3 = i1;
     i1 = i5;
     do {
      i37 = (i3 | 0) / 2 | 0;
      i7 = i1 + (i37 << 4) | 0;
      i36 = i7;
      i38 = HEAP32[i36 + 4 >> 2] | 0;
      i36 = i38 >>> 0 < 0 | ((i38 | 0) == 0 ? (HEAP32[i36 >> 2] | 0) >>> 0 < i4 >>> 0 : 0);
      i3 = i36 ? i3 + -1 - i37 | 0 : i37;
      i1 = i36 ? i7 + 16 | 0 : i1;
     } while ((i3 | 0) != 0);
    }
    if ((i1 | 0) == (i5 + (i6 << 4) | 0)) i1 = -1; else {
     i38 = i1;
     if ((HEAP32[i38 + 4 >> 2] | 0) == 0 ? (HEAP32[i38 >> 2] | 0) == (i4 | 0) : 0) i1 = HEAP32[i1 + 8 >> 2] | 0; else i1 = -1;
    }
    HEAP32[i9 + (i8 * 48 | 0) + 32 >> 2] = i1;
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break; else i7 = i2;
  }
 }
 i4 = HEAP32[i13 >> 2] | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i4 + 12 | 0;
 HEAP32[i4 >> 2] = __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci(364, 12, 16, gb + 64016 | 0, 0, gb + 462200 | 0, 511) | 0;
 i2 = 0;
 do {
  i5 = __ZN6Object13ClassIDToRTTIEi(i2) | 0;
  if (i5 | 0) {
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i7 + (i6 * 12 | 0) >> 2] = i2;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = -1; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] = i1;
   HEAP32[i7 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i3 >> 2] = i6 + 1;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 364);
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i18);
  HEAP32[i27 >> 2] = 0;
 }
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i32, HEAP32[i16 >> 2] | 0);
 if ((HEAP32[i30 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i31);
  HEAP32[i26 >> 2] = 0;
 }
 if ((HEAP32[i28 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i29);
  HEAP32[i23 >> 2] = 0;
 }
 if ((HEAP32[i24 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i25);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
  HEAP32[i19 >> 2] = 0;
 }
 __ZL17SerializeSnapshotRK14MemorySnapshotR13dynamic_arrayIhLj1EE(i34, i15);
 i2 = i33 + 4 | 0;
 if (!(HEAP32[i33 >> 2] | 0)) {
  i38 = HEAP32[i2 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i38, gb + 64016 | 0);
  i38 = i33 + 12 | 0;
  i38 = HEAP32[i38 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i38, gb + 64016 | 0);
  __Z39scripting_free_captured_memory_snapshotP14MemorySnapshot(i34);
  STACKTOP = i35;
  return;
 } else i1 = 0;
 do {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 48 | 0) + 40 >> 2] | 0, gb + 64016 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i33 >> 2] | 0) >>> 0);
 i38 = HEAP32[i2 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i38, gb + 64016 | 0);
 i38 = i33 + 12 | 0;
 i38 = HEAP32[i38 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i38, gb + 64016 | 0);
 __Z39scripting_free_captured_memory_snapshotP14MemorySnapshot(i34);
 STACKTOP = i35;
 return;
}

function __ZN5physx3Scb4Body9syncStateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 28 | 0;
 i3 = i12;
 i6 = i12 + 32 | 0;
 i8 = i10 + 236 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i9 = i10 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 do if (!(i7 & 262144)) {
  HEAP32[i10 + 176 >> 2] = HEAP32[i10 + 32 >> 2];
  HEAP32[i10 + 180 >> 2] = HEAP32[i10 + 36 >> 2];
  HEAP32[i10 + 184 >> 2] = HEAP32[i10 + 40 >> 2];
  HEAP32[i10 + 188 >> 2] = HEAP32[i10 + 44 >> 2];
  HEAP32[i10 + 192 >> 2] = HEAP32[i10 + 48 >> 2];
  HEAP32[i10 + 196 >> 2] = HEAP32[i10 + 52 >> 2];
  HEAP32[i10 + 200 >> 2] = HEAP32[i10 + 56 >> 2];
 } else {
  if (!(i7 & 524288)) {
   __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i10 + 16 | 0, i10 + 176 | 0);
   break;
  }
  i2 = i10 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i10 >> 2] | 0, i4 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  f28 = Math_fround(-Math_fround(HEAPF32[i10 + 64 >> 2]));
  f15 = Math_fround(-Math_fround(HEAPF32[i10 + 68 >> 2]));
  f26 = Math_fround(-Math_fround(HEAPF32[i10 + 72 >> 2]));
  f13 = Math_fround(HEAPF32[i10 + 76 >> 2]);
  f17 = Math_fround(HEAPF32[i1 + 160 >> 2]);
  f17 = Math_fround(f17 - Math_fround(HEAPF32[i10 + 80 >> 2]));
  f24 = Math_fround(HEAPF32[i1 + 164 >> 2]);
  f24 = Math_fround(f24 - Math_fround(HEAPF32[i10 + 84 >> 2]));
  f23 = Math_fround(HEAPF32[i1 + 168 >> 2]);
  f17 = Math_fround(f17 * Math_fround(2.0));
  f24 = Math_fround(f24 * Math_fround(2.0));
  f23 = Math_fround(Math_fround(f23 - Math_fround(HEAPF32[i10 + 88 >> 2])) * Math_fround(2.0));
  f25 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
  f27 = Math_fround(Math_fround(Math_fround(f17 * f28) + Math_fround(f24 * f15)) + Math_fround(f23 * f26));
  f19 = Math_fround(Math_fround(f27 * f28) + Math_fround(Math_fround(f25 * f17) + Math_fround(f13 * Math_fround(Math_fround(f23 * f15) - Math_fround(f24 * f26)))));
  f18 = Math_fround(Math_fround(f27 * f15) + Math_fround(Math_fround(f25 * f24) + Math_fround(f13 * Math_fround(Math_fround(f17 * f26) - Math_fround(f23 * f28)))));
  f27 = Math_fround(Math_fround(Math_fround(f25 * f23) + Math_fround(f13 * Math_fround(Math_fround(f24 * f28) - Math_fround(f17 * f15)))) + Math_fround(f27 * f26));
  f17 = Math_fround(HEAPF32[i1 + 144 >> 2]);
  f24 = Math_fround(f13 * f17);
  f23 = Math_fround(HEAPF32[i1 + 156 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f23 * f28));
  f25 = Math_fround(HEAPF32[i1 + 152 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f25 * f15));
  f14 = Math_fround(HEAPF32[i1 + 148 >> 2]);
  f24 = Math_fround(f24 - Math_fround(f14 * f26));
  f22 = Math_fround(Math_fround(Math_fround(f17 * f26) + Math_fround(Math_fround(f23 * f15) + Math_fround(f13 * f14))) - Math_fround(f25 * f28));
  f20 = Math_fround(Math_fround(Math_fround(f14 * f28) + Math_fround(Math_fround(f23 * f26) + Math_fround(f13 * f25))) - Math_fround(f17 * f15));
  f26 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f23) - Math_fround(f17 * f28)) - Math_fround(f14 * f15)) - Math_fround(f25 * f26));
  i31 = HEAP32[i10 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = i31;
  i1 = i3 + 4 | 0;
  i30 = HEAP32[i10 + 36 >> 2] | 0;
  HEAP32[i1 >> 2] = i30;
  i2 = i3 + 8 | 0;
  i29 = HEAP32[i10 + 40 >> 2] | 0;
  HEAP32[i2 >> 2] = i29;
  f25 = Math_fround(HEAPF32[i10 + 44 >> 2]);
  f15 = Math_fround(HEAPF32[i10 + 48 >> 2]);
  f14 = Math_fround(HEAPF32[i10 + 52 >> 2]);
  f28 = Math_fround(HEAPF32[i10 + 56 >> 2]);
  f19 = Math_fround(f19 * Math_fround(2.0));
  f18 = Math_fround(f18 * Math_fround(2.0));
  f27 = Math_fround(f27 * Math_fround(2.0));
  f17 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
  f23 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f19 * f23);
  f21 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f13 + Math_fround(f18 * f21));
  f16 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f13 + Math_fround(f27 * f16));
  f15 = Math_fround(f15 + Math_fround(Math_fround(f23 * f13) + Math_fround(Math_fround(f19 * f17) + Math_fround(f25 * Math_fround(Math_fround(f27 * f21) - Math_fround(f18 * f16))))));
  f14 = Math_fround(f14 + Math_fround(Math_fround(f21 * f13) + Math_fround(Math_fround(f18 * f17) + Math_fround(f25 * Math_fround(Math_fround(f19 * f16) - Math_fround(f27 * f23))))));
  f13 = Math_fround(f28 + Math_fround(Math_fround(Math_fround(f27 * f17) + Math_fround(f25 * Math_fround(Math_fround(f18 * f23) - Math_fround(f19 * f21)))) + Math_fround(f16 * f13)));
  f19 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f23)) + Math_fround(f20 * f21)) - Math_fround(f22 * f16));
  f18 = Math_fround(Math_fround(Math_fround(f24 * f16) + Math_fround(Math_fround(f22 * f25) + Math_fround(f26 * f21))) - Math_fround(f20 * f23));
  f17 = Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(Math_fround(f20 * f25) + Math_fround(f26 * f16))) - Math_fround(f24 * f21));
  f16 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23)) - Math_fround(f22 * f21)) - Math_fround(f20 * f16));
  HEAPF32[i3 >> 2] = f19;
  HEAPF32[i1 >> 2] = f18;
  HEAPF32[i2 >> 2] = f17;
  HEAPF32[i3 + 12 >> 2] = f16;
  HEAPF32[i3 + 16 >> 2] = f15;
  HEAPF32[i3 + 20 >> 2] = f14;
  HEAPF32[i3 + 24 >> 2] = f13;
  HEAPF32[i10 + 176 >> 2] = f19;
  HEAPF32[i10 + 180 >> 2] = f18;
  HEAPF32[i10 + 184 >> 2] = f17;
  HEAPF32[i10 + 188 >> 2] = f16;
  HEAPF32[i10 + 192 >> 2] = f15;
  HEAPF32[i10 + 196 >> 2] = f14;
  HEAPF32[i10 + 200 >> 2] = f13;
  __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i10 + 16 | 0, i3);
 } while (0);
 i1 = i10 + 204 | 0;
 i2 = i10 + 96 | 0;
 if (!(i7 & 1048576)) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 208 >> 2] = HEAP32[i10 + 100 >> 2];
  HEAP32[i10 + 212 >> 2] = HEAP32[i10 + 104 >> 2];
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 100 >> 2] = HEAP32[i10 + 208 >> 2];
  HEAP32[i10 + 104 >> 2] = HEAP32[i10 + 212 >> 2];
 }
 i1 = i10 + 216 | 0;
 i2 = i10 + 112 | 0;
 if (!(i7 & 2097152)) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 220 >> 2] = HEAP32[i10 + 116 >> 2];
  HEAP32[i10 + 224 >> 2] = HEAP32[i10 + 120 >> 2];
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 116 >> 2] = HEAP32[i10 + 220 >> 2];
  HEAP32[i10 + 120 >> 2] = HEAP32[i10 + 224 >> 2];
 }
 do if (i4 & 1 | 0) {
  i1 = i10 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) >>> 24 & 15) | 0;
   HEAP32[i1 >> 2] = i2;
  }
  i3 = (HEAP16[i10 + 24 >> 1] & 8) != 0;
  i1 = (HEAP16[i2 >> 1] & 8) != 0;
  if (i1 | i3 ^ 1) {
   if (i3 | i1 ^ 1) break;
   __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb(HEAP32[i10 >> 2] | 0, i10, 1);
   break;
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if ((HEAP32[i9 >> 2] & -1073741824 | 0) == -2147483648) {
   i31 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
   i2 = i31 + -16 | 0;
   i3 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i10, i5) | 0;
   __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj(i1 + 16 | 0, (HEAP32[gb + 90260 + 24 + (((HEAP32[i9 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i10 | 0, HEAP32[i5 >> 2] | 0, i3, i31);
   if (i3 | 0) {
    i1 = 0;
    do {
     __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE((HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i2 | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  }
 } while (0);
 do if (i7 & -32768001 | 0) {
  i1 = i10 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) >>> 24 & 15) | 0;
   HEAP32[i1 >> 2] = i2;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 & 1) {
   __ZN5physx2Sc8BodyCore14setInverseMassEf(i10 + 16 | 0, Math_fround(HEAPF32[i2 + 92 >> 2]));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 2) {
   __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E(i10 + 16 | 0, i2 + 96 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 4) {
   __ZN5physx2Sc8BodyCore16setLinearDampingEf(i10 + 16 | 0, Math_fround(HEAPF32[i2 + 108 >> 2]));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 8) {
   __ZN5physx2Sc8BodyCore17setAngularDampingEf(i10 + 16 | 0, Math_fround(HEAPF32[i2 + 112 >> 2]));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 16) {
   __ZN5physx2Sc8BodyCore14setMaxAngVelSqEf(i10 + 16 | 0, Math_fround(HEAPF32[i2 + 116 >> 2]));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 32 | 0) HEAP32[i10 + 160 >> 2] = HEAP32[i2 + 120 >> 2];
  if (i1 & 256 | 0) HEAP16[i10 + 62 >> 1] = HEAP16[i2 + 132 >> 1] | 0;
  if (i1 & 128 | 0) HEAP32[i10 + 124 >> 2] = HEAP32[i2 + 128 >> 2];
  if (i1 & 512 | 0) {
   HEAP32[i10 + 64 >> 2] = HEAP32[i2 + 144 >> 2];
   HEAP32[i10 + 68 >> 2] = HEAP32[i2 + 148 >> 2];
   HEAP32[i10 + 72 >> 2] = HEAP32[i2 + 152 >> 2];
   HEAP32[i10 + 76 >> 2] = HEAP32[i2 + 156 >> 2];
   HEAP32[i10 + 80 >> 2] = HEAP32[i2 + 160 >> 2];
   HEAP32[i10 + 84 >> 2] = HEAP32[i2 + 164 >> 2];
   HEAP32[i10 + 88 >> 2] = HEAP32[i2 + 168 >> 2];
  }
  if (i1 & 2048 | 0) HEAP32[i10 + 164 >> 2] = HEAP32[i2 + 176 >> 2];
  if (i1 & 1024 | 0) HEAP32[i10 + 108 >> 2] = HEAP32[i2 + 172 >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 1248 >> 2] | 0;
  if (i7 & 4096 | 0) {
   HEAP8[i6 >> 0] = HEAP8[i2 + 268 >> 0] | 0;
   __ZN5physx2Sc8BodyCore8setFlagsEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i10 + 16 | 0, i1, i6);
  }
  if (i7 & 8192 | 0) __ZN5physx2Sc8BodyCore18setKinematicTargetEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEERKNS_11PxTransformEf(i10 + 16 | 0, i1, i2 + 192 | 0, Math_fround(HEAPF32[i10 + 228 >> 2]));
  if (i7 & 49152 | 0) __ZN5physx2Sc8BodyCore22addSpatialAccelerationEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i10 + 16 | 0, i1, i2 + 220 | 0, i2 + 232 | 0);
  if (!(i7 & 196608)) break;
  __ZN5physx2Sc8BodyCore18addSpatialVelocityEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i10 + 16 | 0, i1, i2 + 244 | 0, i2 + 256 | 0);
 } while (0);
 do if (!(i7 & 4194304)) {
  i2 = i10 + 16 | 0;
  HEAPF32[i10 + 228 >> 2] = Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i2));
  i1 = __ZNK5physx2Sc8BodyCore10isSleepingEv(i2) | 0;
  if (!(i7 & 25165824)) i11 = 62; else i1 = i2;
 } else {
  i1 = i10 + 16 | 0;
  if (!(i7 & 25165824)) {
   __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i1, Math_fround(HEAPF32[i10 + 228 >> 2]), 0);
   i1 = __ZNK5physx2Sc8BodyCore10isSleepingEv(i1) | 0;
   i11 = 62;
   break;
  } else break;
 } while (0);
 if ((i11 | 0) == 62) {
  if ((HEAP32[i9 >> 2] | 0) >>> 0 > 3221225471) {
   __ZN5physx3Scb11RigidObject9syncStateEv(i10);
   i31 = i10 + 8 | 0;
   HEAP32[i31 >> 2] = 0;
   i31 = HEAP32[i9 >> 2] | 0;
   i31 = i31 & -16777216;
   HEAP32[i9 >> 2] = i31;
   HEAP32[i8 >> 2] = 0;
   STACKTOP = i12;
   return;
  }
  HEAP32[i10 + 232 >> 2] = i1 & 1;
  __ZN5physx3Scb11RigidObject9syncStateEv(i10);
  i31 = i10 + 8 | 0;
  HEAP32[i31 >> 2] = 0;
  i31 = HEAP32[i9 >> 2] | 0;
  i31 = i31 & -16777216;
  HEAP32[i9 >> 2] = i31;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 if (!(i7 & 8388608)) {
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i1, Math_fround(HEAPF32[i10 + 228 >> 2]), 1);
  __ZN5physx3Scb11RigidObject9syncStateEv(i10);
  i31 = i10 + 8 | 0;
  HEAP32[i31 >> 2] = 0;
  i31 = HEAP32[i9 >> 2] | 0;
  i31 = i31 & -16777216;
  HEAP32[i9 >> 2] = i31;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i12;
  return;
 } else {
  __ZN5physx2Sc8BodyCore10putToSleepEv(i1);
  __ZN5physx3Scb11RigidObject9syncStateEv(i10);
  i31 = i10 + 8 | 0;
  HEAP32[i31 >> 2] = 0;
  i31 = HEAP32[i9 >> 2] | 0;
  i31 = i31 & -16777216;
  HEAP32[i9 >> 2] = i31;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i15, i16, i26, i1, i2, i57, i58, i59) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i62 + 16 | 0;
 i61 = i62;
 if (i2 >>> 0 >= i57 >>> 0) {
  STACKTOP = i62;
  return;
 }
 i17 = i1 + 500 | 0;
 i18 = i61 + 4 | 0;
 i19 = i61 + 8 | 0;
 i20 = i61 + 12 | 0;
 i21 = i1 + 520 | 0;
 i22 = i15 + 32 | 0;
 i23 = i15 + 4 | 0;
 i24 = i15 + 8 | 0;
 i25 = i15 + 12 | 0;
 i27 = i15 + 16 | 0;
 i28 = i15 + 20 | 0;
 i29 = i15 + 24 | 0;
 i30 = i15 + 28 | 0;
 i31 = i16 + 32 | 0;
 i32 = i16 + 4 | 0;
 i33 = i16 + 8 | 0;
 i34 = i16 + 12 | 0;
 i35 = i16 + 16 | 0;
 i36 = i16 + 20 | 0;
 i37 = i16 + 24 | 0;
 i38 = i16 + 28 | 0;
 i39 = i26 + 32 | 0;
 i40 = i26 + 4 | 0;
 i41 = i26 + 8 | 0;
 i42 = i26 + 12 | 0;
 i43 = i26 + 16 | 0;
 i44 = i26 + 20 | 0;
 i45 = i26 + 24 | 0;
 i46 = i26 + 28 | 0;
 i47 = i59 + 12 | 0;
 i48 = i59 + 24 | 0;
 i49 = i59 + 4 | 0;
 i50 = i59 + 16 | 0;
 i51 = i59 + 28 | 0;
 i52 = i59 + 8 | 0;
 i53 = i59 + 20 | 0;
 i54 = i59 + 32 | 0;
 i55 = i1 + 120 | 0;
 i56 = i1 + 140 | 0;
 i1 = i1 + 160 | 0;
 do {
  i80 = (HEAP32[i17 >> 2] | 0) + (i2 << 2) | 0;
  i79 = (HEAP32[i80 + 4 >> 2] | 0) + -520366028 | 0;
  i78 = (HEAP32[i80 + 8 >> 2] | 0) + -520366028 | 0;
  i77 = (HEAP32[i80 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i61 >> 2] = (HEAP32[i80 >> 2] | 0) + -520366028;
  HEAP32[i18 >> 2] = i79;
  HEAP32[i19 >> 2] = i78;
  HEAP32[i20 >> 2] = i77;
  __Z17GenerateRandomNx3RKN4math5_int4E(i60, i61);
  i77 = (HEAP32[i21 >> 2] | 0) + (i2 << 2) | 0;
  f71 = Math_fround(HEAPF32[i77 >> 2]);
  f69 = Math_fround(HEAPF32[i77 + 4 >> 2]);
  f67 = Math_fround(HEAPF32[i77 + 8 >> 2]);
  f71 = Math_fround(f71 * Math_fround(.00999999977));
  f69 = Math_fround(f69 * Math_fround(.00999999977));
  f67 = Math_fround(f67 * Math_fround(.00999999977));
  f65 = Math_fround(Math_fround(HEAPF32[i77 + 12 >> 2]) * Math_fround(.00999999977));
  f72 = Math_fround(HEAPF32[i22 >> 2]);
  f5 = Math_fround(HEAPF32[i15 >> 2]);
  f4 = Math_fround(f71 * f5);
  f3 = Math_fround(f69 * f5);
  f6 = Math_fround(f67 * f5);
  f5 = Math_fround(f65 * f5);
  f8 = Math_fround(HEAPF32[i23 >> 2]);
  f4 = Math_fround(f71 * Math_fround(f4 + f8));
  f3 = Math_fround(f69 * Math_fround(f3 + f8));
  f6 = Math_fround(f67 * Math_fround(f6 + f8));
  f8 = Math_fround(f65 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i24 >> 2]);
  f4 = Math_fround(f71 * Math_fround(f5 + f4));
  f3 = Math_fround(f69 * Math_fround(f5 + f3));
  f6 = Math_fround(f67 * Math_fround(f5 + f6));
  f8 = Math_fround(f65 * Math_fround(f5 + f8));
  f5 = Math_fround(HEAPF32[i25 >> 2]);
  f4 = Math_fround(f5 + f4);
  f3 = Math_fround(f5 + f3);
  f6 = Math_fround(f5 + f6);
  f8 = Math_fround(f5 + f8);
  f5 = Math_fround(f71 - f72);
  f75 = Math_fround(f69 - f72);
  f74 = Math_fround(f67 - f72);
  f73 = Math_fround(f65 - f72);
  f13 = Math_fround(HEAPF32[i27 >> 2]);
  f14 = Math_fround(f5 * f13);
  f12 = Math_fround(f75 * f13);
  f10 = Math_fround(f74 * f13);
  f13 = Math_fround(f73 * f13);
  f76 = Math_fround(HEAPF32[i28 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f14 + f76));
  f12 = Math_fround(f75 * Math_fround(f12 + f76));
  f10 = Math_fround(f74 * Math_fround(f10 + f76));
  f76 = Math_fround(f73 * Math_fround(f13 + f76));
  f13 = Math_fround(HEAPF32[i29 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f13 + f14));
  f12 = Math_fround(f75 * Math_fround(f13 + f12));
  f10 = Math_fround(f74 * Math_fround(f13 + f10));
  f76 = Math_fround(f73 * Math_fround(f13 + f76));
  f13 = Math_fround(HEAPF32[i30 >> 2]);
  f14 = Math_fround(f13 + f14);
  f12 = Math_fround(f13 + f12);
  f10 = Math_fround(f13 + f10);
  f76 = Math_fround(f13 + f76);
  f4 = f71 > f72 ? f14 : f4;
  f3 = f69 > f72 ? f12 : f3;
  f6 = f67 > f72 ? f10 : f6;
  f8 = f65 > f72 ? f76 : f8;
  f76 = Math_fround(HEAPF32[i31 >> 2]);
  f72 = Math_fround(HEAPF32[i16 >> 2]);
  f10 = Math_fround(f71 * f72);
  f12 = Math_fround(f69 * f72);
  f14 = Math_fround(f67 * f72);
  f72 = Math_fround(f65 * f72);
  f13 = Math_fround(HEAPF32[i32 >> 2]);
  f10 = Math_fround(f71 * Math_fround(f10 + f13));
  f12 = Math_fround(f69 * Math_fround(f12 + f13));
  f14 = Math_fround(f67 * Math_fround(f14 + f13));
  f13 = Math_fround(f65 * Math_fround(f72 + f13));
  f72 = Math_fround(HEAPF32[i33 >> 2]);
  f10 = Math_fround(f71 * Math_fround(f72 + f10));
  f12 = Math_fround(f69 * Math_fround(f72 + f12));
  f14 = Math_fround(f67 * Math_fround(f72 + f14));
  f13 = Math_fround(f65 * Math_fround(f72 + f13));
  f72 = Math_fround(HEAPF32[i34 >> 2]);
  f10 = Math_fround(f72 + f10);
  f12 = Math_fround(f72 + f12);
  f14 = Math_fround(f72 + f14);
  f13 = Math_fround(f72 + f13);
  f72 = Math_fround(f71 - f76);
  f73 = Math_fround(f69 - f76);
  f74 = Math_fround(f67 - f76);
  f75 = Math_fround(f65 - f76);
  f5 = Math_fround(HEAPF32[i35 >> 2]);
  f7 = Math_fround(f72 * f5);
  f9 = Math_fround(f73 * f5);
  f11 = Math_fround(f74 * f5);
  f5 = Math_fround(f75 * f5);
  f64 = Math_fround(HEAPF32[i36 >> 2]);
  f7 = Math_fround(f72 * Math_fround(f7 + f64));
  f9 = Math_fround(f73 * Math_fround(f9 + f64));
  f11 = Math_fround(f74 * Math_fround(f11 + f64));
  f64 = Math_fround(f75 * Math_fround(f5 + f64));
  f5 = Math_fround(HEAPF32[i37 >> 2]);
  f7 = Math_fround(f72 * Math_fround(f5 + f7));
  f9 = Math_fround(f73 * Math_fround(f5 + f9));
  f11 = Math_fround(f74 * Math_fround(f5 + f11));
  f64 = Math_fround(f75 * Math_fround(f5 + f64));
  f5 = Math_fround(HEAPF32[i38 >> 2]);
  f7 = Math_fround(f5 + f7);
  f9 = Math_fround(f5 + f9);
  f11 = Math_fround(f5 + f11);
  f64 = Math_fround(f5 + f64);
  f10 = f71 > f76 ? f7 : f10;
  f12 = f69 > f76 ? f9 : f12;
  f14 = f67 > f76 ? f11 : f14;
  f13 = f65 > f76 ? f64 : f13;
  f64 = Math_fround(HEAPF32[i39 >> 2]);
  f76 = Math_fround(HEAPF32[i26 >> 2]);
  f11 = Math_fround(f71 * f76);
  f9 = Math_fround(f69 * f76);
  f7 = Math_fround(f67 * f76);
  f76 = Math_fround(f65 * f76);
  f5 = Math_fround(HEAPF32[i40 >> 2]);
  f11 = Math_fround(f71 * Math_fround(f11 + f5));
  f9 = Math_fround(f69 * Math_fround(f9 + f5));
  f7 = Math_fround(f67 * Math_fround(f7 + f5));
  f5 = Math_fround(f65 * Math_fround(f76 + f5));
  f76 = Math_fround(HEAPF32[i41 >> 2]);
  f11 = Math_fround(f71 * Math_fround(f76 + f11));
  f9 = Math_fround(f69 * Math_fround(f76 + f9));
  f7 = Math_fround(f67 * Math_fround(f76 + f7));
  f5 = Math_fround(f65 * Math_fround(f76 + f5));
  f76 = Math_fround(HEAPF32[i42 >> 2]);
  f11 = Math_fround(f76 + f11);
  f9 = Math_fround(f76 + f9);
  f7 = Math_fround(f76 + f7);
  f5 = Math_fround(f76 + f5);
  f76 = Math_fround(f71 - f64);
  f75 = Math_fround(f69 - f64);
  f74 = Math_fround(f67 - f64);
  f73 = Math_fround(f65 - f64);
  f72 = Math_fround(HEAPF32[i43 >> 2]);
  f70 = Math_fround(f76 * f72);
  f68 = Math_fround(f75 * f72);
  f66 = Math_fround(f74 * f72);
  f72 = Math_fround(f73 * f72);
  f63 = Math_fround(HEAPF32[i44 >> 2]);
  f70 = Math_fround(f76 * Math_fround(f70 + f63));
  f68 = Math_fround(f75 * Math_fround(f68 + f63));
  f66 = Math_fround(f74 * Math_fround(f66 + f63));
  f63 = Math_fround(f73 * Math_fround(f72 + f63));
  f72 = Math_fround(HEAPF32[i45 >> 2]);
  f70 = Math_fround(f76 * Math_fround(f72 + f70));
  f68 = Math_fround(f75 * Math_fround(f72 + f68));
  f66 = Math_fround(f74 * Math_fround(f72 + f66));
  f63 = Math_fround(f73 * Math_fround(f72 + f63));
  f72 = Math_fround(HEAPF32[i46 >> 2]);
  f70 = Math_fround(f72 + f70);
  f68 = Math_fround(f72 + f68);
  f66 = Math_fround(f72 + f66);
  f63 = Math_fround(f72 + f63);
  f11 = f71 > f64 ? f70 : f11;
  f9 = f69 > f64 ? f68 : f9;
  f7 = f67 > f64 ? f66 : f7;
  f5 = f65 > f64 ? f63 : f5;
  if (i58) {
   f67 = Math_fround(HEAPF32[i59 >> 2]);
   f65 = Math_fround(f4 * f67);
   f76 = Math_fround(f3 * f67);
   f66 = Math_fround(f6 * f67);
   f67 = Math_fround(f8 * f67);
   f71 = Math_fround(HEAPF32[i47 >> 2]);
   f65 = Math_fround(f65 + Math_fround(f10 * f71));
   f76 = Math_fround(f76 + Math_fround(f12 * f71));
   f66 = Math_fround(f66 + Math_fround(f14 * f71));
   f71 = Math_fround(f67 + Math_fround(f13 * f71));
   f67 = Math_fround(HEAPF32[i48 >> 2]);
   f65 = Math_fround(f65 + Math_fround(f11 * f67));
   f76 = Math_fround(f76 + Math_fround(f9 * f67));
   f66 = Math_fround(f66 + Math_fround(f7 * f67));
   f67 = Math_fround(f71 + Math_fround(f5 * f67));
   f71 = Math_fround(HEAPF32[i49 >> 2]);
   f68 = Math_fround(f4 * f71);
   f69 = Math_fround(f3 * f71);
   f70 = Math_fround(f6 * f71);
   f71 = Math_fround(f8 * f71);
   f75 = Math_fround(HEAPF32[i50 >> 2]);
   f68 = Math_fround(f68 + Math_fround(f10 * f75));
   f69 = Math_fround(f69 + Math_fround(f12 * f75));
   f70 = Math_fround(f70 + Math_fround(f14 * f75));
   f75 = Math_fround(f71 + Math_fround(f13 * f75));
   f71 = Math_fround(HEAPF32[i51 >> 2]);
   f68 = Math_fround(f68 + Math_fround(f11 * f71));
   f69 = Math_fround(f69 + Math_fround(f9 * f71));
   f70 = Math_fround(f70 + Math_fround(f7 * f71));
   f71 = Math_fround(f75 + Math_fround(f5 * f71));
   f75 = Math_fround(HEAPF32[i52 >> 2]);
   f72 = Math_fround(f4 * f75);
   f73 = Math_fround(f3 * f75);
   f74 = Math_fround(f6 * f75);
   f3 = Math_fround(f8 * f75);
   f75 = Math_fround(HEAPF32[i53 >> 2]);
   f72 = Math_fround(f72 + Math_fround(f10 * f75));
   f73 = Math_fround(f73 + Math_fround(f12 * f75));
   f74 = Math_fround(f74 + Math_fround(f14 * f75));
   f75 = Math_fround(f3 + Math_fround(f13 * f75));
   f3 = Math_fround(HEAPF32[i54 >> 2]);
   f4 = f65;
   f6 = f66;
   f8 = f67;
   f10 = f68;
   f12 = f69;
   f14 = f70;
   f13 = f71;
   f11 = Math_fround(f72 + Math_fround(f11 * f3));
   f9 = Math_fround(f73 + Math_fround(f9 * f3));
   f7 = Math_fround(f74 + Math_fround(f7 * f3));
   f5 = Math_fround(f75 + Math_fround(f5 * f3));
   f3 = f76;
  }
  i88 = (HEAP32[i55 >> 2] | 0) + (i2 << 2) | 0;
  f65 = Math_fround(HEAPF32[i88 >> 2]);
  i87 = i88 + 4 | 0;
  f66 = Math_fround(HEAPF32[i87 >> 2]);
  i86 = i88 + 8 | 0;
  f67 = Math_fround(HEAPF32[i86 >> 2]);
  i85 = i88 + 12 | 0;
  f68 = Math_fround(HEAPF32[i85 >> 2]);
  i84 = (HEAP32[i56 >> 2] | 0) + (i2 << 2) | 0;
  f69 = Math_fround(HEAPF32[i84 >> 2]);
  i83 = i84 + 4 | 0;
  f70 = Math_fround(HEAPF32[i83 >> 2]);
  i82 = i84 + 8 | 0;
  f71 = Math_fround(HEAPF32[i82 >> 2]);
  i81 = i84 + 12 | 0;
  f72 = Math_fround(HEAPF32[i81 >> 2]);
  i77 = (HEAP32[i1 >> 2] | 0) + (i2 << 2) | 0;
  f73 = Math_fround(HEAPF32[i77 >> 2]);
  i78 = i77 + 4 | 0;
  f74 = Math_fround(HEAPF32[i78 >> 2]);
  i79 = i77 + 8 | 0;
  f75 = Math_fround(HEAPF32[i79 >> 2]);
  i80 = i77 + 12 | 0;
  f66 = Math_fround(f3 + f66);
  f67 = Math_fround(f6 + f67);
  f68 = Math_fround(f8 + f68);
  f69 = Math_fround(f10 + f69);
  f70 = Math_fround(f12 + f70);
  f71 = Math_fround(f14 + f71);
  f72 = Math_fround(f13 + f72);
  f73 = Math_fround(f11 + f73);
  f74 = Math_fround(f9 + f74);
  f75 = Math_fround(f7 + f75);
  f76 = Math_fround(f5 + Math_fround(HEAPF32[i80 >> 2]));
  HEAPF32[i88 >> 2] = Math_fround(f4 + f65);
  HEAPF32[i87 >> 2] = f66;
  HEAPF32[i86 >> 2] = f67;
  HEAPF32[i85 >> 2] = f68;
  HEAPF32[i84 >> 2] = f69;
  HEAPF32[i83 >> 2] = f70;
  HEAPF32[i82 >> 2] = f71;
  HEAPF32[i81 >> 2] = f72;
  HEAPF32[i77 >> 2] = f73;
  HEAPF32[i78 >> 2] = f74;
  HEAPF32[i79 >> 2] = f75;
  HEAPF32[i80 >> 2] = f76;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i57 >>> 0);
 STACKTOP = i62;
 return;
}

function __ZN8b2Island5SolveEP9b2ProfileRK10b2TimeStepRK6b2Vec2b(i28, i23, i21, i12, i25) {
 i28 = i28 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i12 = i12 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i22 = 0, i24 = 0, i26 = 0, f27 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i31 + 128 | 0;
 i24 = i31 + 148 | 0;
 i22 = i31 + 96 | 0;
 i17 = i31 + 52 | 0;
 i30 = i31;
 f27 = Math_fround(HEAPF32[i21 >> 2]);
 i29 = i28 + 28 | 0;
 if ((HEAP32[i29 >> 2] | 0) > 0) {
  i8 = i28 + 8 | 0;
  i9 = i12 + 4 | 0;
  i16 = i28 + 20 | 0;
  i10 = i28 + 24 | 0;
  i7 = 0;
  do {
   i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   i14 = i6 + 44 | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i15 = HEAP32[i6 + 56 >> 2] | 0;
   i2 = HEAP32[i6 + 64 >> 2] | 0;
   i1 = HEAP32[i6 + 68 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i6 + 72 >> 2]);
   i32 = i6 + 36 | 0;
   HEAP32[i32 >> 2] = i13;
   HEAP32[i32 + 4 >> 2] = i14;
   HEAP32[i6 + 52 >> 2] = i15;
   if ((HEAP32[i6 >> 2] | 0) == 2) {
    f20 = Math_fround(HEAPF32[i6 + 140 >> 2]);
    f11 = Math_fround(f20 * Math_fround(HEAPF32[i12 >> 2]));
    f20 = Math_fround(f20 * Math_fround(HEAPF32[i9 >> 2]));
    f19 = Math_fround(HEAPF32[i6 + 120 >> 2]);
    f18 = Math_fround(f19 * Math_fround(HEAPF32[i6 + 76 >> 2]));
    f18 = Math_fround(f27 * Math_fround(f11 + f18));
    f19 = Math_fround(f27 * Math_fround(f20 + Math_fround(f19 * Math_fround(HEAPF32[i6 + 80 >> 2]))));
    f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f18);
    f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
    f20 = Math_fround(f27 * Math_fround(HEAPF32[i6 + 128 >> 2]));
    f3 = Math_fround(f3 + Math_fround(f20 * Math_fround(HEAPF32[i6 + 84 >> 2])));
    f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i6 + 132 >> 2])) + Math_fround(1.0)));
    f18 = Math_fround(f18 * f20);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    f20 = Math_fround(f19 * f20);
    f3 = Math_fround(f3 * Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i6 + 136 >> 2])) + Math_fround(1.0))));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   }
   i32 = (HEAP32[i16 >> 2] | 0) + (i7 * 12 | 0) | 0;
   HEAP32[i32 >> 2] = i13;
   HEAP32[i32 + 4 >> 2] = i14;
   HEAP32[(HEAP32[i16 >> 2] | 0) + (i7 * 12 | 0) + 8 >> 2] = i15;
   i32 = HEAP32[i10 >> 2] | 0;
   HEAP32[i32 + (i7 * 12 | 0) >> 2] = i2;
   HEAP32[i32 + (i7 * 12 | 0) + 4 >> 2] = i1;
   HEAPF32[(HEAP32[i10 >> 2] | 0) + (i7 * 12 | 0) + 8 >> 2] = f3;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (HEAP32[i29 >> 2] | 0));
  i13 = i10;
 } else {
  i13 = i28 + 24 | 0;
  i16 = i28 + 20 | 0;
 };
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
 i12 = HEAP32[i16 >> 2] | 0;
 HEAP32[i22 + 24 >> 2] = i12;
 i32 = HEAP32[i13 >> 2] | 0;
 HEAP32[i22 + 28 >> 2] = i32;
 HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
 i14 = i28 + 12 | 0;
 HEAP32[i17 + 24 >> 2] = HEAP32[i14 >> 2];
 i15 = i28 + 36 | 0;
 HEAP32[i17 + 28 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 32 >> 2] = i12;
 HEAP32[i17 + 36 >> 2] = i32;
 HEAP32[i17 + 40 >> 2] = HEAP32[i28 >> 2];
 __ZN15b2ContactSolverC2EP18b2ContactSolverDef(i30, i17);
 __ZN15b2ContactSolver29InitializeVelocityConstraintsEv(i30);
 if (HEAP8[i21 + 20 >> 0] | 0) __ZN15b2ContactSolver9WarmStartEv(i30);
 i12 = i28 + 32 | 0;
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i2 = i28 + 16 | 0;
  i1 = 0;
  do {
   i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 32 >> 2] | 0, i32 | 0, i22 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 HEAPF32[i23 + 12 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i24));
 i6 = i21 + 12 | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i7 = i28 + 16 | 0;
  i1 = 0;
  do {
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i2 = 0;
    do {
     i32 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 36 >> 2] | 0, i32 | 0, i22 | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
   }
   __ZN15b2ContactSolver24SolveVelocityConstraintsEv(i30);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 __ZN15b2ContactSolver13StoreImpulsesEv(i30);
 HEAPF32[i23 + 16 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i24));
 if ((HEAP32[i29 >> 2] | 0) > 0) {
  i7 = 0;
  i1 = HEAP32[i13 >> 2] | 0;
  do {
   i2 = HEAP32[i16 >> 2] | 0;
   i9 = i2 + (i7 * 12 | 0) | 0;
   f18 = Math_fround(HEAPF32[i9 >> 2]);
   i8 = i2 + (i7 * 12 | 0) + 4 | 0;
   f19 = Math_fround(HEAPF32[i8 >> 2]);
   f20 = Math_fround(HEAPF32[i2 + (i7 * 12 | 0) + 8 >> 2]);
   i2 = HEAP32[i1 + (i7 * 12 | 0) >> 2] | 0;
   i6 = HEAP32[i1 + (i7 * 12 | 0) + 4 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i1 + (i7 * 12 | 0) + 8 >> 2]);
   f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f27 * f4);
   f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f27 * f5);
   f11 = Math_fround(Math_fround(f33 * f33) + Math_fround(f11 * f11));
   if (f11 > Math_fround(HEAPF32[gb + 151892 >> 2])) {
    f33 = Math_fround(Math_fround(HEAPF32[gb + 151888 >> 2]) / Math_fround(Math_sqrt(Math_fround(f11))));
    f11 = Math_fround(f4 * f33);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    f33 = Math_fround(f5 * f33);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   } else i1 = i6;
   f4 = Math_fround(f27 * f3);
   f33 = Math_fround(f4 * f4);
   if (f33 > Math_fround(HEAPF32[gb + 151900 >> 2])) {
    f11 = Math_fround(HEAPF32[gb + 151896 >> 2]);
    i32 = f4 > Math_fround(0.0);
    f33 = Math_fround(-f4);
    f3 = Math_fround(f3 * Math_fround(f11 / (i32 ? f4 : f33)));
   }
   f11 = Math_fround(f27 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f19 = Math_fround(f19 + Math_fround(f27 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f33 = Math_fround(f20 + Math_fround(f27 * f3));
   HEAPF32[i9 >> 2] = Math_fround(f18 + f11);
   HEAPF32[i8 >> 2] = f19;
   HEAPF32[(HEAP32[i16 >> 2] | 0) + (i7 * 12 | 0) + 8 >> 2] = f33;
   i32 = HEAP32[i13 >> 2] | 0;
   HEAP32[i32 + (i7 * 12 | 0) >> 2] = i2;
   HEAP32[i32 + (i7 * 12 | 0) + 4 >> 2] = i1;
   i1 = HEAP32[i13 >> 2] | 0;
   HEAPF32[i1 + (i7 * 12 | 0) + 8 >> 2] = f3;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (HEAP32[i29 >> 2] | 0));
 }
 i8 = i21 + 16 | 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i9 = i28 + 16 | 0;
  i6 = 0;
  i7 = 0;
  do {
   i10 = __ZN15b2ContactSolver24SolvePositionConstraintsEv(i30) | 0;
   if ((HEAP32[i12 >> 2] | 0) > 0) {
    i2 = 0;
    i1 = 1;
    do {
     i32 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i1 = i1 & (mftCall_iii(HEAP32[(HEAP32[i32 >> 2] | 0) + 40 >> 2] | 0, i32 | 0, i22 | 0) | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i12 >> 2] | 0));
   } else i1 = 1;
   i32 = i10 & i1;
   i7 = i7 | i32;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (HEAP32[i8 >> 2] | 0) & (i32 ^ 1));
  i12 = i7 ^ 1;
 } else i12 = 1;
 i1 = HEAP32[i29 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i7 = i28 + 8 | 0;
  i6 = 0;
  do {
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i1 = (HEAP32[i16 >> 2] | 0) + (i6 * 12 | 0) | 0;
    i32 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i22 = i2 + 44 | 0;
    HEAP32[i22 >> 2] = i32;
    HEAP32[i22 + 4 >> 2] = i1;
    i22 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i2 + 56 >> 2] = i22;
    i10 = (HEAP32[i13 >> 2] | 0) + (i6 * 12 | 0) | 0;
    i17 = HEAP32[i10 + 4 >> 2] | 0;
    i21 = i2 + 64 | 0;
    HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i21 + 4 >> 2] = i17;
    HEAP32[i2 + 72 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 * 12 | 0) + 8 >> 2];
    f19 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = Math_fround(+Math_sin(+f19));
    HEAPF32[i2 + 20 >> 2] = f11;
    f19 = Math_fround(+Math_cos(+f19));
    HEAPF32[i2 + 24 >> 2] = f19;
    f18 = Math_fround(HEAPF32[i2 + 28 >> 2]);
    f20 = Math_fround(f19 * f18);
    f33 = Math_fround(HEAPF32[i2 + 32 >> 2]);
    f20 = Math_fround(f20 - Math_fround(f11 * f33));
    f33 = Math_fround(Math_fround(f11 * f18) + Math_fround(f19 * f33));
    f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f20);
    f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f33);
    HEAPF32[i2 + 12 >> 2] = f20;
    HEAPF32[i2 + 16 >> 2] = f33;
    i1 = HEAP32[i29 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i1 | 0));
 }
 HEAPF32[i23 + 20 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i24));
 i6 = HEAP32[i30 + 40 >> 2] | 0;
 i7 = i28 + 4 | 0;
 if (HEAP32[i7 >> 2] | 0) if ((HEAP32[i15 >> 2] | 0) > 0) {
  i8 = i26 + 16 | 0;
  i1 = 0;
  do {
   i9 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i10 = HEAP32[i6 + (i1 * 156 | 0) + 148 >> 2] | 0;
   HEAP32[i8 >> 2] = i10;
   if ((i10 | 0) > 0) {
    i2 = 0;
    do {
     HEAP32[i26 + (i2 << 2) >> 2] = HEAP32[i6 + (i1 * 156 | 0) + (i2 * 36 | 0) + 16 >> 2];
     HEAP32[i26 + 8 + (i2 << 2) >> 2] = HEAP32[i6 + (i1 * 156 | 0) + (i2 * 36 | 0) + 20 >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i10 | 0));
   }
   i32 = HEAP32[i7 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i32 >> 2] | 0) + 20 >> 2] | 0, i32 | 0, i9 | 0, i26 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 if (!i25) {
  __ZN15b2ContactSolverD2Ev(i30);
  STACKTOP = i31;
  return;
 }
 f4 = Math_fround(HEAPF32[gb + 151916 >> 2]);
 f4 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[gb + 151920 >> 2]);
 f5 = Math_fround(f5 * f5);
 i6 = HEAP32[i29 >> 2] | 0;
 i8 = (i6 | 0) > 0;
 if (i8) {
  i7 = HEAP32[i28 + 8 >> 2] | 0;
  i2 = 0;
  f3 = Math_fround(3402823469999999843913219.0e14);
  do {
   i1 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
   do if (HEAP32[i1 >> 2] | 0) {
    if (HEAP16[i1 + 4 >> 1] & 4) {
     f33 = Math_fround(HEAPF32[i1 + 72 >> 2]);
     if (!(Math_fround(f33 * f33) > f5)) {
      f20 = Math_fround(HEAPF32[i1 + 64 >> 2]);
      f20 = Math_fround(f20 * f20);
      f33 = Math_fround(HEAPF32[i1 + 68 >> 2]);
      if (!(Math_fround(f20 + Math_fround(f33 * f33)) > f4)) {
       i32 = i1 + 144 | 0;
       f33 = Math_fround(f27 + Math_fround(HEAPF32[i32 >> 2]));
       HEAPF32[i32 >> 2] = f33;
       f3 = f3 < f33 ? f3 : f33;
       break;
      }
     }
    }
    HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    f3 = Math_fround(0.0);
   } while (0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i6 | 0));
 } else f3 = Math_fround(3402823469999999843913219.0e14);
 if (!(f3 >= Math_fround(HEAPF32[gb + 151912 >> 2])) | i12 | i8 ^ 1) {
  __ZN15b2ContactSolverD2Ev(i30);
  STACKTOP = i31;
  return;
 }
 i2 = i28 + 8 | 0;
 i1 = 0;
 do {
  i32 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i28 = i32 + 4 | 0;
  HEAP16[i28 >> 1] = HEAPU16[i28 >> 1] & 65533;
  HEAPF32[i32 + 144 >> 2] = Math_fround(0.0);
  i32 = i32 + 64 | 0;
  HEAP32[i32 >> 2] = 0;
  HEAP32[i32 + 4 >> 2] = 0;
  HEAP32[i32 + 8 >> 2] = 0;
  HEAP32[i32 + 12 >> 2] = 0;
  HEAP32[i32 + 16 >> 2] = 0;
  HEAP32[i32 + 20 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i29 >> 2] | 0));
 __ZN15b2ContactSolverD2Ev(i30);
 STACKTOP = i31;
 return;
}

function __ZN5physx2Gu14sweepBoxSphereERKNS0_3BoxEfRKNS_6PxVec3ES6_fRfRS4_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i46, f43, i33, i32, f2, i48, i47, i1) {
 i46 = i46 | 0;
 f43 = Math_fround(f43);
 i33 = i33 | 0;
 i32 = i32 | 0;
 f2 = Math_fround(f2);
 i48 = i48 | 0;
 i47 = i47 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i49 + 136 | 0;
 i22 = i49 + 152 | 0;
 i23 = i49 + 104 | 0;
 i25 = i49 + 96 | 0;
 i26 = i49 + 92 | 0;
 i24 = i49 + 80 | 0;
 i42 = i49 + 68 | 0;
 i41 = i49 + 56 | 0;
 i45 = i49 + 52 | 0;
 i44 = i49 + 48 | 0;
 i40 = i49 + 36 | 0;
 i34 = i49 + 24 | 0;
 i35 = i49 + 12 | 0;
 i39 = i49;
 if (!(HEAP16[i1 >> 1] & 16)) {
  HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
  i5 = i33 + 4 | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
  i1 = i33 + 8 | 0;
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 >> 2];
  HEAPF32[i4 + 12 >> 2] = f43;
  if (__ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i4, i46) | 0) {
   HEAPF32[i48 >> 2] = Math_fround(0.0);
   f14 = Math_fround(-Math_fround(HEAPF32[i32 >> 2]));
   f15 = Math_fround(-Math_fround(HEAPF32[i32 + 4 >> 2]));
   f43 = Math_fround(-Math_fround(HEAPF32[i32 + 8 >> 2]));
   HEAPF32[i47 >> 2] = f14;
   HEAPF32[i47 + 4 >> 2] = f15;
   HEAPF32[i47 + 8 >> 2] = f43;
   i48 = 1;
   STACKTOP = i49;
   return i48 | 0;
  } else i31 = i1;
 } else {
  i31 = i33 + 8 | 0;
  i5 = i33 + 4 | 0;
 }
 i28 = i46 + 36 | 0;
 i36 = i46 + 48 | 0;
 i21 = i46 + 12 | 0;
 i27 = i46 + 24 | 0;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i22, i28, i36, i46, i21, i27);
 i8 = i23 + 4 | 0;
 i9 = i23 + 8 | 0;
 i10 = i23 + 12 | 0;
 i12 = i23 + 16 | 0;
 i13 = i23 + 20 | 0;
 i16 = i23 + 24 | 0;
 i29 = i32 + 4 | 0;
 i30 = i32 + 8 | 0;
 i17 = i24 + 4 | 0;
 i18 = i24 + 8 | 0;
 i19 = i23 + 12 | 0;
 i37 = i47 + 4 | 0;
 i38 = i47 + 8 | 0;
 i20 = i25 + 4 | 0;
 i1 = 0;
 i6 = __ZN5physx2Gu11getBoxEdgesEv() | 0;
 i7 = 0;
 do {
  i50 = HEAPU8[i6 >> 0] | 0;
  i4 = HEAPU8[i6 + 1 >> 0] | 0;
  i6 = i6 + 2 | 0;
  HEAP32[i23 >> 2] = HEAP32[i22 + (i50 * 12 | 0) >> 2];
  HEAP32[i8 >> 2] = HEAP32[i22 + (i50 * 12 | 0) + 4 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i22 + (i50 * 12 | 0) + 8 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i22 + (i4 * 12 | 0) >> 2];
  HEAP32[i12 >> 2] = HEAP32[i22 + (i4 * 12 | 0) + 4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i22 + (i4 * 12 | 0) + 8 >> 2];
  HEAPF32[i16 >> 2] = f43;
  i4 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i33, i32, i23, i10, f43, i25) | 0;
  if (i4) {
   f3 = Math_fround(HEAPF32[i25 >> 2]);
   if ((i4 | 0) != 1) {
    f15 = Math_fround(HEAPF32[i20 >> 2]);
    f3 = f3 < f15 ? f3 : f15;
   }
   HEAPF32[i26 >> 2] = f3;
   if (!(!(f3 >= Math_fround(0.0)) | !(f3 <= f2))) {
    f53 = Math_fround(HEAPF32[i32 >> 2]);
    f14 = Math_fround(HEAPF32[i29 >> 2]);
    f53 = Math_fround(f3 * f53);
    f14 = Math_fround(f3 * f14);
    f51 = Math_fround(f3 * Math_fround(HEAPF32[i30 >> 2]));
    f53 = Math_fround(f53 + Math_fround(HEAPF32[i33 >> 2]));
    f14 = Math_fround(f14 + Math_fround(HEAPF32[i5 >> 2]));
    f51 = Math_fround(f51 + Math_fround(HEAPF32[i31 >> 2]));
    HEAPF32[i24 >> 2] = f53;
    HEAPF32[i17 >> 2] = f14;
    HEAPF32[i18 >> 2] = f51;
    Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i23, i10, i24, i26));
    f51 = Math_fround(HEAPF32[i26 >> 2]);
    f14 = Math_fround(HEAPF32[i19 >> 2]);
    f53 = Math_fround(HEAPF32[i23 >> 2]);
    f14 = Math_fround(f14 - f53);
    f15 = Math_fround(HEAPF32[i12 >> 2]);
    f52 = Math_fround(HEAPF32[i8 >> 2]);
    f15 = Math_fround(f15 - f52);
    f11 = Math_fround(HEAPF32[i13 >> 2]);
    f2 = Math_fround(HEAPF32[i9 >> 2]);
    f14 = Math_fround(f53 + Math_fround(f51 * f14));
    f15 = Math_fround(f52 + Math_fround(f51 * f15));
    f2 = Math_fround(f2 + Math_fround(f51 * Math_fround(f11 - f2)));
    f14 = Math_fround(f14 - Math_fround(HEAPF32[i24 >> 2]));
    f15 = Math_fround(f15 - Math_fround(HEAPF32[i17 >> 2]));
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i18 >> 2]));
    HEAPF32[i47 >> 2] = f14;
    HEAPF32[i37 >> 2] = f15;
    HEAPF32[i38 >> 2] = f2;
    f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f2 * f2))));
    if (f11 > Math_fround(0.0)) {
     f53 = Math_fround(Math_fround(1.0) / f11);
     HEAPF32[i47 >> 2] = Math_fround(f14 * f53);
     HEAPF32[i37 >> 2] = Math_fround(f15 * f53);
     HEAPF32[i38 >> 2] = Math_fround(f2 * f53);
     f2 = f3;
     i1 = 1;
    } else {
     f2 = f3;
     i1 = 1;
    }
   }
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 12);
 f3 = Math_fround(HEAPF32[i46 >> 2]);
 i18 = i46 + 4 | 0;
 f15 = Math_fround(HEAPF32[i18 >> 2]);
 i19 = i46 + 8 | 0;
 f51 = Math_fround(HEAPF32[i19 >> 2]);
 f57 = Math_fround(HEAPF32[i21 >> 2]);
 i16 = i46 + 16 | 0;
 f56 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i46 + 20 | 0;
 f53 = Math_fround(HEAPF32[i17 >> 2]);
 f54 = Math_fround(HEAPF32[i27 >> 2]);
 i12 = i46 + 28 | 0;
 f14 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i46 + 32 | 0;
 f52 = Math_fround(HEAPF32[i13 >> 2]);
 f60 = Math_fround(HEAPF32[i28 >> 2]);
 f59 = Math_fround(HEAPF32[i46 + 40 >> 2]);
 f58 = Math_fround(HEAPF32[i46 + 44 >> 2]);
 f60 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f60);
 f59 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f59);
 f58 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f58);
 f11 = Math_fround(Math_fround(Math_fround(f57 * f60) + Math_fround(f56 * f59)) + Math_fround(f53 * f58));
 f55 = Math_fround(Math_fround(Math_fround(f54 * f60) + Math_fround(f14 * f59)) + Math_fround(f52 * f58));
 HEAPF32[i42 >> 2] = Math_fround(Math_fround(Math_fround(f3 * f60) + Math_fround(f15 * f59)) + Math_fround(f51 * f58));
 HEAPF32[i42 + 4 >> 2] = f11;
 HEAPF32[i42 + 8 >> 2] = f55;
 f55 = Math_fround(HEAPF32[i32 >> 2]);
 f3 = Math_fround(f3 * f55);
 f11 = Math_fround(HEAPF32[i29 >> 2]);
 f15 = Math_fround(f3 + Math_fround(f15 * f11));
 f3 = Math_fround(HEAPF32[i30 >> 2]);
 i9 = i46 + 12 | 0;
 f53 = Math_fround(Math_fround(Math_fround(f55 * f57) + Math_fround(f11 * f56)) + Math_fround(f3 * f53));
 i10 = i46 + 24 | 0;
 f52 = Math_fround(Math_fround(Math_fround(f55 * f54) + Math_fround(f11 * f14)) + Math_fround(f3 * f52));
 HEAPF32[i41 >> 2] = Math_fround(f15 + Math_fround(f51 * f3));
 HEAPF32[i41 + 4 >> 2] = f53;
 HEAPF32[i41 + 8 >> 2] = f52;
 f52 = Math_fround(HEAPF32[i36 >> 2]);
 i5 = i40 + 4 | 0;
 i6 = i46 + 52 | 0;
 i50 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i50;
 i7 = i40 + 8 | 0;
 i8 = i46 + 56 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 f52 = Math_fround(f52 + f43);
 HEAPF32[i40 >> 2] = f52;
 f52 = Math_fround(-f52);
 f53 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f3 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i34 >> 2] = f52;
 HEAPF32[i34 + 4 >> 2] = f53;
 HEAPF32[i34 + 8 >> 2] = f3;
 i4 = __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i34, i40, i42, i41, i45, i44) | 0;
 f3 = Math_fround(HEAPF32[i45 >> 2]);
 if (!(!(f3 <= f2) | ((i4 | 0) == -1 | !(f3 >= Math_fround(-9.99999974e-06))))) {
  i1 = f3 > Math_fround(0.0);
  f2 = i1 ? f3 : Math_fround(0.0);
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) >> 2]);
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i46 >> 2]));
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i18 >> 2]));
  f60 = Math_fround(f60 * Math_fround(HEAPF32[i19 >> 2]));
  f56 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 4 >> 2]);
  f57 = Math_fround(f56 * Math_fround(HEAPF32[i9 >> 2]));
  f55 = Math_fround(f56 * Math_fround(HEAPF32[i16 >> 2]));
  f57 = Math_fround(f59 + f57);
  f55 = Math_fround(f58 + f55);
  f56 = Math_fround(f60 + Math_fround(f56 * Math_fround(HEAPF32[i17 >> 2])));
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 8 >> 2]);
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i10 >> 2]));
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i12 >> 2]));
  f59 = Math_fround(f55 + f59);
  f60 = Math_fround(f56 + Math_fround(f60 * Math_fround(HEAPF32[i13 >> 2])));
  HEAPF32[i47 >> 2] = Math_fround(f57 + f58);
  HEAPF32[i37 >> 2] = f59;
  HEAPF32[i38 >> 2] = f60;
  i1 = 1;
 }
 i50 = HEAP32[i36 >> 2] | 0;
 HEAP32[i40 >> 2] = i50;
 f60 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 f60 = Math_fround(f60 + f43);
 HEAPF32[i5 >> 2] = f60;
 f59 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f60 = Math_fround(-f60);
 f3 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i35 >> 2] = f59;
 HEAPF32[i35 + 4 >> 2] = f60;
 HEAPF32[i35 + 8 >> 2] = f3;
 i4 = __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i35, i40, i42, i41, i45, i44) | 0;
 f3 = Math_fround(HEAPF32[i45 >> 2]);
 if (!(!(f3 <= f2) | ((i4 | 0) == -1 | !(f3 >= Math_fround(-9.99999974e-06))))) {
  i1 = f3 > Math_fround(0.0);
  f2 = i1 ? f3 : Math_fround(0.0);
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) >> 2]);
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i46 >> 2]));
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i18 >> 2]));
  f60 = Math_fround(f60 * Math_fround(HEAPF32[i19 >> 2]));
  f56 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 4 >> 2]);
  f57 = Math_fround(f56 * Math_fround(HEAPF32[i9 >> 2]));
  f55 = Math_fround(f56 * Math_fround(HEAPF32[i16 >> 2]));
  f57 = Math_fround(f59 + f57);
  f55 = Math_fround(f58 + f55);
  f56 = Math_fround(f60 + Math_fround(f56 * Math_fround(HEAPF32[i17 >> 2])));
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 8 >> 2]);
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i10 >> 2]));
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i12 >> 2]));
  f59 = Math_fround(f55 + f59);
  f60 = Math_fround(f56 + Math_fround(f60 * Math_fround(HEAPF32[i13 >> 2])));
  HEAPF32[i47 >> 2] = Math_fround(f57 + f58);
  HEAPF32[i37 >> 2] = f59;
  HEAPF32[i38 >> 2] = f60;
  i1 = 1;
 }
 i50 = HEAP32[i36 >> 2] | 0;
 HEAP32[i40 >> 2] = i50;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 f3 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f43);
 HEAPF32[i7 >> 2] = f3;
 f59 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f60 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f3 = Math_fround(-f3);
 HEAPF32[i39 >> 2] = f59;
 HEAPF32[i39 + 4 >> 2] = f60;
 HEAPF32[i39 + 8 >> 2] = f3;
 i4 = __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i39, i40, i42, i41, i45, i44) | 0;
 f3 = Math_fround(HEAPF32[i45 >> 2]);
 if (!(!(f3 <= f2) | ((i4 | 0) == -1 | !(f3 >= Math_fround(-9.99999974e-06))))) {
  i1 = f3 > Math_fround(0.0);
  f2 = i1 ? f3 : Math_fround(0.0);
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) >> 2]);
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i46 >> 2]));
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i18 >> 2]));
  f60 = Math_fround(f60 * Math_fround(HEAPF32[i19 >> 2]));
  f56 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 4 >> 2]);
  f57 = Math_fround(f56 * Math_fround(HEAPF32[i9 >> 2]));
  f55 = Math_fround(f56 * Math_fround(HEAPF32[i16 >> 2]));
  f57 = Math_fround(f59 + f57);
  f55 = Math_fround(f58 + f55);
  f56 = Math_fround(f60 + Math_fround(f56 * Math_fround(HEAPF32[i17 >> 2])));
  f60 = Math_fround(HEAPF32[gb + 85248 + (i4 * 12 | 0) + 8 >> 2]);
  f58 = Math_fround(f60 * Math_fround(HEAPF32[i10 >> 2]));
  f59 = Math_fround(f60 * Math_fround(HEAPF32[i12 >> 2]));
  f59 = Math_fround(f55 + f59);
  f60 = Math_fround(f56 + Math_fround(f60 * Math_fround(HEAPF32[i13 >> 2])));
  HEAPF32[i47 >> 2] = Math_fround(f57 + f58);
  HEAPF32[i37 >> 2] = f59;
  HEAPF32[i38 >> 2] = f60;
  i1 = 1;
 }
 HEAPF32[i48 >> 2] = f2;
 i50 = i1;
 STACKTOP = i49;
 return i50 | 0;
}

function __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 168 | 0, i10);
 i5 = i6 + 184 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 212 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 240 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 256 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 272 | 0, i10 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 288 | 0, i10 + 8 | 0);
 i5 = i6 + 304 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 320 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 11 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 11 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i43, i19, i36, i37, i38, f39, f40) {
 i43 = i43 | 0;
 i19 = i19 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 f39 = Math_fround(f39);
 f40 = Math_fround(f40);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i46;
 i20 = i46 + 64 | 0;
 i21 = i46 + 48 | 0;
 i1 = i46 + 24 | 0;
 if (!i19) {
  STACKTOP = i46;
  return;
 }
 i6 = i19 + 24 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 i8 = i19 + 36 | 0;
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(f15 + f18);
 i2 = i19 + 28 | 0;
 i3 = i19 + 40 | 0;
 i9 = i19 + 32 | 0;
 f16 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i19 + 44 | 0;
 f17 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f7 * Math_fround(.5));
 f14 = Math_fround(Math_fround(f16 + f17) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f18 - f15) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f17 - f16) * Math_fround(.5));
 f17 = Math_fround(HEAPF32[i38 >> 2]);
 i42 = i38 + 8 | 0;
 f18 = Math_fround(HEAPF32[i42 >> 2]);
 f4 = Math_fround(f17 - f7);
 f5 = Math_fround(f18 - f14);
 if (f4 < Math_fround(-f15)) {
  f4 = Math_fround(f15 + f4);
  f4 = Math_fround(Math_fround(f4 * f4) + Math_fround(0.0));
 } else if (f4 > f15) {
  f4 = Math_fround(f4 - f15);
  f4 = Math_fround(Math_fround(f4 * f4) + Math_fround(0.0));
 } else f4 = Math_fround(0.0);
 if (f5 < Math_fround(-f16)) {
  f5 = Math_fround(f16 + f5);
  f4 = Math_fround(Math_fround(f5 * f5) + f4);
 } else if (f5 > f16) {
  f5 = Math_fround(f5 - f16);
  f4 = Math_fround(Math_fround(f5 * f5) + f4);
 }
 if (f4 > f40) {
  STACKTOP = i46;
  return;
 }
 i44 = i19 + 16 | 0;
 i11 = HEAP32[i44 >> 2] | 0;
 if (!i11) {
  f16 = Math_fround(Math_fround(HEAPF32[i19 + 64 >> 2]) * f17);
  f17 = Math_fround(HEAPF32[i19 + 68 >> 2]);
  f17 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i38 + 4 >> 2])));
  f18 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i19 + 72 >> 2]) * f18));
  if (Math_fround(Math_fround(HEAPF32[i19 + 76 >> 2]) + f18) > Math_fround(0.0)) {
   __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i43, HEAP32[i19 + 84 >> 2] | 0, i36, i37, i38, f39, f40);
   __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i43, HEAP32[i19 + 80 >> 2] | 0, i36, i37, i38, f39, f40);
   STACKTOP = i46;
   return;
  } else {
   __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i43, HEAP32[i19 + 80 >> 2] | 0, i36, i37, i38, f39, f40);
   __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff(i43, HEAP32[i19 + 84 >> 2] | 0, i36, i37, i38, f39, f40);
   STACKTOP = i46;
   return;
  }
 }
 if (!(f4 > f39)) {
  i12 = i19 + 4 | 0;
  i13 = i43 + 120 | 0;
  i19 = i43 + 124 | 0;
  i20 = i43 + 128 | 0;
  i21 = i43 + 136 | 0;
  i22 = i43 + 140 | 0;
  i23 = i43 + 144 | 0;
  i24 = i45 + 4 | 0;
  i25 = i45 + 8 | 0;
  i26 = i45 + 16 | 0;
  i27 = i45 + 20 | 0;
  i28 = i45 + 12 | 0;
  i29 = i43 + 156 | 0;
  i30 = i43 + 168 | 0;
  i31 = i43 + 172 | 0;
  i32 = i43 + 160 | 0;
  i33 = i37 + 12 | 0;
  i34 = i37 + 16 | 0;
  i35 = i37 + 4 | 0;
  i1 = 0;
  f4 = f18;
  i2 = i11;
  while (1) {
   i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i3 + (i10 * 40 | 0) >> 2]);
   f14 = Math_fround(f14 * Math_fround(HEAPF32[i13 >> 2]));
   f5 = Math_fround(HEAPF32[i3 + (i10 * 40 | 0) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   f16 = Math_fround(HEAPF32[i3 + (i10 * 40 | 0) + 8 >> 2]);
   f16 = Math_fround(f16 * Math_fround(HEAPF32[i20 >> 2]));
   f14 = Math_fround(f14 + Math_fround(HEAPF32[i21 >> 2]));
   f15 = Math_fround(HEAPF32[i22 >> 2]);
   f16 = Math_fround(f16 + Math_fround(HEAPF32[i23 >> 2]));
   f18 = Math_fround(f14 - f17);
   f4 = Math_fround(f16 - f4);
   f4 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(0.0)) + Math_fround(f4 * f4));
   HEAPF32[i3 + (i10 * 40 | 0) + 36 >> 2] = f4;
   if (!(f4 >= f40)) {
    f15 = Math_fround(Math_fround(f5 * f7) + f15);
    i11 = HEAP32[i3 + (i10 * 40 | 0) + 32 >> 2] | 0;
    i9 = HEAP32[(HEAP32[i43 >> 2] | 0) + 28 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 20 >> 2]);
    f17 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 24 >> 2]);
    f18 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 28 >> 2]);
    f50 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 32 >> 2]);
    f49 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 36 >> 2]);
    f47 = Math_fround(HEAPF32[i9 + (i11 * 156 | 0) + 40 >> 2]);
    f5 = Math_fround(HEAPF32[i3 + (i10 * 40 | 0) + 12 >> 2]);
    f48 = Math_fround(HEAPF32[i3 + (i10 * 40 | 0) + 16 >> 2]);
    f7 = Math_fround(f7 * f5);
    f17 = Math_fround(f17 * f48);
    f18 = Math_fround(f18 * f5);
    HEAPF32[i28 >> 2] = Math_fround(f50 * f5);
    HEAPF32[i26 >> 2] = Math_fround(f49 * f48);
    HEAPF32[i27 >> 2] = Math_fround(f47 * f5);
    HEAPF32[i45 >> 2] = Math_fround(f14 + f7);
    HEAPF32[i24 >> 2] = Math_fround(f15 + f17);
    HEAPF32[i25 >> 2] = Math_fround(f16 + f18);
    if (!(f4 >= f39)) i41 = 58; else if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i45, i36) | 0) {
     i3 = HEAP32[i33 >> 2] | 0;
     i6 = i3 + 1 | 0;
     i8 = HEAP32[i34 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i34 >> 2] = i2;
       HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i2 << 2, 4, i35, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i35, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i33 >> 2] << 2 | 0) | 0;
       HEAP32[i34 >> 2] = i2;
       HEAP32[i37 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i33 >> 2] = i6;
     HEAP32[(HEAP32[i37 >> 2] | 0) + (i3 << 2) >> 2] = i10;
    } else i41 = 58;
    if ((i41 | 0) == 58) {
     i41 = 0;
     i3 = HEAP32[i30 >> 2] | 0;
     i6 = i3 + 1 | 0;
     i8 = HEAP32[i31 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i31 >> 2] = i2;
       HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i2 << 2, 4, i32, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i32, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i30 >> 2] << 2 | 0) | 0;
       HEAP32[i31 >> 2] = i2;
       HEAP32[i29 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i30 >> 2] = i6;
     HEAP32[(HEAP32[i29 >> 2] | 0) + (i3 << 2) >> 2] = i10;
    }
    i2 = HEAP32[i44 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break;
   f17 = Math_fround(HEAPF32[i38 >> 2]);
   f4 = Math_fround(HEAPF32[i42 >> 2]);
  }
  STACKTOP = i46;
  return;
 }
 f50 = Math_fround(HEAPF32[i2 >> 2]);
 f49 = Math_fround(HEAPF32[i3 >> 2]);
 f48 = Math_fround(Math_fround(f50 + f49) * Math_fround(.5));
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i1 + 4 >> 2] = f48;
 HEAPF32[i1 + 8 >> 2] = f14;
 f50 = Math_fround(Math_fround(f49 - f50) * Math_fround(.5));
 HEAPF32[i1 + 12 >> 2] = f15;
 HEAPF32[i1 + 16 >> 2] = f50;
 HEAPF32[i1 + 20 >> 2] = f16;
 if (!(__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i1, i36) | 0)) {
  STACKTOP = i46;
  return;
 }
 f4 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = Math_fround(HEAPF32[i42 >> 2]);
 if (Math_fround(HEAPF32[i8 >> 2]) < f4) i1 = 2; else if (Math_fround(HEAPF32[i6 >> 2]) < f4) i1 = 1; else i1 = 0;
 do if (!(Math_fround(HEAPF32[i10 >> 2]) < f5)) if (Math_fround(HEAPF32[i9 >> 2]) < f5) {
  i1 = i1 + 3 | 0;
  break;
 } else {
  i1 = i1 + 6 | 0;
  break;
 } while (0);
 i6 = i19 + 56 | 0;
 HEAP32[i6 >> 2] = i1;
 __ZN12TreeRenderer11RenderBatchER14TreeBinaryTreef(i43, i19, Math_fround(0.0));
 i6 = HEAP32[i6 >> 2] | 0;
 i1 = i19 + 52 | 0;
 if ((i6 | 0) != (HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i6;
  i2 = HEAP32[i19 >> 2] | 0;
  i11 = HEAP32[i44 >> 2] | 0;
  i8 = i20 + 12 | 0;
  HEAP32[i8 >> 2] = i11;
  i12 = i20 + 16 | 0;
  HEAP32[i12 >> 2] = i11;
  i13 = i20 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i45, gb + 64016 | 0);
  i44 = i45;
  i10 = HEAP32[i44 + 4 >> 2] | 0;
  i9 = i13;
  HEAP32[i9 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 << 3, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i20 >> 2] = i9;
  i10 = (i11 | 0) == 0;
  if (!i10) {
   i1 = 0;
   do {
    HEAP32[i9 + (i1 << 3) >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i11 | 0));
  }
  if ((i6 | 0) != 4) {
   if (!i10) {
    i3 = HEAP32[i19 + 4 >> 2] | 0;
    i2 = HEAP32[i2 + 16 >> 2] | 0;
    f5 = Math_fround(HEAPF32[gb + 1467504 + (i6 * 12 | 0) >> 2]);
    f7 = Math_fround(HEAPF32[gb + 1467504 + (i6 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[gb + 1467504 + (i6 * 12 | 0) + 8 >> 2]);
    i1 = 0;
    do {
     i44 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
     f50 = Math_fround(f5 * Math_fround(HEAPF32[i2 + (i44 * 40 | 0) >> 2]));
     f50 = Math_fround(f50 + Math_fround(f7 * Math_fround(HEAPF32[i2 + (i44 * 40 | 0) + 4 >> 2])));
     HEAPF32[i9 + (i1 << 3) + 4 >> 2] = Math_fround(f50 + Math_fround(f4 * Math_fround(HEAPF32[i2 + (i44 * 40 | 0) + 8 >> 2])));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i11 | 0));
   }
   __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_(i9, i9 + (HEAP32[i8 >> 2] << 3) | 0);
  }
  i2 = i11 * 6 | 0;
  HEAP32[i21 >> 2] = 0;
  i8 = i21 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i21 + 12 >> 2] = i1;
  if (!i2) i6 = 0; else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i21);
    i1 = HEAP32[i21 + 12 >> 2] | 0;
   }
   i44 = i11 * 12 | 0;
   HEAP32[i45 >> 2] = 1;
   HEAP32[i45 + 4 >> 2] = i1;
   i43 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i44, 16, i45, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i21 >> 2] = i43;
   i6 = i43 + (i2 << 1) | 0;
   HEAP32[i21 + 8 >> 2] = i6;
   _memset(i43 | 0, 0, i44 | 0) | 0;
   HEAP32[i8 >> 2] = i6;
  }
  if (i10) i1 = HEAP32[i21 >> 2] | 0; else {
   i3 = HEAP32[i20 >> 2] | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   i2 = 0;
   do {
    i44 = i2 * 6 | 0;
    i43 = HEAP32[i3 + (i2 << 3) >> 2] << 2;
    HEAP16[i1 + (i44 << 1) >> 1] = i43;
    i42 = (i43 | 1) & 65535;
    HEAP16[i1 + ((i44 | 1) << 1) >> 1] = i42;
    i41 = (i43 | 2) & 65535;
    HEAP16[i1 + (i44 + 2 << 1) >> 1] = i41;
    HEAP16[i1 + (i44 + 3 << 1) >> 1] = i41;
    HEAP16[i1 + (i44 + 4 << 1) >> 1] = i42;
    HEAP16[i1 + (i44 + 5 << 1) >> 1] = i43 | 3;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i11 | 0));
  }
  __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(HEAP32[i19 + 48 >> 2] | 0, (i1 | 0) == (i6 | 0) ? 0 : i1, i6 - i1 >> 1, 0, 0, 17) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -2 - i2 | 0) >>> 1) << 1);
   i44 = HEAP32[i21 + 12 >> 2] | 0;
   HEAP32[i45 >> 2] = 1;
   HEAP32[i45 + 4 >> 2] = i44;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i45);
  }
  if ((HEAP32[i12 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i13);
   HEAP32[i20 >> 2] = 0;
  }
 }
 STACKTOP = i46;
 return;
}

function __ZN4Mesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20;
 i9 = i20 + 352 | 0;
 i10 = i20 + 248 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18, i19);
 i14 = i18 + 32 | 0;
 if ((HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i14 >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  i17 = i2 + 4 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  if (!(HEAP32[i17 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i14 >> 2] = i1;
 }
 i15 = i18 + 44 | 0;
 i12 = (HEAP8[i15 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i18, 1);
 i7 = HEAP32[i14 >> 2] | 0;
 i3 = i7 + 128 | 0;
 i7 = i7 + 132 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 52 | 0;
 HEAP32[i13 >> 2] = i4;
 i16 = i19 + 16 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i17 = i19 + 24 | 0;
 if (i6 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i16 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN7SubMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i19);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN14BlendShapeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 72 | 0, i19);
 i1 = HEAP32[i14 >> 2] | 0;
 i5 = i1 + 156 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 i3 = HEAP32[i16 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i16 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
 i1 = HEAP32[i1 + 144 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i8 << 6) | 0;
 if (i8 | 0) do {
  __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i19);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i18 + 156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i16 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
 i1 = HEAP32[i18 + 144 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i16 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i2 = i18 + 184 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i16 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i2, 4);
  i4 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i17 >> 2] | 0;
 }
 i8 = i18 + 40 | 0;
 if ((i4 + 1 | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i8 >> 0] | 0;
  i2 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
  HEAP32[i16 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i8, 1);
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = i18 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
  HEAP32[i16 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i1, 1);
  i1 = HEAP32[i16 >> 2] | 0;
 }
 i2 = i18 + 42 | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
  HEAP32[i16 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i2, 1);
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = i18 + 43 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
 if (!(HEAP8[i8 >> 0] | 0)) i11 = 40; else if (!(HEAP32[i19 >> 2] & 16384)) {
  HEAP32[i9 >> 2] = 0;
  i4 = i9 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i9 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  i6 = i9 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
  i7 = i13;
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i6;
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN14VertexDataInfoC2Ev(i10);
  __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 >> 2] = 0;
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i16 >> 2] = i2;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i16 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i2 = i1 + (i7 << 5) | 0;
  if (i7 | 0) do {
   __ZN13BoneInfluence8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i19);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZN10VertexData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i19);
  __ZN10VertexDataD2Ev(i10);
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i6);
   HEAP32[i9 >> 2] = 0;
  }
  i1 = 1;
 } else i11 = 40;
 if ((i11 | 0) == 40) {
  i7 = HEAP32[i14 >> 2] | 0;
  i2 = i7 + 112 | 0;
  i7 = i7 + 116 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = i3 - i1 | 0;
  HEAP32[i13 >> 2] = i4;
  i5 = HEAP32[i16 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i16 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
  }
  if ((i1 | 0) != (i3 | 0)) do {
   i2 = HEAP32[i16 >> 2] | 0;
   if ((i2 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i1, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
  i1 = HEAP32[i14 >> 2] | 0;
  i5 = i1 + 176 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i13 >> 2] = i2;
  i3 = HEAP32[i16 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i16 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i13, 4);
  i1 = HEAP32[i1 + 164 >> 2] | 0;
  i11 = HEAP32[i5 >> 2] | 0;
  i2 = i1 + (i11 << 5) | 0;
  if (i11 | 0) do {
   __ZN13BoneInfluence8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i19);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZN10VertexData8TransferI19StreamedBinaryWriteILb0EEEEvRT_((HEAP32[i14 >> 2] | 0) + 8 | 0, i19);
  i1 = 0;
 }
 i21 = i13 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP8[i13 + 12 >> 0] = 0;
 i2 = i13 + 44 | 0;
 i3 = i13 + 72 | 0;
 i4 = i13 + 92 | 0;
 i5 = i13 + 120 | 0;
 i6 = i13 + 140 | 0;
 i7 = i13 + 168 | 0;
 i9 = i13 + 188 | 0;
 i10 = i13 + 208 | 0;
 i11 = i13 + 228 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 20 >> 2] = 0;
 HEAP8[i21 + 24 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i5 + 16 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP8[i6 + 24 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i10 + 16 >> 0] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
 if (i1) {
  __ZN14CompressedMesh8CompressERK4MeshRK21CompressedMeshQuality(i13, i18, gb + 58120 + (HEAPU8[i8 >> 0] << 4) | 0);
  __ZN14CompressedMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13, i19);
 } else __ZN14CompressedMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13, i19);
 __ZN14CompressedMeshD2Ev(i13);
 if (!i12) {
  i4 = HEAP32[i14 >> 2] | 0;
  i5 = i4 + 8 | 0;
  i2 = HEAP16[i4 + 18 >> 1] | 0;
  if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i6 = 0;
   i8 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i6 = 0;
    i8 = 1;
   } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i6 = 0;
    i8 = 1;
   } else {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i6 = i1 + ((i2 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i8 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i2 = i2 >>> 16 & 65535;
   }
  }
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) i7 = 0; else {
   i1 = HEAP32[i4 + 100 >> 2] | 0;
   i3 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i3) i7 = 0; else {
    if (!(HEAP8[i4 + 19 >> 0] | 0)) {
     i7 = 0;
     break;
    }
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    i7 = i3 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) + (i2 >>> 8 & 255)) | 0;
    i2 = i2 >>> 16 & 65535;
   }
  } while (0);
  do if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
   i1 = 0;
   i5 = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i5 = 1;
    break;
   }
   if (!(HEAP8[i4 + 19 >> 0] | 0)) {
    i1 = 0;
    i5 = 1;
    break;
   }
   i21 = HEAP16[i4 + 16 >> 1] | 0;
   i1 = i1 + (((i21 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i21 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  } while (0);
  if ((i6 | 0) != (i7 | 0)) {
   i4 = i1;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
    i1 = i3 + i8 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  }
  HEAP8[i15 >> 0] = HEAP8[i15 >> 0] | 16;
 }
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 48 | 0, i19);
 i1 = i18 + 224 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i16 >> 2] = i3;
  i21 = i18 + 204 | 0;
  __ZN17CollisionMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_R4Mesh(i21, i19, i18);
  STACKTOP = i20;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i16, i1, 4);
  i21 = i18 + 204 | 0;
  __ZN17CollisionMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_R4Mesh(i21, i19, i18);
  STACKTOP = i20;
  return;
 }
}

function __ZN5physx24PxcContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i61, i62, i2, i3, i4, i1, i71) {
 i61 = i61 | 0;
 i62 = i62 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i71 = i71 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i63 = 0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i73 = 0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i70 + 72 | 0;
 i60 = i70 + 68 | 0;
 i63 = i70 + 64 | 0;
 i55 = i70 + 40 | 0;
 i57 = i70 + 32 | 0;
 i58 = i70 + 24 | 0;
 i56 = i70;
 f67 = Math_fround(HEAPF32[i2 >> 2]);
 f65 = Math_fround(f67 * Math_fround(2.0));
 f54 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f53 = Math_fround(f54 * Math_fround(2.0));
 f54 = Math_fround(Math_fround(f67 * f65) + Math_fround(Math_fround(f54 * f53) + Math_fround(-1.0)));
 f67 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f66 = Math_fround(f67 * f53);
 f52 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f66 = Math_fround(f66 + Math_fround(f65 * f52));
 f52 = Math_fround(Math_fround(f65 * f67) - Math_fround(f53 * f52));
 f53 = Math_fround(HEAPF32[i61 + 8 >> 2]);
 f54 = Math_fround(f53 * f54);
 f66 = Math_fround(f53 * f66);
 f52 = Math_fround(f53 * f52);
 HEAPF32[i59 >> 2] = f54;
 i5 = i59 + 4 | 0;
 HEAPF32[i5 >> 2] = f66;
 i13 = i59 + 8 | 0;
 HEAPF32[i13 >> 2] = f52;
 f66 = Math_fround(-f66);
 f52 = Math_fround(-f52);
 i1 = i59 + 12 | 0;
 HEAPF32[i1 >> 2] = Math_fround(-f54);
 i12 = i59 + 16 | 0;
 HEAPF32[i12 >> 2] = f66;
 i15 = i59 + 20 | 0;
 HEAPF32[i15 >> 2] = f52;
 i16 = i59 + 24 | 0;
 f52 = Math_fround(HEAPF32[i3 >> 2]);
 f66 = Math_fround(f52 * Math_fround(2.0));
 f54 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f53 = Math_fround(f54 * Math_fround(2.0));
 f54 = Math_fround(Math_fround(f52 * f66) + Math_fround(Math_fround(f54 * f53) + Math_fround(-1.0)));
 f52 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f67 = Math_fround(f52 * f53);
 f65 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f67 = Math_fround(f67 + Math_fround(f66 * f65));
 f65 = Math_fround(Math_fround(f66 * f52) - Math_fround(f53 * f65));
 f53 = Math_fround(HEAPF32[i62 + 8 >> 2]);
 f54 = Math_fround(f53 * f54);
 f67 = Math_fround(f53 * f67);
 f65 = Math_fround(f53 * f65);
 i17 = i59 + 28 | 0;
 i19 = i59 + 32 | 0;
 i18 = i59 + 40 | 0;
 i20 = i59 + 44 | 0;
 f53 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 i68 = i2 + 16 | 0;
 f53 = Math_fround(f53 - Math_fround(HEAPF32[i68 >> 2]));
 f52 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 i69 = i2 + 20 | 0;
 f52 = Math_fround(f52 - Math_fround(HEAPF32[i69 >> 2]));
 f66 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 i64 = i2 + 24 | 0;
 f66 = Math_fround(f66 - Math_fround(HEAPF32[i64 >> 2]));
 HEAPF32[i59 + 36 >> 2] = Math_fround(f53 - f54);
 HEAPF32[i18 >> 2] = Math_fround(f52 - f67);
 HEAPF32[i20 >> 2] = Math_fround(f66 - f65);
 HEAPF32[i16 >> 2] = Math_fround(f53 + f54);
 HEAPF32[i17 >> 2] = Math_fround(f52 + f67);
 HEAPF32[i19 >> 2] = Math_fround(f66 + f65);
 f65 = Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i59, i16, i60, i63));
 f66 = Math_fround(HEAPF32[i61 + 4 >> 2]);
 f67 = Math_fround(f66 + Math_fround(HEAPF32[i62 + 4 >> 2]));
 f52 = Math_fround(f67 + Math_fround(HEAPF32[i4 >> 2]));
 f52 = Math_fround(f52 * f52);
 if (!(f65 < f52)) {
  i71 = 0;
  STACKTOP = i70;
  return i71 | 0;
 }
 f54 = Math_fround(HEAPF32[i1 >> 2]);
 f53 = Math_fround(HEAPF32[i59 >> 2]);
 f54 = Math_fround(f54 - f53);
 f51 = Math_fround(HEAPF32[i12 >> 2]);
 f50 = Math_fround(HEAPF32[i5 >> 2]);
 f51 = Math_fround(f51 - f50);
 f46 = Math_fround(HEAPF32[i15 >> 2]);
 f45 = Math_fround(HEAPF32[i13 >> 2]);
 f46 = Math_fround(f46 - f45);
 HEAPF32[i55 >> 2] = f54;
 i1 = i55 + 4 | 0;
 HEAPF32[i1 >> 2] = f51;
 i2 = i55 + 8 | 0;
 HEAPF32[i2 >> 2] = f46;
 f48 = Math_fround(HEAPF32[i59 + 36 >> 2]);
 f47 = Math_fround(HEAPF32[i16 >> 2]);
 f48 = Math_fround(f48 - f47);
 f44 = Math_fround(HEAPF32[i18 >> 2]);
 f43 = Math_fround(HEAPF32[i17 >> 2]);
 f44 = Math_fround(f44 - f43);
 f42 = Math_fround(HEAPF32[i20 >> 2]);
 f41 = Math_fround(HEAPF32[i19 >> 2]);
 f42 = Math_fround(f42 - f41);
 i12 = i55 + 12 | 0;
 HEAPF32[i12 >> 2] = f48;
 i13 = i55 + 16 | 0;
 HEAPF32[i13 >> 2] = f44;
 i15 = i55 + 20 | 0;
 HEAPF32[i15 >> 2] = f42;
 f49 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f51 * f51)) + Math_fround(f46 * f46))));
 HEAPF32[i57 >> 2] = f49;
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f48 * f48) + Math_fround(f44 * f44)) + Math_fround(f42 * f42))));
 HEAPF32[i57 + 4 >> 2] = f10;
 if (f49 != Math_fround(0.0)) {
  f14 = Math_fround(Math_fround(1.0) / f49);
  f9 = Math_fround(f14 * f54);
  HEAPF32[i55 >> 2] = f9;
  f11 = Math_fround(f14 * f51);
  HEAPF32[i1 >> 2] = f11;
  f14 = Math_fround(f14 * f46);
  HEAPF32[i2 >> 2] = f14;
 } else {
  f14 = f46;
  f11 = f51;
  f9 = f54;
 }
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 if (f10 != Math_fround(0.0)) {
  f8 = Math_fround(Math_fround(1.0) / f10);
  f6 = Math_fround(f8 * f48);
  HEAPF32[i12 >> 2] = f6;
  f7 = Math_fround(f8 * f44);
  HEAPF32[i13 >> 2] = f7;
  f8 = Math_fround(f8 * f42);
  HEAPF32[i15 >> 2] = f8;
 } else {
  f6 = f48;
  f7 = f44;
  f8 = f42;
 }
 if (Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f9 * f6) + Math_fround(f11 * f7)) + Math_fround(f14 * f8)))) > Math_fround(.999800026)) {
  f37 = Math_fround(f49 * Math_fround(.00100000005));
  HEAPF32[i58 >> 2] = f37;
  HEAPF32[i58 + 4 >> 2] = Math_fround(f10 * Math_fround(.00100000005));
  i31 = i56 + 12 | 0;
  i32 = i56 + 16 | 0;
  i33 = i56 + 4 | 0;
  i34 = i56 + 20 | 0;
  i35 = i56 + 8 | 0;
  i36 = i71 + 4096 | 0;
  f38 = f53;
  f39 = f50;
  f40 = f45;
  i2 = 0;
  i1 = 0;
  while (1) {
   i30 = 1 - i2 | 0;
   i15 = i56 + (i2 * 12 | 0) | 0;
   i16 = i59 + (i30 * 24 | 0) + 12 | 0;
   i17 = i59 + (i30 * 24 | 0) | 0;
   i18 = i56 + (i2 * 12 | 0) + 4 | 0;
   i19 = i56 + (i2 * 12 | 0) + 8 | 0;
   f25 = Math_fround(HEAPF32[i55 + (i2 * 12 | 0) >> 2]);
   f26 = Math_fround(-f37);
   i20 = i57 + (i2 << 2) | 0;
   i27 = i56 + (i30 * 12 | 0) | 0;
   i28 = i56 + (i30 * 12 | 0) + 4 | 0;
   i29 = i56 + (i30 * 12 | 0) + 8 | 0;
   i30 = (i30 | 0 ? i62 : i61) + 4 | 0;
   i13 = 0;
   do {
    i12 = i13 | 0 ? i16 : i17;
    i73 = HEAP32[i12 >> 2] | 0;
    HEAP32[i15 >> 2] = i73;
    i72 = HEAP32[i12 + 4 >> 2] | 0;
    HEAP32[i18 >> 2] = i72;
    i12 = HEAP32[i12 + 8 >> 2] | 0;
    HEAP32[i19 >> 2] = i12;
    f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i73, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f38);
    f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i72, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f39);
    f6 = Math_fround(Math_fround(Math_fround(f24 * f25) + Math_fround(f6 * f11)) + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f40) * f14));
    if (f6 >= f26) if (f6 <= Math_fround(f37 + Math_fround(HEAPF32[i20 >> 2]))) {
     f7 = Math_fround(f39 + Math_fround(f6 * f11));
     f22 = Math_fround(f40 + Math_fround(f6 * f14));
     HEAPF32[i27 >> 2] = Math_fround(f38 + Math_fround(f6 * f25));
     HEAPF32[i28 >> 2] = f7;
     HEAPF32[i29 >> 2] = f22;
     f22 = Math_fround(HEAPF32[i31 >> 2]);
     f7 = Math_fround(f22 - Math_fround(HEAPF32[i56 >> 2]));
     f23 = Math_fround(HEAPF32[i32 >> 2]);
     f8 = Math_fround(f23 - Math_fround(HEAPF32[i33 >> 2]));
     f24 = Math_fround(HEAPF32[i34 >> 2]);
     f9 = Math_fround(f24 - Math_fround(HEAPF32[i35 >> 2]));
     f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
     if (f6 < f52 & +f6 > 1.0e-06) {
      f21 = Math_fround(Math_sqrt(Math_fround(f6)));
      f6 = Math_fround(Math_fround(1.0) / f21);
      f10 = Math_fround(f7 * f6);
      f8 = Math_fround(f8 * f6);
      f6 = Math_fround(f9 * f6);
      f7 = Math_fround(HEAPF32[i30 >> 2]);
      i12 = HEAP32[i36 >> 2] | 0;
      if (i12 >>> 0 <= 63) {
       f21 = Math_fround(f21 - f67);
       f24 = Math_fround(Math_fround(f24 - Math_fround(f6 * f7)) + Math_fround(HEAPF32[i64 >> 2]));
       f23 = Math_fround(Math_fround(f23 - Math_fround(f8 * f7)) + Math_fround(HEAPF32[i69 >> 2]));
       f22 = Math_fround(Math_fround(f22 - Math_fround(f10 * f7)) + Math_fround(HEAPF32[i68 >> 2]));
       HEAP32[i36 >> 2] = i12 + 1;
       HEAPF32[i71 + (i12 << 6) >> 2] = f10;
       HEAPF32[i71 + (i12 << 6) + 4 >> 2] = f8;
       HEAPF32[i71 + (i12 << 6) + 8 >> 2] = f6;
       HEAPF32[i71 + (i12 << 6) + 16 >> 2] = f22;
       HEAPF32[i71 + (i12 << 6) + 20 >> 2] = f23;
       HEAPF32[i71 + (i12 << 6) + 24 >> 2] = f24;
       HEAPF32[i71 + (i12 << 6) + 12 >> 2] = f21;
       HEAP32[i71 + (i12 << 6) + 48 >> 2] = -1;
       HEAP32[i71 + (i12 << 6) + 52 >> 2] = -1;
      }
      i1 = i1 + 1 | 0;
     }
    }
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) != 2);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 2) break;
   f38 = Math_fround(HEAPF32[i59 + (i2 * 24 | 0) >> 2]);
   f39 = Math_fround(HEAPF32[i59 + (i2 * 24 | 0) + 4 >> 2]);
   f40 = Math_fround(HEAPF32[i59 + (i2 * 24 | 0) + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i55 + (i2 * 12 | 0) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i55 + (i2 * 12 | 0) + 8 >> 2]);
   f37 = Math_fround(HEAPF32[i58 + (i2 << 2) >> 2]);
  }
  if (i1 | 0) {
   i73 = 1;
   STACKTOP = i70;
   return i73 | 0;
  }
 }
 f10 = Math_fround(HEAPF32[i60 >> 2]);
 f14 = Math_fround(f53 + Math_fround(f10 * f54));
 f11 = Math_fround(f50 + Math_fround(f10 * f51));
 f10 = Math_fround(f45 + Math_fround(f10 * f46));
 f6 = Math_fround(HEAPF32[i63 >> 2]);
 f9 = Math_fround(f14 - Math_fround(f47 + Math_fround(f6 * f48)));
 f8 = Math_fround(f11 - Math_fround(f43 + Math_fround(f6 * f44)));
 f6 = Math_fround(f10 - Math_fround(f41 + Math_fround(f6 * f42)));
 f7 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f6 * f6));
 if (+f7 < 1.0e-06) {
  if (!(+f49 > 1.0e-06)) {
   i5 = 0;
   i4 = 0;
   i3 = 1065353216;
  }
 } else {
  f54 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
  f53 = Math_fround(f9 * f54);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  f53 = Math_fround(f8 * f54);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
  f54 = Math_fround(f6 * f54);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i1 = i71 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i73 = 1;
  STACKTOP = i70;
  return i73 | 0;
 }
 f67 = Math_fround(Math_fround(Math_sqrt(Math_fround(f65))) - f67);
 f65 = Math_fround(f10 + Math_fround(HEAPF32[i64 >> 2]));
 f65 = Math_fround(f65 - Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66));
 f54 = Math_fround(f11 + Math_fround(HEAPF32[i69 >> 2]));
 f54 = Math_fround(f54 - Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66));
 f53 = Math_fround(f14 + Math_fround(HEAPF32[i68 >> 2]));
 f66 = Math_fround(f53 - Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66));
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i71 + (i2 << 6) >> 2] = i3;
 HEAP32[i71 + (i2 << 6) + 4 >> 2] = i4;
 HEAP32[i71 + (i2 << 6) + 8 >> 2] = i5;
 HEAPF32[i71 + (i2 << 6) + 16 >> 2] = f66;
 HEAPF32[i71 + (i2 << 6) + 20 >> 2] = f54;
 HEAPF32[i71 + (i2 << 6) + 24 >> 2] = f65;
 HEAPF32[i71 + (i2 << 6) + 12 >> 2] = f67;
 HEAP32[i71 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i71 + (i2 << 6) + 52 >> 2] = -1;
 i73 = 1;
 STACKTOP = i70;
 return i73 | 0;
}

function __ZN7mecanim8skeleton15Skeleton3BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_(i1, i2, i3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i10 = i11;
 if (!(f6 > Math_fround(0.0))) {
  STACKTOP = i11;
  return;
 }
 i24 = i7 + 4 | 0;
 i23 = i24;
 i29 = (HEAP32[i24 >> 2] | 0) + i23 | 0;
 f21 = Math_fround(HEAPF32[i29 + (i2 * 40 | 0) + 12 >> 2]);
 f26 = Math_fround(HEAPF32[i29 + (i2 * 40 | 0) + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i29 + (i2 * 40 | 0) + 20 >> 2]);
 f25 = Math_fround(HEAPF32[i29 + (i2 * 40 | 0) + 24 >> 2]);
 f14 = Math_fround(HEAPF32[i29 + (i3 * 40 | 0) + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i29 + (i3 * 40 | 0) + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i29 + (i3 * 40 | 0) + 20 >> 2]);
 f19 = Math_fround(HEAPF32[i29 + (i3 * 40 | 0) + 24 >> 2]);
 f18 = Math_fround(HEAPF32[i29 + (i4 * 40 | 0) + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i29 + (i4 * 40 | 0) + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i29 + (i4 * 40 | 0) + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i29 + (i4 * 40 | 0) + 24 >> 2]);
 i29 = i1 + 16 | 0;
 i29 = (HEAP32[i29 >> 2] | 0) + i29 | 0;
 f27 = Math_fround(HEAPF32[i29 + (i2 * 76 | 0) + 68 >> 2]);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i29 + (i3 * 76 | 0) + 68 >> 2]));
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i29 + (i4 * 76 | 0) + 68 >> 2]));
 i29 = i8 + 4 | 0;
 i36 = i29;
 i30 = (HEAP32[i29 >> 2] | 0) + i36 | 0;
 f32 = Math_fround(HEAPF32[i30 + (i2 * 40 | 0) >> 2]);
 f33 = Math_fround(HEAPF32[i30 + (i2 * 40 | 0) + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i30 + (i2 * 40 | 0) + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i5 >> 2]);
 i30 = i5 + 4 | 0;
 f38 = Math_fround(HEAPF32[i30 >> 2]);
 i35 = i5 + 8 | 0;
 f31 = Math_fround(f32 - f31);
 f38 = Math_fround(f33 - f38);
 f34 = Math_fround(f34 - Math_fround(HEAPF32[i35 >> 2]));
 f27 = Math_fround(Math_fround(Math_fround(_exp2f(Math_fround(Math_fround(_log2f(Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f38 * f38)) + Math_fround(Math_fround(f34 * f34) + Math_fround(0.0))))) / f27))))))) * Math_fround(4.0)))) * Math_fround(2.0)) + Math_fround(-1.0));
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = f27;
 __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i1, i7, i9, i3);
 __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i1, i7, i9, i4);
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i7, i8, i4, i3);
 __ZN7mecanim8skeleton20SkeletonNodeEndPointEPKNS0_8SkeletonEiPKNS0_13SkeletonPoseTIN4math4trsXEEE(i10, i1, i4, i8);
 i9 = (HEAP32[i29 >> 2] | 0) + i36 | 0;
 f27 = Math_fround(HEAPF32[i10 >> 2]);
 f34 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) >> 2]);
 f33 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 8 >> 2]);
 f27 = Math_fround(f27 - f31);
 f34 = Math_fround(f34 - f33);
 f38 = Math_fround(f38 - f32);
 f40 = Math_fround(HEAPF32[i5 >> 2]);
 f37 = Math_fround(HEAPF32[i30 >> 2]);
 f31 = Math_fround(f40 - f31);
 f33 = Math_fround(f37 - f33);
 f32 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f32);
 f37 = Math_fround(Math_fround(f27 * f33) - Math_fround(f34 * f31));
 f40 = Math_fround(Math_fround(f34 * f32) - Math_fround(f38 * f33));
 f22 = Math_fround(Math_fround(f38 * f31) - Math_fround(f27 * f32));
 f32 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f34 * f34)) + Math_fround(Math_fround(f38 * f38) + Math_fround(0.0))) * Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f33 * f33)) + Math_fround(Math_fround(f32 * f32) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f27 * f31) + Math_fround(f34 * f33)) + Math_fround(Math_fround(f38 * f32) + Math_fround(0.0))));
 f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f22 * f22)) + Math_fround(Math_fround(f37 * f37) + Math_fround(f32 * f32))))));
 f40 = Math_fround(f40 * f38);
 f22 = Math_fround(f38 * f22);
 f37 = Math_fround(f37 * f38);
 f32 = Math_fround(f38 * f32);
 i35 = i9 + (i2 * 40 | 0) + 12 | 0;
 f38 = Math_fround(HEAPF32[i35 >> 2]);
 f33 = Math_fround(f38 * f22);
 i10 = i9 + (i2 * 40 | 0) + 24 | 0;
 f34 = Math_fround(HEAPF32[i10 >> 2]);
 f31 = Math_fround(f34 * f32);
 i30 = i9 + (i2 * 40 | 0) + 16 | 0;
 f27 = Math_fround(HEAPF32[i30 >> 2]);
 f28 = Math_fround(f37 * f27);
 i5 = i9 + (i2 * 40 | 0) + 20 | 0;
 f39 = Math_fround(HEAPF32[i5 >> 2]);
 f33 = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f39 * f32)) - Math_fround(f37 * f34)) - Math_fround(f40 * f27));
 f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f38 * f40)) - Math_fround(f37 * f39)) - Math_fround(f22 * f27));
 f28 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(f22 * f39)) - Math_fround(f38 * f32)) - Math_fround(f40 * f34));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) - Math_fround(f38 * f37)) - Math_fround(f27 * f32)) - Math_fround(f22 * f34));
 i9 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 i36 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i29 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAP32[i35 >> 2] = i36 ^ -2147483648;
 HEAP32[i30 >> 2] = i29;
 HEAP32[i5 >> 2] = i9 ^ -2147483648;
 HEAPF32[i10 >> 2] = f31;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i1, i8, i7, i2, i2);
 i10 = (HEAP32[i24 >> 2] | 0) + i23 | 0;
 i5 = i10 + (i2 * 40 | 0) + 12 | 0;
 f31 = Math_fround(HEAPF32[i5 >> 2]);
 f34 = Math_fround(f21 * f31);
 i7 = i10 + (i2 * 40 | 0) + 16 | 0;
 f28 = Math_fround(HEAPF32[i7 >> 2]);
 f33 = Math_fround(f26 * f28);
 i8 = i10 + (i2 * 40 | 0) + 20 | 0;
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f32 = Math_fround(f12 * f22);
 i9 = i10 + (i2 * 40 | 0) + 24 | 0;
 f27 = Math_fround(HEAPF32[i9 >> 2]);
 f32 = Math_fround(Math_fround(f34 + f33) + Math_fround(f32 + Math_fround(f25 * f27)));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i1 & -2147483648;
 i30 = i1 ^ (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i29 = i1 ^ (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i1 ^ (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i1 ^ (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f12);
 f27 = Math_fround(f21 + Math_fround(f27 * f6));
 f22 = Math_fround(f26 + Math_fround(f22 * f6));
 f28 = Math_fround(f12 + Math_fround(f28 * f6));
 f25 = Math_fround(f25 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f25) * f6));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f22 * f22)) + Math_fround(Math_fround(f28 * f28) + Math_fround(f25 * f25))))));
 f22 = Math_fround(f12 * f22);
 f28 = Math_fround(f12 * f28);
 f25 = Math_fround(f12 * f25);
 HEAPF32[i5 >> 2] = Math_fround(f12 * f27);
 HEAPF32[i7 >> 2] = f22;
 HEAPF32[i8 >> 2] = f28;
 HEAPF32[i9 >> 2] = f25;
 i9 = i10 + (i3 * 40 | 0) + 12 | 0;
 f25 = Math_fround(HEAPF32[i9 >> 2]);
 f28 = Math_fround(f14 * f25);
 i8 = i10 + (i3 * 40 | 0) + 16 | 0;
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f27 = Math_fround(f20 * f22);
 i7 = i10 + (i3 * 40 | 0) + 20 | 0;
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 f26 = Math_fround(f13 * f12);
 i10 = i10 + (i3 * 40 | 0) + 24 | 0;
 f21 = Math_fround(HEAPF32[i10 >> 2]);
 f26 = Math_fround(Math_fround(f28 + f27) + Math_fround(f26 + Math_fround(f19 * f21)));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i5 & -2147483648;
 i1 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f20);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
 f21 = Math_fround(f14 + Math_fround(f21 * f6));
 f12 = Math_fround(f20 + Math_fround(f12 * f6));
 f22 = Math_fround(f13 + Math_fround(f22 * f6));
 f19 = Math_fround(f19 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f19) * f6));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f12 * f12)) + Math_fround(Math_fround(f22 * f22) + Math_fround(f19 * f19))))));
 f12 = Math_fround(f13 * f12);
 f22 = Math_fround(f13 * f22);
 f19 = Math_fround(f13 * f19);
 HEAPF32[i9 >> 2] = Math_fround(f13 * f21);
 HEAPF32[i8 >> 2] = f12;
 HEAPF32[i7 >> 2] = f22;
 HEAPF32[i10 >> 2] = f19;
 i10 = (HEAP32[i24 >> 2] | 0) + i23 | 0;
 i7 = i10 + (i4 * 40 | 0) + 12 | 0;
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 f22 = Math_fround(f18 * f19);
 i8 = i10 + (i4 * 40 | 0) + 16 | 0;
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f21 = Math_fround(f17 * f12);
 i9 = i10 + (i4 * 40 | 0) + 20 | 0;
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f20 = Math_fround(f16 * f13);
 i10 = i10 + (i4 * 40 | 0) + 24 | 0;
 f14 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(Math_fround(f22 + f21) + Math_fround(f20 + Math_fround(f15 * f14)));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i5 & -2147483648;
 i2 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18);
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f17);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f16);
 f14 = Math_fround(f18 + Math_fround(f14 * f6));
 f13 = Math_fround(f17 + Math_fround(f13 * f6));
 f12 = Math_fround(f16 + Math_fround(f12 * f6));
 f6 = Math_fround(f15 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15) * f6));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f12 * f12) + Math_fround(f6 * f6))))));
 f13 = Math_fround(f15 * f13);
 f12 = Math_fround(f15 * f12);
 f6 = Math_fround(f15 * f6);
 HEAPF32[i7 >> 2] = Math_fround(f15 * f14);
 HEAPF32[i8 >> 2] = f13;
 HEAPF32[i9 >> 2] = f12;
 HEAPF32[i10 >> 2] = f6;
 STACKTOP = i11;
 return;
}

function __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 168 | 0, i10);
 i5 = i6 + 184 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 212 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 240 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 256 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 272 | 0, i10 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 288 | 0, i10 + 8 | 0);
 i5 = i6 + 304 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 320 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 11 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 11 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(i1, i2, i22) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 L1 : while (1) {
  i20 = i2;
  i24 = i2 + -4 | 0;
  i21 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i19 = i1;
    i3 = i20 - i19 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i23 = 5;
      break L1;
     }
    case 3:
     {
      i23 = 12;
      break L1;
     }
    case 4:
     {
      i23 = 13;
      break L1;
     }
    case 5:
     {
      i23 = 14;
      break L1;
     }
    case 1:
    case 0:
     {
      i23 = 103;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i23 = 16;
     break L1;
    }
    i15 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 << 2) | 0, i15, i15 + (i3 << 2) | 0, i24, i22) | 0;
    } else i3 = __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i1, i15, i24, i22) | 0;
    i17 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i15 >> 2] | 0;
    i18 = HEAP32[i17 + 32 >> 2] | 0;
    i16 = HEAP32[i11 + 32 >> 2] | 0;
    do if ((i18 | 0) == (i16 | 0)) {
     i5 = i17 + 112 | 0;
     i6 = i11 + 112 | 0;
     i9 = HEAP8[i6 + 11 >> 0] | 0;
     i7 = i9 << 24 >> 24 < 0;
     i9 = i7 ? HEAP32[i11 + 116 >> 2] | 0 : i9 & 255;
     i10 = HEAP8[i5 + 11 >> 0] | 0;
     i8 = i10 << 24 >> 24 < 0;
     i10 = i8 ? HEAP32[i17 + 116 >> 2] | 0 : i10 & 255;
     i4 = i10 >>> 0 < i9 >>> 0 ? i10 : i9;
     if (i4 | 0) {
      i4 = _memcmp(i7 ? HEAP32[i6 >> 2] | 0 : i6, i8 ? HEAP32[i5 >> 2] | 0 : i5, i4) | 0;
      if (i4 | 0) if ((i4 | 0) < 0) {
       i4 = i24;
       break L5;
      } else break;
     }
     if (i9 >>> 0 < i10 >>> 0) {
      i4 = i24;
      break L5;
     }
    } else if ((i18 | 0) > (i16 | 0)) {
     i4 = i24;
     break L5;
    } while (0);
    if ((i1 | 0) != (i21 | 0)) {
     i13 = i11 + 112 | 0;
     i14 = i13 + 11 | 0;
     i12 = i11 + 116 | 0;
     i4 = i21;
     do {
      i11 = HEAP32[i4 >> 2] | 0;
      i5 = HEAP32[i11 + 32 >> 2] | 0;
      do if ((i5 | 0) == (i16 | 0)) {
       i6 = i11 + 112 | 0;
       i9 = HEAP8[i14 >> 0] | 0;
       i7 = i9 << 24 >> 24 < 0;
       i9 = i7 ? HEAP32[i12 >> 2] | 0 : i9 & 255;
       i10 = HEAP8[i6 + 11 >> 0] | 0;
       i8 = i10 << 24 >> 24 < 0;
       i10 = i8 ? HEAP32[i11 + 116 >> 2] | 0 : i10 & 255;
       i5 = i10 >>> 0 < i9 >>> 0 ? i10 : i9;
       if (i5 | 0) {
        i5 = _memcmp(i7 ? HEAP32[i13 >> 2] | 0 : i13, i8 ? HEAP32[i6 >> 2] | 0 : i6, i5) | 0;
        if (i5 | 0) if ((i5 | 0) < 0) {
         i23 = 69;
         break L5;
        } else break;
       }
       if (i9 >>> 0 < i10 >>> 0) {
        i23 = 69;
        break L5;
       }
      } else if ((i5 | 0) > (i16 | 0)) {
       i23 = 69;
       break L5;
      } while (0);
      i4 = i4 + -4 | 0;
     } while ((i1 | 0) != (i4 | 0));
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i24 >> 2] | 0;
    i4 = HEAP32[i5 + 32 >> 2] | 0;
    i14 = i5;
    do if ((i18 | 0) == (i4 | 0)) {
     i6 = i17 + 112 | 0;
     i7 = i5 + 112 | 0;
     i9 = HEAP8[i7 + 11 >> 0] | 0;
     i8 = i9 << 24 >> 24 < 0;
     i9 = i8 ? HEAP32[i5 + 116 >> 2] | 0 : i9 & 255;
     i10 = HEAP8[i6 + 11 >> 0] | 0;
     i5 = i10 << 24 >> 24 < 0;
     i10 = i5 ? HEAP32[i17 + 116 >> 2] | 0 : i10 & 255;
     i4 = i10 >>> 0 < i9 >>> 0 ? i10 : i9;
     if (i4 | 0) {
      i4 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i5 ? HEAP32[i6 >> 2] | 0 : i6, i4) | 0;
      if (i4 | 0) if ((i4 | 0) < 0) break; else {
       i23 = 34;
       break;
      }
     }
     if (i9 >>> 0 >= i10 >>> 0) i23 = 34;
    } else if ((i18 | 0) <= (i4 | 0)) i23 = 34; while (0);
    if ((i23 | 0) == 34) {
     i23 = 0;
     if ((i3 | 0) == (i24 | 0)) {
      i23 = 103;
      break L1;
     }
     i12 = i17 + 112 | 0;
     i13 = i12 + 11 | 0;
     i11 = i17 + 116 | 0;
     L44 : while (1) {
      i10 = HEAP32[i3 >> 2] | 0;
      i4 = HEAP32[i10 + 32 >> 2] | 0;
      do if ((i18 | 0) == (i4 | 0)) {
       i5 = i10 + 112 | 0;
       i8 = HEAP8[i5 + 11 >> 0] | 0;
       i6 = i8 << 24 >> 24 < 0;
       i8 = i6 ? HEAP32[i10 + 116 >> 2] | 0 : i8 & 255;
       i9 = HEAP8[i13 >> 0] | 0;
       i7 = i9 << 24 >> 24 < 0;
       i9 = i7 ? HEAP32[i11 >> 2] | 0 : i9 & 255;
       i4 = i9 >>> 0 < i8 >>> 0 ? i9 : i8;
       if (i4 | 0) {
        i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i7 ? HEAP32[i12 >> 2] | 0 : i12, i4) | 0;
        if (i4 | 0) if ((i4 | 0) < 0) break L44; else break;
       }
       if (i8 >>> 0 < i9 >>> 0) break L44;
      } else if ((i18 | 0) > (i4 | 0)) break L44; while (0);
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i24 | 0)) {
       i23 = 103;
       break L1;
      }
     }
     HEAP32[i3 >> 2] = i14;
     HEAP32[i24 >> 2] = i10;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i24 | 0)) {
     i23 = 103;
     break L1;
    } else i11 = i24;
    while (1) {
     i16 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i16 + 32 >> 2] | 0;
     i14 = i16 + 112 | 0;
     i15 = i14 + 11 | 0;
     i16 = i16 + 116 | 0;
     L58 : while (1) {
      i10 = HEAP32[i3 >> 2] | 0;
      i4 = HEAP32[i10 + 32 >> 2] | 0;
      do if ((i13 | 0) == (i4 | 0)) {
       i5 = i10 + 112 | 0;
       i8 = HEAP8[i5 + 11 >> 0] | 0;
       i6 = i8 << 24 >> 24 < 0;
       i8 = i6 ? HEAP32[i10 + 116 >> 2] | 0 : i8 & 255;
       i9 = HEAP8[i15 >> 0] | 0;
       i7 = i9 << 24 >> 24 < 0;
       i9 = i7 ? HEAP32[i16 >> 2] | 0 : i9 & 255;
       i4 = i9 >>> 0 < i8 >>> 0 ? i9 : i8;
       if (i4 | 0) {
        i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i7 ? HEAP32[i14 >> 2] | 0 : i14, i4) | 0;
        if (i4 | 0) if ((i4 | 0) < 0) break L58; else break;
       }
       if (i8 >>> 0 < i9 >>> 0) break L58;
      } else if ((i13 | 0) > (i4 | 0)) break L58; while (0);
      i3 = i3 + 4 | 0;
     }
     while (1) {
      i11 = i11 + -4 | 0;
      i12 = HEAP32[i11 >> 2] | 0;
      i4 = HEAP32[i12 + 32 >> 2] | 0;
      if ((i13 | 0) != (i4 | 0)) if ((i13 | 0) > (i4 | 0)) continue; else break;
      i5 = i12 + 112 | 0;
      i8 = HEAP8[i5 + 11 >> 0] | 0;
      i6 = i8 << 24 >> 24 < 0;
      i8 = i6 ? HEAP32[i12 + 116 >> 2] | 0 : i8 & 255;
      i9 = HEAP8[i15 >> 0] | 0;
      i7 = i9 << 24 >> 24 < 0;
      i9 = i7 ? HEAP32[i16 >> 2] | 0 : i9 & 255;
      i4 = i9 >>> 0 < i8 >>> 0 ? i9 : i8;
      if (i4 | 0) {
       i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i7 ? HEAP32[i14 >> 2] | 0 : i14, i4) | 0;
       if (i4 | 0) if ((i4 | 0) < 0) continue; else break;
      }
      if (i8 >>> 0 >= i9 >>> 0) break;
     }
     if (i3 >>> 0 >= i11 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i12;
     HEAP32[i11 >> 2] = i10;
     i3 = i3 + 4 | 0;
    }
   }
   if ((i23 | 0) == 69) {
    i23 = 0;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i4 >> 2] = i17;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L83 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i18 = HEAP32[i15 >> 2] | 0;
    i14 = HEAP32[i18 + 32 >> 2] | 0;
    i16 = i18 + 112 | 0;
    i17 = i16 + 11 | 0;
    i18 = i18 + 116 | 0;
    L86 : while (1) {
     i12 = HEAP32[i5 >> 2] | 0;
     i6 = HEAP32[i12 + 32 >> 2] | 0;
     do if ((i6 | 0) == (i14 | 0)) {
      i7 = i12 + 112 | 0;
      i10 = HEAP8[i17 >> 0] | 0;
      i8 = i10 << 24 >> 24 < 0;
      i10 = i8 ? HEAP32[i18 >> 2] | 0 : i10 & 255;
      i11 = HEAP8[i7 + 11 >> 0] | 0;
      i9 = i11 << 24 >> 24 < 0;
      i11 = i9 ? HEAP32[i12 + 116 >> 2] | 0 : i11 & 255;
      i6 = i11 >>> 0 < i10 >>> 0 ? i11 : i10;
      if (i6 | 0) {
       i6 = _memcmp(i8 ? HEAP32[i16 >> 2] | 0 : i16, i9 ? HEAP32[i7 >> 2] | 0 : i7, i6) | 0;
       if (i6 | 0) if ((i6 | 0) < 0) break; else break L86;
      }
      if (i10 >>> 0 >= i11 >>> 0) break L86;
     } else if ((i6 | 0) <= (i14 | 0)) break L86; while (0);
     i5 = i5 + 4 | 0;
    }
    while (1) {
     i4 = i4 + -4 | 0;
     i13 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i13 + 32 >> 2] | 0;
     if ((i6 | 0) != (i14 | 0)) if ((i6 | 0) > (i14 | 0)) break; else continue;
     i7 = i13 + 112 | 0;
     i10 = HEAP8[i17 >> 0] | 0;
     i8 = i10 << 24 >> 24 < 0;
     i10 = i8 ? HEAP32[i18 >> 2] | 0 : i10 & 255;
     i11 = HEAP8[i7 + 11 >> 0] | 0;
     i9 = i11 << 24 >> 24 < 0;
     i11 = i9 ? HEAP32[i13 + 116 >> 2] | 0 : i11 & 255;
     i6 = i11 >>> 0 < i10 >>> 0 ? i11 : i10;
     if (i6 | 0) {
      i6 = _memcmp(i8 ? HEAP32[i16 >> 2] | 0 : i16, i9 ? HEAP32[i7 >> 2] | 0 : i7, i6) | 0;
      if (i6 | 0) if ((i6 | 0) < 0) break; else continue;
     }
     if (i10 >>> 0 < i11 >>> 0) break;
    }
    if (i5 >>> 0 > i4 >>> 0) break L83;
    HEAP32[i5 >> 2] = i13;
    HEAP32[i4 >> 2] = i12;
    i15 = (i15 | 0) == (i5 | 0) ? i4 : i15;
    i5 = i5 + 4 | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   L109 : do if ((i5 | 0) != (i15 | 0)) {
    i8 = HEAP32[i15 >> 2] | 0;
    i7 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i8 + 32 >> 2] | 0;
    i6 = HEAP32[i7 + 32 >> 2] | 0;
    i13 = i7;
    i14 = i8;
    do if ((i4 | 0) == (i6 | 0)) {
     i9 = i8 + 112 | 0;
     i10 = i7 + 112 | 0;
     i12 = HEAP8[i10 + 11 >> 0] | 0;
     i11 = i12 << 24 >> 24 < 0;
     i12 = i11 ? HEAP32[i7 + 116 >> 2] | 0 : i12 & 255;
     i7 = HEAP8[i9 + 11 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i7 = i6 ? HEAP32[i8 + 116 >> 2] | 0 : i7 & 255;
     i4 = i7 >>> 0 < i12 >>> 0 ? i7 : i12;
     if (i4 | 0) {
      i4 = _memcmp(i11 ? HEAP32[i10 >> 2] | 0 : i10, i6 ? HEAP32[i9 >> 2] | 0 : i9, i4) | 0;
      if (i4 | 0) if ((i4 | 0) < 0) break; else break L109;
     }
     if (i12 >>> 0 >= i7 >>> 0) break L109;
    } else if ((i4 | 0) <= (i6 | 0)) break L109; while (0);
    HEAP32[i5 >> 2] = i14;
    HEAP32[i15 >> 2] = i13;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR12GreaterLayerPP14AnimationStateEEbT0_S6_T_(i1, i5, i22) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR12GreaterLayerPP14AnimationStateEEbT0_S6_T_(i4, i2, i22) | 0) {
     i23 = 102;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i18 = i5;
   if ((i18 - i19 | 0) >= (i20 - i18 | 0)) {
    i23 = 101;
    break;
   }
   __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(i1, i5, i22);
   i1 = i5 + 4 | 0;
  }
  if ((i23 | 0) == 101) {
   i23 = 0;
   __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(i5 + 4 | 0, i2, i22);
   i2 = i5;
   continue;
  } else if ((i23 | 0) == 102) {
   i23 = 0;
   if (i3) {
    i23 = 103;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i23 | 0) == 5) {
  i9 = HEAP32[i24 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i9 + 32 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i10 = i4;
  i11 = i9;
  do if ((i2 | 0) == (i3 | 0)) {
   i5 = i9 + 112 | 0;
   i6 = i4 + 112 | 0;
   i8 = HEAP8[i6 + 11 >> 0] | 0;
   i7 = i8 << 24 >> 24 < 0;
   i8 = i7 ? HEAP32[i4 + 116 >> 2] | 0 : i8 & 255;
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i9 + 116 >> 2] | 0 : i4 & 255;
   i2 = i4 >>> 0 < i8 >>> 0 ? i4 : i8;
   if (i2 | 0) {
    i2 = _memcmp(i7 ? HEAP32[i6 >> 2] | 0 : i6, i3 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return;
    }
   }
   if (i8 >>> 0 >= i4 >>> 0) return;
  } else if ((i2 | 0) <= (i3 | 0)) return; while (0);
  HEAP32[i1 >> 2] = i11;
  HEAP32[i24 >> 2] = i10;
  return;
 } else if ((i23 | 0) == 12) {
  __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i1, i1 + 4 | 0, i24, i22) | 0;
  return;
 } else if ((i23 | 0) == 13) {
  __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i24, i22) | 0;
  return;
 } else if ((i23 | 0) == 14) {
  __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i24, i22) | 0;
  return;
 } else if ((i23 | 0) == 16) {
  __ZNSt3__218__insertion_sort_3IR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(i1, i2, i22);
  return;
 } else if ((i23 | 0) == 103) return;
}

function __ZN15GlobalCallbacksC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 768 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 1540 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 2312 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 2316 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 3084 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 3088 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 3088 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 3088 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 3856 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 3860 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 3860 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 3860 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 4628 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 4632 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 4632 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 4632 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 5400 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 5404 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 5404 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 5404 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 6172 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 6176 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 6176 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 6176 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 6944 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 6948 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 6948 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 6948 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 7716 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 7720 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 7720 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 7720 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 8488 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 8492 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 8492 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 8492 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 9260 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 9264 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 9264 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 9264 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 10032 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 10036 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 10036 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 10036 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 10804 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 10808 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 10808 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 10808 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 11576 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 11580 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 11580 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 11580 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 12348 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 12352 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 12352 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 12352 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 13120 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 13124 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 13124 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 13124 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 13892 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 13896 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 13896 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 13896 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 14664 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 14668 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 14668 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 14668 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 15436 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 15440 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 15440 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 15440 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 16208 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 16212 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 16212 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 16212 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 16980 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 16984 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 16984 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 16984 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 17752 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 17756 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 17756 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 17756 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 18524 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 18528 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 18528 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 18528 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 19296 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 19300 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 19300 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 19300 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 20068 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 20072 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 20072 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 20072 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 20840 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 20844 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 20844 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 20844 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 21612 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 21616 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 21616 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 21616 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 22384 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 22388 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 22388 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 22388 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 23156 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 23160 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 23160 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 23160 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 23928 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 23932 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 23932 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 24700 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 24704 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 24704 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 24704 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 25472 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 25476 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 25476 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 25476 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 26244 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 26248 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 26248 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 26248 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 27016 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 27020 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 27020 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 27020 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 27788 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 27792 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 27792 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 27792 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 28560 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 28564 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 28564 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 28564 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 29332 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 29336 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 29336 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 29336 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 30104 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 30108 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 30108 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 30108 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 30876 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 30880 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 30880 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 30880 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 31648 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 31652 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 31652 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 31652 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 32420 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 32424 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 32424 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 32424 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 33192 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 33196 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 33196 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 33196 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 33964 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 33968 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 33968 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 33968 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 34736 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 34740 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 34740 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 34740 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 35508 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 35512 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 35512 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 35512 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 36280 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 36284 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 36284 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 36284 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 37052 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 37056 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 37056 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 37056 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 37824 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 37828 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 38596 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 38600 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 38600 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 38600 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i2 + 39368 >> 2] = 0;
 return;
}

function __ZN18ProceduralMaterial9SetPresetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i25, i26) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i39 + 108 | 0;
 i31 = i39 + 96 | 0;
 i32 = i39 + 84 | 0;
 i33 = i39 + 72 | 0;
 i34 = i39 + 60 | 0;
 i35 = i39 + 36 | 0;
 i36 = i39 + 24 | 0;
 i37 = i39 + 48 | 0;
 i27 = i39 + 12 | 0;
 i28 = i39;
 i29 = i26 + 11 | 0;
 i24 = HEAP8[i29 >> 0] | 0;
 i2 = i24 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i26 >> 2] | 0 : i26;
 i3 = i4;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 i30 = i26 + 4 | 0;
 i24 = i2 ? HEAP32[i30 >> 2] | 0 : i24 & 255;
 i2 = i4 + i24 | 0;
 L1 : do if (!i24) i5 = i4; else {
  i1 = i4;
  while (1) {
   if ((HEAP8[i1 >> 0] | 0) == 10) {
    i5 = i1;
    break L1;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i5 = i2;
    break;
   }
  }
 } while (0);
 i1 = i5;
 i11 = (i5 | 0) == (i2 | 0) ? i1 : i5 + 1 | 0;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 i1 = i1 - i3 | 0;
 if (i1 >>> 0 > 4294967279) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i31);
  i22 = 8;
 } else if (i1 >>> 0 < 11) {
  HEAP8[i31 + 11 >> 0] = i1;
  i1 = i31;
 } else i22 = 8;
 if ((i22 | 0) == 8) {
  i23 = i1 + 16 & -16;
  i24 = __Znwj(i23) | 0;
  HEAP32[i31 >> 2] = i24;
  HEAP32[i31 + 8 >> 2] = i23 | -2147483648;
  HEAP32[i31 + 4 >> 2] = i1;
  i1 = i24;
 }
 if ((i4 | 0) != (i5 | 0)) {
  i2 = i4;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
 }
 HEAP8[i1 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i38, i31) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
 i23 = i38 + 11 | 0;
 i8 = HEAP8[i23 >> 0] | 0;
 i2 = i8 << 24 >> 24 < 0;
 i9 = HEAP32[i38 >> 2] | 0;
 i24 = i38 + 4 | 0;
 i10 = HEAP32[i24 >> 2] | 0;
 i1 = i2 ? i9 : i38;
 i2 = i2 ? i10 : i8 & 255;
 if (i2 >>> 0 < 19) {
  i37 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  STACKTOP = i39;
  return i37 | 0;
 }
 i6 = i1 + i2 | 0;
 i5 = i6;
 i7 = i1;
 L20 : do if ((i2 | 0) < 19) i1 = i5; else {
  i4 = i6 + -18 | 0;
  if ((i4 | 0) == (i1 | 0)) i1 = i5; else L22 : while (1) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 102) {
     i2 = gb + 433975 | 0;
     i3 = i1;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L20;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 433975 + 19 | 0)) break L22;
    i3 = i3 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i5;
    break L20;
   }
  }
 } while (0);
 if ((i1 | 0) == (i6 | 0) | (i1 - i7 | 0) == -1) {
  i37 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  STACKTOP = i39;
  return i37 | 0;
 }
 i1 = HEAP8[i29 >> 0] | 0;
 i21 = i1 << 24 >> 24 < 0;
 i2 = HEAP32[i26 >> 2] | 0;
 i4 = HEAP32[i30 >> 2] | 0;
 i5 = i11;
 if ((i5 | 0) == ((i21 ? i2 : i26) + (i21 ? i4 : i1 & 255) | 0)) {
  i37 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  STACKTOP = i39;
  return i37 | 0;
 }
 i17 = i31 + 8 | 0;
 i18 = i31 + 4 | 0;
 i19 = i31 + 4 | 0;
 i20 = i31 + 8 | 0;
 i21 = i34 + 4 | 0;
 i13 = i34 + 8 | 0;
 i14 = i37 + 4 | 0;
 i15 = i37 + 8 | 0;
 i16 = i31 + 11 | 0;
 i3 = i11;
 i6 = i9;
 i7 = i10;
 i11 = i1;
 i10 = i2;
 i12 = i5;
 while (1) {
  i2 = i8 << 24 >> 24 < 0;
  i1 = i2 ? i6 : i38;
  i2 = i2 ? i7 : i8 & 255;
  if (i2 >>> 0 >= 10) {
   i8 = i1 + i2 | 0;
   i7 = i8;
   i9 = i1;
   L43 : do if ((i2 | 0) < 10) i1 = i7; else {
    i6 = i8 + -9 | 0;
    if ((i6 | 0) == (i1 | 0)) i1 = i7; else L45 : while (1) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == 47) {
       i2 = gb + 433995 | 0;
       i5 = i1;
       break;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i6 | 0)) {
       i1 = i7;
       break L43;
      }
     }
     do {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (gb + 433995 + 10 | 0)) break L45;
      i5 = i5 + 1 | 0;
     } while ((HEAP8[i5 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i6 | 0)) {
      i1 = i7;
      break L43;
     }
    }
   } while (0);
   if (!((i1 | 0) == (i8 | 0) | (i1 - i9 | 0) == -1)) {
    i1 = 1;
    i22 = 89;
    break;
   }
  }
  i2 = i11 << 24 >> 24 < 0;
  i2 = (i2 ? i10 : i26) + (i2 ? i4 : i11 & 255) | 0;
  L57 : do if ((i12 | 0) == (i2 | 0)) i4 = i12; else {
   i1 = i12;
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 10) {
     i4 = i1;
     break L57;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i4 = i2;
     break;
    }
   }
  } while (0);
  i1 = i4;
  i8 = (i4 | 0) == (i2 | 0) ? i1 : i4 + 1 | 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  i1 = i1 - i3 | 0;
  if (i1 >>> 0 > 4294967279) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i31);
   i22 = 42;
  } else if (i1 >>> 0 < 11) {
   HEAP8[i16 >> 0] = i1;
   i1 = i31;
  } else i22 = 42;
  if ((i22 | 0) == 42) {
   i22 = 0;
   i10 = i1 + 16 & -16;
   i11 = __Znwj(i10) | 0;
   HEAP32[i31 >> 2] = i11;
   HEAP32[i17 >> 2] = i10 | -2147483648;
   HEAP32[i18 >> 2] = i1;
   i1 = i11;
  }
  if ((i12 | 0) != (i4 | 0)) {
   i2 = i12;
   while (1) {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i3 + 1 | 0;
    i1 = i1 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
   }
  }
  HEAP8[i1 >> 0] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i38, i31) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
  i2 = HEAP8[i23 >> 0] | 0;
  i12 = i2 << 24 >> 24 < 0;
  i1 = i12 ? HEAP32[i38 >> 2] | 0 : i38;
  i2 = i12 ? HEAP32[i24 >> 2] | 0 : i2 & 255;
  if (i2 >>> 0 >= 11) {
   i6 = i1 + i2 | 0;
   i5 = i6;
   i7 = i1;
   L75 : do if ((i2 | 0) < 11) i1 = i5; else {
    i4 = i6 + -10 | 0;
    if ((i4 | 0) == (i1 | 0)) i1 = i5; else L77 : while (1) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == 112) {
       i2 = gb + 434006 | 0;
       i3 = i1;
       break;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i5;
       break L75;
      }
     }
     do {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (gb + 434006 + 11 | 0)) break L77;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L75;
     }
    }
   } while (0);
   if (!((i1 | 0) == (i6 | 0) | (i1 - i7 | 0) == -1)) {
    HEAP32[i31 >> 2] = 0;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i32 >> 2] = 0;
    HEAP32[i32 + 4 >> 2] = 0;
    HEAP32[i32 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i32, gb + 434018 | 0, 10);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i33, i38);
    i12 = (__Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_(i31, i32, i33) | 0) == 1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
    do if (i12) {
     i1 = HEAP32[i31 >> 2] | 0;
     i4 = __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i25, i1) | 0;
     if (i4) {
      i2 = HEAP8[i1 + 11 >> 0] | 0;
      i3 = HEAP32[i1 + 4 >> 2] | 0;
      if (((i2 << 24 >> 24 < 0 ? i3 : i2 & 255) | 0) == 13) {
       if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, gb + 434029 | 0, 13) | 0)) {
        i22 = 80;
        break;
       }
       i1 = HEAP32[i31 >> 2] | 0;
       i2 = HEAP8[i1 + 11 >> 0] | 0;
       i3 = HEAP32[i1 + 4 >> 2] | 0;
      }
      if (((i2 << 24 >> 24 < 0 ? i3 : i2 & 255) | 0) == 11) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, gb + 432369 | 0, 11) | 0)) {
       i22 = 80;
       break;
      }
      HEAP32[i34 >> 2] = 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i13 >> 2] = 0;
      HEAP32[i35 >> 2] = 0;
      HEAP32[i35 + 4 >> 2] = 0;
      HEAP32[i35 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i35, gb + 1047471 | 0, 4);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i36, i38);
      i22 = (__Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_(i34, i35, i36) | 0) == 1;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
      do if (i22) {
       i1 = HEAP32[i34 >> 2] | 0;
       if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
       i22 = _atoi(i1) | 0;
       if ((i22 | 0) == 5 ? 1 : (i22 | 0) != (HEAP32[i4 + 88 >> 2] | 0)) break;
       HEAP32[i37 >> 2] = 0;
       HEAP32[i14 >> 2] = 0;
       HEAP32[i15 >> 2] = 0;
       HEAP32[i27 >> 2] = 0;
       HEAP32[i27 + 4 >> 2] = 0;
       HEAP32[i27 + 8 >> 2] = 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i27, gb + 1034365 | 0, 5);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i28, i38);
       __Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_(i37, i27, i28) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
       i2 = HEAP32[i14 >> 2] | 0;
       i1 = HEAP32[i37 >> 2] | 0;
       i3 = i1;
       if (i1 | 0) {
        if ((i2 | 0) != (i3 | 0)) {
         i1 = i2;
         do {
          i22 = i1 + -12 | 0;
          HEAP32[i14 >> 2] = i22;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
          i1 = HEAP32[i14 >> 2] | 0;
         } while ((i1 | 0) != (i3 | 0));
         i1 = HEAP32[i37 >> 2] | 0;
        }
        __ZdlPv(i1);
       }
      } while (0);
      i1 = HEAP32[i34 >> 2] | 0;
      if (i1 | 0) {
       i2 = HEAP32[i21 >> 2] | 0;
       if ((i2 | 0) != (i1 | 0)) {
        do {
         i22 = i2 + -12 | 0;
         HEAP32[i21 >> 2] = i22;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
         i2 = HEAP32[i21 >> 2] | 0;
        } while ((i2 | 0) != (i1 | 0));
        i1 = HEAP32[i34 >> 2] | 0;
       }
       __ZdlPv(i1);
      }
      i22 = 80;
     }
    } else i22 = 80; while (0);
    if ((i22 | 0) == 80) {
     i22 = 0;
     i1 = HEAP32[i31 >> 2] | 0;
    }
    if (i1 | 0) {
     i2 = HEAP32[i19 >> 2] | 0;
     if ((i2 | 0) != (i1 | 0)) {
      do {
       i12 = i2 + -12 | 0;
       HEAP32[i19 >> 2] = i12;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
       i2 = HEAP32[i19 >> 2] | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i31 >> 2] | 0;
     }
     __ZdlPv(i1);
    }
   }
  }
  i1 = HEAP8[i29 >> 0] | 0;
  i12 = i1 << 24 >> 24 < 0;
  i2 = HEAP32[i26 >> 2] | 0;
  i4 = HEAP32[i30 >> 2] | 0;
  i5 = i8;
  if ((i5 | 0) == ((i12 ? i2 : i26) + (i12 ? i4 : i1 & 255) | 0)) {
   i1 = 1;
   i22 = 89;
   break;
  }
  i3 = i8;
  i8 = HEAP8[i23 >> 0] | 0;
  i6 = HEAP32[i38 >> 2] | 0;
  i7 = HEAP32[i24 >> 2] | 0;
  i11 = i1;
  i10 = i2;
  i12 = i5;
 }
 if ((i22 | 0) == 89) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  STACKTOP = i39;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Gu22pcmContactPlaneCapsuleERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i1, i6, i3, i4, i5, i2, i35) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i35 = i35 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, i52 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34 + 240 | 0;
 i30 = i34 + 224 | 0;
 i31 = i34 + 208 | 0;
 i32 = i34 + 192 | 0;
 i36 = i34 + 176 | 0;
 i1 = i34 + 160 | 0;
 i37 = i34 + 96 | 0;
 i26 = i34 + 80 | 0;
 i28 = i34 + 64 | 0;
 i24 = i34 + 48 | 0;
 i27 = i34 + 32 | 0;
 i29 = i34 + 16 | 0;
 i25 = i34;
 i23 = HEAP32[i2 >> 2] | 0;
 i50 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 8 >> 2] | 0;
 i15 = HEAP32[i4 + 12 >> 2] | 0;
 i4 = i4 + 16 | 0;
 i52 = HEAP32[i4 >> 2] | 0;
 i51 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i33 >> 2] = i50;
 HEAP32[i33 + 4 >> 2] = i2;
 HEAP32[i33 + 8 >> 2] = i7;
 HEAP32[i33 + 12 >> 2] = i15;
 HEAP32[i33 + 16 >> 2] = i52;
 HEAP32[i33 + 20 >> 2] = i51;
 HEAP32[i33 + 24 >> 2] = i4;
 HEAPF32[i33 + 28 >> 2] = Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i3 = i3 + 16 | 0;
 f38 = Math_fround(HEAPF32[i3 >> 2]);
 f43 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f40 = Math_fround(-f12);
 f9 = Math_fround(-f14);
 f18 = Math_fround(-f10);
 f21 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = Math_fround(f21 - f38);
 f43 = Math_fround(f11 - f43);
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
 f11 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f21 = Math_fround(Math_fround(Math_fround(f38 * f40) + Math_fround(f43 * f9)) + Math_fround(f13 * f18));
 f19 = Math_fround(Math_fround(Math_fround(f21 * f40) + Math_fround(Math_fround(f11 * f38) + Math_fround(f8 * Math_fround(Math_fround(f13 * f9) - Math_fround(f43 * f18))))) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(Math_fround(f21 * f9) + Math_fround(Math_fround(f11 * f43) + Math_fround(f8 * Math_fround(Math_fround(f38 * f18) - Math_fround(f13 * f40))))) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f13) + Math_fround(f8 * Math_fround(Math_fround(f43 * f40) - Math_fround(f38 * f9)))) + Math_fround(f21 * f18)) * Math_fround(2.0));
 f38 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(Math_fround(f8 * f11) - Math_fround(Math_fround(Math_fround(f38 * f40) + Math_fround(f43 * f9)) + Math_fround(f13 * f18)));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f9) - Math_fround(f43 * f18)) + Math_fround(Math_fround(f8 * f38) + Math_fround(f11 * f40)));
 f17 = Math_fround(Math_fround(Math_fround(f38 * f18) - Math_fround(f13 * f40)) + Math_fround(Math_fround(f8 * f43) + Math_fround(f11 * f9)));
 f18 = Math_fround(Math_fround(Math_fround(f43 * f40) - Math_fround(f38 * f9)) + Math_fround(Math_fround(f8 * f13) + Math_fround(f11 * f18)));
 f11 = Math_fround(f12 * Math_fround(2.0));
 f13 = Math_fround(f8 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f11 * f14) + Math_fround(f10 * f13));
 f14 = Math_fround(Math_fround(f11 * f10) - Math_fround(f14 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f8 * f13)) + Math_fround(-1.0));
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f9 * f9) + Math_fround(f13 * f13))))));
 f9 = Math_fround(-Math_fround(f9 * f8));
 f14 = Math_fround(-Math_fround(f14 * f8));
 HEAPF32[i30 >> 2] = Math_fround(-Math_fround(f13 * f8));
 HEAPF32[i30 + 4 >> 2] = f9;
 HEAPF32[i30 + 8 >> 2] = f14;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i31 >> 2] = i15;
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f8 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f22 * Math_fround(2.0));
 f11 = Math_fround(f9 * Math_fround(Math_fround(Math_fround(f22 * f13) + Math_fround(f16 * f8)) + Math_fround(-1.0)));
 f12 = Math_fround(f9 * Math_fround(Math_fround(f13 * f18) + Math_fround(f17 * f8)));
 f13 = Math_fround(f9 * Math_fround(Math_fround(f18 * f8) - Math_fround(f13 * f17)));
 f8 = Math_fround(f19 + f11);
 f9 = Math_fround(f20 + f12);
 f10 = Math_fround(f21 + f13);
 f11 = Math_fround(f19 - f11);
 f12 = Math_fround(f20 - f12);
 f13 = Math_fround(f21 - f13);
 f38 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 + f38);
 HEAPF32[i32 >> 2] = Math_fround(f38 * Math_fround(.00100000005));
 HEAPF32[i36 >> 2] = Math_fround(f38 * Math_fround(.0500000007));
 i15 = i23 + 32 | 0;
 i7 = HEAP8[i15 >> 0] | 0;
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i37 + 48 >> 2] = f19;
 HEAPF32[i37 + 52 >> 2] = f20;
 HEAPF32[i37 + 56 >> 2] = f21;
 HEAPF32[i37 + 60 >> 2] = Math_fround(0.0);
 f38 = Math_fround(f16 + f16);
 f40 = Math_fround(f17 + f17);
 f43 = Math_fround(f18 + f18);
 f47 = Math_fround(f17 * f40);
 f46 = Math_fround(f18 * f43);
 f42 = Math_fround(f17 * f38);
 f49 = Math_fround(f18 * f38);
 f39 = Math_fround(f22 * f38);
 f48 = Math_fround(f18 * f40);
 f40 = Math_fround(f22 * f40);
 f43 = Math_fround(f22 * f43);
 f38 = Math_fround(Math_fround(1.0) - Math_fround(f16 * f38));
 f45 = Math_fround(f42 + f43);
 f44 = Math_fround(f49 - f40);
 f43 = Math_fround(f42 - f43);
 f42 = Math_fround(f38 - f46);
 f41 = Math_fround(f48 + f39);
 f40 = Math_fround(f49 + f40);
 f39 = Math_fround(f48 - f39);
 f38 = Math_fround(f38 - f47);
 HEAPF32[i37 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f47) - f46);
 HEAPF32[i37 + 4 >> 2] = f45;
 HEAPF32[i37 + 8 >> 2] = f44;
 HEAPF32[i37 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i37 + 16 >> 2] = f43;
 HEAPF32[i37 + 20 >> 2] = f42;
 HEAPF32[i37 + 24 >> 2] = f41;
 HEAPF32[i37 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i37 + 32 >> 2] = f40;
 HEAPF32[i37 + 36 >> 2] = f39;
 HEAPF32[i37 + 40 >> 2] = f38;
 HEAPF32[i37 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i23, i37, i36, i1);
 if ((HEAP8[i15 >> 0] | 0) == i7 << 24 >> 24) {
  f46 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * Math_fround(.0199999996));
  i6 = i23 + 16 | 0;
  f43 = Math_fround(HEAPF32[i6 >> 2]);
  i4 = i23 + 20 | 0;
  f49 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = i23 + 24 | 0;
  f43 = Math_fround(f19 - f43);
  f49 = Math_fround(f20 - f49);
  f48 = Math_fround(f21 - Math_fround(HEAPF32[i2 >> 2]));
  f45 = Math_fround(-f43);
  f44 = Math_fround(-f49);
  f47 = Math_fround(-f48);
  f45 = f43 > f45 ? f43 : f45;
  f44 = f49 > f44 ? f49 : f44;
  f44 = f45 >= f44 ? f45 : f44;
  i1 = (f48 > f47 ? f48 : f47) >= Math_fround(0.0);
  f45 = i1 ? f45 : Math_fround(0.0);
  f47 = Math_fround(HEAPF32[i23 >> 2]);
  i1 = i23 + 4 | 0;
  f48 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = i23 + 8 | 0;
  f49 = Math_fround(HEAPF32[i3 >> 2]);
  i5 = i23 + 12 | 0;
  if ((f44 >= f45 ? f44 : f45) > f46 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f16 * f47) + Math_fround(f17 * f48)) + Math_fround(f18 * f49)) + Math_fround(f22 * Math_fround(HEAPF32[i5 >> 2]))) < Math_fround(.999800026)) {
   i7 = i3;
   i3 = i23;
  } else {
   __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i23, i35, i30, i33, i31);
   i52 = HEAP8[i15 >> 0] | 0;
   i52 = i52 << 24 >> 24 != 0;
   STACKTOP = i34;
   return i52 | 0;
  }
 } else {
  i1 = i23 + 4 | 0;
  i7 = i23 + 8 | 0;
  i5 = i23 + 12 | 0;
  i6 = i23 + 16 | 0;
  i4 = i23 + 20 | 0;
  i2 = i23 + 24 | 0;
  i3 = i23;
 }
 HEAP8[i15 >> 0] = 0;
 HEAPF32[i3 >> 2] = f16;
 HEAPF32[i1 >> 2] = f17;
 HEAPF32[i7 >> 2] = f18;
 HEAPF32[i5 >> 2] = f22;
 HEAPF32[i6 >> 2] = f19;
 HEAPF32[i4 >> 2] = f20;
 HEAPF32[i2 >> 2] = f21;
 HEAPF32[i23 + 28 >> 2] = Math_fround(0.0);
 if (f14 > f8) {
  f44 = Math_fround(f8 - f19);
  f46 = Math_fround(f9 - f20);
  f45 = Math_fround(f10 - f21);
  f43 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
  f47 = Math_fround(Math_fround(f18 * f45) + Math_fround(Math_fround(f17 * f46) + Math_fround(f16 * f44)));
  f48 = Math_fround(Math_fround(Math_fround(f17 * f47) + Math_fround(Math_fround(f43 * f46) - Math_fround(f22 * Math_fround(Math_fround(f18 * f44) - Math_fround(f16 * f45))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f45) - Math_fround(f22 * Math_fround(Math_fround(f16 * f46) - Math_fround(f17 * f44)))) + Math_fround(f18 * f47)) * Math_fround(2.0));
  HEAPF32[i26 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f44) - Math_fround(f22 * Math_fround(Math_fround(f17 * f45) - Math_fround(f18 * f46)))) + Math_fround(f16 * f47)) * Math_fround(2.0));
  HEAPF32[i26 + 4 >> 2] = f48;
  HEAPF32[i26 + 8 >> 2] = f49;
  HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
  f49 = Math_fround(f8 * Math_fround(0.0));
  f48 = Math_fround(f9 - f49);
  f49 = Math_fround(f10 - f49);
  HEAPF32[i28 >> 2] = Math_fround(f8 - f8);
  HEAPF32[i28 + 4 >> 2] = f48;
  HEAPF32[i28 + 8 >> 2] = f49;
  HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i24 >> 2] = 1065353216;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAPF32[i24 + 12 >> 2] = f8;
  __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i23, i26, i28, i24, i32) | 0;
 }
 if (f14 > f11) {
  f44 = Math_fround(f11 - f19);
  f46 = Math_fround(f12 - f20);
  f45 = Math_fround(f13 - f21);
  f43 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
  f47 = Math_fround(Math_fround(f18 * f45) + Math_fround(Math_fround(f17 * f46) + Math_fround(f16 * f44)));
  f48 = Math_fround(Math_fround(Math_fround(f17 * f47) + Math_fround(Math_fround(f43 * f46) - Math_fround(f22 * Math_fround(Math_fround(f18 * f44) - Math_fround(f16 * f45))))) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f45) - Math_fround(f22 * Math_fround(Math_fround(f16 * f46) - Math_fround(f17 * f44)))) + Math_fround(f18 * f47)) * Math_fround(2.0));
  HEAPF32[i27 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f43 * f44) - Math_fround(f22 * Math_fround(Math_fround(f17 * f45) - Math_fround(f18 * f46)))) + Math_fround(f16 * f47)) * Math_fround(2.0));
  HEAPF32[i27 + 4 >> 2] = f48;
  HEAPF32[i27 + 8 >> 2] = f49;
  HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
  f49 = Math_fround(f11 * Math_fround(0.0));
  f48 = Math_fround(f12 - f49);
  f49 = Math_fround(f13 - f49);
  HEAPF32[i29 >> 2] = Math_fround(f11 - f11);
  HEAPF32[i29 + 4 >> 2] = f48;
  HEAPF32[i29 + 8 >> 2] = f49;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i25 >> 2] = 1065353216;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAPF32[i25 + 12 >> 2] = f11;
  __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i23, i27, i29, i25, i32) | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i23, i35, i30, i33, i31);
 i52 = HEAP8[i15 >> 0] | 0;
 i52 = i52 << 24 >> 24 != 0;
 STACKTOP = i34;
 return i52 | 0;
}

function __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i35, i32, i31, i7, i33) {
 i35 = i35 | 0;
 i32 = i32 | 0;
 i31 = i31 | 0;
 i7 = i7 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i34 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i36 + 32 | 0;
 i6 = i36 + 16 | 0;
 i29 = i36 + 4 | 0;
 i30 = i36;
 i4 = i36 + 48 | 0;
 i8 = i32 + 12 | 0;
 i22 = i32 + 24 | 0;
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f19 = Math_fround(HEAPF32[i32 >> 2]);
 f38 = Math_fround(f17 - f19);
 i27 = i32 + 16 | 0;
 f20 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i32 + 4 | 0;
 f21 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f20 - f21);
 i23 = i32 + 20 | 0;
 f13 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i32 + 8 | 0;
 f14 = Math_fround(HEAPF32[i24 >> 2]);
 f39 = Math_fround(f13 - f14);
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f11 = Math_fround(f15 - f19);
 i25 = i32 + 28 | 0;
 f16 = Math_fround(HEAPF32[i25 >> 2]);
 f37 = Math_fround(f16 - f21);
 i26 = i32 + 32 | 0;
 f18 = Math_fround(HEAPF32[i26 >> 2]);
 f10 = Math_fround(f18 - f14);
 f9 = Math_fround(Math_fround(f12 * f10) - Math_fround(f39 * f37));
 f10 = Math_fround(Math_fround(f39 * f11) - Math_fround(f38 * f10));
 f11 = Math_fround(Math_fround(f38 * f37) - Math_fround(f12 * f11));
 f12 = Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)));
 if (f12 > Math_fround(0.0)) {
  f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12))));
  f37 = Math_fround(f9 * f39);
  f38 = Math_fround(f10 * f39);
  f39 = Math_fround(f11 * f39);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 0;
 }
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i1;
 f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = Math_fround(f12 * f19);
 f37 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = Math_fround(f39 + Math_fround(f37 * f21));
 f38 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = Math_fround(f39 + Math_fround(f38 * f14));
 HEAPF32[i5 + 12 >> 2] = Math_fround(-f39);
 f12 = Math_fround(Math_fround(HEAPF32[i35 + 2156 >> 2]) * f12);
 f37 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i35 + 2160 >> 2]) * f37));
 if (Math_fround(Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i35 + 2164 >> 2]) * f38)) - f39) < Math_fround(0.0)) {
  i35 = 0;
  STACKTOP = i36;
  return i35 | 0;
 }
 f19 = Math_fround(Math_fround(Math_fround(f19 + f17) + f15) * Math_fround(.333333343));
 f39 = Math_fround(Math_fround(Math_fround(f21 + f20) + f16) * Math_fround(.333333343));
 f38 = Math_fround(Math_fround(Math_fround(f14 + f13) + f18) * Math_fround(.333333343));
 HEAPF32[i6 >> 2] = f19;
 HEAPF32[i6 + 4 >> 2] = f39;
 HEAPF32[i6 + 8 >> 2] = f38;
 i3 = i35 + 2108 | 0;
 f18 = Math_fround(f19 * Math_fround(HEAPF32[i3 >> 2]));
 f37 = Math_fround(f19 * Math_fround(HEAPF32[i35 + 2112 >> 2]));
 f21 = Math_fround(f19 * Math_fround(HEAPF32[i35 + 2116 >> 2]));
 f19 = Math_fround(f39 * Math_fround(HEAPF32[i35 + 2120 >> 2]));
 f20 = Math_fround(f39 * Math_fround(HEAPF32[i35 + 2124 >> 2]));
 f19 = Math_fround(f18 + f19);
 f20 = Math_fround(f37 + f20);
 f39 = Math_fround(f21 + Math_fround(f39 * Math_fround(HEAPF32[i35 + 2128 >> 2])));
 f21 = Math_fround(f38 * Math_fround(HEAPF32[i35 + 2132 >> 2]));
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i35 + 2136 >> 2]));
 f21 = Math_fround(f19 + f21);
 f37 = Math_fround(f20 + f37);
 f38 = Math_fround(f39 + Math_fround(f38 * Math_fround(HEAPF32[i35 + 2140 >> 2])));
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i35 + 2144 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i35 + 2148 >> 2]));
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i35 + 2152 >> 2]));
 f39 = Math_fround(HEAPF32[i35 + 2196 >> 2]);
 if (!(__ZL18triangleConvexTestRKN5physx2Gu13PolygonalDataEhjPKNS_6PxVec3ERKNS_7PxPlaneERS5_RKNS_2Cm8Matrix34ESE_SE_SE_RKNSB_23FastVertex2ShapeScalingEfRS4_RfRbb(HEAP32[i35 + 2180 >> 2] | 0, i7, i32, i5, f21, f37, f38, HEAP32[i35 + 2188 >> 2] | 0, i35 + 2060 | 0, i3, HEAP32[i35 + 2192 >> 2] | 0, f39, i29, i30, i4, (HEAP8[i35 + 2201 >> 0] | 0) != 0) | 0)) {
  i35 = 0;
  STACKTOP = i36;
  return i35 | 0;
 }
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = HEAP32[i35 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 + 17 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
   __ZN5physx2Gu9Container6ResizeEj(i2, 17) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i35 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 17;
  HEAP32[i35 + (i1 << 2) >> 2] = i31;
  HEAP32[i35 + (i1 + 1 << 2) >> 2] = HEAP32[i32 >> 2];
  HEAP32[i35 + (i1 + 2 << 2) >> 2] = HEAP32[i28 >> 2];
  HEAP32[i35 + (i1 + 3 << 2) >> 2] = HEAP32[i24 >> 2];
  HEAP32[i35 + (i1 + 4 << 2) >> 2] = HEAP32[i8 >> 2];
  HEAP32[i35 + (i1 + 5 << 2) >> 2] = HEAP32[i27 >> 2];
  HEAP32[i35 + (i1 + 6 << 2) >> 2] = HEAP32[i23 >> 2];
  HEAP32[i35 + (i1 + 7 << 2) >> 2] = HEAP32[i22 >> 2];
  HEAP32[i35 + (i1 + 8 << 2) >> 2] = HEAP32[i25 >> 2];
  HEAP32[i35 + (i1 + 9 << 2) >> 2] = HEAP32[i26 >> 2];
  HEAP32[i35 + (i1 + 10 << 2) >> 2] = HEAP32[i33 >> 2];
  HEAP32[i35 + (i1 + 11 << 2) >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i35 + (i1 + 12 << 2) >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i35 + (i1 + 13 << 2) >> 2] = HEAP32[i29 >> 2];
  HEAP32[i35 + (i1 + 14 << 2) >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i35 + (i1 + 15 << 2) >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[i35 + (i1 + 16 << 2) >> 2] = HEAP32[i30 >> 2];
  i35 = 1;
  STACKTOP = i36;
  return i35 | 0;
 }
 if (!(__ZNK5physx2Gu29ConvexVsMeshContactGeneration16generateContactsERKNS_7PxPlaneEPKNS_6PxVec3ERS6_RS5_fj(i35, i5, i32, i6, i29, Math_fround(HEAPF32[i30 >> 2]), i31) | 0)) {
  i35 = 1;
  STACKTOP = i36;
  return i35 | 0;
 }
 HEAP8[i35 + 2220 >> 0] = 1;
 i4 = HEAP32[i33 >> 2] | 0;
 i23 = i33 + 4 | 0;
 i6 = HEAP32[i23 >> 2] | 0;
 i22 = i4 >>> 0 < i6 >>> 0;
 i5 = i22 ? i4 : i6;
 i6 = i22 ? i6 : i4;
 i22 = i35 + 1284 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 L20 : do if ((i7 | 0) == 128) i6 = i33 + 8 | 0; else {
  i2 = i5 << 16 | i6;
  i2 = i2 + ~(i2 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = ((i2 >>> 16 ^ i2) & 127) + (i35 + 1156) | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  L23 : do if (i1 << 24 >> 24 == -1) {
   HEAP8[i2 >> 0] = i7;
   i34 = 16;
  } else {
   i3 = i1 & 255;
   while (1) {
    if ((HEAP32[i35 + 4 + (i3 << 3) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i35 + 4 + (i3 << 3) + 4 >> 2] | 0) == (i6 | 0)) {
     i2 = i4;
     break L23;
    }
    i2 = HEAP8[i35 + 1028 + i3 >> 0] | 0;
    if (i2 << 24 >> 24 == -1) break; else {
     i3 = i2 & 255;
     i1 = i2;
    }
   }
   HEAP8[(i1 & 255) + (i35 + 1028) >> 0] = i7;
   i34 = 16;
  } while (0);
  if ((i34 | 0) == 16) {
   HEAP8[(HEAP32[i22 >> 2] | 0) + (i35 + 1028) >> 0] = -1;
   i2 = HEAP32[i22 >> 2] | 0;
   HEAP32[i22 >> 2] = i2 + 1;
   i2 = i35 + 4 + (i2 << 3) | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = HEAP32[i33 >> 2] | 0;
   i7 = HEAP32[i22 >> 2] | 0;
  }
  i8 = i33 + 8 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = i2 >>> 0 < i1 >>> 0;
  i6 = i5 ? i2 : i1;
  i5 = i5 ? i1 : i2;
  L35 : do if ((i7 | 0) != 128) {
   i2 = i6 << 16 | i5;
   i2 = i2 + ~(i2 << 15) | 0;
   i2 = (i2 >>> 10 ^ i2) * 9 | 0;
   i2 = i2 >>> 6 ^ i2;
   i2 = i2 + ~(i2 << 11) | 0;
   i2 = ((i2 >>> 16 ^ i2) & 127) + (i35 + 1156) | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   if (i3 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i7; else {
    i4 = i3 & 255;
    while (1) {
     if ((HEAP32[i35 + 4 + (i4 << 3) >> 2] | 0) == (i6 | 0)) if ((HEAP32[i35 + 4 + (i4 << 3) + 4 >> 2] | 0) == (i5 | 0)) break L35;
     i2 = HEAP8[i35 + 1028 + i4 >> 0] | 0;
     if (i2 << 24 >> 24 == -1) {
      i1 = i3;
      break;
     } else {
      i4 = i2 & 255;
      i3 = i2;
     }
    }
    HEAP8[(i1 & 255) + (i35 + 1028) >> 0] = i7;
   }
   HEAP8[(HEAP32[i22 >> 2] | 0) + (i35 + 1028) >> 0] = -1;
   i1 = HEAP32[i22 >> 2] | 0;
   HEAP32[i22 >> 2] = i1 + 1;
   i1 = i35 + 4 + (i1 << 3) | 0;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = HEAP32[i8 >> 2] | 0;
   i7 = HEAP32[i22 >> 2] | 0;
  } while (0);
  i4 = HEAP32[i23 >> 2] | 0;
  i32 = i4 >>> 0 < i1 >>> 0;
  i5 = i32 ? i4 : i1;
  i4 = i32 ? i1 : i4;
  if ((i7 | 0) == 128) i6 = i8; else {
   i2 = i5 << 16 | i4;
   i2 = i2 + ~(i2 << 15) | 0;
   i2 = (i2 >>> 10 ^ i2) * 9 | 0;
   i2 = i2 >>> 6 ^ i2;
   i2 = i2 + ~(i2 << 11) | 0;
   i2 = ((i2 >>> 16 ^ i2) & 127) + (i35 + 1156) | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   if (i1 << 24 >> 24 == -1) HEAP8[i2 >> 0] = i7; else {
    i3 = i1 & 255;
    while (1) {
     if ((HEAP32[i35 + 4 + (i3 << 3) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i35 + 4 + (i3 << 3) + 4 >> 2] | 0) == (i4 | 0)) {
      i6 = i8;
      break L20;
     }
     i2 = HEAP8[i35 + 1028 + i3 >> 0] | 0;
     if (i2 << 24 >> 24 == -1) break; else {
      i3 = i2 & 255;
      i1 = i2;
     }
    }
    HEAP8[(i1 & 255) + (i35 + 1028) >> 0] = i7;
   }
   HEAP8[(HEAP32[i22 >> 2] | 0) + (i35 + 1028) >> 0] = -1;
   i6 = HEAP32[i22 >> 2] | 0;
   HEAP32[i22 >> 2] = i6 + 1;
   i6 = i35 + 4 + (i6 << 3) | 0;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i6 + 4 >> 2] = i4;
   i6 = i8;
  }
 } while (0);
 i4 = HEAP32[i33 >> 2] | 0;
 i7 = i35 + 2056 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if ((i5 | 0) == 128) {
  i35 = 1;
  STACKTOP = i36;
  return i35 | 0;
 }
 i2 = (i4 & 127) + (i35 + 1928) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 L63 : do if (i1 << 24 >> 24 == -1) {
  HEAP8[i2 >> 0] = i5;
  i34 = 42;
 } else {
  i3 = i1 & 255;
  while (1) {
   if ((HEAP32[i35 + 1288 + (i3 << 2) >> 2] | 0) == (i4 | 0)) break L63;
   i2 = HEAP8[i35 + 1800 + i3 >> 0] | 0;
   if (i2 << 24 >> 24 == -1) break; else {
    i3 = i2 & 255;
    i1 = i2;
   }
  }
  HEAP8[(i1 & 255) + (i35 + 1800) >> 0] = i5;
  i34 = 42;
 } while (0);
 if ((i34 | 0) == 42) {
  HEAP8[(HEAP32[i7 >> 2] | 0) + (i35 + 1800) >> 0] = -1;
  i5 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i5 + 1;
  HEAP32[i35 + 1288 + (i5 << 2) >> 2] = i4;
  i5 = HEAP32[i7 >> 2] | 0;
 }
 i4 = HEAP32[i23 >> 2] | 0;
 if ((i5 | 0) == 128) {
  i35 = 1;
  STACKTOP = i36;
  return i35 | 0;
 }
 i2 = (i4 & 127) + (i35 + 1928) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 L76 : do if (i1 << 24 >> 24 == -1) {
  HEAP8[i2 >> 0] = i5;
  i34 = 50;
 } else {
  i3 = i1 & 255;
  while (1) {
   if ((HEAP32[i35 + 1288 + (i3 << 2) >> 2] | 0) == (i4 | 0)) break L76;
   i2 = HEAP8[i35 + 1800 + i3 >> 0] | 0;
   if (i2 << 24 >> 24 == -1) break; else {
    i3 = i2 & 255;
    i1 = i2;
   }
  }
  HEAP8[(i1 & 255) + (i35 + 1800) >> 0] = i5;
  i34 = 50;
 } while (0);
 if ((i34 | 0) == 50) {
  HEAP8[(HEAP32[i7 >> 2] | 0) + (i35 + 1800) >> 0] = -1;
  i5 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i5 + 1;
  HEAP32[i35 + 1288 + (i5 << 2) >> 2] = i4;
  i5 = HEAP32[i7 >> 2] | 0;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 if ((i5 | 0) == 128) {
  i35 = 1;
  STACKTOP = i36;
  return i35 | 0;
 }
 i1 = (i4 & 127) + (i35 + 1928) | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 do if (i2 << 24 >> 24 == -1) HEAP8[i1 >> 0] = i5; else {
  i3 = i2 & 255;
  i1 = i2;
  while (1) {
   if ((HEAP32[i35 + 1288 + (i3 << 2) >> 2] | 0) == (i4 | 0)) {
    i1 = 1;
    i34 = 62;
    break;
   }
   i2 = HEAP8[i35 + 1800 + i3 >> 0] | 0;
   if (i2 << 24 >> 24 == -1) {
    i34 = 57;
    break;
   } else {
    i3 = i2 & 255;
    i1 = i2;
   }
  }
  if ((i34 | 0) == 57) {
   HEAP8[(i1 & 255) + (i35 + 1800) >> 0] = i5;
   break;
  } else if ((i34 | 0) == 62) {
   STACKTOP = i36;
   return i1 | 0;
  }
 } while (0);
 HEAP8[(HEAP32[i7 >> 2] | 0) + (i35 + 1800) >> 0] = -1;
 i34 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i34 + 1;
 HEAP32[i35 + 1288 + (i34 << 2) >> 2] = i4;
 i35 = 1;
 STACKTOP = i36;
 return i35 | 0;
}

function __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i13, i2) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 24 | 0;
 i11 = i14 + 12 | 0;
 i3 = i14;
 i12 = i13 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 if ((i2 | 0) != 1 & (i1 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 if (!(_gettimeofday(i10 | 0, 0) | 0)) {
  i6 = HEAP32[i10 >> 2] | 0;
  i6 = ___muldi3(i6 | 0, ((i6 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
  i5 = getTempRet0() | 0;
  i9 = (HEAP32[i10 + 4 >> 2] | 0) / 1e3 | 0;
  i5 = _i64Add(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, i6 | 0, i5 | 0) | 0;
  i6 = getTempRet0() | 0;
 } else {
  i5 = 0;
  i6 = 0;
 }
 HEAP32[i12 >> 2] = i2;
 do if ((i2 | 2 | 0) == 3) {
  if ((i2 | 0) == 1) {
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   i7 = i2;
   i8 = gb + 1041430 | 0;
   i9 = i7 + 22 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i7 | 0) < (i9 | 0));
   HEAP8[i2 + 22 >> 0] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i2, 22);
   __Z21UnsignedInt64ToStringy(i3, 0, 0);
   __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11, i3);
   i9 = __Z14StringToUInt64PKc((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0;
   i8 = getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i7 = i13 + 16 | 0;
   HEAP32[i7 >> 2] = i9;
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   i7 = i2;
   i8 = gb + 1041453 | 0;
   i9 = i7 + 33 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i7 | 0) < (i9 | 0));
   HEAP8[i2 + 33 >> 0] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i2, 33);
   __Z21UnsignedInt64ToStringy(i3, 0, 0);
   __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11, i3);
   i9 = __Z14StringToUInt64PKc((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0;
   i8 = getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i7 = i13 + 24 | 0;
   HEAP32[i7 >> 2] = i9;
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   i7 = i2;
   i8 = gb + 1041487 | 0;
   i9 = i7 + 36 | 0;
   do {
    HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i8 = i8 + 1 | 0;
   } while ((i7 | 0) < (i9 | 0));
   HEAP8[i2 + 36 >> 0] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i2, 36);
   __Z21UnsignedInt64ToStringy(i3, 0, 0);
   __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11, i3);
   i7 = __Z14StringToUInt64PKc((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0;
   i8 = getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i9 = i13 + 40 | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
  } else {
   i1 = __Z20GetPlayerSettingsPtrv() | 0;
   if (i1 | 0) if (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) | 0) if (__Z20IsHumanControllingUsv() | 0) {
    i9 = _time(0) | 0;
    i1 = i13 + 64 | 0;
    if ((i9 - (HEAP32[i1 >> 2] | 0) | 0) >>> 0 > 1800) {
     HEAP32[i1 >> 2] = 0;
     __ZN19UnityConnectService13ReportSessionEv(i13);
    }
   }
  }
  i2 = i13 + 40 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i13 + 32 | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 4 >> 2] = i6;
  i4 = i13 + 16 | 0;
  i9 = i4;
  if ((HEAP32[i9 >> 2] | 0) == 0 & (HEAP32[i9 + 4 >> 2] | 0) == 0) i1 = i13 + 24 | 0; else {
   i8 = _i64Subtract(i5 | 0, i6 | 0, i1 | 0, i2 | 0) | 0;
   i7 = getTempRet0() | 0;
   i1 = i13 + 24 | 0;
   i9 = i1;
   if (!((i7 | 0) > 0 | (i7 | 0) == 0 & i8 >>> 0 > 18e5 | (HEAP32[i9 >> 2] | 0) == 0 & (HEAP32[i9 + 4 >> 2] | 0) == 0)) break;
  }
  i2 = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  d15 = +_emscripten_get_now() * 1.0e6;
  i2 = __Z17TimeToNanosecondsy(~~d15 >>> 0, +Math_abs(d15) >= 1.0 ? (d15 > 0.0 ? ~~+Math_min(+Math_floor(d15 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d15 - +(~~d15 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
  getTempRet0() | 0;
  i3 = (Math_imul(i2, 1790253981) | 0) + 1900727103 | 0;
  i2 = i2 << 11 ^ i2;
  i3 = i3 ^ i2 ^ i2 >>> 8 ^ i3 >>> 19;
  i2 = i4;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i2 + 4 >> 2] = i3 & 2147483647;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i7 = i3;
  i8 = gb + 1041430 | 0;
  i9 = i7 + 22 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  HEAP8[i3 + 22 >> 0] = 0;
  i7 = i4;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i3, 22);
  __Z21UnsignedInt64ToStringy(i11, i8, i7);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i7 = i3;
  i8 = gb + 1041453 | 0;
  i9 = i7 + 33 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  HEAP8[i3 + 33 >> 0] = 0;
  i9 = i1;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i3, 33);
  __Z21UnsignedInt64ToStringy(i11, i8, i9);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
 } else {
  i3 = i13 + 32 | 0;
  i3 = _i64Subtract(i5 | 0, i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
  i1 = getTempRet0() | 0;
  i4 = i13 + 24 | 0;
  i2 = i4;
  i2 = _i64Add(i3 | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i1 = getTempRet0() | 0;
  i3 = i4;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = i13 + 40 | 0;
  i1 = i3;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i6;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i7 = i2;
  i8 = gb + 1041453 | 0;
  i9 = i7 + 33 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  HEAP8[i2 + 33 >> 0] = 0;
  i7 = i4;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i2, 33);
  __Z21UnsignedInt64ToStringy(i11, i8, i7);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i7 = i2;
  i8 = gb + 1041487 | 0;
  i9 = i7 + 36 | 0;
  do {
   HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
   i7 = i7 + 1 | 0;
   i8 = i8 + 1 | 0;
  } while ((i7 | 0) < (i9 | 0));
  HEAP8[i2 + 36 >> 0] = 0;
  i9 = i3;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i2, 36);
  __Z21UnsignedInt64ToStringy(i11, i8, i9);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i10, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
  i1 = __Z20GetPlayerSettingsPtrv() | 0;
  if (!i1) i1 = i4; else if (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) | 0) if (__Z20IsHumanControllingUsv() | 0) {
   HEAP32[i13 + 64 >> 2] = _time(0) | 0;
   i1 = i4;
  } else i1 = i4; else i1 = i4;
 } while (0);
 i9 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i7 = i13 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i9 + 18524 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 } else i1 = 0;
 do {
  i5 = i9 + 17756 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i9 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiiii(HEAP32[i5 >> 2] | 0, i8 | 0, i6 | 0, i7 | 0, i2 | 0, i3 | 0); else mftCall_viiiiii(HEAP32[i5 >> 2] | 0, HEAP32[i9 + 17756 + (i1 * 12 | 0) + 4 >> 2] | 0, i8 | 0, i6 | 0, i7 | 0, i2 | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN4Mesh15CopyTransformedERKS_RK10Matrix4x4f(i30, i31, i3) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, f33 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i32 + 36 | 0;
 i22 = i32;
 if ((HEAP16[gb + 1161436 + 6 >> 1] | 0) > -1) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161436 | 0, i23);
  i29 = gb + 1161436 | 0;
 } else i29 = 0;
 i28 = i30 + 32 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i28 >> 2] | 0);
  i2 = HEAP32[i28 >> 2] | 0;
  i27 = i2 + 4 | 0;
  HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + -1;
  if (!(HEAP32[i27 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i28 >> 2] = i1;
 }
 i24 = i31 + 32 | 0;
 i27 = HEAP32[i24 >> 2] | 0;
 i25 = HEAP32[i27 + 100 >> 2] | 0;
 i26 = HEAP32[i27 + 96 >> 2] | 0;
 i27 = i27 + 8 | 0;
 __ZNK14VertexDataInfo16GetStreamsLayoutEv(i23, i27);
 __ZNK14VertexDataInfo17GetChannelsLayoutEv(i22, i27);
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1 + 8 | 0, i25, i26, ~i26, i23, i22);
 if (i26 & 1 | 0) {
  i15 = HEAP32[i24 >> 2] | 0;
  i16 = i15 + 8 | 0;
  i17 = HEAP16[i16 >> 1] | 0;
  i18 = HEAP32[i28 >> 2] | 0;
  i20 = i18 + 8 | 0;
  i21 = HEAP16[i20 >> 1] | 0;
  __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fjPS2_ji(i3, (HEAP32[i15 + 92 >> 2] | 0) + (((i17 & 65535) >>> 8 & 65535) + (HEAP32[i16 + 32 + ((i17 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, HEAPU8[i16 + 32 + ((i17 & 255) * 12 | 0) + 10 >> 0] | 0, (HEAP32[i18 + 92 >> 2] | 0) + (((i21 & 65535) >>> 8 & 65535) + (HEAP32[i20 + 32 + ((i21 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0, HEAPU8[i20 + 32 + ((i21 & 255) * 12 | 0) + 10 >> 0] | 0, i25);
 }
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i23, i3);
 i1 = i22;
 i2 = i23;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN10Matrix3x3f15InvertTransposeEv(i22);
 if (i26 & 2 | 0) {
  i3 = HEAP32[i24 >> 2] | 0;
  i4 = i3 + 8 | 0;
  i2 = HEAP16[i3 + 14 >> 1] | 0;
  if ((i2 & 65535) < 768 | (i2 & 255) != 0) {
   i5 = 0;
   i21 = 0;
   i1 = i2;
  } else {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) {
    i5 = 0;
    i21 = 1;
    i1 = i2;
   } else if (!(HEAP8[i3 + 15 >> 0] | 0)) {
    i5 = 0;
    i21 = 1;
    i1 = i2;
   } else {
    i20 = HEAP32[i3 + 12 >> 2] | 0;
    i5 = i1 + ((i20 >>> 8 & 255) + (HEAP32[i4 + 32 + ((i20 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i21 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i1 = i20 >>> 16 & 65535;
   }
  }
  if ((i1 & 65535) < 768 | (i1 & 255) != 0) i20 = 0; else {
   i1 = HEAP32[i3 + 100 >> 2] | 0;
   i2 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i2) i20 = 0; else if (!(HEAP8[i3 + 15 >> 0] | 0)) i20 = 0; else {
    i20 = HEAP16[i3 + 12 >> 1] | 0;
    i20 = i2 + ((Math_imul(HEAPU8[i4 + 32 + ((HEAPU8[i3 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i4 + 32 + ((i20 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i20 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  i2 = HEAP32[i28 >> 2] | 0;
  i3 = i2 + 8 | 0;
  i18 = HEAP16[i2 + 14 >> 1] | 0;
  if ((i18 & 65535) < 768 | (i18 & 255) != 0) {
   i1 = 0;
   i6 = 0;
  } else {
   i1 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i6 = 1;
   } else if (!(HEAP8[i2 + 15 >> 0] | 0)) {
    i1 = 0;
    i6 = 1;
   } else {
    i6 = HEAP16[i2 + 12 >> 1] | 0;
    i1 = i1 + (((i6 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i6 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  if ((i5 | 0) != (i20 | 0)) {
   i7 = i22 + 12 | 0;
   i8 = i22 + 24 | 0;
   i13 = i22 + 4 | 0;
   i14 = i22 + 16 | 0;
   i15 = i22 + 28 | 0;
   i16 = i22 + 8 | 0;
   i17 = i22 + 20 | 0;
   i18 = i22 + 32 | 0;
   f19 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   while (1) {
    f9 = Math_fround(HEAPF32[i22 >> 2]);
    f33 = Math_fround(HEAPF32[i5 >> 2]);
    f9 = Math_fround(f9 * f33);
    f10 = Math_fround(HEAPF32[i7 >> 2]);
    f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f10 = Math_fround(f9 + Math_fround(f10 * f12));
    f9 = Math_fround(HEAPF32[i8 >> 2]);
    f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f9 = Math_fround(f10 + Math_fround(f9 * f11));
    f10 = Math_fround(f33 * Math_fround(HEAPF32[i13 >> 2]));
    f10 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2])));
    f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2])));
    f33 = Math_fround(f33 * Math_fround(HEAPF32[i16 >> 2]));
    f12 = Math_fround(f33 + Math_fround(f12 * Math_fround(HEAPF32[i17 >> 2])));
    f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2])));
    f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11))));
    if (f12 > f19) {
     f33 = Math_fround(f9 / f12);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
     f33 = Math_fround(f10 / f12);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
     f33 = Math_fround(f11 / f12);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i2 = HEAP32[gb + 1162364 >> 2] | 0;
     i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
     i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
    }
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 4 >> 2] = i3;
    HEAP32[i1 + 8 >> 2] = i4;
    i5 = i5 + i21 | 0;
    if ((i5 | 0) == (i20 | 0)) break; else i1 = i1 + i6 | 0;
   }
  }
 }
 if (i26 & 128 | 0) {
  i3 = HEAP32[i24 >> 2] | 0;
  i4 = i3 + 8 | 0;
  i2 = HEAP16[i3 + 38 >> 1] | 0;
  if ((i2 & 65535) < 1024 | (i2 & 255) != 0) {
   i5 = 0;
   i21 = 0;
   i1 = i2;
  } else {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) {
    i5 = 0;
    i21 = 1;
    i1 = i2;
   } else if (!(HEAP8[i3 + 39 >> 0] | 0)) {
    i5 = 0;
    i21 = 1;
    i1 = i2;
   } else {
    i22 = HEAP32[i3 + 36 >> 2] | 0;
    i5 = i1 + ((i22 >>> 8 & 255) + (HEAP32[i4 + 32 + ((i22 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i21 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i1 = i22 >>> 16 & 65535;
   }
  }
  if ((i1 & 65535) < 1024 | (i1 & 255) != 0) i20 = 0; else {
   i1 = HEAP32[i3 + 100 >> 2] | 0;
   i2 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i2) i20 = 0; else if (!(HEAP8[i3 + 39 >> 0] | 0)) i20 = 0; else {
    i20 = HEAP16[i3 + 36 >> 1] | 0;
    i20 = i2 + ((Math_imul(HEAPU8[i4 + 32 + ((HEAPU8[i3 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i1) | 0) + (HEAP32[i4 + 32 + ((i20 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i20 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  i2 = HEAP32[i28 >> 2] | 0;
  i3 = i2 + 8 | 0;
  i22 = HEAP16[i2 + 38 >> 1] | 0;
  if ((i22 & 65535) < 1024 | (i22 & 255) != 0) {
   i1 = 0;
   i6 = 0;
  } else {
   i1 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i6 = 1;
   } else if (!(HEAP8[i2 + 39 >> 0] | 0)) {
    i1 = 0;
    i6 = 1;
   } else {
    i6 = HEAP16[i2 + 36 >> 1] | 0;
    i1 = i1 + (((i6 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i6 = HEAPU8[i3 + 32 + ((HEAPU8[i2 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  if ((i5 | 0) != (i20 | 0)) {
   i7 = i23 + 12 | 0;
   i8 = i23 + 24 | 0;
   i13 = i23 + 4 | 0;
   i14 = i23 + 16 | 0;
   i15 = i23 + 28 | 0;
   i16 = i23 + 8 | 0;
   i17 = i23 + 20 | 0;
   i18 = i23 + 32 | 0;
   f19 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   while (1) {
    f33 = Math_fround(HEAPF32[i5 >> 2]);
    f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f9 = Math_fround(f33 * Math_fround(HEAPF32[i23 >> 2]));
    f9 = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i7 >> 2])));
    f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i8 >> 2])));
    f10 = Math_fround(f33 * Math_fround(HEAPF32[i13 >> 2]));
    f10 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2])));
    f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2])));
    f33 = Math_fround(f33 * Math_fround(HEAPF32[i16 >> 2]));
    f12 = Math_fround(f33 + Math_fround(f12 * Math_fround(HEAPF32[i17 >> 2])));
    f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2])));
    f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11))));
    if (f12 > f19) {
     f33 = Math_fround(f9 / f12);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
     f33 = Math_fround(f10 / f12);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
     f33 = Math_fround(f11 / f12);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i2 = HEAP32[gb + 1162364 >> 2] | 0;
     i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
     i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
    }
    i22 = HEAP32[i5 + 12 >> 2] | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 4 >> 2] = i3;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i1 + 12 >> 2] = i22;
    i5 = i5 + i21 | 0;
    if ((i5 | 0) == (i20 | 0)) break; else i1 = i1 + i6 | 0;
   }
  }
 }
 i1 = HEAP32[i28 >> 2] | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 112 | 0, HEAP32[i2 + 112 >> 2] | 0, HEAP32[i2 + 116 >> 2] | 0);
  i2 = HEAP32[i28 >> 2] | 0;
  i1 = HEAP32[i24 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2 + 128 | 0, HEAP32[i1 + 128 >> 2] | 0, HEAP32[i1 + 132 >> 2] | 0);
   i6 = HEAP32[i28 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i5 = i6 + 164 | 0;
   if ((i1 | 0) != (i6 | 0)) {
    i7 = HEAP32[i1 + 164 >> 2] | 0;
    i8 = i6 + 176 | 0;
    i1 = HEAP32[i1 + 176 >> 2] << 5;
    i2 = i1 >> 5;
    HEAP32[i8 >> 2] = i2;
    i3 = i6 + 180 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 16, i6 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i5 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i6 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] << 5 | 0) | 0;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i5 >> 2] = i1;
     break;
    } else i1 = HEAP32[i5 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 5 | 0) | 0;
    i1 = HEAP32[i28 >> 2] | 0;
   }
  }
 }
 __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i25, i26 & 124, i27, i1 + 8 | 0);
 i28 = i30 + 44 | 0;
 HEAP8[i28 >> 0] = HEAP8[i28 >> 0] & -17 | HEAP8[i31 + 44 >> 0] & 16;
 i28 = i30 + 48 | 0;
 i31 = i31 + 48 | 0;
 HEAP32[i28 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[i31 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[i31 + 20 >> 2];
 __ZN17CollisionMeshData20VertexDataHasChangedEv(i30 + 204 | 0);
 __ZN4Mesh16SetChannelsDirtyEjb(i30, i26, 1);
 __ZN4Mesh14ClearSkinCacheEv(i30);
 if (!i29) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i29);
 STACKTOP = i32;
 return;
}

function __ZN5physx22PxVehicleWheelsDynData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 704 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx23PxVehicleWheels4DynData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx25PxVehicleConstraintShader17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i24 >> 2] = HEAP32[gb + 162224 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 162224 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 162224 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 162224 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 162224 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 162224 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 162224 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 162224 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 162256 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 162256 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 162256 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 162256 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 162256 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 162256 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 162256 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 162256 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 162288 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 162288 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 162288 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 162288 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 162288 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 162288 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 162288 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 162288 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 162320 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 162320 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 162320 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 162320 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 162320 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 162320 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 162320 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 162320 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 162352 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 162352 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 162352 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 162352 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 162352 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 162352 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 162352 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 162352 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 162384 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 162384 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 162384 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 162384 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 162384 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 162384 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 162384 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 162384 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 162416 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 162416 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 162416 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 162416 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 162416 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 162416 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 162416 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 162416 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 162448 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 162448 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 162448 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 162448 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 162448 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 162448 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 162448 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 162448 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 162480 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 162480 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 162480 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 162480 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 162480 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 162480 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 162480 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 162480 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 162512 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 162512 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 162512 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 162512 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 162512 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 162512 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 162512 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 162512 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 162544 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 162544 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 162544 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 162544 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 162544 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 162544 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 162544 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 162544 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 162576 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 162576 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 162576 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 162576 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 162576 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 162576 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 162576 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 162576 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 162608 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 162608 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 162608 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 162608 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 162608 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 162608 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 162608 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 162608 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 162640 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 162640 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 162640 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 162640 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 162640 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 162640 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 162640 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 162640 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 162640 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 162640 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 162640 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 162640 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 162640 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 162640 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 162640 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 162640 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 162640 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 162640 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 162640 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 162640 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 162640 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 162640 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 162640 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 162640 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 162640 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 162640 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 162640 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 162640 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 162640 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 162640 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 162640 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 162640 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 162672 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 162672 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 162672 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 162672 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 162672 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 162672 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 162672 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 162672 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 162672 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 162672 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 162672 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 162672 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 162672 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 162672 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 162672 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 162672 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 162672 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 162672 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 162672 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 162672 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 162672 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 162672 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 162672 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 162672 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 162672 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 162672 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 162672 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 162672 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 162672 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 162672 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 162672 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 162672 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 162704 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 162704 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 162704 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 162704 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 162704 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 162704 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 162704 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 162704 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu33pcmDistanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_S7_(i60, i47, i34, i42, i45, i6, i62, i64, i66) {
 i60 = i60 | 0;
 i47 = i47 | 0;
 i34 = i34 | 0;
 i42 = i42 | 0;
 i45 = i45 | 0;
 i6 = i6 | 0;
 i62 = i62 | 0;
 i64 = i64 | 0;
 i66 = i66 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i61 = 0, i63 = 0, i65 = 0, i67 = 0, i68 = 0, f69 = f0, f70 = f0;
 i68 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i68 + 304 | 0;
 i48 = i68 + 96 | 0;
 i43 = i68 + 80 | 0;
 i44 = i68 + 64 | 0;
 i46 = i68 + 48 | 0;
 i16 = i68 + 292 | 0;
 i17 = i68 + 280 | 0;
 i18 = i68 + 268 | 0;
 i41 = i68 + 256 | 0;
 i40 = i68 + 244 | 0;
 i39 = i68 + 232 | 0;
 i50 = i68 + 32 | 0;
 i51 = i68 + 16 | 0;
 i49 = i68;
 i61 = i68 + 220 | 0;
 i65 = i68 + 208 | 0;
 i67 = i68 + 196 | 0;
 i63 = i68 + 184 | 0;
 i57 = i68 + 172 | 0;
 i56 = i68 + 160 | 0;
 i55 = i68 + 148 | 0;
 i59 = i68 + 136 | 0;
 i58 = i68 + 124 | 0;
 i54 = i68 + 112 | 0;
 f10 = Math_fround(HEAPF32[i34 >> 2]);
 i29 = i34 + 4 | 0;
 f52 = Math_fround(HEAPF32[i29 >> 2]);
 i33 = i34 + 8 | 0;
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f38 = Math_fround(HEAPF32[i47 >> 2]);
 i12 = i47 + 4 | 0;
 f28 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i47 + 8 | 0;
 f53 = Math_fround(HEAPF32[i13 >> 2]);
 f26 = Math_fround(f52 - f28);
 f36 = Math_fround(f8 - f53);
 HEAPF32[i48 >> 2] = Math_fround(f10 - f38);
 i7 = i48 + 4 | 0;
 HEAPF32[i7 >> 2] = f26;
 i11 = i48 + 8 | 0;
 HEAPF32[i11 >> 2] = f36;
 HEAPF32[i48 + 12 >> 2] = Math_fround(0.0);
 f36 = Math_fround(HEAPF32[i45 >> 2]);
 f26 = Math_fround(HEAPF32[i45 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i45 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i42 >> 2]);
 i14 = i42 + 4 | 0;
 f21 = Math_fround(HEAPF32[i14 >> 2]);
 i20 = i42 + 8 | 0;
 f9 = Math_fround(HEAPF32[i20 >> 2]);
 f30 = Math_fround(f36 - f15);
 f31 = Math_fround(f26 - f21);
 f32 = Math_fround(f25 - f9);
 HEAPF32[i43 >> 2] = f30;
 HEAPF32[i43 + 4 >> 2] = f31;
 HEAPF32[i43 + 8 >> 2] = f32;
 HEAPF32[i43 + 12 >> 2] = Math_fround(0.0);
 f27 = Math_fround(HEAPF32[i6 >> 2]);
 f35 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f22 = Math_fround(f27 - f15);
 f23 = Math_fround(f35 - f21);
 f24 = Math_fround(f37 - f9);
 HEAPF32[i44 >> 2] = f22;
 HEAPF32[i44 + 4 >> 2] = f23;
 HEAPF32[i44 + 8 >> 2] = f24;
 HEAPF32[i44 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(f35 - f26);
 f25 = Math_fround(f37 - f25);
 HEAPF32[i46 >> 2] = Math_fround(f27 - f36);
 HEAPF32[i46 + 4 >> 2] = f26;
 HEAPF32[i46 + 8 >> 2] = f25;
 HEAPF32[i46 + 12 >> 2] = Math_fround(0.0);
 f25 = Math_fround(Math_fround(f31 * f24) - Math_fround(f32 * f23));
 f26 = Math_fround(Math_fround(f32 * f22) - Math_fround(f30 * f24));
 f36 = Math_fround(Math_fround(f30 * f23) - Math_fround(f31 * f22));
 f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f36 * f36) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
 f25 = Math_fround(f25 * f27);
 f26 = Math_fround(f26 * f27);
 f27 = Math_fround(f36 * f27);
 f36 = Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) + Math_fround(f32 * f32));
 f37 = Math_fround(Math_fround(Math_fround(f30 * f22) + Math_fround(f31 * f23)) + Math_fround(f32 * f24));
 f35 = Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f23 * f23)) + Math_fround(f24 * f24));
 f28 = Math_fround(Math_fround(Math_fround(f53 - f9) * f27) + Math_fround(Math_fround(Math_fround(f38 - f15) * f25) + Math_fround(Math_fround(f28 - f21) * f26)));
 f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f36 * f35) - Math_fround(f37 * f37)));
 f53 = Math_fround(f28 * f28);
 f21 = Math_fround(Math_fround(Math_fround(f8 - f9) * f27) + Math_fround(Math_fround(Math_fround(f10 - f15) * f25) + Math_fround(Math_fround(f52 - f21) * f26)));
 f52 = Math_fround(f21 * f21);
 if (Math_fround(f28 * f21) < Math_fround(0.0)) {
  f70 = Math_fround(HEAPF32[i48 >> 2]);
  f9 = Math_fround(HEAPF32[i7 >> 2]);
  f69 = Math_fround(HEAPF32[i11 >> 2]);
  f15 = Math_fround(-Math_fround(f28 * Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f25 * f70) + Math_fround(f26 * f9)) + Math_fround(f27 * f69)))));
  f8 = Math_fround(HEAPF32[i47 >> 2]);
  f5 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f70 = Math_fround(Math_fround(f70 * f15) + f8);
  f9 = Math_fround(Math_fround(f9 * f15) + f5);
  f69 = Math_fround(Math_fround(f69 * f15) + f4);
  f3 = Math_fround(HEAPF32[i42 >> 2]);
  f2 = Math_fround(HEAPF32[i14 >> 2]);
  f1 = Math_fround(HEAPF32[i20 >> 2]);
  f70 = Math_fround(f70 - f3);
  f9 = Math_fround(f9 - f2);
  f69 = Math_fround(f69 - f1);
  f10 = Math_fround(Math_fround(Math_fround(f70 * f30) + Math_fround(f9 * f31)) + Math_fround(f69 * f32));
  f69 = Math_fround(Math_fround(Math_fround(f70 * f22) + Math_fround(f9 * f23)) + Math_fround(f69 * f24));
  f9 = Math_fround(f38 * Math_fround(Math_fround(f35 * f10) - Math_fround(f37 * f69)));
  f10 = Math_fround(f38 * Math_fround(Math_fround(f36 * f69) - Math_fround(f37 * f10)));
  if (f9 >= Math_fround(-1.1920929e-07) & f9 <= Math_fround(1.00000012) & (f10 >= Math_fround(-1.1920929e-07) & f10 <= Math_fround(1.00000012) & Math_fround(f10 + f9) < Math_fround(1.00000012))) {
   HEAPF32[i62 >> 2] = f15;
   i67 = i62 + 4 | 0;
   HEAP32[i67 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAPF32[i64 >> 2] = f9;
   i67 = i64 + 4 | 0;
   HEAP32[i67 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAPF32[i66 >> 2] = f10;
   i67 = i66 + 4 | 0;
   HEAP32[i67 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAPF32[i60 >> 2] = Math_fround(0.0);
   i67 = i60 + 4 | 0;
   HEAP32[i67 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i67 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i67 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   STACKTOP = i68;
   return;
  }
 } else {
  f8 = Math_fround(HEAPF32[i47 >> 2]);
  f5 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f3 = Math_fround(HEAPF32[i42 >> 2]);
  f2 = Math_fround(HEAPF32[i14 >> 2]);
  f1 = Math_fround(HEAPF32[i20 >> 2]);
 }
 f70 = Math_fround(f8 - Math_fround(f25 * f28));
 f5 = Math_fround(f5 - Math_fround(f26 * f28));
 f8 = Math_fround(f4 - Math_fround(f27 * f28));
 f69 = Math_fround(HEAPF32[i34 >> 2]);
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f28 = Math_fround(f70 - f3);
 f5 = Math_fround(f5 - f2);
 f8 = Math_fround(f8 - f1);
 f69 = Math_fround(Math_fround(f69 - Math_fround(f25 * f21)) - f3);
 f9 = Math_fround(Math_fround(f9 - Math_fround(f26 * f21)) - f2);
 f70 = Math_fround(Math_fround(Math_fround(HEAPF32[i33 >> 2]) - Math_fround(f27 * f21)) - f1);
 f10 = Math_fround(Math_fround(Math_fround(f28 * f30) + Math_fround(f5 * f31)) + Math_fround(f8 * f32));
 f8 = Math_fround(Math_fround(Math_fround(f28 * f22) + Math_fround(f5 * f23)) + Math_fround(f8 * f24));
 f5 = Math_fround(Math_fround(Math_fround(f69 * f30) + Math_fround(f9 * f31)) + Math_fround(f70 * f32));
 f70 = Math_fround(Math_fround(Math_fround(f69 * f22) + Math_fround(f9 * f23)) + Math_fround(f70 * f24));
 f9 = Math_fround(f38 * Math_fround(Math_fround(f35 * f10) - Math_fround(f37 * f8)));
 f10 = Math_fround(f38 * Math_fround(Math_fround(f36 * f8) - Math_fround(f37 * f10)));
 f8 = Math_fround(f38 * Math_fround(Math_fround(f35 * f5) - Math_fround(f37 * f70)));
 f5 = Math_fround(f38 * Math_fround(Math_fround(f36 * f70) - Math_fround(f37 * f5)));
 i6 = f9 >= Math_fround(-1.1920929e-07) & f9 <= Math_fround(1.00000012) & (f10 >= Math_fround(-1.1920929e-07) & f10 <= Math_fround(1.00000012) & Math_fround(f9 + f10) < Math_fround(1.00000012));
 i7 = f8 >= Math_fround(-1.1920929e-07) & f8 <= Math_fround(1.00000012) & (f5 >= Math_fround(-1.1920929e-07) & f5 <= Math_fround(1.00000012) & Math_fround(f8 + f5) < Math_fround(1.00000012));
 if (i6 & i7) {
  i67 = f52 > f53;
  HEAPF32[i62 >> 2] = i67 ? Math_fround(0.0) : Math_fround(1.0);
  i65 = i62 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAPF32[i64 >> 2] = i67 ? f9 : f8;
  i65 = i64 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAPF32[i66 >> 2] = i67 ? f10 : f5;
  i66 = i66 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAPF32[i60 >> 2] = i67 ? f53 : f52;
  STACKTOP = i68;
  return;
 }
 __ZN5physx2Gu33pcmDistanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_(i49, i47, i48, i42, i43, i45, i46, i42, i44, i42, i43, i50, i51);
 f69 = Math_fround(HEAPF32[i50 >> 2]);
 f70 = Math_fround(HEAPF32[i50 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i50 + 8 >> 2]);
 f37 = Math_fround(HEAPF32[i51 >> 2]);
 f38 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 f2 = Math_fround(Math_fround(1.0) - f38);
 f35 = Math_fround(HEAPF32[i49 >> 2]);
 f36 = Math_fround(HEAPF32[i49 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i49 + 8 >> 2]);
 i50 = f36 > f35 & f1 > f35;
 i51 = f1 > f36;
 f1 = i50 ? f35 : i51 ? f36 : f1;
 f2 = i51 ? f2 : Math_fround(0.0);
 f2 = i50 ? f37 : f2;
 f3 = i50 ? Math_fround(0.0) : i51 ? f38 : f3;
 f4 = i50 ? f69 : i51 ? f70 : f4;
 if (i6) {
  i67 = f1 > f53;
  HEAPF32[i62 >> 2] = i67 ? Math_fround(0.0) : f4;
  i65 = i62 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAPF32[i64 >> 2] = i67 ? f9 : f2;
  i65 = i64 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i56 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
  HEAPF32[i66 >> 2] = i67 ? f10 : f3;
  i66 = i66 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAPF32[i60 >> 2] = i67 ? f53 : f1;
  STACKTOP = i68;
  return;
 }
 if (i7) {
  i67 = f1 > f52;
  HEAPF32[i62 >> 2] = i67 ? Math_fround(1.0) : f4;
  i65 = i62 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
  HEAPF32[i64 >> 2] = i67 ? f8 : f2;
  i65 = i64 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAPF32[i66 >> 2] = i67 ? f5 : f3;
  i66 = i66 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAPF32[i60 >> 2] = i67 ? f52 : f1;
  STACKTOP = i68;
  return;
 } else {
  HEAPF32[i62 >> 2] = f4;
  i62 = i62 + 4 | 0;
  HEAP32[i62 >> 2] = HEAP32[i63 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
  HEAPF32[i64 >> 2] = f2;
  i64 = i64 + 4 | 0;
  HEAP32[i64 >> 2] = HEAP32[i65 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
  HEAPF32[i66 >> 2] = f3;
  i66 = i66 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i67 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i67 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i67 + 8 >> 2];
  HEAPF32[i60 >> 2] = f1;
  i67 = i60 + 4 | 0;
  HEAP32[i67 >> 2] = HEAP32[i61 >> 2];
  HEAP32[i67 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
  HEAP32[i67 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
  STACKTOP = i68;
  return;
 }
}

function __ZN13AnimationClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 32 | 0;
 i7 = i13 + 16 | 0;
 i4 = i13;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i12);
 i1 = i11 + 212 | 0;
 i9 = i12 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i12 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 }
 i3 = i11 + 92 | 0;
 if ((i1 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i3, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i11 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 if (!(HEAP8[i3 >> 0] | 0)) {
  i3 = i11 + 100 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
  i2 = HEAP32[i11 + 104 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i12);
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i7 >> 2] = 0;
  i3 = i7 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i7, i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i7);
 } else {
  HEAP32[i7 >> 2] = 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i7, i1);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i12);
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i2 | 0));
  if (!(HEAP32[i12 >> 2] & 33554432)) {
   HEAP32[i4 >> 2] = 0;
   i3 = i4 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
    i1 = HEAP32[i8 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i9 >> 2] = i2;
   }
   __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i4, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) do {
    __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
    i1 = i1 + 88 | 0;
   } while ((i1 | 0) != (i2 | 0));
   __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i11, i4);
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i4);
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i8 + 4 | 0;
    do {
     i3 = i2 + -204 | 0;
     HEAP32[i6 >> 2] = i3;
     i4 = i2 + -36 | 0;
     if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
      HEAP32[i4 >> 2] = 0;
     }
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i4 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i2 + -192 >> 2] | 0;
      HEAP32[i8 >> 2] = 66;
      HEAP32[i5 >> 2] = i3;
      __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
     }
     i2 = HEAP32[i6 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i7 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 25;
   HEAP32[i8 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
  }
 }
 i3 = i11 + 116 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 120 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 132 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 136 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 148 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 152 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i12);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 164 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 168 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
  i1 = i1 + 132 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 180 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 184 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
  i1 = i1 + 60 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i11 + 88 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i11 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11 + 272 | 0, i12);
 HEAP32[i12 + 4 >> 2] = i11 + 56;
 __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb0EEEvRPT_PKcRjS9_RT0_(i11 + 216 | 0, gb + 898128 | 0, i11 + 220 | 0, gb + 898141 | 0, i12);
 i3 = i11 + 224 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, i1, i12 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i11 + 236 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i12, i11 + 244 | 0, 0);
 i3 = i11 + 196 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i11 + 200 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu23triBoxSweepTestBoxSpaceERKNS_10PxTriangleERKNS_6PxVec3ES6_S6_fRfb(i52, i7, i8, i23, f53, i54, i1) {
 i52 = i52 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i23 = i23 | 0;
 f53 = Math_fround(f53);
 i54 = i54 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f55 = f0;
 i11 = i52 + 12 | 0;
 f49 = Math_fround(HEAPF32[i11 >> 2]);
 f17 = Math_fround(HEAPF32[i52 >> 2]);
 f49 = Math_fround(f49 - f17);
 i12 = i52 + 16 | 0;
 f51 = Math_fround(HEAPF32[i12 >> 2]);
 i9 = i52 + 4 | 0;
 f50 = Math_fround(HEAPF32[i9 >> 2]);
 f51 = Math_fround(f51 - f50);
 i13 = i52 + 20 | 0;
 f48 = Math_fround(HEAPF32[i13 >> 2]);
 i10 = i52 + 8 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f48 = Math_fround(f48 - f6);
 i14 = i52 + 24 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f17);
 i15 = i52 + 28 | 0;
 f50 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f50);
 i16 = i52 + 32 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f6);
 f2 = Math_fround(Math_fround(f51 * f6) - Math_fround(f48 * f50));
 f6 = Math_fround(Math_fround(f48 * f17) - Math_fround(f49 * f6));
 f17 = Math_fround(Math_fround(f49 * f50) - Math_fround(f51 * f17));
 if (i1) {
  f51 = Math_fround(f2 * Math_fround(HEAPF32[i8 >> 2]));
  i1 = i8 + 4 | 0;
  f51 = Math_fround(f51 + Math_fround(f6 * Math_fround(HEAPF32[i1 >> 2])));
  i4 = i8 + 8 | 0;
  if (Math_fround(f51 + Math_fround(f17 * Math_fround(HEAPF32[i4 >> 2]))) >= Math_fround(0.0)) {
   i54 = 0;
   return i54 | 0;
  }
 } else {
  i1 = i8 + 4 | 0;
  i4 = i8 + 8 | 0;
 }
 HEAPF32[i54 >> 2] = f53;
 f50 = Math_fround(HEAPF32[i7 >> 2]);
 f51 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i8 >> 2]);
 f47 = Math_fround(HEAPF32[i1 >> 2]);
 f46 = Math_fround(HEAPF32[i4 >> 2]);
 f45 = Math_fround(HEAPF32[i52 >> 2]);
 f35 = Math_fround(f2 * f45);
 f44 = Math_fround(HEAPF32[i9 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f6 * f44));
 f43 = Math_fround(HEAPF32[i10 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f17 * f43));
 f42 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(f2 * f42);
 f41 = Math_fround(HEAPF32[i12 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f6 * f41));
 f40 = Math_fround(HEAPF32[i13 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f17 * f40));
 f39 = Math_fround(HEAPF32[i14 >> 2]);
 f5 = Math_fround(f2 * f39);
 f38 = Math_fround(HEAPF32[i15 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f6 * f38));
 f37 = Math_fround(HEAPF32[i16 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f17 * f37));
 f36 = f35 < f3 ? f35 : f3;
 f3 = f35 > f3 ? f35 : f3;
 f35 = Math_fround(Math_fround(Math_fround(f50 * Math_fround(Math_abs(Math_fround(f2)))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f6))))) + Math_fround(f49 * Math_fround(Math_abs(Math_fround(f17)))));
 f3 = Math_fround(Math_fround(-f35) - (f3 > f5 ? f3 : f5));
 f5 = Math_fround(f35 - (f36 < f5 ? f36 : f5));
 i4 = f3 <= Math_fround(0.0) & f5 >= Math_fround(0.0);
 f2 = Math_fround(Math_fround(Math_fround(f2 * f48) + Math_fround(f6 * f47)) + Math_fround(f17 * f46));
 do if (Math_fround(Math_abs(Math_fround(f2))) < Math_fround(9.99999997e-07)) if (i4) {
  f3 = Math_fround(3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  i54 = 0;
  return i54 | 0;
 } else {
  f2 = Math_fround(Math_fround(-1.0) / f2);
  f36 = Math_fround(f3 * f2);
  f2 = Math_fround(f5 * f2);
  f5 = f36 < f2 ? f36 : f2;
  f2 = f36 > f2 ? f36 : f2;
  if (f5 > Math_fround(3402823469999999843913219.0e14) | f2 < Math_fround(-3402823469999999843913219.0e14)) {
   i54 = 0;
   return i54 | 0;
  } else {
   i16 = f2 < Math_fround(3402823469999999843913219.0e14);
   f3 = i16 ? f2 : Math_fround(3402823469999999843913219.0e14);
   i16 = f5 > Math_fround(-3402823469999999843913219.0e14);
   f2 = i16 ? f5 : Math_fround(-3402823469999999843913219.0e14);
   break;
  }
 } while (0);
 f6 = f45 < f42 ? f45 : f42;
 f5 = f45 > f42 ? f45 : f42;
 f5 = Math_fround(Math_fround(-f50) - (f5 > f39 ? f5 : f39));
 f6 = Math_fround(f50 - (f6 < f39 ? f6 : f39));
 i1 = f5 <= Math_fround(0.0) & f6 >= Math_fround(0.0);
 i4 = i1 & i4;
 do if (Math_fround(Math_abs(Math_fround(f48))) < Math_fround(9.99999997e-07)) {
  if (!i1) {
   i54 = 0;
   return i54 | 0;
  }
 } else {
  f35 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
  f36 = Math_fround(f5 * f35);
  f5 = Math_fround(f6 * f35);
  f6 = f36 < f5 ? f36 : f5;
  f5 = f36 > f5 ? f36 : f5;
  if (f6 > f3 | f5 < f2) {
   i54 = 0;
   return i54 | 0;
  } else {
   f3 = f5 < f3 ? f5 : f3;
   f2 = f6 > f2 ? f6 : f2;
   break;
  }
 } while (0);
 f6 = f44 < f41 ? f44 : f41;
 f5 = f44 > f41 ? f44 : f41;
 f5 = Math_fround(Math_fround(-f51) - (f5 > f38 ? f5 : f38));
 f6 = Math_fround(f51 - (f6 < f38 ? f6 : f38));
 i1 = f5 <= Math_fround(0.0) & f6 >= Math_fround(0.0);
 i7 = i1 & i4;
 do if (Math_fround(Math_abs(Math_fround(f47))) < Math_fround(9.99999997e-07)) {
  if (!i1) {
   i54 = 0;
   return i54 | 0;
  }
 } else {
  f35 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
  f36 = Math_fround(f5 * f35);
  f5 = Math_fround(f6 * f35);
  f6 = f36 < f5 ? f36 : f5;
  f5 = f36 > f5 ? f36 : f5;
  if (f6 > f3 | f5 < f2) {
   i54 = 0;
   return i54 | 0;
  } else {
   f3 = f5 < f3 ? f5 : f3;
   f2 = f6 > f2 ? f6 : f2;
   break;
  }
 } while (0);
 f6 = f43 < f40 ? f43 : f40;
 f5 = f43 > f40 ? f43 : f40;
 f5 = Math_fround(Math_fround(-f49) - (f5 > f37 ? f5 : f37));
 f6 = Math_fround(f49 - (f6 < f37 ? f6 : f37));
 i4 = f5 <= Math_fround(0.0) & f6 >= Math_fround(0.0);
 i1 = i4 & i7 & 1;
 do if (Math_fround(Math_abs(Math_fround(f46))) < Math_fround(9.99999997e-07)) {
  if (!i4) {
   i54 = 0;
   return i54 | 0;
  }
 } else {
  f35 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
  f36 = Math_fround(f5 * f35);
  f6 = Math_fround(f6 * f35);
  f5 = f36 < f6 ? f36 : f6;
  f6 = f36 > f6 ? f36 : f6;
  if (f5 > f3 | f6 < f2) {
   i54 = 0;
   return i54 | 0;
  } else {
   f2 = f5 > f2 ? f5 : f2;
   f3 = f6 < f3 ? f6 : f3;
   break;
  }
 } while (0);
 f25 = Math_fround(f43 * Math_fround(0.0));
 f26 = Math_fround(f40 * Math_fround(0.0));
 f27 = Math_fround(f37 * Math_fround(0.0));
 f28 = Math_fround(f46 * Math_fround(0.0));
 f29 = Math_fround(f44 * Math_fround(0.0));
 f30 = Math_fround(f41 * Math_fround(0.0));
 f31 = Math_fround(f38 * Math_fround(0.0));
 f32 = Math_fround(f47 * Math_fround(0.0));
 f33 = Math_fround(f45 * Math_fround(0.0));
 f34 = Math_fround(f42 * Math_fround(0.0));
 f35 = Math_fround(f39 * Math_fround(0.0));
 f36 = Math_fround(f48 * Math_fround(0.0));
 f5 = f45;
 f6 = f44;
 f17 = f43;
 i4 = 0;
 L38 : while (1) {
  i7 = i4 + 1 | 0;
  i23 = i4 >>> 0 > 1 ? 0 : i7;
  f24 = Math_fround(Math_fround(HEAPF32[i52 + (i23 * 12 | 0) >> 2]) - f5);
  f21 = Math_fround(Math_fround(HEAPF32[i52 + (i23 * 12 | 0) + 4 >> 2]) - f6);
  f20 = Math_fround(Math_fround(HEAPF32[i52 + (i23 * 12 | 0) + 8 >> 2]) - f17);
  f5 = Math_fround(-f20);
  f18 = Math_fround(Math_fround(f20 * f20) + Math_fround(0.0));
  f22 = Math_fround(f21 * f21);
  do if (Math_fround(f22 + f18) >= Math_fround(9.99999997e-07)) {
   f55 = Math_fround(Math_fround(f43 * f21) + Math_fround(f33 + Math_fround(f44 * f5)));
   f6 = Math_fround(Math_fround(f40 * f21) + Math_fround(f34 + Math_fround(f41 * f5)));
   f17 = Math_fround(Math_fround(f37 * f21) + Math_fround(f35 + Math_fround(f38 * f5)));
   f19 = f55 < f6 ? f55 : f6;
   f6 = f55 > f6 ? f55 : f6;
   f55 = Math_fround(Math_fround(Math_fround(f50 * Math_fround(Math_abs(Math_fround(0.0)))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f5))))) + Math_fround(f49 * Math_fround(Math_abs(Math_fround(f21)))));
   f6 = Math_fround(Math_fround(-f55) - (f6 > f17 ? f6 : f17));
   f17 = Math_fround(f55 - (f19 < f17 ? f19 : f17));
   i4 = f6 <= Math_fround(0.0) & f17 >= Math_fround(0.0);
   i1 = i4 & 1 & (i1 & 255) & 255;
   f5 = Math_fround(Math_fround(f46 * f21) + Math_fround(f36 + Math_fround(f47 * f5)));
   if (Math_fround(Math_abs(Math_fround(f5))) < Math_fround(9.99999997e-07)) if (i4) break; else {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f5 = Math_fround(Math_fround(-1.0) / f5);
   f55 = Math_fround(f6 * f5);
   f5 = Math_fround(f17 * f5);
   f6 = f55 < f5 ? f55 : f5;
   f5 = f55 > f5 ? f55 : f5;
   if (f6 > f3 | f5 < f2) {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f3 = f5 < f3 ? f5 : f3;
   f2 = f6 > f2 ? f6 : f2;
  } while (0);
  f5 = Math_fround(-f24);
  f19 = Math_fround(f24 * f24);
  do if (Math_fround(f19 + f18) >= Math_fround(9.99999997e-07)) {
   f18 = Math_fround(Math_fround(f43 * f5) + Math_fround(f29 + Math_fround(f45 * f20)));
   f6 = Math_fround(Math_fround(f40 * f5) + Math_fround(f30 + Math_fround(f42 * f20)));
   f17 = Math_fround(Math_fround(f37 * f5) + Math_fround(f31 + Math_fround(f39 * f20)));
   f55 = f18 < f6 ? f18 : f6;
   f6 = f18 > f6 ? f18 : f6;
   f18 = Math_fround(Math_fround(Math_fround(f50 * Math_fround(Math_abs(Math_fround(f20)))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(0.0))))) + Math_fround(f49 * Math_fround(Math_abs(Math_fround(f5)))));
   f6 = Math_fround(Math_fround(-f18) - (f6 > f17 ? f6 : f17));
   f17 = Math_fround(f18 - (f55 < f17 ? f55 : f17));
   i4 = f6 <= Math_fround(0.0) & f17 >= Math_fround(0.0);
   i1 = i4 & 1 & (i1 & 255) & 255;
   f5 = Math_fround(Math_fround(f46 * f5) + Math_fround(f32 + Math_fround(f48 * f20)));
   if (Math_fround(Math_abs(Math_fround(f5))) < Math_fround(9.99999997e-07)) if (i4) break; else {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f5 = Math_fround(Math_fround(-1.0) / f5);
   f55 = Math_fround(f6 * f5);
   f5 = Math_fround(f17 * f5);
   f6 = f55 < f5 ? f55 : f5;
   f5 = f55 > f5 ? f55 : f5;
   if (f6 > f3 | f5 < f2) {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f3 = f5 < f3 ? f5 : f3;
   f2 = f6 > f2 ? f6 : f2;
  } while (0);
  f5 = Math_fround(-f21);
  do if (Math_fround(Math_fround(f19 + f22) + Math_fround(0.0)) >= Math_fround(9.99999997e-07)) {
   f22 = Math_fround(f25 + Math_fround(Math_fround(f44 * f24) + Math_fround(f45 * f5)));
   f6 = Math_fround(f26 + Math_fround(Math_fround(f41 * f24) + Math_fround(f42 * f5)));
   f17 = Math_fround(f27 + Math_fround(Math_fround(f38 * f24) + Math_fround(f39 * f5)));
   f55 = f22 < f6 ? f22 : f6;
   f6 = f22 > f6 ? f22 : f6;
   f22 = Math_fround(Math_fround(Math_fround(f50 * Math_fround(Math_abs(Math_fround(f5)))) + Math_fround(f51 * Math_fround(Math_abs(Math_fround(f24))))) + Math_fround(f49 * Math_fround(Math_abs(Math_fround(0.0)))));
   f6 = Math_fround(Math_fround(-f22) - (f6 > f17 ? f6 : f17));
   f17 = Math_fround(f22 - (f55 < f17 ? f55 : f17));
   i4 = f6 <= Math_fround(0.0) & f17 >= Math_fround(0.0);
   i1 = i4 & 1 & (i1 & 255) & 255;
   f5 = Math_fround(f28 + Math_fround(Math_fround(f47 * f24) + Math_fround(f48 * f5)));
   if (Math_fround(Math_abs(Math_fround(f5))) < Math_fround(9.99999997e-07)) if (i4) break; else {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f5 = Math_fround(Math_fround(-1.0) / f5);
   f55 = Math_fround(f6 * f5);
   f6 = Math_fround(f17 * f5);
   f5 = f55 < f6 ? f55 : f6;
   f6 = f55 > f6 ? f55 : f6;
   if (f5 > f3 | f6 < f2) {
    i1 = 0;
    i4 = 42;
    break L38;
   }
   f2 = f5 > f2 ? f5 : f2;
   f3 = f6 < f3 ? f6 : f3;
  } while (0);
  if (i7 >>> 0 >= 3) {
   i4 = 38;
   break;
  }
  f5 = Math_fround(HEAPF32[i52 + (i7 * 12 | 0) >> 2]);
  f6 = Math_fround(HEAPF32[i52 + (i7 * 12 | 0) + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i52 + (i7 * 12 | 0) + 8 >> 2]);
  i4 = i7;
 }
 if ((i4 | 0) == 38) {
  if (f2 > f53 | f3 < Math_fround(0.0)) {
   i54 = 0;
   return i54 | 0;
  }
  if (f2 <= Math_fround(0.0)) if (!(i1 << 24 >> 24)) {
   i54 = 0;
   return i54 | 0;
  } else f2 = Math_fround(0.0);
  HEAPF32[i54 >> 2] = f2;
  i54 = 1;
  return i54 | 0;
 } else if ((i4 | 0) == 42) return i1 | 0;
 return 0;
}

function _cff_slot_load(i33, i26, i2, i3) {
 i33 = i33 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34 + 40 | 0;
 i28 = i34 + 24 | 0;
 i32 = i34 + 8 | 0;
 i23 = i34;
 i24 = i34 + 780 | 0;
 i22 = HEAP32[i33 + 4 >> 2] | 0;
 i17 = i22 + 656 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 if ((HEAP32[i18 + 1456 >> 2] | 0) == 65535) i31 = 5; else {
  i1 = i18 + 1152 | 0;
  if (!(HEAP32[i18 + 1164 >> 2] | 0)) i31 = 5; else if (!i2) i2 = 0; else {
   i1 = _cff_charset_cid_to_gindex(i1, i2) | 0;
   if (!i1) {
    i33 = 6;
    STACKTOP = i34;
    return i33 | 0;
   } else i2 = i1;
  }
 }
 if ((i31 | 0) == 5) if ((HEAP32[i18 + 12 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i33 = 6;
  STACKTOP = i34;
  return i33 | 0;
 }
 i29 = (i3 & 1024 | 0) == 0 ? i3 : i3 | 3;
 i25 = i33 + 164 | 0;
 HEAP32[i25 >> 2] = 65536;
 i27 = i33 + 168 | 0;
 HEAP32[i27 >> 2] = 65536;
 i21 = (i26 | 0) != 0;
 do if (i21) {
  HEAP32[i25 >> 2] = HEAP32[i26 + 16 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i26 + 20 >> 2];
  i3 = HEAP32[i26 >> 2] | 0;
  i1 = HEAP32[i3 + 532 >> 2] | 0;
  i3 = HEAP32[i3 + 104 >> 2] | 0;
  i4 = HEAP32[i26 + 44 >> 2] | 0;
  if ((i4 | 0) != -1) if ((i29 & 8 | 0) == 0 & (HEAP32[i1 + 96 >> 2] | 0) != 0) {
   if (mftCall_iiiiiiii(HEAP32[i1 + 72 >> 2] | 0, i22 | 0, i4 | 0, i2 | 0, i29 | 0, i3 | 0, i33 + 76 | 0, i32 | 0) | 0) break;
   HEAP16[i33 + 110 >> 1] = 0;
   HEAP16[i33 + 108 >> 1] = 0;
   HEAP32[i33 + 24 >> 2] = HEAPU16[i32 + 2 >> 1] << 6;
   HEAP32[i33 + 28 >> 2] = HEAPU16[i32 >> 1] << 6;
   i27 = HEAP16[i32 + 4 >> 1] | 0;
   HEAP32[i33 + 32 >> 2] = i27 << 6;
   i30 = HEAP16[i32 + 6 >> 1] | 0;
   HEAP32[i33 + 36 >> 2] = i30 << 6;
   HEAP32[i33 + 40 >> 2] = HEAPU16[i32 + 8 >> 1] << 6;
   i28 = HEAP16[i32 + 10 >> 1] | 0;
   HEAP32[i33 + 44 >> 2] = i28 << 6;
   i1 = HEAP16[i32 + 12 >> 1] | 0;
   HEAP32[i33 + 48 >> 2] = i1 << 6;
   HEAP32[i33 + 52 >> 2] = HEAPU16[i32 + 14 >> 1] << 6;
   HEAP32[i33 + 72 >> 2] = 1651078259;
   i32 = (i29 & 16 | 0) == 0;
   HEAP32[i33 + 100 >> 2] = i32 ? i27 : i28;
   HEAP32[i33 + 104 >> 2] = i32 ? i30 : i1;
   i1 = i22 + 532 | 0;
   mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i22 | 0, 0, i2 | 0, i24 | 0, i23 | 0);
   HEAP32[i33 + 56 >> 2] = HEAPU16[i23 >> 1];
   if (!(HEAP8[i22 + 292 >> 0] | 0)) i31 = 14; else if (!(HEAP16[i22 + 330 >> 1] | 0)) i31 = 14; else {
    mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i22 | 0, 1, i2 | 0, i24 | 0, i23 | 0);
    HEAP32[i33 + 60 >> 2] = HEAPU16[i23 >> 1];
   }
   do if ((i31 | 0) == 14) if ((HEAP16[i22 + 364 >> 1] | 0) == -1) {
    i32 = HEAP32[i22 + 220 >> 2] | 0;
    HEAP32[i33 + 60 >> 2] = (i32 << 16 >> 16) - (i32 >> 16);
    break;
   } else {
    HEAP32[i33 + 60 >> 2] = (HEAP16[i22 + 434 >> 1] | 0) - (HEAP16[i22 + 436 >> 1] | 0);
    break;
   } while (0);
   i33 = 0;
   STACKTOP = i34;
   return i33 | 0;
  }
 } while (0);
 if (i29 & 16384 | 0) {
  i33 = 6;
  STACKTOP = i34;
  return i33 | 0;
 }
 i1 = i18 + 1896 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i13 = i18 + 1372 | 0;
  HEAP32[i28 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  i13 = 0;
  i4 = HEAP32[i18 + 1396 >> 2] | 0;
  i5 = HEAP32[i18 + 1400 >> 2] | 0;
 } else {
  i3 = _cff_fd_select_get(i18 + 2924 | 0, i2) | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i18 + 1392 >> 2] | 0;
  i5 = HEAP32[i18 + 1900 + ((((i3 & 255) >>> 0 < i5 >>> 0 ? i3 : i5 + 255 & 255) & 255) << 2) >> 2] | 0;
  i3 = HEAP32[i5 + 68 >> 2] | 0;
  i4 = i5 + 48 | 0;
  HEAP32[i28 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i4 = HEAP32[i5 + 72 >> 2] | 0;
  i5 = HEAP32[i5 + 76 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i13 = 0; else {
   HEAP32[i25 >> 2] = _UNITY_FT_MulDiv(HEAP32[i25 >> 2] | 0, i1, i3) | 0;
   HEAP32[i27 >> 2] = _UNITY_FT_MulDiv(HEAP32[i27 >> 2] | 0, i1, i3) | 0;
   i13 = 1;
  }
 }
 i20 = i33 + 108 | 0;
 i19 = i33 + 110 | 0;
 HEAP16[i19 >> 1] = 0;
 HEAP16[i20 >> 1] = 0;
 i12 = (i29 >>> 1 & 1 ^ 1) & 255;
 i15 = i29 & 1;
 i16 = (i15 | 0) != 0;
 i11 = i33 + 160 | 0;
 HEAP8[i11 >> 0] = i12;
 HEAP8[i33 + 161 >> 0] = i15 ^ 1;
 i15 = i33 + 72 | 0;
 HEAP32[i15 >> 2] = 1869968492;
 i8 = i29 >>> 16 & 15;
 i7 = HEAP32[i17 >> 2] | 0;
 i9 = i30 + 4 | 0;
 _memset(i9 + 8 | 0, 0, 728) | 0;
 HEAP8[i30 + 65 >> 0] = 1;
 HEAP32[i9 >> 2] = i22;
 i14 = i30 + 8 | 0;
 HEAP32[i14 >> 2] = i33;
 HEAP32[i30 >> 2] = HEAP32[i22 + 100 >> 2];
 if (i33 | 0) {
  i1 = i33 + 156 | 0;
  i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  HEAP32[i30 + 12 >> 2] = i3;
  HEAP32[i30 + 16 >> 2] = i3 + 20;
  HEAP32[i30 + 20 >> 2] = i3 + 56;
  _UNITY_FT_GlyphLoader_Rewind(i3);
  i3 = i30 + 72 | 0;
  HEAP32[i3 >> 2] = 0;
  i6 = i30 + 68 | 0;
  HEAP32[i6 >> 2] = 0;
  if (i21 & i12 << 24 >> 24 != 0) {
   HEAP32[i3 >> 2] = HEAP32[HEAP32[i26 + 40 >> 2] >> 2];
   HEAP32[i6 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2];
  }
 }
 i10 = i30 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 i10 = i30 + 76 | 0;
 HEAP32[i10 >> 2] = i7;
 i1 = HEAP32[i7 + 92 >> 2] | 0;
 HEAP32[i30 + 700 >> 2] = i1;
 HEAP32[i30 + 716 >> 2] = HEAP32[i7 + 1308 >> 2];
 if ((HEAP32[i7 + 1368 >> 2] | 0) == 1) i1 = 0; else if (i1 >>> 0 < 1240) i1 = 107; else i1 = i1 >>> 0 < 33900 ? 1131 : 32768;
 HEAP32[i30 + 708 >> 2] = i1;
 HEAP32[i30 + 728 >> 2] = i8;
 if (i29 & 256 | 0) HEAP8[i30 + 561 >> 0] = 1;
 i7 = i29 & 1024;
 HEAP8[i30 + 66 >> 0] = 0;
 i1 = _cff_index_access_element((HEAP32[i17 >> 2] | 0) + 1176 | 0, i2, i32, i23) | 0;
 do if (!i1) {
  i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + 656 >> 2] | 0;
  i3 = i1 + 1896 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i3 = i1 + 1324 | 0; else {
   i6 = (_cff_fd_select_get(i1 + 2924 | 0, i2) | 0) & 255;
   if (i6 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
    i1 = 3;
    break;
   }
   i1 = HEAP32[i1 + 1900 + (i6 << 2) >> 2] | 0;
   if (i21 & (HEAP32[i30 + 68 >> 2] | 0) != 0) {
    HEAP32[i30 + 72 >> 2] = HEAP32[(HEAP32[i26 + 40 >> 2] | 0) + 4 + (i6 << 2) >> 2];
    i3 = i1;
   } else i3 = i1;
  }
  i1 = HEAP32[i3 + 544 >> 2] | 0;
  HEAP32[i30 + 696 >> 2] = i1;
  HEAP32[i30 + 712 >> 2] = HEAP32[i3 + 568 >> 2];
  if ((HEAP32[(HEAP32[i10 >> 2] | 0) + 1368 >> 2] | 0) == 1) i1 = 0; else if (i1 >>> 0 < 1240) i1 = 107; else i1 = i1 >>> 0 < 33900 ? 1131 : 32768;
  HEAP32[i30 + 704 >> 2] = i1;
  i6 = i30 + 552 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 + 528 >> 2];
  HEAP32[i30 + 556 >> 2] = HEAP32[i3 + 532 >> 2];
  HEAP32[i30 + 736 >> 2] = i3;
  i1 = _cf2_decoder_parse_charstrings(i30, HEAP32[i32 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
  if ((i1 & 255 | 0) == 164) {
   HEAP8[i11 >> 0] = 0;
   i1 = _cf2_decoder_parse_charstrings(i30, HEAP32[i32 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
   i10 = 0;
   i3 = 1;
  } else {
   i10 = i12;
   i3 = i13;
  }
  _cff_index_forget_element((HEAP32[i17 >> 2] | 0) + 1176 | 0, i32);
  if (!i1) {
   i1 = HEAP32[i18 + 1200 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i33 + 136 >> 2] = (HEAP32[i18 + 1204 >> 2] | 0) + (HEAP32[i1 + (i2 << 2) >> 2] | 0) + -1;
    HEAP32[i33 + 140 >> 2] = HEAP32[i23 >> 2];
   }
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) {
    i18 = i1 + 108 | 0;
    i17 = HEAP32[i30 + 16 >> 2] | 0;
    HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
    HEAP32[i18 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   }
   if (i7 | 0) {
    i32 = HEAP32[i33 + 156 >> 2] | 0;
    HEAP32[i33 + 32 >> 2] = HEAP32[i30 + 32 >> 2];
    HEAP32[i33 + 40 >> 2] = HEAP32[i6 >> 2];
    i33 = i32 + 12 | 0;
    HEAP32[i33 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i33 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
    HEAP32[i33 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
    HEAP32[i33 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
    HEAP32[i32 + 28 >> 2] = i4;
    HEAP32[i32 + 32 >> 2] = i5;
    HEAP8[i32 + 8 >> 0] = 1;
    i33 = 0;
    STACKTOP = i34;
    return i33 | 0;
   }
   i9 = i33 + 24 | 0;
   if (!(HEAP16[i22 + 250 >> 1] | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
    HEAP16[i23 >> 1] = 0;
    HEAP16[i24 >> 1] = 0;
    mftCall_viiiii(HEAP32[(HEAP32[i22 + 532 >> 2] | 0) + 112 >> 2] | 0, i22 | 0, 0, i2 | 0, i23 | 0, i24 | 0);
    i1 = HEAPU16[i24 >> 1] | 0;
    HEAP32[i33 + 32 >> 2] = HEAP16[i23 >> 1];
   }
   i8 = i33 + 40 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i33 + 56 >> 2] = i1;
   HEAP8[(HEAP32[i33 + 156 >> 2] | 0) + 8 >> 0] = 0;
   if (!(HEAP8[i22 + 292 >> 0] | 0)) i31 = 54; else if (!(HEAP16[i22 + 330 >> 1] | 0)) i31 = 54; else {
    HEAP16[i23 >> 1] = 0;
    HEAP16[i24 >> 1] = 0;
    mftCall_viiiii(HEAP32[(HEAP32[i22 + 532 >> 2] | 0) + 112 >> 2] | 0, i22 | 0, 1, i2 | 0, i23 | 0, i24 | 0);
    HEAP32[i33 + 48 >> 2] = HEAP16[i23 >> 1];
    i1 = HEAPU16[i24 >> 1] | 0;
    i6 = i33 + 52 | 0;
    HEAP32[i6 >> 2] = i1;
    i7 = 1;
   }
   do if ((i31 | 0) == 54) if ((HEAP16[i22 + 364 >> 1] | 0) == -1) {
    i1 = HEAP32[i22 + 220 >> 2] | 0;
    i1 = (i1 << 16 >> 16) - (i1 >> 16) | 0;
    i6 = i33 + 52 | 0;
    HEAP32[i6 >> 2] = i1;
    i7 = 0;
    break;
   } else {
    i1 = (HEAP16[i22 + 434 >> 1] | 0) - (HEAP16[i22 + 436 >> 1] | 0) | 0;
    i6 = i33 + 52 | 0;
    HEAP32[i6 >> 2] = i1;
    i7 = 0;
    break;
   } while (0);
   HEAP32[i33 + 60 >> 2] = i1;
   HEAP32[i15 >> 2] = 1869968492;
   i2 = i33 + 124 | 0;
   HEAP32[i2 >> 2] = 0;
   do if (i21) {
    if ((HEAPU16[i26 + 14 >> 1] | 0) >= 24) {
     i1 = 4;
     break;
    }
    HEAP32[i2 >> 2] = 256;
    i1 = 260;
   } else i1 = 4; while (0);
   HEAP32[i2 >> 2] = i1;
   i1 = i28 + 12 | 0;
   do if ((HEAP32[i28 >> 2] | 0) == 65536 & (HEAP32[i1 >> 2] | 0) == 65536) {
    if (HEAP32[i28 + 4 >> 2] | 0) {
     i31 = 63;
     break;
    }
    if (HEAP32[i28 + 8 >> 2] | 0) i31 = 63;
   } else i31 = 63; while (0);
   if ((i31 | 0) == 63) {
    _UNITY_FT_Outline_Transform(i20, i28);
    HEAP32[i8 >> 2] = _UNITY_FT_MulFix(HEAP32[i8 >> 2] | 0, HEAP32[i28 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = _UNITY_FT_MulFix(HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   }
   if (i5 | i4 | 0) {
    _UNITY_FT_Outline_Translate(i20, i4, i5);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i4;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
   }
   if (!(i16 & i3 << 24 >> 24 == 0)) {
    i2 = HEAP32[i33 + 112 >> 2] | 0;
    i4 = HEAP32[i25 >> 2] | 0;
    i3 = HEAP32[i27 >> 2] | 0;
    if (!(i10 << 24 >> 24)) i31 = 69; else if (!(HEAP32[i30 + 68 >> 2] | 0)) i31 = 69;
    do if ((i31 | 0) == 69) {
     i1 = HEAP16[i19 >> 1] | 0;
     if (i1 << 16 >> 16 <= 0) break;
     i1 = i1 << 16 >> 16;
     while (1) {
      HEAP32[i2 >> 2] = _UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i4) | 0;
      i31 = i2 + 4 | 0;
      HEAP32[i31 >> 2] = _UNITY_FT_MulFix(HEAP32[i31 >> 2] | 0, i3) | 0;
      if ((i1 | 0) > 1) {
       i2 = i2 + 8 | 0;
       i1 = i1 + -1 | 0;
      } else break;
     }
    } while (0);
    HEAP32[i8 >> 2] = _UNITY_FT_MulFix(HEAP32[i8 >> 2] | 0, i4) | 0;
    HEAP32[i6 >> 2] = _UNITY_FT_MulFix(HEAP32[i6 >> 2] | 0, i3) | 0;
   }
   _UNITY_FT_Outline_Get_CBox(i20, i32);
   i1 = HEAP32[i32 >> 2] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i32 + 8 >> 2] | 0) - i1;
   i31 = HEAP32[i32 + 12 >> 2] | 0;
   HEAP32[i33 + 28 >> 2] = i31 - (HEAP32[i32 + 4 >> 2] | 0);
   HEAP32[i33 + 32 >> 2] = i1;
   HEAP32[i33 + 36 >> 2] = i31;
   do if (i7) HEAP32[i33 + 44 >> 2] = i1 - ((HEAP32[i8 >> 2] | 0) / 2 | 0); else {
    if (!(i29 & 16)) break;
    _UNITY_ft_synthesize_vertical_metrics(i9, HEAP32[i6 >> 2] | 0);
   } while (0);
   i33 = 0;
   STACKTOP = i34;
   return i33 | 0;
  }
 } while (0);
 i33 = i1;
 STACKTOP = i34;
 return i33 | 0;
}

function __ZL10SweepEventP14TESStesselatorP10TESSvertex(i22, i20) {
 i22 = i22 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23;
 i17 = i22 + 72 | 0;
 HEAP32[i17 >> 2] = i20;
 i12 = i20 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = i2;
 do {
  i6 = HEAP32[i1 + 24 >> 2] | 0;
  if (i6 | 0) {
   i21 = 58;
   break;
  }
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((i21 | 0) == 58) {
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
  do {
   i6 = HEAP32[HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((HEAP32[i2 + 16 >> 2] | 0) == (i1 | 0));
  i4 = i6 + 24 | 0;
  if (!(HEAP32[i4 >> 2] | 0)) i7 = i6; else {
   i5 = i6 + 4 | 0;
   i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i22 >> 2] | 0, HEAP32[(HEAP32[HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] >> 2] >> 2] | 0) + 4 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
   if (!i1) {
    i20 = i22 + 144 | 0;
    _longjmp(i20 | 0, 1);
   }
   if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i22 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0)) {
    i20 = i22 + 144 | 0;
    _longjmp(i20 | 0, 1);
   }
   HEAP32[i4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i1 + 24 >> 2] = i6;
   i1 = HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] >> 2] | 0;
   if (!i1) {
    i20 = i22 + 144 | 0;
    _longjmp(i20 | 0, 1);
   } else i7 = i1;
  }
  i1 = i7 + 4 | 0;
  i14 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] >> 2] | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i14 = __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i22, i14, 0) | 0;
  i16 = i14 + 8 | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  if ((i2 | 0) != (i5 | 0)) {
   __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i22, i7, i2, i5, i5, 1);
   STACKTOP = i23;
   return;
  }
  i12 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i15 = i10 + 4 | 0;
  if ((HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 16 >> 2] | 0) != (HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0)) __ZL17CheckForIntersectP14TESStesselatorP12ActiveRegion(i22, i7) | 0;
  i13 = i1 + 16 | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  i4 = HEAP32[i17 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  if (f11 == f3) {
   f11 = Math_fround(HEAPF32[i2 + 28 >> 2]);
   if (f11 == Math_fround(HEAPF32[i4 + 28 >> 2])) {
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i22 >> 2] | 0, HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 12 >> 2] | 0, i1) | 0)) _longjmp(i22 + 144 | 0, 1);
    i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
    do {
     i7 = HEAP32[HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
     i4 = HEAP32[i7 >> 2] | 0;
    } while ((HEAP32[i4 + 16 >> 2] | 0) == (i2 | 0));
    i5 = i7 + 24 | 0;
    if (!(HEAP32[i5 >> 2] | 0)) i18 = i7; else {
     i6 = i7 + 4 | 0;
     i2 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i22 >> 2] | 0, HEAP32[(HEAP32[HEAP32[HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] >> 2] >> 2] | 0) + 4 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0) | 0;
     if (!i2) {
      i20 = i22 + 144 | 0;
      _longjmp(i20 | 0, 1);
     }
     if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i22 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0)) {
      i20 = i22 + 144 | 0;
      _longjmp(i20 | 0, 1);
     }
     HEAP32[i5 >> 2] = 0;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i2 + 24 >> 2] = i7;
     i2 = HEAP32[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] >> 2] | 0;
     if (!i2) {
      i20 = i22 + 144 | 0;
      _longjmp(i20 | 0, 1);
     } else i18 = i2;
    }
    i2 = HEAP32[HEAP32[(HEAP32[i18 + 4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i22, i2, i12) | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i6 = 1;
    i7 = i18;
    f3 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   } else {
    i6 = 0;
    i2 = i4;
   }
  } else {
   i6 = 0;
   i2 = i4;
  }
  i4 = HEAP32[i10 + 16 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  do if (f8 == f3) {
   f11 = Math_fround(HEAPF32[i4 + 28 >> 2]);
   if (f11 == Math_fround(HEAPF32[i2 + 28 >> 2])) if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i22 >> 2] | 0, i14, HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0) | 0)) _longjmp(i22 + 144 | 0, 1); else {
    i19 = __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i22, i12, 0) | 0;
    break;
   } else i21 = 85;
  } else i21 = 85; while (0);
  if ((i21 | 0) == 85) if (!i6) {
   i2 = HEAP32[i13 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   if (f8 < f3) i21 = 90; else if (f8 == f3) {
    f11 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    if (f11 <= Math_fround(HEAPF32[i2 + 28 >> 2])) i21 = 90;
   }
   if ((i21 | 0) == 90) i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0;
   i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i22 >> 2] | 0, HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0, i1) | 0;
   if (!i1) _longjmp(i22 + 144 | 0, 1);
   i21 = HEAP32[i1 + 8 >> 2] | 0;
   __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i22, i7, i1, i21, i21, 0);
   HEAP32[(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 24 >> 2] | 0) + 24 >> 2] = 1;
   __ZL16WalkDirtyRegionsP14TESStesselatorP12ActiveRegion(i22, i7);
   STACKTOP = i23;
   return;
  } else i19 = i14;
  __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i22, i7, HEAP32[i19 + 8 >> 2] | 0, i5, i5, 1);
  STACKTOP = i23;
  return;
 }
 HEAP32[i10 >> 2] = HEAP32[i2 + 4 >> 2];
 i13 = i22 + 64 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i1 = i4 + 20 | 0;
 i2 = i4 + 12 | 0;
 while (1) {
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (!i5) {
   i21 = 6;
   break;
  }
  if (mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i10 | 0, i5 | 0) | 0) {
   i21 = 8;
   break;
  }
 }
 if ((i21 | 0) != 6) if ((i21 | 0) == 8) i5 = HEAP32[i4 >> 2] | 0;
 i10 = i5 + 4 | 0;
 i2 = HEAP32[HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] >> 2] | 0;
 do if (i2 | 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 16 >> 2] | 0;
  i4 = HEAP32[i7 + 16 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i20 + 24 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f3 = Math_fround(f8 - f11);
  f8 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) - f8);
  if (Math_fround(f3 + f8) > Math_fround(0.0)) {
   f24 = Math_fround(HEAPF32[i20 + 28 >> 2]);
   f3 = Math_fround(f3 * Math_fround(f24 - Math_fround(HEAPF32[i4 + 28 >> 2])));
   f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (!(Math_fround(f3 + Math_fround(f8 * Math_fround(f24 - f9))) == Math_fround(0.0))) {
    i4 = HEAP32[i6 + 4 >> 2] | 0;
    i1 = HEAP32[i4 + 16 >> 2] | 0;
    f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
    do if (f3 < f11) i2 = i5; else if (f3 == f11) if (Math_fround(HEAPF32[i1 + 28 >> 2]) <= f9) {
     i2 = i5;
     break;
    } while (0);
    if (!(HEAP32[i5 + 12 >> 2] | 0)) if (!(HEAP32[i2 + 24 >> 2] | 0)) {
     i21 = HEAP32[i12 >> 2] | 0;
     __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i22, i5, i21, i21, 0, 1);
     break;
    }
    i1 = HEAP32[i22 >> 2] | 0;
    do if ((i2 | 0) == (i5 | 0)) {
     i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i1, HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0) | 0;
     if (!i1) _longjmp(i22 + 144 | 0, 1); else i14 = i1;
    } else {
     i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i1, HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
     if (!i1) _longjmp(i22 + 144 | 0, 1); else {
      i14 = HEAP32[i1 + 4 >> 2] | 0;
      break;
     }
    } while (0);
    i1 = i2 + 24 | 0;
    do if (!(HEAP32[i1 >> 2] | 0)) {
     i6 = HEAP32[i22 + 76 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (!i1) i21 = 32; else {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) i21 = 32; else {
       HEAP32[i6 >> 2] = i2;
       i16 = i1;
      }
     }
     if ((i21 | 0) == 32) {
      i1 = i6 + 8 | 0;
      i2 = i6 + 12 | 0;
      i5 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
      i19 = HEAP32[i6 + 20 >> 2] | 0;
      i5 = mftCall_iii(HEAP32[i19 >> 2] | 0, HEAP32[i19 + 12 >> 2] | 0, i5 | 0) | 0;
      if (!i5) {
       i19 = i22 + 144 | 0;
       _longjmp(i19 | 0, 1);
      }
      i4 = i6 + 4 | 0;
      HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = i5;
      i4 = HEAP32[i1 >> 2] | 0;
      i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i4) | 0) + 4 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      do {
       i1 = i1 - i4 | 0;
       i19 = i2;
       i2 = i5 + i1 | 0;
       HEAP32[i2 >> 2] = i19;
      } while ((i1 | 0) != 4);
      HEAP32[i6 >> 2] = i2;
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      if (!i2) {
       i19 = i22 + 144 | 0;
       _longjmp(i19 | 0, 1);
      } else i16 = i2;
     }
     HEAP32[i16 >> 2] = i14;
     i2 = HEAP32[i13 >> 2] | 0;
     i4 = i2 + 20 | 0;
     i5 = i2 + 12 | 0;
     i7 = HEAP32[i10 >> 2] | 0;
     do {
      i7 = HEAP32[i7 + 8 >> 2] | 0;
      i1 = HEAP32[i7 >> 2] | 0;
      if (!i1) break;
     } while (!(mftCall_iiii(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0, i1 | 0, i16 | 0) | 0));
     i6 = HEAP32[i2 + 16 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (!i1) i21 = 43; else {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) i21 = 43; else {
       HEAP32[i6 >> 2] = i2;
       i15 = i1;
      }
     }
     if ((i21 | 0) == 43) {
      i1 = i6 + 8 | 0;
      i2 = i6 + 12 | 0;
      i5 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
      i21 = HEAP32[i6 + 20 >> 2] | 0;
      i5 = mftCall_iii(HEAP32[i21 >> 2] | 0, HEAP32[i21 + 12 >> 2] | 0, i5 | 0) | 0;
      if (!i5) {
       i21 = i16 + 4 | 0;
       HEAP32[i21 >> 2] = 0;
       i21 = i22 + 144 | 0;
       _longjmp(i21 | 0, 1);
      }
      i4 = i6 + 4 | 0;
      HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = i5;
      i4 = HEAP32[i1 >> 2] | 0;
      i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i4) | 0) + 4 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      do {
       i1 = i1 - i4 | 0;
       i21 = i2;
       i2 = i5 + i1 | 0;
       HEAP32[i2 >> 2] = i21;
      } while ((i1 | 0) != 4);
      HEAP32[i6 >> 2] = i2;
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      if (!i2) {
       i21 = i16 + 4 | 0;
       HEAP32[i21 >> 2] = 0;
       i21 = i22 + 144 | 0;
       _longjmp(i21 | 0, 1);
      } else i15 = i2;
     }
     HEAP32[i15 >> 2] = i16;
     i21 = i7 + 4 | 0;
     HEAP32[i15 + 4 >> 2] = HEAP32[i21 >> 2];
     HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] = i15;
     HEAP32[i15 + 8 >> 2] = i7;
     HEAP32[i21 >> 2] = i15;
     HEAP32[i16 + 4 >> 2] = i15;
     HEAP32[i16 + 24 >> 2] = 0;
     HEAP32[i16 + 16 >> 2] = 0;
     HEAP32[i16 + 20 >> 2] = 0;
     HEAP32[i14 + 24 >> 2] = i16;
     i21 = HEAP32[i22 + 60 >> 2] | 0;
     i1 = (HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] | 0) + (HEAP32[(HEAP32[HEAP32[i15 + 4 >> 2] >> 2] | 0) + 8 >> 2] | 0) | 0;
     HEAP32[i16 + 8 >> 2] = i1;
     switch (i21 | 0) {
     case 0:
      {
       i1 = i1 & 1;
       break;
      }
     case 1:
      {
       i1 = (i1 | 0) != 0 & 1;
       break;
      }
     case 2:
      {
       i1 = (i1 | 0) > 0 & 1;
       break;
      }
     case 3:
      {
       i1 = i1 >>> 31;
       break;
      }
     case 4:
      {
       i1 = (i1 + 1 | 0) >>> 0 > 2 & 1;
       break;
      }
     default:
      i1 = 0;
     }
     HEAP32[i16 + 12 >> 2] = i1;
    } else if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i22 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0)) _longjmp(i22 + 144 | 0, 1); else {
     HEAP32[i1 >> 2] = 0;
     HEAP32[i2 >> 2] = i14;
     HEAP32[i14 + 24 >> 2] = i2;
     break;
    } while (0);
    __ZL10SweepEventP14TESStesselatorP10TESSvertex(i22, i20);
    break;
   }
  }
  __ZL21ConnectLeftDegenerateP14TESStesselatorP12ActiveRegionP10TESSvertex(i22, i5, i20);
 } while (0);
 STACKTOP = i23;
 return;
}

function __ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i11, i4, i22, i20, f1, f2, i5, i6, i9, i23, i24, i28) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i28 = i28 | 0;
 var f3 = f0, f7 = f0, f8 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f21 = f0, f25 = f0, f26 = f0, f27 = f0;
 if (!(HEAP8[gb + 1544220 >> 0] | 0)) {
  HEAPF32[gb + 1113160 >> 2] = Math_fround(-1.0);
  HEAPF32[gb + 1113160 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[gb + 1113160 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 28 >> 2] = Math_fround(-1.0);
  HEAPF32[gb + 1113160 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[gb + 1113160 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 56 >> 2] = Math_fround(-1.0);
  HEAPF32[gb + 1113160 + 60 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 64 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1113160 + 68 >> 2] = Math_fround(1.0);
  HEAP8[gb + 1544220 >> 0] = 1;
 }
 f26 = Math_fround(HEAPF32[i4 + (i5 << 4) >> 2]);
 f26 = Math_fround(f26 + Math_fround(HEAPF32[i4 + (i6 << 4) >> 2]));
 f27 = Math_fround(HEAPF32[i4 + (i5 << 4) + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 + (i6 << 4) + 4 >> 2]));
 f25 = Math_fround(HEAPF32[i4 + (i5 << 4) + 8 >> 2]);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i4 + (i6 << 4) + 8 >> 2]));
 f12 = Math_fround(HEAPF32[gb + 1113160 + (i5 * 12 | 0) >> 2]);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[gb + 1113160 + (i6 * 12 | 0) >> 2]));
 f19 = Math_fround(HEAPF32[gb + 1113160 + (i5 * 12 | 0) + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(HEAPF32[gb + 1113160 + (i6 * 12 | 0) + 4 >> 2]));
 f21 = Math_fround(HEAPF32[gb + 1113160 + (i5 * 12 | 0) + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(HEAPF32[gb + 1113160 + (i6 * 12 | 0) + 8 >> 2]));
 f16 = Math_fround(HEAPF32[gb + 1113160 + (i9 * 12 | 0) >> 2]);
 f17 = Math_fround(HEAPF32[gb + 1113160 + (i9 * 12 | 0) + 4 >> 2]);
 f18 = Math_fround(HEAPF32[gb + 1113160 + (i9 * 12 | 0) + 8 >> 2]);
 f3 = Math_fround(f12 - f16);
 f7 = Math_fround(f19 - f17);
 f8 = Math_fround(f21 - f18);
 f16 = Math_fround(f12 + f16);
 f17 = Math_fround(f19 + f17);
 f18 = Math_fround(f21 + f18);
 i4 = f8 < Math_fround(0.0);
 f21 = i4 ? f1 : f2;
 i4 = f18 < Math_fround(0.0);
 f19 = i4 ? f1 : f2;
 f12 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f1 = Math_fround(f3 * f12);
 f13 = Math_fround(HEAPF32[i22 + 28 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f7 * f13));
 f14 = Math_fround(HEAPF32[i22 + 44 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f8 * f14));
 f15 = Math_fround(HEAPF32[i22 + 60 >> 2]);
 f1 = Math_fround(f15 + f1);
 i4 = f1 < Math_fround(0.0);
 f10 = Math_fround(-f1);
 i4 = (i4 ? f10 : f1) > Math_fround(1.00000001e-07);
 if (i11) {
  if (i4) {
   f10 = Math_fround(f3 * Math_fround(HEAPF32[i22 + 8 >> 2]));
   f10 = Math_fround(f10 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 24 >> 2])));
   f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 40 >> 2])));
   f10 = Math_fround(Math_fround(HEAPF32[i22 + 56 >> 2]) + f10);
   f19 = Math_fround(f3 * Math_fround(HEAPF32[i22 + 4 >> 2]));
   f19 = Math_fround(f19 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 20 >> 2])));
   f19 = Math_fround(f19 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 36 >> 2])));
   f19 = Math_fround(Math_fround(HEAPF32[i22 + 52 >> 2]) + f19);
   f2 = Math_fround(f3 * Math_fround(HEAPF32[i22 >> 2]));
   f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 16 >> 2])));
   f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 32 >> 2])));
   f21 = Math_fround(Math_fround(1.0) / f1);
   f8 = Math_fround(f21 * f10);
   f3 = Math_fround(f21 * f19);
   f2 = Math_fround(f21 * Math_fround(Math_fround(HEAPF32[i22 + 48 >> 2]) + f2));
  } else {
   f8 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
  f1 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f16 * f12) + Math_fround(f17 * f13)) + Math_fround(f18 * f14)));
  i20 = f1 < Math_fround(0.0);
  f21 = Math_fround(-f1);
  if ((i20 ? f21 : f1) > Math_fround(1.00000001e-07)) {
   f10 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 8 >> 2]));
   f10 = Math_fround(f10 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 24 >> 2])));
   f10 = Math_fround(f10 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 40 >> 2])));
   f10 = Math_fround(Math_fround(HEAPF32[i22 + 56 >> 2]) + f10);
   f21 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 4 >> 2]));
   f21 = Math_fround(f21 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 20 >> 2])));
   f21 = Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 36 >> 2])));
   f21 = Math_fround(Math_fround(HEAPF32[i22 + 52 >> 2]) + f21);
   f7 = Math_fround(f16 * Math_fround(HEAPF32[i22 >> 2]));
   f7 = Math_fround(f7 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 16 >> 2])));
   f7 = Math_fround(f7 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 32 >> 2])));
   f1 = Math_fround(Math_fround(1.0) / f1);
   f7 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i22 + 48 >> 2]) + f7));
   f13 = f2;
   f12 = f3;
   f2 = Math_fround(f1 * f10);
   f10 = f8;
   f1 = Math_fround(f1 * f21);
  } else {
   f7 = Math_fround(0.0);
   f13 = f2;
   f12 = f3;
   f2 = Math_fround(0.0);
   f10 = f8;
   f1 = Math_fround(0.0);
  }
 } else {
  if (i4) {
   f10 = Math_fround(f3 * Math_fround(HEAPF32[i22 + 8 >> 2]));
   f10 = Math_fround(f10 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 24 >> 2])));
   f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 40 >> 2])));
   f10 = Math_fround(Math_fround(HEAPF32[i22 + 56 >> 2]) + f10);
   f2 = Math_fround(f3 * Math_fround(HEAPF32[i22 + 4 >> 2]));
   f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 20 >> 2])));
   f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 36 >> 2])));
   f2 = Math_fround(Math_fround(HEAPF32[i22 + 52 >> 2]) + f2);
   f3 = Math_fround(f3 * Math_fround(HEAPF32[i22 >> 2]));
   f3 = Math_fround(f3 + Math_fround(f7 * Math_fround(HEAPF32[i22 + 16 >> 2])));
   f8 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i22 + 32 >> 2])));
   f3 = Math_fround(Math_fround(1.0) / f1);
   f10 = Math_fround(f3 * f10);
   f7 = Math_fround(f3 * f2);
   f8 = Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i22 + 48 >> 2]) + f8));
  } else {
   f10 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(0.0);
  }
  f1 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f16 * f12) + Math_fround(f17 * f13)) + Math_fround(f18 * f14)));
  i11 = f1 < Math_fround(0.0);
  f15 = Math_fround(-f1);
  if ((i11 ? f15 : f1) > Math_fround(1.00000001e-07)) {
   f2 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 8 >> 2]));
   f2 = Math_fround(f2 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 24 >> 2])));
   f2 = Math_fround(f2 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 40 >> 2])));
   f2 = Math_fround(Math_fround(HEAPF32[i22 + 56 >> 2]) + f2);
   f3 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 4 >> 2]));
   f3 = Math_fround(f3 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 20 >> 2])));
   f3 = Math_fround(f3 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 36 >> 2])));
   f3 = Math_fround(Math_fround(HEAPF32[i22 + 52 >> 2]) + f3);
   f16 = Math_fround(f16 * Math_fround(HEAPF32[i22 >> 2]));
   f17 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i22 + 16 >> 2])));
   f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 32 >> 2])));
   f1 = Math_fround(Math_fround(1.0) / f1);
   f2 = Math_fround(f1 * f2);
   f3 = Math_fround(f1 * f3);
   f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i22 + 48 >> 2]) + f18));
  } else {
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
  f16 = Math_fround(HEAPF32[i20 >> 2]);
  f13 = Math_fround(f8 - f16);
  f18 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f12 = Math_fround(f7 - f18);
  f17 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f7 = Math_fround(f16 + Math_fround(f19 * Math_fround(f1 - f16)));
  f13 = Math_fround(f16 + Math_fround(f21 * f13));
  f12 = Math_fround(f18 + Math_fround(f21 * f12));
  f2 = Math_fround(f17 + Math_fround(f19 * Math_fround(f2 - f17)));
  f10 = Math_fround(f17 + Math_fround(f21 * Math_fround(f10 - f17)));
  f1 = Math_fround(f18 + Math_fround(f19 * Math_fround(f3 - f18)));
 }
 f7 = Math_fround(f7 - f13);
 f3 = Math_fround(f1 - f12);
 f2 = Math_fround(f2 - f10);
 if ((i23 | 0) != 1) {
  f1 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f13);
  f18 = Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) - f12);
  f21 = Math_fround(Math_fround(HEAPF32[i24 + 8 >> 2]) - f10);
  f19 = Math_fround(Math_fround(f3 * f21) - Math_fround(f2 * f18));
  f21 = Math_fround(Math_fround(f2 * f1) - Math_fround(f7 * f21));
  f1 = Math_fround(Math_fround(f7 * f18) - Math_fround(f3 * f1));
  i5 = i28 + 4 | 0;
  i6 = i28 + 8 | 0;
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f19 * f19) + Math_fround(f21 * f21)))));
  f2 = Math_fround(f19 / f7);
  f3 = Math_fround(f21 / f7);
  f7 = Math_fround(f1 / f7);
  HEAPF32[i28 >> 2] = f2;
  HEAPF32[i5 >> 2] = f3;
  HEAPF32[i6 >> 2] = f7;
  f1 = Math_fround(Math_fround(f10 * f7) + Math_fround(Math_fround(f13 * f2) + Math_fround(f12 * f3)));
  i4 = i28 + 12 | 0;
  HEAPF32[i4 >> 2] = Math_fround(-f1);
  if (!(Math_fround(Math_fround(Math_fround(f26 * f2) + Math_fround(f27 * f3)) + Math_fround(f25 * f7)) < Math_fround(0.0))) {
   i28 = 1;
   return i28 | 0;
  }
  HEAPF32[i28 >> 2] = Math_fround(-f2);
  HEAPF32[i5 >> 2] = Math_fround(-f3);
  HEAPF32[i6 >> 2] = Math_fround(-f7);
  HEAPF32[i4 >> 2] = f1;
  i28 = 1;
  return i28 | 0;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f3 * f3)) + Math_fround(f2 * f2))));
 if (f1 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f21 = Math_fround(f7 / f1);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround(f3 / f1);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f21 = Math_fround(f2 / f1);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i6 = HEAP32[gb + 1162364 >> 2] | 0;
  i4 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f8 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f1 = Math_fround(HEAPF32[i24 + 8 >> 2]);
 f2 = Math_fround(f8 * f1);
 f18 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f18 * f21));
 f7 = Math_fround(HEAPF32[i24 >> 2]);
 f18 = Math_fround(f18 * f7);
 f19 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f1 = Math_fround(f18 - Math_fround(f1 * f19));
 f7 = Math_fround(Math_fround(f19 * f21) - Math_fround(f8 * f7));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)))));
 if (f8 < Math_fround(.00100000005)) {
  i28 = 0;
  return i28 | 0;
 }
 f3 = Math_fround(f2 / f8);
 f2 = Math_fround(f1 / f8);
 f1 = Math_fround(f7 / f8);
 if (Math_fround(Math_fround(f25 * f1) + Math_fround(Math_fround(f26 * f3) + Math_fround(f27 * f2))) < Math_fround(0.0)) {
  f3 = Math_fround(-f3);
  f2 = Math_fround(-f2);
  f1 = Math_fround(-f1);
 }
 HEAPF32[i28 >> 2] = f3;
 HEAPF32[i28 + 4 >> 2] = f2;
 HEAPF32[i28 + 8 >> 2] = f1;
 HEAPF32[i28 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f10 * f1) + Math_fround(Math_fround(f12 * f2) + Math_fround(f13 * f3))));
 i28 = 1;
 return i28 | 0;
}

function __ZNK14SoundHandleAPI7GetDataEPfjj(i5, i1, i2, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 80 | 0;
 i15 = i24 + 72 | 0;
 i14 = i24 + 56 | 0;
 i13 = i24 + 40 | 0;
 i7 = i24 + 32 | 0;
 i8 = i24 + 16 | 0;
 i4 = i24;
 i22 = i24 + 132 | 0;
 i16 = i24 + 128 | 0;
 i10 = i24 + 124 | 0;
 i11 = i24 + 120 | 0;
 i20 = i24 + 116 | 0;
 i21 = i24 + 112 | 0;
 i17 = i24 + 108 | 0;
 i18 = i24 + 104 | 0;
 i6 = i24 + 100 | 0;
 i12 = i24 + 96 | 0;
 if (!i5) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i19 = i5 + 40 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 if (!i3) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (HEAP32[i5 + 48 >> 2] & 128 | 0) {
  i1 = HEAP32[i5 + 52 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 871633 | 0, 0, gb + 853741 | 0, 473, 1, i1, 0, 0);
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 i3 = __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(i3, 0, i16, i10, i11) | 0;
 if (i3 | 0) {
  i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i3) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 479;
  HEAP32[i4 + 8 >> 2] = gb + 871179;
  HEAP32[i4 + 12 >> 2] = i3;
  __Z6FormatPKcz(i22, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 }
 switch (HEAP32[i16 >> 2] | 0) {
 case 5:
 case 3:
 case 2:
 case 1:
  {
   HEAP32[i20 >> 2] = 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i3 = __ZN4FMOD5Sound9getLengthEPjj(HEAP32[i19 >> 2] | 0, i6, 2) | 0;
   if (i3 | 0) {
    i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i3) | 0;
    HEAP32[i8 >> 2] = gb + 853741;
    HEAP32[i8 + 4 >> 2] = 505;
    HEAP32[i8 + 8 >> 2] = gb + 871367;
    HEAP32[i8 + 12 >> 2] = i4;
    __Z6FormatPKcz(i22, gb + 883334 | 0, i8);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
   }
   if ((HEAP32[i6 >> 2] | 0) >>> 0 < i2 >>> 0) {
    i8 = HEAP32[i5 + 52 >> 2] | 0;
    i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i7 >> 2] = i8;
    HEAP32[i7 + 4 >> 2] = i2;
    __Z6FormatPKcz(i22, gb + 872036 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 853741 | 0, 510, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i10 = HEAP32[i10 >> 2] | 0;
   i3 = Math_imul(i10, i9) | 0;
   i4 = (HEAP32[i11 >> 2] | 0) / 8 | 0;
   i3 = Math_imul(i3, i4) | 0;
   i4 = Math_imul(Math_imul(i10, i2) | 0, i4) | 0;
   i2 = __ZN4FMOD5Sound9getLengthEPjj(HEAP32[i19 >> 2] | 0, i12, 4) | 0;
   if (i2 | 0) {
    i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
    HEAP32[i13 >> 2] = gb + 853741;
    HEAP32[i13 + 4 >> 2] = 521;
    HEAP32[i13 + 8 >> 2] = gb + 872092;
    HEAP32[i13 + 12 >> 2] = i12;
    __Z6FormatPKcz(i22, gb + 883334 | 0, i13);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
   }
   i2 = __ZN4FMOD5Sound4lockEjjPPvS2_PjS3_(HEAP32[i19 >> 2] | 0, i3, i4, i20, i21, i17, i18) | 0;
   if (!i2) {
    i2 = HEAP32[i21 >> 2] | 0;
    L34 : do if (!i2) {
     i2 = HEAP32[i20 >> 2] | 0;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i2 + i3 | 0;
     switch (HEAP32[i16 >> 2] | 0) {
     case 1:
      {
       if (!i3) break L34;
       while (1) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP8[i2 >> 0] | 0) * Math_fround(.0078125));
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
       }
       break;
      }
     case 2:
      {
       if (!i3) break L34;
       while (1) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP16[i2 >> 1] | 0) * Math_fround(.0000305175781));
        i2 = i2 + 2 | 0;
        if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
       }
       break;
      }
     case 3:
      {
       if (!i3) break L34;
       while (1) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround((HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 24) >> 8 | 0) * Math_fround(1.1920929e-07));
        i2 = i2 + 3 | 0;
        if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
       }
       break;
      }
     case 4:
      {
       if (!i3) break L34;
       while (1) {
        HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP32[i2 >> 2] | 0) * Math_fround(-4.65661287e-10));
        i2 = i2 + 4 | 0;
        if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
       }
       break;
      }
     case 5:
      {
       _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
       break L34;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 872164 | 0, 0, gb + 872206 | 0, 278, 1, 0, 0, 0);
       break L34;
      }
     }
    } else {
     i6 = HEAP32[i17 >> 2] | 0;
     i7 = HEAP32[i18 >> 2] | 0;
     if ((i7 + i6 | 0) >>> 0 > i4 >>> 0) {
      HEAP32[i15 >> 2] = i6 - i4 + i7;
      __Z6FormatPKcz(i22, gb + 872283 | 0, i15);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 853741 | 0, 537, 512, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
      break;
     }
     i3 = HEAP32[i20 >> 2] | 0;
     i5 = i3 + i6 | 0;
     L58 : do switch (HEAP32[i16 >> 2] | 0) {
     case 1:
      {
       if (!i6) i4 = 0; else {
        i4 = i1;
        while (1) {
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAP8[i3 >> 0] | 0) * Math_fround(.0078125));
         i3 = i3 + 1 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 4 | 0;
        }
        i4 = i6 >>> 2;
       }
       i3 = i7;
       i5 = i2 + i7 | 0;
       i1 = i1 + (i4 << 2) | 0;
       i4 = 60;
       break;
      }
     case 2:
      {
       if (!i6) i4 = 0; else {
        i4 = i1;
        while (1) {
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAP16[i3 >> 1] | 0) * Math_fround(.0000305175781));
         i3 = i3 + 2 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 4 | 0;
        }
        i4 = i6 >>> 2;
       }
       i3 = i7;
       i5 = i2 + i7 | 0;
       i1 = i1 + (i4 << 2) | 0;
       i4 = 62;
       break;
      }
     case 3:
      {
       if (!i6) i4 = 0; else {
        i4 = i1;
        while (1) {
         HEAPF32[i4 >> 2] = Math_fround(Math_fround((HEAPU8[i3 + 1 >> 0] << 16 | HEAPU8[i3 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 24) >> 8 | 0) * Math_fround(1.1920929e-07));
         i3 = i3 + 3 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 4 | 0;
        }
        i4 = i6 >>> 2;
       }
       i3 = i7;
       i5 = i2 + i7 | 0;
       i1 = i1 + (i4 << 2) | 0;
       i4 = 65;
       break;
      }
     case 4:
      {
       if (!i6) i4 = 0; else {
        i4 = i1;
        while (1) {
         HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAP32[i3 >> 2] | 0) * Math_fround(-4.65661287e-10));
         i3 = i3 + 4 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 4 | 0;
        }
        i4 = i6 >>> 2;
       }
       i3 = i7;
       i5 = i2 + i7 | 0;
       i1 = i1 + (i4 << 2) | 0;
       i4 = 68;
       break;
      }
     case 5:
      {
       _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
       i1 = i1 + (i6 >>> 2 << 2) | 0;
       i3 = i7;
       i4 = 71;
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 872164 | 0, 0, gb + 872206 | 0, 278, 1, 0, 0, 0);
       i2 = HEAP32[i21 >> 2] | 0;
       i3 = HEAP32[i18 >> 2] | 0;
       i4 = i2 + i3 | 0;
       i1 = i1 + ((HEAP32[i17 >> 2] | 0) >>> 2 << 2) | 0;
       switch (HEAP32[i16 >> 2] | 0) {
       case 1:
        {
         i5 = i4;
         i4 = 60;
         break L58;
        }
       case 2:
        {
         i5 = i4;
         i4 = 62;
         break L58;
        }
       case 3:
        {
         i5 = i4;
         i4 = 65;
         break L58;
        }
       case 4:
        {
         i5 = i4;
         i4 = 68;
         break L58;
        }
       case 5:
        {
         i4 = 71;
         break L58;
        }
       default:
        {}
       }
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 872164 | 0, 0, gb + 872206 | 0, 278, 1, 0, 0, 0);
       break L34;
      }
     } while (0);
     if ((i4 | 0) == 60) {
      if (!i3) break;
      while (1) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP8[i2 >> 0] | 0) * Math_fround(.0078125));
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 4 | 0;
      }
     } else if ((i4 | 0) == 62) {
      if (!i3) break;
      while (1) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP16[i2 >> 1] | 0) * Math_fround(.0000305175781));
       i2 = i2 + 2 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 4 | 0;
      }
     } else if ((i4 | 0) == 65) {
      if (!i3) break;
      while (1) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround((HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 24) >> 8 | 0) * Math_fround(1.1920929e-07));
       i2 = i2 + 3 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 4 | 0;
      }
     } else if ((i4 | 0) == 68) {
      if (!i3) break;
      while (1) {
       HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAP32[i2 >> 2] | 0) * Math_fround(-4.65661287e-10));
       i2 = i2 + 4 | 0;
       if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 4 | 0;
      }
     } else if ((i4 | 0) == 71) {
      _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
      break;
     }
    } while (0);
    i1 = __ZN4FMOD5Sound6unlockEPvS1_jj(HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
    if (!i1) i1 = 1; else {
     i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
     HEAP32[i23 >> 2] = gb + 853741;
     HEAP32[i23 + 4 >> 2] = 546;
     HEAP32[i23 + 8 >> 2] = gb + 871583;
     HEAP32[i23 + 12 >> 2] = i1;
     __Z6FormatPKcz(i22, gb + 883334 | 0, i23);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
     i1 = 1;
    }
   } else {
    i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
    HEAP32[i14 >> 2] = gb + 853741;
    HEAP32[i14 + 4 >> 2] = 525;
    HEAP32[i14 + 8 >> 2] = gb + 871496;
    HEAP32[i14 + 12 >> 2] = i1;
    __Z6FormatPKcz(i22, gb + 883334 | 0, i14);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    i1 = 0;
   }
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 52 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 871922 | 0, 0, gb + 853741 | 0, 488, 1, i1, 0, 0);
   i1 = 0;
  }
 }
 i23 = i1;
 STACKTOP = i24;
 return i23 | 0;
}

function __Z28sweepCapsule_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i18, i21, i20, i24, f17, i23, i19, f1) {
 i18 = i18 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 f17 = Math_fround(f17);
 i23 = i23 | 0;
 i19 = i19 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i25 + 144 | 0;
 i12 = i25 + 272 | 0;
 i33 = i25 + 300 | 0;
 i26 = i25 + 232 | 0;
 i29 = i25 + 208 | 0;
 i28 = i25 + 196 | 0;
 i9 = i25 + 184 | 0;
 i27 = i25 + 172 | 0;
 i22 = i25 + 160 | 0;
 i16 = i25;
 i14 = i20 + 12 | 0;
 i15 = i20 + 24 | 0;
 f48 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f1);
 HEAP32[i12 >> 2] = HEAP32[i20 >> 2];
 i10 = i20 + 4 | 0;
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 >> 2];
 i2 = i20 + 8 | 0;
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i14 >> 2];
 i3 = i20 + 16 | 0;
 HEAP32[i12 + 16 >> 2] = HEAP32[i3 >> 2];
 i4 = i20 + 20 | 0;
 HEAP32[i12 + 20 >> 2] = HEAP32[i4 >> 2];
 i7 = i12 + 24 | 0;
 HEAPF32[i7 >> 2] = f48;
 __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE(i12, i33);
 f48 = Math_fround(Math_abs(Math_fround(HEAPF32[i33 >> 2])));
 f1 = Math_fround(Math_abs(Math_fround(HEAPF32[i33 + 4 >> 2])));
 f43 = Math_fround(Math_abs(Math_fround(HEAPF32[i33 + 8 >> 2])));
 i8 = i33 + 12 | 0;
 f45 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 >> 2])));
 f36 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 + 4 >> 2])));
 f42 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 + 8 >> 2])));
 i8 = i33 + 24 | 0;
 f47 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 >> 2])));
 f44 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 + 4 >> 2])));
 f40 = Math_fround(Math_abs(Math_fround(HEAPF32[i8 + 8 >> 2])));
 f50 = Math_fround(HEAPF32[i33 + 48 >> 2]);
 f49 = Math_fround(HEAPF32[i33 + 52 >> 2]);
 f41 = Math_fround(HEAPF32[i33 + 56 >> 2]);
 f47 = Math_fround(Math_fround(Math_fround(f48 * f50) + Math_fround(f45 * f49)) + Math_fround(f47 * f41));
 f44 = Math_fround(Math_fround(Math_fround(f1 * f50) + Math_fround(f36 * f49)) + Math_fround(f44 * f41));
 f41 = Math_fround(Math_fround(Math_fround(f43 * f50) + Math_fround(f42 * f49)) + Math_fround(f40 * f41));
 HEAP32[i26 >> 2] = gb + 85568 + 8;
 i8 = i26 + 24 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i26 + 25 >> 0] = 0;
 HEAP32[i29 + 12 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i29 + 16 >> 2] = i18;
 HEAPF32[i29 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i18 + 8 >> 2]));
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i18 + 12 >> 2]));
 HEAPF32[i29 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i18 + 16 >> 2]));
 HEAP32[i26 + 28 >> 2] = i21;
 HEAP32[i26 + 32 >> 2] = i29;
 HEAP32[i26 + 4 >> 2] = i12;
 HEAP32[i26 + 8 >> 2] = i24;
 HEAPF32[i26 + 12 >> 2] = f17;
 HEAP32[i26 + 16 >> 2] = i23;
 HEAP32[i26 + 20 >> 2] = i19;
 i12 = HEAP16[i19 >> 1] | 0;
 HEAP8[i26 + 37 >> 0] = (i12 & 65535) >>> 6 & 1;
 i11 = i26 + 36 | 0;
 HEAP8[i11 >> 0] = ((HEAPU8[i18 + 20 >> 0] | 0) >>> 1 | (i12 & 65535) >>> 7 & 255) & 1;
 i12 = i23 + 40 | 0;
 HEAPF32[i12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 f40 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f49 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f40 = Math_fround(f40 * Math_fround(-2.0));
 f49 = Math_fround(f49 * Math_fround(-2.0));
 f42 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(-2.0));
 f50 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f43 = Math_fround(Math_fround(f50 * f50) + Math_fround(-.5));
 f36 = Math_fround(HEAPF32[i21 >> 2]);
 f1 = Math_fround(f40 * f36);
 f45 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f49 * f45));
 f48 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f42 * f48));
 f37 = Math_fround(Math_fround(f36 * f1) + Math_fround(Math_fround(f40 * f43) - Math_fround(f50 * Math_fround(Math_fround(f42 * f45) - Math_fround(f49 * f48)))));
 f39 = Math_fround(Math_fround(f45 * f1) + Math_fround(Math_fround(f49 * f43) - Math_fround(f50 * Math_fround(Math_fround(f40 * f48) - Math_fround(f42 * f36)))));
 f1 = Math_fround(Math_fround(Math_fround(f42 * f43) - Math_fround(f50 * Math_fround(Math_fround(f49 * f36) - Math_fround(f40 * f45)))) + Math_fround(f48 * f1));
 f40 = Math_fround(-f36);
 f49 = Math_fround(-f45);
 f42 = Math_fround(-f48);
 f34 = Math_fround(Math_fround(HEAPF32[i33 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i33 + 40 >> 2]) * Math_fround(2.0));
 f46 = Math_fround(Math_fround(HEAPF32[i33 + 44 >> 2]) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(Math_fround(f34 * f40) + Math_fround(f35 * f49)) + Math_fround(f46 * f42));
 f37 = Math_fround(f37 + Math_fround(Math_fround(f38 * f40) + Math_fround(Math_fround(f43 * f34) + Math_fround(f50 * Math_fround(Math_fround(f46 * f49) - Math_fround(f35 * f42))))));
 f39 = Math_fround(f39 + Math_fround(Math_fround(f38 * f49) + Math_fround(Math_fround(f43 * f35) + Math_fround(f50 * Math_fround(Math_fround(f34 * f42) - Math_fround(f46 * f40))))));
 f38 = Math_fround(f1 + Math_fround(Math_fround(Math_fround(f43 * f46) + Math_fround(f50 * Math_fround(Math_fround(f35 * f40) - Math_fround(f34 * f49)))) + Math_fround(f38 * f42)));
 HEAPF32[i28 >> 2] = f37;
 i33 = i28 + 4 | 0;
 HEAPF32[i33 >> 2] = f39;
 i32 = i28 + 8 | 0;
 HEAPF32[i32 >> 2] = f38;
 f34 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * Math_fround(2.0));
 i5 = i24 + 4 | 0;
 f35 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
 i6 = i24 + 8 | 0;
 f46 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(2.0));
 f1 = Math_fround(Math_fround(Math_fround(f34 * f40) + Math_fround(f35 * f49)) + Math_fround(f46 * f42));
 f31 = Math_fround(Math_fround(f1 * f40) + Math_fround(Math_fround(f43 * f34) + Math_fround(f50 * Math_fround(Math_fround(f46 * f49) - Math_fround(f35 * f42)))));
 f30 = Math_fround(Math_fround(f1 * f49) + Math_fround(Math_fround(f43 * f35) + Math_fround(f50 * Math_fround(Math_fround(f34 * f42) - Math_fround(f46 * f40)))));
 f1 = Math_fround(Math_fround(Math_fround(f43 * f46) + Math_fround(f50 * Math_fround(Math_fround(f35 * f40) - Math_fround(f34 * f49)))) + Math_fround(f1 * f42));
 f36 = Math_fround(f40 - f36);
 f45 = Math_fround(f49 - f45);
 f48 = Math_fround(f42 - f48);
 f34 = Math_fround(f45 * f49);
 f35 = Math_fround(f48 * f42);
 f49 = Math_fround(f36 * f49);
 f46 = Math_fround(f36 * f42);
 f43 = Math_fround(f50 * f36);
 f42 = Math_fround(f45 * f42);
 f45 = Math_fround(f50 * f45);
 f48 = Math_fround(f50 * f48);
 f40 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f40));
 f36 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f47 * Math_fround(Math_fround(Math_fround(1.0) - f34) - f35)))) + Math_fround(Math_abs(Math_fround(f44 * Math_fround(f49 - f48))))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f46 + f45)))));
 f35 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f47 * Math_fround(f49 + f48)))) + Math_fround(Math_abs(Math_fround(f44 * Math_fround(f40 - f35))))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f42 - f43)))));
 f34 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f47 * Math_fround(f46 - f45)))) + Math_fround(Math_abs(Math_fround(f44 * Math_fround(f43 + f42))))) + Math_fround(Math_abs(Math_fround(f41 * Math_fround(f40 - f34)))));
 f35 = Math_fround(Math_fround(Math_fround(f35 + f39) - Math_fround(f39 - f35)) * Math_fround(.5));
 f34 = Math_fround(Math_fround(Math_fround(f38 + f34) - Math_fround(f38 - f34)) * Math_fround(.5));
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(Math_fround(f36 + f37) - Math_fround(f37 - f36)) * Math_fround(.5));
 HEAPF32[i9 + 4 >> 2] = f35;
 HEAPF32[i9 + 8 >> 2] = f34;
 f31 = Math_fround(f31 * f17);
 f30 = Math_fround(f30 * f17);
 f1 = Math_fround(f1 * f17);
 f31 = Math_fround(f31 + Math_fround(HEAPF32[i28 >> 2]));
 f30 = Math_fround(f30 + Math_fround(HEAPF32[i33 >> 2]));
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i32 >> 2]));
 HEAPF32[i27 >> 2] = f31;
 HEAPF32[i27 + 4 >> 2] = f30;
 HEAPF32[i27 + 8 >> 2] = f1;
 __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI25CapsuleTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i29, i28, i27, i26, i9);
 i8 = HEAP16[i8 >> 1] | 0;
 if (!((i8 & 255) << 24 >> 24)) {
  i33 = 0;
  STACKTOP = i25;
  return i33 | 0;
 }
 i9 = i23 + 12 | 0;
 if ((i8 & 65535) < 256) {
  HEAP16[i9 >> 1] = 7;
  i33 = 1;
  STACKTOP = i25;
  return i33 | 0;
 }
 HEAP16[i9 >> 1] = 6;
 if (!(HEAP16[i19 >> 1] & 512)) {
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  f48 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  f49 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
  f50 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i23 + 28 >> 2] = f48;
  HEAPF32[i23 + 32 >> 2] = f49;
  HEAPF32[i23 + 36 >> 2] = f50;
  i33 = 1;
  STACKTOP = i25;
  return i33 | 0;
 }
 i26 = HEAP32[i20 >> 2] | 0;
 i27 = HEAP32[i10 >> 2] | 0;
 i28 = HEAP32[i2 >> 2] | 0;
 i29 = HEAP32[i14 >> 2] | 0;
 i32 = HEAP32[i3 >> 2] | 0;
 i33 = HEAP32[i4 >> 2] | 0;
 i20 = HEAP32[i15 >> 2] | 0;
 i19 = i16 + 64 | 0;
 HEAP32[i16 + 80 >> 2] = 4;
 HEAPF32[i16 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i13 >> 2] = -1;
 HEAP32[i13 + 4 >> 2] = -1;
 HEAP32[i13 + 8 >> 2] = -1;
 HEAP32[i13 + 12 >> 2] = -1;
 HEAP32[i19 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i16 + 128 >> 2] = i20;
 i19 = i16 + 132 | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i16 + 96 >> 2] = i26;
 HEAP32[i16 + 100 >> 2] = i27;
 HEAP32[i16 + 104 >> 2] = i28;
 HEAPF32[i16 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i16 + 112 >> 2] = i29;
 HEAP32[i16 + 116 >> 2] = i32;
 HEAP32[i16 + 120 >> 2] = i33;
 HEAPF32[i16 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i16 + 16 >> 2] = i20;
 i19 = i16 + 20 | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i16 + 32 >> 2] = i20;
 i20 = i16 + 36 | 0;
 HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 f47 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f48 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f49 = Math_fround(Math_fround(f46 + f49) * Math_fround(.5));
 f50 = Math_fround(Math_fround(f50 + (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(f47 + f48) * Math_fround(.5));
 HEAPF32[i16 + 4 >> 2] = f49;
 HEAPF32[i16 + 8 >> 2] = f50;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 f50 = Math_fround(HEAPF32[i7 >> 2]);
 if (__ZN5physx2Gu29computeCapsule_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbjRNS_10PxSweepHitE(i18, i21, i16, f50, f17, (HEAP8[i11 >> 0] | 0) != 0, 1, i23) | 0) HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 1; else {
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  f48 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  f49 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
  f50 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i23 + 28 >> 2] = f48;
  HEAPF32[i23 + 32 >> 2] = f49;
  HEAPF32[i23 + 36 >> 2] = f50;
 }
 i33 = 1;
 STACKTOP = i25;
 return i33 | 0;
}

function __Z20raycast_triangleMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i15, i23, i9, i24, f20, i16, i21, i18, i12, i17, i25) {
 i15 = i15 | 0;
 i23 = i23 | 0;
 i9 = i9 | 0;
 i24 = i24 | 0;
 f20 = Math_fround(f20);
 i16 = i16 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i25 = i25 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i19 = 0, i22 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i27 + 188 | 0;
 i14 = i27 + 176 | 0;
 i26 = i27 + 200 | 0;
 i2 = i27 + 72 | 0;
 i3 = i27 + 40 | 0;
 i4 = i27 + 12 | 0;
 i13 = i27 + 120 | 0;
 i19 = i27;
 i10 = HEAP32[i15 + 36 >> 2] | 0;
 i11 = i15 + 4 | 0;
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 i28 = f5 == Math_fround(1.0);
 f1 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 if (i28 & f1 == Math_fround(1.0)) if (Math_fround(HEAPF32[i15 + 12 >> 2]) == Math_fround(1.0)) {
  f7 = Math_fround(HEAPF32[i9 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i23 + 16 >> 2]));
  f29 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f29 = Math_fround(f29 - Math_fround(HEAPF32[i23 + 20 >> 2]));
  f33 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f7 = Math_fround(f7 * Math_fround(2.0));
  f29 = Math_fround(f29 * Math_fround(2.0));
  f33 = Math_fround(Math_fround(f33 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
  f30 = Math_fround(HEAPF32[i23 + 12 >> 2]);
  f31 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
  f34 = Math_fround(HEAPF32[i23 >> 2]);
  f8 = Math_fround(f7 * f34);
  f1 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f29 * f1));
  f6 = Math_fround(HEAPF32[i23 + 8 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f33 * f6));
  f5 = Math_fround(Math_fround(f1 * f8) + Math_fround(Math_fround(f29 * f31) - Math_fround(f30 * Math_fround(Math_fround(f7 * f6) - Math_fround(f33 * f34)))));
  f32 = Math_fround(Math_fround(Math_fround(f33 * f31) - Math_fround(f30 * Math_fround(Math_fround(f29 * f34) - Math_fround(f7 * f1)))) + Math_fround(f6 * f8));
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(f34 * f8) + Math_fround(Math_fround(f7 * f31) - Math_fround(f30 * Math_fround(Math_fround(f33 * f1) - Math_fround(f29 * f6)))));
  HEAPF32[i22 + 4 >> 2] = f5;
  HEAPF32[i22 + 8 >> 2] = f32;
  f32 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * Math_fround(2.0));
  f5 = Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) * Math_fround(2.0));
  f29 = Math_fround(Math_fround(HEAPF32[i24 + 8 >> 2]) * Math_fround(2.0));
  f33 = Math_fround(Math_fround(Math_fround(f32 * f34) + Math_fround(f5 * f1)) + Math_fround(f29 * f6));
  f7 = Math_fround(Math_fround(f1 * f33) + Math_fround(Math_fround(f5 * f31) - Math_fround(f30 * Math_fround(Math_fround(f32 * f6) - Math_fround(f29 * f34)))));
  f8 = Math_fround(Math_fround(Math_fround(f29 * f31) - Math_fround(f30 * Math_fround(Math_fround(f5 * f34) - Math_fround(f32 * f1)))) + Math_fround(f6 * f33));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround(f34 * f33) + Math_fround(Math_fround(f32 * f31) - Math_fround(f30 * Math_fround(Math_fround(f29 * f1) - Math_fround(f5 * f6)))));
  HEAPF32[i14 + 4 >> 2] = f7;
  HEAPF32[i14 + 8 >> 2] = f8;
  f8 = Math_fround(1.0);
  i9 = 0;
  i26 = i15 + 32 | 0;
  i26 = HEAP8[i26 >> 0] | 0;
  i26 = i26 & 2;
  i15 = (i17 | 0) != 0;
  i28 = i21 >>> 0 > 1;
  i15 = i28 | i15;
  i12 = i12 & 1;
  i12 = i12 ^ 1;
  i12 = i15 ? 2 : i12;
  i16 = HEAP16[i16 >> 1] | 0;
  i15 = i16 & 65535;
  i28 = i13 + 4 | 0;
  HEAP32[i28 >> 2] = i12;
  HEAP32[i13 >> 2] = gb + 85992 + 8;
  i28 = i13 + 8 | 0;
  HEAP32[i28 >> 2] = i18;
  i28 = i13 + 12 | 0;
  HEAP32[i28 >> 2] = 0;
  i18 = i13 + 16 | 0;
  HEAP32[i18 >> 2] = i21;
  i21 = i13 + 20 | 0;
  HEAP32[i21 >> 2] = i11;
  i21 = i13 + 24 | 0;
  HEAP32[i21 >> 2] = i23;
  i23 = i13 + 28 | 0;
  HEAP32[i23 >> 2] = i9;
  i23 = i13 + 32 | 0;
  HEAP32[i23 >> 2] = i15;
  i23 = i13 + 36 | 0;
  HEAP32[i23 >> 2] = i17;
  i23 = i13 + 40 | 0;
  HEAP32[i23 >> 2] = i25;
  i25 = i13 + 44 | 0;
  HEAP32[i25 >> 2] = i24;
  i25 = i13 + 48 | 0;
  i24 = (i26 & 255) >>> 1;
  HEAP8[i25 >> 0] = i24;
  i25 = i13 + 49 | 0;
  HEAP8[i25 >> 0] = 0;
  i25 = i13 + 52 | 0;
  HEAPF32[i25 >> 2] = f8;
  i25 = i16 & 128;
  i25 = i25 << 16 >> 16 != 0;
  i26 = i26 << 24 >> 24 != 0;
  i26 = i25 | i26;
  i25 = i10 + 32 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  HEAP32[i19 >> 2] = i25;
  i25 = i10 + 48 | 0;
  i24 = i19 + 4 | 0;
  HEAP32[i24 >> 2] = i25;
  i24 = i10 + 36 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i25 = i19 + 8 | 0;
  HEAP32[i25 >> 2] = i24;
  __ZN5physx2Gu15MeshRayCollider7collideILi0ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i22, i14, f20, i26, i19, i13, 0);
  i28 = HEAP32[i28 >> 2] | 0;
  STACKTOP = i27;
  return i28 | 0;
 } else f1 = Math_fround(1.0);
 f29 = Math_fround(Math_fround(1.0) / f5);
 f31 = Math_fround(Math_fround(1.0) / f1);
 f5 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i15 + 12 >> 2]));
 HEAPF32[i3 >> 2] = f29;
 HEAPF32[i3 + 4 >> 2] = f31;
 HEAPF32[i3 + 8 >> 2] = f5;
 HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i15 + 28 >> 2];
 f5 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f5 = Math_fround(f5 * Math_fround(-2.0));
 f31 = Math_fround(f31 * Math_fround(-2.0));
 f29 = Math_fround(Math_fround(HEAPF32[i23 + 24 >> 2]) * Math_fround(-2.0));
 f7 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f6 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
 f8 = Math_fround(HEAPF32[i23 >> 2]);
 f32 = Math_fround(f5 * f8);
 f33 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f31 * f33));
 f30 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f29 * f30));
 f1 = Math_fround(Math_fround(f8 * f32) + Math_fround(Math_fround(f5 * f6) - Math_fround(f7 * Math_fround(Math_fround(f29 * f33) - Math_fround(f31 * f30)))));
 f34 = Math_fround(Math_fround(f33 * f32) + Math_fround(Math_fround(f31 * f6) - Math_fround(f7 * Math_fround(Math_fround(f5 * f30) - Math_fround(f29 * f8)))));
 f32 = Math_fround(Math_fround(Math_fround(f29 * f6) - Math_fround(f7 * Math_fround(Math_fround(f31 * f8) - Math_fround(f5 * f33)))) + Math_fround(f30 * f32));
 f33 = Math_fround(-f33);
 f30 = Math_fround(-f30);
 HEAPF32[i4 >> 2] = Math_fround(-f8);
 HEAPF32[i4 + 4 >> 2] = f33;
 HEAPF32[i4 + 8 >> 2] = f30;
 HEAPF32[i4 + 12 >> 2] = f7;
 HEAPF32[i4 + 16 >> 2] = f1;
 HEAPF32[i4 + 20 >> 2] = f34;
 HEAPF32[i4 + 24 >> 2] = f32;
 __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE(i2, i3, i4);
 i45 = HEAP32[i2 >> 2] | 0;
 HEAP32[i26 >> 2] = i45;
 i44 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i26 + 4 | 0;
 HEAP32[i4 >> 2] = i44;
 i43 = HEAP32[i2 + 8 >> 2] | 0;
 i28 = i26 + 8 | 0;
 HEAP32[i28 >> 2] = i43;
 i42 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i26 + 12 >> 2] = i42;
 i41 = HEAP32[i2 + 16 >> 2] | 0;
 i3 = i26 + 16 | 0;
 HEAP32[i3 >> 2] = i41;
 i40 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i26 + 20 >> 2] = i40;
 i39 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i26 + 24 >> 2] = i39;
 i38 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i26 + 28 >> 2] = i38;
 i37 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i26 + 32 >> 2] = i37;
 i36 = HEAP32[i2 + 36 >> 2] | 0;
 HEAP32[i26 + 36 >> 2] = i36;
 i35 = HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i26 + 40 >> 2] = i35;
 i2 = HEAP32[i2 + 44 >> 2] | 0;
 HEAP32[i26 + 44 >> 2] = i2;
 f32 = Math_fround(HEAPF32[i9 >> 2]);
 f34 = Math_fround(f32 * (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f1 = Math_fround(f32 * (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f32 = Math_fround(f32 * (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f30 = Math_fround(f7 * (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f33 = Math_fround(f7 * (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f34 + f30);
 f33 = Math_fround(f1 + f33);
 f7 = Math_fround(f32 + Math_fround(f7 * f8));
 f32 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f1 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f32 * f1);
 f5 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f32 * f5);
 f6 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f30 + f34);
 f31 = Math_fround(f33 + f31);
 f32 = Math_fround(f7 + Math_fround(f32 * f6));
 f34 = Math_fround(f34 + (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f31 = Math_fround(f31 + (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f32 = Math_fround(f32 + (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i22 >> 2] = f34;
 HEAPF32[i22 + 4 >> 2] = f31;
 HEAPF32[i22 + 8 >> 2] = f32;
 f32 = Math_fround(HEAPF32[i24 >> 2]);
 f31 = Math_fround(f32 * Math_fround(HEAPF32[i26 >> 2]));
 f34 = Math_fround(f32 * Math_fround(HEAPF32[i4 >> 2]));
 f32 = Math_fround(f32 * Math_fround(HEAPF32[i28 >> 2]));
 f7 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f33 = Math_fround(f7 * Math_fround(HEAPF32[i26 + 12 >> 2]));
 f33 = Math_fround(f31 + f33);
 f34 = Math_fround(f34 + Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2])));
 f8 = Math_fround(f32 + Math_fround(f7 * f8));
 f7 = Math_fround(HEAPF32[i24 + 8 >> 2]);
 f1 = Math_fround(f33 + Math_fround(f7 * f1));
 f5 = Math_fround(f34 + Math_fround(f7 * f5));
 f6 = Math_fround(f8 + Math_fround(f7 * f6));
 HEAPF32[i14 >> 2] = f1;
 i2 = i14 + 4 | 0;
 HEAPF32[i2 >> 2] = f5;
 i3 = i14 + 8 | 0;
 HEAPF32[i3 >> 2] = f6;
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
 f8 = Math_fround(Math_fround(1.0) / f7);
 if (f7 > Math_fround(0.0)) {
  HEAPF32[i14 >> 2] = Math_fround(f1 * f8);
  HEAPF32[i2 >> 2] = Math_fround(f5 * f8);
  HEAPF32[i3 >> 2] = Math_fround(f6 * f8);
 }
 f34 = Math_fround(Math_fround(f7 * f20) + Math_fround(.00100000005));
 f33 = f8;
 i40 = i26;
 i44 = i15 + 32 | 0;
 i44 = HEAP8[i44 >> 0] | 0;
 i44 = i44 & 2;
 i43 = (i17 | 0) != 0;
 i42 = i21 >>> 0 > 1;
 i43 = i42 | i43;
 i42 = i12 & 1;
 i42 = i42 ^ 1;
 i42 = i43 ? 2 : i42;
 i43 = HEAP16[i16 >> 1] | 0;
 i41 = i43 & 65535;
 i45 = i13 + 4 | 0;
 HEAP32[i45 >> 2] = i42;
 HEAP32[i13 >> 2] = gb + 85992 + 8;
 i45 = i13 + 8 | 0;
 HEAP32[i45 >> 2] = i18;
 i45 = i13 + 12 | 0;
 HEAP32[i45 >> 2] = 0;
 i42 = i13 + 16 | 0;
 HEAP32[i42 >> 2] = i21;
 i42 = i13 + 20 | 0;
 HEAP32[i42 >> 2] = i11;
 i42 = i13 + 24 | 0;
 HEAP32[i42 >> 2] = i23;
 i42 = i13 + 28 | 0;
 HEAP32[i42 >> 2] = i40;
 i42 = i13 + 32 | 0;
 HEAP32[i42 >> 2] = i41;
 i42 = i13 + 36 | 0;
 HEAP32[i42 >> 2] = i17;
 i42 = i13 + 40 | 0;
 HEAP32[i42 >> 2] = i25;
 i42 = i13 + 44 | 0;
 HEAP32[i42 >> 2] = i24;
 i42 = i13 + 48 | 0;
 i41 = (i44 & 255) >>> 1;
 HEAP8[i42 >> 0] = i41;
 i42 = i13 + 49 | 0;
 HEAP8[i42 >> 0] = 0;
 i42 = i13 + 52 | 0;
 HEAPF32[i42 >> 2] = f33;
 i43 = i43 & 128;
 i43 = i43 << 16 >> 16 != 0;
 i44 = i44 << 24 >> 24 != 0;
 i44 = i43 | i44;
 i43 = i10 + 32 | 0;
 i43 = HEAP32[i43 >> 2] | 0;
 HEAP32[i19 >> 2] = i43;
 i43 = i10 + 48 | 0;
 i42 = i19 + 4 | 0;
 HEAP32[i42 >> 2] = i43;
 i42 = i10 + 36 | 0;
 i42 = HEAP32[i42 >> 2] | 0;
 i43 = i19 + 8 | 0;
 HEAP32[i43 >> 2] = i42;
 __ZN5physx2Gu15MeshRayCollider7collideILi0ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i22, i14, f34, i44, i19, i13, 0);
 i45 = HEAP32[i45 >> 2] | 0;
 STACKTOP = i27;
 return i45 | 0;
}

function __ZN5physx12writeBack1D4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 i47 = HEAP32[i4 + 20 >> 2] | 0;
 i48 = HEAP32[i4 + 52 >> 2] | 0;
 i49 = HEAP32[i4 + 84 >> 2] | 0;
 i42 = HEAP32[i4 + 116 >> 2] | 0;
 i43 = (i47 | 0) != 0;
 i44 = (i48 | 0) != 0;
 i45 = (i49 | 0) != 0;
 i46 = (i42 | 0) != 0;
 if (!(i43 | i44 | i45 | i46)) return;
 i41 = HEAP32[i4 + 16 >> 2] | 0;
 i37 = (HEAP8[i41 >> 0] | 0) == 9 ? 416 : 272;
 i38 = HEAP32[i41 + 4 >> 2] | 0;
 if (!i38) {
  i1 = 0;
  i3 = 0;
  i6 = 0;
  i10 = 0;
  i2 = 0;
  i4 = 0;
  i7 = 0;
  i11 = 0;
  i37 = 0;
  i34 = 0;
  i35 = 0;
  i36 = 0;
  f19 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  i36 = 0;
  i35 = 0;
  i34 = 0;
  i18 = 0;
  f5 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  i10 = 0;
  i6 = 0;
  i3 = 0;
  i1 = 0;
  i11 = 0;
  i7 = 0;
  i4 = 0;
  i2 = 0;
  i39 = i41 + 128 | 0;
  i40 = 0;
  while (1) {
   f27 = Math_fround(HEAPF32[i39 + 240 >> 2]);
   f29 = Math_fround(HEAPF32[i39 + 244 >> 2]);
   f31 = Math_fround(HEAPF32[i39 + 248 >> 2]);
   f33 = Math_fround(HEAPF32[i39 + 252 >> 2]);
   f27 = HEAP32[i39 + 256 >> 2] & 2 | 0 ? f27 : Math_fround(0.0);
   f29 = HEAP32[i39 + 260 >> 2] & 2 | 0 ? f29 : Math_fround(0.0);
   f31 = HEAP32[i39 + 264 >> 2] & 2 | 0 ? f31 : Math_fround(0.0);
   f33 = HEAP32[i39 + 268 >> 2] & 2 | 0 ? f33 : Math_fround(0.0);
   f26 = Math_fround(HEAPF32[i39 >> 2]);
   f32 = Math_fround(HEAPF32[i39 + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 8 >> 2]);
   f26 = Math_fround(f27 * f26);
   f32 = Math_fround(f29 * f32);
   f30 = Math_fround(f31 * f30);
   f28 = Math_fround(f33 * Math_fround(HEAPF32[i39 + 12 >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f22 + f26);
   f32 = Math_fround(f24 + f32);
   f30 = Math_fround(f25 + f30);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i39 + 16 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 20 >> 2]);
   f32 = Math_fround(HEAPF32[i39 + 24 >> 2]);
   f28 = Math_fround(f27 * f28);
   f30 = Math_fround(f29 * f30);
   f32 = Math_fround(f31 * f32);
   f26 = Math_fround(f33 * Math_fround(HEAPF32[i39 + 28 >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f25 + f28);
   f30 = Math_fround(f24 + f30);
   f32 = Math_fround(f22 + f32);
   f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f26);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   f26 = Math_fround(HEAPF32[i39 + 32 >> 2]);
   f32 = Math_fround(HEAPF32[i39 + 36 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 40 >> 2]);
   f26 = Math_fround(f27 * f26);
   f32 = Math_fround(f29 * f32);
   f30 = Math_fround(f31 * f30);
   f28 = Math_fround(f33 * Math_fround(HEAPF32[i39 + 44 >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f22 + f26);
   f32 = Math_fround(f24 + f32);
   f30 = Math_fround(f25 + f30);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   i36 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i35 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i34 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i18 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround(HEAPF32[i39 + 48 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 52 >> 2]);
   f32 = Math_fround(HEAPF32[i39 + 56 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f27 * f28));
   f12 = Math_fround(f12 + Math_fround(f29 * f30));
   f15 = Math_fround(f15 + Math_fround(f31 * f32));
   f19 = Math_fround(f19 + Math_fround(f33 * Math_fround(HEAPF32[i39 + 60 >> 2])));
   f32 = Math_fround(HEAPF32[i39 + 64 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 68 >> 2]);
   f28 = Math_fround(HEAPF32[i39 + 72 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f27 * f32));
   f13 = Math_fround(f13 + Math_fround(f29 * f30));
   f16 = Math_fround(f16 + Math_fround(f31 * f28));
   f20 = Math_fround(f20 + Math_fround(f33 * Math_fround(HEAPF32[i39 + 76 >> 2])));
   f28 = Math_fround(HEAPF32[i39 + 80 >> 2]);
   f30 = Math_fround(HEAPF32[i39 + 84 >> 2]);
   f32 = Math_fround(HEAPF32[i39 + 88 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f27 * f28));
   f14 = Math_fround(f14 + Math_fround(f29 * f30));
   f17 = Math_fround(f17 + Math_fround(f31 * f32));
   f23 = Math_fround(f23 + Math_fround(f33 * Math_fround(HEAPF32[i39 + 92 >> 2])));
   i40 = i40 + 1 | 0;
   if (i40 >>> 0 >= i38 >>> 0) {
    i37 = i18;
    break;
   } else i39 = i39 + i37 | 0;
  }
 }
 f26 = Math_fround(HEAPF32[i41 + 112 >> 2]);
 f25 = Math_fround(HEAPF32[i41 + 116 >> 2]);
 f24 = Math_fround(HEAPF32[i41 + 120 >> 2]);
 f22 = Math_fround(HEAPF32[i41 + 124 >> 2]);
 f21 = Math_fround(HEAPF32[i41 + 96 >> 2]);
 f59 = Math_fround(HEAPF32[i41 + 100 >> 2]);
 f58 = Math_fround(HEAPF32[i41 + 104 >> 2]);
 f57 = Math_fround(HEAPF32[i41 + 108 >> 2]);
 f32 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f32 * f21);
 f54 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f54 * f59);
 f52 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f52 * f58);
 f50 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f50 * f57);
 f33 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f55 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f53 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f5 - Math_fround(f31 - Math_fround(f33 * f26)));
 f30 = Math_fround(f12 - Math_fround(f30 - Math_fround(f55 * f25)));
 f29 = Math_fround(f15 - Math_fround(f29 - Math_fround(f53 * f24)));
 f27 = Math_fround(f19 - Math_fround(f27 - Math_fround(f51 * f22)));
 f61 = Math_fround(HEAPF32[i41 + 80 >> 2]);
 f60 = Math_fround(HEAPF32[i41 + 84 >> 2]);
 f19 = Math_fround(HEAPF32[i41 + 88 >> 2]);
 f5 = Math_fround(HEAPF32[i41 + 92 >> 2]);
 f28 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f28 * f26);
 f56 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f56 * f25);
 f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f15 * f24);
 f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f8 - Math_fround(f26 - Math_fround(f32 * f61)));
 f25 = Math_fround(f13 - Math_fround(f25 - Math_fround(f54 * f60)));
 f24 = Math_fround(f16 - Math_fround(f24 - Math_fround(f52 * f19)));
 f22 = Math_fround(f20 - Math_fround(Math_fround(f12 * f22) - Math_fround(f50 * f5)));
 f21 = Math_fround(f9 - Math_fround(Math_fround(f33 * f61) - Math_fround(f28 * f21)));
 f20 = Math_fround(f14 - Math_fround(Math_fround(f55 * f60) - Math_fround(f56 * f59)));
 f19 = Math_fround(f17 - Math_fround(Math_fround(f53 * f19) - Math_fround(f15 * f58)));
 f5 = Math_fround(f23 - Math_fround(Math_fround(f51 * f5) - Math_fround(f12 * f57)));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f55 * f55)) + Math_fround(f54 * f54))));
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f53 * f53)) + Math_fround(f52 * f52))));
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f51 * f51)) + Math_fround(f50 * f50))));
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f30 * f30) + Math_fround(f25 * f25)))));
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f29 * f29) + Math_fround(f24 * f24)))));
 f23 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f27 * f27) + Math_fround(f22 * f22)))));
 f14 = Math_fround(HEAPF32[i41 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i41 + 24 >> 2]);
 i18 = f16 > Math_fround(HEAPF32[i41 + 28 >> 2]);
 f16 = Math_fround(HEAPF32[i41 + 36 >> 2]);
 f17 = Math_fround(HEAPF32[i41 + 40 >> 2]);
 i18 = i18 | f23 > Math_fround(HEAPF32[i41 + 44 >> 2]);
 if (i43) {
  f61 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f31 * f31) + Math_fround(f26 * f26)))));
  i43 = f61 > Math_fround(HEAPF32[i41 + 32 >> 2]);
  f61 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f33 * f33)) + Math_fround(f32 * f32))));
  i43 = i43 | f61 > Math_fround(HEAPF32[i41 + 16 >> 2]);
  HEAP32[i47 >> 2] = i10;
  HEAP32[i47 + 4 >> 2] = i11;
  HEAP32[i47 + 8 >> 2] = i36;
  HEAPF32[i47 + 16 >> 2] = f31;
  HEAPF32[i47 + 20 >> 2] = f26;
  HEAPF32[i47 + 24 >> 2] = f21;
  HEAP32[i47 + 12 >> 2] = i43 & 1;
 }
 if (i44) {
  HEAP32[i48 >> 2] = i6;
  HEAP32[i48 + 4 >> 2] = i7;
  HEAP32[i48 + 8 >> 2] = i35;
  HEAPF32[i48 + 16 >> 2] = f30;
  HEAPF32[i48 + 20 >> 2] = f25;
  HEAPF32[i48 + 24 >> 2] = f20;
  HEAP32[i48 + 12 >> 2] = (f8 > f14 | f12 > f16) & 1;
 }
 if (i45) {
  HEAP32[i49 >> 2] = i3;
  HEAP32[i49 + 4 >> 2] = i4;
  HEAP32[i49 + 8 >> 2] = i34;
  HEAPF32[i49 + 16 >> 2] = f29;
  HEAPF32[i49 + 20 >> 2] = f24;
  HEAPF32[i49 + 24 >> 2] = f19;
  HEAP32[i49 + 12 >> 2] = (f9 > f15 | f13 > f17) & 1;
 }
 if (!i46) return;
 HEAP32[i42 >> 2] = i1;
 HEAP32[i42 + 4 >> 2] = i2;
 HEAP32[i42 + 8 >> 2] = i37;
 HEAPF32[i42 + 16 >> 2] = f27;
 HEAPF32[i42 + 20 >> 2] = f22;
 HEAPF32[i42 + 24 >> 2] = f5;
 HEAP32[i42 + 12 >> 2] = i18 & 1;
 return;
}

function __ZN9Animation7AddClipER13AnimationClipRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEiib(i17, i6, i14, i7, i8, i9) {
 i17 = i17 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, d24 = 0.0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 40 | 0;
 i1 = i20;
 i18 = i20 + 24 | 0;
 i4 = i20 + 8 | 0;
 i11 = i20 + 16 | 0;
 if ((HEAP16[gb + 1467040 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = i17;
  HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467040 | 0, i15);
  i16 = gb + 1467040 | 0;
 } else i16 = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 116 >> 2] | 0, i6 | 0) | 0) {
  i5 = (i8 | 0) != 2147483647 | ((i7 | 0) != -2147483648 | i9);
  if (i5) {
   i1 = i14 + 11 | 0;
   i19 = 9;
  } else {
   i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
   i3 = _strlen(i2) | 0;
   i1 = i14 + 11 | 0;
   i13 = HEAP8[i1 >> 0] | 0;
   if ((i3 | 0) == ((i13 << 24 >> 24 < 0 ? HEAP32[i14 + 4 >> 2] | 0 : i13 & 255) | 0)) {
    if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i14, 0, -1, i2, i3) | 0) i19 = 9;
   } else i19 = 9;
  }
  if ((i19 | 0) == 9) {
   i10 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(296, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 896407 | 0, 2090) | 0;
   i3 = gb + 63520 | 0;
   i12 = HEAP32[i3 + 4 >> 2] | 0;
   i13 = i4;
   HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode(i10, i15, 0);
   __Z19pop_allocation_rootv();
   i10 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i10) | 0;
   __Z14CopySerializedRK6ObjectRS_(i6, i10);
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, ((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0);
   if (i5) {
    __ZN13AnimationClip11ClearCurvesEv(i10);
    i13 = i6 + 88 | 0;
    f23 = Math_fround(HEAPF32[i13 >> 2]);
    f21 = Math_fround(Math_fround(i7 | 0) / f23);
    f22 = Math_fround(Math_fround(i8 | 0) / f23);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = f21 > f22;
    f22 = (HEAP32[tempDoublePtr >> 2] = i7 ? i12 : i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = (HEAP32[tempDoublePtr >> 2] = i7 ? i8 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    __Z14ClipAnimationsI11QuaternionfN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i6 + 100 | 0, f22, f21, f23, i9, i10 + 100 | 0);
    __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i6 + 116 | 0, f22, f21, Math_fround(HEAPF32[i13 >> 2]), i9, i10 + 116 | 0);
    __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i6 + 132 | 0, f22, f21, Math_fround(HEAPF32[i13 >> 2]), i9, i10 + 132 | 0);
    __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i6 + 148 | 0, f22, f21, Math_fround(HEAPF32[i13 >> 2]), i9, i10 + 148 | 0);
    __Z14ClipAnimationsIfN13AnimationClip10FloatCurveE13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRS9_(i6 + 164 | 0, f22, f21, Math_fround(HEAPF32[i13 >> 2]), i9, i10 + 164 | 0);
   }
   i7 = i17 + 300 | 0;
   if (!i10) i8 = 0; else i8 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i8;
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i17 + 304 >> 2] | 0;
   i1 = i6 - i2 >> 2;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i13 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i13 << 2) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i8 | 0);
     i4 = i4 + 4 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i13 | 0 : i13;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   i2 = i1;
   if ((i1 | 0) == (i6 | 0)) i19 = 17; else if ((i8 | 0) < (HEAP32[i1 >> 2] | 0)) i19 = 17;
   if ((i19 | 0) == 17) {
    HEAP32[i18 >> 2] = i2;
    HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
    __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i7, i15, i11) | 0;
   }
   i6 = i10;
  }
  i8 = i17 + 284 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i9 = i17 + 288 | 0;
  L28 : do if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) i19 = 34; else {
   i5 = i14 + 11 | 0;
   i7 = i14 + 4 | 0;
   i4 = i1;
   L30 : while (1) {
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i18 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i19 = 27; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i18);
       i2 = HEAP32[i15 >> 2] | 0;
       i13 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i19 = 27; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i19 = 29;
      }
     }
     if ((i19 | 0) == 27) i19 = 29;
     if ((i19 | 0) == 29) {
      i19 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i2 = _strlen(i1) | 0;
     i13 = HEAP8[i5 >> 0] | 0;
     if ((i2 | 0) == ((i13 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i13 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i14, 0, -1, i1, i2) | 0)) break L30;
    } while (0);
    i1 = i4 + 4 | 0;
    if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
     i19 = 34;
     break L28;
    } else i4 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i4 | 0) == (i1 | 0)) i19 = 34; else {
    if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
    HEAP32[i4 >> 2] = i1;
   }
  } while (0);
  if ((i19 | 0) == 34) {
   if (!i6) i2 = 0; else i2 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i15 >> 2] = i2;
   if ((i1 | 0) == (HEAP32[i17 + 292 >> 2] | 0)) __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i15); else {
    HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = i1 + 4;
   }
  }
  i12 = i17 + 104 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i13 = i17 + 108 | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  i2 = i9;
  if ((i1 | 0) != (i9 | 0)) {
   i10 = i17 + 252 | 0;
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
   i10 = HEAP8[i14 + 11 >> 0] | 0;
   i11 = i10 << 24 >> 24 < 0;
   i10 = i11 ? HEAP32[i14 + 4 >> 2] | 0 : i10 & 255;
   i11 = i11 ? HEAP32[i14 >> 2] | 0 : i14;
   do {
    i8 = HEAP32[i1 >> 2] | 0;
    i4 = i8 + 112 | 0;
    i7 = HEAP8[i4 + 11 >> 0] | 0;
    i3 = i7 << 24 >> 24 < 0;
    if (i3) i5 = HEAP32[i8 + 116 >> 2] | 0; else i5 = i7 & 255;
    if ((i5 | 0) == (i10 | 0)) {
     if (i3) {
      i4 = HEAP32[i4 >> 2] | 0;
      i3 = HEAP32[i8 + 116 >> 2] | 0;
     } else i3 = i7 & 255;
     if (!(_strncmp(i4, i11, i3) | 0)) {
      i19 = 53;
      break;
     }
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i9 | 0));
   if ((i19 | 0) == 53) {
    if (i8) {
     __ZN14AnimationStateD2Ev(i8);
     __ZdlPv(i8);
     i2 = HEAP32[i13 >> 2] | 0;
    }
    i3 = i1 + 4 | 0;
    i4 = i2 - i3 | 0;
    i5 = i4 >> 2;
    if (i5) {
     _memmove(i1 | 0, i3 | 0, i4 | 0) | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
    i1 = i1 + (i5 << 2) | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   }
   i1 = __Znwj(160) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
   HEAP32[i1 + 100 >> 2] = 0;
   HEAP32[i1 + 104 >> 2] = 0;
   HEAP32[i1 + 108 >> 2] = i1;
   i2 = i1 + 112 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i1 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i2 = i1 + 128 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i1 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i2 = i1 + 148 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 + 152 >> 2] = 0;
   HEAP32[i1 + 144 >> 2] = i2;
   HEAP32[i1 + 96 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i2 = i1 + 56 | 0;
   HEAP16[i2 >> 1] = HEAP16[i2 >> 1] & -257;
   HEAP32[i15 >> 2] = i1;
   i2 = HEAP32[i13 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i17 + 112 >> 2] | 0)) {
    __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i15);
    i1 = HEAP32[i13 >> 2] | 0;
   } else {
    HEAP32[i2 >> 2] = i1;
    i1 = (HEAP32[i13 >> 2] | 0) + 4 | 0;
    HEAP32[i13 >> 2] = i1;
   }
   i5 = HEAP32[i1 + -4 >> 2] | 0;
   i4 = HEAP8[i14 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
   i4 = i1 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 + 12 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
    i1 = HEAP32[i18 + 12 >> 2] | 0;
    i19 = 66;
   } else if (i4 >>> 0 < 11) {
    i1 = i18 + 11 | 0;
    HEAP8[i1 >> 0] = i4;
    if (!i4) i2 = i18; else {
     i2 = i18;
     i19 = 68;
    }
   } else i19 = 66;
   if ((i19 | 0) == 66) {
    i14 = i4 + 16 & -16;
    HEAP32[i15 >> 2] = 66;
    HEAP32[i15 + 4 >> 2] = i1;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i18 >> 2] = i2;
    HEAP32[i18 + 8 >> 2] = i14 | -2147483648;
    HEAP32[i18 + 4 >> 2] = i4;
    i1 = i18 + 11 | 0;
    i19 = 68;
   }
   if ((i19 | 0) == 68) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i2 + i4 >> 0] = 0;
   d24 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
   i19 = HEAP32[i6 + 96 >> 2] | 0;
   __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib(i5, i18, i6, d24, (i19 | 0) == 0 ? HEAP32[i17 + 36 >> 2] | 0 : i19, 0);
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    i19 = HEAP32[i18 >> 2] | 0;
    i18 = HEAP32[i18 + 12 >> 2] | 0;
    HEAP32[i15 >> 2] = 66;
    HEAP32[i15 + 4 >> 2] = i18;
    __Z19free_alloc_internalPvRK10MemLabelId(i19, i15);
   }
  }
 } else {
  i18 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
  i19 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] | 0, i17 | 0) | 0;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i1 + 4 >> 2] = i19;
  __Z6FormatPKcz(i15, gb + 896682 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 896407 | 0, 2019, 512, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 }
 if (!i16) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i20;
 return;
}

function __ZNK14dtNavMeshQuery16moveAlongSurfaceEyPKfS1_PK13dtQueryFilterPfPyPii(i41, i7, i8, i9, i45, i6, i50, i48, i51, i49) {
 i41 = i41 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i45 = i45 | 0;
 i6 = i6 | 0;
 i50 = i50 | 0;
 i48 = i48 | 0;
 i51 = i51 | 0;
 i49 = i49 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0, i52 = 0, f53 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i52 + 264 | 0;
 i43 = i52 + 192 | 0;
 i44 = i52;
 HEAP32[i51 >> 2] = 0;
 if ((i7 | 0) == 0 & (i8 | 0) == 0) {
  i51 = -2147483640;
  STACKTOP = i52;
  return i51 | 0;
 }
 i2 = HEAP32[i41 >> 2] | 0;
 i3 = _bitshift64Lshr(i7 | 0, i8 | 0, 48) | 0;
 getTempRet0() | 0;
 i4 = _bitshift64Lshr(i7 | 0, i8 | 0, 20) | 0;
 getTempRet0() | 0;
 i4 = i4 & 268435455;
 i5 = i7 & 65535;
 if ((i7 & 983040 | 0) == 65536 & 0 == 0) {
  if (i5 >>> 0 >= (HEAP32[i2 + 44 >> 2] | 0) >>> 0) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  if ((HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + (i5 * 104 | 0) + 92 >> 2] | 0) != (i3 | 0)) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  if (i5 >>> 0 > (HEAP32[i2 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
   i1 = HEAP32[i2 + 48 >> 2] | 0;
   if ((i1 + (i5 * 104 | 0) | 0) == 0 ? 1 : (i3 | 0) != (HEAP32[i1 + (i5 * 104 | 0) + 92 >> 2] | 0)) i1 = 0; else i1 = HEAP32[i1 + (i5 * 104 | 0) + 76 >> 2] | 0;
  }
 } else {
  if (i4 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  if ((HEAP32[i1 + (i4 * 56 | 0) + 4 >> 2] | 0) != (i3 | 0)) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  i1 = HEAP32[i1 + (i4 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  if (i5 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i51 = -2147483640;
   STACKTOP = i52;
   return i51 | 0;
  }
  if (i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   i2 = HEAP32[i2 + 20 >> 2] | 0;
   if ((HEAP32[i2 + (i4 * 56 | 0) + 4 >> 2] | 0) == (i3 | 0)) {
    i1 = HEAP32[i2 + (i4 * 56 | 0) + 8 >> 2] | 0;
    if (!i1) i1 = 0; else if (i5 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) i1 = HEAP32[(HEAP32[i2 + (i4 * 56 | 0) + 16 >> 2] | 0) + (i5 << 5) + 24 >> 2] | 0; else i1 = 0;
   } else i1 = 0;
  } else i1 = 0;
 }
 i39 = i6 + 128 | 0;
 if (!(HEAP32[i39 >> 2] & i1)) {
  i51 = -2147483648;
  STACKTOP = i52;
  return i51 | 0;
 }
 i46 = i41 + 72 | 0;
 i34 = HEAP32[i46 >> 2] | 0;
 _memset(HEAP32[i34 + 4 >> 2] | 0, -1, HEAP32[i34 + 16 >> 2] << 1 | 0) | 0;
 HEAP32[i34 + 20 >> 2] = 0;
 i34 = __ZN10dtNodePool7getNodeEy(HEAP32[i46 >> 2] | 0, i7, i8) | 0;
 HEAPF32[i34 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i34 + 16 >> 2] = Math_fround(0.0);
 i33 = i34 + 24 | 0;
 HEAP32[i33 >> 2] = i7;
 HEAP32[i33 + 4 >> 2] = i8;
 HEAP32[i34 + 20 >> 2] = -2147483648;
 HEAP32[i42 >> 2] = i34;
 i33 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = HEAP32[i9 + 8 >> 2] | 0;
 f35 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f35);
 f35 = Math_fround(f35 + Math_fround(f29 * Math_fround(.5)));
 f14 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i40 = i45 + 4 | 0;
 f14 = Math_fround(Math_fround(HEAPF32[i40 >> 2]) - f14);
 f37 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i36 = i45 + 8 | 0;
 f38 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f37);
 f37 = Math_fround(f37 + Math_fround(f38 * Math_fround(.5)));
 f38 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f14 * f14)) + Math_fround(f38 * f38)))) * Math_fround(.5)) + Math_fround(.00100000005));
 f38 = Math_fround(f38 * f38);
 i1 = 1;
 f14 = Math_fround(3402823469999999843913219.0e14);
 i2 = 0;
 i9 = i33;
 L35 : while (1) {
  i4 = i1 + -1 | 0;
  if ((i1 | 0) > 1) {
   i1 = 0;
   do {
    i33 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i42 + (i33 << 2) >> 2] = HEAP32[i42 + (i1 << 2) >> 2];
   } while ((i1 | 0) != (i4 | 0));
  }
  i33 = i34 + 24 | 0;
  i33 = __ZNK9dtNavMesh15getPolyGeometryEyPfPyi(HEAP32[i41 >> 2] | 0, HEAP32[i33 >> 2] | 0, HEAP32[i33 + 4 >> 2] | 0, i43, i44, 4) | 0;
  if (!i33) {
   f10 = f14;
   i1 = i4;
  } else {
   if ((i33 | 0) <= 0) {
    i47 = 26;
    break;
   }
   i32 = i43 + ((i33 * 3 | 0) + -3 << 2) | 0;
   f10 = Math_fround(HEAPF32[i45 >> 2]);
   f11 = Math_fround(HEAPF32[i36 >> 2]);
   f12 = Math_fround(HEAPF32[i32 >> 2]);
   i1 = 0;
   f13 = Math_fround(HEAPF32[i32 + 8 >> 2]);
   while (1) {
    i32 = i43 + (i1 * 3 << 2) | 0;
    f15 = f12;
    f12 = Math_fround(HEAPF32[i32 >> 2]);
    f29 = Math_fround(f12 - f15);
    f16 = f13;
    f13 = Math_fround(HEAPF32[i32 + 8 >> 2]);
    if (Math_fround(Math_fround(f10 - f15) * Math_fround(f13 - f16)) < Math_fround(Math_fround(f11 - f16) * f29)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i33 | 0)) {
     i47 = 27;
     break L35;
    }
   }
   i31 = (i34 | 0) == 0;
   i32 = i34;
   i30 = 0;
   i3 = i33 + -1 | 0;
   i1 = i4;
   f29 = f14;
   while (1) {
    i24 = i44 + (i3 << 2 << 3) | 0;
    i27 = i43 + (i3 * 3 << 2) | 0;
    i28 = i43 + (i30 * 3 << 2) | 0;
    i25 = i28 + 8 | 0;
    i26 = i27 + 8 | 0;
    i23 = 0;
    i3 = 0;
    do {
     i6 = i24 + (i23 << 3) | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     if ((i4 | 0) == 0 & (i6 | 0) == 0) break;
     i20 = __ZN10dtNodePool7getNodeEy(HEAP32[i46 >> 2] | 0, i4, i6) | 0;
     if (i20) {
      i21 = i20 + 20 | 0;
      i22 = HEAP32[i21 >> 2] | 0;
      if ((i22 | 0) >= 0) {
       i17 = HEAP32[i41 >> 2] | 0;
       if ((i4 & 983040 | 0) == 65536 & 0 == 0) {
        i5 = i4 & 65535;
        if (i5 >>> 0 > (HEAP32[i17 + 44 >> 2] | 0) >>> 0) i4 = 0; else {
         i19 = _bitshift64Lshr(i4 | 0, i6 | 0, 48) | 0;
         getTempRet0() | 0;
         i4 = HEAP32[i17 + 48 >> 2] | 0;
         if ((i4 + (i5 * 104 | 0) | 0) == 0 ? 1 : (i19 | 0) != (HEAP32[i4 + (i5 * 104 | 0) + 92 >> 2] | 0)) i4 = 0; else i4 = HEAP32[i4 + (i5 * 104 | 0) + 76 >> 2] | 0;
        }
       } else {
        i18 = _bitshift64Lshr(i4 | 0, i6 | 0, 20) | 0;
        getTempRet0() | 0;
        i18 = i18 & 268435455;
        i19 = i4 & 65535;
        if (i18 >>> 0 < (HEAP32[i17 + 16 >> 2] | 0) >>> 0) {
         i6 = _bitshift64Lshr(i4 | 0, i6 | 0, 48) | 0;
         getTempRet0() | 0;
         i4 = HEAP32[i17 + 20 >> 2] | 0;
         if ((HEAP32[i4 + (i18 * 56 | 0) + 4 >> 2] | 0) == (i6 | 0)) {
          i5 = HEAP32[i4 + (i18 * 56 | 0) + 8 >> 2] | 0;
          if (!i5) i4 = 0; else if (i19 >>> 0 < (HEAP32[i5 + 20 >> 2] | 0) >>> 0) i4 = HEAP32[(HEAP32[i4 + (i18 * 56 | 0) + 16 >> 2] | 0) + (i19 << 5) + 24 >> 2] | 0; else i4 = 0;
         } else i4 = 0;
        } else i4 = 0;
       }
       if (HEAP32[i39 >> 2] & i4) {
        f10 = Math_fround(HEAPF32[i28 >> 2]);
        f12 = Math_fround(HEAPF32[i27 >> 2]);
        f10 = Math_fround(f10 - f12);
        f11 = Math_fround(HEAPF32[i25 >> 2]);
        f13 = Math_fround(HEAPF32[i26 >> 2]);
        f11 = Math_fround(f11 - f13);
        f12 = Math_fround(f35 - f12);
        f13 = Math_fround(f37 - f13);
        f14 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
        if (f14 == Math_fround(0.0)) f10 = Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)); else {
         f15 = Math_fround(Math_fround(Math_fround(f10 * f12) + Math_fround(f11 * f13)) / f14);
         i19 = f15 < Math_fround(0.0);
         i18 = f15 > Math_fround(1.0);
         f15 = i18 ? Math_fround(1.0) : f15;
         f15 = i19 ? Math_fround(0.0) : f15;
         f16 = Math_fround(Math_fround(f10 * f15) - f12);
         f10 = Math_fround(Math_fround(f11 * f15) - f13);
         f10 = Math_fround(Math_fround(f16 * f16) + Math_fround(f10 * f10));
        }
        if (!(f10 > f38)) {
         if ((i1 | 0) < 48) {
          if (i31) i4 = 0; else i4 = (i32 - (HEAP32[HEAP32[i46 >> 2] >> 2] | 0) >> 5) + 1 | 0;
          HEAP32[i21 >> 2] = i4 & 1073741823 | i22 & 1073741824 | -2147483648;
          HEAP32[i42 + (i1 << 2) >> 2] = i20;
          i1 = i1 + 1 | 0;
         }
         i3 = i3 + 1 | 0;
        }
       }
      }
     }
     i23 = i23 + 1 | 0;
    } while ((i23 | 0) < 4);
    if (!i3) {
     f16 = Math_fround(HEAPF32[i28 >> 2]);
     f15 = Math_fround(HEAPF32[i27 >> 2]);
     f16 = Math_fround(f16 - f15);
     f14 = Math_fround(HEAPF32[i25 >> 2]);
     f13 = Math_fround(HEAPF32[i26 >> 2]);
     f14 = Math_fround(f14 - f13);
     f10 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f15);
     f11 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f13);
     f12 = Math_fround(Math_fround(f16 * f16) + Math_fround(f14 * f14));
     if (f12 == Math_fround(0.0)) {
      f10 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
      f11 = Math_fround(0.0);
     } else {
      f12 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f14 * f11)) / f12);
      i26 = f12 < Math_fround(0.0);
      i25 = f12 > Math_fround(1.0);
      f12 = i25 ? Math_fround(1.0) : f12;
      f12 = i26 ? Math_fround(0.0) : f12;
      f53 = Math_fround(Math_fround(f16 * f12) - f10);
      f10 = Math_fround(Math_fround(f14 * f12) - f11);
      f10 = Math_fround(Math_fround(f53 * f53) + Math_fround(f10 * f10));
      f11 = f12;
     }
     if (f10 < f29) {
      f53 = Math_fround(f15 + Math_fround(f11 * f16));
      i9 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
      f53 = Math_fround(HEAPF32[i27 + 4 >> 2]);
      f53 = Math_fround(f53 + Math_fround(f11 * Math_fround(Math_fround(HEAPF32[i28 + 4 >> 2]) - f53)));
      i7 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
      f53 = Math_fround(f13 + Math_fround(f11 * f14));
      i2 = i34;
      i8 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
     } else f10 = f29;
    } else f10 = f29;
    i3 = i30 + 1 | 0;
    if ((i3 | 0) == (i33 | 0)) break; else {
     i28 = i30;
     i30 = i3;
     f29 = f10;
     i3 = i28;
    }
   }
  }
  if (!i1) break;
  f14 = f10;
  i34 = HEAP32[i42 >> 2] | 0;
 }
 if ((i47 | 0) == 26) {
  i3 = HEAP32[i36 >> 2] | 0;
  i1 = HEAP32[i45 >> 2] | 0;
  i47 = 28;
 } else if ((i47 | 0) == 27) {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i47 = 28;
 }
 if ((i47 | 0) == 28) {
  i2 = i34;
  i9 = i1;
  i8 = i3;
  i7 = HEAP32[i40 >> 2] | 0;
 }
 L96 : do if (!i2) {
  i1 = 0;
  i2 = 1073741824;
 } else {
  i4 = 0;
  while (1) {
   i5 = i2 + 20 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i1 = i6 & 1073741823;
   if (!i1) i3 = 0; else i3 = (HEAP32[HEAP32[i46 >> 2] >> 2] | 0) + (i1 + -1 << 5) | 0;
   if (!i4) i1 = 0; else i1 = (i4 - (HEAP32[HEAP32[i46 >> 2] >> 2] | 0) >> 5) + 1 | 0;
   HEAP32[i5 >> 2] = i6 & -1073741824 | i1 & 1073741823;
   if (!i3) {
    i3 = 0;
    break;
   } else {
    i4 = i2;
    i2 = i3;
   }
  }
  while (1) {
   i44 = i2 + 24 | 0;
   i45 = HEAP32[i44 + 4 >> 2] | 0;
   i1 = i3 + 1 | 0;
   i47 = i48 + (i3 << 3) | 0;
   HEAP32[i47 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i47 + 4 >> 2] = i45;
   if ((i1 | 0) >= (i49 | 0)) {
    i2 = 1073741840;
    break L96;
   }
   i2 = HEAP32[i2 + 20 >> 2] & 1073741823;
   if (!i2) {
    i2 = 1073741824;
    break L96;
   }
   i2 = (HEAP32[HEAP32[i46 >> 2] >> 2] | 0) + (i2 + -1 << 5) | 0;
   if (!i2) {
    i2 = 1073741824;
    break;
   } else i3 = i1;
  }
 } while (0);
 HEAP32[i50 >> 2] = i9;
 HEAP32[i50 + 4 >> 2] = i7;
 HEAP32[i50 + 8 >> 2] = i8;
 HEAP32[i51 >> 2] = i1;
 i51 = i2;
 STACKTOP = i52;
 return i51 | 0;
}

function __Z21ExpandQuaternionCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i7 = HEAP32[i8 + 164 >> 2] | 0;
 i6 = i7 << 4;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i12;
  break;
 } while (0);
 i10 = i9 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i12;
  break;
 } while (0);
 i11 = i9 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i12;
  break;
 } while (0);
 i12 = i9 + 12 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i6;
  break;
 } while (0);
 if ((i7 | 0) > 0) {
  i2 = i8 + 152 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[i2 >> 2] | 0;
   i13 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
   i3 = i5 + (i1 * 52 | 0) + 4 | 0;
   i4 = i5 + (i1 * 52 | 0) + 20 | 0;
   i5 = i5 + (i1 * 52 | 0) + 36 | 0;
   i16 = HEAP32[i3 >> 2] | 0;
   i15 = HEAP32[i4 >> 2] | 0;
   i14 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = i13;
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i16;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i15;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i14;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i14 = HEAP32[i4 + 4 >> 2] | 0;
   i15 = HEAP32[i5 + 4 >> 2] | 0;
   i16 = HEAP32[(HEAP32[i10 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i16 + (i1 << 4) >> 2] = i13;
   HEAP32[i16 + (i1 << 4) + 4 >> 2] = i6;
   HEAP32[i16 + (i1 << 4) + 8 >> 2] = i14;
   HEAP32[i16 + (i1 << 4) + 12 >> 2] = i15;
   i16 = HEAP32[i3 + 8 >> 2] | 0;
   i15 = HEAP32[i4 + 8 >> 2] | 0;
   i14 = HEAP32[i5 + 8 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = i13;
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i16;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i15;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i14;
   i3 = HEAP32[i3 + 12 >> 2] | 0;
   i4 = HEAP32[i4 + 12 >> 2] | 0;
   i5 = HEAP32[i5 + 12 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i12 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = i13;
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i3;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i4;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 i2 = HEAP32[i8 + 172 >> 2] | 0;
 i1 = HEAP32[i8 + 176 >> 2] | 0;
 i8 = HEAP32[i8 + 180 >> 2] | 0;
 switch (i2 | 0) {
 case 1:
  {
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 1;
   i3 = i2 + 4 | 0;
   i4 = i2 + 32 | 0;
   i5 = i2 + 28 | 0;
   if ((i1 | 0) == 1) {
    HEAP32[i2 + 80 >> 2] = 1;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    HEAP32[i2 + 84 >> 2] = i8;
    i16 = HEAP32[i10 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = 1;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    i16 = HEAP32[i11 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = 1;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    i16 = HEAP32[i12 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = 1;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    return;
   } else {
    i15 = (i1 | 0) == 3 ? 3 : (i1 | 0) == 0 ? 0 : 2;
    HEAP32[i2 + 80 >> 2] = i15;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    HEAP32[i2 + 84 >> 2] = i8;
    i16 = HEAP32[i10 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = i15;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    i16 = HEAP32[i11 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = i15;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    i16 = HEAP32[i12 >> 2] | 0;
    HEAP32[i16 + 76 >> 2] = 1;
    HEAP32[i16 + 80 >> 2] = i15;
    HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
    HEAP32[i16 >> 2] = 0;
    HEAPF32[i16 + 32 >> 2] = Math_fround(inf);
    HEAP32[i16 + 28 >> 2] = 0;
    HEAP32[i16 + 84 >> 2] = i8;
    return;
   }
  }
 case 0:
  {
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 0;
   i3 = i2 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   i4 = i2 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i2 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i2 + 80 >> 2] = i1;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i2 + 84 >> 2] = i8;
   return;
  }
 default:
  {
   i6 = HEAP32[i9 >> 2] | 0;
   i7 = (i2 | 0) == 3 ? 3 : 2;
   HEAP32[i6 + 76 >> 2] = i7;
   i3 = i6 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i4 = i6 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i6 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i6 + 80 >> 2] = i2;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 + 84 >> 2] = i8;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = i7;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = i7;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i5 = HEAP32[i12 >> 2] | 0;
   HEAP32[i5 + 76 >> 2] = i7;
   i2 = i5 + 4 | 0;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   i3 = i5 + 32 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   i4 = i5 + 28 | 0;
   HEAP32[i4 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i5 + 80 >> 2] = i1;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 + 84 >> 2] = i8;
   return;
  }
 }
}

function __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i(i25, i34, i35, i36) {
 i25 = i25 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i39 + 8 | 0;
 i28 = i39;
 i37 = i39 + 52 | 0;
 i38 = i39 + 32 | 0;
 i33 = HEAP32[i25 >> 2] | 0;
 i22 = i33 + 16 | 0;
 i24 = i25 + 24 | 0;
 i23 = i25 + 4 | 0;
 __ZN21TreeBinaryTreeBuilder15CalculateBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERKNS1_IN12TreeDatabase9PrototypeENS3_ISD_EEEERK8Vector3fSK_(i26, i22, i23, i33 + 28 | 0, i34, i35);
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
 i24 = i25 + 16 | 0;
 if ((HEAP32[i24 >> 2] | 0) <= (i36 | 0)) {
  STACKTOP = i39;
  return;
 }
 __ZN21TreeBinaryTreeBuilder18CalculatePosBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERK8Vector3fSE_(i26, i22, i23, i34, i35);
 f5 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i26 >> 2]);
 f9 = Math_fround(f5 - f6);
 i1 = i26 + 16 | 0;
 i2 = i26 + 4 | 0;
 f7 = Math_fround(HEAPF32[i26 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f9 = Math_fround(f9 * Math_fround(.5));
 f10 = Math_fround(Math_fround(f7 - f8) * Math_fround(.5));
 i33 = f9 < Math_fround(0.0);
 f40 = Math_fround(-f9);
 if ((i33 ? f40 : f9) <= Math_fround(9.99999997e-07)) {
  i33 = f10 < Math_fround(0.0);
  f40 = Math_fround(-f10);
  if ((i33 ? f40 : f10) <= Math_fround(9.99999997e-07)) {
   STACKTOP = i39;
   return;
  }
 }
 f5 = Math_fround(f5 + f6);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 * Math_fround(.5));
 f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i2 >> 2])) * Math_fround(.5));
 f40 = Math_fround(Math_fround(f7 + f8) * Math_fround(.5));
 i21 = i25 + 64 | 0;
 i30 = f9 > f10 ? gb + 62524 | 0 : gb + 62548 | 0;
 HEAP32[i21 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 f10 = Math_fround(f5 * Math_fround(HEAPF32[i30 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i30 + 4 >> 2])));
 i20 = i25 + 76 | 0;
 HEAPF32[i20 >> 2] = Math_fround(-Math_fround(f10 + Math_fround(f40 * Math_fround(HEAPF32[i30 + 8 >> 2]))));
 i30 = gb + 63616 | 0;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i27 = i28;
 HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i27 + 4 >> 2] = i29;
 HEAP32[i37 >> 2] = 0;
 i27 = i37 + 12 | 0;
 HEAP32[i27 >> 2] = 0;
 i29 = i37 + 16 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i37 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i28);
 i31 = i26;
 i32 = HEAP32[i31 + 4 >> 2] | 0;
 i33 = i30;
 HEAP32[i33 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i33 + 4 >> 2] = i32;
 i33 = gb + 63616 | 0;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i31 = i28;
 HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i31 + 4 >> 2] = i32;
 HEAP32[i38 >> 2] = 0;
 i31 = i38 + 12 | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i38 + 16 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i38 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i28);
 i17 = i26;
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i19 = i33;
 HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 if (HEAP32[i24 >> 2] | 0) {
  i13 = i35 + 4 | 0;
  i14 = i35 + 8 | 0;
  i15 = i34 + 4 | 0;
  i16 = i34 + 8 | 0;
  i17 = i25 + 68 | 0;
  i18 = i25 + 72 | 0;
  i12 = 0;
  do {
   i19 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i12 << 2) >> 2] | 0;
   i11 = HEAP32[i22 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i11 + (i19 * 40 | 0) >> 2]);
   f9 = Math_fround(f9 * Math_fround(HEAPF32[i35 >> 2]));
   f10 = Math_fround(HEAPF32[i11 + (i19 * 40 | 0) + 4 >> 2]);
   f10 = Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2]));
   f40 = Math_fround(HEAPF32[i11 + (i19 * 40 | 0) + 8 >> 2]);
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i14 >> 2]));
   f9 = Math_fround(f9 + Math_fround(HEAPF32[i34 >> 2]));
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i15 >> 2]));
   f40 = Math_fround(f40 + Math_fround(HEAPF32[i16 >> 2]));
   f9 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
   f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2])));
   f40 = Math_fround(f10 + Math_fround(f40 * Math_fround(HEAPF32[i18 >> 2])));
   if (Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f40) > Math_fround(0.0)) {
    i2 = HEAP32[i27 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i29 >> 2] | 0;
    i11 = i4 & 2147483647;
    do if (i3 >>> 0 > i11 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i11 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i29 >> 2] = i1;
      HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i1 << 2, 4, i30, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i30, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i27 >> 2] << 2 | 0) | 0;
      HEAP32[i29 >> 2] = i1;
      HEAP32[i37 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i27 >> 2] = i3;
    HEAP32[(HEAP32[i37 >> 2] | 0) + (i2 << 2) >> 2] = i19;
   } else {
    i2 = HEAP32[i31 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i32 >> 2] | 0;
    i11 = i4 & 2147483647;
    do if (i3 >>> 0 > i11 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i11 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i32 >> 2] = i1;
      HEAP32[i38 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i38 >> 2] | 0, i1 << 2, 4, i33, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i33, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i38 >> 2] | 0, HEAP32[i31 >> 2] << 2 | 0) | 0;
      HEAP32[i32 >> 2] = i1;
      HEAP32[i38 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i31 >> 2] = i3;
    HEAP32[(HEAP32[i38 >> 2] | 0) + (i2 << 2) >> 2] = i19;
   }
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0);
 }
 if (!((HEAP32[i27 >> 2] | 0) == 0 | (HEAP32[i31 >> 2] | 0) == 0)) {
  i1 = i25 + 20 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i25 + 8 | 0);
   HEAP32[i23 >> 2] = 0;
  }
  HEAP32[i23 >> 2] = 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = __Znwj(88) | 0;
  HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
  i12 = gb + 63616 | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i24 = i28;
  HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i24 + 4 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i28);
  i24 = i26;
  i2 = HEAP32[i24 + 4 >> 2] | 0;
  i12 = i1 + 8 | 0;
  HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i12 + 4 >> 2] = i2;
  i12 = i1 + 24 | 0;
  HEAP32[i12 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f40 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  HEAPF32[i1 + 36 >> 2] = f9;
  HEAPF32[i1 + 40 >> 2] = f10;
  HEAPF32[i1 + 44 >> 2] = f40;
  i12 = i1 + 48 | 0;
  HEAP32[i1 + 80 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  i12 = i25 + 80 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) {
   __ZN14TreeBinaryTreeD2Ev(i2);
   __ZdlPv(i2);
  }
  HEAP32[i12 >> 2] = i1;
  i2 = __Znwj(88) | 0;
  HEAP32[i2 >> 2] = HEAP32[i25 >> 2];
  i24 = gb + 63616 | 0;
  i11 = HEAP32[i24 + 4 >> 2] | 0;
  i1 = i28;
  HEAP32[i1 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i1 + 4 >> 2] = i11;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i28);
  i28 = i26;
  i1 = HEAP32[i28 + 4 >> 2] | 0;
  i11 = i2 + 8 | 0;
  HEAP32[i11 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i11 + 4 >> 2] = i1;
  i11 = i2 + 24 | 0;
  HEAP32[i11 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f40 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  HEAPF32[i2 + 36 >> 2] = f9;
  HEAPF32[i2 + 40 >> 2] = f10;
  HEAPF32[i2 + 44 >> 2] = f40;
  i11 = i2 + 48 | 0;
  HEAP32[i2 + 80 >> 2] = 0;
  HEAP32[i2 + 84 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  i11 = i25 + 84 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if (!((i1 | 0) == (i2 | 0) | (i1 | 0) == 0)) {
   __ZN14TreeBinaryTreeD2Ev(i1);
   __ZdlPv(i1);
  }
  HEAP32[i11 >> 2] = i2;
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i3 + 8 | 0, HEAP32[i37 + 8 >> 2] | 0);
  i1 = HEAP32[i37 >> 2] | 0;
  if (!i1) {
   i1 = i37;
   i2 = 0;
  } else {
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i30, HEAP32[i3 + 12 >> 2] | 0);
   i1 = i37;
   i2 = HEAP32[i37 >> 2] | 0;
  }
  i28 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i28;
  i4 = i3 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i27 >> 2] = i1;
  i1 = i3 + 20 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i29 >> 2] = i4;
  i3 = i3 + 8 | 0;
  i4 = i3;
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i27 = i30;
  i28 = HEAP32[i27 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i3 + 4 >> 2] = i28;
  i3 = i30;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i3 + 8 | 0, HEAP32[i38 + 8 >> 2] | 0);
  i1 = HEAP32[i38 >> 2] | 0;
  if (!i1) {
   i1 = i38;
   i2 = 0;
  } else {
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i33, HEAP32[i3 + 12 >> 2] | 0);
   i1 = i38;
   i2 = HEAP32[i38 >> 2] | 0;
  }
  i27 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i27;
  i27 = i3 + 16 | 0;
  i28 = HEAP32[i27 >> 2] | 0;
  HEAP32[i27 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i31 >> 2] = i28;
  i28 = i3 + 20 | 0;
  i31 = HEAP32[i28 >> 2] | 0;
  HEAP32[i28 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i32 >> 2] = i31;
  i31 = i3 + 8 | 0;
  i28 = i31;
  i27 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i25 = i33;
  i26 = HEAP32[i25 + 4 >> 2] | 0;
  HEAP32[i31 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i31 + 4 >> 2] = i26;
  i31 = i33;
  HEAP32[i31 >> 2] = i27;
  HEAP32[i31 + 4 >> 2] = i28;
  __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i(HEAP32[i12 >> 2] | 0, i34, i35, i36);
  __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i(HEAP32[i11 >> 2] | 0, i34, i35, i36);
 }
 if ((HEAP32[i32 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i33);
  HEAP32[i38 >> 2] = 0;
 }
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i30);
  HEAP32[i37 >> 2] = 0;
 }
 STACKTOP = i39;
 return;
}

function __ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_(i50, i6, i52, i53, i54) {
 i50 = i50 | 0;
 i6 = i6 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, i65 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 1872 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i60 + 1848 | 0;
 i55 = i60 + 1832 | 0;
 i56 = i60 + 1504 | 0;
 i57 = i60 + 1440 | 0;
 i58 = i60 + 1376 | 0;
 i8 = i60 + 1820 | 0;
 i51 = i60;
 if ((HEAP16[gb + 1110436 + 6 >> 1] | 0) > -1) {
  HEAP32[i55 >> 2] = i50;
  HEAP32[i49 >> 2] = HEAP32[i55 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110436 | 0, i49);
  i59 = gb + 1110436 | 0;
 } else i59 = 0;
 i3 = HEAP32[gb + 1110436 >> 2] | 0;
 i48 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i48 >> 2] | 0) + 648 >> 2] | 0, i48 | 0, i3 | 0);
 i3 = __Z12GetGfxDevicev() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 704 >> 2] | 0, i3 | 0) | 0;
 if (!i6) {
  i1 = 0;
  i7 = 5;
 } else {
  i48 = (HEAP32[i6 + 8 >> 2] | 0) >>> 21;
  i1 = (i48 - (HEAP32[gb + 29912 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29912 + 28 >> 2] | 0) >>> 0 ? i6 : 0;
  if ((i48 - (HEAP32[gb + 31392 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31392 + 28 >> 2] | 0) >>> 0) i48 = i6; else i7 = 5;
 }
 if ((i7 | 0) == 5) i48 = 0;
 i46 = HEAP32[gb + 1166248 >> 2] | 0;
 i47 = (i1 | 0) != 0;
 do if (i47) {
  if (!(HEAP8[i1 + 111 >> 0] | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376549 | 0, 0, gb + 375437 | 0, 1764, 1, 0, 0, 0);
   i1 = 0;
   break;
  }
  i4 = HEAP32[i1 + 52 >> 2] | 0;
  i5 = (i4 | 0) == 0;
  if (i5) {
   i2 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i7 = 33;
    break;
   }
  } else i2 = HEAP32[i4 + 36 >> 2] | 0;
  if ((i2 | 0) == 5) i7 = 33; else {
   if (i5) {
    i2 = HEAP32[i1 + 92 >> 2] | 0;
    if ((i2 | 0) == -1) i7 = 19; else i7 = 16;
   } else {
    i2 = HEAP32[i4 + 36 >> 2] | 0;
    i7 = 16;
   }
   if ((i7 | 0) == 16) {
    if ((i2 | 0) == 4) {
     i7 = 33;
     break;
    }
    if (i5) i7 = 19; else {
     i2 = HEAP32[i4 + 36 >> 2] | 0;
     i7 = 20;
    }
   }
   if ((i7 | 0) == 19) {
    i2 = HEAP32[i1 + 92 >> 2] | 0;
    if ((i2 | 0) != -1) i7 = 20;
   }
   if ((i7 | 0) == 20) if ((i2 | 0) == 3) {
    i7 = 33;
    break;
   }
   if (!i50) i1 = 0; else i1 = HEAP32[i50 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376613 | 0, 0, gb + 375437 | 0, 1770, 1, i1, 0, 0);
   i1 = 0;
  }
 } else {
  if (!i48) {
   if (!i50) i1 = 0; else i1 = HEAP32[i50 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376711 | 0, 0, gb + 375437 | 0, 1786, 1, i1, 0, 0);
   i1 = 0;
   break;
  }
  if ((mftCall_ii(HEAP32[(HEAP32[i48 >> 2] | 0) + 148 >> 2] | 0, i48 | 0) | 0) == 4) {
   i3 = HEAP32[i48 + 96 >> 2] | 0;
   i7 = 33;
   break;
  }
  if (!i50) i1 = 0; else i1 = HEAP32[i50 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376678 | 0, 0, gb + 375437 | 0, 1778, 1, i1, 0, 0);
  i1 = 0;
 } while (0);
 do if ((i7 | 0) == 33) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 500 >> 0] | 0)) i1 = 0; else {
  i2 = __Z12GetGfxDevicev() | 0;
  if (!(HEAP8[i2 + 4192 >> 0] | 0)) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 496 >> 2] | 0, i2 | 0);
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 516 >> 2] | 0, i2 | 0) | 0) {
    i45 = 1;
    i7 = 36;
   } else i1 = 0;
  } else {
   i45 = 0;
   i7 = 36;
  }
  if ((i7 | 0) == 36) {
   __ZN13RenderManager18UpdateAllRenderersEv();
   i44 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0) | 0;
   if (!i48) i2 = 1; else i2 = HEAP32[i48 + 88 >> 2] | 0;
   i41 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, i44, i44, 2, i3, 0, 0, 0, i2) | 0;
   if (!i41) {
    if (!i50) i1 = 0; else i1 = HEAP32[i50 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376770 | 0, 0, gb + 375437 | 0, 1812, 1, i1, 0, 0);
    i1 = 0;
   } else {
    HEAP32[i56 >> 2] = 0;
    HEAP32[i56 + 4 >> 2] = 0;
    HEAP32[i56 + 252 >> 2] = 0;
    HEAP32[i56 + 256 >> 2] = 0;
    i2 = i56 + 260 | 0;
    i42 = i56 + 16 | 0;
    i43 = i42 + 40 | 0;
    do {
     HEAP32[i42 >> 2] = 0;
     i42 = i42 + 4 | 0;
    } while ((i42 | 0) < (i43 | 0));
    HEAP32[i2 >> 2] = 1;
    HEAP32[i56 + 264 >> 2] = 0;
    i24 = i56 + 268 | 0;
    HEAP32[i24 >> 2] = -1;
    HEAP32[i24 + 4 >> 2] = -1;
    HEAP32[i24 + 8 >> 2] = -1;
    HEAP32[i24 + 12 >> 2] = -1;
    HEAP32[i56 + 284 >> 2] = 0;
    HEAP32[i56 + 288 >> 2] = 0;
    HEAP32[i56 + 292 >> 2] = 1;
    HEAP32[i56 + 296 >> 2] = 0;
    i24 = i56 + 300 | 0;
    HEAP32[i24 >> 2] = -1;
    HEAP32[i24 + 4 >> 2] = -1;
    HEAP32[i24 + 8 >> 2] = -1;
    HEAP32[i24 + 12 >> 2] = -1;
    __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext(i56, i46);
    __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i50);
    i24 = i50 + 744 | 0;
    i25 = HEAP32[i24 >> 2] | 0;
    HEAP32[i24 >> 2] = HEAP32[i41 + 4 >> 2];
    i26 = i50 + 928 | 0;
    i27 = HEAP32[i26 >> 2] | 0;
    i28 = i50 + 292 | 0;
    i29 = HEAP32[i28 >> 2] | 0;
    i30 = i50 + 1060 | 0;
    i31 = HEAP32[i30 >> 2] | 0;
    i32 = i50 + 1087 | 0;
    i33 = HEAP8[i32 >> 0] | 0;
    i34 = i50 + 1086 | 0;
    i35 = HEAP8[i34 >> 0] | 0;
    HEAPF32[i28 >> 2] = Math_fround(90.0);
    HEAPF32[i30 >> 2] = Math_fround(1.0);
    HEAP8[i34 >> 0] = 0;
    HEAP8[i32 >> 0] = 0;
    i36 = i50 + 1077 | 0;
    HEAP8[i36 >> 0] = 1;
    i37 = i50 + 1079 | 0;
    HEAP8[i37 >> 0] = 1;
    i38 = i50 + 1078 | 0;
    HEAP8[i38 >> 0] = 1;
    if ((__ZNK6Camera22CalculateRenderingPathEv(i50) | 0) > 1) HEAP32[i26 >> 2] = 1;
    i39 = __Z12GetGfxDevicev() | 0;
    i40 = i50 + 28 | 0;
    __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i40 >> 2] | 0, gb + 28940 | 0) | 0);
    f63 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
    f62 = Math_fround(-Math_fround(HEAPF32[i8 + 4 >> 2]));
    f61 = Math_fround(-Math_fround(HEAPF32[i8 + 8 >> 2]));
    HEAPF32[i49 >> 2] = f63;
    HEAPF32[i49 + 4 >> 2] = f62;
    HEAPF32[i49 + 8 >> 2] = f61;
    __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i58, i49) | 0;
    mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 88 >> 2] | 0, i39 | 0, 1);
    i6 = i50 + 36 | 0;
    i7 = i50 + 1080 | 0;
    i8 = i51 + 1236 | 0;
    i9 = i51 + 1240 | 0;
    i10 = i49 + 4 | 0;
    i11 = i49 + 8 | 0;
    i12 = i49 + 12 | 0;
    i13 = i49 + 16 | 0;
    i14 = i49 + 20 | 0;
    i15 = i50 + 1089 | 0;
    i16 = i50 + 904 | 0;
    i17 = i49 + 4 | 0;
    i18 = i50 + 908 | 0;
    i19 = i49 + 8 | 0;
    i20 = i50 + 912 | 0;
    i3 = i50 + 892 | 0;
    i4 = i50 + 896 | 0;
    i5 = i50 + 900 | 0;
    i21 = i50 + 1132 | 0;
    i22 = i39 + 4380 | 0;
    i2 = 0;
    do {
     if (1 << i2 & i52 | 0) {
      __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i41, 0, -1, 0, 0);
      i42 = i2 * 3 | 0;
      __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i57, gb + 1113232 + (i42 * 12 | 0) | 0, gb + 1113232 + ((i42 + 1 | 0) * 12 | 0) | 0, gb + 1113232 + ((i42 + 2 | 0) * 12 | 0) | 0) | 0;
      __ZN10Matrix4x4fmLERKS_(i57, i58) | 0;
      i42 = i6;
      i23 = i57;
      i43 = i42 + 64 | 0;
      do {
       HEAP32[i42 >> 2] = HEAP32[i23 >> 2];
       i42 = i42 + 4 | 0;
       i23 = i23 + 4 | 0;
      } while ((i42 | 0) < (i43 | 0));
      HEAP8[i7 >> 0] = 0;
      HEAP8[i38 >> 0] = 1;
      __ZN11CullResultsC2Ev(i51);
      HEAP32[i8 >> 2] = i53;
      HEAP32[i9 >> 2] = i54;
      HEAP32[i55 >> 2] = 0;
      HEAP32[i55 + 4 >> 2] = 0;
      HEAP32[i55 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i55, gb + 1576256 | 0, 0);
      HEAP32[i10 >> 2] = 0;
      HEAP32[i11 >> 2] = -1;
      HEAP32[i49 >> 2] = i50;
      HEAP32[i12 >> 2] = 5;
      HEAP32[i13 >> 2] = 0;
      HEAP32[i14 >> 2] = 0;
      if (HEAP8[i15 >> 0] | 0) HEAP32[i12 >> 2] = 7;
      __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i50, i49, i51);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i55);
      __ZNK9Transform11GetPositionEv(i49, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i40 >> 2] | 0, gb + 28940 | 0) | 0);
      f64 = Math_fround(HEAPF32[i49 >> 2]);
      f64 = Math_fround(f64 - Math_fround(HEAPF32[i16 >> 2]));
      f62 = Math_fround(HEAPF32[i17 >> 2]);
      f62 = Math_fround(f62 - Math_fround(HEAPF32[i18 >> 2]));
      f63 = Math_fround(HEAPF32[i19 >> 2]);
      f63 = Math_fround(f63 - Math_fround(HEAPF32[i20 >> 2]));
      f61 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
      f62 = Math_fround(f62 * f61);
      f63 = Math_fround(f63 * f61);
      HEAPF32[i3 >> 2] = Math_fround(f64 * f61);
      HEAPF32[i4 >> 2] = f62;
      HEAPF32[i5 >> 2] = f63;
      HEAP32[i16 >> 2] = HEAP32[i49 >> 2];
      HEAP32[i16 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
      HEAP32[i16 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
      __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv(i50, i51, i46, 0, 5, 0);
      __ZN21IntermediateRenderers5ClearEj(HEAP32[i21 >> 2] | 0, 0);
      if (i47) __ZN9Texture2D10ReadPixelsEiiiiiiibb(i1, i2, 0, 0, i44, i44, 0, 0, (HEAP8[i22 >> 0] | 0) != 0, 0); else {
       __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i48, 0, i2, 0, 0);
       mftCall_vi(HEAP32[(HEAP32[i39 >> 2] | 0) + 340 >> 2] | 0, i39 | 0);
       i23 = __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0;
       i65 = HEAP32[i23 + 100 >> 2] | 0;
       i42 = __ZN8Material9GetShaderEv(i23) | 0;
       HEAP32[i55 >> 2] = HEAP32[gb + 1110892 >> 2];
       HEAP32[i49 >> 2] = HEAP32[i55 >> 2];
       i43 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i23, i49) | 0;
       __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_(i46, i41, i48, i65, mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 36 >> 2] | 0, i23 | 0) | 0, i42, -1, i43 ? 2 : 0, i2, gb + 62472 | 0, gb + 1162356 | 0);
      }
      __ZN11CullResultsD2Ev(i51);
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 6);
    HEAP8[i7 >> 0] = 1;
    HEAP8[i50 + 1076 >> 0] = 1;
    HEAP32[i26 >> 2] = i27;
    HEAP32[i28 >> 2] = i29;
    HEAP32[i30 >> 2] = i31;
    HEAP8[i32 >> 0] = i33;
    HEAP8[i34 >> 0] = i35;
    HEAP8[i36 >> 0] = 1;
    HEAP8[i37 >> 0] = 1;
    HEAP8[i38 >> 0] = 1;
    HEAP32[i24 >> 2] = i25;
    __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext(i56, i46);
    mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 88 >> 2] | 0, i39 | 0, 0);
    __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i41);
    if (i47) {
     __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace(i1, 1);
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0);
    }
    i1 = 1;
   }
   if (!(i45 << 24 >> 24)) break;
  }
  i65 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i65 >> 2] | 0) + 500 >> 2] | 0, i65 | 0);
 } while (0);
 i65 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i65 >> 2] | 0) + 652 >> 2] | 0, i65 | 0);
 if (!i59) {
  STACKTOP = i60;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i59);
 STACKTOP = i60;
 return i1 | 0;
}

function __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_(i1, i2, i35) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i35 = i35 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i37;
 L1 : while (1) {
  i21 = i2;
  i34 = i2 + -40 | 0;
  i28 = i2 + -36 | 0;
  i29 = i2 + -32 | 0;
  i30 = i2 + -28 | 0;
  i31 = i2 + -24 | 0;
  i32 = i2 + -20 | 0;
  i33 = i2 + -16 | 0;
  i25 = i2 + -12 | 0;
  i26 = i2 + -8 | 0;
  i27 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i20 = i1;
    i3 = i21 - i20 | 0;
    switch ((i3 | 0) / 40 | 0 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 7;
      break L1;
     }
    case 4:
     {
      i22 = 8;
      break L1;
     }
    case 5:
     {
      i22 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 53;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 280) {
     i22 = 11;
     break L1;
    }
    i17 = i1 + (((i3 >>> 0) / 80 | 0) * 40 | 0) | 0;
    if ((i3 | 0) > 39960) {
     i3 = (i3 >>> 0) / 160 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + (i3 * 40 | 0) | 0, i17, i17 + (i3 * 40 | 0) | 0, i34, i35) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i1, i17, i34, i35) | 0;
    if (mftCall_iii(HEAP32[i35 >> 2] | 0, i1 | 0, i17 | 0) | 0) {
     i5 = i34;
     break;
    } else i4 = i34;
    while (1) {
     i16 = i4 + -40 | 0;
     if ((i1 | 0) == (i16 | 0)) break;
     if (mftCall_iii(HEAP32[i35 >> 2] | 0, i16 | 0, i17 | 0) | 0) {
      i22 = 36;
      break L5;
     } else i4 = i16;
    }
    i5 = i1 + 40 | 0;
    if (!(mftCall_iii(HEAP32[i35 >> 2] | 0, i1 | 0, i34 | 0) | 0)) {
     if ((i5 | 0) == (i34 | 0)) {
      i22 = 53;
      break L1;
     } else i3 = i5;
     while (1) {
      if (mftCall_iii(HEAP32[i35 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 40 | 0;
      if ((i3 | 0) == (i34 | 0)) {
       i22 = 53;
       break L1;
      }
     }
     i12 = HEAP32[i3 >> 2] | 0;
     i13 = HEAP32[i3 + 4 >> 2] | 0;
     i14 = HEAP32[i3 + 8 >> 2] | 0;
     i4 = HEAP32[i3 + 12 >> 2] | 0;
     i6 = HEAP32[i3 + 16 >> 2] | 0;
     i7 = HEAP32[i3 + 20 >> 2] | 0;
     i8 = HEAP32[i3 + 24 >> 2] | 0;
     i9 = HEAP32[i3 + 28 >> 2] | 0;
     i10 = HEAP32[i3 + 32 >> 2] | 0;
     i11 = HEAP32[i3 + 36 >> 2] | 0;
     i5 = i3;
     i23 = i34;
     i24 = i5 + 40 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
      i5 = i5 + 4 | 0;
      i23 = i23 + 4 | 0;
     } while ((i5 | 0) < (i24 | 0));
     HEAP32[i34 >> 2] = i12;
     HEAP32[i28 >> 2] = i13;
     HEAP32[i29 >> 2] = i14;
     HEAP32[i30 >> 2] = i4;
     HEAP32[i31 >> 2] = i6;
     HEAP32[i32 >> 2] = i7;
     HEAP32[i33 >> 2] = i8;
     HEAP32[i25 >> 2] = i9;
     HEAP32[i26 >> 2] = i10;
     HEAP32[i27 >> 2] = i11;
     i5 = i3 + 40 | 0;
    }
    if ((i5 | 0) == (i34 | 0)) {
     i22 = 53;
     break L1;
    } else i3 = i34;
    while (1) {
     while (1) {
      i16 = i5 + 40 | 0;
      if (mftCall_iii(HEAP32[i35 >> 2] | 0, i1 | 0, i5 | 0) | 0) break; else i5 = i16;
     }
     while (1) {
      i4 = i3 + -40 | 0;
      if (mftCall_iii(HEAP32[i35 >> 2] | 0, i1 | 0, i4 | 0) | 0) i3 = i4; else break;
     }
     if (i5 >>> 0 >= i4 >>> 0) {
      i1 = i5;
      continue L5;
     }
     i6 = HEAP32[i5 >> 2] | 0;
     i7 = HEAP32[i5 + 4 >> 2] | 0;
     i8 = HEAP32[i5 + 8 >> 2] | 0;
     i9 = HEAP32[i5 + 12 >> 2] | 0;
     i10 = HEAP32[i5 + 16 >> 2] | 0;
     i11 = HEAP32[i5 + 20 >> 2] | 0;
     i12 = HEAP32[i5 + 24 >> 2] | 0;
     i13 = HEAP32[i5 + 28 >> 2] | 0;
     i14 = HEAP32[i5 + 32 >> 2] | 0;
     i15 = HEAP32[i5 + 36 >> 2] | 0;
     i23 = i4;
     i24 = i5 + 40 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
      i5 = i5 + 4 | 0;
      i23 = i23 + 4 | 0;
     } while ((i5 | 0) < (i24 | 0));
     HEAP32[i4 >> 2] = i6;
     HEAP32[i3 + -36 >> 2] = i7;
     HEAP32[i3 + -32 >> 2] = i8;
     HEAP32[i3 + -28 >> 2] = i9;
     HEAP32[i3 + -24 >> 2] = i10;
     HEAP32[i3 + -20 >> 2] = i11;
     HEAP32[i3 + -16 >> 2] = i12;
     HEAP32[i3 + -12 >> 2] = i13;
     HEAP32[i3 + -8 >> 2] = i14;
     HEAP32[i3 + -4 >> 2] = i15;
     i3 = i4;
     i5 = i16;
    }
   }
   if ((i22 | 0) == 36) {
    i22 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i9 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = HEAP32[i1 + 16 >> 2] | 0;
    i11 = HEAP32[i1 + 20 >> 2] | 0;
    i12 = HEAP32[i1 + 24 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i14 = HEAP32[i1 + 32 >> 2] | 0;
    i15 = HEAP32[i1 + 36 >> 2] | 0;
    i5 = i1;
    i23 = i16;
    i24 = i5 + 40 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
     i5 = i5 + 4 | 0;
     i23 = i23 + 4 | 0;
    } while ((i5 | 0) < (i24 | 0));
    HEAP32[i16 >> 2] = i6;
    HEAP32[i4 + -36 >> 2] = i7;
    HEAP32[i4 + -32 >> 2] = i8;
    HEAP32[i4 + -28 >> 2] = i9;
    HEAP32[i4 + -24 >> 2] = i10;
    HEAP32[i4 + -20 >> 2] = i11;
    HEAP32[i4 + -16 >> 2] = i12;
    HEAP32[i4 + -12 >> 2] = i13;
    HEAP32[i4 + -8 >> 2] = i14;
    HEAP32[i4 + -4 >> 2] = i15;
    i5 = i16;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 40 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i19 = i17;
    while (1) {
     while (1) {
      i18 = i4 + 40 | 0;
      if (mftCall_iii(HEAP32[i35 >> 2] | 0, i4 | 0, i19 | 0) | 0) i4 = i18; else {
       i6 = i5;
       break;
      }
     }
     while (1) {
      i7 = i6 + -40 | 0;
      if (mftCall_iii(HEAP32[i35 >> 2] | 0, i7 | 0, i19 | 0) | 0) break; else i6 = i7;
     }
     if (i4 >>> 0 > i7 >>> 0) {
      i15 = i19;
      i16 = i4;
      break L35;
     }
     i8 = HEAP32[i4 >> 2] | 0;
     i9 = HEAP32[i4 + 4 >> 2] | 0;
     i10 = HEAP32[i4 + 8 >> 2] | 0;
     i11 = HEAP32[i4 + 12 >> 2] | 0;
     i12 = HEAP32[i4 + 16 >> 2] | 0;
     i13 = HEAP32[i4 + 20 >> 2] | 0;
     i14 = HEAP32[i4 + 24 >> 2] | 0;
     i15 = HEAP32[i4 + 28 >> 2] | 0;
     i16 = HEAP32[i4 + 32 >> 2] | 0;
     i17 = HEAP32[i4 + 36 >> 2] | 0;
     i5 = i4;
     i23 = i7;
     i24 = i5 + 40 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
      i5 = i5 + 4 | 0;
      i23 = i23 + 4 | 0;
     } while ((i5 | 0) < (i24 | 0));
     HEAP32[i7 >> 2] = i8;
     HEAP32[i6 + -36 >> 2] = i9;
     HEAP32[i6 + -32 >> 2] = i10;
     HEAP32[i6 + -28 >> 2] = i11;
     HEAP32[i6 + -24 >> 2] = i12;
     HEAP32[i6 + -20 >> 2] = i13;
     HEAP32[i6 + -16 >> 2] = i14;
     HEAP32[i6 + -12 >> 2] = i15;
     HEAP32[i6 + -8 >> 2] = i16;
     HEAP32[i6 + -4 >> 2] = i17;
     i19 = (i19 | 0) == (i4 | 0) ? i7 : i19;
     i5 = i7;
     i4 = i18;
     i3 = i3 + 1 | 0;
    }
   } else {
    i15 = i17;
    i16 = i4;
   } while (0);
   if ((i16 | 0) != (i15 | 0)) if (mftCall_iii(HEAP32[i35 >> 2] | 0, i15 | 0, i16 | 0) | 0) {
    i4 = HEAP32[i16 >> 2] | 0;
    i6 = HEAP32[i16 + 4 >> 2] | 0;
    i7 = HEAP32[i16 + 8 >> 2] | 0;
    i8 = HEAP32[i16 + 12 >> 2] | 0;
    i9 = HEAP32[i16 + 16 >> 2] | 0;
    i10 = HEAP32[i16 + 20 >> 2] | 0;
    i11 = HEAP32[i16 + 24 >> 2] | 0;
    i12 = HEAP32[i16 + 28 >> 2] | 0;
    i13 = HEAP32[i16 + 32 >> 2] | 0;
    i14 = HEAP32[i16 + 36 >> 2] | 0;
    i5 = i16;
    i23 = i15;
    i24 = i5 + 40 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
     i5 = i5 + 4 | 0;
     i23 = i23 + 4 | 0;
    } while ((i5 | 0) < (i24 | 0));
    HEAP32[i15 >> 2] = i4;
    HEAP32[i15 + 4 >> 2] = i6;
    HEAP32[i15 + 8 >> 2] = i7;
    HEAP32[i15 + 12 >> 2] = i8;
    HEAP32[i15 + 16 >> 2] = i9;
    HEAP32[i15 + 20 >> 2] = i10;
    HEAP32[i15 + 24 >> 2] = i11;
    HEAP32[i15 + 28 >> 2] = i12;
    HEAP32[i15 + 32 >> 2] = i13;
    HEAP32[i15 + 36 >> 2] = i14;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRK16BlendShapeVertexS3_EPS1_EEbT0_S8_T_(i1, i16, i35) | 0;
    i4 = i16 + 40 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRK16BlendShapeVertexS3_EPS1_EEbT0_S8_T_(i4, i2, i35) | 0) {
     i22 = 52;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i24 = i16;
   if ((i24 - i20 | 0) >= (i21 - i24 | 0)) {
    i22 = 51;
    break;
   }
   __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_(i1, i16, i35);
   i1 = i16 + 40 | 0;
  }
  if ((i22 | 0) == 51) {
   i22 = 0;
   __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_(i16 + 40 | 0, i2, i35);
   i2 = i16;
   continue;
  } else if ((i22 | 0) == 52) {
   i22 = 0;
   if (i3) {
    i22 = 53;
    break;
   } else {
    i2 = i16;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i35 >> 2] | 0, i34 | 0, i1 | 0) | 0)) {
   STACKTOP = i37;
   return;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = HEAP32[i1 + 16 >> 2] | 0;
  i8 = HEAP32[i1 + 20 >> 2] | 0;
  i9 = HEAP32[i1 + 24 >> 2] | 0;
  i10 = HEAP32[i1 + 28 >> 2] | 0;
  i11 = HEAP32[i1 + 32 >> 2] | 0;
  i12 = HEAP32[i1 + 36 >> 2] | 0;
  i5 = i1;
  i23 = i34;
  i24 = i5 + 40 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
   i5 = i5 + 4 | 0;
   i23 = i23 + 4 | 0;
  } while ((i5 | 0) < (i24 | 0));
  HEAP32[i34 >> 2] = i2;
  HEAP32[i28 >> 2] = i3;
  HEAP32[i29 >> 2] = i4;
  HEAP32[i30 >> 2] = i6;
  HEAP32[i31 >> 2] = i7;
  HEAP32[i32 >> 2] = i8;
  HEAP32[i33 >> 2] = i9;
  HEAP32[i25 >> 2] = i10;
  HEAP32[i26 >> 2] = i11;
  HEAP32[i27 >> 2] = i12;
  STACKTOP = i37;
  return;
 } else if ((i22 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i1, i1 + 40 | 0, i34, i35) | 0;
  STACKTOP = i37;
  return;
 } else if ((i22 | 0) == 8) {
  __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i34, i35) | 0;
  STACKTOP = i37;
  return;
 } else if ((i22 | 0) == 9) {
  __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + 40 | 0, i1 + 80 | 0, i1 + 120 | 0, i34, i35) | 0;
  STACKTOP = i37;
  return;
 } else if ((i22 | 0) == 11) {
  i3 = i1 + 80 | 0;
  __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i1, i1 + 40 | 0, i3, i35) | 0;
  i4 = i1 + 120 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i37;
   return;
  }
  i6 = i36 + 4 | 0;
  i7 = i36 + 8 | 0;
  i8 = i36 + 12 | 0;
  i9 = i36 + 16 | 0;
  i10 = i36 + 20 | 0;
  i11 = i36 + 24 | 0;
  i12 = i36 + 28 | 0;
  i13 = i36 + 32 | 0;
  i14 = i36 + 36 | 0;
  while (1) {
   if (mftCall_iii(HEAP32[i35 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    HEAP32[i36 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i4 + 24 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i4 + 28 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i4 + 32 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i4 + 36 >> 2];
    i5 = i4;
    while (1) {
     i23 = i3;
     i24 = i5 + 40 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
      i5 = i5 + 4 | 0;
      i23 = i23 + 4 | 0;
     } while ((i5 | 0) < (i24 | 0));
     if ((i3 | 0) == (i1 | 0)) break;
     i5 = i3 + -40 | 0;
     if (mftCall_iii(HEAP32[i35 >> 2] | 0, i36 | 0, i5 | 0) | 0) {
      i34 = i3;
      i3 = i5;
      i5 = i34;
     } else break;
    }
    i5 = i3;
    i23 = i36;
    i24 = i5 + 40 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
     i5 = i5 + 4 | 0;
     i23 = i23 + 4 | 0;
    } while ((i5 | 0) < (i24 | 0));
   }
   i3 = i4 + 40 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i34 = i4;
    i4 = i3;
    i3 = i34;
   }
  }
  STACKTOP = i37;
  return;
 } else if ((i22 | 0) == 53) {
  STACKTOP = i37;
  return;
 }
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i19, i14) {
 i11 = i11 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 var i1 = 0, d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i15 = i19 + 4 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i17 = i19 + 8 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i4 = i1;
 i13 = (HEAP8[i4 >> 0] | 0) == 45;
 i1 = i13 ? i4 + 1 | 0 : i1;
 i4 = i1;
 i3 = HEAP8[i4 >> 0] | 0;
 L1 : do if (i3 << 24 >> 24 == 48) {
  i8 = 0;
  i10 = 0;
  d2 = 0.0;
  i12 = 0;
  i1 = i4 + 1 | 0;
  i6 = 0;
  i4 = 0;
 } else {
  if ((i3 + -49 & 255) >= 9) {
   HEAP32[i11 + 24 >> 2] = 3;
   HEAP32[i11 + 28 >> 2] = i1 - i18;
   i14 = i1;
   HEAP32[i19 >> 2] = i14;
   HEAP32[i15 >> 2] = i16;
   HEAP32[i17 >> 2] = i18;
   return;
  }
  i6 = i4 + 1 | 0;
  i1 = i6;
  i5 = (i3 << 24 >> 24) + -48 | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  i3 = (i4 + -48 & 255) < 10;
  L8 : do if (i13) {
   if (i3) i3 = i6; else {
    i8 = 0;
    i10 = 0;
    d2 = 0.0;
    i12 = i5;
    i6 = 0;
    i4 = 0;
    break L1;
   }
   while (1) {
    if (i5 >>> 0 > 214748363) {
     if ((i5 | 0) != 214748364) break L8;
     if (i4 << 24 >> 24 > 56) {
      i5 = 214748364;
      break L8;
     }
    }
    i3 = i3 + 1 | 0;
    i1 = i3;
    i5 = (i5 * 10 | 0) + -48 + (i4 << 24 >> 24) | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i8 = 0;
     i10 = 0;
     d2 = 0.0;
     i12 = i5;
     i6 = 0;
     i4 = 0;
     break L1;
    }
   }
  } else {
   if (i3) i3 = i6; else {
    i8 = 0;
    i10 = 0;
    d2 = 0.0;
    i12 = i5;
    i6 = 0;
    i4 = 0;
    break L1;
   }
   while (1) {
    if (i5 >>> 0 > 429496728) {
     if ((i5 | 0) != 429496729) break L8;
     if (i4 << 24 >> 24 > 53) {
      i5 = 429496729;
      break L8;
     }
    }
    i3 = i3 + 1 | 0;
    i1 = i3;
    i5 = (i5 * 10 | 0) + -48 + (i4 << 24 >> 24) | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i8 = 0;
     i10 = 0;
     d2 = 0.0;
     i12 = i5;
     i6 = 0;
     i4 = 0;
     break L1;
    }
   }
  } while (0);
  i8 = i1;
  i7 = HEAP8[i8 >> 0] | 0;
  i3 = (i7 + -48 & 255) < 10;
  L24 : do if (i13) {
   if (i3) {
    i4 = 0;
    i6 = i5;
    i3 = i8;
   } else {
    i8 = 0;
    i10 = 1;
    d2 = 0.0;
    i12 = i5;
    i6 = i5;
    i4 = 0;
    break L1;
   }
   while (1) {
    if (i4 >>> 0 > 214748364 | (i4 | 0) == 214748364 & i6 >>> 0 > 3435973835) if ((i6 | 0) != -858993460 | (i4 | 0) != 214748364 | i7 << 24 >> 24 > 56) {
     i7 = i4;
     break L24;
    }
    i6 = ___muldi3(i6 | 0, i4 | 0, 10, 0) | 0;
    i3 = i3 + 1 | 0;
    i1 = i3;
    i6 = _i64Add((i7 << 24 >> 24) + -48 | 0, 0, i6 | 0, getTempRet0() | 0) | 0;
    i4 = getTempRet0() | 0;
    i7 = HEAP8[i3 >> 0] | 0;
    if ((i7 + -48 & 255) >= 10) {
     i8 = 0;
     i10 = 1;
     d2 = 0.0;
     i12 = i5;
     break L1;
    }
   }
  } else {
   if (i3) {
    i4 = 0;
    i6 = i5;
    i3 = i8;
   } else {
    i8 = 0;
    i10 = 1;
    d2 = 0.0;
    i12 = i5;
    i6 = i5;
    i4 = 0;
    break L1;
   }
   while (1) {
    if (i4 >>> 0 > 429496729 | (i4 | 0) == 429496729 & i6 >>> 0 > 2576980376) if ((i6 | 0) != -1717986919 | (i4 | 0) != 429496729 | i7 << 24 >> 24 > 53) {
     i7 = i4;
     break L24;
    }
    i6 = ___muldi3(i6 | 0, i4 | 0, 10, 0) | 0;
    i3 = i3 + 1 | 0;
    i1 = i3;
    i6 = _i64Add((i7 << 24 >> 24) + -48 | 0, 0, i6 | 0, getTempRet0() | 0) | 0;
    i4 = getTempRet0() | 0;
    i7 = HEAP8[i3 >> 0] | 0;
    if ((i7 + -48 & 255) >= 10) {
     i8 = 0;
     i10 = 1;
     d2 = 0.0;
     i12 = i5;
     break L1;
    }
   }
  } while (0);
  d2 = +(i6 >>> 0) + 4294967296.0 * +(i7 >>> 0);
  i3 = i1;
  i4 = HEAP8[i3 >> 0] | 0;
  if ((i4 + -48 & 255) < 10) {
   while (1) {
    if (d2 >= 1797693134862315758041281.0e283) break;
    i3 = i3 + 1 | 0;
    i1 = i3;
    d2 = d2 * 10.0 + +((i4 << 24 >> 24) + -48 | 0);
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i8 = 1;
     i10 = 1;
     i12 = i5;
     i4 = i7;
     break L1;
    }
   }
   HEAP32[i11 + 24 >> 2] = 13;
   HEAP32[i11 + 28 >> 2] = i1 - i18;
   i14 = i1;
   HEAP32[i19 >> 2] = i14;
   HEAP32[i15 >> 2] = i16;
   HEAP32[i17 >> 2] = i18;
   return;
  } else {
   i8 = 1;
   i10 = 1;
   i12 = i5;
   i4 = i7;
  }
 } while (0);
 i3 = i1;
 i5 = HEAP8[i3 >> 0] | 0;
 do if (i5 << 24 >> 24 == 46) {
  i1 = i3 + 1 | 0;
  if (!i8) d2 = i10 ? +(i6 >>> 0) + 4294967296.0 * +(i4 >>> 0) : +(i12 >>> 0);
  i3 = HEAP8[i1 >> 0] | 0;
  if ((i3 + -48 & 255) < 10) {
   i5 = 0;
   i7 = i1;
   i1 = i3;
   do {
    i7 = i7 + 1 | 0;
    d2 = d2 * 10.0 + +((i1 << 24 >> 24) + -48 | 0);
    i5 = i5 + -1 | 0;
    i1 = HEAP8[i7 >> 0] | 0;
   } while ((i1 + -48 & 255) < 10);
   i1 = i7;
   if (i5) {
    i9 = i5;
    i8 = 1;
    i3 = HEAP8[i7 >> 0] | 0;
    break;
   }
  }
  HEAP32[i11 + 24 >> 2] = 14;
  HEAP32[i11 + 28 >> 2] = i1 - i18;
  i14 = i1;
  HEAP32[i19 >> 2] = i14;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i17 >> 2] = i18;
  return;
 } else {
  i9 = 0;
  i3 = i5;
 } while (0);
 i5 = i1;
 switch (i3 << 24 >> 24) {
 case 69:
 case 101:
  {
   if (!i8) d2 = i10 ? +(i6 >>> 0) + 4294967296.0 * +(i4 >>> 0) : +(i12 >>> 0);
   i1 = i5 + 1 | 0;
   switch (HEAP8[i1 >> 0] | 0) {
   case 43:
    {
     i6 = 0;
     i1 = i5 + 2 | 0;
     break;
    }
   case 45:
    {
     i6 = 1;
     i1 = i5 + 2 | 0;
     break;
    }
   default:
    i6 = 0;
   }
   i3 = i1;
   i4 = HEAP8[i1 >> 0] | 0;
   if ((i4 + -48 & 255) >= 10) {
    HEAP32[i11 + 24 >> 2] = 15;
    HEAP32[i11 + 28 >> 2] = i3 - i18;
    i14 = i3;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i17 >> 2] = i18;
    return;
   }
   i5 = i1 + 1 | 0;
   i1 = i5;
   i4 = (i4 << 24 >> 24) + -48 | 0;
   L114 : do if (i6) {
    i3 = HEAP8[i5 >> 0] | 0;
    if ((i3 + -48 & 255) < 10) {
     i1 = i5;
     do {
      i1 = i1 + 1 | 0;
      i4 = (i4 * 10 | 0) + -48 + (i3 << 24 >> 24) | 0;
      i3 = HEAP8[i1 >> 0] | 0;
     } while ((i3 + -48 & 255) < 10);
     i3 = i4;
    } else i3 = i4;
   } else {
    i3 = i4;
    do {
     i4 = i1;
     i5 = HEAP8[i4 >> 0] | 0;
     if ((i5 + -48 & 255) >= 10) break L114;
     i1 = i4 + 1 | 0;
     i3 = (i3 * 10 | 0) + -48 + (i5 << 24 >> 24) | 0;
    } while ((i3 | 0) < 309);
    HEAP32[i11 + 24 >> 2] = 13;
    HEAP32[i11 + 28 >> 2] = i1 - i18;
    i14 = i1;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i17 >> 2] = i18;
    return;
   } while (0);
   i4 = i6 ? 0 - i3 | 0 : i3;
   break;
  }
 default:
  if (i8) i4 = 0; else {
   if (i10) {
    if (i13) {
     i13 = _i64Subtract(0, 0, i6 | 0, i4 | 0) | 0;
     if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E5Int64Ex(i14, i13, getTempRet0() | 0) | 0) {
      i14 = i1;
      HEAP32[i19 >> 2] = i14;
      HEAP32[i15 >> 2] = i16;
      HEAP32[i17 >> 2] = i18;
      return;
     }
    } else if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6Uint64Ey(i14, i6, i4) | 0) {
     i14 = i1;
     HEAP32[i19 >> 2] = i14;
     HEAP32[i15 >> 2] = i16;
     HEAP32[i17 >> 2] = i18;
     return;
    }
    HEAP32[i11 + 24 >> 2] = 16;
    HEAP32[i11 + 28 >> 2] = i1 - i18;
    i14 = i1;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i17 >> 2] = i18;
    return;
   }
   if (i13) {
    i11 = 0 - i12 | 0;
    i3 = i14 + 28 | 0;
    i10 = i14 + 40 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i8 = i14 + 44 | 0;
    i13 = HEAP32[i8 >> 2] | 0;
    i5 = i13;
    i9 = i4;
    if ((i4 + 24 | 0) >>> 0 >= i13 >>> 0) {
     i4 = i14 + 36 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i6;
     if (!i6) {
      if (!(HEAP32[i3 >> 2] | 0)) {
       i13 = __Znwj(1) | 0;
       HEAP32[i3 >> 2] = i13;
       HEAP32[i14 + 32 >> 2] = i13;
      }
      i3 = HEAP32[i14 + 48 >> 2] | 0;
     } else {
      i3 = i5 - i7 | 0;
      i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
     }
     i9 = i9 - i7 | 0;
     i14 = i9 + 24 | 0;
     i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
     i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i13;
     i4 = i13 + i9 | 0;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i8 >> 2] = i13 + i14;
    }
    HEAP32[i10 >> 2] = i4 + 24;
    i3 = i4 + 8 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    i3 = i4 + 16 | 0;
    HEAP32[i3 >> 2] = 5638;
    i14 = i4;
    HEAP32[i14 >> 2] = i11;
    HEAP32[i14 + 4 >> 2] = ((i11 | 0) < 0) << 31 >> 31;
    if ((i12 | 0) >= 1) {
     i14 = i1;
     HEAP32[i19 >> 2] = i14;
     HEAP32[i15 >> 2] = i16;
     HEAP32[i17 >> 2] = i18;
     return;
    }
    HEAP32[i3 >> 2] = 15878;
    i14 = i1;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i17 >> 2] = i18;
    return;
   } else {
    i3 = i14 + 28 | 0;
    i10 = i14 + 40 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i8 = i14 + 44 | 0;
    i13 = HEAP32[i8 >> 2] | 0;
    i5 = i13;
    i9 = i4;
    if ((i4 + 24 | 0) >>> 0 >= i13 >>> 0) {
     i4 = i14 + 36 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i6;
     if (!i6) {
      if (!(HEAP32[i3 >> 2] | 0)) {
       i13 = __Znwj(1) | 0;
       HEAP32[i3 >> 2] = i13;
       HEAP32[i14 + 32 >> 2] = i13;
      }
      i3 = HEAP32[i14 + 48 >> 2] | 0;
     } else {
      i3 = i5 - i7 | 0;
      i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
     }
     i11 = i9 - i7 | 0;
     i14 = i11 + 24 | 0;
     i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
     i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i13;
     i4 = i13 + i11 | 0;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i8 >> 2] = i13 + i14;
    }
    HEAP32[i10 >> 2] = i4 + 24;
    i3 = i4 + 8 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    i3 = i4 + 16 | 0;
    HEAP32[i3 >> 2] = 14854;
    i14 = i4;
    HEAP32[i14 >> 2] = i12;
    HEAP32[i14 + 4 >> 2] = 0;
    if ((i12 | 0) < 0) {
     i14 = i1;
     HEAP32[i19 >> 2] = i14;
     HEAP32[i15 >> 2] = i16;
     HEAP32[i17 >> 2] = i18;
     return;
    }
    HEAP32[i3 >> 2] = 15878;
    i14 = i1;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i17 >> 2] = i18;
    return;
   }
  }
 }
 i3 = i4 + i9 | 0;
 do if ((i3 | 0) < -308) {
  do if ((i4 | 0) < -308) d2 = 0.0; else if ((i4 | 0) > -1) {
   d2 = d2 * +HEAPF64[gb + 416 + (i4 << 3) >> 3];
   break;
  } else {
   d2 = d2 / +HEAPF64[gb + 416 + (0 - i4 << 3) >> 3];
   break;
  } while (0);
  if ((i9 | 0) < -308) d2 = 0.0; else if ((i9 | 0) > -1) {
   d2 = d2 * +HEAPF64[gb + 416 + (i9 << 3) >> 3];
   break;
  } else {
   d2 = d2 / +HEAPF64[gb + 416 + (0 - i9 << 3) >> 3];
   break;
  }
 } else if ((i3 | 0) > -1) {
  d2 = d2 * +HEAPF64[gb + 416 + (i3 << 3) >> 3];
  break;
 } else {
  d2 = d2 / +HEAPF64[gb + 416 + (0 - i3 << 3) >> 3];
  break;
 } while (0);
 d2 = i13 ? -d2 : d2;
 i4 = i14 + 28 | 0;
 i11 = i14 + 40 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i9 = i14 + 44 | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 i5 = i13;
 i10 = i3;
 if ((i3 + 24 | 0) >>> 0 >= i13 >>> 0) {
  i6 = i14 + 36 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7;
  if (!i7) {
   if (!(HEAP32[i4 >> 2] | 0)) {
    i13 = __Znwj(1) | 0;
    HEAP32[i4 >> 2] = i13;
    HEAP32[i14 + 32 >> 2] = i13;
   }
   i3 = HEAP32[i14 + 48 >> 2] | 0;
  } else {
   i3 = i5 - i8 | 0;
   i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
  }
  i12 = i10 - i8 | 0;
  i14 = i12 + 24 | 0;
  i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
  i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i6 >> 2] = i13;
  i3 = i13 + i12 | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i9 >> 2] = i13 + i14;
 }
 HEAP32[i11 >> 2] = i3 + 24;
 i14 = i3 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 16902;
 HEAPF64[i3 >> 3] = d2;
 i14 = i1;
 HEAP32[i19 >> 2] = i14;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i17 >> 2] = i18;
 return;
}

function __ZN23ParticleSystemParticlesC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 84 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 104 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 124 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 144 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 184 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 204 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 224 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 244 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 264 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 284 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = 0;
 HEAP32[i1 + 316 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 304 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 324 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 344 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 364 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP32[i1 + 392 >> 2] = 0;
 HEAP32[i1 + 396 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 384 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 400 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = 0;
 HEAP32[i1 + 416 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 404 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 420 >> 2] = 0;
 HEAP32[i1 + 432 >> 2] = 0;
 HEAP32[i1 + 436 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 424 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 440 >> 2] = 0;
 HEAP32[i1 + 452 >> 2] = 0;
 HEAP32[i1 + 456 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 444 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 460 >> 2] = 0;
 HEAP32[i1 + 472 >> 2] = 0;
 HEAP32[i1 + 476 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 464 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 480 >> 2] = 0;
 HEAP32[i1 + 492 >> 2] = 0;
 HEAP32[i1 + 496 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 484 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 500 >> 2] = 0;
 HEAP32[i1 + 512 >> 2] = 0;
 HEAP32[i1 + 516 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 504 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 520 >> 2] = 0;
 HEAP32[i1 + 532 >> 2] = 0;
 HEAP32[i1 + 536 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 524 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP32[i1 + 552 >> 2] = 0;
 HEAP32[i1 + 556 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 544 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 560 >> 2] = 0;
 HEAP32[i1 + 572 >> 2] = 0;
 HEAP32[i1 + 576 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 564 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 580 >> 2] = 0;
 HEAP32[i1 + 592 >> 2] = 0;
 HEAP32[i1 + 596 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 584 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 600 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i1 + 608 | 0;
 HEAP32[i1 + 632 >> 2] = 0;
 HEAP32[i1 + 636 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 624 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 640 >> 2] = 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 656 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 644 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 660 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 676 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 664 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 680 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 696 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 684 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 700 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 HEAP32[i1 + 716 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 704 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 720 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i1 + 728 | 0;
 HEAP32[i1 + 752 >> 2] = 0;
 HEAP32[i1 + 756 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 744 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 760 >> 2] = 0;
 HEAP32[i1 + 772 >> 2] = 0;
 HEAP32[i1 + 776 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 764 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 780 >> 2] = 0;
 HEAP32[i1 + 792 >> 2] = 0;
 HEAP32[i1 + 796 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 784 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 800 >> 2] = 0;
 HEAP32[i1 + 812 >> 2] = 0;
 HEAP32[i1 + 816 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 804 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 820 >> 2] = 0;
 HEAP32[i1 + 824 >> 2] = 0;
 HEAP32[i1 + 828 >> 2] = 0;
 HEAP32[i1 + 840 >> 2] = 0;
 HEAP32[i1 + 844 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 832 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 848 >> 2] = 0;
 HEAP32[i1 + 860 >> 2] = 0;
 HEAP32[i1 + 864 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 852 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 868 | 0;
 HEAP32[i1 + 880 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i1 + 884 >> 2] = 1;
 STACKTOP = i2;
 return;
}

function __ZNSt3__26locale5__impC2Ej(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i4 + 4 >> 2] = i1 + -1;
 HEAP32[i4 >> 2] = gb + 212688 + 8;
 i6 = i4 + 8 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i6 | 0, 28);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i5 = i4 + 144 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i5 | 0, gb + 1083663 | 0, 1);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i4 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   while (1) {
    if ((i3 | 0) == (i1 | 0)) break;
    i8 = i3 + -4 | 0;
    HEAP32[i2 >> 2] = i8;
    i3 = i8;
   }
   HEAP32[gb + 1099968 + 4 >> 2] = 0;
   HEAP32[gb + 1099968 >> 2] = gb + 209572 + 8;
   __THREW__ = 0;
   invoke_vii(fb + 4536 | 0, i4 | 0, gb + 1099968 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   do if (i8 & 1) i7 = 42; else {
    HEAP32[gb + 1099976 + 4 >> 2] = 0;
    HEAP32[gb + 1099976 >> 2] = gb + 209604 + 8;
    __THREW__ = 0;
    invoke_vii(fb + 4537 | 0, i4 | 0, gb + 1099976 | 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) i7 = 42; else {
     HEAP32[gb + 1099984 + 4 >> 2] = 0;
     HEAP32[gb + 1099984 >> 2] = gb + 212772 + 8;
     HEAP32[gb + 1099984 + 8 >> 2] = 0;
     HEAP8[gb + 1099984 + 12 >> 0] = 0;
     i8 = __ZNSt3__25ctypeIcE13classic_tableEv() | 0;
     HEAP32[gb + 1099984 + 8 >> 2] = i8;
     __THREW__ = 0;
     invoke_vii(fb + 4538 | 0, i4 | 0, gb + 1099984 | 0);
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) i7 = 42; else {
      HEAP32[gb + 11e5 + 4 >> 2] = 0;
      HEAP32[gb + 11e5 >> 2] = gb + 213168 + 8;
      __THREW__ = 0;
      invoke_vii(fb + 4539 | 0, i4 | 0, gb + 11e5 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) i7 = 42; else {
       HEAP32[gb + 1100008 + 4 >> 2] = 0;
       HEAP32[gb + 1100008 >> 2] = gb + 213236 + 8;
       __THREW__ = 0;
       invoke_vii(fb + 4540 | 0, i4 | 0, gb + 1100008 | 0);
       i8 = __THREW__;
       __THREW__ = 0;
       if (i8 & 1) i7 = 42; else {
        __THREW__ = 0;
        invoke_vii(fb + 4541 | 0, gb + 1100016 | 0, 1);
        i8 = __THREW__;
        __THREW__ = 0;
        if (i8 & 1) i7 = 42; else {
         __THREW__ = 0;
         invoke_vii(fb + 4542 | 0, i4 | 0, gb + 1100016 | 0);
         i8 = __THREW__;
         __THREW__ = 0;
         if (i8 & 1) i7 = 42; else {
          HEAP32[gb + 1100032 + 4 >> 2] = 0;
          HEAP32[gb + 1100032 >> 2] = gb + 213284 + 8;
          __THREW__ = 0;
          invoke_vii(fb + 4543 | 0, i4 | 0, gb + 1100032 | 0);
          i8 = __THREW__;
          __THREW__ = 0;
          if (i8 & 1) i7 = 42; else {
           HEAP32[gb + 1100040 + 4 >> 2] = 0;
           HEAP32[gb + 1100040 >> 2] = gb + 213332 + 8;
           __THREW__ = 0;
           invoke_vii(fb + 4544 | 0, i4 | 0, gb + 1100040 | 0);
           i8 = __THREW__;
           __THREW__ = 0;
           if (i8 & 1) i7 = 42; else {
            __ZNSt3__28numpunctIcEC2Ej(gb + 1100048 | 0, 1);
            __THREW__ = 0;
            invoke_vii(fb + 4545 | 0, i4 | 0, gb + 1100048 | 0);
            i8 = __THREW__;
            __THREW__ = 0;
            if (i8 & 1) i7 = 42; else {
             __ZNSt3__28numpunctIwEC2Ej(gb + 1100072 | 0, 1);
             __THREW__ = 0;
             invoke_vii(fb + 4546 | 0, i4 | 0, gb + 1100072 | 0);
             i8 = __THREW__;
             __THREW__ = 0;
             if (i8 & 1) i7 = 42; else {
              HEAP32[gb + 1100104 + 4 >> 2] = 0;
              HEAP32[gb + 1100104 >> 2] = gb + 209636 + 8;
              __THREW__ = 0;
              invoke_vii(fb + 4547 | 0, i4 | 0, gb + 1100104 | 0);
              i8 = __THREW__;
              __THREW__ = 0;
              if (i8 & 1) i7 = 42; else {
               HEAP32[gb + 1100112 + 4 >> 2] = 0;
               HEAP32[gb + 1100112 >> 2] = gb + 209700 + 8;
               __THREW__ = 0;
               invoke_vii(fb + 4548 | 0, i4 | 0, gb + 1100112 | 0);
               i8 = __THREW__;
               __THREW__ = 0;
               if (i8 & 1) i7 = 42; else {
                HEAP32[gb + 1100120 + 4 >> 2] = 0;
                HEAP32[gb + 1100120 >> 2] = gb + 209764 + 8;
                __THREW__ = 0;
                invoke_vii(fb + 4549 | 0, i4 | 0, gb + 1100120 | 0);
                i8 = __THREW__;
                __THREW__ = 0;
                if (i8 & 1) i7 = 42; else {
                 HEAP32[gb + 1100128 + 4 >> 2] = 0;
                 HEAP32[gb + 1100128 >> 2] = gb + 209816 + 8;
                 __THREW__ = 0;
                 invoke_vii(fb + 4550 | 0, i4 | 0, gb + 1100128 | 0);
                 i8 = __THREW__;
                 __THREW__ = 0;
                 if (i8 & 1) i7 = 42; else {
                  HEAP32[gb + 1100136 + 4 >> 2] = 0;
                  HEAP32[gb + 1100136 >> 2] = gb + 211636 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4551 | 0, i4 | 0, gb + 1100136 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100144 + 4 >> 2] = 0;
                  HEAP32[gb + 1100144 >> 2] = gb + 211692 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4552 | 0, i4 | 0, gb + 1100144 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100152 + 4 >> 2] = 0;
                  HEAP32[gb + 1100152 >> 2] = gb + 211748 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4553 | 0, i4 | 0, gb + 1100152 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100160 + 4 >> 2] = 0;
                  HEAP32[gb + 1100160 >> 2] = gb + 211804 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4554 | 0, i4 | 0, gb + 1100160 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100168 + 4 >> 2] = 0;
                  HEAP32[gb + 1100168 >> 2] = gb + 212084 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4555 | 0, i4 | 0, gb + 1100168 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100176 + 4 >> 2] = 0;
                  HEAP32[gb + 1100176 >> 2] = gb + 212112 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4556 | 0, i4 | 0, gb + 1100176 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100184 + 4 >> 2] = 0;
                  HEAP32[gb + 1100184 >> 2] = gb + 212140 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4557 | 0, i4 | 0, gb + 1100184 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100192 + 4 >> 2] = 0;
                  HEAP32[gb + 1100192 >> 2] = gb + 212168 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4558 | 0, i4 | 0, gb + 1100192 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100200 + 4 >> 2] = 0;
                  HEAP32[gb + 1100200 >> 2] = gb + 209868 + 8;
                  HEAP32[gb + 1100200 + 8 >> 2] = gb + 209868 + 56;
                  __THREW__ = 0;
                  invoke_vii(fb + 4559 | 0, i4 | 0, gb + 1100200 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100216 + 4 >> 2] = 0;
                  HEAP32[gb + 1100216 >> 2] = gb + 209952 + 8;
                  HEAP32[gb + 1100216 + 8 >> 2] = gb + 209952 + 56;
                  __THREW__ = 0;
                  invoke_vii(fb + 4560 | 0, i4 | 0, gb + 1100216 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100232 + 4 >> 2] = 0;
                  HEAP32[gb + 1100232 >> 2] = gb + 213148 + 8;
                  __THREW__ = 0;
                  i1 = invoke_i(fb + 314 | 0) | 0;
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i1 = ___cxa_find_matching_catch_2() | 0;
                   getTempRet0() | 0;
                   break;
                  }
                  HEAP32[gb + 1100232 + 8 >> 2] = i1;
                  HEAP32[gb + 1100232 >> 2] = gb + 211540 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4561 | 0, i4 | 0, gb + 1100232 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100248 + 4 >> 2] = 0;
                  HEAP32[gb + 1100248 >> 2] = gb + 213148 + 8;
                  __THREW__ = 0;
                  i1 = invoke_i(fb + 314 | 0) | 0;
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i1 = ___cxa_find_matching_catch_2() | 0;
                   getTempRet0() | 0;
                   break;
                  }
                  HEAP32[gb + 1100248 + 8 >> 2] = i1;
                  HEAP32[gb + 1100248 >> 2] = gb + 211564 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4562 | 0, i4 | 0, gb + 1100248 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100264 + 4 >> 2] = 0;
                  HEAP32[gb + 1100264 >> 2] = gb + 212196 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4563 | 0, i4 | 0, gb + 1100264 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  HEAP32[gb + 1100272 + 4 >> 2] = 0;
                  HEAP32[gb + 1100272 >> 2] = gb + 212228 + 8;
                  __THREW__ = 0;
                  invoke_vii(fb + 4564 | 0, i4 | 0, gb + 1100272 | 0);
                  i8 = __THREW__;
                  __THREW__ = 0;
                  if (i8 & 1) {
                   i7 = 42;
                   break;
                  }
                  return;
                 }
                }
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   } while (0);
   if ((i7 | 0) == 42) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i6);
 }
 ___resumeException(i1 | 0);
}

function __ZN5physx2Gu5RTree17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 704 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i24 >> 2] = HEAP32[gb + 135076 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 135076 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 135076 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 135076 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 135076 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 135076 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 135076 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 135076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 135108 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 135108 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 135108 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 135108 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 135108 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 135108 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 135108 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 135108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 135140 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 135140 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 135140 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 135140 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 135140 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 135140 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 135140 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 135140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 135172 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 135172 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 135172 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 135172 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 135172 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 135172 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 135172 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 135172 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 135204 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 135204 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 135204 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 135204 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 135204 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 135204 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 135204 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 135204 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 135236 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 135236 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 135236 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 135236 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 135236 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 135236 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 135236 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 135236 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 135268 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 135268 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 135268 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 135268 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 135268 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 135268 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 135268 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 135268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 135300 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 135300 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 135300 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 135300 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 135300 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 135300 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 135300 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 135300 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 135332 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 135332 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 135332 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 135332 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 135332 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 135332 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 135332 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 135332 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 135364 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 135364 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 135364 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 135364 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 135364 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 135364 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 135364 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 135364 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 135396 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 135396 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 135396 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 135396 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 135396 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 135396 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 135396 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 135396 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 135428 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 135428 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 135428 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 135428 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 135428 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 135428 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 135428 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 135428 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 135460 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 135460 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 135460 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 135460 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 135460 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 135460 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 135460 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 135460 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 135492 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 135492 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 135492 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 135492 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 135492 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 135492 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 135492 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 135492 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 135524 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 135524 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 135524 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 135524 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 135524 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 135524 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 135524 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 135524 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 135556 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 135556 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 135556 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 135556 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 135556 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 135556 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 135556 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 135556 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 135588 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 135588 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 135588 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 135588 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 135588 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 135588 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 135588 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 135588 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 135620 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 135620 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 135620 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 135620 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 135620 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 135620 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 135620 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 135620 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 135652 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 135652 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 135652 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 135652 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 135652 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 135652 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 135652 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 135652 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 135684 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 135684 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 135684 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 135684 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 135684 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 135684 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 135684 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 135684 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 135716 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 135716 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 135716 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 135716 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 135716 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 135716 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 135716 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 135716 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 135748 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 135748 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 135748 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 135748 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 135748 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 135748 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 135748 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 135748 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN25ConvexVsMeshSweepCallbackC2ERKN5physx2Gu14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEbfb(i11, i6, i3, i10, i2, i9, i12, f4, i5, i8, f7, i1) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i8 = i8 | 0;
 f7 = Math_fround(f7);
 i1 = i1 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, f43 = f0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i13 + 64 | 0;
 i44 = i13 + 112 | 0;
 i38 = i13 + 80 | 0;
 i56 = i13 + 48 | 0;
 i23 = i13 + 96 | 0;
 i17 = i13 + 32 | 0;
 i16 = i13 + 16 | 0;
 i15 = i13;
 HEAP32[i11 + 4 >> 2] = 2;
 HEAP32[i11 >> 2] = gb + 84784 + 8;
 i14 = i11 + 16 | 0;
 i50 = i11 + 80 | 0;
 HEAP32[i11 + 96 >> 2] = 0;
 i19 = i11 + 32 | 0;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 i18 = i11 + 48 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i48 >> 2] = 0;
 HEAP32[i48 + 4 >> 2] = 0;
 HEAP32[i48 + 8 >> 2] = 0;
 HEAP32[i48 + 12 >> 2] = 0;
 HEAP32[i50 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
 i50 = i11 + 272 | 0;
 HEAP32[i48 >> 2] = 0;
 HEAP32[i48 + 4 >> 2] = 0;
 HEAP32[i48 + 8 >> 2] = 0;
 HEAP32[i48 + 12 >> 2] = 0;
 HEAP32[i50 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 i50 = i11 + 224 | 0;
 HEAPF32[i50 >> 2] = Math_fround(1.0);
 i48 = i11 + 228 | 0;
 HEAP32[i48 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 i44 = i11 + 244 | 0;
 HEAPF32[i44 >> 2] = Math_fround(1.0);
 i42 = i11 + 248 | 0;
 HEAP32[i42 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 i38 = i11 + 264 | 0;
 HEAPF32[i38 >> 2] = Math_fround(1.0);
 i37 = i11 + 268 | 0;
 HEAPF32[i37 >> 2] = Math_fround(0.0);
 HEAP32[i56 >> 2] = 0;
 HEAP32[i56 + 4 >> 2] = 0;
 HEAP32[i56 + 8 >> 2] = 0;
 HEAP32[i56 + 12 >> 2] = 0;
 HEAP32[i11 + 288 >> 2] = 0;
 i33 = i11 + 292 | 0;
 HEAP32[i33 >> 2] = 0;
 i32 = i11 + 296 | 0;
 HEAP32[i32 >> 2] = 0;
 i31 = i11 + 300 | 0;
 HEAP32[i31 >> 2] = 1065353216;
 i55 = i11 + 304 | 0;
 HEAP32[i55 >> 2] = HEAP32[i56 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
 HEAP32[i11 + 320 >> 2] = i10;
 HEAP32[i11 + 324 >> 2] = 0;
 HEAP32[i11 + 328 >> 2] = 0;
 HEAP16[i11 + 336 >> 1] = 0;
 i55 = i11 + 340 | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i55 + 4 >> 2] = 0;
 HEAP32[i55 + 8 >> 2] = 0;
 HEAP32[i55 + 12 >> 2] = 0;
 HEAP32[i55 + 16 >> 2] = 0;
 HEAP32[i55 + 20 >> 2] = 0;
 HEAP32[i11 + 416 >> 2] = HEAP32[i12 >> 2];
 i55 = i12 + 4 | 0;
 HEAP32[i11 + 420 >> 2] = HEAP32[i55 >> 2];
 i10 = i12 + 8 | 0;
 HEAP32[i11 + 424 >> 2] = HEAP32[i10 >> 2];
 HEAPF32[i11 + 440 >> 2] = f7;
 HEAP16[i11 + 444 >> 1] = HEAP16[i5 >> 1] | 0;
 HEAP8[i11 + 446 >> 0] = i1 & 1;
 HEAP8[i11 + 447 >> 0] = i8 & 1;
 HEAP8[i11 + 448 >> 0] = 0;
 HEAPF32[i11 + 364 >> 2] = f4;
 HEAP32[i11 + 332 >> 2] = -1;
 f49 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
 f52 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * Math_fround(2.0));
 f53 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
 f41 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f47 = Math_fround(Math_fround(f41 * f41) + Math_fround(-.5));
 f30 = Math_fround(HEAPF32[i9 >> 2]);
 f45 = Math_fround(f49 * f30);
 f54 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f52 * f54));
 f24 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f53 * f24));
 f7 = Math_fround(Math_fround(f54 * f45) + Math_fround(Math_fround(f52 * f47) - Math_fround(f41 * Math_fround(Math_fround(f49 * f24) - Math_fround(f53 * f30)))));
 f27 = Math_fround(Math_fround(Math_fround(f53 * f47) - Math_fround(f41 * Math_fround(Math_fround(f52 * f30) - Math_fround(f49 * f54)))) + Math_fround(f24 * f45));
 HEAPF32[i11 + 428 >> 2] = Math_fround(Math_fround(f30 * f45) + Math_fround(Math_fround(f49 * f47) - Math_fround(f41 * Math_fround(Math_fround(f53 * f54) - Math_fround(f52 * f24)))));
 HEAPF32[i11 + 432 >> 2] = f7;
 HEAPF32[i11 + 436 >> 2] = f27;
 f27 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(HEAPF32[i55 >> 2]);
 f24 = Math_fround(HEAPF32[i10 >> 2]);
 f52 = Math_fround(HEAPF32[i9 >> 2]);
 f54 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f53 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f41 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 i8 = i9 + 16 | 0;
 f47 = Math_fround(HEAPF32[i8 >> 2]);
 f49 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f45 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i8 = i2 + 16 | 0;
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f21 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f51 = Math_fround(-f30);
 f46 = Math_fround(-f25);
 f39 = Math_fround(-f20);
 f47 = Math_fround(f47 - f22);
 f49 = Math_fround(f49 - f21);
 f45 = Math_fround(f45 - f29);
 f28 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f34 = Math_fround(Math_fround(Math_fround(f47 * f51) + Math_fround(f49 * f46)) + Math_fround(f45 * f39));
 f36 = Math_fround(Math_fround(Math_fround(f34 * f51) + Math_fround(Math_fround(f28 * f47) + Math_fround(f26 * Math_fround(Math_fround(f45 * f46) - Math_fround(f49 * f39))))) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(Math_fround(f34 * f46) + Math_fround(Math_fround(f28 * f49) + Math_fround(f26 * Math_fround(Math_fround(f47 * f39) - Math_fround(f45 * f51))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f45) + Math_fround(f26 * Math_fround(Math_fround(f49 * f51) - Math_fround(f47 * f46)))) + Math_fround(f34 * f39)) * Math_fround(2.0));
 f47 = Math_fround(Math_fround(f41 * f26) - Math_fround(Math_fround(Math_fround(f52 * f51) + Math_fround(f54 * f46)) + Math_fround(f53 * f39)));
 f49 = Math_fround(Math_fround(Math_fround(f53 * f46) - Math_fround(f54 * f39)) + Math_fround(Math_fround(f41 * f51) + Math_fround(f52 * f26)));
 f45 = Math_fround(Math_fround(Math_fround(f52 * f39) - Math_fround(f53 * f51)) + Math_fround(Math_fround(f41 * f46) + Math_fround(f54 * f26)));
 f53 = Math_fround(Math_fround(Math_fround(f54 * f51) - Math_fround(f52 * f46)) + Math_fround(Math_fround(f41 * f39) + Math_fround(f53 * f26)));
 f39 = Math_fround(f49 + f49);
 f41 = Math_fround(f45 + f45);
 f46 = Math_fround(f53 + f53);
 f52 = Math_fround(f45 * f41);
 f51 = Math_fround(f53 * f46);
 f45 = Math_fround(f45 * f39);
 f54 = Math_fround(f53 * f39);
 f40 = Math_fround(f47 * f39);
 f53 = Math_fround(f53 * f41);
 f41 = Math_fround(f47 * f41);
 f46 = Math_fround(f47 * f46);
 f39 = Math_fround(Math_fround(1.0) - Math_fround(f49 * f39));
 f49 = Math_fround(f45 + f46);
 f47 = Math_fround(f54 - f41);
 f46 = Math_fround(f45 - f46);
 f45 = Math_fround(f39 - f51);
 f43 = Math_fround(f53 + f40);
 f41 = Math_fround(f54 + f41);
 f40 = Math_fround(f53 - f40);
 f39 = Math_fround(f39 - f52);
 HEAPF32[i50 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f52) - f51);
 HEAPF32[i48 >> 2] = f49;
 HEAPF32[i11 + 232 >> 2] = f47;
 HEAPF32[i11 + 236 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 240 >> 2] = f46;
 HEAPF32[i44 >> 2] = f45;
 HEAPF32[i42 >> 2] = f43;
 HEAPF32[i11 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 256 >> 2] = f41;
 HEAPF32[i11 + 260 >> 2] = f40;
 HEAPF32[i38 >> 2] = f39;
 HEAPF32[i37 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 272 >> 2] = f36;
 HEAPF32[i11 + 276 >> 2] = f35;
 HEAPF32[i11 + 280 >> 2] = f34;
 HEAPF32[i11 + 284 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 288 >> 2] = f30;
 HEAPF32[i33 >> 2] = f25;
 HEAPF32[i32 >> 2] = f20;
 HEAPF32[i31 >> 2] = f26;
 HEAPF32[i11 + 304 >> 2] = f22;
 HEAPF32[i11 + 308 >> 2] = f21;
 HEAPF32[i11 + 312 >> 2] = f29;
 HEAPF32[i11 + 316 >> 2] = Math_fround(0.0);
 f27 = Math_fround(-Math_fround(f27 * f4));
 f7 = Math_fround(-Math_fround(f7 * f4));
 f24 = Math_fround(-Math_fround(f24 * f4));
 f29 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f25 * f7)) + Math_fround(f20 * f24));
 f21 = Math_fround(Math_fround(Math_fround(f25 * f29) + Math_fround(Math_fround(f28 * f7) - Math_fround(f26 * Math_fround(Math_fround(f20 * f27) - Math_fround(f30 * f24))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(f20 * f29) + Math_fround(Math_fround(f28 * f24) - Math_fround(f26 * Math_fround(Math_fround(f30 * f7) - Math_fround(f25 * f27))))) * Math_fround(2.0));
 HEAPF32[i11 + 400 >> 2] = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * Math_fround(Math_fround(f25 * f24) - Math_fround(f20 * f7))))) * Math_fround(2.0));
 HEAPF32[i11 + 404 >> 2] = f21;
 HEAPF32[i11 + 408 >> 2] = f22;
 HEAPF32[i11 + 412 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 384 >> 2] = f4;
 i8 = i11 + 388 | 0;
 HEAP32[i8 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 i8 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i10 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i17 >> 2] = i8;
 HEAP32[i17 + 4 >> 2] = i9;
 HEAP32[i17 + 8 >> 2] = i10;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 i2 = i3 + 12 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 i12 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = i3;
 HEAP32[i16 + 8 >> 2] = i5;
 HEAP32[i16 + 12 >> 2] = i12;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i12 = (HEAP32[i6 + 40 >> 2] | 0) + ((HEAPU8[i6 + 39 >> 0] | 0) * 20 | 0) | 0;
 f22 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f21 = Math_fround(HEAPF32[i6 + 56 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 60 >> 2]);
 f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f22 * f20);
 f4 = Math_fround(f21 * f4);
 f7 = Math_fround(f7 * (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = f20 <= f4 ? f20 : f4;
 f7 = f4 <= f7 ? f4 : f7;
 HEAPF32[i19 >> 2] = Math_fround(f7 * Math_fround(.200000003));
 HEAPF32[i18 >> 2] = Math_fround(f7 * Math_fround(.100000001));
 __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_(i17, i16, i11 + 112 | 0, i11 + 160 | 0);
 HEAP32[i11 + 216 >> 2] = i12;
 HEAP8[i11 + 220 >> 0] = HEAP8[i6 + 38 >> 0] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i12 = HEAP32[i6 + 44 >> 2] | 0;
 HEAP32[i11 + 212 >> 2] = i12;
 HEAP32[i11 + 208 >> 2] = i6;
 if (!i12) {
  i56 = i11 + 449 | 0;
  HEAP8[i56 >> 0] = 0;
  STACKTOP = i13;
  return;
 }
 i56 = i11 + 449 | 0;
 HEAP8[i56 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx18NpArticulationLink17setCMassLocalPoseERKNS_11PxTransformE(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i35 + 56 | 0;
 i15 = i35 + 28 | 0;
 i34 = i35;
 f38 = Math_fround(HEAPF32[i1 >> 2]);
 f40 = Math_fround(f38 * f38);
 f36 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f40 = Math_fround(f40 + Math_fround(f36 * f36));
 f30 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f40 = Math_fround(f40 + Math_fround(f30 * f30));
 f39 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f40 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f40 + Math_fround(f39 * f39)))));
 f38 = Math_fround(f38 * f40);
 f36 = Math_fround(f36 * f40);
 f30 = Math_fround(f30 * f40);
 f40 = Math_fround(f39 * f40);
 HEAPF32[i25 >> 2] = f38;
 HEAPF32[i25 + 4 >> 2] = f36;
 HEAPF32[i25 + 8 >> 2] = f30;
 HEAPF32[i25 + 12 >> 2] = f40;
 i23 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i25 + 16 >> 2] = i23;
 i24 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i25 + 20 >> 2] = i24;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i25 + 24 >> 2] = i1;
 i22 = (HEAP32[i20 + 284 >> 2] & 512 | 0) == 0 ? i20 + 112 | 0 : (HEAP32[i20 + 56 >> 2] | 0) + 144 | 0;
 f39 = Math_fround(HEAPF32[i22 >> 2]);
 f37 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f41 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i22 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i22 + 20 >> 2]);
 f29 = Math_fround(HEAPF32[i22 + 24 >> 2]);
 f38 = Math_fround(-f38);
 f36 = Math_fround(-f36);
 f30 = Math_fround(-f30);
 f27 = Math_fround(f27 - (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f28 = Math_fround(f28 - (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f28 = Math_fround(f28 * Math_fround(2.0));
 f29 = Math_fround(Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(2.0));
 f42 = Math_fround(Math_fround(f40 * f40) + Math_fround(-.5));
 f33 = Math_fround(Math_fround(Math_fround(f27 * f38) + Math_fround(f28 * f36)) + Math_fround(f29 * f30));
 f31 = Math_fround(Math_fround(f33 * f38) + Math_fround(Math_fround(f42 * f27) + Math_fround(f40 * Math_fround(Math_fround(f29 * f36) - Math_fround(f28 * f30)))));
 f32 = Math_fround(Math_fround(f33 * f36) + Math_fround(Math_fround(f42 * f28) + Math_fround(f40 * Math_fround(Math_fround(f27 * f30) - Math_fround(f29 * f38)))));
 f33 = Math_fround(Math_fround(Math_fround(f42 * f29) + Math_fround(f40 * Math_fround(Math_fround(f28 * f38) - Math_fround(f27 * f36)))) + Math_fround(f33 * f30));
 f27 = Math_fround(Math_fround(Math_fround(f21 * f36) + Math_fround(Math_fround(f41 * f38) + Math_fround(f39 * f40))) - Math_fround(f37 * f30));
 f28 = Math_fround(Math_fround(Math_fround(f39 * f30) + Math_fround(Math_fround(f41 * f36) + Math_fround(f37 * f40))) - Math_fround(f21 * f38));
 f29 = Math_fround(Math_fround(Math_fround(f37 * f38) + Math_fround(Math_fround(f41 * f30) + Math_fround(f21 * f40))) - Math_fround(f39 * f36));
 f30 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) - Math_fround(f39 * f38)) - Math_fround(f37 * f36)) - Math_fround(f21 * f30));
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setCMassLocalPoseInternalERKNS_11PxTransformE(i20, i25);
 i1 = HEAP32[i20 + 292 >> 2] | 0;
 do if (i1 | 0) {
  i18 = i1 + 8 | 0;
  i19 = i1 + 12 | 0;
  i8 = i1 + 16 | 0;
  i11 = (HEAP32[i19 >> 2] & 2 | 0) == 0 ? i1 + 52 | 0 : (HEAP32[i8 >> 2] | 0) + 28 | 0;
  f43 = Math_fround(HEAPF32[i11 >> 2]);
  f21 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f36 = Math_fround(HEAPF32[i11 + 16 >> 2]);
  f37 = Math_fround(HEAPF32[i11 + 20 >> 2]);
  f36 = Math_fround(f36 * Math_fround(2.0));
  f37 = Math_fround(f37 * Math_fround(2.0));
  f38 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) * Math_fround(2.0));
  f45 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
  f42 = Math_fround(Math_fround(Math_fround(f27 * f36) + Math_fround(f28 * f37)) + Math_fround(f29 * f38));
  f40 = Math_fround(f31 + Math_fround(Math_fround(f27 * f42) + Math_fround(Math_fround(f45 * f36) + Math_fround(f30 * Math_fround(Math_fround(f28 * f38) - Math_fround(f29 * f37))))));
  f41 = Math_fround(f32 + Math_fround(Math_fround(f28 * f42) + Math_fround(Math_fround(f45 * f37) + Math_fround(f30 * Math_fround(Math_fround(f29 * f36) - Math_fround(f27 * f38))))));
  f42 = Math_fround(f33 + Math_fround(Math_fround(Math_fround(f45 * f38) + Math_fround(f30 * Math_fround(Math_fround(f27 * f37) - Math_fround(f28 * f36)))) + Math_fround(f29 * f42)));
  f36 = Math_fround(Math_fround(Math_fround(f28 * f39) + Math_fround(Math_fround(f30 * f43) + Math_fround(f27 * f44))) - Math_fround(f29 * f21));
  f37 = Math_fround(Math_fround(Math_fround(f29 * f43) + Math_fround(Math_fround(f30 * f21) + Math_fround(f28 * f44))) - Math_fround(f27 * f39));
  f38 = Math_fround(Math_fround(Math_fround(f27 * f21) + Math_fround(Math_fround(f30 * f39) + Math_fround(f29 * f44))) - Math_fround(f28 * f43));
  f39 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f44) - Math_fround(f27 * f43)) - Math_fround(f28 * f21)) - Math_fround(f29 * f39));
  HEAPF32[i15 >> 2] = f36;
  i11 = i15 + 4 | 0;
  HEAPF32[i11 >> 2] = f37;
  i12 = i15 + 8 | 0;
  HEAPF32[i12 >> 2] = f38;
  i13 = i15 + 12 | 0;
  HEAPF32[i13 >> 2] = f39;
  HEAPF32[i15 + 16 >> 2] = f40;
  i16 = i15 + 20 | 0;
  HEAPF32[i16 >> 2] = f41;
  i17 = i15 + 24 | 0;
  HEAPF32[i17 >> 2] = f42;
  i5 = i1 + 20 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  i9 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i14 = i18;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i18 >> 2] | 0) + 2433 >> 0] | 0)) i26 = 5; else i14 = i18;
    break;
   }
  default:
   i26 = 5;
  }
  if ((i26 | 0) == 5) {
   __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE(i5, i15);
   break;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  if (!i5) {
   i5 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i14 >> 2] | 0, i7 >>> 24 & 15) | 0;
   HEAP32[i8 >> 2] = i5;
   i9 = HEAP32[i15 >> 2] | 0;
   i7 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i15 + 16 >> 2] | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i17 >> 2] | 0;
  } else i7 = i10;
  HEAP32[i5 + 28 >> 2] = i9;
  HEAP32[i5 + 32 >> 2] = i7;
  HEAP32[i5 + 36 >> 2] = i6;
  HEAP32[i5 + 40 >> 2] = i4;
  HEAP32[i5 + 44 >> 2] = i3;
  HEAP32[i5 + 48 >> 2] = i2;
  HEAP32[i5 + 52 >> 2] = i1;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i14 >> 2] | 0, i18);
  HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
 } while (0);
 i25 = i20 + 324 | 0;
 if (!(HEAP32[i25 >> 2] | 0)) {
  STACKTOP = i35;
  return;
 }
 i13 = i20 + 320 | 0;
 f21 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 i14 = i34 + 4 | 0;
 i15 = i34 + 8 | 0;
 i16 = i34 + 12 | 0;
 i17 = i34 + 16 | 0;
 i18 = i34 + 20 | 0;
 i19 = i34 + 24 | 0;
 i20 = i34 + 16 | 0;
 i24 = 0;
 do {
  i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i24 << 2) >> 2] | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 228 >> 2] | 0, i4 | 0) | 0;
  i22 = i4 + 8 | 0;
  i23 = i4 + 12 | 0;
  i5 = HEAP32[i23 >> 2] | 0;
  i6 = i4 + 16 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i7 = (i5 & 1 | 0) == 0 ? i4 + 24 | 0 : i8;
  f37 = Math_fround(HEAPF32[i7 >> 2]);
  f38 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  f39 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f40 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f39 = Math_fround(f39 * Math_fround(2.0));
  f40 = Math_fround(f40 * Math_fround(2.0));
  f41 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
  f45 = Math_fround(Math_fround(Math_fround(f27 * f39) + Math_fround(f28 * f40)) + Math_fround(f29 * f41));
  f43 = Math_fround(f31 + Math_fround(Math_fround(f27 * f45) + Math_fround(Math_fround(f21 * f39) + Math_fround(f30 * Math_fround(Math_fround(f28 * f41) - Math_fround(f29 * f40))))));
  f44 = Math_fround(f32 + Math_fround(Math_fround(f28 * f45) + Math_fround(Math_fround(f21 * f40) + Math_fround(f30 * Math_fround(Math_fround(f29 * f39) - Math_fround(f27 * f41))))));
  f45 = Math_fround(f33 + Math_fround(Math_fround(Math_fround(f21 * f41) + Math_fround(f30 * Math_fround(Math_fround(f27 * f40) - Math_fround(f28 * f39)))) + Math_fround(f29 * f45)));
  f39 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(Math_fround(f30 * f37) + Math_fround(f27 * f36))) - Math_fround(f29 * f38));
  f40 = Math_fround(Math_fround(Math_fround(f29 * f37) + Math_fround(Math_fround(f30 * f38) + Math_fround(f28 * f36))) - Math_fround(f27 * f42));
  f41 = Math_fround(Math_fround(Math_fround(f27 * f38) + Math_fround(Math_fround(f30 * f42) + Math_fround(f29 * f36))) - Math_fround(f28 * f37));
  f42 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f36) - Math_fround(f27 * f37)) - Math_fround(f28 * f38)) - Math_fround(f29 * f42));
  HEAPF32[i34 >> 2] = f39;
  HEAPF32[i14 >> 2] = f40;
  HEAPF32[i15 >> 2] = f41;
  HEAPF32[i16 >> 2] = f42;
  HEAPF32[i17 >> 2] = f43;
  HEAPF32[i18 >> 2] = f44;
  HEAPF32[i19 >> 2] = f45;
  i4 = i4 + 20 | 0;
  i7 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
  switch (i5 >>> 30 | 0) {
  case 3:
   {
    i12 = i22;
    i26 = 15;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i22 >> 2] | 0) + 2433 >> 0] | 0)) i26 = 14; else {
     i12 = i22;
     i26 = 15;
    }
    break;
   }
  default:
   i26 = 14;
  }
  if ((i26 | 0) == 14) __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE(i4, i34); else if ((i26 | 0) == 15) {
   if (!i8) {
    i8 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i12 >> 2] | 0, i5 >>> 24 & 15) | 0;
    HEAP32[i6 >> 2] = i8;
    i7 = HEAP32[i34 >> 2] | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i20 >> 2] | 0;
    i2 = HEAP32[i18 >> 2] | 0;
    i1 = HEAP32[i19 >> 2] | 0;
   } else {
    i6 = i9;
    i5 = i10;
    i4 = i11;
   }
   HEAP32[i8 >> 2] = i7;
   HEAP32[i8 + 4 >> 2] = i6;
   HEAP32[i8 + 8 >> 2] = i5;
   HEAP32[i8 + 12 >> 2] = i4;
   HEAP32[i8 + 16 >> 2] = i3;
   HEAP32[i8 + 20 >> 2] = i2;
   HEAP32[i8 + 24 >> 2] = i1;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i12 >> 2] | 0, i22);
   HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 1;
  }
  i24 = i24 + 1 | 0;
 } while (i24 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
 STACKTOP = i35;
 return;
}

function __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_(i1, i2, i23) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33;
 i32 = i2;
 L1 : while (1) {
  i20 = i32;
  i30 = i32 + -36 | 0;
  i21 = i32 + -8 | 0;
  i24 = i32 + -32 | 0;
  i25 = i32 + -28 | 0;
  i26 = i32 + -24 | 0;
  i27 = i32 + -20 | 0;
  i28 = i32 + -16 | 0;
  i29 = i32 + -12 | 0;
  while (1) {
   i19 = i1;
   L5 : while (1) {
    i16 = i19;
    i1 = i20 - i16 | 0;
    switch ((i1 | 0) / 36 | 0 | 0) {
    case 2:
     {
      i22 = 5;
      break L1;
     }
    case 3:
     {
      i22 = 7;
      break L1;
     }
    case 4:
     {
      i22 = 8;
      break L1;
     }
    case 5:
     {
      i22 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i22 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i1 | 0) < 252) {
     i22 = 11;
     break L1;
    }
    i2 = (i1 >>> 0) / 72 | 0;
    i15 = i19 + (i2 * 36 | 0) | 0;
    if ((i1 | 0) > 35964) {
     i1 = (i1 >>> 0) / 144 | 0;
     i1 = __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_(i19, i19 + (i1 * 36 | 0) | 0, i15, i15 + (i1 * 36 | 0) | 0, i30, i23) | 0;
    } else i1 = __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i19, i15, i30, i23) | 0;
    i12 = i19 + 28 | 0;
    f13 = Math_fround(HEAPF32[i12 >> 2]);
    f8 = Math_fround(HEAPF32[i19 + (i2 * 36 | 0) + 28 >> 2]);
    if (f13 < f8) {
     i2 = i30;
     break;
    } else i11 = i30;
    while (1) {
     i2 = i11 + -36 | 0;
     if ((i19 | 0) == (i2 | 0)) break;
     if (Math_fround(HEAPF32[i11 + -8 >> 2]) < f8) {
      i22 = 35;
      break L5;
     } else i11 = i2;
    }
    i3 = i19 + 36 | 0;
    if (!(f13 < Math_fround(HEAPF32[i21 >> 2]))) {
     if ((i3 | 0) == (i30 | 0)) {
      i22 = 52;
      break L1;
     } else i1 = i3;
     while (1) {
      if (f13 < Math_fround(HEAPF32[i1 + 28 >> 2])) break;
      i1 = i1 + 36 | 0;
      if ((i1 | 0) == (i30 | 0)) {
       i22 = 52;
       break L1;
      }
     }
     i2 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i5 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i1 + 12 >> 2] | 0;
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i9 = HEAP32[i1 + 20 >> 2] | 0;
     i3 = i1 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i3 = i1;
     i17 = i30;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i30 >> 2] = i2;
     HEAP32[i24 >> 2] = i4;
     HEAP32[i25 >> 2] = i5;
     HEAP32[i26 >> 2] = i6;
     HEAP32[i27 >> 2] = i7;
     HEAP32[i28 >> 2] = i9;
     HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i29 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i29 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i3 = i1 + 36 | 0;
    }
    if ((i3 | 0) == (i30 | 0)) {
     i22 = 52;
     break L1;
    } else i1 = i30;
    while (1) {
     f8 = Math_fround(HEAPF32[i12 >> 2]);
     while (1) {
      i11 = i3 + 36 | 0;
      if (f8 < Math_fround(HEAPF32[i3 + 28 >> 2])) break; else i3 = i11;
     }
     while (1) {
      i10 = i1 + -36 | 0;
      if (f8 < Math_fround(HEAPF32[i1 + -8 >> 2])) i1 = i10; else break;
     }
     if (i3 >>> 0 >= i10 >>> 0) {
      i19 = i3;
      continue L5;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i3 + 4 >> 2] | 0;
     i5 = HEAP32[i3 + 8 >> 2] | 0;
     i6 = HEAP32[i3 + 12 >> 2] | 0;
     i7 = HEAP32[i3 + 16 >> 2] | 0;
     i9 = HEAP32[i3 + 20 >> 2] | 0;
     i17 = i3 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     i17 = i10;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i2;
     HEAP32[i1 + -32 >> 2] = i4;
     HEAP32[i1 + -28 >> 2] = i5;
     HEAP32[i1 + -24 >> 2] = i6;
     HEAP32[i1 + -20 >> 2] = i7;
     HEAP32[i1 + -16 >> 2] = i9;
     i1 = i1 + -12 | 0;
     HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i1 = i10;
     i3 = i11;
    }
   }
   if ((i22 | 0) == 35) {
    i22 = 0;
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = HEAP32[i19 + 8 >> 2] | 0;
    i7 = HEAP32[i19 + 12 >> 2] | 0;
    i9 = HEAP32[i19 + 16 >> 2] | 0;
    i10 = HEAP32[i19 + 20 >> 2] | 0;
    i3 = i19 + 24 | 0;
    HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i3 = i19;
    i17 = i2;
    i18 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
     i3 = i3 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i3 | 0) < (i18 | 0));
    HEAP32[i2 >> 2] = i4;
    HEAP32[i11 + -32 >> 2] = i5;
    HEAP32[i11 + -28 >> 2] = i6;
    HEAP32[i11 + -24 >> 2] = i7;
    HEAP32[i11 + -20 >> 2] = i9;
    HEAP32[i11 + -16 >> 2] = i10;
    i18 = i11 + -12 | 0;
    HEAP32[i18 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   i3 = i19 + 36 | 0;
   L35 : do if (i3 >>> 0 < i2 >>> 0) while (1) {
    f8 = Math_fround(HEAPF32[i15 + 28 >> 2]);
    i11 = i3;
    while (1) {
     i14 = i11 + 36 | 0;
     if (Math_fround(HEAPF32[i11 + 28 >> 2]) < f8) i11 = i14; else break;
    }
    while (1) {
     i12 = i2 + -36 | 0;
     if (Math_fround(HEAPF32[i2 + -8 >> 2]) < f8) break; else i2 = i12;
    }
    if (i11 >>> 0 > i12 >>> 0) {
     i10 = i15;
     break L35;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i11 + 4 >> 2] | 0;
    i6 = HEAP32[i11 + 8 >> 2] | 0;
    i7 = HEAP32[i11 + 12 >> 2] | 0;
    i9 = HEAP32[i11 + 16 >> 2] | 0;
    i10 = HEAP32[i11 + 20 >> 2] | 0;
    i3 = i11 + 24 | 0;
    HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i3 = i11;
    i17 = i12;
    i18 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
     i3 = i3 + 4 | 0;
     i17 = i17 + 4 | 0;
    } while ((i3 | 0) < (i18 | 0));
    HEAP32[i12 >> 2] = i4;
    HEAP32[i2 + -32 >> 2] = i5;
    HEAP32[i2 + -28 >> 2] = i6;
    HEAP32[i2 + -24 >> 2] = i7;
    HEAP32[i2 + -20 >> 2] = i9;
    HEAP32[i2 + -16 >> 2] = i10;
    i2 = i2 + -12 | 0;
    HEAP32[i2 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    i15 = (i15 | 0) == (i11 | 0) ? i12 : i15;
    i2 = i12;
    i3 = i14;
    i1 = i1 + 1 | 0;
   } else {
    i10 = i15;
    i11 = i3;
   } while (0);
   if ((i11 | 0) != (i10 | 0)) {
    f13 = Math_fround(HEAPF32[i10 + 28 >> 2]);
    if (f13 < Math_fround(HEAPF32[i11 + 28 >> 2])) {
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i11 + 4 >> 2] | 0;
     i5 = HEAP32[i11 + 8 >> 2] | 0;
     i6 = HEAP32[i11 + 12 >> 2] | 0;
     i7 = HEAP32[i11 + 16 >> 2] | 0;
     i9 = HEAP32[i11 + 20 >> 2] | 0;
     i3 = i11 + 24 | 0;
     HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i3 = i11;
     i17 = i10;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     HEAP32[i10 >> 2] = i2;
     HEAP32[i10 + 4 >> 2] = i4;
     HEAP32[i10 + 8 >> 2] = i5;
     HEAP32[i10 + 12 >> 2] = i6;
     HEAP32[i10 + 16 >> 2] = i7;
     HEAP32[i10 + 20 >> 2] = i9;
     i18 = i10 + 24 | 0;
     HEAP32[i18 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
     i1 = i1 + 1 | 0;
    }
   }
   if (!i1) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR12RaycastHit2DPS1_EEbT0_S4_T_(i19, i11, i23) | 0;
    i1 = i11 + 36 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR12RaycastHit2DPS1_EEbT0_S4_T_(i1, i32, i23) | 0) {
     i22 = 51;
     break;
    }
    if (i2) continue;
   }
   i18 = i11;
   if ((i18 - i16 | 0) >= (i20 - i18 | 0)) {
    i22 = 50;
    break;
   }
   __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_(i19, i11, i23);
   i1 = i11 + 36 | 0;
  }
  if ((i22 | 0) == 50) {
   i22 = 0;
   __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_(i11 + 36 | 0, i32, i23);
   i1 = i19;
   i32 = i11;
   continue;
  } else if ((i22 | 0) == 51) {
   i22 = 0;
   if (i2) {
    i22 = 52;
    break;
   } else {
    i1 = i19;
    i32 = i11;
    continue;
   }
  }
 }
 if ((i22 | 0) == 5) {
  f13 = Math_fround(HEAPF32[i21 >> 2]);
  if (!(f13 < Math_fround(HEAPF32[i19 + 28 >> 2]))) {
   STACKTOP = i33;
   return;
  }
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = HEAP32[i19 + 4 >> 2] | 0;
  i4 = HEAP32[i19 + 8 >> 2] | 0;
  i5 = HEAP32[i19 + 12 >> 2] | 0;
  i6 = HEAP32[i19 + 16 >> 2] | 0;
  i7 = HEAP32[i19 + 20 >> 2] | 0;
  i3 = i19 + 24 | 0;
  HEAP32[i31 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = i19;
  i17 = i30;
  i18 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
   i3 = i3 + 4 | 0;
   i17 = i17 + 4 | 0;
  } while ((i3 | 0) < (i18 | 0));
  HEAP32[i30 >> 2] = i1;
  HEAP32[i24 >> 2] = i2;
  HEAP32[i25 >> 2] = i4;
  HEAP32[i26 >> 2] = i5;
  HEAP32[i27 >> 2] = i6;
  HEAP32[i28 >> 2] = i7;
  HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 7) {
  __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i19, i19 + 36 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 8) {
  __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_(i19, i19 + 36 | 0, i19 + 72 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 9) {
  __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_(i19, i19 + 36 | 0, i19 + 72 | 0, i19 + 108 | 0, i30, i23) | 0;
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 11) {
  i2 = i19 + 72 | 0;
  __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i19, i19 + 36 | 0, i2, i23) | 0;
  i1 = i19 + 108 | 0;
  if ((i1 | 0) == (i32 | 0)) {
   STACKTOP = i33;
   return;
  }
  while (1) {
   f8 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (f8 < Math_fround(HEAPF32[i2 + 28 >> 2])) {
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i1 + 8 >> 2] | 0;
    i10 = HEAP32[i1 + 12 >> 2] | 0;
    i11 = HEAP32[i1 + 16 >> 2] | 0;
    i12 = HEAP32[i1 + 20 >> 2] | 0;
    i5 = HEAP32[i1 + 24 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i3 = i1;
    while (1) {
     i17 = i2;
     i18 = i3 + 36 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
      i3 = i3 + 4 | 0;
      i17 = i17 + 4 | 0;
     } while ((i3 | 0) < (i18 | 0));
     if ((i2 | 0) == (i19 | 0)) {
      i2 = i19;
      break;
     }
     if (f8 < Math_fround(HEAPF32[i2 + -8 >> 2])) {
      i3 = i2;
      i2 = i2 + -36 | 0;
     } else break;
    }
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 4 >> 2] = i7;
    HEAP32[i2 + 8 >> 2] = i9;
    HEAP32[i2 + 12 >> 2] = i10;
    HEAP32[i2 + 16 >> 2] = i11;
    HEAP32[i2 + 20 >> 2] = i12;
    HEAP32[i2 + 24 >> 2] = i5;
    HEAPF32[i2 + 28 >> 2] = f8;
    HEAP32[i2 + 32 >> 2] = i4;
   }
   i2 = i1 + 36 | 0;
   if ((i2 | 0) == (i32 | 0)) break; else {
    i31 = i1;
    i1 = i2;
    i2 = i31;
   }
  }
  STACKTOP = i33;
  return;
 } else if ((i22 | 0) == 52) {
  STACKTOP = i33;
  return;
 }
}

function __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj541ENS_22PxRepXPropertyAccessorILj541ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 16 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj542ENS_22PxRepXPropertyAccessorILj542ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 32 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj543ENS_22PxRepXPropertyAccessorILj543ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 48 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj544ENS_22PxRepXPropertyAccessorILj544ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 64 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj545ENS_22PxRepXPropertyAccessorILj545ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 80 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj546ENS_22PxRepXPropertyAccessorILj546ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 96 | 0;
  i12 = i9 + 6 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEclILj547ES3_NS3_4EnumES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 7 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 96 | 0;
 i12 = i9 + 6 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEclILj547ES3_NS3_4EnumES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 7 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx21PxcArticulationHelper30computeUnconstrainedVelocitiesERKNS_25PxcArticulationSolverDescEfRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescERjRNS_2Cm13EventProfilerERNS_25PxsConstraintBlockManagerE(i26, f27, i28, i25, i23, i1, i24) {
 i26 = i26 | 0;
 f27 = Math_fround(f27);
 i28 = i28 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 3648 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i22 + 1024 | 0;
 i14 = i22 + 3368 | 0;
 i13 = i22 + 3088 | 0;
 i12 = i22;
 i4 = i22 + 3624 | 0;
 i5 = i22 + 3356 | 0;
 i7 = i22 + 3344 | 0;
 i10 = i22 + 3072 | 0;
 i20 = HEAP32[i26 + 4 >> 2] | 0;
 i11 = HEAP16[i26 + 36 >> 1] | 0;
 i21 = HEAP32[i26 >> 2] | 0;
 i6 = HEAP32[i26 + 12 >> 2] | 0;
 i16 = HEAP32[i26 + 28 >> 2] | 0;
 i8 = HEAP16[i26 + 38 >> 1] | 0;
 i17 = i11 & 65535;
 i18 = i16 + (i17 * 144 | 0) | 0;
 __ZN5physx21PxcArticulationHelper16prepareDataBlockERNS_9PxcFsDataEPKNS_19PxsArticulationLinkEtPNS_11PxTransformEPNS_12PxcFsInertiaEPNS_30PxcArticulationJointTransformsEj(i21, i20, i11, i6, i16, i18, HEAPU16[i26 + 32 >> 1] | 0);
 f29 = Math_fround(Math_fround(1.0) / f27);
 i19 = i21 + 128 | 0;
 i1 = i21 + 24 | 0;
 _memset(i21 + (HEAPU16[i1 >> 1] | 0) | 0, 0, i17 * 400 | 0) | 0;
 __ZN5physx21PxcArticulationHelper16prepareLtbMatrixERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEf(i21, i16, i6, i18, f29);
 __ZN5physx12PxcLtbFactorERNS_9PxcFsDataE(i21);
 i8 = i8 & 65535;
 i9 = i17 * 240 | 0;
 __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE(i15, i21, i19);
 i1 = i21 + (HEAPU16[i1 >> 1] | 0) | 0;
 i3 = (i11 & 65535) > 1;
 if (i3) {
  i2 = 1;
  do {
   i33 = i15 + (i2 << 4) | 0;
   f35 = Math_fround(HEAPF32[i33 >> 2]);
   i31 = i15 + (i2 << 4) + 4 | 0;
   f36 = Math_fround(HEAPF32[i31 >> 2]);
   i30 = i15 + (i2 << 4) + 8 | 0;
   f29 = Math_fround(HEAPF32[i30 >> 2]);
   f34 = Math_fround(HEAPF32[i1 + (i2 * 400 | 0) + 384 >> 2]);
   f32 = Math_fround(HEAPF32[i1 + (i2 * 400 | 0) + 388 >> 2]);
   f32 = Math_fround(f36 + f32);
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i1 + (i2 * 400 | 0) + 392 >> 2]));
   HEAPF32[i33 >> 2] = Math_fround(f35 + f34);
   HEAPF32[i31 >> 2] = f32;
   HEAPF32[i30 >> 2] = f29;
   HEAPF32[i15 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i17 | 0));
 }
 __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE(i21, i19, i15);
 _memset(i21 + (HEAPU16[i21 + 26 >> 1] | 0) | 0, 0, (i17 * 160 | 0) + 144 | 0) | 0;
 __ZN5physx21PxcArticulationHelper13prepareFsDataERNS_9PxcFsDataEPKNS_19PxsArticulationLinkE(i21, i20);
 i2 = i26 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >= 0) {
  _memset(HEAP32[i26 + 16 >> 2] | 0, 0, i17 * 48 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) >= 0) _memset(HEAP32[i26 + 20 >> 2] | 0, 0, i17 * 48 | 0) | 0;
 if (i3) {
  i1 = 1;
  do {
   i33 = HEAP32[i20 + (i1 << 5) + 24 >> 2] | 0;
   f36 = Math_fround(Math_fround(Math_fround(HEAPF32[i33 + 88 >> 2]) * f27) + Math_fround(1.0));
   f36 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(HEAPF32[i33 + 84 >> 2]) * f27) * f27));
   HEAPF32[i14 + (i1 << 2) >> 2] = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i33 + 100 >> 2])) * f36);
   HEAPF32[i13 + (i1 << 2) >> 2] = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i33 + 104 >> 2])) * f36);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i17 | 0));
 }
 i31 = i26 + 20 | 0;
 i30 = HEAP32[i31 >> 2] | 0;
 i33 = HEAP32[HEAP32[i2 >> 2] >> 2] & 65535;
 HEAP32[i4 >> 2] = i16;
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i9;
 HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE(i21, i16, i30, i14, i17, i33, i15);
 i33 = i26 + 16 | 0;
 i4 = HEAP32[i33 >> 2] | 0;
 i30 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] & 65535;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i5 + 4 >> 2] = i8;
 HEAP32[i5 + 8 >> 2] = i9;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE(i21, i16, i4, i13, i17, i30, i15);
 i30 = HEAP32[i31 >> 2] | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i7 + 8 >> 2] = i9;
 HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE(i21, i16, i14, i30, i15);
 __ZN5physx21PxcArticulationHelper18computeJointDrivesERNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPKNS_19PxsArticulationLinkEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEPKNS4_6Mat33VEf(i21, i12, i20, i6, i18, HEAP32[i31 >> 2] | 0, f27);
 __ZN5physx21PxcFsApplyJointDrivesERNS_9PxcFsDataEPKNS_6shdfnd3aos5Vec3VE(i21, i12);
 i33 = HEAP32[i33 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP32[i10 + 8 >> 2] = i9;
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE(i21, i16, i13, i33, i15);
 if (!(i11 << 16 >> 16)) {
  __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_(i21, i15, i19);
  i31 = i26 + 8 | 0;
  i31 = HEAP32[i31 >> 2] | 0;
  i33 = i17 << 5;
  _memcpy(i31 | 0, i19 | 0, i33 | 0) | 0;
  i33 = i21 + 16 | 0;
  i31 = i33;
  HEAP32[i31 >> 2] = 0;
  i33 = i33 + 4 | 0;
  HEAP32[i33 >> 2] = 0;
  i33 = i21 + 12 | 0;
  HEAP16[i33 >> 1] = 0;
  i33 = i21 + 14 | 0;
  HEAP16[i33 >> 1] = 0;
  i33 = i21 + 28 | 0;
  HEAP32[i33 >> 2] = 0;
  i33 = i26 + 34 | 0;
  i33 = HEAP16[i33 >> 1] | 0;
  i33 = i33 & 65535;
  i33 = __ZN5physx21PxcArticulationHelper22setupSolverConstraintsERNS_9PxcFsDataEjRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPKNS_19PxsArticulationLinkEPKNS_30PxcArticulationJointTransformsEfRjRNS_25PxsConstraintBlockManagerE(i21, i33, i28, i25, i20, i18, f27, i23, i24) | 0;
  STACKTOP = i22;
  return i33 | 0;
 } else i1 = 0;
 do {
  i33 = HEAP32[i20 + (i1 << 5) + 16 >> 2] | 0;
  f45 = Math_fround(HEAPF32[i33 >> 2]);
  f43 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f42 = Math_fround(HEAPF32[i33 + 16 >> 2]);
  f38 = Math_fround(HEAPF32[i33 + 20 >> 2]);
  f36 = Math_fround(HEAPF32[i33 + 24 >> 2]);
  f52 = Math_fround(f45 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) >> 2]));
  f52 = Math_fround(f52 + Math_fround(f43 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 16 >> 2])));
  f52 = Math_fround(f52 + Math_fround(f34 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 32 >> 2])));
  f51 = Math_fround(f45 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 4 >> 2]));
  f51 = Math_fround(f51 + Math_fround(f43 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 20 >> 2])));
  f51 = Math_fround(f51 + Math_fround(f34 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 36 >> 2])));
  f50 = Math_fround(f45 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 8 >> 2]));
  f50 = Math_fround(f50 + Math_fround(f43 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 24 >> 2])));
  f50 = Math_fround(f50 + Math_fround(f34 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 40 >> 2])));
  f49 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 48 >> 2]);
  f37 = Math_fround(f42 * f49);
  f47 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 64 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f38 * f47));
  f44 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 80 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f36 * f44));
  f48 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 52 >> 2]);
  f29 = Math_fround(f42 * f48);
  f46 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 68 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f38 * f46));
  f35 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 84 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f36 * f35));
  f41 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 56 >> 2]);
  f32 = Math_fround(f42 * f41);
  f40 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 72 >> 2]);
  f32 = Math_fround(f32 + Math_fround(f38 * f40));
  f39 = Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 88 >> 2]);
  f37 = Math_fround(f52 + f37);
  f29 = Math_fround(f51 + f29);
  f32 = Math_fround(f50 + Math_fround(f32 + Math_fround(f36 * f39)));
  f41 = Math_fround(Math_fround(Math_fround(f45 * f49) + Math_fround(f43 * f48)) + Math_fround(f34 * f41));
  f40 = Math_fround(Math_fround(Math_fround(f45 * f47) + Math_fround(f43 * f46)) + Math_fround(f34 * f40));
  f39 = Math_fround(Math_fround(Math_fround(f45 * f44) + Math_fround(f43 * f35)) + Math_fround(f34 * f39));
  f34 = Math_fround(f42 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 96 >> 2]));
  f34 = Math_fround(f34 + Math_fround(f38 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 112 >> 2])));
  f34 = Math_fround(f34 + Math_fround(f36 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 128 >> 2])));
  f35 = Math_fround(f42 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 100 >> 2]));
  f35 = Math_fround(f35 + Math_fround(f38 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 116 >> 2])));
  f35 = Math_fround(f35 + Math_fround(f36 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 132 >> 2])));
  f42 = Math_fround(f42 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 104 >> 2]));
  f38 = Math_fround(f42 + Math_fround(f38 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 120 >> 2])));
  f29 = Math_fround(-Math_fround(f29 * f27));
  f32 = Math_fround(-Math_fround(f32 * f27));
  f34 = Math_fround(-Math_fround(Math_fround(f41 + f34) * f27));
  f35 = Math_fround(-Math_fround(Math_fround(f40 + f35) * f27));
  f36 = Math_fround(-Math_fround(Math_fround(f39 + Math_fround(f38 + Math_fround(f36 * Math_fround(HEAPF32[i16 + (i1 * 144 | 0) + 136 >> 2])))) * f27));
  HEAPF32[i15 + (i1 << 5) >> 2] = Math_fround(-Math_fround(f37 * f27));
  HEAPF32[i15 + (i1 << 5) + 4 >> 2] = f29;
  HEAPF32[i15 + (i1 << 5) + 8 >> 2] = f32;
  HEAPF32[i15 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + (i1 << 5) + 16 >> 2] = f34;
  HEAPF32[i15 + (i1 << 5) + 20 >> 2] = f35;
  HEAPF32[i15 + (i1 << 5) + 24 >> 2] = f36;
  HEAPF32[i15 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i17 | 0));
 __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_(i21, i15, i19);
 i31 = i26 + 8 | 0;
 i31 = HEAP32[i31 >> 2] | 0;
 i33 = i17 << 5;
 _memcpy(i31 | 0, i19 | 0, i33 | 0) | 0;
 i33 = i21 + 16 | 0;
 i31 = i33;
 HEAP32[i31 >> 2] = 0;
 i33 = i33 + 4 | 0;
 HEAP32[i33 >> 2] = 0;
 i33 = i21 + 12 | 0;
 HEAP16[i33 >> 1] = 0;
 i33 = i21 + 14 | 0;
 HEAP16[i33 >> 1] = 0;
 i33 = i21 + 28 | 0;
 HEAP32[i33 >> 2] = 0;
 i33 = i26 + 34 | 0;
 i33 = HEAP16[i33 >> 1] | 0;
 i33 = i33 & 65535;
 i33 = __ZN5physx21PxcArticulationHelper22setupSolverConstraintsERNS_9PxcFsDataEjRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPKNS_19PxsArticulationLinkEPKNS_30PxcArticulationJointTransformsEfRjRNS_25PxsConstraintBlockManagerE(i21, i33, i28, i25, i20, i18, f27, i23, i24) | 0;
 STACKTOP = i22;
 return i33 | 0;
}

function __ZN5physx2Sc5Scene7releaseEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 3 | 0;
 i3 = i14;
 i11 = i14 + 1 | 0;
 i1 = i12 + 76 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i12 + 196 >> 2] = 0;
 i1 = i12 + 1104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx2Sc10NPhaseCoreD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i2);
 }
 HEAP32[i1 >> 2] = 0;
 i7 = i12 + 1108 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i14 + 2 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i7 = HEAP32[i12 + 1208 >> 2] | 0;
 if (i7 | 0) {
  i8 = HEAP32[i7 + 52 >> 2] | 0;
  i9 = HEAP32[i12 + 1216 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
  i10 = i9 + 24 | 0;
  if (!(HEAP8[i10 >> 0] | 0)) i1 = i9 + 16 | 0; else {
   i1 = i9 + 16 | 0;
   __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i9 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i13, i3, 32);
  }
  i5 = Math_imul(HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  L10 : do if ((i1 | 0) >= 0) {
   i6 = HEAP32[i9 + 12 >> 2] | 0;
   i2 = 0;
   i4 = i1;
   L12 : while (1) {
    while (1) {
     i1 = i2 + i4 >> 1;
     i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
     if (i3 >>> 0 <= i7 >>> 0 & (i3 + i5 | 0) >>> 0 > i7 >>> 0) break L12;
     if (i3 >>> 0 >= i7 >>> 0) break;
     if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else break L10;
    }
    i1 = i1 + -1 | 0;
    if ((i2 | 0) > (i1 | 0)) break L10; else i4 = i1;
   }
   i6 = i6 + (i1 * 12 | 0) + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i7;
   if (HEAP8[i10 >> 0] | 0) HEAP32[i9 + 8 >> 2] = i1;
   HEAP8[i10 >> 0] = 0;
  } while (0);
  __ZN5physx2Sc9RigidCoreD2Ev(i8);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i8);
 }
 __ZN5physx2Sc5Scene18postReportsCleanupEv(i12);
 i1 = HEAP32[i12 + 2388 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0);
 i5 = i12 + 96 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 | 0) {
  i1 = i6 + 340 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  i1 = i6 + 300 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  if (HEAP32[i6 + 284 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 4 | 0);
  i3 = i6 + 268 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = HEAP32[i6 + 272 >> 2] | 0;
  i4 = i1 + (i10 << 2) | 0;
  if (i10 | 0) do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i10 = HEAP32[i6 + 276 >> 2] | 0;
  do if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i6 + 8 | 0) == (i1 | 0)) {
    HEAP8[i6 + 264 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i6);
 }
 HEAP32[i5 >> 2] = 0;
 i5 = i12 + 1156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i12 + 1152 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i10 = HEAP32[i3 + 8 >> 2] | 0;
    if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) {
      i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
     }
    }
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i3);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   HEAP32[i2 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i5 = HEAP32[i12 + 1228 >> 2] | 0;
 if (i5 | 0) {
  if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5);
  i3 = i5 + 264 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = HEAP32[i5 + 268 >> 2] | 0;
  i4 = i1 + (i10 << 2) | 0;
  if (i10 | 0) do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i10 = HEAP32[i5 + 272 >> 2] | 0;
  do if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i5 + 4 | 0) == (i1 | 0)) {
    HEAP8[i5 + 260 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
 }
 i5 = HEAP32[i12 + 1224 >> 2] | 0;
 if (i5 | 0) {
  if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5);
  i3 = i5 + 264 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = HEAP32[i5 + 268 >> 2] | 0;
  i4 = i1 + (i10 << 2) | 0;
  if (i10 | 0) do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i10 = HEAP32[i5 + 272 >> 2] | 0;
  do if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i5 + 4 | 0) == (i1 | 0)) {
    HEAP8[i5 + 260 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
 }
 i5 = HEAP32[i12 + 1232 >> 2] | 0;
 if (i5 | 0) {
  if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5);
  i3 = i5 + 264 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = HEAP32[i5 + 268 >> 2] | 0;
  i4 = i1 + (i10 << 2) | 0;
  if (i10 | 0) do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i10 = HEAP32[i5 + 272 >> 2] | 0;
  do if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i5 + 4 | 0) == (i1 | 0)) {
    HEAP8[i5 + 260 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
 }
 i4 = HEAP32[i12 + 1216 >> 2] | 0;
 if (i4 | 0) {
  i1 = i4 + 12 | 0;
  i2 = HEAP32[i4 + 16 >> 2] | 0;
  if (i2 | 0) {
   i3 = 0;
   do {
    i10 = (HEAP32[i1 >> 2] | 0) + (i3 * 12 | 0) | 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i2 | 0));
  }
  i10 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i4);
 }
 i4 = HEAP32[i12 + 1212 >> 2] | 0;
 if (i4 | 0) {
  i1 = i4 + 12 | 0;
  i2 = HEAP32[i4 + 16 >> 2] | 0;
  if (i2 | 0) {
   i3 = 0;
   do {
    i10 = (HEAP32[i1 >> 2] | 0) + (i3 * 12 | 0) | 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i2 | 0));
  }
  i10 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i4);
 }
 i4 = HEAP32[i12 + 1220 >> 2] | 0;
 if (i4 | 0) {
  i1 = i4 + 12 | 0;
  i2 = HEAP32[i4 + 16 >> 2] | 0;
  if (i2 | 0) {
   i3 = 0;
   do {
    i10 = (HEAP32[i1 >> 2] | 0) + (i3 * 12 | 0) | 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i2 | 0));
  }
  i10 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i4);
 }
 i1 = HEAP32[i12 + 168 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i12 + 172 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i12 + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i3 = i12 + 112 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i1);
 i2 = HEAP32[i12 + 1200 >> 2] | 0;
 if (i2 | 0) {
  i11 = HEAP32[i2 + 36 >> 2] | 0;
  if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (i1 | 0) {
    i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
   }
  }
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  do if (i1 | 0) {
   if ((HEAP32[i2 + 20 >> 2] | 0) <= -1) break;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 24 | 0, i1);
  } while (0);
  i11 = HEAP32[i2 + 12 >> 2] | 0;
  do if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) break;
   i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i2);
 }
 i2 = HEAP32[i12 + 1196 >> 2] | 0;
 if (i2 | 0) {
  i11 = HEAP32[i2 + 36 >> 2] | 0;
  do if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (!i1) break;
   i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
  } while (0);
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  do if (i1 | 0) {
   if ((HEAP32[i2 + 20 >> 2] | 0) <= -1) break;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 24 | 0, i1);
  } while (0);
  i11 = HEAP32[i2 + 12 >> 2] | 0;
  do if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) break;
   i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
  } while (0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i2);
 }
 i1 = HEAP32[i12 + 1184 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i1);
 i1 = HEAP32[i12 + 1204 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZN5physx2Sc16InteractionSceneD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i1);
 STACKTOP = i14;
 return;
}

function __ZN17ProfilerFrameData11DeserializeEPPib(i6, i16, i17) {
 i6 = i6 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = i6 + 1136 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = ((i3 | 0) < 0) << 31 >> 31;
 HEAP32[i6 + 1144 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i16 >> 2] = i1 + 20;
 HEAP32[i6 + 1148 >> 2] = HEAP32[i1 + 16 >> 2];
 __ZN16AllProfilerStats11DeserializeEPPib(i6 + 12 | 0, i16, i17);
 i1 = i6 + 1152 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = i2 + 4;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i6 + 1164 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i6 + 1168 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 6, 4, i6 + 1156 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i6 + 1156 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i15;
  break;
 } while (0);
 if ((i2 | 0) > 0) {
  _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i16 >> 2] | 0, i2 << 6 | 0) | 0;
  i1 = (HEAP32[i16 >> 2] | 0) + ((i2 << 4 & 1073741808) << 2) | 0;
  HEAP32[i16 >> 2] = i1;
 } else i1 = HEAP32[i16 >> 2] | 0;
 i5 = i6 + 1172 | 0;
 HEAP32[i16 >> 2] = i1 + 4;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 1184 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i6 + 1188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 * 44 | 0, 4, i6 + 1176 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 44 | 0, 4, i6 + 1176 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i15;
  break;
 } while (0);
 if ((i1 | 0) > 0) {
  i1 = i1 * 44 | 0;
  _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[i16 >> 2] | 0, i1 | 0) | 0;
  i1 = (HEAP32[i16 >> 2] | 0) + (i1 >>> 2 << 2) | 0;
  HEAP32[i16 >> 2] = i1;
 } else i1 = HEAP32[i16 >> 2] | 0;
 i5 = i6 + 1212 | 0;
 HEAP32[i16 >> 2] = i1 + 4;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 1224 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i6 + 1228 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 1, i6 + 1216 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6 + 1216 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i15;
  break;
 } while (0);
 if ((i1 | 0) > 0) {
  _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[i16 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + (i1 >>> 2 << 2);
 }
 if (i17) {
  i3 = (HEAP32[i2 >> 2] | 0) >>> 2;
  if (i3 | 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = 0;
   while (1) {
    HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
   }
  }
 }
 i4 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = i4 + 4;
 i4 = HEAP32[i4 >> 2] | 0;
 i15 = i6 + 1128 | 0;
 if ((i4 | 0) != (HEAP32[i15 >> 2] | 0)) {
  i5 = i6 + 1124 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2 | 0) {
   i3 = i2 + -4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) {
    i1 = i2 + (i1 * 144 | 0) | 0;
    do {
     i1 = i1 + -144 | 0;
     __ZN17ProfilerFrameData10ThreadDataD2Ev(i1);
    } while ((i1 | 0) != (i2 | 0));
   }
   __ZdaPv(i3);
  }
  i1 = i4 * 144 | 0;
  i1 = __Znaj(i4 >>> 0 > 29826161 | i1 >>> 0 > 4294967291 ? -1 : i1 + 4 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  i1 = i1 + 4 | 0;
  if (i4 | 0) {
   i2 = i1 + (i4 * 144 | 0) | 0;
   i3 = i1;
   do {
    __ZN17ProfilerFrameData10ThreadDataC2Ev(i3);
    i3 = i3 + 144 | 0;
   } while ((i3 | 0) != (i2 | 0));
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i15 >> 2] = i4;
 }
 if ((i4 | 0) <= 0) {
  STACKTOP = i19;
  return;
 }
 i9 = i6 + 1124 | 0;
 i10 = i18 + 11 | 0;
 i11 = i18 + 4 | 0;
 i12 = i18 + 11 | 0;
 i13 = i18 + 4 | 0;
 i8 = 0;
 do {
  i14 = HEAP32[i9 >> 2] | 0;
  i2 = i14 + (i8 * 144 | 0) + 120 | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  if (i17) {
   i4 = (_strlen(i3) | 0) >>> 2;
   i1 = 0;
   while (1) {
    i7 = i3 + (i1 << 2) | 0;
    HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i1 = i1 + 1 | 0;
   }
  };
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i3, _strlen(i3) | 0);
  i3 = HEAP8[i10 >> 0] | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + (((i3 << 24 >> 24 < 0 ? HEAP32[i11 >> 2] | 0 : i3 & 255) >>> 2) + 1 << 2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i18) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i2 = i14 + (i8 * 144 | 0) + 132 | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  if (i17) {
   i4 = (_strlen(i3) | 0) >>> 2;
   i1 = 0;
   while (1) {
    i7 = i3 + (i1 << 2) | 0;
    HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i1 = i1 + 1 | 0;
   }
  };
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i3, _strlen(i3) | 0);
  i6 = HEAP8[i12 >> 0] | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + (((i6 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i6 & 255) >>> 2) + 1 << 2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i18) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i6 = i14 + (i8 * 144 | 0) | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i2 + 4;
  i2 = HEAP32[i2 >> 2] | 0;
  i7 = i14 + (i8 * 144 | 0) + 12 | 0;
  HEAP32[i7 >> 2] = i2;
  i1 = i14 + (i8 * 144 | 0) + 16 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 & 2147483647) >>> 0 < i2 >>> 0) {
   if ((i3 | 0) > -1) {
    HEAP32[i1 >> 2] = i2;
    HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 * 24 | 0, 8, i14 + (i8 * 144 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 8, i14 + (i8 * 144 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 24 | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i6 >> 2] = i5;
   }
   i2 = HEAP32[i7 >> 2] | 0;
  }
  if (i2 | 0) {
   i1 = 0;
   do {
    i5 = HEAP32[i16 >> 2] | 0;
    i20 = i5 + 4 | 0;
    HEAP32[i16 >> 2] = i20;
    f21 = Math_fround(HEAP32[i5 >> 2] | 0);
    HEAPF32[(HEAP32[i6 >> 2] | 0) + (i1 * 24 | 0) + 8 >> 2] = f21;
    i4 = i5 + 8 | 0;
    HEAP32[i16 >> 2] = i4;
    i20 = HEAP32[i20 >> 2] | 0;
    i3 = (HEAP32[i6 >> 2] | 0) + (i1 * 24 | 0) | 0;
    HEAP32[i3 >> 2] = i20;
    HEAP32[i3 + 4 >> 2] = ((i20 | 0) < 0) << 31 >> 31;
    HEAP32[i16 >> 2] = i5 + 12;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i5 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + (i1 * 24 | 0) + 16 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  i5 = i14 + (i8 * 144 | 0) + 20 | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i2 + 4;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i14 + (i8 * 144 | 0) + 32 | 0;
  HEAP32[i1 >> 2] = i2;
  i3 = i14 + (i8 * 144 | 0) + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
   if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2 << 4, 4, i14 + (i8 * 144 | 0) + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   } else {
    i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i14 + (i8 * 144 | 0) + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i20 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i5 >> 2] = i20;
   }
   i2 = HEAP32[i1 >> 2] | 0;
  }
  if (i2 | 0) {
   i1 = 0;
   do {
    i20 = HEAP32[i16 >> 2] | 0;
    i3 = i20 + 4 | 0;
    HEAP32[i16 >> 2] = i3;
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 4) + 4 >> 2] = HEAP32[i20 >> 2];
    i4 = i20 + 8 | 0;
    HEAP32[i16 >> 2] = i4;
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 4) >> 2] = HEAP32[i3 >> 2];
    HEAP32[i16 >> 2] = i20 + 12;
    i20 = HEAP32[i5 >> 2] | 0;
    HEAP32[i20 + (i1 << 4) + 12 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i20 + (i1 << 4) + 8 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  HEAP32[i14 + (i8 * 144 | 0) + 52 >> 2] = 0;
  i1 = i14 + (i8 * 144 | 0) + 60 | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i2 + 4;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i14 + (i8 * 144 | 0) + 72 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i14 + (i8 * 144 | 0) + 76 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 3, 4, i14 + (i8 * 144 | 0) + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i14 + (i8 * 144 | 0) + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i20 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = i20;
   break;
  } while (0);
  if ((i2 | 0) > 0) {
   _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i16 >> 2] | 0, i2 << 3 | 0) | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + ((i2 << 1 & 1073741822) << 2);
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i3 = 0;
   do {
    i2 = HEAP32[i6 >> 2] | 0;
    i20 = HEAP32[i16 >> 2] | 0;
    HEAP32[i16 >> 2] = i20 + 4;
    if (HEAP32[i20 >> 2] | 0) {
     HEAP32[i2 + (i3 * 24 | 0) + 16 >> 2] = __ZN17ProfilerFrameData30DeserializeProfilerInformationEPPib(i16, i17) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
  i1 = i14 + (i8 * 144 | 0) + 80 | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i2 + 4;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i14 + (i8 * 144 | 0) + 92 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i14 + (i8 * 144 | 0) + 96 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 2, 4, i14 + (i8 * 144 | 0) + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14 + (i8 * 144 | 0) + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i20 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = i20;
   break;
  } while (0);
  if ((i2 | 0) > 0) {
   _memcpy(HEAP32[i1 >> 2] | 0, HEAP32[i16 >> 2] | 0, i2 << 2 | 0) | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + ((i2 & 1073741823) << 2);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (HEAP32[i15 >> 2] | 0));
 STACKTOP = i19;
 return;
}

function __ZN5physx2Gu23intersectHeightFieldBoxERKNS0_15HeightFieldUtilERKNS0_3BoxE(i28, i22) {
 i28 = i28 | 0;
 i22 = i22 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, f45 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37 + 233 | 0;
 i5 = i37 + 136 | 0;
 i27 = i37 + 40 | 0;
 i25 = i37 + 28 | 0;
 i26 = i37 + 16 | 0;
 i24 = i37 + 232 | 0;
 i23 = i37;
 i33 = i28 + 12 | 0;
 i32 = HEAP32[i33 >> 2] | 0;
 i29 = i22 + 48 | 0;
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 i30 = i22 + 52 | 0;
 f2 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i22 + 56 | 0;
 f3 = Math_fround(HEAPF32[i31 >> 2]);
 i4 = 0;
 do {
  i20 = i4 * 3 | 0;
  f16 = Math_fround(f1 * Math_fround(HEAPF32[gb + 147072 + (i20 << 2) >> 2]));
  f17 = Math_fround(f2 * Math_fround(HEAPF32[gb + 147072 + (i20 + 1 << 2) >> 2]));
  f18 = Math_fround(f3 * Math_fround(HEAPF32[gb + 147072 + (i20 + 2 << 2) >> 2]));
  HEAPF32[i5 + (i4 * 12 | 0) >> 2] = f16;
  HEAPF32[i5 + (i4 * 12 | 0) + 4 >> 2] = f17;
  HEAPF32[i5 + (i4 * 12 | 0) + 8 >> 2] = f18;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 8);
 f1 = Math_fround(HEAPF32[i22 >> 2]);
 f2 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i22 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i22 + 20 >> 2]);
 f13 = Math_fround(HEAPF32[i22 + 24 >> 2]);
 f14 = Math_fround(HEAPF32[i22 + 28 >> 2]);
 f15 = Math_fround(HEAPF32[i22 + 32 >> 2]);
 i19 = i22 + 36 | 0;
 f16 = Math_fround(HEAPF32[i19 >> 2]);
 f17 = Math_fround(HEAPF32[i22 + 40 >> 2]);
 f18 = Math_fround(HEAPF32[i22 + 44 >> 2]);
 i4 = 0;
 do {
  f40 = Math_fround(HEAPF32[i5 + (i4 * 12 | 0) >> 2]);
  f41 = Math_fround(f40 * f1);
  f39 = Math_fround(f40 * f2);
  f40 = Math_fround(f40 * f3);
  f38 = Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 4 >> 2]);
  f41 = Math_fround(f41 + Math_fround(f38 * f9));
  f39 = Math_fround(f39 + Math_fround(f38 * f10));
  f38 = Math_fround(f40 + Math_fround(f38 * f11));
  f40 = Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 8 >> 2]);
  f39 = Math_fround(Math_fround(f39 + Math_fround(f40 * f14)) + f17);
  f38 = Math_fround(Math_fround(f38 + Math_fround(f40 * f15)) + f18);
  HEAPF32[i27 + (i4 * 12 | 0) >> 2] = Math_fround(Math_fround(f41 + Math_fround(f40 * f13)) + f16);
  HEAPF32[i27 + (i4 * 12 | 0) + 4 >> 2] = f39;
  HEAPF32[i27 + (i4 * 12 | 0) + 8 >> 2] = f38;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 8);
 i12 = i28 + 8 | 0;
 i20 = i28 + 16 | 0;
 i5 = i32 + 40 | 0;
 i8 = 0;
 L7 : do {
  i6 = i27 + (i8 * 12 | 0) | 0;
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i27 + (i8 * 12 | 0) + 8 | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f1 = Math_fround(f1 * Math_fround(HEAPF32[i28 >> 2]));
  f2 = Math_fround(f2 * Math_fround(HEAPF32[i12 >> 2]));
  do if (f1 >= Math_fround(0.0) & f2 >= Math_fround(0.0)) {
   i4 = HEAP32[i33 >> 2] | 0;
   if (f1 < Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + Math_fround(1.0))) if (f2 < Math_fround(Math_fround(HEAPF32[i4 + 28 >> 2]) + Math_fround(1.0))) {
    f41 = Math_fround(HEAPF32[(HEAP32[i20 >> 2] | 0) + 8 >> 2]);
    f1 = Math_fround(f41 * Math_fround(__ZNK5physx2Gu11HeightField17getHeightInternalEff(i4, f1, f2)));
    f1 = Math_fround(Math_fround(HEAPF32[i27 + (i8 * 12 | 0) + 4 >> 2]) - f1);
    f2 = Math_fround(HEAPF32[i5 >> 2]);
    if (!(f2 <= f1) | (!(f1 <= Math_fround(0.0)) | !(f2 <= Math_fround(0.0)))) if (!(f2 > f1 & (f1 > Math_fround(-0.0) & f2 > Math_fround(0.0)))) break;
    f41 = Math_fround(HEAPF32[i6 >> 2]);
    if ((__ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff(i28, f41, Math_fround(HEAPF32[i7 >> 2])) | 0) != -1) {
     i21 = 1;
     i36 = 32;
     break L7;
    }
   }
  } while (0);
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < 8);
 if ((i36 | 0) == 32) {
  STACKTOP = i37;
  return i21 | 0;
 }
 i4 = i25 + 4 | 0;
 i5 = i25 + 8 | 0;
 i6 = i26 + 4 | 0;
 i7 = i26 + 8 | 0;
 i8 = 0;
 do {
  i42 = i8 << 1;
  i43 = HEAPU8[gb + 768836 + i42 >> 0] | 0;
  HEAP32[i25 >> 2] = HEAP32[i27 + (i43 * 12 | 0) >> 2];
  HEAP32[i4 >> 2] = HEAP32[i27 + (i43 * 12 | 0) + 4 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i27 + (i43 * 12 | 0) + 8 >> 2];
  i42 = HEAPU8[(i42 | 1) + (gb + 768836) >> 0] | 0;
  HEAP32[i26 >> 2] = HEAP32[i27 + (i42 * 12 | 0) >> 2];
  HEAP32[i6 >> 2] = HEAP32[i27 + (i42 * 12 | 0) + 4 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i27 + (i42 * 12 | 0) + 8 >> 2];
  HEAP8[i24 >> 0] = 0;
  __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_27TriggerTraceSegmentCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i28, i25, i26, i24, 0);
  i8 = i8 + 1 | 0;
  if (HEAP8[i24 >> 0] | 0) {
   i21 = 1;
   i36 = 32;
   break;
  }
 } while (i8 >>> 0 < 12);
 if ((i36 | 0) == 32) {
  STACKTOP = i37;
  return i21 | 0;
 }
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i23, i22);
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f45 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f40 = Math_fround(HEAPF32[i19 >> 2]);
 f9 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f40 = Math_fround(-f40);
 f9 = Math_fround(-f9);
 f16 = Math_fround(-Math_fround(HEAPF32[i19 + 8 >> 2]));
 f14 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f10 = Math_fround(f11 * f16);
 f44 = Math_fround(Math_fround(Math_fround(f11 * f40) + Math_fround(f45 * f9)) + Math_fround(f13 * f16));
 f15 = Math_fround(Math_fround(Math_fround(f11 * f44) + Math_fround(Math_fround(f14 * f40) - Math_fround(f18 * Math_fround(Math_fround(f45 * f16) - Math_fround(f13 * f9))))) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) - Math_fround(f18 * Math_fround(Math_fround(f11 * f9) - Math_fround(f45 * f40)))) + Math_fround(f13 * f44)) * Math_fround(2.0));
 f17 = Math_fround(-f45);
 f39 = Math_fround(HEAPF32[i27 >> 2]);
 i8 = f39 < Math_fround(3402823469999999843913219.0e14);
 f1 = i8 ? f39 : Math_fround(3402823469999999843913219.0e14);
 f3 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 i8 = f3 < Math_fround(3402823469999999843913219.0e14);
 f41 = i8 ? f3 : Math_fround(3402823469999999843913219.0e14);
 i8 = f39 > Math_fround(-3402823469999999843913219.0e14);
 f39 = i8 ? f39 : Math_fround(-3402823469999999843913219.0e14);
 i8 = f3 > Math_fround(-3402823469999999843913219.0e14);
 f3 = i8 ? f3 : Math_fround(-3402823469999999843913219.0e14);
 f38 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f1 = f38 < f1 ? f38 : f1;
 f2 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f41 = f2 < f41 ? f2 : f41;
 f39 = f38 > f39 ? f38 : f39;
 f3 = f2 > f3 ? f2 : f3;
 f2 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f1 = f2 < f1 ? f2 : f1;
 f38 = Math_fround(HEAPF32[i27 + 32 >> 2]);
 f41 = f38 < f41 ? f38 : f41;
 f39 = f2 > f39 ? f2 : f39;
 f3 = f38 > f3 ? f38 : f3;
 f38 = Math_fround(HEAPF32[i27 + 36 >> 2]);
 f1 = f38 < f1 ? f38 : f1;
 f2 = Math_fround(HEAPF32[i27 + 44 >> 2]);
 f41 = f2 < f41 ? f2 : f41;
 f39 = f38 > f39 ? f38 : f39;
 f3 = f2 > f3 ? f2 : f3;
 f2 = Math_fround(HEAPF32[i27 + 48 >> 2]);
 f1 = f2 < f1 ? f2 : f1;
 f38 = Math_fround(HEAPF32[i27 + 56 >> 2]);
 f41 = f38 < f41 ? f38 : f41;
 f39 = f2 > f39 ? f2 : f39;
 f3 = f38 > f3 ? f38 : f3;
 f38 = Math_fround(HEAPF32[i27 + 60 >> 2]);
 f1 = f38 < f1 ? f38 : f1;
 f2 = Math_fround(HEAPF32[i27 + 68 >> 2]);
 f41 = f2 < f41 ? f2 : f41;
 f39 = f38 > f39 ? f38 : f39;
 f3 = f2 > f3 ? f2 : f3;
 f2 = Math_fround(HEAPF32[i27 + 72 >> 2]);
 f1 = f2 < f1 ? f2 : f1;
 f38 = Math_fround(HEAPF32[i27 + 80 >> 2]);
 f41 = f38 < f41 ? f38 : f41;
 f39 = f2 > f39 ? f2 : f39;
 f3 = f38 > f3 ? f38 : f3;
 f38 = Math_fround(HEAPF32[i27 + 84 >> 2]);
 f2 = Math_fround(HEAPF32[i27 + 92 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f45 * f44) + Math_fround(Math_fround(f14 * f9) - Math_fround(f18 * Math_fround(Math_fround(f13 * f40) - f10)))) * Math_fround(2.0));
 f11 = Math_fround(-f11);
 f13 = Math_fround(-f13);
 f40 = Math_fround(HEAPF32[i28 >> 2]);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 i8 = ~~Math_fround(Math_floor(Math_fround((f38 < f1 ? f38 : f1) * f40)));
 i25 = HEAP32[i32 + 16 >> 2] | 0;
 i23 = i25 + -2 | 0;
 i8 = (i8 | 0) > 0 ? i8 : 0;
 i8 = (i8 | 0) > (i23 | 0) ? i23 : i8;
 i23 = ~~Math_fround(Math_ceil(Math_fround((f38 > f39 ? f38 : f39) * f40)));
 i25 = i25 + -1 | 0;
 i23 = (i23 | 0) > 0 ? i23 : 0;
 i23 = (i23 | 0) > (i25 | 0) ? i25 : i23;
 i25 = ~~Math_fround(Math_floor(Math_fround((f2 < f41 ? f2 : f41) * f9)));
 i24 = i32 + 20 | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i26 = i4 + -2 | 0;
 i25 = (i25 | 0) > 0 ? i25 : 0;
 i25 = (i25 | 0) > (i26 | 0) ? i26 : i25;
 i26 = ~~Math_fround(Math_ceil(Math_fround((f2 > f3 ? f2 : f3) * f9)));
 i4 = i4 + -1 | 0;
 i26 = (i26 | 0) > 0 ? i26 : 0;
 i26 = (i26 | 0) > (i4 | 0) ? i4 : i26;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f3 = Math_fround(HEAPF32[i30 >> 2]);
 f2 = Math_fround(HEAPF32[i31 >> 2]);
 i4 = HEAP32[i20 >> 2] | 0;
 if (i8 >>> 0 > i23 >>> 0) {
  i43 = 0;
  STACKTOP = i37;
  return i43 | 0;
 }
 i20 = i25 >>> 0 > i26 >>> 0;
 i21 = i4 + 12 | 0;
 i22 = i4 + 8 | 0;
 i19 = i32 + 36 | 0;
 i12 = i4 + 16 | 0;
 L29 : while (1) {
  if (!i20) {
   f1 = Math_fround(i8 >>> 0);
   i5 = (i8 | 0) == 0;
   i7 = i25;
   do {
    i6 = (Math_imul(HEAP32[i24 >> 2] | 0, i8) | 0) + i7 | 0;
    i43 = HEAP32[i33 >> 2] | 0;
    do if (!((mftCall_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 56 >> 2] | 0, i43 | 0) | 0) & 1)) {
     i34 = HEAP32[i33 >> 2] | 0;
     i36 = 28;
    } else {
     i4 = HEAP32[i33 >> 2] | 0;
     if (!(i5 | (i7 | 0) == 0)) if (((HEAP32[i4 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i8 >>> 0) if (((HEAP32[i4 + 20 >> 2] | 0) + -1 | 0) >>> 0 > i7 >>> 0) {
      i34 = i4;
      i36 = 28;
      break;
     }
     if ((HEAP8[(HEAP32[i4 + 36 >> 2] | 0) + (i6 << 2) + 2 >> 0] & 127) == 127) if (__ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb(i4, i6, i8, i7, 127, i35) | 0) {
      i36 = 29;
      break;
     } else break; else {
      i36 = 29;
      break;
     }
    } while (0);
    if ((i36 | 0) == 28) {
     i36 = 0;
     if ((HEAP8[(HEAP32[i34 + 36 >> 2] | 0) + (i6 << 2) + 3 >> 0] | 0) < 0) i36 = 29;
    }
    if ((i36 | 0) == 29) {
     i36 = 0;
     f41 = Math_fround(f1 * Math_fround(HEAPF32[i21 >> 2]));
     f45 = Math_fround(HEAPF32[i22 >> 2]);
     f45 = Math_fround(f45 * Math_fround(HEAP16[(HEAP32[i19 >> 2] | 0) + (i6 << 2) >> 1] | 0));
     f39 = Math_fround(Math_fround(i7 >>> 0) * Math_fround(HEAPF32[i12 >> 2]));
     f38 = Math_fround(Math_fround(f39 * f13) + Math_fround(Math_fround(f41 * f11) + Math_fround(f45 * f17)));
     f40 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f38 * f11) + Math_fround(Math_fround(f14 * f41) + Math_fround(f18 * Math_fround(Math_fround(f39 * f17) - Math_fround(f45 * f13))))) * Math_fround(2.0)));
     f44 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f38 * f17) + Math_fround(Math_fround(f14 * f45) + Math_fround(f18 * Math_fround(Math_fround(f41 * f13) - Math_fround(f39 * f11))))) * Math_fround(2.0)));
     f38 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f39) + Math_fround(f18 * Math_fround(Math_fround(f45 * f11) - Math_fround(f41 * f17)))) + Math_fround(f38 * f13)) * Math_fround(2.0)));
     f41 = Math_fround(-f40);
     f45 = Math_fround(-f44);
     f39 = Math_fround(-f38);
     if (f2 > (f38 > f39 ? f38 : f39) & (f9 > (f40 > f41 ? f40 : f41) ? f3 > (f44 > f45 ? f44 : f45) : 0)) {
      i21 = 1;
      i36 = 32;
      break L29;
     }
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 <= i26 >>> 0);
  }
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 > i23 >>> 0) {
   i21 = 0;
   i36 = 32;
   break;
  }
 }
 if ((i36 | 0) == 32) {
  STACKTOP = i37;
  return i21 | 0;
 }
 return 0;
}

function __Z12WeldVerticesRK17WeldVerticesInputR18WeldVerticesOutput(i19, i29) {
 i19 = i19 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i38;
 i33 = i38 + 88 | 0;
 i34 = i38 + 68 | 0;
 i35 = i38 + 48 | 0;
 i36 = i38 + 28 | 0;
 i37 = i38 + 8 | 0;
 i20 = i19 + 12 | 0;
 if (HEAP32[i20 >> 2] | 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (!(HEAP32[i1 >> 2] | 0)) if ((HEAP32[i1 + 4 >> 2] | 0) == 3) {
   i5 = HEAP32[i1 + 8 >> 2] | 0;
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   f18 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   i30 = i19 + 20 | 0;
   i2 = HEAP32[i30 >> 2] | 0;
   i1 = i33 + 12 | 0;
   HEAP32[i1 >> 2] = i2;
   i31 = i33 + 16 | 0;
   HEAP32[i31 >> 2] = i2;
   i32 = i33 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 64016 | 0);
   i27 = i22;
   i28 = HEAP32[i27 + 4 >> 2] | 0;
   i3 = i32;
   HEAP32[i3 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i3 + 4 >> 2] = i28;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i32, 0, gb + 1047584 | 0, 446) | 0;
   HEAP32[i33 >> 2] = i2;
   i3 = HEAP32[i30 >> 2] | 0;
   if (i3 | 0) {
    i4 = 0;
    do {
     i28 = i5 + (Math_imul(i4, i6) | 0) | 0;
     f9 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(.554636121));
     f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i28 + 4 >> 2]) * Math_fround(.586600184)));
     HEAPF32[i2 + (i4 << 3) >> 2] = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i28 + 8 >> 2]) * Math_fround(.590151727)));
     HEAP32[i2 + (i4 << 3) + 4 >> 2] = i4;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i3 >>> 0);
   }
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_(i2, i2 + (HEAP32[i1 >> 2] << 3) | 0, i22);
   HEAP32[i34 >> 2] = 0;
   i17 = i34 + 12 | 0;
   HEAP32[i17 >> 2] = 0;
   i27 = i34 + 16 | 0;
   HEAP32[i27 >> 2] = 0;
   i28 = i34 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
   i26 = i22;
   i2 = HEAP32[i26 + 4 >> 2] | 0;
   i1 = i28;
   HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i1 + 4 >> 2] = i2;
   i1 = HEAP32[i30 >> 2] | 0;
   i2 = HEAP32[i27 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i27 >> 2] = i1;
    HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i1 << 3, 4, i28, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i28, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i26 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i34 >> 2] = i26;
    break;
   } while (0);
   i1 = HEAP32[i30 >> 2] | 0;
   HEAP32[i35 + 12 >> 2] = i1;
   i25 = i35 + 16 | 0;
   HEAP32[i25 >> 2] = i1;
   i26 = i35 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 64016 | 0);
   i23 = i22;
   i24 = HEAP32[i23 + 4 >> 2] | 0;
   i2 = i26;
   HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i2 + 4 >> 2] = i24;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i26, 0, gb + 1047584 | 0, 446) | 0;
   HEAP32[i35 >> 2] = i2;
   if (i1 | 0) _memset(i2 | 0, 0, i1 | 0) | 0;
   i1 = HEAP32[i30 >> 2] | 0;
   HEAP32[i36 + 12 >> 2] = i1;
   i23 = i36 + 16 | 0;
   HEAP32[i23 >> 2] = i1;
   i24 = i36 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 64016 | 0);
   i14 = i22;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i16 = i24;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = i15;
   HEAP32[i36 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
   i1 = HEAP32[i30 >> 2] | 0;
   if (i1 | 0) {
    i3 = 0;
    i16 = 0;
    while (1) {
     i2 = (HEAP32[i35 >> 2] | 0) + i16 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) {
      i15 = HEAP32[(HEAP32[i33 >> 2] | 0) + (i16 << 3) + 4 >> 2] | 0;
      HEAP32[(HEAP32[i36 >> 2] | 0) + (i15 << 2) >> 2] = i3;
      HEAP8[i2 >> 0] = 1;
      i2 = i16 + 1 | 0;
      L24 : do if (i2 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0) {
       i1 = i2;
       i14 = i15;
       while (1) {
        while (1) {
         i4 = HEAP32[i33 >> 2] | 0;
         f9 = Math_fround(HEAPF32[i4 + (i1 << 3) >> 2]);
         if (Math_fround(f9 - Math_fround(HEAPF32[i4 + (i16 << 3) >> 2])) > f18) {
          i1 = i14;
          break L24;
         }
         i13 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
         i5 = HEAP32[i20 >> 2] | 0;
         if (!i5) break; else {
          i4 = 1;
          i12 = 0;
         }
         L30 : while (1) {
          i7 = HEAP32[i19 >> 2] | 0;
          i11 = HEAP32[i7 + (i12 * 20 | 0) + 8 >> 2] | 0;
          i10 = HEAP32[i7 + (i12 * 20 | 0) + 12 >> 2] | 0;
          i8 = i11 + (Math_imul(i10, i15) | 0) | 0;
          i10 = i11 + (Math_imul(i10, i13) | 0) | 0;
          L32 : do switch (HEAP32[i7 + (i12 * 20 | 0) >> 2] | 0) {
          case 0:
           {
            i11 = HEAP32[i7 + (i12 * 20 | 0) + 4 >> 2] | 0;
            if (!i11) break L32; else {
             i6 = 0;
             f9 = Math_fround(0.0);
            }
            do {
             f39 = Math_fround(HEAPF32[i10 + (i6 << 2) >> 2]);
             f39 = Math_fround(f39 - Math_fround(HEAPF32[i8 + (i6 << 2) >> 2]));
             f9 = Math_fround(f9 + Math_fround(f39 * f39));
             i6 = i6 + 1 | 0;
            } while (i6 >>> 0 < i11 >>> 0);
            f39 = Math_fround(HEAPF32[i7 + (i12 * 20 | 0) + 16 >> 2]);
            i11 = f9 > Math_fround(f39 * f39);
            i4 = i4 & (i11 ^ 1);
            if (i11) {
             i21 = 29;
             break L30;
            }
            break;
           }
          case 3:
          case 2:
           {
            if (_memcmp(i8, i10, HEAP32[i7 + (i12 * 20 | 0) + 4 >> 2] | 0) | 0) break L30;
            break;
           }
          default:
           {
            __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430933 | 0, 0, gb + 430854 | 0, 93, 1, 0, 0, 0);
            i5 = HEAP32[i20 >> 2] | 0;
           }
          } while (0);
          i12 = i12 + 1 | 0;
          if (i12 >>> 0 >= i5 >>> 0) {
           i21 = 32;
           break;
          }
         }
         if ((i21 | 0) == 29) {
          i21 = 0;
          if (i4) break;
         } else if ((i21 | 0) == 32) {
          i21 = 0;
          if (i4) break;
         }
         i1 = i1 + 1 | 0;
         if (i1 >>> 0 >= (HEAP32[i30 >> 2] | 0) >>> 0) {
          i1 = i14;
          break L24;
         }
        }
        i4 = i13 >>> 0 < i14 >>> 0 ? i13 : i14;
        HEAP32[(HEAP32[i36 >> 2] | 0) + (i13 << 2) >> 2] = i3;
        HEAP8[(HEAP32[i35 >> 2] | 0) + i1 >> 0] = 1;
        i1 = i1 + 1 | 0;
        if (i1 >>> 0 >= (HEAP32[i30 >> 2] | 0) >>> 0) {
         i1 = i4;
         break;
        } else i14 = i4;
       }
      } else i1 = i15; while (0);
      i5 = HEAP32[i17 >> 2] | 0;
      i6 = i5 + 1 | 0;
      i7 = HEAP32[i27 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i4 = i7 << 1;
       i4 = (i4 | 0) == 0 ? 1 : i4;
       if (i8 >>> 0 < i4 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i27 >> 2] = i4;
        HEAP32[i34 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i34 >> 2] | 0, i4 << 3, 4, i28, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i28, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i16 | 0, HEAP32[i34 >> 2] | 0, HEAP32[i17 >> 2] << 3 | 0) | 0;
        HEAP32[i27 >> 2] = i4;
        HEAP32[i34 >> 2] = i16;
        break;
       }
      } while (0);
      HEAP32[i17 >> 2] = i6;
      i16 = (HEAP32[i34 >> 2] | 0) + (i5 << 3) | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP32[i16 + 4 >> 2] = i3;
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i30 >> 2] | 0;
     } else i2 = i16 + 1 | 0;
     if (i2 >>> 0 < i1 >>> 0) i16 = i2; else break;
    }
   }
   i6 = HEAP32[i34 >> 2] | 0;
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_(i6, i6 + (HEAP32[i17 >> 2] << 3) | 0, i22);
   i6 = HEAP32[i17 >> 2] | 0;
   HEAP32[i37 + 12 >> 2] = i6;
   i7 = i37 + 16 | 0;
   HEAP32[i7 >> 2] = i6;
   i8 = i37 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 64016 | 0);
   i5 = i22;
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = i8;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = i2;
   i4 = i6 << 2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
   HEAP32[i37 >> 2] = i2;
   i5 = (i6 | 0) == 0;
   if (!i5) {
    i3 = HEAP32[i34 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] << 2) >> 2] = i1;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   i1 = i29 + 12 | 0;
   HEAP32[i1 >> 2] = i6;
   i2 = i29 + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i6 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i2 >> 2] = i6;
    HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i4, 4, i29 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i29 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i22 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i29 >> 2] = i22;
    break;
   } while (0);
   if (!i5) {
    i2 = HEAP32[i34 >> 2] | 0;
    i3 = HEAP32[i29 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 3) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   i5 = i29 + 20 | 0;
   i1 = HEAP32[i30 >> 2] | 0;
   i2 = i29 + 32 | 0;
   HEAP32[i2 >> 2] = i1;
   i3 = i29 + 36 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 2, 4, i29 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i29 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i29 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i5 >> 2] = i29;
    break;
   } while (0);
   if (HEAP32[i30 >> 2] | 0) {
    i3 = HEAP32[i36 >> 2] | 0;
    i4 = HEAP32[i37 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 + (i1 << 2) >> 2] << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0);
   }
   if ((HEAP32[i7 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i37 >> 2] | 0, i8);
    HEAP32[i37 >> 2] = 0;
   }
   if ((HEAP32[i23 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i24);
    HEAP32[i36 >> 2] = 0;
   }
   if ((HEAP32[i25 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i26);
    HEAP32[i35 >> 2] = 0;
   }
   if ((HEAP32[i27 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i34 >> 2] | 0, i28);
    HEAP32[i34 >> 2] = 0;
   }
   if ((HEAP32[i31 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i32);
    HEAP32[i33 >> 2] = 0;
   }
   STACKTOP = i38;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430799 | 0, 0, gb + 430854 | 0, 11, 1, 0, 0, 0);
 STACKTOP = i38;
 return;
}

function __ZN5physx9NpDestroyERNS_3Scb4BaseE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 do switch ((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15 | 0) {
 case 2:
 case 1:
  {
   i1 = i1 + -32 | 0;
   i4 = i1;
   i5 = HEAP32[i4 + 8 >> 2] | 0;
   if (!(HEAP16[i4 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i4 | 0); else {
    i2 = HEAP32[gb + 1457204 >> 2] | 0;
    i3 = i2 + 1540 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
    i6 = i2 + 1524 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i2 + 1536 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i4;
    i1 = i2 + 1528 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i2 + 1520 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i2 + 1244 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i4, i5, 2);
   return;
  }
 case 3:
  {
   i1 = i1 + -48 | 0;
   i2 = i1;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i4 = HEAP32[gb + 1457204 >> 2] | 0;
    i5 = i4 + 940 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i4 + 924 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i4 + 936 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i4 + 928 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i4 + 920 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4 + 644 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i3, 2);
   return;
  }
 case 4:
  {
   i1 = i1 + -48 | 0;
   i2 = i1;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i4 = HEAP32[gb + 1457204 >> 2] | 0;
    i5 = i4 + 3040 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i4 + 3024 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i4 + 3036 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i4 + 3028 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i4 + 3020 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4 + 2744 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i3, 2);
   return;
  }
 case 5:
  {
   i1 = i1 + -48 | 0;
   i2 = i1;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i4 = HEAP32[gb + 1457204 >> 2] | 0;
    i5 = i4 + 1240 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i4 + 1224 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i4 + 1236 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i4 + 1228 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i4 + 1220 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4 + 944 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i3, 2);
   return;
  }
 case 6:
  {
   i1 = i1 + -16 | 0;
   i2 = i1;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i3 = HEAP32[gb + 1457204 >> 2] | 0;
    i4 = i3 + 2140 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i3 + 2124 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i3 + 2136 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i3 + 2128 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i3 + 2120 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 1844 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, 0, 2);
   return;
  }
 case 7:
  {
   i3 = i1;
   i4 = i3 + -20 | 0;
   i5 = i4;
   i6 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = (HEAP16[i5 + 6 >> 1] & 1) == 0;
   if ((HEAP8[(HEAP32[gb + 90260 + 52 >> 2] | 0) + i3 + 10 >> 0] | 0) == 2) {
    if (i1) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i5 | 0); else {
     i2 = HEAP32[gb + 1457204 >> 2] | 0;
     i3 = i2 + 3640 | 0;
     __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
     i1 = i2 + 3624 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
     i1 = i2 + 3636 | 0;
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i1 >> 2] = i5;
     i1 = i2 + 3628 | 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     if ((i4 | 0) >= ((HEAP32[i2 + 3620 >> 2] | 0) * 50 | 0)) {
      __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i2 + 3344 | 0);
      HEAP32[i1 >> 2] = 0;
     }
     __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
    }
    __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i5, i6, 2);
    return;
   } else {
    if (i1) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i5 | 0); else {
     i2 = HEAP32[gb + 1457204 >> 2] | 0;
     i3 = i2 + 3940 | 0;
     __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
     i1 = i2 + 3924 | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
     i1 = i2 + 3936 | 0;
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i1 >> 2] = i5;
     i1 = i2 + 3928 | 0;
     i4 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i4 + 1;
     if ((i4 | 0) >= ((HEAP32[i2 + 3920 >> 2] | 0) * 50 | 0)) {
      __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i2 + 3644 | 0);
      HEAP32[i1 >> 2] = 0;
     }
     __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
    }
    __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i5, i6, 2);
    return;
   }
  }
 case 8:
  {
   i1 = i1 + -12 | 0;
   i2 = i1;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i4 = HEAP32[gb + 1457204 >> 2] | 0;
    i5 = i4 + 2740 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i4 + 2724 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i4 + 2736 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i4 + 2728 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i4 + 2720 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4 + 2444 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i3, 2);
   return;
  }
 case 9:
  {
   i1 = i1 + -8 | 0;
   i2 = i1;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i3 = HEAP32[gb + 1457204 >> 2] | 0;
    i4 = i3 + 3340 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i3 + 3324 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i3 + 3336 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i3 + 3328 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i3 + 3320 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 3044 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, 0, 2);
   return;
  }
 case 10:
  {
   i1 = i1 + -8 | 0;
   i2 = i1;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i3 = HEAP32[gb + 1457204 >> 2] | 0;
    i4 = i3 + 1840 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i3 + 1824 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i3 + 1836 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i3 + 1828 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i3 + 1820 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 1544 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, 0, 2);
   return;
  }
 case 11:
  {
   i1 = i1 + -20 | 0;
   i2 = i1;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else {
    i4 = HEAP32[gb + 1457204 >> 2] | 0;
    i5 = i4 + 4252 | 0;
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i6 = i4 + 4236 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i6 = i4 + 4248 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i1 = i4 + 4240 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i6 + 1;
    if ((i6 | 0) >= ((HEAP32[i4 + 4232 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4 + 3956 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   }
   __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i3, 2);
   return;
  }
 default:
  return;
 } while (0);
}

function __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_(i1, i2, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 L1 : while (1) {
  i10 = i2;
  i11 = i2 + -20 | 0;
  i12 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i10 - i9 | 0;
    switch ((i3 | 0) / 20 | 0 | 0) {
    case 2:
     {
      i13 = 5;
      break L1;
     }
    case 3:
     {
      i13 = 7;
      break L1;
     }
    case 4:
     {
      i13 = 8;
      break L1;
     }
    case 5:
     {
      i13 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i13 = 53;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 140) {
     i13 = 11;
     break L1;
    }
    i6 = i1 + (((i3 >>> 0) / 40 | 0) * 20 | 0) | 0;
    if ((i3 | 0) > 19980) {
     i3 = (i3 >>> 0) / 80 | 0;
     i3 = __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_(i1, i1 + (i3 * 20 | 0) | 0, i6, i6 + (i3 * 20 | 0) | 0, i11, i14) | 0;
    } else i3 = __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i1, i6, i11, i14) | 0;
    if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i1, i6) | 0) {
     i5 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i5 = i4 + -20 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i5, i6) | 0) {
      i13 = 36;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 20 | 0;
    if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i1, i11) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i13 = 53;
      break L1;
     }
     while (1) {
      if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i1, i3) | 0) break;
      i3 = i3 + 20 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i13 = 53;
       break L1;
      }
     }
     HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i8 = i3 + 16 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i12 >> 2] = i9;
     i3 = i3 + 20 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i13 = 53;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i6 = i3 + 20 | 0;
      if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i1, i3) | 0) break; else i3 = i6;
     }
     while (1) {
      i5 = i4 + -20 | 0;
      if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i1, i5) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     };
     HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i9 = i3 + 16 | 0;
     i4 = i4 + -4 | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     i4 = i5;
     i3 = i6;
    }
   }
   if ((i13 | 0) == 36) {
    i13 = 0;
    HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    i17 = i1 + 16 | 0;
    i8 = i4 + -4 | 0;
    i7 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 20 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i8 = i6;
    while (1) {
     while (1) {
      i7 = i4 + 20 | 0;
      if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i4, i8) | 0) i4 = i7; else break;
     }
     while (1) {
      i6 = i5 + -20 | 0;
      if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i6, i8) | 0) break; else i5 = i6;
     }
     if (i4 >>> 0 > i6 >>> 0) {
      i5 = i8;
      i6 = i4;
      break L35;
     };
     HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
     i18 = i4 + 16 | 0;
     i5 = i5 + -4 | 0;
     i17 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i17;
     i8 = (i8 | 0) == (i4 | 0) ? i6 : i8;
     i5 = i6;
     i4 = i7;
     i3 = i3 + 1 | 0;
    }
   } else {
    i5 = i6;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i5, i6) | 0) {
    HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    i8 = i6 + 16 | 0;
    i18 = i5 + 16 | 0;
    i17 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i18 >> 2] = i17;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEbT0_SB_T_(i1, i6, i14) | 0;
    i4 = i6 + 20 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEbT0_SB_T_(i4, i2, i14) | 0) {
     i13 = 52;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i18 = i6;
   if ((i18 - i9 | 0) >= (i10 - i18 | 0)) {
    i13 = 51;
    break;
   }
   __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_(i1, i6, i14);
   i1 = i6 + 20 | 0;
  }
  if ((i13 | 0) == 51) {
   i13 = 0;
   __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_(i6 + 20 | 0, i2, i14);
   i2 = i6;
   continue;
  } else if ((i13 | 0) == 52) {
   i13 = 0;
   if (i3) {
    i13 = 53;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i13 | 0) == 5) {
  if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i11, i1) | 0)) {
   STACKTOP = i16;
   return;
  };
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i17 = i1 + 16 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i18;
  STACKTOP = i16;
  return;
 } else if ((i13 | 0) == 7) {
  __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i1, i1 + 20 | 0, i11, i14) | 0;
  STACKTOP = i16;
  return;
 } else if ((i13 | 0) == 8) {
  __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i11, i14) | 0;
  STACKTOP = i16;
  return;
 } else if ((i13 | 0) == 9) {
  __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i1 + 60 | 0, i11, i14) | 0;
  STACKTOP = i16;
  return;
 } else if ((i13 | 0) == 11) {
  i3 = i1 + 40 | 0;
  __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i1, i1 + 20 | 0, i3, i14) | 0;
  i4 = i1 + 60 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i16;
   return;
  }
  i7 = i15 + 16 | 0;
  while (1) {
   if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i4, i3) | 0) {
    HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i15 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    i5 = i4;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     i6 = i3 + 16 | 0;
     HEAP32[i5 + 16 >> 2] = HEAP32[i6 >> 2];
     if ((i3 | 0) == (i1 | 0)) break;
     i5 = i3 + -20 | 0;
     if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i14, i15, i5) | 0) {
      i18 = i3;
      i3 = i5;
      i5 = i18;
     } else break;
    }
    HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   }
   i3 = i4 + 20 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i18 = i4;
    i4 = i3;
    i3 = i18;
   }
  }
  STACKTOP = i16;
  return;
 } else if ((i13 | 0) == 53) {
  STACKTOP = i16;
  return;
 }
}

function __ZN12ImageFilters8DoRenderER17ShaderPassContextP13RenderTexturebbbb(i34, i23, i2, i22, i30, i1, i9) {
 i34 = i34 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i41 + 36 | 0;
 i28 = i41 + 24 | 0;
 i29 = i41 + 20 | 0;
 i38 = i41 + 8 | 0;
 i26 = i41 + 4 | 0;
 i19 = i41;
 i20 = i41 + 32 | 0;
 i27 = i41 + 28 | 0;
 if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 488 >> 2] | 0)) {
  STACKTOP = i41;
  return;
 }
 if ((HEAP16[gb + 1110868 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110868 | 0, i25);
  i39 = gb + 1110868 | 0;
 } else i39 = 0;
 i40 = HEAP32[gb + 1110868 >> 2] | 0;
 i36 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i36 >> 2] | 0) + 648 >> 2] | 0, i36 | 0, i40 | 0);
 i40 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 7;
 __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
 i36 = __Z22GetRenderBufferManagerv() | 0;
 i37 = i34 + 32 | 0;
 HEAP32[i37 >> 2] = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (i30) {
  i3 = HEAP32[i34 + 24 >> 2] | 0;
  if (i22 | ((HEAP32[i34 + 12 >> 2] | 0) == (HEAP32[i34 + 16 >> 2] | 0) | i1) ^ 1) i2 = HEAP32[i34 + 28 >> 2] | 0;
 } else {
  do if ((HEAP32[i34 >> 2] | 0) == (HEAP32[i34 + 4 >> 2] | 0)) i1 = i34 + 24 | 0; else {
   if (!((HEAP32[i34 + 12 >> 2] | 0) != (HEAP32[i34 + 16 >> 2] | 0) | i22)) {
    i1 = i34 + 24 | 0;
    break;
   }
   if (i22 | i1 ^ 1) {
    i1 = i34 + 28 | 0;
    break;
   } else {
    i1 = i34 + 24 | 0;
    break;
   }
  } while (0);
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i31 = HEAP8[gb + 1544216 >> 0] | 0;
 i32 = HEAP32[gb + 1110920 >> 2] | 0;
 i33 = HEAP32[gb + 1110924 >> 2] | 0;
 HEAP8[gb + 1544216 >> 0] = 0;
 HEAP32[gb + 1110920 >> 2] = i3;
 HEAP32[gb + 1110924 >> 2] = i2;
 i24 = __Z12GetGfxDevicev() | 0;
 i4 = i30 ? i34 : i34 + 12 | 0;
 HEAP32[i38 >> 2] = 0;
 i35 = i38 + 4 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 i6 = i4 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i7 = i1 - i5 | 0;
 i8 = (i7 | 0) / 12 | 0;
 if (!i7) {
  i4 = 0;
  i1 = 0;
 } else {
  if (i8 >>> 0 > 357913941) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i38);
   i5 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i6 = __Znwj(i7) | 0;
  HEAP32[i35 >> 2] = i6;
  HEAP32[i38 >> 2] = i6;
  HEAP32[i38 + 8 >> 2] = i6 + (i8 * 12 | 0);
  i4 = i1 - i5 | 0;
  i1 = i6;
  if ((i4 | 0) > 0) {
   _memcpy(i6 | 0, i5 | 0, i4 | 0) | 0;
   i4 = i6 + (((i4 >>> 0) / 12 | 0) * 12 | 0) | 0;
   HEAP32[i35 >> 2] = i4;
  } else i4 = i1;
 }
 i18 = i4 - i1 | 0;
 i12 = (i18 | 0) / 12 | 0;
 if (!i18) i10 = 0; else {
  i13 = i12 + -1 | 0;
  i14 = (i2 | 0) != 0;
  i15 = i2 + 121 | 0;
  i11 = i9 ^ 1;
  i16 = i34 + 24 | 0;
  i17 = i34 + 28 | 0;
  i4 = i9;
  i10 = 0;
  i1 = 0;
  i9 = i3;
  while (1) {
   if ((i10 | 0) == (i13 | 0)) {
    i8 = i2;
    i3 = i1;
   } else {
    if ((HEAP8[(HEAP32[i38 >> 2] | 0) + (i10 * 12 | 0) + 8 >> 0] | 0) == 0 | i4 ^ 1) i5 = i4; else {
     i5 = 0;
     i1 = __ZN12ImageFilters17SwitchTargetToLDREP13RenderTexture(i34, i1) | 0;
    }
    if (!i1) {
     i4 = __Z22GetRenderBufferManagerv() | 0;
     i3 = __Z12GetGfxDevicev() | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i5) i1 = mftCall_ii(HEAP32[i1 + 708 >> 2] | 0, i3 | 0) | 0; else i1 = mftCall_ii(HEAP32[i1 + 704 >> 2] | 0, i3 | 0) | 0;
     i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i4, -1, -1, 0, i1, 0, 0, HEAP32[i4 + 24 >> 2] | 0, 1) | 0;
     if (i1 | 0) {
      __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, 1);
      mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 375803 | 0);
     }
    }
    i8 = i1;
    i4 = i5;
    i3 = i1;
   }
   HEAP8[gb + 1544216 >> 0] = 1;
   if ((HEAP16[gb + 1110868 + 6 >> 1] | 0) > -1) {
    HEAP32[i28 >> 2] = HEAP32[(HEAP32[i38 >> 2] | 0) + (i10 * 12 | 0) >> 2];
    HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110868 | 0, i25);
    i7 = gb + 1110868 | 0;
   } else i7 = 0;
   i6 = HEAP32[gb + 1110868 >> 2] | 0;
   i5 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 648 >> 2] | 0, i5 | 0, i6 | 0);
   HEAP32[i26 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   if (__ZL27GetDestRenderTargetSurfacesP13RenderTextureR12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i8, i26, i19) | 0) {
    i6 = (i8 | 0) == (i2 | 0);
    if (i6 & i22) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) {
     i1 = HEAP32[i26 >> 2] | 0;
     if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 1) {
      i1 = __Z12GetGfxDevicev() | 0;
      i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
      HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
      mftCall_viiii(i5 | 0, i1 | 0, i25 | 0, 4, 0);
      i5 = HEAP32[i19 >> 2] | 0;
      if (i5 | 0) {
       i42 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
       HEAP32[i29 >> 2] = i5;
       HEAP32[i25 >> 2] = HEAP32[i29 >> 2];
       mftCall_viiii(i42 | 0, i1 | 0, i25 | 0, 4, 0);
      }
     }
    }
    do if (!(HEAP8[(HEAP32[i26 >> 2] | 0) + 31 >> 0] | 0)) {
     if (i14 & i6) if (HEAP8[i15 >> 0] | 0) break;
     mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 336 >> 2] | 0, i24 | 0, i26 | 0);
    } while (0);
    i1 = HEAP32[gb + 1110920 >> 2] | 0;
    do if (!i1) {
     i1 = HEAP32[i24 >> 2] | 0;
     i21 = 53;
    } else {
     i5 = HEAP32[i19 >> 2] | 0;
     i6 = i5;
     if ((i5 | 0) == (HEAP32[i1 + 136 >> 2] | 0)) i1 = HEAP32[i24 >> 2] | 0; else {
      i1 = HEAP32[i24 >> 2] | 0;
      if (!(HEAP8[i5 + 31 >> 0] | 0)) {
       i21 = 53;
       break;
      }
     }
     i42 = HEAP32[i1 + 344 >> 2] | 0;
     HEAP32[i20 >> 2] = i6;
     HEAP32[i25 >> 2] = HEAP32[i20 >> 2];
     mftCall_vii(i42 | 0, i24 | 0, i25 | 0);
    } while (0);
    if ((i21 | 0) == 53) {
     i21 = 0;
     mftCall_vii(HEAP32[i1 + 336 >> 2] | 0, i24 | 0, i19 | 0);
    }
    i42 = HEAP32[i38 >> 2] | 0;
    mftCall_viii(HEAP32[i42 + (i10 * 12 | 0) + 4 >> 2] | 0, HEAP32[i42 + (i10 * 12 | 0) >> 2] | 0, i9 | 0, i8 | 0);
   }
   HEAP8[gb + 1544216 >> 0] = 0;
   if ((HEAP8[(HEAP32[i38 >> 2] | 0) + (i10 * 12 | 0) + 8 >> 0] | 0) == 0 | i11) i21 = 62; else {
    i1 = i9;
    if ((i9 | 0) == 0 | i4) i21 = 62; else {
     __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i1);
     if ((i1 | 0) == (HEAP32[i16 >> 2] | 0)) HEAP32[i16 >> 2] = 0;
     if ((i1 | 0) == (HEAP32[i17 >> 2] | 0)) {
      HEAP32[i17 >> 2] = 0;
      i1 = 0;
     } else i1 = 0;
    }
   }
   if ((i21 | 0) == 62) {
    i21 = 0;
    if (!i9) i1 = 0; else {
     __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i9, 1);
     i1 = i9;
    }
   }
   i42 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i42 >> 2] | 0) + 652 >> 2] | 0, i42 | 0);
   if (i7 | 0) __Z12profiler_endP19ProfilerInformation(i7);
   i10 = i10 + 1 | 0;
   if (i10 >>> 0 >= i12 >>> 0) {
    i10 = i1;
    break;
   } else i9 = i3;
  }
 }
 if (i22 ^ 1 | i30) i9 = 0; else if ((HEAP32[i38 >> 2] | 0) == (HEAP32[i35 >> 2] | 0)) {
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) {
   if (!i2) {
    i1 = __Z12GetGfxDevicev() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
    i4 = __Z12GetGfxDevicev() | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 372 >> 2] | 0, i4 | 0) | 0;
   } else {
    i4 = HEAP32[i2 + 136 >> 2] | 0;
    i1 = HEAP32[i2 + 128 >> 2] | 0;
   }
   i5 = i1;
   if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 1) {
    i1 = __Z12GetGfxDevicev() | 0;
    i42 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
    HEAP32[i28 >> 2] = i5;
    HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
    mftCall_viiii(i42 | 0, i1 | 0, i25 | 0, 4, 0);
    if (i4 | 0) {
     i42 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
     HEAP32[i29 >> 2] = i4;
     HEAP32[i25 >> 2] = HEAP32[i29 >> 2];
     mftCall_viiii(i42 | 0, i1 | 0, i25 | 0, 4, 0);
    }
   }
  }
  if (!i2) {
   i42 = __Z12GetGfxDevicev() | 0;
   HEAP8[(mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 372 >> 2] | 0, i42 | 0) | 0) + 28 >> 0] = 1;
  }
  __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture(i23, i3, i2);
  i9 = 1;
 } else i9 = 0;
 i1 = HEAP32[gb + 1110920 >> 2] | 0;
 if ((i1 | 0) != 0 & (HEAP32[gb + 1110924 >> 2] | 0) != 0) {
  i8 = HEAP32[i1 + 136 >> 2] | 0;
  i1 = i8;
  if (i8 | 0) {
   i4 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 352 >> 2] | 0, i24 | 0) | 0;
   if (!i4) {
    i5 = 1;
    i6 = 0;
    i7 = 0;
   } else {
    i5 = HEAP32[i4 + 16 >> 2] | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    i7 = HEAP32[i4 + 8 >> 2] | 0;
   }
   if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i1 + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i1 + 8 >> 2] | 0) == (i7 | 0)) {
    i42 = mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 348 >> 2] | 0, i24 | 0, 0) | 0;
    HEAP32[i26 >> 2] = i42;
    if ((HEAP32[i42 + 16 >> 2] | 0) >>> 0 > 1) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 160 >> 0] | 0) {
     i1 = HEAP32[i26 >> 2] | 0;
     do if (i1 | 0) {
      if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 <= 1) break;
      i42 = __Z12GetGfxDevicev() | 0;
      i24 = HEAP32[(HEAP32[i42 >> 2] | 0) + 416 >> 2] | 0;
      HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
      mftCall_viiii(i24 | 0, i42 | 0, i25 | 0, 4, 0);
      i28 = HEAP32[(HEAP32[i42 >> 2] | 0) + 416 >> 2] | 0;
      HEAP32[i29 >> 2] = i8;
      HEAP32[i25 >> 2] = HEAP32[i29 >> 2];
      mftCall_viiii(i28 | 0, i42 | 0, i25 | 0, 4, 0);
     } while (0);
    }
    HEAP32[i27 >> 2] = i8;
    HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
    __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i26, i25, gb + 1110924 | 0, 0, -1, 0, 0) | 0;
   }
  }
 }
 if ((i18 | 0) != 0 | i9) HEAP32[i37 >> 2] = i2;
 i1 = i10;
 if (i10 | 0) if ((i1 | 0) != (HEAP32[i34 + 24 >> 2] | 0)) if ((i1 | 0) != (HEAP32[i34 + 28 >> 2] | 0)) __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i36, i1);
 i1 = i3;
 if (i3 | 0) if ((i1 | 0) != (HEAP32[i34 + 24 >> 2] | 0)) if ((i1 | 0) != (HEAP32[i34 + 28 >> 2] | 0)) __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i36, i1);
 if (!i30) {
  i1 = i34 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i36, i2);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i34 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i36, i2);
   if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i37 >> 2] | 0)) HEAP32[i37 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
  }
 }
 HEAP8[gb + 1544216 >> 0] = i31;
 HEAP32[gb + 1110920 >> 2] = i32;
 HEAP32[gb + 1110924 >> 2] = i33;
 i1 = HEAP32[i38 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i35 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i35 >> 2] = i3 + (~(((i3 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 HEAP32[gb + 1163232 >> 2] = i40;
 i42 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i42 >> 2] | 0) + 652 >> 2] | 0, i42 | 0);
 if (!i39) {
  STACKTOP = i41;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i39);
 STACKTOP = i41;
 return;
}

function __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i4, i46, i59, i60, i61, i62) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i46 = i46 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, i67 = 0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i63 + 224 | 0;
 i56 = i63 + 160 | 0;
 i57 = i63 + 96 | 0;
 i28 = i63 + 80 | 0;
 i55 = i63 + 324 | 0;
 i49 = i63 + 64 | 0;
 i52 = i63 + 48 | 0;
 i53 = i63 + 32 | 0;
 i50 = i63 + 312 | 0;
 i54 = i63 + 16 | 0;
 i25 = i63;
 i24 = i63 + 300 | 0;
 i51 = i63 + 288 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i55 >> 2] = 0;
 i26 = i46 + 48 | 0;
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 i32 = i46 + 52 | 0;
 f9 = Math_fround(HEAPF32[i32 >> 2]);
 i45 = i46 + 56 | 0;
 f10 = Math_fround(HEAPF32[i45 >> 2]);
 i47 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i47 ? f8 : Math_fround(1.0);
 f11 = i47 ? f9 : Math_fround(0.0);
 f7 = i47 ? f10 : Math_fround(0.0);
 HEAPF32[i49 >> 2] = f12;
 i47 = i49 + 4 | 0;
 HEAPF32[i47 >> 2] = f11;
 i48 = i49 + 8 | 0;
 HEAPF32[i48 >> 2] = f7;
 HEAPF32[i49 + 12 >> 2] = Math_fround(0.0);
 f27 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f27 = Math_fround((f27 > f2 ? f2 : f27) * Math_fround(.100000001));
 f27 = Math_fround(f27 * f27);
 HEAP32[i52 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i52 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i53 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i53 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i54 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
 i28 = i46 + 4 | 0;
 i29 = i46 + 8 | 0;
 i30 = i46 + 16 | 0;
 i31 = i46 + 20 | 0;
 i33 = i46 + 24 | 0;
 i34 = i46 + 32 | 0;
 i35 = i46 + 36 | 0;
 i36 = i46 + 40 | 0;
 i37 = i1 + 96 | 0;
 i38 = i1 + 100 | 0;
 i39 = i1 + 104 | 0;
 i40 = i1 + 112 | 0;
 i41 = i1 + 116 | 0;
 i42 = i1 + 120 | 0;
 i43 = i1 + 128 | 0;
 i44 = i1 + 132 | 0;
 i21 = i1 + 136 | 0;
 i22 = i4 + 144 | 0;
 i23 = i4 + 148 | 0;
 i4 = i4 + 152 | 0;
 i13 = i25 + 4 | 0;
 i14 = i25 + 8 | 0;
 i15 = i25 + 12 | 0;
 i16 = i58 + 4 | 0;
 i17 = i58 + 8 | 0;
 i18 = i58 + 16 | 0;
 i19 = i58 + 20 | 0;
 i20 = i58 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  HEAP32[i54 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  f70 = Math_fround(-f12);
  f80 = Math_fround(-f11);
  f81 = Math_fround(-f7);
  f73 = Math_fround(HEAPF32[i46 >> 2]);
  f85 = Math_fround(f73 * f70);
  f71 = Math_fround(HEAPF32[i28 >> 2]);
  f85 = Math_fround(f85 + Math_fround(f71 * f80));
  f3 = Math_fround(HEAPF32[i29 >> 2]);
  f85 = Math_fround(f85 + Math_fround(f3 * f81));
  f66 = Math_fround(HEAPF32[i30 >> 2]);
  f84 = Math_fround(f66 * f70);
  f65 = Math_fround(HEAPF32[i31 >> 2]);
  f84 = Math_fround(f84 + Math_fround(f65 * f80));
  f6 = Math_fround(HEAPF32[i33 >> 2]);
  f84 = Math_fround(f84 + Math_fround(f6 * f81));
  f74 = Math_fround(HEAPF32[i34 >> 2]);
  f70 = Math_fround(f74 * f70);
  f72 = Math_fround(HEAPF32[i35 >> 2]);
  f80 = Math_fround(f70 + Math_fround(f72 * f80));
  f70 = Math_fround(HEAPF32[i36 >> 2]);
  f81 = Math_fround(f80 + Math_fround(f70 * f81));
  f80 = Math_fround(HEAPF32[i37 >> 2]);
  f78 = Math_fround(HEAPF32[i38 >> 2]);
  f76 = Math_fround(HEAPF32[i39 >> 2]);
  f79 = Math_fround(HEAPF32[i40 >> 2]);
  f77 = Math_fround(HEAPF32[i41 >> 2]);
  f75 = Math_fround(HEAPF32[i42 >> 2]);
  f5 = Math_fround(HEAPF32[i43 >> 2]);
  f64 = Math_fround(HEAPF32[i44 >> 2]);
  f69 = Math_fround(HEAPF32[i21 >> 2]);
  f83 = Math_fround(Math_fround(Math_fround(f85 * f80) + Math_fround(f84 * f78)) + Math_fround(f81 * f76));
  f82 = Math_fround(Math_fround(Math_fround(f85 * f79) + Math_fround(f84 * f77)) + Math_fround(f81 * f75));
  f81 = Math_fround(Math_fround(Math_fround(f85 * f5) + Math_fround(f84 * f64)) + Math_fround(f81 * f69));
  i67 = f83 > f82 & f83 > f81;
  i68 = f82 > f81;
  f5 = i67 ? f80 : i68 ? f79 : f5;
  f64 = i67 ? f78 : i68 ? f77 : f64;
  f69 = i67 ? f76 : i68 ? f75 : f69;
  f66 = Math_fround(f8 + Math_fround(Math_fround(f74 * f69) + Math_fround(Math_fround(f73 * f5) + Math_fround(f66 * f64))));
  f65 = Math_fround(f9 + Math_fround(Math_fround(f72 * f69) + Math_fround(Math_fround(f71 * f5) + Math_fround(f65 * f64))));
  f64 = Math_fround(f10 + Math_fround(Math_fround(f70 * f69) + Math_fround(Math_fround(f3 * f5) + Math_fround(f6 * f64))));
  i68 = f12 > Math_fround(0.0);
  i67 = f11 > Math_fround(0.0);
  i1 = f7 > Math_fround(0.0);
  f6 = Math_fround(HEAPF32[i22 >> 2]);
  f5 = Math_fround(HEAPF32[i23 >> 2]);
  f3 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(-f6);
  f9 = Math_fround(-f5);
  f10 = Math_fround(-f3);
  f8 = i68 ? f6 : f8;
  f9 = i67 ? f5 : f9;
  f10 = i1 ? f3 : f10;
  f3 = Math_fround(f66 - f8);
  f5 = Math_fround(f65 - f9);
  f6 = Math_fround(f64 - f10);
  f12 = Math_fround(f2 - Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f12 * f3) + Math_fround(f11 * f5))));
  i1 = HEAP32[i55 >> 2] | 0;
  HEAPF32[i56 + (i1 << 4) >> 2] = f66;
  HEAPF32[i56 + (i1 << 4) + 4 >> 2] = f65;
  HEAPF32[i56 + (i1 << 4) + 8 >> 2] = f64;
  HEAPF32[i56 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i57 + (i1 << 4) >> 2] = f8;
  HEAPF32[i57 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i57 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i57 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i58 + (i1 << 4) >> 2] = f3;
  HEAPF32[i58 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i58 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i58 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i55 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i58 >> 2]);
    f5 = Math_fround(HEAPF32[i16 >> 2]);
    f6 = Math_fround(HEAPF32[i17 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f83 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i68 = f83 > Math_fround(1.0);
     f83 = i68 ? Math_fround(1.0) : f83;
     i68 = f83 > Math_fround(0.0);
     f83 = i68 ? f83 : Math_fround(0.0);
     f84 = Math_fround(f5 + Math_fround(f8 * f83));
     f85 = Math_fround(f6 + Math_fround(f9 * f83));
     HEAPF32[i25 >> 2] = Math_fround(f3 + Math_fround(f7 * f83));
     HEAPF32[i13 >> 2] = f84;
     HEAPF32[i14 >> 2] = f85;
     HEAPF32[i15 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i55 >> 2] = 1;
     HEAP32[i25 >> 2] = HEAP32[i58 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i58 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i58, i56, i57, i55);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i58, i56, i57, i55);
    break;
   }
  default:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i49 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i49 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i49 >> 2]);
  f6 = Math_fround(HEAPF32[i47 >> 2]);
  f7 = Math_fround(HEAPF32[i48 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i50 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f27 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i26 >> 2]);
  f9 = Math_fround(HEAPF32[i32 >> 2]);
  f10 = Math_fround(HEAPF32[i45 >> 2]);
  f2 = f3;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i58, i56, i57, i49, i59, i60, i1);
  f83 = Math_fround(HEAPF32[i49 >> 2]);
  f84 = Math_fround(HEAPF32[i47 >> 2]);
  f82 = Math_fround(HEAPF32[i48 >> 2]);
  f85 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f83 * f83) + Math_fround(f84 * f84)) + Math_fround(f82 * f82)))));
  f83 = Math_fround(-Math_fround(f83 * f85));
  f84 = Math_fround(-Math_fround(f84 * f85));
  f85 = Math_fround(-Math_fround(f82 * f85));
  HEAPF32[i62 >> 2] = f2;
  i68 = i62 + 4 | 0;
  HEAP32[i68 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAPF32[i61 >> 2] = f83;
  HEAPF32[i61 + 4 >> 2] = f84;
  HEAPF32[i61 + 8 >> 2] = f85;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  i68 = 0;
  STACKTOP = i63;
  return i68 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i58, i56, i57, i54, i59, i60, HEAP32[i55 >> 2] | 0);
  HEAP32[i59 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i59 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i60 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i60 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  f82 = Math_fround(HEAPF32[i54 >> 2]);
  f84 = Math_fround(HEAPF32[i54 + 4 >> 2]);
  f85 = Math_fround(HEAPF32[i54 + 8 >> 2]);
  f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f82 * f82) + Math_fround(f84 * f84)) + Math_fround(f85 * f85)))));
  f84 = Math_fround(-Math_fround(f84 * f83));
  f85 = Math_fround(-Math_fround(f85 * f83));
  HEAPF32[i61 >> 2] = Math_fround(-Math_fround(f82 * f83));
  HEAPF32[i61 + 4 >> 2] = f84;
  HEAPF32[i61 + 8 >> 2] = f85;
  HEAPF32[i61 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i62 >> 2] = i1 ? f3 : f2;
  i68 = i62 + 4 | 0;
  HEAP32[i68 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  i68 = i1 ? 1 : 3;
  STACKTOP = i63;
  return i68 | 0;
 }
 return 0;
}

function __ZN11ForceModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles(i5, i1, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, f67 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 3264 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 3216 | 0;
 i7 = i10 + 1608 | 0;
 i8 = i10;
 if ((HEAP16[gb + 1451800 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451800 | 0, i3);
  i4 = gb + 1451800 | 0;
 } else i4 = 0;
 i1 = __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_(i3, (HEAP32[i1 + 280 >> 2] | 0) == 1, (HEAP8[i5 + 800 >> 0] | 0) != 0, i2 + 52 | 0, i2 + 180 | 0) | 0;
 if (!(HEAP8[i5 + 94 >> 0] | 0)) i9 = 7; else if (!(HEAP8[i5 + 358 >> 0] | 0)) i9 = 7; else if (!(HEAP8[i5 + 622 >> 0] | 0)) i9 = 7; else {
  i62 = i5 + 8 | 0;
  i61 = i5 + 12 | 0;
  i52 = HEAP32[i61 >> 2] | 0;
  i60 = i5 + 16 | 0;
  i57 = HEAP32[i60 >> 2] | 0;
  i63 = i5 + 20 | 0;
  i58 = HEAP32[i63 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i7 + 4 >> 2] = i52;
  HEAP32[i7 + 8 >> 2] = i57;
  HEAP32[i7 + 12 >> 2] = i58;
  i58 = i5 + 24 | 0;
  i57 = i5 + 28 | 0;
  i52 = HEAP32[i57 >> 2] | 0;
  i59 = i5 + 32 | 0;
  i45 = HEAP32[i59 >> 2] | 0;
  i55 = i5 + 36 | 0;
  i56 = HEAP32[i55 >> 2] | 0;
  HEAP32[i7 + 16 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i7 + 20 >> 2] = i52;
  HEAP32[i7 + 24 >> 2] = i45;
  HEAP32[i7 + 28 >> 2] = i56;
  i56 = i5 + 40 | 0;
  i45 = i56;
  i52 = HEAP32[i45 + 4 >> 2] | 0;
  i53 = i7 + 32 | 0;
  HEAP32[i53 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i53 + 4 >> 2] = i52;
  i53 = i5 + 48 | 0;
  i52 = i5 + 52 | 0;
  i45 = HEAP32[i52 >> 2] | 0;
  i51 = i5 + 56 | 0;
  i48 = HEAP32[i51 >> 2] | 0;
  i54 = i5 + 60 | 0;
  i49 = HEAP32[i54 >> 2] | 0;
  HEAP32[i7 + 40 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i7 + 44 >> 2] = i45;
  HEAP32[i7 + 48 >> 2] = i48;
  HEAP32[i7 + 52 >> 2] = i49;
  i49 = i5 + 64 | 0;
  i48 = i5 + 68 | 0;
  i45 = HEAP32[i48 >> 2] | 0;
  i50 = i5 + 72 | 0;
  i44 = HEAP32[i50 >> 2] | 0;
  i46 = i5 + 76 | 0;
  i47 = HEAP32[i46 >> 2] | 0;
  HEAP32[i7 + 56 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i7 + 60 >> 2] = i45;
  HEAP32[i7 + 64 >> 2] = i44;
  HEAP32[i7 + 68 >> 2] = i47;
  i47 = i5 + 80 | 0;
  i44 = i47;
  i45 = HEAP32[i44 + 4 >> 2] | 0;
  i64 = i7 + 72 | 0;
  HEAP32[i64 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i64 + 4 >> 2] = i45;
  __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv(i7);
  i64 = i7 + 80 | 0;
  i45 = i5 + 272 | 0;
  i44 = i5 + 276 | 0;
  i35 = HEAP32[i44 >> 2] | 0;
  i43 = i5 + 280 | 0;
  i40 = HEAP32[i43 >> 2] | 0;
  i42 = i5 + 284 | 0;
  i41 = HEAP32[i42 >> 2] | 0;
  HEAP32[i64 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i7 + 84 >> 2] = i35;
  HEAP32[i7 + 88 >> 2] = i40;
  HEAP32[i7 + 92 >> 2] = i41;
  i41 = i5 + 288 | 0;
  i40 = i5 + 292 | 0;
  i35 = HEAP32[i40 >> 2] | 0;
  i37 = i5 + 296 | 0;
  i26 = HEAP32[i37 >> 2] | 0;
  i38 = i5 + 300 | 0;
  i39 = HEAP32[i38 >> 2] | 0;
  HEAP32[i7 + 96 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i7 + 100 >> 2] = i35;
  HEAP32[i7 + 104 >> 2] = i26;
  HEAP32[i7 + 108 >> 2] = i39;
  i39 = i5 + 304 | 0;
  i26 = i39;
  i35 = HEAP32[i26 + 4 >> 2] | 0;
  i36 = i7 + 112 | 0;
  HEAP32[i36 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i36 + 4 >> 2] = i35;
  i36 = i5 + 312 | 0;
  i35 = i5 + 316 | 0;
  i26 = HEAP32[i35 >> 2] | 0;
  i34 = i5 + 320 | 0;
  i31 = HEAP32[i34 >> 2] | 0;
  i33 = i5 + 324 | 0;
  i32 = HEAP32[i33 >> 2] | 0;
  HEAP32[i7 + 120 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i7 + 124 >> 2] = i26;
  HEAP32[i7 + 128 >> 2] = i31;
  HEAP32[i7 + 132 >> 2] = i32;
  i32 = i5 + 328 | 0;
  i31 = i5 + 332 | 0;
  i26 = HEAP32[i31 >> 2] | 0;
  i28 = i5 + 336 | 0;
  i17 = HEAP32[i28 >> 2] | 0;
  i29 = i5 + 340 | 0;
  i30 = HEAP32[i29 >> 2] | 0;
  HEAP32[i7 + 136 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i7 + 140 >> 2] = i26;
  HEAP32[i7 + 144 >> 2] = i17;
  HEAP32[i7 + 148 >> 2] = i30;
  i30 = i5 + 344 | 0;
  i17 = i30;
  i26 = HEAP32[i17 + 4 >> 2] | 0;
  i27 = i7 + 152 | 0;
  HEAP32[i27 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i27 + 4 >> 2] = i26;
  __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv(i64);
  i64 = i7 + 160 | 0;
  i27 = i5 + 536 | 0;
  i26 = i5 + 540 | 0;
  i17 = HEAP32[i26 >> 2] | 0;
  i25 = i5 + 544 | 0;
  i22 = HEAP32[i25 >> 2] | 0;
  i24 = i5 + 548 | 0;
  i23 = HEAP32[i24 >> 2] | 0;
  HEAP32[i64 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i7 + 164 >> 2] = i17;
  HEAP32[i7 + 168 >> 2] = i22;
  HEAP32[i7 + 172 >> 2] = i23;
  i23 = i5 + 552 | 0;
  i22 = i5 + 556 | 0;
  i17 = HEAP32[i22 >> 2] | 0;
  i19 = i5 + 560 | 0;
  i65 = HEAP32[i19 >> 2] | 0;
  i20 = i5 + 564 | 0;
  i21 = HEAP32[i20 >> 2] | 0;
  HEAP32[i7 + 176 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i7 + 180 >> 2] = i17;
  HEAP32[i7 + 184 >> 2] = i65;
  HEAP32[i7 + 188 >> 2] = i21;
  i21 = i5 + 568 | 0;
  i65 = i21;
  i17 = HEAP32[i65 + 4 >> 2] | 0;
  i18 = i7 + 192 | 0;
  HEAP32[i18 >> 2] = HEAP32[i65 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = i5 + 576 | 0;
  i17 = i5 + 580 | 0;
  i65 = HEAP32[i17 >> 2] | 0;
  i16 = i5 + 584 | 0;
  i13 = HEAP32[i16 >> 2] | 0;
  i15 = i5 + 588 | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 + 200 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i7 + 204 >> 2] = i65;
  HEAP32[i7 + 208 >> 2] = i13;
  HEAP32[i7 + 212 >> 2] = i14;
  i14 = i5 + 592 | 0;
  i13 = i5 + 596 | 0;
  i65 = HEAP32[i13 >> 2] | 0;
  i2 = i5 + 600 | 0;
  i66 = HEAP32[i2 >> 2] | 0;
  i11 = i5 + 604 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  HEAP32[i7 + 216 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i7 + 220 >> 2] = i65;
  HEAP32[i7 + 224 >> 2] = i66;
  HEAP32[i7 + 228 >> 2] = i12;
  i12 = i5 + 608 | 0;
  i66 = i12;
  i65 = HEAP32[i66 + 4 >> 2] | 0;
  i5 = i7 + 232 | 0;
  HEAP32[i5 >> 2] = HEAP32[i66 >> 2];
  HEAP32[i5 + 4 >> 2] = i65;
  __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv(i64);
  i61 = HEAP32[i61 >> 2] | 0;
  i60 = HEAP32[i60 >> 2] | 0;
  i5 = HEAP32[i63 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i62 >> 2];
  HEAP32[i8 + 4 >> 2] = i61;
  HEAP32[i8 + 8 >> 2] = i60;
  HEAP32[i8 + 12 >> 2] = i5;
  i57 = HEAP32[i57 >> 2] | 0;
  i5 = HEAP32[i59 >> 2] | 0;
  i55 = HEAP32[i55 >> 2] | 0;
  HEAP32[i8 + 16 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i8 + 20 >> 2] = i57;
  HEAP32[i8 + 24 >> 2] = i5;
  HEAP32[i8 + 28 >> 2] = i55;
  i55 = HEAP32[i56 + 4 >> 2] | 0;
  i5 = i8 + 32 | 0;
  HEAP32[i5 >> 2] = HEAP32[i56 >> 2];
  HEAP32[i5 + 4 >> 2] = i55;
  i52 = HEAP32[i52 >> 2] | 0;
  i51 = HEAP32[i51 >> 2] | 0;
  i5 = HEAP32[i54 >> 2] | 0;
  HEAP32[i8 + 40 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i8 + 44 >> 2] = i52;
  HEAP32[i8 + 48 >> 2] = i51;
  HEAP32[i8 + 52 >> 2] = i5;
  i48 = HEAP32[i48 >> 2] | 0;
  i5 = HEAP32[i50 >> 2] | 0;
  i46 = HEAP32[i46 >> 2] | 0;
  HEAP32[i8 + 56 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i8 + 60 >> 2] = i48;
  HEAP32[i8 + 64 >> 2] = i5;
  HEAP32[i8 + 68 >> 2] = i46;
  i46 = HEAP32[i47 + 4 >> 2] | 0;
  i5 = i8 + 72 | 0;
  HEAP32[i5 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i5 + 4 >> 2] = i46;
  __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i8);
  i5 = i8 + 80 | 0;
  i44 = HEAP32[i44 >> 2] | 0;
  i43 = HEAP32[i43 >> 2] | 0;
  i42 = HEAP32[i42 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i8 + 84 >> 2] = i44;
  HEAP32[i8 + 88 >> 2] = i43;
  HEAP32[i8 + 92 >> 2] = i42;
  i40 = HEAP32[i40 >> 2] | 0;
  i37 = HEAP32[i37 >> 2] | 0;
  i38 = HEAP32[i38 >> 2] | 0;
  HEAP32[i8 + 96 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i8 + 100 >> 2] = i40;
  HEAP32[i8 + 104 >> 2] = i37;
  HEAP32[i8 + 108 >> 2] = i38;
  i38 = HEAP32[i39 + 4 >> 2] | 0;
  i37 = i8 + 112 | 0;
  HEAP32[i37 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i37 + 4 >> 2] = i38;
  i35 = HEAP32[i35 >> 2] | 0;
  i34 = HEAP32[i34 >> 2] | 0;
  i33 = HEAP32[i33 >> 2] | 0;
  HEAP32[i8 + 120 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i8 + 124 >> 2] = i35;
  HEAP32[i8 + 128 >> 2] = i34;
  HEAP32[i8 + 132 >> 2] = i33;
  i31 = HEAP32[i31 >> 2] | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  HEAP32[i8 + 136 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i8 + 140 >> 2] = i31;
  HEAP32[i8 + 144 >> 2] = i28;
  HEAP32[i8 + 148 >> 2] = i29;
  i29 = HEAP32[i30 + 4 >> 2] | 0;
  i28 = i8 + 152 | 0;
  HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i28 + 4 >> 2] = i29;
  __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i5);
  i5 = i8 + 160 | 0;
  i26 = HEAP32[i26 >> 2] | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i8 + 164 >> 2] = i26;
  HEAP32[i8 + 168 >> 2] = i25;
  HEAP32[i8 + 172 >> 2] = i24;
  i22 = HEAP32[i22 >> 2] | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  HEAP32[i8 + 176 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i8 + 180 >> 2] = i22;
  HEAP32[i8 + 184 >> 2] = i19;
  HEAP32[i8 + 188 >> 2] = i20;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = i8 + 192 | 0;
  HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  i17 = HEAP32[i17 >> 2] | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 + 200 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i8 + 204 >> 2] = i17;
  HEAP32[i8 + 208 >> 2] = i16;
  HEAP32[i8 + 212 >> 2] = i15;
  i13 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i8 + 216 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i8 + 220 >> 2] = i13;
  HEAP32[i8 + 224 >> 2] = i2;
  HEAP32[i8 + 228 >> 2] = i11;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i2 = i8 + 232 | 0;
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = i11;
  __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i5);
  __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb(i7, i8, i6, i3, i1);
 }
 if ((i9 | 0) == 7) {
  i66 = i7 + 240 | 0;
  i58 = i5 + 96 | 0;
  i57 = i5 + 88 | 0;
  f67 = Math_fround(HEAPF32[i57 >> 2]);
  i59 = i5 + 92 | 0;
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i58, f67, HEAP16[i59 >> 1] | 0);
  __ZN16MinMaxPolyCurves15DoubleIntegrateEv(i66);
  i66 = i7 + 696 | 0;
  i61 = i5 + 360 | 0;
  i60 = i5 + 352 | 0;
  f67 = Math_fround(HEAPF32[i60 >> 2]);
  i62 = i5 + 356 | 0;
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i61, f67, HEAP16[i62 >> 1] | 0);
  __ZN16MinMaxPolyCurves15DoubleIntegrateEv(i66);
  i66 = i7 + 1152 | 0;
  i64 = i5 + 624 | 0;
  i63 = i5 + 616 | 0;
  f67 = Math_fround(HEAPF32[i63 >> 2]);
  i65 = i5 + 620 | 0;
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i64, f67, HEAP16[i65 >> 1] | 0);
  __ZN16MinMaxPolyCurves15DoubleIntegrateEv(i66);
  i66 = i8 + 240 | 0;
  f67 = Math_fround(HEAPF32[i57 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i58, f67, HEAP16[i59 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i66);
  i66 = i8 + 696 | 0;
  f67 = Math_fround(HEAPF32[i60 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i61, f67, HEAP16[i62 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i66);
  i66 = i8 + 1152 | 0;
  f67 = Math_fround(HEAPF32[i63 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i66, i64, f67, HEAP16[i65 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i66);
  __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb(i7, i8, i6, i3, i1);
 }
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i10;
 return;
}

function __ZN24ConvexVsHeightfieldSweepC2ERN5physx2Gu15HeightFieldUtilERKNS1_14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_11PxTransformESC_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEfbb(i11, i5, i8, i2, i3, i6, i12, f4, i7, f9, i1, i10) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 f4 = Math_fround(f4);
 i7 = i7 | 0;
 f9 = Math_fround(f9);
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, i49 = 0, f50 = f0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i13 + 64 | 0;
 i45 = i13 + 112 | 0;
 i39 = i13 + 80 | 0;
 i29 = i13 + 48 | 0;
 i31 = i13 + 96 | 0;
 i16 = i13 + 32 | 0;
 i15 = i13 + 16 | 0;
 i14 = i13;
 HEAP32[i11 >> 2] = gb + 84704 + 8;
 HEAP32[i11 + 4 >> 2] = i5;
 i51 = i11 + 64 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i51 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i45 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 HEAP32[i45 + 12 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 HEAP32[i39 + 4 >> 2] = 0;
 HEAP32[i39 + 8 >> 2] = 0;
 HEAP32[i39 + 12 >> 2] = 0;
 i51 = i11 + 16 | 0;
 HEAPF32[i51 >> 2] = Math_fround(1.0);
 i49 = i11 + 20 | 0;
 HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i45 = i11 + 36 | 0;
 HEAPF32[i45 >> 2] = Math_fround(1.0);
 i43 = i11 + 40 | 0;
 HEAP32[i43 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
 i39 = i11 + 56 | 0;
 HEAPF32[i39 >> 2] = Math_fround(1.0);
 i38 = i11 + 60 | 0;
 HEAPF32[i38 >> 2] = Math_fround(0.0);
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAP32[i11 + 80 >> 2] = 0;
 i34 = i11 + 84 | 0;
 HEAP32[i34 >> 2] = 0;
 i33 = i11 + 88 | 0;
 HEAP32[i33 >> 2] = 0;
 i30 = i11 + 92 | 0;
 HEAP32[i30 >> 2] = 1065353216;
 i5 = i11 + 96 | 0;
 HEAP32[i5 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
 i5 = i11 + 112 | 0;
 i29 = i11 + 176 | 0;
 HEAP32[i11 + 192 >> 2] = 0;
 i18 = i11 + 128 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 i17 = i11 + 144 | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 160 >> 2] = Math_fround(0.0);
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i11 + 320 >> 2] = 0;
 HEAP32[i11 + 324 >> 2] = 0;
 HEAP16[i11 + 332 >> 1] = 0;
 i29 = i11 + 336 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAP32[i29 + 16 >> 2] = 0;
 HEAP32[i29 + 20 >> 2] = 0;
 HEAP32[i11 + 400 >> 2] = HEAP32[i12 >> 2];
 i29 = i12 + 4 | 0;
 HEAP32[i11 + 404 >> 2] = HEAP32[i29 >> 2];
 i28 = i12 + 8 | 0;
 HEAP32[i11 + 408 >> 2] = HEAP32[i28 >> 2];
 HEAPF32[i11 + 424 >> 2] = f9;
 HEAP32[i11 + 428 >> 2] = HEAPU16[i7 >> 1];
 HEAP8[i11 + 432 >> 0] = i1 & 1;
 HEAP8[i11 + 433 >> 0] = i10 & 1;
 HEAP8[i11 + 434 >> 0] = 0;
 HEAP8[i11 + 435 >> 0] = 0;
 HEAP32[i11 + 328 >> 2] = -1;
 HEAPF32[i11 + 360 >> 2] = f4;
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f22 = Math_fround(HEAPF32[i29 >> 2]);
 f24 = Math_fround(HEAPF32[i28 >> 2]);
 f53 = Math_fround(HEAPF32[i6 >> 2]);
 f55 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f54 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f42 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 i7 = i6 + 16 | 0;
 f48 = Math_fround(HEAPF32[i7 >> 2]);
 f50 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f46 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i3 = i3 + 16 | 0;
 f25 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f52 = Math_fround(-f32);
 f47 = Math_fround(-f27);
 f40 = Math_fround(-f23);
 f48 = Math_fround(f48 - f25);
 f50 = Math_fround(f50 - f19);
 f46 = Math_fround(f46 - f21);
 f20 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f35 = Math_fround(Math_fround(Math_fround(f48 * f52) + Math_fround(f50 * f47)) + Math_fround(f46 * f40));
 f37 = Math_fround(Math_fround(Math_fround(f35 * f52) + Math_fround(Math_fround(f20 * f48) + Math_fround(f26 * Math_fround(Math_fround(f46 * f47) - Math_fround(f50 * f40))))) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(Math_fround(f35 * f47) + Math_fround(Math_fround(f20 * f50) + Math_fround(f26 * Math_fround(Math_fround(f48 * f40) - Math_fround(f46 * f52))))) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f46) + Math_fround(f26 * Math_fround(Math_fround(f50 * f52) - Math_fround(f48 * f47)))) + Math_fround(f35 * f40)) * Math_fround(2.0));
 f48 = Math_fround(Math_fround(f42 * f26) - Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(f55 * f47)) + Math_fround(f54 * f40)));
 f50 = Math_fround(Math_fround(Math_fround(f54 * f47) - Math_fround(f55 * f40)) + Math_fround(Math_fround(f42 * f52) + Math_fround(f53 * f26)));
 f46 = Math_fround(Math_fround(Math_fround(f53 * f40) - Math_fround(f54 * f52)) + Math_fround(Math_fround(f42 * f47) + Math_fround(f55 * f26)));
 f54 = Math_fround(Math_fround(Math_fround(f55 * f52) - Math_fround(f53 * f47)) + Math_fround(Math_fround(f42 * f40) + Math_fround(f54 * f26)));
 f40 = Math_fround(f50 + f50);
 f42 = Math_fround(f46 + f46);
 f47 = Math_fround(f54 + f54);
 f53 = Math_fround(f46 * f42);
 f52 = Math_fround(f54 * f47);
 f46 = Math_fround(f46 * f40);
 f55 = Math_fround(f54 * f40);
 f41 = Math_fround(f48 * f40);
 f54 = Math_fround(f54 * f42);
 f42 = Math_fround(f48 * f42);
 f47 = Math_fround(f48 * f47);
 f40 = Math_fround(Math_fround(1.0) - Math_fround(f50 * f40));
 f50 = Math_fround(f46 + f47);
 f48 = Math_fround(f55 - f42);
 f47 = Math_fround(f46 - f47);
 f46 = Math_fround(f40 - f52);
 f44 = Math_fround(f54 + f41);
 f42 = Math_fround(f55 + f42);
 f41 = Math_fround(f54 - f41);
 f40 = Math_fround(f40 - f53);
 HEAPF32[i51 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f53) - f52);
 HEAPF32[i49 >> 2] = f50;
 HEAPF32[i11 + 24 >> 2] = f48;
 HEAPF32[i11 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 32 >> 2] = f47;
 HEAPF32[i45 >> 2] = f46;
 HEAPF32[i43 >> 2] = f44;
 HEAPF32[i11 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 48 >> 2] = f42;
 HEAPF32[i11 + 52 >> 2] = f41;
 HEAPF32[i39 >> 2] = f40;
 HEAPF32[i38 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 64 >> 2] = f37;
 HEAPF32[i11 + 68 >> 2] = f36;
 HEAPF32[i11 + 72 >> 2] = f35;
 HEAPF32[i11 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 80 >> 2] = f32;
 HEAPF32[i34 >> 2] = f27;
 HEAPF32[i33 >> 2] = f23;
 HEAPF32[i30 >> 2] = f26;
 HEAPF32[i11 + 96 >> 2] = f25;
 HEAPF32[i11 + 100 >> 2] = f19;
 HEAPF32[i11 + 104 >> 2] = f21;
 HEAPF32[i11 + 108 >> 2] = Math_fround(0.0);
 f9 = Math_fround(-Math_fround(f9 * f4));
 f22 = Math_fround(-Math_fround(f22 * f4));
 f24 = Math_fround(-Math_fround(f24 * f4));
 f21 = Math_fround(Math_fround(Math_fround(f32 * f9) + Math_fround(f27 * f22)) + Math_fround(f23 * f24));
 f19 = Math_fround(Math_fround(Math_fround(f27 * f21) + Math_fround(Math_fround(f20 * f22) - Math_fround(f26 * Math_fround(Math_fround(f23 * f9) - Math_fround(f32 * f24))))) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(Math_fround(f23 * f21) + Math_fround(Math_fround(f20 * f24) - Math_fround(f26 * Math_fround(Math_fround(f32 * f22) - Math_fround(f27 * f9))))) * Math_fround(2.0));
 HEAPF32[i11 + 368 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f21) + Math_fround(Math_fround(f20 * f9) - Math_fround(f26 * Math_fround(Math_fround(f27 * f24) - Math_fround(f23 * f22))))) * Math_fround(2.0));
 HEAPF32[i11 + 372 >> 2] = f19;
 HEAPF32[i11 + 376 >> 2] = f25;
 HEAPF32[i11 + 380 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 384 >> 2] = f4;
 i3 = i11 + 388 | 0;
 HEAP32[i3 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i3 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i3;
 HEAP32[i16 + 4 >> 2] = i7;
 HEAP32[i16 + 8 >> 2] = i10;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 i31 = i2 + 12 | 0;
 i30 = HEAP32[i31 + 4 >> 2] | 0;
 i1 = HEAP32[i31 + 8 >> 2] | 0;
 i2 = HEAP32[i31 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i15 + 4 >> 2] = i30;
 HEAP32[i15 + 8 >> 2] = i1;
 HEAP32[i15 + 12 >> 2] = i2;
 f25 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f24 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i6 >> 2]);
 f26 = Math_fround(f25 * f27);
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f19 * f4));
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f22 * f9));
 f20 = Math_fround(Math_fround(f4 * f26) + Math_fround(Math_fround(f19 * f24) - Math_fround(f23 * Math_fround(Math_fround(f25 * f9) - Math_fround(f22 * f27)))));
 f21 = Math_fround(Math_fround(Math_fround(f22 * f24) - Math_fround(f23 * Math_fround(Math_fround(f19 * f27) - Math_fround(f25 * f4)))) + Math_fround(f9 * f26));
 HEAPF32[i11 + 412 >> 2] = Math_fround(Math_fround(f27 * f26) + Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * Math_fround(Math_fround(f22 * f4) - Math_fround(f19 * f9)))));
 HEAPF32[i11 + 416 >> 2] = f20;
 HEAPF32[i11 + 420 >> 2] = f21;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i12 = (HEAP32[i8 + 40 >> 2] | 0) + ((HEAPU8[i8 + 39 >> 0] | 0) * 20 | 0) | 0;
 f21 = Math_fround(HEAPF32[i8 + 52 >> 2]);
 f20 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f9 = Math_fround(HEAPF32[i8 + 60 >> 2]);
 f19 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(f21 * f19);
 f4 = Math_fround(f20 * f4);
 f9 = Math_fround(f9 * (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = f19 <= f4 ? f19 : f4;
 f9 = f4 <= f9 ? f4 : f9;
 HEAPF32[i18 >> 2] = Math_fround(f9 * Math_fround(.200000003));
 HEAPF32[i17 >> 2] = Math_fround(f9 * Math_fround(.100000001));
 __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_(i16, i15, i11 + 208 | 0, i11 + 256 | 0);
 HEAP32[i11 + 312 >> 2] = i12;
 HEAP8[i11 + 316 >> 0] = HEAP8[i8 + 38 >> 0] | 0;
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i12 = HEAP32[i8 + 44 >> 2] | 0;
 HEAP32[i11 + 308 >> 2] = i12;
 HEAP32[i11 + 304 >> 2] = i8;
 if (!i12) {
  STACKTOP = i13;
  return;
 }
 STACKTOP = i13;
 return;
}

function __Z33InitializeBuiltinShaderParamNamesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 if (HEAP32[gb + 1157720 >> 2] | 0) {
  STACKTOP = i13;
  return;
 }
 i2 = __Znwj(160) | 0;
 i3 = i2 + 12 | 0;
 i4 = i2 + 16 | 0;
 i5 = i2 + 4 | 0;
 _memset(i2 | 0, 0, 160) | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i10 = i1;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i5;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i11 = i1;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i2 + 24 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i10 = i1;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i2 + 44 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i11 = i1;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i2 + 64 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i10 = i1;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i2 + 84 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = 0;
 HEAP32[i2 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i11 = i1;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i2 + 104 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i2 + 120 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i10 = i1;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i2 + 124 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i2 + 140 >> 2] = 0;
 HEAP32[i2 + 152 >> 2] = 0;
 HEAP32[i2 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i11 = i1;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i2 + 144 | 0;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP32[gb + 1157720 >> 2] = i2;
 HEAP32[i3 >> 2] = 6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483646) >>> 0 < 6) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = 6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 48, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = 6;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 HEAP32[i1 >> 2] = HEAP32[gb + 4e4 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 4e4 + 4 >> 2];
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = HEAP32[gb + 4e4 + 8 >> 2];
 HEAP32[i1 + 20 >> 2] = 2;
 HEAP32[i1 + 24 >> 2] = HEAP32[gb + 4e4 + 12 >> 2];
 HEAP32[i1 + 28 >> 2] = 3;
 HEAP32[i1 + 32 >> 2] = HEAP32[gb + 4e4 + 16 >> 2];
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 40 >> 2] = HEAP32[gb + 4e4 + 20 >> 2];
 HEAP32[i1 + 44 >> 2] = 5;
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i10 = i3 + 80 | 0;
 i8 = i3 + 92 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) + 2 | 0;
 i9 = i3 + 96 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i6 = i3 + 84 | 0;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 3, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = i10;
  break;
 } else {
  i6 = i3 + 84 | 0;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i1 = i2;
  i7 = i10;
  break;
 } else {
  i6 = i3 + 84 | 0;
  i7 = i10;
 } while (0);
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i1 & 2147483647;
 do if (i4 >>> 0 > i5 >>> 0) {
  i2 = i1 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 3, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i4;
 i1 = gb + 176 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) + (i3 << 3) | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i1 & 2147483647;
 do if (i4 >>> 0 > i5 >>> 0) {
  i2 = i1 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 3, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i4;
 i11 = gb + 176 + 8 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) + (i3 << 3) | 0;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i12, i12 + (HEAP32[i3 + 12 >> 2] << 3) | 0);
 __ZN12_GLOBAL__N_115ParamNameLookup15AddBuiltinNamesEPPKcjb(i3 + 40 | 0, gb + 40548 | 0, 110, 1);
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i12 = i3 + 40 | 0;
 i11 = i3 + 52 | 0;
 i2 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
 i10 = i3 + 56 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i10 >> 2] = i2;
  i3 = i3 + 44 | 0;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 3, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
  i9 = i12;
  break;
 } else {
  i3 = i3 + 44 | 0;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i12 >> 2] = i9;
  i9 = i12;
  break;
 } else {
  i9 = i12;
  i3 = i3 + 44 | 0;
 } while (0);
 i1 = 0;
 do {
  i5 = gb + 40024 + (i1 << 3) | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i8 = i2 & 2147483647;
  do if (i7 >>> 0 > i8 >>> 0) {
   i4 = i2 << 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   if (i8 >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i10 >> 2] = i4;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i4 << 3, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i9 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i11 >> 2] = i7;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i12 >> 2] | 0) + (i6 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 __ZN12_GLOBAL__N_115ParamNameLookup9AddArraysEPKNS_22BuiltinArrayParamIndexEj((HEAP32[gb + 1157720 >> 2] | 0) + 40 | 0, gb + 40152 | 0, 7);
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i12 = HEAP32[i3 + 40 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i12, i12 + (HEAP32[i3 + 52 >> 2] << 3) | 0);
 __ZN12_GLOBAL__N_115ParamNameLookup15AddBuiltinNamesEPPKcjb(i3 + 80 | 0, gb + 40236 | 0, 19, 1);
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i12 = i3 + 80 | 0;
 i11 = i3 + 92 | 0;
 i2 = (HEAP32[i11 >> 2] | 0) + 17 | 0;
 i10 = i3 + 96 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i10 >> 2] = i2;
  i3 = i3 + 84 | 0;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 3, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
  i9 = i12;
  break;
 } else {
  i3 = i3 + 84 | 0;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i12 >> 2] = i9;
  i9 = i12;
  break;
 } else {
  i9 = i12;
  i3 = i3 + 84 | 0;
 } while (0);
 i1 = 0;
 do {
  i5 = gb + 40312 + (i1 << 3) | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i8 = i2 & 2147483647;
  do if (i7 >>> 0 > i8 >>> 0) {
   i4 = i2 << 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   if (i8 >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i10 >> 2] = i4;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i4 << 3, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i9 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i11 >> 2] = i7;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i12 >> 2] | 0) + (i6 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 17);
 __ZN12_GLOBAL__N_115ParamNameLookup9AddArraysEPKNS_22BuiltinArrayParamIndexEj((HEAP32[gb + 1157720 >> 2] | 0) + 80 | 0, gb + 40448 | 0, 1);
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 i4 = HEAP32[i3 + 80 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i4, i4 + (HEAP32[i3 + 92 >> 2] << 3) | 0);
 i4 = i3 + 120 | 0;
 i5 = i3 + 132 | 0;
 HEAP32[i5 >> 2] = 22;
 i1 = i3 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483646) >>> 0 < 22) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = 22;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, 176, 4, i3 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(176, 4, i3 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = 22;
  HEAP32[i4 >> 2] = i2;
  break;
 } else i2 = HEAP32[i4 >> 2] | 0; while (0);
 i1 = 0;
 do {
  HEAP32[i2 + (i1 << 3) >> 2] = HEAP32[gb + 40460 + (i1 << 2) >> 2];
  HEAP32[i2 + (i1 << 3) + 4 >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 22);
 i12 = HEAP32[gb + 1157720 >> 2] | 0;
 i11 = HEAP32[i12 + 120 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i11, i11 + (HEAP32[i12 + 132 >> 2] << 3) | 0);
 STACKTOP = i13;
 return;
}

function __ZN7dtCrowd12setAgentPathERK13dtCrowdHandlePKfS4_PKyib(i11, i1, i27, i31, i26, i25, i29) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i31 = i31 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i28 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34 + 8 | 0;
 i10 = i34;
 i33 = HEAP32[i1 >> 2] | 0;
 i32 = HEAP32[i11 + 16 >> 2] | 0;
 i28 = i32 + (i33 * 608 | 0) | 0;
 i9 = (HEAP32[i11 + 20 >> 2] | 0) + (i33 * 56 | 0) + 40 | 0;
 i6 = i9;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i5 | 0) == 0 & (i6 | 0) == 0) {
  i1 = i32 + (i33 * 608 | 0) + 32 | 0;
  i24 = HEAP32[i1 >> 2] | 0;
  i3 = i32 + (i33 * 608 | 0) + 476 | 0;
  HEAP32[i3 >> 2] = 0;
  if (!i24) {
   i24 = i1;
   i20 = 0;
   i21 = 0;
   i23 = i28;
   i22 = i3;
  } else {
   i2 = i28;
   i7 = 20;
  }
 } else {
  i7 = i11 + 380 | 0;
  i4 = i11 + 384 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  if (i8 | 0) {
   i3 = i4;
   i2 = i8;
   L5 : while (1) {
    i1 = i2;
    while (1) {
     i24 = i1 + 16 | 0;
     i23 = HEAP32[i24 + 4 >> 2] | 0;
     if (!(i23 >>> 0 < i6 >>> 0 | ((i23 | 0) == (i6 | 0) ? (HEAP32[i24 >> 2] | 0) >>> 0 < i5 >>> 0 : 0))) break;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) break L5;
    }
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = i1;
     break;
    } else i3 = i1;
   }
   if ((i3 | 0) != (i4 | 0)) {
    i24 = i3 + 16 | 0;
    i23 = HEAP32[i24 + 4 >> 2] | 0;
    if (!(i6 >>> 0 < i23 >>> 0 | ((i6 | 0) == (i23 | 0) ? i5 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0 : 0))) {
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      }
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
     i24 = i11 + 388 | 0;
     HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + -1;
     __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i3);
     __ZdlPv(i3);
    }
   }
  }
  i2 = i9;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i11 + 464 >> 2] | 0, i32 + (i33 * 608 | 0) + 480 | 0, i11 + 432 | 0, (HEAP32[i11 + 24 >> 2] | 0) + (i33 * 132 | 0) | 0, i10, i30) | 0;
  i2 = i10;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i32 + (i33 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  if ((i1 | 0) == 0 & (i2 | 0) == 0) {
   i24 = i3;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
  } else {
   i23 = i3;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 4 >> 2] = i2;
   HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
   i23 = i30 + 4 | 0;
   HEAP32[i32 + (i33 * 608 | 0) + 4 >> 2] = HEAP32[i23 >> 2];
   i24 = i30 + 8 | 0;
   HEAP32[i32 + (i33 * 608 | 0) + 8 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 12 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 16 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 20 >> 2] = HEAP32[i24 >> 2];
  }
  i1 = i32 + (i33 * 608 | 0) + 32 | 0;
  HEAP32[i1 >> 2] = 1;
  HEAP32[i32 + (i33 * 608 | 0) + 48 >> 2] = i4;
  HEAP8[i32 + (i33 * 608 | 0) + 44 >> 0] = 0;
  HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 0;
  HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
  i3 = i32 + (i33 * 608 | 0) + 476 | 0;
  HEAP32[i3 >> 2] = 0;
  i2 = i28;
  i7 = 20;
 }
 if ((i7 | 0) == 20) {
  i21 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
  i24 = i1;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  i23 = i2;
  i22 = i3;
 }
 i14 = i32 + (i33 * 608 | 0) + 480 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i16 = HEAP32[i32 + (i33 * 608 | 0) + 484 >> 2] | 0;
 i17 = HEAP32[i32 + (i33 * 608 | 0) + 488 >> 2] | 0;
 i18 = (i20 | 0) == 0 & (i21 | 0) == 0;
 if (!i25) {
  i1 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i32 + (i33 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  if (i18) {
   i31 = i1;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 0;
  } else {
   i31 = i1;
   HEAP32[i31 >> 2] = i20;
   HEAP32[i31 + 4 >> 2] = i21;
   HEAP32[i28 >> 2] = i15;
   HEAP32[i32 + (i33 * 608 | 0) + 4 >> 2] = i16;
   HEAP32[i32 + (i33 * 608 | 0) + 8 >> 2] = i17;
   HEAP32[i32 + (i33 * 608 | 0) + 12 >> 2] = i15;
   HEAP32[i32 + (i33 * 608 | 0) + 16 >> 2] = i16;
   HEAP32[i32 + (i33 * 608 | 0) + 20 >> 2] = i17;
  }
  HEAP32[i24 >> 2] = 1;
  HEAP32[i32 + (i33 * 608 | 0) + 48 >> 2] = i2;
  HEAP8[i32 + (i33 * 608 | 0) + 44 >> 0] = 0;
  HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 0;
  HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
  STACKTOP = i34;
  return;
 }
 L39 : do if ((i25 | 0) > 0 & (i18 ^ 1)) {
  i1 = 0;
  do {
   i19 = i26 + (i1 << 3) | 0;
   if ((HEAP32[i19 >> 2] | 0) == (i20 | 0) ? (HEAP32[i19 + 4 >> 2] | 0) == (i21 | 0) : 0) break L39;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i25 | 0));
 } else i1 = 0; while (0);
 i2 = HEAP32[i11 + 24 >> 2] | 0;
 i13 = i2 + (i33 * 132 | 0) | 0;
 i19 = i11 + 464 | 0;
 i4 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
 i5 = (i1 | 0) < (i25 | 0);
 if (i5) {
  i3 = i2 + (i33 * 132 | 0) + 128 | 0;
  i2 = i1;
  do {
   i12 = i26 + (i2 << 3) | 0;
   i12 = __ZNK9dtNavMesh12getPolyFlagsEy(i4, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP32[i3 >> 2] & i12)) {
    i7 = 33;
    break;
   }
  } while ((i2 | 0) < (i25 | 0));
  if ((i7 | 0) == 33) {
   i1 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i32 + (i33 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
   if (i18) {
    i31 = i1;
    HEAP32[i31 >> 2] = 0;
    HEAP32[i31 + 4 >> 2] = 0;
   } else {
    i31 = i1;
    HEAP32[i31 >> 2] = i20;
    HEAP32[i31 + 4 >> 2] = i21;
    HEAP32[i28 >> 2] = i15;
    HEAP32[i32 + (i33 * 608 | 0) + 4 >> 2] = i16;
    HEAP32[i32 + (i33 * 608 | 0) + 8 >> 2] = i17;
    HEAP32[i32 + (i33 * 608 | 0) + 12 >> 2] = i15;
    HEAP32[i32 + (i33 * 608 | 0) + 16 >> 2] = i16;
    HEAP32[i32 + (i33 * 608 | 0) + 20 >> 2] = i17;
   }
   HEAP32[i24 >> 2] = 1;
   HEAP32[i32 + (i33 * 608 | 0) + 48 >> 2] = i2;
   HEAP8[i32 + (i33 * 608 | 0) + 44 >> 0] = 0;
   HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 0;
   HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
   STACKTOP = i34;
   return;
  }
  if (i5) {
   i8 = i25 - i1 | 0;
   i6 = i26 + (i1 << 3) | 0;
   i7 = HEAP32[i19 >> 2] | 0;
   i2 = i32 + (i33 * 608 | 0) + 36 | 0;
   if ((HEAP32[i2 >> 2] | 0) < (i8 | 0)) {
    i3 = HEAP32[i32 + (i33 * 608 | 0) + 40 >> 2] | 0;
    i1 = i8 + -1 | 0;
    i5 = i3 + i1 | 0;
    i3 = i5 - ((i5 | 0) % (i3 | 0) | 0) | 0;
    i5 = i32 + (i33 * 608 | 0) + 28 | 0;
    i4 = __Z9dtReallocPvi(HEAP32[i5 >> 2] | 0, i3 << 3) | 0;
    if (!i4) {
     i3 = i5;
     i2 = i5;
    } else {
     HEAP32[i5 >> 2] = i4;
     HEAP32[i2 >> 2] = i3;
     i3 = i5;
     i2 = i5;
    }
   } else {
    i2 = i32 + (i33 * 608 | 0) + 28 | 0;
    i3 = i2;
    i1 = i8 + -1 | 0;
   }
   HEAP32[i32 + (i33 * 608 | 0) + 12 >> 2] = HEAP32[i31 >> 2];
   i27 = i31 + 4 | 0;
   i26 = i32 + (i33 * 608 | 0) + 16 | 0;
   HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
   i28 = i31 + 8 | 0;
   HEAP32[i32 + (i33 * 608 | 0) + 20 >> 2] = HEAP32[i28 >> 2];
   _memcpy(HEAP32[i2 >> 2] | 0, i6 | 0, i8 << 3 | 0) | 0;
   HEAP32[i24 >> 2] = i8;
   i25 = (i8 | 0) != 0 & 1;
   HEAP8[i32 + (i33 * 608 | 0) + 44 >> 0] = i29 ? i25 | 2 : i25;
   HEAP32[i30 >> 2] = HEAP32[i27 >> 2];
   i29 = (HEAP32[i3 >> 2] | 0) + (i1 << 3) | 0;
   __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i7, HEAP32[i29 >> 2] | 0, HEAP32[i29 + 4 >> 2] | 0, i31, i30) | 0;
   HEAP32[i26 >> 2] = HEAP32[i30 >> 2];
   __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i23, i32 + (i33 * 608 | 0) + 424 | 0, i32 + (i33 * 608 | 0) + 472 | 0, i32 + (i33 * 608 | 0) + 392 | 0, i22, 4, HEAP32[i19 >> 2] | 0) | 0;
   HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 1;
   HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
   HEAP32[i32 + (i33 * 608 | 0) + 564 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 568 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 572 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 576 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 580 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i32 + (i33 * 608 | 0) + 584 >> 2] = HEAP32[i28 >> 2];
   STACKTOP = i34;
   return;
  }
 }
 i9 = HEAP32[i19 >> 2] | 0;
 i1 = i32 + (i33 * 608 | 0) + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) < (i25 | 0)) {
  i2 = HEAP32[i32 + (i33 * 608 | 0) + 40 >> 2] | 0;
  i5 = i25 + -1 | 0;
  i4 = i2 + i5 | 0;
  i2 = i4 - ((i4 | 0) % (i2 | 0) | 0) | 0;
  i4 = i32 + (i33 * 608 | 0) + 28 | 0;
  i3 = __Z9dtReallocPvi(HEAP32[i4 >> 2] | 0, i2 << 3) | 0;
  if (!i3) {
   i2 = i4;
   i1 = i4;
  } else {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i1 >> 2] = i2;
   i2 = i4;
   i1 = i4;
  }
 } else {
  i1 = i32 + (i33 * 608 | 0) + 28 | 0;
  i2 = i1;
  i5 = i25 + -1 | 0;
 }
 i10 = i32 + (i33 * 608 | 0) + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[i31 >> 2];
 i7 = i31 + 4 | 0;
 i11 = i32 + (i33 * 608 | 0) + 16 | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 i8 = i31 + 8 | 0;
 i12 = i32 + (i33 * 608 | 0) + 20 | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 _memcpy(HEAP32[i1 >> 2] | 0, i26 | 0, i25 << 3 | 0) | 0;
 HEAP32[i24 >> 2] = i25;
 i6 = i32 + (i33 * 608 | 0) + 44 | 0;
 HEAP8[i6 >> 0] = i29 ? 3 : 1;
 HEAP32[i30 >> 2] = HEAP32[i7 >> 2];
 i3 = (HEAP32[i2 >> 2] | 0) + (i5 << 3) | 0;
 __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i9, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i31, i30) | 0;
 HEAP32[i11 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
 i3 = i32 + (i33 * 608 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i27 + 4 >> 2];
 i4 = i32 + (i33 * 608 | 0) + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i27 + 8 >> 2];
 __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i23, i14, HEAP32[i19 >> 2] | 0, i13);
 if (!(HEAP32[i24 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 if ((i1 | 0) == (i20 | 0) & (i2 | 0) == (i21 | 0)) {
  __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i23, i32 + (i33 * 608 | 0) + 424 | 0, i32 + (i33 * 608 | 0) + 472 | 0, i32 + (i33 * 608 | 0) + 392 | 0, i22, 4, HEAP32[i19 >> 2] | 0) | 0;
  HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
  HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 1;
  HEAP32[i32 + (i33 * 608 | 0) + 564 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i32 + (i33 * 608 | 0) + 568 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i32 + (i33 * 608 | 0) + 572 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i32 + (i33 * 608 | 0) + 576 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i32 + (i33 * 608 | 0) + 580 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i32 + (i33 * 608 | 0) + 584 >> 2] = HEAP32[i8 >> 2];
  STACKTOP = i34;
  return;
 }
 i1 = HEAP32[i32 + (i33 * 608 | 0) + 28 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i32 + (i33 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
 if (i18) {
  i31 = i1;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
 } else {
  i31 = i1;
  HEAP32[i31 >> 2] = i20;
  HEAP32[i31 + 4 >> 2] = i21;
  HEAP32[i28 >> 2] = i15;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i4 >> 2] = i17;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = i16;
  HEAP32[i12 >> 2] = i17;
 }
 HEAP32[i24 >> 2] = 1;
 HEAP32[i32 + (i33 * 608 | 0) + 48 >> 2] = i2;
 HEAP8[i6 >> 0] = 0;
 HEAP8[i32 + (i33 * 608 | 0) + 601 >> 0] = 0;
 HEAPF32[i32 + (i33 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
 STACKTOP = i34;
 return;
}

function __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 120 | 0;
 i11 = i12 + 12 | 0;
 i9 = i12;
 i7 = i8 + 4 | 0;
 i4 = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 108 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 434536 | 0, 6);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11, i9);
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i8 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i8, i11); else {
  __ZN9InputAxisC2ERKS_(i1, i11);
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 108;
 }
 HEAP32[i11 >> 2] = gb + 59740 + 8;
 i1 = i11 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i11 + 52 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i10);
 }
 i1 = i11 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i11 + 36 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i10);
 }
 i1 = i11 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i11 + 16 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i5 = i4 + 1 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 434543 | 0, 6);
 i2 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i10) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 434550 | 0, 17);
 i1 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i3 + (i4 * 108 | 0) + 56 >> 2] = i2;
 HEAP32[i3 + (i4 * 108 | 0) + 60 >> 2] = 0;
 HEAP32[i3 + (i4 * 108 | 0) + 64 >> 2] = i1;
 HEAP32[i3 + (i4 * 108 | 0) + 68 >> 2] = 0;
 HEAP32[i3 + (i4 * 108 | 0) + 76 >> 2] = 0;
 HEAPF32[i3 + (i4 * 108 | 0) + 100 >> 2] = Math_fround(1.0e3);
 HEAPF32[i3 + (i4 * 108 | 0) + 92 >> 2] = Math_fround(1.0e3);
 HEAP8[i3 + (i4 * 108 | 0) + 104 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 434536 | 0, 6);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11, i9);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i8, i11); else {
  __ZN9InputAxisC2ERKS_(i1, i11);
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 108;
 }
 HEAP32[i11 >> 2] = gb + 59740 + 8;
 i1 = i11 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i11 + 52 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
 }
 i1 = i11 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i11 + 36 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
 }
 i1 = i11 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i11 + 16 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i4 = i4 + 2 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 619770 | 0, 5);
 i2 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255) | 0)) i2 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i10) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i2 = 0; else i2 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1084278 | 0, 5);
 i1 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i3 + (i5 * 108 | 0) + 56 >> 2] = i2;
 HEAP32[i3 + (i5 * 108 | 0) + 60 >> 2] = 0;
 HEAP32[i3 + (i5 * 108 | 0) + 64 >> 2] = i1;
 HEAP32[i3 + (i5 * 108 | 0) + 68 >> 2] = 0;
 HEAP32[i3 + (i5 * 108 | 0) + 76 >> 2] = 0;
 HEAPF32[i3 + (i5 * 108 | 0) + 100 >> 2] = Math_fround(1.0e3);
 HEAPF32[i3 + (i5 * 108 | 0) + 92 >> 2] = Math_fround(1.0e3);
 HEAP8[i3 + (i5 * 108 | 0) + 104 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 434568 | 0, 6);
 __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11, i9);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i8, i11); else {
  __ZN9InputAxisC2ERKS_(i1, i11);
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 108;
 }
 HEAP32[i11 >> 2] = gb + 59740 + 8;
 i1 = i11 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i11 + 52 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i10);
 }
 i1 = i11 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i11 + 36 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i10);
 }
 i1 = i11 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i11 + 16 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 434575 | 0, 6);
 i9 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i9 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i10) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 434582 | 0, 17);
 i9 = HEAP8[i11 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i9 & 255) | 0)) {
  i8 = 0;
  i9 = i3 + (i4 * 108 | 0) + 56 | 0;
  HEAP32[i9 >> 2] = i1;
  i9 = i3 + (i4 * 108 | 0) + 60 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 64 | 0;
  HEAP32[i9 >> 2] = i8;
  i9 = i3 + (i4 * 108 | 0) + 68 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 76 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 100 | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0e3);
  i9 = i3 + (i4 * 108 | 0) + 92 | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0e3);
  i9 = i3 + (i4 * 108 | 0) + 104 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return;
 }
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i11) | 0;
 if ((i2 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
  i8 = 0;
  i9 = i3 + (i4 * 108 | 0) + 56 | 0;
  HEAP32[i9 >> 2] = i1;
  i9 = i3 + (i4 * 108 | 0) + 60 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 64 | 0;
  HEAP32[i9 >> 2] = i8;
  i9 = i3 + (i4 * 108 | 0) + 68 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 76 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i3 + (i4 * 108 | 0) + 100 | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0e3);
  i9 = i3 + (i4 * 108 | 0) + 92 | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0e3);
  i9 = i3 + (i4 * 108 | 0) + 104 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return;
 }
 i8 = HEAP32[i2 + 28 >> 2] | 0;
 i9 = i3 + (i4 * 108 | 0) + 56 | 0;
 HEAP32[i9 >> 2] = i1;
 i9 = i3 + (i4 * 108 | 0) + 60 | 0;
 HEAP32[i9 >> 2] = 0;
 i9 = i3 + (i4 * 108 | 0) + 64 | 0;
 HEAP32[i9 >> 2] = i8;
 i9 = i3 + (i4 * 108 | 0) + 68 | 0;
 HEAP32[i9 >> 2] = 0;
 i9 = i3 + (i4 * 108 | 0) + 76 | 0;
 HEAP32[i9 >> 2] = 0;
 i9 = i3 + (i4 * 108 | 0) + 100 | 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0e3);
 i9 = i3 + (i4 * 108 | 0) + 92 | 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0e3);
 i9 = i3 + (i4 * 108 | 0) + 104 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i12;
 return;
}

function __ZN10TagManager8TransferI14SafeBinaryReadEEvRT_(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 8 | 0;
 i8 = i17;
 i12 = i17 + 1052 | 0;
 i15 = i17 + 1040 | 0;
 i11 = i17 + 16 | 0;
 i7 = i17 + 1056 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i13, 2);
 HEAP32[i15 >> 2] = 0;
 i16 = i15 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i14);
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 470740 | 0, i6, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_17TransferMetaFlags(i13, i15, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i15 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i10 = i13 + 128 | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  if ((HEAP32[i16 >> 2] | 0) != (i1 | 0)) {
   i2 = 2e4;
   i3 = 0;
   while (1) {
    __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i14, i2, i1 + (i3 << 5) | 0);
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    if (i3 >>> 0 >= (HEAP32[i16 >> 2] | 0) - i1 >> 5 >>> 0) break; else i2 = i2 + 1 | 0;
   }
  }
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i13, 1) | 0) {
  i1 = i11 + 1024 | 0;
  i3 = gb + 63648 | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 20 >> 2] = 0;
  i4 = i11 + 24 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 4 >> 0] = 0;
  HEAP32[i11 + 32 >> 2] = 0;
  HEAP32[i11 + 52 >> 2] = 0;
  i4 = i11 + 56 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 36 >> 0] = 0;
  HEAP32[i11 + 64 >> 2] = 0;
  HEAP32[i11 + 84 >> 2] = 0;
  i4 = i11 + 88 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 68 >> 0] = 0;
  HEAP32[i11 + 96 >> 2] = 0;
  HEAP32[i11 + 116 >> 2] = 0;
  i4 = i11 + 120 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 100 >> 0] = 0;
  HEAP32[i11 + 128 >> 2] = 0;
  HEAP32[i11 + 148 >> 2] = 0;
  i4 = i11 + 152 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 132 >> 0] = 0;
  HEAP32[i11 + 160 >> 2] = 0;
  HEAP32[i11 + 180 >> 2] = 0;
  i4 = i11 + 184 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 164 >> 0] = 0;
  HEAP32[i11 + 192 >> 2] = 0;
  HEAP32[i11 + 212 >> 2] = 0;
  i4 = i11 + 216 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 196 >> 0] = 0;
  HEAP32[i11 + 224 >> 2] = 0;
  HEAP32[i11 + 244 >> 2] = 0;
  i4 = i11 + 248 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 228 >> 0] = 0;
  HEAP32[i11 + 256 >> 2] = 0;
  HEAP32[i11 + 276 >> 2] = 0;
  i4 = i11 + 280 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 260 >> 0] = 0;
  HEAP32[i11 + 288 >> 2] = 0;
  HEAP32[i11 + 308 >> 2] = 0;
  i4 = i11 + 312 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 292 >> 0] = 0;
  HEAP32[i11 + 320 >> 2] = 0;
  HEAP32[i11 + 340 >> 2] = 0;
  i4 = i11 + 344 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 324 >> 0] = 0;
  HEAP32[i11 + 352 >> 2] = 0;
  HEAP32[i11 + 372 >> 2] = 0;
  i4 = i11 + 376 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 356 >> 0] = 0;
  HEAP32[i11 + 384 >> 2] = 0;
  HEAP32[i11 + 404 >> 2] = 0;
  i4 = i11 + 408 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 388 >> 0] = 0;
  HEAP32[i11 + 416 >> 2] = 0;
  HEAP32[i11 + 436 >> 2] = 0;
  i4 = i11 + 440 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 420 >> 0] = 0;
  HEAP32[i11 + 448 >> 2] = 0;
  HEAP32[i11 + 468 >> 2] = 0;
  i4 = i11 + 472 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 452 >> 0] = 0;
  HEAP32[i11 + 480 >> 2] = 0;
  HEAP32[i11 + 500 >> 2] = 0;
  i4 = i11 + 504 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 484 >> 0] = 0;
  HEAP32[i11 + 512 >> 2] = 0;
  HEAP32[i11 + 532 >> 2] = 0;
  i4 = i11 + 536 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 516 >> 0] = 0;
  HEAP32[i11 + 544 >> 2] = 0;
  HEAP32[i11 + 564 >> 2] = 0;
  i4 = i11 + 568 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 548 >> 0] = 0;
  HEAP32[i11 + 576 >> 2] = 0;
  HEAP32[i11 + 596 >> 2] = 0;
  i4 = i11 + 600 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 580 >> 0] = 0;
  HEAP32[i11 + 608 >> 2] = 0;
  HEAP32[i11 + 628 >> 2] = 0;
  i4 = i11 + 632 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 612 >> 0] = 0;
  HEAP32[i11 + 640 >> 2] = 0;
  HEAP32[i11 + 660 >> 2] = 0;
  i4 = i11 + 664 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 644 >> 0] = 0;
  HEAP32[i11 + 672 >> 2] = 0;
  HEAP32[i11 + 692 >> 2] = 0;
  i4 = i11 + 696 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 676 >> 0] = 0;
  HEAP32[i11 + 704 >> 2] = 0;
  HEAP32[i11 + 724 >> 2] = 0;
  i4 = i11 + 728 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 708 >> 0] = 0;
  HEAP32[i11 + 736 >> 2] = 0;
  HEAP32[i11 + 756 >> 2] = 0;
  i4 = i11 + 760 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 740 >> 0] = 0;
  HEAP32[i11 + 768 >> 2] = 0;
  HEAP32[i11 + 788 >> 2] = 0;
  i4 = i11 + 792 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 772 >> 0] = 0;
  HEAP32[i11 + 800 >> 2] = 0;
  HEAP32[i11 + 820 >> 2] = 0;
  i4 = i11 + 824 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 804 >> 0] = 0;
  HEAP32[i11 + 832 >> 2] = 0;
  HEAP32[i11 + 852 >> 2] = 0;
  i4 = i11 + 856 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 836 >> 0] = 0;
  HEAP32[i11 + 864 >> 2] = 0;
  HEAP32[i11 + 884 >> 2] = 0;
  i4 = i11 + 888 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 868 >> 0] = 0;
  HEAP32[i11 + 896 >> 2] = 0;
  HEAP32[i11 + 916 >> 2] = 0;
  i4 = i11 + 920 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 900 >> 0] = 0;
  HEAP32[i11 + 928 >> 2] = 0;
  HEAP32[i11 + 948 >> 2] = 0;
  i4 = i11 + 952 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 932 >> 0] = 0;
  HEAP32[i11 + 960 >> 2] = 0;
  HEAP32[i11 + 980 >> 2] = 0;
  i4 = i11 + 984 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 964 >> 0] = 0;
  HEAP32[i11 + 992 >> 2] = 0;
  HEAP32[i11 + 1012 >> 2] = 0;
  i4 = i11 + 1016 | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i11 + 996 >> 0] = 0;
  i4 = HEAP32[gb + 37260 >> 2] | 0;
  i3 = 0;
  do {
   i5 = (i3 | 0) > 7;
   if (i5) {
    HEAP32[i8 >> 2] = i3;
    _snprintf(i7, 64, gb + 370852 | 0, i8) | 0;
   } else {
    HEAP32[i9 >> 2] = i3;
    _snprintf(i7, 64, gb + 370866 | 0, i9) | 0;
   }
   i6 = i11 + (i3 << 5) | 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i6, i14 + 44 + (i3 << 5) | 0);
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, i7, i4, i12, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i13, i6, 1); else {
     i2 = HEAP32[i12 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i6 | 0, i13 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i13);
   }
   if (i5 & (HEAP8[i10 >> 0] | 0) != 0) __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i14, i3, i6);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != 32);
  do {
   i2 = i1;
   i1 = i1 + -32 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) if (HEAP32[i2 + -28 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
  } while ((i1 | 0) != (i11 | 0));
  i1 = HEAP32[gb + 37316 >> 2] | 0;
 } else {
  HEAP32[i11 >> 2] = 0;
  i5 = i11 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = i11 + 8 | 0;
  i1 = 0;
  do {
   i4 = i14 + 44 + (i1 << 5) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i11, i4); else {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    i7 = i14 + 44 + (i1 << 5) + 24 | 0;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i9 = i2 + 24 | 0;
    HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP8[i2 + 4 >> 0] = 0;
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i4);
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 32);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 370883 | 0, i6, i12, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_17TransferMetaFlags(i13, i11, 0); else {
    i1 = HEAP32[i12 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i13 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i13);
  }
  if (HEAP8[i10 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = (HEAP32[i5 >> 2] | 0) - i1 >> 5;
   i2 = (i2 | 0) > 32 ? 32 : i2;
   if ((i2 | 0) > 8) {
    __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i14, 8, i1 + 256 | 0);
    if ((i2 | 0) != 9) {
     i1 = 9;
     do {
      __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i14, i1, (HEAP32[i11 >> 2] | 0) + (i1 << 5) | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
    }
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i3 = i2 + -32 | 0;
     HEAP32[i5 >> 2] = i3;
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
      __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
      i2 = HEAP32[i5 >> 2] | 0;
     }
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = i6;
 }
 i2 = i14 + 1068 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 370890 | 0, i1, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i13, i2, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 __ZN10TagManager23AddDefaultLayerIfNeededEv(i14);
 i4 = i14 + 1080 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i14 = (HEAP32[i14 + 1072 >> 2] | 0) - i3 | 0;
 i2 = (i14 | 0) / 40 | 0;
 L83 : do if (i14 | 0) {
  i1 = 0;
  while (1) {
   if (!(HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i2 | 0)) break L83;
  }
  HEAP32[i4 >> 2] = i1;
 } while (0);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i16 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i16 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i15 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i17;
 return;
}

function __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 L1 : while (1) {
  i14 = i2;
  i15 = i2 + -8 | 0;
  i18 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i3 = i14 - i13 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 7;
      break L1;
     }
    case 4:
     {
      i16 = 15;
      break L1;
     }
    case 5:
     {
      i16 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 69;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 56) {
     i16 = 22;
     break L1;
    }
    i10 = (i4 | 0) / 2 | 0;
    i12 = i1 + (i10 << 3) | 0;
    do if ((i3 | 0) > 7992) {
     i9 = (i4 | 0) / 4 | 0;
     i11 = i1 + (i9 << 3) | 0;
     i7 = i12 + (i9 << 3) | 0;
     i3 = __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i1, i11, i12, i7, i17) | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     if ((i4 | 0) >= (i5 | 0)) {
      i4 = i12;
      break;
     }
     HEAP32[i7 >> 2] = i4;
     HEAP32[i15 >> 2] = i5;
     i8 = i7 + 4 | 0;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i18 >> 2] = i4;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     i6 = HEAP32[i12 >> 2] | 0;
     if ((i5 | 0) < (i6 | 0)) {
      HEAP32[i12 >> 2] = i5;
      HEAP32[i7 >> 2] = i6;
      i7 = i1 + (i10 << 3) + 4 | 0;
      i4 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i8 >> 2] = i4;
      i4 = i3 + 2 | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      if ((i5 | 0) < (i6 | 0)) {
       HEAP32[i11 >> 2] = i5;
       HEAP32[i12 >> 2] = i6;
       i6 = i1 + (i9 << 3) + 4 | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i7 >> 2] = i4;
       i4 = HEAP32[i11 >> 2] | 0;
       i5 = HEAP32[i1 >> 2] | 0;
       if ((i4 | 0) < (i5 | 0)) {
        HEAP32[i1 >> 2] = i4;
        HEAP32[i11 >> 2] = i5;
        i11 = i1 + 4 | 0;
        i4 = HEAP32[i11 >> 2] | 0;
        HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i6 >> 2] = i4;
        i3 = i3 + 4 | 0;
        i4 = i12;
       } else {
        i3 = i3 + 3 | 0;
        i4 = i12;
       }
      } else {
       i3 = i4;
       i4 = i12;
      }
     } else {
      i3 = i4;
      i4 = i12;
     }
    } else {
     i3 = HEAP32[i12 >> 2] | 0;
     i6 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     i5 = (i4 | 0) < (i3 | 0);
     if ((i3 | 0) >= (i6 | 0)) {
      if (!i5) {
       i3 = 0;
       i4 = i12;
       break;
      }
      HEAP32[i12 >> 2] = i4;
      HEAP32[i15 >> 2] = i3;
      i3 = i1 + (i10 << 3) + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i18 >> 2] = i4;
      i4 = HEAP32[i12 >> 2] | 0;
      i5 = HEAP32[i1 >> 2] | 0;
      if ((i4 | 0) >= (i5 | 0)) {
       i3 = 1;
       i4 = i12;
       break;
      }
      HEAP32[i1 >> 2] = i4;
      HEAP32[i12 >> 2] = i5;
      i11 = i1 + 4 | 0;
      i4 = HEAP32[i11 >> 2] | 0;
      HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i3 >> 2] = i4;
      i3 = 2;
      i4 = i12;
      break;
     }
     if (i5) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i15 >> 2] = i6;
      i4 = i1 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i18 >> 2] = i3;
      i3 = 1;
      i4 = i12;
      break;
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i12 >> 2] = i6;
     i11 = i1 + 4 | 0;
     i3 = i1 + (i10 << 3) + 4 | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i3 >> 2] = i4;
     i4 = HEAP32[i15 >> 2] | 0;
     if ((i4 | 0) < (i6 | 0)) {
      HEAP32[i12 >> 2] = i4;
      HEAP32[i15 >> 2] = i6;
      i4 = HEAP32[i3 >> 2] | 0;
      HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i18 >> 2] = i4;
      i3 = 2;
      i4 = i12;
     } else {
      i3 = 1;
      i4 = i12;
     }
    } while (0);
    i8 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i4 >> 2] | 0;
    if ((i8 | 0) < (i6 | 0)) {
     i4 = i15;
     break;
    } else i5 = i15;
    while (1) {
     i4 = i5 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i7 = HEAP32[i4 >> 2] | 0;
     if ((i7 | 0) < (i6 | 0)) {
      i16 = 52;
      break L5;
     } else i5 = i4;
    }
    i3 = i1 + 8 | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    if ((i8 | 0) >= (i5 | 0)) {
     if ((i3 | 0) == (i15 | 0)) {
      i16 = 69;
      break L1;
     }
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i8 | 0) < (i4 | 0)) break;
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i15 | 0)) {
       i16 = 69;
       break L1;
      }
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i15 >> 2] = i4;
     i12 = i3 + 4 | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i18 >> 2] = i13;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i15 | 0)) {
     i16 = 69;
     break L1;
    } else i4 = i15;
    while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i3 >> 2] | 0;
      i8 = i3 + 8 | 0;
      if ((i9 | 0) < (i7 | 0)) break; else i3 = i8;
     }
     while (1) {
      i5 = i4 + -8 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i9 | 0) < (i6 | 0)) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i6;
     HEAP32[i5 >> 2] = i7;
     i13 = i3 + 4 | 0;
     i4 = i4 + -4 | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     i4 = i5;
     i3 = i8;
    }
   }
   if ((i16 | 0) == 52) {
    i16 = 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i4 >> 2] = i8;
    i9 = i1 + 4 | 0;
    i11 = i5 + -4 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i11 >> 2] = i10;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L50 : do if (i5 >>> 0 < i4 >>> 0) {
    i6 = i12;
    while (1) {
     i11 = HEAP32[i6 >> 2] | 0;
     while (1) {
      i9 = HEAP32[i5 >> 2] | 0;
      i10 = i5 + 8 | 0;
      if ((i9 | 0) < (i11 | 0)) i5 = i10; else break;
     }
     while (1) {
      i7 = i4 + -8 | 0;
      i8 = HEAP32[i7 >> 2] | 0;
      if ((i8 | 0) < (i11 | 0)) break; else i4 = i7;
     }
     if (i5 >>> 0 > i7 >>> 0) {
      i7 = i5;
      break L50;
     }
     HEAP32[i5 >> 2] = i8;
     HEAP32[i7 >> 2] = i9;
     i11 = i5 + 4 | 0;
     i4 = i4 + -4 | 0;
     i12 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i12;
     i6 = (i6 | 0) == (i5 | 0) ? i7 : i6;
     i4 = i7;
     i5 = i10;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i12;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) < (i5 | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i10 = i7 + 4 | 0;
     i12 = i6 + 4 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i12 >> 2] = i11;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEbT0_SD_T_(i1, i7, i17) | 0;
    i4 = i7 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEbT0_SD_T_(i4, i2, i17) | 0) {
     i16 = 68;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i12 = i7;
   if ((i12 - i13 | 0) >= (i14 - i12 | 0)) {
    i16 = 67;
    break;
   }
   __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i1, i7, i17);
   i1 = i7 + 8 | 0;
  }
  if ((i16 | 0) == 67) {
   i16 = 0;
   __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i7 + 8 | 0, i2, i17);
   i2 = i7;
   continue;
  } else if ((i16 | 0) == 68) {
   i16 = 0;
   if (i3) {
    i16 = 69;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  i4 = i2 + -8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) >= (i3 | 0)) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i16 = i1 + 4 | 0;
  i17 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i18 >> 2] = i17;
  return;
 } else if ((i16 | 0) == 7) {
  i7 = i1 + 8 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = i2 + -8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = (i2 | 0) < (i4 | 0);
  if ((i4 | 0) >= (i6 | 0)) {
   if (!i3) return;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i4 = i1 + 12 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i18 >> 2] = i2;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   i17 = i1 + 4 | 0;
   i18 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i18;
   return;
  }
  if (i3) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i5 >> 2] = i6;
   i16 = i1 + 4 | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i18 >> 2] = i17;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i6;
  i17 = i1 + 4 | 0;
  i1 = i1 + 12 | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) >= (i6 | 0)) return;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i6;
  i17 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i18 >> 2] = i17;
  return;
 } else if ((i16 | 0) == 15) {
  __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i15, i17) | 0;
  return;
 } else if ((i16 | 0) == 16) {
  i8 = i1 + 8 | 0;
  i7 = i1 + 16 | 0;
  i5 = i1 + 24 | 0;
  __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i1, i8, i7, i5, i17) | 0;
  i2 = i2 + -8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) >= (i4 | 0)) return;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i3 = i1 + 28 | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i18 >> 2] = i6;
  i6 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i6 | 0) >= (i2 | 0)) return;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i5 >> 2] = i2;
  i4 = i1 + 20 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i3 >> 2] = i2;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i6 | 0) >= (i2 | 0)) return;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  i3 = i1 + 12 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i4 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i6 | 0) >= (i2 | 0)) return;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i17 = i1 + 4 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = i5;
  HEAP32[i3 >> 2] = i18;
  return;
 } else if ((i16 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i1, i2, i17);
  return;
 } else if ((i16 | 0) == 69) return;
}

function __ZN27ConvexVsMeshOverlapCallbackC2ERKN5physx2Gu10ConvexMeshERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_bRKNS1_3BoxE(i23, i18, i19, i21, i24, i25, i20, i22) {
 i23 = i23 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i21 = i21 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i28 + 256 | 0;
 i7 = i28 + 304 | 0;
 i9 = i28 + 272 | 0;
 i27 = i28 + 240 | 0;
 i26 = i28 + 224 | 0;
 i2 = i28 + 16 | 0;
 i6 = i28;
 i1 = i28 + 288 | 0;
 HEAP32[i23 + 4 >> 2] = 2;
 HEAP32[i23 >> 2] = gb + 90528 + 8;
 i13 = i23 + 16 | 0;
 i14 = i23 + 64 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 i14 = i23 + 20 | 0;
 HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i15 = i23 + 36 | 0;
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i16 = i23 + 40 | 0;
 HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i17 = i23 + 56 | 0;
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i3 = i23 + 60 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i23 + 160 | 0;
 HEAP32[i23 + 176 >> 2] = 0;
 HEAPF32[i23 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 144 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = i23 + 352 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i4 = i23 + 304 | 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i5 = i23 + 308 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = i23 + 324 | 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i8 = i23 + 328 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i9 = i23 + 344 | 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 i10 = i23 + 348 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAP8[i23 + 432 >> 0] = 0;
 i11 = i23 + 433 | 0;
 i12 = i20 & 1;
 HEAP8[i11 >> 0] = i12;
 if (!i20) {
  i35 = HEAP32[i21 + 4 >> 2] | 0;
  i34 = HEAP32[i21 + 8 >> 2] | 0;
  i33 = HEAP32[i21 + 12 >> 2] | 0;
  i32 = HEAP32[i21 + 16 >> 2] | 0;
  i31 = HEAP32[i21 + 20 >> 2] | 0;
  i30 = HEAP32[i21 + 24 >> 2] | 0;
  i29 = HEAP32[i21 + 28 >> 2] | 0;
  i20 = HEAP32[i21 + 32 >> 2] | 0;
  HEAP32[i23 + 384 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i23 + 388 >> 2] = i35;
  HEAP32[i23 + 392 >> 2] = i34;
  HEAPF32[i23 + 396 >> 2] = Math_fround(0.0);
  HEAP32[i23 + 400 >> 2] = i33;
  HEAP32[i23 + 404 >> 2] = i32;
  HEAP32[i23 + 408 >> 2] = i31;
  HEAPF32[i23 + 412 >> 2] = Math_fround(0.0);
  HEAP32[i23 + 416 >> 2] = i30;
  HEAP32[i23 + 420 >> 2] = i29;
  HEAP32[i23 + 424 >> 2] = i20;
  HEAPF32[i23 + 428 >> 2] = Math_fround(0.0);
 }
 i30 = HEAP32[i19 + 4 >> 2] | 0;
 i32 = HEAP32[i19 + 8 >> 2] | 0;
 HEAP32[i27 >> 2] = HEAP32[i19 >> 2];
 i33 = i27 + 4 | 0;
 HEAP32[i33 >> 2] = i30;
 i30 = i27 + 8 | 0;
 HEAP32[i30 >> 2] = i32;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 i32 = i19 + 12 | 0;
 i29 = HEAP32[i32 + 4 >> 2] | 0;
 i34 = HEAP32[i32 + 8 >> 2] | 0;
 i31 = HEAP32[i32 + 12 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i26 + 4 >> 2] = i29;
 HEAP32[i26 + 8 >> 2] = i34;
 HEAP32[i26 + 12 >> 2] = i31;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i2, i18 + 16 | 0, i6, i27, i26);
 _memcpy(i23 + 96 | 0, i2 | 0, 205) | 0;
 f48 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
 f41 = Math_fround(-Math_fround(HEAPF32[i24 + 4 >> 2]));
 f45 = Math_fround(-Math_fround(HEAPF32[i24 + 8 >> 2]));
 f39 = Math_fround(HEAPF32[i24 + 12 >> 2]);
 f47 = Math_fround(HEAPF32[i25 + 16 >> 2]);
 f47 = Math_fround(f47 - Math_fround(HEAPF32[i24 + 16 >> 2]));
 f46 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 f46 = Math_fround(f46 - Math_fround(HEAPF32[i24 + 20 >> 2]));
 f50 = Math_fround(HEAPF32[i25 + 24 >> 2]);
 f47 = Math_fround(f47 * Math_fround(2.0));
 f46 = Math_fround(f46 * Math_fround(2.0));
 f50 = Math_fround(Math_fround(f50 - Math_fround(HEAPF32[i24 + 24 >> 2])) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
 f37 = Math_fround(Math_fround(Math_fround(f47 * f48) + Math_fround(f46 * f41)) + Math_fround(f50 * f45));
 f40 = Math_fround(Math_fround(f37 * f48) + Math_fround(Math_fround(f38 * f47) + Math_fround(f39 * Math_fround(Math_fround(f50 * f41) - Math_fround(f46 * f45)))));
 f36 = Math_fround(Math_fround(f37 * f41) + Math_fround(Math_fround(f38 * f46) + Math_fround(f39 * Math_fround(Math_fround(f47 * f45) - Math_fround(f50 * f48)))));
 f37 = Math_fround(Math_fround(Math_fround(f38 * f50) + Math_fround(f39 * Math_fround(Math_fround(f46 * f48) - Math_fround(f47 * f41)))) + Math_fround(f37 * f45));
 f47 = Math_fround(HEAPF32[i25 >> 2]);
 f46 = Math_fround(f39 * f47);
 f50 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f50 * f48));
 f38 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f38 * f41));
 f44 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f46 = Math_fround(f46 - Math_fround(f44 * f45));
 f43 = Math_fround(Math_fround(Math_fround(f47 * f45) + Math_fround(Math_fround(f50 * f41) + Math_fround(f39 * f44))) - Math_fround(f38 * f48));
 f49 = Math_fround(Math_fround(Math_fround(f44 * f48) + Math_fround(Math_fround(f50 * f45) + Math_fround(f39 * f38))) - Math_fround(f47 * f41));
 f45 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f50) - Math_fround(f47 * f48)) - Math_fround(f44 * f41)) - Math_fround(f38 * f45));
 f38 = Math_fround(f46 + f46);
 f41 = Math_fround(f43 + f43);
 f44 = Math_fround(f49 + f49);
 f48 = Math_fround(f43 * f41);
 f47 = Math_fround(f49 * f44);
 f43 = Math_fround(f38 * f43);
 f50 = Math_fround(f38 * f49);
 f39 = Math_fround(f38 * f45);
 f49 = Math_fround(f49 * f41);
 f41 = Math_fround(f45 * f41);
 f44 = Math_fround(f45 * f44);
 f38 = Math_fround(Math_fround(1.0) - Math_fround(f46 * f38));
 f46 = Math_fround(f43 + f44);
 f45 = Math_fround(f50 - f41);
 f44 = Math_fround(f43 - f44);
 f43 = Math_fround(f38 - f47);
 f42 = Math_fround(f39 + f49);
 f41 = Math_fround(f50 + f41);
 f39 = Math_fround(f49 - f39);
 f38 = Math_fround(f38 - f48);
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f48) - f47);
 HEAPF32[i5 >> 2] = f46;
 HEAPF32[i23 + 312 >> 2] = f45;
 HEAPF32[i23 + 316 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 320 >> 2] = f44;
 HEAPF32[i7 >> 2] = f43;
 HEAPF32[i8 >> 2] = f42;
 HEAPF32[i23 + 332 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 336 >> 2] = f41;
 HEAPF32[i23 + 340 >> 2] = f39;
 HEAPF32[i9 >> 2] = f38;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 352 >> 2] = f40;
 HEAPF32[i23 + 356 >> 2] = f36;
 HEAPF32[i23 + 360 >> 2] = f37;
 HEAPF32[i23 + 364 >> 2] = Math_fround(0.0);
 f37 = Math_fround(HEAPF32[i18 + 68 >> 2]);
 f36 = Math_fround(HEAPF32[i18 + 72 >> 2]);
 f40 = Math_fround(HEAPF32[i18 + 76 >> 2]);
 f38 = Math_fround(HEAPF32[i27 >> 2]);
 f39 = Math_fround(HEAPF32[i33 >> 2]);
 f38 = Math_fround(f37 * f38);
 f39 = Math_fround(f36 * f39);
 f40 = Math_fround(f40 * Math_fround(HEAPF32[i30 >> 2]));
 f39 = f38 <= f39 ? f38 : f39;
 f40 = Math_fround((f39 <= f40 ? f39 : f40) * Math_fround(.00999999977));
 HEAPF32[i23 + 368 >> 2] = Math_fround(f40 * f40);
 i26 = i23 + 372 | 0;
 HEAP32[i26 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP8[i11 >> 0] = i12;
 i26 = HEAP32[i22 >> 2] | 0;
 i30 = HEAP32[i22 + 4 >> 2] | 0;
 i33 = HEAP32[i22 + 8 >> 2] | 0;
 i27 = HEAP32[i22 + 12 >> 2] | 0;
 i31 = HEAP32[i22 + 16 >> 2] | 0;
 i34 = HEAP32[i22 + 20 >> 2] | 0;
 i29 = HEAP32[i22 + 24 >> 2] | 0;
 i32 = HEAP32[i22 + 28 >> 2] | 0;
 i35 = HEAP32[i22 + 32 >> 2] | 0;
 f40 = Math_fround(HEAPF32[i22 + 36 >> 2]);
 f39 = Math_fround(HEAPF32[i22 + 40 >> 2]);
 f40 = Math_fround(-f40);
 f39 = Math_fround(-f39);
 f38 = Math_fround(-Math_fround(HEAPF32[i22 + 44 >> 2]));
 f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40);
 f36 = Math_fround(f36 + Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f39));
 f36 = Math_fround(f36 + Math_fround((HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38));
 f37 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40);
 f37 = Math_fround(f37 + Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f39));
 f37 = Math_fround(f37 + Math_fround((HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38));
 f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f40);
 f39 = Math_fround(f40 + Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f39));
 f38 = Math_fround(f39 + Math_fround((HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38));
 HEAP32[i13 >> 2] = i26;
 HEAP32[i14 >> 2] = i27;
 HEAP32[i23 + 24 >> 2] = i29;
 HEAPF32[i23 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i23 + 32 >> 2] = i30;
 HEAP32[i15 >> 2] = i31;
 HEAP32[i16 >> 2] = i32;
 HEAPF32[i23 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i23 + 48 >> 2] = i33;
 HEAP32[i23 + 52 >> 2] = i34;
 HEAP32[i17 >> 2] = i35;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 64 >> 2] = f36;
 HEAPF32[i23 + 68 >> 2] = f37;
 HEAPF32[i23 + 72 >> 2] = f38;
 HEAPF32[i23 + 76 >> 2] = Math_fround(0.0);
 f38 = Math_fround(Math_fround(HEAPF32[i22 + 48 >> 2]) + Math_fround(.00100000005));
 f37 = Math_fround(Math_fround(HEAPF32[i22 + 52 >> 2]) + Math_fround(.00100000005));
 f36 = Math_fround(Math_fround(HEAPF32[i22 + 56 >> 2]) + Math_fround(.00100000005));
 HEAPF32[i23 + 80 >> 2] = f38;
 HEAPF32[i23 + 84 >> 2] = f37;
 HEAPF32[i23 + 88 >> 2] = f36;
 HEAPF32[i23 + 92 >> 2] = Math_fround(0.0);
 STACKTOP = i28;
 return;
}

function __ZN24ConvexVsHeightfieldSweep7onEventEjPj(i1, i99, i97) {
 i1 = i1 | 0;
 i99 = i99 | 0;
 i97 = i97 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i98 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, f108 = f0, f109 = f0, f110 = f0, f111 = f0, f112 = f0, f113 = f0, f114 = f0, f115 = f0, f116 = f0;
 i107 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i107 + 224 | 0;
 i105 = i107 + 208 | 0;
 i104 = i107 + 192 | 0;
 i103 = i107 + 48 | 0;
 i101 = i107 + 32 | 0;
 i96 = i107 + 16 | 0;
 i100 = i107;
 i98 = i107 + 240 | 0;
 i102 = i107 + 268 | 0;
 HEAPF32[i98 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i98 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i98 + 24 >> 2] = Math_fround(0.0);
 if (!i99) {
  i106 = 1;
  STACKTOP = i107;
  return i106 | 0;
 }
 i92 = i1 + 4 | 0;
 i95 = i1 + 112 | 0;
 i22 = i1 + 368 | 0;
 i23 = i1 + 360 | 0;
 i24 = i1 + 433 | 0;
 i25 = i1 + 424 | 0;
 i26 = i1 + 434 | 0;
 i27 = i102 + 12 | 0;
 i28 = i102 + 16 | 0;
 i29 = i102 + 4 | 0;
 i30 = i102 + 20 | 0;
 i31 = i102 + 8 | 0;
 i32 = i102 + 24 | 0;
 i33 = i102 + 28 | 0;
 i34 = i102 + 32 | 0;
 i35 = i1 + 412 | 0;
 i36 = i1 + 416 | 0;
 i37 = i1 + 420 | 0;
 i38 = i1 + 64 | 0;
 i39 = i1 + 68 | 0;
 i40 = i1 + 72 | 0;
 i41 = i1 + 16 | 0;
 i42 = i1 + 32 | 0;
 i43 = i1 + 48 | 0;
 i44 = i1 + 20 | 0;
 i45 = i1 + 36 | 0;
 i46 = i1 + 52 | 0;
 i47 = i1 + 24 | 0;
 i48 = i1 + 40 | 0;
 i49 = i1 + 56 | 0;
 i50 = i103 + 64 | 0;
 i51 = i103 + 80 | 0;
 i52 = i103 + 16 | 0;
 i53 = i103 + 32 | 0;
 i54 = i103 + 48 | 0;
 i55 = i103 + 4 | 0;
 i56 = i103 + 8 | 0;
 i57 = i103 + 12 | 0;
 i58 = i103 + 96 | 0;
 i59 = i103 + 100 | 0;
 i60 = i103 + 104 | 0;
 i61 = i103 + 108 | 0;
 i62 = i103 + 112 | 0;
 i63 = i103 + 116 | 0;
 i64 = i103 + 120 | 0;
 i65 = i103 + 124 | 0;
 i66 = i103 + 128 | 0;
 i67 = i103 + 132 | 0;
 i68 = i103 + 136 | 0;
 i69 = i103 + 140 | 0;
 i70 = i1 + 80 | 0;
 i71 = i1 + 84 | 0;
 i72 = i1 + 88 | 0;
 i73 = i1 + 92 | 0;
 i74 = i1 + 96 | 0;
 i75 = i1 + 100 | 0;
 i76 = i1 + 104 | 0;
 i77 = i96 + 4 | 0;
 i78 = i96 + 8 | 0;
 i79 = i100 + 4 | 0;
 i80 = i100 + 8 | 0;
 i81 = i1 + 384 | 0;
 i82 = i1 + 332 | 0;
 i83 = i1 + 336 | 0;
 i84 = i1 + 340 | 0;
 i85 = i1 + 344 | 0;
 i86 = i1 + 348 | 0;
 i87 = i1 + 352 | 0;
 i88 = i1 + 356 | 0;
 i89 = i1 + 435 | 0;
 i90 = i1 + 328 | 0;
 i91 = i1 + 432 | 0;
 i93 = i1 + 400 | 0;
 i94 = i1 + 404 | 0;
 i1 = i1 + 408 | 0;
 i20 = 0;
 L4 : while (1) {
  i19 = i97 + (i20 << 2) | 0;
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i92 >> 2] | 0, i98, i102, 0, 0, HEAP32[i19 >> 2] | 0, 0, 0) | 0;
  f18 = Math_fround(HEAPF32[i23 >> 2]);
  f7 = Math_fround(HEAPF32[i25 >> 2]);
  f8 = Math_fround(HEAPF32[i27 >> 2]);
  f9 = Math_fround(HEAPF32[i102 >> 2]);
  f10 = Math_fround(f8 - f9);
  f11 = Math_fround(HEAPF32[i28 >> 2]);
  f12 = Math_fround(HEAPF32[i29 >> 2]);
  f13 = Math_fround(f11 - f12);
  f14 = Math_fround(HEAPF32[i30 >> 2]);
  f15 = Math_fround(HEAPF32[i31 >> 2]);
  f16 = Math_fround(f14 - f15);
  f17 = Math_fround(HEAPF32[i32 >> 2]);
  f2 = Math_fround(f17 - f8);
  f3 = Math_fround(HEAPF32[i33 >> 2]);
  f4 = Math_fround(f3 - f11);
  f5 = Math_fround(HEAPF32[i34 >> 2]);
  f6 = Math_fround(f5 - f14);
  if (!(HEAP8[i24 >> 0] | 0)) {
   f108 = Math_fround(Math_fround(f10 * f4) - Math_fround(f13 * f2));
   f10 = Math_fround(Math_fround(f16 * f2) - Math_fround(f10 * f6));
   f16 = Math_fround(Math_fround(f13 * f6) - Math_fround(f16 * f4));
   f16 = Math_fround(f16 * Math_fround(HEAPF32[i35 >> 2]));
   f16 = Math_fround(f16 + Math_fround(f10 * Math_fround(HEAPF32[i36 >> 2])));
   if (!(Math_fround(f16 + Math_fround(f108 * Math_fround(HEAPF32[i37 >> 2]))) <= Math_fround(0.0))) i106 = 5;
  } else i106 = 5;
  L9 : do if ((i106 | 0) == 5) {
   i106 = 0;
   HEAP32[i105 >> 2] = 0;
   HEAP32[i105 + 4 >> 2] = 0;
   HEAP32[i105 + 8 >> 2] = 0;
   HEAP32[i105 + 12 >> 2] = 0;
   HEAPF32[i104 >> 2] = Math_fround(0.0);
   f116 = Math_fround(HEAPF32[i38 >> 2]);
   f112 = Math_fround(HEAPF32[i39 >> 2]);
   f109 = Math_fround(HEAPF32[i40 >> 2]);
   f115 = Math_fround(HEAPF32[i41 >> 2]);
   f6 = Math_fround(f9 * f115);
   f114 = Math_fround(HEAPF32[i42 >> 2]);
   f6 = Math_fround(f6 + Math_fround(f12 * f114));
   f113 = Math_fround(HEAPF32[i43 >> 2]);
   f6 = Math_fround(f6 + Math_fround(f15 * f113));
   f111 = Math_fround(HEAPF32[i44 >> 2]);
   f13 = Math_fround(f9 * f111);
   f110 = Math_fround(HEAPF32[i45 >> 2]);
   f13 = Math_fround(f13 + Math_fround(f12 * f110));
   f16 = Math_fround(HEAPF32[i46 >> 2]);
   f13 = Math_fround(f13 + Math_fround(f15 * f16));
   f2 = Math_fround(HEAPF32[i47 >> 2]);
   f10 = Math_fround(f9 * f2);
   f4 = Math_fround(HEAPF32[i48 >> 2]);
   f10 = Math_fround(f10 + Math_fround(f12 * f4));
   f108 = Math_fround(HEAPF32[i49 >> 2]);
   f6 = Math_fround(f116 + f6);
   f9 = Math_fround(f112 + f13);
   f10 = Math_fround(f109 + Math_fround(f10 + Math_fround(f15 * f108)));
   f12 = Math_fround(f116 + Math_fround(Math_fround(Math_fround(f8 * f115) + Math_fround(f11 * f114)) + Math_fround(f14 * f113)));
   f13 = Math_fround(f112 + Math_fround(Math_fround(Math_fround(f8 * f111) + Math_fround(f11 * f110)) + Math_fround(f14 * f16)));
   f14 = Math_fround(f109 + Math_fround(Math_fround(Math_fround(f8 * f2) + Math_fround(f11 * f4)) + Math_fround(f14 * f108)));
   f15 = Math_fround(f116 + Math_fround(Math_fround(Math_fround(f17 * f115) + Math_fround(f3 * f114)) + Math_fround(f5 * f113)));
   f16 = Math_fround(f112 + Math_fround(Math_fround(Math_fround(f17 * f111) + Math_fround(f3 * f110)) + Math_fround(f5 * f16)));
   f108 = Math_fround(f109 + Math_fround(Math_fround(Math_fround(f17 * f2) + Math_fround(f3 * f4)) + Math_fround(f5 * f108)));
   HEAP32[i51 >> 2] = 7;
   HEAPF32[i54 >> 2] = Math_fround(0.0);
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   HEAP32[i50 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i50 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   f11 = Math_fround(Math_fround(f16 + Math_fround(f9 + f13)) * Math_fround(.333332986));
   f17 = Math_fround(Math_fround(f108 + Math_fround(f10 + f14)) * Math_fround(.333332986));
   HEAPF32[i103 >> 2] = Math_fround(Math_fround(f15 + Math_fround(f6 + f12)) * Math_fround(.333332986));
   HEAPF32[i55 >> 2] = f11;
   HEAPF32[i56 >> 2] = f17;
   HEAPF32[i57 >> 2] = Math_fround(0.0);
   HEAPF32[i58 >> 2] = f6;
   HEAPF32[i59 >> 2] = f9;
   HEAPF32[i60 >> 2] = f10;
   HEAPF32[i61 >> 2] = Math_fround(0.0);
   HEAPF32[i62 >> 2] = f12;
   HEAPF32[i63 >> 2] = f13;
   HEAPF32[i64 >> 2] = f14;
   HEAPF32[i65 >> 2] = Math_fround(0.0);
   HEAPF32[i66 >> 2] = f15;
   HEAPF32[i67 >> 2] = f16;
   HEAPF32[i68 >> 2] = f108;
   HEAPF32[i69 >> 2] = Math_fround(0.0);
   HEAPF32[i52 >> 2] = Math_fround(0.0);
   HEAPF32[i53 >> 2] = Math_fround(3402823469999999843913219.0e14);
   do if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i103, i95, i104, i105, i22, i101, i100, i96, f7, 0) | 0) {
    f113 = Math_fround(HEAPF32[i70 >> 2]);
    f115 = Math_fround(HEAPF32[i71 >> 2]);
    f116 = Math_fround(HEAPF32[i72 >> 2]);
    f112 = Math_fround(HEAPF32[i73 >> 2]);
    f3 = Math_fround(HEAPF32[i74 >> 2]);
    f4 = Math_fround(HEAPF32[i75 >> 2]);
    f8 = Math_fround(HEAPF32[i76 >> 2]);
    f2 = Math_fround(HEAPF32[i96 >> 2]);
    f114 = Math_fround(HEAPF32[i77 >> 2]);
    f111 = Math_fround(HEAPF32[i78 >> 2]);
    f110 = Math_fround(Math_fround(f112 * f112) + Math_fround(-.5));
    f5 = Math_fround(Math_fround(Math_fround(f113 * f2) + Math_fround(f115 * f114)) + Math_fround(f116 * f111));
    f3 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f113 * f5) + Math_fround(Math_fround(f110 * f2) + Math_fround(f112 * Math_fround(Math_fround(f115 * f111) - Math_fround(f116 * f114))))) * Math_fround(2.0)));
    f4 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f115 * f5) + Math_fround(Math_fround(f110 * f114) + Math_fround(f112 * Math_fround(Math_fround(f116 * f2) - Math_fround(f113 * f111))))) * Math_fround(2.0)));
    f5 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(Math_fround(f110 * f111) + Math_fround(f112 * Math_fround(Math_fround(f113 * f114) - Math_fround(f115 * f2)))) + Math_fround(f116 * f5)) * Math_fround(2.0)));
    f2 = Math_fround(HEAPF32[i100 >> 2]);
    f114 = Math_fround(HEAPF32[i79 >> 2]);
    f111 = Math_fround(HEAPF32[i80 >> 2]);
    f8 = Math_fround(Math_fround(Math_fround(f113 * f2) + Math_fround(f115 * f114)) + Math_fround(f116 * f111));
    f6 = Math_fround(Math_fround(Math_fround(f113 * f8) + Math_fround(Math_fround(f110 * f2) + Math_fround(f112 * Math_fround(Math_fround(f115 * f111) - Math_fround(f116 * f114))))) * Math_fround(2.0));
    f7 = Math_fround(Math_fround(Math_fround(f115 * f8) + Math_fround(Math_fround(f110 * f114) + Math_fround(f112 * Math_fround(Math_fround(f116 * f2) - Math_fround(f113 * f111))))) * Math_fround(2.0));
    f8 = Math_fround(Math_fround(Math_fround(Math_fround(f110 * f111) + Math_fround(f112 * Math_fround(Math_fround(f113 * f114) - Math_fround(f115 * f2)))) + Math_fround(f116 * f8)) * Math_fround(2.0));
    f116 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))))));
    f6 = Math_fround(f116 * f6);
    f7 = Math_fround(f116 * f7);
    f8 = Math_fround(f116 * f8);
    f116 = Math_fround(HEAPF32[i104 >> 2]);
    f2 = Math_fround(HEAPF32[i101 >> 2]);
    if (!(f116 >= f2)) {
     f2 = Math_fround(f2 * Math_fround(HEAPF32[i81 >> 2]));
     if (!(f2 < f18)) break;
     HEAP16[i82 >> 1] = 7;
     HEAPF32[i83 >> 2] = f3;
     HEAPF32[i84 >> 2] = f4;
     HEAPF32[i85 >> 2] = f5;
     HEAPF32[i86 >> 2] = f6;
     HEAPF32[i87 >> 2] = f7;
     HEAPF32[i88 >> 2] = f8;
     HEAPF32[i23 >> 2] = f2;
    } else {
     HEAP16[i82 >> 1] = 6;
     HEAPF32[i23 >> 2] = Math_fround(0.0);
     f115 = Math_fround(-Math_fround(HEAPF32[i93 >> 2]));
     f116 = Math_fround(-Math_fround(HEAPF32[i94 >> 2]));
     f2 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
     HEAPF32[i86 >> 2] = f115;
     HEAPF32[i87 >> 2] = f116;
     HEAPF32[i88 >> 2] = f2;
     HEAP8[i26 >> 0] = 1;
     f2 = Math_fround(0.0);
    }
    HEAP8[i89 >> 0] = 1;
    HEAP32[i90 >> 2] = HEAP32[i19 >> 2];
    if ((HEAP8[i91 >> 0] | 0) != 0 | f2 == Math_fround(0.0)) break L4; else break L9;
   } while (0);
  } while (0);
  i20 = i20 + 1 | 0;
  if (i20 >>> 0 >= i99 >>> 0) {
   i1 = 1;
   i106 = 15;
   break;
  }
 }
 if ((i106 | 0) == 15) {
  STACKTOP = i107;
  return i1 | 0;
 }
 i106 = 0;
 STACKTOP = i107;
 return i106 | 0;
}

function __Z26FindForwardLightsForObjectR13dynamic_arrayIhLj1EEPK11CulledLightjRK12ActiveLightsRK10RenderNodebRK23FindForwardLightsParams(i24, i30, i7, i25, i28, i1, i27) {
 i24 = i24 | 0;
 i30 = i30 | 0;
 i7 = i7 | 0;
 i25 = i25 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i29 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i31;
 i8 = 1 << HEAP32[i28 + 240 >> 2];
 i22 = i28 + 128 | 0;
 if ((HEAP8[i27 >> 0] & 2) != 0 | i1 ^ 1) i26 = i30; else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 4, gb + 64016 | 0, 0, gb + 380258 | 0, 523) | 0;
  if (!i7) {
   i7 = 0;
   i26 = i6;
  } else {
   i1 = 0;
   i5 = 0;
   do {
    i2 = i30 + (i5 << 3) | 0;
    if (!(HEAP8[(HEAP32[i25 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 180 | 0) + 172 >> 0] | 0)) {
     i21 = i2;
     i23 = HEAP32[i21 + 4 >> 2] | 0;
     i26 = i6 + (i1 << 3) | 0;
     HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i26 + 4 >> 2] = i23;
     i1 = i1 + 1 | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
   i7 = i1;
   i26 = i6;
  }
 }
 i20 = i24 + 12 | 0;
 i23 = HEAP32[i20 >> 2] | 0;
 i2 = i23 + 132 | 0;
 HEAP32[i20 >> 2] = i2;
 i21 = i24 + 16 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i21 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i24 >> 2] = i1;
  i19 = i24;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i24 >> 2] = i1;
  i19 = i24;
  break;
 } else {
  i19 = i24;
  i1 = HEAP32[i24 >> 2] | 0;
 } while (0);
 i6 = i1 + i23 | 0;
 HEAP32[i6 + 112 >> 2] = 0;
 HEAP32[i6 + 116 >> 2] = 0;
 i5 = i6 + 108 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAPF32[i6 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 128 >> 2] = Math_fround(1.0);
 i1 = HEAP8[i27 >> 0] | 0;
 if (!(i1 & 2)) {
  if (HEAP8[i25 + 20 >> 0] | 0) {
   i2 = HEAP32[i25 >> 2] | 0;
   if (i2) if (HEAP32[i2 + 16 >> 2] & i8) if (!(HEAP8[i2 + 81 >> 0] | 0)) {
    HEAP32[i5 >> 2] = i2;
    i1 = HEAP8[i27 >> 0] | 0;
   }
  }
  if (!(i1 & 4)) {
   i1 = i6;
   i2 = i27 + 8 | 0;
   i5 = i1 + 108 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i5 | 0));
  } else __ZN20SphericalHarmonicsL27SetZeroEv(i6);
  i1 = HEAP8[i27 >> 0] | 0;
  i17 = (i1 & 16) == 0 ? i7 : 0;
  if (!i17) {
   i11 = i6;
   i5 = -1;
  } else {
   i15 = i27 + 4 | 0;
   i16 = i24 + 4 | 0;
   i2 = i6;
   i5 = -1;
   i14 = 0;
   do {
    i6 = HEAP32[i26 + (i14 << 3) >> 2] | 0;
    i7 = HEAP32[i25 >> 2] | 0;
    i13 = i7 + (i6 * 180 | 0) | 0;
    i12 = HEAP32[i7 + (i6 * 180 | 0) + 128 >> 2] | 0;
    i8 = i1 & 1;
    i9 = i8 << 24 >> 24 ? (HEAP32[i7 + (i6 * 180 | 0) + 12 >> 2] | 0) == 0 : 0;
    i10 = i2 + 108 | 0;
    i11 = (HEAP32[i10 >> 2] | 0) == 0;
    do if ((i6 | 0) != 0 | i11 | i9) {
     if (i11) if ((i12 | 0) != 2 ? (HEAP32[i7 + (i6 * 180 | 0) + 132 >> 2] | 0) == 1 : 0) if (!(i9 | (HEAP8[i7 + (i6 * 180 | 0) + 81 >> 0] | 0) != 0)) {
      HEAP32[i10 >> 2] = i13;
      break;
     }
     switch (i12 | 0) {
     case 1:
      {
       if (!(i1 & 8)) i18 = 40;
       break;
      }
     case 2:
      break;
     default:
      if ((i1 & 8) == 0 ? (HEAP32[i2 + 112 >> 2] | 0) < (HEAP32[i15 >> 2] | 0) : 0) i18 = 40;
     }
     if ((i18 | 0) == 40) {
      i18 = 0;
      i2 = HEAP32[i20 >> 2] | 0;
      i1 = i2 + 4 | 0;
      HEAP32[i20 >> 2] = i1;
      i6 = HEAP32[i21 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i7 >>> 0 < i1 >>> 0) {
       i11 = i6 << 1;
       i1 = i11 >>> 0 > i1 >>> 0 ? i11 : i1;
       if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i21 >> 2] = i1;
        HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1, 1, i16, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i16, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i11 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
        HEAP32[i21 >> 2] = i1;
        HEAP32[i19 >> 2] = i11;
        break;
       }
      } while (0);
      HEAP32[(HEAP32[i19 >> 2] | 0) + i2 >> 2] = i13;
      i2 = (HEAP32[i19 >> 2] | 0) + i23 | 0;
      i11 = i2 + 112 | 0;
      i13 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
      HEAP32[i11 >> 2] = i13;
      i5 = ((i12 | 0) != 1 ? (i13 | 0) == (HEAP32[i15 >> 2] | 0) : 0) ? i14 : i5;
      break;
     }
     if (!(i8 << 24 >> 24)) {
      if ((HEAP32[i7 + (i6 * 180 | 0) + 132 >> 2] | 0) != 1) if ((HEAP32[i2 + 116 >> 2] | 0) < 4) {
       i2 = HEAP32[i20 >> 2] | 0;
       i1 = i2 + 4 | 0;
       HEAP32[i20 >> 2] = i1;
       i6 = HEAP32[i21 >> 2] | 0;
       i7 = i6 & 2147483647;
       do if (i7 >>> 0 < i1 >>> 0) {
        i12 = i6 << 1;
        i1 = i12 >>> 0 > i1 >>> 0 ? i12 : i1;
        if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
         HEAP32[i21 >> 2] = i1;
         HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1, 1, i16, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i16, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i12 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
         HEAP32[i21 >> 2] = i1;
         HEAP32[i19 >> 2] = i12;
         break;
        }
       } while (0);
       HEAP32[(HEAP32[i19 >> 2] | 0) + i2 >> 2] = i13;
       i2 = (HEAP32[i19 >> 2] | 0) + i23 | 0;
       i13 = i2 + 116 | 0;
       HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
       break;
      }
      __ZL12AddLightToSHRK4AABBRK15SharedLightDataP18ForwardLightsBlockf(i22, HEAP32[i13 >> 2] | 0, i2, Math_fround(1.0));
     }
    } while (0);
    i14 = i14 + 1 | 0;
    i1 = HEAP8[i27 >> 0] | 0;
   } while ((i14 | 0) != (i17 | 0));
   i11 = i2;
  }
  if (!(i1 & 16)) {
   i6 = (i1 & 1) == 0;
   i8 = HEAP32[i19 >> 2] | 0;
   i1 = i8 + i23 | 0;
   i9 = (HEAP32[i1 + 116 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] | 0) | 0;
   i2 = i9 + -1 | 0;
   i7 = i1 + 120 | 0;
   HEAPF32[i7 >> 2] = Math_fround(1.0);
   i10 = i17 + -1 | 0;
   do if ((i5 | 0) > 0 & (i10 | 0) > (i5 | 0)) {
    f4 = Math_fround(HEAPF32[i26 + (i5 + -1 << 3) + 4 >> 2]);
    f3 = Math_fround(HEAPF32[i26 + (i5 + 1 << 3) + 4 >> 2]);
    f4 = Math_fround(f4 - f3);
    if (!(f4 >= Math_fround(1.0e3))) {
     f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i26 + (i5 << 3) + 4 >> 2]) - f3) / Math_fround(f4 + Math_fround(.00100000005)));
     i18 = f3 < Math_fround(0.0);
     i17 = f3 > Math_fround(1.0);
     f3 = i17 ? Math_fround(1.0) : f3;
     f3 = i18 ? Math_fround(0.0) : f3;
     HEAPF32[i7 >> 2] = f3;
     if (i6) {
      i5 = HEAP32[(HEAP32[i25 >> 2] | 0) + ((HEAP32[i26 + (i5 << 3) >> 2] | 0) * 180 | 0) >> 2] | 0;
      if ((HEAP32[i5 + 40 >> 2] | 0) == 1) {
       __ZL12AddLightToSHRK4AABBRK15SharedLightDataP18ForwardLightsBlockf(i22, i5, i1, Math_fround(Math_fround(1.0) - f3));
       break;
      }
      i1 = (HEAP32[i20 >> 2] | 0) + 4 | 0;
      HEAP32[i20 >> 2] = i1;
      i5 = HEAP32[i21 >> 2] | 0;
      do if ((i5 & 2147483647) >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i21 >> 2] = i1;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i1, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i19 >> 2] = i1;
       break;
      } else {
       i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i25 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
       HEAP32[i21 >> 2] = i1;
       HEAP32[i19 >> 2] = i25;
       i1 = i25;
       break;
      } else i1 = i8; while (0);
      i1 = i1 + i23 | 0;
      i6 = i1 + 132 | 0;
      i7 = i1 + 112 | 0;
      i8 = i1 + 116 | 0;
      i5 = HEAP32[i8 >> 2] | 0;
      if ((i5 | 0) >= 0) {
       i5 = (HEAP32[i7 >> 2] | 0) + i5 | 0;
       do {
        i25 = i5;
        i5 = i5 + -1 | 0;
        HEAP32[i6 + (i25 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
       } while ((i25 | 0) > (HEAP32[i7 >> 2] | 0));
       i5 = HEAP32[i8 >> 2] | 0;
      }
      i25 = (i5 | 0) > 3;
      HEAP32[i8 >> 2] = i25 ? 4 : i5 + 1 | 0;
      i2 = i25 ? i9 + -2 | 0 : i2;
     }
    }
   } while (0);
   if ((HEAP32[i1 + 116 >> 2] | 0) > 0) {
    i1 = i1 + 124 | 0;
    HEAPF32[i1 >> 2] = Math_fround(1.0);
    if ((i2 | 0) > 0 & (i10 | 0) > (i2 | 0)) {
     f4 = Math_fround(HEAPF32[i26 + (i2 + -1 << 3) + 4 >> 2]);
     f3 = Math_fround(HEAPF32[i26 + (i2 + 1 << 3) + 4 >> 2]);
     f4 = Math_fround(f4 - f3);
     if (!(f4 >= Math_fround(1.0e3))) {
      f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i26 + (i2 << 3) + 4 >> 2]) - f3) / Math_fround(f4 + Math_fround(.00100000005)));
      i25 = f3 < Math_fround(0.0);
      i24 = f3 > Math_fround(1.0);
      f3 = i24 ? Math_fround(1.0) : f3;
      HEAP32[i1 >> 2] = i25 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
     }
    }
   }
  }
  if (HEAP8[i27 >> 0] & 4) {
   i5 = i28 + 232 | 0;
   i5 = HEAPU16[i5 >> 1] | HEAPU8[i5 + 2 >> 0] << 16;
   if ((i5 & 196608 | 0) == 65536) {
    i1 = HEAP32[i11 + 108 >> 2] | 0;
    if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
    i1 = i27 + 8 | 0;
    if (!(i5 & 8192)) {
     i28 = i28 + 300 | 0;
     __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i1, i28, i29);
     HEAPF32[i11 + 128 >> 2] = Math_fround(__Z31GetInterpolatedLightAttenuationRK17LightProbeContextRK29LightProbeSamplingCoordinatesPK15SharedLightData(i1, i28, i2));
     __ZN20SphericalHarmonicsL2pLERKS_(i11, i29) | 0;
    } else {
     i28 = i28 + 228 | 0;
     HEAPF32[i11 + 128 >> 2] = Math_fround(__Z34GetNonInterpolatedLightAttenuationRK17LightProbeContextjPK15SharedLightData(i1, HEAP32[i28 >> 2] | 0, i2));
     __Z28GetNonInterpolatedLightProbeRK17LightProbeContextjR20SphericalHarmonicsL2(i1, HEAP32[i28 >> 2] | 0, i29);
     __ZN20SphericalHarmonicsL2pLERKS_(i11, i29) | 0;
    }
   }
  }
 } else {
  i5 = (i7 | 0) > 8 ? 8 : i7;
  __ZN20SphericalHarmonicsL27SetZeroEv(i6);
  i1 = (i5 << 2) + i2 | 0;
  HEAP32[i20 >> 2] = i1;
  i2 = HEAP32[i21 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i21 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i19 >> 2] = i1;
   break;
  } else {
   i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i29 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i19 >> 2] = i29;
   i1 = i29;
   break;
  } else i1 = HEAP32[i19 >> 2] | 0; while (0);
  i29 = i1 + i23 | 0;
  i2 = i29 + 132 | 0;
  HEAP32[i29 + 116 >> 2] = i5;
  if ((i7 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = (HEAP32[i25 >> 2] | 0) + ((HEAP32[i26 + (i1 << 3) >> 2] | 0) * 180 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i5 | 0));
  }
 }
 if ((i26 | 0) == (i30 | 0)) {
  STACKTOP = i31;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i26, gb + 64016 | 0);
 STACKTOP = i31;
 return;
}

function __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_PS3_(i1, i5, i3, i6, i7, i8, i9, i4, i10, i11, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0;
 f31 = Math_fround(HEAPF32[i3 >> 2]);
 f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i5 >> 2]);
 f38 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f40 = Math_fround(HEAPF32[i9 >> 2]);
 f39 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f59 = Math_fround(f28 - f23);
 f64 = Math_fround(f28 - f20);
 f72 = Math_fround(f28 - f17);
 f54 = Math_fround(f28 - f40);
 f62 = Math_fround(f38 - f22);
 f71 = Math_fround(f38 - f19);
 f73 = Math_fround(f38 - f16);
 f50 = Math_fround(f38 - f39);
 f63 = Math_fround(f37 - f32);
 f60 = Math_fround(f37 - f34);
 f57 = Math_fround(f37 - f33);
 f53 = Math_fround(f37 - f35);
 f70 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f30 * f30)) + Math_fround(f36 * f36));
 f12 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(f29 * f29));
 f49 = Math_fround(Math_fround(Math_fround(f31 * f14) + Math_fround(f30 * f13)) + Math_fround(f36 * f29));
 f27 = Math_fround(Math_fround(f31 * f59) + Math_fround(Math_fround(f30 * f62) + Math_fround(f36 * f63)));
 f26 = Math_fround(Math_fround(f31 * f64) + Math_fround(Math_fround(f30 * f71) + Math_fround(f36 * f60)));
 f25 = Math_fround(Math_fround(f31 * f72) + Math_fround(Math_fround(f30 * f73) + Math_fround(f36 * f57)));
 f24 = Math_fround(Math_fround(f31 * f54) + Math_fround(Math_fround(f30 * f50) + Math_fround(f36 * f53)));
 f63 = Math_fround(Math_fround(f14 * f59) + Math_fround(Math_fround(f13 * f62) + Math_fround(f29 * f63)));
 f60 = Math_fround(Math_fround(f14 * f64) + Math_fround(Math_fround(f13 * f71) + Math_fround(f29 * f60)));
 f57 = Math_fround(Math_fround(f14 * f72) + Math_fround(Math_fround(f13 * f73) + Math_fround(f29 * f57)));
 f53 = Math_fround(Math_fround(f14 * f54) + Math_fround(Math_fround(f13 * f50) + Math_fround(f29 * f53)));
 f50 = Math_fround(Math_fround(1.0) / f70);
 f54 = Math_fround(Math_fround(1.0) / f12);
 f73 = Math_fround(-f27);
 f72 = Math_fround(-f26);
 f71 = Math_fround(-f25);
 f64 = Math_fround(-f24);
 f62 = Math_fround(f50 * f73);
 f59 = Math_fround(f50 * f72);
 f56 = Math_fround(f50 * f71);
 f52 = Math_fround(f50 * f64);
 i9 = f62 < Math_fround(1.0);
 f48 = i9 ? f62 : Math_fround(1.0);
 i9 = f59 < Math_fround(1.0);
 f47 = i9 ? f59 : Math_fround(1.0);
 i9 = f56 < Math_fround(1.0);
 f46 = i9 ? f56 : Math_fround(1.0);
 i9 = f52 < Math_fround(1.0);
 f45 = i9 ? f52 : Math_fround(1.0);
 i9 = f48 > Math_fround(0.0);
 f48 = i9 ? f48 : Math_fround(0.0);
 i9 = f47 > Math_fround(0.0);
 f47 = i9 ? f47 : Math_fround(0.0);
 i9 = f46 > Math_fround(0.0);
 f46 = i9 ? f46 : Math_fround(0.0);
 i9 = f45 > Math_fround(0.0);
 f45 = i9 ? f45 : Math_fround(0.0);
 f44 = Math_fround(f63 * f54);
 f43 = Math_fround(f60 * f54);
 f42 = Math_fround(f57 * f54);
 f41 = Math_fround(f53 * f54);
 i9 = f44 < Math_fround(1.0);
 f44 = i9 ? f44 : Math_fround(1.0);
 i9 = f43 < Math_fround(1.0);
 f43 = i9 ? f43 : Math_fround(1.0);
 i9 = f42 < Math_fround(1.0);
 f42 = i9 ? f42 : Math_fround(1.0);
 i9 = f41 < Math_fround(1.0);
 f41 = i9 ? f41 : Math_fround(1.0);
 i9 = f44 > Math_fround(0.0);
 f44 = i9 ? f44 : Math_fround(0.0);
 i9 = f43 > Math_fround(0.0);
 f43 = i9 ? f43 : Math_fround(0.0);
 i9 = f42 > Math_fround(0.0);
 f42 = i9 ? f42 : Math_fround(0.0);
 i9 = f41 > Math_fround(0.0);
 f41 = i9 ? f41 : Math_fround(0.0);
 f61 = Math_fround(f70 * f73);
 f58 = Math_fround(f70 * f72);
 f55 = Math_fround(f70 * f71);
 f51 = Math_fround(f70 * f64);
 i9 = f70 < Math_fround(1.1920929e-07);
 i8 = f12 < Math_fround(1.1920929e-07);
 f65 = Math_fround(Math_fround(f70 * f12) - Math_fround(f49 * f49));
 f74 = Math_fround(Math_fround(1.0) / f65);
 f21 = Math_fround(f74 * Math_fround(Math_fround(f63 * f49) - Math_fround(f27 * f12)));
 f18 = Math_fround(f74 * Math_fround(Math_fround(f60 * f49) - Math_fround(f26 * f12)));
 f15 = Math_fround(f74 * Math_fround(Math_fround(f57 * f49) - Math_fround(f25 * f12)));
 f12 = Math_fround(f74 * Math_fround(Math_fround(f53 * f49) - Math_fround(f24 * f12)));
 i7 = f21 < Math_fround(1.0);
 f21 = i7 ? f21 : Math_fround(1.0);
 i7 = f18 < Math_fround(1.0);
 f18 = i7 ? f18 : Math_fround(1.0);
 i7 = f15 < Math_fround(1.0);
 f15 = i7 ? f15 : Math_fround(1.0);
 i7 = f12 < Math_fround(1.0);
 f12 = i7 ? f12 : Math_fround(1.0);
 i7 = f21 > Math_fround(0.0);
 f21 = i7 ? f21 : Math_fround(0.0);
 i7 = f18 > Math_fround(0.0);
 f18 = i7 ? f18 : Math_fround(0.0);
 i7 = f15 > Math_fround(0.0);
 f15 = i7 ? f15 : Math_fround(0.0);
 i7 = f12 > Math_fround(0.0);
 f12 = i7 ? f12 : Math_fround(0.0);
 i7 = f49 > Math_fround(0.0);
 i69 = f27 >= Math_fround(0.0);
 i68 = f26 >= Math_fround(0.0);
 i67 = f25 >= Math_fround(0.0);
 i66 = f24 >= Math_fround(0.0);
 i3 = f70 > f73;
 i4 = f70 > f72;
 i5 = f70 > f71;
 i6 = f70 > f64;
 f61 = i3 ? f61 : Math_fround(1.0);
 f58 = i4 ? f58 : Math_fround(1.0);
 f55 = i5 ? f55 : Math_fround(1.0);
 f51 = i6 ? f51 : Math_fround(1.0);
 f61 = i69 ? Math_fround(0.0) : f61;
 f58 = i68 ? Math_fround(0.0) : f58;
 f55 = i67 ? Math_fround(0.0) : f55;
 f51 = i66 ? Math_fround(0.0) : f51;
 f62 = i69 ? Math_fround(0.0) : f62;
 f59 = i68 ? Math_fround(0.0) : f59;
 f56 = i67 ? Math_fround(0.0) : f56;
 f52 = i66 ? Math_fround(0.0) : f52;
 f62 = i3 ? f62 : Math_fround(1.0);
 f59 = i4 ? f59 : Math_fround(1.0);
 f56 = i5 ? f56 : Math_fround(1.0);
 f52 = i6 ? f52 : Math_fround(1.0);
 f64 = Math_fround(-f65);
 i6 = (f65 > f64 ? f65 : f64) <= Math_fround(.00999999977);
 f21 = Math_fround(f54 * Math_fround(f63 + Math_fround(f49 * (i6 ? (i7 ? f62 : f61) : f21))));
 f18 = Math_fround(f54 * Math_fround(f60 + Math_fround(f49 * (i6 ? (i7 ? f59 : f58) : f18))));
 f15 = Math_fround(f54 * Math_fround(f57 + Math_fround(f49 * (i6 ? (i7 ? f56 : f55) : f15))));
 f12 = Math_fround(f54 * Math_fround(f53 + Math_fround(f49 * (i6 ? (i7 ? f52 : f51) : f12))));
 i7 = f21 < Math_fround(1.0);
 f21 = i7 ? f21 : Math_fround(1.0);
 i7 = f18 < Math_fround(1.0);
 f18 = i7 ? f18 : Math_fround(1.0);
 i7 = f15 < Math_fround(1.0);
 f15 = i7 ? f15 : Math_fround(1.0);
 i7 = f12 < Math_fround(1.0);
 f12 = i7 ? f12 : Math_fround(1.0);
 i7 = f21 > Math_fround(0.0);
 f21 = i7 ? f21 : Math_fround(0.0);
 i7 = f18 > Math_fround(0.0);
 f18 = i7 ? f18 : Math_fround(0.0);
 i7 = f15 > Math_fround(0.0);
 f15 = i7 ? f15 : Math_fround(0.0);
 i7 = f12 > Math_fround(0.0);
 f12 = i7 ? f12 : Math_fround(0.0);
 f27 = Math_fround(f50 * Math_fround(Math_fround(f49 * f21) - f27));
 f26 = Math_fround(f50 * Math_fround(Math_fround(f49 * f18) - f26));
 f25 = Math_fround(f50 * Math_fround(Math_fround(f49 * f15) - f25));
 f24 = Math_fround(f50 * Math_fround(Math_fround(f49 * f12) - f24));
 i7 = f27 < Math_fround(1.0);
 f27 = i7 ? f27 : Math_fround(1.0);
 i7 = f26 < Math_fround(1.0);
 f26 = i7 ? f26 : Math_fround(1.0);
 i7 = f25 < Math_fround(1.0);
 f25 = i7 ? f25 : Math_fround(1.0);
 i7 = f24 < Math_fround(1.0);
 f24 = i7 ? f24 : Math_fround(1.0);
 i7 = f27 > Math_fround(0.0);
 f27 = i7 ? f27 : Math_fround(0.0);
 i7 = f26 > Math_fround(0.0);
 f26 = i7 ? f26 : Math_fround(0.0);
 i7 = f25 > Math_fround(0.0);
 f25 = i7 ? f25 : Math_fround(0.0);
 i7 = f24 > Math_fround(0.0);
 f24 = i7 ? f24 : Math_fround(0.0);
 f27 = i9 ? Math_fround(0.0) : i8 ? f48 : f27;
 f26 = i9 ? Math_fround(0.0) : i8 ? f47 : f26;
 f25 = i9 ? Math_fround(0.0) : i8 ? f46 : f25;
 f24 = i9 ? Math_fround(0.0) : i8 ? f45 : f24;
 f21 = i8 ? Math_fround(0.0) : i9 ? f44 : f21;
 f18 = i8 ? Math_fround(0.0) : i9 ? f43 : f18;
 f15 = i8 ? Math_fround(0.0) : i9 ? f42 : f15;
 f12 = i8 ? Math_fround(0.0) : i9 ? f41 : f12;
 HEAPF32[i10 >> 2] = f27;
 HEAPF32[i10 + 4 >> 2] = f26;
 HEAPF32[i10 + 8 >> 2] = f25;
 HEAPF32[i10 + 12 >> 2] = f24;
 HEAPF32[i11 >> 2] = f21;
 HEAPF32[i11 + 4 >> 2] = f18;
 HEAPF32[i11 + 8 >> 2] = f15;
 HEAPF32[i11 + 12 >> 2] = f12;
 f23 = Math_fround(f23 + Math_fround(f14 * f21));
 f20 = Math_fround(f20 + Math_fround(f14 * f18));
 f17 = Math_fround(f17 + Math_fround(f14 * f15));
 f14 = Math_fround(f40 + Math_fround(f14 * f12));
 f22 = Math_fround(f22 + Math_fround(f13 * f21));
 f19 = Math_fround(f19 + Math_fround(f13 * f18));
 f16 = Math_fround(f16 + Math_fround(f13 * f15));
 f13 = Math_fround(f39 + Math_fround(f13 * f12));
 f21 = Math_fround(f32 + Math_fround(f29 * f21));
 f18 = Math_fround(f34 + Math_fround(f29 * f18));
 f15 = Math_fround(f33 + Math_fround(f29 * f15));
 f12 = Math_fround(f35 + Math_fround(f29 * f12));
 f29 = Math_fround(Math_fround(f28 + Math_fround(f31 * f27)) - f23);
 f35 = Math_fround(Math_fround(f28 + Math_fround(f31 * f26)) - f20);
 f33 = Math_fround(Math_fround(f28 + Math_fround(f31 * f25)) - f17);
 f31 = Math_fround(Math_fround(f28 + Math_fround(f31 * f24)) - f14);
 f28 = Math_fround(Math_fround(f38 + Math_fround(f30 * f27)) - f22);
 f34 = Math_fround(Math_fround(f38 + Math_fround(f30 * f26)) - f19);
 f32 = Math_fround(Math_fround(f38 + Math_fround(f30 * f25)) - f16);
 f30 = Math_fround(Math_fround(f38 + Math_fround(f30 * f24)) - f13);
 f27 = Math_fround(Math_fround(f37 + Math_fround(f36 * f27)) - f21);
 f26 = Math_fround(Math_fround(f37 + Math_fround(f36 * f26)) - f18);
 f25 = Math_fround(Math_fround(f37 + Math_fround(f36 * f25)) - f15);
 f24 = Math_fround(Math_fround(f37 + Math_fround(f36 * f24)) - f12);
 f26 = Math_fround(Math_fround(f35 * f35) + Math_fround(Math_fround(f34 * f34) + Math_fround(f26 * f26)));
 f25 = Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f32 * f32) + Math_fround(f25 * f25)));
 f24 = Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f30 * f30) + Math_fround(f24 * f24)));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)));
 HEAPF32[i1 + 4 >> 2] = f26;
 HEAPF32[i1 + 8 >> 2] = f25;
 HEAPF32[i1 + 12 >> 2] = f24;
 HEAPF32[i2 >> 2] = f23;
 HEAPF32[i2 + 4 >> 2] = f22;
 HEAPF32[i2 + 8 >> 2] = f21;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f20;
 HEAPF32[i2 + 20 >> 2] = f19;
 HEAPF32[i2 + 24 >> 2] = f18;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 32 >> 2] = f17;
 HEAPF32[i2 + 36 >> 2] = f16;
 HEAPF32[i2 + 40 >> 2] = f15;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 48 >> 2] = f14;
 HEAPF32[i2 + 52 >> 2] = f13;
 HEAPF32[i2 + 56 >> 2] = f12;
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEbT0_SD_T_(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 switch (i8 - i9 >> 4 | 0) {
 case 2:
  {
   i2 = i8 + -16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i3 | 0) >= (i1 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i9 >> 2] = i3;
   HEAP32[i2 >> 2] = i1;
   i7 = i9 + 4 | 0;
   i9 = i8 + -12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 3:
  {
   i6 = i9 + 16 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i8 + -16 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = (i2 | 0) < (i1 | 0);
   if ((i1 | 0) >= (i4 | 0)) {
    if (!i3) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    }
    HEAP32[i6 >> 2] = i2;
    HEAP32[i5 >> 2] = i1;
    i3 = i9 + 20 | 0;
    i1 = i8 + -12 | 0;
    HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    }
    HEAP32[i9 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
    i9 = i9 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   if (i3) {
    HEAP32[i9 >> 2] = i2;
    HEAP32[i5 >> 2] = i4;
    i7 = i9 + 4 | 0;
    i9 = i8 + -12 | 0;
    HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = i4;
   i2 = i9 + 4 | 0;
   i1 = i9 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) >= (i4 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i9 = i8 + -12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i9, i9 + 16 | 0, i9 + 32 | 0, i8 + -16 | 0, i1) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 5:
  {
   i7 = i9 + 16 | 0;
   i6 = i9 + 32 | 0;
   i5 = i9 + 48 | 0;
   __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i9, i7, i6, i5, i1) | 0;
   i1 = i8 + -16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i5 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i2 = i9 + 52 | 0;
   i4 = i8 + -12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i4 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i4 | 0) >= (i1 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i6 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i3 = i9 + 36 | 0;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i4 | 0) >= (i1 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i1;
   i2 = i9 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i4 | 0) >= (i1 | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i7 >> 2] = i1;
   i9 = i9 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i3 = i9 + 32 | 0;
   i4 = i9 + 16 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i1 = (i6 | 0) < (i2 | 0);
   do if ((i2 | 0) < (i5 | 0)) {
    if (i1) {
     HEAP32[i9 >> 2] = i6;
     HEAP32[i3 >> 2] = i5;
     i7 = i9 + 4 | 0;
     i2 = i9 + 36 | 0;
     HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i2 = i5;
     break;
    }
    HEAP32[i9 >> 2] = i2;
    HEAP32[i4 >> 2] = i5;
    i7 = i9 + 4 | 0;
    i1 = i9 + 20 | 0;
    HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    if ((i6 | 0) < (i5 | 0)) {
     HEAP32[i4 >> 2] = i6;
     HEAP32[i3 >> 2] = i5;
     i2 = i9 + 36 | 0;
     HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i2 = i5;
    } else i2 = i6;
   } else if (i1) {
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i2;
    i1 = i9 + 20 | 0;
    i7 = i9 + 36 | 0;
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    if ((i6 | 0) < (i5 | 0)) {
     HEAP32[i9 >> 2] = i6;
     HEAP32[i4 >> 2] = i5;
     i7 = i9 + 4 | 0;
     HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    }
   } else i2 = i6; while (0);
   i1 = i9 + 48 | 0;
   L13 : do if ((i1 | 0) == (i8 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i7 = i1;
    i1 = 0;
    while (1) {
     i6 = HEAP32[i7 >> 2] | 0;
     if ((i6 | 0) < (i2 | 0)) {
      i5 = i7 + 4 | 0;
      HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
      i5 = i3;
      i2 = i7;
      i4 = HEAP32[i3 >> 2] | 0;
      while (1) {
       HEAP32[i2 >> 2] = i4;
       i4 = i2 + 4 | 0;
       i2 = i5 + 4 | 0;
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       if ((i5 | 0) == (i9 | 0)) break;
       i3 = i5 + -16 | 0;
       i4 = HEAP32[i3 >> 2] | 0;
       if ((i6 | 0) >= (i4 | 0)) break; else {
        i2 = i5;
        i5 = i3;
       }
      }
      HEAP32[i5 >> 2] = i6;
      HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i7 + 16 | 0) == (i8 | 0);
       break L13;
      }
     }
     i2 = i7 + 16 | 0;
     if ((i2 | 0) == (i8 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i6 = HEAP32[i7 >> 2] | 0;
     i3 = i7;
     i7 = i2;
     i2 = i6;
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i26, i27, i29, i28, i1) {
 i2 = i2 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i29 = i29 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 424 | 0;
 i22 = i25 + 392 | 0;
 i12 = i25 + 384 | 0;
 i6 = i25 + 376 | 0;
 i21 = i25 + 16 | 0;
 i24 = i25;
 i20 = i25 + 488 | 0;
 i19 = i25 + 476 | 0;
 i18 = i25 + 472 | 0;
 i14 = i25 + 456 | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 88 >> 2] | 0, i26 | 0) | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i8 = i20;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i24 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 128, gb + 1084495 | 0, i24) | 0;
 if (HEAP8[i20 >> 0] | 0) {
  i17 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
  mftCall_iiii(i17 | 0, i28 | 0, i20 | 0, _strlen(i20) | 0) | 0;
 }
 HEAP8[i24 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i24 | 0, 1) | 0;
 i15 = i28 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 674663 | 0, HEAP32[i15 >> 2] | 0);
 i16 = i28 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i28 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i2 = i10 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = i20;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i21 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 128, gb + 1084495 | 0, i21) | 0;
 if (HEAP8[i20 >> 0] | 0) {
  i13 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
  mftCall_iiii(i13 | 0, i28 | 0, i20 | 0, _strlen(i20) | 0) | 0;
 }
 HEAP8[i21 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i21 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 773144 | 0, HEAP32[i15 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 232 >> 2] | 0, i26 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i10 + 12 >> 2] | 0;
  i2 = (i1 + -1 | 0) >>> 5;
  if (i5 | 0) {
   i4 = 0;
   while (1) {
    i1 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if ((i4 | 0) != 0 & (i4 & 7 | 0) == 0) mftCall_iiii(i1 | 0, i28 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i28 | 0, gb + 1086395 | 0, 1) | 0;
    i1 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
    i8 = i21;
    i9 = i8 + 128 | 0;
    do {
     HEAP8[i8 >> 0] = 0;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) < (i9 | 0));
    HEAP32[i6 >> 2] = i1;
    __ZN5physx6string9sprintf_sEPcjPKcz(i21, 128, gb + 1084495 | 0, i6) | 0;
    if (HEAP8[i21 >> 0] | 0) {
     i9 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
     mftCall_iiii(i9 | 0, i28 | 0, i21 | 0, _strlen(i21) | 0) | 0;
    }
    if ((i4 | 0) == (i2 | 0)) break; else i4 = i4 + 1 | 0;
   }
   HEAP8[i6 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i6 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 773163 | 0, HEAP32[i15 >> 2] | 0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i10 + 20 | 0;
  if (i1 | 0) {
   i4 = i10 + 16 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i5 | 0, i28 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i5 | 0, i28 | 0, gb + 1086395 | 0, 1) | 0;
    __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i28, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[i2 >> 2] | 0, i6) | 0) | 0) | 0;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i1 | 0));
   HEAP8[i21 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i21 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 765025 | 0, HEAP32[i15 >> 2] | 0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  }
  i7 = i13 & 65535;
  if (i7 & 2 | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i10 + 28 | 0;
   if (i1 | 0) {
    i4 = i10 + 24 | 0;
    i6 = 0;
    do {
     i5 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
     if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i5 | 0, i28 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i5 | 0, i28 | 0, gb + 1086395 | 0, 1) | 0;
     __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i28, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[i2 >> 2] | 0, i6) | 0) | 0) | 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    HEAP8[i21 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i21 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 765035 | 0, HEAP32[i15 >> 2] | 0);
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
  }
  if (i7 & 4 | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = i10 + 36 | 0;
   if (i2 | 0) {
    i5 = i10 + 32 | 0;
    i6 = 0;
    do {
     i1 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
     if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i28 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i28 | 0, gb + 1086395 | 0, 1) | 0;
     d3 = +Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i6) | 0) >> 2]);
     i8 = i21;
     i9 = i8 + 128 | 0;
     do {
      HEAP8[i8 >> 0] = 0;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     HEAPF64[i12 >> 3] = d3;
     __ZN5physx6string9sprintf_sEPcjPKcz(i21, 128, gb + 832323 | 0, i12) | 0;
     if (HEAP8[i21 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i28 | 0, i21 | 0, _strlen(i21) | 0) | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i2 | 0));
    HEAP8[i12 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i12 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 765046 | 0, HEAP32[i15 >> 2] | 0);
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
  }
  if (i7 & 8 | 0) __ZN5physx2Sn16writeStrideFlagsINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEPFRKS5_PS6_jEEEvRNS_9XmlWriterERNS_12MemoryBufferEjRNS_16PxStrideIteratorIKT_EET0_jPKcPKNS_11PxU32ToNameE(i29, i28, 6, i10 + 40 | 0, fb + 829 | 0, HEAP32[i11 >> 2] | 0, gb + 743223 | 0, gb + 115968 | 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i10 | 0);
 i1 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 196 >> 2] | 0, i26 | 0) | 0;
 i8 = i20;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i22 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 128, gb + 1084495 | 0, i22) | 0;
 if (HEAP8[i20 >> 0] | 0) {
  i12 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
  mftCall_iiii(i12 | 0, i28 | 0, i20 | 0, _strlen(i20) | 0) | 0;
 }
 HEAP8[i22 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i22 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 743229 | 0, HEAP32[i15 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 192 >> 2] | 0, i26 | 0) | 0;
 i5 = i12 & 65535;
 if (i12 << 16 >> 16) {
  i1 = HEAP32[gb + 116016 >> 2] | 0;
  if (i1 | 0) {
   i2 = gb + 116016 | 0;
   i4 = 0;
   do {
    i12 = HEAP32[gb + 116016 + (i4 << 3) + 4 >> 2] | 0;
    do if ((i12 & i5 | 0) == (i12 | 0)) {
     if (HEAP32[i17 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i12 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      mftCall_iiii(i12 | 0, i28 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i4 = i4 + 1 | 0;
    i2 = gb + 116016 + (i4 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i22 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i22 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 743242 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 i5 = i13 & 65535;
 if (i13 << 16 >> 16) {
  i1 = HEAP32[gb + 116080 >> 2] | 0;
  if (i1 | 0) {
   i2 = gb + 116080 | 0;
   i4 = 0;
   do {
    i13 = HEAP32[gb + 116080 + (i4 << 3) + 4 >> 2] | 0;
    do if ((i13 & i5 | 0) == (i13 | 0)) {
     if (HEAP32[i17 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i13 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
      mftCall_iiii(i13 | 0, i28 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i4 = i4 + 1 | 0;
    i2 = gb + 116080 + (i4 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i22 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i22 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 743260 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 136 >> 2] | 0, i26 | 0, i19 | 0, i18 | 0);
 i13 = HEAP32[i19 + 4 >> 2] | 0;
 i9 = HEAP32[i19 + 8 >> 2] | 0;
 i8 = HEAP32[i18 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 HEAP32[i14 + 8 >> 2] = i9;
 HEAP32[i14 + 12 >> 2] = i8;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i28, i14) | 0;
 mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +(HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i20;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAPF64[i23 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 128, gb + 832323 | 0, i23) | 0;
 if (HEAP8[i20 >> 0] | 0) {
  i19 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
  mftCall_iiii(i19 | 0, i28 | 0, i20 | 0, _strlen(i20) | 0) | 0;
 }
 HEAP8[i23 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i23 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0, i29 | 0, gb + 743282 | 0, HEAP32[i15 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i24 >> 2] = HEAP32[i28 + 8 >> 2];
 i1 = i24 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i20 = i24 + 12 | 0;
 HEAP32[i20 >> 2] = 0;
 i17 = i24;
 i18 = i29;
 i19 = i26;
 i26 = i28;
 i28 = i27;
 __ZN5physx29PxParticleSystemGeneratedInfoC2Ev(i21);
 HEAP32[i23 >> 2] = i17;
 HEAP32[i23 + 4 >> 2] = i18;
 HEAP32[i23 + 8 >> 2] = i19;
 HEAP32[i23 + 12 >> 2] = i26;
 HEAP32[i23 + 16 >> 2] = i28;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 0;
 i29 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j(i21, i23, 0) | 0;
 HEAP32[i22 >> 2] = i17;
 HEAP32[i22 + 4 >> 2] = i18;
 HEAP32[i22 + 8 >> 2] = i19;
 HEAP32[i22 + 12 >> 2] = i26;
 HEAP32[i22 + 16 >> 2] = i28;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 0;
 __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j(i21, i22, i29) | 0;
 i29 = HEAP32[i20 >> 2] | 0;
 if (!((i29 | 0) > -1 & (i29 & 2147483647 | 0) != 0)) {
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i29 = HEAP32[HEAP32[i24 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 12 >> 2] | 0, i29 | 0, i1 | 0);
 STACKTOP = i25;
 return;
}

function _RevoluteJointSolverPrep(i26, i21, i1, i5, i39, i6, i7) {
 i26 = i26 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i39 = i39 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i38 + 84 | 0;
 i25 = i38 + 56 | 0;
 i37 = i38 + 24 | 0;
 i22 = i38 + 12 | 0;
 i36 = i38;
 i35 = i39 + 56 | 0;
 HEAP32[i5 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
 i35 = i39 + 84 | 0;
 i29 = i39 + 132 | 0;
 i34 = (HEAP16[i29 >> 1] & 1) != 0;
 if (i34) {
  f33 = Math_fround(HEAPF32[i39 + 108 >> 2]);
  i20 = f33 >= Math_fround(HEAPF32[i39 + 104 >> 2]);
 } else i20 = 0;
 f17 = Math_fround(Math_fround(HEAPF32[i39 + 16 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i39 + 20 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i39 + 24 >> 2]) * Math_fround(2.0));
 f4 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f8 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
 f28 = Math_fround(HEAPF32[i6 >> 2]);
 f32 = Math_fround(f17 * f28);
 f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f30 * f16));
 f31 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f23 * f31));
 f3 = Math_fround(Math_fround(f28 * f32) + Math_fround(Math_fround(f17 * f8) + Math_fround(f4 * Math_fround(Math_fround(f23 * f16) - Math_fround(f30 * f31)))));
 f2 = Math_fround(Math_fround(f16 * f32) + Math_fround(Math_fround(f30 * f8) + Math_fround(f4 * Math_fround(Math_fround(f17 * f31) - Math_fround(f23 * f28)))));
 f32 = Math_fround(Math_fround(Math_fround(f23 * f8) + Math_fround(f4 * Math_fround(Math_fround(f30 * f28) - Math_fround(f17 * f16)))) + Math_fround(f31 * f32));
 i18 = i6 + 16 | 0;
 f3 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f3);
 i19 = i6 + 20 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f2);
 i12 = i6 + 24 | 0;
 f32 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f32);
 f17 = Math_fround(HEAPF32[i39 >> 2]);
 f30 = Math_fround(f4 * f17);
 f8 = Math_fround(HEAPF32[i39 + 12 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f28 * f8));
 f23 = Math_fround(HEAPF32[i39 + 8 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f16 * f23));
 f11 = Math_fround(HEAPF32[i39 + 4 >> 2]);
 f33 = Math_fround(Math_fround(Math_fround(f31 * f17) + Math_fround(Math_fround(f16 * f8) + Math_fround(f4 * f11))) - Math_fround(f28 * f23));
 f27 = Math_fround(Math_fround(Math_fround(f28 * f11) + Math_fround(Math_fround(f31 * f8) + Math_fround(f4 * f23))) - Math_fround(f16 * f17));
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f8) - Math_fround(f28 * f17)) - Math_fround(f16 * f11)) - Math_fround(f31 * f23));
 HEAPF32[i24 >> 2] = Math_fround(f30 - Math_fround(f31 * f11));
 i42 = i24 + 4 | 0;
 HEAPF32[i42 >> 2] = f33;
 i41 = i24 + 8 | 0;
 HEAPF32[i41 >> 2] = f27;
 i40 = i24 + 12 | 0;
 HEAPF32[i40 >> 2] = f23;
 i13 = i24 + 16 | 0;
 HEAPF32[i13 >> 2] = f3;
 i14 = i24 + 20 | 0;
 HEAPF32[i14 >> 2] = f2;
 i15 = i24 + 24 | 0;
 HEAPF32[i15 >> 2] = f32;
 f32 = Math_fround(Math_fround(HEAPF32[i39 + 44 >> 2]) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(HEAPF32[i39 + 48 >> 2]) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(HEAPF32[i39 + 52 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f27 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f33 = Math_fround(HEAPF32[i7 >> 2]);
 f11 = Math_fround(f32 * f33);
 f31 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f2 * f31));
 f30 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f3 * f30));
 f16 = Math_fround(Math_fround(f33 * f11) + Math_fround(Math_fround(f32 * f27) + Math_fround(f23 * Math_fround(Math_fround(f3 * f31) - Math_fround(f2 * f30)))));
 f17 = Math_fround(Math_fround(f31 * f11) + Math_fround(Math_fround(f2 * f27) + Math_fround(f23 * Math_fround(Math_fround(f32 * f30) - Math_fround(f3 * f33)))));
 f11 = Math_fround(Math_fround(Math_fround(f3 * f27) + Math_fround(f23 * Math_fround(Math_fround(f2 * f33) - Math_fround(f32 * f31)))) + Math_fround(f30 * f11));
 i9 = i7 + 16 | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f16);
 i10 = i7 + 20 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f17);
 i7 = i7 + 24 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f11);
 f32 = Math_fround(HEAPF32[i39 + 28 >> 2]);
 f2 = Math_fround(f23 * f32);
 f27 = Math_fround(HEAPF32[i39 + 40 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f33 * f27));
 f3 = Math_fround(HEAPF32[i39 + 36 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f31 * f3));
 f28 = Math_fround(HEAPF32[i39 + 32 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f30 * f28));
 f8 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(Math_fround(f31 * f27) + Math_fround(f23 * f28))) - Math_fround(f33 * f3));
 f4 = Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f30 * f27) + Math_fround(f23 * f3))) - Math_fround(f31 * f32));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f27) - Math_fround(f33 * f32)) - Math_fround(f31 * f28)) - Math_fround(f30 * f3));
 HEAPF32[i25 >> 2] = f2;
 i1 = i25 + 4 | 0;
 HEAPF32[i1 >> 2] = f8;
 i5 = i25 + 8 | 0;
 HEAPF32[i5 >> 2] = f4;
 i6 = i25 + 12 | 0;
 HEAPF32[i6 >> 2] = f3;
 HEAPF32[i25 + 16 >> 2] = f16;
 HEAPF32[i25 + 20 >> 2] = f17;
 HEAPF32[i25 + 24 >> 2] = f11;
 f30 = Math_fround(HEAPF32[i24 >> 2]);
 f28 = Math_fround(f2 * f30);
 f31 = Math_fround(HEAPF32[i42 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f8 * f31));
 f32 = Math_fround(HEAPF32[i41 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f4 * f32));
 f33 = Math_fround(HEAPF32[i40 >> 2]);
 if (Math_fround(f28 + Math_fround(f3 * f33)) < Math_fround(0.0)) {
  f28 = Math_fround(-f2);
  f8 = Math_fround(-f8);
  f23 = Math_fround(-f4);
  f27 = Math_fround(-f3);
  HEAPF32[i25 >> 2] = f28;
  HEAPF32[i1 >> 2] = f8;
  HEAPF32[i5 >> 2] = f23;
  HEAPF32[i6 >> 2] = f27;
 } else {
  f28 = f2;
  f27 = f3;
  f23 = f4;
 }
 f43 = Math_fround(f16 - Math_fround(HEAPF32[i18 >> 2]));
 f44 = Math_fround(f17 - Math_fround(HEAPF32[i19 >> 2]));
 f45 = Math_fround(f11 - Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i21 >> 2] = f43;
 HEAPF32[i21 + 4 >> 2] = f44;
 HEAPF32[i21 + 8 >> 2] = f45;
 f45 = Math_fround(f16 - Math_fround(HEAPF32[i18 >> 2]));
 f44 = Math_fround(f17 - Math_fround(HEAPF32[i19 >> 2]));
 f43 = Math_fround(f11 - Math_fround(HEAPF32[i12 >> 2]));
 f2 = Math_fround(f16 - Math_fround(HEAPF32[i9 >> 2]));
 f4 = Math_fround(f17 - Math_fround(HEAPF32[i10 >> 2]));
 f3 = Math_fround(f11 - Math_fround(HEAPF32[i7 >> 2]));
 HEAP32[i37 >> 2] = i26;
 i9 = i37 + 4 | 0;
 HEAP32[i9 >> 2] = i26;
 HEAPF32[i37 + 8 >> 2] = f45;
 HEAPF32[i37 + 12 >> 2] = f44;
 HEAPF32[i37 + 16 >> 2] = f43;
 HEAPF32[i37 + 20 >> 2] = f2;
 HEAPF32[i37 + 24 >> 2] = f4;
 HEAPF32[i37 + 28 >> 2] = f3;
 f3 = Math_fround(f16 - Math_fround(HEAPF32[i13 >> 2]));
 f4 = Math_fround(f17 - Math_fround(HEAPF32[i14 >> 2]));
 f3 = Math_fround(f3 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i15 >> 2])) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f33 * f33) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f3 * f30) + Math_fround(f4 * f31)) + Math_fround(f11 * f32));
 f16 = Math_fround(Math_fround(f31 * f43) + Math_fround(Math_fround(f4 * f2) - Math_fround(f33 * Math_fround(Math_fround(f3 * f32) - Math_fround(f11 * f30)))));
 f17 = Math_fround(Math_fround(Math_fround(f11 * f2) - Math_fround(f33 * Math_fround(Math_fround(f4 * f30) - Math_fround(f3 * f31)))) + Math_fround(f32 * f43));
 HEAPF32[i22 >> 2] = Math_fround(Math_fround(f30 * f43) + Math_fround(Math_fround(f3 * f2) - Math_fround(f33 * Math_fround(Math_fround(f11 * f31) - Math_fround(f4 * f32)))));
 HEAPF32[i22 + 4 >> 2] = f16;
 HEAPF32[i22 + 8 >> 2] = f17;
 __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i37, i24, i25, i22, 7, i20 ? 7 : 6);
 if (i20) {
  i42 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i37 >> 2] | 0) | 0;
  i42 = (i42 | 0) / 80 | 0;
  STACKTOP = i38;
  return i42 | 0;
 }
 f44 = Math_fround(f31 * Math_fround(0.0));
 f4 = Math_fround(f32 * Math_fround(0.0));
 f3 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(2.0)) + f44) + f4);
 f4 = Math_fround(Math_fround(f30 * f3) + Math_fround(Math_fround(f2 * Math_fround(2.0)) + Math_fround(f33 * Math_fround(f44 - f4))));
 f44 = Math_fround(f2 * Math_fround(0.0));
 f45 = Math_fround(f30 * Math_fround(0.0));
 f2 = Math_fround(Math_fround(f31 * f3) + Math_fround(f44 + Math_fround(f33 * Math_fround(Math_fround(f32 * Math_fround(2.0)) - f45))));
 f3 = Math_fround(Math_fround(f44 + Math_fround(f33 * Math_fround(f45 - Math_fround(f31 * Math_fround(2.0))))) + Math_fround(f32 * f3));
 HEAPF32[i36 >> 2] = f4;
 HEAPF32[i36 + 4 >> 2] = f2;
 HEAPF32[i36 + 8 >> 2] = f3;
 i6 = HEAP16[i29 >> 1] | 0;
 if (i6 & 2) {
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i7 + 80;
  HEAP16[i7 + 78 >> 1] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  f45 = Math_fround(-f2);
  f44 = Math_fround(-f3);
  HEAPF32[i7 + 16 >> 2] = Math_fround(-f4);
  HEAPF32[i7 + 20 >> 2] = f45;
  HEAPF32[i7 + 24 >> 2] = f44;
  HEAP32[i7 + 32 >> 2] = 0;
  HEAP32[i7 + 36 >> 2] = 0;
  HEAP32[i7 + 40 >> 2] = 0;
  f44 = Math_fround(HEAPF32[i39 + 80 >> 2]);
  f45 = Math_fround(-Math_fround(f2 * f44));
  f2 = Math_fround(-Math_fround(f3 * f44));
  HEAPF32[i7 + 48 >> 2] = Math_fround(-Math_fround(f4 * f44));
  HEAPF32[i7 + 52 >> 2] = f45;
  HEAPF32[i7 + 56 >> 2] = f2;
  i42 = HEAP32[i39 + 72 >> 2] | 0;
  HEAP32[i7 + 28 >> 2] = i42;
  f2 = Math_fround(HEAPF32[i39 + 76 >> 2]);
  i1 = i7 + 44 | 0;
  HEAPF32[i1 >> 2] = Math_fround(-f2);
  i5 = i7 + 60 | 0;
  HEAPF32[i5 >> 2] = f2;
  f2 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i6 & 4) {
   if (f2 > Math_fround(0.0)) HEAPF32[i1 >> 2] = Math_fround(0.0);
   if (f2 < Math_fround(0.0)) HEAPF32[i5 >> 2] = Math_fround(0.0);
  }
  i42 = i7 + 76 | 0;
  HEAP16[i42 >> 1] = HEAPU16[i42 >> 1] | 0 | 32;
 }
 if (i34) {
  f45 = Math_fround(-f30);
  f4 = Math_fround(-f31);
  f2 = Math_fround(-f32);
  f3 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(f27 * f45)) + Math_fround(f23 * f4)) - Math_fround(f8 * f2));
  f2 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f27) - Math_fround(f28 * f45)) - Math_fround(f8 * f4)) - Math_fround(f23 * f2));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(0.0)) + Math_fround(f2 * f2))));
  if (f4 != Math_fround(0.0)) {
   f45 = Math_fround(Math_fround(1.0) / f4);
   f2 = Math_fround(f2 * f45);
   f3 = Math_fround(f3 * f45);
  }
  f43 = Math_fround(f3 / Math_fround(f2 + Math_fround(1.0)));
  i42 = Math_fround(f4 + Math_fround(-9.99999997e-07)) >= Math_fround(0.0);
  f43 = i42 ? f43 : Math_fround(0.0);
  f44 = Math_fround(HEAPF32[i39 + 116 >> 2]);
  f45 = Math_fround(HEAPF32[i39 + 112 >> 2]);
  __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i37, f43, f44, f45, Math_fround(HEAPF32[i39 + 120 >> 2]), i36, i35);
 }
 i42 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i37 >> 2] | 0) | 0;
 i42 = (i42 | 0) / 80 | 0;
 STACKTOP = i38;
 return i42 | 0;
}

function __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i9, i10 + 2 | 0, i6 + 24 | 0, i7);
 i5 = i6 + 52 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj522ENS_22PxRepXPropertyAccessorILj522ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 68 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj523ENS_22PxRepXPropertyAccessorILj523ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 84 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj524ENS_22PxRepXPropertyAccessorILj524ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 100 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj525ENS_22PxRepXPropertyAccessorILj525ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj526ENS_22PxRepXPropertyAccessorILj526ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj527ENS_22PxRepXPropertyAccessorILj527ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 9 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 9 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK8GUIStyle17DrawTextSelectionER8GUIStateRK5RectTIfER10GUIContentiiRK10ColorRGBAfSA_(i21, i7, i27, i28, i29, i15, i12, i13) {
 i21 = i21 | 0;
 i7 = i7 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i38 + 40 | 0;
 i36 = i38;
 i16 = i38 + 32 | 0;
 i17 = i38 + 28 | 0;
 i18 = i38 + 24 | 0;
 i19 = i38 + 20 | 0;
 i20 = i38 + 16 | 0;
 if (!(HEAP32[i7 + 60 >> 2] | 0)) {
  STACKTOP = i38;
  return;
 }
 i35 = __ZN10builtintex15GetWhiteTextureEv() | 0;
 i1 = __ZNK8GUIStyle14GetCurrentFontEv(i21) | 0;
 do if (!i1) f34 = Math_fround(0.0); else {
  i2 = HEAP32[i21 + 284 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i1 + 36 >> 2] | 0;
   if (i3 | 0) {
    f34 = Math_fround(Math_fround(Math_fround(((i2 | 0) > 500 ? 500 : i2) | 0) * Math_fround(HEAPF32[i1 + 32 >> 2])) / Math_fround(i3 | 0));
    break;
   }
  }
  f34 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 } while (0);
 i1 = HEAP32[gb + 1468864 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i37, gb + 1017441 | 0, 30);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i37) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1468864 >> 2] = i1;
  __Z24InitializeGUIClipTexturev();
  i1 = HEAP32[gb + 1468864 >> 2] | 0;
 }
 f23 = Math_fround(HEAPF32[i7 + 252 >> 2]);
 f26 = Math_fround(HEAPF32[i7 + 256 >> 2]);
 f24 = Math_fround(HEAPF32[i7 + 260 >> 2]);
 f25 = Math_fround(HEAPF32[i7 + 264 >> 2]);
 HEAPF32[gb + 1468288 >> 2] = f23;
 HEAPF32[gb + 1468288 + 4 >> 2] = f26;
 HEAPF32[gb + 1468288 + 8 >> 2] = f24;
 HEAPF32[gb + 1468288 + 12 >> 2] = f25;
 __ZN10Matrix4x4f11SetIdentityEv(i37) | 0;
 i2 = f24 > Math_fround(0.0);
 f30 = Math_fround(Math_fround(.875) / f24);
 f30 = i2 ? f30 : Math_fround(inf);
 HEAPF32[i37 >> 2] = f30;
 i2 = f25 > Math_fround(0.0);
 f22 = Math_fround(Math_fround(.875) / f25);
 f22 = i2 ? f22 : Math_fround(inf);
 HEAPF32[i37 + 20 >> 2] = f22;
 f31 = Math_fround(Math_fround(.0625) - Math_fround(f23 * f30));
 HEAPF32[i37 + 48 >> 2] = f31;
 f32 = Math_fround(Math_fround(.0625) - Math_fround(f26 * f22));
 HEAPF32[i37 + 52 >> 2] = f32;
 HEAPF32[i37 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i37 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i37 + 56 >> 2] = Math_fround(1.0);
 i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i3 = i37;
 i6 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i6 | 0));
 f9 = Math_fround(HEAPF32[i27 >> 2]);
 f4 = Math_fround(f9 + Math_fround(HEAP32[i21 + 208 >> 2] | 0));
 f5 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f8 = Math_fround(f5 + Math_fround(HEAP32[i21 + 216 >> 2] | 0));
 i14 = i27 + 8 | 0;
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i14 >> 2]));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAP32[i21 + 212 >> 2] | 0)) - f4);
 i33 = i21 + 252 | 0;
 if (!(HEAP32[i33 >> 2] | 0)) f11 = f4; else {
  f11 = Math_fround(f5 + Math_fround(HEAPF32[i27 + 12 >> 2]));
  f9 = Math_fround(f4 + f9);
  f11 = Math_fround(f8 + Math_fround(Math_fround(f11 - Math_fround(HEAP32[i21 + 220 >> 2] | 0)) - f8));
  f39 = Math_fround(f23 + f24);
  f5 = Math_fround(f26 + f25);
  f10 = f4 < f23 ? f23 : f4;
  f8 = f8 < f26 ? f26 : f8;
  f9 = Math_fround((f9 > f39 ? f39 : f9) - f10);
  i2 = f9 < Math_fround(0.0);
  f9 = i2 ? Math_fround(0.0) : f9;
  f11 = Math_fround((f11 > f5 ? f5 : f11) - f8);
  i2 = f11 < Math_fround(0.0);
  f11 = i2 ? Math_fround(0.0) : f11;
  f4 = Math_fround(HEAPF32[i21 + 260 >> 2]);
  f4 = Math_fround(f10 + Math_fround(f4 + Math_fround(HEAPF32[i21 + 268 >> 2])));
  f10 = Math_fround(HEAPF32[i21 + 264 >> 2]);
  f10 = Math_fround(f8 + Math_fround(f10 + Math_fround(HEAPF32[i21 + 272 >> 2])));
  HEAPF32[gb + 1468288 >> 2] = f4;
  HEAPF32[gb + 1468288 + 4 >> 2] = f10;
  HEAPF32[gb + 1468288 + 8 >> 2] = f9;
  HEAPF32[gb + 1468288 + 12 >> 2] = f11;
  __ZN10Matrix4x4f11SetIdentityEv(i37) | 0;
  i2 = f9 > Math_fround(0.0);
  f8 = Math_fround(Math_fround(.875) / f9);
  f8 = i2 ? f8 : Math_fround(inf);
  HEAPF32[i37 >> 2] = f8;
  i2 = f11 > Math_fround(0.0);
  f11 = Math_fround(Math_fround(.875) / f11);
  f11 = i2 ? f11 : Math_fround(inf);
  HEAPF32[i37 + 20 >> 2] = f11;
  HEAPF32[i37 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f8 * f4));
  HEAPF32[i37 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f10 * f11));
  HEAPF32[i37 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i37 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i37 + 56 >> 2] = Math_fround(1.0);
  i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
  i3 = i37;
  i6 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i6 | 0));
  f11 = f4;
 }
 i2 = i7 + 12 | 0;
 do if ((i29 | 0) == (i15 | 0)) {
  f11 = Math_fround(HEAPF32[i12 >> 2]);
  f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 >> 2]));
  f39 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i7 + 16 >> 2]));
  f5 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 20 >> 2]));
  f4 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 24 >> 2]));
  i2 = f11 < Math_fround(0.0);
  f11 = i2 ? Math_fround(0.0) : f11;
  i2 = f11 > Math_fround(1.0);
  i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f11) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i3 = f39 < Math_fround(0.0);
  f39 = i3 ? Math_fround(0.0) : f39;
  i3 = f39 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f39) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i6 = f5 < Math_fround(0.0);
  f5 = i6 ? Math_fround(0.0) : f5;
  i6 = f5 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f5) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i7 = f4 < Math_fround(0.0);
  f4 = i7 ? Math_fround(0.0) : f4;
  i7 = f4 > Math_fround(1.0);
  i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i37, i21, i27, i28, i29);
  f4 = Math_fround(HEAPF32[i37 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i21 + 268 >> 2]));
  f5 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i21 + 272 >> 2]));
  if ((HEAP32[i28 + 4 >> 2] | 0) == (i29 | 0)) {
   f39 = Math_fround(HEAPF32[i27 >> 2]);
   if (f4 >= Math_fround(f39 + Math_fround(HEAPF32[i14 >> 2]))) f4 = Math_fround(f4 + Math_fround(-1.0));
  }
  HEAPF32[i36 >> 2] = f4;
  HEAPF32[i36 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i36 + 4 >> 2] = f5;
  HEAPF32[i36 + 12 >> 2] = f34;
  HEAP32[i16 >> 2] = i3 << 8 & 65280 | i2 & 255 | i6 << 16 & 16711680 | i7 << 24;
  HEAP32[i37 >> 2] = HEAP32[i16 >> 2];
  __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i36, i35, i37, i1, -1);
 } else {
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
  f4 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 16 >> 2]));
  f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i7 + 20 >> 2]));
  f8 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i7 + 24 >> 2]));
  i2 = f5 < Math_fround(0.0);
  f5 = i2 ? Math_fround(0.0) : f5;
  i2 = f5 > Math_fround(1.0);
  i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f5) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i3 = f4 < Math_fround(0.0);
  f4 = i3 ? Math_fround(0.0) : f4;
  i3 = f4 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i6 = f10 < Math_fround(0.0);
  f10 = i6 ? Math_fround(0.0) : f10;
  i6 = f10 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i7 = f8 < Math_fround(0.0);
  f8 = i7 ? Math_fround(0.0) : f8;
  i7 = f8 > Math_fround(1.0);
  i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i37, i21, i27, i28, (i29 | 0) < (i15 | 0) ? i29 : i15);
  f8 = Math_fround(HEAPF32[i37 >> 2]);
  i14 = i21 + 268 | 0;
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i14 >> 2]));
  f10 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  i16 = i21 + 272 | 0;
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i16 >> 2]));
  __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i37, i21, i27, i28, (i29 | 0) > (i15 | 0) ? i29 : i15);
  f4 = Math_fround(HEAPF32[i37 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i14 >> 2]));
  f5 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i16 >> 2]));
  if (f10 == f5) {
   f39 = Math_fround(Math_fround(f4 - f8) + Math_fround(1.0));
   HEAPF32[i36 >> 2] = f8;
   HEAPF32[i36 + 8 >> 2] = f39;
   HEAPF32[i36 + 4 >> 2] = f10;
   HEAPF32[i36 + 12 >> 2] = f34;
   HEAP32[i17 >> 2] = i3 << 8 & 65280 | i2 & 255 | i6 << 16 & 16711680 | i7 << 24;
   HEAP32[i37 >> 2] = HEAP32[i17 >> 2];
   __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i36, i35, i37, i1, -1);
   break;
  }
  f39 = Math_fround(Math_fround(f11 + f9) - f8);
  HEAPF32[i36 >> 2] = f8;
  HEAPF32[i36 + 8 >> 2] = f39;
  HEAPF32[i36 + 4 >> 2] = f10;
  HEAPF32[i36 + 12 >> 2] = f34;
  i2 = i3 << 8 & 65280 | i2 & 255 | i6 << 16 & 16711680 | i7 << 24;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i37 >> 2] = HEAP32[i18 >> 2];
  __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i36, i35, i37, i1, -1);
  f8 = Math_fround(f34 + f10);
  f39 = Math_fround(Math_fround(f5 - f10) - f34);
  HEAPF32[i36 >> 2] = f11;
  HEAPF32[i36 + 8 >> 2] = f9;
  HEAPF32[i36 + 4 >> 2] = f8;
  HEAPF32[i36 + 12 >> 2] = f39;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i37 >> 2] = HEAP32[i19 >> 2];
  __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i36, i35, i37, i1, -1);
  if (f4 != f11) {
   f39 = Math_fround(Math_fround(f4 - f11) + Math_fround(1.0));
   HEAPF32[i36 >> 2] = f11;
   HEAPF32[i36 + 8 >> 2] = f39;
   HEAPF32[i36 + 4 >> 2] = f5;
   HEAPF32[i36 + 12 >> 2] = f34;
   HEAP32[i20 >> 2] = i2;
   HEAP32[i37 >> 2] = HEAP32[i20 >> 2];
   __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i36, i35, i37, i1, -1);
  }
 } while (0);
 if (!(HEAP32[i33 >> 2] | 0)) {
  STACKTOP = i38;
  return;
 }
 HEAPF32[gb + 1468288 >> 2] = f23;
 HEAPF32[gb + 1468288 + 4 >> 2] = f26;
 HEAPF32[gb + 1468288 + 8 >> 2] = f24;
 HEAPF32[gb + 1468288 + 12 >> 2] = f25;
 __ZN10Matrix4x4f11SetIdentityEv(i37) | 0;
 HEAPF32[i37 >> 2] = f30;
 HEAPF32[i37 + 20 >> 2] = f22;
 HEAPF32[i37 + 48 >> 2] = f31;
 HEAPF32[i37 + 52 >> 2] = f32;
 HEAPF32[i37 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i37 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i37 + 56 >> 2] = Math_fround(1.0);
 i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i3 = i37;
 i6 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i6 | 0));
 STACKTOP = i38;
 return;
}

function __ZN5physx5cloth16TripletScheduler4warpEjj(i39, i3, i8) {
 i39 = i39 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i41 + 312 | 0;
 i2 = i41 + 308 | 0;
 i34 = i41 + 296 | 0;
 i7 = i41 + 292 | 0;
 i38 = i41 + 280 | 0;
 i10 = i41 + 176 | 0;
 i36 = i41 + 160 | 0;
 i11 = i41 + 156 | 0;
 i12 = i41 + 152 | 0;
 i26 = i41 + 48 | 0;
 i27 = i41 + 44 | 0;
 i25 = i41 + 328 | 0;
 i37 = i41 + 32 | 0;
 i28 = i41 + 28 | 0;
 i40 = i41 + 16 | 0;
 i30 = i41;
 i33 = i39 + 4 | 0;
 i1 = HEAP32[i33 >> 2] | 0;
 if (!i1) {
  STACKTOP = i41;
  return;
 }
 i31 = (HEAP32[i39 >> 2] | 0) + (i1 << 4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i35 >> 2] = 0;
 i6 = i35 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i32 = i35 + 8 | 0;
 HEAP32[i32 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i35, i3 + 1 | 0, i2);
 i1 = HEAP32[i39 >> 2] | 0;
 i5 = HEAP32[i35 >> 2] | 0;
 if ((i1 | 0) != (i31 | 0)) do {
  i29 = i5 + (HEAP32[i1 >> 2] << 2) | 0;
  HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + 1;
  i29 = i5 + (HEAP32[i1 + 4 >> 2] << 2) | 0;
  HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + 1;
  i29 = i5 + (HEAP32[i1 + 8 >> 2] << 2) | 0;
  HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + 1;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i31 | 0));
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i5 + (i3 << 2) | 0;
 if ((i3 | 0) > 1) {
  i2 = i5 + 4 | 0;
  i1 = i5;
  do {
   i1 = (HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 ? i2 : i1;
   i2 = i2 + 4 | 0;
  } while (i2 >>> 0 < i4 >>> 0);
 } else i1 = i5;
 i13 = HEAP32[i1 >> 2] | 0;
 if (!i3) i1 = 0; else if ((i3 | 0) == 1) i1 = 1; else {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i5;
  do {
   i3 = i3 + 4 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   HEAP32[i3 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i1 = HEAP32[i5 + (i1 + -1 << 2) >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 i29 = i34 + 8 | 0;
 HEAP32[i29 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i34, i1, i7);
 i1 = HEAP32[i39 >> 2] | 0;
 if ((i1 | 0) != (i31 | 0)) {
  i3 = HEAP32[i35 >> 2] | 0;
  i4 = HEAP32[i34 >> 2] | 0;
  i2 = 0;
  while (1) {
   i23 = i3 + (HEAP32[i1 >> 2] << 2) | 0;
   i24 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
   HEAP32[i23 >> 2] = i24;
   HEAP32[i4 + (i24 << 2) >> 2] = i2;
   i24 = i3 + (HEAP32[i1 + 4 >> 2] << 2) | 0;
   i23 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
   HEAP32[i24 >> 2] = i23;
   HEAP32[i4 + (i23 << 2) >> 2] = i2;
   i23 = i3 + (HEAP32[i1 + 8 >> 2] << 2) | 0;
   i24 = (HEAP32[i23 >> 2] | 0) + -1 | 0;
   HEAP32[i23 >> 2] = i24;
   HEAP32[i4 + (i24 << 2) >> 2] = i2;
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i31 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 i21 = i8 + -1 | 0;
 HEAP32[i10 >> 2] = -1;
 HEAP8[i10 + 6 >> 0] = 1;
 HEAP8[i10 + 5 >> 0] = 1;
 HEAP8[i10 + 4 >> 0] = 1;
 i8 = i10 + 7 | 0;
 i9 = i8 + 96 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i38 >> 2] = 0;
 i22 = i38 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i24 = i38 + 8 | 0;
 HEAP32[i24 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE6resizeEjRKS3_(i38, i13, i10);
 i1 = HEAP32[i33 >> 2] | 0;
 HEAP32[i11 >> 2] = -1;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 4 >> 2] = 0;
 i23 = i36 + 8 | 0;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i36, i1, i11);
 i1 = i39 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i1, i13, i12);
 i15 = HEAP32[i34 >> 2] | 0;
 i3 = HEAP32[i39 >> 2] | 0;
 if ((i3 | 0) == (i31 | 0)) i2 = i39 + 16 | 0; else {
  i16 = i26 + 6 | 0;
  i17 = i26 + 5 | 0;
  i18 = i26 + 4 | 0;
  i19 = i26 + 7 | 0;
  i20 = i39 + 20 | 0;
  i2 = i39 + 16 | 0;
  i8 = HEAP32[i36 >> 2] | 0;
  i14 = 0;
  while (1) {
   i7 = HEAP32[i35 >> 2] | 0;
   i12 = HEAP32[i38 >> 2] | 0;
   i11 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i7 + (i11 << 2) >> 2] | 0;
   i11 = HEAP32[i7 + (i11 + 1 << 2) >> 2] | 0;
   i6 = i15 + (i11 << 2) | 0;
   if ((i4 | 0) != (i11 | 0)) {
    i5 = i15 + (i4 << 2) | 0;
    do {
     i4 = HEAP32[i8 + (HEAP32[i5 >> 2] << 2) >> 2] | 0;
     if (i13 >>> 0 > i4 >>> 0) HEAP32[i12 + (i4 * 104 | 0) >> 2] = i14;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) != (i6 | 0));
   }
   i11 = i3 + 4 | 0;
   i10 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i7 + (i10 << 2) >> 2] | 0;
   i10 = HEAP32[i7 + (i10 + 1 << 2) >> 2] | 0;
   i6 = i15 + (i10 << 2) | 0;
   if ((i4 | 0) != (i10 | 0)) {
    i5 = i15 + (i4 << 2) | 0;
    do {
     i4 = HEAP32[i8 + (HEAP32[i5 >> 2] << 2) >> 2] | 0;
     if (i13 >>> 0 > i4 >>> 0) HEAP32[i12 + (i4 * 104 | 0) >> 2] = i14;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) != (i6 | 0));
   }
   i10 = i3 + 8 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i7 + (i9 << 2) >> 2] | 0;
   i9 = HEAP32[i7 + (i9 + 1 << 2) >> 2] | 0;
   i6 = i15 + (i9 << 2) | 0;
   if ((i4 | 0) != (i9 | 0)) {
    i5 = i15 + (i4 << 2) | 0;
    do {
     i4 = HEAP32[i8 + (HEAP32[i5 >> 2] << 2) >> 2] | 0;
     if (i13 >>> 0 > i4 >>> 0) HEAP32[i12 + (i4 * 104 | 0) >> 2] = i14;
     i5 = i5 + 4 | 0;
    } while ((i5 | 0) != (i6 | 0));
   }
   if (!i13) i7 = 0; else {
    i4 = i13;
    i5 = 4;
    i6 = 0;
    do {
     if ((HEAP32[i12 + (i6 * 104 | 0) >> 2] | 0) != (i14 | 0)) {
      i9 = ((HEAP8[i12 + (i6 * 104 | 0) + 6 >> 0] | 0) == (HEAP8[(HEAP32[i10 >> 2] & i21) + (i12 + (i6 * 104 | 0) + 71) >> 0] | 0) & 1) + (((HEAP8[i12 + (i6 * 104 | 0) + 5 >> 0] | 0) == (HEAP8[(HEAP32[i11 >> 2] & i21) + (i12 + (i6 * 104 | 0) + 39) >> 0] | 0) & 1) + ((HEAP8[i12 + (i6 * 104 | 0) + 4 >> 0] | 0) == (HEAP8[(HEAP32[i3 >> 2] & i21) + (i12 + (i6 * 104 | 0) + 7) >> 0] | 0) & 1)) | 0;
      i8 = i5 >>> 0 > i9 >>> 0;
      i4 = i8 ? i6 : i4;
      i5 = i8 ? i9 : i5;
     }
     i6 = i6 + 1 | 0;
    } while ((i5 | 0) != 0 & i6 >>> 0 < i13 >>> 0);
    i7 = i4;
   }
   if ((i7 | 0) == (i13 | 0)) {
    HEAP32[i26 >> 2] = -1;
    HEAP8[i16 >> 0] = 1;
    HEAP8[i17 >> 0] = 1;
    HEAP8[i18 >> 0] = 1;
    i8 = i19;
    i9 = i8 + 96 | 0;
    do {
     HEAP8[i8 >> 0] = 0;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) < (i9 | 0));
    i4 = HEAP32[i22 >> 2] | 0;
    if ((HEAP32[i24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     i8 = i12 + (i4 * 104 | 0) | 0;
     i5 = i26;
     i9 = i8 + 104 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
      i8 = i8 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i8 | 0) < (i9 | 0));
     HEAP32[i22 >> 2] = i4 + 1;
    } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE15growAndPushBackERKS3_(i38, i26) | 0;
    HEAP32[i27 >> 2] = 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i20 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 << 2) >> 2] = 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj(i1, i27) | 0;
    i6 = i13 + 1 | 0;
    i4 = HEAP32[i38 >> 2] | 0;
   } else {
    i6 = i13;
    i4 = i12;
   }
   i12 = (HEAP32[i1 >> 2] | 0) + (i7 << 2) | 0;
   i13 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
   HEAP32[i12 >> 2] = i13;
   if (!(i13 & i21)) {
    i8 = i25;
    i9 = i8 + 96 | 0;
    do {
     HEAP8[i8 >> 0] = 0;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) < (i9 | 0));
    HEAP32[i4 + (i7 * 104 | 0) >> 2] = -1;
    HEAP8[i4 + (i7 * 104 | 0) + 4 >> 0] = 1;
    HEAP8[i4 + (i7 * 104 | 0) + 5 >> 0] = 1;
    HEAP8[i4 + (i7 * 104 | 0) + 6 >> 0] = 1;
    i8 = i4 + (i7 * 104 | 0) + 7 | 0;
    i5 = i25;
    i9 = i8 + 96 | 0;
    do {
     HEAP8[i8 >> 0] = HEAP8[i5 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i5 = i5 + 1 | 0;
    } while ((i8 | 0) < (i9 | 0));
   } else {
    i13 = i4 + (i7 * 104 | 0) + 4 | 0;
    i12 = HEAP8[i13 >> 0] | 0;
    i8 = (HEAP32[i3 >> 2] & i21) + (i4 + (i7 * 104 | 0) + 7) | 0;
    i9 = (HEAP8[i8 >> 0] | 0) + 1 << 24 >> 24;
    HEAP8[i8 >> 0] = i9;
    HEAP8[i13 >> 0] = (i12 & 255) < (i9 & 255) ? i9 : i12;
    i13 = i4 + (i7 * 104 | 0) + 5 | 0;
    i12 = HEAP8[i13 >> 0] | 0;
    i9 = (HEAP32[i11 >> 2] & i21) + (i4 + (i7 * 104 | 0) + 39) | 0;
    i11 = (HEAP8[i9 >> 0] | 0) + 1 << 24 >> 24;
    HEAP8[i9 >> 0] = i11;
    HEAP8[i13 >> 0] = (i12 & 255) < (i11 & 255) ? i11 : i12;
    i13 = i4 + (i7 * 104 | 0) + 6 | 0;
    i12 = HEAP8[i13 >> 0] | 0;
    i10 = (HEAP32[i10 >> 2] & i21) + (i4 + (i7 * 104 | 0) + 71) | 0;
    i11 = (HEAP8[i10 >> 0] | 0) + 1 << 24 >> 24;
    HEAP8[i10 >> 0] = i11;
    HEAP8[i13 >> 0] = (i12 & 255) < (i11 & 255) ? i11 : i12;
   }
   i8 = HEAP32[i36 >> 2] | 0;
   HEAP32[i8 + (i14 << 2) >> 2] = i7;
   i3 = i3 + 16 | 0;
   if ((i3 | 0) == (i31 | 0)) break; else {
    i13 = i6;
    i14 = i14 + 1 | 0;
   }
  }
 }
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 i8 = i37 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i37, i3, i28);
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + (i2 << 2) | 0;
 i1 = HEAP32[i37 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  if ((i2 | 0) != 1) {
   i3 = i3 + 4 | 0;
   i2 = i4;
   do {
    i1 = i1 + 4 | 0;
    i2 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
    HEAP32[i1 >> 2] = i2;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) != (i5 | 0));
  }
 }
 i1 = HEAP32[i33 >> 2] | 0;
 HEAP32[i40 >> 2] = 0;
 i6 = i40 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i40 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE6resizeEjRKS4_(i40, i1, i30);
 i1 = HEAP32[i39 >> 2] | 0;
 if ((i1 | 0) == (i31 | 0)) {
  i3 = i40;
  i4 = i39;
  i2 = HEAP32[i40 >> 2] | 0;
 } else {
  i3 = HEAP32[i37 >> 2] | 0;
  i4 = HEAP32[i40 >> 2] | 0;
  i2 = i4;
  i5 = HEAP32[i36 >> 2] | 0;
  while (1) {
   i28 = i3 + (HEAP32[i5 >> 2] << 2) | 0;
   i30 = (HEAP32[i28 >> 2] | 0) + -1 | 0;
   HEAP32[i28 >> 2] = i30;
   i30 = i4 + (i30 << 4) | 0;
   HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i31 | 0)) break; else i5 = i5 + 4 | 0;
  }
  i3 = i40;
  i4 = i39;
  i1 = HEAP32[i39 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i31 = HEAP32[i33 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i31;
 i33 = i39 + 8 | 0;
 i39 = HEAP32[i33 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i39;
 if ((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i40, i1);
 i40 = HEAP32[i8 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i37, HEAP32[i37 >> 2] | 0);
 i40 = HEAP32[i23 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i36, HEAP32[i36 >> 2] | 0);
 i40 = HEAP32[i24 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, HEAP32[i38 >> 2] | 0);
 i40 = HEAP32[i29 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i34, HEAP32[i34 >> 2] | 0);
 i40 = HEAP32[i32 >> 2] | 0;
 if (!((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0)) {
  STACKTOP = i41;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i35, HEAP32[i35 >> 2] | 0);
 STACKTOP = i41;
 return;
}

function __Z18ClipAnimationCurveI11QuaternionfEbRK17AnimationCurveTplIT_ERS3_ff(i1, i21, f20, f5) {
 i1 = i1 | 0;
 i21 = i21 | 0;
 f20 = Math_fround(f20);
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i25;
 i22 = i25 + 52 | 0;
 HEAP32[i22 >> 2] = 0;
 i19 = i22 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i23 = i22 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 63664 | 0);
 i18 = i17;
 i8 = HEAP32[i18 + 4 >> 2] | 0;
 i15 = i24;
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = i8;
 i15 = i1 + 164 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 if (!i8) i1 = 0; else {
  i18 = i1 + 152 | 0;
  i11 = HEAP32[i18 >> 2] | 0;
  if ((HEAP32[i11 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
   i2 = i8 + -1 | 0;
   if ((HEAP32[i11 + (i2 * 52 | 0) >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
    f4 = Math_fround(HEAPF32[i11 >> 2]);
    i1 = HEAP32[i11 + (i2 * 52 | 0) >> 2] | 0;
    if (f4 > f20) f14 = f4; else {
     f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = f14 < f20 ? f14 : f20;
    }
    if (f4 > f5) f16 = f4; else {
     f16 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f16 = f16 < f5 ? f16 : f5;
    }
    i9 = (i8 * 52 | 0) / 52 | 0;
    i7 = i11;
    i1 = i9;
    L11 : while (1) {
     while (1) {
      if (!i1) break L11;
      i3 = (i1 | 0) / 2 | 0;
      i6 = i7 + (i3 * 52 | 0) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f14) break; else i1 = i3;
     }
     i7 = i6 + 52 | 0;
     i1 = i1 + -1 - i3 | 0;
    }
    i8 = i11 + (i8 * 52 | 0) | 0;
    if ((i7 | 0) == (i8 | 0)) i13 = i2; else {
     i12 = (i7 - i11 | 0) / 52 | 0;
     i13 = i12 + -1 | 0;
     i13 = (i13 | 0) < 0 ? 0 : i13;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f14)));
     i10 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i13 * 52 | 0) >> 2]) - f14)));
     i13 = i10 ? i12 : i13;
    }
    i7 = i11;
    i1 = i9;
    L21 : while (1) {
     while (1) {
      if (!i1) break L21;
      i3 = (i1 | 0) / 2 | 0;
      i6 = i7 + (i3 * 52 | 0) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f16) break; else i1 = i3;
     }
     i7 = i6 + 52 | 0;
     i1 = i1 + -1 - i3 | 0;
    }
    if ((i7 | 0) != (i8 | 0)) {
     i12 = (i7 - i11 | 0) / 52 | 0;
     i2 = i12 + -1 | 0;
     i2 = (i2 | 0) < 0 ? 0 : i2;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f16)));
     i10 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i2 * 52 | 0) >> 2]) - f16)));
     i2 = i10 ? i12 : i2;
    }
    f5 = Math_fround(f14 - f16);
    i12 = f5 < Math_fround(0.0);
    f4 = Math_fround(-f5);
    if (!((i12 ? f4 : f5) <= Math_fround(.00100000005))) {
     i1 = i2 - i13 | 0;
     i1 = ((i1 | 0) < 0 ? 0 : i1) + 3 | 0;
     if (!i1) {
      i10 = 0;
      i3 = 0;
     } else {
      HEAP32[i23 >> 2] = i1;
      i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i22 >> 2] = i3;
      i10 = i3;
      i11 = HEAP32[i18 >> 2] | 0;
     }
     i9 = i11 + (i13 * 52 | 0) | 0;
     f5 = Math_fround(f14 - Math_fround(HEAPF32[i9 >> 2]));
     i12 = f5 < Math_fround(0.0);
     f4 = Math_fround(-f5);
     if (!((i12 ? f4 : f5) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i15 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i11 >> 2]);
       f5 = Math_fround(HEAPF32[i11 + ((i8 + -1 | 0) * 52 | 0) >> 2]);
      }
      if (!(f4 >= f14) & !(f5 <= f14)) {
       i7 = i11;
       i1 = (i8 * 52 | 0) / 52 | 0;
       L42 : while (1) {
        while (1) {
         if (!i1) break L42;
         i3 = (i1 | 0) / 2 | 0;
         i6 = i7 + (i3 * 52 | 0) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f14) break; else i1 = i3;
        }
        i7 = i6 + 52 | 0;
        i1 = i1 + -1 - i3 | 0;
       }
       i12 = ((i7 - i11 | 0) / 52 | 0) + -1 | 0;
       i1 = i8 + -2 | 0;
       i1 = (i12 | 0) < (i1 | 0) ? i12 : i1;
       i1 = (i1 | 0) > 0 ? i1 : 0;
      } else i1 = -1;
      __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f(i17, i11 + (i1 * 52 | 0) | 0, i11 + ((i1 + 1 | 0) * 52 | 0) | 0, f14);
      i7 = HEAP32[i19 >> 2] | 0;
      i8 = i7 + 1 | 0;
      i3 = HEAP32[i23 >> 2] | 0;
      i6 = i3 & 2147483647;
      do if (i8 >>> 0 > i6 >>> 0) {
       i1 = i3 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i6 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
        HEAP32[i23 >> 2] = i1;
        HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 52 | 0) | 0;
        HEAP32[i23 >> 2] = i1;
        HEAP32[i22 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i19 >> 2] = i8;
      i3 = HEAP32[i22 >> 2] | 0;
      i7 = i3 + (i7 * 52 | 0) | 0;
      i9 = i17;
      i6 = i7 + 52 | 0;
      do {
       HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
       i7 = i7 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i7 | 0) < (i6 | 0));
      i1 = HEAP32[i18 >> 2] | 0;
      if (f14 > Math_fround(HEAPF32[i1 + (i13 * 52 | 0) >> 2])) {
       i13 = i13 + 1 | 0;
       i12 = i1;
       i11 = i8;
       i10 = i3;
      } else {
       i12 = i1;
       i11 = i8;
       i10 = i3;
      }
     } else {
      i8 = HEAP32[i19 >> 2] | 0;
      i11 = i8 + 1 | 0;
      i6 = HEAP32[i23 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i11 >>> 0 > i7 >>> 0) {
       i1 = i6 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i23 >> 2] = i1;
        i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i1 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i22 >> 2] = i10;
        i3 = i10;
        break;
       } else {
        i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i10 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 52 | 0) | 0;
        HEAP32[i23 >> 2] = i1;
        HEAP32[i22 >> 2] = i10;
        i3 = i10;
        break;
       }
      } while (0);
      HEAP32[i19 >> 2] = i11;
      i7 = i3 + (i8 * 52 | 0) | 0;
      i6 = i7 + 52 | 0;
      do {
       HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
       i7 = i7 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i7 | 0) < (i6 | 0));
      i13 = i13 + 1 | 0;
      i12 = HEAP32[i18 >> 2] | 0;
     }
     i9 = i12 + (i2 * 52 | 0) | 0;
     f14 = Math_fround(f16 - Math_fround(HEAPF32[i9 >> 2]));
     i8 = f14 < Math_fround(0.0);
     f5 = Math_fround(-f14);
     if (!((i8 ? f5 : f14) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i15 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i12 >> 2]);
       f5 = Math_fround(HEAPF32[i12 + ((i8 + -1 | 0) * 52 | 0) >> 2]);
      }
      if (!(f4 >= f16) & !(f5 <= f16)) {
       i7 = i12;
       i1 = (i8 * 52 | 0) / 52 | 0;
       L74 : while (1) {
        while (1) {
         if (!i1) break L74;
         i3 = (i1 | 0) / 2 | 0;
         i6 = i7 + (i3 * 52 | 0) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f16) break; else i1 = i3;
        }
        i7 = i6 + 52 | 0;
        i1 = i1 + -1 - i3 | 0;
       }
       i15 = ((i7 - i12 | 0) / 52 | 0) + -1 | 0;
       i1 = i8 + -2 | 0;
       i1 = (i15 | 0) < (i1 | 0) ? i15 : i1;
       i1 = (i1 | 0) > 0 ? i1 : 0;
      } else i1 = -1;
      __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f(i17, i12 + (i1 * 52 | 0) | 0, i12 + ((i1 + 1 | 0) * 52 | 0) | 0, f16);
      i8 = HEAP32[i19 >> 2] | 0;
      i1 = i8 + 1 | 0;
      i6 = HEAP32[i23 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i1 >>> 0 > i7 >>> 0) {
       i3 = i6 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i23 >> 2] = i3;
        HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i3 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i15 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 52 | 0) | 0;
        HEAP32[i23 >> 2] = i3;
        HEAP32[i22 >> 2] = i15;
        break;
       }
      } while (0);
      HEAP32[i19 >> 2] = i1;
      i3 = HEAP32[i22 >> 2] | 0;
      i7 = i3 + (i8 * 52 | 0) | 0;
      i9 = i17;
      i6 = i7 + 52 | 0;
      do {
       HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
       i7 = i7 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i7 | 0) < (i6 | 0));
      if (f16 > Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + (i2 * 52 | 0) >> 2])) i2 = i2 + 1 | 0;
     } else {
      i1 = i11 + 1 | 0;
      i7 = HEAP32[i23 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i1 >>> 0 > i8 >>> 0) {
       i6 = i7 << 1;
       i6 = (i6 | 0) == 0 ? 1 : i6;
       if (i8 >>> 0 < i6 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i23 >> 2] = i6;
        i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i6 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i22 >> 2] = i3;
        break;
       } else {
        i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 52 | 0, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i3 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 52 | 0) | 0;
        HEAP32[i23 >> 2] = i6;
        HEAP32[i22 >> 2] = i3;
        break;
       }
      } while (0);
      HEAP32[i19 >> 2] = i1;
      i7 = i3 + (i11 * 52 | 0) | 0;
      i6 = i7 + 52 | 0;
      do {
       HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
       i7 = i7 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i7 | 0) < (i6 | 0));
     }
     if ((i2 | 0) > (i13 | 0)) {
      i1 = HEAP32[i18 >> 2] | 0;
      __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EE6insertEPS2_PKS2_S6_(i22, i3 + 52 | 0, i1 + (i13 * 52 | 0) | 0, i1 + (i2 * 52 | 0) | 0) | 0;
      i1 = HEAP32[i19 >> 2] | 0;
      i3 = HEAP32[i22 >> 2] | 0;
     }
     if (!i1) i1 = 0; else {
      i2 = 0;
      do {
       i19 = i3 + (i2 * 52 | 0) | 0;
       HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f20);
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     __ZN17AnimationCurveTplI11QuaternionfE6AssignEPK11KeyframeTplIS0_ES5_(i21, i3, i3 + (i1 * 52 | 0) | 0);
     HEAPF32[i21 + 4 >> 2] = Math_fround(inf);
     HEAP32[i21 >> 2] = 0;
     HEAPF32[i21 + 80 >> 2] = Math_fround(inf);
     HEAP32[i21 + 76 >> 2] = 0;
     i2 = HEAP32[i21 + 164 >> 2] | 0;
     if (!i2) i1 = 0; else {
      i1 = HEAP32[i21 + 152 >> 2] | 0;
      if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else i1 = (HEAP32[i1 + ((i2 + -1 | 0) * 52 | 0) >> 2] & 2139095040 | 0) != 2139095040;
     }
    } else i1 = 0;
   }
  }
 }
 if ((HEAP32[i23 >> 2] | 0) <= -1) {
  STACKTOP = i25;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i24);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i25;
 return i1 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI25CapsuleTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i17, i8, i9, i56, i10) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i56 = i56 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i59 + 216 | 0;
 i53 = i59 + 24 | 0;
 i58 = i59 + 48 | 0;
 i11 = i59 + 8 | 0;
 i13 = i59 + 4 | 0;
 i12 = i59;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i17, i53);
 f28 = Math_fround(HEAPF32[i53 >> 2]);
 f45 = Math_fround(HEAPF32[i10 >> 2]);
 f28 = Math_fround(f28 - f45);
 i55 = i53 + 4 | 0;
 f29 = Math_fround(HEAPF32[i55 >> 2]);
 i7 = i10 + 4 | 0;
 f32 = Math_fround(HEAPF32[i7 >> 2]);
 f29 = Math_fround(f29 - f32);
 i54 = i53 + 8 | 0;
 f30 = Math_fround(HEAPF32[i54 >> 2]);
 i14 = i10 + 8 | 0;
 f31 = Math_fround(HEAPF32[i14 >> 2]);
 f30 = Math_fround(f30 - f31);
 HEAPF32[i53 >> 2] = f28;
 HEAPF32[i55 >> 2] = f29;
 HEAPF32[i54 >> 2] = f30;
 i54 = i53 + 12 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) + f45);
 i55 = i53 + 16 | 0;
 f32 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) + f32);
 i16 = i53 + 20 | 0;
 f31 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f31);
 HEAPF32[i54 >> 2] = f45;
 HEAPF32[i55 >> 2] = f32;
 HEAPF32[i16 >> 2] = f31;
 i16 = i17 + 12 | 0;
 i55 = HEAP32[i16 >> 2] | 0;
 HEAP8[i58 >> 0] = 0;
 i1 = i58 + 4 | 0;
 HEAP32[i1 >> 2] = i17;
 i2 = i58 + 8 | 0;
 HEAP32[i2 >> 2] = i55;
 i55 = i58 + 156 | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i58 + 160 >> 2] = 0;
 f31 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(f31 - Math_fround(HEAPF32[i8 >> 2]));
 i3 = i9 + 4 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i8 + 4 | 0;
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i4 >> 2]));
 i15 = i9 + 8 | 0;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 i5 = i8 + 8 | 0;
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i11 >> 2] = f31;
 HEAPF32[i11 + 4 >> 2] = f32;
 i6 = i11 + 8 | 0;
 HEAPF32[i6 >> 2] = f45;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i53, i54, i8, i11, Math_fround(1.0), i13, i12) | 0)) {
  STACKTOP = i59;
  return;
 }
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f28 = Math_fround(HEAPF32[i11 >> 2]);
 f23 = Math_fround(f24 * f28);
 f31 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(f24 * f31);
 f45 = Math_fround(HEAPF32[i8 >> 2]);
 f23 = Math_fround(f23 + f45);
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(f24 + f25);
 f30 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(f45 + Math_fround(f28 * f30));
 f30 = Math_fround(f25 + Math_fround(f31 * f30));
 f31 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround((f31 < f22 ? f31 : f22) - f18);
 i51 = HEAP32[i1 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 HEAPF32[i58 + 24 >> 2] = Math_fround(f19 * f29);
 HEAPF32[i58 + 28 >> 2] = Math_fround(Math_fround(f18 + (f31 > f22 ? f31 : f22)) * f29);
 i52 = HEAP32[i2 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i9 >> 2]);
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f31 = Math_fround((f29 < f45 ? f29 : f45) - f22);
 f18 = Math_fround(HEAPF32[i51 >> 2]);
 i50 = ~~Math_fround(Math_floor(Math_fround(f18 * f31)));
 i49 = HEAP32[i52 + 16 >> 2] | 0;
 i53 = i49 + -2 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i54 = i58 + 32 | 0;
 HEAP32[i54 >> 2] = (i50 | 0) > (i53 | 0) ? i53 : i50;
 i50 = ~~Math_fround(Math_ceil(Math_fround(f18 * Math_fround(f22 + (f29 > f45 ? f29 : f45)))));
 i49 = i49 + -1 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i53 = i58 + 36 | 0;
 HEAP32[i53 >> 2] = (i50 | 0) > (i49 | 0) ? i49 : i50;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i14 >> 2]);
 f31 = Math_fround((f45 < f25 ? f45 : f25) - f29);
 f19 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 i51 = ~~Math_fround(Math_floor(Math_fround(f19 * f31)));
 i52 = HEAP32[i52 + 20 >> 2] | 0;
 i50 = i52 + -2 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i49 = i58 + 40 | 0;
 HEAP32[i49 >> 2] = (i51 | 0) > (i50 | 0) ? i50 : i51;
 i51 = ~~Math_fround(Math_ceil(Math_fround(f19 * Math_fround(f29 + (f45 > f25 ? f45 : f25)))));
 i52 = i52 + -1 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i50 = i58 + 44 | 0;
 HEAP32[i50 >> 2] = (i51 | 0) > (i52 | 0) ? i52 : i51;
 f18 = Math_fround(Math_ceil(Math_fround(f22 * f18)));
 f19 = Math_fround(Math_ceil(Math_fround(f29 * f19)));
 i51 = i58 + 16 | 0;
 HEAP32[i51 >> 2] = ~~f18 + 1;
 i52 = i58 + 20 | 0;
 HEAP32[i52 >> 2] = ~~f19 + 1;
 i3 = HEAP32[i16 >> 2] | 0;
 i48 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i17 >> 2]);
 f22 = Math_fround(Math_fround(i3 + -1 | 0) * Math_fround(.99999988));
 f25 = Math_fround(Math_fround(i48 + -1 | 0) * Math_fround(.99999988));
 f23 = Math_fround(f23 * f29);
 f45 = Math_fround(Math_fround(1.00000001e-07) - f18);
 f23 = f23 > f45 ? f23 : f45;
 f22 = Math_fround(f18 + f22);
 f23 = f23 < f22 ? f23 : f22;
 f31 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f24 = Math_fround(f24 * f31);
 f32 = Math_fround(Math_fround(1.00000001e-07) - f19);
 f24 = f24 > f32 ? f24 : f32;
 f25 = Math_fround(f19 + f25);
 f24 = f24 < f25 ? f24 : f25;
 f29 = Math_fround(f28 * f29);
 f45 = f29 > f45 ? f29 : f45;
 f31 = Math_fround(f30 * f31);
 f32 = f31 > f32 ? f31 : f32;
 f22 = Math_fround((f45 < f22 ? f45 : f22) - f23);
 f25 = Math_fround((f32 < f25 ? f32 : f25) - f24);
 i46 = f22 >= Math_fround(0.0);
 f32 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = f25 >= Math_fround(0.0);
 f45 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = ~~f32;
 i47 = ~~f45;
 i1 = Math_fround(Math_abs(Math_fround(f22))) < Math_fround(1.00000001e-10);
 f32 = Math_fround(f32 * Math_fround(1.00000001e-10));
 f22 = i1 ? f32 : f22;
 i1 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(1.00000001e-10);
 f45 = Math_fround(f45 * Math_fround(1.00000001e-10));
 f25 = i1 ? f45 : f25;
 i1 = f22 > Math_fround(0.0);
 if (i1) f26 = Math_fround(Math_floor(Math_fround(f23))); else f26 = Math_fround(Math_ceil(Math_fround(f23)));
 i2 = f25 > Math_fround(0.0);
 if (i2) f27 = Math_fround(Math_floor(Math_fround(f24))); else f27 = Math_fround(Math_ceil(Math_fround(f24)));
 if (i1) {
  f20 = Math_fround(Math_ceil(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(1.0));
  f20 = f20 == f23 ? f45 : f20;
 } else {
  f20 = Math_fround(Math_floor(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(-1.0));
  f20 = f20 == f23 ? f45 : f20;
 }
 if (i2) {
  f21 = Math_fround(Math_ceil(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(1.0));
  f21 = f21 == f24 ? f45 : f21;
 } else {
  f21 = Math_fround(Math_floor(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(-1.0));
  f21 = f21 == f24 ? f45 : f21;
 }
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f22))));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f25))));
 i15 = i58 + 12 | 0;
 i16 = i58 + 48 | 0;
 i17 = ((i46 | 0) < 1) << 31 >> 31;
 i33 = i58 + 52 | 0;
 i34 = ((i47 | 0) < 1) << 31 >> 31;
 i35 = i58 + 56 | 0;
 i36 = i58 + 76 | 0;
 i37 = i58 + 80 | 0;
 i38 = i58 + 84 | 0;
 i39 = i58 + 88 | 0;
 i40 = i58 + 60 | 0;
 i41 = i58 + 64 | 0;
 i42 = i58 + 68 | 0;
 i43 = i58 + 72 | 0;
 i44 = i58 + 92 | 0;
 f45 = Math_fround(Math_fround(0.0) - f18);
 f29 = Math_fround(f18 + Math_fround(i3 | 0));
 f30 = Math_fround(Math_fround(0.0) - f19);
 f28 = Math_fround(f19 + Math_fround(i48 | 0));
 i10 = i58 + 76 | 0;
 i11 = i58 + 60 | 0;
 i12 = i57 + 4 | 0;
 i13 = i57 + 8 | 0;
 i14 = i57 + 12 | 0;
 f18 = Math_fround(Math_fround(f20 - f23) / f22);
 f19 = Math_fround(Math_fround(f21 - f24) / f25);
 i9 = ~~f26;
 i2 = ~~f27;
 L20 : while (1) {
  i8 = f18 < f19;
  f20 = i8 ? f18 : f19;
  if (!(HEAP8[i58 >> 0] | 0)) {
   HEAP8[i58 >> 0] = 1;
   HEAP32[i15 >> 2] = i56;
   HEAP32[i16 >> 2] = i48;
   HEAP32[i33 >> 2] = i17;
   HEAP32[i35 >> 2] = i34;
   HEAP32[i36 >> 2] = 1;
   HEAP32[i37 >> 2] = -1;
   HEAP32[i38 >> 2] = 1;
   HEAP32[i39 >> 2] = -1;
   i4 = HEAP32[i51 >> 2] | 0;
   i5 = i9 - i4 | 0;
   HEAP32[i40 >> 2] = i5;
   i4 = i4 + i9 | 0;
   HEAP32[i41 >> 2] = i4;
   i1 = HEAP32[i52 >> 2] | 0;
   HEAP32[i42 >> 2] = i2 - i1;
   i1 = i1 + i2 | 0;
   HEAP32[i43 >> 2] = i1;
   i5 = i17 + i5 | 0;
   if ((i5 | 0) > (i4 + i17 | 0)) i1 = i56; else {
    i3 = i34;
    i7 = i17;
    while (1) {
     if ((i5 | 0) < (HEAP32[i54 >> 2] | 0)) i6 = i7; else {
      if ((i5 | 0) >= (HEAP32[i53 >> 2] | 0)) break;
      i6 = i3 + (HEAP32[i42 >> 2] | 0) | 0;
      if ((i6 | 0) > (i1 + i3 | 0)) i6 = i7; else {
       i4 = i6;
       while (1) {
        if ((i4 | 0) >= (HEAP32[i49 >> 2] | 0)) {
         if ((i4 | 0) >= (HEAP32[i50 >> 2] | 0)) break;
         if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj(i58, (Math_imul(HEAP32[i16 >> 2] | 0, i5) | 0) + i4 | 0) | 0)) {
          i1 = 44;
          break L20;
         }
         i1 = HEAP32[i43 >> 2] | 0;
         i3 = HEAP32[i35 >> 2] | 0;
        }
        if ((i4 | 0) < (i1 + i3 | 0)) i4 = i4 + 1 | 0; else break;
       }
       i4 = HEAP32[i41 >> 2] | 0;
       i6 = HEAP32[i33 >> 2] | 0;
      }
     }
     if ((i5 | 0) < (i4 + i6 | 0)) {
      i7 = i6;
      i5 = i5 + 1 | 0;
     } else break;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 44;
    break;
   }
   HEAP32[i55 >> 2] = 0;
  } else {
   i4 = HEAP32[i51 >> 2] | 0;
   i3 = i9 - i4 | 0;
   HEAP32[i10 >> 2] = i3;
   i4 = i4 + i9 | 0;
   HEAP32[i37 >> 2] = i4;
   i6 = HEAP32[i52 >> 2] | 0;
   i5 = i2 - i6 | 0;
   HEAP32[i38 >> 2] = i5;
   i6 = i6 + i2 | 0;
   HEAP32[i39 >> 2] = i6;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) {
    i1 = HEAP32[i42 >> 2] | 0;
    if ((i5 | 0) != (i1 | 0)) {
     HEAP8[i57 >> 0] = 1;
     HEAP32[i12 >> 2] = (i5 | 0) < (i1 | 0) ? i5 : i6;
     HEAP32[i13 >> 2] = i3;
     HEAP32[i14 >> 2] = i4;
    }
   } else {
    HEAP8[i57 >> 0] = 0;
    HEAP32[i12 >> 2] = (i3 | 0) < (i1 | 0) ? i3 : i4;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i14 >> 2] = i6;
   }
   if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE(i58, i57) | 0)) {
    i1 = 36;
    break;
   }
   i7 = HEAP32[i15 >> 2] | 0;
   if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 36;
    break;
   }
   HEAP32[i55 >> 2] = 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  }
  if (i8) {
   i1 = i9 + i46 | 0;
   f27 = Math_fround(i1 + i46 | 0);
   if (!(!(f27 < f45) & !(f27 >= f29))) {
    i1 = 44;
    break;
   }
   f18 = Math_fround(f31 + f18);
  } else {
   i2 = i2 + i47 | 0;
   f27 = Math_fround(i2 + i47 | 0);
   if (!(!(f27 < f30) & !(f27 >= f28))) {
    i1 = 44;
    break;
   }
   f19 = Math_fround(f32 + f19);
   i1 = i9;
  }
  if (f20 < Math_fround(1.00010002)) i9 = i1; else {
   i1 = 44;
   break;
  }
 }
 if ((i1 | 0) == 36) {
  STACKTOP = i59;
  return;
 } else if ((i1 | 0) == 44) {
  STACKTOP = i59;
  return;
 }
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI24ConvexVsHeightfieldSweepLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i17, i8, i9, i56, i10) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i56 = i56 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i59 + 216 | 0;
 i53 = i59 + 24 | 0;
 i58 = i59 + 48 | 0;
 i11 = i59 + 8 | 0;
 i13 = i59 + 4 | 0;
 i12 = i59;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i17, i53);
 f28 = Math_fround(HEAPF32[i53 >> 2]);
 f45 = Math_fround(HEAPF32[i10 >> 2]);
 f28 = Math_fround(f28 - f45);
 i55 = i53 + 4 | 0;
 f29 = Math_fround(HEAPF32[i55 >> 2]);
 i7 = i10 + 4 | 0;
 f32 = Math_fround(HEAPF32[i7 >> 2]);
 f29 = Math_fround(f29 - f32);
 i54 = i53 + 8 | 0;
 f30 = Math_fround(HEAPF32[i54 >> 2]);
 i14 = i10 + 8 | 0;
 f31 = Math_fround(HEAPF32[i14 >> 2]);
 f30 = Math_fround(f30 - f31);
 HEAPF32[i53 >> 2] = f28;
 HEAPF32[i55 >> 2] = f29;
 HEAPF32[i54 >> 2] = f30;
 i54 = i53 + 12 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) + f45);
 i55 = i53 + 16 | 0;
 f32 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) + f32);
 i16 = i53 + 20 | 0;
 f31 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f31);
 HEAPF32[i54 >> 2] = f45;
 HEAPF32[i55 >> 2] = f32;
 HEAPF32[i16 >> 2] = f31;
 i16 = i17 + 12 | 0;
 i55 = HEAP32[i16 >> 2] | 0;
 HEAP8[i58 >> 0] = 0;
 i1 = i58 + 4 | 0;
 HEAP32[i1 >> 2] = i17;
 i2 = i58 + 8 | 0;
 HEAP32[i2 >> 2] = i55;
 i55 = i58 + 156 | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i58 + 160 >> 2] = 0;
 f31 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(f31 - Math_fround(HEAPF32[i8 >> 2]));
 i3 = i9 + 4 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i8 + 4 | 0;
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i4 >> 2]));
 i15 = i9 + 8 | 0;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 i5 = i8 + 8 | 0;
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i11 >> 2] = f31;
 HEAPF32[i11 + 4 >> 2] = f32;
 i6 = i11 + 8 | 0;
 HEAPF32[i6 >> 2] = f45;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i53, i54, i8, i11, Math_fround(1.0), i13, i12) | 0)) {
  STACKTOP = i59;
  return;
 }
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f28 = Math_fround(HEAPF32[i11 >> 2]);
 f23 = Math_fround(f24 * f28);
 f31 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(f24 * f31);
 f45 = Math_fround(HEAPF32[i8 >> 2]);
 f23 = Math_fround(f23 + f45);
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(f24 + f25);
 f30 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(f45 + Math_fround(f28 * f30));
 f30 = Math_fround(f25 + Math_fround(f31 * f30));
 f31 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround((f31 < f22 ? f31 : f22) - f18);
 i51 = HEAP32[i1 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 HEAPF32[i58 + 24 >> 2] = Math_fround(f19 * f29);
 HEAPF32[i58 + 28 >> 2] = Math_fround(Math_fround(f18 + (f31 > f22 ? f31 : f22)) * f29);
 i52 = HEAP32[i2 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i9 >> 2]);
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f31 = Math_fround((f29 < f45 ? f29 : f45) - f22);
 f18 = Math_fround(HEAPF32[i51 >> 2]);
 i50 = ~~Math_fround(Math_floor(Math_fround(f18 * f31)));
 i49 = HEAP32[i52 + 16 >> 2] | 0;
 i53 = i49 + -2 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i54 = i58 + 32 | 0;
 HEAP32[i54 >> 2] = (i50 | 0) > (i53 | 0) ? i53 : i50;
 i50 = ~~Math_fround(Math_ceil(Math_fround(f18 * Math_fround(f22 + (f29 > f45 ? f29 : f45)))));
 i49 = i49 + -1 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i53 = i58 + 36 | 0;
 HEAP32[i53 >> 2] = (i50 | 0) > (i49 | 0) ? i49 : i50;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i14 >> 2]);
 f31 = Math_fround((f45 < f25 ? f45 : f25) - f29);
 f19 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 i51 = ~~Math_fround(Math_floor(Math_fround(f19 * f31)));
 i52 = HEAP32[i52 + 20 >> 2] | 0;
 i50 = i52 + -2 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i49 = i58 + 40 | 0;
 HEAP32[i49 >> 2] = (i51 | 0) > (i50 | 0) ? i50 : i51;
 i51 = ~~Math_fround(Math_ceil(Math_fround(f19 * Math_fround(f29 + (f45 > f25 ? f45 : f25)))));
 i52 = i52 + -1 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i50 = i58 + 44 | 0;
 HEAP32[i50 >> 2] = (i51 | 0) > (i52 | 0) ? i52 : i51;
 f18 = Math_fround(Math_ceil(Math_fround(f22 * f18)));
 f19 = Math_fround(Math_ceil(Math_fround(f29 * f19)));
 i51 = i58 + 16 | 0;
 HEAP32[i51 >> 2] = ~~f18 + 1;
 i52 = i58 + 20 | 0;
 HEAP32[i52 >> 2] = ~~f19 + 1;
 i3 = HEAP32[i16 >> 2] | 0;
 i48 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i17 >> 2]);
 f22 = Math_fround(Math_fround(i3 + -1 | 0) * Math_fround(.99999988));
 f25 = Math_fround(Math_fround(i48 + -1 | 0) * Math_fround(.99999988));
 f23 = Math_fround(f23 * f29);
 f45 = Math_fround(Math_fround(1.00000001e-07) - f18);
 f23 = f23 > f45 ? f23 : f45;
 f22 = Math_fround(f18 + f22);
 f23 = f23 < f22 ? f23 : f22;
 f31 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f24 = Math_fround(f24 * f31);
 f32 = Math_fround(Math_fround(1.00000001e-07) - f19);
 f24 = f24 > f32 ? f24 : f32;
 f25 = Math_fround(f19 + f25);
 f24 = f24 < f25 ? f24 : f25;
 f29 = Math_fround(f28 * f29);
 f45 = f29 > f45 ? f29 : f45;
 f31 = Math_fround(f30 * f31);
 f32 = f31 > f32 ? f31 : f32;
 f22 = Math_fround((f45 < f22 ? f45 : f22) - f23);
 f25 = Math_fround((f32 < f25 ? f32 : f25) - f24);
 i46 = f22 >= Math_fround(0.0);
 f32 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = f25 >= Math_fround(0.0);
 f45 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = ~~f32;
 i47 = ~~f45;
 i1 = Math_fround(Math_abs(Math_fround(f22))) < Math_fround(1.00000001e-10);
 f32 = Math_fround(f32 * Math_fround(1.00000001e-10));
 f22 = i1 ? f32 : f22;
 i1 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(1.00000001e-10);
 f45 = Math_fround(f45 * Math_fround(1.00000001e-10));
 f25 = i1 ? f45 : f25;
 i1 = f22 > Math_fround(0.0);
 if (i1) f26 = Math_fround(Math_floor(Math_fround(f23))); else f26 = Math_fround(Math_ceil(Math_fround(f23)));
 i2 = f25 > Math_fround(0.0);
 if (i2) f27 = Math_fround(Math_floor(Math_fround(f24))); else f27 = Math_fround(Math_ceil(Math_fround(f24)));
 if (i1) {
  f20 = Math_fround(Math_ceil(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(1.0));
  f20 = f20 == f23 ? f45 : f20;
 } else {
  f20 = Math_fround(Math_floor(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(-1.0));
  f20 = f20 == f23 ? f45 : f20;
 }
 if (i2) {
  f21 = Math_fround(Math_ceil(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(1.0));
  f21 = f21 == f24 ? f45 : f21;
 } else {
  f21 = Math_fround(Math_floor(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(-1.0));
  f21 = f21 == f24 ? f45 : f21;
 }
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f22))));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f25))));
 i15 = i58 + 12 | 0;
 i16 = i58 + 48 | 0;
 i17 = ((i46 | 0) < 1) << 31 >> 31;
 i33 = i58 + 52 | 0;
 i34 = ((i47 | 0) < 1) << 31 >> 31;
 i35 = i58 + 56 | 0;
 i36 = i58 + 76 | 0;
 i37 = i58 + 80 | 0;
 i38 = i58 + 84 | 0;
 i39 = i58 + 88 | 0;
 i40 = i58 + 60 | 0;
 i41 = i58 + 64 | 0;
 i42 = i58 + 68 | 0;
 i43 = i58 + 72 | 0;
 i44 = i58 + 92 | 0;
 f45 = Math_fround(Math_fround(0.0) - f18);
 f29 = Math_fround(f18 + Math_fround(i3 | 0));
 f30 = Math_fround(Math_fround(0.0) - f19);
 f28 = Math_fround(f19 + Math_fround(i48 | 0));
 i10 = i58 + 76 | 0;
 i11 = i58 + 60 | 0;
 i12 = i57 + 4 | 0;
 i13 = i57 + 8 | 0;
 i14 = i57 + 12 | 0;
 f18 = Math_fround(Math_fround(f20 - f23) / f22);
 f19 = Math_fround(Math_fround(f21 - f24) / f25);
 i9 = ~~f26;
 i2 = ~~f27;
 L20 : while (1) {
  i8 = f18 < f19;
  f20 = i8 ? f18 : f19;
  if (!(HEAP8[i58 >> 0] | 0)) {
   HEAP8[i58 >> 0] = 1;
   HEAP32[i15 >> 2] = i56;
   HEAP32[i16 >> 2] = i48;
   HEAP32[i33 >> 2] = i17;
   HEAP32[i35 >> 2] = i34;
   HEAP32[i36 >> 2] = 1;
   HEAP32[i37 >> 2] = -1;
   HEAP32[i38 >> 2] = 1;
   HEAP32[i39 >> 2] = -1;
   i4 = HEAP32[i51 >> 2] | 0;
   i5 = i9 - i4 | 0;
   HEAP32[i40 >> 2] = i5;
   i4 = i4 + i9 | 0;
   HEAP32[i41 >> 2] = i4;
   i1 = HEAP32[i52 >> 2] | 0;
   HEAP32[i42 >> 2] = i2 - i1;
   i1 = i1 + i2 | 0;
   HEAP32[i43 >> 2] = i1;
   i5 = i17 + i5 | 0;
   if ((i5 | 0) > (i4 + i17 | 0)) i1 = i56; else {
    i3 = i34;
    i7 = i17;
    while (1) {
     if ((i5 | 0) < (HEAP32[i54 >> 2] | 0)) i6 = i7; else {
      if ((i5 | 0) >= (HEAP32[i53 >> 2] | 0)) break;
      i6 = i3 + (HEAP32[i42 >> 2] | 0) | 0;
      if ((i6 | 0) > (i1 + i3 | 0)) i6 = i7; else {
       i4 = i6;
       while (1) {
        if ((i4 | 0) >= (HEAP32[i49 >> 2] | 0)) {
         if ((i4 | 0) >= (HEAP32[i50 >> 2] | 0)) break;
         if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj(i58, (Math_imul(HEAP32[i16 >> 2] | 0, i5) | 0) + i4 | 0) | 0)) {
          i1 = 44;
          break L20;
         }
         i1 = HEAP32[i43 >> 2] | 0;
         i3 = HEAP32[i35 >> 2] | 0;
        }
        if ((i4 | 0) < (i1 + i3 | 0)) i4 = i4 + 1 | 0; else break;
       }
       i4 = HEAP32[i41 >> 2] | 0;
       i6 = HEAP32[i33 >> 2] | 0;
      }
     }
     if ((i5 | 0) < (i4 + i6 | 0)) {
      i7 = i6;
      i5 = i5 + 1 | 0;
     } else break;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 44;
    break;
   }
   HEAP32[i55 >> 2] = 0;
  } else {
   i4 = HEAP32[i51 >> 2] | 0;
   i3 = i9 - i4 | 0;
   HEAP32[i10 >> 2] = i3;
   i4 = i4 + i9 | 0;
   HEAP32[i37 >> 2] = i4;
   i6 = HEAP32[i52 >> 2] | 0;
   i5 = i2 - i6 | 0;
   HEAP32[i38 >> 2] = i5;
   i6 = i6 + i2 | 0;
   HEAP32[i39 >> 2] = i6;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) {
    i1 = HEAP32[i42 >> 2] | 0;
    if ((i5 | 0) != (i1 | 0)) {
     HEAP8[i57 >> 0] = 1;
     HEAP32[i12 >> 2] = (i5 | 0) < (i1 | 0) ? i5 : i6;
     HEAP32[i13 >> 2] = i3;
     HEAP32[i14 >> 2] = i4;
    }
   } else {
    HEAP8[i57 >> 0] = 0;
    HEAP32[i12 >> 2] = (i3 | 0) < (i1 | 0) ? i3 : i4;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i14 >> 2] = i6;
   }
   if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE10visitCellsERKNS4_11OverlapLineE(i58, i57) | 0)) {
    i1 = 36;
    break;
   }
   i7 = HEAP32[i15 >> 2] | 0;
   if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 36;
    break;
   }
   HEAP32[i55 >> 2] = 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  }
  if (i8) {
   i1 = i9 + i46 | 0;
   f27 = Math_fround(i1 + i46 | 0);
   if (!(!(f27 < f45) & !(f27 >= f29))) {
    i1 = 44;
    break;
   }
   f18 = Math_fround(f31 + f18);
  } else {
   i2 = i2 + i47 | 0;
   f27 = Math_fround(i2 + i47 | 0);
   if (!(!(f27 < f30) & !(f27 >= f28))) {
    i1 = 44;
    break;
   }
   f19 = Math_fround(f32 + f19);
   i1 = i9;
  }
  if (f20 < Math_fround(1.00010002)) i9 = i1; else {
   i1 = 44;
   break;
  }
 }
 if ((i1 | 0) == 36) {
  STACKTOP = i59;
  return;
 } else if ((i1 | 0) == 44) {
  STACKTOP = i59;
  return;
 }
}

function __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE(i37, i31, i41, i42, i33, i24, i29, i30, i39, i1) {
 i37 = i37 | 0;
 i31 = i31 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i33 = i33 | 0;
 i24 = i24 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i40 = 0, i43 = 0, f44 = f0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i43 + 32 | 0;
 i32 = i43 + 24 | 0;
 i25 = i43 + 61 | 0;
 i28 = i43 + 16 | 0;
 i26 = i43 + 60 | 0;
 i36 = i43;
 i8 = HEAP32[i39 + 4 >> 2] | 0;
 i34 = i8 + 36 | 0;
 i35 = (HEAP8[i39 + 13 >> 0] | 0) == 0 ? 0 : HEAP32[i39 >> 2] | 0;
 i27 = i1 + 28 | 0;
 i5 = i1 + 44 | 0;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i1 + 48 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i1 + 52 | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 f17 = Math_fround(f9 * Math_fround(-2.0));
 f18 = Math_fround(f11 * Math_fround(-2.0));
 f44 = Math_fround(f10 * Math_fround(-2.0));
 f12 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i27 >> 2]);
 f21 = Math_fround(f17 * f14);
 f15 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f18 * f15));
 f16 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f44 * f16));
 f19 = Math_fround(Math_fround(f14 * f21) + Math_fround(Math_fround(f17 * f13) - Math_fround(f12 * Math_fround(Math_fround(f44 * f15) - Math_fround(f18 * f16)))));
 f20 = Math_fround(Math_fround(f15 * f21) + Math_fround(Math_fround(f18 * f13) - Math_fround(f12 * Math_fround(Math_fround(f17 * f16) - Math_fround(f44 * f14)))));
 f21 = Math_fround(Math_fround(Math_fround(f44 * f13) - Math_fround(f12 * Math_fround(Math_fround(f18 * f14) - Math_fround(f17 * f15)))) + Math_fround(f16 * f21));
 f17 = Math_fround(-f15);
 f18 = Math_fround(-f16);
 HEAPF32[i40 >> 2] = Math_fround(-f14);
 HEAPF32[i40 + 4 >> 2] = f17;
 HEAPF32[i40 + 8 >> 2] = f18;
 HEAPF32[i40 + 12 >> 2] = f12;
 HEAPF32[i40 + 16 >> 2] = f19;
 HEAPF32[i40 + 20 >> 2] = f20;
 HEAPF32[i40 + 24 >> 2] = f21;
 i38 = (i41 | 0) == 0;
 L1 : do if (!i38) {
  f17 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
  f19 = Math_fround(HEAPF32[i1 >> 2]);
  f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i22 = i1 + 16 | 0;
  i23 = i1 + 20 | 0;
  i2 = i1 + 24 | 0;
  i3 = HEAP32[i33 >> 2] | 0;
  i4 = HEAP32[i33 + 4 >> 2] | 0;
  i1 = 0;
  while (1) {
   HEAP32[i42 + (i1 * 176 | 0) + 124 >> 2] = HEAP32[i42 + (i1 * 176 | 0) + 12 >> 2] & 2;
   f49 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 64 >> 2]) * Math_fround(2.0));
   f44 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 68 >> 2]) * Math_fround(2.0));
   f48 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 72 >> 2]) * Math_fround(2.0));
   f50 = Math_fround(Math_fround(Math_fround(f49 * f14) + Math_fround(f44 * f15)) + Math_fround(f48 * f16));
   f47 = Math_fround(f11 + Math_fround(Math_fround(f15 * f50) + Math_fround(Math_fround(f44 * f13) + Math_fround(f12 * Math_fround(Math_fround(f49 * f16) - Math_fround(f48 * f14))))));
   f46 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f48 * f13) + Math_fround(f12 * Math_fround(Math_fround(f44 * f14) - Math_fround(f49 * f15)))) + Math_fround(f16 * f50)));
   HEAPF32[i42 + (i1 * 176 | 0) + 128 >> 2] = Math_fround(f9 + Math_fround(Math_fround(f14 * f50) + Math_fround(Math_fround(f49 * f13) + Math_fround(f12 * Math_fround(Math_fround(f48 * f15) - Math_fround(f44 * f16))))));
   HEAPF32[i42 + (i1 * 176 | 0) + 132 >> 2] = f47;
   HEAPF32[i42 + (i1 * 176 | 0) + 136 >> 2] = f46;
   f9 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 48 >> 2]) * Math_fround(2.0));
   f46 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 52 >> 2]) * Math_fround(2.0));
   f47 = Math_fround(Math_fround(HEAPF32[i42 + (i1 * 176 | 0) + 56 >> 2]) * Math_fround(2.0));
   f44 = Math_fround(Math_fround(Math_fround(f9 * f19) + Math_fround(f46 * f20)) + Math_fround(f47 * f21));
   f10 = Math_fround(Math_fround(f19 * f44) + Math_fround(Math_fround(f9 * f18) + Math_fround(f17 * Math_fround(Math_fround(f47 * f20) - Math_fround(f46 * f21)))));
   f11 = Math_fround(Math_fround(f20 * f44) + Math_fround(Math_fround(f46 * f18) + Math_fround(f17 * Math_fround(Math_fround(f9 * f21) - Math_fround(f47 * f19)))));
   f44 = Math_fround(Math_fround(Math_fround(f47 * f18) + Math_fround(f17 * Math_fround(Math_fround(f46 * f19) - Math_fround(f9 * f20)))) + Math_fround(f21 * f44));
   f10 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f10);
   f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f11);
   f44 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f44);
   HEAPF32[i42 + (i1 * 176 | 0) + 112 >> 2] = f10;
   HEAPF32[i42 + (i1 * 176 | 0) + 116 >> 2] = f11;
   HEAPF32[i42 + (i1 * 176 | 0) + 120 >> 2] = f44;
   i45 = HEAP32[i42 + (i1 * 176 | 0) + 76 >> 2] | 0;
   HEAP32[i42 + (i1 * 176 | 0) + 140 >> 2] = i3 + (i45 << 4);
   HEAP32[i42 + (i1 * 176 | 0) + 156 >> 2] = i4 + (i45 << 4);
   HEAP32[i42 + (i1 * 176 | 0) + 144 >> 2] = 0;
   HEAP32[i42 + (i1 * 176 | 0) + 148 >> 2] = 0;
   HEAP32[i42 + (i1 * 176 | 0) + 152 >> 2] = 0;
   HEAP32[i42 + (i1 * 176 | 0) + 160 >> 2] = 0;
   HEAP32[i42 + (i1 * 176 | 0) + 164 >> 2] = 0;
   HEAP32[i42 + (i1 * 176 | 0) + 168 >> 2] = 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i41 | 0)) break L1;
   f9 = Math_fround(HEAPF32[i5 >> 2]);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   f10 = Math_fround(HEAPF32[i7 >> 2]);
  }
 } while (0);
 L7 : do switch (HEAP32[i34 >> 2] | 0) {
 case 0:
  {
   __ZN5physx17collideWithSphereEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]));
   i1 = 28;
   break;
  }
 case 1:
  {
   __ZN5physx16collideWithPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]));
   i1 = 28;
   break;
  }
 case 2:
  {
   __ZN5physx18collideWithCapsuleEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]));
   i1 = 28;
   break;
  }
 case 3:
  {
   __ZN5physx14collideWithBoxEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]));
   i1 = 28;
   break;
  }
 case 4:
  {
   i3 = HEAPU8[(HEAP32[i8 + 72 >> 2] | 0) + 39 >> 0] | 0;
   i1 = i3 << 4;
   i45 = i1 >>> 0 > 1024;
   i4 = i32 + 4 | 0;
   i2 = i45 & 1;
   HEAP8[i4 >> 0] = i2;
   if (i45) {
    i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i25, i1, gb + 769468 | 0, 624) | 0;
    HEAP32[i32 >> 2] = i1;
    i3 = i1;
    i2 = HEAP8[i4 >> 0] | 0;
   } else {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * (i3 << 4) | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    HEAP32[i32 >> 2] = i1;
    i3 = i1;
   }
   __ZN5physx17collideWithConvexEPNS_7PxPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i3, i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]));
   if (!(i2 << 24 >> 24)) i1 = 28; else {
    __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i32, i1);
    i1 = 28;
   }
   break;
  }
 case 5:
  {
   if (i24 | 0) {
    f49 = Math_fround(HEAPF32[i37 + 28 >> 2]);
    f50 = Math_fround(HEAPF32[i37 + 60 >> 2]);
    __ZN5physx21collideWithStaticMeshEjPNS_19PxsParticleCollDataEPNS_27PxsFluidParticleOpcodeCacheERKNS_2Gu13GeometryUnionERKNS_11PxTransformESA_fff(i41, i42, i24, i34, i27, i40, f49, f50, Math_fround(HEAPF32[i37 + 52 >> 2]));
    i1 = 25;
    break L7;
   }
   i5 = i29 + 16 | 0;
   if (!(HEAP8[i5 >> 0] | 0)) {
    i3 = i41 << 2;
    i45 = i3 >>> 0 > 1024;
    i4 = i28 + 4 | 0;
    i1 = i45 & 1;
    HEAP8[i4 >> 0] = i1;
    if (i45) {
     i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i26, i3, gb + 769468 | 0, 640) | 0;
     HEAP32[i28 >> 2] = i2;
     i1 = HEAP8[i4 >> 0] | 0;
    } else {
     i2 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     HEAP32[i28 >> 2] = i2;
    }
    f50 = Math_fround(HEAPF32[i37 + 32 >> 2]);
    i45 = i41 + 1 | 0;
    i45 = i45 >>> 1 | i45;
    i45 = i45 >>> 2 | i45;
    i45 = i45 >>> 4 | i45;
    i45 = i45 >>> 8 | i45;
    i45 = (i45 >>> 16 | i45) + 1 | 0;
    i45 = i45 >>> 0 > 256 ? 256 : i45;
    __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i31, i41, HEAP32[i29 + 12 >> 2] | 0, HEAP32[i29 + 4 >> 2] | 0, i2, i45, f50, i30);
    HEAP32[i29 + 8 >> 2] = i45;
    HEAP32[i29 >> 2] = i41;
    HEAP8[i5 >> 0] = 1;
    if (i1 << 24 >> 24) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i28, i2);
   }
   __ZN5physx26collideCellsWithStaticMeshEPNS_19PxsParticleCollDataERKNS_21PxsFluidLocalCellHashERKNS_2Gu13GeometryUnionERKNS_11PxTransformESB_fffRKNS_6PxVec3E(i42, i29, i34, i27, i40, Math_fround(HEAPF32[i37 + 28 >> 2]), Math_fround(HEAPF32[i37 + 60 >> 2]), Math_fround(HEAPF32[i37 + 52 >> 2]), i30);
   i1 = 25;
   break;
  }
 case 6:
  {
   __ZN5physx28collideWithStaticHeightFieldEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEfRKNS_11PxTransformE(i42, i41, i34, Math_fround(HEAPF32[i37 + 52 >> 2]), i40);
   i1 = 25;
   break;
  }
 default:
  i1 = 28;
 } while (0);
 L31 : do if ((i1 | 0) == 25) {
  if (!i38) {
   i1 = i37 + 64 | 0;
   i2 = 0;
   do {
    __ZN5physx24updateCollDataStaticMeshERNS_19PxsParticleCollDataERKNS_11PxTransformEf(i42 + (i2 * 176 | 0) | 0, i40, Math_fround(HEAPF32[i1 >> 2]));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i41 | 0));
  }
 } else if ((i1 | 0) == 28) {
  if (!i35) {
   if (i38) break;
   i1 = i37 + 64 | 0;
   i2 = 0;
   while (1) {
    __ZN5physx20updateCollDataStaticERNS_19PxsParticleCollDataERKNS_11PxTransformEf(i42 + (i2 * 176 | 0) | 0, i40, Math_fround(HEAPF32[i1 >> 2]));
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i41 | 0)) break L31;
   }
  }
  if (!i38) {
   i8 = i33 + 8 | 0;
   i5 = i33 + 12 | 0;
   i6 = i35 + 64 | 0;
   i7 = i35 + 80 | 0;
   i3 = i37 + 64 | 0;
   i4 = 0;
   do {
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) i2 = i36; else i2 = i1 + (HEAP32[i42 + (i4 * 176 | 0) + 76 >> 2] << 4) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (!i1) i1 = i36; else i1 = i1 + (HEAP32[i42 + (i4 * 176 | 0) + 76 >> 2] << 4) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    __ZN5physx21updateCollDataDynamicERNS_19PxsParticleCollDataERKNS_11PxTransformERKNS_6PxVec3ES7_PKNS_11PxsBodyCoreES4_fRNS_25PxsFluidConstraintDynamicESC_(i42 + (i4 * 176 | 0) | 0, i35, i6, i7, i35, i40, Math_fround(HEAPF32[i3 >> 2]), i2, i1);
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i41 | 0));
  }
 } while (0);
 if ((HEAP8[i39 + 12 >> 0] | 0) == 0 | i38) {
  STACKTOP = i43;
  return;
 } else i1 = 0;
 do {
  if (HEAP32[i42 + (i1 * 176 | 0) + 124 >> 2] & 56 | 0) {
   i45 = i42 + (i1 * 176 | 0) + 60 | 0;
   HEAP16[i45 >> 1] = HEAPU16[i45 >> 1] | 8;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i41 | 0));
 STACKTOP = i43;
 return;
}

function __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i46, i45, i60, i61, i62, i63) {
 i1 = i1 | 0;
 i46 = i46 | 0;
 i45 = i45 | 0;
 i60 = i60 | 0;
 i61 = i61 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i64 = 0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i64 + 240 | 0;
 i57 = i64 + 176 | 0;
 i58 = i64 + 112 | 0;
 i27 = i64 + 96 | 0;
 i56 = i64 + 340 | 0;
 i50 = i64 + 80 | 0;
 i53 = i64 + 64 | 0;
 i54 = i64 + 48 | 0;
 i51 = i64 + 328 | 0;
 i55 = i64 + 32 | 0;
 i47 = i64 + 16 | 0;
 i24 = i64;
 i23 = i64 + 316 | 0;
 i52 = i64 + 304 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i56 >> 2] = 0;
 i25 = i45 + 48 | 0;
 f8 = Math_fround(HEAPF32[i25 >> 2]);
 i31 = i45 + 52 | 0;
 f9 = Math_fround(HEAPF32[i31 >> 2]);
 i44 = i45 + 56 | 0;
 f10 = Math_fround(HEAPF32[i44 >> 2]);
 i48 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i48 ? f8 : Math_fround(1.0);
 f11 = i48 ? f9 : Math_fround(0.0);
 f7 = i48 ? f10 : Math_fround(0.0);
 HEAPF32[i50 >> 2] = f12;
 i48 = i50 + 4 | 0;
 HEAPF32[i48 >> 2] = f11;
 i49 = i50 + 8 | 0;
 HEAPF32[i49 >> 2] = f7;
 HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i46 + 32 >> 2]);
 f26 = Math_fround((f26 > f2 ? f2 : f26) * Math_fround(.100000001));
 f26 = Math_fround(f26 * f26);
 HEAP32[i53 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i53 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i54 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i55 >> 2] = HEAP32[i50 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
 i27 = i45 + 4 | 0;
 i28 = i45 + 8 | 0;
 i29 = i45 + 16 | 0;
 i30 = i45 + 20 | 0;
 i32 = i45 + 24 | 0;
 i33 = i45 + 32 | 0;
 i34 = i45 + 36 | 0;
 i35 = i45 + 40 | 0;
 i36 = i1 + 96 | 0;
 i37 = i1 + 100 | 0;
 i38 = i1 + 104 | 0;
 i39 = i1 + 112 | 0;
 i40 = i1 + 116 | 0;
 i41 = i1 + 120 | 0;
 i42 = i1 + 128 | 0;
 i43 = i1 + 132 | 0;
 i4 = i1 + 136 | 0;
 i13 = i47 + 4 | 0;
 i14 = i47 + 8 | 0;
 i15 = i24 + 4 | 0;
 i16 = i24 + 8 | 0;
 i17 = i24 + 12 | 0;
 i18 = i59 + 4 | 0;
 i19 = i59 + 8 | 0;
 i20 = i59 + 16 | 0;
 i21 = i59 + 20 | 0;
 i22 = i59 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  HEAP32[i55 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  f68 = Math_fround(-f12);
  f80 = Math_fround(-f11);
  f81 = Math_fround(-f7);
  f73 = Math_fround(HEAPF32[i45 >> 2]);
  f85 = Math_fround(f73 * f68);
  f70 = Math_fround(HEAPF32[i27 >> 2]);
  f85 = Math_fround(f85 + Math_fround(f70 * f80));
  f66 = Math_fround(HEAPF32[i28 >> 2]);
  f85 = Math_fround(f85 + Math_fround(f66 * f81));
  f72 = Math_fround(HEAPF32[i29 >> 2]);
  f84 = Math_fround(f72 * f68);
  f69 = Math_fround(HEAPF32[i30 >> 2]);
  f84 = Math_fround(f84 + Math_fround(f69 * f80));
  f5 = Math_fround(HEAPF32[i32 >> 2]);
  f84 = Math_fround(f84 + Math_fround(f5 * f81));
  f74 = Math_fround(HEAPF32[i33 >> 2]);
  f68 = Math_fround(f74 * f68);
  f71 = Math_fround(HEAPF32[i34 >> 2]);
  f80 = Math_fround(f68 + Math_fround(f71 * f80));
  f68 = Math_fround(HEAPF32[i35 >> 2]);
  f81 = Math_fround(f80 + Math_fround(f68 * f81));
  f80 = Math_fround(HEAPF32[i36 >> 2]);
  f78 = Math_fround(HEAPF32[i37 >> 2]);
  f76 = Math_fround(HEAPF32[i38 >> 2]);
  f79 = Math_fround(HEAPF32[i39 >> 2]);
  f77 = Math_fround(HEAPF32[i40 >> 2]);
  f75 = Math_fround(HEAPF32[i41 >> 2]);
  f6 = Math_fround(HEAPF32[i42 >> 2]);
  f3 = Math_fround(HEAPF32[i43 >> 2]);
  f67 = Math_fround(HEAPF32[i4 >> 2]);
  f83 = Math_fround(Math_fround(Math_fround(f85 * f80) + Math_fround(f84 * f78)) + Math_fround(f81 * f76));
  f82 = Math_fround(Math_fround(Math_fround(f85 * f79) + Math_fround(f84 * f77)) + Math_fround(f81 * f75));
  f81 = Math_fround(Math_fround(Math_fround(f85 * f6) + Math_fround(f84 * f3)) + Math_fround(f81 * f67));
  i65 = f83 > f82 & f83 > f81;
  i1 = f82 > f81;
  f6 = i65 ? f80 : i1 ? f79 : f6;
  f3 = i65 ? f78 : i1 ? f77 : f3;
  f67 = i65 ? f76 : i1 ? f75 : f67;
  f8 = Math_fround(f8 + Math_fround(Math_fround(f74 * f67) + Math_fround(Math_fround(f73 * f6) + Math_fround(f72 * f3))));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f71 * f67) + Math_fround(Math_fround(f70 * f6) + Math_fround(f69 * f3))));
  f10 = Math_fround(f10 + Math_fround(Math_fround(f68 * f67) + Math_fround(Math_fround(f66 * f6) + Math_fround(f5 * f3))));
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i47, i46, i50);
  f3 = Math_fround(HEAPF32[i47 >> 2]);
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f3 = Math_fround(f8 - f3);
  f5 = Math_fround(f9 - f5);
  f6 = Math_fround(f10 - Math_fround(HEAPF32[i14 >> 2]));
  f12 = Math_fround(f2 - Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f12 * f3) + Math_fround(f11 * f5))));
  i1 = HEAP32[i56 >> 2] | 0;
  HEAPF32[i57 + (i1 << 4) >> 2] = f8;
  HEAPF32[i57 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i57 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i57 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i65 = i58 + (i1 << 4) | 0;
  HEAP32[i65 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i65 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  HEAPF32[i59 + (i1 << 4) >> 2] = f3;
  HEAPF32[i59 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i59 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i59 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i56 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i59 >> 2]);
    f5 = Math_fround(HEAPF32[i18 >> 2]);
    f6 = Math_fround(HEAPF32[i19 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f83 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i65 = f83 > Math_fround(1.0);
     f83 = i65 ? Math_fround(1.0) : f83;
     i65 = f83 > Math_fround(0.0);
     f83 = i65 ? f83 : Math_fround(0.0);
     f84 = Math_fround(f5 + Math_fround(f8 * f83));
     f85 = Math_fround(f6 + Math_fround(f9 * f83));
     HEAPF32[i24 >> 2] = Math_fround(f3 + Math_fround(f7 * f83));
     HEAPF32[i15 >> 2] = f84;
     HEAPF32[i16 >> 2] = f85;
     HEAPF32[i17 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i56 >> 2] = 1;
     HEAP32[i24 >> 2] = HEAP32[i59 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
     HEAP32[i24 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i59, i57, i58, i56);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i59, i57, i58, i56);
    break;
   }
  default:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i50 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i50 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i50 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i50 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i50 >> 2]);
  f6 = Math_fround(HEAPF32[i48 >> 2]);
  f7 = Math_fround(HEAPF32[i49 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i51 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f26 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f9 = Math_fround(HEAPF32[i31 >> 2]);
  f10 = Math_fround(HEAPF32[i44 >> 2]);
  f2 = f3;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i59, i57, i58, i50, i60, i61, i1);
  f83 = Math_fround(HEAPF32[i50 >> 2]);
  f84 = Math_fround(HEAPF32[i48 >> 2]);
  f82 = Math_fround(HEAPF32[i49 >> 2]);
  f85 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f83 * f83) + Math_fround(f84 * f84)) + Math_fround(f82 * f82)))));
  f83 = Math_fround(-Math_fround(f83 * f85));
  f84 = Math_fround(-Math_fround(f84 * f85));
  f85 = Math_fround(-Math_fround(f82 * f85));
  HEAPF32[i63 >> 2] = f2;
  i65 = i63 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAPF32[i62 >> 2] = f83;
  HEAPF32[i62 + 4 >> 2] = f84;
  HEAPF32[i62 + 8 >> 2] = f85;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  i65 = 0;
  STACKTOP = i64;
  return i65 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i59, i57, i58, i55, i60, i61, HEAP32[i56 >> 2] | 0);
  HEAP32[i60 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i60 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i60 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i60 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  HEAP32[i61 >> 2] = HEAP32[i54 >> 2];
  HEAP32[i61 + 4 >> 2] = HEAP32[i54 + 4 >> 2];
  HEAP32[i61 + 8 >> 2] = HEAP32[i54 + 8 >> 2];
  HEAP32[i61 + 12 >> 2] = HEAP32[i54 + 12 >> 2];
  f82 = Math_fround(HEAPF32[i55 >> 2]);
  f84 = Math_fround(HEAPF32[i55 + 4 >> 2]);
  f85 = Math_fround(HEAPF32[i55 + 8 >> 2]);
  f83 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f82 * f82) + Math_fround(f84 * f84)) + Math_fround(f85 * f85)))));
  f84 = Math_fround(-Math_fround(f84 * f83));
  f85 = Math_fround(-Math_fround(f85 * f83));
  HEAPF32[i62 >> 2] = Math_fround(-Math_fround(f82 * f83));
  HEAPF32[i62 + 4 >> 2] = f84;
  HEAPF32[i62 + 8 >> 2] = f85;
  HEAPF32[i62 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i63 >> 2] = i1 ? f3 : f2;
  i65 = i63 + 4 | 0;
  HEAP32[i65 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i65 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i65 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  i65 = i1 ? 1 : 3;
  STACKTOP = i64;
  return i65 | 0;
 }
 return 0;
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_15RayCastCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i10, i8, i3, i65, i1) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i65 = i65 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0;
 i64 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i64 + 128 | 0;
 i6 = i64 + 112 | 0;
 i7 = i64 + 108 | 0;
 i9 = i64 + 104 | 0;
 i62 = i64 + 92 | 0;
 i63 = i64 + 80 | 0;
 i53 = i64 + 64 | 0;
 i60 = i64 + 60 | 0;
 i61 = i64 + 56 | 0;
 i54 = i64 + 44 | 0;
 i55 = i64 + 32 | 0;
 i56 = i64 + 20 | 0;
 i57 = i64 + 8 | 0;
 i58 = i64 + 4 | 0;
 i59 = i64;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i10, i47);
 f50 = Math_fround(HEAPF32[i3 >> 2]);
 f50 = Math_fround(f50 - Math_fround(HEAPF32[i8 >> 2]));
 f51 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i5 = i8 + 4 | 0;
 f51 = Math_fround(f51 - Math_fround(HEAPF32[i5 >> 2]));
 f52 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i4 = i8 + 8 | 0;
 f52 = Math_fround(f52 - Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i6 >> 2] = f50;
 i1 = i6 + 4 | 0;
 HEAPF32[i1 >> 2] = f51;
 i3 = i6 + 8 | 0;
 HEAPF32[i3 >> 2] = f52;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i47, i47 + 12 | 0, i8, i6, Math_fround(1.0), i7, i9) | 0)) {
  STACKTOP = i64;
  return;
 }
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f37 = Math_fround(f12 * f20);
 f39 = Math_fround(HEAPF32[i1 >> 2]);
 f52 = Math_fround(f12 * f39);
 f49 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f12 * f49);
 f11 = Math_fround(HEAPF32[i8 >> 2]);
 f37 = Math_fround(f37 + f11);
 f44 = Math_fround(HEAPF32[i5 >> 2]);
 f52 = Math_fround(f52 + f44);
 f50 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f12 + f50);
 f38 = Math_fround(HEAPF32[i9 >> 2]);
 f20 = Math_fround(f11 + Math_fround(f20 * f38));
 f39 = Math_fround(f44 + Math_fround(f39 * f38));
 f38 = Math_fround(f50 + Math_fround(f49 * f38));
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 f49 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f50 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f44 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i4 = HEAP32[i10 + 12 >> 2] | 0;
 i45 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = HEAP32[i4 + 16 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i10 >> 2]);
 f13 = Math_fround(Math_fround(i5 + -1 | 0) * Math_fround(.99999988));
 f14 = Math_fround(Math_fround(i45 + -1 | 0) * Math_fround(.99999988));
 f18 = Math_fround(f37 * f11);
 i42 = f18 > Math_fround(1.00000001e-07);
 f51 = i42 ? f18 : Math_fround(1.00000001e-07);
 f13 = Math_fround(f13 + Math_fround(0.0));
 f51 = f51 < f13 ? f51 : f13;
 f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f19 = Math_fround(f12 * f2);
 i42 = f19 > Math_fround(1.00000001e-07);
 f48 = i42 ? f19 : Math_fround(1.00000001e-07);
 f14 = Math_fround(f14 + Math_fround(0.0));
 f48 = f48 < f14 ? f48 : f14;
 f41 = Math_fround(f20 * f11);
 i42 = f41 > Math_fround(1.00000001e-07);
 f41 = i42 ? f41 : Math_fround(1.00000001e-07);
 f40 = Math_fround(f38 * f2);
 i42 = f40 > Math_fround(1.00000001e-07);
 f40 = i42 ? f40 : Math_fround(1.00000001e-07);
 f13 = Math_fround((f41 < f13 ? f41 : f13) - f51);
 f14 = Math_fround((f40 < f14 ? f40 : f14) - f48);
 f39 = Math_fround(f39 - f52);
 i42 = f13 >= Math_fround(0.0);
 f40 = i42 ? Math_fround(1.0) : Math_fround(-1.0);
 i42 = f14 >= Math_fround(0.0);
 f41 = i42 ? Math_fround(1.0) : Math_fround(-1.0);
 i42 = ~~f40;
 i43 = ~~f41;
 i46 = Math_fround(Math_abs(Math_fround(f13))) < Math_fround(1.00000001e-10);
 f17 = Math_fround(f40 * Math_fround(1.00000001e-10));
 f13 = i46 ? f17 : f13;
 i46 = Math_fround(Math_abs(Math_fround(f14))) < Math_fround(1.00000001e-10);
 f17 = Math_fround(f41 * Math_fround(1.00000001e-10));
 f14 = i46 ? f17 : f14;
 HEAPF32[i62 >> 2] = f18;
 HEAPF32[i62 + 4 >> 2] = f52;
 HEAPF32[i62 + 8 >> 2] = f19;
 f11 = Math_fround(Math_fround(f20 - f37) * f11);
 f2 = Math_fround(Math_fround(f38 - f12) * f2);
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f11 * f11)) + Math_fround(f2 * f2))));
 HEAPF32[i63 >> 2] = f11;
 i46 = i63 + 4 | 0;
 HEAPF32[i46 >> 2] = f39;
 i47 = i63 + 8 | 0;
 HEAPF32[i47 >> 2] = f2;
 if (f12 > Math_fround(9.99999968e-21)) {
  f38 = Math_fround(Math_fround(1.0) / f12);
  HEAPF32[i63 >> 2] = Math_fround(f38 * f11);
  HEAPF32[i46 >> 2] = Math_fround(f38 * f39);
  HEAPF32[i47 >> 2] = Math_fround(f38 * f2);
 }
 i1 = f13 > Math_fround(0.0);
 if (i1) f2 = Math_fround(Math_floor(Math_fround(f51))); else f2 = Math_fround(Math_ceil(Math_fround(f51)));
 i6 = ~~f2;
 i3 = f14 > Math_fround(0.0);
 if (i3) f2 = Math_fround(Math_floor(Math_fround(f48))); else f2 = Math_fround(Math_ceil(Math_fround(f48)));
 i7 = ~~f2;
 if (i1) {
  f2 = Math_fround(Math_ceil(Math_fround(f51)));
  f38 = Math_fround(f2 + Math_fround(1.0));
  f2 = f2 == f51 ? f38 : f2;
 } else {
  f2 = Math_fround(Math_floor(Math_fround(f51)));
  f38 = Math_fround(f2 + Math_fround(-1.0));
  f2 = f2 == f51 ? f38 : f2;
 }
 if (i3) {
  f11 = Math_fround(Math_ceil(Math_fround(f48)));
  f38 = Math_fround(f11 + Math_fround(1.0));
  f11 = f11 == f48 ? f38 : f11;
 } else {
  f11 = Math_fround(Math_floor(Math_fround(f48)));
  f38 = Math_fround(f11 + Math_fround(-1.0));
  f11 = f11 == f48 ? f38 : f11;
 }
 f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f13))));
 f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f14))));
 i25 = 1 - i42 | 0;
 i24 = (1 - i43 | 0) / 2 | 0;
 i33 = i4 + 36 | 0;
 i34 = i53 + 4 | 0;
 i35 = i53 + 8 | 0;
 i36 = i53 + 12 | 0;
 f19 = Math_fround(i5 | 0);
 f20 = Math_fround(i45 | 0);
 i21 = i53 + (i24 + i25 << 2) | 0;
 i22 = i53 + (i25 + 1 - i24 << 2) | 0;
 i23 = i53 + (2 - i25 + i24 << 2) | 0;
 i24 = i53 + (3 - i25 - i24 << 2) | 0;
 i25 = i54 + 4 | 0;
 i26 = i54 + 8 | 0;
 i27 = i55 + 4 | 0;
 i28 = i55 + 8 | 0;
 i29 = i56 + 4 | 0;
 i30 = i56 + 8 | 0;
 i31 = i57 + 4 | 0;
 i32 = i57 + 8 | 0;
 f17 = Math_fround(f12 + Math_fround(.0000999999974));
 f18 = Math_fround(f52 + Math_fround(f39 * Math_fround(0.0)));
 f16 = Math_fround(Math_fround(f2 - f51) / f13);
 f13 = Math_fround(Math_fround(f11 - f48) / f14);
 i10 = i6;
 f11 = Math_fround(i6 | 0);
 i9 = i7;
 f14 = Math_fround(i7 | 0);
 while (1) {
  i7 = f16 < f13;
  f15 = i7 ? f16 : f13;
  f67 = f18;
  f18 = Math_fround(f52 + Math_fround(f39 * f15));
  i5 = (Math_imul(i10, i45) | 0) + i9 | 0;
  i8 = i10 + i42 | 0;
  i6 = (Math_imul(i8, i45) | 0) + i9 | 0;
  i3 = HEAP32[i33 >> 2] | 0;
  f71 = Math_fround(f44 * Math_fround(HEAP16[i3 + (i5 << 2) >> 1] | 0));
  HEAPF32[i53 >> 2] = f71;
  f69 = Math_fround(f44 * Math_fround(HEAP16[i3 + (i5 + i43 << 2) >> 1] | 0));
  HEAPF32[i34 >> 2] = f69;
  f70 = Math_fround(f44 * Math_fround(HEAP16[i3 + (i6 << 2) >> 1] | 0));
  HEAPF32[i35 >> 2] = f70;
  f68 = Math_fround(f44 * Math_fround(HEAP16[i3 + (i6 + i43 << 2) >> 1] | 0));
  HEAPF32[i36 >> 2] = f68;
  f2 = f71 < f69 ? f71 : f69;
  f12 = f70 < f68 ? f70 : f68;
  f69 = f71 > f69 ? f71 : f69;
  f68 = f70 > f68 ? f70 : f68;
  if (!(Math_fround((f67 < f18 ? f67 : f18) + Math_fround(-.0000999999974)) > (f69 > f68 ? f69 : f68) ? 1 : Math_fround((f67 > f18 ? f67 : f18) + Math_fround(.0000999999974)) < (f2 < f12 ? f2 : f12))) {
   i5 = HEAP32[i21 >> 2] | 0;
   i4 = HEAP32[i22 >> 2] | 0;
   i6 = HEAP32[i23 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   f70 = Math_fround(f40 + f11);
   f68 = f11 < f70 ? f11 : f70;
   f70 = f11 > f70 ? f11 : f70;
   f71 = Math_fround(f41 + f14);
   f69 = f14 < f71 ? f14 : f71;
   f71 = f14 > f71 ? f14 : f71;
   HEAPF32[i54 >> 2] = f68;
   HEAP32[i25 >> 2] = i5;
   HEAPF32[i26 >> 2] = f69;
   HEAPF32[i55 >> 2] = f68;
   HEAP32[i27 >> 2] = i4;
   HEAPF32[i28 >> 2] = f71;
   HEAPF32[i56 >> 2] = f70;
   HEAP32[i29 >> 2] = i6;
   HEAPF32[i30 >> 2] = f69;
   HEAPF32[i57 >> 2] = f70;
   HEAP32[i31 >> 2] = i1;
   HEAPF32[i32 >> 2] = f71;
   i1 = i9 + i43 | 0;
   i1 = (Math_imul((i8 | 0) < (i10 | 0) ? i8 : i10, i45) | 0) + ((i1 | 0) < (i9 | 0) ? i1 : i9) | 0;
   i6 = (HEAP8[i3 + (i1 << 2) + 2 >> 0] | 0) < 0;
   i3 = i6 ? i54 : i55;
   i4 = i6 ? i55 : i57;
   i5 = i6 ? i57 : i56;
   HEAPF32[i58 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i59 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i6 = __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i62, i63, i6 ? i56 : i54, i3, i5, i58, i60, i61, Math_fround(.0000999999974)) | 0;
   f71 = Math_fround(HEAPF32[i58 >> 2]);
   if (!(f71 <= f17) | i6 & f71 >= Math_fround(-.0000999999974) ^ 1) i66 = 20; else if ((HEAP8[(HEAP32[i33 >> 2] | 0) + (i1 << 2) + 2 >> 0] & 127) == 127) i66 = 20; else i6 = 1;
   if ((i66 | 0) == 20) {
    i66 = 0;
    HEAPF32[i58 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i6 = 0;
   }
   i5 = __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i62, i63, i4, i5, i3, i59, i60, i61, Math_fround(.0000999999974)) | 0;
   f2 = Math_fround(HEAPF32[i59 >> 2]);
   if (!(f2 <= f17) | i5 & f2 >= Math_fround(-.0000999999974) ^ 1) i66 = 23; else if ((HEAP8[(HEAP32[i33 >> 2] | 0) + (i1 << 2) + 3 >> 0] & 127) == 127) i66 = 23; else i3 = 0;
   if ((i66 | 0) == 23) {
    i66 = 0;
    HEAPF32[i59 >> 2] = Math_fround(3402823469999999843913219.0e14);
    f2 = Math_fround(3402823469999999843913219.0e14);
    i3 = 1;
   }
   if (i6) {
    f12 = Math_fround(HEAPF32[i58 >> 2]);
    if (f12 <= f2) {
     f2 = f12;
     i66 = 26;
     break;
    }
   }
   if (!(i3 | !(f2 <= Math_fround(HEAPF32[i58 >> 2])))) {
    i66 = 28;
    break;
   }
  }
  if (i7) {
   i10 = i8 + i42 | 0;
   if (!((i10 | 0) > -1 & !(Math_fround(i10 | 0) >= f19))) {
    i66 = 35;
    break;
   }
   f12 = Math_fround(f37 + f16);
   i3 = i8;
   f11 = Math_fround(f40 + f11);
   i1 = i9;
   f2 = f14;
  } else {
   i1 = i9 + i43 | 0;
   i9 = i1 + i43 | 0;
   if (!((i9 | 0) > -1 & !(Math_fround(i9 | 0) >= f20))) {
    i66 = 35;
    break;
   }
   f12 = f16;
   f13 = Math_fround(f38 + f13);
   i3 = i10;
   f2 = Math_fround(f41 + f14);
  }
  if (!(f15 < Math_fround(.999899983))) {
   i66 = 35;
   break;
  } else {
   f16 = f12;
   i10 = i3;
   i9 = i1;
   f14 = f2;
  }
 }
 if ((i66 | 0) == 26) {
  f69 = Math_fround(f49 * Math_fround(f51 + Math_fround(f2 * Math_fround(HEAPF32[i63 >> 2]))));
  f70 = Math_fround(f52 + Math_fround(f2 * Math_fround(HEAPF32[i46 >> 2])));
  f71 = Math_fround(f50 * Math_fround(f48 + Math_fround(f2 * Math_fround(HEAPF32[i47 >> 2]))));
  HEAPF32[i65 >> 2] = f69;
  HEAPF32[i65 + 4 >> 2] = f70;
  HEAPF32[i65 + 8 >> 2] = f71;
  HEAP32[i65 + 12 >> 2] = i1 << 1;
  HEAP8[i65 + 16 >> 0] = 1;
  STACKTOP = i64;
  return;
 } else if ((i66 | 0) == 28) {
  f69 = Math_fround(f49 * Math_fround(f51 + Math_fround(f2 * Math_fround(HEAPF32[i63 >> 2]))));
  f70 = Math_fround(f52 + Math_fround(f2 * Math_fround(HEAPF32[i46 >> 2])));
  f71 = Math_fround(f50 * Math_fround(f48 + Math_fround(f2 * Math_fround(HEAPF32[i47 >> 2]))));
  HEAPF32[i65 >> 2] = f69;
  HEAPF32[i65 + 4 >> 2] = f70;
  HEAPF32[i65 + 8 >> 2] = f71;
  HEAP32[i65 + 12 >> 2] = i1 << 1 | 1;
  HEAP8[i65 + 16 >> 0] = 1;
  STACKTOP = i64;
  return;
 } else if ((i66 | 0) == 35) {
  STACKTOP = i64;
  return;
 }
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI21BoxTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_(i17, i8, i9, i56, i10) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i56 = i56 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0, i58 = 0, i59 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i59 + 216 | 0;
 i53 = i59 + 24 | 0;
 i58 = i59 + 48 | 0;
 i11 = i59 + 8 | 0;
 i13 = i59 + 4 | 0;
 i12 = i59;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i17, i53);
 f28 = Math_fround(HEAPF32[i53 >> 2]);
 f45 = Math_fround(HEAPF32[i10 >> 2]);
 f28 = Math_fround(f28 - f45);
 i55 = i53 + 4 | 0;
 f29 = Math_fround(HEAPF32[i55 >> 2]);
 i7 = i10 + 4 | 0;
 f32 = Math_fround(HEAPF32[i7 >> 2]);
 f29 = Math_fround(f29 - f32);
 i54 = i53 + 8 | 0;
 f30 = Math_fround(HEAPF32[i54 >> 2]);
 i14 = i10 + 8 | 0;
 f31 = Math_fround(HEAPF32[i14 >> 2]);
 f30 = Math_fround(f30 - f31);
 HEAPF32[i53 >> 2] = f28;
 HEAPF32[i55 >> 2] = f29;
 HEAPF32[i54 >> 2] = f30;
 i54 = i53 + 12 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) + f45);
 i55 = i53 + 16 | 0;
 f32 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) + f32);
 i16 = i53 + 20 | 0;
 f31 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f31);
 HEAPF32[i54 >> 2] = f45;
 HEAPF32[i55 >> 2] = f32;
 HEAPF32[i16 >> 2] = f31;
 i16 = i17 + 12 | 0;
 i55 = HEAP32[i16 >> 2] | 0;
 HEAP8[i58 >> 0] = 0;
 i1 = i58 + 4 | 0;
 HEAP32[i1 >> 2] = i17;
 i2 = i58 + 8 | 0;
 HEAP32[i2 >> 2] = i55;
 i55 = i58 + 156 | 0;
 HEAP32[i55 >> 2] = 0;
 HEAP32[i58 + 160 >> 2] = 0;
 f31 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(f31 - Math_fround(HEAPF32[i8 >> 2]));
 i3 = i9 + 4 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i8 + 4 | 0;
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i4 >> 2]));
 i15 = i9 + 8 | 0;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 i5 = i8 + 8 | 0;
 f45 = Math_fround(f45 - Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i11 >> 2] = f31;
 HEAPF32[i11 + 4 >> 2] = f32;
 i6 = i11 + 8 | 0;
 HEAPF32[i6 >> 2] = f45;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i53, i54, i8, i11, Math_fround(1.0), i13, i12) | 0)) {
  STACKTOP = i59;
  return;
 }
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f28 = Math_fround(HEAPF32[i11 >> 2]);
 f23 = Math_fround(f24 * f28);
 f31 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(f24 * f31);
 f45 = Math_fround(HEAPF32[i8 >> 2]);
 f23 = Math_fround(f23 + f45);
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(f24 + f25);
 f30 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(f45 + Math_fround(f28 * f30));
 f30 = Math_fround(f25 + Math_fround(f31 * f30));
 f31 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround((f31 < f22 ? f31 : f22) - f18);
 i51 = HEAP32[i1 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i51 + 4 >> 2]);
 HEAPF32[i58 + 24 >> 2] = Math_fround(f19 * f29);
 HEAPF32[i58 + 28 >> 2] = Math_fround(Math_fround(f18 + (f31 > f22 ? f31 : f22)) * f29);
 i52 = HEAP32[i2 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i9 >> 2]);
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f31 = Math_fround((f29 < f45 ? f29 : f45) - f22);
 f18 = Math_fround(HEAPF32[i51 >> 2]);
 i50 = ~~Math_fround(Math_floor(Math_fround(f18 * f31)));
 i49 = HEAP32[i52 + 16 >> 2] | 0;
 i53 = i49 + -2 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i54 = i58 + 32 | 0;
 HEAP32[i54 >> 2] = (i50 | 0) > (i53 | 0) ? i53 : i50;
 i50 = ~~Math_fround(Math_ceil(Math_fround(f18 * Math_fround(f22 + (f29 > f45 ? f29 : f45)))));
 i49 = i49 + -1 | 0;
 i50 = (i50 | 0) > 0 ? i50 : 0;
 i53 = i58 + 36 | 0;
 HEAP32[i53 >> 2] = (i50 | 0) > (i49 | 0) ? i49 : i50;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 f29 = Math_fround(HEAPF32[i14 >> 2]);
 f31 = Math_fround((f45 < f25 ? f45 : f25) - f29);
 f19 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 i51 = ~~Math_fround(Math_floor(Math_fround(f19 * f31)));
 i52 = HEAP32[i52 + 20 >> 2] | 0;
 i50 = i52 + -2 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i49 = i58 + 40 | 0;
 HEAP32[i49 >> 2] = (i51 | 0) > (i50 | 0) ? i50 : i51;
 i51 = ~~Math_fround(Math_ceil(Math_fround(f19 * Math_fround(f29 + (f45 > f25 ? f45 : f25)))));
 i52 = i52 + -1 | 0;
 i51 = (i51 | 0) > 0 ? i51 : 0;
 i50 = i58 + 44 | 0;
 HEAP32[i50 >> 2] = (i51 | 0) > (i52 | 0) ? i52 : i51;
 f18 = Math_fround(Math_ceil(Math_fround(f22 * f18)));
 f19 = Math_fround(Math_ceil(Math_fround(f29 * f19)));
 i51 = i58 + 16 | 0;
 HEAP32[i51 >> 2] = ~~f18 + 1;
 i52 = i58 + 20 | 0;
 HEAP32[i52 >> 2] = ~~f19 + 1;
 i3 = HEAP32[i16 >> 2] | 0;
 i48 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i17 >> 2]);
 f22 = Math_fround(Math_fround(i3 + -1 | 0) * Math_fround(.99999988));
 f25 = Math_fround(Math_fround(i48 + -1 | 0) * Math_fround(.99999988));
 f23 = Math_fround(f23 * f29);
 f45 = Math_fround(Math_fround(1.00000001e-07) - f18);
 f23 = f23 > f45 ? f23 : f45;
 f22 = Math_fround(f18 + f22);
 f23 = f23 < f22 ? f23 : f22;
 f31 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f24 = Math_fround(f24 * f31);
 f32 = Math_fround(Math_fround(1.00000001e-07) - f19);
 f24 = f24 > f32 ? f24 : f32;
 f25 = Math_fround(f19 + f25);
 f24 = f24 < f25 ? f24 : f25;
 f29 = Math_fround(f28 * f29);
 f45 = f29 > f45 ? f29 : f45;
 f31 = Math_fround(f30 * f31);
 f32 = f31 > f32 ? f31 : f32;
 f22 = Math_fround((f45 < f22 ? f45 : f22) - f23);
 f25 = Math_fround((f32 < f25 ? f32 : f25) - f24);
 i46 = f22 >= Math_fround(0.0);
 f32 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = f25 >= Math_fround(0.0);
 f45 = i46 ? Math_fround(1.0) : Math_fround(-1.0);
 i46 = ~~f32;
 i47 = ~~f45;
 i1 = Math_fround(Math_abs(Math_fround(f22))) < Math_fround(1.00000001e-10);
 f32 = Math_fround(f32 * Math_fround(1.00000001e-10));
 f22 = i1 ? f32 : f22;
 i1 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(1.00000001e-10);
 f45 = Math_fround(f45 * Math_fround(1.00000001e-10));
 f25 = i1 ? f45 : f25;
 i1 = f22 > Math_fround(0.0);
 if (i1) f26 = Math_fround(Math_floor(Math_fround(f23))); else f26 = Math_fround(Math_ceil(Math_fround(f23)));
 i2 = f25 > Math_fround(0.0);
 if (i2) f27 = Math_fround(Math_floor(Math_fround(f24))); else f27 = Math_fround(Math_ceil(Math_fround(f24)));
 if (i1) {
  f20 = Math_fround(Math_ceil(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(1.0));
  f20 = f20 == f23 ? f45 : f20;
 } else {
  f20 = Math_fround(Math_floor(Math_fround(f23)));
  f45 = Math_fround(f20 + Math_fround(-1.0));
  f20 = f20 == f23 ? f45 : f20;
 }
 if (i2) {
  f21 = Math_fround(Math_ceil(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(1.0));
  f21 = f21 == f24 ? f45 : f21;
 } else {
  f21 = Math_fround(Math_floor(Math_fround(f24)));
  f45 = Math_fround(f21 + Math_fround(-1.0));
  f21 = f21 == f24 ? f45 : f21;
 }
 f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f22))));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f25))));
 i15 = i58 + 12 | 0;
 i16 = i58 + 48 | 0;
 i17 = ((i46 | 0) < 1) << 31 >> 31;
 i33 = i58 + 52 | 0;
 i34 = ((i47 | 0) < 1) << 31 >> 31;
 i35 = i58 + 56 | 0;
 i36 = i58 + 76 | 0;
 i37 = i58 + 80 | 0;
 i38 = i58 + 84 | 0;
 i39 = i58 + 88 | 0;
 i40 = i58 + 60 | 0;
 i41 = i58 + 64 | 0;
 i42 = i58 + 68 | 0;
 i43 = i58 + 72 | 0;
 i44 = i58 + 92 | 0;
 f45 = Math_fround(Math_fround(0.0) - f18);
 f29 = Math_fround(f18 + Math_fround(i3 | 0));
 f30 = Math_fround(Math_fround(0.0) - f19);
 f28 = Math_fround(f19 + Math_fround(i48 | 0));
 i10 = i58 + 76 | 0;
 i11 = i58 + 60 | 0;
 i12 = i57 + 4 | 0;
 i13 = i57 + 8 | 0;
 i14 = i57 + 12 | 0;
 f18 = Math_fround(Math_fround(f20 - f23) / f22);
 f19 = Math_fround(Math_fround(f21 - f24) / f25);
 i9 = ~~f26;
 i2 = ~~f27;
 L20 : while (1) {
  i8 = f18 < f19;
  f20 = i8 ? f18 : f19;
  if (!(HEAP8[i58 >> 0] | 0)) {
   HEAP8[i58 >> 0] = 1;
   HEAP32[i15 >> 2] = i56;
   HEAP32[i16 >> 2] = i48;
   HEAP32[i33 >> 2] = i17;
   HEAP32[i35 >> 2] = i34;
   HEAP32[i36 >> 2] = 1;
   HEAP32[i37 >> 2] = -1;
   HEAP32[i38 >> 2] = 1;
   HEAP32[i39 >> 2] = -1;
   i4 = HEAP32[i51 >> 2] | 0;
   i5 = i9 - i4 | 0;
   HEAP32[i40 >> 2] = i5;
   i4 = i4 + i9 | 0;
   HEAP32[i41 >> 2] = i4;
   i1 = HEAP32[i52 >> 2] | 0;
   HEAP32[i42 >> 2] = i2 - i1;
   i1 = i1 + i2 | 0;
   HEAP32[i43 >> 2] = i1;
   i5 = i17 + i5 | 0;
   if ((i5 | 0) > (i4 + i17 | 0)) i1 = i56; else {
    i3 = i34;
    i7 = i17;
    while (1) {
     if ((i5 | 0) < (HEAP32[i54 >> 2] | 0)) i6 = i7; else {
      if ((i5 | 0) >= (HEAP32[i53 >> 2] | 0)) break;
      i6 = i3 + (HEAP32[i42 >> 2] | 0) | 0;
      if ((i6 | 0) > (i1 + i3 | 0)) i6 = i7; else {
       i4 = i6;
       while (1) {
        if ((i4 | 0) >= (HEAP32[i49 >> 2] | 0)) {
         if ((i4 | 0) >= (HEAP32[i50 >> 2] | 0)) break;
         if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj(i58, (Math_imul(HEAP32[i16 >> 2] | 0, i5) | 0) + i4 | 0) | 0)) {
          i1 = 44;
          break L20;
         }
         i1 = HEAP32[i43 >> 2] | 0;
         i3 = HEAP32[i35 >> 2] | 0;
        }
        if ((i4 | 0) < (i1 + i3 | 0)) i4 = i4 + 1 | 0; else break;
       }
       i4 = HEAP32[i41 >> 2] | 0;
       i6 = HEAP32[i33 >> 2] | 0;
      }
     }
     if ((i5 | 0) < (i4 + i6 | 0)) {
      i7 = i6;
      i5 = i5 + 1 | 0;
     } else break;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 44;
    break;
   }
   HEAP32[i55 >> 2] = 0;
  } else {
   i4 = HEAP32[i51 >> 2] | 0;
   i3 = i9 - i4 | 0;
   HEAP32[i10 >> 2] = i3;
   i4 = i4 + i9 | 0;
   HEAP32[i37 >> 2] = i4;
   i6 = HEAP32[i52 >> 2] | 0;
   i5 = i2 - i6 | 0;
   HEAP32[i38 >> 2] = i5;
   i6 = i6 + i2 | 0;
   HEAP32[i39 >> 2] = i6;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) {
    i1 = HEAP32[i42 >> 2] | 0;
    if ((i5 | 0) != (i1 | 0)) {
     HEAP8[i57 >> 0] = 1;
     HEAP32[i12 >> 2] = (i5 | 0) < (i1 | 0) ? i5 : i6;
     HEAP32[i13 >> 2] = i3;
     HEAP32[i14 >> 2] = i4;
    }
   } else {
    HEAP8[i57 >> 0] = 0;
    HEAP32[i12 >> 2] = (i3 | 0) < (i1 | 0) ? i3 : i4;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i14 >> 2] = i6;
   }
   if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE(i58, i57) | 0)) {
    i1 = 36;
    break;
   }
   i7 = HEAP32[i15 >> 2] | 0;
   if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, HEAP32[i55 >> 2] | 0, i44 | 0) | 0)) {
    i1 = 36;
    break;
   }
   HEAP32[i55 >> 2] = 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  }
  if (i8) {
   i1 = i9 + i46 | 0;
   f27 = Math_fround(i1 + i46 | 0);
   if (!(!(f27 < f45) & !(f27 >= f29))) {
    i1 = 44;
    break;
   }
   f18 = Math_fround(f31 + f18);
  } else {
   i2 = i2 + i47 | 0;
   f27 = Math_fround(i2 + i47 | 0);
   if (!(!(f27 < f30) & !(f27 >= f28))) {
    i1 = 44;
    break;
   }
   f19 = Math_fround(f32 + f19);
   i1 = i9;
  }
  if (f20 < Math_fround(1.00010002)) i9 = i1; else {
   i1 = 44;
   break;
  }
 }
 if ((i1 | 0) == 36) {
  STACKTOP = i59;
  return;
 } else if ((i1 | 0) == 44) {
  STACKTOP = i59;
  return;
 }
}

function __ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb(i32, i48, i44, f33, i49, f4, i2, i38, i40, i42, i39, i41, i43, i46, i1) {
 i32 = i32 | 0;
 i48 = i48 | 0;
 i44 = i44 | 0;
 f33 = Math_fround(f33);
 i49 = i49 | 0;
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 i38 = i38 | 0;
 i40 = i40 | 0;
 i42 = i42 | 0;
 i39 = i39 | 0;
 i41 = i41 | 0;
 i43 = i43 | 0;
 i46 = i46 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i45 = 0, i47 = 0, i50 = 0, f51 = f0, i52 = 0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i50 + 28 | 0;
 i31 = i50 + 24 | 0;
 i45 = i50 + 12 | 0;
 i47 = i50;
 if (!i32) {
  i49 = 0;
  STACKTOP = i50;
  return i49 | 0;
 }
 i37 = i1 ^ 1;
 if (!i2) i30 = 0; else i30 = HEAP32[i2 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i44 >> 2]);
 f27 = Math_fround(f27 * Math_fround(HEAPF32[i49 >> 2]));
 f26 = Math_fround(HEAPF32[i44 + 4 >> 2]);
 i36 = i49 + 4 | 0;
 f26 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i36 >> 2])));
 f27 = Math_fround(HEAPF32[i44 + 8 >> 2]);
 i35 = i49 + 8 | 0;
 f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i35 >> 2])));
 i28 = i34 + 4 | 0;
 i29 = i34 + 8 | 0;
 if ((i46 ^ 1) & i37) {
  i23 = 0;
  i22 = 0;
  i20 = 0;
  f25 = f4;
  i24 = 0;
  i5 = -1;
  f26 = Math_fround(2.0);
  while (1) {
   i21 = (i24 | 0) == 0 ? i30 : (i24 | 0) == (i30 | 0) ? 0 : i24;
   i1 = i48 + (i21 * 36 | 0) | 0;
   do if (__ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE(i44, i49, f25, f33, i1) | 0) {
    f4 = Math_fround(HEAPF32[i1 >> 2]);
    f17 = Math_fround(HEAPF32[i49 >> 2]);
    f8 = Math_fround(f4 * f17);
    f6 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i36 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f6 * f18));
    f7 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i35 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f7 * f19));
    f9 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 12 >> 2]);
    f12 = Math_fround(f17 * f9);
    f10 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 16 >> 2]);
    f12 = Math_fround(f12 + Math_fround(f18 * f10));
    f11 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 20 >> 2]);
    f12 = Math_fround(f12 + Math_fround(f19 * f11));
    f13 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 24 >> 2]);
    f16 = Math_fround(f17 * f13);
    f14 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 28 >> 2]);
    f16 = Math_fround(f16 + Math_fround(f18 * f14));
    f15 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 32 >> 2]);
    f16 = Math_fround(f16 + Math_fround(f19 * f15));
    f51 = f8 < f12 ? f8 : f12;
    if ((f51 < f16 ? f51 : f16) > Math_fround(Math_fround(Math_fround(f27 + f25) + f33) + Math_fround(.00999999977))) {
     i1 = i20;
     i2 = i22;
     i3 = i23;
     f4 = f25;
     f6 = f26;
    } else if (f8 < f27 & f12 < f27 & f16 < f27) {
     i1 = i20;
     i2 = i22;
     i3 = i23;
     f4 = f25;
     f6 = f26;
    } else {
     f12 = Math_fround(f9 - f4);
     f51 = Math_fround(f10 - f6);
     f11 = Math_fround(f11 - f7);
     f9 = Math_fround(f13 - f4);
     f16 = Math_fround(f14 - f6);
     f8 = Math_fround(f15 - f7);
     f6 = Math_fround(Math_fround(f51 * f8) - Math_fround(f11 * f16));
     f8 = Math_fround(Math_fround(f11 * f9) - Math_fround(f12 * f8));
     f9 = Math_fround(Math_fround(f12 * f16) - Math_fround(f51 * f9));
     HEAPF32[i34 >> 2] = f6;
     HEAPF32[i28 >> 2] = f8;
     HEAPF32[i29 >> 2] = f9;
     if (Math_fround(Math_fround(Math_fround(f6 * f17) + Math_fround(f8 * f18)) + Math_fround(f9 * f19)) > Math_fround(0.0)) {
      i1 = i20;
      i2 = i22;
      i3 = i23;
      f4 = f25;
      f6 = f26;
     } else {
      f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f8 * f8)) + Math_fround(f9 * f9))));
      if (f4 == Math_fround(0.0)) {
       i1 = i20;
       i2 = i22;
       i3 = i23;
       f4 = f25;
       f6 = f26;
      } else {
       f4 = Math_fround(Math_fround(1.0) / f4);
       f7 = Math_fround(f6 * f4);
       HEAPF32[i34 >> 2] = f7;
       f6 = Math_fround(f4 * f8);
       HEAPF32[i28 >> 2] = f6;
       f4 = Math_fround(f4 * f9);
       HEAPF32[i29 >> 2] = f4;
       i52 = __ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf(i1, i34, i44, f33, i49, i31) | 0;
       i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
       i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
       if (i52) {
        f7 = Math_fround(f7 * Math_fround(HEAPF32[i49 >> 2]));
        f6 = Math_fround(f7 + Math_fround(f6 * Math_fround(HEAPF32[i36 >> 2])));
        f6 = Math_fround(-Math_fround(Math_abs(Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i35 >> 2]))))));
        f4 = Math_fround(HEAPF32[i31 >> 2]);
        f7 = f4 > f25 ? f4 : f25;
        i52 = f7 < Math_fround(1.0);
        f7 = Math_fround(f7 * Math_fround(.00100000005));
        f7 = i52 ? Math_fround(.00100000005) : f7;
        if (!(Math_fround(f25 - f7) > f4)) if (!(f26 > f6 & Math_fround(f25 + f7) > f4)) {
         i1 = i20;
         i2 = i22;
         i3 = i23;
         f4 = f25;
         f6 = f26;
         break;
        }
        i5 = i21;
       } else {
        i1 = i20;
        i2 = i22;
        i3 = i23;
        f4 = f25;
        f6 = f26;
       }
      }
     }
    }
   } else {
    i1 = i20;
    i2 = i22;
    i3 = i23;
    f4 = f25;
    f6 = f26;
   } while (0);
   i24 = i24 + 1 | 0;
   if ((i24 | 0) == (i32 | 0)) break; else {
    i23 = i3;
    i22 = i2;
    i20 = i1;
    f25 = f4;
    f26 = f6;
   }
  }
 } else {
  i23 = 0;
  i22 = 0;
  i20 = 0;
  f17 = f4;
  i24 = 0;
  i5 = -1;
  f18 = Math_fround(2.0);
  while (1) {
   i21 = (i24 | 0) == 0 ? i30 : (i24 | 0) == (i30 | 0) ? 0 : i24;
   i1 = i48 + (i21 * 36 | 0) | 0;
   do if (__ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE(i44, i49, f17, f33, i1) | 0) {
    f4 = Math_fround(HEAPF32[i1 >> 2]);
    f15 = Math_fround(HEAPF32[i49 >> 2]);
    f8 = Math_fround(f4 * f15);
    f6 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 4 >> 2]);
    f51 = Math_fround(HEAPF32[i36 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f6 * f51));
    f7 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 8 >> 2]);
    f16 = Math_fround(HEAPF32[i35 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f7 * f16));
    f9 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 12 >> 2]);
    f12 = Math_fround(f15 * f9);
    f10 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 16 >> 2]);
    f12 = Math_fround(f12 + Math_fround(f51 * f10));
    f11 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 20 >> 2]);
    f12 = Math_fround(f12 + Math_fround(f16 * f11));
    f13 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 24 >> 2]);
    f15 = Math_fround(f15 * f13);
    f14 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 28 >> 2]);
    f51 = Math_fround(f15 + Math_fround(f51 * f14));
    f15 = Math_fround(HEAPF32[i48 + (i21 * 36 | 0) + 32 >> 2]);
    f16 = Math_fround(f51 + Math_fround(f16 * f15));
    f51 = f8 < f12 ? f8 : f12;
    if ((f51 < f16 ? f51 : f16) > Math_fround(Math_fround(Math_fround(f27 + f17) + f33) + Math_fround(.00999999977))) {
     i1 = i20;
     i2 = i22;
     i3 = i23;
     f4 = f17;
     f6 = f18;
    } else if (f8 < f27 & f12 < f27 & f16 < f27) {
     i1 = i20;
     i2 = i22;
     i3 = i23;
     f4 = f17;
     f6 = f18;
    } else {
     f26 = Math_fround(f9 - f4);
     f51 = Math_fround(f10 - f6);
     f25 = Math_fround(f11 - f7);
     f8 = Math_fround(f13 - f4);
     f6 = Math_fround(f14 - f6);
     f7 = Math_fround(f15 - f7);
     f4 = Math_fround(Math_fround(f51 * f7) - Math_fround(f25 * f6));
     f7 = Math_fround(Math_fround(f25 * f8) - Math_fround(f26 * f7));
     f8 = Math_fround(Math_fround(f26 * f6) - Math_fround(f51 * f8));
     HEAPF32[i34 >> 2] = f4;
     HEAPF32[i28 >> 2] = f7;
     HEAPF32[i29 >> 2] = f8;
     f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)) + Math_fround(f8 * f8))));
     if (f6 == Math_fround(0.0)) {
      i1 = i20;
      i2 = i22;
      i3 = i23;
      f4 = f17;
      f6 = f18;
     } else {
      f51 = Math_fround(Math_fround(1.0) / f6);
      f9 = Math_fround(f4 * f51);
      HEAPF32[i34 >> 2] = f9;
      f6 = Math_fround(f51 * f7);
      HEAPF32[i28 >> 2] = f6;
      f4 = Math_fround(f51 * f8);
      HEAPF32[i29 >> 2] = f4;
      i52 = __ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf(i1, i34, i44, f33, i49, i31) | 0;
      i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
      if (i52) {
       f7 = Math_fround(f9 * Math_fround(HEAPF32[i49 >> 2]));
       f6 = Math_fround(f7 + Math_fround(f6 * Math_fround(HEAPF32[i36 >> 2])));
       f6 = Math_fround(-Math_fround(Math_abs(Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i35 >> 2]))))));
       f4 = Math_fround(HEAPF32[i31 >> 2]);
       f7 = f4 > f17 ? f4 : f17;
       i52 = f7 < Math_fround(1.0);
       f7 = Math_fround(f7 * Math_fround(.00100000005));
       f7 = i52 ? Math_fround(.00100000005) : f7;
       if (!(Math_fround(f17 - f7) > f4)) if (!(f18 > f6 & Math_fround(f17 + f7) > f4)) {
        i1 = i20;
        i2 = i22;
        i3 = i23;
        f4 = f17;
        f6 = f18;
        break;
       }
       i5 = i21;
      } else {
       i1 = i20;
       i2 = i22;
       i3 = i23;
       f4 = f17;
       f6 = f18;
      }
     }
    }
   } else {
    i1 = i20;
    i2 = i22;
    i3 = i23;
    f4 = f17;
    f6 = f18;
   } while (0);
   i24 = i24 + 1 | 0;
   if ((i24 | 0) == (i32 | 0)) break; else {
    i23 = i3;
    i22 = i2;
    i20 = i1;
    f17 = f4;
    f18 = f6;
   }
  }
 }
 if ((i5 | 0) == -1) {
  i52 = 0;
  STACKTOP = i50;
  return i52 | 0;
 }
 __ZN5physx2Gu26computeSphereTriImpactDataERNS_6PxVec3ES2_RKS1_S4_fRKNS_10PxTriangleE(i45, i47, i44, i49, f4, i48 + (i5 * 36 | 0) | 0);
 if (!(i46 | i37)) {
  f51 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f51 = Math_fround(f51 * Math_fround(HEAPF32[i49 >> 2]));
  f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = Math_fround(f51 + Math_fround(f33 * Math_fround(HEAPF32[i36 >> 2])));
  f51 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(f33 + Math_fround(f51 * Math_fround(HEAPF32[i35 >> 2]))) > Math_fround(0.0)) {
   f27 = Math_fround(-Math_fround(HEAPF32[i47 >> 2]));
   i49 = i47 + 4 | 0;
   f33 = Math_fround(-Math_fround(HEAPF32[i49 >> 2]));
   i52 = i47 + 8 | 0;
   f51 = Math_fround(-Math_fround(HEAPF32[i52 >> 2]));
   HEAPF32[i47 >> 2] = f27;
   HEAPF32[i49 >> 2] = f33;
   HEAPF32[i52 >> 2] = f51;
  }
 }
 HEAP32[i38 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i38 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i38 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i40 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 HEAPF32[i42 >> 2] = f4;
 HEAP32[i39 >> 2] = i5;
 HEAP16[i41 >> 1] = 7;
 HEAP32[i43 >> 2] = i3;
 HEAP32[i43 + 4 >> 2] = i2;
 HEAP32[i43 + 8 >> 2] = i1;
 i52 = 1;
 STACKTOP = i50;
 return i52 | 0;
}

function __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[i7 + 36 >> 2] | 0, 0, 0) | 0;
 i6 = HEAP32[i7 + 28 >> 2] | 0;
 i1 = i6 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i6, HEAP32[i1 >> 2] | 0);
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i7 + 32 >> 2] | 0;
 i6 = i1 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i6 >> 2] | 0);
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[i7 + 40 >> 2] | 0;
 i1 = i6 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i6, HEAP32[i1 >> 2] | 0);
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = 0;
 do {
  i3 = i7 + 44 + (i1 << 5) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = i7 + 44 + (i1 << 5) + 4 | 0;
  if (i4 | 0) if (HEAP32[i2 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i4, i7 + 44 + (i1 << 5) + 24 | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i7 + 44 + (i1 << 5) + 20 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i6 = i7 + 1068 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i7 + 1072 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1 + -40 | 0;
  HEAP32[i5 >> 2] = i2;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i1 = i2; else if (!(HEAP32[i1 + -36 >> 2] | 0)) i1 = i2; else {
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + -16 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
  }
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i2 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i8 + 32 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP8[i8 + 36 >> 0] = 0;
 if ((i4 | 0) == (HEAP32[i7 + 1076 >> 2] | 0)) __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i6, i8); else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  i12 = i2;
  i3 = HEAP32[i12 + 4 >> 2] | 0;
  i11 = i4 + 24 | 0;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i11 + 4 >> 2] = i3;
  HEAP8[i4 + 4 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i4, i8);
  i11 = i4 + 32 | 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP8[i11 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 40;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 i1 = HEAP32[i6 >> 2] | 0;
 __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i1, gb + 1012705 | 0) | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i7 + 1080 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 1635020373;
 HEAP32[i2 + 4 >> 2] = 1684367207;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 8;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 0, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[gb + 371154 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 371154 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 371154 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 371154 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 371154 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 371154 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[gb + 371154 + 6 >> 0] | 0;
 HEAP8[i8 + 11 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 7;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 1, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[gb + 371162 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 371162 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 371162 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 371162 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 371162 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 371162 + 5 >> 0] | 0;
 HEAP8[i8 + 10 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 6;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 2, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i8 + 4 | 0;
 i4 = gb + 371169 | 0;
 i5 = i3 + 10 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i8 + 14 >> 0] = 0;
 HEAP32[i1 >> 2] = 10;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 3, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i8 + 4 | 0;
 i4 = gb + 371180 | 0;
 i5 = i3 + 10 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i8 + 14 >> 0] = 0;
 HEAP32[i1 >> 2] = 10;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 5, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i8 + 4 | 0;
 i4 = gb + 371191 | 0;
 i5 = i3 + 14 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i8 + 18 >> 0] = 0;
 HEAP32[i1 >> 2] = 14;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 7, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[gb + 371206 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 371206 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 371206 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 371206 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 371206 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 371206 + 5 >> 0] | 0;
 HEAP8[i8 + 10 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 6;
 __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 6, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[gb + 1012705 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1012705 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1012705 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1012705 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1012705 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1012705 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[gb + 1012705 + 6 >> 0] | 0;
 HEAP8[i8 + 11 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 7;
 __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 0, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i8 + 4 | 0;
 i4 = gb + 371213 | 0;
 i5 = i3 + 13 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i8 + 17 >> 0] = 0;
 HEAP32[i1 >> 2] = 13;
 __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 1, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i8 + 4 | 0;
 i4 = gb + 371227 | 0;
 i5 = i3 + 14 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i8 + 18 >> 0] = 0;
 HEAP32[i1 >> 2] = 14;
 __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 2, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i8 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[gb + 371242 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 371242 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 371242 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 371242 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 371242 + 4 >> 0] | 0;
 HEAP8[i8 + 9 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 5;
 __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 4, i8);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = i8 + 4 | 0;
 HEAP16[i1 >> 1] = 18773;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP32[i8 + 20 >> 2] = 2;
 __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, 5, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __ZN12SoundManager19CaptureProfilerInfoER13dynamic_arrayI21AudioProfilerClipInfoLj4EERS0_IcLj1EE(i21, i22, i23) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = HEAP32[i21 + 12 >> 2] | 0;
 i18 = i21 + 8 | 0;
 i1 = i2;
 if ((i1 | 0) != (i18 | 0)) {
  i19 = i23 + 12 | 0;
  i20 = i23 + 16 | 0;
  i14 = i23 + 4 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 4 | 0;
  do {
   i11 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i11 = HEAP32[i11 + 8 >> 2] | 0;
   i1 = HEAP32[i11 + 52 >> 2] | 0;
   if (i1 | 0) {
    i12 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = HEAP32[i19 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (HEAP8[i1 >> 0] | 0) do {
     i4 = HEAP32[i19 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i20 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i3 = i6 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i20 >> 2] = i3;
       HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i3, 1, i14, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i14, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i10 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
       HEAP32[i20 >> 2] = i3;
       HEAP32[i23 >> 2] = i10;
       break;
      }
     } while (0);
     HEAP32[i19 >> 2] = i5;
     HEAP8[(HEAP32[i23 >> 2] | 0) + i4 >> 0] = HEAP8[i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i1 >> 0] | 0) != 0);
    i3 = HEAP32[i19 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i20 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i20 >> 2] = i1;
      HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1, 1, i14, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i14, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
      HEAP32[i20 >> 2] = i1;
      HEAP32[i23 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i19 >> 2] = i4;
    HEAP8[(HEAP32[i23 >> 2] | 0) + i3 >> 0] = 0;
    i8 = HEAP32[i11 + 44 >> 2] | 0;
    i9 = HEAP32[i11 + 112 >> 2] | 0;
    i10 = HEAPU8[i11 + 116 >> 0] | 0;
    i4 = i11 + 28 | 0;
    i1 = HEAP32[i11 + 32 >> 2] | 0;
    if ((i1 | 0) == (i4 | 0)) i3 = 0; else {
     i3 = 0;
     do {
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
     } while ((i1 | 0) != (i4 | 0));
    }
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i16 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i1 = i6 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i16 >> 2] = i1;
      HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 28 | 0, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 28 | 0) | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP32[i22 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i5;
    i11 = HEAP32[i22 >> 2] | 0;
    HEAP32[i11 + (i4 * 28 | 0) >> 2] = i12;
    HEAP32[i11 + (i4 * 28 | 0) + 4 >> 2] = i13;
    HEAP32[i11 + (i4 * 28 | 0) + 8 >> 2] = i8;
    HEAP32[i11 + (i4 * 28 | 0) + 12 >> 2] = 0;
    HEAP32[i11 + (i4 * 28 | 0) + 16 >> 2] = i9;
    HEAP32[i11 + (i4 * 28 | 0) + 20 >> 2] = i10;
    HEAP32[i11 + (i4 * 28 | 0) + 24 >> 2] = i3;
   }
   i1 = i2;
  } while ((i1 | 0) != (i18 | 0));
 }
 i1 = HEAP32[i21 + 20 >> 2] | 0;
 i14 = i21 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) != (i14 | 0)) {
  i15 = i23 + 12 | 0;
  i16 = i23 + 16 | 0;
  i17 = i23 + 4 | 0;
  i18 = i22 + 12 | 0;
  i19 = i22 + 16 | 0;
  i20 = i22 + 4 | 0;
  do {
   i11 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i11 = HEAP32[i11 + 8 >> 2] | 0;
   i2 = HEAP32[i11 + 52 >> 2] | 0;
   if (i2 | 0) {
    i12 = HEAP32[i2 + 4 >> 2] | 0;
    i13 = HEAP32[i15 >> 2] | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    if (HEAP8[i2 >> 0] | 0) do {
     i4 = HEAP32[i15 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i16 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i3 = i6 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i16 >> 2] = i3;
       HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i3, 1, i17, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i17, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i10 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
       HEAP32[i16 >> 2] = i3;
       HEAP32[i23 >> 2] = i10;
       break;
      }
     } while (0);
     HEAP32[i15 >> 2] = i5;
     HEAP8[(HEAP32[i23 >> 2] | 0) + i4 >> 0] = HEAP8[i2 >> 0] | 0;
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) != 0);
    i3 = HEAP32[i15 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i16 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i16 >> 2] = i2;
      HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i2, 1, i17, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
      HEAP32[i16 >> 2] = i2;
      HEAP32[i23 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i4;
    HEAP8[(HEAP32[i23 >> 2] | 0) + i3 >> 0] = 0;
    i8 = HEAP32[i11 + 44 >> 2] | 0;
    i9 = HEAP32[i11 + 112 >> 2] | 0;
    i10 = HEAPU8[i11 + 116 >> 0] | 0;
    i4 = i11 + 28 | 0;
    i2 = HEAP32[i11 + 32 >> 2] | 0;
    if ((i2 | 0) == (i4 | 0)) i3 = 0; else {
     i3 = 0;
     do {
      i3 = i3 + 1 | 0;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
     } while ((i2 | 0) != (i4 | 0));
    }
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i19 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i19 >> 2] = i2;
      HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i2 * 28 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 28 | 0) | 0;
      HEAP32[i19 >> 2] = i2;
      HEAP32[i22 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i18 >> 2] = i5;
    i11 = HEAP32[i22 >> 2] | 0;
    HEAP32[i11 + (i4 * 28 | 0) >> 2] = i12;
    HEAP32[i11 + (i4 * 28 | 0) + 4 >> 2] = i13;
    HEAP32[i11 + (i4 * 28 | 0) + 8 >> 2] = i8;
    HEAP32[i11 + (i4 * 28 | 0) + 12 >> 2] = 1;
    HEAP32[i11 + (i4 * 28 | 0) + 16 >> 2] = i9;
    HEAP32[i11 + (i4 * 28 | 0) + 20 >> 2] = i10;
    HEAP32[i11 + (i4 * 28 | 0) + 24 >> 2] = i3;
   }
   i2 = i1;
  } while ((i2 | 0) != (i14 | 0));
 }
 i2 = HEAP32[i21 + 28 >> 2] | 0;
 i14 = i21 + 24 | 0;
 i1 = i2;
 if ((i1 | 0) == (i14 | 0)) return;
 i15 = i23 + 12 | 0;
 i16 = i23 + 16 | 0;
 i17 = i23 + 4 | 0;
 i18 = i22 + 12 | 0;
 i19 = i22 + 16 | 0;
 i20 = i22 + 4 | 0;
 do {
  i9 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = HEAP32[i9 + 8 >> 2] | 0;
  i5 = HEAP32[i9 + 52 >> 2] | 0;
  if (i5 | 0) {
   i10 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = HEAP32[i15 >> 2] | 0;
   i12 = HEAP32[i9 + 112 >> 2] | 0;
   i13 = HEAPU8[i9 + 116 >> 0] | 0;
   i4 = i9 + 28 | 0;
   i1 = HEAP32[i9 + 32 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i3 = 0; else {
    i3 = 0;
    do {
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    } while ((i1 | 0) != (i4 | 0));
   }
   i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
   if (HEAP8[i1 >> 0] | 0) do {
    i5 = HEAP32[i15 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = HEAP32[i16 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i6 >>> 0 > i8 >>> 0) {
     i4 = i7 << 1;
     i4 = (i4 | 0) == 0 ? 1 : i4;
     if (i8 >>> 0 < i4 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i16 >> 2] = i4;
      HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i4, 1, i17, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i21 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
      HEAP32[i16 >> 2] = i4;
      HEAP32[i23 >> 2] = i21;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i6;
    HEAP8[(HEAP32[i23 >> 2] | 0) + i5 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((HEAP8[i1 >> 0] | 0) != 0);
   i4 = HEAP32[i15 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i16 >> 2] = i1;
     HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1, 1, i17, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i17, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i21 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
     HEAP32[i16 >> 2] = i1;
     HEAP32[i23 >> 2] = i21;
     break;
    }
   } while (0);
   HEAP32[i15 >> 2] = i5;
   HEAP8[(HEAP32[i23 >> 2] | 0) + i4 >> 0] = 0;
   i4 = HEAP32[i9 + 44 >> 2] | 0;
   i5 = HEAP32[i18 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i7 = HEAP32[i19 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i6 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i19 >> 2] = i1;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 28 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i21 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 28 | 0) | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i22 >> 2] = i21;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i6;
   i21 = HEAP32[i22 >> 2] | 0;
   HEAP32[i21 + (i5 * 28 | 0) >> 2] = i10;
   HEAP32[i21 + (i5 * 28 | 0) + 4 >> 2] = i11;
   HEAP32[i21 + (i5 * 28 | 0) + 8 >> 2] = i4;
   HEAP32[i21 + (i5 * 28 | 0) + 12 >> 2] = 2;
   HEAP32[i21 + (i5 * 28 | 0) + 16 >> 2] = i12;
   HEAP32[i21 + (i5 * 28 | 0) + 20 >> 2] = i13;
   HEAP32[i21 + (i5 * 28 | 0) + 24 >> 2] = i3;
  }
  i1 = i2;
 } while ((i1 | 0) != (i14 | 0));
 return;
}

function __ZN5physx16applyConstraintsERKNS_6PxVec3ERS0_S2_RPKNS_11PxsBodyCoreES3_S3_PKNS_18PxsFluidConstraintESA_S6_S6_S2_S2_jRKNS_27PxsFluidCollisionParametersERKNS_16PxvParticleFlagsE(i32, i49, i26, i31, i29, i30, i40, i38, i24, i3, i25, i22, i28, i27, i1) {
 i32 = i32 | 0;
 i49 = i49 | 0;
 i26 = i26 | 0;
 i31 = i31 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i40 = i40 | 0;
 i38 = i38 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i22 = i22 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i23 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, f51 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i50 + 24 | 0;
 i2 = i50 + 12 | 0;
 i23 = i50;
 i33 = HEAP32[i49 >> 2] | 0;
 HEAP32[i46 >> 2] = i33;
 i44 = i46 + 4 | 0;
 i47 = i49 + 4 | 0;
 i36 = HEAP32[i47 >> 2] | 0;
 HEAP32[i44 >> 2] = i36;
 i45 = i46 + 8 | 0;
 i48 = i49 + 8 | 0;
 i41 = HEAP32[i48 >> 2] | 0;
 HEAP32[i45 >> 2] = i41;
 f4 = Math_fround(HEAPF32[i32 >> 2]);
 f14 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f4 + f14);
 i33 = i32 + 4 | 0;
 f5 = Math_fround(HEAPF32[i33 >> 2]);
 f10 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 + f10);
 i36 = i32 + 8 | 0;
 f6 = Math_fround(HEAPF32[i36 >> 2]);
 f15 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 + f15);
 f11 = Math_fround(HEAPF32[i40 >> 2]);
 f9 = Math_fround(f4 * f11);
 i41 = i40 + 4 | 0;
 f12 = Math_fround(HEAPF32[i41 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f5 * f12));
 i42 = i40 + 8 | 0;
 f13 = Math_fround(HEAPF32[i42 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f6 * f13));
 do if (!(HEAP16[i1 + 2 >> 1] & 2)) {
  i1 = i40 + 12 | 0;
  if (!(f9 < Math_fround(HEAPF32[i1 >> 2]))) {
   i49 = 0;
   STACKTOP = i50;
   return i49 | 0;
  }
  HEAP32[i31 >> 2] = i24;
  HEAPF32[i29 >> 2] = f11;
  HEAPF32[i29 + 4 >> 2] = f12;
  HEAPF32[i29 + 8 >> 2] = f13;
  HEAP32[i30 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  f20 = Math_fround(HEAPF32[i27 + 68 >> 2]);
  f19 = Math_fround(f20 * f10);
  f21 = Math_fround(f20 * f15);
  HEAPF32[i2 >> 2] = Math_fround(f20 * f14);
  HEAPF32[i2 + 4 >> 2] = f19;
  HEAPF32[i2 + 8 >> 2] = f21;
  __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE(i46, i2, i26, i40, i25, i28, i27);
  f21 = Math_fround(HEAPF32[i27 + 64 >> 2]);
  f19 = Math_fround(f21 * Math_fround(HEAPF32[i46 >> 2]));
  HEAPF32[i46 >> 2] = f19;
  f20 = Math_fround(f21 * Math_fround(HEAPF32[i44 >> 2]));
  HEAPF32[i44 >> 2] = f20;
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i45 >> 2]));
  HEAPF32[i45 >> 2] = f21;
  f13 = Math_fround(HEAPF32[i32 >> 2]);
  f14 = Math_fround(f13 + f19);
  f11 = Math_fround(HEAPF32[i33 >> 2]);
  f12 = Math_fround(f11 + f20);
  f9 = Math_fround(HEAPF32[i36 >> 2]);
  f10 = Math_fround(f21 + f9);
  f8 = Math_fround(HEAPF32[i40 >> 2]);
  f6 = Math_fround(f14 * f8);
  f7 = Math_fround(HEAPF32[i41 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f12 * f7));
  f5 = Math_fround(HEAPF32[i42 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f10 * f5));
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  if (f4 > f6) {
   f6 = Math_fround(Math_fround(f4 - f6) * Math_fround(1.00999999));
   f8 = Math_fround(Math_fround(f14 + Math_fround(f8 * f6)) - f13);
   f7 = Math_fround(Math_fround(f12 + Math_fround(f7 * f6)) - f11);
   f6 = Math_fround(Math_fround(f10 + Math_fround(f5 * f6)) - f9);
   HEAPF32[i46 >> 2] = f8;
   HEAPF32[i44 >> 2] = f7;
   HEAPF32[i45 >> 2] = f6;
   i43 = 20;
  }
 } else {
  f8 = Math_fround(HEAPF32[i38 >> 2]);
  f21 = Math_fround(f4 * f8);
  i34 = i38 + 4 | 0;
  f7 = Math_fround(HEAPF32[i34 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f5 * f7));
  i35 = i38 + 8 | 0;
  f4 = Math_fround(HEAPF32[i35 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f6 * f4));
  i37 = i40 + 12 | 0;
  i2 = f9 < Math_fround(HEAPF32[i37 >> 2]);
  i39 = i38 + 12 | 0;
  i1 = f21 < Math_fround(HEAPF32[i39 >> 2]);
  do if (i2) {
   HEAP32[i31 >> 2] = i24;
   HEAPF32[i29 >> 2] = f11;
   HEAPF32[i29 + 4 >> 2] = f12;
   HEAPF32[i29 + 8 >> 2] = f13;
   HEAP32[i30 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
   if (i1) {
    f6 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i27 + 20 >> 2]));
    f4 = Math_fround(f14 * f6);
    HEAPF32[i46 >> 2] = f4;
    f5 = Math_fround(f6 * f10);
    HEAPF32[i44 >> 2] = f5;
    f6 = Math_fround(f6 * f15);
   } else i43 = 9;
  } else if (i1) {
   HEAP32[i31 >> 2] = i3;
   HEAPF32[i29 >> 2] = f8;
   HEAPF32[i29 + 4 >> 2] = f7;
   HEAPF32[i29 + 8 >> 2] = f4;
   HEAP32[i30 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i43 = 9;
   break;
  } else {
   i49 = 0;
   STACKTOP = i50;
   return i49 | 0;
  } while (0);
  if ((i43 | 0) == 9) {
   f5 = Math_fround(HEAPF32[i27 + 68 >> 2]);
   f4 = Math_fround(f5 * f10);
   f6 = Math_fround(f5 * f15);
   HEAPF32[i23 >> 2] = Math_fround(f5 * f14);
   HEAPF32[i23 + 4 >> 2] = f4;
   HEAPF32[i23 + 8 >> 2] = f6;
   __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE(i46, i23, i26, i29, i30, i28, i27);
   f6 = Math_fround(HEAPF32[i27 + 64 >> 2]);
   f4 = Math_fround(f6 * Math_fround(HEAPF32[i46 >> 2]));
   HEAPF32[i46 >> 2] = f4;
   f5 = Math_fround(f6 * Math_fround(HEAPF32[i44 >> 2]));
   HEAPF32[i44 >> 2] = f5;
   f6 = Math_fround(f6 * Math_fround(HEAPF32[i45 >> 2]));
  }
  i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i45 >> 2] = f6;
  f21 = Math_fround(HEAPF32[i32 >> 2]);
  f20 = Math_fround(f21 + f4);
  f19 = Math_fround(HEAPF32[i33 >> 2]);
  f18 = Math_fround(f19 + f5);
  f16 = Math_fround(HEAPF32[i36 >> 2]);
  f17 = Math_fround(f16 + f6);
  f15 = Math_fround(HEAPF32[i40 >> 2]);
  f13 = Math_fround(f20 * f15);
  f14 = Math_fround(HEAPF32[i41 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f18 * f14));
  f12 = Math_fround(HEAPF32[i42 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f17 * f12));
  f11 = Math_fround(HEAPF32[i38 >> 2]);
  f9 = Math_fround(f15 * f11);
  f10 = Math_fround(HEAPF32[i34 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f14 * f10));
  f8 = Math_fround(HEAPF32[i35 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f12 * f8));
  i42 = Math_fround(Math_abs(Math_fround(f9))) > Math_fround(.999998986);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  if (i42) {
   f4 = Math_fround(HEAPF32[i37 >> 2]);
   if (!(f13 < f4)) break;
   f6 = Math_fround(Math_fround(f4 - f13) * Math_fround(1.00999999));
   f8 = Math_fround(Math_fround(f20 + Math_fround(f15 * f6)) - f21);
   f7 = Math_fround(Math_fround(f18 + Math_fround(f14 * f6)) - f19);
   f6 = Math_fround(Math_fround(f17 + Math_fround(f12 * f6)) - f16);
   HEAPF32[i46 >> 2] = f8;
   HEAPF32[i44 >> 2] = f7;
   HEAPF32[i45 >> 2] = f6;
   i43 = 20;
   break;
  }
  f51 = Math_fround(Math_fround(Math_fround(f20 * f11) + Math_fround(f18 * f10)) + Math_fround(f17 * f8));
  f6 = Math_fround(HEAPF32[i37 >> 2]);
  f7 = Math_fround(f6 - f13);
  f4 = Math_fround(HEAPF32[i39 >> 2]);
  f5 = Math_fround(f4 - f51);
  if (f13 < f6 | f51 < f4) {
   if (!(Math_fround(Math_fround(Math_fround(Math_fround(f20 + Math_fround(f11 * f5)) * f15) + Math_fround(Math_fround(f18 + Math_fround(f10 * f5)) * f14)) + Math_fround(Math_fround(f17 + Math_fround(f8 * f5)) * f12)) < f6)) {
    f6 = Math_fround(f5 * Math_fround(1.00010002));
    f51 = Math_fround(Math_fround(f20 + Math_fround(f6 * f11)) - f21);
    f7 = Math_fround(Math_fround(f18 + Math_fround(f6 * f10)) - f19);
    f6 = Math_fround(Math_fround(f17 + Math_fround(f6 * f8)) - f16);
    HEAPF32[i46 >> 2] = f51;
    HEAPF32[i44 >> 2] = f7;
    HEAPF32[i45 >> 2] = f6;
    f8 = f51;
    i43 = 20;
    break;
   }
   if (Math_fround(Math_fround(Math_fround(Math_fround(f20 + Math_fround(f15 * f7)) * f11) + Math_fround(Math_fround(f18 + Math_fround(f14 * f7)) * f10)) + Math_fround(Math_fround(f17 + Math_fround(f12 * f7)) * f8)) < f4) {
    f51 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(1.0) - Math_fround(f9 * f9)));
    f6 = Math_fround(Math_fround(f7 - Math_fround(f9 * f5)) * f51);
    f51 = Math_fround(Math_fround(f5 - Math_fround(f9 * f7)) * f51);
    f13 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(f15 * f6) + Math_fround(f11 * f51))) - f21);
    f21 = Math_fround(Math_fround(f18 + Math_fround(Math_fround(f14 * f6) + Math_fround(f10 * f51))) - f19);
    f51 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(f12 * f6) + Math_fround(f8 * f51))) - f16);
    f20 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f21 * f21)) + Math_fround(f51 * f51));
    f7 = Math_fround(Math_fround(Math_fround(Math_fround(f14 + f10) * Math_fround(.5)) * Math_fround(.0000999999974)) * f20);
    f6 = Math_fround(Math_fround(Math_fround(Math_fround(f12 + f8) * Math_fround(.5)) * Math_fround(.0000999999974)) * f20);
    f8 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(Math_fround(f15 + f11) * Math_fround(.5)) * Math_fround(.0000999999974)) * f20));
    HEAPF32[i46 >> 2] = f8;
    f7 = Math_fround(f21 + f7);
    HEAPF32[i44 >> 2] = f7;
    f6 = Math_fround(f51 + f6);
    HEAPF32[i45 >> 2] = f6;
    i43 = 20;
    break;
   } else {
    f6 = Math_fround(f7 * Math_fround(1.00010002));
    f8 = Math_fround(Math_fround(f20 + Math_fround(f6 * f15)) - f21);
    f7 = Math_fround(Math_fround(f18 + Math_fround(f6 * f14)) - f19);
    f6 = Math_fround(Math_fround(f17 + Math_fround(f6 * f12)) - f16);
    HEAPF32[i46 >> 2] = f8;
    HEAPF32[i44 >> 2] = f7;
    HEAPF32[i45 >> 2] = f6;
    i43 = 20;
    break;
   }
  }
 } while (0);
 if ((i43 | 0) == 20) {
  i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  f4 = Math_fround(HEAPF32[i49 >> 2]);
  f4 = Math_fround(f4 * f4);
  f5 = Math_fround(HEAPF32[i47 >> 2]);
  f5 = Math_fround(f4 + Math_fround(f5 * f5));
  f4 = Math_fround(HEAPF32[i48 >> 2]);
  f4 = Math_fround(f5 + Math_fround(f4 * f4));
  f5 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6));
  if (f5 > f4) {
   f51 = Math_fround(Math_fround(Math_sqrt(Math_fround(f4))) * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5)))));
   f20 = Math_fround(f8 * f51);
   HEAPF32[i46 >> 2] = f20;
   f21 = Math_fround(f7 * f51);
   HEAPF32[i44 >> 2] = f21;
   f51 = Math_fround(f51 * f6);
   HEAPF32[i45 >> 2] = f51;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  }
 }
 HEAP32[i49 >> 2] = i3;
 HEAP32[i47 >> 2] = i2;
 HEAP32[i48 >> 2] = i1;
 i49 = 1;
 STACKTOP = i50;
 return i49 | 0;
}

function __ZN5physx2Gu27pcmContactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i30, i33, i34, i24, i1, i22) {
 i2 = i2 | 0;
 i30 = i30 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 2656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i35 + 208 | 0;
 i31 = i35 + 128 | 0;
 i23 = i35 + 112 | 0;
 i32 = i35 + 80 | 0;
 i25 = i35 + 48 | 0;
 i20 = i35 + 144 | 0;
 i29 = i35 + 32 | 0;
 i27 = i35 + 16 | 0;
 i28 = i35;
 i26 = i35 + 2632 | 0;
 i21 = i35 + 2608 | 0;
 i17 = HEAP32[i1 >> 2] & -16;
 i4 = HEAP32[i33 >> 2] | 0;
 i11 = HEAP32[i33 + 4 >> 2] | 0;
 i10 = HEAP32[i33 + 8 >> 2] | 0;
 i9 = HEAP32[i33 + 12 >> 2] | 0;
 i16 = i33 + 16 | 0;
 i51 = HEAP32[i16 >> 2] | 0;
 i50 = HEAP32[i16 + 4 >> 2] | 0;
 i49 = HEAP32[i16 + 8 >> 2] | 0;
 i55 = HEAP32[i34 >> 2] | 0;
 i54 = HEAP32[i34 + 4 >> 2] | 0;
 i53 = HEAP32[i34 + 8 >> 2] | 0;
 i52 = HEAP32[i34 + 12 >> 2] | 0;
 i18 = i34 + 16 | 0;
 i48 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i18 + 4 >> 2] | 0;
 i3 = HEAP32[i18 + 8 >> 2] | 0;
 i12 = i2 + 4 | 0;
 HEAP32[i31 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i32 >> 2] = i4;
 HEAP32[i32 + 4 >> 2] = i11;
 HEAP32[i32 + 8 >> 2] = i10;
 HEAP32[i32 + 12 >> 2] = i9;
 HEAP32[i32 + 16 >> 2] = i51;
 HEAP32[i32 + 20 >> 2] = i50;
 HEAP32[i32 + 24 >> 2] = i49;
 HEAPF32[i32 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i25 >> 2] = i55;
 HEAP32[i25 + 4 >> 2] = i54;
 HEAP32[i25 + 8 >> 2] = i53;
 HEAP32[i25 + 12 >> 2] = i52;
 HEAP32[i25 + 16 >> 2] = i48;
 HEAP32[i25 + 20 >> 2] = i1;
 HEAP32[i25 + 24 >> 2] = i3;
 HEAPF32[i25 + 28 >> 2] = Math_fround(0.0);
 f40 = (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(-f40);
 f45 = Math_fround(-f45);
 f8 = Math_fround(-f8);
 f15 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = Math_fround(f15 - f44);
 f47 = Math_fround(f36 - f47);
 f38 = Math_fround(f38 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f36 = Math_fround(Math_fround(f41 * f41) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(Math_fround(f44 * f40) + Math_fround(f47 * f45)) + Math_fround(f38 * f8));
 f13 = Math_fround(Math_fround(Math_fround(f15 * f40) + Math_fround(Math_fround(f36 * f44) + Math_fround(f41 * Math_fround(Math_fround(f38 * f45) - Math_fround(f47 * f8))))) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(Math_fround(f15 * f45) + Math_fround(Math_fround(f36 * f47) + Math_fround(f41 * Math_fround(Math_fround(f44 * f8) - Math_fround(f38 * f40))))) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f38) + Math_fround(f41 * Math_fround(Math_fround(f47 * f40) - Math_fround(f44 * f45)))) + Math_fround(f15 * f8)) * Math_fround(2.0));
 f44 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_fround(f41 * f36) - Math_fround(Math_fround(Math_fround(f44 * f40) + Math_fround(f47 * f45)) + Math_fround(f38 * f8)));
 f6 = Math_fround(Math_fround(Math_fround(f38 * f45) - Math_fround(f47 * f8)) + Math_fround(Math_fround(f41 * f44) + Math_fround(f36 * f40)));
 f7 = Math_fround(Math_fround(Math_fround(f44 * f8) - Math_fround(f38 * f40)) + Math_fround(Math_fround(f41 * f47) + Math_fround(f36 * f45)));
 f8 = Math_fround(Math_fround(Math_fround(f47 * f40) - Math_fround(f44 * f45)) + Math_fround(Math_fround(f41 * f38) + Math_fround(f36 * f8)));
 HEAPF32[i20 + 48 >> 2] = f13;
 HEAPF32[i20 + 52 >> 2] = f14;
 HEAPF32[i20 + 56 >> 2] = f15;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f36 = Math_fround(f6 + f6);
 f38 = Math_fround(f7 + f7);
 f41 = Math_fround(f8 + f8);
 f45 = Math_fround(f7 * f38);
 f44 = Math_fround(f8 * f41);
 f40 = Math_fround(f7 * f36);
 f47 = Math_fround(f8 * f36);
 f37 = Math_fround(f5 * f36);
 f46 = Math_fround(f8 * f38);
 f38 = Math_fround(f5 * f38);
 f41 = Math_fround(f5 * f41);
 f36 = Math_fround(Math_fround(1.0) - Math_fround(f6 * f36));
 f43 = Math_fround(f40 + f41);
 f42 = Math_fround(f47 - f38);
 f41 = Math_fround(f40 - f41);
 f40 = Math_fround(f36 - f44);
 f39 = Math_fround(f46 + f37);
 f38 = Math_fround(f47 + f38);
 f37 = Math_fround(f46 - f37);
 f36 = Math_fround(f36 - f45);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f45) - f44);
 HEAPF32[i20 + 4 >> 2] = f43;
 HEAPF32[i20 + 8 >> 2] = f42;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f41;
 HEAPF32[i20 + 20 >> 2] = f40;
 HEAPF32[i20 + 24 >> 2] = f39;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f38;
 HEAPF32[i20 + 36 >> 2] = f37;
 HEAPF32[i20 + 40 >> 2] = f36;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 f36 = Math_fround(HEAPF32[i31 >> 2]);
 HEAPF32[i29 >> 2] = Math_fround(f36 * Math_fround(.00100000005));
 HEAPF32[i27 >> 2] = Math_fround(f36 * Math_fround(.0500000007));
 i9 = i17 + 53 | 0;
 i10 = HEAP8[i9 >> 0] | 0;
 HEAPF32[i28 >> 2] = Math_fround(f36 + Math_fround(HEAPF32[i23 >> 2]));
 i11 = i17 + 52 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 if (i4 << 24 >> 24) {
  i1 = 0;
  do {
   i2 = i17 + 48 + i1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = i3 & 255;
   __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i19, i17 + 64 + (i4 * 400 | 0) | 0, i20, i27, i28);
   if (!(HEAP32[i17 + 64 + (i4 * 400 | 0) + 384 >> 2] | 0)) {
    i54 = (HEAP8[i11 >> 0] | 0) + -1 << 24 >> 24;
    HEAP8[i11 >> 0] = i54;
    i54 = (i54 & 255) + (i17 + 48) | 0;
    i55 = HEAP8[i54 >> 0] | 0;
    HEAP8[i54 >> 0] = i3;
    HEAP8[i2 >> 0] = i55;
    i1 = i1 + -1 | 0;
   } else HEAP32[i17 + 32 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
   i1 = i1 + 1 | 0;
   i55 = HEAPU8[i11 >> 0] | 0;
  } while (i1 >>> 0 < i55 >>> 0);
 }
 if ((HEAP8[i9 >> 0] | 0) == i10 << 24 >> 24) {
  f44 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * Math_fround(.0199999996));
  f41 = Math_fround(HEAPF32[i17 + 16 >> 2]);
  f47 = Math_fround(HEAPF32[i17 + 20 >> 2]);
  f41 = Math_fround(f13 - f41);
  f47 = Math_fround(f14 - f47);
  f46 = Math_fround(f15 - Math_fround(HEAPF32[i17 + 24 >> 2]));
  f43 = Math_fround(-f41);
  f42 = Math_fround(-f47);
  f45 = Math_fround(-f46);
  f43 = f41 > f43 ? f41 : f43;
  f42 = f47 > f42 ? f47 : f42;
  f42 = f43 >= f42 ? f43 : f42;
  i55 = (f46 > f45 ? f46 : f45) >= Math_fround(0.0);
  f43 = i55 ? f43 : Math_fround(0.0);
  f45 = Math_fround(HEAPF32[i17 >> 2]);
  f46 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f47 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  if (!((f42 >= f43 ? f42 : f43) > f44 ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f6 * f45) + Math_fround(f7 * f46)) + Math_fround(f8 * f47)) + Math_fround(f5 * Math_fround(HEAPF32[i17 + 12 >> 2]))) < Math_fround(.999800026))) {
   i55 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i17, i22, i32, i25, i31) | 0;
   STACKTOP = i35;
   return i55 | 0;
  }
 }
 HEAP32[i26 + 12 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i26 + 16 >> 2] = i30;
 HEAPF32[i26 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i30 + 8 >> 2]));
 HEAPF32[i26 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i30 + 12 >> 2]));
 HEAPF32[i26 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i30 + 16 >> 2]));
 f41 = Math_fround(HEAPF32[i16 >> 2]);
 f41 = Math_fround(f41 - Math_fround(HEAPF32[i18 >> 2]));
 f43 = Math_fround(HEAPF32[i33 + 20 >> 2]);
 f43 = Math_fround(f43 - Math_fround(HEAPF32[i34 + 20 >> 2]));
 f37 = Math_fround(HEAPF32[i33 + 24 >> 2]);
 f41 = Math_fround(f41 * Math_fround(2.0));
 f43 = Math_fround(f43 * Math_fround(2.0));
 f37 = Math_fround(Math_fround(f37 - Math_fround(HEAPF32[i34 + 24 >> 2])) * Math_fround(2.0));
 f44 = Math_fround(HEAPF32[i34 + 12 >> 2]);
 f38 = Math_fround(Math_fround(f44 * f44) + Math_fround(-.5));
 f42 = Math_fround(HEAPF32[i34 >> 2]);
 f47 = Math_fround(f41 * f42);
 f40 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f43 * f40));
 f39 = Math_fround(HEAPF32[i34 + 8 >> 2]);
 f47 = Math_fround(f47 + Math_fround(f37 * f39));
 f45 = Math_fround(Math_fround(f42 * f47) + Math_fround(Math_fround(f41 * f38) - Math_fround(f44 * Math_fround(Math_fround(f37 * f40) - Math_fround(f43 * f39)))));
 f46 = Math_fround(Math_fround(f40 * f47) + Math_fround(Math_fround(f43 * f38) - Math_fround(f44 * Math_fround(Math_fround(f41 * f39) - Math_fround(f37 * f42)))));
 f47 = Math_fround(Math_fround(Math_fround(f37 * f38) - Math_fround(f44 * Math_fround(Math_fround(f43 * f42) - Math_fround(f41 * f40)))) + Math_fround(f39 * f47));
 f39 = Math_fround(HEAPF32[i12 >> 2]);
 f39 = Math_fround(f39 + Math_fround(HEAPF32[i24 >> 2]));
 f40 = Math_fround(f46 - f39);
 f41 = Math_fround(f47 - f39);
 f42 = Math_fround(f39 + f45);
 f43 = Math_fround(f39 + f46);
 f44 = Math_fround(f39 + f47);
 HEAPF32[i21 >> 2] = Math_fround(f45 - f39);
 HEAPF32[i21 + 4 >> 2] = f40;
 HEAPF32[i21 + 8 >> 2] = f41;
 HEAPF32[i21 + 12 >> 2] = f42;
 HEAPF32[i21 + 16 >> 2] = f43;
 HEAPF32[i21 + 20 >> 2] = f44;
 HEAP32[i19 + 4 >> 2] = i26;
 HEAP32[i19 + 8 >> 2] = i34;
 HEAP32[i19 >> 2] = gb + 147052 + 8;
 i55 = i19 + 16 | 0;
 __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE(i55, i23, i29, i32, i25, i17, i22);
 HEAPF32[i19 + 2352 >> 2] = f45;
 HEAPF32[i19 + 2356 >> 2] = f46;
 HEAPF32[i19 + 2360 >> 2] = f47;
 HEAPF32[i19 + 2364 >> 2] = Math_fround(0.0);
 i54 = i19 + 2368 | 0;
 HEAP32[i54 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
 f47 = Math_fround(HEAPF32[i31 >> 2]);
 f47 = Math_fround(f47 + Math_fround(HEAPF32[i23 >> 2]));
 HEAPF32[i19 + 2384 >> 2] = Math_fround(f47 * f47);
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i26, i34, i21, 0, i19) | 0;
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i55, 1, 0);
 i55 = __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i17, i22, i32, i25, i31) | 0;
 STACKTOP = i35;
 return i55 | 0;
}

function __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_(i1, i2, i18) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0;
 L1 : while (1) {
  i15 = i2;
  i17 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 7;
      break L1;
     }
    case 4:
     {
      i16 = 15;
      break L1;
     }
    case 5:
     {
      i16 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 86;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i16 = 22;
     break L1;
    }
    i13 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    do if ((i3 | 0) > 3996) {
     i10 = (i4 | 0) / 4 | 0;
     i11 = i1 + (i10 << 2) | 0;
     i10 = i13 + (i10 << 2) | 0;
     i3 = __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i1, i11, i13, i10, i18) | 0;
     i5 = HEAP32[i17 >> 2] | 0;
     i6 = HEAP32[i10 >> 2] | 0;
     i4 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
     f9 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 36 >> 2]);
     if (f9 > Math_fround(HEAPF32[i4 + (i6 * 40 | 0) + 36 >> 2])) {
      HEAP32[i10 >> 2] = i5;
      HEAP32[i17 >> 2] = i6;
      i5 = i3 + 1 | 0;
      i6 = HEAP32[i10 >> 2] | 0;
      i7 = HEAP32[i13 >> 2] | 0;
      f9 = Math_fround(HEAPF32[i4 + (i6 * 40 | 0) + 36 >> 2]);
      if (f9 > Math_fround(HEAPF32[i4 + (i7 * 40 | 0) + 36 >> 2])) {
       HEAP32[i13 >> 2] = i6;
       HEAP32[i10 >> 2] = i7;
       i5 = i3 + 2 | 0;
       i6 = HEAP32[i13 >> 2] | 0;
       i7 = HEAP32[i11 >> 2] | 0;
       f9 = Math_fround(HEAPF32[i4 + (i6 * 40 | 0) + 36 >> 2]);
       if (f9 > Math_fround(HEAPF32[i4 + (i7 * 40 | 0) + 36 >> 2])) {
        HEAP32[i11 >> 2] = i6;
        HEAP32[i13 >> 2] = i7;
        i5 = HEAP32[i11 >> 2] | 0;
        i6 = HEAP32[i1 >> 2] | 0;
        f9 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 36 >> 2]);
        if (f9 > Math_fround(HEAPF32[i4 + (i6 * 40 | 0) + 36 >> 2])) {
         HEAP32[i1 >> 2] = i5;
         HEAP32[i11 >> 2] = i6;
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i5;
      } else i3 = i5;
     }
    } else {
     i3 = HEAP32[i13 >> 2] | 0;
     i6 = HEAP32[i1 >> 2] | 0;
     i7 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
     f9 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 36 >> 2]);
     f8 = Math_fround(HEAPF32[i7 + (i6 * 40 | 0) + 36 >> 2]);
     i4 = HEAP32[i17 >> 2] | 0;
     i5 = Math_fround(HEAPF32[i7 + (i4 * 40 | 0) + 36 >> 2]) > f9;
     if (!(f9 > f8)) {
      if (!i5) {
       i3 = 0;
       i4 = i7;
       break;
      }
      HEAP32[i13 >> 2] = i4;
      HEAP32[i17 >> 2] = i3;
      i3 = HEAP32[i13 >> 2] | 0;
      i4 = HEAP32[i1 >> 2] | 0;
      f9 = Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 36 >> 2]);
      if (!(f9 > Math_fround(HEAPF32[i7 + (i4 * 40 | 0) + 36 >> 2]))) {
       i3 = 1;
       i4 = i7;
       break;
      }
      HEAP32[i1 >> 2] = i3;
      HEAP32[i13 >> 2] = i4;
      i3 = 2;
      i4 = i7;
      break;
     }
     if (i5) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i17 >> 2] = i6;
      i3 = 1;
      i4 = i7;
      break;
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i13 >> 2] = i6;
     i3 = HEAP32[i17 >> 2] | 0;
     if (Math_fround(HEAPF32[i7 + (i3 * 40 | 0) + 36 >> 2]) > f8) {
      HEAP32[i13 >> 2] = i3;
      HEAP32[i17 >> 2] = i6;
      i3 = 2;
      i4 = i7;
     } else {
      i3 = 1;
      i4 = i7;
     }
    } while (0);
    i10 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    f9 = Math_fround(HEAPF32[i4 + (i10 * 40 | 0) + 36 >> 2]);
    if (f9 > Math_fround(HEAPF32[i4 + (i6 * 40 | 0) + 36 >> 2])) {
     i4 = i17;
     break;
    }
    i7 = HEAP32[i18 >> 2] | 0;
    i4 = i17;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i5 = HEAP32[i4 >> 2] | 0;
     i12 = HEAP32[i7 >> 2] | 0;
     f9 = Math_fround(HEAPF32[i12 + (i5 * 40 | 0) + 36 >> 2]);
     if (f9 > Math_fround(HEAPF32[i12 + (i6 * 40 | 0) + 36 >> 2])) {
      i16 = 68;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i6 = HEAP32[i17 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    f8 = Math_fround(HEAPF32[i5 + (i10 * 40 | 0) + 36 >> 2]);
    if (!(f8 > Math_fround(HEAPF32[i5 + (i6 * 40 | 0) + 36 >> 2]))) {
     if ((i3 | 0) == (i17 | 0)) {
      i16 = 86;
      break L1;
     }
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if (f8 > Math_fround(HEAPF32[i5 + (i4 * 40 | 0) + 36 >> 2])) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i17 | 0)) {
       i16 = 86;
       break L1;
      }
     }
     HEAP32[i3 >> 2] = i6;
     HEAP32[i17 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i17 | 0)) {
     i16 = 86;
     break L1;
    }
    i10 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
    i4 = i17;
    while (1) {
     f8 = Math_fround(HEAPF32[i10 + ((HEAP32[i1 >> 2] | 0) * 40 | 0) + 36 >> 2]);
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if (f8 > Math_fround(HEAPF32[i10 + (i6 * 40 | 0) + 36 >> 2])) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while (f8 > Math_fround(HEAPF32[i10 + (i5 * 40 | 0) + 36 >> 2]));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i16 | 0) == 68) {
    i16 = 0;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i4 >> 2] = i10;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L50 : do if (i5 >>> 0 < i4 >>> 0) {
    i12 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
    i6 = i13;
    while (1) {
     f8 = Math_fround(HEAPF32[i12 + ((HEAP32[i6 >> 2] | 0) * 40 | 0) + 36 >> 2]);
     while (1) {
      i10 = HEAP32[i5 >> 2] | 0;
      i11 = i5 + 4 | 0;
      if (Math_fround(HEAPF32[i12 + (i10 * 40 | 0) + 36 >> 2]) > f8) i5 = i11; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i7 = HEAP32[i4 >> 2] | 0;
     } while (!(Math_fround(HEAPF32[i12 + (i7 * 40 | 0) + 36 >> 2]) > f8));
     if (i5 >>> 0 > i4 >>> 0) {
      i7 = i5;
      break L50;
     }
     HEAP32[i5 >> 2] = i7;
     HEAP32[i4 >> 2] = i10;
     i6 = (i6 | 0) == (i5 | 0) ? i4 : i6;
     i5 = i11;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i13;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i13 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
    f9 = Math_fround(HEAPF32[i13 + (i4 * 40 | 0) + 36 >> 2]);
    if (f9 > Math_fround(HEAPF32[i13 + (i5 * 40 | 0) + 36 >> 2])) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR23TreeInstanceIndexSorterPjEEbT0_S4_T_(i1, i7, i18) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR23TreeInstanceIndexSorterPjEEbT0_S4_T_(i4, i2, i18) | 0) {
     i16 = 85;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i7;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i16 = 84;
    break;
   }
   __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_(i1, i7, i18);
   i1 = i7 + 4 | 0;
  }
  if ((i16 | 0) == 84) {
   i16 = 0;
   __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_(i7 + 4 | 0, i2, i18);
   i2 = i7;
   continue;
  } else if ((i16 | 0) == 85) {
   i16 = 0;
   if (i3) {
    i16 = 86;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i18 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  f9 = Math_fround(HEAPF32[i18 + (i2 * 40 | 0) + 36 >> 2]);
  if (!(f9 > Math_fround(HEAPF32[i18 + (i3 * 40 | 0) + 36 >> 2]))) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i17 >> 2] = i3;
  return;
 } else if ((i16 | 0) == 7) {
  i7 = i1 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  f9 = Math_fround(HEAPF32[i6 + (i4 * 40 | 0) + 36 >> 2]);
  f8 = Math_fround(HEAPF32[i6 + (i5 * 40 | 0) + 36 >> 2]);
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]) > f9;
  if (!(f9 > f8)) {
   if (!i3) return;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i17 >> 2] = i4;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]);
   if (!(f9 > Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 36 >> 2]))) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   return;
  }
  if (i3) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i17 >> 2] = i5;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i5;
  i1 = HEAP32[i17 >> 2] | 0;
  if (!(Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 36 >> 2]) > f8)) return;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i17 >> 2] = i5;
  return;
 } else if ((i16 | 0) == 15) {
  __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i17, i18) | 0;
  return;
 } else if ((i16 | 0) == 16) {
  i7 = i1 + 4 | 0;
  i5 = i1 + 8 | 0;
  i4 = i1 + 12 | 0;
  __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i1, i7, i5, i4, i18) | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  f9 = Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]);
  if (!(f9 > Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 36 >> 2]))) return;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i17 >> 2] = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 36 >> 2]);
  if (!(f8 > Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]))) return;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i2;
  i2 = HEAP32[i7 >> 2] | 0;
  if (!(f8 > Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]))) return;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i5 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(f8 > Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]))) return;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i2;
  return;
 } else if ((i16 | 0) == 22) {
  i3 = i1 + 8 | 0;
  i4 = i1 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  f19 = Math_fround(HEAPF32[i10 + (i5 * 40 | 0) + 36 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + (i6 * 40 | 0) + 36 >> 2]);
  i7 = HEAP32[i3 >> 2] | 0;
  f9 = Math_fround(HEAPF32[i10 + (i7 * 40 | 0) + 36 >> 2]);
  i10 = f9 > f19;
  do if (f19 > f8) {
   if (i10) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i3 >> 2] = i6;
    i5 = i6;
    break;
   }
   HEAP32[i1 >> 2] = i5;
   HEAP32[i4 >> 2] = i6;
   if (f9 > f8) {
    HEAP32[i4 >> 2] = i7;
    HEAP32[i3 >> 2] = i6;
    i5 = i6;
   } else i5 = i7;
  } else if (i10) {
   HEAP32[i4 >> 2] = i7;
   HEAP32[i3 >> 2] = i5;
   if (f9 > f8) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i4 >> 2] = i6;
   }
  } else i5 = i7; while (0);
  i4 = i1 + 12 | 0;
  if ((i4 | 0) == (i2 | 0)) return;
  i11 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  while (1) {
   i10 = HEAP32[i4 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) + 36 >> 2]);
   if (f8 > Math_fround(HEAPF32[i11 + (i5 * 40 | 0) + 36 >> 2])) {
    i6 = i4;
    i7 = i5;
    while (1) {
     HEAP32[i6 >> 2] = i7;
     if ((i3 | 0) == (i1 | 0)) {
      i3 = i1;
      break;
     }
     i5 = i3 + -4 | 0;
     i7 = HEAP32[i5 >> 2] | 0;
     if (!(f8 > Math_fround(HEAPF32[i11 + (i7 * 40 | 0) + 36 >> 2]))) break; else {
      i6 = i3;
      i3 = i5;
     }
    }
    HEAP32[i3 >> 2] = i10;
   }
   i3 = i4 + 4 | 0;
   if ((i3 | 0) == (i2 | 0)) break;
   i5 = HEAP32[i4 >> 2] | 0;
   i18 = i4;
   i4 = i3;
   i3 = i18;
  }
  return;
 } else if ((i16 | 0) == 86) return;
}

function __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 260 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj467ENS_22PxRepXPropertyAccessorILj467ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 276 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj468ENS_22PxRepXPropertyAccessorILj468ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 292 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj469ENS_22PxRepXPropertyAccessorILj469ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 308 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj470ENS_22PxRepXPropertyAccessorILj470ES4_ffEEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj471ES3_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 324 | 0, i10 + 6 | 0);
 i5 = i6 + 340 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj472ENS_22PxRepXPropertyAccessorILj472ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 356 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj473ENS_22PxRepXPropertyAccessorILj473ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 10 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 10 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN17PrePassRenderLoop15RenderFinalPassEP13RenderTextureS1_b(i49, i1, i2, i3) {
 i49 = i49 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i53 + 624 | 0;
 i6 = i53 + 600 | 0;
 i4 = i53 + 616 | 0;
 i5 = i53 + 592 | 0;
 i52 = i53 + 392 | 0;
 i45 = i53 + 168 | 0;
 i46 = i53 + 152 | 0;
 i39 = i53 + 140 | 0;
 i40 = i53 + 40 | 0;
 i41 = i53 + 28 | 0;
 i42 = i53 + 8 | 0;
 i43 = i53;
 if ((HEAP16[gb + 1115048 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = HEAP32[(HEAP32[i49 >> 2] | 0) + 8 >> 2];
  HEAP32[i38 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115048 | 0, i38);
  i48 = gb + 1115048 | 0;
 } else i48 = 0;
 i50 = HEAP32[gb + 1115048 >> 2] | 0;
 i51 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i51 >> 2] | 0) + 648 >> 2] | 0, i51 | 0, i50 | 0);
 i50 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 1;
 i51 = HEAP32[gb + 1166248 >> 2] | 0;
 i44 = HEAP32[(HEAP32[i49 >> 2] | 0) + 1832 >> 2] | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0, i7 | 0, 0);
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 __ZN6Camera13ClearNoSkyboxEb(HEAP32[(HEAP32[i49 >> 2] | 0) + 8 >> 2] | 0, 1);
 if (!i2) {
  if (i3) i1 = __ZN10builtintex15GetBlackTextureEv() | 0; else i1 = __ZN10builtintex15GetWhiteTextureEv() | 0;
  HEAP32[i4 >> 2] = HEAP32[gb + 62472 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
  HEAP32[i5 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i51 + 36 | 0, gb + 1115100 | 0, i1, i4, i5);
 } else __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i2, gb + 1115100 | 0, i51);
 i2 = HEAP32[i49 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i3 + 1136 | 0, 8, i51, HEAP32[i2 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i3 + 4 >> 2] | 0);
 i3 = HEAP32[i49 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i2 + 1136 | 0, 8, i51, HEAP32[i3 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i2 + 4 >> 2] | 0);
 i2 = __Z19GetLightmapSettingsv() | 0;
 __ZNK16LightmapSettings23GetLightmapDecodeValuesEv(i38, i2);
 __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv(i6, i2);
 __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext(i38, i6, i51);
 i3 = HEAP32[(HEAP32[i49 >> 2] | 0) + 1828 >> 2] | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i52, i6, i44, 0, 1);
 __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats(i45, i52, i6);
 HEAP32[i46 + 4 >> 2] = i52;
 HEAP32[i46 + 8 >> 2] = i6;
 HEAP8[i46 >> 0] = 1;
 i8 = __Z12GetGfxDevicev() | 0;
 HEAPF32[i8 + 980 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 984 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 988 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 992 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 996 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 1e3 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 1004 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 1008 >> 2] = Math_fround(0.0);
 __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats(i39, i52, i6);
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 >> 2] = HEAP32[(__ZN10builtintex16GetDefaultTexEnvE16TextureDimension(3) | 0) >> 2];
 HEAPF32[i40 + 4 >> 2] = Math_fround(1.0);
 i8 = i40 + 8 | 0;
 i9 = i38 + 12 | 0;
 HEAP32[i38 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i38 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i38 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i38 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
 i8 = i40 + 32 | 0;
 i9 = gb + 1162292 | 0;
 i10 = i8 + 64 | 0;
 do {
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  i8 = i8 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAP8[i40 + 96 >> 0] = 1;
 HEAP32[i41 >> 2] = i52;
 i27 = __Z12GetGfxDevicev() | 0;
 HEAP32[i41 + 4 >> 2] = i27 + 4;
 HEAPF32[i41 + 8 >> 2] = Math_fround(0.0);
 i27 = i27 + 964 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 i27 = i49 + 4 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i28 = HEAP32[i4 + 12 >> 2] | 0;
 L12 : do if (!i28) i1 = i51 + 4 | 0; else {
  i29 = i49 + 140 | 0;
  i30 = i42 + 4 | 0;
  i31 = i42 + 12 | 0;
  i32 = i42 + 16 | 0;
  i33 = i42 + 8 | 0;
  i34 = i42 + 12 | 0;
  i35 = i49 + 8 | 0;
  i36 = i49 + 136 | 0;
  i37 = i43 + 4 | 0;
  i1 = i51 + 4 | 0;
  i26 = i7 + 608 | 0;
  i23 = i2 + 28 | 0;
  i24 = i42 + 16 | 0;
  i25 = i52 + 184 | 0;
  i20 = i52 + 188 | 0;
  i21 = i52 + 192 | 0;
  i22 = HEAP32[i39 + 4 >> 2] | 0;
  i19 = i3 + 65940 | 0;
  i2 = 0;
  i7 = 0;
  i6 = -1;
  i5 = 0;
  i17 = 0;
  i18 = -1;
  i3 = i4;
  while (1) {
   i14 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i11 = HEAP32[i3 >> 2] | 0;
   i12 = i11 + (i14 << 5) + 8 | 0;
   i15 = HEAP32[i12 >> 2] | 0;
   i16 = HEAP32[i44 >> 2] | 0;
   i3 = i16 + (i15 * 360 | 0) | 0;
   i13 = i11 + (i14 << 5) | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   HEAP32[i42 >> 2] = HEAP32[(HEAP32[i16 + (i15 * 360 | 0) + 324 >> 2] | 0) + (HEAPU16[i11 + (i14 << 5) + 18 >> 1] << 3) >> 2];
   HEAP32[i30 >> 2] = i4;
   i54 = HEAPU16[i11 + (i14 << 5) + 16 >> 1] & 32767;
   i8 = HEAP32[i16 + (i15 * 360 | 0) + 176 >> 2] << 13 & 32768;
   i9 = i16 + (i15 * 360 | 0) + 252 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   i10 = (i10 & 2147483647 | 0) == 0 ? 0 : i10 >> 15 & 131072 | 65536;
   HEAP32[i31 >> 2] = i10 | (i8 | i54);
   HEAP32[i32 >> 2] = HEAP32[i16 + (i15 * 360 | 0) + 224 >> 2];
   HEAP32[i33 >> 2] = 0;
   if ((i54 | 0) == 32767) {
    i54 = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 36 >> 2] & 32767;
    HEAP32[i34 >> 2] = i54 | (i10 | i8);
    if ((i54 | 0) == 32767) {
     i4 = i17;
     i3 = i18;
    } else i47 = 17;
   } else i47 = 17;
   if ((i47 | 0) == 17) {
    i47 = 0;
    __ZN15LightmapSTCache5ApplyERK10RenderNode(i46, i3);
    __ZN12LODFadeCache14ApplyValueOnlyEf(i41, Math_fround(HEAPF32[i9 >> 2]));
    i54 = HEAP8[i36 >> 0] | 0;
    __Z7ApplySHR15SHConstantCacheRK17LightProbeContextRK10RenderNodeb(i45, i35, i3, __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i3, (i54 & 2) != 0, (i54 & 1) != 0) | 0);
    i3 = HEAP16[i16 + (i15 * 360 | 0) + 268 >> 1] | 0;
    if (i3 << 16 >> 16 != -1) {
     i4 = (HEAP32[i19 >> 2] | 0) + ((i3 << 16 >> 16) * 100 | 0) | 0;
     i8 = i40;
     i9 = i4;
     i10 = i8 + 96 | 0;
     do {
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i8 = i8 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i8 | 0) < (i10 | 0));
     HEAP8[i40 + 96 >> 0] = HEAP8[i4 + 96 >> 0] | 0;
    }
    if ((HEAP16[i39 >> 1] | 0) != i3 << 16 >> 16) {
     HEAP16[i39 >> 1] = i3;
     __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb(i22, i40, i3 << 16 >> 16 != -1);
    }
    HEAP32[i43 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i37 >> 2] = HEAPU16[i11 + (i14 << 5) + 14 >> 1];
    i12 = HEAP32[(HEAP32[HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] >> 2] | 0) + (HEAP32[i34 >> 2] << 17 >> 17 << 2) >> 2] | 0;
    i13 = HEAP32[i12 + 20 >> 2] | 0;
    if ((i13 | 0) > 0) {
     i11 = i16 + (i15 * 360 | 0) + 260 | 0;
     i10 = 0;
     i8 = i5;
     i4 = i17;
     i3 = i18;
     while (1) {
      i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i10 << 2) >> 2] | 0;
      if ((HEAP32[i5 + 696 >> 2] | 0) == 7) {
       HEAP32[i33 >> 2] = i5;
       if ((HEAP32[i32 >> 2] | 0) != (i6 | 0) | (HEAP32[i31 >> 2] | 0) == (i3 | 0) & ((i5 | 0) == (i4 | 0) & ((HEAP32[i42 >> 2] | 0) == (i7 | 0) ? (HEAP32[i30 >> 2] | 0) == (i8 | 0) : 0)) ^ 1) i47 = 27; else if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i21 >> 2] | 0)) i5 = i8; else i47 = 27;
       if ((i47 | 0) == 27) {
        i47 = 0;
        __ZN13BatchRenderer5FlushEv(i52);
        i7 = HEAP32[i42 >> 2] | 0;
        i5 = HEAP32[i30 >> 2] | 0;
        i4 = HEAP32[i33 >> 2] | 0;
        i3 = HEAP32[i31 >> 2] | 0;
        i9 = HEAP32[i32 >> 2] | 0;
        switch (i3 << 14 >> 30 | 0) {
        case 1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 8388608;
          break;
         }
        case -1:
         {
          HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913 | 4194304;
          break;
         }
        default:
         HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -12582913;
        }
        HEAPF32[i26 >> 2] = HEAP32[i34 >> 2] & 32768 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
        __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext(HEAP32[i23 >> 2] | 0, i24, i51);
        i54 = HEAP32[i42 >> 2] | 0;
        i8 = HEAP32[i30 >> 2] | 0;
        i6 = HEAP32[i33 >> 2] | 0;
        HEAP32[i38 >> 2] = 0;
        HEAP32[i38 + 4 >> 2] = 0;
        HEAP32[i38 + 8 >> 2] = 0;
        HEAP32[i38 + 12 >> 2] = 0;
        HEAP32[i38 + 16 >> 2] = 0;
        HEAP32[i38 + 20 >> 2] = 0;
        i6 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i54, i51, i8, i6, i10, (HEAP32[i6 + 744 >> 2] | 0) == 0, 0, i38) | 0;
        HEAP32[i25 >> 2] = i6;
        if (!i6) i6 = 0; else i6 = HEAP32[i6 >> 2] & 1;
        i6 = HEAP8[i20 >> 0] & -4 | i6;
        HEAP8[i20 >> 0] = i6;
        HEAP8[i20 >> 0] = (HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 64 >> 2] & 255) << 2 & 12 | i6 & -13;
        i6 = i9;
       }
       __ZN13BatchRenderer3AddERK17BatchInstanceData(i52, i43);
      } else i5 = i8;
      i10 = i10 + 1 | 0;
      if ((i10 | 0) == (i13 | 0)) break; else i8 = i5;
     }
    } else {
     i4 = i17;
     i3 = i18;
    }
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i28 | 0)) break L12;
   i17 = i4;
   i18 = i3;
   i3 = HEAP32[i27 >> 2] | 0;
  }
 } while (0);
 __ZN13BatchRenderer5FlushEv(i52);
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 i47 = HEAP32[i49 >> 2] | 0;
 i54 = HEAP32[i47 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i54 + 1136 | 0, 9, i51, HEAP32[i47 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i54 + 4 >> 2] | 0);
 i49 = HEAP32[i49 >> 2] | 0;
 i54 = HEAP32[i49 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i54 + 1136 | 0, 9, i51, HEAP32[i49 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i54 + 4 >> 2] | 0);
 __ZN13BatchRendererD2Ev(i52);
 HEAP32[gb + 1163232 >> 2] = i50;
 i54 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i54 >> 2] | 0) + 652 >> 2] | 0, i54 | 0);
 if (!i48) {
  STACKTOP = i53;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i48);
 STACKTOP = i53;
 return;
}

function __Z26CalculateLightScreenBoundsRK13ShadowJobDataRK15SharedLightDataP5RectTIfER13TargetEyeMask(i14, i5, i15, i16) {
 i14 = i14 | 0;
 i5 = i5 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 408 | 0;
 i18 = i21 + 120 | 0;
 i19 = i21 + 24 | 0;
 i20 = i21;
 f4 = Math_fround(HEAPF32[i5 + 264 >> 2]);
 f2 = Math_fround(HEAPF32[i5 + 268 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 272 >> 2]);
 i6 = i5 + 40 | 0;
 switch (HEAP32[i6 >> 2] | 0) {
 case 0:
  {
   i1 = i5 + 48 | 0;
   __Z24CalculateSpotLightBoundsffRK10Matrix4x4fR15SpotLightBounds(Math_fround(HEAPF32[i1 >> 2]), Math_fround(HEAPF32[i5 + 68 >> 2]), i5 + 216 | 0, i19);
   HEAP8[i17 >> 0] = 4;
   i13 = i17 + 1 | 0;
   i11 = i19 + 48 | 0;
   HEAP8[i13 >> 0] = 3;
   HEAP8[i13 + 1 >> 0] = 3;
   HEAP8[i13 + 2 >> 0] = 3;
   HEAP8[i13 + 3 >> 0] = 3;
   HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 12 | 0;
   i10 = i19 + 36 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 24 | 0;
   i9 = i19 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 36 | 0;
   i12 = i19 + 12 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = i18 + 48 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 60 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = i18 + 72 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 84 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 96 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 108 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 120 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 132 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 144 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 156 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 168 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 180 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = 5;
   break;
  }
 case 2:
  {
   i1 = i5 + 48 | 0;
   f26 = Math_fround(HEAPF32[i1 >> 2]);
   f23 = Math_fround(f4 - f26);
   f25 = Math_fround(f2 - f26);
   f27 = Math_fround(f3 - f26);
   HEAPF32[i19 >> 2] = f23;
   HEAPF32[i19 + 4 >> 2] = f25;
   HEAPF32[i19 + 8 >> 2] = f27;
   i8 = i19 + 12 | 0;
   f24 = Math_fround(f4 + f26);
   HEAPF32[i8 >> 2] = f24;
   HEAPF32[i19 + 16 >> 2] = f25;
   HEAPF32[i19 + 20 >> 2] = f27;
   i12 = i19 + 24 | 0;
   f2 = Math_fround(f2 + f26);
   HEAPF32[i12 >> 2] = f24;
   HEAPF32[i19 + 28 >> 2] = f2;
   HEAPF32[i19 + 32 >> 2] = f27;
   i11 = i19 + 36 | 0;
   HEAPF32[i11 >> 2] = f23;
   HEAPF32[i19 + 40 >> 2] = f2;
   HEAPF32[i19 + 44 >> 2] = f27;
   i22 = i19 + 48 | 0;
   f4 = Math_fround(f3 + f26);
   HEAPF32[i22 >> 2] = f23;
   HEAPF32[i19 + 52 >> 2] = f25;
   HEAPF32[i19 + 56 >> 2] = f4;
   i7 = i19 + 60 | 0;
   HEAPF32[i7 >> 2] = f24;
   HEAPF32[i19 + 64 >> 2] = f25;
   HEAPF32[i19 + 68 >> 2] = f4;
   i9 = i19 + 72 | 0;
   HEAPF32[i9 >> 2] = f24;
   HEAPF32[i19 + 76 >> 2] = f2;
   HEAPF32[i19 + 80 >> 2] = f4;
   i10 = i19 + 84 | 0;
   HEAPF32[i10 >> 2] = f23;
   HEAPF32[i19 + 88 >> 2] = f2;
   HEAPF32[i19 + 92 >> 2] = f4;
   HEAP8[i17 >> 0] = 4;
   HEAP8[i17 + 1 >> 0] = 4;
   HEAP8[i17 + 2 >> 0] = 4;
   HEAP8[i17 + 3 >> 0] = 4;
   HEAP8[i17 + 4 >> 0] = 4;
   HEAP8[i17 + 5 >> 0] = 4;
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 12 | 0;
   HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i13 = i18 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = i18 + 36 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 48 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 60 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 72 | 0;
   HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i13 = i18 + 84 | 0;
   HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i13 = i18 + 96 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 108 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 120 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 132 | 0;
   HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i13 = i18 + 144 | 0;
   HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i13 = i18 + 156 | 0;
   HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i13 = i18 + 168 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 180 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = i18 + 192 | 0;
   HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i13 = i18 + 204 | 0;
   HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i13 = i18 + 216 | 0;
   HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i13 = i18 + 228 | 0;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i13 = i18 + 240 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i13 = i18 + 252 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i13 = i18 + 264 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i13 = i18 + 276 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i13 = 6;
   break;
  }
 default:
  {
   i13 = 0;
   i1 = i5 + 48 | 0;
  }
 }
 i9 = i14 + 528 | 0;
 f25 = Math_fround(HEAPF32[i14 + 784 >> 2]);
 f23 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(f25 * f23);
 f26 = Math_fround(HEAPF32[i14 + 532 >> 2]);
 f27 = Math_fround(f25 * f26);
 f24 = Math_fround(HEAPF32[i14 + 536 >> 2]);
 f25 = Math_fround(f25 * f24);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i14 + 516 >> 2]));
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i14 + 520 >> 2]));
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i14 + 524 >> 2]));
 HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 f24 = Math_fround(Math_fround(Math_fround(f4 * f23) + Math_fround(f27 * f26)) + Math_fround(f25 * f24));
 f25 = Math_fround(-f24);
 i9 = f24 > Math_fround(-0.0);
 f26 = Math_fround(HEAPF32[i5 + 204 >> 2]);
 f27 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i19 + 12 >> 2] = Math_fround(f25 - Math_fround(Math_fround((i9 ? f24 : f25) + ((HEAP32[i6 >> 2] | 0) == 3 ? f26 : f27)) * Math_fround(.0000999999974)));
 HEAP32[i16 >> 2] = 0;
 i9 = i14 + 548 | 0;
 i5 = HEAP8[i9 >> 0] | 0;
 i10 = i5 << 24 >> 24 ? 2 : 1;
 i11 = i14 + 192 | 0;
 i6 = i20 + 12 | 0;
 i7 = i20 + 16 | 0;
 i8 = i20 + 20 | 0;
 i12 = i20 + 4 | 0;
 i1 = 0;
 while (1) {
  HEAP32[i20 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f27 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f2 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f25 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  HEAPF32[i6 >> 2] = f27;
  HEAPF32[i7 >> 2] = f2;
  HEAPF32[i8 >> 2] = f25;
  __Z14CalcHullBoundsPK8Vector3fPKhhRK5PlaneRK10Matrix4x4fR10MinMaxAABB(i18, i17, i13, i19, i5 << 24 >> 24 == 0 ? i11 : i14 + 256 + (i1 << 6) | 0, i20);
  i5 = i15 + (i1 << 4) | 0;
  f25 = Math_fround(HEAPF32[i20 >> 2]);
  f2 = Math_fround(Math_fround(f25 + Math_fround(1.0)) * Math_fround(.5));
  f27 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(Math_fround(f27 + Math_fround(1.0)) * Math_fround(.5));
  f24 = Math_fround(HEAPF32[i6 >> 2]);
  f3 = Math_fround(Math_fround(f24 - f25) * Math_fround(.5));
  f26 = Math_fround(HEAPF32[i7 >> 2]);
  f23 = Math_fround(Math_fround(f26 - f27) * Math_fround(.5));
  HEAPF32[i5 >> 2] = f2;
  HEAPF32[i15 + (i1 << 4) + 8 >> 2] = f3;
  HEAPF32[i15 + (i1 << 4) + 4 >> 2] = f4;
  HEAPF32[i15 + (i1 << 4) + 12 >> 2] = f23;
  if (f24 > f25 & f26 > f27) HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 1 << i1; else {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i10 | 0)) break;
  i5 = HEAP8[i9 >> 0] | 0;
 }
 STACKTOP = i21;
 return;
}

function __Z26BuildSerializationCacheForP11Il2CppClassRb(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21;
 i14 = i21 + 168 | 0;
 i16 = i21 + 144 | 0;
 i17 = i21 + 8 | 0;
 i20 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63496 | 0, 16, gb + 458083 | 0, 59) | 0;
 __ZN23CachedSerializationDataC2Ev(i20);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 __ZN12CachedReaderC2Ev(i17 + 16 | 0);
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 4 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP16[i14 + 16 >> 1] = 1;
 HEAP32[i16 >> 2] = 0;
 i1 = i16 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i5 = i13;
 i15 = HEAP32[i5 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = i15;
 i9 = i16 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i19 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i14, i16, i20, 0, 0);
 i15 = i20 + 4 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i5 + 1;
 i10 = i20 + 8 + (i5 * 24 | 0) | 0;
 i6 = i20 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i11 = HEAP32[i16 >> 2] | 0;
  i12 = i20 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i12 >> 2] = i2;
  i3 = i20 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i11 | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i10 >> 0] = 1;
 HEAP8[i10 + 1 >> 0] = 0;
 HEAP8[i19 >> 0] = (HEAP8[i19 >> 0] | 0) == 0 ? HEAP8[i9 >> 0] | 0 : 1;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
  HEAP32[i16 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 4 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP16[i14 + 16 >> 1] = 3;
 HEAP32[i16 >> 2] = 0;
 i1 = i16 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i10 = i13;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i16 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i19 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i14, i16, i20, 0, 0);
 i5 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i5 + 1;
 i10 = i20 + 8 + (i5 * 24 | 0) | 0;
 i6 = i20 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i11 = HEAP32[i16 >> 2] | 0;
  i12 = i20 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i12 >> 2] = i2;
  i3 = i20 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i11 | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i10 >> 0] = 3;
 HEAP8[i10 + 1 >> 0] = 0;
 HEAP8[i19 >> 0] = (HEAP8[i19 >> 0] | 0) == 0 ? HEAP8[i9 >> 0] | 0 : 1;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
  HEAP32[i16 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 4 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP16[i14 + 16 >> 1] = 6;
 HEAP32[i16 >> 2] = 0;
 i1 = i16 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i10 = i13;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i16 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i19 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i14, i16, i20, 0, 0);
 i5 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i5 + 1;
 i10 = i20 + 8 + (i5 * 24 | 0) | 0;
 i6 = i20 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i11 = HEAP32[i16 >> 2] | 0;
  i12 = i20 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i12 >> 2] = i2;
  i3 = i20 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i11 | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i10 >> 0] = 6;
 HEAP8[i10 + 1 >> 0] = 0;
 HEAP8[i19 >> 0] = (HEAP8[i19 >> 0] | 0) == 0 ? HEAP8[i9 >> 0] | 0 : 1;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
  HEAP32[i16 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 4 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP16[i14 + 16 >> 1] = 263;
 HEAP32[i16 >> 2] = 0;
 i1 = i16 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i10 = i13;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i16 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i19 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i14, i16, i20, 0, 0);
 i5 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i5 + 1;
 i10 = i20 + 8 + (i5 * 24 | 0) | 0;
 i6 = i20 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i16 | 0) != (i6 | 0)) {
  i11 = HEAP32[i16 >> 2] | 0;
  i12 = i20 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i12 >> 2] = i2;
  i3 = i20 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i11 | 0, HEAP32[i12 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i10 >> 0] = 7;
 HEAP8[i10 + 1 >> 0] = 1;
 HEAP8[i19 >> 0] = (HEAP8[i19 >> 0] | 0) == 0 ? HEAP8[i9 >> 0] | 0 : 1;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
  HEAP32[i16 >> 2] = 0;
 }
 __ZN14SafeBinaryReadC2Ev(i17);
 HEAP32[i14 >> 2] = i18;
 HEAP32[i14 + 4 >> 2] = i18;
 HEAP32[i14 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP16[i14 + 16 >> 1] = 5;
 HEAP32[i16 >> 2] = 0;
 i1 = i16 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i11 = i16 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i7 = i13;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = i16 + 20 | 0;
 HEAP8[i10 >> 0] = HEAP8[i19 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i14, i16, i20, 0, 0);
 i6 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i6 + 1;
 i7 = i20 + 8 + (i6 * 24 | 0) | 0;
 i5 = i20 + 8 + (i6 * 24 | 0) + 4 | 0;
 if ((i16 | 0) != (i5 | 0)) {
  i8 = HEAP32[i16 >> 2] | 0;
  i9 = i20 + 8 + (i6 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i9 >> 2] = i2;
  i3 = i20 + 8 + (i6 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i20 + 8 + (i6 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 8 + (i6 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i9 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i8 | 0, HEAP32[i9 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i7 >> 0] = 5;
 HEAP8[i7 + 1 >> 0] = 0;
 HEAP8[i19 >> 0] = (HEAP8[i19 >> 0] | 0) == 0 ? HEAP8[i10 >> 0] | 0 : 1;
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i12);
  HEAP32[i16 >> 2] = 0;
 }
 __ZN14SafeBinaryReadD2Ev(i17);
 i1 = HEAP32[gb + 1163040 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return i20 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i1 + 4 | 0)) {
  STACKTOP = i21;
  return i20 | 0;
 }
 while (1) {
  mftCall_viii(HEAP32[i2 + 16 >> 2] | 0, i18 | 0, i20 | 0, i19 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == ((HEAP32[gb + 1163040 >> 2] | 0) + 4 | 0)) break; else i2 = i1;
 }
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN5physx22PxcSweepCapsuleCapsuleERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i4 + 496 | 0;
 i16 = i4 + 480 | 0;
 i42 = i4 + 524 | 0;
 i38 = i4 + 512 | 0;
 i19 = i4 + 240 | 0;
 i20 = i4 + 416 | 0;
 i22 = i4 + 272 | 0;
 i21 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i37 = HEAP32[i8 >> 2] | 0;
 i61 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i37 + 40 | 0;
 i39 = HEAP32[i8 >> 2] | 0;
 f40 = Math_fround(HEAPF32[i37 + 44 >> 2]);
 i9 = i61 + 40 | 0;
 i37 = HEAP32[i9 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i61 + 44 >> 2]);
 f55 = Math_fround(HEAPF32[i11 >> 2]);
 f56 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f54 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i61 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i61 >> 2]);
 f25 = Math_fround(HEAPF32[i61 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i61 + 8 >> 2]);
 i61 = HEAP32[i12 >> 2] | 0;
 i60 = HEAP32[i12 + 4 >> 2] | 0;
 i59 = HEAP32[i12 + 8 >> 2] | 0;
 i58 = HEAP32[i12 + 12 >> 2] | 0;
 i35 = i6 + 16 | 0;
 i57 = HEAP32[i35 >> 2] | 0;
 i43 = HEAP32[i35 + 4 >> 2] | 0;
 i35 = HEAP32[i35 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i61;
 i33 = i19 + 4 | 0;
 HEAP32[i33 >> 2] = i60;
 i5 = i19 + 8 | 0;
 HEAP32[i5 >> 2] = i59;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = i58;
 HEAP32[i19 + 16 >> 2] = i57;
 HEAP32[i19 + 20 >> 2] = i43;
 HEAP32[i19 + 24 >> 2] = i35;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f52 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = Math_fround(-f52);
 f47 = Math_fround(-f47);
 f41 = Math_fround(-f41);
 f29 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f30 - f29);
 f48 = Math_fround(f25 - f24);
 f50 = Math_fround(f27 - f32);
 f51 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f53 = Math_fround(Math_fround(Math_fround(f26 * f52) + Math_fround(f48 * f47)) + Math_fround(f50 * f41));
 f23 = Math_fround(Math_fround(Math_fround(f53 * f47) + Math_fround(Math_fround(f51 * f48) + Math_fround(f28 * Math_fround(Math_fround(f26 * f41) - Math_fround(f50 * f52))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f51 * f50) + Math_fround(f28 * Math_fround(Math_fround(f48 * f52) - Math_fround(f26 * f47)))) + Math_fround(f53 * f41)) * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f54 * f28) - Math_fround(Math_fround(Math_fround(f55 * f52) + Math_fround(f56 * f47)) + Math_fround(f49 * f41)));
 f46 = Math_fround(Math_fround(Math_fround(f49 * f47) - Math_fround(f56 * f41)) + Math_fround(Math_fround(f54 * f52) + Math_fround(f55 * f28)));
 f44 = Math_fround(Math_fround(Math_fround(f55 * f41) - Math_fround(f49 * f52)) + Math_fround(Math_fround(f54 * f47) + Math_fround(f56 * f28)));
 f49 = Math_fround(Math_fround(Math_fround(f56 * f52) - Math_fround(f55 * f47)) + Math_fround(Math_fround(f54 * f41) + Math_fround(f49 * f28)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(Math_fround(f51 * f26) + Math_fround(f28 * Math_fround(Math_fround(f50 * f47) - Math_fround(f48 * f41))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f23;
 HEAPF32[i20 + 56 >> 2] = f34;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f34 = Math_fround(f46 + f46);
 f23 = Math_fround(f44 + f44);
 f41 = Math_fround(f49 + f49);
 f48 = Math_fround(f44 * f23);
 f47 = Math_fround(f49 * f41);
 f44 = Math_fround(f44 * f34);
 f50 = Math_fround(f49 * f34);
 f28 = Math_fround(f45 * f34);
 f49 = Math_fround(f49 * f23);
 f23 = Math_fround(f45 * f23);
 f41 = Math_fround(f45 * f41);
 f34 = Math_fround(Math_fround(1.0) - Math_fround(f46 * f34));
 f46 = Math_fround(f44 + f41);
 f45 = Math_fround(f50 - f23);
 f41 = Math_fround(f44 - f41);
 f44 = Math_fround(f34 - f47);
 f26 = Math_fround(f49 + f28);
 f23 = Math_fround(f50 + f23);
 f28 = Math_fround(f49 - f28);
 f34 = Math_fround(f34 - f48);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f48) - f47);
 HEAPF32[i20 + 4 >> 2] = f46;
 HEAPF32[i20 + 8 >> 2] = f45;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f41;
 HEAPF32[i20 + 20 >> 2] = f44;
 HEAPF32[i20 + 24 >> 2] = f26;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f23;
 HEAPF32[i20 + 36 >> 2] = f28;
 HEAPF32[i20 + 40 >> 2] = f34;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 f34 = Math_fround(f40 * Math_fround(0.0));
 i35 = i22 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 80 >> 2] = 4;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 128 >> 2] = i39;
 i43 = i22 + 132 | 0;
 HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 f28 = Math_fround(HEAPF32[i16 >> 2]);
 f23 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f44 = Math_fround(f34 + f23);
 f41 = Math_fround(f34 + f26);
 HEAPF32[i22 + 96 >> 2] = Math_fround(f40 + f28);
 HEAPF32[i22 + 100 >> 2] = f44;
 HEAPF32[i22 + 104 >> 2] = f41;
 HEAPF32[i22 + 108 >> 2] = Math_fround(0.0);
 f41 = Math_fround(f23 - f34);
 f34 = Math_fround(f26 - f34);
 HEAPF32[i22 + 112 >> 2] = Math_fround(f28 - f40);
 HEAPF32[i22 + 116 >> 2] = f41;
 HEAPF32[i22 + 120 >> 2] = f34;
 HEAPF32[i22 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 16 >> 2] = i39;
 i43 = i22 + 20 | 0;
 HEAP32[i43 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i22 + 32 >> 2] = i39;
 i39 = i22 + 36 | 0;
 HEAP32[i39 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 HEAP32[i36 >> 2] = -1;
 HEAP32[i36 + 4 >> 2] = -1;
 HEAP32[i36 + 8 >> 2] = -1;
 HEAP32[i36 + 12 >> 2] = -1;
 HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 f34 = Math_fround(f31 * Math_fround(0.0));
 i35 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 4;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i21 + 128 >> 2] = i37;
 i39 = i21 + 132 | 0;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 f41 = Math_fround(f34 + f23);
 f40 = Math_fround(f34 + f26);
 HEAPF32[i21 + 96 >> 2] = Math_fround(f31 + f28);
 HEAPF32[i21 + 100 >> 2] = f41;
 HEAPF32[i21 + 104 >> 2] = f40;
 HEAPF32[i21 + 108 >> 2] = Math_fround(0.0);
 f23 = Math_fround(f23 - f34);
 f34 = Math_fround(f26 - f34);
 HEAPF32[i21 + 112 >> 2] = Math_fround(f28 - f31);
 HEAPF32[i21 + 116 >> 2] = f23;
 HEAPF32[i21 + 120 >> 2] = f34;
 HEAPF32[i21 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i21 + 16 >> 2] = i37;
 i39 = i21 + 20 | 0;
 HEAP32[i39 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i21 + 32 >> 2] = i37;
 i37 = i21 + 36 | 0;
 HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i36 >> 2] = -1;
 HEAP32[i36 + 4 >> 2] = -1;
 HEAP32[i36 + 8 >> 2] = -1;
 HEAP32[i36 + 12 >> 2] = -1;
 HEAP32[i35 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 HEAPF32[i17 >> 2] = f10;
 f34 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f34 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i33 >> 2]);
 f24 = Math_fround(HEAPF32[i5 >> 2]);
 f28 = Math_fround(HEAPF32[i6 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(__ZN5physx8CCDSweepINS_2Gu8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i9 >> 2])) + f7)) | 0)) {
  f56 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f56);
 }
 f56 = Math_fround(HEAPF32[i2 >> 2]);
 i61 = HEAP32[i3 + 4 >> 2] | 0;
 i60 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i61;
 HEAP32[i13 + 8 >> 2] = i60;
 i60 = HEAP32[i1 + 4 >> 2] | 0;
 i61 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i60;
 HEAP32[i14 + 8 >> 2] = i61;
 STACKTOP = i4;
 return Math_fround(f56);
}

function __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb(i31, i30, i27, i29, i26, i28, i10, i15, i14) {
 i31 = i31 | 0;
 i30 = i30 | 0;
 i27 = i27 | 0;
 i29 = i29 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i32 = 0, f33 = f0, f34 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i32 + 88 | 0;
 i9 = i32 + 72 | 0;
 i13 = i32 + 60 | 0;
 i16 = i32 + 48 | 0;
 i17 = i32 + 36 | 0;
 i19 = i32 + 24 | 0;
 i20 = i32 + 12 | 0;
 i25 = i32;
 i21 = i31 + 12 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i8 = HEAP32[i5 + 20 >> 2] | 0;
 i24 = (Math_imul(i8, i30) | 0) + i27 | 0;
 i23 = i24 * 3 | 0;
 i4 = ((HEAP32[i5 + 16 >> 2] | 0) + -2 | 0) == (i30 | 0);
 i1 = i15 & 1;
 i3 = (i8 + -2 | 0) == (i27 | 0) & i15;
 i18 = i4 & i15;
 i4 = i4 & i3;
 i2 = i24 << 1;
 i5 = HEAP32[i5 + 36 >> 2] | 0;
 i12 = i2 | 1;
 i6 = i24 & 2147483647;
 i11 = HEAP8[i5 + (i6 << 2) + 3 >> 0] | 0;
 do if (i10) {
  if ((HEAP8[i5 + (i6 << 2) + 2 >> 0] & 127) == 127) {
   i2 = 0;
   i6 = i15;
   i5 = i18;
  } else if (__ZNK5physx2Gu15HeightFieldUtil24findProjectionOnTriangleEjjjRKNS_6PxVec3ERS2_(i31, i2, i30, i27, i29, i9) | 0) {
   HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i26 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i26 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   if (!i28) {
    i2 = 1;
    i1 = 0;
    i6 = 0;
    i5 = 0;
   } else {
    HEAP32[i28 >> 2] = i2;
    i2 = 1;
    i1 = 0;
    i6 = 0;
    i5 = 0;
   }
  } else {
   i2 = 0;
   i6 = i15;
   i5 = i18;
  }
  if ((i11 & 127) != 127) if (__ZNK5physx2Gu15HeightFieldUtil24findProjectionOnTriangleEjjjRKNS_6PxVec3ERS2_(i31, i12, i30, i27, i29, i13) | 0) {
   HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i13 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i12;
   i2 = i2 + 1 | 0;
   i1 = 0;
   i3 = 0;
   i4 = 0;
  }
  if (!i15) {
   i31 = i2;
   STACKTOP = i32;
   return i31 | 0;
  }
  if ((i2 | 0) == 0 | i14 ^ 1) {
   i8 = HEAP32[(HEAP32[i21 >> 2] | 0) + 20 >> 2] | 0;
   i11 = (i1 & 1) != 0;
   i10 = i3;
   i12 = i5;
   i13 = 15;
   break;
  } else {
   i31 = i2;
   STACKTOP = i32;
   return i31 | 0;
  }
 } else if (i15) {
  i2 = 0;
  i11 = 1;
  i6 = 1;
  i10 = i3;
  i12 = i18;
  i13 = 15;
 } else {
  i2 = 0;
  i5 = 0;
  i6 = 0;
  i1 = i18;
  i13 = 37;
 } while (0);
 L22 : do if ((i13 | 0) == 15) {
  f7 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i31, i23, i24, i30, i27, i29, i16));
  if (f7 <= Math_fround(0.0)) {
   if (!i6) {
    i5 = i11;
    i6 = 0;
    i3 = i10;
    i1 = i12;
    i13 = 37;
    break;
   }
   i1 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i21 >> 2] | 0, i24, i30, i27, i22) | 0;
   L27 : do if (i1 | 0) {
    i3 = 0;
    while (1) {
     if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i31, HEAP32[i22 + (i3 << 4) >> 2] | 0, HEAP32[i22 + (i3 << 4) + 4 >> 2] | 0, HEAP32[i22 + (i3 << 4) + 8 >> 2] | 0, HEAP32[i22 + (i3 << 4) + 12 >> 2] | 0) | 0) != -1) break;
     i3 = i3 + 2 | 0;
     if (i3 >>> 0 >= i1 >>> 0) break L27;
    }
    HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i16 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = (Math_imul(i8, i30) | 0) + i27 | -2147483648;
    i2 = i2 + 1 | 0;
    i9 = 1;
    i5 = 0;
    i3 = i12;
    i6 = i4;
    i13 = 38;
    break L22;
   } while (0);
   i9 = 1;
   i5 = 0;
   i3 = i12;
   i6 = i4;
   i13 = 38;
   break;
  }
  if (f7 < Math_fround(1.0)) {
   if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i31, i23) | 0) == -1) {
    i5 = i11;
    i3 = i10;
    i1 = i12;
    i13 = 37;
    break;
   }
   HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i23 | 1073741824;
   i2 = i2 + 1 | 0;
   i5 = i11;
   i3 = i10;
   i1 = i12;
   i13 = 37;
   break;
  }
  if (i10) {
   i1 = i27 + 1 | 0;
   i3 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i21 >> 2] | 0, i24 + 1 | 0, i30, i1, i22) | 0;
   L45 : do if (i3 | 0) {
    i5 = 0;
    while (1) {
     if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i31, HEAP32[i22 + (i5 << 4) >> 2] | 0, HEAP32[i22 + (i5 << 4) + 4 >> 2] | 0, HEAP32[i22 + (i5 << 4) + 8 >> 2] | 0, HEAP32[i22 + (i5 << 4) + 12 >> 2] | 0) | 0) != -1) break;
     i5 = i5 + 2 | 0;
     if (i5 >>> 0 >= i3 >>> 0) break L45;
    }
    HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i16 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i1 + (Math_imul(i8, i30) | 0) | -2147483648;
    i2 = i2 + 1 | 0;
    i5 = i11;
    i3 = 1;
    i1 = i12;
    i13 = 37;
    break L22;
   } while (0);
   i5 = i11;
   i3 = 1;
   i1 = i12;
   i13 = 37;
  } else {
   i5 = i11;
   i3 = 0;
   i1 = i12;
   i13 = 37;
  }
 } while (0);
 if ((i13 | 0) == 37) if (i1 | i6) {
  i11 = i5;
  i9 = i6;
  i10 = i3;
  i5 = i6;
  i3 = i1;
  i6 = i4;
  i13 = 38;
 } else i9 = i5;
 L56 : do if ((i13 | 0) == 38) {
  i1 = i23 + 2 | 0;
  f7 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i31, i1, i24, i30, i27, i29, i17));
  if (f7 <= Math_fround(0.0)) {
   if (!i5) {
    i9 = i11;
    i3 = i10;
    i4 = i6;
    break;
   }
   i1 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i21 >> 2] | 0, i24, i30, i27, i22) | 0;
   L61 : do if (i1 | 0) {
    i3 = 0;
    while (1) {
     if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i31, HEAP32[i22 + (i3 << 4) >> 2] | 0, HEAP32[i22 + (i3 << 4) + 4 >> 2] | 0, HEAP32[i22 + (i3 << 4) + 8 >> 2] | 0, HEAP32[i22 + (i3 << 4) + 12 >> 2] | 0) | 0) != -1) break;
     i3 = i3 + 2 | 0;
     if (i3 >>> 0 >= i1 >>> 0) break L61;
    }
    HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i17 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = (Math_imul(i8, i30) | 0) + i27 | -2147483648;
    i2 = i2 + 1 | 0;
    i9 = i11;
    i3 = i10;
    i4 = i6;
    break L56;
   } while (0);
   i9 = i11;
   i3 = i10;
   i4 = i6;
   break;
  }
  if (f7 < Math_fround(1.0)) {
   if (!i9) {
    i9 = i11;
    i3 = i10;
    i4 = i6;
    break;
   }
   if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i31, i1) | 0) == -1) {
    i9 = i11;
    i3 = i10;
    i4 = i6;
    break;
   }
   HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i1 | 1073741824;
   i2 = i2 + 1 | 0;
   i9 = i11;
   i3 = i10;
   i4 = i6;
   break;
  }
  if (i3) {
   i1 = i30 + 1 | 0;
   i3 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i21 >> 2] | 0, i8 + i24 | 0, i1, i27, i22) | 0;
   L80 : do if (i3 | 0) {
    i4 = 0;
    while (1) {
     if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i31, HEAP32[i22 + (i4 << 4) >> 2] | 0, HEAP32[i22 + (i4 << 4) + 4 >> 2] | 0, HEAP32[i22 + (i4 << 4) + 8 >> 2] | 0, HEAP32[i22 + (i4 << 4) + 12 >> 2] | 0) | 0) != -1) break;
     i4 = i4 + 2 | 0;
     if (i4 >>> 0 >= i3 >>> 0) break L80;
    }
    HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i17 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = (Math_imul(i8, i1) | 0) + i27 | -2147483648;
    i2 = i2 + 1 | 0;
    i9 = i11;
    i3 = i10;
    i4 = i6;
    break L56;
   } while (0);
   i9 = i11;
   i3 = i10;
   i4 = i6;
  } else {
   i9 = i11;
   i3 = i10;
   i4 = i6;
  }
 } while (0);
 if (i18) {
  i1 = (i8 * 3 | 0) + i23 | 0;
  f7 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i31, i1, i8 + i24 | 0, i30 + 1 | 0, i27, i29, i19));
  if (!(f7 <= Math_fround(0.0)) & f7 < Math_fround(1.0)) if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i31, i1) | 0) != -1) {
   HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i19 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i1 | 1073741824;
   i2 = i2 + 1 | 0;
  }
 }
 if (i3) {
  i1 = i23 + 5 | 0;
  f7 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i31, i1, i24 + 1 | 0, i30, i27 + 1 | 0, i29, i20));
  if (!(f7 <= Math_fround(0.0)) & f7 < Math_fround(1.0)) if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i31, i1) | 0) != -1) {
   HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i20 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i1 | 1073741824;
   i2 = i2 + 1 | 0;
  }
 }
 L106 : do if (i4) {
  i1 = i24 + 1 | 0;
  i3 = i30 + 1 | 0;
  i4 = i27 + 1 | 0;
  i5 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i21 >> 2] | 0, i1 + i8 | 0, i3, i4, i22) | 0;
  L108 : do if (i5 | 0) {
   i6 = 0;
   while (1) {
    if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i31, HEAP32[i22 + (i6 << 4) >> 2] | 0, HEAP32[i22 + (i6 << 4) + 4 >> 2] | 0, HEAP32[i22 + (i6 << 4) + 8 >> 2] | 0, HEAP32[i22 + (i6 << 4) + 12 >> 2] | 0) | 0) != -1) break;
    i6 = i6 + 2 | 0;
    if (i6 >>> 0 >= i5 >>> 0) break L108;
   }
   f34 = Math_fround(i3 >>> 0);
   i22 = HEAP32[i31 + 16 >> 2] | 0;
   f34 = Math_fround(f34 * Math_fround(HEAPF32[i22 + 12 >> 2]));
   f33 = Math_fround(HEAPF32[i22 + 8 >> 2]);
   i21 = HEAP32[i21 >> 2] | 0;
   f33 = Math_fround(f33 * Math_fround(HEAP16[(HEAP32[i21 + 36 >> 2] | 0) + (i1 + (HEAP32[i21 + 20 >> 2] | 0) << 2) >> 1] | 0));
   f7 = Math_fround(i4 >>> 0);
   f7 = Math_fround(f7 * Math_fround(HEAPF32[i22 + 16 >> 2]));
   HEAPF32[i26 + (i2 * 12 | 0) >> 2] = f34;
   HEAPF32[i26 + (i2 * 12 | 0) + 4 >> 2] = f33;
   HEAPF32[i26 + (i2 * 12 | 0) + 8 >> 2] = f7;
   if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i4 + (Math_imul(i8, i3) | 0) | -2147483648;
   i2 = i2 + 1 | 0;
   break L106;
  } while (0);
 } while (0);
 if (!i9) {
  i31 = i2;
  STACKTOP = i32;
  return i31 | 0;
 }
 i1 = i23 + 1 | 0;
 if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i31, i1) | 0) == -1) {
  i31 = i2;
  STACKTOP = i32;
  return i31 | 0;
 }
 f34 = Math_fround(__ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i31, i1, i24, i30, i27, i29, i25));
 if (!(!(f34 <= Math_fround(0.0)) & f34 < Math_fround(1.0))) {
  i31 = i2;
  STACKTOP = i32;
  return i31 | 0;
 }
 HEAP32[i26 + (i2 * 12 | 0) >> 2] = HEAP32[i25 >> 2];
 HEAP32[i26 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i26 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 if (i28 | 0) HEAP32[i28 + (i2 << 2) >> 2] = i1 | 1073741824;
 i31 = i2 + 1 | 0;
 STACKTOP = i32;
 return i31 | 0;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i31, i3, i18, i9, i1) {
 i31 = i31 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i30 + 144 | 0;
 i16 = i30 + 128 | 0;
 i17 = i30 + 112 | 0;
 i14 = i30 + 96 | 0;
 i12 = i30 + 80 | 0;
 i5 = i30 + 64 | 0;
 i8 = i30 + 48 | 0;
 i4 = i30 + 32 | 0;
 i29 = i30 + 16 | 0;
 i28 = i30;
 i27 = i30 + 160 | 0;
 i39 = HEAP32[i3 >> 2] | 0;
 i24 = HEAP32[i3 + 4 >> 2] | 0;
 i25 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i15 >> 2] = i39;
 i10 = i15 + 4 | 0;
 HEAP32[i10 >> 2] = i24;
 i11 = i15 + 8 | 0;
 HEAP32[i11 >> 2] = i25;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 i42 = HEAP32[i3 + 12 >> 2] | 0;
 i41 = HEAP32[i3 + 16 >> 2] | 0;
 i40 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i16 >> 2] = i42;
 HEAP32[i16 + 4 >> 2] = i41;
 HEAP32[i16 + 8 >> 2] = i40;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 i26 = HEAP32[i3 + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 i13 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP32[i17 >> 2] = i26;
 HEAP32[i17 + 4 >> 2] = i1;
 HEAP32[i17 + 8 >> 2] = i13;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 f37 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f37 - f2);
 f6 = Math_fround(f19 - f33);
 f38 = Math_fround(f20 - f7);
 f21 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = Math_fround(f21 - f2);
 f36 = Math_fround(f22 - f33);
 f32 = Math_fround(f23 - f7);
 f34 = Math_fround(Math_fround(f6 * f32) - Math_fround(f38 * f36));
 f32 = Math_fround(Math_fround(f38 * f35) - Math_fround(f37 * f32));
 f35 = Math_fround(Math_fround(f37 * f36) - Math_fround(f6 * f35));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f35 * f35) + Math_fround(Math_fround(f34 * f34) + Math_fround(f32 * f32))))));
 f34 = Math_fround(f6 * f34);
 f32 = Math_fround(f6 * f32);
 f6 = Math_fround(f35 * f6);
 HEAPF32[i14 >> 2] = f34;
 HEAPF32[i14 + 4 >> 2] = f32;
 HEAPF32[i14 + 8 >> 2] = f6;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(Math_fround(Math_fround(f2 * f34) + Math_fround(f33 * f32)) + Math_fround(f7 * f6));
 i13 = i31 + 2368 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (Math_fround(Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f32 * f2)) + Math_fround(f6 * Math_fround(HEAPF32[i1 + 8 >> 2]))) - f7) < Math_fround(0.0)) {
  i42 = 0;
  STACKTOP = i30;
  return i42 | 0;
 }
 __ZN5physx2Gu33pcmDistanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_S7_(i4, i1 + 96 | 0, i1 + 112 | 0, i15, i16, i17, i12, i5, i8);
 i3 = i31 + 2352 | 0;
 f38 = Math_fround(HEAPF32[i31 + 2352 >> 2]);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f38 > f7)) {
  i42 = 1;
  STACKTOP = i30;
  return i42 | 0;
 }
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 do if (f6 == Math_fround(0.0)) {
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  if (f2 == Math_fround(0.0)) if (!(i9 & 40)) {
   i1 = 14;
   break;
  } else {
   i1 = 15;
   break;
  }
  i1 = i9 & 255;
  if (f2 == Math_fround(1.0)) if (!(i1 & 48)) {
   i1 = 14;
   break;
  } else {
   f2 = Math_fround(1.0);
   i1 = 15;
   break;
  } else if (!(i1 & 32)) {
   i1 = 14;
   break;
  } else {
   i1 = 15;
   break;
  }
 } else {
  i42 = f6 == Math_fround(1.0);
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  i1 = f2 == Math_fround(0.0);
  if (i42) if ((i9 & 24) == 0 & i1) {
   i1 = 14;
   break;
  } else {
   i1 = 15;
   break;
  }
  if (i1) if (!(i9 & 8)) {
   i1 = 14;
   break;
  } else {
   i1 = 15;
   break;
  } else if ((i9 & 16) == 0 | !(Math_fround(f6 + f2) >= Math_fround(.999899983))) {
   i1 = 14;
   break;
  } else {
   i1 = 15;
   break;
  }
 } while (0);
 do if ((i1 | 0) == 14) {
  HEAP32[i29 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 } else if ((i1 | 0) == 15) if (f7 == Math_fround(0.0)) {
  HEAP32[i29 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  break;
 } else {
  i42 = HEAP32[i13 >> 2] | 0;
  f38 = Math_fround(HEAPF32[i42 + 112 >> 2]);
  f37 = Math_fround(HEAPF32[i42 + 116 >> 2]);
  f36 = Math_fround(HEAPF32[i42 + 120 >> 2]);
  f32 = Math_fround(HEAPF32[i42 + 96 >> 2]);
  f33 = Math_fround(HEAPF32[i42 + 100 >> 2]);
  f34 = Math_fround(HEAPF32[i42 + 104 >> 2]);
  f38 = Math_fround(f38 - f32);
  f37 = Math_fround(f37 - f33);
  f36 = Math_fround(f36 - f34);
  f35 = Math_fround(HEAPF32[i12 >> 2]);
  f32 = Math_fround(Math_fround(f38 * f35) + f32);
  f33 = Math_fround(Math_fround(f37 * f35) + f33);
  f34 = Math_fround(Math_fround(f36 * f35) + f34);
  f35 = Math_fround(Math_fround(1.0) - Math_fround(f6 + f2));
  f36 = Math_fround(HEAPF32[i15 >> 2]);
  f37 = Math_fround(HEAPF32[i10 >> 2]);
  f38 = Math_fround(HEAPF32[i11 >> 2]);
  f36 = Math_fround(f32 - Math_fround(Math_fround(f36 * f35) + Math_fround(Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f6) + Math_fround(f21 * f2))));
  f37 = Math_fround(f33 - Math_fround(Math_fround(f37 * f35) + Math_fround(Math_fround(f19 * f6) + Math_fround(f22 * f2))));
  f38 = Math_fround(f34 - Math_fround(Math_fround(f35 * f38) + Math_fround(Math_fround(f20 * f6) + Math_fround(f23 * f2))));
  f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f38 * f38) + Math_fround(Math_fround(f36 * f36) + Math_fround(f37 * f37))))));
  f37 = Math_fround(f35 * f37);
  f38 = Math_fround(f35 * f38);
  HEAPF32[i29 >> 2] = Math_fround(f35 * f36);
  HEAPF32[i29 + 4 >> 2] = f37;
  HEAPF32[i29 + 8 >> 2] = f38;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  break;
 } while (0);
 i24 = i31 + 2324 | 0;
 i25 = HEAP32[i24 >> 2] | 0;
 i42 = HEAP32[i13 >> 2] | 0;
 i26 = i31 + 2320 | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration16generateContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj(i15, i16, i17, i14, i29, i18, i42 + 96 | 0, i42 + 112 | 0, i31 + 2336 | 0, HEAP32[i26 >> 2] | 0, i24) | 0;
 i42 = HEAP32[i13 >> 2] | 0;
 i41 = i42 + 96 | 0;
 i42 = i42 + 112 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i41, i42, i3, i29, i18, i15, i16, i1, i24);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i41, i42, i3, i29, i18, i16, i17, i1, i24);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i41, i42, i3, i29, i18, i15, i17, i1, i24);
 i1 = HEAP32[i24 >> 2] | 0;
 if ((i1 | 0) == (i25 | 0)) {
  i42 = 1;
  STACKTOP = i30;
  return i42 | 0;
 }
 HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (i25 >>> 0 < i1 >>> 0) {
  i3 = i31 + 2304 | 0;
  i4 = i31 + 2308 | 0;
  i5 = i31 + 2312 | 0;
  i8 = i31 + 2256 | 0;
  i9 = i31 + 2272 | 0;
  i10 = i31 + 2288 | 0;
  i11 = i31 + 2260 | 0;
  i12 = i31 + 2276 | 0;
  i13 = i31 + 2292 | 0;
  i14 = i31 + 2264 | 0;
  i15 = i31 + 2280 | 0;
  i16 = i31 + 2296 | 0;
  i17 = i28 + 4 | 0;
  f2 = Math_fround(3402823469999999843913219.0e14);
  i18 = i25;
  do {
   i1 = HEAP32[i26 >> 2] | 0;
   f38 = Math_fround(HEAPF32[i1 + (i18 << 6) + 44 >> 2]);
   f34 = Math_fround(HEAPF32[i3 >> 2]);
   f23 = Math_fround(HEAPF32[i4 >> 2]);
   f32 = Math_fround(HEAPF32[i5 >> 2]);
   i40 = i1 + (i18 << 6) | 0;
   f22 = Math_fround(HEAPF32[i40 >> 2]);
   i41 = i1 + (i18 << 6) + 4 | 0;
   f33 = Math_fround(HEAPF32[i41 >> 2]);
   i42 = i1 + (i18 << 6) + 8 | 0;
   f37 = Math_fround(HEAPF32[i42 >> 2]);
   f35 = Math_fround(f22 * Math_fround(HEAPF32[i8 >> 2]));
   f35 = Math_fround(f35 + Math_fround(f33 * Math_fround(HEAPF32[i9 >> 2])));
   f35 = Math_fround(f35 + Math_fround(f37 * Math_fround(HEAPF32[i10 >> 2])));
   f36 = Math_fround(f22 * Math_fround(HEAPF32[i11 >> 2]));
   f36 = Math_fround(f36 + Math_fround(f33 * Math_fround(HEAPF32[i12 >> 2])));
   f36 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i13 >> 2])));
   f22 = Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2]));
   f33 = Math_fround(f22 + Math_fround(f33 * Math_fround(HEAPF32[i15 >> 2])));
   f36 = Math_fround(f23 + f36);
   f37 = Math_fround(f32 + Math_fround(f33 + Math_fround(f37 * Math_fround(HEAPF32[i16 >> 2]))));
   HEAPF32[i40 >> 2] = Math_fround(f34 + f35);
   HEAPF32[i41 >> 2] = f36;
   HEAPF32[i42 >> 2] = f37;
   HEAPF32[i1 + (i18 << 6) + 12 >> 2] = Math_fround(0.0);
   f2 = f2 > f38 ? f38 : f2;
   HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   i18 = i18 + 1 | 0;
   i1 = HEAP32[i24 >> 2] | 0;
  } while (i18 >>> 0 < i1 >>> 0);
  HEAPF32[i28 >> 2] = f2;
 }
 if (i25 >>> 0 < i1 >>> 0) {
  i9 = i31 + 2240 | 0;
  i8 = i25;
  do {
   i3 = HEAP32[i26 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i3 + (i8 << 6) + 16 >> 2]);
   f6 = Math_fround(HEAPF32[i3 + (i8 << 6) + 20 >> 2]);
   f7 = Math_fround(HEAPF32[i3 + (i8 << 6) + 24 >> 2]);
   i8 = i8 + 1 | 0;
   L42 : do if (i8 >>> 0 < i1 >>> 0) {
    i4 = i8;
    while (1) {
     f36 = Math_fround(HEAPF32[i3 + (i4 << 6) + 16 >> 2]);
     f37 = Math_fround(HEAPF32[i3 + (i4 << 6) + 20 >> 2]);
     f36 = Math_fround(f36 - f2);
     f37 = Math_fround(f37 - f6);
     f38 = Math_fround(Math_fround(HEAPF32[i3 + (i4 << 6) + 24 >> 2]) - f7);
     f38 = Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f37 * f37)) + Math_fround(f38 * f38));
     if (Math_fround(HEAPF32[i9 >> 2]) > f38) {
      i5 = i3 + (i4 << 6) | 0;
      i1 = i3 + (i1 + -1 << 6) | 0;
      i3 = i5 + 52 | 0;
      do {
       HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
       i5 = i5 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i5 | 0) < (i3 | 0));
      i1 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
      HEAP32[i24 >> 2] = i1;
      i3 = i4 + -1 | 0;
     } else i3 = i4;
     i4 = i3 + 1 | 0;
     if (i4 >>> 0 >= i1 >>> 0) break L42;
     i3 = HEAP32[i26 >> 2] | 0;
    }
   } while (0);
  } while (i8 >>> 0 < i1 >>> 0);
 }
 __ZN5physx2Gu24PCMMeshContactGeneration23addManifoldPointToPatchERKNS_6shdfnd3aos5Vec3VERKNS3_6FloatVEj(i31, i29, i28, i25);
 if ((HEAP32[i24 >> 2] | 0) >>> 0 <= 15) {
  i42 = 1;
  STACKTOP = i30;
  return i42 | 0;
 }
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i31, 3, 1);
 i42 = 1;
 STACKTOP = i30;
 return i42 | 0;
}

function __ZL21CompileFragmentShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 16 | 0;
 i15 = i18 + 8 | 0;
 i14 = i18;
 i7 = i18 + 92 | 0;
 i8 = i18 + 80 | 0;
 i9 = i18 + 68 | 0;
 i10 = i18 + 56 | 0;
 i11 = i18 + 44 | 0;
 i13 = i18 + 32 | 0;
 i17 = i18 + 20 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i6 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 < 4;
 i12 = HEAP32[gb + 1451148 >> 2] | 0;
 i4 = (HEAP8[i12 + 163 >> 0] | 0) != 0;
 i12 = (HEAP8[i12 + 165 >> 0] | 0) != 0 & i2;
 i5 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | 0) == 0;
 if (i3) if (!(_strstr(i6, gb + 605228 | 0) | 0)) if (!(_strstr(i6, gb + 605250 | 0) | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i1 = 0;
   i2 = 0;
   i3 = 0;
  } else {
   i1 = i6;
   L6 : while (1) {
    i3 = i1 + 1 | 0;
    if (_isspace(i2 << 24 >> 24) | 0) {
     i1 = i3;
     while (1) {
      i2 = HEAP8[i1 >> 0] | 0;
      i3 = i1 + 1 | 0;
      if (!(_isspace(i2 << 24 >> 24) | 0)) break; else i1 = i3;
     }
    }
    if (i2 << 24 >> 24 != 35) break;
    switch (HEAP8[i3 >> 0] | 0) {
    case 118:
     {
      if ((HEAP8[i1 + 2 >> 0] | 0) != 101) break L6;
      if ((HEAP8[i1 + 3 >> 0] | 0) == 114) i2 = 35; else break L6;
      break;
     }
    case 101:
     {
      if ((HEAP8[i1 + 2 >> 0] | 0) != 120) break L6;
      if ((HEAP8[i1 + 3 >> 0] | 0) == 116) i2 = 35; else break L6;
      break;
     }
    default:
     break L6;
    }
    while (1) {
     switch (i2 << 24 >> 24) {
     case 13:
     case 10:
      continue L6;
     default:
      {}
     }
     i2 = i1 + 1 | 0;
     i1 = i2;
     i2 = HEAP8[i2 >> 0] | 0;
    }
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i7, i6, i1 - i6 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i8, i1) | 0;
   i1 = HEAP8[i7 + 11 >> 0] | 0;
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i19 = i4 ? gb + 605228 | 0 : gb + 605250 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i20 = i1 << 24 >> 24 < 0;
  i1 = i20 ? i2 : i1 & 255;
  i2 = i4 ? 21 : 23;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i20 ? i3 : i7, i1, i1 + i2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, i19, i2) | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i3 = HEAP8[i11 + 11 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i11 + 4 >> 2] | 0 : i3 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i2 ? HEAP32[i11 >> 2] | 0 : i11, i3, i3 + 2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, gb + 605274 | 0, 2) | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i3 = HEAP8[i10 + 11 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i3 & 255;
  i4 = i8 + 11 | 0;
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i2 ? HEAP32[i10 >> 2] | 0 : i10, i3, i1 + i3 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i17, i9) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = 0;
 } else i1 = 1; else i1 = 1; else i1 = 1;
 if (i5) {
  if (i1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i17, i6) | 0;
 } else {
  if (i1) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i6, _strlen(i6) | 0);
  } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i17);
  __ZL39PatchShaderSourceForAdrenoES3WorkaroundNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPS5_(i13, i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 }
 i13 = i17 + 11 | 0;
 i11 = HEAP8[i13 >> 0] | 0;
 if (!i12) {
  i16 = i11;
  i20 = HEAP32[i17 >> 2] | 0;
  i19 = HEAP32[gb + 1451080 >> 2] | 0;
  i16 = i16 << 24 >> 24 < 0;
  i20 = i16 ? i20 : i17;
  i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return i20 | 0;
 }
 i6 = i11 << 24 >> 24 < 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i12 = i17 + 4 | 0;
 i1 = i6 ? i8 : i17;
 i6 = i6 ? HEAP32[i12 >> 2] | 0 : i11 & 255;
 if (i6 >>> 0 < 17) {
  i16 = i11;
  i20 = i8;
  i19 = HEAP32[gb + 1451080 >> 2] | 0;
  i16 = i16 << 24 >> 24 < 0;
  i20 = i16 ? i20 : i17;
  i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return i20 | 0;
 }
 i9 = i1 + i6 | 0;
 i7 = i9;
 i10 = i1;
 L40 : do if ((i6 | 0) < 17) i2 = i7; else {
  i5 = i9 + -16 | 0;
  if ((i5 | 0) == (i1 | 0)) i2 = i7; else {
   i2 = i1;
   L42 : while (1) {
    while (1) {
     if ((HEAP8[i2 >> 0] | 0) == 116) {
      i3 = gb + 605277 | 0;
      i4 = i2;
      break;
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) {
      i2 = i7;
      break L40;
     }
    }
    do {
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (gb + 605277 + 17 | 0)) break L42;
     i4 = i4 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i5 | 0)) {
     i2 = i7;
     break L40;
    }
   }
  }
 } while (0);
 if ((i2 | 0) == (i9 | 0) | (i2 - i10 | 0) == -1) {
  if (i6 >>> 0 < 18) {
   i16 = i11;
   i20 = i8;
   i19 = HEAP32[gb + 1451080 >> 2] | 0;
   i16 = i16 << 24 >> 24 < 0;
   i20 = i16 ? i20 : i17;
   i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   STACKTOP = i18;
   return i20 | 0;
  }
  L58 : do if ((i6 | 0) < 18) i1 = i7; else {
   i4 = i9 + -17 | 0;
   if ((i4 | 0) == (i1 | 0)) i1 = i7; else L60 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 116) {
      i2 = gb + 605295 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i7;
      break L58;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 605295 + 18 | 0)) break L60;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i7;
     break L58;
    }
   }
  } while (0);
  if ((i1 | 0) == (i9 | 0) | (i1 - i10 | 0) == -1) {
   i16 = i11;
   i20 = i8;
   i19 = HEAP32[gb + 1451080 >> 2] | 0;
   i16 = i16 << 24 >> 24 < 0;
   i20 = i16 ? i20 : i17;
   i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   STACKTOP = i18;
   return i20 | 0;
  }
 }
 _printf_console(gb + 605314 | 0, i14);
 _printf_console(gb + 605371 | 0, i15);
 _printf_console(gb + 605437 | 0, i16);
 i3 = HEAP8[i13 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = i2 ? i1 : i17;
 i2 = i2 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
 if (i2 >>> 0 < 11) {
  i16 = i3;
  i20 = i1;
  i19 = HEAP32[gb + 1451080 >> 2] | 0;
  i16 = i16 << 24 >> 24 < 0;
  i20 = i16 ? i20 : i17;
  i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return i20 | 0;
 }
 i9 = i4 + i2 | 0;
 i7 = i9;
 i8 = i4;
 L76 : do if ((i2 | 0) < 11) i4 = i7; else {
  i6 = i9 + -10 | 0;
  if ((i6 | 0) == (i4 | 0)) i4 = i7; else L78 : while (1) {
   while (1) {
    if ((HEAP8[i4 >> 0] | 0) == 116) {
     i2 = gb + 605542 | 0;
     i5 = i4;
     break;
    }
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i6 | 0)) {
     i4 = i7;
     break L76;
    }
   }
   do {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (gb + 605542 + 11 | 0)) break L78;
    i5 = i5 + 1 | 0;
   } while ((HEAP8[i5 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i6 | 0)) {
    i4 = i7;
    break L76;
   }
  }
 } while (0);
 i2 = i4 - i8 | 0;
 if ((i4 | 0) == (i9 | 0) | (i2 | 0) == -1) {
  i16 = i3;
  i20 = i1;
  i19 = HEAP32[gb + 1451080 >> 2] | 0;
  i16 = i16 << 24 >> 24 < 0;
  i20 = i16 ? i20 : i17;
  i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return i20 | 0;
 } else i4 = i2;
 while (1) {
  i5 = i4 + 11 | 0;
  i1 = i3 << 24 >> 24 < 0 ? i1 : i17;
  i2 = i1 + i5 | 0;
  if (!(_strncmp(gb + 605554 | 0, i2, 6) | 0)) {
   HEAP8[i1 + (i4 + 14) >> 0] = 32;
   HEAP8[((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17) + (i4 + 15) >> 0] = 32;
   HEAP8[((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17) + (i4 + 16) >> 0] = 32;
  } else if (!(_strncmp(gb + 605561 | 0, i2, 7) | 0)) {
   HEAP8[i1 + (i4 + 15) >> 0] = 65;
   HEAP8[((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17) + (i4 + 16) >> 0] = 82;
   HEAP8[((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17) + (i4 + 17) >> 0] = 66;
  }
  i3 = HEAP8[i13 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i1 = HEAP32[i17 >> 2] | 0;
  i9 = i4 ? i1 : i17;
  i4 = i4 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
  if (i4 >>> 0 < i5 >>> 0 | (i4 - i5 | 0) >>> 0 < 11) {
   i2 = 74;
   break;
  }
  i2 = i9 + i5 | 0;
  i8 = i9 + i4 | 0;
  i6 = i8;
  L99 : do if ((i6 - i2 | 0) < 11) i2 = i6; else {
   i7 = i8 + -10 | 0;
   if ((i7 | 0) == (i2 | 0)) i2 = i6; else L101 : while (1) {
    while (1) {
     if ((HEAP8[i2 >> 0] | 0) == 116) {
      i4 = gb + 605542 | 0;
      i5 = i2;
      break;
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = i6;
      break L99;
     }
    }
    do {
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (gb + 605542 + 11 | 0)) break L101;
     i5 = i5 + 1 | 0;
    } while ((HEAP8[i5 >> 0] | 0) == (HEAP8[i4 >> 0] | 0));
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i7 | 0)) {
     i2 = i6;
     break L99;
    }
   }
  } while (0);
  i4 = i2 - i9 | 0;
  if ((i2 | 0) == (i8 | 0) | (i4 | 0) == -1) {
   i2 = 74;
   break;
  }
 }
 if ((i2 | 0) == 74) {
  i19 = HEAP32[gb + 1451080 >> 2] | 0;
  i20 = i3 << 24 >> 24 < 0;
  i20 = i20 ? i1 : i17;
  i20 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i19, 4, i20) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return i20 | 0;
 }
 return 0;
}

function __ZN7mecanim9animation18ClipMuscleConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 24 | 0;
 i4 = i7 + 16 | 0;
 i5 = i7;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898434 | 0, gb + 898446 | 0, i1, 0);
 __ZN7mecanim5human9HumanPose8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 888 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898456 | 0, gb + 905989 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1085944 | 0, 0);
 i6 = i1 + 900 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i6, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 916 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 928 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898465 | 0, gb + 905989 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1085944 | 0, 0);
 i6 = i1 + 940 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i6, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 956 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 968 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898473 | 0, gb + 905989 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1085944 | 0, 0);
 i6 = i1 + 980 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i6, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 996 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 1008 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898490 | 0, gb + 905989 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1085944 | 0, 0);
 i6 = i1 + 1020 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i6, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 1036 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 1048 | 0, gb + 898508 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898523 | 0, gb + 905830 | 0, i1 + 1060 | 0, 0);
 i6 = i3;
 i8 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 898530 | 0, i3, 0);
 __ZN7mecanim9animation4Clip8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898535 | 0, i11, i1 + 1064 | 0, 0);
 i6 = i2 + 16 | 0;
 i8 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898547 | 0, i11, i1 + 1068 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898558 | 0, i11, i1 + 1072 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898579 | 0, i11, i1 + 1076 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898587 | 0, i11, i1 + 1080 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898601 | 0, i11, i1 + 1084 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = 155;
 HEAP32[i5 + 4 >> 2] = i1 + 1088;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898623 | 0, HEAP32[gb + 37256 >> 2] | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i2 + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 1712;
 HEAP32[i5 + 4 >> 2] = i1 + 1708;
 HEAP32[i5 + 8 >> 2] = i10;
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898636 | 0, i10, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 898886 | 0, i4, 0);
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898897 | 0, i9, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898905 | 0, i9, i4 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 1720;
 HEAP32[i5 + 4 >> 2] = i1 + 1716;
 HEAP32[i5 + 8 >> 2] = i11;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898654 | 0, i10, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898680 | 0, i5, i1 + 1724 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898689 | 0, i5, i1 + 1725 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898700 | 0, i5, i1 + 1726 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898712 | 0, i5, i1 + 1727 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898735 | 0, i5, i1 + 1728 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898756 | 0, i5, i1 + 1729 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898778 | 0, i5, i1 + 1730 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898794 | 0, i5, i1 + 1731 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898820 | 0, i5, i1 + 1732 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898844 | 0, i5, i1 + 1733 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898869 | 0, i5, i1 + 1734 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i7;
 return;
}

function __Z19tessComputeInteriorP14TESStesselator(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i2 = HEAP32[i19 >> 2] | 0;
 i6 = i2 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if ((i1 | 0) == (i6 | 0)) i9 = i2; else {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i5 = HEAP32[i1 + 12 >> 2] | 0;
   i4 = HEAP32[i1 + 16 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 16 >> 2] | 0;
   if (f8 == Math_fround(HEAPF32[i3 + 24 >> 2])) {
    f8 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    if (f8 == Math_fround(HEAPF32[i3 + 28 >> 2])) {
     i3 = i5 + 12 | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) i3 = i5; else {
      if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i19 >> 2] | 0, i5, i1) | 0)) {
       i17 = 6;
       break;
      }
      if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i19 >> 2] | 0, i1) | 0)) {
       i17 = 8;
       break;
      }
      i3 = HEAP32[i3 >> 2] | 0;
      i1 = i5;
     }
    } else i3 = i5;
   } else i3 = i5;
   if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) {
    if ((i3 | 0) != (i1 | 0)) {
     if ((i3 | 0) == (i2 | 0)) i17 = 14; else if ((i3 | 0) == (HEAP32[i2 + 4 >> 2] | 0)) i17 = 14;
     if ((i17 | 0) == 14) {
      i17 = 0;
      i2 = HEAP32[i2 >> 2] | 0;
     }
     if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i19 >> 2] | 0, i3) | 0)) {
      i17 = 16;
      break;
     }
    }
    if ((i1 | 0) == (i2 | 0)) i17 = 19; else if ((i1 | 0) == (HEAP32[i2 + 4 >> 2] | 0)) i17 = 19;
    if ((i17 | 0) == 19) {
     i17 = 0;
     i2 = HEAP32[i2 >> 2] | 0;
    }
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i19 >> 2] | 0, i1) | 0)) {
     i17 = 22;
     break;
    } else i1 = i2;
   } else i1 = i2;
   if ((i1 | 0) == (i6 | 0)) {
    i17 = 23;
    break;
   }
  }
  if ((i17 | 0) == 6) _longjmp(i19 + 144 | 0, 1); else if ((i17 | 0) == 8) _longjmp(i19 + 144 | 0, 1); else if ((i17 | 0) == 16) _longjmp(i19 + 144 | 0, 1); else if ((i17 | 0) == 22) _longjmp(i19 + 144 | 0, 1); else if ((i17 | 0) == 23) {
   i9 = HEAP32[i19 >> 2] | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) i1 = 0; else {
  i2 = i1;
  i1 = 0;
  do {
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  } while ((i2 | 0) != (i9 | 0));
 }
 i16 = i19 + 104 | 0;
 i9 = HEAP32[i19 + 140 >> 2] | 0;
 i9 = __Z14pqNewPriorityQP9TESSallociPFiPvS1_E(i16, ((i9 | 0) > 8 ? i9 : 8) + i1 | 0, fb + 517 | 0) | 0;
 i18 = i19 + 68 | 0;
 HEAP32[i18 >> 2] = i9;
 if (!i9) {
  i19 = 0;
  return i19 | 0;
 }
 i10 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 L41 : do if ((i1 | 0) == (i10 | 0)) i17 = 40; else {
  i11 = i9 + 20 | 0;
  i12 = i9 + 12 | 0;
  i13 = i9 + 16 | 0;
  i6 = i9 + 4 | 0;
  i14 = i19 + 108 | 0;
  i15 = i19 + 116 | 0;
  while (1) {
   if (!(HEAP32[i11 >> 2] | 0)) {
    i5 = HEAP32[i12 >> 2] | 0;
    i4 = i5 + 1 | 0;
    HEAP32[i12 >> 2] = i4;
    i2 = HEAP32[i13 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) i2 = HEAP32[i6 >> 2] | 0; else {
     i3 = HEAP32[i14 >> 2] | 0;
     if (!i3) break;
     i4 = HEAP32[i6 >> 2] | 0;
     HEAP32[i13 >> 2] = i2 << 1;
     i2 = mftCall_iiii(i3 | 0, HEAP32[i15 >> 2] | 0, i4 | 0, i2 << 3 | 0) | 0;
     HEAP32[i6 >> 2] = i2;
     if (!i2) {
      i17 = 35;
      break;
     }
    }
    HEAP32[i2 + (i5 << 2) >> 2] = i1;
    i2 = ~i5;
   } else i2 = __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv(i16, HEAP32[i9 >> 2] | 0, i1) | 0;
   HEAP32[i1 + 32 >> 2] = i2;
   if ((i2 | 0) == 268435455) break L41;
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) == (i10 | 0)) {
    i17 = 40;
    break L41;
   }
  }
  if ((i17 | 0) == 35) HEAP32[i6 >> 2] = i4;
  HEAP32[i1 + 32 >> 2] = 268435455;
 } while (0);
 if ((i17 | 0) == 40) if (__Z6pqInitP9TESSallocP9PriorityQ(i16, i9) | 0) {
  i16 = __Z11dictNewDictP9TESSallocPvPFiS1_S1_S1_E(i16, i19, fb + 336 | 0) | 0;
  i14 = i19 + 64 | 0;
  HEAP32[i14 >> 2] = i16;
  if (!i16) _longjmp(i19 + 144 | 0, 1);
  f23 = Math_fround(HEAPF32[i19 + 52 >> 2]);
  f20 = Math_fround(HEAPF32[i19 + 44 >> 2]);
  f7 = Math_fround(f23 - f20);
  f8 = Math_fround(HEAPF32[i19 + 56 >> 2]);
  f22 = Math_fround(HEAPF32[i19 + 48 >> 2]);
  f21 = Math_fround(f8 - f22);
  f20 = Math_fround(f20 - f7);
  f7 = Math_fround(f23 + f7);
  f8 = Math_fround(f8 + f21);
  __ZL11AddSentinelP14TESStesselatorfff(i19, f20, f7, Math_fround(f22 - f21));
  __ZL11AddSentinelP14TESStesselatorfff(i19, f20, f7, f8);
  L64 : while (1) {
   i1 = HEAP32[i18 >> 2] | 0;
   i4 = i1 + 12 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   L66 : do if (!i3) i6 = __Z16pqHeapExtractMinP13PriorityQHeap(HEAP32[i1 >> 2] | 0) | 0; else {
    i5 = HEAP32[i1 + 8 >> 2] | 0;
    i6 = HEAP32[HEAP32[i5 + (i3 + -1 << 2) >> 2] >> 2] | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    do if (!(HEAP32[i1 + 8 >> 2] | 0)) i1 = i3; else {
     i2 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
     f7 = Math_fround(HEAPF32[i2 + 24 >> 2]);
     f8 = Math_fround(HEAPF32[i6 + 24 >> 2]);
     if (!(f7 < f8)) {
      if (!(f7 == f8)) {
       i1 = i3;
       break;
      }
      f23 = Math_fround(HEAPF32[i2 + 28 >> 2]);
      if (!(f23 <= Math_fround(HEAPF32[i6 + 28 >> 2]))) {
       i1 = i3;
       break;
      }
     }
     i6 = __Z16pqHeapExtractMinP13PriorityQHeap(i1) | 0;
     break L66;
    } while (0);
    do {
     i2 = i1;
     i1 = i1 + -1 | 0;
     if ((i2 | 0) <= 1) break;
    } while (!(HEAP32[HEAP32[i5 + (i2 + -2 << 2) >> 2] >> 2] | 0));
    HEAP32[i4 >> 2] = i1;
   } while (0);
   if (!i6) break;
   i11 = i6 + 24 | 0;
   i12 = i6 + 28 | 0;
   i13 = i6 + 8 | 0;
   while (1) {
    i5 = HEAP32[i18 >> 2] | 0;
    i10 = i5 + 12 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    i9 = (i2 | 0) == 0;
    do if (i9) {
     i3 = HEAP32[i5 >> 2] | 0;
     i1 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
     i17 = 71;
    } else {
     i1 = HEAP32[HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + (i2 + -1 << 2) >> 2] >> 2] | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     if (!(HEAP32[i3 + 8 >> 2] | 0)) i17 = 71; else {
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
      f7 = Math_fround(HEAPF32[i4 + 24 >> 2]);
      f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
      if (f7 < f8) {
       i1 = i4;
       i17 = 71;
      } else if (f7 == f8) {
       f23 = Math_fround(HEAPF32[i4 + 28 >> 2]);
       if (f23 <= Math_fround(HEAPF32[i1 + 28 >> 2])) {
        i1 = i4;
        break;
       }
      }
     }
    } while (0);
    if ((i17 | 0) == 71) {
     i17 = 0;
     if (!i1) break;
    }
    f23 = Math_fround(HEAPF32[i1 + 24 >> 2]);
    if (!(f23 == Math_fround(HEAPF32[i11 >> 2]))) break;
    f23 = Math_fround(HEAPF32[i1 + 28 >> 2]);
    if (!(f23 == Math_fround(HEAPF32[i12 >> 2]))) break;
    L96 : do if (i9) i1 = __Z16pqHeapExtractMinP13PriorityQHeap(i3) | 0; else {
     i5 = HEAP32[i5 + 8 >> 2] | 0;
     i1 = HEAP32[HEAP32[i5 + (i2 + -1 << 2) >> 2] >> 2] | 0;
     do if (HEAP32[i3 + 8 >> 2] | 0) {
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
      f7 = Math_fround(HEAPF32[i4 + 24 >> 2]);
      f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
      if (!(f7 < f8)) {
       if (!(f7 == f8)) break;
       f23 = Math_fround(HEAPF32[i4 + 28 >> 2]);
       if (!(f23 <= Math_fround(HEAPF32[i1 + 28 >> 2]))) break;
      }
      i1 = __Z16pqHeapExtractMinP13PriorityQHeap(i3) | 0;
      break L96;
     } while (0);
     do {
      i3 = i2;
      i2 = i2 + -1 | 0;
      if ((i3 | 0) <= 1) break;
     } while (!(HEAP32[HEAP32[i5 + (i3 + -2 << 2) >> 2] >> 2] | 0));
     HEAP32[i10 >> 2] = i2;
    } while (0);
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i19 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0)) {
     i17 = 85;
     break L64;
    }
   }
   __ZL10SweepEventP14TESStesselatorP10TESSvertex(i19, i6);
  }
  if ((i17 | 0) == 85) _longjmp(i19 + 144 | 0, 1);
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i19 + 72 >> 2] = HEAP32[i1 + 16 >> 2];
  L114 : do if (i3) {
   i4 = i19 + 76 | 0;
   while (1) {
    HEAP32[i1 + 24 >> 2] = 0;
    i17 = HEAP32[i3 + 4 >> 2] | 0;
    i16 = i17 + 8 | 0;
    i15 = HEAP32[i17 + 4 >> 2] | 0;
    HEAP32[i15 + 8 >> 2] = HEAP32[i16 >> 2];
    HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] = i15;
    i2 = HEAP32[i2 + 16 >> 2] | 0;
    HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i2 >> 2] = i17;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i2 >> 2] = i3;
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0;
    if (!i3) break L114;
    i1 = HEAP32[i3 >> 2] | 0;
   }
  } while (0);
  i5 = HEAP32[i2 + 16 >> 2] | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i6 = i5 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i4 + 8 | 0;
  i4 = i4 + 12 | 0;
  if (i1 | 0) do {
   i17 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i17 | 0);
  } while ((i1 | 0) != 0);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i5 | 0);
  i3 = i19 + 112 | 0;
  i4 = i19 + 116 | 0;
  mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0);
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 | 0);
  }
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i2 | 0);
  i3 = (HEAP32[i19 >> 2] | 0) + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i19 = 1;
   return i19 | 0;
  }
  while (1) {
   i2 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0) == (i2 | 0)) {
    i18 = HEAP32[i2 + 8 >> 2] | 0;
    i17 = i18 + 28 | 0;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i2 + 28 >> 2] | 0);
    i18 = (HEAP32[i18 + 4 >> 2] | 0) + 28 | 0;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 28 >> 2] | 0);
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i19 >> 2] | 0, i2) | 0)) {
     i1 = 0;
     i17 = 103;
     break;
    }
   }
   if ((i1 | 0) == (i3 | 0)) {
    i1 = 1;
    i17 = 103;
    break;
   }
  }
  if ((i17 | 0) == 103) return i1 | 0;
 }
 i3 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i19 + 112 | 0;
 if (i1 | 0) {
  i17 = i19 + 116 | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i17 >> 2] | 0, i1 | 0);
 }
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i19 + 116 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i1 = i19 + 116 | 0; else {
  i19 = i19 + 116 | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i19 >> 2] | 0, i1 | 0);
  i1 = i19;
 }
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 | 0);
 HEAP32[i18 >> 2] = 0;
 i19 = 0;
 return i19 | 0;
}

function __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_RKNS6_6FloatVE(i1, i71, i73, i74, i72) {
 i1 = i1 | 0;
 i71 = i71 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 i72 = i72 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i75 = 0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i70 = i75 + 192 | 0;
 i49 = i75 + 180 | 0;
 i50 = i75 + 168 | 0;
 i61 = i75 + 156 | 0;
 i63 = i75 + 144 | 0;
 i64 = i75 + 132 | 0;
 i65 = i75 + 120 | 0;
 i66 = i75 + 108 | 0;
 i67 = i75 + 96 | 0;
 i68 = i75 + 84 | 0;
 i69 = i75 + 72 | 0;
 i51 = i75 + 60 | 0;
 i52 = i75 + 48 | 0;
 i53 = i75 + 36 | 0;
 i54 = i75 + 24 | 0;
 i55 = i75 + 12 | 0;
 i56 = i75;
 i57 = i73 + 20 | 0;
 i58 = i73 + 24 | 0;
 i59 = i74 + 20 | 0;
 i60 = i74 + 24 | 0;
 i62 = i1 + 32 | 0;
 if (!(HEAP8[i62 >> 0] | 0)) {
  STACKTOP = i75;
  return;
 }
 i1 = i1 + 44 | 0;
 i2 = i74 + 4 | 0;
 i3 = i74 + 8 | 0;
 i4 = i74 + 12 | 0;
 i5 = i73 + 4 | 0;
 i6 = i73 + 8 | 0;
 i7 = i73 + 12 | 0;
 i8 = i73 + 16 | 0;
 i9 = i74 + 16 | 0;
 i10 = i70 + 4 | 0;
 i11 = i70 + 20 | 0;
 i12 = i70 + 24 | 0;
 i13 = i70 + 40 | 0;
 i14 = i70 + 44 | 0;
 i15 = i70 + 60 | 0;
 i16 = i49 + 4 | 0;
 i17 = i49 + 8 | 0;
 i18 = i50 + 4 | 0;
 i19 = i50 + 8 | 0;
 i20 = i61 + 4 | 0;
 i21 = i61 + 8 | 0;
 i22 = i63 + 4 | 0;
 i23 = i63 + 8 | 0;
 i24 = i64 + 4 | 0;
 i25 = i64 + 8 | 0;
 i26 = i65 + 4 | 0;
 i27 = i65 + 8 | 0;
 i28 = i66 + 4 | 0;
 i29 = i66 + 8 | 0;
 i30 = i67 + 4 | 0;
 i31 = i67 + 8 | 0;
 i32 = i68 + 4 | 0;
 i33 = i68 + 8 | 0;
 i34 = i69 + 4 | 0;
 i35 = i69 + 8 | 0;
 i36 = i51 + 4 | 0;
 i37 = i51 + 8 | 0;
 i38 = i52 + 4 | 0;
 i39 = i52 + 8 | 0;
 i40 = i53 + 4 | 0;
 i41 = i53 + 8 | 0;
 i42 = i54 + 4 | 0;
 i43 = i54 + 8 | 0;
 i44 = i55 + 4 | 0;
 i45 = i55 + 8 | 0;
 i46 = i56 + 4 | 0;
 i47 = i56 + 8 | 0;
 i48 = 0;
 do {
  i76 = HEAP32[i1 >> 2] | 0;
  f83 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 32 >> 2]);
  f90 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 36 >> 2]);
  f86 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 40 >> 2]);
  f91 = Math_fround(HEAPF32[i74 >> 2]);
  f89 = Math_fround(HEAPF32[i2 >> 2]);
  f87 = Math_fround(HEAPF32[i3 >> 2]);
  f92 = Math_fround(HEAPF32[i4 >> 2]);
  f94 = Math_fround(Math_fround(f92 * f92) + Math_fround(-.5));
  f95 = Math_fround(Math_fround(Math_fround(f83 * f91) + Math_fround(f90 * f89)) + Math_fround(f86 * f87));
  f85 = Math_fround(Math_fround(Math_fround(f91 * f95) + Math_fround(Math_fround(f92 * Math_fround(Math_fround(f86 * f89) - Math_fround(f90 * f87))) + Math_fround(f83 * f94))) * Math_fround(2.0));
  f84 = Math_fround(Math_fround(Math_fround(f89 * f95) + Math_fround(Math_fround(f92 * Math_fround(Math_fround(f83 * f87) - Math_fround(f86 * f91))) + Math_fround(f90 * f94))) * Math_fround(2.0));
  f86 = Math_fround(Math_fround(Math_fround(f87 * f95) + Math_fround(Math_fround(f92 * Math_fround(Math_fround(f90 * f91) - Math_fround(f83 * f89))) + Math_fround(f86 * f94))) * Math_fround(2.0));
  f83 = Math_fround(HEAPF32[i72 >> 2]);
  f90 = Math_fround(HEAPF32[i73 >> 2]);
  f95 = Math_fround(HEAPF32[i5 >> 2]);
  f79 = Math_fround(HEAPF32[i6 >> 2]);
  f93 = Math_fround(HEAPF32[i7 >> 2]);
  f82 = Math_fround(HEAPF32[i8 >> 2]);
  f81 = Math_fround(HEAPF32[i57 >> 2]);
  f97 = Math_fround(HEAPF32[i58 >> 2]);
  f78 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) >> 2]);
  f88 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 4 >> 2]);
  f77 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 8 >> 2]);
  f96 = Math_fround(Math_fround(f93 * f93) + Math_fround(-.5));
  f80 = Math_fround(Math_fround(Math_fround(f90 * f78) + Math_fround(f95 * f88)) + Math_fround(f79 * f77));
  f82 = Math_fround(Math_fround(f82 + Math_fround(Math_fround(Math_fround(f90 * f80) + Math_fround(Math_fround(f96 * f78) + Math_fround(f93 * Math_fround(Math_fround(f95 * f77) - Math_fround(f79 * f88))))) * Math_fround(2.0))) - Math_fround(f83 * f85));
  f81 = Math_fround(Math_fround(f81 + Math_fround(Math_fround(Math_fround(f95 * f80) + Math_fround(Math_fround(f96 * f88) + Math_fround(f93 * Math_fround(Math_fround(f79 * f78) - Math_fround(f90 * f77))))) * Math_fround(2.0))) - Math_fround(f83 * f84));
  f80 = Math_fround(Math_fround(f97 + Math_fround(Math_fround(Math_fround(Math_fround(f96 * f77) + Math_fround(f93 * Math_fround(Math_fround(f90 * f88) - Math_fround(f95 * f78)))) + Math_fround(f79 * f80)) * Math_fround(2.0))) - Math_fround(f83 * f86));
  f79 = Math_fround(HEAPF32[i9 >> 2]);
  f78 = Math_fround(HEAPF32[i59 >> 2]);
  f95 = Math_fround(HEAPF32[i60 >> 2]);
  f88 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 16 >> 2]);
  f90 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 20 >> 2]);
  f93 = Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 24 >> 2]);
  f77 = Math_fround(Math_fround(Math_fround(f91 * f88) + Math_fround(f89 * f90)) + Math_fround(f87 * f93));
  f79 = Math_fround(f79 + Math_fround(Math_fround(Math_fround(f91 * f77) + Math_fround(Math_fround(f94 * f88) + Math_fround(f92 * Math_fround(Math_fround(f89 * f93) - Math_fround(f87 * f90))))) * Math_fround(2.0)));
  f78 = Math_fround(f78 + Math_fround(Math_fround(Math_fround(f89 * f77) + Math_fround(Math_fround(f94 * f90) + Math_fround(f92 * Math_fround(Math_fround(f87 * f88) - Math_fround(f91 * f93))))) * Math_fround(2.0)));
  f77 = Math_fround(f95 + Math_fround(Math_fround(Math_fround(Math_fround(f94 * f93) + Math_fround(f92 * Math_fround(Math_fround(f91 * f90) - Math_fround(f89 * f88)))) + Math_fround(f87 * f77)) * Math_fround(2.0)));
  f83 = Math_fround(Math_fround(HEAPF32[i76 + (i48 * 48 | 0) + 44 >> 2]) - f83);
  f85 = Math_fround(f82 - Math_fround(f85 * f83));
  f84 = Math_fround(f81 - Math_fround(f84 * f83));
  f83 = Math_fround(f80 - Math_fround(f86 * f83));
  HEAPF32[i70 >> 2] = Math_fround(1.0);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAPF32[i11 >> 2] = Math_fround(1.0);
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAPF32[i15 >> 2] = Math_fround(1.0);
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -65281) | 0, i70) | 0, 1) | 0;
  HEAPF32[i49 >> 2] = f82;
  HEAPF32[i16 >> 2] = f81;
  HEAPF32[i17 >> 2] = f80;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i49) | 0;
  HEAPF32[i50 >> 2] = f85;
  HEAPF32[i18 >> 2] = f84;
  HEAPF32[i19 >> 2] = f83;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i50) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -16711681) | 0, i70) | 0, 1) | 0;
  f83 = Math_fround(f82 + Math_fround(0.0));
  f84 = Math_fround(f81 + Math_fround(.0500000007));
  f85 = Math_fround(f80 + Math_fround(0.0));
  HEAPF32[i61 >> 2] = f83;
  HEAPF32[i20 >> 2] = f84;
  HEAPF32[i21 >> 2] = f85;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i61) | 0;
  f84 = Math_fround(f81 + Math_fround(-.0500000007));
  HEAPF32[i63 >> 2] = f82;
  HEAPF32[i22 >> 2] = f84;
  HEAPF32[i23 >> 2] = f80;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i63) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -16711681) | 0, i70) | 0, 1) | 0;
  f84 = Math_fround(f81 + Math_fround(0.0));
  HEAPF32[i64 >> 2] = Math_fround(f82 + Math_fround(.0500000007));
  HEAPF32[i24 >> 2] = f84;
  HEAPF32[i25 >> 2] = f85;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i64) | 0;
  HEAPF32[i65 >> 2] = Math_fround(f82 + Math_fround(-.0500000007));
  HEAPF32[i26 >> 2] = f81;
  HEAPF32[i27 >> 2] = f80;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i65) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -16711681) | 0, i70) | 0, 1) | 0;
  f85 = Math_fround(f80 + Math_fround(.0500000007));
  HEAPF32[i66 >> 2] = f83;
  HEAPF32[i28 >> 2] = f84;
  HEAPF32[i29 >> 2] = f85;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i66) | 0;
  f85 = Math_fround(f80 + Math_fround(-.0500000007));
  HEAPF32[i67 >> 2] = f82;
  HEAPF32[i30 >> 2] = f81;
  HEAPF32[i31 >> 2] = f85;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i67) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -65536) | 0, i70) | 0, 1) | 0;
  f85 = Math_fround(f79 + Math_fround(0.0));
  f84 = Math_fround(f78 + Math_fround(.100000001));
  f83 = Math_fround(f77 + Math_fround(0.0));
  HEAPF32[i68 >> 2] = f85;
  HEAPF32[i32 >> 2] = f84;
  HEAPF32[i33 >> 2] = f83;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i68) | 0;
  f84 = Math_fround(f78 + Math_fround(-.100000001));
  HEAPF32[i69 >> 2] = f79;
  HEAPF32[i34 >> 2] = f84;
  HEAPF32[i35 >> 2] = f77;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i69) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -65536) | 0, i70) | 0, 1) | 0;
  f84 = Math_fround(f78 + Math_fround(0.0));
  HEAPF32[i51 >> 2] = Math_fround(f79 + Math_fround(.100000001));
  HEAPF32[i36 >> 2] = f84;
  HEAPF32[i37 >> 2] = f83;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i51) | 0;
  HEAPF32[i52 >> 2] = Math_fround(f79 + Math_fround(-.100000001));
  HEAPF32[i38 >> 2] = f78;
  HEAPF32[i39 >> 2] = f77;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i52) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -65536) | 0, i70) | 0, 1) | 0;
  f83 = Math_fround(f77 + Math_fround(.100000001));
  HEAPF32[i53 >> 2] = f85;
  HEAPF32[i40 >> 2] = f84;
  HEAPF32[i41 >> 2] = f83;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i53) | 0;
  f83 = Math_fround(f77 + Math_fround(-.100000001));
  HEAPF32[i54 >> 2] = f79;
  HEAPF32[i42 >> 2] = f78;
  HEAPF32[i43 >> 2] = f83;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i54) | 0;
  i76 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i71, -65536) | 0, i70) | 0, 1) | 0;
  HEAPF32[i55 >> 2] = f82;
  HEAPF32[i44 >> 2] = f81;
  HEAPF32[i45 >> 2] = f80;
  i76 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i55) | 0;
  HEAPF32[i56 >> 2] = f79;
  HEAPF32[i46 >> 2] = f78;
  HEAPF32[i47 >> 2] = f77;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i76, i56) | 0;
  i48 = i48 + 1 | 0;
 } while (i48 >>> 0 < (HEAPU8[i62 >> 0] | 0) >>> 0);
 STACKTOP = i75;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXml10processXmlERN5physx11PxInputDataEb(i18, i2, i4) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 8208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 8194 | 0;
 i15 = i24;
 i16 = i24 + 8193 | 0;
 i17 = i24 + 8192 | 0;
 i19 = i18 + 1028 | 0;
 HEAP32[i19 >> 2] = 0;
 i12 = i18 + 11312 | 0;
 i22 = HEAP32[i12 >> 2] | 0;
 i14 = i18 + 1032 | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 32 >> 2] | 0, i22 | 0, HEAP32[i14 >> 2] | 0);
 HEAP32[i14 >> 2] = 0;
 i14 = i18 + 1060 | 0;
 HEAP32[i14 >> 2] = 0;
 i22 = i18 + 1036 | 0;
 HEAP32[i22 >> 2] = 0;
 i13 = i18 + 1040 | 0;
 HEAP32[i13 >> 2] = 0;
 i20 = i18 + 1048 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i18 + 1056 | 0;
 HEAP32[i21 >> 2] = 0;
 i3 = 0;
 do {
  i1 = i18 + 9261 + i3 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) i1 = i18 + 1064 + (i3 << 2) | 0; else {
   i9 = HEAP32[i12 >> 2] | 0;
   i10 = i18 + 1064 + (i3 << 2) | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, HEAP32[i10 >> 2] | 0);
   HEAP8[i1 >> 0] = 0;
   i1 = i10;
  }
  HEAP32[i1 >> 2] = 0;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < ((HEAP32[i14 >> 2] | 0) + 1 | 0) >>> 0);
 HEAP32[i19 >> 2] = i2;
 HEAP8[i18 + 9260 >> 0] = i4 & 1;
 i9 = HEAP32[i12 >> 2] | 0;
 i10 = i18 + 1052 | 0;
 HEAP32[i10 >> 2] = 1;
 i1 = __ZN12_GLOBAL__N_19MyFastXml8readDataEPc(i18, 0) | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L8 : do if (i2 << 24 >> 24) {
  i8 = i18 + 4 | 0;
  i3 = i1;
  L10 : while (1) {
   switch (HEAP32[i18 + 4 + ((i2 & 255) << 2) >> 2] | 0) {
   case 4:
   case 2:
    {
     if (i2 << 24 >> 24 == 10) HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i1 = i3 + 1 | 0;
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) break L8; else {
      i3 = i1;
      continue L10;
     }
    }
   default:
    {}
   }
   L18 : do if (i2 << 24 >> 24 == 60) {
    i1 = i3 + 1 | 0;
    if ((HEAP8[i1 >> 0] | 0) == 47) i11 = 35; else {
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
     i2 = HEAP8[i1 >> 0] | 0;
     switch (i2 << 24 >> 24) {
     case 63:
      {
       i1 = i3 + 2 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
       i11 = 34;
       break L18;
      }
     case 33:
      break;
     default:
      {
       i11 = 34;
       break L18;
      }
     }
     i1 = i3 + 2 | 0;
     if ((HEAP8[i1 >> 0] | 0) == 45) if ((HEAP8[i3 + 3 >> 0] | 0) == 45) {
      i1 = i3 + 4 | 0;
      while (1) if ((HEAP8[i1 >> 0] | 0) == 32) i1 = i1 + 1 | 0; else break;
      i2 = _strstr(i1, gb + 767157 | 0) | 0;
      if (!i2) break;
      HEAP8[i2 >> 0] = 0;
      if (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i1 | 0) | 0) {
       i1 = i2 + 3 | 0;
       break;
      } else {
       i11 = 23;
       break L10;
      }
     }
     if (!(_strstr(i1, gb + 767194 | 0) | 0)) {
      i11 = 25;
      break L10;
     }
     i3 = i3 + 9 | 0;
     L33 : while (1) {
      i1 = HEAP32[i18 + 4 + (HEAPU8[i3 >> 0] << 2) >> 2] | 0;
      switch (i1 | 0) {
      case 2:
       {
        i3 = i3 + 1 | 0;
        break;
       }
      case 0:
       {
        i11 = 28;
        break L33;
       }
      default:
       {
        i2 = i1;
        i4 = i3;
        break L33;
       }
      }
     }
     if ((i11 | 0) == 28) {
      i11 = 0;
      i1 = i3;
      do {
       i1 = i1 + 1 | 0;
       i2 = HEAP32[i18 + 4 + (HEAPU8[i1 >> 0] << 2) >> 2] | 0;
      } while ((i2 | 0) == 0);
      i4 = i3;
      i3 = i1;
     }
     i1 = i3 + 1 | 0;
     if ((i2 | 0) != 3) while (1) {
      i2 = i1 + 1 | 0;
      if ((HEAP32[i18 + 4 + (HEAPU8[i1 >> 0] << 2) >> 2] | 0) == 3) {
       i1 = i2;
       break;
      } else i1 = i2;
     }
     HEAP8[i3 >> 0] = 0;
     if (!(mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, i4 | 0, 0, 0, 0) | 0)) {
      i11 = 33;
      break L10;
     }
    }
   } else {
    i1 = i3;
    i11 = 34;
   } while (0);
   L44 : do if ((i11 | 0) == 34) {
    i11 = 0;
    switch (i2 << 24 >> 24) {
    case 47:
     {
      i11 = 35;
      break L44;
     }
    case 63:
     {
      i1 = i1 + 1 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      break;
     }
    default:
     {}
    }
    if (!(i2 << 24 >> 24)) {
     i1 = 1;
     i11 = 96;
     break L10;
    } else i3 = i1;
    while (1) {
     if (!(i2 << 24 >> 24 != 62 ? (HEAP32[i18 + 4 + ((i2 & 255) << 2) >> 2] | 0) != 2 : 0)) break;
     i3 = i3 + 1 | 0;
     i2 = HEAP8[i3 >> 0] | 0;
     if (!(i2 << 24 >> 24)) {
      i1 = 1;
      i11 = 96;
      break L10;
     }
    }
    L53 : do if (i2 << 24 >> 24 == 62) {
     i7 = HEAP8[i3 + -1 >> 0] | 0;
     HEAP8[i3 >> 0] = 0;
     i1 = __ZN12_GLOBAL__N_19MyFastXml12processCloseEcPKcPciPS2_PN5physx6shdfnd7FastXml8CallbackERb(i18, i7 << 24 >> 24 == 63 ? 63 : i7 << 24 >> 24 == 47 ? 47 : 62, i1, i3 + 1 | 0, 0, i15, i9, i16) | 0;
     if (!i1) {
      i11 = 56;
      break L10;
     }
    } else {
     HEAP8[i3 >> 0] = 0;
     i3 = i3 + 1 | 0;
     i2 = HEAP8[i3 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i1 = i3; else {
      i5 = 0;
      while (1) {
       i6 = (i5 | 0) > 2047;
       i7 = i15 + (i5 << 2) | 0;
       L58 : while (1) {
        i4 = HEAP32[i18 + 4 + ((i2 & 255) << 2) >> 2] | 0;
        switch (i4 | 0) {
        case 4:
        case 2:
         break;
        default:
         break L58;
        }
        if (i2 << 24 >> 24 == 10) HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) {
         i11 = 64;
         break;
        }
       }
       if ((i11 | 0) == 64) {
        i11 = 0;
        i2 = 0;
        i4 = HEAP32[i8 >> 2] | 0;
       }
       if ((i4 | 0) == 3) break;
       if (i6) {
        i11 = 73;
        break L10;
       }
       HEAP32[i7 >> 2] = i3;
       i2 = HEAP8[i3 >> 0] | 0;
       if (!(i2 << 24 >> 24)) {
        i1 = i3;
        break L53;
       }
       while (1) {
        if (!(i2 << 24 >> 24 != 61 ? (HEAP32[i18 + 4 + ((i2 & 255) << 2) >> 2] | 0) != 2 : 0)) {
         i4 = i3;
         break;
        }
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) {
         i1 = i3;
         break L53;
        }
       }
       HEAP8[i4 >> 0] = 0;
       i3 = i4 + 1 | 0;
       if (i2 << 24 >> 24 != 61) {
        L74 : while (1) {
         i2 = HEAP8[i3 >> 0] | 0;
         switch (i2 << 24 >> 24) {
         case 0:
         case 61:
          break L74;
         default:
          {}
         }
         i4 = i3;
         i3 = i3 + 1 | 0;
        }
        i3 = i2 << 24 >> 24 == 61 ? i4 + 2 | 0 : i3;
       }
       i2 = HEAP8[i3 >> 0] | 0;
       if (!(i2 << 24 >> 24)) {
        i1 = i3;
        break L53;
       }
       L79 : while (1) {
        switch (HEAP32[i18 + 4 + ((i2 & 255) << 2) >> 2] | 0) {
        case 4:
        case 2:
         break;
        default:
         {
          i11 = 86;
          break L79;
         }
        }
        if (i2 << 24 >> 24 == 10) HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) {
         i2 = 0;
         i11 = 93;
         break;
        }
       }
       if ((i11 | 0) == 86) {
        i11 = 0;
        if (i2 << 24 >> 24 == 34) {
         i2 = i3 + 1 | 0;
         HEAP32[i15 + (i5 + 1 << 2) >> 2] = i2;
         i4 = i5 + 2 | 0;
         L88 : while (1) {
          switch (HEAP8[i2 >> 0] | 0) {
          case 0:
           {
            i11 = 92;
            break L10;
           }
          case 34:
           break L88;
          default:
           {}
          }
          i3 = i2;
          i2 = i2 + 1 | 0;
         }
         HEAP8[i2 >> 0] = 0;
         i3 = i3 + 2 | 0;
         i2 = HEAP8[i3 >> 0] | 0;
        } else i11 = 93;
       }
       L92 : do if ((i11 | 0) == 93) {
        i11 = 0;
        i4 = i5 + -1 | 0;
        while (1) {
         switch (i2 << 24 >> 24) {
         case 0:
         case 62:
         case 47:
          break L92;
         default:
          {}
         }
         i7 = i3 + 1 | 0;
         i2 = HEAP8[i7 >> 0] | 0;
         i3 = i7;
        }
       } while (0);
       if (!(i2 << 24 >> 24)) {
        i1 = i3;
        break L53;
       } else i5 = i4;
      }
      i4 = i3 + 1 | 0;
      if (i2 << 24 >> 24 == 63) {
       if ((HEAP8[i4 >> 0] | 0) != 62) {
        i1 = 0;
        i11 = 96;
        break L10;
       }
       i3 = i3 + 2 | 0;
      } else i3 = i4;
      i1 = __ZN12_GLOBAL__N_19MyFastXml12processCloseEcPKcPciPS2_PN5physx6shdfnd7FastXml8CallbackERb(i18, i2, i1, i3, i5, i15, i9, i17) | 0;
      if (!i1) {
       i11 = 70;
       break L10;
      }
     }
    } while (0);
   } while (0);
   if ((i11 | 0) == 35) {
    i11 = 0;
    i2 = HEAP32[i14 >> 2] | 0;
    if (HEAP8[i18 + 9261 + i2 >> 0] | 0) {
     i7 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, HEAP32[i18 + 1064 + (i2 << 2) >> 2] | 0);
     HEAP8[(HEAP32[i14 >> 2] | 0) + (i18 + 9261) >> 0] = 0;
     i2 = HEAP32[i14 >> 2] | 0;
    }
    HEAP32[i18 + 1064 + (i2 << 2) >> 2] = 0;
    i2 = HEAP32[i14 >> 2] | 0;
    if (!i2) i4 = 0; else {
     i4 = i2 + -1 | 0;
     HEAP32[i14 >> 2] = i4;
     i4 = HEAP32[i18 + 1064 + (i4 << 2) >> 2] | 0;
    }
    i2 = i1 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
    if (i3 << 24 >> 24 == 62) i2 = i4; else {
     i1 = i2;
     L113 : while (1) {
      switch (i3 << 24 >> 24) {
      case 0:
      case 62:
       break L113;
      default:
       {}
      }
      i3 = i1 + 1 | 0;
      i1 = i3;
      i3 = HEAP8[i3 >> 0] | 0;
     }
     HEAP8[i1 >> 0] = 0;
    }
    if (_strcmp(i4, i2) | 0) {
     i11 = 44;
     break;
    }
    if (!(mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0, HEAP32[i14 >> 2] | 0, i23 | 0) | 0)) {
     i11 = 46;
     break;
    }
    i1 = i1 + 1 | 0;
   }
   i2 = HEAP8[i1 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L8; else i3 = i1;
  }
  if ((i11 | 0) == 23) {
   HEAP32[i21 >> 2] = gb + 767161;
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  } else if ((i11 | 0) == 25) {
   HEAP32[i21 >> 2] = gb + 767202;
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  } else if ((i11 | 0) == 33) {
   HEAP32[i21 >> 2] = gb + 767161;
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  } else if ((i11 | 0) == 44) HEAP32[i21 >> 2] = gb + 767218; else if ((i11 | 0) == 46) {
   i19 = HEAP32[i19 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 16 >> 2] | 0, i19 | 0, i1 + 1 - (HEAP32[i22 >> 2] | 0) + (HEAP32[i20 >> 2] | 0) | 0);
  } else if ((i11 | 0) == 56) if (!(HEAP8[i16 >> 0] | 0)) {
   i1 = 1;
   i11 = 96;
  } else {
   HEAP32[i21 >> 2] = gb + 767161;
   i1 = 0;
   i11 = 96;
  } else if ((i11 | 0) == 70) if (!(HEAP8[i17 >> 0] | 0)) {
   i1 = 1;
   i11 = 96;
  } else {
   HEAP32[i21 >> 2] = gb + 767161;
   i1 = 0;
   i11 = 96;
  } else if ((i11 | 0) == 73) {
   HEAP32[i21 >> 2] = gb + 767253;
   i1 = 0;
   i11 = 96;
  } else if ((i11 | 0) == 92) {
   HEAP32[i21 >> 2] = gb + 767285;
   i1 = 0;
   i11 = 96;
  }
  if ((i11 | 0) == 96) {
   i23 = i1;
   STACKTOP = i24;
   return i23 | 0;
  }
  if (!(HEAP8[i23 >> 0] | 0)) {
   i23 = 1;
   STACKTOP = i24;
   return i23 | 0;
  }
  HEAP32[i21 >> 2] = gb + 767161;
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 } while (0);
 if (!(HEAP32[i14 >> 2] | 0)) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 }
 HEAP32[i21 >> 2] = gb + 767328;
 i23 = 0;
 STACKTOP = i24;
 return i23 | 0;
}

function __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 140 | 0;
 i13 = i23 + 80 | 0;
 i12 = i23 + 64 | 0;
 i11 = i23 + 48 | 0;
 i15 = i23 + 32 | 0;
 i14 = i23 + 16 | 0;
 i10 = i23;
 i6 = i23 + 136 | 0;
 i16 = i23 + 132 | 0;
 i7 = i23 + 128 | 0;
 i19 = i23 + 124 | 0;
 i8 = i23 + 120 | 0;
 i20 = i23 + 116 | 0;
 i9 = i23 + 112 | 0;
 i21 = i23 + 108 | 0;
 i4 = i23 + 104 | 0;
 i17 = i23 + 100 | 0;
 i5 = i23 + 96 | 0;
 i18 = i23 + 92 | 0;
 switch (i2 | 0) {
 case 0:
  {
   HEAP32[i10 >> 2] = gb + 737689;
   HEAP32[i10 + 4 >> 2] = gb + 1046296;
   HEAP32[i10 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i10) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 453327 | 0, 14);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i10) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i6 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 1:
  {
   HEAP32[i14 >> 2] = gb + 733808;
   HEAP32[i14 + 4 >> 2] = gb + 1046296;
   HEAP32[i14 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i14) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 453342 | 0, 15);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i14) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i7 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 64328 | 0) | 0;
   if (i1 | 0) {
    i21 = __Z11GetIPhysicsv() | 0;
    mftCall_viif(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, 2.0);
   }
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 2:
  {
   HEAP32[i15 >> 2] = gb + 733808;
   HEAP32[i15 + 4 >> 2] = gb + 1046296;
   HEAP32[i15 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i15) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 453310 | 0, 16);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i15) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 64328 | 0) | 0;
   if (i1 | 0) {
    i21 = __Z11GetIPhysicsv() | 0;
    mftCall_viif(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, 2.0);
   }
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 3:
  {
   HEAP32[i11 >> 2] = gb + 733457;
   HEAP32[i11 + 4 >> 2] = gb + 1046296;
   HEAP32[i11 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i11) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 453301 | 0, 8);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i11) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 32548 | 0) | 0;
   do if (i1 | 0) {
    i20 = (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0;
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
    if (i20) {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    } else {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    }
   } while (0);
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 4:
  {
   HEAP32[i12 >> 2] = gb + 737071;
   HEAP32[i12 + 4 >> 2] = gb + 1046296;
   HEAP32[i12 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i12) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 453358 | 0, 13);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i12) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i4 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 32548 | 0) | 0;
   do if (i1 | 0) {
    i21 = (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0;
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
    if (i21) {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    } else {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    }
   } while (0);
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 5:
  {
   HEAP32[i13 >> 2] = gb + 737071;
   HEAP32[i13 + 4 >> 2] = gb + 1046296;
   HEAP32[i13 + 8 >> 2] = 0;
   i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, gb + 1046285 | 0, i13) | 0;
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1046309 | 0, 8);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i13) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
   __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 32548 | 0) | 0;
   do if (i1 | 0) {
    i21 = (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0;
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
    if (i21) {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    } else {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
     break;
    }
   } while (0);
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 31312 | 0) | 0;
   i1 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
   __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i22, 0);
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 return 0;
}

function __Z17CleanupAllObjectsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 i11 = i13 + 36 | 0;
 i12 = i13 + 16 | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 12348 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 11580 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 11580 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 11580 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i11 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i10);
 i2 = i9;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28900 | 0, i11, 0);
 if (HEAP32[i6 >> 2] | 0) {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   do if (!i1) i5 = 17; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 17; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) {
      i14 = HEAP32[i1 + 8 >> 2] | 0;
      if ((i14 & 1081344 | 0) == 0 ? ((i14 >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0 : 0) {
       i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
       if (i2 | 0) if (HEAP32[i2 + 100 >> 2] | 0) break;
       __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
      }
     }
    }
   } while (0);
   if ((i5 | 0) == 17) i5 = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
  HEAP32[i11 >> 2] = 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28900 | 0, i11, 0);
 if (HEAP32[i6 >> 2] | 0) {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 30; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 30; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) {
      i14 = HEAP32[i1 + 8 >> 2] | 0;
      if ((i14 & 1048576 | 0) == 0 ? ((i14 >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0 : 0) {
       i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
       if (i2 | 0) if (!(HEAP32[i2 + 100 >> 2] | 0)) __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
      }
     }
    }
   }
   if ((i5 | 0) == 30) i5 = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i1 = __ZN13TextRendering17GetITextRenderingEv() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 if (__Z25GetRenderBufferManagerPtrv() | 0) __ZN19RenderBufferManager7CleanupEv(__Z22GetRenderBufferManagerv() | 0);
 __ZN9ShaderLab10GrabPasses29DidClearAllTempRenderTexturesEv();
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
  HEAP32[i11 >> 2] = 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28304 | 0, i11, 0);
 if (HEAP32[i6 >> 2] | 0) {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 58; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 58; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) {
      i14 = HEAP32[i1 + 8 >> 2] | 0;
      if ((i14 & 32768 | 0) == 0 ? ((i14 >>> 21) - (HEAP32[gb + 28608 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28608 + 28 >> 2] | 0) >>> 0 : 0) __Z22delete_object_internalP6Object(i1);
     }
    }
   }
   if ((i5 | 0) == 58) i5 = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 13120 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 12352 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 12352 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 12352 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
  HEAP32[i11 >> 2] = 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28304 | 0, i11, 0);
 if (!(HEAP32[i6 >> 2] | 0)) i1 = 27; else {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 68; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 68; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28608 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28608 + 28 >> 2] | 0) >>> 0) __Z22delete_object_internalP6Object(i1);
    }
   }
   if ((i5 | 0) == 68) i5 = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
  i1 = 27;
 }
 do {
  if (HEAP32[(__Z17GetManagerContextv() | 0) + (i1 << 2) >> 2] | 0) {
   i14 = __Z20GetPersistentManagerv() | 0;
   __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i14, HEAP32[(HEAP32[(__Z17GetManagerContextv() | 0) + (i1 << 2) >> 2] | 0) + 4 >> 2] | 0, 0);
   __Z22delete_object_internalP6Object(HEAP32[(__Z17GetManagerContextv() | 0) + (i1 << 2) >> 2] | 0);
   __Z22SetManagerPtrInContextiP6Object(i1, 0);
  }
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
  HEAP32[i11 >> 2] = 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28304 | 0, i11, 0);
 if (HEAP32[i6 >> 2] | 0) {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i1 = 0; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   __Z22delete_object_internalP6Object(i1);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i12 >> 2] = 0;
 i2 = i12 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i12 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i10);
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i14 = i4;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i14 + 4 >> 2] = i10;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 30792 | 0, i12, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN8Material15ClearPropertiesEv(HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i4);
  HEAP32[i12 >> 2] = 0;
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i4);
  HEAP32[i12 >> 2] = 0;
 }
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZL23ComputeBoneBindPoseAABBPK10Matrix4x4fj14StrideIteratorI8Vector3fEPK13BoneInfluencejRK13dynamic_arrayI16BlendShapeVertexLj4EEP10MinMaxAABB(i16, i10, i17, i18, i7, i19) {
 i16 = i16 | 0;
 i10 = i10 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i7 = i7 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 12 | 0;
 i14 = i20;
 i8 = i7 + 12 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  if (!i18) {
   STACKTOP = i20;
   return;
  }
  i3 = i10 + 4 | 0;
  i2 = 0;
  do {
   i4 = (HEAP32[i10 >> 2] | 0) + (Math_imul(HEAP32[i3 >> 2] | 0, i2) | 0) | 0;
   i5 = i4 + 4 | 0;
   i6 = i4 + 8 | 0;
   i1 = 0;
   do {
    if (Math_fround(HEAPF32[i17 + (i2 << 5) + (i1 << 2) >> 2]) > Math_fround(0.0)) {
     i15 = HEAP32[i17 + (i2 << 5) + 16 + (i1 << 2) >> 2] | 0;
     f26 = Math_fround(HEAPF32[i16 + (i15 << 6) >> 2]);
     f23 = Math_fround(HEAPF32[i4 >> 2]);
     f26 = Math_fround(f26 * f23);
     f24 = Math_fround(HEAPF32[i16 + (i15 << 6) + 16 >> 2]);
     f21 = Math_fround(HEAPF32[i5 >> 2]);
     f24 = Math_fround(f26 + Math_fround(f24 * f21));
     f26 = Math_fround(HEAPF32[i16 + (i15 << 6) + 32 >> 2]);
     f22 = Math_fround(HEAPF32[i6 >> 2]);
     f26 = Math_fround(f24 + Math_fround(f26 * f22));
     f26 = Math_fround(Math_fround(HEAPF32[i16 + (i15 << 6) + 48 >> 2]) + f26);
     f24 = Math_fround(f23 * Math_fround(HEAPF32[i16 + (i15 << 6) + 4 >> 2]));
     f24 = Math_fround(f24 + Math_fround(f21 * Math_fround(HEAPF32[i16 + (i15 << 6) + 20 >> 2])));
     f24 = Math_fround(f24 + Math_fround(f22 * Math_fround(HEAPF32[i16 + (i15 << 6) + 36 >> 2])));
     f24 = Math_fround(Math_fround(HEAPF32[i16 + (i15 << 6) + 52 >> 2]) + f24);
     f23 = Math_fround(f23 * Math_fround(HEAPF32[i16 + (i15 << 6) + 8 >> 2]));
     f21 = Math_fround(f23 + Math_fround(f21 * Math_fround(HEAPF32[i16 + (i15 << 6) + 24 >> 2])));
     f22 = Math_fround(f21 + Math_fround(f22 * Math_fround(HEAPF32[i16 + (i15 << 6) + 40 >> 2])));
     f22 = Math_fround(Math_fround(HEAPF32[i16 + (i15 << 6) + 56 >> 2]) + f22);
     i12 = i19 + (i15 * 24 | 0) | 0;
     f21 = Math_fround(HEAPF32[i12 >> 2]);
     i14 = i19 + (i15 * 24 | 0) + 4 | 0;
     f23 = Math_fround(HEAPF32[i14 >> 2]);
     i13 = i19 + (i15 * 24 | 0) + 8 | 0;
     f25 = Math_fround(HEAPF32[i13 >> 2]);
     HEAPF32[i12 >> 2] = f26 < f21 ? f26 : f21;
     HEAPF32[i14 >> 2] = f24 < f23 ? f24 : f23;
     HEAPF32[i13 >> 2] = f22 < f25 ? f22 : f25;
     i13 = i19 + (i15 * 24 | 0) + 12 | 0;
     f25 = Math_fround(HEAPF32[i13 >> 2]);
     i14 = i19 + (i15 * 24 | 0) + 16 | 0;
     f23 = Math_fround(HEAPF32[i14 >> 2]);
     i15 = i19 + (i15 * 24 | 0) + 20 | 0;
     f21 = Math_fround(HEAPF32[i15 >> 2]);
     HEAPF32[i13 >> 2] = f25 < f26 ? f26 : f25;
     HEAPF32[i14 >> 2] = f23 < f24 ? f24 : f23;
     HEAPF32[i15 >> 2] = f21 < f22 ? f22 : f21;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
  STACKTOP = i20;
  return;
 }
 HEAP32[i13 >> 2] = 0;
 i15 = i13 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i15;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i18 * 12 | 0;
 i5 = (i6 | 0) != 0;
 do if (i5) {
  i1 = i6 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = i4;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 425656 | 0, 1917) | 0;
   i3 = gb + 64016 | 0;
   i12 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i2;
   i1 = i15;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = gb + 63160 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } else {
  i2 = 0;
  i1 = i4;
 } while (0);
 i11 = i2 + 3 & -4;
 HEAP32[i14 >> 2] = 0;
 i12 = i14 + 4 | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 4 >> 2] = i1;
 do if (i5) {
  i2 = i6 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 425656 | 0, 1919) | 0;
   i6 = gb + 64016 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i1;
   i9 = i12;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i9 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i9 = i1 + 3 & -4;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = i10 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = i1;
 i3 = Math_imul(i5, i18) | 0;
 i4 = i2 + i3 | 0;
 if (!i3) i4 = i5; else {
  i3 = i11;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i2 = i1 + i5 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else {
    i3 = i3 + 12 | 0;
    i1 = i2;
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i1;
 i3 = Math_imul(i4, i18) | 0;
 i5 = i2 + i3 | 0;
 if (i3 | 0) {
  i3 = i9;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i2 = i1 + i4 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else {
    i3 = i3 + 12 | 0;
    i1 = i2;
   }
  }
 }
 if (HEAP32[i8 >> 2] | 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   i10 = HEAP32[i4 + (i1 * 40 | 0) + 36 >> 2] | 0;
   i5 = i3 + (Math_imul(i2, i10) | 0) | 0;
   f21 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) >> 2]);
   f21 = Math_fround(f21 + Math_fround(HEAPF32[i5 >> 2]));
   f23 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 4 >> 2]);
   f23 = Math_fround(f23 + Math_fround(HEAPF32[i5 + 4 >> 2]));
   f25 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 8 >> 2]);
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i5 + 8 >> 2]));
   i5 = i9 + (i10 * 12 | 0) | 0;
   f26 = Math_fround(HEAPF32[i5 >> 2]);
   i7 = i9 + (i10 * 12 | 0) + 4 | 0;
   f24 = Math_fround(HEAPF32[i7 >> 2]);
   i6 = i9 + (i10 * 12 | 0) + 8 | 0;
   f22 = Math_fround(HEAPF32[i6 >> 2]);
   HEAPF32[i5 >> 2] = f26 < f21 ? f21 : f26;
   HEAPF32[i7 >> 2] = f24 < f23 ? f23 : f24;
   HEAPF32[i6 >> 2] = f22 < f25 ? f25 : f22;
   i6 = i11 + (i10 * 12 | 0) | 0;
   f22 = Math_fround(HEAPF32[i6 >> 2]);
   i7 = i11 + (i10 * 12 | 0) + 4 | 0;
   f24 = Math_fround(HEAPF32[i7 >> 2]);
   i10 = i11 + (i10 * 12 | 0) + 8 | 0;
   f26 = Math_fround(HEAPF32[i10 >> 2]);
   HEAPF32[i6 >> 2] = f21 < f22 ? f21 : f22;
   HEAPF32[i7 >> 2] = f23 < f24 ? f23 : f24;
   HEAPF32[i10 >> 2] = f25 < f26 ? f25 : f26;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 if (i18 | 0) {
  i2 = 0;
  do {
   i3 = i11 + (i2 * 12 | 0) | 0;
   i4 = i11 + (i2 * 12 | 0) + 4 | 0;
   i5 = i11 + (i2 * 12 | 0) + 8 | 0;
   i6 = i9 + (i2 * 12 | 0) | 0;
   i7 = i9 + (i2 * 12 | 0) + 4 | 0;
   i8 = i9 + (i2 * 12 | 0) + 8 | 0;
   i1 = 0;
   do {
    if (Math_fround(HEAPF32[i17 + (i2 << 5) + (i1 << 2) >> 2]) > Math_fround(0.0)) {
     i10 = HEAP32[i17 + (i2 << 5) + 16 + (i1 << 2) >> 2] | 0;
     i48 = i16 + (i10 << 6) | 0;
     f24 = Math_fround(HEAPF32[i48 >> 2]);
     f32 = Math_fround(HEAPF32[i3 >> 2]);
     f24 = Math_fround(f24 * f32);
     i47 = i16 + (i10 << 6) + 16 | 0;
     f26 = Math_fround(HEAPF32[i47 >> 2]);
     f34 = Math_fround(HEAPF32[i4 >> 2]);
     f26 = Math_fround(f24 + Math_fround(f26 * f34));
     i46 = i16 + (i10 << 6) + 32 | 0;
     f24 = Math_fround(HEAPF32[i46 >> 2]);
     f21 = Math_fround(HEAPF32[i5 >> 2]);
     f24 = Math_fround(f26 + Math_fround(f24 * f21));
     i45 = i16 + (i10 << 6) + 48 | 0;
     f24 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) + f24);
     i44 = i16 + (i10 << 6) + 4 | 0;
     f26 = Math_fround(f32 * Math_fround(HEAPF32[i44 >> 2]));
     i43 = i16 + (i10 << 6) + 20 | 0;
     f26 = Math_fround(f26 + Math_fround(f34 * Math_fround(HEAPF32[i43 >> 2])));
     i42 = i16 + (i10 << 6) + 36 | 0;
     f26 = Math_fround(f26 + Math_fround(f21 * Math_fround(HEAPF32[i42 >> 2])));
     i41 = i16 + (i10 << 6) + 52 | 0;
     f26 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f26);
     i40 = i16 + (i10 << 6) + 8 | 0;
     f32 = Math_fround(f32 * Math_fround(HEAPF32[i40 >> 2]));
     i38 = i16 + (i10 << 6) + 24 | 0;
     f34 = Math_fround(f32 + Math_fround(f34 * Math_fround(HEAPF32[i38 >> 2])));
     i36 = i16 + (i10 << 6) + 40 | 0;
     f21 = Math_fround(f34 + Math_fround(f21 * Math_fround(HEAPF32[i36 >> 2])));
     i35 = i16 + (i10 << 6) + 56 | 0;
     f21 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) + f21);
     i33 = i19 + (i10 * 24 | 0) | 0;
     f34 = Math_fround(HEAPF32[i33 >> 2]);
     f34 = f24 < f34 ? f24 : f34;
     i31 = i19 + (i10 * 24 | 0) + 4 | 0;
     f32 = Math_fround(HEAPF32[i31 >> 2]);
     f32 = f26 < f32 ? f26 : f32;
     i29 = i19 + (i10 * 24 | 0) + 8 | 0;
     f30 = Math_fround(HEAPF32[i29 >> 2]);
     f30 = f21 < f30 ? f21 : f30;
     HEAPF32[i33 >> 2] = f34;
     HEAPF32[i31 >> 2] = f32;
     HEAPF32[i29 >> 2] = f30;
     i28 = i19 + (i10 * 24 | 0) + 12 | 0;
     f22 = Math_fround(HEAPF32[i28 >> 2]);
     f22 = f22 < f24 ? f24 : f22;
     i27 = i19 + (i10 * 24 | 0) + 16 | 0;
     f24 = Math_fround(HEAPF32[i27 >> 2]);
     f24 = f24 < f26 ? f26 : f24;
     i10 = i19 + (i10 * 24 | 0) + 20 | 0;
     f26 = Math_fround(HEAPF32[i10 >> 2]);
     f26 = f26 < f21 ? f21 : f26;
     HEAPF32[i28 >> 2] = f22;
     HEAPF32[i27 >> 2] = f24;
     HEAPF32[i10 >> 2] = f26;
     f21 = Math_fround(HEAPF32[i48 >> 2]);
     f39 = Math_fround(HEAPF32[i6 >> 2]);
     f21 = Math_fround(f21 * f39);
     f23 = Math_fround(HEAPF32[i47 >> 2]);
     f37 = Math_fround(HEAPF32[i7 >> 2]);
     f23 = Math_fround(f21 + Math_fround(f23 * f37));
     f21 = Math_fround(HEAPF32[i46 >> 2]);
     f25 = Math_fround(HEAPF32[i8 >> 2]);
     f21 = Math_fround(f23 + Math_fround(f21 * f25));
     f21 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) + f21);
     f23 = Math_fround(f39 * Math_fround(HEAPF32[i44 >> 2]));
     f23 = Math_fround(f23 + Math_fround(f37 * Math_fround(HEAPF32[i43 >> 2])));
     f23 = Math_fround(f23 + Math_fround(f25 * Math_fround(HEAPF32[i42 >> 2])));
     f23 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f23);
     f39 = Math_fround(f39 * Math_fround(HEAPF32[i40 >> 2]));
     f37 = Math_fround(f39 + Math_fround(f37 * Math_fround(HEAPF32[i38 >> 2])));
     f25 = Math_fround(f37 + Math_fround(f25 * Math_fround(HEAPF32[i36 >> 2])));
     f25 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) + f25);
     HEAPF32[i33 >> 2] = f21 < f34 ? f21 : f34;
     HEAPF32[i31 >> 2] = f23 < f32 ? f23 : f32;
     HEAPF32[i29 >> 2] = f25 < f30 ? f25 : f30;
     HEAPF32[i28 >> 2] = f22 < f21 ? f21 : f22;
     HEAPF32[i27 >> 2] = f24 < f23 ? f23 : f24;
     HEAPF32[i10 >> 2] = f26 < f25 ? f25 : f26;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i12);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i15);
 STACKTOP = i20;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i16, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i15 = i16 + 4 | 0;
 i17 = HEAP32[i15 >> 2] | 0;
 i4 = i1;
 i13 = (HEAP8[i4 >> 0] | 0) == 45;
 i1 = i13 ? i4 + 1 | 0 : i1;
 i4 = i1;
 i3 = HEAP8[i4 >> 0] | 0;
 L1 : do if (i3 << 24 >> 24 == 48) {
  i6 = 0;
  i10 = 0;
  d2 = 0.0;
  i12 = 0;
  i1 = i4 + 1 | 0;
  i8 = 0;
  i7 = 0;
 } else {
  if ((i3 + -49 & 255) >= 9) {
   HEAP32[i11 + 24 >> 2] = 3;
   HEAP32[i11 + 28 >> 2] = i1 - i17;
   i14 = i1;
   HEAP32[i16 >> 2] = i14;
   HEAP32[i15 >> 2] = i17;
   return;
  }
  i6 = i4 + 1 | 0;
  i1 = i6;
  i5 = (i3 << 24 >> 24) + -48 | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  i3 = (i4 + -48 & 255) < 10;
  L8 : do if (i13) {
   if (i3) i3 = i6; else {
    i6 = 0;
    i10 = 0;
    d2 = 0.0;
    i12 = i5;
    i8 = 0;
    i7 = 0;
    break L1;
   }
   while (1) {
    if (i5 >>> 0 > 214748363) {
     if ((i5 | 0) != 214748364) break L8;
     if (i4 << 24 >> 24 > 56) {
      i5 = 214748364;
      break L8;
     }
    }
    i3 = i3 + 1 | 0;
    i1 = i3;
    i5 = (i5 * 10 | 0) + -48 + (i4 << 24 >> 24) | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i6 = 0;
     i10 = 0;
     d2 = 0.0;
     i12 = i5;
     i8 = 0;
     i7 = 0;
     break L1;
    }
   }
  } else {
   if (i3) i3 = i6; else {
    i6 = 0;
    i10 = 0;
    d2 = 0.0;
    i12 = i5;
    i8 = 0;
    i7 = 0;
    break L1;
   }
   while (1) {
    if (i5 >>> 0 > 429496728) {
     if ((i5 | 0) != 429496729) break L8;
     if (i4 << 24 >> 24 > 53) {
      i5 = 429496729;
      break L8;
     }
    }
    i3 = i3 + 1 | 0;
    i1 = i3;
    i5 = (i5 * 10 | 0) + -48 + (i4 << 24 >> 24) | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i6 = 0;
     i10 = 0;
     d2 = 0.0;
     i12 = i5;
     i8 = 0;
     i7 = 0;
     break L1;
    }
   }
  } while (0);
  i4 = i1;
  i6 = HEAP8[i4 >> 0] | 0;
  i3 = (i6 + -48 & 255) < 10;
  L24 : do if (i13) {
   if (i3) {
    i7 = 0;
    i3 = i5;
   } else {
    i6 = 0;
    i10 = 1;
    d2 = 0.0;
    i12 = i5;
    i8 = i5;
    i7 = 0;
    break L1;
   }
   while (1) {
    if (i7 >>> 0 > 214748364 | (i7 | 0) == 214748364 & i3 >>> 0 > 3435973835) if ((i3 | 0) != -858993460 | (i7 | 0) != 214748364 | i6 << 24 >> 24 > 56) {
     i8 = i3;
     break L24;
    }
    i3 = ___muldi3(i3 | 0, i7 | 0, 10, 0) | 0;
    i4 = i4 + 1 | 0;
    i1 = i4;
    i3 = _i64Add((i6 << 24 >> 24) + -48 | 0, 0, i3 | 0, getTempRet0() | 0) | 0;
    i7 = getTempRet0() | 0;
    i6 = HEAP8[i4 >> 0] | 0;
    if ((i6 + -48 & 255) >= 10) {
     i6 = 0;
     i10 = 1;
     d2 = 0.0;
     i12 = i5;
     i8 = i3;
     break L1;
    }
   }
  } else {
   if (i3) {
    i7 = 0;
    i3 = i5;
   } else {
    i6 = 0;
    i10 = 1;
    d2 = 0.0;
    i12 = i5;
    i8 = i5;
    i7 = 0;
    break L1;
   }
   while (1) {
    if (i7 >>> 0 > 429496729 | (i7 | 0) == 429496729 & i3 >>> 0 > 2576980376) if ((i3 | 0) != -1717986919 | (i7 | 0) != 429496729 | i6 << 24 >> 24 > 53) {
     i8 = i3;
     break L24;
    }
    i3 = ___muldi3(i3 | 0, i7 | 0, 10, 0) | 0;
    i4 = i4 + 1 | 0;
    i1 = i4;
    i3 = _i64Add((i6 << 24 >> 24) + -48 | 0, 0, i3 | 0, getTempRet0() | 0) | 0;
    i7 = getTempRet0() | 0;
    i6 = HEAP8[i4 >> 0] | 0;
    if ((i6 + -48 & 255) >= 10) {
     i6 = 0;
     i10 = 1;
     d2 = 0.0;
     i12 = i5;
     i8 = i3;
     break L1;
    }
   }
  } while (0);
  d2 = +(i8 >>> 0) + 4294967296.0 * +(i7 >>> 0);
  i3 = i1;
  i4 = HEAP8[i3 >> 0] | 0;
  if ((i4 + -48 & 255) < 10) {
   while (1) {
    if (d2 >= 1797693134862315758041281.0e283) break;
    i3 = i3 + 1 | 0;
    i1 = i3;
    d2 = d2 * 10.0 + +((i4 << 24 >> 24) + -48 | 0);
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) {
     i6 = 1;
     i10 = 1;
     i12 = i5;
     break L1;
    }
   }
   HEAP32[i11 + 24 >> 2] = 13;
   HEAP32[i11 + 28 >> 2] = i1 - i17;
   i14 = i1;
   HEAP32[i16 >> 2] = i14;
   HEAP32[i15 >> 2] = i17;
   return;
  } else {
   i6 = 1;
   i10 = 1;
   i12 = i5;
  }
 } while (0);
 i3 = i1;
 i4 = HEAP8[i3 >> 0] | 0;
 do if (i4 << 24 >> 24 == 46) {
  i1 = i3 + 1 | 0;
  if (!i6) d2 = i10 ? +(i8 >>> 0) + 4294967296.0 * +(i7 >>> 0) : +(i12 >>> 0);
  i3 = HEAP8[i1 >> 0] | 0;
  if ((i3 + -48 & 255) < 10) {
   i4 = 0;
   i5 = i1;
   i1 = i3;
   do {
    i5 = i5 + 1 | 0;
    d2 = d2 * 10.0 + +((i1 << 24 >> 24) + -48 | 0);
    i4 = i4 + -1 | 0;
    i1 = HEAP8[i5 >> 0] | 0;
   } while ((i1 + -48 & 255) < 10);
   i1 = i5;
   if (i4) {
    i9 = i4;
    i6 = 1;
    i3 = HEAP8[i5 >> 0] | 0;
    break;
   }
  }
  HEAP32[i11 + 24 >> 2] = 14;
  HEAP32[i11 + 28 >> 2] = i1 - i17;
  i14 = i1;
  HEAP32[i16 >> 2] = i14;
  HEAP32[i15 >> 2] = i17;
  return;
 } else {
  i9 = 0;
  i3 = i4;
 } while (0);
 i4 = i1;
 switch (i3 << 24 >> 24) {
 case 69:
 case 101:
  {
   if (!i6) d2 = i10 ? +(i8 >>> 0) + 4294967296.0 * +(i7 >>> 0) : +(i12 >>> 0);
   i1 = i4 + 1 | 0;
   switch (HEAP8[i1 >> 0] | 0) {
   case 43:
    {
     i6 = 0;
     i1 = i4 + 2 | 0;
     break;
    }
   case 45:
    {
     i6 = 1;
     i1 = i4 + 2 | 0;
     break;
    }
   default:
    i6 = 0;
   }
   i3 = i1;
   i4 = HEAP8[i1 >> 0] | 0;
   if ((i4 + -48 & 255) >= 10) {
    HEAP32[i11 + 24 >> 2] = 15;
    HEAP32[i11 + 28 >> 2] = i3 - i17;
    i14 = i3;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i15 >> 2] = i17;
    return;
   }
   i5 = i1 + 1 | 0;
   i1 = i5;
   i4 = (i4 << 24 >> 24) + -48 | 0;
   L114 : do if (i6) {
    i3 = HEAP8[i5 >> 0] | 0;
    if ((i3 + -48 & 255) < 10) {
     i1 = i5;
     do {
      i1 = i1 + 1 | 0;
      i4 = (i4 * 10 | 0) + -48 + (i3 << 24 >> 24) | 0;
      i3 = HEAP8[i1 >> 0] | 0;
     } while ((i3 + -48 & 255) < 10);
     i3 = i4;
    } else i3 = i4;
   } else {
    i3 = i4;
    do {
     i4 = i1;
     i5 = HEAP8[i4 >> 0] | 0;
     if ((i5 + -48 & 255) >= 10) break L114;
     i1 = i4 + 1 | 0;
     i3 = (i3 * 10 | 0) + -48 + (i5 << 24 >> 24) | 0;
    } while ((i3 | 0) < 309);
    HEAP32[i11 + 24 >> 2] = 13;
    HEAP32[i11 + 28 >> 2] = i1 - i17;
    i14 = i1;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i15 >> 2] = i17;
    return;
   } while (0);
   i4 = i6 ? 0 - i3 | 0 : i3;
   break;
  }
 default:
  if (i6) i4 = 0; else {
   if (i10) {
    if (i13) {
     i13 = _i64Subtract(0, 0, i8 | 0, i7 | 0) | 0;
     if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E5Int64Ex(i14, i13, getTempRet0() | 0) | 0) {
      i14 = i1;
      HEAP32[i16 >> 2] = i14;
      HEAP32[i15 >> 2] = i17;
      return;
     }
    } else if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6Uint64Ey(i14, i8, i7) | 0) {
     i14 = i1;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i15 >> 2] = i17;
     return;
    }
    HEAP32[i11 + 24 >> 2] = 16;
    HEAP32[i11 + 28 >> 2] = i1 - i17;
    i14 = i1;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i15 >> 2] = i17;
    return;
   }
   if (i13) {
    i11 = 0 - i12 | 0;
    i3 = i14 + 28 | 0;
    i10 = i14 + 40 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i8 = i14 + 44 | 0;
    i13 = HEAP32[i8 >> 2] | 0;
    i5 = i13;
    i9 = i4;
    if ((i4 + 24 | 0) >>> 0 >= i13 >>> 0) {
     i4 = i14 + 36 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i6;
     if (!i6) {
      if (!(HEAP32[i3 >> 2] | 0)) {
       i13 = __Znwj(1) | 0;
       HEAP32[i3 >> 2] = i13;
       HEAP32[i14 + 32 >> 2] = i13;
      }
      i3 = HEAP32[i14 + 48 >> 2] | 0;
     } else {
      i3 = i5 - i7 | 0;
      i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
     }
     i9 = i9 - i7 | 0;
     i14 = i9 + 24 | 0;
     i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
     i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i13;
     i4 = i13 + i9 | 0;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i8 >> 2] = i13 + i14;
    }
    HEAP32[i10 >> 2] = i4 + 24;
    i3 = i4 + 8 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    i3 = i4 + 16 | 0;
    HEAP32[i3 >> 2] = 5638;
    i14 = i4;
    HEAP32[i14 >> 2] = i11;
    HEAP32[i14 + 4 >> 2] = ((i11 | 0) < 0) << 31 >> 31;
    if ((i12 | 0) >= 1) {
     i14 = i1;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i15 >> 2] = i17;
     return;
    }
    HEAP32[i3 >> 2] = 15878;
    i14 = i1;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i15 >> 2] = i17;
    return;
   } else {
    i3 = i14 + 28 | 0;
    i10 = i14 + 40 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i8 = i14 + 44 | 0;
    i13 = HEAP32[i8 >> 2] | 0;
    i5 = i13;
    i9 = i4;
    if ((i4 + 24 | 0) >>> 0 >= i13 >>> 0) {
     i4 = i14 + 36 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i6;
     if (!i6) {
      if (!(HEAP32[i3 >> 2] | 0)) {
       i13 = __Znwj(1) | 0;
       HEAP32[i3 >> 2] = i13;
       HEAP32[i14 + 32 >> 2] = i13;
      }
      i3 = HEAP32[i14 + 48 >> 2] | 0;
     } else {
      i3 = i5 - i7 | 0;
      i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
     }
     i11 = i9 - i7 | 0;
     i14 = i11 + 24 | 0;
     i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
     i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i13;
     i4 = i13 + i11 | 0;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i8 >> 2] = i13 + i14;
    }
    HEAP32[i10 >> 2] = i4 + 24;
    i3 = i4 + 8 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    i3 = i4 + 16 | 0;
    HEAP32[i3 >> 2] = 14854;
    i14 = i4;
    HEAP32[i14 >> 2] = i12;
    HEAP32[i14 + 4 >> 2] = 0;
    if ((i12 | 0) < 0) {
     i14 = i1;
     HEAP32[i16 >> 2] = i14;
     HEAP32[i15 >> 2] = i17;
     return;
    }
    HEAP32[i3 >> 2] = 15878;
    i14 = i1;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i15 >> 2] = i17;
    return;
   }
  }
 }
 i3 = i4 + i9 | 0;
 do if ((i3 | 0) < -308) {
  do if ((i4 | 0) < -308) d2 = 0.0; else if ((i4 | 0) > -1) {
   d2 = d2 * +HEAPF64[gb + 416 + (i4 << 3) >> 3];
   break;
  } else {
   d2 = d2 / +HEAPF64[gb + 416 + (0 - i4 << 3) >> 3];
   break;
  } while (0);
  if ((i9 | 0) < -308) d2 = 0.0; else if ((i9 | 0) > -1) {
   d2 = d2 * +HEAPF64[gb + 416 + (i9 << 3) >> 3];
   break;
  } else {
   d2 = d2 / +HEAPF64[gb + 416 + (0 - i9 << 3) >> 3];
   break;
  }
 } else if ((i3 | 0) > -1) {
  d2 = d2 * +HEAPF64[gb + 416 + (i3 << 3) >> 3];
  break;
 } else {
  d2 = d2 / +HEAPF64[gb + 416 + (0 - i3 << 3) >> 3];
  break;
 } while (0);
 d2 = i13 ? -d2 : d2;
 i4 = i14 + 28 | 0;
 i11 = i14 + 40 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i9 = i14 + 44 | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 i5 = i13;
 i10 = i3;
 if ((i3 + 24 | 0) >>> 0 >= i13 >>> 0) {
  i6 = i14 + 36 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7;
  if (!i7) {
   if (!(HEAP32[i4 >> 2] | 0)) {
    i13 = __Znwj(1) | 0;
    HEAP32[i4 >> 2] = i13;
    HEAP32[i14 + 32 >> 2] = i13;
   }
   i3 = HEAP32[i14 + 48 >> 2] | 0;
  } else {
   i3 = i5 - i8 | 0;
   i3 = ((i3 + 1 | 0) >>> 1) + i3 | 0;
  }
  i12 = i10 - i8 | 0;
  i14 = i12 + 24 | 0;
  i14 = i3 >>> 0 < i14 >>> 0 ? i14 : i3;
  i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i14, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i6 >> 2] = i13;
  i3 = i13 + i12 | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i9 >> 2] = i13 + i14;
 }
 HEAP32[i11 >> 2] = i3 + 24;
 i14 = i3 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 16902;
 HEAPF64[i3 >> 3] = d2;
 i14 = i1;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i15 >> 2] = i17;
 return;
}

function __ZN19CollisionListener2D16ReportCollisionsEv(i35) {
 i35 = i35 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i36 + 8 | 0;
 i33 = i36;
 if ((HEAP16[gb + 1458064 + 6 >> 1] | 0) > -1) {
  HEAP32[i33 >> 2] = 0;
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458064 | 0, i32);
  i34 = gb + 1458064 | 0;
 } else i34 = 0;
 i26 = i35 + 176 | 0;
 i10 = HEAP32[i26 >> 2] | 0;
 i27 = i35 + 180 | 0;
 i9 = HEAP32[i27 >> 2] | 0;
 i28 = i10 + (i9 * 80 | 0) | 0;
 L4 : do if (!i9) {
  i1 = i10;
  i29 = 12;
 } else {
  i2 = HEAP32[i35 + 96 >> 2] | 0;
  i3 = i35 + 100 | 0;
  i4 = i35 + 8 | 0;
  i5 = i35 + 16 | 0;
  i6 = i35 + 20 | 0;
  i7 = i35 + 12 | 0;
  i1 = i10;
  while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i8 | 0)) {
    if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i29 = 7;
   } else i29 = 7;
   if ((i29 | 0) == 7) {
    i29 = 0;
    if (!(HEAP8[i7 >> 0] | 0)) {
     i29 = 12;
     break L4;
    }
    if (!(HEAP32[i4 >> 2] | 0)) {
     i29 = 12;
     break L4;
    }
    if ((HEAP32[i5 >> 2] | 0) != (i8 | 0)) {
     i29 = 12;
     break L4;
    }
    if ((HEAP32[i6 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i29 = 12;
     break L4;
    }
   }
   i1 = i1 + 80 | 0;
   if ((i1 | 0) == (i28 | 0)) {
    i29 = 13;
    break;
   }
  }
 } while (0);
 L16 : do if ((i29 | 0) == 12) if ((i1 | 0) == (i28 | 0)) i29 = 13; else {
  i31 = i35 + 204 | 0;
  i11 = i35 + 12 | 0;
  i12 = i35 + 16 | 0;
  i13 = i35 + 24 | 0;
  i14 = i35 + 80 | 0;
  i15 = i35 + 84 | 0;
  i16 = i35 + 88 | 0;
  i17 = i35 + 8 | 0;
  i18 = i35 + 196 | 0;
  i19 = i35 + 16 | 0;
  i20 = i35 + 20 | 0;
  i21 = i32 + 56 | 0;
  i22 = i32 + 60 | 0;
  i23 = i32 + 64 | 0;
  i24 = i35 + 96 | 0;
  i25 = i35 + 100 | 0;
  i3 = i9;
  i6 = i10;
  while (1) {
   i2 = i1 + 80 | 0;
   L21 : do if ((i2 | 0) == (i28 | 0)) i2 = i28; else {
    i5 = HEAP32[i24 >> 2] | 0;
    while (1) {
     i4 = HEAP32[i2 >> 2] | 0;
     if ((i5 | 0) == (i4 | 0)) {
      if ((HEAP32[i25 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) i29 = 21;
     } else i29 = 21;
     if ((i29 | 0) == 21) {
      i29 = 0;
      if (!(HEAP8[i11 >> 0] | 0)) break L21;
      if (!(HEAP32[i17 >> 2] | 0)) break L21;
      if ((HEAP32[i19 >> 2] | 0) != (i4 | 0)) break L21;
      if ((HEAP32[i20 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) break L21;
     }
     i2 = i2 + 80 | 0;
     if ((i2 | 0) == (i28 | 0)) {
      i2 = i28;
      break;
     }
    }
   } while (0);
   i7 = i1 + 8 | 0;
   i8 = i1 + 72 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   switch (i4 | 0) {
   case 5:
    {
     HEAP32[i8 >> 2] = 2;
     i29 = 29;
     break;
    }
   case 0:
    {
     i4 = i6;
     i29 = 30;
     break;
    }
   case 3:
    {
     i4 = i32;
     i5 = i7;
     i6 = i4 + 56 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     HEAP32[i21 >> 2] = HEAP32[i1 + 64 >> 2];
     HEAP32[i22 >> 2] = HEAP32[i1 + 68 >> 2];
     i10 = i8;
     i30 = HEAP32[i10 + 4 >> 2] | 0;
     i29 = i23;
     HEAP32[i29 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i29 + 4 >> 2] = i30;
     HEAP32[i23 >> 2] = 1;
     __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_(i31, i32);
     HEAP32[i8 >> 2] = 2;
     i29 = 29;
     break;
    }
   case 2:
    {
     i29 = 29;
     break;
    }
   default:
    {
     HEAP8[i1 + 78 >> 0] = 1;
     do if ((i4 | 0) == 4) {
      i3 = HEAP32[i7 >> 2] | 0;
      i1 = HEAP32[i1 + 12 >> 2] | 0;
      if (i3 | 0) if (!(__ZNK11Rigidbody2D10IsSleepingEv(i3) | 0)) {
       i29 = 43;
       break;
      }
      if (i1 | 0) if (!(__ZNK11Rigidbody2D10IsSleepingEv(i1) | 0)) i29 = 43;
     } else i29 = 43; while (0);
     if ((i29 | 0) == 43) {
      i29 = 0;
      __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_(i31, i7);
     }
     HEAP32[i8 >> 2] = 4;
    }
   }
   if ((i29 | 0) == 29) {
    __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_(i31, i7);
    i4 = HEAP32[i26 >> 2] | 0;
    i3 = HEAP32[i27 >> 2] | 0;
    i29 = 30;
   }
   if ((i29 | 0) == 30) {
    i29 = 0;
    if ((i1 | 0) != (i4 + (i3 * 80 | 0) | 0)) {
     if (!(HEAP8[i11 >> 0] | 0)) i3 = 1; else if (!(HEAP32[i17 >> 2] | 0)) i3 = 1; else if ((HEAP32[i19 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) i3 = (HEAP32[i20 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0); else i3 = 1;
     i6 = i12;
     i5 = HEAP32[i6 + 4 >> 2] | 0;
     i4 = i1;
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i4 + 4 >> 2] = i5;
     i4 = i7;
     i5 = i13;
     i6 = i4 + 56 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     HEAP32[i1 + 64 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i1 + 68 >> 2] = HEAP32[i15 >> 2];
     i9 = i16;
     i10 = HEAP32[i9 + 4 >> 2] | 0;
     i30 = i8;
     HEAP32[i30 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i30 + 4 >> 2] = i10;
     if (i3) {
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
      HEAP8[i18 >> 0] = 1;
     }
    }
   }
   i6 = HEAP32[i26 >> 2] | 0;
   i3 = HEAP32[i27 >> 2] | 0;
   if ((i2 | 0) == (i6 + (i3 * 80 | 0) | 0)) break L16; else i1 = i2;
  }
 } while (0);
 if ((i29 | 0) == 13) i31 = i35 + 204 | 0;
 i29 = i35 + 204 | 0;
 i30 = i35 + 216 | 0;
 if (HEAP32[i30 >> 2] | 0) {
  i13 = i32 + 8 | 0;
  i14 = i32 + 4 | 0;
  i15 = i32 + 8 | 0;
  i16 = i32 + 4 | 0;
  i17 = i32 + 8 | 0;
  i18 = i32 + 4 | 0;
  i19 = i32 + 8 | 0;
  i20 = i32 + 4 | 0;
  i21 = i32 + 8 | 0;
  i22 = i32 + 4 | 0;
  i23 = i32 + 8 | 0;
  i24 = i32 + 4 | 0;
  i25 = i32 + 8 | 0;
  i26 = i32 + 4 | 0;
  i27 = i32 + 8 | 0;
  i28 = i32 + 4 | 0;
  i8 = HEAP32[i29 >> 2] | 0;
  do {
   i9 = i8 + 64 | 0;
   i4 = i8 + 8 | 0;
   i5 = i8 + 12 | 0;
   i10 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i11 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i12 = (i10 | 0) != 0;
   if (i12) i1 = (HEAP32[i10 + 28 >> 2] | 0) == (HEAP32[i1 + 28 >> 2] | 0) ? 0 : i1;
   i7 = (i11 | 0) != 0;
   if (i7) i6 = (HEAP32[i11 + 28 >> 2] | 0) == (HEAP32[i2 + 28 >> 2] | 0) ? 0 : i2; else i6 = i2;
   L72 : do if (!(HEAP8[i8 + 69 >> 0] | 0)) {
    if ((HEAP16[gb + 1458088 + 6 >> 1] | 0) > -1) {
     HEAP32[i33 >> 2] = 0;
     HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458088 | 0, i32);
     i2 = gb + 1458088 | 0;
    } else i2 = 0;
    i4 = HEAP32[i9 >> 2] | 0;
    i4 = (i4 | 0) == 1 ? gb + 1104856 | 0 : (i4 | 0) == 2 ? gb + 1104876 | 0 : gb + 1104896 | 0;
    i3 = i8 + 68 | 0;
    HEAP8[i3 >> 0] = 1;
    if (i12) {
     HEAP32[i32 >> 2] = gb + 29552;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i14 >> 2] = i8;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i10, i4, i32);
    }
    L80 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L80;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    if (i1 | 0) {
     HEAP32[i32 >> 2] = gb + 29552;
     HEAP32[i19 >> 2] = 0;
     HEAP32[i20 >> 2] = i8;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i4, i32);
    }
    L88 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L88;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    HEAP8[i3 >> 0] = 0;
    if (i7) {
     HEAP32[i32 >> 2] = gb + 29552;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i16 >> 2] = i8;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i11, i4, i32);
    }
    L96 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L96;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    if (i6 | 0) {
     HEAP32[i32 >> 2] = gb + 29552;
     HEAP32[i17 >> 2] = 0;
     HEAP32[i18 >> 2] = i8;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i6, i4, i32);
    }
    if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
   } else {
    if ((HEAP16[gb + 1458076 + 6 >> 1] | 0) > -1) {
     HEAP32[i33 >> 2] = 0;
     HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458076 | 0, i32);
     i2 = gb + 1458076 | 0;
    } else i2 = 0;
    i3 = HEAP32[i9 >> 2] | 0;
    i3 = (i3 | 0) == 1 ? gb + 1104916 | 0 : (i3 | 0) == 2 ? gb + 1104936 | 0 : gb + 1104956 | 0;
    if (i12) {
     i12 = HEAP32[i5 >> 2] | 0;
     HEAP32[i32 >> 2] = gb + 32588;
     HEAP32[i21 >> 2] = 0;
     HEAP32[i22 >> 2] = i12;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i10, i3, i32);
    }
    L112 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L112;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    if (i1 | 0) {
     i12 = HEAP32[i5 >> 2] | 0;
     HEAP32[i32 >> 2] = gb + 32588;
     HEAP32[i27 >> 2] = 0;
     HEAP32[i28 >> 2] = i12;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i3, i32);
    }
    L120 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L120;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    if (i7) {
     i12 = HEAP32[i4 >> 2] | 0;
     HEAP32[i32 >> 2] = gb + 32588;
     HEAP32[i23 >> 2] = 0;
     HEAP32[i24 >> 2] = i12;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i11, i3, i32);
    }
    L128 : do if (HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0) {
     switch (HEAP32[i9 >> 2] | 0) {
     case 0:
     case 5:
      break;
     default:
      break L128;
     }
     if (!i2) break L72;
     __Z12profiler_endP19ProfilerInformation(i2);
     break L72;
    } while (0);
    if (i6 | 0) {
     i12 = HEAP32[i4 >> 2] | 0;
     HEAP32[i32 >> 2] = gb + 32588;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i26 >> 2] = i12;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i6, i3, i32);
    }
    if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
   } while (0);
   i8 = i8 + 72 | 0;
  } while ((i8 | 0) != ((HEAP32[i29 >> 2] | 0) + ((HEAP32[i30 >> 2] | 0) * 72 | 0) | 0));
 }
 i1 = i35 + 220 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i35 + 208 | 0);
  HEAP32[i29 >> 2] = 0;
 }
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 if (!i34) {
  STACKTOP = i36;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i34);
 STACKTOP = i36;
 return;
}

function __ZN9Animation25RebuildStateForEverythingEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i35 + 136 | 0;
 i23 = i35 + 128 | 0;
 i26 = i35 + 104 | 0;
 i34 = i35 + 16 | 0;
 i29 = i35;
 if ((HEAP16[gb + 1465188 + 6 >> 1] | 0) > -1) {
  HEAP32[i23 >> 2] = i22;
  HEAP32[i32 >> 2] = HEAP32[i23 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465188 | 0, i32);
  i33 = gb + 1465188 | 0;
 } else i33 = 0;
 i30 = i34 + 4 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP8[i34 + 8 >> 0] = 0;
 HEAP8[i34 + 9 >> 0] = 0;
 HEAP32[i34 + 32 >> 2] = 0;
 HEAP32[i34 + 56 >> 2] = 0;
 i24 = i34 + 60 | 0;
 HEAP32[i24 >> 2] = 0;
 i5 = i34 + 64 | 0;
 HEAP32[i5 >> 2] = 32;
 i25 = i34 + 68 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i34 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f36 = Math_fround((HEAP32[i5 >> 2] | 0) >>> 0);
 HEAP32[i34 + 76 >> 2] = ~~Math_fround(f36 * Math_fround(.5)) >>> 0;
 HEAP32[i34 + 72 >> 2] = ~~Math_fround(f36 * Math_fround(.200000003)) >>> 0;
 HEAP8[i34 + 80 >> 0] = 0;
 __ZN15AnimationBinder17InitCurveIDLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEE(i34);
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i22 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 if (i5 | 0) {
  i27 = i22 + 104 | 0;
  i28 = i22 + 108 | 0;
  i1 = HEAP32[i28 >> 2] | 0;
  i2 = HEAP32[i27 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = 0;
   do {
    i3 = HEAP32[(HEAP32[i2 + (i4 << 2) >> 2] | 0) + 96 >> 2] | 0;
    if (i3) {
     __Z27InsertAnimationClipCurveIDsR14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEER13AnimationClip(i34, i3);
     i1 = HEAP32[i28 >> 2] | 0;
     i2 = HEAP32[i27 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i1 - i2 >> 2 >>> 0);
  }
  i21 = i22 + 84 | 0;
  __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER9TransformR13dynamic_arrayI20BoundCurveDeprecatedLj4EERNS3_6vectorIPSF_S6_ISM_LSA_25ELi16EEEERi(HEAP32[gb + 1465224 >> 2] | 0, i34, i5, i21, i22 + 48 | 0, i22 + 64 | 0);
  __ZN15AnimationBinder19RemoveUnboundCurvesER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER13dynamic_arrayI20BoundCurveDeprecatedLj4EE(i34, i21);
  i1 = HEAP32[i27 >> 2] | 0;
  if ((HEAP32[i28 >> 2] | 0) != (i1 | 0)) {
   i16 = i23 + 4 | 0;
   i12 = i26 + 4 | 0;
   i13 = i26 + 8 | 0;
   i14 = i26 + 12 | 0;
   i15 = i26 + 16 | 0;
   i17 = i23 + 4 | 0;
   i18 = i23 + 4 | 0;
   i19 = i23 + 4 | 0;
   i20 = i23 + 4 | 0;
   i11 = 0;
   do {
    i10 = HEAP32[i1 + (i11 << 2) >> 2] | 0;
    i3 = i10 + 56 | 0;
    i1 = HEAP16[i3 >> 1] | 0;
    i4 = i10 + 4 | 0;
    if (i1 & 16) {
     i2 = HEAP32[i4 >> 2] | 0;
     if (i2) {
      __ZdaPv(i2);
      i1 = HEAP16[i3 >> 1] | 0;
     }
    }
    HEAP32[i4 >> 2] = 0;
    i2 = (HEAP32[i25 >> 2] | 0) - (HEAP32[i30 >> 2] | 0) | 0;
    HEAP16[i3 >> 1] = i1 | 16;
    i1 = __Znaj(i2 >>> 0 > 1073741823 ? -1 : i2 << 2) | 0;
    HEAP32[i4 >> 2] = i1;
    if ((i2 | 0) > 0) {
     HEAP32[i1 >> 2] = 0;
     if ((i2 | 0) != 1) {
      i1 = 1;
      do {
       HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i2 | 0));
     }
    }
    i5 = HEAP32[i10 + 96 >> 2] | 0;
    if (i5 | 0) {
     i1 = HEAP32[i5 + 100 >> 2] | 0;
     i4 = i5 + 104 | 0;
     if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
      i3 = i1 + 16 | 0;
      do if (HEAP32[i1 + 180 >> 2] | 0) {
       __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i32, i3);
       if ((HEAP32[i32 >> 2] & 2139095040 | 0) == 2139095040) break;
       __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i23, i3);
       if ((HEAP32[i20 >> 2] & 2139095040 | 0) != 2139095040) {
        if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
        i9 = HEAP32[i1 + 200 >> 2] | 0;
        HEAP32[i26 >> 2] = i2;
        HEAP32[i12 >> 2] = 4;
        HEAP32[i13 >> 2] = gb + 896768;
        HEAP32[i14 >> 2] = 0;
        HEAP32[i15 >> 2] = i9;
        __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i34, i26, i3, i21, i10);
       }
      } while (0);
      i1 = i1 + 204 | 0;
     } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
     i1 = HEAP32[i5 + 116 >> 2] | 0;
     i4 = i5 + 120 | 0;
     if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
      i2 = i1 + 16 | 0;
      do if (HEAP32[i1 + 148 >> 2] | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i32, i2);
       if ((HEAP32[i32 >> 2] & 2139095040 | 0) == 2139095040) break;
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i23, i2);
       if ((HEAP32[i19 >> 2] & 2139095040 | 0) != 2139095040) {
        if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
        i9 = HEAP32[i1 + 168 >> 2] | 0;
        HEAP32[i26 >> 2] = i3;
        HEAP32[i12 >> 2] = 4;
        HEAP32[i13 >> 2] = gb + 896784;
        HEAP32[i14 >> 2] = 0;
        HEAP32[i15 >> 2] = i9;
        __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i34, i26, i2, i21, i10);
       }
      } while (0);
      i1 = i1 + 172 | 0;
     } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
     i1 = HEAP32[i5 + 132 >> 2] | 0;
     i4 = i5 + 136 | 0;
     if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
      i2 = i1 + 16 | 0;
      do if (HEAP32[i1 + 148 >> 2] | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i32, i2);
       if ((HEAP32[i32 >> 2] & 2139095040 | 0) == 2139095040) break;
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i23, i2);
       if ((HEAP32[i18 >> 2] & 2139095040 | 0) != 2139095040) {
        if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
        i9 = HEAP32[i1 + 168 >> 2] | 0;
        HEAP32[i26 >> 2] = i3;
        HEAP32[i12 >> 2] = 4;
        HEAP32[i13 >> 2] = gb + 896797;
        HEAP32[i14 >> 2] = 0;
        HEAP32[i15 >> 2] = i9;
        __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i34, i26, i2, i21, i10);
       }
      } while (0);
      i1 = i1 + 172 | 0;
     } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
     i1 = HEAP32[i5 + 148 >> 2] | 0;
     i4 = i5 + 152 | 0;
     if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
      i2 = i1 + 16 | 0;
      do if (HEAP32[i1 + 148 >> 2] | 0) {
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i32, i2);
       if ((HEAP32[i32 >> 2] & 2139095040 | 0) == 2139095040) break;
       __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i23, i2);
       if ((HEAP32[i17 >> 2] & 2139095040 | 0) != 2139095040) {
        if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
        i9 = HEAP32[i1 + 168 >> 2] | 0;
        HEAP32[i26 >> 2] = i3;
        HEAP32[i12 >> 2] = 4;
        HEAP32[i13 >> 2] = gb + 896813;
        HEAP32[i14 >> 2] = 0;
        HEAP32[i15 >> 2] = i9;
        __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i34, i26, i2, i21, i10);
       }
      } while (0);
      i1 = i1 + 172 | 0;
     } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
     i1 = HEAP32[i5 + 164 >> 2] | 0;
     i9 = i5 + 168 | 0;
     if ((i1 | 0) != (HEAP32[i9 >> 2] | 0)) do {
      i6 = i1 + 40 | 0;
      do if (HEAP32[i1 + 108 >> 2] | 0) {
       __ZNK17AnimationCurveTplIfE8GetRangeEv(i32, i6);
       if ((HEAP32[i32 >> 2] & 2139095040 | 0) == 2139095040) break;
       __ZNK17AnimationCurveTplIfE8GetRangeEv(i23, i6);
       if ((HEAP32[i16 >> 2] & 2139095040 | 0) == 2139095040) break;
       if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i8 = HEAP32[i1 >> 2] | 0; else i8 = i1;
       i7 = HEAP32[i1 + 32 >> 2] | 0;
       i5 = i1 + 36 | 0;
       i2 = HEAP32[i5 >> 2] | 0;
       if (!i2) i2 = 0; else {
        HEAP32[i23 >> 2] = i2;
        i2 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i2) i31 = 71; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i3 = HEAP32[i2 + 28 >> 2] | 0;
          i4 = HEAP32[i2 + 32 >> 2] | 0;
          i2 = i3 + (i4 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i32, i2, i23);
          i3 = HEAP32[i32 >> 2] | 0;
          i37 = HEAP32[i2 + 28 >> 2] | 0;
          i4 = HEAP32[gb + 1104264 >> 2] | 0;
          i2 = (i3 | 0) == -1 ? i37 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i37 + (i3 << 3) | 0;
          i3 = HEAP32[i4 + 28 >> 2] | 0;
          i4 = HEAP32[i4 + 32 >> 2] | 0;
         }
         if ((i2 | 0) == (i3 + (i4 << 3) | 0)) {
          i31 = 71;
          break;
         }
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i31 = 73;
        } while (0);
        if ((i31 | 0) == 71) i31 = 73;
        if ((i31 | 0) == 73) {
         i31 = 0;
         i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
        }
       }
       i3 = i1 + 16 | 0;
       if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
       i37 = HEAP32[i1 + 128 >> 2] | 0;
       HEAP32[i26 >> 2] = i8;
       HEAP32[i12 >> 2] = i7;
       HEAP32[i13 >> 2] = i3;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i15 >> 2] = i37;
       __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i34, i26, i6, i21, i10);
      } while (0);
      i1 = i1 + 132 | 0;
     } while ((i1 | 0) != (HEAP32[i9 >> 2] | 0));
    }
    i11 = i11 + 1 | 0;
    i1 = HEAP32[i27 >> 2] | 0;
   } while (i11 >>> 0 < (HEAP32[i28 >> 2] | 0) - i1 >> 2 >>> 0);
  }
 }
 HEAP32[i22 + 248 >> 2] = 0;
 i1 = i22 + 252 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) {
  i37 = HEAP32[i34 + 84 >> 2] | 0;
  HEAP32[i32 >> 2] = 1;
  HEAP32[i32 + 4 >> 2] = i37;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i32);
 }
 if (!i33) {
  STACKTOP = i35;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i33);
 STACKTOP = i35;
 return;
}

function __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_(i1, i2, i18) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 L1 : while (1) {
  i14 = i2;
  i15 = i2 + -24 | 0;
  i16 = i2 + -20 | 0;
  i10 = i2 + -16 | 0;
  i11 = i2 + -12 | 0;
  i12 = i2 + -8 | 0;
  i13 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i14 - i9 | 0;
    switch ((i3 | 0) / 24 | 0 | 0) {
    case 2:
     {
      i17 = 5;
      break L1;
     }
    case 3:
     {
      i17 = 7;
      break L1;
     }
    case 4:
     {
      i17 = 8;
      break L1;
     }
    case 5:
     {
      i17 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i17 = 53;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 168) {
     i17 = 11;
     break L1;
    }
    i6 = i1 + (((i3 >>> 0) / 48 | 0) * 24 | 0) | 0;
    if ((i3 | 0) > 23976) {
     i3 = (i3 >>> 0) / 96 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_(i1, i1 + (i3 * 24 | 0) | 0, i6, i6 + (i3 * 24 | 0) | 0, i15, i18) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i1, i6, i15, i18) | 0;
    if (mftCall_iii(HEAP32[i18 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
     i5 = i15;
     break;
    } else i4 = i15;
    while (1) {
     i5 = i4 + -24 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (mftCall_iii(HEAP32[i18 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
      i17 = 36;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 24 | 0;
    if (!(mftCall_iii(HEAP32[i18 >> 2] | 0, i1 | 0, i15 | 0) | 0)) {
     if ((i3 | 0) == (i15 | 0)) {
      i17 = 53;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i18 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 24 | 0;
      if ((i3 | 0) == (i15 | 0)) {
       i17 = 53;
       break L1;
      }
     }
     i4 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i15 >> 2] = i4;
     i4 = i3 + 4 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i3 + 8 >> 2] | 0;
     i7 = HEAP32[i3 + 12 >> 2] | 0;
     i8 = HEAP32[i3 + 16 >> 2] | 0;
     i9 = HEAP32[i3 + 20 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
     HEAP32[i16 >> 2] = i5;
     HEAP32[i10 >> 2] = i6;
     HEAP32[i11 >> 2] = i7;
     HEAP32[i12 >> 2] = i8;
     HEAP32[i13 >> 2] = i9;
     i3 = i3 + 24 | 0;
    }
    if ((i3 | 0) == (i15 | 0)) {
     i17 = 53;
     break L1;
    } else i4 = i15;
    while (1) {
     while (1) {
      i6 = i3 + 24 | 0;
      if (mftCall_iii(HEAP32[i18 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i6;
     }
     while (1) {
      i5 = i4 + -24 | 0;
      if (mftCall_iii(HEAP32[i18 >> 2] | 0, i1 | 0, i5 | 0) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i23 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i23;
     i23 = i3 + 4 | 0;
     i21 = i4 + -20 | 0;
     i22 = HEAP32[i23 >> 2] | 0;
     i7 = HEAP32[i3 + 8 >> 2] | 0;
     i8 = HEAP32[i3 + 12 >> 2] | 0;
     i9 = HEAP32[i3 + 16 >> 2] | 0;
     i3 = HEAP32[i3 + 20 >> 2] | 0;
     HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i23 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i21 >> 2] = i22;
     HEAP32[i4 + -16 >> 2] = i7;
     HEAP32[i4 + -12 >> 2] = i8;
     HEAP32[i4 + -8 >> 2] = i9;
     HEAP32[i4 + -4 >> 2] = i3;
     i4 = i5;
     i3 = i6;
    }
   }
   if ((i17 | 0) == 36) {
    i17 = 0;
    i25 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i25;
    i25 = i1 + 4 | 0;
    i7 = i4 + -20 | 0;
    i24 = HEAP32[i25 >> 2] | 0;
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i21 = HEAP32[i1 + 12 >> 2] | 0;
    i22 = HEAP32[i1 + 16 >> 2] | 0;
    i23 = HEAP32[i1 + 20 >> 2] | 0;
    HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i25 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i25 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i25 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i25 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i7 >> 2] = i24;
    HEAP32[i4 + -16 >> 2] = i8;
    HEAP32[i4 + -12 >> 2] = i21;
    HEAP32[i4 + -8 >> 2] = i22;
    HEAP32[i4 + -4 >> 2] = i23;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 24 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i8 = i6;
    while (1) {
     while (1) {
      i7 = i4 + 24 | 0;
      if (mftCall_iii(HEAP32[i18 >> 2] | 0, i4 | 0, i8 | 0) | 0) i4 = i7; else break;
     }
     while (1) {
      i6 = i5 + -24 | 0;
      if (mftCall_iii(HEAP32[i18 >> 2] | 0, i6 | 0, i8 | 0) | 0) break; else i5 = i6;
     }
     if (i4 >>> 0 > i6 >>> 0) {
      i5 = i8;
      i6 = i4;
      break L35;
     }
     i27 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = i27;
     i27 = i4 + 4 | 0;
     i21 = i5 + -20 | 0;
     i26 = HEAP32[i27 >> 2] | 0;
     i22 = HEAP32[i4 + 8 >> 2] | 0;
     i23 = HEAP32[i4 + 12 >> 2] | 0;
     i24 = HEAP32[i4 + 16 >> 2] | 0;
     i25 = HEAP32[i4 + 20 >> 2] | 0;
     HEAP32[i27 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i27 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     HEAP32[i27 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
     HEAP32[i27 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
     HEAP32[i27 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
     HEAP32[i21 >> 2] = i26;
     HEAP32[i5 + -16 >> 2] = i22;
     HEAP32[i5 + -12 >> 2] = i23;
     HEAP32[i5 + -8 >> 2] = i24;
     HEAP32[i5 + -4 >> 2] = i25;
     i8 = (i8 | 0) == (i4 | 0) ? i6 : i8;
     i5 = i6;
     i4 = i7;
     i3 = i3 + 1 | 0;
    }
   } else {
    i5 = i6;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) if (mftCall_iii(HEAP32[i18 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
    i21 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i21;
    i21 = i6 + 4 | 0;
    i23 = i5 + 4 | 0;
    i22 = HEAP32[i21 >> 2] | 0;
    i24 = HEAP32[i6 + 8 >> 2] | 0;
    i25 = HEAP32[i6 + 12 >> 2] | 0;
    i26 = HEAP32[i6 + 16 >> 2] | 0;
    i27 = HEAP32[i6 + 20 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i21 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
    HEAP32[i21 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
    HEAP32[i23 >> 2] = i22;
    HEAP32[i5 + 8 >> 2] = i24;
    HEAP32[i5 + 12 >> 2] = i25;
    HEAP32[i5 + 16 >> 2] = i26;
    HEAP32[i5 + 20 >> 2] = i27;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEbT0_SD_T_(i1, i6, i18) | 0;
    i4 = i6 + 24 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEbT0_SD_T_(i4, i2, i18) | 0) {
     i17 = 52;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i27 = i6;
   if ((i27 - i9 | 0) >= (i14 - i27 | 0)) {
    i17 = 51;
    break;
   }
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_(i1, i6, i18);
   i1 = i6 + 24 | 0;
  }
  if ((i17 | 0) == 51) {
   i17 = 0;
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_(i6 + 24 | 0, i2, i18);
   i2 = i6;
   continue;
  } else if ((i17 | 0) == 52) {
   i17 = 0;
   if (i3) {
    i17 = 53;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i17 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i18 >> 2] | 0, i15 | 0, i1 | 0) | 0)) {
   STACKTOP = i20;
   return;
  }
  i22 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i22;
  i22 = i1 + 4 | 0;
  i23 = HEAP32[i22 >> 2] | 0;
  i24 = HEAP32[i1 + 8 >> 2] | 0;
  i25 = HEAP32[i1 + 12 >> 2] | 0;
  i26 = HEAP32[i1 + 16 >> 2] | 0;
  i27 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i16 >> 2] = i23;
  HEAP32[i10 >> 2] = i24;
  HEAP32[i11 >> 2] = i25;
  HEAP32[i12 >> 2] = i26;
  HEAP32[i13 >> 2] = i27;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i1, i1 + 24 | 0, i15, i18) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 8) {
  __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i15, i18) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 9) {
  __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_(i1, i1 + 24 | 0, i1 + 48 | 0, i1 + 72 | 0, i15, i18) | 0;
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 11) {
  i3 = i1 + 48 | 0;
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i1, i1 + 24 | 0, i3, i18) | 0;
  i4 = i1 + 72 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i20;
   return;
  }
  i7 = i19 + 4 | 0;
  i8 = i19 + 8 | 0;
  i9 = i19 + 12 | 0;
  i10 = i19 + 16 | 0;
  i11 = i19 + 20 | 0;
  while (1) {
   if (mftCall_iii(HEAP32[i18 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i4 + 20 >> 2];
    i5 = i4;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     i27 = i5 + 4 | 0;
     i5 = i3 + 4 | 0;
     HEAP32[i27 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i27 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i27 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i27 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP32[i27 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
     if ((i3 | 0) == (i1 | 0)) break;
     i6 = i3 + -24 | 0;
     if (mftCall_iii(HEAP32[i18 >> 2] | 0, i19 | 0, i6 | 0) | 0) {
      i5 = i3;
      i3 = i6;
     } else break;
    }
    HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   }
   i3 = i4 + 24 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i27 = i4;
    i4 = i3;
    i3 = i27;
   }
  }
  STACKTOP = i20;
  return;
 } else if ((i17 | 0) == 53) {
  STACKTOP = i20;
  return;
 }
}

function __ZN5physx3Ext29RegisterExtensionsSerializersERNS_23PxSerializationRegistryE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 89) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 89264 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 8, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 90) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 89384 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 7, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 91) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 89488 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 3, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 92) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 89616 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 1, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 93) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 89688 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 2, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 94) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 89728 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 6, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 95) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 89848 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 5, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 96) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 89928 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 14, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 97) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 89992 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 13, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 100) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 90032 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 4, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 101) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 90112 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 10, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 104) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 114456 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 11, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 105) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 114496 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 12, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 108) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 114536 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 259, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 109) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 114576 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 260, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 110) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 114616 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 261, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 111) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 114656 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 258, i2 | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 112) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 114696 + 8;
 mftCall_viii(i2 | 0, i1 | 0, 257, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830799 | 0, gb + 741290 | 0, 113) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 114736 + 8;
 mftCall_viii(i3 | 0, i1 | 0, 256, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 116) | 0;
 HEAP32[i3 >> 2] = gb + 114776 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 744763;
 mftCall_viii(i2 | 0, i1 | 0, 259, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 117) | 0;
 HEAP32[i2 >> 2] = gb + 114824 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 744276;
 mftCall_viii(i3 | 0, i1 | 0, 260, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 118) | 0;
 HEAP32[i3 >> 2] = gb + 114872 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 744345;
 mftCall_viii(i2 | 0, i1 | 0, 261, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 119) | 0;
 HEAP32[i2 >> 2] = gb + 114920 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 744688;
 mftCall_viii(i3 | 0, i1 | 0, 258, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 120) | 0;
 HEAP32[i3 >> 2] = gb + 114968 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 743937;
 mftCall_viii(i2 | 0, i1 | 0, 257, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 741290 | 0, 121) | 0;
 HEAP32[i2 >> 2] = gb + 115016 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 744174;
 mftCall_viii(i3 | 0, i1 | 0, 256, i2 | 0);
 return;
}

function __ZN12_GLOBAL__N_119constrainSeparationI8Scalar4fPKS1_EEvPT_PKS4_RKT0_(i1, i62, i2) {
 i1 = i1 | 0;
 i62 = i62 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, f49 = f0, i50 = 0, f51 = f0, f52 = f0, i53 = 0, f54 = f0, f55 = f0, i56 = 0, f57 = f0, f58 = f0, i59 = 0, f60 = f0, f61 = f0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0;
 if (i1 >>> 0 >= i62 >>> 0) return;
 while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  i26 = i1 + 4 | 0;
  i37 = HEAP32[i26 >> 2] | 0;
  i44 = i1 + 8 | 0;
  i47 = HEAP32[i44 >> 2] | 0;
  i50 = i1 + 12 | 0;
  i53 = HEAP32[i50 >> 2] | 0;
  i56 = i1 + 16 | 0;
  i59 = HEAP32[i56 >> 2] | 0;
  i4 = i1 + 20 | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i10 = i1 + 24 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i12 = i1 + 28 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i18 = i1 + 32 | 0;
  i23 = HEAP32[i18 >> 2] | 0;
  i24 = i1 + 36 | 0;
  i25 = HEAP32[i24 >> 2] | 0;
  i27 = i1 + 40 | 0;
  i28 = HEAP32[i27 >> 2] | 0;
  i29 = i1 + 44 | 0;
  i30 = HEAP32[i29 >> 2] | 0;
  i31 = i1 + 48 | 0;
  i32 = HEAP32[i31 >> 2] | 0;
  i33 = i1 + 52 | 0;
  i34 = HEAP32[i33 >> 2] | 0;
  i35 = i1 + 56 | 0;
  i36 = HEAP32[i35 >> 2] | 0;
  i38 = i1 + 60 | 0;
  i39 = HEAP32[i38 >> 2] | 0;
  i40 = HEAP32[gb + 1097472 >> 2] | 0;
  i41 = HEAP32[gb + 1097472 + 4 >> 2] | 0;
  i42 = HEAP32[gb + 1097472 + 8 >> 2] | 0;
  i43 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
  f45 = Math_fround(HEAPF32[i2 >> 2]);
  f45 = Math_fround(f45 - (HEAP32[tempDoublePtr >> 2] = i40 & i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f46 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f46 = Math_fround(f46 - (HEAP32[tempDoublePtr >> 2] = i41 & i37, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f48 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f48 = Math_fround(f48 - (HEAP32[tempDoublePtr >> 2] = i42 & i47, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f49 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f49 = Math_fround(f49 - (HEAP32[tempDoublePtr >> 2] = i43 & i53, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f51 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f51 = Math_fround(f51 - (HEAP32[tempDoublePtr >> 2] = i40 & i59, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f52 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  f52 = Math_fround(f52 - (HEAP32[tempDoublePtr >> 2] = i41 & i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f54 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f54 = Math_fround(f54 - (HEAP32[tempDoublePtr >> 2] = i42 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f55 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f55 = Math_fround(f55 - (HEAP32[tempDoublePtr >> 2] = i43 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f57 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f57 = Math_fround(f57 - (HEAP32[tempDoublePtr >> 2] = i40 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f58 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f58 = Math_fround(f58 - (HEAP32[tempDoublePtr >> 2] = i41 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f60 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f60 = Math_fround(f60 - (HEAP32[tempDoublePtr >> 2] = i42 & i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f61 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f61 = Math_fround(f61 - (HEAP32[tempDoublePtr >> 2] = i43 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f5 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  f5 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i40 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f6 = Math_fround(HEAPF32[i2 + 52 >> 2]);
  f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i41 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f8 = Math_fround(HEAPF32[i2 + 56 >> 2]);
  f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i42 & i36, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f9 = Math_fround(HEAPF32[i2 + 60 >> 2]);
  f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i43 & i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f14 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
  f15 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
  f16 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
  f14 = Math_fround(Math_fround(1.0) - Math_fround(f49 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f48 * f48) + Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f45 * f45) + f14))))))));
  f15 = Math_fround(Math_fround(1.0) - Math_fround(f55 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f54 * f54) + Math_fround(Math_fround(f52 * f52) + Math_fround(Math_fround(f51 * f51) + f15))))))));
  f16 = Math_fround(Math_fround(1.0) - Math_fround(f61 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f60 * f60) + Math_fround(Math_fround(f58 * f58) + Math_fround(Math_fround(f57 * f57) + f16))))))));
  f17 = Math_fround(Math_fround(1.0) - Math_fround(f9 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f5 * f5) + Math_fround(HEAPF32[gb + 1097504 + 12 >> 2])))))))));
  i19 = f14 < Math_fround(0.0);
  i20 = f15 < Math_fround(0.0);
  i21 = f16 < Math_fround(0.0);
  i22 = f17 < Math_fround(0.0);
  if (i19 | i20 | i21 | i22) {
   i64 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i68 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
   i72 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
   i75 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
   i65 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i69 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
   i73 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
   i76 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
   i66 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i70 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
   i74 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
   i77 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
   i63 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i67 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
   i71 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
   f57 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0) & i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = i19 ? f14 : Math_fround(0.0);
   f57 = Math_fround(f57 * f61);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i77 & i41, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f61);
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i76 & i42, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f61);
   f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i75 & i43, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f61);
   f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f58);
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f60);
   f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f61);
   HEAPF32[i1 >> 2] = f57;
   HEAPF32[i26 >> 2] = f58;
   HEAPF32[i44 >> 2] = f60;
   HEAPF32[i50 >> 2] = f61;
   i47 = HEAP32[gb + 1097472 + 4 >> 2] & i74;
   i50 = HEAP32[gb + 1097472 + 8 >> 2] & i73;
   i53 = HEAP32[gb + 1097472 + 12 >> 2] & i72;
   f61 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i71, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = i20 ? f15 : Math_fround(0.0);
   f61 = Math_fround(f60 * f61);
   f58 = Math_fround(f60 * (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f57 = Math_fround(f60 * (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f60 = Math_fround(f60 * (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f61);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f58);
   f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f60);
   HEAPF32[i56 >> 2] = f61;
   HEAPF32[i4 >> 2] = f58;
   HEAPF32[i10 >> 2] = f57;
   HEAPF32[i12 >> 2] = f60;
   i59 = HEAP32[gb + 1097472 + 4 >> 2] & i70;
   i56 = HEAP32[gb + 1097472 + 8 >> 2] & i69;
   i53 = HEAP32[gb + 1097472 + 12 >> 2] & i68;
   f60 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i67, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = i21 ? f16 : Math_fround(0.0);
   f60 = Math_fround(f57 * f60);
   f58 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f61 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f57 = Math_fround(f57 * (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f60);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f58);
   f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f61);
   f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
   HEAPF32[i18 >> 2] = f60;
   HEAPF32[i24 >> 2] = f58;
   HEAPF32[i27 >> 2] = f61;
   HEAPF32[i29 >> 2] = f57;
   i53 = HEAP32[gb + 1097472 + 4 >> 2] & i66;
   i56 = HEAP32[gb + 1097472 + 8 >> 2] & i65;
   i59 = HEAP32[gb + 1097472 + 12 >> 2] & i64;
   f57 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097472 >> 2] & i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = i22 ? f17 : Math_fround(0.0);
   f57 = Math_fround(f61 * f57);
   f58 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f60 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f61 = Math_fround(f61 * (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f57 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f57);
   f58 = Math_fround((HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f58);
   f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f60);
   f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f61);
   HEAPF32[i31 >> 2] = f57;
   HEAPF32[i33 >> 2] = f58;
   HEAPF32[i35 >> 2] = f60;
   HEAPF32[i38 >> 2] = f61;
  }
  i1 = i1 + 64 | 0;
  if (i1 >>> 0 >= i62 >>> 0) break; else i2 = i2 + 64 | 0;
 }
 return;
}

function __ZN14PhysicsManager8TransferI14SafeBinaryReadEEvRT_(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 4 | 0;
 i9 = i13;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i10, i12);
 __ZN14SafeBinaryRead10SetVersionEi(i12, 3);
 i2 = i10 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 801749 | 0, HEAP32[gb + 37324 >> 2] | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 944562 | 0, gb + 737343 | 0, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14PhysicMaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i10 + 52 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737364 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 18; else {
    i4 = i2 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i8 = 18; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 839280 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 29; else {
    i4 = i2 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i8 = 29; else {
     HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i7 = i12 + 128 | 0;
 if (!((HEAP8[i7 >> 0] | 0) == 0 | (HEAP32[gb + 1457408 >> 2] | 0) == 0)) HEAP32[i10 + 44 >> 2] = HEAP32[i9 >> 2];
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737382 | 0, i6, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i4 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   if (i1 >>> 0 < i6 >>> 0) i8 = 42; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i8 = 42; else {
     HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 42) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i9, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 do if (HEAP8[i7 >> 0] | 0) {
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  if (HEAP32[gb + 1457408 >> 2] | 0) if (!(f3 <= Math_fround(0.0))) {
   HEAPF32[i10 + 48 >> 2] = f3;
   break;
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737405 | 0, 0, gb + 662472 | 0, 1179, 1, 0, 0, 0);
   break;
  }
 } while (0);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737458 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 58; else {
    i4 = i2 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i8 = 58; else {
     HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (HEAP8[i7 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (HEAP32[gb + 1457408 >> 2] | 0) HEAP32[i10 + 168 >> 2] = (i1 | 0) < 1 ? 1 : (i1 | 0) > 255 ? 255 : i1;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737484 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 72; else {
    i4 = i2 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (HEAP8[i7 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (HEAP32[gb + 1457408 >> 2] | 0) HEAP32[i10 + 172 >> 2] = (i1 | 0) < 1 ? 1 : (i1 | 0) > 255 ? 255 : i1;
 }
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737518 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) {
    i4 = i2 + 1 | 0;
    if (i4 >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i9 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i4;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (HEAP8[i7 >> 0] | 0) HEAP8[i10 + 798 >> 0] = HEAP8[i9 >> 0] | 0;
 i4 = i10 + 56 | 0;
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i12, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 802065 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   L129 : do if ((i1 | 0) > 0) {
    i1 = i12 + 16 | 0;
    i9 = HEAP32[i12 + 20 >> 2] | 0;
    i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i9 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L129;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 802114 | 0, i5, i11, 0) | 0;
  if (i1 | 0) {
   L142 : do if ((i1 | 0) > 0) {
    i1 = i12 + 16 | 0;
    i9 = HEAP32[i12 + 20 >> 2] | 0;
    i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    do if (i2 >>> 0 >= i9 >>> 0) {
     if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     break L142;
    } while (0);
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
 }
 i4 = i10 + 57 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737540 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  L155 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i9 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i9 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L155;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 797 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 737562 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  L167 : do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i9 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   do if (i2 >>> 0 >= i9 >>> 0) {
    if ((i2 + 1 | 0) >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) break;
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break L167;
   } while (0);
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 724 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 802184 | 0, HEAP32[gb + 37316 >> 2] | 0, i11, 1) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIjNS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i12, i2, 0); else {
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i4, i43, i56, i57, i58, i59) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i43 = i43 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, i64 = 0, i65 = 0, i66 = 0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i60 + 224 | 0;
 i53 = i60 + 160 | 0;
 i54 = i60 + 96 | 0;
 i28 = i60 + 80 | 0;
 i52 = i60 + 324 | 0;
 i46 = i60 + 64 | 0;
 i49 = i60 + 48 | 0;
 i50 = i60 + 32 | 0;
 i47 = i60 + 312 | 0;
 i51 = i60 + 16 | 0;
 i25 = i60;
 i24 = i60 + 300 | 0;
 i48 = i60 + 288 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i52 >> 2] = 0;
 i26 = i43 + 48 | 0;
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 i32 = i43 + 52 | 0;
 f9 = Math_fround(HEAPF32[i32 >> 2]);
 i42 = i43 + 56 | 0;
 f10 = Math_fround(HEAPF32[i42 >> 2]);
 i44 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i44 ? f8 : Math_fround(1.0);
 f11 = i44 ? f9 : Math_fround(0.0);
 f7 = i44 ? f10 : Math_fround(0.0);
 HEAPF32[i46 >> 2] = f12;
 i44 = i46 + 4 | 0;
 HEAPF32[i44 >> 2] = f11;
 i45 = i46 + 8 | 0;
 HEAPF32[i45 >> 2] = f7;
 HEAPF32[i46 + 12 >> 2] = Math_fround(0.0);
 f27 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f27 = Math_fround((f27 > f2 ? f2 : f27) * Math_fround(.100000001));
 f27 = Math_fround(f27 * f27);
 HEAP32[i49 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i50 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
 i28 = i43 + 4 | 0;
 i29 = i43 + 8 | 0;
 i30 = i43 + 16 | 0;
 i31 = i43 + 20 | 0;
 i33 = i43 + 24 | 0;
 i34 = i43 + 32 | 0;
 i35 = i43 + 36 | 0;
 i36 = i43 + 40 | 0;
 i37 = i1 + 96 | 0;
 i38 = i1 + 100 | 0;
 i39 = i1 + 104 | 0;
 i40 = i1 + 112 | 0;
 i41 = i1 + 116 | 0;
 i21 = i1 + 120 | 0;
 i22 = i4 + 144 | 0;
 i23 = i4 + 148 | 0;
 i4 = i4 + 152 | 0;
 i13 = i25 + 4 | 0;
 i14 = i25 + 8 | 0;
 i15 = i25 + 12 | 0;
 i16 = i55 + 4 | 0;
 i17 = i55 + 8 | 0;
 i18 = i55 + 16 | 0;
 i19 = i55 + 20 | 0;
 i20 = i55 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 i1 = 0;
 while (1) {
  HEAP32[i51 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
  f68 = Math_fround(-f12);
  f75 = Math_fround(-f11);
  f76 = Math_fround(-f7);
  f71 = Math_fround(HEAPF32[i43 >> 2]);
  f78 = Math_fround(f71 * f68);
  f69 = Math_fround(HEAPF32[i28 >> 2]);
  f78 = Math_fround(f78 + Math_fround(f69 * f75));
  f3 = Math_fround(HEAPF32[i29 >> 2]);
  f78 = Math_fround(f78 + Math_fround(f3 * f76));
  f63 = Math_fround(HEAPF32[i30 >> 2]);
  f77 = Math_fround(f63 * f68);
  f62 = Math_fround(HEAPF32[i31 >> 2]);
  f77 = Math_fround(f77 + Math_fround(f62 * f75));
  f6 = Math_fround(HEAPF32[i33 >> 2]);
  f77 = Math_fround(f77 + Math_fround(f6 * f76));
  f72 = Math_fround(HEAPF32[i34 >> 2]);
  f68 = Math_fround(f72 * f68);
  f70 = Math_fround(HEAPF32[i35 >> 2]);
  f75 = Math_fround(f68 + Math_fround(f70 * f75));
  f68 = Math_fround(HEAPF32[i36 >> 2]);
  f76 = Math_fround(f75 + Math_fround(f68 * f76));
  f75 = Math_fround(HEAPF32[i37 >> 2]);
  f74 = Math_fround(HEAPF32[i38 >> 2]);
  f73 = Math_fround(HEAPF32[i39 >> 2]);
  f79 = Math_fround(Math_fround(Math_fround(f78 * f75) + Math_fround(f77 * f74)) + Math_fround(f76 * f73));
  f5 = Math_fround(HEAPF32[i40 >> 2]);
  f61 = Math_fround(HEAPF32[i41 >> 2]);
  f67 = Math_fround(HEAPF32[i21 >> 2]);
  i66 = f79 > Math_fround(Math_fround(Math_fround(f78 * f5) + Math_fround(f77 * f61)) + Math_fround(f76 * f67));
  f5 = i66 ? f75 : f5;
  f61 = i66 ? f74 : f61;
  f67 = i66 ? f73 : f67;
  f63 = Math_fround(f8 + Math_fround(Math_fround(f72 * f67) + Math_fround(Math_fround(f71 * f5) + Math_fround(f63 * f61))));
  f62 = Math_fround(f9 + Math_fround(Math_fround(f70 * f67) + Math_fround(Math_fround(f69 * f5) + Math_fround(f62 * f61))));
  f61 = Math_fround(f10 + Math_fround(Math_fround(f68 * f67) + Math_fround(Math_fround(f3 * f5) + Math_fround(f6 * f61))));
  i66 = f12 > Math_fround(0.0);
  i65 = f11 > Math_fround(0.0);
  i64 = f7 > Math_fround(0.0);
  f6 = Math_fround(HEAPF32[i22 >> 2]);
  f5 = Math_fround(HEAPF32[i23 >> 2]);
  f3 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(-f6);
  f9 = Math_fround(-f5);
  f10 = Math_fround(-f3);
  f8 = i66 ? f6 : f8;
  f9 = i65 ? f5 : f9;
  f10 = i64 ? f3 : f10;
  f3 = Math_fround(f63 - f8);
  f5 = Math_fround(f62 - f9);
  f6 = Math_fround(f61 - f10);
  f12 = Math_fround(f2 - Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f12 * f3) + Math_fround(f11 * f5))));
  HEAPF32[i53 + (i1 << 4) >> 2] = f63;
  HEAPF32[i53 + (i1 << 4) + 4 >> 2] = f62;
  HEAPF32[i53 + (i1 << 4) + 8 >> 2] = f61;
  HEAPF32[i53 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = HEAP32[i52 >> 2] | 0;
  HEAPF32[i54 + (i1 << 4) >> 2] = f8;
  HEAPF32[i54 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i54 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i54 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i55 + (i1 << 4) >> 2] = f3;
  HEAPF32[i55 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i55 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i55 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i52 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i55 >> 2]);
    f5 = Math_fround(HEAPF32[i16 >> 2]);
    f6 = Math_fround(HEAPF32[i17 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f77 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i66 = f77 > Math_fround(1.0);
     f77 = i66 ? Math_fround(1.0) : f77;
     i66 = f77 > Math_fround(0.0);
     f77 = i66 ? f77 : Math_fround(0.0);
     f78 = Math_fround(f5 + Math_fround(f8 * f77));
     f79 = Math_fround(f6 + Math_fround(f9 * f77));
     HEAPF32[i25 >> 2] = Math_fround(f3 + Math_fround(f7 * f77));
     HEAPF32[i13 >> 2] = f78;
     HEAPF32[i14 >> 2] = f79;
     HEAPF32[i15 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i52 >> 2] = 1;
     HEAP32[i25 >> 2] = HEAP32[i55 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i55, i53, i54, i52);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i55, i53, i54, i52);
    break;
   }
  default:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i46 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i46 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i46 >> 2]);
  f6 = Math_fround(HEAPF32[i44 >> 2]);
  f7 = Math_fround(HEAPF32[i45 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i47 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f27 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i26 >> 2]);
  f9 = Math_fround(HEAPF32[i32 >> 2]);
  f10 = Math_fround(HEAPF32[i42 >> 2]);
  f2 = f3;
  i1 = HEAP32[i52 >> 2] | 0;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i55, i53, i54, i46, i56, i57, i1);
  f77 = Math_fround(HEAPF32[i46 >> 2]);
  f78 = Math_fround(HEAPF32[i44 >> 2]);
  f76 = Math_fround(HEAPF32[i45 >> 2]);
  f79 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f77 * f77) + Math_fround(f78 * f78)) + Math_fround(f76 * f76)))));
  f77 = Math_fround(-Math_fround(f77 * f79));
  f78 = Math_fround(-Math_fround(f78 * f79));
  f79 = Math_fround(-Math_fround(f76 * f79));
  HEAPF32[i59 >> 2] = f2;
  i66 = i59 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAPF32[i58 >> 2] = f77;
  HEAPF32[i58 + 4 >> 2] = f78;
  HEAPF32[i58 + 8 >> 2] = f79;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  i66 = 0;
  STACKTOP = i60;
  return i66 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i55, i53, i54, i51, i56, i57, HEAP32[i52 >> 2] | 0);
  HEAP32[i56 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i56 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i56 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAP32[i56 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
  HEAP32[i57 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i57 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  f76 = Math_fround(HEAPF32[i51 >> 2]);
  f78 = Math_fround(HEAPF32[i51 + 4 >> 2]);
  f79 = Math_fround(HEAPF32[i51 + 8 >> 2]);
  f77 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f76 * f76) + Math_fround(f78 * f78)) + Math_fround(f79 * f79)))));
  f78 = Math_fround(-Math_fround(f78 * f77));
  f79 = Math_fround(-Math_fround(f79 * f77));
  HEAPF32[i58 >> 2] = Math_fround(-Math_fround(f76 * f77));
  HEAPF32[i58 + 4 >> 2] = f78;
  HEAPF32[i58 + 8 >> 2] = f79;
  HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i59 >> 2] = i1 ? f3 : f2;
  i66 = i59 + 4 | 0;
  HEAP32[i66 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i66 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i66 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  i66 = i1 ? 1 : 3;
  STACKTOP = i60;
  return i66 | 0;
 }
 return 0;
}

function __ZN5physx26collideCellsWithStaticMeshEPNS_19PxsParticleCollDataERKNS_21PxsFluidLocalCellHashERKNS_2Gu13GeometryUnionERKNS_11PxTransformESB_fffRKNS_6PxVec3E(i85, i5, i4, i88, i87, f1, f2, f86, i3) {
 i85 = i85 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i88 = i88 | 0;
 i87 = i87 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f86 = Math_fround(f86);
 i3 = i3 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, i95 = 0;
 i84 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i84 + 216 | 0;
 i80 = i84 + 56 | 0;
 i79 = i84 + 24 | 0;
 i83 = i84 + 240 | 0;
 i82 = i84;
 i81 = i84 + 104 | 0;
 i63 = HEAP32[i4 + 40 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i88 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i88 + 20 >> 2]);
 f9 = Math_fround(f9 * Math_fround(-2.0));
 f8 = Math_fround(f8 * Math_fround(-2.0));
 f2 = Math_fround(Math_fround(HEAPF32[i88 + 24 >> 2]) * Math_fround(-2.0));
 f51 = Math_fround(HEAPF32[i88 + 12 >> 2]);
 f7 = Math_fround(Math_fround(f51 * f51) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i88 >> 2]);
 f54 = Math_fround(f9 * f10);
 f21 = Math_fround(HEAPF32[i88 + 4 >> 2]);
 f54 = Math_fround(f54 + Math_fround(f8 * f21));
 f50 = Math_fround(HEAPF32[i88 + 8 >> 2]);
 f54 = Math_fround(f54 + Math_fround(f2 * f50));
 f52 = Math_fround(Math_fround(f10 * f54) + Math_fround(Math_fround(f9 * f7) - Math_fround(f51 * Math_fround(Math_fround(f2 * f21) - Math_fround(f8 * f50)))));
 f53 = Math_fround(Math_fround(f21 * f54) + Math_fround(Math_fround(f8 * f7) - Math_fround(f51 * Math_fround(Math_fround(f9 * f50) - Math_fround(f2 * f10)))));
 f54 = Math_fround(Math_fround(Math_fround(f2 * f7) - Math_fround(f51 * Math_fround(Math_fround(f8 * f10) - Math_fround(f9 * f21)))) + Math_fround(f50 * f54));
 f21 = Math_fround(-f21);
 f50 = Math_fround(-f50);
 HEAPF32[i79 >> 2] = Math_fround(-f10);
 HEAPF32[i79 + 4 >> 2] = f21;
 HEAPF32[i79 + 8 >> 2] = f50;
 HEAPF32[i79 + 12 >> 2] = f51;
 HEAPF32[i79 + 16 >> 2] = f52;
 HEAPF32[i79 + 20 >> 2] = f53;
 HEAPF32[i79 + 24 >> 2] = f54;
 i3 = i4 + 4 | 0;
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i80, i79, i3);
 __ZN5physx2Cm9transformERKNS0_8Matrix34ERKNS_9PxBounds3E(i6, i80, i63 + 128 | 0);
 if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(1.0)) i62 = Math_fround(HEAPF32[i4 + 12 >> 2]) == Math_fround(1.0); else i62 = 0; else i62 = 0;
 i64 = i83 + 36 | 0;
 HEAP32[i83 >> 2] = 1065353216;
 i65 = i83 + 4 | 0;
 HEAP32[i65 >> 2] = 0;
 i66 = i83 + 8 | 0;
 HEAP32[i66 >> 2] = 0;
 i67 = i83 + 12 | 0;
 HEAP32[i67 >> 2] = 0;
 i68 = i83 + 16 | 0;
 HEAP32[i68 >> 2] = 1065353216;
 i69 = i83 + 20 | 0;
 HEAP32[i69 >> 2] = 0;
 i70 = i83 + 24 | 0;
 HEAP32[i70 >> 2] = 0;
 i71 = i83 + 28 | 0;
 HEAP32[i71 >> 2] = 0;
 i72 = i83 + 32 | 0;
 HEAP32[i72 >> 2] = 1065353216;
 HEAP32[i64 >> 2] = 1065353216;
 i73 = i83 + 40 | 0;
 HEAP32[i73 >> 2] = 0;
 i74 = i83 + 44 | 0;
 HEAP32[i74 >> 2] = 0;
 i75 = i83 + 48 | 0;
 HEAP32[i75 >> 2] = 0;
 i76 = i83 + 52 | 0;
 HEAP32[i76 >> 2] = 1065353216;
 i77 = i83 + 56 | 0;
 HEAP32[i77 >> 2] = 0;
 i78 = i83 + 60 | 0;
 HEAP32[i78 >> 2] = 0;
 i79 = i83 + 64 | 0;
 HEAP32[i79 >> 2] = 0;
 i80 = i83 + 68 | 0;
 HEAP32[i80 >> 2] = 1065353216;
 if (!i62) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i83, i3, i4 + 16 | 0);
 i55 = i5 + 8 | 0;
 i3 = HEAP32[i55 >> 2] | 0;
 if (!i3) {
  STACKTOP = i84;
  return;
 }
 i56 = i5 + 12 | 0;
 i57 = i82 + 4 | 0;
 i58 = i82 + 8 | 0;
 i59 = i82 + 12 | 0;
 i60 = i82 + 16 | 0;
 i61 = i82 + 20 | 0;
 i48 = i5 + 4 | 0;
 i49 = i82 + 12 | 0;
 f50 = Math_fround(HEAPF32[i6 >> 2]);
 f51 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f52 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f53 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f54 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 i22 = i81 + 4 | 0;
 i23 = i81 + 8 | 0;
 i24 = i81 + 12 | 0;
 i25 = i81 + 16 | 0;
 i26 = i81 + 20 | 0;
 i27 = i81 + 24 | 0;
 i28 = i81 + 28 | 0;
 i29 = i81 + 32 | 0;
 i30 = i81 + 36 | 0;
 i31 = i81 + 40 | 0;
 i32 = i81 + 44 | 0;
 i33 = i81 + 48 | 0;
 i34 = i81 + 52 | 0;
 i35 = i81 + 56 | 0;
 i36 = i81 + 60 | 0;
 i37 = i81 + 64 | 0;
 i38 = i81 + 68 | 0;
 i39 = i81 + 72 | 0;
 i40 = i81 + 76 | 0;
 i41 = i81 + 80 | 0;
 i42 = i81 + 84 | 0;
 i43 = i81 + 88 | 0;
 i44 = i81 + 92 | 0;
 i45 = i81 + 96 | 0;
 i46 = i81 + 100 | 0;
 i47 = i81 + 104 | 0;
 i20 = 0;
 do {
  i4 = HEAP32[i56 >> 2] | 0;
  i19 = HEAP32[i4 + (i20 << 4) + 8 >> 2] | 0;
  if ((i19 | 0) != -1) {
   HEAP32[i82 >> 2] = 2122317823;
   HEAP32[i57 >> 2] = 2122317823;
   HEAP32[i58 >> 2] = 2122317823;
   HEAP32[i59 >> 2] = -25165825;
   HEAP32[i60 >> 2] = -25165825;
   HEAP32[i61 >> 2] = -25165825;
   i17 = HEAP32[i48 >> 2] | 0;
   i16 = HEAP32[i4 + (i20 << 4) + 12 >> 2] | 0;
   i14 = i17 + (i19 + i16 << 2) | 0;
   i18 = (i19 | 0) == 0;
   if (i18) {
    i4 = -25165825;
    i5 = -25165825;
    i6 = -25165825;
    i12 = 2122317823;
    i13 = 2122317823;
    i11 = 2122317823;
    f10 = Math_fround(8507058669999999534545717.0e13);
    f9 = Math_fround(8507058669999999534545717.0e13);
    f8 = Math_fround(8507058669999999534545717.0e13);
    f7 = Math_fround(-8507058669999999534545717.0e13);
    f2 = Math_fround(-8507058669999999534545717.0e13);
    f1 = Math_fround(-8507058669999999534545717.0e13);
   } else {
    f10 = Math_fround(8507058669999999534545717.0e13);
    f9 = Math_fround(8507058669999999534545717.0e13);
    f8 = Math_fround(8507058669999999534545717.0e13);
    f7 = Math_fround(-8507058669999999534545717.0e13);
    f2 = Math_fround(-8507058669999999534545717.0e13);
    f1 = Math_fround(-8507058669999999534545717.0e13);
    i11 = 2122317823;
    i13 = 2122317823;
    i12 = 2122317823;
    i6 = -25165825;
    i5 = -25165825;
    i4 = -25165825;
    i15 = i17 + (i16 << 2) | 0;
    do {
     i95 = HEAP32[i15 >> 2] | 0;
     f92 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 48 >> 2]);
     f10 = f10 < f92 ? f10 : f92;
     f93 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 52 >> 2]);
     f9 = f9 < f93 ? f9 : f93;
     f90 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 56 >> 2]);
     f8 = f8 < f90 ? f8 : f90;
     f7 = f7 > f92 ? f7 : f92;
     f2 = f2 > f93 ? f2 : f93;
     f1 = f1 > f90 ? f1 : f90;
     f90 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f93 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 64 >> 2]);
     f92 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f91 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 68 >> 2]);
     f94 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f89 = Math_fround(HEAPF32[i85 + (i95 * 176 | 0) + 72 >> 2]);
     i11 = (HEAPF32[tempDoublePtr >> 2] = f90 < f93 ? f90 : f93, HEAP32[tempDoublePtr >> 2] | 0);
     i13 = (HEAPF32[tempDoublePtr >> 2] = f92 < f91 ? f92 : f91, HEAP32[tempDoublePtr >> 2] | 0);
     i12 = (HEAPF32[tempDoublePtr >> 2] = f94 < f89 ? f94 : f89, HEAP32[tempDoublePtr >> 2] | 0);
     f94 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f92 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f90 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i6 = (HEAPF32[tempDoublePtr >> 2] = f94 > f93 ? f94 : f93, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f92 > f91 ? f92 : f91, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f90 > f89 ? f90 : f89, HEAP32[tempDoublePtr >> 2] | 0);
     i15 = i15 + 4 | 0;
    } while ((i15 | 0) != (i14 | 0));
    HEAPF32[i82 >> 2] = f10;
    HEAPF32[i57 >> 2] = f9;
    HEAPF32[i58 >> 2] = f8;
    HEAPF32[i49 >> 2] = f7;
    HEAPF32[i60 >> 2] = f2;
    HEAPF32[i61 >> 2] = f1;
   }
   f91 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f86);
   f93 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f86);
   f89 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f86);
   f90 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f86);
   f92 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f86);
   f94 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f86);
   f91 = f10 < f91 ? f10 : f91;
   f93 = f9 < f93 ? f9 : f93;
   f89 = f8 < f89 ? f8 : f89;
   HEAPF32[i82 >> 2] = f91;
   HEAPF32[i57 >> 2] = f93;
   HEAPF32[i58 >> 2] = f89;
   f90 = f7 > f90 ? f7 : f90;
   f92 = f2 > f92 ? f2 : f92;
   f94 = f1 > f94 ? f1 : f94;
   HEAPF32[i49 >> 2] = f90;
   HEAPF32[i60 >> 2] = f92;
   HEAPF32[i61 >> 2] = f94;
   if (!(f89 > f21) & ((f50 > f90 | f91 > f51 | f52 > f92 | f93 > f53 | f54 > f94) ^ 1)) {
    i3 = i17 + (i16 << 2) | 0;
    HEAP32[i22 >> 2] = 2;
    HEAP32[i81 >> 2] = gb + 147476 + 8;
    HEAP32[i23 >> 2] = i85;
    HEAP32[i24 >> 2] = i3;
    HEAP32[i25 >> 2] = i19;
    HEAP32[i26 >> 2] = i63;
    HEAP32[i27 >> 2] = HEAP32[i83 >> 2];
    HEAP32[i28 >> 2] = HEAP32[i65 >> 2];
    HEAP32[i29 >> 2] = HEAP32[i66 >> 2];
    HEAP32[i30 >> 2] = HEAP32[i67 >> 2];
    HEAP32[i31 >> 2] = HEAP32[i68 >> 2];
    HEAP32[i32 >> 2] = HEAP32[i69 >> 2];
    HEAP32[i33 >> 2] = HEAP32[i70 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i71 >> 2];
    HEAP32[i35 >> 2] = HEAP32[i72 >> 2];
    HEAP32[i36 >> 2] = HEAP32[i64 >> 2];
    HEAP32[i37 >> 2] = HEAP32[i73 >> 2];
    HEAP32[i38 >> 2] = HEAP32[i74 >> 2];
    HEAP32[i39 >> 2] = HEAP32[i75 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i76 >> 2];
    HEAP32[i41 >> 2] = HEAP32[i77 >> 2];
    HEAP32[i42 >> 2] = HEAP32[i78 >> 2];
    HEAP32[i43 >> 2] = HEAP32[i79 >> 2];
    HEAP32[i44 >> 2] = HEAP32[i80 >> 2];
    HEAPF32[i45 >> 2] = f86;
    HEAP32[i46 >> 2] = 0;
    HEAP32[i47 >> 2] = i87;
    if (!i18) {
     i4 = 0;
     while (1) {
      i95 = HEAP32[i3 >> 2] | 0;
      HEAP32[i85 + (i95 * 176 | 0) + 144 >> 2] = 0;
      HEAP32[i85 + (i95 * 176 | 0) + 148 >> 2] = 0;
      HEAP32[i85 + (i95 * 176 | 0) + 152 >> 2] = 0;
      i95 = i85 + (i95 * 176 | 0) + 160 | 0;
      i4 = i4 + 1 | 0;
      HEAP32[i95 >> 2] = 0;
      HEAP32[i95 + 4 >> 2] = 0;
      HEAP32[i95 + 8 >> 2] = 0;
      HEAP32[i95 + 12 >> 2] = 0;
      if ((i4 | 0) == (i19 | 0)) break; else i3 = i3 + 4 | 0;
     }
    }
    __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback(i63, i88, i87, i83, i62, i82, i81);
    i3 = HEAP32[i55 >> 2] | 0;
   }
  }
  i20 = i20 + 1 | 0;
 } while (i20 >>> 0 < i3 >>> 0);
 STACKTOP = i84;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXml12processCloseEcPKcPciPS2_PN5physx6shdfnd7FastXml8CallbackERb(i15, i3, i12, i5, i1, i2, i14, i13) {
 i15 = i15 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP8[i13 >> 0] = 1;
 L1 : do switch (i3 << 24 >> 24) {
 case 63:
 case 47:
  {
   i1 = _strchr(i12, i3 << 24 >> 24) | 0;
   i4 = (i1 | 0) != 0;
   if (i4) HEAP8[i1 >> 0] = 0;
   if (i3 << 24 >> 24 == 63) if (!(_strcmp(i12, gb + 767348 | 0) | 0)) {
    if (!(mftCall_iiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0, i11 | 0, 0, HEAP32[i15 + 1052 >> 2] | 0) | 0)) {
     i15 = 0;
     STACKTOP = i16;
     return i15 | 0;
    }
   } else i10 = 7; else i10 = 7;
   if ((i10 | 0) == 7) {
    if (!(mftCall_iiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, i12 | 0, 0, i11 | 0, HEAP32[i15 + 1052 >> 2] | 0) | 0)) {
     HEAP32[i15 + 1056 >> 2] = gb + 767161;
     i15 = 0;
     STACKTOP = i16;
     return i15 | 0;
    }
    i2 = i15 + 1060 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (i1 >>> 0 < 2048) {
     if (HEAP8[i15 + 9261 + i1 >> 0] | 0) {
      i11 = HEAP32[i15 + 11312 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, HEAP32[i15 + 1064 + (i1 << 2) >> 2] | 0);
      HEAP8[(HEAP32[i2 >> 2] | 0) + (i15 + 9261) >> 0] = 0;
      i1 = HEAP32[i2 >> 2] | 0;
     }
     HEAP32[i2 >> 2] = i1 + 1;
     HEAP32[i15 + 1064 + (i1 << 2) >> 2] = i12;
     i1 = HEAP32[i2 >> 2] | 0;
    }
    if (HEAP8[i15 + 9261 + i1 >> 0] | 0) {
     i12 = HEAP32[i15 + 11312 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0, i12 | 0, HEAP32[i15 + 1064 + (i1 << 2) >> 2] | 0);
     HEAP8[(HEAP32[i2 >> 2] | 0) + (i15 + 9261) >> 0] = 0;
     i1 = HEAP32[i2 >> 2] | 0;
    }
    HEAP32[i15 + 1064 + (i1 << 2) >> 2] = 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     i2 = 0;
    } else {
     i12 = i1 + -1 | 0;
     HEAP32[i2 >> 2] = i12;
     i1 = HEAP32[i15 + 1064 + (i12 << 2) >> 2] | 0;
     i2 = i12;
    }
    if (!(mftCall_iiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0, i2 | 0, i13 | 0) | 0)) {
     i15 = 0;
     STACKTOP = i16;
     return i15 | 0;
    }
   }
   i1 = i4 ? i5 : i5 + 1 | 0;
   break;
  }
 default:
  {
   i1 = HEAP8[i5 >> 0] | 0;
   L3 : do if (!(i1 << 24 >> 24)) {
    i2 = i5;
    i1 = 0;
   } else {
    i3 = i15 + 1052 | 0;
    i2 = i5;
    while (1) {
     switch (HEAP32[i15 + 4 + ((i1 & 255) << 2) >> 2] | 0) {
     case 4:
     case 2:
      break;
     default:
      break L3;
     }
     if (i1 << 24 >> 24 == 10) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i2 = i2 + 1 | 0;
     i1 = HEAP8[i2 >> 0] | 0;
     if (!(i1 << 24 >> 24)) {
      i1 = 0;
      break L3;
     }
    }
   } while (0);
   i3 = i2;
   L12 : while (1) {
    switch (i1 << 24 >> 24) {
    case 60:
    case 0:
     {
      i4 = 0;
      i10 = 71;
      break L12;
     }
    default:
     {}
    }
    if ((HEAP32[i15 + 4 + ((i1 & 255) << 2) >> 2] | 0) == 4) {
     i10 = 28;
     break;
    }
    if (i1 << 24 >> 24 == 38) {
     i9 = i3;
     i10 = 61;
     break;
    }
    i1 = i3 + 1 | 0;
    i3 = i1;
    i1 = HEAP8[i1 >> 0] | 0;
   }
   L17 : do if ((i10 | 0) == 28) {
    i6 = i15 + 1052 | 0;
    if (i1 << 24 >> 24 == 13) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    i4 = i3 + 1 | 0;
    HEAP8[i3 >> 0] = 32;
    i1 = 32;
    L55 : while (1) {
     switch (HEAP32[i15 + 4 + ((i1 & 255) << 2) >> 2] | 0) {
     case 4:
     case 2:
      break;
     default:
      break L55;
     }
     if (i1 << 24 >> 24 == 10) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i3 = i3 + 1 | 0;
     i1 = HEAP8[i3 >> 0] | 0;
     if (!(i1 << 24 >> 24)) {
      i1 = 0;
      break;
     }
    }
    L61 : while (1) {
     while (1) {
      switch (i1 << 24 >> 24) {
      case 60:
      case 0:
       {
        i10 = 71;
        break L17;
       }
      default:
       {}
      }
      if ((HEAP32[i15 + 4 + ((i1 & 255) << 2) >> 2] | 0) != 4) {
       i10 = 46;
       break;
      }
      if (i1 << 24 >> 24 == 13) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
      i5 = i4 + 1 | 0;
      HEAP8[i4 >> 0] = 32;
      i1 = HEAP8[i3 >> 0] | 0;
      if (!(i1 << 24 >> 24)) {
       i1 = 0;
       i4 = i5;
      } else {
       i4 = i5;
       break;
      }
     }
     if ((i10 | 0) == 46) {
      i10 = 0;
      i9 = i3 + 1 | 0;
      HEAP8[i4 >> 0] = i1;
      i3 = i9;
      i1 = HEAP8[i9 >> 0] | 0;
      i4 = i4 + 1 | 0;
      continue;
     }
     while (1) {
      switch (HEAP32[i15 + 4 + ((i1 & 255) << 2) >> 2] | 0) {
      case 4:
      case 2:
       break;
      default:
       continue L61;
      }
      if (i1 << 24 >> 24 == 10) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
      i3 = i3 + 1 | 0;
      i1 = HEAP8[i3 >> 0] | 0;
      if (!(i1 << 24 >> 24)) {
       i1 = 0;
       continue L61;
      }
     }
    }
   } else if ((i10 | 0) == 61) while (1) {
    i10 = 0;
    i8 = i9 + 1 | 0;
    i7 = i9 + 2 | 0;
    i6 = i9 + 3 | 0;
    i4 = i3;
    L20 : while (1) {
     i1 = HEAP8[i9 >> 0] | 0;
     switch (i1 << 24 >> 24) {
     case 0:
      {
       i10 = 104;
       break L17;
      }
     case 60:
      {
       i3 = i9;
       break L17;
      }
     case 38:
      break;
     default:
      {
       i10 = 69;
       break L20;
      }
     }
     i3 = (HEAP8[i8 >> 0] | 0) == 35;
     L23 : while (1) {
      if (i3) switch (HEAP8[i7 >> 0] | 0) {
      case 120:
       {
        i10 = 48;
        break L23;
       }
      case 0:
       break;
      default:
       {
        i10 = 57;
        break L23;
       }
      }
      if (!(_strncmp(gb + 767358 | 0, i9, 4) | 0)) {
       i3 = gb + 146716 + 4 | 0;
       i1 = 0;
       i10 = 68;
       break L20;
      }
      if (!(_strncmp(gb + 767352 | 0, i9, 5) | 0)) {
       i3 = gb + 146716 + 16 | 0;
       i1 = 1;
       i10 = 68;
       break L20;
      }
      if (!(_strncmp(gb + 767417 | 0, i9, 4) | 0)) {
       i3 = gb + 146716 + 28 | 0;
       i1 = 2;
       i10 = 68;
       break L20;
      }
      if (!(_strncmp(gb + 767422 | 0, i9, 6) | 0)) {
       i3 = gb + 146716 + 40 | 0;
       i1 = 3;
       i10 = 68;
       break L20;
      }
      if (!(_strncmp(gb + 767429 | 0, i9, 6) | 0)) {
       i3 = gb + 146716 + 52 | 0;
       i1 = 4;
       i10 = 68;
       break L20;
      }
     }
     if ((i10 | 0) == 48) {
      i10 = 0;
      if (!(HEAP8[i6 >> 0] | 0)) {
       i3 = i9;
       i10 = 71;
       break L17;
      }
      i3 = _strchr(i6, 59) | 0;
      i5 = HEAP8[i3 + -1 >> 0] | 0;
      i1 = i5 << 24 >> 24;
      if (i5 << 24 >> 24 > 57) i5 = (_tolower(i1) | 0) + -87 | 0; else i5 = i1 + -48 | 0;
      i1 = i3 + -2 | 0;
      i3 = HEAP8[i1 >> 0] | 0;
      if ((i3 | 0) == (_tolower(120) | 0)) i1 = i5; else {
       i3 = HEAP8[i1 >> 0] | 0;
       i1 = i3 << 24 >> 24;
       if (i3 << 24 >> 24 > 57) i1 = (_tolower(i1) | 0) + -87 | 0; else i1 = i1 + -48 | 0;
       i1 = i1 << 4 & 4080 | i5 << 24 >> 24;
      }
     } else if ((i10 | 0) == 57) {
      i10 = 0;
      i3 = _strchr(i7, 59) | 0;
      i1 = (HEAPU8[i3 + -1 >> 0] | 0) + 208 | 0;
      i3 = HEAP8[i3 + -2 >> 0] | 0;
      if (i3 << 24 >> 24 != 35) i1 = i1 << 24 >> 24 | ((i3 << 24 >> 24) * 10 | 0) + 32;
     }
     i3 = i4 + 1 | 0;
     HEAP8[i4 >> 0] = i1;
     i1 = _strchr(i9, 59) | 0;
     if (!i1) i4 = i3; else {
      i10 = 60;
      break;
     }
    }
    if ((i10 | 0) == 60) {
     HEAP8[i1 >> 0] = 0;
     i9 = i1 + 1 | 0;
     i10 = 61;
     continue;
    } else if ((i10 | 0) == 68) {
     HEAP8[i4 >> 0] = HEAP8[gb + 146716 + (i1 * 12 | 0) + 8 >> 0] | 0;
     i9 = i9 + (HEAP32[i3 >> 2] | 0) | 0;
     i3 = i4 + 1 | 0;
     i10 = 61;
     continue;
    } else if ((i10 | 0) == 69) {
     HEAP8[i4 >> 0] = i1;
     i9 = i8;
     i3 = i4 + 1 | 0;
     i10 = 61;
     continue;
    }
   } while (0);
   if ((i10 | 0) == 71) if (i1 << 24 >> 24 != 60) i10 = 104;
   if ((i10 | 0) == 104) {
    HEAP32[i15 + 1056 >> 2] = gb + 767363;
    i15 = 0;
    STACKTOP = i16;
    return i15 | 0;
   }
   i1 = i3 + 1 | 0;
   if ((HEAP8[i1 >> 0] | 0) != 47) {
    i10 = i15 + 1040 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   }
   if (!i4) HEAP8[i3 >> 0] = 0; else HEAP8[i4 >> 0] = 0;
   if (!(mftCall_iiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, i12 | 0, ((HEAP8[i2 >> 0] | 0) == 0 ? 0 : i2) | 0, i11 | 0, HEAP32[i15 + 1052 >> 2] | 0) | 0)) {
    HEAP32[i15 + 1056 >> 2] = gb + 767161;
    i15 = 0;
    STACKTOP = i16;
    return i15 | 0;
   }
   i5 = i15 + 1060 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 >>> 0 < 2048) {
    if (HEAP8[i15 + 9261 + i2 >> 0] | 0) {
     i11 = HEAP32[i15 + 11312 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, HEAP32[i15 + 1064 + (i2 << 2) >> 2] | 0);
     HEAP8[(HEAP32[i5 >> 2] | 0) + (i15 + 9261) >> 0] = 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i2 + 1;
    HEAP32[i15 + 1064 + (i2 << 2) >> 2] = i12;
   }
   switch (HEAP8[i1 >> 0] | 0) {
   case 33:
    {
     if ((HEAP8[i3 + 2 >> 0] | 0) != 45) break L1;
     if ((HEAP8[i3 + 3 >> 0] | 0) != 45) break L1;
     i1 = i3 + 4 | 0;
     while (1) if ((HEAP8[i1 >> 0] | 0) == 32) i1 = i1 + 1 | 0; else break;
     i2 = _strstr(i1, gb + 767157 | 0) | 0;
     if (!i2) break L1;
     HEAP8[i2 >> 0] = 0;
     if (mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 | 0) | 0) {
      i1 = i2 + 3 | 0;
      break L1;
     }
     HEAP32[i15 + 1056 >> 2] = gb + 767161;
     i15 = 0;
     STACKTOP = i16;
     return i15 | 0;
    }
   case 47:
    break;
   default:
    break L1;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if (HEAP8[i15 + 9261 + i2 >> 0] | 0) {
    i12 = HEAP32[i15 + 11312 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0, i12 | 0, HEAP32[i15 + 1064 + (i2 << 2) >> 2] | 0);
    HEAP8[(HEAP32[i5 >> 2] | 0) + (i15 + 9261) >> 0] = 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   HEAP32[i15 + 1064 + (i2 << 2) >> 2] = 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i4 = 0; else {
    i4 = i2 + -1 | 0;
    HEAP32[i5 >> 2] = i4;
    i4 = HEAP32[i15 + 1064 + (i4 << 2) >> 2] | 0;
   }
   i2 = i3 + 2 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   if (i3 << 24 >> 24 == 62) i2 = i4; else {
    i1 = i2;
    L120 : while (1) {
     switch (i3 << 24 >> 24) {
     case 0:
     case 62:
      break L120;
     default:
      {}
     }
     i3 = i1 + 1 | 0;
     i1 = i3;
     i3 = HEAP8[i3 >> 0] | 0;
    }
    HEAP8[i1 >> 0] = 0;
   }
   if (_strcmp(i4, i2) | 0) {
    HEAP32[i15 + 1056 >> 2] = gb + 767218;
    i15 = 0;
    STACKTOP = i16;
    return i15 | 0;
   }
   if (mftCall_iiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 | 0, HEAP32[i5 >> 2] | 0, i13 | 0) | 0) {
    i1 = i1 + 1 | 0;
    break L1;
   }
   i14 = HEAP32[i15 + 1028 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, i1 + 1 - (HEAP32[i15 + 1036 >> 2] | 0) + (HEAP32[i15 + 1048 >> 2] | 0) | 0);
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 } while (0);
 if ((HEAP32[i15 + 1040 >> 2] | 0) >>> 0 >= 2) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = __ZN12_GLOBAL__N_19MyFastXml8readDataEPc(i15, i1) | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i61, i2, i62, i3, i1) {
 i61 = i61 | 0;
 i2 = i2 | 0;
 i62 = i62 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0, i60 = 0, i63 = 0, i64 = 0, i65 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i60;
 i58 = i60 + 16 | 0;
 HEAP32[i59 >> 2] = 0;
 HEAP32[i59 + 4 >> 2] = 0;
 HEAP32[i59 + 8 >> 2] = 0;
 HEAP32[i59 + 12 >> 2] = 0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f49 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f51 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f47 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f50 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f46 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f48 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f19 = Math_fround(f47 - f10);
 f20 = Math_fround(f50 - f49);
 f21 = Math_fround(f8 - f51);
 f22 = Math_fround(f46 - f10);
 f23 = Math_fround(f9 - f49);
 f24 = Math_fround(f48 - f51);
 f25 = Math_fround(Math_fround(f20 * f24) - Math_fround(f21 * f23));
 f26 = Math_fround(Math_fround(f21 * f22) - Math_fround(f19 * f24));
 f27 = Math_fround(Math_fround(f19 * f23) - Math_fround(f20 * f22));
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26)));
 f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f28))));
 f55 = Math_fround(f57 * f25);
 f56 = Math_fround(f57 * f26);
 f57 = Math_fround(f27 * f57);
 f45 = Math_fround(Math_fround(f51 * f57) + Math_fround(Math_fround(f10 * f55) + Math_fround(f49 * f56)));
 f52 = Math_fround(HEAPF32[i61 + 2336 >> 2]);
 f53 = Math_fround(HEAPF32[i61 + 2340 >> 2]);
 f54 = Math_fround(HEAPF32[i61 + 2344 >> 2]);
 if (Math_fround(Math_fround(Math_fround(Math_fround(f52 * f55) + Math_fround(f53 * f56)) + Math_fround(f57 * f54)) - f45) < Math_fround(0.0)) {
  i63 = 0;
  STACKTOP = i60;
  return i63 | 0;
 }
 f29 = Math_fround(f46 - f47);
 f30 = Math_fround(f9 - f50);
 f31 = Math_fround(f48 - f8);
 f37 = Math_fround(f52 - f10);
 f38 = Math_fround(f53 - f49);
 f39 = Math_fround(f54 - f51);
 f40 = Math_fround(f52 - f47);
 f41 = Math_fround(f53 - f50);
 f42 = Math_fround(f54 - f8);
 f43 = Math_fround(f52 - f46);
 f44 = Math_fround(f53 - f9);
 f45 = Math_fround(f54 - f48);
 f32 = Math_fround(Math_fround(Math_fround(f19 * f37) + Math_fround(f20 * f38)) + Math_fround(f21 * f39));
 f33 = Math_fround(Math_fround(Math_fround(f22 * f37) + Math_fround(f23 * f38)) + Math_fround(f24 * f39));
 f34 = Math_fround(Math_fround(Math_fround(f19 * f40) + Math_fround(f20 * f41)) + Math_fround(f21 * f42));
 f35 = Math_fround(Math_fround(Math_fround(f22 * f40) + Math_fround(f23 * f41)) + Math_fround(f24 * f42));
 f36 = Math_fround(Math_fround(Math_fround(f19 * f43) + Math_fround(f20 * f44)) + Math_fround(f21 * f45));
 f4 = Math_fround(Math_fround(Math_fround(f22 * f43) + Math_fround(f23 * f44)) + Math_fround(f24 * f45));
 f5 = Math_fround(f35 - f34);
 f6 = Math_fround(f36 - f4);
 f7 = Math_fround(Math_fround(f41 * f45) - Math_fround(f44 * f42));
 f11 = Math_fround(Math_fround(f43 * f42) - Math_fround(f40 * f45));
 f12 = Math_fround(Math_fround(f40 * f44) - Math_fround(f43 * f41));
 f13 = Math_fround(Math_fround(f44 * f39) - Math_fround(f38 * f45));
 f14 = Math_fround(Math_fround(f37 * f45) - Math_fround(f43 * f39));
 f15 = Math_fround(Math_fround(f43 * f38) - Math_fround(f37 * f44));
 f16 = Math_fround(Math_fround(f38 * f42) - Math_fround(f41 * f39));
 f17 = Math_fround(Math_fround(f40 * f39) - Math_fround(f37 * f42));
 f18 = Math_fround(Math_fround(f37 * f41) - Math_fround(f40 * f38));
 do if (f32 < Math_fround(0.0) & f33 < Math_fround(0.0)) {
  i1 = i3 & 255;
  if (!(i1 & 8)) i1 = i1 >>> 5 & 1; else i1 = 1;
  f4 = Math_fround(Math_fround(Math_fround(f37 * f37) + Math_fround(f38 * f38)) + Math_fround(f39 * f39));
  f9 = f49;
  f8 = f51;
 } else {
  if (f34 >= Math_fround(0.0) & f34 >= f35) {
   i1 = i3 & 255;
   if (!(i1 & 8)) i1 = i1 >>> 4 & 1; else i1 = 1;
   f4 = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41)) + Math_fround(f42 * f42));
   f10 = f47;
   f9 = f50;
   break;
  }
  if (f4 >= Math_fround(0.0) & f4 >= f36) {
   i1 = i3 & 255;
   if (!(i1 & 16)) i1 = i1 >>> 5 & 1; else i1 = 1;
   f4 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f44 * f44)) + Math_fround(f45 * f45));
   f10 = f46;
   f8 = f48;
   break;
  }
  if (f32 >= Math_fround(0.0) & f34 < Math_fround(0.0) & Math_fround(Math_fround(f27 * f18) + Math_fround(Math_fround(f25 * f16) + Math_fround(f26 * f17))) < Math_fround(0.0)) {
   f8 = Math_fround(f32 / Math_fround(f32 - f34));
   f10 = Math_fround(f10 + Math_fround(f19 * f8));
   f9 = Math_fround(f49 + Math_fround(f20 * f8));
   f8 = Math_fround(f51 + Math_fround(f21 * f8));
   f51 = Math_fround(f52 - f10);
   f4 = Math_fround(f53 - f9);
   f50 = Math_fround(f54 - f8);
   f4 = Math_fround(Math_fround(f50 * f50) + Math_fround(Math_fround(f51 * f51) + Math_fround(f4 * f4)));
   i1 = (i3 & 255) >>> 3 & 1;
   break;
  }
  if (f35 >= f34 & f36 >= f4 & Math_fround(Math_fround(f27 * f12) + Math_fround(Math_fround(f25 * f7) + Math_fround(f26 * f11))) < Math_fround(0.0)) {
   f51 = Math_fround(f5 / Math_fround(f5 + f6));
   f10 = Math_fround(f47 + Math_fround(f29 * f51));
   f9 = Math_fround(f50 + Math_fround(f30 * f51));
   f8 = Math_fround(f8 + Math_fround(f31 * f51));
   f51 = Math_fround(f52 - f10);
   f4 = Math_fround(f53 - f9);
   f50 = Math_fround(f54 - f8);
   f4 = Math_fround(Math_fround(f50 * f50) + Math_fround(Math_fround(f51 * f51) + Math_fround(f4 * f4)));
   i1 = (i3 & 255) >>> 4 & 1;
   break;
  }
  if (f33 >= Math_fround(0.0) & f4 < Math_fround(0.0) & Math_fround(Math_fround(f27 * f15) + Math_fround(Math_fround(f25 * f13) + Math_fround(f26 * f14))) < Math_fround(0.0)) {
   f8 = Math_fround(f33 / Math_fround(f33 - f4));
   f10 = Math_fround(f10 + Math_fround(f22 * f8));
   f9 = Math_fround(f49 + Math_fround(f23 * f8));
   f8 = Math_fround(f51 + Math_fround(f24 * f8));
   f51 = Math_fround(f52 - f10);
   f4 = Math_fround(f53 - f9);
   f50 = Math_fround(f54 - f8);
   f4 = Math_fround(Math_fround(f50 * f50) + Math_fround(Math_fround(f51 * f51) + Math_fround(f4 * f4)));
   i1 = (i3 & 255) >>> 5 & 1;
   break;
  } else {
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * Math_fround(f10 - f52)) + Math_fround(f26 * Math_fround(f49 - f53))) + Math_fround(f27 * Math_fround(f51 - f54))) / f28);
   f10 = Math_fround(f25 * f8);
   f9 = Math_fround(f26 * f8);
   f8 = Math_fround(f27 * f8);
   f4 = Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)));
   f10 = Math_fround(f52 + f10);
   f9 = Math_fround(f53 + f9);
   f8 = Math_fround(f54 + f8);
   i1 = 1;
   break;
  }
 } while (0);
 if (f4 > Math_fround(1.1920929e-07)) {
  f52 = Math_fround(f52 - f10);
  f6 = Math_fround(f53 - f9);
  f5 = Math_fround(f54 - f8);
  f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)))));
  f5 = Math_fround(f5 * f7);
  f6 = Math_fround(f6 * f7);
  f7 = Math_fround(f52 * f7);
 } else {
  f5 = f57;
  f6 = f56;
  f7 = f55;
 }
 if (!(Math_fround(HEAPF32[i61 + 2368 >> 2]) > f4)) {
  i63 = 1;
  STACKTOP = i60;
  return i63 | 0;
 }
 if (!(i1 << 24 >> 24 ? 1 : Math_fround(Math_fround(f57 * f5) + Math_fround(Math_fround(f56 * f6) + Math_fround(f55 * f7))) > Math_fround(.995999991))) {
  i63 = 1;
  STACKTOP = i60;
  return i63 | 0;
 }
 f4 = Math_fround(Math_sqrt(Math_fround(f4)));
 i2 = i61 + 2328 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i63 = 29; else {
  i3 = i1 + -1 | 0;
  f56 = Math_fround(HEAPF32[i61 + (i3 << 6) >> 2]);
  f57 = Math_fround(HEAPF32[i61 + (i3 << 6) + 4 >> 2]);
  f57 = Math_fround(Math_fround(Math_fround(f7 * f56) + Math_fround(f6 * f57)) + Math_fround(f5 * Math_fround(HEAPF32[i61 + (i3 << 6) + 8 >> 2])));
  if (f57 > Math_fround(HEAPF32[i61 + 2224 >> 2])) {
   i1 = i61 + (i3 << 6) + 32 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) > f4) {
    i2 = i61 + (i3 << 6) + 36 | 0;
    i3 = i61 + (i3 << 6) + 48 | 0;
    i64 = i61 + 2320 | 0;
    i65 = (HEAP32[i64 >> 2] | 0) + (HEAP32[i3 >> 2] << 6) | 0;
    HEAP32[i65 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i65 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
    HEAP32[i65 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
    HEAP32[i65 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
    i59 = HEAP32[i3 >> 2] | 0;
    i65 = HEAP32[i64 >> 2] | 0;
    HEAPF32[i65 + (i59 << 6) + 16 >> 2] = f10;
    HEAPF32[i65 + (i59 << 6) + 20 >> 2] = f9;
    HEAPF32[i65 + (i59 << 6) + 24 >> 2] = f8;
    HEAPF32[i65 + (i59 << 6) + 28 >> 2] = Math_fround(0.0);
    i59 = HEAP32[i3 >> 2] | 0;
    i65 = HEAP32[i64 >> 2] | 0;
    HEAPF32[i65 + (i59 << 6) + 32 >> 2] = f7;
    HEAPF32[i65 + (i59 << 6) + 36 >> 2] = f6;
    HEAPF32[i65 + (i59 << 6) + 40 >> 2] = f5;
    HEAPF32[i65 + (i59 << 6) + 44 >> 2] = f4;
    HEAP32[(HEAP32[i64 >> 2] | 0) + (HEAP32[i3 >> 2] << 6) + 48 >> 2] = i62;
    HEAPF32[i1 >> 2] = f4;
    HEAP32[i2 >> 2] = HEAP32[i58 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
   }
  } else i63 = 29;
 }
 if ((i63 | 0) == 29) {
  i3 = i61 + 2324 | 0;
  i65 = i61 + 2320 | 0;
  i63 = (HEAP32[i65 >> 2] | 0) + (HEAP32[i3 >> 2] << 6) | 0;
  HEAP32[i63 >> 2] = HEAP32[i59 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
  HEAP32[i63 + 12 >> 2] = HEAP32[i59 + 12 >> 2];
  i63 = HEAP32[i3 >> 2] | 0;
  i64 = HEAP32[i65 >> 2] | 0;
  HEAPF32[i64 + (i63 << 6) + 16 >> 2] = f10;
  HEAPF32[i64 + (i63 << 6) + 20 >> 2] = f9;
  HEAPF32[i64 + (i63 << 6) + 24 >> 2] = f8;
  HEAPF32[i64 + (i63 << 6) + 28 >> 2] = Math_fround(0.0);
  i63 = HEAP32[i3 >> 2] | 0;
  i64 = HEAP32[i65 >> 2] | 0;
  HEAPF32[i64 + (i63 << 6) + 32 >> 2] = f7;
  HEAPF32[i64 + (i63 << 6) + 36 >> 2] = f6;
  HEAPF32[i64 + (i63 << 6) + 40 >> 2] = f5;
  HEAPF32[i64 + (i63 << 6) + 44 >> 2] = f4;
  i63 = HEAP32[i3 >> 2] | 0;
  i64 = i63 + 1 | 0;
  HEAP32[i3 >> 2] = i64;
  HEAP32[(HEAP32[i65 >> 2] | 0) + (i63 << 6) + 48 >> 2] = i62;
  i65 = HEAP32[i2 >> 2] | 0;
  HEAP32[i61 + (i65 << 6) + 48 >> 2] = i63;
  HEAP32[i61 + (i65 << 6) + 52 >> 2] = i64;
  HEAPF32[i61 + (i65 << 6) + 32 >> 2] = f4;
  i64 = i61 + (i65 << 6) + 36 | 0;
  HEAP32[i64 >> 2] = HEAP32[i58 >> 2];
  HEAP32[i64 + 4 >> 2] = HEAP32[i58 + 4 >> 2];
  HEAP32[i64 + 8 >> 2] = HEAP32[i58 + 8 >> 2];
  HEAP32[i2 >> 2] = i65 + 1;
  HEAPF32[i61 + (i65 << 6) >> 2] = f7;
  HEAPF32[i61 + (i65 << 6) + 4 >> 2] = f6;
  HEAPF32[i61 + (i65 << 6) + 8 >> 2] = f5;
  HEAPF32[i61 + (i65 << 6) + 12 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i61 + 2324 >> 2] | 0) >>> 0 <= 15) {
  i65 = 1;
  STACKTOP = i60;
  return i65 | 0;
 }
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i61, 1, 1);
 i65 = 1;
 STACKTOP = i60;
 return i65 | 0;
}

function __ZN18AssetBundleManager19RegisterAssetBundleEP11AssetBundle(i3, i49) {
 i3 = i3 | 0;
 i49 = i49 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i54 = i59;
 i56 = i59 + 96 | 0;
 i57 = i59 + 64 | 0;
 i50 = i59 + 44 | 0;
 i51 = i59 + 80 | 0;
 i52 = i59 + 24 | 0;
 i53 = i59 + 12 | 0;
 HEAP32[i57 >> 2] = 0;
 i58 = i57 + 4 | 0;
 HEAP32[i58 >> 2] = 0;
 HEAP32[i57 + 8 >> 2] = 0;
 __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i49, i57);
 if (!(HEAP8[i49 + 184 >> 0] | 0)) {
  __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E14find_or_insertIS2_S4_EEvRPT0_RKT_(i3, i56, i49 + 168 | 0);
  HEAP32[HEAP32[i56 >> 2] >> 2] = i49;
 }
 i2 = HEAP32[i58 >> 2] | 0;
 i1 = HEAP32[i57 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i16 = i49;
  i17 = i50 + 12 | 0;
  i13 = i50 + 12 | 0;
  i18 = i56 + 4 | 0;
  i19 = i50 + 8 | 0;
  i20 = i50 + 4 | 0;
  i21 = i50 + 16 | 0;
  i22 = i3 + 68 | 0;
  i23 = i51 + 12 | 0;
  i24 = i50 + 11 | 0;
  i25 = i56 + 4 | 0;
  i26 = i50 + 12 | 0;
  i15 = i50 + 12 | 0;
  i27 = i56 + 4 | 0;
  i28 = i50 + 8 | 0;
  i29 = i50 + 4 | 0;
  i30 = i3 + 128 | 0;
  i31 = i3 + 72 | 0;
  i32 = i3 + 120 | 0;
  i33 = i3 + 124 | 0;
  i34 = i50 + 11 | 0;
  i35 = i56 + 4 | 0;
  i36 = i56 + 11 | 0;
  i37 = i52 + 11 | 0;
  i38 = i52 + 4 | 0;
  i39 = i50 + 12 | 0;
  i14 = i50 + 12 | 0;
  i40 = i56 + 4 | 0;
  i41 = i50 + 8 | 0;
  i42 = i50 + 4 | 0;
  i43 = i50 + 11 | 0;
  i44 = i52 + 12 | 0;
  i12 = i52 + 12 | 0;
  i45 = i56 + 4 | 0;
  i46 = i52 + 8 | 0;
  i47 = i52 + 4 | 0;
  i48 = i52 + 16 | 0;
  i8 = i3 + 144 | 0;
  i9 = i52 + 11 | 0;
  i10 = i56 + 4 | 0;
  i11 = i56 + 4 | 0;
  i7 = 0;
  i1 = HEAP32[i57 >> 2] | 0;
  do {
   i3 = i1 + (i7 << 4) | 0;
   i6 = i3 + 11 | 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) i4 = HEAP32[i3 >> 2] | 0; else i4 = i3;
   HEAP32[i50 >> 2] = 0;
   HEAP32[i50 + 4 >> 2] = 0;
   HEAP32[i50 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i17 >> 2] = i2;
   i5 = _strlen(i4) | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i50);
    i2 = HEAP32[i13 >> 2] | 0;
    i55 = 20;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i24 >> 0] = i5;
    if (!i5) i2 = i50; else {
     i2 = i50;
     i55 = 22;
    }
   } else i55 = 20;
   if ((i55 | 0) == 20) {
    i60 = i5 + 16 & -16;
    HEAP32[i56 >> 2] = 54;
    HEAP32[i18 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i60, 16, i56, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i50 >> 2] = i2;
    HEAP32[i19 >> 2] = i60 | -2147483648;
    HEAP32[i20 >> 2] = i5;
    i55 = 22;
   }
   if ((i55 | 0) == 22) {
    i55 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   HEAP32[i21 >> 2] = i16;
   __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12resize_deltaEjj(i22, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E15insert_noresizeERKSC_(i51, i22, i50);
   i2 = (HEAP8[i23 >> 0] | 0) == 0;
   if ((HEAP8[i24 >> 0] | 0) < 0) {
    i60 = HEAP32[i50 >> 2] | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    HEAP32[i56 >> 2] = 54;
    HEAP32[i25 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i60, i56);
   }
   if (i2) {
    if ((HEAP8[i6 >> 0] | 0) < 0) i2 = HEAP32[i3 >> 2] | 0; else i2 = i3;
    HEAP32[i50 >> 2] = 0;
    HEAP32[i50 + 4 >> 2] = 0;
    HEAP32[i50 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i26 >> 2] = i1;
    i4 = _strlen(i2) | 0;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i50);
     i1 = HEAP32[i15 >> 2] | 0;
     i55 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i34 >> 0] = i4;
     if (!i4) i1 = i50; else {
      i1 = i50;
      i55 = 34;
     }
    } else i55 = 32;
    if ((i55 | 0) == 32) {
     i60 = i4 + 16 & -16;
     HEAP32[i56 >> 2] = 54;
     HEAP32[i27 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i60, 16, i56, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i50 >> 2] = i1;
     HEAP32[i28 >> 2] = i60 | -2147483648;
     HEAP32[i29 >> 2] = i4;
     i55 = 34;
    }
    if ((i55 | 0) == 34) {
     i55 = 0;
     _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    if ((HEAP32[i30 >> 2] | 0) == (HEAP32[i31 >> 2] | 0)) i2 = (HEAP32[i32 >> 2] | 0) + ((HEAP32[i33 >> 2] | 0) * 20 | 0) | 0; else {
     __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i56, i22, i50);
     i2 = HEAP32[i56 >> 2] | 0;
     i60 = HEAP32[i32 >> 2] | 0;
     i2 = (i2 | 0) == -1 ? i60 + ((HEAP32[i33 >> 2] | 0) * 20 | 0) | 0 : i60 + (i2 * 20 | 0) | 0;
    }
    if ((HEAP8[i34 >> 0] | 0) < 0) {
     i60 = HEAP32[i50 >> 2] | 0;
     i5 = HEAP32[i15 >> 2] | 0;
     HEAP32[i56 >> 2] = 54;
     HEAP32[i35 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i60, i56);
    }
    if ((HEAP8[i6 >> 0] | 0) < 0) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
    i6 = mftCall_ii(HEAP32[(HEAP32[i49 >> 2] | 0) + 36 >> 2] | 0, i49 | 0) | 0;
    i60 = HEAP32[i2 + 16 >> 2] | 0;
    i60 = mftCall_ii(HEAP32[(HEAP32[i60 >> 2] | 0) + 36 >> 2] | 0, i60 | 0) | 0;
    HEAP32[i54 >> 2] = i1;
    HEAP32[i54 + 4 >> 2] = i6;
    HEAP32[i54 + 8 >> 2] = i60;
    __Z6FormatPKcz(i56, gb + 366328 | 0, i54);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i36 >> 0] | 0) < 0 ? HEAP32[i56 >> 2] | 0 : i56, 0, gb + 365670 | 0, 56, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i56);
   } else {
    i2 = HEAP8[i6 >> 0] | 0;
    if (i2 << 24 >> 24 < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i1 = HEAP32[i1 + (i7 << 4) + 4 >> 2] | 0;
    } else i1 = i2 & 255;
    HEAP32[i53 >> 2] = 0;
    HEAP32[i53 + 4 >> 2] = 0;
    HEAP32[i53 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i53, i3, i1);
    __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i56, i53);
    __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i52, i56);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i56);
    i3 = HEAP8[i37 >> 0] | 0;
    i1 = i3 << 24 >> 24 < 0;
    i2 = i1 ? HEAP32[i52 >> 2] | 0 : i52;
    i3 = i1 ? HEAP32[i38 >> 2] | 0 : i3 & 255;
    HEAP32[i50 >> 2] = 0;
    HEAP32[i50 + 4 >> 2] = 0;
    HEAP32[i50 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i39 >> 2] = i1;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i50);
     i1 = HEAP32[i14 >> 2] | 0;
     i55 = 50;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i43 >> 0] = i3;
     if (!i3) i1 = i50; else {
      i1 = i50;
      i55 = 52;
     }
    } else i55 = 50;
    if ((i55 | 0) == 50) {
     i60 = i3 + 16 & -16;
     HEAP32[i56 >> 2] = 66;
     HEAP32[i40 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i60, 16, i56, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i50 >> 2] = i1;
     HEAP32[i41 >> 2] = i60 | -2147483648;
     HEAP32[i42 >> 2] = i3;
     i55 = 52;
    }
    if ((i55 | 0) == 52) {
     i55 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i53);
    i2 = (HEAP8[i43 >> 0] | 0) < 0 ? HEAP32[i50 >> 2] | 0 : i50;
    HEAP32[i52 >> 2] = 0;
    HEAP32[i52 + 4 >> 2] = 0;
    HEAP32[i52 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i44 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i52);
     i1 = HEAP32[i12 >> 2] | 0;
     i55 = 56;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i9 >> 0] = i3;
     if (!i3) i1 = i52; else {
      i1 = i52;
      i55 = 58;
     }
    } else i55 = 56;
    if ((i55 | 0) == 56) {
     i60 = i3 + 16 & -16;
     HEAP32[i56 >> 2] = 54;
     HEAP32[i45 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i60, 16, i56, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i52 >> 2] = i1;
     HEAP32[i46 >> 2] = i60 | -2147483648;
     HEAP32[i47 >> 2] = i3;
     i55 = 58;
    }
    if ((i55 | 0) == 58) {
     i55 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    HEAP32[i48 >> 2] = i16;
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12resize_deltaEjj(i8, 1, 0);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E15insert_noresizeERKSC_(i56, i8, i52);
    if ((HEAP8[i9 >> 0] | 0) < 0) {
     i60 = HEAP32[i52 >> 2] | 0;
     i6 = HEAP32[i12 >> 2] | 0;
     HEAP32[i56 >> 2] = 54;
     HEAP32[i10 >> 2] = i6;
     __Z19free_alloc_internalPvRK10MemLabelId(i60, i56);
    }
    if ((HEAP8[i43 >> 0] | 0) < 0) {
     i60 = HEAP32[i50 >> 2] | 0;
     i6 = HEAP32[i14 >> 2] | 0;
     HEAP32[i56 >> 2] = 66;
     HEAP32[i11 >> 2] = i6;
     __Z19free_alloc_internalPvRK10MemLabelId(i60, i56);
    }
   }
   i7 = i7 + 1 | 0;
   i2 = HEAP32[i58 >> 2] | 0;
   i60 = HEAP32[i57 >> 2] | 0;
   i1 = i60;
  } while (i7 >>> 0 < i2 - i60 >> 4 >>> 0);
 }
 if (!i1) {
  STACKTOP = i59;
  return;
 }
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i56 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i58 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i60 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i56 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i60, i56);
    i2 = HEAP32[i58 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i57 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i59;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_16ConstantIteratorIS2_EEEEvRT_RKS2_(i4, i1, i37) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i37 = i37 | 0;
 var i2 = 0, f3 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0;
 i30 = HEAP32[i4 + 4 >> 2] | 0;
 i31 = HEAP32[i30 + 4 >> 2] | 0;
 i6 = HEAP32[i30 >> 2] | 0;
 i36 = i31 + (i6 << 4) | 0;
 i30 = HEAP32[i30 + 8 >> 2] | 0;
 i2 = i4 + 604 | 0;
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i1 = (i6 | 0) == 0;
 if (!(HEAP8[i4 + 728 >> 0] | 0)) {
  if (i1) return;
  f8 = Math_fround(HEAPF32[i4 + 616 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 612 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + 608 >> 2]);
  f3 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i37 + 4 | 0;
  i5 = i37 + 8 | 0;
  i6 = i37 + 12 | 0;
  i2 = i30;
  i1 = i31;
  while (1) {
   i47 = HEAP32[i1 >> 2] | 0;
   i53 = i1 + 4 | 0;
   i50 = HEAP32[i53 >> 2] | 0;
   i52 = i1 + 8 | 0;
   i49 = HEAP32[i52 >> 2] | 0;
   i51 = i1 + 12 | 0;
   i48 = HEAP32[i51 >> 2] | 0;
   i56 = HEAP32[i2 >> 2] | 0;
   i38 = i2 + 4 | 0;
   i55 = HEAP32[i38 >> 2] | 0;
   i30 = i2 + 8 | 0;
   i54 = HEAP32[i30 >> 2] | 0;
   i31 = i2 + 12 | 0;
   i45 = HEAP32[i31 >> 2] | 0;
   f26 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f29 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f28 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f27 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   f24 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i46 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f27;
   i47 = f24 > f26 ? i56 ^ i47 : 0;
   i50 = f22 > f29 ? i55 ^ i50 : 0;
   i49 = f23 > f28 ? i54 ^ i49 : 0;
   i48 = i46 ? i45 ^ i48 : 0;
   i46 = i47 ^ i56;
   i44 = i50 ^ i55;
   i42 = i49 ^ i54;
   i40 = i48 ^ i45;
   f28 = Math_fround(HEAPF32[gb + 1097536 >> 2]);
   f23 = Math_fround(HEAPF32[gb + 1097536 + 4 >> 2]);
   f29 = Math_fround(HEAPF32[gb + 1097536 + 8 >> 2]);
   f22 = Math_fround(HEAPF32[gb + 1097536 + 12 >> 2]);
   f26 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i45 = f26 > f28;
   i43 = f26 > f23;
   i41 = f26 > f29;
   i39 = f26 > f22;
   f22 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f22 - (HEAP32[tempDoublePtr >> 2] = i56, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f23 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i55, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f24 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f25 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f33 + Math_fround(f3 * f29));
   f28 = Math_fround(f34 + Math_fround(f7 * f28));
   f27 = Math_fround(f35 + Math_fround(f9 * f27));
   f26 = Math_fround(f32 + Math_fround(f8 * Math_fround(f25 - f26)));
   f29 = Math_fround(f22 + (i45 ? f29 : Math_fround(0.0)));
   f28 = Math_fround(f23 + (i43 ? f28 : Math_fround(0.0)));
   f27 = Math_fround(f24 + (i41 ? f27 : Math_fround(0.0)));
   f26 = Math_fround(f25 + (i39 ? f26 : Math_fround(0.0)));
   HEAPF32[i1 >> 2] = f29;
   HEAPF32[i53 >> 2] = f28;
   HEAPF32[i52 >> 2] = f27;
   HEAPF32[i51 >> 2] = f26;
   i44 = HEAP32[gb + 1097440 + 4 >> 2] & i50 ^ i44;
   i42 = HEAP32[gb + 1097440 + 8 >> 2] & i49 ^ i42;
   i40 = HEAP32[gb + 1097440 + 12 >> 2] & i48 ^ i40;
   f26 = Math_fround(HEAPF32[i37 >> 2]);
   f27 = Math_fround(HEAPF32[i4 >> 2]);
   f28 = Math_fround(HEAPF32[i5 >> 2]);
   f29 = Math_fround(HEAPF32[i6 >> 2]);
   f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097440 >> 2] & i47 ^ i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f25 + (i45 ? f26 : Math_fround(0.0)));
   f25 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f25 + (i43 ? f27 : Math_fround(0.0)));
   f25 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f25 + (i41 ? f28 : Math_fround(0.0)));
   f25 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f25 + (i39 ? f29 : Math_fround(0.0)));
   HEAPF32[i2 >> 2] = f26;
   HEAPF32[i38 >> 2] = f27;
   HEAPF32[i30 >> 2] = f28;
   HEAPF32[i31 >> 2] = f29;
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i36 | 0)) break; else i2 = i2 + 16 | 0;
  }
  return;
 } else {
  if (i1) return;
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 608 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 612 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 616 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 620 >> 2]);
  f12 = Math_fround(HEAPF32[i4 + 624 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 628 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 632 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 636 >> 2]);
  f16 = Math_fround(HEAPF32[i4 + 640 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 644 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 648 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 652 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 656 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 660 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 664 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 668 >> 2]);
  f24 = Math_fround(HEAPF32[i4 + 672 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 676 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 680 >> 2]);
  f27 = Math_fround(HEAPF32[i4 + 684 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 688 >> 2]);
  f29 = Math_fround(HEAPF32[i4 + 692 >> 2]);
  f3 = Math_fround(HEAPF32[i4 + 696 >> 2]);
  i4 = i37 + 4 | 0;
  i5 = i37 + 8 | 0;
  i6 = i37 + 12 | 0;
  i2 = i30;
  i1 = i31;
  while (1) {
   i45 = HEAP32[i1 >> 2] | 0;
   i39 = i1 + 4 | 0;
   i42 = HEAP32[i39 >> 2] | 0;
   i40 = i1 + 8 | 0;
   i43 = HEAP32[i40 >> 2] | 0;
   i41 = i1 + 12 | 0;
   i44 = HEAP32[i41 >> 2] | 0;
   i30 = HEAP32[i2 >> 2] | 0;
   i54 = i2 + 4 | 0;
   i31 = HEAP32[i54 >> 2] | 0;
   i55 = i2 + 8 | 0;
   i38 = HEAP32[i55 >> 2] | 0;
   i56 = i2 + 12 | 0;
   i47 = HEAP32[i56 >> 2] | 0;
   f57 = Math_fround(HEAPF32[gb + 1097552 >> 2]);
   f58 = Math_fround(HEAPF32[gb + 1097552 + 4 >> 2]);
   f63 = Math_fround(HEAPF32[gb + 1097552 + 8 >> 2]);
   f61 = Math_fround(HEAPF32[gb + 1097552 + 12 >> 2]);
   f62 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i46 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f61;
   i45 = f62 > f57 ? i30 ^ i45 : 0;
   i42 = f60 > f58 ? i31 ^ i42 : 0;
   i43 = f59 > f63 ? i38 ^ i43 : 0;
   i44 = i46 ? i47 ^ i44 : 0;
   i46 = i45 ^ i30;
   i48 = i42 ^ i31;
   i50 = i43 ^ i38;
   i52 = i44 ^ i47;
   f63 = Math_fround(HEAPF32[gb + 1097536 >> 2]);
   f59 = Math_fround(HEAPF32[gb + 1097536 + 4 >> 2]);
   f58 = Math_fround(HEAPF32[gb + 1097536 + 8 >> 2]);
   f60 = Math_fround(HEAPF32[gb + 1097536 + 12 >> 2]);
   f57 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i47 = f57 > f63;
   i49 = f57 > f59;
   i51 = f57 > f58;
   i53 = f57 > f60;
   f60 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f33 + Math_fround(f7 * f60));
   f58 = Math_fround(f34 + Math_fround(f8 * f60));
   f59 = Math_fround(f35 + Math_fround(f9 * f60));
   f60 = Math_fround(f32 + Math_fround(f10 * f60));
   f63 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f57 + Math_fround(f11 * f63));
   f58 = Math_fround(f58 + Math_fround(f12 * f63));
   f59 = Math_fround(f59 + Math_fround(f13 * f63));
   f63 = Math_fround(f60 + Math_fround(f14 * f63));
   f60 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f57 + Math_fround(f15 * f60));
   f58 = Math_fround(f58 + Math_fround(f16 * f60));
   f59 = Math_fround(f59 + Math_fround(f17 * f60));
   f60 = Math_fround(f63 + Math_fround(f18 * f60));
   f63 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f57 + Math_fround(f19 * f63));
   f58 = Math_fround(f58 + Math_fround(f20 * f63));
   f59 = Math_fround(f59 + Math_fround(f21 * f63));
   f60 = Math_fround(f60 + Math_fround(f22 * f63));
   f62 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f57 + Math_fround(f23 * f62));
   f58 = Math_fround(f58 + Math_fround(f24 * f62));
   f59 = Math_fround(f59 + Math_fround(f25 * f62));
   f60 = Math_fround(f60 + Math_fround(f26 * f62));
   f61 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f57 + Math_fround(f27 * f61));
   f58 = Math_fround(f58 + Math_fround(f28 * f61));
   f59 = Math_fround(f59 + Math_fround(f29 * f61));
   f60 = Math_fround(f60 + Math_fround(f3 * f61));
   f57 = Math_fround(f63 + (i47 ? f57 : Math_fround(0.0)));
   f58 = Math_fround(f62 + (i49 ? f58 : Math_fround(0.0)));
   f59 = Math_fround(f61 + (i51 ? f59 : Math_fround(0.0)));
   f61 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround(f61 + (i53 ? f60 : Math_fround(0.0)));
   HEAPF32[i1 >> 2] = f57;
   HEAPF32[i39 >> 2] = f58;
   HEAPF32[i40 >> 2] = f59;
   HEAPF32[i41 >> 2] = f60;
   i48 = HEAP32[gb + 1097440 + 4 >> 2] & i42 ^ i48;
   i50 = HEAP32[gb + 1097440 + 8 >> 2] & i43 ^ i50;
   i52 = HEAP32[gb + 1097440 + 12 >> 2] & i44 ^ i52;
   f60 = Math_fround(HEAPF32[i37 >> 2]);
   f59 = Math_fround(HEAPF32[i4 >> 2]);
   f58 = Math_fround(HEAPF32[i5 >> 2]);
   f57 = Math_fround(HEAPF32[i6 >> 2]);
   f61 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097440 >> 2] & i45 ^ i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround(f61 + (i47 ? f60 : Math_fround(0.0)));
   f61 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f59 = Math_fround(f61 + (i49 ? f59 : Math_fround(0.0)));
   f61 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f58 = Math_fround(f61 + (i51 ? f58 : Math_fround(0.0)));
   f61 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f61 + (i53 ? f57 : Math_fround(0.0)));
   HEAPF32[i2 >> 2] = f60;
   HEAPF32[i54 >> 2] = f59;
   HEAPF32[i55 >> 2] = f58;
   HEAPF32[i56 >> 2] = f57;
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i36 | 0)) break; else i2 = i2 + 16 | 0;
  }
  return;
 }
}

function __Z18ClipAnimationCurveIfEbRK17AnimationCurveTplIT_ERS2_ff(i1, i20, f19, f5) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 f19 = Math_fround(f19);
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i24;
 i21 = i24 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i18 = i21 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i22 = i21 + 16 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i17 = i16;
 i8 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i23;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i8;
 i14 = i1 + 68 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 if (!i8) i1 = 0; else {
  i17 = i1 + 56 | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  if ((HEAP32[i11 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
   i1 = i8 + -1 | 0;
   if ((HEAP32[i11 + (i1 << 4) >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
    f4 = Math_fround(HEAPF32[i11 >> 2]);
    i2 = HEAP32[i11 + (i1 << 4) >> 2] | 0;
    if (f4 > f19) f13 = f4; else {
     f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f13 = f13 < f19 ? f13 : f19;
    }
    if (f4 > f5) f15 = f4; else {
     f15 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f15 = f15 < f5 ? f15 : f5;
    }
    i9 = i8 << 4 >> 4;
    i7 = i11;
    i2 = i9;
    L11 : while (1) {
     while (1) {
      if (!i2) break L11;
      i3 = (i2 | 0) / 2 | 0;
      i6 = i7 + (i3 << 4) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f13) break; else i2 = i3;
     }
     i7 = i6 + 16 | 0;
     i2 = i2 + -1 - i3 | 0;
    }
    i8 = i11 + (i8 << 4) | 0;
    if ((i7 | 0) == (i8 | 0)) i12 = i1; else {
     i10 = i7 - i11 >> 4;
     i12 = i10 + -1 | 0;
     i12 = (i12 | 0) < 0 ? 0 : i12;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f13)));
     i7 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i12 << 4) >> 2]) - f13)));
     i12 = i7 ? i10 : i12;
    }
    i7 = i11;
    i2 = i9;
    L21 : while (1) {
     while (1) {
      if (!i2) break L21;
      i3 = (i2 | 0) / 2 | 0;
      i6 = i7 + (i3 << 4) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f15) break; else i2 = i3;
     }
     i7 = i6 + 16 | 0;
     i2 = i2 + -1 - i3 | 0;
    }
    if ((i7 | 0) != (i8 | 0)) {
     i10 = i7 - i11 >> 4;
     i1 = i10 + -1 | 0;
     i1 = (i1 | 0) < 0 ? 0 : i1;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f15)));
     i9 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i1 << 4) >> 2]) - f15)));
     i1 = i9 ? i10 : i1;
    }
    f5 = Math_fround(f13 - f15);
    i10 = f5 < Math_fround(0.0);
    f4 = Math_fround(-f5);
    if (!((i10 ? f4 : f5) <= Math_fround(.00100000005))) {
     i2 = i1 - i12 | 0;
     i2 = ((i2 | 0) < 0 ? 0 : i2) + 3 | 0;
     if (!i2) {
      i10 = 0;
      i2 = 0;
      i9 = i11;
     } else {
      HEAP32[i22 >> 2] = i2;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i21 >> 2] = i2;
      i10 = i2;
      i9 = HEAP32[i17 >> 2] | 0;
     }
     i11 = i9 + (i12 << 4) | 0;
     f5 = Math_fround(f13 - Math_fround(HEAPF32[i11 >> 2]));
     i8 = f5 < Math_fround(0.0);
     f4 = Math_fround(-f5);
     if (!((i8 ? f4 : f5) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i14 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i9 >> 2]);
       f5 = Math_fround(HEAPF32[i9 + (i8 + -1 << 4) >> 2]);
      }
      if (!(f4 >= f13) & !(f5 <= f13)) {
       i7 = i9;
       i2 = i8 << 4 >> 4;
       L42 : while (1) {
        while (1) {
         if (!i2) break L42;
         i3 = (i2 | 0) / 2 | 0;
         i6 = i7 + (i3 << 4) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f13) break; else i2 = i3;
        }
        i7 = i6 + 16 | 0;
        i2 = i2 + -1 - i3 | 0;
       }
       i11 = (i7 - i9 >> 4) + -1 | 0;
       i2 = i8 + -2 | 0;
       i2 = (i11 | 0) < (i2 | 0) ? i11 : i2;
       i2 = (i2 | 0) > 0 ? i2 : 0;
      } else i2 = -1;
      __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f(i16, i9 + (i2 << 4) | 0, i9 + (i2 + 1 << 4) | 0, f13);
      i3 = HEAP32[i18 >> 2] | 0;
      i6 = i3 + 1 | 0;
      i7 = HEAP32[i22 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i2 = i7 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i11 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i18 >> 2] << 4 | 0) | 0;
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = i11;
        break;
       }
      } while (0);
      HEAP32[i18 >> 2] = i6;
      i2 = (HEAP32[i21 >> 2] | 0) + (i3 << 4) | 0;
      HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      i2 = HEAP32[i17 >> 2] | 0;
      if (f13 > Math_fround(HEAPF32[i2 + (i12 << 4) >> 2])) {
       i11 = i12 + 1 | 0;
       i10 = i2;
      } else {
       i11 = i12;
       i10 = i2;
      }
     } else {
      i8 = HEAP32[i18 >> 2] | 0;
      i9 = i8 + 1 | 0;
      i6 = HEAP32[i22 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i9 >>> 0 > i7 >>> 0) {
       i3 = i6 << 1;
       i3 = (i3 | 0) == 0 ? 1 : i3;
       if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i22 >> 2] = i3;
        i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i3 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i21 >> 2] = i2;
        break;
       } else {
        i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i2 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i18 >> 2] << 4 | 0) | 0;
        HEAP32[i22 >> 2] = i3;
        HEAP32[i21 >> 2] = i2;
        break;
       }
      } while (0);
      HEAP32[i18 >> 2] = i9;
      i10 = i2 + (i8 << 4) | 0;
      HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      i11 = i12 + 1 | 0;
      i10 = HEAP32[i17 >> 2] | 0;
     }
     i9 = i10 + (i1 << 4) | 0;
     f13 = Math_fround(f15 - Math_fround(HEAPF32[i9 >> 2]));
     i12 = f13 < Math_fround(0.0);
     f5 = Math_fround(-f13);
     if (!((i12 ? f5 : f13) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i14 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i10 >> 2]);
       f5 = Math_fround(HEAPF32[i10 + (i8 + -1 << 4) >> 2]);
      }
      if (!(f4 >= f15) & !(f5 <= f15)) {
       i7 = i10;
       i2 = i8 << 4 >> 4;
       L74 : while (1) {
        while (1) {
         if (!i2) break L74;
         i3 = (i2 | 0) / 2 | 0;
         i6 = i7 + (i3 << 4) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f15) break; else i2 = i3;
        }
        i7 = i6 + 16 | 0;
        i2 = i2 + -1 - i3 | 0;
       }
       i14 = (i7 - i10 >> 4) + -1 | 0;
       i2 = i8 + -2 | 0;
       i2 = (i14 | 0) < (i2 | 0) ? i14 : i2;
       i2 = (i2 | 0) > 0 ? i2 : 0;
      } else i2 = -1;
      __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f(i16, i10 + (i2 << 4) | 0, i10 + (i2 + 1 << 4) | 0, f15);
      i3 = HEAP32[i18 >> 2] | 0;
      i6 = i3 + 1 | 0;
      i7 = HEAP32[i22 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i2 = i7 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i14 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i18 >> 2] << 4 | 0) | 0;
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = i14;
        break;
       }
      } while (0);
      HEAP32[i18 >> 2] = i6;
      i14 = (HEAP32[i21 >> 2] | 0) + (i3 << 4) | 0;
      HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      if (f15 > Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + (i1 << 4) >> 2])) i1 = i1 + 1 | 0;
     } else {
      i3 = HEAP32[i18 >> 2] | 0;
      i6 = i3 + 1 | 0;
      i7 = HEAP32[i22 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i2 = i7 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 4, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i16 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i18 >> 2] << 4 | 0) | 0;
        HEAP32[i22 >> 2] = i2;
        HEAP32[i21 >> 2] = i16;
        break;
       }
      } while (0);
      HEAP32[i18 >> 2] = i6;
      i16 = (HEAP32[i21 >> 2] | 0) + (i3 << 4) | 0;
      HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     }
     if ((i1 | 0) > (i11 | 0)) {
      i17 = HEAP32[i17 >> 2] | 0;
      __ZN13dynamic_arrayI11KeyframeTplIfELj4EE6insertEPS1_PKS1_S5_(i21, (HEAP32[i21 >> 2] | 0) + 16 | 0, i17 + (i11 << 4) | 0, i17 + (i1 << 4) | 0) | 0;
     }
     i1 = HEAP32[i18 >> 2] | 0;
     i3 = HEAP32[i21 >> 2] | 0;
     if (!i1) i1 = 0; else {
      i2 = 0;
      do {
       i18 = i3 + (i2 << 4) | 0;
       HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f19);
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i20, i3, i3 + (i1 << 4) | 0);
     HEAPF32[i20 + 4 >> 2] = Math_fround(inf);
     HEAP32[i20 >> 2] = 0;
     HEAPF32[i20 + 32 >> 2] = Math_fround(inf);
     HEAP32[i20 + 28 >> 2] = 0;
     i2 = HEAP32[i20 + 68 >> 2] | 0;
     if (!i2) i1 = 0; else {
      i1 = HEAP32[i20 + 56 >> 2] | 0;
      if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else i1 = (HEAP32[i1 + (i2 + -1 << 4) >> 2] & 2139095040 | 0) != 2139095040;
     }
    } else i1 = 0;
   }
  }
 }
 if ((HEAP32[i22 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i23);
 HEAP32[i21 >> 2] = 0;
 STACKTOP = i24;
 return i1 | 0;
}

function __ZN5physx2Sq16BucketPrunerCore11shiftOriginERKNS_6PxVec3E(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0;
 i1 = i8 + 28 | 0;
 i5 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = 0;
  do {
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   f9 = Math_fround(HEAPF32[i5 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   f9 = Math_fround(HEAPF32[i6 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) + 8 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) + 12 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   f9 = Math_fround(HEAPF32[i5 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) + 16 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   f9 = Math_fround(HEAPF32[i6 >> 2]);
   i4 = i8 + 160 + (i2 * 24 | 0) + 20 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i8 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i2 = i8 + 608 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f10);
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i8 + 612 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f10);
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i8 + 616 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f10);
 i4 = HEAP32[i8 + 592 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i2 + (i4 << 2) >> 2]);
 f9 = Math_fround(HEAPF32[i8 + 624 + (i4 << 2) >> 2]);
 f11 = Math_fround(f10 - f9);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 f9 = Math_fround(f10 + f9);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i8 + 620 >> 2] = (i2 | 0) < 0 ? ~i2 : i2 | -2147483648;
 HEAP32[i8 + 636 >> 2] = (i3 | 0) < 0 ? ~i3 : i3 | -2147483648;
 if (i1 | 0) {
  i2 = HEAP32[i8 + 8 >> 2] | 0;
  i3 = 0;
  do {
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i12 = i2 + (i3 * 24 | 0) | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i12 = i2 + (i3 * 24 | 0) + 4 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i12 = i2 + (i3 * 24 | 0) + 8 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i12 = i2 + (i3 * 24 | 0) + 12 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i12 = i2 + (i3 * 24 | 0) + 16 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i12 = i2 + (i3 * 24 | 0) + 20 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f11);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i8 + 584 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i8 + 20 >> 2] | 0;
  i3 = 0;
  do {
   f10 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i2 + (i3 << 5) | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f10);
   f10 = Math_fround(HEAPF32[i5 >> 2]);
   i12 = i2 + (i3 << 5) + 4 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f10);
   f10 = Math_fround(HEAPF32[i6 >> 2]);
   i12 = i2 + (i3 << 5) + 8 | 0;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f10);
   f10 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
   f11 = Math_fround(HEAPF32[i2 + (i3 << 5) + 16 + (i4 << 2) >> 2]);
   f9 = Math_fround(f10 - f11);
   i13 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround(f10 + f11);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   HEAP32[i2 + (i3 << 5) + 12 >> 2] = (i13 | 0) < 0 ? ~i13 : i13 | -2147483648;
   HEAP32[i2 + (i3 << 5) + 28 >> 2] = (i12 | 0) < 0 ? ~i12 : i12 | -2147483648;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i8 + 688 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i8 + 692 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = i8 + 696 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i8 + 720 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i8 + 724 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = i8 + 728 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i8 + 752 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i8 + 756 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = i8 + 760 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i8 + 784 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i8 + 788 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = i8 + 792 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i8 + 816 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i8 + 820 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = i8 + 824 | 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f11);
 i1 = 0;
 do {
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 48 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 52 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 56 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 80 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 84 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 88 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 112 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 116 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 120 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 144 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 148 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 152 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 176 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 180 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = i8 + 864 + (i1 * 224 | 0) + 184 | 0;
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 i1 = 0;
 do {
  i2 = 0;
  do {
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 48 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 52 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 56 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 80 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 84 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 88 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 112 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 116 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 120 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 144 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 148 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 152 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i7 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 176 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 180 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   f11 = Math_fround(HEAPF32[i6 >> 2]);
   i13 = i8 + 1984 + (i1 * 1120 | 0) + (i2 * 224 | 0) + 184 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 return;
}

function __ZN5physx2Gu10computeMTDERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_RNS_6shdfnd3aos6FloatVERNS6_5Vec3VE(i10, i11, i4, i5, i9, i8) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 112 | 0;
 i13 = i15 + 48 | 0;
 i12 = i15 + 184 | 0;
 i7 = i15 + 32 | 0;
 i6 = i15 + 16 | 0;
 i3 = i15;
 i1 = i4 + 32 | 0;
 i30 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + 32 | 0;
 i31 = HEAP32[i2 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i30 >> 2]);
 f17 = Math_fround(HEAPF32[i30 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i30 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i30 + 12 >> 2]);
 f23 = Math_fround(-f23);
 f17 = Math_fround(-f17);
 f18 = Math_fround(-f18);
 f28 = Math_fround(HEAPF32[i31 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i31 + 20 >> 2]);
 f29 = Math_fround(HEAPF32[i31 + 24 >> 2]);
 f27 = Math_fround(HEAPF32[i30 + 16 >> 2]);
 f20 = Math_fround(HEAPF32[i30 + 20 >> 2]);
 f27 = Math_fround(f28 - f27);
 f20 = Math_fround(f21 - f20);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i30 + 24 >> 2]));
 f21 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f28 = Math_fround(Math_fround(Math_fround(f27 * f23) + Math_fround(f20 * f17)) + Math_fround(f29 * f18));
 f25 = Math_fround(Math_fround(Math_fround(f28 * f23) + Math_fround(Math_fround(f21 * f27) + Math_fround(f22 * Math_fround(Math_fround(f29 * f17) - Math_fround(f20 * f18))))) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(Math_fround(f28 * f17) + Math_fround(Math_fround(f21 * f20) + Math_fround(f22 * Math_fround(Math_fround(f27 * f18) - Math_fround(f29 * f23))))) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f29) + Math_fround(f22 * Math_fround(Math_fround(f20 * f23) - Math_fround(f27 * f17)))) + Math_fround(f28 * f18)) * Math_fround(2.0));
 f27 = Math_fround(HEAPF32[i31 >> 2]);
 f20 = Math_fround(HEAPF32[i31 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i31 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f24 = Math_fround(Math_fround(f22 * f21) - Math_fround(Math_fround(Math_fround(f27 * f23) + Math_fround(f20 * f17)) + Math_fround(f29 * f18)));
 f19 = Math_fround(Math_fround(Math_fround(f29 * f17) - Math_fround(f20 * f18)) + Math_fround(Math_fround(f22 * f27) + Math_fround(f21 * f23)));
 f16 = Math_fround(Math_fround(Math_fround(f27 * f18) - Math_fround(f29 * f23)) + Math_fround(Math_fround(f22 * f20) + Math_fround(f21 * f17)));
 f18 = Math_fround(Math_fround(Math_fround(f20 * f23) - Math_fround(f27 * f17)) + Math_fround(Math_fround(f22 * f29) + Math_fround(f21 * f18)));
 HEAPF32[i14 + 48 >> 2] = f25;
 HEAPF32[i14 + 52 >> 2] = f26;
 HEAPF32[i14 + 56 >> 2] = f28;
 HEAPF32[i14 + 60 >> 2] = Math_fround(0.0);
 f28 = Math_fround(f19 + f19);
 f26 = Math_fround(f16 + f16);
 f25 = Math_fround(f18 + f18);
 f21 = Math_fround(f16 * f26);
 f29 = Math_fround(f18 * f25);
 f16 = Math_fround(f16 * f28);
 f22 = Math_fround(f18 * f28);
 f17 = Math_fround(f24 * f28);
 f18 = Math_fround(f18 * f26);
 f26 = Math_fround(f24 * f26);
 f25 = Math_fround(f24 * f25);
 f28 = Math_fround(Math_fround(1.0) - Math_fround(f19 * f28));
 f19 = Math_fround(f16 + f25);
 f24 = Math_fround(f22 - f26);
 f25 = Math_fround(f16 - f25);
 f16 = Math_fround(f28 - f29);
 f27 = Math_fround(f18 + f17);
 f26 = Math_fround(f22 + f26);
 f17 = Math_fround(f18 - f17);
 f28 = Math_fround(f28 - f21);
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f21) - f29);
 HEAPF32[i14 + 4 >> 2] = f19;
 HEAPF32[i14 + 8 >> 2] = f24;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 16 >> 2] = f25;
 HEAPF32[i14 + 20 >> 2] = f16;
 HEAPF32[i14 + 24 >> 2] = f27;
 HEAPF32[i14 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 32 >> 2] = f26;
 HEAPF32[i14 + 36 >> 2] = f17;
 HEAPF32[i14 + 40 >> 2] = f28;
 HEAPF32[i14 + 44 >> 2] = Math_fround(0.0);
 i31 = HEAP32[i2 >> 2] | 0;
 i30 = HEAP32[i1 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i31 >> 2]);
 f17 = Math_fround(HEAPF32[i31 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i31 + 8 >> 2]);
 f27 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f28 = Math_fround(-f28);
 f17 = Math_fround(-f17);
 f26 = Math_fround(-f26);
 f16 = Math_fround(HEAPF32[i30 + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i30 + 20 >> 2]);
 f24 = Math_fround(HEAPF32[i30 + 24 >> 2]);
 f19 = Math_fround(HEAPF32[i31 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i31 + 20 >> 2]);
 f19 = Math_fround(f16 - f19);
 f29 = Math_fround(f25 - f29);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i31 + 24 >> 2]));
 f25 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f28) + Math_fround(f29 * f17)) + Math_fround(f24 * f26));
 f21 = Math_fround(Math_fround(Math_fround(f16 * f28) + Math_fround(Math_fround(f25 * f19) + Math_fround(f27 * Math_fround(Math_fround(f24 * f17) - Math_fround(f29 * f26))))) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(Math_fround(f16 * f17) + Math_fround(Math_fround(f25 * f29) + Math_fround(f27 * Math_fround(Math_fround(f19 * f26) - Math_fround(f24 * f28))))) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f27 * Math_fround(Math_fround(f29 * f28) - Math_fround(f19 * f17)))) + Math_fround(f16 * f26)) * Math_fround(2.0));
 f19 = Math_fround(HEAPF32[i30 >> 2]);
 f29 = Math_fround(HEAPF32[i30 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i30 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i30 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f27 * f25) - Math_fround(Math_fround(Math_fround(f19 * f28) + Math_fround(f29 * f17)) + Math_fround(f24 * f26)));
 f23 = Math_fround(Math_fround(Math_fround(f24 * f17) - Math_fround(f29 * f26)) + Math_fround(Math_fround(f27 * f19) + Math_fround(f25 * f28)));
 f20 = Math_fround(Math_fround(Math_fround(f19 * f26) - Math_fround(f24 * f28)) + Math_fround(Math_fround(f27 * f29) + Math_fround(f25 * f17)));
 f26 = Math_fround(Math_fround(Math_fround(f29 * f28) - Math_fround(f19 * f17)) + Math_fround(Math_fround(f27 * f24) + Math_fround(f25 * f26)));
 HEAPF32[i13 + 48 >> 2] = f21;
 HEAPF32[i13 + 52 >> 2] = f18;
 HEAPF32[i13 + 56 >> 2] = f16;
 HEAPF32[i13 + 60 >> 2] = Math_fround(0.0);
 f16 = Math_fround(f23 + f23);
 f18 = Math_fround(f20 + f20);
 f21 = Math_fround(f26 + f26);
 f25 = Math_fround(f20 * f18);
 f24 = Math_fround(f26 * f21);
 f20 = Math_fround(f20 * f16);
 f27 = Math_fround(f26 * f16);
 f17 = Math_fround(f22 * f16);
 f26 = Math_fround(f26 * f18);
 f18 = Math_fround(f22 * f18);
 f21 = Math_fround(f22 * f21);
 f16 = Math_fround(Math_fround(1.0) - Math_fround(f23 * f16));
 f23 = Math_fround(f20 + f21);
 f22 = Math_fround(f27 - f18);
 f21 = Math_fround(f20 - f21);
 f20 = Math_fround(f16 - f24);
 f19 = Math_fround(f26 + f17);
 f18 = Math_fround(f27 + f18);
 f17 = Math_fround(f26 - f17);
 f16 = Math_fround(f16 - f25);
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f25) - f24);
 HEAPF32[i13 + 4 >> 2] = f23;
 HEAPF32[i13 + 8 >> 2] = f22;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 16 >> 2] = f21;
 HEAPF32[i13 + 20 >> 2] = f20;
 HEAPF32[i13 + 24 >> 2] = f19;
 HEAPF32[i13 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 32 >> 2] = f18;
 HEAPF32[i13 + 36 >> 2] = f17;
 HEAPF32[i13 + 40 >> 2] = f16;
 HEAPF32[i13 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i12 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_(i10, i11, i4, i5, i13, i14, i3, i7, i15 + 180 | 0, i6, 0, i12) | 0)) {
  i31 = 0;
  STACKTOP = i15;
  return i31 | 0;
 }
 if (!(__ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_(i11, i10, i5, i4, i14, i13, i3, i7, i15 + 176 | 0, i6, 1, i12) | 0)) {
  i31 = 0;
  STACKTOP = i15;
  return i31 | 0;
 }
 if (!(__ZN5physx2GuL14testEdgeNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RNS7_5Vec3VENS0_13FeatureStatusERSH_(i10, i11, i4, i5, i13, i14, i3, i7, i6, i12) | 0)) {
  i31 = 0;
  STACKTOP = i15;
  return i31 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP32[i12 >> 2] | 0) == 1) {
  i31 = HEAP32[i2 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i31 >> 2]);
  f24 = Math_fround(HEAPF32[i31 + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i31 + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i31 + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f22 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
  f20 = Math_fround(Math_fround(Math_fround(f19 * f21) + Math_fround(f24 * f27)) + Math_fround(f26 * f25));
  f28 = Math_fround(Math_fround(Math_fround(f24 * f20) + Math_fround(Math_fround(f22 * f27) + Math_fround(f23 * Math_fround(Math_fround(f26 * f21) - Math_fround(f19 * f25))))) * Math_fround(2.0));
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f23 * Math_fround(Math_fround(f19 * f27) - Math_fround(f24 * f21)))) + Math_fround(f26 * f20)) * Math_fround(2.0));
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(Math_fround(f21 * f22) + Math_fround(f23 * Math_fround(Math_fround(f24 * f25) - Math_fround(f26 * f27))))) * Math_fround(2.0));
  HEAPF32[i8 + 4 >> 2] = f28;
  HEAPF32[i8 + 8 >> 2] = f29;
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  i31 = 1;
  STACKTOP = i15;
  return i31 | 0;
 } else {
  i31 = HEAP32[i1 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i31 >> 2]);
  f24 = Math_fround(HEAPF32[i31 + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i31 + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i31 + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f22 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
  f20 = Math_fround(Math_fround(Math_fround(f19 * f21) + Math_fround(f24 * f27)) + Math_fround(f26 * f25));
  f28 = Math_fround(-Math_fround(Math_fround(Math_fround(f24 * f20) + Math_fround(Math_fround(f22 * f27) + Math_fround(f23 * Math_fround(Math_fround(f26 * f21) - Math_fround(f19 * f25))))) * Math_fround(2.0)));
  f29 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f23 * Math_fround(Math_fround(f19 * f27) - Math_fround(f24 * f21)))) + Math_fround(f26 * f20)) * Math_fround(2.0)));
  HEAPF32[i8 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(Math_fround(f21 * f22) + Math_fround(f23 * Math_fround(Math_fround(f24 * f25) - Math_fround(f26 * f27))))) * Math_fround(2.0)));
  HEAPF32[i8 + 4 >> 2] = f28;
  HEAPF32[i8 + 8 >> 2] = f29;
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  i31 = 1;
  STACKTOP = i15;
  return i31 | 0;
 }
 return 0;
}

function __ZN12NavMeshAgent8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i8, i9);
 i4 = i8 + 36 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843745 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903494 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842264 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842279 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842297 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842312 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 104 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842331 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 105 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842357 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 106 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842371 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932223 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i7 = 99; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 99; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 99) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842384 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i7 = 110; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 110; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 110) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842397 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  i11 = i8 + 92 | 0;
  __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ObstacleAvoidanceTypeEvRT_RT0_PKc17TransferMetaFlags(i9, i11, gb + 842412 | 0, 0);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i11 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i11 >>> 0) i7 = 121; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 121; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 121) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 i11 = i8 + 92 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ObstacleAvoidanceTypeEvRT_RT0_PKc17TransferMetaFlags(i9, i11, gb + 842412 | 0, 0);
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings7SetJSONER8JSONRead(i52, i1) {
 i52 = i52 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i60 + 248 | 0;
 i54 = i60 + 240 | 0;
 i55 = i60 + 208 | 0;
 i56 = i60 + 160 | 0;
 i57 = i60 + 80 | 0;
 i58 = i60;
 i51 = __ZN8JSONRead18GetValueNodeForKeyEPKc(i1, gb + 1041415 | 0) | 0;
 if (!i51) {
  STACKTOP = i60;
  return;
 }
 if ((HEAP32[i51 + 16 >> 2] | 0) != 3) {
  STACKTOP = i60;
  return;
 }
 i12 = i52 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE(i52, HEAP32[i12 >> 2] | 0);
 i13 = i52 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i52 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 i14 = i51 + 4 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i15 = i55 + 20 | 0;
  i16 = i55 + 24 | 0;
  i17 = i55 + 4 | 0;
  i18 = i55 + 4 | 0;
  i19 = i56 + 16 | 0;
  i20 = i56 + 36 | 0;
  i21 = i56 + 40 | 0;
  i22 = i56 + 20 | 0;
  i23 = i56 + 16 | 0;
  i24 = i56 + 8 | 0;
  i25 = i56 + 8 | 0;
  i26 = i58 + 20 | 0;
  i27 = i58 + 24 | 0;
  i28 = i58 + 4 | 0;
  i29 = i58 + 4 | 0;
  i30 = i58 + 32 | 0;
  i31 = i58 + 48 | 0;
  i32 = i58 + 68 | 0;
  i33 = i58 + 72 | 0;
  i34 = i58 + 52 | 0;
  i35 = i56 + 20 | 0;
  i36 = i58 + 52 | 0;
  i37 = i57 + 20 | 0;
  i38 = i57 + 24 | 0;
  i39 = i57 + 4 | 0;
  i40 = i57 + 4 | 0;
  i41 = i57 + 32 | 0;
  i42 = i57 + 48 | 0;
  i43 = i57 + 68 | 0;
  i44 = i57 + 72 | 0;
  i45 = i57 + 52 | 0;
  i46 = i57 + 52 | 0;
  i47 = i12;
  i48 = i52 + 8 | 0;
  i49 = i53 + 4 | 0;
  i50 = i52 + 4 | 0;
  i11 = HEAP32[i51 >> 2] | 0;
  do {
   if (!(HEAP32[i11 + 16 >> 2] & 4194304)) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
   HEAP32[i55 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   i9 = gb + 63648 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i4 = i16;
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = i10;
   HEAP8[i17 >> 0] = 0;
   i4 = _strlen(i2) | 0;
   if (i4 >>> 0 > 15) {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i16, 0, gb + 1047486 | 0, 251) | 0;
    HEAP32[i55 >> 2] = i1;
    HEAP32[i18 >> 2] = i4;
    i1 = (i1 | 0) == 0 ? i17 : i1;
   } else i1 = i17;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i15 >> 2] = i4;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   i10 = gb + 63648 | 0;
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i21;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i2;
   HEAP8[i22 >> 0] = 0;
   i1 = i11 + 24 | 0;
   i2 = HEAP32[i11 + 40 >> 2] | 0;
   do if (!(i2 & 1024)) {
    if (i2 & 16384 | 0) {
     HEAP32[i56 >> 2] = 1;
     HEAPF64[i25 >> 3] = +HEAPF64[i1 >> 3];
     break;
    }
    if (i2 & 256 | 0) {
     HEAP32[i56 >> 2] = 2;
     HEAP8[i24 >> 0] = (i2 | 0) == 258 & 1;
     break;
    }
    if (i2 & 1048576) {
     HEAP32[i56 >> 2] = 3;
     if (!(i2 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
     __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i23, i1) | 0;
     i4 = HEAP32[i15 >> 2] | 0;
    }
   } else {
    HEAP32[i56 >> 2] = 0;
    HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
   } while (0);
   HEAP32[i58 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   i9 = i16;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = i27;
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i2 + 4 >> 2] = i10;
   HEAP8[i28 >> 0] = 0;
   i2 = HEAP32[i55 >> 2] | 0;
   i10 = (i2 | 0) == 0;
   i2 = i10 ? i17 : i2;
   if ((HEAP32[i18 >> 2] | 0) != 0 | i10) {
    if (i4 >>> 0 > 15) {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i27, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i58 >> 2] = i1;
     HEAP32[i29 >> 2] = i4;
     i1 = (i1 | 0) == 0 ? i28 : i1;
    } else i1 = i28;
    _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i26 >> 2] = i4;
   } else {
    HEAP32[i58 >> 2] = i2;
    HEAP32[i26 >> 2] = i4;
    HEAP32[i29 >> 2] = 0;
   };
   HEAP32[i30 >> 2] = HEAP32[i56 >> 2];
   HEAP32[i30 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
   HEAP32[i30 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
   HEAP32[i30 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
   HEAP32[i31 >> 2] = 0;
   HEAP32[i32 >> 2] = 0;
   i3 = i21;
   i10 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i33;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = i10;
   HEAP8[i34 >> 0] = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   i10 = (i2 | 0) == 0;
   i2 = i10 ? i22 : i2;
   i3 = HEAP32[i20 >> 2] | 0;
   if ((HEAP32[i35 >> 2] | 0) != 0 | i10) {
    if (i3 >>> 0 > 15) {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i33, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i31 >> 2] = i1;
     HEAP32[i36 >> 2] = i3;
     i1 = (i1 | 0) == 0 ? i34 : i1;
    } else i1 = i34;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    HEAP8[i1 + i3 >> 0] = 0;
    HEAP32[i32 >> 2] = i3;
    i4 = HEAP32[i26 >> 2] | 0;
   } else {
    HEAP32[i31 >> 2] = i2;
    HEAP32[i32 >> 2] = i3;
    HEAP32[i36 >> 2] = 0;
   }
   HEAP32[i57 >> 2] = 0;
   HEAP32[i37 >> 2] = 0;
   i9 = i27;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = i38;
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i2 + 4 >> 2] = i10;
   HEAP8[i39 >> 0] = 0;
   i2 = HEAP32[i58 >> 2] | 0;
   i10 = (i2 | 0) == 0;
   i2 = i10 ? i28 : i2;
   if ((HEAP32[i29 >> 2] | 0) != 0 | i10) {
    if (i4 >>> 0 > 15) {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i38, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i57 >> 2] = i1;
     HEAP32[i40 >> 2] = i4;
     i1 = (i1 | 0) == 0 ? i39 : i1;
    } else i1 = i39;
    _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i37 >> 2] = i4;
    i3 = HEAP32[i32 >> 2] | 0;
   } else {
    HEAP32[i57 >> 2] = i2;
    HEAP32[i37 >> 2] = i4;
    HEAP32[i40 >> 2] = 0;
   };
   HEAP32[i41 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i41 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i41 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i41 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   HEAP32[i42 >> 2] = 0;
   HEAP32[i43 >> 2] = 0;
   i9 = i33;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = i44;
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i2 + 4 >> 2] = i10;
   HEAP8[i45 >> 0] = 0;
   i2 = HEAP32[i31 >> 2] | 0;
   i10 = (i2 | 0) == 0;
   i2 = i10 ? i34 : i2;
   if ((HEAP32[i36 >> 2] | 0) != 0 | i10) {
    if (i3 >>> 0 > 15) {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i44, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i42 >> 2] = i1;
     HEAP32[i46 >> 2] = i3;
     i1 = (i1 | 0) == 0 ? i45 : i1;
    } else i1 = i45;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    HEAP8[i1 + i3 >> 0] = 0;
    HEAP32[i43 >> 2] = i3;
   } else {
    HEAP32[i42 >> 2] = i2;
    HEAP32[i43 >> 2] = i3;
    HEAP32[i46 >> 2] = 0;
   }
   i1 = HEAP32[i12 >> 2] | 0;
   do if (!i1) {
    HEAP32[i54 >> 2] = i12;
    i2 = i47;
    i3 = i12;
   } else {
    i9 = HEAP32[i37 >> 2] | 0;
    i10 = HEAP32[i57 >> 2] | 0;
    i10 = (i10 | 0) == 0 ? i39 : i10;
    while (1) {
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = HEAP32[i1 + 36 >> 2] | 0;
     i2 = i9 >>> 0 > i8 >>> 0 ? i8 : i9;
     L66 : do if (!i2) i59 = 46; else {
      i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
      i4 = i10;
      while (1) {
       i5 = HEAP8[i4 >> 0] | 0;
       i6 = HEAP8[i3 >> 0] | 0;
       if (i5 << 24 >> 24 != i6 << 24 >> 24) break;
       i2 = i2 + -1 | 0;
       if (!i2) {
        i59 = 46;
        break L66;
       } else {
        i3 = i3 + 1 | 0;
        i4 = i4 + 1 | 0;
       }
      }
      i2 = (i5 & 255) - (i6 & 255) | 0;
     } while (0);
     if ((i59 | 0) == 46) {
      i59 = 0;
      i2 = i9 - i8 | 0;
     }
     if ((i2 | 0) < 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i59 = 52;
       break;
      } else i1 = i2;
     } else {
      i2 = i8 >>> 0 > i9 >>> 0 ? i9 : i8;
      L78 : do if (!i2) i59 = 55; else {
       i6 = i10;
       i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
       while (1) {
        i4 = HEAP8[i3 >> 0] | 0;
        i5 = HEAP8[i6 >> 0] | 0;
        if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
        i2 = i2 + -1 | 0;
        if (!i2) {
         i59 = 55;
         break L78;
        } else {
         i6 = i6 + 1 | 0;
         i3 = i3 + 1 | 0;
        }
       }
       i2 = (i4 & 255) - (i5 & 255) | 0;
      } while (0);
      if ((i59 | 0) == 55) {
       i59 = 0;
       i2 = i8 - i9 | 0;
      }
      if ((i2 | 0) >= 0) {
       i59 = 63;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i59 = 62;
       break;
      } else i1 = i2;
     }
    }
    if ((i59 | 0) == 52) {
     i59 = 0;
     HEAP32[i54 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     break;
    } else if ((i59 | 0) == 62) {
     i59 = 0;
     HEAP32[i54 >> 2] = i1;
     i2 = i1;
     break;
    } else if ((i59 | 0) == 63) {
     i59 = 0;
     HEAP32[i54 >> 2] = i1;
     i2 = i1;
     i3 = i54;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = HEAP32[i48 >> 2] | 0;
    HEAP32[i53 >> 2] = 5;
    HEAP32[i49 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 16, i53, 0, gb + 1049224 | 0, 75) | 0;
    __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEC2ERKSA_(i1 + 16 | 0, i57);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i52 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i52 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i50 >> 2] | 0, i1);
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   }
   i1 = HEAP32[i42 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i46 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i44);
   i1 = HEAP32[i57 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i40 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i38);
   i1 = HEAP32[i31 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i36 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i33);
   i1 = HEAP32[i58 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i29 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
   i1 = HEAP32[i19 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i35 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
   i1 = HEAP32[i55 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i18 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
   i11 = i11 + 48 | 0;
  } while ((i11 | 0) != ((HEAP32[i51 >> 2] | 0) + ((HEAP32[i14 >> 2] | 0) * 48 | 0) | 0));
 }
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3935 | 0, 0);
 STACKTOP = i60;
 return;
}

function __ZN5physx3Ext13RevoluteJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 704 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i24 >> 2] = HEAP32[gb + 116176 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[gb + 116176 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[gb + 116176 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[gb + 116176 + 12 >> 2];
 HEAP32[i24 + 16 >> 2] = HEAP32[gb + 116176 + 16 >> 2];
 HEAP32[i24 + 20 >> 2] = HEAP32[gb + 116176 + 20 >> 2];
 HEAP32[i24 + 24 >> 2] = HEAP32[gb + 116176 + 24 >> 2];
 HEAP32[i24 + 28 >> 2] = HEAP32[gb + 116176 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = HEAP32[gb + 116208 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[gb + 116208 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[gb + 116208 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[gb + 116208 + 12 >> 2];
 HEAP32[i23 + 16 >> 2] = HEAP32[gb + 116208 + 16 >> 2];
 HEAP32[i23 + 20 >> 2] = HEAP32[gb + 116208 + 20 >> 2];
 HEAP32[i23 + 24 >> 2] = HEAP32[gb + 116208 + 24 >> 2];
 HEAP32[i23 + 28 >> 2] = HEAP32[gb + 116208 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = gb + 743909;
 HEAP32[i22 + 4 >> 2] = gb + 743927;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 136;
 HEAP32[i22 + 16 >> 2] = 0;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 1;
 HEAP32[i22 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 116240 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 116240 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 116240 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 116240 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 116240 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 116240 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 116240 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 116240 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 116272 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 116272 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 116272 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 116272 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 116272 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 116272 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 116272 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 116272 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 116304 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 116304 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 116304 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 116304 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 116304 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 116304 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 116304 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 116304 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 116336 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 116336 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 116336 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 116336 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 116336 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 116336 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 116336 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 116336 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 116368 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 116368 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 116368 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 116368 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 116368 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 116368 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 116368 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 116368 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 116400 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 116400 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 116400 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 116400 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 116400 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 116400 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 116400 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 116400 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 116432 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 116432 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 116432 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 116432 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 116432 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 116432 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 116432 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 116432 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 116464 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 116464 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 116464 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 116464 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 116464 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 116464 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 116464 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 116464 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 116496 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 116496 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 116496 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 116496 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 116496 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 116496 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 116496 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 116496 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 116528 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 116528 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 116528 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 116528 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 116528 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 116528 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 116528 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 116528 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 116560 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 116560 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 116560 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 116560 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 116560 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 116560 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 116560 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 116560 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 743937;
 HEAP32[i10 + 4 >> 2] = gb + 743901;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 84;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 743937;
 HEAP32[i9 + 4 >> 2] = gb + 829211;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 84;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 116720 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 116720 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 116720 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 116720 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 116720 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 116720 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 116720 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 116720 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_RNS3_18ImpulseAccumulatorE(i92, i1, i112, i91) {
 i92 = i92 | 0;
 i1 = i1 | 0;
 i112 = i112 | 0;
 i91 = i91 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i93 = 0, i94 = 0, i95 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0, i136 = 0;
 i132 = STACKTOP;
 STACKTOP = STACKTOP + 1808 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i121 = i132 + 1768 | 0;
 i111 = i132 + 1752 | 0;
 i2 = i132 + 1736 | 0;
 i125 = i132 + 1720 | 0;
 i4 = i132 + 1704 | 0;
 i15 = i132 + 1800 | 0;
 i102 = i132 + 1688 | 0;
 i26 = i132 + 1672 | 0;
 i37 = i132 + 1656 | 0;
 i100 = i132 + 1640 | 0;
 i48 = i132 + 1632 | 0;
 i103 = i132 + 1616 | 0;
 i59 = i132 + 1600 | 0;
 i104 = i132 + 1584 | 0;
 i70 = i132 + 1568 | 0;
 i105 = i132 + 1552 | 0;
 i79 = i132 + 1536 | 0;
 i94 = i132 + 1520 | 0;
 i85 = i132 + 1512 | 0;
 i95 = i132 + 1496 | 0;
 i96 = i132 + 1480 | 0;
 i97 = i132 + 1464 | 0;
 i122 = i132 + 1448 | 0;
 i106 = i132 + 1432 | 0;
 i5 = i132 + 1416 | 0;
 i6 = i132 + 1400 | 0;
 i7 = i132 + 1384 | 0;
 i8 = i132 + 1368 | 0;
 i113 = i132 + 1352 | 0;
 i9 = i132 + 1336 | 0;
 i10 = i132 + 1320 | 0;
 i11 = i132 + 1304 | 0;
 i12 = i132 + 1288 | 0;
 i13 = i132 + 1272 | 0;
 i14 = i132 + 1256 | 0;
 i124 = i132 + 1240 | 0;
 i16 = i132 + 1224 | 0;
 i17 = i132 + 1208 | 0;
 i18 = i132 + 1192 | 0;
 i19 = i132 + 1176 | 0;
 i20 = i132 + 1160 | 0;
 i21 = i132 + 1144 | 0;
 i93 = i132 + 1128 | 0;
 i22 = i132 + 1112 | 0;
 i23 = i132 + 1104 | 0;
 i99 = i132 + 1088 | 0;
 i101 = i132 + 1072 | 0;
 i24 = i132 + 1056 | 0;
 i25 = i132 + 1040 | 0;
 i27 = i132 + 1024 | 0;
 i28 = i132 + 1008 | 0;
 i29 = i132 + 992 | 0;
 i109 = i132 + 976 | 0;
 i98 = i132 + 960 | 0;
 i30 = i132 + 944 | 0;
 i31 = i132 + 928 | 0;
 i32 = i132 + 912 | 0;
 i108 = i132 + 896 | 0;
 i33 = i132 + 880 | 0;
 i110 = i132 + 864 | 0;
 i34 = i132 + 848 | 0;
 i35 = i132 + 832 | 0;
 i114 = i132 + 816 | 0;
 i36 = i132 + 800 | 0;
 i107 = i132 + 784 | 0;
 i120 = i132 + 768 | 0;
 i38 = i132 + 752 | 0;
 i39 = i132 + 736 | 0;
 i40 = i132 + 720 | 0;
 i41 = i132 + 704 | 0;
 i42 = i132 + 688 | 0;
 i43 = i132 + 672 | 0;
 i44 = i132 + 656 | 0;
 i45 = i132 + 640 | 0;
 i46 = i132 + 624 | 0;
 i47 = i132 + 608 | 0;
 i49 = i132 + 592 | 0;
 i50 = i132 + 576 | 0;
 i51 = i132 + 560 | 0;
 i52 = i132 + 544 | 0;
 i123 = i132 + 528 | 0;
 i53 = i132 + 512 | 0;
 i119 = i132 + 496 | 0;
 i54 = i132 + 480 | 0;
 i55 = i132 + 464 | 0;
 i56 = i132 + 448 | 0;
 i57 = i132 + 432 | 0;
 i58 = i132 + 416 | 0;
 i60 = i132 + 400 | 0;
 i115 = i132 + 384 | 0;
 i61 = i132 + 376 | 0;
 i116 = i132 + 360 | 0;
 i62 = i132 + 352 | 0;
 i117 = i132 + 336 | 0;
 i63 = i132 + 328 | 0;
 i118 = i132 + 312 | 0;
 i64 = i132 + 304 | 0;
 i126 = i132 + 288 | 0;
 i127 = i132 + 272 | 0;
 i128 = i132 + 256 | 0;
 i65 = i132 + 240 | 0;
 i66 = i132 + 224 | 0;
 i67 = i132 + 208 | 0;
 i68 = i132 + 192 | 0;
 i129 = i132 + 176 | 0;
 i69 = i132 + 160 | 0;
 i71 = i132 + 144 | 0;
 i72 = i132 + 128 | 0;
 i130 = i132 + 112 | 0;
 i73 = i132 + 96 | 0;
 i74 = i132 + 80 | 0;
 i75 = i132 + 64 | 0;
 i131 = i132 + 48 | 0;
 i76 = i132 + 32 | 0;
 i77 = i132 + 16 | 0;
 i78 = i132;
 i82 = HEAP32[i1 + 428 >> 2] | 0;
 i80 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i82) | 0;
 i81 = __ZN5physx5cloth5arrayERNS_6PxVec3E(i82 + 16 | 0) | 0;
 i82 = i82 + 32 | 0;
 i83 = i1 + 432 | 0;
 i84 = Math_fround(HEAPF32[(HEAP32[i83 >> 2] | 0) + 216 >> 2]) > Math_fround(0.0);
 __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_(i121, i1, i112);
 __ZN8Scalar4fC2ERKS_(i2, i121);
 __ZN5physx5cloth12horizontalOrE8Scalar4f(i111, i2);
 i2 = HEAP32[(__ZN5simdi5arrayER8Scalar4f(i111) | 0) >> 2] | 0;
 if (!i2) {
  i131 = i121 + 16 | 0;
  __ZN8Scalar4fC2ERKS_(i92, i131);
  STACKTOP = i132;
  return;
 }
 i86 = i112 + 16 | 0;
 i87 = i112 + 32 | 0;
 i88 = i121 + 16 | 0;
 i89 = i121 + 16 | 0;
 i90 = i1 + 416 | 0;
 i3 = i1 + 424 | 0;
 do {
  i1 = __ZN5physx5cloth10findBitSetEj(i2 & 0 - i2) | 0;
  i133 = i1 * 48 | 0;
  i2 = i2 + -1 & i2;
  __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i4, i15);
  __ZN5simdimiERK8Scalar4fS2_(i125, i111, i4);
  __ZN12_GLOBAL__N_112andNotIsZeroI8Scalar4fEET_RKS2_S4_(i26, i121, i125);
  __Z6simd4fRK8Scalar4f(i102, i26);
  __ZanRK8Scalar4fS1_(i37, i111, i125);
  __ZN8Scalar4faSERKS_(i111, i37) | 0;
  __Z11loadAlignedPKfj(i48, i80, i133);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i100, i48);
  __Z5splatILj0EE8Scalar4fRKS0_(i59, i100);
  __ZmiRK8Scalar4fS1_(i103, i112, i59);
  __Z5splatILj1EE8Scalar4fRKS0_(i70, i100);
  __ZmiRK8Scalar4fS1_(i104, i86, i70);
  __Z5splatILj2EE8Scalar4fRKS0_(i79, i100);
  __ZmiRK8Scalar4fS1_(i105, i87, i79);
  __Z11loadAlignedPKfj(i85, i81, i133);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i94, i85);
  __Z5splatILj0EE8Scalar4fRKS0_(i95, i94);
  __Z5splatILj1EE8Scalar4fRKS0_(i96, i94);
  __Z5splatILj2EE8Scalar4fRKS0_(i97, i94);
  __Z5splatILj3EE8Scalar4fRKS0_(i122, i94);
  __ZmlRK8Scalar4fS1_(i6, i103, i95);
  __ZmlRK8Scalar4fS1_(i7, i104, i96);
  __ZplRK8Scalar4fS1_(i5, i6, i7);
  __ZmlRK8Scalar4fS1_(i8, i105, i97);
  __ZplRK8Scalar4fS1_(i106, i5, i8);
  __ZmlRK8Scalar4fS1_(i9, i106, i122);
  __Z5splatILj3EE8Scalar4fRKS0_(i10, i100);
  __ZplRK8Scalar4fS1_(i113, i9, i10);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i13, gb + 1097776 | 0);
  __Z3maxRK8Scalar4fS1_(i12, i113, i13);
  __ZcoRK8Scalar4f(i14, i102);
  __ZanRK8Scalar4fRK14ComplementExprIS_E(i11, i12, i14);
  __ZN8Scalar4faSERKS_(i113, i11) | 0;
  __ZmlRK8Scalar4fS1_(i18, i103, i103);
  __ZmlRK8Scalar4fS1_(i19, i104, i104);
  __ZplRK8Scalar4fS1_(i17, i18, i19);
  __ZmlRK8Scalar4fS1_(i20, i105, i105);
  __ZplRK8Scalar4fS1_(i16, i17, i20);
  __ZmlRK8Scalar4fS1_(i21, i106, i106);
  __ZmiRK8Scalar4fS1_(i124, i16, i21);
  __Z11loadAlignedPKfj(i23, i82, i133);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i22, i23);
  __Z6simd4iRK8Scalar4f(i93, i22);
  __Z5splatILj3EE8Scalar4fRKS0_(i99, i93);
  __ZmlRK8Scalar4fS1_(i24, i113, i113);
  if (!(__Z10anyGreaterRK8Scalar4fS1_RS_(i24, i124, i101) | 0)) {
   __ZcoRK8Scalar4f(i27, i99);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i25, i88, i27);
   __ZN8Scalar4faSERKS_(i88, i25) | 0;
  } else {
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i29, gb + 1097856 | 0);
   __Z3maxRK8Scalar4fS1_(i28, i124, i29);
   __ZN8Scalar4faSERKS_(i124, i28) | 0;
   __Z5rsqrtRK8Scalar4f(i109, i124);
   __ZmlRK8Scalar4fS1_(i31, i122, i124);
   __ZmlRK8Scalar4fS1_(i30, i31, i109);
   __ZplRK8Scalar4fS1_(i98, i106, i30);
   __ZanRK8Scalar4fS1_(i32, i98, i101);
   __ZN8Scalar4faSERKS_(i98, i32) | 0;
   __Z6simd4fRK8Scalar4f(i33, i93);
   __Z5splatILj1EE8Scalar4fRKS0_(i108, i33);
   __ZngRK8Scalar4f(i35, i108);
   __ZltRK8Scalar4fS1_(i34, i98, i35);
   __Z6simd4iRK8Scalar4f(i110, i34);
   __ZgtRK8Scalar4fS1_(i36, i98, i108);
   __Z6simd4iRK8Scalar4f(i114, i36);
   __Z5splatILj2EE8Scalar4fRKS0_(i107, i93);
   __ZeoRK8Scalar4fS1_(i120, i107, i99);
   __ZcoRK8Scalar4f(i41, i110);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i40, i107, i41);
   __ZcoRK8Scalar4f(i39, i40);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i38, i89, i39);
   __ZN8Scalar4faSERKS_(i89, i38) | 0;
   __ZcoRK8Scalar4f(i45, i114);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i44, i120, i45);
   __ZcoRK8Scalar4f(i43, i44);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i42, i89, i43);
   __ZN8Scalar4faSERKS_(i89, i42) | 0;
   __ZmlRK8Scalar4fS1_(i47, i98, i95);
   __ZmiRK8Scalar4fS1_(i46, i103, i47);
   __ZN8Scalar4faSERKS_(i103, i46) | 0;
   __ZmlRK8Scalar4fS1_(i50, i98, i96);
   __ZmiRK8Scalar4fS1_(i49, i104, i50);
   __ZN8Scalar4faSERKS_(i104, i49) | 0;
   __ZmlRK8Scalar4fS1_(i52, i98, i97);
   __ZmiRK8Scalar4fS1_(i51, i105, i52);
   __ZN8Scalar4faSERKS_(i105, i51) | 0;
   __Z6simd4fRK8Scalar4f(i53, i93);
   __Z5splatILj0EE8Scalar4fRKS0_(i123, i53);
   __ZmlRK8Scalar4fS1_(i55, i113, i109);
   __ZmlRK8Scalar4fS1_(i54, i55, i123);
   __ZmiRK8Scalar4fS1_(i119, i54, i123);
   __ZorRK8Scalar4fS1_(i60, i110, i114);
   __Z6simd4fRK8Scalar4f(i58, i60);
   __ZcoRK8Scalar4f(i57, i58);
   __ZanRK8Scalar4fRK14ComplementExprIS_E(i56, i101, i57);
   __ZN8Scalar4faSERKS_(i101, i56) | 0;
   if (__Z7anyTrueRK8Scalar4f(i101) | 0) {
    __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator3addERKS2_S6_S6_S6_S6_(i91, i103, i104, i105, i119, i101);
    if (i84) {
     i136 = HEAP32[(HEAP32[i83 >> 2] | 0) + 156 >> 2] | 0;
     i133 = HEAP32[i136 + (i1 << 3) + 4 >> 2] | 0;
     i135 = HEAP32[i90 >> 2] | 0;
     i134 = HEAP32[i3 >> 2] | 0;
     i1 = HEAP32[i136 + (i1 << 3) >> 2] << 4;
     __Z11loadAlignedPKfj(i61, i135, i1);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i115, i61);
     __Z11loadAlignedPKfj(i62, i134, i1);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i116, i62);
     i133 = i133 << 4;
     __Z11loadAlignedPKfj(i63, i135, i133);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i117, i63);
     __Z11loadAlignedPKfj(i64, i134, i133);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i118, i64);
     __ZmiRK8Scalar4fS1_(i126, i116, i115);
     __ZmiRK8Scalar4fS1_(i127, i118, i117);
     __ZmiRK8Scalar4fS1_(i128, i127, i126);
     __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i67, gb + 1097728 | 0);
     __ZmlRK8Scalar4fS1_(i66, i106, i67);
     __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i68, gb + 1097728 | 0);
     __ZplRK8Scalar4fS1_(i65, i66, i68);
     __ZN8Scalar4faSERKS_(i106, i65) | 0;
     __Z5splatILj0EE8Scalar4fRKS0_(i69, i126);
     __Z5splatILj0EE8Scalar4fRKS0_(i72, i128);
     __ZmlRK8Scalar4fS1_(i71, i106, i72);
     __ZplRK8Scalar4fS1_(i129, i69, i71);
     __Z5splatILj1EE8Scalar4fRKS0_(i73, i126);
     __Z5splatILj1EE8Scalar4fRKS0_(i75, i128);
     __ZmlRK8Scalar4fS1_(i74, i106, i75);
     __ZplRK8Scalar4fS1_(i130, i73, i74);
     __Z5splatILj2EE8Scalar4fRKS0_(i76, i126);
     __Z5splatILj2EE8Scalar4fRKS0_(i78, i128);
     __ZmlRK8Scalar4fS1_(i77, i106, i78);
     __ZplRK8Scalar4fS1_(i131, i76, i77);
     __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_(i91, i129, i130, i131, i101);
    }
   }
  }
 } while ((i2 | 0) != 0);
 i136 = i121 + 16 | 0;
 __ZN8Scalar4fC2ERKS_(i92, i136);
 STACKTOP = i132;
 return;
}

function __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j(i12, i15, i16) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 24 | 0;
 i14 = i17;
 i10 = i17 + 32 | 0;
 __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE22handleGeometryPropertyERKNS_23PxShapeGeometryPropertyE(i15, i12 + 12 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i12 + 24 | 0, i16 + 2 | 0);
 i6 = HEAP32[i12 + 48 >> 2] | 0;
 i5 = HEAP32[i12 + 40 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i15 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i13;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 i7 = i15 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i8 = i15 + 8 | 0;
 mftCall_vii(i6 | 0, i10 | 0, HEAP32[i8 >> 2] | 0);
 i11 = i15 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i9 = i15 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i4, i14) | 0;
 HEAP8[i13 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i13 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 64 >> 2] | 0;
 i5 = HEAP32[i12 + 56 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i15 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i18 = i13;
  i4 = HEAP32[i18 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(i6 | 0, i10 | 0, HEAP32[i8 >> 2] | 0);
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i3, i14) | 0;
 HEAP8[i13 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i13 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclERKNS_24PxShapeMaterialsPropertyEj(i15, i12 + 72 | 0, i16 + 5 | 0);
 i5 = i12 + 88 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i1 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i18 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i18 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj120ENS_22PxRepXPropertyAccessorILj120ES4_ffEEEEvRKT0_(i15, i14);
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i15 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i12 + 104 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i18 = i14 + 8 | 0;
 HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i15 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i18 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i18 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj121ENS_22PxRepXPropertyAccessorILj121ES4_ffEEEEvRKT0_(i15, i14);
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj122ES3_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i12 + 120 | 0, i16 + 8 | 0);
 i5 = i12 + 148 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i1 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i13;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i18 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i18 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj124ENS_22PxRepXPropertyAccessorILj124ES4_PKcSA_EEEEvRKT0_(i15, i14);
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i18 = i16 + 13 | 0;
  STACKTOP = i17;
  return i18 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i18 = i16 + 13 | 0;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZN15DetailPrototype8TransferI14SafeBinaryReadEEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932534 | 0, gb + 932544 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i9, i6); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i9 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932561 | 0, gb + 1034905 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 8 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932578 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932587 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932596 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i6 + 16 | 0;
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   i3 = i1 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i1 >>> 0) i10 = 40; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i10 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932606 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 51; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 51; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932616 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 62; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 62; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 62) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932628 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 73; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 73; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 73) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i9 + 32 | 0;
 i3 = HEAP32[gb + 36980 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932639 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i9 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932652 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932661 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i5 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i10 = 96; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 96; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 96) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 68 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932676 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i10 = 107; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 107; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 107) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i9 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932687 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i5 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i10 = 118; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i10 = 118; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i10 | 0) == 118) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i6, 1) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 131; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 131; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i10 = 133;
  }
  if ((i10 | 0) == 131) i10 = 133;
  if ((i10 | 0) == 133) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0)) break;
  HEAP32[i4 >> 2] = 1;
  STACKTOP = i11;
  return;
 } while (0);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE(i14, i12, i1, i13) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 60 | 0;
 i11 = i15;
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f3 = Math_fround(Math_fround(f6 + f16) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f7 + f2) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f8 + f9) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f16 - f6) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f2 - f7) * Math_fround(.5));
 f8 = Math_fround(Math_fround(f9 - f8) * Math_fround(.5));
 i1 = i12 + 4 | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 if (f9 == Math_fround(1.0)) {
  f2 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  if (f2 == Math_fround(1.0)) if (Math_fround(HEAPF32[i12 + 12 >> 2]) == Math_fround(1.0)) {
   f24 = Math_fround(HEAPF32[i13 >> 2]);
   f16 = Math_fround(f24 + f24);
   f9 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f20 = Math_fround(f9 + f9);
   f17 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f25 = Math_fround(f17 + f17);
   f26 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f22 = Math_fround(f16 * f26);
   f23 = Math_fround(f20 * f26);
   f26 = Math_fround(f26 * f25);
   f18 = Math_fround(f24 * f20);
   f2 = Math_fround(f24 * f25);
   f20 = Math_fround(f9 * f20);
   f9 = Math_fround(f9 * f25);
   f25 = Math_fround(f17 * f25);
   f17 = Math_fround(Math_fround(Math_fround(1.0) - f20) - f25);
   f21 = Math_fround(f18 + f26);
   f19 = Math_fround(f2 - f23);
   f26 = Math_fround(f18 - f26);
   f16 = Math_fround(Math_fround(1.0) - Math_fround(f24 * f16));
   f25 = Math_fround(f16 - f25);
   f24 = Math_fround(f9 + f22);
   f23 = Math_fround(f2 + f23);
   f22 = Math_fround(f9 - f22);
   f20 = Math_fround(f16 - f20);
   f16 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f9 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f2 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   HEAPF32[i14 + 48 >> 2] = f6;
   HEAPF32[i14 + 52 >> 2] = f7;
   HEAPF32[i14 + 56 >> 2] = f8;
   f9 = Math_fround(f9 + Math_fround(Math_fround(f5 * f22) + Math_fround(Math_fround(f3 * f21) + Math_fround(f4 * f25))));
   f2 = Math_fround(f2 + Math_fround(Math_fround(f5 * f20) + Math_fround(Math_fround(f3 * f19) + Math_fround(f4 * f24))));
   HEAPF32[i14 + 36 >> 2] = Math_fround(f16 + Math_fround(Math_fround(f5 * f23) + Math_fround(Math_fround(f3 * f17) + Math_fround(f4 * f26))));
   HEAPF32[i14 + 40 >> 2] = f9;
   HEAPF32[i14 + 44 >> 2] = f2;
   f2 = Math_fround(f26 * Math_fround(0.0));
   f9 = Math_fround(f25 * Math_fround(0.0));
   f16 = Math_fround(f24 * Math_fround(0.0));
   f18 = Math_fround(f23 * Math_fround(0.0));
   f6 = Math_fround(f22 * Math_fround(0.0));
   f7 = Math_fround(f20 * Math_fround(0.0));
   f3 = Math_fround(f6 + Math_fround(f21 + f9));
   f4 = Math_fround(f7 + Math_fround(f19 + f16));
   f8 = Math_fround(f17 * Math_fround(0.0));
   f21 = Math_fround(f21 * Math_fround(0.0));
   f19 = Math_fround(f19 * Math_fround(0.0));
   f5 = Math_fround(f18 + Math_fround(f26 + f8));
   f6 = Math_fround(f6 + Math_fround(f25 + f21));
   f7 = Math_fround(f7 + Math_fround(f24 + f19));
   f8 = Math_fround(f23 + Math_fround(f8 + f2));
   f9 = Math_fround(f22 + Math_fround(f21 + f9));
   f16 = Math_fround(f20 + Math_fround(f19 + f16));
   HEAPF32[i14 >> 2] = Math_fround(f18 + Math_fround(f17 + f2));
   HEAPF32[i14 + 4 >> 2] = f3;
   HEAPF32[i14 + 8 >> 2] = f4;
   HEAPF32[i14 + 12 >> 2] = f5;
   HEAPF32[i14 + 16 >> 2] = f6;
   HEAPF32[i14 + 20 >> 2] = f7;
   HEAPF32[i14 + 24 >> 2] = f8;
   HEAPF32[i14 + 28 >> 2] = f9;
   HEAPF32[i14 + 32 >> 2] = f16;
   STACKTOP = i15;
   return;
  } else f2 = Math_fround(1.0);
 } else f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i13 >> 2]);
 f50 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f47 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f41 = Math_fround(f21 + f21);
 f40 = Math_fround(f50 + f50);
 f39 = Math_fround(f47 + f47);
 f35 = Math_fround(f50 * f40);
 f16 = Math_fround(f47 * f39);
 f50 = Math_fround(f41 * f50);
 f46 = Math_fround(f41 * f47);
 f38 = Math_fround(f41 * f22);
 f47 = Math_fround(f40 * f47);
 f40 = Math_fround(f40 * f22);
 f22 = Math_fround(f39 * f22);
 f39 = Math_fround(Math_fround(Math_fround(1.0) - f35) - f16);
 f37 = Math_fround(f50 + f22);
 f18 = Math_fround(f46 - f40);
 f22 = Math_fround(f50 - f22);
 f41 = Math_fround(Math_fround(1.0) - Math_fround(f21 * f41));
 f16 = Math_fround(f41 - f16);
 f21 = Math_fround(f47 + f38);
 f40 = Math_fround(f46 + f40);
 f38 = Math_fround(f47 - f38);
 f35 = Math_fround(f41 - f35);
 f41 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f47 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f46 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f50 = Math_fround(HEAPF32[i12 + 28 >> 2]);
 f48 = Math_fround(f41 + f41);
 f44 = Math_fround(f47 + f47);
 f51 = Math_fround(f46 + f46);
 f23 = Math_fround(f47 * f44);
 f49 = Math_fround(f46 * f51);
 f47 = Math_fround(f48 * f47);
 f43 = Math_fround(f48 * f46);
 f42 = Math_fround(f48 * f50);
 f46 = Math_fround(f44 * f46);
 f44 = Math_fround(f44 * f50);
 f50 = Math_fround(f51 * f50);
 f51 = Math_fround(Math_fround(Math_fround(1.0) - f23) - f49);
 f26 = Math_fround(f47 + f50);
 f25 = Math_fround(f43 - f44);
 f50 = Math_fround(f47 - f50);
 f48 = Math_fround(Math_fround(1.0) - Math_fround(f41 * f48));
 f49 = Math_fround(f48 - f49);
 f41 = Math_fround(f46 + f42);
 f44 = Math_fround(f43 + f44);
 f42 = Math_fround(f46 - f42);
 f23 = Math_fround(f48 - f23);
 f48 = Math_fround(f9 * f51);
 f46 = Math_fround(f9 * f50);
 f43 = Math_fround(f9 * f44);
 f47 = Math_fround(f26 * f2);
 f45 = Math_fround(f49 * f2);
 f17 = Math_fround(f42 * f2);
 f36 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f25 * f36);
 f19 = Math_fround(f41 * f36);
 f36 = Math_fround(f23 * f36);
 f24 = Math_fround(Math_fround(Math_fround(f51 * f48) + Math_fround(f26 * f47)) + Math_fround(f25 * f9));
 f20 = Math_fround(Math_fround(Math_fround(f51 * f46) + Math_fround(f26 * f45)) + Math_fround(f25 * f19));
 f25 = Math_fround(Math_fround(Math_fround(f51 * f43) + Math_fround(f26 * f17)) + Math_fround(f25 * f36));
 f2 = Math_fround(Math_fround(Math_fround(f50 * f48) + Math_fround(f49 * f47)) + Math_fround(f41 * f9));
 f26 = Math_fround(Math_fround(Math_fround(f50 * f46) + Math_fround(f49 * f45)) + Math_fround(f41 * f19));
 f41 = Math_fround(Math_fround(Math_fround(f50 * f43) + Math_fround(f49 * f17)) + Math_fround(f41 * f36));
 f9 = Math_fround(Math_fround(Math_fround(f44 * f48) + Math_fround(f42 * f47)) + Math_fround(f23 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f44 * f46) + Math_fround(f42 * f45)) + Math_fround(f23 * f19));
 f36 = Math_fround(Math_fround(Math_fround(f44 * f43) + Math_fround(f42 * f17)) + Math_fround(f23 * f36));
 f23 = Math_fround(Math_fround(f40 * f25) + Math_fround(Math_fround(f39 * f24) + Math_fround(f22 * f20)));
 f17 = Math_fround(Math_fround(f38 * f25) + Math_fround(Math_fround(f37 * f24) + Math_fround(f16 * f20)));
 f20 = Math_fround(Math_fround(f35 * f25) + Math_fround(Math_fround(f18 * f24) + Math_fround(f21 * f20)));
 f24 = Math_fround(Math_fround(f40 * f41) + Math_fround(Math_fround(f39 * f2) + Math_fround(f22 * f26)));
 f25 = Math_fround(Math_fround(f38 * f41) + Math_fround(Math_fround(f37 * f2) + Math_fround(f16 * f26)));
 f26 = Math_fround(Math_fround(f35 * f41) + Math_fround(Math_fround(f18 * f2) + Math_fround(f21 * f26)));
 f22 = Math_fround(Math_fround(f40 * f36) + Math_fround(Math_fround(f39 * f9) + Math_fround(f22 * f19)));
 f16 = Math_fround(Math_fround(f38 * f36) + Math_fround(Math_fround(f37 * f9) + Math_fround(f16 * f19)));
 f19 = Math_fround(Math_fround(f35 * f36) + Math_fround(Math_fround(f18 * f9) + Math_fround(f21 * f19)));
 f21 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 f18 = Math_fround(HEAPF32[i13 + 24 >> 2]);
 f36 = Math_fround(f6 * Math_fround(0.0));
 f2 = Math_fround(Math_fround(f36 * f16) + Math_fround(Math_fround(f6 * f17) + Math_fround(f36 * f25)));
 f35 = Math_fround(Math_fround(f36 * f19) + Math_fround(Math_fround(f6 * f20) + Math_fround(f36 * f26)));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f36 * f22) + Math_fround(Math_fround(f6 * f23) + Math_fround(f36 * f24)));
 i34 = i11 + 4 | 0;
 HEAPF32[i34 >> 2] = f2;
 i33 = i11 + 8 | 0;
 HEAPF32[i33 >> 2] = f35;
 f35 = Math_fround(f7 * Math_fround(0.0));
 f6 = Math_fround(Math_fround(f35 * f16) + Math_fround(Math_fround(f35 * f17) + Math_fround(f7 * f25)));
 f2 = Math_fround(Math_fround(f35 * f19) + Math_fround(Math_fround(f35 * f20) + Math_fround(f7 * f26)));
 HEAPF32[i11 + 12 >> 2] = Math_fround(Math_fround(f35 * f22) + Math_fround(Math_fround(f35 * f23) + Math_fround(f7 * f24)));
 i32 = i11 + 16 | 0;
 HEAPF32[i32 >> 2] = f6;
 i31 = i11 + 20 | 0;
 HEAPF32[i31 >> 2] = f2;
 f2 = Math_fround(f8 * Math_fround(0.0));
 f6 = Math_fround(Math_fround(f8 * f16) + Math_fround(Math_fround(f2 * f17) + Math_fround(f2 * f25)));
 f7 = Math_fround(Math_fround(f8 * f19) + Math_fround(Math_fround(f2 * f20) + Math_fround(f2 * f26)));
 HEAPF32[i11 + 24 >> 2] = Math_fround(Math_fround(f8 * f22) + Math_fround(Math_fround(f2 * f23) + Math_fround(f2 * f24)));
 i30 = i11 + 28 | 0;
 HEAPF32[i30 >> 2] = f6;
 i29 = i11 + 32 | 0;
 HEAPF32[i29 >> 2] = f7;
 f25 = Math_fround(f9 + Math_fround(Math_fround(f5 * f16) + Math_fround(Math_fround(f3 * f17) + Math_fround(f4 * f25))));
 f26 = Math_fround(f18 + Math_fround(Math_fround(f5 * f19) + Math_fround(Math_fround(f3 * f20) + Math_fround(f4 * f26))));
 HEAPF32[i11 + 36 >> 2] = Math_fround(f21 + Math_fround(Math_fround(f5 * f22) + Math_fround(Math_fround(f3 * f23) + Math_fround(f4 * f24))));
 i28 = i11 + 40 | 0;
 HEAPF32[i28 >> 2] = f25;
 i27 = i11 + 44 | 0;
 HEAPF32[i27 >> 2] = f26;
 __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E(i10, i11);
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 + 48 >> 2] = i1;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i11 + 52 >> 2] = i12;
 i13 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i11 + 56 >> 2] = i13;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i14 + 32 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i14 + 36 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i14 + 40 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i14 + 44 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i14 + 48 >> 2] = i1;
 HEAP32[i14 + 52 >> 2] = i12;
 HEAP32[i14 + 56 >> 2] = i13;
 STACKTOP = i15;
 return;
}

function __ZN30EmissionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 614866 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614866 + 34 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614901 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614901 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614940 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614940 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614960 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614960 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614980 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614980 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615e3 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615e3 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 5;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615020 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615020 + 22 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 6;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615043 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615043 + 22 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 7;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615066 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615066 + 22 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615089 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615089 + 22 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615112 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615112 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 10;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615133 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615133 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 11;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615154 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615154 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 12;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615175 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615175 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 13;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615196 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615196 + 27 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 14;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN7mecanim5human5Human8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3 + 144 | 0;
 i7 = i3 + 72 | 0;
 i10 = i3 + 60 | 0;
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906072 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i11 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i11, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i11, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906080 | 0, gb + 905830 | 0, i1 + 40 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i2, i9, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906091 | 0, gb + 905830 | 0, i1 + 44 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i2, i9, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906106 | 0, gb + 905830 | 0, i1 + 48 | 0, 0);
 __ZN7mecanim4hand4HandC2Ev(i6);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 906465 | 0, i6, 0);
 HEAP32[i10 >> 2] = 15;
 HEAP32[i10 + 4 >> 2] = i6;
 i11 = HEAP32[gb + 37256 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906470 | 0, i11, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906117 | 0, gb + 905830 | 0, i1 + 52 | 0, 0);
 __ZN7mecanim4hand4HandC2Ev(i6);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 906465 | 0, i6, 0);
 HEAP32[i10 >> 2] = 15;
 HEAP32[i10 + 4 >> 2] = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906470 | 0, i11, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i2 + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i1 + 60;
 HEAP32[i10 + 4 >> 2] = i1 + 56;
 HEAP32[i10 + 8 >> 2] = i11;
 i11 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906129 | 0, i11, i10, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1065353216;
 HEAP32[i7 + 28 >> 2] = 1065353216;
 HEAP32[i7 + 32 >> 2] = 1065353216;
 HEAP32[i7 + 36 >> 2] = 1065353216;
 HEAP32[i7 + 40 >> 2] = -1;
 HEAP32[i7 + 44 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 906439 | 0, i7, 0);
 __ZN7mecanim5human6Handle8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i1 + 68;
 HEAP32[i10 + 4 >> 2] = i1 + 64;
 HEAP32[i10 + 8 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906139 | 0, i11, i10, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1065353216;
 HEAP32[i7 + 28 >> 2] = 1065353216;
 HEAP32[i7 + 32 >> 2] = 1065353216;
 HEAP32[i7 + 36 >> 2] = 1065353216;
 HEAP32[i7 + 40 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 906336 | 0, i7, 0);
 __ZN4math8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i10 >> 2] = 24;
 HEAP32[i10 + 4 >> 2] = i1 + 72;
 i11 = HEAP32[gb + 37256 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906155 | 0, i11, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i10 >> 2] = 24;
 HEAP32[i10 + 4 >> 2] = i1 + 168;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906172 | 0, i11, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i10 >> 2] = 24;
 HEAP32[i10 + 4 >> 2] = i1 + 264;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906188 | 0, i11, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932253 | 0, i6, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906204 | 0, i6, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906215 | 0, i6, i1 + 368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906230 | 0, i6, i1 + 372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906246 | 0, i6, i1 + 376 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906257 | 0, i6, i1 + 380 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906270 | 0, i6, i1 + 384 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906283 | 0, i6, i1 + 388 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906297 | 0, i6, i1 + 392 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906311 | 0, i6, i1 + 393 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906326 | 0, i6, i1 + 394 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx15PxSerialization26createCollectionFromBinaryEPvRNS_23PxSerializationRegistryEPKNS_12PxCollectionE(i11, i24, i20) {
 i11 = i11 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i33 + 24 | 0;
 i9 = i33 + 16 | 0;
 i8 = i33 + 8 | 0;
 i2 = i33;
 i30 = i33 + 112 | 0;
 i22 = i33 + 64 | 0;
 i32 = i33 + 72 | 0;
 i23 = i33 + 32 | 0;
 i31 = i33 + 28 | 0;
 i18 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = 0 - (i11 + 24) & 15;
 i21 = HEAP32[i11 + (i10 + 24) >> 2] | 0;
 i10 = i10 + 28 | 0;
 i10 = (0 - (i11 + i10) & 15) + i10 | 0;
 i17 = HEAP32[i11 + i10 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i29 = i17 | 0 ? i11 + i10 | 0 : 0;
 i10 = (i17 << 3) + i10 | 0;
 i17 = HEAP32[i11 + i10 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i10 = (0 - (i11 + i10) & 15) + i10 | 0;
 i6 = HEAP32[i11 + i10 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i19 = i6 | 0 ? i11 + i10 | 0 : 0;
 i10 = i10 + (i6 << 4) | 0;
 i7 = i11 + i10 | 0;
 HEAP32[i22 >> 2] = i7;
 i1 = (i6 | 0) == 0;
 L1 : do if (!i20) {
  if (!i1) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 755321 | 0, 91, gb + 755437 | 0, i2);
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  }
 } else if (!i1) {
  i5 = 0;
  while (1) {
   i1 = i19 + (i5 << 4) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = HEAP16[i19 + (i5 << 4) + 8 >> 1] | 0;
   i4 = mftCall_iiii(HEAP32[(HEAP32[i20 >> 2] | 0) + 40 >> 2] | 0, i20 | 0, i3 | 0, i1 | 0) | 0;
   if (!i4) {
    i2 = i3;
    i28 = 8;
    break;
   }
   i1 = i4 + 4 | 0;
   i5 = i5 + 1 | 0;
   if ((HEAP16[i1 >> 1] | 0) != i2 << 16 >> 16) {
    i28 = 10;
    break;
   }
   if (i5 >>> 0 >= i6 >>> 0) break L1;
  }
  if ((i28 | 0) == 8) {
   i32 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i31 = i8;
   HEAP32[i31 >> 2] = i2;
   HEAP32[i31 + 4 >> 2] = i1;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i32, 4, gb + 755321 | 0, 105, gb + 755551 | 0, i8);
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  } else if ((i28 | 0) == 10) {
   i32 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i31 = HEAPU16[i1 >> 1] | 0;
   HEAP32[i9 >> 2] = i2 & 65535;
   HEAP32[i9 + 4 >> 2] = i31;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i32, 4, gb + 755321 | 0, 110, gb + 755671 | 0, i9);
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i1 = 0 - i7 & 15;
 i25 = HEAP32[i11 + (i10 + i1) >> 2] | 0;
 i1 = i1 + 4 | 0;
 i14 = (i25 | 0) != 0;
 i26 = i14 ? i11 + (i10 + i1) | 0 : 0;
 i1 = i1 + (i25 << 4) | 0;
 i1 = (0 - (i11 + (i10 + i1)) & 15) + i1 | 0;
 i6 = HEAP32[i11 + (i10 + i1) >> 2] | 0;
 i1 = i1 + 4 | 0;
 i7 = i6 | 0 ? i11 + (i10 + i1) | 0 : 0;
 i1 = i1 + (i6 * 12 | 0) | 0;
 i12 = HEAP32[i11 + (i10 + i1) >> 2] | 0;
 i1 = i1 + 4 | 0;
 i13 = i12 | 0 ? i11 + (i10 + i1) | 0 : 0;
 HEAP32[i22 >> 2] = i11 + (i10 + (i1 + (i12 * 12 | 0)));
 i1 = ~~Math_fround(Math_fround((i6 + 1 + i12 | 0) >>> 0) * Math_fround(1.33333337)) >>> 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = 0;
 HEAP32[i32 + 16 >> 2] = 0;
 HEAP32[i32 + 20 >> 2] = 0;
 HEAPF32[i32 + 24 >> 2] = Math_fround(.75);
 i8 = i32 + 28 | 0;
 HEAP32[i8 >> 2] = -1;
 i9 = i32 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i32 + 36 | 0;
 HEAP32[i10 >> 2] = 0;
 if (i1 | 0) __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i32, i1);
 if (i6 | 0) {
  i1 = i32 + 20 | 0;
  i2 = HEAP32[i32 + 12 >> 2] | 0;
  i3 = HEAP32[i32 + 8 >> 2] | 0;
  i4 = HEAP32[i32 + 4 >> 2] | 0;
  i5 = 0;
  do {
   i34 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
   i11 = HEAP32[i7 + (i5 * 12 | 0) + 4 >> 2] | 0;
   i15 = HEAP32[i7 + (i5 * 12 | 0) + 8 >> 2] | 0;
   i16 = i11 + ~(i11 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i35 = i34 + ~(i34 << 15) | 0;
   i35 = (i35 >>> 10 ^ i35) * 9 | 0;
   i35 = i35 >>> 6 ^ i35;
   i35 = i35 + ~(i35 << 11) | 0;
   i35 = (i16 >>> 16 ^ i16 ^ (i35 ^ -57320555 ^ i35 >>> 16) * 1000007) & (HEAP32[i1 >> 2] | 0) + -1;
   i16 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i16 + 1;
   i35 = i2 + (i35 << 2) | 0;
   HEAP32[i3 + (i16 << 2) >> 2] = HEAP32[i35 >> 2];
   HEAP32[i35 >> 2] = i16;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   HEAP32[i4 + (i16 * 12 | 0) >> 2] = i34;
   HEAP32[i4 + (i16 * 12 | 0) + 4 >> 2] = i11;
   HEAP32[i4 + (i16 * 12 | 0) + 8 >> 2] = i15;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 if (i12 | 0) {
  i1 = i32 + 20 | 0;
  i2 = HEAP32[i32 + 12 >> 2] | 0;
  i3 = HEAP32[i32 + 8 >> 2] | 0;
  i4 = HEAP32[i32 + 4 >> 2] | 0;
  i5 = 0;
  do {
   i15 = HEAP32[i13 + (i5 * 12 | 0) >> 2] | 0;
   i16 = HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2] | 0;
   i34 = HEAP32[i13 + (i5 * 12 | 0) + 8 >> 2] | 0;
   i35 = i16 + ~(i16 << 15) | 0;
   i35 = (i35 >>> 10 ^ i35) * 9 | 0;
   i35 = i35 >>> 6 ^ i35;
   i35 = i35 + ~(i35 << 11) | 0;
   i11 = i15 + ~(i15 << 15) | 0;
   i11 = (i11 >>> 10 ^ i11) * 9 | 0;
   i11 = i11 >>> 6 ^ i11;
   i11 = i11 + ~(i11 << 11) | 0;
   i11 = (i35 >>> 16 ^ i35 ^ (i11 ^ -57320555 ^ i11 >>> 16) * 1000007) & (HEAP32[i1 >> 2] | 0) + -1;
   i35 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i35 + 1;
   i11 = i2 + (i11 << 2) | 0;
   HEAP32[i3 + (i35 << 2) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i35;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   HEAP32[i4 + (i35 * 12 | 0) >> 2] = i15;
   HEAP32[i4 + (i35 * 12 | 0) + 4 >> 2] = i16;
   HEAP32[i4 + (i35 * 12 | 0) + 8 >> 2] = i34;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i12 | 0));
 }
 i2 = __Z18PxCreateCollectionv() | 0;
 i16 = i2 + 44 | 0;
 i1 = (~~Math_fround(Math_fround(i21 >>> 0) * Math_fround(1.33333337)) >>> 0) + 1 | 0;
 i13 = i2 + 64 | 0;
 if ((HEAP32[i13 >> 2] | 0) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i16, i1);
 if (i14) {
  i1 = (~~Math_fround(Math_fround(i25 >>> 0) * Math_fround(1.33333337)) >>> 0) + 1 | 0;
  if ((HEAP32[i2 + 24 >> 2] | 0) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i2 + 4 | 0, i1);
 }
 i14 = HEAP32[i22 >> 2] | 0;
 i15 = 0 - i14 & 15;
 i3 = i15 + i17 | 0;
 i3 = i14 + ((0 - (i14 + i3) & 15) + i3) | 0;
 HEAP32[i23 >> 2] = gb + 89200 + 8;
 HEAP32[i23 + 8 >> 2] = i29;
 HEAP32[i23 + 12 >> 2] = i19;
 HEAP32[i23 + 16 >> 2] = i14 + i15;
 HEAP32[i23 + 20 >> 2] = i32;
 HEAP32[i23 + 24 >> 2] = i20;
 HEAP32[i23 + 28 >> 2] = i18;
 i6 = i23 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 L37 : do if (!i21) i28 = 26; else {
  i7 = i2 + 72 | 0;
  i8 = i2 + 56 | 0;
  i9 = i2 + 52 | 0;
  i10 = i2 + 80 | 0;
  i11 = i2 + 76 | 0;
  i12 = i2 + 48 | 0;
  i1 = i21;
  i5 = i14;
  while (1) {
   i4 = i1 + -1 | 0;
   i1 = 0 - i5 & 15;
   HEAP32[i22 >> 2] = i5 + i1;
   HEAP32[i6 >> 2] = i3 + 15 & -16;
   i1 = HEAP16[i5 + (i1 + 4) >> 1] | 0;
   i3 = mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0) | 0;
   i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i22 | 0, i23 | 0) | 0;
   if (!i3) break;
   i21 = i3;
   i34 = i21 + ~(i21 << 15) | 0;
   i34 = (i34 >>> 10 ^ i34) * 9 | 0;
   i34 = i34 >>> 6 ^ i34;
   i34 = i34 + ~(i34 << 11) | 0;
   i34 = (HEAP32[i13 >> 2] | 0) + -1 & (i34 >>> 16 ^ i34);
   i35 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i35 + 1;
   i34 = (HEAP32[i8 >> 2] | 0) + (i34 << 2) | 0;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i35 << 2) >> 2] = HEAP32[i34 >> 2];
   HEAP32[i34 >> 2] = i35;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i34 = HEAP32[i12 >> 2] | 0;
   HEAP32[i34 + (i35 << 4) >> 2] = i21;
   i35 = i34 + (i35 << 4) + 8 | 0;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   if (!i4) {
    i28 = 26;
    break L37;
   }
   i1 = i4;
   i5 = HEAP32[i22 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
  }
  i35 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i27 >> 2] = i1 & 65535;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i35, 4, gb + 755321 | 0, 247, gb + 755806 | 0, i27);
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
  i2 = 0;
 } while (0);
 if ((i28 | 0) == 26) {
  if (i25 | 0) {
   i4 = i2 + 24 | 0;
   i5 = i2 + 32 | 0;
   i6 = i2 + 16 | 0;
   i7 = i2 + 12 | 0;
   i8 = i2 + 40 | 0;
   i9 = i2 + 36 | 0;
   i10 = i2 + 8 | 0;
   i13 = 0;
   do {
    i1 = i14 + ((HEAP32[i29 + ((HEAP32[i26 + (i13 << 4) + 8 >> 2] & 2147483647) << 3) >> 2] | 0) + i15) | 0;
    HEAP32[i31 >> 2] = i1;
    i35 = HEAP32[i4 >> 2] | 0;
    i12 = i26 + (i13 << 4) | 0;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i34 = _i64Add(i11 | 0, i12 | 0, -1, ~i11 | 0) | 0;
    i28 = getTempRet0() | 0;
    i3 = _bitshift64Lshr(i34 | 0, i28 | 0, 22) | 0;
    i34 = i3 ^ i34;
    i28 = (getTempRet0() | 0) ^ i28;
    i3 = _bitshift64Shl(i34 | 0, i28 | 0, 13) | 0;
    i3 = _i64Add(i34 | 0, i28 | 0, ~i3 | 0, ~(getTempRet0() | 0) | 0) | 0;
    i28 = getTempRet0() | 0;
    i34 = _bitshift64Lshr(i3 | 0, i28 | 0, 8) | 0;
    i28 = ___muldi3(i34 ^ i3 | 0, (getTempRet0() | 0) ^ i28 | 0, 9, 0) | 0;
    i3 = getTempRet0() | 0;
    i34 = _bitshift64Lshr(i28 | 0, i3 | 0, 15) | 0;
    i28 = i34 ^ i28;
    i3 = (getTempRet0() | 0) ^ i3;
    i34 = _bitshift64Shl(i28 | 0, i3 | 0, 27) | 0;
    i34 = _i64Add(i28 | 0, i3 | 0, ~i34 | 0, ~(getTempRet0() | 0) | 0) | 0;
    i3 = getTempRet0() | 0;
    i28 = _bitshift64Lshr(i34 | 0, i3 | 0, 31) | 0;
    (getTempRet0() | 0) ^ i3;
    i3 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i3 + 1;
    i35 = (HEAP32[i6 >> 2] | 0) + (((i28 ^ i34) & i35 + -1) << 2) | 0;
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i35 >> 2];
    HEAP32[i35 >> 2] = i3;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i35 = HEAP32[i10 >> 2] | 0;
    i34 = i35 + (i3 << 4) | 0;
    HEAP32[i34 >> 2] = i11;
    HEAP32[i34 + 4 >> 2] = i12;
    HEAP32[i35 + (i3 << 4) + 8 >> 2] = i1;
    i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i16, i31, i30) | 0;
    if (!(HEAP8[i30 >> 0] | 0)) {
     HEAP32[i3 >> 2] = i1;
     i1 = i3 + 8 | 0;
     i35 = i1;
     HEAP32[i35 >> 2] = 0;
     HEAP32[i35 + 4 >> 2] = 0;
    } else i1 = i3 + 8 | 0;
    i35 = i1;
    HEAP32[i35 >> 2] = i11;
    HEAP32[i35 + 4 >> 2] = i12;
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) != (i25 | 0));
  }
  _PxAddCollectionToPhysics(i2);
 }
 i1 = HEAP32[i32 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
 i35 = i2;
 STACKTOP = i33;
 return i35 | 0;
}

function __ZN7mecanim5human12HumanPoseAddERNS0_9HumanPoseERKS1_S4_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i1 = 0;
 do {
  f25 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 28 >> 2]);
  f15 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 32 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 36 >> 2]);
  f25 = Math_fround(f25 * f16);
  f21 = Math_fround(f21 * f15);
  f19 = Math_fround(f19 * f5);
  f18 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 16 >> 2]);
  f24 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 24 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 20 >> 2]);
  f26 = Math_fround(f18 * Math_fround(-2.0));
  f7 = Math_fround(f18 * Math_fround(2.0));
  f23 = Math_fround(f26 * f20);
  f17 = Math_fround(f22 * Math_fround(2.0));
  f6 = Math_fround(f22 * Math_fround(-2.0));
  f27 = Math_fround(f20 * f6);
  f8 = Math_fround(f24 * Math_fround(-2.0));
  f13 = Math_fround(f24 * Math_fround(2.0));
  f12 = Math_fround(f20 * f8);
  f14 = Math_fround(Math_fround(f25 + Math_fround(f25 * Math_fround(Math_fround(f18 * f26) - Math_fround(f22 * f17)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f13 * f22) - f23)) + Math_fround(f21 * Math_fround(f27 - Math_fround(f18 * f8)))));
  f13 = Math_fround(Math_fround(f21 + Math_fround(f25 * Math_fround(Math_fround(f24 * f7) - f27))) + Math_fround(Math_fround(f19 * Math_fround(f12 - Math_fround(f26 * f22))) + Math_fround(f21 * Math_fround(Math_fround(f22 * f6) - Math_fround(f24 * f13)))));
  f12 = Math_fround(Math_fround(f19 + Math_fround(f25 * Math_fround(f23 - Math_fround(f24 * f6)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f24 * f8) - Math_fround(f18 * f7))) + Math_fround(f21 * Math_fround(Math_fround(f18 * f17) - f12))));
  f17 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) >> 2]);
  f21 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 4 >> 2]);
  f14 = Math_fround(f17 + f14);
  f13 = Math_fround(f21 + f13);
  f12 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 8 >> 2]) + f12);
  f21 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 12 >> 2]);
  f17 = Math_fround(f18 * f21);
  f7 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 24 >> 2]);
  f8 = Math_fround(f20 * f7);
  f19 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 16 >> 2]);
  f6 = Math_fround(f22 * f19);
  f23 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 20 >> 2]);
  f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f20 * f23)) - Math_fround(f22 * f7)) - Math_fround(f24 * f19));
  f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f24 * f21)) - Math_fround(f22 * f23)) - Math_fround(f18 * f19));
  f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f18 * f23)) - Math_fround(f20 * f21)) - Math_fround(f24 * f7));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f18 * f7));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f7 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 28 >> 2]);
  f6 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 32 >> 2]);
  f7 = Math_fround(f16 * f7);
  f6 = Math_fround(f15 * f6);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 36 >> 2]));
  HEAPF32[i2 + 68 + (i1 << 6) >> 2] = f14;
  HEAPF32[i2 + 68 + (i1 << 6) + 4 >> 2] = f13;
  HEAPF32[i2 + 68 + (i1 << 6) + 8 >> 2] = f12;
  HEAP32[i2 + 68 + (i1 << 6) + 12 >> 2] = i11 ^ -2147483648;
  HEAP32[i2 + 68 + (i1 << 6) + 16 >> 2] = i10;
  HEAP32[i2 + 68 + (i1 << 6) + 20 >> 2] = i9 ^ -2147483648;
  HEAPF32[i2 + 68 + (i1 << 6) + 24 >> 2] = f8;
  HEAPF32[i2 + 68 + (i1 << 6) + 28 >> 2] = f7;
  HEAPF32[i2 + 68 + (i1 << 6) + 32 >> 2] = f6;
  HEAPF32[i2 + 68 + (i1 << 6) + 36 >> 2] = f5;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  f27 = Math_fround(HEAPF32[i3 + 596 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 596 + (i1 << 2) >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i4 + 596 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 52);
 i1 = 0;
 do {
  f27 = Math_fround(HEAPF32[i3 + 364 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 364 + (i1 << 2) >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i4 + 364 + (i1 << 2) >> 2]));
  f27 = Math_fround(HEAPF32[i3 + 500 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 500 + (i1 << 2) >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i4 + 500 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f7 = Math_fround(f7 * f19);
 f14 = Math_fround(f14 * f20);
 f16 = Math_fround(f16 * f24);
 f17 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f17 * Math_fround(-2.0));
 f27 = Math_fround(f17 * Math_fround(2.0));
 f12 = Math_fround(f6 * f15);
 f18 = Math_fround(f13 * Math_fround(2.0));
 f23 = Math_fround(f13 * Math_fround(-2.0));
 f5 = Math_fround(f15 * f23);
 f25 = Math_fround(f8 * Math_fround(-2.0));
 f22 = Math_fround(f8 * Math_fround(2.0));
 f26 = Math_fround(f15 * f25);
 f21 = Math_fround(Math_fround(f7 + Math_fround(f7 * Math_fround(Math_fround(f17 * f6) - Math_fround(f13 * f18)))) + Math_fround(Math_fround(f16 * Math_fround(Math_fround(f22 * f13) - f12)) + Math_fround(f14 * Math_fround(f5 - Math_fround(f17 * f25)))));
 f22 = Math_fround(Math_fround(f14 + Math_fround(f7 * Math_fround(Math_fround(f8 * f27) - f5))) + Math_fround(Math_fround(f16 * Math_fround(f26 - Math_fround(f6 * f13))) + Math_fround(f14 * Math_fround(Math_fround(f13 * f23) - Math_fround(f8 * f22)))));
 f26 = Math_fround(Math_fround(f16 + Math_fround(f7 * Math_fround(f12 - Math_fround(f8 * f23)))) + Math_fround(Math_fround(f16 * Math_fround(Math_fround(f8 * f25) - Math_fround(f17 * f27))) + Math_fround(f14 * Math_fround(Math_fround(f17 * f18) - f26))));
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f21 = Math_fround(f18 + f21);
 f22 = Math_fround(f14 + f22);
 f26 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) + f26);
 f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f18 = Math_fround(f17 * f14);
 f27 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f25 = Math_fround(f15 * f27);
 f16 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f23 = Math_fround(f13 * f16);
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f15 * f12)) - Math_fround(f13 * f27)) - Math_fround(f8 * f16));
 f25 = Math_fround(Math_fround(Math_fround(f25 - Math_fround(f8 * f14)) - Math_fround(f13 * f12)) - Math_fround(f17 * f16));
 f23 = Math_fround(Math_fround(Math_fround(f23 - Math_fround(f17 * f12)) - Math_fround(f15 * f14)) - Math_fround(f8 * f27));
 f27 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f13 * f14)) - Math_fround(f15 * f16)) - Math_fround(f17 * f27));
 i11 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f27 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f27 = Math_fround(f19 * f27);
 f23 = Math_fround(f20 * f23);
 f24 = Math_fround(f24 * Math_fround(HEAPF32[i4 + 36 >> 2]));
 HEAPF32[i2 >> 2] = f21;
 HEAPF32[i2 + 4 >> 2] = f22;
 HEAPF32[i2 + 8 >> 2] = f26;
 HEAP32[i2 + 12 >> 2] = i9 ^ -2147483648;
 HEAP32[i2 + 16 >> 2] = i10;
 HEAP32[i2 + 20 >> 2] = i11 ^ -2147483648;
 HEAPF32[i2 + 24 >> 2] = f25;
 HEAPF32[i2 + 28 >> 2] = f27;
 HEAPF32[i2 + 32 >> 2] = f23;
 HEAPF32[i2 + 36 >> 2] = f24;
 f24 = Math_fround(HEAPF32[i3 + 804 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 808 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 812 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 804 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 808 >> 2]);
 f26 = Math_fround(f23 + f26);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 + 812 >> 2]));
 HEAPF32[i2 + 804 >> 2] = Math_fround(f24 + f25);
 HEAPF32[i2 + 808 >> 2] = f26;
 HEAPF32[i2 + 812 >> 2] = f27;
 f27 = Math_fround(HEAPF32[i3 + 816 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 820 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 824 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 816 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 820 >> 2]);
 f23 = Math_fround(f26 + f23);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i4 + 824 >> 2]));
 HEAPF32[i2 + 816 >> 2] = Math_fround(f27 + f24);
 HEAPF32[i2 + 820 >> 2] = f23;
 HEAPF32[i2 + 824 >> 2] = f25;
 f25 = Math_fround(HEAPF32[i3 + 828 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 832 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 836 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 828 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 832 >> 2]);
 f26 = Math_fround(f23 + f26);
 f24 = Math_fround(f24 + Math_fround(HEAPF32[i4 + 836 >> 2]));
 HEAPF32[i2 + 828 >> 2] = Math_fround(f25 + f27);
 HEAPF32[i2 + 832 >> 2] = f26;
 HEAPF32[i2 + 836 >> 2] = f24;
 f24 = Math_fround(HEAPF32[i3 + 840 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 844 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 848 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 840 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 844 >> 2]);
 f23 = Math_fround(f26 + f23);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 + 848 >> 2]));
 HEAPF32[i2 + 840 >> 2] = Math_fround(f24 + f25);
 HEAPF32[i2 + 844 >> 2] = f23;
 HEAPF32[i2 + 848 >> 2] = f27;
 f27 = Math_fround(HEAPF32[i3 + 852 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 856 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 860 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 852 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 856 >> 2]);
 f26 = Math_fround(f23 + f26);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i4 + 860 >> 2]));
 HEAPF32[i2 + 852 >> 2] = Math_fround(f27 + f24);
 HEAPF32[i2 + 856 >> 2] = f26;
 HEAPF32[i2 + 860 >> 2] = f25;
 f25 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 872 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 864 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 868 >> 2]);
 f23 = Math_fround(f26 + f23);
 f24 = Math_fround(f24 + Math_fround(HEAPF32[i4 + 872 >> 2]));
 HEAPF32[i2 + 864 >> 2] = Math_fround(f25 + f27);
 HEAPF32[i2 + 868 >> 2] = f23;
 HEAPF32[i2 + 872 >> 2] = f24;
 f24 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 880 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 884 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 876 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 880 >> 2]);
 f26 = Math_fround(f23 + f26);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 + 884 >> 2]));
 HEAPF32[i2 + 876 >> 2] = Math_fround(f24 + f25);
 HEAPF32[i2 + 880 >> 2] = f26;
 HEAPF32[i2 + 884 >> 2] = f27;
 return;
}

function __ZN5physx3Cct9SweepTest13moveCharacterEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERNS0_11SweptVolumeERKNS_6PxVec3ERKNS0_13UserObstaclesEfRKNS_19PxControllerFiltersEbb(i53, i54, i55, i57, i50, i56, f52, i51, i33, i11) {
 i53 = i53 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i57 = i57 | 0;
 i50 = i50 | 0;
 i56 = i56 | 0;
 f52 = Math_fround(f52);
 i51 = i51 | 0;
 i33 = i33 | 0;
 i11 = i11 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, d6 = 0.0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, d36 = 0.0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, d43 = 0.0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i58 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i58 + 124 | 0;
 i30 = i58 + 112 | 0;
 i49 = i58 + 100 | 0;
 i17 = i58 + 24 | 0;
 i47 = i58 + 96 | 0;
 i32 = i58 + 84 | 0;
 i31 = i58;
 i48 = i58 + 72 | 0;
 i46 = i53 + 308 | 0;
 i5 = HEAP32[i46 >> 2] | 0;
 i7 = i5 & -2;
 HEAP32[i46 >> 2] = i7;
 if (!(i5 & 2)) i1 = 0; else i1 = (HEAP32[i53 + 224 >> 2] | 0) == 1;
 i29 = i1 ? 10 : 1;
 i34 = i53 + 264 | 0;
 f2 = Math_fround(HEAPF32[i34 >> 2]);
 i39 = i57 + 8 | 0;
 f16 = Math_fround(+HEAPF64[i39 >> 3]);
 i40 = i57 + 16 | 0;
 f3 = Math_fround(+HEAPF64[i40 >> 3]);
 i41 = i57 + 24 | 0;
 f42 = Math_fround(+HEAPF64[i41 >> 3]);
 i35 = i53 + 244 | 0;
 f14 = Math_fround(HEAPF32[i35 >> 2]);
 f16 = Math_fround(f16 * f14);
 i37 = i53 + 248 | 0;
 f15 = Math_fround(HEAPF32[i37 >> 2]);
 f3 = Math_fround(f16 + Math_fround(f3 * f15));
 i38 = i53 + 252 | 0;
 f16 = Math_fround(HEAPF32[i38 >> 2]);
 f42 = Math_fround(f3 + Math_fround(f42 * f16));
 d43 = +f42;
 d36 = d43 - +Math_fround(HEAPF32[i57 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i50 >> 2]);
 f9 = Math_fround(f14 * f3);
 i44 = i50 + 4 | 0;
 f4 = Math_fround(HEAPF32[i44 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f15 * f4));
 i45 = i50 + 8 | 0;
 f8 = Math_fround(HEAPF32[i45 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f16 * f8));
 if (f9 > Math_fround(0.0)) {
  HEAP32[i46 >> 2] = i7 | 256;
  f2 = i11 ? f2 : Math_fround(0.0);
 } else HEAP32[i46 >> 2] = i5 & -258;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 i1 = i19 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i5 = i19 + 8 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i30 >> 2] = Math_fround(0.0);
 i26 = i30 + 4 | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 i27 = i30 + 8 | 0;
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 f10 = Math_fround(f14 * f9);
 f12 = Math_fround(f15 * f9);
 f13 = Math_fround(f16 * f9);
 f25 = Math_fround(f3 - f10);
 f24 = Math_fround(f4 - f12);
 f20 = Math_fround(f8 - f13);
 i28 = f9 <= Math_fround(0.0);
 if (i28) {
  HEAPF32[i30 >> 2] = f10;
  HEAPF32[i26 >> 2] = f12;
  HEAPF32[i27 >> 2] = f13;
  f21 = f10;
  f22 = f12;
  f23 = f13;
  f8 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 } else {
  HEAPF32[i19 >> 2] = f10;
  HEAPF32[i1 >> 2] = f12;
  HEAPF32[i5 >> 2] = f13;
  f21 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f8 = f10;
  f4 = f12;
  f3 = f13;
 }
 HEAPF32[i49 >> 2] = f25;
 HEAPF32[i49 + 4 >> 2] = f24;
 HEAPF32[i49 + 8 >> 2] = f20;
 if (i11) i18 = 13; else if (+Math_fround(Math_abs(Math_fround(f25))) > 1.0e-06) i18 = 13; else if (+Math_fround(Math_abs(Math_fround(f24))) > 1.0e-06) i18 = 13; else if (+Math_fround(Math_abs(Math_fround(f20))) > 1.0e-06) i18 = 13; else i11 = 1;
 if ((i18 | 0) == 13) {
  f15 = Math_fround(f2 * f15);
  f16 = Math_fround(f2 * f16);
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(f2 * f14) + f8);
  HEAPF32[i1 >> 2] = Math_fround(f15 + f4);
  HEAPF32[i5 >> 2] = Math_fround(f16 + f3);
  i11 = 0;
 }
 mftCall_viiiii(HEAP32[(HEAP32[i57 >> 2] | 0) + 8 >> 2] | 0, i57 | 0, i53 | 0, i17 | 0, i39 | 0, i50 | 0);
 __ZN5physx3Cct9SweepTest18updateTouchedGeomsEPKNS0_30InternalCBData_FindTouchedGeomERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3ERKNS_19PxControllerFiltersERKNS_6PxVec3E(i53, i54, i56, i17, i51, i49);
 i7 = i53 + 96 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i47 >> 2] = 0;
 if (!(HEAP8[i53 + 284 >> 0] | 0)) if (+Math_fround(Math_abs(Math_fround(f25))) > 1.0e-06) i1 = 1; else if (+Math_fround(Math_abs(Math_fround(f24))) > 1.0e-06) i1 = 1; else if (+Math_fround(Math_abs(Math_fround(f20))) > 1.0e-06) i1 = 1; else i1 = 10; else i1 = 1;
 if (!(HEAP32[i46 >> 2] & 2)) {
  i19 = __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i53, i54, i55, i56, i57, i19, i49, i1, i47, f52, i51, 0) | 0;
  if (i19 & (HEAP32[i47 >> 2] | 0) != 0) {
   f14 = Math_fround(+HEAPF64[i39 >> 3]);
   f15 = Math_fround(+HEAPF64[i40 >> 3]);
   f16 = Math_fround(+HEAPF64[i41 >> 3]);
   f14 = Math_fround(f14 * Math_fround(HEAPF32[i35 >> 2]));
   f15 = Math_fround(f14 + Math_fround(f15 * Math_fround(HEAPF32[i37 >> 2])));
   d6 = +Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i38 >> 2]))) - d43;
   if (d6 < +f2) {
    i5 = 2;
    f2 = Math_fround(d6);
   } else i5 = 2;
  } else i5 = 0;
 } else i5 = 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i46 >> 2] = HEAP32[i46 >> 2] & -9;
 HEAP32[i47 >> 2] = 0;
 i19 = __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i53, i54, i55, i56, i57, i49, i49, 10, i47, f52, i51, 1) | 0;
 if (i19 & (HEAP32[i47 >> 2] | 0) != 0) i5 = (i5 & 255 | 1) & 255;
 if (i33) if ((HEAP32[i57 + 36 >> 2] | 0) == 1) {
  i1 = HEAP32[i46 >> 2] | 0;
  if (!(i1 & 8)) {
   f9 = Math_fround(HEAPF32[i57 + 40 >> 2]);
   f3 = Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)) + Math_fround(f20 * f20));
   f4 = Math_fround(Math_sqrt(Math_fround(f3)));
   if (f4 < f9) {
    if (f3 > Math_fround(0.0)) {
     f3 = Math_fround(Math_fround(1.0) / f4);
     f8 = Math_fround(f20 * f3);
     f4 = Math_fround(f24 * f3);
     f3 = Math_fround(f25 * f3);
    } else {
     f8 = Math_fround(0.0);
     f4 = Math_fround(0.0);
     f3 = Math_fround(0.0);
    }
    f24 = Math_fround(f9 * f4);
    f25 = Math_fround(f9 * f8);
    HEAPF32[i32 >> 2] = Math_fround(f9 * f3);
    HEAPF32[i32 + 4 >> 2] = f24;
    HEAPF32[i32 + 8 >> 2] = f25;
    HEAP32[i46 >> 2] = i1 & -9;
    HEAP32[i47 >> 2] = 0;
    HEAP32[i31 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i31 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    HEAP32[i31 + 16 >> 2] = HEAP32[i39 + 16 >> 2];
    HEAP32[i31 + 20 >> 2] = HEAP32[i39 + 20 >> 2];
    __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i53, i54, i55, i56, i57, i32, i49, 1, i47, f52, i51, 3) | 0;
    HEAP32[i39 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i39 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i39 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    HEAP32[i39 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
    HEAP32[i39 + 16 >> 2] = HEAP32[i31 + 16 >> 2];
    HEAP32[i39 + 20 >> 2] = HEAP32[i31 + 20 >> 2];
   }
  }
 }
 HEAP32[i7 >> 2] = 2;
 HEAP32[i47 >> 2] = 0;
 if (!i11) {
  f20 = Math_fround(f2 * Math_fround(HEAPF32[i35 >> 2]));
  f24 = Math_fround(f2 * Math_fround(HEAPF32[i37 >> 2]));
  f25 = Math_fround(f2 * Math_fround(HEAPF32[i38 >> 2]));
  HEAPF32[i30 >> 2] = Math_fround(f21 - f20);
  HEAPF32[i26 >> 2] = Math_fround(f22 - f24);
  HEAPF32[i27 >> 2] = Math_fround(f23 - f25);
 }
 HEAP32[i46 >> 2] = HEAP32[i46 >> 2] & -5;
 HEAP32[i53 + 156 >> 2] = 0;
 HEAP32[i53 + 160 >> 2] = 0;
 HEAP32[i53 + 152 >> 2] = -1;
 i32 = __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i53, i54, i55, i56, i57, i30, i49, i29, i47, f52, i51, 2) | 0;
 if (i32 & (HEAP32[i47 >> 2] | 0) != 0) {
  if (i28) i5 = (i5 & 255 | 4) & 255;
  if (!(HEAP8[i53 + 281 >> 0] | 0)) {
   i57 = i5;
   STACKTOP = i58;
   return i57 | 0;
  }
  i1 = HEAP32[i46 >> 2] | 0;
  if ((i1 & 56 | 0) == 8) {
   f25 = Math_fround(HEAPF32[i53 + 256 >> 2]);
   f24 = Math_fround(HEAPF32[i53 + 132 >> 2]);
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i35 >> 2]));
   f23 = Math_fround(HEAPF32[i53 + 136 >> 2]);
   f23 = Math_fround(f24 + Math_fround(f23 * Math_fround(HEAPF32[i37 >> 2])));
   f24 = Math_fround(HEAPF32[i53 + 140 >> 2]);
   f24 = Math_fround(f23 + Math_fround(f24 * Math_fround(HEAPF32[i38 >> 2])));
   if (!(!(f24 >= Math_fround(0.0)) | !(f24 < f25) | i33 ^ 1)) if (+Math_fround(HEAPF32[i53 + 292 >> 2]) > d36 + +f2) {
    HEAP32[i46 >> 2] = i1 | 1;
    if (!(i1 & 2)) {
     i57 = i5;
     STACKTOP = i58;
     return i57 | 0;
    }
   }
  }
 } else if (!(HEAP8[i53 + 281 >> 0] | 0)) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 i1 = HEAP32[i46 >> 2] | 0;
 if (i1 & 48 | 0) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 if (!(i28 & (i1 & 4 | 0) != 0)) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 f25 = Math_fround(+Math_fround(HEAPF32[i53 + 148 >> 2]) - d36);
 if (!(f25 > Math_fround(HEAPF32[i34 >> 2]))) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 f25 = Math_fround(HEAPF32[i53 + 128 >> 2]);
 f23 = Math_fround(HEAPF32[i53 + 124 >> 2]);
 f2 = Math_fround(HEAPF32[i53 + 120 >> 2]);
 f24 = Math_fround(HEAPF32[i53 + 256 >> 2]);
 f4 = Math_fround(HEAPF32[i35 >> 2]);
 f2 = Math_fround(f2 * f4);
 f3 = Math_fround(HEAPF32[i37 >> 2]);
 f23 = Math_fround(f2 + Math_fround(f23 * f3));
 f2 = Math_fround(HEAPF32[i38 >> 2]);
 f25 = Math_fround(f23 + Math_fround(f25 * f2));
 if (!(f25 < f24 & f25 >= Math_fround(0.0))) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 HEAP32[i46 >> 2] = i1 | 1;
 if (!(i1 & 2)) {
  i57 = i5;
  STACKTOP = i58;
  return i57 | 0;
 }
 HEAP32[i46 >> 2] = i1 | 65;
 f25 = Math_fround(+HEAPF64[i39 >> 3]);
 f24 = Math_fround(+HEAPF64[i40 >> 3]);
 f24 = Math_fround(Math_fround(Math_fround(f25 * f4) + Math_fround(f24 * f3)) + Math_fround(Math_fround(+HEAPF64[i41 >> 3]) * f2));
 f25 = Math_fround(f4 * Math_fround(HEAPF32[i50 >> 2]));
 f25 = Math_fround(f25 + Math_fround(f3 * Math_fround(HEAPF32[i44 >> 2])));
 d36 = (f24 > f42 ? +f24 - d43 : 0.0) + +Math_fround(Math_abs(Math_fround(f25 + Math_fround(f2 * Math_fround(HEAPF32[i45 >> 2])))));
 HEAP32[i47 >> 2] = 0;
 d43 = +f52;
 f25 = Math_fround(d36);
 f42 = Math_fround(-Math_fround(f3 * f25));
 f52 = Math_fround(-Math_fround(f25 * f2));
 HEAPF32[i48 >> 2] = Math_fround(-Math_fround(f4 * f25));
 HEAPF32[i48 + 4 >> 2] = f42;
 HEAPF32[i48 + 8 >> 2] = f52;
 __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE(i53, i54, i55, i56, i57, i48, i49, 10, i47, Math_fround(d36 < d43 ? d36 / 10.0 : d43), i51, 0) | 0;
 HEAP32[i46 >> 2] = HEAP32[i46 >> 2] & -65;
 i57 = i5;
 STACKTOP = i58;
 return i57 | 0;
}

function __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE(i1, i32, i39, i41) {
 i1 = i1 | 0;
 i32 = i32 | 0;
 i39 = i39 | 0;
 i41 = i41 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i42 = 0, f43 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i42 + 40 | 0;
 i38 = i42 + 4 | 0;
 i40 = i42;
 f14 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 if (f14 == Math_fround(0.0)) {
  i41 = 0;
  STACKTOP = i42;
  return i41 | 0;
 }
 f21 = Math_fround(HEAPF32[i32 + 12 >> 2]);
 f22 = Math_fround(HEAPF32[i32 >> 2]);
 f30 = Math_fround(f21 - f22);
 i25 = i32 + 16 | 0;
 f23 = Math_fround(HEAPF32[i25 >> 2]);
 i33 = i32 + 4 | 0;
 f18 = Math_fround(HEAPF32[i33 >> 2]);
 f10 = Math_fround(f23 - f18);
 i26 = i32 + 20 | 0;
 f19 = Math_fround(HEAPF32[i26 >> 2]);
 i34 = i32 + 8 | 0;
 f20 = Math_fround(HEAPF32[i34 >> 2]);
 f29 = Math_fround(f19 - f20);
 f15 = Math_fround(HEAPF32[i32 + 24 >> 2]);
 f12 = Math_fround(f15 - f22);
 i36 = i32 + 28 | 0;
 f16 = Math_fround(HEAPF32[i36 >> 2]);
 f31 = Math_fround(f16 - f18);
 i37 = i32 + 32 | 0;
 f17 = Math_fround(HEAPF32[i37 >> 2]);
 f11 = Math_fround(f17 - f20);
 f6 = Math_fround(Math_fround(f10 * f11) - Math_fround(f29 * f31));
 f11 = Math_fround(Math_fround(f29 * f12) - Math_fround(f30 * f11));
 f12 = Math_fround(Math_fround(f30 * f31) - Math_fround(f10 * f12));
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f6 * f6) + Math_fround(f11 * f11)))));
 if (f10 > Math_fround(0.0)) {
  f31 = Math_fround(Math_fround(1.0) / f10);
  f6 = Math_fround(f6 * f31);
  f11 = Math_fround(f11 * f31);
  f12 = Math_fround(f12 * f31);
 }
 f30 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f31 = Math_fround(f6 * f13);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f11 * f10));
 f6 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f12 * f6));
 if (!(f31 < f30 & f31 >= Math_fround(0.0))) {
  i41 = 0;
  STACKTOP = i42;
  return i41 | 0;
 }
 f43 = Math_fround(f14 * f13);
 f13 = Math_fround(f14 * f10);
 f12 = Math_fround(f14 * f6);
 f29 = Math_fround(f43 + f22);
 f30 = Math_fround(f13 + f18);
 f31 = Math_fround(f12 + f20);
 i7 = i32 + 12 | 0;
 f6 = Math_fround(f43 + f21);
 f10 = Math_fround(f13 + f23);
 f11 = Math_fround(f12 + f19);
 i27 = i32 + 24 | 0;
 f14 = Math_fround(f43 + f15);
 f13 = Math_fround(f13 + f16);
 f12 = Math_fround(f12 + f17);
 HEAPF32[i35 >> 2] = f22;
 HEAPF32[i35 + 4 >> 2] = f18;
 HEAPF32[i35 + 8 >> 2] = f20;
 HEAPF32[i35 + 12 >> 2] = f21;
 HEAPF32[i35 + 16 >> 2] = f23;
 HEAPF32[i35 + 20 >> 2] = f19;
 HEAPF32[i35 + 24 >> 2] = f29;
 HEAPF32[i35 + 28 >> 2] = f30;
 HEAPF32[i35 + 32 >> 2] = f31;
 i24 = i39 + 8 | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i28 = i39 + 4 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 > i1 >>> 0) {
  i5 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i5 + (i1 * 36 | 0) >> 2] = f22;
  HEAPF32[i5 + (i1 * 36 | 0) + 4 >> 2] = f18;
  HEAPF32[i5 + (i1 * 36 | 0) + 8 >> 2] = f20;
  HEAPF32[i5 + (i1 * 36 | 0) + 12 >> 2] = f21;
  HEAPF32[i5 + (i1 * 36 | 0) + 16 >> 2] = f23;
  HEAPF32[i5 + (i1 * 36 | 0) + 20 >> 2] = f19;
  HEAPF32[i5 + (i1 * 36 | 0) + 24 >> 2] = f29;
  HEAPF32[i5 + (i1 * 36 | 0) + 28 >> 2] = f30;
  HEAPF32[i5 + (i1 * 36 | 0) + 32 >> 2] = f31;
  i5 = i1 + 1 | 0;
  HEAP32[i28 >> 2] = i5;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i35) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i5 = HEAP32[i28 >> 2] | 0;
 }
 HEAPF32[i38 >> 2] = f29;
 HEAPF32[i38 + 4 >> 2] = f30;
 HEAPF32[i38 + 8 >> 2] = f31;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i38 + 12 >> 2] = i1;
 i2 = HEAP32[i25 >> 2] | 0;
 HEAP32[i38 + 16 >> 2] = i2;
 i3 = HEAP32[i26 >> 2] | 0;
 HEAP32[i38 + 20 >> 2] = i3;
 HEAPF32[i38 + 24 >> 2] = f6;
 HEAPF32[i38 + 28 >> 2] = f10;
 HEAPF32[i38 + 32 >> 2] = f11;
 if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
  i9 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i9 + (i5 * 36 | 0) >> 2] = f29;
  HEAPF32[i9 + (i5 * 36 | 0) + 4 >> 2] = f30;
  HEAPF32[i9 + (i5 * 36 | 0) + 8 >> 2] = f31;
  HEAP32[i9 + (i5 * 36 | 0) + 12 >> 2] = i1;
  HEAP32[i9 + (i5 * 36 | 0) + 16 >> 2] = i2;
  HEAP32[i9 + (i5 * 36 | 0) + 20 >> 2] = i3;
  HEAPF32[i9 + (i5 * 36 | 0) + 24 >> 2] = f6;
  HEAPF32[i9 + (i5 * 36 | 0) + 28 >> 2] = f10;
  HEAPF32[i9 + (i5 * 36 | 0) + 32 >> 2] = f11;
  i5 = i5 + 1 | 0;
  HEAP32[i28 >> 2] = i5;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i38) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i5 = HEAP32[i28 >> 2] | 0;
 }
 HEAPF32[i35 >> 2] = f6;
 HEAPF32[i35 + 4 >> 2] = f10;
 HEAPF32[i35 + 8 >> 2] = f11;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i35 + 12 >> 2] = i1;
 i2 = HEAP32[i25 >> 2] | 0;
 HEAP32[i35 + 16 >> 2] = i2;
 i3 = HEAP32[i26 >> 2] | 0;
 HEAP32[i35 + 20 >> 2] = i3;
 HEAPF32[i35 + 24 >> 2] = f14;
 HEAPF32[i35 + 28 >> 2] = f13;
 HEAPF32[i35 + 32 >> 2] = f12;
 if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
  i9 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i9 + (i5 * 36 | 0) >> 2] = f6;
  HEAPF32[i9 + (i5 * 36 | 0) + 4 >> 2] = f10;
  HEAPF32[i9 + (i5 * 36 | 0) + 8 >> 2] = f11;
  HEAP32[i9 + (i5 * 36 | 0) + 12 >> 2] = i1;
  HEAP32[i9 + (i5 * 36 | 0) + 16 >> 2] = i2;
  HEAP32[i9 + (i5 * 36 | 0) + 20 >> 2] = i3;
  HEAPF32[i9 + (i5 * 36 | 0) + 24 >> 2] = f14;
  HEAPF32[i9 + (i5 * 36 | 0) + 28 >> 2] = f13;
  HEAPF32[i9 + (i5 * 36 | 0) + 32 >> 2] = f12;
  i9 = i5 + 1 | 0;
  HEAP32[i28 >> 2] = i9;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i35) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i9 = HEAP32[i28 >> 2] | 0;
 }
 HEAPF32[i38 >> 2] = f14;
 HEAPF32[i38 + 4 >> 2] = f13;
 HEAPF32[i38 + 8 >> 2] = f12;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i38 + 12 >> 2] = i8;
 i7 = HEAP32[i25 >> 2] | 0;
 HEAP32[i38 + 16 >> 2] = i7;
 i1 = HEAP32[i26 >> 2] | 0;
 HEAP32[i38 + 20 >> 2] = i1;
 i2 = HEAP32[i27 >> 2] | 0;
 HEAP32[i38 + 24 >> 2] = i2;
 i3 = HEAP32[i36 >> 2] | 0;
 HEAP32[i38 + 28 >> 2] = i3;
 i5 = HEAP32[i37 >> 2] | 0;
 HEAP32[i38 + 32 >> 2] = i5;
 if ((i4 & 2147483647) >>> 0 > i9 >>> 0) {
  i26 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i26 + (i9 * 36 | 0) >> 2] = f14;
  HEAPF32[i26 + (i9 * 36 | 0) + 4 >> 2] = f13;
  HEAPF32[i26 + (i9 * 36 | 0) + 8 >> 2] = f12;
  HEAP32[i26 + (i9 * 36 | 0) + 12 >> 2] = i8;
  HEAP32[i26 + (i9 * 36 | 0) + 16 >> 2] = i7;
  HEAP32[i26 + (i9 * 36 | 0) + 20 >> 2] = i1;
  HEAP32[i26 + (i9 * 36 | 0) + 24 >> 2] = i2;
  HEAP32[i26 + (i9 * 36 | 0) + 28 >> 2] = i3;
  HEAP32[i26 + (i9 * 36 | 0) + 32 >> 2] = i5;
  i9 = i9 + 1 | 0;
  HEAP32[i28 >> 2] = i9;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i38) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i9 = HEAP32[i28 >> 2] | 0;
 }
 HEAPF32[i35 >> 2] = f29;
 HEAPF32[i35 + 4 >> 2] = f30;
 HEAPF32[i35 + 8 >> 2] = f31;
 i5 = HEAP32[i27 >> 2] | 0;
 HEAP32[i35 + 12 >> 2] = i5;
 i7 = HEAP32[i36 >> 2] | 0;
 HEAP32[i35 + 16 >> 2] = i7;
 i8 = HEAP32[i37 >> 2] | 0;
 HEAP32[i35 + 20 >> 2] = i8;
 i3 = HEAP32[i32 >> 2] | 0;
 HEAP32[i35 + 24 >> 2] = i3;
 i2 = HEAP32[i33 >> 2] | 0;
 HEAP32[i35 + 28 >> 2] = i2;
 i1 = HEAP32[i34 >> 2] | 0;
 HEAP32[i35 + 32 >> 2] = i1;
 if ((i4 & 2147483647) >>> 0 > i9 >>> 0) {
  i35 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i35 + (i9 * 36 | 0) >> 2] = f29;
  HEAPF32[i35 + (i9 * 36 | 0) + 4 >> 2] = f30;
  HEAPF32[i35 + (i9 * 36 | 0) + 8 >> 2] = f31;
  HEAP32[i35 + (i9 * 36 | 0) + 12 >> 2] = i5;
  HEAP32[i35 + (i9 * 36 | 0) + 16 >> 2] = i7;
  HEAP32[i35 + (i9 * 36 | 0) + 20 >> 2] = i8;
  HEAP32[i35 + (i9 * 36 | 0) + 24 >> 2] = i3;
  HEAP32[i35 + (i9 * 36 | 0) + 28 >> 2] = i2;
  HEAP32[i35 + (i9 * 36 | 0) + 32 >> 2] = i1;
  i5 = i9 + 1 | 0;
  HEAP32[i28 >> 2] = i5;
 } else {
  __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i35) | 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i5 = HEAP32[i28 >> 2] | 0;
 }
 HEAPF32[i38 >> 2] = f29;
 HEAPF32[i38 + 4 >> 2] = f30;
 HEAPF32[i38 + 8 >> 2] = f31;
 HEAPF32[i38 + 12 >> 2] = f14;
 HEAPF32[i38 + 16 >> 2] = f13;
 HEAPF32[i38 + 20 >> 2] = f12;
 i3 = HEAP32[i27 >> 2] | 0;
 HEAP32[i38 + 24 >> 2] = i3;
 i2 = HEAP32[i36 >> 2] | 0;
 HEAP32[i38 + 28 >> 2] = i2;
 i1 = HEAP32[i37 >> 2] | 0;
 HEAP32[i38 + 32 >> 2] = i1;
 if ((i4 & 2147483647) >>> 0 > i5 >>> 0) {
  i39 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i39 + (i5 * 36 | 0) >> 2] = f29;
  HEAPF32[i39 + (i5 * 36 | 0) + 4 >> 2] = f30;
  HEAPF32[i39 + (i5 * 36 | 0) + 8 >> 2] = f31;
  HEAPF32[i39 + (i5 * 36 | 0) + 12 >> 2] = f14;
  HEAPF32[i39 + (i5 * 36 | 0) + 16 >> 2] = f13;
  HEAPF32[i39 + (i5 * 36 | 0) + 20 >> 2] = f12;
  HEAP32[i39 + (i5 * 36 | 0) + 24 >> 2] = i3;
  HEAP32[i39 + (i5 * 36 | 0) + 28 >> 2] = i2;
  HEAP32[i39 + (i5 * 36 | 0) + 32 >> 2] = i1;
  HEAP32[i28 >> 2] = i5 + 1;
 } else __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i39, i38) | 0;
 HEAP32[i40 >> 2] = -1;
 i2 = i41 + 8 | 0;
 i3 = i41 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i41 >> 2] | 0) + (i1 << 2) >> 2] = -1;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i41 = 6;
  STACKTOP = i42;
  return i41 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i41, i40) | 0;
  i41 = 6;
  STACKTOP = i42;
  return i41 | 0;
 }
 return 0;
}

function __ZN5physx2Gu20doSupportMappingPairERKNS0_7ConvexVES3_PNS0_10SupportMapES5_NS_6shdfnd3aos5Vec3VEPS8_S9_S9_jRNS0_12SimplexStackE(i36, i1, i2, i3, i19, i20, i35, i32, i34, i37, i33) {
 i36 = i36 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i35 = i35 | 0;
 i32 = i32 | 0;
 i34 = i34 | 0;
 i37 = i37 | 0;
 i33 = i33 | 0;
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i31 + 96 | 0;
 i29 = i31 + 80 | 0;
 i30 = i31 + 64 | 0;
 i1 = i31 + 48 | 0;
 i2 = i31 + 32 | 0;
 i17 = i31 + 16 | 0;
 i21 = i31;
 f4 = Math_fround(HEAPF32[i20 >> 2]);
 i15 = i20 + 4 | 0;
 f10 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i20 + 8 | 0;
 f10 = Math_fround(-f10);
 f9 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
 HEAPF32[i18 >> 2] = Math_fround(-f4);
 i5 = i18 + 4 | 0;
 HEAPF32[i5 >> 2] = f10;
 i8 = i18 + 8 | 0;
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i29 | 0, i3 | 0, i18 | 0);
 mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, i19 | 0, i20 | 0);
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 i27 = i29 + 4 | 0;
 f10 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i29 + 8 | 0;
 f4 = Math_fround(HEAPF32[i28 >> 2]);
 f7 = Math_fround(HEAPF32[i30 >> 2]);
 i23 = i30 + 4 | 0;
 f6 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i30 + 8 | 0;
 f6 = Math_fround(f10 - f6);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i24 >> 2]));
 HEAPF32[i36 >> 2] = Math_fround(f9 - f7);
 HEAPF32[i36 + 4 >> 2] = f6;
 HEAPF32[i36 + 8 >> 2] = f4;
 HEAPF32[i36 + 12 >> 2] = Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i18 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(-f4);
 f10 = Math_fround(-f6);
 f11 = Math_fround(-f7);
 f9 = f4 > f9 ? f4 : f9;
 f10 = f6 > f10 ? f6 : f10;
 f11 = f7 > f11 ? f7 : f11;
 f12 = f9 <= f10 ? f9 : f10;
 i25 = (f12 <= f11 ? f12 : f11) < Math_fround(.00999999977);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f13 = Math_fround(HEAPF32[i15 >> 2]);
 f14 = Math_fround(HEAPF32[i16 >> 2]);
 f40 = Math_fround(-f12);
 f39 = Math_fround(-f13);
 f38 = Math_fround(-f14);
 f40 = f12 > f40 ? f12 : f40;
 f39 = f13 > f39 ? f13 : f39;
 f38 = f14 > f38 ? f14 : f38;
 f39 = f40 <= f39 ? f40 : f39;
 i26 = (f39 <= f38 ? f39 : f38) < Math_fround(.00999999977);
 if (i25) {
  i43 = f9 < Math_fround(.00999999977);
  i42 = f10 < Math_fround(.00999999977);
  i41 = f11 < Math_fround(.00999999977);
  HEAPF32[i1 >> 2] = i43 ? f12 : f4;
  HEAPF32[i1 + 4 >> 2] = i42 ? f13 : f6;
  HEAPF32[i1 + 8 >> 2] = i41 ? f14 : f7;
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i2 >> 2]);
  f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 } else {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f10 = Math_fround(0.0);
 }
 if (i26) {
  f40 = Math_fround(HEAPF32[i20 >> 2]);
  f6 = Math_fround(HEAPF32[i15 >> 2]);
  f9 = Math_fround(HEAPF32[i16 >> 2]);
  f7 = Math_fround(-f40);
  f4 = Math_fround(-f6);
  f39 = Math_fround(-f9);
  i41 = (f40 > f7 ? f40 : f7) < Math_fround(.00999999977);
  i42 = (f6 > f4 ? f6 : f4) < Math_fround(.00999999977);
  i43 = (f9 > f39 ? f9 : f39) < Math_fround(.00999999977);
  f39 = Math_fround(HEAPF32[i18 >> 2]);
  f4 = Math_fround(HEAPF32[i5 >> 2]);
  f7 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i17 >> 2] = i41 ? f39 : f40;
  HEAPF32[i17 + 4 >> 2] = i42 ? f4 : f6;
  HEAPF32[i17 + 8 >> 2] = i43 ? f7 : f9;
  HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
  mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i21 | 0, i19 | 0, i17 | 0);
  f9 = Math_fround(HEAPF32[i21 >> 2]);
  f7 = Math_fround(HEAPF32[i21 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  if (i25) {
   HEAPF32[i32 + (i37 << 4) >> 2] = f11;
   HEAPF32[i32 + (i37 << 4) + 4 >> 2] = f12;
   HEAPF32[i32 + (i37 << 4) + 8 >> 2] = f13;
   HEAPF32[i32 + (i37 << 4) + 12 >> 2] = f10;
   HEAPF32[i34 + (i37 << 4) >> 2] = f9;
   HEAPF32[i34 + (i37 << 4) + 4 >> 2] = f7;
   HEAPF32[i34 + (i37 << 4) + 8 >> 2] = f6;
   HEAPF32[i34 + (i37 << 4) + 12 >> 2] = f4;
   f39 = Math_fround(f12 - f7);
   f40 = Math_fround(f13 - f6);
   HEAPF32[i35 + (i37 << 4) >> 2] = Math_fround(f11 - f9);
   HEAPF32[i35 + (i37 << 4) + 4 >> 2] = f39;
   HEAPF32[i35 + (i37 << 4) + 8 >> 2] = f40;
   HEAPF32[i35 + (i37 << 4) + 12 >> 2] = Math_fround(0.0);
   i3 = i37 + 1 | 0;
   i5 = i33 + 13312 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i3) {
    i2 = 0;
    do {
     i1 = i33 + (i1 * 208 | 0) + (i2 << 4) | 0;
     i43 = i32 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 64 + (i2 << 4) | 0;
     i43 = i34 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 128 + (i2 << 4) | 0;
     i43 = i35 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     HEAP32[i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 192 >> 2] = i3;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   HEAP32[i5 >> 2] = i1 + 1;
   i22 = 8;
  }
 } else {
  f9 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i22 = 8;
 }
 if ((i22 | 0) == 8) {
  if (i25) {
   HEAPF32[i32 + (i37 << 4) >> 2] = f11;
   HEAPF32[i32 + (i37 << 4) + 4 >> 2] = f12;
   HEAPF32[i32 + (i37 << 4) + 8 >> 2] = f13;
   HEAPF32[i32 + (i37 << 4) + 12 >> 2] = f10;
   i3 = i34 + (i37 << 4) | 0;
   HEAP32[i3 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   f38 = Math_fround(HEAPF32[i30 >> 2]);
   f39 = Math_fround(HEAPF32[i23 >> 2]);
   f39 = Math_fround(f12 - f39);
   f40 = Math_fround(f13 - Math_fround(HEAPF32[i24 >> 2]));
   HEAPF32[i35 + (i37 << 4) >> 2] = Math_fround(f11 - f38);
   HEAPF32[i35 + (i37 << 4) + 4 >> 2] = f39;
   HEAPF32[i35 + (i37 << 4) + 8 >> 2] = f40;
   HEAPF32[i35 + (i37 << 4) + 12 >> 2] = Math_fround(0.0);
   i3 = i37 + 1 | 0;
   i5 = i33 + 13312 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i3) {
    i2 = 0;
    do {
     i1 = i33 + (i1 * 208 | 0) + (i2 << 4) | 0;
     i43 = i32 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 64 + (i2 << 4) | 0;
     i43 = i34 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 128 + (i2 << 4) | 0;
     i43 = i35 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
     HEAP32[i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 192 >> 2] = i3;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   HEAP32[i5 >> 2] = i1 + 1;
  }
  if (!i26) {
   i43 = i32 + (i37 << 4) | 0;
   HEAP32[i43 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   i43 = i34 + (i37 << 4) | 0;
   HEAP32[i43 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   i43 = i35 + (i37 << 4) | 0;
   HEAP32[i43 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   STACKTOP = i31;
   return;
  }
 }
 i8 = i32 + (i37 << 4) | 0;
 HEAP32[i8 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
 HEAPF32[i34 + (i37 << 4) >> 2] = f9;
 HEAPF32[i34 + (i37 << 4) + 4 >> 2] = f7;
 HEAPF32[i34 + (i37 << 4) + 8 >> 2] = f6;
 HEAPF32[i34 + (i37 << 4) + 12 >> 2] = f4;
 f38 = Math_fround(HEAPF32[i29 >> 2]);
 f39 = Math_fround(HEAPF32[i27 >> 2]);
 f39 = Math_fround(f39 - f7);
 f40 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f6);
 HEAPF32[i35 + (i37 << 4) >> 2] = Math_fround(f38 - f9);
 HEAPF32[i35 + (i37 << 4) + 4 >> 2] = f39;
 HEAPF32[i35 + (i37 << 4) + 8 >> 2] = f40;
 HEAPF32[i35 + (i37 << 4) + 12 >> 2] = Math_fround(0.0);
 i3 = i37 + 1 | 0;
 i5 = i33 + 13312 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i3) {
  i2 = 0;
  do {
   i1 = i33 + (i1 * 208 | 0) + (i2 << 4) | 0;
   i43 = i32 + (i2 << 4) | 0;
   HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 64 + (i2 << 4) | 0;
   i43 = i34 + (i2 << 4) | 0;
   HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   i1 = i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 128 + (i2 << 4) | 0;
   i43 = i35 + (i2 << 4) | 0;
   HEAP32[i1 >> 2] = HEAP32[i43 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
   HEAP32[i33 + ((HEAP32[i5 >> 2] | 0) * 208 | 0) + 192 >> 2] = i3;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 HEAP32[i5 >> 2] = i1 + 1;
 i43 = i8;
 HEAP32[i43 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
 i43 = i34 + (i37 << 4) | 0;
 HEAP32[i43 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 i43 = i35 + (i37 << 4) | 0;
 HEAP32[i43 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
 STACKTOP = i31;
 return;
}

function __ZN18DeferredRenderLoop13RenderGBufferEP13RenderTexturePS1_b8JobFencePK25DeferredRenderLoopScratchRi(i21, i9, i14, i15, i24, i18, i16) {
 i21 = i21 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i24 = i24 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i29 + 8 | 0;
 i25 = i29;
 i1 = i29 + 88 | 0;
 i8 = i29 + 72 | 0;
 i17 = i29 + 56 | 0;
 i10 = i29 + 40 | 0;
 i11 = i29 + 104 | 0;
 i12 = i29 + 24 | 0;
 i13 = i29 + 100 | 0;
 i22 = i21 + 8 | 0;
 if ((HEAP16[gb + 1114600 + 6 >> 1] | 0) > -1) {
  HEAP32[i25 >> 2] = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i25 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114600 | 0, i20);
  i26 = gb + 1114600 | 0;
 } else i26 = 0;
 i27 = HEAP32[gb + 1114600 >> 2] | 0;
 i23 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 648 >> 2] | 0, i23 | 0, i27 | 0);
 i27 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 4;
 i23 = HEAP32[gb + 1166248 >> 2] | 0;
 i28 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 148 >> 2] | 0, i28 | 0, 0);
 HEAP8[i1 + 1 >> 0] = -1;
 HEAP8[i1 + 3 >> 0] = 0;
 HEAP8[i1 + 4 >> 0] = 8;
 HEAP8[i1 + 6 >> 0] = 0;
 HEAP8[i1 + 7 >> 0] = 0;
 HEAP8[i1 + 8 >> 0] = 8;
 HEAP8[i1 + 10 >> 0] = 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 + 2 >> 0] = -17;
 HEAP8[i1 >> 0] = 1;
 HEAP8[i1 + 9 >> 0] = 2;
 HEAP8[i1 + 5 >> 0] = 2;
 i19 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 52 >> 2] | 0, i28 | 0, i1 | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 241 >> 0] | 0) {
  HEAP32[i8 + 8 >> 2] = 8;
  HEAP32[i8 + 12 >> 2] = 8;
 }
 HEAP32[i16 >> 2] = 4;
 i7 = __Z22GetRenderBufferManagerv() | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i1 = HEAP32[i16 >> 2] | 0;
 L7 : do if ((i1 | 0) > 0) {
  i4 = i9 + 128 | 0;
  if (!i15) {
   i1 = 0;
   while (1) {
    i3 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i7, -1, -1, 0, HEAP32[i8 + (i1 << 2) >> 2] | 0, 0, HEAP32[gb + 36740 + (i1 << 2) >> 2] | 0, 0, 1) | 0;
    if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, gb + 387706 | 0);
    __ZN7Texture13SetFilterModeEi(i3, 0);
    __ZN13RenderTexture6CreateEv(i3) | 0;
    i2 = i1 + 1 | 0;
    i6 = HEAP32[i3 + 128 >> 2] | 0;
    HEAP32[i10 + (i1 << 2) >> 2] = i6;
    HEAP32[i17 + (i1 << 2) >> 2] = i6;
    HEAP32[i14 + (i1 << 2) >> 2] = i3;
    __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[(HEAP32[i22 >> 2] | 0) + 1888 >> 2] | 0, i1 + 10 | 0, i3);
    if ((i2 | 0) < (HEAP32[i16 >> 2] | 0)) i1 = i2; else break L7;
   }
  }
  i5 = i17 + 12 | 0;
  i6 = i14 + 12 | 0;
  i2 = 0;
  i3 = 0;
  do {
   if ((i3 | 0) == 3) {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 >> 2] = i9;
   } else {
    i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i7, -1, -1, 0, HEAP32[i8 + (i3 << 2) >> 2] | 0, 0, HEAP32[gb + 36740 + (i3 << 2) >> 2] | 0, 0, 1) | 0;
    if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 387706 | 0);
    __ZN7Texture13SetFilterModeEi(i1, 0);
    __ZN13RenderTexture6CreateEv(i1) | 0;
    i30 = HEAP32[i1 + 128 >> 2] | 0;
    HEAP32[i10 + (i2 << 2) >> 2] = i30;
    HEAP32[i17 + (i3 << 2) >> 2] = i30;
    HEAP32[i14 + (i3 << 2) >> 2] = i1;
    __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[(HEAP32[i22 >> 2] | 0) + 1888 >> 2] | 0, i3 + 10 | 0, i1);
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i16 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 } else i2 = 0; while (0);
 i3 = HEAP32[i9 + 136 >> 2] | 0;
 if (i15) {
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i9, 0, -1, 0, 1);
  __ZN6Camera13ClearNoSkyboxEb(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, 1);
 }
 i30 = (HEAP32[(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0) + 844 >> 2] | 0) == 4;
 i1 = (i30 ? 4 : 12) | i15 & 1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i2, i10, i20, i14, 0, -1, 0, i1) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i30 ? 1 : 7, i12, Math_fround(1.0), 0, i23);
 if (i15) {
  i30 = HEAP32[i16 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i30, i17, i20, i14, 0, -1, 0, i1) | 0;
 }
 __Z15gpu_time_samplev();
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 112 >> 2] | 0, i28 | 0, (HEAP32[i22 >> 2] | 0) + 1732 | 0);
 if (__Z12GetIVRDevicev() | 0) {
  i30 = __Z12GetIVRDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i30 >> 2] | 0) + 56 >> 2] | 0, i30 | 0);
 }
 i17 = HEAP32[i22 >> 2] | 0;
 i30 = HEAP32[i17 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i30 + 1136 | 0, 4, i23, HEAP32[i17 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i30 + 4 >> 2] | 0);
 i30 = HEAP32[i22 >> 2] | 0;
 i17 = HEAP32[i30 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i17 + 1136 | 0, 4, i23, HEAP32[i30 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i17 + 4 >> 2] | 0);
 i17 = __Z19GetLightmapSettingsv() | 0;
 HEAP32[i21 + 12 >> 2] = __ZNK16LightmapSettings17AcquireSharedDataEv(i17) | 0;
 i30 = i21 + 244 | 0;
 __ZNK16LightmapSettings23GetLightmapDecodeValuesEv(i20, i17);
 HEAP32[i30 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 i30 = i21 + 260 | 0;
 __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv(i20, i17);
 HEAP32[i30 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0)) i1 = 0; else i1 = HEAP8[i23 + 149 >> 0] << 1 & 255 ^ 2;
 i30 = i21 + 408 | 0;
 HEAP8[i30 >> 0] = HEAP8[i30 >> 0] & -3 | i1;
 if (!(HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] | 0)) i1 = 1; else i1 = __Z22GetJobQueueThreadCountv() | 0;
 i12 = HEAP32[i21 + 28 >> 2] | 0;
 i11 = ((i12 >>> 0) / (i1 >>> 0) | 0) + 1 | 0;
 i11 = i11 >>> 0 > 128 ? i11 : 128;
 i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 16, gb + 64024 | 0, 0, gb + 387579 | 0, 1364) | 0;
 i3 = i18 + 172 | 0;
 i1 = 0;
 i10 = 0;
 do {
  i4 = i1 + i11 | 0;
  i2 = i1;
  i1 = i12 >>> 0 < i4 >>> 0 ? i12 : i4;
  i4 = __ZnwjRK10MemLabelIdiPKci(184, gb + 64024 | 0, 16, gb + 387579 | 0, 1371) | 0;
  HEAP32[i4 + 4 >> 2] = 1;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = gb + 36756 + 8;
  i5 = i4 + 12 | 0;
  i6 = i4 + 48 | 0;
  i7 = i4 + 52 | 0;
  i8 = i5;
  i9 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = 0;
   i8 = i8 + 4 | 0;
  } while ((i8 | 0) < (i9 | 0));
  HEAP32[i7 >> 2] = 1;
  HEAP32[i6 >> 2] = gb + 33952 + 8;
  i30 = gb + 64024 | 0;
  i18 = HEAP32[i30 + 4 >> 2] | 0;
  i17 = i25;
  HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  HEAP32[i4 + 80 >> 2] = 0;
  HEAP32[i4 + 92 >> 2] = 0;
  HEAP32[i4 + 96 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i25);
  i17 = i20;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i30 = i4 + 84 | 0;
  HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i30 + 4 >> 2] = i18;
  i30 = gb + 64024 | 0;
  i18 = HEAP32[i30 + 4 >> 2] | 0;
  i17 = i25;
  HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  HEAP32[i4 + 100 >> 2] = 0;
  HEAP32[i4 + 112 >> 2] = 0;
  HEAP32[i4 + 116 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i25);
  i17 = i20;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i30 = i4 + 104 | 0;
  HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i30 + 4 >> 2] = i18;
  i30 = gb + 64024 | 0;
  i18 = HEAP32[i30 + 4 >> 2] | 0;
  i17 = i25;
  HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  HEAP32[i4 + 120 >> 2] = 0;
  HEAP32[i4 + 132 >> 2] = 0;
  HEAP32[i4 + 136 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i25);
  i17 = i20;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i30 = i4 + 124 | 0;
  HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i30 + 4 >> 2] = i18;
  HEAP32[i4 + 140 >> 2] = 0;
  HEAP32[i4 + 144 >> 2] = 0;
  i30 = gb + 64024 | 0;
  i18 = HEAP32[i30 + 4 >> 2] | 0;
  i17 = i4 + 148 | 0;
  HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  i17 = i4 + 156 | 0;
  HEAP8[i17 >> 0] = 1;
  i18 = i4 + 56 | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i18 + 16 >> 2] = 0;
  HEAP32[i18 + 20 >> 2] = 0;
  HEAP8[i4 + 160 >> 0] = 1;
  HEAP8[i4 + 161 >> 0] = 0;
  i18 = i4 + 164 | 0;
  HEAP32[i18 >> 2] = 0;
  i30 = i4 + 172 | 0;
  HEAP8[i30 >> 0] = 0;
  i16 = i10;
  i10 = i10 + 1 | 0;
  HEAP32[i13 + (i16 << 2) >> 2] = i4;
  __ZN17ShaderPassContext8CopyFromERKS_(i5, i23);
  HEAP8[i17 >> 0] = 0;
  HEAP32[i4 + 168 >> 2] = i19;
  HEAP32[i4 + 176 >> 2] = i2;
  HEAP32[i4 + 180 >> 2] = i1;
  HEAP8[i30 >> 0] = HEAP8[i3 >> 0] | 0;
  i30 = HEAP32[i22 >> 2] | 0;
  HEAP32[i18 >> 2] = i30;
  i30 = i30 + 4 | 0;
  HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
 } while (i1 >>> 0 < i12 >>> 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i28 >> 2] | 0) + 892 >> 2] | 0, i28 | 0, i10 | 0, fb + 2391 | 0, i13 | 0, i21 | 0, i24 | 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i24);
 i30 = HEAP32[i22 >> 2] | 0;
 i25 = HEAP32[i30 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i25 + 1136 | 0, 5, i23, HEAP32[i30 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i25 + 4 >> 2] | 0);
 i25 = HEAP32[i22 >> 2] | 0;
 i30 = HEAP32[i25 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i30 + 1136 | 0, 5, i23, HEAP32[i25 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i30 + 4 >> 2] | 0);
 if (i10 | 0) {
  i1 = 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 296 >> 2] | 0, i28 | 0, HEAP32[i13 + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i13, gb + 64024 | 0);
 HEAP32[gb + 1163232 >> 2] = i27;
 i30 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i30 >> 2] | 0) + 652 >> 2] | 0, i30 | 0);
 if (!i26) {
  STACKTOP = i29;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i26);
 STACKTOP = i29;
 return;
}

function __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i39, i1) {
 i39 = i39 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i40 + 144 | 0;
 i34 = i40 + 128 | 0;
 i2 = i40 + 96 | 0;
 i8 = i40 + 64 | 0;
 i32 = i40 + 48 | 0;
 i33 = i40 + 32 | 0;
 i36 = i40 + 16 | 0;
 i37 = i40;
 i38 = HEAP32[i39 + 16 >> 2] | 0;
 i31 = i39 + 8 | 0;
 i1 = HEAP16[i31 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i39 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i6 = i1 + 4 | 0;
  i5 = i1;
  i4 = i1 + 24 | 0;
  i3 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i2, HEAP32[i39 >> 2] | 0, i1 & 65535);
  i7 = i2 + 8 | 0;
  i6 = i2 + 4 | 0;
  i5 = i2;
  i4 = i2 + 24 | 0;
  i3 = i2 + 20 | 0;
  i1 = i2 + 16 | 0;
 }
 i23 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i3 >> 2] | 0;
 i27 = HEAP32[i4 >> 2] | 0;
 i26 = HEAP32[i5 >> 2] | 0;
 i25 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i29 = i39 + 12 | 0;
 i1 = HEAP16[i29 >> 1] | 0;
 i30 = i39 + 4 | 0;
 if (i1 << 16 >> 16 == -1) {
  i1 = HEAP32[i30 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i5 = i1 + 4 | 0;
  i4 = i1;
  i3 = i1 + 24 | 0;
  i2 = i1 + 20 | 0;
  i1 = i1 + 16 | 0;
 } else {
  __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj(i8, HEAP32[i30 >> 2] | 0, i1 & 65535);
  i6 = i8 + 8 | 0;
  i5 = i8 + 4 | 0;
  i4 = i8;
  i3 = i8 + 24 | 0;
  i2 = i8 + 20 | 0;
  i1 = i8 + 16 | 0;
 }
 i16 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i28 = i38 + 1 | 0;
 if (!(HEAP8[i28 >> 0] | 0)) {
  i4 = i25;
  i5 = i26;
  i6 = i27;
  i25 = i1;
  f24 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f21 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  f20 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f24 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f21 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  i6 = i27;
  i5 = i26;
  i4 = i25;
  i25 = i38 + 48 | 0;
  i26 = 0;
  while (1) {
   f65 = Math_fround(HEAPF32[i25 >> 2]);
   f64 = Math_fround(HEAPF32[i25 + 4 >> 2]);
   f63 = Math_fround(HEAPF32[i25 + 8 >> 2]);
   f75 = Math_fround(HEAPF32[i25 + 12 >> 2]);
   i27 = i25 + 16 | 0;
   f59 = Math_fround(HEAPF32[i27 >> 2]);
   f58 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   i27 = i25 + 32 | 0;
   f62 = Math_fround(HEAPF32[i27 >> 2]);
   f61 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f60 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f74 = Math_fround(HEAPF32[i27 + 12 >> 2]);
   i27 = i25 + 48 | 0;
   f56 = Math_fround(HEAPF32[i27 >> 2]);
   f42 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f53 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f76 = Math_fround(HEAPF32[i27 + 12 >> 2]);
   i27 = i25 + 96 | 0;
   f68 = Math_fround(HEAPF32[i27 >> 2]);
   f66 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f41 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f52 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f52 * f62);
   f51 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f71 = Math_fround(f51 * f61);
   f47 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f47 * f60);
   f55 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f54 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f50 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(Math_fround(f55 * f65) + f73);
   f71 = Math_fround(Math_fround(f54 * f64) + f71);
   f69 = Math_fround(Math_fround(f50 * f63) + f69);
   f46 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f72 = Math_fround(f46 * f56);
   f45 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f70 = Math_fround(f45 * f42);
   f44 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(f44 * f53);
   f49 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f48 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f43 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f67 = Math_fround(Math_fround(f76 * f41) + Math_fround(f75 + Math_fround(f74 * Math_fround(Math_fround(Math_fround(f73 - Math_fround(Math_fround(f49 * f59) + f72)) + Math_fround(f71 - Math_fround(Math_fround(f48 * f58) + f70))) + Math_fround(f69 - Math_fround(Math_fround(f43 * f57) + f67))))));
   f67 = f68 > f67 ? f68 : f67;
   f66 = f66 > f67 ? f67 : f66;
   f41 = Math_fround(f66 - f41);
   HEAPF32[i25 + 104 >> 2] = f66;
   f20 = Math_fround(f20 + Math_fround(f65 * f41));
   f22 = Math_fround(f22 + Math_fround(f64 * f41));
   f24 = Math_fround(f24 + Math_fround(f63 * f41));
   f11 = Math_fround(f11 + Math_fround(f62 * f41));
   f13 = Math_fround(f13 + Math_fround(f61 * f41));
   f15 = Math_fround(f15 + Math_fround(f60 * f41));
   f17 = Math_fround(f17 + Math_fround(f59 * f41));
   f18 = Math_fround(f18 + Math_fround(f58 * f41));
   f21 = Math_fround(f21 + Math_fround(f57 * f41));
   f9 = Math_fround(f9 + Math_fround(f56 * f41));
   f10 = Math_fround(f10 + Math_fround(f42 * f41));
   f12 = Math_fround(f12 + Math_fround(f53 * f41));
   f53 = Math_fround(HEAPF32[i25 + 112 >> 2]);
   f42 = Math_fround(HEAPF32[i25 + 116 >> 2]);
   f53 = Math_fround(f55 + Math_fround(f53 * f41));
   f42 = Math_fround(f54 + Math_fround(f42 * f41));
   f50 = Math_fround(f50 + Math_fround(Math_fround(HEAPF32[i25 + 120 >> 2]) * f41));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
   f50 = Math_fround(HEAPF32[i25 + 128 >> 2]);
   f42 = Math_fround(HEAPF32[i25 + 132 >> 2]);
   f50 = Math_fround(f52 + Math_fround(f50 * f41));
   f42 = Math_fround(f51 + Math_fround(f42 * f41));
   f47 = Math_fround(f47 + Math_fround(Math_fround(HEAPF32[i25 + 136 >> 2]) * f41));
   i23 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   f47 = Math_fround(HEAPF32[i25 + 144 >> 2]);
   f42 = Math_fround(HEAPF32[i25 + 148 >> 2]);
   f47 = Math_fround(f49 + Math_fround(f47 * f41));
   f42 = Math_fround(f48 + Math_fround(f42 * f41));
   f43 = Math_fround(f43 + Math_fround(f41 * Math_fround(HEAPF32[i25 + 152 >> 2])));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f47, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
   f43 = Math_fround(HEAPF32[i25 + 160 >> 2]);
   f42 = Math_fround(HEAPF32[i25 + 164 >> 2]);
   f43 = Math_fround(f46 + Math_fround(f41 * f43));
   f42 = Math_fround(f45 + Math_fround(f41 * f42));
   f41 = Math_fround(f44 + Math_fround(f41 * Math_fround(HEAPF32[i25 + 168 >> 2])));
   i16 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
   i14 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
   i26 = i26 + 1 | 0;
   if (i26 >>> 0 >= (HEAPU8[i28 >> 0] | 0) >>> 0) {
    i25 = i1;
    break;
   } else i25 = i25 + 176 | 0;
  }
 }
 i1 = HEAP16[i31 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i39 = HEAP32[i39 >> 2] | 0;
  HEAP32[i39 >> 2] = i5;
  HEAP32[i39 + 4 >> 2] = i4;
  HEAP32[i39 + 8 >> 2] = i7;
  HEAP32[i39 + 16 >> 2] = i23;
  HEAP32[i39 + 20 >> 2] = i19;
  HEAP32[i39 + 24 >> 2] = i6;
 } else {
  i39 = HEAP32[i39 >> 2] | 0;
  f76 = Math_fround(HEAPF32[i38 + 32 >> 2]);
  f75 = Math_fround(f22 * f76);
  f74 = Math_fround(f24 * f76);
  HEAPF32[i32 >> 2] = Math_fround(f20 * f76);
  HEAPF32[i32 + 4 >> 2] = f75;
  HEAPF32[i32 + 8 >> 2] = f74;
  HEAPF32[i32 + 12 >> 2] = Math_fround(0.0);
  f74 = Math_fround(HEAPF32[i38 + 36 >> 2]);
  f75 = Math_fround(f13 * f74);
  f76 = Math_fround(f15 * f74);
  HEAPF32[i33 >> 2] = Math_fround(f11 * f74);
  HEAPF32[i33 + 4 >> 2] = f75;
  HEAPF32[i33 + 8 >> 2] = f76;
  HEAPF32[i33 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i34 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  HEAP32[i35 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i39, i1 & 65535, i34, i35);
 }
 i1 = HEAP16[i29 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i39 = HEAP32[i30 >> 2] | 0;
  HEAP32[i39 >> 2] = i3;
  HEAP32[i39 + 4 >> 2] = i2;
  HEAP32[i39 + 8 >> 2] = i25;
  HEAP32[i39 + 16 >> 2] = i16;
  HEAP32[i39 + 20 >> 2] = i14;
  HEAP32[i39 + 24 >> 2] = i8;
  STACKTOP = i40;
  return;
 } else {
  i39 = HEAP32[i30 >> 2] | 0;
  f76 = Math_fround(HEAPF32[i38 + 40 >> 2]);
  f75 = Math_fround(f18 * f76);
  f74 = Math_fround(f21 * f76);
  HEAPF32[i36 >> 2] = Math_fround(f17 * f76);
  HEAPF32[i36 + 4 >> 2] = f75;
  HEAPF32[i36 + 8 >> 2] = f74;
  HEAPF32[i36 + 12 >> 2] = Math_fround(0.0);
  f74 = Math_fround(HEAPF32[i38 + 44 >> 2]);
  f75 = Math_fround(f10 * f74);
  f76 = Math_fround(f12 * f74);
  HEAPF32[i37 >> 2] = Math_fround(f9 * f74);
  HEAPF32[i37 + 4 >> 2] = f75;
  HEAPF32[i37 + 8 >> 2] = f76;
  HEAPF32[i37 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
  HEAP32[i35 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
  __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i39, i1 & 65535, i34, i35);
  STACKTOP = i40;
  return;
 }
}

function __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 L1 : while (1) {
  i10 = i2;
  i11 = i2 + -20 | 0;
  i12 = i2 + -16 | 0;
  i13 = i2 + -12 | 0;
  i14 = i2 + -8 | 0;
  i15 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i10 - i9 | 0;
    switch ((i3 | 0) / 20 | 0 | 0) {
    case 2:
     {
      i16 = 5;
      break L1;
     }
    case 3:
     {
      i16 = 7;
      break L1;
     }
    case 4:
     {
      i16 = 8;
      break L1;
     }
    case 5:
     {
      i16 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i16 = 53;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 140) {
     i16 = 11;
     break L1;
    }
    i6 = i1 + (((i3 >>> 0) / 40 | 0) * 20 | 0) | 0;
    if ((i3 | 0) > 19980) {
     i3 = (i3 >>> 0) / 80 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_(i1, i1 + (i3 * 20 | 0) | 0, i6, i6 + (i3 * 20 | 0) | 0, i11, i17) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i1, i6, i11, i17) | 0;
    if (mftCall_iii(HEAP32[i17 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
     i5 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i5 = i4 + -20 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (mftCall_iii(HEAP32[i17 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
      i16 = 36;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 20 | 0;
    if (!(mftCall_iii(HEAP32[i17 >> 2] | 0, i1 | 0, i11 | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i16 = 53;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i17 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 20 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i16 = 53;
       break L1;
      }
     }
     i24 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i24;
     i24 = i3 + 4 | 0;
     i6 = HEAP32[i24 >> 2] | 0;
     i22 = i3 + 8 | 0;
     i7 = HEAP32[i22 >> 2] | 0;
     i20 = i3 + 12 | 0;
     i8 = HEAP32[i20 >> 2] | 0;
     i5 = i3 + 16 | 0;
     i9 = HEAP32[i5 >> 2] | 0;
     i23 = HEAP32[i13 >> 2] | 0;
     i21 = HEAP32[i14 >> 2] | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i22 >> 2] = i23;
     HEAP32[i20 >> 2] = i21;
     HEAP32[i5 >> 2] = i4;
     HEAP32[i12 >> 2] = i6;
     HEAP32[i13 >> 2] = i7;
     HEAP32[i14 >> 2] = i8;
     HEAP32[i15 >> 2] = i9;
     i3 = i3 + 20 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i16 = 53;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i6 = i3 + 20 | 0;
      if (mftCall_iii(HEAP32[i17 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i6;
     }
     while (1) {
      i5 = i4 + -20 | 0;
      if (mftCall_iii(HEAP32[i17 >> 2] | 0, i1 | 0, i5 | 0) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i29 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i29;
     i29 = i3 + 4 | 0;
     i20 = i4 + -16 | 0;
     i9 = HEAP32[i29 >> 2] | 0;
     i27 = i3 + 8 | 0;
     i21 = HEAP32[i27 >> 2] | 0;
     i25 = i3 + 12 | 0;
     i23 = HEAP32[i25 >> 2] | 0;
     i8 = i3 + 16 | 0;
     i3 = HEAP32[i8 >> 2] | 0;
     i22 = i4 + -12 | 0;
     i28 = HEAP32[i22 >> 2] | 0;
     i24 = i4 + -8 | 0;
     i26 = HEAP32[i24 >> 2] | 0;
     i4 = i4 + -4 | 0;
     i7 = HEAP32[i4 >> 2] | 0;
     HEAP32[i29 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i27 >> 2] = i28;
     HEAP32[i25 >> 2] = i26;
     HEAP32[i8 >> 2] = i7;
     HEAP32[i20 >> 2] = i9;
     HEAP32[i22 >> 2] = i21;
     HEAP32[i24 >> 2] = i23;
     HEAP32[i4 >> 2] = i3;
     i4 = i5;
     i3 = i6;
    }
   }
   if ((i16 | 0) == 36) {
    i16 = 0;
    i32 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i32;
    i32 = i1 + 4 | 0;
    i23 = i4 + -16 | 0;
    i22 = HEAP32[i32 >> 2] | 0;
    i30 = i1 + 8 | 0;
    i24 = HEAP32[i30 >> 2] | 0;
    i8 = i1 + 12 | 0;
    i26 = HEAP32[i8 >> 2] | 0;
    i21 = i1 + 16 | 0;
    i28 = HEAP32[i21 >> 2] | 0;
    i25 = i4 + -12 | 0;
    i31 = HEAP32[i25 >> 2] | 0;
    i27 = i4 + -8 | 0;
    i7 = HEAP32[i27 >> 2] | 0;
    i29 = i4 + -4 | 0;
    i20 = HEAP32[i29 >> 2] | 0;
    HEAP32[i32 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i30 >> 2] = i31;
    HEAP32[i8 >> 2] = i7;
    HEAP32[i21 >> 2] = i20;
    HEAP32[i23 >> 2] = i22;
    HEAP32[i25 >> 2] = i24;
    HEAP32[i27 >> 2] = i26;
    HEAP32[i29 >> 2] = i28;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 20 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i8 = i6;
    while (1) {
     while (1) {
      i7 = i4 + 20 | 0;
      if (mftCall_iii(HEAP32[i17 >> 2] | 0, i4 | 0, i8 | 0) | 0) i4 = i7; else break;
     }
     while (1) {
      i6 = i5 + -20 | 0;
      if (mftCall_iii(HEAP32[i17 >> 2] | 0, i6 | 0, i8 | 0) | 0) break; else i5 = i6;
     }
     if (i4 >>> 0 > i6 >>> 0) {
      i5 = i8;
      i6 = i4;
      break L35;
     }
     i33 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = i33;
     i33 = i4 + 4 | 0;
     i27 = i5 + -16 | 0;
     i26 = HEAP32[i33 >> 2] | 0;
     i21 = i4 + 8 | 0;
     i28 = HEAP32[i21 >> 2] | 0;
     i23 = i4 + 12 | 0;
     i30 = HEAP32[i23 >> 2] | 0;
     i25 = i4 + 16 | 0;
     i32 = HEAP32[i25 >> 2] | 0;
     i29 = i5 + -12 | 0;
     i20 = HEAP32[i29 >> 2] | 0;
     i31 = i5 + -8 | 0;
     i22 = HEAP32[i31 >> 2] | 0;
     i5 = i5 + -4 | 0;
     i24 = HEAP32[i5 >> 2] | 0;
     HEAP32[i33 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i21 >> 2] = i20;
     HEAP32[i23 >> 2] = i22;
     HEAP32[i25 >> 2] = i24;
     HEAP32[i27 >> 2] = i26;
     HEAP32[i29 >> 2] = i28;
     HEAP32[i31 >> 2] = i30;
     HEAP32[i5 >> 2] = i32;
     i8 = (i8 | 0) == (i4 | 0) ? i6 : i8;
     i5 = i6;
     i4 = i7;
     i3 = i3 + 1 | 0;
    }
   } else {
    i5 = i6;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) if (mftCall_iii(HEAP32[i17 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
    i8 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i8;
    i8 = i6 + 4 | 0;
    i27 = i5 + 4 | 0;
    i26 = HEAP32[i8 >> 2] | 0;
    i21 = i6 + 8 | 0;
    i28 = HEAP32[i21 >> 2] | 0;
    i23 = i6 + 12 | 0;
    i30 = HEAP32[i23 >> 2] | 0;
    i25 = i6 + 16 | 0;
    i32 = HEAP32[i25 >> 2] | 0;
    i29 = i5 + 8 | 0;
    i20 = HEAP32[i29 >> 2] | 0;
    i31 = i5 + 12 | 0;
    i22 = HEAP32[i31 >> 2] | 0;
    i33 = i5 + 16 | 0;
    i24 = HEAP32[i33 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i21 >> 2] = i20;
    HEAP32[i23 >> 2] = i22;
    HEAP32[i25 >> 2] = i24;
    HEAP32[i27 >> 2] = i26;
    HEAP32[i29 >> 2] = i28;
    HEAP32[i31 >> 2] = i30;
    HEAP32[i33 >> 2] = i32;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEbT0_SC_T_(i1, i6, i17) | 0;
    i4 = i6 + 20 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEbT0_SC_T_(i4, i2, i17) | 0) {
     i16 = 52;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i33 = i6;
   if ((i33 - i9 | 0) >= (i10 - i33 | 0)) {
    i16 = 51;
    break;
   }
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_(i1, i6, i17);
   i1 = i6 + 20 | 0;
  }
  if ((i16 | 0) == 51) {
   i16 = 0;
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_(i6 + 20 | 0, i2, i17);
   i2 = i6;
   continue;
  } else if ((i16 | 0) == 52) {
   i16 = 0;
   if (i3) {
    i16 = 53;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i16 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i17 >> 2] | 0, i11 | 0, i1 | 0) | 0)) {
   STACKTOP = i19;
   return;
  }
  i23 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i23;
  i23 = i1 + 4 | 0;
  i30 = HEAP32[i23 >> 2] | 0;
  i25 = i1 + 8 | 0;
  i31 = HEAP32[i25 >> 2] | 0;
  i27 = i1 + 12 | 0;
  i32 = HEAP32[i27 >> 2] | 0;
  i29 = i1 + 16 | 0;
  i33 = HEAP32[i29 >> 2] | 0;
  i24 = HEAP32[i13 >> 2] | 0;
  i26 = HEAP32[i14 >> 2] | 0;
  i28 = HEAP32[i15 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i25 >> 2] = i24;
  HEAP32[i27 >> 2] = i26;
  HEAP32[i29 >> 2] = i28;
  HEAP32[i12 >> 2] = i30;
  HEAP32[i13 >> 2] = i31;
  HEAP32[i14 >> 2] = i32;
  HEAP32[i15 >> 2] = i33;
  STACKTOP = i19;
  return;
 } else if ((i16 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i1, i1 + 20 | 0, i11, i17) | 0;
  STACKTOP = i19;
  return;
 } else if ((i16 | 0) == 8) {
  __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i11, i17) | 0;
  STACKTOP = i19;
  return;
 } else if ((i16 | 0) == 9) {
  __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_(i1, i1 + 20 | 0, i1 + 40 | 0, i1 + 60 | 0, i11, i17) | 0;
  STACKTOP = i19;
  return;
 } else if ((i16 | 0) == 11) {
  i3 = i1 + 40 | 0;
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i1, i1 + 20 | 0, i3, i17) | 0;
  i4 = i1 + 60 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i19;
   return;
  }
  i10 = i18 + 4 | 0;
  i11 = i18 + 8 | 0;
  i12 = i18 + 12 | 0;
  i13 = i18 + 16 | 0;
  while (1) {
   if (mftCall_iii(HEAP32[i17 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    HEAP32[i18 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i18 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i18 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    i5 = i4;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     i6 = i3 + 4 | 0;
     i7 = i3 + 8 | 0;
     i31 = HEAP32[i7 >> 2] | 0;
     i8 = i3 + 12 | 0;
     i32 = HEAP32[i8 >> 2] | 0;
     i9 = i3 + 16 | 0;
     i33 = HEAP32[i9 >> 2] | 0;
     HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i5 + 8 >> 2] = i31;
     HEAP32[i5 + 12 >> 2] = i32;
     HEAP32[i5 + 16 >> 2] = i33;
     if ((i3 | 0) == (i1 | 0)) break;
     i5 = i3 + -20 | 0;
     if (mftCall_iii(HEAP32[i17 >> 2] | 0, i18 | 0, i5 | 0) | 0) {
      i33 = i3;
      i3 = i5;
      i5 = i33;
     } else break;
    }
    HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
    i31 = HEAP32[i11 >> 2] | 0;
    i32 = HEAP32[i12 >> 2] | 0;
    i33 = HEAP32[i13 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 >> 2] = i31;
    HEAP32[i8 >> 2] = i32;
    HEAP32[i9 >> 2] = i33;
   }
   i3 = i4 + 20 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i33 = i4;
    i4 = i3;
    i3 = i33;
   }
  }
  STACKTOP = i19;
  return;
 } else if ((i16 | 0) == 53) {
  STACKTOP = i19;
  return;
 }
}
function __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv(i47) {
 i47 = i47 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0, f50 = f0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i49 + 24 | 0;
 i48 = i49 + 12 | 0;
 i45 = i49;
 i1 = HEAP32[i47 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i49;
  return;
 }
 i44 = (i2 >>> 0) / 17 | 0;
 i43 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 <= 16) {
  STACKTOP = i49;
  return;
 }
 i21 = i47 + 2156 | 0;
 i22 = i47 + 2160 | 0;
 i23 = i47 + 2164 | 0;
 i40 = i46 + 4 | 0;
 i41 = i46 + 8 | 0;
 i24 = i46 + 12 | 0;
 i25 = i48 + 4 | 0;
 i26 = i48 + 8 | 0;
 i27 = i45 + 4 | 0;
 i28 = i45 + 8 | 0;
 i29 = i47 + 2220 | 0;
 i42 = 0;
 do {
  i30 = HEAP32[i43 + (i42 * 68 | 0) >> 2] | 0;
  i11 = HEAP32[i43 + (i42 * 68 | 0) + 40 >> 2] | 0;
  i12 = HEAP32[i43 + (i42 * 68 | 0) + 44 >> 2] | 0;
  i13 = HEAP32[i43 + (i42 * 68 | 0) + 48 >> 2] | 0;
  i31 = i43 + (i42 * 68 | 0) + 4 | 0;
  f50 = Math_fround(HEAPF32[i21 >> 2]);
  f5 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
  i32 = i43 + (i42 * 68 | 0) + 16 | 0;
  f17 = Math_fround(HEAPF32[i32 >> 2]);
  f10 = Math_fround(HEAPF32[i31 >> 2]);
  f17 = Math_fround(f17 - f10);
  i33 = i43 + (i42 * 68 | 0) + 20 | 0;
  f18 = Math_fround(HEAPF32[i33 >> 2]);
  i34 = i43 + (i42 * 68 | 0) + 8 | 0;
  f8 = Math_fround(HEAPF32[i34 >> 2]);
  f18 = Math_fround(f18 - f8);
  i35 = i43 + (i42 * 68 | 0) + 24 | 0;
  f15 = Math_fround(HEAPF32[i35 >> 2]);
  i36 = i43 + (i42 * 68 | 0) + 12 | 0;
  f9 = Math_fround(HEAPF32[i36 >> 2]);
  f15 = Math_fround(f15 - f9);
  i37 = i43 + (i42 * 68 | 0) + 28 | 0;
  f19 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) - f10);
  i38 = i43 + (i42 * 68 | 0) + 32 | 0;
  f20 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) - f8);
  i39 = i43 + (i42 * 68 | 0) + 36 | 0;
  f16 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) - f9);
  f50 = Math_fround(f10 - f50);
  f5 = Math_fround(f8 - f5);
  f7 = Math_fround(f9 - f7);
  f9 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f15 * f15));
  f8 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * f20)) + Math_fround(f15 * f16));
  f10 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f16 * f16));
  f6 = Math_fround(Math_fround(Math_fround(f50 * f17) + Math_fround(f5 * f18)) + Math_fround(f7 * f15));
  f7 = Math_fround(Math_fround(Math_fround(f50 * f19) + Math_fround(f5 * f20)) + Math_fround(f7 * f16));
  f5 = Math_fround(Math_fround(f9 * f10) - Math_fround(f8 * f8));
  f50 = Math_fround(Math_fround(f8 * f7) - Math_fround(f6 * f10));
  f4 = Math_fround(Math_fround(f6 * f8) - Math_fround(f9 * f7));
  i2 = f50 < Math_fround(0.0);
  do if (!(Math_fround(f50 + f4) <= Math_fround(Math_abs(Math_fround(f5))))) {
   if (i2) {
    f4 = Math_fround(f6 + f8);
    f5 = Math_fround(f10 + f7);
    if (f5 > f4) {
     i1 = !(Math_fround(f5 - f4) >= Math_fround(f10 + Math_fround(f9 - Math_fround(f8 * Math_fround(2.0)))));
     i1 = i1 ? 4 : 1;
     i14 = 29;
     break;
    }
    if (f5 <= Math_fround(0.0)) {
     i14 = 38;
     break;
    }
    i1 = !(f7 >= Math_fround(0.0));
    i1 = i1 ? 5 : 0;
    i14 = 29;
    break;
   }
   if (!(f4 < Math_fround(0.0))) {
    f4 = Math_fround(Math_fround(Math_fround(f10 + f7) - f8) - f6);
    if (f4 <= Math_fround(0.0)) {
     i14 = 38;
     break;
    }
    i1 = !(f4 >= Math_fround(f10 + Math_fround(f9 - Math_fround(f8 * Math_fround(2.0)))));
    i1 = i1 ? 4 : 1;
    i14 = 29;
    break;
   }
   f4 = Math_fround(f8 + f7);
   f5 = Math_fround(f9 + f6);
   if (f5 > f4) {
    i1 = !(Math_fround(f5 - f4) >= Math_fround(f10 + Math_fround(f9 - Math_fround(f8 * Math_fround(2.0)))));
    i1 = i1 ? 4 : 2;
    i14 = 29;
    break;
   }
   if (!(f5 <= Math_fround(0.0))) {
    i1 = !(f6 >= Math_fround(0.0));
    i1 = i1 ? 3 : 0;
    i14 = 29;
   } else i14 = 34;
  } else {
   i1 = f4 < Math_fround(0.0);
   if (!i2) {
    if (!i1) {
     i1 = f5 == Math_fround(0.0);
     i1 = i1 ? 0 : 6;
     i14 = 29;
     break;
    }
    if (f6 >= Math_fround(0.0)) {
     i14 = 30;
     break;
    }
    i1 = !(f9 <= Math_fround(-f6));
    i1 = i1 ? 3 : 1;
    i14 = 29;
    break;
   }
   if (!i1) {
    if (f7 >= Math_fround(0.0)) {
     i14 = 30;
     break;
    }
    i1 = !(f10 <= Math_fround(-f7));
    i1 = i1 ? 5 : 2;
    i14 = 29;
    break;
   }
   if (f6 < Math_fround(0.0)) {
    i1 = !(f9 <= Math_fround(-f6));
    i1 = i1 ? 3 : 1;
    i14 = 29;
    break;
   }
   if (!(f7 >= Math_fround(0.0))) {
    i1 = !(f10 <= Math_fround(-f7));
    i1 = i1 ? 5 : 2;
    i14 = 29;
   } else i14 = 30;
  } while (0);
  L42 : do if ((i14 | 0) == 29) {
   i14 = 0;
   switch (i1 | 0) {
   case 0:
    {
     i14 = 30;
     break L42;
    }
   case 1:
    {
     i14 = 34;
     break L42;
    }
   case 2:
    {
     i14 = 38;
     break L42;
    }
   case 6:
    {
     i14 = 57;
     break L42;
    }
   case 3:
    {
     i2 = i11 >>> 0 < i12 >>> 0;
     i3 = i2 ? i11 : i12;
     i2 = i2 ? i12 : i11;
     i1 = i3 << 16 | i2;
     i1 = i1 + ~(i1 << 15) | 0;
     i1 = (i1 >>> 10 ^ i1) * 9 | 0;
     i1 = i1 >>> 6 ^ i1;
     i1 = i1 + ~(i1 << 11) | 0;
     i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i47 + 1156) >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break L42;
     }
     i1 = i1 & 255;
     while (1) {
      if ((HEAP32[i47 + 4 + (i1 << 3) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i47 + 4 + (i1 << 3) + 4 >> 2] | 0) == (i2 | 0)) break L42;
      i1 = HEAP8[i47 + 1028 + i1 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) {
       i14 = 57;
       break;
      } else i1 = i1 & 255;
     }
     break;
    }
   case 4:
    {
     i2 = i12 >>> 0 < i13 >>> 0;
     i3 = i2 ? i12 : i13;
     i2 = i2 ? i13 : i12;
     i1 = i3 << 16 | i2;
     i1 = i1 + ~(i1 << 15) | 0;
     i1 = (i1 >>> 10 ^ i1) * 9 | 0;
     i1 = i1 >>> 6 ^ i1;
     i1 = i1 + ~(i1 << 11) | 0;
     i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i47 + 1156) >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break L42;
     }
     i1 = i1 & 255;
     while (1) {
      if ((HEAP32[i47 + 4 + (i1 << 3) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i47 + 4 + (i1 << 3) + 4 >> 2] | 0) == (i2 | 0)) break L42;
      i1 = HEAP8[i47 + 1028 + i1 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) {
       i14 = 57;
       break;
      } else i1 = i1 & 255;
     }
     break;
    }
   case 5:
    {
     i2 = i11 >>> 0 < i13 >>> 0;
     i3 = i2 ? i11 : i13;
     i2 = i2 ? i13 : i11;
     i1 = i3 << 16 | i2;
     i1 = i1 + ~(i1 << 15) | 0;
     i1 = (i1 >>> 10 ^ i1) * 9 | 0;
     i1 = i1 >>> 6 ^ i1;
     i1 = i1 + ~(i1 << 11) | 0;
     i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i47 + 1156) >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break L42;
     }
     i1 = i1 & 255;
     while (1) {
      if ((HEAP32[i47 + 4 + (i1 << 3) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i47 + 4 + (i1 << 3) + 4 >> 2] | 0) == (i2 | 0)) break L42;
      i1 = HEAP8[i47 + 1028 + i1 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) {
       i14 = 57;
       break;
      } else i1 = i1 & 255;
     }
     break;
    }
   default:
    break L42;
   }
  } while (0);
  L66 : do if ((i14 | 0) == 30) {
   i14 = 0;
   i1 = HEAP8[(i11 & 127) + (i47 + 1928) >> 0] | 0;
   if (i1 << 24 >> 24 == -1) i14 = 57; else {
    i1 = i1 & 255;
    while (1) {
     if ((HEAP32[i47 + 1288 + (i1 << 2) >> 2] | 0) == (i11 | 0)) break L66;
     i1 = HEAP8[i47 + 1800 + i1 >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break;
     } else i1 = i1 & 255;
    }
   }
  } else if ((i14 | 0) == 34) {
   i14 = 0;
   i1 = HEAP8[(i12 & 127) + (i47 + 1928) >> 0] | 0;
   if (i1 << 24 >> 24 == -1) i14 = 57; else {
    i1 = i1 & 255;
    while (1) {
     if ((HEAP32[i47 + 1288 + (i1 << 2) >> 2] | 0) == (i12 | 0)) break L66;
     i1 = HEAP8[i47 + 1800 + i1 >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break;
     } else i1 = i1 & 255;
    }
   }
  } else if ((i14 | 0) == 38) {
   i14 = 0;
   i1 = HEAP8[(i13 & 127) + (i47 + 1928) >> 0] | 0;
   if (i1 << 24 >> 24 == -1) i14 = 57; else {
    i1 = i1 & 255;
    while (1) {
     if ((HEAP32[i47 + 1288 + (i1 << 2) >> 2] | 0) == (i13 | 0)) break L66;
     i1 = HEAP8[i47 + 1800 + i1 >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i14 = 57;
      break;
     } else i1 = i1 & 255;
    }
   }
  } while (0);
  if ((i14 | 0) == 57) {
   f7 = Math_fround(Math_fround(f18 * f16) - Math_fround(f15 * f20));
   f6 = Math_fround(Math_fround(f15 * f19) - Math_fround(f17 * f16));
   f4 = Math_fround(Math_fround(f17 * f20) - Math_fround(f18 * f19));
   f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
   if (f5 > Math_fround(0.0)) {
    f50 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
    f19 = Math_fround(f7 * f50);
    f20 = Math_fround(f6 * f50);
    f50 = Math_fround(f4 * f50);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i1 = 0;
    i2 = 0;
    i3 = 0;
   }
   HEAP32[i46 >> 2] = i3;
   HEAP32[i40 >> 2] = i2;
   HEAP32[i41 >> 2] = i1;
   f19 = Math_fround(HEAPF32[i31 >> 2]);
   f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f19);
   f20 = Math_fround(HEAPF32[i34 >> 2]);
   f18 = Math_fround(f18 + Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f20));
   f50 = Math_fround(HEAPF32[i36 >> 2]);
   HEAPF32[i24 >> 2] = Math_fround(-Math_fround(f18 + Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f50)));
   f19 = Math_fround(f19 + Math_fround(HEAPF32[i32 >> 2]));
   f20 = Math_fround(f20 + Math_fround(HEAPF32[i33 >> 2]));
   f50 = Math_fround(f50 + Math_fround(HEAPF32[i35 >> 2]));
   f19 = Math_fround(f19 + Math_fround(HEAPF32[i37 >> 2]));
   f20 = Math_fround(f20 + Math_fround(HEAPF32[i38 >> 2]));
   f20 = Math_fround(f20 * Math_fround(.333333343));
   f50 = Math_fround(Math_fround(f50 + Math_fround(HEAPF32[i39 >> 2])) * Math_fround(.333333343));
   HEAPF32[i48 >> 2] = Math_fround(f19 * Math_fround(.333333343));
   HEAPF32[i25 >> 2] = f20;
   HEAPF32[i26 >> 2] = f50;
   HEAP32[i45 >> 2] = HEAP32[i43 + (i42 * 68 | 0) + 52 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i43 + (i42 * 68 | 0) + 56 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i43 + (i42 * 68 | 0) + 60 >> 2];
   if (__ZNK5physx2Gu29ConvexVsMeshContactGeneration16generateContactsERKNS_7PxPlaneEPKNS_6PxVec3ERS6_RS5_fj(i47, i46, i31, i48, i45, Math_fround(HEAPF32[i43 + (i42 * 68 | 0) + 64 >> 2]), i30) | 0) HEAP8[i29 >> 0] = 1;
  }
  i42 = i42 + 1 | 0;
 } while (i42 >>> 0 < i44 >>> 0);
 STACKTOP = i49;
 return;
}

function __ZN13RendererScene15InitializeUmbraEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24 + 8 | 0;
 i14 = i24;
 i19 = i24 + 52 | 0;
 i20 = i24 + 32 | 0;
 __ZN13RendererScene22RecalculateDirtyBoundsEv(i16);
 i21 = i16 + 144 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i16 + 140 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, gb + 63600 | 0);
 HEAP32[i22 >> 2] = 0;
 i23 = i16 + 60 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i18 = i16 + 72 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i2 = i3 + (i4 * 24 | 0) | 0;
 L1 : do if (i4 | 0) {
  i1 = i3;
  do {
   HEAP32[i1 + 8 >> 2] = -1;
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = 0;
  i2 = i4;
  while (1) {
   if (!(HEAP32[i3 + (i1 * 24 | 0) >> 2] | 0)) {
    __ZN13RendererScene14RemoveRendererEi(i16, i1) | 0;
    i1 = i1 + -1 | 0;
    i2 = HEAP32[i18 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
   i3 = HEAP32[i23 >> 2] | 0;
  }
 } while (0);
 if (!(__Z30GetOcclusionCullingSettingsPtrv() | 0)) {
  STACKTOP = i24;
  return;
 }
 i4 = HEAP32[(__Z27GetOcclusionCullingSettingsv() | 0) + 28 >> 2] | 0;
 if (!i4) {
  STACKTOP = i24;
  return;
 }
 HEAP32[i14 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i15 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i14);
   i2 = HEAP32[i17 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 14; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i15 = 16;
  }
 }
 if ((i15 | 0) == 14) i15 = 16;
 if ((i15 | 0) == 16) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   STACKTOP = i24;
   return;
  }
 }
 HEAP32[i21 >> 2] = HEAP32[i1 + 32 >> 2];
 i13 = __ZNK20OcclusionCullingData22GetStaticRendererCountEv(i1) | 0;
 i9 = i19 + 12 | 0;
 HEAP32[i9 >> 2] = i13;
 i10 = i19 + 16 | 0;
 HEAP32[i10 >> 2] = i13;
 i11 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 64016 | 0);
 i5 = i17;
 i8 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = i8;
 HEAP32[i19 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i14;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i20 >> 2] = 0;
 i8 = i20 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i20 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i14);
 i5 = i17;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i13;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 __ZN19RuntimeSceneManager15GetLoadedScenesER13dynamic_arrayIP10UnitySceneLj4EE(__Z15GetSceneManagerv() | 0, i20);
 if (HEAP32[i8 >> 2] | 0) {
  i7 = 0;
  do {
   i6 = __ZNK10UnityScene19GetLevelGameManagerEi(HEAP32[(HEAP32[i20 >> 2] | 0) + (i7 << 2) >> 2] | 0, 24) | 0;
   if (i6 | 0) if ((((HEAP32[i6 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 35088 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 35088 + 28 >> 2] | 0) >>> 0) {
    i5 = HEAP32[i6 + 28 >> 2] | 0;
    if (i5 | 0) {
     HEAP32[i14 >> 2] = i5;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i15 = 29; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i2, i14);
       i3 = HEAP32[i17 >> 2] | 0;
       i25 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i25 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i25 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 29; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i15 = 31;
      }
     }
     if ((i15 | 0) == 29) i15 = 31;
     if ((i15 | 0) == 31) {
      i15 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     }
     if ((i2 | 0) != 0 & (i2 | 0) == (i1 | 0)) {
      i3 = i6 + 32 | 0;
      i2 = __ZNK20OcclusionCullingData8GetSceneERK9UnityGUID(i1, i6 + 72 | 0) | 0;
      if (i2 | 0) {
       i4 = HEAP32[i2 >> 2] | 0;
       i5 = i3 + 12 | 0;
       if (HEAP32[i5 >> 2] | 0) {
        i6 = HEAP32[i19 >> 2] | 0;
        i3 = HEAP32[i3 >> 2] | 0;
        i2 = 0;
        do {
         HEAP32[i6 + (i2 + i4 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
       }
      }
     }
    }
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (HEAP32[i8 >> 2] | 0));
 }
 i5 = __Z9GetIUmbrav() | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i21 >> 2] | 0) | 0;
 if ((i5 | 0) > 0) {
  i6 = i17 + 12 | 0;
  i4 = 0;
  do {
   i1 = __Z9GetIUmbrav() | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, HEAP32[i21 >> 2] | 0, i4 | 0) | 0;
   if (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i15 = 46; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i14);
      i2 = HEAP32[i17 >> 2] | 0;
      i25 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i25 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i25 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 46; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i15 = 51; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) {
       i1 = HEAP32[i1 + 284 >> 2] | 0;
       if ((i1 | 0) < 0) i15 = 51; else if ((i1 | 0) >= (HEAP32[i18 >> 2] | 0)) i15 = 51;
      } else i15 = 51;
     }
    }
    if ((i15 | 0) == 46) i15 = 51;
    if ((i15 | 0) == 51) {
     i15 = 0;
     HEAP32[i17 >> 2] = HEAP32[gb + 1162364 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
     HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
     i1 = __ZN13RendererScene19AddRendererInternalEP8RendereriRK4AABB(i16, 0, 0, i17) | 0;
    }
    HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 * 24 | 0) + 8 >> 2] = i4;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i2 = HEAP32[i18 >> 2] | 0;
 if (i2 | 0) {
  i6 = i16 + 80 | 0;
  i5 = i16 + 100 | 0;
  i4 = 0;
  i1 = HEAP32[i23 >> 2] | 0;
  do {
   i3 = HEAP32[i1 + (i4 * 24 | 0) + 8 >> 2] | 0;
   if (!((i3 | 0) == -1 | (i3 | 0) == (i4 | 0))) {
    do {
     i7 = i1 + (i4 * 24 | 0) | 0;
     i1 = i1 + (i3 * 24 | 0) | 0;
     HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i17 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i17 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP8[i7 + 20 >> 0] = HEAP8[i1 + 20 >> 0] | 0;
     HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
     HEAP8[i1 + 20 >> 0] = HEAP8[i17 + 20 >> 0] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     i7 = i1 + (i4 * 24 | 0) | 0;
     i9 = i1 + (i3 * 24 | 0) | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i14 = HEAP32[i1 + (i4 * 24 | 0) + 4 >> 2] | 0;
     i15 = HEAP32[i1 + (i4 * 24 | 0) + 8 >> 2] | 0;
     i16 = HEAP32[i1 + (i4 * 24 | 0) + 12 >> 2] | 0;
     i25 = HEAP32[i1 + (i4 * 24 | 0) + 16 >> 2] | 0;
     i2 = HEAP32[i1 + (i4 * 24 | 0) + 20 >> 2] | 0;
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i9 >> 2] = i8;
     HEAP32[i1 + (i3 * 24 | 0) + 4 >> 2] = i14;
     HEAP32[i1 + (i3 * 24 | 0) + 8 >> 2] = i15;
     HEAP32[i1 + (i3 * 24 | 0) + 12 >> 2] = i16;
     HEAP32[i1 + (i3 * 24 | 0) + 16 >> 2] = i25;
     HEAP32[i1 + (i3 * 24 | 0) + 20 >> 2] = i2;
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = i1 + i4 | 0;
     i1 = i1 + i3 | 0;
     i25 = HEAP8[i2 >> 0] | 0;
     HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = i25;
     i1 = HEAP32[i23 >> 2] | 0;
     i25 = HEAP32[i1 + (i4 * 24 | 0) >> 2] | 0;
     i2 = i25 + -32 | 0;
     if (!((i25 | 0) == 0 | (i2 | 0) == 0)) {
      __ZN8Renderer23NotifySceneHandleChangeEi(i2, i4);
      i1 = HEAP32[i23 >> 2] | 0;
     }
     i25 = HEAP32[i1 + (i3 * 24 | 0) >> 2] | 0;
     i2 = i25 + -32 | 0;
     if (!((i25 | 0) == 0 | (i2 | 0) == 0)) {
      __ZN8Renderer23NotifySceneHandleChangeEi(i2, i3);
      i1 = HEAP32[i23 >> 2] | 0;
     }
     i3 = HEAP32[i1 + (i4 * 24 | 0) + 8 >> 2] | 0;
    } while (!((i3 | 0) == -1 | (i3 | 0) == (i4 | 0)));
    i2 = HEAP32[i18 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 i25 = __Z9GetIUmbrav() | 0;
 HEAP32[i22 >> 2] = mftCall_iii(HEAP32[(HEAP32[i25 >> 2] | 0) + 44 >> 2] | 0, i25 | 0, HEAP32[i21 >> 2] | 0) | 0;
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i13);
  HEAP32[i20 >> 2] = 0;
 }
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i11);
  HEAP32[i19 >> 2] = 0;
 }
 STACKTOP = i24;
 return;
}

function __ZN12GraphicsCaps8InitNullEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 24 | 0;
 i14 = i17 + 16 | 0;
 i13 = i17 + 8 | 0;
 i12 = i17;
 i10 = i17 + 48 | 0;
 i11 = i17 + 32 | 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = -2147483632;
 i2 = i11 + 4 | 0;
 HEAP32[i2 >> 2] = 11;
 i5 = i1;
 i4 = gb + 612171 | 0;
 i6 = i5 + 11 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i1 + 11 >> 0] = 0;
 i6 = i11 + 11 | 0;
 do if ((i16 | 0) != (i11 | 0)) {
  i5 = HEAP8[i6 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i5 = i3 ? HEAP32[i2 >> 2] | 0 : i5 & 255;
  i3 = i16 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i16 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i4, i5 - i4 | 0, i1, 0, i1, i5, i7);
   break;
  }
  if (i2) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
  if (i5 | 0) _memmove(i1 | 0, i7 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i16 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 }
 i9 = i16 + 16 | 0;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i7;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 8 >> 2] = -2147483616;
 HEAP32[i11 + 4 >> 2] = 18;
 i5 = i7;
 i4 = gb + 612183 | 0;
 i6 = i5 + 18 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i7 + 18 >> 0] = 0;
 i4 = i11 + 11 | 0;
 i2 = i9 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 < 0) {
  i1 = (HEAP32[i16 + 24 >> 2] & 2147483647) + -1 | 0;
  if (i1 >>> 0 < 18) {
   i2 = HEAP32[i16 + 20 >> 2] | 0;
   i3 = 26;
   break;
  }
  i8 = HEAP32[i9 >> 2] | 0;
  _memmove(i8 | 0, i7 | 0, 18) | 0;
  HEAP8[i8 + 18 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i16 + 20 >> 2] = 18;
   i3 = 27;
   break;
  } else {
   HEAP8[i2 >> 0] = 18;
   i3 = 27;
   break;
  }
 } else {
  i1 = 10;
  i2 = i3 & 255;
  i3 = 26;
 } while (0);
 if ((i3 | 0) == 26) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i1, 18 - i1 | 0, i2, 0, i2, 18, i7);
  if ((HEAP8[i4 >> 0] | 0) < 0) i3 = 27;
 }
 if ((i3 | 0) == 27) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 i1 = i16 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i11 + 11 | 0;
 HEAP8[i4 >> 0] = 3;
 HEAP8[i11 >> 0] = HEAP8[gb + 766693 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 766693 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 766693 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = 0;
 L41 : do if ((i1 | 0) != (i11 | 0)) {
  i5 = i1 + 11 | 0;
  do if ((HEAP8[i5 >> 0] | 0) < 0) {
   i2 = HEAP32[i16 + 40 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 3) {
    i8 = HEAP32[i16 + 36 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 4 - i2 | 0, i8, 0, i8, 3, i11);
    break L41;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } while (0);
  _memmove(i1 | 0, i11 | 0, 3) | 0;
  HEAP8[i1 + 3 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i16 + 36 >> 2] = 3;
   break;
  } else {
   HEAP8[i5 >> 0] = 3;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 i1 = i16 + 48 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i2;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = -2147483632;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = 14;
 i5 = i2;
 i4 = gb + 612202 | 0;
 i6 = i5 + 14 | 0;
 do {
  HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
  i5 = i5 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i2 + 14 >> 0] = 0;
 i7 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i6 = HEAP8[i7 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i8 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i6 = i4 ? HEAP32[i3 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i16 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i16 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
   break;
  }
  if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  if (i6 | 0) _memmove(i2 | 0, i8 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i16 + 52 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 i2 = i16 + 64 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i5 = i11 + 11 | 0;
 HEAP8[i5 >> 0] = 6;
 HEAP8[i11 >> 0] = HEAP8[gb + 1057545 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 1057545 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 1057545 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = HEAP8[gb + 1057545 + 3 >> 0] | 0;
 HEAP8[i11 + 4 >> 0] = HEAP8[gb + 1057545 + 4 >> 0] | 0;
 HEAP8[i11 + 5 >> 0] = HEAP8[gb + 1057545 + 5 >> 0] | 0;
 HEAP8[i11 + 6 >> 0] = 0;
 L83 : do if ((i2 | 0) != (i11 | 0)) {
  i6 = i2 + 11 | 0;
  do if ((HEAP8[i6 >> 0] | 0) < 0) {
   i3 = HEAP32[i16 + 72 >> 2] & 2147483647;
   i4 = i3 + -1 | 0;
   if (i4 >>> 0 < 6) {
    i8 = HEAP32[i16 + 68 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i4, 7 - i3 | 0, i8, 0, i8, 6, i11);
    break L83;
   } else {
    i2 = HEAP32[i2 >> 2] | 0;
    break;
   }
  } while (0);
  _memmove(i2 | 0, i11 | 0, 6) | 0;
  HEAP8[i2 + 6 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i16 + 68 >> 2] = 6;
   break;
  } else {
   HEAP8[i6 >> 0] = 6;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 HEAPF32[i16 + 100 >> 2] = Math_fround(128.0);
 HEAP32[i16 + 84 >> 2] = 0;
 HEAP32[i16 + 80 >> 2] = 0;
 _printf_console(gb + 612217 | 0, i12);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 _printf_console(gb + 612233 | 0, i13);
 if ((HEAP8[i16 + 11 >> 0] | 0) < 0) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
 HEAP32[i14 >> 2] = i1;
 _printf_console(gb + 612251 | 0, i14);
 if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i15 >> 2] = i5;
  _printf_console(gb + 612269 | 0, i15);
  i5 = i16 + 88 | 0;
  HEAP32[i5 >> 2] = 30;
  i5 = i16 + 152 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 112 | 0;
  HEAP32[i5 >> 2] = 0;
  i5 = i16 + 153 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 156 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 161 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i16 + 162 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i16 + 170 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 116 | 0;
  HEAP32[i5 >> 2] = 8;
  i5 = i16 + 120 | 0;
  HEAP32[i5 >> 2] = 16;
  i5 = i16 + 124 | 0;
  HEAP32[i5 >> 2] = 4096;
  i5 = i16 + 128 | 0;
  HEAP32[i5 >> 2] = 512;
  i5 = i16 + 132 | 0;
  HEAP32[i5 >> 2] = 4096;
  i5 = i16 + 171 | 0;
  i6 = i5 + 62 | 0;
  do {
   HEAP8[i5 >> 0] = 1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i1 = i16 + 233 | 0;
  i5 = i16 + 234 | 0;
  i6 = i5 + 22 | 0;
  do {
   HEAP8[i5 >> 0] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP8[i1 >> 0] = 1;
  i15 = i16 + 481 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 484 | 0;
  HEAP32[i15 >> 2] = 1;
  i15 = i16 + 488 | 0;
  HEAP32[i15 >> 2] = 1;
  i15 = i16 + 500 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 505 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 506 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 507 | 0;
  HEAP8[i15 >> 0] = 0;
  i16 = i16 + 514 | 0;
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i17;
  return;
 } else {
  i5 = i9;
  HEAP32[i15 >> 2] = i5;
  _printf_console(gb + 612269 | 0, i15);
  i5 = i16 + 88 | 0;
  HEAP32[i5 >> 2] = 30;
  i5 = i16 + 152 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 112 | 0;
  HEAP32[i5 >> 2] = 0;
  i5 = i16 + 153 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 156 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 161 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i16 + 162 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i16 + 170 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i16 + 116 | 0;
  HEAP32[i5 >> 2] = 8;
  i5 = i16 + 120 | 0;
  HEAP32[i5 >> 2] = 16;
  i5 = i16 + 124 | 0;
  HEAP32[i5 >> 2] = 4096;
  i5 = i16 + 128 | 0;
  HEAP32[i5 >> 2] = 512;
  i5 = i16 + 132 | 0;
  HEAP32[i5 >> 2] = 4096;
  i5 = i16 + 171 | 0;
  i6 = i5 + 62 | 0;
  do {
   HEAP8[i5 >> 0] = 1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i1 = i16 + 233 | 0;
  i5 = i16 + 234 | 0;
  i6 = i5 + 22 | 0;
  do {
   HEAP8[i5 >> 0] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP8[i1 >> 0] = 1;
  i15 = i16 + 481 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 484 | 0;
  HEAP32[i15 >> 2] = 1;
  i15 = i16 + 488 | 0;
  HEAP32[i15 >> 2] = 1;
  i15 = i16 + 500 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 505 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 506 | 0;
  HEAP8[i15 >> 0] = 0;
  i15 = i16 + 507 | 0;
  HEAP8[i15 >> 0] = 0;
  i16 = i16 + 514 | 0;
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i17;
  return;
 }
}

function __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i43, i42, i57, i58, i59, i60) {
 i1 = i1 | 0;
 i43 = i43 | 0;
 i42 = i42 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i56 = i61 + 240 | 0;
 i54 = i61 + 176 | 0;
 i55 = i61 + 112 | 0;
 i27 = i61 + 96 | 0;
 i53 = i61 + 340 | 0;
 i47 = i61 + 80 | 0;
 i50 = i61 + 64 | 0;
 i51 = i61 + 48 | 0;
 i48 = i61 + 328 | 0;
 i52 = i61 + 32 | 0;
 i44 = i61 + 16 | 0;
 i24 = i61;
 i23 = i61 + 316 | 0;
 i49 = i61 + 304 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i53 >> 2] = 0;
 i25 = i42 + 48 | 0;
 f8 = Math_fround(HEAPF32[i25 >> 2]);
 i31 = i42 + 52 | 0;
 f9 = Math_fround(HEAPF32[i31 >> 2]);
 i41 = i42 + 56 | 0;
 f10 = Math_fround(HEAPF32[i41 >> 2]);
 i45 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i45 ? f8 : Math_fround(1.0);
 f11 = i45 ? f9 : Math_fround(0.0);
 f7 = i45 ? f10 : Math_fround(0.0);
 HEAPF32[i47 >> 2] = f12;
 i45 = i47 + 4 | 0;
 HEAPF32[i45 >> 2] = f11;
 i46 = i47 + 8 | 0;
 HEAPF32[i46 >> 2] = f7;
 HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i43 + 32 >> 2]);
 f26 = Math_fround((f26 > f2 ? f2 : f26) * Math_fround(.100000001));
 f26 = Math_fround(f26 * f26);
 HEAP32[i50 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i52 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 HEAP32[i52 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
 i27 = i42 + 4 | 0;
 i28 = i42 + 8 | 0;
 i29 = i42 + 16 | 0;
 i30 = i42 + 20 | 0;
 i32 = i42 + 24 | 0;
 i33 = i42 + 32 | 0;
 i34 = i42 + 36 | 0;
 i35 = i42 + 40 | 0;
 i36 = i1 + 96 | 0;
 i37 = i1 + 100 | 0;
 i38 = i1 + 104 | 0;
 i39 = i1 + 112 | 0;
 i40 = i1 + 116 | 0;
 i4 = i1 + 120 | 0;
 i13 = i44 + 4 | 0;
 i14 = i44 + 8 | 0;
 i15 = i24 + 4 | 0;
 i16 = i24 + 8 | 0;
 i17 = i24 + 12 | 0;
 i18 = i56 + 4 | 0;
 i19 = i56 + 8 | 0;
 i20 = i56 + 16 | 0;
 i21 = i56 + 20 | 0;
 i22 = i56 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  HEAP32[i52 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  f65 = Math_fround(-f12);
  f74 = Math_fround(-f11);
  f75 = Math_fround(-f7);
  f70 = Math_fround(HEAPF32[i42 >> 2]);
  f77 = Math_fround(f70 * f65);
  f67 = Math_fround(HEAPF32[i27 >> 2]);
  f77 = Math_fround(f77 + Math_fround(f67 * f74));
  f63 = Math_fround(HEAPF32[i28 >> 2]);
  f77 = Math_fround(f77 + Math_fround(f63 * f75));
  f69 = Math_fround(HEAPF32[i29 >> 2]);
  f76 = Math_fround(f69 * f65);
  f66 = Math_fround(HEAPF32[i30 >> 2]);
  f76 = Math_fround(f76 + Math_fround(f66 * f74));
  f5 = Math_fround(HEAPF32[i32 >> 2]);
  f76 = Math_fround(f76 + Math_fround(f5 * f75));
  f71 = Math_fround(HEAPF32[i33 >> 2]);
  f65 = Math_fround(f71 * f65);
  f68 = Math_fround(HEAPF32[i34 >> 2]);
  f74 = Math_fround(f65 + Math_fround(f68 * f74));
  f65 = Math_fround(HEAPF32[i35 >> 2]);
  f75 = Math_fround(f74 + Math_fround(f65 * f75));
  f74 = Math_fround(HEAPF32[i36 >> 2]);
  f73 = Math_fround(HEAPF32[i37 >> 2]);
  f72 = Math_fround(HEAPF32[i38 >> 2]);
  f78 = Math_fround(Math_fround(Math_fround(f77 * f74) + Math_fround(f76 * f73)) + Math_fround(f75 * f72));
  f6 = Math_fround(HEAPF32[i39 >> 2]);
  f3 = Math_fround(HEAPF32[i40 >> 2]);
  f64 = Math_fround(HEAPF32[i4 >> 2]);
  i1 = f78 > Math_fround(Math_fround(Math_fround(f77 * f6) + Math_fround(f76 * f3)) + Math_fround(f75 * f64));
  f6 = i1 ? f74 : f6;
  f3 = i1 ? f73 : f3;
  f64 = i1 ? f72 : f64;
  f8 = Math_fround(f8 + Math_fround(Math_fround(f71 * f64) + Math_fround(Math_fround(f70 * f6) + Math_fround(f69 * f3))));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f68 * f64) + Math_fround(Math_fround(f67 * f6) + Math_fround(f66 * f3))));
  f10 = Math_fround(f10 + Math_fround(Math_fround(f65 * f64) + Math_fround(Math_fround(f63 * f6) + Math_fround(f5 * f3))));
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i44, i43, i47);
  f3 = Math_fround(HEAPF32[i44 >> 2]);
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f3 = Math_fround(f8 - f3);
  f5 = Math_fround(f9 - f5);
  f6 = Math_fround(f10 - Math_fround(HEAPF32[i14 >> 2]));
  f12 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f12 * f3) + Math_fround(f11 * f5)) + Math_fround(f6 * f7)));
  i1 = HEAP32[i53 >> 2] | 0;
  HEAPF32[i54 + (i1 << 4) >> 2] = f8;
  HEAPF32[i54 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i54 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i54 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i62 = i55 + (i1 << 4) | 0;
  HEAP32[i62 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i62 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  HEAPF32[i56 + (i1 << 4) >> 2] = f3;
  HEAPF32[i56 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i56 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i56 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i53 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i56 >> 2]);
    f5 = Math_fround(HEAPF32[i18 >> 2]);
    f6 = Math_fround(HEAPF32[i19 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f76 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i62 = f76 > Math_fround(1.0);
     f76 = i62 ? Math_fround(1.0) : f76;
     i62 = f76 > Math_fround(0.0);
     f76 = i62 ? f76 : Math_fround(0.0);
     f77 = Math_fround(f5 + Math_fround(f8 * f76));
     f78 = Math_fround(f6 + Math_fround(f9 * f76));
     HEAPF32[i24 >> 2] = Math_fround(f3 + Math_fround(f7 * f76));
     HEAPF32[i15 >> 2] = f77;
     HEAPF32[i16 >> 2] = f78;
     HEAPF32[i17 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i53 >> 2] = 1;
     HEAP32[i24 >> 2] = HEAP32[i56 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
     HEAP32[i24 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i56, i54, i55, i53);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i56, i54, i55, i53);
    break;
   }
  default:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i47 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i47 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i47 >> 2]);
  f6 = Math_fround(HEAPF32[i45 >> 2]);
  f7 = Math_fround(HEAPF32[i46 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i48 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f26 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f9 = Math_fround(HEAPF32[i31 >> 2]);
  f10 = Math_fround(HEAPF32[i41 >> 2]);
  f2 = f3;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i47, i57, i58, i1);
  f76 = Math_fround(HEAPF32[i47 >> 2]);
  f77 = Math_fround(HEAPF32[i45 >> 2]);
  f75 = Math_fround(HEAPF32[i46 >> 2]);
  f78 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f76 * f76) + Math_fround(f77 * f77)) + Math_fround(f75 * f75)))));
  f76 = Math_fround(-Math_fround(f76 * f78));
  f77 = Math_fround(-Math_fround(f77 * f78));
  f78 = Math_fround(-Math_fround(f75 * f78));
  HEAPF32[i60 >> 2] = f2;
  i62 = i60 + 4 | 0;
  HEAP32[i62 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAPF32[i59 >> 2] = f76;
  HEAPF32[i59 + 4 >> 2] = f77;
  HEAPF32[i59 + 8 >> 2] = f78;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  i62 = 0;
  STACKTOP = i61;
  return i62 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i52, i57, i58, HEAP32[i53 >> 2] | 0);
  HEAP32[i57 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i57 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  HEAP32[i58 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i58 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  f75 = Math_fround(HEAPF32[i52 >> 2]);
  f77 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  f78 = Math_fround(HEAPF32[i52 + 8 >> 2]);
  f76 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f75 * f75) + Math_fround(f77 * f77)) + Math_fround(f78 * f78)))));
  f77 = Math_fround(-Math_fround(f77 * f76));
  f78 = Math_fround(-Math_fround(f78 * f76));
  HEAPF32[i59 >> 2] = Math_fround(-Math_fround(f75 * f76));
  HEAPF32[i59 + 4 >> 2] = f77;
  HEAPF32[i59 + 8 >> 2] = f78;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i60 >> 2] = i1 ? f3 : f2;
  i62 = i60 + 4 | 0;
  HEAP32[i62 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  i62 = i1 ? 1 : 3;
  STACKTOP = i61;
  return i62 | 0;
 }
 return 0;
}

function __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 116 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 124 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 128 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_(i40, i45, i47, i37, i41, i1, i43, i44) {
 i40 = i40 | 0;
 i45 = i45 | 0;
 i47 = i47 | 0;
 i37 = i37 | 0;
 i41 = i41 | 0;
 i1 = i1 | 0;
 i43 = i43 | 0;
 i44 = i44 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i42 = 0, i46 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i51 = i52 + 112 | 0;
 i46 = i52 + 96 | 0;
 i38 = i52 + 80 | 0;
 i39 = i52 + 64 | 0;
 i42 = i52 + 48 | 0;
 i49 = i52 + 32 | 0;
 i50 = i52 + 16 | 0;
 i48 = i52;
 f5 = Math_fround(HEAPF32[i47 >> 2]);
 i22 = i47 + 4 | 0;
 f3 = Math_fround(HEAPF32[i22 >> 2]);
 i33 = i47 + 8 | 0;
 f53 = Math_fround(HEAPF32[i33 >> 2]);
 f21 = Math_fround(HEAPF32[i45 >> 2]);
 i35 = i45 + 4 | 0;
 f20 = Math_fround(HEAPF32[i35 >> 2]);
 i36 = i45 + 8 | 0;
 f54 = Math_fround(HEAPF32[i36 >> 2]);
 f14 = Math_fround(f3 - f20);
 f15 = Math_fround(f53 - f54);
 HEAPF32[i46 >> 2] = Math_fround(f5 - f21);
 i23 = i46 + 4 | 0;
 HEAPF32[i23 >> 2] = f14;
 i24 = i46 + 8 | 0;
 HEAPF32[i24 >> 2] = f15;
 HEAPF32[i46 + 12 >> 2] = Math_fround(0.0);
 f15 = Math_fround(HEAPF32[i41 >> 2]);
 i25 = i41 + 4 | 0;
 f14 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i41 + 8 | 0;
 f13 = Math_fround(HEAPF32[i26 >> 2]);
 f6 = Math_fround(HEAPF32[i37 >> 2]);
 i27 = i37 + 4 | 0;
 f2 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i37 + 8 | 0;
 f4 = Math_fround(HEAPF32[i28 >> 2]);
 f29 = Math_fround(f15 - f6);
 f30 = Math_fround(f14 - f2);
 f31 = Math_fround(f13 - f4);
 HEAPF32[i38 >> 2] = f29;
 i32 = i38 + 4 | 0;
 HEAPF32[i32 >> 2] = f30;
 i34 = i38 + 8 | 0;
 HEAPF32[i34 >> 2] = f31;
 HEAPF32[i38 + 12 >> 2] = Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(f16 - f6);
 f8 = Math_fround(f18 - f2);
 f9 = Math_fround(f17 - f4);
 HEAPF32[i39 >> 2] = f7;
 i1 = i39 + 4 | 0;
 HEAPF32[i1 >> 2] = f8;
 i10 = i39 + 8 | 0;
 HEAPF32[i10 >> 2] = f9;
 HEAPF32[i39 + 12 >> 2] = Math_fround(0.0);
 f14 = Math_fround(f18 - f14);
 f13 = Math_fround(f17 - f13);
 HEAPF32[i42 >> 2] = Math_fround(f16 - f15);
 i11 = i42 + 4 | 0;
 HEAPF32[i11 >> 2] = f14;
 i12 = i42 + 8 | 0;
 HEAPF32[i12 >> 2] = f13;
 HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
 f13 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31));
 f14 = Math_fround(Math_fround(Math_fround(f29 * f7) + Math_fround(f30 * f8)) + Math_fround(f31 * f9));
 f15 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f13 * f15) - Math_fround(f14 * f14)));
 f17 = Math_fround(Math_fround(f30 * f9) - Math_fround(f31 * f8));
 f18 = Math_fround(Math_fround(f31 * f7) - Math_fround(f29 * f9));
 f55 = Math_fround(Math_fround(f29 * f8) - Math_fround(f30 * f7));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f55 * f55) + Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18))))));
 f17 = Math_fround(f17 * f19);
 f18 = Math_fround(f18 * f19);
 f19 = Math_fround(f55 * f19);
 f20 = Math_fround(Math_fround(Math_fround(f54 - f4) * f19) + Math_fround(Math_fround(Math_fround(f21 - f6) * f17) + Math_fround(Math_fround(f20 - f2) * f18)));
 f21 = Math_fround(f20 * f20);
 f2 = Math_fround(Math_fround(Math_fround(f53 - f4) * f19) + Math_fround(Math_fround(Math_fround(f5 - f6) * f17) + Math_fround(Math_fround(f3 - f2) * f18)));
 f3 = Math_fround(f2 * f2);
 if (Math_fround(f20 * f2) < Math_fround(0.0)) {
  f53 = Math_fround(HEAPF32[i46 >> 2]);
  f55 = Math_fround(HEAPF32[i23 >> 2]);
  f56 = Math_fround(HEAPF32[i24 >> 2]);
  f6 = Math_fround(-Math_fround(f20 * Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f17 * f53) + Math_fround(f18 * f55)) + Math_fround(f19 * f56)))));
  f4 = Math_fround(HEAPF32[i45 >> 2]);
  f5 = Math_fround(HEAPF32[i35 >> 2]);
  f4 = Math_fround(Math_fround(f53 * f6) + f4);
  f5 = Math_fround(Math_fround(f55 * f6) + f5);
  f6 = Math_fround(Math_fround(f56 * f6) + Math_fround(HEAPF32[i36 >> 2]));
  f56 = Math_fround(HEAPF32[i37 >> 2]);
  f55 = Math_fround(HEAPF32[i27 >> 2]);
  f56 = Math_fround(f4 - f56);
  f55 = Math_fround(f5 - f55);
  f53 = Math_fround(f6 - Math_fround(HEAPF32[i28 >> 2]));
  f54 = Math_fround(Math_fround(Math_fround(f56 * f29) + Math_fround(f55 * f30)) + Math_fround(f53 * f31));
  f53 = Math_fround(Math_fround(Math_fround(f56 * f7) + Math_fround(f55 * f8)) + Math_fround(f53 * f9));
  f55 = Math_fround(f16 * Math_fround(Math_fround(f15 * f54) - Math_fround(f14 * f53)));
  f54 = Math_fround(f16 * Math_fround(Math_fround(f13 * f53) - Math_fround(f14 * f54)));
  if (f55 >= Math_fround(-1.1920929e-07) & f55 <= Math_fround(1.00000012) & (f54 >= Math_fround(-1.1920929e-07) & f54 <= Math_fround(1.00000012) & Math_fround(f54 + f55) < Math_fround(1.00000012))) {
   HEAPF32[i44 >> 2] = f4;
   HEAPF32[i44 + 4 >> 2] = f5;
   HEAPF32[i44 + 8 >> 2] = f6;
   HEAPF32[i44 + 12 >> 2] = Math_fround(0.0);
   HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
   HEAP32[i43 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   HEAPF32[i40 >> 2] = Math_fround(0.0);
   i50 = i40 + 4 | 0;
   HEAP32[i50 >> 2] = HEAP32[i51 >> 2];
   HEAP32[i50 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
   HEAP32[i50 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
   STACKTOP = i52;
   return;
  }
 }
 __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_(i48, i45, i46, i37, i38, i41, i42, i37, i39, i37, i38, i49, i50);
 f71 = Math_fround(HEAPF32[i49 >> 2]);
 f70 = Math_fround(HEAPF32[i49 + 4 >> 2]);
 f69 = Math_fround(HEAPF32[i49 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i50 >> 2]);
 f63 = Math_fround(HEAPF32[i50 + 4 >> 2]);
 f53 = Math_fround(HEAPF32[i50 + 8 >> 2]);
 f73 = Math_fround(HEAPF32[i48 >> 2]);
 f72 = Math_fround(HEAPF32[i48 + 4 >> 2]);
 f60 = Math_fround(HEAPF32[i48 + 8 >> 2]);
 f58 = Math_fround(HEAPF32[i46 >> 2]);
 f5 = Math_fround(HEAPF32[i23 >> 2]);
 f29 = Math_fround(HEAPF32[i24 >> 2]);
 f59 = Math_fround(HEAPF32[i45 >> 2]);
 f57 = Math_fround(HEAPF32[i35 >> 2]);
 f6 = Math_fround(HEAPF32[i36 >> 2]);
 f64 = Math_fround(HEAPF32[i38 >> 2]);
 f55 = Math_fround(HEAPF32[i32 >> 2]);
 f4 = Math_fround(HEAPF32[i34 >> 2]);
 f54 = Math_fround(HEAPF32[i37 >> 2]);
 f65 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(HEAPF32[i28 >> 2]);
 f68 = Math_fround(Math_fround(f9 * f64) + f54);
 f66 = Math_fround(Math_fround(f9 * f55) + f65);
 f9 = Math_fround(Math_fround(f9 * f4) + f7);
 f61 = Math_fround(HEAPF32[i42 >> 2]);
 f62 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i12 >> 2]);
 f67 = Math_fround(HEAPF32[i41 >> 2]);
 f56 = Math_fround(HEAPF32[i25 >> 2]);
 f67 = Math_fround(Math_fround(f63 * f61) + f67);
 f56 = Math_fround(Math_fround(f63 * f62) + f56);
 f8 = Math_fround(Math_fround(f63 * f8) + Math_fround(HEAPF32[i26 >> 2]));
 f63 = Math_fround(HEAPF32[i39 >> 2]);
 f62 = Math_fround(HEAPF32[i1 >> 2]);
 f61 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(Math_fround(f53 * f63) + f54);
 f31 = Math_fround(Math_fround(f53 * f62) + f65);
 f53 = Math_fround(Math_fround(f53 * f61) + f7);
 i51 = f72 > f73 & f60 > f73;
 i49 = f73 >= f72 & f60 > f72;
 f60 = i51 ? f73 : i49 ? f72 : f60;
 f58 = Math_fround(Math_fround((i51 ? f71 : i49 ? f70 : f69) * f58) + f59);
 f5 = Math_fround(Math_fround((i51 ? f71 : i49 ? f70 : f69) * f5) + f57);
 f29 = Math_fround(Math_fround((i51 ? f71 : i49 ? f70 : f69) * f29) + f6);
 f30 = i51 ? f68 : i49 ? f67 : f30;
 f31 = i51 ? f66 : i49 ? f56 : f31;
 f53 = i51 ? f9 : i49 ? f8 : f53;
 f8 = Math_fround(f59 - Math_fround(f17 * f20));
 f9 = Math_fround(f57 - Math_fround(f18 * f20));
 f56 = Math_fround(f6 - Math_fround(f19 * f20));
 f54 = Math_fround(f8 - f54);
 f20 = Math_fround(f9 - f65);
 f7 = Math_fround(f56 - f7);
 f4 = Math_fround(Math_fround(Math_fround(f54 * f64) + Math_fround(f20 * f55)) + Math_fround(f7 * f4));
 f7 = Math_fround(Math_fround(Math_fround(f54 * f63) + Math_fround(f20 * f62)) + Math_fround(f7 * f61));
 f20 = Math_fround(f16 * Math_fround(Math_fround(f15 * f4) - Math_fround(f14 * f7)));
 f4 = Math_fround(f16 * Math_fround(Math_fround(f13 * f7) - Math_fround(f14 * f4)));
 i49 = f20 >= Math_fround(-1.1920929e-07) & f20 <= Math_fround(1.00000012) & (f4 >= Math_fround(-1.1920929e-07) & f4 <= Math_fround(1.00000012) & Math_fround(f4 + f20) < Math_fround(1.00000012));
 f20 = Math_fround(HEAPF32[i47 >> 2]);
 f4 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(HEAPF32[i33 >> 2]);
 f17 = Math_fround(f20 - Math_fround(f17 * f2));
 f54 = Math_fround(f4 - Math_fround(f18 * f2));
 f55 = Math_fround(f7 - Math_fround(f19 * f2));
 f64 = Math_fround(HEAPF32[i37 >> 2]);
 f19 = Math_fround(HEAPF32[i27 >> 2]);
 f64 = Math_fround(f17 - f64);
 f19 = Math_fround(f54 - f19);
 f2 = Math_fround(f55 - Math_fround(HEAPF32[i28 >> 2]));
 f65 = Math_fround(HEAPF32[i38 >> 2]);
 f18 = Math_fround(HEAPF32[i32 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f64 * f65) + Math_fround(f19 * f18)) + Math_fround(f2 * Math_fround(HEAPF32[i34 >> 2])));
 f2 = Math_fround(Math_fround(Math_fround(f64 * f63) + Math_fround(f19 * f62)) + Math_fround(f2 * f61));
 f19 = Math_fround(f16 * Math_fround(Math_fround(f15 * f18) - Math_fround(f14 * f2)));
 f18 = Math_fround(f16 * Math_fround(Math_fround(f13 * f2) - Math_fround(f14 * f18)));
 i51 = f19 >= Math_fround(-1.1920929e-07) & f19 <= Math_fround(1.00000012) & (f18 >= Math_fround(-1.1920929e-07) & f18 <= Math_fround(1.00000012) & Math_fround(f18 + f19) < Math_fround(1.00000012));
 i50 = f60 > f21;
 i48 = f3 > f21;
 i47 = i49 & i51;
 i51 = f60 > f3 & i51;
 f20 = i47 ? (i48 ? f59 : f20) : i49 ? (i50 ? f59 : f58) : i51 ? f20 : f58;
 f21 = i47 ? (i48 ? f57 : f4) : i49 ? (i50 ? f57 : f5) : i51 ? f4 : f5;
 f29 = i47 ? (i48 ? f6 : f7) : i49 ? (i50 ? f6 : f29) : i51 ? f7 : f29;
 f30 = i47 ? (i48 ? f8 : f17) : i49 ? (i50 ? f8 : f30) : i51 ? f17 : f30;
 f31 = i47 ? (i48 ? f9 : f54) : i49 ? (i50 ? f9 : f31) : i51 ? f54 : f31;
 f53 = i47 ? (i48 ? f56 : f55) : i49 ? (i50 ? f56 : f53) : i51 ? f55 : f53;
 f55 = Math_fround(f30 - f20);
 f56 = Math_fround(f31 - f21);
 f54 = Math_fround(f53 - f29);
 HEAPF32[i43 >> 2] = f20;
 HEAPF32[i43 + 4 >> 2] = f21;
 HEAPF32[i43 + 8 >> 2] = f29;
 HEAPF32[i43 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i44 >> 2] = f30;
 HEAPF32[i44 + 4 >> 2] = f31;
 HEAPF32[i44 + 8 >> 2] = f53;
 HEAPF32[i44 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i40 >> 2] = Math_fround(Math_fround(f54 * f54) + Math_fround(Math_fround(f55 * f55) + Math_fround(f56 * f56)));
 STACKTOP = i52;
 return;
}

function __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i3, i5, i4, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i15 = i19 + 24 | 0;
 i16 = i19 + 26 | 0;
 i17 = i19 + 25 | 0;
 i7 = i5;
 i6 = i3;
 i1 = i7 - i6 | 0;
 i2 = (i1 | 0) > 744;
 L1 : do if ((i4 | 0) > 0 & i2) {
  i14 = i7;
  while (1) {
   i13 = i5 + -24 | 0;
   while (1) {
    i10 = ((i1 | 0) / 24 | 0) + -1 | 0;
    HEAP8[i18 >> 0] = HEAP8[i15 >> 0] | 0;
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i3, i13, i10, i18);
    i1 = -1;
    i2 = i10;
    while (1) {
     i12 = i13;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     while (1) {
      i8 = i1 + 1 | 0;
      i9 = i3 + (i8 * 24 | 0) | 0;
      i7 = i9;
      i20 = HEAP32[i7 + 4 >> 2] | 0;
      if ((i8 | 0) == (i10 | 0) | (i20 >>> 0 > i12 >>> 0 | ((i20 | 0) == (i12 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 >= i11 >>> 0 : 0))) break; else i1 = i8;
     }
     do {
      i2 = i2 + -1 | 0;
      i7 = i3 + (i2 * 24 | 0) | 0;
      i20 = i7;
      i21 = HEAP32[i20 + 4 >> 2] | 0;
     } while (!((i2 | 0) == 0 | (i12 >>> 0 > i21 >>> 0 | ((i12 | 0) == (i21 | 0) ? i11 >>> 0 >= (HEAP32[i20 >> 2] | 0) >>> 0 : 0))));
     if ((i8 | 0) >= (i2 | 0)) break;
     HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i18 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i18 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
     i1 = i8;
    }
    HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i18 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i18 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    HEAP32[i18 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    HEAP32[i13 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
    HEAP32[i13 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
    i8 = i3 + ((i1 + 2 | 0) * 24 | 0) | 0;
    i4 = ((i4 | 0) / 2 | 0) + ((i4 | 0) / 4 | 0) | 0;
    i9 = i3 + (i1 * 24 | 0) + 24 | 0;
    i10 = i9;
    i2 = (i10 - i6 | 0) / 24 | 0;
    i6 = i8;
    i1 = i14 - i6 | 0;
    i7 = (i1 | 0) / 24 | 0;
    if ((i2 | 0) >= (i7 | 0)) break;
    HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
    __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i3, i9, i2, i18);
    i2 = (i1 | 0) > 744;
    if (!((i4 | 0) > 0 & i2)) break L1; else i3 = i8;
   }
   HEAP8[i18 >> 0] = HEAP8[i17 >> 0] | 0;
   __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i8, i5, i7, i18);
   i6 = i3;
   i1 = i10 - i6 | 0;
   i2 = (i1 | 0) > 744;
   if ((i4 | 0) > 0 & i2) {
    i5 = i9;
    i14 = i10;
   } else {
    i8 = i3;
    i5 = i9;
    break;
   }
  }
 } else i8 = i3; while (0);
 if (!i2) {
  if (!(i8 >>> 0 < i5 >>> 0 & (i1 | 0) > 24)) {
   STACKTOP = i19;
   return;
  }
  i1 = i8;
  do {
   L26 : do if (i1 >>> 0 > i8 >>> 0) {
    i2 = i1;
    do {
     i3 = i2;
     i2 = i2 + -24 | 0;
     i20 = i3;
     i16 = HEAP32[i20 + 4 >> 2] | 0;
     i21 = i2;
     i17 = HEAP32[i21 + 4 >> 2] | 0;
     if (!(i16 >>> 0 < i17 >>> 0 | ((i16 | 0) == (i17 | 0) ? (HEAP32[i20 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0))) break L26;
     HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i18 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i18 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
    } while (i2 >>> 0 > i8 >>> 0);
   } while (0);
   i1 = i1 + 24 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
  STACKTOP = i19;
  return;
 }
 i10 = (i1 >>> 0) / 24 | 0;
 i11 = (i10 + -2 | 0) / 2 | 0;
 i9 = i11;
 while (1) {
  i4 = i8 + (i9 * 24 | 0) | 0;
  i1 = (i9 * 24 | 0) / 24 | 0;
  if ((i11 | 0) >= (i1 | 0)) {
   i2 = i1 << 1 | 1;
   i1 = i8 + (i2 * 24 | 0) | 0;
   i3 = i2 + 1 | 0;
   if ((i3 | 0) < (i10 | 0)) {
    i20 = i1 + 24 | 0;
    i17 = i1;
    i15 = HEAP32[i17 + 4 >> 2] | 0;
    i21 = i20;
    i16 = HEAP32[i21 + 4 >> 2] | 0;
    i21 = i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
    i1 = i21 ? i20 : i1;
    i2 = i21 ? i3 : i2;
   }
   i21 = i1;
   i20 = HEAP32[i21 + 4 >> 2] | 0;
   i7 = i4;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   if (!(i20 >>> 0 < i7 >>> 0 | ((i20 | 0) == (i7 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i6 >>> 0 : 0))) {
    i3 = i8 + (i9 * 24 | 0) + 8 | 0;
    HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i18 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    i3 = i4;
    while (1) {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     if ((i11 | 0) < (i2 | 0)) break;
     i2 = i2 << 1 | 1;
     i3 = i8 + (i2 * 24 | 0) | 0;
     i4 = i2 + 1 | 0;
     if ((i4 | 0) < (i10 | 0)) {
      i20 = i3 + 24 | 0;
      i17 = i3;
      i15 = HEAP32[i17 + 4 >> 2] | 0;
      i21 = i20;
      i16 = HEAP32[i21 + 4 >> 2] | 0;
      i21 = i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
      i3 = i21 ? i20 : i3;
      i2 = i21 ? i4 : i2;
     }
     i21 = i3;
     i20 = HEAP32[i21 + 4 >> 2] | 0;
     if (i20 >>> 0 < i7 >>> 0 | ((i20 | 0) == (i7 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i6 >>> 0 : 0)) break; else {
      i21 = i1;
      i1 = i3;
      i3 = i21;
     }
    }
    i21 = i1;
    HEAP32[i21 >> 2] = i6;
    HEAP32[i21 + 4 >> 2] = i7;
    i21 = i1 + 8 | 0;
    HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i21 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   }
  }
  if ((i9 | 0) > 0) i9 = i9 + -1 | 0; else break;
 }
 i12 = i8 + 24 | 0;
 i13 = i8 + 48 | 0;
 i11 = i8 + 8 | 0;
 do {
  i5 = i5 + -24 | 0;
  HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  i1 = i10;
  i10 = i10 + -1 | 0;
  if ((i1 | 0) != 2) {
   i21 = i1 + -3 | 0;
   i6 = (i21 | 0) / 2 | 0;
   if ((i21 | 0) >= -1) {
    if ((i10 | 0) > 2) {
     i1 = i12;
     i20 = HEAP32[i1 + 4 >> 2] | 0;
     i2 = i13;
     i21 = HEAP32[i2 + 4 >> 2] | 0;
     i2 = i20 >>> 0 < i21 >>> 0 | ((i20 | 0) == (i21 | 0) ? (HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 : 0);
     i1 = i2 ? i13 : i12;
     i2 = i2 ? 2 : 1;
    } else {
     i1 = i12;
     i2 = 1;
    }
    i21 = i1;
    i20 = HEAP32[i21 + 4 >> 2] | 0;
    i9 = i8;
    i7 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    if (!(i20 >>> 0 < i9 >>> 0 | ((i20 | 0) == (i9 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) {
     HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     i3 = i8;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      if ((i6 | 0) < (i2 | 0)) break;
      i2 = i2 << 1 | 1;
      i3 = i8 + (i2 * 24 | 0) | 0;
      i4 = i2 + 1 | 0;
      if ((i4 | 0) < (i10 | 0)) {
       i20 = i3 + 24 | 0;
       i17 = i3;
       i15 = HEAP32[i17 + 4 >> 2] | 0;
       i21 = i20;
       i16 = HEAP32[i21 + 4 >> 2] | 0;
       i21 = i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
       i3 = i21 ? i20 : i3;
       i2 = i21 ? i4 : i2;
      }
      i21 = i3;
      i20 = HEAP32[i21 + 4 >> 2] | 0;
      if (i20 >>> 0 < i9 >>> 0 | ((i20 | 0) == (i9 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i7 >>> 0 : 0)) break; else {
       i21 = i1;
       i1 = i3;
       i3 = i21;
      }
     }
     i21 = i1;
     HEAP32[i21 >> 2] = i7;
     HEAP32[i21 + 4 >> 2] = i9;
     i21 = i1 + 8 | 0;
     HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i21 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    }
   }
  }
 } while ((i10 | 0) > 1);
 STACKTOP = i19;
 return;
}

function _tt_sbit_decoder_load_image(i20, i12, i21, i22) {
 i20 = i20 | 0;
 i12 = i12 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24;
 i6 = (HEAP32[i20 + 36 >> 2] | 0) + (HEAP32[i20 + 28 >> 2] | 0) | 0;
 i10 = HEAP32[i20 + 40 >> 2] | 0;
 i4 = HEAP32[i20 + 32 >> 2] | 0;
 if (!i4) {
  i23 = 6;
  STACKTOP = i24;
  return i23 | 0;
 } else i5 = i6;
 while (1) {
  i7 = HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0];
  if (i7 >>> 0 <= i12 >>> 0) if ((HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0]) >>> 0 >= i12 >>> 0) break;
  i4 = i4 + -1 | 0;
  if (!i4) {
   i11 = 6;
   i15 = 62;
   break;
  } else i5 = i5 + 8 | 0;
 }
 if ((i15 | 0) == 62) {
  STACKTOP = i24;
  return i11 | 0;
 }
 i4 = HEAPU8[i5 + 5 >> 0] << 16 | HEAPU8[i5 + 4 >> 0] << 24 | HEAPU8[i5 + 6 >> 0] << 8 | HEAPU8[i5 + 7 >> 0];
 i9 = i10;
 if (i4 >>> 0 > (i9 - i6 | 0) >>> 0) {
  i23 = 8;
  STACKTOP = i24;
  return i23 | 0;
 }
 i4 = i6 + i4 | 0;
 if ((i4 + 8 | 0) >>> 0 > i10 >>> 0) {
  i23 = 6;
  STACKTOP = i24;
  return i23 | 0;
 }
 i4 = i4 + 2 | 0;
 i8 = i4 + -2 | 0;
 i4 = i4 + 2 | 0;
 i14 = i4 + -2 | 0;
 i14 = HEAPU8[i14 >> 0] << 8 | HEAPU8[i14 + 1 >> 0];
 i4 = i4 + 4 | 0;
 i13 = i4 + -4 | 0;
 i13 = HEAPU8[i13 + 1 >> 0] << 16 | HEAPU8[i13 >> 0] << 24 | HEAPU8[i13 + 2 >> 0] << 8 | HEAPU8[i13 + 3 >> 0];
 L17 : do switch (((HEAPU8[i8 >> 0] << 8 | HEAPU8[i8 + 1 >> 0]) & 65535) << 16 >> 16) {
 case 1:
  {
   i2 = i4 + (i12 - i7 << 2) | 0;
   if ((i2 + 8 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   i3 = i2 + 4 | 0;
   i2 = i3 + -4 | 0;
   i2 = HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
   i3 = i3 + 4 + -4 | 0;
   i3 = HEAPU8[i3 + 1 >> 0] << 16 | HEAPU8[i3 >> 0] << 24 | HEAPU8[i3 + 2 >> 0] << 8 | HEAPU8[i3 + 3 >> 0];
   if ((i2 | 0) == (i3 | 0)) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   break;
  }
 case 2:
  {
   if ((i4 + 12 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   i2 = i4 + 4 | 0;
   i5 = i2 + -4 | 0;
   i5 = HEAPU8[i5 + 1 >> 0] << 16 | HEAPU8[i5 >> 0] << 24 | HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0];
   i3 = HEAP32[i20 + 12 >> 2] | 0;
   i4 = i2 + 5 | 0;
   if (i4 >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   HEAP16[i3 >> 1] = HEAPU8[i2 >> 0] | 0;
   HEAP16[i3 + 2 >> 1] = HEAPU8[i2 + 1 >> 0] | 0;
   HEAP16[i3 + 4 >> 1] = HEAP8[i2 + 2 >> 0] | 0;
   HEAP16[i3 + 6 >> 1] = HEAP8[i2 + 3 >> 0] | 0;
   HEAP16[i3 + 8 >> 1] = HEAPU8[i2 + 4 >> 0] | 0;
   if ((i2 + 8 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   } else {
    HEAP16[i3 + 10 >> 1] = HEAP8[i4 >> 0] | 0;
    HEAP16[i3 + 12 >> 1] = HEAP8[i2 + 6 >> 0] | 0;
    HEAP16[i3 + 14 >> 1] = HEAPU8[i2 + 7 >> 0] | 0;
    HEAP8[i20 + 16 >> 0] = 1;
    i3 = Math_imul(i5, i12 - i7 | 0) | 0;
    i2 = i3;
    i3 = i3 + i5 | 0;
    break L17;
   }
  }
 case 3:
  {
   i2 = i4 + (i12 - i7 << 1) | 0;
   if ((i2 + 4 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   i3 = i2 + 2 | 0;
   i2 = i3 + -2 | 0;
   i2 = HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0];
   i3 = i3 + 2 + -2 | 0;
   i3 = HEAPU8[i3 >> 0] << 8 | HEAPU8[i3 + 1 >> 0];
   if ((i2 | 0) == (i3 | 0)) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   break;
  }
 case 4:
  {
   i5 = i4 + 4 | 0;
   if (i5 >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   i6 = i5 + -4 | 0;
   i6 = HEAPU8[i6 + 1 >> 0] << 16 | HEAPU8[i6 >> 0] << 24 | HEAPU8[i6 + 2 >> 0] << 8 | HEAPU8[i6 + 3 >> 0];
   if ((i5 + 4 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   if (i6 | 0 ? i6 >>> 0 <= ((i9 - i5 >> 2) + -1 | 0) >>> 0 : 0) i4 = 0; else {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   while (1) {
    if ((HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0] | 0) == (i12 | 0)) {
     i15 = 20;
     break;
    }
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= i6 >>> 0) {
     i11 = 6;
     i15 = 62;
     break;
    } else i5 = i5 + 4 | 0;
   }
   if ((i15 | 0) == 20) {
    i2 = HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0];
    i3 = HEAPU8[i5 + 6 >> 0] << 8 | HEAPU8[i5 + 7 >> 0];
    break L17;
   } else if ((i15 | 0) == 62) {
    STACKTOP = i24;
    return i11 | 0;
   }
   break;
  }
 case 19:
 case 5:
  {
   if ((i4 + 16 | 0) >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   i6 = i4 + 4 | 0;
   i8 = HEAPU8[i4 + 1 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i4 + 2 >> 0] << 8 | HEAPU8[i4 + 3 >> 0];
   i4 = HEAP32[i20 + 12 >> 2] | 0;
   i5 = i6 + 5 | 0;
   if (i5 >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   HEAP16[i4 >> 1] = HEAPU8[i6 >> 0] | 0;
   HEAP16[i4 + 2 >> 1] = HEAPU8[i6 + 1 >> 0] | 0;
   HEAP16[i4 + 4 >> 1] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP16[i4 + 6 >> 1] = HEAP8[i6 + 3 >> 0] | 0;
   HEAP16[i4 + 8 >> 1] = HEAPU8[i6 + 4 >> 0] | 0;
   i7 = i6 + 8 | 0;
   if (i7 >>> 0 > i10 >>> 0) {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   HEAP16[i4 + 10 >> 1] = HEAP8[i5 >> 0] | 0;
   HEAP16[i4 + 12 >> 1] = HEAP8[i6 + 6 >> 0] | 0;
   HEAP16[i4 + 14 >> 1] = HEAPU8[i6 + 7 >> 0] | 0;
   HEAP8[i20 + 16 >> 0] = 1;
   i4 = i7 + 4 | 0;
   i7 = HEAPU8[i7 + 1 >> 0] << 16 | HEAPU8[i7 >> 0] << 24 | HEAPU8[i7 + 2 >> 0] << 8 | HEAPU8[i7 + 3 >> 0];
   if (i7 >>> 0 <= i9 - i4 >> 1 >>> 0 & (i7 | 0) != 0) i6 = 0; else {
    i23 = 6;
    STACKTOP = i24;
    return i23 | 0;
   }
   while (1) {
    if ((HEAPU8[i4 >> 0] << 8 | HEAPU8[i4 + 1 >> 0] | 0) == (i12 | 0)) {
     i15 = 28;
     break;
    }
    i5 = i6 + 1 | 0;
    if (i5 >>> 0 < i7 >>> 0) {
     i6 = i5;
     i4 = i4 + 2 | 0;
    } else {
     i11 = 6;
     i15 = 62;
     break;
    }
   }
   if ((i15 | 0) == 28) {
    i3 = Math_imul(i6, i8) | 0;
    i2 = i3;
    i3 = i3 + i8 | 0;
    break L17;
   } else if ((i15 | 0) == 62) {
    STACKTOP = i24;
    return i11 | 0;
   }
   break;
  }
 default:
  {
   i23 = 6;
   STACKTOP = i24;
   return i23 | 0;
  }
 } while (0);
 if (i3 >>> 0 < i2 >>> 0) {
  i23 = 6;
  STACKTOP = i24;
  return i23 | 0;
 }
 i6 = i3 - i2 | 0;
 i8 = HEAP32[i20 + 4 >> 2] | 0;
 if ((i3 + i13 | 0) >>> 0 > (HEAP32[i20 + 24 >> 2] | 0) >>> 0) i1 = 6; else {
  i2 = _UNITY_FT_Stream_Seek(i8, i2 + i13 + (HEAP32[i20 + 20 >> 2] | 0) | 0) | 0;
  if (!i2) {
   i2 = _UNITY_FT_Stream_ExtractFrame(i8, i6, i23) | 0;
   if (!i2) {
    i4 = HEAP32[i23 >> 2] | 0;
    i7 = i4 + i6 | 0;
    i5 = i14 & 65535;
    switch (i5 << 16 >> 16) {
    case 17:
    case 8:
    case 2:
    case 1:
     {
      i2 = HEAP32[i20 + 12 >> 2] | 0;
      if ((i6 | 0) < 5) i1 = 6; else {
       HEAP16[i2 >> 1] = HEAPU8[i4 >> 0] | 0;
       HEAP16[i2 + 2 >> 1] = HEAPU8[i4 + 1 >> 0] | 0;
       HEAP16[i2 + 4 >> 1] = HEAP8[i4 + 2 >> 0] | 0;
       HEAP16[i2 + 6 >> 1] = HEAP8[i4 + 3 >> 0] | 0;
       HEAP16[i2 + 8 >> 1] = HEAPU8[i4 + 4 >> 0] | 0;
       HEAP16[i2 + 10 >> 1] = 0;
       HEAP16[i2 + 12 >> 1] = 0;
       HEAP16[i2 + 14 >> 1] = 0;
       HEAP8[i20 + 16 >> 0] = 1;
       i16 = i4 + 5 | 0;
       i15 = 39;
      }
      break;
     }
    case 18:
    case 9:
    case 7:
    case 6:
     {
      i2 = HEAP32[i20 + 12 >> 2] | 0;
      i3 = i4 + 5 | 0;
      if ((i6 | 0) < 5) i1 = 6; else {
       HEAP16[i2 >> 1] = HEAPU8[i4 >> 0] | 0;
       HEAP16[i2 + 2 >> 1] = HEAPU8[i4 + 1 >> 0] | 0;
       HEAP16[i2 + 4 >> 1] = HEAP8[i4 + 2 >> 0] | 0;
       HEAP16[i2 + 6 >> 1] = HEAP8[i4 + 3 >> 0] | 0;
       HEAP16[i2 + 8 >> 1] = HEAPU8[i4 + 4 >> 0] | 0;
       if ((i6 | 0) < 8) i1 = 6; else {
        HEAP16[i2 + 10 >> 1] = HEAP8[i3 >> 0] | 0;
        HEAP16[i2 + 12 >> 1] = HEAP8[i4 + 6 >> 0] | 0;
        HEAP16[i2 + 14 >> 1] = HEAPU8[i4 + 7 >> 0] | 0;
        HEAP8[i20 + 16 >> 0] = 1;
        i16 = i4 + 8 | 0;
        i15 = 39;
       }
      }
      break;
     }
    default:
     {
      i16 = i4;
      i15 = 39;
     }
    }
    L86 : do if ((i15 | 0) == 39) {
     i2 = i16;
     L88 : do switch (i5 << 16 >> 16) {
     case 19:
     case 18:
     case 17:
      {
       i1 = 7;
       break L86;
      }
     case 6:
     case 1:
      {
       i18 = fb + 183 | 0;
       i19 = i2;
       break;
      }
     case 7:
     case 2:
      {
       i18 = HEAP32[i20 + 12 >> 2] | 0;
       i19 = HEAPU16[i18 + 2 >> 1] | 0;
       i18 = HEAPU16[i18 >> 1] | 0;
       i1 = Math_imul((i19 + 7 | 0) >>> 3, i18) | 0;
       if (((Math_imul(i18, i19) | 0) + 7 | 0) >>> 3 >>> 0 < i1 >>> 0) if ((i1 | 0) == (i7 - i2 | 0)) {
        i18 = fb + 183 | 0;
        i19 = i2;
        break L88;
       }
       i18 = fb + 184 | 0;
       i19 = i2;
       break;
      }
     case 5:
      {
       i18 = fb + 184 | 0;
       i19 = i2;
       break;
      }
     case 8:
      {
       i1 = i16 + 1 | 0;
       if (i1 >>> 0 > i7 >>> 0) {
        i1 = 0;
        break L86;
       }
       i17 = i1;
       i15 = 46;
       break;
      }
     case 9:
      {
       i17 = i2;
       i15 = 46;
       break;
      }
     default:
      {
       i1 = 8;
       break L86;
      }
     } while (0);
     if ((i15 | 0) == 46) {
      i18 = fb + 185 | 0;
      i19 = i17;
     }
     i5 = i20 + 17 | 0;
     if (!(HEAP8[i5 >> 0] | 0)) {
      i2 = HEAP32[i20 + 8 >> 2] | 0;
      i3 = HEAP32[i20 + 16 >> 2] | 0;
      if (!((i3 & 255) << 24 >> 24)) {
       i1 = 6;
       break;
      }
      i4 = HEAP32[i20 + 12 >> 2] | 0;
      i1 = HEAPU16[i4 + 2 >> 1] | 0;
      i4 = HEAPU16[i4 >> 1] | 0;
      HEAP32[i2 + 4 >> 2] = i1;
      HEAP32[i2 >> 2] = i4;
      switch ((i3 >>> 16 & 255) << 24 >> 24) {
      case 1:
       {
        HEAP8[i2 + 18 >> 0] = 1;
        i1 = (i1 + 7 | 0) >>> 3;
        HEAP32[i2 + 8 >> 2] = i1;
        HEAP16[i2 + 16 >> 1] = 2;
        break;
       }
      case 2:
       {
        HEAP8[i2 + 18 >> 0] = 3;
        i1 = (i1 + 3 | 0) >>> 2;
        HEAP32[i2 + 8 >> 2] = i1;
        HEAP16[i2 + 16 >> 1] = 4;
        break;
       }
      case 4:
       {
        HEAP8[i2 + 18 >> 0] = 4;
        i1 = (i1 + 1 | 0) >>> 1;
        HEAP32[i2 + 8 >> 2] = i1;
        HEAP16[i2 + 16 >> 1] = 16;
        break;
       }
      case 8:
       {
        HEAP8[i2 + 18 >> 0] = 2;
        HEAP32[i2 + 8 >> 2] = i1;
        HEAP16[i2 + 16 >> 1] = 256;
        break;
       }
      case 32:
       {
        HEAP8[i2 + 18 >> 0] = 7;
        i1 = i1 << 2;
        HEAP32[i2 + 8 >> 2] = i1;
        HEAP16[i2 + 16 >> 1] = 256;
        break;
       }
      default:
       {
        i1 = 3;
        break L86;
       }
      }
      i1 = Math_imul(i1, i4) | 0;
      if (i1 | 0) {
       i1 = _UNITY_ft_glyphslot_alloc_bitmap(HEAP32[(HEAP32[i20 >> 2] | 0) + 84 >> 2] | 0, i1) | 0;
       if (i1 | 0) break;
       HEAP8[i5 >> 0] = 1;
      }
     }
     i1 = mftCall_iiiiii(i18 | 0, i20 | 0, i19 | 0, i7 | 0, i21 | 0, i22 | 0) | 0;
    } while (0);
    _UNITY_FT_Stream_ReleaseFrame(i8, i23);
   } else i1 = i2;
  } else i1 = i2;
 }
 i23 = i1;
 STACKTOP = i24;
 return i23 | 0;
}

function __Z20SendCullingCallbacksRK13CullingOutputRK14ShadowCullDataRK15SharedLightData(i19, i6, i20) {
 i19 = i19 | 0;
 i6 = i6 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23;
 i22 = i23 + 16 | 0;
 if ((HEAP16[gb + 1113144 + 6 >> 1] | 0) > -1) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113144 | 0, i18);
  i21 = gb + 1113144 | 0;
 } else i21 = 0;
 i4 = HEAP32[gb + 1112268 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i22 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i22);
    i2 = HEAP32[i18 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 11;
   }
  }
  if ((i5 | 0) == 9) i5 = 11;
  if ((i5 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i22 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i14 = i18;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 4 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 32 >> 2] = 0;
 HEAP32[i22 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i17 = i18;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 24 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i22 + 40 >> 2] = 0;
 HEAP32[i22 + 52 >> 2] = 0;
 HEAP32[i22 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i14 = i18;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 44 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP32[i22 + 60 >> 2] = 0;
 HEAP32[i22 + 72 >> 2] = 0;
 HEAP32[i22 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i17 = i18;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 64 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i22 + 80 >> 2] = 0;
 HEAP32[i22 + 92 >> 2] = 0;
 HEAP32[i22 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i14 = i18;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 84 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP32[i22 + 100 >> 2] = 0;
 HEAP32[i22 + 112 >> 2] = 0;
 HEAP32[i22 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i17 = i18;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 104 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i22 + 120 >> 2] = 0;
 HEAP32[i22 + 132 >> 2] = 0;
 HEAP32[i22 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i14 = i18;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 124 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP32[i22 + 140 >> 2] = 0;
 HEAP32[i22 + 152 >> 2] = 0;
 HEAP32[i22 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i17 = i18;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 144 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i22 + 160 >> 2] = 0;
 HEAP32[i22 + 172 >> 2] = 0;
 HEAP32[i22 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i14 = i18;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 164 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP32[i22 + 180 >> 2] = 0;
 HEAP32[i22 + 192 >> 2] = 0;
 HEAP32[i22 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, gb + 63664 | 0);
 i17 = i18;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 184 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 i14 = gb + 64016 | 0;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 4 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP8[i18 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 28560 >> 2] | 0) != 0 & 1;
 i17 = gb + 64016 | 0;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 24 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i18 + 1 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 29332 >> 2] | 0) != 0 & 1;
 i14 = gb + 64016 | 0;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 44 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP8[i18 + 2 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 30104 >> 2] | 0) != 0 & 1;
 i17 = gb + 64016 | 0;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 64 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i18 + 3 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 30876 >> 2] | 0) != 0 & 1;
 i14 = gb + 64016 | 0;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 84 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP8[i18 + 4 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 31648 >> 2] | 0) != 0 & 1;
 i17 = gb + 64016 | 0;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 104 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i18 + 5 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 32420 >> 2] | 0) != 0 & 1;
 i14 = gb + 64016 | 0;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 124 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP8[i18 + 6 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 33192 >> 2] | 0) != 0 & 1;
 i17 = gb + 64016 | 0;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 144 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i18 + 7 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 33964 >> 2] | 0) != 0 & 1;
 i14 = gb + 64016 | 0;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i22 + 164 | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i12;
 HEAP8[i18 + 8 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 34736 >> 2] | 0) != 0 & 1;
 i17 = gb + 64016 | 0;
 i12 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i22 + 184 | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i18 + 9 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 35508 >> 2] | 0) != 0 & 1;
 i14 = i6 + 952 | 0;
 i12 = 0;
 do {
  i15 = i19 + (i12 * 12 | 0) + 4 | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i16 = i19 + (i12 * 12 | 0) | 0;
   i17 = (HEAP32[i14 >> 2] | 0) + 752 + (i12 * 12 | 0) + 4 | 0;
   i13 = 0;
   do {
    i11 = HEAP32[(HEAP32[i17 >> 2] | 0) + ((HEAP32[(HEAP32[i16 >> 2] | 0) + (i13 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0;
    i10 = i11;
    i11 = i11 + 236 | 0;
    i11 = (HEAPU16[i11 >> 1] | HEAPU8[i11 + 2 >> 0] << 16) & 63;
    if (HEAP8[i18 + i11 >> 0] | 0) {
     i3 = i22 + (i11 * 20 | 0) | 0;
     i4 = i22 + (i11 * 20 | 0) + 12 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = i22 + (i11 * 20 | 0) + 16 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i22 + (i11 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i22 + (i11 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i4 >> 2] = i6;
     HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i10;
     i2 = HEAP32[i15 >> 2] | 0;
    }
    i13 = i13 + 1 | 0;
   } while ((i13 | 0) < (i2 | 0));
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 5);
 i7 = i20 + 280 | 0;
 i6 = 0;
 do {
  i2 = i22 + (i6 * 20 | 0) + 12 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i8 = __ZN15GlobalCallbacks3GetEv() | 0;
   i9 = HEAP32[i22 + (i6 * 20 | 0) >> 2] | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i8 + 27792 + (i6 * 772 | 0) + 768 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i2 = 0;
    do {
     i5 = i8 + 27792 + (i6 * 772 | 0) + (i2 * 12 | 0) | 0;
     if (!(HEAP8[i8 + 27792 + (i6 * 772 | 0) + (i2 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiii(HEAP32[i5 >> 2] | 0, i9 | 0, i3 | 0, i1 | 0, i7 | 0); else mftCall_viiiii(HEAP32[i5 >> 2] | 0, HEAP32[i8 + 27792 + (i6 * 772 | 0) + (i2 * 12 | 0) + 4 >> 2] | 0, i9 | 0, i3 | 0, i1 | 0, i7 | 0);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 10);
 i1 = i22 + 180 | 0;
 if ((HEAP32[i22 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 160 | 0;
 if ((HEAP32[i22 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 140 | 0;
 if ((HEAP32[i22 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 120 | 0;
 if ((HEAP32[i22 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 100 | 0;
 if ((HEAP32[i22 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 80 | 0;
 if ((HEAP32[i22 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 60 | 0;
 if ((HEAP32[i22 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 40 | 0;
 if ((HEAP32[i22 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 20 | 0;
 if ((HEAP32[i22 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i22 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i22 + 4 | 0);
  HEAP32[i22 >> 2] = 0;
 }
 if (!i21) {
  STACKTOP = i23;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i21);
 STACKTOP = i23;
 return;
}

function __ZN10Matrix3x4f8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034440 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034444 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034448 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034452 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034456 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034460 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034464 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034468 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034472 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 94; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 94; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 94) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034476 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 105; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 105; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 105) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034480 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 116; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 116; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 116) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034484 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 127; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 127; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 127) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15DirectorManager12AddToManagerEP18PlayableController(i36, i37) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i45 + 24 | 0;
 i43 = i45;
 i39 = i45 + 92 | 0;
 i40 = i45 + 72 | 0;
 i41 = i45 + 52 | 0;
 i42 = i45 + 32 | 0;
 i9 = i37 + 160 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i2 = i36 + 384 | 0;
  i3 = i36 + 396 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i36 + 400 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i36 + 388 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 388 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i35 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i35;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i37;
 } else {
  i2 = i36 + 364 | 0;
  i3 = i36 + 376 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i36 + 380 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i36 + 368 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i36 + 368 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i35 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i35;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i37;
 }
 i33 = gb + 64016 | 0;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i31 = i43;
 HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i31 + 4 >> 2] = i32;
 HEAP32[i39 >> 2] = 0;
 i31 = i39 + 12 | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i39 + 16 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i39 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i43);
 i34 = i38;
 i35 = HEAP32[i34 + 4 >> 2] | 0;
 i29 = i33;
 HEAP32[i29 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i29 + 4 >> 2] = i35;
 i29 = gb + 64016 | 0;
 i35 = HEAP32[i29 + 4 >> 2] | 0;
 i34 = i43;
 HEAP32[i34 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 i34 = i40 + 16 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i40 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i43);
 i29 = i38;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 i27 = i35;
 HEAP32[i27 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i27 + 4 >> 2] = i30;
 i27 = gb + 64016 | 0;
 i30 = HEAP32[i27 + 4 >> 2] | 0;
 i29 = i43;
 HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i29 + 4 >> 2] = i30;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 i29 = i41 + 16 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i41 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i43);
 i27 = i38;
 i28 = HEAP32[i27 + 4 >> 2] | 0;
 i1 = i30;
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i1 + 4 >> 2] = i28;
 __ZNK18PlayableController14GetBindingInfoER13dynamic_arrayIP14DirectorPlayerLj4EERS0_IP8PlayableLj4EERS0_IiLj4EE(i37, i39, i40, i41);
 i1 = HEAP32[i9 >> 2] | 0;
 if (HEAP32[i31 >> 2] | 0) {
  i13 = i36 + 140 + (i1 * 20 | 0) | 0;
  i14 = i36 + 140 + (i1 * 20 | 0) + 12 | 0;
  i15 = i36 + 140 + (i1 * 20 | 0) + 16 | 0;
  i16 = i36 + 140 + (i1 * 20 | 0) + 4 | 0;
  i17 = i37 + 44 | 0;
  i18 = i42 + 12 | 0;
  i19 = i42 + 16 | 0;
  i20 = i42 + 4 | 0;
  i21 = i43 + 4 | 0;
  i22 = i43 + 16 | 0;
  i23 = i43 + 20 | 0;
  i24 = i43 + 8 | 0;
  i25 = i43 + 4 | 0;
  i26 = i36 + (i1 * 20 | 0) | 0;
  i27 = i36 + (i1 * 20 | 0) + 12 | 0;
  i28 = i36 + (i1 * 20 | 0) + 16 | 0;
  i12 = i36 + (i1 * 20 | 0) + 4 | 0;
  i11 = 0;
  do {
   if (!(HEAP8[(__ZN18PlayableController12GetFrameDataEv(i37) | 0) + 60 >> 0] | 0)) {
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 * 24 | 0, 8, i16, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 8, i16, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i14 >> 2] | 0) * 24 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i13 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i3;
    i1 = (HEAP32[i13 >> 2] | 0) + (i2 * 24 | 0) | 0;
   } else {
    i2 = HEAP32[i27 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i28 >> 2] = i1;
      HEAP32[i26 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i26 >> 2] | 0, i1 * 24 | 0, 8, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 8, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i26 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 24 | 0) | 0;
      HEAP32[i28 >> 2] = i1;
      HEAP32[i26 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i27 >> 2] = i3;
    i1 = (HEAP32[i26 >> 2] | 0) + (i2 * 24 | 0) | 0;
   }
   HEAP32[i1 >> 2] = i37;
   HEAP32[i1 + 4 >> 2] = HEAP32[(HEAP32[i39 >> 2] | 0) + (i11 << 2) >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[(HEAP32[i40 >> 2] | 0) + (i11 << 2) >> 2];
   i8 = (HEAP32[i17 >> 2] | 0) + (i11 << 3) | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i1 + 16 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i1 + 8 >> 2] = HEAP32[(HEAP32[i41 >> 2] | 0) + (i11 << 2) >> 2];
   i10 = gb + 64016 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i43;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i42 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, i43);
   i8 = i38;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i20;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   i10 = HEAP32[(HEAP32[i39 >> 2] | 0) + (i11 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0, i42 | 0);
   if (HEAP32[i18 >> 2] | 0) {
    i10 = 0;
    do {
     i1 = HEAP32[i42 >> 2] | 0;
     i3 = HEAP32[i1 + (i10 << 3) + 4 >> 2] | 0;
     i2 = HEAP32[i36 + 280 + (i3 * 12 | 0) + 4 >> 2] | 0;
     i3 = HEAP32[i36 + 280 + (i3 * 12 | 0) >> 2] | 0;
     i5 = i3;
     if ((i2 | 0) == (i3 | 0)) i44 = 44; else {
      i4 = HEAP32[i1 + (i10 << 3) >> 2] | 0;
      i3 = (i2 - i3 | 0) / 24 | 0;
      i2 = 0;
      i1 = 0;
      do {
       i9 = i5 + (i2 * 24 | 0) | 0;
       i1 = (HEAP32[i9 >> 2] | 0) == (i4 | 0) ? i9 : i1;
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i3 >>> 0);
      if (!i1) i44 = 44;
     }
     if ((i44 | 0) == 44) {
      i44 = 0;
      HEAP32[i21 >> 2] = 0;
      HEAP32[i22 >> 2] = 0;
      HEAP32[i23 >> 2] = 0;
      __Z21SetCurrentMemoryOwnerRK10MemLabelId(i38, gb + 63664 | 0);
      i3 = i38;
      i1 = HEAP32[i3 + 4 >> 2] | 0;
      i2 = i24;
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i2 + 4 >> 2] = i1;
      i2 = HEAP32[i42 >> 2] | 0;
      i1 = HEAP32[i2 + (i10 << 3) >> 2] | 0;
      HEAP32[i43 >> 2] = i1;
      i2 = HEAP32[i2 + (i10 << 3) + 4 >> 2] | 0;
      i3 = i36 + 280 + (i2 * 12 | 0) + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i36 + 280 + (i2 * 12 | 0) + 8 >> 2] | 0)) __ZNSt3__26vectorI20ProcessFrameJobGroupNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i36 + 280 + (i2 * 12 | 0) | 0, i43); else {
       HEAP32[i4 >> 2] = i1;
       __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_(i4 + 4 | 0, i25);
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 24;
      }
      i9 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i10 << 3) + 4 >> 2] | 0;
      i1 = HEAP32[i36 + 280 + (i9 * 12 | 0) >> 2] | 0;
      i1 = i1 + (((((HEAP32[i36 + 280 + (i9 * 12 | 0) + 4 >> 2] | 0) - i1 | 0) / 24 | 0) + -1 | 0) * 24 | 0) | 0;
      if ((HEAP32[i23 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i24);
       HEAP32[i25 >> 2] = 0;
      }
     }
     i3 = i1 + 4 | 0;
     i4 = i1 + 16 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = i1 + 20 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 * 24 | 0, 8, i1 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 8, i1 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = i9;
       break;
      }
     } while (0);
     HEAP32[i4 >> 2] = i6;
     i9 = HEAP32[i3 >> 2] | 0;
     HEAP32[i9 + (i5 * 24 | 0) >> 2] = i37;
     HEAP32[i9 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[(HEAP32[i41 >> 2] | 0) + (i11 << 2) >> 2];
     HEAP32[i9 + (i5 * 24 | 0) + 4 >> 2] = HEAP32[(HEAP32[i39 >> 2] | 0) + (i11 << 2) >> 2];
     HEAP32[i9 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[(HEAP32[i40 >> 2] | 0) + (i11 << 2) >> 2];
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
   }
   if ((HEAP32[i19 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i20);
    HEAP32[i42 >> 2] = 0;
   }
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i30);
  HEAP32[i41 >> 2] = 0;
 }
 if ((HEAP32[i34 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i40 >> 2] | 0, i35);
  HEAP32[i40 >> 2] = 0;
 }
 if ((HEAP32[i32 >> 2] | 0) <= -1) {
  STACKTOP = i45;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i33);
 HEAP32[i39 >> 2] = 0;
 STACKTOP = i45;
 return;
}

function __ZN5physx18PxcFsFlushVelocityERNS_9PxcFsDataE(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i25 + 80 | 0;
 i23 = i25 + 48 | 0;
 i16 = i25 + 16 | 0;
 i21 = i25;
 i2 = HEAPU16[i24 + 26 >> 1] | 0;
 i22 = i24 + (i2 + 144) | 0;
 i17 = i24 + 8 | 0;
 i18 = i24 + (((HEAPU16[i17 >> 1] | 0) * 432 | 0) + (HEAPU16[i24 + 24 >> 1] | 0)) | 0;
 i20 = i24 + (HEAPU16[i24 + 10 >> 1] | 0) | 0;
 i19 = i24 + 32 | 0;
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f7 = Math_fround(HEAPF32[i24 + 36 >> 2]);
 f32 = Math_fround(-f32);
 f7 = Math_fround(-f7);
 f27 = Math_fround(-Math_fround(HEAPF32[i24 + 40 >> 2]));
 f30 = Math_fround(HEAPF32[i24 + 48 >> 2]);
 f26 = Math_fround(HEAPF32[i24 + 52 >> 2]);
 f30 = Math_fround(-f30);
 f26 = Math_fround(-f26);
 f8 = Math_fround(-Math_fround(HEAPF32[i24 + 56 >> 2]));
 f40 = Math_fround(Math_fround(HEAPF32[i24 + i2 >> 2]) * f32);
 f40 = Math_fround(f40 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 16) >> 2]) * f7));
 f40 = Math_fround(f40 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 32) >> 2]) * f27));
 f39 = Math_fround(Math_fround(HEAPF32[i24 + (i2 + 4) >> 2]) * f32);
 f39 = Math_fround(f39 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 20) >> 2]) * f7));
 f39 = Math_fround(f39 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 36) >> 2]) * f27));
 f38 = Math_fround(Math_fround(HEAPF32[i24 + (i2 + 8) >> 2]) * f32);
 f38 = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 24) >> 2]) * f7));
 f38 = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 40) >> 2]) * f27));
 f37 = Math_fround(HEAPF32[i24 + (i2 + 48) >> 2]);
 f3 = Math_fround(f37 * f30);
 f35 = Math_fround(HEAPF32[i24 + (i2 + 64) >> 2]);
 f3 = Math_fround(f3 + Math_fround(f35 * f26));
 f33 = Math_fround(HEAPF32[i24 + (i2 + 80) >> 2]);
 f3 = Math_fround(f3 + Math_fround(f33 * f8));
 f36 = Math_fround(HEAPF32[i24 + (i2 + 52) >> 2]);
 f4 = Math_fround(f36 * f30);
 f34 = Math_fround(HEAPF32[i24 + (i2 + 68) >> 2]);
 f4 = Math_fround(f4 + Math_fround(f34 * f26));
 f31 = Math_fround(HEAPF32[i24 + (i2 + 84) >> 2]);
 f4 = Math_fround(f4 + Math_fround(f31 * f8));
 f29 = Math_fround(HEAPF32[i24 + (i2 + 56) >> 2]);
 f5 = Math_fround(f29 * f30);
 f28 = Math_fround(HEAPF32[i24 + (i2 + 72) >> 2]);
 f5 = Math_fround(f5 + Math_fround(f28 * f26));
 f6 = Math_fround(HEAPF32[i24 + (i2 + 88) >> 2]);
 f3 = Math_fround(f40 + f3);
 f4 = Math_fround(f39 + f4);
 f5 = Math_fround(f38 + Math_fround(f5 + Math_fround(f6 * f8)));
 f29 = Math_fround(Math_fround(Math_fround(f37 * f32) + Math_fround(f36 * f7)) + Math_fround(f29 * f27));
 f28 = Math_fround(Math_fround(Math_fround(f35 * f32) + Math_fround(f34 * f7)) + Math_fround(f28 * f27));
 f27 = Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f31 * f7)) + Math_fround(f6 * f27));
 f6 = Math_fround(Math_fround(HEAPF32[i24 + (i2 + 96) >> 2]) * f30);
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 112) >> 2]) * f26));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 128) >> 2]) * f8));
 f7 = Math_fround(Math_fround(HEAPF32[i24 + (i2 + 100) >> 2]) * f30);
 f7 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 116) >> 2]) * f26));
 f7 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 132) >> 2]) * f8));
 f30 = Math_fround(Math_fround(HEAPF32[i24 + (i2 + 104) >> 2]) * f30);
 f26 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 120) >> 2]) * f26));
 f6 = Math_fround(f29 + f6);
 f7 = Math_fround(f28 + f7);
 f8 = Math_fround(f27 + Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i24 + (i2 + 136) >> 2]) * f8)));
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i19 = i24 + 48 | 0;
 i15 = i15 + 16 | 0;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i19 = i24 + 128 | 0;
 f26 = Math_fround(HEAPF32[i19 >> 2]);
 i15 = i24 + 132 | 0;
 f27 = Math_fround(HEAPF32[i15 >> 2]);
 i14 = i24 + 136 | 0;
 f27 = Math_fround(f4 + f27);
 f28 = Math_fround(f5 + Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i19 >> 2] = Math_fround(f3 + f26);
 HEAPF32[i15 >> 2] = f27;
 HEAPF32[i14 >> 2] = f28;
 HEAPF32[i24 + 140 >> 2] = Math_fround(0.0);
 i14 = i24 + 144 | 0;
 f28 = Math_fround(HEAPF32[i14 >> 2]);
 i15 = i19 + 20 | 0;
 f27 = Math_fround(HEAPF32[i15 >> 2]);
 i1 = i24 + 152 | 0;
 f27 = Math_fround(f7 + f27);
 f26 = Math_fround(f8 + Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i14 >> 2] = Math_fround(f6 + f28);
 HEAPF32[i15 >> 2] = f27;
 HEAPF32[i1 >> 2] = f26;
 HEAPF32[i24 + 156 >> 2] = Math_fround(0.0);
 i2 = i24 + (i2 + 288) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!((i1 | 0) == 0 & (i2 | 0) == 0)) do {
  i14 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
  i15 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i15 = i1 | 0 ? HEAP32[gb + 90668 + (i14 << 2) >> 2] | 0 : (HEAP32[gb + 90668 + (i15 << 2) >> 2] | 0) + 32 | 0;
  i14 = i19 + ((HEAPU16[i17 >> 1] | 0) << 5) | 0;
  i13 = i14 + (i15 << 5) | 0;
  f40 = Math_fround(HEAPF32[i13 >> 2]);
  i12 = i14 + (i15 << 5) + 4 | 0;
  f39 = Math_fround(HEAPF32[i12 >> 2]);
  i11 = i14 + (i15 << 5) + 8 | 0;
  f39 = Math_fround(f4 + f39);
  f38 = Math_fround(f5 + Math_fround(HEAPF32[i11 >> 2]));
  HEAPF32[i13 >> 2] = Math_fround(f3 + f40);
  HEAPF32[i12 >> 2] = f39;
  HEAPF32[i11 >> 2] = f38;
  HEAPF32[i14 + (i15 << 5) + 12 >> 2] = Math_fround(0.0);
  i11 = i14 + (i15 << 5) + 16 | 0;
  f38 = Math_fround(HEAPF32[i11 >> 2]);
  i12 = i14 + (i15 << 5) + 20 | 0;
  f39 = Math_fround(HEAPF32[i12 >> 2]);
  i13 = i14 + (i15 << 5) + 24 | 0;
  f39 = Math_fround(f7 + f39);
  f40 = Math_fround(f8 + Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i11 >> 2] = Math_fround(f6 + f38);
  HEAPF32[i12 >> 2] = f39;
  HEAPF32[i13 >> 2] = f40;
  HEAPF32[i14 + (i15 << 5) + 28 >> 2] = Math_fround(0.0);
  i15 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i1 = i15 & i1;
  i2 = (getTempRet0() | 0) & i2;
 } while (!((i1 | 0) == 0 & (i2 | 0) == 0));
 i1 = HEAP16[i17 >> 1] | 0;
 if ((i1 & 65535) <= 1) {
  i24 = i24 + 16 | 0;
  i23 = i24;
  HEAP32[i23 >> 2] = 0;
  i24 = i24 + 4 | 0;
  HEAP32[i24 >> 2] = 0;
  STACKTOP = i25;
  return;
 }
 i10 = i16 + 16 | 0;
 i11 = i23 + 4 | 0;
 i12 = i23 + 8 | 0;
 i13 = i23 + 16 | 0;
 i14 = i23 + 20 | 0;
 i15 = i23 + 24 | 0;
 i1 = i1 & 65535;
 i9 = 1;
 do {
  __ZN5physx21propagateVelocitySIMDERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i23, i22 + (i9 * 160 | 0) | 0, i20 + (i9 << 5) | 0, i19 + (i1 << 6) + (i9 << 4) | 0, i19 + (i1 << 5) + (i9 << 5) | 0, i18 + (i9 * 96 | 0) | 0);
  i2 = i19 + ((HEAPU16[i17 >> 1] | 0) << 5) | 0;
  i1 = i2 + (i9 << 5) | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  HEAP32[i16 + 16 >> 2] = 0;
  HEAP32[i16 + 20 >> 2] = 0;
  HEAP32[i16 + 24 >> 2] = 0;
  HEAP32[i16 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  i2 = i2 + (i9 << 5) + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  i2 = i19 + ((HEAPU16[i17 >> 1] | 0) << 6) + (i9 << 4) | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  HEAP32[i21 + 12 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  i2 = i19 + (i9 << 5) | 0;
  f40 = Math_fround(HEAPF32[i2 >> 2]);
  i1 = i19 + (i9 << 5) + 4 | 0;
  f39 = Math_fround(HEAPF32[i1 >> 2]);
  i41 = i19 + (i9 << 5) + 8 | 0;
  f38 = Math_fround(HEAPF32[i41 >> 2]);
  f3 = Math_fround(HEAPF32[i23 >> 2]);
  f4 = Math_fround(HEAPF32[i11 >> 2]);
  f5 = Math_fround(HEAPF32[i12 >> 2]);
  f39 = Math_fround(f39 + f4);
  f38 = Math_fround(f38 + f5);
  HEAPF32[i2 >> 2] = Math_fround(f40 + f3);
  HEAPF32[i1 >> 2] = f39;
  HEAPF32[i41 >> 2] = f38;
  HEAPF32[i19 + (i9 << 5) + 12 >> 2] = Math_fround(0.0);
  i41 = i19 + (i9 << 5) + 16 | 0;
  f38 = Math_fround(HEAPF32[i41 >> 2]);
  i1 = i19 + (i9 << 5) + 20 | 0;
  f39 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i19 + (i9 << 5) + 24 | 0;
  f40 = Math_fround(HEAPF32[i2 >> 2]);
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f8 = Math_fround(HEAPF32[i15 >> 2]);
  f39 = Math_fround(f39 + f7);
  f40 = Math_fround(f40 + f8);
  HEAPF32[i41 >> 2] = Math_fround(f38 + f6);
  HEAPF32[i1 >> 2] = f39;
  HEAPF32[i2 >> 2] = f40;
  HEAPF32[i19 + (i9 << 5) + 28 >> 2] = Math_fround(0.0);
  i2 = i22 + (i9 * 160 | 0) + 144 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i1 | 0) == 0 & (i2 | 0) == 0)) do {
   i42 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
   i41 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i41 = i1 | 0 ? HEAP32[gb + 90668 + (i42 << 2) >> 2] | 0 : (HEAP32[gb + 90668 + (i41 << 2) >> 2] | 0) + 32 | 0;
   i42 = i19 + ((HEAPU16[i17 >> 1] | 0) << 5) | 0;
   i43 = i42 + (i41 << 5) | 0;
   f40 = Math_fround(HEAPF32[i43 >> 2]);
   i44 = i42 + (i41 << 5) + 4 | 0;
   f39 = Math_fround(HEAPF32[i44 >> 2]);
   i45 = i42 + (i41 << 5) + 8 | 0;
   f39 = Math_fround(f39 + f4);
   f38 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) + f5);
   HEAPF32[i43 >> 2] = Math_fround(f40 + f3);
   HEAPF32[i44 >> 2] = f39;
   HEAPF32[i45 >> 2] = f38;
   HEAPF32[i42 + (i41 << 5) + 12 >> 2] = Math_fround(0.0);
   i45 = i42 + (i41 << 5) + 16 | 0;
   f38 = Math_fround(HEAPF32[i45 >> 2]);
   i44 = i42 + (i41 << 5) + 20 | 0;
   f39 = Math_fround(HEAPF32[i44 >> 2]);
   i43 = i42 + (i41 << 5) + 24 | 0;
   f39 = Math_fround(f39 + f7);
   f40 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) + f8);
   HEAPF32[i45 >> 2] = Math_fround(f38 + f6);
   HEAPF32[i44 >> 2] = f39;
   HEAPF32[i43 >> 2] = f40;
   HEAPF32[i42 + (i41 << 5) + 28 >> 2] = Math_fround(0.0);
   i41 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
   i1 = i41 & i1;
   i2 = (getTempRet0() | 0) & i2;
  } while (!((i1 | 0) == 0 & (i2 | 0) == 0));
  i9 = i9 + 1 | 0;
  i1 = HEAPU16[i17 >> 1] | 0;
 } while (i9 >>> 0 < i1 >>> 0);
 i45 = i24 + 16 | 0;
 i44 = i45;
 HEAP32[i44 >> 2] = 0;
 i45 = i45 + 4 | 0;
 HEAP32[i45 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_(i10, i4, i12) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 3104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 1056 | 0;
 i9 = i14 + 32 | 0;
 i5 = i14;
 i3 = i10 + 26 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 i8 = i10 + ((i1 & 65535) + 144) | 0;
 i11 = i10 + 8 | 0;
 i15 = HEAP16[i11 >> 1] | 0;
 i2 = i15 & 65535;
 i6 = i10 + ((i2 * 432 | 0) + (HEAPU16[i10 + 24 >> 1] | 0)) | 0;
 i7 = i10 + (HEAPU16[i10 + 10 >> 1] | 0) | 0;
 if ((i15 & 65535) > 1) {
  i1 = i2;
  do {
   i1 = i1 + -1 | 0;
   i15 = HEAPU8[i10 + 64 + i1 >> 0] | 0;
   i19 = i4 + (i1 << 5) + 16 | 0;
   f30 = Math_fround(HEAPF32[i19 >> 2]);
   i17 = i4 + (i1 << 5) + 20 | 0;
   f34 = Math_fround(HEAPF32[i17 >> 2]);
   i2 = i4 + (i1 << 5) + 24 | 0;
   f29 = Math_fround(HEAPF32[i2 >> 2]);
   f22 = Math_fround(HEAPF32[i4 + (i1 << 5) >> 2]);
   f23 = Math_fround(HEAPF32[i4 + (i1 << 5) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i4 + (i1 << 5) + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i7 + (i1 << 5) + 16 >> 2]);
   f31 = Math_fround(HEAPF32[i7 + (i1 << 5) + 20 >> 2]);
   f28 = Math_fround(HEAPF32[i7 + (i1 << 5) + 24 >> 2]);
   f30 = Math_fround(f30 + Math_fround(Math_fround(f23 * f28) - Math_fround(f16 * f31)));
   f28 = Math_fround(f34 + Math_fround(Math_fround(f16 * f18) - Math_fround(f22 * f28)));
   f18 = Math_fround(f29 + Math_fround(Math_fround(f22 * f31) - Math_fround(f23 * f18)));
   HEAPF32[i9 + (i1 << 4) >> 2] = f30;
   HEAPF32[i9 + (i1 << 4) + 4 >> 2] = f28;
   HEAPF32[i9 + (i1 << 4) + 8 >> 2] = f18;
   HEAPF32[i9 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f31 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) >> 2]);
   f29 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 4 >> 2]);
   f34 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 8 >> 2]);
   f33 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 32 >> 2]);
   f32 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 36 >> 2]);
   f20 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 40 >> 2]);
   f24 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 64 >> 2]);
   f25 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 68 >> 2]);
   f24 = Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f28 * f33) + Math_fround(f18 * f24)));
   f25 = Math_fround(Math_fround(f29 * f30) + Math_fround(Math_fround(f28 * f32) + Math_fround(f18 * f25)));
   f20 = Math_fround(Math_fround(f30 * f34) + Math_fround(Math_fround(f28 * f20) + Math_fround(f18 * Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 72 >> 2]))));
   f34 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 16 >> 2]);
   f32 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 20 >> 2]);
   f29 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 24 >> 2]);
   f33 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 48 >> 2]);
   f31 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 52 >> 2]);
   f27 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 56 >> 2]);
   f21 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 80 >> 2]);
   f26 = Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 84 >> 2]);
   f21 = Math_fround(Math_fround(f30 * f34) + Math_fround(Math_fround(f28 * f33) + Math_fround(f18 * f21)));
   f26 = Math_fround(Math_fround(f30 * f32) + Math_fround(Math_fround(f28 * f31) + Math_fround(f18 * f26)));
   f18 = Math_fround(Math_fround(f30 * f29) + Math_fround(Math_fround(f28 * f27) + Math_fround(f18 * Math_fround(HEAPF32[i8 + (i1 * 160 | 0) + 88 >> 2]))));
   f24 = Math_fround(f22 - f24);
   f25 = Math_fround(f23 - f25);
   f20 = Math_fround(f16 - f20);
   f16 = Math_fround(HEAPF32[i19 >> 2]);
   f23 = Math_fround(HEAPF32[i17 >> 2]);
   f21 = Math_fround(f16 - f21);
   f26 = Math_fround(f23 - f26);
   f18 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f18);
   f23 = Math_fround(HEAPF32[i7 + (i1 << 5) >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i1 << 5) + 4 >> 2]);
   f22 = Math_fround(HEAPF32[i7 + (i1 << 5) + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(Math_fround(f20 * f16) - Math_fround(f25 * f22)));
   f22 = Math_fround(f26 + Math_fround(Math_fround(f24 * f22) - Math_fround(f20 * f23)));
   f16 = Math_fround(f18 + Math_fround(Math_fround(f25 * f23) - Math_fround(f24 * f16)));
   i2 = i4 + (i15 << 5) | 0;
   f23 = Math_fround(HEAPF32[i2 >> 2]);
   i17 = i4 + (i15 << 5) + 4 | 0;
   f18 = Math_fround(HEAPF32[i17 >> 2]);
   i19 = i4 + (i15 << 5) + 8 | 0;
   f18 = Math_fround(f25 + f18);
   f20 = Math_fround(f20 + Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i2 >> 2] = Math_fround(f24 + f23);
   HEAPF32[i17 >> 2] = f18;
   HEAPF32[i19 >> 2] = f20;
   HEAPF32[i4 + (i15 << 5) + 12 >> 2] = Math_fround(0.0);
   i19 = i4 + (i15 << 5) + 16 | 0;
   f20 = Math_fround(HEAPF32[i19 >> 2]);
   i17 = i4 + (i15 << 5) + 20 | 0;
   f18 = Math_fround(HEAPF32[i17 >> 2]);
   i2 = i4 + (i15 << 5) + 24 | 0;
   f18 = Math_fround(f22 + f18);
   f16 = Math_fround(f16 + Math_fround(HEAPF32[i2 >> 2]));
   HEAPF32[i19 >> 2] = Math_fround(f21 + f20);
   HEAPF32[i17 >> 2] = f18;
   HEAPF32[i2 >> 2] = f16;
   HEAPF32[i4 + (i15 << 5) + 28 >> 2] = Math_fround(0.0);
  } while (i1 >>> 0 > 1);
  i1 = HEAP16[i3 >> 1] | 0;
 }
 i1 = i1 & 65535;
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f33 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f22 = Math_fround(-f22);
 f33 = Math_fround(-f33);
 f27 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f24 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f24 = Math_fround(-f24);
 f28 = Math_fround(-f28);
 f34 = Math_fround(-Math_fround(HEAPF32[i4 + 24 >> 2]));
 f38 = Math_fround(Math_fround(HEAPF32[i10 + i1 >> 2]) * f22);
 f38 = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 16) >> 2]) * f33));
 f38 = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 32) >> 2]) * f27));
 f37 = Math_fround(Math_fround(HEAPF32[i10 + (i1 + 4) >> 2]) * f22);
 f37 = Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 20) >> 2]) * f33));
 f37 = Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 36) >> 2]) * f27));
 f36 = Math_fround(Math_fround(HEAPF32[i10 + (i1 + 8) >> 2]) * f22);
 f36 = Math_fround(f36 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 24) >> 2]) * f33));
 f36 = Math_fround(f36 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 40) >> 2]) * f27));
 f35 = Math_fround(HEAPF32[i10 + (i1 + 48) >> 2]);
 f29 = Math_fround(f35 * f24);
 f18 = Math_fround(HEAPF32[i10 + (i1 + 64) >> 2]);
 f29 = Math_fround(f29 + Math_fround(f18 * f28));
 f21 = Math_fround(HEAPF32[i10 + (i1 + 80) >> 2]);
 f29 = Math_fround(f29 + Math_fround(f21 * f34));
 f16 = Math_fround(HEAPF32[i10 + (i1 + 52) >> 2]);
 f30 = Math_fround(f16 * f24);
 f20 = Math_fround(HEAPF32[i10 + (i1 + 68) >> 2]);
 f30 = Math_fround(f30 + Math_fround(f20 * f28));
 f23 = Math_fround(HEAPF32[i10 + (i1 + 84) >> 2]);
 f30 = Math_fround(f30 + Math_fround(f23 * f34));
 f25 = Math_fround(HEAPF32[i10 + (i1 + 56) >> 2]);
 f31 = Math_fround(f25 * f24);
 f26 = Math_fround(HEAPF32[i10 + (i1 + 72) >> 2]);
 f31 = Math_fround(f31 + Math_fround(f26 * f28));
 f32 = Math_fround(HEAPF32[i10 + (i1 + 88) >> 2]);
 f29 = Math_fround(f38 + f29);
 f30 = Math_fround(f37 + f30);
 f31 = Math_fround(f36 + Math_fround(f31 + Math_fround(f32 * f34)));
 f25 = Math_fround(Math_fround(Math_fround(f35 * f22) + Math_fround(f16 * f33)) + Math_fround(f25 * f27));
 f26 = Math_fround(Math_fround(Math_fround(f18 * f22) + Math_fround(f20 * f33)) + Math_fround(f26 * f27));
 f27 = Math_fround(Math_fround(Math_fround(f21 * f22) + Math_fround(f23 * f33)) + Math_fround(f32 * f27));
 f32 = Math_fround(Math_fround(HEAPF32[i10 + (i1 + 96) >> 2]) * f24);
 f32 = Math_fround(f32 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 112) >> 2]) * f28));
 f32 = Math_fround(f32 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 128) >> 2]) * f34));
 f33 = Math_fround(Math_fround(HEAPF32[i10 + (i1 + 100) >> 2]) * f24);
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 116) >> 2]) * f28));
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 132) >> 2]) * f34));
 f24 = Math_fround(Math_fround(HEAPF32[i10 + (i1 + 104) >> 2]) * f24);
 f28 = Math_fround(f24 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 120) >> 2]) * f28));
 f32 = Math_fround(f25 + f32);
 f33 = Math_fround(f26 + f33);
 f34 = Math_fround(f27 + Math_fround(f28 + Math_fround(Math_fround(HEAPF32[i10 + (i1 + 136) >> 2]) * f34)));
 HEAPF32[i13 >> 2] = f29;
 HEAPF32[i13 + 4 >> 2] = f30;
 HEAPF32[i13 + 8 >> 2] = f31;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 16 >> 2] = f32;
 HEAPF32[i13 + 20 >> 2] = f33;
 HEAPF32[i13 + 24 >> 2] = f34;
 HEAPF32[i13 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP16[i11 >> 1] | 0;
 if ((i1 & 65535) > 1) {
  i2 = i5 + 16 | 0;
  i3 = 1;
  do {
   i1 = i13 + (i3 << 5) | 0;
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i5, i8 + (i3 * 160 | 0) | 0, i7 + (i3 << 5) | 0, i9 + (i3 << 4) | 0, i13 + ((HEAPU8[i10 + 64 + i3 >> 0] | 0) << 5) | 0, i6 + (i3 * 96 | 0) | 0);
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i1 = i13 + (i3 << 5) + 16 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i3 = i3 + 1 | 0;
   i1 = HEAP16[i11 >> 1] | 0;
  } while (i3 >>> 0 < (i1 & 65535) >>> 0);
 }
 if (!(i1 << 16 >> 16)) {
  STACKTOP = i14;
  return;
 } else i1 = 0;
 do {
  i19 = i12 + (i1 << 5) | 0;
  f36 = Math_fround(HEAPF32[i19 >> 2]);
  i17 = i12 + (i1 << 5) + 4 | 0;
  f37 = Math_fround(HEAPF32[i17 >> 2]);
  i15 = i12 + (i1 << 5) + 8 | 0;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  f38 = Math_fround(HEAPF32[i13 + (i1 << 5) >> 2]);
  f34 = Math_fround(HEAPF32[i13 + (i1 << 5) + 4 >> 2]);
  f34 = Math_fround(f37 + f34);
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i13 + (i1 << 5) + 8 >> 2]));
  HEAPF32[i19 >> 2] = Math_fround(f36 + f38);
  HEAPF32[i17 >> 2] = f34;
  HEAPF32[i15 >> 2] = f35;
  HEAPF32[i12 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
  i15 = i12 + (i1 << 5) + 16 | 0;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  i17 = i12 + (i1 << 5) + 20 | 0;
  f34 = Math_fround(HEAPF32[i17 >> 2]);
  i19 = i12 + (i1 << 5) + 24 | 0;
  f38 = Math_fround(HEAPF32[i19 >> 2]);
  f36 = Math_fround(HEAPF32[i13 + (i1 << 5) + 16 >> 2]);
  f37 = Math_fround(HEAPF32[i13 + (i1 << 5) + 20 >> 2]);
  f37 = Math_fround(f34 + f37);
  f38 = Math_fround(f38 + Math_fround(HEAPF32[i13 + (i1 << 5) + 24 >> 2]));
  HEAPF32[i15 >> 2] = Math_fround(f35 + f36);
  HEAPF32[i17 >> 2] = f37;
  HEAPF32[i19 >> 2] = f38;
  HEAPF32[i12 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAPU16[i11 >> 1] | 0) >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN10HumanTrait18InitializeBoneNameEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i40 + 56 | 0;
 i11 = i40;
 i22 = i40 + 40 | 0;
 i33 = i40 + 28 | 0;
 i36 = i40 + 16 | 0;
 i37 = __Znwj(12) | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[gb + 1467164 >> 2] = i37;
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj(i37, 54);
 i37 = i22 + 11 | 0;
 i38 = i11 + 12 | 0;
 i7 = i11 + 12 | 0;
 i12 = i10 + 4 | 0;
 i13 = i11 + 8 | 0;
 i14 = i11 + 4 | 0;
 i15 = i11 + 11 | 0;
 i16 = i10 + 4 | 0;
 i17 = i10 + 4 | 0;
 i18 = i33 + 11 | 0;
 i19 = i11 + 12 | 0;
 i8 = i11 + 12 | 0;
 i20 = i10 + 4 | 0;
 i21 = i11 + 8 | 0;
 i23 = i11 + 4 | 0;
 i24 = i11 + 11 | 0;
 i25 = i10 + 4 | 0;
 i26 = i10 + 4 | 0;
 i27 = i36 + 11 | 0;
 i28 = i11 + 12 | 0;
 i9 = i11 + 12 | 0;
 i29 = i10 + 4 | 0;
 i30 = i11 + 8 | 0;
 i31 = i11 + 4 | 0;
 i32 = i11 + 11 | 0;
 i34 = i10 + 4 | 0;
 i35 = i10 + 4 | 0;
 i6 = 0;
 do {
  do if ((i6 | 0) < 24) {
   i4 = HEAP32[gb + 1467164 >> 2] | 0;
   i2 = __ZN7mecanim5human8BoneNameEj(i6) | 0;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i2, _strlen(i2) | 0);
   i2 = (HEAP8[i37 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i38 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
    i1 = HEAP32[i7 >> 2] | 0;
    i39 = 7;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i3;
    if (!i3) i1 = i11; else {
     i1 = i11;
     i39 = 9;
    }
   } else i39 = 7;
   if ((i39 | 0) == 7) {
    i5 = i3 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i13 >> 2] = i5 | -2147483648;
    HEAP32[i14 >> 2] = i3;
    i39 = 9;
   }
   if ((i39 | 0) == 9) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i5 = i4 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
    i4 = HEAP8[i15 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
    i4 = i2 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i39 = 14;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i39 = 16;
    } else i39 = 14;
    if ((i39 | 0) == 14) {
     i41 = i4 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i17 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i41 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i2;
     i39 = 16;
    }
    if ((i39 | 0) == 16) {
     i39 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
   }
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i41 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i16 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i41, i10);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  } else {
   i4 = HEAP32[gb + 1467164 >> 2] | 0;
   if ((i6 | 0) < 39) {
    i1 = i6 + -24 | 0;
    HEAP32[i33 >> 2] = 0;
    HEAP32[i33 + 4 >> 2] = 0;
    HEAP32[i33 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i33, gb + 908416 | 0, 5);
    if (i1 >>> 0 < 15) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, __ZN7mecanim4hand10FingerNameEj((i1 >>> 0) / 3 | 0) | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, gb + 1086395 | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, __ZN7mecanim4hand12PhalangeNameEj((i1 >>> 0) % 3 | 0) | 0) | 0;
    }
    i2 = (HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i19 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
     i1 = HEAP32[i8 >> 2] | 0;
     i39 = 28;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i24 >> 0] = i3;
     if (!i3) i1 = i11; else {
      i1 = i11;
      i39 = 30;
     }
    } else i39 = 28;
    if ((i39 | 0) == 28) {
     i41 = i3 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i20 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i21 >> 2] = i41 | -2147483648;
     HEAP32[i23 >> 2] = i3;
     i39 = 30;
    }
    if ((i39 | 0) == 30) {
     i39 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    i5 = i4 + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
     i4 = HEAP8[i24 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = i2 ? HEAP32[i23 >> 2] | 0 : i4 & 255;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i1 + 12 >> 2] = i2;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      i39 = 35;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i1 + 11 >> 0] = i4;
      if (i4) i39 = 37;
     } else i39 = 35;
     if ((i39 | 0) == 35) {
      i42 = i4 + 16 & -16;
      HEAP32[i10 >> 2] = 66;
      HEAP32[i26 >> 2] = i2;
      i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i42, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i1 >> 2] = i41;
      HEAP32[i1 + 8 >> 2] = i42 | -2147483648;
      HEAP32[i1 + 4 >> 2] = i4;
      i1 = i41;
      i39 = 37;
     }
     if ((i39 | 0) == 37) {
      i39 = 0;
      _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i1 + i4 >> 0] = 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
    }
    if ((HEAP8[i24 >> 0] | 0) < 0) {
     i42 = HEAP32[i11 >> 2] | 0;
     i41 = HEAP32[i8 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i25 >> 2] = i41;
     __Z19free_alloc_internalPvRK10MemLabelId(i42, i10);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
    break;
   } else {
    i1 = i6 + -39 | 0;
    HEAP32[i36 >> 2] = 0;
    HEAP32[i36 + 4 >> 2] = 0;
    HEAP32[i36 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i36, gb + 908422 | 0, 6);
    if (i1 >>> 0 < 15) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, __ZN7mecanim4hand10FingerNameEj((i1 >>> 0) / 3 | 0) | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, gb + 1086395 | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, __ZN7mecanim4hand12PhalangeNameEj((i1 >>> 0) % 3 | 0) | 0) | 0;
    }
    i2 = (HEAP8[i27 >> 0] | 0) < 0 ? HEAP32[i36 >> 2] | 0 : i36;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i28 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
     i1 = HEAP32[i9 >> 2] | 0;
     i39 = 48;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i32 >> 0] = i3;
     if (!i3) i1 = i11; else {
      i1 = i11;
      i39 = 50;
     }
    } else i39 = 48;
    if ((i39 | 0) == 48) {
     i42 = i3 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i29 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i42, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i30 >> 2] = i42 | -2147483648;
     HEAP32[i31 >> 2] = i3;
     i39 = 50;
    }
    if ((i39 | 0) == 50) {
     i39 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    i5 = i4 + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
     i4 = HEAP8[i32 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = i2 ? HEAP32[i31 >> 2] | 0 : i4 & 255;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i1 + 12 >> 2] = i2;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      i39 = 55;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i1 + 11 >> 0] = i4;
      if (i4) i39 = 57;
     } else i39 = 55;
     if ((i39 | 0) == 55) {
      i41 = i4 + 16 & -16;
      HEAP32[i10 >> 2] = 66;
      HEAP32[i35 >> 2] = i2;
      i42 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i1 >> 2] = i42;
      HEAP32[i1 + 8 >> 2] = i41 | -2147483648;
      HEAP32[i1 + 4 >> 2] = i4;
      i1 = i42;
      i39 = 57;
     }
     if ((i39 | 0) == 57) {
      i39 = 0;
      _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i1 + i4 >> 0] = 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
    }
    if ((HEAP8[i32 >> 0] | 0) < 0) {
     i42 = HEAP32[i11 >> 2] | 0;
     i41 = HEAP32[i9 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i34 >> 2] = i41;
     __Z19free_alloc_internalPvRK10MemLabelId(i42, i10);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
    break;
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 54);
 STACKTOP = i40;
 return;
}

function __ZNK9DebugGLES13ProgramStatusEv(i34) {
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i38 + 132 | 0;
 i33 = i38 + 128 | 0;
 i32 = i38 + 116 | 0;
 i31 = i38 + 8 | 0;
 i36 = i38;
 i35 = i38 + 104 | 0;
 i21 = i38 + 100 | 0;
 i22 = i38 + 96 | 0;
 i23 = i38 + 92 | 0;
 i24 = i38 + 88 | 0;
 i29 = i38 + 76 | 0;
 i25 = i38 + 64 | 0;
 i26 = i38 + 52 | 0;
 i27 = i38 + 48 | 0;
 i14 = i38 + 36 | 0;
 i15 = i38 + 32 | 0;
 i16 = i38 + 28 | 0;
 i17 = i38 + 24 | 0;
 i18 = i38 + 20 | 0;
 i19 = i38 + 16 | 0;
 i20 = i38 + 12 | 0;
 if (!(HEAP8[(HEAP32[i34 >> 2] | 0) + 1992 >> 0] | 0)) {
  i37 = 1;
  STACKTOP = i38;
  return i37 | 0;
 }
 if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -10 | 0) >>> 0 < 3) i28 = 4; else if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -3 | 0) >>> 0 < 2) i28 = 4; else i4 = 1;
 if ((i28 | 0) == 4) {
  HEAP32[i35 >> 2] = 0;
  i2 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[i2 + 92 >> 2] | 0, HEAP32[i2 + 868 >> 2] | 0, 35721, i35 | 0);
  i2 = HEAP32[i35 >> 2] | 0;
  i2 = (i2 | 0) <= (__ZNK7ApiGLES3GetEj(HEAP32[i34 >> 2] | 0, 34921) | 0);
  i4 = i2 & 1;
  HEAP32[i21 >> 2] = 0;
  i1 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[i1 + 92 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, 35722, i21 | 0);
  HEAP32[i22 >> 2] = 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i24 >> 2] = 0;
  i1 = HEAP32[i21 >> 2] | 0;
  HEAP32[i29 >> 2] = 0;
  i30 = i29 + 4 | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i29 + 8 >> 2] = 0;
  if (i1 | 0) {
   if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i29);
   i3 = __Znwj(i1) | 0;
   HEAP32[i30 >> 2] = i3;
   HEAP32[i29 >> 2] = i3;
   HEAP32[i29 + 8 >> 2] = i3 + i1;
   do {
    HEAP8[i3 >> 0] = 0;
    i3 = (HEAP32[i30 >> 2] | 0) + 1 | 0;
    HEAP32[i30 >> 2] = i3;
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) != 0);
  }
  i13 = HEAP32[i35 >> 2] | 0;
  if ((i13 | 0) != 0 & i2) {
   i7 = i14 + 11 | 0;
   i8 = i37 + 4 | 0;
   i9 = i37 + 8 | 0;
   i10 = i29 + 8 | 0;
   i11 = i37 + 8 | 0;
   i12 = i14;
   i3 = i4;
   i6 = 0;
   do {
    HEAP32[i25 >> 2] = HEAP32[gb + 74176 >> 2];
    HEAP32[i25 + 4 >> 2] = HEAP32[gb + 74176 + 4 >> 2];
    HEAP32[i25 + 8 >> 2] = HEAP32[gb + 74176 + 8 >> 2];
    HEAP32[i27 >> 2] = 0;
    i1 = HEAP32[i34 >> 2] | 0;
    mftCall_viiiiiiii(HEAP32[i1 + 256 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, 37603, i6 | 0, 3, i25 | 0, 3, i27 | 0, i26 | 0);
    i1 = HEAP32[i34 >> 2] | 0;
    mftCall_viiiiiii(HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, i6 | 0, HEAP32[i21 >> 2] | 0, i22 | 0, i23 | 0, i24 | 0, HEAP32[i29 >> 2] | 0);
    HEAP32[i14 >> 2] = 0;
    HEAP32[i14 + 4 >> 2] = 0;
    HEAP32[i14 + 8 >> 2] = 0;
    HEAP32[i15 >> 2] = i12;
    HEAP32[i16 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i17 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i32 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i33 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i37 >> 2] = HEAP32[i17 >> 2];
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertINS_11__wrap_iterIPcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISB_EE5valueES9_E4typeENS7_IPKcEESB_SB_(i14, i32, i33, i37) | 0;
    i1 = HEAP32[i21 >> 2] | 0;
    HEAP32[i37 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    if (!i1) {
     i2 = 0;
     i5 = 0;
     i1 = 0;
    } else {
     if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i37);
     i4 = __Znwj(i1) | 0;
     HEAP32[i8 >> 2] = i4;
     HEAP32[i37 >> 2] = i4;
     HEAP32[i11 >> 2] = i4 + i1;
     do {
      HEAP8[i4 >> 0] = 0;
      i4 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
      HEAP32[i8 >> 2] = i4;
      i1 = i1 + -1 | 0;
     } while ((i1 | 0) != 0);
     i2 = HEAP32[i11 >> 2] | 0;
     i5 = HEAP32[i37 >> 2] | 0;
     i1 = i4;
    }
    i4 = HEAP32[i29 >> 2] | 0;
    HEAP32[i29 >> 2] = i5;
    HEAP32[i37 >> 2] = i4;
    i5 = HEAP32[i30 >> 2] | 0;
    HEAP32[i30 >> 2] = i1;
    HEAP32[i8 >> 2] = i5;
    i5 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i11 >> 2] = i5;
    i2 = HEAP32[i34 >> 2] | 0;
    i2 = mftCall_iii(HEAP32[i2 + 80 >> 2] | 0, HEAP32[i2 + 868 >> 2] | 0, ((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0) | 0;
    if ((i2 | 0) != -1) {
     mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 34338, i33 | 0);
     i5 = (HEAP32[i33 >> 2] | 0) == 1;
     mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 34341, i32 | 0);
     mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 34922, i18 | 0);
     L31 : do if (i5) {
      L33 : do switch (HEAP32[i18 >> 2] | 0) {
      case 0:
       {
        mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
        break;
       }
      case 1:
       {
        i1 = HEAP32[i26 >> 2] | 0;
        L37 : do if ((i1 | 0) < 35665) if ((i1 | 0) < 35664) switch (i1 | 0) {
        case 5126:
         break L37;
        default:
         {
          i28 = 35;
          break L37;
         }
        } else switch (i1 | 0) {
        case 35664:
         break L37;
        default:
         {
          i28 = 35;
          break L37;
         }
        } else switch (i1 | 0) {
        case 35666:
        case 35665:
         break;
        default:
         i28 = 35;
        } while (0);
        if ((i28 | 0) == 35) {
         i28 = 0;
         mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
         i1 = 0;
         break L31;
        }
        i1 = HEAP32[i32 >> 2] | 0;
        L46 : do if ((i1 | 0) < 5124) switch (i1 | 0) {
        case 5120:
        case 5121:
        case 5122:
        case 5123:
         {
          i28 = 29;
          break;
         }
        default:
         i28 = 27;
        } else {
         if ((i1 | 0) < 5126) switch (i1 | 0) {
         case 5124:
         case 5125:
          {
           i28 = 29;
           break L46;
          }
         default:
          {
           i28 = 27;
           break L46;
          }
         }
         if ((i1 | 0) < 5131) switch (i1 | 0) {
         case 5126:
          {
           i28 = 29;
           break L46;
          }
         default:
          {
           i28 = 27;
           break L46;
          }
         }
         if ((i1 | 0) < 36193) switch (i1 | 0) {
         case 5131:
          {
           i28 = 29;
           break L46;
          }
         default:
          {
           i28 = 27;
           break L46;
          }
         } else switch (i1 | 0) {
         case 36193:
          {
           i28 = 29;
           break L46;
          }
         default:
          {
           i28 = 27;
           break L46;
          }
         }
        } while (0);
        if ((i28 | 0) == 27) {
         i28 = 0;
         mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
         i1 = 0;
         break L31;
        } else if ((i28 | 0) == 29) {
         i28 = 0;
         mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
         break L33;
        }
        break;
       }
      default:
       {
        mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
        i1 = 0;
        break L31;
       }
      } while (0);
      i1 = HEAP32[i19 >> 2] | 0;
      if (!i1) i1 = 1; else if ((i1 | 0) == 1) {
       i1 = HEAP32[i26 >> 2] | 0;
       L64 : do if ((i1 | 0) < 35669) if ((i1 | 0) < 35667) switch (i1 | 0) {
       case 5124:
       case 5125:
        break L64;
       default:
        {
         i1 = 0;
         break L31;
        }
       } else switch (i1 | 0) {
       case 35667:
       case 35668:
        break L64;
       default:
        {
         i1 = 0;
         break L31;
        }
       } else switch (i1 | 0) {
       case 36296:
       case 35669:
       case 36294:
       case 36295:
        break;
       default:
        {
         i1 = 0;
         break L31;
        }
       } while (0);
       i1 = ((HEAP32[i32 >> 2] | 0) + -5120 | 0) >>> 0 < 6;
      } else i1 = 0;
     } else {
      mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 35069, i19 | 0);
      i1 = 0;
     } while (0);
     if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -10 | 0) >>> 0 < 3) {
      mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 34638, i20 | 0);
      i1 = i1 & (HEAP32[i20 >> 2] | 0) == 0;
     }
     i3 = i1 & 1;
    }
    i1 = HEAP32[i37 >> 2] | 0;
    if (i1 | 0) {
     if ((HEAP32[i8 >> 2] | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i1;
     __ZdlPv(i1);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i6 = i6 + 1 | 0;
    i2 = (i3 & 1) != 0;
   } while (i6 >>> 0 < i13 >>> 0 & i2);
  }
  i1 = HEAP32[i29 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i30 >> 2] | 0) != (i1 | 0)) HEAP32[i30 >> 2] = i1;
   __ZdlPv(i1);
  }
  i4 = i2;
 }
 i1 = HEAP32[i34 >> 2] | 0;
 mftCall_vi(HEAP32[i1 + 532 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0);
 HEAP32[i37 >> 2] = 0;
 i1 = HEAP32[i34 >> 2] | 0;
 mftCall_viii(HEAP32[i1 + 92 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, 35715, i37 | 0);
 i1 = HEAP32[i37 >> 2] | 0;
 if (!i1) {
  HEAP32[i33 >> 2] = 0;
  i1 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[i1 + 92 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, 35716, i33 | 0);
  i1 = HEAP32[i33 >> 2] | 0;
  if (!i1) {
   __Z6FormatPKcz(i32, gb + 599842 | 0, i31);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i32 + 11 >> 0] | 0) < 0 ? HEAP32[i32 >> 2] | 0 : i32, 0, gb + 598120 | 0, 386, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
  } else {
   HEAP32[i32 >> 2] = 0;
   i3 = i32 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i32 + 8 >> 2] = 0;
   if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i32);
   i2 = __Znwj(i1) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i32 >> 2] = i2;
   HEAP32[i32 + 8 >> 2] = i2 + i1;
   do {
    HEAP8[i2 >> 0] = 0;
    i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
    HEAP32[i3 >> 2] = i2;
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i34 >> 2] | 0;
   mftCall_viiii(HEAP32[i1 + 528 >> 2] | 0, HEAP32[i1 + 868 >> 2] | 0, HEAP32[i33 >> 2] | 0, 0, HEAP32[i32 >> 2] | 0);
   HEAP32[i36 >> 2] = HEAP32[i32 >> 2];
   __Z6FormatPKcz(i35, gb + 599811 | 0, i36);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i35 + 11 >> 0] | 0) < 0 ? HEAP32[i35 >> 2] | 0 : i35, 0, gb + 598120 | 0, 383, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
   i1 = HEAP32[i32 >> 2] | 0;
   if (i1 | 0) {
    if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
    __ZdlPv(i1);
   }
  }
  i1 = HEAP32[i37 >> 2] | 0;
 }
 i37 = i4 & (i1 | 0) == 1;
 STACKTOP = i38;
 return i37 | 0;
}

function __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE19computeDriveInertiaERKNS_12PxcFsInertiaES5_PKNS_14PxcSIMDSpatialE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i5 + 768 | 0;
 i27 = i5 + 672 | 0;
 i25 = i5 + 528 | 0;
 i26 = i5 + 480 | 0;
 i29 = i5 + 336 | 0;
 i30 = i5 + 192 | 0;
 i28 = i5 + 48 | 0;
 i18 = i5;
 __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i25, i1, i3, i31);
 f42 = Math_fround(HEAPF32[i25 + 16 >> 2]);
 f40 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 f45 = Math_fround(HEAPF32[i25 + 24 >> 2]);
 f39 = Math_fround(HEAPF32[i25 + 32 >> 2]);
 f47 = Math_fround(HEAPF32[i25 + 36 >> 2]);
 f35 = Math_fround(HEAPF32[i25 + 40 >> 2]);
 f43 = Math_fround(Math_fround(f40 * f35) - Math_fround(f45 * f47));
 f45 = Math_fround(Math_fround(f45 * f39) - Math_fround(f42 * f35));
 f44 = Math_fround(Math_fround(f42 * f47) - Math_fround(f40 * f39));
 f38 = Math_fround(HEAPF32[i25 >> 2]);
 f48 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f46 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f41 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f38 * f43) + Math_fround(f45 * f48)) + Math_fround(f44 * f46)));
 f45 = Math_fround(f45 * f41);
 f44 = Math_fround(f44 * f41);
 f46 = Math_fround(f41 * Math_fround(Math_fround(f35 * f38) - Math_fround(f39 * f46)));
 f47 = Math_fround(f41 * Math_fround(Math_fround(f39 * f48) - Math_fround(f47 * f38)));
 f48 = Math_fround(f41 * Math_fround(Math_fround(f40 * f38) - Math_fround(f42 * f48)));
 HEAPF32[i26 >> 2] = Math_fround(f43 * f41);
 i25 = i26 + 4 | 0;
 HEAPF32[i25 >> 2] = f45;
 i24 = i26 + 8 | 0;
 HEAPF32[i24 >> 2] = f44;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 i23 = i26 + 16 | 0;
 HEAPF32[i23 >> 2] = f45;
 i22 = i26 + 20 | 0;
 HEAPF32[i22 >> 2] = f46;
 i21 = i26 + 24 | 0;
 HEAPF32[i21 >> 2] = f47;
 HEAPF32[i26 + 28 >> 2] = Math_fround(0.0);
 i20 = i26 + 32 | 0;
 HEAPF32[i20 >> 2] = f44;
 i19 = i26 + 36 | 0;
 HEAPF32[i19 >> 2] = f47;
 i3 = i26 + 40 | 0;
 HEAPF32[i3 >> 2] = f48;
 HEAPF32[i26 + 44 >> 2] = Math_fround(0.0);
 f48 = Math_fround(HEAPF32[i1 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f44 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 f45 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f46 = Math_fround(f48 + f46);
 f45 = Math_fround(f47 + f45);
 f44 = Math_fround(f44 + Math_fround(HEAPF32[i2 + 8 >> 2]));
 f47 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f48 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f41 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f43 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f42 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f43 = Math_fround(f47 + f43);
 f42 = Math_fround(f48 + f42);
 f41 = Math_fround(f41 + Math_fround(HEAPF32[i2 + 24 >> 2]));
 f48 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f40 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f40 = Math_fround(f48 + f40);
 f39 = Math_fround(f47 + f39);
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i2 + 40 >> 2]));
 f47 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f48 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f37 = Math_fround(f47 + f37);
 f36 = Math_fround(f48 + f36);
 f35 = Math_fround(f35 + Math_fround(HEAPF32[i2 + 56 >> 2]));
 f48 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f34 = Math_fround(f48 + f34);
 f33 = Math_fround(f47 + f33);
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i2 + 72 >> 2]));
 f47 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f48 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f12 = Math_fround(f47 + f12);
 f7 = Math_fround(f48 + f7);
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i2 + 88 >> 2]));
 f48 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 100 >> 2]);
 f17 = Math_fround(f48 + f17);
 f14 = Math_fround(f47 + f14);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 + 104 >> 2]));
 f47 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f48 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 112 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f10 = Math_fround(f47 + f10);
 f13 = Math_fround(f48 + f13);
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i2 + 120 >> 2]));
 f48 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 128 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 132 >> 2]);
 f9 = Math_fround(f48 + f9);
 f11 = Math_fround(f47 + f11);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 + 136 >> 2]));
 HEAPF32[i29 >> 2] = f46;
 HEAPF32[i29 + 4 >> 2] = f45;
 HEAPF32[i29 + 8 >> 2] = f44;
 HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 16 >> 2] = f43;
 HEAPF32[i29 + 20 >> 2] = f42;
 HEAPF32[i29 + 24 >> 2] = f41;
 HEAPF32[i29 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 32 >> 2] = f40;
 HEAPF32[i29 + 36 >> 2] = f39;
 HEAPF32[i29 + 40 >> 2] = f38;
 HEAPF32[i29 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 48 >> 2] = f37;
 HEAPF32[i29 + 52 >> 2] = f36;
 HEAPF32[i29 + 56 >> 2] = f35;
 HEAPF32[i29 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 64 >> 2] = f34;
 HEAPF32[i29 + 68 >> 2] = f33;
 HEAPF32[i29 + 72 >> 2] = f32;
 HEAPF32[i29 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 80 >> 2] = f12;
 HEAPF32[i29 + 84 >> 2] = f7;
 HEAPF32[i29 + 88 >> 2] = f16;
 HEAPF32[i29 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 96 >> 2] = f17;
 HEAPF32[i29 + 100 >> 2] = f14;
 HEAPF32[i29 + 104 >> 2] = f6;
 HEAPF32[i29 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 112 >> 2] = f10;
 HEAPF32[i29 + 116 >> 2] = f13;
 HEAPF32[i29 + 120 >> 2] = f15;
 HEAPF32[i29 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 128 >> 2] = f9;
 HEAPF32[i29 + 132 >> 2] = f11;
 HEAPF32[i29 + 136 >> 2] = f8;
 HEAPF32[i29 + 140 >> 2] = Math_fround(0.0);
 __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_(i30, i29, i26, i31, i27);
 HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 i2 = i29 + 16 | 0;
 i1 = i30 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 32 | 0;
 i1 = i30 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 48 | 0;
 i1 = i30 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 64 | 0;
 i1 = i30 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 80 | 0;
 i1 = i30 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 96 | 0;
 i1 = i30 + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 112 | 0;
 i1 = i30 + 112 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i29 + 128 | 0;
 i1 = i30 + 128 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i28, i29);
 __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i18, i28, i27, i5 + 576 | 0);
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 f11 = Math_fround(HEAPF32[i25 >> 2]);
 f9 = Math_fround(HEAPF32[i24 >> 2]);
 f15 = Math_fround(HEAPF32[i18 >> 2]);
 f13 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f15 = Math_fround(f8 + f15);
 f13 = Math_fround(f11 + f13);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i18 + 8 >> 2]));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f8 = Math_fround(HEAPF32[i22 >> 2]);
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f6 = Math_fround(HEAPF32[i18 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i18 + 20 >> 2]);
 f6 = Math_fround(f11 + f6);
 f14 = Math_fround(f8 + f14);
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i18 + 24 >> 2]));
 f8 = Math_fround(HEAPF32[i20 >> 2]);
 f11 = Math_fround(HEAPF32[i19 >> 2]);
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(HEAPF32[i18 + 32 >> 2]);
 f7 = Math_fround(HEAPF32[i18 + 36 >> 2]);
 f16 = Math_fround(f8 + f16);
 f7 = Math_fround(f11 + f7);
 f17 = Math_fround(f17 + Math_fround(HEAPF32[i18 + 40 >> 2]));
 f11 = Math_fround(Math_fround(f14 * f17) - Math_fround(f10 * f7));
 f10 = Math_fround(Math_fround(f10 * f16) - Math_fround(f6 * f17));
 f8 = Math_fround(Math_fround(f6 * f7) - Math_fround(f14 * f16));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f9 * f8) + Math_fround(Math_fround(f15 * f11) + Math_fround(f13 * f10))));
 f10 = Math_fround(f12 * f10);
 f8 = Math_fround(f12 * f8);
 f9 = Math_fround(f12 * Math_fround(Math_fround(f15 * f17) - Math_fround(f9 * f16)));
 f7 = Math_fround(f12 * Math_fround(Math_fround(f13 * f16) - Math_fround(f15 * f7)));
 f6 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f6)) * f12);
 HEAPF32[i4 >> 2] = Math_fround(f12 * f11);
 HEAPF32[i4 + 4 >> 2] = f10;
 HEAPF32[i4 + 8 >> 2] = f8;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 16 >> 2] = f10;
 HEAPF32[i4 + 20 >> 2] = f9;
 HEAPF32[i4 + 24 >> 2] = f7;
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 32 >> 2] = f8;
 HEAPF32[i4 + 36 >> 2] = f7;
 HEAPF32[i4 + 40 >> 2] = f6;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 STACKTOP = i5;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i1, i5, i14) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i8 = i16;
 i7 = i16 + 24 | 0;
 i6 = i1;
 L1 : do if ((i5 - i6 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == 84) {
  i2 = HEAP8[i1 + 1 >> 0] | 0;
  L4 : do if (i2 << 24 >> 24 == 95) {
   i2 = HEAP32[i14 + 36 >> 2] | 0;
   if ((HEAP32[i14 + 32 >> 2] | 0) == (i2 | 0)) break L1;
   i3 = HEAP32[i2 + -16 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + -12 >> 2] | 0)) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    HEAP32[i8 + 8 >> 2] = 0;
    HEAP8[i8 + 11 >> 0] = 2;
    HEAP16[i8 >> 1] = 24404;
    HEAP8[i8 + 2 >> 0] = 0;
    i3 = i8 + 12 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    i2 = i14 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i5 = i13;
    do if (i3 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i8);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i8);
      break L4;
     } else {
      i12 = (i5 - i4 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i14 + 12 | 0);
      i13 = i15 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i8);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i8);
    HEAP8[i14 + 62 >> 0] = 1;
    i1 = i1 + 2 | 0;
    break L1;
   }
   i7 = HEAP32[i3 + 4 >> 2] | 0;
   i8 = i14 + 4 | 0;
   i9 = i14 + 8 | 0;
   i10 = i14 + 12 | 0;
   i11 = i15 + 8 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 8;
     break;
    }
    i3 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i9 >> 2] | 0;
    i4 = i13;
    if ((i3 | 0) == (i13 | 0)) {
     i5 = HEAP32[i14 >> 2] | 0;
     i2 = (i3 - i5 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      i2 = 14;
      break;
     }
     i5 = (i4 - i5 | 0) / 24 | 0;
     i13 = i5 << 1;
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i5 >>> 0 < 89478485 ? (i13 >>> 0 < i3 >>> 0 ? i3 : i13) : 178956970, i2, i10);
     i3 = HEAP32[i11 >> 2] | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i3 | 0, i6 | 0);
     i13 = __THREW__;
     __THREW__ = 0;
     if (i13 & 1) {
      i2 = 18;
      break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i6 + 12 | 0);
     i13 = __THREW__;
     __THREW__ = 0;
     if (i13 & 1) {
      i2 = 17;
      break;
     }
     HEAP32[i11 >> 2] = i3 + 24;
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i3, i6);
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i3 + 12 | 0, i6 + 12 | 0);
     i13 = __THREW__;
     __THREW__ = 0;
     if (i13 & 1) {
      i2 = 11;
      break;
     }
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 24;
    }
    i6 = i6 + 24 | 0;
   }
   if ((i2 | 0) == 8) {
    i1 = i1 + 2 | 0;
    break L1;
   } else if ((i2 | 0) == 11) {
    i16 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
    ___resumeException(i16 | 0);
   } else if ((i2 | 0) == 14) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14); else if ((i2 | 0) == 17) {
    i12 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
   } else if ((i2 | 0) == 18) {
    i12 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
   ___resumeException(i12 | 0);
  } else {
   i2 = (i2 << 24 >> 24) + -48 | 0;
   if (i2 >>> 0 >= 10) break L1;
   i11 = i1 + 2 | 0;
   while (1) {
    if ((i11 | 0) == (i5 | 0)) break L1;
    i3 = HEAP8[i11 >> 0] | 0;
    i4 = (i3 << 24 >> 24) + -48 | 0;
    if (i4 >>> 0 >= 10) break;
    i2 = i4 + (i2 * 10 | 0) | 0;
    i11 = i11 + 1 | 0;
   }
   if (i3 << 24 >> 24 != 95) break L1;
   i3 = HEAP32[i14 + 36 >> 2] | 0;
   if ((HEAP32[i14 + 32 >> 2] | 0) == (i3 | 0)) break L1;
   i2 = i2 + 1 | 0;
   i12 = HEAP32[i3 + -16 >> 2] | 0;
   i4 = i12;
   if (i2 >>> 0 >= (HEAP32[i3 + -12 >> 2] | 0) - i12 >> 4 >>> 0) {
    i5 = i11 + 1 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    i4 = i5 - i6 | 0;
    if (i4 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
    if (i4 >>> 0 < 11) {
     HEAP8[i7 + 11 >> 0] = i4;
     i3 = i7;
    } else {
     i13 = i4 + 16 & -16;
     i3 = _malloc(i13) | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 8 >> 2] = i13 | -2147483648;
     HEAP32[i7 + 4 >> 2] = i4;
    }
    i2 = i3;
    while (1) {
     if ((i1 | 0) == (i5 | 0)) break;
     HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
    }
    HEAP8[i3 + i4 >> 0] = 0;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i15, i7);
    i1 = i14 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i13 = HEAP32[i14 + 8 >> 2] | 0;
    i4 = i13;
    do if (i2 >>> 0 < i13 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i15);
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
    } else {
     i3 = HEAP32[i14 >> 2] | 0;
     i1 = (i2 - i3 | 0) / 24 | 0;
     i2 = i1 + 1 | 0;
     if (i2 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i14 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      break L4;
     } else {
      i12 = (i4 - i3 | 0) / 24 | 0;
      i13 = i12 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i8, i12 >>> 0 < 89478485 ? (i13 >>> 0 < i2 >>> 0 ? i2 : i13) : 178956970, i1, i14 + 12 | 0);
      i13 = i8 + 8 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i12, i15);
      HEAP32[i13 >> 2] = i12 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i8);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i8);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i15);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
    HEAP8[i14 + 62 >> 0] = 1;
    i1 = i5;
    break L1;
   }
   i6 = HEAP32[i4 + (i2 << 4) + 4 >> 2] | 0;
   i7 = i14 + 4 | 0;
   i8 = i14 + 8 | 0;
   i9 = i14 + 12 | 0;
   i10 = i15 + 8 | 0;
   i5 = HEAP32[i4 + (i2 << 4) >> 2] | 0;
   while (1) {
    if ((i5 | 0) == (i6 | 0)) {
     i2 = 41;
     break;
    }
    i1 = HEAP32[i7 >> 2] | 0;
    i12 = HEAP32[i8 >> 2] | 0;
    i3 = i12;
    if ((i1 | 0) == (i12 | 0)) {
     i4 = HEAP32[i14 >> 2] | 0;
     i1 = (i1 - i4 | 0) / 24 | 0;
     i2 = i1 + 1 | 0;
     if (i2 >>> 0 > 178956970) {
      i2 = 47;
      break;
     }
     i4 = (i3 - i4 | 0) / 24 | 0;
     i12 = i4 << 1;
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i15, i4 >>> 0 < 89478485 ? (i12 >>> 0 < i2 >>> 0 ? i2 : i12) : 178956970, i1, i9);
     i1 = HEAP32[i10 >> 2] | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i1 | 0, i5 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (i12 & 1) {
      i2 = 51;
      break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i1 + 12 | 0, i5 + 12 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (i12 & 1) {
      i2 = 50;
      break;
     }
     HEAP32[i10 >> 2] = i1 + 24;
     __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i14, i15);
     __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
    } else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i1, i5);
     __THREW__ = 0;
     invoke_vii(fb + 4621 | 0, i1 + 12 | 0, i5 + 12 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (i12 & 1) {
      i2 = 44;
      break;
     }
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 24;
    }
    i5 = i5 + 24 | 0;
   }
   if ((i2 | 0) == 41) {
    i1 = i11 + 1 | 0;
    break L1;
   } else if ((i2 | 0) == 44) {
    i16 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
    ___resumeException(i16 | 0);
   } else if ((i2 | 0) == 47) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14); else if ((i2 | 0) == 50) {
    i13 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
   } else if ((i2 | 0) == 51) {
    i13 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i15);
   ___resumeException(i13 | 0);
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN10HumanTrait20InitializeMuscleNameEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i40 + 56 | 0;
 i11 = i40;
 i22 = i40 + 40 | 0;
 i33 = i40 + 28 | 0;
 i36 = i40 + 16 | 0;
 i37 = __Znwj(12) | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[gb + 1467160 >> 2] = i37;
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj(i37, 92);
 i37 = i22 + 11 | 0;
 i38 = i11 + 12 | 0;
 i7 = i11 + 12 | 0;
 i12 = i10 + 4 | 0;
 i13 = i11 + 8 | 0;
 i14 = i11 + 4 | 0;
 i15 = i11 + 11 | 0;
 i16 = i10 + 4 | 0;
 i17 = i10 + 4 | 0;
 i18 = i33 + 11 | 0;
 i19 = i11 + 12 | 0;
 i8 = i11 + 12 | 0;
 i20 = i10 + 4 | 0;
 i21 = i11 + 8 | 0;
 i23 = i11 + 4 | 0;
 i24 = i11 + 11 | 0;
 i25 = i10 + 4 | 0;
 i26 = i10 + 4 | 0;
 i27 = i36 + 11 | 0;
 i28 = i11 + 12 | 0;
 i9 = i11 + 12 | 0;
 i29 = i10 + 4 | 0;
 i30 = i11 + 8 | 0;
 i31 = i11 + 4 | 0;
 i32 = i11 + 11 | 0;
 i34 = i10 + 4 | 0;
 i35 = i10 + 4 | 0;
 i6 = 0;
 do {
  do if ((i6 | 0) < 52) {
   i4 = HEAP32[gb + 1467160 >> 2] | 0;
   i2 = __ZN7mecanim5human10MuscleNameEj(i6) | 0;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i2, _strlen(i2) | 0);
   i2 = (HEAP8[i37 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i38 >> 2] = i1;
   i3 = _strlen(i2) | 0;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
    i1 = HEAP32[i7 >> 2] | 0;
    i39 = 7;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i3;
    if (!i3) i1 = i11; else {
     i1 = i11;
     i39 = 9;
    }
   } else i39 = 7;
   if ((i39 | 0) == 7) {
    i5 = i3 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i13 >> 2] = i5 | -2147483648;
    HEAP32[i14 >> 2] = i3;
    i39 = 9;
   }
   if ((i39 | 0) == 9) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i5 = i4 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
    i4 = HEAP8[i15 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
    i4 = i2 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i39 = 14;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i39 = 16;
    } else i39 = 14;
    if ((i39 | 0) == 14) {
     i41 = i4 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i17 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i41 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i2;
     i39 = 16;
    }
    if ((i39 | 0) == 16) {
     i39 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
   }
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i41 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i16 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i41, i10);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  } else {
   i4 = HEAP32[gb + 1467160 >> 2] | 0;
   if ((i6 | 0) < 72) {
    i1 = i6 + -52 | 0;
    HEAP32[i33 >> 2] = 0;
    HEAP32[i33 + 4 >> 2] = 0;
    HEAP32[i33 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i33, gb + 908416 | 0, 5);
    if (i1 >>> 0 < 20) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, __ZN7mecanim4hand10FingerNameEj(i1 >>> 2) | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, gb + 1086395 | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i33, __ZN7mecanim4hand13FingerDoFNameEj(i1 & 3) | 0) | 0;
    }
    i2 = (HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i33 >> 2] | 0 : i33;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i19 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
     i1 = HEAP32[i8 >> 2] | 0;
     i39 = 28;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i24 >> 0] = i3;
     if (!i3) i1 = i11; else {
      i1 = i11;
      i39 = 30;
     }
    } else i39 = 28;
    if ((i39 | 0) == 28) {
     i41 = i3 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i20 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i21 >> 2] = i41 | -2147483648;
     HEAP32[i23 >> 2] = i3;
     i39 = 30;
    }
    if ((i39 | 0) == 30) {
     i39 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    i5 = i4 + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
     i4 = HEAP8[i24 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = i2 ? HEAP32[i23 >> 2] | 0 : i4 & 255;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i1 + 12 >> 2] = i2;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      i39 = 35;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i1 + 11 >> 0] = i4;
      if (i4) i39 = 37;
     } else i39 = 35;
     if ((i39 | 0) == 35) {
      i42 = i4 + 16 & -16;
      HEAP32[i10 >> 2] = 66;
      HEAP32[i26 >> 2] = i2;
      i41 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i42, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i1 >> 2] = i41;
      HEAP32[i1 + 8 >> 2] = i42 | -2147483648;
      HEAP32[i1 + 4 >> 2] = i4;
      i1 = i41;
      i39 = 37;
     }
     if ((i39 | 0) == 37) {
      i39 = 0;
      _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i1 + i4 >> 0] = 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
    }
    if ((HEAP8[i24 >> 0] | 0) < 0) {
     i42 = HEAP32[i11 >> 2] | 0;
     i41 = HEAP32[i8 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i25 >> 2] = i41;
     __Z19free_alloc_internalPvRK10MemLabelId(i42, i10);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
    break;
   } else {
    i1 = i6 + -72 | 0;
    HEAP32[i36 >> 2] = 0;
    HEAP32[i36 + 4 >> 2] = 0;
    HEAP32[i36 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i36, gb + 908422 | 0, 6);
    if (i1 >>> 0 < 20) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, __ZN7mecanim4hand10FingerNameEj(i1 >>> 2) | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, gb + 1086395 | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i36, __ZN7mecanim4hand13FingerDoFNameEj(i1 & 3) | 0) | 0;
    }
    i2 = (HEAP8[i27 >> 0] | 0) < 0 ? HEAP32[i36 >> 2] | 0 : i36;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i28 >> 2] = i1;
    i3 = _strlen(i2) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
     i1 = HEAP32[i9 >> 2] | 0;
     i39 = 48;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i32 >> 0] = i3;
     if (!i3) i1 = i11; else {
      i1 = i11;
      i39 = 50;
     }
    } else i39 = 48;
    if ((i39 | 0) == 48) {
     i42 = i3 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i29 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i42, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i30 >> 2] = i42 | -2147483648;
     HEAP32[i31 >> 2] = i3;
     i39 = 50;
    }
    if ((i39 | 0) == 50) {
     i39 = 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    i5 = i4 + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4, i11); else {
     i4 = HEAP8[i32 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     i3 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = i2 ? HEAP32[i31 >> 2] | 0 : i4 & 255;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i1 + 12 >> 2] = i2;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
      i2 = HEAP32[i1 + 12 >> 2] | 0;
      i39 = 55;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i1 + 11 >> 0] = i4;
      if (i4) i39 = 57;
     } else i39 = 55;
     if ((i39 | 0) == 55) {
      i41 = i4 + 16 & -16;
      HEAP32[i10 >> 2] = 66;
      HEAP32[i35 >> 2] = i2;
      i42 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i1 >> 2] = i42;
      HEAP32[i1 + 8 >> 2] = i41 | -2147483648;
      HEAP32[i1 + 4 >> 2] = i4;
      i1 = i42;
      i39 = 57;
     }
     if ((i39 | 0) == 57) {
      i39 = 0;
      _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i1 + i4 >> 0] = 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 16;
    }
    if ((HEAP8[i32 >> 0] | 0) < 0) {
     i42 = HEAP32[i11 >> 2] | 0;
     i41 = HEAP32[i9 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i34 >> 2] = i41;
     __Z19free_alloc_internalPvRK10MemLabelId(i42, i10);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
    break;
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 92);
 STACKTOP = i40;
 return;
}

function __Z17setConstraintDataRN5physx19PxsParticleCollDataERKfRKNS_6PxVec3ES6_RKNS_11PxTransformE(i19, i8, i9, i10, i4) {
 i19 = i19 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i20 = i19 + 62 | 0;
 i1 = HEAP16[i20 >> 1] | 0;
 i2 = i1 & 65535;
 L1 : do if (!(i2 & 1)) {
  f15 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
  f13 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) * Math_fround(2.0));
  f21 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(2.0));
  f11 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f22 = Math_fround(Math_fround(f11 * f11) + Math_fround(-.5));
  f12 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f15 * f12);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f14));
  f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f21 * f16));
  f7 = Math_fround(Math_fround(f12 * f5) + Math_fround(Math_fround(f15 * f22) + Math_fround(f11 * Math_fround(Math_fround(f21 * f14) - Math_fround(f13 * f16)))));
  f6 = Math_fround(Math_fround(f14 * f5) + Math_fround(Math_fround(f13 * f22) + Math_fround(f11 * Math_fround(Math_fround(f15 * f16) - Math_fround(f21 * f12)))));
  f5 = Math_fround(Math_fround(Math_fround(f21 * f22) + Math_fround(f11 * Math_fround(Math_fround(f13 * f12) - Math_fround(f15 * f14)))) + Math_fround(f16 * f5));
  f15 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
  f13 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(2.0));
  f21 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) * Math_fround(2.0));
  f17 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(f14 * f13)) + Math_fround(f16 * f21));
  f18 = Math_fround(Math_fround(f12 * f17) + Math_fround(Math_fround(f22 * f15) + Math_fround(f11 * Math_fround(Math_fround(f14 * f21) - Math_fround(f16 * f13)))));
  f3 = Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f22 * f13) + Math_fround(f11 * Math_fround(Math_fround(f16 * f15) - Math_fround(f12 * f21)))));
  f17 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f11 * Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * f15)))) + Math_fround(f16 * f17));
  f18 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f18);
  f3 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f3);
  f3 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f17)) + Math_fround(Math_fround(f7 * f18) + Math_fround(f6 * f3)));
  i2 = HEAP32[i19 + 140 >> 2] | 0;
  i1 = HEAP16[i20 >> 1] | 0;
 } else {
  do if (!(i2 & 2)) {
   f17 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
   f15 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(2.0));
   f13 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f11 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f5 = Math_fround(f17 * f14);
   f16 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f15 * f16));
   f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f12 * f18));
   f7 = Math_fround(Math_fround(f14 * f5) + Math_fround(Math_fround(f17 * f11) + Math_fround(f13 * Math_fround(Math_fround(f12 * f16) - Math_fround(f15 * f18)))));
   f6 = Math_fround(Math_fround(f16 * f5) + Math_fround(Math_fround(f15 * f11) + Math_fround(f13 * Math_fround(Math_fround(f17 * f18) - Math_fround(f12 * f14)))));
   f5 = Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f13 * Math_fround(Math_fround(f15 * f14) - Math_fround(f17 * f16)))) + Math_fround(f18 * f5));
   f17 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
   f15 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) * Math_fround(2.0));
   f21 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(f16 * f15)) + Math_fround(f18 * f12));
   f22 = Math_fround(Math_fround(f14 * f21) + Math_fround(Math_fround(f11 * f17) + Math_fround(f13 * Math_fround(Math_fround(f16 * f12) - Math_fround(f18 * f15)))));
   f3 = Math_fround(Math_fround(f16 * f21) + Math_fround(Math_fround(f11 * f15) + Math_fround(f13 * Math_fround(Math_fround(f18 * f17) - Math_fround(f14 * f12)))));
   f21 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(f13 * Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f17)))) + Math_fround(f18 * f21));
   f22 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f22);
   f3 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f3);
   f3 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f21)) + Math_fround(Math_fround(f7 * f22) + Math_fround(f6 * f3)));
   i2 = HEAP32[i19 + 156 >> 2] | 0;
   i1 = HEAP16[i20 >> 1] | 0;
  } else {
   f17 = Math_fround(Math_fround(HEAPF32[i19 + 112 >> 2]) * Math_fround(2.0));
   f18 = Math_fround(Math_fround(HEAPF32[i19 + 116 >> 2]) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(HEAPF32[i19 + 120 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f5 = Math_fround(f17 * f14);
   f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f18 * f15));
   f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f11 * f16));
   f22 = Math_fround(Math_fround(f14 * f5) + Math_fround(Math_fround(f17 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f15) - Math_fround(f18 * f16)))));
   f3 = Math_fround(Math_fround(f15 * f5) + Math_fround(Math_fround(f18 * f13) + Math_fround(f12 * Math_fround(Math_fround(f17 * f16) - Math_fround(f11 * f14)))));
   f5 = Math_fround(Math_fround(Math_fround(f11 * f13) + Math_fround(f12 * Math_fround(Math_fround(f18 * f14) - Math_fround(f17 * f15)))) + Math_fround(f16 * f5));
   f17 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   f22 = Math_fround(f17 + f22);
   f18 = Math_fround(HEAPF32[i4 + 20 >> 2]);
   f3 = Math_fround(f18 + f3);
   f11 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   f5 = Math_fround(f11 + f5);
   i2 = HEAP32[i19 + 140 >> 2] | 0;
   f6 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f22);
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f3));
   f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2])));
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 12 >> 2]));
   i4 = HEAP32[i19 + 156 >> 2] | 0;
   f22 = Math_fround(f22 * Math_fround(HEAPF32[i4 >> 2]));
   f3 = Math_fround(f22 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 4 >> 2])));
   f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i4 + 8 >> 2])));
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 12 >> 2]));
   f3 = Math_fround(HEAPF32[i8 >> 2]);
   if (f6 < f5) if (f3 < f5) {
    f22 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
    f21 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) * Math_fround(2.0));
    f3 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(2.0));
    f26 = Math_fround(Math_fround(Math_fround(f14 * f22) + Math_fround(f15 * f21)) + Math_fround(f16 * f3));
    f25 = Math_fround(Math_fround(f14 * f26) + Math_fround(Math_fround(f13 * f22) + Math_fround(f12 * Math_fround(Math_fround(f15 * f3) - Math_fround(f16 * f21)))));
    f24 = Math_fround(Math_fround(f15 * f26) + Math_fround(Math_fround(f13 * f21) + Math_fround(f12 * Math_fround(Math_fround(f16 * f22) - Math_fround(f14 * f3)))));
    f26 = Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(f12 * Math_fround(Math_fround(f14 * f21) - Math_fround(f15 * f22)))) + Math_fround(f16 * f26));
    f22 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
    f21 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(2.0));
    f3 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) * Math_fround(2.0));
    f23 = Math_fround(Math_fround(Math_fround(f14 * f22) + Math_fround(f15 * f21)) + Math_fround(f16 * f3));
    f5 = f26;
    f6 = f24;
    f7 = f25;
    f3 = Math_fround(Math_fround(f26 * Math_fround(f11 + Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(f12 * Math_fround(Math_fround(f14 * f21) - Math_fround(f15 * f22)))) + Math_fround(f16 * f23)))) + Math_fround(Math_fround(f25 * Math_fround(f17 + Math_fround(Math_fround(f14 * f23) + Math_fround(Math_fround(f13 * f22) + Math_fround(f12 * Math_fround(Math_fround(f15 * f3) - Math_fround(f16 * f21))))))) + Math_fround(f24 * Math_fround(f18 + Math_fround(Math_fround(f15 * f23) + Math_fround(Math_fround(f13 * f21) + Math_fround(f12 * Math_fround(Math_fround(f16 * f22) - Math_fround(f14 * f3)))))))));
    i2 = i4;
    break;
   } else return; else if (f3 < f6) {
    f26 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
    f25 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) * Math_fround(2.0));
    f3 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(2.0));
    f21 = Math_fround(Math_fround(Math_fround(f14 * f26) + Math_fround(f15 * f25)) + Math_fround(f16 * f3));
    f22 = Math_fround(Math_fround(f14 * f21) + Math_fround(Math_fround(f13 * f26) + Math_fround(f12 * Math_fround(Math_fround(f15 * f3) - Math_fround(f16 * f25)))));
    f23 = Math_fround(Math_fround(f15 * f21) + Math_fround(Math_fround(f13 * f25) + Math_fround(f12 * Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f3)))));
    f21 = Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(f12 * Math_fround(Math_fround(f14 * f25) - Math_fround(f15 * f26)))) + Math_fround(f16 * f21));
    f26 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
    f25 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(2.0));
    f3 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) * Math_fround(2.0));
    f24 = Math_fround(Math_fround(Math_fround(f14 * f26) + Math_fround(f15 * f25)) + Math_fround(f16 * f3));
    f5 = f21;
    f6 = f23;
    f7 = f22;
    f3 = Math_fround(Math_fround(f21 * Math_fround(f11 + Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(f12 * Math_fround(Math_fround(f14 * f25) - Math_fround(f15 * f26)))) + Math_fround(f16 * f24)))) + Math_fround(Math_fround(f22 * Math_fround(f17 + Math_fround(Math_fround(f14 * f24) + Math_fround(Math_fround(f13 * f26) + Math_fround(f12 * Math_fround(Math_fround(f15 * f3) - Math_fround(f16 * f25))))))) + Math_fround(f23 * Math_fround(f18 + Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f13 * f25) + Math_fround(f12 * Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f3)))))))));
    break L1;
   } else return;
  } while (0);
  HEAPF32[i2 >> 2] = f7;
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f3;
  HEAP16[i20 >> 1] = i1 & 65525 | 2;
  return;
 } while (0);
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f5;
 HEAPF32[i2 + 12 >> 2] = f3;
 HEAP16[i20 >> 1] = i1 & 65530 | 1;
 return;
}

function __Z26CreateTangentSpaceTangentsPK8Vector3fPK8Vector2fS1_P10Matrix3x3fiPKii(i13, i14, i35, i36, i37, i28, i29) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i43 + 60 | 0;
 i39 = i43 + 48 | 0;
 i41 = i43 + 36 | 0;
 i32 = i43 + 24 | 0;
 i33 = i43 + 12 | 0;
 i34 = i43;
 HEAP32[i41 >> 2] = 0;
 i42 = i41 + 4 | 0;
 HEAP32[i42 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i32 >> 2] = 0;
 i40 = i32 + 4 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 if (!i37) {
  i2 = 0;
  i1 = 0;
 } else {
  __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj(i41, i37);
  i2 = HEAP32[i40 >> 2] | 0;
  i1 = HEAP32[i32 >> 2] | 0;
 }
 i3 = (i2 - i1 | 0) / 12 | 0;
 if (i3 >>> 0 < i37 >>> 0) __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj(i32, i37 - i3 | 0); else if (i3 >>> 0 > i37 >>> 0) {
  i1 = i1 + (i37 * 12 | 0) | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i40 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 }
 if (!i29) {
  i30 = 0;
  i31 = 0;
 } else {
  i30 = i29 * 36 | 0;
  i31 = __Znwj(i30) | 0;
  i30 = __Znwj(i30) | 0;
 }
 i4 = (i37 | 0) > 0;
 if (i4) {
  i9 = i37 * 12 | 0;
  _memset(i31 | 0, 0, i9 | 0) | 0;
  _memset(i30 | 0, 0, i9 | 0) | 0;
 }
 if ((i29 | 0) > 0) {
  i5 = i38 + 4 | 0;
  i6 = i38 + 8 | 0;
  i3 = i39 + 4 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   i7 = HEAP32[i28 + (i1 << 2) >> 2] | 0;
   i8 = i13 + (i7 * 12 | 0) | 0;
   HEAP32[i38 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i38 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i38 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = i28 + (i1 + 1 << 2) | 0;
   i45 = HEAP32[i8 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i13 + (i45 * 12 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i38 >> 2]);
   f10 = Math_fround(f10 - f15);
   f11 = Math_fround(HEAPF32[i13 + (i45 * 12 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i5 >> 2]);
   f11 = Math_fround(f11 - f16);
   f12 = Math_fround(HEAPF32[i13 + (i45 * 12 | 0) + 8 >> 2]);
   f17 = Math_fround(HEAPF32[i6 >> 2]);
   f12 = Math_fround(f12 - f17);
   i9 = i28 + (i1 + 2 << 2) | 0;
   i44 = HEAP32[i9 >> 2] | 0;
   f18 = Math_fround(Math_fround(HEAPF32[i13 + (i44 * 12 | 0) >> 2]) - f15);
   f19 = Math_fround(Math_fround(HEAPF32[i13 + (i44 * 12 | 0) + 4 >> 2]) - f16);
   f20 = Math_fround(Math_fround(HEAPF32[i13 + (i44 * 12 | 0) + 8 >> 2]) - f17);
   f21 = Math_fround(HEAPF32[i14 + (i7 << 3) >> 2]);
   f22 = Math_fround(HEAPF32[i14 + (i7 << 3) + 4 >> 2]);
   f23 = Math_fround(Math_fround(HEAPF32[i14 + (i45 << 3) >> 2]) - f21);
   f24 = Math_fround(Math_fround(HEAPF32[i14 + (i45 << 3) + 4 >> 2]) - f22);
   f25 = Math_fround(Math_fround(HEAPF32[i14 + (i44 << 3) >> 2]) - f21);
   f26 = Math_fround(Math_fround(HEAPF32[i14 + (i44 << 3) + 4 >> 2]) - f22);
   f27 = Math_fround(Math_fround(f23 * f26) - Math_fround(f24 * f25));
   if (!(Math_fround(Math_abs(Math_fround(f27))) < Math_fround(9.99999997e-07))) {
    f49 = Math_fround(Math_fround(0.0) - f21);
    f52 = Math_fround(Math_fround(0.0) - f22);
    f50 = Math_fround(f49 * f26);
    f53 = Math_fround(f52 * f25);
    f46 = Math_fround(Math_fround(f50 - f53) / f27);
    f52 = Math_fround(f52 * f23);
    f49 = Math_fround(f49 * f24);
    f51 = Math_fround(Math_fround(f52 - f49) / f27);
    f48 = Math_fround(Math_fround(f18 * f51) + Math_fround(f15 + Math_fround(f46 * f10)));
    f47 = Math_fround(Math_fround(f19 * f51) + Math_fround(f16 + Math_fround(f46 * f11)));
    f46 = Math_fround(Math_fround(f20 * f51) + Math_fround(f17 + Math_fround(f12 * f46)));
    f51 = Math_fround(Math_fround(1.0) - f21);
    f21 = Math_fround(Math_fround(Math_fround(f51 * f26) - f53) / f27);
    f24 = Math_fround(Math_fround(f52 - Math_fround(f51 * f24)) / f27);
    f22 = Math_fround(Math_fround(1.0) - f22);
    f25 = Math_fround(Math_fround(f50 - Math_fround(f22 * f25)) / f27);
    f27 = Math_fround(Math_fround(Math_fround(f22 * f23) - f49) / f27);
    f22 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(f15 + Math_fround(f25 * f10))) - f48);
    f23 = Math_fround(Math_fround(Math_fround(f19 * f27) + Math_fround(f16 + Math_fround(f25 * f11))) - f47);
    f27 = Math_fround(Math_fround(Math_fround(f20 * f27) + Math_fround(f17 + Math_fround(f12 * f25))) - f46);
    f25 = Math_fround(Math_fround(Math_fround(f18 * f24) + Math_fround(f15 + Math_fround(f21 * f10))) - f48);
    f26 = Math_fround(Math_fround(Math_fround(f19 * f24) + Math_fround(f16 + Math_fround(f21 * f11))) - f47);
    f21 = Math_fround(Math_fround(Math_fround(f20 * f24) + Math_fround(f17 + Math_fround(f12 * f21))) - f46);
    f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f22 * f22) + Math_fround(f23 * f23))))));
    f22 = Math_fround(f24 * f22);
    f23 = Math_fround(f24 * f23);
    f24 = Math_fround(f27 * f24);
    f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
    f25 = Math_fround(f25 * f27);
    f26 = Math_fround(f27 * f26);
    f27 = Math_fround(f21 * f27);
    i45 = i31 + (i7 * 12 | 0) | 0;
    HEAPF32[i45 >> 2] = Math_fround(Math_fround(HEAPF32[i45 >> 2]) + f22);
    i45 = i31 + (i7 * 12 | 0) + 4 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = i31 + (i7 * 12 | 0) + 8 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = i30 + (i7 * 12 | 0) | 0;
    HEAPF32[i45 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = i30 + (i7 * 12 | 0) + 4 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = i30 + (i7 * 12 | 0) + 8 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = HEAP32[i8 >> 2] | 0;
    i44 = i31 + (i45 * 12 | 0) | 0;
    HEAPF32[i44 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i31 + (i45 * 12 | 0) + 4 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i31 + (i45 * 12 | 0) + 8 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i30 + (i45 * 12 | 0) | 0;
    HEAPF32[i44 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i30 + (i45 * 12 | 0) + 4 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i44 >> 2]));
    i45 = i30 + (i45 * 12 | 0) + 8 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i45 >> 2]));
    i45 = HEAP32[i9 >> 2] | 0;
    i44 = i31 + (i45 * 12 | 0) | 0;
    HEAPF32[i44 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i31 + (i45 * 12 | 0) + 4 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i31 + (i45 * 12 | 0) + 8 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i30 + (i45 * 12 | 0) | 0;
    HEAPF32[i44 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i44 >> 2]));
    i44 = i30 + (i45 * 12 | 0) + 4 | 0;
    HEAPF32[i44 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i44 >> 2]));
    i45 = i30 + (i45 * 12 | 0) + 8 | 0;
    HEAPF32[i45 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i45 >> 2]));
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i29 | 0)) break; else i1 = i1 + 3 | 0;
  }
  HEAPF32[i39 >> 2] = f10;
  HEAPF32[i3 >> 2] = f11;
  HEAPF32[i39 + 8 >> 2] = f12;
 }
 if (i4) {
  i3 = i38 + 4 | 0;
  i5 = i38 + 8 | 0;
  i2 = i39 + 4 | 0;
  i4 = i39 + 8 | 0;
  i13 = i33 + 4 | 0;
  i14 = i33 + 8 | 0;
  i1 = 0;
  do {
   i6 = i31 + (i1 * 12 | 0) | 0;
   i54 = HEAP32[i31 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i31 + (i1 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i38 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 >> 2] = i54;
   HEAP32[i5 >> 2] = i7;
   __Z15NormalizeRobustRK8Vector3f(i33, i38);
   HEAP32[i38 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i38 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i38 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   i7 = i30 + (i1 * 12 | 0) | 0;
   i54 = HEAP32[i7 >> 2] | 0;
   i8 = i30 + (i1 * 12 | 0) + 4 | 0;
   i28 = HEAP32[i8 >> 2] | 0;
   i9 = i30 + (i1 * 12 | 0) + 8 | 0;
   i45 = HEAP32[i9 >> 2] | 0;
   HEAP32[i39 >> 2] = i54;
   HEAP32[i2 >> 2] = i28;
   HEAP32[i4 >> 2] = i45;
   i44 = HEAP32[i35 + (i1 * 12 | 0) >> 2] | 0;
   i29 = HEAP32[i35 + (i1 * 12 | 0) + 4 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i35 + (i1 * 12 | 0) + 8 >> 2]);
   HEAP32[i33 >> 2] = i44;
   HEAP32[i13 >> 2] = i29;
   HEAPF32[i14 >> 2] = f10;
   f11 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround(f11 * f11);
   f12 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(f11 + Math_fround(f12 * f12));
   f11 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i45 = Math_fround(f12 + Math_fround(f11 * f11)) < Math_fround(.0000999999974);
   f11 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i45) {
    f53 = Math_fround(HEAPF32[i3 >> 2]);
    f51 = Math_fround(f10 * f53);
    f52 = Math_fround(HEAPF32[i5 >> 2]);
    f51 = Math_fround(f51 - Math_fround(f52 * f11));
    f52 = Math_fround(f52 * f12);
    f50 = Math_fround(HEAPF32[i38 >> 2]);
    f52 = Math_fround(f52 - Math_fround(f10 * f50));
    f53 = Math_fround(Math_fround(f11 * f50) - Math_fround(f53 * f12));
    HEAPF32[i39 >> 2] = f51;
    HEAPF32[i2 >> 2] = f52;
    HEAPF32[i4 >> 2] = f53;
   }
   __Z15NormalizeRobustRK8Vector3f(i34, i39);
   HEAP32[i39 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i39 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i39 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   __ZN10Matrix3x3f8SetBasisERK8Vector3fS2_S2_(i36 + (i1 * 36 | 0) | 0, i7, i6, i33) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i37 | 0));
 }
 i1 = HEAP32[i32 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i40 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i40 >> 2] = i3 + (~(((i3 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i41 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i42 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i42 >> 2] = i3 + (~(((i3 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 if (i30 | 0) __ZdlPv(i30);
 if (!i31) {
  STACKTOP = i43;
  return;
 }
 __ZdlPv(i31);
 STACKTOP = i43;
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i25, i26, i28, i27, i1) {
 i2 = i2 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 160 | 0;
 i21 = i24 + 152 | 0;
 i13 = i24 + 144 | 0;
 i6 = i24 + 136 | 0;
 i12 = i24 + 8 | 0;
 i2 = i24;
 i22 = i24 + 200 | 0;
 i20 = i24 + 188 | 0;
 i19 = i24 + 184 | 0;
 i18 = i24 + 168 | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 88 >> 2] | 0, i25 | 0) | 0;
 i11 = i10 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i8 = i22;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 128, gb + 1084495 | 0, i2) | 0;
 if (HEAP8[i22 >> 0] | 0) {
  i17 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
  mftCall_iiii(i17 | 0, i27 | 0, i22 | 0, _strlen(i22) | 0) | 0;
 }
 HEAP8[i2 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i2 | 0, 1) | 0;
 i15 = i27 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 674663 | 0, HEAP32[i15 >> 2] | 0);
 i16 = i27 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i27 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i2 = i10 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = i22;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i12 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 128, gb + 1084495 | 0, i12) | 0;
 if (HEAP8[i22 >> 0] | 0) {
  i14 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
  mftCall_iiii(i14 | 0, i27 | 0, i22 | 0, _strlen(i22) | 0) | 0;
 }
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 773144 | 0, HEAP32[i15 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 232 >> 2] | 0, i25 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i10 + 12 >> 2] | 0;
  i2 = (i1 + -1 | 0) >>> 5;
  if (i5 | 0) {
   i4 = 0;
   while (1) {
    i1 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
    if ((i4 | 0) != 0 & (i4 & 7 | 0) == 0) mftCall_iiii(i1 | 0, i27 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i27 | 0, gb + 1086395 | 0, 1) | 0;
    i1 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
    i8 = i12;
    i9 = i8 + 128 | 0;
    do {
     HEAP8[i8 >> 0] = 0;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) < (i9 | 0));
    HEAP32[i6 >> 2] = i1;
    __ZN5physx6string9sprintf_sEPcjPKcz(i12, 128, gb + 1084495 | 0, i6) | 0;
    if (HEAP8[i12 >> 0] | 0) {
     i9 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
     mftCall_iiii(i9 | 0, i27 | 0, i12 | 0, _strlen(i12) | 0) | 0;
    }
    if ((i4 | 0) == (i2 | 0)) break; else i4 = i4 + 1 | 0;
   }
   HEAP8[i6 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i6 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 773163 | 0, HEAP32[i15 >> 2] | 0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i10 + 20 | 0;
  if (i1 | 0) {
   i4 = i10 + 16 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
    if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i5 | 0, i27 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i5 | 0, i27 | 0, gb + 1086395 | 0, 1) | 0;
    __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i27, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[i2 >> 2] | 0, i6) | 0) | 0) | 0;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i1 | 0));
   HEAP8[i12 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i12 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 765025 | 0, HEAP32[i15 >> 2] | 0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  }
  i7 = i14 & 65535;
  if (i7 & 2 | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i10 + 28 | 0;
   if (i1 | 0) {
    i4 = i10 + 24 | 0;
    i6 = 0;
    do {
     i5 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
     if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i5 | 0, i27 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i5 | 0, i27 | 0, gb + 1086395 | 0, 1) | 0;
     __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i27, (HEAP32[i4 >> 2] | 0) + (Math_imul(HEAP32[i2 >> 2] | 0, i6) | 0) | 0) | 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i1 | 0));
    HEAP8[i12 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i12 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 765035 | 0, HEAP32[i15 >> 2] | 0);
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
  }
  if (i7 & 4 | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = i10 + 36 | 0;
   if (i2 | 0) {
    i5 = i10 + 32 | 0;
    i6 = 0;
    do {
     i1 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
     if ((i6 | 0) != 0 & ((i6 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i27 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i27 | 0, gb + 1086395 | 0, 1) | 0;
     d3 = +Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i6) | 0) >> 2]);
     i8 = i12;
     i9 = i8 + 128 | 0;
     do {
      HEAP8[i8 >> 0] = 0;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) < (i9 | 0));
     HEAPF64[i13 >> 3] = d3;
     __ZN5physx6string9sprintf_sEPcjPKcz(i12, 128, gb + 832323 | 0, i13) | 0;
     if (HEAP8[i12 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i27 | 0, i12 | 0, _strlen(i12) | 0) | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i2 | 0));
    HEAP8[i13 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i13 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 765046 | 0, HEAP32[i15 >> 2] | 0);
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
  }
  if (i7 & 8 | 0) __ZN5physx2Sn16writeStrideFlagsINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEPFRKS5_PS6_jEEEvRNS_9XmlWriterERNS_12MemoryBufferEjRNS_16PxStrideIteratorIKT_EET0_jPKcPKNS_11PxU32ToNameE(i28, i27, 6, i10 + 40 | 0, fb + 829 | 0, HEAP32[i11 >> 2] | 0, gb + 743223 | 0, gb + 115968 | 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i10 | 0);
 i1 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 196 >> 2] | 0, i25 | 0) | 0;
 i8 = i22;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i21 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 128, gb + 1084495 | 0, i21) | 0;
 if (HEAP8[i22 >> 0] | 0) {
  i13 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
  mftCall_iiii(i13 | 0, i27 | 0, i22 | 0, _strlen(i22) | 0) | 0;
 }
 HEAP8[i21 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i21 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 743229 | 0, HEAP32[i15 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 192 >> 2] | 0, i25 | 0) | 0;
 i5 = i13 & 65535;
 if (i13 << 16 >> 16) {
  i1 = HEAP32[gb + 116016 >> 2] | 0;
  if (i1 | 0) {
   i2 = gb + 116016 | 0;
   i4 = 0;
   do {
    i13 = HEAP32[gb + 116016 + (i4 << 3) + 4 >> 2] | 0;
    do if ((i13 & i5 | 0) == (i13 | 0)) {
     if (HEAP32[i17 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i13 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
      mftCall_iiii(i13 | 0, i27 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i4 = i4 + 1 | 0;
    i2 = gb + 116016 + (i4 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i21 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i21 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 743242 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 i5 = i14 & 65535;
 if (i14 << 16 >> 16) {
  i1 = HEAP32[gb + 116080 >> 2] | 0;
  if (i1 | 0) {
   i2 = gb + 116080 | 0;
   i4 = 0;
   do {
    i14 = HEAP32[gb + 116080 + (i4 << 3) + 4 >> 2] | 0;
    do if ((i14 & i5 | 0) == (i14 | 0)) {
     if (HEAP32[i17 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i14 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
      mftCall_iiii(i14 | 0, i27 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i4 = i4 + 1 | 0;
    i2 = gb + 116080 + (i4 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i21 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i21 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, gb + 743260 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i25 >> 2] | 0) + 136 >> 2] | 0, i25 | 0, i20 | 0, i19 | 0);
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i9 = HEAP32[i20 + 8 >> 2] | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 HEAP32[i18 + 8 >> 2] = i9;
 HEAP32[i18 + 12 >> 2] = i8;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i27, i18) | 0;
 mftCall_iiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +(HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i22;
 i9 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAPF64[i23 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 128, gb + 832323 | 0, i23) | 0;
 if (!(HEAP8[i22 >> 0] | 0)) {
  HEAP8[i23 >> 0] = 0;
  i22 = HEAP32[i27 >> 2] | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  mftCall_iiii(i22 | 0, i27 | 0, i23 | 0, 1) | 0;
  i22 = HEAP32[i28 >> 2] | 0;
  i22 = i22 + 8 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i23 = HEAP32[i15 >> 2] | 0;
  mftCall_viii(i22 | 0, i28 | 0, gb + 743282 | 0, i23 | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
  __ZN5physx2Sn18writeAllPropertiesINS_15PxParticleFluidEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i25, i28, i27, i26);
  STACKTOP = i24;
  return;
 }
 i21 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
 mftCall_iiii(i21 | 0, i27 | 0, i22 | 0, _strlen(i22) | 0) | 0;
 HEAP8[i23 >> 0] = 0;
 i22 = HEAP32[i27 >> 2] | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 mftCall_iiii(i22 | 0, i27 | 0, i23 | 0, 1) | 0;
 i22 = HEAP32[i28 >> 2] | 0;
 i22 = i22 + 8 | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i15 >> 2] | 0;
 mftCall_viii(i22 | 0, i28 | 0, gb + 743282 | 0, i23 | 0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 __ZN5physx2Sn18writeAllPropertiesINS_15PxParticleFluidEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i25, i28, i27, i26);
 STACKTOP = i24;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_(i20, i21, i16, i8, i1) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i16 = i16 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 16 | 0;
 i24 = i25;
 i22 = __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i20, i21, i16, i1) | 0;
 i9 = i8 + 11 | 0;
 i3 = HEAP8[i9 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i7 = i8 + 4 | 0;
 i3 = i2 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
 i14 = i16 + 11 | 0;
 i6 = HEAP8[i14 >> 0] | 0;
 i5 = i6 << 24 >> 24 < 0;
 i15 = i16 + 4 | 0;
 i6 = i5 ? HEAP32[i15 >> 2] | 0 : i6 & 255;
 i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 if (!i1) i19 = 3; else {
  i4 = HEAP32[i16 >> 2] | 0;
  i1 = _memcmp(i2 ? HEAP32[i8 >> 2] | 0 : i8, i5 ? i4 : i16, i1) | 0;
  if (!i1) i19 = 3; else if ((i1 | 0) < 0) {
   i10 = i16;
   i11 = i16;
   i1 = i4;
  } else {
   i24 = i22;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 3) if (i3 >>> 0 < i6 >>> 0) {
  i10 = i16;
  i11 = i16;
  i1 = HEAP32[i16 >> 2] | 0;
  break;
 } else {
  i24 = i22;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i5 ? i1 : i10;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 9;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i6;
  if (!i6) i1 = i24; else {
   i1 = i24;
   i19 = 11;
  }
 } else i19 = 9;
 if ((i19 | 0) == 9) {
  i18 = i6 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i18 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i6;
  i19 = 11;
 }
 if ((i19 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 do if ((i16 | 0) != (i8 | 0)) {
  i5 = HEAP8[i9 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  i5 = i1 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i18 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i5 - i3 | 0, i18, 0, i18, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i11 >> 2] | 0 : i10;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i14 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = i5;
   break;
  } else {
   HEAP8[i14 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i8 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i9 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i18 = i2 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i6 - i3 | 0, i18, 0, i18, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   HEAP32[i7 >> 2] = i6;
   break;
  } else {
   HEAP8[i9 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i18 = HEAP32[i24 >> 2] | 0;
  i17 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i17;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i23);
 }
 i4 = i22 + 1 | 0;
 i5 = HEAP8[i14 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
 i17 = i21 + 11 | 0;
 i7 = HEAP8[i17 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i18 = i21 + 4 | 0;
 i7 = i6 ? HEAP32[i18 >> 2] | 0 : i7 & 255;
 i2 = i7 >>> 0 < i5 >>> 0 ? i7 : i5;
 if (!i2) i19 = 36; else {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = _memcmp(i3 ? HEAP32[i11 >> 2] | 0 : i10, i6 ? i1 : i21, i2) | 0;
  if (!i2) i19 = 36; else if ((i2 | 0) < 0) {
   i12 = i21;
   i13 = i21;
  } else {
   i24 = i4;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 36) if (i5 >>> 0 < i7 >>> 0) {
  i12 = i21;
  i13 = i21;
  i1 = HEAP32[i21 >> 2] | 0;
  break;
 } else {
  i24 = i4;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i6 ? i1 : i12;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i7 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 42;
 } else if (i7 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i7;
  if (!i7) i1 = i24; else {
   i1 = i24;
   i19 = 44;
  }
 } else i19 = 42;
 if ((i19 | 0) == 42) {
  i9 = i7 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i7;
  i19 = 44;
 }
 if ((i19 | 0) == 44) _memcpy(i1 | 0, i2 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 do if ((i21 | 0) != (i16 | 0)) {
  i5 = HEAP8[i14 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i11 >> 2] | 0 : i10;
  i5 = i1 ? HEAP32[i15 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i17 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i9 = i2 ? HEAP32[i18 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i3, i5 - i3 | 0, i9, 0, i9, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i13 >> 2] | 0 : i12;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i17 >> 0] | 0) < 0) {
   HEAP32[i18 >> 2] = i5;
   break;
  } else {
   HEAP8[i17 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i16 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i15 = i2 ? HEAP32[i15 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i6 - i3 | 0, i15, 0, i15, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i11 >> 2] | 0 : i10;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i14 >> 0] | 0) < 0) {
   HEAP32[i15 >> 2] = i6;
   break;
  } else {
   HEAP8[i14 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i16 = HEAP32[i24 >> 2] | 0;
  i15 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i23);
 }
 i4 = i22 + 2 | 0;
 i5 = HEAP8[i17 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i18 >> 2] | 0 : i5 & 255;
 i10 = i20 + 11 | 0;
 i9 = HEAP8[i10 >> 0] | 0;
 i6 = i9 << 24 >> 24 < 0;
 i11 = i20 + 4 | 0;
 i9 = i6 ? HEAP32[i11 >> 2] | 0 : i9 & 255;
 i2 = i9 >>> 0 < i5 >>> 0 ? i9 : i5;
 if (!i2) i19 = 69; else {
  i1 = HEAP32[i20 >> 2] | 0;
  i2 = _memcmp(i3 ? HEAP32[i13 >> 2] | 0 : i12, i6 ? i1 : i20, i2) | 0;
  if (!i2) i19 = 69; else if ((i2 | 0) < 0) {
   i7 = i20;
   i8 = i20;
  } else {
   i24 = i4;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 do if ((i19 | 0) == 69) if (i5 >>> 0 < i9 >>> 0) {
  i7 = i20;
  i8 = i20;
  i1 = HEAP32[i20 >> 2] | 0;
  break;
 } else {
  i24 = i4;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i2 = i6 ? i1 : i8;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i24 + 12 >> 2] = i1;
 if (i9 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
  i1 = HEAP32[i24 + 12 >> 2] | 0;
  i19 = 75;
 } else if (i9 >>> 0 < 11) {
  HEAP8[i24 + 11 >> 0] = i9;
  if (!i9) i1 = i24; else {
   i1 = i24;
   i19 = 77;
  }
 } else i19 = 75;
 if ((i19 | 0) == 75) {
  i16 = i9 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i16 | -2147483648;
  HEAP32[i24 + 4 >> 2] = i9;
  i19 = 77;
 }
 if ((i19 | 0) == 77) _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
 HEAP8[i1 + i9 >> 0] = 0;
 do if ((i20 | 0) != (i21 | 0)) {
  i5 = HEAP8[i17 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i13 >> 2] | 0 : i12;
  i5 = i1 ? HEAP32[i18 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i10 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i20 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i19 = i2 ? HEAP32[i11 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i3, i5 - i3 | 0, i19, 0, i19, i5, i4);
   break;
  }
  i1 = i2 ? HEAP32[i7 >> 2] | 0 : i8;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i11 >> 2] = i5;
   break;
  } else {
   HEAP8[i10 >> 0] = i5;
   break;
  }
 } while (0);
 i4 = i24 + 11 | 0;
 do if ((i24 | 0) != (i21 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
  i6 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i17 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i20 = i2 ? HEAP32[i18 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i21, i3, i6 - i3 | 0, i20, 0, i20, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i13 >> 2] | 0 : i12;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i17 >> 0] | 0) < 0) {
   HEAP32[i18 >> 2] = i6;
   break;
  } else {
   HEAP8[i17 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i21 = HEAP32[i24 >> 2] | 0;
  i24 = HEAP32[i24 + 12 >> 2] | 0;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i23);
 }
 i24 = i22 + 3 | 0;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesEPKNS0_12TriangleDataEPS2_RNS3_18ImpulseAccumulatorE(i1, i5, i98, i94) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i98 = i98 | 0;
 i94 = i94 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i92 = 0, i93 = 0, i95 = 0, i96 = 0, i97 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i112 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0, i124 = 0, i125 = 0, i126 = 0, i127 = 0, i128 = 0, i129 = 0, i130 = 0, i131 = 0, i132 = 0, i133 = 0, i134 = 0, i135 = 0;
 i135 = STACKTOP;
 STACKTOP = STACKTOP + 1856 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i122 = i135 + 1824 | 0;
 i123 = i135 + 1808 | 0;
 i124 = i135 + 1792 | 0;
 i121 = i135 + 1776 | 0;
 i4 = i135 + 1760 | 0;
 i119 = i135 + 1744 | 0;
 i96 = i135 + 1728 | 0;
 i16 = i135 + 1720 | 0;
 i112 = i135 + 1704 | 0;
 i27 = i135 + 1696 | 0;
 i115 = i135 + 1680 | 0;
 i38 = i135 + 1672 | 0;
 i120 = i135 + 1656 | 0;
 i49 = i135 + 1648 | 0;
 i95 = i135 + 1632 | 0;
 i60 = i135 + 1624 | 0;
 i103 = i135 + 1608 | 0;
 i71 = i135 + 1592 | 0;
 i104 = i135 + 1576 | 0;
 i82 = i135 + 1560 | 0;
 i105 = i135 + 1544 | 0;
 i93 = i135 + 1528 | 0;
 i106 = i135 + 1512 | 0;
 i107 = i135 + 1496 | 0;
 i108 = i135 + 1480 | 0;
 i109 = i135 + 1464 | 0;
 i110 = i135 + 1448 | 0;
 i111 = i135 + 1432 | 0;
 i126 = i135 + 1416 | 0;
 i127 = i135 + 1400 | 0;
 i128 = i135 + 1384 | 0;
 i99 = i135 + 1368 | 0;
 i6 = i135 + 1352 | 0;
 i7 = i135 + 1336 | 0;
 i8 = i135 + 1320 | 0;
 i9 = i135 + 1304 | 0;
 i100 = i135 + 1288 | 0;
 i10 = i135 + 1272 | 0;
 i11 = i135 + 1256 | 0;
 i12 = i135 + 1240 | 0;
 i13 = i135 + 1224 | 0;
 i101 = i135 + 1208 | 0;
 i14 = i135 + 1192 | 0;
 i15 = i135 + 1176 | 0;
 i17 = i135 + 1160 | 0;
 i18 = i135 + 1144 | 0;
 i113 = i135 + 1128 | 0;
 i114 = i135 + 1112 | 0;
 i116 = i135 + 1096 | 0;
 i129 = i135 + 1080 | 0;
 i19 = i135 + 1064 | 0;
 i20 = i135 + 1048 | 0;
 i133 = i135 + 1032 | 0;
 i21 = i135 + 1016 | 0;
 i22 = i135 + 1e3 | 0;
 i130 = i135 + 984 | 0;
 i23 = i135 + 968 | 0;
 i24 = i135 + 1848 | 0;
 i134 = i135 + 952 | 0;
 i25 = i135 + 936 | 0;
 i26 = i135 + 1847 | 0;
 i102 = i135 + 920 | 0;
 i28 = i135 + 904 | 0;
 i29 = i135 + 888 | 0;
 i30 = i135 + 872 | 0;
 i31 = i135 + 856 | 0;
 i32 = i135 + 840 | 0;
 i33 = i135 + 824 | 0;
 i34 = i135 + 808 | 0;
 i35 = i135 + 792 | 0;
 i97 = i135 + 776 | 0;
 i36 = i135 + 760 | 0;
 i37 = i135 + 1846 | 0;
 i39 = i135 + 744 | 0;
 i125 = i135 + 728 | 0;
 i40 = i135 + 712 | 0;
 i41 = i135 + 696 | 0;
 i42 = i135 + 680 | 0;
 i43 = i135 + 664 | 0;
 i44 = i135 + 648 | 0;
 i45 = i135 + 632 | 0;
 i46 = i135 + 616 | 0;
 i47 = i135 + 1845 | 0;
 i48 = i135 + 600 | 0;
 i50 = i135 + 584 | 0;
 i51 = i135 + 1844 | 0;
 i52 = i135 + 568 | 0;
 i53 = i135 + 552 | 0;
 i54 = i135 + 1843 | 0;
 i55 = i135 + 536 | 0;
 i56 = i135 + 520 | 0;
 i57 = i135 + 504 | 0;
 i58 = i135 + 1842 | 0;
 i59 = i135 + 488 | 0;
 i61 = i135 + 472 | 0;
 i62 = i135 + 456 | 0;
 i63 = i135 + 440 | 0;
 i64 = i135 + 424 | 0;
 i65 = i135 + 408 | 0;
 i66 = i135 + 392 | 0;
 i67 = i135 + 376 | 0;
 i68 = i135 + 360 | 0;
 i69 = i135 + 344 | 0;
 i70 = i135 + 328 | 0;
 i72 = i135 + 312 | 0;
 i132 = i135 + 296 | 0;
 i73 = i135 + 280 | 0;
 i74 = i135 + 264 | 0;
 i75 = i135 + 248 | 0;
 i76 = i135 + 232 | 0;
 i131 = i135 + 216 | 0;
 i77 = i135 + 200 | 0;
 i78 = i135 + 184 | 0;
 i79 = i135 + 1841 | 0;
 i80 = i135 + 168 | 0;
 i81 = i135 + 164 | 0;
 i83 = i135 + 160 | 0;
 i84 = i135 + 144 | 0;
 i85 = i135 + 128 | 0;
 i117 = i135 + 112 | 0;
 i86 = i135 + 96 | 0;
 i87 = i135 + 80 | 0;
 i88 = i135 + 64 | 0;
 i89 = i135 + 48 | 0;
 i90 = i135 + 32 | 0;
 i118 = i135 + 16 | 0;
 i91 = i135;
 i92 = i135 + 1840 | 0;
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i4, i135 + 1849 | 0);
 __ZN8Scalar4faSERKS_(i122, __ZN8Scalar4faSERKS_(i123, __ZN8Scalar4faSERKS_(i124, __ZN8Scalar4faSERKS_(i121, i4) | 0) | 0) | 0) | 0;
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i119, gb + 1097840 | 0);
 i4 = HEAP32[(HEAP32[i1 + 432 >> 2] | 0) + 192 >> 2] | 0;
 i3 = i5 + (i4 * 80 | 0) | 0;
 if (i4 | 0) {
  i4 = i98 + 16 | 0;
  i2 = i98 + 32 | 0;
  i1 = i5;
  do {
   HEAP32[i16 >> 2] = __Z11loadAlignedPKf(i1) | 0;
   __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i96, i16);
   HEAP32[i27 >> 2] = __Z11loadAlignedPKf(i1 + 16 | 0) | 0;
   __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i112, i27);
   HEAP32[i38 >> 2] = __Z11loadAlignedPKf(i1 + 32 | 0) | 0;
   __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i115, i38);
   HEAP32[i49 >> 2] = __Z11loadAlignedPKf(i1 + 48 | 0) | 0;
   __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i120, i49);
   HEAP32[i60 >> 2] = __Z11loadAlignedPKf(i1 + 64 | 0) | 0;
   __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i95, i60);
   __Z5splatILj0EE8Scalar4fRKS0_(i71, i96);
   __ZmiRK8Scalar4fS1_(i103, i98, i71);
   __Z5splatILj1EE8Scalar4fRKS0_(i82, i96);
   __ZmiRK8Scalar4fS1_(i104, i4, i82);
   __Z5splatILj2EE8Scalar4fRKS0_(i93, i96);
   __ZmiRK8Scalar4fS1_(i105, i2, i93);
   __Z5splatILj0EE8Scalar4fRKS0_(i106, i112);
   __Z5splatILj1EE8Scalar4fRKS0_(i107, i112);
   __Z5splatILj2EE8Scalar4fRKS0_(i108, i112);
   __Z5splatILj0EE8Scalar4fRKS0_(i109, i115);
   __Z5splatILj1EE8Scalar4fRKS0_(i110, i115);
   __Z5splatILj2EE8Scalar4fRKS0_(i111, i115);
   __Z5splatILj0EE8Scalar4fRKS0_(i126, i120);
   __Z5splatILj1EE8Scalar4fRKS0_(i127, i120);
   __Z5splatILj2EE8Scalar4fRKS0_(i128, i120);
   __ZmlRK8Scalar4fS1_(i7, i103, i106);
   __ZmlRK8Scalar4fS1_(i8, i104, i107);
   __ZplRK8Scalar4fS1_(i6, i7, i8);
   __ZmlRK8Scalar4fS1_(i9, i105, i108);
   __ZplRK8Scalar4fS1_(i99, i6, i9);
   __ZmlRK8Scalar4fS1_(i11, i103, i109);
   __ZmlRK8Scalar4fS1_(i12, i104, i110);
   __ZplRK8Scalar4fS1_(i10, i11, i12);
   __ZmlRK8Scalar4fS1_(i13, i105, i111);
   __ZplRK8Scalar4fS1_(i100, i10, i13);
   __ZmlRK8Scalar4fS1_(i15, i103, i126);
   __ZmlRK8Scalar4fS1_(i17, i104, i127);
   __ZplRK8Scalar4fS1_(i14, i15, i17);
   __ZmlRK8Scalar4fS1_(i18, i105, i128);
   __ZplRK8Scalar4fS1_(i101, i14, i18);
   __Z5splatILj3EE8Scalar4fRKS0_(i113, i96);
   __Z5splatILj3EE8Scalar4fRKS0_(i114, i112);
   __Z5splatILj3EE8Scalar4fRKS0_(i116, i115);
   __ZmlRK8Scalar4fS1_(i19, i116, i99);
   __ZmlRK8Scalar4fS1_(i20, i113, i100);
   __ZmiRK8Scalar4fS1_(i129, i19, i20);
   __ZmlRK8Scalar4fS1_(i21, i114, i100);
   __ZmlRK8Scalar4fS1_(i22, i113, i99);
   __ZmiRK8Scalar4fS1_(i133, i21, i22);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i23, i24);
   __ZgtRK8Scalar4fS1_(i130, i129, i23);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i25, i26);
   __ZgtRK8Scalar4fS1_(i134, i133, i25);
   __Z5splatILj0EE8Scalar4fRKS0_(i102, i95);
   __ZmlRK8Scalar4fS1_(i29, i129, i102);
   __Z5splatILj2EE8Scalar4fRKS0_(i31, i95);
   __ZmlRK8Scalar4fS1_(i30, i99, i31);
   __Z6selectRK8Scalar4fS1_S1_(i28, i134, i29, i30);
   __ZN8Scalar4faSERKS_(i129, i28) | 0;
   __ZmlRK8Scalar4fS1_(i33, i133, i102);
   __Z5splatILj3EE8Scalar4fRKS0_(i35, i95);
   __ZmlRK8Scalar4fS1_(i34, i100, i35);
   __Z6selectRK8Scalar4fS1_S1_(i32, i130, i33, i34);
   __ZN8Scalar4faSERKS_(i133, i32) | 0;
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i36, i37);
   __ZplRK8Scalar4fS1_(i39, i129, i133);
   __ZltRK8Scalar4fS1_(i97, i36, i39);
   __ZmiRK8Scalar4fS1_(i41, i116, i113);
   __ZplRK8Scalar4fS1_(i40, i41, i99);
   __ZmiRK8Scalar4fS1_(i125, i40, i100);
   __Z5splatILj1EE8Scalar4fRKS0_(i44, i95);
   __ZmlRK8Scalar4fS1_(i43, i125, i44);
   __Z6selectRK8Scalar4fS1_S1_(i42, i97, i43, i129);
   __ZN8Scalar4faSERKS_(i129, i42) | 0;
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i46, i47);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i50, i51);
   __Z3minRK8Scalar4fS1_(i48, i50, i129);
   __Z3maxRK8Scalar4fS1_(i45, i46, i48);
   __ZN8Scalar4faSERKS_(i129, i45) | 0;
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i53, i54);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i57, i58);
   __ZmiRK8Scalar4fS1_(i56, i57, i129);
   __Z3minRK8Scalar4fS1_(i55, i56, i133);
   __Z3maxRK8Scalar4fS1_(i52, i53, i55);
   __ZN8Scalar4faSERKS_(i133, i52) | 0;
   __ZmlRK8Scalar4fS1_(i62, i106, i129);
   __ZmiRK8Scalar4fS1_(i61, i103, i62);
   __ZmlRK8Scalar4fS1_(i63, i109, i133);
   __ZmiRK8Scalar4fS1_(i59, i61, i63);
   __ZN8Scalar4faSERKS_(i103, i59) | 0;
   __ZmlRK8Scalar4fS1_(i66, i107, i129);
   __ZmiRK8Scalar4fS1_(i65, i104, i66);
   __ZmlRK8Scalar4fS1_(i67, i110, i133);
   __ZmiRK8Scalar4fS1_(i64, i65, i67);
   __ZN8Scalar4faSERKS_(i104, i64) | 0;
   __ZmlRK8Scalar4fS1_(i70, i108, i129);
   __ZmiRK8Scalar4fS1_(i69, i105, i70);
   __ZmlRK8Scalar4fS1_(i72, i111, i133);
   __ZmiRK8Scalar4fS1_(i68, i69, i72);
   __ZN8Scalar4faSERKS_(i105, i68) | 0;
   __ZmlRK8Scalar4fS1_(i74, i103, i103);
   __ZmlRK8Scalar4fS1_(i75, i104, i104);
   __ZplRK8Scalar4fS1_(i73, i74, i75);
   __ZmlRK8Scalar4fS1_(i76, i105, i105);
   __ZplRK8Scalar4fS1_(i132, i73, i76);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i78, i79);
   __ZgtRK8Scalar4fS1_(i77, i78, i101);
   HEAPF32[i81 >> 2] = Math_fround(.0000999999974);
   HEAP32[i83 >> 2] = __Z6simd4fRKf(i81) | 0;
   __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i80, i83);
   __ZanRK8Scalar4fS1_(i131, i77, i80);
   __ZmlRK8Scalar4fS1_(i85, i132, i131);
   __ZplRK8Scalar4fS1_(i84, i132, i85);
   __ZN8Scalar4faSERKS_(i132, i84) | 0;
   __ZltRK8Scalar4fS1_(i117, i132, i119);
   __Z6selectRK8Scalar4fS1_S1_(i86, i117, i126, i122);
   __ZN8Scalar4faSERKS_(i122, i86) | 0;
   __Z6selectRK8Scalar4fS1_S1_(i87, i117, i127, i123);
   __ZN8Scalar4faSERKS_(i123, i87) | 0;
   __Z6selectRK8Scalar4fS1_S1_(i88, i117, i128, i124);
   __ZN8Scalar4faSERKS_(i124, i88) | 0;
   __Z6selectRK8Scalar4fS1_S1_(i89, i117, i101, i121);
   __ZN8Scalar4faSERKS_(i121, i89) | 0;
   __Z3minRK8Scalar4fS1_(i90, i132, i119);
   __ZN8Scalar4faSERKS_(i119, i90) | 0;
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i91, i92);
 if (!(__Z10anyGreaterRK8Scalar4fS1_RS_(i91, i121, i118) | 0)) {
  STACKTOP = i135;
  return;
 }
 __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_(i94, i122, i123, i124, i121, i118);
 STACKTOP = i135;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator21outputExternalPortalsERNS_7ExtTileEiiPKNS0_6ResultERKNS_5ArrayIjEEi(i39, i36, i32, i40, i3, i8, i33) {
 i39 = i39 | 0;
 i36 = i36 | 0;
 i32 = i32 | 0;
 i40 = i40 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0;
 i37 = i39 + 76 | 0;
 i1 = HEAP32[i37 >> 2] | 0;
 if ((i1 | 0) > (i40 | 0)) i1 = (HEAP32[i39 + 68 >> 2] | 0) + (i40 << 5) + 4 | 0; else i1 = (HEAP32[i39 + 164 >> 2] | 0) + ((i40 - i1 | 0) * 40 | 0) + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i39 >> 2] | 0;
 if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
  i38 = gb + 1451688 | 0;
 } else i38 = gb + 1451688 | 0; else i38 = i1;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i38 >> 2] | 0) + 8 >> 2] | 0, i38 | 0, 528, 0) | 0;
 if (!i1) i35 = 0; else {
  HEAP32[i1 >> 2] = 32;
  i35 = i1 + 16 | 0;
  _memset(i35 | 0, 0, 512) | 0;
 }
 i5 = HEAP32[i8 + 12 >> 2] | 0;
 if (!i5) {
  i7 = -1;
  i27 = 0;
  i6 = 0;
  i24 = 0;
  i23 = 0;
 } else {
  i4 = HEAP32[(HEAP32[i39 + 248 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  i3 = (i3 | 0) == 0 ? 0 : i1 + i3 | 0;
  i2 = HEAP32[i3 + (i4 << 5) + 8 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 0 : i1 + i2 | 0;
  if ((HEAP32[i37 >> 2] | 0) > (i40 | 0)) {
   i7 = i4;
   i27 = i1;
   i6 = i3;
   i24 = i2;
   i23 = 0;
  } else {
   i7 = i4;
   i27 = i1;
   i6 = i3;
   i24 = i2;
   i23 = HEAP32[i36 + 4 >> 2] & HEAP32[i3 + (i4 << 5) + 4 >> 2];
  }
 }
 i2 = i39 + 280 | 0;
 do if (!(i5 | HEAP32[i2 >> 2])) i1 = 1; else {
  i28 = i39 + 300 | 0;
  i1 = i32 << 3;
  if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i28, i1 + 16 | 0, 65536) | 0)) {
   HEAP32[i39 + 464 >> 2] = 1;
   i1 = 0;
   break;
  }
  i1 = i1 + 15 & -16;
  i25 = i39 + 452 | 0;
  i26 = i39 + 444 | 0;
  i29 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i25 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i31 = HEAP32[i29 >> 2] | 0;
  _memset(i31 | 0, 0, i1 | 0) | 0;
  HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + i1;
  i29 = i39 + 432 | 0;
  i3 = HEAP32[i29 >> 2] | 0;
  HEAP32[i36 + 8 >> 2] = (HEAP32[i39 + 304 + (i3 << 3) + 4 >> 2] | 0) - (HEAP32[i39 + 304 + (i3 << 3) >> 2] | 0);
  i3 = i39 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i39 >> 2] | 0;
  if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
   i30 = gb + 1451688 | 0;
  } else i30 = gb + 1451688 | 0; else i30 = i1;
  if ((i3 | 0) > 0) {
   i1 = i3 << 4;
   i2 = mftCall_iiii(HEAP32[(HEAP32[i30 >> 2] | 0) + 8 >> 2] | 0, i30 | 0, i1 + 16 | 0, 0) | 0;
   if (!i2) {
    i2 = 0;
    i3 = 0;
   } else {
    HEAP32[i2 >> 2] = i3;
    i2 = i2 + 16 | 0;
    _memset(i2 | 0, 0, i1 | 0) | 0;
   }
  } else {
   i2 = 0;
   i3 = 0;
  }
  L29 : do if ((i32 | 0) > 0) {
   i18 = (i24 | 0) == 0;
   i19 = i39 + 288 | 0;
   i20 = i39 + 272 | 0;
   i21 = (i33 | 0) != 0;
   i22 = i39 + 68 | 0;
   i17 = i6 + (i7 << 5) + 12 | 0;
   i15 = i8 + 4 | 0;
   i16 = i39 + 232 | 0;
   i14 = 0;
   i13 = 0;
   L31 : while (1) {
    do if (i18) i1 = i13; else {
     if (i21 & (HEAP32[i37 >> 2] | 0) > (i40 | 0)) {
      i12 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i40 << 5) >> 2] | 0;
      i12 = i12 + (HEAP32[i12 + 56 >> 2] | 0) | 0;
      i10 = HEAP32[i12 + (i14 * 36 | 0) + 24 >> 2] | 0;
      i11 = HEAP32[i12 + (i14 * 36 | 0) + 28 >> 2] | 0;
      i12 = HEAP32[i12 + (i14 * 36 | 0) + 32 >> 2] | 0;
      if (!(((i10 & 65535) + -1 >> 31 & 4 | ((i10 >>> 16) + -1 | 0) >>> 31 | (i11 >>> 16) + -1 >> 31 & 16 | 65534 - (i11 & 65535) >> 31 & 2 | 65534 - (i12 >>> 16) >> 31 & 8 | 65534 - (i12 & 65535) >> 31 & 32) & i33)) {
       i1 = i13;
       break;
      }
     }
     i8 = (HEAP32[i24 + (i14 << 3) >> 2] << 4) + (HEAP32[i17 >> 2] | 0) | 0;
     i10 = i24 + (i14 << 3) + 4 | 0;
     i6 = (i8 | 0) == 0;
     i8 = i27 + i8 | 0;
     i1 = HEAP32[i10 >> 2] | 0;
     i11 = i1 + i13 | 0;
     if ((i3 | 0) < (i11 | 0)) {
      i5 = i11 << 1;
      i5 = (i5 | 0) > 16 ? i5 : 16;
      i3 = i5 << 4;
      i1 = mftCall_iiii(HEAP32[(HEAP32[i30 >> 2] | 0) + 8 >> 2] | 0, i30 | 0, i3 | 16 | 0, 0) | 0;
      if (!i1) break L31;
      HEAP32[i1 >> 2] = i5;
      i4 = i1 + 16 | 0;
      _memset(i4 | 0, 0, i3 | 0) | 0;
      if (i2 | 0) {
       do if (i13 | 0) {
        i3 = (i13 | 0) <= (i11 | 0) ? i13 : i11;
        if ((i3 | 0) > 0) i1 = 0; else break;
        do {
         i12 = i4 + (i1 << 4) | 0;
         i9 = i2 + (i1 << 4) | 0;
         HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
         HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
         HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
         HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != (i3 | 0));
       } while (0);
       mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i2 + -16 | 0);
      }
      i2 = i4;
      i9 = i5;
      i1 = HEAP32[i10 >> 2] | 0;
     } else i9 = i3;
     if ((i1 | 0) > 0) {
      i7 = 0;
      i3 = i2 + (i13 << 4) | 0;
      i1 = i13;
      i4 = i6 ? 0 : i8;
      do {
       i5 = HEAP32[i4 >> 2] | 0;
       do if (!(i5 & 268435456)) {
        i6 = i5 & 67108863;
        if (HEAP32[(HEAP32[i15 >> 2] | 0) + (i6 >>> 5 << 2) >> 2] & 1 << (i5 & 31)) {
         HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
         HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -67108864 | HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 << 2) >> 2];
         i3 = i3 + 16 | 0;
         i1 = i1 + 1 | 0;
        }
        i4 = i4 + 16 | 0;
       } else {
        if (!(1 << (i5 >>> 29) & i23)) break;
        HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
        i3 = i3 + 16 | 0;
        i1 = i1 + 1 | 0;
        i4 = i4 + 16 | 0;
       } while (0);
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) < (HEAP32[i10 >> 2] | 0));
     } else i1 = i13;
     if ((i9 | 0) < (i1 | 0)) {
      i3 = i1 << 1;
      i3 = (i3 | 0) > 16 ? i3 : 16;
      i5 = i3 << 4;
      i4 = mftCall_iiii(HEAP32[(HEAP32[i30 >> 2] | 0) + 8 >> 2] | 0, i30 | 0, i5 | 16 | 0, 0) | 0;
      if (!i4) {
       i3 = i9;
       i1 = i11;
      } else {
       HEAP32[i4 >> 2] = i3;
       i6 = i4 + 16 | 0;
       _memset(i6 | 0, 0, i5 | 0) | 0;
       if (!i2) i2 = i6; else {
        do if (i11 | 0) {
         i5 = (i11 | 0) <= (i1 | 0) ? i11 : i1;
         if ((i5 | 0) > 0) i4 = 0; else break;
         do {
          i12 = i6 + (i4 << 4) | 0;
          i11 = i2 + (i4 << 4) | 0;
          HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
          HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
          HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
          HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i5 | 0));
        } while (0);
        mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i2 + -16 | 0);
        i2 = i6;
       }
      }
     } else i3 = i9;
    } while (0);
    i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i14 << 2) >> 2] | 0;
    if (i4) {
     i5 = HEAP32[i20 >> 2] | 0;
     do {
      i12 = i4 + -1 | 0;
      i8 = HEAP32[i5 + (i12 * 28 | 0) >> 2] | 0;
      i9 = HEAP32[i5 + (i12 * 28 | 0) + 4 >> 2] | 0;
      i10 = HEAP32[i5 + (i12 * 28 | 0) + 16 >> 2] | HEAP32[i5 + (i12 * 28 | 0) + 8 >> 2] << 16;
      i7 = HEAP32[i5 + (i12 * 28 | 0) + 20 >> 2] | HEAP32[i5 + (i12 * 28 | 0) + 12 >> 2] << 16;
      i11 = i1 + 1 | 0;
      if ((i3 | 0) > (i1 | 0)) i34 = 58; else {
       i6 = i11 << 1;
       i6 = (i6 | 0) > 16 ? i6 : 16;
       i5 = i6 << 4;
       i4 = mftCall_iiii(HEAP32[(HEAP32[i30 >> 2] | 0) + 8 >> 2] | 0, i30 | 0, i5 | 16 | 0, 0) | 0;
       if (i4) {
        HEAP32[i4 >> 2] = i6;
        i4 = i4 + 16 | 0;
        _memset(i4 | 0, 0, i5 | 0) | 0;
        if (!i2) {
         i2 = i4;
         i3 = i6;
         i34 = 58;
        } else {
         if ((i1 | 0) > 0) {
          i3 = 0;
          do {
           i34 = i4 + (i3 << 4) | 0;
           i5 = i2 + (i3 << 4) | 0;
           HEAP32[i34 >> 2] = HEAP32[i5 >> 2];
           HEAP32[i34 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
           HEAP32[i34 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
           HEAP32[i34 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
           i3 = i3 + 1 | 0;
          } while ((i3 | 0) != (i1 | 0));
         }
         mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i2 + -16 | 0);
         i2 = i4;
         i3 = i6;
         i34 = 58;
        }
       }
      }
      if ((i34 | 0) == 58) {
       i34 = 0;
       HEAP32[i2 + (i1 << 4) >> 2] = i8;
       HEAP32[i2 + (i1 << 4) + 4 >> 2] = i9;
       HEAP32[i2 + (i1 << 4) + 8 >> 2] = i10;
       HEAP32[i2 + (i1 << 4) + 12 >> 2] = i7;
       i1 = i11;
      }
      i5 = HEAP32[i20 >> 2] | 0;
      i4 = HEAP32[i5 + (i12 * 28 | 0) + 24 >> 2] | 0;
     } while ((i4 | 0) != 0);
    }
    HEAP32[i31 + (i14 << 3) >> 2] = i13;
    HEAP32[i31 + (i14 << 3) + 4 >> 2] = i1 - i13;
    i14 = i14 + 1 | 0;
    if ((i14 | 0) >= (i32 | 0)) {
     i34 = 62;
     break L29;
    } else i13 = i1;
   }
   HEAP32[i39 + 464 >> 2] = 1;
   i1 = 0;
  } else {
   i1 = 0;
   i34 = 62;
  } while (0);
  do if ((i34 | 0) == 62) {
   i4 = i39 + 436 | 0;
   HEAP8[i4 >> 0] = 0;
   i1 = i1 << 4;
   if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i28, i1 + 16 | 0, 65536) | 0)) {
    HEAP32[i39 + 464 >> 2] = 1;
    i1 = 0;
    break;
   }
   i34 = (HEAP32[i26 >> 2] | 0) + (((HEAP32[i25 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
   i3 = HEAP32[i34 >> 2] | 0;
   _memset(i3 | 0, 0, i1 | 0) | 0;
   HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1;
   i34 = HEAP32[i29 >> 2] | 0;
   HEAP32[i36 + 12 >> 2] = (HEAP32[i39 + 304 + (i34 << 3) + 4 >> 2] | 0) - (HEAP32[i39 + 304 + (i34 << 3) >> 2] | 0);
   i36 = i39 + 304 + (HEAP32[i29 >> 2] << 3) + 4 | 0;
   HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + i1;
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP8[i4 >> 0] = 0;
   i1 = HEAP32[i37 >> 2] | 0;
   if ((i1 | 0) > (i40 | 0)) {
    i1 = HEAP32[i39 + 68 >> 2] | 0;
    HEAP32[i1 + (i40 << 5) + 24 >> 2] = i31;
    HEAP32[i1 + (i40 << 5) + 28 >> 2] = i3;
    i1 = 1;
    break;
   } else {
    i1 = i40 - i1 | 0;
    i40 = HEAP32[i39 + 164 >> 2] | 0;
    HEAP32[i40 + (i1 * 40 | 0) + 32 >> 2] = i31;
    HEAP32[i40 + (i1 * 40 | 0) + 36 >> 2] = i3;
    i1 = 1;
    break;
   }
  } while (0);
  if (i2) mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i2 + -16 | 0);
 } while (0);
 if (!i35) return i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i38 >> 2] | 0) + 12 >> 2] | 0, i38 | 0, i35 + -16 | 0);
 return i1 | 0;
}

function __ZN5physx2Gu11gjkRelativeINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE(i40, i42, i41, i57, i58, i59, i60) {
 i40 = i40 | 0;
 i42 = i42 | 0;
 i41 = i41 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 i60 = i60 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i61 + 320 | 0;
 i43 = i61 + 304 | 0;
 i56 = i61 + 240 | 0;
 i54 = i61 + 176 | 0;
 i55 = i61 + 112 | 0;
 i14 = i61 + 96 | 0;
 i53 = i61 + 372 | 0;
 i47 = i61 + 80 | 0;
 i50 = i61 + 64 | 0;
 i51 = i61 + 48 | 0;
 i48 = i61 + 360 | 0;
 i52 = i61 + 32 | 0;
 i44 = i61 + 16 | 0;
 i11 = i61;
 i4 = i61 + 348 | 0;
 i49 = i61 + 336 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i53 >> 2] = 0;
 i12 = i41 + 48 | 0;
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 i18 = i41 + 52 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 i38 = i41 + 56 | 0;
 f9 = Math_fround(HEAPF32[i38 >> 2]);
 i45 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9)) > Math_fround(0.0);
 f7 = i45 ? f7 : Math_fround(1.0);
 f8 = i45 ? f8 : Math_fround(0.0);
 f9 = i45 ? f9 : Math_fround(0.0);
 HEAPF32[i47 >> 2] = f7;
 i45 = i47 + 4 | 0;
 HEAPF32[i45 >> 2] = f8;
 i46 = i47 + 8 | 0;
 HEAPF32[i46 >> 2] = f9;
 HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
 f13 = Math_fround(HEAPF32[i40 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i42 + 32 >> 2]);
 f13 = Math_fround((f13 > f2 ? f2 : f13) * Math_fround(.100000001));
 f13 = Math_fround(f13 * f13);
 HEAP32[i50 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i52 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 HEAP32[i52 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
 i14 = i41 + 4 | 0;
 i15 = i41 + 8 | 0;
 i16 = i41 + 16 | 0;
 i17 = i41 + 20 | 0;
 i19 = i41 + 24 | 0;
 i20 = i41 + 32 | 0;
 i21 = i41 + 36 | 0;
 i22 = i41 + 40 | 0;
 i23 = i39 + 4 | 0;
 i24 = i39 + 8 | 0;
 i25 = i39 + 12 | 0;
 i26 = i43 + 4 | 0;
 i27 = i43 + 8 | 0;
 i28 = i44 + 4 | 0;
 i29 = i44 + 8 | 0;
 i30 = i11 + 4 | 0;
 i31 = i11 + 8 | 0;
 i32 = i11 + 12 | 0;
 i33 = i56 + 4 | 0;
 i34 = i56 + 8 | 0;
 i35 = i56 + 16 | 0;
 i36 = i56 + 20 | 0;
 i37 = i56 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  HEAP32[i52 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  f3 = Math_fround(-f7);
  f66 = Math_fround(-f8);
  f10 = Math_fround(-f9);
  f5 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f3);
  f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f66));
  f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f10));
  f6 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f3);
  f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f66));
  f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f10));
  f3 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f3);
  f66 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f66));
  f10 = Math_fround(f66 + Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f10));
  HEAPF32[i39 >> 2] = f5;
  HEAPF32[i23 >> 2] = f6;
  HEAPF32[i24 >> 2] = f10;
  HEAPF32[i25 >> 2] = Math_fround(0.0);
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i43, i40, i39);
  f10 = Math_fround(HEAPF32[i12 >> 2]);
  f6 = Math_fround(HEAPF32[i18 >> 2]);
  f5 = Math_fround(HEAPF32[i38 >> 2]);
  f66 = Math_fround(HEAPF32[i43 >> 2]);
  f3 = Math_fround(HEAPF32[i26 >> 2]);
  f63 = Math_fround(HEAPF32[i27 >> 2]);
  f65 = Math_fround(f66 * Math_fround(HEAPF32[i41 >> 2]));
  f65 = Math_fround(f65 + Math_fround(f3 * Math_fround(HEAPF32[i16 >> 2])));
  f65 = Math_fround(f65 + Math_fround(f63 * Math_fround(HEAPF32[i20 >> 2])));
  f64 = Math_fround(f66 * Math_fround(HEAPF32[i14 >> 2]));
  f64 = Math_fround(f64 + Math_fround(f3 * Math_fround(HEAPF32[i17 >> 2])));
  f64 = Math_fround(f64 + Math_fround(f63 * Math_fround(HEAPF32[i21 >> 2])));
  f66 = Math_fround(f66 * Math_fround(HEAPF32[i15 >> 2]));
  f3 = Math_fround(f66 + Math_fround(f3 * Math_fround(HEAPF32[i19 >> 2])));
  f65 = Math_fround(f10 + f65);
  f64 = Math_fround(f6 + f64);
  f63 = Math_fround(f5 + Math_fround(f3 + Math_fround(f63 * Math_fround(HEAPF32[i22 >> 2]))));
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i44, i42, i47);
  f3 = Math_fround(HEAPF32[i44 >> 2]);
  f5 = Math_fround(HEAPF32[i28 >> 2]);
  f3 = Math_fround(f65 - f3);
  f5 = Math_fround(f64 - f5);
  f6 = Math_fround(f63 - Math_fround(HEAPF32[i29 >> 2]));
  f10 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f3 * f7) + Math_fround(f5 * f8)) + Math_fround(f6 * f9)));
  i1 = HEAP32[i53 >> 2] | 0;
  HEAPF32[i54 + (i1 << 4) >> 2] = f65;
  HEAPF32[i54 + (i1 << 4) + 4 >> 2] = f64;
  HEAPF32[i54 + (i1 << 4) + 8 >> 2] = f63;
  HEAPF32[i54 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i62 = i55 + (i1 << 4) | 0;
  HEAP32[i62 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i62 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  HEAPF32[i56 + (i1 << 4) >> 2] = f3;
  HEAPF32[i56 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i56 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i56 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f10) {
   i4 = 3;
   break;
  }
  HEAP32[i53 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i11 >> 2] = f3;
    HEAPF32[i30 >> 2] = f5;
    HEAPF32[i31 >> 2] = f6;
    HEAPF32[i32 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i56 >> 2]);
    f5 = Math_fround(HEAPF32[i33 >> 2]);
    f6 = Math_fround(HEAPF32[i34 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i36 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f64 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i62 = f64 > Math_fround(1.0);
     f64 = i62 ? Math_fround(1.0) : f64;
     i62 = f64 > Math_fround(0.0);
     f64 = i62 ? f64 : Math_fround(0.0);
     f65 = Math_fround(f5 + Math_fround(f8 * f64));
     f66 = Math_fround(f6 + Math_fround(f9 * f64));
     HEAPF32[i11 >> 2] = Math_fround(f3 + Math_fround(f7 * f64));
     HEAPF32[i30 >> 2] = f65;
     HEAPF32[i31 >> 2] = f66;
     HEAPF32[i32 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i53 >> 2] = 1;
     HEAP32[i11 >> 2] = HEAP32[i56 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i56 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i11, i56, i54, i55, i53);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i11, i56, i54, i55, i53);
    break;
   }
  default:
   {
    HEAPF32[i11 >> 2] = f3;
    HEAPF32[i30 >> 2] = f5;
    HEAPF32[i31 >> 2] = f6;
    HEAPF32[i32 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i47 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i47 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i47 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i47 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  f7 = Math_fround(HEAPF32[i47 >> 2]);
  f8 = Math_fround(HEAPF32[i45 >> 2]);
  f9 = Math_fround(HEAPF32[i46 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
  HEAP32[i48 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f13 & i1)) {
   i4 = 13;
   break;
  } else f2 = f3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i47, i57, i58, i1);
  f64 = Math_fround(HEAPF32[i47 >> 2]);
  f65 = Math_fround(HEAPF32[i45 >> 2]);
  f63 = Math_fround(HEAPF32[i46 >> 2]);
  f66 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f64 * f64) + Math_fround(f65 * f65)) + Math_fround(f63 * f63)))));
  f64 = Math_fround(-Math_fround(f64 * f66));
  f65 = Math_fround(-Math_fround(f65 * f66));
  f66 = Math_fround(-Math_fround(f63 * f66));
  HEAPF32[i60 >> 2] = f2;
  i62 = i60 + 4 | 0;
  HEAP32[i62 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAPF32[i59 >> 2] = f64;
  HEAPF32[i59 + 4 >> 2] = f65;
  HEAPF32[i59 + 8 >> 2] = f66;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  i62 = 0;
  STACKTOP = i61;
  return i62 | 0;
 } else if ((i4 | 0) == 13) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i56, i54, i55, i52, i57, i58, HEAP32[i53 >> 2] | 0);
  HEAP32[i57 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i57 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  HEAP32[i58 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i58 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  f63 = Math_fround(HEAPF32[i52 >> 2]);
  f65 = Math_fround(HEAPF32[i52 + 4 >> 2]);
  f66 = Math_fround(HEAPF32[i52 + 8 >> 2]);
  f64 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f63 * f63) + Math_fround(f65 * f65)) + Math_fround(f66 * f66)))));
  f65 = Math_fround(-Math_fround(f65 * f64));
  f66 = Math_fround(-Math_fround(f66 * f64));
  HEAPF32[i59 >> 2] = Math_fround(-Math_fround(f63 * f64));
  HEAPF32[i59 + 4 >> 2] = f65;
  HEAPF32[i59 + 8 >> 2] = f66;
  HEAPF32[i59 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i60 >> 2] = i1 ? f3 : f2;
  i62 = i60 + 4 | 0;
  HEAP32[i62 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i62 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i62 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  i62 = i1 ? 1 : 3;
  STACKTOP = i61;
  return i62 | 0;
 }
 return 0;
}

function __ZN5physx2Gu11gjkRelativeINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE(i1, i4, i40, i53, i54, i55, i56) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i40 = i40 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i57 = 0, f58 = f0, f59 = f0, f60 = f0, i61 = 0, i62 = 0, i63 = 0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i57 + 224 | 0;
 i50 = i57 + 160 | 0;
 i51 = i57 + 96 | 0;
 i28 = i57 + 80 | 0;
 i49 = i57 + 324 | 0;
 i43 = i57 + 64 | 0;
 i46 = i57 + 48 | 0;
 i47 = i57 + 32 | 0;
 i44 = i57 + 312 | 0;
 i48 = i57 + 16 | 0;
 i25 = i57;
 i24 = i57 + 300 | 0;
 i45 = i57 + 288 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i49 >> 2] = 0;
 i26 = i40 + 48 | 0;
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 i32 = i40 + 52 | 0;
 f9 = Math_fround(HEAPF32[i32 >> 2]);
 i39 = i40 + 56 | 0;
 f10 = Math_fround(HEAPF32[i39 >> 2]);
 i41 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i41 ? f8 : Math_fround(1.0);
 f11 = i41 ? f9 : Math_fround(0.0);
 f7 = i41 ? f10 : Math_fround(0.0);
 HEAPF32[i43 >> 2] = f12;
 i41 = i43 + 4 | 0;
 HEAPF32[i41 >> 2] = f11;
 i42 = i43 + 8 | 0;
 HEAPF32[i42 >> 2] = f7;
 HEAPF32[i43 + 12 >> 2] = Math_fround(0.0);
 f27 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f27 = Math_fround((f27 > f2 ? f2 : f27) * Math_fround(.100000001));
 f27 = Math_fround(f27 * f27);
 HEAP32[i46 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i47 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i48 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
 i28 = i40 + 4 | 0;
 i29 = i40 + 8 | 0;
 i30 = i40 + 16 | 0;
 i31 = i40 + 20 | 0;
 i33 = i40 + 24 | 0;
 i34 = i40 + 32 | 0;
 i35 = i40 + 36 | 0;
 i36 = i40 + 40 | 0;
 i37 = i1 + 144 | 0;
 i38 = i1 + 148 | 0;
 i21 = i1 + 152 | 0;
 i22 = i4 + 144 | 0;
 i23 = i4 + 148 | 0;
 i4 = i4 + 152 | 0;
 i13 = i25 + 4 | 0;
 i14 = i25 + 8 | 0;
 i15 = i25 + 12 | 0;
 i16 = i52 + 4 | 0;
 i17 = i52 + 8 | 0;
 i18 = i52 + 16 | 0;
 i19 = i52 + 20 | 0;
 i20 = i52 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 i1 = 0;
 while (1) {
  HEAP32[i48 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
  f6 = Math_fround(-f12);
  f71 = Math_fround(-f11);
  f72 = Math_fround(-f7);
  f69 = Math_fround(HEAPF32[i40 >> 2]);
  f64 = Math_fround(f69 * f6);
  f67 = Math_fround(HEAPF32[i28 >> 2]);
  f64 = Math_fround(f64 + Math_fround(f67 * f71));
  f65 = Math_fround(HEAPF32[i29 >> 2]);
  f64 = Math_fround(f64 + Math_fround(f65 * f72));
  f68 = Math_fround(HEAPF32[i30 >> 2]);
  f70 = Math_fround(f68 * f6);
  f66 = Math_fround(HEAPF32[i31 >> 2]);
  f70 = Math_fround(f70 + Math_fround(f66 * f71));
  f3 = Math_fround(HEAPF32[i33 >> 2]);
  f70 = Math_fround(f70 + Math_fround(f3 * f72));
  f60 = Math_fround(HEAPF32[i34 >> 2]);
  f6 = Math_fround(f60 * f6);
  f59 = Math_fround(HEAPF32[i35 >> 2]);
  f71 = Math_fround(f6 + Math_fround(f59 * f71));
  f6 = Math_fround(HEAPF32[i36 >> 2]);
  i61 = f64 > Math_fround(0.0);
  i62 = f70 > Math_fround(0.0);
  i63 = Math_fround(f71 + Math_fround(f6 * f72)) > Math_fround(0.0);
  f72 = Math_fround(HEAPF32[i37 >> 2]);
  f71 = Math_fround(HEAPF32[i38 >> 2]);
  f70 = Math_fround(HEAPF32[i21 >> 2]);
  f64 = Math_fround(-f72);
  f5 = Math_fround(-f71);
  f58 = Math_fround(-f70);
  f64 = i61 ? f72 : f64;
  f5 = i62 ? f71 : f5;
  f58 = i63 ? f70 : f58;
  f60 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f69 * f64) + Math_fround(f68 * f5)) + Math_fround(f60 * f58)));
  f59 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f67 * f64) + Math_fround(f66 * f5)) + Math_fround(f59 * f58)));
  f58 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f65 * f64) + Math_fround(f3 * f5)) + Math_fround(f6 * f58)));
  i63 = f12 > Math_fround(0.0);
  i62 = f11 > Math_fround(0.0);
  i61 = f7 > Math_fround(0.0);
  f6 = Math_fround(HEAPF32[i22 >> 2]);
  f5 = Math_fround(HEAPF32[i23 >> 2]);
  f3 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(-f6);
  f9 = Math_fround(-f5);
  f10 = Math_fround(-f3);
  f8 = i63 ? f6 : f8;
  f9 = i62 ? f5 : f9;
  f10 = i61 ? f3 : f10;
  f3 = Math_fround(f60 - f8);
  f5 = Math_fround(f59 - f9);
  f6 = Math_fround(f58 - f10);
  f12 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f12 * f3) + Math_fround(f11 * f5)) + Math_fround(f7 * f6)));
  HEAPF32[i50 + (i1 << 4) >> 2] = f60;
  HEAPF32[i50 + (i1 << 4) + 4 >> 2] = f59;
  HEAPF32[i50 + (i1 << 4) + 8 >> 2] = f58;
  HEAPF32[i50 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i51 + (i1 << 4) >> 2] = f8;
  HEAPF32[i51 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i51 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i51 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = HEAP32[i49 >> 2] | 0;
  HEAPF32[i52 + (i1 << 4) >> 2] = f3;
  HEAPF32[i52 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i52 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i52 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i49 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i52 >> 2]);
    f5 = Math_fround(HEAPF32[i16 >> 2]);
    f6 = Math_fround(HEAPF32[i17 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f70 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i63 = f70 > Math_fround(1.0);
     f70 = i63 ? Math_fround(1.0) : f70;
     i63 = f70 > Math_fround(0.0);
     f70 = i63 ? f70 : Math_fround(0.0);
     f71 = Math_fround(f5 + Math_fround(f8 * f70));
     f72 = Math_fround(f6 + Math_fround(f9 * f70));
     HEAPF32[i25 >> 2] = Math_fround(f3 + Math_fround(f7 * f70));
     HEAPF32[i13 >> 2] = f71;
     HEAPF32[i14 >> 2] = f72;
     HEAPF32[i15 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i49 >> 2] = 1;
     HEAP32[i25 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i52, i50, i51, i49);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i25, i52, i50, i51, i49);
    break;
   }
  default:
   {
    HEAPF32[i25 >> 2] = f3;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i14 >> 2] = f6;
    HEAPF32[i15 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i43 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i43 >> 2]);
  f6 = Math_fround(HEAPF32[i41 >> 2]);
  f7 = Math_fround(HEAPF32[i42 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i44 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f27 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i26 >> 2]);
  f9 = Math_fround(HEAPF32[i32 >> 2]);
  f10 = Math_fround(HEAPF32[i39 >> 2]);
  f2 = f3;
  i1 = HEAP32[i49 >> 2] | 0;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i52, i50, i51, i43, i53, i54, i1);
  f70 = Math_fround(HEAPF32[i43 >> 2]);
  f71 = Math_fround(HEAPF32[i41 >> 2]);
  f69 = Math_fround(HEAPF32[i42 >> 2]);
  f72 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f70 * f70) + Math_fround(f71 * f71)) + Math_fround(f69 * f69)))));
  f70 = Math_fround(-Math_fround(f70 * f72));
  f71 = Math_fround(-Math_fround(f71 * f72));
  f72 = Math_fround(-Math_fround(f69 * f72));
  HEAPF32[i56 >> 2] = f2;
  i63 = i56 + 4 | 0;
  HEAP32[i63 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAPF32[i55 >> 2] = f70;
  HEAPF32[i55 + 4 >> 2] = f71;
  HEAPF32[i55 + 8 >> 2] = f72;
  HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
  i63 = 0;
  STACKTOP = i57;
  return i63 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i52, i50, i51, i48, i53, i54, HEAP32[i49 >> 2] | 0);
  HEAP32[i53 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  HEAP32[i53 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
  HEAP32[i54 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  f69 = Math_fround(HEAPF32[i48 >> 2]);
  f71 = Math_fround(HEAPF32[i48 + 4 >> 2]);
  f72 = Math_fround(HEAPF32[i48 + 8 >> 2]);
  f70 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f69 * f69) + Math_fround(f71 * f71)) + Math_fround(f72 * f72)))));
  f71 = Math_fround(-Math_fround(f71 * f70));
  f72 = Math_fround(-Math_fround(f72 * f70));
  HEAPF32[i55 >> 2] = Math_fround(-Math_fround(f69 * f70));
  HEAPF32[i55 + 4 >> 2] = f71;
  HEAPF32[i55 + 8 >> 2] = f72;
  HEAPF32[i55 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i56 >> 2] = i1 ? f3 : f2;
  i63 = i56 + 4 | 0;
  HEAP32[i63 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  i63 = i1 ? 1 : 3;
  STACKTOP = i57;
  return i63 | 0;
 }
 return 0;
}

function __ZN11NoiseModule15PreviewNoiseJobILi3EEEvP19PreviewNoiseJobData(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, i60 = 0, i61 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i58 + 288 | 0;
 i38 = i58 + 284 | 0;
 i40 = i58 + 280 | 0;
 i42 = i58 + 112 | 0;
 i43 = i58 + 64 | 0;
 i49 = i58 + 32 | 0;
 i56 = i58 + 16 | 0;
 i57 = i58;
 if ((HEAP16[gb + 1452304 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i26 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452304 | 0, i26);
  i28 = gb + 1452304 | 0;
 } else i28 = 0;
 i39 = HEAP32[i1 >> 2] | 0;
 f44 = Math_fround(_fmaxf(Math_fround(HEAPF32[i39 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i26 >> 2] = f44;
 HEAP32[i38 >> 2] = HEAP32[i39 + 816 >> 2];
 HEAP32[i40 >> 2] = HEAP32[i39 + 812 >> 2];
 f2 = Math_fround(HEAPF32[i39 + 1088 >> 2]);
 i41 = i1 + 8 | 0;
 i3 = HEAP32[i41 >> 2] | 0;
 f45 = Math_fround(i3 >>> 0);
 f46 = Math_fround((HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 HEAPF32[i42 + 4 >> 2] = Math_fround(inf);
 HEAP32[i42 >> 2] = 0;
 i47 = i42 + 8 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAPF32[i42 + 32 >> 2] = Math_fround(inf);
 HEAP32[i42 + 28 >> 2] = 0;
 i47 = i42 + 36 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAPF32[i42 + 60 >> 2] = Math_fround(inf);
 HEAP32[i42 + 56 >> 2] = 0;
 i47 = i42 + 64 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAPF32[i42 + 88 >> 2] = Math_fround(inf);
 HEAP32[i42 + 84 >> 2] = 0;
 i47 = i42 + 92 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAPF32[i42 + 116 >> 2] = Math_fround(inf);
 HEAP32[i42 + 112 >> 2] = 0;
 i47 = i42 + 120 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 HEAPF32[i42 + 144 >> 2] = Math_fround(inf);
 HEAP32[i42 + 140 >> 2] = 0;
 i47 = i42 + 148 | 0;
 HEAP32[i47 >> 2] = 0;
 HEAP32[i47 + 4 >> 2] = 0;
 HEAP32[i47 + 8 >> 2] = 0;
 HEAP32[i47 + 12 >> 2] = 0;
 HEAP32[i47 + 16 >> 2] = 0;
 f44 = Math_fround(Math_fround(1.0) / f44);
 f45 = Math_fround(Math_fround(1.0) / f45);
 f46 = Math_fround(Math_fround(1.0) / f46);
 i47 = i1 + 4 | 0;
 i4 = HEAP32[i47 >> 2] | 0;
 if (i4 >>> 0 < 4294967284) {
  i48 = i39 + 804 | 0;
  i30 = i43 + 4 | 0;
  i33 = i43 + 8 | 0;
  i36 = i43 + 12 | 0;
  i50 = i43 + 16 | 0;
  i31 = i43 + 20 | 0;
  i34 = i43 + 24 | 0;
  i37 = i43 + 28 | 0;
  i27 = i43 + 32 | 0;
  i29 = i43 + 36 | 0;
  i32 = i43 + 40 | 0;
  i35 = i43 + 44 | 0;
  i51 = i39 + 808 | 0;
  i52 = i49 + 4 | 0;
  i53 = i49 + 8 | 0;
  i54 = i49 + 12 | 0;
  i55 = i39 + 1884 | 0;
  i19 = i1 + 16 | 0;
  i20 = i57 + 12 | 0;
  i21 = i57 + 8 | 0;
  i22 = i57 + 4 | 0;
  i23 = i56 + 4 | 0;
  i24 = i56 + 8 | 0;
  i25 = i56 + 12 | 0;
  f15 = Math_fround(Math_fround(f2 + Math_fround(0.0)) * Math_fround(5.0));
  i16 = i49 + 4 | 0;
  i17 = i49 + 8 | 0;
  i18 = i49 + 12 | 0;
  i14 = i4;
  i1 = i4;
  do {
   if (!i3) i3 = 0; else {
    f13 = Math_fround(Math_fround(f46 * Math_fround(i14 >>> 0)) * Math_fround(5.0));
    i8 = 0;
    f9 = Math_fround(0.0);
    f10 = Math_fround(2.0);
    f11 = Math_fround(3.0);
    f12 = Math_fround(1.0);
    do {
     i1 = HEAP16[i48 >> 1] | 0;
     if (!((i1 & 255) << 24 >> 24)) i4 = 0; else i4 = (i8 >>> 0) / (((i3 >>> 0) / 3 | 0) >>> 0) | 0;
     f2 = Math_fround(HEAPF32[i39 + 8 + (i4 * 264 | 0) + 80 >> 2]);
     f2 = Math_fround(Math_fround(f44 * f2) * ((i1 & 65535) > 255 ? f44 : Math_fround(1.0)));
     f6 = Math_fround(Math_fround(f45 * f12) * Math_fround(5.0));
     f7 = Math_fround(Math_fround(f45 * f10) * Math_fround(5.0));
     f5 = Math_fround(Math_fround(f45 * f11) * Math_fround(5.0));
     HEAPF32[i43 >> 2] = Math_fround(Math_fround(f45 * f9) * Math_fround(5.0));
     HEAPF32[i30 >> 2] = f6;
     HEAPF32[i33 >> 2] = f7;
     HEAPF32[i36 >> 2] = f5;
     HEAPF32[i50 >> 2] = f13;
     HEAPF32[i31 >> 2] = f13;
     HEAPF32[i34 >> 2] = f13;
     HEAPF32[i37 >> 2] = f13;
     HEAPF32[i27 >> 2] = f15;
     HEAPF32[i29 >> 2] = f15;
     HEAPF32[i32 >> 2] = f15;
     HEAPF32[i35 >> 2] = f15;
     __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i49, i43, i26, HEAP32[i51 >> 2] | 0, i38, i40);
     f5 = Math_fround(f2 * Math_fround(HEAPF32[i49 >> 2]));
     f7 = Math_fround(f2 * Math_fround(HEAPF32[i52 >> 2]));
     f6 = Math_fround(f2 * Math_fround(HEAPF32[i53 >> 2]));
     f2 = Math_fround(f2 * Math_fround(HEAPF32[i54 >> 2]));
     HEAPF32[i49 >> 2] = f5;
     HEAPF32[i52 >> 2] = f7;
     HEAPF32[i53 >> 2] = f6;
     HEAPF32[i54 >> 2] = f2;
     if (HEAP8[i55 >> 0] | 0) {
      f59 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
      f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
      f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
      f7 = Math_fround(Math_fround(f2 * Math_fround(.5)) + Math_fround(.5));
      i1 = f59 < Math_fround(0.0);
      f2 = i1 ? Math_fround(0.0) : f59;
      i1 = f5 < Math_fround(0.0);
      f5 = i1 ? Math_fround(0.0) : f5;
      i1 = f6 < Math_fround(0.0);
      f6 = i1 ? Math_fround(0.0) : f6;
      i1 = f7 < Math_fround(0.0);
      f7 = i1 ? Math_fround(0.0) : f7;
      i1 = f2 > Math_fround(1.0);
      f2 = i1 ? Math_fround(1.0) : f2;
      i1 = f5 > Math_fround(1.0);
      f5 = i1 ? Math_fround(1.0) : f5;
      i1 = f6 > Math_fround(1.0);
      f6 = i1 ? Math_fround(1.0) : f6;
      i1 = f7 > Math_fround(1.0);
      f7 = i1 ? Math_fround(1.0) : f7;
      HEAPF32[i49 >> 2] = f2;
      HEAPF32[i52 >> 2] = f5;
      HEAPF32[i53 >> 2] = f6;
      HEAPF32[i54 >> 2] = f7;
      i1 = i39 + 1092 + (i4 * 264 | 0) | 0;
      HEAPF32[i20 >> 2] = Math_fround(1.0);
      HEAPF32[i21 >> 2] = Math_fround(1.0);
      HEAPF32[i22 >> 2] = Math_fround(1.0);
      HEAPF32[i57 >> 2] = Math_fround(1.0);
      i3 = HEAP32[i39 + 1092 + (i4 * 264 | 0) + 84 >> 2] | 0;
      L17 : do switch ((i3 & 65535) << 16 >> 16) {
      case 0:
       {
        i4 = HEAP32[i39 + 1092 + (i4 * 264 | 0) + 80 >> 2] | 0;
        HEAP32[i25 >> 2] = i4;
        HEAP32[i24 >> 2] = i4;
        HEAP32[i23 >> 2] = i4;
        HEAP32[i56 >> 2] = i4;
        break;
       }
      case 3:
       {
        f59 = Math_fround(HEAPF32[(HEAP32[i39 + 1092 + (i4 * 264 | 0) + 232 >> 2] | 0) + 4 >> 2]);
        f7 = Math_fround(HEAPF32[i39 + 1092 + (i4 * 264 | 0) + 80 >> 2]);
        f59 = Math_fround(f59 * f7);
        f59 = Math_fround(f59 + Math_fround(Math_fround(f7 * Math_fround(HEAPF32[(HEAP32[i39 + 1092 + (i4 * 264 | 0) + 144 >> 2] | 0) + 4 >> 2])) - f59));
        HEAPF32[i56 >> 2] = f59;
        HEAPF32[i23 >> 2] = f59;
        HEAPF32[i24 >> 2] = f59;
        HEAPF32[i25 >> 2] = f59;
        break;
       }
      default:
       if (!(i3 & 16711680)) {
        __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i56, i1, i42 + (i4 * 56 | 0) | 0, i49, i57);
        break L17;
       } else {
        __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i56, i1, i49, i57);
        break L17;
       }
      } while (0);
      i60 = HEAP32[i56 >> 2] | 0;
      i1 = HEAP32[i23 >> 2] | 0;
      i3 = HEAP32[i24 >> 2] | 0;
      i4 = HEAP32[i25 >> 2] | 0;
      HEAP32[i49 >> 2] = i60;
      HEAP32[i52 >> 2] = i1;
      HEAP32[i53 >> 2] = i3;
      HEAP32[i54 >> 2] = i4;
      f5 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     }
     f59 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
     f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
     f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
     f7 = Math_fround(Math_fround(f2 * Math_fround(.5)) + Math_fround(.5));
     i3 = f59 < Math_fround(0.0);
     f59 = i3 ? Math_fround(0.0) : f59;
     i3 = f5 < Math_fround(0.0);
     f5 = i3 ? Math_fround(0.0) : f5;
     i3 = f6 < Math_fround(0.0);
     f6 = i3 ? Math_fround(0.0) : f6;
     i3 = f7 < Math_fround(0.0);
     f7 = i3 ? Math_fround(0.0) : f7;
     i3 = f59 > Math_fround(1.0);
     f59 = i3 ? Math_fround(1.0) : f59;
     i3 = f5 > Math_fround(1.0);
     f5 = i3 ? Math_fround(1.0) : f5;
     i3 = f6 > Math_fround(1.0);
     f6 = i3 ? Math_fround(1.0) : f6;
     i3 = f7 > Math_fround(1.0);
     f7 = i3 ? Math_fround(1.0) : f7;
     HEAPF32[i49 >> 2] = f59;
     HEAPF32[i52 >> 2] = f5;
     HEAPF32[i53 >> 2] = f6;
     HEAPF32[i54 >> 2] = f7;
     i3 = HEAP32[i41 >> 2] | 0;
     i60 = Math_imul(i3, i14) | 0;
     i4 = HEAP32[i19 >> 2] | 0;
     i1 = i8 + i60 | 0;
     HEAPF32[i4 + (i1 << 4) >> 2] = f59;
     HEAPF32[i4 + (i1 << 4) + 4 >> 2] = f59;
     HEAPF32[i4 + (i1 << 4) + 8 >> 2] = f59;
     HEAPF32[i4 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 1) + i60 | 0;
     i61 = HEAP32[i16 >> 2] | 0;
     HEAP32[i4 + (i1 << 4) >> 2] = i61;
     HEAP32[i4 + (i1 << 4) + 4 >> 2] = i61;
     HEAP32[i4 + (i1 << 4) + 8 >> 2] = i61;
     HEAPF32[i4 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 2) + i60 | 0;
     i61 = HEAP32[i17 >> 2] | 0;
     HEAP32[i4 + (i1 << 4) >> 2] = i61;
     HEAP32[i4 + (i1 << 4) + 4 >> 2] = i61;
     HEAP32[i4 + (i1 << 4) + 8 >> 2] = i61;
     HEAPF32[i4 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i60 = (i8 | 3) + i60 | 0;
     i1 = HEAP32[i18 >> 2] | 0;
     HEAP32[i4 + (i60 << 4) >> 2] = i1;
     HEAP32[i4 + (i60 << 4) + 4 >> 2] = i1;
     HEAP32[i4 + (i60 << 4) + 8 >> 2] = i1;
     HEAPF32[i4 + (i60 << 4) + 12 >> 2] = Math_fround(1.0);
     i8 = i8 + 4 | 0;
     f9 = Math_fround(f9 + Math_fround(4.0));
     f12 = Math_fround(f12 + Math_fround(4.0));
     f10 = Math_fround(f10 + Math_fround(4.0));
     f11 = Math_fround(f11 + Math_fround(4.0));
    } while (i8 >>> 0 < i3 >>> 0);
    i1 = HEAP32[i47 >> 2] | 0;
   }
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < (i1 + 12 | 0) >>> 0);
 }
 if (!i28) {
  STACKTOP = i58;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i28);
 STACKTOP = i58;
 return;
}

function __ZN11HaloManager11RenderHalosEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f(i25, i1, i35, i26) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 3296 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i39 + 704 | 0;
 i38 = i39 + 688 | 0;
 i3 = i39 + 160 | 0;
 i29 = i39 + 152 | 0;
 i4 = i39 + 88 | 0;
 i30 = i39 + 156 | 0;
 i36 = i39 + 24 | 0;
 i34 = i39;
 i2 = i25 + 4 | 0;
 if ((HEAP32[i25 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i39;
  return;
 }
 if (i1 | 0) if (HEAP32[i1 + 1360 >> 2] | 0) {
  STACKTOP = i39;
  return;
 }
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali((__Z21GetManagerFromContexti(6) | 0) + 76 | 0, gb + 1110928 | 0, 1);
 i1 = HEAP32[gb + 1110928 >> 2] | 0;
 if (!i1) {
  STACKTOP = i39;
  return;
 }
 i31 = __ZNK6Shader23GetActiveSubShaderIndexEv(__ZN8Material9GetShaderEv(i1) | 0) | 0;
 i32 = __Z12GetGfxDevicev() | 0;
 if ((HEAP16[gb + 1110844 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110844 | 0, i37);
  i33 = gb + 1110844 | 0;
 } else i33 = 0;
 i5 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i25 >> 2] | 0) | 0;
 i24 = (i5 | 0) / 40 | 0;
 if (i5 | 0) {
  __ZN14BatchAllocatorC2Ev(i3);
  HEAP32[i29 >> 2] = 0;
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, i29, -1, 24, 1, 4);
  HEAP32[i29 >> 2] = 0;
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, 0, 0, 20, i24, 4);
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i3, (HEAP32[i29 >> 2] | 0) + 4 | 0, 0, 2580, (i24 + 63 | 0) >>> 6, 4);
  __ZN14BatchAllocator6CommitERK10MemLabelId(i3, gb + 64024 | 0);
  i3 = __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
  i23 = HEAP32[i3 + 880 >> 2] | 0;
  __Z20InvertMatrix4x4_FullPKfPf(i26, i4) | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  __ZN17UniqueIDGenerator8CreateIDEv(i37, (__Z12GetGfxDevicev() | 0) + 4448 | 0);
  HEAP32[i1 + 8 >> 2] = HEAP32[i37 >> 2];
  i1 = HEAP32[(HEAP32[i29 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i37 + 2572 >> 2] = 0;
  i2 = 0;
  do {
   i27 = i1 + (i2 * 40 | 0) | 0;
   i22 = i37 + (i2 * 40 | 0) | 0;
   HEAP32[i27 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i27 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   HEAP32[i27 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
   HEAP32[i1 + (i2 * 40 | 0) + 24 >> 2] = HEAP32[i37 + (i2 * 40 | 0) + 24 >> 2];
   i27 = i1 + (i2 * 40 | 0) + 28 | 0;
   i22 = i37 + (i2 * 40 | 0) + 28 | 0;
   HEAP32[i27 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 64);
  i27 = i1 + 2560 | 0;
  i22 = i37 + 2560 | 0;
  HEAP32[i27 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  HEAP8[i27 + 16 >> 0] = HEAP8[i22 + 16 >> 0] | 0;
  i22 = i3 + 28 | 0;
  __ZNK9Transform11GetPositionEv(i37, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i22 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i27 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
  i27 = __ZNK6Camera16GetStereoEnabledEv(i3) | 0;
  HEAP8[i1 + 2576 >> 0] = i27 & 1;
  if ((i5 | 0) > 0) {
   i9 = i26 + 16 | 0;
   i10 = i26 + 32 | 0;
   i11 = i26 + 48 | 0;
   i12 = i26 + 4 | 0;
   i13 = i26 + 20 | 0;
   i14 = i26 + 36 | 0;
   i15 = i26 + 52 | 0;
   i16 = i26 + 8 | 0;
   i17 = i26 + 24 | 0;
   i18 = i26 + 40 | 0;
   i19 = i26 + 56 | 0;
   i20 = i37 + 2572 | 0;
   i21 = i37 + 2560 | 0;
   i8 = 0;
   i3 = 0;
   i4 = 0;
   do {
    i6 = HEAP32[i25 >> 2] | 0;
    i7 = i6 + (i8 * 40 | 0) | 0;
    f42 = Math_fround(HEAPF32[i26 >> 2]);
    f44 = Math_fround(HEAPF32[i7 >> 2]);
    f42 = Math_fround(f42 * f44);
    f41 = Math_fround(HEAPF32[i9 >> 2]);
    f43 = Math_fround(HEAPF32[i6 + (i8 * 40 | 0) + 4 >> 2]);
    f41 = Math_fround(f42 + Math_fround(f41 * f43));
    f42 = Math_fround(HEAPF32[i10 >> 2]);
    f40 = Math_fround(HEAPF32[i6 + (i8 * 40 | 0) + 8 >> 2]);
    f42 = Math_fround(f41 + Math_fround(f42 * f40));
    f42 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f42);
    f41 = Math_fround(f44 * Math_fround(HEAPF32[i12 >> 2]));
    f41 = Math_fround(f41 + Math_fround(f43 * Math_fround(HEAPF32[i13 >> 2])));
    f41 = Math_fround(f41 + Math_fround(f40 * Math_fround(HEAPF32[i14 >> 2])));
    f41 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f41);
    f44 = Math_fround(f44 * Math_fround(HEAPF32[i16 >> 2]));
    f43 = Math_fround(f44 + Math_fround(f43 * Math_fround(HEAPF32[i17 >> 2])));
    f40 = Math_fround(f43 + Math_fround(f40 * Math_fround(HEAPF32[i18 >> 2])));
    f40 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f40);
    HEAPF32[i6 + (i8 * 40 | 0) + 12 >> 2] = f42;
    HEAPF32[i6 + (i8 * 40 | 0) + 16 >> 2] = f41;
    HEAPF32[i6 + (i8 * 40 | 0) + 20 >> 2] = f40;
    i2 = i6 + (i8 * 40 | 0) + 28 | 0;
    if (!(f40 > Math_fround(-Math_fround(HEAPF32[i2 >> 2])))) if (HEAP32[i6 + (i8 * 40 | 0) + 36 >> 2] & i23) {
     i5 = i1 + 2572 | 0;
     i45 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i45 + 1;
     i46 = i1 + (i45 * 40 | 0) | 0;
     HEAP32[i46 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i46 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i46 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i46 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i46 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i46 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i1 + (i45 * 40 | 0) + 24 >> 2] = HEAP32[i6 + (i8 * 40 | 0) + 24 >> 2];
     i7 = i1 + (i45 * 40 | 0) + 28 | 0;
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     if ((HEAP32[i5 >> 2] | 0) == 64) {
      i2 = HEAP32[HEAP32[i29 >> 2] >> 2] | 0;
      HEAP32[i2 + (i3 * 20 | 0) + 8 >> 2] = 1344;
      HEAP32[i2 + (i3 * 20 | 0) + 12 >> 2] = 0;
      HEAP32[i2 + (i3 * 20 | 0) + 16 >> 2] = 24;
      i5 = (HEAP32[i5 >> 2] | 0) * 21 | 0;
      i3 = i3 + 1 | 0;
      HEAP32[i20 >> 2] = 0;
      i2 = 0;
      do {
       i46 = i1 + 2580 + (i2 * 40 | 0) | 0;
       i45 = i37 + (i2 * 40 | 0) | 0;
       HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
       HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
       HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
       HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
       HEAP32[i46 + 16 >> 2] = HEAP32[i45 + 16 >> 2];
       HEAP32[i46 + 20 >> 2] = HEAP32[i45 + 20 >> 2];
       HEAP32[i1 + 2580 + (i2 * 40 | 0) + 24 >> 2] = HEAP32[i37 + (i2 * 40 | 0) + 24 >> 2];
       i46 = i1 + 2580 + (i2 * 40 | 0) + 28 | 0;
       i45 = i37 + (i2 * 40 | 0) + 28 | 0;
       HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
       HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
       HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 64);
      i46 = i1 + 5140 | 0;
      HEAP32[i46 >> 2] = HEAP32[i21 >> 2];
      HEAP32[i46 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
      HEAP32[i46 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
      HEAP32[i46 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
      HEAP8[i46 + 16 >> 0] = HEAP8[i21 + 16 >> 0] | 0;
      __ZNK9Transform11GetPositionEv(i37, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i22 >> 2] | 0, gb + 28940 | 0) | 0);
      HEAP32[i46 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i46 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i46 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      i4 = i5 + i4 | 0;
      i1 = i1 + 2580 | 0;
     }
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) < (i24 | 0));
   if (!i1) i1 = i3; else i28 = 20;
  } else {
   i3 = 0;
   i4 = 0;
   i28 = 20;
  }
  if ((i28 | 0) == 20) {
   i2 = i1 + 2572 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = i3; else {
    i46 = HEAP32[HEAP32[i29 >> 2] >> 2] | 0;
    HEAP32[i46 + (i3 * 20 | 0) + 8 >> 2] = i1 * 21;
    HEAP32[i46 + (i3 * 20 | 0) + 12 >> 2] = 0;
    HEAP32[i46 + (i3 * 20 | 0) + 16 >> 2] = 24;
    i1 = i3 + 1 | 0;
    i4 = ((HEAP32[i2 >> 2] | 0) * 21 | 0) + i4 | 0;
   }
  }
  if (!i1) {
   i2 = HEAP32[i29 >> 2] | 0;
   if ((HEAP16[gb + 1110856 + 6 >> 1] | 0) > -1) {
    HEAP32[i38 >> 2] = 0;
    HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110856 | 0, i37);
    i1 = gb + 1110856 | 0;
   } else i1 = 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  } else {
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = -1;
   HEAP32[i38 + 12 >> 2] = 0;
   i3 = HEAP32[i29 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i32 >> 2] | 0) + 252 >> 2] | 0, i32 | 0, fb + 2375 | 0, fb + 3323 | 0, i3 | 0, i1 | 0, 1, i38 | 0);
   HEAP32[i29 >> 2] = 0;
   i1 = HEAP32[(HEAP32[i32 >> 2] | 0) + 256 >> 2] | 0;
   HEAP32[i30 >> 2] = i2;
   HEAP32[i37 >> 2] = HEAP32[i30 >> 2];
   mftCall_vii(i1 | 0, i32 | 0, i37 | 0);
   i1 = i37;
   i2 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 132 >> 2] | 0, i32 | 0) | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i1 = i36;
   i2 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 128 >> 2] | 0, i32 | 0) | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   if (!i27) mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 112 >> 2] | 0, i32 | 0, gb + 1162292 | 0);
   mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 108 >> 2] | 0, i32 | 0, gb + 1162292 | 0);
   i46 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1110928 >> 2] | 0, 0, i35, i31, 1) | 0;
   HEAP32[i34 >> 2] = 24;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = i4;
   HEAP32[i34 + 12 >> 2] = 0;
   HEAP32[i34 + 16 >> 2] = 0;
   i31 = __ZN9GfxDevice13GetDynamicVBOEv(i32) | 0;
   i30 = HEAP32[(HEAP32[i31 >> 2] | 0) + 16 >> 2] | 0;
   i45 = HEAP32[gb + 1110836 + 4 >> 2] | 0;
   i35 = HEAP32[i45 + 4 >> 2] | 0;
   mftCall_viiiiiii(i30 | 0, i31 | 0, i38 | 0, i46 | 0, i35 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i45, HEAP32[i46 >> 2] | 0, 0) | 0, i34 | 0, 1);
   __Z15gpu_time_samplev();
   if (!i27) mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 112 >> 2] | 0, i32 | 0, i37 | 0);
   mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 108 >> 2] | 0, i32 | 0, i36 | 0);
  }
 }
 if (!i33) {
  STACKTOP = i39;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i33);
 STACKTOP = i39;
 return;
}

function __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES(i22, i23, i1) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i17 = i24 + 8 | 0;
 i15 = i24 + 24 | 0;
 i16 = i24 + 16 | 0;
 i18 = i24;
 if (i1 | 0) __ZN14GfxContextGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES(i1, i23);
 __ZN13GfxDeviceGLES19CancelPendingMipGenEP17RenderSurfaceBase(__Z16GetRealGfxDevicev() | 0, i23);
 i21 = i22 + 336 | 0;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i17, HEAP32[i21 >> 2] | 0, 0);
 i2 = HEAP32[i22 >> 2] | 0;
 i8 = i22 + 4 | 0;
 if ((i2 | 0) == (i8 | 0)) i19 = 46; else {
  i9 = i23 + 36 | 0;
  i10 = i23 + 44 | 0;
  i11 = i22 + 376 | 0;
  i12 = i22 + 8 | 0;
  i13 = i22 + 4 | 0;
  i14 = i17 + 4 | 0;
  i1 = 1;
  L6 : do {
   i3 = i2;
   L8 : while (1) {
    i6 = i3 + 16 | 0;
    i7 = i3 + 108 | 0;
    if (HEAP8[i7 >> 0] | 0) {
     i2 = HEAP32[i3 + 84 >> 2] | 0;
     if (i2 | 0) if ((i2 | 0) == (HEAP32[i23 >> 2] | 0)) {
      i19 = 20;
      break;
     }
     i2 = HEAP32[i3 + 88 >> 2] | 0;
     if (i2 | 0) if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
      i19 = 20;
      break;
     }
     i2 = HEAP32[i3 + 92 >> 2] | 0;
     if (i2 | 0) if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) {
      i19 = 20;
      break;
     }
    }
    i5 = HEAP32[i6 >> 2] | 0;
    if (i5 | 0) {
     i4 = 0;
     do {
      i2 = HEAP32[i3 + 20 + (i4 << 2) >> 2] | 0;
      if (i2 | 0) if ((i2 | 0) == (HEAP32[i23 >> 2] | 0)) {
       i2 = i6;
       break L8;
      }
      i2 = HEAP32[i3 + 52 + (i4 << 2) >> 2] | 0;
      if (i2 | 0) if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
       i2 = i6;
       break L8;
      }
      i4 = i4 + 1 | 0;
     } while (i4 >>> 0 < i5 >>> 0);
    }
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((i2 | 0) == (i8 | 0)) break L6; else i3 = i2;
   }
   if ((i19 | 0) == 20) i2 = i6;
   i5 = HEAP32[i21 >> 2] | 0;
   i6 = i3 + 112 | 0;
   i25 = i6;
   i19 = HEAP32[i25 + 4 >> 2] | 0;
   i4 = i15;
   HEAP32[i4 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i4 + 4 >> 2] = i19;
   HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i5, 0, i20);
   i5 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 668 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) > 0) {
    i2 = 0;
    do {
     mftCall_viiiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i2 + 36064 | 0, 3553, 0, 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i4 | 0));
   }
   if (HEAP8[i7 >> 0] | 0) {
    mftCall_viiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, 36096, 36161, 0);
    mftCall_viiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, 36128, 36161, 0);
   }
   i2 = HEAP32[i17 >> 2] | 0;
   if (!i2) if (!(HEAP32[i6 >> 2] | 0)) i19 = 29; else i19 = 27; else i19 = 27;
   if ((i19 | 0) == 27) {
    i19 = 0;
    if ((HEAP32[i3 + 116 >> 2] | 0) == (HEAP32[i14 >> 2] | 0)) if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) i19 = 29;
   }
   if ((i19 | 0) == 29) {
    i19 = 0;
    i1 = 0;
   }
   i4 = HEAP32[i21 >> 2] | 0;
   i5 = i11;
   i7 = HEAP32[i5 + 4 >> 2] | 0;
   i25 = i16;
   HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i25 + 4 >> 2] = i7;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_(i4, i6, i20);
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = (i4 | 0) == 0;
   if (i6) {
    i5 = i3;
    while (1) {
     i2 = HEAP32[i5 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
      i7 = i3;
      break;
     } else i5 = i2;
    }
   } else {
    i2 = i4;
    while (1) {
     i5 = HEAP32[i2 >> 2] | 0;
     if (!i5) break; else i2 = i5;
    }
    i7 = i3;
   }
   if (i6) {
    i5 = i7;
    while (1) {
     i4 = HEAP32[i5 + 8 >> 2] | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) break; else i5 = i4;
    }
   } else while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) break; else i4 = i5;
   }
   if ((HEAP32[i22 >> 2] | 0) == (i3 | 0)) HEAP32[i22 >> 2] = i4;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 >> 2] | 0, i7);
   __ZdlPv(i3);
  } while ((i2 | 0) != (i8 | 0));
  if (i1) i19 = 46;
 }
 if ((i19 | 0) == 46) {
  i25 = HEAP32[i21 >> 2] | 0;
  i15 = i17;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = i18;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i25, 0, i20);
 }
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i20, HEAP32[i21 >> 2] | 0, 0);
 i2 = i20;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i22 + 168 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = i20 + 68 | 0;
 i1 = i22 + 248 | 0;
 i2 = i20;
 i3 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i22 + 212 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i20 >> 2] = 1;
  i3 = i20;
  i19 = 52;
  break;
 } else {
  HEAP32[i20 >> 2] = 0;
  i2 = 0;
  break;
 } else {
  HEAP32[i20 >> 2] = i1;
  if (!i1) i2 = 0; else {
   i3 = i20;
   i19 = 52;
  }
 } while (0);
 if ((i19 | 0) == 52) {
  i1 = 0;
  do {
   i2 = HEAP32[i22 + 212 + (i1 << 2) >> 2] | 0;
   HEAP32[i20 + 4 + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i20 + 36 + (i1 << 2) >> 2] = HEAP32[i2 + 36 >> 2];
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = HEAP32[i22 + 244 >> 2] | 0;
 do if (!i1) {
  HEAP8[i20 + 92 >> 0] = 0;
  i1 = 1;
 } else {
  i3 = i20 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i3 >> 0] = 1;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i20 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i20 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   i1 = 0;
   break;
  } else {
   HEAP8[i3 >> 0] = 0;
   i1 = 1;
   break;
  }
 } while (0);
 HEAP32[i20 + 80 >> 2] = HEAP32[i22 + 252 >> 2];
 HEAP32[i20 + 84 >> 2] = HEAP32[i22 + 260 >> 2];
 HEAP32[i20 + 88 >> 2] = HEAP32[i22 + 256 >> 2];
 do if (i1) i19 = 66; else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
   i6 = 0;
   break;
  }
  i1 = HEAP32[i20 + 72 >> 2] | 0;
  if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 + 36 >> 2] | 0)) {
   i6 = 0;
   break;
  }
  i1 = HEAP32[i20 + 76 >> 2] | 0;
  if (!i1) i19 = 66; else if ((i1 | 0) == (HEAP32[i23 + 44 >> 2] | 0)) i6 = 0; else i19 = 66;
 } while (0);
 L103 : do if ((i19 | 0) == 66) {
  i4 = i23 + 36 | 0;
  if (!i2) i6 = 1; else {
   i3 = 0;
   while (1) {
    i1 = HEAP32[i20 + 4 + (i3 << 2) >> 2] | 0;
    if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
     i6 = 0;
     break L103;
    }
    i1 = HEAP32[i20 + 36 + (i3 << 2) >> 2] | 0;
    if (i1 | 0) if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
     i6 = 0;
     break L103;
    }
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i2 >>> 0) {
     i6 = 1;
     break;
    }
   }
  }
 } while (0);
 i7 = i22 + 328 | 0;
 HEAP8[i7 >> 0] = i6;
 i4 = i20 + 68 | 0;
 i1 = i22 + 128 | 0;
 i2 = i20;
 i3 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i22 + 92 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i20 >> 2] = 1;
  i3 = i20;
  i19 = 77;
  break;
 } else {
  HEAP32[i20 >> 2] = 0;
  i5 = 0;
  break;
 } else {
  HEAP32[i20 >> 2] = i1;
  if (!i1) i5 = 0; else {
   i3 = i20;
   i19 = 77;
  }
 } while (0);
 if ((i19 | 0) == 77) {
  i1 = 0;
  do {
   i2 = HEAP32[i22 + 92 + (i1 << 2) >> 2] | 0;
   HEAP32[i20 + 4 + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i20 + 36 + (i1 << 2) >> 2] = HEAP32[i2 + 36 >> 2];
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i5 = i2;
 }
 i1 = HEAP32[i22 + 124 >> 2] | 0;
 do if (!i1) {
  HEAP8[i20 + 92 >> 0] = 0;
  i1 = 1;
 } else {
  i2 = i20 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i20 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i20 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   i1 = 0;
   break;
  } else {
   HEAP8[i2 >> 0] = 0;
   i1 = 1;
   break;
  }
 } while (0);
 HEAP32[i20 + 80 >> 2] = HEAP32[i22 + 132 >> 2];
 HEAP32[i20 + 84 >> 2] = HEAP32[i22 + 140 >> 2];
 HEAP32[i20 + 88 >> 2] = HEAP32[i22 + 136 >> 2];
 do if (i1) i19 = 91; else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
   i2 = 0;
   break;
  }
  i1 = HEAP32[i20 + 72 >> 2] | 0;
  if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 + 36 >> 2] | 0)) {
   i2 = 0;
   break;
  }
  i1 = HEAP32[i20 + 76 >> 2] | 0;
  if (!i1) i19 = 91; else if ((i1 | 0) == (HEAP32[i23 + 44 >> 2] | 0)) i2 = 0; else i19 = 91;
 } while (0);
 L141 : do if ((i19 | 0) == 91) {
  i3 = i23 + 36 | 0;
  if (!i5) i2 = 1; else {
   i2 = 0;
   while (1) {
    i1 = HEAP32[i20 + 4 + (i2 << 2) >> 2] | 0;
    if (i1 | 0) if ((i1 | 0) == (HEAP32[i23 >> 2] | 0)) {
     i2 = 0;
     break L141;
    }
    i1 = HEAP32[i20 + 36 + (i2 << 2) >> 2] | 0;
    if (i1 | 0) if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
     i2 = 0;
     break L141;
    }
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 1;
     break;
    }
   }
  }
 } while (0);
 i1 = i22 + 208 | 0;
 HEAP8[i1 >> 0] = i2;
 if (!(i6 << 24 >> 24)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 602476 | 0, 0, gb + 602389 | 0, 701, 1, 0, 0, 0);
  i2 = HEAP8[i1 >> 0] | 0;
  i1 = (HEAP8[i7 >> 0] | 0) == 0;
 } else i1 = 0;
 if (i2 << 24 >> 24) {
  if (!i1) {
   i25 = HEAP32[i21 >> 2] | 0;
   __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES(i25, i23);
   STACKTOP = i24;
   return;
  }
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i22, i22 + 16 | 0);
  i25 = HEAP32[i21 >> 2] | 0;
  __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES(i25, i23);
  STACKTOP = i24;
  return;
 }
 if (i1) {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i22, 0);
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i22, i22 + 16 | 0);
  i25 = HEAP32[i21 >> 2] | 0;
  __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES(i25, i23);
  STACKTOP = i24;
  return;
 } else {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i22, 1);
  i25 = HEAP32[i21 >> 2] | 0;
  __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES(i25, i23);
  STACKTOP = i24;
  return;
 }
}

function __Z19sweepBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i4, i3, i22, f19, i21, i6, f2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i22 = i22 | 0;
 f19 = Math_fround(f19);
 i21 = i21 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, i46 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i23 + 400 | 0;
 i15 = i23 + 384 | 0;
 i25 = i23 + 368 | 0;
 i35 = i23 + 432 | 0;
 i46 = i23 + 416 | 0;
 i26 = i23 + 208 | 0;
 i27 = i23 + 64 | 0;
 i24 = i23 + 48 | 0;
 i14 = i23 + 32 | 0;
 i18 = i23 + 16 | 0;
 i20 = i23;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i42 = HEAP32[i3 + 48 >> 2] | 0;
 i41 = HEAP32[i3 + 52 >> 2] | 0;
 i40 = HEAP32[i3 + 56 >> 2] | 0;
 f32 = Math_fround(HEAPF32[i22 >> 2]);
 i17 = i22 + 4 | 0;
 f30 = Math_fround(HEAPF32[i17 >> 2]);
 i16 = i22 + 8 | 0;
 f31 = Math_fround(HEAPF32[i16 >> 2]);
 i1 = i1 + 4 | 0;
 i36 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i46, i3);
 f8 = Math_fround(HEAPF32[i46 >> 2]);
 f9 = Math_fround(HEAPF32[i46 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i46 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i46 + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 i3 = i4 + 16 | 0;
 f37 = Math_fround(HEAPF32[i3 >> 2]);
 f44 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f43 = Math_fround(-f8);
 f38 = Math_fround(-f9);
 f33 = Math_fround(-f10);
 f37 = Math_fround(f37 - f12);
 f44 = Math_fround(f44 - f13);
 f45 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f7);
 f5 = Math_fround(Math_fround(f11 * f11) + Math_fround(-.5));
 f39 = Math_fround(Math_fround(Math_fround(f37 * f43) + Math_fround(f44 * f38)) + Math_fround(f45 * f33));
 f28 = Math_fround(Math_fround(Math_fround(f39 * f43) + Math_fround(Math_fround(f5 * f37) + Math_fround(f11 * Math_fround(Math_fround(f45 * f38) - Math_fround(f44 * f33))))) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(Math_fround(f5 * f44) + Math_fround(f11 * Math_fround(Math_fround(f37 * f33) - Math_fround(f45 * f43))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f45) + Math_fround(f11 * Math_fround(Math_fround(f44 * f43) - Math_fround(f37 * f38)))) + Math_fround(f39 * f33)) * Math_fround(2.0));
 i3 = i26 + 64 | 0;
 HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i26 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 HEAP32[i26 + 80 >> 2] = 3;
 HEAPF32[i26 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 HEAP32[i26 + 144 >> 2] = i42;
 HEAP32[i26 + 148 >> 2] = i41;
 HEAP32[i26 + 152 >> 2] = i40;
 HEAPF32[i26 + 156 >> 2] = Math_fround(0.0);
 f39 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = f39 <= f38 ? f39 : f38;
 f37 = f38 <= f37 ? f38 : f37;
 HEAPF32[i26 + 16 >> 2] = Math_fround(f37 * Math_fround(.150000006));
 HEAPF32[i26 + 32 >> 2] = Math_fround(f37 * Math_fround(.0500000007));
 i3 = i27 + 64 | 0;
 HEAP32[i27 + 80 >> 2] = 4;
 HEAPF32[i27 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i27 >> 2] = f28;
 HEAPF32[i27 + 4 >> 2] = f29;
 HEAPF32[i27 + 8 >> 2] = f33;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 128 >> 2] = i36;
 i4 = i27 + 132 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAPF32[i27 + 96 >> 2] = f28;
 HEAPF32[i27 + 100 >> 2] = f29;
 HEAPF32[i27 + 104 >> 2] = f33;
 HEAPF32[i27 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 112 >> 2] = f28;
 HEAPF32[i27 + 116 >> 2] = f29;
 HEAPF32[i27 + 120 >> 2] = f33;
 HEAPF32[i27 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 16 >> 2] = i36;
 i4 = i27 + 20 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i27 + 32 >> 2] = i36;
 i4 = i27 + 36 | 0;
 HEAP32[i4 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i34 >> 2] = -1;
 HEAP32[i34 + 4 >> 2] = -1;
 HEAP32[i34 + 8 >> 2] = -1;
 HEAP32[i34 + 12 >> 2] = -1;
 HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 f32 = Math_fround(f32 * f19);
 f30 = Math_fround(f30 * f19);
 f31 = Math_fround(f31 * f19);
 f33 = Math_fround(Math_fround(Math_fround(f32 * f8) + Math_fround(f30 * f9)) + Math_fround(f31 * f10));
 f29 = Math_fround(Math_fround(Math_fround(f9 * f33) + Math_fround(Math_fround(f30 * f5) - Math_fround(f11 * Math_fround(Math_fround(f32 * f10) - Math_fround(f31 * f8))))) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(Math_fround(f10 * f33) + Math_fround(Math_fround(f31 * f5) - Math_fround(f11 * Math_fround(Math_fround(f30 * f8) - Math_fround(f32 * f9))))) * Math_fround(2.0));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f8 * f33) + Math_fround(Math_fround(f32 * f5) - Math_fround(f11 * Math_fround(Math_fround(f31 * f9) - Math_fround(f30 * f10))))) * Math_fround(2.0));
 HEAPF32[i24 + 4 >> 2] = f29;
 HEAPF32[i24 + 8 >> 2] = f28;
 HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
 i3 = (HEAP16[i6 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i27, i26, i15, i25, i24, i14, i20, i18, Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f2), i3) | 0)) {
  i46 = 0;
  STACKTOP = i23;
  return i46 | 0;
 }
 i1 = i21 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 f45 = Math_fround(HEAPF32[i15 >> 2]);
 f2 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f45 >= f2)) {
  HEAP16[i1 >> 1] = 7;
  f31 = Math_fround(HEAPF32[i18 >> 2]);
  f33 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f44 = Math_fround(Math_fround(Math_fround(f8 * f31) + Math_fround(f9 * f33)) + Math_fround(f10 * f32));
  f39 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f8 * f44) + Math_fround(Math_fround(f5 * f31) + Math_fround(f11 * Math_fround(Math_fround(f9 * f32) - Math_fround(f10 * f33))))) * Math_fround(2.0)));
  f43 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f9 * f44) + Math_fround(Math_fround(f5 * f33) + Math_fround(f11 * Math_fround(Math_fround(f10 * f31) - Math_fround(f8 * f32))))) * Math_fround(2.0)));
  f44 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f32) + Math_fround(f11 * Math_fround(Math_fround(f8 * f33) - Math_fround(f9 * f31)))) + Math_fround(f10 * f44)) * Math_fround(2.0)));
  f31 = Math_fround(HEAPF32[i20 >> 2]);
  f33 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f30 = Math_fround(Math_fround(Math_fround(f8 * f31) + Math_fround(f9 * f33)) + Math_fround(f10 * f32));
  f37 = Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f30) + Math_fround(Math_fround(f5 * f33) + Math_fround(f11 * Math_fround(Math_fround(f10 * f31) - Math_fround(f8 * f32))))) * Math_fround(2.0)));
  f38 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f5 * f32) + Math_fround(f11 * Math_fround(Math_fround(f8 * f33) - Math_fround(f9 * f31)))) + Math_fround(f10 * f30)) * Math_fround(2.0)));
  f45 = Math_fround(f2 * f19);
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f8 * f30) + Math_fround(Math_fround(f5 * f31) + Math_fround(f11 * Math_fround(Math_fround(f9 * f32) - Math_fround(f10 * f33))))) * Math_fround(2.0)));
  HEAPF32[i21 + 32 >> 2] = f37;
  HEAPF32[i21 + 36 >> 2] = f38;
  HEAPF32[i21 + 16 >> 2] = f39;
  HEAPF32[i21 + 20 >> 2] = f43;
  HEAPF32[i21 + 24 >> 2] = f44;
  HEAPF32[i21 + 40 >> 2] = f45;
  i46 = 1;
  STACKTOP = i23;
  return i46 | 0;
 }
 if (i3) {
  HEAP16[i1 >> 1] = 7;
  f32 = Math_fround(HEAPF32[i18 >> 2]);
  f37 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f45 = Math_fround(Math_fround(Math_fround(f8 * f32) + Math_fround(f9 * f37)) + Math_fround(f10 * f33));
  f43 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f8 * f45) + Math_fround(Math_fround(f5 * f32) + Math_fround(f11 * Math_fround(Math_fround(f9 * f33) - Math_fround(f10 * f37))))) * Math_fround(2.0)));
  f44 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f9 * f45) + Math_fround(Math_fround(f5 * f37) + Math_fround(f11 * Math_fround(Math_fround(f10 * f32) - Math_fround(f8 * f33))))) * Math_fround(2.0)));
  f45 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f33) + Math_fround(f11 * Math_fround(Math_fround(f8 * f37) - Math_fround(f9 * f32)))) + Math_fround(f10 * f45)) * Math_fround(2.0)));
  f32 = Math_fround(HEAPF32[i20 >> 2]);
  f37 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f31 = Math_fround(Math_fround(Math_fround(f8 * f32) + Math_fround(f9 * f37)) + Math_fround(f10 * f33));
  f38 = Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f31) + Math_fround(Math_fround(f5 * f37) + Math_fround(f11 * Math_fround(Math_fround(f10 * f32) - Math_fround(f8 * f33))))) * Math_fround(2.0)));
  f39 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f5 * f33) + Math_fround(f11 * Math_fround(Math_fround(f8 * f37) - Math_fround(f9 * f32)))) + Math_fround(f10 * f31)) * Math_fround(2.0)));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f8 * f31) + Math_fround(Math_fround(f5 * f32) + Math_fround(f11 * Math_fround(Math_fround(f9 * f33) - Math_fround(f10 * f37))))) * Math_fround(2.0)));
  HEAPF32[i21 + 32 >> 2] = f38;
  HEAPF32[i21 + 36 >> 2] = f39;
  HEAPF32[i21 + 16 >> 2] = f43;
  HEAPF32[i21 + 20 >> 2] = f44;
  HEAPF32[i21 + 24 >> 2] = f45;
  HEAPF32[i21 + 40 >> 2] = f2;
  i46 = 1;
  STACKTOP = i23;
  return i46 | 0;
 } else {
  HEAPF32[i21 + 40 >> 2] = Math_fround(0.0);
  f43 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  f44 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
  f45 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
  HEAPF32[i21 + 28 >> 2] = f43;
  HEAPF32[i21 + 32 >> 2] = f44;
  HEAPF32[i21 + 36 >> 2] = f45;
  i46 = 1;
  STACKTOP = i23;
  return i46 | 0;
 }
 return 0;
}

function _build_tree(i20, i15) {
 i20 = i20 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23;
 i22 = HEAP32[i15 >> 2] | 0;
 i17 = i15 + 8 | 0;
 i12 = HEAP32[i17 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 i16 = i20 + 5200 | 0;
 HEAP32[i16 >> 2] = 0;
 i18 = i20 + 5204 | 0;
 HEAP32[i18 >> 2] = 573;
 if ((i12 | 0) > 0) {
  i1 = -1;
  i2 = 0;
  do {
   if (!(HEAP16[i22 + (i2 << 2) >> 1] | 0)) HEAP16[i22 + (i2 << 2) + 2 >> 1] = 0; else {
    i1 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i2;
    HEAP8[i20 + 5208 + i2 >> 0] = 0;
    i1 = i2;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  i2 = HEAP32[i16 >> 2] | 0;
  if ((i2 | 0) < 2) i3 = 3; else i19 = i1;
 } else {
  i1 = -1;
  i2 = 0;
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i4 = i20 + 5800 | 0;
  i3 = i20 + 5804 | 0;
  if (!i5) {
   do {
    i14 = (i1 | 0) < 2;
    i19 = i1 + 1 | 0;
    i1 = i14 ? i19 : i1;
    i19 = i14 ? i19 : 0;
    i2 = i2 + 1 | 0;
    HEAP32[i16 >> 2] = i2;
    HEAP32[i20 + 2908 + (i2 << 2) >> 2] = i19;
    HEAP16[i22 + (i19 << 2) >> 1] = 1;
    HEAP8[i20 + 5208 + i19 >> 0] = 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
    i2 = HEAP32[i16 >> 2] | 0;
   } while ((i2 | 0) < 2);
   i19 = i1;
  } else {
   do {
    i14 = (i1 | 0) < 2;
    i19 = i1 + 1 | 0;
    i1 = i14 ? i19 : i1;
    i19 = i14 ? i19 : 0;
    i2 = i2 + 1 | 0;
    HEAP32[i16 >> 2] = i2;
    HEAP32[i20 + 2908 + (i2 << 2) >> 2] = i19;
    HEAP16[i22 + (i19 << 2) >> 1] = 1;
    HEAP8[i20 + 5208 + i19 >> 0] = 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - (HEAPU16[i5 + (i19 << 2) + 2 >> 1] | 0);
    i2 = HEAP32[i16 >> 2] | 0;
   } while ((i2 | 0) < 2);
   i19 = i1;
  }
 }
 i14 = i15 + 4 | 0;
 HEAP32[i14 >> 2] = i19;
 i11 = (i2 | 0) / 2 | 0;
 while (1) {
  i10 = HEAP32[i20 + 2908 + (i11 << 2) >> 2] | 0;
  i8 = i20 + 5208 + i10 | 0;
  i3 = i11 << 1;
  L19 : do if ((i3 | 0) > (i2 | 0)) i1 = i11; else {
   i9 = i22 + (i10 << 2) | 0;
   i1 = i11;
   while (1) {
    do if ((i3 | 0) < (i2 | 0)) {
     i5 = i3 | 1;
     i2 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
     i4 = HEAP16[i22 + (i2 << 2) >> 1] | 0;
     i6 = HEAP32[i20 + 2908 + (i3 << 2) >> 2] | 0;
     i7 = HEAP16[i22 + (i6 << 2) >> 1] | 0;
     if ((i4 & 65535) >= (i7 & 65535)) {
      if (i4 << 16 >> 16 != i7 << 16 >> 16) {
       i5 = i3;
       break;
      }
      if ((HEAPU8[i20 + 5208 + i2 >> 0] | 0) > (HEAPU8[i20 + 5208 + i6 >> 0] | 0)) {
       i5 = i3;
       break;
      }
     }
    } else i5 = i3; while (0);
    i2 = HEAP16[i9 >> 1] | 0;
    i3 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
    i4 = HEAP16[i22 + (i3 << 2) >> 1] | 0;
    if ((i2 & 65535) < (i4 & 65535)) break L19;
    if (i2 << 16 >> 16 == i4 << 16 >> 16) if ((HEAPU8[i8 >> 0] | 0) <= (HEAPU8[i20 + 5208 + i3 >> 0] | 0)) break L19;
    HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i3;
    i3 = i5 << 1;
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i3 | 0) > (i2 | 0)) {
     i1 = i5;
     break;
    } else i1 = i5;
   }
  } while (0);
  HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i10;
  if ((i11 | 0) <= 1) break;
  i11 = i11 + -1 | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i13 = i20 + 2912 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 do {
  i11 = HEAP32[i13 >> 2] | 0;
  i2 = i1 + -1 | 0;
  HEAP32[i16 >> 2] = i2;
  i10 = HEAP32[i20 + 2908 + (i1 << 2) >> 2] | 0;
  HEAP32[i13 >> 2] = i10;
  i9 = i20 + 5208 + i10 | 0;
  L39 : do if ((i1 | 0) < 3) i1 = 1; else {
   i8 = i22 + (i10 << 2) | 0;
   i1 = 1;
   i7 = 2;
   while (1) {
    do if ((i7 | 0) < (i2 | 0)) {
     i5 = i7 | 1;
     i2 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
     i3 = HEAP16[i22 + (i2 << 2) >> 1] | 0;
     i4 = HEAP32[i20 + 2908 + (i7 << 2) >> 2] | 0;
     i6 = HEAP16[i22 + (i4 << 2) >> 1] | 0;
     if ((i3 & 65535) >= (i6 & 65535)) {
      if (i3 << 16 >> 16 != i6 << 16 >> 16) {
       i5 = i7;
       break;
      }
      if ((HEAPU8[i20 + 5208 + i2 >> 0] | 0) > (HEAPU8[i20 + 5208 + i4 >> 0] | 0)) {
       i5 = i7;
       break;
      }
     }
    } else i5 = i7; while (0);
    i2 = HEAP16[i8 >> 1] | 0;
    i3 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
    i4 = HEAP16[i22 + (i3 << 2) >> 1] | 0;
    if ((i2 & 65535) < (i4 & 65535)) break L39;
    if (i2 << 16 >> 16 == i4 << 16 >> 16) if ((HEAPU8[i9 >> 0] | 0) <= (HEAPU8[i20 + 5208 + i3 >> 0] | 0)) break L39;
    HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i3;
    i7 = i5 << 1;
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i7 | 0) > (i2 | 0)) {
     i1 = i5;
     break;
    } else i1 = i5;
   }
  } while (0);
  HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i10;
  i10 = HEAP32[i13 >> 2] | 0;
  i8 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
  HEAP32[i18 >> 2] = i8;
  HEAP32[i20 + 2908 + (i8 << 2) >> 2] = i11;
  i8 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
  HEAP32[i18 >> 2] = i8;
  HEAP32[i20 + 2908 + (i8 << 2) >> 2] = i10;
  i8 = i22 + (i12 << 2) | 0;
  HEAP16[i8 >> 1] = (HEAPU16[i22 + (i10 << 2) >> 1] | 0) + (HEAPU16[i22 + (i11 << 2) >> 1] | 0);
  i2 = HEAP8[i20 + 5208 + i11 >> 0] | 0;
  i7 = HEAP8[i20 + 5208 + i10 >> 0] | 0;
  i9 = i20 + 5208 + i12 | 0;
  HEAP8[i9 >> 0] = (((i2 & 255) < (i7 & 255) ? i7 : i2) & 255) + 1;
  i2 = i12 & 65535;
  HEAP16[i22 + (i10 << 2) + 2 >> 1] = i2;
  HEAP16[i22 + (i11 << 2) + 2 >> 1] = i2;
  HEAP32[i13 >> 2] = i12;
  i2 = HEAP32[i16 >> 2] | 0;
  L55 : do if ((i2 | 0) < 2) i1 = 1; else {
   i1 = 1;
   i7 = 2;
   while (1) {
    do if ((i7 | 0) < (i2 | 0)) {
     i5 = i7 | 1;
     i2 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
     i3 = HEAP16[i22 + (i2 << 2) >> 1] | 0;
     i4 = HEAP32[i20 + 2908 + (i7 << 2) >> 2] | 0;
     i6 = HEAP16[i22 + (i4 << 2) >> 1] | 0;
     if ((i3 & 65535) >= (i6 & 65535)) {
      if (i3 << 16 >> 16 != i6 << 16 >> 16) {
       i5 = i7;
       break;
      }
      if ((HEAPU8[i20 + 5208 + i2 >> 0] | 0) > (HEAPU8[i20 + 5208 + i4 >> 0] | 0)) {
       i5 = i7;
       break;
      }
     }
    } else i5 = i7; while (0);
    i2 = HEAP16[i8 >> 1] | 0;
    i3 = HEAP32[i20 + 2908 + (i5 << 2) >> 2] | 0;
    i4 = HEAP16[i22 + (i3 << 2) >> 1] | 0;
    if ((i2 & 65535) < (i4 & 65535)) break L55;
    if (i2 << 16 >> 16 == i4 << 16 >> 16) if ((HEAPU8[i9 >> 0] | 0) <= (HEAPU8[i20 + 5208 + i3 >> 0] | 0)) break L55;
    HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i3;
    i7 = i5 << 1;
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i7 | 0) > (i2 | 0)) {
     i1 = i5;
     break;
    } else i1 = i5;
   }
  } while (0);
  HEAP32[i20 + 2908 + (i1 << 2) >> 2] = i12;
  i12 = i12 + 1 | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 } while ((i1 | 0) > 1);
 i12 = HEAP32[i13 >> 2] | 0;
 i13 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
 HEAP32[i18 >> 2] = i13;
 HEAP32[i20 + 2908 + (i13 << 2) >> 2] = i12;
 i13 = HEAP32[i15 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = HEAP32[i7 + 8 >> 2] | 0;
 i7 = HEAP32[i7 + 16 >> 2] | 0;
 i1 = i20 + 2876 | 0;
 i2 = i1 + 32 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP16[i13 + (HEAP32[i20 + 2908 + (i1 << 2) >> 2] << 2) + 2 >> 1] = 0;
 i1 = i1 + 1 | 0;
 L71 : do if ((i1 | 0) < 573) {
  i11 = i20 + 5800 | 0;
  i6 = i20 + 5804 | 0;
  if (!i8) {
   i4 = i1;
   i1 = 0;
   do {
    i5 = HEAP32[i20 + 2908 + (i4 << 2) >> 2] | 0;
    i18 = i13 + (i5 << 2) + 2 | 0;
    i3 = HEAPU16[i13 + (HEAPU16[i18 >> 1] << 2) + 2 >> 1] | 0;
    i17 = (i3 | 0) < (i7 | 0);
    i3 = i17 ? i3 + 1 | 0 : i7;
    i1 = (i17 & 1 ^ 1) + i1 | 0;
    HEAP16[i18 >> 1] = i3;
    if ((i5 | 0) <= (i12 | 0)) {
     i18 = i20 + 2876 + (i3 << 1) | 0;
     HEAP16[i18 >> 1] = (HEAP16[i18 >> 1] | 0) + 1 << 16 >> 16;
     if ((i5 | 0) < (i10 | 0)) i2 = 0; else i2 = HEAP32[i9 + (i5 - i10 << 2) >> 2] | 0;
     i18 = Math_imul(HEAPU16[i13 + (i5 << 2) >> 1] | 0, i2 + i3 | 0) | 0;
     HEAP32[i11 >> 2] = i18 + (HEAP32[i11 >> 2] | 0);
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 573);
  } else {
   i4 = i1;
   i1 = 0;
   do {
    i5 = HEAP32[i20 + 2908 + (i4 << 2) >> 2] | 0;
    i18 = i13 + (i5 << 2) + 2 | 0;
    i3 = HEAPU16[i13 + (HEAPU16[i18 >> 1] << 2) + 2 >> 1] | 0;
    i17 = (i3 | 0) < (i7 | 0);
    i3 = i17 ? i3 + 1 | 0 : i7;
    i1 = (i17 & 1 ^ 1) + i1 | 0;
    HEAP16[i18 >> 1] = i3;
    if ((i5 | 0) <= (i12 | 0)) {
     i18 = i20 + 2876 + (i3 << 1) | 0;
     HEAP16[i18 >> 1] = (HEAP16[i18 >> 1] | 0) + 1 << 16 >> 16;
     if ((i5 | 0) < (i10 | 0)) i2 = 0; else i2 = HEAP32[i9 + (i5 - i10 << 2) >> 2] | 0;
     i18 = HEAPU16[i13 + (i5 << 2) >> 1] | 0;
     i17 = Math_imul(i18, i2 + i3 | 0) | 0;
     HEAP32[i11 >> 2] = i17 + (HEAP32[i11 >> 2] | 0);
     i18 = Math_imul((HEAPU16[i8 + (i5 << 2) + 2 >> 1] | 0) + i2 | 0, i18) | 0;
     HEAP32[i6 >> 2] = i18 + (HEAP32[i6 >> 2] | 0);
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 573);
  }
  if (i1 | 0) {
   i6 = i20 + 2876 + (i7 << 1) | 0;
   while (1) {
    i3 = i7;
    while (1) {
     i2 = i3 + -1 | 0;
     i4 = i20 + 2876 + (i2 << 1) | 0;
     i5 = HEAP16[i4 >> 1] | 0;
     if (!(i5 << 16 >> 16)) i3 = i2; else break;
    }
    HEAP16[i4 >> 1] = i5 + -1 << 16 >> 16;
    i2 = i20 + 2876 + (i3 << 1) | 0;
    HEAP16[i2 >> 1] = (HEAPU16[i2 >> 1] | 0) + 2;
    i2 = (HEAP16[i6 >> 1] | 0) + -1 << 16 >> 16;
    HEAP16[i6 >> 1] = i2;
    if ((i1 | 0) > 2) i1 = i1 + -2 | 0; else break;
   }
   if (i7 | 0) {
    i1 = 573;
    while (1) {
     i6 = i7 & 65535;
     if (i2 << 16 >> 16) {
      i5 = i2 & 65535;
      do {
       do {
        i1 = i1 + -1 | 0;
        i2 = HEAP32[i20 + 2908 + (i1 << 2) >> 2] | 0;
       } while ((i2 | 0) > (i12 | 0));
       i3 = i13 + (i2 << 2) + 2 | 0;
       i4 = HEAPU16[i3 >> 1] | 0;
       if ((i7 | 0) != (i4 | 0)) {
        i18 = Math_imul(HEAPU16[i13 + (i2 << 2) >> 1] | 0, i7 - i4 | 0) | 0;
        HEAP32[i11 >> 2] = i18 + (HEAP32[i11 >> 2] | 0);
        HEAP16[i3 >> 1] = i6;
       }
       i5 = i5 + -1 | 0;
      } while ((i5 | 0) != 0);
     }
     i2 = i7 + -1 | 0;
     if (!i2) break L71;
     i7 = i2;
     i2 = HEAP16[i20 + 2876 + (i2 << 1) >> 1] | 0;
    }
   }
  }
 } while (0);
 i1 = 0;
 i2 = 1;
 do {
  i1 = (HEAPU16[i20 + 2876 + (i2 + -1 << 1) >> 1] | 0) + (i1 & 65534) << 1;
  HEAP16[i21 + (i2 << 1) >> 1] = i1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 16);
 if ((i19 | 0) < 0) {
  STACKTOP = i23;
  return;
 } else i4 = 0;
 while (1) {
  i20 = HEAP16[i22 + (i4 << 2) + 2 >> 1] | 0;
  i1 = i20 & 65535;
  if (i20 << 16 >> 16) {
   i2 = i21 + (i1 << 1) | 0;
   i3 = HEAP16[i2 >> 1] | 0;
   HEAP16[i2 >> 1] = i3 + 1 << 16 >> 16;
   i2 = 0;
   i3 = i3 & 65535;
   while (1) {
    i2 = i2 | i3 & 1;
    if ((i1 | 0) > 1) {
     i2 = i2 << 1;
     i1 = i1 + -1 | 0;
     i3 = i3 >>> 1;
    } else break;
   }
   HEAP16[i22 + (i4 << 2) >> 1] = i2;
  }
  if ((i4 | 0) == (i19 | 0)) break; else i4 = i4 + 1 | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN7mecanim9animation9GetCycleXERKN4math4trsXES4_S4_if(i1, i2, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 40 | 0;
 i8 = i9;
 if (!i5) {
  i8 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i5;
  i5 = HEAP32[i2 + 16 >> 2] | 0;
  i8 = HEAP32[i2 + 20 >> 2] | 0;
  i7 = HEAP32[i2 + 24 >> 2] | 0;
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = i5;
  HEAP32[i1 + 20 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = i7;
  i7 = HEAP32[i2 + 32 >> 2] | 0;
  i8 = HEAP32[i2 + 36 >> 2] | 0;
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 32 >> 2] = i7;
  HEAP32[i1 + 36 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i29 = (i5 >>> 31 | 0) != (f6 < Math_fround(0.0) | 0);
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f39 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f41 = Math_fround(HEAPF32[i3 >> 2]);
  f40 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f32 = i29 ? f19 : f41;
  f17 = i29 ? f39 : f40;
  f24 = i29 ? f35 : f36;
  i47 = HEAP32[i3 + 12 >> 2] | 0;
  i46 = HEAP32[i4 + 12 >> 2] | 0;
  i49 = HEAP32[i3 + 16 >> 2] | 0;
  i48 = HEAP32[i4 + 16 >> 2] | 0;
  i43 = HEAP32[i3 + 20 >> 2] | 0;
  i42 = HEAP32[i4 + 20 >> 2] | 0;
  i45 = HEAP32[i3 + 24 >> 2] | 0;
  i44 = HEAP32[i4 + 24 >> 2] | 0;
  f23 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f27 = Math_fround(HEAPF32[i3 + 36 >> 2]);
  f23 = i29 ? f22 : f23;
  f21 = i29 ? f20 : f21;
  f25 = i29 ? f27 : f25;
  f27 = (HEAP32[tempDoublePtr >> 2] = i29 ? i44 : i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i50 = Math_fround(Math_abs(Math_fround(f23))) < Math_fround(9.99999971e-10);
  i3 = Math_fround(Math_abs(Math_fround(f21))) < Math_fround(9.99999971e-10);
  i4 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(9.99999971e-10);
  f20 = Math_fround(Math_fround(1.0) / f23);
  f20 = i50 ? Math_fround(1.0) : f20;
  f22 = Math_fround(Math_fround(1.0) / f21);
  f22 = i3 ? Math_fround(1.0) : f22;
  f26 = Math_fround(Math_fround(1.0) / f25);
  f26 = i4 ? Math_fround(1.0) : f26;
  f34 = Math_fround(-f32);
  f16 = Math_fround(-f17);
  f10 = Math_fround(-f24);
  f28 = (HEAP32[tempDoublePtr >> 2] = (i29 ? i48 : i49) ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = (HEAP32[tempDoublePtr >> 2] = (i29 ? i46 : i47) ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = (i29 ? i42 : i43) ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f28 * Math_fround(-2.0));
  f12 = Math_fround(f28 * Math_fround(2.0));
  f33 = Math_fround(f11 * f27);
  f15 = Math_fround(f13 * Math_fround(2.0));
  f31 = Math_fround(f13 * Math_fround(-2.0));
  f37 = Math_fround(f27 * f31);
  f6 = Math_fround(f14 * Math_fround(-2.0));
  f38 = Math_fround(f14 * Math_fround(2.0));
  f18 = Math_fround(f6 * f27);
  f32 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f28 * f11) - Math_fround(f13 * f15)) * f34) - f32) + Math_fround(Math_fround(Math_fround(f37 - Math_fround(f6 * f28)) * f16) + Math_fround(Math_fround(Math_fround(f38 * f13) - f33) * f10))) * f20));
  f11 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f14 * f12) - f37) * f34) - f17) + Math_fround(Math_fround(Math_fround(Math_fround(f13 * f31) - Math_fround(f14 * f38)) * f16) + Math_fround(Math_fround(f18 - Math_fround(f11 * f13)) * f10))) * f22));
  f16 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f33 - Math_fround(f14 * f31)) * f34) - f24) + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f6) - Math_fround(f28 * f12)) * f10) + Math_fround(Math_fround(Math_fround(f28 * f15) - f18) * f16))) * f26));
  f18 = (HEAP32[tempDoublePtr >> 2] = i29 ? i49 : i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = i29 ? i47 : i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i29 ? i45 : i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i29 ? i43 : i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f18 * Math_fround(-2.0));
  f24 = Math_fround(f18 * Math_fround(2.0));
  f34 = Math_fround(f6 * f10);
  f31 = Math_fround(f12 * Math_fround(2.0));
  f33 = Math_fround(f12 * Math_fround(-2.0));
  f38 = Math_fround(f33 * f10);
  f17 = Math_fround(f15 * Math_fround(-2.0));
  f37 = Math_fround(f15 * Math_fround(2.0));
  f30 = Math_fround(f17 * f10);
  f19 = Math_fround((i29 ? f41 : f19) + Math_fround(Math_fround(f32 + Math_fround(Math_fround(Math_fround(f18 * f6) - Math_fround(f12 * f31)) * f32)) + Math_fround(Math_fround(Math_fround(f38 - Math_fround(f17 * f18)) * f11) + Math_fround(Math_fround(Math_fround(f37 * f12) - f34) * f16))));
  f6 = Math_fround((i29 ? f40 : f39) + Math_fround(Math_fround(f11 + Math_fround(Math_fround(Math_fround(f15 * f24) - f38) * f32)) + Math_fround(Math_fround(Math_fround(Math_fround(f12 * f33) - Math_fround(f15 * f37)) * f11) + Math_fround(Math_fround(f30 - Math_fround(f6 * f12)) * f16))));
  f16 = Math_fround((i29 ? f36 : f35) + Math_fround(Math_fround(Math_fround(Math_fround(f34 - Math_fround(f15 * f33)) * f32) + f16) + Math_fround(Math_fround(Math_fround(Math_fround(f18 * f31) - f30) * f11) + Math_fround(Math_fround(Math_fround(f15 * f17) - Math_fround(f18 * f24)) * f16))));
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f18) - Math_fround(f13 * f10)) - Math_fround(f12 * f27)) - Math_fround(f15 * f28));
  f17 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f10) - Math_fround(f15 * f14)) - Math_fround(f12 * f13)) - Math_fround(f18 * f28));
  f11 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f12) - Math_fround(f18 * f13)) - Math_fround(f14 * f10)) - Math_fround(f15 * f27));
  f27 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f28 * f10)) - Math_fround(f18 * f27));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f20 = Math_fround(f23 * f20);
  f22 = Math_fround(f21 * f22);
  f26 = Math_fround(f25 * f26);
  HEAPF32[i8 >> 2] = f19;
  HEAPF32[i8 + 4 >> 2] = f6;
  HEAPF32[i8 + 8 >> 2] = f16;
  HEAP32[i8 + 12 >> 2] = i29 ^ -2147483648;
  HEAP32[i8 + 16 >> 2] = i3;
  HEAP32[i8 + 20 >> 2] = i4 ^ -2147483648;
  HEAPF32[i8 + 24 >> 2] = f17;
  HEAPF32[i8 + 28 >> 2] = f20;
  HEAPF32[i8 + 32 >> 2] = f22;
  HEAPF32[i8 + 36 >> 2] = f26;
  __ZN7mecanim9animation11xformPrePowERKN4math4trsXEi(i7, i8, (i5 | 0) > -1 ? i5 : 0 - i5 | 0);
  f26 = Math_fround(HEAPF32[i2 >> 2]);
  f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f17 = Math_fround(HEAPF32[i7 + 28 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + 32 >> 2]);
  f6 = Math_fround(HEAPF32[i7 + 36 >> 2]);
  f26 = Math_fround(f26 * f17);
  f22 = Math_fround(f22 * f16);
  f20 = Math_fround(f20 * f6);
  f19 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f25 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i7 + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f27 = Math_fround(f19 * Math_fround(-2.0));
  f11 = Math_fround(f19 * Math_fround(2.0));
  f24 = Math_fround(f27 * f21);
  f18 = Math_fround(f23 * Math_fround(2.0));
  f10 = Math_fround(f23 * Math_fround(-2.0));
  f28 = Math_fround(f21 * f10);
  f12 = Math_fround(f25 * Math_fround(-2.0));
  f14 = Math_fround(f25 * Math_fround(2.0));
  f13 = Math_fround(f21 * f12);
  f15 = Math_fround(Math_fround(f26 + Math_fround(f26 * Math_fround(Math_fround(f19 * f27) - Math_fround(f23 * f18)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f14 * f23) - f24)) + Math_fround(f22 * Math_fround(f28 - Math_fround(f19 * f12)))));
  f14 = Math_fround(Math_fround(f22 + Math_fround(f26 * Math_fround(Math_fround(f25 * f11) - f28))) + Math_fround(Math_fround(f20 * Math_fround(f13 - Math_fround(f27 * f23))) + Math_fround(f22 * Math_fround(Math_fround(f23 * f10) - Math_fround(f25 * f14)))));
  f13 = Math_fround(Math_fround(f20 + Math_fround(f26 * Math_fround(f24 - Math_fround(f25 * f10)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f25 * f12) - Math_fround(f19 * f11))) + Math_fround(f22 * Math_fround(Math_fround(f19 * f18) - f13))));
  f18 = Math_fround(HEAPF32[i7 >> 2]);
  f22 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f15 = Math_fround(f18 + f15);
  f14 = Math_fround(f22 + f14);
  f13 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) + f13);
  f22 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f18 = Math_fround(f19 * f22);
  f11 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f12 = Math_fround(f21 * f11);
  f20 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f10 = Math_fround(f23 * f20);
  f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f21 * f24)) - Math_fround(f23 * f11)) - Math_fround(f25 * f20));
  f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f25 * f22)) - Math_fround(f23 * f24)) - Math_fround(f19 * f20));
  f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f19 * f24)) - Math_fround(f21 * f22)) - Math_fround(f25 * f11));
  f11 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f20)) - Math_fround(f19 * f11));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f11 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f10 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f11 = Math_fround(f17 * f11);
  f10 = Math_fround(f16 * f10);
  f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 36 >> 2]));
  HEAPF32[i1 >> 2] = f15;
  HEAPF32[i1 + 4 >> 2] = f14;
  HEAPF32[i1 + 8 >> 2] = f13;
  HEAP32[i1 + 12 >> 2] = i5 ^ -2147483648;
  HEAP32[i1 + 16 >> 2] = i7;
  HEAP32[i1 + 20 >> 2] = i8 ^ -2147483648;
  HEAPF32[i1 + 24 >> 2] = f12;
  HEAPF32[i1 + 28 >> 2] = f11;
  HEAPF32[i1 + 32 >> 2] = f10;
  HEAPF32[i1 + 36 >> 2] = f6;
  STACKTOP = i9;
  return;
 }
}

function __ZNK24dtObstacleAvoidanceQuery13processSampleEPKfS1_S1_S1_f(i24, i23, i22, i25, i26, f1) {
 i24 = i24 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f27 = f0, i28 = 0;
 f1 = Math_fround(HEAPF32[i24 + 10440 >> 2]);
 i11 = HEAP32[i24 + 10452 >> 2] | 0;
 if ((i11 | 0) > 0) {
  f17 = Math_fround(HEAPF32[i25 >> 2]);
  f10 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i23 >> 2]);
  f9 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i22 >> 2]);
  f15 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  i5 = 0;
  do {
   f3 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 20 >> 2]);
   f2 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 8 >> 2]);
   f4 = Math_fround(Math_fround(1.0) - f3);
   f2 = Math_fround(f16 - Math_fround(Math_fround(f4 * f17) + Math_fround(f3 * f2)));
   f3 = Math_fround(f9 - Math_fround(Math_fround(f4 * f10) + Math_fround(f3 * Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 12 >> 2]))));
   f4 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 16 >> 2]);
   f6 = Math_fround(HEAPF32[i24 + (i5 * 24 | 0) >> 2]);
   f6 = Math_fround(f6 - f18);
   f7 = Math_fround(Math_fround(HEAPF32[i24 + (i5 * 24 | 0) + 4 >> 2]) - f15);
   f8 = Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3));
   if (!(f8 < Math_fround(.0000999999974))) {
    f3 = Math_fround(Math_fround(f2 * f6) + Math_fround(f3 * f7));
    f2 = Math_fround(Math_fround(f3 * f3) - Math_fround(f8 * Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) - Math_fround(f4 * f4))));
    if (!(f2 < Math_fround(0.0))) {
     f20 = Math_fround(Math_fround(1.0) / f8);
     f21 = Math_fround(Math_sqrt(Math_fround(f2)));
     f2 = Math_fround(f20 * Math_fround(f3 - f21));
     f3 = Math_fround(f20 * Math_fround(f3 + f21));
     if (f2 < Math_fround(0.0) & f3 > Math_fround(0.0)) f2 = Math_fround(Math_fround(f2 * Math_fround(-2.0)) / f3);
     i13 = f2 < f1 & f2 >= Math_fround(0.0);
     f1 = i13 ? f2 : f1;
    }
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i11 | 0));
 }
 i13 = HEAP32[i24 + 10460 >> 2] | 0;
 if ((i13 | 0) > 0) {
  f21 = Math_fround(HEAPF32[i25 >> 2]);
  f19 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i23 >> 2]);
  f18 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  i12 = i22 + 4 | 0;
  i11 = 0;
  do {
   f17 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 48 >> 2]);
   f16 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 16 >> 2]);
   f7 = Math_fround(Math_fround(1.0) - f17);
   f16 = Math_fround(f20 - Math_fround(Math_fround(f7 * f21) + Math_fround(f17 * f16)));
   f17 = Math_fround(f18 - Math_fround(Math_fround(f7 * f19) + Math_fround(f17 * Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 20 >> 2]))));
   i5 = i24 + 4992 + (i11 * 52 | 0) + 24 | 0;
   f7 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 40 >> 2]);
   f15 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 44 >> 2]);
   if (f7 < Math_fround(9.99999997e-07)) {
    f2 = Math_fround(HEAPF32[i22 >> 2]);
    f3 = Math_fround(HEAPF32[i12 >> 2]);
    f4 = Math_fround(HEAPF32[i5 >> 2]);
    f2 = Math_fround(f4 - f2);
    f3 = Math_fround(Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 28 >> 2]) - f3);
    f4 = Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17));
    if (!(f4 < Math_fround(.0000999999974))) {
     f6 = Math_fround(Math_fround(f16 * f2) + Math_fround(f17 * f3));
     f2 = Math_fround(Math_fround(f6 * f6) - Math_fround(f4 * Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) - Math_fround(f15 * f15))));
     if (!(f2 < Math_fround(0.0))) {
      f15 = Math_fround(Math_fround(1.0) / f4);
      f2 = Math_fround(Math_sqrt(Math_fround(f2)));
      f3 = Math_fround(f15 * Math_fround(f6 + f2));
      f2 = Math_fround(f15 * Math_fround(f6 - f2));
      i14 = 27;
     }
    }
   } else {
    f9 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 32 >> 2]);
    f6 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 36 >> 2]);
    f10 = Math_fround(-f6);
    f3 = Math_fround(HEAPF32[i5 >> 2]);
    f2 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 28 >> 2]);
    f8 = Math_fround(Math_fround(f3 * f10) + Math_fround(f9 * f2));
    f4 = Math_fround(Math_fround(f16 * f9) + Math_fround(f17 * f6));
    do if (Math_fround(Math_abs(Math_fround(f4))) > Math_fround(9.99999997e-07)) {
     f27 = Math_fround(f9 * Math_fround(HEAPF32[i22 >> 2]));
     f4 = Math_fround(Math_fround(1.0) / f4);
     f2 = Math_fround(Math_fround(f27 + Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2]))) - Math_fround(Math_fround(f9 * f3) + Math_fround(f6 * f2)));
     f3 = Math_fround(-Math_fround(f4 * Math_fround(f7 + f2)));
     f2 = Math_fround(-Math_fround(f4 * Math_fround(f2 - f7)));
     if (f4 > Math_fround(0.0)) {
      i5 = f3 < Math_fround(-3402823469999999843913219.0e14);
      f27 = i5 ? Math_fround(-3402823469999999843913219.0e14) : f3;
      i5 = f2 > Math_fround(3402823469999999843913219.0e14);
      f3 = i5 ? Math_fround(3402823469999999843913219.0e14) : f2;
      i5 = 1;
      f2 = f27;
      break;
     } else {
      i5 = f2 < Math_fround(-3402823469999999843913219.0e14);
      f2 = i5 ? Math_fround(-3402823469999999843913219.0e14) : f2;
      i5 = f3 > Math_fround(3402823469999999843913219.0e14);
      f3 = i5 ? Math_fround(3402823469999999843913219.0e14) : f3;
      i5 = 1;
      break;
     }
    } else {
     f3 = Math_fround(3402823469999999843913219.0e14);
     i5 = 0;
     f2 = Math_fround(-3402823469999999843913219.0e14);
    } while (0);
    f4 = Math_fround(Math_fround(f17 * f9) + Math_fround(f16 * f10));
    do if (Math_fround(Math_abs(Math_fround(f4))) > Math_fround(9.99999997e-07)) {
     f6 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f10);
     f27 = Math_fround(Math_fround(1.0) / f4);
     f4 = Math_fround(Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i12 >> 2]))) - f8);
     f6 = Math_fround(-Math_fround(f27 * Math_fround(f15 + f4)));
     f4 = Math_fround(-Math_fround(f27 * Math_fround(f4 - f15)));
     if (f27 > Math_fround(0.0)) {
      f3 = f3 < f4 ? f3 : f4;
      i5 = 1;
      f2 = f2 > f6 ? f2 : f6;
      break;
     } else {
      f3 = f3 < f6 ? f3 : f6;
      i5 = 1;
      f2 = f2 > f4 ? f2 : f4;
      break;
     }
    } while (0);
    if (!(f3 < f2 | (i5 | 0) == 0)) i14 = 27;
   }
   if ((i14 | 0) == 27) {
    i14 = 0;
    if (f2 < Math_fround(0.0) & f3 > Math_fround(0.0)) f8 = Math_fround(Math_fround(f2 * Math_fround(-2.0)) / f3); else f8 = f2;
    f3 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) >> 2]);
    f2 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 8 >> 2]);
    f4 = Math_fround(f4 - f3);
    f6 = Math_fround(Math_fround(HEAPF32[i24 + 4992 + (i11 * 52 | 0) + 12 >> 2]) - f2);
    f7 = Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6));
    if (f7 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
     f17 = Math_fround(f17 * f8);
     f17 = Math_fround(f17 + Math_fround(HEAPF32[i12 >> 2]));
     f27 = Math_fround(f16 * f8);
     f2 = Math_fround(Math_fround(Math_fround(f6 * Math_fround(f17 - f2)) + Math_fround(f4 * Math_fround(Math_fround(f27 + Math_fround(HEAPF32[i22 >> 2])) - f3))) / f7);
     i5 = f2 < Math_fround(0.0);
     i28 = f2 > Math_fround(1.0);
     f2 = i28 ? Math_fround(1.0) : f2;
     f2 = i5 ? Math_fround(0.0) : f2;
    }
    f27 = Math_fround(Math_fround(1.0) - Math_fround(f2 * Math_fround(2.0)));
    f27 = Math_fround(f8 * Math_fround(Math_fround(Math_fround(f27 * f27) * Math_fround(.5)) + Math_fround(.5)));
    i28 = f27 < f1 & f27 >= Math_fround(0.0);
    f1 = i28 ? f27 : f1;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i13 | 0));
 }
 i14 = HEAP32[i24 + 10456 >> 2] | 0;
 L44 : do if ((i14 | 0) > 0) {
  i12 = i22 + 4 | 0;
  i13 = i23 + 4 | 0;
  i11 = 0;
  f3 = f1;
  do {
   i5 = i24 + 2496 + (i11 * 24 | 0) | 0;
   if (!(HEAP8[i24 + 2496 + (i11 * 24 | 0) + 20 >> 0] | 0)) {
    f27 = Math_fround(HEAPF32[i22 >> 2]);
    f4 = Math_fround(HEAPF32[i12 >> 2]);
    f1 = Math_fround(HEAPF32[i23 >> 2]);
    f2 = Math_fround(HEAPF32[i13 >> 2]);
    f9 = Math_fround(HEAPF32[i5 >> 2]);
    f10 = Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 4 >> 2]);
    f6 = Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 8 >> 2]);
    f6 = Math_fround(f6 - f9);
    f7 = Math_fround(Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 12 >> 2]) - f10);
    f9 = Math_fround(f27 - f9);
    f10 = Math_fround(f4 - f10);
    f4 = Math_fround(Math_fround(f2 * f6) - Math_fround(f1 * f7));
    if (Math_fround(Math_abs(Math_fround(f4))) < Math_fround(9.99999997e-07)) f4 = Math_fround(3402823469999999843913219.0e14); else {
     f8 = Math_fround(Math_fround(1.0) / f4);
     f4 = Math_fround(Math_fround(Math_fround(f9 * f7) - Math_fround(f10 * f6)) * f8);
     if (f4 < Math_fround(0.0)) f4 = Math_fround(3402823469999999843913219.0e14); else {
      f27 = Math_fround(Math_fround(Math_fround(f2 * f9) - Math_fround(f1 * f10)) * f8);
      i28 = f27 < Math_fround(0.0) | f27 > Math_fround(1.0);
      f4 = i28 ? Math_fround(3402823469999999843913219.0e14) : f4;
     }
    }
    f27 = Math_fround(f4 / Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 16 >> 2]));
    f3 = f3 < f27 ? f3 : f27;
   } else {
    f1 = Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 8 >> 2]);
    f21 = Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 12 >> 2]);
    f27 = Math_fround(HEAPF32[i5 >> 2]);
    f27 = Math_fround(f1 - f27);
    f21 = Math_fround(f21 - Math_fround(HEAPF32[i24 + 2496 + (i11 * 24 | 0) + 4 >> 2]));
    f1 = Math_fround(HEAPF32[i23 >> 2]);
    f2 = Math_fround(HEAPF32[i13 >> 2]);
    if (!(Math_fround(Math_fround(f21 * f1) - Math_fround(f27 * f2)) > Math_fround(0.0))) {
     f3 = Math_fround(0.0);
     break L44;
    }
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) < (i14 | 0));
 } else {
  f27 = Math_fround(HEAPF32[i23 >> 2]);
  f3 = f1;
  f2 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f1 = f27;
 } while (0);
 f18 = Math_fround(HEAPF32[i24 + 10404 >> 2]);
 f19 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 - f1);
 f20 = Math_fround(Math_fround(HEAPF32[i26 + 4 >> 2]) - f2);
 f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20))));
 f19 = Math_fround(HEAPF32[i24 + 10448 >> 2]);
 f20 = Math_fround(f18 * Math_fround(f20 * f19));
 f18 = Math_fround(HEAPF32[i24 + 10408 >> 2]);
 f27 = Math_fround(HEAPF32[i25 >> 2]);
 f27 = Math_fround(f27 - f1);
 f21 = Math_fround(Math_fround(HEAPF32[i25 + 4 >> 2]) - f2);
 f21 = Math_fround(f18 * Math_fround(f19 * Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(f21 * f21))))));
 f27 = Math_fround(HEAPF32[i24 + 10412 >> 2]);
 return Math_fround(Math_fround(f20 + f21) + Math_fround(f27 * Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i24 + 10444 >> 2])) + Math_fround(.100000001)))));
}

function __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i11, i12, i1, i3, i2, i4, i5) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 if (i5) {
  f16 = Math_fround(HEAPF32[i4 + 44 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 48 >> 2]);
  f16 = Math_fround(f16 * Math_fround(-2.0));
  f18 = Math_fround(f18 * Math_fround(-2.0));
  f6 = Math_fround(Math_fround(HEAPF32[i4 + 52 >> 2]) * Math_fround(-2.0));
  f14 = Math_fround(HEAPF32[i4 + 40 >> 2]);
  f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
  f8 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f15 = Math_fround(f16 * f8);
  f13 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f13));
  f9 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f6 * f9));
  f10 = Math_fround(-f8);
  f22 = Math_fround(-f13);
  f21 = Math_fround(-f9);
  f19 = Math_fround(Math_fround(Math_fround(f8 * f15) + Math_fround(Math_fround(f16 * f20) - Math_fround(f14 * Math_fround(Math_fround(f6 * f13) - Math_fround(f18 * f9))))) * Math_fround(2.0));
  f17 = Math_fround(Math_fround(Math_fround(f13 * f15) + Math_fround(Math_fround(f18 * f20) - Math_fround(f14 * Math_fround(Math_fround(f16 * f9) - Math_fround(f6 * f8))))) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f20) - Math_fround(f14 * Math_fround(Math_fround(f18 * f8) - Math_fround(f16 * f13)))) + Math_fround(f9 * f15)) * Math_fround(2.0));
  f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f13 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
  f16 = Math_fround(HEAPF32[i2 >> 2]);
  f8 = Math_fround(f16 * f19);
  f18 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f18 * f17));
  f20 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f8 = Math_fround(Math_fround(f20 * f15) + f8);
  f6 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f13 * f19) + Math_fround(f9 * Math_fround(Math_fround(f18 * f15) - Math_fround(f20 * f17)))));
  f7 = Math_fround(Math_fround(f18 * f8) + Math_fround(Math_fround(f13 * f17) + Math_fround(f9 * Math_fround(Math_fround(f20 * f19) - Math_fround(f16 * f15)))));
  f8 = Math_fround(Math_fround(Math_fround(f13 * f15) + Math_fround(f9 * Math_fround(Math_fround(f16 * f17) - Math_fround(f18 * f19)))) + Math_fround(f20 * f8));
  f6 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f6);
  f7 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f7);
  f19 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f10) + Math_fround(f14 * f16)) + Math_fround(f18 * f21)) - Math_fround(f20 * f22));
  f17 = Math_fround(Math_fround(Math_fround(f20 * f10) + Math_fround(Math_fround(f9 * f22) + Math_fround(f14 * f18))) - Math_fround(f16 * f21));
  f15 = Math_fround(Math_fround(Math_fround(f16 * f22) + Math_fround(Math_fround(f9 * f21) + Math_fround(f14 * f20))) - Math_fround(f18 * f10));
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f9) - Math_fround(f16 * f10)) - Math_fround(f18 * f22)) - Math_fround(f20 * f21));
  f6 = Math_fround(f6 * Math_fround(2.0));
  f7 = Math_fround(f7 * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f8) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f22 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f10 = Math_fround(f18 * f6);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f16 * f7));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f10 = Math_fround(Math_fround(f9 * f8) + f10);
  f14 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f22 * f6) + Math_fround(f20 * Math_fround(Math_fround(f16 * f8) - Math_fround(f9 * f7)))));
  f13 = Math_fround(Math_fround(f16 * f10) + Math_fround(Math_fround(f22 * f7) + Math_fround(f20 * Math_fround(Math_fround(f9 * f6) - Math_fround(f18 * f8)))));
  f10 = Math_fround(Math_fround(Math_fround(f22 * f8) + Math_fround(f20 * Math_fround(Math_fround(f18 * f7) - Math_fround(f16 * f6)))) + Math_fround(f9 * f10));
  f14 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f14);
  f13 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f13);
  f10 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f10);
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * f18)) + Math_fround(f15 * f16)) - Math_fround(f17 * f9));
  f7 = Math_fround(Math_fround(Math_fround(f19 * f9) + Math_fround(Math_fround(f17 * f20) + Math_fround(f21 * f16))) - Math_fround(f15 * f18));
  f8 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(Math_fround(f20 * f15) + Math_fround(f21 * f9))) - Math_fround(f19 * f16));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f16)) - Math_fround(f15 * f9));
  HEAPF32[i12 >> 2] = f6;
  i1 = i12 + 4 | 0;
  HEAPF32[i1 >> 2] = f7;
  i2 = i12 + 8 | 0;
  HEAPF32[i2 >> 2] = f8;
  i3 = i12 + 12 | 0;
  HEAPF32[i3 >> 2] = f9;
  HEAPF32[i12 + 16 >> 2] = f14;
  HEAPF32[i12 + 20 >> 2] = f13;
  HEAPF32[i12 + 24 >> 2] = f10;
  f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)) + Math_fround(f9 * f9))));
  if (!(f10 != Math_fround(0.0))) return;
  f22 = Math_fround(Math_fround(1.0) / f10);
  HEAPF32[i12 >> 2] = Math_fround(f6 * f22);
  HEAPF32[i1 >> 2] = Math_fround(f7 * f22);
  HEAPF32[i2 >> 2] = Math_fround(f8 * f22);
  HEAPF32[i3 >> 2] = Math_fround(f9 * f22);
  return;
 } else {
  f24 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f24 = Math_fround(f24 * Math_fround(-2.0));
  f10 = Math_fround(f10 * Math_fround(-2.0));
  f13 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(-2.0));
  f26 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f7 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
  f25 = Math_fround(HEAPF32[i4 >> 2]);
  f21 = Math_fround(f24 * f25);
  f23 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f10 * f23));
  f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f13 * f6));
  f17 = Math_fround(Math_fround(f25 * f21) + Math_fround(Math_fround(f24 * f7) - Math_fround(f26 * Math_fround(Math_fround(f13 * f23) - Math_fround(f10 * f6)))));
  f19 = Math_fround(Math_fround(f23 * f21) + Math_fround(Math_fround(f10 * f7) - Math_fround(f26 * Math_fround(Math_fround(f24 * f6) - Math_fround(f13 * f25)))));
  f21 = Math_fround(Math_fround(Math_fround(f13 * f7) - Math_fround(f26 * Math_fround(Math_fround(f10 * f25) - Math_fround(f24 * f23)))) + Math_fround(f6 * f21));
  f24 = Math_fround(HEAPF32[i2 >> 2]);
  f10 = Math_fround(-f24);
  f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f13 = Math_fround(-f7);
  f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f8 = Math_fround(-f15);
  f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f17 = Math_fround(f17 - Math_fround(HEAPF32[i2 + 16 >> 2]));
  f19 = Math_fround(f19 - Math_fround(HEAPF32[i2 + 20 >> 2]));
  f17 = Math_fround(f17 * Math_fround(2.0));
  f19 = Math_fround(f19 * Math_fround(2.0));
  f21 = Math_fround(Math_fround(f21 - Math_fround(HEAPF32[i2 + 24 >> 2])) * Math_fround(2.0));
  f22 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
  f14 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f19 * f13)) + Math_fround(f21 * f8));
  f16 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f26 * f10) - Math_fround(f25 * f9))) - Math_fround(f23 * f15));
  f18 = Math_fround(Math_fround(Math_fround(f25 * f15) + Math_fround(Math_fround(f26 * f13) - Math_fround(f23 * f9))) - Math_fround(f6 * f24));
  f20 = Math_fround(Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f26 * f8) - Math_fround(f6 * f9))) - Math_fround(f25 * f7));
  f15 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f9) - Math_fround(f25 * f24)) - Math_fround(f23 * f7)) - Math_fround(f6 * f15));
  f6 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f22 * f17) + Math_fround(f9 * Math_fround(Math_fround(f21 * f13) - Math_fround(f19 * f8))))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(Math_fround(f22 * f19) + Math_fround(f9 * Math_fround(Math_fround(f17 * f8) - Math_fround(f21 * f10))))) * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f9 * Math_fround(Math_fround(f19 * f10) - Math_fround(f17 * f13)))) + Math_fround(f14 * f8)) * Math_fround(2.0));
  f14 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f13 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(f17 * f6);
  f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f19 * f7));
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f10 = Math_fround(Math_fround(f9 * f8) + f10);
  f21 = Math_fround(Math_fround(f17 * f10) + Math_fround(Math_fround(f13 * f6) + Math_fround(f14 * Math_fround(Math_fround(f19 * f8) - Math_fround(f9 * f7)))));
  f22 = Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(f13 * f7) + Math_fround(f14 * Math_fround(Math_fround(f9 * f6) - Math_fround(f17 * f8)))));
  f10 = Math_fround(Math_fround(Math_fround(f13 * f8) + Math_fround(f14 * Math_fround(Math_fround(f17 * f7) - Math_fround(f19 * f6)))) + Math_fround(f9 * f10));
  f21 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f21);
  f22 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f22);
  f10 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f10);
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) + Math_fround(f15 * f17)) + Math_fround(f20 * f19)) - Math_fround(f18 * f9));
  f7 = Math_fround(Math_fround(Math_fround(f16 * f9) + Math_fround(Math_fround(f14 * f18) + Math_fround(f15 * f19))) - Math_fround(f20 * f17));
  f8 = Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f14 * f20) + Math_fround(f15 * f9))) - Math_fround(f16 * f19));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f17)) - Math_fround(f18 * f19)) - Math_fround(f20 * f9));
  HEAPF32[i11 >> 2] = f6;
  i1 = i11 + 4 | 0;
  HEAPF32[i1 >> 2] = f7;
  i2 = i11 + 8 | 0;
  HEAPF32[i2 >> 2] = f8;
  i3 = i11 + 12 | 0;
  HEAPF32[i3 >> 2] = f9;
  HEAPF32[i11 + 16 >> 2] = f21;
  HEAPF32[i11 + 20 >> 2] = f22;
  HEAPF32[i11 + 24 >> 2] = f10;
  f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)) + Math_fround(f9 * f9))));
  if (!(f10 != Math_fround(0.0))) return;
  f26 = Math_fround(Math_fround(1.0) / f10);
  HEAPF32[i11 >> 2] = Math_fround(f6 * f26);
  HEAPF32[i1 >> 2] = Math_fround(f7 * f26);
  HEAPF32[i2 >> 2] = Math_fround(f8 * f26);
  HEAPF32[i3 >> 2] = Math_fround(f9 * f26);
  return;
 }
}

function __ZN7mecanim5human18HumanSetupColliderEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i26, i1) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i11 = i1 + 4 | 0;
 i10 = HEAP32[i26 + 76 >> 2] | 0;
 i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
 i12 = HEAP32[i26 + 80 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + (i12 * 40 | 0) >> 2]);
 f17 = Math_fround(HEAPF32[i11 + (i12 * 40 | 0) + 4 >> 2]);
 f16 = Math_fround(f15 - f16);
 f17 = Math_fround(f9 - f17);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i11 + (i12 * 40 | 0) + 8 >> 2]));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(Math_fround(f8 * f8) + Math_fround(0.0)))));
 i12 = HEAP32[i26 + 124 >> 2] | 0;
 i10 = HEAP32[i26 + 128 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i11 + (i12 * 40 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i11 + (i12 * 40 | 0) + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + (i12 * 40 | 0) + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i11 + (i10 * 40 | 0) + 4 >> 2]);
 f15 = Math_fround(f17 - f15);
 f14 = Math_fround(f16 - f14);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i11 + (i10 * 40 | 0) + 8 >> 2]));
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f9 * f9) + Math_fround(0.0)))));
 i10 = i26 + 40 | 0;
 i11 = i10;
 i12 = i26 + 68 | 0;
 i13 = i12;
 f14 = Math_fround(f9 * Math_fround(.100000001));
 f15 = Math_fround(f9 * Math_fround(.200000003));
 f16 = Math_fround(f9 * Math_fround(.400000006));
 f17 = Math_fround(f9 * Math_fround(.850000023));
 f18 = Math_fround(f8 * Math_fround(1.5));
 f19 = Math_fround(f8 * Math_fround(1.20000005));
 f20 = Math_fround(f8 * Math_fround(.800000011));
 f21 = Math_fround(f9 * Math_fround(.600000024));
 f22 = Math_fround(f9 * Math_fround(.449999988));
 f23 = Math_fround(f17 * Math_fround(-.25));
 f24 = Math_fround(f15 * Math_fround(-.5));
 f25 = Math_fround(f21 * Math_fround(.200000003));
 i7 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i26 + 72 + (i7 << 2) >> 2] | 0;
  if ((i2 | 0) > -1) {
   HEAP32[i26 + 264 + (i7 << 2) >> 2] = i1;
   i3 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
   i6 = i3 + 4 | 0;
   i2 = HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) > -1) {
    i6 = i3 + 16 | 0;
    i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i2 * 76 | 0) + 68 >> 2] | 0;
   } else i2 = 1065353216;
   i6 = (HEAP32[i12 >> 2] | 0) + i13 | 0;
   HEAP32[i6 + (i1 * 72 | 0) + 28 >> 2] = i2;
   f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(f5 * Math_fround(.5));
   i2 = i6 + (i1 * 72 | 0) | 0;
   HEAPF32[i2 >> 2] = f4;
   L8 : do switch (i7 | 0) {
   case 0:
    {
     HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 1;
     HEAPF32[i2 >> 2] = Math_fround(0.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f18;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f8;
     HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 0;
     HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 0;
     HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 0;
     break;
    }
   case 7:
    {
     HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 2;
     HEAPF32[i2 >> 2] = f4;
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f19;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f20;
     HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-7.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(7.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(7.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(7.0);
     break;
    }
   case 8:
    {
     HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 1;
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f9;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f21;
     HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-11.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(11.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(11.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(11.0);
     break;
    }
   case 9:
    {
     HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 4 >> 2] = Math_fround(f5 * Math_fround(.100000001));
     f5 = Math_fround(f5 * Math_fround(.330000013));
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f5;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f5;
     HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-10.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(10.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(20.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(5.0);
     break;
    }
   case 10:
    {
     HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 28 >> 2] = f21;
     HEAPF32[i6 + (i1 * 72 | 0) + 4 >> 2] = f25;
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f16;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f22;
     HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
     HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
     HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-5.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(8.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(20.0);
     HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(10.0);
     break;
    }
   default:
    {
     if ((i7 + -11 | 0) >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 0;
      HEAPF32[i2 >> 2] = f4;
      HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f14;
      HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f15;
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 0;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 0;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 0;
      break L8;
     }
     if ((i7 + -17 | 0) >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 1;
      HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f4;
      HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = Math_fround(f5 * Math_fround(.200000003));
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
      HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-30.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(30.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(40.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(25.0);
      break L8;
     }
     if ((i7 + -5 | 0) >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 1;
      HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f16;
      HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f17;
      HEAPF32[i6 + (i1 * 72 | 0) + 4 >> 2] = f23;
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
      HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-45.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(20.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(30.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(50.0);
      break L8;
     }
     if ((i7 + -19 | 0) >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 40 >> 2] = 0;
      HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f16;
      HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f15;
      HEAPF32[i6 + (i1 * 72 | 0) + 4 >> 2] = f24;
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 0;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 0;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 0;
      break L8;
     }
     i2 = i7 + -13 | 0;
     i3 = i6 + (i1 * 72 | 0) + 40 | 0;
     if (i2 >>> 0 >= 4) {
      i2 = i7 + -1 | 0;
      if (i2 >>> 0 >= 4) {
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       break L8;
      }
      HEAP32[i3 >> 2] = 4;
      f5 = Math_fround(f5 * Math_fround(.174999997));
      HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f5;
      HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f5;
      if ((i7 + -3 | 0) >>> 0 < 2) {
       HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
       HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 1;
       HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
       HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(0.0);
       HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(130.0);
       HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(0.0);
       HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(10.0);
       break L8;
      }
      if (i2 >>> 0 >= 2) break L8;
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
      HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-70.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(10.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(45.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(60.0);
      break L8;
     }
     HEAP32[i3 >> 2] = 4;
     f5 = Math_fround(f5 * Math_fround(.25));
     HEAPF32[i6 + (i1 * 72 | 0) + 36 >> 2] = f5;
     HEAPF32[i6 + (i1 * 72 | 0) + 32 >> 2] = f5;
     if (i2 >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
      HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-100.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(100.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(20.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(45.0);
      break L8;
     }
     if ((i7 + -15 | 0) >>> 0 < 2) {
      HEAP32[i6 + (i1 * 72 | 0) + 44 >> 2] = 2;
      HEAP32[i6 + (i1 * 72 | 0) + 48 >> 2] = 1;
      HEAP32[i6 + (i1 * 72 | 0) + 52 >> 2] = 2;
      switch (i7 | 0) {
      case 15:
       {
        HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(-130.0);
        HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(0.0);
        break;
       }
      case 16:
       {
        HEAPF32[i6 + (i1 * 72 | 0) + 56 >> 2] = Math_fround(0.0);
        HEAPF32[i6 + (i1 * 72 | 0) + 60 >> 2] = Math_fround(130.0);
        break;
       }
      default:
       {}
      }
      HEAPF32[i6 + (i1 * 72 | 0) + 64 >> 2] = Math_fround(5.0);
      HEAPF32[i6 + (i1 * 72 | 0) + 68 >> 2] = Math_fround(20.0);
     }
    }
   } while (0);
   i1 = i1 + 1 | 0;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 24);
 return;
}

function __ZN5physxL18testPolyEdgeNormalERKNS_2Gu9TriangleVEhRKNS0_15HullPolygonDataERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSH_RNSG_5Vec3VENS0_13FeatureStatusERSN_(i1, i3, i16, i17, i36, i31, i41, i34, i37) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i36 = i36 | 0;
 i31 = i31 | 0;
 i41 = i41 | 0;
 i34 = i34 | 0;
 i37 = i37 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i32 = 0, i33 = 0, i35 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i43 + 108 | 0;
 i33 = i43 + 32 | 0;
 i32 = i43 + 16 | 0;
 i39 = i43 + 48 | 0;
 i35 = i43;
 i38 = i43 + 96 | 0;
 f2 = Math_fround(HEAPF32[i41 >> 2]);
 i40 = i41 + 4 | 0;
 HEAP32[i42 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 i30 = i36 + 40 | 0;
 i26 = HEAP32[i30 >> 2] | 0;
 i13 = i1 + 96 | 0;
 f29 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i1 + 100 | 0;
 f28 = Math_fround(HEAPF32[i14 >> 2]);
 i15 = i1 + 104 | 0;
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f49 = Math_fround(HEAPF32[i26 >> 2]);
 f7 = Math_fround(f29 * f49);
 f48 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f28 * f48));
 f4 = Math_fround(HEAPF32[i26 + 32 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * f4));
 f47 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f8 = Math_fround(f29 * f47);
 f46 = Math_fround(HEAPF32[i26 + 20 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f28 * f46));
 f5 = Math_fround(HEAPF32[i26 + 36 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f9 * f5));
 f45 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f29 = Math_fround(f29 * f45);
 f27 = Math_fround(HEAPF32[i26 + 24 >> 2]);
 f28 = Math_fround(f29 + Math_fround(f28 * f27));
 f29 = Math_fround(HEAPF32[i26 + 40 >> 2]);
 f9 = Math_fround(f28 + Math_fround(f9 * f29));
 f28 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f44 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f49 * f28) + Math_fround(f48 * f44)) + Math_fround(f4 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f47 * f28) + Math_fround(f46 * f44)) + Math_fround(f5 * f12));
 f12 = Math_fround(Math_fround(Math_fround(f45 * f28) + Math_fround(f27 * f44)) + Math_fround(f29 * f12));
 f44 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(f49 * f44) + Math_fround(f48 * f28)) + Math_fround(f4 * f6));
 f5 = Math_fround(Math_fround(Math_fround(f47 * f44) + Math_fround(f46 * f28)) + Math_fround(f5 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f45 * f44) + Math_fround(f27 * f28)) + Math_fround(f29 * f6));
 i3 = i3 & 255;
 if (!(i3 & 32)) i1 = 0; else {
  f48 = Math_fround(f5 - f8);
  f49 = Math_fround(f6 - f9);
  HEAPF32[i39 >> 2] = Math_fround(f4 - f7);
  HEAPF32[i39 + 4 >> 2] = f48;
  HEAPF32[i39 + 8 >> 2] = f49;
  HEAPF32[i39 + 12 >> 2] = Math_fround(0.0);
  i1 = 1;
 }
 if (i3 & 8) {
  f48 = Math_fround(f8 - f11);
  f49 = Math_fround(f9 - f12);
  HEAPF32[i39 + (i1 << 4) >> 2] = Math_fround(f7 - f10);
  HEAPF32[i39 + (i1 << 4) + 4 >> 2] = f48;
  HEAPF32[i39 + (i1 << 4) + 8 >> 2] = f49;
  HEAPF32[i39 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 }
 if (!(i3 & 16)) {
  if (!i1) {
   i42 = 1;
   STACKTOP = i43;
   return i42 | 0;
  }
 } else {
  f48 = Math_fround(f11 - f5);
  f49 = Math_fround(f12 - f6);
  HEAPF32[i39 + (i1 << 4) >> 2] = Math_fround(f10 - f4);
  HEAPF32[i39 + (i1 << 4) + 4 >> 2] = f48;
  HEAPF32[i39 + (i1 << 4) + 8 >> 2] = f49;
  HEAPF32[i39 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 }
 f48 = Math_fround(f10 - f7);
 f29 = Math_fround(f11 - f8);
 f47 = Math_fround(f12 - f9);
 f49 = Math_fround(f4 - f7);
 f12 = Math_fround(f5 - f8);
 f28 = Math_fround(f6 - f9);
 f27 = Math_fround(Math_fround(f29 * f28) - Math_fround(f47 * f12));
 f28 = Math_fround(Math_fround(f47 * f49) - Math_fround(f48 * f28));
 f49 = Math_fround(Math_fround(f48 * f12) - Math_fround(f29 * f49));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f49 * f49) + Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28))))));
 f27 = Math_fround(f29 * f27);
 f28 = Math_fround(f29 * f28);
 f29 = Math_fround(f49 * f29);
 f49 = Math_fround(HEAPF32[i13 >> 2]);
 f12 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f49 * f27) + Math_fround(f28 * f12)) + Math_fround(f29 * Math_fround(HEAPF32[i15 >> 2])));
 i24 = i16 + 16 | 0;
 L12 : do if (HEAP32[i24 >> 2] | 0) {
  i25 = i16 + 24 | 0;
  i26 = i16 + 32 | 0;
  i20 = i16 + 28 | 0;
  i21 = i35 + 4 | 0;
  i22 = i35 + 8 | 0;
  i23 = i35 + 12 | 0;
  i19 = i17 + 48 | 0;
  i18 = 0;
  L14 : while (1) {
   i3 = HEAP32[i25 >> 2] | 0;
   i16 = HEAP32[i26 >> 2] | 0;
   i17 = HEAPU16[i3 + (i18 * 20 | 0) + 16 >> 1] | 0;
   f48 = Math_fround(HEAPF32[i3 + (i18 * 20 | 0) >> 2]);
   f49 = Math_fround(HEAPF32[i3 + (i18 * 20 | 0) + 4 >> 2]);
   if (!(Math_fround(Math_fround(Math_fround(f27 * f48) + Math_fround(f28 * f49)) + Math_fround(f29 * Math_fround(HEAPF32[i3 + (i18 * 20 | 0) + 8 >> 2]))) > Math_fround(0.0))) {
    i15 = i3 + (i18 * 20 | 0) + 18 | 0;
    i3 = HEAP8[i15 >> 0] | 0;
    if (i3 << 24 >> 24) {
     i13 = i3;
     i3 = (i3 & 255) + -1 | 0;
     i14 = 0;
     while (1) {
      i51 = HEAPU8[i16 + (i14 + i17) >> 0] | 0;
      i50 = HEAP32[i20 >> 2] | 0;
      f5 = Math_fround(HEAPF32[i50 + (i51 * 12 | 0) >> 2]);
      f7 = Math_fround(HEAPF32[i50 + (i51 * 12 | 0) + 4 >> 2]);
      f9 = Math_fround(HEAPF32[i50 + (i51 * 12 | 0) + 8 >> 2]);
      i3 = HEAPU8[i16 + (i3 + i17) >> 0] | 0;
      f4 = Math_fround(HEAPF32[i50 + (i3 * 12 | 0) >> 2]);
      f6 = Math_fround(HEAPF32[i50 + (i3 * 12 | 0) + 4 >> 2]);
      f8 = Math_fround(HEAPF32[i50 + (i3 * 12 | 0) + 8 >> 2]);
      f47 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f5) + Math_fround(f28 * f7)) + Math_fround(f29 * f9)) - f12);
      f49 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f4) + Math_fround(f28 * f6)) + Math_fround(f29 * f8)) - f12);
      f48 = Math_fround(HEAPF32[i31 >> 2]);
      if (f48 >= f47 | f48 >= f49) {
       f11 = Math_fround(f4 - f5);
       f10 = Math_fround(f6 - f7);
       f7 = Math_fround(f8 - f9);
       f6 = f2;
       i3 = 0;
       while (1) {
        f5 = Math_fround(HEAPF32[i39 + (i3 << 4) >> 2]);
        f48 = Math_fround(HEAPF32[i39 + (i3 << 4) + 4 >> 2]);
        f4 = Math_fround(HEAPF32[i39 + (i3 << 4) + 8 >> 2]);
        f2 = Math_fround(Math_fround(f10 * f4) - Math_fround(f7 * f48));
        f4 = Math_fround(Math_fround(f7 * f5) - Math_fround(f11 * f4));
        f5 = Math_fround(Math_fround(f11 * f48) - Math_fround(f10 * f5));
        f48 = Math_fround(-f2);
        f49 = Math_fround(-f4);
        f47 = Math_fround(-f5);
        if ((f5 > f47 ? f5 : f47) < Math_fround(9.99999997e-07) & ((f2 > f48 ? f2 : f48) < Math_fround(9.99999997e-07) ? (f4 > f49 ? f4 : f49) < Math_fround(9.99999997e-07) : 0)) f2 = f6; else {
         i51 = HEAP32[i30 >> 2] | 0;
         f46 = Math_fround(f2 * Math_fround(HEAPF32[i51 >> 2]));
         f46 = Math_fround(f46 + Math_fround(f4 * Math_fround(HEAPF32[i51 + 4 >> 2])));
         f46 = Math_fround(f46 + Math_fround(f5 * Math_fround(HEAPF32[i51 + 8 >> 2])));
         f8 = Math_fround(f2 * Math_fround(HEAPF32[i51 + 16 >> 2]));
         f8 = Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i51 + 20 >> 2])));
         f8 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i51 + 24 >> 2])));
         f2 = Math_fround(f2 * Math_fround(HEAPF32[i51 + 32 >> 2]));
         f4 = Math_fround(f2 + Math_fround(f4 * Math_fround(HEAPF32[i51 + 36 >> 2])));
         f5 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i51 + 40 >> 2])));
         f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f8 * f8)) + Math_fround(f5 * f5)))));
         f46 = Math_fround(f46 * f4);
         f2 = Math_fround(f8 * f4);
         f4 = Math_fround(f5 * f4);
         HEAPF32[i35 >> 2] = f46;
         HEAPF32[i21 >> 2] = f2;
         HEAPF32[i22 >> 2] = f4;
         HEAPF32[i23 >> 2] = Math_fround(0.0);
         i51 = HEAP32[i19 >> 2] | 0;
         f5 = Math_fround(HEAPF32[i51 + 96 >> 2]);
         f8 = Math_fround(HEAPF32[i51 + 100 >> 2]);
         f48 = Math_fround(HEAPF32[i51 + 104 >> 2]);
         f9 = Math_fround(HEAPF32[i51 + 112 >> 2]);
         f44 = Math_fround(HEAPF32[i51 + 116 >> 2]);
         f47 = Math_fround(HEAPF32[i51 + 120 >> 2]);
         f45 = Math_fround(HEAPF32[i51 + 128 >> 2]);
         f49 = Math_fround(HEAPF32[i51 + 132 >> 2]);
         f48 = Math_fround(Math_fround(Math_fround(f5 * f46) + Math_fround(f8 * f2)) + Math_fround(f48 * f4));
         f47 = Math_fround(Math_fround(Math_fround(f9 * f46) + Math_fround(f44 * f2)) + Math_fround(f47 * f4));
         f4 = Math_fround(Math_fround(Math_fround(f45 * f46) + Math_fround(f49 * f2)) + Math_fround(Math_fround(HEAPF32[i51 + 136 >> 2]) * f4));
         i51 = f47 > f4;
         f2 = i51 ? f47 : f4;
         f2 = f48 > f2 ? f48 : f2;
         f47 = i51 ? f4 : f47;
         mftCall_viiii(HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0, i36 | 0, i35 | 0, i33 | 0, i32 | 0);
         f4 = Math_fround(HEAPF32[i33 >> 2]);
         f49 = Math_fround(HEAPF32[i31 >> 2]);
         i51 = f4 > Math_fround(f49 + f2);
         if ((f48 > f47 ? f47 : f48) > Math_fround(f49 + Math_fround(HEAPF32[i32 >> 2])) | i51) {
          i1 = 0;
          break L14;
         }
         f2 = Math_fround(f2 - f4);
         if (f6 > f2) {
          HEAP32[i42 >> 2] = HEAP32[i38 >> 2];
          HEAP32[i42 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
          HEAP32[i42 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
          HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
          HEAP32[i34 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
          HEAP32[i34 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
          HEAP32[i34 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
          HEAP32[i37 >> 2] = 2;
         } else f2 = f6;
        }
        i3 = i3 + 1 | 0;
        if (i3 >>> 0 >= i1 >>> 0) break; else f6 = f2;
       }
       i13 = HEAP8[i15 >> 0] | 0;
      }
      i3 = i14 + 1 | 0;
      if (i3 >>> 0 < (i13 & 255) >>> 0) {
       i51 = i14;
       i14 = i3;
       i3 = i51;
      } else break;
     }
    }
   }
   i18 = i18 + 1 | 0;
   if (i18 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) break L12;
  }
  STACKTOP = i43;
  return i1 | 0;
 } while (0);
 HEAPF32[i41 >> 2] = f2;
 HEAP32[i40 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
 i51 = 1;
 STACKTOP = i43;
 return i51 | 0;
}

function __ZN19TouchPhaseEmulation18DispatchTouchEventEj8Vector2fNS_10TouchPhaseExj(i19, i18, i24, i16, i25, i26, i27) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i24 = i24 | 0;
 i16 = i16 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i28;
 i12 = i19 + 12 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i15 = i19 + 4 | 0;
 i21 = i19 + 8 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i15 >> 2] | 0;
  i6 = i5 + (i1 * 96 | 0) | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if ((i7 | 0) != -1) {
   i8 = i5 + (i1 * 96 | 0) + 84 | 0;
   if ((HEAP32[i8 >> 2] | 0) >>> 0 < i11 >>> 0) {
    i9 = i5 + (i1 * 96 | 0) + 72 | 0;
    i29 = i9;
    i29 = _i64Subtract(i25 | 0, i26 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i29 + 4 >> 2] | 0) | 0;
    i30 = getTempRet0() | 0;
    i10 = i5 + (i1 * 96 | 0) + 36 | 0;
    if (((i30 | 0) > 0 | (i30 | 0) == 0 & i29 >>> 0 > 15e4) & ((HEAP32[i10 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & ~(1 << i7);
     HEAP32[i6 >> 2] = -1;
     HEAP32[i10 >> 2] = 4;
     HEAP32[i5 + (i1 * 96 | 0) + 92 >> 2] = 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 88 >> 2] = 0;
     i30 = i5 + (i1 * 96 | 0) + 4 | 0;
     i29 = i9;
     HEAP32[i29 >> 2] = 0;
     HEAP32[i29 + 4 >> 2] = 0;
     HEAP32[i30 >> 2] = 0;
     HEAP32[i30 + 4 >> 2] = 0;
     HEAP32[i30 + 8 >> 2] = 0;
     HEAP32[i30 + 12 >> 2] = 0;
     HEAP32[i30 + 16 >> 2] = 0;
     HEAP32[i30 + 20 >> 2] = 0;
     HEAP32[i30 + 24 >> 2] = 0;
     HEAP32[i30 + 28 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 80 >> 2] = -1;
     HEAPF32[i5 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
     HEAPF32[i5 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
     HEAP32[i5 + (i1 * 96 | 0) + 40 >> 2] = 0;
     i30 = i5 + (i1 * 96 | 0) + 52 | 0;
     HEAP32[i30 >> 2] = 0;
     HEAP32[i30 + 4 >> 2] = 0;
     HEAP32[i30 + 8 >> 2] = 0;
     HEAP32[i30 + 12 >> 2] = 0;
    }
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i6 = HEAP32[i15 >> 2] | 0;
 i1 = 0;
 i5 = 0;
 while (1) {
  if ((HEAP32[i6 + (i5 * 96 | 0) + 80 >> 2] | 0) == (i18 | 0)) {
   HEAP32[i13 + (i1 << 2) >> 2] = i6 + (i5 * 96 | 0);
   i9 = i1 + 1 | 0;
  } else i9 = i1;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 32) break; else i1 = i9;
 }
 if (!i9) {
  i17 = 0;
  i22 = 33;
 } else {
  i7 = i19 + 16 | 0;
  i8 = i24 + 4 | 0;
  if (!i16) {
   i4 = 0;
   i1 = 0;
   i6 = 0;
   do {
    i5 = HEAP32[i13 + (i6 << 2) >> 2] | 0;
    do if ((HEAP32[i5 >> 2] | 0) != -1) {
     if (((HEAP32[i5 + 36 >> 2] | 0) + -3 | 0) >>> 0 >= 2) if (((HEAP32[i5 + 92 >> 2] | 0) + -3 | 0) >>> 0 >= 2) break;
     i4 = (HEAP32[i5 + 84 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 ? i5 : i4;
     if (!(HEAP8[gb + 1098144 >> 0] | 0)) {
      f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(.400000006)) * Math_fround(.393700987));
      HEAPF32[gb + 1162096 >> 2] = f3;
      i30 = gb + 1098144 | 0;
      HEAP32[i30 >> 2] = 1;
      HEAP32[i30 + 4 >> 2] = 0;
     }
     if (!(HEAP8[gb + 1098152 >> 0] | 0)) {
      f3 = Math_fround(HEAPF32[gb + 1162096 >> 2]);
      f3 = Math_fround(f3 * f3);
      HEAPF32[gb + 1162100 >> 2] = f3;
      i30 = gb + 1098152 | 0;
      HEAP32[i30 >> 2] = 1;
      HEAP32[i30 + 4 >> 2] = 0;
     }
     i30 = i5 + 72 | 0;
     i30 = _i64Subtract(i25 | 0, i26 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i30 + 4 >> 2] | 0) | 0;
     i29 = getTempRet0() | 0;
     if ((i29 | 0) < 0 | (i29 | 0) == 0 & i30 >>> 0 < 15e4) {
      f2 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      f2 = Math_fround(f2 - Math_fround(HEAPF32[i24 >> 2]));
      f3 = Math_fround(HEAPF32[i5 + 8 >> 2]);
      f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 >> 2]));
      f3 = Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3));
      if (f3 < Math_fround(HEAPF32[gb + 1162100 >> 2])) i1 = HEAP32[i5 + 32 >> 2] | 0;
     }
    } while (0);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i9 | 0));
  } else {
   i5 = 0;
   i6 = 0;
   while (1) {
    i7 = HEAP32[i13 + (i6 << 2) >> 2] | 0;
    if ((HEAP32[i7 >> 2] | 0) == -1) i22 = 28; else if (((HEAP32[i7 + 36 >> 2] | 0) + -3 | 0) >>> 0 < 2) i4 = i5; else if (((HEAP32[i7 + 92 >> 2] | 0) + -3 | 0) >>> 0 < 2) i4 = i5; else i22 = 28;
    do if ((i22 | 0) == 28) {
     i22 = 0;
     if (!i5) i4 = i7; else {
      i1 = HEAP32[i5 >> 2] | 0;
      if ((i1 | 0) == -1) {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 441549 | 0, 0, gb + 441584 | 0, 504, 1, 0, 0, 0);
       i4 = i7;
       break;
      } else {
       HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & ~(1 << i1);
       HEAP32[i5 >> 2] = -1;
       HEAP32[i5 + 36 >> 2] = 4;
       HEAP32[i5 + 92 >> 2] = 0;
       HEAP32[i5 + 84 >> 2] = 0;
       HEAP32[i5 + 88 >> 2] = 0;
       i4 = i5 + 4 | 0;
       i30 = i5 + 72 | 0;
       HEAP32[i30 >> 2] = 0;
       HEAP32[i30 + 4 >> 2] = 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = 0;
       HEAP32[i4 + 12 >> 2] = 0;
       HEAP32[i4 + 16 >> 2] = 0;
       HEAP32[i4 + 20 >> 2] = 0;
       HEAP32[i4 + 24 >> 2] = 0;
       HEAP32[i4 + 28 >> 2] = 0;
       HEAP32[i5 + 80 >> 2] = -1;
       HEAPF32[i5 + 44 >> 2] = Math_fround(1.0);
       HEAPF32[i5 + 48 >> 2] = Math_fround(1.0);
       HEAP32[i5 + 40 >> 2] = 0;
       i4 = i5 + 52 | 0;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i4 + 4 >> 2] = 0;
       HEAP32[i4 + 8 >> 2] = 0;
       HEAP32[i4 + 12 >> 2] = 0;
       i4 = i7;
       break;
      }
     }
    } while (0);
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i9 | 0)) {
     i1 = 0;
     break;
    } else i5 = i4;
   }
  }
  if (!i4) {
   i17 = i1;
   i22 = 33;
  } else {
   i23 = i4;
   i14 = i1;
  }
 }
 if ((i22 | 0) == 33) {
  if (i16 | 0) {
   STACKTOP = i28;
   return;
  }
  i1 = HEAP32[i21 >> 2] | 0;
  i7 = 0;
  while (1) {
   i4 = 1 << i7;
   if (!(i4 & i1)) break;
   i5 = i7 + 1 | 0;
   if ((i5 | 0) < 32) i7 = i5; else {
    i22 = 72;
    break;
   }
  }
  if ((i22 | 0) == 72) {
   STACKTOP = i28;
   return;
  }
  HEAP32[i21 >> 2] = i4 | i1;
  i4 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  while (1) {
   i5 = i4 + (i1 * 96 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) == -1) break;
   i6 = i1 + 1 | 0;
   if (i6 >>> 0 < 32) i1 = i6; else {
    i22 = 72;
    break;
   }
  }
  if ((i22 | 0) == 72) {
   STACKTOP = i28;
   return;
  }
  HEAP32[i5 >> 2] = i7;
  HEAP32[i4 + (i1 * 96 | 0) + 20 >> 2] = 0;
  HEAP32[i4 + (i1 * 96 | 0) + 24 >> 2] = 0;
  HEAPF32[i4 + (i1 * 96 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAP32[i4 + (i1 * 96 | 0) + 92 >> 2] = 0;
  if (!i5) {
   STACKTOP = i28;
   return;
  } else {
   i23 = i5;
   i14 = i17;
  }
 }
 if (!i16) {
  i1 = i23 + 32 | 0;
  HEAP32[i1 >> 2] = i14;
  i17 = HEAP32[i24 >> 2] | 0;
  i4 = i24 + 4 | 0;
  i29 = HEAP32[i4 >> 2] | 0;
  HEAP32[i23 + 80 >> 2] = i18;
  i30 = i23 + 4 | 0;
  HEAP32[i30 >> 2] = i17;
  HEAP32[i30 + 4 >> 2] = i29;
  i30 = i23 + 12 | 0;
  HEAP32[i30 >> 2] = i17;
  HEAP32[i30 + 4 >> 2] = i29;
  HEAP32[i23 + 36 >> 2] = 0;
  HEAP32[i23 + 88 >> 2] = i27;
  i30 = i23 + 72 | 0;
  HEAP32[i30 >> 2] = i25;
  HEAP32[i30 + 4 >> 2] = i26;
  HEAP32[i23 + 84 >> 2] = i27;
  HEAPF32[i23 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i23 + 48 >> 2] = Math_fround(1.0);
  i30 = i23 + 52 | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i30 + 4 >> 2] = 0;
  HEAP32[i30 + 8 >> 2] = 0;
  HEAP32[i30 + 12 >> 2] = 0;
  i30 = (HEAP8[gb + 1098144 >> 0] | 0) == 0;
  f2 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i30) {
   f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i19 + 16 >> 2]) * Math_fround(.400000006)) * Math_fround(.393700987));
   HEAPF32[gb + 1162096 >> 2] = f3;
   i30 = gb + 1098144 | 0;
   HEAP32[i30 >> 2] = 1;
   HEAP32[i30 + 4 >> 2] = 0;
  }
  if (!(HEAP8[gb + 1098152 >> 0] | 0)) {
   f3 = Math_fround(HEAPF32[gb + 1162096 >> 2]);
   f3 = Math_fround(f3 * f3);
   HEAPF32[gb + 1162100 >> 2] = f3;
   i30 = gb + 1098152 | 0;
   HEAP32[i30 >> 2] = 1;
   HEAP32[i30 + 4 >> 2] = 0;
  }
  f31 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f31 = Math_fround(f31 - Math_fround(HEAPF32[i24 >> 2]));
  f3 = Math_fround(f2 - Math_fround(HEAPF32[i4 >> 2]));
  f3 = Math_fround(Math_fround(f31 * f31) + Math_fround(f3 * f3));
  i4 = f3 < Math_fround(HEAPF32[gb + 1162100 >> 2]);
  HEAP32[i1 >> 2] = i4 ? i14 + 1 | 0 : 1;
  i4 = HEAP32[i23 >> 2] | 0;
  i5 = HEAP32[i21 >> 2] | 0;
  i1 = 0;
  while (1) {
   i6 = 1 << i1;
   if (!(i6 & i5)) {
    i22 = 48;
    break;
   }
   i7 = i1 + 1 | 0;
   if ((i7 | 0) < 32) i1 = i7; else {
    i20 = i4;
    break;
   }
  }
  if ((i22 | 0) == 48) if ((i1 | 0) > (i4 | 0)) i20 = i4; else {
   HEAP32[i21 >> 2] = (i6 | i5) & ~(1 << i4);
   i20 = i1;
  }
  HEAP32[i23 >> 2] = i20;
  STACKTOP = i28;
  return;
 }
 if ((i16 + -3 | 0) >>> 0 < 2) {
  if ((HEAP32[i23 + 88 >> 2] | 0) == (i27 | 0)) HEAP32[i23 + 92 >> 2] = i16; else HEAP32[i23 + 36 >> 2] = i16;
  if ((i16 | 0) == 4) {
   i4 = HEAP32[i15 >> 2] | 0;
   i1 = 0;
   do {
    if ((HEAP32[i4 + (i1 * 96 | 0) >> 2] | 0) != -1) if (((HEAP32[i4 + (i1 * 96 | 0) + 36 >> 2] | 0) + -3 | 0) >>> 0 >= 2) {
     i5 = i4 + (i1 * 96 | 0) + 92 | 0;
     if (((HEAP32[i5 >> 2] | 0) + -3 | 0) >>> 0 >= 2) HEAP32[i5 >> 2] = 4;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 32);
  }
 } else if ((i16 | 0) == 1) {
  i1 = i23 + 36 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 2) {
   f3 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i24 >> 2]));
   f31 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   f31 = Math_fround(f31 - Math_fround(HEAPF32[i24 + 4 >> 2]));
   if (Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f31 * f31)))) >= Math_fround(.5)) HEAP32[i1 >> 2] = 1;
  }
 }
 f31 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 f33 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
 f2 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f33 = Math_fround(f33 - f2);
 f32 = Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f32 = Math_fround(f32 - f3);
 if (!(Math_fround(Math_fround(f33 * f33) + Math_fround(f32 * f32)) <= Math_fround(f31 * f31))) {
  f32 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f2);
  f33 = Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) - f3);
  HEAPF32[i23 + 20 >> 2] = f32;
  HEAPF32[i23 + 24 >> 2] = f33;
 }
 i4 = i24;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i23 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i23 + 72 | 0;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 if (!((i4 | 0) == 0 & (i5 | 0) == 0)) {
  i30 = _i64Subtract(i25 | 0, i26 | 0, i4 | 0, i5 | 0) | 0;
  HEAPF32[i23 + 28 >> 2] = Math_fround(Math_fround(+(i30 >>> 0) + 4294967296.0 * +(getTempRet0() | 0)) / Math_fround(1.0e6));
 }
 i30 = i1;
 HEAP32[i30 >> 2] = i25;
 HEAP32[i30 + 4 >> 2] = i26;
 HEAP32[i23 + 84 >> 2] = i27;
 STACKTOP = i28;
 return;
}

function __ZN11NoiseModule15PreviewNoiseJobILi1EEEvP19PreviewNoiseJobData(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, i57 = 0, i58 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i55 + 288 | 0;
 i34 = i55 + 284 | 0;
 i37 = i55 + 280 | 0;
 i39 = i55 + 112 | 0;
 i40 = i55 + 64 | 0;
 i46 = i55 + 32 | 0;
 i53 = i55 + 16 | 0;
 i54 = i55;
 if ((HEAP16[gb + 1452304 + 6 >> 1] | 0) > -1) {
  HEAP32[i34 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i34 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452304 | 0, i25);
  i27 = gb + 1452304 | 0;
 } else i27 = 0;
 i35 = HEAP32[i1 >> 2] | 0;
 f41 = Math_fround(_fmaxf(Math_fround(HEAPF32[i35 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i25 >> 2] = f41;
 HEAP32[i34 >> 2] = HEAP32[i35 + 816 >> 2];
 HEAP32[i37 >> 2] = HEAP32[i35 + 812 >> 2];
 f36 = Math_fround(HEAPF32[i35 + 1088 >> 2]);
 i38 = i1 + 8 | 0;
 i2 = HEAP32[i38 >> 2] | 0;
 f42 = Math_fround(i2 >>> 0);
 f43 = Math_fround((HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 HEAPF32[i39 + 4 >> 2] = Math_fround(inf);
 HEAP32[i39 >> 2] = 0;
 i44 = i39 + 8 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 32 >> 2] = Math_fround(inf);
 HEAP32[i39 + 28 >> 2] = 0;
 i44 = i39 + 36 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 60 >> 2] = Math_fround(inf);
 HEAP32[i39 + 56 >> 2] = 0;
 i44 = i39 + 64 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 88 >> 2] = Math_fround(inf);
 HEAP32[i39 + 84 >> 2] = 0;
 i44 = i39 + 92 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 116 >> 2] = Math_fround(inf);
 HEAP32[i39 + 112 >> 2] = 0;
 i44 = i39 + 120 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 144 >> 2] = Math_fround(inf);
 HEAP32[i39 + 140 >> 2] = 0;
 i44 = i39 + 148 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 f41 = Math_fround(Math_fround(1.0) / f41);
 f42 = Math_fround(Math_fround(1.0) / f42);
 f43 = Math_fround(Math_fround(1.0) / f43);
 i44 = i1 + 4 | 0;
 i3 = HEAP32[i44 >> 2] | 0;
 if (i3 >>> 0 < 4294967284) {
  i45 = i35 + 804 | 0;
  i28 = i40 + 4 | 0;
  i30 = i40 + 8 | 0;
  i32 = i40 + 12 | 0;
  i47 = i40 + 16 | 0;
  i29 = i40 + 20 | 0;
  i31 = i40 + 24 | 0;
  i33 = i40 + 28 | 0;
  i26 = i40 + 32 | 0;
  i48 = i35 + 808 | 0;
  i49 = i46 + 4 | 0;
  i50 = i46 + 8 | 0;
  i51 = i46 + 12 | 0;
  i52 = i35 + 1884 | 0;
  i15 = i1 + 16 | 0;
  i16 = i54 + 12 | 0;
  i17 = i54 + 8 | 0;
  i18 = i54 + 4 | 0;
  i19 = i53 + 4 | 0;
  i20 = i53 + 8 | 0;
  i21 = i53 + 12 | 0;
  i22 = i46 + 4 | 0;
  i23 = i46 + 8 | 0;
  i24 = i46 + 12 | 0;
  i14 = i3;
  i1 = i3;
  do {
   if (!i2) i2 = 0; else {
    f13 = Math_fround(Math_fround(f43 * Math_fround(i14 >>> 0)) * Math_fround(5.0));
    i8 = 0;
    f9 = Math_fround(0.0);
    f10 = Math_fround(2.0);
    f11 = Math_fround(3.0);
    f12 = Math_fround(1.0);
    do {
     i1 = HEAP16[i45 >> 1] | 0;
     if (!((i1 & 255) << 24 >> 24)) i3 = 0; else i3 = (i8 >>> 0) / (((i2 >>> 0) / 3 | 0) >>> 0) | 0;
     f4 = Math_fround(HEAPF32[i35 + 8 + (i3 * 264 | 0) + 80 >> 2]);
     f4 = Math_fround(Math_fround(f41 * f4) * ((i1 & 65535) > 255 ? f41 : Math_fround(1.0)));
     f6 = Math_fround(Math_fround(f36 + Math_fround(f42 * f12)) * Math_fround(5.0));
     f7 = Math_fround(Math_fround(f36 + Math_fround(f42 * f10)) * Math_fround(5.0));
     f5 = Math_fround(Math_fround(f36 + Math_fround(f42 * f11)) * Math_fround(5.0));
     HEAPF32[i40 >> 2] = Math_fround(Math_fround(f36 + Math_fround(f42 * f9)) * Math_fround(5.0));
     HEAPF32[i28 >> 2] = f6;
     HEAPF32[i30 >> 2] = f7;
     HEAPF32[i32 >> 2] = f5;
     HEAPF32[i47 >> 2] = f13;
     HEAPF32[i29 >> 2] = f13;
     HEAPF32[i31 >> 2] = f13;
     HEAPF32[i33 >> 2] = f13;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     HEAP32[i26 + 12 >> 2] = 0;
     __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i46, i40, i25, HEAP32[i48 >> 2] | 0, i34, i37);
     f5 = Math_fround(f4 * Math_fround(HEAPF32[i46 >> 2]));
     f7 = Math_fround(f4 * Math_fround(HEAPF32[i49 >> 2]));
     f6 = Math_fround(f4 * Math_fround(HEAPF32[i50 >> 2]));
     f4 = Math_fround(f4 * Math_fround(HEAPF32[i51 >> 2]));
     HEAPF32[i46 >> 2] = f5;
     HEAPF32[i49 >> 2] = f7;
     HEAPF32[i50 >> 2] = f6;
     HEAPF32[i51 >> 2] = f4;
     if (HEAP8[i52 >> 0] | 0) {
      f56 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
      f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
      f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
      f7 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
      i1 = f56 < Math_fround(0.0);
      f4 = i1 ? Math_fround(0.0) : f56;
      i1 = f5 < Math_fround(0.0);
      f5 = i1 ? Math_fround(0.0) : f5;
      i1 = f6 < Math_fround(0.0);
      f6 = i1 ? Math_fround(0.0) : f6;
      i1 = f7 < Math_fround(0.0);
      f7 = i1 ? Math_fround(0.0) : f7;
      i1 = f4 > Math_fround(1.0);
      f4 = i1 ? Math_fround(1.0) : f4;
      i1 = f5 > Math_fround(1.0);
      f5 = i1 ? Math_fround(1.0) : f5;
      i1 = f6 > Math_fround(1.0);
      f6 = i1 ? Math_fround(1.0) : f6;
      i1 = f7 > Math_fround(1.0);
      f7 = i1 ? Math_fround(1.0) : f7;
      HEAPF32[i46 >> 2] = f4;
      HEAPF32[i49 >> 2] = f5;
      HEAPF32[i50 >> 2] = f6;
      HEAPF32[i51 >> 2] = f7;
      i1 = i35 + 1092 + (i3 * 264 | 0) | 0;
      HEAPF32[i16 >> 2] = Math_fround(1.0);
      HEAPF32[i17 >> 2] = Math_fround(1.0);
      HEAPF32[i18 >> 2] = Math_fround(1.0);
      HEAPF32[i54 >> 2] = Math_fround(1.0);
      i2 = HEAP32[i35 + 1092 + (i3 * 264 | 0) + 84 >> 2] | 0;
      L17 : do switch ((i2 & 65535) << 16 >> 16) {
      case 0:
       {
        i3 = HEAP32[i35 + 1092 + (i3 * 264 | 0) + 80 >> 2] | 0;
        HEAP32[i21 >> 2] = i3;
        HEAP32[i20 >> 2] = i3;
        HEAP32[i19 >> 2] = i3;
        HEAP32[i53 >> 2] = i3;
        break;
       }
      case 3:
       {
        f56 = Math_fround(HEAPF32[(HEAP32[i35 + 1092 + (i3 * 264 | 0) + 232 >> 2] | 0) + 4 >> 2]);
        f7 = Math_fround(HEAPF32[i35 + 1092 + (i3 * 264 | 0) + 80 >> 2]);
        f56 = Math_fround(f56 * f7);
        f56 = Math_fround(f56 + Math_fround(Math_fround(f7 * Math_fround(HEAPF32[(HEAP32[i35 + 1092 + (i3 * 264 | 0) + 144 >> 2] | 0) + 4 >> 2])) - f56));
        HEAPF32[i53 >> 2] = f56;
        HEAPF32[i19 >> 2] = f56;
        HEAPF32[i20 >> 2] = f56;
        HEAPF32[i21 >> 2] = f56;
        break;
       }
      default:
       if (!(i2 & 16711680)) {
        __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i53, i1, i39 + (i3 * 56 | 0) | 0, i46, i54);
        break L17;
       } else {
        __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i53, i1, i46, i54);
        break L17;
       }
      } while (0);
      i57 = HEAP32[i53 >> 2] | 0;
      i1 = HEAP32[i19 >> 2] | 0;
      i2 = HEAP32[i20 >> 2] | 0;
      i3 = HEAP32[i21 >> 2] | 0;
      HEAP32[i46 >> 2] = i57;
      HEAP32[i49 >> 2] = i1;
      HEAP32[i50 >> 2] = i2;
      HEAP32[i51 >> 2] = i3;
      f5 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     }
     f56 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
     f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
     f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
     f7 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
     i2 = f56 < Math_fround(0.0);
     f56 = i2 ? Math_fround(0.0) : f56;
     i2 = f5 < Math_fround(0.0);
     f5 = i2 ? Math_fround(0.0) : f5;
     i2 = f6 < Math_fround(0.0);
     f6 = i2 ? Math_fround(0.0) : f6;
     i2 = f7 < Math_fround(0.0);
     f7 = i2 ? Math_fround(0.0) : f7;
     i2 = f56 > Math_fround(1.0);
     f56 = i2 ? Math_fround(1.0) : f56;
     i2 = f5 > Math_fround(1.0);
     f5 = i2 ? Math_fround(1.0) : f5;
     i2 = f6 > Math_fround(1.0);
     f6 = i2 ? Math_fround(1.0) : f6;
     i2 = f7 > Math_fround(1.0);
     f7 = i2 ? Math_fround(1.0) : f7;
     HEAPF32[i46 >> 2] = f56;
     HEAPF32[i49 >> 2] = f5;
     HEAPF32[i50 >> 2] = f6;
     HEAPF32[i51 >> 2] = f7;
     i2 = HEAP32[i38 >> 2] | 0;
     i57 = Math_imul(i2, i14) | 0;
     i3 = HEAP32[i15 >> 2] | 0;
     i1 = i8 + i57 | 0;
     HEAPF32[i3 + (i1 << 4) >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 4 >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 1) + i57 | 0;
     i58 = HEAP32[i22 >> 2] | 0;
     HEAP32[i3 + (i1 << 4) >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 4 >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 8 >> 2] = i58;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 2) + i57 | 0;
     i58 = HEAP32[i23 >> 2] | 0;
     HEAP32[i3 + (i1 << 4) >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 4 >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 8 >> 2] = i58;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i57 = (i8 | 3) + i57 | 0;
     i1 = HEAP32[i24 >> 2] | 0;
     HEAP32[i3 + (i57 << 4) >> 2] = i1;
     HEAP32[i3 + (i57 << 4) + 4 >> 2] = i1;
     HEAP32[i3 + (i57 << 4) + 8 >> 2] = i1;
     HEAPF32[i3 + (i57 << 4) + 12 >> 2] = Math_fround(1.0);
     i8 = i8 + 4 | 0;
     f9 = Math_fround(f9 + Math_fround(4.0));
     f12 = Math_fround(f12 + Math_fround(4.0));
     f10 = Math_fround(f10 + Math_fround(4.0));
     f11 = Math_fround(f11 + Math_fround(4.0));
    } while (i8 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i44 >> 2] | 0;
   }
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < (i1 + 12 | 0) >>> 0);
 }
 if (!i27) {
  STACKTOP = i55;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i27);
 STACKTOP = i55;
 return;
}

function __ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E(i8, i15, i14, i11, i4) {
 i8 = i8 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16;
 i1 = i16 + 4 | 0;
 switch (HEAP32[i8 >> 2] | 0) {
 case 0:
  {
   HEAP32[i15 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 24 >> 2];
   i15 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i15;
   HEAP32[i14 + 4 >> 2] = i15;
   HEAP32[i14 + 8 >> 2] = i15;
   f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.75));
   STACKTOP = i16;
   return Math_fround(f13);
  }
 case 1:
  {
   f3 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(f3 * Math_fround(2.0));
   f7 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   f5 = Math_fround(f7 * Math_fround(2.0));
   f7 = Math_fround(Math_fround(f3 * f6) + Math_fround(Math_fround(f7 * f5) + Math_fround(-1.0)));
   f3 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f12 = Math_fround(f3 * f5);
   f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f6 * f13));
   f13 = Math_fround(Math_fround(f6 * f3) - Math_fround(f5 * f13));
   f5 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) * f7) + Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) * f12)) + Math_fround(f13 * Math_fround(HEAPF32[i11 + 24 >> 2])));
   f3 = Math_fround(-f5);
   f6 = Math_fround(Math_abs(Math_fround(f7)));
   f10 = Math_fround(Math_abs(Math_fround(f12)));
   f9 = Math_fround(Math_abs(Math_fround(f13)));
   i2 = f10 < Math_fround(9.99999997e-07);
   i4 = f9 < Math_fround(9.99999997e-07);
   do if (f6 > Math_fround(.999998986) & i2 & i4) if (f7 > Math_fround(0.0)) {
    f9 = f5;
    f10 = Math_fround(8507058669999999534545717.0e13);
    f5 = Math_fround(8507058669999999534545717.0e13);
    f6 = Math_fround(-8507058669999999534545717.0e13);
    f7 = Math_fround(-8507058669999999534545717.0e13);
    f3 = Math_fround(-8507058669999999534545717.0e13);
   } else {
    f9 = Math_fround(8507058669999999534545717.0e13);
    f10 = Math_fround(8507058669999999534545717.0e13);
    f5 = Math_fround(8507058669999999534545717.0e13);
    f6 = f3;
    f7 = Math_fround(-8507058669999999534545717.0e13);
    f3 = Math_fround(-8507058669999999534545717.0e13);
   } else {
    i1 = f6 < Math_fround(9.99999997e-07);
    if (i1 & f10 > Math_fround(.999998986) & i4) {
     if (f12 > Math_fround(0.0)) {
      f9 = Math_fround(8507058669999999534545717.0e13);
      f10 = f5;
      f5 = Math_fround(8507058669999999534545717.0e13);
      f6 = Math_fround(-8507058669999999534545717.0e13);
      f7 = Math_fround(-8507058669999999534545717.0e13);
      f3 = Math_fround(-8507058669999999534545717.0e13);
      break;
     }
     f9 = Math_fround(8507058669999999534545717.0e13);
     f10 = Math_fround(8507058669999999534545717.0e13);
     f5 = Math_fround(8507058669999999534545717.0e13);
     f6 = Math_fround(-8507058669999999534545717.0e13);
     f7 = f3;
     f3 = Math_fround(-8507058669999999534545717.0e13);
     break;
    }
    if (i1 & i2 & f9 > Math_fround(.999998986)) if (f13 > Math_fround(0.0)) {
     f9 = Math_fround(8507058669999999534545717.0e13);
     f10 = Math_fround(8507058669999999534545717.0e13);
     f6 = Math_fround(-8507058669999999534545717.0e13);
     f7 = Math_fround(-8507058669999999534545717.0e13);
     f3 = Math_fround(-8507058669999999534545717.0e13);
    } else {
     f9 = Math_fround(8507058669999999534545717.0e13);
     f10 = Math_fround(8507058669999999534545717.0e13);
     f5 = Math_fround(8507058669999999534545717.0e13);
     f6 = Math_fround(-8507058669999999534545717.0e13);
     f7 = Math_fround(-8507058669999999534545717.0e13);
    } else {
     f9 = Math_fround(8507058669999999534545717.0e13);
     f10 = Math_fround(8507058669999999534545717.0e13);
     f5 = Math_fround(8507058669999999534545717.0e13);
     f6 = Math_fround(-8507058669999999534545717.0e13);
     f7 = Math_fround(-8507058669999999534545717.0e13);
     f3 = Math_fround(-8507058669999999534545717.0e13);
    }
   } while (0);
   f9 = Math_fround(f9 + Math_fround(0.0));
   f12 = Math_fround(f10 + Math_fround(0.0));
   f13 = Math_fround(f5 + Math_fround(0.0));
   f5 = Math_fround(Math_fround(f7 + f12) * Math_fround(.5));
   f10 = Math_fround(Math_fround(f3 + f13) * Math_fround(.5));
   HEAPF32[i15 >> 2] = Math_fround(Math_fround(f6 + f9) * Math_fround(.5));
   HEAPF32[i15 + 4 >> 2] = f5;
   HEAPF32[i15 + 8 >> 2] = f10;
   f12 = Math_fround(Math_fround(f12 - f7) * Math_fround(.5));
   f13 = Math_fround(Math_fround(f13 - f3) * Math_fround(.5));
   HEAPF32[i14 >> 2] = Math_fround(Math_fround(f9 - f6) * Math_fround(.5));
   HEAPF32[i14 + 4 >> 2] = f12;
   HEAPF32[i14 + 8 >> 2] = f13;
   f13 = Math_fround(3402823469999999843913219.0e14);
   STACKTOP = i16;
   return Math_fround(f13);
  }
 case 2:
  {
   HEAP32[i15 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 24 >> 2];
   f7 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(f7 * Math_fround(2.0));
   f10 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   f9 = Math_fround(f10 * Math_fround(2.0));
   f10 = Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f10 * f9) + Math_fround(-1.0)));
   f7 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f12 = Math_fround(f7 * f9);
   f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f6 * f13));
   f13 = Math_fround(Math_fround(f6 * f7) - Math_fround(f9 * f13));
   i11 = i8 + 8 | 0;
   i15 = i8 + 4 | 0;
   HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f10))) * Math_fround(HEAPF32[i11 >> 2])) + Math_fround(HEAPF32[i15 >> 2]));
   HEAPF32[i14 + 4 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f12))) * Math_fround(HEAPF32[i11 >> 2])) + Math_fround(HEAPF32[i15 >> 2]));
   HEAPF32[i14 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f13))) * Math_fround(HEAPF32[i11 >> 2])) + Math_fround(HEAPF32[i15 >> 2]));
   f13 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * Math_fround(.75));
   STACKTOP = i16;
   return Math_fround(f13);
  }
 case 3:
  {
   f12 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   f20 = Math_fround(f12 + f12);
   f3 = Math_fround(f21 + f21);
   f19 = Math_fround(f17 + f17);
   f13 = Math_fround(f21 * f3);
   f7 = Math_fround(f17 * f19);
   f21 = Math_fround(f20 * f21);
   f5 = Math_fround(f20 * f17);
   f9 = Math_fround(f20 * f18);
   f17 = Math_fround(f3 * f17);
   f3 = Math_fround(f3 * f18);
   f18 = Math_fround(f19 * f18);
   f19 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f7);
   f6 = Math_fround(f21 + f18);
   f10 = Math_fround(f5 - f3);
   f18 = Math_fround(f21 - f18);
   f20 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f20));
   f7 = Math_fround(f20 - f7);
   f12 = Math_fround(f17 + f9);
   f3 = Math_fround(f5 + f3);
   f9 = Math_fround(f17 - f9);
   f13 = Math_fround(f20 - f13);
   i2 = i8 + 4 | 0;
   f20 = Math_fround(HEAPF32[i2 >> 2]);
   i4 = i8 + 8 | 0;
   f17 = Math_fround(HEAPF32[i4 >> 2]);
   i8 = i8 + 12 | 0;
   f5 = Math_fround(HEAPF32[i8 >> 2]);
   f6 = Math_fround(f20 * f6);
   f10 = Math_fround(f20 * f10);
   f7 = Math_fround(f7 * f17);
   f12 = Math_fround(f12 * f17);
   f9 = Math_fround(f9 * f5);
   f13 = Math_fround(f13 * f5);
   HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f20 * f19))) + Math_fround(Math_abs(Math_fround(f18 * f17)))) + Math_fround(Math_abs(Math_fround(f3 * f5))));
   HEAPF32[i14 + 4 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f6))) + Math_fround(Math_abs(Math_fround(f7)))) + Math_fround(Math_abs(Math_fround(f9))));
   HEAPF32[i14 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f10))) + Math_fround(Math_abs(Math_fround(f12)))) + Math_fround(Math_abs(Math_fround(f13))));
   HEAP32[i15 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 24 >> 2];
   f13 = Math_fround(HEAPF32[i2 >> 2]);
   f12 = Math_fround(HEAPF32[i4 >> 2]);
   f12 = f13 < f12 ? f13 : f12;
   f13 = Math_fround(HEAPF32[i8 >> 2]);
   f13 = Math_fround((f12 < f13 ? f12 : f13) * Math_fround(.75));
   STACKTOP = i16;
   return Math_fround(f13);
  }
 case 4:
  {
   i2 = HEAP32[i8 + 36 >> 2] | 0;
   if (!i4) {
    i1 = i8 + 4 | 0;
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, i2, i1, i15, i14);
   } else {
    i1 = i8 + 4 | 0;
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, i4, i1, i15, i14);
   }
   f20 = Math_fround(HEAPF32[i8 + 12 >> 2]);
   f19 = Math_fround(HEAPF32[i1 >> 2]);
   f21 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f21 = f19 < f21 ? f19 : f21;
   f21 = Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) * (f20 < f21 ? f20 : f21)) * Math_fround(.75));
   STACKTOP = i16;
   return Math_fround(f21);
  }
 case 5:
  if (!i4) {
   __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, (HEAP32[i8 + 40 >> 2] | 0) + 128 | 0, i8 + 4 | 0, i15, i14);
   f21 = Math_fround(0.0);
   STACKTOP = i16;
   return Math_fround(f21);
  } else {
   __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, i4, i8 + 4 | 0, i15, i14);
   f21 = Math_fround(0.0);
   STACKTOP = i16;
   return Math_fround(f21);
  }
 case 6:
  {
   i22 = HEAP32[i8 + 8 >> 2] | 0;
   i2 = HEAP32[i8 + 16 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i1 + 4 >> 2] = i22;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 1065353216;
   if (!i4) {
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, (HEAP32[i8 + 24 >> 2] | 0) + 40 | 0, i1, i15, i14);
    f21 = Math_fround(0.0);
    STACKTOP = i16;
    return Math_fround(f21);
   } else {
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i11, i4, i1, i15, i14);
    f21 = Math_fround(0.0);
    STACKTOP = i16;
    return Math_fround(f21);
   }
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 676222 | 0, 432, gb + 676302 | 0, i2);
   f21 = Math_fround(3402823469999999843913219.0e14);
   STACKTOP = i16;
   return Math_fround(f21);
  }
 }
 return f0;
}

function _gray_render_line(i36, i38, i41) {
 i36 = i36 | 0;
 i38 = i38 | 0;
 i41 = i41 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i39 = 0, i40 = 0, i42 = 0;
 i42 = i36 + 64 | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 i5 = i1 >> 8;
 i37 = i41 >> 8;
 i4 = i1 - (i5 << 8) | 0;
 i39 = i41 - (i37 << 8) | 0;
 i40 = i36 + 60 | 0;
 i3 = HEAP32[i40 >> 2] | 0;
 i12 = i38 - i3 | 0;
 i1 = i41 - i1 | 0;
 i34 = HEAP32[i36 + 24 >> 2] | 0;
 if (!((i5 | 0) < (i34 | 0) | (i37 | 0) < (i34 | 0))) {
  HEAP32[i40 >> 2] = i38;
  HEAP32[i42 >> 2] = i41;
  return;
 }
 i34 = i36 + 20 | 0;
 i27 = HEAP32[i34 >> 2] | 0;
 if ((i5 | 0) < (i27 | 0) & (i37 | 0) < (i27 | 0)) {
  HEAP32[i40 >> 2] = i38;
  HEAP32[i42 >> 2] = i41;
  return;
 }
 if ((i5 | 0) == (i37 | 0)) {
  _gray_render_scanline(i36, i5, i3, i4, i38, i39);
  HEAP32[i40 >> 2] = i38;
  HEAP32[i42 >> 2] = i41;
  return;
 }
 if (!i12) {
  i20 = i3 >> 8;
  i26 = i3 - (i20 << 8) << 1;
  i22 = i1 >> 31;
  i25 = i22 + 256 & -256;
  i22 = i22 | 1;
  i1 = i25 - i4 | 0;
  i2 = Math_imul(i26, i1) | 0;
  i23 = i36 + 36 | 0;
  i2 = (HEAP32[i23 >> 2] | 0) + i2 | 0;
  HEAP32[i23 >> 2] = i2;
  i24 = i36 + 40 | 0;
  i1 = (HEAP32[i24 >> 2] | 0) + i1 | 0;
  HEAP32[i24 >> 2] = i1;
  i7 = i22 + i5 | 0;
  i9 = i7 - i27 | 0;
  i21 = HEAP32[i36 + 16 >> 2] | 0;
  i20 = ((i21 | 0) < (i20 | 0) ? i21 : i20) - (HEAP32[i36 + 12 >> 2] | 0) | 0;
  i20 = (i20 | 0) > -1 ? i20 : -1;
  i21 = i36 + 4 | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  if ((i20 | 0) == (i3 | 0)) {
   if ((i9 | 0) != (HEAP32[i36 + 8 >> 2] | 0)) i35 = 8;
  } else i35 = 8;
  if ((i35 | 0) == 8) {
   L17 : do if (!((HEAP32[i36 + 44 >> 2] | 0) != 0 | (i1 | i2 | 0) == 0)) {
    i6 = HEAP32[i36 + 28 >> 2] | 0;
    i6 = (i3 | 0) > (i6 | 0) ? i6 : i3;
    i4 = (HEAP32[i36 + 1256 >> 2] | 0) + (HEAP32[i36 + 8 >> 2] << 2) | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    L19 : do if (!i3) i35 = 13; else while (1) {
     i5 = HEAP32[i3 >> 2] | 0;
     if ((i5 | 0) > (i6 | 0)) {
      i35 = 13;
      break L19;
     }
     if ((i5 | 0) == (i6 | 0)) break L19;
     i4 = i3 + 12 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i35 = 13;
      break;
     }
    } while (0);
    do if ((i35 | 0) == 13) {
     i3 = i36 + 56 | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     if ((i5 | 0) < (HEAP32[i36 + 52 >> 2] | 0)) {
      i34 = HEAP32[i36 + 48 >> 2] | 0;
      HEAP32[i3 >> 2] = i5 + 1;
      i3 = i34 + (i5 << 4) | 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i34 + (i5 << 4) + 8 >> 2] = 0;
      HEAP32[i34 + (i5 << 4) + 4 >> 2] = 0;
      HEAP32[i34 + (i5 << 4) + 12 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = i3;
      if (!i3) break L17; else break;
     } else {
      HEAP32[i36 >> 2] = 64;
      break L17;
     }
    } while (0);
    i34 = i3 + 8 | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i2;
    i34 = i3 + 4 | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1;
   } while (0);
   HEAP32[i23 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i21 >> 2] = i20;
   HEAP32[i36 + 8 >> 2] = i9;
   i2 = 0;
   i1 = 0;
  }
  i19 = HEAP32[i36 + 32 >> 2] | 0;
  if (i9 >>> 0 < i19 >>> 0) i3 = (i20 | 0) >= (HEAP32[i36 + 28 >> 2] | 0); else i3 = 1;
  i3 = i3 & 1;
  i10 = i36 + 44 | 0;
  HEAP32[i10 >> 2] = i3;
  i11 = (i25 << 1) + -256 | 0;
  i12 = Math_imul(i11, i26) | 0;
  if ((i7 | 0) != (i37 | 0)) {
   i13 = i36 + 8 | 0;
   i14 = i36 + 28 | 0;
   i15 = i36 + 1256 | 0;
   i16 = i36 + 56 | 0;
   i17 = i36 + 52 | 0;
   i18 = i36 + 48 | 0;
   i8 = i9;
   i4 = i9;
   do {
    i2 = i2 + i12 | 0;
    i1 = i1 + i11 | 0;
    i7 = i7 + i22 | 0;
    i34 = i8;
    i8 = i7 - i27 | 0;
    if ((i8 | 0) != (i34 | 0)) {
     L41 : do if (!((i3 | 0) != 0 | (i1 | i2 | 0) == 0)) {
      i6 = HEAP32[i14 >> 2] | 0;
      i6 = (i20 | 0) > (i6 | 0) ? i6 : i20;
      i4 = (HEAP32[i15 >> 2] | 0) + (i4 << 2) | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      L43 : do if (!i3) i35 = 28; else while (1) {
       i5 = HEAP32[i3 >> 2] | 0;
       if ((i5 | 0) > (i6 | 0)) {
        i35 = 28;
        break L43;
       }
       if ((i5 | 0) == (i6 | 0)) break L43;
       i4 = i3 + 12 | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if (!i3) {
        i35 = 28;
        break;
       }
      } while (0);
      do if ((i35 | 0) == 28) {
       i35 = 0;
       i5 = HEAP32[i16 >> 2] | 0;
       if ((i5 | 0) < (HEAP32[i17 >> 2] | 0)) {
        i34 = HEAP32[i18 >> 2] | 0;
        HEAP32[i16 >> 2] = i5 + 1;
        i3 = i34 + (i5 << 4) | 0;
        HEAP32[i3 >> 2] = i6;
        HEAP32[i34 + (i5 << 4) + 8 >> 2] = 0;
        HEAP32[i34 + (i5 << 4) + 4 >> 2] = 0;
        HEAP32[i34 + (i5 << 4) + 12 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i4 >> 2] = i3;
        if (!i3) break L41; else break;
       } else {
        HEAP32[i36 >> 2] = 64;
        break L41;
       }
      } while (0);
      i34 = i3 + 8 | 0;
      HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i2;
      i34 = i3 + 4 | 0;
      HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i1;
     } while (0);
     HEAP32[i21 >> 2] = i20;
     HEAP32[i13 >> 2] = i8;
     i2 = 0;
     i1 = 0;
     i4 = i8;
    }
    if (i8 >>> 0 < i19 >>> 0) i3 = (i20 | 0) >= (HEAP32[i14 >> 2] | 0); else i3 = 1;
    i3 = i3 & 1;
   } while ((i7 | 0) != (i37 | 0));
   HEAP32[i23 >> 2] = i2;
   HEAP32[i24 >> 2] = i1;
   HEAP32[i10 >> 2] = i3;
  }
  i39 = i39 + -256 + i25 | 0;
  HEAP32[i23 >> 2] = i2 + (Math_imul(i26, i39) | 0);
  HEAP32[i24 >> 2] = i1 + i39;
  HEAP32[i40 >> 2] = i38;
  HEAP32[i42 >> 2] = i41;
  return;
 }
 i2 = (i1 | 0) < 0;
 i32 = i1 >> 31;
 i33 = i32 + 256 & -256;
 i32 = i32 | 1;
 i31 = i2 ? 0 - i1 | 0 : i1;
 i2 = Math_imul(i2 ? i4 : 256 - i4 | 0, i12) | 0;
 i26 = (i2 | 0) % (i31 | 0) | 0;
 i27 = (i26 | 0) < 0 ? i31 : 0;
 i2 = ((i2 | 0) / (i31 | 0) | 0) + i3 + (i26 >> 31) | 0;
 _gray_render_scanline(i36, i5, i3, i4, i2, i33);
 i23 = i32 + i5 | 0;
 i10 = i2 >> 8;
 i11 = i23 - (HEAP32[i34 >> 2] | 0) | 0;
 i28 = i36 + 16 | 0;
 i30 = HEAP32[i28 >> 2] | 0;
 i29 = i36 + 12 | 0;
 i10 = ((i30 | 0) < (i10 | 0) ? i30 : i10) - (HEAP32[i29 >> 2] | 0) | 0;
 i10 = (i10 | 0) > -1 ? i10 : -1;
 i30 = i36 + 4 | 0;
 i3 = HEAP32[i30 >> 2] | 0;
 if ((i10 | 0) == (i3 | 0)) {
  if ((i11 | 0) != (HEAP32[i36 + 8 >> 2] | 0)) i35 = 40;
 } else i35 = 40;
 if ((i35 | 0) == 40) {
  i9 = i36 + 36 | 0;
  L67 : do if (!(HEAP32[i36 + 44 >> 2] | 0)) {
   i7 = HEAP32[i9 >> 2] | 0;
   i1 = i36 + 40 | 0;
   i8 = HEAP32[i1 >> 2] | 0;
   if (i8 | i7) {
    i6 = HEAP32[i36 + 28 >> 2] | 0;
    i6 = (i3 | 0) > (i6 | 0) ? i6 : i3;
    i4 = (HEAP32[i36 + 1256 >> 2] | 0) + (HEAP32[i36 + 8 >> 2] << 2) | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    L70 : do if (!i3) i35 = 47; else while (1) {
     i5 = HEAP32[i3 >> 2] | 0;
     if ((i5 | 0) > (i6 | 0)) {
      i35 = 47;
      break L70;
     }
     if ((i5 | 0) == (i6 | 0)) break L70;
     i4 = i3 + 12 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i35 = 47;
      break;
     }
    } while (0);
    do if ((i35 | 0) == 47) {
     i3 = i36 + 56 | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     if ((i5 | 0) < (HEAP32[i36 + 52 >> 2] | 0)) {
      i25 = HEAP32[i36 + 48 >> 2] | 0;
      HEAP32[i3 >> 2] = i5 + 1;
      i3 = i25 + (i5 << 4) | 0;
      HEAP32[i3 >> 2] = i6;
      HEAP32[i25 + (i5 << 4) + 8 >> 2] = 0;
      HEAP32[i25 + (i5 << 4) + 4 >> 2] = 0;
      HEAP32[i25 + (i5 << 4) + 12 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = i3;
      if (!i3) break L67; else break;
     } else {
      HEAP32[i36 >> 2] = 64;
      break L67;
     }
    } while (0);
    i25 = i3 + 8 | 0;
    HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + i7;
    i25 = i3 + 4 | 0;
    HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + i8;
   }
  } else i1 = i36 + 40 | 0; while (0);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i30 >> 2] = i10;
  HEAP32[i36 + 8 >> 2] = i11;
 }
 i25 = i36 + 32 | 0;
 if (i11 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) i1 = (i10 | 0) >= (HEAP32[i36 + 28 >> 2] | 0); else i1 = 1;
 i24 = i36 + 44 | 0;
 HEAP32[i24 >> 2] = i1 & 1;
 if ((i23 | 0) == (i37 | 0)) i1 = 256 - i33 | 0; else {
  i13 = i12 << 8;
  i1 = (i13 | 0) % (i31 | 0) | 0;
  i14 = ((i1 | 0) < 0 ? i31 : 0) + i1 | 0;
  i13 = (i1 >> 31) + ((i13 | 0) / (i31 | 0) | 0) | 0;
  i1 = 256 - i33 | 0;
  i15 = i36 + 8 | 0;
  i16 = i36 + 28 | 0;
  i17 = i36 + 36 | 0;
  i18 = i36 + 40 | 0;
  i19 = i36 + 1256 | 0;
  i20 = i36 + 56 | 0;
  i21 = i36 + 52 | 0;
  i22 = i36 + 48 | 0;
  i12 = i23;
  i10 = i26 - i31 + i27 | 0;
  while (1) {
   i11 = i14 + i10 | 0;
   i10 = i11 - ((i11 | 0) > -1 ? i31 : 0) | 0;
   i11 = i13 + i2 + (i11 >>> 31 ^ 1) | 0;
   _gray_render_scanline(i36, i12, i2, i1, i11, i33);
   i12 = i12 + i32 | 0;
   i6 = i11 >> 8;
   i7 = i12 - (HEAP32[i34 >> 2] | 0) | 0;
   i2 = HEAP32[i28 >> 2] | 0;
   i6 = ((i2 | 0) < (i6 | 0) ? i2 : i6) - (HEAP32[i29 >> 2] | 0) | 0;
   i6 = (i6 | 0) > -1 ? i6 : -1;
   i2 = HEAP32[i30 >> 2] | 0;
   if ((i6 | 0) == (i2 | 0)) {
    if ((i7 | 0) != (HEAP32[i15 >> 2] | 0)) i35 = 59;
   } else i35 = 59;
   if ((i35 | 0) == 59) {
    i35 = 0;
    L96 : do if (!(HEAP32[i24 >> 2] | 0)) {
     i8 = HEAP32[i17 >> 2] | 0;
     i9 = HEAP32[i18 >> 2] | 0;
     if (i9 | i8 | 0) {
      i5 = HEAP32[i16 >> 2] | 0;
      i5 = (i2 | 0) > (i5 | 0) ? i5 : i2;
      i3 = (HEAP32[i19 >> 2] | 0) + (HEAP32[i15 >> 2] << 2) | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      L99 : do if (!i2) i35 = 65; else while (1) {
       i4 = HEAP32[i2 >> 2] | 0;
       if ((i4 | 0) > (i5 | 0)) {
        i35 = 65;
        break L99;
       }
       if ((i4 | 0) == (i5 | 0)) break L99;
       i3 = i2 + 12 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if (!i2) {
        i35 = 65;
        break;
       }
      } while (0);
      do if ((i35 | 0) == 65) {
       i35 = 0;
       i4 = HEAP32[i20 >> 2] | 0;
       if ((i4 | 0) < (HEAP32[i21 >> 2] | 0)) {
        i27 = HEAP32[i22 >> 2] | 0;
        HEAP32[i20 >> 2] = i4 + 1;
        i2 = i27 + (i4 << 4) | 0;
        HEAP32[i2 >> 2] = i5;
        HEAP32[i27 + (i4 << 4) + 8 >> 2] = 0;
        HEAP32[i27 + (i4 << 4) + 4 >> 2] = 0;
        HEAP32[i27 + (i4 << 4) + 12 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i3 >> 2] = i2;
        if (!i2) break L96; else break;
       } else {
        HEAP32[i36 >> 2] = 64;
        break L96;
       }
      } while (0);
      i27 = i2 + 8 | 0;
      HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + i8;
      i27 = i2 + 4 | 0;
      HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + i9;
     }
    } while (0);
    HEAP32[i17 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i30 >> 2] = i6;
    HEAP32[i15 >> 2] = i7;
   }
   if (i7 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0) i2 = (i6 | 0) >= (HEAP32[i16 >> 2] | 0); else i2 = 1;
   HEAP32[i24 >> 2] = i2 & 1;
   if ((i12 | 0) == (i37 | 0)) {
    i2 = i11;
    break;
   } else i2 = i11;
  }
 }
 _gray_render_scanline(i36, i37, i2, i1, i38, i39);
 HEAP32[i40 >> 2] = i38;
 HEAP32[i42 >> 2] = i41;
 return;
}

function __ZN5physx17ConvexHullBuilder14CreateEdgeListEv(i33) {
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i41;
 i40 = i41 + 4 | 0;
 i25 = i41 + 50 | 0;
 i26 = i41 + 49 | 0;
 i27 = i41 + 48 | 0;
 i28 = i41 + 47 | 0;
 i29 = i41 + 46 | 0;
 i30 = i41 + 45 | 0;
 i34 = i41 + 44 | 0;
 i37 = i41 + 43 | 0;
 i38 = i41 + 42 | 0;
 i39 = i41 + 41 | 0;
 i36 = i41 + 40 | 0;
 i35 = i33 + 20 | 0;
 i1 = HEAP8[(HEAP32[i35 >> 2] | 0) + 39 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  __ZN5physx17ConvexHullBuilder17CreatePolygonDataEv(i33) | 0;
  i1 = HEAP8[(HEAP32[i35 >> 2] | 0) + 39 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i3 = 1;
   i1 = 0;
   i32 = 0;
  } else i2 = 3;
 } else i2 = 3;
 if ((i2 | 0) == 3) {
  i3 = HEAP32[i33 + 4 >> 2] | 0;
  i4 = i1 & 255;
  i2 = 0;
  i5 = 0;
  do {
   i2 = (HEAPU8[i3 + (i5 * 20 | 0) + 18 >> 0] | 0) + i2 | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
  i3 = 0;
  i32 = i2;
 }
 i17 = i32 >>> 0 > 1073741823 ? -1 : i32 << 2;
 i16 = (i17 | 0) == 0;
 if (i16) {
  i18 = 0;
  i21 = 0;
  i22 = 0;
  i23 = 0;
  i24 = 0;
  i19 = 0;
  i20 = 0;
 } else {
  i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0;
  i20 = _PxGetFoundation() | 0;
  i20 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 24 >> 2] | 0, i20 | 0) | 0;
  i20 = mftCall_iiiiii(i24 | 0, i23 | 0, i17 | 0, (i20 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1782) | 0;
  i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0;
  i19 = _PxGetFoundation() | 0;
  i19 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 24 >> 2] | 0, i19 | 0) | 0;
  i19 = mftCall_iiiiii(i24 | 0, i23 | 0, i17 | 0, (i19 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1783) | 0;
  i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0;
  i22 = _PxGetFoundation() | 0;
  i22 = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0;
  i22 = mftCall_iiiiii(i24 | 0, i23 | 0, i17 | 0, (i22 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1784) | 0;
  i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2] | 0;
  i21 = _PxGetFoundation() | 0;
  i21 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 24 >> 2] | 0, i21 | 0) | 0;
  i18 = i22;
  i21 = mftCall_iiiiii(i24 | 0, i23 | 0, i17 | 0, (i21 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1785) | 0;
  i23 = i19;
  i24 = i20;
 }
 if (!i3) {
  i14 = i1 & 255;
  i12 = HEAP32[i33 + 4 >> 2] | 0;
  i13 = HEAP32[i33 + 8 >> 2] | 0;
  i4 = i20;
  i3 = i19;
  i2 = i18;
  i1 = i21;
  i15 = 0;
  do {
   i11 = HEAP8[i12 + (i15 * 20 | 0) + 18 >> 0] | 0;
   i10 = i11 & 255;
   i7 = HEAPU16[i12 + (i15 * 20 | 0) + 16 >> 1] | 0;
   if (i11 << 24 >> 24) {
    i11 = i1 + (i10 << 2) | 0;
    i9 = i3 + (i10 << 2) | 0;
    i8 = i4;
    i6 = i2;
    i5 = 0;
    while (1) {
     i46 = HEAP8[i13 + (i5 + i7) >> 0] | 0;
     i44 = i46 & 255;
     i42 = i5;
     i5 = i5 + 1 | 0;
     i45 = HEAP8[i13 + (((i5 | 0) == (i10 | 0) ? 0 : i5) + i7) >> 0] | 0;
     i43 = i45 & 255;
     i45 = (i46 & 255) > (i45 & 255);
     HEAP32[i8 >> 2] = i45 ? i43 : i44;
     HEAP32[i3 >> 2] = i45 ? i44 : i43;
     HEAP32[i6 >> 2] = i15;
     HEAP32[i1 >> 2] = i42;
     if ((i5 | 0) == (i10 | 0)) break; else {
      i8 = i8 + 4 | 0;
      i3 = i3 + 4 | 0;
      i6 = i6 + 4 | 0;
      i1 = i1 + 4 | 0;
     }
    }
    i4 = i4 + (i10 << 2) | 0;
    i3 = i9;
    i2 = i2 + (i10 << 2) | 0;
    i1 = i11;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i40);
 i11 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i40, i19, i32, 0) | 0, i20, i32, 0) | 0) + 8 >> 2] | 0;
 HEAP16[(HEAP32[i35 >> 2] | 0) + 36 >> 1] = 0;
 if (i16) {
  i13 = 0;
  i10 = 0;
  i14 = 0;
  i15 = 0;
  i16 = 0;
 } else {
  i46 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i45 = HEAP32[(HEAP32[i46 >> 2] | 0) + 8 >> 2] | 0;
  i16 = _PxGetFoundation() | 0;
  i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
  i16 = mftCall_iiiiii(i45 | 0, i46 | 0, i17 | 0, (i16 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1822) | 0;
  i46 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i45 = HEAP32[(HEAP32[i46 >> 2] | 0) + 8 >> 2] | 0;
  i15 = _PxGetFoundation() | 0;
  i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
  i15 = mftCall_iiiiii(i45 | 0, i46 | 0, i17 | 0, (i15 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1823) | 0;
  i46 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i45 = HEAP32[(HEAP32[i46 >> 2] | 0) + 8 >> 2] | 0;
  i14 = _PxGetFoundation() | 0;
  i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
  i13 = i16;
  i10 = i15;
  i14 = mftCall_iiiiii(i45 | 0, i46 | 0, i17 | 0, (i14 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1824) | 0;
 }
 i12 = (i32 | 0) == 0;
 if (!i12) {
  i6 = (HEAP32[i35 >> 2] | 0) + 36 | 0;
  i4 = -1;
  i5 = -1;
  i9 = 0;
  while (1) {
   i1 = HEAP32[i11 + (i9 << 2) >> 2] | 0;
   i7 = HEAP32[i18 + (i1 << 2) >> 2] | 0;
   i8 = HEAP32[i21 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
   i1 = HEAP32[i19 + (i1 << 2) >> 2] | 0;
   i2 = HEAP16[i6 >> 1] | 0;
   if ((i3 | 0) == (i4 | 0) & (i1 | 0) == (i5 | 0)) {
    i3 = i4;
    i1 = i5;
   } else {
    i2 = i2 + 1 << 16 >> 16;
    HEAP16[i6 >> 1] = i2;
   }
   HEAP32[i13 + (i9 << 2) >> 2] = i7;
   HEAP32[i10 + (i9 << 2) >> 2] = i8;
   HEAP32[i14 + (i9 << 2) >> 2] = (i2 & 65535) + -1;
   i9 = i9 + 1 | 0;
   if ((i9 | 0) == (i32 | 0)) break; else {
    i4 = i3;
    i5 = i1;
   }
  }
 }
 i7 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i40, i10, i32, 0) | 0, i13, i32, 0) | 0) + 8 >> 2] | 0;
 i6 = i33 + 28 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i1 = i32 >>> 0 > 2147483647 ? -1 : i32 << 1;
 if (!i1) i1 = 0; else {
  i45 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i44 = HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0;
  i46 = _PxGetFoundation() | 0;
  i46 = mftCall_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 24 >> 2] | 0, i46 | 0) | 0;
  i1 = mftCall_iiiiii(i44 | 0, i45 | 0, i1 | 0, (i46 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1856) | 0;
 }
 HEAP32[i6 >> 2] = i1;
 if (!i12) {
  i2 = 0;
  do {
   HEAP16[i1 + (i2 << 1) >> 1] = HEAP32[i14 + (HEAP32[i7 + (i2 << 2) >> 2] << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i32 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i21);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i27, i22);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, i23);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i29, i24);
 i5 = i33 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i1 = HEAP16[(HEAP32[i35 >> 2] | 0) + 36 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i1 = 0;
  i2 = 0;
 } else {
  i46 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i45 = HEAP32[(HEAP32[i46 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i1 = mftCall_iiiiii(i45 | 0, i46 | 0, (i1 & 65535) << 3 | 0, (i2 ? gb + 729415 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1869) | 0;
  i2 = HEAP16[(HEAP32[i35 >> 2] | 0) + 36 >> 1] | 0;
 }
 HEAP32[i5 >> 2] = i1;
 _memset(i1 | 0, 0, (i2 & 65535) << 3 | 0) | 0;
 if (i12) i4 = HEAP32[i5 >> 2] | 0; else {
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = 0;
  while (1) {
   i46 = i1 + (HEAPU16[i2 >> 1] << 3) + 2 | 0;
   HEAP16[i46 >> 1] = (HEAP16[i46 >> 1] | 0) + 1 << 16 >> 16;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i32 | 0)) {
    i4 = i1;
    break;
   } else i2 = i2 + 2 | 0;
  }
 }
 i3 = HEAP16[(HEAP32[i35 >> 2] | 0) + 36 >> 1] | 0;
 do if (!(i3 << 16 >> 16)) {
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = 0;
 } else {
  i1 = i3 & 65535;
  i2 = 0;
  while (1) {
   if ((HEAP16[i4 + (i2 << 3) + 2 >> 1] | 0) != 2) {
    i2 = 36;
    break;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    i2 = 37;
    break;
   }
  }
  if ((i2 | 0) == 36) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726825 | 0, 1885, gb + 729535 | 0, i31);
   i46 = 0;
   __ZN5physx2Gu17RadixSortBufferedD2Ev(i40);
   STACKTOP = i41;
   return i46 | 0;
  } else if ((i2 | 0) == 37) {
   HEAP32[i4 + 4 >> 2] = 0;
   if ((i3 & 65535) > 1) {
    i2 = 0;
    i3 = 1;
   } else break;
   do {
    i2 = (HEAPU16[i4 + (i3 + -1 << 3) + 2 >> 1] | 0) + i2 | 0;
    HEAP32[i4 + (i3 << 3) + 4 >> 2] = i2;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
 } while (0);
 i1 = i1 + -1 | 0;
 i1 = (HEAPU16[i4 + (i1 << 3) + 2 >> 1] | 0) + (HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0) | 0;
 i4 = i33 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i34, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 if (!i1) i1 = 0; else {
  i45 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i44 = HEAP32[(HEAP32[i45 >> 2] | 0) + 8 >> 2] | 0;
  i46 = _PxGetFoundation() | 0;
  i46 = mftCall_ii(HEAP32[(HEAP32[i46 >> 2] | 0) + 24 >> 2] | 0, i46 | 0) | 0;
  i1 = mftCall_iiiiii(i44 | 0, i45 | 0, i1 | 0, (i46 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1898) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 L65 : do if (!i12) {
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = 0;
  while (1) {
   i45 = HEAP32[i13 + (HEAP32[i7 + (i2 << 2) >> 2] << 2) >> 2] & 255;
   i44 = (HEAP32[i5 >> 2] | 0) + (HEAPU16[i3 >> 1] << 3) + 4 | 0;
   i46 = HEAP32[i44 >> 2] | 0;
   HEAP32[i44 >> 2] = i46 + 1;
   HEAP8[i1 + i46 >> 0] = i45;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i32 | 0)) break L65;
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = i3 + 2 | 0;
  }
 } while (0);
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i1 = HEAP16[(HEAP32[i35 >> 2] | 0) + 36 >> 1] | 0;
 if ((i1 & 65535) > 1) {
  i1 = i1 & 65535;
  i2 = 0;
  i3 = 1;
  do {
   i2 = (HEAPU16[i4 + (i3 + -1 << 3) + 2 >> 1] | 0) + i2 | 0;
   HEAP32[i4 + (i3 << 3) + 4 >> 2] = i2;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i37, i14);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i15);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i39, i16);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i36, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i46 = 1;
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i40);
 STACKTOP = i41;
 return i46 | 0;
}

function __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i12, i14, i13, i1) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 24 | 0;
 i15 = i17;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = (HEAP32[i13 >> 2] | 0) < (i2 | 0);
 if ((i2 | 0) >= (i3 | 0)) {
  if (!i1) {
   i16 = 0;
   STACKTOP = i17;
   return i16 | 0;
  }
  HEAP32[i15 >> 2] = i2;
  i4 = i15 + 4 | 0;
  i11 = i14 + 4 | 0;
  i1 = HEAP32[i14 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  i6 = i15 + 8 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  i7 = i15 + 16 | 0;
  HEAP32[i7 >> 2] = i1;
  i10 = i14 + 8 | 0;
  i2 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i15 + 12 >> 2] = i3 + (i5 << 2);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i2 >> 2 << 2);
   }
  }
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  if ((i14 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0);
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  if ((i15 | 0) == (i13 | 0)) i1 = i13 + 4 | 0; else {
   i1 = i15 + 4 | 0;
   __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0);
  }
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i13 = HEAP32[i7 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  i1 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) >= (i1 | 0)) {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
  HEAP32[i15 >> 2] = i1;
  i4 = i15 + 4 | 0;
  i7 = i12 + 4 | 0;
  i1 = HEAP32[i12 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  i8 = i15 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  i9 = i15 + 16 | 0;
  HEAP32[i9 >> 2] = i1;
  i6 = i12 + 8 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i15 + 12 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  if ((i12 | 0) != (i14 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i10 >> 2] | 0);
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  i1 = i15 + 4 | 0;
  if ((i15 | 0) != (i14 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i15 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  i16 = 2;
  STACKTOP = i17;
  return i16 | 0;
 }
 if (i1) {
  HEAP32[i15 >> 2] = i3;
  i4 = i15 + 4 | 0;
  i7 = i12 + 4 | 0;
  i1 = HEAP32[i12 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  i8 = i15 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  i9 = i15 + 16 | 0;
  HEAP32[i9 >> 2] = i1;
  i6 = i12 + 8 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i15 + 12 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  if ((i12 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0);
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  if ((i15 | 0) == (i13 | 0)) i1 = i13 + 4 | 0; else {
   i1 = i15 + 4 | 0;
   __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
  }
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i15 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 HEAP32[i15 >> 2] = i3;
 i4 = i15 + 4 | 0;
 i7 = i12 + 4 | 0;
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i15 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i9 = i15 + 16 | 0;
 HEAP32[i9 >> 2] = i1;
 i6 = i12 + 8 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i15 + 12 >> 2] = i3 + (i5 << 2);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
  }
 }
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 if ((i12 | 0) != (i14 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i14 + 8 >> 2] | 0);
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 if ((i15 | 0) == (i14 | 0)) i1 = i14 + 4 | 0; else {
  i1 = i15 + 4 | 0;
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i14 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i12 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) >= (i1 | 0)) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 HEAP32[i15 >> 2] = i1;
 i4 = i15 + 4 | 0;
 i7 = i14 + 4 | 0;
 i1 = HEAP32[i14 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i15 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i9 = i15 + 16 | 0;
 HEAP32[i9 >> 2] = i1;
 i6 = i14 + 8 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i15 + 12 >> 2] = i3 + (i5 << 2);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
  }
 }
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 if ((i14 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0);
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 if ((i15 | 0) == (i13 | 0)) i1 = i13 + 4 | 0; else {
  i1 = i15 + 4 | 0;
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i15 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 i16 = 2;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx2Gu28distancePointTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_RS3_(i41, i43, i10, i11, i12, i46, i47, i42) {
 i41 = i41 | 0;
 i43 = i43 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 i42 = i42 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i44 = 0, i45 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i50 + 84 | 0;
 i13 = i50 + 72 | 0;
 i14 = i50 + 60 | 0;
 i27 = i50 + 48 | 0;
 i15 = i50 + 36 | 0;
 i45 = i50 + 24 | 0;
 i44 = i50 + 12 | 0;
 i48 = i50;
 f1 = Math_fround(HEAPF32[i11 >> 2]);
 i4 = i11 + 4 | 0;
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = i11 + 8 | 0;
 f20 = Math_fround(HEAPF32[i7 >> 2]);
 f37 = Math_fround(HEAPF32[i10 >> 2]);
 i8 = i10 + 4 | 0;
 f39 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i10 + 8 | 0;
 f40 = Math_fround(HEAPF32[i9 >> 2]);
 f28 = Math_fround(f1 - f37);
 f29 = Math_fround(f16 - f39);
 f30 = Math_fround(f20 - f40);
 f26 = Math_fround(HEAPF32[i12 >> 2]);
 i5 = i12 + 4 | 0;
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i12 + 8 | 0;
 f38 = Math_fround(HEAPF32[i6 >> 2]);
 f31 = Math_fround(f26 - f37);
 f32 = Math_fround(f25 - f39);
 f33 = Math_fround(f38 - f40);
 f17 = Math_fround(f26 - f1);
 f18 = Math_fround(f25 - f16);
 f19 = Math_fround(f38 - f20);
 f52 = Math_fround(HEAPF32[i43 >> 2]);
 i34 = i43 + 4 | 0;
 f51 = Math_fround(HEAPF32[i34 >> 2]);
 i35 = i43 + 8 | 0;
 f21 = Math_fround(HEAPF32[i35 >> 2]);
 f2 = Math_fround(f52 - f37);
 f22 = Math_fround(f51 - f39);
 f36 = Math_fround(f21 - f40);
 f3 = Math_fround(f52 - f1);
 f24 = Math_fround(f51 - f16);
 f23 = Math_fround(f21 - f20);
 f26 = Math_fround(f52 - f26);
 f25 = Math_fround(f51 - f25);
 f38 = Math_fround(f21 - f38);
 f21 = Math_fround(Math_fround(Math_fround(f28 * f2) + Math_fround(f29 * f22)) + Math_fround(f30 * f36));
 f36 = Math_fround(Math_fround(Math_fround(f31 * f2) + Math_fround(f32 * f22)) + Math_fround(f33 * f36));
 f22 = Math_fround(Math_fround(Math_fround(f28 * f3) + Math_fround(f29 * f24)) + Math_fround(f30 * f23));
 f23 = Math_fround(Math_fround(Math_fround(f31 * f3) + Math_fround(f32 * f24)) + Math_fround(f33 * f23));
 f24 = Math_fround(Math_fround(Math_fround(f28 * f26) + Math_fround(f29 * f25)) + Math_fround(f30 * f38));
 f38 = Math_fround(Math_fround(Math_fround(f31 * f26) + Math_fround(f32 * f25)) + Math_fround(f33 * f38));
 f25 = Math_fround(f23 - f22);
 f26 = Math_fround(f24 - f38);
 if (f21 < Math_fround(0.0) & f36 < Math_fround(0.0)) {
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  i48 = i46 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAPF32[i47 >> 2] = Math_fround(0.0);
  i48 = i47 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  f38 = Math_fround(HEAPF32[i43 >> 2]);
  f39 = Math_fround(HEAPF32[i34 >> 2]);
  f52 = Math_fround(HEAPF32[i35 >> 2]);
  f40 = Math_fround(HEAPF32[i10 >> 2]);
  f51 = Math_fround(HEAPF32[i8 >> 2]);
  f40 = Math_fround(f38 - f40);
  f51 = Math_fround(f39 - f51);
  f52 = Math_fround(f52 - Math_fround(HEAPF32[i9 >> 2]));
  HEAP32[i42 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
 if (f22 >= Math_fround(0.0) & f22 >= f23) {
  HEAPF32[i46 >> 2] = Math_fround(1.0);
  i48 = i46 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAPF32[i47 >> 2] = Math_fround(0.0);
  i48 = i47 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  f38 = Math_fround(HEAPF32[i43 >> 2]);
  f39 = Math_fround(HEAPF32[i34 >> 2]);
  f52 = Math_fround(HEAPF32[i35 >> 2]);
  f40 = Math_fround(HEAPF32[i11 >> 2]);
  f51 = Math_fround(HEAPF32[i4 >> 2]);
  f40 = Math_fround(f38 - f40);
  f51 = Math_fround(f39 - f51);
  f52 = Math_fround(f52 - Math_fround(HEAPF32[i7 >> 2]));
  HEAP32[i42 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
 if (f38 >= Math_fround(0.0) & f38 >= f24) {
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  i48 = i46 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAPF32[i47 >> 2] = Math_fround(1.0);
  i49 = i47 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  f38 = Math_fround(HEAPF32[i43 >> 2]);
  f39 = Math_fround(HEAPF32[i34 >> 2]);
  f52 = Math_fround(HEAPF32[i35 >> 2]);
  f40 = Math_fround(HEAPF32[i12 >> 2]);
  f51 = Math_fround(HEAPF32[i5 >> 2]);
  f40 = Math_fround(f38 - f40);
  f51 = Math_fround(f39 - f51);
  f52 = Math_fround(f52 - Math_fround(HEAPF32[i6 >> 2]));
  HEAP32[i42 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
 f3 = Math_fround(Math_fround(f21 * f23) - Math_fround(f22 * f36));
 if (f21 >= Math_fround(0.0) & f22 < Math_fround(0.0) & f3 < Math_fround(0.0)) {
  f51 = Math_fround(f21 / Math_fround(f21 - f22));
  f37 = Math_fround(f37 + Math_fround(f28 * f51));
  f38 = Math_fround(Math_fround(f29 * f51) + f39);
  f39 = Math_fround(Math_fround(f30 * f51) + f40);
  HEAPF32[i46 >> 2] = f51;
  i48 = i46 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAPF32[i47 >> 2] = Math_fround(0.0);
  i48 = i47 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  f40 = Math_fround(HEAPF32[i43 >> 2]);
  f51 = Math_fround(HEAPF32[i34 >> 2]);
  f40 = Math_fround(f40 - f37);
  f51 = Math_fround(f51 - f38);
  f52 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f39);
  HEAPF32[i42 >> 2] = f37;
  HEAPF32[i42 + 4 >> 2] = f38;
  HEAPF32[i42 + 8 >> 2] = f39;
  HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
 f2 = Math_fround(Math_fround(f22 * f38) - Math_fround(f24 * f23));
 if (f23 >= f22 & f24 >= f38 & f2 < Math_fround(0.0)) {
  f40 = Math_fround(f25 / Math_fround(f25 + f26));
  f37 = Math_fround(f1 + Math_fround(f17 * f40));
  f38 = Math_fround(Math_fround(f18 * f40) + f16);
  f39 = Math_fround(Math_fround(f19 * f40) + f20);
  HEAPF32[i46 >> 2] = Math_fround(Math_fround(1.0) - f40);
  i49 = i46 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAPF32[i47 >> 2] = f40;
  i49 = i47 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  f40 = Math_fround(HEAPF32[i43 >> 2]);
  f51 = Math_fround(HEAPF32[i34 >> 2]);
  f40 = Math_fround(f40 - f37);
  f51 = Math_fround(f51 - f38);
  f52 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f39);
  HEAPF32[i42 >> 2] = f37;
  HEAPF32[i42 + 4 >> 2] = f38;
  HEAPF32[i42 + 8 >> 2] = f39;
  HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
 f1 = Math_fround(Math_fround(f24 * f36) - Math_fround(f21 * f38));
 if (f36 >= Math_fround(0.0) & f38 < Math_fround(0.0) & f1 < Math_fround(0.0)) {
  f51 = Math_fround(f36 / Math_fround(f36 - f38));
  f37 = Math_fround(f37 + Math_fround(f31 * f51));
  f38 = Math_fround(Math_fround(f32 * f51) + f39);
  f39 = Math_fround(Math_fround(f33 * f51) + f40);
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  i48 = i46 + 4 | 0;
  HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
  HEAPF32[i47 >> 2] = f51;
  i49 = i47 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  f40 = Math_fround(HEAPF32[i43 >> 2]);
  f51 = Math_fround(HEAPF32[i34 >> 2]);
  f40 = Math_fround(f40 - f37);
  f51 = Math_fround(f51 - f38);
  f52 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f39);
  HEAPF32[i42 >> 2] = f37;
  HEAPF32[i42 + 4 >> 2] = f38;
  HEAPF32[i42 + 8 >> 2] = f39;
  HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 } else {
  f36 = Math_fround(Math_fround(1.0) / Math_fround(f2 + Math_fround(f1 + f3)));
  f26 = Math_fround(f1 * f36);
  f36 = Math_fround(f3 * f36);
  f38 = Math_fround(f37 + Math_fround(Math_fround(f28 * f26) + Math_fround(f31 * f36)));
  f51 = Math_fround(f39 + Math_fround(Math_fround(f29 * f26) + Math_fround(f32 * f36)));
  f52 = Math_fround(f40 + Math_fround(Math_fround(f30 * f26) + Math_fround(f33 * f36)));
  HEAPF32[i46 >> 2] = f26;
  i49 = i46 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAPF32[i47 >> 2] = f36;
  i49 = i47 + 4 | 0;
  HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAPF32[i42 >> 2] = f38;
  HEAPF32[i42 + 4 >> 2] = f51;
  HEAPF32[i42 + 8 >> 2] = f52;
  HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
  f40 = Math_fround(HEAPF32[i43 >> 2]);
  f39 = Math_fround(HEAPF32[i34 >> 2]);
  f40 = Math_fround(f40 - f38);
  f51 = Math_fround(f39 - f51);
  f52 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) - f52);
  HEAPF32[i41 >> 2] = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f51 * f51)) + Math_fround(f52 * f52));
  STACKTOP = i50;
  return;
 }
}

function __ZN5physx2Gu29computeCapsule_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbjRNS_10PxSweepHitE(i3, i70, i67, f7, f1, i69, i68, i4) {
 i3 = i3 | 0;
 i70 = i70 | 0;
 i67 = i67 | 0;
 f7 = Math_fround(f7);
 f1 = Math_fround(f1);
 i69 = i69 | 0;
 i68 = i68 | 0;
 i4 = i4 | 0;
 var f2 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, f103 = f0, f104 = f0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 6144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i89 + 4352 | 0;
 i64 = i89 + 80 | 0;
 i66 = i89 + 4348 | 0;
 i63 = i89 + 64 | 0;
 i87 = i89 + 4272 | 0;
 i61 = i89 + 4248 | 0;
 i85 = i89 + 48 | 0;
 i60 = i89 + 32 | 0;
 i86 = i89 + 16 | 0;
 i88 = i89 + 4244 | 0;
 i65 = i89;
 i62 = i89 + 4216 | 0;
 i59 = i89 + 4288 | 0;
 i58 = i89 + 4192 | 0;
 i56 = i89 + 4176 | 0;
 HEAP32[i66 >> 2] = 0;
 HEAPF32[i63 >> 2] = Math_fround(f7 * Math_fround(1.00999999));
 __ZN5physx2Gu9ContainerC2Ev(i87);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i87, 128, i89 + 5632 | 0, 1);
 HEAP32[i61 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i61 + 16 >> 2] = i3;
 HEAPF32[i61 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i61 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i61 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 i73 = i85 + 4 | 0;
 i74 = i85 + 8 | 0;
 HEAP32[i85 >> 2] = 0;
 HEAP32[i85 + 4 >> 2] = 0;
 HEAP32[i85 + 8 >> 2] = 0;
 HEAP32[i85 + 12 >> 2] = 0;
 HEAP32[i60 >> 2] = 0;
 HEAP32[i60 + 4 >> 2] = 0;
 HEAP32[i60 + 8 >> 2] = 0;
 HEAP32[i60 + 12 >> 2] = 0;
 i75 = i86 + 4 | 0;
 i76 = i86 + 8 | 0;
 i77 = i86 + 12 | 0;
 HEAP32[i86 >> 2] = 0;
 HEAP32[i86 + 4 >> 2] = 0;
 HEAP32[i86 + 8 >> 2] = 0;
 HEAP32[i86 + 12 >> 2] = 0;
 HEAP32[i88 >> 2] = 268435455;
 i22 = i87 + 4 | 0;
 i23 = i67 + 96 | 0;
 i24 = i67 + 100 | 0;
 i25 = i67 + 104 | 0;
 i26 = i67 + 108 | 0;
 i27 = i62 + 4 | 0;
 i28 = i62 + 8 | 0;
 i29 = i67 + 112 | 0;
 i30 = i67 + 116 | 0;
 i31 = i67 + 120 | 0;
 i32 = i67 + 124 | 0;
 i33 = i62 + 12 | 0;
 i34 = i62 + 16 | 0;
 i35 = i62 + 20 | 0;
 i36 = i62 + 24 | 0;
 i37 = i57 + 4 | 0;
 i38 = i57 + 8 | 0;
 i39 = i57 + 12 | 0;
 i40 = i59 + 36 | 0;
 i41 = i59 + 40 | 0;
 i42 = i59 + 44 | 0;
 i43 = i59 + 48 | 0;
 i44 = i59 + 52 | 0;
 i45 = i59 + 56 | 0;
 i46 = i58 + 4 | 0;
 i47 = i58 + 8 | 0;
 i48 = i58 + 12 | 0;
 i49 = i58 + 16 | 0;
 i50 = i58 + 20 | 0;
 i51 = i57 + 4 | 0;
 i52 = i87 + 8 | 0;
 i53 = i65 + 4 | 0;
 i54 = i67 + 128 | 0;
 i78 = i4 + 40 | 0;
 i79 = i4 + 16 | 0;
 i80 = i4 + 20 | 0;
 i81 = i4 + 24 | 0;
 i82 = i4 + 28 | 0;
 i83 = i4 + 32 | 0;
 i84 = i4 + 36 | 0;
 i72 = i4 + 8 | 0;
 i17 = i67 + 4 | 0;
 i18 = i67 + 8 | 0;
 i19 = i67 + 12 | 0;
 i20 = i67 + 96 | 0;
 i21 = i67 + 112 | 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 i55 = 0;
 i3 = 0;
 while (1) {
  if (HEAP32[i22 >> 2] | 0) HEAP32[i22 >> 2] = 0;
  i4 = HEAP32[i24 >> 2] | 0;
  i16 = HEAP32[i25 >> 2] | 0;
  HEAP32[i62 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i27 >> 2] = i4;
  HEAP32[i28 >> 2] = i16;
  i16 = HEAP32[i30 >> 2] | 0;
  i4 = HEAP32[i31 >> 2] | 0;
  HEAP32[i33 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i34 >> 2] = i16;
  HEAP32[i35 >> 2] = i4;
  HEAPF32[i36 >> 2] = f7;
  __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE(i62, i59);
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i57, i59);
  f6 = Math_fround(HEAPF32[i57 >> 2]);
  f104 = Math_fround(HEAPF32[i37 >> 2]);
  f102 = Math_fround(HEAPF32[i38 >> 2]);
  f100 = Math_fround(HEAPF32[i39 >> 2]);
  f95 = Math_fround(HEAPF32[i40 >> 2]);
  f97 = Math_fround(HEAPF32[i41 >> 2]);
  f96 = Math_fround(HEAPF32[i42 >> 2]);
  f91 = Math_fround(f6 + f6);
  f94 = Math_fround(f104 + f104);
  f101 = Math_fround(f102 + f102);
  f93 = Math_fround(f104 * f94);
  f98 = Math_fround(f102 * f101);
  f104 = Math_fround(f91 * f104);
  f103 = Math_fround(f91 * f102);
  f90 = Math_fround(f91 * f100);
  f102 = Math_fround(f94 * f102);
  f94 = Math_fround(f94 * f100);
  f100 = Math_fround(f101 * f100);
  f101 = Math_fround(Math_fround(Math_fround(1.0) - f93) - f98);
  f99 = Math_fround(f104 + f100);
  f92 = Math_fround(f103 - f94);
  f100 = Math_fround(f104 - f100);
  f91 = Math_fround(Math_fround(1.0) - Math_fround(f6 * f91));
  f98 = Math_fround(f91 - f98);
  f6 = Math_fround(f102 + f90);
  f94 = Math_fround(f103 + f94);
  f90 = Math_fround(f102 - f90);
  f93 = Math_fround(f91 - f93);
  f91 = Math_fround(HEAPF32[i43 >> 2]);
  f101 = Math_fround(f101 * f91);
  f99 = Math_fround(f99 * f91);
  f91 = Math_fround(f92 * f91);
  f92 = Math_fround(HEAPF32[i44 >> 2]);
  f100 = Math_fround(f100 * f92);
  f98 = Math_fround(f98 * f92);
  f92 = Math_fround(f6 * f92);
  f6 = Math_fround(HEAPF32[i45 >> 2]);
  f94 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f101))) + Math_fround(Math_abs(Math_fround(f100)))) + Math_fround(Math_abs(Math_fround(f94 * f6))));
  f90 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f99))) + Math_fround(Math_abs(Math_fround(f98)))) + Math_fround(Math_abs(Math_fround(f90 * f6))));
  f6 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f91))) + Math_fround(Math_abs(Math_fround(f92)))) + Math_fround(Math_abs(Math_fround(f93 * f6))));
  f93 = Math_fround(f97 - f90);
  f92 = Math_fround(f96 - f6);
  f91 = Math_fround(f95 + f94);
  f90 = Math_fround(f97 + f90);
  f6 = Math_fround(f96 + f6);
  HEAPF32[i58 >> 2] = Math_fround(f95 - f94);
  HEAPF32[i46 >> 2] = f93;
  HEAPF32[i47 >> 2] = f92;
  HEAPF32[i48 >> 2] = f91;
  HEAPF32[i49 >> 2] = f90;
  HEAPF32[i50 >> 2] = f6;
  HEAP32[i57 >> 2] = gb + 84656 + 8;
  HEAP32[i51 >> 2] = i87;
  __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i61, i70, i58, i68, i57) | 0;
  i4 = HEAP32[i22 >> 2] | 0;
  if (!i4) {
   i3 = i55;
   i71 = 5;
   break;
  }
  i8 = HEAP32[i52 >> 2] | 0;
  HEAPF32[i65 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i53 >> 2] = HEAP32[i56 >> 2];
  HEAP32[i53 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
  HEAP32[i53 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
  i9 = (i4 + 31 | 0) >>> 5;
  if (!i9) {
   i3 = i55;
   i71 = 14;
   break;
  }
  i13 = 0;
  i14 = 0;
  i15 = ~i4;
  while (1) {
   i10 = i15 >>> 0 > 4294967263 ? ~i15 : 32;
   i11 = i13 << 5;
   i12 = i4 - i11 | 0;
   i12 = i12 >>> 0 < 32 ? i12 : 32;
   if (i12 | 0) {
    i16 = 0;
    do {
     __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i61, i70, i57 + (i16 * 40 | 0) | 0, 0, 0, HEAP32[i8 + (i16 + i11 << 2) >> 2] | 0, 1, 1) | 0;
     HEAP8[i57 + (i16 * 40 | 0) + 36 >> 0] = 56;
     i16 = i16 + 1 | 0;
    } while ((i16 | 0) != (i10 | 0));
   }
   i14 = i14 | (__Z12calculateMTDRKN5physx2Gu8CapsuleVERKNS_6shdfnd3aos6FloatVEbPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS5_5Vec3VESG_SG_SE_RS6_(i67, i63, i69, i57, i12, i11, i64, i66, i86, i85, i60, i88, i65) | 0);
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i9 | 0)) break; else i15 = i15 + 32 | 0;
  }
  if (!i14) {
   i3 = i55;
   i71 = 14;
   break;
  }
  i4 = HEAP32[i8 + (HEAP32[i88 >> 2] << 2) >> 2] | 0;
  HEAP32[i88 >> 2] = i4;
  f6 = Math_fround(HEAPF32[i65 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i54 >> 2]));
  if (!(f6 <= Math_fround(0.0))) {
   i71 = 13;
   break;
  }
  f101 = Math_fround(HEAPF32[i67 >> 2]);
  f100 = Math_fround(HEAPF32[i17 >> 2]);
  f104 = Math_fround(HEAPF32[i18 >> 2]);
  f102 = Math_fround(HEAPF32[i86 >> 2]);
  f103 = Math_fround(HEAPF32[i75 >> 2]);
  f102 = Math_fround(f6 * f102);
  f103 = Math_fround(f6 * f103);
  f99 = Math_fround(f6 * Math_fround(HEAPF32[i76 >> 2]));
  f1 = Math_fround(f1 - f102);
  f2 = Math_fround(f2 - f103);
  f5 = Math_fround(f5 - f99);
  f102 = Math_fround(f101 - f102);
  f103 = Math_fround(f100 - f103);
  f99 = Math_fround(f104 - f99);
  f101 = Math_fround(f102 - f101);
  f100 = Math_fround(f103 - f100);
  f104 = Math_fround(f99 - f104);
  HEAPF32[i67 >> 2] = f102;
  HEAPF32[i17 >> 2] = f103;
  HEAPF32[i18 >> 2] = f99;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  f99 = Math_fround(HEAPF32[i20 >> 2]);
  f103 = Math_fround(HEAPF32[i24 >> 2]);
  f103 = Math_fround(f100 + f103);
  f102 = Math_fround(f104 + Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i20 >> 2] = Math_fround(f101 + f99);
  HEAPF32[i24 >> 2] = f103;
  HEAPF32[i25 >> 2] = f102;
  HEAPF32[i26 >> 2] = Math_fround(0.0);
  f102 = Math_fround(HEAPF32[i21 >> 2]);
  f103 = Math_fround(HEAPF32[i30 >> 2]);
  f103 = Math_fround(f100 + f103);
  f104 = Math_fround(f104 + Math_fround(HEAPF32[i31 >> 2]));
  HEAPF32[i21 >> 2] = Math_fround(f101 + f102);
  HEAPF32[i30 >> 2] = f103;
  HEAPF32[i31 >> 2] = f104;
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= 4) {
   f7 = f5;
   i3 = 1;
   break;
  } else i55 = 1;
 }
 if ((i71 | 0) == 5) f7 = f5; else if ((i71 | 0) == 13) if (!i3) {
  HEAPF32[i78 >> 2] = Math_fround(0.0);
  i78 = HEAP32[i73 >> 2] | 0;
  i88 = HEAP32[i74 >> 2] | 0;
  HEAP32[i79 >> 2] = HEAP32[i85 >> 2];
  HEAP32[i80 >> 2] = i78;
  HEAP32[i81 >> 2] = i88;
  i85 = HEAP32[i75 >> 2] | 0;
  i88 = HEAP32[i76 >> 2] | 0;
  HEAP32[i82 >> 2] = HEAP32[i86 >> 2];
  HEAP32[i83 >> 2] = i85;
  HEAP32[i84 >> 2] = i88;
  HEAP32[i72 >> 2] = i4;
  i88 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i87);
  STACKTOP = i89;
  return i88 | 0;
 } else {
  i3 = 1;
  i71 = 14;
 }
 if ((i71 | 0) == 14) f7 = f5;
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)))));
 f104 = Math_fround(Math_fround(1.0) / f6);
 f5 = Math_fround(f1 * f104);
 f2 = Math_fround(f2 * f104);
 f1 = Math_fround(f7 * f104);
 HEAPF32[i86 >> 2] = f5;
 HEAPF32[i75 >> 2] = f2;
 HEAPF32[i76 >> 2] = f1;
 HEAPF32[i77 >> 2] = Math_fround(0.0);
 if (!i3) {
  i88 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i87);
  STACKTOP = i89;
  return i88 | 0;
 }
 HEAPF32[i78 >> 2] = Math_fround(-f6);
 i78 = HEAP32[i73 >> 2] | 0;
 i86 = HEAP32[i74 >> 2] | 0;
 HEAP32[i79 >> 2] = HEAP32[i85 >> 2];
 HEAP32[i80 >> 2] = i78;
 HEAP32[i81 >> 2] = i86;
 HEAPF32[i82 >> 2] = f5;
 HEAPF32[i83 >> 2] = f2;
 HEAPF32[i84 >> 2] = f1;
 HEAP32[i72 >> 2] = HEAP32[i88 >> 2];
 i88 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i87);
 STACKTOP = i89;
 return i88 | 0;
}

function __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j(i7, i10, i11) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i12 + 64 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i10, i11, i7 + 236 | 0, gb + 115664 | 0, i8);
 i6 = HEAP32[i7 + 296 >> 2] | 0;
 i5 = HEAP32[i7 + 288 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i13 = i8;
  i4 = HEAP32[i13 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = i9;
 i4 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev(i9);
 mftCall_vii(i6 | 0, i8 | 0, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i10 + 4 | 0;
 __ZN5physx2Sn18writeAllPropertiesINS_18PxJointLinearLimitEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(HEAP32[i10 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0, HEAP32[i10 + 12 >> 2] | 0, HEAP32[i10 + 16 >> 2] | 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i7 + 304 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i13 = i9 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i10 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i8;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj431ENS_22PxRepXPropertyAccessorILj431ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_(i10, i9);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i7 + 320 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i13 = i9 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i10 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i8;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj432ENS_22PxRepXPropertyAccessorILj432ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_(i10, i9);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 i1 = i7 + 336 | 0;
 i2 = i11 + 7 | 0;
 i3 = i8;
 i4 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev(i8);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i10, i2, i1, gb + 115720 | 0, i8);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i7 + 352 | 0, i11 + 8 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i10, i7 + 368 | 0, i11 + 9 | 0);
 i5 = i7 + 392 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i1 = i9 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i8;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj436ENS_22PxRepXPropertyAccessorILj436ES4_ffEEEEvRKT0_(i10, i9);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i7 + 408 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i13 = i9 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i10 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i13 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i13 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj437ENS_22PxRepXPropertyAccessorILj437ES4_ffEEEEvRKT0_(i10, i9);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i13 = i11 + 13 | 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i13 = i11 + 13 | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN5physx31PxClothGeodesicTetherCookerImpl20findVertTriNeighborsEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i27 + 48 | 0;
 i1 = i27 + 56 | 0;
 i15 = i27 + 32 | 0;
 i12 = i27 + 16 | 0;
 i13 = i27 + 8 | 0;
 i14 = i27;
 i21 = i27 + 28 | 0;
 i24 = i27 + 24 | 0;
 HEAP32[i15 >> 2] = 0;
 i22 = i15 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i25 = i15 + 8 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i23 + 24 | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i15, i2);
  i19 = HEAP32[i26 >> 2] | 0;
  i5 = (i19 | 0) / 3 | 0;
  if ((i19 | 0) > 2) {
   i6 = i23 + 20 | 0;
   i7 = i12 + 4 | 0;
   i8 = i13 + 4 | 0;
   i9 = i14 + 4 | 0;
   i11 = 0;
   do {
    i10 = i11 * 3 | 0;
    HEAP32[i12 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i10 << 2) >> 2];
    HEAP32[i7 >> 2] = i11;
    i4 = HEAP32[i25 >> 2] | 0;
    i2 = HEAP32[i22 >> 2] | 0;
    if ((i4 & 2147483647) >>> 0 > i2 >>> 0) {
     i18 = i12;
     i19 = HEAP32[i18 + 4 >> 2] | 0;
     i3 = (HEAP32[i15 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i3 + 4 >> 2] = i19;
     i3 = i2 + 1 | 0;
     HEAP32[i22 >> 2] = i3;
     i2 = i4;
    } else {
     __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i15, i12) | 0;
     i3 = HEAP32[i22 >> 2] | 0;
     i2 = HEAP32[i25 >> 2] | 0;
    }
    HEAP32[i13 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i10 + 1 << 2) >> 2];
    HEAP32[i8 >> 2] = i11;
    if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
     i17 = i13;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = (HEAP32[i15 >> 2] | 0) + (i3 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     i3 = i3 + 1 | 0;
     HEAP32[i22 >> 2] = i3;
    } else {
     __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i15, i13) | 0;
     i3 = HEAP32[i22 >> 2] | 0;
     i2 = HEAP32[i25 >> 2] | 0;
    }
    HEAP32[i14 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i10 + 2 << 2) >> 2];
    HEAP32[i9 >> 2] = i11;
    if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
     i17 = i14;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = (HEAP32[i15 >> 2] | 0) + (i3 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     HEAP32[i22 >> 2] = i3 + 1;
    } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i15, i14) | 0;
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) < (i5 | 0));
  }
 }
 i19 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i22 >> 2] | 0;
 i18 = i20 + 4 | 0;
 HEAP8[i18 >> 0] = 0;
 HEAP32[i20 >> 2] = i1;
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i17 = 32;
  i5 = 0;
  i4 = 0;
  L21 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i15 = HEAP32[i19 + (i6 << 3) >> 2] | 0;
       i16 = HEAP32[i19 + (i5 << 3) >> 2] | 0;
       i5 = ((i15 | 0) == (i16 | 0) ? (HEAP32[i19 + (i6 << 3) + 4 >> 2] | 0) < (HEAP32[i19 + (i5 << 3) + 4 >> 2] | 0) : (i15 | 0) < (i16 | 0)) ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i19 + (i5 << 3) | 0;
       i16 = i19 + (i7 << 3) | 0;
       i15 = i13;
       i14 = HEAP32[i15 >> 2] | 0;
       i15 = HEAP32[i15 + 4 >> 2] | 0;
       i11 = i16;
       i12 = HEAP32[i11 + 4 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i13 + 4 >> 2] = i12;
       HEAP32[i16 >> 2] = i14;
       HEAP32[i16 + 4 >> 2] = i15;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L21;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = i8 + -2 | 0;
    i8 = i4;
    i4 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   }
   i14 = (i3 + i4 | 0) / 2 | 0;
   i15 = i19 + (i14 << 3) | 0;
   i13 = i19 + (i4 << 3) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i14 = i19 + (i14 << 3) + 4 | 0;
   i6 = HEAP32[i13 >> 2] | 0;
   i9 = i19 + (i4 << 3) + 4 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   if ((i5 | 0) == (i6 | 0) ? (HEAP32[i14 >> 2] | 0) < (i10 | 0) : (i5 | 0) < (i6 | 0)) {
    i10 = i13;
    i7 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i15;
    i16 = HEAP32[i12 + 4 >> 2] | 0;
    i6 = i13;
    HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i6 + 4 >> 2] = i16;
    i6 = i15;
    HEAP32[i6 >> 2] = i7;
    HEAP32[i6 + 4 >> 2] = i10;
    i6 = HEAP32[i13 >> 2] | 0;
    i10 = HEAP32[i9 >> 2] | 0;
   } else i7 = i5;
   i12 = i19 + (i3 << 3) | 0;
   i9 = HEAP32[i12 >> 2] | 0;
   i11 = i19 + (i3 << 3) + 4 | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   if ((i9 | 0) == (i6 | 0) ? (i5 | 0) < (i10 | 0) : (i9 | 0) < (i6 | 0)) {
    i5 = i13;
    i6 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i10 = i12;
    i16 = HEAP32[i10 + 4 >> 2] | 0;
    i7 = i13;
    HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 + 4 >> 2] = i16;
    i7 = i12;
    HEAP32[i7 >> 2] = i6;
    HEAP32[i7 + 4 >> 2] = i5;
    i7 = HEAP32[i15 >> 2] | 0;
    i5 = HEAP32[i11 >> 2] | 0;
   } else i6 = i9;
   if ((i6 | 0) == (i7 | 0) ? (i5 | 0) < (HEAP32[i14 >> 2] | 0) : (i6 | 0) < (i7 | 0)) {
    i14 = i15;
    i13 = HEAP32[i14 >> 2] | 0;
    i14 = HEAP32[i14 + 4 >> 2] | 0;
    i10 = i12;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i16 = i15;
    HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i16 + 4 >> 2] = i11;
    i16 = i12;
    HEAP32[i16 >> 2] = i13;
    HEAP32[i16 + 4 >> 2] = i14;
   }
   i10 = i3 + -1 | 0;
   i16 = i19 + (i10 << 3) | 0;
   i5 = i15;
   i12 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = i16;
   i13 = HEAP32[i11 + 4 >> 2] | 0;
   i14 = i15;
   HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i14 = i16;
   HEAP32[i14 >> 2] = i12;
   HEAP32[i14 + 4 >> 2] = i5;
   i14 = i19 + (i10 << 3) + 4 | 0;
   i5 = i4;
   while (1) {
    i11 = HEAP32[i14 >> 2] | 0;
    while (1) {
     i6 = i5 + 1 | 0;
     i7 = i19 + (i6 << 3) | 0;
     i15 = HEAP32[i7 >> 2] | 0;
     if ((i15 | 0) == (i12 | 0) ? (HEAP32[i19 + (i6 << 3) + 4 >> 2] | 0) < (i11 | 0) : (i15 | 0) < (i12 | 0)) i5 = i6; else {
      i13 = i7;
      i15 = i5;
      break;
     }
    }
    i5 = i10;
    do {
     i5 = i5 + -1 | 0;
     i9 = i19 + (i5 << 3) | 0;
     i10 = HEAP32[i9 >> 2] | 0;
    } while ((i12 | 0) == (i10 | 0) ? (i11 | 0) < (HEAP32[i19 + (i5 << 3) + 4 >> 2] | 0) : (i12 | 0) < (i10 | 0));
    i10 = i5;
    i5 = i13;
    i7 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if ((i6 | 0) >= (i10 | 0)) {
     i9 = i13;
     break;
    }
    i11 = i9;
    i15 = HEAP32[i11 + 4 >> 2] | 0;
    i12 = i13;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = i15;
    i12 = i9;
    HEAP32[i12 >> 2] = i7;
    HEAP32[i12 + 4 >> 2] = i5;
    i12 = HEAP32[i16 >> 2] | 0;
    i5 = i6;
   }
   i12 = i16;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i14 = i9;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i16 >> 2] = i7;
   HEAP32[i16 + 4 >> 2] = i5;
   if ((i6 - i4 | 0) < (i3 - i6 | 0)) {
    if (i8 >>> 0 < (i17 + -1 | 0) >>> 0) i5 = i17; else {
     i5 = i17 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i16 = _PxGetFoundation() | 0;
      i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
      i5 = mftCall_iiiiii(i13 | 0, i14 | 0, i5 | 0, (i16 ? gb + 738802 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i17 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i15;
    i4 = i15 + 2 | 0;
   } else {
    i6 = i15 + 2 | 0;
    if (i8 >>> 0 < (i17 + -1 | 0) >>> 0) i5 = i17; else {
     i5 = i17 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i16 = _PxGetFoundation() | 0;
      i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
      i5 = mftCall_iiiiii(i13 | 0, i14 | 0, i5 | 0, (i16 ? gb + 738802 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i17 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i15;
   }
   i17 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
  }
 }
 if (HEAP8[i18 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i20, HEAP32[i20 >> 2] | 0);
 i9 = i23 + 44 | 0;
 i7 = HEAP32[i23 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i9, i7, i21);
 i7 = i23 + 56 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 i8 = i23 + 64 | 0;
 if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i7, i1);
 i6 = HEAP32[i22 >> 2] | 0;
 if (i6 | 0) {
  i5 = i23 + 60 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i19 + (i1 << 3) >> 2] | 0;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   L92 : do if (i1 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0) do {
    if ((HEAP32[i19 + (i1 << 3) >> 2] | 0) != (i4 | 0)) break L92;
    i2 = HEAP32[i19 + (i1 << 3) + 4 >> 2] | 0;
    HEAP32[i24 >> 2] = i2;
    i3 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i7, i24) | 0;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0); while (0);
  } while (i1 >>> 0 < i6 >>> 0);
 }
 i26 = HEAP32[i25 >> 2] | 0;
 if ((i26 & 2147483647 | 0) == 0 | (i26 | 0) < 0 | (i19 | 0) == 0) {
  STACKTOP = i27;
  return;
 }
 i26 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0, i19 | 0);
 STACKTOP = i27;
 return;
}

function __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_(i26, i16, i6, i25, i1, i29, i4, i23, i7, i24, i17) {
 i26 = i26 | 0;
 i16 = i16 | 0;
 i6 = i6 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i29 = i29 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 i7 = i7 | 0;
 i24 = i24 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i36 + 112 | 0;
 i2 = i36 + 96 | 0;
 i34 = i36;
 i35 = i36 + 336 | 0;
 i27 = i36 + 320 | 0;
 i33 = i36 + 288 | 0;
 i30 = i36 + 176 | 0;
 i18 = i36 + 544 | 0;
 i19 = i36 + 536 | 0;
 if ((HEAP16[gb + 1110880 + 6 >> 1] | 0) > -1) {
  HEAP32[i34 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i31 >> 2] = HEAP32[i34 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110880 | 0, i31);
  i32 = gb + 1110880 | 0;
 } else i32 = 0;
 i28 = HEAP32[HEAP32[HEAP32[i29 + 32 >> 2] >> 2] >> 2] | 0;
 i3 = HEAP32[i28 + 20 >> 2] | 0;
 do if ((i4 | 0) == -1) {
  i15 = 0;
  i5 = 7;
 } else if ((i4 | 0) > -1 & (i3 | 0) > (i4 | 0)) {
  i15 = i4;
  i3 = i4 + 1 | 0;
  i5 = 7;
  break;
 } else {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = i3;
  __Z6FormatPKcz(i31, gb + 375503 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i31 + 11 >> 0] | 0) < 0 ? HEAP32[i31 >> 2] | 0 : i31, 0, gb + 375577 | 0, 731, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
  break;
 } while (0);
 if ((i5 | 0) == 7) {
  i14 = __Z12GetGfxDevicev() | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  HEAP32[i35 >> 2] = i1;
  i20 = i35 + 4 | 0;
  i21 = i35 + 68 | 0;
  i22 = i35 + 132 | 0;
  i2 = i21;
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = i20;
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = i22;
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  __ZN10Matrix4x4f8SetOrthoEffffff(i31, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(100.0)) | 0;
  mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 116 >> 2] | 0, i14 | 0, i31 | 0);
  mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 112 >> 2] | 0, i14 | 0, gb + 1162292 | 0);
  i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
  if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 1;
  if ((i23 & 1 | 0) != 0 | i1 | (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 780 >> 2] | 0, i14 | 0) | 0)) __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace(i6, i1 ? 2 : 0, i7);
  i1 = (i16 | 0) != 0;
  if (i1) i13 = Math_fround(HEAPF32[i16 + 72 >> 2]) < Math_fround(0.0); else i13 = 0;
  HEAPF32[i27 >> 2] = Math_fround(0.0);
  i2 = i27 + 8 | 0;
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAPF32[i27 + 4 >> 2] = Math_fround(0.0);
  i4 = i27 + 12 | 0;
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (i1) if ((HEAP32[i16 + 56 >> 2] | 0) == 6) {
   f37 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 136 >> 2] | 0, i16 | 0) | 0);
   HEAPF32[i2 >> 2] = Math_fround(f37 / Math_fround(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 100 >> 2] | 0, i16 | 0) | 0));
   f37 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0);
   HEAPF32[i4 >> 2] = Math_fround(f37 / Math_fround(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 104 >> 2] | 0, i16 | 0) | 0));
  }
  i8 = HEAP32[i25 + 124 >> 2] | 0;
  i4 = HEAP32[i25 + 128 >> 2] | 0;
  i7 = HEAP32[i25 + 132 >> 2] | 0;
  i6 = HEAP32[i25 + 136 >> 2] | 0;
  i5 = HEAP32[i25 + 140 >> 2] | 0;
  i9 = HEAP32[i25 + 144 >> 2] | 0;
  i11 = HEAP32[i25 + 148 >> 2] | 0;
  i12 = HEAP32[i25 + 152 >> 2] | 0;
  i10 = i26 + 4 | 0;
  HEAP32[i33 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i33 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i33 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i33 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i33 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i8;
  i8 = i26 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i4;
  i8 = i26 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i7;
  i8 = i26 + 16 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i6;
  i8 = i26 + 20 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i5;
  i8 = i26 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i9;
  i8 = i26 + 28 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i11;
  i8 = i26 + 32 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i12;
  HEAP32[i30 + 4 >> 2] = 1;
  HEAP32[i30 >> 2] = gb + 33952 + 8;
  i8 = gb + 64016 | 0;
  i12 = HEAP32[i8 + 4 >> 2] | 0;
  i11 = i34;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i30 + 32 >> 2] = 0;
  HEAP32[i30 + 44 >> 2] = 0;
  i11 = i30 + 48 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i30 + 36 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i34);
  i8 = i31;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i5 = i12;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = i9;
  i5 = gb + 64016 | 0;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i34;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i30 + 52 >> 2] = 0;
  HEAP32[i30 + 64 >> 2] = 0;
  i8 = i30 + 68 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i30 + 56 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i34);
  i5 = i31;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i9;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i7 = gb + 64016 | 0;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = i34;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  i5 = i30 + 72 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i30 + 84 >> 2] = 0;
  i6 = i30 + 88 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i30 + 76 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i34);
  i4 = i31;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i7;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i30 + 92 >> 2] = 0;
  HEAP32[i30 + 96 >> 2] = 0;
  i1 = gb + 64016 | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i30 + 100 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP8[i30 + 108 >> 0] = 1;
  i4 = i30 + 8 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  if (i23 & 2 | 0) {
   __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i30, gb + 1110892 | 0, i16);
   HEAP32[i18 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_(i30, gb + 1110892 | 0, i18, i19);
  }
  i4 = i25 + 12 | 0;
  i2 = i25 + 160 | 0;
  if ((i15 | 0) < (i3 | 0)) {
   i1 = i15;
   do {
    i25 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[i28 >> 2] | 0) + (i1 << 2) >> 2] | 0, HEAP32[i2 >> 2] | 0, i4, i26, i29, i1, 0, 0) | 0;
    mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 184 >> 2] | 0, i14 | 0, i30 | 0);
    __ZN14GraphicsHelper8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE(i14, i25, i13, i27);
    __Z15gpu_time_samplev();
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i30 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i6 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i7);
   HEAP32[i5 >> 2] = 0;
  }
  i1 = i30 + 52 | 0;
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i30 + 32 | 0;
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12);
   HEAP32[i1 >> 2] = 0;
  };
  HEAP32[i10 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i33 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i33 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i33 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i33 + 28 >> 2];
  i33 = HEAP32[i35 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 116 >> 2] | 0, i33 | 0, i22 | 0);
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 112 >> 2] | 0, i33 | 0, i21 | 0);
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 108 >> 2] | 0, i33 | 0, i20 | 0);
  i35 = HEAP32[i35 >> 2] | 0;
  i33 = mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 132 >> 2] | 0, i35 | 0) | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i35 >> 2] | 0) + 140 >> 2] | 0, i35 | 0) | 0, i33, i31);
  __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i31, i34);
  i33 = i35 + 1364 | 0;
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
  i33 = i34 + 16 | 0;
  i31 = i35 + 1380 | 0;
  HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  i31 = i34 + 32 | 0;
  i33 = i35 + 1396 | 0;
  HEAP32[i33 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  i33 = i34 + 48 | 0;
  i31 = i35 + 1412 | 0;
  HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
  i31 = i34 + 64 | 0;
  i33 = i35 + 1428 | 0;
  HEAP32[i33 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  i34 = i34 + 80 | 0;
  i35 = i35 + 1444 | 0;
  HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
 }
 if (!i32) {
  STACKTOP = i36;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i32);
 STACKTOP = i36;
 return;
}

function __ZN11NoiseModule15PreviewNoiseJobILi2EEEvP19PreviewNoiseJobData(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, i57 = 0, i58 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i55 + 288 | 0;
 i34 = i55 + 284 | 0;
 i37 = i55 + 280 | 0;
 i39 = i55 + 112 | 0;
 i40 = i55 + 64 | 0;
 i46 = i55 + 32 | 0;
 i53 = i55 + 16 | 0;
 i54 = i55;
 if ((HEAP16[gb + 1452304 + 6 >> 1] | 0) > -1) {
  HEAP32[i34 >> 2] = 0;
  HEAP32[i25 >> 2] = HEAP32[i34 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452304 | 0, i25);
  i27 = gb + 1452304 | 0;
 } else i27 = 0;
 i35 = HEAP32[i1 >> 2] | 0;
 f41 = Math_fround(_fmaxf(Math_fround(HEAPF32[i35 + 800 >> 2]), Math_fround(9.99999974e-06)));
 HEAPF32[i25 >> 2] = f41;
 HEAP32[i34 >> 2] = HEAP32[i35 + 816 >> 2];
 HEAP32[i37 >> 2] = HEAP32[i35 + 812 >> 2];
 f36 = Math_fround(HEAPF32[i35 + 1088 >> 2]);
 i38 = i1 + 8 | 0;
 i2 = HEAP32[i38 >> 2] | 0;
 f42 = Math_fround(i2 >>> 0);
 f43 = Math_fround((HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 HEAPF32[i39 + 4 >> 2] = Math_fround(inf);
 HEAP32[i39 >> 2] = 0;
 i44 = i39 + 8 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 32 >> 2] = Math_fround(inf);
 HEAP32[i39 + 28 >> 2] = 0;
 i44 = i39 + 36 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 60 >> 2] = Math_fround(inf);
 HEAP32[i39 + 56 >> 2] = 0;
 i44 = i39 + 64 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 88 >> 2] = Math_fround(inf);
 HEAP32[i39 + 84 >> 2] = 0;
 i44 = i39 + 92 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 116 >> 2] = Math_fround(inf);
 HEAP32[i39 + 112 >> 2] = 0;
 i44 = i39 + 120 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 HEAPF32[i39 + 144 >> 2] = Math_fround(inf);
 HEAP32[i39 + 140 >> 2] = 0;
 i44 = i39 + 148 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 HEAP32[i44 + 16 >> 2] = 0;
 f41 = Math_fround(Math_fround(1.0) / f41);
 f42 = Math_fround(Math_fround(1.0) / f42);
 f43 = Math_fround(Math_fround(1.0) / f43);
 i44 = i1 + 4 | 0;
 i3 = HEAP32[i44 >> 2] | 0;
 if (i3 >>> 0 < 4294967284) {
  i45 = i35 + 804 | 0;
  i28 = i40 + 4 | 0;
  i30 = i40 + 8 | 0;
  i32 = i40 + 12 | 0;
  i47 = i40 + 16 | 0;
  i29 = i40 + 20 | 0;
  i31 = i40 + 24 | 0;
  i33 = i40 + 28 | 0;
  i26 = i40 + 32 | 0;
  i48 = i35 + 808 | 0;
  i49 = i46 + 4 | 0;
  i50 = i46 + 8 | 0;
  i51 = i46 + 12 | 0;
  i52 = i35 + 1884 | 0;
  i15 = i1 + 16 | 0;
  i16 = i54 + 12 | 0;
  i17 = i54 + 8 | 0;
  i18 = i54 + 4 | 0;
  i19 = i53 + 4 | 0;
  i20 = i53 + 8 | 0;
  i21 = i53 + 12 | 0;
  i22 = i46 + 4 | 0;
  i23 = i46 + 8 | 0;
  i24 = i46 + 12 | 0;
  i14 = i3;
  i1 = i3;
  do {
   if (!i2) i2 = 0; else {
    f13 = Math_fround(Math_fround(f36 + Math_fround(f43 * Math_fround(i14 >>> 0))) * Math_fround(5.0));
    i8 = 0;
    f9 = Math_fround(0.0);
    f10 = Math_fround(2.0);
    f11 = Math_fround(3.0);
    f12 = Math_fround(1.0);
    do {
     i1 = HEAP16[i45 >> 1] | 0;
     if (!((i1 & 255) << 24 >> 24)) i3 = 0; else i3 = (i8 >>> 0) / (((i2 >>> 0) / 3 | 0) >>> 0) | 0;
     f4 = Math_fround(HEAPF32[i35 + 8 + (i3 * 264 | 0) + 80 >> 2]);
     f4 = Math_fround(Math_fround(f41 * f4) * ((i1 & 65535) > 255 ? f41 : Math_fround(1.0)));
     f6 = Math_fround(Math_fround(f42 * f12) * Math_fround(5.0));
     f7 = Math_fround(Math_fround(f42 * f10) * Math_fround(5.0));
     f5 = Math_fround(Math_fround(f42 * f11) * Math_fround(5.0));
     HEAPF32[i40 >> 2] = Math_fround(Math_fround(f42 * f9) * Math_fround(5.0));
     HEAPF32[i28 >> 2] = f6;
     HEAPF32[i30 >> 2] = f7;
     HEAPF32[i32 >> 2] = f5;
     HEAPF32[i47 >> 2] = f13;
     HEAPF32[i29 >> 2] = f13;
     HEAPF32[i31 >> 2] = f13;
     HEAPF32[i33 >> 2] = f13;
     HEAP32[i26 >> 2] = 0;
     HEAP32[i26 + 4 >> 2] = 0;
     HEAP32[i26 + 8 >> 2] = 0;
     HEAP32[i26 + 12 >> 2] = 0;
     __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i46, i40, i25, HEAP32[i48 >> 2] | 0, i34, i37);
     f5 = Math_fround(f4 * Math_fround(HEAPF32[i46 >> 2]));
     f7 = Math_fround(f4 * Math_fround(HEAPF32[i49 >> 2]));
     f6 = Math_fround(f4 * Math_fround(HEAPF32[i50 >> 2]));
     f4 = Math_fround(f4 * Math_fround(HEAPF32[i51 >> 2]));
     HEAPF32[i46 >> 2] = f5;
     HEAPF32[i49 >> 2] = f7;
     HEAPF32[i50 >> 2] = f6;
     HEAPF32[i51 >> 2] = f4;
     if (HEAP8[i52 >> 0] | 0) {
      f56 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
      f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
      f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
      f7 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
      i1 = f56 < Math_fround(0.0);
      f4 = i1 ? Math_fround(0.0) : f56;
      i1 = f5 < Math_fround(0.0);
      f5 = i1 ? Math_fround(0.0) : f5;
      i1 = f6 < Math_fround(0.0);
      f6 = i1 ? Math_fround(0.0) : f6;
      i1 = f7 < Math_fround(0.0);
      f7 = i1 ? Math_fround(0.0) : f7;
      i1 = f4 > Math_fround(1.0);
      f4 = i1 ? Math_fround(1.0) : f4;
      i1 = f5 > Math_fround(1.0);
      f5 = i1 ? Math_fround(1.0) : f5;
      i1 = f6 > Math_fround(1.0);
      f6 = i1 ? Math_fround(1.0) : f6;
      i1 = f7 > Math_fround(1.0);
      f7 = i1 ? Math_fround(1.0) : f7;
      HEAPF32[i46 >> 2] = f4;
      HEAPF32[i49 >> 2] = f5;
      HEAPF32[i50 >> 2] = f6;
      HEAPF32[i51 >> 2] = f7;
      i1 = i35 + 1092 + (i3 * 264 | 0) | 0;
      HEAPF32[i16 >> 2] = Math_fround(1.0);
      HEAPF32[i17 >> 2] = Math_fround(1.0);
      HEAPF32[i18 >> 2] = Math_fround(1.0);
      HEAPF32[i54 >> 2] = Math_fround(1.0);
      i2 = HEAP32[i35 + 1092 + (i3 * 264 | 0) + 84 >> 2] | 0;
      L17 : do switch ((i2 & 65535) << 16 >> 16) {
      case 0:
       {
        i3 = HEAP32[i35 + 1092 + (i3 * 264 | 0) + 80 >> 2] | 0;
        HEAP32[i21 >> 2] = i3;
        HEAP32[i20 >> 2] = i3;
        HEAP32[i19 >> 2] = i3;
        HEAP32[i53 >> 2] = i3;
        break;
       }
      case 3:
       {
        f56 = Math_fround(HEAPF32[(HEAP32[i35 + 1092 + (i3 * 264 | 0) + 232 >> 2] | 0) + 4 >> 2]);
        f7 = Math_fround(HEAPF32[i35 + 1092 + (i3 * 264 | 0) + 80 >> 2]);
        f56 = Math_fround(f56 * f7);
        f56 = Math_fround(f56 + Math_fround(Math_fround(f7 * Math_fround(HEAPF32[(HEAP32[i35 + 1092 + (i3 * 264 | 0) + 144 >> 2] | 0) + 4 >> 2])) - f56));
        HEAPF32[i53 >> 2] = f56;
        HEAPF32[i19 >> 2] = f56;
        HEAPF32[i20 >> 2] = f56;
        HEAPF32[i21 >> 2] = f56;
        break;
       }
      default:
       if (!(i2 & 16711680)) {
        __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i53, i1, i39 + (i3 * 56 | 0) | 0, i46, i54);
        break L17;
       } else {
        __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i53, i1, i46, i54);
        break L17;
       }
      } while (0);
      i57 = HEAP32[i53 >> 2] | 0;
      i1 = HEAP32[i19 >> 2] | 0;
      i2 = HEAP32[i20 >> 2] | 0;
      i3 = HEAP32[i21 >> 2] | 0;
      HEAP32[i46 >> 2] = i57;
      HEAP32[i49 >> 2] = i1;
      HEAP32[i50 >> 2] = i2;
      HEAP32[i51 >> 2] = i3;
      f5 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     }
     f56 = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(.5));
     f5 = Math_fround(Math_fround(f7 * Math_fround(.5)) + Math_fround(.5));
     f6 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
     f7 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
     i2 = f56 < Math_fround(0.0);
     f56 = i2 ? Math_fround(0.0) : f56;
     i2 = f5 < Math_fround(0.0);
     f5 = i2 ? Math_fround(0.0) : f5;
     i2 = f6 < Math_fround(0.0);
     f6 = i2 ? Math_fround(0.0) : f6;
     i2 = f7 < Math_fround(0.0);
     f7 = i2 ? Math_fround(0.0) : f7;
     i2 = f56 > Math_fround(1.0);
     f56 = i2 ? Math_fround(1.0) : f56;
     i2 = f5 > Math_fround(1.0);
     f5 = i2 ? Math_fround(1.0) : f5;
     i2 = f6 > Math_fround(1.0);
     f6 = i2 ? Math_fround(1.0) : f6;
     i2 = f7 > Math_fround(1.0);
     f7 = i2 ? Math_fround(1.0) : f7;
     HEAPF32[i46 >> 2] = f56;
     HEAPF32[i49 >> 2] = f5;
     HEAPF32[i50 >> 2] = f6;
     HEAPF32[i51 >> 2] = f7;
     i2 = HEAP32[i38 >> 2] | 0;
     i57 = Math_imul(i2, i14) | 0;
     i3 = HEAP32[i15 >> 2] | 0;
     i1 = i8 + i57 | 0;
     HEAPF32[i3 + (i1 << 4) >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 4 >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f56;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 1) + i57 | 0;
     i58 = HEAP32[i22 >> 2] | 0;
     HEAP32[i3 + (i1 << 4) >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 4 >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 8 >> 2] = i58;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i1 = (i8 | 2) + i57 | 0;
     i58 = HEAP32[i23 >> 2] | 0;
     HEAP32[i3 + (i1 << 4) >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 4 >> 2] = i58;
     HEAP32[i3 + (i1 << 4) + 8 >> 2] = i58;
     HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
     i57 = (i8 | 3) + i57 | 0;
     i1 = HEAP32[i24 >> 2] | 0;
     HEAP32[i3 + (i57 << 4) >> 2] = i1;
     HEAP32[i3 + (i57 << 4) + 4 >> 2] = i1;
     HEAP32[i3 + (i57 << 4) + 8 >> 2] = i1;
     HEAPF32[i3 + (i57 << 4) + 12 >> 2] = Math_fround(1.0);
     i8 = i8 + 4 | 0;
     f9 = Math_fround(f9 + Math_fround(4.0));
     f12 = Math_fround(f12 + Math_fround(4.0));
     f10 = Math_fround(f10 + Math_fround(4.0));
     f11 = Math_fround(f11 + Math_fround(4.0));
    } while (i8 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i44 >> 2] | 0;
   }
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < (i1 + 12 | 0) >>> 0);
 }
 if (!i27) {
  STACKTOP = i55;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i27);
 STACKTOP = i55;
 return;
}

function __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i26, i19, i24) {
 i26 = i26 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 208 | 0;
 i21 = i30 + 204 | 0;
 i22 = i30 + 168 | 0;
 i23 = i30 + 96 | 0;
 i17 = i30 + 136 | 0;
 i18 = i30 + 64 | 0;
 i25 = i30 + 32 | 0;
 i28 = i30;
 i29 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[i26 + 36 >> 2] | 0, 0, 0) | 0;
 i12 = HEAP32[i26 + 28 >> 2] | 0;
 i20 = i24 + 24 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 i16 = i17 + 24 | 0;
 i2 = i20;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i14 = i16;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 HEAP8[i17 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i17, i24);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 i14 = i23 + 24 | 0;
 i13 = i16;
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 i4 = i14;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP8[i23 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i23, i17);
 i4 = i23 + 32 | 0;
 HEAP32[i4 >> 2] = i19;
 HEAP32[i22 >> 2] = 0;
 i2 = i22 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i13 = i22 + 24 | 0;
 i1 = i14;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i13;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i11;
 i3 = i22 + 4 | 0;
 HEAP8[i3 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i22, i23);
 i11 = i22 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 i4 = i12 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  HEAP32[i21 >> 2] = i4;
  i2 = i4;
  i3 = i4;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  i9 = HEAP32[i22 >> 2] | 0;
  i9 = (i9 | 0) == 0 ? i3 : i9;
  while (1) {
   i7 = HEAP32[i1 + 16 >> 2] | 0;
   i8 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = i10 >>> 0 > i8 >>> 0 ? i8 : i10;
   L6 : do if (!i2) i15 = 5; else {
    i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
    i4 = i9;
    while (1) {
     i5 = HEAP8[i4 >> 0] | 0;
     i6 = HEAP8[i3 >> 0] | 0;
     if (i5 << 24 >> 24 != i6 << 24 >> 24) break;
     i2 = i2 + -1 | 0;
     if (!i2) {
      i15 = 5;
      break L6;
     } else {
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     }
    }
    i2 = (i5 & 255) - (i6 & 255) | 0;
   } while (0);
   if ((i15 | 0) == 5) {
    i15 = 0;
    i2 = i10 - i8 | 0;
   }
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i15 = 11;
     break;
    } else i1 = i2;
   } else {
    i2 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
    L18 : do if (!i2) i15 = 14; else {
     i6 = i9;
     i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
     while (1) {
      i4 = HEAP8[i3 >> 0] | 0;
      i5 = HEAP8[i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i15 = 14;
       break L18;
      } else {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
      }
     }
     i2 = (i4 & 255) - (i5 & 255) | 0;
    } while (0);
    if ((i15 | 0) == 14) {
     i15 = 0;
     i2 = i8 - i10 | 0;
    }
    if ((i2 | 0) >= 0) {
     i15 = 22;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i15 = 21;
     break;
    } else i1 = i2;
   }
  }
  if ((i15 | 0) == 11) {
   HEAP32[i21 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i15 | 0) == 21) {
   HEAP32[i21 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i15 | 0) == 22) {
   HEAP32[i21 >> 2] = i1;
   i2 = i1;
   i3 = i21;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  HEAP32[i27 >> 2] = 6;
  HEAP32[i27 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
  i18 = i1 + 16 | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = i1 + 40 | 0;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i10;
  HEAP8[i1 + 20 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i18, i22);
  HEAP32[i1 + 48 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i12 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 4 >> 2] | 0, i1);
  i1 = i12 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i22 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  i1 = HEAP32[i23 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i23 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  i1 = HEAP32[i17 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i17 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 } else {
  i2 = (HEAP32[i24 + 20 >> 2] | 0) == 0;
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i22 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  i1 = HEAP32[i23 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i23 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  i1 = HEAP32[i17 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i17 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  if (!i2) {
   __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i18, gb + 371095 | 0, i24);
   HEAP32[i27 >> 2] = 0;
   i1 = i27 + 20 | 0;
   HEAP32[i1 >> 2] = 0;
   i4 = i27 + 24 | 0;
   i17 = gb + 64016 | 0;
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   i3 = i4;
   HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = i27 + 4 | 0;
   HEAP8[i3 >> 0] = 0;
   i2 = (HEAP32[i18 + 20 >> 2] | 0) + 19 | 0;
   if (i2 >>> 0 >= 15) __ZN4core20StringStorageDefaultIcE10reallocateEj(i27, i2);
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i27, i18);
   __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i27, HEAP32[i1 >> 2] | 0, 0, gb + 370962 | 0, 19);
   if (!i26) i1 = 0; else i1 = HEAP32[i26 + 4 >> 2] | 0;
   i17 = HEAP32[i27 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i17 | 0) == 0 ? i3 : i17, 0, gb + 370982 | 0, 90, 4, i1, 0, 0);
   i1 = HEAP32[i27 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i27 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
   i1 = HEAP32[i18 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i18 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i18 + 24 | 0);
  }
 }
 i5 = HEAP32[i26 + 32 >> 2] | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 i8 = i25 + 24 | 0;
 i7 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP8[i25 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i25, i24);
 HEAP32[i23 >> 2] = i19;
 i2 = i23 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 0;
 i7 = i23 + 28 | 0;
 i20 = i8;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i6 + 4 >> 2] = i19;
 HEAP8[i23 + 8 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i25);
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 i2 = i22 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 0;
 i6 = i22 + 28 | 0;
 i19 = i7;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 HEAP8[i22 + 8 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i23 + 4 | 0);
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i21 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  i4 = HEAP32[i22 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i15 = 62;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i15 = 67;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i15 = 66;
     break;
    } else i1 = i2;
   }
  }
  if ((i15 | 0) == 62) {
   HEAP32[i21 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i15 | 0) == 66) {
   HEAP32[i21 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i15 | 0) == 67) {
   HEAP32[i21 >> 2] = i1;
   i4 = i1;
   i3 = i21;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i27 >> 2] = 6;
  HEAP32[i27 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = HEAP32[i22 >> 2];
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  i19 = i6;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i1 + 44 | 0;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
  HEAP8[i1 + 24 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i22 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i5 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i1);
  i2 = i5 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = 0;
 } else i2 = 1;
 i1 = HEAP32[i22 + 4 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i22 + 8 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 i1 = HEAP32[i23 + 4 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i23 + 8 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 i1 = HEAP32[i25 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i25 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 if (i2) {
  __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i28, gb + 371120 | 0, i24);
  HEAP32[i27 >> 2] = 0;
  i1 = i27 + 20 | 0;
  HEAP32[i1 >> 2] = 0;
  i4 = i27 + 24 | 0;
  i25 = gb + 64016 | 0;
  i2 = HEAP32[i25 + 4 >> 2] | 0;
  i3 = i4;
  HEAP32[i3 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  i3 = i27 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  i2 = (HEAP32[i28 + 20 >> 2] | 0) + 19 | 0;
  if (i2 >>> 0 >= 15) __ZN4core20StringStorageDefaultIcE10reallocateEj(i27, i2);
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i27, i28);
  __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i27, HEAP32[i1 >> 2] | 0, 0, gb + 370962 | 0, 19);
  if (!i26) i1 = 0; else i1 = HEAP32[i26 + 4 >> 2] | 0;
  i26 = HEAP32[i27 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i26 | 0) == 0 ? i3 : i26, 0, gb + 370982 | 0, 93, 4, i1, 0, 0);
  i1 = HEAP32[i27 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i27 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
  i1 = HEAP32[i28 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i28 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i28 + 24 | 0);
 }
 if (!i29) {
  STACKTOP = i30;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i30;
 return;
}

function __ZN14RenderSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 7);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381350 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 312 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = i1 + 320 | 0;
 i9 = HEAP32[gb + 36980 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381356 | 0, i9, i8, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381367 | 0, i8, i1 + 316 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381377 | 0, i7, i1 + 344 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381390 | 0, i7, i1 + 336 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381407 | 0, i7, i1 + 340 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381422 | 0, i9, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381440 | 0, i9, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381462 | 0, i9, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381483 | 0, i7, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381502 | 0, i8, i1 + 188 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 360 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381516 | 0, gb + 946436 | 0, i6, 0);
 i9 = i10 + 8 | 0;
 i11 = i9;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381533 | 0, i7, i1 + 300 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381548 | 0, i7, i1 + 304 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381564 | 0, i7, i1 + 308 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 352 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381581 | 0, gb + 1034905 | 0, i7, 0);
 i9 = i10 + 8 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 348 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381595 | 0, gb + 1034905 | 0, i9, 0);
 i7 = i10 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381608 | 0, i8, i1 + 368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381632 | 0, i8, i1 + 372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381662 | 0, i8, i1 + 376 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381682 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 380 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381704 | 0, gb + 381723 | 0, i7, 0);
 i6 = i10 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381737 | 0, gb + 590318 | 0, i6, 0);
 __ZN20SphericalHarmonicsL28TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 384 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381752 | 0, gb + 381723 | 0, i6, 0);
 i8 = i10 + 8 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 388 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381780 | 0, gb + 619515 | 0, i8, 0);
 i6 = i10 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 392 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381786 | 0, HEAP32[gb + 36980 >> 2] | 0, i1, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManagerC2E10MemLabelId18ObjectCreationMode(i17, i1, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 16 | 0;
 i12 = i19;
 i7 = i19 + 8 | 0;
 i18 = i19 + 24 | 0;
 i5 = i1;
 i6 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i17, i11, i2);
 i7 = i17 + 28 | 0;
 HEAP32[i17 >> 2] = gb + 113148 + 8;
 HEAP32[i7 >> 2] = gb + 113148 + 140;
 HEAP32[i17 + 60 >> 2] = 0;
 i1 = i17 + 104 | 0;
 HEAP32[i17 + 108 >> 2] = 0;
 HEAP32[i17 + 112 >> 2] = 0;
 i2 = i17 + 108 | 0;
 i3 = i17 + 68 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = i2;
 i16 = gb + 63400 | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i12;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 HEAP32[i17 + 116 >> 2] = 0;
 HEAP32[i17 + 128 >> 2] = 0;
 HEAP32[i17 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i14 = i11;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i16 = i17 + 120 | 0;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = i13;
 HEAP32[i17 + 140 >> 2] = 0;
 HEAP32[i17 + 144 >> 2] = 0;
 HEAP32[i17 + 136 >> 2] = i17 + 140;
 i16 = gb + 63400 | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i12;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 HEAP32[i17 + 148 >> 2] = 0;
 HEAP32[i17 + 160 >> 2] = 0;
 HEAP32[i17 + 164 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i14 = i11;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i16 = i17 + 152 | 0;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = i13;
 i16 = i17 + 176 | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i5;
 HEAP32[i16 >> 2] = 0;
 i13 = i17 + 188 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i17 + 192 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i17 + 180 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i5 = i11;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i15;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i17 + 196 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 200 >> 2] = i1;
 i1 = i17 + 204 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 208 >> 2] = i1;
 i1 = i17 + 212 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 216 >> 2] = i1;
 i1 = i17 + 220 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 224 >> 2] = i1;
 i1 = i17 + 228 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 232 >> 2] = i1;
 i1 = i17 + 236 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 240 >> 2] = i1;
 i1 = i17 + 244 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 248 >> 2] = i1;
 i1 = i17 + 252 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 256 >> 2] = i1;
 i1 = i17 + 260 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 264 >> 2] = i1;
 i1 = i17 + 268 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 272 >> 2] = i1;
 i1 = i17 + 276 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 280 >> 2] = i1;
 i1 = i17 + 284 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 288 >> 2] = i1;
 i1 = i17 + 292 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 296 >> 2] = i1;
 i1 = i17 + 300 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 304 >> 2] = i1;
 i1 = i17 + 308 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 312 >> 2] = i1;
 i1 = i17 + 316 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 320 >> 2] = i1;
 i1 = i17 + 324 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 328 >> 2] = i1;
 i1 = i17 + 332 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 336 >> 2] = i1;
 i1 = i17 + 340 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 344 >> 2] = i1;
 i1 = i17 + 348 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 352 >> 2] = i1;
 i1 = i17 + 356 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 360 >> 2] = i1;
 i1 = i17 + 364 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 368 >> 2] = i1;
 i1 = i17 + 372 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 376 >> 2] = i1;
 i1 = i17 + 380 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 384 >> 2] = i1;
 i1 = i17 + 388 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 392 >> 2] = i1;
 i1 = i17 + 396 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 400 >> 2] = i1;
 i1 = i17 + 404 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 408 >> 2] = i1;
 i1 = i17 + 412 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 416 >> 2] = i1;
 i1 = i17 + 420 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 424 >> 2] = i1;
 i1 = i17 + 428 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 432 >> 2] = i1;
 i1 = i17 + 436 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 440 >> 2] = i1;
 i1 = i17 + 444 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 448 >> 2] = i1;
 i1 = i17 + 452 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 456 >> 2] = i1;
 i1 = i17 + 460 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 464 >> 2] = i1;
 i1 = i17 + 468 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 472 >> 2] = i1;
 i1 = i17 + 476 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 480 >> 2] = i1;
 i1 = i17 + 484 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 488 >> 2] = i1;
 i1 = i17 + 492 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 496 >> 2] = i1;
 i1 = i17 + 500 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 504 >> 2] = i1;
 i1 = i17 + 508 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 512 >> 2] = i1;
 i1 = i17 + 516 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 520 >> 2] = i1;
 i1 = i17 + 524 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 528 >> 2] = i1;
 i1 = i17 + 532 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 536 >> 2] = i1;
 i1 = i17 + 540 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 544 >> 2] = i1;
 i1 = i17 + 548 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 552 >> 2] = i1;
 i1 = i17 + 556 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 560 >> 2] = i1;
 i1 = i17 + 564 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 568 >> 2] = i1;
 i1 = i17 + 572 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 576 >> 2] = i1;
 i1 = i17 + 580 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 584 >> 2] = i1;
 i1 = i17 + 588 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 592 >> 2] = i1;
 i1 = i17 + 596 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 600 >> 2] = i1;
 i1 = i17 + 604 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 608 >> 2] = i1;
 i1 = i17 + 612 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 616 >> 2] = i1;
 i1 = i17 + 620 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 624 >> 2] = i1;
 i1 = i17 + 628 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 632 >> 2] = i1;
 i1 = i17 + 636 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 640 >> 2] = i1;
 i1 = i17 + 644 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 648 >> 2] = i1;
 i1 = i17 + 652 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 656 >> 2] = i1;
 i1 = i17 + 660 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 664 >> 2] = i1;
 i1 = i17 + 668 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 672 >> 2] = i1;
 i1 = i17 + 676 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 680 >> 2] = i1;
 i1 = i17 + 684 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 688 >> 2] = i1;
 i1 = i17 + 692 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 696 >> 2] = i1;
 i1 = i17 + 700 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 704 >> 2] = i1;
 i1 = i17 + 708 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 712 >> 2] = i1;
 i1 = i17 + 716 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i17 + 720 >> 2] = i1;
 i1 = i17 + 724 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i17 + 728 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i17 + 732 >> 2] = 0;
 __ZN5Unity12PhysicsQueryC2Ev(i17 + 736 | 0);
 HEAP8[i17 + 56 >> 0] = 1;
 HEAP8[i17 + 798 >> 0] = 0;
 HEAP8[i17 + 57 >> 0] = 0;
 HEAPF32[i17 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 36 >> 2] = Math_fround(-9.81000041);
 HEAPF32[i17 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 52 >> 2] = Math_fround(2.0);
 HEAP32[i11 >> 2] = -1;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i5 - i3 >> 2;
 if (i2 >>> 0 < 32) __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEjRKj(i1, 32 - i2 | 0, i11); else if ((i2 | 0) != 32) {
  i1 = i3 + 128 | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
 }
 HEAP32[i17 + 168 >> 2] = 6;
 HEAP32[i17 + 172 >> 2] = 1;
 HEAP8[i17 + 58 >> 0] = 1;
 HEAPF32[i17 + 44 >> 2] = Math_fround(.00499999989);
 HEAPF32[i17 + 48 >> 2] = Math_fround(.00999999977);
 HEAP8[i17 + 797 >> 0] = 1;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN14PhysicsManager20SetupDefaultMaterialEv(i17);
 i10 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 164 >> 2] | 0, i10 | 0, 0, 0);
 i10 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 164 >> 2] | 0, i10 | 0, i7 | 0, 0);
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i12;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i18 >> 2] = 0;
 i8 = i18 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i18 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i12 = i11;
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE(gb + 32548 | 0, i18, 1);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i14 >> 2] = i1;
   HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i16 >> 2] = i12;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (i1 | 0) {
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i14 >> 2] = i2;
     HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i12 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
     HEAP32[i14 >> 2] = i2;
     HEAP32[i16 >> 2] = i12;
     break;
    }
   } while (0);
   HEAP32[i13 >> 2] = i5;
   HEAP32[(HEAP32[i16 >> 2] | 0) + (i4 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 HEAP8[i17 + 796 >> 0] = HEAP8[gb + 67048 + 36 >> 0] ^ 1;
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i10);
  HEAP32[i18 >> 2] = 0;
 }
 STACKTOP = i19;
 return;
}

function __ZN5physx2Gu11gjkRelativeINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i40, i39, i54, i55, i56, i57) {
 i1 = i1 | 0;
 i40 = i40 | 0;
 i39 = i39 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, i72 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i58 + 240 | 0;
 i51 = i58 + 176 | 0;
 i52 = i58 + 112 | 0;
 i27 = i58 + 96 | 0;
 i50 = i58 + 340 | 0;
 i44 = i58 + 80 | 0;
 i47 = i58 + 64 | 0;
 i48 = i58 + 48 | 0;
 i45 = i58 + 328 | 0;
 i49 = i58 + 32 | 0;
 i41 = i58 + 16 | 0;
 i24 = i58;
 i23 = i58 + 316 | 0;
 i46 = i58 + 304 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i50 >> 2] = 0;
 i25 = i39 + 48 | 0;
 f8 = Math_fround(HEAPF32[i25 >> 2]);
 i31 = i39 + 52 | 0;
 f9 = Math_fround(HEAPF32[i31 >> 2]);
 i38 = i39 + 56 | 0;
 f10 = Math_fround(HEAPF32[i38 >> 2]);
 i42 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f12 = i42 ? f8 : Math_fround(1.0);
 f11 = i42 ? f9 : Math_fround(0.0);
 f7 = i42 ? f10 : Math_fround(0.0);
 HEAPF32[i44 >> 2] = f12;
 i42 = i44 + 4 | 0;
 HEAPF32[i42 >> 2] = f11;
 i43 = i44 + 8 | 0;
 HEAPF32[i43 >> 2] = f7;
 HEAPF32[i44 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i40 + 32 >> 2]);
 f26 = Math_fround((f26 > f2 ? f2 : f26) * Math_fround(.100000001));
 f26 = Math_fround(f26 * f26);
 HEAP32[i47 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i48 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i49 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 i27 = i39 + 4 | 0;
 i28 = i39 + 8 | 0;
 i29 = i39 + 16 | 0;
 i30 = i39 + 20 | 0;
 i32 = i39 + 24 | 0;
 i33 = i39 + 32 | 0;
 i34 = i39 + 36 | 0;
 i35 = i39 + 40 | 0;
 i36 = i1 + 144 | 0;
 i37 = i1 + 148 | 0;
 i4 = i1 + 152 | 0;
 i13 = i41 + 4 | 0;
 i14 = i41 + 8 | 0;
 i15 = i24 + 4 | 0;
 i16 = i24 + 8 | 0;
 i17 = i24 + 12 | 0;
 i18 = i53 + 4 | 0;
 i19 = i53 + 8 | 0;
 i20 = i53 + 16 | 0;
 i21 = i53 + 20 | 0;
 i22 = i53 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  HEAP32[i49 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i49 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  f5 = Math_fround(-f12);
  f70 = Math_fround(-f11);
  f71 = Math_fround(-f7);
  f68 = Math_fround(HEAPF32[i39 >> 2]);
  f61 = Math_fround(f68 * f5);
  f65 = Math_fround(HEAPF32[i27 >> 2]);
  f61 = Math_fround(f61 + Math_fround(f65 * f70));
  f62 = Math_fround(HEAPF32[i28 >> 2]);
  f61 = Math_fround(f61 + Math_fround(f62 * f71));
  f67 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(f67 * f5);
  f64 = Math_fround(HEAPF32[i30 >> 2]);
  f69 = Math_fround(f69 + Math_fround(f64 * f70));
  f60 = Math_fround(HEAPF32[i32 >> 2]);
  f69 = Math_fround(f69 + Math_fround(f60 * f71));
  f66 = Math_fround(HEAPF32[i33 >> 2]);
  f5 = Math_fround(f66 * f5);
  f63 = Math_fround(HEAPF32[i34 >> 2]);
  f70 = Math_fround(f5 + Math_fround(f63 * f70));
  f5 = Math_fround(HEAPF32[i35 >> 2]);
  i72 = f61 > Math_fround(0.0);
  i59 = f69 > Math_fround(0.0);
  i1 = Math_fround(f70 + Math_fround(f5 * f71)) > Math_fround(0.0);
  f71 = Math_fround(HEAPF32[i36 >> 2]);
  f70 = Math_fround(HEAPF32[i37 >> 2]);
  f69 = Math_fround(HEAPF32[i4 >> 2]);
  f61 = Math_fround(-f71);
  f6 = Math_fround(-f70);
  f3 = Math_fround(-f69);
  f61 = i72 ? f71 : f61;
  f6 = i59 ? f70 : f6;
  f3 = i1 ? f69 : f3;
  f8 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f68 * f61) + Math_fround(f67 * f6)) + Math_fround(f66 * f3)));
  f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f65 * f61) + Math_fround(f64 * f6)) + Math_fround(f63 * f3)));
  f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f62 * f61) + Math_fround(f60 * f6)) + Math_fround(f5 * f3)));
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i41, i40, i44);
  f3 = Math_fround(HEAPF32[i41 >> 2]);
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f3 = Math_fround(f8 - f3);
  f5 = Math_fround(f9 - f5);
  f6 = Math_fround(f10 - Math_fround(HEAPF32[i14 >> 2]));
  f12 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f3 * f12) + Math_fround(f5 * f11)) + Math_fround(f6 * f7)));
  i1 = HEAP32[i50 >> 2] | 0;
  HEAPF32[i51 + (i1 << 4) >> 2] = f8;
  HEAPF32[i51 + (i1 << 4) + 4 >> 2] = f9;
  HEAPF32[i51 + (i1 << 4) + 8 >> 2] = f10;
  HEAPF32[i51 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i59 = i52 + (i1 << 4) | 0;
  HEAP32[i59 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i59 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i59 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i59 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  HEAPF32[i53 + (i1 << 4) >> 2] = f3;
  HEAPF32[i53 + (i1 << 4) + 4 >> 2] = f5;
  HEAPF32[i53 + (i1 << 4) + 8 >> 2] = f6;
  HEAPF32[i53 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f12) {
   i4 = 3;
   break;
  }
  HEAP32[i50 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i53 >> 2]);
    f5 = Math_fround(HEAPF32[i18 >> 2]);
    f6 = Math_fround(HEAPF32[i19 >> 2]);
    f7 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f3);
    f8 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f5);
    f9 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f6);
    f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
    if (!(f10 <= Math_fround(1.1920929e-07))) {
     f69 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f5 * f8)) - Math_fround(f3 * f7)) - Math_fround(f6 * f9)) / f10);
     i72 = f69 > Math_fround(1.0);
     f69 = i72 ? Math_fround(1.0) : f69;
     i72 = f69 > Math_fround(0.0);
     f69 = i72 ? f69 : Math_fround(0.0);
     f70 = Math_fround(f5 + Math_fround(f8 * f69));
     f71 = Math_fround(f6 + Math_fround(f9 * f69));
     HEAPF32[i24 >> 2] = Math_fround(f3 + Math_fround(f7 * f69));
     HEAPF32[i15 >> 2] = f70;
     HEAPF32[i16 >> 2] = f71;
     HEAPF32[i17 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i50 >> 2] = 1;
     HEAP32[i24 >> 2] = HEAP32[i53 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
     HEAP32[i24 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i53, i51, i52, i50);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i53, i51, i52, i50);
    break;
   }
  default:
   {
    HEAPF32[i24 >> 2] = f3;
    HEAPF32[i15 >> 2] = f5;
    HEAPF32[i16 >> 2] = f6;
    HEAPF32[i17 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i44 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i44 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  f5 = Math_fround(HEAPF32[i44 >> 2]);
  f6 = Math_fround(HEAPF32[i42 >> 2]);
  f7 = Math_fround(HEAPF32[i43 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
  HEAP32[i45 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i45 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i45 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  i1 = f2 > f3;
  if (!(f3 > f26 & i1)) {
   i4 = 14;
   break;
  }
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f9 = Math_fround(HEAPF32[i31 >> 2]);
  f10 = Math_fround(HEAPF32[i38 >> 2]);
  f2 = f3;
  f12 = f5;
  f11 = f6;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i53, i51, i52, i44, i54, i55, i1);
  f69 = Math_fround(HEAPF32[i44 >> 2]);
  f70 = Math_fround(HEAPF32[i42 >> 2]);
  f68 = Math_fround(HEAPF32[i43 >> 2]);
  f71 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f69 * f69) + Math_fround(f70 * f70)) + Math_fround(f68 * f68)))));
  f69 = Math_fround(-Math_fround(f69 * f71));
  f70 = Math_fround(-Math_fround(f70 * f71));
  f71 = Math_fround(-Math_fround(f68 * f71));
  HEAPF32[i57 >> 2] = f2;
  i72 = i57 + 4 | 0;
  HEAP32[i72 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i72 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i72 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAPF32[i56 >> 2] = f69;
  HEAPF32[i56 + 4 >> 2] = f70;
  HEAPF32[i56 + 8 >> 2] = f71;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  i72 = 0;
  STACKTOP = i58;
  return i72 | 0;
 } else if ((i4 | 0) == 14) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i53, i51, i52, i49, i54, i55, HEAP32[i50 >> 2] | 0);
  HEAP32[i54 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  HEAP32[i55 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
  f68 = Math_fround(HEAPF32[i49 >> 2]);
  f70 = Math_fround(HEAPF32[i49 + 4 >> 2]);
  f71 = Math_fround(HEAPF32[i49 + 8 >> 2]);
  f69 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f68 * f68) + Math_fround(f70 * f70)) + Math_fround(f71 * f71)))));
  f70 = Math_fround(-Math_fround(f70 * f69));
  f71 = Math_fround(-Math_fround(f71 * f69));
  HEAPF32[i56 >> 2] = Math_fround(-Math_fround(f68 * f69));
  HEAPF32[i56 + 4 >> 2] = f70;
  HEAPF32[i56 + 8 >> 2] = f71;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i57 >> 2] = i1 ? f3 : f2;
  i72 = i57 + 4 | 0;
  HEAP32[i72 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i72 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i72 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  i72 = i1 ? 1 : 3;
  STACKTOP = i58;
  return i72 | 0;
 }
 return 0;
}

function __ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i43, i41, i46, i39, i36, i35, f40) {
 i43 = i43 | 0;
 i41 = i41 | 0;
 i46 = i46 | 0;
 i39 = i39 | 0;
 i36 = i36 | 0;
 i35 = i35 | 0;
 f40 = Math_fround(f40);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i42 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i48;
 i47 = i48 + 48 | 0;
 i37 = i48 + 86 | 0;
 i34 = i48 + 40 | 0;
 i5 = i48 + 88 | 0;
 i42 = i48 + 32 | 0;
 i38 = i48 + 4 | 0;
 i31 = i48 + 84 | 0;
 i44 = i46 + 20 | 0;
 HEAP8[i44 >> 0] = 0;
 i45 = i46 + 32 | 0;
 HEAP32[i45 >> 2] = 0;
 i32 = i36 + 16 | 0;
 i8 = HEAP16[i32 >> 1] | 0;
 HEAP16[i37 >> 1] = i8;
 i4 = i43 + 80 | 0;
 i2 = i43 + 112 | 0;
 i33 = i8 & 65535;
 i1 = i43 + 4 | 0;
 if (!(HEAP8[i43 + 116 >> 0] | 0)) if ((i33 & 1 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0) == (HEAP32[i43 + 108 >> 2] | 0)) i6 = 9; else i6 = 4; else if (!(i33 & 1)) i6 = 9; else i6 = 4;
 if ((i6 | 0) == 4) if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i43, 0, 0, 0) | 0) == 1) i6 = 6; else if ((HEAP32[i1 >> 2] | 0) == -1) i6 = 7; else i6 = 9;
 do if ((i6 | 0) == 9) {
  if (!(HEAP8[i43 + 117 >> 0] | 0)) {
   if (!((i33 & 2 | 0) == 0 ? 1 : (HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0) == (HEAP32[i2 >> 2] | 0))) i6 = 69;
  } else if (i33 & 2 | 0) i6 = 69;
  if ((i6 | 0) == 69) {
   if ((__ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i43, 1, 0, 0) | 0) == 1) {
    i6 = 6;
    break;
   }
   if ((HEAP32[i1 >> 2] | 0) == -1) {
    i6 = 7;
    break;
   }
  }
  i3 = HEAP32[i43 + 88 >> 2] | 0;
  HEAP32[i34 >> 2] = i3;
  i30 = HEAP32[i43 + 100 >> 2] | 0;
  HEAP32[i34 + 4 >> 2] = i30;
  if (!(i3 | i30)) {
   i47 = 0;
   STACKTOP = i48;
   return i47 | 0;
  }
  i28 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
  i30 = HEAP32[i43 + 72 >> 2] | 0;
  i1 = HEAP32[i43 + 76 >> 2] | 0;
  i30 = i30 >>> 0 < i1 >>> 0 ? i1 : i30;
  i1 = i30 << 4;
  if (i30 >>> 0 < 128) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i30 = 0;
  } else {
   i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i5, i1, gb + 704671 | 0, 615) | 0;
   i30 = i2;
  }
  i14 = (HEAP16[i32 >> 1] & 32) != 0;
  i15 = i46 + 28 | 0;
  i16 = i41 + 12 | 0;
  i17 = i41 + 16 | 0;
  i18 = (i35 | 0) == 0;
  i19 = i47 + 4 | 0;
  i20 = i47 + 8 | 0;
  i21 = i47 + 12 | 0;
  i22 = i47 + 20 | 0;
  i23 = i47 + 24 | 0;
  i24 = i47 + 28 | 0;
  i25 = i47 + 32 | 0;
  i27 = i46 + 4 | 0;
  i26 = i47 + 4 | 0;
  i29 = i46 + 24 | 0;
  i11 = (i8 & 8) == 0;
  i12 = i2 + 4 | 0;
  i13 = i2 + 4 | 0;
  f7 = Math_fround(3402823469999999843913219.0e14);
  i10 = i3;
  i1 = 0;
  L23 : while (1) {
   if (i10) {
    i9 = i43 + 84 + (i1 * 12 | 0) | 0;
    i8 = 0;
    do {
     i3 = (HEAP32[i9 >> 2] | 0) + (i8 << 3) | 0;
     i6 = HEAP32[i3 >> 2] | 0;
     L29 : do if (((i6 | 0 ? (HEAP16[i6 + 4 >> 1] | 0) == 5 : 0) ? 2 : 1) & i33) {
      HEAP32[i42 >> 2] = HEAP32[i15 >> 2] | 0 ? 1 : 2;
      i5 = __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE(i3, i42, i37, i36, i35, i28, i39) | 0;
      i3 = HEAP32[i42 >> 2] | 0;
      if (!((i5 | 0) == 0 | (i3 | 0) == 0)) {
       i6 = i5 + 4 | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE(i38, i4, HEAP32[i5 >> 2] | 0);
       if (!(HEAP32[i4 + 36 >> 2] & 1)) i4 = i4 + 116 | 0; else i4 = (HEAP32[i4 + 40 >> 2] | 0) + 56 | 0;
       if (__ZN5physx15PxGeometryQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformES3_S6_(HEAP32[i16 >> 2] | 0, HEAP32[i17 >> 2] | 0, i4, i38) | 0) {
        i4 = HEAP32[i5 >> 2] | 0;
        if (i18) {
         HEAP32[i2 >> 2] = i4;
         HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
         if (HEAP16[i32 >> 1] & 16) {
          i6 = 39;
          break L23;
         }
         switch ((i14 ? 1 : i3) | 0) {
         case 1:
          break;
         case 2:
          {
           if (!(f7 >= Math_fround(-1.0))) break L29;
           HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
           HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
           HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
           HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
           HEAP8[i44 >> 0] = 1;
           f7 = Math_fround(-1.0);
           break L29;
          }
         default:
          break L29;
         }
         i4 = HEAP32[i15 >> 2] | 0;
         if (!(f7 >= Math_fround(-1.0)) | (i4 | 0) == 0) break;
         i3 = HEAP32[i45 >> 2] | 0;
         if ((i3 | 0) == (i4 | 0)) {
          HEAP32[i19 >> 2] = 0;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i21 >> 2] = -1;
          HEAP8[i22 >> 0] = 0;
          HEAP32[i23 >> 2] = 0;
          HEAP32[i24 >> 2] = 0;
          HEAP32[i25 >> 2] = 0;
          HEAP32[i47 >> 2] = gb + 85608 + 8;
          HEAP16[i31 >> 1] = HEAP16[i39 >> 1] | 0;
          if (__ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i43, i41, i47, i31, i36, 0, f40) | 0) {
           HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
           HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
           HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
           HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
           HEAP8[i44 >> 0] = 1;
          }
          i3 = HEAP32[i45 >> 2] | 0;
          if ((i3 | 0) == (HEAP32[i15 >> 2] | 0)) {
           if (!(mftCall_iiii(HEAP32[HEAP32[i46 >> 2] >> 2] | 0, i46 | 0, HEAP32[i29 >> 2] | 0, i3 | 0) | 0)) {
            i6 = 49;
            break L23;
           }
           HEAP32[i45 >> 2] = 0;
           i3 = 0;
          }
         }
         HEAP32[i45 >> 2] = i3 + 1;
         i6 = (HEAP32[i29 >> 2] | 0) + (i3 << 4) | 0;
         HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
         break;
        }
        HEAP32[i2 >> 2] = i4;
        HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
        if (!i11) i3 = mftCall_iiii(HEAP32[(HEAP32[i35 >> 2] | 0) + 4 >> 2] | 0, i35 | 0, i36 | 0, i2 | 0) | 0;
        if ((i3 | 0) != 0 & (HEAP16[i32 >> 1] & 16) != 0) {
         i6 = 39;
         break L23;
        }
        switch ((i14 ? 1 : i3) | 0) {
        case 1:
         break;
        case 2:
         {
          if (!(f7 >= Math_fround(-1.0))) break L29;
          HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
          HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
          HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
          HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
          HEAP8[i44 >> 0] = 1;
          f7 = Math_fround(-1.0);
          break L29;
         }
        default:
         break L29;
        }
        i4 = HEAP32[i15 >> 2] | 0;
        if (!(!(f7 >= Math_fround(-1.0)) | (i4 | 0) == 0)) {
         i3 = HEAP32[i45 >> 2] | 0;
         if ((i3 | 0) == (i4 | 0)) {
          HEAP32[i19 >> 2] = 0;
          HEAP32[i20 >> 2] = 0;
          HEAP32[i21 >> 2] = -1;
          HEAP8[i22 >> 0] = 0;
          HEAP32[i23 >> 2] = 0;
          HEAP32[i24 >> 2] = 0;
          HEAP32[i25 >> 2] = 0;
          HEAP32[i47 >> 2] = gb + 85608 + 8;
          HEAP16[i31 >> 1] = HEAP16[i39 >> 1] | 0;
          if (__ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i43, i41, i47, i31, i36, i35, f40) | 0) {
           HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
           HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
           HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
           HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
           HEAP8[i44 >> 0] = 1;
          }
          i3 = HEAP32[i45 >> 2] | 0;
          if ((i3 | 0) == (HEAP32[i15 >> 2] | 0)) {
           if (!(mftCall_iiii(HEAP32[HEAP32[i46 >> 2] >> 2] | 0, i46 | 0, HEAP32[i29 >> 2] | 0, i3 | 0) | 0)) {
            i6 = 49;
            break L23;
           }
           HEAP32[i45 >> 2] = 0;
           i3 = 0;
          }
         }
         HEAP32[i45 >> 2] = i3 + 1;
         i6 = (HEAP32[i29 >> 2] | 0) + (i3 << 4) | 0;
         HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
        }
       }
      }
     } while (0);
     i8 = i8 + 1 | 0;
    } while (i8 >>> 0 < i10 >>> 0);
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= 2) {
    i6 = 56;
    break;
   }
   i10 = HEAP32[i34 + (i1 << 2) >> 2] | 0;
  }
  if ((i6 | 0) == 39) {
   HEAP32[i27 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   mftCall_vi(HEAP32[(HEAP32[i46 >> 2] | 0) + 4 >> 2] | 0, i46 | 0);
   HEAP8[i44 >> 0] = 1;
   i1 = 1;
  } else if ((i6 | 0) == 49) {
   mftCall_vi(HEAP32[(HEAP32[i46 >> 2] | 0) + 4 >> 2] | 0, i46 | 0);
   i1 = (HEAP8[i44 >> 0] | 0) != 0;
  } else if ((i6 | 0) == 56) {
   i1 = HEAP32[i45 >> 2] | 0;
   i2 = (i1 | 0) == 0;
   if (!(HEAP8[i44 >> 0] | 0)) {
    if (!i2) i6 = 60;
   } else if (!i2) {
    HEAP32[i45 >> 2] = i1;
    i6 = 60;
   }
   if ((i6 | 0) == 60) if (mftCall_iiii(HEAP32[HEAP32[i46 >> 2] >> 2] | 0, i46 | 0, HEAP32[i29 >> 2] | 0, i1 | 0) | 0) HEAP32[i45 >> 2] = 0;
   mftCall_vi(HEAP32[(HEAP32[i46 >> 2] | 0) + 4 >> 2] | 0, i46 | 0);
   i1 = (HEAP8[i44 >> 0] | 0) != 0;
  }
  if (i30 | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i47, i30);
  i47 = i1;
  STACKTOP = i48;
  return i47 | 0;
 } while (0);
 if ((i6 | 0) == 6) if ((HEAP32[i1 >> 2] | 0) == -1) i6 = 7;
 if ((i6 | 0) == 7) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 128, gb + 704671 | 0, 582, gb + 704746 | 0, i3);
 i47 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i4 >> 2] | 0) | 0;
 mftCall_iiiiiii(HEAP32[(HEAP32[i47 >> 2] | 0) + 356 >> 2] | 0, i47 | 0, HEAP32[i41 + 12 >> 2] | 0, HEAP32[i41 + 16 >> 2] | 0, i46 | 0, i36 | 0, i35 | 0) | 0;
 i47 = (HEAP8[i44 >> 0] | 0) != 0 | (HEAP32[i45 >> 2] | 0) != 0;
 STACKTOP = i48;
 return i47 | 0;
}

function __ZNK11ShapeModule25CalculateProceduralBoundsER10MinMaxAABBRK8Vector3f8Vector2f(i16, i1, i6, i24) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i24 = i24 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i13 = i16 + 8 | 0;
 switch (HEAP32[i13 >> 2] | 0) {
 case 1:
 case 0:
  {
   i19 = HEAP32[i16 + 12 >> 2] | 0;
   i21 = i1 + 12 | 0;
   HEAP32[i21 >> 2] = i19;
   i22 = i1 + 16 | 0;
   HEAP32[i22 >> 2] = i19;
   i23 = i1 + 20 | 0;
   HEAP32[i23 >> 2] = i19;
   f8 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(-f8);
   HEAPF32[i1 >> 2] = f4;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f4;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = f4;
   f2 = f4;
   f3 = f4;
   f5 = f8;
   f7 = f8;
   break;
  }
 case 3:
 case 2:
  {
   i19 = i16 + 12 | 0;
   i26 = HEAP32[i19 >> 2] | 0;
   i21 = i1 + 12 | 0;
   HEAP32[i21 >> 2] = i26;
   i22 = i1 + 16 | 0;
   HEAP32[i22 >> 2] = i26;
   i23 = i1 + 20 | 0;
   HEAP32[i23 >> 2] = i26;
   f3 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i1 >> 2] = f3;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   f8 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = f3;
   f4 = Math_fround(0.0);
   f5 = f8;
   f7 = f8;
   break;
  }
 case 7:
 case 4:
  {
   i19 = HEAP32[i16 + 12 >> 2] | 0;
   i21 = i1 + 12 | 0;
   HEAP32[i21 >> 2] = i19;
   i22 = i1 + 16 | 0;
   HEAP32[i22 >> 2] = i19;
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = Math_fround(0.0);
   f7 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(-f7);
   HEAPF32[i1 >> 2] = f3;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = Math_fround(-0.0);
   f2 = f3;
   f4 = Math_fround(-0.0);
   f5 = f7;
   f8 = Math_fround(0.0);
   break;
  }
 case 9:
 case 8:
  {
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i16 + 16 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
   f7 = Math_fround(HEAPF32[i16 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i16 + 20 >> 2]);
   f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(+Math_sin(+f8))));
   f8 = Math_fround(f3 * Math_fround(+Math_cos(+f8)));
   i21 = i1 + 12 | 0;
   HEAPF32[i21 >> 2] = f7;
   i22 = i1 + 16 | 0;
   HEAPF32[i22 >> 2] = f7;
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = f8;
   f3 = Math_fround(-f7);
   HEAPF32[i1 >> 2] = f3;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = Math_fround(-0.0);
   f2 = f3;
   f4 = Math_fround(-0.0);
   f5 = f7;
   break;
  }
 case 11:
 case 10:
  {
   i19 = HEAP32[i16 + 12 >> 2] | 0;
   i21 = i1 + 12 | 0;
   HEAP32[i21 >> 2] = i19;
   i22 = i1 + 16 | 0;
   HEAP32[i22 >> 2] = i19;
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = Math_fround(.100000001);
   f7 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(-f7);
   HEAPF32[i1 >> 2] = f3;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = Math_fround(-.100000001);
   f2 = f3;
   f4 = Math_fround(-.100000001);
   f5 = f7;
   f8 = Math_fround(.100000001);
   break;
  }
 case 12:
  {
   i19 = HEAP32[i16 + 12 >> 2] | 0;
   i21 = i1 + 12 | 0;
   HEAP32[i21 >> 2] = i19;
   i22 = i1 + 16 | 0;
   HEAPF32[i22 >> 2] = Math_fround(.100000001);
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = Math_fround(.100000001);
   f5 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = Math_fround(-f5);
   HEAPF32[i1 >> 2] = f2;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = Math_fround(-.100000001);
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = Math_fround(-.100000001);
   f3 = Math_fround(-.100000001);
   f4 = Math_fround(-.100000001);
   f7 = Math_fround(.100000001);
   f8 = Math_fround(.100000001);
   break;
  }
 case 16:
 case 15:
 case 5:
  {
   f5 = Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) * Math_fround(.5));
   f7 = Math_fround(Math_fround(HEAPF32[i16 + 28 >> 2]) * Math_fround(.5));
   f8 = Math_fround(Math_fround(HEAPF32[i16 + 32 >> 2]) * Math_fround(.5));
   i21 = i1 + 12 | 0;
   HEAPF32[i21 >> 2] = f5;
   i22 = i1 + 16 | 0;
   HEAPF32[i22 >> 2] = f7;
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = f8;
   f2 = Math_fround(-f5);
   f3 = Math_fround(-f7);
   f4 = Math_fround(-f8);
   HEAPF32[i1 >> 2] = f2;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = f4;
   break;
  }
 case 14:
 case 13:
 case 6:
  {
   f15 = Math_fround(HEAPF32[i16 + 76 >> 2]);
   f5 = Math_fround(HEAPF32[i16 + 88 >> 2]);
   f2 = Math_fround(f15 - f5);
   f17 = Math_fround(HEAPF32[i16 + 80 >> 2]);
   f7 = Math_fround(HEAPF32[i16 + 92 >> 2]);
   f3 = Math_fround(f17 - f7);
   f18 = Math_fround(HEAPF32[i16 + 84 >> 2]);
   f8 = Math_fround(HEAPF32[i16 + 96 >> 2]);
   f4 = Math_fround(f18 - f8);
   f5 = Math_fround(f15 + f5);
   f7 = Math_fround(f17 + f7);
   f8 = Math_fround(f18 + f8);
   HEAPF32[i1 >> 2] = f2;
   i19 = i1 + 4 | 0;
   HEAPF32[i19 >> 2] = f3;
   i20 = i1 + 8 | 0;
   HEAPF32[i20 >> 2] = f4;
   i21 = i1 + 12 | 0;
   HEAPF32[i21 >> 2] = f5;
   i22 = i1 + 16 | 0;
   HEAPF32[i22 >> 2] = f7;
   i23 = i1 + 20 | 0;
   HEAPF32[i23 >> 2] = f8;
   break;
  }
 default:
  {
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   i19 = i1 + 4 | 0;
   f3 = Math_fround(HEAPF32[i19 >> 2]);
   i20 = i1 + 8 | 0;
   f4 = Math_fround(HEAPF32[i20 >> 2]);
   i21 = i1 + 12 | 0;
   f5 = Math_fround(HEAPF32[i21 >> 2]);
   i27 = i1 + 16 | 0;
   i26 = i1 + 20 | 0;
   i22 = i27;
   i23 = i26;
   f7 = Math_fround(HEAPF32[i27 >> 2]);
   f8 = Math_fround(HEAPF32[i26 >> 2]);
  }
 }
 f10 = Math_fround(f2 * Math_fround(HEAPF32[i6 >> 2]));
 i26 = i6 + 4 | 0;
 f17 = Math_fround(f3 * Math_fround(HEAPF32[i26 >> 2]));
 i27 = i6 + 8 | 0;
 f18 = Math_fround(f4 * Math_fround(HEAPF32[i27 >> 2]));
 HEAPF32[i1 >> 2] = f10;
 HEAPF32[i19 >> 2] = f17;
 HEAPF32[i20 >> 2] = f18;
 f4 = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
 f3 = Math_fround(f7 * Math_fround(HEAPF32[i26 >> 2]));
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i27 >> 2]));
 HEAPF32[i21 >> 2] = f4;
 HEAPF32[i22 >> 2] = f3;
 HEAPF32[i23 >> 2] = f2;
 f5 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f7 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 i27 = Math_fround(HEAPF32[i16 + 204 >> 2]) > Math_fround(0.0);
 i6 = HEAP32[i13 >> 2] | 0;
 L12 : do if (i27) {
  switch (i6 | 0) {
  case 7:
  case 4:
   {
    i25 = 17;
    break L12;
   }
  default:
   {}
  }
  f9 = Math_fround(HEAPF32[gb + 62512 >> 2]);
  f12 = Math_fround(HEAPF32[gb + 62512 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[gb + 62512 + 8 >> 2]);
  f5 = Math_fround(-f9);
  f15 = Math_fround(-f12);
  f14 = Math_fround(-f11);
  f7 = Math_fround(HEAPF32[i24 >> 2]);
  i16 = f7 < Math_fround(0.0);
  f4 = Math_fround(-f7);
  i27 = i24 + 4 | 0;
  f10 = Math_fround(HEAPF32[i27 >> 2]);
  i26 = f10 < Math_fround(0.0);
  f8 = Math_fround(-f10);
  HEAPF32[i24 >> 2] = i16 ? f4 : f7;
  HEAPF32[i27 >> 2] = i26 ? f8 : f10;
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(HEAPF32[i19 >> 2]);
  f7 = Math_fround(HEAPF32[i20 >> 2]);
  f4 = Math_fround(HEAPF32[i21 >> 2]);
  f3 = Math_fround(HEAPF32[i22 >> 2]);
  f2 = Math_fround(HEAPF32[i23 >> 2]);
 } else {
  f11 = Math_fround(-f8);
  f12 = Math_fround(-f7);
  f9 = Math_fround(-f5);
  switch (i6 | 0) {
  case 9:
  case 8:
  case 7:
  case 4:
   {
    i25 = 17;
    break L12;
   }
  case 11:
  case 10:
  case 14:
  case 13:
  case 6:
  case 1:
  case 0:
   {
    f9 = Math_fround(HEAPF32[gb + 62512 >> 2]);
    f12 = Math_fround(HEAPF32[gb + 62512 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[gb + 62512 + 8 >> 2]);
    f5 = Math_fround(-f9);
    f15 = Math_fround(-f12);
    f14 = Math_fround(-f11);
    f8 = f17;
    f7 = f18;
    break L12;
   }
  case 3:
  case 2:
   {
    f9 = Math_fround(HEAPF32[gb + 62512 >> 2]);
    f5 = Math_fround(-1.0);
    f15 = Math_fround(-1.0);
    f14 = Math_fround(0.0);
    f12 = Math_fround(HEAPF32[gb + 62512 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[gb + 62512 + 8 >> 2]);
    f8 = f17;
    f7 = f18;
    break L12;
   }
  case 12:
   {
    f9 = Math_fround(HEAPF32[gb + 62536 >> 2]);
    f12 = Math_fround(HEAPF32[gb + 62536 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[gb + 62536 + 8 >> 2]);
    f5 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
    f15 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
    f14 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
    f8 = f17;
    f7 = f18;
    break L12;
   }
  case 16:
  case 15:
  case 5:
   {
    f9 = Math_fround(HEAPF32[gb + 62548 >> 2]);
    f12 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
    f11 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
    f5 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
    f15 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
    f14 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
    f8 = f17;
    f7 = f18;
    break L12;
   }
  default:
   {
    f15 = f7;
    f14 = f8;
    f8 = f17;
    f7 = f18;
    break L12;
   }
  }
 } while (0);
 if ((i25 | 0) == 17) {
  f12 = Math_fround(+Math_sin(+Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i16 + 16 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274))));
  f15 = Math_fround(-f12);
  f5 = f15;
  f14 = Math_fround(0.0);
  f9 = f12;
  f11 = Math_fround(1.0);
  f8 = f17;
  f7 = f18;
 }
 f18 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f29 = Math_fround(f10 + Math_fround(f5 * f18));
 f28 = Math_fround(Math_fround(f15 * f18) + f8);
 f31 = Math_fround(Math_fround(f14 * f18) + f7);
 f30 = Math_fround(Math_fround(f9 * f18) + f4);
 f17 = Math_fround(Math_fround(f12 * f18) + f3);
 f18 = Math_fround(Math_fround(f11 * f18) + f2);
 f29 = f29 < f10 ? f29 : f10;
 f28 = f28 < f8 ? f28 : f8;
 f7 = f31 < f7 ? f31 : f7;
 HEAPF32[i1 >> 2] = f29;
 HEAPF32[i19 >> 2] = f28;
 HEAPF32[i20 >> 2] = f7;
 f8 = f4 < f30 ? f30 : f4;
 f10 = f3 < f17 ? f17 : f3;
 f18 = f2 < f18 ? f18 : f2;
 HEAPF32[i21 >> 2] = f8;
 HEAPF32[i22 >> 2] = f10;
 HEAPF32[i23 >> 2] = f18;
 f2 = Math_fround(HEAPF32[i24 >> 2]);
 f3 = Math_fround(f5 * f2);
 f15 = Math_fround(f15 * f2);
 f17 = Math_fround(f14 * f2);
 f14 = Math_fround(f9 * f2);
 f4 = Math_fround(f12 * f2);
 f5 = Math_fround(f11 * f2);
 f9 = f14 < f3 ? f14 : f3;
 f11 = f4 < f15 ? f4 : f15;
 f12 = f5 < f17 ? f5 : f17;
 f14 = f3 < f14 ? f14 : f3;
 f15 = f15 < f4 ? f4 : f15;
 f17 = f17 < f5 ? f5 : f17;
 HEAPF32[i1 >> 2] = f9 < f29 ? f9 : f29;
 HEAPF32[i19 >> 2] = f11 < f28 ? f11 : f28;
 HEAPF32[i20 >> 2] = f12 < f7 ? f12 : f7;
 HEAPF32[i21 >> 2] = f8 < f14 ? f14 : f8;
 HEAPF32[i22 >> 2] = f10 < f15 ? f15 : f10;
 HEAPF32[i23 >> 2] = f18 < f17 ? f17 : f18;
 return;
}

function __ZN18ProceduralMaterial8TransferI14SafeBinaryReadEEvRT_(i13, i15) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 16 | 0;
 i11 = i16;
 __ZN8Material8TransferI14SafeBinaryReadEEvRT_(i13, i15);
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i15, 2) | 0) {
  i4 = HEAP32[gb + 37040 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 430993 | 0, i4, i14, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i15 + 16 | 0;
    i10 = HEAP32[i15 + 20 >> 2] | 0;
    i1 = i10 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i10 >>> 0) i12 = 7; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i12 = 7; else {
      HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i12 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i11, 4);
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i14 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 + 112 >> 2] = i10;
  HEAP32[i13 + 116 >> 2] = i10;
  i10 = i4;
 } else {
  i4 = i13 + 112 | 0;
  i5 = HEAP32[gb + 37040 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 932215 | 0, i5, i14, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i10 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i10 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i10 >>> 0) i12 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i12 = 19; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i12 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i14 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i4 = i13 + 116 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 932223 | 0, i5, i14, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i15 + 16 | 0;
    i10 = HEAP32[i15 + 20 >> 2] | 0;
    i2 = i10 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i10 >>> 0) i12 = 30; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i12 = 30; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i12 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i14 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i10 = i5;
 }
 i3 = i13 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431007 | 0, HEAP32[gb + 36972 >> 2] | 0, i14, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i9 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i15 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 if (!(HEAP8[i15 + 128 >> 0] | 0)) HEAP8[i3 >> 0] = 1;
 i2 = i13 + 124 | 0;
 i5 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431025 | 0, i5, i14, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS5_L18MemLabelIdentifier77ELi16EEEEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i4 = i13 + 172 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 471855 | 0, HEAP32[gb + 37304 >> 2] | 0, i14, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i9 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i9 >>> 0) i12 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i12 = 59; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i12 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i13 + 256 | 0;
 HEAP32[i2 >> 2] = i1 & 1;
 HEAP32[i4 >> 2] = i1 & -131074;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead25ProceduralLoadingBehaviorEvRT_RT0_PKc17TransferMetaFlags(i15, i2, gb + 431036 | 0, 0);
 i2 = i13 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431054 | 0, gb + 431073 | 0, i14, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI16SubstanceArchiveE8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i13 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431096 | 0, i5, i14, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i15, i2, 0); else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i9 = i13 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431105 | 0, HEAP32[gb + 37260 >> 2] | 0, i14, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i15, i9, 1); else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i7 = i9 + 11 | 0;
 i6 = HEAP8[i7 >> 0] | 0;
 i8 = i13 + 160 | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i6 & 255) | 0)) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i11 + 12 >> 2] | 0;
   i12 = 87;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i11 + 11 >> 0] = i3;
   if (!i3) i1 = i11; else {
    i1 = i11;
    i12 = 89;
   }
  } else i12 = 87;
  if ((i12 | 0) == 87) {
   i6 = i3 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i11 + 8 >> 2] = i6 | -2147483648;
   HEAP32[i11 + 4 >> 2] = i3;
   i12 = 89;
  }
  if ((i12 | 0) == 89) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i11 + 11 | 0;
  do if ((i9 | 0) != (i11 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
   i6 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i7 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
    break;
   }
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i8 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i9 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
  }
 }
 i4 = i13 + 264 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431121 | 0, i10, i14, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i15 + 16 | 0;
   i11 = HEAP32[i15 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i15 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i15 + 36 >> 2] | 0, 0 - (HEAP32[i15 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i12 = 114; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i15 + 24 >> 2] | 0) >>> 0) i12 = 114; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i12 | 0) == 114) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i15 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i13 + 240 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 431143 | 0, gb + 455698 | 0, i14, 1) | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
  i1 = HEAP32[i14 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i15);
 STACKTOP = i16;
 return;
}

function __ZL22PrepareValueParametersI27OverridingParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i15, i12, i13, i14, i17, i16) {
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i18 = 0;
 if (!i12) i1 = 0; else {
  i9 = i17 + 12 | 0;
  i10 = i17 + 16 | 0;
  i11 = i17 + 4 | 0;
  i8 = 0;
  while (1) {
   i6 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   L5 : do if ((i1 | 0) < (i3 | 0)) {
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i5 = HEAP32[i6 + (i8 * 20 | 0) >> 2] | 0;
    while (1) {
     if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) break L5;
    }
    if ((i1 | 0) > -1) {
     i7 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     i1 = i7 >>> 20 & 1023;
     i7 = (HEAP32[i2 + 72 >> 2] | 0) + (i7 & 1048575) | 0;
     i5 = HEAP32[i6 + (i8 * 20 | 0) + 8 >> 2] | 0;
     i5 = (i5 | 0) == 0 ? 1 : i5 & 65535;
     i6 = (i1 | 0) == 0 ? 1 : i1 & 65535;
     i5 = (i6 & 65535) < (i5 & 65535) ? i6 : i5;
     i6 = i5 & 65535;
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = i2 + 4 | 0;
     HEAP32[i9 >> 2] = i1;
     i3 = HEAP32[i10 >> 2] | 0;
     i4 = i3 & 2147483647;
     do if (i4 >>> 0 < i1 >>> 0) {
      i18 = i3 << 1;
      i1 = i18 >>> 0 > i1 >>> 0 ? i18 : i1;
      if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     i2 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
     i1 = i6 << 16 | i8 & 65535;
     HEAP16[i2 >> 1] = i1;
     HEAP16[i2 + 2 >> 1] = i1 >>> 16;
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = i2 + (i6 << 2) | 0;
     HEAP32[i9 >> 2] = i1;
     i3 = HEAP32[i10 >> 2] | 0;
     i4 = i3 & 2147483647;
     do if (i4 >>> 0 < i1 >>> 0) {
      i18 = i3 << 1;
      i1 = i18 >>> 0 > i1 >>> 0 ? i18 : i1;
      if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     if (i5 << 16 >> 16) {
      i1 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
      i2 = 0;
      while (1) {
       HEAP32[i1 >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
       if ((i2 | 0) >= (i6 | 0)) break; else i1 = i1 + 4 | 0;
      }
     }
    }
   } while (0);
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i12 | 0)) {
    i1 = i12;
    break;
   }
  }
 }
 i12 = i13 + i12 | 0;
 if ((i1 | 0) != (i12 | 0)) {
  i9 = i17 + 12 | 0;
  i10 = i17 + 16 | 0;
  i11 = i17 + 4 | 0;
  while (1) {
   i7 = HEAP32[i15 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i5 + 12 >> 2] | 0;
   i6 = HEAP32[i5 + 16 >> 2] | 0;
   L35 : do if ((i2 | 0) < (i6 | 0)) {
    i3 = HEAP32[i5 + 32 >> 2] | 0;
    i4 = HEAP32[i7 + (i1 * 20 | 0) >> 2] | 0;
    while (1) {
     if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) == (i4 | 0)) break;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i6 | 0)) break L35;
    }
    if ((i2 | 0) > -1) {
     i8 = HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i3 = i8 >>> 20 & 1023;
     i8 = (HEAP32[i5 + 72 >> 2] | 0) + (i8 & 1048575) | 0;
     i6 = HEAP32[i7 + (i1 * 20 | 0) + 8 >> 2] | 0;
     i6 = (i6 | 0) == 0 ? 1 : i6 & 65535;
     i7 = (i3 | 0) == 0 ? 1 : i3 & 65535;
     i6 = (i7 & 65535) < (i6 & 65535) ? i7 : i6;
     i7 = i6 & 65535;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i3 + 4 | 0;
     HEAP32[i9 >> 2] = i2;
     i4 = HEAP32[i10 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i5 >>> 0 < i2 >>> 0) {
      i18 = i4 << 1;
      i2 = i18 >>> 0 > i2 >>> 0 ? i18 : i2;
      if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i10 >> 2] = i2;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
       HEAP32[i10 >> 2] = i2;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     i3 = (HEAP32[i17 >> 2] | 0) + i3 | 0;
     i2 = i7 << 16 | i1 & 65535;
     HEAP16[i3 >> 1] = i2;
     HEAP16[i3 + 2 >> 1] = i2 >>> 16;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = i3 + (i7 << 4) | 0;
     HEAP32[i9 >> 2] = i2;
     i4 = HEAP32[i10 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i5 >>> 0 < i2 >>> 0) {
      i18 = i4 << 1;
      i2 = i18 >>> 0 > i2 >>> 0 ? i18 : i2;
      if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i10 >> 2] = i2;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
       HEAP32[i10 >> 2] = i2;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     if (i6 << 16 >> 16) {
      i2 = (HEAP32[i17 >> 2] | 0) + i3 | 0;
      i3 = 0;
      while (1) {
       i18 = i8 + (i3 << 4) | 0;
       HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
       HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
       HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) >= (i7 | 0)) break; else i2 = i2 + 16 | 0;
      }
     }
    }
   } while (0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i12 | 0)) {
    i1 = i12;
    break;
   }
  }
 }
 i11 = i12 + i14 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i6 = i17 + 16 | 0;
  i2 = i17 + 12 | 0;
 } else {
  i2 = i17 + 12 | 0;
  i6 = i17 + 16 | 0;
  i12 = i17 + 4 | 0;
  do {
   i9 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   i5 = HEAP32[i4 + 20 >> 2] | 0;
   L66 : do if ((i3 | 0) < (i5 | 0)) {
    i7 = HEAP32[i4 + 32 >> 2] | 0;
    i8 = HEAP32[i9 + (i1 * 20 | 0) >> 2] | 0;
    while (1) {
     if ((HEAP32[i7 + (i3 << 2) >> 2] | 0) == (i8 | 0)) break;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) >= (i5 | 0)) break L66;
    }
    if ((i3 | 0) > -1) {
     i10 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     i3 = i10 >>> 20 & 1023;
     i10 = (HEAP32[i4 + 72 >> 2] | 0) + (i10 & 1048575) | 0;
     i8 = HEAP32[i9 + (i1 * 20 | 0) + 8 >> 2] | 0;
     i8 = (i8 | 0) == 0 ? 1 : i8 & 65535;
     i9 = (i3 | 0) == 0 ? 1 : i3 & 65535;
     i8 = (i9 & 65535) < (i8 & 65535) ? i9 : i8;
     i9 = i8 & 65535;
     i4 = HEAP32[i2 >> 2] | 0;
     i3 = i4 + 4 | 0;
     HEAP32[i2 >> 2] = i3;
     i5 = HEAP32[i6 >> 2] | 0;
     i7 = i5 & 2147483647;
     do if (i7 >>> 0 < i3 >>> 0) {
      i18 = i5 << 1;
      i3 = i18 >>> 0 > i3 >>> 0 ? i18 : i3;
      if (i7 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i6 >> 2] = i3;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i3, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
       HEAP32[i6 >> 2] = i3;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     i4 = (HEAP32[i17 >> 2] | 0) + i4 | 0;
     i3 = i9 << 16 | i1 & 65535;
     HEAP16[i4 >> 1] = i3;
     HEAP16[i4 + 2 >> 1] = i3 >>> 16;
     i4 = HEAP32[i2 >> 2] | 0;
     i3 = i4 + (i9 << 6) | 0;
     HEAP32[i2 >> 2] = i3;
     i5 = HEAP32[i6 >> 2] | 0;
     i7 = i5 & 2147483647;
     do if (i7 >>> 0 < i3 >>> 0) {
      i18 = i5 << 1;
      i3 = i18 >>> 0 > i3 >>> 0 ? i18 : i3;
      if (i7 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i6 >> 2] = i3;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i3, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
       HEAP32[i6 >> 2] = i3;
       HEAP32[i17 >> 2] = i18;
       break;
      }
     } while (0);
     if (i8 << 16 >> 16) {
      i3 = (HEAP32[i17 >> 2] | 0) + i4 | 0;
      i4 = 0;
      do {
       i5 = i3;
       i3 = i3 + 64 | 0;
       i7 = i10 + (i4 << 6) | 0;
       i8 = i5 + 64 | 0;
       do {
        HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
        i5 = i5 + 4 | 0;
        i7 = i7 + 4 | 0;
       } while ((i5 | 0) < (i8 | 0));
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < (i9 | 0));
     }
    }
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i4 & 2147483647;
 if (i5 >>> 0 >= i1 >>> 0) {
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + i3 | 0;
  HEAP16[i18 >> 1] = 65535;
  HEAP16[i18 + 2 >> 1] = 65535 >>> 16;
  return;
 }
 i18 = i4 << 1;
 i1 = i18 >>> 0 > i1 >>> 0 ? i18 : i1;
 if (i5 >>> 0 >= i1 >>> 0) {
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + i3 | 0;
  HEAP16[i18 >> 1] = 65535;
  HEAP16[i18 + 2 >> 1] = 65535 >>> 16;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + i3 | 0;
  HEAP16[i18 >> 1] = 65535;
  HEAP16[i18 + 2 >> 1] = 65535 >>> 16;
  return;
 } else {
  i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i18 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i17 >> 2] = i18;
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + i3 | 0;
  HEAP16[i18 >> 1] = 65535;
  HEAP16[i18 + 2 >> 1] = 65535 >>> 16;
  return;
 }
}

function _UNITY_FT_Create_Class_cff_field_handlers(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 1456, i2) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 4 >> 2] = 4096;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 4;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 4;
 HEAP32[i1 + 32 >> 2] = 4097;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP8[i1 + 40 >> 0] = 4;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 4;
 HEAP32[i1 + 60 >> 2] = 4352;
 HEAP32[i1 + 64 >> 2] = 8;
 HEAP8[i1 + 68 >> 0] = 4;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 4;
 HEAP32[i1 + 88 >> 2] = 4098;
 HEAP32[i1 + 92 >> 2] = 12;
 HEAP8[i1 + 96 >> 0] = 4;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 4;
 HEAP32[i1 + 116 >> 2] = 4099;
 HEAP32[i1 + 120 >> 2] = 16;
 HEAP8[i1 + 124 >> 0] = 4;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 4;
 HEAP32[i1 + 144 >> 2] = 4100;
 HEAP32[i1 + 148 >> 2] = 20;
 HEAP8[i1 + 152 >> 0] = 4;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 5;
 HEAP32[i1 + 172 >> 2] = 4353;
 HEAP32[i1 + 176 >> 2] = 24;
 HEAP8[i1 + 180 >> 0] = 1;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 2;
 HEAP32[i1 + 200 >> 2] = 4354;
 HEAP32[i1 + 204 >> 2] = 28;
 HEAP8[i1 + 208 >> 0] = 4;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 2;
 HEAP32[i1 + 228 >> 2] = 4355;
 HEAP32[i1 + 232 >> 2] = 32;
 HEAP8[i1 + 236 >> 0] = 4;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 2;
 HEAP32[i1 + 256 >> 2] = 4356;
 HEAP32[i1 + 260 >> 2] = 36;
 HEAP8[i1 + 264 >> 0] = 4;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = 0;
 HEAP32[i1 + 280 >> 2] = 1;
 HEAP32[i1 + 284 >> 2] = 4357;
 HEAP32[i1 + 288 >> 2] = 40;
 HEAP8[i1 + 292 >> 0] = 4;
 HEAP32[i1 + 296 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAP32[i1 + 308 >> 2] = 1;
 HEAP32[i1 + 312 >> 2] = 4358;
 HEAP32[i1 + 316 >> 2] = 44;
 HEAP8[i1 + 320 >> 0] = 4;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 7;
 HEAP32[i1 + 340 >> 2] = 4359;
 HEAP32[i1 + 344 >> 2] = 0;
 HEAP8[i1 + 348 >> 0] = 0;
 HEAP32[i1 + 352 >> 2] = fb + 2638;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 364 >> 2] = 1;
 HEAP32[i1 + 368 >> 2] = 4109;
 HEAP32[i1 + 372 >> 2] = 80;
 HEAP8[i1 + 376 >> 0] = 4;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP32[i1 + 384 >> 2] = 0;
 HEAP32[i1 + 388 >> 2] = 0;
 HEAP32[i1 + 392 >> 2] = 7;
 HEAP32[i1 + 396 >> 2] = 4101;
 HEAP32[i1 + 400 >> 2] = 0;
 HEAP8[i1 + 404 >> 0] = 0;
 HEAP32[i1 + 408 >> 2] = fb + 2639;
 HEAP32[i1 + 412 >> 2] = 0;
 HEAP32[i1 + 416 >> 2] = 0;
 HEAP32[i1 + 420 >> 2] = 1;
 HEAP32[i1 + 424 >> 2] = 4360;
 HEAP32[i1 + 428 >> 2] = 100;
 HEAP8[i1 + 432 >> 0] = 4;
 HEAP32[i1 + 436 >> 2] = 0;
 HEAP32[i1 + 440 >> 2] = 0;
 HEAP32[i1 + 444 >> 2] = 0;
 HEAP32[i1 + 448 >> 2] = 1;
 HEAP32[i1 + 452 >> 2] = 4111;
 HEAP32[i1 + 456 >> 2] = 104;
 HEAP8[i1 + 460 >> 0] = 4;
 HEAP32[i1 + 464 >> 2] = 0;
 HEAP32[i1 + 468 >> 2] = 0;
 HEAP32[i1 + 472 >> 2] = 0;
 HEAP32[i1 + 476 >> 2] = 1;
 HEAP32[i1 + 480 >> 2] = 4112;
 HEAP32[i1 + 484 >> 2] = 108;
 HEAP8[i1 + 488 >> 0] = 4;
 HEAP32[i1 + 492 >> 2] = 0;
 HEAP32[i1 + 496 >> 2] = 0;
 HEAP32[i1 + 500 >> 2] = 0;
 HEAP32[i1 + 504 >> 2] = 1;
 HEAP32[i1 + 508 >> 2] = 4113;
 HEAP32[i1 + 512 >> 2] = 112;
 HEAP8[i1 + 516 >> 0] = 4;
 HEAP32[i1 + 520 >> 2] = 0;
 HEAP32[i1 + 524 >> 2] = 0;
 HEAP32[i1 + 528 >> 2] = 0;
 HEAP32[i1 + 532 >> 2] = 7;
 HEAP32[i1 + 536 >> 2] = 4114;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP8[i1 + 544 >> 0] = 0;
 HEAP32[i1 + 548 >> 2] = fb + 2640;
 HEAP32[i1 + 552 >> 2] = 0;
 HEAP32[i1 + 556 >> 2] = 0;
 HEAP32[i1 + 560 >> 2] = 1;
 HEAP32[i1 + 564 >> 2] = 4372;
 HEAP32[i1 + 568 >> 2] = 124;
 HEAP8[i1 + 572 >> 0] = 4;
 HEAP32[i1 + 576 >> 2] = 0;
 HEAP32[i1 + 580 >> 2] = 0;
 HEAP32[i1 + 584 >> 2] = 0;
 HEAP32[i1 + 588 >> 2] = 4;
 HEAP32[i1 + 592 >> 2] = 4373;
 HEAP32[i1 + 596 >> 2] = 128;
 HEAP8[i1 + 600 >> 0] = 4;
 HEAP32[i1 + 604 >> 2] = 0;
 HEAP32[i1 + 608 >> 2] = 0;
 HEAP32[i1 + 612 >> 2] = 0;
 HEAP32[i1 + 616 >> 2] = 7;
 HEAP32[i1 + 620 >> 2] = 4382;
 HEAP32[i1 + 624 >> 2] = 0;
 HEAP8[i1 + 628 >> 0] = 0;
 HEAP32[i1 + 632 >> 2] = fb + 2641;
 HEAP32[i1 + 636 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = 0;
 HEAP32[i1 + 644 >> 2] = 1;
 HEAP32[i1 + 648 >> 2] = 4383;
 HEAP32[i1 + 652 >> 2] = 144;
 HEAP8[i1 + 656 >> 0] = 4;
 HEAP32[i1 + 660 >> 2] = 0;
 HEAP32[i1 + 664 >> 2] = 0;
 HEAP32[i1 + 668 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 1;
 HEAP32[i1 + 676 >> 2] = 4384;
 HEAP32[i1 + 680 >> 2] = 148;
 HEAP8[i1 + 684 >> 0] = 4;
 HEAP32[i1 + 688 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 696 >> 2] = 0;
 HEAP32[i1 + 700 >> 2] = 1;
 HEAP32[i1 + 704 >> 2] = 4385;
 HEAP32[i1 + 708 >> 2] = 152;
 HEAP8[i1 + 712 >> 0] = 4;
 HEAP32[i1 + 716 >> 2] = 0;
 HEAP32[i1 + 720 >> 2] = 0;
 HEAP32[i1 + 724 >> 2] = 0;
 HEAP32[i1 + 728 >> 2] = 1;
 HEAP32[i1 + 732 >> 2] = 4386;
 HEAP32[i1 + 736 >> 2] = 156;
 HEAP8[i1 + 740 >> 0] = 4;
 HEAP32[i1 + 744 >> 2] = 0;
 HEAP32[i1 + 748 >> 2] = 0;
 HEAP32[i1 + 752 >> 2] = 0;
 HEAP32[i1 + 756 >> 2] = 1;
 HEAP32[i1 + 760 >> 2] = 4387;
 HEAP32[i1 + 764 >> 2] = 160;
 HEAP8[i1 + 768 >> 0] = 4;
 HEAP32[i1 + 772 >> 2] = 0;
 HEAP32[i1 + 776 >> 2] = 0;
 HEAP32[i1 + 780 >> 2] = 0;
 HEAP32[i1 + 784 >> 2] = 1;
 HEAP32[i1 + 788 >> 2] = 4388;
 HEAP32[i1 + 792 >> 2] = 164;
 HEAP8[i1 + 796 >> 0] = 4;
 HEAP32[i1 + 800 >> 2] = 0;
 HEAP32[i1 + 804 >> 2] = 0;
 HEAP32[i1 + 808 >> 2] = 0;
 HEAP32[i1 + 812 >> 2] = 1;
 HEAP32[i1 + 816 >> 2] = 4389;
 HEAP32[i1 + 820 >> 2] = 168;
 HEAP8[i1 + 824 >> 0] = 4;
 HEAP32[i1 + 828 >> 2] = 0;
 HEAP32[i1 + 832 >> 2] = 0;
 HEAP32[i1 + 836 >> 2] = 0;
 HEAP32[i1 + 840 >> 2] = 4;
 HEAP32[i1 + 844 >> 2] = 4390;
 HEAP32[i1 + 848 >> 2] = 172;
 HEAP8[i1 + 852 >> 0] = 4;
 HEAP32[i1 + 856 >> 2] = 0;
 HEAP32[i1 + 860 >> 2] = 0;
 HEAP32[i1 + 864 >> 2] = 0;
 HEAP32[i1 + 868 >> 2] = 6;
 HEAP32[i1 + 872 >> 2] = 8198;
 HEAP32[i1 + 876 >> 2] = 4;
 HEAP8[i1 + 880 >> 0] = 4;
 HEAP32[i1 + 884 >> 2] = 0;
 HEAP32[i1 + 888 >> 2] = 14;
 HEAP32[i1 + 892 >> 2] = 0;
 HEAP32[i1 + 896 >> 2] = 6;
 HEAP32[i1 + 900 >> 2] = 8199;
 HEAP32[i1 + 904 >> 2] = 60;
 HEAP8[i1 + 908 >> 0] = 4;
 HEAP32[i1 + 912 >> 2] = 0;
 HEAP32[i1 + 916 >> 2] = 10;
 HEAP32[i1 + 920 >> 2] = 1;
 HEAP32[i1 + 924 >> 2] = 6;
 HEAP32[i1 + 928 >> 2] = 8200;
 HEAP32[i1 + 932 >> 2] = 100;
 HEAP8[i1 + 936 >> 0] = 4;
 HEAP32[i1 + 940 >> 2] = 0;
 HEAP32[i1 + 944 >> 2] = 14;
 HEAP32[i1 + 948 >> 2] = 2;
 HEAP32[i1 + 952 >> 2] = 6;
 HEAP32[i1 + 956 >> 2] = 8201;
 HEAP32[i1 + 960 >> 2] = 156;
 HEAP8[i1 + 964 >> 0] = 4;
 HEAP32[i1 + 968 >> 2] = 0;
 HEAP32[i1 + 972 >> 2] = 10;
 HEAP32[i1 + 976 >> 2] = 3;
 HEAP32[i1 + 980 >> 2] = 3;
 HEAP32[i1 + 984 >> 2] = 8457;
 HEAP32[i1 + 988 >> 2] = 196;
 HEAP8[i1 + 992 >> 0] = 4;
 HEAP32[i1 + 996 >> 2] = 0;
 HEAP32[i1 + 1e3 >> 2] = 0;
 HEAP32[i1 + 1004 >> 2] = 0;
 HEAP32[i1 + 1008 >> 2] = 1;
 HEAP32[i1 + 1012 >> 2] = 8458;
 HEAP32[i1 + 1016 >> 2] = 200;
 HEAP8[i1 + 1020 >> 0] = 4;
 HEAP32[i1 + 1024 >> 2] = 0;
 HEAP32[i1 + 1028 >> 2] = 0;
 HEAP32[i1 + 1032 >> 2] = 0;
 HEAP32[i1 + 1036 >> 2] = 1;
 HEAP32[i1 + 1040 >> 2] = 8459;
 HEAP32[i1 + 1044 >> 2] = 204;
 HEAP8[i1 + 1048 >> 0] = 4;
 HEAP32[i1 + 1052 >> 2] = 0;
 HEAP32[i1 + 1056 >> 2] = 0;
 HEAP32[i1 + 1060 >> 2] = 0;
 HEAP32[i1 + 1064 >> 2] = 1;
 HEAP32[i1 + 1068 >> 2] = 8202;
 HEAP32[i1 + 1072 >> 2] = 208;
 HEAP8[i1 + 1076 >> 0] = 4;
 HEAP32[i1 + 1080 >> 2] = 0;
 HEAP32[i1 + 1084 >> 2] = 0;
 HEAP32[i1 + 1088 >> 2] = 0;
 HEAP32[i1 + 1092 >> 2] = 1;
 HEAP32[i1 + 1096 >> 2] = 8203;
 HEAP32[i1 + 1100 >> 2] = 212;
 HEAP8[i1 + 1104 >> 0] = 4;
 HEAP32[i1 + 1108 >> 2] = 0;
 HEAP32[i1 + 1112 >> 2] = 0;
 HEAP32[i1 + 1116 >> 2] = 0;
 HEAP32[i1 + 1120 >> 2] = 6;
 HEAP32[i1 + 1124 >> 2] = 8460;
 HEAP32[i1 + 1128 >> 2] = 220;
 HEAP8[i1 + 1132 >> 0] = 4;
 HEAP32[i1 + 1136 >> 2] = 0;
 HEAP32[i1 + 1140 >> 2] = 13;
 HEAP32[i1 + 1144 >> 2] = 216;
 HEAP32[i1 + 1148 >> 2] = 6;
 HEAP32[i1 + 1152 >> 2] = 8461;
 HEAP32[i1 + 1156 >> 2] = 272;
 HEAP8[i1 + 1160 >> 0] = 4;
 HEAP32[i1 + 1164 >> 2] = 0;
 HEAP32[i1 + 1168 >> 2] = 13;
 HEAP32[i1 + 1172 >> 2] = 217;
 HEAP32[i1 + 1176 >> 2] = 5;
 HEAP32[i1 + 1180 >> 2] = 8462;
 HEAP32[i1 + 1184 >> 2] = 324;
 HEAP8[i1 + 1188 >> 0] = 1;
 HEAP32[i1 + 1192 >> 2] = 0;
 HEAP32[i1 + 1196 >> 2] = 0;
 HEAP32[i1 + 1200 >> 2] = 0;
 HEAP32[i1 + 1204 >> 2] = 2;
 HEAP32[i1 + 1208 >> 2] = 8463;
 HEAP32[i1 + 1212 >> 2] = 328;
 HEAP8[i1 + 1216 >> 0] = 4;
 HEAP32[i1 + 1220 >> 2] = 0;
 HEAP32[i1 + 1224 >> 2] = 0;
 HEAP32[i1 + 1228 >> 2] = 0;
 HEAP32[i1 + 1232 >> 2] = 1;
 HEAP32[i1 + 1236 >> 2] = 8464;
 HEAP32[i1 + 1240 >> 2] = 332;
 HEAP8[i1 + 1244 >> 0] = 4;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAP32[i1 + 1252 >> 2] = 0;
 HEAP32[i1 + 1256 >> 2] = 0;
 HEAP32[i1 + 1260 >> 2] = 1;
 HEAP32[i1 + 1264 >> 2] = 8465;
 HEAP32[i1 + 1268 >> 2] = 336;
 HEAP8[i1 + 1272 >> 0] = 4;
 HEAP32[i1 + 1276 >> 2] = 0;
 HEAP32[i1 + 1280 >> 2] = 0;
 HEAP32[i1 + 1284 >> 2] = 0;
 HEAP32[i1 + 1288 >> 2] = 2;
 HEAP32[i1 + 1292 >> 2] = 8466;
 HEAP32[i1 + 1296 >> 2] = 340;
 HEAP8[i1 + 1300 >> 0] = 4;
 HEAP32[i1 + 1304 >> 2] = 0;
 HEAP32[i1 + 1308 >> 2] = 0;
 HEAP32[i1 + 1312 >> 2] = 0;
 HEAP32[i1 + 1316 >> 2] = 1;
 HEAP32[i1 + 1320 >> 2] = 8467;
 HEAP32[i1 + 1324 >> 2] = 344;
 HEAP8[i1 + 1328 >> 0] = 4;
 HEAP32[i1 + 1332 >> 2] = 0;
 HEAP32[i1 + 1336 >> 2] = 0;
 HEAP32[i1 + 1340 >> 2] = 0;
 HEAP32[i1 + 1344 >> 2] = 1;
 HEAP32[i1 + 1348 >> 2] = 8211;
 HEAP32[i1 + 1352 >> 2] = 348;
 HEAP8[i1 + 1356 >> 0] = 4;
 HEAP32[i1 + 1360 >> 2] = 0;
 HEAP32[i1 + 1364 >> 2] = 0;
 HEAP32[i1 + 1368 >> 2] = 0;
 HEAP32[i1 + 1372 >> 2] = 1;
 HEAP32[i1 + 1376 >> 2] = 8212;
 HEAP32[i1 + 1380 >> 2] = 352;
 HEAP8[i1 + 1384 >> 0] = 4;
 HEAP32[i1 + 1388 >> 2] = 0;
 HEAP32[i1 + 1392 >> 2] = 0;
 HEAP32[i1 + 1396 >> 2] = 0;
 HEAP32[i1 + 1400 >> 2] = 1;
 HEAP32[i1 + 1404 >> 2] = 8213;
 HEAP32[i1 + 1408 >> 2] = 356;
 HEAP8[i1 + 1412 >> 0] = 4;
 i2 = i1 + 1416 | 0;
 HEAP32[i1 + 1444 >> 2] = 0;
 HEAP32[i1 + 1448 >> 2] = 0;
 HEAP32[i1 + 1452 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 0;
 HEAP32[i3 >> 2] = i1;
 i3 = 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z12calculateMTDRKN5physx2Gu8CapsuleVERKNS_6shdfnd3aos6FloatVEbPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS5_5Vec3VESG_SG_SE_RS6_(i33, i37, i1, i45, i39, i43, i38, i41, i40, i34, i35, i36, i48) {
 i33 = i33 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 i45 = i45 | 0;
 i39 = i39 | 0;
 i43 = i43 | 0;
 i38 = i38 | 0;
 i41 = i41 | 0;
 i40 = i40 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i48 = i48 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i42 = 0, i44 = 0, i46 = 0, i47 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0, i62 = 0, i63 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i49 + 144 | 0;
 i42 = i49 + 160 | 0;
 i47 = i49 + 172 | 0;
 i44 = i49;
 i2 = HEAP32[i48 >> 2] | 0;
 i46 = i48 + 4 | 0;
 HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
 if (!i39) {
  i44 = i2;
  i45 = 0;
  HEAP32[i48 >> 2] = i44;
  HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  STACKTOP = i49;
  return i45 | 0;
 }
 i27 = i44 + 64 | 0;
 i28 = i44 + 80 | 0;
 i29 = i44 + 16 | 0;
 i30 = i44 + 32 | 0;
 i31 = i44 + 48 | 0;
 i32 = i44 + 96 | 0;
 i12 = i44 + 100 | 0;
 i13 = i44 + 104 | 0;
 i14 = i44 + 108 | 0;
 i15 = i44 + 112 | 0;
 i16 = i44 + 116 | 0;
 i17 = i44 + 120 | 0;
 i18 = i44 + 124 | 0;
 i19 = i44 + 128 | 0;
 i20 = i44 + 132 | 0;
 i21 = i44 + 136 | 0;
 i22 = i44 + 140 | 0;
 i23 = i38 + 44 | 0;
 i24 = i40 + 4 | 0;
 i25 = i40 + 8 | 0;
 i26 = i40 + 12 | 0;
 i9 = i33 + 4 | 0;
 i10 = i33 + 8 | 0;
 if (i1) {
  i7 = i2;
  i1 = 0;
  i8 = 0;
  while (1) {
   HEAP32[i41 >> 2] = 0;
   HEAP32[i28 >> 2] = 7;
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i27 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i27 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i27 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAPF32[i29 >> 2] = Math_fround(.0199999996);
   HEAPF32[i30 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i5 = HEAP32[i45 + (i8 * 40 | 0) + 4 >> 2] | 0;
   i6 = HEAP32[i45 + (i8 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i32 >> 2] = HEAP32[i45 + (i8 * 40 | 0) >> 2];
   HEAP32[i12 >> 2] = i5;
   HEAP32[i13 >> 2] = i6;
   HEAPF32[i14 >> 2] = Math_fround(0.0);
   i6 = HEAP32[i45 + (i8 * 40 | 0) + 16 >> 2] | 0;
   i5 = HEAP32[i45 + (i8 * 40 | 0) + 20 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i45 + (i8 * 40 | 0) + 12 >> 2];
   HEAP32[i16 >> 2] = i6;
   HEAP32[i17 >> 2] = i5;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   i5 = HEAP32[i45 + (i8 * 40 | 0) + 28 >> 2] | 0;
   i6 = HEAP32[i45 + (i8 * 40 | 0) + 32 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i45 + (i8 * 40 | 0) + 24 >> 2];
   HEAP32[i20 >> 2] = i5;
   HEAP32[i21 >> 2] = i6;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   i6 = i8 + i43 | 0;
   __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleERKNS0_9TriangleVEjRKNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVEhPNS0_21MeshPersistentContactERj(i44, i6, i33, i37, HEAP8[i45 + (i8 * 40 | 0) + 36 >> 0] | 0, i38, i41) | 0;
   i5 = HEAP32[i41 >> 2] | 0;
   if (!i5) i2 = i7; else {
    i2 = HEAP32[i23 >> 2] | 0;
    if (i5 >>> 0 > 1) {
     i3 = i2;
     i1 = 0;
     i4 = 1;
     while (1) {
      i2 = HEAP32[i38 + (i4 << 6) + 44 >> 2] | 0;
      f50 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (f50 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
       HEAP32[i11 >> 2] = HEAP32[i42 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
       i1 = i4;
      } else i2 = i3;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i5 | 0)) break; else i3 = i2;
     }
    } else i1 = 0;
    f50 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f50 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     HEAP32[i36 >> 2] = i6;
     HEAP32[i47 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i47 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i47 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     i9 = HEAP32[i38 + (i1 << 6) + 36 >> 2] | 0;
     i10 = HEAP32[i38 + (i1 << 6) + 40 >> 2] | 0;
     HEAP32[i40 >> 2] = HEAP32[i38 + (i1 << 6) + 32 >> 2];
     HEAP32[i24 >> 2] = i9;
     HEAP32[i25 >> 2] = i10;
     HEAPF32[i26 >> 2] = Math_fround(0.0);
     i10 = i38 + (i1 << 6) + 16 | 0;
     HEAP32[i34 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i34 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i34 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i34 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     i10 = i38 + (i1 << 6) | 0;
     HEAP32[i35 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i35 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i35 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i35 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    } else i2 = i7;
    i1 = 1;
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i39 | 0)) break; else i7 = i2;
  }
  HEAP32[i48 >> 2] = i2;
  HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  STACKTOP = i49;
  return i1 | 0;
 } else {
  i1 = 0;
  i8 = 0;
 }
 do {
  HEAP32[i41 >> 2] = 0;
  HEAP32[i28 >> 2] = 7;
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAPF32[i29 >> 2] = Math_fround(.0199999996);
  HEAPF32[i30 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i60 = HEAP32[i45 + (i8 * 40 | 0) >> 2] | 0;
  i3 = HEAP32[i45 + (i8 * 40 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i45 + (i8 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i32 >> 2] = i60;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i13 >> 2] = i4;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i63 = HEAP32[i45 + (i8 * 40 | 0) + 12 >> 2] | 0;
  i62 = HEAP32[i45 + (i8 * 40 | 0) + 16 >> 2] | 0;
  i61 = HEAP32[i45 + (i8 * 40 | 0) + 20 >> 2] | 0;
  HEAP32[i15 >> 2] = i63;
  HEAP32[i16 >> 2] = i62;
  HEAP32[i17 >> 2] = i61;
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  i5 = HEAP32[i45 + (i8 * 40 | 0) + 24 >> 2] | 0;
  i6 = HEAP32[i45 + (i8 * 40 | 0) + 28 >> 2] | 0;
  i7 = HEAP32[i45 + (i8 * 40 | 0) + 32 >> 2] | 0;
  HEAP32[i19 >> 2] = i5;
  HEAP32[i20 >> 2] = i6;
  HEAP32[i21 >> 2] = i7;
  HEAPF32[i22 >> 2] = Math_fround(0.0);
  f58 = (HEAP32[tempDoublePtr >> 2] = i63, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f51 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f55 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f52 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f50 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f58 - f55);
  f51 = Math_fround(f51 - f52);
  f59 = Math_fround(f59 - f50);
  f53 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f53 = Math_fround(f53 - f55);
  f57 = Math_fround(f57 - f52);
  f54 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f50);
  f56 = Math_fround(Math_fround(f51 * f54) - Math_fround(f59 * f57));
  f54 = Math_fround(Math_fround(f59 * f53) - Math_fround(f58 * f54));
  f53 = Math_fround(Math_fround(f58 * f57) - Math_fround(f51 * f53));
  f51 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f53 * f53) + Math_fround(Math_fround(f56 * f56) + Math_fround(f54 * f54))))));
  f56 = Math_fround(f51 * f56);
  f55 = Math_fround(f56 * Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f55));
  f54 = Math_fround(f51 * f54);
  f52 = Math_fround(f55 + Math_fround(f54 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f52)));
  f51 = Math_fround(f53 * f51);
  if (!(Math_fround(f52 + Math_fround(f51 * Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f50))) < Math_fround(0.0))) {
   i7 = i8 + i43 | 0;
   __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleERKNS0_9TriangleVEjRKNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVEhPNS0_21MeshPersistentContactERj(i44, i7, i33, i37, HEAP8[i45 + (i8 * 40 | 0) + 36 >> 0] | 0, i38, i41) | 0;
   i6 = HEAP32[i41 >> 2] | 0;
   if (i6) {
    i1 = HEAP32[i23 >> 2] | 0;
    if (i6 >>> 0 > 1) {
     i4 = i1;
     i3 = 0;
     i5 = 1;
     while (1) {
      i1 = HEAP32[i38 + (i5 << 6) + 44 >> 2] | 0;
      f59 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (f59 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
       HEAP32[i11 >> 2] = HEAP32[i42 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
       i3 = i5;
      } else i1 = i4;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i6 | 0)) break; else i4 = i1;
     }
    } else i3 = 0;
    f59 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f59 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     HEAP32[i36 >> 2] = i7;
     HEAP32[i47 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i47 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i47 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     i63 = HEAP32[i38 + (i3 << 6) + 36 >> 2] | 0;
     i2 = HEAP32[i38 + (i3 << 6) + 40 >> 2] | 0;
     HEAP32[i40 >> 2] = HEAP32[i38 + (i3 << 6) + 32 >> 2];
     HEAP32[i24 >> 2] = i63;
     HEAP32[i25 >> 2] = i2;
     HEAPF32[i26 >> 2] = Math_fround(0.0);
     i2 = i38 + (i3 << 6) + 16 | 0;
     HEAP32[i34 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i34 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i34 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i34 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     i2 = i38 + (i3 << 6) | 0;
     HEAP32[i35 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i35 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i35 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i35 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     i2 = i1;
    }
    i1 = 1;
   }
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i39 | 0));
 HEAP32[i48 >> 2] = i2;
 HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 STACKTOP = i49;
 return i1 | 0;
}

function __ZN5physx15PxsParticleData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i22 >> 2] = HEAP32[gb + 126500 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 126500 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 126500 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 126500 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 126500 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 126500 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 126500 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 126500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 126532 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 126532 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 126532 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 126532 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 126532 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 126532 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 126532 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 126532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 126564 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 126564 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 126564 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 126564 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 126564 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 126564 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 126564 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 126564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 126596 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 126596 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 126596 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 126596 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 126596 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 126596 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 126596 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 126596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 126628 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 126628 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 126628 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 126628 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 126628 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 126628 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 126628 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 126628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 126660 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 126660 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 126660 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 126660 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 126660 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 126660 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 126660 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 126660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 126692 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 126692 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 126692 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 126692 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 126692 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 126692 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 126692 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 126692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 126724 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 126724 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 126724 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 126724 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 126724 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 126724 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 126724 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 126724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 126756 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 126756 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 126756 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 126756 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 126756 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 126756 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 126756 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 126756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 126788 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 126788 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 126788 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 126788 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 126788 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 126788 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 126788 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 126788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 126820 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 126820 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 126820 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 126820 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 126820 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 126820 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 126820 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 126820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 126852 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 126852 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 126852 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 126852 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 126852 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 126852 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 126852 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 126852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 126884 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 126884 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 126884 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 126884 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 126884 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 126884 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 126884 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 126884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 126916 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 126916 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 126916 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 126916 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 126916 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 126916 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 126916 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 126916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 126948 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 126948 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 126948 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 126948 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 126948 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 126948 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 126948 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 126948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 126980 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 126980 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 126980 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 126980 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 126980 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 126980 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 126980 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 126980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 127012 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 127012 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 127012 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 127012 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 127012 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 127012 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 127012 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 127012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 127044 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 127044 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 127044 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 127044 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 127044 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 127044 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 127044 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 127044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 127076 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 127076 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 127076 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 127076 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 127076 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 127076 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 127076 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 127076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 127108 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 127108 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 127108 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 127108 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 127108 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 127108 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 127108 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 127108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN23RayMeshColliderCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i17, i4, i12, i13, i14, i1, i2) {
 i17 = i17 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f15 = f0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, f36 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27;
 i28 = i4 + 44 | 0;
 f5 = Math_fround(HEAPF32[i28 >> 2]);
 f30 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f33 = Math_fround(Math_fround(Math_fround(1.0) - f5) - f30);
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i1 = i12 + 4 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i12 + 8 | 0;
 f6 = Math_fround(f33 * f6);
 f3 = Math_fround(f33 * f3);
 f33 = Math_fround(f33 * Math_fround(HEAPF32[i2 >> 2]));
 f29 = Math_fround(HEAPF32[i13 >> 2]);
 i7 = i13 + 4 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i13 + 8 | 0;
 f29 = Math_fround(f6 + Math_fround(f5 * f29));
 f8 = Math_fround(f3 + Math_fround(f5 * f8));
 f5 = Math_fround(f33 + Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2])));
 f33 = Math_fround(HEAPF32[i14 >> 2]);
 i10 = i14 + 4 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i14 + 8 | 0;
 f33 = Math_fround(f29 + Math_fround(f30 * f33));
 f3 = Math_fround(f8 + Math_fround(f30 * f3));
 f30 = Math_fround(f5 + Math_fround(f30 * Math_fround(HEAPF32[i11 >> 2])));
 HEAP32[i26 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i18 = i26 + 12 | 0;
 HEAP16[i18 >> 1] = HEAP16[i4 + 12 >> 1] | 0;
 i19 = i26 + 16 | 0;
 HEAP32[i19 >> 2] = HEAP32[i4 + 16 >> 2];
 i20 = i26 + 20 | 0;
 HEAP32[i20 >> 2] = HEAP32[i4 + 20 >> 2];
 i21 = i26 + 24 | 0;
 HEAP32[i21 >> 2] = HEAP32[i4 + 24 >> 2];
 i22 = i26 + 28 | 0;
 HEAP32[i22 >> 2] = HEAP32[i4 + 28 >> 2];
 i23 = i26 + 32 | 0;
 HEAP32[i23 >> 2] = HEAP32[i4 + 32 >> 2];
 i24 = i26 + 36 | 0;
 HEAP32[i24 >> 2] = HEAP32[i4 + 36 >> 2];
 i25 = i26 + 40 | 0;
 HEAP32[i25 >> 2] = HEAP32[i4 + 40 >> 2];
 i16 = i26 + 44 | 0;
 HEAP32[i16 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
 i4 = i17 + 24 | 0;
 i28 = HEAP32[i4 >> 2] | 0;
 i35 = HEAP32[i17 + 20 >> 2] | 0;
 f33 = Math_fround(f33 * Math_fround(2.0));
 f3 = Math_fround(f3 * Math_fround(2.0));
 f30 = Math_fround(f30 * Math_fround(2.0));
 f5 = Math_fround(HEAPF32[i35 + 24 >> 2]);
 f8 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
 f29 = Math_fround(HEAPF32[i35 + 12 >> 2]);
 f6 = Math_fround(f33 * f29);
 f31 = Math_fround(HEAPF32[i35 + 16 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f3 * f31));
 f32 = Math_fround(HEAPF32[i35 + 20 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f30 * f32));
 f34 = Math_fround(Math_fround(f29 * f6) + Math_fround(Math_fround(f33 * f8) + Math_fround(f5 * Math_fround(Math_fround(f30 * f31) - Math_fround(f3 * f32)))));
 f15 = Math_fround(Math_fround(f31 * f6) + Math_fround(Math_fround(f3 * f8) + Math_fround(f5 * Math_fround(Math_fround(f33 * f32) - Math_fround(f30 * f29)))));
 f6 = Math_fround(Math_fround(Math_fround(f30 * f8) + Math_fround(f5 * Math_fround(Math_fround(f3 * f29) - Math_fround(f33 * f31)))) + Math_fround(f32 * f6));
 f34 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f34);
 f15 = Math_fround(Math_fround(HEAPF32[i35 + 4 >> 2]) * f15);
 f34 = Math_fround(f34 * Math_fround(2.0));
 f15 = Math_fround(f15 * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(HEAPF32[i35 + 8 >> 2]) * f6) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(f32 * f6) + Math_fround(Math_fround(f29 * f34) + Math_fround(f31 * f15)));
 f3 = Math_fround(Math_fround(Math_fround(f29 * f33) + Math_fround(Math_fround(f8 * f34) - Math_fround(f5 * Math_fround(Math_fround(f31 * f6) - Math_fround(f32 * f15))))) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(Math_fround(f31 * f33) + Math_fround(Math_fround(f8 * f15) - Math_fround(f5 * Math_fround(Math_fround(f32 * f34) - Math_fround(f29 * f6))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f6) - Math_fround(f5 * Math_fround(Math_fround(f29 * f15) - Math_fround(f31 * f34)))) + Math_fround(f32 * f33)) * Math_fround(2.0));
 f32 = Math_fround(HEAPF32[i28 + 12 >> 2]);
 f34 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f31 = Math_fround(HEAPF32[i28 >> 2]);
 f15 = Math_fround(f31 * f3);
 f29 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f29 * f30));
 f5 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f15 = Math_fround(Math_fround(f5 * f33) + f15);
 f6 = Math_fround(Math_fround(f31 * f15) + Math_fround(Math_fround(f34 * f3) + Math_fround(f32 * Math_fround(Math_fround(f29 * f33) - Math_fround(f5 * f30)))));
 f8 = Math_fround(Math_fround(f29 * f15) + Math_fround(Math_fround(f34 * f30) + Math_fround(f32 * Math_fround(Math_fround(f5 * f3) - Math_fround(f31 * f33)))));
 f15 = Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f32 * Math_fround(Math_fround(f31 * f30) - Math_fround(f29 * f3)))) + Math_fround(f5 * f15));
 f6 = Math_fround(Math_fround(HEAPF32[i28 + 16 >> 2]) + f6);
 f8 = Math_fround(Math_fround(HEAPF32[i28 + 20 >> 2]) + f8);
 f15 = Math_fround(Math_fround(HEAPF32[i28 + 24 >> 2]) + f15);
 HEAPF32[i19 >> 2] = f6;
 HEAPF32[i20 >> 2] = f8;
 HEAPF32[i21 >> 2] = f15;
 HEAP16[i18 >> 1] = 13;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 f15 = Math_fround(HEAPF32[i17 + 52 >> 2]);
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i25 >> 2]));
 HEAPF32[i25 >> 2] = f15;
 if (HEAP32[i17 + 32 >> 2] & 2 | 0) {
  f32 = Math_fround(HEAPF32[i13 >> 2]);
  f8 = Math_fround(HEAPF32[i12 >> 2]);
  f32 = Math_fround(f32 - f8);
  f34 = Math_fround(HEAPF32[i7 >> 2]);
  f33 = Math_fround(HEAPF32[i1 >> 2]);
  f34 = Math_fround(f34 - f33);
  f31 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  f31 = Math_fround(f31 - f5);
  f8 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f8);
  f33 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f33);
  f5 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f5);
  f3 = Math_fround(Math_fround(f34 * f5) - Math_fround(f31 * f33));
  f5 = Math_fround(Math_fround(f31 * f8) - Math_fround(f32 * f5));
  f8 = Math_fround(Math_fround(f32 * f33) - Math_fround(f34 * f8));
  i1 = HEAP32[i17 + 28 >> 2] | 0;
  if (!i1) {
   i35 = HEAP32[i4 >> 2] | 0;
   f32 = Math_fround(f3 * Math_fround(2.0));
   f29 = Math_fround(f5 * Math_fround(2.0));
   f34 = Math_fround(f8 * Math_fround(2.0));
   f31 = Math_fround(HEAPF32[i35 + 12 >> 2]);
   f30 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
   f8 = Math_fround(HEAPF32[i35 >> 2]);
   f5 = Math_fround(f32 * f8);
   f36 = Math_fround(HEAPF32[i35 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f29 * f36));
   f33 = Math_fround(HEAPF32[i35 + 8 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f34 * f33));
   f6 = Math_fround(Math_fround(f8 * f5) + Math_fround(Math_fround(f32 * f30) + Math_fround(f31 * Math_fround(Math_fround(f34 * f36) - Math_fround(f29 * f33)))));
   f3 = Math_fround(Math_fround(Math_fround(f34 * f30) + Math_fround(f31 * Math_fround(Math_fround(f29 * f8) - Math_fround(f32 * f36)))) + Math_fround(f33 * f5));
   f8 = Math_fround(Math_fround(f36 * f5) + Math_fround(Math_fround(f29 * f30) + Math_fround(f31 * Math_fround(Math_fround(f32 * f33) - Math_fround(f34 * f8)))));
  } else {
   f6 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 4 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 8 >> 2])));
   f36 = Math_fround(f3 * Math_fround(HEAPF32[i1 + 12 >> 2]));
   f36 = Math_fround(f36 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 16 >> 2])));
   f36 = Math_fround(f36 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 20 >> 2])));
   f3 = Math_fround(f3 * Math_fround(HEAPF32[i1 + 24 >> 2]));
   f3 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 28 >> 2])));
   f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 32 >> 2])));
   f8 = f36;
  }
  HEAPF32[i22 >> 2] = f6;
  HEAPF32[i23 >> 2] = f8;
  HEAPF32[i24 >> 2] = f3;
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f8 * f8)) + Math_fround(f3 * f3))));
  if (f5 > Math_fround(0.0)) {
   f36 = Math_fround(Math_fround(1.0) / f5);
   f6 = Math_fround(f6 * f36);
   HEAPF32[i22 >> 2] = f6;
   f5 = Math_fround(f8 * f36);
   HEAPF32[i23 >> 2] = f5;
   f3 = Math_fround(f3 * f36);
   HEAPF32[i24 >> 2] = f3;
  } else f5 = f8;
  if (HEAP8[i17 + 48 >> 0] | 0) {
   i35 = HEAP32[i17 + 44 >> 2] | 0;
   f36 = Math_fround(f6 * Math_fround(HEAPF32[i35 >> 2]));
   f36 = Math_fround(f36 + Math_fround(f5 * Math_fround(HEAPF32[i35 + 4 >> 2])));
   if (Math_fround(f36 + Math_fround(f3 * Math_fround(HEAPF32[i35 + 8 >> 2]))) > Math_fround(0.0)) {
    f34 = Math_fround(-f5);
    f36 = Math_fround(-f3);
    HEAPF32[i22 >> 2] = Math_fround(-f6);
    HEAPF32[i23 >> 2] = f34;
    HEAPF32[i24 >> 2] = f36;
   }
  }
  HEAP16[i18 >> 1] = 15;
 }
 i1 = HEAP32[i17 + 36 >> 2] | 0;
 if (i1 | 0) {
  i35 = mftCall_iii(i1 | 0, i26 | 0, HEAP32[i17 + 40 >> 2] | 0) | 0;
  STACKTOP = i27;
  return i35 | 0;
 }
 i7 = i17 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i17 + 16 >> 2] | 0)) {
  HEAP8[i17 + 49 >> 0] = 1;
  i35 = 0;
  STACKTOP = i27;
  return i35 | 0;
 }
 i4 = HEAP32[i17 + 8 >> 2] | 0;
 L23 : do if (!i1) i1 = 0; else {
  i2 = 0;
  while (1) {
   if (+Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i4 + (i2 << 6) + 40 >> 2]) - f15))) < .0001) {
    i1 = 1;
    break;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) break L23;
  }
  STACKTOP = i27;
  return i1 | 0;
 } while (0);
 HEAP32[i7 >> 2] = i1 + 1;
 i35 = i4 + (i1 << 6) | 0;
 HEAP32[i35 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP16[i4 + (i1 << 6) + 12 >> 1] = HEAP16[i18 >> 1] | 0;
 HEAP32[i4 + (i1 << 6) + 16 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i4 + (i1 << 6) + 20 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i4 + (i1 << 6) + 24 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i4 + (i1 << 6) + 28 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i4 + (i1 << 6) + 32 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i4 + (i1 << 6) + 36 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i4 + (i1 << 6) + 40 >> 2] = HEAP32[i25 >> 2];
 i35 = i4 + (i1 << 6) + 44 | 0;
 HEAP32[i35 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i35 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 i35 = 1;
 STACKTOP = i27;
 return i35 | 0;
}

function __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb(i5, i4, i40, i35, i36, i37, i15) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i40 = i40 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i46 + 396 | 0;
 i45 = i46 + 200 | 0;
 i41 = i46 + 136 | 0;
 i42 = i46 + 72 | 0;
 i44 = i46 + 60 | 0;
 i30 = i46 + 56 | 0;
 i31 = i46 + 40 | 0;
 i32 = i46 + 24 | 0;
 i33 = i46 + 8 | 0;
 i34 = i46;
 i39 = __Z12GetGfxDevicev() | 0;
 i1 = i41;
 i2 = mftCall_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 132 >> 2] | 0, i39 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i42;
 i2 = mftCall_ii(HEAP32[(HEAP32[i39 >> 2] | 0) + 128 >> 2] | 0, i39 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i44 >> 2] = 0;
 i43 = i44 + 4 | 0;
 i20 = gb + 63160 | 0;
 i29 = HEAP32[i20 + 4 >> 2] | 0;
 i1 = i43;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = i29;
 i1 = (HEAP32[i36 + 4 >> 2] | 0) - (HEAP32[i36 >> 2] | 0) | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 + 7 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, gb + 64016 | 0, 0, gb + 384477 | 0, 766) | 0;
   i20 = gb + 64016 | 0;
   i19 = HEAP32[i20 >> 2] | 0;
   i20 = HEAP32[i20 + 4 >> 2] | 0;
   HEAP32[i44 >> 2] = i1;
   i29 = i43;
   HEAP32[i29 >> 2] = i19;
   HEAP32[i29 + 4 >> 2] = i20;
   break;
  }
 } while (0);
 i29 = i1 + 7 & -8;
 f22 = Math_fround(HEAPF32[i4 + 136 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 152 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 168 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 184 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 140 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 156 >> 2]);
 f28 = Math_fround(HEAPF32[i4 + 172 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 188 >> 2]);
 i12 = 1 << i5;
 i13 = i35 + 4 | 0;
 i2 = HEAP32[i35 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) == (i2 | 0)) i20 = 0; else {
  i11 = 0;
  i1 = 0;
  do {
   i5 = HEAP32[i2 + (i11 * 24 | 0) + 8 >> 2] | 0;
   i6 = HEAP32[i37 >> 2] | 0;
   if (HEAP32[i2 + (i11 * 24 | 0) + 12 >> 2] & i12) {
    i4 = i6 + (i5 * 360 | 0) + 232 | 0;
    i8 = (HEAP16[i6 + (i5 * 360 | 0) + 182 >> 1] | 0) != 0;
    if (i8) i7 = HEAP16[i6 + (i5 * 360 | 0) + 180 >> 1] | 0; else {
     i20 = HEAP32[i2 + (i11 * 24 | 0) + 4 >> 2] | 0;
     f49 = Math_fround(HEAPF32[i20 >> 2]);
     f50 = Math_fround(f22 * f49);
     f48 = Math_fround(HEAPF32[i20 + 4 >> 2]);
     f50 = Math_fround(f50 + Math_fround(f23 * f48));
     f47 = Math_fround(HEAPF32[i20 + 8 >> 2]);
     f47 = Math_fround(Math_fround(f25 + Math_fround(f50 + Math_fround(f24 * f47))) / Math_fround(f21 + Math_fround(Math_fround(Math_fround(f26 * f49) + Math_fround(f27 * f48)) + Math_fround(f28 * f47))));
     i20 = f47 < Math_fround(0.0);
     i7 = f47 > Math_fround(1.0);
     i7 = ~~Math_fround((i7 ? Math_fround(1.0) : f47) * Math_fround(16383.0)) & 65535;
     i7 = i20 ? 0 : i7;
    }
    i3 = HEAP32[i2 + (i11 * 24 | 0) + 16 >> 2] | 0;
    i10 = i2 + (i11 * 24 | 0) + 20 | 0;
    if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
     i9 = ((HEAPU16[i4 >> 1] | HEAPU8[i4 + 2 >> 0] << 16) & 192 | 0) == 128 ? 8388608 : 0;
     i4 = _bitshift64Shl(HEAP32[i6 + (i5 * 360 | 0) + 248 >> 2] & 65535 | 0, 0, 24) | 0;
     i5 = getTempRet0() | 0;
     i4 = i7 & 65535 | i4;
     if (i8) while (1) {
      i2 = i1 + 1 | 0;
      i18 = _bitshift64Shl(HEAP32[(HEAP32[(HEAP32[i36 >> 2] | 0) + (i3 << 4) + 12 >> 2] | 0) + 156 >> 2] & 8388607 | i9 | 0, 0, 40) | 0;
      i19 = getTempRet0() | 0 | i5;
      i20 = i29 + (i1 << 4) | 0;
      HEAP32[i20 >> 2] = i18 | i4;
      HEAP32[i20 + 4 >> 2] = i19;
      HEAP32[i29 + (i1 << 4) + 8 >> 2] = i11;
      HEAP32[i29 + (i1 << 4) + 12 >> 2] = i3;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
       i1 = i2;
       break;
      } else i1 = i2;
     } else while (1) {
      i17 = HEAP32[i36 >> 2] | 0;
      i18 = HEAP32[i17 + (i3 << 4) >> 2] | 0;
      i2 = i1 + 1 | 0;
      i17 = _bitshift64Shl(HEAP32[(HEAP32[i17 + (i3 << 4) + 12 >> 2] | 0) + 156 >> 2] & 8388607 | i9 | 0, 0, 40) | 0;
      i19 = getTempRet0() | 0;
      i18 = _bitshift64Shl(i18 & 255 | 0, 0, 16) | 0;
      i19 = i19 | i5 | (getTempRet0() | 0);
      i20 = i29 + (i1 << 4) | 0;
      HEAP32[i20 >> 2] = i17 | i4 | i18;
      HEAP32[i20 + 4 >> 2] = i19;
      HEAP32[i29 + (i1 << 4) + 8 >> 2] = i11;
      HEAP32[i29 + (i1 << 4) + 12 >> 2] = i3;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
       i1 = i2;
       break;
      } else i1 = i2;
     }
    }
   }
   i11 = i11 + 1 | 0;
   i2 = HEAP32[i35 >> 2] | 0;
  } while (i11 >>> 0 < (((HEAP32[i13 >> 2] | 0) - i2 | 0) / 24 | 0) >>> 0);
  i20 = i1;
 }
 if ((HEAP16[gb + 1113024 + 6 >> 1] | 0) > -1) {
  HEAP32[i45 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i45 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113024 | 0, i14);
  i1 = gb + 1113024 | 0;
 } else i1 = 0;
 HEAP8[i14 >> 0] = HEAP8[i45 >> 0] | 0;
 __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i29, i29 + (i20 << 4) | 0, i20 << 4 >> 4, i14);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if (HEAP8[i39 + 3896 >> 0] | 0) {
  i19 = i39 + 3752 | 0;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i20;
 }
 if (!i20) {
  i45 = HEAP32[i44 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i45, i43);
  STACKTOP = i46;
  return;
 }
 mftCall_viff(HEAP32[(HEAP32[i39 >> 2] | 0) + 644 >> 2] | 0, i39 | 0, 1.0, 1.0);
 __Z12SetupLODFadeR9GfxDeviceR17ShaderPassContextf(i39, i40, Math_fround(0.0));
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i45, i14, i37, i15, 1);
 HEAP32[i30 >> 2] = 0;
 i14 = i39 + 804 | 0;
 i17 = HEAP32[i14 >> 2] | 0;
 HEAP32[i31 >> 2] = i17;
 i18 = HEAP32[i39 + 808 >> 2] | 0;
 HEAP32[i31 + 4 >> 2] = i18;
 HEAP32[i31 + 8 >> 2] = HEAP32[i39 + 812 >> 2];
 i19 = HEAP32[i39 + 816 >> 2] | 0;
 HEAP32[i31 + 12 >> 2] = i19;
 HEAP32[i32 >> 2] = i17;
 HEAP32[i32 + 4 >> 2] = i18;
 HEAPF32[i32 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i32 + 12 >> 2] = i19;
 __ZN12LODFadeCacheC2ER13BatchRenderer(i33, i45);
 if ((i20 | 0) > 0) {
  i15 = i45 + 192 | 0;
  i16 = i34 + 4 | 0;
  i11 = -1;
  i2 = 0;
  i4 = 0;
  i8 = 0;
  i13 = 0;
  i5 = 1;
  i3 = 0;
  while (1) {
   i17 = HEAP32[(HEAP32[i35 >> 2] | 0) + ((HEAP32[i29 + (i13 << 4) + 8 >> 2] | 0) * 24 | 0) + 8 >> 2] | 0;
   i10 = HEAP32[i37 >> 2] | 0;
   i18 = HEAP32[i29 + (i13 << 4) + 12 >> 2] | 0;
   i19 = HEAP32[i36 >> 2] | 0;
   i6 = i10 + (i17 * 360 | 0) + 232 | 0;
   i1 = ((HEAPU16[i6 >> 1] | HEAPU8[i6 + 2 >> 0] << 16) & 60 | 0) == 4;
   if (i4 ^ i1) {
    i4 = i1 ? i32 : i31;
    __ZN13BatchRenderer5FlushEv(i45);
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i4 = i1;
   }
   i9 = i10 + (i17 * 360 | 0) + 252 | 0;
   __ZN12LODFadeCache14ApplyValueOnlyEf(i33, Math_fround(HEAPF32[i9 >> 2]));
   i9 = HEAP32[i9 >> 2] | 0;
   i9 = (i9 & 2147483647 | 0) == 0 ? 0 : i9 >> 31 | 1;
   i12 = HEAP32[i29 + (i13 << 4) + 4 >> 2] & -256;
   i7 = (i5 | 0) != 0 | (i3 | 0) != (i12 | 0);
   if ((i9 | 0) == (i8 | 0) & (i7 ^ 1)) if ((HEAP32[i10 + (i17 * 360 | 0) + 260 >> 2] | 0) == (HEAP32[i15 >> 2] | 0)) {
    i6 = i8;
    i1 = i11;
   } else i38 = 41; else i38 = 41;
   if ((i38 | 0) == 41) {
    i38 = 0;
    __ZN13BatchRenderer5FlushEv(i45);
    __Z19SetupLODFadeKeywordR17ShaderPassContexti(i40, i9);
    i1 = (((HEAPU16[i6 >> 1] | HEAPU8[i6 + 2 >> 0] << 16) & 192 | 0) != 128) << 31 >> 31;
    if ((i1 | 0) == (i11 | 0)) i1 = i11; else mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 92 >> 2] | 0, i39 | 0, i1 | 0);
    i3 = i19 + (i18 << 4) + 8 | 0;
    if (i7) i2 = __ZNK6Shader24GetShadowCasterPassToUseEiRi(HEAP32[i3 >> 2] | 0, HEAP32[i19 + (i18 << 4) + 4 >> 2] | 0, i30) | 0;
    __ZN13BatchRenderer15ApplyShaderPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEi13BatchingFlagsbPKNS7_10GrabPassesE(i45, i40, HEAP32[i19 + (i18 << 4) + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0, i2, HEAP32[i30 >> 2] | 0, HEAP32[i10 + (i17 * 360 | 0) + 348 >> 2] | 0, 0, 0);
    i6 = i9;
    i5 = 0;
    i3 = i12;
   }
   HEAP32[i34 >> 2] = i17;
   HEAP32[i16 >> 2] = HEAP32[i19 + (i18 << 4) >> 2];
   __ZN13BatchRenderer3AddERK17BatchInstanceData(i45, i34);
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i20 | 0)) {
    i1 = i39;
    break;
   } else {
    i11 = i1;
    i8 = i6;
   }
  }
 } else i1 = i39;
 __ZN13BatchRenderer5FlushEv(i45);
 mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 112 >> 2] | 0, i39 | 0, i41 | 0);
 mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 108 >> 2] | 0, i39 | 0, i42 | 0);
 mftCall_viff(HEAP32[(HEAP32[i39 >> 2] | 0) + 644 >> 2] | 0, i39 | 0, 0.0, 0.0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i39 | 0, -1);
 i1 = i40 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 i1 = i45 + 140 | 0;
 if ((HEAP32[i45 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i45 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i45 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 35824 + 8;
 i2 = i45 + 120 | 0;
 if ((HEAP32[i45 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i45 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i45 + 96 >> 2] | 0) > -1) {
  i42 = i45 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i45 + 84 | 0);
  HEAP32[i42 >> 2] = 0;
 }
 i1 = i45 + 60 | 0;
 if ((HEAP32[i45 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i45 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i45 + 40 | 0;
 if ((HEAP32[i45 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i45 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i45 = HEAP32[i44 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i45, i43);
 STACKTOP = i46;
 return;
}

function __ZN10GUITexture14DrawGUITextureERK5RectTIfER17ShaderPassContext(i26, i22, i28) {
 i26 = i26 | 0;
 i22 = i22 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i32 + 24 | 0;
 i5 = i32 + 16 | 0;
 i30 = i32;
 i31 = i32 + 20 | 0;
 if ((HEAP16[gb + 1114504 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114504 | 0, i24);
  i25 = gb + 1114504 | 0;
 } else i25 = 0;
 if (!(HEAP32[gb + 1114516 >> 2] | 0)) {
  i29 = __Z15GetScriptMapperv() | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i24, gb + 1046327 | 0, 26);
  i29 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i29, i24) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  i29 = __ZN8Material14CreateMaterialER6Shaderib(i29, 61, 0) | 0;
  HEAP32[gb + 1114516 >> 2] = i29;
  i29 = __ZN8Material9GetShaderEv(i29) | 0;
  HEAP32[gb + 1114520 >> 2] = i29;
 } else i29 = HEAP32[gb + 1114520 >> 2] | 0;
 i27 = __ZN9GfxDevice13GetDynamicVBOEv(__Z12GetGfxDevicev() | 0) | 0;
 HEAP32[i30 >> 2] = 0;
 i23 = i30 + 4 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = -1;
 HEAP32[i30 + 12 >> 2] = 0;
 f18 = Math_fround(HEAPF32[i26 + 56 >> 2]);
 i4 = f18 < Math_fround(0.0);
 f18 = i4 ? Math_fround(0.0) : f18;
 i4 = f18 > Math_fround(1.0);
 i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f18 = Math_fround(HEAPF32[i26 + 60 >> 2]);
 i2 = f18 < Math_fround(0.0);
 f18 = i2 ? Math_fround(0.0) : f18;
 i2 = f18 > Math_fround(1.0);
 i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f18 = Math_fround(HEAPF32[i26 + 64 >> 2]);
 i1 = f18 < Math_fround(0.0);
 f18 = i1 ? Math_fround(0.0) : f18;
 i1 = f18 > Math_fround(1.0);
 i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f18 = Math_fround(HEAPF32[i26 + 68 >> 2]);
 i21 = f18 < Math_fround(0.0);
 f18 = i21 ? Math_fround(0.0) : f18;
 i21 = f18 > Math_fround(1.0);
 i21 = ~~Math_fround(Math_fround((i21 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i21 = i21 << 24;
 i3 = i21 | i1 << 16 & 16711680;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
  i19 = i4;
  i2 = (i3 | i2 << 8 & 65280) >>> 8;
  i4 = i3 >>> 16;
 } else i19 = i1;
 i16 = i26 + 52 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i20 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i24, i1, i5);
    i3 = HEAP32[i24 >> 2] | 0;
    i33 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i33 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i33 + (i3 << 3) | 0;
    i3 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i5 << 3) | 0)) i20 = 14; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i20 = 16;
   }
  }
  if ((i20 | 0) == 14) i20 = 16;
  if ((i20 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i16 >> 2] | 0) | 0;
 }
 i5 = HEAP32[i26 + 36 >> 2] | 0;
 i16 = HEAP32[i26 + 40 >> 2] | 0;
 i33 = HEAP32[i26 + 44 >> 2] | 0;
 i20 = HEAP32[i26 + 48 >> 2] | 0;
 i2 = i4 << 16 & 16711680 | i21 | i2 << 8 & 65280 | i19 & 255;
 f13 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0));
 f11 = Math_fround(HEAPF32[i22 >> 2]);
 f18 = Math_fround(f11 + Math_fround(.5));
 i21 = f18 >= Math_fround(0.0);
 f17 = Math_fround(f18 + Math_fround(-.99999994));
 f17 = Math_fround(~~(i21 ? f18 : f17) | 0);
 f11 = Math_fround(Math_fround(f11 + Math_fround(HEAPF32[i22 + 8 >> 2])) + Math_fround(.5));
 i21 = f11 >= Math_fround(0.0);
 f18 = Math_fround(f11 + Math_fround(-.99999994));
 f18 = Math_fround(~~(i21 ? f11 : f18) | 0);
 f11 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f9 = Math_fround(f11 + Math_fround(.5));
 i21 = f9 >= Math_fround(0.0);
 f8 = Math_fround(f9 + Math_fround(-.99999994));
 f11 = Math_fround(Math_fround(f11 + Math_fround(HEAPF32[i22 + 12 >> 2])) + Math_fround(.5));
 i4 = f11 >= Math_fround(0.0);
 f10 = Math_fround(f11 + Math_fround(-.99999994));
 f12 = Math_fround(i5 | 0);
 f6 = Math_fround(f12 + f17);
 f14 = Math_fround(i16 | 0);
 f7 = Math_fround(f18 - f14);
 f8 = Math_fround(~~(i21 ? f9 : f8) | 0);
 f9 = Math_fround(i20 | 0);
 f10 = Math_fround(~~(i4 ? f11 : f10) | 0);
 f11 = Math_fround(i33 | 0);
 f12 = Math_fround(Math_fround(f12 * f13) + Math_fround(0.0));
 f13 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f13));
 f14 = Math_fround(Math_fround(f9 * f15) + Math_fround(0.0));
 f15 = Math_fround(Math_fround(1.0) - Math_fround(f11 * f15));
 i4 = __ZN9GfxDevice13GetDynamicVBOEv(__Z12GetGfxDevicev() | 0) | 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 24, 16, 54, 0, i30 | 0) | 0) {
  i3 = ~~Math_fround(f10 - f11);
  i33 = ~~Math_fround(f9 + f8);
  i1 = HEAP32[i30 >> 2] | 0;
  HEAPF32[i1 >> 2] = f17;
  HEAPF32[i1 + 4 >> 2] = f8;
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 12 >> 2] = i2;
  HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 24 >> 2] = f6;
  HEAPF32[i1 + 28 >> 2] = f8;
  HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 36 >> 2] = i2;
  HEAPF32[i1 + 40 >> 2] = f12;
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 48 >> 2] = f7;
  HEAPF32[i1 + 52 >> 2] = f8;
  HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 60 >> 2] = i2;
  HEAPF32[i1 + 64 >> 2] = f13;
  HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 72 >> 2] = f18;
  HEAPF32[i1 + 76 >> 2] = f8;
  HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 84 >> 2] = i2;
  HEAPF32[i1 + 88 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
  f11 = Math_fround(i33 | 0);
  HEAPF32[i1 + 96 >> 2] = f17;
  HEAPF32[i1 + 100 >> 2] = f11;
  HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 108 >> 2] = i2;
  HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 116 >> 2] = f14;
  HEAPF32[i1 + 120 >> 2] = f6;
  HEAPF32[i1 + 124 >> 2] = f11;
  HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 132 >> 2] = i2;
  HEAPF32[i1 + 136 >> 2] = f12;
  HEAPF32[i1 + 140 >> 2] = f14;
  HEAPF32[i1 + 144 >> 2] = f7;
  HEAPF32[i1 + 148 >> 2] = f11;
  HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 156 >> 2] = i2;
  HEAPF32[i1 + 160 >> 2] = f13;
  HEAPF32[i1 + 164 >> 2] = f14;
  HEAPF32[i1 + 168 >> 2] = f18;
  HEAPF32[i1 + 172 >> 2] = f11;
  HEAPF32[i1 + 176 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 180 >> 2] = i2;
  HEAPF32[i1 + 184 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 188 >> 2] = f14;
  f14 = Math_fround(i3 | 0);
  HEAPF32[i1 + 192 >> 2] = f17;
  HEAPF32[i1 + 196 >> 2] = f14;
  HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 204 >> 2] = i2;
  HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 212 >> 2] = f15;
  HEAPF32[i1 + 216 >> 2] = f6;
  HEAPF32[i1 + 220 >> 2] = f14;
  HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 228 >> 2] = i2;
  HEAPF32[i1 + 232 >> 2] = f12;
  HEAPF32[i1 + 236 >> 2] = f15;
  HEAPF32[i1 + 240 >> 2] = f7;
  HEAPF32[i1 + 244 >> 2] = f14;
  HEAPF32[i1 + 248 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 252 >> 2] = i2;
  HEAPF32[i1 + 256 >> 2] = f13;
  HEAPF32[i1 + 260 >> 2] = f15;
  HEAPF32[i1 + 264 >> 2] = f18;
  HEAPF32[i1 + 268 >> 2] = f14;
  HEAPF32[i1 + 272 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 276 >> 2] = i2;
  HEAPF32[i1 + 280 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 284 >> 2] = f15;
  HEAPF32[i1 + 288 >> 2] = f17;
  HEAPF32[i1 + 292 >> 2] = f10;
  HEAPF32[i1 + 296 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 300 >> 2] = i2;
  HEAPF32[i1 + 304 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 308 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 312 >> 2] = f6;
  HEAPF32[i1 + 316 >> 2] = f10;
  HEAPF32[i1 + 320 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 324 >> 2] = i2;
  HEAPF32[i1 + 328 >> 2] = f12;
  HEAPF32[i1 + 332 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 336 >> 2] = f7;
  HEAPF32[i1 + 340 >> 2] = f10;
  HEAPF32[i1 + 344 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 348 >> 2] = i2;
  HEAPF32[i1 + 352 >> 2] = f13;
  HEAPF32[i1 + 356 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 360 >> 2] = f18;
  HEAPF32[i1 + 364 >> 2] = f10;
  HEAPF32[i1 + 368 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 372 >> 2] = i2;
  HEAPF32[i1 + 376 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 380 >> 2] = Math_fround(1.0);
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = gb + 222826 | 0;
  i3 = i1 + 108 | 0;
  do {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   i2 = i2 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i30 | 0, 16, 54);
  i2 = HEAP32[i29 + 32 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] | 0;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  if (i3 | 0) {
   i4 = i26 + 88 | 0;
   i1 = 0;
   do {
    HEAP32[i31 >> 2] = i26;
    HEAP32[i24 >> 2] = HEAP32[i31 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114524 | 0, i24);
    i33 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, 0, HEAP32[i4 >> 2] | 0, i28, i29, i1, 0, 0) | 0;
    i21 = HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0;
    i23 = HEAP32[gb + 1114536 + 4 >> 2] | 0;
    i22 = HEAP32[i23 + 4 >> 2] | 0;
    mftCall_viiiiiii(i21 | 0, i27 | 0, i30 | 0, i33 | 0, i22 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i23, HEAP32[i33 >> 2] | 0, 0) | 0, 0, 0);
    __Z15gpu_time_samplev();
    __Z12profiler_endP19ProfilerInformation(gb + 1114524 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 if (!i25) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i25);
 STACKTOP = i32;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEventC2Ev(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 16 | 0;
 i15 = i18;
 i17 = i18 + 48 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i14, gb + 1040589 | 0, 2);
 HEAP32[i14 >> 2] = gb + 188936 + 8;
 i13 = i14 + 32 | 0;
 __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoC2Ev(i13);
 i5 = i14 + 392 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i14 + 404 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i14 + 408 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i14 + 420 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i14 + 424 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i14 + 436 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i14 + 440 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i14 + 452 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i14 + 476 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i14 + 488 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv(i17);
 i5 = i17 + 11 | 0;
 do if ((i13 | 0) != (i17 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
  i7 = i3 ? HEAP32[i17 + 4 >> 2] | 0 : i7 & 255;
  i3 = i13 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i14 + 40 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i14 + 36 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i13 >> 2] | 0; else i1 = i13;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i14 + 36 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i12 = HEAP32[i17 >> 2] | 0;
  i11 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
 }
 i5 = i14 + 48 | 0;
 __ZN11UnityEngine15PlatformWrapper21GetApplicationVersionEv(i17);
 i6 = i17 + 11 | 0;
 do if ((i5 | 0) != (i17 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i3 = i8 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
  i8 = i3 ? HEAP32[i17 + 4 >> 2] | 0 : i8 & 255;
  i3 = i5 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i14 + 56 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i8 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i14 + 52 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i8 - i4 | 0, i1, 0, i1, i8, i7);
   break;
  }
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i14 + 52 >> 2] = i8;
   break;
  } else {
   HEAP8[i3 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i12 = HEAP32[i17 >> 2] | 0;
  i11 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
 }
 i4 = i14 + 64 | 0;
 i2 = __ZN11UnityEngine15PlatformWrapper17GameEngineVersionEv() | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i9 = 40;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i17 + 11 >> 0] = i3;
  if (!i3) i1 = i17; else {
   i1 = i17;
   i9 = 42;
  }
 } else i9 = 40;
 if ((i9 | 0) == 40) {
  i12 = i3 + 16 & -16;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i3;
  i9 = 42;
 }
 if ((i9 | 0) == 42) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i7 = i17 + 11 | 0;
 do if ((i4 | 0) != (i17 | 0)) {
  i9 = HEAP8[i7 >> 0] | 0;
  i3 = i9 << 24 >> 24 < 0;
  i8 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
  i9 = i3 ? HEAP32[i17 + 4 >> 2] | 0 : i9 & 255;
  i3 = i4 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i6 = (HEAP32[i14 + 72 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i9 >>> 0 > i6 >>> 0) {
   if (i2) i1 = HEAP32[i14 + 68 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i6, i9 - i6 | 0, i1, 0, i1, i9, i8);
   break;
  }
  if (i2) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
  if (i9 | 0) _memmove(i1 | 0, i8 | 0, i9 | 0) | 0;
  HEAP8[i1 + i9 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i14 + 68 >> 2] = i9;
   break;
  } else {
   HEAP8[i3 >> 0] = i9;
   break;
  }
 } while (0);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i12 = HEAP32[i17 >> 2] | 0;
  i11 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
 }
 i12 = i14 + 80 | 0;
 HEAP8[i12 >> 0] = (__ZN11UnityEngine15PlatformWrapper20IsRootedOrJailbrokenEv() | 0) & 1;
 HEAP8[i14 + 81 >> 0] = (__ZN11UnityEngine15PlatformWrapper13IsDebugDeviceEv() | 0) & 1;
 i2 = i14 + 88 | 0;
 __ZN11UnityEngine15PlatformWrapper15GetVRDeviceNameEv(i17);
 i8 = i17 + 11 | 0;
 do if ((i2 | 0) != (i17 | 0)) {
  i10 = HEAP8[i8 >> 0] | 0;
  i6 = i10 << 24 >> 24 < 0;
  i9 = i6 ? HEAP32[i17 >> 2] | 0 : i17;
  i10 = i6 ? HEAP32[i17 + 4 >> 2] | 0 : i10 & 255;
  i6 = i2 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) i7 = (HEAP32[i14 + 96 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
  if (i10 >>> 0 > i7 >>> 0) {
   if (i3) i1 = HEAP32[i14 + 92 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i7, i10 - i7 | 0, i1, 0, i1, i10, i9);
   break;
  }
  if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
  if (i10 | 0) _memmove(i1 | 0, i9 | 0, i10 | 0) | 0;
  HEAP8[i1 + i10 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i14 + 92 >> 2] = i10;
   break;
  } else {
   HEAP8[i6 >> 0] = i10;
   break;
  }
 } while (0);
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i11 = HEAP32[i17 >> 2] | 0;
  i10 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i15);
 }
 i1 = i14 + 104 | 0;
 __ZN11UnityEngine15PlatformWrapper16GetVRDeviceModelEv(i17);
 i9 = i17 + 11 | 0;
 do if ((i1 | 0) != (i17 | 0)) {
  i11 = HEAP8[i9 >> 0] | 0;
  i7 = i11 << 24 >> 24 < 0;
  i10 = i7 ? HEAP32[i17 >> 2] | 0 : i17;
  i11 = i7 ? HEAP32[i17 + 4 >> 2] | 0 : i11 & 255;
  i7 = i1 + 11 | 0;
  i3 = HEAP8[i7 >> 0] | 0;
  i6 = i3 << 24 >> 24 < 0;
  if (i6) i8 = (HEAP32[i14 + 112 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
  if (i11 >>> 0 > i8 >>> 0) {
   if (i6) i3 = HEAP32[i14 + 108 >> 2] | 0; else i3 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i8, i11 - i8 | 0, i3, 0, i3, i11, i10);
   break;
  }
  if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  if (i11 | 0) _memmove(i3 | 0, i10 | 0, i11 | 0) | 0;
  HEAP8[i3 + i11 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i14 + 108 >> 2] = i11;
   break;
  } else {
   HEAP8[i7 >> 0] = i11;
   break;
  }
 } while (0);
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  i11 = HEAP32[i17 >> 2] | 0;
  i10 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i15);
 }
 if ((HEAP8[i13 + 11 >> 0] | 0) < 0) i6 = HEAP32[i13 >> 2] | 0; else i6 = i13;
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) i5 = HEAP32[i5 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i4 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP16[i12 >> 1] | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i16 + 4 >> 2] = i5;
 HEAP32[i16 + 8 >> 2] = i4;
 HEAP32[i16 + 12 >> 2] = i3 & 255;
 HEAP32[i16 + 16 >> 2] = (i3 & 65535) >>> 8 & 65535;
 HEAP32[i16 + 20 >> 2] = i2;
 HEAP32[i16 + 24 >> 2] = i1;
 __Z6FormatPKcz(i15, gb + 1040600 | 0, i16);
 HEAP32[i17 >> 2] = 0;
 i2 = i17 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i17 + 24 | 0;
 i13 = gb + 63648 | 0;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = i17 + 4 | 0;
 HEAP8[i3 >> 0] = 0;
 i5 = HEAP8[i15 + 11 >> 0] | 0;
 i13 = i5 << 24 >> 24 < 0;
 i4 = i13 ? HEAP32[i15 >> 2] | 0 : i15;
 i5 = i13 ? HEAP32[i15 + 4 >> 2] | 0 : i5 & 255;
 if (i5 >>> 0 > 15) {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 4 >> 2] = i5;
  i1 = (i1 | 0) == 0 ? i3 : i1;
 } else i1 = i3;
 _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i2 >> 2] = i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 i13 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i12 = i16;
 HEAP32[i12 >> 2] = 305419896;
 HEAP32[i12 + 4 >> 2] = 0;
 i12 = i15;
 HEAP32[i12 >> 2] = 305419896;
 HEAP32[i12 + 4 >> 2] = 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_((i13 | 0) == 0 ? i3 : i13, i1, i16, i15);
 HEAP32[i14 + 84 >> 2] = HEAP32[i16 >> 2];
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (!(HEAP32[i17 + 4 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i18;
 return;
}

function __Z16GetFrustumPointsRK10Matrix4x4fP8Vector3f(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0, f12 = f0;
 i5 = i8 + 12 | 0;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i8 + 28 | 0;
 f1 = Math_fround(Math_fround(-Math_fround(HEAPF32[i6 >> 2])) - f1);
 i7 = i8 + 44 | 0;
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i7 >> 2]));
 i4 = i8 + 60 | 0;
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f3 = Math_fround(-f1);
 if ((i10 ? f3 : f1) > Math_fround(1.00000001e-07)) {
  f12 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f12 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 24 >> 2])) - f12);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i8 + 40 >> 2]));
  f12 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f12);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 20 >> 2])) - f2);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 16 >> 2])) - f3);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 32 >> 2]));
  f11 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f11 * f12);
  f2 = Math_fround(f11 * f2);
  f3 = Math_fround(f11 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 >> 2] = f3;
 HEAPF32[i9 + 4 >> 2] = f2;
 HEAPF32[i9 + 8 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i6 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i8 + 24 >> 2]));
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 20 >> 2]));
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 16 >> 2]));
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 12 >> 2] = f3;
 HEAPF32[i9 + 16 >> 2] = f2;
 HEAPF32[i9 + 20 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i6 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 24 >> 2]));
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 20 >> 2]));
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 16 >> 2]));
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 24 >> 2] = f3;
 HEAPF32[i9 + 28 >> 2] = f2;
 HEAPF32[i9 + 32 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f1);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) - f11);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) - f2);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) - f3);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 36 >> 2] = f3;
 HEAPF32[i9 + 40 >> 2] = f2;
 HEAPF32[i9 + 44 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(Math_fround(-Math_fround(HEAPF32[i6 >> 2])) - f1);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 24 >> 2])) - f11);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 20 >> 2])) - f2);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(Math_fround(-Math_fround(HEAPF32[i8 + 16 >> 2])) - f3);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 48 >> 2] = f3;
 HEAPF32[i9 + 52 >> 2] = f2;
 HEAPF32[i9 + 56 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i6 >> 2]));
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i8 + 24 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i8 + 20 >> 2]));
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 16 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 60 >> 2] = f3;
 HEAPF32[i9 + 64 >> 2] = f2;
 HEAPF32[i9 + 68 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i6 >> 2]));
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if ((i10 ? f12 : f1) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 24 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 40 >> 2]));
  f11 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f11);
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 20 >> 2]));
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 36 >> 2]));
  f2 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f2);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 16 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 32 >> 2]));
  f12 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f12 * f11);
  f2 = Math_fround(f12 * f2);
  f3 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 HEAPF32[i9 + 72 >> 2] = f3;
 HEAPF32[i9 + 76 >> 2] = f2;
 HEAPF32[i9 + 80 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f1);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i7 >> 2]));
 f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f1);
 i10 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if (!((i10 ? f12 : f1) > Math_fround(1.00000001e-07))) {
  f12 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  i10 = i9 + 84 | 0;
  HEAPF32[i10 >> 2] = f3;
  i10 = i9 + 88 | 0;
  HEAPF32[i10 >> 2] = f11;
  i10 = i9 + 92 | 0;
  HEAPF32[i10 >> 2] = f12;
  return;
 }
 f12 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) - f12);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i8 + 40 >> 2]));
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) + f12);
 f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f11 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) - f11);
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i8 + 36 >> 2]));
 f11 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f11);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) - f3);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 + 32 >> 2]));
 f2 = Math_fround(Math_fround(1.0) / f1);
 f12 = Math_fround(f2 * f12);
 f11 = Math_fround(f2 * f11);
 f3 = Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f3));
 i10 = i9 + 84 | 0;
 HEAPF32[i10 >> 2] = f3;
 i10 = i9 + 88 | 0;
 HEAPF32[i10 >> 2] = f11;
 i10 = i9 + 92 | 0;
 HEAPF32[i10 >> 2] = f12;
 return;
}

function __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB(i1, i18, i8) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i8 = i8 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i22 + 8 | 0;
 i19 = i22;
 i16 = i22 + 20 | 0;
 i17 = i22 + 16 | 0;
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f7 == f3) {
  f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  if (f7 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f7 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   if (f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
    i21 = 0;
    STACKTOP = i22;
    return i21 | 0;
   }
  }
 }
 f7 = Math_fround(-f3);
 f3 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 if (Math_fround(HEAPF32[i8 + 12 >> 2]) == f7) {
  f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  if (Math_fround(HEAPF32[i8 + 16 >> 2]) == f7) if (!(Math_fround(HEAPF32[i8 + 20 >> 2]) != f3)) {
   i21 = 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 }
 i14 = HEAP32[i1 + 1308 >> 2] | 0;
 i15 = HEAP32[i18 >> 2] | 0;
 if ((HEAP16[gb + 1113120 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1113120 | 0, HEAP32[i15 + 16 >> 2] | 0);
  i20 = gb + 1113120 | 0;
 } else i20 = 0;
 i2 = HEAP32[gb + 1113120 >> 2] | 0;
 i11 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 648 >> 2] | 0, i11 | 0, i2 | 0);
 i2 = HEAP32[i18 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 360 >> 2] | 0;
 i11 = i1 + (i2 * 960 | 0) + 72 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i12 + 4 >> 2] = i11;
 if (i13 | 0) __Z21CompleteFenceInternalR8JobFence(i4);
 i9 = i1 + (i2 * 960 | 0) + 4 | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i10 = i14 + 952 | 0;
 i4 = (HEAP32[i10 >> 2] | 0) + 752 | 0;
 i5 = i2 + 27788 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = 0;
  do {
   i6 = i2 + 27020 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 27020 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i6 >> 2] | 0, i9 | 0, i4 | 0); else mftCall_viii(HEAP32[i6 >> 2] | 0, HEAP32[i2 + 27020 + (i1 * 12 | 0) + 4 >> 2] | 0, i9 | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 __Z20SendCullingCallbacksRK13CullingOutputRK14ShadowCullDataRK15SharedLightData(i9, i14, i15);
 i1 = __ZnwjRK10MemLabelIdiPKci(36868, gb + 64024 | 0, 16, gb + 384477 | 0, 1685) | 0;
 __ZN18ShadowMapJobHeaderC2ERK13ShadowJobDataPK15SharedLightDataPK10MinMaxAABB(i1, i14, HEAP32[i18 >> 2] | 0, i8);
 i6 = i1 + 200 | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = (HEAP8[i1 + 749 >> 0] | 0) == 0 ? (HEAP32[i8 + 40 >> 2] | 0) == 1 : 0;
 i12 = i1 + 36 | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 + 104 >> 2];
 i13 = i1 + 32 | 0;
 HEAP32[i13 >> 2] = 3 - (__ZNK15SharedLightData24GetFinalShadowResolutionEv(i8) | 0);
 L25 : do if (i11) {
  i11 = __Z19GetGraphicsSettingsv() | 0;
  if (!(HEAP8[i11 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0)) i4 = 1; else {
   i4 = __Z18GetQualitySettingsv() | 0;
   i4 = HEAP32[(HEAP32[i4 + 28 >> 2] | 0) + ((HEAP32[i4 + 44 >> 2] | 0) * 108 | 0) + 32 >> 2] | 0;
  }
  HEAP32[i1 + 35884 >> 2] = i4;
  f7 = Math_fround(HEAPF32[i1 + 992 >> 2]);
  f3 = Math_fround(HEAPF32[i1 + 980 >> 2]);
  HEAPF32[i1 + 35824 >> 2] = f7;
  HEAPF32[i1 + 35824 + (i4 << 2) >> 2] = f3;
  HEAPF32[i1 + 35844 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 35844 + (i4 << 2) >> 2] = Math_fround(1.0);
  switch (i4 | 0) {
  case 2:
   {
    i11 = __Z18GetQualitySettingsv() | 0;
    HEAP32[i1 + 35848 >> 2] = HEAP32[(HEAP32[i11 + 28 >> 2] | 0) + ((HEAP32[i11 + 44 >> 2] | 0) * 108 | 0) + 44 >> 2];
    break;
   }
  case 4:
   {
    i11 = __Z18GetQualitySettingsv() | 0;
    i11 = (HEAP32[i11 + 28 >> 2] | 0) + ((HEAP32[i11 + 44 >> 2] | 0) * 108 | 0) + 48 | 0;
    HEAP32[i1 + 35848 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i1 + 35852 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i1 + 35856 >> 2] = HEAP32[i11 + 8 >> 2];
    break;
   }
  default:
   if ((i4 | 0) <= 1) break L25;
  }
  f3 = Math_fround(f3 - f7);
  i2 = 1;
  do {
   HEAPF32[i1 + 35824 + (i2 << 2) >> 2] = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i1 + 35844 + (i2 << 2) >> 2])));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 } else {
  HEAP32[i1 + 35824 >> 2] = HEAP32[i1 + 992 >> 2];
  HEAP32[i1 + 35828 >> 2] = HEAP32[i1 + 980 >> 2];
  HEAPF32[i1 + 35844 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 35848 >> 2] = Math_fround(1.0);
  HEAP32[i1 + 35884 >> 2] = 1;
 } while (0);
 i11 = __Z18GetQualitySettingsv() | 0;
 i11 = HEAP32[(HEAP32[i11 + 28 >> 2] | 0) + ((HEAP32[i11 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = i11;
 if ((i11 | 0) == 1) {
  i2 = i1 + 48 | 0;
  i4 = i1 + 584 | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = i1 + 112 | 0;
  i4 = i6;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
 }
 i11 = i1 + 35884 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i4 + 1 | 0;
 if ((i2 | 0) < 5) {
  f7 = Math_fround(HEAPF32[i1 + 35824 + (i4 << 2) >> 2]);
  f3 = Math_fround(HEAPF32[i1 + ((i4 << 2) + 35844) >> 2]);
  do {
   f7 = Math_fround(f7 * Math_fround(1.00999999));
   HEAPF32[i1 + 35824 + (i2 << 2) >> 2] = f7;
   f3 = Math_fround(f3 * Math_fround(1.00999999));
   HEAPF32[i1 + 35844 + (i2 << 2) >> 2] = f3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 5);
  i2 = HEAP32[i11 >> 2] | 0;
 } else i2 = i4;
 HEAPF32[i1 + 35760 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35764 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35768 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35772 >> 2] = Math_fround(-inf);
 HEAPF32[i1 + 35776 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35780 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35784 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35788 >> 2] = Math_fround(-inf);
 HEAPF32[i1 + 35792 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35796 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35800 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35804 >> 2] = Math_fround(-inf);
 HEAPF32[i1 + 35808 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35812 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35816 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 35820 >> 2] = Math_fround(-inf);
 i4 = i2 << 6;
 if ((i2 | 0) < 4) _memset(i1 + (i4 + 34040) | 0, 0, 256 - i4 | 0) | 0;
 i5 = __Z16GetBuildSettingsv() | 0;
 i6 = __Z18GetQualitySettingsv() | 0;
 i8 = HEAP32[i6 + 44 >> 2] | 0;
 i6 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = __Z19GetGraphicsSettingsv() | 0;
 HEAP8[i1 + 36856 >> 0] = HEAP8[i4 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0;
 i5 = HEAP16[i5 + 116 >> 1] | 0;
 HEAP8[i1 + 36857 >> 0] = i5;
 HEAP8[i1 + 36858 >> 0] = (i5 & 65535) >>> 8;
 HEAP32[i1 + 36860 >> 2] = HEAP32[i6 + (i8 * 108 | 0) + 20 >> 2];
 HEAP32[i1 + 36864 >> 2] = HEAP32[i6 + (i8 * 108 | 0) + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i6 + (i8 * 108 | 0) + 40 >> 2];
 i10 = HEAP32[i10 >> 2] | 0;
 i9 = __Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags(i1 + 1228 | 0, i10 + 752 | 0, i9, HEAP32[i10 + 812 >> 2] | 0, 4) | 0;
 if (!i9) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
  i1 = 0;
 } else {
  i6 = i1 + 24 | 0;
  i10 = i1 + 28 | 0;
  i8 = i1 + 44 | 0;
  i2 = HEAP32[i18 + 56 >> 2] | 0;
  i4 = HEAP32[i18 + 60 >> 2] | 0;
  HEAP32[i19 >> 2] = i2;
  i5 = i19 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  if (HEAP8[i14 + 548 >> 0] | 0) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAP32[i18 + 72 >> 2] | 0;
   i2 = HEAP32[i18 + 76 >> 2] | 0;
   HEAP32[i16 >> 2] = i4;
   HEAP32[i17 >> 2] = i2;
   i4 = f3 < (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i2 = f7 < (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i5 = HEAP32[(i2 ? i17 : i5) >> 2] | 0;
   i17 = i19;
   HEAP32[i17 >> 2] = HEAP32[(i4 ? i16 : i19) >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
  }
  i2 = __Z22CalculateShadowMapSizeRK13ShadowJobData9LightTypeRK8Vector2fii(i14, HEAP32[(HEAP32[i18 >> 2] | 0) + 40 >> 2] | 0, i19, HEAP32[i13 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i1 + 20 >> 2] = i2;
  do if ((HEAP32[i15 + 40 >> 2] | 0) == 2) {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 500 >> 0] | 0)) {
    __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext(i9) | 0;
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
    i1 = 0;
    break;
   }
   HEAP32[i8 >> 2] = 23;
   i19 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 479 >> 0] | 0) == 0;
   i2 = __Z15GetGraphicsCapsv() | 0;
   if (i19) {
    if (HEAP8[i2 + 247 >> 0] | 0) {
     HEAP32[i8 >> 2] = 14;
     i2 = 1;
     i21 = 55;
     break;
    }
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 245 >> 0] | 0) {
     HEAP32[i8 >> 2] = 12;
     i2 = 1;
     i21 = 55;
     break;
    }
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 248 >> 0] | 0) {
     HEAP32[i8 >> 2] = 15;
     i2 = 1;
     i21 = 55;
     break;
    }
   } else if (HEAP8[i2 + 233 >> 0] | 0) {
    HEAP32[i8 >> 2] = 0;
    i2 = 1;
    i21 = 55;
    break;
   }
   if ((HEAP32[i8 >> 2] | 0) == 23) {
    __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext(i9) | 0;
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
    i1 = 0;
   } else {
    i2 = 1;
    i21 = 55;
   }
  } else {
   if ((HEAP32[i11 >> 2] | 0) == 2) HEAP32[i6 >> 2] = (i2 | 0) / 2 | 0;
   i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0) != 0;
   HEAP32[i8 >> 2] = i2 ? 3 : 1;
   i2 = 0;
   i21 = 55;
  } while (0);
  do if ((i21 | 0) == 55) {
   HEAP8[i10 >> 0] = i2;
   if (__Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext(i9) | 0) {
    HEAP8[i1 + 36859 >> 0] = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 105 >> 0] | 0;
    __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i1 + 34296 | 0, fb + 3339 | 0, i1, 0);
    break;
   } else {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
    i1 = 0;
    break;
   }
  } while (0);
 }
 i21 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i21 >> 2] | 0) + 652 >> 2] | 0, i21 | 0);
 if (!i20) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i20);
 i21 = i1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5physx2Gu27generateFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb(i40, i46, i43, i39, i42, i45, i41, i44, i1) {
 i40 = i40 | 0;
 i46 = i46 | 0;
 i43 = i43 | 0;
 i39 = i39 | 0;
 i42 = i42 | 0;
 i45 = i45 | 0;
 i41 = i41 | 0;
 i44 = i44 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, i51 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i48;
 i38 = HEAP32[i45 >> 2] | 0;
 if (i1) if (!(__ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i40, i46, i43, i41, i48 + 16 | 0, i44) | 0)) {
  i47 = 0;
  STACKTOP = i48;
  return i47 | 0;
 }
 f35 = Math_fround(HEAPF32[i40 + 128 >> 2]);
 f35 = Math_fround(f35 + Math_fround(HEAPF32[i41 >> 2]));
 f32 = Math_fround(HEAPF32[i44 >> 2]);
 i36 = i44 + 4 | 0;
 f33 = Math_fround(HEAPF32[i36 >> 2]);
 i31 = i44 + 8 | 0;
 f32 = Math_fround(-f32);
 f33 = Math_fround(-f33);
 f34 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 i15 = i43 + 40 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i16 >> 2]);
 f28 = Math_fround(f21 * f32);
 f9 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f9 * f33));
 f8 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f8 * f34));
 f10 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f29 = Math_fround(f10 * f32);
 f6 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f29 = Math_fround(f29 + Math_fround(f6 * f33));
 f4 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f29 = Math_fround(f29 + Math_fround(f4 * f34));
 f5 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f30 = Math_fround(f5 * f32);
 f3 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f3 * f33));
 f26 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f26 * f34));
 i16 = i40 + 96 | 0;
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i40 + 100 | 0;
 f23 = Math_fround(HEAPF32[i17 >> 2]);
 i24 = i40 + 104 | 0;
 f25 = Math_fround(HEAPF32[i24 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f21 * f22) + Math_fround(f9 * f23)) + Math_fround(f8 * f25));
 f19 = Math_fround(Math_fround(Math_fround(f10 * f22) + Math_fround(f6 * f23)) + Math_fround(f4 * f25));
 f20 = Math_fround(Math_fround(Math_fround(f5 * f22) + Math_fround(f3 * f23)) + Math_fround(f26 * f25));
 i27 = i46 + 16 | 0;
 i12 = HEAP32[i27 >> 2] | 0;
 L5 : do if (!i12) {
  f2 = Math_fround(0.0);
  i47 = 10;
 } else {
  i1 = HEAP32[i46 + 24 >> 2] | 0;
  f2 = Math_fround(0.0);
  f11 = Math_fround(1.0);
  i7 = 0;
  while (1) {
   f50 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) >> 2]);
   f49 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 8 >> 2]);
   f13 = Math_fround(Math_fround(Math_fround(f28 * f50) + Math_fround(f29 * f49)) + Math_fround(f30 * f14));
   f14 = Math_fround(Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 12 >> 2]) + Math_fround(Math_fround(Math_fround(f18 * f50) + Math_fround(f19 * f49)) + Math_fround(f20 * f14)));
   if (Math_fround(Math_abs(Math_fround(f13))) < Math_fround(1.00000001e-07)) {
    if (f14 > Math_fround(0.0)) {
     f11 = f21;
     f2 = f26;
     break L5;
    }
   } else {
    f50 = Math_fround(-Math_fround(f14 / f13));
    i51 = f13 < Math_fround(0.0);
    f2 = i51 & f2 < f50 ? f50 : f2;
    f11 = f11 > f50 & (i51 ^ 1) ? f50 : f11;
   }
   i7 = i7 + 1 | 0;
   if (f2 > f11) {
    f11 = f21;
    f2 = f26;
    break L5;
   }
   if (i7 >>> 0 >= i12 >>> 0) {
    i47 = 10;
    break;
   }
  }
 } while (0);
 if ((i47 | 0) == 10) if (!(f35 >= f2)) {
  f11 = f21;
  f2 = f26;
 } else {
  i12 = HEAP32[i45 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i39 + 48 >> 2]);
  f10 = Math_fround(HEAPF32[i39 + 52 >> 2]);
  f6 = Math_fround(f22 - f6);
  f10 = Math_fround(f23 - f10);
  f8 = Math_fround(f25 - Math_fround(HEAPF32[i39 + 56 >> 2]));
  f11 = Math_fround(f6 * Math_fround(HEAPF32[i39 >> 2]));
  f11 = Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i39 + 4 >> 2])));
  f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i39 + 8 >> 2])));
  f9 = Math_fround(f6 * Math_fround(HEAPF32[i39 + 16 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i39 + 20 >> 2])));
  f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i39 + 24 >> 2])));
  f6 = Math_fround(f6 * Math_fround(HEAPF32[i39 + 32 >> 2]));
  f10 = Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i39 + 36 >> 2])));
  f8 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i39 + 40 >> 2])));
  HEAPF32[i42 + (i12 * 48 | 0) >> 2] = f11;
  HEAPF32[i42 + (i12 * 48 | 0) + 4 >> 2] = f9;
  HEAPF32[i42 + (i12 * 48 | 0) + 8 >> 2] = f8;
  HEAPF32[i42 + (i12 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  i12 = HEAP32[i45 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i16 >> 2]);
  f9 = Math_fround(HEAPF32[i17 >> 2]);
  f9 = Math_fround(Math_fround(f2 * f33) + f9);
  f11 = Math_fround(Math_fround(f2 * f34) + Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i42 + (i12 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f2 * f32) + f8);
  HEAPF32[i42 + (i12 * 48 | 0) + 20 >> 2] = f9;
  HEAPF32[i42 + (i12 * 48 | 0) + 24 >> 2] = f11;
  HEAPF32[i42 + (i12 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  i12 = HEAP32[i45 >> 2] | 0;
  HEAP32[i45 >> 2] = i12 + 1;
  i24 = HEAP32[i36 >> 2] | 0;
  i51 = HEAP32[i31 >> 2] | 0;
  HEAP32[i42 + (i12 * 48 | 0) + 32 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i42 + (i12 * 48 | 0) + 36 >> 2] = i24;
  HEAP32[i42 + (i12 * 48 | 0) + 40 >> 2] = i51;
  HEAPF32[i42 + (i12 * 48 | 0) + 44 >> 2] = f2;
  i12 = HEAP32[i15 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i12 >> 2]);
  f9 = Math_fround(HEAPF32[i12 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i12 + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i12 + 20 >> 2]);
  f4 = Math_fround(HEAPF32[i12 + 36 >> 2]);
  f5 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i12 + 24 >> 2]);
  f2 = Math_fround(HEAPF32[i12 + 40 >> 2]);
  i12 = HEAP32[i27 >> 2] | 0;
 }
 i15 = i40 + 112 | 0;
 f13 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i40 + 116 | 0;
 f14 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i40 + 120 | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f11 * f13) + Math_fround(f9 * f14)) + Math_fround(f8 * f18));
 f8 = Math_fround(Math_fround(Math_fround(f10 * f13) + Math_fround(f6 * f14)) + Math_fround(f4 * f18));
 f6 = Math_fround(Math_fround(Math_fround(f5 * f13) + Math_fround(f3 * f14)) + Math_fround(f2 * f18));
 L18 : do if (!i12) {
  f2 = Math_fround(0.0);
  i47 = 19;
 } else {
  i1 = HEAP32[i46 + 24 >> 2] | 0;
  f2 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  i7 = 0;
  while (1) {
   f49 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) >> 2]);
   f50 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 8 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f28 * f49) + Math_fround(f29 * f50)) + Math_fround(f30 * f5));
   f5 = Math_fround(Math_fround(HEAPF32[i1 + (i7 * 20 | 0) + 12 >> 2]) + Math_fround(Math_fround(Math_fround(f9 * f49) + Math_fround(f8 * f50)) + Math_fround(f6 * f5)));
   if (Math_fround(Math_abs(Math_fround(f4))) < Math_fround(1.00000001e-07)) {
    if (f5 > Math_fround(0.0)) break L18;
   } else {
    f50 = Math_fround(-Math_fround(f5 / f4));
    i51 = f4 < Math_fround(0.0);
    f2 = i51 & f2 < f50 ? f50 : f2;
    f3 = f3 > f50 & (i51 ^ 1) ? f50 : f3;
   }
   i7 = i7 + 1 | 0;
   if (f2 > f3) break L18;
   if (i7 >>> 0 >= i12 >>> 0) {
    i47 = 19;
    break;
   }
  }
 } while (0);
 if ((i47 | 0) == 19) if (f35 >= f2) {
  i51 = HEAP32[i45 >> 2] | 0;
  f29 = Math_fround(HEAPF32[i39 + 48 >> 2]);
  f30 = Math_fround(HEAPF32[i39 + 52 >> 2]);
  f29 = Math_fround(f13 - f29);
  f30 = Math_fround(f14 - f30);
  f35 = Math_fround(f18 - Math_fround(HEAPF32[i39 + 56 >> 2]));
  f50 = Math_fround(f29 * Math_fround(HEAPF32[i39 >> 2]));
  f50 = Math_fround(f50 + Math_fround(f30 * Math_fround(HEAPF32[i39 + 4 >> 2])));
  f50 = Math_fround(f50 + Math_fround(f35 * Math_fround(HEAPF32[i39 + 8 >> 2])));
  f49 = Math_fround(f29 * Math_fround(HEAPF32[i39 + 16 >> 2]));
  f49 = Math_fround(f49 + Math_fround(f30 * Math_fround(HEAPF32[i39 + 20 >> 2])));
  f49 = Math_fround(f49 + Math_fround(f35 * Math_fround(HEAPF32[i39 + 24 >> 2])));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i39 + 32 >> 2]));
  f30 = Math_fround(f29 + Math_fround(f30 * Math_fround(HEAPF32[i39 + 36 >> 2])));
  f35 = Math_fround(f30 + Math_fround(f35 * Math_fround(HEAPF32[i39 + 40 >> 2])));
  HEAPF32[i42 + (i51 * 48 | 0) >> 2] = f50;
  HEAPF32[i42 + (i51 * 48 | 0) + 4 >> 2] = f49;
  HEAPF32[i42 + (i51 * 48 | 0) + 8 >> 2] = f35;
  HEAPF32[i42 + (i51 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
  i51 = HEAP32[i45 >> 2] | 0;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  f49 = Math_fround(HEAPF32[i16 >> 2]);
  f49 = Math_fround(Math_fround(f2 * f33) + f49);
  f50 = Math_fround(Math_fround(f2 * f34) + Math_fround(HEAPF32[i17 >> 2]));
  HEAPF32[i42 + (i51 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f2 * f32) + f35);
  HEAPF32[i42 + (i51 * 48 | 0) + 20 >> 2] = f49;
  HEAPF32[i42 + (i51 * 48 | 0) + 24 >> 2] = f50;
  HEAPF32[i42 + (i51 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
  i51 = HEAP32[i45 >> 2] | 0;
  HEAP32[i45 >> 2] = i51 + 1;
  i27 = HEAP32[i36 >> 2] | 0;
  i47 = HEAP32[i31 >> 2] | 0;
  HEAP32[i42 + (i51 * 48 | 0) + 32 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i42 + (i51 * 48 | 0) + 36 >> 2] = i27;
  HEAP32[i42 + (i51 * 48 | 0) + 40 >> 2] = i47;
  HEAPF32[i42 + (i51 * 48 | 0) + 44 >> 2] = f2;
 }
 if (((HEAP32[i45 >> 2] | 0) - i38 | 0) >>> 0 >= 2) {
  i51 = 1;
  STACKTOP = i48;
  return i51 | 0;
 }
 f35 = Math_fround(HEAPF32[i44 >> 2]);
 f49 = Math_fround(HEAPF32[i36 >> 2]);
 f49 = Math_fround(-f49);
 f50 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 HEAPF32[i37 >> 2] = Math_fround(-f35);
 HEAPF32[i37 + 4 >> 2] = f49;
 HEAPF32[i37 + 8 >> 2] = f50;
 HEAPF32[i37 + 12 >> 2] = Math_fround(0.0);
 i51 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i46, i43, i37) | 0;
 __ZN5physx2Gu27generatedContactsEEContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE(i40, i46, (HEAP32[i46 + 24 >> 2] | 0) + (i51 * 20 | 0) | 0, i43, i39, i42, i45, i41, i44);
 i51 = 1;
 STACKTOP = i48;
 return i51 | 0;
}

function __Z22DetermineFilterExtentsPfiiP10CBBoxInt32(i1, i24, i3, i25) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29 + 32 | 0;
 i27 = i29 + 16 | 0;
 i28 = i29;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(Math_abs(Math_fround(f8)));
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(Math_abs(Math_fround(f7)));
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(Math_abs(Math_fround(f6)));
 do if (!(f5 >= f2) | !(f5 >= f4)) if (!(f2 >= f5) | !(f2 >= f4)) {
  i23 = !(f6 >= Math_fround(0.0));
  f2 = f4;
  i23 = i23 ? 5 : 4;
  break;
 } else {
  i23 = !(f7 >= Math_fround(0.0));
  i23 = i23 ? 3 : 2;
  break;
 } else {
  f2 = f5;
  i23 = !(f8 >= Math_fround(0.0)) & 1;
 } while (0);
 f5 = Math_fround(Math_fround(1.0) / f2);
 f4 = Math_fround(f8 * f5);
 f7 = Math_fround(f7 * f5);
 f8 = Math_fround(f6 * f5);
 f5 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) >> 2]) * f4);
 f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) + 4 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) + 8 >> 2])));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) + 12 >> 2]));
 f7 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) + 16 >> 2])));
 i22 = i24 + -1 | 0;
 f6 = Math_fround(Math_fround(i22 | 0) * Math_fround(.5));
 i19 = ~~Math_fround(Math_floor(Math_fround(f6 * Math_fround(f5 + Math_fround(1.0)))));
 i17 = ~~Math_fround(Math_floor(Math_fround(f6 * Math_fround(Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[gb + 41340 + (i23 * 36 | 0) + 20 >> 2]))) + Math_fround(1.0)))));
 i21 = i19 - i3 | 0;
 i16 = i17 - i3 | 0;
 i10 = i25 + (i23 * 24 | 0) | 0;
 i20 = HEAP32[i10 >> 2] | 0;
 i20 = (i20 | 0) < (i21 | 0) ? i20 : i21;
 i11 = i25 + (i23 * 24 | 0) + 4 | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i15 = (i15 | 0) < (i16 | 0) ? i15 : i16;
 i12 = i25 + (i23 * 24 | 0) + 12 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i21 = (i13 | 0) > (i21 | 0) ? i13 : i21;
 i13 = i25 + (i23 * 24 | 0) + 16 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i16 = (i14 | 0) > (i16 | 0) ? i14 : i16;
 i14 = i19 + i3 | 0;
 i18 = i17 + i3 | 0;
 i20 = (i20 | 0) < (i14 | 0) ? i20 : i14;
 i15 = (i15 | 0) < (i18 | 0) ? i15 : i18;
 i21 = (i21 | 0) > (i14 | 0) ? i21 : i14;
 i16 = (i16 | 0) > (i18 | 0) ? i16 : i18;
 i20 = (i20 | 0) > 0 ? i20 : 0;
 HEAP32[i10 >> 2] = i20;
 i15 = (i15 | 0) > 0 ? i15 : 0;
 HEAP32[i11 >> 2] = i15;
 HEAP32[i25 + (i23 * 24 | 0) + 8 >> 2] = 0;
 i21 = (i21 | 0) < (i22 | 0) ? i21 : i22;
 HEAP32[i12 >> 2] = i21;
 i16 = (i16 | 0) < (i22 | 0) ? i16 : i22;
 HEAP32[i13 >> 2] = i16;
 HEAP32[i25 + (i23 * 24 | 0) + 20 >> 2] = 0;
 i19 = i3 - i19 | 0;
 HEAP32[i26 >> 2] = i19;
 HEAP32[i27 >> 2] = i15;
 HEAP32[i28 >> 2] = i16;
 HEAP32[i26 + 4 >> 2] = i14 - i22;
 HEAP32[i27 + 4 >> 2] = i15;
 HEAP32[i28 + 4 >> 2] = i16;
 HEAP32[i26 + 8 >> 2] = i3 - i17;
 HEAP32[i27 + 8 >> 2] = i20;
 HEAP32[i28 + 8 >> 2] = i21;
 HEAP32[i26 + 12 >> 2] = i18 - i22;
 HEAP32[i27 + 12 >> 2] = i20;
 HEAP32[i28 + 12 >> 2] = i21;
 i21 = i23 & 255;
 i20 = 0;
 while (1) {
  if ((i19 | 0) > 0) {
   i1 = HEAPU8[gb + 397165 + (i23 << 3) + (i20 << 1) >> 0] | 0;
   i3 = HEAP8[gb + 397165 + (i23 << 3) + (i20 << 1) + 1 >> 0] | 0;
   i18 = i3 & 255;
   if ((i20 | 0) == (i18 | 0) | (i18 + i20 | 0) == 3) {
    i18 = i27 + (i20 << 2) | 0;
    HEAP32[i18 >> 2] = i22 - (HEAP32[i18 >> 2] | 0);
    i18 = i28 + (i20 << 2) | 0;
    HEAP32[i18 >> 2] = i22 - (HEAP32[i18 >> 2] | 0);
   }
   switch (i3 << 24 >> 24) {
   case 0:
    {
     i31 = HEAP32[i27 + (i20 << 2) >> 2] | 0;
     i12 = i25 + (i1 * 24 | 0) | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     i13 = (i13 | 0) < 0 ? i13 : 0;
     i30 = i25 + (i1 * 24 | 0) + 4 | 0;
     i14 = HEAP32[i30 >> 2] | 0;
     i14 = (i14 | 0) < (i31 | 0) ? i14 : i31;
     i3 = i25 + (i1 * 24 | 0) + 8 | 0;
     i15 = HEAP32[i3 >> 2] | 0;
     i9 = i25 + (i1 * 24 | 0) + 12 | 0;
     i16 = HEAP32[i9 >> 2] | 0;
     i16 = (i16 | 0) > 0 ? i16 : 0;
     i10 = i25 + (i1 * 24 | 0) + 16 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     i31 = (i11 | 0) > (i31 | 0) ? i11 : i31;
     i11 = i25 + (i1 * 24 | 0) + 20 | 0;
     i18 = HEAP32[i11 >> 2] | 0;
     i17 = HEAP32[i28 + (i20 << 2) >> 2] | 0;
     i13 = (i13 | 0) < (i19 | 0) ? i13 : i19;
     HEAP32[i12 >> 2] = i13;
     i14 = (i14 | 0) < (i17 | 0) ? i14 : i17;
     HEAP32[i30 >> 2] = i14;
     i15 = (i15 | 0) < 0 ? i15 : 0;
     HEAP32[i3 >> 2] = i15;
     i16 = (i16 | 0) > (i19 | 0) ? i16 : i19;
     HEAP32[i9 >> 2] = i16;
     i17 = (i31 | 0) > (i17 | 0) ? i31 : i17;
     HEAP32[i10 >> 2] = i17;
     i18 = (i18 | 0) > 0 ? i18 : 0;
     HEAP32[i11 >> 2] = i18;
     i1 = i30;
     break;
    }
   case 1:
    {
     i30 = HEAP32[i27 + (i20 << 2) >> 2] | 0;
     i12 = i25 + (i1 * 24 | 0) | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     i13 = (i13 | 0) < (i22 | 0) ? i13 : i22;
     i31 = i25 + (i1 * 24 | 0) + 4 | 0;
     i14 = HEAP32[i31 >> 2] | 0;
     i14 = (i14 | 0) < (i30 | 0) ? i14 : i30;
     i3 = i25 + (i1 * 24 | 0) + 8 | 0;
     i15 = HEAP32[i3 >> 2] | 0;
     i9 = i25 + (i1 * 24 | 0) + 12 | 0;
     i32 = HEAP32[i9 >> 2] | 0;
     i32 = (i32 | 0) > (i22 | 0) ? i32 : i22;
     i10 = i25 + (i1 * 24 | 0) + 16 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     i30 = (i11 | 0) > (i30 | 0) ? i11 : i30;
     i11 = i25 + (i1 * 24 | 0) + 20 | 0;
     i18 = HEAP32[i11 >> 2] | 0;
     i16 = i22 - i19 | 0;
     i17 = HEAP32[i28 + (i20 << 2) >> 2] | 0;
     i13 = (i13 | 0) < (i16 | 0) ? i13 : i16;
     HEAP32[i12 >> 2] = i13;
     i14 = (i14 | 0) < (i17 | 0) ? i14 : i17;
     HEAP32[i31 >> 2] = i14;
     i15 = (i15 | 0) < 0 ? i15 : 0;
     HEAP32[i3 >> 2] = i15;
     i16 = (i32 | 0) > (i16 | 0) ? i32 : i16;
     HEAP32[i9 >> 2] = i16;
     i17 = (i30 | 0) > (i17 | 0) ? i30 : i17;
     HEAP32[i10 >> 2] = i17;
     i18 = (i18 | 0) > 0 ? i18 : 0;
     HEAP32[i11 >> 2] = i18;
     i1 = i31;
     break;
    }
   case 2:
    {
     i31 = HEAP32[i27 + (i20 << 2) >> 2] | 0;
     i12 = i25 + (i1 * 24 | 0) | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     i13 = (i13 | 0) < (i31 | 0) ? i13 : i31;
     i32 = i25 + (i1 * 24 | 0) + 4 | 0;
     i14 = HEAP32[i32 >> 2] | 0;
     i14 = (i14 | 0) < 0 ? i14 : 0;
     i3 = i25 + (i1 * 24 | 0) + 8 | 0;
     i15 = HEAP32[i3 >> 2] | 0;
     i9 = i25 + (i1 * 24 | 0) + 12 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     i31 = (i10 | 0) > (i31 | 0) ? i10 : i31;
     i10 = i25 + (i1 * 24 | 0) + 16 | 0;
     i17 = HEAP32[i10 >> 2] | 0;
     i17 = (i17 | 0) > 0 ? i17 : 0;
     i11 = i25 + (i1 * 24 | 0) + 20 | 0;
     i18 = HEAP32[i11 >> 2] | 0;
     i16 = HEAP32[i28 + (i20 << 2) >> 2] | 0;
     i13 = (i13 | 0) < (i16 | 0) ? i13 : i16;
     HEAP32[i12 >> 2] = i13;
     i14 = (i14 | 0) < (i19 | 0) ? i14 : i19;
     HEAP32[i32 >> 2] = i14;
     i15 = (i15 | 0) < 0 ? i15 : 0;
     HEAP32[i3 >> 2] = i15;
     i16 = (i31 | 0) > (i16 | 0) ? i31 : i16;
     HEAP32[i9 >> 2] = i16;
     i17 = (i17 | 0) > (i19 | 0) ? i17 : i19;
     HEAP32[i10 >> 2] = i17;
     i18 = (i18 | 0) > 0 ? i18 : 0;
     HEAP32[i11 >> 2] = i18;
     i1 = i32;
     break;
    }
   case 3:
    {
     i30 = HEAP32[i27 + (i20 << 2) >> 2] | 0;
     i12 = i25 + (i1 * 24 | 0) | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     i13 = (i13 | 0) < (i30 | 0) ? i13 : i30;
     i32 = i25 + (i1 * 24 | 0) + 4 | 0;
     i14 = HEAP32[i32 >> 2] | 0;
     i14 = (i14 | 0) < (i22 | 0) ? i14 : i22;
     i3 = i25 + (i1 * 24 | 0) + 8 | 0;
     i15 = HEAP32[i3 >> 2] | 0;
     i9 = i25 + (i1 * 24 | 0) + 12 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     i30 = (i10 | 0) > (i30 | 0) ? i10 : i30;
     i10 = i25 + (i1 * 24 | 0) + 16 | 0;
     i31 = HEAP32[i10 >> 2] | 0;
     i31 = (i31 | 0) > (i22 | 0) ? i31 : i22;
     i11 = i25 + (i1 * 24 | 0) + 20 | 0;
     i18 = HEAP32[i11 >> 2] | 0;
     i16 = HEAP32[i28 + (i20 << 2) >> 2] | 0;
     i17 = i22 - i19 | 0;
     i13 = (i13 | 0) < (i16 | 0) ? i13 : i16;
     HEAP32[i12 >> 2] = i13;
     i14 = (i14 | 0) < (i17 | 0) ? i14 : i17;
     HEAP32[i32 >> 2] = i14;
     i15 = (i15 | 0) < 0 ? i15 : 0;
     HEAP32[i3 >> 2] = i15;
     i16 = (i30 | 0) > (i16 | 0) ? i30 : i16;
     HEAP32[i9 >> 2] = i16;
     i17 = (i31 | 0) > (i17 | 0) ? i31 : i17;
     HEAP32[i10 >> 2] = i17;
     i18 = (i18 | 0) > 0 ? i18 : 0;
     HEAP32[i11 >> 2] = i18;
     i1 = i32;
     break;
    }
   default:
    {
     i13 = i25 + (i1 * 24 | 0) | 0;
     i14 = i25 + (i1 * 24 | 0) + 4 | 0;
     i15 = i25 + (i1 * 24 | 0) + 8 | 0;
     i16 = i25 + (i1 * 24 | 0) + 12 | 0;
     i17 = i25 + (i1 * 24 | 0) + 16 | 0;
     i18 = i25 + (i1 * 24 | 0) + 20 | 0;
     i1 = i14;
     i3 = i15;
     i9 = i16;
     i10 = i17;
     i11 = i18;
     i12 = i13;
     i13 = HEAP32[i13 >> 2] | 0;
     i14 = HEAP32[i14 >> 2] | 0;
     i15 = HEAP32[i15 >> 2] | 0;
     i16 = HEAP32[i16 >> 2] | 0;
     i17 = HEAP32[i17 >> 2] | 0;
     i18 = HEAP32[i18 >> 2] | 0;
    }
   }
   HEAP32[i12 >> 2] = (i13 | 0) > 0 ? i13 : 0;
   HEAP32[i1 >> 2] = (i14 | 0) > 0 ? i14 : 0;
   HEAP32[i3 >> 2] = (i15 | 0) > 0 ? i15 : 0;
   HEAP32[i9 >> 2] = (i16 | 0) < (i22 | 0) ? i16 : i22;
   HEAP32[i10 >> 2] = (i17 | 0) < (i22 | 0) ? i17 : i22;
   HEAP32[i11 >> 2] = (i18 | 0) < 0 ? i18 : 0;
  }
  if ((i19 | 0) > (i24 | 0)) {
   switch (i21 & 7) {
   case 0:
    {
     i1 = 1;
     break;
    }
   case 5:
    {
     i1 = 4;
     break;
    }
   case 2:
    {
     i1 = 3;
     break;
    }
   case 3:
    {
     i1 = 2;
     break;
    }
   case 4:
    {
     i1 = 5;
     break;
    }
   default:
    i1 = 0;
   }
   i12 = i25 + (i1 * 24 | 0) | 0;
   i11 = HEAP32[i12 >> 2] | 0;
   i11 = (i11 | 0) < 0 ? i11 : 0;
   i14 = i25 + (i1 * 24 | 0) + 4 | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   i13 = (i13 | 0) < 0 ? i13 : 0;
   i16 = i25 + (i1 * 24 | 0) + 8 | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   i18 = i25 + (i1 * 24 | 0) + 12 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i17 = (i17 | 0) > 0 ? i17 : 0;
   i30 = i25 + (i1 * 24 | 0) + 16 | 0;
   i19 = HEAP32[i30 >> 2] | 0;
   i19 = (i19 | 0) > 0 ? i19 : 0;
   i32 = i25 + (i1 * 24 | 0) + 20 | 0;
   i31 = HEAP32[i32 >> 2] | 0;
   HEAP32[i12 >> 2] = (i11 | 0) < (i22 | 0) ? i11 : i22;
   HEAP32[i14 >> 2] = (i13 | 0) < (i22 | 0) ? i13 : i22;
   HEAP32[i16 >> 2] = (i15 | 0) < 0 ? i15 : 0;
   HEAP32[i18 >> 2] = (i17 | 0) > (i22 | 0) ? i17 : i22;
   HEAP32[i30 >> 2] = (i19 | 0) > (i22 | 0) ? i19 : i22;
   HEAP32[i32 >> 2] = (i31 | 0) > 0 ? i31 : 0;
  }
  i1 = i20 + 1 | 0;
  if ((i1 | 0) == 4) break;
  i20 = i1;
  i19 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
 }
 STACKTOP = i29;
 return;
}

function __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i1 = 0;
 do {
  f17 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) >> 2]);
  f15 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) >> 2]);
  f12 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 4 >> 2]);
  f13 = Math_fround(f21 - f13);
  f12 = Math_fround(f15 - f12);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 8 >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 68 + (i1 << 6) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 68 + (i1 << 6) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 68 + (i1 << 6) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f15 * Math_fround(-2.0));
  f18 = Math_fround(f15 * Math_fround(2.0));
  f22 = Math_fround(f17 * f10);
  f16 = Math_fround(f19 * Math_fround(2.0));
  f20 = Math_fround(f19 * Math_fround(-2.0));
  f24 = Math_fround(f17 * f20);
  f14 = Math_fround(f21 * Math_fround(-2.0));
  f23 = Math_fround(f21 * Math_fround(2.0));
  f5 = Math_fround(f17 * f14);
  f11 = Math_fround(Math_fround(f13 + Math_fround(Math_fround(Math_fround(f15 * f10) - Math_fround(f19 * f16)) * f13)) + Math_fround(Math_fround(Math_fround(f24 - Math_fround(f15 * f14)) * f12) + Math_fround(Math_fround(Math_fround(f23 * f19) - f22) * f9)));
  f10 = Math_fround(Math_fround(f12 + Math_fround(Math_fround(Math_fround(f21 * f18) - f24) * f13)) + Math_fround(Math_fround(Math_fround(Math_fround(f19 * f20) - Math_fround(f21 * f23)) * f12) + Math_fround(Math_fround(f5 - Math_fround(f19 * f10)) * f9)));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f22 - Math_fround(f21 * f20)) * f13) + f9) + Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) - f5) * f12) + Math_fround(Math_fround(Math_fround(f21 * f14) - Math_fround(f15 * f18)) * f9)));
  f18 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 12 >> 2]);
  f14 = Math_fround(f15 * f18);
  f12 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 24 >> 2]);
  f5 = Math_fround(f17 * f12);
  f16 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 16 >> 2]);
  f13 = Math_fround(f19 * f16);
  f20 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 20 >> 2]);
  f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f17 * f20)) - Math_fround(f19 * f12)) - Math_fround(f21 * f16));
  f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f21 * f18)) - Math_fround(f19 * f20)) - Math_fround(f15 * f16));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f15 * f20)) - Math_fround(f17 * f18)) - Math_fround(f21 * f12));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f16)) - Math_fround(f15 * f12));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAPF32[i2 + 68 + (i1 << 6) >> 2] = f11;
  HEAPF32[i2 + 68 + (i1 << 6) + 4 >> 2] = f10;
  HEAPF32[i2 + 68 + (i1 << 6) + 8 >> 2] = f9;
  HEAP32[i2 + 68 + (i1 << 6) + 12 >> 2] = i8 ^ -2147483648;
  HEAP32[i2 + 68 + (i1 << 6) + 16 >> 2] = i7;
  HEAP32[i2 + 68 + (i1 << 6) + 20 >> 2] = i6 ^ -2147483648;
  HEAPF32[i2 + 68 + (i1 << 6) + 24 >> 2] = f5;
  HEAP32[i2 + 68 + (i1 << 6) + 28 >> 2] = 1065353216;
  HEAP32[i2 + 68 + (i1 << 6) + 32 >> 2] = 1065353216;
  HEAP32[i2 + 68 + (i1 << 6) + 36 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  f24 = Math_fround(HEAPF32[i3 + 596 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 596 + (i1 << 2) >> 2] = Math_fround(f24 - Math_fround(HEAPF32[i4 + 596 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 52);
 i1 = 0;
 do {
  f24 = Math_fround(HEAPF32[i3 + 364 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 364 + (i1 << 2) >> 2] = Math_fround(f24 - Math_fround(HEAPF32[i4 + 364 + (i1 << 2) >> 2]));
  f24 = Math_fround(HEAPF32[i3 + 500 + (i1 << 2) >> 2]);
  HEAPF32[i2 + 500 + (i1 << 2) >> 2] = Math_fround(f24 - Math_fround(HEAPF32[i4 + 500 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 f15 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f19 = Math_fround(f11 - f19);
 f23 = Math_fround(f17 - f23);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i4 + 8 >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f17 * Math_fround(-2.0));
 f14 = Math_fround(f17 * Math_fround(2.0));
 f10 = Math_fround(f15 * f24);
 f16 = Math_fround(f13 * Math_fround(2.0));
 f12 = Math_fround(f13 * Math_fround(-2.0));
 f5 = Math_fround(f15 * f12);
 f18 = Math_fround(f11 * Math_fround(-2.0));
 f9 = Math_fround(f11 * Math_fround(2.0));
 f21 = Math_fround(f15 * f18);
 f22 = Math_fround(Math_fround(f19 + Math_fround(Math_fround(Math_fround(f17 * f24) - Math_fround(f13 * f16)) * f19)) + Math_fround(Math_fround(Math_fround(f5 - Math_fround(f17 * f18)) * f23) + Math_fround(Math_fround(Math_fround(f9 * f13) - f10) * f20)));
 f24 = Math_fround(Math_fround(f23 + Math_fround(Math_fround(Math_fround(f11 * f14) - f5) * f19)) + Math_fround(Math_fround(Math_fround(Math_fround(f13 * f12) - Math_fround(f11 * f9)) * f23) + Math_fround(Math_fround(f21 - Math_fround(f13 * f24)) * f20)));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f10 - Math_fround(f11 * f12)) * f19) + f20) + Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - f21) * f23) + Math_fround(Math_fround(Math_fround(f11 * f18) - Math_fround(f17 * f14)) * f20)));
 f14 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f18 = Math_fround(f17 * f14);
 f23 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f21 = Math_fround(f15 * f23);
 f16 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f19 = Math_fround(f13 * f16);
 f12 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f15 * f12)) - Math_fround(f13 * f23)) - Math_fround(f11 * f16));
 f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f11 * f14)) - Math_fround(f13 * f12)) - Math_fround(f17 * f16));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f17 * f12)) - Math_fround(f15 * f14)) - Math_fround(f11 * f23));
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)) - Math_fround(f15 * f16)) - Math_fround(f17 * f23));
 i8 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i2 >> 2] = f22;
 HEAPF32[i2 + 4 >> 2] = f24;
 HEAPF32[i2 + 8 >> 2] = f20;
 HEAP32[i2 + 12 >> 2] = i6 ^ -2147483648;
 HEAP32[i2 + 16 >> 2] = i7;
 HEAP32[i2 + 20 >> 2] = i8 ^ -2147483648;
 HEAPF32[i2 + 24 >> 2] = f21;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i2 + 32 >> 2] = 1065353216;
 HEAP32[i2 + 36 >> 2] = 1065353216;
 f21 = Math_fround(HEAPF32[i3 + 804 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 808 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 812 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 804 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 808 >> 2]);
 f23 = Math_fround(f20 - f23);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i4 + 812 >> 2]));
 HEAPF32[i2 + 804 >> 2] = Math_fround(f21 - f22);
 HEAPF32[i2 + 808 >> 2] = f23;
 HEAPF32[i2 + 812 >> 2] = f24;
 f24 = Math_fround(HEAPF32[i3 + 816 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 820 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 824 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 816 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 820 >> 2]);
 f20 = Math_fround(f23 - f20);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i4 + 824 >> 2]));
 HEAPF32[i2 + 816 >> 2] = Math_fround(f24 - f21);
 HEAPF32[i2 + 820 >> 2] = f20;
 HEAPF32[i2 + 824 >> 2] = f22;
 f22 = Math_fround(HEAPF32[i3 + 828 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 832 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 836 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 828 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 832 >> 2]);
 f23 = Math_fround(f20 - f23);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i4 + 836 >> 2]));
 HEAPF32[i2 + 828 >> 2] = Math_fround(f22 - f24);
 HEAPF32[i2 + 832 >> 2] = f23;
 HEAPF32[i2 + 836 >> 2] = f21;
 f21 = Math_fround(HEAPF32[i3 + 840 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 844 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 848 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 840 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 844 >> 2]);
 f20 = Math_fround(f23 - f20);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i4 + 848 >> 2]));
 HEAPF32[i2 + 840 >> 2] = Math_fround(f21 - f22);
 HEAPF32[i2 + 844 >> 2] = f20;
 HEAPF32[i2 + 848 >> 2] = f24;
 f24 = Math_fround(HEAPF32[i3 + 852 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 856 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 860 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 852 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 856 >> 2]);
 f23 = Math_fround(f20 - f23);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i4 + 860 >> 2]));
 HEAPF32[i2 + 852 >> 2] = Math_fround(f24 - f21);
 HEAPF32[i2 + 856 >> 2] = f23;
 HEAPF32[i2 + 860 >> 2] = f22;
 f22 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 872 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 864 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 868 >> 2]);
 f20 = Math_fround(f23 - f20);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i4 + 872 >> 2]));
 HEAPF32[i2 + 864 >> 2] = Math_fround(f22 - f24);
 HEAPF32[i2 + 868 >> 2] = f20;
 HEAPF32[i2 + 872 >> 2] = f21;
 f21 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 880 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 884 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 876 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 880 >> 2]);
 f23 = Math_fround(f20 - f23);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i4 + 884 >> 2]));
 HEAPF32[i2 + 876 >> 2] = Math_fround(f21 - f22);
 HEAPF32[i2 + 880 >> 2] = f23;
 HEAPF32[i2 + 884 >> 2] = f24;
 return;
}

function __ZN5physx17PxcSweepSphereBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i4 + 512 | 0;
 i16 = i4 + 496 | 0;
 i19 = i4 + 464 | 0;
 i20 = i4 + 400 | 0;
 i22 = i4 + 256 | 0;
 i40 = i4 + 528 | 0;
 i21 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i39 = HEAP32[i8 >> 2] | 0;
 i34 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i36 = HEAP32[i34 + 40 >> 2] | 0;
 i35 = HEAP32[i34 + 44 >> 2] | 0;
 i34 = HEAP32[i34 + 48 >> 2] | 0;
 f55 = Math_fround(HEAPF32[i11 >> 2]);
 f56 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f49 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f54 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i58 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i58 >> 2]);
 f25 = Math_fround(HEAPF32[i58 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i58 + 8 >> 2]);
 i58 = HEAP32[i12 >> 2] | 0;
 i57 = HEAP32[i12 + 4 >> 2] | 0;
 i43 = HEAP32[i12 + 8 >> 2] | 0;
 i41 = HEAP32[i12 + 12 >> 2] | 0;
 i9 = i6 + 16 | 0;
 i42 = HEAP32[i9 >> 2] | 0;
 i37 = HEAP32[i9 + 4 >> 2] | 0;
 i9 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i58;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = i57;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = i43;
 i8 = i19 + 12 | 0;
 HEAP32[i8 >> 2] = i41;
 HEAP32[i19 + 16 >> 2] = i42;
 HEAP32[i19 + 20 >> 2] = i37;
 HEAP32[i19 + 24 >> 2] = i9;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f52 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f47 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f52 = Math_fround(-f52);
 f47 = Math_fround(-f47);
 f44 = Math_fround(-f44);
 f29 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f48 = Math_fround(f25 - f24);
 f50 = Math_fround(f27 - f32);
 f51 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f53 = Math_fround(Math_fround(Math_fround(f28 * f52) + Math_fround(f48 * f47)) + Math_fround(f50 * f44));
 f33 = Math_fround(Math_fround(Math_fround(f53 * f47) + Math_fround(Math_fround(f51 * f48) + Math_fround(f23 * Math_fround(Math_fround(f28 * f44) - Math_fround(f50 * f52))))) * Math_fround(2.0));
 f31 = Math_fround(Math_fround(Math_fround(Math_fround(f51 * f50) + Math_fround(f23 * Math_fround(Math_fround(f48 * f52) - Math_fround(f28 * f47)))) + Math_fround(f53 * f44)) * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f54 * f23) - Math_fround(Math_fround(Math_fround(f55 * f52) + Math_fround(f56 * f47)) + Math_fround(f49 * f44)));
 f46 = Math_fround(Math_fround(Math_fround(f49 * f47) - Math_fround(f56 * f44)) + Math_fround(Math_fround(f54 * f52) + Math_fround(f55 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f55 * f44) - Math_fround(f49 * f52)) + Math_fround(Math_fround(f54 * f47) + Math_fround(f56 * f23)));
 f49 = Math_fround(Math_fround(Math_fround(f56 * f52) - Math_fround(f55 * f47)) + Math_fround(Math_fround(f54 * f44) + Math_fround(f49 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(Math_fround(f51 * f28) + Math_fround(f23 * Math_fround(Math_fround(f50 * f47) - Math_fround(f48 * f44))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f33;
 HEAPF32[i20 + 56 >> 2] = f31;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f31 = Math_fround(f46 + f46);
 f33 = Math_fround(f26 + f26);
 f44 = Math_fround(f49 + f49);
 f48 = Math_fround(f26 * f33);
 f47 = Math_fround(f49 * f44);
 f26 = Math_fround(f26 * f31);
 f50 = Math_fround(f49 * f31);
 f23 = Math_fround(f45 * f31);
 f49 = Math_fround(f49 * f33);
 f33 = Math_fround(f45 * f33);
 f44 = Math_fround(f45 * f44);
 f31 = Math_fround(Math_fround(1.0) - Math_fround(f46 * f31));
 f46 = Math_fround(f26 + f44);
 f45 = Math_fround(f50 - f33);
 f44 = Math_fround(f26 - f44);
 f26 = Math_fround(f31 - f47);
 f28 = Math_fround(f49 + f23);
 f33 = Math_fround(f50 + f33);
 f23 = Math_fround(f49 - f23);
 f31 = Math_fround(f31 - f48);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f48) - f47);
 HEAPF32[i20 + 4 >> 2] = f46;
 HEAPF32[i20 + 8 >> 2] = f45;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f44;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f33;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f31;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 i9 = i39 + 40 | 0;
 i39 = HEAP32[i9 >> 2] | 0;
 i37 = i22 + 64 | 0;
 HEAP32[i22 + 80 >> 2] = 4;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 i42 = i22 + 96 | 0;
 i41 = i22 + 112 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 128 >> 2] = i39;
 i43 = i22 + 132 | 0;
 HEAP32[i43 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i42 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i42 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i42 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i42 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i41 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i41 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i41 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i41 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = i39;
 i41 = i22 + 20 | 0;
 HEAP32[i41 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i41 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i41 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i22 + 32 >> 2] = i39;
 i39 = i22 + 36 | 0;
 HEAP32[i39 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i39 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i38 >> 2] = -1;
 HEAP32[i38 + 4 >> 2] = -1;
 HEAP32[i38 + 8 >> 2] = -1;
 HEAP32[i38 + 12 >> 2] = -1;
 HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 i37 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 3;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = 0;
 HEAP32[i37 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
 HEAP32[i21 + 144 >> 2] = i36;
 HEAP32[i21 + 148 >> 2] = i35;
 HEAP32[i21 + 152 >> 2] = i34;
 HEAPF32[i21 + 156 >> 2] = Math_fround(0.0);
 f31 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = f31 <= f23 ? f31 : f23;
 f33 = f23 <= f33 ? f23 : f33;
 HEAPF32[i21 + 16 >> 2] = Math_fround(f33 * Math_fround(.150000006));
 HEAPF32[i21 + 32 >> 2] = Math_fround(f33 * Math_fround(.0500000007));
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(HEAPF32[i8 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f7)) | 0)) {
  f56 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f56);
 }
 f56 = Math_fround(HEAPF32[i2 >> 2]);
 i58 = HEAP32[i3 + 4 >> 2] | 0;
 i57 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i58;
 HEAP32[i13 + 8 >> 2] = i57;
 i57 = HEAP32[i1 + 4 >> 2] | 0;
 i58 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i57;
 HEAP32[i14 + 8 >> 2] = i58;
 STACKTOP = i4;
 return Math_fround(f56);
}

function __ZN5physx3Cct10Controller17findTouchedObjectERKNS_19PxControllerFiltersEPKNS_17PxObstacleContextERKNS_6PxVec3E(i24, i2, i21, i25) {
 i24 = i24 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i25 = i25 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i26 + 208 | 0;
 i13 = i26 + 176 | 0;
 i18 = i26 + 160 | 0;
 i16 = i26 + 56 | 0;
 i3 = i26 + 40 | 0;
 i22 = i26 + 28 | 0;
 i17 = i26 + 76 | 0;
 i14 = i26 + 16 | 0;
 i15 = i26 + 272 | 0;
 i23 = i26 + 12 | 0;
 i20 = i26;
 i4 = HEAP16[i2 + 8 >> 1] | 0;
 if (!(i4 & 2)) {
  STACKTOP = i26;
  return;
 }
 HEAP32[i18 >> 2] = gb + 85916 + 8;
 HEAP32[i18 + 4 >> 2] = (HEAP32[i24 + 464 >> 2] | 0) + 76;
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP16[i18 + 12 >> 1] = i4;
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP16[i16 + 16 >> 1] = i4 & 8 | 6;
 HEAP8[i16 + 18 >> 0] = 0;
 f9 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0));
 f1 = Math_fround(+HEAPF64[i24 + 408 >> 3]);
 f29 = Math_fround(+HEAPF64[i24 + 416 >> 3]);
 f30 = Math_fround(+HEAPF64[i24 + 424 >> 3]);
 HEAPF32[i22 >> 2] = f1;
 HEAPF32[i22 + 4 >> 2] = f29;
 HEAPF32[i22 + 8 >> 2] = f30;
 HEAP32[i17 + 4 >> 2] = 0;
 i2 = i17 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = -1;
 i3 = i17 + 16 | 0;
 HEAP16[i3 >> 1] = 0;
 i4 = i17 + 20 | 0;
 i10 = i17 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i4 = i17 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i17 + 68 >> 0] = 0;
 i5 = i17 + 72 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i17 + 76 >> 2] = 0;
 i6 = i17 + 80 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i17 >> 2] = gb + 85940 + 8;
 i7 = i17 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i8 = i24 + 456 | 0;
 i27 = HEAP32[i8 >> 2] | 0;
 i28 = HEAP32[(HEAP32[i27 >> 2] | 0) + 348 >> 2] | 0;
 f30 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 i11 = i25 + 4 | 0;
 f29 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 i12 = i25 + 8 | 0;
 f1 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i14 >> 2] = f30;
 HEAPF32[i14 + 4 >> 2] = f29;
 HEAPF32[i14 + 8 >> 2] = f1;
 f1 = Math_fround(f9 + Math_fround(0.0));
 HEAP16[i15 >> 1] = 4;
 if (mftCall_iiiifiiiii(i28 | 0, i27 | 0, i22 | 0, i14 | 0, +f1, i17 | 0, i15 | 0, i16 | 0, i18 | 0, 0) | 0) {
  i28 = HEAP32[i6 >> 2] | 0 ? HEAP32[i5 >> 2] | 0 : i7;
  HEAP32[i7 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP16[i3 >> 1] = HEAP16[i28 + 12 >> 1] | 0;
  HEAP32[i17 + 20 >> 2] = HEAP32[i28 + 16 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i28 + 20 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i28 + 24 >> 2];
  HEAP32[i17 + 32 >> 2] = HEAP32[i28 + 28 >> 2];
  HEAP32[i17 + 36 >> 2] = HEAP32[i28 + 32 >> 2];
  HEAP32[i17 + 40 >> 2] = HEAP32[i28 + 36 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i28 + 40 >> 2];
  i28 = i28 + 44 | 0;
  HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
  i28 = HEAP32[i2 >> 2] | 0;
  HEAP32[i24 + 244 >> 2] = i28;
  i27 = HEAP32[i7 >> 2] | 0;
  HEAP32[i24 + 248 >> 2] = i27;
  mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 84 >> 2] | 0, i19 | 0, i27 | 0);
  mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 72 >> 2] | 0, i13 | 0, i28 | 0);
  f30 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) * Math_fround(2.0));
  f39 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) * Math_fround(2.0));
  f35 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) * Math_fround(2.0));
  f42 = Math_fround(HEAPF32[i19 + 12 >> 2]);
  f41 = Math_fround(Math_fround(f42 * f42) + Math_fround(-.5));
  f40 = Math_fround(HEAPF32[i19 >> 2]);
  f34 = Math_fround(f30 * f40);
  f38 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f39 * f38));
  f36 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f35 * f36));
  f37 = Math_fround(Math_fround(f40 * f34) + Math_fround(Math_fround(f30 * f41) + Math_fround(f42 * Math_fround(Math_fround(f35 * f38) - Math_fround(f39 * f36)))));
  f32 = Math_fround(Math_fround(f38 * f34) + Math_fround(Math_fround(f39 * f41) + Math_fround(f42 * Math_fround(Math_fround(f30 * f36) - Math_fround(f35 * f40)))));
  f34 = Math_fround(Math_fround(Math_fround(f35 * f41) + Math_fround(f42 * Math_fround(Math_fround(f39 * f40) - Math_fround(f30 * f38)))) + Math_fround(f36 * f34));
  f37 = Math_fround(Math_fround(HEAPF32[i19 + 16 >> 2]) + f37);
  f32 = Math_fround(Math_fround(HEAPF32[i19 + 20 >> 2]) + f32);
  f34 = Math_fround(Math_fround(HEAPF32[i19 + 24 >> 2]) + f34);
  f30 = Math_fround(HEAPF32[i13 >> 2]);
  f39 = Math_fround(f42 * f30);
  f41 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f39 = Math_fround(f39 + Math_fround(f40 * f41));
  f35 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f39 = Math_fround(f39 + Math_fround(f38 * f35));
  f29 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f39 = Math_fround(f39 - Math_fround(f36 * f29));
  f33 = Math_fround(Math_fround(Math_fround(f36 * f30) + Math_fround(Math_fround(f38 * f41) + Math_fround(f42 * f29))) - Math_fround(f40 * f35));
  f31 = Math_fround(Math_fround(Math_fround(f40 * f29) + Math_fround(Math_fround(f36 * f41) + Math_fround(f42 * f35))) - Math_fround(f38 * f30));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f41) - Math_fround(f40 * f30)) - Math_fround(f38 * f29)) - Math_fround(f36 * f35));
  f36 = Math_fround(f9 - Math_fround(HEAPF32[i10 >> 2]));
  f29 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f36);
  f38 = Math_fround(f36 * Math_fround(HEAPF32[i11 >> 2]));
  f38 = Math_fround(Math_fround(0.0) - f38);
  f36 = Math_fround(Math_fround(0.0) - Math_fround(f36 * Math_fround(HEAPF32[i12 >> 2])));
  HEAPF32[i24 + 276 >> 2] = Math_fround(Math_fround(0.0) - f29);
  HEAPF32[i24 + 280 >> 2] = f38;
  HEAPF32[i24 + 284 >> 2] = f36;
  f37 = Math_fround(Math_fround(Math_fround(0.0) - f37) * Math_fround(2.0));
  f32 = Math_fround(Math_fround(Math_fround(0.0) - f32) * Math_fround(2.0));
  f34 = Math_fround(Math_fround(Math_fround(0.0) - f34) * Math_fround(2.0));
  f36 = Math_fround(Math_fround(f35 * f35) + Math_fround(-.5));
  f38 = Math_fround(Math_fround(f34 * f31) + Math_fround(Math_fround(f37 * f39) + Math_fround(f32 * f33)));
  f29 = Math_fround(Math_fround(Math_fround(f32 * f36) - Math_fround(f35 * Math_fround(Math_fround(f37 * f31) - Math_fround(f34 * f39)))) + Math_fround(f33 * f38));
  f30 = Math_fround(Math_fround(Math_fround(f34 * f36) - Math_fround(f35 * Math_fround(Math_fround(f32 * f39) - Math_fround(f37 * f33)))) + Math_fround(f31 * f38));
  HEAPF32[i24 + 264 >> 2] = Math_fround(Math_fround(f39 * f38) + Math_fround(Math_fround(f37 * f36) - Math_fround(f35 * Math_fround(Math_fround(f34 * f33) - Math_fround(f32 * f31)))));
  HEAPF32[i24 + 268 >> 2] = f29;
  HEAPF32[i24 + 272 >> 2] = f30;
  i28 = HEAP32[i8 >> 2] | 0;
  HEAP32[i24 + 460 >> 2] = (mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 32 >> 2] | 0, i28 | 0) | 0) + -1;
 }
 if (i21 | 0) {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = -1;
  HEAP16[i19 + 12 >> 1] = 0;
  i2 = i19 + 16 | 0;
  i3 = i19 + 40 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i19 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 48 >> 2] = Math_fround(0.0);
  f40 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
  f41 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
  f42 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
  HEAPF32[i20 >> 2] = f40;
  HEAPF32[i20 + 4 >> 2] = f41;
  HEAPF32[i20 + 8 >> 2] = f42;
  i2 = __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKNS_6PxVec3ES6_fRj(i21, i19, i22, i20, f1, i23) | 0;
  if (i2 | 0) {
   f1 = Math_fround(HEAPF32[i3 >> 2]);
   if (f1 < Math_fround(HEAPF32[i10 >> 2])) {
    HEAP32[i24 + 240 >> 2] = HEAP32[i23 >> 2];
    f34 = Math_fround(f9 - f1);
    f38 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f34);
    f39 = Math_fround(f34 * Math_fround(HEAPF32[i11 >> 2]));
    f39 = Math_fround(Math_fround(0.0) - f39);
    f34 = Math_fround(Math_fround(0.0) - Math_fround(f34 * Math_fround(HEAPF32[i12 >> 2])));
    HEAPF32[i24 + 300 >> 2] = Math_fround(Math_fround(0.0) - f38);
    HEAPF32[i24 + 304 >> 2] = f39;
    HEAPF32[i24 + 308 >> 2] = f34;
    f34 = Math_fround(+HEAPF64[i2 + 8 >> 3]);
    f39 = Math_fround(+HEAPF64[i2 + 16 >> 3]);
    f38 = Math_fround(+HEAPF64[i2 + 24 >> 3]);
    f32 = Math_fround(HEAPF32[i2 + 32 >> 2]);
    f37 = Math_fround(HEAPF32[i2 + 36 >> 2]);
    f40 = Math_fround(HEAPF32[i2 + 40 >> 2]);
    f36 = Math_fround(HEAPF32[i2 + 44 >> 2]);
    f34 = Math_fround(Math_fround(Math_fround(0.0) - f34) * Math_fround(2.0));
    f39 = Math_fround(Math_fround(Math_fround(0.0) - f39) * Math_fround(2.0));
    f38 = Math_fround(Math_fround(Math_fround(0.0) - f38) * Math_fround(2.0));
    f35 = Math_fround(Math_fround(f36 * f36) + Math_fround(-.5));
    f33 = Math_fround(Math_fround(Math_fround(f34 * f32) + Math_fround(f39 * f37)) + Math_fround(f38 * f40));
    f41 = Math_fround(Math_fround(f37 * f33) + Math_fround(Math_fround(f39 * f35) - Math_fround(f36 * Math_fround(Math_fround(f34 * f40) - Math_fround(f32 * f38)))));
    f42 = Math_fround(Math_fround(f40 * f33) + Math_fround(Math_fround(f38 * f35) - Math_fround(f36 * Math_fround(Math_fround(f32 * f39) - Math_fround(f34 * f37)))));
    HEAPF32[i24 + 288 >> 2] = Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f34 * f35) - Math_fround(f36 * Math_fround(Math_fround(f37 * f38) - Math_fround(f39 * f40)))));
    HEAPF32[i24 + 292 >> 2] = f41;
    HEAPF32[i24 + 296 >> 2] = f42;
   }
  }
 }
 STACKTOP = i26;
 return;
}

function __ZN20TextRenderingPrivate22ScriptingTextGenerator19GetStringRenderInfoERS0_RKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEPNS_8FontImplE11ColorRGBA32iffibbiiNS0_16VerticalWrapModeENS0_18HorizontalWrapModeEbiRK8Vector2fSI_bbbPj(i36, i14, i21, i16, i10, f6, f9, i26, i27, i8, i11, i2, i5, i7, i33, i34, i4, i35, i19, i20, i22, i23) {
 i36 = i36 | 0;
 i14 = i14 | 0;
 i21 = i21 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 f6 = Math_fround(f6);
 f9 = Math_fround(f9);
 i26 = i26 | 0;
 i27 = i27 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 i35 = i35 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var f1 = f0, i3 = 0, f12 = f0, f13 = f0, i15 = 0, i17 = 0, i18 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i40 + 488 | 0;
 i24 = i40 + 480 | 0;
 i37 = i40 + 456 | 0;
 i15 = i40;
 i38 = i40 + 8 | 0;
 i25 = i40 + 452 | 0;
 i3 = (i23 | 0) != 0;
 if (i3) HEAP32[i23 >> 2] = 0;
 i39 = i36 + 60 | 0;
 HEAP8[i39 >> 0] = 0;
 if (!i21) {
  if (!i3) {
   STACKTOP = i40;
   return;
  }
  HEAP32[i23 >> 2] = 4;
  STACKTOP = i40;
  return;
 }
 i3 = (i11 | 0) > (i2 | 0) ? i11 : i2;
 L11 : do switch (i34 | 0) {
 case 1:
 case 4:
 case 7:
  {
   i18 = 1;
   break;
  }
 default:
  {
   switch (i34 | 0) {
   case 2:
   case 5:
   case 8:
    break;
   default:
    {
     i18 = 0;
     break L11;
    }
   }
   i18 = 2;
  }
 } while (0);
 f12 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f6);
 f31 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f6);
 f13 = Math_fround(Math_fround(HEAPF32[gb + 62472 >> 2]) * Math_fround(.0000999999974));
 f13 = Math_fround(f12 + f13);
 f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[gb + 62472 + 4 >> 2]) * Math_fround(.0000999999974)));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i24 >> 2] = f13;
 i29 = (i5 | 0) == 1;
 HEAPF32[i24 + 4 >> 2] = i29 ? Math_fround(3402823469999999843913219.0e14) : f31;
 i30 = (i7 | 0) == 1;
 if (i30) HEAPF32[i24 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i17 = i8 & (i29 & i30 ^ 1);
 if (!i10) if ((HEAP32[i21 + 32 >> 2] | 0) == -2) i2 = HEAP32[(HEAP32[i21 + 76 >> 2] | 0) + 36 >> 2] | 0; else i2 = 0; else i2 = i10;
 f12 = Math_fround(Math_fround(i2 | 0) * f6);
 i2 = f12 >= Math_fround(0.0);
 f13 = Math_fround(f12 + Math_fround(-.99999994));
 i2 = ~~(i2 ? f12 : f13);
 i2 = (i2 | 0) > 500 ? 500 : i2;
 f13 = Math_fround(Math_fround(i11 | 0) * f6);
 i5 = f13 >= Math_fround(0.0);
 f12 = Math_fround(f13 + Math_fround(-.99999994));
 i5 = ~~(i5 ? f13 : f12);
 i5 = (i5 | 0) > 500 ? 500 : i5;
 f12 = Math_fround(Math_fround(i3 | 0) * f6);
 i3 = f12 >= Math_fround(0.0);
 f13 = Math_fround(f12 + Math_fround(-.99999994));
 i3 = ~~(i3 ? f12 : f13);
 i3 = (i3 | 0) > 500 ? 500 : i3;
 if (i17) if ((i2 | 0) < (i5 | 0)) i7 = i5; else i7 = (i2 | 0) > (i3 | 0) ? i3 : i2; else i7 = i2;
 i11 = i14 + 11 | 0;
 i10 = (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
 i2 = gb + 63672 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i15;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 HEAP32[i28 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i37, i10, i28);
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i16 >> 2] | 0;
 f1 = Math_fround(i7 | 0);
 L26 : do if (!i7) {
  i2 = 0;
  while (1) {
   i4 = HEAP8[i11 >> 0] | 0;
   __ZN20TextRenderingPrivate22ScriptingTextGenerator9InitVertsEi(i36, i4 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i4 & 255);
   HEAP32[i25 >> 2] = i8;
   HEAP32[i28 >> 2] = HEAP32[i25 >> 2];
   __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE(i38, i37, i21, i28, 0, f6, i24, i27, i26, f9, i18, 4, 1, Math_fround(1.0), Math_fround(1.0), i19, i20, i22, i36);
   __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv(i38) | 0;
   i4 = __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj(i38, i23) | 0;
   if (!(i17 & (i5 | 0) < (i3 | 0))) break L26;
   i16 = i4 ? i3 : i2 + -1 | 0;
   i15 = i4 ? i2 : i5;
   __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev(i38);
   i5 = i15;
   i2 = (i16 + 1 + i15 | 0) / 2 | 0;
   i3 = i16;
  }
 } else {
  i2 = i7;
  while (1) {
   i4 = HEAP8[i11 >> 0] | 0;
   __ZN20TextRenderingPrivate22ScriptingTextGenerator9InitVertsEi(i36, i4 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i4 & 255);
   f13 = Math_fround(Math_fround(i2 | 0) / f1);
   HEAP32[i25 >> 2] = i8;
   HEAP32[i28 >> 2] = HEAP32[i25 >> 2];
   __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE(i38, i37, i21, i28, i7, f6, i24, i27, i26, f9, i18, 4, 1, Math_fround(1.0), f13, i19, i20, i22, i36);
   __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv(i38) | 0;
   i4 = __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj(i38, i23) | 0;
   if (!(i17 & (i5 | 0) < (i3 | 0))) break L26;
   i16 = i4 ? i3 : i2 + -1 | 0;
   i15 = i4 ? i2 : i5;
   __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev(i38);
   i5 = i15;
   i2 = (i16 + 1 + i15 | 0) / 2 | 0;
   i3 = i16;
  }
 } while (0);
 HEAP32[i36 + 76 >> 2] = i2;
 f6 = Math_fround(HEAPF32[i38 + 288 >> 2]);
 i2 = (HEAP8[i38 + 229 >> 0] | 0) == 0;
 f1 = Math_fround(HEAPF32[i38 + 292 >> 2]);
 if (i2) f13 = f6; else {
  f13 = Math_fround(HEAPF32[i38 + 248 >> 2]);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f13 * f1) + Math_fround(.5)))) / f13);
  f13 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f6 * f13) + Math_fround(.5)))) / f13);
 }
 f12 = Math_fround(f1 - f13);
 switch (HEAP32[i38 + 216 >> 2] | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i38 + 316 >> 2]);
   if (!i2) {
    f9 = Math_fround(HEAPF32[i38 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f9) + Math_fround(.5)))) / f9);
   }
   i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i38 + 316 >> 2]);
   if (!i2) {
    f9 = Math_fround(HEAPF32[i38 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f9) + Math_fround(.5)))) / f9);
   }
   f9 = Math_fround(-f1);
   i2 = f1 > Math_fround(-0.0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = i2 ? f1 : f9, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i38 + 316 >> 2]);
   if (!i2) {
    f9 = Math_fround(HEAPF32[i38 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f9) + Math_fround(.5)))) / f9);
   }
   i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  i2 = 0;
 }
 i33 = i33 ^ 1;
 f9 = i29 ^ 1 | i33 ? f31 : f12;
 f1 = Math_fround(f9);
 i33 = i30 ^ 1 | i33 ? i32 : i2;
 i32 = i36 + 64 | 0;
 HEAP32[i32 >> 2] = i33;
 HEAPF32[i32 + 4 >> 2] = f1;
 f1 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 switch (i34 | 0) {
 case 2:
 case 5:
 case 8:
  {
   f6 = f1;
   break;
  }
 case 7:
 case 4:
 case 1:
  {
   f6 = Math_fround(f1 * Math_fround(.5));
   break;
  }
 default:
  f6 = Math_fround(0.0);
 }
 f6 = Math_fround(f6 - Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f1));
 switch (i34 | 0) {
 case 2:
 case 1:
 case 0:
  {
   f1 = Math_fround(-f13);
   break;
  }
 case 5:
 case 4:
 case 3:
  {
   f1 = Math_fround(Math_fround(Math_fround(f9 - f12) * Math_fround(.5)) - f13);
   break;
  }
 case 8:
 case 7:
 case 6:
  {
   f1 = Math_fround(f9 - Math_fround(f13 + f12));
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 f6 = Math_fround(Math_floor(Math_fround(f6 + Math_fround(.5))));
 f1 = Math_fround(Math_floor(Math_fround(Math_fround(f1 - Math_fround(Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i35 + 4 >> 2])) * f9)) + Math_fround(.5))));
 i11 = i36 + 12 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i4 = HEAP32[i36 >> 2] | 0;
  i2 = 0;
  do {
   i35 = i4 + (i2 * 60 | 0) | 0;
   HEAPF32[i35 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i35 >> 2]));
   i35 = i4 + (i2 * 60 | 0) + 4 | 0;
   f31 = Math_fround(f1 + Math_fround(HEAPF32[i35 >> 2]));
   i34 = i4 + (i2 * 60 | 0) + 8 | 0;
   HEAPF32[i34 >> 2] = Math_fround(Math_fround(HEAPF32[i34 >> 2]) + Math_fround(0.0));
   HEAPF32[i35 >> 2] = Math_fround(-f31);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 }
 i3 = HEAP32[i38 + 368 >> 2] | 0;
 i10 = HEAP32[i38 + 428 >> 2] | 0;
 __ZN20TextRenderingPrivate22ScriptingTextGenerator19InitCharAndLineInfoEii(i36, i10, i3);
 if ((i3 | 0) > 0) {
  i4 = i36 + 20 | 0;
  i5 = i38 + 356 | 0;
  i7 = i38 + 376 | 0;
  i2 = 0;
  i8 = HEAP32[i4 >> 2] | 0;
  do {
   i33 = (HEAP32[i5 >> 2] | 0) + (i2 << 3) | 0;
   i34 = HEAP32[i33 + 4 >> 2] | 0;
   i35 = i8 + (i2 * 12 | 0) | 0;
   HEAP32[i35 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i35 + 4 >> 2] = i34;
   i8 = HEAP32[i4 >> 2] | 0;
   i35 = i8 + (i2 * 12 | 0) | 0;
   HEAPF32[i35 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i35 >> 2]));
   i35 = i8 + (i2 * 12 | 0) + 4 | 0;
   HEAPF32[i35 >> 2] = Math_fround(-Math_fround(f1 + Math_fround(HEAPF32[i35 >> 2])));
   HEAP32[i8 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 if ((i10 | 0) > 0) {
  i3 = HEAP32[i38 + 416 >> 2] | 0;
  i4 = HEAP32[i36 + 40 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i4 + (i2 * 12 | 0) >> 2] = HEAP32[i3 + (i2 * 12 | 0) >> 2];
   HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2];
   HEAPF32[i4 + (i2 * 12 | 0) + 8 >> 2] = Math_fround(-Math_fround(f1 + Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2])));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
 }
 i2 = (HEAP32[i38 + 436 >> 2] | 0) - (HEAP32[i38 + 440 >> 2] | 0) | 0;
 i3 = (i2 | 0) / 60 | 0;
 HEAP32[i36 + 72 >> 2] = i3;
 HEAP32[i11 >> 2] = i3;
 i4 = i36 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i36 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i35 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i36 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i35 | 0, HEAP32[i36 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 60 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i36 >> 2] = i35;
  break;
 } while (0);
 HEAP8[i39 >> 0] = 1;
 __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev(i38);
 __ZN11UTF16StringD2Ev(i37);
 STACKTOP = i40;
 return;
}

function __ZN7mecanim9animation14ValuesFromClipERKNS_10ValueArrayERKNS0_18ClipMuscleConstantERKNS0_10ClipOutputERKNS0_12ClipBindingsEiRS1_RNS_14ValueArrayMaskEb(i15, i1, i2, i18, i20, i16, i14, i17) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i19 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i19 = HEAP32[i2 >> 2] | 0;
 i3 = i16 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = (i4 | 0) == 0 ? 0 : i4 + i3 | 0;
 i4 = i14 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = (i6 | 0) == 0 ? 0 : i6 + i4 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 if (i6 | 0) {
  i7 = HEAP32[i18 >> 2] | 0;
  i8 = i15 + 4 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i9 = i17 & 1;
  i5 = 0;
  do {
   i1 = HEAP16[i7 + (i5 << 1) >> 1] | 0;
   i2 = i3 + (i5 * 12 | 0) | 0;
   if (i1 << 16 >> 16 == -1) {
    i13 = HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] | 0;
    i1 = HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i8 + (i5 * 12 | 0) >> 2];
    HEAP32[i3 + (i5 * 12 | 0) + 4 >> 2] = i13;
    HEAP32[i3 + (i5 * 12 | 0) + 8 >> 2] = i1;
    i1 = i9;
   } else {
    i12 = i19 + (i1 << 16 >> 16 << 2) | 0;
    i13 = HEAP32[i12 + 4 >> 2] | 0;
    i1 = HEAP32[i12 + 8 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i3 + (i5 * 12 | 0) + 4 >> 2] = i13;
    HEAP32[i3 + (i5 * 12 | 0) + 8 >> 2] = i1;
    i1 = 1;
   }
   HEAP8[i4 + i5 >> 0] = i1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 i1 = i16 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 i2 = i14 + 12 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = (i7 | 0) == 0 ? 0 : i7 + i2 | 0;
 i7 = HEAP32[i16 + 8 >> 2] | 0;
 if (i7 | 0) {
  i8 = HEAP32[i18 + 4 >> 2] | 0;
  i9 = HEAP32[i18 + 8 >> 2] | 0;
  i10 = i15 + 12 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i11 = i17 & 1;
  i12 = HEAP32[i18 + 12 >> 2] | 0;
  i3 = 0;
  do {
   i13 = HEAP16[i8 + (i3 << 1) >> 1] | 0;
   i4 = i13 << 16 >> 16;
   i5 = HEAP16[i9 + (i3 << 1) >> 1] | 0;
   i6 = i5 << 16 >> 16;
   do if ((i5 & i13) << 16 >> 16 == -1) {
    i5 = HEAP32[i10 + (i3 << 4) + 4 >> 2] | 0;
    i6 = HEAP32[i10 + (i3 << 4) + 8 >> 2] | 0;
    i13 = HEAP32[i10 + (i3 << 4) + 12 >> 2] | 0;
    HEAP32[i1 + (i3 << 4) >> 2] = HEAP32[i10 + (i3 << 4) >> 2];
    HEAP32[i1 + (i3 << 4) + 4 >> 2] = i5;
    HEAP32[i1 + (i3 << 4) + 8 >> 2] = i6;
    HEAP32[i1 + (i3 << 4) + 12 >> 2] = i13;
    HEAP8[i2 + i3 >> 0] = i11;
   } else {
    if (i13 << 16 >> 16 != -1) {
     i4 = i19 + (i4 << 2) | 0;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i6 = HEAP32[i4 + 8 >> 2] | 0;
     i13 = HEAP32[i4 + 12 >> 2] | 0;
     HEAP32[i1 + (i3 << 4) >> 2] = HEAP32[i4 >> 2];
     HEAP32[i1 + (i3 << 4) + 4 >> 2] = i5;
     HEAP32[i1 + (i3 << 4) + 8 >> 2] = i6;
     HEAP32[i1 + (i3 << 4) + 12 >> 2] = i13;
     HEAP8[i2 + i3 >> 0] = 1;
     break;
    }
    if (i5 << 16 >> 16 != -1) {
     i13 = HEAP16[i12 + (i3 << 1) >> 1] | 0;
     i6 = i19 + (i6 << 2) | 0;
     f27 = Math_fround(HEAPF32[i6 >> 2]);
     f21 = Math_fround(HEAPF32[i6 + 4 >> 2]);
     f27 = Math_fround(Math_fround(Math_fround(f27 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
     f21 = Math_fround(Math_fround(Math_fround(f21 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
     f23 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
     f30 = Math_fround(+_roundf(+f27));
     f31 = Math_fround(+_roundf(+f21));
     f30 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f30))));
     f31 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f21 - f31))));
     f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f23 - Math_fround(+_roundf(+f23))))));
     f26 = Math_fround(f30 * f30);
     f28 = Math_fround(f31 * f31);
     f32 = Math_fround(f25 * f25);
     f22 = Math_fround(f26 * f26);
     f24 = Math_fround(f28 * f28);
     f29 = Math_fround(f32 * f32);
     f26 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f22 * f22) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f26 * Math_fround(41.3416595))) + Math_fround(f22 * Math_fround(Math_fround(81.6018218) - Math_fround(f26 * Math_fround(76.5686187)))))));
     f28 = Math_fround(f31 * Math_fround(Math_fround(Math_fround(f24 * f24) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f28 * Math_fround(41.3416595))) + Math_fround(f24 * Math_fround(Math_fround(81.6018218) - Math_fround(f28 * Math_fround(76.5686187)))))));
     f32 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f29 * f29) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f32 * Math_fround(41.3416595))) + Math_fround(f29 * Math_fround(Math_fround(81.6018218) - Math_fround(f32 * Math_fround(76.5686187)))))));
     f27 = Math_fround(f27 + Math_fround(-.25));
     f21 = Math_fround(f21 + Math_fround(-.25));
     f23 = Math_fround(f23 + Math_fround(-.25));
     f29 = Math_fround(+_roundf(+f27));
     f25 = Math_fround(+_roundf(+f21));
     f29 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f27 - f29))));
     f25 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f21 - f25))));
     f23 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f23 - Math_fround(+_roundf(+f23))))));
     f21 = Math_fround(f29 * f29);
     f27 = Math_fround(f25 * f25);
     f24 = Math_fround(f23 * f23);
     f31 = Math_fround(f21 * f21);
     f22 = Math_fround(f27 * f27);
     f30 = Math_fround(f24 * f24);
     f21 = Math_fround(f29 * Math_fround(Math_fround(Math_fround(f31 * f31) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f21 * Math_fround(41.3416595))) + Math_fround(f31 * Math_fround(Math_fround(81.6018218) - Math_fround(f21 * Math_fround(76.5686187)))))));
     f27 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f22 * f22) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f27 * Math_fround(41.3416595))) + Math_fround(f22 * Math_fround(Math_fround(81.6018218) - Math_fround(f27 * Math_fround(76.5686187)))))));
     f24 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f30 * f30) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f24 * Math_fround(41.3416595))) + Math_fround(f30 * Math_fround(Math_fround(81.6018218) - Math_fround(f24 * Math_fround(76.5686187)))))));
     f30 = Math_fround(f32 * f21);
     f21 = Math_fround(f21 * f24);
     f24 = Math_fround(f26 * f24);
     f32 = Math_fround(f26 * f32);
     f26 = Math_fround(f28 * f30);
     f23 = Math_fround(f28 * f21);
     f22 = Math_fround(f28 * f24);
     f28 = Math_fround(f28 * f32);
     i13 = i13 << 1;
     f26 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) >> 2]) * f26);
     f23 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 4 >> 2]) * f23);
     f22 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 8 >> 2]) * f22);
     f28 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 12 >> 2]) * f28);
     i13 = i13 | 1;
     f25 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) >> 2]) * f27);
     f31 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 4 >> 2]) * f27);
     f29 = Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 8 >> 2]) * f27);
     f23 = Math_fround(Math_fround(f32 * f31) + f23);
     f22 = Math_fround(Math_fround(f30 * f29) + f22);
     f21 = Math_fround(f28 + Math_fround(Math_fround(Math_fround(HEAPF32[gb + 1466580 + (i13 << 4) + 12 >> 2]) * f27) * f21));
     HEAPF32[i1 + (i3 << 4) >> 2] = Math_fround(f26 + Math_fround(f25 * f24));
     HEAPF32[i1 + (i3 << 4) + 4 >> 2] = f23;
     HEAPF32[i1 + (i3 << 4) + 8 >> 2] = f22;
     HEAPF32[i1 + (i3 << 4) + 12 >> 2] = f21;
     HEAP8[i2 + i3 >> 0] = 1;
    }
   } while (0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i4 = i16 + 20 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = (i3 | 0) == 0 ? 0 : i3 + i4 | 0;
 i3 = i14 + 20 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i3 = (i6 | 0) == 0 ? 0 : i6 + i3 | 0;
 i6 = HEAP32[i16 + 16 >> 2] | 0;
 if (i6 | 0) {
  i7 = HEAP32[i18 + 16 >> 2] | 0;
  i8 = i15 + 20 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i9 = i17 & 1;
  i5 = 0;
  do {
   i1 = HEAP16[i7 + (i5 << 1) >> 1] | 0;
   i2 = i4 + (i5 * 12 | 0) | 0;
   if (i1 << 16 >> 16 == -1) {
    i13 = HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] | 0;
    i1 = HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i8 + (i5 * 12 | 0) >> 2];
    HEAP32[i4 + (i5 * 12 | 0) + 4 >> 2] = i13;
    HEAP32[i4 + (i5 * 12 | 0) + 8 >> 2] = i1;
    i1 = i9;
   } else {
    i12 = i19 + (i1 << 16 >> 16 << 2) | 0;
    i13 = HEAP32[i12 + 4 >> 2] | 0;
    i1 = HEAP32[i12 + 8 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i4 + (i5 * 12 | 0) + 4 >> 2] = i13;
    HEAP32[i4 + (i5 * 12 | 0) + 8 >> 2] = i1;
    i1 = 1;
   }
   HEAP8[i3 + i5 >> 0] = i1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 i3 = i16 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i14 + 28 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = (i5 | 0) == 0 ? 0 : i5 + i2 | 0;
 i5 = HEAP32[i16 + 24 >> 2] | 0;
 if (i5 | 0) {
  i6 = HEAP32[i18 + 20 >> 2] | 0;
  i7 = i15 + 28 | 0;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i8 = i17 & 1;
  i4 = 0;
  do {
   i1 = HEAP16[i6 + (i4 << 1) >> 1] | 0;
   if (i1 << 16 >> 16 == -1) {
    HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i7 + (i4 << 2) >> 2];
    i1 = i8;
   } else {
    HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i19 + (i1 << 16 >> 16 << 2) >> 2];
    i1 = 1;
   }
   HEAP8[i2 + i4 >> 0] = i1;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i9 = i14 + 36 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = (i10 | 0) == 0 ? 0 : i10 + i9 | 0;
 i10 = HEAP32[i16 + 32 >> 2] | 0;
 if (!i10) return;
 i11 = HEAP32[i18 + 24 >> 2] | 0;
 i7 = i15 + 36 | 0;
 i8 = i7;
 i5 = i16 + 36 | 0;
 i6 = i5;
 i4 = i17 & 1;
 i3 = HEAP32[i18 + 28 >> 2] | 0;
 i2 = 0;
 do {
  i1 = HEAP16[i11 + (i2 << 1) >> 1] | 0;
  if (i1 << 16 >> 16 == -1) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + i8 + (i2 << 2) >> 2];
   i1 = i4;
  } else {
   i1 = HEAP32[i3 + (Math_imul(~~Math_fround(HEAPF32[i19 + (i1 << 16 >> 16 << 2) >> 2]) >>> 0, i20) | 0) >> 2] | 0;
   HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i2 << 2) >> 2] = i1;
   i1 = 1;
  }
  HEAP8[i9 + i2 >> 0] = i1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZN5physx31PxClothGeodesicTetherCookerImpl25computeVertexIntersectionEjjRN12_GLOBAL__N_116PathIntersectionE(i2, i41, i40, i47) {
 i2 = i2 | 0;
 i41 = i41 | 0;
 i40 = i40 | 0;
 i47 = i47 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f48 = f0, f49 = f0;
 if ((i40 | 0) == (i41 | 0)) {
  HEAP32[i47 >> 2] = 1;
  HEAP32[i47 + 4 >> 2] = i40;
  HEAPF32[i47 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
  i47 = 0;
  return i47 | 0;
 }
 i42 = HEAP32[i2 + 8 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i42 + (i41 * 12 | 0) >> 2]);
 f46 = Math_fround(HEAPF32[i42 + (i40 * 12 | 0) >> 2]);
 f7 = Math_fround(f7 - f46);
 f6 = Math_fround(HEAPF32[i42 + (i41 * 12 | 0) + 4 >> 2]);
 f44 = Math_fround(HEAPF32[i42 + (i40 * 12 | 0) + 4 >> 2]);
 f6 = Math_fround(f6 - f44);
 f4 = Math_fround(HEAPF32[i42 + (i41 * 12 | 0) + 8 >> 2]);
 f45 = Math_fround(HEAPF32[i42 + (i40 * 12 | 0) + 8 >> 2]);
 f4 = Math_fround(f4 - f45);
 f5 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f4 * f4));
 if (f5 > Math_fround(0.0)) {
  f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
  f39 = Math_fround(f4 * f35);
  f38 = Math_fround(f6 * f35);
  f35 = Math_fround(f7 * f35);
 } else {
  f39 = Math_fround(0.0);
  f38 = Math_fround(0.0);
  f35 = Math_fround(0.0);
 }
 i36 = HEAP32[i2 + 44 >> 2] | 0;
 i1 = HEAP32[i36 + (i40 << 2) >> 2] | 0;
 i36 = HEAP32[(((HEAP32[i2 + 4 >> 2] | 0) + -1 | 0) >>> 0 > i40 >>> 0 ? i36 + (i40 + 1 << 2) | 0 : i2 + 60 | 0) >> 2] | 0;
 if (i1 >>> 0 >= i36 >>> 0) {
  i47 = -1;
  return i47 | 0;
 }
 i37 = HEAP32[i2 + 56 >> 2] | 0;
 i34 = HEAP32[i2 + 20 >> 2] | 0;
 i33 = i1;
 i32 = -1;
 f31 = Math_fround(-1.0);
 while (1) {
  i2 = (HEAP32[i37 + (i33 << 2) >> 2] | 0) * 3 | 0;
  i1 = HEAP32[i34 + (i2 + 2 << 2) >> 2] | 0;
  if ((HEAP32[i34 + (i2 << 2) >> 2] | 0) == (i40 | 0)) {
   i1 = 1;
   i43 = 10;
  } else if ((HEAP32[i34 + (i2 + 1 << 2) >> 2] | 0) == (i40 | 0)) {
   i1 = 2;
   i43 = 10;
  } else if ((i1 | 0) == (i40 | 0)) {
   i1 = 0;
   i43 = 10;
  } else {
   i1 = i32;
   f4 = f31;
  }
  if ((i43 | 0) == 10) {
   i43 = 0;
   i11 = i1 + i2 | 0;
   i30 = HEAP32[i34 + (i11 << 2) >> 2] | 0;
   i1 = HEAP32[i34 + ((((i1 + 1 | 0) >>> 0) % 3 | 0) + i2 << 2) >> 2] | 0;
   i3 = HEAP32[i42 + (i30 * 12 | 0) >> 2] | 0;
   i2 = HEAP32[i42 + (i30 * 12 | 0) + 4 >> 2] | 0;
   i12 = HEAP32[i42 + (i30 * 12 | 0) + 8 >> 2] | 0;
   i13 = HEAP32[i42 + (i1 * 12 | 0) >> 2] | 0;
   i14 = HEAP32[i42 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i15 = HEAP32[i42 + (i1 * 12 | 0) + 8 >> 2] | 0;
   if ((i30 | 0) == (i41 | 0)) {
    i1 = i12;
    i43 = 11;
    break;
   }
   if ((i1 | 0) == (i41 | 0)) {
    i3 = i13;
    i2 = i14;
    i1 = i15;
    i43 = 13;
    break;
   }
   f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f10 - f46);
   f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f9 - f44);
   f8 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f8 - f45);
   f17 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f17 - f46);
   f18 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f18 - f44);
   f19 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f19 - f45);
   f7 = Math_fround(Math_fround(f26 * f25) - Math_fround(f27 * f24));
   f6 = Math_fround(Math_fround(f29 * f24) - Math_fround(f28 * f25));
   f4 = Math_fround(Math_fround(f28 * f27) - Math_fround(f29 * f26));
   f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
   if (f5 > Math_fround(0.0)) {
    f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
    f16 = Math_fround(f4 * f23);
    f5 = Math_fround(f6 * f23);
    f4 = Math_fround(f7 * f23);
   } else {
    f16 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    f4 = Math_fround(0.0);
   }
   f23 = Math_fround(Math_fround(Math_fround(f35 * f4) + Math_fround(f38 * f5)) + Math_fround(f39 * f16));
   f7 = Math_fround(f35 - Math_fround(f4 * f23));
   f6 = Math_fround(f38 - Math_fround(f5 * f23));
   f4 = Math_fround(f39 - Math_fround(f16 * f23));
   f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
   if (f5 > Math_fround(0.0)) {
    f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
    f23 = Math_fround(f4 * f21);
    f22 = Math_fround(f6 * f21);
    f21 = Math_fround(f7 * f21);
   } else {
    f23 = Math_fround(0.0);
    f22 = Math_fround(0.0);
    f21 = Math_fround(0.0);
   }
   f49 = Math_fround(f46 - f10);
   f48 = Math_fround(f44 - f9);
   f20 = Math_fround(f45 - f8);
   f7 = Math_fround(f17 - f10);
   f6 = Math_fround(f18 - f9);
   f5 = Math_fround(f19 - f8);
   f18 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5));
   f4 = Math_fround(Math_fround(Math_fround(f7 * f21) + Math_fround(f6 * f22)) + Math_fround(f5 * f23));
   f16 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f23 * f23));
   f19 = Math_fround(Math_fround(Math_fround(f7 * f49) + Math_fround(f6 * f48)) + Math_fround(f5 * f20));
   f20 = Math_fround(-Math_fround(Math_fround(Math_fround(f49 * f21) + Math_fround(f48 * f22)) + Math_fround(f20 * f23)));
   f17 = Math_fround(Math_fround(f18 * f16) - Math_fround(f4 * f4));
   if (Math_fround(Math_abs(Math_fround(f17))) < Math_fround(.0000999999974)) {
    i1 = i32;
    f4 = f31;
   } else {
    f49 = Math_fround(Math_fround(1.0) / f17);
    f48 = Math_fround(f4 * f49);
    f4 = Math_fround(Math_fround(f19 * Math_fround(f16 * f49)) + Math_fround(f48 * f20));
    if (Math_fround(Math_fround(f19 * f48) + Math_fround(Math_fround(f18 * f49) * f20)) > Math_fround(-9.99999974e-06)) if (f4 > Math_fround(-9.99999974e-06) & f4 < Math_fround(1.00001001)) {
     i3 = i30;
     i43 = 21;
     break;
    }
    f4 = Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f24 * f24));
    if (f4 > Math_fround(0.0)) {
     f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
     f9 = Math_fround(f24 * f7);
     f8 = Math_fround(f26 * f7);
     f7 = Math_fround(f28 * f7);
    } else {
     f9 = Math_fround(0.0);
     f8 = Math_fround(0.0);
     f7 = Math_fround(0.0);
    }
    f4 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f27 * f27)) + Math_fround(f25 * f25));
    if (f4 > Math_fround(0.0)) {
     f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
     f6 = Math_fround(f25 * f4);
     f5 = Math_fround(f27 * f4);
     f4 = Math_fround(f29 * f4);
    } else {
     f6 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     f4 = Math_fround(0.0);
    }
    f49 = Math_fround(Math_fround(Math_fround(f21 * f7) + Math_fround(f22 * f8)) + Math_fround(f23 * f9));
    f4 = Math_fround(Math_fround(Math_fround(f21 * f4) + Math_fround(f22 * f5)) + Math_fround(f23 * f6));
    i2 = f49 > f31;
    f5 = i2 ? f49 : f31;
    if (!(f4 > f5)) {
     i1 = i2 ? i30 : i32;
     f4 = f5;
    }
   }
  }
  i33 = i33 + 1 | 0;
  if (i33 >>> 0 >= i36 >>> 0) {
   i43 = 31;
   break;
  } else {
   i32 = i1;
   f31 = f4;
  }
 }
 if ((i43 | 0) == 11) {
  f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f46);
  f48 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f44);
  f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f45);
  f49 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f48 * f48)) + Math_fround(f49 * f49))));
  HEAP32[i47 >> 2] = 1;
  HEAP32[i47 + 4 >> 2] = i41;
  HEAPF32[i47 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i47 + 12 >> 2] = f49;
  i47 = 1;
  return i47 | 0;
 } else if ((i43 | 0) == 13) {
  f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f46);
  f48 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f44);
  f49 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f45);
  f49 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f48 * f48)) + Math_fround(f49 * f49))));
  HEAP32[i47 >> 2] = 1;
  HEAP32[i47 + 4 >> 2] = i41;
  HEAPF32[i47 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i47 + 12 >> 2] = f49;
  i47 = 1;
  return i47 | 0;
 } else if ((i43 | 0) == 21) {
  i2 = f4 < Math_fround(9.99999974e-06);
  if (i2 | f4 > Math_fround(.999989986)) {
   HEAP32[i47 >> 2] = 1;
   i43 = i2 ? i3 : i1;
   HEAP32[i47 + 4 >> 2] = i43;
   f46 = Math_fround(f46 - Math_fround(HEAPF32[i42 + (i43 * 12 | 0) >> 2]));
   f48 = Math_fround(f44 - Math_fround(HEAPF32[i42 + (i43 * 12 | 0) + 4 >> 2]));
   f49 = Math_fround(f45 - Math_fround(HEAPF32[i42 + (i43 * 12 | 0) + 8 >> 2]));
   HEAPF32[i47 + 12 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f48 * f48)) + Math_fround(f49 * f49))));
   i47 = 1;
   return i47 | 0;
  } else {
   f48 = Math_fround(f46 - Math_fround(f10 + Math_fround(f7 * f4)));
   f49 = Math_fround(f44 - Math_fround(f9 + Math_fround(f6 * f4)));
   f46 = Math_fround(f45 - Math_fround(f8 + Math_fround(f5 * f4)));
   f49 = Math_fround(Math_sqrt(Math_fround(Math_fround(f46 * f46) + Math_fround(Math_fround(f48 * f48) + Math_fround(f49 * f49)))));
   HEAP32[i47 >> 2] = 0;
   HEAP32[i47 + 4 >> 2] = i11;
   HEAPF32[i47 + 8 >> 2] = f4;
   HEAPF32[i47 + 12 >> 2] = f49;
   i47 = 1;
   return i47 | 0;
  }
 } else if ((i43 | 0) == 31) {
  if ((i1 | 0) <= 0) {
   i47 = -1;
   return i47 | 0;
  }
  f46 = Math_fround(f46 - Math_fround(HEAPF32[i42 + (i1 * 12 | 0) >> 2]));
  f48 = Math_fround(f44 - Math_fround(HEAPF32[i42 + (i1 * 12 | 0) + 4 >> 2]));
  f49 = Math_fround(f45 - Math_fround(HEAPF32[i42 + (i1 * 12 | 0) + 8 >> 2]));
  f49 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f48 * f48)) + Math_fround(f49 * f49))));
  HEAP32[i47 >> 2] = 1;
  HEAP32[i47 + 4 >> 2] = i1;
  HEAPF32[i47 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i47 + 12 >> 2] = f49;
  i47 = 1;
  return i47 | 0;
 }
 return 0;
}

function __ZN26AnimatorControllerPlayable27SetupStateMachineBehavioursEP6Object(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 8 | 0;
 i13 = i19;
 if (!(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 180 >> 2] | 0, i16 | 0) | 0)) {
  i18 = 1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i14 = i16 + 112 | 0;
 i15 = i16 + 124 | 0;
 if (HEAP32[i15 >> 2] | 0) {
  i18 = 1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i9 = HEAP32[i16 + 84 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 108 >> 2] | 0, i9 | 0) | 0;
 i10 = i9 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i12 = i16 + 128 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i16 + 116 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16 + 116 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i14 >> 2] = i8;
  break;
 } while (0);
 HEAP32[i16 + 132 >> 2] = i17;
 HEAP32[i16 + 136 >> 2] = i16;
 if (HEAP32[i10 >> 2] | 0) {
  i8 = i16 + 116 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  do {
   i6 = HEAP32[i7 >> 2] | 0;
   do if (!i6) i18 = 19; else {
    HEAP32[i13 >> 2] = i6;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i18 = 15; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i13);
      i4 = HEAP32[i11 >> 2] | 0;
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
      i1 = i3;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i18 = 15; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i18 = 17;
    }
    if ((i18 | 0) == 15) i18 = 17;
    if ((i18 | 0) == 17) {
     i18 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
      i18 = 19;
      break;
     }
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i13 >> 2] = i6;
    if (!i1) i18 = 30; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i13);
      i2 = HEAP32[i11 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 30; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i18 = 32;
     }
    }
    if ((i18 | 0) == 30) i18 = 32;
    if ((i18 | 0) == 32) {
     i18 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
    }
    i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
    if (!i1) {
     i2 = HEAP32[i15 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i12 >> 2] = i1;
       HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i14 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i15 >> 2] = i3;
     HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i6;
     break;
    }
    if (__Z29scripting_class_has_attributeP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 408 >> 2] | 0) | 0) {
     i2 = HEAP32[i15 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i12 >> 2] = i1;
       HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i14 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i15 >> 2] = i3;
     HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i6;
     break;
    }
    HEAP32[i13 >> 2] = i6;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i18 = 46; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i13);
      i2 = HEAP32[i11 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 46; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i18 = 48;
     }
    }
    if ((i18 | 0) == 46) i18 = 48;
    if ((i18 | 0) == 48) {
     i18 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
    }
    i1 = __Z11CloneObjectR6Object(i1) | 0;
    i1 = (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0 ? HEAP32[i1 + 4 >> 2] | 0 : 0;
    i3 = HEAP32[i15 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i12 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i2;
      HEAP32[i14 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i4;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i3 << 2) >> 2] = i1;
    i4 = (HEAP32[i14 >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) + -1 << 2) | 0;
    HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i18 = 59; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i13);
      i2 = HEAP32[i11 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 59; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i18 = 61;
     }
    }
    if ((i18 | 0) == 59) i18 = 61;
    if ((i18 | 0) == 61) {
     i18 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    }
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
   } while (0);
   if ((i18 | 0) == 19) {
    i18 = 0;
    i2 = HEAP32[i15 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i12 >> 2] = i1;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i14 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i3;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   }
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) != ((HEAP32[i9 >> 2] | 0) + (HEAP32[i10 >> 2] << 2) | 0));
 }
 if (HEAP32[i15 >> 2] | 0) {
  i18 = 1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i5 = HEAP32[(HEAP32[i16 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i1 = 0;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i16;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i18 = 77;
    break;
   } else i3 = 0;
  }
  if ((i18 | 0) == 77) {
   i18 = 0;
   i1 = i1 | (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i17 | 0) | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i5 | 0));
 STACKTOP = i19;
 return i1 | 0;
}

function __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i13, i11, i12) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i9 = i14 + 280 | 0;
 i8 = i14 + 248 | 0;
 i6 = i14 + 168 | 0;
 _memset(i10 | 0, 0, 164) | 0;
 __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev(i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 1 | 0, i13 + 12 | 0, i10);
 _memset(i10 | 0, 0, 168) | 0;
 __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev(i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 2 | 0, i13 + 36 | 0, i10);
 _memset(i10 | 0, 0, 140) | 0;
 __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev(i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 3 | 0, i13 + 60 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 4 | 0, i13 + 84 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 5 | 0, i13 + 108 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 6 | 0, i13 + 132 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 7 | 0, i13 + 156 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 8 | 0, i13 + 180 | 0, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i12 + 9 | 0, i13 + 204 | 0, i10);
 i7 = HEAP32[i13 + 236 >> 2] | 0;
 i5 = HEAP32[i13 + 228 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i10;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6;
 i2 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i6 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev(i10);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i15;
 HEAP32[i9 + 8 >> 2] = i8;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx40PxVehicleTireLoadFilterDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEEEEEjT_j(i10, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i13 + 244 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i15 = i9 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i10;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i15 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i15 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj623ENS_22PxRepXPropertyAccessorILj623ES4_KffEEEEvRKT0_(i11, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i13 + 260 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i15 = i9 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = i10;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i15 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i15 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj624ENS_22PxRepXPropertyAccessorILj624ES4_KffEEEEvRKT0_(i11, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i15 = i13 + 276 | 0;
  i9 = i12 + 13 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i15, i9);
  i9 = i13 + 292 | 0;
  i15 = i12 + 14 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i9, i15);
  i15 = i13 + 308 | 0;
  i13 = i12 + 15 | 0;
  __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i13, i15, i10);
  i15 = i12 + 16 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i15 = i13 + 276 | 0;
 i9 = i12 + 13 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i15, i9);
 i9 = i13 + 292 | 0;
 i15 = i12 + 14 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i9, i15);
 i15 = i13 + 308 | 0;
 i13 = i12 + 15 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, i13, i15, i10);
 i15 = i12 + 16 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN9ShaderLab9SubShader29CreateFromSerializedSubShaderERKNS_19SerializedSubShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_(i34, i24, i27, i28) {
 i34 = i34 | 0;
 i24 = i24 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i38;
 i35 = i38 + 72 | 0;
 i36 = i38 + 60 | 0;
 i29 = i38 + 40 | 0;
 i30 = i38 + 24 | 0;
 i31 = i38 + 8 | 0;
 i37 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63280 | 0, 16, gb + 472212 | 0, 162) | 0;
 __ZN9ShaderLab9SubShaderC2Ev(i37);
 i25 = i34 + 4 | 0;
 i1 = ((HEAP32[i25 >> 2] | 0) - (HEAP32[i34 >> 2] | 0) | 0) / 872 | 0;
 i26 = i37 + 16 | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i26 >> 2] = i1;
  HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i1 << 2, 4, i37 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i37 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i23 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i37 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[i26 >> 2] = i1;
  HEAP32[i37 >> 2] = i23;
  break;
 } while (0);
 i1 = HEAP32[i34 >> 2] | 0;
 L7 : do if ((HEAP32[i25 >> 2] | 0) != (i1 | 0)) {
  i11 = i37 + 12 | 0;
  i12 = i37 + 4 | 0;
  i13 = i37 + 20 | 0;
  i14 = i31 + 11 | 0;
  i15 = i29 + 12 | 0;
  i16 = i29 + 16 | 0;
  i17 = i29 + 4 | 0;
  i18 = i30 + 12 | 0;
  i10 = i30 + 12 | 0;
  i19 = i33 + 4 | 0;
  i20 = i30 + 8 | 0;
  i21 = i30 + 4 | 0;
  i22 = i30 + 11 | 0;
  i23 = i33 + 4 | 0;
  i9 = 0;
  L9 : while (1) {
   i2 = i1 + (i9 * 872 | 0) | 0;
   switch (HEAP32[i2 >> 2] | 0) {
   case 0:
    {
     i8 = __ZN9ShaderLab4Pass24CreateFromSerializedPassERKNS_14SerializedPassEPK6Shader(i2, i28) | 0;
     i2 = i8;
     if (i8 | 0) {
      i3 = HEAP32[i11 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i5 = HEAP32[i26 >> 2] | 0;
      i6 = i5 & 2147483647;
      do if (i4 >>> 0 > i6 >>> 0) {
       i1 = i5 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i26 >> 2] = i1;
        HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i8 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
        HEAP32[i26 >> 2] = i1;
        HEAP32[i37 >> 2] = i8;
        break;
       }
      } while (0);
      HEAP32[i11 >> 2] = i4;
      HEAP32[(HEAP32[i37 >> 2] | 0) + (i3 << 2) >> 2] = i2;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     }
     break;
    }
   case 1:
    {
     i8 = HEAP32[i11 >> 2] | 0;
     i1 = i1 + (i9 * 872 | 0) + 800 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP32[i31 + 4 >> 2] = 0;
     HEAP32[i31 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, i1, _strlen(i1) | 0);
     i3 = (HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i31 >> 2] | 0 : i31;
     i4 = 0;
     i2 = i3;
     L26 : while (1) {
      switch (HEAP8[i2 >> 0] | 0) {
      case 0:
       break L26;
      case 47:
       {
        i1 = i2;
        break;
       }
      default:
       i1 = i4;
      }
      i4 = i1;
      i2 = i2 + 1 | 0;
     }
     if (!((i4 | 0) == 0 | (i4 | 0) == (i3 | 0))) {
      i1 = i4 - i3 | 0;
      _strncpy(i35, i3, i1) | 0;
      HEAP8[i35 + i1 >> 0] = 0;
      HEAP32[i36 >> 2] = 0;
      HEAP32[i36 + 4 >> 2] = 0;
      HEAP32[i36 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i36, i35, _strlen(i35) | 0);
      i1 = __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb(i36, i24, i27) | 0;
      if (i1 | 0) {
       HEAP32[i29 >> 2] = 0;
       HEAP32[i15 >> 2] = 0;
       HEAP32[i16 >> 2] = 0;
       __Z21SetCurrentMemoryOwnerRK10MemLabelId(i33, gb + 63664 | 0);
       i3 = i33;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       i5 = i17;
       HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i5 + 4 >> 2] = i2;
       i5 = HEAP32[HEAP32[HEAP32[i1 + 32 >> 2] >> 2] >> 2] | 0;
       i2 = i4 + 1 | 0;
       HEAP32[i30 >> 2] = 0;
       HEAP32[i30 + 4 >> 2] = 0;
       HEAP32[i30 + 8 >> 2] = 0;
       i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i18 >> 2] = i1;
       i3 = _strlen(i2) | 0;
       if (i3 >>> 0 > 2147483631) {
        __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i30);
        i1 = HEAP32[i10 >> 2] | 0;
        i32 = 27;
       } else if (i3 >>> 0 < 11) {
        HEAP8[i22 >> 0] = i3;
        if (!i3) i1 = i30; else {
         i1 = i30;
         i32 = 29;
        }
       } else i32 = 27;
       if ((i32 | 0) == 27) {
        i7 = i3 + 16 & -16;
        HEAP32[i33 >> 2] = 66;
        HEAP32[i19 >> 2] = i1;
        i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i33, 0, gb + 1049224 | 0, 75) | 0;
        HEAP32[i30 >> 2] = i1;
        HEAP32[i20 >> 2] = i7 | -2147483648;
        HEAP32[i21 >> 2] = i3;
        i32 = 29;
       }
       if ((i32 | 0) == 29) {
        i32 = 0;
        _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
       }
       HEAP8[i1 + i3 >> 0] = 0;
       __ZN9ShaderLab9SubShader15FindNamedPassesERK8UnityStrR13dynamic_arrayIPNS_4PassELj4EE(i5, i30, i29);
       if ((HEAP8[i22 >> 0] | 0) < 0) {
        i7 = HEAP32[i30 >> 2] | 0;
        i6 = HEAP32[i10 >> 2] | 0;
        HEAP32[i33 >> 2] = 66;
        HEAP32[i23 >> 2] = i6;
        __Z19free_alloc_internalPvRK10MemLabelId(i7, i33);
       }
       if (HEAP32[i15 >> 2] | 0) {
        i1 = 0;
        i4 = HEAP32[i11 >> 2] | 0;
        do {
         i3 = (HEAP32[i29 >> 2] | 0) + (i1 << 2) | 0;
         i5 = i4;
         i4 = i4 + 1 | 0;
         i6 = HEAP32[i26 >> 2] | 0;
         i7 = i6 & 2147483647;
         do if (i4 >>> 0 > i7 >>> 0) {
          i2 = i6 << 1;
          i2 = (i2 | 0) == 0 ? 1 : i2;
          if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
           HEAP32[i26 >> 2] = i2;
           HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
           break;
          } else {
           i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
           _memcpy(i7 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
           HEAP32[i26 >> 2] = i2;
           HEAP32[i37 >> 2] = i7;
           break;
          }
         } while (0);
         HEAP32[i11 >> 2] = i4;
         HEAP32[(HEAP32[i37 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i3 >> 2];
         i1 = i1 + 1 | 0;
        } while (i1 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
       }
       if ((HEAP32[i16 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i17);
        HEAP32[i29 >> 2] = 0;
       }
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
     i7 = HEAP32[i11 >> 2] | 0;
     HEAP32[i13 >> 2] = i7 - i8 + (HEAP32[i13 >> 2] | 0);
     if ((i7 | 0) == (i8 | 0)) break L9;
     break;
    }
   case 2:
    {
     i2 = __ZN9ShaderLab4Pass28CreateFromSerializedGrabPassERKNS_14SerializedPassE(i2) | 0;
     i3 = HEAP32[i11 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i26 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i26 >> 2] = i1;
       HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i37 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
       HEAP32[i26 >> 2] = i1;
       HEAP32[i37 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i11 >> 2] = i4;
     HEAP32[(HEAP32[i37 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     break;
    }
   default:
    {}
   }
   i9 = i9 + 1 | 0;
   i1 = HEAP32[i34 >> 2] | 0;
   if (i9 >>> 0 >= (((HEAP32[i25 >> 2] | 0) - i1 | 0) / 872 | 0) >>> 0) break L7;
  }
  __ZN9ShaderLab9SubShaderD2Ev(i37);
  __Z19free_alloc_internalPvRK10MemLabelId(i37, gb + 63280 | 0);
  i37 = 0;
  STACKTOP = i38;
  return i37 | 0;
 } while (0);
 i5 = i37 + 24 | 0;
 i1 = HEAP32[i34 + 12 >> 2] | 0;
 i6 = i34 + 16 | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i37 + 28 | 0;
  i8 = i7;
  i9 = i37 + 32 | 0;
  i2 = i1;
  while (1) {
   i3 = i2 + 16 | 0;
   HEAP32[i36 >> 2] = i8;
   HEAP32[i33 >> 2] = HEAP32[i36 >> 2];
   i4 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i5, i33, i35, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i31 = i3;
    i32 = HEAP32[i31 + 4 >> 2] | 0;
    i3 = i2 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i3 + 4 >> 2] = i32;
    i3 = HEAP32[i35 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i5 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i2);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
  }
 }
 HEAP32[i37 + 36 >> 2] = HEAP32[i34 + 24 >> 2];
 STACKTOP = i38;
 return i37 | 0;
}

function __ZN7VRInput21UpdateControllerInputEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 2656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i45 + 2624 | 0;
 i35 = i45 + 2608 | 0;
 i43 = i45 + 2632 | 0;
 i36 = i45 + 240 | 0;
 i37 = i45 + 40 | 0;
 i38 = i45 + 20 | 0;
 i39 = i45;
 i40 = i45 + 2592 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i45;
  return;
 }
 if (!(HEAP32[i1 + 260 >> 2] | 0)) {
  STACKTOP = i45;
  return;
 }
 i41 = __Z18GetInputManagerPtrv() | 0;
 i1 = 0;
 do {
  i44 = i36 + (i1 * 196 | 0) + 176 | 0;
  HEAP8[i36 + (i1 * 196 | 0) >> 0] = 0;
  HEAPF32[i36 + (i1 * 196 | 0) + 64 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 68 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 72 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 76 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 80 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 84 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 88 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 92 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 96 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 100 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 104 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 108 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 112 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 116 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 120 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 124 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 128 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 132 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 136 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 140 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 144 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 148 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 152 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 156 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 160 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 164 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 168 >> 2] = Math_fround(255.0);
  HEAPF32[i36 + (i1 * 196 | 0) + 172 >> 2] = Math_fround(255.0);
  HEAP32[i44 >> 2] = -1;
  HEAP32[i44 + 4 >> 2] = -1;
  HEAP32[i44 + 8 >> 2] = -1;
  HEAP32[i44 + 12 >> 2] = -1;
  HEAP32[i44 + 16 >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 12);
 i1 = i43;
 i2 = i1 + 20 | 0;
 do {
  HEAP8[i1 >> 0] = 255;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i36 | 0, 12);
 i33 = i3 + 44 | 0;
 i1 = HEAP32[i33 >> 2] | 0;
 i44 = i3 + 48 | 0;
 if ((i1 | 0) != (i44 | 0)) {
  i2 = i1;
  while (1) {
   HEAP8[i2 + 32 >> 0] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i44 | 0)) break; else i2 = i1;
  }
 }
 i16 = i40 + 12 | 0;
 i13 = i40 + 12 | 0;
 i17 = i34 + 4 | 0;
 i18 = i40 + 8 | 0;
 i19 = i40 + 4 | 0;
 i20 = i40 + 11 | 0;
 i21 = i39 + 12 | 0;
 i15 = i39 + 12 | 0;
 i22 = i34 + 4 | 0;
 i23 = i39 + 8 | 0;
 i24 = i39 + 4 | 0;
 i25 = i39 + 16 | 0;
 i26 = i39 + 11 | 0;
 i27 = i38 + 12 | 0;
 i14 = i38 + 12 | 0;
 i28 = i34 + 4 | 0;
 i29 = i38 + 8 | 0;
 i30 = i38 + 4 | 0;
 i31 = i38 + 16 | 0;
 i32 = i3 + 48 | 0;
 i8 = i3 + 56 | 0;
 i9 = i38 + 11 | 0;
 i10 = i34 + 4 | 0;
 i11 = i34 + 4 | 0;
 i12 = i34 + 4 | 0;
 i7 = 0;
 while (1) {
  _memcpy(i37 | 0, i36 + (i7 * 196 | 0) | 0, 196) | 0;
  if (!(_strlen(i37) | 0)) {
   i42 = 55;
   break;
  }
  i1 = __Z23GetVirtualJoystickIndexPKc(i37) | 0;
  if ((i1 | 0) == -1) i1 = __Z22ConnectVirtualJoystickPKc(i37) | 0;
  i6 = i1 + 1 | 0;
  HEAP32[i40 >> 2] = 0;
  HEAP32[i40 + 4 >> 2] = 0;
  HEAP32[i40 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i16 >> 2] = i1;
  i2 = _strlen(i37) | 0;
  if (i2 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i40);
   i1 = HEAP32[i13 >> 2] | 0;
   i42 = 19;
  } else if (i2 >>> 0 < 11) {
   HEAP8[i20 >> 0] = i2;
   if (!i2) i1 = i40; else {
    i1 = i40;
    i42 = 21;
   }
  } else i42 = 19;
  if ((i42 | 0) == 19) {
   i5 = i2 + 16 & -16;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i17 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i34, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i40 >> 2] = i1;
   HEAP32[i18 >> 2] = i5 | -2147483648;
   HEAP32[i19 >> 2] = i2;
   i42 = 21;
  }
  if ((i42 | 0) == 21) {
   i42 = 0;
   _memcpy(i1 | 0, i37 | 0, i2 | 0) | 0;
  }
  HEAP8[i1 + i2 >> 0] = 0;
  i3 = HEAP8[i20 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i40 >> 2] | 0 : i40;
  i3 = i1 ? HEAP32[i19 >> 2] | 0 : i3 & 255;
  HEAP32[i39 >> 2] = 0;
  HEAP32[i39 + 4 >> 2] = 0;
  HEAP32[i39 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i21 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
   i1 = HEAP32[i15 >> 2] | 0;
   i42 = 25;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i26 >> 0] = i3;
   if (!i3) i1 = i39; else {
    i1 = i39;
    i42 = 27;
   }
  } else i42 = 25;
  if ((i42 | 0) == 25) {
   i5 = i3 + 16 & -16;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i22 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i34, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i39 >> 2] = i1;
   HEAP32[i23 >> 2] = i5 | -2147483648;
   HEAP32[i24 >> 2] = i3;
   i42 = 27;
  }
  if ((i42 | 0) == 27) {
   i42 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP8[i25 >> 0] = 1;
  i3 = HEAP8[i26 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i39 >> 2] | 0 : i39;
  i3 = i1 ? HEAP32[i24 >> 2] | 0 : i3 & 255;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i27 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
   i1 = HEAP32[i14 >> 2] | 0;
   i42 = 31;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i9 >> 0] = i3;
   if (!i3) i1 = i38; else {
    i1 = i38;
    i42 = 33;
   }
  } else i42 = 31;
  if ((i42 | 0) == 31) {
   i5 = i3 + 16 & -16;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i28 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i34, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i38 >> 2] = i1;
   HEAP32[i29 >> 2] = i5 | -2147483648;
   HEAP32[i30 >> 2] = i3;
   i42 = 33;
  }
  if ((i42 | 0) == 33) {
   i42 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP8[i31 >> 0] = HEAP8[i25 >> 0] | 0;
  i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i33, i34, i38) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE16__construct_nodeERKNS_4pairIKS2_bEE(i35, i33, i38);
   i1 = HEAP32[i35 >> 2] | 0;
   HEAP32[i35 >> 2] = 0;
   i2 = HEAP32[i34 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i33 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i33 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i32 >> 2] | 0, i2);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i2 = 1;
  } else i2 = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i5 = HEAP32[i38 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i10 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i34);
  }
  if ((HEAP8[i26 >> 0] | 0) < 0) {
   i5 = HEAP32[i39 >> 2] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i11 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i34);
  }
  if ((HEAP8[i20 >> 0] | 0) < 0) {
   i5 = HEAP32[i40 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   HEAP32[i34 >> 2] = 66;
   HEAP32[i12 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i34);
  }
  if (!(i2 << 24 >> 24)) {
   HEAP8[i1 + 32 >> 0] = 1;
   i2 = 0;
  } else i2 = 0;
  do {
   i1 = i37 + 176 + i2 | 0;
   do if ((HEAP8[i1 >> 0] | 0) != -1) {
    i3 = __Z19JoystickButtonToKeyii(i6, i2) | 0;
    __ZN12InputManager11SetKeyStateEib(i41, i3, (HEAP8[i1 >> 0] | 0) != 0);
    i3 = i43 + i2 | 0;
    i5 = HEAP8[i3 >> 0] | 0;
    i1 = HEAP8[i1 >> 0] | 0;
    if (i5 << 24 >> 24 == -1) {
     HEAP8[i3 >> 0] = i1;
     break;
    } else {
     HEAP8[i3 >> 0] = i1 | i5;
     break;
    }
   } while (0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 20);
  i1 = 0;
  do {
   f4 = Math_fround(HEAPF32[i37 + 64 + (i1 << 2) >> 2]);
   if (f4 < Math_fround(255.0)) __ZN12InputManager19SetJoystickPositionEiif(i41, i6, i1, f4);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 28);
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= 12) {
   i2 = 0;
   break;
  }
 }
 if ((i42 | 0) == 55) i2 = 0;
 do {
  i1 = HEAP8[i43 + i2 >> 0] | 0;
  if (i1 << 24 >> 24 != -1) __ZN12InputManager11SetKeyStateEib(i41, __Z19JoystickButtonToKeyii(0, i2) | 0, i1 << 24 >> 24 != 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 20);
 i1 = HEAP32[i33 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i44 | 0)) while (1) {
  i3 = i2 + 16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  __Z32SetVirtualJoystickConnectedStatePKcb(i3, (HEAP8[i2 + 32 >> 0] | 0) != 0);
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i44 | 0)) break; else i1 = i2;
 }
 STACKTOP = i45;
 return;
}

function __ZN7mecanim12statemachine18TransitionConstant8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 12 | 0;
 i2 = i10;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i7 + 4;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i2 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903088 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903204 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903024 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 910040 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   i3 = i1 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i1 >>> 0) i6 = 34; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i6 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903223 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 24 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903232 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903253 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903174 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 78; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 78; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 78) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 36 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903272 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 37 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903286 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead28TransitionInterruptionSourceEvRT_RT0_PKc17TransferMetaFlags(i9, i7 + 40 | 0, gb + 903305 | 0, 0);
 i3 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903326 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 45 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903348 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_41PCMCapsuleVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj(i17, i5, i2, i3, i4, i1, i18) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 if (!(HEAP8[i17 + 16 >> 0] | 0)) {
  i6 = HEAP32[i17 + 8 >> 2] | 0;
  f25 = Math_fround(HEAPF32[i2 >> 2]);
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i6 >> 2]));
  i7 = i6 + 4 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i7 >> 2]));
  i8 = i6 + 8 | 0;
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i8 >> 2]));
  f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i9 = i6 + 12 | 0;
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i9 >> 2]));
  i10 = i6 + 16 | 0;
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i10 >> 2]));
  i11 = i6 + 20 | 0;
  f24 = Math_fround(f26 + f24);
  f23 = Math_fround(f27 + f23);
  f22 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i11 >> 2])));
  f25 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i12 = i6 + 24 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i12 >> 2]));
  i13 = i6 + 28 | 0;
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i13 >> 2]));
  i14 = i6 + 32 | 0;
  f27 = Math_fround(f24 + f27);
  f26 = Math_fround(f23 + f26);
  f25 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 >> 2] = f27;
  HEAPF32[i15 + 4 >> 2] = f26;
  HEAPF32[i15 + 8 >> 2] = f25;
  f22 = Math_fround(HEAPF32[i3 >> 2]);
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i6 >> 2]));
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i7 >> 2]));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i8 >> 2]));
  f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i10 >> 2]));
  f21 = Math_fround(f23 + f21);
  f20 = Math_fround(f24 + f20);
  f19 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2])));
  f22 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i12 >> 2]));
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i13 >> 2]));
  f24 = Math_fround(f21 + f24);
  f23 = Math_fround(f20 + f23);
  f22 = Math_fround(f19 + Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 12 >> 2] = f24;
  HEAPF32[i15 + 16 >> 2] = f23;
  HEAPF32[i15 + 20 >> 2] = f22;
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i6 >> 2]));
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2]));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2]));
  f28 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f30 = Math_fround(f28 * Math_fround(HEAPF32[i9 >> 2]));
  f29 = Math_fround(f28 * Math_fround(HEAPF32[i10 >> 2]));
  f30 = Math_fround(f20 + f30);
  f29 = Math_fround(f21 + f29);
  f28 = Math_fround(f19 + Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2])));
  f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i12 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2]));
  f21 = Math_fround(f30 + f21);
  f20 = Math_fround(f29 + f20);
  f19 = Math_fround(f28 + Math_fround(f19 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 24 >> 2] = f21;
  HEAPF32[i15 + 28 >> 2] = f20;
  HEAPF32[i15 + 32 >> 2] = f19;
  i14 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i14 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i14;
  i13 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i13;
  i12 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i12;
  i11 = HEAP32[i3 >> 2] | 0;
  HEAP32[i15 + 12 >> 2] = i11;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i15 + 16 >> 2] = i10;
  i9 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i15 + 20 >> 2] = i9;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i15 + 24 >> 2] = i8;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i15 + 28 >> 2] = i7;
  i6 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
 }
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i17 + 12 >> 2] | 0;
 if (!i1) i3 = 56; else i3 = HEAP8[i1 + i4 >> 0] | 0;
 i1 = i17 + 868 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 16) {
  i15 = i2;
  i32 = i14;
  i31 = i13;
  i13 = i12;
  i2 = i11;
  i5 = i10;
  i11 = i9;
  i9 = i7;
  i10 = i6;
  i12 = i15 + 1 | 0;
  HEAP32[i1 >> 2] = i12;
  i12 = i15 * 3 | 0;
  i14 = i17 + 20 + (i12 * 12 | 0) | 0;
  HEAP32[i14 >> 2] = i32;
  i14 = i17 + 20 + (i12 * 12 | 0) + 4 | 0;
  HEAP32[i14 >> 2] = i31;
  i14 = i17 + 20 + (i12 * 12 | 0) + 8 | 0;
  HEAP32[i14 >> 2] = i13;
  i14 = i12 + 1 | 0;
  i13 = i17 + 20 + (i14 * 12 | 0) | 0;
  HEAP32[i13 >> 2] = i2;
  i13 = i17 + 20 + (i14 * 12 | 0) + 4 | 0;
  HEAP32[i13 >> 2] = i5;
  i13 = i17 + 20 + (i14 * 12 | 0) + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i12 + 2 | 0;
  i11 = i17 + 20 + (i13 * 12 | 0) | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i17 + 20 + (i13 * 12 | 0) + 4 | 0;
  HEAP32[i11 >> 2] = i9;
  i11 = i17 + 20 + (i13 * 12 | 0) + 8 | 0;
  HEAP32[i11 >> 2] = i10;
  i11 = HEAP32[i18 >> 2] | 0;
  i12 = i17 + 596 + (i12 << 2) | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i18 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i14 = i17 + 596 + (i14 << 2) | 0;
  HEAP32[i14 >> 2] = i12;
  i14 = i18 + 8 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i18 = i17 + 596 + (i13 << 2) | 0;
  HEAP32[i18 >> 2] = i14;
  i18 = i17 + 788 + (i15 << 2) | 0;
  HEAP32[i18 >> 2] = i4;
  i18 = i17 + 852 + i15 | 0;
  HEAP8[i18 >> 0] = i3;
  STACKTOP = i16;
  return 1;
 }
 i32 = i17 + 880 | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 20 | 0, HEAP32[i17 + 788 >> 2] | 0, HEAP8[i17 + 852 >> 0] | 0, i17 + 596 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 56 | 0, HEAP32[i17 + 792 >> 2] | 0, HEAP8[i17 + 853 >> 0] | 0, i17 + 608 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 92 | 0, HEAP32[i17 + 796 >> 2] | 0, HEAP8[i17 + 854 >> 0] | 0, i17 + 620 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 128 | 0, HEAP32[i17 + 800 >> 2] | 0, HEAP8[i17 + 855 >> 0] | 0, i17 + 632 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 164 | 0, HEAP32[i17 + 804 >> 2] | 0, HEAP8[i17 + 856 >> 0] | 0, i17 + 644 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 200 | 0, HEAP32[i17 + 808 >> 2] | 0, HEAP8[i17 + 857 >> 0] | 0, i17 + 656 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 236 | 0, HEAP32[i17 + 812 >> 2] | 0, HEAP8[i17 + 858 >> 0] | 0, i17 + 668 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 272 | 0, HEAP32[i17 + 816 >> 2] | 0, HEAP8[i17 + 859 >> 0] | 0, i17 + 680 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 308 | 0, HEAP32[i17 + 820 >> 2] | 0, HEAP8[i17 + 860 >> 0] | 0, i17 + 692 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 344 | 0, HEAP32[i17 + 824 >> 2] | 0, HEAP8[i17 + 861 >> 0] | 0, i17 + 704 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 380 | 0, HEAP32[i17 + 828 >> 2] | 0, HEAP8[i17 + 862 >> 0] | 0, i17 + 716 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 416 | 0, HEAP32[i17 + 832 >> 2] | 0, HEAP8[i17 + 863 >> 0] | 0, i17 + 728 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 452 | 0, HEAP32[i17 + 836 >> 2] | 0, HEAP8[i17 + 864 >> 0] | 0, i17 + 740 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 488 | 0, HEAP32[i17 + 840 >> 2] | 0, HEAP8[i17 + 865 >> 0] | 0, i17 + 752 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 524 | 0, HEAP32[i17 + 844 >> 2] | 0, HEAP8[i17 + 866 >> 0] | 0, i17 + 764 | 0) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 560 | 0, HEAP32[i17 + 848 >> 2] | 0, HEAP8[i17 + 867 >> 0] | 0, i17 + 776 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i32 = 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i15 + 4 >> 2] | 0;
 i31 = HEAP32[i15 + 8 >> 2] | 0;
 i8 = HEAP32[i15 + 12 >> 2] | 0;
 i9 = HEAP32[i15 + 16 >> 2] | 0;
 i13 = HEAP32[i15 + 20 >> 2] | 0;
 i10 = HEAP32[i15 + 24 >> 2] | 0;
 i11 = HEAP32[i15 + 28 >> 2] | 0;
 i12 = HEAP32[i15 + 32 >> 2] | 0;
 i14 = i32 + 1 | 0;
 HEAP32[i1 >> 2] = i14;
 i14 = i32 * 3 | 0;
 i15 = i17 + 20 + (i14 * 12 | 0) | 0;
 HEAP32[i15 >> 2] = i6;
 i15 = i17 + 20 + (i14 * 12 | 0) + 4 | 0;
 HEAP32[i15 >> 2] = i7;
 i15 = i17 + 20 + (i14 * 12 | 0) + 8 | 0;
 HEAP32[i15 >> 2] = i31;
 i15 = i14 + 1 | 0;
 i31 = i17 + 20 + (i15 * 12 | 0) | 0;
 HEAP32[i31 >> 2] = i8;
 i31 = i17 + 20 + (i15 * 12 | 0) + 4 | 0;
 HEAP32[i31 >> 2] = i9;
 i31 = i17 + 20 + (i15 * 12 | 0) + 8 | 0;
 HEAP32[i31 >> 2] = i13;
 i31 = i14 + 2 | 0;
 i13 = i17 + 20 + (i31 * 12 | 0) | 0;
 HEAP32[i13 >> 2] = i10;
 i13 = i17 + 20 + (i31 * 12 | 0) + 4 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i17 + 20 + (i31 * 12 | 0) + 8 | 0;
 HEAP32[i13 >> 2] = i12;
 i13 = HEAP32[i18 >> 2] | 0;
 i14 = i17 + 596 + (i14 << 2) | 0;
 HEAP32[i14 >> 2] = i13;
 i14 = i18 + 4 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = i17 + 596 + (i15 << 2) | 0;
 HEAP32[i15 >> 2] = i14;
 i18 = i18 + 8 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i31 = i17 + 596 + (i31 << 2) | 0;
 HEAP32[i31 >> 2] = i18;
 i31 = i17 + 788 + (i32 << 2) | 0;
 HEAP32[i31 >> 2] = i4;
 i32 = i17 + 852 + i32 | 0;
 HEAP8[i32 >> 0] = i3;
 STACKTOP = i16;
 return 1;
}

function __ZN5physx25PxVehicleConstraintShader17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i22 >> 2] = HEAP32[gb + 162736 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[gb + 162736 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[gb + 162736 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[gb + 162736 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[gb + 162736 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[gb + 162736 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[gb + 162736 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[gb + 162736 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 162768 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 162768 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 162768 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 162768 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 162768 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 162768 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 162768 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 162768 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 162800 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 162800 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 162800 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 162800 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 162800 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 162800 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 162800 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 162800 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 162832 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 162832 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 162832 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 162832 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 162832 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 162832 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 162832 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 162832 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 162864 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 162864 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 162864 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 162864 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 162864 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 162864 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 162864 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 162864 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 162896 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 162896 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 162896 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 162896 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 162896 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 162896 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 162896 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 162896 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 162768 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 162768 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 162768 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 162768 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 162768 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 162768 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 162768 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 162768 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 162800 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 162800 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 162800 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 162800 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 162800 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 162800 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 162800 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 162800 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 162928 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 162928 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 162928 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 162928 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 162928 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 162928 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 162928 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 162928 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 162864 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 162864 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 162864 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 162864 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 162864 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 162864 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 162864 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 162864 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 162960 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 162960 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 162960 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 162960 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 162960 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 162960 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 162960 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 162960 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 162992 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 162992 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 162992 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 162992 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 162992 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 162992 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 162992 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 162992 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 163024 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 163024 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 163024 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 163024 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 163024 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 163024 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 163024 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 163024 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 163056 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 163056 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 163056 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 163056 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 163056 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 163056 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 163056 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 163056 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 163088 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 163088 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 163088 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 163088 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 163088 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 163088 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 163088 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 163088 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 829030;
 HEAP32[i7 + 4 >> 2] = gb + 829211;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 384;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 163120 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 163120 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 163120 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 163120 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 163120 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 163120 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 163120 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 163120 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 163152 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 163152 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 163152 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 163152 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 163152 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 163152 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 163152 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 163152 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 163184 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 163184 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 163184 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 163184 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 163184 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 163184 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 163184 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 163184 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 163216 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 163216 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 163216 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 163216 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 163216 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 163216 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 163216 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 163216 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx14PxsAABBManager25processAggregateAggregateERKNS_19AggregateSortedDataERKNS_9AggregateES3_S6_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i27, i1, i3, i2, i4, i29) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i29 = i29 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 2080 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i35 + 2065 | 0;
 i32 = i35 + 2064 | 0;
 i31 = i35;
 i24 = HEAPU8[i4 + 1025 >> 0] | 0;
 i25 = HEAP32[i1 + 4 >> 2] | 0;
 i26 = HEAP32[i2 + 4 >> 2] | 0;
 i30 = i31 + 2048 | 0;
 HEAP32[i30 >> 2] = HEAP32[i27 >> 2];
 i28 = i31 + 2052 | 0;
 HEAP32[i28 >> 2] = i31;
 HEAP32[i31 + 2056 >> 2] = -2147483136;
 _memset(i31 | 0, 0, 2048) | 0;
 i23 = HEAP32[i27 + 300 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i20 = HEAP32[i2 >> 2] | 0;
 i19 = HEAP8[i3 + 1026 >> 0] | 0;
 i22 = i1 + ((i19 & 255) << 2) | 0;
 i18 = HEAP8[i4 + 1026 >> 0] | 0;
 i21 = i20 + ((i18 & 255) << 2) | 0;
 i19 = i18 << 24 >> 24 != 0 & i19 << 24 >> 24 != 0;
 L1 : do if (i19) {
  i13 = i27 + 308 | 0;
  i14 = i27 + 304 | 0;
  i15 = i27 + 49836 | 0;
  i16 = i27 + 49840 | 0;
  i17 = i27 + 49832 | 0;
  i2 = i20;
  i18 = i1;
  do {
   i4 = HEAP32[i18 >> 2] | 0;
   i18 = i18 + 4 | 0;
   L5 : do if (i2 >>> 0 < i21 >>> 0) {
    i3 = HEAP32[i23 + ((HEAP32[i25 + (i4 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0;
    do {
     if ((HEAP32[i23 + ((HEAP32[i26 + (HEAP32[i2 >> 2] << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0 >= i3 >>> 0) break L5;
     i2 = i2 + 4 | 0;
    } while (i2 >>> 0 < i21 >>> 0);
   } while (0);
   i11 = i2 >>> 0 < i21 >>> 0;
   if (!i11) break;
   i12 = i25 + (i4 << 2) | 0;
   i9 = Math_imul(i4, i24) | 0;
   i10 = i2;
   do {
    i3 = HEAP32[i10 >> 2] | 0;
    i10 = i10 + 4 | 0;
    i5 = HEAP32[i26 + (i3 << 2) >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i23 + (i5 * 24 | 0) >> 2] | 0) >>> 0 > (HEAP32[i23 + (i4 * 24 | 0) + 12 >> 2] | 0) >>> 0) break;
    i8 = HEAP32[i13 >> 2] | 0;
    if ((HEAP32[i8 + (i4 << 2) >> 2] | 0) != (HEAP32[i8 + (i5 << 2) >> 2] | 0)) if ((HEAP32[i23 + (i4 * 24 | 0) >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i5 * 24 | 0) + 12 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i5 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i4 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i4 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i5 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i5 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i4 * 24 | 0) + 20 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i4 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i5 * 24 | 0) + 20 >> 2] | 0) >>> 0) {
     i8 = i3 + i9 | 0;
     i7 = i27 + 384 + ((i8 & 31) << 2) | 0;
     i8 = i8 >>> 5;
     i6 = (HEAP32[i28 >> 2] | 0) + (i8 << 2) | 0;
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | HEAP32[i7 >> 2];
     if (!(HEAP32[i7 >> 2] & HEAP32[(HEAP32[i29 >> 2] | 0) + (i8 << 2) >> 2])) {
      i7 = HEAP32[i14 >> 2] | 0;
      i8 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
      i7 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
      i4 = HEAP32[i15 >> 2] | 0;
      if ((i4 | 0) == (HEAP32[i16 >> 2] | 0)) {
       i5 = (i4 | 0) == 0 ? 32 : i4 << 1;
       i6 = HEAP32[i17 >> 2] | 0;
       i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i33, i5 << 3, gb + 717789 | 0, 59) | 0;
       if (i6 | 0) _memcpy(i3 | 0, i6 | 0, i4 << 3 | 0) | 0;
       _memset(i3 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i6);
       HEAP32[i17 >> 2] = i3;
       HEAP32[i16 >> 2] = i5;
       i4 = HEAP32[i15 >> 2] | 0;
      } else i3 = HEAP32[i17 >> 2] | 0;
      HEAP32[i15 >> 2] = i4 + 1;
      HEAP32[i3 + (i4 << 3) >> 2] = i8;
      HEAP32[i3 + (i4 << 3) + 4 >> 2] = i7;
     }
    }
   } while (i10 >>> 0 < i21 >>> 0);
  } while (i11 & i18 >>> 0 < i22 >>> 0);
  if (i19) {
   i13 = i27 + 308 | 0;
   i14 = i27 + 304 | 0;
   i15 = i27 + 49836 | 0;
   i16 = i27 + 49840 | 0;
   i17 = i27 + 49832 | 0;
   i12 = i20;
   do {
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = i12 + 4 | 0;
    L36 : do if (i1 >>> 0 < i22 >>> 0) {
     i2 = HEAP32[i23 + ((HEAP32[i26 + (i11 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0;
     do {
      if ((HEAP32[i23 + ((HEAP32[i25 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0 > i2 >>> 0) break L36;
      i1 = i1 + 4 | 0;
     } while (i1 >>> 0 < i22 >>> 0);
    } while (0);
    i8 = i1 >>> 0 < i22 >>> 0;
    if (!i8) break L1;
    i9 = i26 + (i11 << 2) | 0;
    i10 = i1;
    do {
     i2 = HEAP32[i10 >> 2] | 0;
     i10 = i10 + 4 | 0;
     i3 = HEAP32[i25 + (i2 << 2) >> 2] | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     if ((HEAP32[i23 + (i3 * 24 | 0) >> 2] | 0) >>> 0 > (HEAP32[i23 + (i4 * 24 | 0) + 12 >> 2] | 0) >>> 0) break;
     i20 = HEAP32[i13 >> 2] | 0;
     if ((HEAP32[i20 + (i3 << 2) >> 2] | 0) != (HEAP32[i20 + (i4 << 2) >> 2] | 0)) if ((HEAP32[i23 + (i4 * 24 | 0) >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i3 * 24 | 0) + 12 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i4 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i3 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i3 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i4 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i4 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i3 * 24 | 0) + 20 >> 2] | 0) >>> 0) if ((HEAP32[i23 + (i3 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= (HEAP32[i23 + (i4 * 24 | 0) + 20 >> 2] | 0) >>> 0) {
      i20 = (Math_imul(i2, i24) | 0) + i11 | 0;
      i19 = i27 + 384 + ((i20 & 31) << 2) | 0;
      i20 = i20 >>> 5;
      i18 = (HEAP32[i28 >> 2] | 0) + (i20 << 2) | 0;
      HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | HEAP32[i19 >> 2];
      if (!(HEAP32[i19 >> 2] & HEAP32[(HEAP32[i29 >> 2] | 0) + (i20 << 2) >> 2])) {
       i6 = HEAP32[i14 >> 2] | 0;
       i7 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
       i6 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i15 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i16 >> 2] | 0)) {
        i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
        i5 = HEAP32[i17 >> 2] | 0;
        i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i33, i4 << 3, gb + 717789 | 0, 59) | 0;
        if (i5 | 0) _memcpy(i2 | 0, i5 | 0, i3 << 3 | 0) | 0;
        _memset(i2 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i5);
        HEAP32[i17 >> 2] = i2;
        HEAP32[i16 >> 2] = i4;
        i3 = HEAP32[i15 >> 2] | 0;
       } else i2 = HEAP32[i17 >> 2] | 0;
       HEAP32[i15 >> 2] = i3 + 1;
       HEAP32[i2 + (i3 << 3) >> 2] = i7;
       HEAP32[i2 + (i3 << 3) + 4 >> 2] = i6;
      }
     }
    } while (i10 >>> 0 < i22 >>> 0);
   } while (i8 & i12 >>> 0 < i21 >>> 0);
  }
 } while (0);
 i15 = i29 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i5 = i1 & 2147483647;
 L64 : do if (i5) {
  i4 = HEAP32[i29 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i5 >>> 0) break L64;
  }
  i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
  i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i2 << 5;
  i3 = i3 + -1 & i3;
  L70 : do if (!i3) do {
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i5 >>> 0) {
    i3 = 0;
    break L70;
   }
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  } while ((i3 | 0) == 0); while (0);
  if ((i6 | 0) != -1) {
   i10 = i27 + 308 | 0;
   i11 = i27 + 304 | 0;
   i12 = i27 + 49848 | 0;
   i13 = i27 + 49852 | 0;
   i14 = i27 + 49844 | 0;
   i1 = i6;
   L76 : while (1) {
    i9 = i2 << 5;
    while (1) {
     if (!(HEAP32[i27 + 384 + ((i1 & 31) << 2) >> 2] & HEAP32[(HEAP32[i28 >> 2] | 0) + (i1 >>> 5 << 2) >> 2])) {
      i4 = (i1 >>> 0) / (i24 >>> 0) | 0;
      i5 = i1 - (Math_imul(i4, i24) | 0) | 0;
      i1 = HEAP32[i25 + (i4 << 2) >> 2] | 0;
      i5 = HEAP32[i26 + (i5 << 2) >> 2] | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) != 1073741823) if ((HEAP32[i4 + (i5 << 2) >> 2] | 0) != 1073741823) {
       i7 = HEAP32[i11 >> 2] | 0;
       i8 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
       i7 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
       i4 = HEAP32[i12 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i13 >> 2] | 0)) {
        i5 = (i4 | 0) == 0 ? 32 : i4 << 1;
        i6 = HEAP32[i14 >> 2] | 0;
        i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i33, i5 << 3, gb + 717789 | 0, 59) | 0;
        if (i6 | 0) _memcpy(i1 | 0, i6 | 0, i4 << 3 | 0) | 0;
        _memset(i1 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i6);
        HEAP32[i14 >> 2] = i1;
        HEAP32[i13 >> 2] = i5;
        i4 = HEAP32[i12 >> 2] | 0;
       } else i1 = HEAP32[i14 >> 2] | 0;
       HEAP32[i12 >> 2] = i4 + 1;
       HEAP32[i1 + (i4 << 3) >> 2] = i8;
       HEAP32[i1 + (i4 << 3) + 4 >> 2] = i7;
      }
     }
     if (!i3) break L76;
     i1 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i1 = HEAP32[gb + 90668 + (i1 << 2) >> 2] | i9;
     i3 = i3 + -1 & i3;
     if (!i3) {
      i5 = i1;
      break;
     }
     if ((i1 | 0) == -1) break L76;
    }
    i1 = HEAP32[i15 >> 2] | 0;
    i4 = i1 & 2147483647;
    do {
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i4 >>> 0) {
      i3 = 0;
      break;
     }
     i3 = HEAP32[(HEAP32[i29 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    } while ((i3 | 0) == 0);
    if ((i5 | 0) == -1) break L64; else i1 = i5;
   }
   i1 = HEAP32[i15 >> 2] | 0;
  }
 } while (0);
 _memcpy(HEAP32[i29 >> 2] | 0, HEAP32[i28 >> 2] | 0, i1 << 2 | 0) | 0;
 i5 = HEAP32[i31 + 2052 >> 2] | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == (i31 | 0)) {
  STACKTOP = i35;
  return;
 }
 i9 = HEAP32[i30 >> 2] | 0;
 if (!i9) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i5);
  STACKTOP = i35;
  return;
 }
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (i1 >>> 0 > i5 >>> 0) i34 = 80; else if ((i1 + (HEAP32[i9 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
  i6 = i9 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
 } else i34 = 80;
 if ((i34 | 0) == 80) __ZN5physx6shdfnd9Allocator10deallocateEPv(i33, i5);
 STACKTOP = i35;
 return;
}

function __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMSphereVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj(i17, i5, i2, i3, i4, i1, i18) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 if (!(HEAP8[i17 + 16 >> 0] | 0)) {
  i6 = HEAP32[i17 + 8 >> 2] | 0;
  f25 = Math_fround(HEAPF32[i2 >> 2]);
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i6 >> 2]));
  i7 = i6 + 4 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i7 >> 2]));
  i8 = i6 + 8 | 0;
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i8 >> 2]));
  f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i9 = i6 + 12 | 0;
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i9 >> 2]));
  i10 = i6 + 16 | 0;
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i10 >> 2]));
  i11 = i6 + 20 | 0;
  f24 = Math_fround(f26 + f24);
  f23 = Math_fround(f27 + f23);
  f22 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i11 >> 2])));
  f25 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i12 = i6 + 24 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i12 >> 2]));
  i13 = i6 + 28 | 0;
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i13 >> 2]));
  i14 = i6 + 32 | 0;
  f27 = Math_fround(f24 + f27);
  f26 = Math_fround(f23 + f26);
  f25 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 >> 2] = f27;
  HEAPF32[i15 + 4 >> 2] = f26;
  HEAPF32[i15 + 8 >> 2] = f25;
  f22 = Math_fround(HEAPF32[i3 >> 2]);
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i6 >> 2]));
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i7 >> 2]));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i8 >> 2]));
  f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i10 >> 2]));
  f21 = Math_fround(f23 + f21);
  f20 = Math_fround(f24 + f20);
  f19 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2])));
  f22 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i12 >> 2]));
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i13 >> 2]));
  f24 = Math_fround(f21 + f24);
  f23 = Math_fround(f20 + f23);
  f22 = Math_fround(f19 + Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 12 >> 2] = f24;
  HEAPF32[i15 + 16 >> 2] = f23;
  HEAPF32[i15 + 20 >> 2] = f22;
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i6 >> 2]));
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2]));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2]));
  f28 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f30 = Math_fround(f28 * Math_fround(HEAPF32[i9 >> 2]));
  f29 = Math_fround(f28 * Math_fround(HEAPF32[i10 >> 2]));
  f30 = Math_fround(f20 + f30);
  f29 = Math_fround(f21 + f29);
  f28 = Math_fround(f19 + Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2])));
  f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i12 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2]));
  f21 = Math_fround(f30 + f21);
  f20 = Math_fround(f29 + f20);
  f19 = Math_fround(f28 + Math_fround(f19 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 24 >> 2] = f21;
  HEAPF32[i15 + 28 >> 2] = f20;
  HEAPF32[i15 + 32 >> 2] = f19;
  i14 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i14 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i14;
  i13 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i13;
  i12 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i12;
  i11 = HEAP32[i3 >> 2] | 0;
  HEAP32[i15 + 12 >> 2] = i11;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i15 + 16 >> 2] = i10;
  i9 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i15 + 20 >> 2] = i9;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i15 + 24 >> 2] = i8;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i15 + 28 >> 2] = i7;
  i6 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
 }
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i17 + 12 >> 2] | 0;
 if (!i1) i3 = 56; else i3 = HEAP8[i1 + i4 >> 0] | 0;
 i1 = i17 + 868 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 16) {
  i15 = i2;
  i32 = i14;
  i31 = i13;
  i13 = i12;
  i2 = i11;
  i5 = i10;
  i11 = i9;
  i9 = i7;
  i10 = i6;
  i12 = i15 + 1 | 0;
  HEAP32[i1 >> 2] = i12;
  i12 = i15 * 3 | 0;
  i14 = i17 + 20 + (i12 * 12 | 0) | 0;
  HEAP32[i14 >> 2] = i32;
  i14 = i17 + 20 + (i12 * 12 | 0) + 4 | 0;
  HEAP32[i14 >> 2] = i31;
  i14 = i17 + 20 + (i12 * 12 | 0) + 8 | 0;
  HEAP32[i14 >> 2] = i13;
  i14 = i12 + 1 | 0;
  i13 = i17 + 20 + (i14 * 12 | 0) | 0;
  HEAP32[i13 >> 2] = i2;
  i13 = i17 + 20 + (i14 * 12 | 0) + 4 | 0;
  HEAP32[i13 >> 2] = i5;
  i13 = i17 + 20 + (i14 * 12 | 0) + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i12 + 2 | 0;
  i11 = i17 + 20 + (i13 * 12 | 0) | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i17 + 20 + (i13 * 12 | 0) + 4 | 0;
  HEAP32[i11 >> 2] = i9;
  i11 = i17 + 20 + (i13 * 12 | 0) + 8 | 0;
  HEAP32[i11 >> 2] = i10;
  i11 = HEAP32[i18 >> 2] | 0;
  i12 = i17 + 596 + (i12 << 2) | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i18 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i14 = i17 + 596 + (i14 << 2) | 0;
  HEAP32[i14 >> 2] = i12;
  i14 = i18 + 8 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i18 = i17 + 596 + (i13 << 2) | 0;
  HEAP32[i18 >> 2] = i14;
  i18 = i17 + 788 + (i15 << 2) | 0;
  HEAP32[i18 >> 2] = i4;
  i18 = i17 + 852 + i15 | 0;
  HEAP8[i18 >> 0] = i3;
  STACKTOP = i16;
  return 1;
 }
 i32 = i17 + 880 | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 20 | 0, HEAP32[i17 + 788 >> 2] | 0, HEAP8[i17 + 852 >> 0] | 0, i17 + 596 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 56 | 0, HEAP32[i17 + 792 >> 2] | 0, HEAP8[i17 + 853 >> 0] | 0, i17 + 608 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 92 | 0, HEAP32[i17 + 796 >> 2] | 0, HEAP8[i17 + 854 >> 0] | 0, i17 + 620 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 128 | 0, HEAP32[i17 + 800 >> 2] | 0, HEAP8[i17 + 855 >> 0] | 0, i17 + 632 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 164 | 0, HEAP32[i17 + 804 >> 2] | 0, HEAP8[i17 + 856 >> 0] | 0, i17 + 644 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 200 | 0, HEAP32[i17 + 808 >> 2] | 0, HEAP8[i17 + 857 >> 0] | 0, i17 + 656 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 236 | 0, HEAP32[i17 + 812 >> 2] | 0, HEAP8[i17 + 858 >> 0] | 0, i17 + 668 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 272 | 0, HEAP32[i17 + 816 >> 2] | 0, HEAP8[i17 + 859 >> 0] | 0, i17 + 680 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 308 | 0, HEAP32[i17 + 820 >> 2] | 0, HEAP8[i17 + 860 >> 0] | 0, i17 + 692 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 344 | 0, HEAP32[i17 + 824 >> 2] | 0, HEAP8[i17 + 861 >> 0] | 0, i17 + 704 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 380 | 0, HEAP32[i17 + 828 >> 2] | 0, HEAP8[i17 + 862 >> 0] | 0, i17 + 716 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 416 | 0, HEAP32[i17 + 832 >> 2] | 0, HEAP8[i17 + 863 >> 0] | 0, i17 + 728 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 452 | 0, HEAP32[i17 + 836 >> 2] | 0, HEAP8[i17 + 864 >> 0] | 0, i17 + 740 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 488 | 0, HEAP32[i17 + 840 >> 2] | 0, HEAP8[i17 + 865 >> 0] | 0, i17 + 752 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 524 | 0, HEAP32[i17 + 844 >> 2] | 0, HEAP8[i17 + 866 >> 0] | 0, i17 + 764 | 0) | 0;
 __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i32, i17 + 560 | 0, HEAP32[i17 + 848 >> 2] | 0, HEAP8[i17 + 867 >> 0] | 0, i17 + 776 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i32 = 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i15 + 4 >> 2] | 0;
 i31 = HEAP32[i15 + 8 >> 2] | 0;
 i8 = HEAP32[i15 + 12 >> 2] | 0;
 i9 = HEAP32[i15 + 16 >> 2] | 0;
 i13 = HEAP32[i15 + 20 >> 2] | 0;
 i10 = HEAP32[i15 + 24 >> 2] | 0;
 i11 = HEAP32[i15 + 28 >> 2] | 0;
 i12 = HEAP32[i15 + 32 >> 2] | 0;
 i14 = i32 + 1 | 0;
 HEAP32[i1 >> 2] = i14;
 i14 = i32 * 3 | 0;
 i15 = i17 + 20 + (i14 * 12 | 0) | 0;
 HEAP32[i15 >> 2] = i6;
 i15 = i17 + 20 + (i14 * 12 | 0) + 4 | 0;
 HEAP32[i15 >> 2] = i7;
 i15 = i17 + 20 + (i14 * 12 | 0) + 8 | 0;
 HEAP32[i15 >> 2] = i31;
 i15 = i14 + 1 | 0;
 i31 = i17 + 20 + (i15 * 12 | 0) | 0;
 HEAP32[i31 >> 2] = i8;
 i31 = i17 + 20 + (i15 * 12 | 0) + 4 | 0;
 HEAP32[i31 >> 2] = i9;
 i31 = i17 + 20 + (i15 * 12 | 0) + 8 | 0;
 HEAP32[i31 >> 2] = i13;
 i31 = i14 + 2 | 0;
 i13 = i17 + 20 + (i31 * 12 | 0) | 0;
 HEAP32[i13 >> 2] = i10;
 i13 = i17 + 20 + (i31 * 12 | 0) + 4 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i17 + 20 + (i31 * 12 | 0) + 8 | 0;
 HEAP32[i13 >> 2] = i12;
 i13 = HEAP32[i18 >> 2] | 0;
 i14 = i17 + 596 + (i14 << 2) | 0;
 HEAP32[i14 >> 2] = i13;
 i14 = i18 + 4 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = i17 + 596 + (i15 << 2) | 0;
 HEAP32[i15 >> 2] = i14;
 i18 = i18 + 8 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i31 = i17 + 596 + (i31 << 2) | 0;
 HEAP32[i31 >> 2] = i18;
 i31 = i17 + 788 + (i32 << 2) | 0;
 HEAP32[i31 >> 2] = i4;
 i32 = i17 + 852 + i32 | 0;
 HEAP8[i32 >> 0] = i3;
 STACKTOP = i16;
 return 1;
}

function __ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_(i15, i1, i4) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i18 = HEAP32[i1 + 8 >> 2] | 0;
 i14 = HEAP32[i1 + 12 >> 2] | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = HEAP32[i4 + 8 >> 2] | 0;
 i10 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i15 + 1196 >> 2] | 0;
 if (!i1) {
  i23 = 1;
  return i23 | 0;
 }
 i4 = i15 + 1228 | 0;
 f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = f6 > Math_fround(HEAPF32[i15 + 1332 >> 2]);
 f6 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = f6 > Math_fround(HEAPF32[i15 + 1336 >> 2]);
 f6 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f6 > Math_fround(HEAPF32[i15 + 1340 >> 2]);
 f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i22 = f6 > Math_fround(HEAPF32[i15 + 1344 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 1316 >> 2]);
 i19 = f6 > (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i15 + 1320 >> 2]);
 i20 = f6 > (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i15 + 1324 >> 2]);
 i21 = f6 > (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i15 + 1328 >> 2]);
 i19 = i7 | i19;
 i20 = i8 | i20;
 i21 = i9 | i21;
 i22 = i22 | f6 > (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 | 0) > 3) {
  i7 = i1 + -4 | 0;
  i8 = i7 & -4;
  i9 = i8 + 4 | 0;
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  while (1) {
   i37 = HEAP32[i4 >> 2] | 0;
   i36 = HEAP32[i4 + 4 >> 2] | 0;
   i35 = HEAP32[i4 + 8 >> 2] | 0;
   i30 = HEAP32[i4 + 12 >> 2] | 0;
   i38 = HEAP32[i15 + 832 + (i37 << 4) >> 2] | 0;
   i32 = HEAP32[i15 + 832 + (i37 << 4) + 4 >> 2] | 0;
   i33 = HEAP32[i15 + 832 + (i37 << 4) + 8 >> 2] | 0;
   i34 = HEAP32[i15 + 832 + (i37 << 4) + 12 >> 2] | 0;
   f28 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i38 | i38 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i37 << 4) >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i32 | i32 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i15 + 480 + (i37 << 4) + 4 >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i33 | i33 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i15 + 480 + (i37 << 4) + 8 >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i34 | i34 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(Math_fround(f26 * Math_fround(HEAPF32[i15 + 480 + (i37 << 4) + 12 >> 2])) + Math_fround(f25 + Math_fround(f28 + f27)));
   i37 = HEAP32[i15 + 832 + (i36 << 4) >> 2] | 0;
   i34 = HEAP32[i15 + 832 + (i36 << 4) + 4 >> 2] | 0;
   i33 = HEAP32[i15 + 832 + (i36 << 4) + 8 >> 2] | 0;
   i32 = HEAP32[i15 + 832 + (i36 << 4) + 12 >> 2] | 0;
   f28 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i37 | i37 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i36 << 4) >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i34 | i34 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i15 + 480 + (i36 << 4) + 4 >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i33 | i33 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i15 + 480 + (i36 << 4) + 8 >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i32 | i32 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(Math_fround(f24 * Math_fround(HEAPF32[i15 + 480 + (i36 << 4) + 12 >> 2])) + Math_fround(f26 + Math_fround(f28 + f25)));
   i36 = HEAP32[i15 + 832 + (i35 << 4) >> 2] | 0;
   i32 = HEAP32[i15 + 832 + (i35 << 4) + 4 >> 2] | 0;
   i33 = HEAP32[i15 + 832 + (i35 << 4) + 8 >> 2] | 0;
   i34 = HEAP32[i15 + 832 + (i35 << 4) + 12 >> 2] | 0;
   f28 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i36 | i36 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i35 << 4) >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i32 | i32 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i15 + 480 + (i35 << 4) + 4 >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i33 | i33 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i15 + 480 + (i35 << 4) + 8 >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i34 | i34 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i15 + 480 + (i35 << 4) + 12 >> 2])) + Math_fround(f24 + Math_fround(f28 + f26)));
   i35 = HEAP32[i15 + 832 + (i30 << 4) >> 2] | 0;
   i34 = HEAP32[i15 + 832 + (i30 << 4) + 4 >> 2] | 0;
   i33 = HEAP32[i15 + 832 + (i30 << 4) + 8 >> 2] | 0;
   i32 = HEAP32[i15 + 832 + (i30 << 4) + 12 >> 2] | 0;
   f28 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i35 | i35 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i30 << 4) >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i34 | i34 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i15 + 480 + (i30 << 4) + 4 >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i33 | i33 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f29 * Math_fround(HEAPF32[i15 + 480 + (i30 << 4) + 8 >> 2]));
   f31 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i32 | i32 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(Math_fround(f31 * Math_fround(HEAPF32[i15 + 480 + (i30 << 4) + 12 >> 2])) + Math_fround(f29 + Math_fround(f28 + f24)));
   f25 = f27 <= f25 ? f27 : f25;
   f24 = f26 <= f24 ? f26 : f24;
   f24 = f25 <= f24 ? f25 : f24;
   f6 = f6 <= f24 ? f6 : f24;
   f5 = f5 <= f24 ? f5 : f24;
   f3 = f3 <= f24 ? f3 : f24;
   f2 = f2 <= f24 ? f2 : f24;
   i1 = i1 + -4 | 0;
   if ((i1 | 0) <= 3) break; else i4 = i4 + 16 | 0;
  }
  i1 = i7 - i8 | 0;
  i4 = i15 + 1228 + (i9 << 2) | 0;
 } else {
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 switch (i1 | 0) {
 case 3:
  {
   i23 = HEAP32[i4 >> 2] | 0;
   i35 = HEAP32[i15 + 832 + (i23 << 4) >> 2] | 0;
   i36 = HEAP32[i15 + 832 + (i23 << 4) + 4 >> 2] | 0;
   i37 = HEAP32[i15 + 832 + (i23 << 4) + 8 >> 2] | 0;
   i38 = HEAP32[i15 + 832 + (i23 << 4) + 12 >> 2] | 0;
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 & ~i35 | i35 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i15 + 480 + (i23 << 4) >> 2]));
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17 & ~i36 | i36 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i15 + 480 + (i23 << 4) + 4 >> 2]));
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18 & ~i37 | i37 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i15 + 480 + (i23 << 4) + 8 >> 2]));
   f31 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i14 & ~i38 | i38 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i15 + 480 + (i23 << 4) + 12 >> 2])) + Math_fround(f28 + Math_fround(f29 + f31)));
   i4 = i4 + 4 | 0;
   f6 = f6 <= f31 ? f6 : f31;
   f5 = f5 <= f31 ? f5 : f31;
   f3 = f3 <= f31 ? f3 : f31;
   f2 = f2 <= f31 ? f2 : f31;
   i23 = 8;
   break;
  }
 case 2:
  {
   i23 = 8;
   break;
  }
 case 1:
  {
   i23 = 9;
   break;
  }
 default:
  {}
 }
 if ((i23 | 0) == 8) {
  i38 = HEAP32[i4 >> 2] | 0;
  i34 = HEAP32[i15 + 832 + (i38 << 4) >> 2] | 0;
  i35 = HEAP32[i15 + 832 + (i38 << 4) + 4 >> 2] | 0;
  i36 = HEAP32[i15 + 832 + (i38 << 4) + 8 >> 2] | 0;
  i37 = HEAP32[i15 + 832 + (i38 << 4) + 12 >> 2] | 0;
  f29 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i34 | i34 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) >> 2]));
  f31 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i35 | i35 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 4 >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i36 | i36 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 8 >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i37 | i37 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 12 >> 2])) + Math_fround(f28 + Math_fround(f29 + f31)));
  i4 = i4 + 4 | 0;
  f6 = f6 <= f31 ? f6 : f31;
  f5 = f5 <= f31 ? f5 : f31;
  f3 = f3 <= f31 ? f3 : f31;
  f2 = f2 <= f31 ? f2 : f31;
  i23 = 9;
 }
 if ((i23 | 0) == 9) {
  i38 = HEAP32[i4 >> 2] | 0;
  i34 = HEAP32[i15 + 832 + (i38 << 4) >> 2] | 0;
  i35 = HEAP32[i15 + 832 + (i38 << 4) + 4 >> 2] | 0;
  i36 = HEAP32[i15 + 832 + (i38 << 4) + 8 >> 2] | 0;
  i37 = HEAP32[i15 + 832 + (i38 << 4) + 12 >> 2] | 0;
  f29 = (HEAP32[tempDoublePtr >> 2] = i16 & ~i34 | i34 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) >> 2]));
  f31 = (HEAP32[tempDoublePtr >> 2] = i17 & ~i35 | i35 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 4 >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i18 & ~i36 | i36 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 8 >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i37 | i37 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i15 + 480 + (i38 << 4) + 12 >> 2])) + Math_fround(f28 + Math_fround(f29 + f31)));
  f6 = f6 <= f31 ? f6 : f31;
  f5 = f5 <= f31 ? f5 : f31;
  f3 = f3 <= f31 ? f3 : f31;
  f2 = f2 <= f31 ? f2 : f31;
 }
 if (i19 | f6 < Math_fround(0.0) | (i20 | f5 < Math_fround(0.0)) | (i21 | f3 < Math_fround(0.0))) {
  i38 = 0;
  return i38 | 0;
 }
 i38 = (i22 | f2 < Math_fround(0.0)) ^ 1;
 return i38 | 0;
}

function __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i38, i5, i4, i6, i1) {
 i38 = i38 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, f37 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i42 + 76 | 0;
 i8 = i42 + 72 | 0;
 i32 = i42 + 48 | 0;
 i36 = i42 + 24 | 0;
 i40 = i42;
 i41 = i38 + 60 | 0;
 HEAP32[i41 >> 2] = 0;
 f39 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f39 = Math_fround(f39 + Math_fround(HEAPF32[i6 + 8 >> 2]));
 HEAP32[i7 >> 2] = 0;
 f2 = Math_fround(__ZL19b2FindMaxSeparationPiPK14b2PolygonShapeRK11b2TransformS2_S5_(i7, i5, i4, i6, i1));
 if (f2 > f39) {
  STACKTOP = i42;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 f3 = Math_fround(__ZL19b2FindMaxSeparationPiPK14b2PolygonShapeRK11b2TransformS2_S5_(i8, i6, i1, i5, i4));
 if (!(f3 > f39)) {
  i33 = f3 > Math_fround(f2 + Math_fround(.000500000024));
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f2 = Math_fround(HEAPF32[i4 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  if (i33) {
   i24 = i6;
   i7 = i8;
   i33 = 1;
   i1 = 2;
   f37 = f2;
   f2 = f3;
   f35 = f13;
   f29 = f10;
   f27 = f12;
   f34 = f11;
   f13 = f14;
  } else {
   i24 = i5;
   i5 = i6;
   i33 = 0;
   i1 = 1;
   f37 = f3;
   f35 = f14;
   f29 = f9;
   f9 = f10;
   f27 = f11;
   f34 = f12;
  }
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i38 + 56 >> 2] = i1;
  i7 = HEAP32[i5 + 148 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i24 + 84 + (i8 << 3) >> 2]);
  f11 = Math_fround(f29 * f10);
  f31 = Math_fround(HEAPF32[i24 + 84 + (i8 << 3) + 4 >> 2]);
  f11 = Math_fround(f11 - Math_fround(f13 * f31));
  f31 = Math_fround(Math_fround(f13 * f10) + Math_fround(f29 * f31));
  f10 = Math_fround(Math_fround(f9 * f11) + Math_fround(f35 * f31));
  f11 = Math_fround(Math_fround(f9 * f31) - Math_fround(f35 * f11));
  if ((i7 | 0) > 0) {
   f3 = Math_fround(3402823469999999843913219.0e14);
   i4 = 0;
   i1 = 0;
   while (1) {
    f12 = Math_fround(f10 * Math_fround(HEAPF32[i5 + 84 + (i4 << 3) >> 2]));
    f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i5 + 84 + (i4 << 3) + 4 >> 2])));
    i6 = !(f12 <= f3);
    i1 = i6 ? i1 : i4;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i7 | 0)) break; else f3 = i6 ? f3 : f12;
   }
  } else i1 = 0;
  i4 = i1 + 1 | 0;
  i4 = (i4 | 0) < (i7 | 0) ? i4 : 0;
  f12 = Math_fround(HEAPF32[i5 + 20 + (i1 << 3) >> 2]);
  f20 = Math_fround(f9 * f12);
  f21 = Math_fround(HEAPF32[i5 + 20 + (i1 << 3) + 4 >> 2]);
  f20 = Math_fround(f37 + Math_fround(f20 - Math_fround(f35 * f21)));
  f21 = Math_fround(f34 + Math_fround(Math_fround(f35 * f12) + Math_fround(f9 * f21)));
  HEAPF32[i32 >> 2] = f20;
  HEAPF32[i32 + 4 >> 2] = f21;
  i7 = i8 & 255;
  i43 = i32 + 8 | 0;
  HEAP8[i43 >> 0] = i7;
  i6 = i1 & 255;
  HEAP8[i43 + 1 >> 0] = i6;
  HEAP8[i43 + 2 >> 0] = 1;
  HEAP8[i43 + 3 >> 0] = 0;
  f12 = Math_fround(HEAPF32[i5 + 20 + (i4 << 3) >> 2]);
  f17 = Math_fround(f9 * f12);
  f18 = Math_fround(HEAPF32[i5 + 20 + (i4 << 3) + 4 >> 2]);
  f17 = Math_fround(f37 + Math_fround(f17 - Math_fround(f35 * f18)));
  f18 = Math_fround(f34 + Math_fround(Math_fround(f35 * f12) + Math_fround(f9 * f18)));
  HEAPF32[i32 + 12 >> 2] = f17;
  HEAPF32[i32 + 16 >> 2] = f18;
  i5 = i32 + 20 | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP8[i5 + 1 >> 0] = i4;
  HEAP8[i5 + 2 >> 0] = 1;
  HEAP8[i5 + 3 >> 0] = 0;
  i5 = i8 + 1 | 0;
  i5 = (i5 | 0) < (HEAP32[i24 + 148 >> 2] | 0) ? i5 : 0;
  f12 = Math_fround(HEAPF32[i24 + 20 + (i8 << 3) >> 2]);
  f14 = Math_fround(HEAPF32[i24 + 20 + (i8 << 3) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i24 + 20 + (i5 << 3) >> 2]);
  f15 = Math_fround(HEAPF32[i24 + 20 + (i5 << 3) + 4 >> 2]);
  f3 = Math_fround(f16 - f12);
  f11 = Math_fround(f15 - f14);
  f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f11 * f11))));
  if (f10 < Math_fround(1.1920929e-07)) f25 = f11; else {
   f25 = Math_fround(Math_fround(1.0) / f10);
   f3 = Math_fround(f3 * f25);
   f25 = Math_fround(f11 * f25);
  }
  f26 = Math_fround(Math_fround(f12 + f16) * Math_fround(.5));
  f19 = Math_fround(Math_fround(f29 * f3) - Math_fround(f13 * f25));
  f30 = Math_fround(Math_fround(f13 * f3) + Math_fround(f29 * f25));
  f31 = Math_fround(-f19);
  f11 = Math_fround(f2 + Math_fround(Math_fround(f29 * f12) - Math_fround(f13 * f14)));
  f12 = Math_fround(f27 + Math_fround(Math_fround(f13 * f12) + Math_fround(f29 * f14)));
  f23 = Math_fround(-f3);
  f22 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
  f28 = Math_fround(Math_fround(f11 * f30) + Math_fround(f12 * f31));
  f3 = Math_fround(f39 - Math_fround(Math_fround(f11 * f19) + Math_fround(f12 * f30)));
  f14 = Math_fround(f39 + Math_fround(Math_fround(Math_fround(f2 + Math_fround(Math_fround(f29 * f16) - Math_fround(f13 * f15))) * f19) + Math_fround(Math_fround(f27 + Math_fround(Math_fround(f13 * f16) + Math_fround(f29 * f15))) * f30)));
  f29 = Math_fround(-f30);
  f2 = Math_fround(Math_fround(Math_fround(f20 * f31) + Math_fround(f21 * f29)) - f3);
  i4 = i32 + 12 | 0;
  f3 = Math_fround(Math_fround(Math_fround(f17 * f31) + Math_fround(f18 * f29)) - f3);
  if (!(f2 <= Math_fround(0.0))) i1 = 0; else {
   HEAP32[i36 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
   i1 = 1;
  }
  if (f3 <= Math_fround(0.0)) {
   i43 = i36 + (i1 * 12 | 0) | 0;
   HEAP32[i43 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i43 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i43 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i1 = i1 + 1 | 0;
  }
  if (Math_fround(f2 * f3) < Math_fround(0.0)) {
   f27 = Math_fround(f2 / Math_fround(f2 - f3));
   f29 = Math_fround(f21 + Math_fround(f27 * Math_fround(f18 - f21)));
   HEAPF32[i36 + (i1 * 12 | 0) >> 2] = Math_fround(f20 + Math_fround(f27 * Math_fround(f17 - f20)));
   HEAPF32[i36 + (i1 * 12 | 0) + 4 >> 2] = f29;
   i43 = i36 + (i1 * 12 | 0) + 8 | 0;
   HEAP8[i43 >> 0] = i7;
   HEAP8[i43 + 1 >> 0] = i6;
   HEAP8[i43 + 2 >> 0] = 0;
   HEAP8[i43 + 3 >> 0] = 1;
   i1 = i1 + 1 | 0;
  }
  if ((i1 | 0) >= 2) {
   f10 = Math_fround(HEAPF32[i36 >> 2]);
   f12 = Math_fround(f19 * f10);
   f11 = Math_fround(HEAPF32[i36 + 4 >> 2]);
   f12 = Math_fround(Math_fround(f12 + Math_fround(f30 * f11)) - f14);
   i4 = i36 + 12 | 0;
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   f2 = Math_fround(f19 * f13);
   f3 = Math_fround(HEAPF32[i36 + 16 >> 2]);
   f2 = Math_fround(Math_fround(f2 + Math_fround(f30 * f3)) - f14);
   if (!(f12 <= Math_fround(0.0))) i1 = 0; else {
    HEAP32[i40 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i40 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i40 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    i1 = 1;
   }
   if (f2 <= Math_fround(0.0)) {
    i43 = i40 + (i1 * 12 | 0) | 0;
    HEAP32[i43 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i43 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i43 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   if (Math_fround(f12 * f2) < Math_fround(0.0)) {
    f27 = Math_fround(f12 / Math_fround(f12 - f2));
    f29 = Math_fround(f11 + Math_fround(f27 * Math_fround(f3 - f11)));
    HEAPF32[i40 + (i1 * 12 | 0) >> 2] = Math_fround(f10 + Math_fround(f27 * Math_fround(f13 - f10)));
    HEAPF32[i40 + (i1 * 12 | 0) + 4 >> 2] = f29;
    i43 = i40 + (i1 * 12 | 0) + 8 | 0;
    HEAP8[i43 >> 0] = i5;
    HEAP8[i43 + 1 >> 0] = HEAP8[i36 + 8 + 1 >> 0] | 0;
    HEAP8[i43 + 2 >> 0] = 0;
    HEAP8[i43 + 3 >> 0] = 1;
    i1 = i1 + 1 | 0;
   }
   if ((i1 | 0) >= 2) {
    HEAPF32[i38 + 40 >> 2] = f25;
    HEAPF32[i38 + 44 >> 2] = f23;
    HEAPF32[i38 + 48 >> 2] = f26;
    HEAPF32[i38 + 52 >> 2] = f22;
    f2 = Math_fround(HEAPF32[i40 >> 2]);
    f29 = Math_fround(f30 * f2);
    f3 = Math_fround(HEAPF32[i40 + 4 >> 2]);
    i1 = !(Math_fround(Math_fround(f29 + Math_fround(f3 * f31)) - f28) <= f39);
    if (!(i33 << 24 >> 24)) {
     if (i1) i1 = 0; else {
      f26 = Math_fround(f2 - f37);
      f27 = Math_fround(f3 - f34);
      f29 = Math_fround(Math_fround(f9 * f27) - Math_fround(f35 * f26));
      HEAPF32[i38 >> 2] = Math_fround(Math_fround(f9 * f26) + Math_fround(f35 * f27));
      HEAPF32[i38 + 4 >> 2] = f29;
      HEAP32[i38 + 16 >> 2] = HEAP32[i40 + 8 >> 2];
      i1 = 1;
     }
     f3 = Math_fround(HEAPF32[i40 + 12 >> 2]);
     f30 = Math_fround(f30 * f3);
     f2 = Math_fround(HEAPF32[i40 + 16 >> 2]);
     if (Math_fround(Math_fround(f30 + Math_fround(f2 * f31)) - f28) <= f39) {
      f31 = Math_fround(f3 - f37);
      f37 = Math_fround(f2 - f34);
      f39 = Math_fround(Math_fround(f9 * f37) - Math_fround(f35 * f31));
      HEAPF32[i38 + (i1 * 20 | 0) >> 2] = Math_fround(Math_fround(f9 * f31) + Math_fround(f35 * f37));
      HEAPF32[i38 + (i1 * 20 | 0) + 4 >> 2] = f39;
      HEAP32[i38 + (i1 * 20 | 0) + 16 >> 2] = HEAP32[i40 + 20 >> 2];
      i1 = i1 + 1 | 0;
     }
    } else {
     if (i1) i1 = 0; else {
      f26 = Math_fround(f2 - f37);
      f27 = Math_fround(f3 - f34);
      f29 = Math_fround(Math_fround(f9 * f27) - Math_fround(f35 * f26));
      HEAPF32[i38 >> 2] = Math_fround(Math_fround(f9 * f26) + Math_fround(f35 * f27));
      HEAPF32[i38 + 4 >> 2] = f29;
      i1 = i38 + 16 | 0;
      i43 = HEAP32[i40 + 8 >> 2] | 0;
      HEAP8[i1 >> 0] = i43 >>> 8;
      HEAP8[i1 + 1 >> 0] = i43;
      HEAP8[i1 + 2 >> 0] = i43 >>> 24;
      HEAP8[i1 + 3 >> 0] = i43 >>> 16;
      i1 = 1;
     }
     f3 = Math_fround(HEAPF32[i40 + 12 >> 2]);
     f30 = Math_fround(f30 * f3);
     f2 = Math_fround(HEAPF32[i40 + 16 >> 2]);
     if (Math_fround(Math_fround(f30 + Math_fround(f2 * f31)) - f28) <= f39) {
      f31 = Math_fround(f3 - f37);
      f37 = Math_fround(f2 - f34);
      f39 = Math_fround(Math_fround(f9 * f37) - Math_fround(f35 * f31));
      HEAPF32[i38 + (i1 * 20 | 0) >> 2] = Math_fround(Math_fround(f9 * f31) + Math_fround(f35 * f37));
      HEAPF32[i38 + (i1 * 20 | 0) + 4 >> 2] = f39;
      i43 = i38 + (i1 * 20 | 0) + 16 | 0;
      i40 = HEAP32[i40 + 20 >> 2] | 0;
      HEAP8[i43 >> 0] = i40 >>> 8;
      HEAP8[i43 + 1 >> 0] = i40;
      HEAP8[i43 + 2 >> 0] = i40 >>> 24;
      HEAP8[i43 + 3 >> 0] = i40 >>> 16;
      i1 = i1 + 1 | 0;
     }
    }
    HEAP32[i41 >> 2] = i1;
   }
  }
 }
 STACKTOP = i42;
 return;
}

function __ZNK14dtNavMeshQuery19getPolyWallSegmentsEyPK13dtQueryFilterPfPyPii(i1, i2, i3, i4, i30, i31, i34, i32) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i34 = i34 | 0;
 i32 = i32 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i33 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i35;
 if ((i2 & 983040 | 0) == 65536 & 0 == 0) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == 0 & (i3 | 0) == 0) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 i5 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i29 = i2 & 65535;
 if (i5 >>> 0 >= (HEAP32[i6 + 16 >> 2] | 0) >>> 0) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 i26 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
 getTempRet0() | 0;
 i27 = i6 + 20 | 0;
 i2 = HEAP32[i27 >> 2] | 0;
 if ((HEAP32[i2 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i26 | 0)) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 i1 = HEAP32[i2 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i1) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 if (i29 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
  i34 = -2147483640;
  STACKTOP = i35;
  return i34 | 0;
 }
 i22 = HEAP32[i2 + (i5 * 56 | 0) + 16 >> 2] | 0;
 i23 = (i31 | 0) != 0;
 i24 = i22 + (i29 << 5) + 28 | 0;
 i3 = HEAP8[i24 >> 0] | 0;
 if (!(i3 << 24 >> 24)) {
  i2 = 0;
  i1 = 1073741824;
 } else {
  i25 = i2 + (i5 * 56 | 0) + 20 | 0;
  i26 = i2 + (i5 * 56 | 0) + 16 | 0;
  i18 = i4 + 128 | 0;
  i19 = i2 + (i5 * 56 | 0) | 0;
  i20 = i2 + (i5 * 56 | 0) + 4 | 0;
  i21 = i22 + (i29 << 5) | 0;
  i15 = i2 + (i5 * 56 | 0) + 12 | 0;
  i16 = i6 + 36 | 0;
  i17 = i6 + 36 | 0;
  i14 = i6 + 20 | 0;
  i2 = 0;
  i1 = 1073741824;
  i13 = 0;
  i12 = (i3 & 255) + -1 | 0;
  while (1) {
   i3 = HEAP16[i22 + (i29 << 5) + 12 + (i12 << 1) >> 1] | 0;
   i4 = i3 & 65535;
   do if (!(i4 & 32768)) {
    if (!(i3 << 16 >> 16)) {
     i5 = 0;
     i3 = 0;
    } else {
     i4 = i4 + -1 | 0;
     i11 = (i19 - (HEAP32[i27 >> 2] | 0) | 0) / 56 | 0;
     i5 = _bitshift64Shl(HEAP32[i20 >> 2] | 0, 0, 48) | 0;
     i3 = getTempRet0() | 0;
     i11 = _bitshift64Shl(i11 | 0, 0, 20) | 0;
     i3 = getTempRet0() | 0 | i3;
     i5 = i11 | i5 | i4;
     if (!i23) if ((i5 | 0) == 0 & (i3 | 0) == 0 | (HEAP32[i18 >> 2] & HEAP32[(HEAP32[i26 >> 2] | 0) + (i4 << 5) + 24 >> 2] | 0) == 0) {
      i5 = 0;
      i3 = 0;
     } else break;
    }
    if ((i2 | 0) >= (i32 | 0)) {
     i1 = i1 | 16;
     break;
    }
    i11 = HEAP32[i25 >> 2] | 0;
    i10 = i11 + ((HEAPU16[i22 + (i29 << 5) + (i12 << 1) >> 1] | 0) * 3 << 2) | 0;
    i11 = i11 + ((HEAPU16[i22 + (i29 << 5) + (i13 << 1) >> 1] | 0) * 3 << 2) | 0;
    i12 = i30 + (i2 * 6 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i12 = i12 + 12 | 0;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    if (i23) {
     i12 = i31 + (i2 << 3) | 0;
     HEAP32[i12 >> 2] = i5;
     HEAP32[i12 + 4 >> 2] = i3;
    }
    i2 = i2 + 1 | 0;
   } else {
    i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i21 - (HEAP32[i26 >> 2] | 0) >> 5 << 2) >> 2] | 0;
    L36 : do if ((i3 | 0) == -1) {
     i3 = 0;
     i6 = 0;
     i28 = 17;
    } else {
     i3 = (HEAP32[i16 >> 2] | 0) + (i3 << 4) | 0;
     if (!i3) {
      i3 = 0;
      i6 = 0;
      i28 = 17;
     } else {
      i5 = 0;
      do {
       i11 = HEAP32[i3 + 12 >> 2] | 0;
       i4 = i11 >>> 16;
       i8 = i11 >>> 24;
       do if ((i11 & 255 | 0) == (i12 | 0)) {
        i11 = i3;
        i10 = HEAP32[i11 >> 2] | 0;
        i11 = HEAP32[i11 + 4 >> 2] | 0;
        if (!((i10 | 0) == 0 & (i11 | 0) == 0 | (i10 & 983040 | 0) == 65536 & 0 == 0)) {
         i7 = _bitshift64Lshr(i10 | 0, i11 | 0, 20) | 0;
         getTempRet0() | 0;
         i6 = i10 & 65535;
         i7 = HEAP32[(HEAP32[i14 >> 2] | 0) + ((i7 & 268435455) * 56 | 0) + 16 >> 2] | 0;
         if (i7 + (i6 << 5) | 0) if (HEAP32[i18 >> 2] & HEAP32[i7 + (i6 << 5) + 24 >> 2]) {
          i9 = i4 & 255;
          i8 = i8 & 65535;
          if ((i5 | 0) > 15) break;
          L46 : do if ((i5 | 0) > 0) {
           i4 = 0;
           do {
            if ((HEAP16[i33 + (i4 << 4) + 8 >> 1] | 0) >= i8 << 16 >> 16) break L46;
            i4 = i4 + 1 | 0;
           } while ((i4 | 0) < (i5 | 0));
          } else i4 = 0; while (0);
          i6 = i5 - i4 | 0;
          i7 = i33 + (i4 << 4) | 0;
          if (i6 | 0) _memmove(i7 + 16 | 0, i7 | 0, i6 << 4 | 0) | 0;
          i7 = i33 + (i4 << 4) | 0;
          HEAP32[i7 >> 2] = i10;
          HEAP32[i7 + 4 >> 2] = i11;
          HEAP16[i33 + (i4 << 4) + 8 >> 1] = i9;
          HEAP16[i33 + (i4 << 4) + 10 >> 1] = i8;
          i5 = i5 + 1 | 0;
         }
        }
       } while (0);
       i3 = HEAP32[i3 + 8 >> 2] | 0;
       if ((i3 | 0) == -1) break;
       i3 = (HEAP32[i17 >> 2] | 0) + (i3 << 4) | 0;
      } while ((i3 | 0) != 0);
      if ((i5 | 0) <= 15) if ((i5 | 0) > 0) {
       i3 = 0;
       while (1) {
        if ((HEAP16[i33 + (i3 << 4) + 8 >> 1] | 0) >= 0) {
         i6 = i5;
         i28 = 17;
         break L36;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) >= (i5 | 0)) {
         i6 = i5;
         i28 = 17;
         break;
        }
       }
      } else {
       i3 = 0;
       i6 = i5;
       i28 = 17;
      }
     }
    } while (0);
    if ((i28 | 0) == 17) {
     i28 = 0;
     i4 = i6 - i3 | 0;
     i5 = i33 + (i3 << 4) | 0;
     if (i4 | 0) _memmove(i5 + 16 | 0, i5 | 0, i4 << 4 | 0) | 0;
     i5 = i33 + (i3 << 4) | 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i5 + 4 >> 2] = 0;
     HEAP16[i33 + (i3 << 4) + 8 >> 1] = -1;
     HEAP16[i33 + (i3 << 4) + 10 >> 1] = 0;
     i5 = i6 + 1 | 0;
     if ((i6 | 0) <= 14) {
      L67 : do if ((i6 | 0) > -1) {
       i3 = 0;
       while (1) {
        if ((HEAP16[i33 + (i3 << 4) + 8 >> 1] | 0) >= 256) break L67;
        i4 = i3 + 1 | 0;
        if ((i3 | 0) < (i6 | 0)) i3 = i4; else {
         i3 = i4;
         break;
        }
       }
      } else i3 = 0; while (0);
      i5 = i5 - i3 | 0;
      i4 = i33 + (i3 << 4) | 0;
      if (i5 | 0) _memmove(i4 + 16 | 0, i4 | 0, i5 << 4 | 0) | 0;
      i5 = i33 + (i3 << 4) | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i5 + 4 >> 2] = 0;
      HEAP16[i33 + (i3 << 4) + 8 >> 1] = 255;
      HEAP16[i33 + (i3 << 4) + 10 >> 1] = 256;
      i5 = i6 + 2 | 0;
     }
    }
    i8 = HEAP32[i25 >> 2] | 0;
    i7 = i8 + ((HEAPU16[i22 + (i29 << 5) + (i12 << 1) >> 1] | 0) * 3 << 2) | 0;
    i8 = i8 + ((HEAPU16[i22 + (i29 << 5) + (i13 << 1) >> 1] | 0) * 3 << 2) | 0;
    if ((i5 | 0) > 1) {
     i9 = i7 + 4 | 0;
     i10 = i8 + 4 | 0;
     i11 = i7 + 8 | 0;
     i12 = i8 + 8 | 0;
     i6 = 1;
     do {
      do if (i23) {
       i4 = i33 + (i6 << 4) | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       i4 = HEAP32[i4 + 4 >> 2] | 0;
       if (!((i3 | 0) == 0 & (i4 | 0) == 0)) if ((i2 | 0) < (i32 | 0)) {
        f38 = Math_fround(Math_fround(HEAP16[i33 + (i6 << 4) + 10 >> 1] | 0) / Math_fround(255.0));
        f39 = Math_fround(Math_fround(HEAP16[i33 + (i6 << 4) + 8 >> 1] | 0) / Math_fround(255.0));
        i36 = i30 + (i2 * 6 << 2) | 0;
        f37 = Math_fround(HEAPF32[i7 >> 2]);
        HEAPF32[i36 >> 2] = Math_fround(f37 + Math_fround(f39 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f37)));
        f37 = Math_fround(HEAPF32[i9 >> 2]);
        HEAPF32[i36 + 4 >> 2] = Math_fround(f37 + Math_fround(f39 * Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f37)));
        f37 = Math_fround(HEAPF32[i11 >> 2]);
        HEAPF32[i36 + 8 >> 2] = Math_fround(f37 + Math_fround(f39 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f37)));
        i36 = i36 + 12 | 0;
        f37 = Math_fround(HEAPF32[i7 >> 2]);
        HEAPF32[i36 >> 2] = Math_fround(f37 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f37)));
        f37 = Math_fround(HEAPF32[i9 >> 2]);
        HEAPF32[i36 + 4 >> 2] = Math_fround(f37 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f37)));
        f37 = Math_fround(HEAPF32[i11 >> 2]);
        HEAPF32[i36 + 8 >> 2] = Math_fround(f37 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f37)));
        i36 = i31 + (i2 << 3) | 0;
        HEAP32[i36 >> 2] = i3;
        HEAP32[i36 + 4 >> 2] = i4;
        i2 = i2 + 1 | 0;
        break;
       } else {
        i1 = i1 | 16;
        break;
       }
      } while (0);
      i3 = HEAP16[i33 + (i6 + -1 << 4) + 10 >> 1] | 0;
      i4 = HEAP16[i33 + (i6 << 4) + 8 >> 1] | 0;
      do if (i3 << 16 >> 16 != i4 << 16 >> 16) {
       if ((i2 | 0) >= (i32 | 0)) {
        i1 = i1 | 16;
        break;
       }
       f38 = Math_fround(Math_fround(i4 << 16 >> 16) / Math_fround(255.0));
       f37 = Math_fround(Math_fround(i3 << 16 >> 16) / Math_fround(255.0));
       i36 = i30 + (i2 * 6 << 2) | 0;
       f39 = Math_fround(HEAPF32[i7 >> 2]);
       HEAPF32[i36 >> 2] = Math_fround(f39 + Math_fround(f37 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f39)));
       f39 = Math_fround(HEAPF32[i9 >> 2]);
       HEAPF32[i36 + 4 >> 2] = Math_fround(f39 + Math_fround(f37 * Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f39)));
       f39 = Math_fround(HEAPF32[i11 >> 2]);
       HEAPF32[i36 + 8 >> 2] = Math_fround(f39 + Math_fround(f37 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f39)));
       i36 = i36 + 12 | 0;
       f39 = Math_fround(HEAPF32[i7 >> 2]);
       HEAPF32[i36 >> 2] = Math_fround(f39 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f39)));
       f39 = Math_fround(HEAPF32[i9 >> 2]);
       HEAPF32[i36 + 4 >> 2] = Math_fround(f39 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f39)));
       f39 = Math_fround(HEAPF32[i11 >> 2]);
       HEAPF32[i36 + 8 >> 2] = Math_fround(f39 + Math_fround(f38 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f39)));
       if (i23) {
        i36 = i31 + (i2 << 3) | 0;
        HEAP32[i36 >> 2] = 0;
        HEAP32[i36 + 4 >> 2] = 0;
       }
       i2 = i2 + 1 | 0;
      } while (0);
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i5 | 0));
    }
   } while (0);
   i3 = i13 + 1 | 0;
   if ((i3 | 0) < (HEAPU8[i24 >> 0] | 0)) {
    i12 = i13;
    i13 = i3;
   } else break;
  }
 }
 HEAP32[i34 >> 2] = i2;
 i36 = i1;
 STACKTOP = i35;
 return i36 | 0;
}

function __ZN14ParticleSystem8TransferI14SafeBinaryReadEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i7, i8);
 i10 = i7 + 36 | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 284 >> 2] | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i8, 5);
 __ZN27ParticleSystemReadOnlyState8TransferI14SafeBinaryReadEEvRT_(HEAP32[i10 >> 2] | 0, i8);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i10 >> 2] | 0);
 i12 = i7 + 40 | 0;
 __ZN19ParticleSystemState8TransferI14SafeBinaryReadEEvRT_(HEAP32[i12 >> 2] | 0, i8);
 i9 = i7 + 44 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 618937 | 0, gb + 618937 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13InitialModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i9 >> 2] | 0);
 i3 = i7 + 48 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 618951 | 0, gb + 618951 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11ShapeModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN11ShapeModule16CheckConsistencyEv(i3);
 i3 = i7 + 264 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 618963 | 0, gb + 618963 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14EmissionModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN14EmissionModule16CheckConsistencyEv(i3);
 i3 = HEAP32[i7 + 852 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 618978 | 0, gb + 618978 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10SizeModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = HEAP32[i7 + 856 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 618989 | 0, gb + 618989 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14RotationModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = HEAP32[i7 + 860 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619004 | 0, gb + 619004 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11ColorModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i7 + 864 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619016 | 0, gb + 619016 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8UVModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = HEAP32[i7 + 868 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619025 | 0, gb + 619025 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14VelocityModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i5 = i7 + 872 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619040 | 0, gb + 619040 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN21InheritVelocityModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i5 >> 2] | 0);
 i3 = HEAP32[i7 + 876 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619062 | 0, gb + 619062 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11ForceModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = HEAP32[i7 + 880 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619074 | 0, gb + 619074 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN20ExternalForcesModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i7 + 884 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619095 | 0, gb + 619095 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19ClampVelocityModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 888 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619115 | 0, gb + 619115 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NoiseModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 892 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619127 | 0, gb + 619127 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17SizeBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 896 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619145 | 0, gb + 619145 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN21RotationBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 900 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619167 | 0, gb + 619167 | 0, i6, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18ColorBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 904 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619186 | 0, gb + 619186 | 0, i6, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN15CollisionModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 912 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619202 | 0, gb + 619202 | 0, i6, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN13TriggerModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = HEAP32[i7 + 916 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619216 | 0, gb + 619216 | 0, i6, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN9SubModule8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i7 + 920 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619226 | 0, gb + 619226 | 0, i6, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN12LightsModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i7 + 908 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619239 | 0, gb + 619239 | 0, i6, 1) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) __ZN11TrailModule8TransferI14SafeBinaryReadEEvRT_(i4, i8); else {
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) break;
   mftCall_iii(i2 | 0, i4 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i7 = __ZN14ParticleSystem27DetermineSupportsProceduralERKS_(i7) | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP8[i12 + 25 >> 0] = i7 & 1;
 HEAP8[i12 + 26 >> 0] = 1;
 i12 = i12 + 27 | 0;
 HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 0 | (i11 | 0) != (HEAP32[(HEAP32[i10 >> 2] | 0) + 284 >> 2] | 0);
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i8, 1) | 0)) {
  STACKTOP = i13;
  return;
 }
 f1 = Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 2544 >> 2]);
 if (!(f1 > Math_fround(0.0))) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i5 >> 2] | 0;
 HEAP8[i12 + 4 >> 0] = 1;
 HEAP16[i12 + 96 >> 1] = 0;
 HEAPF32[i12 + 92 >> 2] = f1;
 HEAP8[i12 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i12 + 12 | 0, i12 + 100 | 0, f1, 0) | 0) & 1;
 STACKTOP = i13;
 return;
}

function __ZN5physx34PxsSolverConstraintPostProcessTask13mergeContactsERNS_25PxsCompoundContactManagerERNS_16PxsThreadContextE(i48, i53, i50) {
 i48 = i48 | 0;
 i53 = i53 | 0;
 i50 = i50 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 1536 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i54 = i55 + 1216 | 0;
 i47 = i55 + 4 | 0;
 i49 = i55 + 1472 | 0;
 i52 = i55;
 i51 = i50 + 16 | 0;
 i1 = HEAP16[i53 + 4 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i12 = 0;
  i10 = 0;
 } else {
  i41 = i48 + 24 | 0;
  i42 = i47 + 4 | 0;
  i43 = i47 + 8 | 0;
  i44 = i47 + 36 | 0;
  i45 = i47 + 40 | 0;
  i46 = i47 + 44 | 0;
  i31 = i47 + 12 | 0;
  i32 = i47 + 60 | 0;
  i33 = i47 + 56 | 0;
  i34 = i47 + 64 | 0;
  i35 = i47 + 48 | 0;
  i36 = i47 + 52 | 0;
  i37 = i47 + 24 | 0;
  i38 = i47 + 28 | 0;
  i39 = i47 + 16 | 0;
  i40 = i47 + 32 | 0;
  i30 = HEAP32[i53 >> 2] | 0;
  i28 = i1 & 65535;
  i29 = 0;
  i1 = 0;
  i2 = 0;
  do {
   i27 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i41 >> 2] | 0) + 8976 >> 2] | 0) + (i30 + i29 << 2) >> 2] | 0) + 12 >> 2] | 0;
   i3 = HEAP32[i27 + 44 >> 2] | 0;
   i22 = HEAP32[i27 + 48 >> 2] | 0;
   HEAPF32[i47 >> 2] = Math_fround(0.0);
   HEAPF32[i42 >> 2] = Math_fround(0.0);
   HEAPF32[i43 >> 2] = Math_fround(0.0);
   HEAP32[i44 >> 2] = i22;
   HEAP32[i45 >> 2] = 0;
   HEAP32[i46 >> 2] = 0;
   HEAP32[i31 >> 2] = i3;
   if (!i22) {
    i23 = 0;
    i24 = 0;
    i5 = 0;
    i25 = 0;
    i26 = 0;
    i4 = 1;
   } else {
    i4 = HEAP16[i3 + 2 >> 1] | 0;
    i25 = i4 & 65535;
    i5 = i25 & 2;
    i26 = (i5 | 0) != 0;
    i25 = i25 & 1;
    i23 = i26 ? 4 : 32;
    i24 = i26 ? 72 : i25 << 3 | 16;
    i5 = i3 + (i5 << 3 | 4) | 0;
    i25 = (i25 | 0) != 0;
    i4 = (i4 & 4) != 0;
   }
   HEAP32[i32 >> 2] = i26 & 1;
   HEAP32[i33 >> 2] = i25 & 1;
   HEAP32[i34 >> 2] = i4 & 1;
   HEAP32[i35 >> 2] = i23;
   HEAP32[i36 >> 2] = i24;
   HEAP32[i37 >> 2] = i5;
   HEAP32[i38 >> 2] = i5;
   HEAP32[i39 >> 2] = i5;
   i6 = i5;
   if (!i4) {
    if ((i6 - i3 | 0) >>> 0 < i22 >>> 0) {
     i4 = i6;
     i8 = 0;
     i7 = 0;
     while (1) {
      HEAP32[i37 >> 2] = i5;
      if ((i6 - i3 | 0) >>> 0 < i22 >>> 0) {
       i8 = HEAPU16[i5 >> 1] | 0;
       HEAP32[i45 >> 2] = i8;
       i21 = i5 + ((Math_imul(i24, i8) | 0) + i23) | 0;
       HEAP32[i38 >> 2] = i21;
       i4 = i5 + i23 | 0;
       HEAP32[i39 >> 2] = i4;
       HEAP32[i46 >> 2] = 0;
       i7 = 0;
      } else {
       HEAP32[i38 >> 2] = i5;
       i21 = i5;
      }
      if (i7 >>> 0 < i8 >>> 0) {
       i15 = i5 + 20 | 0;
       i16 = i5 + 16 | 0;
       i17 = i5 + 24 | 0;
       i18 = i5 + 4 | 0;
       i19 = i5 + 28 | 0;
       i12 = i5 + 30 | 0;
       i5 = i7 + 1 | 0;
       i5 = i8 >>> 0 > i5 >>> 0 ? i8 : i5;
       i20 = i2 + i5 | 0;
       i14 = i7;
       while (1) {
        i14 = i14 + 1 | 0;
        HEAP32[i40 >> 2] = i4;
        i9 = i4 + i24 | 0;
        HEAP32[i39 >> 2] = i9;
        i11 = i4;
        HEAP32[i50 + 400 + (i2 << 6) + 56 >> 2] = HEAP32[(i26 ? i11 + 56 | 0 : i15) >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 44 >> 2] = HEAP32[(i26 ? i11 + 52 | 0 : i16) >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 60 >> 2] = HEAP32[(i26 ? i11 + 60 | 0 : i17) >> 2];
        i6 = i4;
        i10 = i4;
        if (i25) {
         HEAP32[i50 + 400 + (i2 << 6) + 48 >> 2] = HEAP32[i6 + 16 >> 2];
         i6 = HEAP32[i6 + 20 >> 2] | 0;
        } else {
         HEAP32[i50 + 400 + (i2 << 6) + 48 >> 2] = -1;
         i6 = -1;
        }
        HEAP32[i50 + 400 + (i2 << 6) + 52 >> 2] = i6;
        if (i26) f13 = Math_fround(HEAPF32[i11 + 48 >> 2]); else f13 = Math_fround(3402823469999999843913219.0e14);
        HEAPF32[i50 + 400 + (i2 << 6) + 28 >> 2] = f13;
        i6 = i26 ? i11 + 36 | 0 : i47;
        HEAP32[i50 + 400 + (i2 << 6) + 32 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 36 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 40 >> 2] = HEAP32[i6 + 8 >> 2];
        i6 = i26 ? i11 + 24 | 0 : i18;
        HEAP32[i50 + 400 + (i2 << 6) >> 2] = HEAP32[i6 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 16 >> 2] = HEAP32[i4 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 20 >> 2] = HEAP32[i10 + 4 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 24 >> 2] = HEAP32[i10 + 8 >> 2];
        HEAP32[i50 + 400 + (i2 << 6) + 12 >> 2] = HEAP32[i10 + 12 >> 2];
        HEAP16[i54 + (i2 << 2) >> 1] = HEAP16[(i26 ? i11 + 64 | 0 : i19) >> 1] | 0;
        HEAP16[i54 + (i2 << 2) + 2 >> 1] = HEAP16[(i26 ? i11 + 66 | 0 : i12) >> 1] | 0;
        if (i14 >>> 0 >= i8 >>> 0) {
         i2 = i9;
         break;
        } else {
         i4 = i9;
         i2 = i2 + 1 | 0;
        }
       }
       HEAP32[i46 >> 2] = i5;
       i4 = i2;
       i2 = i20 - i7 | 0;
      } else i5 = i7;
      i6 = i21;
      if ((i6 - i3 | 0) >>> 0 >= i22 >>> 0) break; else {
       i7 = i5;
       i5 = i21;
      }
     }
    }
    if (i1) i1 = 1; else i1 = (HEAP16[i27 + 114 >> 1] & 16) != 0;
   }
   i29 = i29 + 1 | 0;
  } while (i29 >>> 0 < i28 >>> 0);
  i12 = i1;
  i10 = i2;
 }
 i11 = i50 + 400 | 0;
 i1 = i47 + 168 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i47 + 1196 >> 2] = 0;
 HEAP32[i47 + 1200 >> 2] = i11;
 HEAP32[i47 + 1204 >> 2] = i54;
 HEAP32[i47 + 1208 >> 2] = i10;
 __ZN5physx19PxsContactReductionILj6EE14reduceContactsEv(i47);
 i2 = i49;
 i3 = i2 + 64 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i5 = HEAP32[i1 >> 2] | 0;
 if (!i5) i1 = 0; else {
  i6 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i47 + (i6 * 28 | 0) >> 2] | 0;
   if (i2) {
    i4 = i2 >>> 0 > 1 ? i2 : 1;
    i3 = 0;
    do {
     HEAP8[i49 + (HEAP32[i47 + (i6 * 28 | 0) + 4 + (i3 << 2) >> 2] | 0) >> 0] = 1;
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i2 >>> 0);
    i1 = i1 + i4 | 0;
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i5 >>> 0);
 }
 i8 = i50 + 332 | 0;
 i9 = i48 + 24 | 0;
 i7 = (HEAP32[i9 >> 2] | 0) + 316 | 0;
 i2 = (i1 << 1) + 15 & -16;
 do if (i2 >>> 0 > 16384) i2 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i8 >> 2] | 0, i2) | 0; else {
  i3 = i50 + 336 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = i50 + 340 | 0;
  if (i4 | 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i6 = i5 + i2 | 0;
   if (i6 >>> 0 <= 16384) {
    HEAP32[i1 >> 2] = i6;
    i2 = i4 + i5 | 0;
    break;
   }
  }
  i48 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i8 >> 2] | 0, i7) | 0;
  HEAP32[i3 >> 2] = i48;
  HEAP32[i1 >> 2] = i2;
  i2 = i48;
 } while (0);
 HEAP32[i53 + 28 >> 2] = i2;
 if (!i10) i1 = 0; else {
  i3 = 0;
  i1 = 0;
  do {
   if (HEAP8[i49 + i3 >> 0] | 0) {
    if ((i1 | 0) != (i3 | 0)) {
     HEAP32[i50 + 400 + (i1 << 6) >> 2] = HEAP32[i50 + 400 + (i3 << 6) >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 4 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 4 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 8 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 8 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 12 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 12 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 16 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 16 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 20 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 20 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 24 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 24 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 28 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 28 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 32 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 32 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 36 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 36 >> 2];
     HEAP32[i50 + 400 + (i1 << 6) + 40 >> 2] = HEAP32[i50 + 400 + (i3 << 6) + 40 >> 2];
     i48 = i50 + 400 + (i1 << 6) + 44 | 0;
     i47 = i50 + 400 + (i3 << 6) + 44 | 0;
     HEAP32[i48 >> 2] = HEAP32[i47 >> 2];
     HEAP32[i48 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
     HEAP32[i48 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
     HEAP32[i48 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
     HEAP32[i48 + 16 >> 2] = HEAP32[i47 + 16 >> 2];
     i48 = i54 + (i1 << 2) | 0;
     i47 = i54 + (i3 << 2) | 0;
     i47 = HEAPU16[i47 >> 1] | HEAPU16[i47 + 2 >> 1] << 16;
     HEAP16[i48 >> 1] = i47;
     HEAP16[i48 + 2 >> 1] = i47 >>> 16;
    }
    HEAP16[i2 + (i1 << 1) >> 1] = i3;
    i1 = i1 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i10 | 0));
  if (!i1) i1 = 0; else if (i12) {
   i47 = i1 << 2;
   i43 = i1;
   i48 = i43 & 65535;
   i50 = i53 + 8 | 0;
   i50 = HEAP32[i50 >> 2] | 0;
   i44 = i50 + 20 | 0;
   HEAP16[i44 >> 1] = i48;
   i48 = i50 + 98 | 0;
   i45 = HEAP16[i48 >> 1] | 0;
   i46 = i53 + 22 | 0;
   HEAP16[i46 >> 1] = i45;
   i45 = i45 & 65535;
   i45 = i45 & 65519;
   i45 = i45 & 65535;
   HEAP16[i48 >> 1] = i45;
   i45 = i50 + 28 | 0;
   i46 = i50 + 32 | 0;
   i49 = i50 + 80 | 0;
   i49 = HEAP32[i49 >> 2] | 0;
   i50 = i50 + 22 | 0;
   i50 = HEAP16[i50 >> 1] | 0;
   i50 = i50 & 128;
   i50 = i50 << 16 >> 16 != 0;
   i53 = HEAP32[i9 >> 2] | 0;
   i42 = (i53 | 0) == 0;
   i53 = i53 + 16 | 0;
   i53 = i42 ? 0 : i53;
   __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b(i11, i43, i51, i44, i45, i46, i52, i47, i48, i49, i50, 0, i54, 0, 1, i53, 0) | 0;
   STACKTOP = i55;
   return;
  }
 }
 i47 = 0;
 i43 = i1;
 i48 = i43 & 65535;
 i50 = i53 + 8 | 0;
 i50 = HEAP32[i50 >> 2] | 0;
 i44 = i50 + 20 | 0;
 HEAP16[i44 >> 1] = i48;
 i48 = i50 + 98 | 0;
 i45 = HEAP16[i48 >> 1] | 0;
 i46 = i53 + 22 | 0;
 HEAP16[i46 >> 1] = i45;
 i45 = i45 & 65535;
 i45 = i45 & 65519;
 i45 = i45 & 65535;
 HEAP16[i48 >> 1] = i45;
 i45 = i50 + 28 | 0;
 i46 = i50 + 32 | 0;
 i49 = i50 + 80 | 0;
 i49 = HEAP32[i49 >> 2] | 0;
 i50 = i50 + 22 | 0;
 i50 = HEAP16[i50 >> 1] | 0;
 i50 = i50 & 128;
 i50 = i50 << 16 >> 16 != 0;
 i53 = HEAP32[i9 >> 2] | 0;
 i42 = (i53 | 0) == 0;
 i53 = i53 + 16 | 0;
 i53 = i42 ? 0 : i53;
 __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b(i11, i43, i51, i44, i45, i46, i52, i47, i48, i49, i50, 0, i54, 0, 1, i53, 0) | 0;
 STACKTOP = i55;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI8UnityStrS2_EEPS2_EEbT0_S6_T_(i19, i20, i1) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 16 | 0;
 i22 = i23;
 switch (i20 - i19 >> 4 | 0) {
 case 2:
  {
   i11 = i20 + -16 | 0;
   i12 = i11 + 11 | 0;
   i3 = HEAP8[i12 >> 0] | 0;
   i2 = i3 << 24 >> 24 < 0;
   i13 = i20 + -12 | 0;
   i3 = i2 ? HEAP32[i13 >> 2] | 0 : i3 & 255;
   i9 = i19 + 11 | 0;
   i6 = HEAP8[i9 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   i10 = i19 + 4 | 0;
   i6 = i5 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
   i1 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
   if (!i1) i18 = 4; else {
    i4 = HEAP32[i19 >> 2] | 0;
    i1 = _memcmp(i2 ? HEAP32[i11 >> 2] | 0 : i11, i5 ? i4 : i19, i1) | 0;
    if (!i1) i18 = 4; else if ((i1 | 0) < 0) {
     i7 = i19;
     i8 = i19;
     i1 = i4;
    } else {
     i22 = 1;
     STACKTOP = i23;
     return i22 | 0;
    }
   }
   do if ((i18 | 0) == 4) if (i3 >>> 0 < i6 >>> 0) {
    i7 = i19;
    i8 = i19;
    i1 = HEAP32[i19 >> 2] | 0;
    break;
   } else {
    i22 = 1;
    STACKTOP = i23;
    return i22 | 0;
   } while (0);
   i2 = i5 ? i1 : i8;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i22 + 12 >> 2] = i1;
   if (i6 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
    i1 = HEAP32[i22 + 12 >> 2] | 0;
    i18 = 10;
   } else if (i6 >>> 0 < 11) {
    HEAP8[i22 + 11 >> 0] = i6;
    if (!i6) i1 = i22; else {
     i1 = i22;
     i18 = 12;
    }
   } else i18 = 10;
   if ((i18 | 0) == 10) {
    i17 = i6 + 16 & -16;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i21 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i22 >> 2] = i1;
    HEAP32[i22 + 8 >> 2] = i17 | -2147483648;
    HEAP32[i22 + 4 >> 2] = i6;
    i18 = 12;
   }
   if ((i18 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   do if ((i11 | 0) != (i19 | 0)) {
    i5 = HEAP8[i12 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i4 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
    i5 = i1 ? HEAP32[i13 >> 2] | 0 : i5 & 255;
    i1 = HEAP8[i9 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i19 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    if (i5 >>> 0 > i3 >>> 0) {
     i18 = i2 ? HEAP32[i10 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i19, i3, i5 - i3 | 0, i18, 0, i18, i5, i4);
     break;
    }
    i1 = i2 ? HEAP32[i7 >> 2] | 0 : i8;
    if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i9 >> 0] | 0) < 0) {
     HEAP32[i10 >> 2] = i5;
     break;
    } else {
     HEAP8[i9 >> 0] = i5;
     break;
    }
   } while (0);
   i4 = i22 + 11 | 0;
   do if ((i22 | 0) != (i11 | 0)) {
    i6 = HEAP8[i4 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i5 = i2 ? HEAP32[i22 >> 2] | 0 : i22;
    i6 = i2 ? HEAP32[i22 + 4 >> 2] | 0 : i6 & 255;
    i2 = HEAP8[i12 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i1 = (HEAP32[i20 + -8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    if (i6 >>> 0 > i1 >>> 0) {
     i20 = i3 ? HEAP32[i13 >> 2] | 0 : i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i1, i6 - i1 | 0, i20, 0, i20, i6, i5);
     break;
    }
    i1 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
    if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
    HEAP8[i1 + i6 >> 0] = 0;
    if ((HEAP8[i12 >> 0] | 0) < 0) {
     HEAP32[i13 >> 2] = i6;
     break;
    } else {
     HEAP8[i12 >> 0] = i6;
     break;
    }
   } while (0);
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i20 = HEAP32[i22 >> 2] | 0;
    i22 = HEAP32[i22 + 12 >> 2] | 0;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i21 + 4 >> 2] = i22;
    __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
   }
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i19, i19 + 16 | 0, i20 + -16 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_(i19, i19 + 16 | 0, i19 + 32 | 0, i20 + -16 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i19, i19 + 16 | 0, i19 + 32 | 0, i19 + 48 | 0, i20 + -16 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 1:
 case 0:
  {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  {
   i3 = i19 + 32 | 0;
   __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i19, i19 + 16 | 0, i3, i1) | 0;
   i1 = i19 + 48 | 0;
   L3 : do if ((i1 | 0) == (i20 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i12 = i22 + 12 | 0;
    i11 = i22 + 12 | 0;
    i13 = i21 + 4 | 0;
    i14 = i22 + 8 | 0;
    i15 = i22 + 4 | 0;
    i16 = i22 + 11 | 0;
    i17 = i21 + 4 | 0;
    i2 = 0;
    i8 = i3;
    while (1) {
     i9 = HEAP8[i1 + 11 >> 0] | 0;
     i7 = i9 << 24 >> 24 < 0;
     i9 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
     i6 = HEAP8[i8 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
     i4 = i6 >>> 0 < i9 >>> 0 ? i6 : i9;
     if (!i4) i18 = 43; else {
      i3 = HEAP32[i1 >> 2] | 0;
      i4 = _memcmp(i7 ? i3 : i1, i5 ? HEAP32[i8 >> 2] | 0 : i8, i4) | 0;
      if (!i4) i18 = 43; else if ((i4 | 0) < 0) {
       i4 = i1;
       i18 = 46;
      }
     }
     if ((i18 | 0) == 43) {
      i18 = 0;
      if (i9 >>> 0 < i6 >>> 0) {
       i4 = i1;
       i3 = HEAP32[i1 >> 2] | 0;
       i18 = 46;
      }
     }
     if ((i18 | 0) == 46) {
      i18 = 0;
      i4 = i7 ? i3 : i4;
      HEAP32[i22 >> 2] = 0;
      HEAP32[i22 + 4 >> 2] = 0;
      HEAP32[i22 + 8 >> 2] = 0;
      i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
      HEAP32[i12 >> 2] = i3;
      if (i9 >>> 0 > 2147483631) {
       __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
       i3 = HEAP32[i11 >> 2] | 0;
       i18 = 49;
      } else if (i9 >>> 0 < 11) {
       HEAP8[i16 >> 0] = i9;
       if (!i9) i3 = i22; else {
        i3 = i22;
        i18 = 51;
       }
      } else i18 = 49;
      if ((i18 | 0) == 49) {
       i10 = i9 + 16 & -16;
       HEAP32[i21 >> 2] = 66;
       HEAP32[i13 >> 2] = i3;
       i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i22 >> 2] = i3;
       HEAP32[i14 >> 2] = i10 | -2147483648;
       HEAP32[i15 >> 2] = i9;
       i18 = 51;
      }
      if ((i18 | 0) == 51) {
       i18 = 0;
       _memcpy(i3 | 0, i4 | 0, i9 | 0) | 0;
      }
      HEAP8[i3 + i9 >> 0] = 0;
      i10 = i8;
      i7 = i1;
      while (1) {
       do if ((i7 | 0) != (i10 | 0)) {
        i9 = HEAP8[i10 + 11 >> 0] | 0;
        i5 = i9 << 24 >> 24 < 0;
        i8 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
        i9 = i5 ? HEAP32[i10 + 4 >> 2] | 0 : i9 & 255;
        i5 = i7 + 11 | 0;
        i3 = HEAP8[i5 >> 0] | 0;
        i4 = i3 << 24 >> 24 < 0;
        if (i4) i6 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
        if (i9 >>> 0 > i6 >>> 0) {
         if (i4) i3 = HEAP32[i7 + 4 >> 2] | 0; else i3 = i3 & 255;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i6, i9 - i6 | 0, i3, 0, i3, i9, i8);
         break;
        }
        if (i4) i3 = HEAP32[i7 >> 2] | 0; else i3 = i7;
        if (i9 | 0) _memmove(i3 | 0, i8 | 0, i9 | 0) | 0;
        HEAP8[i3 + i9 >> 0] = 0;
        if ((HEAP8[i5 >> 0] | 0) < 0) {
         HEAP32[i7 + 4 >> 2] = i9;
         break;
        } else {
         HEAP8[i5 >> 0] = i9;
         break;
        }
       } while (0);
       if ((i10 | 0) == (i19 | 0)) {
        i7 = i19;
        break;
       }
       i6 = i10 + -16 | 0;
       i7 = HEAP8[i16 >> 0] | 0;
       i4 = i7 << 24 >> 24 < 0;
       i7 = i4 ? HEAP32[i15 >> 2] | 0 : i7 & 255;
       i8 = HEAP8[i6 + 11 >> 0] | 0;
       i5 = i8 << 24 >> 24 < 0;
       i8 = i5 ? HEAP32[i10 + -12 >> 2] | 0 : i8 & 255;
       i3 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
       if (i3 | 0) {
        i3 = _memcmp(i4 ? HEAP32[i22 >> 2] | 0 : i22, i5 ? HEAP32[i6 >> 2] | 0 : i6, i3) | 0;
        if (i3 | 0) if ((i3 | 0) < 0) {
         i7 = i10;
         i10 = i6;
         continue;
        } else {
         i7 = i10;
         break;
        }
       }
       if (i7 >>> 0 < i8 >>> 0) {
        i7 = i10;
        i10 = i6;
       } else {
        i7 = i10;
        break;
       }
      }
      do if ((i7 | 0) != (i22 | 0)) {
       i9 = HEAP8[i16 >> 0] | 0;
       i5 = i9 << 24 >> 24 < 0;
       i8 = i5 ? HEAP32[i22 >> 2] | 0 : i22;
       i9 = i5 ? HEAP32[i15 >> 2] | 0 : i9 & 255;
       i5 = i7 + 11 | 0;
       i3 = HEAP8[i5 >> 0] | 0;
       i4 = i3 << 24 >> 24 < 0;
       if (i4) i6 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
       if (i9 >>> 0 > i6 >>> 0) {
        if (i4) i3 = HEAP32[i7 + 4 >> 2] | 0; else i3 = i3 & 255;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i6, i9 - i6 | 0, i3, 0, i3, i9, i8);
        break;
       }
       if (i4) i3 = HEAP32[i7 >> 2] | 0; else i3 = i7;
       if (i9 | 0) _memmove(i3 | 0, i8 | 0, i9 | 0) | 0;
       HEAP8[i3 + i9 >> 0] = 0;
       if ((HEAP8[i5 >> 0] | 0) < 0) {
        HEAP32[i7 + 4 >> 2] = i9;
        break;
       } else {
        HEAP8[i5 >> 0] = i9;
        break;
       }
      } while (0);
      i2 = i2 + 1 | 0;
      if ((HEAP8[i16 >> 0] | 0) < 0) {
       i10 = HEAP32[i22 >> 2] | 0;
       i9 = HEAP32[i11 >> 2] | 0;
       HEAP32[i21 >> 2] = 66;
       HEAP32[i17 >> 2] = i9;
       __Z19free_alloc_internalPvRK10MemLabelId(i10, i21);
      }
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 16 | 0) == (i20 | 0);
       break L3;
      }
     }
     i3 = i1 + 16 | 0;
     if ((i3 | 0) == (i20 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i8 = i1;
      i1 = i3;
     }
    }
   } while (0);
   i22 = i1 | i2;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 return 0;
}

function __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_27TriggerTraceSegmentCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i10, i7, i2, i59, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i59 = i59 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, f44 = f0, i45 = 0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i60 = 0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i58 + 128 | 0;
 i5 = i58 + 112 | 0;
 i6 = i58 + 108 | 0;
 i8 = i58 + 104 | 0;
 i57 = i58 + 92 | 0;
 i47 = i58 + 80 | 0;
 i48 = i58 + 64 | 0;
 i55 = i58 + 60 | 0;
 i56 = i58 + 56 | 0;
 i49 = i58 + 44 | 0;
 i50 = i58 + 32 | 0;
 i51 = i58 + 20 | 0;
 i52 = i58 + 8 | 0;
 i53 = i58 + 4 | 0;
 i54 = i58;
 __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i10, i45);
 f41 = Math_fround(HEAPF32[i2 >> 2]);
 f41 = Math_fround(f41 - Math_fround(HEAPF32[i7 >> 2]));
 f44 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = i7 + 4 | 0;
 f44 = Math_fround(f44 - Math_fround(HEAPF32[i4 >> 2]));
 f46 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i3 = i7 + 8 | 0;
 f46 = Math_fround(f46 - Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i5 >> 2] = f41;
 i1 = i5 + 4 | 0;
 HEAPF32[i1 >> 2] = f44;
 i2 = i5 + 8 | 0;
 HEAPF32[i2 >> 2] = f46;
 if (!(__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i45, i45 + 12 | 0, i7, i5, Math_fround(1.0), i6, i8) | 0)) {
  STACKTOP = i58;
  return;
 }
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(HEAPF32[i5 >> 2]);
 f37 = Math_fround(f12 * f20);
 f39 = Math_fround(HEAPF32[i1 >> 2]);
 f46 = Math_fround(f12 * f39);
 f44 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f12 * f44);
 f16 = Math_fround(HEAPF32[i7 >> 2]);
 f37 = Math_fround(f37 + f16);
 f13 = Math_fround(HEAPF32[i4 >> 2]);
 f46 = Math_fround(f46 + f13);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f12 + f9);
 f38 = Math_fround(HEAPF32[i8 >> 2]);
 f20 = Math_fround(f16 + Math_fround(f20 * f38));
 f39 = Math_fround(f13 + Math_fround(f39 * f38));
 f38 = Math_fround(f9 + Math_fround(f44 * f38));
 f44 = Math_fround(HEAPF32[(HEAP32[i10 + 16 >> 2] | 0) + 8 >> 2]);
 i3 = HEAP32[i10 + 12 >> 2] | 0;
 i45 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f13 = Math_fround(Math_fround(i4 + -1 | 0) * Math_fround(.99999988));
 f16 = Math_fround(Math_fround(i45 + -1 | 0) * Math_fround(.99999988));
 f18 = Math_fround(f37 * f9);
 i42 = f18 > Math_fround(1.00000001e-07);
 f14 = i42 ? f18 : Math_fround(1.00000001e-07);
 f13 = Math_fround(f13 + Math_fround(0.0));
 f14 = f14 < f13 ? f14 : f13;
 f11 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f19 = Math_fround(f12 * f11);
 i42 = f19 > Math_fround(1.00000001e-07);
 f15 = i42 ? f19 : Math_fround(1.00000001e-07);
 f16 = Math_fround(f16 + Math_fround(0.0));
 f15 = f15 < f16 ? f15 : f16;
 f41 = Math_fround(f20 * f9);
 i42 = f41 > Math_fround(1.00000001e-07);
 f41 = i42 ? f41 : Math_fround(1.00000001e-07);
 f40 = Math_fround(f38 * f11);
 i42 = f40 > Math_fround(1.00000001e-07);
 f40 = i42 ? f40 : Math_fround(1.00000001e-07);
 f13 = Math_fround((f41 < f13 ? f41 : f13) - f14);
 f16 = Math_fround((f40 < f16 ? f40 : f16) - f15);
 f39 = Math_fround(f39 - f46);
 i42 = f13 >= Math_fround(0.0);
 f40 = i42 ? Math_fround(1.0) : Math_fround(-1.0);
 i42 = f16 >= Math_fround(0.0);
 f41 = i42 ? Math_fround(1.0) : Math_fround(-1.0);
 i42 = ~~f40;
 i43 = ~~f41;
 i1 = Math_fround(Math_abs(Math_fround(f13))) < Math_fround(1.00000001e-10);
 f17 = Math_fround(f40 * Math_fround(1.00000001e-10));
 f13 = i1 ? f17 : f13;
 i1 = Math_fround(Math_abs(Math_fround(f16))) < Math_fround(1.00000001e-10);
 f17 = Math_fround(f41 * Math_fround(1.00000001e-10));
 f16 = i1 ? f17 : f16;
 HEAPF32[i57 >> 2] = f18;
 HEAPF32[i57 + 4 >> 2] = f46;
 HEAPF32[i57 + 8 >> 2] = f19;
 f9 = Math_fround(Math_fround(f20 - f37) * f9);
 f11 = Math_fround(Math_fround(f38 - f12) * f11);
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f9 * f9)) + Math_fround(f11 * f11))));
 HEAPF32[i47 >> 2] = f9;
 i1 = i47 + 4 | 0;
 HEAPF32[i1 >> 2] = f39;
 i2 = i47 + 8 | 0;
 HEAPF32[i2 >> 2] = f11;
 if (f12 > Math_fround(9.99999968e-21)) {
  f38 = Math_fround(Math_fround(1.0) / f12);
  HEAPF32[i47 >> 2] = Math_fround(f38 * f9);
  HEAPF32[i1 >> 2] = Math_fround(f38 * f39);
  HEAPF32[i2 >> 2] = Math_fround(f38 * f11);
 }
 i1 = f13 > Math_fround(0.0);
 if (i1) f9 = Math_fround(Math_floor(Math_fround(f14))); else f9 = Math_fround(Math_ceil(Math_fround(f14)));
 i5 = ~~f9;
 i2 = f16 > Math_fround(0.0);
 if (i2) f9 = Math_fround(Math_floor(Math_fround(f15))); else f9 = Math_fround(Math_ceil(Math_fround(f15)));
 i6 = ~~f9;
 if (i1) {
  f9 = Math_fround(Math_ceil(Math_fround(f14)));
  f38 = Math_fround(f9 + Math_fround(1.0));
  f9 = f9 == f14 ? f38 : f9;
 } else {
  f9 = Math_fround(Math_floor(Math_fround(f14)));
  f38 = Math_fround(f9 + Math_fround(-1.0));
  f9 = f9 == f14 ? f38 : f9;
 }
 if (i2) {
  f11 = Math_fround(Math_ceil(Math_fround(f15)));
  f38 = Math_fround(f11 + Math_fround(1.0));
  f11 = f11 == f15 ? f38 : f11;
 } else {
  f11 = Math_fround(Math_floor(Math_fround(f15)));
  f38 = Math_fround(f11 + Math_fround(-1.0));
  f11 = f11 == f15 ? f38 : f11;
 }
 f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f13))));
 f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f16))));
 i25 = 1 - i42 | 0;
 i24 = (1 - i43 | 0) / 2 | 0;
 i33 = i3 + 36 | 0;
 i34 = i48 + 4 | 0;
 i35 = i48 + 8 | 0;
 i36 = i48 + 12 | 0;
 f19 = Math_fround(i4 | 0);
 f20 = Math_fround(i45 | 0);
 i21 = i48 + (i24 + i25 << 2) | 0;
 i22 = i48 + (i25 + 1 - i24 << 2) | 0;
 i23 = i48 + (2 - i25 + i24 << 2) | 0;
 i24 = i48 + (3 - i25 - i24 << 2) | 0;
 i25 = i49 + 4 | 0;
 i26 = i49 + 8 | 0;
 i27 = i50 + 4 | 0;
 i28 = i50 + 8 | 0;
 i29 = i51 + 4 | 0;
 i30 = i51 + 8 | 0;
 i31 = i52 + 4 | 0;
 i32 = i52 + 8 | 0;
 f17 = Math_fround(f12 + Math_fround(.0000999999974));
 f18 = Math_fround(f46 + Math_fround(f39 * Math_fround(0.0)));
 f12 = Math_fround(Math_fround(f9 - f14) / f13);
 f13 = Math_fround(Math_fround(f11 - f15) / f16);
 i10 = i5;
 f11 = Math_fround(i5 | 0);
 i8 = i6;
 f14 = Math_fround(i6 | 0);
 while (1) {
  i7 = f12 < f13;
  f15 = i7 ? f12 : f13;
  f61 = f18;
  f18 = Math_fround(f46 + Math_fround(f39 * f15));
  i5 = (Math_imul(i10, i45) | 0) + i8 | 0;
  i2 = i10 + i42 | 0;
  i6 = (Math_imul(i2, i45) | 0) + i8 | 0;
  i1 = HEAP32[i33 >> 2] | 0;
  f65 = Math_fround(f44 * Math_fround(HEAP16[i1 + (i5 << 2) >> 1] | 0));
  HEAPF32[i48 >> 2] = f65;
  f63 = Math_fround(f44 * Math_fround(HEAP16[i1 + (i5 + i43 << 2) >> 1] | 0));
  HEAPF32[i34 >> 2] = f63;
  f64 = Math_fround(f44 * Math_fround(HEAP16[i1 + (i6 << 2) >> 1] | 0));
  HEAPF32[i35 >> 2] = f64;
  f62 = Math_fround(f44 * Math_fround(HEAP16[i1 + (i6 + i43 << 2) >> 1] | 0));
  HEAPF32[i36 >> 2] = f62;
  f9 = f65 < f63 ? f65 : f63;
  f16 = f64 < f62 ? f64 : f62;
  f63 = f65 > f63 ? f65 : f63;
  f62 = f64 > f62 ? f64 : f62;
  if (!(Math_fround((f61 < f18 ? f61 : f18) + Math_fround(-.0000999999974)) > (f63 > f62 ? f63 : f62) ? 1 : Math_fround((f61 > f18 ? f61 : f18) + Math_fround(.0000999999974)) < (f9 < f16 ? f9 : f16))) {
   i4 = HEAP32[i21 >> 2] | 0;
   i3 = HEAP32[i22 >> 2] | 0;
   i6 = HEAP32[i23 >> 2] | 0;
   i5 = HEAP32[i24 >> 2] | 0;
   f64 = Math_fround(f40 + f11);
   f62 = f11 < f64 ? f11 : f64;
   f64 = f11 > f64 ? f11 : f64;
   f65 = Math_fround(f41 + f14);
   f63 = f14 < f65 ? f14 : f65;
   f65 = f14 > f65 ? f14 : f65;
   HEAPF32[i49 >> 2] = f62;
   HEAP32[i25 >> 2] = i4;
   HEAPF32[i26 >> 2] = f63;
   HEAPF32[i50 >> 2] = f62;
   HEAP32[i27 >> 2] = i3;
   HEAPF32[i28 >> 2] = f65;
   HEAPF32[i51 >> 2] = f64;
   HEAP32[i29 >> 2] = i6;
   HEAPF32[i30 >> 2] = f63;
   HEAPF32[i52 >> 2] = f64;
   HEAP32[i31 >> 2] = i5;
   HEAPF32[i32 >> 2] = f65;
   i5 = i8 + i43 | 0;
   i5 = (Math_imul((i2 | 0) < (i10 | 0) ? i2 : i10, i45) | 0) + ((i5 | 0) < (i8 | 0) ? i5 : i8) | 0;
   i6 = (HEAP8[i1 + (i5 << 2) + 2 >> 0] | 0) < 0;
   i1 = i6 ? i49 : i50;
   i3 = i6 ? i50 : i52;
   i4 = i6 ? i52 : i51;
   HEAPF32[i53 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i54 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i6 = __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i57, i47, i6 ? i51 : i49, i1, i4, i53, i55, i56, Math_fround(.0000999999974)) | 0;
   f65 = Math_fround(HEAPF32[i53 >> 2]);
   if (!(f65 <= f17) | i6 & f65 >= Math_fround(-.0000999999974) ^ 1) i60 = 20; else if ((HEAP8[(HEAP32[i33 >> 2] | 0) + (i5 << 2) + 2 >> 0] & 127) == 127) i60 = 20; else i6 = 0;
   if ((i60 | 0) == 20) {
    i60 = 0;
    HEAPF32[i53 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i6 = 1;
   }
   i4 = __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i57, i47, i3, i4, i1, i54, i55, i56, Math_fround(.0000999999974)) | 0;
   f9 = Math_fround(HEAPF32[i54 >> 2]);
   if (!(f9 <= f17) | i4 & f9 >= Math_fround(-.0000999999974) ^ 1) i60 = 23; else if ((HEAP8[(HEAP32[i33 >> 2] | 0) + (i5 << 2) + 3 >> 0] & 127) == 127) i60 = 23; else i1 = 0;
   if ((i60 | 0) == 23) {
    i60 = 0;
    HEAPF32[i54 >> 2] = Math_fround(3402823469999999843913219.0e14);
    f9 = Math_fround(3402823469999999843913219.0e14);
    i1 = 1;
   }
   if (!(i6 | !(Math_fround(HEAPF32[i53 >> 2]) <= f9))) {
    i60 = 25;
    break;
   }
   if (!(i1 | !(f9 <= Math_fround(HEAPF32[i53 >> 2])))) {
    i60 = 27;
    break;
   }
  }
  if (i7) {
   i10 = i2 + i42 | 0;
   if (!((i10 | 0) > -1 & !(Math_fround(i10 | 0) >= f19))) {
    i60 = 34;
    break;
   }
   f12 = Math_fround(f37 + f12);
   f11 = Math_fround(f40 + f11);
   i1 = i8;
   f9 = f14;
  } else {
   i1 = i8 + i43 | 0;
   i8 = i1 + i43 | 0;
   if (!((i8 | 0) > -1 & !(Math_fround(i8 | 0) >= f20))) {
    i60 = 34;
    break;
   }
   f13 = Math_fround(f38 + f13);
   i2 = i10;
   f9 = Math_fround(f41 + f14);
  }
  if (!(f15 < Math_fround(.999899983))) {
   i60 = 34;
   break;
  } else {
   i10 = i2;
   i8 = i1;
   f14 = f9;
  }
 }
 if ((i60 | 0) == 25) {
  HEAP8[i59 >> 0] = 1;
  STACKTOP = i58;
  return;
 } else if ((i60 | 0) == 27) {
  HEAP8[i59 >> 0] = 1;
  STACKTOP = i58;
  return;
 } else if ((i60 | 0) == 34) {
  STACKTOP = i58;
  return;
 }
}

function __ZN25ConvexVsMeshSweepCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i33, i32, i7, i11, i12, i1, i2) {
 i33 = i33 | 0;
 i32 = i32 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i31 + 224 | 0;
 i25 = i31 + 208 | 0;
 i30 = i31 + 192 | 0;
 i24 = i31 + 48 | 0;
 i29 = i31 + 32 | 0;
 i23 = i31 + 16 | 0;
 i27 = i31;
 i1 = HEAP32[i33 + 320 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(f21 * f14);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f21 * f13);
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f21 = Math_fround(f21 * f6);
 f18 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(f18 * f9);
 f8 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f16 = Math_fround(f18 * f8);
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f17 = Math_fround(f19 + f17);
 f16 = Math_fround(f3 + f16);
 f18 = Math_fround(f21 + Math_fround(f18 * f5));
 f21 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f19 = Math_fround(f21 * f3);
 f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f20 = Math_fround(f21 * f4);
 f28 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f19 = Math_fround(f17 + f19);
 f20 = Math_fround(f16 + f20);
 f21 = Math_fround(f18 + Math_fround(f21 * f28));
 f18 = Math_fround(HEAPF32[i11 >> 2]);
 f16 = Math_fround(f14 * f18);
 f17 = Math_fround(f13 * f18);
 f18 = Math_fround(f6 * f18);
 f10 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f9 * f10));
 f17 = Math_fround(f17 + Math_fround(f8 * f10));
 f10 = Math_fround(f18 + Math_fround(f5 * f10));
 f18 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f3 * f18));
 f17 = Math_fround(f17 + Math_fround(f4 * f18));
 f18 = Math_fround(f10 + Math_fround(f28 * f18));
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f14 = Math_fround(f14 * f10);
 f13 = Math_fround(f13 * f10);
 f10 = Math_fround(f6 * f10);
 f6 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f9 = Math_fround(f14 + Math_fround(f9 * f6));
 f8 = Math_fround(f13 + Math_fround(f8 * f6));
 f6 = Math_fround(f10 + Math_fround(f5 * f6));
 f5 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f3 = Math_fround(f9 + Math_fround(f3 * f5));
 f4 = Math_fround(f8 + Math_fround(f4 * f5));
 f5 = Math_fround(f6 + Math_fround(f28 * f5));
 i11 = i33 + 364 | 0;
 f28 = Math_fround(HEAPF32[i11 >> 2]);
 i1 = i33 + 16 | 0;
 i2 = i33 + 400 | 0;
 f6 = Math_fround(HEAPF32[i33 + 440 >> 2]);
 i7 = i33 + 448 | 0;
 f8 = Math_fround(f16 - f19);
 f9 = Math_fround(f17 - f20);
 f10 = Math_fround(f18 - f21);
 f13 = Math_fround(f3 - f16);
 f14 = Math_fround(f4 - f17);
 f15 = Math_fround(f5 - f18);
 if (!(HEAP8[i33 + 447 >> 0] | 0)) {
  f34 = Math_fround(Math_fround(f8 * f14) - Math_fround(f9 * f13));
  f13 = Math_fround(Math_fround(f10 * f13) - Math_fround(f8 * f15));
  f15 = Math_fround(Math_fround(f9 * f15) - Math_fround(f10 * f14));
  f15 = Math_fround(f15 * Math_fround(HEAPF32[i33 + 428 >> 2]));
  f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i33 + 432 >> 2])));
  if (!(Math_fround(f15 + Math_fround(f34 * Math_fround(HEAPF32[i33 + 436 >> 2]))) <= Math_fround(0.0))) i26 = 3;
 } else i26 = 3;
 L4 : do if ((i26 | 0) == 3) {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
  HEAPF32[i30 >> 2] = Math_fround(0.0);
  f44 = Math_fround(HEAPF32[i33 + 272 >> 2]);
  f40 = Math_fround(HEAPF32[i33 + 276 >> 2]);
  f36 = Math_fround(HEAPF32[i33 + 280 >> 2]);
  f43 = Math_fround(HEAPF32[i33 + 224 >> 2]);
  f9 = Math_fround(f19 * f43);
  f42 = Math_fround(HEAPF32[i33 + 240 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f20 * f42));
  f41 = Math_fround(HEAPF32[i33 + 256 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f21 * f41));
  f39 = Math_fround(HEAPF32[i33 + 228 >> 2]);
  f10 = Math_fround(f19 * f39);
  f38 = Math_fround(HEAPF32[i33 + 244 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f20 * f38));
  f37 = Math_fround(HEAPF32[i33 + 260 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f21 * f37));
  f35 = Math_fround(HEAPF32[i33 + 232 >> 2]);
  f13 = Math_fround(f19 * f35);
  f8 = Math_fround(HEAPF32[i33 + 248 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f20 * f8));
  f34 = Math_fround(HEAPF32[i33 + 264 >> 2]);
  f9 = Math_fround(f44 + f9);
  f10 = Math_fround(f40 + f10);
  f13 = Math_fround(f36 + Math_fround(f13 + Math_fround(f21 * f34)));
  f14 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f16 * f43) + Math_fround(f17 * f42)) + Math_fround(f18 * f41)));
  f15 = Math_fround(f40 + Math_fround(Math_fround(Math_fround(f16 * f39) + Math_fround(f17 * f38)) + Math_fround(f18 * f37)));
  f19 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f16 * f35) + Math_fround(f17 * f8)) + Math_fround(f18 * f34)));
  f20 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f3 * f43) + Math_fround(f4 * f42)) + Math_fround(f5 * f41)));
  f21 = Math_fround(f40 + Math_fround(Math_fround(Math_fround(f3 * f39) + Math_fround(f4 * f38)) + Math_fround(f5 * f37)));
  f34 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f3 * f35) + Math_fround(f4 * f8)) + Math_fround(f5 * f34)));
  i26 = i24 + 64 | 0;
  HEAP32[i24 + 80 >> 2] = 7;
  HEAPF32[i24 + 48 >> 2] = Math_fround(0.0);
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  f17 = Math_fround(Math_fround(f21 + Math_fround(f10 + f15)) * Math_fround(.333332986));
  f18 = Math_fround(Math_fround(f34 + Math_fround(f13 + f19)) * Math_fround(.333332986));
  HEAPF32[i24 >> 2] = Math_fround(Math_fround(f20 + Math_fround(f9 + f14)) * Math_fround(.333332986));
  HEAPF32[i24 + 4 >> 2] = f17;
  HEAPF32[i24 + 8 >> 2] = f18;
  HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 96 >> 2] = f9;
  HEAPF32[i24 + 100 >> 2] = f10;
  HEAPF32[i24 + 104 >> 2] = f13;
  HEAPF32[i24 + 108 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 112 >> 2] = f14;
  HEAPF32[i24 + 116 >> 2] = f15;
  HEAPF32[i24 + 120 >> 2] = f19;
  HEAPF32[i24 + 124 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 128 >> 2] = f20;
  HEAPF32[i24 + 132 >> 2] = f21;
  HEAPF32[i24 + 136 >> 2] = f34;
  HEAPF32[i24 + 140 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
  do if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i24, i1, i30, i25, i2, i29, i27, i23, f6, 0) | 0) {
   f41 = Math_fround(HEAPF32[i33 + 288 >> 2]);
   f43 = Math_fround(HEAPF32[i33 + 292 >> 2]);
   f44 = Math_fround(HEAPF32[i33 + 296 >> 2]);
   f40 = Math_fround(HEAPF32[i33 + 300 >> 2]);
   f8 = Math_fround(HEAPF32[i33 + 304 >> 2]);
   f9 = Math_fround(HEAPF32[i33 + 308 >> 2]);
   f6 = Math_fround(HEAPF32[i33 + 312 >> 2]);
   f3 = Math_fround(HEAPF32[i23 >> 2]);
   f42 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   f38 = Math_fround(Math_fround(f40 * f40) + Math_fround(-.5));
   f10 = Math_fround(Math_fround(Math_fround(f41 * f3) + Math_fround(f43 * f42)) + Math_fround(f44 * f39));
   f8 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f41 * f10) + Math_fround(Math_fround(f38 * f3) + Math_fround(f40 * Math_fround(Math_fround(f43 * f39) - Math_fround(f44 * f42))))) * Math_fround(2.0)));
   f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f43 * f10) + Math_fround(Math_fround(f38 * f42) + Math_fround(f40 * Math_fround(Math_fround(f44 * f3) - Math_fround(f41 * f39))))) * Math_fround(2.0)));
   f10 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) + Math_fround(f40 * Math_fround(Math_fround(f41 * f42) - Math_fround(f43 * f3)))) + Math_fround(f44 * f10)) * Math_fround(2.0)));
   f3 = Math_fround(HEAPF32[i27 >> 2]);
   f42 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f6 = Math_fround(Math_fround(Math_fround(f41 * f3) + Math_fround(f43 * f42)) + Math_fround(f44 * f39));
   f4 = Math_fround(Math_fround(Math_fround(f41 * f6) + Math_fround(Math_fround(f38 * f3) + Math_fround(f40 * Math_fround(Math_fround(f43 * f39) - Math_fround(f44 * f42))))) * Math_fround(2.0));
   f5 = Math_fround(Math_fround(Math_fround(f43 * f6) + Math_fround(Math_fround(f38 * f42) + Math_fround(f40 * Math_fround(Math_fround(f44 * f3) - Math_fround(f41 * f39))))) * Math_fround(2.0));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f39) + Math_fround(f40 * Math_fround(Math_fround(f41 * f42) - Math_fround(f43 * f3)))) + Math_fround(f44 * f6)) * Math_fround(2.0));
   f44 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))));
   f4 = Math_fround(f44 * f4);
   f5 = Math_fround(f44 * f5);
   f6 = Math_fround(f44 * f6);
   f44 = Math_fround(HEAPF32[i30 >> 2]);
   f3 = Math_fround(HEAPF32[i29 >> 2]);
   if (!(f44 >= f3)) {
    f3 = Math_fround(f3 * Math_fround(HEAPF32[i33 + 384 >> 2]));
    if (!(f3 < f28)) break;
    HEAP16[i33 + 336 >> 1] = 7;
    HEAPF32[i33 + 340 >> 2] = f8;
    HEAPF32[i33 + 344 >> 2] = f9;
    HEAPF32[i33 + 348 >> 2] = f10;
    HEAPF32[i33 + 352 >> 2] = f4;
    HEAPF32[i33 + 356 >> 2] = f5;
    HEAPF32[i33 + 360 >> 2] = f6;
    HEAPF32[i11 >> 2] = f3;
    i1 = f3 == Math_fround(0.0);
   } else {
    HEAP16[i33 + 336 >> 1] = 6;
    HEAPF32[i11 >> 2] = Math_fround(0.0);
    f42 = Math_fround(-Math_fround(HEAPF32[i33 + 416 >> 2]));
    f43 = Math_fround(-Math_fround(HEAPF32[i33 + 420 >> 2]));
    f44 = Math_fround(-Math_fround(HEAPF32[i33 + 424 >> 2]));
    HEAPF32[i33 + 352 >> 2] = f42;
    HEAPF32[i33 + 356 >> 2] = f43;
    HEAPF32[i33 + 360 >> 2] = f44;
    HEAP8[i7 >> 0] = 1;
    i1 = 1;
   }
   HEAP8[i33 + 449 >> 0] = 1;
   HEAP32[i33 + 332 >> 2] = HEAP32[i32 + 8 >> 2];
   if ((HEAP8[i33 + 446 >> 0] | 0) != 0 | i1) i1 = 0; else break L4;
   STACKTOP = i31;
   return i1 | 0;
  } while (0);
 } while (0);
 i33 = 1;
 STACKTOP = i31;
 return i33 | 0;
}

function __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i10, i2, i8, i5, i9) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i17 + 328 | 0;
 i13 = i17 + 316 | 0;
 i12 = i17;
 i16 = i17 + 304 | 0;
 i14 = i17 + 292 | 0;
 i15 = i17 + 280 | 0;
 i6 = i17 + 220 | 0;
 i11 = i17 + 160 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 if (f3 == Math_fround(1.0)) {
  f1 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  if (f1 == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(1.0)) {
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = i2 + 16;
   HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i12 + 4 >> 2] = 2;
   HEAP32[i12 >> 2] = gb + 85796 + 8;
   HEAP32[i12 + 8 >> 2] = i2;
   HEAP32[i12 + 16 >> 2] = i4;
   i2 = i12 + 68 | 0;
   HEAP8[i2 >> 0] = 0;
   HEAP32[i12 + 116 >> 2] = i9;
   f21 = Math_fround(HEAPF32[i10 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i8 + 16 >> 2]));
   f23 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f23 = Math_fround(f23 - Math_fround(HEAPF32[i8 + 20 >> 2]));
   f26 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f21 = Math_fround(f21 * Math_fround(2.0));
   f23 = Math_fround(f23 * Math_fround(2.0));
   f26 = Math_fround(Math_fround(f26 - Math_fround(HEAPF32[i8 + 24 >> 2])) * Math_fround(2.0));
   f24 = Math_fround(HEAPF32[i8 + 12 >> 2]);
   f25 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
   f22 = Math_fround(HEAPF32[i8 >> 2]);
   f3 = Math_fround(f21 * f22);
   f20 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f3 = Math_fround(f3 + Math_fround(f23 * f20));
   f1 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f3 = Math_fround(f3 + Math_fround(f26 * f1));
   f19 = Math_fround(Math_fround(f22 * f3) + Math_fround(Math_fround(f21 * f25) - Math_fround(f24 * Math_fround(Math_fround(f26 * f20) - Math_fround(f23 * f1)))));
   f18 = Math_fround(Math_fround(f20 * f3) + Math_fround(Math_fround(f23 * f25) - Math_fround(f24 * Math_fround(Math_fround(f21 * f1) - Math_fround(f26 * f22)))));
   f3 = Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)))) + Math_fround(f1 * f3));
   HEAPF32[i12 + 76 >> 2] = f19;
   HEAPF32[i12 + 80 >> 2] = f18;
   HEAPF32[i12 + 84 >> 2] = f3;
   f1 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   HEAPF32[i12 + 72 >> 2] = Math_fround(f1 * f1);
   HEAPF32[i16 >> 2] = f19;
   HEAPF32[i16 + 4 >> 2] = f18;
   HEAPF32[i16 + 8 >> 2] = f3;
   HEAP32[i14 >> 2] = 1065353216;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   i11 = f1 > Math_fround(.00100000005);
   i11 = i11 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 981668463;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i15 + 4 >> 2] = i11;
   HEAP32[i15 + 8 >> 2] = i11;
   __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i16, i14, Math_fround(0.0), 1, i13, i12, i15);
   i16 = HEAP8[i2 >> 0] | 0;
   i16 = i16 << 24 >> 24 != 0;
   STACKTOP = i17;
   return i16 | 0;
  } else f1 = Math_fround(1.0);
 } else f1 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f36 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f38 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f24 = Math_fround(f22 + f22);
 f34 = Math_fround(f21 + f21);
 f26 = Math_fround(f36 + f36);
 f30 = Math_fround(f21 * f34);
 f37 = Math_fround(f36 * f26);
 f21 = Math_fround(f24 * f21);
 f33 = Math_fround(f24 * f36);
 f32 = Math_fround(f24 * f38);
 f36 = Math_fround(f34 * f36);
 f34 = Math_fround(f34 * f38);
 f38 = Math_fround(f26 * f38);
 f26 = Math_fround(Math_fround(Math_fround(1.0) - f30) - f37);
 f23 = Math_fround(f21 + f38);
 f28 = Math_fround(f33 - f34);
 f38 = Math_fround(f21 - f38);
 f24 = Math_fround(Math_fround(1.0) - Math_fround(f22 * f24));
 f37 = Math_fround(f24 - f37);
 f22 = Math_fround(f36 + f32);
 f34 = Math_fround(f33 + f34);
 f32 = Math_fround(f36 - f32);
 f30 = Math_fround(f24 - f30);
 f24 = Math_fround(f3 * f26);
 f36 = Math_fround(f3 * f38);
 f33 = Math_fround(f3 * f34);
 f21 = Math_fround(f23 * f1);
 f35 = Math_fround(f37 * f1);
 f31 = Math_fround(f32 * f1);
 f25 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f29 = Math_fround(f28 * f25);
 f27 = Math_fround(f22 * f25);
 f25 = Math_fround(f30 * f25);
 f18 = Math_fround(Math_fround(Math_fround(f26 * f36) + Math_fround(f23 * f35)) + Math_fround(f28 * f27));
 f19 = Math_fround(Math_fround(Math_fround(f26 * f33) + Math_fround(f23 * f31)) + Math_fround(f28 * f25));
 f20 = Math_fround(Math_fround(Math_fround(f38 * f24) + Math_fround(f37 * f21)) + Math_fround(f22 * f29));
 f1 = Math_fround(Math_fround(Math_fround(f38 * f36) + Math_fround(f37 * f35)) + Math_fround(f22 * f27));
 f22 = Math_fround(Math_fround(Math_fround(f38 * f33) + Math_fround(f37 * f31)) + Math_fround(f22 * f25));
 f3 = Math_fround(Math_fround(Math_fround(f34 * f24) + Math_fround(f32 * f21)) + Math_fround(f30 * f29));
 f27 = Math_fround(Math_fround(Math_fround(f34 * f36) + Math_fround(f32 * f35)) + Math_fround(f30 * f27));
 f25 = Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f32 * f31)) + Math_fround(f30 * f25));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f23 * f21)) + Math_fround(f28 * f29));
 HEAPF32[i4 + 4 >> 2] = f18;
 HEAPF32[i4 + 8 >> 2] = f19;
 HEAPF32[i4 + 12 >> 2] = f20;
 HEAPF32[i4 + 16 >> 2] = f1;
 HEAPF32[i4 + 20 >> 2] = f22;
 HEAPF32[i4 + 24 >> 2] = f3;
 HEAPF32[i4 + 28 >> 2] = f27;
 HEAPF32[i4 + 32 >> 2] = f25;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = i2 + 16;
 HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 + 4 >> 2] = 2;
 HEAP32[i12 >> 2] = gb + 85816 + 8;
 HEAP32[i12 + 8 >> 2] = i2;
 HEAP32[i12 + 16 >> 2] = i4;
 i7 = i12 + 68 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i12 + 116 >> 2] = i9;
 f25 = Math_fround(HEAPF32[i10 >> 2]);
 f27 = Math_fround(f25 - Math_fround(HEAPF32[i8 + 16 >> 2]));
 f3 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f22 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 20 >> 2]));
 f1 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f27 = Math_fround(f27 * Math_fround(2.0));
 f22 = Math_fround(f22 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f1 - Math_fround(HEAPF32[i8 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f18 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f29 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(f27 * f29);
 f21 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f22 * f21));
 f23 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f20 * f23));
 f24 = Math_fround(Math_fround(f21 * f28) + Math_fround(Math_fround(f22 * f18) - Math_fround(f19 * Math_fround(Math_fround(f27 * f23) - Math_fround(f20 * f29)))));
 f26 = Math_fround(Math_fround(Math_fround(f20 * f18) - Math_fround(f19 * Math_fround(Math_fround(f22 * f29) - Math_fround(f27 * f21)))) + Math_fround(f23 * f28));
 HEAPF32[i12 + 76 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f27 * f18) - Math_fround(f19 * Math_fround(Math_fround(f20 * f21) - Math_fround(f22 * f23)))));
 HEAPF32[i12 + 80 >> 2] = f24;
 HEAPF32[i12 + 84 >> 2] = f26;
 f26 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 HEAPF32[i12 + 72 >> 2] = Math_fround(f26 * f26);
 HEAP32[i6 >> 2] = 1065353216;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 1065353216;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = 1065353216;
 HEAPF32[i6 + 36 >> 2] = f25;
 HEAPF32[i6 + 40 >> 2] = f3;
 HEAPF32[i6 + 44 >> 2] = f1;
 HEAPF32[i6 + 48 >> 2] = f26;
 HEAPF32[i6 + 52 >> 2] = f26;
 HEAPF32[i6 + 56 >> 2] = f26;
 __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i11, i6, i8, i5);
 i6 = i11 + 48 | 0;
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + 56 >> 2]);
 if (!(f26 >= (f1 > f3 ? f1 : f3))) if (!(f1 >= f3)) {
  i2 = 2;
  i4 = 0;
  i5 = 1;
 } else {
  i2 = 1;
  i4 = 0;
  i5 = 2;
 } else {
  i2 = 0;
  i4 = 1;
  i5 = 2;
 }
 f38 = Math_fround(HEAPF32[i6 + (i2 << 2) >> 2]);
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i11 + (i2 * 12 | 0) >> 2]));
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i11 + (i2 * 12 | 0) + 4 >> 2]));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i11 + (i2 * 12 | 0) + 8 >> 2]));
 f32 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i4 * 12 | 0) >> 2])));
 f30 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i4 * 12 | 0) + 4 >> 2])));
 f33 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i4 * 12 | 0) + 8 >> 2])));
 f31 = Math_fround(HEAPF32[i6 + (i4 << 2) >> 2]);
 f32 = Math_fround(f32 * f31);
 f30 = Math_fround(f30 * f31);
 f31 = Math_fround(f33 * f31);
 f33 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i5 * 12 | 0) >> 2])));
 f34 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i5 * 12 | 0) + 4 >> 2])));
 f27 = Math_fround(Math_abs(Math_fround(HEAPF32[i11 + (i5 * 12 | 0) + 8 >> 2])));
 f35 = Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]);
 f33 = Math_fround(f33 * f35);
 f34 = Math_fround(f34 * f35);
 f35 = Math_fround(f27 * f35);
 f27 = Math_fround(Math_fround(HEAPF32[i11 + 36 >> 2]) - f36);
 f28 = Math_fround(Math_fround(HEAPF32[i11 + 40 >> 2]) - f37);
 f29 = Math_fround(Math_fround(HEAPF32[i11 + 44 >> 2]) - f38);
 HEAPF32[i16 >> 2] = f27;
 HEAPF32[i16 + 4 >> 2] = f28;
 HEAPF32[i16 + 8 >> 2] = f29;
 f34 = Math_fround(Math_fround(f30 + f34) + Math_fround(.00100000005));
 f35 = Math_fround(Math_fround(f31 + f35) + Math_fround(.00100000005));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(f32 + f33) + Math_fround(.00100000005));
 HEAPF32[i15 + 4 >> 2] = f34;
 HEAPF32[i15 + 8 >> 2] = f35;
 HEAPF32[i14 >> 2] = f36;
 HEAPF32[i14 + 4 >> 2] = f37;
 HEAPF32[i14 + 8 >> 2] = f38;
 __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i16, i14, Math_fround(2.0), 1, i13, i12, i15);
 i16 = HEAP8[i7 >> 0] | 0;
 i16 = i16 << 24 >> 24 != 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx35createFinalizeSolverContactsCoulombERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE(i51, i34, i1, i4, i49, i52, i53, i54, i55, i5, i6, f50, f48, f3, f2, i40, i33) {
 i51 = i51 | 0;
 i34 = i34 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i49 = i49 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f50 = Math_fround(f50);
 f48 = Math_fround(f48);
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 i40 = i40 | 0;
 i33 = i33 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 1872 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i47 + 1832 | 0;
 i46 = i47;
 i44 = i47 + 1820 | 0;
 i45 = i47 + 1808 | 0;
 i1 = i4 & 1;
 HEAP16[i49 + 26 >> 1] = 0;
 i43 = i34 + 384 | 0;
 i32 = i34 + 4480 | 0;
 HEAP32[i32 >> 2] = 0;
 i38 = i51 + 40 | 0;
 HEAPF32[i39 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i39 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i39 + 24 >> 2] = Math_fround(0.0);
 i42 = i51 + 22 | 0;
 i31 = HEAP16[i42 >> 1] | 0;
 i41 = (i31 & 32) == 0 ? i39 : i5;
 i39 = (i31 & 64) == 0 ? i39 : i6;
 i6 = HEAP32[i51 + 28 >> 2] | 0;
 do if (i6 | 0) {
  i25 = HEAP32[i51 + 32 >> 2] | 0;
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  HEAPF32[i46 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i46 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i46 + 36 >> 2] = i25;
  i26 = i46 + 40 | 0;
  HEAP32[i26 >> 2] = 0;
  i27 = i46 + 44 | 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i46 + 12 >> 2] = i6;
  i28 = i6;
  if (!i25) {
   i29 = 0;
   i30 = 0;
   i7 = 0;
   i4 = 0;
   i31 = 0;
   i5 = 1;
  } else {
   i5 = HEAP16[i6 + 2 >> 1] | 0;
   i4 = i5 & 65535;
   i7 = i4 & 2;
   i31 = (i7 | 0) != 0;
   i4 = i4 & 1;
   i29 = i31 ? 4 : 32;
   i30 = i31 ? 72 : i4 << 3 | 16;
   i7 = i6 + (i7 << 3 | 4) | 0;
   i4 = (i4 | 0) != 0;
   i5 = (i5 & 4) != 0;
  }
  HEAP32[i46 + 60 >> 2] = i31 & 1;
  HEAP32[i46 + 56 >> 2] = i4 & 1;
  HEAP32[i46 + 64 >> 2] = i5 & 1;
  HEAP32[i46 + 48 >> 2] = i29;
  HEAP32[i46 + 52 >> 2] = i30;
  i22 = i46 + 24 | 0;
  HEAP32[i22 >> 2] = i7;
  i23 = i46 + 28 | 0;
  HEAP32[i23 >> 2] = i7;
  i24 = i46 + 16 | 0;
  HEAP32[i24 >> 2] = i7;
  i4 = i7;
  if (i5) break;
  if (i31) {
   f35 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f36 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  } else {
   f35 = Math_fround(1.0);
   f36 = Math_fround(1.0);
   f37 = Math_fround(1.0);
   f3 = Math_fround(1.0);
  }
  if ((i4 - i28 | 0) >>> 0 >= i25 >>> 0) {
   HEAP32[i32 >> 2] = 0;
   break;
  }
  i21 = i46 + 32 | 0;
  i6 = i4;
  i8 = 0;
  i5 = i4;
  i9 = 0;
  i10 = 0;
  i11 = i4;
  i12 = 0;
  while (1) {
   HEAP32[i22 >> 2] = i7;
   if ((i11 - i28 | 0) >>> 0 < i25 >>> 0) {
    i10 = HEAPU16[i7 >> 1] | 0;
    HEAP32[i26 >> 2] = i10;
    i20 = i7 + ((Math_imul(i30, i10) | 0) + i29) | 0;
    HEAP32[i23 >> 2] = i20;
    i5 = i7 + i29 | 0;
    HEAP32[i24 >> 2] = i5;
    HEAP32[i27 >> 2] = 0;
    i6 = i5;
    i8 = 0;
    i4 = 0;
   } else {
    HEAP32[i23 >> 2] = i7;
    i4 = i9;
    i20 = i7;
   }
   i14 = i7 + 4 | 0;
   i15 = i7 + 28 | 0;
   i16 = i7 + 30 | 0;
   i17 = i7 + 2 | 0;
   i18 = i7 + 16 | 0;
   i19 = i7 + 20 | 0;
   i13 = i7 + 24 | 0;
   L21 : while (1) {
    if (i31) {
     i7 = i8;
     while (1) {
      if (i4 >>> 0 >= i10 >>> 0) break L21;
      i4 = i4 + 1 | 0;
      HEAP32[i27 >> 2] = i4;
      HEAP32[i21 >> 2] = i5;
      i6 = i5 + i30 | 0;
      HEAP32[i24 >> 2] = i6;
      i7 = i5;
      f2 = Math_fround(HEAPF32[i7 + 48 >> 2]);
      if (f2 != Math_fround(0.0)) break; else {
       i5 = i6;
       i7 = i4;
      }
     }
     i8 = i31 ? i7 + 24 | 0 : i14;
     i9 = i6;
     i11 = i4;
    } else {
     if (i8 >>> 0 >= i10 >>> 0) {
      i7 = i8;
      i4 = i8;
      break;
     }
     i11 = i8 + 1 | 0;
     HEAP32[i27 >> 2] = i11;
     HEAP32[i21 >> 2] = i6;
     i9 = i6 + i30 | 0;
     HEAP32[i24 >> 2] = i9;
     i5 = i6;
     i8 = i14;
     i7 = i6;
     f2 = Math_fround(3402823469999999843913219.0e14);
    }
    i6 = i5;
    HEAP32[i34 + 384 + (i12 << 6) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 16 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 20 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 24 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 48 >> 2] = (HEAPU16[(i31 ? i7 + 66 | 0 : i16) >> 1] | 0) << 16 | (HEAPU16[(i31 ? i7 + 64 | 0 : i15) >> 1] | 0);
    if (i31) i4 = HEAP32[i7 + 68 >> 2] | 0; else i4 = HEAPU16[i17 >> 1] | 0;
    HEAP32[i34 + 384 + (i12 << 6) + 52 >> 2] = i4;
    HEAPF32[i34 + 384 + (i12 << 6) + 28 >> 2] = f2;
    HEAP32[i34 + 384 + (i12 << 6) + 44 >> 2] = HEAP32[(i31 ? i7 + 52 | 0 : i18) >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 56 >> 2] = HEAP32[(i31 ? i7 + 56 | 0 : i19) >> 2];
    HEAP32[i34 + 384 + (i12 << 6) + 60 >> 2] = HEAP32[(i31 ? i7 + 60 | 0 : i13) >> 2];
    i4 = i31 ? i7 + 36 | 0 : i46;
    HEAP32[i34 + 384 + (i12 << 6) + 32 >> 2] = HEAP32[i4 >> 2];
    i5 = i4 + 4 | 0;
    HEAP32[i34 + 384 + (i12 << 6) + 36 >> 2] = HEAP32[i5 >> 2];
    i6 = i4 + 8 | 0;
    HEAP32[i34 + 384 + (i12 << 6) + 40 >> 2] = HEAP32[i6 >> 2];
    if (i31) {
     if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0)) i4 = Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0); else i4 = 0; else i4 = 0;
     i4 = i4 ^ 1;
    } else i4 = 0;
    i1 = (i4 & 1 | i1 & 1) & 255;
    i6 = i9;
    i5 = i9;
    i4 = i11;
    i8 = i11;
    i12 = i12 + 1 | 0;
   }
   i11 = i20;
   if ((i11 - i28 | 0) >>> 0 >= i25 >>> 0) break; else {
    i8 = i7;
    i9 = i4;
    i7 = i20;
   }
  }
  HEAP32[i32 >> 2] = i12;
  i14 = (i1 & 1) != 0;
  if (i12 | 0) {
   HEAP32[i46 + 1792 >> 2] = 0;
   i8 = i46 + 1796 | 0;
   HEAP32[i8 >> 2] = 0;
   __ZN5physx27createContactPatchesCoulombERNS_27PxcCorrelationBufferCoulombERNS_2Gu13ContactBufferEfj(i46, i43, Math_fround(.999000012), 0) | 0;
   i13 = (i33 | 0) == 1 ? 1 : 2;
   __ZN5physx23correlatePatchesCoulombERNS_27PxcCorrelationBufferCoulombERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjjj(i46, i43, i41, i39, Math_fround(.999000012), i13, 0, 0) | 0;
   i9 = HEAP16[i42 >> 1] | 0;
   i1 = (i9 & 24) != 0;
   i8 = HEAP32[i8 >> 2] | 0;
   if (!i8) {
    i11 = 0;
    i1 = 0;
   } else {
    i7 = i1 ? 112 : 80;
    if (i1) {
     i5 = 0;
     i6 = 0;
     i1 = 0;
     do {
      i4 = HEAP32[i46 + 1408 + (i6 << 2) >> 2] | 0;
      if (i4) {
       i5 = i4 + i5 | 0;
       i1 = i1 + 80 + (Math_imul(i4, i7) | 0) + ((i4 << 2) + 12 & -16) | 0;
       if (!(HEAP16[i46 + 768 + (i6 * 20 | 0) + 18 >> 1] & 1)) {
        i33 = HEAPU16[i46 + 768 + (i6 * 20 | 0) + 16 >> 1] | 0;
        i5 = i33 + i5 | 0;
        i1 = (i33 << 7) + i1 | 0;
       }
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i8 | 0));
     i11 = i5;
    } else {
     i5 = 0;
     i6 = 0;
     i1 = 0;
     do {
      i4 = HEAP32[i46 + 1408 + (i6 << 2) >> 2] | 0;
      if (i4) {
       i5 = i4 + i5 | 0;
       i1 = i1 + 80 + (Math_imul(i4, i7) | 0) + ((i4 << 2) + 12 & -16) | 0;
       if (!(HEAP16[i46 + 768 + (i6 * 20 | 0) + 18 >> 1] & 1)) {
        i33 = HEAPU16[i46 + 768 + (i6 * 20 | 0) + 16 >> 1] | 0;
        i5 = i33 + i5 | 0;
        i1 = (i33 * 96 | 0) + i1 | 0;
       }
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i8 | 0));
     i11 = i5;
    }
   }
   i10 = (i9 & 130) == 0 ? 0 : i1 + 15 & -16;
   if (!i10) {
    i5 = 0;
    i6 = 1;
   } else {
    i6 = i34 + 316 | 0;
    i7 = i10 + 31 & -16;
    do if (i7 >>> 0 > 16384) i1 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i6 >> 2] | 0, i7) | 0; else {
     i8 = i34 + 320 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     i1 = i34 + 324 | 0;
     if (i9 | 0) {
      i4 = HEAP32[i1 >> 2] | 0;
      i5 = i4 + i7 | 0;
      if (i5 >>> 0 <= 16384) {
       HEAP32[i1 >> 2] = i5;
       i1 = i9 + i4 | 0;
       break;
      }
     }
     i40 = __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i6 >> 2] | 0, i40) | 0;
     HEAP32[i8 >> 2] = i40;
     HEAP32[i1 >> 2] = i7;
     i1 = i40;
    } while (0);
    i6 = (i1 | 0) == 0 | (i1 | 0) != (-1 | 0) ? i1 : 0;
    i5 = i6;
    i6 = (i6 | 0) != 0;
   }
   HEAP32[i38 >> 2] = 0;
   HEAP32[i51 >> 2] = 0;
   i1 = i51 + 20 | 0;
   HEAP16[i1 >> 1] = 0;
   HEAP32[i51 + 36 >> 2] = 0;
   i4 = i51 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   i40 = i51 + 16 | 0;
   HEAP16[i40 >> 1] = (HEAPU16[i40 >> 1] | 0) + i11;
   if (i6) {
    HEAP32[i51 >> 2] = i5;
    HEAP16[i1 >> 1] = i12;
    HEAP32[i4 >> 2] = i10;
    i4 = i5;
    if (i5 | 0) {
     if (!(HEAP16[i42 >> 1] & 24)) i1 = __ZN5physx37setupFinalizeSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffjffff(i51, i43, i46, i41, i39, i14, i4, i52, i53, i54, i55, f50, f48, i13, f35, f36, f37, f3) | 0; else {
      i1 = HEAP16[i49 + 8 >> 1] | 0;
      HEAP32[i44 >> 2] = i52;
      HEAP32[i44 + 4 >> 2] = i54;
      HEAP16[i44 + 8 >> 1] = i1;
      i1 = HEAP16[i49 + 12 >> 1] | 0;
      HEAP32[i45 >> 2] = i53;
      HEAP32[i45 + 4 >> 2] = i55;
      HEAP16[i45 + 8 >> 1] = i1;
      i1 = __ZN5physx40setupFinalizeExtSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhffRNS_16PxsSolverExtBodyESE_jffff(i51, i43, i46, i41, i39, i14, i4, f50, f48, i44, i45, i13, f35, f36, f37, f3) | 0;
     }
     HEAP32[i4 + i10 >> 2] = 0;
     HEAP32[i4 + (i10 | 4) >> 2] = i1 << 31 >> 31;
    }
   }
   i55 = i6;
   STACKTOP = i47;
   return i55 | 0;
  }
 } while (0);
 HEAP32[i38 >> 2] = 0;
 HEAP32[i51 + 36 >> 2] = 0;
 HEAP16[i51 + 20 >> 1] = 0;
 i55 = 1;
 STACKTOP = i47;
 return i55 | 0;
}

function __ZN5physx18collideWithCapsuleERNS_19PxsParticleCollDataERKNS_17PxCapsuleGeometryEf(i36, i1, f34) {
 i36 = i36 | 0;
 i1 = i1 | 0;
 f34 = Math_fround(f34);
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f35 = f0, i37 = 0, f38 = f0, f39 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i37 + 64 | 0;
 i25 = i37 + 60 | 0;
 i24 = i37 + 56 | 0;
 i20 = i37 + 44 | 0;
 i21 = i37 + 32 | 0;
 i22 = i37 + 20 | 0;
 i23 = i37 + 8 | 0;
 i10 = i37 + 4 | 0;
 i17 = i37;
 HEAPF32[i16 >> 2] = f34;
 i18 = i36 + 112 | 0;
 i19 = i36 + 128 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i25 >> 2] = i2;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i24 >> 2] = i7;
 f28 = Math_fround(HEAPF32[i36 + 116 >> 2]);
 f4 = Math_fround(f28 * f28);
 f29 = Math_fround(HEAPF32[i36 + 120 >> 2]);
 f8 = Math_fround(f29 * f29);
 f12 = Math_fround(f4 + f8);
 f35 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f12 - Math_fround(f35 * f35));
 f26 = Math_fround(HEAPF32[i18 >> 2]);
 f31 = Math_fround(f12 + Math_fround(f26 * f26));
 f30 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = Math_fround(f31 + Math_fround(f30 * f30));
 f15 = Math_fround(f26 * Math_fround(f30 * Math_fround(2.0)));
 f14 = Math_fround(f31 - f15);
 f15 = Math_fround(f31 + f15);
 i7 = f12 < Math_fround(0.0);
 i1 = f14 < Math_fround(0.0);
 i2 = f15 < Math_fround(0.0);
 f31 = Math_fround(-f30);
 if (f26 > f30 | f26 < f31) {
  if (i1 | i2) i3 = 4;
 } else if (i2 | (i7 | i1)) i3 = 4;
 if ((i3 | 0) == 4) {
  f6 = f26 > f31 ? f26 : f31;
  f6 = f6 < f30 ? f6 : f30;
  f5 = Math_fround(f26 - f6);
  i7 = i36 + 144 | 0;
  if (f29 == Math_fround(0.0) & (f28 == Math_fround(0.0) & f5 == Math_fround(0.0))) {
   i1 = 0;
   i2 = 1065353216;
   i3 = 0;
  } else {
   f4 = Math_fround(f8 + Math_fround(f4 + Math_fround(f5 * f5)));
   if (f4 > Math_fround(0.0)) {
    f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
    f32 = Math_fround(f5 * f34);
    f33 = Math_fround(f28 * f34);
    f34 = Math_fround(f29 * f34);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i1 = 0;
    i2 = 0;
    i3 = 0;
   }
  }
  HEAP32[i7 >> 2] = i1;
  HEAP32[i36 + 148 >> 2] = i2;
  HEAP32[i36 + 152 >> 2] = i3;
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i36 + 92 >> 2]));
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f35);
  f34 = Math_fround(f35 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f34 = Math_fround(f34 + Math_fround(0.0));
  f35 = Math_fround(Math_fround(f35 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + Math_fround(0.0));
  HEAPF32[i36 + 160 >> 2] = Math_fround(f6 + f33);
  HEAPF32[i36 + 164 >> 2] = f34;
  HEAPF32[i36 + 168 >> 2] = f35;
  HEAPF32[i36 + 44 >> 2] = Math_fround(0.0);
  i36 = i36 + 124 | 0;
  HEAP32[i36 >> 2] = HEAP32[i36 >> 2] | 8;
  STACKTOP = i37;
  return;
 }
 f27 = Math_fround(HEAPF32[i19 >> 2]);
 f9 = Math_fround(f27 - f26);
 f32 = Math_fround(HEAPF32[i36 + 132 >> 2]);
 f11 = Math_fround(f32 - f28);
 f33 = Math_fround(HEAPF32[i36 + 136 >> 2]);
 f13 = Math_fround(f33 - f29);
 HEAPF32[i22 >> 2] = f9;
 HEAPF32[i22 + 4 >> 2] = f11;
 HEAPF32[i22 + 8 >> 2] = f13;
 f5 = Math_fround(Math_fround(f11 * f28) + Math_fround(f13 * f29));
 HEAPF32[i21 + 4 >> 2] = f5;
 f6 = Math_fround(f5 + Math_fround(f9 * f26));
 f39 = Math_fround(f9 * f30);
 f38 = Math_fround(f6 - f39);
 HEAPF32[i21 >> 2] = f38;
 f39 = Math_fround(f6 + f39);
 i3 = i21 + 8 | 0;
 HEAPF32[i3 >> 2] = f39;
 f6 = Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13));
 HEAPF32[i20 + 4 >> 2] = f6;
 f8 = Math_fround(f6 + Math_fround(f9 * f9));
 HEAPF32[i20 >> 2] = f8;
 i2 = i20 + 8 | 0;
 HEAPF32[i2 >> 2] = f8;
 f4 = Math_fround(Math_fround(f5 * f5) - Math_fround(f12 * f6));
 f15 = Math_fround(Math_fround(f39 * f39) - Math_fround(f15 * f8));
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(f38 * f38) - Math_fround(f14 * f8));
 HEAPF32[i23 + 4 >> 2] = f4;
 i1 = i23 + 8 | 0;
 HEAPF32[i1 >> 2] = f15;
 if (!(f4 >= Math_fround(0.0))) {
  i7 = i36 + 124 | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  if (i10 & 2 | 0) {
   STACKTOP = i37;
   return;
  }
  f9 = f27 > f31 ? f27 : f31;
  f9 = f9 < f30 ? f9 : f30;
  i3 = i36 + 144 | 0;
  f4 = Math_fround(f27 - f9);
  HEAPF32[i3 >> 2] = f4;
  i1 = i36 + 148 | 0;
  HEAPF32[i1 >> 2] = f32;
  i2 = i36 + 152 | 0;
  HEAPF32[i2 >> 2] = f33;
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f32 * f32) + Math_fround(f4 * f4)))));
  if (!(f8 < Math_fround(f35 + f34))) {
   STACKTOP = i37;
   return;
  }
  if (f8 != Math_fround(0.0)) {
   f6 = Math_fround(Math_fround(1.0) / f8);
   f4 = Math_fround(f4 * f6);
   HEAPF32[i3 >> 2] = f4;
   f5 = Math_fround(f32 * f6);
   HEAPF32[i1 >> 2] = f5;
   f6 = Math_fround(f33 * f6);
   HEAPF32[i2 >> 2] = f6;
  } else {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f6 = Math_fround(0.0);
  }
  f39 = Math_fround(f35 + Math_fround(HEAPF32[i36 + 92 >> 2]));
  f35 = Math_fround(Math_fround(f5 * f39) + Math_fround(0.0));
  f38 = Math_fround(Math_fround(f6 * f39) + Math_fround(0.0));
  HEAPF32[i36 + 160 >> 2] = Math_fround(f9 + Math_fround(f4 * f39));
  HEAPF32[i36 + 164 >> 2] = f35;
  HEAPF32[i36 + 168 >> 2] = f38;
  HEAP32[i7 >> 2] = i10 | 32;
  if (!(f8 < f39)) {
   STACKTOP = i37;
   return;
  }
  HEAP32[i7 >> 2] = i10 | 48;
  STACKTOP = i37;
  return;
 }
 if (i7) if (f26 > Math_fround(0.0)) {
  __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_(i36, i18, i19, i22, i24, i25, i24, i23, i20, i21, i16);
  STACKTOP = i37;
  return;
 } else {
  HEAPF32[i10 >> 2] = f31;
  __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_(i36, i18, i19, i22, i24, i25, i10, i1, i2, i3, i16);
  STACKTOP = i37;
  return;
 }
 if (f4 <= Math_fround(0.0) | f6 == Math_fround(0.0)) {
  i7 = i36 + 124 | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  if (i10 & 2 | 0) {
   STACKTOP = i37;
   return;
  }
  f9 = f27 > f31 ? f27 : f31;
  f9 = f9 < f30 ? f9 : f30;
  i3 = i36 + 144 | 0;
  f4 = Math_fround(f27 - f9);
  HEAPF32[i3 >> 2] = f4;
  i1 = i36 + 148 | 0;
  HEAPF32[i1 >> 2] = f32;
  i2 = i36 + 152 | 0;
  HEAPF32[i2 >> 2] = f33;
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f32 * f32) + Math_fround(f4 * f4)))));
  if (!(f8 < Math_fround(f35 + f34))) {
   STACKTOP = i37;
   return;
  }
  if (f8 != Math_fround(0.0)) {
   f6 = Math_fround(Math_fround(1.0) / f8);
   f4 = Math_fround(f4 * f6);
   HEAPF32[i3 >> 2] = f4;
   f5 = Math_fround(f32 * f6);
   HEAPF32[i1 >> 2] = f5;
   f6 = Math_fround(f33 * f6);
   HEAPF32[i2 >> 2] = f6;
  } else {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f6 = Math_fround(0.0);
  }
  f39 = Math_fround(f35 + Math_fround(HEAPF32[i36 + 92 >> 2]));
  f35 = Math_fround(Math_fround(f5 * f39) + Math_fround(0.0));
  f38 = Math_fround(Math_fround(f6 * f39) + Math_fround(0.0));
  HEAPF32[i36 + 160 >> 2] = Math_fround(f9 + Math_fround(f4 * f39));
  HEAPF32[i36 + 164 >> 2] = f35;
  HEAPF32[i36 + 168 >> 2] = f38;
  HEAP32[i7 >> 2] = i10 | 32;
  if (!(f8 < f39)) {
   STACKTOP = i37;
   return;
  }
  HEAP32[i7 >> 2] = i10 | 48;
  STACKTOP = i37;
  return;
 }
 f8 = Math_fround(Math_fround(-Math_fround(f5 + Math_fround(Math_sqrt(Math_fround(f4))))) / f6);
 if (!(f8 < Math_fround(0.0) | f8 > Math_fround(1.0))) {
  f5 = Math_fround(Math_fround(f8 * f9) + f26);
  f6 = Math_fround(Math_fround(f8 * f11) + f28);
  f4 = Math_fround(Math_fround(f8 * f13) + f29);
  if (f5 > f30) {
   __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_(i36, i18, i19, i22, i24, i25, i24, i23, i20, i21, i16);
   STACKTOP = i37;
   return;
  }
  if (f5 < f31) {
   HEAPF32[i17 >> 2] = f31;
   __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_(i36, i18, i19, i22, i24, i25, i17, i1, i2, i3, i16);
   STACKTOP = i37;
   return;
  }
  i1 = i36 + 44 | 0;
  if (!(f8 < Math_fround(HEAPF32[i1 >> 2]))) {
   STACKTOP = i37;
   return;
  }
  f38 = Math_fround(Math_fround(1.0) / f35);
  f39 = Math_fround(f4 * f38);
  HEAPF32[i36 + 148 >> 2] = Math_fround(f6 * f38);
  HEAPF32[i36 + 152 >> 2] = f39;
  HEAPF32[i36 + 144 >> 2] = Math_fround(0.0);
  HEAPF32[i36 + 160 >> 2] = f26;
  HEAPF32[i36 + 164 >> 2] = f28;
  HEAPF32[i36 + 168 >> 2] = f29;
  HEAPF32[i1 >> 2] = f8;
  i36 = i36 + 124 | 0;
  HEAP32[i36 >> 2] = HEAP32[i36 >> 2] | 8;
  STACKTOP = i37;
  return;
 }
 i7 = i36 + 124 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 if (i10 & 2 | 0) {
  STACKTOP = i37;
  return;
 }
 f9 = f27 > f31 ? f27 : f31;
 f9 = f9 < f30 ? f9 : f30;
 i3 = i36 + 144 | 0;
 f4 = Math_fround(f27 - f9);
 HEAPF32[i3 >> 2] = f4;
 i1 = i36 + 148 | 0;
 HEAPF32[i1 >> 2] = f32;
 i2 = i36 + 152 | 0;
 HEAPF32[i2 >> 2] = f33;
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f33 * f33) + Math_fround(Math_fround(f32 * f32) + Math_fround(f4 * f4)))));
 if (!(f8 < Math_fround(f35 + f34))) {
  STACKTOP = i37;
  return;
 }
 if (f8 != Math_fround(0.0)) {
  f6 = Math_fround(Math_fround(1.0) / f8);
  f4 = Math_fround(f4 * f6);
  HEAPF32[i3 >> 2] = f4;
  f5 = Math_fround(f32 * f6);
  HEAPF32[i1 >> 2] = f5;
  f6 = Math_fround(f33 * f6);
  HEAPF32[i2 >> 2] = f6;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 }
 f39 = Math_fround(f35 + Math_fround(HEAPF32[i36 + 92 >> 2]));
 f35 = Math_fround(Math_fround(f5 * f39) + Math_fround(0.0));
 f38 = Math_fround(Math_fround(f6 * f39) + Math_fround(0.0));
 HEAPF32[i36 + 160 >> 2] = Math_fround(f9 + Math_fround(f4 * f39));
 HEAPF32[i36 + 164 >> 2] = f35;
 HEAPF32[i36 + 168 >> 2] = f38;
 HEAP32[i7 >> 2] = i10 | 32;
 if (!(f8 < f39)) {
  STACKTOP = i37;
  return;
 }
 HEAP32[i7 >> 2] = i10 | 48;
 STACKTOP = i37;
 return;
}

function __ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_(i20, i1, i18, i19) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i3 = (i1 | 0) == 0;
 i6 = i3 ? i20 + 1228 | 0 : i1 + 4 | 0;
 i3 = HEAP32[(i3 ? i20 + 1196 | 0 : i1) >> 2] | 0;
 if ((i3 | 0) > 3) {
  i17 = HEAP32[i18 >> 2] | 0;
  i8 = HEAP32[i19 >> 2] | 0;
  i9 = HEAP32[i18 + 4 >> 2] | 0;
  i10 = HEAP32[i19 + 4 >> 2] | 0;
  i11 = HEAP32[i18 + 8 >> 2] | 0;
  i12 = HEAP32[i19 + 8 >> 2] | 0;
  i13 = HEAP32[i18 + 12 >> 2] | 0;
  i14 = HEAP32[i19 + 12 >> 2] | 0;
  i15 = i3 + -4 | 0;
  i16 = i15 & -4;
  i1 = i6 + (i16 + 4 << 2) | 0;
  f2 = Math_fround(1.0);
  f4 = Math_fround(1.0);
  f5 = Math_fround(1.0);
  f7 = Math_fround(1.0);
  while (1) {
   i35 = HEAP32[i6 >> 2] | 0;
   i34 = HEAP32[i6 + 4 >> 2] | 0;
   i33 = HEAP32[i6 + 8 >> 2] | 0;
   i28 = HEAP32[i6 + 12 >> 2] | 0;
   i36 = HEAP32[i20 + 832 + (i35 << 4) >> 2] | 0;
   i30 = HEAP32[i20 + 832 + (i35 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i20 + 832 + (i35 << 4) + 8 >> 2] | 0;
   i32 = HEAP32[i20 + 832 + (i35 << 4) + 12 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i36 | i17 & i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i30 | i9 & i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 4 >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i12 & ~i31 | i11 & i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = Math_fround(f23 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 8 >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i32 | i13 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(Math_fround(f24 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 12 >> 2])) + Math_fround(f23 + Math_fround(f26 + f25)));
   i35 = HEAP32[i20 + 832 + (i34 << 4) >> 2] | 0;
   i32 = HEAP32[i20 + 832 + (i34 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i20 + 832 + (i34 << 4) + 8 >> 2] | 0;
   i30 = HEAP32[i20 + 832 + (i34 << 4) + 12 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i35 | i35 & i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i34 << 4) >> 2]));
   f23 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i32 | i32 & i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = Math_fround(f23 * Math_fround(HEAPF32[i20 + 480 + (i34 << 4) + 4 >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i12 & ~i31 | i31 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i20 + 480 + (i34 << 4) + 8 >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i30 | i30 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f23 = Math_fround(Math_fround(f22 * Math_fround(HEAPF32[i20 + 480 + (i34 << 4) + 12 >> 2])) + Math_fround(f24 + Math_fround(f26 + f23)));
   i34 = HEAP32[i20 + 832 + (i33 << 4) >> 2] | 0;
   i30 = HEAP32[i20 + 832 + (i33 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i20 + 832 + (i33 << 4) + 8 >> 2] | 0;
   i32 = HEAP32[i20 + 832 + (i33 << 4) + 12 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i34 | i34 & i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i33 << 4) >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i30 | i30 & i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f24 * Math_fround(HEAPF32[i20 + 480 + (i33 << 4) + 4 >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i12 & ~i31 | i31 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(f22 * Math_fround(HEAPF32[i20 + 480 + (i33 << 4) + 8 >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i32 | i32 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i20 + 480 + (i33 << 4) + 12 >> 2])) + Math_fround(f22 + Math_fround(f26 + f24)));
   i33 = HEAP32[i20 + 832 + (i28 << 4) >> 2] | 0;
   i32 = HEAP32[i20 + 832 + (i28 << 4) + 4 >> 2] | 0;
   i31 = HEAP32[i20 + 832 + (i28 << 4) + 8 >> 2] | 0;
   i30 = HEAP32[i20 + 832 + (i28 << 4) + 12 >> 2] | 0;
   f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i33 | i33 & i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i28 << 4) >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i32 | i32 & i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(f22 * Math_fround(HEAPF32[i20 + 480 + (i28 << 4) + 4 >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i12 & ~i31 | i31 & i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i20 + 480 + (i28 << 4) + 8 >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i14 & ~i30 | i30 & i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(Math_fround(f29 * Math_fround(HEAPF32[i20 + 480 + (i28 << 4) + 12 >> 2])) + Math_fround(f27 + Math_fround(f26 + f22)));
   f23 = f25 <= f23 ? f25 : f23;
   f22 = f24 <= f22 ? f24 : f22;
   f22 = f23 <= f22 ? f23 : f22;
   f2 = f2 <= f22 ? f2 : f22;
   f4 = f4 <= f22 ? f4 : f22;
   f5 = f5 <= f22 ? f5 : f22;
   f7 = f7 <= f22 ? f7 : f22;
   i3 = i3 + -4 | 0;
   if ((i3 | 0) <= 3) break; else i6 = i6 + 16 | 0;
  }
  i3 = i15 - i16 | 0;
 } else {
  i1 = i6;
  f2 = Math_fround(1.0);
  f4 = Math_fround(1.0);
  f5 = Math_fround(1.0);
  f7 = Math_fround(1.0);
 }
 switch (i3 | 0) {
 case 3:
  {
   i21 = HEAP32[i1 >> 2] | 0;
   i33 = HEAP32[i20 + 832 + (i21 << 4) >> 2] | 0;
   i11 = HEAP32[i18 >> 2] | 0;
   i13 = HEAP32[i19 >> 2] | 0;
   i34 = HEAP32[i20 + 832 + (i21 << 4) + 4 >> 2] | 0;
   i12 = HEAP32[i18 + 4 >> 2] | 0;
   i10 = HEAP32[i19 + 4 >> 2] | 0;
   i35 = HEAP32[i20 + 832 + (i21 << 4) + 8 >> 2] | 0;
   i9 = HEAP32[i18 + 8 >> 2] | 0;
   i8 = HEAP32[i19 + 8 >> 2] | 0;
   i36 = HEAP32[i20 + 832 + (i21 << 4) + 12 >> 2] | 0;
   i6 = HEAP32[i18 + 12 >> 2] | 0;
   i3 = HEAP32[i19 + 12 >> 2] | 0;
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13 & ~i33 | i11 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i20 + 480 + (i21 << 4) >> 2]));
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10 & ~i34 | i12 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i20 + 480 + (i21 << 4) + 4 >> 2]));
   f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8 & ~i35 | i9 & i35, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i20 + 480 + (i21 << 4) + 8 >> 2]));
   f29 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i3 & ~i36 | i6 & i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(HEAPF32[i20 + 480 + (i21 << 4) + 12 >> 2])) + Math_fround(f26 + Math_fround(f27 + f29)));
   i1 = i1 + 4 | 0;
   f2 = f2 <= f29 ? f2 : f29;
   f4 = f4 <= f29 ? f4 : f29;
   f5 = f5 <= f29 ? f5 : f29;
   f7 = f7 <= f29 ? f7 : f29;
   i21 = 9;
   break;
  }
 case 2:
  {
   i11 = HEAP32[i18 >> 2] | 0;
   i13 = HEAP32[i19 >> 2] | 0;
   i12 = HEAP32[i18 + 4 >> 2] | 0;
   i10 = HEAP32[i19 + 4 >> 2] | 0;
   i9 = HEAP32[i18 + 8 >> 2] | 0;
   i8 = HEAP32[i19 + 8 >> 2] | 0;
   i6 = HEAP32[i18 + 12 >> 2] | 0;
   i3 = HEAP32[i19 + 12 >> 2] | 0;
   i21 = 9;
   break;
  }
 case 1:
  {
   i11 = HEAP32[i18 >> 2] | 0;
   i13 = HEAP32[i19 >> 2] | 0;
   i12 = HEAP32[i18 + 4 >> 2] | 0;
   i10 = HEAP32[i19 + 4 >> 2] | 0;
   i9 = HEAP32[i18 + 8 >> 2] | 0;
   i8 = HEAP32[i19 + 8 >> 2] | 0;
   i6 = HEAP32[i18 + 12 >> 2] | 0;
   i3 = HEAP32[i19 + 12 >> 2] | 0;
   break;
  }
 default:
  {
   f25 = f2;
   f26 = f4;
   f27 = f5;
   f29 = f7;
   i35 = !(f25 < Math_fround(0.0));
   i36 = !(f26 < Math_fround(0.0));
   i36 = i35 & i36;
   i35 = !(f27 < Math_fround(0.0));
   i35 = i36 & i35;
   i36 = !(f29 < Math_fround(0.0));
   i36 = i35 & i36;
   return i36 | 0;
  }
 }
 if ((i21 | 0) == 9) {
  i36 = HEAP32[i1 >> 2] | 0;
  i32 = HEAP32[i20 + 832 + (i36 << 4) >> 2] | 0;
  i33 = HEAP32[i20 + 832 + (i36 << 4) + 4 >> 2] | 0;
  i34 = HEAP32[i20 + 832 + (i36 << 4) + 8 >> 2] | 0;
  i35 = HEAP32[i20 + 832 + (i36 << 4) + 12 >> 2] | 0;
  f27 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i32 | i11 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i20 + 480 + (i36 << 4) >> 2]));
  f29 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i33 | i12 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i20 + 480 + (i36 << 4) + 4 >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i34 | i9 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i36 << 4) + 8 >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i35 | i6 & i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(Math_fround(f25 * Math_fround(HEAPF32[i20 + 480 + (i36 << 4) + 12 >> 2])) + Math_fround(f26 + Math_fround(f27 + f29)));
  i1 = i1 + 4 | 0;
  f2 = f2 <= f29 ? f2 : f29;
  f4 = f4 <= f29 ? f4 : f29;
  f5 = f5 <= f29 ? f5 : f29;
  f7 = f7 <= f29 ? f7 : f29;
 }
 i35 = HEAP32[i1 >> 2] | 0;
 i32 = HEAP32[i20 + 832 + (i35 << 4) >> 2] | 0;
 i33 = HEAP32[i20 + 832 + (i35 << 4) + 4 >> 2] | 0;
 i34 = HEAP32[i20 + 832 + (i35 << 4) + 8 >> 2] | 0;
 i36 = HEAP32[i20 + 832 + (i35 << 4) + 12 >> 2] | 0;
 f25 = (HEAP32[tempDoublePtr >> 2] = i13 & ~i32 | i11 & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f25 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) >> 2]));
 f29 = (HEAP32[tempDoublePtr >> 2] = i10 & ~i33 | i12 & i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 4 >> 2]));
 f26 = (HEAP32[tempDoublePtr >> 2] = i8 & ~i34 | i9 & i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 8 >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i36 | i6 & i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i20 + 480 + (i35 << 4) + 12 >> 2])) + Math_fround(f26 + Math_fround(f25 + f29)));
 f25 = f2 <= f29 ? f2 : f29;
 f26 = f4 <= f29 ? f4 : f29;
 f27 = f5 <= f29 ? f5 : f29;
 f29 = f7 <= f29 ? f7 : f29;
 i35 = !(f25 < Math_fround(0.0));
 i36 = !(f26 < Math_fround(0.0));
 i36 = i35 & i36;
 i35 = !(f27 < Math_fround(0.0));
 i35 = i36 & i35;
 i36 = !(f29 < Math_fround(0.0));
 i36 = i35 & i36;
 return i36 | 0;
}

function __ZN21BoxTraceSegmentReport7onEventEjPj(i72, i61, i60) {
 i72 = i72 | 0;
 i61 = i61 | 0;
 i60 = i60 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i73 = 0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, i85 = 0, i86 = 0, i87 = 0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i73 + 240 | 0;
 i65 = i73 + 224 | 0;
 i66 = i73 + 208 | 0;
 i58 = i73 + 48 | 0;
 i63 = i73 + 32 | 0;
 i56 = i73 + 16 | 0;
 i62 = i73;
 i57 = i73 + 256 | 0;
 i64 = i73 + 64 | 0;
 HEAPF32[i65 >> 2] = Math_fround(0.0);
 HEAP32[i66 >> 2] = 0;
 HEAP32[i66 + 4 >> 2] = 0;
 HEAP32[i66 + 8 >> 2] = 0;
 HEAP32[i66 + 12 >> 2] = 0;
 i69 = i72 + 48 | 0;
 i70 = i72 + 52 | 0;
 i55 = HEAP32[i70 >> 2] | 0;
 i71 = i72 + 56 | 0;
 i67 = HEAP32[i71 >> 2] | 0;
 HEAP32[i58 >> 2] = HEAP32[i69 >> 2];
 i54 = i58 + 4 | 0;
 HEAP32[i54 >> 2] = i55;
 i55 = i58 + 8 | 0;
 HEAP32[i55 >> 2] = i67;
 HEAPF32[i58 + 12 >> 2] = Math_fround(0.0);
 L1 : do if (!i61) {
  i1 = i72 + 68 | 0;
  i68 = 15;
 } else {
  i7 = i72 + 12 | 0;
  i8 = i72 + 8 | 0;
  i14 = i57 + 4 | 0;
  i15 = i57 + 8 | 0;
  i16 = i57 + 12 | 0;
  i17 = i57 + 16 | 0;
  i18 = i57 + 20 | 0;
  i19 = i57 + 24 | 0;
  i20 = i57 + 28 | 0;
  i21 = i57 + 32 | 0;
  i22 = i72 + 4 | 0;
  i23 = i72 + 69 | 0;
  i24 = i64 + 64 | 0;
  i25 = i64 + 80 | 0;
  i26 = i64 + 16 | 0;
  i27 = i64 + 32 | 0;
  i28 = i64 + 48 | 0;
  i29 = i64 + 4 | 0;
  i30 = i64 + 8 | 0;
  i31 = i64 + 12 | 0;
  i32 = i64 + 96 | 0;
  i33 = i64 + 100 | 0;
  i34 = i64 + 104 | 0;
  i35 = i64 + 108 | 0;
  i36 = i64 + 112 | 0;
  i37 = i64 + 116 | 0;
  i38 = i64 + 120 | 0;
  i39 = i64 + 124 | 0;
  i40 = i64 + 128 | 0;
  i41 = i64 + 132 | 0;
  i42 = i64 + 136 | 0;
  i43 = i64 + 140 | 0;
  i44 = i72 + 16 | 0;
  i45 = i72 + 64 | 0;
  i46 = i72 + 68 | 0;
  i47 = i72 + 32 | 0;
  i48 = i72 + 32 | 0;
  i67 = i72 + 60 | 0;
  i49 = i62 + 4 | 0;
  i50 = i62 + 8 | 0;
  i51 = i56 + 4 | 0;
  i52 = i56 + 8 | 0;
  i53 = i72 + 71 | 0;
  i59 = 0;
  while (1) {
   i1 = HEAP32[i60 + (i59 << 2) >> 2] | 0;
   __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, i57, 0, 0, i1, 1, 1) | 0;
   f84 = Math_fround(HEAPF32[i57 >> 2]);
   f5 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(HEAPF32[i15 >> 2]);
   f80 = Math_fround(HEAPF32[i16 >> 2]);
   f83 = Math_fround(HEAPF32[i17 >> 2]);
   f10 = Math_fround(HEAPF32[i18 >> 2]);
   f76 = Math_fround(HEAPF32[i19 >> 2]);
   f78 = Math_fround(HEAPF32[i20 >> 2]);
   f74 = Math_fround(HEAPF32[i21 >> 2]);
   i85 = HEAP32[i22 >> 2] | 0;
   f77 = Math_fround(HEAPF32[i85 >> 2]);
   f75 = Math_fround(HEAPF32[i85 + 4 >> 2]);
   f81 = Math_fround(HEAPF32[i85 + 8 >> 2]);
   f79 = Math_fround(HEAPF32[i85 + 12 >> 2]);
   f11 = Math_fround(HEAPF32[i85 + 16 >> 2]);
   f12 = Math_fround(HEAPF32[i85 + 20 >> 2]);
   f82 = Math_fround(HEAPF32[i85 + 24 >> 2]);
   f13 = Math_fround(Math_fround(f79 * f79) + Math_fround(-.5));
   f9 = Math_fround(Math_fround(Math_fround(f84 * f77) + Math_fround(f5 * f75)) + Math_fround(f4 * f81));
   f2 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f77 * f9) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f4 * f75) - Math_fround(f5 * f81))) + Math_fround(f84 * f13))) * Math_fround(2.0)));
   f3 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f75 * f9) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f84 * f81) - Math_fround(f4 * f77))) + Math_fround(f5 * f13))) * Math_fround(2.0)));
   f4 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f81 * f9) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f5 * f77) - Math_fround(f84 * f75))) + Math_fround(f4 * f13))) * Math_fround(2.0)));
   f84 = Math_fround(Math_fround(Math_fround(f80 * f77) + Math_fround(f83 * f75)) + Math_fround(f10 * f81));
   f5 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f77 * f84) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f10 * f75) - Math_fround(f83 * f81))) + Math_fround(f80 * f13))) * Math_fround(2.0)));
   f9 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f75 * f84) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f80 * f81) - Math_fround(f10 * f77))) + Math_fround(f83 * f13))) * Math_fround(2.0)));
   f10 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f81 * f84) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f83 * f77) - Math_fround(f80 * f75))) + Math_fround(f10 * f13))) * Math_fround(2.0)));
   f80 = Math_fround(Math_fround(Math_fround(f76 * f77) + Math_fround(f78 * f75)) + Math_fround(f74 * f81));
   f11 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f77 * f80) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f74 * f75) - Math_fround(f78 * f81))) + Math_fround(f76 * f13))) * Math_fround(2.0)));
   f12 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f75 * f80) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f76 * f81) - Math_fround(f74 * f77))) + Math_fround(f78 * f13))) * Math_fround(2.0)));
   f13 = Math_fround(f82 + Math_fround(Math_fround(Math_fround(f81 * f80) + Math_fround(Math_fround(f79 * Math_fround(Math_fround(f78 * f77) - Math_fround(f76 * f75))) + Math_fround(f74 * f13))) * Math_fround(2.0)));
   if (!(HEAP8[i23 >> 0] | 0)) {
    f83 = Math_fround(f11 - f5);
    f81 = Math_fround(f12 - f9);
    f78 = Math_fround(f13 - f10);
    f84 = Math_fround(f2 - f5);
    f79 = Math_fround(f3 - f9);
    f82 = Math_fround(f4 - f10);
    f80 = Math_fround(Math_fround(f81 * f82) - Math_fround(f78 * f79));
    f82 = Math_fround(Math_fround(f78 * f84) - Math_fround(f82 * f83));
    f84 = Math_fround(Math_fround(f79 * f83) - Math_fround(f81 * f84));
    f81 = Math_fround(HEAPF32[i58 >> 2]);
    f83 = Math_fround(HEAPF32[i54 >> 2]);
    f84 = Math_fround(Math_fround(Math_fround(f80 * f81) + Math_fround(f82 * f83)) + Math_fround(f84 * Math_fround(HEAPF32[i55 >> 2])));
    if (!(f84 >= Math_fround(HEAPF32[i65 >> 2]))) i68 = 7;
   } else i68 = 7;
   if ((i68 | 0) == 7) {
    i68 = 0;
    HEAP32[i25 >> 2] = 7;
    HEAPF32[i28 >> 2] = Math_fround(0.0);
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i24 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i24 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i24 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    f83 = Math_fround(Math_fround(f12 + Math_fround(f3 + f9)) * Math_fround(.333332986));
    f84 = Math_fround(Math_fround(f13 + Math_fround(f4 + f10)) * Math_fround(.333332986));
    HEAPF32[i64 >> 2] = Math_fround(Math_fround(f11 + Math_fround(f2 + f5)) * Math_fround(.333332986));
    HEAPF32[i29 >> 2] = f83;
    HEAPF32[i30 >> 2] = f84;
    HEAPF32[i31 >> 2] = Math_fround(0.0);
    HEAPF32[i32 >> 2] = f2;
    HEAPF32[i33 >> 2] = f3;
    HEAPF32[i34 >> 2] = f4;
    HEAPF32[i35 >> 2] = Math_fround(0.0);
    HEAPF32[i36 >> 2] = f5;
    HEAPF32[i37 >> 2] = f9;
    HEAPF32[i38 >> 2] = f10;
    HEAPF32[i39 >> 2] = Math_fround(0.0);
    HEAPF32[i40 >> 2] = f11;
    HEAPF32[i41 >> 2] = f12;
    HEAPF32[i42 >> 2] = f13;
    HEAPF32[i43 >> 2] = Math_fround(0.0);
    HEAPF32[i26 >> 2] = Math_fround(0.0);
    HEAPF32[i27 >> 2] = Math_fround(3402823469999999843913219.0e14);
    if (__ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i64, HEAP32[i44 >> 2] | 0, i65, i66, i58, i63, i62, i56, Math_fround(HEAPF32[i45 >> 2]), 0) | 0) {
     HEAP8[i46 >> 0] = 1;
     f2 = Math_fround(HEAPF32[i63 >> 2]);
     if (!(f2 > Math_fround(HEAPF32[i65 >> 2]))) break;
     if (Math_fround(HEAPF32[i47 >> 2]) > f2) {
      HEAP32[i48 >> 2] = HEAP32[i63 >> 2];
      HEAP32[i48 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
      HEAP32[i48 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
      HEAP32[i48 + 12 >> 2] = HEAP32[i63 + 12 >> 2];
      i85 = HEAP32[i67 >> 2] | 0;
      HEAPF32[i85 + 40 >> 2] = f2;
      i86 = HEAP32[i49 >> 2] | 0;
      i87 = HEAP32[i50 >> 2] | 0;
      HEAP32[i85 + 28 >> 2] = HEAP32[i62 >> 2];
      HEAP32[i85 + 32 >> 2] = i86;
      HEAP32[i85 + 36 >> 2] = i87;
      i87 = HEAP32[i51 >> 2] | 0;
      i86 = HEAP32[i52 >> 2] | 0;
      HEAP32[i85 + 16 >> 2] = HEAP32[i56 >> 2];
      HEAP32[i85 + 20 >> 2] = i87;
      HEAP32[i85 + 24 >> 2] = i86;
      HEAP32[i85 + 8 >> 2] = i1;
      if (HEAP8[i53 >> 0] | 0) {
       i68 = 11;
       break;
      }
     }
    }
   }
   i59 = i59 + 1 | 0;
   if (i59 >>> 0 >= i61 >>> 0) {
    i1 = i46;
    i68 = 15;
    break L1;
   }
  }
  if ((i68 | 0) == 11) {
   i68 = 16;
   break;
  }
  i87 = HEAP32[i67 >> 2] | 0;
  HEAPF32[i87 + 40 >> 2] = Math_fround(0.0);
  HEAP32[i87 + 8 >> 2] = i1;
  HEAP8[i72 + 70 >> 0] = 1;
  i87 = 0;
  STACKTOP = i73;
  return i87 | 0;
 } while (0);
 if ((i68 | 0) == 15) if (HEAP8[i1 >> 0] | 0) i68 = 16;
 if ((i68 | 0) == 16) {
  i6 = HEAP32[i72 + 60 >> 2] | 0;
  i1 = i6 + 28 | 0;
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f4 * f4);
  i7 = i6 + 32 | 0;
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f3 * f3));
  i8 = i6 + 36 | 0;
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f2 * f2))));
  if (f5 > Math_fround(0.0)) {
   f84 = Math_fround(Math_fround(1.0) / f5);
   f4 = Math_fround(f4 * f84);
   HEAPF32[i1 >> 2] = f4;
   f3 = Math_fround(f3 * f84);
   HEAPF32[i7 >> 2] = f3;
   f2 = Math_fround(f2 * f84);
   HEAPF32[i8 >> 2] = f2;
  }
  f84 = Math_fround(f4 * Math_fround(HEAPF32[i69 >> 2]));
  f84 = Math_fround(f84 + Math_fround(f3 * Math_fround(HEAPF32[i70 >> 2])));
  if (Math_fround(f84 + Math_fround(f2 * Math_fround(HEAPF32[i71 >> 2]))) > Math_fround(0.0)) {
   f83 = Math_fround(-f3);
   f84 = Math_fround(-f2);
   HEAPF32[i6 + 28 >> 2] = Math_fround(-f4);
   HEAPF32[i7 >> 2] = f83;
   HEAPF32[i8 >> 2] = f84;
  }
  if (HEAP8[i72 + 71 >> 0] | 0) {
   i87 = 0;
   STACKTOP = i73;
   return i87 | 0;
  }
 }
 i87 = 1;
 STACKTOP = i73;
 return i87 | 0;
}

function __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i9, i10, i12, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 24 | 0;
 i13 = i15 + 8 | 0;
 i4 = i15;
 i14 = __Z12GetGfxDevicev() | 0;
 i1 = __ZNK6Camera17CalculateUsingHDREv(i9) | 0;
 i2 = i9 + 1092 | 0;
 HEAP8[i2 >> 0] = i1 & 1;
 i11 = i10 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i1 ? i3 | 2097152 : i3 & -2097153;
 i3 = __ZNK6Camera28CalculateNeedsToRenderIntoRTEv(i9) | 0;
 i1 = __ZNK6Camera26CalculateAntiAliasingForRTEv(i9) | 0;
 if (i8 & 8 | 0) {
  i5 = __Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i9 + 1124 >> 2] | 0) | 0;
  __ZN12ImageFilters7PrepareEbbi(i5, i3, (HEAP8[i2 >> 0] | 0) != 0, i1);
 }
 i5 = i9 + 1144 | 0;
 HEAP32[i5 >> 2] = 0;
 if (!(__ZNK6Camera27GetUsesScreenForCompositingEb(i9, i3) | 0)) {
  i2 = __Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i9 + 1124 >> 2] | 0) | 0;
  if (!(i8 & 32)) {
   i1 = HEAP32[i2 + 24 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!((i1 | 0) == 0 | i3 ^ 1)) {
    if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
     i1 = HEAP32[i5 >> 2] | 0;
     if (!i1) {
      i1 = __Z12GetGfxDevicev() | 0;
      i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
      i3 = __Z12GetGfxDevicev() | 0;
      i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 372 >> 2] | 0, i3 | 0) | 0;
     } else {
      i3 = HEAP32[i1 + 136 >> 2] | 0;
      i1 = HEAP32[i1 + 128 >> 2] | 0;
     }
     i2 = i1;
     if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 1) {
      i1 = __Z12GetGfxDevicev() | 0;
      i16 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
      HEAP32[i13 >> 2] = i2;
      HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
      mftCall_viiii(i16 | 0, i1 | 0, i7 | 0, 4, 0);
      if (i3 | 0) {
       i16 = HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0;
       HEAP32[i4 >> 2] = i3;
       HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
       mftCall_viiii(i16 | 0, i1 | 0, i7 | 0, 4, 0);
      }
     }
    }
    i1 = HEAP32[i5 >> 2] | 0;
   }
   do if (i1 | 0) {
    i4 = i9 + 744 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     HEAP32[i13 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i6 = 26; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i13);
       i2 = HEAP32[i7 >> 2] | 0;
       i16 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 26; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 28;
     }
     if ((i6 | 0) == 26) i6 = 28;
     if ((i6 | 0) == 28) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) break;
     if ((i8 & 128 | 0) == 0 ? ((HEAP32[i9 + 844 >> 2] | 0) + -3 | 0) >>> 0 < 2 : 0) {
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = 0; else {
       HEAP32[i13 >> 2] = i1;
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i1) i6 = 36; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i13);
         i2 = HEAP32[i7 >> 2] | 0;
         i16 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 36; else {
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i6 = 38;
        }
       }
       if ((i6 | 0) == 36) i6 = 38;
       if ((i6 | 0) == 38) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      }
      __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture(i10, i1, HEAP32[i5 >> 2] | 0);
     }
    }
   } while (0);
   i1 = HEAP32[i5 >> 2] | 0;
  } else {
   i1 = HEAP32[i2 + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
  }
  if (!i1) {
   i4 = i9 + 744 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i13 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i6 = 49; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i13);
      i2 = HEAP32[i7 >> 2] | 0;
      i16 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 49; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i6 = 51;
     }
    }
    if ((i6 | 0) == 49) i6 = 51;
    if ((i6 | 0) == 51) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   HEAP32[i5 >> 2] = i1;
  }
 }
 if (!(i8 & 4)) {
  i13 = i12 + 64 | 0;
  i16 = HEAP32[i14 >> 2] | 0;
  i16 = i16 + 116 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vii(i16 | 0, i14 | 0, i13 | 0);
  i13 = HEAP32[i14 >> 2] | 0;
  i13 = i13 + 112 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  mftCall_vii(i13 | 0, i14 | 0, i12 | 0);
  __ZN6Camera20SetCameraShaderPropsER17ShaderPassContextRK21CameraRenderingParams(i9, i10, i12);
  i13 = i14 + 4 | 0;
  i16 = __Z18GetQualitySettingsv() | 0;
  i14 = i16 + 44 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i16 = i16 + 28 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i14 = i16 + (i14 * 108 | 0) + 83 | 0;
  i14 = HEAP8[i14 >> 0] | 0;
  i14 = i14 << 24 >> 24 != 0;
  i16 = i12 + 128 | 0;
  __ZN21BillboardBatchManager23SetBillboardShaderPropsER16ShaderKeywordSetR24BuiltinShaderParamValuesbRK10Matrix4x4fRK8Vector3f(i11, i13, i14, i12, i16);
  STACKTOP = i15;
  return;
 }
 HEAP32[i5 >> 2] = __Z28EnsureRenderTextureIsCreatedP13RenderTexture(HEAP32[i5 >> 2] | 0) | 0;
 i16 = __ZN6Camera18ApplyRenderTextureEv(i9) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 if (i16) {
  __ZL19GetCameraTargetRectRK6Camerab(i7, i9, 0);
  f20 = Math_fround(HEAPF32[i9 + 864 >> 2]);
  f18 = Math_fround(HEAPF32[i9 + 868 >> 2]);
  f19 = Math_fround(HEAPF32[i9 + 872 >> 2]);
  f17 = Math_fround(HEAPF32[i9 + 876 >> 2]);
  f22 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  f20 = Math_fround(f20 * f22);
  f19 = Math_fround(f19 * f22);
  f18 = Math_fround(f18 * f21);
  f17 = Math_fround(f17 * f21);
  f24 = Math_fround(HEAPF32[i7 >> 2]);
  f23 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f20 = Math_fround(f20 + f24);
  f18 = Math_fround(f18 + f23);
  f19 = Math_fround(f19 + f20);
  f17 = Math_fround(f17 + f18);
  f22 = Math_fround(f22 + f24);
  f21 = Math_fround(f21 + f23);
  f20 = f20 < f24 ? f24 : f20;
  f18 = f18 < f23 ? f23 : f18;
  f19 = Math_fround((f19 > f22 ? f22 : f19) - f20);
  i16 = f19 < Math_fround(0.0);
  f19 = i16 ? Math_fround(0.0) : f19;
  f17 = Math_fround((f17 > f21 ? f21 : f17) - f18);
  i16 = f17 < Math_fround(0.0);
  f17 = i16 ? Math_fround(0.0) : f17;
  f21 = Math_fround(f20 + Math_fround(.5));
  i16 = f21 >= Math_fround(0.0);
  f22 = Math_fround(f21 + Math_fround(-.99999994));
  i16 = ~~(i16 ? f21 : f22);
  f22 = Math_fround(f18 + Math_fround(.5));
  i3 = f22 >= Math_fround(0.0);
  f21 = Math_fround(f22 + Math_fround(-.99999994));
  i3 = ~~(i3 ? f22 : f21);
  i2 = (~~Math_fround(Math_fround(f20 + f19) + Math_fround(.5)) >>> 0) - i16 | 0;
  i1 = (~~Math_fround(Math_fround(f18 + f17) + Math_fround(.5)) >>> 0) - i3 | 0;
  HEAP32[i13 >> 2] = i16;
 } else {
  __ZNK6Camera18GetRenderRectangleEv(i7, i9);
  f23 = Math_fround(HEAPF32[i7 >> 2]);
  f21 = Math_fround(f23 + Math_fround(.5));
  i16 = f21 >= Math_fround(0.0);
  f24 = Math_fround(f21 + Math_fround(-.99999994));
  i16 = ~~(i16 ? f21 : f24);
  f24 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f21 = Math_fround(f24 + Math_fround(.5));
  i3 = f21 >= Math_fround(0.0);
  f22 = Math_fround(f21 + Math_fround(-.99999994));
  i3 = ~~(i3 ? f21 : f22);
  i2 = (~~Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i7 + 8 >> 2])) + Math_fround(.5)) >>> 0) - i16 | 0;
  i1 = (~~Math_fround(Math_fround(f24 + Math_fround(HEAPF32[i7 + 12 >> 2])) + Math_fround(.5)) >>> 0) - i3 | 0;
  HEAP32[i13 >> 2] = i16;
 }
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i2;
 HEAP32[i13 + 12 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 152 >> 2] | 0, i14 | 0, i13 | 0);
 i13 = i12 + 64 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 i16 = i16 + 116 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vii(i16 | 0, i14 | 0, i13 | 0);
 i13 = HEAP32[i14 >> 2] | 0;
 i13 = i13 + 112 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 mftCall_vii(i13 | 0, i14 | 0, i12 | 0);
 __ZN6Camera20SetCameraShaderPropsER17ShaderPassContextRK21CameraRenderingParams(i9, i10, i12);
 i13 = i14 + 4 | 0;
 i16 = __Z18GetQualitySettingsv() | 0;
 i14 = i16 + 44 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i16 = i16 + 28 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i14 = i16 + (i14 * 108 | 0) + 83 | 0;
 i14 = HEAP8[i14 >> 0] | 0;
 i14 = i14 << 24 >> 24 != 0;
 i16 = i12 + 128 | 0;
 __ZN21BillboardBatchManager23SetBillboardShaderPropsER16ShaderKeywordSetR24BuiltinShaderParamValuesbRK10Matrix4x4fRK8Vector3f(i11, i13, i14, i12, i16);
 STACKTOP = i15;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i24, i25, i35, i1, i2, i54, i55, i56, i57) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i59 + 64 | 0;
 i26 = i59 + 48 | 0;
 i27 = i59 + 32 | 0;
 i28 = i59 + 16 | 0;
 i29 = i59;
 if (i2 >>> 0 >= i54 >>> 0) {
  STACKTOP = i59;
  return;
 }
 i30 = i1 + 500 | 0;
 i31 = i26 + 4 | 0;
 i32 = i26 + 8 | 0;
 i33 = i26 + 12 | 0;
 i34 = i1 + 520 | 0;
 i36 = i26 + 4 | 0;
 i37 = i26 + 8 | 0;
 i38 = i26 + 12 | 0;
 i39 = i58 + 16 | 0;
 i40 = i58 + 32 | 0;
 i22 = i27 + 4 | 0;
 i23 = i27 + 8 | 0;
 i15 = i27 + 12 | 0;
 i16 = i28 + 4 | 0;
 i17 = i28 + 8 | 0;
 i18 = i28 + 12 | 0;
 i19 = i29 + 4 | 0;
 i20 = i29 + 8 | 0;
 i21 = i29 + 12 | 0;
 i41 = i56 + 12 | 0;
 i42 = i56 + 24 | 0;
 i43 = i56 + 4 | 0;
 i44 = i56 + 16 | 0;
 i45 = i56 + 28 | 0;
 i46 = i56 + 8 | 0;
 i47 = i56 + 20 | 0;
 i48 = i56 + 32 | 0;
 i49 = i57 + 4 | 0;
 i50 = i57 + 8 | 0;
 i51 = i57 + 12 | 0;
 i52 = i1 + 60 | 0;
 i53 = i1 + 80 | 0;
 i14 = i1 + 100 | 0;
 do {
  i4 = (HEAP32[i30 >> 2] | 0) + (i2 << 2) | 0;
  i3 = (HEAP32[i4 + 4 >> 2] | 0) + 306581307 | 0;
  i5 = (HEAP32[i4 + 8 >> 2] | 0) + 306581307 | 0;
  i1 = (HEAP32[i4 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i26 >> 2] = (HEAP32[i4 >> 2] | 0) + 306581307;
  HEAP32[i31 >> 2] = i3;
  HEAP32[i32 >> 2] = i5;
  HEAP32[i33 >> 2] = i1;
  __Z17GenerateRandomNx3RKN4math5_int4E(i58, i26);
  i1 = (HEAP32[i34 >> 2] | 0) + (i2 << 2) | 0;
  f63 = Math_fround(HEAPF32[i1 >> 2]);
  f62 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f61 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f62 = Math_fround(f62 * Math_fround(.00999999977));
  f61 = Math_fround(f61 * Math_fround(.00999999977));
  f60 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i26 >> 2] = Math_fround(f63 * Math_fround(.00999999977));
  HEAPF32[i36 >> 2] = f62;
  HEAPF32[i37 >> 2] = f61;
  HEAPF32[i38 >> 2] = f60;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i27, i24, i26, i58);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i28, i25, i26, i39);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i29, i35, i26, i40);
  i1 = HEAP32[i27 >> 2] | 0;
  i5 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i10 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i29 >> 2] | 0;
  i11 = HEAP32[i19 >> 2] | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  if (i55) {
   f69 = Math_fround(HEAPF32[i56 >> 2]);
   f72 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround(f72 * f69);
   f71 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f71 * f69);
   f70 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround(f70 * f69);
   f65 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f65 * f69);
   f76 = Math_fround(HEAPF32[i41 >> 2]);
   f68 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f79 = Math_fround(f68 * f76);
   f67 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f78 = Math_fround(f67 * f76);
   f66 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f77 = Math_fround(f66 * f76);
   f63 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f79 = Math_fround(f61 + f79);
   f78 = Math_fround(f73 + f78);
   f77 = Math_fround(f60 + f77);
   f76 = Math_fround(f69 + Math_fround(f63 * f76));
   f69 = Math_fround(HEAPF32[i42 >> 2]);
   f60 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f60 * f69);
   f61 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = Math_fround(f61 * f69);
   f62 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f62 * f69);
   f64 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f79 + f73);
   f74 = Math_fround(f78 + f74);
   f75 = Math_fround(f77 + f75);
   f69 = Math_fround(f76 + Math_fround(f64 * f69));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   f69 = Math_fround(HEAPF32[i43 >> 2]);
   f75 = Math_fround(f72 * f69);
   f74 = Math_fround(f71 * f69);
   f73 = Math_fround(f70 * f69);
   f69 = Math_fround(f65 * f69);
   f76 = Math_fround(HEAPF32[i44 >> 2]);
   f75 = Math_fround(f75 + Math_fround(f68 * f76));
   f74 = Math_fround(f74 + Math_fround(f67 * f76));
   f73 = Math_fround(f73 + Math_fround(f66 * f76));
   f76 = Math_fround(f69 + Math_fround(f63 * f76));
   f69 = Math_fround(HEAPF32[i45 >> 2]);
   f75 = Math_fround(f75 + Math_fround(f60 * f69));
   f74 = Math_fround(f74 + Math_fround(f61 * f69));
   f73 = Math_fround(f73 + Math_fround(f62 * f69));
   f69 = Math_fround(f76 + Math_fround(f64 * f69));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f72 = Math_fround(f72 * f69);
   f71 = Math_fround(f71 * f69);
   f70 = Math_fround(f70 * f69);
   f69 = Math_fround(f65 * f69);
   f65 = Math_fround(HEAPF32[i47 >> 2]);
   f68 = Math_fround(f72 + Math_fround(f68 * f65));
   f67 = Math_fround(f71 + Math_fround(f67 * f65));
   f66 = Math_fround(f70 + Math_fround(f66 * f65));
   f65 = Math_fround(f69 + Math_fround(f63 * f65));
   f63 = Math_fround(HEAPF32[i48 >> 2]);
   f60 = Math_fround(f68 + Math_fround(f60 * f63));
   f61 = Math_fround(f67 + Math_fround(f61 * f63));
   f62 = Math_fround(f66 + Math_fround(f62 * f63));
   f63 = Math_fround(f65 + Math_fround(f64 * f63));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f67 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(HEAPF32[i57 >> 2]);
  f67 = Math_fround(f67 * f64);
  f82 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = Math_fround(HEAPF32[i49 >> 2]);
  f82 = Math_fround(f82 * f65);
  f81 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(HEAPF32[i50 >> 2]);
  f81 = Math_fround(f81 * f66);
  f80 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f79 = Math_fround(HEAPF32[i51 >> 2]);
  f80 = Math_fround(f80 * f79);
  f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f64);
  f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f65);
  f62 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66);
  f63 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f79);
  f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f64);
  f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f65);
  f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66);
  f79 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f79);
  i1 = (HEAP32[i52 >> 2] | 0) + (i2 << 2) | 0;
  f68 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = i1 + 4 | 0;
  f69 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i1 + 8 | 0;
  f70 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i1 + 12 | 0;
  f71 = Math_fround(HEAPF32[i5 >> 2]);
  i6 = (HEAP32[i53 >> 2] | 0) + (i2 << 2) | 0;
  f72 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i6 + 4 | 0;
  f73 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i6 + 8 | 0;
  f74 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i6 + 12 | 0;
  f75 = Math_fround(HEAPF32[i9 >> 2]);
  i10 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f76 = Math_fround(HEAPF32[i10 >> 2]);
  i11 = i10 + 4 | 0;
  f77 = Math_fround(HEAPF32[i11 >> 2]);
  i12 = i10 + 8 | 0;
  f78 = Math_fround(HEAPF32[i12 >> 2]);
  i13 = i10 + 12 | 0;
  f69 = Math_fround(f82 + f69);
  f70 = Math_fround(f81 + f70);
  f71 = Math_fround(f80 + f71);
  f72 = Math_fround(f60 + f72);
  f73 = Math_fround(f61 + f73);
  f74 = Math_fround(f62 + f74);
  f75 = Math_fround(f63 + f75);
  f76 = Math_fround(f64 + f76);
  f77 = Math_fround(f65 + f77);
  f78 = Math_fround(f66 + f78);
  f79 = Math_fround(f79 + Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i1 >> 2] = Math_fround(f67 + f68);
  HEAPF32[i3 >> 2] = f69;
  HEAPF32[i4 >> 2] = f70;
  HEAPF32[i5 >> 2] = f71;
  HEAPF32[i6 >> 2] = f72;
  HEAPF32[i7 >> 2] = f73;
  HEAPF32[i8 >> 2] = f74;
  HEAPF32[i9 >> 2] = f75;
  HEAPF32[i10 >> 2] = f76;
  HEAPF32[i11 >> 2] = f77;
  HEAPF32[i12 >> 2] = f78;
  HEAPF32[i13 >> 2] = f79;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i54 >>> 0);
 STACKTOP = i59;
 return;
}

function __Z18UpdateAvoidanceJobP9CrowdInfoj(i45, i46) {
 i45 = i45 | 0;
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 10480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i48 + 10468 | 0;
 i42 = i48 + 10464 | 0;
 i35 = i48;
 i37 = i35 + 10452 | 0;
 HEAP32[i37 >> 2] = 0;
 i38 = i35 + 10456 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i35 + 10460 | 0;
 HEAP32[i39 >> 2] = 0;
 i40 = i35 + 10420 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAP32[i40 + 16 >> 2] = 0;
 i47 = i45 + (i46 << 4) | 0;
 if ((HEAP16[gb + 1459380 + 6 >> 1] | 0) > -1) {
  HEAP32[i42 >> 2] = 0;
  HEAP32[i41 >> 2] = HEAP32[i42 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459380 | 0, i41);
  i20 = gb + 1459380 | 0;
 } else i20 = 0;
 i43 = i45 + (i46 << 4) + 12 | 0;
 i21 = HEAP32[i43 >> 2] | 0;
 if ((i21 | 0) > 0) {
  i22 = i45 + (i46 << 4) + 8 | 0;
  i23 = i35 + 10424 | 0;
  i24 = i35 + 10428 | 0;
  i25 = i35 + 10432 | 0;
  i26 = i35 + 10436 | 0;
  i27 = i45 + 324 | 0;
  i28 = i45 + 360 | 0;
  i29 = i45 + 352 | 0;
  i30 = i45 + 344 | 0;
  i31 = i45 + 336 | 0;
  i32 = i45 + 348 | 0;
  i33 = i45 + 340 | 0;
  i19 = 0;
  do {
   i34 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i19 << 2) >> 2] | 0;
   i36 = HEAP32[i47 >> 2] | 0;
   do if ((HEAP8[i36 + (i34 * 608 | 0) + 601 >> 0] | 0) != 2) {
    if (!(HEAP8[i36 + (i34 * 608 | 0) + 317 >> 0] & 1)) {
     HEAP32[i36 + (i34 * 608 | 0) + 528 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 504 >> 2];
     HEAP32[i36 + (i34 * 608 | 0) + 532 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 508 >> 2];
     HEAP32[i36 + (i34 * 608 | 0) + 536 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 512 >> 2];
     break;
    }
    i16 = HEAP32[i36 + (i34 * 608 | 0) + 292 >> 2] | 0;
    i9 = HEAP32[i36 + (i34 * 608 | 0) + 296 >> 2] | 0;
    HEAP32[i37 >> 2] = 0;
    HEAP32[i38 >> 2] = 0;
    HEAP32[i39 >> 2] = 0;
    HEAP32[i40 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 480 >> 2];
    HEAP32[i23 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 484 >> 2];
    HEAP32[i24 >> 2] = HEAP32[i36 + (i34 * 608 | 0) + 488 >> 2];
    HEAP32[i25 >> 2] = i16;
    HEAP32[i26 >> 2] = i9;
    i9 = HEAP32[i36 + (i34 * 608 | 0) + 384 >> 2] | 0;
    if ((i9 | 0) > 0) {
     i16 = i36 + (i34 * 608 | 0) + 316 | 0;
     i7 = 0;
     do {
      i1 = HEAP32[i36 + (i34 * 608 | 0) + 320 + (i7 << 3) >> 2] | 0;
      i2 = HEAP32[i29 >> 2] | 0;
      L17 : do if ((i1 | 0) < (i2 | 0)) {
       i3 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0;
       i5 = HEAP32[i31 >> 2] | 0;
       i1 = HEAP8[i16 >> 0] | 0;
       i2 = HEAP8[i5 + (i3 * 608 | 0) + 316 >> 0] | 0;
       f4 = (i2 & 255) > (i1 & 255) ? Math_fround(1.0) : Math_fround(0.0);
       f4 = i1 << 24 >> 24 == i2 << 24 >> 24 ? Math_fround(.5) : f4;
       i2 = HEAP32[i5 + (i3 * 608 | 0) + 384 >> 2] | 0;
       L19 : do if ((i2 | 0) > 0) {
        i1 = 0;
        while (1) {
         if ((HEAP32[i5 + (i3 * 608 | 0) + 320 + (i1 << 3) >> 2] | 0) == (i19 | 0)) break L19;
         i1 = i1 + 1 | 0;
         if ((i1 | 0) >= (i2 | 0)) {
          f4 = Math_fround(1.0);
          break;
         }
        }
       } else f4 = Math_fround(1.0); while (0);
       i1 = HEAP32[i37 >> 2] | 0;
       if ((i1 | 0) <= 103) {
        f44 = Math_fround(HEAPF32[i5 + (i3 * 608 | 0) + 292 >> 2]);
        HEAP32[i37 >> 2] = i1 + 1;
        HEAP32[i35 + (i1 * 24 | 0) >> 2] = HEAP32[i5 + (i3 * 608 | 0) + 480 >> 2];
        HEAP32[i35 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i5 + (i3 * 608 | 0) + 488 >> 2];
        HEAP32[i35 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i5 + (i3 * 608 | 0) + 516 >> 2];
        HEAP32[i35 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i5 + (i3 * 608 | 0) + 524 >> 2];
        HEAPF32[i35 + (i1 * 24 | 0) + 16 >> 2] = Math_fround(f44 + Math_fround(HEAPF32[i25 >> 2]));
        HEAPF32[i35 + (i1 * 24 | 0) + 20 >> 2] = f4;
       }
      } else {
       i1 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i1 - i2 << 2) >> 2] | 0;
       i2 = HEAP32[i33 >> 2] | 0;
       i3 = i2 + (i1 * 92 | 0) | 0;
       switch (HEAP32[i2 + (i1 * 92 | 0) + 84 >> 2] | 0) {
       case 1:
        {
         __ZN24dtObstacleAvoidanceQuery10addCapsuleEPKfS1_S1_S1_(i35, i3, i2 + (i1 * 92 | 0) + 24 | 0, i2 + (i1 * 92 | 0) + 60 | 0, i2 + (i1 * 92 | 0) + 12 | 0);
         break L17;
        }
       case 2:
        {
         __ZN24dtObstacleAvoidanceQuery6addBoxEPKfS1_S1_S1_S1_S1_(i35, i3, i2 + (i1 * 92 | 0) + 24 | 0, i2 + (i1 * 92 | 0) + 48 | 0, i2 + (i1 * 92 | 0) + 60 | 0, i2 + (i1 * 92 | 0) + 72 | 0, i2 + (i1 * 92 | 0) + 12 | 0);
         break L17;
        }
       default:
        break L17;
       }
      } while (0);
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i9 | 0));
    }
    i2 = i36 + (i34 * 608 | 0) + 288 | 0;
    if ((HEAP32[i2 >> 2] | 0) > 0) {
     i1 = 0;
     do {
      __ZN24dtObstacleAvoidanceQuery18addBoundarySegmentEPKfS1_(i35, i36 + (i34 * 608 | 0) + 64 + (i1 * 28 | 0) | 0, i36 + (i34 * 608 | 0) + 64 + (i1 * 28 | 0) + 12 | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
    }
    f44 = Math_fround(HEAPF32[i36 + (i34 * 608 | 0) + 560 >> 2]);
    __ZN24dtObstacleAvoidanceQuery22sampleVelocityAdaptiveEPKfS1_fffPffPK25dtObstacleAvoidanceParamsP21dtCrowdAgentDebugInfo(i35, i36 + (i34 * 608 | 0) + 516 | 0, i36 + (i34 * 608 | 0) + 504 | 0, Math_fround(0.0), Math_fround(0.0), f44, i36 + (i34 * 608 | 0) + 528 | 0, Math_fround(HEAPF32[i28 >> 2]), (HEAP32[i27 >> 2] | 0) + ((HEAPU8[i36 + (i34 * 608 | 0) + 318 >> 0] | 0) * 20 | 0) | 0, 0) | 0;
   } while (0);
   i19 = i19 + 1 | 0;
  } while ((i19 | 0) != (i21 | 0));
 }
 if (i20 | 0) __Z12profiler_endP19ProfilerInformation(i20);
 f44 = Math_fround(HEAPF32[i45 + 368 >> 2]);
 if ((HEAP16[gb + 1459392 + 6 >> 1] | 0) > -1) {
  HEAP32[i42 >> 2] = 0;
  HEAP32[i41 >> 2] = HEAP32[i42 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459392 | 0, i41);
  i24 = gb + 1459392 | 0;
 } else i24 = 0;
 i23 = HEAP32[i43 >> 2] | 0;
 if ((i23 | 0) > 0) {
  i22 = HEAP32[i45 + (i46 << 4) + 8 >> 2] | 0;
  i21 = HEAP32[i47 >> 2] | 0;
  i20 = 0;
  do {
   i19 = HEAP32[i22 + (i20 << 2) >> 2] | 0;
   i5 = i21 + (i19 * 608 | 0) + 480 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   HEAP32[i21 + (i19 * 608 | 0) + 540 >> 2] = i1;
   i7 = i21 + (i19 * 608 | 0) + 484 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i21 + (i19 * 608 | 0) + 544 >> 2] = i2;
   i9 = i21 + (i19 * 608 | 0) + 488 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP32[i21 + (i19 * 608 | 0) + 548 >> 2] = i3;
   do if ((HEAP8[i21 + (i19 * 608 | 0) + 601 >> 0] | 0) != 2) {
    f14 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f18 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i16 = i21 + (i19 * 608 | 0) + 516 | 0;
    f17 = Math_fround(HEAPF32[i16 >> 2]);
    HEAPF32[i5 >> 2] = Math_fround(f15 + Math_fround(f44 * f17));
    i5 = i21 + (i19 * 608 | 0) + 520 | 0;
    f15 = Math_fround(HEAPF32[i5 >> 2]);
    HEAPF32[i7 >> 2] = Math_fround(f18 + Math_fround(f44 * f15));
    i7 = i21 + (i19 * 608 | 0) + 524 | 0;
    f18 = Math_fround(HEAPF32[i7 >> 2]);
    HEAPF32[i9 >> 2] = Math_fround(f14 + Math_fround(f44 * f18));
    if (!(HEAP8[i21 + (i19 * 608 | 0) + 602 >> 0] & 2)) {
     f10 = Math_fround(f44 * Math_fround(HEAPF32[i21 + (i19 * 608 | 0) + 300 >> 2]));
     f11 = Math_fround(HEAPF32[i21 + (i19 * 608 | 0) + 528 >> 2]);
     f12 = Math_fround(f11 - f17);
     f13 = Math_fround(HEAPF32[i21 + (i19 * 608 | 0) + 532 >> 2]);
     f14 = Math_fround(f13 - f15);
     f4 = Math_fround(HEAPF32[i21 + (i19 * 608 | 0) + 536 >> 2]);
     f6 = Math_fround(f4 - f18);
     f8 = Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)) + Math_fround(f6 * f6));
     if (!(f8 <= Math_fround(f10 * f10))) {
      f13 = Math_fround(f10 / Math_fround(Math_sqrt(Math_fround(f8))));
      HEAPF32[i16 >> 2] = Math_fround(f17 + Math_fround(f12 * f13));
      HEAPF32[i5 >> 2] = Math_fround(f15 + Math_fround(f14 * f13));
      HEAPF32[i7 >> 2] = Math_fround(f18 + Math_fround(f6 * f13));
      break;
     } else {
      HEAPF32[i16 >> 2] = f11;
      HEAPF32[i5 >> 2] = f13;
      HEAPF32[i7 >> 2] = f4;
      break;
     }
    }
    i1 = i21 + (i19 * 608 | 0) + 504 | 0;
    f6 = Math_fround(HEAPF32[i1 >> 2]);
    f14 = Math_fround(f6 * f6);
    i2 = i21 + (i19 * 608 | 0) + 508 | 0;
    f8 = Math_fround(HEAPF32[i2 >> 2]);
    f14 = Math_fround(f14 + Math_fround(f8 * f8));
    i3 = i21 + (i19 * 608 | 0) + 512 | 0;
    f4 = Math_fround(HEAPF32[i3 >> 2]);
    if (!(Math_fround(f14 + Math_fround(f4 * f4)) > Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f15 * f15)) + Math_fround(f18 * f18)))) {
     HEAPF32[i21 + (i19 * 608 | 0) + 528 >> 2] = f6;
     HEAPF32[i21 + (i19 * 608 | 0) + 532 >> 2] = f8;
     HEAPF32[i21 + (i19 * 608 | 0) + 536 >> 2] = f4;
     HEAPF32[i16 >> 2] = f6;
     HEAPF32[i5 >> 2] = f8;
     HEAPF32[i7 >> 2] = f4;
     break;
    }
    f10 = Math_fround(f44 * Math_fround(HEAPF32[i21 + (i19 * 608 | 0) + 300 >> 2]));
    f11 = Math_fround(f6 - f17);
    f12 = Math_fround(f8 - f15);
    f14 = Math_fround(f4 - f18);
    f13 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f14 * f14));
    if (!(f13 <= Math_fround(f10 * f10))) {
     f4 = Math_fround(f10 / Math_fround(Math_sqrt(Math_fround(f13))));
     f6 = Math_fround(f17 + Math_fround(f11 * f4));
     HEAPF32[i16 >> 2] = f6;
     f8 = Math_fround(f15 + Math_fround(f12 * f4));
     HEAPF32[i5 >> 2] = f8;
     f4 = Math_fround(f18 + Math_fround(f14 * f4));
    } else {
     HEAPF32[i16 >> 2] = f6;
     HEAPF32[i5 >> 2] = f8;
    }
    HEAPF32[i7 >> 2] = f4;
    HEAPF32[i1 >> 2] = f6;
    HEAPF32[i2 >> 2] = f8;
    HEAPF32[i3 >> 2] = f4;
    HEAPF32[i21 + (i19 * 608 | 0) + 528 >> 2] = f6;
    HEAPF32[i21 + (i19 * 608 | 0) + 532 >> 2] = f8;
    HEAPF32[i21 + (i19 * 608 | 0) + 536 >> 2] = f4;
   } while (0);
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i23 | 0));
 }
 if (!i24) {
  STACKTOP = i48;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i48;
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i25 + 24 | 0;
 i14 = i25 + 16 | 0;
 i13 = i25 + 8 | 0;
 i12 = i25;
 i19 = i25 + 76 | 0;
 i23 = i25 + 64 | 0;
 i24 = i25 + 52 | 0;
 i22 = i25 + 40 | 0;
 i17 = i25 + 28 | 0;
 i15 = i18 + 92 | 0;
 i20 = i18 + 80 | 0;
 i10 = HEAP32[i20 >> 2] | 0;
 i1 = (i10 | 0) == 0;
 if (HEAP32[i15 >> 2] | 0) {
  if (i1) {
   i24 = 0;
   STACKTOP = i25;
   return i24 | 0;
  }
  mftCall_vi(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 63552 | 0);
  HEAP32[i20 >> 2] = 0;
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 if (i1) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i11 = i10 + 120 | 0;
 i1 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, i1, _strlen(i1) | 0);
 __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i23, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 i5 = HEAP32[i20 >> 2] | 0;
 i8 = (HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
 i2 = i5 + 2344 | 0;
 i8 = i8 | 0 ? i8 : gb + 1576256 | 0;
 i9 = _strlen(i8) | 0;
 i6 = i2 + 11 | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 if (i4) i7 = (HEAP32[i5 + 2352 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
 do if (i9 >>> 0 > i7 >>> 0) {
  if (i4) i3 = HEAP32[i5 + 2348 >> 2] | 0; else i3 = i3 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i7, i9 - i7 | 0, i3, 0, i3, i9, i8);
 } else {
  if (i4) i2 = HEAP32[i2 >> 2] | 0;
  if (i9 | 0) _memmove(i2 | 0, i8 | 0, i9 | 0) | 0;
  HEAP8[i2 + i9 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i5 + 2348 >> 2] = i9;
   break;
  } else {
   HEAP8[i6 >> 0] = i9;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i1, _strlen(i1) | 0);
 i2 = HEAP32[gb + 27264 >> 2] | 0;
 __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i19, i22);
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i1 = _strlen(i2) | 0;
 i5 = i19 + 11 | 0;
 i7 = HEAP8[i5 >> 0] | 0;
 i7 = i7 << 24 >> 24 < 0 ? HEAP32[i19 + 4 >> 2] | 0 : i7 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i24, i2, i1, i7 + i1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i24, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 HEAP32[i22 >> 2] = 0;
 i7 = i22 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i5 = i10 + 124 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 L36 : do if ((i1 | 0) == (i2 | 0)) i21 = 35; else {
  i6 = i22 + 8 | 0;
  i4 = 0;
  do {
   i3 = i2;
   if (HEAP32[i3 + (i4 * 40 | 0) + 16 >> 2] & 4) {
    i1 = i3 + (i4 * 40 | 0) + 20 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, _strlen(i1) | 0);
    __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i19, i24, i17);
    i1 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i22, i19); else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i19);
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 12;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    i1 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < ((i1 - i2 | 0) / 40 | 0) >>> 0);
  if ((HEAP32[i22 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) i21 = 35; else {
   i5 = __Z20GetPersistentManagerv() | 0;
   __ZN17PersistentManager4LockEv(i5);
   i1 = HEAP32[i22 >> 2] | 0;
   L53 : do if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) {
    i2 = 0;
    while (1) {
     if (__ZN17PersistentManager14IsStreamLoadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i1 + (i2 * 12 | 0) | 0) | 0) break;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i22 >> 2] | 0;
     if (i2 >>> 0 >= (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0) break L53;
    }
    __ZN17PersistentManager6UnlockEv(i5);
    if (HEAP32[i15 >> 2] | 0) {
     i3 = 0;
     break L36;
    }
    HEAP32[i15 >> 2] = 7;
    i1 = i18 + 112 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i13 >> 2] = i1;
    __Z6FormatPKcz(i19, gb + 365963 | 0, i13);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i18 + 96 | 0, i19) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i3 = 0;
    break L36;
   } while (0);
   i2 = __Z24GetAssetBundleFileSystemv() | 0;
   __ZN21AssetBundleFileSystem10AddArchiveEP20ArchiveStorageReader(i2, HEAP32[i20 >> 2] | 0) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i13 = HEAP32[i22 >> 2] | 0;
   i1 = i13;
   L64 : do if ((i2 | 0) == (i13 | 0)) {
    i4 = i2;
    i3 = i2;
    i2 = i1;
   } else {
    i4 = 0;
    while (1) {
     i13 = i1 + (i4 * 12 | 0) | 0;
     i4 = i4 + 1 | 0;
     if (!(__ZN17PersistentManager14LoadFileStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_24TransferInstructionFlagsii(i5, i13, i13, 256, 0, -1) | 0)) break;
     i2 = HEAP32[i7 >> 2] | 0;
     i3 = HEAP32[i22 >> 2] | 0;
     i1 = i3;
     if (i4 >>> 0 >= ((i2 - i3 | 0) / 12 | 0) >>> 0) {
      i4 = i2;
      i2 = i1;
      break L64;
     }
    }
    __ZN17PersistentManager6UnlockEv(i5);
    if (!(HEAP32[i15 >> 2] | 0)) {
     HEAP32[i15 >> 2] = 6;
     i1 = i18 + 112 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i14 >> 2] = i1;
     __Z6FormatPKcz(i19, gb + 366067 | 0, i14);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i18 + 96 | 0, i19) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    }
    i2 = __Z20GetPersistentManagerv() | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) do {
     __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i2, i1, 1);
     i1 = i1 + 12 | 0;
    } while ((i1 | 0) != (HEAP32[i7 >> 2] | 0));
    i3 = __Z24GetAssetBundleFileSystemv() | 0;
    __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader(i3, HEAP32[i20 >> 2] | 0);
    i3 = 0;
    break L36;
   } while (0);
   if (HEAP8[i18 + 124 >> 0] | 0) {
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    L83 : do if ((i4 | 0) != (i3 | 0)) {
     i1 = i18 + 112 | 0;
     i3 = 0;
     while (1) {
      if (!(__Z28TestAssetBundleCompatibilityRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_(i2 + (i3 * 12 | 0) | 0, i1, i17) | 0)) break;
      i3 = i3 + 1 | 0;
      i2 = HEAP32[i22 >> 2] | 0;
      if (i3 >>> 0 >= (((HEAP32[i7 >> 2] | 0) - i2 | 0) / 12 | 0) >>> 0) break L83;
     }
     __ZN17PersistentManager6UnlockEv(i5);
     i3 = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
     if (!(HEAP32[i15 >> 2] | 0)) {
      HEAP32[i15 >> 2] = 6;
      i2 = i18 + 96 | 0;
      if (!i3) {
       if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
       HEAP32[i16 >> 2] = i1;
       __Z6FormatPKcz(i19, gb + 366067 | 0, i16);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i19) | 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
      } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
     }
     i2 = __Z20GetPersistentManagerv() | 0;
     i1 = HEAP32[i22 >> 2] | 0;
     if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) do {
      __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i2, i1, 1);
      i1 = i1 + 12 | 0;
     } while ((i1 | 0) != (HEAP32[i7 >> 2] | 0));
     i3 = __Z24GetAssetBundleFileSystemv() | 0;
     __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader(i3, HEAP32[i20 >> 2] | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
     i3 = 0;
     break L36;
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   }
   __ZN17PersistentManager6UnlockEv(i5);
   i3 = __ZN33AssetBundleLoadFromAsyncOperation21InitializeAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i18, HEAP32[i22 >> 2] | 0) | 0;
  }
 } while (0);
 if ((i21 | 0) == 35) if (!(HEAP32[i15 >> 2] | 0)) {
  HEAP32[i15 >> 2] = 5;
  i1 = i18 + 112 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  __Z6FormatPKcz(i19, gb + 365885 | 0, i12);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i18 + 96 | 0, i19) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  i3 = 0;
 } else i3 = 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i21 = i2 + -12 | 0;
    HEAP32[i7 >> 2] = i21;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    i2 = HEAP32[i7 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i22 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 i24 = i3;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE(i29, i25) {
 i29 = i29 | 0;
 i25 = i25 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i9 = i29 + 12 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i26 = i29 + 64 | 0;
  f30 = Math_fround(HEAPF32[i26 >> 2]);
  i27 = i29 + 68 | 0;
  f2 = Math_fround(HEAPF32[i27 >> 2]);
  i25 = i29 + 72 | 0;
  f3 = Math_fround(0.0);
  i28 = i25;
  f4 = Math_fround(HEAPF32[i25 >> 2]);
  f3 = Math_fround(Math_fround(1.0) / f3);
  f30 = Math_fround(f3 * f30);
  HEAPF32[i26 >> 2] = f30;
  f2 = Math_fround(f3 * f2);
  HEAPF32[i27 >> 2] = f2;
  f4 = Math_fround(f3 * f4);
  HEAPF32[i28 >> 2] = f4;
  i29 = i29 + 76 | 0;
  HEAP8[i29 >> 0] = 1;
  return;
 }
 i18 = HEAP32[i29 + 8 >> 2] | 0;
 i19 = i29 + 4 | 0;
 i20 = i25 + 12 | 0;
 i21 = i25 + 4 | 0;
 i22 = i25 + 8 | 0;
 i23 = i25 + 16 | 0;
 i10 = i25 + 20 | 0;
 i11 = i25 + 24 | 0;
 i26 = i29 + 64 | 0;
 i27 = i29 + 68 | 0;
 i28 = i29 + 72 | 0;
 i12 = i29 + 40 | 0;
 i13 = i29 + 44 | 0;
 i14 = i29 + 48 | 0;
 i15 = i29 + 52 | 0;
 i16 = i29 + 56 | 0;
 i17 = i29 + 60 | 0;
 i24 = 0;
 do {
  i1 = HEAP32[i18 + (i24 << 2) >> 2] | 0;
  i7 = HEAP32[(HEAP32[i29 >> 2] | 0) + 40 >> 2] | 0;
  i5 = HEAP32[i7 + 12 >> 2] | 0;
  i8 = HEAP32[i7 + 8 >> 2] | 0;
  if (!(HEAP8[i7 + 156 >> 0] & 2)) {
   i6 = HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0;
   i1 = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0;
  } else {
   i6 = HEAPU16[i5 + (i1 * 6 | 0) + 2 >> 1] | 0;
   i7 = HEAPU16[i5 + (i1 * 6 | 0) >> 1] | 0;
   i1 = HEAPU16[i5 + (i1 * 6 | 0) + 4 >> 1] | 0;
  }
  i5 = HEAP32[i19 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i8 + (i7 * 12 | 0) >> 2]);
  f35 = Math_fround(f2 * Math_fround(HEAPF32[i5 >> 2]));
  f34 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 4 >> 2]));
  f2 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 8 >> 2]));
  f33 = Math_fround(HEAPF32[i8 + (i7 * 12 | 0) + 4 >> 2]);
  f37 = Math_fround(f33 * Math_fround(HEAPF32[i5 + 12 >> 2]));
  f31 = Math_fround(f33 * Math_fround(HEAPF32[i5 + 16 >> 2]));
  f37 = Math_fround(f35 + f37);
  f31 = Math_fround(f34 + f31);
  f33 = Math_fround(f2 + Math_fround(f33 * Math_fround(HEAPF32[i5 + 20 >> 2])));
  f2 = Math_fround(HEAPF32[i8 + (i7 * 12 | 0) + 8 >> 2]);
  f34 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 24 >> 2]));
  f35 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 28 >> 2]));
  f34 = Math_fround(Math_fround(f37 + f34) * Math_fround(2.0));
  f35 = Math_fround(Math_fround(f31 + f35) * Math_fround(2.0));
  f2 = Math_fround(Math_fround(f33 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 32 >> 2]))) * Math_fround(2.0));
  f33 = Math_fround(HEAPF32[i20 >> 2]);
  f31 = Math_fround(Math_fround(f33 * f33) + Math_fround(-.5));
  f37 = Math_fround(HEAPF32[i25 >> 2]);
  f32 = Math_fround(f34 * f37);
  f4 = Math_fround(HEAPF32[i21 >> 2]);
  f32 = Math_fround(f32 + Math_fround(f35 * f4));
  f3 = Math_fround(HEAPF32[i22 >> 2]);
  f32 = Math_fround(f32 + Math_fround(f2 * f3));
  f30 = Math_fround(Math_fround(f37 * f32) + Math_fround(Math_fround(f34 * f31) + Math_fround(f33 * Math_fround(Math_fround(f2 * f4) - Math_fround(f35 * f3)))));
  f36 = Math_fround(Math_fround(f4 * f32) + Math_fround(Math_fround(f35 * f31) + Math_fround(f33 * Math_fround(Math_fround(f34 * f3) - Math_fround(f37 * f2)))));
  f32 = Math_fround(Math_fround(Math_fround(f2 * f31) + Math_fround(f33 * Math_fround(Math_fround(f35 * f37) - Math_fround(f34 * f4)))) + Math_fround(f3 * f32));
  f30 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f30);
  f36 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f36);
  f32 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f32);
  HEAPF32[i26 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f30);
  HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f36);
  HEAPF32[i28 >> 2] = Math_fround(f32 + Math_fround(HEAPF32[i28 >> 2]));
  f3 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f34 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i12 >> 2] = f3 < f30 ? f3 : f30;
  HEAPF32[i13 >> 2] = f4 < f36 ? f4 : f36;
  HEAPF32[i14 >> 2] = f34 < f32 ? f34 : f32;
  f34 = Math_fround(HEAPF32[i15 >> 2]);
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  f3 = Math_fround(HEAPF32[i17 >> 2]);
  HEAPF32[i15 >> 2] = f34 > f30 ? f34 : f30;
  HEAPF32[i16 >> 2] = f4 > f36 ? f4 : f36;
  HEAPF32[i17 >> 2] = f3 > f32 ? f3 : f32;
  i7 = HEAP32[i19 >> 2] | 0;
  f32 = Math_fround(HEAPF32[i8 + (i6 * 12 | 0) >> 2]);
  f3 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
  f36 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 4 >> 2]));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 8 >> 2]));
  f4 = Math_fround(HEAPF32[i8 + (i6 * 12 | 0) + 4 >> 2]);
  f30 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 12 >> 2]));
  f34 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 16 >> 2]));
  f30 = Math_fround(f3 + f30);
  f34 = Math_fround(f36 + f34);
  f4 = Math_fround(f32 + Math_fround(f4 * Math_fround(HEAPF32[i7 + 20 >> 2])));
  f32 = Math_fround(HEAPF32[i8 + (i6 * 12 | 0) + 8 >> 2]);
  f36 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 24 >> 2]));
  f3 = Math_fround(f32 * Math_fround(HEAPF32[i7 + 28 >> 2]));
  f36 = Math_fround(Math_fround(f30 + f36) * Math_fround(2.0));
  f3 = Math_fround(Math_fround(f34 + f3) * Math_fround(2.0));
  f32 = Math_fround(Math_fround(f4 + Math_fround(f32 * Math_fround(HEAPF32[i7 + 32 >> 2]))) * Math_fround(2.0));
  f4 = Math_fround(HEAPF32[i20 >> 2]);
  f34 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
  f30 = Math_fround(HEAPF32[i25 >> 2]);
  f37 = Math_fround(f36 * f30);
  f35 = Math_fround(HEAPF32[i21 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f3 * f35));
  f33 = Math_fround(HEAPF32[i22 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f32 * f33));
  f31 = Math_fround(Math_fround(f30 * f37) + Math_fround(Math_fround(f36 * f34) + Math_fround(f4 * Math_fround(Math_fround(f32 * f35) - Math_fround(f3 * f33)))));
  f2 = Math_fround(Math_fround(f35 * f37) + Math_fround(Math_fround(f3 * f34) + Math_fround(f4 * Math_fround(Math_fround(f36 * f33) - Math_fround(f30 * f32)))));
  f37 = Math_fround(Math_fround(Math_fround(f32 * f34) + Math_fround(f4 * Math_fround(Math_fround(f3 * f30) - Math_fround(f36 * f35)))) + Math_fround(f33 * f37));
  f31 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f31);
  f2 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f2);
  f37 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f37);
  HEAPF32[i26 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f31);
  HEAPF32[i27 >> 2] = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f2);
  HEAPF32[i28 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i28 >> 2]));
  f33 = Math_fround(HEAPF32[i12 >> 2]);
  f35 = Math_fround(HEAPF32[i13 >> 2]);
  f36 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i12 >> 2] = f33 < f31 ? f33 : f31;
  HEAPF32[i13 >> 2] = f35 < f2 ? f35 : f2;
  HEAPF32[i14 >> 2] = f36 < f37 ? f36 : f37;
  f36 = Math_fround(HEAPF32[i15 >> 2]);
  f35 = Math_fround(HEAPF32[i16 >> 2]);
  f33 = Math_fround(HEAPF32[i17 >> 2]);
  HEAPF32[i15 >> 2] = f36 > f31 ? f36 : f31;
  HEAPF32[i16 >> 2] = f35 > f2 ? f35 : f2;
  HEAPF32[i17 >> 2] = f33 > f37 ? f33 : f37;
  i7 = HEAP32[i19 >> 2] | 0;
  f37 = Math_fround(HEAPF32[i8 + (i1 * 12 | 0) >> 2]);
  f33 = Math_fround(f37 * Math_fround(HEAPF32[i7 >> 2]));
  f2 = Math_fround(f37 * Math_fround(HEAPF32[i7 + 4 >> 2]));
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i7 + 8 >> 2]));
  f35 = Math_fround(HEAPF32[i8 + (i1 * 12 | 0) + 4 >> 2]);
  f31 = Math_fround(f35 * Math_fround(HEAPF32[i7 + 12 >> 2]));
  f36 = Math_fround(f35 * Math_fround(HEAPF32[i7 + 16 >> 2]));
  f31 = Math_fround(f33 + f31);
  f36 = Math_fround(f2 + f36);
  f35 = Math_fround(f37 + Math_fround(f35 * Math_fround(HEAPF32[i7 + 20 >> 2])));
  f37 = Math_fround(HEAPF32[i8 + (i1 * 12 | 0) + 8 >> 2]);
  f2 = Math_fround(f37 * Math_fround(HEAPF32[i7 + 24 >> 2]));
  f33 = Math_fround(f37 * Math_fround(HEAPF32[i7 + 28 >> 2]));
  f2 = Math_fround(Math_fround(f31 + f2) * Math_fround(2.0));
  f33 = Math_fround(Math_fround(f36 + f33) * Math_fround(2.0));
  f37 = Math_fround(Math_fround(f35 + Math_fround(f37 * Math_fround(HEAPF32[i7 + 32 >> 2]))) * Math_fround(2.0));
  f35 = Math_fround(HEAPF32[i20 >> 2]);
  f36 = Math_fround(Math_fround(f35 * f35) + Math_fround(-.5));
  f31 = Math_fround(HEAPF32[i25 >> 2]);
  f30 = Math_fround(f2 * f31);
  f3 = Math_fround(HEAPF32[i21 >> 2]);
  f30 = Math_fround(f30 + Math_fround(f33 * f3));
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f30 = Math_fround(f30 + Math_fround(f37 * f4));
  f34 = Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f2 * f36) + Math_fround(f35 * Math_fround(Math_fround(f37 * f3) - Math_fround(f33 * f4)))));
  f32 = Math_fround(Math_fround(f3 * f30) + Math_fround(Math_fround(f33 * f36) + Math_fround(f35 * Math_fround(Math_fround(f2 * f4) - Math_fround(f31 * f37)))));
  f30 = Math_fround(Math_fround(Math_fround(f37 * f36) + Math_fround(f35 * Math_fround(Math_fround(f33 * f31) - Math_fround(f2 * f3)))) + Math_fround(f4 * f30));
  f34 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f34);
  f32 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f32);
  f30 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f30);
  f4 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f34);
  HEAPF32[i26 >> 2] = f4;
  f3 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f32);
  HEAPF32[i27 >> 2] = f3;
  f2 = Math_fround(f30 + Math_fround(HEAPF32[i28 >> 2]));
  HEAPF32[i28 >> 2] = f2;
  f31 = Math_fround(HEAPF32[i12 >> 2]);
  f33 = Math_fround(HEAPF32[i13 >> 2]);
  f35 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i12 >> 2] = f31 < f34 ? f31 : f34;
  HEAPF32[i13 >> 2] = f33 < f32 ? f33 : f32;
  HEAPF32[i14 >> 2] = f35 < f30 ? f35 : f30;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  f33 = Math_fround(HEAPF32[i16 >> 2]);
  f31 = Math_fround(HEAPF32[i17 >> 2]);
  HEAPF32[i15 >> 2] = f35 > f34 ? f35 : f34;
  HEAPF32[i16 >> 2] = f33 > f32 ? f33 : f32;
  HEAPF32[i17 >> 2] = f31 > f30 ? f31 : f30;
  i24 = i24 + 1 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } while (i24 >>> 0 < i1 >>> 0);
 f36 = Math_fround((i1 * 3 | 0) >>> 0);
 f34 = f4;
 f35 = f3;
 f37 = f2;
 f36 = Math_fround(Math_fround(1.0) / f36);
 f34 = Math_fround(f36 * f34);
 HEAPF32[i26 >> 2] = f34;
 f35 = Math_fround(f36 * f35);
 HEAPF32[i27 >> 2] = f35;
 f37 = Math_fround(f36 * f37);
 HEAPF32[i28 >> 2] = f37;
 i29 = i29 + 76 | 0;
 HEAP8[i29 >> 0] = 1;
 return;
}

function __ZN5physx19calcForce4_onlyPtrsERNS_6shdfnd3aos6Mat44VEPKNS_16PxsFluidParticleES6_S6_S6_RKS2_S8_RKNS_30PxsFluidDynamicsParametersSIMDE(i1, i2, i3, i4, i5, i7, i8, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0;
 f43 = Math_fround(HEAPF32[i2 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f48 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f42 = Math_fround(HEAPF32[i3 >> 2]);
 f38 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f41 = Math_fround(HEAPF32[i4 >> 2]);
 f37 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f40 = Math_fround(HEAPF32[i5 >> 2]);
 f36 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f58 = Math_fround(HEAPF32[i7 >> 2]);
 f55 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f52 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f43 = Math_fround(f58 - f43);
 f42 = Math_fround(f55 - f42);
 f41 = Math_fround(f52 - f41);
 f40 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) - f40);
 f52 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f55 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f58 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f39 = Math_fround(f52 - f39);
 f38 = Math_fround(f55 - f38);
 f37 = Math_fround(f58 - f37);
 f36 = Math_fround(Math_fround(HEAPF32[i7 + 28 >> 2]) - f36);
 f58 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f55 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f52 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 f48 = Math_fround(f58 - f48);
 f26 = Math_fround(f55 - f26);
 f30 = Math_fround(f52 - f30);
 f34 = Math_fround(Math_fround(HEAPF32[i7 + 44 >> 2]) - f34);
 f52 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f39 * f39)) + Math_fround(f48 * f48));
 f55 = Math_fround(Math_fround(Math_fround(f42 * f42) + Math_fround(f38 * f38)) + Math_fround(f26 * f26));
 f58 = Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f37 * f37)) + Math_fround(f30 * f30));
 f31 = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f36 * f36)) + Math_fround(f34 * f34));
 f59 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f56 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f53 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f59 = Math_fround(f52 * f59);
 f56 = Math_fround(f55 * f56);
 f53 = Math_fround(f58 * f53);
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i6 + 28 >> 2]));
 f58 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f59))));
 f55 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f56))));
 f52 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f53))));
 f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f31))));
 f59 = Math_fround(f59 * f58);
 f56 = Math_fround(f56 * f55);
 f53 = Math_fround(f53 * f52);
 f31 = Math_fround(f31 * f35);
 f50 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f21 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f45 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 44 >> 2]);
 f46 = Math_fround(f50 - f59);
 f44 = Math_fround(f21 - f56);
 f23 = Math_fround(f45 - f53);
 f11 = Math_fround(f10 - f31);
 i2 = i2 + 16 | 0;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i3 = i3 + 16 | 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i4 = i4 + 16 | 0;
 f17 = Math_fround(HEAPF32[i4 >> 2]);
 f32 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i5 = i5 + 16 | 0;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f60 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f27 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f54 = Math_fround(HEAPF32[i7 + 56 >> 2]);
 f57 = Math_fround(HEAPF32[i7 + 60 >> 2]);
 f51 = Math_fround(HEAPF32[i6 + 112 >> 2]);
 f49 = Math_fround(HEAPF32[i6 + 116 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 120 >> 2]);
 f47 = Math_fround(HEAPF32[i6 + 124 >> 2]);
 f60 = Math_fround(f60 - f51);
 f27 = Math_fround(f27 - f49);
 f54 = Math_fround(f54 - f22);
 f57 = Math_fround(f57 - f47);
 f51 = Math_fround(f13 - f51);
 f49 = Math_fround(f15 - f49);
 f22 = Math_fround(f14 - f22);
 f47 = Math_fround(f9 - f47);
 i7 = f60 > Math_fround(0.0);
 f60 = i7 ? f60 : Math_fround(0.0);
 i7 = f27 > Math_fround(0.0);
 f27 = i7 ? f27 : Math_fround(0.0);
 i7 = f54 > Math_fround(0.0);
 f54 = i7 ? f54 : Math_fround(0.0);
 i7 = f57 > Math_fround(0.0);
 f57 = i7 ? f57 : Math_fround(0.0);
 i7 = f51 > Math_fround(0.0);
 f51 = i7 ? f51 : Math_fround(0.0);
 i7 = f49 > Math_fround(0.0);
 f49 = i7 ? f49 : Math_fround(0.0);
 i7 = f22 > Math_fround(0.0);
 f22 = i7 ? f22 : Math_fround(0.0);
 i7 = f47 > Math_fround(0.0);
 f51 = Math_fround(f60 + f51);
 f49 = Math_fround(f27 + f49);
 f22 = Math_fround(f54 + f22);
 f47 = Math_fround(f57 + (i7 ? f47 : Math_fround(0.0)));
 f50 = Math_fround(f50 + f50);
 f21 = Math_fround(f21 + f21);
 f45 = Math_fround(f45 + f45);
 f10 = Math_fround(f10 + f10);
 f57 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f54 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f27 = Math_fround(HEAPF32[i6 + 56 >> 2]);
 f50 = Math_fround(Math_fround(f59 + Math_fround(f58 * f57)) - f50);
 f21 = Math_fround(Math_fround(f56 + Math_fround(f55 * f54)) - f21);
 f45 = Math_fround(Math_fround(f53 + Math_fround(f52 * f27)) - f45);
 f10 = Math_fround(Math_fround(f31 + Math_fround(f35 * Math_fround(HEAPF32[i6 + 60 >> 2]))) - f10);
 f35 = Math_fround(HEAPF32[i6 + 80 >> 2]);
 f31 = Math_fround(HEAPF32[i6 + 84 >> 2]);
 f27 = Math_fround(HEAPF32[i6 + 88 >> 2]);
 f35 = Math_fround(f51 * Math_fround(f50 * f35));
 f31 = Math_fround(f49 * Math_fround(f21 * f31));
 f27 = Math_fround(f22 * Math_fround(f45 * f27));
 f10 = Math_fround(f47 * Math_fround(f10 * Math_fround(HEAPF32[i6 + 92 >> 2])));
 f47 = Math_fround(HEAPF32[i6 >> 2]);
 f45 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f35 = Math_fround(f35 * f47);
 f31 = Math_fround(f31 * f45);
 f27 = Math_fround(f27 * f22);
 f10 = Math_fround(f10 * f21);
 f43 = Math_fround(f43 * f35);
 f42 = Math_fround(f42 * f31);
 f41 = Math_fround(f41 * f27);
 f40 = Math_fround(f40 * f10);
 f39 = Math_fround(f39 * f35);
 f38 = Math_fround(f38 * f31);
 f37 = Math_fround(f37 * f27);
 f36 = Math_fround(f36 * f10);
 f35 = Math_fround(f48 * f35);
 f31 = Math_fround(f26 * f31);
 f27 = Math_fround(f30 * f27);
 f10 = Math_fround(f34 * f10);
 f34 = Math_fround(HEAPF32[i6 + 96 >> 2]);
 f30 = Math_fround(HEAPF32[i6 + 100 >> 2]);
 f26 = Math_fround(HEAPF32[i6 + 104 >> 2]);
 f34 = Math_fround(f47 * Math_fround(f46 * f34));
 f30 = Math_fround(f45 * Math_fround(f44 * f30));
 f26 = Math_fround(f22 * Math_fround(f23 * f26));
 f11 = Math_fround(f21 * Math_fround(f11 * Math_fround(HEAPF32[i6 + 108 >> 2])));
 f21 = Math_fround(HEAPF32[i8 >> 2]);
 f23 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f21 = Math_fround(f18 - f21);
 f23 = Math_fround(f19 - f23);
 f22 = Math_fround(f17 - f22);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i8 + 12 >> 2]));
 f17 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f18 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 f17 = Math_fround(f24 - f17);
 f19 = Math_fround(f28 - f19);
 f18 = Math_fround(f32 - f18);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i8 + 28 >> 2]));
 f32 = Math_fround(HEAPF32[i8 + 32 >> 2]);
 f28 = Math_fround(HEAPF32[i8 + 36 >> 2]);
 f24 = Math_fround(HEAPF32[i8 + 40 >> 2]);
 f13 = Math_fround(Math_fround(1.0) / f13);
 f15 = Math_fround(Math_fround(1.0) / f15);
 f14 = Math_fround(Math_fround(1.0) / f14);
 f9 = Math_fround(Math_fround(1.0) / f9);
 f21 = Math_fround(Math_fround(f43 + Math_fround(f34 * f21)) * f13);
 f23 = Math_fround(Math_fround(f42 + Math_fround(f30 * f23)) * f15);
 f22 = Math_fround(Math_fround(f41 + Math_fround(f26 * f22)) * f14);
 f16 = Math_fround(Math_fround(f40 + Math_fround(f11 * f16)) * f9);
 f17 = Math_fround(Math_fround(f39 + Math_fround(f34 * f17)) * f13);
 f19 = Math_fround(Math_fround(f38 + Math_fround(f30 * f19)) * f15);
 f18 = Math_fround(Math_fround(f37 + Math_fround(f26 * f18)) * f14);
 f12 = Math_fround(Math_fround(f36 + Math_fround(f11 * f12)) * f9);
 f13 = Math_fround(Math_fround(f35 + Math_fround(f34 * Math_fround(f33 - f32))) * f13);
 f15 = Math_fround(Math_fround(f31 + Math_fround(f30 * Math_fround(f29 - f28))) * f15);
 f14 = Math_fround(Math_fround(f27 + Math_fround(f26 * Math_fround(f25 - f24))) * f14);
 f9 = Math_fround(Math_fround(f10 + Math_fround(f11 * Math_fround(f20 - Math_fround(HEAPF32[i8 + 44 >> 2])))) * f9);
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = i1 + 4 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i1 + 8 | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i1 + 12 | 0;
 f11 = Math_fround(f23 + f11);
 f10 = Math_fround(f22 + f10);
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f21 + f20);
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f16;
 i8 = i1 + 16 | 0;
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = i1 + 20 | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i6 = i1 + 24 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = i1 + 28 | 0;
 f10 = Math_fround(f19 + f10);
 f11 = Math_fround(f18 + f11);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f17 + f16);
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i5 >> 2] = f12;
 i5 = i1 + 32 | 0;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i1 + 36 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i1 + 40 | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i1 + 44 | 0;
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f14 + f10);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i5 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f9;
 return;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK8GUIStyle17DrawTextUnderlineER8GUIStateRK5RectTIfER10GUIContentiiPK13GUIStyleState(i21, i13, i22, i23, i24, i25, i14) {
 i21 = i21 | 0;
 i13 = i13 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i14 = i14 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, d11 = 0.0, f12 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34 + 24 | 0;
 i31 = i34;
 i29 = i34 + 20 | 0;
 i32 = i34 + 16 | 0;
 if (!(HEAP32[i13 + 60 >> 2] | 0)) {
  STACKTOP = i34;
  return;
 }
 f12 = Math_fround(HEAPF32[i13 + 252 >> 2]);
 f16 = Math_fround(HEAPF32[i13 + 256 >> 2]);
 f17 = Math_fround(HEAPF32[i13 + 260 >> 2]);
 f18 = Math_fround(HEAPF32[i13 + 264 >> 2]);
 HEAPF32[gb + 1468288 >> 2] = f12;
 HEAPF32[gb + 1468288 + 4 >> 2] = f16;
 HEAPF32[gb + 1468288 + 8 >> 2] = f17;
 HEAPF32[gb + 1468288 + 12 >> 2] = f18;
 __ZN10Matrix4x4f11SetIdentityEv(i33) | 0;
 i2 = f17 > Math_fround(0.0);
 f20 = Math_fround(Math_fround(.875) / f17);
 f20 = i2 ? f20 : Math_fround(inf);
 HEAPF32[i33 >> 2] = f20;
 i2 = f18 > Math_fround(0.0);
 f26 = Math_fround(Math_fround(.875) / f18);
 f26 = i2 ? f26 : Math_fround(inf);
 HEAPF32[i33 + 20 >> 2] = f26;
 HEAPF32[i33 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f12 * f20));
 HEAPF32[i33 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f16 * f26));
 HEAPF32[i33 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i33 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i33 + 56 >> 2] = Math_fround(1.0);
 i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i4 = i33;
 i7 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i2 = i2 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i2 | 0) < (i7 | 0));
 i30 = __ZN10builtintex15GetWhiteTextureEv() | 0;
 i2 = __ZNK8GUIStyle14GetCurrentFontEv(i21) | 0;
 do if (!i2) f26 = Math_fround(0.0); else {
  i3 = HEAP32[i21 + 284 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i2 + 36 >> 2] | 0;
   if (i4 | 0) {
    f26 = Math_fround(Math_fround(Math_fround(((i3 | 0) > 500 ? 500 : i3) | 0) * Math_fround(HEAPF32[i2 + 32 >> 2])) / Math_fround(i4 | 0));
    break;
   }
  }
  f26 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 } while (0);
 i2 = HEAP32[gb + 1468864 >> 2] | 0;
 if (!i2) {
  i27 = __Z15GetScriptMapperv() | 0;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i33, gb + 1017441 | 0, 30);
  i27 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i27, i33) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i33);
  i27 = __ZN8Material14CreateMaterialER6Shaderib(i27, 61, 0) | 0;
  HEAP32[gb + 1468864 >> 2] = i27;
  __Z24InitializeGUIClipTexturev();
  i27 = HEAP32[gb + 1468864 >> 2] | 0;
 } else i27 = i2;
 f8 = Math_fround(HEAPF32[i22 >> 2]);
 f6 = Math_fround(f8 + Math_fround(HEAP32[i21 + 208 >> 2] | 0));
 f1 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f5 = Math_fround(f1 + Math_fround(HEAP32[i21 + 216 >> 2] | 0));
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i22 + 8 >> 2]));
 f8 = Math_fround(Math_fround(f8 - Math_fround(HEAP32[i21 + 212 >> 2] | 0)) - f6);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i28 = i21 + 252 | 0;
 if (!(HEAP32[i28 >> 2] | 0)) {
  i9 = i21 + 272 | 0;
  i10 = i21 + 268 | 0;
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f17 = Math_fround(0.0);
  f18 = Math_fround(0.0);
 } else {
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i22 + 12 >> 2]));
  f19 = Math_fround(f6 + f8);
  f1 = Math_fround(f5 + Math_fround(Math_fround(f1 - Math_fround(HEAP32[i21 + 220 >> 2] | 0)) - f5));
  f35 = Math_fround(f12 + f17);
  f20 = Math_fround(f16 + f18);
  i15 = f6 < f12;
  f8 = f5 < f16 ? f16 : f5;
  f6 = Math_fround((f19 > f35 ? f35 : f19) - (i15 ? f12 : f6));
  i10 = f6 < Math_fround(0.0);
  f6 = i10 ? Math_fround(0.0) : f6;
  f5 = Math_fround((f1 > f20 ? f20 : f1) - f8);
  i10 = f5 < Math_fround(0.0);
  f5 = i10 ? Math_fround(0.0) : f5;
  f1 = Math_fround(HEAPF32[i21 + 260 >> 2]);
  i10 = i21 + 268 | 0;
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i10 >> 2]));
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15 ? (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) : i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f1);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  f20 = Math_fround(HEAPF32[i21 + 264 >> 2]);
  i9 = i21 + 272 | 0;
  f20 = Math_fround(f8 + Math_fround(f20 + Math_fround(HEAPF32[i9 >> 2])));
  HEAPF32[gb + 1468288 >> 2] = f19;
  HEAPF32[gb + 1468288 + 4 >> 2] = f20;
  HEAPF32[gb + 1468288 + 8 >> 2] = f6;
  HEAPF32[gb + 1468288 + 12 >> 2] = f5;
  __ZN10Matrix4x4f11SetIdentityEv(i33) | 0;
  i2 = f6 > Math_fround(0.0);
  f8 = Math_fround(Math_fround(.875) / f6);
  f8 = i2 ? f8 : Math_fround(inf);
  HEAPF32[i33 >> 2] = f8;
  i2 = f5 > Math_fround(0.0);
  f35 = Math_fround(Math_fround(.875) / f5);
  f35 = i2 ? f35 : Math_fround(inf);
  HEAPF32[i33 + 20 >> 2] = f35;
  HEAPF32[i33 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f8 * f19));
  HEAPF32[i33 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f20 * f35));
  HEAPF32[i33 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i33 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i33 + 56 >> 2] = Math_fround(1.0);
  i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
  i4 = i33;
  i7 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i7 | 0));
  f20 = f12;
  f8 = f6;
  f19 = f16;
 }
 f6 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i13 + 12 >> 2]));
 f35 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f35 = Math_fround(f35 * Math_fround(HEAPF32[i13 + 16 >> 2]));
 f1 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i13 + 20 >> 2]));
 f16 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i13 + 24 >> 2]));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i13 + 44 >> 2]));
 f35 = Math_fround(f35 * Math_fround(HEAPF32[i13 + 48 >> 2]));
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i13 + 52 >> 2]));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i13 + 56 >> 2]));
 i2 = f6 < Math_fround(0.0);
 f6 = i2 ? Math_fround(0.0) : f6;
 i2 = f6 > Math_fround(1.0);
 i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i13 = f35 < Math_fround(0.0);
 f35 = i13 ? Math_fround(0.0) : f35;
 i13 = f35 > Math_fround(1.0);
 i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f35) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i14 = f1 < Math_fround(0.0);
 f1 = i14 ? Math_fround(0.0) : f1;
 i14 = f1 > Math_fround(1.0);
 i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f1) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i15 = f16 < Math_fround(0.0);
 f16 = i15 ? Math_fround(0.0) : f16;
 i15 = f16 > Math_fround(1.0);
 i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i33, i21, i22, i23, (i24 | 0) < (i25 | 0) ? i24 : i25);
 f16 = Math_fround(HEAPF32[i33 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i10 >> 2]));
 f1 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i9 >> 2]));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i33, i21, i22, i23, (i24 | 0) > (i25 | 0) ? i24 : i25);
 f16 = Math_fround(HEAPF32[i33 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i10 >> 2]));
 f35 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f35 = Math_fround(f35 - Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f26 * Math_fround(.0299999993));
 i25 = f6 > Math_fround(1.0);
 f6 = i25 ? f6 : Math_fround(1.0);
 f12 = Math_fround(Math_fround(f26 * Math_fround(.949999988)) - f6);
 d11 = +f35 + -.01;
 if (+f1 < d11) {
  f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f8);
  i7 = i31 + 8 | 0;
  i9 = i31 + 4 | 0;
  i10 = i31 + 12 | 0;
  i2 = i13 << 8 & 65280 | i2 & 255 | i14 << 16 & 16711680 | i15 << 24;
  while (1) {
   f35 = Math_fround(f12 + f1);
   f8 = Math_fround(Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + Math_fround(1.0));
   HEAP32[i31 >> 2] = i4;
   HEAPF32[i7 >> 2] = f8;
   HEAPF32[i9 >> 2] = f35;
   HEAPF32[i10 >> 2] = f6;
   HEAP32[i29 >> 2] = i2;
   HEAP32[i33 >> 2] = HEAP32[i29 >> 2];
   __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i31, i30, i33, i27, -1);
   f1 = Math_fround(f1 + Math_fround(Math_ceil(Math_fround(f26))));
   if (+f1 < d11) i4 = i3; else break;
  }
 } else {
  i3 = i4;
  i2 = i13 << 8 & 65280 | i2 & 255 | i14 << 16 & 16711680 | i15 << 24;
 }
 f35 = Math_fround(f12 + f1);
 f26 = Math_fround(Math_fround(f16 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + Math_fround(1.0));
 HEAP32[i31 >> 2] = i3;
 HEAPF32[i31 + 8 >> 2] = f26;
 HEAPF32[i31 + 4 >> 2] = f35;
 HEAPF32[i31 + 12 >> 2] = f6;
 HEAP32[i32 >> 2] = i2;
 HEAP32[i33 >> 2] = HEAP32[i32 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i31, i30, i33, i27, -1);
 if (!(HEAP32[i28 >> 2] | 0)) {
  STACKTOP = i34;
  return;
 }
 HEAPF32[gb + 1468288 >> 2] = f20;
 HEAPF32[gb + 1468288 + 4 >> 2] = f19;
 HEAPF32[gb + 1468288 + 8 >> 2] = f17;
 HEAPF32[gb + 1468288 + 12 >> 2] = f18;
 __ZN10Matrix4x4f11SetIdentityEv(i33) | 0;
 i2 = f17 > Math_fround(0.0);
 f26 = Math_fround(Math_fround(.875) / f17);
 f26 = i2 ? f26 : Math_fround(inf);
 HEAPF32[i33 >> 2] = f26;
 i2 = f18 > Math_fround(0.0);
 f35 = Math_fround(Math_fround(.875) / f18);
 f35 = i2 ? f35 : Math_fround(inf);
 HEAPF32[i33 + 20 >> 2] = f35;
 HEAPF32[i33 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f20 * f26));
 HEAPF32[i33 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f19 * f35));
 HEAPF32[i33 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i33 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i33 + 56 >> 2] = Math_fround(1.0);
 i2 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i4 = i33;
 i7 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i2 = i2 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i2 | 0) < (i7 | 0));
 STACKTOP = i34;
 return;
}

function _unity_z_tr_flush_block(i17, i14, i15, i16) {
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if ((HEAP32[i17 + 132 >> 2] | 0) > 0) {
  if (i15 | 0) {
   i2 = (HEAP32[i17 >> 2] | 0) + 44 | 0;
   if ((HEAP32[i2 >> 2] | 0) == 2) {
    do if (!(HEAP16[i17 + 148 >> 1] | 0)) if (!(HEAP16[i17 + 152 >> 1] | 0)) if (!(HEAP16[i17 + 156 >> 1] | 0)) if (!(HEAP16[i17 + 160 >> 1] | 0)) if (!(HEAP16[i17 + 164 >> 1] | 0)) if (!(HEAP16[i17 + 168 >> 1] | 0)) if (!(HEAP16[i17 + 172 >> 1] | 0)) if (!(HEAP16[i17 + 176 >> 1] | 0)) if (!(HEAP16[i17 + 180 >> 1] | 0)) if (!(HEAP16[i17 + 204 >> 1] | 0)) if (!(HEAP16[i17 + 208 >> 1] | 0)) if (!(HEAP16[i17 + 212 >> 1] | 0)) if (!(HEAP16[i17 + 216 >> 1] | 0)) if (!(HEAP16[i17 + 220 >> 1] | 0)) {
     if (HEAP16[i17 + 224 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 228 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 232 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 236 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 240 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 244 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 248 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 252 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 256 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 260 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 264 >> 1] | 0) {
      i1 = 0;
      break;
     }
     if (HEAP16[i17 + 268 >> 1] | 0) {
      i1 = 0;
      break;
     }
     i1 = (HEAP16[i17 + 272 >> 1] | 0) == 0;
    } else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0; while (0);
    HEAP32[i2 >> 2] = i1 & 1;
   }
  }
  _build_tree(i17, i17 + 2840 | 0);
  _build_tree(i17, i17 + 2852 | 0);
  i10 = HEAP32[i17 + 2844 >> 2] | 0;
  i7 = HEAP16[i17 + 150 >> 1] | 0;
  i4 = i7 << 16 >> 16 == 0;
  HEAP16[i17 + 148 + (i10 + 1 << 2) + 2 >> 1] = -1;
  i11 = i17 + 2752 | 0;
  i12 = i17 + 2756 | 0;
  i13 = i17 + 2748 | 0;
  i7 = i7 & 65535;
  i1 = 0;
  i8 = -1;
  i3 = i4 ? 3 : 4;
  i4 = i4 ? 138 : 7;
  L35 : while (1) {
   i2 = 0;
   do {
    if ((i1 | 0) > (i10 | 0)) break L35;
    i1 = i1 + 1 | 0;
    i5 = HEAP16[i17 + 148 + (i1 << 2) + 2 >> 1] | 0;
    i6 = i5 & 65535;
    i2 = i2 + 1 | 0;
    i9 = (i7 | 0) == (i6 | 0);
   } while ((i2 | 0) < (i4 | 0) & i9);
   do if ((i2 | 0) < (i3 | 0)) {
    i8 = i17 + 2684 + (i7 << 2) | 0;
    HEAP16[i8 >> 1] = (HEAPU16[i8 >> 1] | 0) + i2;
   } else if (!i7) if ((i2 | 0) < 11) {
    HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } else {
    HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } else {
    i2 = i17 + 2684 + (i7 << 2) | 0;
    if ((i7 | 0) != (i8 | 0)) HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
    HEAP16[i13 >> 1] = (HEAP16[i13 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } while (0);
   i4 = i5 << 16 >> 16 == 0;
   i8 = i7;
   i7 = i6;
   i3 = i4 | i9 ? 3 : 4;
   i4 = i4 ? 138 : i9 ? 6 : 7;
  }
  i9 = HEAP32[i17 + 2856 >> 2] | 0;
  i7 = HEAP16[i17 + 2442 >> 1] | 0;
  i4 = i7 << 16 >> 16 == 0;
  HEAP16[i17 + 2440 + (i9 + 1 << 2) + 2 >> 1] = -1;
  i7 = i7 & 65535;
  i1 = 0;
  i8 = -1;
  i3 = i4 ? 3 : 4;
  i4 = i4 ? 138 : 7;
  L55 : while (1) {
   i2 = 0;
   do {
    if ((i1 | 0) > (i9 | 0)) break L55;
    i1 = i1 + 1 | 0;
    i5 = HEAP16[i17 + 2440 + (i1 << 2) + 2 >> 1] | 0;
    i6 = i5 & 65535;
    i2 = i2 + 1 | 0;
    i10 = (i7 | 0) == (i6 | 0);
   } while ((i2 | 0) < (i4 | 0) & i10);
   do if ((i2 | 0) < (i3 | 0)) {
    i8 = i17 + 2684 + (i7 << 2) | 0;
    HEAP16[i8 >> 1] = (HEAPU16[i8 >> 1] | 0) + i2;
   } else if (!i7) if ((i2 | 0) < 11) {
    HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } else {
    HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } else {
    i2 = i17 + 2684 + (i7 << 2) | 0;
    if ((i7 | 0) != (i8 | 0)) HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
    HEAP16[i13 >> 1] = (HEAP16[i13 >> 1] | 0) + 1 << 16 >> 16;
    break;
   } while (0);
   i4 = i5 << 16 >> 16 == 0;
   i8 = i7;
   i7 = i6;
   i3 = i4 | i10 ? 3 : 4;
   i4 = i4 ? 138 : i10 ? 6 : 7;
  }
  _build_tree(i17, i17 + 2864 | 0);
  if (!(HEAP16[i17 + 2746 >> 1] | 0)) if (!(HEAP16[i17 + 2690 >> 1] | 0)) if (!(HEAP16[i17 + 2742 >> 1] | 0)) if (!(HEAP16[i17 + 2694 >> 1] | 0)) if (!(HEAP16[i17 + 2738 >> 1] | 0)) if (!(HEAP16[i17 + 2698 >> 1] | 0)) if (!(HEAP16[i17 + 2734 >> 1] | 0)) if (!(HEAP16[i17 + 2702 >> 1] | 0)) if (!(HEAP16[i17 + 2730 >> 1] | 0)) if (!(HEAP16[i17 + 2706 >> 1] | 0)) if (!(HEAP16[i17 + 2726 >> 1] | 0)) if (!(HEAP16[i17 + 2710 >> 1] | 0)) if (!(HEAP16[i17 + 2722 >> 1] | 0)) if (!(HEAP16[i17 + 2714 >> 1] | 0)) if (!(HEAP16[i17 + 2718 >> 1] | 0)) i1 = (HEAP16[i17 + 2686 >> 1] | 0) == 0 ? 2 : 3; else i1 = 4; else i1 = 5; else i1 = 6; else i1 = 7; else i1 = 8; else i1 = 9; else i1 = 10; else i1 = 11; else i1 = 12; else i1 = 13; else i1 = 14; else i1 = 15; else i1 = 16; else i1 = 17; else i1 = 18;
  i3 = i17 + 5800 | 0;
  i2 = (i1 * 3 | 0) + 17 + (HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  i2 = (i2 + 10 | 0) >>> 3;
  i3 = ((HEAP32[i17 + 5804 >> 2] | 0) + 10 | 0) >>> 3;
  i2 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
 } else {
  i3 = i15 + 5 | 0;
  i2 = i3;
  i1 = 0;
 }
 do if ((i14 | 0) != 0 & (i15 + 4 | 0) >>> 0 <= i2 >>> 0) _unity_z_tr_stored_block(i17, i14, i15, i16); else {
  i11 = i17 + 5820 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i4 = (i5 | 0) > 13;
  if ((i3 | 0) == (i2 | 0) ? 1 : (HEAP32[i17 + 136 >> 2] | 0) == 4) {
   i1 = i16 + 2 | 0;
   i2 = i17 + 5816 | 0;
   i3 = HEAPU16[i2 >> 1] | i1 << i5;
   HEAP16[i2 >> 1] = i3;
   if (i4) {
    i12 = i17 + 20 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i13 + 1;
    i14 = i17 + 8 | 0;
    HEAP8[(HEAP32[i14 >> 2] | 0) + i13 >> 0] = i3;
    i13 = (HEAPU16[i2 >> 1] | 0) >>> 8 & 255;
    i15 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i15 + 1;
    HEAP8[(HEAP32[i14 >> 2] | 0) + i15 >> 0] = i13;
    i15 = HEAP32[i11 >> 2] | 0;
    HEAP16[i2 >> 1] = (i1 & 65535) >>> (16 - i15 | 0);
    i1 = i15 + -13 | 0;
   } else i1 = i5 + 3 | 0;
   HEAP32[i11 >> 2] = i1;
   _compress_block(i17, gb + 216912 | 0, gb + 218064 | 0);
   break;
  }
  i2 = i16 + 4 | 0;
  i10 = i17 + 5816 | 0;
  i3 = HEAPU16[i10 >> 1] | i2 << i5;
  HEAP16[i10 >> 1] = i3;
  if (i4) {
   i14 = i17 + 20 | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i5 + 1;
   i15 = i17 + 8 | 0;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i5 >> 0] = i3;
   i3 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i5 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i5 + 1;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i5 >> 0] = i3;
   i5 = HEAP32[i11 >> 2] | 0;
   i3 = (i2 & 65535) >>> (16 - i5 | 0);
   HEAP16[i10 >> 1] = i3;
   i5 = i5 + -13 | 0;
  } else i5 = i5 + 3 | 0;
  HEAP32[i11 >> 2] = i5;
  i8 = HEAP32[i17 + 2844 >> 2] | 0;
  i9 = HEAP32[i17 + 2856 >> 2] | 0;
  i4 = i8 + -256 | 0;
  i2 = i3 & 65535 | i4 << i5;
  HEAP16[i10 >> 1] = i2;
  if ((i5 | 0) > 11) {
   i14 = i17 + 20 | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + 1;
   i15 = i17 + 8 | 0;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i3 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i3 + 1;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i3 >> 0] = i2;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = (i4 & 65535) >>> (16 - i3 | 0);
   HEAP16[i10 >> 1] = i2;
   i3 = i3 + -11 | 0;
  } else i3 = i5 + 5 | 0;
  HEAP32[i11 >> 2] = i3;
  i2 = i9 << i3 | i2 & 65535;
  HEAP16[i10 >> 1] = i2;
  if ((i3 | 0) > 11) {
   i14 = i17 + 20 | 0;
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i4 + 1;
   i15 = i17 + 8 | 0;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i4 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i4 + 1;
   HEAP8[(HEAP32[i15 >> 2] | 0) + i4 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   i2 = (i9 & 65535) >>> (16 - i4 | 0);
   HEAP16[i10 >> 1] = i2;
   i4 = i4 + -11 | 0;
  } else i4 = i3 + 5 | 0;
  HEAP32[i11 >> 2] = i4;
  i3 = i1 + -3 | 0;
  i2 = i3 << i4 | i2 & 65535;
  HEAP16[i10 >> 1] = i2;
  if ((i4 | 0) > 12) {
   i7 = i17 + 20 | 0;
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i15 + 1;
   i6 = i17 + 8 | 0;
   HEAP8[(HEAP32[i6 >> 2] | 0) + i15 >> 0] = i2;
   i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i15 + 1;
   HEAP8[(HEAP32[i6 >> 2] | 0) + i15 >> 0] = i2;
   i15 = HEAP32[i11 >> 2] | 0;
   i2 = (i3 & 65535) >>> (16 - i15 | 0);
   HEAP16[i10 >> 1] = i2;
   i3 = i15 + -12 | 0;
  } else {
   i6 = i17 + 8 | 0;
   i7 = i17 + 20 | 0;
   i3 = i4 + 4 | 0;
  }
  HEAP32[i11 >> 2] = i3;
  i5 = 0;
  while (1) {
   i4 = HEAPU16[i17 + 2684 + (HEAPU8[gb + 362506 + i5 >> 0] << 2) + 2 >> 1] | 0;
   i2 = i4 << i3 | i2 & 65535;
   HEAP16[i10 >> 1] = i2;
   if ((i3 | 0) > 13) {
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = i3 + 1;
    HEAP8[(HEAP32[i6 >> 2] | 0) + i3 >> 0] = i2;
    i2 = (HEAPU16[i10 >> 1] | 0) >>> 8 & 255;
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = i3 + 1;
    HEAP8[(HEAP32[i6 >> 2] | 0) + i3 >> 0] = i2;
    i3 = HEAP32[i11 >> 2] | 0;
    i2 = i4 >>> (16 - i3 | 0);
    HEAP16[i10 >> 1] = i2;
    i3 = i3 + -13 | 0;
   } else i3 = i3 + 3 | 0;
   HEAP32[i11 >> 2] = i3;
   if ((i5 | 0) == (i1 | 0)) break; else i5 = i5 + 1 | 0;
  }
  i14 = i17 + 148 | 0;
  _send_tree(i17, i14, i8);
  i15 = i17 + 2440 | 0;
  _send_tree(i17, i15, i9);
  _compress_block(i17, i14, i15);
 } while (0);
 _init_block(i17);
 if (!i16) return;
 i3 = i17 + 5820 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) > 8) {
  i1 = i17 + 5816 | 0;
  i13 = HEAP16[i1 >> 1] & 255;
  i14 = i17 + 20 | 0;
  i15 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i15 + 1;
  i16 = i17 + 8 | 0;
  HEAP8[(HEAP32[i16 >> 2] | 0) + i15 >> 0] = i13;
  i15 = (HEAPU16[i1 >> 1] | 0) >>> 8 & 255;
  i17 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i17 + 1;
  HEAP8[(HEAP32[i16 >> 2] | 0) + i17 >> 0] = i15;
 } else {
  i1 = i17 + 5816 | 0;
  if ((i2 | 0) > 0) {
   i15 = HEAP16[i1 >> 1] & 255;
   i14 = i17 + 20 | 0;
   i16 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i16 + 1;
   HEAP8[(HEAP32[i17 + 8 >> 2] | 0) + i16 >> 0] = i15;
  }
 }
 HEAP16[i1 >> 1] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 12 | 0;
 i6 = i12;
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903650 | 0, i7, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i10, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903662 | 0, i7, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903677 | 0, i7, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i11 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i10 + 16;
 HEAP32[i6 + 4 >> 2] = i10 + 12;
 HEAP32[i6 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903693 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i11, i6, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903708 | 0, gb + 905830 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i4 = i2;
    i1 = i1 | 0 ? i1 - i4 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i4;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim9animation19Blend1dDataConstantEEEvRT_PKc17TransferMetaFlags(i11, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903722 | 0, gb + 905830 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 40, 4) | 0;
    i3 = i1;
    i4 = i3 + 40 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    i4 = i2;
    i1 = i1 | 0 ? i1 - i4 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i4;
   }
   i3 = i1 + i2 | 0;
   i1 = i3;
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 903736 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim9animation19Blend2dDataConstant8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903756 | 0, gb + 905830 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 12, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP8[i1 + 8 >> 0] = 0;
    i6 = i2;
    i1 = i1 | 0 ? i1 - i6 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i6;
   }
   i3 = i1 + i2 | 0;
   i1 = i3;
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 903774 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim9animation23BlendDirectDataConstant8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903798 | 0, i7, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 84; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 84; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 36 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 903807 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 95; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 95; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 898587 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 106; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 106; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 106) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 898680 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (!i1) {
  __ZN7mecanim9animation21BlendTreeNodeConstant35Transfer_4_0_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i10, i11);
  STACKTOP = i12;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i11 + 16 | 0;
  i9 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 __ZN7mecanim9animation21BlendTreeNodeConstant35Transfer_4_0_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i10, i11);
 STACKTOP = i12;
 return;
}

function __ZN11Rigidbody2D8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i13 + 4 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 4);
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i6, i10);
 i12 = i6 + 68 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D8BodyTypeEEvRT_RT0_PKc17TransferMetaFlags(i10, i12, gb + 802708 | 0, 8388608);
 i3 = i6 + 48 | 0;
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802719 | 0, i8, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 50 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802731 | 0, i8, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 49 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802758 | 0, i8, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 32 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827258 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 33; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 33; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802772 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 44; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 44; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 44) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802447 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 55; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 55; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 55) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802785 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 66; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 66; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 66) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946425 | 0, gb + 801759 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D13InterpolationEEvRT_RT0_PKc17TransferMetaFlags(i10, i6 + 56 | 0, gb + 802800 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D9SleepModeEEvRT_RT0_PKc17TransferMetaFlags(i10, i6 + 60 | 0, gb + 802814 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D22CollisionDetectionModeEEvRT_RT0_PKc17TransferMetaFlags(i10, i6 + 64 | 0, gb + 802829 | 0, 0);
 i4 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802850 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i10, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802864 | 0, i8, i9, 0) | 0;
  if (!i1) i1 = 0; else {
   do if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i7 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i7 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i11 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 1);
   } else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i10);
   i1 = (HEAP8[i11 >> 0] | 0) == 0;
  }
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i1 ? i7 & -5 : i7 | 4;
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i10, 3) | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802877 | 0, i8, i9, 0) | 0;
 if (!i1) i1 = 0; else {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i9 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i11 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = HEAP8[i11 >> 0] | 0;
 }
 HEAP32[i12 >> 2] = i1 & 255;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Cct9SweepTest20findTouchedObstaclesERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3E(i62, i61, i76) {
 i62 = i62 | 0;
 i61 = i61 | 0;
 i76 = i76 | 0;
 var d1 = 0.0, d2 = 0.0, d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, d12 = 0.0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, d67 = 0.0, i68 = 0, d69 = 0.0, d70 = 0.0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i77 = 0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, i89 = 0, i90 = 0, i91 = 0;
 i77 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i77 + 192 | 0;
 i59 = i77 + 180 | 0;
 i54 = i77 + 144 | 0;
 i60 = i77 + 84 | 0;
 i75 = i77 + 72 | 0;
 i63 = i77 + 60 | 0;
 i68 = i77 + 48 | 0;
 i71 = i77 + 36 | 0;
 i72 = i77;
 d4 = +HEAPF64[i76 >> 3];
 i73 = i76 + 24 | 0;
 d6 = +HEAPF64[i73 >> 3];
 i74 = i76 + 8 | 0;
 d2 = +HEAPF64[i74 >> 3];
 i64 = i76 + 32 | 0;
 d5 = +HEAPF64[i64 >> 3];
 i65 = i76 + 16 | 0;
 d1 = +HEAPF64[i65 >> 3];
 i66 = i76 + 40 | 0;
 d3 = +HEAPF64[i66 >> 3];
 d67 = (d4 + d6) * .5;
 d69 = (d2 + d5) * .5;
 d70 = (d1 + d3) * .5;
 i55 = HEAP32[i61 >> 2] | 0;
 i56 = HEAP32[i61 + 4 >> 2] | 0;
 i57 = HEAP32[i61 + 8 >> 2] | 0;
 f11 = Math_fround(d4);
 f26 = Math_fround(d2);
 f28 = Math_fround(d1);
 f14 = Math_fround(d6);
 f27 = Math_fround(d5);
 f29 = Math_fround(d3);
 if (i55) {
  i34 = i60 + 4 | 0;
  i35 = i60 + 8 | 0;
  i36 = i60 + 12 | 0;
  i38 = i60 + 16 | 0;
  i39 = i60 + 20 | 0;
  i40 = i60 + 24 | 0;
  i41 = i60 + 28 | 0;
  i42 = i60 + 32 | 0;
  i43 = i60 + 36 | 0;
  i44 = i60 + 40 | 0;
  i45 = i60 + 44 | 0;
  i46 = i60 + 48 | 0;
  i47 = i60 + 52 | 0;
  i48 = i60 + 56 | 0;
  f49 = Math_fround(Math_fround(f11 + f14) * Math_fround(.5));
  f50 = Math_fround(Math_fround(f26 + f27) * Math_fround(.5));
  f51 = Math_fround(Math_fround(f28 + f29) * Math_fround(.5));
  i52 = i58 + 4 | 0;
  i53 = i58 + 8 | 0;
  f37 = Math_fround(Math_fround(f14 - f11) * Math_fround(.5));
  f14 = Math_fround(Math_fround(f27 - f26) * Math_fround(.5));
  f11 = Math_fround(Math_fround(f29 - f28) * Math_fround(.5));
  i9 = i59 + 4 | 0;
  i10 = i59 + 8 | 0;
  i13 = i54 + 4 | 0;
  i15 = i54 + 8 | 0;
  i16 = i54 + 12 | 0;
  i17 = i54 + 16 | 0;
  i18 = i54 + 20 | 0;
  i19 = i54 + 24 | 0;
  i20 = i54 + 28 | 0;
  i21 = i54 + 32 | 0;
  i22 = i62 + 32 | 0;
  i23 = i62 + 36 | 0;
  i33 = 0;
  do {
   i24 = i56 + (i33 * 56 | 0) | 0;
   f27 = Math_fround(+HEAPF64[i24 >> 3]);
   f28 = Math_fround(+HEAPF64[i56 + (i33 * 56 | 0) + 8 >> 3]);
   f29 = Math_fround(+HEAPF64[i56 + (i33 * 56 | 0) + 16 >> 3]);
   i25 = i56 + (i33 * 56 | 0) + 24 | 0;
   f81 = Math_fround(HEAPF32[i56 + (i33 * 56 | 0) + 36 >> 2]);
   i30 = i56 + (i33 * 56 | 0) + 40 | 0;
   f80 = Math_fround(HEAPF32[i30 >> 2]);
   i31 = i56 + (i33 * 56 | 0) + 44 | 0;
   f87 = Math_fround(HEAPF32[i31 >> 2]);
   i32 = i56 + (i33 * 56 | 0) + 48 | 0;
   f82 = Math_fround(HEAPF32[i32 >> 2]);
   f26 = Math_fround(f81 + f81);
   f79 = Math_fround(f80 + f80);
   f84 = Math_fround(f87 + f87);
   f86 = Math_fround(f80 * f79);
   f85 = Math_fround(f87 * f84);
   f80 = Math_fround(f26 * f80);
   f88 = Math_fround(f26 * f87);
   f78 = Math_fround(f26 * f82);
   f87 = Math_fround(f79 * f87);
   f79 = Math_fround(f79 * f82);
   f82 = Math_fround(f84 * f82);
   f84 = Math_fround(f80 + f82);
   f83 = Math_fround(f88 - f79);
   f82 = Math_fround(f80 - f82);
   f26 = Math_fround(Math_fround(1.0) - Math_fround(f81 * f26));
   f81 = Math_fround(f26 - f85);
   f80 = Math_fround(f87 + f78);
   f79 = Math_fround(f88 + f79);
   f78 = Math_fround(f87 - f78);
   f26 = Math_fround(f26 - f86);
   HEAPF32[i60 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f86) - f85);
   HEAPF32[i34 >> 2] = f84;
   HEAPF32[i35 >> 2] = f83;
   HEAPF32[i36 >> 2] = f82;
   HEAPF32[i38 >> 2] = f81;
   HEAPF32[i39 >> 2] = f80;
   HEAPF32[i40 >> 2] = f79;
   HEAPF32[i41 >> 2] = f78;
   HEAPF32[i42 >> 2] = f26;
   HEAPF32[i43 >> 2] = f27;
   HEAPF32[i44 >> 2] = f28;
   HEAPF32[i45 >> 2] = f29;
   HEAP32[i46 >> 2] = HEAP32[i25 >> 2];
   i7 = i56 + (i33 * 56 | 0) + 28 | 0;
   HEAP32[i47 >> 2] = HEAP32[i7 >> 2];
   i8 = i56 + (i33 * 56 | 0) + 32 | 0;
   HEAP32[i48 >> 2] = HEAP32[i8 >> 2];
   HEAPF32[i58 >> 2] = f49;
   HEAPF32[i52 >> 2] = f50;
   HEAPF32[i53 >> 2] = f51;
   HEAPF32[i59 >> 2] = f37;
   HEAPF32[i9 >> 2] = f14;
   HEAPF32[i10 >> 2] = f11;
   HEAPF32[i54 >> 2] = Math_fround(1.0);
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   HEAPF32[i15 >> 2] = Math_fround(0.0);
   HEAPF32[i16 >> 2] = Math_fround(0.0);
   HEAPF32[i17 >> 2] = Math_fround(1.0);
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   HEAPF32[i21 >> 2] = Math_fround(1.0);
   if (__ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b(i46, i43, i60, i59, i58, i54, 1) | 0) {
    i89 = HEAP32[i23 >> 2] | 0;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i22, i89 + 24 | 0);
    i90 = HEAP32[i22 >> 2] | 0;
    HEAP32[i90 + (i89 << 2) >> 2] = 0;
    HEAP32[i90 + (i89 + 1 << 2) >> 2] = HEAP32[i57 + (i33 << 2) >> 2];
    HEAP32[i90 + (i89 + 2 << 2) >> 2] = 0;
    HEAPF64[i90 + (i89 + 4 << 2) >> 3] = d67;
    HEAPF64[i90 + (i89 + 6 << 2) >> 3] = d69;
    HEAPF64[i90 + (i89 + 8 << 2) >> 3] = d70;
    i91 = i90 + (i89 + 10 << 2) | 0;
    HEAP32[i91 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i91 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
    HEAP32[i91 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
    HEAP32[i91 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
    HEAP32[i91 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
    HEAP32[i91 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
    HEAP32[i90 + (i89 + 16 << 2) >> 2] = HEAP32[i25 >> 2];
    HEAP32[i90 + (i89 + 17 << 2) >> 2] = HEAP32[i7 >> 2];
    HEAP32[i90 + (i89 + 18 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i90 + (i89 + 19 << 2) >> 2] = HEAP32[i56 + (i33 * 56 | 0) + 36 >> 2];
    HEAP32[i90 + (i89 + 20 << 2) >> 2] = HEAP32[i30 >> 2];
    HEAP32[i90 + (i89 + 21 << 2) >> 2] = HEAP32[i31 >> 2];
    HEAP32[i90 + (i89 + 22 << 2) >> 2] = HEAP32[i32 >> 2];
   }
   i33 = i33 + 1 | 0;
  } while ((i33 | 0) != (i55 | 0));
  d6 = +HEAPF64[i73 >> 3];
  d4 = +HEAPF64[i76 >> 3];
  d5 = +HEAPF64[i64 >> 3];
  d2 = +HEAPF64[i74 >> 3];
  d3 = +HEAPF64[i66 >> 3];
  d1 = +HEAPF64[i65 >> 3];
 }
 i35 = HEAP32[i61 + 12 >> 2] | 0;
 i36 = HEAP32[i61 + 16 >> 2] | 0;
 i30 = HEAP32[i61 + 20 >> 2] | 0;
 f87 = Math_fround(d5 - d2);
 f88 = Math_fround(d3 - d1);
 HEAPF32[i75 >> 2] = Math_fround(Math_fround(d6 - d4) * Math_fround(.5));
 HEAPF32[i75 + 4 >> 2] = Math_fround(f87 * Math_fround(.5));
 HEAPF32[i75 + 8 >> 2] = Math_fround(f88 * Math_fround(.5));
 if (!i35) {
  STACKTOP = i77;
  return;
 }
 i31 = i63 + 4 | 0;
 i32 = i63 + 8 | 0;
 i33 = i68 + 4 | 0;
 i34 = i68 + 8 | 0;
 f27 = Math_fround((d4 + d6) * .5);
 f26 = Math_fround((d2 + d5) * .5);
 f14 = Math_fround((d1 + d3) * .5);
 i15 = i71 + 4 | 0;
 i16 = i71 + 8 | 0;
 i17 = i72 + 4 | 0;
 i18 = i72 + 8 | 0;
 i19 = i72 + 12 | 0;
 i20 = i72 + 16 | 0;
 i21 = i72 + 20 | 0;
 i22 = i72 + 24 | 0;
 i23 = i72 + 28 | 0;
 i24 = i72 + 32 | 0;
 i25 = i62 + 32 | 0;
 i13 = i62 + 36 | 0;
 i7 = 0;
 while (1) {
  i8 = i36 + (i7 * 56 | 0) | 0;
  f11 = Math_fround(HEAPF32[i36 + (i7 * 56 | 0) + 48 >> 2]);
  d5 = +HEAPF64[i8 >> 3];
  d12 = +HEAPF64[i36 + (i7 * 56 | 0) + 24 >> 3];
  i9 = d5 < d12;
  if (!(+Math_fround(Math_fround(i9 ? d5 : d12) - f11) > d6)) {
   f88 = Math_fround(i9 ? d12 : d5);
   if (!(+HEAPF64[i76 >> 3] > +Math_fround(f11 + f88))) {
    d3 = +HEAPF64[i36 + (i7 * 56 | 0) + 8 >> 3];
    d4 = +HEAPF64[i36 + (i7 * 56 | 0) + 32 >> 3];
    i9 = d3 < d4;
    d6 = +Math_fround(Math_fround(i9 ? d3 : d4) - f11);
    if (!(d6 > +HEAPF64[i64 >> 3])) {
     f88 = Math_fround(i9 ? d4 : d3);
     if (!(+HEAPF64[i74 >> 3] > +Math_fround(f11 + f88))) {
      d1 = +HEAPF64[i36 + (i7 * 56 | 0) + 16 >> 3];
      d2 = +HEAPF64[i36 + (i7 * 56 | 0) + 40 >> 3];
      i9 = d1 < d2;
      d6 = +Math_fround(Math_fround(i9 ? d1 : d2) - f11);
      if (!(d6 > +HEAPF64[i66 >> 3])) {
       f88 = Math_fround(i9 ? d2 : d1);
       if (!(+HEAPF64[i65 >> 3] > +Math_fround(f11 + f88))) {
        f88 = Math_fround(d3);
        f87 = Math_fround(d1);
        HEAPF32[i63 >> 2] = Math_fround(d5);
        HEAPF32[i31 >> 2] = f88;
        HEAPF32[i32 >> 2] = f87;
        f87 = Math_fround(d4);
        f88 = Math_fround(d2);
        HEAPF32[i68 >> 2] = Math_fround(d12);
        HEAPF32[i33 >> 2] = f87;
        HEAPF32[i34 >> 2] = f88;
        HEAPF32[i71 >> 2] = f27;
        HEAPF32[i15 >> 2] = f26;
        HEAPF32[i16 >> 2] = f14;
        HEAPF32[i72 >> 2] = Math_fround(1.0);
        HEAPF32[i17 >> 2] = Math_fround(0.0);
        HEAPF32[i18 >> 2] = Math_fround(0.0);
        HEAPF32[i19 >> 2] = Math_fround(0.0);
        HEAPF32[i20 >> 2] = Math_fround(1.0);
        HEAPF32[i21 >> 2] = Math_fround(0.0);
        HEAPF32[i22 >> 2] = Math_fround(0.0);
        HEAPF32[i23 >> 2] = Math_fround(0.0);
        HEAPF32[i24 >> 2] = Math_fround(1.0);
        if (!(Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i63, i68, i71, i75, i72, 0, 0)) > Math_fround(f11 * f11))) {
         i10 = HEAP32[i13 >> 2] | 0;
         __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i25, i10 + 24 | 0);
         i9 = HEAP32[i25 >> 2] | 0;
         HEAP32[i9 + (i10 << 2) >> 2] = 1;
         HEAP32[i9 + (i10 + 1 << 2) >> 2] = HEAP32[i30 + (i7 << 2) >> 2];
         HEAP32[i9 + (i10 + 2 << 2) >> 2] = 0;
         HEAPF64[i9 + (i10 + 4 << 2) >> 3] = d67;
         HEAPF64[i9 + (i10 + 6 << 2) >> 3] = d69;
         HEAPF64[i9 + (i10 + 8 << 2) >> 3] = d70;
         i10 = i9 + (i10 + 10 << 2) | 0;
         i9 = i10 + 52 | 0;
         do {
          HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
          i10 = i10 + 4 | 0;
          i8 = i8 + 4 | 0;
         } while ((i10 | 0) < (i9 | 0));
        }
       }
      }
     }
    }
   }
  }
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == (i35 | 0)) break;
  d6 = +HEAPF64[i73 >> 3];
 }
 STACKTOP = i77;
 return;
}

function __ZN5physx20PxcSweepSphereSphereERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 432 | 0;
 i16 = i4 + 416 | 0;
 i22 = i4 + 272 | 0;
 i21 = i4 + 128 | 0;
 i52 = i4 + 496 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i8 + 40 | 0;
 i54 = HEAP32[i8 >> 2] | 0;
 i53 = i22 + 64 | 0;
 HEAP32[i22 + 80 >> 2] = 4;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 i51 = i22 + 96 | 0;
 i48 = i22 + 112 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 128 >> 2] = i54;
 HEAP32[i51 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i48 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = i54;
 HEAP32[i22 + 32 >> 2] = i54;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = -1;
 HEAP32[i53 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i53 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 i9 = i9 + 40 | 0;
 i53 = HEAP32[i9 >> 2] | 0;
 i54 = i21 + 64 | 0;
 HEAP32[i21 + 80 >> 2] = 4;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 i48 = i21 + 96 | 0;
 i51 = i21 + 112 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 128 >> 2] = i53;
 HEAP32[i48 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = i53;
 i51 = i21 + 20 | 0;
 HEAP32[i51 >> 2] = HEAP32[i52 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
 HEAP32[i21 + 32 >> 2] = i53;
 i53 = i21 + 36 | 0;
 HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
 HEAP32[i20 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = -1;
 HEAP32[i54 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i54 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i54 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i54 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 f46 = Math_fround(HEAPF32[i11 >> 2]);
 f47 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f40 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f45 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i54 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i54 >> 2]);
 f25 = Math_fround(HEAPF32[i54 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i54 + 8 >> 2]);
 i54 = HEAP32[i12 >> 2] | 0;
 i53 = HEAP32[i12 + 4 >> 2] | 0;
 i52 = HEAP32[i12 + 8 >> 2] | 0;
 i51 = HEAP32[i12 + 12 >> 2] | 0;
 i48 = i6 + 16 | 0;
 i50 = HEAP32[i48 >> 2] | 0;
 i49 = HEAP32[i48 + 4 >> 2] | 0;
 i48 = HEAP32[i48 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i54;
 i33 = i19 + 4 | 0;
 HEAP32[i33 >> 2] = i53;
 i5 = i19 + 8 | 0;
 HEAP32[i5 >> 2] = i52;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = i51;
 HEAP32[i19 + 16 >> 2] = i50;
 HEAP32[i19 + 20 >> 2] = i49;
 HEAP32[i19 + 24 >> 2] = i48;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f43 = (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = Math_fround(-f43);
 f38 = Math_fround(-f38);
 f35 = Math_fround(-f35);
 f29 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f39 = Math_fround(f25 - f24);
 f41 = Math_fround(f27 - f32);
 f42 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f44 = Math_fround(Math_fround(Math_fround(f28 * f43) + Math_fround(f39 * f38)) + Math_fround(f41 * f35));
 f31 = Math_fround(Math_fround(Math_fround(f44 * f38) + Math_fround(Math_fround(f42 * f39) + Math_fround(f23 * Math_fround(Math_fround(f28 * f35) - Math_fround(f41 * f43))))) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(f23 * Math_fround(Math_fround(f39 * f43) - Math_fround(f28 * f38)))) + Math_fround(f44 * f35)) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(f45 * f23) - Math_fround(Math_fround(Math_fround(f46 * f43) + Math_fround(f47 * f38)) + Math_fround(f40 * f35)));
 f37 = Math_fround(Math_fround(Math_fround(f40 * f38) - Math_fround(f47 * f35)) + Math_fround(Math_fround(f45 * f43) + Math_fround(f46 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f46 * f35) - Math_fround(f40 * f43)) + Math_fround(Math_fround(f45 * f38) + Math_fround(f47 * f23)));
 f40 = Math_fround(Math_fround(Math_fround(f47 * f43) - Math_fround(f46 * f38)) + Math_fround(Math_fround(f45 * f35) + Math_fround(f40 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f44 * f43) + Math_fround(Math_fround(f42 * f28) + Math_fround(f23 * Math_fround(Math_fround(f41 * f38) - Math_fround(f39 * f35))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f34;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f34 = Math_fround(f37 + f37);
 f31 = Math_fround(f26 + f26);
 f35 = Math_fround(f40 + f40);
 f39 = Math_fround(f26 * f31);
 f38 = Math_fround(f40 * f35);
 f26 = Math_fround(f26 * f34);
 f41 = Math_fround(f40 * f34);
 f23 = Math_fround(f36 * f34);
 f40 = Math_fround(f40 * f31);
 f31 = Math_fround(f36 * f31);
 f35 = Math_fround(f36 * f35);
 f34 = Math_fround(Math_fround(1.0) - Math_fround(f37 * f34));
 f37 = Math_fround(f26 + f35);
 f36 = Math_fround(f41 - f31);
 f35 = Math_fround(f26 - f35);
 f26 = Math_fround(f34 - f38);
 f28 = Math_fround(f40 + f23);
 f31 = Math_fround(f41 + f31);
 f23 = Math_fround(f40 - f23);
 f34 = Math_fround(f34 - f39);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f39) - f38);
 HEAPF32[i20 + 4 >> 2] = f37;
 HEAPF32[i20 + 8 >> 2] = f36;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f35;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f34;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f34 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f34 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i33 >> 2]);
 f24 = Math_fround(HEAPF32[i5 >> 2]);
 f28 = Math_fround(HEAPF32[i6 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(__ZN5physx8CCDSweepINS_2Gu8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i9 >> 2])) + f7)) | 0)) {
  f47 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f47);
 }
 f47 = Math_fround(HEAPF32[i2 >> 2]);
 i54 = HEAP32[i3 + 4 >> 2] | 0;
 i53 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i54;
 HEAP32[i13 + 8 >> 2] = i53;
 i53 = HEAP32[i1 + 4 >> 2] | 0;
 i54 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i53;
 HEAP32[i14 + 8 >> 2] = i54;
 STACKTOP = i4;
 return Math_fround(f47);
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i29, i12, i1) {
 i29 = i29 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28;
 i19 = i28 + 152 | 0;
 i2 = i28 + 148 | 0;
 i27 = i28 + 28 | 0;
 i9 = i28 + 88 | 0;
 HEAP32[i2 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i29, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i28;
  return;
 }
 i25 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (i25 | 0)) i2 = i25; else {
  i1 = i12 + 4 | 0;
  i24 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i1 >> 2] | 0) | 0;
  i24 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i1 >> 2] | 0, i24, i25) | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i1 >> 2] = i24;
  HEAP32[i1 + 4 >> 2] = i25;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i20 = i27 + 24 | 0;
 HEAP8[i20 >> 0] = 1;
 i21 = i27 + 28 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i27 + 32 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i27 + 36 | 0;
 HEAP32[i23 >> 2] = -1;
 i24 = i27 + 44 | 0;
 HEAP32[i24 >> 2] = 0;
 i18 = i27 + 48 | 0;
 HEAP32[i18 >> 2] = 0;
 L7 : do if (i2 | 0) {
  i5 = i9 + 24 | 0;
  HEAP8[i5 >> 0] = 1;
  i6 = i9 + 28 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i9 + 32 | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i9 + 36 | 0;
  HEAP32[i8 >> 2] = -1;
  HEAP32[i9 >> 2] = i1;
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  i10 = i12 + 4 | 0;
  i17 = i9 + 4 | 0;
  HEAP8[i17 >> 0] = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0) & 1;
  i2 = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) | 0) | 0;
  HEAP32[i9 + 8 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = i9 + 16 | 0;
  HEAP32[i4 >> 2] = i1;
  i11 = i12 + 8 | 0;
  i15 = HEAP32[i11 >> 2] | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 8 >> 2] | 0;
  HEAP32[i9 + 40 >> 2] = i16;
  HEAP32[i9 + 48 >> 2] = i15;
  i15 = i15 - i16 >> 6;
  HEAP32[i9 + 56 >> 2] = i15;
  HEAP32[i9 + 52 >> 2] = i15;
  HEAP32[i9 + 44 >> 2] = i16;
  HEAP32[i9 + 20 >> 2] = i9 + 40;
  if (!(HEAP8[i17 >> 0] | 0)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i4 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, HEAP32[i3 >> 2] | 0, i1);
   }
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP8[i5 >> 0] = 1;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i7 >> 2] = i2;
   i1 = i2;
   i2 = -1;
  } else {
   i17 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   i2 = (Math_imul(i2, HEAP32[i3 >> 2] | 0) | 0) + 16 | 0;
   HEAP8[i5 >> 0] = 0;
   HEAP32[i6 >> 2] = i17;
   HEAP32[i7 >> 2] = i1;
  }
  HEAP32[i8 >> 2] = i2;
  if (!i1) i1 = gb + 1033805 | 0; else i1 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
  i14 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 1041891 | 0, i1, 0, 1) | 0;
  i15 = i29 + 80 | 0;
  i16 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i15 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i17 = i29 + 84 | 0;
  HEAP32[HEAP32[i17 >> 2] >> 2] = 0;
  if ((i14 | 0) == 2) {
   i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0;
   i9 = HEAP32[i12 >> 2] | 0;
   i6 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0) & 1;
   i12 = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) | 0) | 0;
   i13 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 8 >> 2] | 0;
   i19 = i8 - i7 >> 6;
   HEAP32[i27 >> 2] = i9;
   i9 = i27 + 4 | 0;
   HEAP8[i9 >> 0] = i6;
   i10 = i27 + 8 | 0;
   HEAP32[i10 >> 2] = i12;
   i11 = i27 + 12 | 0;
   HEAP32[i11 >> 2] = 0;
   i12 = i27 + 16 | 0;
   HEAP32[i12 >> 2] = i13;
   i13 = i27 + 20 | 0;
   HEAP8[i20 >> 0] = 1;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i23 >> 2] = -1;
   HEAP32[i27 + 40 >> 2] = i7;
   HEAP32[i24 >> 2] = i7;
   HEAP32[i18 >> 2] = i8;
   HEAP32[i27 + 52 >> 2] = i19;
   HEAP32[i27 + 56 >> 2] = i19;
   if (i25 | 0) {
    i6 = i27 + 40 | 0;
    i7 = i26 + 20 | 0;
    i8 = i26 + 16 | 0;
    do {
     i5 = (Math_imul(HEAP32[HEAP32[i17 >> 2] >> 2] | 0, i16) | 0) + i14 | 0;
     i19 = HEAP32[i15 >> 2] | 0;
     HEAP32[i19 + 20 >> 2] = i5;
     HEAP32[i19 + 12 >> 2] = i5;
     __ZNK16TypeTreeIterator8ChildrenEv(i26, i19);
     i5 = i26;
     i18 = HEAP32[i5 + 4 >> 2] | 0;
     i19 = i19 + 24 | 0;
     HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     i19 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
     HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i13 >> 2] = i6;
     if (!(HEAP8[i9 >> 0] | 0)) {
      i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0) >> 2] | 0;
      if (!i1) {
       i1 = _il2cpp_object_new(HEAP32[i12 >> 2] | 0) | 0;
       __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
       __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, HEAP32[i11 >> 2] | 0, i1);
      }
      i3 = HEAP32[i12 >> 2] | 0;
      HEAP8[i20 >> 0] = 1;
      HEAP32[i21 >> 2] = i1;
      HEAP32[i22 >> 2] = i3;
      i3 = HEAP32[i13 >> 2] | 0;
      i1 = -1;
     } else {
      i19 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
      i3 = HEAP32[i12 >> 2] | 0;
      i1 = (Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0) + 16 | 0;
      HEAP8[i20 >> 0] = 0;
      HEAP32[i21 >> 2] = i19;
      HEAP32[i22 >> 2] = i3;
      i3 = i6;
     }
     HEAP32[i23 >> 2] = i1;
     HEAP32[i7 >> 2] = i29;
     HEAP32[i26 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i26 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i26 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i26 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i8 >> 2] = i3;
     i4 = i3 + 4 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     i5 = i3 + 8 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i1 | 0) != (i2 | 0)) {
      i3 = i3 + 12 | 0;
      do {
       i19 = i1 + 64 | 0;
       HEAP32[i4 >> 2] = i19;
       HEAP32[i3 >> 2] = i2 - i19 >> 6;
       mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i26 | 0);
       i1 = HEAP32[i4 >> 2] | 0;
       i2 = HEAP32[i5 >> 2] | 0;
      } while ((i1 | 0) != (i2 | 0));
     }
     i19 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
     HEAP32[i11 >> 2] = i19;
    } while ((i19 | 0) != (i25 | 0));
   }
   __ZN14SafeBinaryRead11EndTransferEv(i29);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
  i14 = HEAP32[i12 >> 2] | 0;
  i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0) & 1;
  i13 = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) | 0) | 0;
  i15 = HEAP32[i10 >> 2] | 0;
  i16 = HEAP32[i11 >> 2] | 0;
  i10 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 8 >> 2] | 0;
  i1 = i10;
  i17 = i16 - i1 >> 6;
  HEAP32[i27 >> 2] = i14;
  i11 = i27 + 4 | 0;
  HEAP8[i11 >> 0] = i3;
  i12 = i27 + 8 | 0;
  HEAP32[i12 >> 2] = i13;
  i13 = i27 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i27 + 16 | 0;
  HEAP32[i14 >> 2] = i15;
  i15 = i27 + 20 | 0;
  HEAP8[i20 >> 0] = 1;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i23 >> 2] = -1;
  HEAP32[i27 + 40 >> 2] = i10;
  HEAP32[i24 >> 2] = i10;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i27 + 52 >> 2] = i17;
  HEAP32[i27 + 56 >> 2] = i17;
  if (i25 | 0) {
   i7 = i27 + 40 | 0;
   i8 = i27 + 20 | 0;
   i9 = i26 + 20 | 0;
   i10 = i26 + 16 | 0;
   i2 = 0;
   while (1) {
    HEAP32[i24 >> 2] = i1;
    HEAP32[i15 >> 2] = i7;
    if (!(i3 << 24 >> 24)) {
     i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i2) | 0) >> 2] | 0;
     if (!i1) {
      i1 = _il2cpp_object_new(HEAP32[i14 >> 2] | 0) | 0;
      __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
      __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, HEAP32[i13 >> 2] | 0, i1);
     }
     i2 = HEAP32[i14 >> 2] | 0;
     HEAP8[i20 >> 0] = 1;
     HEAP32[i21 >> 2] = i1;
     i1 = -1;
    } else {
     i17 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
     i18 = HEAP32[i14 >> 2] | 0;
     i1 = (Math_imul(HEAP32[i12 >> 2] | 0, i2) | 0) + 16 | 0;
     HEAP8[i20 >> 0] = 0;
     HEAP32[i21 >> 2] = i17;
     i2 = i18;
    }
    HEAP32[i22 >> 2] = i2;
    HEAP32[i23 >> 2] = i1;
    if (!i2) i1 = gb + 1033805 | 0; else i1 = __Z24scripting_class_get_nameP11Il2CppClass(i2) | 0;
    i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 1041891 | 0, i1, i19, 1) | 0;
    if (i1 | 0) {
     if ((i1 | 0) > 0) {
      i1 = HEAP32[i8 >> 2] | 0;
      HEAP32[i9 >> 2] = i29;
      HEAP32[i26 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i26 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i26 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      HEAP32[i26 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
      HEAP32[i10 >> 2] = i1;
      i5 = i1 + 4 | 0;
      i3 = HEAP32[i5 >> 2] | 0;
      i6 = i1 + 8 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      if ((i3 | 0) != (i2 | 0)) {
       i4 = i1 + 12 | 0;
       i1 = i3;
       do {
        i18 = i1 + 64 | 0;
        HEAP32[i5 >> 2] = i18;
        HEAP32[i4 >> 2] = i2 - i18 >> 6;
        mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i26 | 0);
        i1 = HEAP32[i5 >> 2] | 0;
        i2 = HEAP32[i6 >> 2] | 0;
       } while ((i1 | 0) != (i2 | 0));
      }
     } else {
      i1 = HEAP32[i19 >> 2] | 0;
      if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i29 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i29);
    }
    i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
    HEAP32[i13 >> 2] = i2;
    if ((i2 | 0) == (i25 | 0)) break L7;
    i1 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP8[i11 >> 0] | 0;
   }
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i29);
 STACKTOP = i28;
 return;
}

function __ZN9ShaderLab14SerializedPassC2ERKS0_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 24 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17 + 12 | 0;
 i16 = i17;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 i1 = i11 + 4 | 0;
 i3 = i12 + 4 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i12 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 16 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i11 + 16 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 6;
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i8 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i11 + 12 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 8 >> 2] = i4;
  i1 = i9;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 _memcpy(i11 + 20 | 0, i12 + 20 | 0, 684) | 0;
 i6 = i11 + 704 | 0;
 i7 = i11 + 708 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i11 + 712 | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = i11 + 708 | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i12 + 704 >> 2] | 0;
 i9 = i12 + 708 | 0;
 if ((i2 | 0) != (i9 | 0)) {
  i4 = i2;
  i3 = i2;
  while (1) {
   i4 = i4 + 16 | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   i5 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i6, i13, i14, i4) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i19 = i4;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i4 = i2 + 16 | 0;
    HEAP32[i4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i4 + 4 >> 2] = i18;
    i4 = HEAP32[i14 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i4;
    HEAP32[i5 >> 2] = i2;
    i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i6 >> 2] = i4;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i2);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   if ((i2 | 0) == (i9 | 0)) break; else {
    i4 = i2;
    i3 = i2;
   }
  }
 }
 i6 = i11 + 716 | 0;
 i19 = i12 + 716 | 0;
 HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
 HEAP16[i6 + 4 >> 1] = HEAP16[i19 + 4 >> 1] | 0;
 HEAP32[i11 + 724 >> 2] = HEAP32[i12 + 724 >> 2];
 i6 = 0;
 do {
  i2 = i11 + 728 + (i6 * 12 | 0) | 0;
  i3 = i12 + 728 + (i6 * 12 | 0) | 0;
  HEAP32[i2 >> 2] = 0;
  i7 = i11 + 728 + (i6 * 12 | 0) + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 + 728 + (i6 * 12 | 0) + 8 >> 2] = 0;
  i5 = i12 + 728 + (i6 * 12 | 0) + 4 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
  i4 = (i1 | 0) / 192 | 0;
  if (i1 | 0) {
   if (i4 >>> 0 > 22369621) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
   i1 = __Znwj(i1) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 + 728 + (i6 * 12 | 0) + 8 >> 2] = i1 + (i4 * 192 | 0);
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) do {
    __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i1, i2);
    i2 = i2 + 192 | 0;
    i1 = (HEAP32[i7 >> 2] | 0) + 192 | 0;
    HEAP32[i7 >> 2] = i1;
   } while ((i2 | 0) != (i3 | 0));
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 6);
 i1 = i11 + 800 | 0;
 i3 = i12 + 800 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i12 + 804 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 812 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i11 + 812 >> 2] | 0;
  i10 = 27;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 29;
 } else i10 = 27;
 if ((i10 | 0) == 27) {
  i18 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i2;
  i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i19;
  HEAP32[i11 + 808 >> 2] = i18 | -2147483648;
  HEAP32[i11 + 804 >> 2] = i4;
  i1 = i19;
  i10 = 29;
 }
 if ((i10 | 0) == 29) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i11 + 816 | 0;
 i3 = i12 + 816 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i12 + 820 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 828 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i11 + 828 >> 2] | 0;
  i10 = 33;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 35;
 } else i10 = 33;
 if ((i10 | 0) == 33) {
  i18 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i2;
  i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i19;
  HEAP32[i11 + 824 >> 2] = i18 | -2147483648;
  HEAP32[i11 + 820 >> 2] = i4;
  i1 = i19;
  i10 = 35;
 }
 if ((i10 | 0) == 35) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i11 + 832 | 0;
 i3 = i12 + 832 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i12 + 836 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 844 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i11 + 844 >> 2] | 0;
  i10 = 39;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 41;
 } else i10 = 39;
 if ((i10 | 0) == 39) {
  i18 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i2;
  i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i19;
  HEAP32[i11 + 840 >> 2] = i18 | -2147483648;
  HEAP32[i11 + 836 >> 2] = i4;
  i1 = i19;
  i10 = 41;
 }
 if ((i10 | 0) == 41) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i6 = i11 + 848 | 0;
 i7 = i11 + 852 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i11 + 856 | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = i11 + 852 | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i12 + 848 >> 2] | 0;
 i9 = i12 + 852 | 0;
 if ((i2 | 0) != (i9 | 0)) {
  i3 = i2;
  while (1) {
   i4 = i3 + 16 | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   i5 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i6, i13, i14, i4) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i3 = __Znwj(24) | 0;
    i18 = i4;
    i19 = HEAP32[i18 + 4 >> 2] | 0;
    i4 = i3 + 16 | 0;
    HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i4 + 4 >> 2] = i19;
    i4 = HEAP32[i14 >> 2] | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = i4;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i6 >> 2] = i4;
     i3 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i3);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     break;
    } else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
   }
   if ((i2 | 0) == (i9 | 0)) break; else i3 = i2;
  }
 }
 i7 = i11 + 860 | 0;
 i8 = i11 + 864 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 868 | 0;
 HEAP32[i9 >> 2] = 0;
 i1 = i11 + 864 | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i12 + 860 >> 2] | 0;
 i6 = i12 + 864 | 0;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i17;
  return;
 }
 i5 = i1;
 i3 = i2;
 i1 = i2;
 while (1) {
  i2 = i3 + 16 | 0;
  HEAP32[i15 >> 2] = i5;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  i4 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_(i7, i13, i14, i2) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i16, i7, i2);
   i2 = HEAP32[i16 >> 2] | 0;
   HEAP32[i16 >> 2] = 0;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i7 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i2);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  if ((i1 | 0) == (i6 | 0)) break; else i3 = i1;
 }
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i24, i25, i35, i1, i2, i54, i55, i56, i57) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i59 + 64 | 0;
 i26 = i59 + 48 | 0;
 i27 = i59 + 32 | 0;
 i28 = i59 + 16 | 0;
 i29 = i59;
 if (i2 >>> 0 >= i54 >>> 0) {
  STACKTOP = i59;
  return;
 }
 i30 = i1 + 500 | 0;
 i31 = i26 + 4 | 0;
 i32 = i26 + 8 | 0;
 i33 = i26 + 12 | 0;
 i34 = i1 + 520 | 0;
 i36 = i26 + 4 | 0;
 i37 = i26 + 8 | 0;
 i38 = i26 + 12 | 0;
 i39 = i58 + 16 | 0;
 i40 = i58 + 32 | 0;
 i22 = i27 + 4 | 0;
 i23 = i27 + 8 | 0;
 i15 = i27 + 12 | 0;
 i16 = i28 + 4 | 0;
 i17 = i28 + 8 | 0;
 i18 = i28 + 12 | 0;
 i19 = i29 + 4 | 0;
 i20 = i29 + 8 | 0;
 i21 = i29 + 12 | 0;
 i41 = i56 + 12 | 0;
 i42 = i56 + 24 | 0;
 i43 = i56 + 4 | 0;
 i44 = i56 + 16 | 0;
 i45 = i56 + 28 | 0;
 i46 = i56 + 8 | 0;
 i47 = i56 + 20 | 0;
 i48 = i56 + 32 | 0;
 i49 = i57 + 4 | 0;
 i50 = i57 + 8 | 0;
 i51 = i57 + 12 | 0;
 i52 = i1 + 60 | 0;
 i53 = i1 + 80 | 0;
 i14 = i1 + 100 | 0;
 do {
  i4 = (HEAP32[i30 >> 2] | 0) + (i2 << 2) | 0;
  i3 = (HEAP32[i4 + 4 >> 2] | 0) + 306581307 | 0;
  i5 = (HEAP32[i4 + 8 >> 2] | 0) + 306581307 | 0;
  i1 = (HEAP32[i4 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i26 >> 2] = (HEAP32[i4 >> 2] | 0) + 306581307;
  HEAP32[i31 >> 2] = i3;
  HEAP32[i32 >> 2] = i5;
  HEAP32[i33 >> 2] = i1;
  __Z17GenerateRandomNx3RKN4math5_int4E(i58, i26);
  i1 = (HEAP32[i34 >> 2] | 0) + (i2 << 2) | 0;
  f63 = Math_fround(HEAPF32[i1 >> 2]);
  f62 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f61 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f62 = Math_fround(f62 * Math_fround(.00999999977));
  f61 = Math_fround(f61 * Math_fround(.00999999977));
  f60 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i26 >> 2] = Math_fround(f63 * Math_fround(.00999999977));
  HEAPF32[i36 >> 2] = f62;
  HEAPF32[i37 >> 2] = f61;
  HEAPF32[i38 >> 2] = f60;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i27, i24, i26, i58);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i28, i25, i26, i39);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i29, i35, i26, i40);
  i1 = HEAP32[i27 >> 2] | 0;
  i5 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i10 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i29 >> 2] | 0;
  i11 = HEAP32[i19 >> 2] | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  if (i55) {
   f69 = Math_fround(HEAPF32[i56 >> 2]);
   f72 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f61 = Math_fround(f72 * f69);
   f71 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f71 * f69);
   f70 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f60 = Math_fround(f70 * f69);
   f65 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f65 * f69);
   f76 = Math_fround(HEAPF32[i41 >> 2]);
   f68 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f79 = Math_fround(f68 * f76);
   f67 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f78 = Math_fround(f67 * f76);
   f66 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f77 = Math_fround(f66 * f76);
   f63 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f79 = Math_fround(f61 + f79);
   f78 = Math_fround(f73 + f78);
   f77 = Math_fround(f60 + f77);
   f76 = Math_fround(f69 + Math_fround(f63 * f76));
   f69 = Math_fround(HEAPF32[i42 >> 2]);
   f60 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f60 * f69);
   f61 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = Math_fround(f61 * f69);
   f62 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f62 * f69);
   f64 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f79 + f73);
   f74 = Math_fround(f78 + f74);
   f75 = Math_fround(f77 + f75);
   f69 = Math_fround(f76 + Math_fround(f64 * f69));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   f69 = Math_fround(HEAPF32[i43 >> 2]);
   f75 = Math_fround(f72 * f69);
   f74 = Math_fround(f71 * f69);
   f73 = Math_fround(f70 * f69);
   f69 = Math_fround(f65 * f69);
   f76 = Math_fround(HEAPF32[i44 >> 2]);
   f75 = Math_fround(f75 + Math_fround(f68 * f76));
   f74 = Math_fround(f74 + Math_fround(f67 * f76));
   f73 = Math_fround(f73 + Math_fround(f66 * f76));
   f76 = Math_fround(f69 + Math_fround(f63 * f76));
   f69 = Math_fround(HEAPF32[i45 >> 2]);
   f75 = Math_fround(f75 + Math_fround(f60 * f69));
   f74 = Math_fround(f74 + Math_fround(f61 * f69));
   f73 = Math_fround(f73 + Math_fround(f62 * f69));
   f69 = Math_fround(f76 + Math_fround(f64 * f69));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f73, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   f69 = Math_fround(HEAPF32[i46 >> 2]);
   f72 = Math_fround(f72 * f69);
   f71 = Math_fround(f71 * f69);
   f70 = Math_fround(f70 * f69);
   f69 = Math_fround(f65 * f69);
   f65 = Math_fround(HEAPF32[i47 >> 2]);
   f68 = Math_fround(f72 + Math_fround(f68 * f65));
   f67 = Math_fround(f71 + Math_fround(f67 * f65));
   f66 = Math_fround(f70 + Math_fround(f66 * f65));
   f65 = Math_fround(f69 + Math_fround(f63 * f65));
   f63 = Math_fround(HEAPF32[i48 >> 2]);
   f60 = Math_fround(f68 + Math_fround(f60 * f63));
   f61 = Math_fround(f67 + Math_fround(f61 * f63));
   f62 = Math_fround(f66 + Math_fround(f62 * f63));
   f63 = Math_fround(f65 + Math_fround(f64 * f63));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f62, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f67 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(HEAPF32[i57 >> 2]);
  f67 = Math_fround(f67 * f64);
  f82 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = Math_fround(HEAPF32[i49 >> 2]);
  f82 = Math_fround(f82 * f65);
  f81 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(HEAPF32[i50 >> 2]);
  f81 = Math_fround(f81 * f66);
  f80 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f79 = Math_fround(HEAPF32[i51 >> 2]);
  f80 = Math_fround(f80 * f79);
  f60 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f64);
  f61 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f65);
  f62 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66);
  f63 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f79);
  f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f64);
  f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f65);
  f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f66);
  f79 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f79);
  i1 = (HEAP32[i52 >> 2] | 0) + (i2 << 2) | 0;
  f68 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = i1 + 4 | 0;
  f69 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i1 + 8 | 0;
  f70 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i1 + 12 | 0;
  f71 = Math_fround(HEAPF32[i5 >> 2]);
  i6 = (HEAP32[i53 >> 2] | 0) + (i2 << 2) | 0;
  f72 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i6 + 4 | 0;
  f73 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i6 + 8 | 0;
  f74 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i6 + 12 | 0;
  f75 = Math_fround(HEAPF32[i9 >> 2]);
  i10 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f76 = Math_fround(HEAPF32[i10 >> 2]);
  i11 = i10 + 4 | 0;
  f77 = Math_fround(HEAPF32[i11 >> 2]);
  i12 = i10 + 8 | 0;
  f78 = Math_fround(HEAPF32[i12 >> 2]);
  i13 = i10 + 12 | 0;
  f69 = Math_fround(f82 + f69);
  f70 = Math_fround(f81 + f70);
  f71 = Math_fround(f80 + f71);
  f72 = Math_fround(f60 + f72);
  f73 = Math_fround(f61 + f73);
  f74 = Math_fround(f62 + f74);
  f75 = Math_fround(f63 + f75);
  f76 = Math_fround(f64 + f76);
  f77 = Math_fround(f65 + f77);
  f78 = Math_fround(f66 + f78);
  f79 = Math_fround(f79 + Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i1 >> 2] = Math_fround(f67 + f68);
  HEAPF32[i3 >> 2] = f69;
  HEAPF32[i4 >> 2] = f70;
  HEAPF32[i5 >> 2] = f71;
  HEAPF32[i6 >> 2] = f72;
  HEAPF32[i7 >> 2] = f73;
  HEAPF32[i8 >> 2] = f74;
  HEAPF32[i9 >> 2] = f75;
  HEAPF32[i10 >> 2] = f76;
  HEAPF32[i11 >> 2] = f77;
  HEAPF32[i12 >> 2] = f78;
  HEAPF32[i13 >> 2] = f79;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i54 >>> 0);
 STACKTOP = i59;
 return;
}

function __ZN14ParticleSystemC2E10MemLabelId18ObjectCreationMode(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 i8 = i1;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i5, i6, i2);
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 82792 + 8;
 i1 = i5 + 48 | 0;
 HEAP8[i5 + 52 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83032 + 8;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 96 >> 2] = 0;
 HEAP32[i5 + 100 >> 2] = 0;
 HEAP32[i5 + 152 >> 2] = 0;
 HEAP32[i5 + 164 >> 2] = 0;
 HEAP32[i5 + 168 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i5 + 156 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i5 + 172 >> 2] = 0;
 HEAP32[i5 + 176 >> 2] = 0;
 HEAP32[i5 + 180 >> 2] = 0;
 i2 = i5 + 188 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i5 + 204 >> 2] = 1;
 HEAP32[i5 + 208 >> 2] = 1;
 HEAP32[i5 + 212 >> 2] = 1;
 HEAP32[i5 + 216 >> 2] = 1;
 HEAP32[i5 + 220 >> 2] = 1812433254;
 HEAP32[i5 + 224 >> 2] = 1812433254;
 HEAP32[i5 + 228 >> 2] = 1812433254;
 HEAP32[i5 + 232 >> 2] = 1812433254;
 HEAP32[i5 + 236 >> 2] = 1900727103;
 HEAP32[i5 + 240 >> 2] = 1900727103;
 HEAP32[i5 + 244 >> 2] = 1900727103;
 HEAP32[i5 + 248 >> 2] = 1900727103;
 __ZN11ShapeModule5ResetEv(i1);
 i1 = i5 + 264 | 0;
 HEAP8[i5 + 268 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83016 + 8;
 __ZN11MinMaxCurveC2Ev(i5 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i5 + 536 | 0);
 __ZN14EmissionModule5ResetEv(i1);
 HEAPF32[i5 + 924 >> 2] = Math_fround(1.0);
 i1 = i5 + 928 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i5 + 944 >> 2] = -1;
 i1 = __ZnwjRK10MemLabelIdiPKci(512, gb + 63264 | 0, 16, gb + 612988 | 0, 154) | 0;
 __ZN19ParticleSystemStateC2Ev(i1);
 HEAP32[i5 + 40 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(292, gb + 63264 | 0, 16, gb + 612988 | 0, 155) | 0;
 __ZN11MinMaxCurveC2Ev(i1);
 HEAP32[i1 + 288 >> 2] = 0;
 __ZN27ParticleSystemReadOnlyState5ResetEv(i1);
 HEAP32[i5 + 36 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(2660, gb + 63264 | 0, 16, gb + 612988 | 0, 157) | 0;
 __ZN13InitialModuleC2Ev(i1);
 HEAP32[i5 + 44 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(804, gb + 63264 | 0, 16, gb + 612988 | 0, 158) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83336 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN10SizeModule5ResetEv(i1);
 HEAP32[i5 + 852 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(804, gb + 63264 | 0, 16, gb + 612988 | 0, 159) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83352 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN14RotationModule5ResetEv(i1);
 HEAP32[i5 + 856 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(164, gb + 63264 | 0, 16, gb + 612988 | 0, 160) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83368 + 8;
 __ZN8GradientC2Ev(i1 + 8 | 0);
 __ZN8GradientC2Ev(i1 + 80 | 0);
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP16[i1 + 160 >> 1] = 0;
 __ZN11ColorModule5ResetEv(i1);
 HEAP32[i5 + 860 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(572, gb + 63264 | 0, 16, gb + 612988 | 0, 161) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83384 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN8UVModule5ResetEv(i1);
 HEAP32[i5 + 864 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(804, gb + 63264 | 0, 16, gb + 612988 | 0, 162) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83400 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN14VelocityModule5ResetEv(i1);
 HEAP32[i5 + 868 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(276, gb + 63264 | 0, 16, gb + 612988 | 0, 163) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83416 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 12 | 0);
 __ZN21InheritVelocityModule5ResetEv(i1);
 HEAP32[i5 + 872 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(868, gb + 63264 | 0, 16, gb + 612988 | 0, 164) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83432 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 i2 = i1 + 804 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 820 >> 2] = 1;
 HEAP32[i1 + 824 >> 2] = 1;
 HEAP32[i1 + 828 >> 2] = 1;
 HEAP32[i1 + 832 >> 2] = 1;
 HEAP32[i1 + 836 >> 2] = 1812433254;
 HEAP32[i1 + 840 >> 2] = 1812433254;
 HEAP32[i1 + 844 >> 2] = 1812433254;
 HEAP32[i1 + 848 >> 2] = 1812433254;
 HEAP32[i1 + 852 >> 2] = 1900727103;
 HEAP32[i1 + 856 >> 2] = 1900727103;
 HEAP32[i1 + 860 >> 2] = 1900727103;
 HEAP32[i1 + 864 >> 2] = 1900727103;
 __ZN11ForceModule5ResetEv(i1);
 HEAP32[i5 + 876 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63264 | 0, 16, gb + 612988 | 0, 165) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83448 + 8;
 __ZN20ExternalForcesModule5ResetEv(i1);
 HEAP32[i5 + 880 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(1072, gb + 63264 | 0, 16, gb + 612988 | 0, 166) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83464 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 800 | 0);
 __ZN19ClampVelocityModule5ResetEv(i1);
 HEAP32[i5 + 884 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(1888, gb + 63264 | 0, 16, gb + 612988 | 0, 167) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83480 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 824 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1092 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1356 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1620 | 0);
 __ZN11NoiseModule5ResetEv(i1);
 HEAP32[i5 + 888 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(812, gb + 63264 | 0, 16, gb + 612988 | 0, 168) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83496 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN17SizeBySpeedModule5ResetEv(i1);
 HEAP32[i5 + 892 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(812, gb + 63264 | 0, 16, gb + 612988 | 0, 169) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83512 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 536 | 0);
 __ZN21RotationBySpeedModule5ResetEv(i1);
 HEAP32[i5 + 896 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(172, gb + 63264 | 0, 16, gb + 612988 | 0, 170) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83528 + 8;
 __ZN8GradientC2Ev(i1 + 8 | 0);
 __ZN8GradientC2Ev(i1 + 80 | 0);
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP16[i1 + 160 >> 1] = 0;
 __ZN18ColorBySpeedModule5ResetEv(i1);
 HEAP32[i5 + 900 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(1064, gb + 63264 | 0, 16, gb + 612988 | 0, 171) | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83544 + 8;
 __ZN32PlaneColliderCache_dense_hashmapC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 144 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 408 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 672 | 0);
 i2 = i1 + 1012 | 0;
 i3 = i1 + 972 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 + 1016 >> 2] = 1;
 HEAP32[i1 + 1020 >> 2] = 1;
 HEAP32[i1 + 1024 >> 2] = 1;
 HEAP32[i1 + 1028 >> 2] = 1812433254;
 HEAP32[i1 + 1032 >> 2] = 1812433254;
 HEAP32[i1 + 1036 >> 2] = 1812433254;
 HEAP32[i1 + 1040 >> 2] = 1812433254;
 HEAP32[i1 + 1044 >> 2] = 1900727103;
 HEAP32[i1 + 1048 >> 2] = 1900727103;
 HEAP32[i1 + 1052 >> 2] = 1900727103;
 HEAP32[i1 + 1056 >> 2] = 1900727103;
 __ZN15CollisionModule5ResetEv(i1);
 HEAP32[i5 + 904 >> 2] = i1;
 i8 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63264 | 0, 16, gb + 612988 | 0, 172) | 0;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP32[i8 >> 2] = gb + 83560 + 8;
 i3 = i8 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 __ZN13TriggerModule5ResetEv(i8);
 HEAP32[i5 + 912 >> 2] = i8;
 i8 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63264 | 0, 16, gb + 612988 | 0, 173) | 0;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP32[i8 >> 2] = gb + 83576 + 8;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i3 = i6;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 __ZN9SubModule5ResetEv(i8);
 HEAP32[i5 + 916 >> 2] = i8;
 i8 = __ZnwjRK10MemLabelIdiPKci(596, gb + 63264 | 0, 16, gb + 612988 | 0, 174) | 0;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP32[i8 >> 2] = gb + 83592 + 8;
 HEAP32[i8 + 16 >> 2] = 0;
 __ZN11MinMaxCurveC2Ev(i8 + 24 | 0);
 __ZN11MinMaxCurveC2Ev(i8 + 288 | 0);
 HEAP32[i8 + 556 >> 2] = 0;
 HEAP32[i8 + 560 >> 2] = 1;
 HEAP32[i8 + 564 >> 2] = 1812433254;
 HEAP32[i8 + 568 >> 2] = 1900727103;
 i6 = i8 + 576 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i8 + 580 >> 2] = i6;
 i6 = i8 + 584 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i8 + 588 >> 2] = i6;
 __ZN12LightsModule5ResetEv(i8);
 HEAP32[i5 + 920 >> 2] = i8;
 i8 = __ZnwjRK10MemLabelIdiPKci(876, gb + 63264 | 0, 16, gb + 612988 | 0, 175) | 0;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP32[i8 >> 2] = gb + 83608 + 8;
 __ZN11MinMaxCurveC2Ev(i8 + 12 | 0);
 __ZN8GradientC2Ev(i8 + 292 | 0);
 __ZN8GradientC2Ev(i8 + 364 | 0);
 i6 = i8 + 436 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 HEAP16[i8 + 444 >> 1] = 0;
 __ZN11MinMaxCurveC2Ev(i8 + 448 | 0);
 __ZN8GradientC2Ev(i8 + 712 | 0);
 __ZN8GradientC2Ev(i8 + 784 | 0);
 i6 = i8 + 856 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 HEAP16[i8 + 864 >> 1] = 0;
 __ZN11TrailModule5ResetEv(i8);
 HEAP32[i5 + 908 >> 2] = i8;
 i8 = __ZnwjRK10MemLabelIdiPKci(888, gb + 63264 | 0, 16, gb + 612988 | 0, 178) | 0;
 __ZN23ParticleSystemParticlesC2Ev(i8);
 HEAP32[i5 + 32 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i39, i1, i27, i26, i21, i22) {
 i39 = i39 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i42 + 100 | 0;
 i9 = i42;
 i28 = i42 + 96 | 0;
 i7 = i42 + 92 | 0;
 i6 = i42 + 88 | 0;
 i2 = i42 + 84 | 0;
 i3 = i42 + 80 | 0;
 i4 = i42 + 76 | 0;
 i5 = i42 + 72 | 0;
 i8 = i42 + 68 | 0;
 i35 = i42 + 56 | 0;
 i36 = i42 + 44 | 0;
 i41 = i42 + 32 | 0;
 i40 = i42 + 20 | 0;
 i38 = i42 + 8 | 0;
 i20 = i42 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674663 | 0, i28 | 0) | 0) {
  i1 = HEAP32[i28 >> 2] | 0;
  HEAP32[i37 >> 2] = i1;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
  i31 = i1;
 } else i31 = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 773144 | 0, i28 | 0) | 0) {
  i1 = HEAP32[i28 >> 2] | 0;
  HEAP32[i37 >> 2] = i1;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
 } else i1 = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i27, gb + 773163 | 0, i2, i7, i6, i26);
 i19 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i27, gb + 765025 | 0, i3, i7, i6, i26);
 i18 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i27, gb + 765035 | 0, i4, i7, i6, i26);
 i17 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i27, gb + 765046 | 0, i5, i7, i6, i26);
 i16 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx2Sn24readStridedFlagsPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorEPKNS_11PxU32ToNameE(i27, gb + 743223 | 0, i8, i7, i6, i26, gb + 115968 | 0);
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i35 >> 2] = 0;
 i11 = i35 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i33 = i35 + 8 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 i12 = i36 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i34 = i36 + 8 | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i41 >> 2] = 0;
 i13 = i41 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i32 = i41 + 8 | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i40 >> 2] = 0;
 i14 = i40 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i30 = i40 + 8 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 i15 = i38 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i29 = i38 + 8 | 0;
 HEAP32[i29 >> 2] = 0;
 i23 = (i16 | 0) != 0;
 i24 = (i17 | 0) != 0;
 i25 = (i10 | 0) != 0;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 743680 | 0, 983, gb + 743790 | 0, i9);
  HEAP32[i39 >> 2] = gb + 1576256;
  HEAP32[i39 + 4 >> 2] = 0;
  i3 = i39 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i6 = (i1 + -1 | 0) >>> 5;
  i8 = 0;
  while (1) {
   i1 = HEAP32[i19 + (i8 << 2) >> 2] | 0;
   if (i1 | 0) {
    i7 = i8 << 5;
    do {
     i5 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
     i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i7;
     HEAP32[i20 >> 2] = i5;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((HEAP32[i33 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i35 >> 2] | 0) + (i2 << 2) >> 2] = i5;
      HEAP32[i11 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i35, i20) | 0;
     i4 = i5 * 12 | 0;
     i2 = i18 + i4 | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      i9 = HEAP32[i36 >> 2] | 0;
      HEAP32[i9 + (i3 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i18 + (i4 + 4) >> 2];
      HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i18 + (i4 + 8) >> 2];
      HEAP32[i12 >> 2] = i3 + 1;
     } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i36, i2) | 0;
     do if (i24) {
      i2 = i17 + i4 | 0;
      i3 = HEAP32[i13 >> 2] | 0;
      if ((HEAP32[i32 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       i9 = HEAP32[i41 >> 2] | 0;
       HEAP32[i9 + (i3 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i17 + (i4 + 4) >> 2];
       HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i17 + (i4 + 8) >> 2];
       HEAP32[i13 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i41, i2) | 0;
       break;
      }
     } while (0);
     do if (i23) {
      i2 = i16 + (i5 << 2) | 0;
      i3 = HEAP32[i14 >> 2] | 0;
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i40 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i14 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf(i40, i2) | 0;
       break;
      }
     } while (0);
     do if (i25) {
      i2 = i10 + (i5 << 2) | 0;
      i3 = HEAP32[i15 >> 2] | 0;
      if ((HEAP32[i29 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i38 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
       HEAP32[i15 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i38, i2) | 0;
       break;
      }
     } while (0);
     i1 = i1 + -1 & i1;
    } while ((i1 | 0) != 0);
   }
   if ((i8 | 0) == (i6 | 0)) break; else i8 = i8 + 1 | 0;
  }
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743229 | 0, i28 | 0) | 0) {
   i1 = HEAP32[i28 >> 2] | 0;
   HEAP32[i37 >> 2] = i1;
   if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i37, 10) | 0;
   i2 = 1;
  } else {
   i2 = 0;
   i1 = 0;
  }
  i6 = HEAP32[i21 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 116 >> 2] | 0, i6 | 0, i1 | 0, i23 | 0) | 0;
  HEAP32[i37 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  i6 = i2 & (__ZN5physx2Sn17readAllPropertiesINS_15PxParticleFluidEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i37, i27, i1, i26, i22) | 0);
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743242 | 0, i37 | 0) | 0) {
   HEAP32[i28 >> 2] = 0;
   __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(HEAP32[i37 >> 2] | 0, i26, i28, gb + 116016 | 0);
   i5 = 1;
   i2 = HEAP32[i28 >> 2] | 0;
  } else {
   i5 = 0;
   i2 = 0;
  }
  i2 = i2 & 65535;
  i4 = 0;
  while (1) {
   i3 = 1 << i4;
   if ((i4 | 0) == 4) {
    i4 = 5;
    continue;
   }
   if (i2 & i3 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i3 | 0, 1);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == 16) break;
  }
  i11 = i6 & i5;
  if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 743260 | 0, i37 | 0) | 0) {
   HEAP32[i28 >> 2] = 0;
   __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(HEAP32[i37 >> 2] | 0, i26, i28, gb + 116080 | 0);
   i10 = 1;
   i3 = HEAP32[i28 >> 2] & 65535;
  } else {
   i10 = 0;
   i3 = 0;
  }
  i4 = 0;
  do {
   i2 = 1 << i4;
   if (i2 & i3 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, i2 | 0, 1);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != 16);
  i4 = i37 + 20 | 0;
  i5 = i37 + 24 | 0;
  i6 = i37 + 28 | 0;
  i7 = i37 + 32 | 0;
  i8 = i37 + 36 | 0;
  i9 = i37 + 40 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 12;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 4;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 4;
  HEAP32[i37 >> 2] = i31;
  i2 = HEAP32[i35 >> 2] | 0;
  HEAP32[i37 + 4 >> 2] = i2;
  HEAP32[i37 + 8 >> 2] = 4;
  i3 = HEAP32[i36 >> 2] | 0;
  HEAP32[i37 + 12 >> 2] = i3;
  HEAP32[i37 + 16 >> 2] = 12;
  if (i24) {
   HEAP32[i4 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i5 >> 2] = 12;
  }
  if (i23) {
   HEAP32[i6 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i7 >> 2] = 4;
  }
  if (i25) {
   HEAP32[i8 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i9 >> 2] = 4;
  }
  mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i37 | 0) | 0;
  if (i11 & i10) {
   HEAP32[i39 + 4 >> 2] = i1;
   i5 = gb + 765009 | 0;
   i4 = 0;
  } else {
   HEAP32[i39 + 4 >> 2] = 0;
   i5 = gb + 1576256 | 0;
   i1 = 0;
   i4 = 0;
  }
  HEAP32[i39 >> 2] = i5;
  i39 = i39 + 8 | 0;
  HEAP32[i39 >> 2] = i1;
  HEAP32[i39 + 4 >> 2] = i4;
  i39 = HEAP32[i29 >> 2] | 0;
  if ((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i38 >> 2] | 0;
   if (i1) {
    i39 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 12 >> 2] | 0, i39 | 0, i1 | 0);
   }
  }
 }
 i39 = HEAP32[i30 >> 2] | 0;
 if ((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i40 >> 2] | 0;
  if (i1 | 0) {
   i40 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i40 >> 2] | 0) + 12 >> 2] | 0, i40 | 0, i1 | 0);
  }
 }
 i40 = HEAP32[i32 >> 2] | 0;
 if ((i40 | 0) > -1 & (i40 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i41 >> 2] | 0;
  if (i1 | 0) {
   i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
  }
 }
 i41 = HEAP32[i34 >> 2] | 0;
 if (!((i41 & 2147483647 | 0) == 0 | (i41 | 0) < 0 | (i3 | 0) == 0)) {
  i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i3 | 0);
 }
 i41 = HEAP32[i33 >> 2] | 0;
 if ((i41 & 2147483647 | 0) == 0 | (i41 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i42;
  return;
 }
 i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i2 | 0);
 STACKTOP = i42;
 return;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6, i10);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10 + 1 | 0, i6 + 24 | 0, gb + 115320 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 100 | 0, i10 + 6 | 0);
 i5 = i6 + 116 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 132 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 164 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 192 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN9Rigidbody16ApplyConstraintsEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i34 + 84 | 0;
 i7 = i34 + 56 | 0;
 i5 = i34 + 40 | 0;
 i30 = i34 + 12 | 0;
 i20 = i34;
 i19 = HEAP32[i4 + 88 >> 2] | 0;
 i27 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i22 = i4 + 52 | 0;
 i28 = HEAP32[i22 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 124 >> 2] | 0, i21 | 0, i28 | 0);
 __ZNK9Transform11GetPositionEv(i7, i27);
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 f16 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 __ZNK9Transform11GetRotationEv(i5, i27);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 i27 = HEAP32[i22 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i27 | 0);
 i27 = i21 + 16 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(2.0));
 i28 = i21 + 20 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * Math_fround(2.0));
 i29 = i21 + 24 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
 f14 = Math_fround(Math_fround(Math_fround(f3 * f10) + Math_fround(f6 * f11)) + Math_fround(f8 * f12));
 f16 = Math_fround(f16 + Math_fround(Math_fround(f6 * f14) + Math_fround(Math_fround(f13 * f11) + Math_fround(f9 * Math_fround(Math_fround(f8 * f10) - Math_fround(f3 * f12))))));
 f18 = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f13 * f12) + Math_fround(f9 * Math_fround(Math_fround(f3 * f11) - Math_fround(f6 * f10)))) + Math_fround(f8 * f14)));
 f39 = Math_fround(HEAPF32[i21 >> 2]);
 i31 = i21 + 12 | 0;
 f41 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i21 + 8 | 0;
 f35 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i21 + 4 | 0;
 f37 = Math_fround(HEAPF32[i33 >> 2]);
 f40 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f40 * f40) + Math_fround(-.5));
 f38 = Math_fround(HEAPF32[i7 >> 2]);
 f17 = Math_fround(f10 * f38);
 f36 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f11 * f36));
 f26 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f12 * f26));
 f1 = Math_fround(Math_fround(f38 * f17) + Math_fround(Math_fround(f10 * f23) + Math_fround(f40 * Math_fround(Math_fround(f12 * f36) - Math_fround(f11 * f26)))));
 f15 = Math_fround(Math_fround(f36 * f17) + Math_fround(Math_fround(f11 * f23) + Math_fround(f40 * Math_fround(Math_fround(f10 * f26) - Math_fround(f12 * f38)))));
 f17 = Math_fround(Math_fround(Math_fround(f12 * f23) + Math_fround(f40 * Math_fround(Math_fround(f11 * f38) - Math_fround(f10 * f36)))) + Math_fround(f26 * f17));
 f1 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f1);
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f15);
 f17 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f17);
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f40) + Math_fround(f41 * f38)) + Math_fround(f35 * f36)) - Math_fround(f37 * f26));
 f24 = Math_fround(Math_fround(Math_fround(f39 * f26) + Math_fround(Math_fround(f37 * f40) + Math_fround(f41 * f36))) - Math_fround(f35 * f38));
 f25 = Math_fround(Math_fround(Math_fround(f37 * f38) + Math_fround(Math_fround(f35 * f40) + Math_fround(f41 * f26))) - Math_fround(f39 * f36));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) - Math_fround(f39 * f38)) - Math_fround(f37 * f36)) - Math_fround(f35 * f26));
 i7 = HEAP32[i22 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i7 | 0);
 if (!(i19 & 2)) f9 = f1; else {
  f9 = Math_fround(f2 + Math_fround(Math_fround(f3 * f14) + Math_fround(Math_fround(f13 * f10) + Math_fround(f9 * Math_fround(Math_fround(f6 * f12) - Math_fround(f8 * f11))))));
  HEAPF32[i5 >> 2] = Math_fround(0.0);
 }
 if (i19 & 4) {
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  f15 = f16;
 }
 if (!(i19 & 8)) f8 = f17; else {
  HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
  f8 = f18;
 }
 i7 = i4 + 84 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i4 = HEAP32[i22 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 156 >> 2] | 0, i4 | 0, i5 | 0, 0);
 }
 if (!(i19 & 112)) f1 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5)); else {
  i5 = HEAP32[i22 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 160 >> 2] | 0, i30 | 0, i5 | 0);
  f41 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(HEAPF32[i30 + 4 >> 2]) * Math_fround(2.0));
  f39 = Math_fround(Math_fround(HEAPF32[i30 + 8 >> 2]) * Math_fround(2.0));
  f1 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
  f2 = Math_fround(Math_fround(Math_fround(f23 * f41) + Math_fround(f24 * f40)) + Math_fround(f25 * f39));
  f3 = Math_fround(Math_fround(f23 * f2) + Math_fround(Math_fround(f1 * f41) - Math_fround(f26 * Math_fround(Math_fround(f24 * f39) - Math_fround(f25 * f40)))));
  f6 = Math_fround(Math_fround(f24 * f2) + Math_fround(Math_fround(f1 * f40) - Math_fround(f26 * Math_fround(Math_fround(f25 * f41) - Math_fround(f23 * f39)))));
  f2 = Math_fround(Math_fround(Math_fround(f1 * f39) - Math_fround(f26 * Math_fround(Math_fround(f23 * f40) - Math_fround(f24 * f41)))) + Math_fround(f25 * f2));
  i5 = HEAP32[i22 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i30 | 0, i5 | 0);
  if (!(i19 & 16)) i5 = 0; else if (Math_fround(HEAPF32[i30 >> 2]) > Math_fround(0.0)) {
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i5 = 1;
   f3 = Math_fround(0.0);
  } else i5 = 0;
  if (i19 & 32) {
   i4 = i30 + 4 | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = Math_fround(0.0);
    i5 = 1;
    f6 = Math_fround(0.0);
   }
  }
  if (!(i19 & 64)) i4 = 20; else {
   i4 = i30 + 8 | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0)) {
    HEAPF32[i4 >> 2] = Math_fround(0.0);
    f2 = Math_fround(0.0);
    i4 = 21;
   } else i4 = 20;
  }
  if ((i4 | 0) == 20) if (i5) i4 = 21;
  if ((i4 | 0) == 21) {
   i19 = HEAP32[i22 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 140 >> 2] | 0, i19 | 0, i30 | 0);
   if (!(HEAP8[i7 >> 0] | 0)) {
    i19 = HEAP32[i22 >> 2] | 0;
    i7 = HEAP32[(HEAP32[i19 >> 2] | 0) + 164 >> 2] | 0;
    f37 = Math_fround(f3 * Math_fround(2.0));
    f39 = Math_fround(f6 * Math_fround(2.0));
    f38 = Math_fround(f2 * Math_fround(2.0));
    f36 = Math_fround(Math_fround(Math_fround(f23 * f37) + Math_fround(f24 * f39)) + Math_fround(f25 * f38));
    f40 = Math_fround(Math_fround(f24 * f36) + Math_fround(Math_fround(f1 * f39) + Math_fround(f26 * Math_fround(Math_fround(f25 * f37) - Math_fround(f23 * f38)))));
    f41 = Math_fround(Math_fround(Math_fround(f26 * Math_fround(Math_fround(f23 * f39) - Math_fround(f24 * f37))) + Math_fround(f1 * f38)) + Math_fround(f25 * f36));
    HEAPF32[i20 >> 2] = Math_fround(Math_fround(f23 * f36) + Math_fround(Math_fround(f1 * f37) + Math_fround(f26 * Math_fround(Math_fround(f24 * f38) - Math_fround(f25 * f39)))));
    HEAPF32[i20 + 4 >> 2] = f40;
    HEAPF32[i20 + 8 >> 2] = f41;
    mftCall_viii(i7 | 0, i19 | 0, i20 | 0, 1);
   }
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 i20 = HEAP32[(HEAP32[i22 >> 2] | 0) + 88 >> 2] | 0;
 f40 = Math_fround(HEAPF32[i27 >> 2]);
 f13 = Math_fround(HEAPF32[i28 >> 2]);
 f40 = Math_fround(f40 * Math_fround(-2.0));
 f13 = Math_fround(f13 * Math_fround(-2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(-2.0));
 f16 = Math_fround(HEAPF32[i31 >> 2]);
 f12 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f38 = Math_fround(f40 * f14);
 f39 = Math_fround(HEAPF32[i33 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f13 * f39));
 f41 = Math_fround(HEAPF32[i32 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f11 * f41));
 f17 = Math_fround(-f14);
 f35 = Math_fround(-f39);
 f18 = Math_fround(-f41);
 f36 = Math_fround(Math_fround(Math_fround(f14 * f38) + Math_fround(Math_fround(f40 * f12) - Math_fround(f16 * Math_fround(Math_fround(f11 * f39) - Math_fround(f13 * f41))))) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(Math_fround(f13 * f12) - Math_fround(f16 * Math_fround(Math_fround(f40 * f41) - Math_fround(f11 * f14))))) * Math_fround(2.0));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f12) - Math_fround(f16 * Math_fround(Math_fround(f13 * f14) - Math_fround(f40 * f39)))) + Math_fround(f41 * f38)) * Math_fround(2.0));
 f41 = Math_fround(Math_fround(f25 * f38) + Math_fround(Math_fround(f23 * f36) + Math_fround(f24 * f37)));
 f39 = Math_fround(f9 + Math_fround(Math_fround(f23 * f41) + Math_fround(Math_fround(f1 * f36) + Math_fround(f26 * Math_fround(Math_fround(f24 * f38) - Math_fround(f25 * f37))))));
 f40 = Math_fround(f15 + Math_fround(Math_fround(f24 * f41) + Math_fround(Math_fround(f1 * f37) + Math_fround(f26 * Math_fround(Math_fround(f25 * f36) - Math_fround(f23 * f38))))));
 f41 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f1 * f38) + Math_fround(f26 * Math_fround(Math_fround(f23 * f37) - Math_fround(f24 * f36)))) + Math_fround(f25 * f41)));
 f36 = Math_fround(Math_fround(Math_fround(f25 * f17) + Math_fround(Math_fround(f24 * f16) + Math_fround(f26 * f35))) - Math_fround(f23 * f18));
 f37 = Math_fround(Math_fround(Math_fround(f23 * f35) + Math_fround(Math_fround(f25 * f16) + Math_fround(f26 * f18))) - Math_fround(f24 * f17));
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f16) - Math_fround(f23 * f17)) - Math_fround(f24 * f35)) - Math_fround(f25 * f18));
 HEAPF32[i30 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f16) + Math_fround(f26 * f17)) + Math_fround(f24 * f18)) - Math_fround(f25 * f35));
 HEAPF32[i30 + 4 >> 2] = f36;
 HEAPF32[i30 + 8 >> 2] = f37;
 HEAPF32[i30 + 12 >> 2] = f38;
 HEAPF32[i30 + 16 >> 2] = f39;
 HEAPF32[i30 + 20 >> 2] = f40;
 HEAPF32[i30 + 24 >> 2] = f41;
 mftCall_viii(i20 | 0, i22 | 0, i30 | 0, 0);
 STACKTOP = i34;
 return;
}

function __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv(i24, i25, i21, i15, i16, i1) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i21 = i21 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, f26 = f0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 33200 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 384 | 0;
 i18 = i23 + 144 | 0;
 i1 = i23;
 i10 = i24 + 872 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 if (f6 <= Math_fround(9.99999974e-06)) {
  STACKTOP = i23;
  return;
 }
 i11 = i24 + 876 | 0;
 f7 = Math_fround(HEAPF32[i11 >> 2]);
 if (f7 <= Math_fround(9.99999974e-06)) {
  STACKTOP = i23;
  return;
 }
 i14 = i24 + 864 | 0;
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(!(f26 >= Math_fround(1.0)) & !(Math_fround(f6 + f26) <= Math_fround(0.0)))) {
  STACKTOP = i23;
  return;
 }
 i12 = i24 + 868 | 0;
 f26 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(!(f26 >= Math_fround(1.0)) & !(Math_fround(f7 + f26) <= Math_fround(0.0)))) {
  STACKTOP = i23;
  return;
 }
 i8 = i24 + 924 | 0;
 f26 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i24 + 920 | 0;
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 if (f26 <= f6) {
  STACKTOP = i23;
  return;
 }
 i13 = i24 + 1088 | 0;
 if (!(HEAP8[i13 >> 0] | 0)) {
  if (f6 <= Math_fround(0.0)) {
   STACKTOP = i23;
   return;
  }
  f26 = Math_fround(HEAPF32[i24 + 292 >> 2]);
  i19 = f26 < Math_fround(0.0);
  f7 = Math_fround(-f26);
  if ((i19 ? f7 : f26) < Math_fround(9.99999997e-07)) {
   STACKTOP = i23;
   return;
  }
 } else {
  f26 = Math_fround(HEAPF32[i24 + 916 >> 2]);
  i19 = f26 < Math_fround(0.0);
  f7 = Math_fround(-f26);
  if ((i19 ? f7 : f26) < Math_fround(9.99999997e-07)) {
   STACKTOP = i23;
   return;
  }
 }
 if (!(HEAP8[i25 + 1368 >> 0] | 0)) {
  STACKTOP = i23;
  return;
 }
 i19 = i24 + 1116 | 0;
 if (HEAP8[i19 >> 0] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376294 | 0, 0, gb + 375437 | 0, 2198, 512, HEAP32[i24 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i23;
  return;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i2 + 4192 >> 0] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 496 >> 2] | 0, i2 | 0);
 HEAP8[i19 >> 0] = 1;
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i24);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 26244 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = 0;
  do {
   i5 = i3 + 25476 + (i2 * 12 | 0) | 0;
   if (!(HEAP8[i3 + 25476 + (i2 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i5 >> 2] | 0, i24 | 0); else mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 25476 + (i2 * 12 | 0) + 4 >> 2] | 0, i24 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i17 = (i16 & 64 | 0) != 0;
 if (!i17) {
  __ZN13RendererScene27SetPreventAddRemoveRendererEb(__Z16GetRendererScenev() | 0, 1);
  i2 = i24 + 8 | 0;
  i3 = (HEAP32[i2 >> 2] | 0) >>> 13;
  mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 48 >> 2] | 0, i24 | 0, i3 & 63 | 64 | 0);
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i24, gb + 1105396 | 0, i20);
  if (__Z17GetMonoManagerPtrv() | 0) {
   i27 = (__Z23GetCoreScriptingClassesv() | 0) + 112 | 0;
   i4 = HEAP32[i27 + 4 >> 2] | 0;
   i5 = i1;
   HEAP32[i5 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i5 + 4 >> 2] = i4;
   HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i18, i20);
   __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i18, __ZN9Scripting19ScriptingWrapperForEP6Object(i24) | 0);
   HEAP32[i20 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i18, i20, 0) | 0;
  }
  if (!(i3 & 64)) mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 48 >> 2] | 0, i24 | 0, (HEAP32[i2 >> 2] | 0) >>> 13 & 63 | 0);
  __ZN13RendererScene27SetPreventAddRemoveRendererEb(__Z16GetRendererScenev() | 0, 0);
 }
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 do if (!(f7 <= Math_fround(9.99999974e-06))) {
  f6 = Math_fround(HEAPF32[i11 >> 2]);
  if (!(f6 <= Math_fround(9.99999974e-06))) {
   f26 = Math_fround(HEAPF32[i14 >> 2]);
   if (!(f26 >= Math_fround(1.0)) & !(Math_fround(f7 + f26) <= Math_fround(0.0))) {
    f26 = Math_fround(HEAPF32[i12 >> 2]);
    if (!(f26 >= Math_fround(1.0)) & !(Math_fround(f6 + f26) <= Math_fround(0.0))) {
     f26 = Math_fround(HEAPF32[i8 >> 2]);
     f6 = Math_fround(HEAPF32[i9 >> 2]);
     if (!(f26 <= f6)) {
      if (!(HEAP8[i13 >> 0] | 0)) {
       if (f6 <= Math_fround(0.0)) break;
       f26 = Math_fround(HEAPF32[i24 + 292 >> 2]);
       i27 = f26 < Math_fround(0.0);
       f7 = Math_fround(-f26);
       if ((i27 ? f7 : f26) < Math_fround(9.99999997e-07)) break;
      } else {
       f26 = Math_fround(HEAPF32[i24 + 916 >> 2]);
       i27 = f26 < Math_fround(0.0);
       f7 = Math_fround(-f26);
       if ((i27 ? f7 : f26) < Math_fround(9.99999997e-07)) break;
      }
      i2 = __ZN11CullResults30GetOrCreateSharedRendererSceneEv(i25) | 0;
      if (!i15) {
       __ZNK6Camera28ExtractCameraRenderingParamsEv(i20, i24);
       _memcpy(i1 | 0, i20 | 0, 140) | 0;
      } else i1 = i15;
      __ZN6Camera19UpdateDepthTexturesERK11CullResultsRK19SharedRendererSceneNS_10RenderFlagE(i24, i25, i2, 0);
      __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i24, i21, i1, i16 | 8);
      __ZN6Camera8DoRenderER11CullResultsRK19SharedRendererSceneNS_10RenderFlagEPFvRS_R10RenderLoopRK15RenderNodeQueueEPSA_(i24, i25, 0, i16, 0, 0);
      i8 = (i16 & 1 | 0) == 0;
      do if (i8) {
       if (mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 112 >> 2] | 0, i24 | 0) | 0) {
        i22 = 41;
        break;
       }
       i4 = i24 + 744 | 0;
      } else i22 = 41; while (0);
      if ((i22 | 0) == 41) {
       if (!(HEAP32[i25 + 1360 >> 2] | 0)) __ZN6Camera18DoRenderPostLayersEPK11CullResultsR17ShaderPassContextNS_10RenderFlagE(i24, i25, i21, 0);
       i5 = HEAP32[i24 + 1124 >> 2] | 0;
       i4 = i24 + 744 | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       if (!i1) i1 = 0; else {
        HEAP32[i18 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        do if (!i1) i22 = 49; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i18);
          i2 = HEAP32[i20 >> 2] | 0;
          i27 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
          i22 = 49;
          break;
         }
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i22 = 51;
        } while (0);
        if ((i22 | 0) == 49) i22 = 51;
        if ((i22 | 0) == 51) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
       }
       __Z18RenderImageFiltersR10RenderLoopP13RenderTextureb(i5, i1, 0);
      }
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = 0; else {
       HEAP32[i18 >> 2] = i1;
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       do if (!i1) i22 = 60; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i18);
         i2 = HEAP32[i20 >> 2] | 0;
         i27 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
         i22 = 60;
         break;
        }
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i22 = 62;
       } while (0);
       if ((i22 | 0) == 60) i22 = 62;
       if ((i22 | 0) == 62) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      }
      HEAP32[i24 + 1144 >> 2] = i1;
      HEAP8[i19 >> 0] = 0;
      if (i8) {
       if (mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 112 >> 2] | 0, i24 | 0) | 0) i22 = 66;
      } else i22 = 66;
      if ((i22 | 0) == 66) {
       if (!i17) __ZN6Camera16DoRenderGUILayerER17ShaderPassContextNS_10RenderFlagE(i24, i21, 0);
       __ZN15RenderNodeQueueC2ERK10MemLabelId(i20, gb + 64016 | 0);
       i22 = i24 + 1136 | 0;
       i27 = i24 + 4 | 0;
       __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i22, 20, i21, i20, gb + 1159956 | 0, HEAP32[i27 >> 2] | 0);
       __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i22, 20, i21, i20, gb + 1159956 | 0, HEAP32[i27 >> 2] | 0);
       __ZN15RenderNodeQueueD2Ev(i20);
      }
      if (HEAP32[i25 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i25);
      i1 = i25 + 1312 | 0;
      if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
      i4 = i25 + 372 | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      if (i1 | 0) {
       i5 = i25 + 360 | 0;
       i3 = 0;
       do {
        i2 = (HEAP32[i5 >> 2] | 0) + (i3 * 960 | 0) + 72 | 0;
        if (HEAP32[i2 >> 2] | 0) {
         __Z21CompleteFenceInternalR8JobFence(i2);
         i1 = HEAP32[i4 >> 2] | 0;
        }
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i1 >>> 0);
      }
      __ZN6Camera21CleanupAfterRenderingEPK11CullResults(i24, i25);
      STACKTOP = i23;
      return;
     }
    }
   }
  }
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376428 | 0, 0, gb + 375437 | 0, 2240, 512, HEAP32[i24 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i23;
 return;
}

function __ZN14PhysicsManager6UpdateEv(i42) {
 i42 = i42 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, d52 = 0.0, d53 = 0.0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i51 + 64 | 0;
 i47 = i51 + 48 | 0;
 i48 = i51 + 32 | 0;
 i49 = i51 + 16 | 0;
 i50 = i51;
 if (!(HEAP8[i42 + 796 >> 0] | 0)) {
  STACKTOP = i51;
  return;
 }
 if ((HEAP16[gb + 1452476 + 6 >> 1] | 0) > -1) {
  HEAP32[i47 >> 2] = 0;
  HEAP32[i45 >> 2] = HEAP32[i47 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452476 | 0, i45);
  i46 = gb + 1452476 | 0;
 } else i46 = 0;
 i44 = i42 + 188 | 0;
 if (HEAP32[i44 >> 2] | 0) {
  i2 = i42 + 176 | 0;
  i1 = 0;
  do {
   i43 = __ZN14MessageHandler3GetEv() | 0;
   i41 = (Math_imul(HEAP32[i43 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i43 = (HEAP32[i43 + 16 >> 2] | 0) + (i41 >>> 5 << 2) | 0;
   HEAP32[i43 >> 2] = HEAP32[i43 >> 2] & ~(1 << (i41 & 31));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i44 >> 2] | 0) >>> 0);
 }
 i43 = i42 + 58 | 0;
 HEAP8[i43 >> 0] = 0;
 i1 = __ZN14MessageHandler3GetEv() | 0;
 i2 = HEAP32[gb + 67048 + 24 >> 2] | 0;
 if ((i2 | 0) != -2147483648) {
  i40 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
  i41 = (HEAP32[i1 + 16 >> 2] | 0) + (i40 >>> 5 << 2) | 0;
  HEAP32[i41 >> 2] = HEAP32[i41 >> 2] & ~(1 << (i40 & 31));
 }
 d52 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 f18 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
 d52 = d52 - +HEAPF64[(__Z14GetTimeManagerv() | 0) + 32 >> 3];
 d53 = d52 / +f18;
 f18 = Math_fround(d53 > 1.0 ? 1.0 : d53);
 f18 = d53 < 0.0 ? Math_fround(0.0) : f18;
 f19 = Math_fround(d52);
 i1 = HEAP32[i42 + 200 >> 2] | 0;
 i20 = i42 + 196 | 0;
 i2 = i1;
 if ((i2 | 0) != (i20 | 0)) {
  i21 = i45 + 16 | 0;
  i22 = i45 + 20 | 0;
  i23 = i45 + 24 | 0;
  f24 = Math_fround(Math_fround(1.0) - f18);
  i13 = i48 + 4 | 0;
  i15 = i48 + 8 | 0;
  i25 = i45 + 4 | 0;
  i26 = i45 + 8 | 0;
  i27 = i45 + 12 | 0;
  i28 = i50 + 4 | 0;
  i29 = i50 + 8 | 0;
  i30 = i50 + 12 | 0;
  i31 = i45 + 16 | 0;
  i32 = i45 + 20 | 0;
  i33 = i45 + 24 | 0;
  i34 = i45 + 4 | 0;
  i35 = i45 + 8 | 0;
  i36 = i45 + 4 | 0;
  i37 = i45 + 8 | 0;
  f38 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  i39 = i45 + 4 | 0;
  i40 = i45 + 8 | 0;
  i41 = i45 + 12 | 0;
  i14 = i47 + 4 | 0;
  i16 = i47 + 8 | 0;
  i17 = i47 + 12 | 0;
  do {
   i3 = HEAP32[i1 + 36 >> 2] | 0;
   if (!(HEAP32[i1 + 40 >> 2] | 0)) {
    i11 = i3 + 52 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    if (!(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 256 >> 2] | 0, i12 | 0) | 0)) {
     i12 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
     switch (HEAP8[i3 + 102 >> 0] | 0) {
     case 1:
      {
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 84 >> 2] | 0, i45 | 0, i54 | 0);
       f7 = Math_fround(HEAPF32[i21 >> 2]);
       f7 = Math_fround(f18 * f7);
       f9 = Math_fround(f18 * Math_fround(HEAPF32[i22 >> 2]));
       f10 = Math_fround(f18 * Math_fround(HEAPF32[i23 >> 2]));
       f8 = Math_fround(f24 * Math_fround(HEAPF32[i1 + 8 >> 2]));
       f9 = Math_fround(f9 + Math_fround(f24 * Math_fround(HEAPF32[i1 + 12 >> 2])));
       f10 = Math_fround(f10 + Math_fround(f24 * Math_fround(HEAPF32[i1 + 16 >> 2])));
       HEAPF32[i48 >> 2] = Math_fround(f7 + f8);
       HEAPF32[i13 >> 2] = f9;
       HEAPF32[i15 >> 2] = f10;
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 84 >> 2] | 0, i45 | 0, i54 | 0);
       i54 = HEAP32[i25 >> 2] | 0;
       i3 = HEAP32[i26 >> 2] | 0;
       i11 = HEAP32[i27 >> 2] | 0;
       HEAP32[i50 >> 2] = HEAP32[i45 >> 2];
       HEAP32[i28 >> 2] = i54;
       HEAP32[i29 >> 2] = i3;
       HEAP32[i30 >> 2] = i11;
       __Z5SlerpRK11QuaternionfS1_f(i49, i1 + 20 | 0, i50, f18);
       HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
       HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
       HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
       HEAP32[i47 + 12 >> 2] = HEAP32[i49 + 12 >> 2];
       __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i12, i48, i47);
       break;
      }
     case 2:
      {
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 84 >> 2] | 0, i45 | 0, i54 | 0);
       f5 = Math_fround(HEAPF32[i31 >> 2]);
       f6 = Math_fround(HEAPF32[i32 >> 2]);
       f4 = Math_fround(HEAPF32[i33 >> 2]);
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 152 >> 2] | 0, i45 | 0, i54 | 0);
       f7 = Math_fround(HEAPF32[i45 >> 2]);
       f6 = Math_fround(f6 + Math_fround(f19 * Math_fround(HEAPF32[i34 >> 2])));
       f4 = Math_fround(f4 + Math_fround(f19 * Math_fround(HEAPF32[i35 >> 2])));
       HEAPF32[i48 >> 2] = Math_fround(f5 + Math_fround(f19 * f7));
       HEAPF32[i13 >> 2] = f6;
       HEAPF32[i15 >> 2] = f4;
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 160 >> 2] | 0, i45 | 0, i54 | 0);
       f4 = Math_fround(HEAPF32[i45 >> 2]);
       f6 = Math_fround(HEAPF32[i36 >> 2]);
       f7 = Math_fround(HEAPF32[i37 >> 2]);
       f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7))));
       if (f5 > f38) {
        f8 = Math_fround(Math_fround(f19 * f5) * Math_fround(.5));
        f10 = Math_fround(+Math_cos(+f8));
        f8 = Math_fround(Math_fround(+Math_sin(+f8)) / f5);
        f4 = Math_fround(f4 * f8);
        f5 = Math_fround(f6 * f8);
        f8 = Math_fround(f7 * f8);
        f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))));
        if (f9 < f38) {
         f7 = Math_fround(0.0);
         f6 = Math_fround(1.0);
         f5 = Math_fround(0.0);
         f4 = Math_fround(0.0);
        } else {
         f7 = Math_fround(f4 / f9);
         f6 = Math_fround(f10 / f9);
         f5 = Math_fround(f5 / f9);
         f4 = Math_fround(f8 / f9);
        }
       } else {
        f7 = Math_fround(0.0);
        f6 = Math_fround(1.0);
        f5 = Math_fround(0.0);
        f4 = Math_fround(0.0);
       }
       i54 = HEAP32[i11 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i54 >> 2] | 0) + 84 >> 2] | 0, i45 | 0, i54 | 0);
       f57 = Math_fround(HEAPF32[i45 >> 2]);
       f55 = Math_fround(HEAPF32[i39 >> 2]);
       f58 = Math_fround(HEAPF32[i40 >> 2]);
       f56 = Math_fround(HEAPF32[i41 >> 2]);
       f8 = Math_fround(Math_fround(Math_fround(f4 * f57) + Math_fround(Math_fround(f6 * f55) + Math_fround(f5 * f56))) - Math_fround(f7 * f58));
       f9 = Math_fround(Math_fround(Math_fround(f7 * f55) + Math_fround(Math_fround(f6 * f58) + Math_fround(f4 * f56))) - Math_fround(f5 * f57));
       f10 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f56) - Math_fround(f7 * f57)) - Math_fround(f5 * f55)) - Math_fround(f4 * f58));
       HEAPF32[i47 >> 2] = Math_fround(Math_fround(Math_fround(f5 * f58) + Math_fround(Math_fround(f6 * f57) + Math_fround(f7 * f56))) - Math_fround(f4 * f55));
       HEAPF32[i14 >> 2] = f8;
       HEAPF32[i16 >> 2] = f9;
       HEAPF32[i17 >> 2] = f10;
       __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i12, i48, i47);
       break;
      }
     default:
      {}
     }
    }
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i20 | 0));
 }
 if (HEAP32[i44 >> 2] | 0) {
  i2 = i42 + 176 | 0;
  i1 = 0;
  do {
   i54 = __ZN14MessageHandler3GetEv() | 0;
   i42 = (Math_imul(HEAP32[i54 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i54 = (HEAP32[i54 + 16 >> 2] | 0) + (i42 >>> 5 << 2) | 0;
   HEAP32[i54 >> 2] = 1 << (i42 & 31) | HEAP32[i54 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i44 >> 2] | 0) >>> 0);
 }
 HEAP8[i43 >> 0] = 1;
 i1 = __ZN14MessageHandler3GetEv() | 0;
 i2 = HEAP32[gb + 67048 + 24 >> 2] | 0;
 if ((i2 | 0) != -2147483648) {
  i44 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
  i54 = (HEAP32[i1 + 16 >> 2] | 0) + (i44 >>> 5 << 2) | 0;
  HEAP32[i54 >> 2] = 1 << (i44 & 31) | HEAP32[i54 >> 2];
 }
 if (HEAP32[gb + 1457416 >> 2] | 0) {
  i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (i1 | 0) {
   i42 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
   __ZNK9Transform11GetPositionEv(i45, i42);
   __ZNK9Transform18TransformDirectionERK8Vector3f(i47, i42, gb + 62536 | 0);
   __ZNK9Transform18TransformDirectionERK8Vector3f(i48, i42, gb + 62548 | 0);
   f56 = Math_fround(HEAPF32[i48 >> 2]);
   f56 = Math_fround(f56 + Math_fround(HEAPF32[i45 >> 2]));
   f57 = Math_fround(HEAPF32[i48 + 4 >> 2]);
   i42 = i45 + 4 | 0;
   f57 = Math_fround(f57 + Math_fround(HEAPF32[i42 >> 2]));
   f58 = Math_fround(HEAPF32[i48 + 8 >> 2]);
   i43 = i45 + 8 | 0;
   f58 = Math_fround(f58 + Math_fround(HEAPF32[i43 >> 2]));
   i54 = HEAP32[gb + 1457408 >> 2] | 0;
   i54 = mftCall_ii(HEAP32[(HEAP32[i54 >> 2] | 0) + 20 >> 2] | 0, i54 | 0) | 0;
   i44 = HEAP32[(HEAP32[i54 >> 2] | 0) + 20 >> 2] | 0;
   i42 = HEAP32[i42 >> 2] | 0;
   i43 = HEAP32[i43 >> 2] | 0;
   HEAP32[i48 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i48 + 4 >> 2] = i42;
   HEAP32[i48 + 8 >> 2] = i43;
   i43 = HEAP32[i47 + 4 >> 2] | 0;
   i45 = HEAP32[i47 + 8 >> 2] | 0;
   HEAP32[i49 >> 2] = HEAP32[i47 >> 2];
   HEAP32[i49 + 4 >> 2] = i43;
   HEAP32[i49 + 8 >> 2] = i45;
   HEAPF32[i50 >> 2] = f56;
   HEAPF32[i50 + 4 >> 2] = f57;
   HEAPF32[i50 + 8 >> 2] = f58;
   mftCall_viiiii(i44 | 0, i54 | 0, gb + 1044265 | 0, i48 | 0, i49 | 0, i50 | 0);
  }
 }
 if (!i46) {
  STACKTOP = i51;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i46);
 STACKTOP = i51;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i2, i21, i24, i12, i13, i22, i20, i19) {
 i2 = i2 | 0;
 i21 = i21 | 0;
 i24 = i24 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i23 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25;
 i17 = i2 + 16 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i1 = Math_fround(HEAPF32[i18 + 16 >> 2]) < Math_fround(0.0);
 if (Math_fround(HEAPF32[i18 + 12 >> 2]) < Math_fround(0.0)) i1 = i1 ^ 1;
 i6 = i2 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (Math_fround(HEAPF32[i5 + 40 >> 2]) > Math_fround(0.0)) if (i1) i2 = 13; else i2 = 6; else if (i1) i2 = 6; else i2 = 13;
 do if ((i2 | 0) == 6) {
  i1 = i23 + 8 | 0;
  i2 = i23 + 4 | 0;
  i4 = i22 >>> 1;
  i3 = (i22 & 1 | 0) == 0;
  if ((HEAP8[(HEAP32[i5 + 36 >> 2] | 0) + (i4 << 2) + 2 >> 0] | 0) < 0) if (i3) {
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i18 = i3 + i4 | 0;
   HEAP32[i23 >> 2] = i18;
   HEAP32[i1 >> 2] = i4;
   i1 = i4 + 1 + i3 | 0;
   HEAP32[i2 >> 2] = i1;
   i3 = i4;
   i4 = i1;
   i1 = 1;
   break;
  } else {
   i18 = i4 + 1 | 0;
   HEAP32[i23 >> 2] = i18;
   i3 = (HEAP32[i5 + 20 >> 2] | 0) + i18 | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i2 >> 2] = i4;
   i1 = 1;
   break;
  } else if (i3) {
   HEAP32[i23 >> 2] = i4;
   i3 = i4 + 1 | 0;
   HEAP32[i1 >> 2] = i3;
   i1 = (HEAP32[i5 + 20 >> 2] | 0) + i4 | 0;
   HEAP32[i2 >> 2] = i1;
   i18 = i4;
   i4 = i1;
   i1 = 1;
   break;
  } else {
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i26 = i4 + 1 | 0;
   i18 = i3 + i26 | 0;
   HEAP32[i23 >> 2] = i18;
   i3 = i3 + i4 | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i2 >> 2] = i26;
   i4 = i26;
   i1 = 1;
   break;
  }
 } else if ((i2 | 0) == 13) {
  i1 = i23 + 4 | 0;
  i2 = i23 + 8 | 0;
  i4 = i22 >>> 1;
  i3 = (i22 & 1 | 0) == 0;
  if ((HEAP8[(HEAP32[i5 + 36 >> 2] | 0) + (i4 << 2) + 2 >> 0] | 0) < 0) if (i3) {
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i18 = i3 + i4 | 0;
   HEAP32[i23 >> 2] = i18;
   HEAP32[i1 >> 2] = i4;
   i3 = i4 + 1 + i3 | 0;
   HEAP32[i2 >> 2] = i3;
   i1 = 0;
   break;
  } else {
   i18 = i4 + 1 | 0;
   HEAP32[i23 >> 2] = i18;
   i26 = (HEAP32[i5 + 20 >> 2] | 0) + i18 | 0;
   HEAP32[i1 >> 2] = i26;
   HEAP32[i2 >> 2] = i4;
   i3 = i4;
   i4 = i26;
   i1 = 0;
   break;
  } else if (i3) {
   HEAP32[i23 >> 2] = i4;
   i26 = i4 + 1 | 0;
   HEAP32[i1 >> 2] = i26;
   i3 = (HEAP32[i5 + 20 >> 2] | 0) + i4 | 0;
   HEAP32[i2 >> 2] = i3;
   i18 = i4;
   i4 = i26;
   i1 = 0;
   break;
  } else {
   i26 = HEAP32[i5 + 20 >> 2] | 0;
   i3 = i4 + 1 | 0;
   i18 = i26 + i3 | 0;
   HEAP32[i23 >> 2] = i18;
   i4 = i26 + i4 | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
   i1 = 0;
   break;
  }
 } while (0);
 do if (i13 | 0) if (i1) {
  __ZNK5physx2Gu11HeightField27getTriangleAdjacencyIndicesEjjjjRjS2_S2_(i5, i22, i18, i3, i4, i13 + 8 | 0, i13 + 4 | 0, i13);
  break;
 } else {
  __ZNK5physx2Gu11HeightField27getTriangleAdjacencyIndicesEjjjjRjS2_S2_(i5, i22, i18, i4, i3, i13, i13 + 4 | 0, i13 + 8 | 0);
  break;
 } while (0);
 if (i12 | 0) {
  HEAP32[i12 >> 2] = i18;
  HEAP32[i12 + 4 >> 2] = i4;
  HEAP32[i12 + 8 >> 2] = i3;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 i13 = HEAP32[i6 + 36 >> 2] | 0;
 i26 = HEAP32[i17 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 if (!i19) if (i20) {
  i20 = i21 + 16 | 0;
  i26 = i21 + 20 | 0;
  i23 = i21 + 24 | 0;
  f11 = Math_fround(((i18 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f11 = Math_fround(f11 * f14);
  f10 = Math_fround(Math_fround(HEAP16[i13 + (i18 << 2) >> 1] | 0) * f15);
  f9 = Math_fround(Math_fround(((i18 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i20 >> 2]));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i26 >> 2]));
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i23 >> 2]));
  HEAPF32[i24 >> 2] = f11;
  HEAPF32[i24 + 4 >> 2] = f10;
  HEAPF32[i24 + 8 >> 2] = f9;
  f9 = Math_fround(((i4 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f9 = Math_fround(f9 * f14);
  f10 = Math_fround(Math_fround(HEAP16[i13 + (i4 << 2) >> 1] | 0) * f15);
  f11 = Math_fround(Math_fround(((i4 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i20 >> 2]));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i26 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i23 >> 2]));
  HEAPF32[i24 + 12 >> 2] = f9;
  HEAPF32[i24 + 16 >> 2] = f10;
  HEAPF32[i24 + 20 >> 2] = f11;
  f11 = Math_fround(((i3 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f14 = Math_fround(f11 * f14);
  f15 = Math_fround(Math_fround(HEAP16[i13 + (i3 << 2) >> 1] | 0) * f15);
  f16 = Math_fround(Math_fround(((i3 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i20 >> 2]));
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i26 >> 2]));
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i23 >> 2]));
  HEAPF32[i24 + 24 >> 2] = f14;
  HEAPF32[i24 + 28 >> 2] = f15;
  HEAPF32[i24 + 32 >> 2] = f16;
  i23 = i22 & 1;
  i23 = (i23 | 0) == 0;
  i26 = i22 >>> 1;
  i22 = i6 + 36 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i22 + (i26 << 2) + 2 | 0;
  i26 = i22 + (i26 << 2) + 3 | 0;
  i26 = i23 ? i24 : i26;
  i26 = HEAP8[i26 >> 0] | 0;
  i26 = i26 & 127;
  i26 = i26 << 24 >> 24 != 127;
  i26 = i26 & 1;
  STACKTOP = i25;
  return i26 | 0;
 } else {
  f11 = Math_fround(((i18 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f10 = Math_fround(Math_fround(HEAP16[i13 + (i18 << 2) >> 1] | 0) * f15);
  f9 = Math_fround(Math_fround(((i18 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  HEAPF32[i24 >> 2] = Math_fround(f11 * f14);
  HEAPF32[i24 + 4 >> 2] = f10;
  HEAPF32[i24 + 8 >> 2] = f9;
  f9 = Math_fround(((i4 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f10 = Math_fround(Math_fround(HEAP16[i13 + (i4 << 2) >> 1] | 0) * f15);
  f11 = Math_fround(Math_fround(((i4 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  HEAPF32[i24 + 12 >> 2] = Math_fround(f9 * f14);
  HEAPF32[i24 + 16 >> 2] = f10;
  HEAPF32[i24 + 20 >> 2] = f11;
  f11 = Math_fround(((i3 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f15 = Math_fround(Math_fround(HEAP16[i13 + (i3 << 2) >> 1] | 0) * f15);
  f16 = Math_fround(Math_fround(((i3 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16);
  HEAPF32[i24 + 24 >> 2] = Math_fround(f11 * f14);
  HEAPF32[i24 + 28 >> 2] = f15;
  HEAPF32[i24 + 32 >> 2] = f16;
  i23 = i22 & 1;
  i23 = (i23 | 0) == 0;
  i26 = i22 >>> 1;
  i22 = i6 + 36 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i22 + (i26 << 2) + 2 | 0;
  i26 = i22 + (i26 << 2) + 3 | 0;
  i26 = i23 ? i24 : i26;
  i26 = HEAP8[i26 >> 0] | 0;
  i26 = i26 & 127;
  i26 = i26 << 24 >> 24 != 127;
  i26 = i26 & 1;
  STACKTOP = i25;
  return i26 | 0;
 }
 f8 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 if (!i20) {
  i2 = i18;
  i1 = 0;
  while (1) {
   f31 = Math_fround(((i2 >>> 0) / (i12 >>> 0) | 0) >>> 0);
   f31 = Math_fround(Math_fround(f31 * f14) * Math_fround(2.0));
   f29 = Math_fround(Math_fround(Math_fround(HEAP16[i13 + (i2 << 2) >> 1] | 0) * f15) * Math_fround(2.0));
   f30 = Math_fround(Math_fround(Math_fround(((i2 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16) * Math_fround(2.0));
   f32 = Math_fround(Math_fround(Math_fround(f31 * f10) + Math_fround(f29 * f11)) + Math_fround(f30 * f7));
   f28 = Math_fround(Math_fround(f11 * f32) + Math_fround(Math_fround(f29 * f9) + Math_fround(f8 * Math_fround(Math_fround(f31 * f7) - Math_fround(f30 * f10)))));
   f27 = Math_fround(Math_fround(Math_fround(f30 * f9) + Math_fround(f8 * Math_fround(Math_fround(f29 * f10) - Math_fround(f31 * f11)))) + Math_fround(f7 * f32));
   HEAPF32[i24 + (i1 * 12 | 0) >> 2] = Math_fround(Math_fround(f10 * f32) + Math_fround(Math_fround(f31 * f9) + Math_fround(f8 * Math_fround(Math_fround(f30 * f11) - Math_fround(f29 * f7)))));
   HEAPF32[i24 + (i1 * 12 | 0) + 4 >> 2] = f28;
   HEAPF32[i24 + (i1 * 12 | 0) + 8 >> 2] = f27;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 3) break;
   i2 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
  }
  i23 = i22 & 1;
  i23 = (i23 | 0) == 0;
  i26 = i22 >>> 1;
  i22 = i6 + 36 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i22 + (i26 << 2) + 2 | 0;
  i26 = i22 + (i26 << 2) + 3 | 0;
  i26 = i23 ? i24 : i26;
  i26 = HEAP8[i26 >> 0] | 0;
  i26 = i26 & 127;
  i26 = i26 << 24 >> 24 != 127;
  i26 = i26 & 1;
  STACKTOP = i25;
  return i26 | 0;
 }
 i4 = i21 + 16 | 0;
 i5 = i21 + 20 | 0;
 i3 = i21 + 24 | 0;
 i2 = i18;
 i1 = 0;
 while (1) {
  f29 = Math_fround(((i2 >>> 0) / (i12 >>> 0) | 0) >>> 0);
  f29 = Math_fround(Math_fround(f29 * f14) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(Math_fround(HEAP16[i13 + (i2 << 2) >> 1] | 0) * f15) * Math_fround(2.0));
  f27 = Math_fround(Math_fround(Math_fround(((i2 >>> 0) % (i12 >>> 0) | 0) >>> 0) * f16) * Math_fround(2.0));
  f32 = Math_fround(Math_fround(Math_fround(f29 * f10) + Math_fround(f28 * f11)) + Math_fround(f27 * f7));
  f30 = Math_fround(Math_fround(f10 * f32) + Math_fround(Math_fround(f29 * f9) + Math_fround(f8 * Math_fround(Math_fround(f27 * f11) - Math_fround(f28 * f7)))));
  f31 = Math_fround(Math_fround(f11 * f32) + Math_fround(Math_fround(f28 * f9) + Math_fround(f8 * Math_fround(Math_fround(f29 * f7) - Math_fround(f27 * f10)))));
  f32 = Math_fround(Math_fround(Math_fround(f27 * f9) + Math_fround(f8 * Math_fround(Math_fround(f28 * f10) - Math_fround(f29 * f11)))) + Math_fround(f7 * f32));
  f30 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f30);
  f31 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f31);
  f32 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f32);
  HEAPF32[i24 + (i1 * 12 | 0) >> 2] = f30;
  HEAPF32[i24 + (i1 * 12 | 0) + 4 >> 2] = f31;
  HEAPF32[i24 + (i1 * 12 | 0) + 8 >> 2] = f32;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 3) break;
  i2 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
 }
 i23 = i22 & 1;
 i23 = (i23 | 0) == 0;
 i26 = i22 >>> 1;
 i22 = i6 + 36 | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 i24 = i22 + (i26 << 2) + 2 | 0;
 i26 = i22 + (i26 << 2) + 3 | 0;
 i26 = i23 ? i24 : i26;
 i26 = HEAP8[i26 >> 0] | 0;
 i26 = i26 & 127;
 i26 = i26 << 24 >> 24 != 127;
 i26 = i26 & 1;
 STACKTOP = i25;
 return i26 | 0;
}

function __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_(i5, i3, i1, i4, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0;
 f66 = Math_fround(HEAPF32[i4 >> 2]);
 f60 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f54 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f63 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f57 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f52 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f65 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f59 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f53 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f62 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f56 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f51 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 f30 = Math_fround(HEAPF32[i4 + 64 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 68 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 72 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 80 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 84 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 88 >> 2]);
 f40 = Math_fround(HEAPF32[i1 >> 2]);
 f41 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f45 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f39 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f50 = Math_fround(Math_fround(f66 * f40) + Math_fround(Math_fround(f65 * f41) + Math_fround(f30 * f45)));
 f49 = Math_fround(Math_fround(f60 * f40) + Math_fround(Math_fround(f59 * f41) + Math_fround(f27 * f45)));
 f48 = Math_fround(Math_fround(f54 * f40) + Math_fround(Math_fround(f53 * f41) + Math_fround(f24 * f45)));
 f44 = Math_fround(Math_fround(f66 * f34) + Math_fround(Math_fround(f65 * f35) + Math_fround(f30 * f39)));
 f43 = Math_fround(Math_fround(f60 * f34) + Math_fround(Math_fround(f59 * f35) + Math_fround(f27 * f39)));
 f42 = Math_fround(Math_fround(f54 * f34) + Math_fround(Math_fround(f53 * f35) + Math_fround(f24 * f39)));
 f38 = Math_fround(Math_fround(f66 * f31) + Math_fround(Math_fround(f65 * f32) + Math_fround(f30 * f33)));
 f37 = Math_fround(Math_fround(f60 * f31) + Math_fround(Math_fround(f59 * f32) + Math_fround(f27 * f33)));
 f36 = Math_fround(Math_fround(f54 * f31) + Math_fround(Math_fround(f53 * f32) + Math_fround(f24 * f33)));
 f47 = Math_fround(Math_fround(f63 * f40) + Math_fround(Math_fround(f62 * f41) + Math_fround(f12 * f45)));
 f46 = Math_fround(Math_fround(f57 * f40) + Math_fround(Math_fround(f56 * f41) + Math_fround(f9 * f45)));
 f45 = Math_fround(Math_fround(f52 * f40) + Math_fround(Math_fround(f51 * f41) + Math_fround(f6 * f45)));
 f41 = Math_fround(Math_fround(f63 * f34) + Math_fround(Math_fround(f62 * f35) + Math_fround(f12 * f39)));
 f40 = Math_fround(Math_fround(f57 * f34) + Math_fround(Math_fround(f56 * f35) + Math_fround(f9 * f39)));
 f39 = Math_fround(Math_fround(f52 * f34) + Math_fround(Math_fround(f51 * f35) + Math_fround(f6 * f39)));
 f35 = Math_fround(Math_fround(f63 * f31) + Math_fround(Math_fround(f62 * f32) + Math_fround(f12 * f33)));
 f34 = Math_fround(Math_fround(f57 * f31) + Math_fround(Math_fround(f56 * f32) + Math_fround(f9 * f33)));
 f33 = Math_fround(Math_fround(f52 * f31) + Math_fround(Math_fround(f51 * f32) + Math_fround(f6 * f33)));
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f67 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f61 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f55 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 f64 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f58 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f32 = Math_fround(Math_fround(Math_fround(f32 - Math_fround(f66 * f50)) - Math_fround(f65 * f44)) - Math_fround(f30 * f38));
 f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f66 * f49)) - Math_fround(f65 * f43)) - Math_fround(f30 * f37));
 f30 = Math_fround(Math_fround(Math_fround(f67 - Math_fround(f66 * f48)) - Math_fround(f65 * f42)) - Math_fround(f30 * f36));
 f23 = Math_fround(Math_fround(Math_fround(f23 - Math_fround(f63 * f50)) - Math_fround(f62 * f44)) - Math_fround(f12 * f38));
 f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f63 * f49)) - Math_fround(f62 * f43)) - Math_fround(f12 * f37));
 f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f63 * f48)) - Math_fround(f62 * f42)) - Math_fround(f12 * f36));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f63 * f47)) - Math_fround(f62 * f41)) - Math_fround(f12 * f35));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f63 * f46)) - Math_fround(f62 * f40)) - Math_fround(f12 * f34));
 f12 = Math_fround(Math_fround(Math_fround(f64 - Math_fround(f63 * f45)) - Math_fround(f62 * f39)) - Math_fround(f12 * f33));
 f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f60 * f50)) - Math_fround(f59 * f44)) - Math_fround(f27 * f38));
 f28 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(f60 * f49)) - Math_fround(f59 * f43)) - Math_fround(f27 * f37));
 f27 = Math_fround(Math_fround(Math_fround(f61 - Math_fround(f60 * f48)) - Math_fround(f59 * f42)) - Math_fround(f27 * f36));
 f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f57 * f50)) - Math_fround(f56 * f44)) - Math_fround(f9 * f38));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f57 * f49)) - Math_fround(f56 * f43)) - Math_fround(f9 * f37));
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f57 * f48)) - Math_fround(f56 * f42)) - Math_fround(f9 * f36));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f57 * f47)) - Math_fround(f56 * f41)) - Math_fround(f9 * f35));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f57 * f46)) - Math_fround(f56 * f40)) - Math_fround(f9 * f34));
 f9 = Math_fround(Math_fround(Math_fround(f58 - Math_fround(f57 * f45)) - Math_fround(f56 * f39)) - Math_fround(f9 * f33));
 f26 = Math_fround(Math_fround(Math_fround(f26 - Math_fround(f54 * f50)) - Math_fround(f53 * f44)) - Math_fround(f24 * f38));
 f25 = Math_fround(Math_fround(Math_fround(f25 - Math_fround(f54 * f49)) - Math_fround(f53 * f43)) - Math_fround(f24 * f37));
 f24 = Math_fround(Math_fround(Math_fround(f55 - Math_fround(f54 * f48)) - Math_fround(f53 * f42)) - Math_fround(f24 * f36));
 f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f52 * f50)) - Math_fround(f51 * f44)) - Math_fround(f6 * f38));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f52 * f49)) - Math_fround(f51 * f43)) - Math_fround(f6 * f37));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f52 * f48)) - Math_fround(f51 * f42)) - Math_fround(f6 * f36));
 f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f52 * f47)) - Math_fround(f51 * f41)) - Math_fround(f6 * f35));
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f52 * f46)) - Math_fround(f51 * f40)) - Math_fround(f6 * f34));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 136 >> 2]) - Math_fround(f52 * f45)) - Math_fround(f51 * f39)) - Math_fround(f6 * f33));
 HEAPF32[i2 >> 2] = f50;
 HEAPF32[i2 + 4 >> 2] = f49;
 HEAPF32[i2 + 8 >> 2] = f48;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f47;
 HEAPF32[i2 + 20 >> 2] = f46;
 HEAPF32[i2 + 24 >> 2] = f45;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 32 >> 2] = f44;
 HEAPF32[i2 + 36 >> 2] = f43;
 HEAPF32[i2 + 40 >> 2] = f42;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 48 >> 2] = f41;
 HEAPF32[i2 + 52 >> 2] = f40;
 HEAPF32[i2 + 56 >> 2] = f39;
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 64 >> 2] = f38;
 HEAPF32[i2 + 68 >> 2] = f37;
 HEAPF32[i2 + 72 >> 2] = f36;
 HEAPF32[i2 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 80 >> 2] = f35;
 HEAPF32[i2 + 84 >> 2] = f34;
 HEAPF32[i2 + 88 >> 2] = f33;
 HEAPF32[i2 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f32;
 HEAPF32[i5 + 4 >> 2] = f31;
 HEAPF32[i5 + 8 >> 2] = f30;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 16 >> 2] = f29;
 HEAPF32[i5 + 20 >> 2] = f28;
 HEAPF32[i5 + 24 >> 2] = f27;
 HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 32 >> 2] = f26;
 HEAPF32[i5 + 36 >> 2] = f25;
 HEAPF32[i5 + 40 >> 2] = f24;
 HEAPF32[i5 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 48 >> 2] = f23;
 HEAPF32[i5 + 52 >> 2] = f22;
 HEAPF32[i5 + 56 >> 2] = f21;
 HEAPF32[i5 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 64 >> 2] = f20;
 HEAPF32[i5 + 68 >> 2] = f19;
 HEAPF32[i5 + 72 >> 2] = f18;
 HEAPF32[i5 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 80 >> 2] = f17;
 HEAPF32[i5 + 84 >> 2] = f16;
 HEAPF32[i5 + 88 >> 2] = f15;
 HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 96 >> 2] = f14;
 HEAPF32[i5 + 100 >> 2] = f13;
 HEAPF32[i5 + 104 >> 2] = f12;
 HEAPF32[i5 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 112 >> 2] = f11;
 HEAPF32[i5 + 116 >> 2] = f10;
 HEAPF32[i5 + 120 >> 2] = f9;
 HEAPF32[i5 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 128 >> 2] = f8;
 HEAPF32[i5 + 132 >> 2] = f7;
 HEAPF32[i5 + 136 >> 2] = f6;
 HEAPF32[i5 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __ZN28BucketPrunerOverlapTraversalI19SphereAABBTest_SIMDLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i1, i18, i20, i19, i8) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 4 | 0;
 i7 = i21;
 i3 = i18 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = i20 + 4 | 0;
  i5 = i20 + 8 | 0;
  i6 = i20 + 16 | 0;
  i2 = 0;
  while (1) {
   f30 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) >> 2]);
   f23 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) + 12 >> 2]);
   f31 = Math_fround(f30 + f23);
   f28 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) + 16 >> 2]);
   f29 = Math_fround(f28 + f25);
   f26 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i18 + 160 + (i2 * 24 | 0) + 20 >> 2]);
   f31 = Math_fround(f31 * Math_fround(.5));
   f29 = Math_fround(f29 * Math_fround(.5));
   f27 = Math_fround(Math_fround(f26 + f24) * Math_fround(.5));
   f30 = Math_fround(Math_fround(f23 - f30) * Math_fround(.5));
   f28 = Math_fround(Math_fround(f25 - f28) * Math_fround(.5));
   f26 = Math_fround(Math_fround(f24 - f26) * Math_fround(.5));
   f24 = Math_fround(HEAPF32[i20 >> 2]);
   f25 = Math_fround(HEAPF32[i4 >> 2]);
   f31 = Math_fround(f24 - f31);
   f29 = Math_fround(f25 - f29);
   f27 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f27);
   f25 = Math_fround(-f30);
   f24 = Math_fround(-f28);
   f23 = Math_fround(-f26);
   f30 = f31 < f30 ? f31 : f30;
   f28 = f29 < f28 ? f29 : f28;
   f26 = f27 < f26 ? f27 : f26;
   f25 = Math_fround(f31 - (f30 > f25 ? f30 : f25));
   f24 = Math_fround(f29 - (f28 > f24 ? f28 : f24));
   f23 = Math_fround(f27 - (f26 > f23 ? f26 : f23));
   if (Math_fround(HEAPF32[i6 >> 2]) >= Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)) + Math_fround(f23 * f23))) {
    HEAPF32[i7 >> 2] = Math_fround(-1.0);
    if (!(mftCall_iiiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i7 | 0, i18 + 32 + (i2 << 3) | 0, 1) | 0)) {
     i1 = 0;
     break;
    }
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) break L1;
  }
  STACKTOP = i21;
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i18 + 584 >> 2] | 0)) {
  i22 = 1;
  STACKTOP = i21;
  return i22 | 0;
 }
 f23 = Math_fround(HEAPF32[i18 + 608 >> 2]);
 f25 = Math_fround(HEAPF32[i18 + 612 >> 2]);
 f27 = Math_fround(HEAPF32[i18 + 616 >> 2]);
 f24 = Math_fround(HEAPF32[i18 + 624 >> 2]);
 f26 = Math_fround(HEAPF32[i18 + 628 >> 2]);
 f28 = Math_fround(HEAPF32[i18 + 632 >> 2]);
 f30 = Math_fround(HEAPF32[i20 >> 2]);
 i15 = i20 + 4 | 0;
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i20 + 8 | 0;
 f23 = Math_fround(f30 - f23);
 f25 = Math_fround(f29 - f25);
 f27 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f27);
 f29 = Math_fround(-f24);
 f30 = Math_fround(-f26);
 f31 = Math_fround(-f28);
 f24 = f23 < f24 ? f23 : f24;
 f26 = f25 < f26 ? f25 : f26;
 f28 = f27 < f28 ? f27 : f28;
 f29 = Math_fround(f23 - (f24 > f29 ? f24 : f29));
 f30 = Math_fround(f25 - (f26 > f30 ? f26 : f30));
 f31 = Math_fround(f27 - (f28 > f31 ? f28 : f31));
 i14 = i20 + 16 | 0;
 if (!(Math_fround(HEAPF32[i14 >> 2]) >= Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31)))) {
  i22 = 1;
  STACKTOP = i21;
  return i22 | 0;
 }
 i5 = HEAP32[i18 + 592 >> 2] | 0;
 i6 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
 i5 = HEAP32[i8 + 12 + (i5 << 2) >> 2] | 0;
 i6 = (i6 | 0) < 0 ? ~i6 : i6 | -2147483648;
 i5 = (i5 | 0) < 0 ? ~i5 : i5 | -2147483648;
 i7 = i18 + 20 | 0;
 i8 = i18 + 24 | 0;
 i11 = 0;
 L17 : while (1) {
  if (HEAP32[i18 + 640 + (i11 << 2) >> 2] | 0) {
   f23 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) >> 2]);
   f25 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) + 16 >> 2]);
   f26 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) + 20 >> 2]);
   f28 = Math_fround(HEAPF32[i18 + 688 + (i11 << 5) + 24 >> 2]);
   f30 = Math_fround(HEAPF32[i20 >> 2]);
   f29 = Math_fround(HEAPF32[i15 >> 2]);
   f23 = Math_fround(f30 - f23);
   f25 = Math_fround(f29 - f25);
   f27 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f27);
   f29 = Math_fround(-f24);
   f30 = Math_fround(-f26);
   f31 = Math_fround(-f28);
   f24 = f23 < f24 ? f23 : f24;
   f26 = f25 < f26 ? f25 : f26;
   f28 = f27 < f28 ? f27 : f28;
   f29 = Math_fround(f23 - (f24 > f29 ? f24 : f29));
   f30 = Math_fround(f25 - (f26 > f30 ? f26 : f30));
   f31 = Math_fround(f27 - (f28 > f31 ? f28 : f31));
   if (Math_fround(HEAPF32[i14 >> 2]) >= Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31))) {
    i9 = i18 + 660 + (i11 << 2) | 0;
    i12 = 0;
    do {
     if (HEAP32[i18 + 864 + (i11 * 224 | 0) + (i12 << 2) >> 2] | 0) {
      f23 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) >> 2]);
      f25 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) + 4 >> 2]);
      f27 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) + 8 >> 2]);
      f24 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) + 16 >> 2]);
      f26 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) + 20 >> 2]);
      f28 = Math_fround(HEAPF32[i18 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) + 24 >> 2]);
      f30 = Math_fround(HEAPF32[i20 >> 2]);
      f29 = Math_fround(HEAPF32[i15 >> 2]);
      f23 = Math_fround(f30 - f23);
      f25 = Math_fround(f29 - f25);
      f27 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f27);
      f29 = Math_fround(-f24);
      f30 = Math_fround(-f26);
      f31 = Math_fround(-f28);
      f24 = f23 < f24 ? f23 : f24;
      f26 = f25 < f26 ? f25 : f26;
      f28 = f27 < f28 ? f27 : f28;
      f29 = Math_fround(f23 - (f24 > f29 ? f24 : f29));
      f30 = Math_fround(f25 - (f26 > f30 ? f26 : f30));
      f31 = Math_fround(f27 - (f28 > f31 ? f28 : f31));
      if (Math_fround(HEAPF32[i14 >> 2]) >= Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31))) {
       i10 = i18 + 864 + (i11 * 224 | 0) + 20 + (i12 << 2) | 0;
       i13 = 0;
       do {
        i1 = HEAP32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + (i13 << 2) >> 2] | 0;
        if (i1 | 0) {
         f23 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) >> 2]);
         f25 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) + 4 >> 2]);
         f27 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) + 8 >> 2]);
         f24 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) + 16 >> 2]);
         f26 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) + 20 >> 2]);
         f28 = Math_fround(HEAPF32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) + 24 >> 2]);
         f30 = Math_fround(HEAPF32[i20 >> 2]);
         f29 = Math_fround(HEAPF32[i15 >> 2]);
         f23 = Math_fround(f30 - f23);
         f25 = Math_fround(f29 - f25);
         f27 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f27);
         f29 = Math_fround(-f24);
         f30 = Math_fround(-f26);
         f31 = Math_fround(-f28);
         f24 = f23 < f24 ? f23 : f24;
         f26 = f25 < f26 ? f25 : f26;
         f28 = f27 < f28 ? f27 : f28;
         f29 = Math_fround(f23 - (f24 > f29 ? f24 : f29));
         f30 = Math_fround(f25 - (f26 > f30 ? f26 : f30));
         f31 = Math_fround(f27 - (f28 > f31 ? f28 : f31));
         if (Math_fround(HEAPF32[i14 >> 2]) >= Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31))) {
          i4 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i18 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 20 + (i13 << 2) >> 2] | 0) | 0;
          i2 = (HEAP32[i7 >> 2] | 0) + (i4 << 5) | 0;
          i4 = (HEAP32[i8 >> 2] | 0) + (i4 << 3) | 0;
          do {
           i1 = i1 + -1 | 0;
           i3 = i2;
           i2 = i2 + 32 | 0;
           if ((HEAP32[i3 + 28 >> 2] | 0) >>> 0 >= i6 >>> 0) {
            if ((HEAP32[i3 + 12 >> 2] | 0) >>> 0 > i5 >>> 0) break;
            f23 = Math_fround(HEAPF32[i3 >> 2]);
            f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
            f27 = Math_fround(HEAPF32[i3 + 8 >> 2]);
            f24 = Math_fround(HEAPF32[i3 + 16 >> 2]);
            f26 = Math_fround(HEAPF32[i3 + 20 >> 2]);
            f28 = Math_fround(HEAPF32[i3 + 24 >> 2]);
            f30 = Math_fround(HEAPF32[i20 >> 2]);
            f29 = Math_fround(HEAPF32[i15 >> 2]);
            f23 = Math_fround(f30 - f23);
            f25 = Math_fround(f29 - f25);
            f27 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f27);
            f29 = Math_fround(-f24);
            f30 = Math_fround(-f26);
            f31 = Math_fround(-f28);
            f24 = f23 < f24 ? f23 : f24;
            f26 = f25 < f26 ? f25 : f26;
            f28 = f27 < f28 ? f27 : f28;
            f29 = Math_fround(f23 - (f24 > f29 ? f24 : f29));
            f30 = Math_fround(f25 - (f26 > f30 ? f26 : f30));
            f31 = Math_fround(f27 - (f28 > f31 ? f28 : f31));
            if (Math_fround(HEAPF32[i14 >> 2]) >= Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31))) {
             HEAPF32[i17 >> 2] = Math_fround(-1.0);
             if (!(mftCall_iiiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i17 | 0, i4 | 0, 1) | 0)) break L17;
            }
           }
           i4 = i4 + 8 | 0;
          } while ((i1 | 0) != 0);
         }
        }
        i13 = i13 + 1 | 0;
       } while (i13 >>> 0 < 5);
      }
     }
     i12 = i12 + 1 | 0;
    } while (i12 >>> 0 < 5);
   }
  }
  i11 = i11 + 1 | 0;
  if (i11 >>> 0 >= 5) {
   i1 = 1;
   i22 = 29;
   break;
  }
 }
 if ((i22 | 0) == 29) {
  STACKTOP = i21;
  return i1 | 0;
 }
 i22 = 0;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 12 | 0, i10 + 1 | 0);
 i5 = i6 + 28 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj84ENS_22PxRepXPropertyAccessorILj84ES4_ffEEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 44 | 0, i10 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 60 | 0, i10 + 4 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i6 + 76 | 0, i10 + 5 | 0);
 i5 = i6 + 112 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj89ENS_22PxRepXPropertyAccessorILj89ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 128 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj90ENS_22PxRepXPropertyAccessorILj90ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 144 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj91ENS_22PxRepXPropertyAccessorILj91ES4_ffEEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclERKNS_32PxArticulationLinkCollectionPropEj(i9, i6 + 160 | 0, i10 + 10 | 0);
 i5 = i6 + 176 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj93ENS_22PxRepXPropertyAccessorILj93ES4_PKcSA_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 15 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 15 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx18PxcSweepCapsuleBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 448 | 0;
 i16 = i4 + 432 | 0;
 i22 = i4 + 288 | 0;
 i21 = i4 + 128 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i51 = HEAP32[i8 >> 2] | 0;
 i53 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i9 = i51 + 40 | 0;
 i47 = HEAP32[i9 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i51 + 44 >> 2]);
 i51 = HEAP32[i53 + 40 >> 2] | 0;
 i52 = HEAP32[i53 + 44 >> 2] | 0;
 i53 = HEAP32[i53 + 48 >> 2] | 0;
 f39 = Math_fround(f46 * Math_fround(0.0));
 i50 = i22 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 80 >> 2] = 4;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 128 >> 2] = i47;
 f45 = Math_fround(f39 + Math_fround(0.0));
 HEAPF32[i22 + 96 >> 2] = Math_fround(f46 + Math_fround(0.0));
 HEAPF32[i22 + 100 >> 2] = f45;
 HEAPF32[i22 + 104 >> 2] = f45;
 HEAPF32[i22 + 108 >> 2] = Math_fround(0.0);
 f39 = Math_fround(Math_fround(0.0) - f39);
 HEAPF32[i22 + 112 >> 2] = Math_fround(Math_fround(0.0) - f46);
 HEAPF32[i22 + 116 >> 2] = f39;
 HEAPF32[i22 + 120 >> 2] = f39;
 HEAPF32[i22 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 16 >> 2] = i47;
 HEAP32[i22 + 32 >> 2] = i47;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = -1;
 HEAP32[i50 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 i50 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 3;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i50 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i21 + 144 >> 2] = i51;
 HEAP32[i21 + 148 >> 2] = i52;
 HEAP32[i21 + 152 >> 2] = i53;
 HEAPF32[i21 + 156 >> 2] = Math_fround(0.0);
 f39 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = f39 <= f46 ? f39 : f46;
 f45 = f46 <= f45 ? f46 : f45;
 HEAPF32[i21 + 16 >> 2] = Math_fround(f45 * Math_fround(.150000006));
 HEAPF32[i21 + 32 >> 2] = Math_fround(f45 * Math_fround(.0500000007));
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i53 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i53 >> 2]);
 f25 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 i53 = HEAP32[i12 >> 2] | 0;
 i52 = HEAP32[i12 + 4 >> 2] | 0;
 i51 = HEAP32[i12 + 8 >> 2] | 0;
 i50 = HEAP32[i12 + 12 >> 2] | 0;
 i47 = i6 + 16 | 0;
 i49 = HEAP32[i47 >> 2] | 0;
 i48 = HEAP32[i47 + 4 >> 2] | 0;
 i47 = HEAP32[i47 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i53;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = i52;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = i51;
 i8 = i19 + 12 | 0;
 HEAP32[i8 >> 2] = i50;
 HEAP32[i19 + 16 >> 2] = i49;
 HEAP32[i19 + 20 >> 2] = i48;
 HEAP32[i19 + 24 >> 2] = i47;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f29 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f38 = Math_fround(f25 - f24);
 f40 = Math_fround(f27 - f32);
 f41 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f31 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f23 * Math_fround(Math_fround(f28 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f23 * Math_fround(Math_fround(f38 * f42) - Math_fround(f28 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f23) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f23)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f28) + Math_fround(f23 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f33;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f36 + f36);
 f31 = Math_fround(f26 + f26);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f26 * f31);
 f37 = Math_fround(f39 * f34);
 f26 = Math_fround(f26 * f33);
 f40 = Math_fround(f39 * f33);
 f23 = Math_fround(f35 * f33);
 f39 = Math_fround(f39 * f31);
 f31 = Math_fround(f35 * f31);
 f34 = Math_fround(f35 * f34);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f33));
 f36 = Math_fround(f26 + f34);
 f35 = Math_fround(f40 - f31);
 f34 = Math_fround(f26 - f34);
 f26 = Math_fround(f33 - f37);
 f28 = Math_fround(f39 + f23);
 f31 = Math_fround(f40 + f31);
 f23 = Math_fround(f39 - f23);
 f33 = Math_fround(f33 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f33;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(HEAPF32[i8 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f7)) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i53 = HEAP32[i3 + 4 >> 2] | 0;
 i52 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i53;
 HEAP32[i13 + 8 >> 2] = i52;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i53 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i52;
 HEAP32[i14 + 8 >> 2] = i53;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN20UnityConnectSettings14GetCloudUserIdEv(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 32 | 0;
 i8 = i15 + 16 | 0;
 i9 = i15;
 i11 = i10 + 180 | 0;
 i12 = i11 + 11 | 0;
 i3 = HEAP8[i12 >> 0] | 0;
 i5 = i3 << 24 >> 24 < 0;
 if (i5) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i3 & 255;
 if (i2 | 0) {
  i4 = i5 ? HEAP32[i11 >> 2] | 0 : i11;
  i3 = i5 ? HEAP32[i10 + 184 >> 2] | 0 : i3 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i14 = 8;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i3;
   if (i3) i14 = 10;
  } else i14 = 8;
  if ((i14 | 0) == 8) {
   i12 = i3 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i13;
   i14 = 10;
  }
  if ((i14 | 0) == 10) _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  STACKTOP = i15;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1041188 | 0, 18);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1576256 | 0, 0);
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i13, i8, i9);
 i6 = HEAP8[i13 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i5 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
 i6 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
 i2 = HEAP8[i12 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i10 + 188 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
 } else {
  if (i3) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   HEAP32[i10 + 184 >> 2] = i6;
   break;
  } else {
   HEAP8[i12 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i3 = HEAP8[i12 >> 0] | 0;
 i5 = i3 << 24 >> 24 < 0;
 if (i5) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i3 & 255;
 if (i2 | 0) {
  if (i5) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
  if (_strcmp(i2, gb + 1041207 | 0) | 0) {
   i4 = i5 ? HEAP32[i11 >> 2] | 0 : i11;
   i3 = i5 ? HEAP32[i10 + 184 >> 2] | 0 : i3 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i14 = 38;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i3;
    if (i3) i14 = 40;
   } else i14 = 38;
   if ((i14 | 0) == 38) {
    i12 = i3 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i13 + 4 >> 2] = i2;
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i13;
    HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i3;
    i1 = i13;
    i14 = 40;
   }
   if ((i14 | 0) == 40) _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   STACKTOP = i15;
   return;
  }
 }
 __ZN22UnityAnalyticsSettings12GetOldUserIdEv(i8, i10 + 68 | 0);
 i5 = i8 + 11 | 0;
 do if ((i11 | 0) != (i8 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i2 = i7 << 24 >> 24 < 0;
  i6 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  i7 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
  i2 = HEAP8[i12 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i10 + 188 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i4, i7 - i4 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
  if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i2 + i7 >> 0] = 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   HEAP32[i10 + 184 >> 2] = i7;
   break;
  } else {
   HEAP8[i12 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i7 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i13);
 }
 i2 = HEAP8[i12 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i2 & 255;
 if (i2 | 0) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1041188 | 0, 18);
  i2 = HEAP8[i12 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i2 = i10 + 184 | 0;
   i4 = i11;
   i5 = i11;
   i6 = i2;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
  } else {
   i4 = i11;
   i5 = i11;
   i6 = i10 + 184 | 0;
   i3 = i11;
   i2 = i2 & 255;
  };
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, i2);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i13, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i2 = HEAP8[i12 >> 0] | 0;
  i12 = i2 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i4 >> 2] | 0 : i5;
  i4 = i12 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i14 = 70;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i14 = 72;
  } else i14 = 70;
  if ((i14 | 0) == 70) {
   i12 = i4 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i13;
   i14 = 72;
  }
  if ((i14 | 0) == 72) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  STACKTOP = i15;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 __ZN9UnityGUID4InitEv(i8);
 __Z12GUIDToStringRK9UnityGUID(i13, i8);
 i6 = HEAP8[i13 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i5 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
 i6 = i2 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
 i2 = HEAP8[i12 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i10 + 188 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i2 = HEAP32[i10 + 184 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i4, i6 - i4 | 0, i2, 0, i2, i6, i5);
 } else {
  if (i3) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
  if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   HEAP32[i10 + 184 >> 2] = i6;
   break;
  } else {
   HEAP8[i12 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1041188 | 0, 18);
 i2 = HEAP8[i12 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = i10 + 184 | 0;
  i5 = i11;
  i6 = i2;
  i4 = i11;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i5 = i11;
  i6 = i10 + 184 | 0;
  i4 = i11;
  i3 = i11;
  i2 = i2 & 255;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i3, i2);
 __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i13, i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZN11PlayerPrefs4SyncEv();
 i2 = HEAP8[i12 >> 0] | 0;
 i12 = i2 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i4 >> 2] | 0 : i5;
 i4 = i12 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i14 = 95;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i14 = 97;
 } else i14 = 95;
 if ((i14 | 0) == 95) {
  i12 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i2;
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i13;
  HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i13;
  i14 = 97;
 }
 if ((i14 | 0) == 97) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __Z22b2DistanceBetweenLinesP6b2Vec2S0_RKS_S2_S2_S2_(i14, i15, i20, i6, i23, i7) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 i6 = i6 | 0;
 i23 = i23 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f21 = f0, f22 = f0, f24 = f0, f25 = f0;
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f24 = Math_fround(f24 - f12);
 f17 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i16 = i20 + 4 | 0;
 f11 = Math_fround(HEAPF32[i16 >> 2]);
 f17 = Math_fround(f17 - f11);
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(HEAPF32[i23 >> 2]);
 f18 = Math_fround(f18 - f2);
 i1 = i7 + 4 | 0;
 f21 = Math_fround(HEAPF32[i1 >> 2]);
 i19 = i23 + 4 | 0;
 f4 = Math_fround(HEAPF32[i19 >> 2]);
 f21 = Math_fround(f21 - f4);
 f13 = Math_fround(Math_fround(f24 * f24) + Math_fround(f17 * f17));
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(f21 * f21));
 do if (f13 < Math_fround(1.42108547e-14)) {
  i6 = i20;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i14;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  if (f22 < Math_fround(1.42108547e-14)) {
   i19 = i23;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i23 = i15;
   HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i23 + 4 >> 2] = i20;
   break;
  } else {
   f12 = Math_fround(HEAPF32[i20 >> 2]);
   f17 = Math_fround(HEAPF32[i23 >> 2]);
   f12 = Math_fround(f12 - f17);
   f13 = Math_fround(HEAPF32[i16 >> 2]);
   f24 = Math_fround(HEAPF32[i19 >> 2]);
   f22 = Math_fround(Math_fround(Math_fround(f18 * f12) + Math_fround(f21 * Math_fround(f13 - f24))) / f22);
   i23 = f22 < Math_fround(1.0);
   f22 = i23 ? f22 : Math_fround(1.0);
   i23 = f22 < Math_fround(0.0);
   f22 = i23 ? Math_fround(0.0) : f22;
   f24 = Math_fround(f24 + Math_fround(f21 * f22));
   HEAPF32[i15 >> 2] = Math_fround(f17 + Math_fround(f18 * f22));
   HEAPF32[i15 + 4 >> 2] = f24;
   break;
  }
 } else {
  if (f22 < Math_fround(1.42108547e-14)) {
   i6 = i23;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i8 = i15;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = i7;
   f12 = Math_fround(HEAPF32[i23 >> 2]);
   f18 = Math_fround(HEAPF32[i20 >> 2]);
   f12 = Math_fround(f12 - f18);
   f21 = Math_fround(HEAPF32[i19 >> 2]);
   f22 = Math_fround(HEAPF32[i16 >> 2]);
   f21 = Math_fround(Math_fround(Math_fround(f24 * f12) + Math_fround(f17 * Math_fround(f21 - f22))) / f13);
   i23 = f21 < Math_fround(1.0);
   f21 = i23 ? f21 : Math_fround(1.0);
   i23 = f21 < Math_fround(0.0);
   f21 = i23 ? Math_fround(0.0) : f21;
   f22 = Math_fround(f22 + Math_fround(f17 * f21));
   HEAPF32[i14 >> 2] = Math_fround(f18 + Math_fround(f24 * f21));
   HEAPF32[i14 + 4 >> 2] = f22;
   break;
  }
  f10 = Math_fround(f2 - f12);
  f4 = Math_fround(f4 - f11);
  f2 = Math_fround(Math_fround(f24 * f18) + Math_fround(f17 * f21));
  f5 = Math_fround(-f2);
  f2 = Math_fround(Math_fround(f13 * f22) - Math_fround(f2 * f2));
  i8 = f2 > Math_fround(0.0);
  f25 = Math_fround(-f2);
  f9 = Math_fround(Math_fround(f24 * f10) + Math_fround(f17 * f4));
  if (!((i8 ? f2 : f25) < Math_fround(1.1920929e-07))) {
   f4 = Math_fround(Math_fround(Math_fround(-Math_fround(f13 * Math_fround(Math_fround(f18 * f10) + Math_fround(f21 * f4)))) - Math_fround(f9 * f5)) / f2);
   f2 = Math_fround(Math_fround(f9 - Math_fround(f4 * f5)) / f13);
   f25 = Math_fround(f11 + Math_fround(f17 * f2));
   HEAPF32[i14 >> 2] = Math_fround(f12 + Math_fround(f24 * f2));
   i6 = i14 + 4 | 0;
   HEAPF32[i6 >> 2] = f25;
   f12 = Math_fround(f18 * f4);
   f25 = Math_fround(f21 * f4);
   f12 = Math_fround(f12 + Math_fround(HEAPF32[i23 >> 2]));
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i15 >> 2] = f12;
   i3 = i15 + 4 | 0;
   HEAPF32[i3 >> 2] = f25;
   i1 = f2 < Math_fround(0.0) | f2 > Math_fround(1.0);
   i7 = f4 < Math_fround(0.0);
   i8 = f4 > Math_fround(1.0);
   if (!(i8 | (i7 | i1))) break;
   if (!i1) {
    i8 = f4 < Math_fround(1.0);
    f22 = i8 ? f4 : Math_fround(1.0);
    i8 = f22 < Math_fround(0.0);
    f22 = i8 ? Math_fround(0.0) : f22;
    f18 = Math_fround(f18 * f22);
    f22 = Math_fround(f21 * f22);
    f18 = Math_fround(f18 + Math_fround(HEAPF32[i23 >> 2]));
    f22 = Math_fround(f22 + Math_fround(HEAPF32[i19 >> 2]));
    HEAPF32[i15 >> 2] = f18;
    HEAPF32[i3 >> 2] = f22;
    f21 = Math_fround(HEAPF32[i20 >> 2]);
    f18 = Math_fround(f18 - f21);
    f25 = Math_fround(HEAPF32[i16 >> 2]);
    f22 = Math_fround(Math_fround(Math_fround(f24 * f18) + Math_fround(f17 * Math_fround(f22 - f25))) / f13);
    i23 = f22 < Math_fround(1.0);
    f22 = i23 ? f22 : Math_fround(1.0);
    i23 = f22 < Math_fround(0.0);
    f22 = i23 ? Math_fround(0.0) : f22;
    f25 = Math_fround(f25 + Math_fround(f17 * f22));
    HEAPF32[i14 >> 2] = Math_fround(f21 + Math_fround(f24 * f22));
    HEAPF32[i6 >> 2] = f25;
    break;
   }
   i1 = f2 < Math_fround(1.0);
   f5 = i1 ? f2 : Math_fround(1.0);
   i1 = f5 < Math_fround(0.0);
   f5 = i1 ? Math_fround(0.0) : f5;
   f25 = Math_fround(f24 * f5);
   f5 = Math_fround(f17 * f5);
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i20 >> 2]));
   f5 = Math_fround(f5 + Math_fround(HEAPF32[i16 >> 2]));
   HEAPF32[i14 >> 2] = f25;
   HEAPF32[i6 >> 2] = f5;
   f2 = Math_fround(HEAPF32[i23 >> 2]);
   f25 = Math_fround(f25 - f2);
   f4 = Math_fround(HEAPF32[i19 >> 2]);
   f5 = Math_fround(Math_fround(Math_fround(f18 * f25) + Math_fround(f21 * Math_fround(f5 - f4))) / f22);
   if (!(i7 | i8)) {
    i23 = f5 < Math_fround(1.0);
    f24 = i23 ? f5 : Math_fround(1.0);
    i23 = f24 < Math_fround(0.0);
    f24 = i23 ? Math_fround(0.0) : f24;
    f25 = Math_fround(f4 + Math_fround(f21 * f24));
    HEAPF32[i15 >> 2] = Math_fround(f2 + Math_fround(f18 * f24));
    HEAPF32[i3 >> 2] = f25;
    break;
   }
   f25 = Math_fround(f4 + Math_fround(f21 * f5));
   HEAPF32[i15 >> 2] = Math_fround(f2 + Math_fround(f18 * f5));
   HEAPF32[i3 >> 2] = f25;
   if (!(f5 < Math_fround(0.0) | f5 > Math_fround(1.0))) break;
   i8 = f5 < Math_fround(1.0);
   f25 = i8 ? f5 : Math_fround(1.0);
   i8 = f25 < Math_fround(0.0);
   f25 = i8 ? Math_fround(0.0) : f25;
   f10 = Math_fround(f18 * f25);
   f25 = Math_fround(f21 * f25);
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i23 >> 2]));
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i15 >> 2] = f10;
   HEAPF32[i3 >> 2] = f25;
   f11 = Math_fround(HEAPF32[i20 >> 2]);
   f10 = Math_fround(f10 - f11);
   f12 = Math_fround(HEAPF32[i16 >> 2]);
   f25 = Math_fround(Math_fround(Math_fround(f24 * f10) + Math_fround(f17 * Math_fround(f25 - f12))) / f13);
   i20 = f25 < Math_fround(1.0);
   f25 = i20 ? f25 : Math_fround(1.0);
   i20 = f25 < Math_fround(0.0);
   f25 = i20 ? Math_fround(0.0) : f25;
   f13 = Math_fround(f11 + Math_fround(f24 * f25));
   f24 = Math_fround(f12 + Math_fround(f17 * f25));
   HEAPF32[i14 >> 2] = f13;
   HEAPF32[i6 >> 2] = f24;
   f17 = Math_fround(HEAPF32[i23 >> 2]);
   f13 = Math_fround(f13 - f17);
   f25 = Math_fround(HEAPF32[i19 >> 2]);
   f24 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(f21 * Math_fround(f24 - f25))) / f22);
   i23 = f24 < Math_fround(1.0);
   f24 = i23 ? f24 : Math_fround(1.0);
   i23 = f24 < Math_fround(0.0);
   f24 = i23 ? Math_fround(0.0) : f24;
   f25 = Math_fround(f25 + Math_fround(f21 * f24));
   HEAPF32[i15 >> 2] = Math_fround(f17 + Math_fround(f18 * f24));
   HEAPF32[i3 >> 2] = f25;
   break;
  }
  f4 = Math_fround(f9 / f13);
  f11 = Math_fround(f11 + Math_fround(f17 * f4));
  HEAPF32[i14 >> 2] = Math_fround(f12 + Math_fround(f24 * f4));
  i3 = i14 + 4 | 0;
  HEAPF32[i3 >> 2] = f11;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  f12 = Math_fround(HEAPF32[i20 >> 2]);
  f11 = Math_fround(f11 - f12);
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  f25 = Math_fround(HEAPF32[i16 >> 2]);
  f2 = Math_fround(Math_fround(Math_fround(f24 * f11) + Math_fround(f17 * Math_fround(f2 - f25))) / f13);
  f25 = Math_fround(f25 + Math_fround(f17 * f2));
  HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(f24 * f2));
  i1 = i15 + 4 | 0;
  HEAPF32[i1 >> 2] = f25;
  if (f4 < Math_fround(0.0) & f2 < Math_fround(0.0)) {
   i16 = i20;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i14;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   if (f4 < f2) {
    i19 = i7;
    i20 = HEAP32[i19 + 4 >> 2] | 0;
    i23 = i15;
    HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i23 + 4 >> 2] = i20;
    break;
   } else {
    i19 = i23;
    i20 = HEAP32[i19 + 4 >> 2] | 0;
    i23 = i15;
    HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i23 + 4 >> 2] = i20;
    break;
   }
  }
  if (!(f4 > Math_fround(1.0) & f2 > Math_fround(1.0))) {
   i8 = f4 < Math_fround(1.0);
   f13 = i8 ? f4 : Math_fround(1.0);
   i8 = f13 < Math_fround(0.0);
   f13 = i8 ? Math_fround(0.0) : f13;
   i8 = f2 < Math_fround(1.0);
   f25 = i8 ? f2 : Math_fround(1.0);
   i8 = f25 < Math_fround(0.0);
   f25 = Math_fround(Math_fround(f13 + (i8 ? Math_fround(0.0) : f25)) * Math_fround(.5));
   f13 = Math_fround(f24 * f25);
   f24 = Math_fround(f17 * f25);
   f13 = Math_fround(f13 + Math_fround(HEAPF32[i20 >> 2]));
   f24 = Math_fround(f24 + Math_fround(HEAPF32[i16 >> 2]));
   HEAPF32[i14 >> 2] = f13;
   HEAPF32[i3 >> 2] = f24;
   f17 = Math_fround(HEAPF32[i23 >> 2]);
   f13 = Math_fround(f13 - f17);
   f25 = Math_fround(HEAPF32[i19 >> 2]);
   f24 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(f21 * Math_fround(f24 - f25))) / f22);
   f25 = Math_fround(f25 + Math_fround(f21 * f24));
   HEAPF32[i15 >> 2] = Math_fround(f17 + Math_fround(f18 * f24));
   HEAPF32[i1 >> 2] = f25;
   break;
  }
  i16 = i6;
  i19 = HEAP32[i16 + 4 >> 2] | 0;
  i20 = i14;
  HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i20 + 4 >> 2] = i19;
  if (f4 < f2) {
   i19 = i23;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i23 = i15;
   HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i23 + 4 >> 2] = i20;
   break;
  } else {
   i19 = i7;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i23 = i15;
   HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i23 + 4 >> 2] = i20;
   break;
  }
 } while (0);
 f24 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i14 >> 2]));
 f25 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f25 = Math_fround(f25 - Math_fround(HEAPF32[i14 + 4 >> 2]));
 return Math_fround(Math_sqrt(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25))));
}

function __ZN15b2RevoluteJoint24SolveVelocityConstraintsERK12b2SolverData(i26, i1) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, f37 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i36 + 32 | 0;
 i12 = i36 + 8 | 0;
 i27 = i36 + 24 | 0;
 i28 = i36;
 i34 = i26 + 128 | 0;
 i29 = HEAP32[i34 >> 2] | 0;
 i35 = i1 + 28 | 0;
 i24 = HEAP32[i35 >> 2] | 0;
 i7 = HEAP32[i24 + (i29 * 12 | 0) >> 2] | 0;
 i8 = HEAP32[i24 + (i29 * 12 | 0) + 4 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i24 + (i29 * 12 | 0) + 8 >> 2]);
 i29 = i26 + 132 | 0;
 i4 = HEAP32[i29 >> 2] | 0;
 i5 = HEAP32[i24 + (i4 * 12 | 0) >> 2] | 0;
 i6 = HEAP32[i24 + (i4 * 12 | 0) + 4 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i24 + (i4 * 12 | 0) + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i26 + 168 >> 2]);
 f31 = Math_fround(HEAPF32[i26 + 172 >> 2]);
 f32 = Math_fround(HEAPF32[i26 + 176 >> 2]);
 f33 = Math_fround(HEAPF32[i26 + 180 >> 2]);
 i4 = Math_fround(f32 + f33) == Math_fround(0.0);
 if (!(HEAP8[i26 + 100 >> 0] | 0)) f25 = f3; else if (i4 | (HEAP32[i26 + 224 >> 2] | 0) == 3) f25 = f3; else {
  f20 = Math_fround(f3 - f2);
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i26 + 108 >> 2]));
  f20 = Math_fround(Math_fround(HEAPF32[i26 + 220 >> 2]) * f20);
  i24 = i26 + 96 | 0;
  f25 = Math_fround(HEAPF32[i24 >> 2]);
  f22 = Math_fround(HEAPF32[i1 >> 2]);
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i26 + 104 >> 2]));
  f20 = Math_fround(f25 - f20);
  f21 = Math_fround(-f22);
  f22 = f20 < f22 ? f20 : f22;
  f22 = f22 < f21 ? f21 : f22;
  HEAPF32[i24 >> 2] = f22;
  f25 = Math_fround(f22 - f25);
  f2 = Math_fround(f2 - Math_fround(f32 * f25));
  f25 = Math_fround(f3 + Math_fround(f33 * f25));
 }
 if (HEAP8[i26 + 112 >> 0] | 0) {
  i13 = i26 + 224 | 0;
  if (!(i4 | (HEAP32[i13 >> 2] | 0) == 0)) {
   i23 = i26 + 148 | 0;
   f14 = Math_fround(f25 * Math_fround(HEAPF32[i23 >> 2]));
   i24 = i26 + 144 | 0;
   f17 = Math_fround(f25 * Math_fround(HEAPF32[i24 >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f22 - f14);
   f21 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f21 + f17);
   f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f14 - f20);
   f18 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f17 - f18);
   i8 = i26 + 140 | 0;
   f16 = Math_fround(f2 * Math_fround(HEAPF32[i8 >> 2]));
   i19 = i26 + 136 | 0;
   f16 = Math_fround(f14 + f16);
   f17 = Math_fround(f17 - Math_fround(f2 * Math_fround(HEAPF32[i19 >> 2])));
   f14 = Math_fround(f25 - f2);
   HEAPF32[i11 >> 2] = f16;
   HEAPF32[i11 + 4 >> 2] = f17;
   HEAPF32[i11 + 8 >> 2] = f14;
   i7 = i26 + 184 | 0;
   __ZNK7b2Mat337Solve33ERK6b2Vec3(i12, i7, i11);
   f14 = Math_fround(HEAPF32[i12 >> 2]);
   f37 = Math_fround(-f14);
   f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f10 = Math_fround(-f15);
   f9 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f3 = Math_fround(-f9);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   L8 : do switch (HEAP32[i13 >> 2] | 0) {
   case 3:
    {
     i28 = i26 + 84 | 0;
     HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f14);
     i28 = i26 + 88 | 0;
     HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f15);
     i28 = i26 + 92 | 0;
     HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f9);
     break;
    }
   case 1:
    {
     i5 = i26 + 84 | 0;
     i6 = i26 + 92 | 0;
     f10 = Math_fround(HEAPF32[i6 >> 2]);
     f9 = Math_fround(f10 - f9);
     if (f9 < Math_fround(0.0)) {
      f37 = Math_fround(HEAPF32[i26 + 208 >> 2]);
      f3 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i26 + 212 >> 2])) - f17);
      HEAPF32[i27 >> 2] = Math_fround(Math_fround(f10 * f37) - f16);
      HEAPF32[i27 + 4 >> 2] = f3;
      __ZNK7b2Mat337Solve22ERK6b2Vec2(i28, i7, i27);
      i4 = HEAP32[i28 >> 2] | 0;
      i1 = HEAP32[i28 + 4 >> 2] | 0;
      f3 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      HEAPF32[i5 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i5 >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i28 = i26 + 88 | 0;
      HEAPF32[i28 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i28 >> 2]));
      HEAPF32[i6 >> 2] = Math_fround(0.0);
      break L8;
     } else {
      HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f14);
      i28 = i26 + 88 | 0;
      HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f15);
      HEAPF32[i6 >> 2] = f9;
      break L8;
     }
    }
   case 2:
    {
     i5 = i26 + 84 | 0;
     i6 = i26 + 92 | 0;
     f10 = Math_fround(HEAPF32[i6 >> 2]);
     f9 = Math_fround(f10 - f9);
     if (f9 > Math_fround(0.0)) {
      f37 = Math_fround(HEAPF32[i26 + 208 >> 2]);
      f3 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i26 + 212 >> 2])) - f17);
      HEAPF32[i27 >> 2] = Math_fround(Math_fround(f10 * f37) - f16);
      HEAPF32[i27 + 4 >> 2] = f3;
      __ZNK7b2Mat337Solve22ERK6b2Vec2(i28, i7, i27);
      i4 = HEAP32[i28 >> 2] | 0;
      i1 = HEAP32[i28 + 4 >> 2] | 0;
      f3 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      HEAPF32[i5 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i5 >> 2]));
      f37 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i28 = i26 + 88 | 0;
      HEAPF32[i28 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i28 >> 2]));
      HEAPF32[i6 >> 2] = Math_fround(0.0);
      break L8;
     } else {
      HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f14);
      i28 = i26 + 88 | 0;
      HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f15);
      HEAPF32[i6 >> 2] = f9;
      break L8;
     }
    }
   default:
    {}
   } while (0);
   f37 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f20 - Math_fround(f30 * f37));
   f18 = Math_fround(f18 - Math_fround(f30 * f16));
   f20 = Math_fround(f16 * Math_fround(HEAPF32[i19 >> 2]));
   f20 = Math_fround(f3 + Math_fround(f20 - Math_fround(f37 * Math_fround(HEAPF32[i8 >> 2]))));
   f30 = Math_fround(f22 + Math_fround(f31 * f37));
   f31 = Math_fround(f21 + Math_fround(f31 * f16));
   f21 = Math_fround(f16 * Math_fround(HEAPF32[i24 >> 2]));
   f37 = Math_fround(f3 + Math_fround(f21 - Math_fround(f37 * Math_fround(HEAPF32[i23 >> 2]))));
   f21 = f17;
   f22 = f18;
   f32 = Math_fround(f32 * f20);
   f37 = Math_fround(f33 * f37);
   f33 = Math_fround(f2 - f32);
   f37 = Math_fround(f25 + f37);
   i28 = HEAP32[i34 >> 2] | 0;
   i27 = HEAP32[i35 >> 2] | 0;
   i26 = i27 + (i28 * 12 | 0) | 0;
   HEAPF32[i26 >> 2] = f21;
   i28 = i27 + (i28 * 12 | 0) + 4 | 0;
   HEAPF32[i28 >> 2] = f22;
   i34 = HEAP32[i34 >> 2] | 0;
   i28 = HEAP32[i35 >> 2] | 0;
   i34 = i28 + (i34 * 12 | 0) + 8 | 0;
   HEAPF32[i34 >> 2] = f33;
   i34 = HEAP32[i29 >> 2] | 0;
   i27 = i28 + (i34 * 12 | 0) | 0;
   HEAPF32[i27 >> 2] = f30;
   i34 = i28 + (i34 * 12 | 0) + 4 | 0;
   HEAPF32[i34 >> 2] = f31;
   i34 = HEAP32[i29 >> 2] | 0;
   i35 = HEAP32[i35 >> 2] | 0;
   i35 = i35 + (i34 * 12 | 0) + 8 | 0;
   HEAPF32[i35 >> 2] = f37;
   STACKTOP = i36;
   return;
  }
 }
 i28 = i26 + 148 | 0;
 f20 = Math_fround(f25 * Math_fround(HEAPF32[i28 >> 2]));
 i24 = i26 + 144 | 0;
 f37 = Math_fround(f25 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f16 - f20);
 f17 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f17 + f37);
 f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f20 - f21);
 f22 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f37 - f22);
 i23 = i26 + 140 | 0;
 f18 = Math_fround(f2 * Math_fround(HEAPF32[i23 >> 2]));
 i19 = i26 + 136 | 0;
 f37 = Math_fround(-Math_fround(f37 - Math_fround(f2 * Math_fround(HEAPF32[i19 >> 2]))));
 HEAPF32[i27 >> 2] = Math_fround(-Math_fround(f20 + f18));
 HEAPF32[i27 + 4 >> 2] = f37;
 __ZNK7b2Mat337Solve22ERK6b2Vec2(i11, i26 + 184 | 0, i27);
 f37 = Math_fround(HEAPF32[i11 >> 2]);
 i27 = i26 + 84 | 0;
 HEAPF32[i27 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i27 >> 2]));
 f18 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 i27 = i26 + 88 | 0;
 HEAPF32[i27 >> 2] = Math_fround(f18 + Math_fround(HEAPF32[i27 >> 2]));
 f21 = Math_fround(f21 - Math_fround(f30 * f37));
 f22 = Math_fround(f22 - Math_fround(f30 * f18));
 f20 = Math_fround(f18 * Math_fround(HEAPF32[i19 >> 2]));
 f20 = Math_fround(f20 - Math_fround(f37 * Math_fround(HEAPF32[i23 >> 2])));
 f30 = Math_fround(f16 + Math_fround(f31 * f37));
 f31 = Math_fround(f17 + Math_fround(f31 * f18));
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i24 >> 2]));
 f37 = Math_fround(f18 - Math_fround(f37 * Math_fround(HEAPF32[i28 >> 2])));
 f32 = Math_fround(f32 * f20);
 f37 = Math_fround(f33 * f37);
 f33 = Math_fround(f2 - f32);
 f37 = Math_fround(f25 + f37);
 i28 = HEAP32[i34 >> 2] | 0;
 i27 = HEAP32[i35 >> 2] | 0;
 i26 = i27 + (i28 * 12 | 0) | 0;
 HEAPF32[i26 >> 2] = f21;
 i28 = i27 + (i28 * 12 | 0) + 4 | 0;
 HEAPF32[i28 >> 2] = f22;
 i34 = HEAP32[i34 >> 2] | 0;
 i28 = HEAP32[i35 >> 2] | 0;
 i34 = i28 + (i34 * 12 | 0) + 8 | 0;
 HEAPF32[i34 >> 2] = f33;
 i34 = HEAP32[i29 >> 2] | 0;
 i27 = i28 + (i34 * 12 | 0) | 0;
 HEAPF32[i27 >> 2] = f30;
 i34 = i28 + (i34 * 12 | 0) + 4 | 0;
 HEAPF32[i34 >> 2] = f31;
 i34 = HEAP32[i29 >> 2] | 0;
 i35 = HEAP32[i35 >> 2] | 0;
 i35 = i35 + (i34 * 12 | 0) + 8 | 0;
 HEAPF32[i35 >> 2] = f37;
 STACKTOP = i36;
 return;
}

function __ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i10, i2, i8) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i12 = i14;
 do if ((i10 | 0) < 0 & (i8 | 0) != 0) {
  i7 = i8 + 12 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i3) {
   i6 = HEAP32[i3 + 72 >> 2] | 0;
   if (i6) {
    HEAP32[i12 >> 2] = i6;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i13 = 9; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i3, i12);
      i4 = HEAP32[i11 >> 2] | 0;
      i9 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i9 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i9 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i13 = 9; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i13 = 11;
    }
    if ((i13 | 0) == 9) i13 = 11;
    if ((i13 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i6 + 72 >> 2] | 0;
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 17; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i3 = HEAP32[i11 >> 2] | 0;
      i9 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 17; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 19;
     }
    }
    if ((i13 | 0) == 17) i13 = 19;
    if ((i13 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    i9 = i1 + 248 | 0;
    i1 = i9;
    i8 = i6;
    i10 = i10 + -1 + (HEAP32[i9 + 72 >> 2] | 0) | 0;
   }
  }
 } while (0);
 i7 = i1 + 72 | 0;
 do if (i8 | 0 ? (i10 | 0) >= (HEAP32[i7 >> 2] | 0) : 0) {
  i9 = i8 + 4 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if (i3) {
   i6 = HEAP32[i3 + 72 >> 2] | 0;
   if (i6) {
    HEAP32[i12 >> 2] = i6;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i13 = 29; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i3, i12);
      i4 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i15 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i15 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i13 = 29; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i13 = 31;
    }
    if ((i13 | 0) == 29) i13 = 31;
    if ((i13 | 0) == 31) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i7 = i10 + 1 - (HEAP32[i7 >> 2] | 0) | 0;
    i6 = HEAP32[i9 >> 2] | 0;
    i5 = HEAP32[i6 + 72 >> 2] | 0;
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 37; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i3 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 37; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 39;
     }
    }
    if ((i13 | 0) == 37) i13 = 39;
    if ((i13 | 0) == 39) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    i1 = i1 + 248 | 0;
    i8 = i6;
    i10 = i7;
   }
  }
 } while (0);
 do if ((i2 | 0) < 0 & (i8 | 0) != 0) {
  i7 = i8 + 8 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i3) {
   i6 = HEAP32[i3 + 72 >> 2] | 0;
   if (i6) {
    HEAP32[i12 >> 2] = i6;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i13 = 49; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i3, i12);
      i4 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i15 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i15 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i13 = 49; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i13 = 51;
    }
    if ((i13 | 0) == 49) i13 = 51;
    if ((i13 | 0) == 51) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i8 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i8 + 72 >> 2] | 0;
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 57; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i3 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 57; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 59;
     }
    }
    if ((i13 | 0) == 57) i13 = 59;
    if ((i13 | 0) == 59) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    i1 = i1 + 248 | 0;
    i2 = i2 + -1 + (HEAP32[i1 + 76 >> 2] | 0) | 0;
   }
  }
 } while (0);
 i7 = i1 + 76 | 0;
 do if (i8 | 0 ? (i2 | 0) >= (HEAP32[i7 >> 2] | 0) : 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if (i3) {
   i6 = HEAP32[i3 + 72 >> 2] | 0;
   if (i6) {
    HEAP32[i12 >> 2] = i6;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i13 = 69; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i3, i12);
      i4 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i15 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i15 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i13 = 69; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i13 = 71;
    }
    if ((i13 | 0) == 69) i13 = 71;
    if ((i13 | 0) == 71) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i2 = i2 + 1 - (HEAP32[i7 >> 2] | 0) | 0;
    i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + 72 >> 2] | 0;
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 77; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i3 = HEAP32[i11 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 77; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 79;
     }
    }
    if ((i13 | 0) == 77) i13 = 79;
    if ((i13 | 0) == 79) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    i1 = i1 + 248 | 0;
   }
  }
 } while (0);
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) / Math_fround(32766.0));
 i13 = (HEAP32[i1 + 72 >> 2] | 0) + -1 | 0;
 i12 = i15 + -1 | 0;
 i15 = ((i2 | 0) < 0 ? 0 : (i12 | 0) < (i2 | 0) ? i12 : i2) + (Math_imul((i10 | 0) < 0 ? 0 : (i13 | 0) < (i10 | 0) ? i13 : i10, i15) | 0) | 0;
 f16 = Math_fround(f16 * Math_fround(HEAP16[(HEAP32[i1 + 4 >> 2] | 0) + (i15 << 1) >> 1] | 0));
 STACKTOP = i14;
 return Math_fround(f16);
}

function __ZNSt3__217moneypunct_bynameIwLb1EE4initEPKc(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11 + 32 | 0;
 i13 = i11;
 i7 = i11 + 24 | 0;
 i10 = i11 + 12 | 0;
 i17 = _newlocale(2147483647, i1, 0) | 0;
 i15 = (i17 | 0) == 0;
 L1 : do if (i15) {
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i14 = _strlen(i1) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i13 | 0, i1 | 0, i14 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i13 | 0, 0, gb + 1081806 | 0) | 0;
   i14 = __THREW__;
   __THREW__ = 0;
   if (i14 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i12 | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   if (!i2) {
    i14 = 76;
    break;
   }
  }
  ___cxa_free_exception(i3 | 0);
  i14 = 76;
 } else {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2805 | 0, i17 | 0) | 0;
  i8 = __THREW__;
  __THREW__ = 0;
  do if (i8 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i8 = invoke_i(fb + 318 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (!i2) break;
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (!(i6 & 1)) break;
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   }
   if (i2 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i6 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i6);
    }
   }
   i6 = HEAP8[HEAP32[i8 + 20 >> 2] >> 0] | 0;
   HEAP32[i9 + 8 >> 2] = i6 << 24 >> 24 == 0 ? 2147483647 : i6 << 24 >> 24;
   i6 = HEAP8[HEAP32[i8 + 24 >> 2] >> 0] | 0;
   HEAP32[i9 + 12 >> 2] = i6 << 24 >> 24 == 0 ? 2147483647 : i6 << 24 >> 24;
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, i9 + 16 | 0, HEAP32[i8 + 28 >> 2] | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i14 = 77;
    break L1;
   }
   i2 = i13;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i7 >> 2] = HEAP32[i8 + 12 >> 2];
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2805 | 0, i17 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   L34 : do if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i14 = 37;
   } else {
    __THREW__ = 0;
    i3 = invoke_iiiii(fb + 208 | 0, i12 | 0, i7 | 0, 100, i13 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     if (!i2) {
      i14 = 37;
      break;
     }
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (!(i6 & 1)) {
      i14 = 37;
      break;
     }
     i6 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i6);
    }
    if (i2 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i6 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i6);
     }
    }
    if ((i3 | 0) == -1) {
     __THREW__ = 0;
     invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     }
    }
    i6 = i9 + 28 | 0;
    __THREW__ = 0;
    invoke_iiii(fb + 513 | 0, i6 | 0, i12 | 0, i12 + (i3 << 2) | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    do if (i5 & 1) i14 = 41; else {
     i5 = HEAP8[i8 + 40 >> 0] | 0;
     HEAP32[i9 + 64 >> 2] = i5 << 24 >> 24 == 127 ? 0 : i5 << 24 >> 24;
     i5 = i8 + 52 | 0;
     if (!(HEAP8[i5 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, i9 + 40 | 0, gb + 214172 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i14 = 41;
       break;
      }
     } else {
      i2 = i13;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i7 >> 2] = HEAP32[i8 + 32 >> 2];
      __THREW__ = 0;
      i2 = invoke_ii(fb + 2805 | 0, i17 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i14 = 41;
       break;
      }
      __THREW__ = 0;
      i3 = invoke_iiiii(fb + 208 | 0, i12 | 0, i7 | 0, 100, i13 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       if (!i2) break;
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
       i4 = __THREW__;
       __THREW__ = 0;
       if (!(i4 & 1)) break;
       i4 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i4);
      }
      do if (i2 | 0) {
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
       i4 = __THREW__;
       __THREW__ = 0;
       if (!(i4 & 1)) break;
       i4 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i4);
      } while (0);
      if ((i3 | 0) == -1) {
       __THREW__ = 0;
       invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
       i4 = __THREW__;
       __THREW__ = 0;
       if (i4 & 1) {
        i14 = 41;
        break;
       }
      }
      __THREW__ = 0;
      invoke_iiii(fb + 513 | 0, i9 + 40 | 0, i12 | 0, i12 + (i3 << 2) | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i14 = 41;
       break;
      }
     }
     i3 = i8 + 53 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, i9 + 52 | 0, gb + 214172 | 0) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i14 = 41;
       break;
      }
     } else {
      i4 = i13;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i7 >> 2] = HEAP32[i8 + 36 >> 2];
      __THREW__ = 0;
      i4 = invoke_ii(fb + 2805 | 0, i17 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i14 = 41;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_iiiii(fb + 208 | 0, i12 | 0, i7 | 0, 100, i13 | 0) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       if (!i4) break;
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
       i13 = __THREW__;
       __THREW__ = 0;
       if (!(i13 & 1)) break;
       i13 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i13);
      }
      do if (i4 | 0) {
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
       i13 = __THREW__;
       __THREW__ = 0;
       if (!(i13 & 1)) break;
       i13 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i13);
      } while (0);
      if ((i2 | 0) == -1) {
       __THREW__ = 0;
       invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
       i13 = __THREW__;
       __THREW__ = 0;
       if (i13 & 1) {
        i14 = 41;
        break;
       }
      }
      __THREW__ = 0;
      invoke_iiii(fb + 513 | 0, i9 + 52 | 0, i12 | 0, i12 + (i2 << 2) | 0) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (i13 & 1) {
       i14 = 41;
       break;
      }
     }
     __THREW__ = 0;
     invoke_vii(fb + 4532 | 0, i10 | 0, i6 | 0);
     i13 = __THREW__;
     __THREW__ = 0;
     if (i13 & 1) i14 = 41; else {
      i13 = HEAP16[i8 + 48 >> 1] | 0;
      __THREW__ = 0;
      invoke_viiiiii(fb + 204 | 0, i9 + 68 | 0, i10 | 0, 1, i13 & 255 | 0, (i13 & 65535) >>> 8 & 255 | 0, HEAP8[i5 >> 0] | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       i13 = HEAP16[i8 + 50 >> 1] | 0;
       __THREW__ = 0;
       invoke_viiiiii(fb + 204 | 0, i9 + 72 | 0, i6 | 0, 1, i13 & 255 | 0, (i13 & 65535) >>> 8 & 255 | 0, HEAP8[i3 >> 0] | 0);
       i13 = __THREW__;
       __THREW__ = 0;
       if (!(i13 & 1)) {
        __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
        __THREW__ = 0;
        invoke_vi(fb + 4002 | 0, i17 | 0);
        i13 = __THREW__;
        __THREW__ = 0;
        if (i13 & 1) {
         i13 = ___cxa_find_matching_catch_3(0) | 0;
         getTempRet0() | 0;
         ___clang_call_terminate(i13);
        } else {
         STACKTOP = i11;
         return;
        }
       }
      }
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
      break L34;
     }
    } while (0);
    if ((i14 | 0) == 41) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    }
   } while (0);
   i14 = 76;
   break L1;
  } while (0);
  i14 = 76;
 } while (0);
 if ((i14 | 0) == 76) if (i15) i16 = i1; else i14 = 77;
 if ((i14 | 0) == 77) {
  __THREW__ = 0;
  invoke_vi(fb + 4002 | 0, i17 | 0);
  i17 = __THREW__;
  __THREW__ = 0;
  if (i17 & 1) {
   i17 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i17);
  } else i16 = i1;
 }
 ___resumeException(i16 | 0);
}

function __ZN5physx14PxcSweepBoxBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 464 | 0;
 i16 = i4 + 448 | 0;
 i22 = i4 + 288 | 0;
 i21 = i4 + 128 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i49 = HEAP32[i8 >> 2] | 0;
 i52 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i47 = HEAP32[i49 + 40 >> 2] | 0;
 i48 = HEAP32[i49 + 44 >> 2] | 0;
 i49 = HEAP32[i49 + 48 >> 2] | 0;
 i50 = HEAP32[i52 + 40 >> 2] | 0;
 i51 = HEAP32[i52 + 44 >> 2] | 0;
 i52 = HEAP32[i52 + 48 >> 2] | 0;
 i8 = i22 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 80 >> 2] = 3;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i22 + 144 >> 2] = i47;
 HEAP32[i22 + 148 >> 2] = i48;
 HEAP32[i22 + 152 >> 2] = i49;
 HEAPF32[i22 + 156 >> 2] = Math_fround(0.0);
 f45 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = f45 <= f46 ? f45 : f46;
 f39 = f46 <= f39 ? f46 : f39;
 HEAPF32[i22 + 16 >> 2] = Math_fround(f39 * Math_fround(.150000006));
 HEAPF32[i22 + 32 >> 2] = Math_fround(f39 * Math_fround(.0500000007));
 i49 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 3;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i49 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i21 + 144 >> 2] = i50;
 HEAP32[i21 + 148 >> 2] = i51;
 HEAP32[i21 + 152 >> 2] = i52;
 HEAPF32[i21 + 156 >> 2] = Math_fround(0.0);
 f39 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = f39 <= f46 ? f39 : f46;
 f45 = f46 <= f45 ? f46 : f45;
 HEAPF32[i21 + 16 >> 2] = Math_fround(f45 * Math_fround(.150000006));
 HEAPF32[i21 + 32 >> 2] = Math_fround(f45 * Math_fround(.0500000007));
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i52 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i52 >> 2]);
 f25 = Math_fround(HEAPF32[i52 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i52 + 8 >> 2]);
 i52 = HEAP32[i12 >> 2] | 0;
 i51 = HEAP32[i12 + 4 >> 2] | 0;
 i50 = HEAP32[i12 + 8 >> 2] | 0;
 i49 = HEAP32[i12 + 12 >> 2] | 0;
 i5 = i6 + 16 | 0;
 i48 = HEAP32[i5 >> 2] | 0;
 i47 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i52;
 i6 = i19 + 4 | 0;
 HEAP32[i6 >> 2] = i51;
 i8 = i19 + 8 | 0;
 HEAP32[i8 >> 2] = i50;
 i9 = i19 + 12 | 0;
 HEAP32[i9 >> 2] = i49;
 HEAP32[i19 + 16 >> 2] = i48;
 HEAP32[i19 + 20 >> 2] = i47;
 HEAP32[i19 + 24 >> 2] = i5;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f29 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f38 = Math_fround(f25 - f24);
 f40 = Math_fround(f27 - f32);
 f41 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f31 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f23 * Math_fround(Math_fround(f28 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f23 * Math_fround(Math_fround(f38 * f42) - Math_fround(f28 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f23) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f23)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f28) + Math_fround(f23 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f33;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f36 + f36);
 f31 = Math_fround(f26 + f26);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f26 * f31);
 f37 = Math_fround(f39 * f34);
 f26 = Math_fround(f26 * f33);
 f40 = Math_fround(f39 * f33);
 f23 = Math_fround(f35 * f33);
 f39 = Math_fround(f39 * f31);
 f31 = Math_fround(f35 * f31);
 f34 = Math_fround(f35 * f34);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f33));
 f36 = Math_fround(f26 + f34);
 f35 = Math_fround(f40 - f31);
 f34 = Math_fround(f26 - f34);
 f26 = Math_fround(f33 - f37);
 f28 = Math_fround(f39 + f23);
 f31 = Math_fround(f40 + f31);
 f23 = Math_fround(f39 - f23);
 f33 = Math_fround(f33 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f33;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(HEAPF32[i9 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, f7) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i52 = HEAP32[i3 + 4 >> 2] | 0;
 i51 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i52;
 HEAP32[i13 + 8 >> 2] = i51;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i52 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i51;
 HEAP32[i14 + 8 >> 2] = i52;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN6Shader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i28, i29) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i33 + 24 | 0;
 i9 = i33 + 16 | 0;
 i14 = i33 + 8 | 0;
 i17 = i33 + 116 | 0;
 i18 = i33 + 96 | 0;
 i21 = i33 + 76 | 0;
 i22 = i33 + 56 | 0;
 i25 = i33 + 36 | 0;
 i7 = i33;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i28, i29);
 i16 = gb + 64016 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i8 = i14;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = i15;
 HEAP32[i17 >> 2] = 0;
 i8 = i17 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i15 = i17 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i14);
 i5 = i32;
 i19 = HEAP32[i5 + 4 >> 2] | 0;
 i20 = i16;
 HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i5 = i14;
 HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i5 + 4 >> 2] = i19;
 HEAP32[i18 >> 2] = 0;
 i5 = i18 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i18 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i14);
 i6 = i32;
 i23 = HEAP32[i6 + 4 >> 2] | 0;
 i24 = i20;
 HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i24 + 4 >> 2] = i23;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i6 = i14;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = i23;
 HEAP32[i21 >> 2] = 0;
 i6 = i21 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i23 = i21 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i14);
 i10 = i32;
 i26 = HEAP32[i10 + 4 >> 2] | 0;
 i27 = i24;
 HEAP32[i27 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 i27 = gb + 64016 | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i10 = i14;
 HEAP32[i10 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i10 + 4 >> 2] = i26;
 HEAP32[i22 >> 2] = 0;
 i10 = i22 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i26 = i22 + 16 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i14);
 i11 = i32;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i27;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i14;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i25 >> 2] = 0;
 i11 = i25 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i25 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i32, i14);
 i2 = i32;
 i30 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i30;
 __ZN9ShaderLab16SerializedShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i28 + 96 >> 2] | 0, i29);
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i32 >> 2] = i1;
 i30 = i29 + 16 | 0;
 i2 = HEAP32[i30 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i31 = i29 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i30 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
 i1 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  i2 = HEAP32[i30 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i30 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i32 >> 2] = i1;
 i2 = HEAP32[i30 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i30 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
 i1 = HEAP32[i18 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i30 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i30 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i32 >> 2] = i1;
 i2 = HEAP32[i30 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i30 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
 i1 = HEAP32[i21 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i30 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i30 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i32 >> 2] = i1;
 i2 = HEAP32[i30 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i30 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
 i1 = HEAP32[i22 >> 2] | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i30 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i30 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i32 >> 2] = i1;
 i2 = HEAP32[i30 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i30 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
 i1 = HEAP32[i25 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i30 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i29);
 if (HEAP32[i8 >> 2] | 0) {
  i5 = gb + 64016 | 0;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i7;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i32 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  i7 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i32) | 0;
  i6 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i6 << 2) >> 2] | 0;
  L63 : do if ((i6 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i8 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i17 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L63;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i9 >> 2] = i4;
   __Z6FormatPKcz(i32, gb + 470364 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i32 + 11 >> 0] | 0) < 0 ? HEAP32[i32 >> 2] | 0 : i32, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   i4 = i28 + 60 | 0;
   i5 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i10 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i32 >> 2] = i5;
   HEAP32[i14 >> 2] = i10;
   if ((i10 | 0) != 0 & (i5 | 0 ? (HEAP32[i11 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i28 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i28 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i28 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i28 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i11;
     i1 = i11;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, (HEAP32[i25 >> 2] | 0) + i6 | 0, i14 | 0, i1 | 0, i32 | 0) | 0;
   }
  }
  if (i7 | 0) mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64016 | 0);
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i13);
  HEAP32[i25 >> 2] = 0;
 }
 if ((HEAP32[i26 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i27);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i24);
  HEAP32[i21 >> 2] = 0;
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i20);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16);
  HEAP32[i17 >> 2] = 0;
 }
 i6 = i28 + 80 | 0;
 i7 = i28 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 2;
 HEAP32[i32 >> 2] = i3;
 i4 = HEAP32[i30 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i30 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i29);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP8[i32 >> 0] = 1;
 i1 = HEAP32[i30 >> 2] | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i29);
  STACKTOP = i33;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i30, i32, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i29);
  STACKTOP = i33;
  return;
 }
}

function __ZL16contactHullMesh2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESI_bb(i9, i1, i2, i10, i11, f6, i3, i4, i8, i5, i7) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f6 = Math_fround(f6);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 7808 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i16 + 3400 | 0;
 i20 = i16 + 3352 | 0;
 i23 = i16 + 3324 | 0;
 i22 = i16 + 28 | 0;
 i18 = i16 + 3264 | 0;
 i17 = i16 + 16 | 0;
 i15 = i16;
 i14 = i16 + 56 | 0;
 f31 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(f31 + f31);
 i42 = i10 + 4 | 0;
 f33 = Math_fround(HEAPF32[i42 >> 2]);
 f28 = Math_fround(f33 + f33);
 i43 = i10 + 8 | 0;
 f32 = Math_fround(HEAPF32[i43 >> 2]);
 f27 = Math_fround(f32 + f32);
 i44 = i10 + 12 | 0;
 f36 = Math_fround(HEAPF32[i44 >> 2]);
 f26 = Math_fround(f30 * f36);
 f24 = Math_fround(f28 * f36);
 f36 = Math_fround(f36 * f27);
 f30 = Math_fround(f31 * f30);
 f34 = Math_fround(f31 * f28);
 f31 = Math_fround(f31 * f27);
 f28 = Math_fround(f33 * f28);
 f33 = Math_fround(f33 * f27);
 f27 = Math_fround(f32 * f27);
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f28) - f27);
 HEAPF32[i21 + 4 >> 2] = Math_fround(f34 + f36);
 HEAPF32[i21 + 8 >> 2] = Math_fround(f31 - f24);
 HEAPF32[i21 + 12 >> 2] = Math_fround(f34 - f36);
 f30 = Math_fround(Math_fround(1.0) - f30);
 HEAPF32[i21 + 16 >> 2] = Math_fround(f30 - f27);
 HEAPF32[i21 + 20 >> 2] = Math_fround(f33 + f26);
 HEAPF32[i21 + 24 >> 2] = Math_fround(f31 + f24);
 HEAPF32[i21 + 28 >> 2] = Math_fround(f33 - f26);
 HEAPF32[i21 + 32 >> 2] = Math_fround(f30 - f28);
 i50 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i21 + 36 >> 2] = i50;
 i40 = i10 + 20 | 0;
 i48 = HEAP32[i40 >> 2] | 0;
 HEAP32[i21 + 40 >> 2] = i48;
 i38 = i10 + 24 | 0;
 i46 = HEAP32[i38 >> 2] | 0;
 HEAP32[i21 + 44 >> 2] = i46;
 f28 = Math_fround(HEAPF32[i11 >> 2]);
 f30 = Math_fround(f28 + f28);
 i12 = i11 + 4 | 0;
 f26 = Math_fround(HEAPF32[i12 >> 2]);
 f33 = Math_fround(f26 + f26);
 i13 = i11 + 8 | 0;
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f31 = Math_fround(f24 + f24);
 i37 = i11 + 12 | 0;
 f27 = Math_fround(HEAPF32[i37 >> 2]);
 f36 = Math_fround(f30 * f27);
 f34 = Math_fround(f33 * f27);
 f32 = Math_fround(f27 * f31);
 f30 = Math_fround(f28 * f30);
 f25 = Math_fround(f28 * f33);
 f35 = Math_fround(f28 * f31);
 f33 = Math_fround(f26 * f33);
 f29 = Math_fround(f26 * f31);
 f31 = Math_fround(f24 * f31);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f33) - f31);
 HEAPF32[i20 + 4 >> 2] = Math_fround(f25 + f32);
 HEAPF32[i20 + 8 >> 2] = Math_fround(f35 - f34);
 HEAPF32[i20 + 12 >> 2] = Math_fround(f25 - f32);
 f30 = Math_fround(Math_fround(1.0) - f30);
 HEAPF32[i20 + 16 >> 2] = Math_fround(f30 - f31);
 HEAPF32[i20 + 20 >> 2] = Math_fround(f29 + f36);
 HEAPF32[i20 + 24 >> 2] = Math_fround(f35 + f34);
 HEAPF32[i20 + 28 >> 2] = Math_fround(f29 - f36);
 HEAPF32[i20 + 32 >> 2] = Math_fround(f30 - f33);
 i49 = HEAP32[i11 + 16 >> 2] | 0;
 HEAP32[i20 + 36 >> 2] = i49;
 i41 = i11 + 20 | 0;
 i47 = HEAP32[i41 >> 2] | 0;
 HEAP32[i20 + 40 >> 2] = i47;
 i39 = i11 + 24 | 0;
 i45 = HEAP32[i39 >> 2] | 0;
 HEAP32[i20 + 44 >> 2] = i45;
 f28 = Math_fround(-f28);
 f26 = Math_fround(-f26);
 f24 = Math_fround(-f24);
 f33 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f33 - (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f30 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f30 - (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f36 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f33 * Math_fround(2.0));
 f30 = Math_fround(f30 * Math_fround(2.0));
 f36 = Math_fround(Math_fround(f36 - (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f34 = Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(f30 * f26)) + Math_fround(f36 * f24));
 f35 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f29 * f33) + Math_fround(f27 * Math_fround(Math_fround(f36 * f26) - Math_fround(f30 * f24)))));
 f31 = Math_fround(Math_fround(f34 * f26) + Math_fround(Math_fround(f29 * f30) + Math_fround(f27 * Math_fround(Math_fround(f33 * f24) - Math_fround(f36 * f28)))));
 f34 = Math_fround(Math_fround(Math_fround(f29 * f36) + Math_fround(f27 * Math_fround(Math_fround(f30 * f28) - Math_fround(f33 * f26)))) + Math_fround(f34 * f24));
 f33 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(f27 * f33);
 f36 = Math_fround(HEAPF32[i44 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f36 * f28));
 f29 = Math_fround(HEAPF32[i43 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f29 * f26));
 f32 = Math_fround(HEAPF32[i42 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f33 * f24) + Math_fround(Math_fround(f36 * f26) + Math_fround(f27 * f32))) - Math_fround(f29 * f28));
 f19 = Math_fround(Math_fround(Math_fround(f32 * f28) + Math_fround(Math_fround(f36 * f24) + Math_fround(f27 * f29))) - Math_fround(f33 * f26));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f36) - Math_fround(f33 * f28)) - Math_fround(f32 * f26)) - Math_fround(f29 * f24));
 HEAPF32[i23 >> 2] = Math_fround(f30 - Math_fround(f32 * f24));
 HEAPF32[i23 + 4 >> 2] = f25;
 HEAPF32[i23 + 8 >> 2] = f19;
 HEAPF32[i23 + 12 >> 2] = f26;
 HEAPF32[i23 + 16 >> 2] = f35;
 HEAPF32[i23 + 20 >> 2] = f31;
 HEAPF32[i23 + 24 >> 2] = f34;
 f33 = Math_fround(-f33);
 f32 = Math_fround(-f32);
 f29 = Math_fround(-f29);
 f34 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f34 = Math_fround(f34 - Math_fround(HEAPF32[i10 + 16 >> 2]));
 f31 = Math_fround(HEAPF32[i41 >> 2]);
 f31 = Math_fround(f31 - Math_fround(HEAPF32[i40 >> 2]));
 f35 = Math_fround(HEAPF32[i39 >> 2]);
 f34 = Math_fround(f34 * Math_fround(2.0));
 f31 = Math_fround(f31 * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f35 - Math_fround(HEAPF32[i38 >> 2])) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f36 * f36) + Math_fround(-.5));
 f19 = Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f31 * f32)) + Math_fround(f35 * f29));
 f25 = Math_fround(Math_fround(f19 * f33) + Math_fround(Math_fround(f26 * f34) + Math_fround(f36 * Math_fround(Math_fround(f35 * f32) - Math_fround(f31 * f29)))));
 f24 = Math_fround(Math_fround(f19 * f32) + Math_fround(Math_fround(f26 * f31) + Math_fround(f36 * Math_fround(Math_fround(f34 * f29) - Math_fround(f35 * f33)))));
 f19 = Math_fround(Math_fround(Math_fround(f26 * f35) + Math_fround(f36 * Math_fround(Math_fround(f31 * f33) - Math_fround(f34 * f32)))) + Math_fround(f19 * f29));
 f34 = Math_fround(HEAPF32[i11 >> 2]);
 f31 = Math_fround(f36 * f34);
 f35 = Math_fround(HEAPF32[i37 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f35 * f33));
 f26 = Math_fround(HEAPF32[i13 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f26 * f32));
 f30 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(Math_fround(Math_fround(f34 * f29) + Math_fround(Math_fround(f35 * f32) + Math_fround(f36 * f30))) - Math_fround(f26 * f33));
 f27 = Math_fround(Math_fround(Math_fround(f30 * f33) + Math_fround(Math_fround(f35 * f29) + Math_fround(f36 * f26))) - Math_fround(f34 * f32));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33)) - Math_fround(f30 * f32)) - Math_fround(f26 * f29));
 HEAPF32[i22 >> 2] = Math_fround(f31 - Math_fround(f30 * f29));
 HEAPF32[i22 + 4 >> 2] = f28;
 HEAPF32[i22 + 8 >> 2] = f27;
 HEAPF32[i22 + 12 >> 2] = f26;
 HEAPF32[i22 + 16 >> 2] = f25;
 HEAPF32[i22 + 20 >> 2] = f24;
 HEAPF32[i22 + 24 >> 2] = f19;
 __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb(i18, i1, f6, i10, i21, i20, i8, i7);
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i17 + 4 >> 2] = i1 + 32;
 HEAP32[i17 + 8 >> 2] = HEAP32[i1 + 20 >> 2];
 __ZN5physx2Gu9ContainerC2Ev(i15);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i15, 1088, i16 + 3448 | 0, 1);
 i2 = HEAP32[i1 + 152 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i3 + 4100 >> 2]);
 HEAP32[i14 + 4 >> 2] = 2;
 HEAP32[i14 >> 2] = gb + 84156 + 8;
 i12 = i14 + 856 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 860 | 0;
 __ZN5physx2Gu29ConvexVsMeshContactGenerationC2ERNS0_9ContainerERKNS_11PxTransformES6_RKNS0_13PolygonalDataERKNS_2Cm8Matrix34ESD_RKNSA_23FastVertex2ShapeScalingEfbfS6_S6_RNS0_13ContactBufferE(i13, i15, i23, i22, i9, i21, i20, i4, f6, i5, f19, i10, i11, i3);
 HEAP32[i14 + 3084 >> 2] = i8;
 HEAP32[i14 + 3088 >> 2] = i2;
 HEAP8[i14 + 3092 >> 0] = i7 & 1;
 HEAP32[i14 + 3096 >> 2] = i1;
 __ZN5physx2Gu15OBBTriangleTestC2ERKNS0_3BoxE(i14 + 3100 | 0, i18);
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i18, 0, i17, i14, 1);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv(i13);
  i50 = i14 + 3080 | 0;
  i50 = HEAP8[i50 >> 0] | 0;
  i50 = i50 << 24 >> 24 != 0;
  __ZN5physx2Gu9ContainerD2Ev(i15);
  STACKTOP = i16;
  return i50 | 0;
 }
 i2 = i14 + 840 | 0;
 i3 = i14 + 776 | 0;
 i4 = i14 + 584 | 0;
 i5 = i14 + 8 | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i13, i5, HEAP32[i3 >> 2] | 0, HEAP8[i2 >> 0] | 0, i4) | 0;
  if (!i1) break; else {
   i2 = i2 + 1 | 0;
   i3 = i3 + 4 | 0;
   i4 = i4 + 12 | 0;
   i5 = i5 + 36 | 0;
  }
 }
 HEAP32[i12 >> 2] = 0;
 __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv(i13);
 i50 = i14 + 3080 | 0;
 i50 = HEAP8[i50 >> 0] | 0;
 i50 = i50 << 24 >> 24 != 0;
 __ZN5physx2Gu9ContainerD2Ev(i15);
 STACKTOP = i16;
 return i50 | 0;
}

function __ZNSt3__217moneypunct_bynameIwLb0EE4initEPKc(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10 + 32 | 0;
 i12 = i10;
 i6 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i16 = _newlocale(2147483647, i1, 0) | 0;
 i14 = (i16 | 0) == 0;
 L1 : do if (i14) {
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i13 = _strlen(i1) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i12 | 0, i1 | 0, i13 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i12 | 0, 0, gb + 1081806 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i11 | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   if (!i2) {
    i13 = 76;
    break;
   }
  }
  ___cxa_free_exception(i3 | 0);
  i13 = 76;
 } else {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2805 | 0, i16 | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  do if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i7 = invoke_i(fb + 318 | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (!i2) break;
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) break;
    i5 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i5);
   }
   if (i2 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i5 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i5);
    }
   }
   i5 = HEAP8[HEAP32[i7 + 20 >> 2] >> 0] | 0;
   HEAP32[i8 + 8 >> 2] = i5 << 24 >> 24 == 0 ? 2147483647 : i5 << 24 >> 24;
   i5 = HEAP8[HEAP32[i7 + 24 >> 2] >> 0] | 0;
   HEAP32[i8 + 12 >> 2] = i5 << 24 >> 24 == 0 ? 2147483647 : i5 << 24 >> 24;
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, i8 + 16 | 0, HEAP32[i7 + 28 >> 2] | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i13 = 77;
    break L1;
   }
   i2 = i12;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = HEAP32[i7 + 16 >> 2];
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2805 | 0, i16 | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   L34 : do if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i13 = 37;
   } else {
    __THREW__ = 0;
    i3 = invoke_iiiii(fb + 208 | 0, i11 | 0, i6 | 0, 100, i12 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     if (!i2) {
      i13 = 37;
      break;
     }
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (!(i5 & 1)) {
      i13 = 37;
      break;
     }
     i5 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i5);
    }
    if (i2 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i5 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i5);
     }
    }
    if ((i3 | 0) == -1) {
     __THREW__ = 0;
     invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     }
    }
    i5 = i8 + 28 | 0;
    __THREW__ = 0;
    invoke_iiii(fb + 513 | 0, i5 | 0, i11 | 0, i11 + (i3 << 2) | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    do if (i4 & 1) i13 = 41; else {
     i4 = HEAP8[i7 + 41 >> 0] | 0;
     HEAP32[i8 + 64 >> 2] = i4 << 24 >> 24 == 127 ? 0 : i4 << 24 >> 24;
     i4 = i7 + 46 | 0;
     if (!(HEAP8[i4 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, i8 + 40 | 0, gb + 214172 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i13 = 41;
       break;
      }
     } else {
      i2 = i12;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i6 >> 2] = HEAP32[i7 + 32 >> 2];
      __THREW__ = 0;
      i2 = invoke_ii(fb + 2805 | 0, i16 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i13 = 41;
       break;
      }
      __THREW__ = 0;
      i3 = invoke_iiiii(fb + 208 | 0, i11 | 0, i6 | 0, 100, i12 | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       if (!i2) break;
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
       i17 = __THREW__;
       __THREW__ = 0;
       if (!(i17 & 1)) break;
       i17 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i17);
      }
      do if (i2 | 0) {
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
       i17 = __THREW__;
       __THREW__ = 0;
       if (!(i17 & 1)) break;
       i17 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i17);
      } while (0);
      if ((i3 | 0) == -1) {
       __THREW__ = 0;
       invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
       i17 = __THREW__;
       __THREW__ = 0;
       if (i17 & 1) {
        i13 = 41;
        break;
       }
      }
      __THREW__ = 0;
      invoke_iiii(fb + 513 | 0, i8 + 40 | 0, i11 | 0, i11 + (i3 << 2) | 0) | 0;
      i17 = __THREW__;
      __THREW__ = 0;
      if (i17 & 1) {
       i13 = 41;
       break;
      }
     }
     if (!(HEAP8[i7 + 47 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, i8 + 52 | 0, gb + 214172 | 0) | 0;
      i17 = __THREW__;
      __THREW__ = 0;
      if (i17 & 1) {
       i13 = 41;
       break;
      }
     } else {
      i3 = i12;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i6 >> 2] = HEAP32[i7 + 36 >> 2];
      __THREW__ = 0;
      i3 = invoke_ii(fb + 2805 | 0, i16 | 0) | 0;
      i17 = __THREW__;
      __THREW__ = 0;
      if (i17 & 1) {
       i13 = 41;
       break;
      }
      __THREW__ = 0;
      i2 = invoke_iiiii(fb + 208 | 0, i11 | 0, i6 | 0, 100, i12 | 0) | 0;
      i17 = __THREW__;
      __THREW__ = 0;
      if (i17 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
       if (!i3) break;
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
       i17 = __THREW__;
       __THREW__ = 0;
       if (!(i17 & 1)) break;
       i17 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i17);
      }
      do if (i3 | 0) {
       __THREW__ = 0;
       invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
       i17 = __THREW__;
       __THREW__ = 0;
       if (!(i17 & 1)) break;
       i17 = ___cxa_find_matching_catch_3(0) | 0;
       getTempRet0() | 0;
       ___clang_call_terminate(i17);
      } while (0);
      if ((i2 | 0) == -1) {
       __THREW__ = 0;
       invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
       i17 = __THREW__;
       __THREW__ = 0;
       if (i17 & 1) {
        i13 = 41;
        break;
       }
      }
      __THREW__ = 0;
      invoke_iiii(fb + 513 | 0, i8 + 52 | 0, i11 | 0, i11 + (i2 << 2) | 0) | 0;
      i17 = __THREW__;
      __THREW__ = 0;
      if (i17 & 1) {
       i13 = 41;
       break;
      }
     }
     __THREW__ = 0;
     invoke_vii(fb + 4532 | 0, i9 | 0, i5 | 0);
     i17 = __THREW__;
     __THREW__ = 0;
     if (i17 & 1) i13 = 41; else {
      i17 = HEAP16[i7 + 42 >> 1] | 0;
      __THREW__ = 0;
      invoke_viiiiii(fb + 204 | 0, i8 + 68 | 0, i9 | 0, 0, i17 & 255 | 0, (i17 & 65535) >>> 8 & 255 | 0, HEAP8[i4 >> 0] | 0);
      i17 = __THREW__;
      __THREW__ = 0;
      if (!(i17 & 1)) {
       i17 = HEAP32[i7 + 44 >> 2] | 0;
       __THREW__ = 0;
       invoke_viiiiii(fb + 204 | 0, i8 + 72 | 0, i5 | 0, 0, i17 & 255 | 0, (i17 & 65535) >>> 8 & 255 | 0, i17 >>> 24 & 255 | 0);
       i17 = __THREW__;
       __THREW__ = 0;
       if (!(i17 & 1)) {
        __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
        __THREW__ = 0;
        invoke_vi(fb + 4002 | 0, i16 | 0);
        i17 = __THREW__;
        __THREW__ = 0;
        if (i17 & 1) {
         i17 = ___cxa_find_matching_catch_3(0) | 0;
         getTempRet0() | 0;
         ___clang_call_terminate(i17);
        } else {
         STACKTOP = i10;
         return;
        }
       }
      }
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
      break L34;
     }
    } while (0);
    if ((i13 | 0) == 41) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    }
   } while (0);
   i13 = 76;
   break L1;
  } while (0);
  i13 = 76;
 } while (0);
 if ((i13 | 0) == 76) if (i14) i15 = i1; else i13 = 77;
 if ((i13 | 0) == 77) {
  __THREW__ = 0;
  invoke_vi(fb + 4002 | 0, i16 | 0);
  i17 = __THREW__;
  __THREW__ = 0;
  if (i17 & 1) {
   i17 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i17);
  } else i15 = i1;
 }
 ___resumeException(i15 | 0);
}

function __ZNK5physx20PxsSolverCoreGeneral20solveVCoulomb_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj(i2, f3, i13, i33, i15, i4, i1, i14, i18, i17, i27, i5, i29, i12, i26, i28, i16, i31, i32, i30) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i13 = i13 | 0;
 i33 = i33 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i27 = i27 | 0;
 i5 = i5 | 0;
 i29 = i29 | 0;
 i12 = i12 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i16 = i16 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i30 = i30 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i34 + 4 | 0;
 i25 = i34;
 HEAP32[i24 + 16 >> 2] = i4;
 HEAP32[i24 + 4 >> 2] = i31;
 HEAP32[i24 + 12 >> 2] = i32 + 4;
 i23 = i24 + 8 | 0;
 HEAP32[i23 >> 2] = 0;
 i19 = i24 + 1 | 0;
 HEAP8[i19 >> 0] = 0;
 if (!i5) {
  if (i14 | 0) {
   i1 = 0;
   do {
    HEAP32[i16 + (i1 << 5) >> 2] = HEAP32[i15 + (i1 << 5) >> 2];
    HEAP32[i16 + (i1 << 5) + 4 >> 2] = HEAP32[i15 + (i1 << 5) + 4 >> 2];
    HEAP32[i16 + (i1 << 5) + 8 >> 2] = HEAP32[i15 + (i1 << 5) + 8 >> 2];
    HEAP32[i16 + (i1 << 5) + 16 >> 2] = HEAP32[i15 + (i1 << 5) + 16 >> 2];
    HEAP32[i16 + (i1 << 5) + 20 >> 2] = HEAP32[i15 + (i1 << 5) + 20 >> 2];
    HEAP32[i16 + (i1 << 5) + 24 >> 2] = HEAP32[i15 + (i1 << 5) + 24 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
  if (!i17) {
   STACKTOP = i34;
   return;
  } else i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i18 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i17 | 0));
  STACKTOP = i34;
  return;
 }
 i21 = HEAP32[i26 + 4 >> 2] | 0;
 i22 = HEAP32[i28 + 4 >> 2] | 0;
 if ((i13 | 0) > 0) {
  i7 = (i21 | 0) > 0;
  i11 = i13;
  while (1) {
   i9 = (i11 | 0) == 1 ? gb + 103400 | 0 : gb + 103460 | 0;
   i8 = HEAP32[i26 >> 2] | 0;
   if (i7) {
    i10 = 0;
    do {
     i6 = HEAP16[i8 + (i10 << 3) + 4 >> 1] | 0;
     i5 = HEAP32[i8 + (i10 << 3) >> 2] | 0;
     i4 = HEAP32[i27 + (i5 << 5) + 16 >> 2] | 0;
     i2 = i4;
     i35 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
     i20 = getTempRet0() | 0;
     i2 = _i64Add(i2 | 0, 0, 383, 0) | 0;
     i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
     i1 = getTempRet0() | 0;
     i20 = _i64Subtract(1, 0, i35 | 0, i20 | 0) | 0;
     i1 = _i64Add(i20 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
     i2 = getTempRet0() | 0;
     while (1) {
      i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i4 = i4 + 64 | 0;
     }
     i4 = i6 & 65535;
     i2 = i27 + (i5 << 5) | 0;
     if (i6 << 16 >> 16) {
      i1 = 0;
      do i1 = i1 + 1 | 0; while ((i1 | 0) != (i4 | 0));
     }
     mftCall_viii(HEAP32[i9 + ((HEAPU16[i8 + (i10 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i2 | 0, i4 | 0, i24 | 0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i21 | 0));
   }
   if ((i11 | 0) > 1) i11 = i11 + -1 | 0; else break;
  }
 }
 i20 = (i12 | 0) == 0;
 if (!i20) {
  i1 = i13 << 1;
  if ((i1 | 0) > 0) {
   i11 = (i22 | 0) > 0;
   while (1) {
    i9 = (i1 | 0) == 1 ? gb + 103400 | 0 : gb + 103460 | 0;
    i8 = HEAP32[i28 >> 2] | 0;
    if (i11) {
     i10 = 0;
     do {
      i7 = HEAP16[i8 + (i10 << 3) + 4 >> 1] | 0;
      i6 = HEAP32[i8 + (i10 << 3) >> 2] | 0;
      i5 = HEAP32[i29 + (i6 << 5) + 16 >> 2] | 0;
      i4 = i5;
      i13 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
      i35 = getTempRet0() | 0;
      i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
      i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
      i2 = getTempRet0() | 0;
      i35 = _i64Subtract(1, 0, i13 | 0, i35 | 0) | 0;
      i2 = _i64Add(i35 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
      i4 = getTempRet0() | 0;
      while (1) {
       i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
       i4 = getTempRet0() | 0;
       if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
      }
      i5 = i7 & 65535;
      i4 = i29 + (i6 << 5) | 0;
      if (i7 << 16 >> 16) {
       i2 = 0;
       do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
      }
      mftCall_viii(HEAP32[i9 + ((HEAPU16[i8 + (i10 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i24 | 0);
      i10 = i10 + 1 | 0;
     } while ((i10 | 0) != (i22 | 0));
    }
    if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
   }
  }
 }
 if (i14 | 0) {
  i1 = 0;
  do {
   HEAP32[i16 + (i1 << 5) >> 2] = HEAP32[i15 + (i1 << 5) >> 2];
   HEAP32[i16 + (i1 << 5) + 4 >> 2] = HEAP32[i15 + (i1 << 5) + 4 >> 2];
   HEAP32[i16 + (i1 << 5) + 8 >> 2] = HEAP32[i15 + (i1 << 5) + 8 >> 2];
   HEAP32[i16 + (i1 << 5) + 16 >> 2] = HEAP32[i15 + (i1 << 5) + 16 >> 2];
   HEAP32[i16 + (i1 << 5) + 20 >> 2] = HEAP32[i15 + (i1 << 5) + 20 >> 2];
   HEAP32[i16 + (i1 << 5) + 24 >> 2] = HEAP32[i15 + (i1 << 5) + 24 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i14 | 0));
 }
 if (i17 | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i18 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i17 | 0));
 }
 if ((i33 | 0) > 1) {
  i10 = (i21 | 0) > 0;
  i11 = (i22 | 0) > 0;
  i1 = i33 + -1 | 0;
  i12 = 0;
  do {
   i8 = HEAP32[i26 >> 2] | 0;
   if (i10) {
    i9 = 0;
    do {
     i7 = HEAP16[i8 + (i9 << 3) + 4 >> 1] | 0;
     i6 = HEAP32[i8 + (i9 << 3) >> 2] | 0;
     i5 = HEAP32[i27 + (i6 << 5) + 16 >> 2] | 0;
     i4 = i5;
     i18 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
     i35 = getTempRet0() | 0;
     i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
     i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
     i2 = getTempRet0() | 0;
     i35 = _i64Subtract(1, 0, i18 | 0, i35 | 0) | 0;
     i2 = _i64Add(i35 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
     i4 = getTempRet0() | 0;
     while (1) {
      i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
      i4 = getTempRet0() | 0;
      if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
     }
     i5 = i7 & 65535;
     i4 = i27 + (i6 << 5) | 0;
     if (i7 << 16 >> 16) {
      i2 = 0;
      do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
     }
     mftCall_viii(HEAP32[gb + 103460 + ((HEAPU16[i8 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i24 | 0);
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i21 | 0));
   }
   if (!i20) {
    i8 = HEAP32[i28 >> 2] | 0;
    if (i11) {
     i9 = 0;
     do {
      i7 = HEAP16[i8 + (i9 << 3) + 4 >> 1] | 0;
      i6 = HEAP32[i8 + (i9 << 3) >> 2] | 0;
      i5 = HEAP32[i29 + (i6 << 5) + 16 >> 2] | 0;
      i4 = i5;
      i18 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
      i35 = getTempRet0() | 0;
      i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
      i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
      i2 = getTempRet0() | 0;
      i35 = _i64Subtract(1, 0, i18 | 0, i35 | 0) | 0;
      i2 = _i64Add(i35 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
      i4 = getTempRet0() | 0;
      while (1) {
       i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
       i4 = getTempRet0() | 0;
       if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
      }
      i5 = i7 & 65535;
      i4 = i29 + (i6 << 5) | 0;
      if (i7 << 16 >> 16) {
       i2 = 0;
       do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
      }
      mftCall_viii(HEAP32[gb + 103460 + ((HEAPU16[i8 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i24 | 0);
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i22 | 0));
    }
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i1 | 0));
 } else i1 = 0;
 HEAP32[i25 >> 2] = HEAP32[i30 >> 2];
 HEAP8[i19 >> 0] = 1;
 if ((i1 | 0) < (i33 | 0)) {
  i10 = (i21 | 0) > 0;
  i11 = (i22 | 0) > 0;
  do {
   i8 = HEAP32[i26 >> 2] | 0;
   if (i10) {
    i9 = 0;
    do {
     i7 = HEAP16[i8 + (i9 << 3) + 4 >> 1] | 0;
     i6 = HEAP32[i8 + (i9 << 3) >> 2] | 0;
     i5 = HEAP32[i27 + (i6 << 5) + 16 >> 2] | 0;
     i4 = i5;
     i19 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
     i35 = getTempRet0() | 0;
     i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
     i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
     i2 = getTempRet0() | 0;
     i35 = _i64Subtract(1, 0, i19 | 0, i35 | 0) | 0;
     i2 = _i64Add(i35 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
     i4 = getTempRet0() | 0;
     while (1) {
      i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
      i4 = getTempRet0() | 0;
      if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
     }
     i5 = i7 & 65535;
     i4 = i27 + (i6 << 5) | 0;
     if (i7 << 16 >> 16) {
      i2 = 0;
      do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
     }
     mftCall_viiiiii(HEAP32[gb + 103520 + ((HEAPU16[i8 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i24 | 0, i31 | 0, i32 | 0, i25 | 0);
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i21 | 0));
   }
   if (!i20) {
    i8 = HEAP32[i28 >> 2] | 0;
    if (i11) {
     i9 = 0;
     do {
      i7 = HEAP16[i8 + (i9 << 3) + 4 >> 1] | 0;
      i6 = HEAP32[i8 + (i9 << 3) >> 2] | 0;
      i5 = HEAP32[i29 + (i6 << 5) + 16 >> 2] | 0;
      i4 = i5;
      i19 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
      i35 = getTempRet0() | 0;
      i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
      i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
      i2 = getTempRet0() | 0;
      i35 = _i64Subtract(1, 0, i19 | 0, i35 | 0) | 0;
      i2 = _i64Add(i35 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
      i4 = getTempRet0() | 0;
      while (1) {
       i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
       i4 = getTempRet0() | 0;
       if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
      }
      i5 = i7 & 65535;
      i4 = i29 + (i6 << 5) | 0;
      if (i7 << 16 >> 16) {
       i2 = 0;
       do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
      }
      mftCall_viiiiii(HEAP32[gb + 103520 + ((HEAPU16[i8 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i24 | 0, i31 | 0, i32 | 0, i25 | 0);
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i22 | 0));
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i33 | 0));
 }
 HEAP32[i30 >> 2] = HEAP32[i23 >> 2];
 STACKTOP = i34;
 return;
}

function __Z38getBinaryMetaData_SerializationContextRN5physx14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i21 >> 2] = HEAP32[gb + 118736 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 118736 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 118736 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[gb + 118736 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[gb + 118736 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[gb + 118736 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[gb + 118736 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[gb + 118736 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = HEAP32[gb + 118768 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 118768 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 118768 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 118768 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 118768 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 118768 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 118768 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 118768 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 118800 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 118800 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 118800 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 118800 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 118800 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 118800 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 118800 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 118800 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 118832 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 118832 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 118832 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 118832 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 118832 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 118832 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 118832 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 118832 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 118864 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 118864 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 118864 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 118864 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 118864 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 118864 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 118864 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 118864 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 118896 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 118896 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 118896 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 118896 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 118896 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 118896 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 118896 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 118896 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 118928 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 118928 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 118928 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 118928 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 118928 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 118928 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 118928 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 118928 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 118960 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 118960 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 118960 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 118960 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 118960 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 118960 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 118960 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 118960 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 118992 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 118992 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 118992 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 118992 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 118992 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 118992 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 118992 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 118992 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 118928 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 118928 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 118928 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 118928 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 118928 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 118928 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 118928 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 118928 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 119024 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 119024 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 119024 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 119024 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 119024 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 119024 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 119024 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 119024 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 119056 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 119056 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 119056 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 119056 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 119056 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 119056 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 119056 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 119056 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 119088 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 119088 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 119088 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 119088 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 119088 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 119088 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 119088 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 119088 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 119120 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 119120 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 119120 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 119120 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 119120 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 119120 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 119120 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 119120 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 119024 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 119024 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 119024 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 119024 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 119024 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 119024 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 119024 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 119024 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 119152 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 119152 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 119152 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 119152 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 119152 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 119152 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 119152 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 119152 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 119184 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 119184 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 119184 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 119184 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 119184 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 119184 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 119184 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 119184 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 119120 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 119120 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 119120 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 119120 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 119120 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 119120 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 119120 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 119120 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 119024 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 119024 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 119024 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 119024 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 119024 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 119024 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 119024 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 119024 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN9WWWCached10IsDoneImplEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 56 | 0;
 i7 = i14 + 40 | 0;
 i8 = i14 + 24 | 0;
 i2 = i14 + 16 | 0;
 i3 = i14;
 i5 = i14 + 72 | 0;
 i11 = i13 + 85 | 0;
 if (HEAP8[i11 >> 0] | 0) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i10 = i13 + 88 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0)) {
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 76 >> 2] | 0, i9 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) != 0;
  do if (i9) {
   if (!i1) {
    HEAP8[i13 + 84 >> 0] = 1;
    i9 = i13 + 80 | 0;
    HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
    _printf_console(gb + 454531 | 0, i2);
    __ZN3WWW7ReleaseEv(HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = 0;
    i10 = __Znwj(224) | 0;
    i11 = HEAP32[i9 >> 2] | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i11, _strlen(i11) | 0);
    __ZN38AssetBundleLoadFromCacheAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10, i12);
    i11 = i13 + 92 | 0;
    HEAP32[i11 >> 2] = i10;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    i10 = HEAP32[i11 >> 2] | 0;
    i8 = i13 + 40 | 0;
    i7 = HEAP32[i8 + 4 >> 2] | 0;
    i6 = i10 + 192 | 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = i7;
    i6 = i13 + 48 | 0;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i10 + 200 | 0;
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = i7;
    i9 = HEAP32[i9 >> 2] | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i9, _strlen(i9) | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10 + 208 | 0, i12) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i12 + 88 >> 2] = HEAP32[i13 + 56 >> 2];
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0, HEAP32[i13 + 60 >> 2] | 0);
    __ZN38AssetBundleLoadFromCacheAsyncOperation7ExecuteEv(HEAP32[i11 >> 2] | 0);
    i13 = 0;
    STACKTOP = i14;
    return i13 | 0;
   }
   i1 = HEAP32[i10 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0) | 0;
   if (i1 | 0) {
    i2 = HEAP8[i1 + 24 + 11 >> 0] | 0;
    if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 28 >> 2] | 0; else i1 = i2 & 255;
    if (i1 | 0) {
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) {
      __ZN3WWW7ReleaseEv(i1);
      HEAP32[i10 >> 2] = 0;
     }
     i8 = i13 + 80 | 0;
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     _printf_console(gb + 454504 | 0, i3);
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = 0;
     i11 = i3 + 4 | 0;
     HEAP32[i3 >> 2] = i11;
     i8 = HEAP32[i8 >> 2] | 0;
     i7 = i13 + 40 | 0;
     i9 = HEAP32[i13 + 56 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     i12 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i8, 0, 0, i3, 0, i12, i9) | 0;
     HEAP32[i10 >> 2] = i12;
     mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i12 | 0, HEAP32[i13 + 60 >> 2] | 0);
     __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i3, HEAP32[i11 >> 2] | 0);
     i13 = 0;
     STACKTOP = i14;
     return i13 | 0;
    }
   }
   i9 = HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0) | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i8, _strlen(i8) | 0);
   mftCall_vii(i9 | 0, i13 | 0, i12 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  } else if (i1) {
   i9 = HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0) | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i8, _strlen(i8) | 0);
   mftCall_vii(i9 | 0, i13 | 0, i12 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   break;
  } else {
   i13 = 1;
   STACKTOP = i14;
   return i13 | 0;
  } while (0);
  HEAP8[i11 >> 0] = 1;
  __ZN3WWW7ReleaseEv(HEAP32[i10 >> 2] | 0);
  HEAP32[i10 >> 2] = 0;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = i13 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i6 = i1 + 84 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 | 0) {
   HEAP32[i5 >> 2] = i3;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 28; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i5);
     i2 = HEAP32[i12 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 28; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 30;
    }
   }
   if ((i9 | 0) == 28) i9 = 30;
   if ((i9 | 0) == 30) {
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    if (!i1) {
     i13 = 1;
     STACKTOP = i14;
     return i13 | 0;
    }
   }
   i10 = HEAP32[i13 + 80 >> 2] | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i10, _strlen(i10) | 0);
   i13 = __Z28TestAssetBundleCompatibilityR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERS7_(i1, i12, i13 + 20 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   if (i13) {
    i13 = 1;
    STACKTOP = i14;
    return i13 | 0;
   }
   HEAP8[i11 >> 0] = 1;
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 do if ((HEAP32[i2 >> 2] & -2 | 0) == 6) {
  i10 = HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0;
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i12, i1);
  mftCall_vii(i10 | 0, i13 | 0, i12 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  HEAP8[i11 >> 0] = 1;
 } else if (!(HEAP8[i13 + 84 >> 0] | 0)) {
  i1 = (HEAP8[(__ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0) + 52 >> 0] | 0) != 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2 | 0) {
   __ZN3WWW7ReleaseEv(i2);
   HEAP32[i10 >> 2] = 0;
  }
  i7 = i13 + 80 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  _printf_console(gb + 454504 | 0, i8);
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i11 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i11;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = i13 + 40 | 0;
  i9 = HEAP32[i13 + 56 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i12 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i7, 0, 0, i8, i1, i12, i9) | 0;
  HEAP32[i10 >> 2] = i12;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i12 | 0, HEAP32[i13 + 60 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i8, HEAP32[i11 >> 2] | 0);
  break;
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   __ZN3WWW7ReleaseEv(i1);
   HEAP32[i10 >> 2] = 0;
  }
  i8 = i13 + 80 | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  _printf_console(gb + 454504 | 0, i7);
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i11 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i11;
  i8 = HEAP32[i8 >> 2] | 0;
  i6 = i13 + 40 | 0;
  i9 = HEAP32[i13 + 56 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i12 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i8, 0, 0, i7, 0, i12, i9) | 0;
  HEAP32[i10 >> 2] = i12;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i12 | 0, HEAP32[i13 + 60 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, HEAP32[i11 >> 2] | 0);
  break;
 } while (0);
 i13 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0);
 HEAP32[i4 >> 2] = 0;
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN22BaseUnityConnectClient17OnEnterStateReadyEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i11 = i16 + 24 | 0;
 i9 = i16 + 8 | 0;
 i12 = i16 + 40 | 0;
 HEAP32[i14 + 4 >> 2] = 1;
 HEAP8[i14 + 110 >> 0] = 0;
 i1 = i14 + 352 | 0;
 i15 = i14 + 16 | 0;
 i7 = HEAP8[i15 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i15 >> 2] | 0 : i15;
 i7 = i4 ? HEAP32[i14 + 20 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i14 + 360 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i14 + 356 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 356 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 __ZN20UnityConnectSettings14GetCloudUserIdEv(i9, __Z21GetManagerFromContexti(22) | 0);
 i1 = i14 + 368 | 0;
 i6 = i9 + 11 | 0;
 do if ((i1 | 0) != (i9 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
  i8 = i4 ? HEAP32[i9 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i14 + 376 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i14 + 372 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 372 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 HEAP32[i13 >> 2] = gb + 1040146;
 __Z6FormatPKcz(i9, gb + 1040806 | 0, i13);
 i3 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i3 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i10 = 37;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i10 = 39;
  }
 } else i10 = 37;
 if ((i10 | 0) == 37) {
  i8 = i3 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i10 = 39;
 }
 if ((i10 | 0) == 39) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i14 + 392 | 0;
 i6 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i8 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i14 + 400 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i14 + 396 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 396 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZN11UnityEngine15PlatformWrapper24GetRuntimePlatformStringEv(i11);
 i1 = i14 + 412 | 0;
 i6 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i8 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i14 + 420 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i14 + 416 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 416 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 }
 HEAP32[i14 + 428 >> 2] = __ZN10systeminfo18GetRuntimePlatformEv() | 0;
 i6 = i14 + 48 | 0;
 i1 = i14 + 480 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i14 + 52 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i14 + 488 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i14 + 484 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 484 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i2 = __ZN10systeminfo25GetDeviceUniqueIdentifierEv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i10 = 94;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i10 = 96;
  }
 } else i10 = 94;
 if ((i10 | 0) == 94) {
  i9 = i3 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i10 = 96;
 }
 if ((i10 | 0) == 96) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i14 + 512 | 0;
 i6 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i8 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i14 + 520 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i14 + 516 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 516 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i13);
 }
 __Z40GetPersistentDataPathApplicationSpecificv(i12);
 i1 = HEAP8[i12 + 11 >> 0] | 0;
 HEAP8[i14 + 109 >> 0] = ((i1 << 24 >> 24 < 0 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255) | 0) != 0 & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i1 = i14 + 280 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i13 = i14 + 548 | 0;
  i12 = i14 + 544 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  __ZN11UnityEngine7Connect13ConnectConfig8RegisterERNS0_13ConfigHandlerE(i13, i12);
  i12 = HEAP32[i1 >> 2] | 0;
  i13 = i14 + 292 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  __ZN19CloudServiceHandler10InitializeERK8UnityStrNS_13InitModeFlagsE(i12, i15, i13) | 0;
  i15 = HEAP32[i1 >> 2] | 0;
  __ZN19CloudServiceHandler31SetICloudServiceHandlerListenerEP28ICloudServiceHandlerListener(i15, i14);
  STACKTOP = i16;
  return;
 }
 i13 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0) | 0;
 HEAP32[i1 >> 2] = i13;
 __ZN19CloudServiceHandler6RetainEv(i13);
 i13 = i14 + 548 | 0;
 i12 = i14 + 544 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 __ZN11UnityEngine7Connect13ConnectConfig8RegisterERNS0_13ConfigHandlerE(i13, i12);
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i14 + 292 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 __ZN19CloudServiceHandler10InitializeERK8UnityStrNS_13InitModeFlagsE(i12, i15, i13) | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 __ZN19CloudServiceHandler31SetICloudServiceHandlerListenerEP28ICloudServiceHandlerListener(i15, i14);
 STACKTOP = i16;
 return;
}

function __ZN20NavMeshBuildSettings8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845836 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i6 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i8, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 4 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845848 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845860 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845872 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845883 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845894 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845910 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845932 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 32 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845946 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843667 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 103; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 103; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 103) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 845961 | 0, i5, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx14PxRigidBodyExt19linearSweepMultipleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEPNS_10PxSweepHitEPjjRSC_RiRbRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf(i70, i85, i87, f73, i82, i77, i79, i78, i68, i69, i83, i76, i75, i72, f81) {
 i70 = i70 | 0;
 i85 = i85 | 0;
 i87 = i87 | 0;
 f73 = Math_fround(f73);
 i82 = i82 | 0;
 i77 = i77 | 0;
 i79 = i79 | 0;
 i78 = i78 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i83 = i83 | 0;
 i76 = i76 | 0;
 i75 = i75 | 0;
 i72 = i72 | 0;
 f81 = Math_fround(f81);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i71 = 0, i74 = 0, i80 = 0, i84 = 0, i86 = 0, i88 = 0, i89 = 0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0, f102 = f0, i103 = 0, i104 = 0, i105 = 0;
 i89 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i89 + 184 | 0;
 i8 = i89 + 136 | 0;
 i86 = i89 + 132 | 0;
 i84 = i89 + 104 | 0;
 i74 = i89 + 84 | 0;
 i18 = i89;
 i71 = i89 + 16 | 0;
 i29 = i89 + 224 | 0;
 HEAP8[i83 >> 0] = 0;
 HEAP32[i69 >> 2] = -1;
 if (i78 | 0) _memset(i79 | 0, -1, i78 << 2 | 0) | 0;
 i67 = mftCall_ii(HEAP32[(HEAP32[i70 >> 2] | 0) + 104 >> 2] | 0, i70 | 0) | 0;
 if (!i67) {
  i88 = 0;
  STACKTOP = i89;
  return i88 | 0;
 }
 i9 = i8 + 16 | 0;
 i10 = i8 + 20 | 0;
 i11 = i8 + 24 | 0;
 i12 = i7 + 12 | 0;
 i13 = i7 + 4 | 0;
 i14 = i7 + 8 | 0;
 i15 = i7 + 16 | 0;
 i16 = i7 + 20 | 0;
 i17 = i7 + 24 | 0;
 i19 = i8 + 12 | 0;
 i20 = i8 + 8 | 0;
 i21 = i8 + 4 | 0;
 i22 = i84 + 4 | 0;
 i23 = i84 + 8 | 0;
 i24 = i84 + 12 | 0;
 i25 = i84 + 16 | 0;
 i26 = i84 + 20 | 0;
 i27 = i84 + 24 | 0;
 i28 = i74 + 16 | 0;
 i30 = i74 + 18 | 0;
 i31 = i76 + 16 | 0;
 i32 = i76 + 4 | 0;
 i33 = i76 + 8 | 0;
 i34 = i76 + 12 | 0;
 i35 = i8 + 4 | 0;
 i36 = i8 + 8 | 0;
 i37 = i8 + 12 | 0;
 i38 = i8 + 16 | 0;
 i39 = i8 + 40 | 0;
 i40 = i71 + 4 | 0;
 i41 = i71 + 8 | 0;
 i42 = i71 + 12 | 0;
 i43 = i71 + 16 | 0;
 i44 = i71 + 20 | 0;
 i45 = i71 + 44 | 0;
 i46 = i71 + 52 | 0;
 i47 = i71 + 56 | 0;
 i48 = i71 + 60 | 0;
 i49 = i71 + 64 | 0;
 i50 = i71 + 4 | 0;
 i51 = i68 + 12 | 0;
 i52 = i68 + 16 | 0;
 i53 = i71 + 20 | 0;
 i54 = i71 + 24 | 0;
 i55 = i68 + 20 | 0;
 i56 = i71 + 28 | 0;
 i57 = i68 + 24 | 0;
 i58 = i68 + 28 | 0;
 i59 = i71 + 32 | 0;
 i60 = i71 + 36 | 0;
 i61 = i68 + 32 | 0;
 i62 = i71 + 40 | 0;
 i63 = i68 + 36 | 0;
 i64 = i68 + 40 | 0;
 i65 = i71 + 48 | 0;
 i66 = i68 + 44 | 0;
 i80 = 0;
 i1 = 0;
 do {
  HEAP32[i86 >> 2] = 0;
  mftCall_iiiii(HEAP32[(HEAP32[i70 >> 2] | 0) + 108 >> 2] | 0, i70 | 0, i86 | 0, 1, i80 | 0) | 0;
  i6 = HEAP32[i86 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i70 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i70 | 0);
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 72 >> 2] | 0, i8 | 0, i6 | 0);
  f99 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
  f97 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
  f92 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(2.0));
  f102 = Math_fround(HEAPF32[i12 >> 2]);
  f101 = Math_fround(Math_fround(f102 * f102) + Math_fround(-.5));
  f100 = Math_fround(HEAPF32[i7 >> 2]);
  f4 = Math_fround(f99 * f100);
  f98 = Math_fround(HEAPF32[i13 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f97 * f98));
  f96 = Math_fround(HEAPF32[i14 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f92 * f96));
  f91 = Math_fround(Math_fround(f100 * f4) + Math_fround(Math_fround(f99 * f101) + Math_fround(f102 * Math_fround(Math_fround(f92 * f98) - Math_fround(f97 * f96)))));
  f90 = Math_fround(Math_fround(f98 * f4) + Math_fround(Math_fround(f97 * f101) + Math_fround(f102 * Math_fround(Math_fround(f99 * f96) - Math_fround(f92 * f100)))));
  f4 = Math_fround(Math_fround(Math_fround(f92 * f101) + Math_fround(f102 * Math_fround(Math_fround(f97 * f100) - Math_fround(f99 * f98)))) + Math_fround(f96 * f4));
  f91 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f91);
  f90 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f90);
  f4 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f4);
  f99 = Math_fround(HEAPF32[i8 >> 2]);
  f97 = Math_fround(f102 * f99);
  f101 = Math_fround(HEAPF32[i19 >> 2]);
  f97 = Math_fround(f97 + Math_fround(f100 * f101));
  f92 = Math_fround(HEAPF32[i20 >> 2]);
  f97 = Math_fround(f97 + Math_fround(f98 * f92));
  f95 = Math_fround(HEAPF32[i21 >> 2]);
  f94 = Math_fround(Math_fround(Math_fround(f96 * f99) + Math_fround(Math_fround(f98 * f101) + Math_fround(f102 * f95))) - Math_fround(f100 * f92));
  f93 = Math_fround(Math_fround(Math_fround(f100 * f95) + Math_fround(Math_fround(f96 * f101) + Math_fround(f102 * f92))) - Math_fround(f98 * f99));
  f92 = Math_fround(Math_fround(Math_fround(Math_fround(f102 * f101) - Math_fround(f100 * f99)) - Math_fround(f98 * f95)) - Math_fround(f96 * f92));
  HEAPF32[i84 >> 2] = Math_fround(f97 - Math_fround(f96 * f95));
  HEAPF32[i22 >> 2] = f94;
  HEAPF32[i23 >> 2] = f93;
  HEAPF32[i24 >> 2] = f92;
  HEAPF32[i25 >> 2] = f91;
  HEAPF32[i26 >> 2] = f90;
  HEAPF32[i27 >> 2] = f4;
  HEAP32[i74 >> 2] = 0;
  HEAP32[i74 + 4 >> 2] = 0;
  HEAP32[i74 + 8 >> 2] = 0;
  HEAP32[i74 + 12 >> 2] = 0;
  HEAP8[i30 >> 0] = 0;
  HEAP16[i28 >> 1] = HEAP16[i31 >> 1] | 0;
  if (!(HEAP32[i32 >> 2] | HEAP32[i76 >> 2] | HEAP32[i33 >> 2] | HEAP32[i34 >> 2])) {
   i6 = HEAP32[i86 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 92 >> 2] | 0, i18 | 0, i6 | 0);
  } else {
   HEAP32[i18 >> 2] = HEAP32[i76 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
  };
  HEAP32[i74 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i74 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i74 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i74 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  i5 = HEAP32[i86 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, i5 | 0);
  i5 = i78 - i1 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i36 >> 2] = -1;
  HEAP16[i37 >> 1] = 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  HEAP32[i38 + 12 >> 2] = 0;
  HEAP32[i38 + 16 >> 2] = 0;
  HEAP32[i38 + 20 >> 2] = 0;
  HEAPF32[i39 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i6 = (i1 | 0) == (i78 | 0);
  HEAP32[i40 >> 2] = 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i42 >> 2] = -1;
  HEAP16[i43 >> 1] = 0;
  HEAP32[i44 >> 2] = 0;
  HEAP32[i44 + 4 >> 2] = 0;
  HEAP32[i44 + 8 >> 2] = 0;
  HEAP32[i44 + 12 >> 2] = 0;
  HEAP32[i44 + 16 >> 2] = 0;
  HEAP32[i44 + 20 >> 2] = 0;
  HEAPF32[i45 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP8[i46 >> 0] = 0;
  HEAP32[i47 >> 2] = i6 ? i8 : i77 + (i1 * 48 | 0) | 0;
  HEAP32[i48 >> 2] = i6 ? 1 : i5;
  HEAP32[i49 >> 2] = 0;
  HEAP32[i71 >> 2] = gb + 93084 + 8;
  i2 = HEAP32[(HEAP32[i85 >> 2] | 0) + 352 >> 2] | 0;
  HEAP16[i29 >> 1] = HEAP16[i82 >> 1] | 0;
  mftCall_iiiiifiiiiif(i2 | 0, i85 | 0, i7 | 0, i84 | 0, i87 | 0, +f73, i71 | 0, i29 | 0, i74 | 0, i75 | 0, i72 | 0, +f81) | 0;
  i2 = HEAP32[i49 >> 2] | 0;
  HEAP8[i83 >> 0] = HEAPU8[i83 >> 0] | i2 >>> 0 >= i5 >>> 0;
  i2 = i6 ? 0 : i2;
  if (i2 | 0) {
   i5 = 0;
   do {
    i3 = i5 + i1 | 0;
    if (i3 >>> 0 < i78 >>> 0) HEAP32[i79 + (i3 << 2) >> 2] = i80;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i2 | 0));
  }
  L20 : do if (HEAP8[i46 >> 0] | 0) {
   if ((HEAP32[i69 >> 2] | 0) == -1) {
    i88 = HEAP32[i45 >> 2] | 0;
    i3 = i88;
    f4 = (HEAP32[tempDoublePtr >> 2] = i88, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i88 = 16;
   } else {
    f4 = Math_fround(HEAPF32[i45 >> 2]);
    i6 = f4 < Math_fround(HEAPF32[i64 >> 2]);
    if (i6) {
     i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
     i88 = 16;
    }
   }
   if ((i88 | 0) == 16) {
    i88 = 0;
    HEAP32[i69 >> 2] = i80;
    HEAP32[i68 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i68 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
    HEAP32[i68 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
    HEAP16[i51 >> 1] = HEAP16[i43 >> 1] | 0;
    HEAP32[i52 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i55 >> 2] = HEAP32[i54 >> 2];
    HEAP32[i57 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i58 >> 2] = HEAP32[i59 >> 2];
    HEAP32[i61 >> 2] = HEAP32[i60 >> 2];
    HEAP32[i63 >> 2] = HEAP32[i62 >> 2];
    HEAP32[i64 >> 2] = i3;
    HEAP32[i66 >> 2] = HEAP32[i65 >> 2];
   }
   i6 = i1 + -1 | 0;
   i3 = i1;
   while (1) {
    while (1) {
     i5 = i3 + -1 | 0;
     if ((i3 | 0) <= 0) break L20;
     i3 = i77 + (i5 * 48 | 0) + 40 | 0;
     if (f4 < Math_fround(HEAPF32[i3 >> 2])) break; else i3 = i5;
    }
    i104 = i77 + (i5 * 48 | 0) | 0;
    i103 = i6 + i2 | 0;
    i105 = i77 + (i103 * 48 | 0) | 0;
    HEAP32[i104 >> 2] = HEAP32[i105 >> 2];
    HEAP32[i104 + 4 >> 2] = HEAP32[i105 + 4 >> 2];
    HEAP32[i104 + 8 >> 2] = HEAP32[i105 + 8 >> 2];
    HEAP16[i77 + (i5 * 48 | 0) + 12 >> 1] = HEAP16[i77 + (i103 * 48 | 0) + 12 >> 1] | 0;
    HEAP32[i77 + (i5 * 48 | 0) + 16 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 16 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 20 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 20 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 24 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 24 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 28 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 28 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 32 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 32 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 36 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 36 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 40 >> 2];
    HEAP32[i77 + (i5 * 48 | 0) + 44 >> 2] = HEAP32[i77 + (i103 * 48 | 0) + 44 >> 2];
    HEAP32[i79 + (i5 << 2) >> 2] = HEAP32[i79 + (i103 << 2) >> 2];
    i3 = i5;
    i2 = i2 + -1 | 0;
   }
  } while (0);
  i1 = i2 + i1 | 0;
  i80 = i80 + 1 | 0;
 } while ((i80 | 0) != (i67 | 0));
 STACKTOP = i89;
 return i1 | 0;
}

function __ZN5physx18NpArticulationLink14visualizeJointERNS_22PxConstraintVisualizerE(i5, i18) {
 i5 = i5 | 0;
 i18 = i18 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 184 | 0;
 i6 = i24 + 156 | 0;
 i7 = i24 + 128 | 0;
 i16 = i24 + 100 | 0;
 i8 = i24 + 72 | 0;
 i9 = i24 + 44 | 0;
 i20 = i24 + 16 | 0;
 i19 = i24 + 12 | 0;
 i21 = i24 + 8 | 0;
 i22 = i24 + 4 | 0;
 i23 = i24;
 i10 = HEAP32[i5 + 296 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i6 | 0, i5 | 0);
 i17 = i5 + 292 | 0;
 i28 = HEAP32[i17 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, i28 | 0);
 f2 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
 f1 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f14 = Math_fround(Math_fround(f1 * f1) + Math_fround(-.5));
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f33 = Math_fround(f2 * f3);
 f25 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f15 * f25));
 f32 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f36 * f32));
 f13 = Math_fround(Math_fround(f3 * f33) + Math_fround(Math_fround(f2 * f14) + Math_fround(f1 * Math_fround(Math_fround(f36 * f25) - Math_fround(f15 * f32)))));
 f4 = Math_fround(Math_fround(f25 * f33) + Math_fround(Math_fround(f15 * f14) + Math_fround(f1 * Math_fround(Math_fround(f2 * f32) - Math_fround(f36 * f3)))));
 f33 = Math_fround(Math_fround(Math_fround(f36 * f14) + Math_fround(f1 * Math_fround(Math_fround(f15 * f3) - Math_fround(f2 * f25)))) + Math_fround(f32 * f33));
 f13 = Math_fround(Math_fround(HEAPF32[i6 + 16 >> 2]) + f13);
 f4 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) + f4);
 f33 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) + f33);
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 f15 = Math_fround(f1 * f2);
 f14 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f3 * f14));
 f36 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f25 * f36));
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f34 = Math_fround(Math_fround(Math_fround(f32 * f2) + Math_fround(Math_fround(f25 * f14) + Math_fround(f1 * f12))) - Math_fround(f3 * f36));
 f35 = Math_fround(Math_fround(Math_fround(f3 * f12) + Math_fround(Math_fround(f32 * f14) + Math_fround(f1 * f36))) - Math_fround(f25 * f2));
 f36 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f14) - Math_fround(f3 * f2)) - Math_fround(f25 * f12)) - Math_fround(f32 * f36));
 HEAPF32[i11 >> 2] = Math_fround(f15 - Math_fround(f32 * f12));
 i28 = i11 + 4 | 0;
 HEAPF32[i28 >> 2] = f34;
 i27 = i11 + 8 | 0;
 HEAPF32[i27 >> 2] = f35;
 i26 = i11 + 12 | 0;
 HEAPF32[i26 >> 2] = f36;
 HEAPF32[i11 + 16 >> 2] = f13;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i11 + 24 >> 2] = f33;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i8 | 0, i10 | 0);
 i5 = HEAP32[i17 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i5 | 0);
 f33 = Math_fround(Math_fround(HEAPF32[i9 + 16 >> 2]) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(HEAPF32[i9 + 20 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i9 + 24 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f36 * f36) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i8 >> 2]);
 f12 = Math_fround(f33 * f34);
 f32 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f4 * f32));
 f15 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f25 = Math_fround(Math_fround(f34 * f12) + Math_fround(Math_fround(f33 * f35) + Math_fround(f36 * Math_fround(Math_fround(f13 * f32) - Math_fround(f4 * f15)))));
 f2 = Math_fround(Math_fround(f32 * f12) + Math_fround(Math_fround(f4 * f35) + Math_fround(f36 * Math_fround(Math_fround(f33 * f15) - Math_fround(f13 * f34)))));
 f12 = Math_fround(Math_fround(Math_fround(f13 * f35) + Math_fround(f36 * Math_fround(Math_fround(f4 * f34) - Math_fround(f33 * f32)))) + Math_fround(f15 * f12));
 f25 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) + f25);
 f2 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) + f2);
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) + f12);
 f33 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(f36 * f33);
 f35 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f34 * f35));
 f13 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f32 * f13));
 f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f15 * f33) + Math_fround(Math_fround(f32 * f35) + Math_fround(f36 * f3))) - Math_fround(f34 * f13));
 f1 = Math_fround(Math_fround(Math_fround(f34 * f3) + Math_fround(Math_fround(f15 * f35) + Math_fround(f36 * f13))) - Math_fround(f32 * f33));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33)) - Math_fround(f32 * f3)) - Math_fround(f15 * f13));
 HEAPF32[i16 >> 2] = Math_fround(f4 - Math_fround(f15 * f3));
 i5 = i16 + 4 | 0;
 HEAPF32[i5 >> 2] = f14;
 i6 = i16 + 8 | 0;
 HEAPF32[i6 >> 2] = f1;
 i7 = i16 + 12 | 0;
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i16 + 16 >> 2] = f25;
 i31 = i16 + 20 | 0;
 HEAPF32[i31 >> 2] = f2;
 i30 = i16 + 24 | 0;
 HEAPF32[i30 >> 2] = f12;
 mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, i11 | 0, i16 | 0);
 i29 = HEAP32[i16 >> 2] | 0;
 HEAP32[i20 >> 2] = i29;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i20 + 4 >> 2] = i8;
 i9 = HEAP32[i6 >> 2] | 0;
 HEAP32[i20 + 8 >> 2] = i9;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i20 + 12 >> 2] = i10;
 HEAP32[i20 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[i30 >> 2];
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 f2 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f12 * f2);
 f13 = Math_fround(HEAPF32[i28 >> 2]);
 f1 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f25 + Math_fround(f13 * f1));
 f14 = Math_fround(HEAPF32[i27 >> 2]);
 f3 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f25 + Math_fround(f14 * f3));
 f15 = Math_fround(HEAPF32[i26 >> 2]);
 f4 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (Math_fround(f25 + Math_fround(f15 * f4)) < Math_fround(0.0)) {
  f2 = Math_fround(-f2);
  f1 = Math_fround(-f1);
  f3 = Math_fround(-f3);
  f4 = Math_fround(-f4);
  HEAPF32[i16 >> 2] = f2;
  HEAPF32[i5 >> 2] = f1;
  HEAPF32[i6 >> 2] = f3;
  HEAPF32[i7 >> 2] = f4;
 }
 f34 = Math_fround(-f12);
 f35 = Math_fround(-f13);
 f36 = Math_fround(-f14);
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f2) + Math_fround(f4 * f34)) + Math_fround(f3 * f35)) - Math_fround(f1 * f36));
 f13 = Math_fround(Math_fround(Math_fround(f2 * f36) + Math_fround(Math_fround(f4 * f35) + Math_fround(f15 * f1))) - Math_fround(f3 * f34));
 f14 = Math_fround(Math_fround(Math_fround(f1 * f34) + Math_fround(Math_fround(f4 * f36) + Math_fround(f15 * f3))) - Math_fround(f2 * f35));
 f1 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f4) - Math_fround(f2 * f34)) - Math_fround(f1 * f35)) - Math_fround(f3 * f36));
 if (f12 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(0.0)) + Math_fround(f1 * f1)))));
  f2 = Math_fround(f12 * f4);
  f3 = Math_fround(f4 * Math_fround(0.0));
  f4 = Math_fround(f1 * f4);
 } else {
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(1.0);
 }
 f15 = Math_fround(-f2);
 f36 = Math_fround(-f3);
 f35 = Math_fround(f1 * f36);
 f32 = Math_fround(f12 * f36);
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f4) + f35) + Math_fround(f14 * f15)) - f32);
 f35 = Math_fround(Math_fround(f32 + Math_fround(Math_fround(f14 * f4) + f35)) - Math_fround(f13 * f15));
 f36 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f4) - Math_fround(f12 * f15)) - Math_fround(f13 * f36)) - Math_fround(f14 * f36));
 f15 = Math_fround(f2 / Math_fround(f4 + Math_fround(1.0)));
 i31 = HEAP32[i17 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i31 >> 2] | 0) + 140 >> 2] | 0, i31 | 0, i19 | 0, i21 | 0);
 i31 = HEAP32[i17 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i31 >> 2] | 0) + 100 >> 2] | 0, i31 | 0, i22 | 0, i23 | 0);
 i31 = HEAP32[i17 >> 2] | 0;
 f32 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i31 >> 2] | 0) + 124 >> 2] | 0, i31 | 0));
 i31 = HEAP32[i17 >> 2] | 0;
 f34 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i31 >> 2] | 0) + 156 >> 2] | 0, i31 | 0));
 f14 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(HEAPF32[i21 >> 2]);
 mftCall_viiffi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0, i20 | 0, +f14, +f25, Math_fround(Math_abs(Math_fround(f15))) > Math_fround(+Math_tan(+Math_fround(f25 - f34))) | 0);
 f36 = Math_fround(f36 + Math_fround(1.0));
 f35 = Math_fround(f35 / f36);
 f36 = Math_fround(-Math_fround(f33 / f36));
 f33 = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(.25))));
 f34 = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(.25))));
 f32 = Math_fround(+Math_tan(+Math_fround(f32 * Math_fround(.25))));
 f35 = Math_fround(Math_abs(Math_fround(f35)));
 f36 = Math_fround(Math_abs(Math_fround(f36)));
 f35 = Math_fround(Math_fround(Math_fround(f32 + f35) / Math_fround(Math_fround(1.0) - Math_fround(f32 * f35))) / f33);
 f36 = Math_fround(Math_fround(Math_fround(f32 + f36) / Math_fround(Math_fround(1.0) - Math_fround(f32 * f36))) / f34);
 mftCall_viiffi(HEAP32[(HEAP32[i18 >> 2] | 0) + 20 >> 2] | 0, i18 | 0, i20 | 0, +f33, +f34, !(Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36)) <= Math_fround(1.0)) | 0);
 STACKTOP = i24;
 return;
}

function _free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 if (!i1) return;
 i3 = i1 + -8 | 0;
 i7 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
 if (i3 >>> 0 < i7 >>> 0) _abort();
 i1 = HEAP32[i1 + -4 >> 2] | 0;
 i2 = i1 & 3;
 if ((i2 | 0) == 1) _abort();
 i4 = i1 & -8;
 i13 = i3 + i4 | 0;
 do if (!(i1 & 1)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i2) return;
  i10 = i3 + (0 - i1) | 0;
  i9 = i1 + i4 | 0;
  if (i10 >>> 0 < i7 >>> 0) _abort();
  if ((i10 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   i1 = i13 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 & 3 | 0) != 3) {
    i16 = i10;
    i5 = i9;
    break;
   }
   HEAP32[gb + 1470404 + 8 >> 2] = i9;
   HEAP32[i1 >> 2] = i2 & -2;
   HEAP32[i10 + 4 >> 2] = i9 | 1;
   HEAP32[i10 + i9 >> 2] = i9;
   return;
  }
  i4 = i1 >>> 3;
  if (i1 >>> 0 < 256) {
   i2 = HEAP32[i10 + 8 >> 2] | 0;
   i3 = HEAP32[i10 + 12 >> 2] | 0;
   i1 = gb + 1470404 + 40 + (i4 << 1 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    if (i2 >>> 0 < i7 >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i10 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i4);
    i16 = i10;
    i5 = i9;
    break;
   }
   if ((i3 | 0) == (i1 | 0)) i6 = i3 + 8 | 0; else {
    if (i3 >>> 0 < i7 >>> 0) _abort();
    i1 = i3 + 8 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) i6 = i1; else _abort();
   }
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i6 >> 2] = i2;
   i16 = i10;
   i5 = i9;
   break;
  }
  i6 = HEAP32[i10 + 24 >> 2] | 0;
  i3 = HEAP32[i10 + 12 >> 2] | 0;
  do if ((i3 | 0) == (i10 | 0)) {
   i3 = i10 + 16 | 0;
   i2 = i3 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i8 = 0;
     break;
    } else i2 = i3;
   }
   while (1) {
    i3 = i1 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i1 = i4;
     i2 = i3;
     continue;
    }
    i3 = i1 + 16 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) break; else {
     i1 = i4;
     i2 = i3;
    }
   }
   if (i2 >>> 0 < i7 >>> 0) _abort(); else {
    HEAP32[i2 >> 2] = 0;
    i8 = i1;
    break;
   }
  } else {
   i4 = HEAP32[i10 + 8 >> 2] | 0;
   if (i4 >>> 0 < i7 >>> 0) _abort();
   i1 = i4 + 12 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i10 | 0)) _abort();
   i2 = i3 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i10 | 0)) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i2 >> 2] = i4;
    i8 = i3;
    break;
   } else _abort();
  } while (0);
  if (!i6) {
   i16 = i10;
   i5 = i9;
  } else {
   i1 = HEAP32[i10 + 28 >> 2] | 0;
   i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
   if ((i10 | 0) == (HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = i8;
    if (!i8) {
     HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i1);
     i16 = i10;
     i5 = i9;
     break;
    }
   } else {
    if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i1 = i6 + 16 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) HEAP32[i1 >> 2] = i8; else HEAP32[i6 + 20 >> 2] = i8;
    if (!i8) {
     i16 = i10;
     i5 = i9;
     break;
    }
   }
   i3 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if (i8 >>> 0 < i3 >>> 0) _abort();
   HEAP32[i8 + 24 >> 2] = i6;
   i1 = i10 + 16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2 | 0) if (i2 >>> 0 < i3 >>> 0) _abort(); else {
    HEAP32[i8 + 16 >> 2] = i2;
    HEAP32[i2 + 24 >> 2] = i8;
    break;
   } while (0);
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i16 = i10;
    i5 = i9;
   } else if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
    HEAP32[i8 + 20 >> 2] = i1;
    HEAP32[i1 + 24 >> 2] = i8;
    i16 = i10;
    i5 = i9;
    break;
   }
  }
 } else {
  i16 = i3;
  i5 = i4;
 } while (0);
 if (i16 >>> 0 >= i13 >>> 0) _abort();
 i1 = i13 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 1)) _abort();
 if (!(i2 & 2)) {
  if ((i13 | 0) == (HEAP32[gb + 1470404 + 24 >> 2] | 0)) {
   i15 = (HEAP32[gb + 1470404 + 12 >> 2] | 0) + i5 | 0;
   HEAP32[gb + 1470404 + 12 >> 2] = i15;
   HEAP32[gb + 1470404 + 24 >> 2] = i16;
   HEAP32[i16 + 4 >> 2] = i15 | 1;
   if ((i16 | 0) != (HEAP32[gb + 1470404 + 20 >> 2] | 0)) return;
   HEAP32[gb + 1470404 + 20 >> 2] = 0;
   HEAP32[gb + 1470404 + 8 >> 2] = 0;
   return;
  }
  if ((i13 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   i15 = (HEAP32[gb + 1470404 + 8 >> 2] | 0) + i5 | 0;
   HEAP32[gb + 1470404 + 8 >> 2] = i15;
   HEAP32[gb + 1470404 + 20 >> 2] = i16;
   HEAP32[i16 + 4 >> 2] = i15 | 1;
   HEAP32[i16 + i15 >> 2] = i15;
   return;
  }
  i5 = (i2 & -8) + i5 | 0;
  i4 = i2 >>> 3;
  do if (i2 >>> 0 < 256) {
   i2 = HEAP32[i13 + 8 >> 2] | 0;
   i3 = HEAP32[i13 + 12 >> 2] | 0;
   i1 = gb + 1470404 + 40 + (i4 << 1 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i13 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i4);
    break;
   }
   if ((i3 | 0) == (i1 | 0)) i11 = i3 + 8 | 0; else {
    if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i1 = i3 + 8 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i13 | 0)) i11 = i1; else _abort();
   }
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i11 >> 2] = i2;
  } else {
   i6 = HEAP32[i13 + 24 >> 2] | 0;
   i1 = HEAP32[i13 + 12 >> 2] | 0;
   do if ((i1 | 0) == (i13 | 0)) {
    i3 = i13 + 16 | 0;
    i2 = i3 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      i12 = 0;
      break;
     } else i2 = i3;
    }
    while (1) {
     i3 = i1 + 20 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (i4 | 0) {
      i1 = i4;
      i2 = i3;
      continue;
     }
     i3 = i1 + 16 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else {
      i1 = i4;
      i2 = i3;
     }
    }
    if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
     HEAP32[i2 >> 2] = 0;
     i12 = i1;
     break;
    }
   } else {
    i2 = HEAP32[i13 + 8 >> 2] | 0;
    if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i3 = i2 + 12 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i13 | 0)) _abort();
    i4 = i1 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i13 | 0)) {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i4 >> 2] = i2;
     i12 = i1;
     break;
    } else _abort();
   } while (0);
   if (i6 | 0) {
    i1 = HEAP32[i13 + 28 >> 2] | 0;
    i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
    if ((i13 | 0) == (HEAP32[i2 >> 2] | 0)) {
     HEAP32[i2 >> 2] = i12;
     if (!i12) {
      HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i1);
      break;
     }
    } else {
     if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
     i1 = i6 + 16 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i13 | 0)) HEAP32[i1 >> 2] = i12; else HEAP32[i6 + 20 >> 2] = i12;
     if (!i12) break;
    }
    i3 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
    if (i12 >>> 0 < i3 >>> 0) _abort();
    HEAP32[i12 + 24 >> 2] = i6;
    i1 = i13 + 16 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    do if (i2 | 0) if (i2 >>> 0 < i3 >>> 0) _abort(); else {
     HEAP32[i12 + 16 >> 2] = i2;
     HEAP32[i2 + 24 >> 2] = i12;
     break;
    } while (0);
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
     HEAP32[i12 + 20 >> 2] = i1;
     HEAP32[i1 + 24 >> 2] = i12;
     break;
    }
   }
  } while (0);
  HEAP32[i16 + 4 >> 2] = i5 | 1;
  HEAP32[i16 + i5 >> 2] = i5;
  if ((i16 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   HEAP32[gb + 1470404 + 8 >> 2] = i5;
   return;
  }
 } else {
  HEAP32[i1 >> 2] = i2 & -2;
  HEAP32[i16 + 4 >> 2] = i5 | 1;
  HEAP32[i16 + i5 >> 2] = i5;
 }
 i1 = i5 >>> 3;
 if (i5 >>> 0 < 256) {
  i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
  i2 = HEAP32[gb + 1470404 >> 2] | 0;
  i1 = 1 << i1;
  if (!(i2 & i1)) {
   HEAP32[gb + 1470404 >> 2] = i2 | i1;
   i14 = i3;
   i15 = i3 + 8 | 0;
  } else {
   i1 = i3 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
    i14 = i2;
    i15 = i1;
   }
  }
  HEAP32[i15 >> 2] = i16;
  HEAP32[i14 + 12 >> 2] = i16;
  HEAP32[i16 + 8 >> 2] = i14;
  HEAP32[i16 + 12 >> 2] = i3;
  return;
 }
 i1 = i5 >>> 8;
 if (!i1) i1 = 0; else if (i5 >>> 0 > 16777215) i1 = 31; else {
  i14 = (i1 + 1048320 | 0) >>> 16 & 8;
  i15 = i1 << i14;
  i13 = (i15 + 520192 | 0) >>> 16 & 4;
  i15 = i15 << i13;
  i1 = (i15 + 245760 | 0) >>> 16 & 2;
  i1 = 14 - (i13 | i14 | i1) + (i15 << i1 >>> 15) | 0;
  i1 = i5 >>> (i1 + 7 | 0) & 1 | i1 << 1;
 }
 i4 = gb + 1470404 + 304 + (i1 << 2) | 0;
 HEAP32[i16 + 28 >> 2] = i1;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i2 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
 i3 = 1 << i1;
 do if (!(i2 & i3)) {
  HEAP32[gb + 1470404 + 4 >> 2] = i2 | i3;
  HEAP32[i4 >> 2] = i16;
  HEAP32[i16 + 24 >> 2] = i4;
  HEAP32[i16 + 12 >> 2] = i16;
  HEAP32[i16 + 8 >> 2] = i16;
 } else {
  i2 = i5 << ((i1 | 0) == 31 ? 0 : 25 - (i1 >>> 1) | 0);
  i4 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + 4 >> 2] & -8 | 0) == (i5 | 0)) {
    i1 = 130;
    break;
   }
   i3 = i4 + 16 + (i2 >>> 31 << 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = 127;
    break;
   } else {
    i2 = i2 << 1;
    i4 = i1;
   }
  }
  if ((i1 | 0) == 127) if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
   HEAP32[i3 >> 2] = i16;
   HEAP32[i16 + 24 >> 2] = i4;
   HEAP32[i16 + 12 >> 2] = i16;
   HEAP32[i16 + 8 >> 2] = i16;
   break;
  } else if ((i1 | 0) == 130) {
   i1 = i4 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i15 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if (i2 >>> 0 >= i15 >>> 0 & i4 >>> 0 >= i15 >>> 0) {
    HEAP32[i2 + 12 >> 2] = i16;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i16 + 8 >> 2] = i2;
    HEAP32[i16 + 12 >> 2] = i4;
    HEAP32[i16 + 24 >> 2] = 0;
    break;
   } else _abort();
  }
 } while (0);
 i16 = (HEAP32[gb + 1470404 + 32 >> 2] | 0) + -1 | 0;
 HEAP32[gb + 1470404 + 32 >> 2] = i16;
 if (!i16) i1 = gb + 1470404 + 456 | 0; else return;
 while (1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) break; else i1 = i1 + 8 | 0;
 }
 HEAP32[gb + 1470404 + 32 >> 2] = -1;
 return;
}

function __ZN14NavMeshCarving14PrepareCarvingEv(i37) {
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i40 + 8 | 0;
 i32 = i40;
 i38 = i40 + 100 | 0;
 i39 = i40 + 80 | 0;
 i28 = i40 + 56 | 0;
 i29 = i40 + 24 | 0;
 i30 = i37 + 8 | 0;
 i31 = i37 + 20 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if (!i1) if (!(HEAP32[i37 + 60 >> 2] | 0)) {
  STACKTOP = i40;
  return;
 }
 if ((HEAP16[gb + 1459080 + 6 >> 1] | 0) > -1) {
  HEAP32[i32 >> 2] = 0;
  HEAP32[i35 >> 2] = HEAP32[i32 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459080 | 0, i35);
  i36 = gb + 1459080 | 0;
  i1 = HEAP32[i31 >> 2] | 0;
 } else i36 = 0;
 if (!i1) i25 = 9; else {
  i4 = HEAP32[i30 >> 2] | 0;
  i2 = 0;
  i3 = 0;
  do {
   i2 = ((HEAP32[i4 + (i3 * 120 | 0) + 112 >> 2] | 0) != 0 & 1) + i2 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  if (!i2) i25 = 9; else i25 = 10;
 }
 if ((i25 | 0) == 9) if (HEAP32[i37 + 60 >> 2] | 0) i25 = 10;
 if ((i25 | 0) == 10) {
  i34 = gb + 64016 | 0;
  i33 = HEAP32[i34 + 4 >> 2] | 0;
  i3 = i32;
  HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i3 + 4 >> 2] = i33;
  HEAP32[i38 >> 2] = 0;
  i3 = i38 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  i33 = i38 + 16 | 0;
  HEAP32[i33 >> 2] = 0;
  i34 = i38 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, i32);
  i26 = i35;
  i27 = HEAP32[i26 + 4 >> 2] | 0;
  i4 = i34;
  HEAP32[i4 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i4 + 4 >> 2] = i27;
  i4 = HEAP32[i31 >> 2] | 0;
  if (i4 | 0) {
   i5 = i37 + 48 | 0;
   i2 = 0;
   do {
    i6 = HEAP32[i30 >> 2] | 0;
    i1 = HEAP32[i6 + (i2 * 120 | 0) + 112 >> 2] | 0;
    if (i1 | 0) {
     i7 = i6 + (i2 * 120 | 0) + 116 | 0;
     i1 = HEAP32[i1 + 148 >> 2] | 0;
     if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) {
      HEAP32[i7 >> 2] = i1;
      __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_(i5, i6 + (i2 * 120 | 0) + 88 | 0);
      i26 = HEAP32[i30 >> 2] | 0;
      __ZNK15NavMeshObstacle12GetCarveDataER16NavMeshCarveData(HEAP32[i26 + (i2 * 120 | 0) + 112 >> 2] | 0, i26 + (i2 * 120 | 0) | 0);
      i27 = (HEAP32[i30 >> 2] | 0) + (i2 * 120 | 0) + 88 | 0;
      i26 = i26 + (i2 * 120 | 0) + 64 | 0;
      HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
      HEAP32[i27 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
      HEAP32[i27 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
      __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_(i38, (HEAP32[i30 >> 2] | 0) + (i2 * 120 | 0) + 88 | 0);
     }
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
  }
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i37 + 60 >> 2] | 0)) {
   if (HEAP32[i37 + 76 >> 2] | 0) i25 = 19;
  } else i25 = 19; else i25 = 19;
  if ((i25 | 0) == 19) {
   i27 = __Z17GetNavMeshManagerv() | 0;
   f23 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   i27 = gb + 64016 | 0;
   i26 = HEAP32[i27 + 4 >> 2] | 0;
   i24 = i32;
   HEAP32[i24 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i24 + 4 >> 2] = i26;
   HEAP32[i39 >> 2] = 0;
   i24 = i39 + 12 | 0;
   HEAP32[i24 >> 2] = 0;
   i26 = i39 + 16 | 0;
   HEAP32[i26 >> 2] = 0;
   i27 = i39 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, i32);
   i20 = i35;
   i21 = HEAP32[i20 + 4 >> 2] | 0;
   i22 = i27;
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i22 + 4 >> 2] = i21;
   __ZNK14NavMeshManager23GetSourceTileDataBoundsER13dynamic_arrayI12TileLocationLj4EE(__Z17GetNavMeshManagerv() | 0, i39);
   if (!(HEAP32[i24 >> 2] | 0)) {
    i2 = i37 + 84 | 0;
    i1 = i37 + 80 | 0;
   } else {
    i19 = i28 + 4 | 0;
    i20 = i28 + 8 | 0;
    i21 = i28 + 16 | 0;
    i22 = i28 + 20 | 0;
    f8 = Math_fround(f8 * Math_fround(1.41499996));
    i9 = i28 + 12 | 0;
    i10 = i29 + 4 | 0;
    i11 = i29 + 8 | 0;
    i12 = i29 + 12 | 0;
    i13 = i29 + 24 | 0;
    i14 = i29 + 28 | 0;
    i15 = i29 + 16 | 0;
    i16 = i37 + 72 | 0;
    i2 = i37 + 84 | 0;
    i17 = i37 + 88 | 0;
    i1 = i37 + 80 | 0;
    i18 = i29 + 12 | 0;
    i7 = 0;
    do {
     i5 = HEAP32[i39 >> 2] | 0;
     f45 = Math_fround(HEAPF32[i5 + (i7 * 36 | 0) >> 2]);
     HEAP32[i19 >> 2] = HEAP32[i5 + (i7 * 36 | 0) + 4 >> 2];
     f44 = Math_fround(HEAPF32[i5 + (i7 * 36 | 0) + 8 >> 2]);
     f43 = Math_fround(HEAPF32[i5 + (i7 * 36 | 0) + 12 >> 2]);
     f42 = Math_fround(HEAPF32[i5 + (i7 * 36 | 0) + 16 >> 2]);
     f41 = Math_fround(HEAPF32[i5 + (i7 * 36 | 0) + 20 >> 2]);
     HEAPF32[i28 >> 2] = Math_fround(f45 - f8);
     HEAPF32[i20 >> 2] = Math_fround(f44 - f8);
     HEAPF32[i9 >> 2] = Math_fround(f8 + f43);
     HEAPF32[i21 >> 2] = Math_fround(f23 + f42);
     HEAPF32[i22 >> 2] = Math_fround(f8 + f41);
     i3 = i5 + (i7 * 36 | 0) + 32 | 0;
     i6 = HEAP32[i5 + (i7 * 36 | 0) + 24 >> 2] | 0;
     i5 = HEAP32[i5 + (i7 * 36 | 0) + 28 >> 2] | 0;
     HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i10 >> 2] = i6;
     HEAP32[i11 >> 2] = i5;
     i5 = gb + 63704 | 0;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i4 = i32;
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i4 + 4 >> 2] = i6;
     HEAP32[i12 >> 2] = 0;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i35, i32);
     i4 = i35;
     i6 = HEAP32[i4 + 4 >> 2] | 0;
     i5 = i15;
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i5 + 4 >> 2] = i6;
     i5 = HEAP32[i16 >> 2] | 0;
     do if (!i5) i25 = 49; else {
      i6 = HEAP32[i3 >> 2] | 0;
      i3 = i16;
      L38 : while (1) {
       i4 = i5;
       while (1) {
        if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
        i4 = HEAP32[i4 + 4 >> 2] | 0;
        if (!i4) break L38;
       }
       i5 = HEAP32[i4 >> 2] | 0;
       if (!i5) {
        i3 = i4;
        break;
       } else i3 = i4;
      }
      if ((i3 | 0) == (i16 | 0)) i25 = 49; else if ((i6 | 0) < (HEAP32[i3 + 16 >> 2] | 0)) i25 = 49; else {
       if (HEAP32[i31 >> 2] | 0) {
        i3 = 0;
        do {
         i4 = HEAP32[i30 >> 2] | 0;
         if (HEAP32[i4 + (i3 * 120 | 0) + 112 >> 2] | 0) if (__Z17IntersectAABBAABBRK10MinMaxAABBS1_(i4 + (i3 * 120 | 0) + 88 | 0, i28) | 0) __ZN15CarveDataArrays8PushBackERK16NavMeshCarveData(i29, i4 + (i3 * 120 | 0) | 0);
         i3 = i3 + 1 | 0;
        } while (i3 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0);
       }
       if (HEAP32[i13 >> 2] | 0) {
        i3 = HEAP32[i2 >> 2] | 0;
        if ((i3 | 0) == (HEAP32[i17 >> 2] | 0)) {
         __ZNSt3__26vectorI15CarveDataArraysNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i29);
         break;
        } else {
         HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
         __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_(i3 + 12 | 0, i18);
         HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 32;
         break;
        }
       }
      }
     } while (0);
     do if ((i25 | 0) == 49) {
      i25 = 0;
      if (__ZNK14NavMeshCarving28CollectCarveDataAndOperationER15CarveDataArraysRK10MinMaxAABBRK13dynamic_arrayIS2_Lj4EE(i37, i29, i28, i38) | 0) {
       i3 = HEAP32[i2 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i17 >> 2] | 0)) {
        __ZNSt3__26vectorI15CarveDataArraysNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i29);
        break;
       } else {
        HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
        __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_(i3 + 12 | 0, i18);
        HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 32;
        break;
       }
      }
     } while (0);
     if ((HEAP32[i14 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i15);
      HEAP32[i18 >> 2] = 0;
     }
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0);
   }
   i6 = i37 + 92 | 0;
   i4 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 5;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   HEAP32[i35 + 8 >> 2] = 0;
   i1 = i37 + 104 | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i4;
   i2 = i37 + 108 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i2 >> 2] = i4;
    HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i4 * 12 | 0, 4, i37 + 96 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 12 | 0, 4, i37 + 96 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i32 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i6 >> 2] = i32;
    break;
   } while (0);
   if (i4 >>> 0 > i5 >>> 0) {
    i3 = (HEAP32[i6 >> 2] | 0) + (i5 * 12 | 0) | 0;
    i2 = i4 - i5 | 0;
    if (i2 | 0) {
     i1 = 0;
     do {
      i32 = i3 + (i1 * 12 | 0) | 0;
      HEAP32[i32 >> 2] = HEAP32[i35 >> 2];
      HEAP32[i32 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
      HEAP32[i32 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   i32 = i37 + 68 | 0;
   i35 = i37 + 72 | 0;
   __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i32, HEAP32[i35 >> 2] | 0);
   HEAP32[i37 + 76 >> 2] = 0;
   HEAP32[i32 >> 2] = i35;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i37 + 60 >> 2] = 0;
   if ((HEAP32[i26 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i39 >> 2] | 0, i27);
    HEAP32[i39 >> 2] = 0;
   }
  }
  if ((HEAP32[i33 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i34);
   HEAP32[i38 >> 2] = 0;
  }
 }
 if (!i36) {
  STACKTOP = i40;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i36);
 STACKTOP = i40;
 return;
}

function __ZN5physx12SubSortQuick5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjRNS_10PxBounds3VEj(i55, i52, i49, i53, i51, i54, i9) {
 i55 = i55 | 0;
 i52 = i52 | 0;
 i49 = i49 | 0;
 i53 = i53 | 0;
 i51 = i51 | 0;
 i54 = i54 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i56 = 0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i56 + 48 | 0;
 i48 = i56 + 16 | 0;
 i47 = i56;
 if (!i9) i1 = 1; else {
  i1 = HEAP32[i51 >> 2] | 0;
  i46 = i9 + 1 | 0;
  i1 = i1 >>> 0 < i46 >>> 0 ? i46 : i1;
 }
 HEAP32[i51 >> 2] = i1;
 i46 = i49 >>> 2;
 i46 = (i46 | 0) == 0 ? 1 : i46;
 i44 = HEAP32[i52 >> 2] | 0;
 i45 = i55 + 8 | 0;
 i8 = HEAP32[i45 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i8 + (i44 << 5) + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i8 + (i44 << 5) + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i8 + (i44 << 5) + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i8 + (i44 << 5) >> 2]);
 f3 = Math_fround(HEAPF32[i8 + (i44 << 5) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + (i44 << 5) + 8 >> 2]);
 if (i49 >>> 0 > 1) {
  i1 = 1;
  do {
   i44 = HEAP32[i52 + (i1 << 2) >> 2] | 0;
   f57 = Math_fround(HEAPF32[i8 + (i44 << 5) + 16 >> 2]);
   f58 = Math_fround(HEAPF32[i8 + (i44 << 5) + 20 >> 2]);
   f59 = Math_fround(HEAPF32[i8 + (i44 << 5) + 24 >> 2]);
   f4 = f4 > f57 ? f4 : f57;
   f5 = f5 > f58 ? f5 : f58;
   f6 = f6 > f59 ? f6 : f59;
   f59 = Math_fround(HEAPF32[i8 + (i44 << 5) >> 2]);
   f58 = Math_fround(HEAPF32[i8 + (i44 << 5) + 4 >> 2]);
   f57 = Math_fround(HEAPF32[i8 + (i44 << 5) + 8 >> 2]);
   f2 = f2 < f59 ? f2 : f59;
   f3 = f3 < f58 ? f3 : f58;
   f7 = f7 < f57 ? f7 : f57;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i49 | 0));
 }
 f57 = Math_fround(f4 - f2);
 f58 = Math_fround(f5 - f3);
 f59 = Math_fround(f6 - f7);
 HEAPF32[i50 >> 2] = f57;
 i37 = i50 + 4 | 0;
 HEAPF32[i37 >> 2] = f58;
 i38 = i50 + 8 | 0;
 HEAPF32[i38 >> 2] = f59;
 i39 = HEAP32[i55 + 12 >> 2] | 0;
 i40 = i53 + 4 | 0;
 i41 = HEAP32[i40 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i53, i41 + 4 | 0);
 i42 = (Math_imul(i46, -3) | 0) + i49 | 0;
 i42 = (i42 | 0) < 0 ? 0 : i42;
 i43 = i49 + -1 | 0;
 i44 = i55 + 24 | 0;
 i17 = i9 + 1 | 0;
 i18 = i48 + 4 | 0;
 i19 = i48 + 8 | 0;
 i20 = i48 + 16 | 0;
 i21 = i48 + 20 | 0;
 i22 = i48 + 24 | 0;
 i23 = i54 + 4 | 0;
 i24 = i54 + 8 | 0;
 i25 = i54 + 12 | 0;
 i26 = i54 + 16 | 0;
 i27 = i54 + 20 | 0;
 i28 = i54 + 24 | 0;
 i29 = i54 + 28 | 0;
 i30 = i48 + 16 | 0;
 i31 = i55 + 4 | 0;
 i32 = i52;
 i33 = i48 + 12 | 0;
 i34 = i48 + 28 | 0;
 i15 = f57 > f58 & f57 > f59 ? 0 : f58 > f59 ? 1 : 2;
 i35 = 0;
 i36 = 0;
 do {
  i16 = Math_imul(i35, i46) | 0;
  if (i35 >>> 0 < 3) if (i16 >>> 0 > i43 >>> 0) i9 = i46; else {
   i13 = i16;
   i1 = i43;
   i14 = i46;
   L12 : while (1) {
    while (1) {
     i11 = i52 + ((i1 + i13 | 0) >>> 1 << 2) | 0;
     i8 = HEAP32[i11 >> 2] | 0;
     i12 = i52 + (i1 << 2) | 0;
     i10 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i8;
     HEAP32[i11 >> 2] = i10;
     if (i13 >>> 0 < i1 >>> 0) {
      f2 = Math_fround(HEAPF32[i39 + (i8 * 12 | 0) + (i15 << 2) >> 2]);
      i11 = i13;
      i8 = i13;
      do {
       i9 = i52 + (i11 << 2) | 0;
       i10 = HEAP32[i9 >> 2] | 0;
       if (Math_fround(HEAPF32[i39 + (i10 * 12 | 0) + (i15 << 2) >> 2]) <= f2) {
        i61 = i52 + (i8 << 2) | 0;
        i60 = HEAP32[i61 >> 2] | 0;
        HEAP32[i61 >> 2] = i10;
        HEAP32[i9 >> 2] = i60;
        i8 = i8 + 1 | 0;
       }
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) != (i1 | 0));
     } else i8 = i13;
     i61 = HEAP32[i12 >> 2] | 0;
     i9 = i52 + (i8 << 2) | 0;
     HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = i61;
     i9 = i8;
     do i9 = i9 + 1 | 0; while (i9 >>> 0 <= i1 >>> 0);
     i9 = i8 - i13 + 1 | 0;
     if ((i14 | 0) == (i9 | 0)) break L12;
     if (i14 >>> 0 >= i9 >>> 0) break;
     i1 = i8 + -1 | 0;
    }
    i13 = i8 + 1 | 0;
    i14 = i14 - i9 | 0;
   }
   f59 = Math_fround(HEAPF32[gb + 110284 + (i35 << 2) >> 2]);
   i61 = i50 + (i15 << 2) | 0;
   HEAPF32[i61 >> 2] = Math_fround(f59 * Math_fround(HEAPF32[i61 >> 2]));
   f59 = Math_fround(HEAPF32[i50 >> 2]);
   f2 = Math_fround(HEAPF32[i37 >> 2]);
   f3 = Math_fround(HEAPF32[i38 >> 2]);
   if (f59 > f2 & f59 > f3) {
    i15 = 0;
    i9 = i46;
   } else {
    i15 = f2 > f3 ? 1 : 2;
    i9 = i46;
   }
  } else i9 = i42;
  i13 = i35 + i41 | 0;
  i1 = HEAP32[i53 >> 2] | 0;
  i8 = i1 + (i13 << 5) | 0;
  i36 = i9 + i36 | 0;
  do if (i9 >>> 0 > (HEAP32[i44 >> 2] | 0) >>> 0) {
   HEAP32[i1 + (i13 << 5) + 24 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i1 + (i13 << 5) + 28 >> 2] = 0;
   __ZN5physx12SubSortQuick5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjRNS_10PxBounds3VEj(i55, i52 + (i16 << 2) | 0, i9, i53, i51, i48, i17);
  } else {
   if (i36 >>> 0 > i49 >>> 0) {
    HEAP32[i47 >> 2] = 0;
    HEAP32[i47 + 4 >> 2] = 0;
    HEAP32[i47 + 8 >> 2] = 0;
    HEAP32[i47 + 12 >> 2] = 0;
    HEAP32[i20 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
    HEAP32[i48 >> 2] = HEAP32[i47 >> 2];
    HEAP32[i48 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
    HEAP32[i48 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
    HEAP32[i48 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
    HEAP32[i8 >> 2] = 2122317823;
    HEAP32[i1 + (i13 << 5) + 4 >> 2] = 2122317823;
    HEAP32[i1 + (i13 << 5) + 8 >> 2] = 2122317823;
    HEAP32[i1 + (i13 << 5) + 12 >> 2] = -25165825;
    HEAP32[i1 + (i13 << 5) + 16 >> 2] = -25165825;
    HEAP32[i1 + (i13 << 5) + 20 >> 2] = -25165825;
    HEAP32[i1 + (i13 << 5) + 28 >> 2] = -1;
    HEAP32[i1 + (i13 << 5) + 24 >> 2] = -1;
    break;
   }
   HEAP32[i1 + (i13 << 5) + 28 >> 2] = i9;
   HEAP32[i1 + (i13 << 5) + 24 >> 2] = (i32 - (HEAP32[i31 >> 2] | 0) >> 2) + i16;
   i1 = HEAP32[i45 >> 2] | 0;
   i61 = i1 + (HEAP32[i52 + (i16 << 2) >> 2] << 5) | 0;
   HEAP32[i48 >> 2] = HEAP32[i61 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i61 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i61 + 8 >> 2];
   HEAP32[i48 + 12 >> 2] = HEAP32[i61 + 12 >> 2];
   HEAP32[i48 + 16 >> 2] = HEAP32[i61 + 16 >> 2];
   HEAP32[i48 + 20 >> 2] = HEAP32[i61 + 20 >> 2];
   HEAP32[i48 + 24 >> 2] = HEAP32[i61 + 24 >> 2];
   HEAP32[i48 + 28 >> 2] = HEAP32[i61 + 28 >> 2];
   if (i9 >>> 0 > 1) {
    f7 = Math_fround(HEAPF32[i48 >> 2]);
    f6 = Math_fround(HEAPF32[i18 >> 2]);
    f5 = Math_fround(HEAPF32[i19 >> 2]);
    f4 = Math_fround(HEAPF32[i30 >> 2]);
    f3 = Math_fround(HEAPF32[i21 >> 2]);
    f2 = Math_fround(HEAPF32[i22 >> 2]);
    i8 = 1;
    do {
     i61 = HEAP32[i52 + (i8 + i16 << 2) >> 2] | 0;
     f59 = Math_fround(HEAPF32[i1 + (i61 << 5) >> 2]);
     f58 = Math_fround(HEAPF32[i1 + (i61 << 5) + 4 >> 2]);
     f57 = Math_fround(HEAPF32[i1 + (i61 << 5) + 8 >> 2]);
     f7 = f7 < f59 ? f7 : f59;
     f6 = f6 < f58 ? f6 : f58;
     f5 = f5 < f57 ? f5 : f57;
     f57 = Math_fround(HEAPF32[i1 + (i61 << 5) + 16 >> 2]);
     f58 = Math_fround(HEAPF32[i1 + (i61 << 5) + 20 >> 2]);
     f59 = Math_fround(HEAPF32[i1 + (i61 << 5) + 24 >> 2]);
     f4 = f4 > f57 ? f4 : f57;
     f3 = f3 > f58 ? f3 : f58;
     f2 = f2 > f59 ? f2 : f59;
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i9 | 0));
    HEAPF32[i48 >> 2] = f7;
    HEAPF32[i18 >> 2] = f6;
    HEAPF32[i19 >> 2] = f5;
    HEAPF32[i33 >> 2] = Math_fround(0.0);
    HEAPF32[i30 >> 2] = f4;
    HEAPF32[i21 >> 2] = f3;
    HEAPF32[i22 >> 2] = f2;
    HEAPF32[i34 >> 2] = Math_fround(0.0);
   }
  } while (0);
  if (!i35) {
   HEAP32[i54 >> 2] = HEAP32[i48 >> 2];
   HEAP32[i54 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
   HEAP32[i54 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
   HEAP32[i54 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
   HEAP32[i54 + 16 >> 2] = HEAP32[i48 + 16 >> 2];
   HEAP32[i54 + 20 >> 2] = HEAP32[i48 + 20 >> 2];
   HEAP32[i54 + 24 >> 2] = HEAP32[i48 + 24 >> 2];
   HEAP32[i54 + 28 >> 2] = HEAP32[i48 + 28 >> 2];
   i1 = HEAP32[i48 >> 2] | 0;
   i8 = HEAP32[i18 >> 2] | 0;
   i9 = HEAP32[i19 >> 2] | 0;
   i10 = HEAP32[i20 >> 2] | 0;
   i11 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i22 >> 2] | 0;
  } else {
   f4 = Math_fround(HEAPF32[i54 >> 2]);
   f3 = Math_fround(HEAPF32[i23 >> 2]);
   f2 = Math_fround(HEAPF32[i24 >> 2]);
   f5 = Math_fround(HEAPF32[i48 >> 2]);
   f6 = Math_fround(HEAPF32[i18 >> 2]);
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   HEAPF32[i54 >> 2] = f4 < f5 ? f4 : f5;
   HEAPF32[i23 >> 2] = f3 < f6 ? f3 : f6;
   HEAPF32[i24 >> 2] = f2 < f7 ? f2 : f7;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   f2 = Math_fround(HEAPF32[i26 >> 2]);
   f3 = Math_fround(HEAPF32[i27 >> 2]);
   f4 = Math_fround(HEAPF32[i28 >> 2]);
   f57 = Math_fround(HEAPF32[i30 >> 2]);
   f58 = Math_fround(HEAPF32[i21 >> 2]);
   f59 = Math_fround(HEAPF32[i22 >> 2]);
   HEAPF32[i26 >> 2] = f2 > f57 ? f2 : f57;
   HEAPF32[i27 >> 2] = f3 > f58 ? f3 : f58;
   HEAPF32[i28 >> 2] = f4 > f59 ? f4 : f59;
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i61 = HEAP32[i53 >> 2] | 0;
  HEAP32[i61 + (i13 << 5) >> 2] = i1;
  HEAP32[i61 + (i13 << 5) + 4 >> 2] = i8;
  HEAP32[i61 + (i13 << 5) + 8 >> 2] = i9;
  HEAP32[i61 + (i13 << 5) + 12 >> 2] = i10;
  HEAP32[i61 + (i13 << 5) + 16 >> 2] = i11;
  HEAP32[i61 + (i13 << 5) + 20 >> 2] = i12;
  i35 = i35 + 1 | 0;
 } while ((i35 | 0) != 4);
 STACKTOP = i56;
 return;
}

function __ZL22PrepareValueParametersI21FullParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i18, i15, i16, i17, i21, i19) {
 i18 = i18 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i21 = i21 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 if (!i15) i1 = 0; else {
  i13 = i21 + 12 | 0;
  i14 = i20 + 6 | 0;
  i10 = i21 + 16 | 0;
  i11 = i21 + 4 | 0;
  i12 = i20 + 4 | 0;
  i9 = 0;
  do {
   if (__ZNK21FullParameterPreparer14OnPrepareFloatER12PartialArrayIfERKN20GpuProgramParameters14ValueParameterEj(i19, i20, (HEAP32[i18 >> 2] | 0) + (i9 * 20 | 0) | 0, (HEAP32[i13 >> 2] | 0) + 4 | 0) | 0) {
    i2 = HEAP16[i14 >> 1] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i1 = i3 + 4 | 0;
    HEAP32[i13 >> 2] = i1;
    i4 = HEAP32[i10 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i5 >>> 0 < i1 >>> 0) {
     i8 = i4 << 1;
     i1 = i8 >>> 0 > i1 >>> 0 ? i8 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i8 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i21 >> 2] = i8;
      break;
     }
    } while (0);
    i8 = (HEAP32[i21 >> 2] | 0) + i3 | 0;
    i1 = (i2 & 65535) << 16 | i9 & 65535;
    HEAP16[i8 >> 1] = i1;
    HEAP16[i8 + 2 >> 1] = i1 >>> 16;
    i8 = HEAP32[i13 >> 2] | 0;
    i1 = ((HEAPU16[i14 >> 1] | 0) << 2) + i8 | 0;
    HEAP32[i13 >> 2] = i1;
    i2 = HEAP32[i10 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i3 >>> 0 < i1 >>> 0) {
     i7 = i2 << 1;
     i1 = i7 >>> 0 > i1 >>> 0 ? i7 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i21 >> 2] = i7;
      break;
     }
    } while (0);
    i6 = HEAP32[i12 >> 2] | 0;
    i1 = i6 & 65535;
    i5 = i6 & 65535;
    i6 = i6 >>> 16;
    i7 = i6 & 65535;
    if (!(i1 << 16 >> 16)) i1 = 0; else {
     i4 = HEAP32[i20 >> 2] | 0;
     i2 = (HEAP32[i21 >> 2] | 0) + i8 | 0;
     i3 = 0;
     while (1) {
      HEAP32[i2 >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
     }
    }
    if ((i7 & 65535) > (i1 & 65535)) _memset((HEAP32[i21 >> 2] | 0) + ((i5 << 2) + i8) | 0, 0, i6 - i5 << 2 | 0) | 0;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i15 | 0));
  i1 = i15;
 }
 i14 = i16 + i15 | 0;
 if ((i1 | 0) != (i14 | 0)) {
  i9 = i21 + 12 | 0;
  i10 = i20 + 6 | 0;
  i11 = i21 + 16 | 0;
  i12 = i21 + 4 | 0;
  i13 = i20 + 4 | 0;
  do {
   if (__ZNK21FullParameterPreparer15OnPrepareVectorER12PartialArrayI8Vector4fERKN20GpuProgramParameters14ValueParameterEj(i19, i20, (HEAP32[i18 >> 2] | 0) + (i1 * 20 | 0) | 0, (HEAP32[i9 >> 2] | 0) + 4 | 0) | 0) {
    i3 = HEAP16[i10 >> 1] | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = i4 + 4 | 0;
    HEAP32[i9 >> 2] = i2;
    i5 = HEAP32[i11 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i6 >>> 0 < i2 >>> 0) {
     i16 = i5 << 1;
     i2 = i16 >>> 0 > i2 >>> 0 ? i16 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i11 >> 2] = i2;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
      HEAP32[i11 >> 2] = i2;
      HEAP32[i21 >> 2] = i16;
      break;
     }
    } while (0);
    i8 = (HEAP32[i21 >> 2] | 0) + i4 | 0;
    i2 = (i3 & 65535) << 16 | i1 & 65535;
    HEAP16[i8 >> 1] = i2;
    HEAP16[i8 + 2 >> 1] = i2 >>> 16;
    i8 = HEAP32[i9 >> 2] | 0;
    i2 = ((HEAPU16[i10 >> 1] | 0) << 4) + i8 | 0;
    HEAP32[i9 >> 2] = i2;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i4 >>> 0 < i2 >>> 0) {
     i16 = i3 << 1;
     i2 = i16 >>> 0 > i2 >>> 0 ? i16 : i2;
     if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i11 >> 2] = i2;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
      HEAP32[i11 >> 2] = i2;
      HEAP32[i21 >> 2] = i16;
      break;
     }
    } while (0);
    i6 = HEAP32[i13 >> 2] | 0;
    i3 = i6 & 65535;
    i7 = i6 & 65535;
    if (!(i3 << 16 >> 16)) i3 = 0; else {
     i5 = HEAP32[i20 >> 2] | 0;
     i2 = (HEAP32[i21 >> 2] | 0) + i8 | 0;
     i4 = 0;
     while (1) {
      i16 = i5 + (i4 << 4) | 0;
      HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i7 | 0)) break; else i2 = i2 + 16 | 0;
     }
    }
    i2 = i6 >>> 16;
    if ((i2 & 65535) > (i3 & 65535)) _memset((HEAP32[i21 >> 2] | 0) + ((i7 << 4) + i8) | 0, 0, i2 - i7 << 4 | 0) | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i14 | 0));
  i1 = i14;
 }
 i14 = i14 + i17 | 0;
 if ((i1 | 0) == (i14 | 0)) {
  i6 = i21 + 16 | 0;
  i2 = i21 + 12 | 0;
 } else {
  i2 = i21 + 12 | 0;
  i15 = i20 + 6 | 0;
  i6 = i21 + 16 | 0;
  i16 = i21 + 4 | 0;
  i17 = i20 + 4 | 0;
  do {
   if (__ZNK21FullParameterPreparer15OnPrepareMatrixER12PartialArrayI10Matrix4x4fERKN20GpuProgramParameters14ValueParameterEj(i19, i20, (HEAP32[i18 >> 2] | 0) + (i1 * 20 | 0) | 0, (HEAP32[i2 >> 2] | 0) + 4 | 0) | 0) {
    i4 = HEAP16[i15 >> 1] | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    i3 = i5 + 4 | 0;
    HEAP32[i2 >> 2] = i3;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i8 >>> 0 < i3 >>> 0) {
     i13 = i7 << 1;
     i3 = i13 >>> 0 > i3 >>> 0 ? i13 : i3;
     if (i8 >>> 0 < i3 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i3;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i3, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i13 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i3;
      HEAP32[i21 >> 2] = i13;
      break;
     }
    } while (0);
    i13 = (HEAP32[i21 >> 2] | 0) + i5 | 0;
    i3 = (i4 & 65535) << 16 | i1 & 65535;
    HEAP16[i13 >> 1] = i3;
    HEAP16[i13 + 2 >> 1] = i3 >>> 16;
    i13 = HEAP32[i2 >> 2] | 0;
    i3 = ((HEAPU16[i15 >> 1] | 0) << 6) + i13 | 0;
    HEAP32[i2 >> 2] = i3;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i5 >>> 0 < i3 >>> 0) {
     i12 = i4 << 1;
     i3 = i12 >>> 0 > i3 >>> 0 ? i12 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i6 >> 2] = i3;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i3, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i3;
      HEAP32[i21 >> 2] = i12;
      break;
     }
    } while (0);
    i11 = HEAP32[i17 >> 2] | 0;
    i4 = i11 & 65535;
    i12 = i11 & 65535;
    if (!(i4 << 16 >> 16)) i4 = 0; else {
     i7 = HEAP32[i20 >> 2] | 0;
     i3 = (HEAP32[i21 >> 2] | 0) + i13 | 0;
     i5 = 0;
     do {
      i8 = i3;
      i3 = i3 + 64 | 0;
      i9 = i7 + (i5 << 6) | 0;
      i10 = i8 + 64 | 0;
      do {
       HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
       i8 = i8 + 4 | 0;
       i9 = i9 + 4 | 0;
      } while ((i8 | 0) < (i10 | 0));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i12 | 0));
    }
    i3 = i11 >>> 16;
    if ((i3 & 65535) > (i4 & 65535)) _memset((HEAP32[i21 >> 2] | 0) + ((i12 << 6) + i13) | 0, 0, i3 - i12 << 6 | 0) | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i14 | 0));
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i4 & 2147483647;
 if (i5 >>> 0 >= i1 >>> 0) {
  i21 = HEAP32[i21 >> 2] | 0;
  i21 = i21 + i3 | 0;
  HEAP16[i21 >> 1] = 65535;
  HEAP16[i21 + 2 >> 1] = 65535 >>> 16;
  STACKTOP = i22;
  return;
 }
 i20 = i4 << 1;
 i1 = i20 >>> 0 > i1 >>> 0 ? i20 : i1;
 if (i5 >>> 0 >= i1 >>> 0) {
  i21 = HEAP32[i21 >> 2] | 0;
  i21 = i21 + i3 | 0;
  HEAP16[i21 >> 1] = 65535;
  HEAP16[i21 + 2 >> 1] = 65535 >>> 16;
  STACKTOP = i22;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1, 4, i21 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i21 = HEAP32[i21 >> 2] | 0;
  i21 = i21 + i3 | 0;
  HEAP16[i21 >> 1] = 65535;
  HEAP16[i21 + 2 >> 1] = 65535 >>> 16;
  STACKTOP = i22;
  return;
 } else {
  i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i21 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i20 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i21 >> 2] = i20;
  i21 = HEAP32[i21 >> 2] | 0;
  i21 = i21 + i3 | 0;
  HEAP16[i21 >> 1] = 65535;
  HEAP16[i21 + 2 >> 1] = 65535 >>> 16;
  STACKTOP = i22;
  return;
 }
}

function __ZN5physx13BigConvexData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i18 >> 2] = HEAP32[gb + 136740 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 136740 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 136740 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 136740 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 136740 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 136740 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 136740 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 136740 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 136772 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 136772 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 136772 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 136772 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 136772 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 136772 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 136772 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 136772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 136804 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 136804 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 136804 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 136804 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 136804 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 136804 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 136804 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 136804 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 136836 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 136836 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 136836 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 136836 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 136836 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 136836 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 136836 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 136836 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 136868 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 136868 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 136868 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 136868 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 136868 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 136868 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 136868 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 136868 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 136900 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 136900 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 136900 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 136900 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 136900 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 136900 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 136900 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 136900 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 136932 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 136932 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 136932 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 136932 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 136932 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 136932 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 136932 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 136932 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 136964 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 136964 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 136964 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 136964 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 136964 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 136964 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 136964 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 136964 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 136996 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 136996 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 136996 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 136996 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 136996 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 136996 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 136996 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 136996 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 137028 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 137028 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 137028 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 137028 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 137028 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 137028 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 137028 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 137028 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 137060 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 137060 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 137060 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 137060 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 137060 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 137060 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 137060 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 137060 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 137092 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 137092 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 137092 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 137092 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 137092 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 137092 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 137092 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 137092 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 137124 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 137124 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 137124 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 137124 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 137124 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 137124 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 137124 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 137124 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 137156 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 137156 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 137156 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 137156 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 137156 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 137156 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 137156 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 137156 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 137188 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 137188 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 137188 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 137188 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 137188 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 137188 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 137188 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 137188 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 137220 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 137220 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 137220 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 137220 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 137220 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 137220 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 137220 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 137220 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 137252 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 137252 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 137252 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 137252 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 137252 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 137252 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 137252 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 137252 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 137284 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 137284 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 137284 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 137284 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 137284 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 137284 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 137284 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 137284 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 137316 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 137316 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 137316 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 137316 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 137316 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 137316 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 137316 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 137316 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN9ShaderLab14SerializedPass16CreateNamesTableEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i30 + 16 | 0;
 i23 = i30;
 i25 = i16 + 860 | 0;
 i26 = i16 + 864 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i25, HEAP32[i26 >> 2] | 0);
 HEAP32[i16 + 868 >> 2] = 0;
 HEAP32[i25 >> 2] = i26;
 HEAP32[i26 >> 2] = 0;
 i26 = i16 + 724 | 0;
 i27 = i23 + 12 | 0;
 i15 = i23 + 12 | 0;
 i28 = i17 + 4 | 0;
 i18 = i23 + 8 | 0;
 i19 = i23 + 4 | 0;
 i20 = i23 + 11 | 0;
 i21 = i17 + 4 | 0;
 i14 = 0;
 do {
  L3 : do if (HEAP32[i26 >> 2] & 1 << i14 | 0) {
   i22 = i16 + 728 + (i14 * 12 | 0) | 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i13 = (HEAP32[i16 + 728 + (i14 * 12 | 0) + 4 >> 2] | 0) - i2 | 0;
   i24 = (i13 | 0) / 192 | 0;
   if (i13 | 0) {
    i1 = 0;
    while (1) {
     i5 = i2 + (i1 * 192 | 0) + 108 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 112 >> 2] | 0) - i3 | 0;
     i6 = (i13 | 0) / 36 | 0;
     if (i13 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 * 36 | 0) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 * 36 | 0) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i5 = i2 + (i1 * 192 | 0) + 120 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 124 >> 2] | 0) - i3 | 0;
     i6 = (i13 | 0) / 36 | 0;
     if (i13 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 * 36 | 0) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 * 36 | 0) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i5 = i2 + (i1 * 192 | 0) + 132 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i6 = (HEAP32[i2 + (i1 * 192 | 0) + 136 >> 2] | 0) - i3 >> 5;
     if (i6 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 << 5) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 << 5) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i5 = i2 + (i1 * 192 | 0) + 144 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 148 >> 2] | 0) - i3 | 0;
     i6 = (i13 | 0) / 28 | 0;
     if (i13 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 * 28 | 0) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 * 28 | 0) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i10 = i2 + (i1 * 192 | 0) + 168 | 0;
     i6 = i2 + (i1 * 192 | 0) + 172 | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i3 = HEAP32[i10 >> 2] | 0;
     i13 = i5 - i3 | 0;
     i7 = (i13 | 0) / 48 | 0;
     i4 = i3;
     if (i13) {
      i3 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i4 + (i3 * 48 | 0) | 0) | 0;
       i4 = HEAP32[i10 >> 2] | 0;
       HEAP32[i4 + (i3 * 48 | 0) + 16 >> 2] = i13;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i7 | 0));
      i5 = HEAP32[i6 >> 2] | 0;
      i3 = i4;
     }
     i13 = i5 - i3 | 0;
     i9 = (i13 | 0) / 48 | 0;
     L34 : do if (i13 | 0) {
      i3 = 0;
      while (1) {
       i7 = i4 + (i3 * 48 | 0) + 32 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i13 = (HEAP32[i4 + (i3 * 48 | 0) + 36 >> 2] | 0) - i6 | 0;
       i8 = (i13 | 0) / 36 | 0;
       if (i13) {
        i5 = 0;
        i4 = i6;
        do {
         i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i4 + (i5 * 36 | 0) | 0) | 0;
         i4 = HEAP32[i7 >> 2] | 0;
         HEAP32[i4 + (i5 * 36 | 0) + 16 >> 2] = i13;
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i8 | 0));
        i4 = HEAP32[i10 >> 2] | 0;
       }
       i8 = i4 + (i3 * 48 | 0) + 20 | 0;
       i6 = HEAP32[i8 >> 2] | 0;
       i13 = (HEAP32[i4 + (i3 * 48 | 0) + 24 >> 2] | 0) - i6 | 0;
       i7 = (i13 | 0) / 36 | 0;
       if (i13 | 0) {
        i5 = 0;
        i4 = i6;
        do {
         i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i4 + (i5 * 36 | 0) | 0) | 0;
         i4 = HEAP32[i8 >> 2] | 0;
         HEAP32[i4 + (i5 * 36 | 0) + 16 >> 2] = i13;
         i5 = i5 + 1 | 0;
        } while ((i5 | 0) != (i7 | 0));
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i9 | 0)) break L34;
       i4 = HEAP32[i10 >> 2] | 0;
      }
     } while (0);
     i5 = i2 + (i1 * 192 | 0) + 180 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 184 >> 2] | 0) - i3 | 0;
     i6 = (i13 | 0) / 24 | 0;
     if (i13 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 * 24 | 0) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 * 24 | 0) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i5 = i2 + (i1 * 192 | 0) + 156 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = (HEAP32[i2 + (i1 * 192 | 0) + 160 >> 2] | 0) - i3 | 0;
     i6 = (i13 | 0) / 24 | 0;
     if (i13 | 0) {
      i4 = 0;
      do {
       i13 = __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i3 + (i4 * 24 | 0) | 0) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       HEAP32[i3 + (i4 * 24 | 0) + 16 >> 2] = i13;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i11 = i2 + (i1 * 192 | 0) + 56 | 0;
     i12 = i2 + (i1 * 192 | 0) + 72 | 0;
     if ((HEAP32[i12 >> 2] | 0) > -1) {
      i10 = i2 + (i1 * 192 | 0) + 60 | 0;
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
      HEAP32[i11 >> 2] = 0;
     } else i10 = i2 + (i1 * 192 | 0) + 60 | 0;
     HEAP32[i11 >> 2] = 0;
     i13 = i2 + (i1 * 192 | 0) + 68 | 0;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i12 >> 2] = 0;
     i9 = 0;
     do {
      if (HEAP32[i2 + (i1 * 192 | 0) + 76 + (i9 >>> 5 << 2) >> 2] & 1 << (i9 & 31) | 0) {
       i5 = HEAP32[gb + 1166252 >> 2] | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       i5 = i5 + 4 | 0;
       i4 = i3;
       L69 : do if ((i4 | 0) == (i5 | 0)) i4 = gb + 1576256 | 0; else {
        while (1) {
         if ((HEAP32[i4 + 20 >> 2] | 0) == (i9 | 0)) break;
         i4 = HEAP32[i3 + 4 >> 2] | 0;
         if (!i4) while (1) {
          i4 = HEAP32[i3 + 8 >> 2] | 0;
          if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) break; else i3 = i4;
         } else {
          i3 = i4;
          while (1) {
           i4 = HEAP32[i3 >> 2] | 0;
           if (!i4) {
            i4 = i3;
            break;
           } else i3 = i4;
          }
         }
         if ((i4 | 0) == (i5 | 0)) {
          i4 = gb + 1576256 | 0;
          break L69;
         } else i3 = i4;
        }
        i4 = HEAP32[i4 + 16 >> 2] | 0;
       } while (0);
       HEAP32[i23 >> 2] = 0;
       HEAP32[i23 + 4 >> 2] = 0;
       HEAP32[i23 + 8 >> 2] = 0;
       i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
       HEAP32[i27 >> 2] = i3;
       i5 = _strlen(i4) | 0;
       do if (i5 >>> 0 > 2147483631) {
        __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
        i3 = HEAP32[i15 >> 2] | 0;
        i29 = 57;
       } else {
        if (i5 >>> 0 >= 11) {
         i29 = 57;
         break;
        }
        HEAP8[i20 >> 0] = i5;
        if (!i5) i3 = i23; else {
         i3 = i23;
         i29 = 59;
        }
       } while (0);
       if ((i29 | 0) == 57) {
        i8 = i5 + 16 & -16;
        HEAP32[i17 >> 2] = 66;
        HEAP32[i28 >> 2] = i3;
        i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
        HEAP32[i23 >> 2] = i3;
        HEAP32[i18 >> 2] = i8 | -2147483648;
        HEAP32[i19 >> 2] = i5;
        i29 = 59;
       }
       if ((i29 | 0) == 59) {
        i29 = 0;
        _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
       }
       HEAP8[i3 + i5 >> 0] = 0;
       i4 = (__ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i25, i23) | 0) & 65535;
       i5 = HEAP32[i13 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i7 = HEAP32[i12 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i6 >>> 0 > i8 >>> 0) {
        i3 = i7 << 1;
        i3 = (i3 | 0) == 0 ? 1 : i3;
        if (i8 >>> 0 >= i3 >>> 0) break;
        if ((i7 | 0) > -1) {
         HEAP32[i12 >> 2] = i3;
         HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i3 << 1, 2, i10, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 1, 2, i10, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i13 >> 2] << 1 | 0) | 0;
         HEAP32[i12 >> 2] = i3;
         HEAP32[i11 >> 2] = i8;
         break;
        }
       } while (0);
       HEAP32[i13 >> 2] = i6;
       HEAP16[(HEAP32[i11 >> 2] | 0) + (i5 << 1) >> 1] = i4;
       if ((HEAP8[i20 >> 0] | 0) < 0) {
        i8 = HEAP32[i23 >> 2] | 0;
        i7 = HEAP32[i15 >> 2] | 0;
        HEAP32[i17 >> 2] = 66;
        HEAP32[i21 >> 2] = i7;
        __Z19free_alloc_internalPvRK10MemLabelId(i8, i17);
       }
      }
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != 256);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i24 | 0)) break L3;
     i2 = HEAP32[i22 >> 2] | 0;
    }
   }
  } while (0);
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != 6);
 STACKTOP = i30;
 return;
}

function __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i34, i35, i36, i6) {
 i34 = i34 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i37 = 0, f38 = f0, f39 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37 + 100 | 0;
 i28 = i37 + 40 | 0;
 i32 = i37;
 if (!i35) {
  i1 = HEAP32[i34 + 76 >> 2] | 0;
  switch (i1 | 0) {
  case 1:
   break;
  case 0:
   {
    i1 = 0;
    break;
   }
  case 3:
   break;
  default:
   i1 = 2;
  }
  HEAP32[i36 + 140 >> 2] = i1;
  i2 = i36 + 4 | 0;
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAP32[i36 >> 2] = 0;
  i3 = i36 + 64 | 0;
  HEAPF32[i3 >> 2] = Math_fround(inf);
  i4 = i36 + 60 | 0;
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i34 + 80 >> 2] | 0;
  switch (i1 | 0) {
  case 1:
   break;
  case 0:
   {
    i1 = 0;
    break;
   }
  case 3:
   break;
  default:
   i1 = 2;
  }
  HEAP32[i36 + 144 >> 2] = i1;
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAP32[i36 >> 2] = 0;
  HEAPF32[i3 >> 2] = Math_fround(inf);
  HEAP32[i4 >> 2] = 0;
 }
 i27 = i36 + 132 | 0;
 i13 = HEAP32[i27 >> 2] | 0;
 if (!i13) {
  i2 = HEAP32[i34 + 68 >> 2] | 0;
  i1 = i36 + 120 | 0;
  HEAP32[i27 >> 2] = i2;
  i3 = i36 + 136 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
   if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 * 40 | 0, 4, i36 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
   } else {
    i33 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i36 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i33 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 40 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = i33;
   }
   i2 = HEAP32[i27 >> 2] | 0;
  }
  if ((i2 | 0) > 0) {
   i3 = i34 + 56 | 0;
   i4 = i36 + 120 | 0;
   i1 = 0;
   do {
    i32 = HEAP32[i3 >> 2] | 0;
    i33 = HEAP32[i4 >> 2] | 0;
    HEAP32[i33 + (i1 * 40 | 0) >> 2] = HEAP32[i32 + (i1 << 4) >> 2];
    i30 = i33 + (i1 * 40 | 0) + 4 | 0;
    HEAP32[i30 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i30 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i30 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    i31 = i33 + (i1 * 40 | 0) + 16 | 0;
    HEAP32[i31 >> 2] = 0;
    HEAP32[i31 + 4 >> 2] = 0;
    HEAP32[i31 + 8 >> 2] = 0;
    HEAP32[i31 + 12 >> 2] = 0;
    HEAP32[i31 + 16 >> 2] = 0;
    HEAP32[i31 + 20 >> 2] = 0;
    HEAP32[i30 + (i35 << 2) >> 2] = HEAP32[i32 + (i1 << 4) + 4 >> 2];
    HEAP32[i31 + (i35 << 2) >> 2] = HEAP32[i32 + (i1 << 4) + 8 >> 2];
    HEAP32[i33 + (i1 * 40 | 0) + 28 + (i35 << 2) >> 2] = HEAP32[i32 + (i1 << 4) + 12 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAPF32[i36 + 4 >> 2] = Math_fround(inf);
  HEAP32[i36 >> 2] = 0;
  HEAPF32[i36 + 64 >> 2] = Math_fround(inf);
  HEAP32[i36 + 60 >> 2] = 0;
  HEAP32[i36 + 148 >> 2] = HEAP32[i34 + 84 >> 2];
  STACKTOP = i37;
  return;
 }
 i30 = i31 + 4 | 0;
 HEAPF32[i30 >> 2] = Math_fround(inf);
 HEAP32[i31 >> 2] = 0;
 i26 = i31 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i26 + 16 >> 2] = 0;
 i26 = i28 + 4 | 0;
 HEAPF32[i26 >> 2] = Math_fround(inf);
 HEAP32[i28 >> 2] = 0;
 i1 = i28 + 8 | 0;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i29 = i34 + 68 | 0;
 i9 = HEAP32[i29 >> 2] | 0;
 if ((i9 | 0) > 0) {
  i10 = i34 + 56 | 0;
  i11 = i36 + 120 | 0;
  i12 = i32 + 4 | 0;
  i14 = i32 + 8 | 0;
  i15 = i32 + 12 | 0;
  i16 = i32 + 16 | 0;
  i17 = i32 + 20 | 0;
  i18 = i32 + 24 | 0;
  i19 = i32 + 28 | 0;
  i20 = i32 + 32 | 0;
  i21 = i32 + 36 | 0;
  i22 = i36 + 4 | 0;
  i23 = i36 + 64 | 0;
  i24 = i36 + 60 | 0;
  i25 = i36 + 120 | 0;
  i8 = 0;
  do {
   i3 = (HEAP32[i10 >> 2] | 0) + (i8 << 4) | 0;
   if (!i13) {
    i1 = HEAP32[i11 >> 2] | 0;
    i33 = 40;
   } else {
    i1 = HEAP32[i11 >> 2] | 0;
    if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) i33 = 40; else if ((i13 | 0) > 1 ? (HEAP32[i1 + ((i13 + -1 | 0) * 40 | 0) >> 2] & 2139095040 | 0) != 2139095040 : 0) {
     i2 = __ZNK17AnimationCurveTplI8Vector3fE9FindIndexERKNS1_5CacheEf(i36, i28, Math_fround(HEAPF32[i3 >> 2])) | 0;
     i7 = HEAP32[i11 >> 2] | 0;
     i1 = i7 + (i2 * 40 | 0) | 0;
     HEAP32[i28 >> 2] = i2;
     i13 = HEAP32[i1 >> 2] | 0;
     HEAP32[i26 >> 2] = i13;
     i2 = i7 + ((i2 + 1 | 0) * 40 | 0) | 0;
     f5 = Math_fround(HEAPF32[i3 >> 2]);
     f38 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i13 = f38 < Math_fround(0.0);
     f39 = Math_fround(-f38);
     if (!((i13 ? f39 : f38) <= Math_fround(1.99999999e-06))) {
      f39 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
      i13 = f39 < Math_fround(0.0);
      f38 = Math_fround(-f39);
      if (!((i13 ? f38 : f39) <= Math_fround(1.99999999e-06))) {
       __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f(i32, i1, i2, f5);
       HEAPF32[i22 >> 2] = Math_fround(inf);
       HEAP32[i36 >> 2] = 0;
       HEAPF32[i23 >> 2] = Math_fround(inf);
       HEAP32[i24 >> 2] = 0;
       i6 = HEAP32[i25 >> 2] | 0;
       i7 = HEAP32[i27 >> 2] | 0;
       f5 = Math_fround(HEAPF32[i32 >> 2]);
       i4 = i6;
       i1 = (i7 * 40 | 0) / 40 | 0;
       L41 : while (1) {
        while (1) {
         if (!i1) break L41;
         i2 = (i1 | 0) / 2 | 0;
         i3 = i4 + (i2 * 40 | 0) | 0;
         if (Math_fround(HEAPF32[i3 >> 2]) < f5) break; else i1 = i2;
        }
        i4 = i3 + 40 | 0;
        i1 = i1 + -1 - i2 | 0;
       }
       if ((i4 | 0) == (i6 + (i7 * 40 | 0) | 0)) i33 = 38; else if (f5 < Math_fround(HEAPF32[i4 >> 2])) i33 = 38;
       if ((i33 | 0) == 38) {
        i33 = 0;
        __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_(i25, i4, 1, i32) | 0;
       }
       HEAPF32[i26 >> 2] = Math_fround(inf);
       HEAP32[i28 >> 2] = 0;
      }
     }
    } else i33 = 40;
   }
   if ((i33 | 0) == 40) {
    i33 = 0;
    HEAP32[i12 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i17 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i1 + 24 >> 2];
    HEAP32[i19 >> 2] = HEAP32[i1 + 28 >> 2];
    HEAP32[i20 >> 2] = HEAP32[i1 + 32 >> 2];
    HEAP32[i21 >> 2] = HEAP32[i1 + 36 >> 2];
    i6 = HEAP32[i3 >> 2] | 0;
    HEAP32[i32 >> 2] = i6;
    HEAPF32[i22 >> 2] = Math_fround(inf);
    HEAP32[i36 >> 2] = 0;
    HEAPF32[i23 >> 2] = Math_fround(inf);
    HEAP32[i24 >> 2] = 0;
    f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i6 = i1;
    i2 = (i13 * 40 | 0) / 40 | 0;
    L55 : while (1) {
     while (1) {
      if (!i2) break L55;
      i3 = (i2 | 0) / 2 | 0;
      i4 = i6 + (i3 * 40 | 0) | 0;
      if (Math_fround(HEAPF32[i4 >> 2]) < f5) break; else i2 = i3;
     }
     i6 = i4 + 40 | 0;
     i2 = i2 + -1 - i3 | 0;
    }
    if ((i6 | 0) == (i1 + (i13 * 40 | 0) | 0)) i33 = 47; else if (f5 < Math_fround(HEAPF32[i6 >> 2])) i33 = 47;
    if ((i33 | 0) == 47) {
     i33 = 0;
     __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_(i25, i6, 1, i32) | 0;
    }
    HEAPF32[i26 >> 2] = Math_fround(inf);
    HEAP32[i28 >> 2] = 0;
   }
   i8 = i8 + 1 | 0;
   i13 = HEAP32[i27 >> 2] | 0;
  } while ((i8 | 0) != (i9 | 0));
 }
 if ((i13 | 0) > 0) {
  i14 = i36 + 120 | 0;
  i15 = i34 + 56 | 0;
  i10 = i32 + 4 | 0;
  i11 = i32 + 8 | 0;
  i9 = i32 + 12 | 0;
  i8 = 0;
  do {
   i12 = HEAP32[i14 >> 2] | 0;
   i1 = HEAP32[i29 >> 2] | 0;
   do if (!i1) {
    f5 = Math_fround(0.0);
    i33 = 61;
   } else {
    i2 = HEAP32[i15 >> 2] | 0;
    if ((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040) if ((i1 | 0) > 1 ? (HEAP32[i2 + (i1 + -1 << 4) >> 2] & 2139095040 | 0) != 2139095040 : 0) {
     i27 = i12 + (i8 * 40 | 0) | 0;
     i4 = __ZNK17AnimationCurveTplIfE9FindIndexERKNS0_5CacheEf(i34, i31, Math_fround(HEAPF32[i27 >> 2])) | 0;
     i6 = HEAP32[i15 >> 2] | 0;
     i1 = i6 + (i4 << 4) | 0;
     HEAP32[i31 >> 2] = i4;
     i28 = HEAP32[i1 >> 2] | 0;
     HEAP32[i30 >> 2] = i28;
     i7 = i4 + 1 | 0;
     i2 = i6 + (i7 << 4) | 0;
     f5 = Math_fround(HEAPF32[i27 >> 2]);
     f39 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i28 = f39 < Math_fround(0.0);
     f38 = Math_fround(-f39);
     if ((i28 ? f38 : f39) <= Math_fround(1.99999999e-06)) {
      i3 = HEAP32[i6 + (i4 << 4) + 12 >> 2] | 0;
      i2 = HEAP32[i6 + (i4 << 4) + 4 >> 2] | 0;
      i1 = HEAP32[i6 + (i4 << 4) + 8 >> 2] | 0;
      break;
     }
     f39 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
     i28 = f39 < Math_fround(0.0);
     f38 = Math_fround(-f39);
     if (!((i28 ? f38 : f39) <= Math_fround(1.99999999e-06))) {
      __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f(i32, i1, i2, f5);
      i3 = HEAP32[i9 >> 2] | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      i1 = HEAP32[i11 >> 2] | 0;
      break;
     } else {
      i3 = HEAP32[i6 + (i7 << 4) + 12 >> 2] | 0;
      i2 = HEAP32[i6 + (i7 << 4) + 4 >> 2] | 0;
      i1 = HEAP32[i6 + (i7 << 4) + 8 >> 2] | 0;
      break;
     }
    }
    if ((i1 | 0) == 1) {
     f5 = Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2]);
     i33 = 61;
    } else {
     f5 = Math_fround(0.0);
     i33 = 61;
    }
   } while (0);
   if ((i33 | 0) == 61) {
    i33 = 0;
    i3 = 0;
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = 0;
   }
   HEAP32[i12 + (i8 * 40 | 0) + 4 + (i35 << 2) >> 2] = i2;
   HEAP32[i12 + (i8 * 40 | 0) + 16 + (i35 << 2) >> 2] = i1;
   HEAP32[i12 + (i8 * 40 | 0) + 28 + (i35 << 2) >> 2] = i3;
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i13 | 0));
 }
 HEAPF32[i36 + 4 >> 2] = Math_fround(inf);
 HEAP32[i36 >> 2] = 0;
 HEAPF32[i36 + 64 >> 2] = Math_fround(inf);
 HEAP32[i36 + 60 >> 2] = 0;
 STACKTOP = i37;
 return;
}

function __ZN5physx14PxsAABBManager22computeAABBUpdateListsEPjjRKNS_20PxsComputeAABBParamsE(i29, i26, i24, i1) {
 i29 = i29 | 0;
 i26 = i26 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28 + 157 | 0;
 i22 = i28 + 156 | 0;
 i21 = i28;
 i25 = i28 + 144 | 0;
 i19 = i29 + 268 | 0;
 if (HEAP32[i19 >> 2] | 0) {
  i1 = HEAP32[i29 + 196 >> 2] | 0;
  i4 = HEAP32[i29 >> 2] | 0;
  i20 = i21 + 128 | 0;
  HEAP32[i20 >> 2] = i4;
  i5 = i21 + 132 | 0;
  HEAP32[i5 >> 2] = 0;
  i2 = i21 + 136 | 0;
  HEAP32[i2 >> 2] = 0;
  if (i1 | 0) {
   i3 = (i1 + 31 | 0) >>> 5;
   do if (i1 >>> 0 > 1024) {
    i1 = (i3 << 2) + 15 & 1073741808;
    if (!i4) {
     i18 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, i1, gb + 717789 | 0, 1998) | 0;
     HEAP32[i5 >> 2] = i18;
     i1 = i3 | -2147483648;
     HEAP32[i2 >> 2] = i1;
     i2 = i18;
     break;
    } else {
     i18 = __ZN5physx19PxcScratchAllocator5allocEjb(i4, i1, 1) | 0;
     HEAP32[i5 >> 2] = i18;
     i1 = i3 | -2147483648;
     HEAP32[i2 >> 2] = i1;
     i2 = i18;
     break;
    }
   } else {
    HEAP32[i5 >> 2] = i21;
    i1 = i3 | -2147483648;
    HEAP32[i2 >> 2] = i1;
    i2 = i21;
   } while (0);
   _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
  }
  i17 = HEAP32[i29 + 41556 >> 2] | 0;
  i18 = i29 + 272 | 0;
  i4 = HEAP32[i18 >> 2] & 2147483647;
  L13 : do if (!i4) i27 = 17; else {
   i3 = HEAP32[i19 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (i2 | 0) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) {
     i27 = 17;
     break L13;
    }
   }
   i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i1 << 5;
   i2 = i2 + -1 & i2;
   L19 : do if (!i2) do {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) {
     i2 = 0;
     break L19;
    }
    i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   } while ((i2 | 0) == 0); while (0);
   if ((i5 | 0) == -1) i27 = 17; else {
    i12 = HEAP32[i29 + 260 >> 2] | 0;
    i13 = HEAP32[i29 + 180 >> 2] | 0;
    i10 = i21 + 132 | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    i14 = i29 + 356 | 0;
    i15 = i29 + 96 | 0;
    i16 = i29 + 68 | 0;
    i3 = i1;
    i1 = 0;
    i4 = i5;
    do {
     i11 = i3 << 5;
     while (1) {
      i7 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
      if (HEAP8[i13 + (i7 * 1048 | 0) + 1025 >> 0] | 0) {
       i6 = i7 >>> 5;
       i4 = i8 + (i6 << 2) | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       i9 = 1 << (i7 & 31);
       if (!(i5 & i9)) {
        HEAP32[i4 >> 2] = i5 | i9;
        HEAP32[i17 + (i1 << 2) >> 2] = i7;
        i1 = i1 + 1 | 0;
       }
       i4 = (HEAP32[i14 >> 2] | 0) + (i6 << 2) | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (!(i5 & i9)) HEAP32[i4 >> 2] = i5 | i9;
       i6 = HEAP32[i13 + (i7 * 1048 | 0) + 1028 >> 2] | 0;
       i4 = i6 >>> 5;
       i6 = 1 << (i6 & 31);
       if (!(HEAP32[(HEAP32[i15 >> 2] | 0) + (i4 << 2) >> 2] & i6)) {
        i4 = (HEAP32[i16 >> 2] | 0) + (i4 << 2) | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        if (!(i5 & i6)) HEAP32[i4 >> 2] = i5 | i6;
       }
      }
      if (!i2) break L13;
      i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i11;
      i2 = i2 + -1 & i2;
      if (!i2) break;
      if ((i4 | 0) == -1) break L13;
     }
     i5 = HEAP32[i18 >> 2] & 2147483647;
     i2 = i3;
     while (1) {
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 >= i5 >>> 0) {
       i2 = 0;
       break;
      }
      i2 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      if (!i2) i2 = i3; else break;
     }
    } while ((i4 | 0) != -1);
   }
  } while (0);
  if ((i27 | 0) == 17) {
   i8 = i21 + 132 | 0;
   i10 = i8;
   i8 = HEAP32[i8 >> 2] | 0;
   i1 = 0;
  }
  HEAP32[i29 + 41568 >> 2] = i1;
  do if (!((i8 | 0) == 0 | (i8 | 0) == (i21 | 0))) {
   i9 = HEAP32[i20 >> 2] | 0;
   if (!i9) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i8);
    break;
   }
   i1 = HEAP32[i9 + 16 >> 2] | 0;
   if (i1 >>> 0 > i8 >>> 0) i27 = 39; else if ((i1 + (HEAP32[i9 + 20 >> 2] | 0) | 0) >>> 0 > i8 >>> 0) {
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
    i5 = i9 + 8 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i7 = i9 + 4 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    i1 = i6;
    while (1) {
     i3 = i1 + -1 | 0;
     i2 = i4 + (i3 << 2) | 0;
     if ((HEAP32[i2 >> 2] | 0) >>> 0 < i8 >>> 0) i1 = i3; else break;
    }
    if (i1 >>> 0 < i6 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 < i6 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i6 | 0));
    }
    HEAP32[i5 >> 2] = i6 + -1;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
   } else i27 = 39;
   if ((i27 | 0) == 39) __ZN5physx6shdfnd9Allocator10deallocateEPv(i23, i8);
  } while (0);
  HEAP32[i10 >> 2] = 0;
 }
 i15 = HEAP32[i29 + 16900 >> 2] | 0;
 i16 = i25 + 4 | 0;
 HEAP32[i25 >> 2] = i26;
 HEAP32[i16 >> 2] = i24 | -2147483648;
 i3 = i24 & 2147483647;
 L71 : do if (!i3) {
  i1 = 0;
  i2 = 0;
  i4 = -1;
 } else {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i2 = 0;
    i4 = -1;
    break L71;
   }
  }
  i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  i3 = i24 & 2147483647;
  if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i2 = 0;
    break L71;
   }
   i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
 } while (0);
 i10 = i29 + 156 | 0;
 i17 = i29 + 96 | 0;
 i18 = i29 + 68 | 0;
 i11 = i29 + 28 | 0;
 i12 = i29 + 260 | 0;
 i14 = i29 + 180 | 0;
 i13 = i29 + 356 | 0;
 i3 = 0;
 L80 : while (1) {
  i9 = i1 << 5;
  i8 = i3;
  while (1) {
   L84 : while (1) {
    if ((i4 | 0) < 1073741823) {
     i27 = 92;
     break;
    }
    switch (i4 | 0) {
    case 1073741823:
     {
      i4 = 1073741823;
      break;
     }
    default:
     break L84;
    }
   }
   if ((i27 | 0) == 92) {
    i27 = 0;
    switch (i4 | 0) {
    case -1:
     {
      i1 = i8;
      break L80;
     }
    default:
     {}
    }
   }
   i3 = i4 >>> 1;
   if (!(i4 & 1)) {
    i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if ((i4 | 0) == 1073741823) i3 = i8; else {
     i3 = i8;
     do {
      HEAP32[i15 + (i3 << 2) >> 2] = i4;
      i3 = i3 + 1 | 0;
      i5 = i4 >>> 5;
      i7 = 1 << (i4 & 31);
      if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] & i7)) {
       i5 = (HEAP32[i18 >> 2] | 0) + (i5 << 2) | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       if (!(i6 & i7)) HEAP32[i5 >> 2] = i6 | i7;
      }
      i4 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != 1073741823);
    }
   } else {
    i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 * 1048 | 0) + 1025 >> 0] | 0)) i3 = i8; else {
     i5 = (HEAP32[i13 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i7 = 1 << (i3 & 31);
     if (!(i6 & i7)) HEAP32[i5 >> 2] = i6 | i7;
     i5 = HEAP32[i4 + (i3 * 1048 | 0) + 1028 >> 2] | 0;
     i3 = i5 >>> 5;
     i5 = 1 << (i5 & 31);
     if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + (i3 << 2) >> 2] & i5)) {
      i3 = (HEAP32[i18 >> 2] | 0) + (i3 << 2) | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (!(i4 & i5)) {
       HEAP32[i3 >> 2] = i4 | i5;
       i3 = i8;
      } else i3 = i8;
     } else i3 = i8;
    }
   }
   if (!i2) {
    i2 = 0;
    i8 = i3;
    i4 = -1;
    continue;
   }
   i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i9;
   i2 = i2 + -1 & i2;
   if (!i2) break; else i8 = i3;
  }
  i5 = HEAP32[i16 >> 2] & 2147483647;
  while (1) {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    continue L80;
   }
   i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
   if (i2) continue L80;
  }
 }
 HEAP32[i29 + 16912 >> 2] = i1;
 if ((i26 | 0) != 0 & (HEAP32[i16 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i25 + 8 | 0, i26);
 __ZN5physx10ChangeList11computeListEv(i29 + 356 | 0);
 i7 = HEAP32[i29 + 33316 >> 2] | 0;
 i8 = HEAP32[i29 + 372 >> 2] | 0;
 i9 = HEAP32[i29 + 368 >> 2] | 0;
 if (!i8) {
  i26 = 0;
  i27 = i29 + 33328 | 0;
  HEAP32[i27 >> 2] = i26;
  i27 = i29 + 68 | 0;
  __ZN5physx10ChangeList11computeListEv(i27);
  i27 = i29 + 96 | 0;
  __ZN5physx10ChangeList11computeListEv(i27);
  i29 = i29 + 124 | 0;
  __ZN5physx10ChangeList11computeListEv(i29);
  STACKTOP = i28;
  return;
 }
 i10 = i29 + 232 | 0;
 i11 = i29 + 308 | 0;
 i12 = i29 + 316 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i1 = 0;
 i6 = 0;
 do {
  i4 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
  if (!(HEAP8[i5 + (i4 * 1048 | 0) + 1024 >> 0] | 0)) {
   if (HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31)) i27 = 82;
  } else i27 = 82;
  if ((i27 | 0) == 82) {
   i27 = 0;
   i2 = HEAP32[i5 + (i4 * 1048 | 0) + 1032 >> 2] | 0;
   if ((i2 | 0) != 1073741823) {
    i3 = HEAP32[i11 >> 2] | 0;
    do {
     if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) != 1073741823) {
      HEAP32[i7 + (i1 << 2) >> 2] = i2;
      i1 = i1 + 1 | 0;
     }
     i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    } while ((i2 | 0) != 1073741823);
   }
   i4 = HEAP32[i5 + (i4 * 1048 | 0) + 1028 >> 2] | 0;
   i2 = i4 >>> 5;
   i4 = 1 << (i4 & 31);
   if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + (i2 << 2) >> 2] & i4)) {
    i2 = (HEAP32[i18 >> 2] | 0) + (i2 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!(i3 & i4)) HEAP32[i2 >> 2] = i3 | i4;
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 i27 = i29 + 33328 | 0;
 HEAP32[i27 >> 2] = i1;
 i27 = i29 + 68 | 0;
 __ZN5physx10ChangeList11computeListEv(i27);
 i27 = i29 + 96 | 0;
 __ZN5physx10ChangeList11computeListEv(i27);
 i29 = i29 + 124 | 0;
 __ZN5physx10ChangeList11computeListEv(i29);
 STACKTOP = i28;
 return;
}

function __ZN5Umbra5Query21queryPortalVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEffPKNS_20ObjectDistanceParamsEiii(i1, i14, i22, i7, f8, f13, i16, i9, i10, i11) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i22 = i22 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f13 = Math_fround(f13);
 i16 = i16 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i12 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, f25 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1568 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 1496 | 0;
 i23 = i24 + 1432 | 0;
 i15 = i24;
 i17 = i24 + 1408 | 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i23 >> 2] = i5;
 i2 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i23 + 4 >> 2] = i2;
 i20 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i20 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i20 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i23 + 8 >> 2] = i1;
 i12 = i23 + 12 | 0;
 HEAP32[i12 >> 2] = i1 + i4;
 i18 = i23 + 16 | 0;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i23 + 20 >> 2] = i4;
 HEAP32[i23 + 24 >> 2] = 0;
 i20 = i23 + 28 | 0;
 HEAP32[i20 >> 2] = 0;
 i19 = i23 + 32 | 0;
 HEAP32[i19 >> 2] = i14;
 HEAP32[i23 + 36 >> 2] = 0;
 HEAP32[i23 + 40 >> 2] = -1;
 i3 = HEAP32[i5 + 84 >> 2] | 0;
 HEAP32[i23 + 44 >> 2] = i3;
 HEAP32[i23 + 48 >> 2] = i3;
 HEAP32[i23 + 52 >> 2] = 0;
 HEAP32[i23 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i18 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i23 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP32[i5 >> 2] | 0)) {
  i22 = 6;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 if ((i10 + -1 | 0) >>> 0 > 15) {
  i22 = 3;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 if ((i9 | 0) < 0 | (i9 | 0) >= (i10 | 0) | i11 >>> 0 > 4) {
  i22 = 3;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 if (i11 | 0) {
  if ((i10 | 0) % (i11 | 0) | 0 | 0) {
   i22 = 3;
   __ZN5Umbra12QueryContextD2Ev(i23);
   STACKTOP = i24;
   return i22 | 0;
  }
  if (((i10 | 0) / (i11 | 0) | 0 | 0) > 4) {
   i22 = 3;
   __ZN5Umbra12QueryContextD2Ev(i23);
   STACKTOP = i24;
   return i22 | 0;
  }
 }
 i1 = i7 + 3 & -4;
 i4 = i1;
 if (!(HEAP8[i4 + 436 >> 0] | 0)) {
  f25 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i4 + 16 | 0;
  f6 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  if (f25 == f6) {
   i3 = i4 + 32 | 0;
   if (f6 == Math_fround(HEAPF32[i4 + 40 >> 2])) if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 24 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 36 >> 2]) == Math_fround(0.0)) {
    HEAP32[i20 >> 2] = 3;
    i22 = 3;
    __ZN5Umbra12QueryContextD2Ev(i23);
    STACKTOP = i24;
    return i22 | 0;
   }
  }
 }
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i1 = i15 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 20 >> 2] = Math_fround(1.0);
 i1 = i15 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 40 >> 2] = Math_fround(1.0);
 i1 = i15 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i15 + 64 >> 2] = Math_fround(1.0);
 i1 = i15 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 84 >> 2] = Math_fround(1.0);
 i1 = i15 + 88 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 104 >> 2] = Math_fround(1.0);
 i1 = i15 + 108 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i15 + 124 >> 2] = Math_fround(1.0);
 i1 = i15 + 1208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i15 + 1376 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 _memset(i15 + 128 | 0, 0, 1068) | 0;
 i1 = i15 + 1316 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i21 >> 2] = f8;
 HEAPF32[i21 + 4 >> 2] = f8;
 HEAPF32[i21 + 8 >> 2] = f8;
 __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii(i15, i4, i21, i9, i10, i11);
 if (i14 & 512 | 0) __ZN5Umbra12QueryContext16visualizeFrustumERKNS_11TransformerE(i23, i15);
 __ZN5Umbra16VisibilityResultC2ERNS_12QueryContextERKNS_10VisibilityERKNS_11TransformerEb(i21, i23, i22, i15, 1);
 i3 = HEAP32[i20 >> 2] | 0;
 do if (!i3) {
  if (i14 & 4 | 0) {
   i1 = HEAP32[i18 >> 2] | 0;
   i2 = i1 + 4448 | 0;
   if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i2 = 0; else {
    HEAP32[i18 >> 2] = i2;
    i2 = i1;
   }
   __ZN5Umbra15PortalRayTracerC2EPNS_12QueryContextERKNS_7Vector3EPKNS_23ImpObjectDistanceParamsEPNS_11TransformerE(i2, i23, i15 + 1184 | 0, (i16 | 0) == 0 ? 0 : i16 + 3 & -4, i15);
   if (!i2) {
    i4 = 1;
    i3 = 2;
    break;
   }
   HEAP32[i20 >> 2] = __ZN5Umbra15PortalRayTracer7executeERNS_16VisibilityResultE(i2, i21) | 0;
   i1 = HEAP32[i2 + 84 >> 2] | 0;
   if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
   i1 = HEAP32[i2 + 4416 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4420 >> 2];
   i1 = HEAP32[i2 + 4380 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4384 >> 2];
   HEAP32[i18 >> 2] = i2;
   i4 = 0;
   i3 = 2;
   break;
  }
  HEAPF32[i17 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i17 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i17 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i17 + 12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i17 + 16 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i17 + 20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i1 + 7056 | 0;
  if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i7 = 0; else {
   HEAP32[i18 >> 2] = i2;
   i7 = i1;
  }
  __ZN5Umbra12PortalCullerC2EPNS_12QueryContextEPNS_11TransformerEfPKNS_23ImpObjectDistanceParamsEii(i7, i23, i15, f13, (i16 | 0) == 0 ? 0 : i16 + 3 & -4, 1024, 4096);
  if (!i7) {
   i4 = 1;
   i3 = 2;
   break;
  }
  if (!(HEAP32[i20 >> 2] | 0)) {
   i5 = (i14 & 8 | 0) == 0;
   i4 = (i14 & 2 | 0) != 0;
   i3 = i7 + 8 | 0;
   HEAP32[i3 >> 2] = i21;
   i1 = HEAP32[i21 + 24 >> 2] | 0;
   if (!i1) i1 = i21; else {
    i1 = HEAP32[i1 + 1408 >> 2] | 0;
    HEAP32[i7 + 356 >> 2] = i1;
    HEAP8[i7 + 364 >> 0] = 0;
    i2 = i1 + 16384 | 0;
    if (i1 >>> 0 < 4294950912) {
     do {
      _memset(i1 | 0, 0, 1024) | 0;
      i1 = i1 + 1024 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
     i1 = HEAP32[i3 >> 2] | 0;
    } else i1 = i21;
    HEAPF32[i7 + 360 >> 2] = Math_fround(0.0);
   }
   HEAP32[i7 + 396 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP8[i7 + 404 >> 0] = 1;
   HEAP32[i7 + 400 >> 2] = HEAP32[i1 + 32 >> 2];
   if (__ZN5Umbra12PortalCuller4initEbbRKNS_4AABBEi(i7, i4, i5, i17, -1) | 0) __ZN5Umbra12PortalCuller8traverseEv(i7);
   HEAP32[i20 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2];
   i2 = i7;
  } else i2 = i7;
  i1 = HEAP32[i7 + 292 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
  i1 = HEAP32[i7 + 348 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
  i1 = HEAP32[i7 + 2300 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
  i1 = HEAP32[i7 + 2872 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 2876 >> 2];
  i1 = HEAP32[i7 + 2836 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 2840 >> 2];
  i2 = i7 + 432 | 0;
  i1 = HEAP32[i7 + 484 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
  i1 = HEAP32[i7 + 452 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
  i1 = HEAP32[i7 + 424 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 428 >> 2];
  i1 = HEAP32[i7 + 412 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 416 >> 2];
  i1 = HEAP32[i7 + 384 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 388 >> 2];
  i1 = HEAP32[i7 + 372 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 376 >> 2];
  HEAP32[i18 >> 2] = i7;
  i4 = 0;
  i3 = 2;
 } else i4 = 1; while (0);
 i1 = HEAP32[i21 + 68 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i21 + 24 >> 2] | 0;
  _memcpy(i1 | 0, i2 | 0, 1424) | 0;
  if (i2 | 0) HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] = i2;
 }
 i1 = HEAP32[i21 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i21 + 12 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i21 + 4 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 4 >> 2] | 0)) HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] = 2;
 i1 = HEAP32[i21 + 8 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 4 >> 2] | 0)) HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] = 2;
 if (i4 | 0) {
  i22 = i3;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) {
  i22 = i1;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 if (!(HEAP32[(HEAP32[i23 >> 2] | 0) + 32 >> 2] | 0)) {
  i22 = 0;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 if (!(HEAP32[i19 >> 2] & 64)) {
  i22 = 0;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 i1 = HEAP32[(i22 + 3 & -4) + 8 >> 2] | 0;
 if (!i1) {
  i22 = 0;
  __ZN5Umbra12QueryContextD2Ev(i23);
  STACKTOP = i24;
  return i22 | 0;
 }
 __ZNK5Umbra18ImpOcclusionBuffer13visualizeHullEPNS_12QueryContextE(i1 + 15 & -16, i23);
 i22 = HEAP32[i20 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i23);
 STACKTOP = i24;
 return i22 | 0;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI14SafeBinaryReadEEvRT_(i18, i17) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 12 | 0;
 i14 = i19;
 __ZN14SafeBinaryRead10SetVersionEi(i17, 3);
 __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i17, i18, gb + 905792 | 0, 0);
 i15 = i18 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905809 | 0, gb + 905830 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i15 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i17 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i2 = i15;
    i1 = i1 | 0 ? i1 - i2 | 0 : 0;
    HEAP32[i15 >> 2] = i1;
   } else i2 = i15;
   __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i17, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i15 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i2 = i18 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905840 | 0, gb + 905830 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i17 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i16 = i2;
    i1 = i1 | 0 ? i1 - i16 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i16;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i17, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i13 = i17 + 4 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = i18 + 16;
 HEAP32[i14 + 4 >> 2] = i18 + 12;
 HEAP32[i14 + 8 >> 2] = i8;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905854 | 0, i8, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i17, i14, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i16 = i18 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905876 | 0, gb + 905830 | 0, i14, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i16 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i13 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 396, 4) | 0;
    __ZN7mecanim5human5HumanC2Ev(i1);
    i2 = i16;
    i1 = i1 | 0 ? i1 - i2 | 0 : 0;
    HEAP32[i16 >> 2] = i1;
   } else i2 = i16;
   i3 = i1 + i2 | 0;
   i1 = i3;
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, gb + 905884 | 0, i12, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim5human5Human8TransferI14SafeBinaryReadEEvRT_(i1, i17); else {
     i1 = HEAP32[i12 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i17 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i17);
   }
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i11 = i18 + 28 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = i11;
 HEAP32[i14 + 4 >> 2] = i18 + 24;
 HEAP32[i14 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905890 | 0, i8, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i17, i14, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i10 = i18 + 36 | 0;
 i9 = i18 + 32 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 HEAP32[i14 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905916 | 0, i8, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i17, i14, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i7 = i18 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905949 | 0, HEAP32[gb + 37040 >> 2] | 0, i12, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i17 + 16 | 0;
   i6 = HEAP32[i17 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i17 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i17 + 36 >> 2] | 0, 0 - (HEAP32[i17 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i4 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i17 + 24 >> 2] | 0) >>> 0) i4 = 57; else {
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
   if (HEAP32[i17 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i2 = i18 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 905971 | 0, gb + 905989 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i17); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i3 = i18 + 84 | 0;
 __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i17, i3, gb + 905995 | 0, 0);
 i4 = i18 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 906016 | 0, gb + 905830 | 0, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i13 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i2 = i4;
    i1 = i1 | 0 ? i1 - i2 | 0 : 0;
    HEAP32[i4 >> 2] = i1;
   } else i2 = i4;
   __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i17, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 i5 = i18 + 96 | 0;
 i6 = i18 + 92 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 906041 | 0, i8, i12, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i17, i14, 0); else {
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i17 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i17, 1) | 0) if ((HEAP32[i7 >> 2] | 0) != -1) {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i18;
  i14 = (HEAP32[i18 >> 2] | 0) + i2 | 0;
  i14 = __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE(HEAP32[i14 >> 2] | 0, HEAP32[i14 + 12 >> 2] | 0, i1) | 0;
  i12 = i3;
  i14 = i14 | 0 ? i14 - i12 | 0 : 0;
  HEAP32[i3 >> 2] = i14;
  i8 = HEAP32[i18 >> 2] | 0;
  __ZN7mecanim8skeleton12SkeletonCopyEPKNS0_8SkeletonEPS1_((i8 | 0) == 0 ? 0 : i8 + i2 | 0, (i14 | 0) == 0 ? 0 : i14 + i12 | 0);
  i14 = HEAP32[i3 >> 2] | 0;
  i12 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i14 | 0) == 0 ? 0 : i14 + i12 | 0, i1) | 0;
  i14 = i4;
  i12 = i12 | 0 ? i12 - i14 | 0 : 0;
  HEAP32[i4 >> 2] = i12;
  i8 = HEAP32[i15 >> 2] | 0;
  __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i8 | 0) == 0 ? 0 : i8 + i15 | 0, (i12 | 0) == 0 ? 0 : i12 + i14 | 0);
  i2 = HEAP32[(HEAP32[i18 >> 2] | 0) + i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  if (!i2) i1 = 0; else {
   i3 = i2 << 2;
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 4) | 0;
   if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  }
  i2 = i5;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i5 >> 2] = i1;
  if (HEAP32[i6 >> 2] | 0) {
   HEAP32[i1 + i2 >> 2] = 0;
   if ((HEAP32[i6 >> 2] | 0) >>> 0 > 1) {
    i1 = 1;
    do {
     HEAP32[(HEAP32[i5 >> 2] | 0) + i2 + (i1 << 2) >> 2] = i1;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
   }
  }
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i17, 2) | 0)) {
  STACKTOP = i19;
  return;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i5 = i16;
 i17 = i1 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i17 >> 2] | 0) + i17 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = i18;
 i3 = HEAP32[(HEAP32[i18 >> 2] | 0) + i4 >> 2] | 0;
 HEAP32[i9 >> 2] = i3;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i14 = i10;
 i13 = i1 | 0 ? i1 - i14 | 0 : 0;
 HEAP32[i10 >> 2] = i13;
 i15 = HEAP32[i11 >> 2] | 0;
 i16 = (HEAP32[i16 >> 2] | 0) + i5 + 40 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 __ZN7mecanim8skeleton30SkeletonBuildReverseIndexArrayEPiPKiPKNS0_8SkeletonES6_((i13 | 0) == 0 ? 0 : i13 + i14 | 0, (i15 | 0) == 0 ? 0 : i15 + i11 | 0, (i17 | 0) == 0 ? 0 : i16 + i17 | 0, (i18 | 0) == 0 ? 0 : i18 + i4 | 0);
 STACKTOP = i19;
 return;
}

function __ZN22AnimationMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i10, i17, i18, i21) {
 i10 = i10 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i29 + 8 | 0;
 i16 = i29;
 i27 = i29 + 48 | 0;
 i28 = i29 + 28 | 0;
 i20 = i29 + 16 | 0;
 i15 = i10 + 8 | 0;
 i11 = HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i12 = i16;
 HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i12 + 4 >> 2] = i23;
 HEAP32[i27 >> 2] = 0;
 i12 = i27 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i23 = i27 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i16);
 i14 = i19;
 i25 = HEAP32[i14 + 4 >> 2] | 0;
 i26 = i24;
 HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 i26 = gb + 64016 | 0;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i14 = i16;
 HEAP32[i14 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i14 + 4 >> 2] = i25;
 HEAP32[i28 >> 2] = 0;
 i14 = i28 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i25 = i28 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i28 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i16);
 i8 = i19;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i13 = i26;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i13 + 4 >> 2] = i9;
 L1 : do if ((i11 | 0) > 0) {
  i9 = 0;
  i2 = 0;
  i3 = 0;
  while (1) {
   i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0;
   if (!(HEAP32[i1 + (i9 << 3) + 4 >> 2] | 0)) i13 = i2; else if (Math_fround(HEAPF32[i1 + (i9 << 3) >> 2]) > Math_fround(0.0)) {
    i8 = i2 + 1 | 0;
    i2 = i9;
    i1 = i10;
    while (1) {
     i1 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
     if (!i1) {
      i1 = 0;
      break;
     }
     if (!(HEAP32[i1 + 16 >> 2] | 0)) break; else i2 = 0;
    }
    i3 = HEAP32[i12 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i6 = HEAP32[i23 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i4 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i23 >> 2] = i2;
      HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i2 << 2, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i13 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
      HEAP32[i23 >> 2] = i2;
      HEAP32[i27 >> 2] = i13;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i4;
    HEAP32[(HEAP32[i27 >> 2] | 0) + (i3 << 2) >> 2] = i1;
    i2 = (HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0) + (i9 << 3) | 0;
    i3 = HEAP32[i14 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i6 = HEAP32[i25 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i4 >>> 0 > i7 >>> 0) {
     i1 = i6 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i25 >> 2] = i1;
      HEAP32[i28 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i28 >> 2] | 0, i1 << 2, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i13 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
      HEAP32[i25 >> 2] = i1;
      HEAP32[i28 >> 2] = i13;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i4;
    i7 = HEAP32[i28 >> 2] | 0;
    HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
    i13 = i8;
    i3 = i7;
   } else i13 = i2;
   i9 = i9 + 1 | 0;
   if ((i9 | 0) == (i11 | 0)) break; else i2 = i13;
  }
  i1 = HEAP8[i17 + 33 >> 0] | 0;
  i4 = HEAP16[i17 + 34 >> 1] | 0;
  i2 = i4 & 255;
  i4 = (i4 & 65535) > 255;
  switch (i13 | 0) {
  case 0:
   {
    i22 = 23;
    break L1;
   }
  case 1:
   {
    if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(1.0)) {
     i1 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
     if (!i1) break L1;
     mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i17 | 0, i18 | 0, i21 | 0);
     break L1;
    }
    break;
   }
  default:
   {}
  }
  i11 = gb + 64016 | 0;
  i15 = HEAP32[i11 + 4 >> 2] | 0;
  i14 = i16;
  HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i20 >> 2] = gb + 175924 + 8;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i16);
  i14 = i19;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i11 = i20 + 4 | 0;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i11 + 4 >> 2] = i15;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  __ZN7mecanim20ValueArrayBlendBeginERNS_14ValueArrayMaskE(HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0);
  i11 = i1 << 24 >> 24 != 0;
  if (!(i2 << 24 >> 24 == 0 & (i11 ^ 1))) {
   i15 = i2 << 24 >> 24 != 0;
   __ZN7mecanim9animation22MotionOutputBlendBeginEPNS0_12MotionOutputEbb(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i11, i15);
   if (i15) {
    __ZN7mecanim5human19HumanPoseBlendBeginERNS0_9HumanPoseE(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0);
    i3 = HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0;
    if (i3 | 0) __ZN7mecanim5human19HumanPoseBlendBeginERNS0_9HumanPoseE(i3);
   }
  }
  i12 = __ZN7mecanim22CreateValueArrayWeightEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i17 >> 2] | 0, i20) | 0;
  i9 = i2 << 24 >> 24 != 0;
  i10 = __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE(HEAP32[i17 >> 2] | 0, i11, i9, i4, i20) | 0;
  L39 : do if ((i13 | 0) > 0) {
   i7 = i16 + 4 | 0;
   i8 = i21 + 4 | 0;
   i6 = i18 + 8 | 0;
   if (!((i2 | i1) << 24 >> 24)) {
    i3 = 0;
    while (1) {
     f5 = Math_fround(HEAPF32[(HEAP32[i28 >> 2] | 0) + (i3 << 2) >> 2]);
     i4 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if (i4 | 0) {
      HEAPF32[i19 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i19 >> 2]));
      HEAP8[i7 >> 0] = 0;
      HEAP32[i16 >> 2] = i10;
      mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 72 >> 2] | 0, i4 | 0, i17 | 0, i18 | 0, i16 | 0);
      HEAP8[i8 >> 0] = HEAP8[i8 >> 0] | HEAP8[i7 >> 0];
      i14 = HEAP32[i21 >> 2] | 0;
      i15 = HEAP32[i16 >> 2] | 0;
      __ZN7mecanim19ValueArrayBlendNodeERNS_10ValueArrayERNS_16ValueArrayWeightERNS_14ValueArrayMaskERKS0_RKS4_f(HEAP32[i14 >> 2] | 0, i12, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, f5);
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i13 | 0)) break L39;
    }
   } else i4 = 0;
   do {
    f5 = Math_fround(HEAPF32[(HEAP32[i28 >> 2] | 0) + (i4 << 2) >> 2]);
    i3 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    if (i3 | 0) {
     HEAPF32[i19 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i19 >> 2]));
     HEAP8[i7 >> 0] = 0;
     HEAP32[i16 >> 2] = i10;
     mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i3 | 0, i17 | 0, i18 | 0, i16 | 0);
     HEAP8[i8 >> 0] = HEAP8[i8 >> 0] | HEAP8[i7 >> 0];
     i14 = HEAP32[i21 >> 2] | 0;
     i15 = HEAP32[i16 >> 2] | 0;
     __ZN7mecanim19ValueArrayBlendNodeERNS_10ValueArrayERNS_16ValueArrayWeightERNS_14ValueArrayMaskERKS0_RKS4_f(HEAP32[i14 >> 2] | 0, i12, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, f5);
     __ZN7mecanim9animation21MotionOutputBlendNodeEPNS0_12MotionOutputES2_fbbRKNS_6bitsetILj66EEE(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, f5, i11, i9, HEAP32[i6 >> 2] | 0);
     if (i9) {
      __ZN7mecanim5human18HumanPoseBlendNodeERNS0_9HumanPoseEPS1_f(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, f5);
      i3 = HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0;
      if (i3 | 0) __ZN7mecanim5human18HumanPoseBlendNodeERNS0_9HumanPoseEPS1_f(i3, HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, f5);
     }
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i13 | 0));
  } while (0);
  i4 = HEAP32[i21 >> 2] | 0;
  if (!(HEAP8[i18 + 4 >> 0] | 0)) i3 = HEAP32[i17 + 4 >> 2] | 0; else i3 = 0;
  __ZN7mecanim18ValueArrayBlendEndERNS_10ValueArrayERKNS_14ValueArrayMaskERKNS_16ValueArrayWeightEPKS0_(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i12, i3);
  if ((i2 | i1) << 24 >> 24) {
   __ZN7mecanim9animation20MotionOutputBlendEndEPNS0_12MotionOutputEbbRKNS_6bitsetILj66EEERf(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i11, i9, HEAP32[i18 + 8 >> 2] | 0, i19);
   if (i9) {
    __ZN7mecanim5human17HumanPoseBlendEndERNS0_9HumanPoseERf(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i19);
    i1 = HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0;
    if (i1 | 0) __ZN7mecanim5human17HumanPoseBlendEndERNS0_9HumanPoseERf(i1, i19);
   }
  }
  __ZN7mecanim23DestroyValueArrayWeightEPNS_16ValueArrayWeightERNS_6memory9AllocatorE(i12, i20);
  __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(i10, i20);
 } else {
  i2 = HEAP16[i17 + 34 >> 1] & 255;
  i1 = HEAP8[i17 + 33 >> 0] | 0;
  i22 = 23;
 } while (0);
 if ((i22 | 0) == 23) {
  __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0, 0);
  if ((i2 | i1) << 24 >> 24) {
   __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0);
   if (i2 << 24 >> 24) {
    __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0);
    i1 = HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0;
    if (i1 | 0) __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(i1);
   }
  }
 }
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i26);
  HEAP32[i28 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) <= -1) {
  STACKTOP = i29;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i24);
 HEAP32[i27 >> 2] = 0;
 STACKTOP = i29;
 return;
}

function __ZN6Camera20SetCameraShaderPropsER17ShaderPassContextRK21CameraRenderingParams(i15, i1, i16) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, d24 = 0.0, f25 = f0, f26 = f0, f27 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 352 | 0;
 i8 = i20 + 256 | 0;
 i9 = i20 + 192 | 0;
 i10 = i20 + 128 | 0;
 i11 = i20 + 64 | 0;
 i12 = i20;
 __ZN9ShaderLab28UpdateGlobalShaderPropertiesEf(Math_fround(-1.0));
 i18 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[i16 + 132 >> 2] | 0;
 i14 = HEAP32[i16 + 136 >> 2] | 0;
 HEAP32[i18 + 580 >> 2] = HEAP32[i16 + 128 >> 2];
 HEAP32[i18 + 584 >> 2] = i5;
 HEAP32[i18 + 588 >> 2] = i14;
 HEAPF32[i18 + 592 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i9, i17) | 0;
 __ZN10Matrix4x4fmLERKS_(i9, i16) | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i9, i10) | 0;
 i14 = i18 + 2020 | 0;
 i5 = i9;
 i13 = i14 + 64 | 0;
 do {
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  i14 = i14 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 i14 = i18 + 2084 | 0;
 i5 = i10;
 i13 = i14 + 64 | 0;
 do {
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  i14 = i14 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 HEAP32[i9 + 48 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 52 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 56 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[i17 + 8 >> 2] = Math_fround(1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i11, i17) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i9, i11, i12);
 __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i1 + 36 | 0, gb + 1110572 | 0, i12, 0);
 i5 = __Z12GetGfxDevicev() | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 132 >> 2] | 0, i5 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0, i14, i17);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i17, i8);
 i14 = i5 + 1364 | 0;
 HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i14 = i8 + 16 | 0;
 i13 = i5 + 1380 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i13 = i8 + 32 | 0;
 i14 = i5 + 1396 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i8 + 48 | 0;
 i13 = i5 + 1412 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i13 = i8 + 64 | 0;
 i14 = i5 + 1428 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i8 + 80 | 0;
 i5 = i5 + 1444 | 0;
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i5 = i15 + 1081 | 0;
 do if (!(HEAP8[i5 >> 0] | 0)) {
  i1 = __ZNK6Camera19GetProjectionMatrixEv(i15) | 0;
  if (!(Math_fround(HEAPF32[i1 + 16 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 32 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 36 >> 2]) != Math_fround(0.0))) {
   f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (!(f2 != Math_fround(0.0))) {
    f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
    if (!(f3 != Math_fround(0.0))) {
     f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     f22 = Math_fround(HEAPF32[i1 + 44 >> 2]);
     f21 = Math_fround(HEAPF32[i1 + 60 >> 2]);
     f4 = Math_fround(HEAPF32[i1 + 40 >> 2]);
     f6 = Math_fround(f2 + f6);
     f7 = Math_fround(f3 + f7);
     f4 = Math_fround(f22 + f4);
     f4 = Math_fround(Math_fround(-Math_fround(f21 + Math_fround(HEAPF32[i1 + 56 >> 2]))) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f4 * f4)))));
     break;
    }
   }
  }
  f4 = Math_fround(HEAPF32[i15 + 920 >> 2]);
 } else f4 = Math_fround(HEAPF32[i15 + 920 >> 2]); while (0);
 do if (!(HEAP8[i5 >> 0] | 0)) {
  i1 = __ZNK6Camera19GetProjectionMatrixEv(i15) | 0;
  if (!(Math_fround(HEAPF32[i1 + 16 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 32 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 + 36 >> 2]) != Math_fround(0.0))) {
   f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (!(f2 != Math_fround(0.0))) {
    f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
    if (!(f3 != Math_fround(0.0))) {
     f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     f22 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     f23 = Math_fround(HEAPF32[i1 + 44 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 60 >> 2]);
     f6 = Math_fround(HEAPF32[i1 + 40 >> 2]);
     f21 = Math_fround(f21 - f2);
     f22 = Math_fround(f22 - f3);
     f2 = Math_fround(f23 - f6);
     f2 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i1 + 56 >> 2])) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f2 * f2)))));
     break;
    }
   }
  }
  f2 = Math_fround(HEAPF32[i15 + 924 >> 2]);
 } else f2 = Math_fround(HEAPF32[i15 + 924 >> 2]); while (0);
 i14 = f4 == Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f4);
 f3 = i14 ? Math_fround(1.0) : f3;
 i14 = f2 == Math_fround(0.0);
 f23 = Math_fround(Math_fround(1.0) / f2);
 f23 = i14 ? Math_fround(1.0) : f23;
 HEAPF32[i18 + 612 >> 2] = HEAP8[i18 + 4380 >> 0] | 0 ? Math_fround(-1.0) : Math_fround(1.0);
 HEAPF32[i18 + 616 >> 2] = f4;
 HEAPF32[i18 + 620 >> 2] = f2;
 HEAPF32[i18 + 624 >> 2] = f23;
 __ZL19GetCameraTargetRectRK6Camerab(i17, i15, 1);
 f21 = Math_fround(HEAPF32[i15 + 864 >> 2]);
 f22 = Math_fround(HEAPF32[i15 + 868 >> 2]);
 f26 = Math_fround(HEAPF32[i15 + 872 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 876 >> 2]);
 f27 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f21 = Math_fround(f21 * f27);
 f26 = Math_fround(f26 * f27);
 f22 = Math_fround(f22 * f7);
 f6 = Math_fround(f6 * f7);
 f25 = Math_fround(HEAPF32[i17 >> 2]);
 f4 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f21 = Math_fround(f21 + f25);
 f22 = Math_fround(f22 + f4);
 f26 = Math_fround(f26 + f21);
 f6 = Math_fround(f6 + f22);
 f27 = Math_fround(f27 + f25);
 f7 = Math_fround(f7 + f4);
 f21 = Math_fround((f26 > f27 ? f27 : f26) - (f21 < f25 ? f25 : f21));
 i14 = f21 < Math_fround(0.0);
 f21 = i14 ? Math_fround(0.0) : f21;
 f22 = Math_fround((f6 > f7 ? f7 : f6) - (f22 < f4 ? f4 : f22));
 i14 = f22 < Math_fround(0.0);
 f22 = i14 ? Math_fround(0.0) : f22;
 f4 = Math_fround(Math_fround(Math_fround(1.0) / f21) + Math_fround(1.0));
 f6 = Math_fround(Math_fround(Math_fround(1.0) / f22) + Math_fround(1.0));
 HEAPF32[i18 + 628 >> 2] = f21;
 HEAPF32[i18 + 632 >> 2] = f22;
 HEAPF32[i18 + 636 >> 2] = f4;
 HEAPF32[i18 + 640 >> 2] = f6;
 f3 = Math_fround(f3 * f2);
 d24 = 1.0 - +f3;
 f6 = Math_fround(d24);
 f2 = Math_fround(d24 * +f23);
 f4 = Math_fround(f3 * f23);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 105 >> 0] | 0)) f7 = f6; else {
  f7 = Math_fround(-f6);
  f4 = Math_fround(f4 + f2);
  f3 = Math_fround(f3 + f6);
  f2 = Math_fround(-f2);
 }
 HEAPF32[i18 + 644 >> 2] = f7;
 HEAPF32[i18 + 648 >> 2] = f3;
 HEAPF32[i18 + 652 >> 2] = f2;
 HEAPF32[i18 + 656 >> 2] = f4;
 i5 = i16 + 64 | 0;
 if (Math_fround(HEAPF32[i16 + 76 >> 2]) != Math_fround(0.0)) i19 = 26; else if (Math_fround(HEAPF32[i16 + 92 >> 2]) != Math_fround(0.0)) i19 = 26; else if (Math_fround(HEAPF32[i16 + 108 >> 2]) != Math_fround(0.0)) i19 = 26; else {
  i16 = Math_fround(HEAPF32[i16 + 124 >> 2]) != Math_fround(1.0);
  f27 = Math_fround(HEAPF32[i15 + 916 >> 2]);
  f2 = Math_fround(f27 * Math_fround(HEAPF32[i15 + 1060 >> 2]));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  if (!i16) {
   f26 = f2;
   i13 = i1;
   f27 = Math_fround(1.0);
   i14 = i18 + 660 | 0;
   HEAPF32[i14 >> 2] = f26;
   i14 = i18 + 664 | 0;
   HEAP32[i14 >> 2] = i13;
   i14 = i18 + 668 | 0;
   HEAPF32[i14 >> 2] = Math_fround(0.0);
   i14 = i18 + 672 | 0;
   HEAPF32[i14 >> 2] = f27;
   __Z20InvertMatrix4x4_FullPKfPf(i5, i17) | 0;
   i14 = i18 + 2788 | 0;
   i13 = i14 + 64 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
    i14 = i14 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i14 | 0) < (i13 | 0));
   i14 = i18 + 2852 | 0;
   i5 = i17;
   i13 = i14 + 64 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
    i14 = i14 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i14 | 0) < (i13 | 0));
   STACKTOP = i20;
   return;
  }
 }
 if ((i19 | 0) == 26) {
  f27 = Math_fround(HEAPF32[i15 + 916 >> 2]);
  f2 = Math_fround(f27 * Math_fround(HEAPF32[i15 + 1060 >> 2]));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f26 = f2;
 i13 = i1;
 f27 = Math_fround(0.0);
 i14 = i18 + 660 | 0;
 HEAPF32[i14 >> 2] = f26;
 i14 = i18 + 664 | 0;
 HEAP32[i14 >> 2] = i13;
 i14 = i18 + 668 | 0;
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 i14 = i18 + 672 | 0;
 HEAPF32[i14 >> 2] = f27;
 __Z20InvertMatrix4x4_FullPKfPf(i5, i17) | 0;
 i14 = i18 + 2788 | 0;
 i13 = i14 + 64 | 0;
 do {
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  i14 = i14 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 i14 = i18 + 2852 | 0;
 i5 = i17;
 i13 = i14 + 64 | 0;
 do {
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  i14 = i14 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i14 | 0) < (i13 | 0));
 STACKTOP = i20;
 return;
}

function __Z23sweepCCTCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i9, i10, i25, i27, f21, i26, i24, f1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 f21 = Math_fround(f21);
 i26 = i26 | 0;
 i24 = i24 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 64 | 0;
 i16 = i23 + 126 | 0;
 i20 = i23 + 52 | 0;
 i19 = i23 + 40 | 0;
 i2 = i23 + 124 | 0;
 i8 = i23 + 12 | 0;
 i7 = i23;
 i6 = i25 + 12 | 0;
 f1 = Math_fround(HEAPF32[i25 >> 2]);
 if (f1 == Math_fround(HEAPF32[i6 >> 2])) {
  i18 = i25 + 4 | 0;
  f1 = Math_fround(HEAPF32[i18 >> 2]);
  if (f1 == Math_fround(HEAPF32[i25 + 16 >> 2])) {
   i17 = i25 + 8 | 0;
   f1 = Math_fround(HEAPF32[i17 >> 2]);
   if (f1 == Math_fround(HEAPF32[i25 + 20 >> 2])) {
    i12 = i22 + 36 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 + 16 >> 2];
    i13 = i22 + 40 | 0;
    HEAP32[i13 >> 2] = HEAP32[i10 + 20 >> 2];
    i14 = i22 + 44 | 0;
    HEAP32[i14 >> 2] = HEAP32[i10 + 24 >> 2];
    i15 = i22 + 48 | 0;
    HEAP32[i15 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i22 + 52 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i22 + 56 >> 2] = HEAP32[i9 + 12 >> 2];
    f31 = Math_fround(HEAPF32[i10 >> 2]);
    f30 = Math_fround(HEAPF32[i10 + 4 >> 2]);
    f37 = Math_fround(HEAPF32[i10 + 8 >> 2]);
    f32 = Math_fround(HEAPF32[i10 + 12 >> 2]);
    f1 = Math_fround(f31 + f31);
    f29 = Math_fround(f30 + f30);
    f34 = Math_fround(f37 + f37);
    f36 = Math_fround(f30 * f29);
    f35 = Math_fround(f37 * f34);
    f30 = Math_fround(f1 * f30);
    f38 = Math_fround(f1 * f37);
    f28 = Math_fround(f1 * f32);
    f37 = Math_fround(f29 * f37);
    f29 = Math_fround(f29 * f32);
    f32 = Math_fround(f34 * f32);
    f34 = Math_fround(f30 + f32);
    f33 = Math_fround(f38 - f29);
    f32 = Math_fround(f30 - f32);
    f1 = Math_fround(Math_fround(1.0) - Math_fround(f31 * f1));
    f31 = Math_fround(f1 - f35);
    f30 = Math_fround(f37 + f28);
    f29 = Math_fround(f38 + f29);
    f28 = Math_fround(f37 - f28);
    f1 = Math_fround(f1 - f36);
    HEAPF32[i22 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f36) - f35);
    i3 = i22 + 4 | 0;
    HEAPF32[i3 >> 2] = f34;
    i4 = i22 + 8 | 0;
    HEAPF32[i4 >> 2] = f33;
    i5 = i22 + 12 | 0;
    HEAPF32[i5 >> 2] = f32;
    i6 = i22 + 16 | 0;
    HEAPF32[i6 >> 2] = f31;
    i7 = i22 + 20 | 0;
    HEAPF32[i7 >> 2] = f30;
    i8 = i22 + 24 | 0;
    HEAPF32[i8 >> 2] = f29;
    i9 = i22 + 28 | 0;
    HEAPF32[i9 >> 2] = f28;
    i10 = i22 + 32 | 0;
    HEAPF32[i10 >> 2] = f1;
    f1 = Math_fround(HEAPF32[i25 + 24 >> 2]);
    i11 = i26 + 40 | 0;
    i2 = i26 + 28 | 0;
    HEAP16[i16 >> 1] = HEAP16[i24 >> 1] | 0;
    if (!(__ZN5physx2Gu14sweepBoxSphereERKNS0_3BoxEfRKNS_6PxVec3ES6_fRfRS4_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i22, f1, i25, i27, f21, i11, i2, i16) | 0)) {
     i27 = 0;
     STACKTOP = i23;
     return i27 | 0;
    }
    f36 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
    i39 = i26 + 32 | 0;
    f37 = Math_fround(-Math_fround(HEAPF32[i39 >> 2]));
    i16 = i26 + 36 | 0;
    f38 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
    HEAPF32[i2 >> 2] = f36;
    HEAPF32[i39 >> 2] = f37;
    HEAPF32[i16 >> 2] = f38;
    i2 = i26 + 12 | 0;
    HEAP16[i2 >> 1] = 6;
    if (HEAP16[i24 >> 1] & 1) {
     f38 = Math_fround(HEAPF32[i11 >> 2]);
     f36 = Math_fround(f38 * Math_fround(HEAPF32[i27 >> 2]));
     f37 = Math_fround(f38 * Math_fround(HEAPF32[i27 + 4 >> 2]));
     f38 = Math_fround(f38 * Math_fround(HEAPF32[i27 + 8 >> 2]));
     f36 = Math_fround(f36 + Math_fround(HEAPF32[i25 >> 2]));
     f37 = Math_fround(f37 + Math_fround(HEAPF32[i18 >> 2]));
     f38 = Math_fround(f38 + Math_fround(HEAPF32[i17 >> 2]));
     HEAPF32[i20 >> 2] = f36;
     HEAPF32[i20 + 4 >> 2] = f37;
     HEAPF32[i20 + 8 >> 2] = f38;
     Math_fround(__ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i20, i12, i15, i22, i19));
     f38 = Math_fround(HEAPF32[i19 >> 2]);
     f37 = Math_fround(f38 * Math_fround(HEAPF32[i22 >> 2]));
     f36 = Math_fround(f38 * Math_fround(HEAPF32[i3 >> 2]));
     f38 = Math_fround(f38 * Math_fround(HEAPF32[i4 >> 2]));
     i27 = i19 + 4 | 0;
     f35 = Math_fround(HEAPF32[i27 >> 2]);
     f33 = Math_fround(f35 * Math_fround(HEAPF32[i5 >> 2]));
     f34 = Math_fround(f35 * Math_fround(HEAPF32[i6 >> 2]));
     f33 = Math_fround(f37 + f33);
     f34 = Math_fround(f36 + f34);
     f35 = Math_fround(f38 + Math_fround(f35 * Math_fround(HEAPF32[i7 >> 2])));
     i39 = i19 + 8 | 0;
     f38 = Math_fround(HEAPF32[i39 >> 2]);
     f36 = Math_fround(f38 * Math_fround(HEAPF32[i8 >> 2]));
     f37 = Math_fround(f38 * Math_fround(HEAPF32[i9 >> 2]));
     f36 = Math_fround(f33 + f36);
     f37 = Math_fround(f34 + f37);
     f38 = Math_fround(f35 + Math_fround(f38 * Math_fround(HEAPF32[i10 >> 2])));
     HEAPF32[i19 >> 2] = f36;
     HEAPF32[i27 >> 2] = f37;
     HEAPF32[i39 >> 2] = f38;
     f36 = Math_fround(f36 + Math_fround(HEAPF32[i12 >> 2]));
     f37 = Math_fround(f37 + Math_fround(HEAPF32[i13 >> 2]));
     f38 = Math_fround(f38 + Math_fround(HEAPF32[i14 >> 2]));
     HEAPF32[i26 + 16 >> 2] = f36;
     HEAPF32[i26 + 20 >> 2] = f37;
     HEAPF32[i26 + 24 >> 2] = f38;
     HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 1;
    }
    i39 = 1;
    STACKTOP = i23;
    return i39 | 0;
   }
  }
 }
 i4 = i9 + 4 | 0;
 i5 = i26 + 16 | 0;
 i3 = i26 + 40 | 0;
 HEAP16[i2 >> 1] = HEAP16[i24 >> 1] | 0;
 if (!(__ZN5physx2Gu15sweepCapsuleBoxERKNS0_7CapsuleERKNS_11PxTransformERKNS_6PxVec3ES9_fRS7_RfSA_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i25, i10, i4, i27, f21, i5, i3, i26 + 28 | 0, i2) | 0)) {
  i39 = 0;
  STACKTOP = i23;
  return i39 | 0;
 }
 i2 = i26 + 12 | 0;
 HEAP16[i2 >> 1] = 6;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 if (!((HEAP16[i24 >> 1] & 1) != 0 & f1 != Math_fround(0.0))) {
  i39 = 1;
  STACKTOP = i23;
  return i39 | 0;
 }
 f35 = Math_fround(HEAPF32[i25 >> 2]);
 f36 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 i16 = i8 + 12 | 0;
 f33 = Math_fround(HEAPF32[i6 >> 2]);
 f37 = Math_fround(HEAPF32[i25 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 HEAP32[i8 + 24 >> 2] = HEAP32[i25 + 24 >> 2];
 f28 = Math_fround(f1 * Math_fround(HEAPF32[i27 >> 2]));
 f32 = Math_fround(f1 * Math_fround(HEAPF32[i27 + 4 >> 2]));
 f30 = Math_fround(f1 * Math_fround(HEAPF32[i27 + 8 >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f28 + f35);
 HEAPF32[i8 + 4 >> 2] = Math_fround(f32 + f36);
 HEAPF32[i8 + 8 >> 2] = Math_fround(f30 + f34);
 HEAPF32[i16 >> 2] = Math_fround(f28 + f33);
 HEAPF32[i8 + 16 >> 2] = Math_fround(f32 + f37);
 HEAPF32[i8 + 20 >> 2] = Math_fround(f30 + f29);
 i25 = i10 + 16 | 0;
 i17 = i22 + 36 | 0;
 HEAP32[i17 >> 2] = HEAP32[i25 >> 2];
 i27 = i10 + 20 | 0;
 HEAP32[i22 + 40 >> 2] = HEAP32[i27 >> 2];
 i39 = i10 + 24 | 0;
 HEAP32[i22 + 44 >> 2] = HEAP32[i39 >> 2];
 i24 = i22 + 48 | 0;
 HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i22 + 52 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i22 + 56 >> 2] = HEAP32[i9 + 12 >> 2];
 f29 = Math_fround(HEAPF32[i10 >> 2]);
 i19 = i10 + 4 | 0;
 f30 = Math_fround(HEAPF32[i19 >> 2]);
 i20 = i10 + 8 | 0;
 f37 = Math_fround(HEAPF32[i20 >> 2]);
 i18 = i10 + 12 | 0;
 f32 = Math_fround(HEAPF32[i18 >> 2]);
 f33 = Math_fround(f29 + f29);
 f28 = Math_fround(f30 + f30);
 f34 = Math_fround(f37 + f37);
 f36 = Math_fround(f30 * f28);
 f35 = Math_fround(f37 * f34);
 f30 = Math_fround(f33 * f30);
 f21 = Math_fround(f33 * f37);
 f31 = Math_fround(f33 * f32);
 f37 = Math_fround(f28 * f37);
 f28 = Math_fround(f28 * f32);
 f32 = Math_fround(f34 * f32);
 f34 = Math_fround(f30 + f32);
 f38 = Math_fround(f21 - f28);
 f32 = Math_fround(f30 - f32);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f29 * f33));
 f29 = Math_fround(f33 - f35);
 f30 = Math_fround(f37 + f31);
 f28 = Math_fround(f21 + f28);
 f31 = Math_fround(f37 - f31);
 f33 = Math_fround(f33 - f36);
 HEAPF32[i22 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f36) - f35);
 HEAPF32[i22 + 4 >> 2] = f34;
 HEAPF32[i22 + 8 >> 2] = f38;
 HEAPF32[i22 + 12 >> 2] = f32;
 HEAPF32[i22 + 16 >> 2] = f29;
 HEAPF32[i22 + 20 >> 2] = f30;
 HEAPF32[i22 + 24 >> 2] = f28;
 HEAPF32[i22 + 28 >> 2] = f31;
 HEAPF32[i22 + 32 >> 2] = f33;
 Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i8, i16, i17, i24, i22, 0, i7));
 f33 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(2.0));
 i22 = i7 + 4 | 0;
 f31 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(2.0));
 i24 = i7 + 8 | 0;
 f28 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(HEAPF32[i18 >> 2]);
 f29 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i10 >> 2]);
 f38 = Math_fround(f33 * f32);
 f34 = Math_fround(HEAPF32[i19 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f31 * f34));
 f35 = Math_fround(HEAPF32[i20 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f28 * f35));
 f36 = Math_fround(Math_fround(f32 * f38) + Math_fround(Math_fround(f33 * f29) + Math_fround(f30 * Math_fround(Math_fround(f28 * f34) - Math_fround(f31 * f35)))));
 f37 = Math_fround(Math_fround(f34 * f38) + Math_fround(Math_fround(f31 * f29) + Math_fround(f30 * Math_fround(Math_fround(f33 * f35) - Math_fround(f28 * f32)))));
 f38 = Math_fround(Math_fround(Math_fround(f28 * f29) + Math_fround(f30 * Math_fround(Math_fround(f31 * f32) - Math_fround(f33 * f34)))) + Math_fround(f35 * f38));
 HEAPF32[i7 >> 2] = f36;
 HEAPF32[i22 >> 2] = f37;
 HEAPF32[i24 >> 2] = f38;
 f36 = Math_fround(f36 + Math_fround(HEAPF32[i25 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i27 >> 2]));
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i39 >> 2]));
 HEAPF32[i5 >> 2] = f36;
 HEAPF32[i26 + 20 >> 2] = f37;
 HEAPF32[i26 + 24 >> 2] = f38;
 HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 1;
 i39 = 1;
 STACKTOP = i23;
 return i39 | 0;
}

function __ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf(i28, i2, i25, f38, i37, i40) {
 i28 = i28 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 f38 = Math_fround(f38);
 i37 = i37 | 0;
 i40 = i40 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i26 = 0, i27 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i39 = 0, i41 = 0, f42 = f0, i43 = 0, i44 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i41 + 52 | 0;
 i36 = i41 + 24 | 0;
 i39 = i41 + 16 | 0;
 i35 = i41;
 f5 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f38);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f38);
 f1 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f38);
 f34 = Math_fround(HEAPF32[i37 >> 2]);
 f31 = Math_fround(f5 * f34);
 f32 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f4 * f32));
 f33 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 if (Math_fround(f31 + Math_fround(f1 * f33)) >= Math_fround(0.0)) {
  f1 = Math_fround(-f1);
  f4 = Math_fround(-f4);
  f5 = Math_fround(-f5);
 }
 f21 = Math_fround(HEAPF32[i28 >> 2]);
 f22 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i28 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i28 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i28 + 20 >> 2]);
 f18 = Math_fround(HEAPF32[i28 + 24 >> 2]);
 f19 = Math_fround(HEAPF32[i28 + 28 >> 2]);
 f20 = Math_fround(HEAPF32[i28 + 32 >> 2]);
 f10 = Math_fround(f24 - f21);
 f11 = Math_fround(f16 - f22);
 f12 = Math_fround(f17 - f23);
 f13 = Math_fround(f18 - f21);
 f14 = Math_fround(f19 - f22);
 f15 = Math_fround(f20 - f23);
 f7 = Math_fround(Math_fround(f15 * f32) - Math_fround(f14 * f33));
 f8 = Math_fround(Math_fround(f13 * f33) - Math_fround(f15 * f34));
 f9 = Math_fround(Math_fround(f14 * f34) - Math_fround(f13 * f32));
 f6 = Math_fround(Math_fround(f12 * f9) + Math_fround(Math_fround(f10 * f7) + Math_fround(f11 * f8)));
 if (f6 > Math_fround(-9.99999974e-06) & f6 < Math_fround(9.99999974e-06)) {
  i40 = 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 f31 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f1 = Math_fround(f31 - f1);
 f30 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f4 = Math_fround(f30 - f4);
 f29 = Math_fround(HEAPF32[i25 >> 2]);
 f6 = Math_fround(Math_fround(1.0) / f6);
 f42 = Math_fround(Math_fround(f29 - f5) - f21);
 f5 = Math_fround(f4 - f22);
 f4 = Math_fround(f1 - f23);
 f7 = Math_fround(f6 * Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f8 * f5) + Math_fround(f7 * f42))));
 f1 = Math_fround(Math_fround(f12 * f5) - Math_fround(f11 * f4));
 f4 = Math_fround(Math_fround(f10 * f4) - Math_fround(f12 * f42));
 f5 = Math_fround(Math_fround(f11 * f42) - Math_fround(f10 * f5));
 f8 = Math_fround(f6 * Math_fround(Math_fround(f33 * f5) + Math_fround(Math_fround(f34 * f1) + Math_fround(f32 * f4))));
 i3 = f7 < Math_fround(0.0);
 if (!(i3 | f7 > Math_fround(1.0))) if (!(f8 < Math_fround(0.0) | Math_fround(f7 + f8) > Math_fround(1.0))) {
  f1 = Math_fround(f6 * Math_fround(Math_fround(f15 * f5) + Math_fround(Math_fround(f13 * f1) + Math_fround(f14 * f4))));
  if (f1 < Math_fround(0.0)) {
   i40 = 0;
   STACKTOP = i41;
   return i40 | 0;
  }
  HEAPF32[i40 >> 2] = f1;
  i40 = 1;
  STACKTOP = i41;
  return i40 | 0;
 }
 i2 = f8 < Math_fround(0.0);
 do if (i3) {
  if (i2) {
   f1 = Math_fround(Math_fround(Math_fround(1.0) - f7) - f8);
   f4 = Math_fround(Math_fround(Math_fround(f7 * f24) + Math_fround(f8 * f18)) + Math_fround(f1 * f21));
   f5 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f8 * f19)) + Math_fround(f1 * f22));
   f1 = Math_fround(Math_fround(Math_fround(f7 * f17) + Math_fround(f8 * f20)) + Math_fround(f1 * f23));
   f14 = Math_fround(f21 - f24);
   f15 = Math_fround(f22 - f16);
   f42 = Math_fround(f23 - f17);
   if (Math_fround(Math_fround(Math_fround(f14 * Math_fround(f4 - f24)) + Math_fround(f15 * Math_fround(f5 - f16))) + Math_fround(f42 * Math_fround(f1 - f17))) < Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f42 * f42))) {
    i3 = 1;
    i2 = 0;
    break;
   }
   f21 = Math_fround(f21 - f18);
   f24 = Math_fround(f22 - f19);
   f42 = Math_fround(f23 - f20);
   if (Math_fround(Math_fround(Math_fround(f21 * Math_fround(f4 - f18)) + Math_fround(f24 * Math_fround(f5 - f19))) + Math_fround(f42 * Math_fround(f1 - f20))) < Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f24 * f24)) + Math_fround(f42 * f42))) {
    i3 = 2;
    i2 = 0;
    break;
   } else {
    i2 = 0;
    i27 = 19;
    break;
   }
  }
  if (Math_fround(f7 + f8) > Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(1.0) - f7) - f8);
   f4 = Math_fround(Math_fround(Math_fround(f7 * f24) + Math_fround(f8 * f18)) + Math_fround(f1 * f21));
   f5 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f8 * f19)) + Math_fround(f1 * f22));
   f1 = Math_fround(Math_fround(Math_fround(f7 * f17) + Math_fround(f8 * f20)) + Math_fround(f1 * f23));
   if (Math_fround(Math_fround(Math_fround(f13 * Math_fround(f4 - f21)) + Math_fround(f14 * Math_fround(f5 - f22))) + Math_fround(f15 * Math_fround(f1 - f23))) < Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f15 * f15))) {
    i3 = 0;
    i2 = 2;
   } else {
    f22 = Math_fround(f18 - f24);
    f23 = Math_fround(f19 - f16);
    f42 = Math_fround(f20 - f17);
    if (Math_fround(Math_fround(Math_fround(f22 * Math_fround(f4 - f24)) + Math_fround(f23 * Math_fround(f5 - f16))) + Math_fround(f42 * Math_fround(f1 - f17))) < Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f23 * f23)) + Math_fround(f42 * f42))) {
     i3 = 1;
     i2 = 2;
    } else {
     i2 = 2;
     i27 = 19;
    }
   }
  } else {
   i3 = 2;
   i2 = 0;
  }
 } else if (i2) if (Math_fround(f7 + f8) > Math_fround(1.0)) {
  f1 = Math_fround(Math_fround(Math_fround(1.0) - f7) - f8);
  f4 = Math_fround(Math_fround(Math_fround(f7 * f24) + Math_fround(f8 * f18)) + Math_fround(f1 * f21));
  f5 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f8 * f19)) + Math_fround(f1 * f22));
  f1 = Math_fround(Math_fround(Math_fround(f7 * f17) + Math_fround(f8 * f20)) + Math_fround(f1 * f23));
  if (Math_fround(Math_fround(Math_fround(f10 * Math_fround(f4 - f21)) + Math_fround(f11 * Math_fround(f5 - f22))) + Math_fround(f12 * Math_fround(f1 - f23))) < Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f12 * f12))) {
   i3 = 0;
   i2 = 1;
  } else {
   f23 = Math_fround(f24 - f18);
   f24 = Math_fround(f16 - f19);
   f42 = Math_fround(f17 - f20);
   if (Math_fround(Math_fround(Math_fround(f23 * Math_fround(f4 - f18)) + Math_fround(f24 * Math_fround(f5 - f19))) + Math_fround(f42 * Math_fround(f1 - f20))) < Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f24 * f24)) + Math_fround(f42 * f42))) {
    i3 = 2;
    i2 = 1;
   } else {
    i2 = 1;
    i27 = 19;
   }
  }
 } else {
  i3 = 1;
  i2 = 0;
 } else {
  i3 = 2;
  i2 = 1;
 } while (0);
 if ((i27 | 0) == 19) {
  if (!(__ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_(i25, i37, Math_fround(3402823469999999843913219.0e14), i28 + (i2 * 12 | 0) | 0, f38, i26, 0) | 0)) {
   i40 = 0;
   STACKTOP = i41;
   return i40 | 0;
  }
  HEAP32[i40 >> 2] = HEAP32[i26 >> 2];
  i40 = 1;
  STACKTOP = i41;
  return i40 | 0;
 }
 i44 = HEAP32[i28 + (i2 * 12 | 0) >> 2] | 0;
 HEAP32[i36 >> 2] = i44;
 i43 = HEAP32[i28 + (i2 * 12 | 0) + 4 >> 2] | 0;
 HEAP32[i36 + 4 >> 2] = i43;
 i25 = HEAP32[i28 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i36 + 8 >> 2] = i25;
 i2 = i36 + 12 | 0;
 i26 = HEAP32[i28 + (i3 * 12 | 0) >> 2] | 0;
 HEAP32[i2 >> 2] = i26;
 i27 = HEAP32[i28 + (i3 * 12 | 0) + 4 >> 2] | 0;
 HEAP32[i36 + 16 >> 2] = i27;
 i28 = HEAP32[i28 + (i3 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i36 + 20 >> 2] = i28;
 HEAPF32[i36 + 24 >> 2] = f38;
 f6 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f29 - f6);
 f9 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f30 - f9);
 f10 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f1 = Math_fround(f31 - f10);
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f6);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f10);
 f7 = Math_fround(Math_fround(Math_fround(f5 * f6) + Math_fround(f4 * f9)) + Math_fround(f1 * f10));
 do if (!(f7 <= Math_fround(0.0))) {
  f8 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
  if (!(f7 >= f8)) {
   f42 = Math_fround(f7 / f8);
   f5 = Math_fround(f5 - Math_fround(f6 * f42));
   f4 = Math_fround(f4 - Math_fround(f9 * f42));
   f1 = Math_fround(f1 - Math_fround(f10 * f42));
   break;
  } else {
   f5 = Math_fround(f5 - f6);
   f4 = Math_fround(f4 - f9);
   f1 = Math_fround(f1 - f10);
   break;
  }
 } while (0);
 f4 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))) - f38) + Math_fround(-10.0));
 i44 = f4 > Math_fround(0.0);
 f4 = i44 ? f4 : Math_fround(0.0);
 f32 = Math_fround(f30 + Math_fround(f32 * f4));
 f42 = Math_fround(Math_fround(f33 * f4) + f31);
 HEAPF32[i35 >> 2] = Math_fround(f29 + Math_fround(f34 * f4));
 HEAPF32[i35 + 4 >> 2] = f32;
 HEAPF32[i35 + 8 >> 2] = f42;
 i2 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i35, i37, i36, i2, f38, i39) | 0;
 if (!i2) {
  i44 = 0;
  STACKTOP = i41;
  return i44 | 0;
 }
 f1 = Math_fround(HEAPF32[i39 >> 2]);
 if ((i2 | 0) != 1) {
  f42 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f1 = f1 < f42 ? f1 : f42;
 }
 f1 = Math_fround(f4 + f1);
 if (!(f1 >= Math_fround(0.0))) {
  i44 = 0;
  STACKTOP = i41;
  return i44 | 0;
 }
 HEAPF32[i40 >> 2] = f1;
 i44 = 1;
 STACKTOP = i41;
 return i44 | 0;
}

function __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 52 | 0;
 i15 = i19 + 28 | 0;
 i16 = i19 + 16 | 0;
 i17 = i19;
 i5 = i19 + 40 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i15, i1);
 i9 = i15 + 11 | 0;
 i12 = HEAP8[i9 >> 0] | 0;
 i2 = i12 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i15 >> 2] | 0 : i15;
 i8 = i15 + 4 | 0;
 i12 = i2 ? HEAP32[i8 >> 2] | 0 : i12 & 255;
 i2 = i1 + i12 | 0;
 if (i12 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i16, i15);
 i10 = i16 + 11 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i11 = i16 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (!((i2 ? i4 : i1 & 255) | 0)) i2 = i4; else {
  i2 = i2 ? i3 : i16;
  do {
   i12 = HEAP8[i2 >> 0] | 0;
   i1 = i12 << 24 >> 24;
   HEAP8[i2 >> 0] = (i12 + -65 & 255) < 26 ? i1 + 32 | 0 : i1;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i10 >> 0] | 0;
   i12 = i1 << 24 >> 24 < 0;
   i3 = HEAP32[i16 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
  } while ((i2 | 0) != ((i12 ? i3 : i16) + (i12 ? i4 : i1 & 255) | 0));
  i2 = i4;
 }
 i12 = i6 + 68 | 0;
 i7 = i1 << 24 >> 24 < 0;
 i4 = i7 ? i3 : i16;
 i2 = i7 ? i2 : i1 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i18 = 11;
 } else if (i2 >>> 0 < 11) {
  i3 = i17 + 11 | 0;
  HEAP8[i3 >> 0] = i2;
  if (!i2) i1 = i17; else {
   i1 = i17;
   i18 = 13;
  }
 } else i18 = 11;
 if ((i18 | 0) == 11) {
  i3 = i2 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i2;
  i3 = i17 + 11 | 0;
  i18 = 13;
 }
 if ((i18 | 0) == 13) _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_(i14, i12, i17);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i7 = HEAP32[i17 >> 2] | 0;
  i4 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i14);
 }
 if ((i1 | 0) != (i2 | 0)) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i19;
  return;
 }
 if ((__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i16, 47, 0) | 0) != -1) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i19;
  return;
 }
 i4 = HEAP8[i10 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
 i4 = i1 ? HEAP32[i11 >> 2] | 0 : i4 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i18 = 23;
 } else if (i4 >>> 0 < 11) {
  i3 = i17 + 11 | 0;
  HEAP8[i3 >> 0] = i4;
  if (!i4) i1 = i17; else {
   i1 = i17;
   i18 = 25;
  }
 } else i18 = 23;
 if ((i18 | 0) == 23) {
  i3 = i4 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i4;
  i3 = i17 + 11 | 0;
  i18 = 25;
 }
 if ((i18 | 0) == 25) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_(i14, i6 + 80 | 0, i17);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i7 = HEAP32[i17 >> 2] | 0;
  i4 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i14);
 }
 if ((i1 | 0) != (i2 | 0)) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i19;
  return;
 }
 __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i16);
 i7 = HEAP8[i5 + 11 >> 0] | 0;
 i7 = ((i7 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i7 & 255) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (i7) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i19;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i5 = i6 + 72 | 0;
 i2 = i1;
 L53 : do if ((i2 | 0) != (i5 | 0)) {
  i6 = i17 + 11 | 0;
  i7 = i17 + 4 | 0;
  while (1) {
   i3 = i2 + 16 | 0;
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   if (i4 << 24 >> 24 < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + 20 >> 2] | 0;
   } else i2 = i4 & 255;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i3, i2);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i17, i14);
   i20 = HEAP8[i9 >> 0] | 0;
   i2 = i20 << 24 >> 24 < 0;
   i4 = HEAP8[i6 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   if (((i2 ? HEAP32[i8 >> 2] | 0 : i20 & 255) | 0) == ((i3 ? HEAP32[i7 >> 2] | 0 : i4 & 255) | 0)) {
    i20 = (__Z7StrICmpPKcS0_(i2 ? HEAP32[i15 >> 2] | 0 : i15, i3 ? HEAP32[i17 >> 2] | 0 : i17) | 0) == 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    if (i20) break;
   } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i5 | 0)) break L53; else i1 = i2;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i17, i14);
  i2 = i17 + 11 | 0;
  i20 = HEAP8[i2 >> 0] | 0;
  i1 = i20 << 24 >> 24 < 0;
  i3 = i17 + 4 | 0;
  if ((i1 ? HEAP32[i3 >> 2] | 0 : i20 & 255) | 0) {
   i1 = i1 ? HEAP32[i17 >> 2] | 0 : i17;
   do {
    i9 = HEAP8[i1 >> 0] | 0;
    i20 = i9 << 24 >> 24;
    HEAP8[i1 >> 0] = (i9 + -65 & 255) < 26 ? i20 + 32 | 0 : i20;
    i1 = i1 + 1 | 0;
    i20 = HEAP8[i2 >> 0] | 0;
    i9 = i20 << 24 >> 24 < 0;
   } while ((i1 | 0) != ((i9 ? HEAP32[i17 >> 2] | 0 : i17) + (i9 ? HEAP32[i3 >> 2] | 0 : i20 & 255) | 0));
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i16, i17) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 } while (0);
 i4 = HEAP8[i10 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
 i4 = i1 ? HEAP32[i11 >> 2] | 0 : i4 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i18 = 50;
 } else if (i4 >>> 0 < 11) {
  i1 = i17 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i17; else {
   i2 = i17;
   i18 = 52;
  }
 } else i18 = 50;
 if ((i18 | 0) == 50) {
  i20 = i4 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i2;
  HEAP32[i17 + 8 >> 2] = i20 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i4;
  i1 = i17 + 11 | 0;
  i18 = 52;
 }
 if ((i18 | 0) == 52) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_(i14, i12, i17);
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i20 = HEAP32[i17 >> 2] | 0;
  i18 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 STACKTOP = i19;
 return;
}

function __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i2, i4, i5, i30, i40) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i30 = i30 | 0;
 i40 = i40 | 0;
 var f1 = f0, i3 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i4 & 983040 | 0) == 65536 & 0 == 0) {
  i3 = i4 & 65535;
  if (i3 >>> 0 > (HEAP32[i2 + 44 >> 2] | 0) >>> 0) {
   i40 = -2147483640;
   return i40 | 0;
  }
  i39 = _bitshift64Lshr(i4 | 0, i5 | 0, 48) | 0;
  getTempRet0() | 0;
  i2 = HEAP32[i2 + 48 >> 2] | 0;
  if ((i2 + (i3 * 104 | 0) | 0) == 0 ? 1 : (i39 | 0) != (HEAP32[i2 + (i3 * 104 | 0) + 92 >> 2] | 0)) {
   i40 = -2147483640;
   return i40 | 0;
  }
  f29 = Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 12 >> 2]);
  f32 = Math_fround(HEAPF32[i30 >> 2]);
  f29 = Math_fround(f29 - f32);
  f36 = Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 16 >> 2]);
  f33 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  f35 = Math_fround(f36 - f33);
  f31 = Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 20 >> 2]);
  f34 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  f31 = Math_fround(f31 - f34);
  f31 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f35 * f35)) + Math_fround(f31 * f31))));
  f32 = Math_fround(Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 44 >> 2]) - f32);
  f35 = Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 48 >> 2]);
  f33 = Math_fround(f35 - f33);
  f34 = Math_fround(Math_fround(HEAPF32[i2 + (i3 * 104 | 0) + 52 >> 2]) - f34);
  HEAPF32[i40 >> 2] = Math_fround(f36 + Math_fround(Math_fround(f31 / Math_fround(f31 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f33 * f33)) + Math_fround(f34 * f34)))))) * Math_fround(f35 - f36)));
  i40 = 1073741824;
  return i40 | 0;
 }
 if ((i4 | 0) == 0 & (i5 | 0) == 0) {
  i40 = -2147483640;
  return i40 | 0;
 }
 i25 = _bitshift64Lshr(i4 | 0, i5 | 0, 20) | 0;
 getTempRet0() | 0;
 i25 = i25 & 268435455;
 i39 = i4 & 65535;
 if (i25 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
  i40 = -2147483640;
  return i40 | 0;
 }
 i38 = _bitshift64Lshr(i4 | 0, i5 | 0, 48) | 0;
 getTempRet0() | 0;
 i21 = HEAP32[i2 + 20 >> 2] | 0;
 if ((HEAP32[i21 + (i25 * 56 | 0) + 4 >> 2] | 0) != (i38 | 0)) {
  i40 = -2147483640;
  return i40 | 0;
 }
 i2 = HEAP32[i21 + (i25 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i40 = -2147483640;
  return i40 | 0;
 }
 if (i39 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i40 = -2147483640;
  return i40 | 0;
 }
 i37 = HEAP32[i21 + (i25 * 56 | 0) + 16 >> 2] | 0;
 i17 = HEAP32[i21 + (i25 * 56 | 0) + 24 >> 2] | 0;
 i38 = i17 + (i39 * 12 | 0) | 0;
 i23 = HEAP16[i17 + (i39 * 12 | 0) + 10 >> 1] | 0;
 i18 = i23 << 16 >> 16 == 0;
 if (i18) f1 = Math_fround(3402823469999999843913219.0e14); else {
  i19 = HEAP32[i17 + (i39 * 12 | 0) + 4 >> 2] | 0;
  i20 = HEAP32[i21 + (i25 * 56 | 0) + 32 >> 2] | 0;
  i13 = HEAPU8[i37 + (i39 << 5) + 28 >> 0] | 0;
  i14 = i21 + (i25 * 56 | 0) + 20 | 0;
  i15 = i21 + (i25 * 56 | 0) + 28 | 0;
  f9 = Math_fround(HEAPF32[i30 >> 2]);
  f10 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  i16 = i23 & 65535;
  i12 = 0;
  do {
   i3 = i20 + (i19 + i12 << 2 << 1) | 0;
   i2 = HEAPU16[i3 >> 1] | 0;
   if (i2 >>> 0 < i13 >>> 0) i5 = (HEAP32[i14 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i5 = (HEAP32[i15 >> 2] | 0) + ((i2 - i13 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
   f7 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   i2 = HEAPU16[i3 + 2 >> 1] | 0;
   if (i2 >>> 0 < i13 >>> 0) i4 = (HEAP32[i14 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i4 = (HEAP32[i15 >> 2] | 0) + ((i2 - i13 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
   f1 = Math_fround(HEAPF32[i4 >> 2]);
   f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   i2 = HEAPU16[i3 + 4 >> 1] | 0;
   if (i2 >>> 0 < i13 >>> 0) i2 = (HEAP32[i14 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i2 = (HEAP32[i15 >> 2] | 0) + ((i2 - i13 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
   f28 = Math_fround(HEAPF32[i2 >> 2]);
   f28 = Math_fround(f28 - f7);
   f29 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f8);
   f31 = Math_fround(f1 - f7);
   f33 = Math_fround(f6 - f8);
   f32 = Math_fround(f9 - f7);
   f35 = Math_fround(f10 - f8);
   f34 = Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29));
   f36 = Math_fround(Math_fround(f28 * f31) + Math_fround(f29 * f33));
   f6 = Math_fround(Math_fround(f28 * f32) + Math_fround(f29 * f35));
   f1 = Math_fround(Math_fround(f31 * f31) + Math_fround(f33 * f33));
   f35 = Math_fround(Math_fround(f31 * f32) + Math_fround(f33 * f35));
   f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f34 * f1) - Math_fround(f36 * f36)));
   f1 = Math_fround(f33 * Math_fround(Math_fround(f1 * f6) - Math_fround(f36 * f35)));
   f6 = Math_fround(f33 * Math_fround(Math_fround(f34 * f35) - Math_fround(f36 * f6)));
   if (!(!(f6 >= Math_fround(-.0000999999974)) | !(f1 >= Math_fround(-.0000999999974)) | !(Math_fround(f1 + f6) <= Math_fround(1.00010002)))) {
    i22 = 19;
    break;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) < (i16 | 0));
  if ((i22 | 0) == 19) {
   f36 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f35 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   HEAPF32[i40 >> 2] = Math_fround(Math_fround(f6 * Math_fround(f35 - f36)) + Math_fround(f36 + Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) - f36))));
   i40 = 1073741824;
   return i40 | 0;
  }
  if (i18) f1 = Math_fround(3402823469999999843913219.0e14); else {
   i13 = HEAP32[i17 + (i39 * 12 | 0) + 4 >> 2] | 0;
   i14 = HEAP32[i21 + (i25 * 56 | 0) + 32 >> 2] | 0;
   i15 = HEAPU8[i37 + (i39 << 5) + 28 >> 0] | 0;
   i16 = i21 + (i25 * 56 | 0) + 20 | 0;
   i12 = i21 + (i25 * 56 | 0) + 28 | 0;
   f36 = Math_fround(HEAPF32[i30 >> 2]);
   f35 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   i5 = i23 & 65535;
   i4 = 0;
   f1 = Math_fround(3402823469999999843913219.0e14);
   f6 = Math_fround(3402823469999999843913219.0e14);
   do {
    i3 = i14 + (i13 + i4 << 2 << 1) | 0;
    i2 = HEAPU16[i3 >> 1] | 0;
    if (i2 >>> 0 < i15 >>> 0) i2 = (HEAP32[i16 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i2 = (HEAP32[i12 >> 2] | 0) + ((i2 - i15 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
    f24 = Math_fround(HEAPF32[i2 >> 2]);
    f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
    f29 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    i2 = HEAPU16[i3 + 2 >> 1] | 0;
    if (i2 >>> 0 < i15 >>> 0) i2 = (HEAP32[i16 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i2 = (HEAP32[i12 >> 2] | 0) + ((i2 - i15 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
    f31 = Math_fround(HEAPF32[i2 >> 2]);
    f33 = Math_fround(HEAPF32[i2 + 8 >> 2]);
    f34 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    i2 = HEAPU16[i3 + 4 >> 1] | 0;
    if (i2 >>> 0 < i15 >>> 0) i2 = (HEAP32[i16 >> 2] | 0) + ((HEAPU16[i37 + (i39 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0; else i2 = (HEAP32[i12 >> 2] | 0) + ((i2 - i15 + (HEAP32[i38 >> 2] | 0) | 0) * 3 << 2) | 0;
    f27 = Math_fround(HEAPF32[i2 >> 2]);
    f28 = Math_fround(HEAPF32[i2 + 8 >> 2]);
    f32 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f7 = Math_fround(f24 - f27);
    f8 = Math_fround(f26 - f28);
    f10 = Math_fround(f36 - f27);
    f11 = Math_fround(f35 - f28);
    f9 = Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8));
    if (f9 == Math_fround(0.0)) {
     f8 = Math_fround(0.0);
     f7 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
    } else {
     f9 = Math_fround(Math_fround(Math_fround(f7 * f10) + Math_fround(f8 * f11)) / f9);
     i30 = f9 < Math_fround(0.0);
     i25 = f9 > Math_fround(1.0);
     f9 = i25 ? Math_fround(1.0) : f9;
     f9 = i30 ? Math_fround(0.0) : f9;
     f10 = Math_fround(Math_fround(f7 * f9) - f10);
     f7 = Math_fround(Math_fround(f8 * f9) - f11);
     f8 = f9;
     f7 = Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7));
    }
    if (f7 < f6) {
     f1 = Math_fround(f32 + Math_fround(f8 * Math_fround(f29 - f32)));
     f6 = f7;
    }
    f8 = Math_fround(f31 - f24);
    f10 = Math_fround(f33 - f26);
    f11 = Math_fround(f36 - f24);
    f9 = Math_fround(f35 - f26);
    f7 = Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10));
    if (f7 == Math_fround(0.0)) {
     f8 = Math_fround(0.0);
     f7 = Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9));
    } else {
     f24 = Math_fround(Math_fround(Math_fround(f8 * f11) + Math_fround(f10 * f9)) / f7);
     i30 = f24 < Math_fround(0.0);
     i25 = f24 > Math_fround(1.0);
     f24 = i25 ? Math_fround(1.0) : f24;
     f24 = i30 ? Math_fround(0.0) : f24;
     f26 = Math_fround(Math_fround(f8 * f24) - f11);
     f7 = Math_fround(Math_fround(f10 * f24) - f9);
     f8 = f24;
     f7 = Math_fround(Math_fround(f26 * f26) + Math_fround(f7 * f7));
    }
    if (f7 < f6) {
     f1 = Math_fround(f29 + Math_fround(f8 * Math_fround(f34 - f29)));
     f11 = f7;
    } else f11 = f6;
    f10 = Math_fround(f27 - f31);
    f7 = Math_fround(f28 - f33);
    f9 = Math_fround(f36 - f31);
    f8 = Math_fround(f35 - f33);
    f6 = Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7));
    if (f6 == Math_fround(0.0)) {
     f7 = Math_fround(0.0);
     f6 = Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8));
    } else {
     f31 = Math_fround(Math_fround(Math_fround(f10 * f9) + Math_fround(f7 * f8)) / f6);
     i30 = f31 < Math_fround(0.0);
     i25 = f31 > Math_fround(1.0);
     f31 = i25 ? Math_fround(1.0) : f31;
     f31 = i30 ? Math_fround(0.0) : f31;
     f33 = Math_fround(Math_fround(f10 * f31) - f9);
     f6 = Math_fround(Math_fround(f7 * f31) - f8);
     f7 = f31;
     f6 = Math_fround(Math_fround(f33 * f33) + Math_fround(f6 * f6));
    }
    if (f6 < f11) f1 = Math_fround(f34 + Math_fround(f7 * Math_fround(f32 - f34))); else f6 = f11;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i5 | 0));
  }
 }
 HEAPF32[i40 >> 2] = f1;
 i40 = 1073741824;
 return i40 | 0;
}

function __ZN5physx2Sc9ShapeCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i16 >> 2] = HEAP32[gb + 130500 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 130500 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 130500 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 130500 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 130500 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 130500 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 130500 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 130500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 130532 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 130532 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 130532 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 130532 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 130532 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 130532 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 130532 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 130532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 130564 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 130564 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 130564 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 130564 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 130564 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 130564 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 130564 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 130564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 130596 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 130596 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 130596 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 130596 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 130596 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 130596 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 130596 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 130596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 130628 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 130628 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 130628 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 130628 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 130628 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 130628 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 130628 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 130628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 130660 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 130660 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 130660 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 130660 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 130660 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 130660 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 130660 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 130660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 130692 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 130692 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 130692 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 130692 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 130692 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 130692 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 130692 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 130692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 130724 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 130724 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 130724 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 130724 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 130724 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 130724 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 130724 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 130724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 130756 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 130756 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 130756 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 130756 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 130756 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 130756 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 130756 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 130756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 130788 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 130788 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 130788 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 130788 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 130788 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 130788 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 130788 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 130788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 130820 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 130820 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 130820 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 130820 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 130820 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 130820 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 130820 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 130820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 130852 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 130852 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 130852 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 130852 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 130852 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 130852 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 130852 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 130852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 130884 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 130884 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 130884 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 130884 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 130884 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 130884 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 130884 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 130884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 130916 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 130916 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 130916 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 130916 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 130916 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 130916 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 130916 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 130916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 130948 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 130948 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 130948 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 130948 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 130948 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 130948 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 130948 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 130948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 130980 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 130980 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 130980 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 130980 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 130980 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 130980 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 130980 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 130980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 131012 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 131012 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 131012 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 131012 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 131012 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 131012 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 131012 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 131012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 131044 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 131044 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 131044 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 131044 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 131044 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 131044 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 131044 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 131044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 131076 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 131076 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 131076 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 131076 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 131076 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 131076 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 131076 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 131076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN16ReflectionProbes16GetClosestProbesERK4AABBP9Transform20ReflectionProbeUsageR13dynamic_arrayI24ReflectionProbeBlendInfoLj4EE(i4, i1, i2, i27, i30) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i30 = i30 | 0;
 var f3 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i32 + 100 | 0;
 i28 = i32 + 48 | 0;
 i23 = i32 + 24 | 0;
 i24 = i32 + 72 | 0;
 i29 = i32;
 if (!i27) {
  STACKTOP = i32;
  return;
 }
 i25 = i30 + 16 | 0;
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i30 + 4 | 0);
  HEAP32[i30 >> 2] = 0;
 }
 HEAP32[i30 >> 2] = 0;
 i31 = i30 + 12 | 0;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i25 >> 2] = 0;
 i2 = __Z29FindReflectionProbeFromAnchorP9TransformRK4AABBRS1_RsS5_(i2, i1, i23, i26, i28) | 0;
 L7 : do if (!i2) {
  i22 = i4 + 12 | 0;
  i18 = i4 + 24 | 0;
  if (HEAP32[i18 >> 2] | 0) {
   i19 = i26 + 4 | 0;
   i20 = i26 + 8 | 0;
   i15 = i28 + 4 | 0;
   i17 = i28 + 8 | 0;
   i13 = i28 + 12 | 0;
   i14 = i28 + 16 | 0;
   i16 = i28 + 20 | 0;
   i21 = i30 + 4 | 0;
   i12 = HEAP32[i22 >> 2] | 0;
   do {
    i1 = HEAP32[i12 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f36 = Math_fround(HEAPF32[i26 >> 2]);
    f36 = Math_fround(f36 + Math_fround(HEAPF32[i1 + 76 >> 2]));
    f35 = Math_fround(HEAPF32[i19 >> 2]);
    f35 = Math_fround(f35 + Math_fround(HEAPF32[i1 + 80 >> 2]));
    f34 = Math_fround(HEAPF32[i20 >> 2]);
    f34 = Math_fround(f34 + Math_fround(HEAPF32[i1 + 84 >> 2]));
    f8 = Math_fround(HEAPF32[i1 + 64 >> 2]);
    f10 = Math_fround(HEAPF32[i1 + 68 >> 2]);
    f8 = Math_fround(f8 * Math_fround(.5));
    f10 = Math_fround(f10 * Math_fround(.5));
    f3 = Math_fround(Math_fround(HEAPF32[i1 + 72 >> 2]) * Math_fround(.5));
    i5 = f8 < Math_fround(0.0);
    f33 = Math_fround(-f8);
    i6 = f10 < Math_fround(0.0);
    f9 = Math_fround(-f10);
    i7 = f3 < Math_fround(0.0);
    f11 = Math_fround(-f3);
    HEAPF32[i28 >> 2] = f36;
    HEAPF32[i15 >> 2] = f35;
    HEAPF32[i17 >> 2] = f34;
    HEAPF32[i13 >> 2] = i5 ? f33 : f8;
    HEAPF32[i14 >> 2] = i6 ? f9 : f10;
    HEAPF32[i16 >> 2] = i7 ? f11 : f3;
    f3 = Math_fround(__ZL23CalculateProbeInfluenceRK4AABBS1_(i23, i28));
    if (f3 > Math_fround(0.0)) {
     i4 = HEAP32[i31 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i25 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i25 >> 2] = i2;
       HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i2 << 3, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i31 >> 2] << 3 | 0) | 0;
       HEAP32[i25 >> 2] = i2;
       HEAP32[i30 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i31 >> 2] = i5;
     i7 = HEAP32[i30 >> 2] | 0;
     HEAP32[i7 + (i4 << 3) >> 2] = i1;
     HEAPF32[i7 + (i4 << 3) + 4 >> 2] = f3;
    }
    i12 = i12 + 4 | 0;
   } while ((i12 | 0) != ((HEAP32[i22 >> 2] | 0) + (HEAP32[i18 >> 2] << 2) | 0));
  }
  i1 = HEAP32[i31 >> 2] | 0;
  if (i1 | 0) {
   i4 = HEAP32[i30 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   i21 = HEAP32[i23 + 12 >> 2] | 0;
   HEAP32[i24 + 12 >> 2] = i21;
   i22 = HEAP32[i23 + 16 >> 2] | 0;
   HEAP32[i24 + 16 >> 2] = i22;
   i25 = HEAP32[i23 + 20 >> 2] | 0;
   HEAP32[i24 + 20 >> 2] = i25;
   __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_(i4, i4 + (i1 << 3) | 0, i24);
   i4 = HEAP32[i30 >> 2] | 0;
   i1 = i4 + 4 | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i27 | 0) == 3) {
    HEAPF32[i1 >> 2] = Math_fround(1.0);
    i2 = HEAP32[i31 >> 2] | 0;
    if (i2 >>> 0 > 1) i1 = 1; else break;
    while (1) {
     HEAPF32[i4 + (i1 << 3) + 4 >> 2] = Math_fround(0.0);
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break L7;
    }
   }
   f11 = Math_fround(HEAPF32[i1 >> 2]);
   i23 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP16[i23 + 60 >> 1] | 0;
   __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i23 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f40 = Math_fround(HEAPF32[i26 >> 2]);
   f40 = Math_fround(f40 + Math_fround(HEAPF32[i23 + 76 >> 2]));
   f39 = Math_fround(HEAPF32[i26 + 4 >> 2]);
   f39 = Math_fround(f39 + Math_fround(HEAPF32[i23 + 80 >> 2]));
   f38 = Math_fround(HEAPF32[i26 + 8 >> 2]);
   f38 = Math_fround(f38 + Math_fround(HEAPF32[i23 + 84 >> 2]));
   f8 = Math_fround(HEAPF32[i23 + 64 >> 2]);
   f34 = Math_fround(HEAPF32[i23 + 68 >> 2]);
   f8 = Math_fround(f8 * Math_fround(.5));
   f34 = Math_fround(f34 * Math_fround(.5));
   f36 = Math_fround(Math_fround(HEAPF32[i23 + 72 >> 2]) * Math_fround(.5));
   i23 = f8 < Math_fround(0.0);
   f37 = Math_fround(-f8);
   i24 = f34 < Math_fround(0.0);
   f33 = Math_fround(-f34);
   i25 = f36 < Math_fround(0.0);
   f35 = Math_fround(-f36);
   HEAPF32[i28 >> 2] = f40;
   HEAPF32[i28 + 4 >> 2] = f39;
   HEAPF32[i28 + 8 >> 2] = f38;
   HEAPF32[i28 + 12 >> 2] = i23 ? f37 : f8;
   HEAPF32[i28 + 16 >> 2] = i24 ? f33 : f34;
   HEAPF32[i28 + 20 >> 2] = i25 ? f35 : f36;
   if ((HEAP32[i31 >> 2] | 0) >>> 0 > 1) {
    i1 = HEAP32[i30 >> 2] | 0;
    f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    i1 = HEAP16[(HEAP32[i1 + 8 >> 2] | 0) + 60 >> 1] | 0;
    i24 = HEAP32[(HEAP32[i30 >> 2] | 0) + 8 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i24 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f41 = Math_fround(HEAPF32[i26 >> 2]);
    f41 = Math_fround(f41 + Math_fround(HEAPF32[i24 + 76 >> 2]));
    f33 = Math_fround(HEAPF32[i26 + 4 >> 2]);
    f33 = Math_fround(f33 + Math_fround(HEAPF32[i24 + 80 >> 2]));
    f34 = Math_fround(HEAPF32[i26 + 8 >> 2]);
    f34 = Math_fround(f34 + Math_fround(HEAPF32[i24 + 84 >> 2]));
    f36 = Math_fround(HEAPF32[i24 + 64 >> 2]);
    f38 = Math_fround(HEAPF32[i24 + 68 >> 2]);
    f36 = Math_fround(f36 * Math_fround(.5));
    f38 = Math_fround(f38 * Math_fround(.5));
    f40 = Math_fround(Math_fround(HEAPF32[i24 + 72 >> 2]) * Math_fround(.5));
    i24 = f36 < Math_fround(0.0);
    f35 = Math_fround(-f36);
    i25 = f38 < Math_fround(0.0);
    f37 = Math_fround(-f38);
    i26 = f40 < Math_fround(0.0);
    f39 = Math_fround(-f40);
    HEAPF32[i29 >> 2] = f41;
    HEAPF32[i29 + 4 >> 2] = f33;
    HEAPF32[i29 + 8 >> 2] = f34;
    HEAPF32[i29 + 12 >> 2] = i24 ? f35 : f36;
    HEAPF32[i29 + 16 >> 2] = i25 ? f37 : f38;
    HEAPF32[i29 + 20 >> 2] = i26 ? f39 : f40;
   } else {
    HEAP32[i29 >> 2] = HEAP32[gb + 1155204 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
    HEAP32[i29 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
    f8 = Math_fround(0.0);
    i1 = -1;
   }
   f41 = Math_fround(Math_fround(Math_fround(f3 * Math_fround(2.0)) * Math_fround(f9 * Math_fround(2.0))) * Math_fround(f10 * Math_fround(2.0)));
   f3 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   f3 = f3 < f41 ? f41 : f3;
   do if (f8 > Math_fround(0.0)) {
    if ((i2 | 0) > (i1 | 0)) {
     f3 = Math_fround(f11 / f3);
     break;
    }
    if ((i1 | 0) > (i2 | 0)) {
     f3 = Math_fround(Math_fround(1.0) - Math_fround(f8 / f3));
     break;
    }
    if (__Z17IsContainedInAABBRK4AABBS1_(i28, i29) | 0) {
     f3 = Math_fround(f11 / f3);
     break;
    }
    if (__Z17IsContainedInAABBRK4AABBS1_(i29, i28) | 0) {
     f3 = Math_fround(Math_fround(1.0) - Math_fround(f8 / f3));
     break;
    } else {
     f3 = Math_fround(f11 / Math_fround(f11 + f8));
     break;
    }
   } else if ((i27 | 0) == 2) {
    f3 = Math_fround(f11 / f3);
    i29 = f3 < Math_fround(0.0);
    i28 = f3 > Math_fround(1.0);
    f3 = i28 ? Math_fround(1.0) : f3;
    f3 = i29 ? Math_fround(0.0) : f3;
   } else f3 = Math_fround(1.0); while (0);
   i4 = HEAP32[i30 >> 2] | 0;
   HEAPF32[i4 + 4 >> 2] = f3;
   i2 = HEAP32[i31 >> 2] | 0;
   if (i2 >>> 0 > 1) {
    HEAPF32[i4 + 12 >> 2] = Math_fround(Math_fround(1.0) - f3);
    if ((i2 | 0) != 2) {
     i1 = 2;
     do {
      HEAPF32[i4 + (i1 << 3) + 4 >> 2] = Math_fround(0.0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
    }
   }
  }
 } else {
  i4 = HEAP32[i31 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i25 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i25 >> 2] = i1;
    HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 3, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i30 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i29 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i31 >> 2] << 3 | 0) | 0;
    HEAP32[i25 >> 2] = i1;
    HEAP32[i30 >> 2] = i29;
    break;
   }
  } while (0);
  HEAP32[i31 >> 2] = i5;
  i31 = HEAP32[i30 >> 2] | 0;
  HEAP32[i31 + (i4 << 3) >> 2] = i2;
  HEAP32[i31 + (i4 << 3) + 4 >> 2] = 1065353216;
 } while (0);
 STACKTOP = i32;
 return;
}

function __ZN13InitialModule8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i9 = i12;
 __ZN14SafeBinaryRead10SetVersionEi(i11, 3);
 HEAP8[i10 + 4 >> 0] = 1;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i10, i11);
 i3 = i10 + 8 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620918 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 272 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620932 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 536 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620943 | 0, gb + 620954 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 692 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620969 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 956 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620979 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 1220 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620990 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 1484 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621001 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 1748 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621016 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 2012 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621031 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i10 + 2540 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621045 | 0, i6, i7, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i4 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i4 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i4 >>> 0) i8 = 60; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 60; else {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    }
   }
   if ((i8 | 0) == 60) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i5 = i10 + 2548 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621072 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i4 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 71; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 71; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 71) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 2552 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621088 | 0, i5, i7, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 >= i13 >>> 0) if ((i3 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 2553 | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621095 | 0, i5, i7, 0) | 0;
 if (i2 | 0) {
  do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 >= i13 >>> 0) if ((i3 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0) {
  i5 = i10 + 2544 | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621106 | 0, i6, i7, 0) | 0;
  if (i2 | 0) {
   do if ((i2 | 0) > 0) {
    i2 = i11 + 16 | 0;
    i13 = HEAP32[i11 + 20 >> 2] | 0;
    i3 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    do if (i3 >>> 0 < i13 >>> 0) i8 = 101; else {
     i4 = i3 + 4 | 0;
     if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
      i8 = 101;
      break;
     }
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i4;
    } while (0);
    if ((i8 | 0) == 101) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
    if (!(HEAP32[i11 >> 2] & 512)) break;
    HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i2 = HEAP32[i7 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i11 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 2) | 0)) {
  i3 = i10 + 2276 | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621122 | 0, gb + 620173 | 0, i7, 1) | 0;
  if (i2 | 0) {
   do if ((i2 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
    i2 = HEAP32[i7 >> 2] | 0;
    if (!i2) break;
    mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  STACKTOP = i12;
  return;
 }
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 621122 | 0, i6, i7, 0) | 0;
 if (!i2) f1 = Math_fround(0.0); else {
  do if ((i2 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   do if (i3 >>> 0 < i13 >>> 0) i8 = 114; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     i8 = 114;
     break;
    }
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 >> 2] = i4;
   } while (0);
   if ((i8 | 0) == 114) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i9, 4);
   if (!(HEAP32[i11 >> 2] & 512)) break;
   HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) mftCall_iii(i2 | 0, i9 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  f1 = Math_fround(HEAPF32[i9 >> 2]);
 }
 HEAP16[i10 + 2360 >> 1] = 0;
 HEAPF32[i10 + 2356 >> 2] = f1;
 HEAP8[i10 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i10 + 2276 | 0, i10 + 2364 | 0, f1, 0) | 0) & 1;
 STACKTOP = i12;
 return;
}

function _encode_mcu_huff(i22, i23) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i33 + 40 | 0;
 i30 = i33;
 i32 = HEAP32[i22 + 348 >> 2] | 0;
 i31 = i22 + 24 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i30 >> 2] = i2;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i24 = i30 + 4 | 0;
 HEAP32[i24 >> 2] = i1;
 i27 = i30 + 8 | 0;
 i28 = i32 + 12 | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
 i25 = i30 + 32 | 0;
 HEAP32[i25 >> 2] = i22;
 i29 = i22 + 188 | 0;
 if (HEAP32[i29 >> 2] | 0) if (!(HEAP32[i32 + 36 >> 2] | 0)) {
  i8 = HEAP32[i32 + 40 >> 2] | 0;
  i6 = i30 + 8 | 0;
  i7 = i30 + 12 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i5 = i1 >>> 0 < 128;
  i1 = i5 ? i26 : i2;
  i4 = HEAP32[i6 >> 2] << 7 | 127;
  if ((i3 | 0) > 0) {
   i3 = i3 + 7 | 0;
   do {
    i3 = i3 + -8 | 0;
    i21 = i4 >>> i3;
    i2 = i1 + 1 | 0;
    HEAP8[i1 >> 0] = i21;
    if ((i21 & 255 | 0) == 255) {
     HEAP8[i2 >> 0] = 0;
     i1 = i1 + 2 | 0;
    } else i1 = i2;
   } while ((i3 | 0) > 7);
  }
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  L12 : do if (i5) {
   i1 = i1 - i26 | 0;
   if (!i1) {
    i1 = HEAP32[i30 >> 2] | 0;
    break;
   }
   i5 = i26;
   i2 = HEAP32[i24 >> 2] | 0;
   i3 = HEAP32[i30 >> 2] | 0;
   while (1) {
    i4 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
    _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
    i3 = (HEAP32[i30 >> 2] | 0) + i4 | 0;
    HEAP32[i30 >> 2] = i3;
    i5 = i5 + i4 | 0;
    i2 = (HEAP32[i24 >> 2] | 0) - i4 | 0;
    HEAP32[i24 >> 2] = i2;
    if (!i2) {
     i21 = HEAP32[i25 >> 2] | 0;
     i2 = HEAP32[i21 + 24 >> 2] | 0;
     if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i21 | 0) | 0) << 24 >> 24)) break;
     i3 = HEAP32[i2 >> 2] | 0;
     HEAP32[i30 >> 2] = i3;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     HEAP32[i24 >> 2] = i2;
    }
    i1 = i1 - i4 | 0;
    if (!i1) {
     i1 = i3;
     break L12;
    }
   }
   i32 = 0;
   STACKTOP = i33;
   return i32 | 0;
  } else {
   HEAP32[i24 >> 2] = (HEAP32[i30 >> 2] | 0) - i1 + (HEAP32[i24 >> 2] | 0);
   HEAP32[i30 >> 2] = i1;
  } while (0);
  HEAP32[i30 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = -1;
  i21 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
  HEAP32[i24 >> 2] = i21;
  do if (!i21) {
   i21 = HEAP32[i25 >> 2] | 0;
   i1 = HEAP32[i21 + 24 >> 2] | 0;
   if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i21 | 0) | 0) << 24 >> 24)) {
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } else {
    i21 = HEAP32[i1 >> 2] | 0;
    HEAP32[i30 >> 2] = i21;
    HEAP32[i24 >> 2] = HEAP32[i1 + 4 >> 2];
    i1 = i21;
    break;
   }
  } else i1 = HEAP32[i30 >> 2] | 0; while (0);
  HEAP32[i30 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i8 + 208;
  i1 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
  HEAP32[i24 >> 2] = i1;
  do if (!i1) {
   i21 = HEAP32[i25 >> 2] | 0;
   i1 = HEAP32[i21 + 24 >> 2] | 0;
   if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i21 | 0) | 0) << 24 >> 24)) {
    i32 = 0;
    STACKTOP = i33;
    return i32 | 0;
   } else {
    HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i24 >> 2] = i1;
    break;
   }
  } while (0);
  if ((HEAP32[(HEAP32[i25 >> 2] | 0) + 228 >> 2] | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i30 + 16 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[(HEAP32[i25 >> 2] | 0) + 228 >> 2] | 0));
  }
 }
 i18 = i22 + 256 | 0;
 L43 : do if ((HEAP32[i18 >> 2] | 0) > 0) {
  i19 = i30 + 8 | 0;
  i20 = i30 + 12 | 0;
  i21 = i26;
  i17 = 0;
  L45 : while (1) {
   i16 = HEAP32[i22 + 260 + (i17 << 2) >> 2] | 0;
   i13 = HEAP32[i22 + 232 + (i16 << 2) >> 2] | 0;
   i15 = i23 + (i17 << 2) | 0;
   i10 = HEAP32[i15 >> 2] | 0;
   i16 = i30 + 16 + (i16 << 2) | 0;
   i6 = HEAP32[i32 + 44 + (HEAP32[i13 + 20 >> 2] << 2) >> 2] | 0;
   i13 = HEAP32[i32 + 60 + (HEAP32[i13 + 24 >> 2] << 2) >> 2] | 0;
   i11 = HEAP32[i13 + 960 >> 2] | 0;
   i12 = HEAP8[i13 + 1264 >> 0] | 0;
   i14 = i1 >>> 0 < 128;
   i3 = i14 ? i26 : HEAP32[i30 >> 2] | 0;
   i9 = (HEAP16[i10 >> 1] | 0) - (HEAP32[i16 >> 2] | 0) | 0;
   i5 = i9 >> 31;
   i4 = i5 + i9 | 0;
   i5 = HEAPU8[(i5 ^ i9) - i5 + (gb + 1478668) >> 0] | 0;
   i9 = HEAP8[i6 + 1024 + i5 >> 0] | 0;
   i2 = i9 + (HEAP32[i20 >> 2] | 0) | 0;
   i6 = HEAP32[i19 >> 2] << i9 | HEAP32[i6 + (i5 << 2) >> 2];
   if ((i2 | 0) > 15) {
    i9 = i6 >>> (i2 + -8 | 0);
    i1 = i3 + 1 | 0;
    HEAP8[i3 >> 0] = i9;
    if ((i9 & 255 | 0) == 255) {
     HEAP8[i1 >> 0] = 0;
     i1 = i3 + 2 | 0;
    }
    i2 = i2 + -16 | 0;
    i9 = i6 >>> i2;
    i3 = i1 + 1 | 0;
    HEAP8[i1 >> 0] = i9;
    if ((i9 & 255 | 0) == 255) {
     HEAP8[i3 >> 0] = 0;
     i3 = i1 + 2 | 0;
    }
   }
   i1 = i2 + i5 | 0;
   i2 = i6 << i5 | i4 & (1 << i5) + -1;
   if ((i1 | 0) > 15) {
    i9 = i2 >>> (i1 + -8 | 0);
    i4 = i3 + 1 | 0;
    HEAP8[i3 >> 0] = i9;
    if ((i9 & 255 | 0) == 255) {
     HEAP8[i4 >> 0] = 0;
     i4 = i3 + 2 | 0;
    }
    i1 = i1 + -16 | 0;
    i9 = i2 >>> i1;
    i3 = i4 + 1 | 0;
    HEAP8[i4 >> 0] = i9;
    if ((i9 & 255 | 0) == 255) {
     HEAP8[i3 >> 0] = 0;
     i9 = 1;
     i7 = 0;
     i3 = i4 + 2 | 0;
    } else {
     i9 = 1;
     i7 = 0;
    }
   } else {
    i9 = 1;
    i7 = 0;
   }
   while (1) {
    i8 = HEAP16[i10 + (HEAP32[gb + 15416 + (i9 << 2) >> 2] << 1) >> 1] | 0;
    i4 = i8 << 16 >> 16;
    if (!(i8 << 16 >> 16)) i4 = i7 + 1 | 0; else {
     i8 = i4 >> 31;
     i6 = i8 + i4 | 0;
     i8 = HEAPU8[(i8 ^ i4) - i8 + (gb + 1478668) >> 0] | 0;
     if ((i7 | 0) > 15) {
      i5 = i7;
      do {
       i1 = i1 + i12 | 0;
       i2 = i2 << i12 | i11;
       if ((i1 | 0) > 15) {
        i34 = i2 >>> (i1 + -8 | 0);
        i4 = i3 + 1 | 0;
        HEAP8[i3 >> 0] = i34;
        if ((i34 & 255 | 0) == 255) {
         HEAP8[i4 >> 0] = 0;
         i4 = i3 + 2 | 0;
        }
        i1 = i1 + -16 | 0;
        i34 = i2 >>> i1;
        i3 = i4 + 1 | 0;
        HEAP8[i4 >> 0] = i34;
        if ((i34 & 255 | 0) == 255) {
         HEAP8[i3 >> 0] = 0;
         i3 = i4 + 2 | 0;
        }
       }
       i5 = i5 + -16 | 0;
      } while ((i5 | 0) > 15);
      i4 = i7 & 15;
     } else i4 = i7;
     i4 = (i4 << 4) + i8 | 0;
     i34 = HEAP8[i13 + 1024 + i4 >> 0] | 0;
     i5 = (1 << i8) + -1 & i6;
     i1 = i34 + i1 | 0;
     i4 = i2 << i34 | HEAP32[i13 + (i4 << 2) >> 2];
     if ((i1 | 0) > 15) {
      i34 = i4 >>> (i1 + -8 | 0);
      i2 = i3 + 1 | 0;
      HEAP8[i3 >> 0] = i34;
      if ((i34 & 255 | 0) == 255) {
       HEAP8[i2 >> 0] = 0;
       i2 = i3 + 2 | 0;
      }
      i1 = i1 + -16 | 0;
      i34 = i4 >>> i1;
      i3 = i2 + 1 | 0;
      HEAP8[i2 >> 0] = i34;
      if ((i34 & 255 | 0) == 255) {
       HEAP8[i3 >> 0] = 0;
       i3 = i2 + 2 | 0;
      }
     }
     i1 = i1 + i8 | 0;
     i2 = i4 << i8 | i5;
     if ((i1 | 0) > 15) {
      i34 = i2 >>> (i1 + -8 | 0);
      i4 = i3 + 1 | 0;
      HEAP8[i3 >> 0] = i34;
      if ((i34 & 255 | 0) == 255) {
       HEAP8[i4 >> 0] = 0;
       i4 = i3 + 2 | 0;
      }
      i1 = i1 + -16 | 0;
      i34 = i2 >>> i1;
      i3 = i4 + 1 | 0;
      HEAP8[i4 >> 0] = i34;
      if ((i34 & 255 | 0) == 255) {
       HEAP8[i3 >> 0] = 0;
       i3 = i4 + 2 | 0;
       i4 = 0;
      } else i4 = 0;
     } else i4 = 0;
    }
    i9 = i9 + 1 | 0;
    if ((i9 | 0) == 64) break; else i7 = i4;
   }
   if ((i4 | 0) > 0) {
    i4 = HEAP8[i13 + 1024 >> 0] | 0;
    i1 = i4 + i1 | 0;
    i4 = i2 << i4 | HEAP32[i13 >> 2];
    if ((i1 | 0) > 15) {
     i34 = i4 >>> (i1 + -8 | 0);
     i2 = i3 + 1 | 0;
     HEAP8[i3 >> 0] = i34;
     if ((i34 & 255 | 0) == 255) {
      HEAP8[i2 >> 0] = 0;
      i2 = i3 + 2 | 0;
     }
     i1 = i1 + -16 | 0;
     i34 = i4 >>> i1;
     i3 = i2 + 1 | 0;
     HEAP8[i2 >> 0] = i34;
     if ((i34 & 255 | 0) == 255) {
      HEAP8[i3 >> 0] = 0;
      i3 = i2 + 2 | 0;
      i2 = i4;
     } else i2 = i4;
    } else i2 = i4;
   }
   HEAP32[i19 >> 2] = i2;
   HEAP32[i20 >> 2] = i1;
   if (i14) {
    i1 = i3 - i21 | 0;
    if (i1 | 0) {
     i5 = i26;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = HEAP32[i30 >> 2] | 0;
     do {
      i4 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
      _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
      i3 = (HEAP32[i30 >> 2] | 0) + i4 | 0;
      HEAP32[i30 >> 2] = i3;
      i5 = i5 + i4 | 0;
      i2 = (HEAP32[i24 >> 2] | 0) - i4 | 0;
      HEAP32[i24 >> 2] = i2;
      if (!i2) {
       i34 = HEAP32[i25 >> 2] | 0;
       i2 = HEAP32[i34 + 24 >> 2] | 0;
       if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i34 | 0) | 0) << 24 >> 24)) break L45;
       i3 = HEAP32[i2 >> 2] | 0;
       HEAP32[i30 >> 2] = i3;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       HEAP32[i24 >> 2] = i2;
      }
      i1 = i1 - i4 | 0;
     } while ((i1 | 0) != 0);
    }
   } else {
    HEAP32[i24 >> 2] = (HEAP32[i30 >> 2] | 0) - i3 + (HEAP32[i24 >> 2] | 0);
    HEAP32[i30 >> 2] = i3;
   }
   HEAP32[i16 >> 2] = HEAP16[HEAP32[i15 >> 2] >> 1];
   i17 = i17 + 1 | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   if ((i17 | 0) >= (HEAP32[i18 >> 2] | 0)) break L43;
  }
  i34 = 0;
  STACKTOP = i33;
  return i34 | 0;
 } while (0);
 i34 = HEAP32[i31 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i34 + 4 >> 2] = i1;
 HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
 i1 = HEAP32[i29 >> 2] | 0;
 if (!i1) {
  i34 = 1;
  STACKTOP = i33;
  return i34 | 0;
 }
 i3 = i32 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = i1;
  i34 = i32 + 40 | 0;
  HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1 & 7;
 } else i1 = i2;
 HEAP32[i3 >> 2] = i1 + -1;
 i34 = 1;
 STACKTOP = i33;
 return i34 | 0;
}

function __ZN13AvatarBuilder22RemoveAllNoneHumanLeafERNSt3__26vectorINS_14NamedTransformENS0_9allocatorIS2_EEEERK16HumanDescription(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i51 + 48 | 0;
 i36 = i51 + 32 | 0;
 i47 = i51;
 i48 = i51 + 16 | 0;
 i49 = i16 + 4 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = (HEAP32[i49 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i51;
  return;
 }
 i18 = i17 + 4 | 0;
 i19 = i47 + 12 | 0;
 i15 = i47 + 12 | 0;
 i20 = i25 + 4 | 0;
 i21 = i47 + 8 | 0;
 i22 = i47 + 4 | 0;
 i23 = i47 + 11 | 0;
 i24 = i48 + 12 | 0;
 i14 = i48 + 12 | 0;
 i26 = i25 + 4 | 0;
 i27 = i48 + 8 | 0;
 i28 = i48 + 4 | 0;
 i29 = i48 + 11 | 0;
 i30 = i25 + 4 | 0;
 i31 = i25 + 4 | 0;
 i32 = i25 + 4 | 0;
 i33 = i25 + 4 | 0;
 i34 = i47 + 12 | 0;
 i12 = i47 + 12 | 0;
 i35 = i25 + 4 | 0;
 i37 = i47 + 8 | 0;
 i38 = i47 + 4 | 0;
 i39 = i47 + 11 | 0;
 i40 = i36 + 12 | 0;
 i13 = i36 + 12 | 0;
 i41 = i25 + 4 | 0;
 i42 = i36 + 8 | 0;
 i43 = i36 + 4 | 0;
 i44 = i36 + 11 | 0;
 i45 = i25 + 4 | 0;
 i46 = i25 + 4 | 0;
 i1 = ((i1 >>> 0) / 36 | 0) + -1 | 0;
 while (1) {
  i11 = HEAP32[i2 + (i1 * 36 | 0) + 32 >> 2] | 0;
  i9 = i11 + 92 | 0;
  if ((HEAP32[i9 >> 2] | 0) < 1) i50 = 36; else {
   i10 = i11 + 80 | 0;
   i8 = 0;
   i7 = HEAP32[i49 >> 2] | 0;
   while (1) {
    i4 = i2 + (i1 * 36 | 0) | 0;
    i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    HEAP32[i47 >> 2] = 0;
    HEAP32[i47 + 4 >> 2] = 0;
    HEAP32[i47 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i34 >> 2] = i2;
    i5 = _strlen(i3) | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i47);
     i2 = HEAP32[i12 >> 2] | 0;
     i50 = 12;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i39 >> 0] = i5;
     if (!i5) i2 = i47; else {
      i2 = i47;
      i50 = 14;
     }
    } else i50 = 12;
    if ((i50 | 0) == 12) {
     i6 = i5 + 16 & -16;
     HEAP32[i25 >> 2] = 66;
     HEAP32[i35 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i47 >> 2] = i2;
     HEAP32[i37 >> 2] = i6 | -2147483648;
     HEAP32[i38 >> 2] = i5;
     i50 = 14;
    }
    if ((i50 | 0) == 14) {
     i50 = 0;
     _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
    i5 = HEAP8[i39 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i47 >> 2] | 0 : i47;
    i5 = i2 ? HEAP32[i38 >> 2] | 0 : i5 & 255;
    HEAP32[i36 >> 2] = 0;
    HEAP32[i36 + 4 >> 2] = 0;
    HEAP32[i36 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i40 >> 2] = i2;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i36);
     i2 = HEAP32[i13 >> 2] | 0;
     i50 = 18;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i44 >> 0] = i5;
     if (!i5) i2 = i36; else {
      i2 = i36;
      i50 = 20;
     }
    } else i50 = 18;
    if ((i50 | 0) == 18) {
     i6 = i5 + 16 & -16;
     HEAP32[i25 >> 2] = 66;
     HEAP32[i41 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i36 >> 2] = i2;
     HEAP32[i42 >> 2] = i6 | -2147483648;
     HEAP32[i43 >> 2] = i5;
     i50 = 20;
    }
    if ((i50 | 0) == 20) {
     i50 = 0;
     _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
    i6 = HEAP8[i44 >> 0] | 0;
    L28 : do if ((i4 | 0) == (i7 | 0)) i4 = i7; else {
     i3 = i6 & 255;
     if (i6 << 24 >> 24 >= 0) while (1) {
      i5 = HEAP8[i4 + 11 >> 0] | 0;
      i2 = i5 << 24 >> 24 < 0;
      if ((i3 | 0) == ((i2 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) | 0)) if (!(_strncmp(i36, i2 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0)) break L28;
      i4 = i4 + 36 | 0;
      if ((i4 | 0) == (i7 | 0)) {
       i4 = i7;
       break L28;
      }
     }
     i3 = HEAP32[i43 >> 2] | 0;
     i5 = HEAP32[i36 >> 2] | 0;
     while (1) {
      i52 = HEAP8[i4 + 11 >> 0] | 0;
      i2 = i52 << 24 >> 24 < 0;
      if ((i3 | 0) == ((i2 ? HEAP32[i4 + 4 >> 2] | 0 : i52 & 255) | 0)) if (!(_strncmp(i5, i2 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0)) break L28;
      i4 = i4 + 36 | 0;
      if ((i4 | 0) == (i7 | 0)) {
       i4 = i7;
       break;
      }
     }
    } while (0);
    if (i6 << 24 >> 24 < 0) {
     i52 = HEAP32[i36 >> 2] | 0;
     i7 = HEAP32[i13 >> 2] | 0;
     HEAP32[i25 >> 2] = 66;
     HEAP32[i45 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
    }
    if ((HEAP8[i39 >> 0] | 0) < 0) {
     i52 = HEAP32[i47 >> 2] | 0;
     i7 = HEAP32[i12 >> 2] | 0;
     HEAP32[i25 >> 2] = 66;
     HEAP32[i46 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
    }
    i3 = (i4 | 0) != (HEAP32[i49 >> 2] | 0);
    i2 = i8 + 1 | 0;
    if (i3 | (i2 | 0) >= (HEAP32[i9 >> 2] | 0)) break;
    i8 = i2;
    i2 = HEAP32[i16 >> 2] | 0;
    i7 = i4;
   }
   if (!i3) i50 = 36;
  }
  do if ((i50 | 0) == 36) {
   i50 = 0;
   i2 = HEAP32[i17 >> 2] | 0;
   i7 = HEAP32[i18 >> 2] | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
   HEAP32[i47 >> 2] = 0;
   HEAP32[i47 + 4 >> 2] = 0;
   HEAP32[i47 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i19 >> 2] = i3;
   i5 = _strlen(i4) | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i47);
    i3 = HEAP32[i15 >> 2] | 0;
    i50 = 39;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i23 >> 0] = i5;
    if (!i5) i3 = i47; else {
     i3 = i47;
     i50 = 41;
    }
   } else i50 = 39;
   if ((i50 | 0) == 39) {
    i52 = i5 + 16 & -16;
    HEAP32[i25 >> 2] = 66;
    HEAP32[i20 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i52, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i47 >> 2] = i3;
    HEAP32[i21 >> 2] = i52 | -2147483648;
    HEAP32[i22 >> 2] = i5;
    i50 = 41;
   }
   if ((i50 | 0) == 41) {
    i50 = 0;
    _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i5 = HEAP8[i23 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i47 >> 2] | 0 : i47;
   i5 = i3 ? HEAP32[i22 >> 2] | 0 : i5 & 255;
   HEAP32[i48 >> 2] = 0;
   HEAP32[i48 + 4 >> 2] = 0;
   HEAP32[i48 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i24 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i48);
    i3 = HEAP32[i14 >> 2] | 0;
    i50 = 45;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i29 >> 0] = i5;
    if (!i5) i3 = i48; else {
     i3 = i48;
     i50 = 47;
    }
   } else i50 = 45;
   if ((i50 | 0) == 45) {
    i52 = i5 + 16 & -16;
    HEAP32[i25 >> 2] = 66;
    HEAP32[i26 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i52, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i48 >> 2] = i3;
    HEAP32[i27 >> 2] = i52 | -2147483648;
    HEAP32[i28 >> 2] = i5;
    i50 = 47;
   }
   if ((i50 | 0) == 47) {
    i50 = 0;
    _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i6 = HEAP8[i29 >> 0] | 0;
   L71 : do if ((i2 | 0) != (i7 | 0)) {
    i4 = i6 & 255;
    if (i6 << 24 >> 24 >= 0) while (1) {
     i52 = HEAP8[i2 + 11 >> 0] | 0;
     i3 = i52 << 24 >> 24 < 0;
     if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i52 & 255) | 0)) if (!(_strncmp(i48, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L71;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = i7;
      break L71;
     }
    }
    i4 = HEAP32[i28 >> 2] | 0;
    i5 = HEAP32[i48 >> 2] | 0;
    while (1) {
     i52 = HEAP8[i2 + 11 >> 0] | 0;
     i3 = i52 << 24 >> 24 < 0;
     if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i52 & 255) | 0)) if (!(_strncmp(i5, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) break L71;
     i2 = i2 + 76 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = i7;
      break;
     }
    }
   } while (0);
   if (i6 << 24 >> 24 < 0) {
    i52 = HEAP32[i48 >> 2] | 0;
    i11 = HEAP32[i14 >> 2] | 0;
    HEAP32[i25 >> 2] = 66;
    HEAP32[i30 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
   }
   if ((HEAP8[i23 >> 0] | 0) < 0) {
    i52 = HEAP32[i47 >> 2] | 0;
    i11 = HEAP32[i15 >> 2] | 0;
    HEAP32[i25 >> 2] = 66;
    HEAP32[i31 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
   }
   if ((i2 | 0) == (HEAP32[i18 >> 2] | 0)) {
    i3 = (HEAP32[i16 >> 2] | 0) + (i1 * 36 | 0) | 0;
    i2 = i3 + 36 | 0;
    i4 = HEAP32[i49 >> 2] | 0;
    if ((i2 | 0) != (i4 | 0)) {
     do {
      __ZN13AvatarBuilder14NamedTransformaSERKS0_(i3, i2) | 0;
      i2 = i2 + 36 | 0;
      i3 = i3 + 36 | 0;
     } while ((i2 | 0) != (i4 | 0));
     i2 = HEAP32[i49 >> 2] | 0;
     if ((i2 | 0) == (i3 | 0)) break;
    }
    do {
     i4 = i2 + -36 | 0;
     HEAP32[i49 >> 2] = i4;
     i5 = i2 + -20 | 0;
     if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
      i52 = HEAP32[i5 >> 2] | 0;
      i11 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i25 >> 2] = 66;
      HEAP32[i32 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
     }
     if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
      i52 = HEAP32[i4 >> 2] | 0;
      i11 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i25 >> 2] = 66;
      HEAP32[i33 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i52, i25);
     }
     i2 = HEAP32[i49 >> 2] | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
  } while (0);
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= -1) break;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 STACKTOP = i51;
 return;
}

function __Z22sweepConvex_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i2, i3, i1, i5, i22, f19, i21, i10, f7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 f19 = Math_fround(f19);
 i21 = i21 | 0;
 i10 = i10 | 0;
 f7 = Math_fround(f7);
 var f4 = f0, f6 = f0, f8 = f0, f9 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i23 + 480 | 0;
 i25 = i23 + 256 | 0;
 i18 = i23 + 240 | 0;
 i34 = i23 + 80 | 0;
 i31 = i23 + 64 | 0;
 i30 = i23 + 496 | 0;
 i24 = i23 + 48 | 0;
 i26 = i23 + 272 | 0;
 i27 = i23 + 96 | 0;
 i17 = i23 + 32 | 0;
 i11 = i23 + 16 | 0;
 i20 = i23;
 i35 = (HEAP32[i1 + 32 >> 2] | 0) + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 i29 = i1 + 4 | 0;
 i42 = HEAP32[i29 + 4 >> 2] | 0;
 i43 = HEAP32[i29 + 8 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i34 + 4 >> 2] = i42;
 HEAP32[i34 + 8 >> 2] = i43;
 HEAPF32[i34 + 12 >> 2] = Math_fround(0.0);
 i43 = i1 + 16 | 0;
 i42 = HEAP32[i43 + 4 >> 2] | 0;
 i29 = HEAP32[i43 + 8 >> 2] | 0;
 i1 = HEAP32[i43 + 12 >> 2] | 0;
 HEAP32[i31 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i31 + 4 >> 2] = i42;
 HEAP32[i31 + 8 >> 2] = i29;
 HEAP32[i31 + 12 >> 2] = i1;
 i1 = i2 + 4 | 0;
 i29 = HEAP32[i1 >> 2] | 0;
 i3 = i3 + 16 | 0;
 f39 = Math_fround(HEAPF32[i3 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 i3 = i5 + 16 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f41 = Math_fround(-f13);
 f38 = Math_fround(-f14);
 f8 = Math_fround(-f15);
 f39 = Math_fround(f39 - f4);
 f37 = Math_fround(f37 - f6);
 f36 = Math_fround(f36 - f9);
 f12 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f40 = Math_fround(Math_fround(Math_fround(f39 * f41) + Math_fround(f37 * f38)) + Math_fround(f36 * f8));
 f33 = Math_fround(Math_fround(Math_fround(f40 * f41) + Math_fround(Math_fround(f12 * f39) + Math_fround(f16 * Math_fround(Math_fround(f36 * f38) - Math_fround(f37 * f8))))) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(Math_fround(f40 * f38) + Math_fround(Math_fround(f12 * f37) + Math_fround(f16 * Math_fround(Math_fround(f39 * f8) - Math_fround(f36 * f41))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f36) + Math_fround(f16 * Math_fround(Math_fround(f37 * f41) - Math_fround(f39 * f38)))) + Math_fround(f40 * f8)) * Math_fround(2.0));
 f40 = Math_fround(HEAPF32[i22 >> 2]);
 i3 = i22 + 4 | 0;
 f38 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = i22 + 8 | 0;
 f40 = Math_fround(f40 * f19);
 f38 = Math_fround(f38 * f19);
 f39 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f19);
 f41 = Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(f14 * f38)) + Math_fround(f15 * f39));
 f37 = Math_fround(Math_fround(Math_fround(f14 * f41) + Math_fround(Math_fround(f12 * f38) - Math_fround(f16 * Math_fround(Math_fround(f15 * f40) - Math_fround(f13 * f39))))) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f39) - Math_fround(f16 * Math_fround(Math_fround(f13 * f38) - Math_fround(f14 * f40)))) + Math_fround(f15 * f41)) * Math_fround(2.0));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f13 * f41) + Math_fround(Math_fround(f12 * f40) - Math_fround(f16 * Math_fround(Math_fround(f14 * f39) - Math_fround(f15 * f38))))) * Math_fround(2.0));
 HEAPF32[i24 + 4 >> 2] = f37;
 HEAPF32[i24 + 8 >> 2] = f36;
 HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i26, i35, i25, i34, i31);
 i2 = i27 + 64 | 0;
 HEAP32[i27 + 80 >> 2] = 4;
 HEAPF32[i27 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i27 >> 2] = f33;
 HEAPF32[i27 + 4 >> 2] = f32;
 HEAPF32[i27 + 8 >> 2] = f8;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 128 >> 2] = i29;
 i31 = i27 + 132 | 0;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAPF32[i27 + 96 >> 2] = f33;
 HEAPF32[i27 + 100 >> 2] = f32;
 HEAPF32[i27 + 104 >> 2] = f8;
 HEAPF32[i27 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 112 >> 2] = f33;
 HEAPF32[i27 + 116 >> 2] = f32;
 HEAPF32[i27 + 120 >> 2] = f8;
 HEAPF32[i27 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 16 >> 2] = i29;
 i31 = i27 + 20 | 0;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i27 + 32 >> 2] = i29;
 i29 = i27 + 36 | 0;
 HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i28 >> 2] = -1;
 HEAP32[i28 + 4 >> 2] = -1;
 HEAP32[i28 + 8 >> 2] = -1;
 HEAP32[i28 + 12 >> 2] = -1;
 HEAP32[i2 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 i2 = (HEAP16[i10 >> 1] & 512) != 0;
 if (!(__ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i27, i26, i18, i25, i24, i17, i20, i11, Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f7), i2) | 0)) {
  i43 = 0;
  STACKTOP = i23;
  return i43 | 0;
 }
 HEAP32[i21 + 8 >> 2] = -1;
 f40 = Math_fround(HEAPF32[i11 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f41 = Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(f14 * f39)) + Math_fround(f15 * f38));
 f8 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f13 * f41) + Math_fround(Math_fround(f12 * f40) + Math_fround(f16 * Math_fround(Math_fround(f14 * f38) - Math_fround(f15 * f39))))) * Math_fround(2.0)));
 f7 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f14 * f41) + Math_fround(Math_fround(f12 * f39) + Math_fround(f16 * Math_fround(Math_fround(f15 * f40) - Math_fround(f13 * f38))))) * Math_fround(2.0)));
 f6 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(Math_fround(f12 * f38) + Math_fround(f16 * Math_fround(Math_fround(f13 * f39) - Math_fround(f14 * f40)))) + Math_fround(f15 * f41)) * Math_fround(2.0)));
 i1 = i21 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 f41 = Math_fround(HEAPF32[i18 >> 2]);
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 if (!(f41 >= f4)) {
  HEAP16[i1 >> 1] = 7;
  f37 = Math_fround(HEAPF32[i20 >> 2]);
  f41 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f40 = Math_fround(Math_fround(Math_fround(f13 * f37) + Math_fround(f14 * f41)) + Math_fround(f15 * f36));
  f38 = Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(Math_fround(f12 * f37) + Math_fround(f16 * Math_fround(Math_fround(f14 * f36) - Math_fround(f15 * f41))))) * Math_fround(2.0));
  f39 = Math_fround(Math_fround(Math_fround(f14 * f40) + Math_fround(Math_fround(f12 * f41) + Math_fround(f16 * Math_fround(Math_fround(f15 * f37) - Math_fround(f13 * f36))))) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f36) + Math_fround(f16 * Math_fround(Math_fround(f13 * f41) - Math_fround(f14 * f37)))) + Math_fround(f15 * f40)) * Math_fround(2.0));
  f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f40 * f40) + Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39))))));
  f39 = Math_fround(-Math_fround(f37 * f39));
  f40 = Math_fround(-Math_fround(f37 * f40));
  f41 = Math_fround(f4 * f19);
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(f37 * f38));
  HEAPF32[i21 + 32 >> 2] = f39;
  HEAPF32[i21 + 36 >> 2] = f40;
  HEAPF32[i21 + 16 >> 2] = f8;
  HEAPF32[i21 + 20 >> 2] = f7;
  HEAPF32[i21 + 24 >> 2] = f6;
  HEAPF32[i21 + 40 >> 2] = f41;
  i43 = 1;
  STACKTOP = i23;
  return i43 | 0;
 }
 if (i2) {
  HEAP16[i1 >> 1] = 7;
  f38 = Math_fround(HEAPF32[i20 >> 2]);
  f37 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f41 = Math_fround(Math_fround(Math_fround(f13 * f38) + Math_fround(f14 * f37)) + Math_fround(f15 * f36));
  f39 = Math_fround(Math_fround(Math_fround(f13 * f41) + Math_fround(Math_fround(f12 * f38) + Math_fround(f16 * Math_fround(Math_fround(f14 * f36) - Math_fround(f15 * f37))))) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(Math_fround(f14 * f41) + Math_fround(Math_fround(f12 * f37) + Math_fround(f16 * Math_fround(Math_fround(f15 * f38) - Math_fround(f13 * f36))))) * Math_fround(2.0));
  f41 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f36) + Math_fround(f16 * Math_fround(Math_fround(f13 * f37) - Math_fround(f14 * f38)))) + Math_fround(f15 * f41)) * Math_fround(2.0));
  f38 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f41 * f41) + Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40))))));
  f40 = Math_fround(-Math_fround(f38 * f40));
  f41 = Math_fround(-Math_fround(f38 * f41));
  HEAPF32[i21 + 28 >> 2] = Math_fround(-Math_fround(f38 * f39));
  HEAPF32[i21 + 32 >> 2] = f40;
  HEAPF32[i21 + 36 >> 2] = f41;
  HEAPF32[i21 + 16 >> 2] = f8;
  HEAPF32[i21 + 20 >> 2] = f7;
  HEAPF32[i21 + 24 >> 2] = f6;
  HEAPF32[i21 + 40 >> 2] = f4;
  i43 = 1;
  STACKTOP = i23;
  return i43 | 0;
 } else {
  HEAPF32[i21 + 40 >> 2] = Math_fround(0.0);
  f39 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  f40 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  f41 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
  HEAPF32[i21 + 28 >> 2] = f39;
  HEAPF32[i21 + 32 >> 2] = f40;
  HEAPF32[i21 + 36 >> 2] = f41;
  i43 = 1;
  STACKTOP = i23;
  return i43 | 0;
 }
 return 0;
}

function __ZN13AvatarBuilder21IsValidHumanHierarchyERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i2, i42, i1, i45) {
 i2 = i2 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 i45 = i45 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i44 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i47 + 8 | 0;
 i44 = i47;
 i43 = i47 + 72 | 0;
 i37 = i47 + 56 | 0;
 i38 = i47 + 40 | 0;
 i39 = i47 + 24 | 0;
 i40 = i42 + 4 | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 L1 : do if ((HEAP32[i40 >> 2] | 0) != (i1 | 0)) {
  i36 = i2 + 12 | 0;
  i16 = i2 + 16 | 0;
  i17 = i37 + 12 | 0;
  i13 = i37 + 12 | 0;
  i18 = i43 + 4 | 0;
  i19 = i37 + 8 | 0;
  i20 = i37 + 4 | 0;
  i21 = i37 + 11 | 0;
  i22 = i43 + 4 | 0;
  i23 = i38 + 12 | 0;
  i14 = i38 + 12 | 0;
  i24 = i43 + 4 | 0;
  i25 = i38 + 8 | 0;
  i26 = i38 + 4 | 0;
  i27 = i39 + 12 | 0;
  i12 = i39 + 12 | 0;
  i28 = i43 + 4 | 0;
  i29 = i39 + 8 | 0;
  i30 = i39 + 4 | 0;
  i31 = i39 + 11 | 0;
  i32 = i38 + 11 | 0;
  i33 = i43 + 4 | 0;
  i34 = i43 + 4 | 0;
  i15 = i39 + 11 | 0;
  i35 = i39 + 11 | 0;
  i11 = 0;
  while (1) {
   i2 = i1;
   i1 = i2 + (i11 * 36 | 0) | 0;
   i9 = HEAP32[(HEAP32[i2 + (i11 * 36 | 0) + 32 >> 2] | 0) + 100 >> 2] | 0;
   if (i9 | 0) {
    i7 = HEAP32[i36 >> 2] | 0;
    i8 = HEAP32[i16 >> 2] | 0;
    i10 = i1 + 11 | 0;
    i4 = HEAP8[i10 >> 0] | 0;
    i6 = i4 << 24 >> 24 < 0;
    i3 = i6 ? HEAP32[i1 >> 2] | 0 : i1;
    i4 = i6 ? HEAP32[i2 + (i11 * 36 | 0) + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i37 >> 2] = 0;
    HEAP32[i37 + 4 >> 2] = 0;
    HEAP32[i37 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i17 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i37);
     i2 = HEAP32[i13 >> 2] | 0;
     i46 = 7;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i21 >> 0] = i4;
     if (!i4) i2 = i37; else {
      i2 = i37;
      i46 = 9;
     }
    } else i46 = 7;
    if ((i46 | 0) == 7) {
     i6 = i4 + 16 & -16;
     HEAP32[i43 >> 2] = 66;
     HEAP32[i18 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i43, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i37 >> 2] = i2;
     HEAP32[i19 >> 2] = i6 | -2147483648;
     HEAP32[i20 >> 2] = i4;
     i46 = 9;
    }
    if ((i46 | 0) == 9) {
     i46 = 0;
     _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i2 + i4 >> 0] = 0;
    i6 = HEAP8[i21 >> 0] | 0;
    L16 : do if ((i7 | 0) == (i8 | 0)) i5 = i7; else {
     i4 = i6 & 255;
     if (i6 << 24 >> 24 >= 0) {
      i2 = i7;
      while (1) {
       i7 = HEAP8[i2 + 11 >> 0] | 0;
       i3 = i7 << 24 >> 24 < 0;
       if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255) | 0)) if (!(_strncmp(i37, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) {
        i5 = i2;
        break L16;
       }
       i2 = i2 + 72 | 0;
       if ((i2 | 0) == (i8 | 0)) {
        i5 = i8;
        break L16;
       }
      }
     }
     i4 = HEAP32[i20 >> 2] | 0;
     i5 = HEAP32[i37 >> 2] | 0;
     i2 = i7;
     while (1) {
      i7 = HEAP8[i2 + 11 >> 0] | 0;
      i3 = i7 << 24 >> 24 < 0;
      if ((i4 | 0) == ((i3 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255) | 0)) if (!(_strncmp(i5, i3 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0)) {
       i5 = i2;
       break L16;
      }
      i2 = i2 + 72 | 0;
      if ((i2 | 0) == (i8 | 0)) {
       i5 = i8;
       break;
      }
     }
    } while (0);
    if (i6 << 24 >> 24 < 0) {
     i8 = HEAP32[i37 >> 2] | 0;
     i7 = HEAP32[i13 >> 2] | 0;
     HEAP32[i43 >> 2] = 66;
     HEAP32[i22 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i43);
    }
    if ((i5 | 0) == (HEAP32[i16 >> 2] | 0)) break;
    i2 = HEAP8[i5 + 16 + 11 >> 0] | 0;
    if (i2 << 24 >> 24 < 0) i2 = HEAP32[i5 + 20 >> 2] | 0; else i2 = i2 & 255;
    if (i2 | 0) {
     i3 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
     HEAP32[i38 >> 2] = 0;
     HEAP32[i38 + 4 >> 2] = 0;
     HEAP32[i38 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i23 >> 2] = i2;
     i4 = _strlen(i3) | 0;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
      i2 = HEAP32[i14 >> 2] | 0;
      i46 = 32;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i32 >> 0] = i4;
      if (!i4) i2 = i38; else {
       i2 = i38;
       i46 = 34;
      }
     } else i46 = 32;
     if ((i46 | 0) == 32) {
      i9 = i4 + 16 & -16;
      HEAP32[i43 >> 2] = 66;
      HEAP32[i24 >> 2] = i2;
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i43, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i38 >> 2] = i2;
      HEAP32[i25 >> 2] = i9 | -2147483648;
      HEAP32[i26 >> 2] = i4;
      i46 = 34;
     }
     if ((i46 | 0) == 34) {
      i46 = 0;
      _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i2 + i4 >> 0] = 0;
     i3 = i5 + 16 | 0;
     i4 = HEAP8[i3 + 11 >> 0] | 0;
     i2 = i4 << 24 >> 24 < 0;
     i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
     i4 = i2 ? HEAP32[i5 + 20 >> 2] | 0 : i4 & 255;
     HEAP32[i39 >> 2] = 0;
     HEAP32[i39 + 4 >> 2] = 0;
     HEAP32[i39 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i27 >> 2] = i2;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i39);
      i2 = HEAP32[i12 >> 2] | 0;
      i46 = 38;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i31 >> 0] = i4;
      if (!i4) i2 = i39; else {
       i2 = i39;
       i46 = 40;
      }
     } else i46 = 38;
     if ((i46 | 0) == 38) {
      i9 = i4 + 16 & -16;
      HEAP32[i43 >> 2] = 66;
      HEAP32[i28 >> 2] = i2;
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i43, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i39 >> 2] = i2;
      HEAP32[i29 >> 2] = i9 | -2147483648;
      HEAP32[i30 >> 2] = i4;
      i46 = 40;
     }
     if ((i46 | 0) == 40) {
      i46 = 0;
      _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i2 + i4 >> 0] = 0;
     i3 = HEAP32[i36 >> 2] | 0;
     i2 = HEAP8[i31 >> 0] | 0;
     i7 = i2 << 24 >> 24 < 0;
     i4 = HEAP32[i30 >> 2] | 0;
     i5 = i2 & 255;
     i8 = i7 ? i4 : i5;
     i9 = HEAP8[i3 + 11 >> 0] | 0;
     i6 = i9 << 24 >> 24 < 0;
     do if ((i8 | 0) == ((i6 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255) | 0)) {
      i9 = (_strncmp(i7 ? HEAP32[i39 >> 2] | 0 : i39, i6 ? HEAP32[i3 >> 2] | 0 : i3, i7 ? i4 : i5) | 0) != 0;
      i3 = i9 ? i39 : i38;
      if (!i9) {
       i9 = HEAP8[i3 + 11 >> 0] | 0;
       i6 = i9 << 24 >> 24 < 0;
       i4 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
       i3 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255;
       if (i7) i2 = (HEAP32[i29 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
       if (i3 >>> 0 > i2 >>> 0) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i39, i2, i3 - i2 | 0, i8, 0, i8, i3, i4);
        i2 = HEAP8[i15 >> 0] | 0;
        break;
       }
       i2 = i7 ? HEAP32[i39 >> 2] | 0 : i39;
       if (i3 | 0) _memmove(i2 | 0, i4 | 0, i3 | 0) | 0;
       HEAP8[i2 + i3 >> 0] = 0;
       i2 = HEAP8[i31 >> 0] | 0;
       if (i2 << 24 >> 24 < 0) {
        HEAP32[i30 >> 2] = i3;
        break;
       } else {
        i2 = i3 & 255;
        HEAP8[i31 >> 0] = i2;
        break;
       }
      }
     } while (0);
     i5 = HEAP8[i32 >> 0] | 0;
     i7 = i5 << 24 >> 24 < 0;
     i4 = HEAP32[i26 >> 2] | 0;
     i5 = i5 & 255;
     i3 = i2 << 24 >> 24 < 0;
     if (((i7 ? i4 : i5) | 0) == ((i3 ? HEAP32[i30 >> 2] | 0 : i2 & 255) | 0)) {
      if (i7) {
       i6 = HEAP32[i38 >> 2] | 0;
       i3 = i3 ? HEAP32[i39 >> 2] | 0 : i39;
       i2 = i4;
      } else {
       i6 = i38;
       i3 = i3 ? HEAP32[i39 >> 2] | 0 : i39;
       i2 = i5;
      }
      if (!(_strncmp(i6, i3, i2) | 0)) i1 = 0; else i46 = 57;
     } else i46 = 57;
     if ((i46 | 0) == 57) {
      i46 = 0;
      if ((HEAP8[i10 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
      i9 = i7 ? HEAP32[i38 >> 2] | 0 : i38;
      i10 = (HEAP8[i35 >> 0] | 0) < 0 ? HEAP32[i39 >> 2] | 0 : i39;
      HEAP32[i41 >> 2] = i1;
      HEAP32[i41 + 4 >> 2] = i9;
      HEAP32[i41 + 8 >> 2] = i10;
      __Z6FormatPKcz(i43, gb + 912910 | 0, i41);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i45, i43) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
      i1 = 1;
     }
     if ((HEAP8[i35 >> 0] | 0) < 0) {
      i10 = HEAP32[i39 >> 2] | 0;
      i9 = HEAP32[i12 >> 2] | 0;
      HEAP32[i43 >> 2] = 66;
      HEAP32[i33 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i43);
     }
     if ((HEAP8[i32 >> 0] | 0) < 0) {
      i10 = HEAP32[i38 >> 2] | 0;
      i9 = HEAP32[i14 >> 2] | 0;
      HEAP32[i43 >> 2] = 66;
      HEAP32[i34 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i43);
     }
     if (i1 | 0) {
      i1 = 0;
      i46 = 67;
      break;
     }
    }
   }
   i11 = i11 + 1 | 0;
   i1 = HEAP32[i42 >> 2] | 0;
   if (i11 >>> 0 >= (((HEAP32[i40 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0) break L1;
  }
  if ((i46 | 0) == 67) {
   STACKTOP = i47;
   return i1 | 0;
  }
  if ((HEAP8[i10 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i44 >> 2] = i1;
  __Z6FormatPKcz(i43, gb + 912864 | 0, i44);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i45, i43) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i43);
  i46 = 0;
  STACKTOP = i47;
  return i46 | 0;
 } while (0);
 i46 = HEAP8[i45 + 11 >> 0] | 0;
 i46 = ((i46 << 24 >> 24 < 0 ? HEAP32[i45 + 4 >> 2] | 0 : i46 & 255) | 0) == 0;
 STACKTOP = i47;
 return i46 | 0;
}

function __ZN16Physics2DManager13DynamicUpdateEv(i34) {
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i37 + 44 | 0;
 i28 = i37 + 16 | 0;
 i30 = i37 + 32 | 0;
 i31 = i37;
 if ((HEAP16[gb + 1457512 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457512 | 0, i27);
  i36 = gb + 1457512 | 0;
 } else i36 = 0;
 if ((HEAP16[gb + 1457536 + 6 >> 1] | 0) > -1) {
  HEAP32[i28 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457536 | 0, i27);
  i35 = gb + 1457536 | 0;
 } else i35 = 0;
 i8 = i34 + 600 | 0;
 i29 = i34 + 596 | 0;
 if ((HEAP32[i8 >> 2] | 0) != (i29 | 0)) {
  i32 = i34 + 616 | 0;
  i2 = HEAP32[i32 >> 2] | 0;
  if (i2 | 0) {
   i3 = i34 + 604 | 0;
   i1 = 0;
   do {
    i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i4 = __ZN14MessageHandler3GetEv() | 0;
    i5 = HEAP32[i5 + 24 >> 2] | 0;
    if ((i5 | 0) != -2147483648) {
     i25 = (Math_imul(HEAP32[i4 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i5 | 0;
     i33 = (HEAP32[i4 + 16 >> 2] | 0) + (i25 >>> 5 << 2) | 0;
     HEAP32[i33 >> 2] = HEAP32[i33 >> 2] & ~(1 << (i25 & 31));
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i33 = i34 + 624 | 0;
  HEAP8[i33 >> 0] = 0;
  i1 = __ZN14MessageHandler3GetEv() | 0;
  i2 = HEAP32[gb + 67088 + 24 >> 2] | 0;
  if ((i2 | 0) != -2147483648) {
   i24 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
   i25 = (HEAP32[i1 + 16 >> 2] | 0) + (i24 >>> 5 << 2) | 0;
   HEAP32[i25 >> 2] = HEAP32[i25 >> 2] & ~(1 << (i24 & 31));
  }
  d6 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  f7 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
  i1 = __Z14GetTimeManagerv() | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2;
  if ((i3 | 0) != (i29 | 0)) {
   f26 = Math_fround(Math_fround(d6) - Math_fround(+HEAPF64[i1 + 32 >> 3]));
   f14 = Math_fround(f26 / f7);
   i16 = f14 < Math_fround(0.0);
   i17 = f14 > Math_fround(1.0);
   f14 = i17 ? Math_fround(1.0) : f14;
   f14 = i16 ? Math_fround(0.0) : f14;
   f15 = Math_fround(Math_fround(1.0) - f14);
   i16 = i27 + 4 | 0;
   i17 = i27 + 8 | 0;
   i18 = i30 + 8 | 0;
   i19 = i27 + 4 | 0;
   i20 = i27 + 8 | 0;
   i21 = i31 + 8 | 0;
   f22 = Math_fround(HEAPF32[gb + 62452 >> 2]);
   i23 = i28 + 4 | 0;
   i24 = i28 + 8 | 0;
   i25 = i28 + 12 | 0;
   i1 = i2;
   do {
    i13 = HEAP32[i1 + 8 >> 2] | 0;
    L24 : do if (HEAP8[i13 + 48 >> 0] | 0) {
     i2 = HEAP32[i13 + 56 >> 2] | 0;
     if (!((i2 | 0) == 0 | (HEAP8[i1 + 109 >> 0] | 0) == 0)) {
      i5 = HEAP32[i13 + 92 >> 2] | 0;
      i8 = (i5 | 0) == 0;
      if (!i8) if (!(HEAP16[i5 + 4 >> 1] & 2)) break;
      switch (i2 | 0) {
      case 1:
       {
        f9 = Math_fround(f14 * Math_fround(HEAPF32[i1 + 68 >> 2]));
        f11 = Math_fround(f14 * Math_fround(HEAPF32[i1 + 72 >> 2]));
        f12 = Math_fround(f14 * Math_fround(HEAPF32[i1 + 76 >> 2]));
        f10 = Math_fround(f15 * Math_fround(HEAPF32[i1 + 12 >> 2]));
        f11 = Math_fround(f11 + Math_fround(f15 * Math_fround(HEAPF32[i1 + 16 >> 2])));
        f12 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i1 + 20 >> 2])));
        HEAPF32[i27 >> 2] = Math_fround(f9 + f10);
        HEAPF32[i16 >> 2] = f11;
        HEAPF32[i17 >> 2] = f12;
        __Z5SlerpRK11QuaternionfS1_f(i28, i1 + 24 | 0, i1 + 80 | 0, f14);
        i8 = i1 + 108 | 0;
        HEAP8[i8 >> 0] = 1;
        i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
        __ZNK9Transform11GetPositionEv(i30, i13);
        HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
        __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i13, i27, i28);
        i13 = i1 + 40 | 0;
        HEAP32[i13 >> 2] = HEAP32[i27 >> 2];
        HEAP32[i13 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
        HEAP32[i13 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
        i13 = i1 + 52 | 0;
        HEAP32[i13 >> 2] = HEAP32[i28 >> 2];
        HEAP32[i13 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
        HEAP32[i13 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
        HEAP32[i13 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
        HEAP8[i8 >> 0] = 0;
        break L24;
       }
      case 2:
       break;
      default:
       break L24;
      }
      do if (i8) {
       i2 = gb + 1162356 | 0;
       i4 = gb + 1162356 + 4 | 0;
      } else if ((HEAP32[i13 + 68 >> 2] | 0) == 2) {
       i2 = gb + 1162356 | 0;
       i4 = gb + 1162356 + 4 | 0;
      } else if (!(HEAP8[i13 + 226 >> 0] | 0)) {
       i2 = i5 + 64 | 0;
       i4 = i5 + 68 | 0;
       break;
      } else {
       i2 = i13 + 212 | 0;
       i4 = i13 + 216 | 0;
       break;
      } while (0);
      f11 = Math_fround(HEAPF32[i4 >> 2]);
      f10 = Math_fround(f26 * Math_fround(HEAPF32[i2 >> 2]));
      f11 = Math_fround(f26 * f11);
      f10 = Math_fround(f10 + Math_fround(HEAPF32[i1 + 68 >> 2]));
      f11 = Math_fround(f11 + Math_fround(HEAPF32[i1 + 72 >> 2]));
      f12 = Math_fround(Math_fround(HEAPF32[i1 + 76 >> 2]) + Math_fround(0.0));
      HEAPF32[i27 >> 2] = f10;
      HEAPF32[i19 >> 2] = f11;
      HEAPF32[i20 >> 2] = f12;
      if (i8) f9 = Math_fround(0.0); else if ((HEAP32[i13 + 68 >> 2] | 0) == 2) f9 = Math_fround(0.0); else f9 = Math_fround(Math_fround(HEAPF32[((HEAP8[i13 + 227 >> 0] | 0) == 0 ? i5 + 72 | 0 : i13 + 220 | 0) >> 2]) * Math_fround(57.2957802));
      i8 = f9 < Math_fround(0.0);
      f12 = Math_fround(-f9);
      if (!((i8 ? f12 : f9) <= Math_fround(9.99999997e-07))) {
       i8 = i1 + 80 | 0;
       HEAP32[i28 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i28 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
       HEAP32[i28 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
       HEAP32[i28 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
      } else {
       f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(0.0))));
       if (f7 > f22) {
        f11 = Math_fround(Math_fround(f26 * f7) * Math_fround(.5));
        f10 = Math_fround(+Math_cos(+f11));
        f11 = Math_fround(Math_fround(+Math_sin(+f11)) / f7);
        f7 = Math_fround(f11 * Math_fround(0.0));
        f11 = Math_fround(f9 * f11);
        f12 = Math_fround(f7 * f7);
        f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 + f12)))));
        if (f12 < f22) {
         f10 = Math_fround(1.0);
         f9 = Math_fround(0.0);
         f7 = Math_fround(0.0);
        } else {
         f10 = Math_fround(f10 / f12);
         f9 = Math_fround(f7 / f12);
         f7 = Math_fround(f11 / f12);
        }
       } else {
        f10 = Math_fround(1.0);
        f9 = Math_fround(0.0);
        f7 = Math_fround(0.0);
       }
       f11 = Math_fround(HEAPF32[i1 + 80 >> 2]);
       f40 = Math_fround(f10 * f11);
       f42 = Math_fround(HEAPF32[i1 + 92 >> 2]);
       f41 = Math_fround(f9 * f42);
       f40 = Math_fround(f40 + f41);
       f12 = Math_fround(HEAPF32[i1 + 88 >> 2]);
       f38 = Math_fround(f9 * f12);
       f40 = Math_fround(f40 + f38);
       f39 = Math_fround(HEAPF32[i1 + 84 >> 2]);
       f38 = Math_fround(Math_fround(Math_fround(f7 * f11) + Math_fround(f41 + Math_fround(f10 * f39))) - f38);
       f41 = Math_fround(f9 * f39);
       f9 = Math_fround(f9 * f11);
       f11 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f42) + Math_fround(f10 * f12)) + f41) - f9);
       f12 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f42) - f9) - f41) - Math_fround(f7 * f12));
       HEAPF32[i28 >> 2] = Math_fround(f40 - Math_fround(f7 * f39));
       HEAPF32[i23 >> 2] = f38;
       HEAPF32[i24 >> 2] = f11;
       HEAPF32[i25 >> 2] = f12;
      }
      i8 = i1 + 108 | 0;
      HEAP8[i8 >> 0] = 1;
      i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
      __ZNK9Transform11GetPositionEv(i31, i13);
      HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
      __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i13, i27, i28);
      i13 = i1 + 40 | 0;
      HEAP32[i13 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      i13 = i1 + 52 | 0;
      HEAP32[i13 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
      HEAP8[i8 >> 0] = 0;
     }
    } while (0);
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    i3 = i1;
   } while ((i3 | 0) != (i29 | 0));
  }
  i1 = __ZN14MessageHandler3GetEv() | 0;
  i2 = HEAP32[gb + 67088 + 24 >> 2] | 0;
  if ((i2 | 0) != -2147483648) {
   i30 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
   i31 = (HEAP32[i1 + 16 >> 2] | 0) + (i30 >>> 5 << 2) | 0;
   HEAP32[i31 >> 2] = 1 << (i30 & 31) | HEAP32[i31 >> 2];
  }
  i5 = HEAP32[i32 >> 2] | 0;
  if (i5 | 0) {
   i2 = i34 + 604 | 0;
   i1 = 0;
   do {
    i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i3 = __ZN14MessageHandler3GetEv() | 0;
    i4 = HEAP32[i4 + 24 >> 2] | 0;
    if ((i4 | 0) != -2147483648) {
     i32 = (Math_imul(HEAP32[i3 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i4 | 0;
     i34 = (HEAP32[i3 + 16 >> 2] | 0) + (i32 >>> 5 << 2) | 0;
     HEAP32[i34 >> 2] = 1 << (i32 & 31) | HEAP32[i34 >> 2];
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  HEAP8[i33 >> 0] = 1;
 }
 if (i35 | 0) __Z12profiler_endP19ProfilerInformation(i35);
 if (!i36) {
  STACKTOP = i37;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i36);
 STACKTOP = i37;
 return;
}

function __ZN5physx21PxcSweepCapsuleConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i4 + 384 | 0;
 i16 = i4 + 368 | 0;
 i49 = i4 + 592 | 0;
 i52 = i4 + 208 | 0;
 i53 = i4 + 128 | 0;
 i22 = i4 + 224 | 0;
 i19 = i4 + 96 | 0;
 i20 = i4 + 144 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i48 = HEAP32[i8 >> 2] | 0;
 i51 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i9 = i48 + 40 | 0;
 i47 = HEAP32[i9 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i48 + 44 >> 2]);
 i48 = HEAP32[i51 + 44 >> 2] | 0;
 i8 = HEAP32[i51 + 48 >> 2] | 0;
 HEAP32[i52 >> 2] = HEAP32[i51 + 40 >> 2];
 HEAP32[i52 + 4 >> 2] = i48;
 HEAP32[i52 + 8 >> 2] = i8;
 HEAPF32[i52 + 12 >> 2] = Math_fround(0.0);
 i8 = HEAP32[i51 + 56 >> 2] | 0;
 i48 = HEAP32[i51 + 60 >> 2] | 0;
 i50 = HEAP32[i51 + 64 >> 2] | 0;
 HEAP32[i53 >> 2] = HEAP32[i51 + 52 >> 2];
 HEAP32[i53 + 4 >> 2] = i8;
 HEAP32[i53 + 8 >> 2] = i48;
 HEAP32[i53 + 12 >> 2] = i50;
 i51 = HEAP32[i51 + 72 >> 2] | 0;
 f45 = Math_fround(f46 * Math_fround(0.0));
 i50 = i22 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 80 >> 2] = 4;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 128 >> 2] = i47;
 f39 = Math_fround(f45 + Math_fround(0.0));
 HEAPF32[i22 + 96 >> 2] = Math_fround(f46 + Math_fround(0.0));
 HEAPF32[i22 + 100 >> 2] = f39;
 HEAPF32[i22 + 104 >> 2] = f39;
 HEAPF32[i22 + 108 >> 2] = Math_fround(0.0);
 f45 = Math_fround(Math_fround(0.0) - f45);
 HEAPF32[i22 + 112 >> 2] = Math_fround(Math_fround(0.0) - f46);
 HEAPF32[i22 + 116 >> 2] = f45;
 HEAPF32[i22 + 120 >> 2] = f45;
 HEAPF32[i22 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i22 + 16 >> 2] = i47;
 i48 = i22 + 20 | 0;
 HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
 HEAP32[i22 + 32 >> 2] = i47;
 i47 = i22 + 36 | 0;
 HEAP32[i47 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i49 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i49 + 8 >> 2];
 HEAP32[i21 >> 2] = -1;
 HEAP32[i21 + 4 >> 2] = -1;
 HEAP32[i21 + 8 >> 2] = -1;
 HEAP32[i21 + 12 >> 2] = -1;
 HEAP32[i50 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i21, i51, i16, i52, i53);
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i53 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i53 >> 2]);
 f25 = Math_fround(HEAPF32[i53 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i53 + 8 >> 2]);
 i53 = HEAP32[i12 >> 2] | 0;
 i52 = HEAP32[i12 + 4 >> 2] | 0;
 i51 = HEAP32[i12 + 8 >> 2] | 0;
 i50 = HEAP32[i12 + 12 >> 2] | 0;
 i47 = i6 + 16 | 0;
 i49 = HEAP32[i47 >> 2] | 0;
 i48 = HEAP32[i47 + 4 >> 2] | 0;
 i47 = HEAP32[i47 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i53;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = i52;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = i51;
 i8 = i19 + 12 | 0;
 HEAP32[i8 >> 2] = i50;
 HEAP32[i19 + 16 >> 2] = i49;
 HEAP32[i19 + 20 >> 2] = i48;
 HEAP32[i19 + 24 >> 2] = i47;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f29 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f38 = Math_fround(f25 - f24);
 f40 = Math_fround(f27 - f32);
 f41 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f31 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f23 * Math_fround(Math_fround(f28 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f23 * Math_fround(Math_fround(f38 * f42) - Math_fround(f28 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f23) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f23)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f28) + Math_fround(f23 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f33;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f36 + f36);
 f31 = Math_fround(f26 + f26);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f26 * f31);
 f37 = Math_fround(f39 * f34);
 f26 = Math_fround(f26 * f33);
 f40 = Math_fround(f39 * f33);
 f23 = Math_fround(f35 * f33);
 f39 = Math_fround(f39 * f31);
 f31 = Math_fround(f35 * f31);
 f34 = Math_fround(f35 * f34);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f33));
 f36 = Math_fround(f26 + f34);
 f35 = Math_fround(f40 - f31);
 f34 = Math_fround(f26 - f34);
 f26 = Math_fround(f33 - f37);
 f28 = Math_fround(f39 + f23);
 f31 = Math_fround(f40 + f31);
 f23 = Math_fround(f39 - f23);
 f33 = Math_fround(f33 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f33;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(HEAPF32[i8 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f7)) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i53 = HEAP32[i3 + 4 >> 2] | 0;
 i52 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i53;
 HEAP32[i13 + 8 >> 2] = i52;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i53 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i52;
 HEAP32[i14 + 8 >> 2] = i53;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN11NoiseModule8TransferI14SafeBinaryReadEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i9, i11);
 i2 = i9 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620191 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620200 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620210 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 804 | 0;
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620483 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 800 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620220 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 33; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 33; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 805 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048298 | 0, i8, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i5 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 808 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620230 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 53; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 53; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 53) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 812 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620238 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 64; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 64; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 64) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 816 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620255 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 75; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 75; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 75) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 820 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620267 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 86; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 86; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 86) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 824 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620275 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 1092 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620287 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 1356 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620293 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 1620 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620300 | 0, gb + 620173 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i9 + 1884 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 620307 | 0, i8, i10, 0) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i11 + 16 | 0;
  i10 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function _UNITY_FT_Open_Face(i15, i13, i20, i21) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i27 + 120 | 0;
 i16 = i27 + 84 | 0;
 i17 = i27 + 48 | 0;
 i18 = i27 + 16 | 0;
 i19 = i27 + 12 | 0;
 i26 = i27 + 8 | 0;
 i11 = i27 + 4 | 0;
 i24 = i27;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 i14 = (i21 | 0) == 0;
 i12 = (i20 | 0) > -1;
 if (!((i13 | 0) != 0 & (i12 & i14 ^ 1))) {
  i26 = 6;
  STACKTOP = i27;
  return i26 | 0;
 }
 if (!(HEAP32[i13 >> 2] & 2)) i23 = 0; else i23 = (HEAP32[i13 + 16 >> 2] | 0) != 0;
 i10 = i23 & 1;
 i3 = _UNITY_FT_Stream_New(i15, i13, i11) | 0;
 HEAP32[i26 >> 2] = i3;
 L7 : do if (!i3) {
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  do if (!(i3 & 8)) i25 = 15; else {
   i1 = HEAP32[i13 + 20 >> 2] | 0;
   if (!i1) i25 = 15; else {
    if (!(HEAP32[HEAP32[i1 >> 2] >> 2] & 1)) HEAP32[i26 >> 2] = 32; else {
     if (!(i3 & 16)) {
      i4 = 0;
      i3 = 0;
     } else {
      i4 = HEAP32[i13 + 28 >> 2] | 0;
      i3 = HEAP32[i13 + 24 >> 2] | 0;
     }
     i20 = _open_face(i1, i11, i10, i20, i3, i4, i24) | 0;
     HEAP32[i26 >> 2] = i20;
     if (!i20) {
      i3 = i1;
      break;
     }
    }
    i3 = HEAP32[i11 >> 2] | 0;
    if (!i3) {
     i25 = 88;
     break L7;
    }
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    _UNITY_FT_Stream_Close(i3);
    if (i23) {
     i25 = 88;
     break L7;
    }
    _UNITY_ft_mem_free(i4, i3);
    i25 = 88;
    break L7;
   }
  } while (0);
  L21 : do if ((i25 | 0) == 15) {
   HEAP32[i26 >> 2] = 11;
   i9 = HEAP32[i15 + 16 >> 2] | 0;
   i7 = i15 + 20 + (i9 << 2) | 0;
   if ((i9 | 0) <= 0) {
    i1 = 0;
    i3 = 11;
    i25 = 29;
    break L7;
   }
   i8 = i13 + 24 | 0;
   i9 = i13 + 28 | 0;
   i1 = 0;
   i6 = i15 + 20 | 0;
   i4 = 11;
   while (1) {
    i3 = HEAP32[i6 >> 2] | 0;
    if (!(HEAP32[HEAP32[i3 >> 2] >> 2] & 1)) i3 = i4; else {
     if (!(HEAP32[i13 >> 2] & 16)) {
      i1 = 0;
      i4 = 0;
     } else {
      i1 = HEAP32[i9 >> 2] | 0;
      i4 = HEAP32[i8 >> 2] | 0;
     }
     i4 = _open_face(i3, i11, i10, i20, i4, i1, i24) | 0;
     HEAP32[i26 >> 2] = i4;
     if (!i4) break L21;
     if ((i4 & 255 | 0) == 142 & (_strcmp(HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + 8 >> 2] | 0, gb + 1007021 | 0) | 0) == 0) {
      i5 = HEAP32[i11 >> 2] | 0;
      if (_UNITY_FT_Stream_Seek(i5, 0) | 0) {
       i1 = i3;
       i3 = i4;
       i25 = 29;
       break L7;
      }
      i1 = _open_face_PS_from_sfnt_stream(i15, i5, i20, 0, 0, i21) | 0;
      HEAP32[i26 >> 2] = i1;
      if (!i1) break; else i4 = i1;
     }
     if ((i4 & 255 | 0) == 2) {
      i1 = i3;
      i3 = i4;
     } else {
      i1 = i3;
      i3 = i4;
      i25 = 29;
      break L7;
     }
    }
    i6 = i6 + 4 | 0;
    if (i6 >>> 0 >= i7 >>> 0) {
     i25 = 29;
     break L7;
    } else i4 = i3;
   }
   if (!i5) {
    i26 = 0;
    STACKTOP = i27;
    return i26 | 0;
   }
   i1 = HEAP32[i5 + 28 >> 2] | 0;
   _UNITY_FT_Stream_Close(i5);
   if (i23) {
    i26 = 0;
    STACKTOP = i27;
    return i26 | 0;
   }
   _UNITY_ft_mem_free(i1, i5);
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  } while (0);
  i4 = _UNITY_ft_mem_alloc(i2, 12, i26) | 0;
  L46 : do if (!(HEAP32[i26 >> 2] | 0)) {
   i8 = HEAP32[i24 >> 2] | 0;
   HEAP32[i4 + 8 >> 2] = i8;
   i1 = i8;
   i7 = i1 + 96 | 0;
   _UNITY_FT_List_Add((HEAP32[i7 >> 2] | 0) + 16 | 0, i4);
   do if (i12) {
    i24 = _UNITY_FT_New_GlyphSlot(i1, 0) | 0;
    HEAP32[i26 >> 2] = i24;
    if (i24 | 0) break L46;
    i24 = _UNITY_FT_New_Size(i1, i22) | 0;
    HEAP32[i26 >> 2] = i24;
    if (!i24) {
     HEAP32[i1 + 88 >> 2] = HEAP32[i22 >> 2];
     break;
    } else break L46;
   } while (0);
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   if (i4 & 1 | 0) {
    i3 = i1 + 74 | 0;
    i2 = HEAP16[i3 >> 1] | 0;
    if (i2 << 16 >> 16 < 0) {
     i2 = 0 - (i2 & 65535) & 65535;
     HEAP16[i3 >> 1] = i2;
    }
    if (!(i4 & 32)) HEAP16[i1 + 78 >> 1] = i2;
   }
   if (i4 & 2 | 0) {
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    if ((i6 | 0) > 0) {
     i5 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = 0;
     do {
      i2 = i5 + (i4 << 4) | 0;
      i3 = HEAP16[i2 >> 1] | 0;
      if (i3 << 16 >> 16 < 0) HEAP16[i2 >> 1] = 0 - (i3 & 65535);
      i2 = i5 + (i4 << 4) + 8 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) < 0) HEAP32[i2 >> 2] = 0 - i3 << 16 >> 16;
      i2 = i5 + (i4 << 4) + 12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) < 0) HEAP32[i2 >> 2] = 0 - i3;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i6 | 0));
    }
   }
   i2 = HEAP32[i1 + 128 >> 2] | 0;
   HEAP32[i2 >> 2] = 65536;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 65536;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i2 = i2 + 52 | 0;
   HEAP32[i2 >> 2] = 1;
   if (!i14) {
    HEAP32[i21 >> 2] = i1;
    break L7;
   }
   if (!i8) break L7;
   i5 = HEAP32[i7 >> 2] | 0;
   if (!i5) break L7;
   HEAP32[i2 >> 2] = 0;
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i4 = i5 + 16 | 0;
   i2 = _UNITY_FT_List_Find(i4, i8) | 0;
   if (!i2) break L7;
   _UNITY_FT_List_Remove(i4, i2);
   _UNITY_ft_mem_free(i3, i2);
   _destroy_face(i3, i1, i5);
   break L7;
  } else {
   i1 = HEAP32[i24 >> 2] | 0;
   if (!i4) {
    i25 = 95;
    break L7;
   }
  } while (0);
  if (i1 | 0) {
   i2 = HEAP32[i1 + 96 >> 2] | 0;
   if (i2 | 0) {
    i23 = (HEAP32[i1 + 128 >> 2] | 0) + 52 | 0;
    i24 = HEAP32[i23 >> 2] | 0;
    HEAP32[i23 >> 2] = i24 + -1;
    if ((i24 | 0) <= 1) {
     i3 = HEAP32[i2 + 8 >> 2] | 0;
     i4 = i2 + 16 | 0;
     i5 = _UNITY_FT_List_Find(i4, i1) | 0;
     if (i5 | 0) {
      _UNITY_FT_List_Remove(i4, i5);
      _UNITY_ft_mem_free(i3, i5);
      _destroy_face(i3, i1, i2);
     }
    }
   }
  }
 } else {
  i2 = 0;
  i1 = 0;
  i25 = 29;
 } while (0);
 if ((i25 | 0) == 29) {
  L91 : do switch ((i3 & 255) << 24 >> 24) {
  case 85:
  case 2:
  case 81:
   {
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = _IsMacBinary(i15, i3, i20, i21) | 0;
    if ((i4 & 255 | 0) == 2) i4 = _IsMacResource(i15, i3, 0, i20, i21) | 0;
    L97 : do switch ((i4 & 255) << 24 >> 24) {
    case 85:
    case 2:
     {
      if (!(HEAP32[i13 >> 2] & 4)) i25 = 51; else {
       i11 = HEAP32[i15 >> 2] | 0;
       HEAP32[i19 >> 2] = 0;
       i10 = i13 + 12 | 0;
       _UNITY_FT_Raccess_Guess(i15, i3, HEAP32[i10 >> 2] | 0, i22, i16, i17);
       i9 = i18 + 12 | 0;
       i4 = 0;
       i5 = 2;
       i8 = 0;
       while (1) {
        i7 = _UNITY_ft_raccess_rule_by_darwin_vfs(i15, i8) | 0;
        i6 = i7 << 24 >> 24 != 0;
        if (i4 << 24 >> 24 == 0 | i6 ^ 1) if (!(HEAP32[i17 + (i8 << 2) >> 2] | 0)) {
         HEAP32[i18 >> 2] = 4;
         i5 = HEAP32[i22 + (i8 << 2) >> 2] | 0;
         if (!i5) i5 = HEAP32[i10 >> 2] | 0;
         HEAP32[i9 >> 2] = i5;
         i5 = _UNITY_FT_Stream_New(i15, i18, i19) | 0;
         i4 = i6 & (i5 & 255 | 0) == 81 ? 1 : i4;
         if (!i5) {
          i6 = HEAP32[i19 >> 2] | 0;
          i5 = _IsMacResource(i15, i6, HEAP32[i16 + (i8 << 2) >> 2] | 0, i20, i21) | 0;
          if (i6 | 0) {
           i14 = HEAP32[i6 + 28 >> 2] | 0;
           _UNITY_FT_Stream_Close(i6);
           _UNITY_ft_mem_free(i14, i6);
          }
          if (!i5) {
           i6 = 0;
           break;
          }
          i4 = i7 << 24 >> 24 == 0 ? i4 : 1;
         }
        }
        i8 = i8 + 1 | 0;
        if (i8 >>> 0 >= 9) {
         i6 = i5;
         break;
        }
       }
       i4 = HEAP32[i22 >> 2] | 0;
       if (i4 | 0) {
        _UNITY_ft_mem_free(i11, i4);
        HEAP32[i22 >> 2] = 0;
       }
       i4 = i22 + 4 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 12 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 16 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 20 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 24 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 28 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       i4 = i22 + 32 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if (i5 | 0) {
        _UNITY_ft_mem_free(i11, i5);
        HEAP32[i4 >> 2] = 0;
       }
       if (!i6) {
        HEAP32[i26 >> 2] = 0;
        break L97;
       } else {
        HEAP32[i26 >> 2] = 2;
        i25 = 57;
        break L97;
       }
      }
      break;
     }
    default:
     i25 = 51;
    } while (0);
    if ((i25 | 0) == 51) {
     HEAP32[i26 >> 2] = i4;
     if (i4 | 0) if ((i4 & 255 | 0) == 2) i25 = 57; else break L91;
    }
    if ((i25 | 0) == 57) {
     HEAP32[i26 >> 2] = 2;
     break L91;
    }
    if (i3 | 0) {
     i1 = HEAP32[i3 + 28 >> 2] | 0;
     _UNITY_FT_Stream_Close(i3);
     if (!i23) _UNITY_ft_mem_free(i1, i3);
    }
    i26 = HEAP32[i26 >> 2] | 0;
    STACKTOP = i27;
    return i26 | 0;
   }
  default:
   i3 = HEAP32[i11 >> 2] | 0;
  } while (0);
  if (!i3) i25 = 88; else {
   i4 = HEAP32[i3 + 28 >> 2] | 0;
   _UNITY_FT_Stream_Close(i3);
   if (i23) i25 = 88; else {
    _UNITY_ft_mem_free(i4, i3);
    i25 = 88;
   }
  }
 }
 if ((i25 | 0) == 88) {
  i3 = i1;
  i1 = HEAP32[i24 >> 2] | 0;
  i25 = 95;
 }
 if ((i25 | 0) == 95) if (i1 | 0) _destroy_face(i2, i1, i3);
 i26 = HEAP32[i26 >> 2] | 0;
 STACKTOP = i27;
 return i26 | 0;
}

function __ZN5physx14PxsAABBManager22processAggregateSingleERKNS_19AggregateSortedDataERKNS_9AggregateEjPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i33, i1, i2, i32, i35) {
 i33 = i33 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i32 = i32 | 0;
 i35 = i35 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i41 + 33 | 0;
 i38 = i41 + 32 | 0;
 i37 = i41;
 i36 = i37 + 16 | 0;
 HEAP32[i36 >> 2] = HEAP32[i33 >> 2];
 i34 = i37 + 20 | 0;
 HEAP32[i34 >> 2] = i37;
 HEAP32[i37 + 24 >> 2] = -2147483644;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 i31 = HEAPU8[i2 + 1025 >> 0] | 0;
 i27 = HEAP32[i33 + 300 >> 2] | 0;
 i30 = i33 + 308 | 0;
 i28 = HEAP32[i30 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i29 = HEAP32[i1 + 4 >> 2] | 0;
 i25 = HEAP32[i33 + 12 >> 2] | 0;
 i20 = HEAP32[i25 + (i32 * 24 | 0) >> 2] | 0;
 i21 = HEAP32[i25 + (i32 * 24 | 0) + 4 >> 2] | 0;
 i22 = HEAP32[i25 + (i32 * 24 | 0) + 8 >> 2] | 0;
 i23 = HEAP32[i25 + (i32 * 24 | 0) + 12 >> 2] | 0;
 i24 = HEAP32[i25 + (i32 * 24 | 0) + 16 >> 2] | 0;
 i25 = HEAP32[i25 + (i32 * 24 | 0) + 20 >> 2] | 0;
 i26 = HEAP32[(HEAP32[i33 + 20 >> 2] | 0) + (i32 << 2) >> 2] | 0;
 i11 = HEAP8[i2 + 1026 >> 0] | 0;
 i19 = i12 + ((i11 & 255) << 2) | 0;
 i11 = i11 << 24 >> 24 == 0;
 L1 : do if (!i11) {
  i13 = i33 + 304 | 0;
  i14 = i33 + 16 | 0;
  i15 = i33 + 49836 | 0;
  i16 = i33 + 49840 | 0;
  i17 = i33 + 49832 | 0;
  i1 = i12;
  i18 = gb + 1470388 | 0;
  do {
   i2 = HEAP32[i18 >> 2] | 0;
   i18 = i18 + 4 | 0;
   L5 : do if (i1 >>> 0 < i19 >>> 0) do {
    if ((HEAP32[i27 + ((HEAP32[i29 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0 >= i20 >>> 0) break L5;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i19 >>> 0); while (0);
   i10 = i1 >>> 0 < i19 >>> 0;
   if (!i10) break;
   i8 = Math_imul(i2, i31) | 0;
   i9 = i1;
   do {
    i2 = HEAP32[i9 >> 2] | 0;
    i9 = i9 + 4 | 0;
    i3 = HEAP32[i29 + (i2 << 2) >> 2] | 0;
    if ((HEAP32[i27 + (i3 * 24 | 0) >> 2] | 0) >>> 0 > i23 >>> 0) break;
    if ((HEAP32[i28 + (i3 << 2) >> 2] | 0) != (i26 | 0)) if (i20 >>> 0 <= (HEAP32[i27 + (i3 * 24 | 0) + 12 >> 2] | 0) >>> 0) if ((HEAP32[i27 + (i3 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= i24 >>> 0) if (i21 >>> 0 <= (HEAP32[i27 + (i3 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i27 + (i3 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= i25 >>> 0) if (i22 >>> 0 <= (HEAP32[i27 + (i3 * 24 | 0) + 20 >> 2] | 0) >>> 0) {
     i7 = i2 + i8 | 0;
     i6 = i33 + 384 + ((i7 & 31) << 2) | 0;
     i7 = i7 >>> 5;
     i5 = (HEAP32[i34 >> 2] | 0) + (i7 << 2) | 0;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | HEAP32[i6 >> 2];
     if (!(HEAP32[i6 >> 2] & HEAP32[(HEAP32[i35 >> 2] | 0) + (i7 << 2) >> 2])) {
      i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      i7 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i32 << 2) >> 2] | 0;
      i3 = HEAP32[i15 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i16 >> 2] | 0)) {
       i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
       i5 = HEAP32[i17 >> 2] | 0;
       i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i39, i4 << 3, gb + 717789 | 0, 59) | 0;
       if (i5 | 0) _memcpy(i2 | 0, i5 | 0, i3 << 3 | 0) | 0;
       _memset(i2 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i5);
       HEAP32[i17 >> 2] = i2;
       HEAP32[i16 >> 2] = i4;
       i3 = HEAP32[i15 >> 2] | 0;
      } else i2 = HEAP32[i17 >> 2] | 0;
      HEAP32[i15 >> 2] = i3 + 1;
      HEAP32[i2 + (i3 << 3) >> 2] = i6;
      HEAP32[i2 + (i3 << 3) + 4 >> 2] = i7;
     }
    }
   } while (i9 >>> 0 < i19 >>> 0);
  } while (i10 & i18 >>> 0 < (gb + 1470388 + 4 | 0) >>> 0);
  if (!i11) {
   i13 = i33 + 304 | 0;
   i14 = i33 + 16 | 0;
   i15 = i33 + 49836 | 0;
   i16 = i33 + 49840 | 0;
   i17 = i33 + 49832 | 0;
   i1 = gb + 1470388 | 0;
   do {
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = i12 + 4 | 0;
    if (i1 >>> 0 < (gb + 1470388 + 4 | 0) >>> 0) if (i20 >>> 0 <= (HEAP32[i27 + ((HEAP32[i29 + (i11 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0) do i1 = i1 + 4 | 0; while (i1 >>> 0 < (gb + 1470388 + 4 | 0) >>> 0);
    i8 = i1 >>> 0 < (gb + 1470388 + 4 | 0) >>> 0;
    if (!i8) break L1;
    i9 = i29 + (i11 << 2) | 0;
    i10 = i1;
    do {
     i2 = HEAP32[i10 >> 2] | 0;
     i10 = i10 + 4 | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     if (i20 >>> 0 > (HEAP32[i27 + (i3 * 24 | 0) + 12 >> 2] | 0) >>> 0) break;
     if ((HEAP32[i28 + (i3 << 2) >> 2] | 0) != (i26 | 0)) if ((HEAP32[i27 + (i3 * 24 | 0) >> 2] | 0) >>> 0 <= i23 >>> 0) if ((HEAP32[i27 + (i3 * 24 | 0) + 4 >> 2] | 0) >>> 0 <= i24 >>> 0) if (i21 >>> 0 <= (HEAP32[i27 + (i3 * 24 | 0) + 16 >> 2] | 0) >>> 0) if ((HEAP32[i27 + (i3 * 24 | 0) + 8 >> 2] | 0) >>> 0 <= i25 >>> 0) if (i22 >>> 0 <= (HEAP32[i27 + (i3 * 24 | 0) + 20 >> 2] | 0) >>> 0) {
      i18 = (Math_imul(i2, i31) | 0) + i11 | 0;
      i7 = i33 + 384 + ((i18 & 31) << 2) | 0;
      i18 = i18 >>> 5;
      i6 = (HEAP32[i34 >> 2] | 0) + (i18 << 2) | 0;
      HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | HEAP32[i7 >> 2];
      if (!(HEAP32[i7 >> 2] & HEAP32[(HEAP32[i35 >> 2] | 0) + (i18 << 2) >> 2])) {
       i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] | 0;
       i7 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i32 << 2) >> 2] | 0;
       i3 = HEAP32[i15 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i16 >> 2] | 0)) {
        i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
        i5 = HEAP32[i17 >> 2] | 0;
        i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i39, i4 << 3, gb + 717789 | 0, 59) | 0;
        if (i5 | 0) _memcpy(i2 | 0, i5 | 0, i3 << 3 | 0) | 0;
        _memset(i2 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i5);
        HEAP32[i17 >> 2] = i2;
        HEAP32[i16 >> 2] = i4;
        i3 = HEAP32[i15 >> 2] | 0;
       } else i2 = HEAP32[i17 >> 2] | 0;
       HEAP32[i15 >> 2] = i3 + 1;
       HEAP32[i2 + (i3 << 3) >> 2] = i6;
       HEAP32[i2 + (i3 << 3) + 4 >> 2] = i7;
      }
     }
    } while (i10 >>> 0 < (gb + 1470388 + 4 | 0) >>> 0);
   } while (i8 & i12 >>> 0 < i19 >>> 0);
  }
 } while (0);
 i15 = i35 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i5 = i1 & 2147483647;
 L62 : do if (i5) {
  i4 = HEAP32[i35 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i5 >>> 0) break L62;
  }
  i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
  i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i2 << 5;
  i3 = i3 + -1 & i3;
  L68 : do if (!i3) do {
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i5 >>> 0) {
    i3 = 0;
    break L68;
   }
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  } while ((i3 | 0) == 0); while (0);
  if ((i6 | 0) != -1) {
   i10 = i33 + 304 | 0;
   i11 = i33 + 16 | 0;
   i12 = i33 + 49848 | 0;
   i13 = i33 + 49852 | 0;
   i14 = i33 + 49844 | 0;
   i1 = i6;
   L74 : while (1) {
    i9 = i2 << 5;
    while (1) {
     if (!(HEAP32[i33 + 384 + ((i1 & 31) << 2) >> 2] & HEAP32[(HEAP32[i34 >> 2] | 0) + (i1 >>> 5 << 2) >> 2])) {
      i1 = HEAP32[i29 + (((i1 >>> 0) % (i31 >>> 0) | 0) << 2) >> 2] | 0;
      if ((HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0) != 1073741823) {
       i7 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
       i8 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i32 << 2) >> 2] | 0;
       i4 = HEAP32[i12 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i13 >> 2] | 0)) {
        i5 = (i4 | 0) == 0 ? 32 : i4 << 1;
        i6 = HEAP32[i14 >> 2] | 0;
        i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i39, i5 << 3, gb + 717789 | 0, 59) | 0;
        if (i6 | 0) _memcpy(i1 | 0, i6 | 0, i4 << 3 | 0) | 0;
        _memset(i1 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i6);
        HEAP32[i14 >> 2] = i1;
        HEAP32[i13 >> 2] = i5;
        i4 = HEAP32[i12 >> 2] | 0;
       } else i1 = HEAP32[i14 >> 2] | 0;
       HEAP32[i12 >> 2] = i4 + 1;
       HEAP32[i1 + (i4 << 3) >> 2] = i7;
       HEAP32[i1 + (i4 << 3) + 4 >> 2] = i8;
      }
     }
     if (!i3) break L74;
     i1 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i1 = HEAP32[gb + 90668 + (i1 << 2) >> 2] | i9;
     i3 = i3 + -1 & i3;
     if (!i3) {
      i5 = i1;
      break;
     }
     if ((i1 | 0) == -1) break L74;
    }
    i1 = HEAP32[i15 >> 2] | 0;
    i4 = i1 & 2147483647;
    do {
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i4 >>> 0) {
      i3 = 0;
      break;
     }
     i3 = HEAP32[(HEAP32[i35 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    } while ((i3 | 0) == 0);
    if ((i5 | 0) == -1) break L62; else i1 = i5;
   }
   i1 = HEAP32[i15 >> 2] | 0;
  }
 } while (0);
 _memcpy(HEAP32[i35 >> 2] | 0, HEAP32[i34 >> 2] | 0, i1 << 2 | 0) | 0;
 i5 = HEAP32[i37 + 20 >> 2] | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == (i37 | 0)) {
  STACKTOP = i41;
  return;
 }
 i9 = HEAP32[i36 >> 2] | 0;
 if (!i9) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i38, i5);
  STACKTOP = i41;
  return;
 }
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (i1 >>> 0 > i5 >>> 0) i40 = 77; else if ((i1 + (HEAP32[i9 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
  i6 = i9 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
 } else i40 = 77;
 if ((i40 | 0) == 77) __ZN5physx6shdfnd9Allocator10deallocateEPv(i39, i5);
 STACKTOP = i41;
 return;
}

function __ZN19UnityConnectService13ReportSessionEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 32 | 0;
 i4 = i16 + 24 | 0;
 i3 = i16 + 16 | 0;
 i11 = i16 + 128 | 0;
 i12 = i16 + 96 | 0;
 i13 = i16 + 84 | 0;
 i1 = i16 + 112 | 0;
 i14 = i16 + 72 | 0;
 i9 = i16 + 48 | 0;
 i15 = i16;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1040146 | 0, 13);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i2 = __Z24GetManagerPtrFromContexti(22) | 0;
 if (i2 | 0) {
  __ZN20UnityConnectSettings14GetCloudUserIdEv(i1, i2);
  i7 = i1 + 11 | 0;
  HEAP32[i3 >> 2] = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i13, gb + 1041524 | 0, i3);
  i6 = HEAP8[i13 + 11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i5 ? HEAP32[i13 >> 2] | 0 : i13, i5 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   i7 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i10);
  }
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = i11 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i2 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, gb + 1041536 | 0, 7, i2 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, i2) | 0;
 i2 = HEAP8[i10 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i1 ? HEAP32[i10 >> 2] | 0 : i10, i1 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZN10systeminfo18GetOperatingSystemEv(i13);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i2 = i13 + 11 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, gb + 1041544 | 0, 4, i1 + 4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i1) | 0;
 i1 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i2 ? HEAP32[i10 >> 2] | 0 : i10, i2 ? HEAP32[i10 + 4 >> 2] | 0 : i1 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i1 = __ZN10systeminfo25GetDeviceUniqueIdentifierEv() | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, _strlen(i1) | 0);
 i1 = i8 + 48 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i8 + 52 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) {
  i2 = i13 + 11 | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
  if (i1 | 0) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, gb + 1041558 | 0, 6, i1 + 6 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i1) | 0;
   i7 = HEAP8[i10 + 11 >> 0] | 0;
   i6 = i7 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i6 ? HEAP32[i10 >> 2] | 0 : i10, i6 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  }
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 1041549 | 0, i4);
  i7 = HEAP8[i10 + 11 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i6 ? HEAP32[i10 >> 2] | 0 : i10, i6 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i2 = __Z20GetPlayerSettingsPtrv() | 0;
 if (i2 | 0) {
  i1 = i2 + 44 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 48 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i4, i1);
  i1 = i10 + 11 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i2 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
  if (i2 | 0) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, gb + 1041565 | 0, 11, i2 + 11 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, i2) | 0;
   i7 = HEAP8[i14 + 11 >> 0] | 0;
   i6 = i7 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i6 ? HEAP32[i14 >> 2] | 0 : i14, i6 ? HEAP32[i14 + 4 >> 2] | 0 : i7 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i4 = i14 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i14 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1047147 | 0, 12);
 i6 = i9 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1041577 | 0, 33);
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i14, i10, i9) | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i1 = __Znwj(40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 28 | 0, i6);
  i3 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  i3 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i14 >> 2] = i3;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i1 = i8 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i9 = i12 + 11 | 0;
  i9 = HEAP8[i9 >> 0] | 0;
  i5 = i9 << 24 >> 24 < 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i6 = i12 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i9 = i9 & 255;
  i8 = i5 ? i8 : i12;
  i9 = i5 ? i6 : i9;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i15 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(gb + 1041611 | 0, i8, i9, i14, 0, i10, 0) | 0;
  HEAP32[i1 >> 2] = i15;
  i15 = HEAP32[i7 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i14, i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i16;
  return;
 }
 __ZN3WWW7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 i9 = i12 + 11 | 0;
 i9 = HEAP8[i9 >> 0] | 0;
 i5 = i9 << 24 >> 24 < 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i6 = i12 + 4 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i9 = i9 & 255;
 i8 = i5 ? i8 : i12;
 i9 = i5 ? i6 : i9;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i15 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(gb + 1041611 | 0, i8, i9, i14, 0, i10, 0) | 0;
 HEAP32[i1 >> 2] = i15;
 i15 = HEAP32[i7 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i14, i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i16;
 return;
}

function __ZN19SkinnedMeshRenderer22UpdateAllSkinnedMeshesENS_10UpdateTypeEP13dynamic_arrayIPS_Lj4EE(i9, i20) {
 i9 = i9 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i25 + 8 | 0;
 i12 = i25;
 i22 = i25 + 88 | 0;
 i23 = i25 + 68 | 0;
 i3 = i25 + 108 | 0;
 i24 = i25 + 40 | 0;
 i13 = i25 + 20 | 0;
 if ((HEAP16[gb + 1161796 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161796 | 0, i14);
  i21 = gb + 1161796 | 0;
 } else i21 = 0;
 i11 = (i9 | 0) == 0;
 i8 = i11 ? 2 : 8;
 i1 = HEAP32[gb + 1161628 + 4 >> 2] | 0;
 if ((i1 | 0) == (gb + 1161628 | 0)) i2 = 0; else {
  i2 = 0;
  do {
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } while ((i1 | 0) != (gb + 1161628 | 0));
 }
 i15 = i22 + 12 | 0;
 HEAP32[i15 >> 2] = i2;
 i17 = i22 + 16 | 0;
 HEAP32[i17 >> 2] = i2;
 i18 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
 i19 = i14;
 i10 = HEAP32[i19 + 4 >> 2] | 0;
 i7 = i18;
 HEAP32[i7 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 i7 = i2 << 2;
 HEAP32[i22 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
 i10 = i23 + 12 | 0;
 HEAP32[i10 >> 2] = i2;
 i19 = i23 + 16 | 0;
 HEAP32[i19 >> 2] = i2;
 i16 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 64016 | 0);
 i5 = i14;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i16;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i23 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161808 | 0, i14);
 __ZN18JobBatchDispatcherC2E11JobPriorityi(i24, 0, -1);
 i2 = HEAP32[gb + 1161628 + 4 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (gb + 1161628 | 0)) {
  i5 = 0;
  i6 = 0;
 } else {
  i1 = 0;
  i4 = 0;
  do {
   i5 = HEAP32[i2 + 8 >> 2] | 0;
   i6 = (HEAP32[i5 + 504 >> 2] | 0) == 0;
   if ((i6 & 1 | 0) == (i9 | 0)) {
    i7 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i5, i8, i24) | 0;
    if (i7) {
     i2 = i7 + 93 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
      HEAP32[i7 + 96 >> 2] = __ZN4Mesh24QueryGpuSkinSourceBufferEi(HEAP32[i5 + 356 >> 2] | 0, HEAP32[i7 + 20 >> 2] | 0) | 0;
      i2 = HEAP8[i2 >> 0] | 0;
     }
     HEAP8[i7 + 92 >> 0] = i6 & 1;
     HEAP32[(HEAP32[i23 >> 2] | 0) + (i4 << 2) >> 2] = i7;
     HEAP32[(HEAP32[i22 >> 2] | 0) + (i4 << 2) >> 2] = i5;
     i4 = i4 + 1 | 0;
     i1 = i2 << 24 >> 24 == 0 ? i1 : i7;
    }
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
  } while ((i3 | 0) != (gb + 1161628 | 0));
  i5 = i1;
  i6 = i4;
 }
 __ZN18JobBatchDispatcher8KickJobsEv(i24);
 __Z12profiler_endP19ProfilerInformation(gb + 1161808 | 0);
 if (i6 | 0) {
  HEAP32[i15 >> 2] = i6;
  i1 = HEAP32[i17 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i17 >> 2] = i6;
   HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i6 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
   HEAP32[i17 >> 2] = i6;
   HEAP32[i22 >> 2] = i9;
   break;
  } while (0);
  HEAP32[i10 >> 2] = i6;
  i1 = HEAP32[i19 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i19 >> 2] = i6;
   HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i6 << 2, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i19 >> 2] = i6;
   HEAP32[i23 >> 2] = i9;
   break;
  } while (0);
  if (i11) {
   i5 = gb + 64016 | 0;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i12;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   HEAP32[i13 >> 2] = 0;
   i3 = i13 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   i4 = i13 + 16 | 0;
   HEAP32[i4 >> 2] = 0;
   i5 = i13 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i12);
   i12 = i14;
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i6;
   i2 = HEAP32[i4 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i4 >> 2] = i6;
    HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i6 << 3, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i12 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i6;
    HEAP32[i13 >> 2] = i12;
    break;
   } while (0);
   if (i6 >>> 0 > i1 >>> 0) _memset((HEAP32[i13 >> 2] | 0) + (i1 << 3) | 0, 0, i6 - i1 << 3 | 0) | 0;
   i2 = i14 + 4 | 0;
   i1 = 0;
   do {
    i11 = (HEAP32[i13 >> 2] | 0) + (i1 << 3) | 0;
    i12 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i24, i11, fb + 3391 | 0, i12, i14);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
   __ZN18JobBatchDispatcher8KickJobsEv(i24);
   i3 = 0;
   do {
    i1 = (HEAP32[i13 >> 2] | 0) + (i3 << 3) | 0;
    if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
    i10 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i2 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i11 = i2 + 36 | 0;
    i14 = HEAP32[i11 >> 2] | 0;
    i9 = HEAP16[i2 + 56 >> 1] | 0;
    i12 = (i9 & 255) << 24 >> 24 ? i14 + (HEAP32[i2 + 48 >> 2] | 0) | 0 : 0;
    i14 = (i9 & 65535) > 255 ? i14 + (HEAP32[i2 + 52 >> 2] | 0) | 0 : 0;
    i9 = __Z9GetIClothv() | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, HEAP32[i10 + 504 >> 2] | 0, HEAP32[i11 >> 2] | 0, i12 | 0, i14 | 0, HEAP32[i2 + 44 >> 2] | 0, 0);
    i2 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if (i2 | 0) {
     i1 = i2 + 84 | 0;
     if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
     i1 = HEAP32[i2 + 100 >> 2] | 0;
     if (i1 | 0) {
      i14 = i1 + 4 | 0;
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
      if (!(HEAP32[i14 >> 2] | 0)) {
       mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
       __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
      }
     }
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i6 | 0));
   if ((HEAP32[i4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i5);
    HEAP32[i13 >> 2] = 0;
   }
  } else {
   i3 = __Z12GetGfxDevicev() | 0;
   HEAP32[i14 >> 2] = 0;
   i4 = i14 + 4 | 0;
   i11 = gb + 63160 | 0;
   i13 = HEAP32[i11 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = i6 << 5;
   do if (!i1) i1 = 0; else {
    i2 = (i1 | 4) + -1 | 0;
    if (i2 >>> 0 < 2e3) {
     i1 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 429036 | 0, 1162) | 0;
     i11 = gb + 64016 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     HEAP32[i14 >> 2] = i1;
     i13 = i4;
     HEAP32[i13 >> 2] = i10;
     HEAP32[i13 + 4 >> 2] = i11;
     break;
    }
   } while (0);
   i2 = i1 + 3 & -4;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
   do {
    i13 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    __ZN19SkinnedMeshRenderer8SkinMeshEP12SkinMeshInfobR9GfxDeviceP22GeometryJobInstructionRi(HEAP32[(HEAP32[i22 >> 2] | 0) + (i1 << 2) >> 2] | 0, i13, (i13 | 0) == (i5 | 0), i3, i2, i12);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
   i14 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 248 >> 2] | 0, i3 | 0, fb + 3391 | 0, i2 | 0, HEAP32[i12 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i14, i4);
  }
  if (i20 | 0) {
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = i20 + 12 | 0;
   i1 = HEAP32[i15 >> 2] << 2;
   i2 = i1 >> 2;
   HEAP32[i6 >> 2] = i2;
   i3 = i20 + 16 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i20 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i20 >> 2] = i1;
    break;
   } else i1 = HEAP32[i20 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  }
 }
 __ZN18JobBatchDispatcherD2Ev(i24);
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i16);
  HEAP32[i23 >> 2] = 0;
 }
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i18);
  HEAP32[i22 >> 2] = 0;
 }
 if (!i21) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i21);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL9visualizeERNS_2Cm12RenderOutputE(i1, i53) {
 i1 = i1 | 0;
 i53 = i53 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, f56 = f0, i57 = 0, i58 = 0, f59 = f0, i60 = 0, i61 = 0, f62 = f0, f63 = f0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i55 + 84 | 0;
 i43 = i55 + 72 | 0;
 i46 = i55 + 60 | 0;
 i47 = i55 + 48 | 0;
 i48 = i55 + 36 | 0;
 i49 = i55 + 24 | 0;
 i50 = i55 + 12 | 0;
 i51 = i55;
 i52 = i1 + 56 | 0;
 if (!(HEAP32[i52 >> 2] | 0)) {
  STACKTOP = i55;
  return;
 }
 i24 = i1 + 32 | 0;
 i44 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i24 >> 2] | 0) | 0;
 f45 = Math_fround(HEAPF32[i44 + 1408 >> 2]);
 i25 = HEAP32[HEAP32[i1 + 48 >> 2] >> 2] | 0;
 i24 = (i25 | 0) == (__ZNK5physx2Sc8ShapeSim8getRbSimEv(HEAP32[i24 >> 2] | 0) | 0);
 f23 = i24 ? Math_fround(1.0) : Math_fround(-1.0);
 i24 = i42 + 4 | 0;
 i25 = i42 + 8 | 0;
 i26 = i43 + 4 | 0;
 i27 = i43 + 8 | 0;
 f28 = Math_fround(f45 * Math_fround(.100000001));
 i29 = i46 + 4 | 0;
 i30 = i46 + 8 | 0;
 i31 = i47 + 4 | 0;
 i32 = i47 + 8 | 0;
 i33 = i48 + 4 | 0;
 i34 = i48 + 8 | 0;
 i35 = i49 + 4 | 0;
 i36 = i49 + 8 | 0;
 i37 = i50 + 4 | 0;
 i38 = i50 + 8 | 0;
 i39 = i51 + 4 | 0;
 i40 = i51 + 8 | 0;
 i41 = 0;
 while (1) {
  i3 = HEAP32[i52 >> 2] | 0;
  L6 : do if (!i3) {
   i2 = 0;
   i22 = i41;
   i4 = 0;
   i5 = 0;
  } else {
   i1 = HEAP32[i3 + 40 >> 2] | 0;
   i4 = HEAP32[i3 + 44 >> 2] | 0;
   i5 = HEAP32[i3 + 48 >> 2] | 0;
   i2 = (HEAP16[i3 + 114 >> 1] & 16) == 0 ? 0 : i4 + (i5 + 15 & -16) | 0;
   if (!(HEAP16[i3 + 36 >> 1] | 0)) i2 = 0; else if (!i41) {
    i22 = (i1 | 0) != 0 & 1;
    break;
   } else i2 = 1;
   if (!i1) {
    i2 = 0;
    i22 = i41;
    i4 = 0;
    i5 = 0;
   } else {
    while (1) {
     if ((i2 | 0) == (i41 | 0)) break;
     i1 = HEAP32[i1 >> 2] | 0;
     if (!i1) {
      i2 = 0;
      i22 = i41;
      i4 = 0;
      i5 = 0;
      break L6;
     } else i2 = i2 + 1 | 0;
    }
    i4 = i1;
    i5 = HEAPU16[i4 + 4 >> 1] | 0;
    i2 = i1 + (i5 + 15 & 131056) | 0;
    i22 = ((HEAP32[i4 >> 2] | 0) != 0 & 1) + i41 | 0;
    i4 = i4 + 8 | 0;
    i5 = i5 + -8 | 0;
   }
  } while (0);
  f6 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i44, 10));
  f8 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i44, 8));
  f9 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i44, 9));
  f7 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i44, 7));
  i1 = i4;
  if (!i5) {
   i19 = 0;
   i20 = 0;
   i21 = 0;
   i1 = 0;
  } else {
   i21 = HEAPU16[i1 + 2 >> 1] | 0;
   i18 = i21 & 2;
   i16 = (i18 | 0) != 0;
   i19 = i16;
   i20 = i16 ? 4 : 32;
   i21 = i16 ? 72 : i21 << 3 & 8 | 16;
   i1 = i1 + (i18 << 3 | 4) | 0;
  }
  if ((i1 - i4 | 0) >>> 0 < i5 >>> 0) {
   i18 = (i2 | 0) != 0 & f6 != Math_fround(0.0);
   f17 = Math_fround(f45 * f6);
   i15 = f7 != Math_fround(0.0);
   i16 = f8 != Math_fround(0.0);
   f8 = Math_fround(f45 * f8);
   i14 = f9 != Math_fround(0.0);
   f7 = Math_fround(f45 * f9);
   i13 = i1;
   do {
    i11 = HEAP16[i13 >> 1] | 0;
    i12 = i11 & 65535;
    i1 = i13;
    i13 = i13 + ((Math_imul(i12, i21) | 0) + i20) | 0;
    i3 = i1 + i20 | 0;
    L24 : do if (i11 << 16 >> 16) {
     i11 = i1 + 4 | 0;
     if (i18) {
      i10 = 0;
      i1 = i3;
      while (1) {
       i10 = i10 + 1 | 0;
       f6 = Math_fround(f17 * Math_fround(HEAPF32[i2 >> 2]));
       if (f6 != Math_fround(0.0)) {
        i3 = __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i53, 1) | 0, 16711680) | 0;
        i60 = i1;
        HEAP32[i42 >> 2] = HEAP32[i1 >> 2];
        i58 = i60 + 4 | 0;
        HEAP32[i24 >> 2] = HEAP32[i58 >> 2];
        i57 = i60 + 8 | 0;
        HEAP32[i25 >> 2] = HEAP32[i57 >> 2];
        i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i42) | 0;
        i61 = i19 ? i1 + 24 | 0 : i11;
        f56 = Math_fround(f6 * Math_fround(HEAPF32[i61 >> 2]));
        f59 = Math_fround(f6 * Math_fround(HEAPF32[i61 + 4 >> 2]));
        f56 = Math_fround(f23 * f56);
        f59 = Math_fround(f23 * f59);
        f9 = Math_fround(f23 * Math_fround(f6 * Math_fround(HEAPF32[i61 + 8 >> 2])));
        f56 = Math_fround(f56 + Math_fround(HEAPF32[i60 >> 2]));
        f6 = Math_fround(f59 + Math_fround(HEAPF32[i58 >> 2]));
        f9 = Math_fround(f9 + Math_fround(HEAPF32[i57 >> 2]));
        HEAPF32[i43 >> 2] = f56;
        HEAPF32[i26 >> 2] = f6;
        HEAPF32[i27 >> 2] = f9;
        __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i43) | 0;
       }
       if (i15) {
        i61 = i1;
        f9 = Math_fround(HEAPF32[i1 >> 2]);
        f62 = Math_fround(HEAPF32[i61 + 4 >> 2]);
        f59 = Math_fround(HEAPF32[i61 + 8 >> 2]);
        __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i53, 1) | 0, -65536) | 0;
        f56 = Math_fround(f62 + Math_fround(0.0));
        f6 = Math_fround(f59 + Math_fround(0.0));
        HEAPF32[i46 >> 2] = Math_fround(f9 - f28);
        HEAPF32[i29 >> 2] = f56;
        HEAPF32[i30 >> 2] = f6;
        i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i46) | 0;
        HEAPF32[i47 >> 2] = Math_fround(f28 + f9);
        HEAPF32[i31 >> 2] = f56;
        HEAPF32[i32 >> 2] = f6;
        __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i47) | 0;
        f9 = Math_fround(f9 + Math_fround(0.0));
        f63 = Math_fround(f62 - f28);
        HEAPF32[i48 >> 2] = f9;
        HEAPF32[i33 >> 2] = f63;
        HEAPF32[i34 >> 2] = f6;
        i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i48) | 0;
        f62 = Math_fround(f28 + f62);
        HEAPF32[i49 >> 2] = f9;
        HEAPF32[i35 >> 2] = f62;
        HEAPF32[i36 >> 2] = f6;
        __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i49) | 0;
        f6 = Math_fround(f59 - f28);
        HEAPF32[i50 >> 2] = f9;
        HEAPF32[i37 >> 2] = f56;
        HEAPF32[i38 >> 2] = f6;
        i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i50) | 0;
        f59 = Math_fround(f28 + f59);
        HEAPF32[i51 >> 2] = f9;
        HEAPF32[i39 >> 2] = f56;
        HEAPF32[i40 >> 2] = f59;
        __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i51) | 0;
       }
       if ((i10 | 0) == (i12 | 0)) break L24; else i1 = i1 + i21 | 0;
      }
     } else i10 = 0;
     do {
      i10 = i10 + 1 | 0;
      if (i16) {
       i1 = 255;
       f6 = f8;
       i54 = 26;
      } else if (i14) {
       i1 = 16776960;
       f6 = Math_fround(Math_abs(Math_fround(f7 * Math_fround(HEAPF32[i3 + 12 >> 2]))));
       i54 = 26;
      }
      if ((i54 | 0) == 26) {
       i54 = 0;
       if (f6 != Math_fround(0.0)) {
        i61 = __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i53, 1) | 0, i1) | 0;
        i57 = i3;
        HEAP32[i42 >> 2] = HEAP32[i3 >> 2];
        i58 = i57 + 4 | 0;
        HEAP32[i24 >> 2] = HEAP32[i58 >> 2];
        i60 = i57 + 8 | 0;
        HEAP32[i25 >> 2] = HEAP32[i60 >> 2];
        i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i42) | 0;
        i1 = i19 ? i3 + 24 | 0 : i11;
        f59 = Math_fround(f6 * Math_fround(HEAPF32[i1 >> 2]));
        f62 = Math_fround(f6 * Math_fround(HEAPF32[i1 + 4 >> 2]));
        f59 = Math_fround(f23 * f59);
        f62 = Math_fround(f23 * f62);
        f63 = Math_fround(f23 * Math_fround(f6 * Math_fround(HEAPF32[i1 + 8 >> 2])));
        f59 = Math_fround(f59 + Math_fround(HEAPF32[i57 >> 2]));
        f62 = Math_fround(f62 + Math_fround(HEAPF32[i58 >> 2]));
        f63 = Math_fround(f63 + Math_fround(HEAPF32[i60 >> 2]));
        HEAPF32[i43 >> 2] = f59;
        HEAPF32[i26 >> 2] = f62;
        HEAPF32[i27 >> 2] = f63;
        __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i43) | 0;
       }
      }
      if (i15) {
       i61 = i3;
       f59 = Math_fround(HEAPF32[i3 >> 2]);
       f9 = Math_fround(HEAPF32[i61 + 4 >> 2]);
       f63 = Math_fround(HEAPF32[i61 + 8 >> 2]);
       __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i53, 1) | 0, -65536) | 0;
       f62 = Math_fround(f9 + Math_fround(0.0));
       f56 = Math_fround(f63 + Math_fround(0.0));
       HEAPF32[i46 >> 2] = Math_fround(f59 - f28);
       HEAPF32[i29 >> 2] = f62;
       HEAPF32[i30 >> 2] = f56;
       i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i46) | 0;
       HEAPF32[i47 >> 2] = Math_fround(f28 + f59);
       HEAPF32[i31 >> 2] = f62;
       HEAPF32[i32 >> 2] = f56;
       __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i47) | 0;
       f59 = Math_fround(f59 + Math_fround(0.0));
       f6 = Math_fround(f9 - f28);
       HEAPF32[i48 >> 2] = f59;
       HEAPF32[i33 >> 2] = f6;
       HEAPF32[i34 >> 2] = f56;
       i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i48) | 0;
       f9 = Math_fround(f28 + f9);
       HEAPF32[i49 >> 2] = f59;
       HEAPF32[i35 >> 2] = f9;
       HEAPF32[i36 >> 2] = f56;
       __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i49) | 0;
       f56 = Math_fround(f63 - f28);
       HEAPF32[i50 >> 2] = f59;
       HEAPF32[i37 >> 2] = f62;
       HEAPF32[i38 >> 2] = f56;
       i61 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i53, i50) | 0;
       f63 = Math_fround(f28 + f63);
       HEAPF32[i51 >> 2] = f59;
       HEAPF32[i39 >> 2] = f62;
       HEAPF32[i40 >> 2] = f63;
       __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i61, i51) | 0;
      }
      i3 = i3 + i21 | 0;
     } while ((i10 | 0) != (i12 | 0));
    } while (0);
   } while ((i13 - i4 | 0) >>> 0 < i5 >>> 0);
  }
  if ((i22 | 0) == (i41 | 0)) break; else i41 = i22;
 }
 STACKTOP = i55;
 return;
}

function _LzmaDec_TryDummy(i17, i11, i7) {
 i17 = i17 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i9 = HEAP32[i17 + 28 >> 2] | 0;
 i12 = HEAP32[i17 + 32 >> 2] | 0;
 i38 = i11 + i7 | 0;
 i31 = HEAP32[i17 + 16 >> 2] | 0;
 i24 = HEAP32[i17 + 52 >> 2] | 0;
 i14 = HEAP32[i17 + 44 >> 2] | 0;
 i26 = (1 << HEAP32[i17 + 8 >> 2]) + -1 & i14;
 i23 = i24 << 4;
 i13 = HEAPU16[i31 + (i23 << 1) + (i26 << 1) >> 1] | 0;
 do if (i9 >>> 0 < 16777216) if ((i7 | 0) < 1) {
  i38 = 0;
  return i38 | 0;
 } else {
  i22 = i11 + 1 | 0;
  i9 = i9 << 8;
  i21 = HEAPU8[i11 >> 0] | 0 | i12 << 8;
  break;
 } else {
  i22 = i11;
  i21 = i12;
 } while (0);
 i20 = Math_imul(i9 >>> 11, i13) | 0;
 if (i21 >>> 0 < i20 >>> 0) {
  i11 = i31 + 3692 | 0;
  if (HEAP32[i17 + 48 >> 2] | i14) {
   i12 = HEAP32[i17 >> 2] | 0;
   i7 = HEAP32[i17 + 36 >> 2] | 0;
   if (!i7) i7 = HEAP32[i17 + 40 >> 2] | 0;
   i11 = i11 + ((((HEAPU8[(HEAP32[i17 + 20 >> 2] | 0) + (i7 + -1) >> 0] | 0) >>> (8 - i12 | 0)) + (((1 << HEAP32[i17 + 4 >> 2]) + -1 & i14) << i12) | 0) * 768 << 1) | 0;
  }
  if (i24 >>> 0 < 7) {
   i7 = 1;
   i15 = i22;
   i12 = i20;
   i13 = i21;
   while (1) {
    i14 = HEAPU16[i11 + (i7 << 1) >> 1] | 0;
    if (i12 >>> 0 < 16777216) {
     if (i15 >>> 0 >= i38 >>> 0) {
      i33 = 0;
      i25 = 98;
      break;
     }
     i16 = i15 + 1 | 0;
     i12 = i12 << 8;
     i13 = HEAPU8[i15 >> 0] | 0 | i13 << 8;
    } else i16 = i15;
    i14 = Math_imul(i12 >>> 11, i14) | 0;
    if (i13 >>> 0 < i14 >>> 0) {
     i7 = i7 << 1;
     i12 = i14;
    } else {
     i7 = i7 << 1 | 1;
     i12 = i12 - i14 | 0;
     i13 = i13 - i14 | 0;
    }
    if (i7 >>> 0 < 256) i15 = i16; else {
     i35 = 1;
     i36 = i16;
     i37 = i12;
     i25 = 97;
     break;
    }
   }
   if ((i25 | 0) == 97) {
    i37 = i37 >>> 0 > 16777215;
    i38 = i36 >>> 0 < i38 >>> 0;
    i38 = i37 | i38;
    i38 = i38 ? i35 : 0;
    return i38 | 0;
   } else if ((i25 | 0) == 98) return i33 | 0;
  }
  i7 = HEAP32[i17 + 36 >> 2] | 0;
  i12 = HEAP32[i17 + 56 >> 2] | 0;
  if (i7 >>> 0 < i12 >>> 0) i13 = HEAP32[i17 + 40 >> 2] | 0; else i13 = 0;
  i14 = 1;
  i19 = 256;
  i17 = HEAPU8[(HEAP32[i17 + 20 >> 2] | 0) + (i7 - i12 + i13) >> 0] | 0;
  i16 = i22;
  i12 = i20;
  i13 = i21;
  while (1) {
   i17 = i17 << 1;
   i7 = i17 & i19;
   i15 = HEAPU16[i11 + (i19 << 1) + (i7 << 1) + (i14 << 1) >> 1] | 0;
   if (i12 >>> 0 < 16777216) {
    if (i16 >>> 0 >= i38 >>> 0) {
     i33 = 0;
     i25 = 98;
     break;
    }
    i18 = i16 + 1 | 0;
    i12 = i12 << 8;
    i13 = HEAPU8[i16 >> 0] | 0 | i13 << 8;
   } else i18 = i16;
   i15 = Math_imul(i12 >>> 11, i15) | 0;
   if (i13 >>> 0 < i15 >>> 0) {
    i14 = i14 << 1;
    i7 = i7 ^ i19;
    i12 = i15;
   } else {
    i14 = i14 << 1 | 1;
    i12 = i12 - i15 | 0;
    i13 = i13 - i15 | 0;
   }
   if (i14 >>> 0 >= 256) {
    i35 = 1;
    i36 = i18;
    i37 = i12;
    i25 = 97;
    break;
   } else {
    i19 = i7;
    i16 = i18;
   }
  }
  if ((i25 | 0) == 97) {
   i37 = i37 >>> 0 > 16777215;
   i38 = i36 >>> 0 < i38 >>> 0;
   i38 = i37 | i38;
   i38 = i38 ? i35 : 0;
   return i38 | 0;
  } else if ((i25 | 0) == 98) return i33 | 0;
 }
 i9 = i9 - i20 | 0;
 i7 = i21 - i20 | 0;
 i11 = HEAPU16[i31 + 384 + (i24 << 1) >> 1] | 0;
 do if (i9 >>> 0 < 16777216) if (i22 >>> 0 < i38 >>> 0) {
  i9 = i9 << 8;
  i7 = HEAPU8[i22 >> 0] | 0 | i7 << 8;
  i13 = i22 + 1 | 0;
  break;
 } else {
  i38 = 0;
  return i38 | 0;
 } else i13 = i22; while (0);
 i12 = Math_imul(i9 >>> 11, i11) | 0;
 if (i7 >>> 0 < i12 >>> 0) {
  i19 = 2;
  i18 = 0;
  i15 = i31 + 1636 | 0;
  i9 = i12;
 } else {
  i11 = i9 - i12 | 0;
  i9 = i7 - i12 | 0;
  i7 = HEAPU16[i31 + 408 + (i24 << 1) >> 1] | 0;
  do if (i11 >>> 0 < 16777216) if (i13 >>> 0 < i38 >>> 0) {
   i11 = i11 << 8;
   i9 = HEAPU8[i13 >> 0] | 0 | i9 << 8;
   i14 = i13 + 1 | 0;
   break;
  } else {
   i38 = 0;
   return i38 | 0;
  } else i14 = i13; while (0);
  i12 = Math_imul(i11 >>> 11, i7) | 0;
  do if (i9 >>> 0 < i12 >>> 0) {
   i7 = HEAPU16[i31 + 480 + (i23 << 1) + (i26 << 1) >> 1] | 0;
   do if (i12 >>> 0 < 16777216) if (i14 >>> 0 < i38 >>> 0) {
    i11 = i14 + 1 | 0;
    i12 = i12 << 8;
    i9 = HEAPU8[i14 >> 0] | 0 | i9 << 8;
    break;
   } else {
    i38 = 0;
    return i38 | 0;
   } else i11 = i14; while (0);
   i7 = Math_imul(i12 >>> 11, i7) | 0;
   if (i9 >>> 0 >= i7 >>> 0) {
    i13 = i11;
    i11 = i12 - i7 | 0;
    i7 = i9 - i7 | 0;
    break;
   }
   if (i7 >>> 0 < 16777216) return (i11 >>> 0 < i38 >>> 0 ? 3 : 0) | 0; else {
    i38 = 3;
    return i38 | 0;
   }
  } else {
   i11 = i11 - i12 | 0;
   i7 = i9 - i12 | 0;
   i9 = HEAPU16[i31 + 432 + (i24 << 1) >> 1] | 0;
   do if (i11 >>> 0 < 16777216) if (i14 >>> 0 < i38 >>> 0) {
    i13 = i14 + 1 | 0;
    i11 = i11 << 8;
    i7 = HEAPU8[i14 >> 0] | 0 | i7 << 8;
    break;
   } else {
    i38 = 0;
    return i38 | 0;
   } else i13 = i14; while (0);
   i9 = Math_imul(i11 >>> 11, i9) | 0;
   if (i7 >>> 0 < i9 >>> 0) i11 = i9; else {
    i11 = i11 - i9 | 0;
    i7 = i7 - i9 | 0;
    i12 = HEAPU16[i31 + 456 + (i24 << 1) >> 1] | 0;
    do if (i11 >>> 0 < 16777216) if (i13 >>> 0 < i38 >>> 0) {
     i9 = i13 + 1 | 0;
     i11 = i11 << 8;
     i7 = HEAPU8[i13 >> 0] | 0 | i7 << 8;
     break;
    } else {
     i38 = 0;
     return i38 | 0;
    } else i9 = i13; while (0);
    i24 = Math_imul(i11 >>> 11, i12) | 0;
    i23 = i7 >>> 0 < i24 >>> 0;
    i13 = i9;
    i11 = i23 ? i24 : i11 - i24 | 0;
    i7 = i7 - (i23 ? 0 : i24) | 0;
   }
  } while (0);
  i19 = 3;
  i18 = 12;
  i15 = i31 + 2664 | 0;
  i9 = i11;
 }
 i12 = HEAPU16[i15 >> 1] | 0;
 do if (i9 >>> 0 < 16777216) if (i13 >>> 0 < i38 >>> 0) {
  i14 = i13 + 1 | 0;
  i11 = i9 << 8;
  i7 = HEAPU8[i13 >> 0] | 0 | i7 << 8;
  break;
 } else {
  i38 = 0;
  return i38 | 0;
 } else {
  i14 = i13;
  i11 = i9;
 } while (0);
 i9 = Math_imul(i11 >>> 11, i12) | 0;
 do if (i7 >>> 0 < i9 >>> 0) {
  i15 = i15 + 4 + (i26 << 3 << 1) | 0;
  i16 = 0;
  i17 = 8;
  i12 = i14;
 } else {
  i11 = i11 - i9 | 0;
  i7 = i7 - i9 | 0;
  i9 = HEAPU16[i15 + 2 >> 1] | 0;
  do if (i11 >>> 0 < 16777216) if (i14 >>> 0 < i38 >>> 0) {
   i12 = i14 + 1 | 0;
   i11 = i11 << 8;
   i7 = HEAPU8[i14 >> 0] | 0 | i7 << 8;
   break;
  } else {
   i38 = 0;
   return i38 | 0;
  } else i12 = i14; while (0);
  i13 = Math_imul(i11 >>> 11, i9) | 0;
  if (i7 >>> 0 < i13 >>> 0) {
   i15 = i15 + 260 + (i26 << 3 << 1) | 0;
   i16 = 8;
   i17 = 8;
   i9 = i13;
   break;
  } else {
   i15 = i15 + 516 | 0;
   i16 = 16;
   i17 = 256;
   i9 = i11 - i13 | 0;
   i7 = i7 - i13 | 0;
   break;
  }
 } while (0);
 i13 = 1;
 while (1) {
  i11 = HEAPU16[i15 + (i13 << 1) >> 1] | 0;
  if (i9 >>> 0 < 16777216) {
   if (i12 >>> 0 >= i38 >>> 0) {
    i33 = 0;
    i25 = 98;
    break;
   }
   i10 = i12 + 1 | 0;
   i9 = i9 << 8;
   i8 = HEAPU8[i12 >> 0] | 0 | i7 << 8;
  } else {
   i10 = i12;
   i8 = i7;
  }
  i7 = Math_imul(i9 >>> 11, i11) | 0;
  if (i8 >>> 0 < i7 >>> 0) {
   i27 = i13 << 1;
   i28 = i7;
  } else {
   i27 = i13 << 1 | 1;
   i28 = i9 - i7 | 0;
   i8 = i8 - i7 | 0;
  }
  if (i27 >>> 0 < i17 >>> 0) {
   i13 = i27;
   i12 = i10;
   i9 = i28;
   i7 = i8;
  } else break;
 }
 if ((i25 | 0) == 98) return i33 | 0;
 i7 = i27 - i17 + i16 | 0;
 if (i18 >>> 0 >= 4) {
  i37 = i19;
  i35 = i10;
  i36 = i28;
  i36 = i36 >>> 0 > 16777215;
  i38 = i35 >>> 0 < i38 >>> 0;
  i38 = i36 | i38;
  i38 = i38 ? i37 : 0;
  return i38 | 0;
 }
 i12 = i31 + 864 + ((i7 >>> 0 > 3 ? 3 : i7) << 6 << 1) | 0;
 i11 = 1;
 i7 = i28;
 while (1) {
  i9 = HEAPU16[i12 + (i11 << 1) >> 1] | 0;
  if (i7 >>> 0 < 16777216) {
   if (i10 >>> 0 >= i38 >>> 0) {
    i33 = 0;
    i25 = 98;
    break;
   }
   i5 = i10 + 1 | 0;
   i4 = i7 << 8;
   i1 = HEAPU8[i10 >> 0] | 0 | i8 << 8;
  } else {
   i5 = i10;
   i4 = i7;
   i1 = i8;
  }
  i7 = Math_imul(i4 >>> 11, i9) | 0;
  if (i1 >>> 0 < i7 >>> 0) {
   i29 = i11 << 1;
   i4 = i7;
  } else {
   i29 = i11 << 1 | 1;
   i4 = i4 - i7 | 0;
   i1 = i1 - i7 | 0;
  }
  if (i29 >>> 0 < 64) {
   i11 = i29;
   i10 = i5;
   i7 = i4;
   i8 = i1;
  } else break;
 }
 if ((i25 | 0) == 98) return i33 | 0;
 i7 = i29 + -64 | 0;
 if (i7 >>> 0 <= 3) {
  i37 = i19;
  i35 = i5;
  i36 = i4;
  i36 = i36 >>> 0 > 16777215;
  i38 = i35 >>> 0 < i38 >>> 0;
  i38 = i36 | i38;
  i38 = i38 ? i37 : 0;
  return i38 | 0;
 }
 i8 = i7 >>> 1;
 i9 = i8 + -1 | 0;
 do if (i7 >>> 0 < 14) {
  i32 = i9;
  i34 = i31 + 1376 + ((i7 & 1 | 2) << i9 << 1) + (64 - i29 << 1) + -2 | 0;
  i6 = i5;
  i3 = i4;
  i2 = i1;
 } else {
  i7 = i8 + -5 | 0;
  while (1) {
   if (i4 >>> 0 < 16777216) {
    if (i5 >>> 0 >= i38 >>> 0) {
     i33 = 0;
     i25 = 98;
     break;
    }
    i30 = i5 + 1 | 0;
    i4 = i4 << 8;
    i1 = HEAPU8[i5 >> 0] | 0 | i1 << 8;
   } else i30 = i5;
   i4 = i4 >>> 1;
   i1 = i1 - (((i1 - i4 | 0) >>> 31) + 2147483647 & i4) | 0;
   i7 = i7 + -1 | 0;
   if (!i7) {
    i25 = 88;
    break;
   } else i5 = i30;
  }
  if ((i25 | 0) == 88) {
   i32 = 4;
   i34 = i31 + 1604 | 0;
   i6 = i30;
   i3 = i4;
   i2 = i1;
   break;
  } else if ((i25 | 0) == 98) return i33 | 0;
 } while (0);
 i1 = 1;
 i8 = i32;
 while (1) {
  i4 = HEAPU16[i34 + (i1 << 1) >> 1] | 0;
  if (i3 >>> 0 < 16777216) {
   if (i6 >>> 0 >= i38 >>> 0) {
    i33 = 0;
    i25 = 98;
    break;
   }
   i7 = i6 + 1 | 0;
   i5 = i3 << 8;
   i2 = HEAPU8[i6 >> 0] | 0 | i2 << 8;
  } else {
   i7 = i6;
   i5 = i3;
  }
  i3 = Math_imul(i5 >>> 11, i4) | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   i1 = i1 << 1;
   i4 = i3;
  } else {
   i1 = i1 << 1 | 1;
   i4 = i5 - i3 | 0;
   i2 = i2 - i3 | 0;
  }
  i8 = i8 + -1 | 0;
  if (!i8) {
   i35 = i19;
   i36 = i7;
   i37 = i4;
   i25 = 97;
   break;
  } else {
   i6 = i7;
   i3 = i4;
  }
 }
 if ((i25 | 0) == 97) {
  i37 = i37 >>> 0 > 16777215;
  i38 = i36 >>> 0 < i38 >>> 0;
  i38 = i37 | i38;
  i38 = i38 ? i35 : 0;
  return i38 | 0;
 } else if ((i25 | 0) == 98) return i33 | 0;
 return 0;
}

function __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i12, i5, i7, i6, i9) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 292 | 0;
 i10 = i13 + 280 | 0;
 i4 = i13;
 i8 = i13 + 220 | 0;
 i2 = i13 + 160 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 if (f3 == Math_fround(1.0)) {
  f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  if (f1 == Math_fround(1.0)) if (Math_fround(HEAPF32[i6 + 8 >> 2]) == Math_fround(1.0)) {
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i5 + 16;
   HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 4 >> 2] = 2;
   HEAP32[i4 >> 2] = gb + 85836 + 8;
   HEAP32[i4 + 8 >> 2] = i5;
   HEAP32[i4 + 16 >> 2] = i11;
   i11 = i4 + 68 | 0;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i4 + 116 >> 2] = i9;
   f18 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   HEAPF32[i4 + 72 >> 2] = Math_fround(f18 * f18);
   i9 = i4 + 88 | 0;
   f16 = Math_fround(HEAPF32[i12 >> 2]);
   f20 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   f16 = Math_fround(f16 - f20);
   f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f22 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f15 = Math_fround(f15 - f22);
   f17 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f16 = Math_fround(f16 * Math_fround(2.0));
   f15 = Math_fround(f15 * Math_fround(2.0));
   f17 = Math_fround(Math_fround(f17 - f25) * Math_fround(2.0));
   f24 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f26 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
   f23 = Math_fround(HEAPF32[i7 >> 2]);
   f3 = Math_fround(f16 * f23);
   f21 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f3 = Math_fround(f3 + Math_fround(f15 * f21));
   f19 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f3 = Math_fround(f3 + Math_fround(f17 * f19));
   f14 = Math_fround(Math_fround(f23 * f3) + Math_fround(Math_fround(f16 * f26) - Math_fround(f24 * Math_fround(Math_fround(f17 * f21) - Math_fround(f15 * f19)))));
   f1 = Math_fround(Math_fround(f21 * f3) + Math_fround(Math_fround(f15 * f26) - Math_fround(f24 * Math_fround(Math_fround(f16 * f19) - Math_fround(f17 * f23)))));
   f3 = Math_fround(Math_fround(Math_fround(f17 * f26) - Math_fround(f24 * Math_fround(Math_fround(f15 * f23) - Math_fround(f16 * f21)))) + Math_fround(f19 * f3));
   HEAPF32[i9 >> 2] = f14;
   HEAPF32[i4 + 92 >> 2] = f1;
   HEAPF32[i4 + 96 >> 2] = f3;
   f20 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) - f20);
   f22 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) - f22);
   f20 = Math_fround(f20 * Math_fround(2.0));
   f22 = Math_fround(f22 * Math_fround(2.0));
   f25 = Math_fround(Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) - f25) * Math_fround(2.0));
   f16 = Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f21 * f22)) + Math_fround(f19 * f25));
   f15 = Math_fround(Math_fround(f23 * f16) + Math_fround(Math_fround(f26 * f20) - Math_fround(f24 * Math_fround(Math_fround(f21 * f25) - Math_fround(f19 * f22)))));
   f17 = Math_fround(Math_fround(f21 * f16) + Math_fround(Math_fround(f26 * f22) - Math_fround(f24 * Math_fround(Math_fround(f19 * f20) - Math_fround(f23 * f25)))));
   f16 = Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)))) + Math_fround(f19 * f16));
   HEAPF32[i4 + 100 >> 2] = f15;
   HEAPF32[i4 + 104 >> 2] = f17;
   HEAPF32[i4 + 108 >> 2] = f16;
   HEAPF32[i4 + 112 >> 2] = f18;
   HEAPF32[i8 >> 2] = f18;
   HEAPF32[i8 + 4 >> 2] = f18;
   HEAPF32[i8 + 8 >> 2] = f18;
   f1 = Math_fround(f17 - f1);
   f3 = Math_fround(f16 - f3);
   HEAPF32[i2 >> 2] = Math_fround(f15 - f14);
   HEAPF32[i2 + 4 >> 2] = f1;
   HEAPF32[i2 + 8 >> 2] = f3;
   __ZN5physx2Gu15MeshRayCollider7collideILi1ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i9, i2, Math_fround(1.0), 1, i10, i4, i8);
   i12 = HEAP8[i11 >> 0] | 0;
   i12 = i12 << 24 >> 24 != 0;
   STACKTOP = i13;
   return i12 | 0;
  } else f1 = Math_fround(1.0);
 } else f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f32 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f33 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f24 = Math_fround(f25 + f25);
 f30 = Math_fround(f20 + f20);
 f16 = Math_fround(f32 + f32);
 f27 = Math_fround(f20 * f30);
 f18 = Math_fround(f32 * f16);
 f20 = Math_fround(f24 * f20);
 f29 = Math_fround(f24 * f32);
 f28 = Math_fround(f24 * f33);
 f32 = Math_fround(f30 * f32);
 f30 = Math_fround(f30 * f33);
 f33 = Math_fround(f16 * f33);
 f16 = Math_fround(Math_fround(Math_fround(1.0) - f27) - f18);
 f22 = Math_fround(f20 + f33);
 f15 = Math_fround(f29 - f30);
 f33 = Math_fround(f20 - f33);
 f24 = Math_fround(Math_fround(1.0) - Math_fround(f25 * f24));
 f18 = Math_fround(f24 - f18);
 f25 = Math_fround(f32 + f28);
 f30 = Math_fround(f29 + f30);
 f28 = Math_fround(f32 - f28);
 f27 = Math_fround(f24 - f27);
 f24 = Math_fround(f3 * f16);
 f32 = Math_fround(f3 * f33);
 f29 = Math_fround(f3 * f30);
 f20 = Math_fround(f22 * f1);
 f31 = Math_fround(f18 * f1);
 f1 = Math_fround(f28 * f1);
 f26 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f17 = Math_fround(f15 * f26);
 f3 = Math_fround(f25 * f26);
 f26 = Math_fround(f27 * f26);
 f19 = Math_fround(Math_fround(Math_fround(f16 * f32) + Math_fround(f22 * f31)) + Math_fround(f15 * f3));
 f21 = Math_fround(Math_fround(Math_fround(f16 * f29) + Math_fround(f22 * f1)) + Math_fround(f15 * f26));
 f14 = Math_fround(Math_fround(Math_fround(f33 * f24) + Math_fround(f18 * f20)) + Math_fround(f25 * f17));
 f23 = Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f18 * f31)) + Math_fround(f25 * f3));
 f25 = Math_fround(Math_fround(Math_fround(f33 * f29) + Math_fround(f18 * f1)) + Math_fround(f25 * f26));
 f18 = Math_fround(Math_fround(Math_fround(f30 * f24) + Math_fround(f28 * f20)) + Math_fround(f27 * f17));
 f3 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f28 * f31)) + Math_fround(f27 * f3));
 f26 = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f28 * f1)) + Math_fround(f27 * f26));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f16 * f24) + Math_fround(f22 * f20)) + Math_fround(f15 * f17));
 HEAPF32[i11 + 4 >> 2] = f19;
 HEAPF32[i11 + 8 >> 2] = f21;
 HEAPF32[i11 + 12 >> 2] = f14;
 HEAPF32[i11 + 16 >> 2] = f23;
 HEAPF32[i11 + 20 >> 2] = f25;
 HEAPF32[i11 + 24 >> 2] = f18;
 HEAPF32[i11 + 28 >> 2] = f3;
 HEAPF32[i11 + 32 >> 2] = f26;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = i5 + 16;
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 4 >> 2] = 2;
 HEAP32[i4 >> 2] = gb + 85856 + 8;
 HEAP32[i4 + 8 >> 2] = i5;
 HEAP32[i4 + 16 >> 2] = i11;
 i11 = i4 + 68 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i4 + 116 >> 2] = i9;
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 HEAPF32[i4 + 72 >> 2] = Math_fround(f26 * f26);
 f3 = Math_fround(HEAPF32[i12 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f3 = Math_fround(f3 - f18);
 f25 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f25 = Math_fround(f25 - f23);
 f14 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f3 = Math_fround(f3 * Math_fround(2.0));
 f25 = Math_fround(f25 * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f14 - f21) * Math_fround(2.0));
 f19 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(f3 * f15);
 f20 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f25 * f20));
 f22 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f14 * f22));
 f24 = Math_fround(Math_fround(f20 * f1) + Math_fround(Math_fround(f25 * f17) - Math_fround(f19 * Math_fround(Math_fround(f3 * f22) - Math_fround(f14 * f15)))));
 f16 = Math_fround(Math_fround(Math_fround(f14 * f17) - Math_fround(f19 * Math_fround(Math_fround(f25 * f15) - Math_fround(f3 * f20)))) + Math_fround(f22 * f1));
 HEAPF32[i4 + 88 >> 2] = Math_fround(Math_fround(f15 * f1) + Math_fround(Math_fround(f3 * f17) - Math_fround(f19 * Math_fround(Math_fround(f14 * f20) - Math_fround(f25 * f22)))));
 HEAPF32[i4 + 92 >> 2] = f24;
 HEAPF32[i4 + 96 >> 2] = f16;
 f18 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) - f18);
 f23 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) - f23);
 f18 = Math_fround(f18 * Math_fround(2.0));
 f23 = Math_fround(f23 * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) - f21) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(f20 * f23)) + Math_fround(f22 * f21));
 f24 = Math_fround(Math_fround(f20 * f16) + Math_fround(Math_fround(f17 * f23) - Math_fround(f19 * Math_fround(Math_fround(f22 * f18) - Math_fround(f15 * f21)))));
 f25 = Math_fround(Math_fround(Math_fround(f17 * f21) - Math_fround(f19 * Math_fround(Math_fround(f15 * f23) - Math_fround(f20 * f18)))) + Math_fround(f22 * f16));
 HEAPF32[i4 + 100 >> 2] = Math_fround(Math_fround(f15 * f16) + Math_fround(Math_fround(f17 * f18) - Math_fround(f19 * Math_fround(Math_fround(f20 * f21) - Math_fround(f22 * f23)))));
 HEAPF32[i4 + 104 >> 2] = f24;
 HEAPF32[i4 + 108 >> 2] = f25;
 HEAPF32[i4 + 112 >> 2] = f26;
 __ZN5physx2Gu3Box6createERKNS0_7CapsuleE(i2, i12);
 __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i8, i2, i7, i6);
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i8, 1, i10, i4, 1);
 i12 = HEAP8[i11 >> 0] | 0;
 i12 = i12 << 24 >> 24 != 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN7mecanim5human25HumanPoseAddAdditiveLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i3, i4, f5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 if (f5 > Math_fround(0.0)) i1 = 0; else return;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  if (HEAP32[i6 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) {
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 596 + (i2 << 2) >> 2]) * f5);
   i2 = i3 + 596 + (i2 << 2) | 0;
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f7);
  }
 } while ((i1 | 0) != 52);
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 if (i2 & 33554432 | 0) {
  i1 = 0;
  do {
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 364 + (i1 << 2) >> 2]) * f5);
   i8 = i3 + 364 + (i1 << 2) | 0;
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f7);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 20);
 }
 if (!(i2 & 67108864)) i1 = 0; else {
  i1 = 0;
  do {
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 500 + (i1 << 2) >> 2]) * f5);
   i8 = i3 + 500 + (i1 << 2) | 0;
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f7);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 20);
  i1 = 0;
 }
 do {
  i8 = i1 + 53 | 0;
  if (HEAP32[i6 + (i8 >>> 5 << 2) >> 2] & 1 << (i8 & 31) | 0) {
   f27 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) >> 2]);
   f19 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 4 >> 2]);
   f27 = Math_fround(f27 * f5);
   f19 = Math_fround(f19 * f5);
   f30 = Math_fround(Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 8 >> 2]) * f5);
   f26 = Math_fround(Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 12 >> 2]) * f5);
   f24 = Math_fround(Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 16 >> 2]) * f5);
   f28 = Math_fround(Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 20 >> 2]) * f5);
   f33 = Math_fround(HEAPF32[i4 + 68 + (i1 << 6) + 24 >> 2]);
   f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f24 * f24)) + Math_fround(Math_fround(f28 * f28) + Math_fround(f33 * f33))))));
   f26 = Math_fround(f26 * f22);
   f24 = Math_fround(f24 * f22);
   f28 = Math_fround(f28 * f22);
   f22 = Math_fround(f33 * f22);
   f33 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 28 >> 2]);
   f21 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 32 >> 2]);
   f33 = Math_fround(f27 * f33);
   f21 = Math_fround(f19 * f21);
   f30 = Math_fround(f30 * Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 36 >> 2]));
   i10 = i3 + 68 + (i1 << 6) + 16 | 0;
   f19 = Math_fround(HEAPF32[i10 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 12 >> 2]);
   i8 = i3 + 68 + (i1 << 6) + 24 | 0;
   f23 = Math_fround(HEAPF32[i8 >> 2]);
   i2 = i3 + 68 + (i1 << 6) + 20 | 0;
   f25 = Math_fround(HEAPF32[i2 >> 2]);
   f34 = Math_fround(f19 * Math_fround(-2.0));
   f20 = Math_fround(f19 * Math_fround(2.0));
   f32 = Math_fround(f34 * f23);
   f7 = Math_fround(f25 * Math_fround(2.0));
   f31 = Math_fround(f25 * Math_fround(-2.0));
   f35 = Math_fround(f23 * f31);
   f29 = Math_fround(f27 * Math_fround(-2.0));
   f16 = Math_fround(f27 * Math_fround(2.0));
   f14 = Math_fround(f23 * f29);
   f18 = Math_fround(Math_fround(f33 + Math_fround(f33 * Math_fround(Math_fround(f19 * f34) - Math_fround(f25 * f7)))) + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f16 * f25) - f32)) + Math_fround(f21 * Math_fround(f35 - Math_fround(f19 * f29)))));
   f16 = Math_fround(Math_fround(f21 + Math_fround(f33 * Math_fround(Math_fround(f27 * f20) - f35))) + Math_fround(Math_fround(f30 * Math_fround(f14 - Math_fround(f34 * f25))) + Math_fround(f21 * Math_fround(Math_fround(f25 * f31) - Math_fround(f27 * f16)))));
   f14 = Math_fround(Math_fround(f30 + Math_fround(f33 * Math_fround(f32 - Math_fround(f27 * f31)))) + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f27 * f29) - Math_fround(f19 * f20))) + Math_fround(f21 * Math_fround(Math_fround(f19 * f7) - f14))));
   i17 = i3 + 68 + (i1 << 6) | 0;
   f7 = Math_fround(HEAPF32[i17 >> 2]);
   i15 = i3 + 68 + (i1 << 6) + 4 | 0;
   f21 = Math_fround(HEAPF32[i15 >> 2]);
   i13 = i3 + 68 + (i1 << 6) + 8 | 0;
   f18 = Math_fround(f7 + f18);
   f16 = Math_fround(f21 + f16);
   f14 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f14);
   f21 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f19) - Math_fround(f28 * f23)) - Math_fround(f22 * f25)) - Math_fround(f24 * f27));
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f23) - Math_fround(f26 * f27)) - Math_fround(f28 * f25)) - Math_fround(f24 * f19));
   f20 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f25) - Math_fround(f28 * f19)) - Math_fround(f26 * f23)) - Math_fround(f22 * f27));
   f19 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f23)) - Math_fround(f22 * f19));
   i9 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   HEAPF32[i17 >> 2] = f18;
   HEAPF32[i15 >> 2] = f16;
   HEAPF32[i13 >> 2] = f14;
   HEAP32[i3 + 68 + (i1 << 6) + 12 >> 2] = i12 ^ -2147483648;
   HEAP32[i10 >> 2] = i11;
   HEAP32[i2 >> 2] = i9 ^ -2147483648;
   HEAPF32[i8 >> 2] = f7;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (!(HEAP32[i6 >> 2] & 1)) i1 = 0; else {
  f23 = Math_fround(HEAPF32[i4 >> 2]);
  f31 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f23 = Math_fround(f23 * f5);
  f31 = Math_fround(f31 * f5);
  f20 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * f5);
  f24 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * f5);
  f26 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) * f5);
  f22 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * f5);
  f16 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f26 * f26)) + Math_fround(Math_fround(f22 * f22) + Math_fround(f16 * f16))))));
  f24 = Math_fround(f24 * f28);
  f26 = Math_fround(f26 * f28);
  f22 = Math_fround(f22 * f28);
  f28 = Math_fround(f16 * f28);
  f16 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f29 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f16 = Math_fround(f23 * f16);
  f29 = Math_fround(f31 * f29);
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i3 + 36 >> 2]));
  i13 = i3 + 16 | 0;
  f31 = Math_fround(HEAPF32[i13 >> 2]);
  f23 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  i1 = i3 + 24 | 0;
  f27 = Math_fround(HEAPF32[i1 >> 2]);
  i17 = i3 + 20 | 0;
  f25 = Math_fround(HEAPF32[i17 >> 2]);
  f14 = Math_fround(f31 * Math_fround(-2.0));
  f30 = Math_fround(f31 * Math_fround(2.0));
  f18 = Math_fround(f14 * f27);
  f35 = Math_fround(f25 * Math_fround(2.0));
  f19 = Math_fround(f25 * Math_fround(-2.0));
  f7 = Math_fround(f27 * f19);
  f21 = Math_fround(f23 * Math_fround(-2.0));
  f33 = Math_fround(f23 * Math_fround(2.0));
  f34 = Math_fround(f27 * f21);
  f32 = Math_fround(Math_fround(f16 + Math_fround(f16 * Math_fround(Math_fround(f31 * f14) - Math_fround(f25 * f35)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f33 * f25) - f18)) + Math_fround(f29 * Math_fround(f7 - Math_fround(f31 * f21)))));
  f33 = Math_fround(Math_fround(f29 + Math_fround(f16 * Math_fround(Math_fround(f23 * f30) - f7))) + Math_fround(Math_fround(f20 * Math_fround(f34 - Math_fround(f14 * f25))) + Math_fround(f29 * Math_fround(Math_fround(f25 * f19) - Math_fround(f23 * f33)))));
  f34 = Math_fround(Math_fround(f20 + Math_fround(f16 * Math_fround(f18 - Math_fround(f23 * f19)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f23 * f21) - Math_fround(f31 * f30))) + Math_fround(f29 * Math_fround(Math_fround(f31 * f35) - f34))));
  f35 = Math_fround(HEAPF32[i3 >> 2]);
  i9 = i3 + 4 | 0;
  f29 = Math_fround(HEAPF32[i9 >> 2]);
  i10 = i3 + 8 | 0;
  f32 = Math_fround(f35 + f32);
  f33 = Math_fround(f29 + f33);
  f34 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f34);
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f31) - Math_fround(f22 * f27)) - Math_fround(f28 * f25)) - Math_fround(f26 * f23));
  f35 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f24 * f23)) - Math_fround(f22 * f25)) - Math_fround(f26 * f31));
  f30 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f22 * f31)) - Math_fround(f24 * f27)) - Math_fround(f28 * f23));
  f31 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f23) - Math_fround(f24 * f25)) - Math_fround(f26 * f27)) - Math_fround(f28 * f31));
  i15 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAPF32[i3 >> 2] = f32;
  HEAPF32[i9 >> 2] = f33;
  HEAPF32[i10 >> 2] = f34;
  HEAP32[i3 + 12 >> 2] = i11 ^ -2147483648;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i17 >> 2] = i15 ^ -2147483648;
  HEAPF32[i1 >> 2] = f35;
  i1 = 0;
 }
 do {
  i17 = i1 + 59 | 0;
  if (HEAP32[i6 + (i17 >>> 5 << 2) >> 2] & 1 << (i17 & 31) | 0) {
   f33 = Math_fround(HEAPF32[i4 + 804 + (i1 * 12 | 0) >> 2]);
   f34 = Math_fround(HEAPF32[i4 + 804 + (i1 * 12 | 0) + 4 >> 2]);
   f33 = Math_fround(f33 * f5);
   f34 = Math_fround(f34 * f5);
   f35 = Math_fround(Math_fround(HEAPF32[i4 + 804 + (i1 * 12 | 0) + 8 >> 2]) * f5);
   i13 = i3 + 804 + (i1 * 12 | 0) | 0;
   f33 = Math_fround(f33 + Math_fround(HEAPF32[i13 >> 2]));
   i15 = i3 + 804 + (i1 * 12 | 0) + 4 | 0;
   f34 = Math_fround(f34 + Math_fround(HEAPF32[i15 >> 2]));
   i17 = i3 + 804 + (i1 * 12 | 0) + 8 | 0;
   f35 = Math_fround(f35 + Math_fround(HEAPF32[i17 >> 2]));
   HEAPF32[i13 >> 2] = f33;
   HEAPF32[i15 >> 2] = f34;
   HEAPF32[i17 >> 2] = f35;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 return;
}

function __ZN5physx2Sq8AABBTree6refit2EPNS0_15AABBTreeBuilderEPj(i2, i1, i18) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0;
 if (!i1) {
  i18 = 0;
  return i18 | 0;
 }
 i17 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i2 + 536 >> 2] | 0;
 if (!i1) {
  i18 = 1;
  return i18 | 0;
 }
 i16 = i2 + 4 | 0;
 do {
  i1 = i1 + -1 | 0;
  i12 = HEAP32[i16 >> 2] | 0;
  i13 = i12 + (i1 * 24 | 0) | 0;
  i14 = (i1 | 0) == 0;
  i15 = i12 + (i1 * 24 | 0) + 16 | 0;
  i11 = i15;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  if ((i10 & 1 | 0) == 0 & 0 == 0) {
   i8 = HEAP32[i16 >> 2] | 0;
   i11 = _bitshift64Lshr(i10 | 0, i11 | 0, 21) | 0;
   getTempRet0() | 0;
   i11 = i11 & 524287;
   i7 = i11 | 0 ? i8 + ((i11 + 1 | 0) * 24 | 0) | 0 : i8;
   i5 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = HEAP32[i7 + 8 >> 2] | 0;
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i7 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   f22 = Math_fround(Math_fround(i5 & 255 | 0) * f28);
   f26 = Math_fround(Math_fround(i3 & 255 | 0) * f28);
   f28 = Math_fround(Math_fround(i2 & 255 | 0) * f28);
   i7 = HEAP32[i8 + (i11 * 24 | 0) >> 2] | 0;
   i6 = HEAP32[i8 + (i11 * 24 | 0) + 4 >> 2] | 0;
   i10 = HEAP32[i8 + (i11 * 24 | 0) + 8 >> 2] | 0;
   f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + (i11 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   f4 = Math_fround(Math_fround(i7 & 255 | 0) * f20);
   f19 = Math_fround(Math_fround(i6 & 255 | 0) * f20);
   f20 = Math_fround(Math_fround(i10 & 255 | 0) * f20);
   f32 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f35 = Math_fround(f32 - f4);
   f31 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f34 = Math_fround(f31 - f19);
   f30 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f30 - f20);
   f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f21 - f22);
   f23 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(f23 - f26);
   f24 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f24 - f28);
   f29 = f35 < f29 ? f35 : f29;
   f27 = f34 < f27 ? f34 : f27;
   f25 = f33 < f25 ? f33 : f25;
   f4 = Math_fround(f32 + f4);
   f19 = Math_fround(f31 + f19);
   f20 = Math_fround(f30 + f20);
   f22 = Math_fround(f21 + f22);
   f26 = Math_fround(f23 + f26);
   f28 = Math_fround(f24 + f28);
   f22 = f4 > f22 ? f4 : f22;
   f26 = f19 > f26 ? f19 : f26;
   f28 = f20 > f28 ? f20 : f28;
   i2 = f29 > Math_fround(-9999999940000000065998519.0e8);
   f29 = i2 ? f29 : Math_fround(-9999999940000000065998519.0e8);
   i2 = f27 > Math_fround(-9999999940000000065998519.0e8);
   f27 = i2 ? f27 : Math_fround(-9999999940000000065998519.0e8);
   i2 = f25 > Math_fround(-9999999940000000065998519.0e8);
   f25 = i2 ? f25 : Math_fround(-9999999940000000065998519.0e8);
   i2 = f22 < Math_fround(9999999940000000065998519.0e8);
   f22 = i2 ? f22 : Math_fround(9999999940000000065998519.0e8);
   i2 = f26 < Math_fround(9999999940000000065998519.0e8);
   f26 = i2 ? f26 : Math_fround(9999999940000000065998519.0e8);
   i2 = f28 < Math_fround(9999999940000000065998519.0e8);
   f28 = i2 ? f28 : Math_fround(9999999940000000065998519.0e8);
   f20 = Math_fround(Math_fround(f29 + f22) * Math_fround(.5));
   f19 = Math_fround(Math_fround(f27 + f26) * Math_fround(.5));
   f4 = Math_fround(Math_fround(f25 + f28) * Math_fround(.5));
   f29 = Math_fround(Math_fround(f22 - f29) * Math_fround(.5));
   f27 = Math_fround(Math_fround(f26 - f27) * Math_fround(.5));
   f25 = Math_fround(Math_fround(f28 - f25) * Math_fround(.5));
   f28 = Math_fround(f20 * Math_fround(.0000999999974));
   f26 = Math_fround(f19 * Math_fround(.0000999999974));
   f22 = Math_fround(f4 * Math_fround(.0000999999974));
   f24 = Math_fround(-f28);
   f23 = Math_fround(-f26);
   f21 = Math_fround(-f22);
   f24 = Math_fround(f29 + Math_fround((f28 > f24 ? f28 : f24) + Math_fround(.0000999999974)));
   f23 = Math_fround(f27 + Math_fround((f26 > f23 ? f26 : f23) + Math_fround(.0000999999974)));
   f21 = Math_fround(f25 + Math_fround((f22 > f21 ? f22 : f21) + Math_fround(.0000999999974)));
   f22 = f23 > f21 ? f23 : f21;
   f22 = Math_fround((f24 > f22 ? f24 : f22) * Math_fround(.00392158423));
   f25 = Math_fround(Math_fround(f22 + Math_fround(f22 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   f22 = Math_fround(Math_fround(1.0) / f22);
   i3 = ~~Math_fround(Math_fround(f22 * f24) + Math_fround(1.0));
   i5 = ~~Math_fround(Math_fround(f22 * f23) + Math_fround(1.0));
   i10 = ~~Math_fround(Math_fround(f22 * f21) + Math_fround(1.0));
   i6 = f20 == Math_fround(0.0);
   i7 = f19 == Math_fround(0.0);
   i11 = f4 == Math_fround(0.0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = i10 | (i11 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -256);
   HEAP32[i13 >> 2] = i3 | (i6 ? 16777216 : i8 & -256);
   HEAP32[i12 + (i1 * 24 | 0) + 4 >> 2] = i5 | (i7 ? 16777216 : i9 & -256);
   HEAP32[i12 + (i1 * 24 | 0) + 8 >> 2] = i11;
   i13 = i15;
   i3 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] & 255;
   i2 = _bitshift64Shl(i2 >>> 8 | 0, 0, 40) | 0;
   i3 = i2 | i3;
   i2 = getTempRet0() | 0 | i13;
  } else {
   if ((i10 & 2 | 0) == 0 & 0 == 0) {
    i2 = 1967470361;
    i3 = 1967470361;
    i5 = 1967470361;
    i6 = -180013287;
    i7 = -180013287;
    i8 = -180013287;
   } else {
    i8 = _bitshift64Lshr(i10 | 0, i11 | 0, 21) | 0;
    getTempRet0() | 0;
    i8 = HEAP32[i18 + ((i8 & 524287) << 2) >> 2] | 0;
    i2 = HEAP32[i17 + (i8 * 24 | 0) >> 2] | 0;
    i3 = HEAP32[i17 + (i8 * 24 | 0) + 4 >> 2] | 0;
    i5 = HEAP32[i17 + (i8 * 24 | 0) + 8 >> 2] | 0;
    i6 = HEAP32[i17 + (i8 * 24 | 0) + 12 >> 2] | 0;
    i7 = HEAP32[i17 + (i8 * 24 | 0) + 16 >> 2] | 0;
    i8 = HEAP32[i17 + (i8 * 24 | 0) + 20 >> 2] | 0;
   }
   f25 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i2 = f25 > Math_fround(-9999999940000000065998519.0e8);
   f25 = i2 ? f25 : Math_fround(-9999999940000000065998519.0e8);
   i2 = f27 > Math_fround(-9999999940000000065998519.0e8);
   f27 = i2 ? f27 : Math_fround(-9999999940000000065998519.0e8);
   i2 = f29 > Math_fround(-9999999940000000065998519.0e8);
   f29 = i2 ? f29 : Math_fround(-9999999940000000065998519.0e8);
   f32 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i2 = f32 < Math_fround(9999999940000000065998519.0e8);
   f32 = i2 ? f32 : Math_fround(9999999940000000065998519.0e8);
   i2 = f28 < Math_fround(9999999940000000065998519.0e8);
   f28 = i2 ? f28 : Math_fround(9999999940000000065998519.0e8);
   i2 = f26 < Math_fround(9999999940000000065998519.0e8);
   f26 = i2 ? f26 : Math_fround(9999999940000000065998519.0e8);
   f34 = Math_fround(Math_fround(f25 + f32) * Math_fround(.5));
   f35 = Math_fround(Math_fround(f27 + f28) * Math_fround(.5));
   f4 = Math_fround(Math_fround(f29 + f26) * Math_fround(.5));
   f25 = Math_fround(Math_fround(f32 - f25) * Math_fround(.5));
   f27 = Math_fround(Math_fround(f28 - f27) * Math_fround(.5));
   f29 = Math_fround(Math_fround(f26 - f29) * Math_fround(.5));
   f26 = Math_fround(f34 * Math_fround(.0000999999974));
   f28 = Math_fround(f35 * Math_fround(.0000999999974));
   f32 = Math_fround(f4 * Math_fround(.0000999999974));
   f30 = Math_fround(-f26);
   f31 = Math_fround(-f28);
   f33 = Math_fround(-f32);
   f30 = Math_fround(f25 + Math_fround((f26 > f30 ? f26 : f30) + Math_fround(.0000999999974)));
   f31 = Math_fround(f27 + Math_fround((f28 > f31 ? f28 : f31) + Math_fround(.0000999999974)));
   f33 = Math_fround(f29 + Math_fround((f32 > f33 ? f32 : f33) + Math_fround(.0000999999974)));
   f32 = f31 > f33 ? f31 : f33;
   f32 = Math_fround((f30 > f32 ? f30 : f32) * Math_fround(.00392158423));
   f29 = Math_fround(Math_fround(f32 + Math_fround(f32 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   f32 = Math_fround(Math_fround(1.0) / f32);
   i3 = ~~Math_fround(Math_fround(f32 * f30) + Math_fround(1.0));
   i5 = ~~Math_fround(Math_fround(f32 * f31) + Math_fround(1.0));
   i37 = ~~Math_fround(Math_fround(f32 * f33) + Math_fround(1.0));
   i6 = f34 == Math_fround(0.0);
   i7 = f35 == Math_fround(0.0);
   i36 = f4 == Math_fround(0.0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
   i37 = i37 | (i36 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -256);
   HEAP32[i13 >> 2] = i3 | (i6 ? 16777216 : i8 & -256);
   HEAP32[i12 + (i1 * 24 | 0) + 4 >> 2] = i5 | (i7 ? 16777216 : i9 & -256);
   HEAP32[i12 + (i1 * 24 | 0) + 8 >> 2] = i37;
   i3 = _bitshift64Shl(i2 >>> 8 | 0, 0, 40) | 0;
   i3 = i3 | i10;
   i2 = getTempRet0() | 0 | i11 & 255;
  }
  i37 = i15;
  HEAP32[i37 >> 2] = i3;
  HEAP32[i37 + 4 >> 2] = i2;
 } while (!i14);
 i1 = 1;
 return i1 | 0;
}

function __ZN2UI29ScheduleUIJobsForInstructionsERNS_7BatchesEjPKNS_13UIInstructionEfjjPNS_13CanvasJobDataE(i9, i10, i12, f7, i13, i14, i15) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18 + 48 | 0;
 i6 = i18 + 40 | 0;
 i16 = i18 + 32 | 0;
 i17 = i18;
 i5 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 256 >> 2] | 0;
 i11 = i9 + 112 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i1 | 0, i5 | 0, i8 | 0);
 i5 = i9 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i6 = i9 + 20 | 0;
  i4 = 0;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i3 = HEAP32[i2 + (i4 * 36 | 0) >> 2] | 0;
   if (i3) {
    i1 = i3 + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
    if (!(HEAP32[i1 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
     i1 = HEAP32[i6 >> 2] | 0;
    } else i1 = i2;
    HEAP32[i1 + (i4 * 36 | 0) >> 2] = 0;
    i2 = i1;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i1 | 0));
 }
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i9 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f21 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i9 + 76 >> 2] = f21;
 HEAPF32[i9 + 80 >> 2] = f20;
 HEAPF32[i9 + 84 >> 2] = f19;
 __ZN2UI13PrepareOutputERNS_7BatchesEjj(i9, i13, i14);
 if ((i10 | 0) == 0 | (i13 | 0) == 0 | (i14 | 0) == 0) {
  STACKTOP = i18;
  return;
 }
 f20 = Math_fround(Math_fround(f7 * Math_fround(255.0)) + Math_fround(.5));
 i3 = f20 >= Math_fround(0.0);
 f19 = Math_fround(f20 + Math_fround(-.99999994));
 i3 = ~~(i3 ? f20 : f19);
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 * 2016 | 0, 16, gb + 64024 | 0, 0, gb + 1012316 | 0, 393) | 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(48, gb + 64024 | 0, 16, gb + 1012316 | 0, 398) | 0;
 i6 = i4 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f19 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f21 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i4 + 36 >> 2] = f19;
 HEAPF32[i4 + 40 >> 2] = f20;
 HEAPF32[i4 + 44 >> 2] = f21;
 HEAP32[i4 + 12 >> 2] = i1;
 i1 = 0;
 do {
  i2 = HEAP32[i12 + (i1 * 672 | 0) + 476 >> 2] | 0;
  if (i2 | 0) {
   i6 = i2 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i6 = __ZnwjRK10MemLabelIdiPKci(784, gb + 64024 | 0, 16, gb + 1012316 | 0, 418) | 0;
 i5 = i6 + 384 | 0;
 f19 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f20 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f19 = Math_fround(-f19);
 f20 = Math_fround(-f20);
 f21 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 396 >> 2] = f19;
 HEAPF32[i6 + 400 >> 2] = f20;
 HEAPF32[i6 + 404 >> 2] = f21;
 i5 = i6 + 408 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 420 >> 2] = f19;
 HEAPF32[i6 + 424 >> 2] = f20;
 HEAPF32[i6 + 428 >> 2] = f21;
 i5 = i6 + 432 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 444 >> 2] = f19;
 HEAPF32[i6 + 448 >> 2] = f20;
 HEAPF32[i6 + 452 >> 2] = f21;
 i5 = i6 + 456 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 468 >> 2] = f19;
 HEAPF32[i6 + 472 >> 2] = f20;
 HEAPF32[i6 + 476 >> 2] = f21;
 i5 = i6 + 480 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 492 >> 2] = f19;
 HEAPF32[i6 + 496 >> 2] = f20;
 HEAPF32[i6 + 500 >> 2] = f21;
 i5 = i6 + 504 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 516 >> 2] = f19;
 HEAPF32[i6 + 520 >> 2] = f20;
 HEAPF32[i6 + 524 >> 2] = f21;
 i5 = i6 + 528 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 540 >> 2] = f19;
 HEAPF32[i6 + 544 >> 2] = f20;
 HEAPF32[i6 + 548 >> 2] = f21;
 i5 = i6 + 552 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 564 >> 2] = f19;
 HEAPF32[i6 + 568 >> 2] = f20;
 HEAPF32[i6 + 572 >> 2] = f21;
 i5 = i6 + 576 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 588 >> 2] = f19;
 HEAPF32[i6 + 592 >> 2] = f20;
 HEAPF32[i6 + 596 >> 2] = f21;
 i5 = i6 + 600 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 612 >> 2] = f19;
 HEAPF32[i6 + 616 >> 2] = f20;
 HEAPF32[i6 + 620 >> 2] = f21;
 i5 = i6 + 624 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 636 >> 2] = f19;
 HEAPF32[i6 + 640 >> 2] = f20;
 HEAPF32[i6 + 644 >> 2] = f21;
 i5 = i6 + 648 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 660 >> 2] = f19;
 HEAPF32[i6 + 664 >> 2] = f20;
 HEAPF32[i6 + 668 >> 2] = f21;
 i5 = i6 + 672 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 684 >> 2] = f19;
 HEAPF32[i6 + 688 >> 2] = f20;
 HEAPF32[i6 + 692 >> 2] = f21;
 i5 = i6 + 696 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 708 >> 2] = f19;
 HEAPF32[i6 + 712 >> 2] = f20;
 HEAPF32[i6 + 716 >> 2] = f21;
 i5 = i6 + 720 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 732 >> 2] = f19;
 HEAPF32[i6 + 736 >> 2] = f20;
 HEAPF32[i6 + 740 >> 2] = f21;
 i5 = i6 + 744 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i6 + 756 >> 2] = f19;
 HEAPF32[i6 + 760 >> 2] = f20;
 HEAPF32[i6 + 764 >> 2] = f21;
 HEAP32[i6 + 776 >> 2] = i4;
 HEAP32[i6 + 780 >> 2] = i12;
 i10 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i6, i10, 1024) | 0;
 HEAP32[i6 + 768 >> 2] = i10;
 HEAP8[i6 + 772 >> 0] = HEAP8[i15 >> 0] | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i8, fb + 4237 | 0, i6, i10, fb + 3868 | 0, 0);
 i10 = __ZnwjRK10MemLabelIdiPKci(12, gb + 64024 | 0, 16, gb + 1012316 | 0, 429) | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i16, fb + 3869 | 0, i10, i8, 0);
 i10 = __ZnwjRK10MemLabelIdiPKci(12, gb + 64024 | 0, 16, gb + 1012316 | 0, 439) | 0;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = i3 << 24 | 16777215;
 HEAP32[i10 + 8 >> 2] = i9;
 i15 = i9 + 104 | 0;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i15, fb + 3870 | 0, i10, i16, 0);
 i10 = __ZnwjRK10MemLabelIdiPKci(36, gb + 64024 | 0, 16, gb + 1012316 | 0, 453) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = i4;
 HEAP8[i10 + 32 >> 0] = (__Z19GetActiveColorSpacev() | 0) == 1 & 1;
 HEAP8[i10 + 33 >> 0] = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0;
 i12 = HEAP32[i15 + 4 >> 2] | 0;
 i6 = i10 + 20 | 0;
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 __ZN17UniqueIDGenerator8CreateIDEv(i17, (__Z12GetGfxDevicev() | 0) + 4448 | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 HEAP32[i11 >> 2] = i6;
 i12 = HEAP32[(HEAP32[i9 + 88 >> 2] | 0) + 8 >> 2] | 0;
 i15 = HEAP32[(HEAP32[i9 + 92 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i17 >> 2] = i6;
 HEAP32[i17 + 4 >> 2] = i10;
 HEAP32[i17 + 8 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = i13 * 60;
 HEAP32[i17 + 20 >> 2] = i15;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = i14 << 1;
 i15 = __Z12GetGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 248 >> 2] | 0, i15 | 0, fb + 3871 | 0, i17 | 0, 1);
 __Z21ClearFenceWithoutSyncR8JobFence(i8);
 __Z21ClearFenceWithoutSyncR8JobFence(i16);
 STACKTOP = i18;
 return;
}

function __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 248 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj442ENS_22PxRepXPropertyAccessorILj442ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 264 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj443ENS_22PxRepXPropertyAccessorILj443ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 280 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj444ENS_22PxRepXPropertyAccessorILj444ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 296 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj445ENS_22PxRepXPropertyAccessorILj445ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 312 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj446ENS_22PxRepXPropertyAccessorILj446ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 328 | 0;
  i12 = i9 + 6 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj447ES3_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 328 | 0;
 i12 = i9 + 6 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj447ES3_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture(i2, i3, f4, i20) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i20 = i20 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26 + 96 | 0;
 i24 = i26;
 i23 = i26 + 288 | 0;
 i21 = i26 + 160 | 0;
 i5 = i26 + 492 | 0;
 i6 = i26 + 488 | 0;
 i7 = i26 + 484 | 0;
 if ((HEAP16[gb + 1110588 + 6 >> 1] | 0) > -1) {
  HEAP32[i24 >> 2] = 0;
  HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110588 | 0, i22);
  i25 = gb + 1110588 | 0;
 } else i25 = 0;
 i1 = HEAP32[gb + 1110932 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, gb + 377771 | 0, 16);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i22) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  if (!i1) i1 = 0; else {
   i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
   HEAP32[gb + 1110932 >> 2] = i1;
   i8 = 6;
  }
 } else i8 = 6;
 if ((i8 | 0) == 6) {
  HEAP32[i5 >> 2] = HEAP32[gb + 1110620 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i22, i2);
  i9 = HEAP32[gb + 1110932 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[gb + 1110624 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i6 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i9, i22, i3);
  i9 = HEAP32[gb + 1110932 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[gb + 1110628 >> 2];
  i16 = f4 < Math_fround(0.0);
  i13 = f4 > Math_fround(1.0);
  f4 = i13 ? Math_fround(1.0) : f4;
  f4 = i16 ? Math_fround(0.0) : f4;
  HEAP32[i22 >> 2] = HEAP32[i7 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i9, i22, f4);
  i9 = HEAP32[gb + 1110932 >> 2] | 0;
  i16 = __Z12GetGfxDevicev() | 0;
  i13 = HEAP32[i20 + 80 >> 2] | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  HEAP32[i23 >> 2] = i1;
  i17 = i23 + 4 | 0;
  i18 = i23 + 68 | 0;
  i19 = i23 + 132 | 0;
  i2 = i18;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = i17;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = i19;
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i10 = __Z12GetGfxDevicev() | 0;
  __ZN10Matrix4x4f8SetOrthoEffffff(i22, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(100.0)) | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 116 >> 2] | 0, i10 | 0, i22 | 0);
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0, gb + 1162292 | 0);
  i10 = HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0;
  mftCall_vii(i10 | 0, i16 | 0, __ZNK13RenderTexture32CalculateNeedsInvertedProjectionEv(i20) | 0);
  i10 = i21 + 12 | 0;
  HEAP32[i21 + 16 >> 2] = 1;
  HEAP32[i10 >> 2] = gb + 33952 + 8;
  i11 = gb + 64016 | 0;
  i15 = HEAP32[i11 + 4 >> 2] | 0;
  i14 = i24;
  HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i21 + 44 >> 2] = 0;
  HEAP32[i21 + 56 >> 2] = 0;
  i14 = i21 + 60 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i21 + 48 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, i24);
  i11 = i22;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i6 = i15;
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 4 >> 2] = i12;
  i6 = gb + 64016 | 0;
  i12 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = i24;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i21 + 64 >> 2] = 0;
  HEAP32[i21 + 76 >> 2] = 0;
  i11 = i21 + 80 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i21 + 68 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, i24);
  i6 = i22;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i12;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i8 = gb + 64016 | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i24;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  i6 = i21 + 84 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i21 + 96 >> 2] = 0;
  i7 = i21 + 100 | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i21 + 88 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, i24);
  i3 = i22;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = i8;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i21 + 104 >> 2] = 0;
  HEAP32[i21 + 108 >> 2] = 0;
  i2 = gb + 64016 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i21 + 112 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP8[i21 + 120 >> 0] = 1;
  i3 = i21 + 20 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i21 + 124 >> 2] = __Z12GetGfxDevicev() | 0;
  i3 = i21 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i21 >> 2] = i9;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i9, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
  i3 = i20 + 117 | 0;
  L9 : do if ((i13 | 0) > 0) {
   i5 = i21 + 12 | 0;
   i1 = i13;
   i2 = 0;
   while (1) {
    f4 = Math_fround(i2 | 0);
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 0, Math_fround(.999984741));
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 1, Math_fround(.999984741));
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 2, Math_fround(.999984741));
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 3, Math_fround(.999984741));
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 4, Math_fround(.999984741));
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1110608 | 0, f4, 0);
    __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i16, i21, i20, i2, 5, Math_fround(.999984741));
    if (!(mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 112 >> 2] | 0, i20 | 0) | 0)) break L9;
    if (HEAP8[i3 >> 0] | 0) break L9;
    i1 = i1 >> 1;
    if ((i1 | 0) <= 0) break; else i2 = i2 + 1 | 0;
   }
  } while (0);
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
  HEAP32[i10 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i7 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i8);
   HEAP32[i6 >> 2] = 0;
  }
  i1 = i21 + 64 | 0;
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i21 + 44 | 0;
  if ((HEAP32[i14 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i15);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = HEAP32[i23 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i19 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, i18 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i17 | 0);
  i1 = HEAP32[i23 >> 2] | 0;
  i23 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i23, i22);
  __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i22, i24);
  i23 = i1 + 1364 | 0;
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  i23 = i24 + 16 | 0;
  i22 = i1 + 1380 | 0;
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  i22 = i24 + 32 | 0;
  i23 = i1 + 1396 | 0;
  HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i23 = i24 + 48 | 0;
  i22 = i1 + 1412 | 0;
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  i22 = i24 + 64 | 0;
  i23 = i1 + 1428 | 0;
  HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i24 = i24 + 80 | 0;
  i1 = i1 + 1444 | 0;
  HEAP32[i1 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
  i1 = 1;
 }
 if (!i25) {
  STACKTOP = i26;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i25);
 STACKTOP = i26;
 return i1 | 0;
}

function __ZN5Umbra10PathFinder10outputPathERNS_7ImpPathEfRKNS_7Vector3ES5_(i34, i41, f42, i1, i38) {
 i34 = i34 | 0;
 i41 = i41 | 0;
 f42 = Math_fround(f42);
 i1 = i1 | 0;
 i38 = i38 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i43 = 0, i44 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i43 + 16 | 0;
 i36 = i43;
 i12 = HEAP32[i34 + 24172 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 i39 = i41 + 8 | 0;
 i1 = HEAP32[i39 >> 2] | 0;
 i40 = i41 + 4 | 0;
 if ((i1 | 0) < (HEAP32[i40 >> 2] | 0)) {
  i11 = HEAP32[i41 >> 2] | 0;
  HEAP32[i11 + (i1 << 5) >> 2] = i8;
  HEAP32[i11 + (i1 << 5) + 4 >> 2] = i9;
  HEAP32[i11 + (i1 << 5) + 8 >> 2] = i10;
  HEAP32[i11 + (i1 << 5) + 12 >> 2] = -1;
  i11 = i11 + (i1 << 5) + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  i11 = i34 + 24174 | 0;
  i33 = i11;
  i1 = HEAP32[i39 >> 2] | 0;
  i11 = HEAP16[i11 >> 1] | 0;
 } else {
  i33 = i34 + 24174 | 0;
  i11 = i12 >>> 16 & 65535;
 }
 i1 = i1 + 1 | 0;
 HEAP32[i39 >> 2] = i1;
 i14 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
 i32 = i34 + 24168 | 0;
 i12 = HEAP16[(HEAP32[i32 >> 2] | 0) + ((i12 & 65535) << 1) >> 1] | 0;
 L5 : do if (i12 << 16 >> 16 == i11 << 16 >> 16) f13 = Math_fround(0.0); else {
  i23 = i34 + 80 | 0;
  i24 = i34 + 96 | 0;
  i25 = i36 + 4 | 0;
  i26 = i36 + 8 | 0;
  i27 = i35 + 8 | 0;
  i28 = i34 + 116 | 0;
  i29 = i34 + 132 | 0;
  i30 = i34 + 108 | 0;
  i31 = i34 + 144 | 0;
  f13 = Math_fround(0.0);
  i22 = i12 & 65535;
  i15 = HEAP32[i14 + 92 >> 2] | 0;
  i16 = HEAP32[i14 + 100 >> 2] | 0;
  i17 = HEAP32[i14 + 112 >> 2] | 0;
  i11 = HEAP32[i14 + 96 >> 2] | 0;
  i1 = i14;
  while (1) {
   i12 = __ZN5Umbra10QueryState23findTomeByClusterPortalEi(i1, i22) | 0;
   if ((i12 | 0) == (i15 | 0)) {
    i12 = i15;
    i21 = i11;
   } else {
    i11 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
    i1 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i12 | 0) != -1 & (i1 | 0) != 0) {
     i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i12 << 5)) | 0;
     if (!i1) i37 = 10; else {
      i19 = HEAP32[i1 >> 2] | 0;
      i21 = HEAP32[i11 >> 2] | 0;
      i17 = HEAP32[i21 + (HEAP32[i21 + 180 >> 2] | 0) + (i12 << 2) >> 2] | 0;
      i18 = i21 + (HEAP32[i21 + 184 >> 2] | 0) | 0;
      i20 = HEAP32[i18 + (i12 << 2) >> 2] | 0;
      i18 = (HEAP32[i18 + (i12 + 1 << 2) >> 2] | 0) - i20 | 0;
      HEAP32[i11 + 92 >> 2] = i12;
      HEAP32[i11 + 96 >> 2] = i1;
      HEAP32[i11 + 100 >> 2] = i19;
      HEAP32[i11 + 104 >> 2] = i21;
      HEAP32[i11 + 108 >> 2] = i17;
      HEAP32[i11 + 112 >> 2] = i20;
      HEAP32[i11 + 116 >> 2] = i18;
      i11 = i21;
      i21 = i1;
     }
    } else i37 = 10;
    if ((i37 | 0) == 10) {
     i37 = 0;
     i20 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 + 92 >> 2] = 0;
     HEAP32[i11 + 96 >> 2] = 0;
     HEAP32[i11 + 100 >> 2] = i20;
     HEAP32[i11 + 104 >> 2] = i20;
     HEAP32[i11 + 108 >> 2] = 0;
     HEAP32[i11 + 112 >> 2] = 0;
     HEAP32[i11 + 116 >> 2] = 0;
     i12 = 0;
     i19 = i20;
     i11 = i20;
     i20 = 0;
     i18 = 0;
     i21 = 0;
    }
    i14 = i19;
    i15 = i19;
    i16 = HEAP32[i14 + 132 >> 2] | 0;
    i17 = i14 + 180 | 0;
    if (!(HEAP32[i17 >> 2] | 0)) {
     i1 = (HEAP32[i14 + 124 >> 2] | 0) + -1 | 0;
     i44 = i15 + (HEAP32[i14 + 128 >> 2] | 0) | 0;
     i1 = (HEAP32[i44 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i44 + (i1 * 20 | 0) >> 2] | 0) | 0;
    } else i1 = HEAP32[i15 + (HEAP32[i14 + 184 >> 2] | 0) + (HEAP32[i14 + 176 >> 2] << 2) >> 2] | 0;
    HEAP32[i30 >> 2] = i1;
    HEAP32[i23 >> 2] = (i16 | 0) == 0 ? 0 : i15 + i16 | 0;
    if (!i21) {
     i11 = 0;
     i14 = 0;
     i1 = 0;
    } else {
     if (!(HEAP32[i17 >> 2] | 0)) {
      i1 = (HEAP32[i14 + 124 >> 2] | 0) + -1 | 0;
      i44 = i15 + (HEAP32[i14 + 128 >> 2] | 0) | 0;
      i1 = (HEAP32[i44 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i44 + (i1 * 20 | 0) >> 2] | 0) | 0;
     } else i1 = HEAP32[i15 + (HEAP32[i14 + 184 >> 2] | 0) + (HEAP32[i14 + 176 >> 2] << 2) >> 2] | 0;
     i14 = HEAP32[i21 + 24 >> 2] | 0;
     i1 = i18 - i1 | 0;
    }
    HEAP32[i31 >> 2] = i1;
    HEAP32[i28 >> 2] = (i14 | 0) == 0 ? 0 : i11 + i14 | 0;
    i16 = i19;
    i17 = i20;
   }
   i14 = i22 - ((i21 | 0) == 0 ? 0 : i17) | 0;
   i15 = i16;
   i11 = (HEAP32[i15 + 180 >> 2] | 0) == 0;
   if (i11) {
    i1 = (HEAP32[i15 + 124 >> 2] | 0) + -1 | 0;
    i44 = i16 + (HEAP32[i15 + 128 >> 2] | 0) | 0;
    i1 = (HEAP32[i44 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i44 + (i1 * 20 | 0) >> 2] | 0) | 0;
   } else i1 = HEAP32[i16 + (HEAP32[i15 + 184 >> 2] | 0) + (HEAP32[i15 + 176 >> 2] << 2) >> 2] | 0;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   HEAP32[i35 + 8 >> 2] = 0;
   HEAP32[i35 + 12 >> 2] = 0;
   if ((i14 | 0) < (i1 | 0)) {
    i44 = (HEAP32[i23 >> 2] | 0) + (Math_imul(HEAP32[i24 >> 2] | 0, i14) | 0) | 0;
    HEAP32[i35 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   } else {
    if (i11) {
     i1 = (HEAP32[i15 + 124 >> 2] | 0) + -1 | 0;
     i44 = i16 + (HEAP32[i15 + 128 >> 2] | 0) | 0;
     i1 = (HEAP32[i44 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i44 + (i1 * 20 | 0) >> 2] | 0) | 0;
    } else i1 = HEAP32[i16 + (HEAP32[i15 + 184 >> 2] | 0) + (HEAP32[i15 + 176 >> 2] << 2) >> 2] | 0;
    i44 = (HEAP32[i28 >> 2] | 0) + (Math_imul(HEAP32[i29 >> 2] | 0, i14 - i1 | 0) | 0) | 0;
    HEAP32[i35 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
   }
   __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i36, i15, i35);
   f5 = Math_fround(HEAPF32[i36 >> 2]);
   f2 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f4 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f3 = Math_fround(HEAPF32[i26 >> 2]);
   f7 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f13 = Math_fround(f13 + Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)))) * f42));
   i10 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   if (HEAP32[i35 >> 2] & 134217728) {
    i11 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
    i18 = HEAP32[i11 + 16 >> 2] | 0;
    if (i18) if (HEAP8[i11 + 20 >> 0] | 0) {
     i1 = HEAP32[i27 >> 2] | 0;
     i19 = i1 & 4095;
     L45 : do if (!i19) f2 = Math_fround(0.0); else {
      i15 = HEAP32[i11 + 100 >> 2] | 0;
      i14 = i1 >>> 12;
      i15 = i15 + (HEAP32[i15 + 120 >> 2] | 0) | 0;
      i1 = HEAP32[i11 + 96 >> 2] | 0;
      if (!i1) {
       f2 = Math_fround(0.0);
       i1 = 0;
       while (1) {
        f2 = Math_fround(f2 + Math_fround(HEAPF32[i18 + (HEAP32[i15 + (i1 + i14 << 2) >> 2] << 2) >> 2]));
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i19 | 0)) break L45;
       }
      }
      i11 = (HEAP32[i11 + 104 >> 2] | 0) + (HEAP32[i1 + 16 >> 2] | 0) | 0;
      f2 = Math_fround(0.0);
      i1 = 0;
      do {
       f2 = Math_fround(f2 + Math_fround(HEAPF32[i18 + (HEAP32[i11 + (HEAP32[i15 + (i1 + i14 << 2) >> 2] << 2) >> 2] << 2) >> 2]));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i19 | 0));
     } while (0);
     f13 = Math_fround(f13 + f2);
    }
   }
   i1 = HEAP32[i39 >> 2] | 0;
   if ((i1 | 0) < (HEAP32[i40 >> 2] | 0)) {
    i8 = HEAP32[i41 >> 2] | 0;
    HEAPF32[i8 + (i1 << 5) >> 2] = f5;
    HEAPF32[i8 + (i1 << 5) + 4 >> 2] = f4;
    HEAPF32[i8 + (i1 << 5) + 8 >> 2] = f3;
    HEAP32[i8 + (i1 << 5) + 12 >> 2] = i22;
    HEAPF32[i8 + (i1 << 5) + 16 >> 2] = f13;
    HEAP32[i8 + (i1 << 5) + 20 >> 2] = 0;
    HEAP32[i8 + (i1 << 5) + 24 >> 2] = 0;
    HEAP32[i8 + (i1 << 5) + 28 >> 2] = 0;
    i8 = HEAP32[i36 >> 2] | 0;
    i9 = HEAP32[i25 >> 2] | 0;
    i10 = HEAP32[i26 >> 2] | 0;
    i1 = HEAP32[i39 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   HEAP32[i39 >> 2] = i1;
   i11 = HEAP16[(HEAP32[i32 >> 2] | 0) + (i22 << 1) >> 1] | 0;
   if (i11 << 16 >> 16 == (HEAP16[i33 >> 1] | 0)) break L5;
   i22 = i11 & 65535;
   i15 = i12;
   i11 = i21;
   i1 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
  }
 } while (0);
 f7 = Math_fround(HEAPF32[i38 >> 2]);
 f5 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f6 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f4 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f3 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f2 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 if ((i1 | 0) >= (HEAP32[i40 >> 2] | 0)) {
  i44 = i1;
  i44 = i44 + 1 | 0;
  HEAP32[i39 >> 2] = i44;
  STACKTOP = i43;
  return;
 }
 f42 = Math_fround(f13 + Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f2 * f2)))) * f42));
 i44 = HEAP32[i41 >> 2] | 0;
 HEAPF32[i44 + (i1 << 5) >> 2] = f7;
 HEAPF32[i44 + (i1 << 5) + 4 >> 2] = f6;
 HEAPF32[i44 + (i1 << 5) + 8 >> 2] = f3;
 HEAP32[i44 + (i1 << 5) + 12 >> 2] = -1;
 HEAPF32[i44 + (i1 << 5) + 16 >> 2] = f42;
 HEAP32[i44 + (i1 << 5) + 20 >> 2] = 0;
 HEAP32[i44 + (i1 << 5) + 24 >> 2] = 0;
 HEAP32[i44 + (i1 << 5) + 28 >> 2] = 0;
 i44 = HEAP32[i39 >> 2] | 0;
 i44 = i44 + 1 | 0;
 HEAP32[i39 >> 2] = i44;
 STACKTOP = i43;
 return;
}

function __ZL36CollectAndProduceGameObjectHierarchyR9TransformPS_R10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS3_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i32, i7) {
 i1 = i1 | 0;
 i32 = i32 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i38 + 8 | 0;
 i21 = i38;
 i3 = i38 + 96 | 0;
 i4 = i38 + 88 | 0;
 i5 = i38 + 80 | 0;
 i36 = i38 + 68 | 0;
 i37 = i38 + 64 | 0;
 i6 = i38 + 72 | 0;
 i2 = i38 + 56 | 0;
 i33 = i38 + 44 | 0;
 i34 = i38 + 32 | 0;
 i20 = i38 + 24 | 0;
 i26 = i38 + 16 | 0;
 __ZN9Transform18GetTransformAccessEv(i23, i1);
 i35 = HEAP32[(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0) + (HEAP32[i23 + 4 >> 2] << 2) >> 2] | 0;
 i27 = (i32 | 0) != 0;
 if (i27) {
  __ZN9Transform22EnsureCapacityIncreaseEj(i32, i35);
  i28 = __ZNK9Transform18FindLastChildIndexEv(i32) | 0;
  __ZN9Transform18GetTransformAccessEv(i3, i32);
  i29 = HEAP32[i3 + 4 >> 2] | 0;
  __ZN9Transform18GetTransformAccessEv(i4, i1);
  i31 = HEAP32[i4 >> 2] | 0;
  __ZN9Transform18GetTransformAccessEv(i5, i32);
  i30 = HEAP32[i5 >> 2] | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i37 >> 2] = 0;
  __ZN9Transform18GetTransformAccessEv(i6, i1);
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb(i31, i5, i30, i36, i37, __Z33GetHasChangedDeprecatedSystemMaskv() | 0, 1);
  i5 = i31;
 } else {
  __ZN9Transform18GetTransformAccessEv(i4, i1);
  i5 = HEAP32[i4 >> 2] | 0;
  i30 = __ZN17TransformInternal24CreateTransformHierarchyEj(i35) | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i37 >> 2] = 0;
  __ZN9Transform18GetTransformAccessEv(i2, i1);
  i28 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN17TransformInternal25CopyTransformSubhierarchyER18TransformHierarchyjS1_jb(i5, i28, i30, __Z33GetHasChangedDeprecatedSystemMaskv() | 0, 1);
  HEAP32[i36 >> 2] = 0;
  HEAP32[i37 >> 2] = i35 + -1;
  i28 = 0;
  i29 = -1;
 }
 i24 = HEAP32[i30 + 24 >> 2] | 0;
 i19 = i30 + 68 | 0;
 i22 = HEAP32[i19 >> 2] | 0;
 HEAP32[i33 >> 2] = 0;
 i31 = i33 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i31;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i30 >> 2] << 2;
 do if (!i1) {
  i1 = 0;
  i2 = i4;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 391318 | 0, 110) | 0;
   i3 = gb + 64016 | 0;
   i25 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i33 >> 2] = i1;
   i2 = i31;
   HEAP32[i2 >> 2] = i25;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = gb + 63160 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 i18 = i1 + 3 & -4;
 HEAP32[i34 >> 2] = 0;
 i25 = i34 + 4 | 0;
 i1 = i25;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i5 >> 2] << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 391318 | 0, 111) | 0;
   i16 = gb + 64016 | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   HEAP32[i34 >> 2] = i1;
   i17 = i25;
   HEAP32[i17 >> 2] = i15;
   HEAP32[i17 + 4 >> 2] = i16;
   break;
  }
 } while (0);
 i17 = i1 + 3 & -4;
 i1 = HEAP32[i36 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = -1; else {
  i13 = i20 + 4 | 0;
  i14 = i7 + 4 | 0;
  i15 = i23 + 4 | 0;
  i16 = i7 + 8 | 0;
  i11 = i7 + 12 | 0;
  i12 = i23 + 4 | 0;
  do {
   i9 = i24 + (i1 << 2) | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i18 + (i1 << 2) >> 2] = i6;
   __ZN9Transform18GetTransformAccessEv(i20, i6);
   HEAP32[i17 + (HEAP32[i13 >> 2] << 2) >> 2] = i1;
   i6 = HEAP32[i6 + 28 >> 2] | 0;
   i8 = gb + 63520 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(1) | 0;
   i2 = i21;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i2 + 4 >> 2] = i8;
   HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   i10 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i10, 0, i23, 2) | 0;
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i23 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i15 >> 2] = i2;
   i2 = HEAP32[i16 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i23); else {
    i5 = i23;
    i7 = HEAP32[i5 + 4 >> 2] | 0;
    i8 = i2;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i8 + 4 >> 2] = i7;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 8;
   }
   __ZN10GameObject14CopyPropertiesERS_(i6, i10);
   i7 = i10 + 28 | 0;
   i8 = i6 + 40 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i10 + 40 | 0;
   HEAP32[i3 >> 2] = i2;
   i4 = i10 + 44 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i2;
    HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 3, 4, i10 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i10 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i7 >> 2] = i5;
    break;
   } while (0);
   if (HEAP32[i8 >> 2] | 0) {
    i5 = i6 + 28 | 0;
    i4 = 0;
    do {
     i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
     i39 = gb + 63520 | 0;
     i40 = HEAP32[i39 >> 2] | 0;
     i39 = HEAP32[i39 + 4 >> 2] | 0;
     i3 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
     i6 = i21;
     HEAP32[i6 >> 2] = i40;
     HEAP32[i6 + 4 >> 2] = i39;
     HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
     i3 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i3, 0, i23, 2) | 0;
     if (i3 | 0) if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN13MonoBehaviour20SetScriptingDataFromERKS_(i3, i2);
     i40 = HEAP32[i7 >> 2] | 0;
     HEAP32[i40 + (i4 << 3) >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) >> 2];
     HEAP32[i40 + (i4 << 3) + 4 >> 2] = i3;
     HEAP32[i3 + 28 >> 2] = i10;
     i40 = HEAP32[i3 + 4 >> 2] | 0;
     HEAP32[i23 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i12 >> 2] = i40;
     i2 = HEAP32[i16 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i23); else {
      i6 = i23;
      i39 = HEAP32[i6 + 4 >> 2] | 0;
      i40 = i2;
      HEAP32[i40 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i40 + 4 >> 2] = i39;
      HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 8;
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
   }
   HEAP32[i9 >> 2] = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i10, gb + 28940 | 0) | 0;
   i1 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i1 = HEAP32[i36 >> 2] | 0;
 }
 i4 = HEAP32[i30 + 12 >> 2] | 0;
 HEAP32[i4 + (i1 << 2) >> 2] = i29;
 i1 = HEAP32[i36 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if ((i2 | 0) != -1) {
  i3 = i26 + 4 | 0;
  i1 = i2;
  do {
   __ZN9Transform18GetTransformAccessEv(i26, HEAP32[(HEAP32[i18 + (i1 << 2) >> 2] | 0) + 100 >> 2] | 0);
   HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i17 + (HEAP32[i3 >> 2] << 2) >> 2];
   i1 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i1 = HEAP32[i36 >> 2] | 0;
 }
 __ZN9Transform40InstantiateTransformSubhierarchyInternalER18TransformHierarchyPPS_Pij(i30, i18, i17, i1);
 if (!i27) {
  i40 = HEAP32[i34 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i40, i25);
  i40 = HEAP32[i33 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
  STACKTOP = i38;
  return;
 }
 i9 = i32 + 80 | 0;
 i2 = HEAP32[i24 + (HEAP32[i36 >> 2] << 2) >> 2] | 0;
 i3 = i32 + 92 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i32 + 96 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i32 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i40 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i32 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i40 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i40;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 __ZN17TransformInternal26InsertTransformThreadAfterER18TransformHierarchyjjj(i30, i28, HEAP32[i36 >> 2] | 0, HEAP32[i37 >> 2] | 0);
 __ZN17TransformInternal27UpdateDeepChildCountUpwardsER18TransformHierarchyii(i30, i29, i35);
 i40 = HEAP32[i34 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i40, i25);
 i40 = HEAP32[i33 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
 STACKTOP = i38;
 return;
}

function _cff_parse_font_matrix(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = HEAP32[i9 + 412 >> 2] | 0;
 i10 = i13 + 72 | 0;
 i14 = i13 + 68 | 0;
 i11 = i9 + 40 | 0;
 if ((HEAP32[i9 + 404 >> 2] | 0) >>> 0 < i11 >>> 0) {
  i14 = 161;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP8[i13 + 64 >> 0] = 1;
 i2 = HEAP32[i9 + 16 >> 2] | 0;
 i7 = i9 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 == 30) {
  i1 = _cff_parse_real(i2, i1, 0, i12) | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i6 = 26;
 } else {
  i4 = i2 + 1 | 0;
  i5 = i3 & 255;
  L7 : do switch (i3 << 24 >> 24) {
  case 28:
   {
    if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
    break;
   }
  case 29:
   {
    if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
     i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     i6 = 16;
    }
    break;
   }
  default:
   {
    if ((i3 & 255) < 247) {
     i1 = i5 + -139 | 0;
     break L7;
    }
    i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i3 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L7;
     }
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     i6 = 16;
     break L7;
    } else {
     if (i1) {
      i1 = 0;
      break L7;
     }
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     i6 = 16;
     break L7;
    }
   }
  } while (0);
  if ((i6 | 0) == 16) if ((i1 | 0) > 32767) {
   if ((i1 | 0) < 1e5) i2 = 5; else if ((i1 | 0) < 1e6) i2 = 6; else if ((i1 | 0) < 1e7) i2 = 7; else if ((i1 | 0) < 1e8) i2 = 8; else i2 = (i1 | 0) < 1e9 ? 9 : 10;
   i4 = i2 + -5 | 0;
   i3 = HEAP32[gb + 186012 + (i4 << 2) >> 2] | 0;
   if (((i1 | 0) / (i3 | 0) | 0 | 0) > 32767) {
    i4 = i2 + -4 | 0;
    HEAP32[i12 >> 2] = i4;
    i1 = _UNITY_FT_DivFix(i1, HEAP32[gb + 186012 + (i4 << 2) >> 2] | 0) | 0;
    i6 = 26;
    break;
   } else {
    HEAP32[i12 >> 2] = i4;
    i1 = _UNITY_FT_DivFix(i1, i3) | 0;
    i6 = 26;
    break;
   }
  }
  HEAP32[i13 + 48 >> 2] = i1 << 16;
  HEAP32[i12 >> 2] = 0;
  i4 = 0;
  i8 = 0;
  i6 = 28;
 } while (0);
 if ((i6 | 0) == 26) {
  i2 = i13 + 48 | 0;
  HEAP32[i2 >> 2] = i1;
  i1 = 0 - i4 | 0;
  HEAP32[i12 >> 2] = i1;
  if ((i4 + 9 | 0) >>> 0 > 9) {
   HEAP32[i2 >> 2] = 65536;
   HEAP32[i13 + 56 >> 2] = 0;
   HEAP32[i13 + 52 >> 2] = 0;
   HEAP32[i13 + 60 >> 2] = 65536;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i13 + 76 >> 2] = 0;
   i1 = 1;
  } else {
   i8 = i1;
   i6 = 28;
  }
 }
 if ((i6 | 0) == 28) {
  i1 = i9 + 24 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP8[i2 >> 0] | 0;
  if (i6 << 24 >> 24 == 30) {
   i7 = _cff_parse_real(i2, i7, i8, 0) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i1 = i7;
   i7 = HEAP32[i12 >> 2] | 0;
  } else {
   i3 = i2 + 1 | 0;
   i5 = i6 & 255;
   L42 : do switch (i6 << 24 >> 24) {
   case 28:
    {
     if ((i2 + 3 | 0) >>> 0 > i7 >>> 0) i1 = 0; else i1 = ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
     break;
    }
   case 29:
    {
     if ((i2 + 5 | 0) >>> 0 > i7 >>> 0) i1 = 0; else i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     break;
    }
   default:
    {
     if ((i6 & 255) < 247) {
      i1 = i5 + -139 | 0;
      break L42;
     }
     i1 = (i2 + 2 | 0) >>> 0 > i7 >>> 0;
     if ((i6 & 255) < 251) {
      if (i1) {
       i1 = 0;
       break L42;
      }
      i1 = (HEAPU8[i3 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
      break L42;
     } else {
      if (i1) {
       i1 = 0;
       break L42;
      }
      i1 = (251 - i5 << 8) + -108 - (HEAPU8[i3 >> 0] | 0) | 0;
      break L42;
     }
    }
   } while (0);
   if (i4) i1 = Math_imul(HEAP32[gb + 186012 + (i8 << 2) >> 2] | 0, i1) | 0;
   if ((i1 | 0) > 32767) {
    i6 = i7;
    i1 = 2147483647;
    i7 = i8;
   } else {
    i6 = i7;
    i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
    i7 = i8;
   }
  }
  HEAP32[i13 + 56 >> 2] = i1;
  i1 = i9 + 28 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  if (i4 << 24 >> 24 == 30) {
   i7 = _cff_parse_real(i6, i5, i7, 0) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i1 = i7;
   i7 = HEAP32[i12 >> 2] | 0;
  } else {
   i2 = i6 + 1 | 0;
   i3 = i4 & 255;
   L65 : do switch (i4 << 24 >> 24) {
   case 28:
    {
     if ((i6 + 3 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = ((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i6 + 2 >> 0] | 0)) << 16 >> 16;
     break;
    }
   case 29:
    {
     if ((i6 + 5 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = (HEAPU8[i6 + 2 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i6 + 3 >> 0] | 0) << 8 | (HEAPU8[i6 + 4 >> 0] | 0);
     break;
    }
   default:
    {
     if ((i4 & 255) < 247) {
      i1 = i3 + -139 | 0;
      break L65;
     }
     i1 = (i6 + 2 | 0) >>> 0 > i5 >>> 0;
     if ((i4 & 255) < 251) {
      if (i1) {
       i1 = 0;
       break L65;
      }
      i1 = (HEAPU8[i2 >> 0] | 0 | (i3 << 8) + -63232) + 108 | 0;
      break L65;
     } else {
      if (i1) {
       i1 = 0;
       break L65;
      }
      i1 = (251 - i3 << 8) + -108 - (HEAPU8[i2 >> 0] | 0) | 0;
      break L65;
     }
    }
   } while (0);
   if (i7) i1 = Math_imul(HEAP32[gb + 186012 + (i7 << 2) >> 2] | 0, i1) | 0;
   if ((i1 | 0) > 32767) {
    i6 = i5;
    i1 = 2147483647;
   } else {
    i6 = i5;
    i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
   }
  }
  HEAP32[i13 + 52 >> 2] = i1;
  i1 = i9 + 32 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  if (i4 << 24 >> 24 == 30) {
   i7 = _cff_parse_real(i6, i5, i7, 0) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i1 = i7;
   i7 = HEAP32[i12 >> 2] | 0;
  } else {
   i2 = i6 + 1 | 0;
   i3 = i4 & 255;
   L88 : do switch (i4 << 24 >> 24) {
   case 28:
    {
     if ((i6 + 3 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = ((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i6 + 2 >> 0] | 0)) << 16 >> 16;
     break;
    }
   case 29:
    {
     if ((i6 + 5 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = (HEAPU8[i6 + 2 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i6 + 3 >> 0] | 0) << 8 | (HEAPU8[i6 + 4 >> 0] | 0);
     break;
    }
   default:
    {
     if ((i4 & 255) < 247) {
      i1 = i3 + -139 | 0;
      break L88;
     }
     i1 = (i6 + 2 | 0) >>> 0 > i5 >>> 0;
     if ((i4 & 255) < 251) {
      if (i1) {
       i1 = 0;
       break L88;
      }
      i1 = (HEAPU8[i2 >> 0] | 0 | (i3 << 8) + -63232) + 108 | 0;
      break L88;
     } else {
      if (i1) {
       i1 = 0;
       break L88;
      }
      i1 = (251 - i3 << 8) + -108 - (HEAPU8[i2 >> 0] | 0) | 0;
      break L88;
     }
    }
   } while (0);
   if (i7) i1 = Math_imul(HEAP32[gb + 186012 + (i7 << 2) >> 2] | 0, i1) | 0;
   if ((i1 | 0) > 32767) {
    i6 = i5;
    i1 = 2147483647;
   } else {
    i6 = i5;
    i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
   }
  }
  HEAP32[i13 + 60 >> 2] = i1;
  i1 = i9 + 36 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  if (i4 << 24 >> 24 == 30) {
   i6 = _cff_parse_real(i6, i5, i7, 0) | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = i6;
   i6 = HEAP32[i12 >> 2] | 0;
  } else {
   i2 = i6 + 1 | 0;
   i3 = i4 & 255;
   L111 : do switch (i4 << 24 >> 24) {
   case 28:
    {
     if ((i6 + 3 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = ((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i6 + 2 >> 0] | 0)) << 16 >> 16;
     break;
    }
   case 29:
    {
     if ((i6 + 5 | 0) >>> 0 > i5 >>> 0) i1 = 0; else i1 = (HEAPU8[i6 + 2 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i6 + 3 >> 0] | 0) << 8 | (HEAPU8[i6 + 4 >> 0] | 0);
     break;
    }
   default:
    {
     if ((i4 & 255) < 247) {
      i1 = i3 + -139 | 0;
      break L111;
     }
     i1 = (i6 + 2 | 0) >>> 0 > i5 >>> 0;
     if ((i4 & 255) < 251) {
      if (i1) {
       i1 = 0;
       break L111;
      }
      i1 = (HEAPU8[i2 >> 0] | 0 | (i3 << 8) + -63232) + 108 | 0;
      break L111;
     } else {
      if (i1) {
       i1 = 0;
       break L111;
      }
      i1 = (251 - i3 << 8) + -108 - (HEAPU8[i2 >> 0] | 0) | 0;
      break L111;
     }
    }
   } while (0);
   if (i7) i1 = Math_imul(HEAP32[gb + 186012 + (i7 << 2) >> 2] | 0, i1) | 0;
   if ((i1 | 0) > 32767) {
    i1 = 2147483647;
    i6 = i7;
   } else {
    i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
    i6 = i7;
   }
  }
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP8[i5 >> 0] | 0;
  if (i4 << 24 >> 24 == 30) {
   i2 = _cff_parse_real(i5, i1, i6, 0) | 0;
   i1 = HEAP32[i12 >> 2] | 0;
  } else {
   i2 = i5 + 1 | 0;
   i3 = i4 & 255;
   L134 : do switch (i4 << 24 >> 24) {
   case 28:
    {
     if ((i5 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i5 + 2 >> 0] | 0)) << 16 >> 16;
     break;
    }
   case 29:
    {
     if ((i5 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = (HEAPU8[i5 + 2 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i5 + 3 >> 0] | 0) << 8 | (HEAPU8[i5 + 4 >> 0] | 0);
     break;
    }
   default:
    {
     if ((i4 & 255) < 247) {
      i1 = i3 + -139 | 0;
      break L134;
     }
     i1 = (i5 + 2 | 0) >>> 0 > i1 >>> 0;
     if ((i4 & 255) < 251) {
      if (i1) {
       i1 = 0;
       break L134;
      }
      i1 = (HEAPU8[i2 >> 0] | 0 | (i3 << 8) + -63232) + 108 | 0;
      break L134;
     } else {
      if (i1) {
       i1 = 0;
       break L134;
      }
      i1 = (251 - i3 << 8) + -108 - (HEAPU8[i2 >> 0] | 0) | 0;
      break L134;
     }
    }
   } while (0);
   if (i6) i1 = Math_imul(HEAP32[gb + 186012 + (i6 << 2) >> 2] | 0, i1) | 0;
   if ((i1 | 0) > 32767) {
    i2 = 2147483647;
    i1 = i6;
   } else {
    i2 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
    i1 = i6;
   }
  }
  HEAP32[i13 + 76 >> 2] = i2;
  i1 = HEAP32[gb + 186012 + (i1 << 2) >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 i14 = 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN11JpegDecoder16DecodePixelsImplEPhjb13TextureFormat(i5, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = 4;
 i15 = _malloc(40) | 0;
 HEAP32[i15 >> 2] = 0;
 i10 = i16 + 4 | 0;
 i11 = i16;
 i12 = i5 + 4 | 0;
 if (HEAP8[i12 >> 0] | 0) {
  _free(i15 | 0);
  STACKTOP = i16;
  return;
 }
 i14 = i5 + 36 | 0;
 i15 = _saveSetjmp((HEAP32[i14 >> 2] | 0) + 132 | 0, 1, i15 | 0, i13 | 0) | 0;
 i13 = getTempRet0() | 0;
 __THREW__ = 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
  if (!i2) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i2 = -1;
 i1 = getTempRet0() | 0;
 if ((i2 | 0) != 1) i1 = 0;
 L6 : while (1) {
  if (i1 | 0) {
   HEAP8[i12 >> 0] = 1;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i3 = i5 + 32 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(fb + 3369 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue;
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(fb + 3370 | 0, i1 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue;
    }
   }
   i1 = HEAP32[i14 >> 2] | 0;
   if (!i1) {
    i1 = 13;
    break;
   }
   __THREW__ = 0;
   invoke_vi(fb + 3370 | 0, i1 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue; else {
    i1 = 12;
    break;
   }
  }
  switch (i9 | 0) {
  case 3:
   {
    i4 = i5 + 32 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 44 >> 2] = 2;
    break;
   }
  case 4:
   {
    i4 = i5 + 32 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 44 >> 2] = 12;
    break;
   }
  case 8:
   {
    i4 = i5 + 32 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 44 >> 2] = 8;
    break;
   }
  case 14:
   {
    i4 = i5 + 32 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 44 >> 2] = 13;
    break;
   }
  case 5:
   {
    i4 = i5 + 32 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 44 >> 2] = 15;
    break;
   }
  default:
   {
    HEAP8[i12 >> 0] = 1;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 + 12 >> 2] = 0;
    i3 = i5 + 32 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(fb + 3369 | 0, i1 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue L6;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) {
      __THREW__ = 0;
      invoke_vi(fb + 3370 | 0, i1 | 0);
      i1 = __THREW__;
      __THREW__ = 0;
      if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
       i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
       if (!i2) _longjmp(i1 | 0, threwValue | 0);
       setTempRet0(threwValue | 0);
      } else i2 = -1;
      i1 = getTempRet0() | 0;
      if ((i2 | 0) == 1) continue L6;
     }
    }
    i1 = HEAP32[i14 >> 2] | 0;
    if (!i1) {
     i1 = 28;
     break L6;
    }
    __THREW__ = 0;
    invoke_vi(fb + 3370 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue L6; else {
     i1 = 27;
     break L6;
    }
   }
  }
  __THREW__ = 0;
  i2 = invoke_ii(fb + 1573 | 0, i1 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
   if (!i3) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i3 = -1;
  i1 = getTempRet0() | 0;
  if ((i3 | 0) == 1) continue;
  if (!(i2 << 24 >> 24)) {
   HEAP8[i12 >> 0] = 1;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(fb + 3369 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(fb + 3370 | 0, i1 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue;
    }
   }
   i1 = HEAP32[i14 >> 2] | 0;
   if (!i1) {
    i1 = 39;
    break;
   }
   __THREW__ = 0;
   invoke_vi(fb + 3370 | 0, i1 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue; else {
    i1 = 38;
    break;
   }
  }
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = (HEAP32[i1 + 120 >> 2] | 0) >>> 0 < (HEAP32[i1 + 96 >> 2] | 0) >>> 0;
  if (i8) {
   if (i2) {
    i3 = HEAP32[i5 + 12 >> 2] | 0;
    while (1) {
     i3 = i3 + -1 | 0;
     HEAP32[i10 >> 2] = i6 + (Math_imul(i3, i7) | 0);
     __THREW__ = 0;
     invoke_iiii(fb + 350 | 0, i1 | 0, i10 | 0, 1) | 0;
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) continue L6;
     i1 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i1 + 120 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 96 >> 2] | 0) >>> 0) break;
    }
   }
  } else if (i2) {
   i3 = 0;
   while (1) {
    HEAP32[i11 >> 2] = i6 + (Math_imul(i3, i7) | 0);
    __THREW__ = 0;
    invoke_iiii(fb + 350 | 0, i1 | 0, i11 | 0, 1) | 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue L6;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i1 + 120 >> 2] | 0) >>> 0 < (HEAP32[i1 + 96 >> 2] | 0) >>> 0) i3 = i3 + 1 | 0; else break;
   }
  }
  __THREW__ = 0;
  invoke_ii(fb + 1574 | 0, i1 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) continue;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   __THREW__ = 0;
   invoke_vi(fb + 3369 | 0, i1 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) continue;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(fb + 3370 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) continue;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if (!i1) {
   i1 = 58;
   break;
  }
  __THREW__ = 0;
  invoke_vi(fb + 3370 | 0, i1 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i15 | 0, i13 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i1 = 57;
   break;
  }
 }
 if ((i1 | 0) == 12) i1 = 13; else if ((i1 | 0) == 27) i1 = 28; else if ((i1 | 0) == 38) i1 = 39; else if ((i1 | 0) == 57) i1 = 58;
 if ((i1 | 0) == 13) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  _free(i15 | 0);
  STACKTOP = i16;
  return;
 } else if ((i1 | 0) == 28) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  _free(i15 | 0);
  STACKTOP = i16;
  return;
 } else if ((i1 | 0) == 39) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  _free(i15 | 0);
  STACKTOP = i16;
  return;
 } else if ((i1 | 0) == 58) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  _free(i15 | 0);
  STACKTOP = i16;
  return;
 }
}

function _UNITY_TT_Vary_Apply_Glyph_Deltas(i1, i4, i30, i31) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i37 + 8 | 0;
 i32 = i37 + 4 | 0;
 i6 = i37;
 i34 = HEAP32[i1 + 104 >> 2] | 0;
 i35 = HEAP32[i34 + 28 >> 2] | 0;
 i29 = HEAP32[i1 + 676 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 if ((i29 | 0) == 0 | (HEAP8[i1 + 672 >> 0] | 0) == 0) {
  i36 = 6;
  STACKTOP = i37;
  return i36 | 0;
 }
 if ((HEAP32[i29 + 32 >> 2] | 0) >>> 0 <= i4 >>> 0) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i2 = i29 + 36 | 0;
 i33 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 if ((HEAP32[i33 + (i4 << 2) >> 2] | 0) == (HEAP32[i33 + (i3 << 2) >> 2] | 0)) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i33 = _UNITY_ft_mem_realloc(i35, 8, 0, i31, 0, i36) | 0;
 if (!(HEAP32[i36 >> 2] | 0)) {
  i1 = _UNITY_ft_mem_realloc(i35, 1, 0, i31, 0, i36) | 0;
  if (!(HEAP32[i36 >> 2] | 0)) {
   i28 = _UNITY_FT_Stream_Seek(i34, HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0) | 0;
   HEAP32[i36 >> 2] = i28;
   if (!i28) {
    i28 = HEAP32[i2 >> 2] | 0;
    i28 = _UNITY_FT_Stream_EnterFrame(i34, (HEAP32[i28 + (i3 << 2) >> 2] | 0) - (HEAP32[i28 + (i4 << 2) >> 2] | 0) | 0) | 0;
    HEAP32[i36 >> 2] = i28;
    if (!i28) {
     i27 = i34 + 32 | 0;
     i4 = (HEAP32[i27 >> 2] | 0) - (HEAP32[i34 >> 2] | 0) | 0;
     i28 = _UNITY_ft_mem_realloc(i35, 4, 0, HEAP32[i29 >> 2] | 0, 0, i36) | 0;
     L15 : do if (!(HEAP32[i36 >> 2] | 0)) {
      i2 = _UNITY_ft_mem_realloc(i35, 4, 0, HEAP32[i29 >> 2] | 0, 0, i36) | 0;
      if (!(HEAP32[i36 >> 2] | 0)) {
       i3 = _UNITY_ft_mem_realloc(i35, 4, 0, HEAP32[i29 >> 2] | 0, 0, i36) | 0;
       if (!(HEAP32[i36 >> 2] | 0)) {
        i5 = (_UNITY_FT_Stream_GetUShort(i34) | 0) & 65535;
        i4 = ((_UNITY_FT_Stream_GetUShort(i34) | 0) & 65535) + i4 | 0;
        if (!(i5 & 32768)) i26 = 0; else {
         i26 = HEAP32[i34 >> 2] | 0;
         i25 = (HEAP32[i27 >> 2] | 0) - i26 | 0;
         HEAP32[i27 >> 2] = i26 + i4;
         i26 = _ft_var_readpackedpoints(i34, i6) | 0;
         i24 = HEAP32[i34 >> 2] | 0;
         i4 = (HEAP32[i27 >> 2] | 0) - i24 | 0;
         HEAP32[i27 >> 2] = i24 + i25;
        }
        i23 = i5 & 4095;
        if (i23) {
         i24 = i29 + 24 | 0;
         i25 = i29 + 28 | 0;
         i19 = HEAP32[i6 >> 2] | 0;
         i20 = (i31 | 0) == 0;
         i21 = i30 + 4 | 0;
         i22 = i30 + 12 | 0;
         i5 = 0;
         i18 = 0;
         while (1) {
          i17 = (_UNITY_FT_Stream_GetUShort(i34) | 0) & 65535;
          i8 = _UNITY_FT_Stream_GetUShort(i34) | 0;
          i9 = i8 & 65535;
          if (!(i9 & 32768)) {
           i6 = i9 & 4095;
           if (i6 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) break;
           i16 = HEAP32[i29 >> 2] | 0;
           i15 = Math_imul(i16, i6) | 0;
           _memcpy(i28 | 0, (HEAP32[i25 >> 2] | 0) + (i15 << 2) | 0, i16 << 2 | 0) | 0;
          } else if (HEAP32[i29 >> 2] | 0) {
           i6 = 0;
           do {
            HEAP32[i28 + (i6 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i34) | 0) << 16 >> 16 << 2;
            i6 = i6 + 1 | 0;
           } while (i6 >>> 0 < (HEAP32[i29 >> 2] | 0) >>> 0);
          }
          if (i9 & 16384 | 0) if (HEAP32[i29 >> 2] | 0) {
           i6 = 0;
           do {
            HEAP32[i2 + (i6 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i34) | 0) << 16 >> 16 << 2;
            i6 = i6 + 1 | 0;
            i7 = HEAP32[i29 >> 2] | 0;
           } while (i6 >>> 0 < i7 >>> 0);
           if (i7 | 0) {
            i6 = 0;
            do {
             HEAP32[i3 + (i6 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i34) | 0) << 16 >> 16 << 2;
             i6 = i6 + 1 | 0;
            } while (i6 >>> 0 < (HEAP32[i29 >> 2] | 0) >>> 0);
           }
          }
          i10 = _ft_var_apply_tuple(i29, i8, i28, i2, i3) | 0;
          if (i10) {
           i6 = HEAP32[i34 >> 2] | 0;
           i16 = (HEAP32[i27 >> 2] | 0) - i6 | 0;
           if (!(i9 & 8192)) {
            HEAP32[i32 >> 2] = i19;
            i6 = i26;
            i8 = i19;
           } else {
            HEAP32[i27 >> 2] = i6 + i4;
            i5 = _ft_var_readpackedpoints(i34, i32) | 0;
            i6 = i5;
            i8 = HEAP32[i32 >> 2] | 0;
           }
           i7 = (i8 | 0) == 0;
           i15 = i7 ? i31 : i8;
           i14 = _ft_var_readpackeddeltas(i34, i15) | 0;
           i15 = _ft_var_readpackeddeltas(i34, i15) | 0;
           L46 : do if (!((i14 | 0) == 0 | ((i6 | 0) == 0 | (i15 | 0) == 0))) {
            if ((i6 | 0) == (-1 | 0)) {
             if (i20) break; else i6 = 0;
             while (1) {
              i13 = _UNITY_FT_MulFix(HEAP16[i14 + (i6 << 1) >> 1] | 0, i10) | 0;
              i12 = (HEAP32[i21 >> 2] | 0) + (i6 << 3) | 0;
              HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i13;
              i12 = _UNITY_FT_MulFix(HEAP16[i15 + (i6 << 1) >> 1] | 0, i10) | 0;
              i13 = (HEAP32[i21 >> 2] | 0) + (i6 << 3) + 4 | 0;
              HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
              i6 = i6 + 1 | 0;
              if ((i6 | 0) == (i31 | 0)) break L46;
             }
            }
            if (!i20) {
             i6 = 0;
             do {
              i11 = (HEAP32[i21 >> 2] | 0) + (i6 << 3) | 0;
              i12 = HEAP32[i11 + 4 >> 2] | 0;
              i13 = i33 + (i6 << 3) | 0;
              HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
              HEAP32[i13 + 4 >> 2] = i12;
              HEAP8[i1 + i6 >> 0] = 0;
              i6 = i6 + 1 | 0;
             } while ((i6 | 0) != (i31 | 0));
            }
            if (!i7) {
             i6 = 0;
             do {
              i7 = HEAPU16[i5 + (i6 << 1) >> 1] | 0;
              if (i7 >>> 0 < i31 >>> 0) {
               HEAP8[i1 + i7 >> 0] = 1;
               i13 = _UNITY_FT_MulFix(HEAP16[i14 + (i6 << 1) >> 1] | 0, i10) | 0;
               i12 = (HEAP32[i21 >> 2] | 0) + (i7 << 3) | 0;
               HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i13;
               i12 = _UNITY_FT_MulFix(HEAP16[i15 + (i6 << 1) >> 1] | 0, i10) | 0;
               i13 = (HEAP32[i21 >> 2] | 0) + (i7 << 3) + 4 | 0;
               HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
              }
              i6 = i6 + 1 | 0;
             } while (i6 >>> 0 < i8 >>> 0);
            }
            if (!(HEAP16[i30 >> 1] | 0)) break;
            i13 = HEAP32[i21 >> 2] | 0;
            i12 = 0;
            i6 = 0;
            do {
             i11 = HEAP16[(HEAP32[i22 >> 2] | 0) + (i12 << 16 >> 16 << 1) >> 1] | 0;
             L67 : do if ((i6 | 0) <= (i11 | 0)) {
              i9 = i6;
              while (1) {
               if (HEAP8[i1 + i9 >> 0] | 0) {
                i7 = i9;
                break;
               }
               i7 = i9 + 1 | 0;
               if ((i9 | 0) < (i11 | 0)) i9 = i7; else {
                i6 = i7;
                break L67;
               }
              }
              L71 : while (1) {
               i8 = i7;
               while (1) {
                i10 = i8 + 1 | 0;
                if ((i8 | 0) >= (i11 | 0)) break L71;
                if (!(HEAP8[i1 + i10 >> 0] | 0)) i8 = i10; else break;
               }
               _tt_delta_interpolate(i7 + 1 | 0, i8, i7, i10, i33, i13);
               i7 = i10;
              }
              if ((i7 | 0) != (i9 | 0)) {
               _tt_delta_interpolate(i7 + 1 | 0, i11, i7, i9, i33, i13);
               if ((i9 | 0) <= 0) {
                i6 = i10;
                break;
               }
               _tt_delta_interpolate(i6, i9 + -1 | 0, i7, i9, i33, i13);
               i6 = i10;
               break;
              }
              i7 = (HEAP32[i13 + (i9 << 3) >> 2] | 0) - (HEAP32[i33 + (i9 << 3) >> 2] | 0) | 0;
              i8 = (HEAP32[i13 + (i9 << 3) + 4 >> 2] | 0) - (HEAP32[i33 + (i9 << 3) + 4 >> 2] | 0) | 0;
              if (!(i8 | i7)) {
               i6 = i10;
               break;
              }
              if ((i6 | 0) < (i9 | 0)) do {
               i38 = i13 + (i6 << 3) | 0;
               HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i7;
               i38 = i13 + (i6 << 3) + 4 | 0;
               HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i8;
               i6 = i6 + 1 | 0;
              } while ((i6 | 0) != (i9 | 0));
              if ((i9 | 0) < (i11 | 0)) i6 = i9; else {
               i6 = i10;
               break;
              }
              do {
               i6 = i6 + 1 | 0;
               i38 = i13 + (i6 << 3) | 0;
               HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i7;
               i38 = i13 + (i6 << 3) + 4 | 0;
               HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + i8;
              } while ((i6 | 0) != (i11 | 0));
              i6 = i10;
             } while (0);
             i12 = i12 + 1 << 16 >> 16;
            } while (i12 << 16 >> 16 < (HEAP16[i30 >> 1] | 0));
           } while (0);
           if ((i5 | 0) == (-1 | 0)) i5 = -1; else {
            _UNITY_ft_mem_free(i35, i5);
            i5 = 0;
           }
           _UNITY_ft_mem_free(i35, i14);
           _UNITY_ft_mem_free(i35, i15);
           HEAP32[i27 >> 2] = (HEAP32[i34 >> 2] | 0) + i16;
          }
          i18 = i18 + 1 | 0;
          if (i18 >>> 0 >= i23 >>> 0) break L15; else i4 = i17 + i4 | 0;
         }
         HEAP32[i36 >> 2] = 8;
        }
       }
      } else i3 = 0;
     } else {
      i3 = 0;
      i2 = 0;
     } while (0);
     _UNITY_ft_mem_free(i35, i28);
     _UNITY_ft_mem_free(i35, i2);
     _UNITY_ft_mem_free(i35, i3);
     _UNITY_FT_Stream_ExitFrame(i34);
    }
   }
  }
 } else i1 = 0;
 _UNITY_ft_mem_free(i35, i33);
 _UNITY_ft_mem_free(i35, i1);
 i38 = HEAP32[i36 >> 2] | 0;
 STACKTOP = i37;
 return i38 | 0;
}

function __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i32, i1, i35, i36) {
 i32 = i32 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i40 + 24 | 0;
 i38 = i40 + 12 | 0;
 i39 = i40;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 i34 = i1 + 11 | 0;
 i28 = HEAP8[i34 >> 0] | 0;
 i28 = i28 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i28 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i37, gb + 396388 | 0, 7, i28 + 7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i37, (HEAP8[i34 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, i28) | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i38, gb + 396396 | 0, 6);
 i28 = (i36 | 0) != 0;
 do if (i28) {
  i1 = i36 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i36 >> 2] >> 0] = 0;
   HEAP32[i36 + 4 >> 2] = 0;
   break;
  } else {
   HEAP8[i36 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
   break;
  }
 } while (0);
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 i33 = i35 + 11 | 0;
 i34 = i35 + 4 | 0;
 i20 = i37 + 11 | 0;
 i21 = i37 + 4 | 0;
 i30 = i38 + 11 | 0;
 i31 = i38 + 4 | 0;
 i22 = i39 + 11 | 0;
 i23 = i39 + 4 | 0;
 i24 = i39 + 11 | 0;
 i25 = i39 + 4 | 0;
 i26 = i39 + 11 | 0;
 i27 = i39 + 4 | 0;
 i29 = 0;
 L7 : while (1) {
  i16 = HEAP8[i33 >> 0] | 0;
  i6 = i16 << 24 >> 24 < 0;
  i15 = i6 ? HEAP32[i35 >> 2] | 0 : i35;
  i16 = i6 ? HEAP32[i34 >> 2] | 0 : i16 & 255;
  i6 = HEAP8[i20 >> 0] | 0;
  i17 = i6 << 24 >> 24 < 0;
  i5 = i17 ? HEAP32[i37 >> 2] | 0 : i37;
  i6 = i17 ? HEAP32[i21 >> 2] | 0 : i6 & 255;
  i17 = i15 + i16 | 0;
  i7 = i5 + i6 | 0;
  i18 = i17;
  i19 = i15;
  i8 = i17 + (1 - i6) | 0;
  if (!i6) {
   i2 = i16 >>> 0 < i29 >>> 0 | (i29 | 0) == -1;
   i1 = i15 + i29 | 0;
   while (1) {
    if (i2) break L7;
    i14 = (HEAP8[i1 >> 0] | 0) + -9 << 24 >> 24;
    if ((i14 & 255) < 24 & (8388639 >>> (i14 & 255) & 1 | 0) != 0) {
     i14 = i29;
     break;
    }
   }
  } else {
   i1 = i29;
   while (1) {
    if (i16 >>> 0 < i1 >>> 0 | (i16 - i1 | 0) >>> 0 < i6 >>> 0) break L7;
    i1 = i15 + i1 | 0;
    L17 : do if ((i18 - i1 | 0) < (i6 | 0) | (i8 | 0) == (i1 | 0)) i1 = i18; else {
     i4 = HEAP8[i5 >> 0] | 0;
     L19 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i4 << 24 >> 24) {
        i2 = i5;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i8 | 0)) {
        i1 = i18;
        break L17;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break L19;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i8 | 0)) {
       i1 = i18;
       break L17;
      }
     }
    } while (0);
    i2 = i1 - i19 | 0;
    if ((i1 | 0) == (i17 | 0) | (i2 | 0) == -1) break L7;
    i1 = i6 + i2 | 0;
    i14 = (HEAP8[i15 + i1 >> 0] | 0) + -9 << 24 >> 24;
    if ((i14 & 255) < 24 & (8388639 >>> (i14 & 255) & 1 | 0) != 0) {
     i14 = i1;
     break;
    }
   }
  }
  i9 = HEAP8[i30 >> 0] | 0;
  i13 = i9 << 24 >> 24 < 0;
  i12 = i13 ? HEAP32[i38 >> 2] | 0 : i38;
  i9 = i13 ? HEAP32[i31 >> 2] | 0 : i9 & 255;
  i13 = i17 + -2 | 0;
  i10 = i12 + i9 | 0;
  i11 = i17 + (1 - i9) | 0;
  if (!i9) {
   i5 = 1;
   i1 = i14;
   do {
    i12 = i16 >>> 0 < i1 >>> 0;
    i4 = i12 ? -1 : i1;
    if (i12 | (i16 - i1 | 0) >>> 0 < 3) i1 = -1; else {
     i1 = i15 + i1 | 0;
     L37 : do if ((i18 - i1 | 0) < 3 | (i13 | 0) == (i1 | 0)) i1 = i18; else L38 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == 35) {
        i2 = gb + 396403 | 0;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i13 | 0)) {
        i1 = i18;
        break L37;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (gb + 396403 + 3 | 0)) break L38;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i13 | 0)) {
       i1 = i18;
       break L37;
      }
     } while (0);
     i1 = (i1 | 0) == (i17 | 0) ? -1 : i1 - i19 | 0;
    }
    if ((i4 | 0) == -1) break L7;
    i12 = (i1 | 0) != -1 & i1 >>> 0 < i4 >>> 0;
    i5 = (i12 ? 1 : -1) + i5 | 0;
    i1 = (i12 ? i1 : i4) + 1 | 0;
   } while ((i5 | 0) != 0);
  } else {
   i8 = 1;
   i1 = i14;
   do {
    i6 = i16 >>> 0 < i1 >>> 0;
    i7 = i16 - i1 | 0;
    if (i6 | i7 >>> 0 < i9 >>> 0) i4 = -1; else {
     i2 = i15 + i1 | 0;
     L55 : do if ((i18 - i2 | 0) < (i9 | 0) | (i11 | 0) == (i2 | 0)) i2 = i18; else {
      i5 = HEAP8[i12 >> 0] | 0;
      L57 : while (1) {
       while (1) {
        if ((HEAP8[i2 >> 0] | 0) == i5 << 24 >> 24) {
         i3 = i12;
         i4 = i2;
         break;
        }
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i11 | 0)) {
         i2 = i18;
         break L55;
        }
       }
       do {
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i10 | 0)) break L57;
        i4 = i4 + 1 | 0;
       } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i11 | 0)) {
        i2 = i18;
        break L55;
       }
      }
     } while (0);
     i4 = (i2 | 0) == (i17 | 0) ? -1 : i2 - i19 | 0;
    }
    if (i6 | i7 >>> 0 < 3) i1 = -1; else {
     i1 = i15 + i1 | 0;
     L71 : do if ((i18 - i1 | 0) < 3 | (i13 | 0) == (i1 | 0)) i1 = i18; else L72 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == 35) {
        i2 = gb + 396403 | 0;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i13 | 0)) {
        i1 = i18;
        break L71;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (gb + 396403 + 3 | 0)) break L72;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i13 | 0)) {
       i1 = i18;
       break L71;
      }
     } while (0);
     i1 = (i1 | 0) == (i17 | 0) ? -1 : i1 - i19 | 0;
    }
    if ((i4 | 0) == -1) break L7;
    i7 = (i1 | 0) != -1 & i1 >>> 0 < i4 >>> 0;
    i8 = (i7 ? 1 : -1) + i8 | 0;
    i1 = (i7 ? i1 : i4) + 1 | 0;
   } while ((i8 | 0) != 0);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i39, i35, i14, i1 + ~i14 | 0, i35);
  i19 = HEAP8[i22 >> 0] | 0;
  i18 = i19 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i32, i18 ? HEAP32[i39 >> 2] | 0 : i39, i18 ? HEAP32[i23 >> 2] | 0 : i19 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
  if (!i28) {
   i29 = i1;
   continue;
  }
  if (!i29) {
   i29 = HEAP8[i20 >> 0] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i39, i35, 0, i14 - (i29 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i29 & 255) | 0, i35);
   i29 = HEAP8[i24 >> 0] | 0;
   i19 = i29 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i36, i19 ? HEAP32[i39 >> 2] | 0 : i39, i19 ? HEAP32[i25 >> 2] | 0 : i29 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
   i29 = i1;
   continue;
  } else {
   i19 = HEAP8[i30 >> 0] | 0;
   i19 = i19 << 24 >> 24 < 0 ? HEAP32[i31 >> 2] | 0 : i19 & 255;
   i18 = HEAP8[i20 >> 0] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i39, i35, i19 + i29 | 0, i14 - i29 - (i18 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i18 & 255) - i19 | 0, i35);
   i19 = HEAP8[i26 >> 0] | 0;
   i18 = i19 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i36, i18 ? HEAP32[i39 >> 2] | 0 : i39, i18 ? HEAP32[i27 >> 2] | 0 : i19 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
   i29 = i1;
   continue;
  }
 }
 if (!i28) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  STACKTOP = i40;
  return;
 }
 i1 = HEAP8[i32 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i32 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i36, i35) | 0;
 if (!i29) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  STACKTOP = i40;
  return;
 }
 i1 = HEAP8[i30 >> 0] | 0;
 i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i31 >> 2] | 0 : i1 & 255) + i29 | 0;
 i33 = HEAP8[i33 >> 0] | 0;
 if (i1 >>> 0 >= (i33 << 24 >> 24 < 0 ? HEAP32[i34 >> 2] | 0 : i33 & 255) >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  STACKTOP = i40;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i39, i35, i1, -1, i35);
 i35 = HEAP8[i39 + 11 >> 0] | 0;
 i34 = i35 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i36, i34 ? HEAP32[i39 >> 2] | 0 : i39, i34 ? HEAP32[i39 + 4 >> 2] | 0 : i35 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i39);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i38);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
 STACKTOP = i40;
 return;
}

function __ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i8, f16, i2) {
 i8 = i8 | 0;
 f16 = Math_fround(f16);
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 16 | 0;
 i14 = i19 + 12 | 0;
 i9 = i19 + 8 | 0;
 i10 = i19 + 4 | 0;
 i17 = i19;
 i5 = HEAP32[i8 + 68 >> 2] | 0;
 if ((i5 | 0) == 1) {
  f16 = Math_fround(HEAPF32[(HEAP32[i8 + 56 >> 2] | 0) + 4 >> 2]);
  STACKTOP = i19;
  return Math_fround(f16);
 }
 i15 = (i2 | 0) == 0 ? i8 : i2;
 i12 = i15 + 4 | 0;
 f1 = Math_fround(HEAPF32[i12 >> 2]);
 if (f1 <= f16) if (Math_fround(HEAPF32[i15 + 8 >> 2]) > f16) {
  f11 = Math_fround(f16 - f1);
  f16 = Math_fround(f11 * Math_fround(HEAPF32[i15 + 12 >> 2]));
  f16 = Math_fround(f11 * Math_fround(f16 + Math_fround(HEAPF32[i15 + 16 >> 2])));
  f16 = Math_fround(f11 * Math_fround(Math_fround(HEAPF32[i15 + 20 >> 2]) + f16));
  f16 = Math_fround(Math_fround(HEAPF32[i15 + 24 >> 2]) + f16);
  HEAPF32[i17 >> 2] = f16;
  STACKTOP = i19;
  return Math_fround(f16);
 }
 if (!i5) {
  f16 = Math_fround(0.0);
  STACKTOP = i19;
  return Math_fround(f16);
 }
 i6 = i8 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i7 >> 2] & 2139095040 | 0) == 2139095040) {
  f16 = Math_fround(0.0);
  STACKTOP = i19;
  return Math_fround(f16);
 }
 i2 = i5 + -1 | 0;
 if ((HEAP32[i7 + (i2 << 4) >> 2] & 2139095040 | 0) == 2139095040) {
  f16 = Math_fround(0.0);
  STACKTOP = i19;
  return Math_fround(f16);
 }
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = Math_fround(HEAPF32[i7 + (i2 << 4) >> 2]);
 L19 : do if (!(f3 <= f16)) {
  if (!(f1 > f16)) {
   __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i8, i15, f16, i9, i10);
   i9 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[i6 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i8 + (i9 << 4) >> 2]);
   f11 = Math_fround(f21 + Math_fround(0.0));
   HEAPF32[i12 >> 2] = f11;
   f3 = Math_fround(HEAPF32[i8 + (i7 << 4) >> 2]);
   HEAPF32[i15 + 8 >> 2] = Math_fround(f3 + Math_fround(0.0));
   HEAP32[i15 >> 2] = i9;
   f21 = Math_fround(f3 - f21);
   HEAPF32[i13 >> 2] = f21;
   HEAPF32[i14 >> 2] = Math_fround(.0000999999974);
   i6 = f21 < Math_fround(.0000999999974);
   i14 = HEAP32[(i6 ? i14 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i14;
   f21 = Math_fround(HEAPF32[i8 + (i7 << 4) + 4 >> 2]);
   i6 = i8 + (i9 << 4) + 4 | 0;
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i6 >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = Math_fround(Math_fround(1.0) / Math_fround(f3 * f3));
   i14 = i8 + (i9 << 4) + 12 | 0;
   f1 = Math_fround(HEAPF32[i14 >> 2]);
   i7 = i8 + (i7 << 4) + 8 | 0;
   f20 = Math_fround(f3 * f1);
   f4 = Math_fround(f3 * Math_fround(HEAPF32[i7 >> 2]));
   f3 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f20 + f4) - f21) - f21)) / f3);
   i8 = i15 + 12 | 0;
   HEAPF32[i8 >> 2] = f3;
   f4 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f21 + Math_fround(f21 + f21)) - f20) - f20) - f4));
   i9 = i15 + 16 | 0;
   HEAPF32[i9 >> 2] = f4;
   i10 = i15 + 20 | 0;
   HEAPF32[i10 >> 2] = f1;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i15 + 24 | 0;
   HEAP32[i5 >> 2] = i2;
   if (Math_fround(HEAPF32[i14 >> 2]) == Math_fround(inf)) i18 = 27; else if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(inf)) i18 = 27;
   if ((i18 | 0) == 27) {
    HEAPF32[i8 >> 2] = Math_fround(0.0);
    HEAPF32[i9 >> 2] = Math_fround(0.0);
    HEAPF32[i10 >> 2] = Math_fround(0.0);
    i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i5 >> 2] = i2;
    f1 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f3 = Math_fround(0.0);
   }
   i18 = 29;
   break;
  }
  switch (HEAP32[i8 + 76 >> 2] | 0) {
  case 2:
   {
    f11 = Math_fround(f16 + Math_fround(-1.0e3));
    HEAPF32[i12 >> 2] = f11;
    HEAPF32[i15 + 8 >> 2] = f1;
    HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
    i2 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i15 + 24 >> 2] = i2;
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f1 = Math_fround(0.0);
    i18 = 29;
    break L19;
   }
  case 1:
   {
    f21 = Math_fround(f16 - f1);
    f20 = Math_fround(f3 - f1);
    f20 = Math_fround(f1 + Math_fround(f21 - Math_fround(f20 * Math_fround(Math_floor(Math_fround(f21 / f20))))));
    __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i8, i15, f20, i9, i10);
    i9 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    f20 = Math_fround(f16 - f20);
    i8 = HEAP32[i6 >> 2] | 0;
    f21 = Math_fround(HEAPF32[i8 + (i9 << 4) >> 2]);
    f11 = Math_fround(f20 + f21);
    HEAPF32[i12 >> 2] = f11;
    f3 = Math_fround(HEAPF32[i8 + (i7 << 4) >> 2]);
    HEAPF32[i15 + 8 >> 2] = Math_fround(f20 + f3);
    HEAP32[i15 >> 2] = i9;
    f21 = Math_fround(f3 - f21);
    HEAPF32[i13 >> 2] = f21;
    HEAPF32[i14 >> 2] = Math_fround(.0000999999974);
    i6 = f21 < Math_fround(.0000999999974);
    i14 = HEAP32[(i6 ? i14 : i13) >> 2] | 0;
    HEAP32[i13 >> 2] = i14;
    i6 = i8 + (i9 << 4) + 4 | 0;
    f21 = Math_fround(Math_fround(HEAPF32[i8 + (i7 << 4) + 4 >> 2]) - Math_fround(HEAPF32[i6 >> 2]));
    f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(Math_fround(1.0) / Math_fround(f3 * f3));
    i14 = i8 + (i9 << 4) + 12 | 0;
    f1 = Math_fround(HEAPF32[i14 >> 2]);
    i7 = i8 + (i7 << 4) + 8 | 0;
    f22 = Math_fround(f3 * f1);
    f4 = Math_fround(f3 * Math_fround(HEAPF32[i7 >> 2]));
    f3 = Math_fround(Math_fround(f20 * Math_fround(Math_fround(Math_fround(f22 + f4) - f21) - f21)) / f3);
    i8 = i15 + 12 | 0;
    HEAPF32[i8 >> 2] = f3;
    f4 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f21 + Math_fround(f21 + f21)) - f22) - f22) - f4));
    i9 = i15 + 16 | 0;
    HEAPF32[i9 >> 2] = f4;
    i10 = i15 + 20 | 0;
    HEAPF32[i10 >> 2] = f1;
    i2 = HEAP32[i6 >> 2] | 0;
    i5 = i15 + 24 | 0;
    HEAP32[i5 >> 2] = i2;
    if (Math_fround(HEAPF32[i14 >> 2]) == Math_fround(inf)) i18 = 22; else if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(inf)) i18 = 22;
    if ((i18 | 0) == 22) {
     HEAPF32[i8 >> 2] = Math_fround(0.0);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
     HEAPF32[i10 >> 2] = Math_fround(0.0);
     i2 = HEAP32[i6 >> 2] | 0;
     HEAP32[i5 >> 2] = i2;
     f1 = Math_fround(0.0);
     f4 = Math_fround(0.0);
     f3 = Math_fround(0.0);
    }
    i18 = 29;
    break L19;
   }
  default:
   {
    __ZNK17AnimationCurveTplIfE20EvaluateWithoutCacheEfRf(i8, f16, i17);
    break L19;
   }
  }
 } else switch (HEAP32[i8 + 80 >> 2] | 0) {
 case 2:
  {
   HEAPF32[i12 >> 2] = f3;
   HEAPF32[i15 + 8 >> 2] = Math_fround(inf);
   HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
   i2 = HEAP32[i7 + (i2 << 4) + 4 >> 2] | 0;
   HEAP32[i15 + 24 >> 2] = i2;
   f11 = f3;
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f1 = Math_fround(0.0);
   i18 = 29;
   break L19;
  }
 case 1:
  {
   f21 = Math_fround(f16 - f1);
   f20 = Math_fround(f3 - f1);
   f20 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f1 + Math_fround(f21 - Math_fround(f20 * Math_fround(Math_floor(Math_fround(f21 / f20)))))), f1)), f3));
   __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i8, i15, f20, i9, i10);
   i7 = HEAP32[i9 >> 2] | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   f20 = Math_fround(f16 - f20);
   i6 = HEAP32[i6 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i6 + (i7 << 4) >> 2]);
   f11 = Math_fround(f20 + f21);
   HEAPF32[i12 >> 2] = f11;
   f3 = Math_fround(HEAPF32[i6 + (i10 << 4) >> 2]);
   HEAPF32[i15 + 8 >> 2] = Math_fround(f20 + f3);
   HEAP32[i15 >> 2] = i7;
   f21 = Math_fround(f3 - f21);
   HEAPF32[i13 >> 2] = f21;
   HEAPF32[i14 >> 2] = Math_fround(.0000999999974);
   i9 = f21 < Math_fround(.0000999999974);
   i14 = HEAP32[(i9 ? i14 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i14;
   i9 = i6 + (i7 << 4) + 4 | 0;
   f21 = Math_fround(Math_fround(HEAPF32[i6 + (i10 << 4) + 4 >> 2]) - Math_fround(HEAPF32[i9 >> 2]));
   f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(Math_fround(1.0) / Math_fround(f3 * f3));
   i14 = i6 + (i7 << 4) + 12 | 0;
   f1 = Math_fround(HEAPF32[i14 >> 2]);
   i10 = i6 + (i10 << 4) + 8 | 0;
   f22 = Math_fround(f3 * f1);
   f4 = Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2]));
   f3 = Math_fround(Math_fround(f20 * Math_fround(Math_fround(Math_fround(f22 + f4) - f21) - f21)) / f3);
   i6 = i15 + 12 | 0;
   HEAPF32[i6 >> 2] = f3;
   f4 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(Math_fround(f21 + Math_fround(f21 + f21)) - f22) - f22) - f4));
   i7 = i15 + 16 | 0;
   HEAPF32[i7 >> 2] = f4;
   i8 = i15 + 20 | 0;
   HEAPF32[i8 >> 2] = f1;
   i2 = HEAP32[i9 >> 2] | 0;
   i5 = i15 + 24 | 0;
   HEAP32[i5 >> 2] = i2;
   if (Math_fround(HEAPF32[i14 >> 2]) == Math_fround(inf)) i18 = 14; else if (Math_fround(HEAPF32[i10 >> 2]) == Math_fround(inf)) i18 = 14;
   if ((i18 | 0) == 14) {
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i7 >> 2] = Math_fround(0.0);
    HEAPF32[i8 >> 2] = Math_fround(0.0);
    i2 = HEAP32[i9 >> 2] | 0;
    HEAP32[i5 >> 2] = i2;
    f1 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f3 = Math_fround(0.0);
   }
   i18 = 29;
   break L19;
  }
 default:
  {
   __ZNK17AnimationCurveTplIfE20EvaluateWithoutCacheEfRf(i8, f16, i17);
   break L19;
  }
 } while (0);
 if ((i18 | 0) == 29) {
  f22 = Math_fround(f16 - f11);
  HEAPF32[i17 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(f22 * Math_fround(f1 + Math_fround(f22 * Math_fround(Math_fround(f22 * f3) + f4)))));
 }
 f22 = Math_fround(HEAPF32[i17 >> 2]);
 STACKTOP = i19;
 return Math_fround(f22);
}

function __ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i22, i28, i25, i24, i23, i27, i26) {
 i22 = i22 | 0;
 i28 = i28 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i29 + 32 | 0;
 i18 = i29 + 20 | 0;
 i5 = i29 + 8 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29;
 f31 = Math_fround(HEAPF32[i28 >> 2]);
 f2 = Math_fround(HEAPF32[i22 >> 2]);
 f31 = Math_fround(f31 - f2);
 f11 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f11 = Math_fround(f11 - f35);
 f13 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f13 = Math_fround(f13 - f9);
 f10 = Math_fround(HEAPF32[i25 >> 2]);
 f36 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f10 = Math_fround(f2 - f10);
 f36 = Math_fround(f35 - f36);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i25 + 8 >> 2]));
 f35 = Math_fround(HEAPF32[i23 >> 2]);
 f2 = Math_fround(f10 * f35);
 f34 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f36 * f34));
 f3 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f9 * f3));
 f33 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f7 = Math_fround(f10 * f33);
 f32 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f36 * f32));
 f8 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * f8));
 f30 = Math_fround(HEAPF32[i23 + 24 >> 2]);
 f10 = Math_fround(f10 * f30);
 f12 = Math_fround(HEAPF32[i23 + 28 >> 2]);
 f36 = Math_fround(f10 + Math_fround(f36 * f12));
 f10 = Math_fround(HEAPF32[i23 + 32 >> 2]);
 f9 = Math_fround(f36 + Math_fround(f9 * f10));
 HEAPF32[i18 >> 2] = f2;
 i19 = i18 + 4 | 0;
 HEAPF32[i19 >> 2] = f7;
 i17 = i18 + 8 | 0;
 HEAPF32[i17 >> 2] = f9;
 f3 = Math_fround(Math_fround(Math_fround(f31 * f35) + Math_fround(f11 * f34)) + Math_fround(f13 * f3));
 f8 = Math_fround(Math_fround(Math_fround(f31 * f33) + Math_fround(f11 * f32)) + Math_fround(f13 * f8));
 f10 = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f11 * f12)) + Math_fround(f13 * f10));
 HEAPF32[i5 >> 2] = f3;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f10;
 if (f3 < Math_fround(0.0)) {
  f11 = Math_fround(-f2);
  HEAPF32[i18 >> 2] = f11;
  f3 = Math_fround(-f3);
  HEAPF32[i5 >> 2] = f3;
  i16 = 1;
 } else {
  i16 = 0;
  f11 = f2;
 }
 if (f8 < Math_fround(0.0)) {
  f12 = Math_fround(-f7);
  HEAPF32[i18 + 4 >> 2] = f12;
  f8 = Math_fround(-f8);
  HEAPF32[i5 + 4 >> 2] = f8;
  i15 = 1;
 } else {
  i15 = 0;
  f12 = f7;
 }
 if (f10 < Math_fround(0.0)) {
  f13 = Math_fround(-f9);
  HEAPF32[i18 + 8 >> 2] = f13;
  f10 = Math_fround(-f10);
  HEAPF32[i5 + 8 >> 2] = f10;
  i14 = 1;
 } else {
  i14 = 0;
  f13 = f9;
 }
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 i1 = f8 > Math_fround(0.0);
 i4 = f10 > Math_fround(0.0);
 do if (f3 > Math_fround(0.0)) if (i1) {
  if (!i4) {
   __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf(0, 1, 2, i18, i5, i24, i21, i20);
   break;
  }
  f9 = Math_fround(f11 - Math_fround(HEAPF32[i24 >> 2]));
  f7 = Math_fround(f12 - Math_fround(HEAPF32[i24 + 4 >> 2]));
  f2 = Math_fround(f13 - Math_fround(HEAPF32[i24 + 8 >> 2]));
  HEAPF32[i6 >> 2] = f9;
  HEAPF32[i6 + 4 >> 2] = f7;
  HEAPF32[i6 + 8 >> 2] = f2;
  do if (!(Math_fround(f8 * f9) >= Math_fround(f3 * f7))) if (!(Math_fround(f10 * f7) >= Math_fround(f8 * f2))) {
   __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf(2, 0, 1, i18, i5, i24, i6, i21, i20);
   break;
  } else {
   __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf(1, 2, 0, i18, i5, i24, i6, i21, i20);
   break;
  } else if (!(Math_fround(f10 * f9) >= Math_fround(f3 * f2))) {
   __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf(2, 0, 1, i18, i5, i24, i6, i21, i20);
   break;
  } else {
   __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf(0, 1, 2, i18, i5, i24, i6, i21, i20);
   break;
  } while (0);
  break;
 } else {
  if (i4) {
   __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf(0, 2, 1, i18, i5, i24, i21, i20);
   break;
  }
  f2 = Math_fround(HEAPF32[i24 >> 2]);
  HEAPF32[i21 >> 2] = Math_fround(Math_fround(f2 - f11) / f3);
  HEAPF32[i18 >> 2] = f2;
  i1 = i18 + 4 | 0;
  f2 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f3 = Math_fround(-f2);
  if (f12 < f3) {
   f7 = Math_fround(f12 + f2);
   f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i1 >> 2] = f3;
  } else if (f12 > f2) {
   f7 = Math_fround(f12 - f2);
   f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i1 >> 2] = f2;
  } else f7 = Math_fround(0.0);
  i1 = i18 + 8 | 0;
  f2 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  f3 = Math_fround(-f2);
  if (f13 < f3) {
   f36 = Math_fround(f13 + f2);
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i1 >> 2] = f3;
   break;
  }
  if (!(f13 > f2)) break;
  f36 = Math_fround(f13 - f2);
  HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
  HEAPF32[i1 >> 2] = f2;
  break;
 } else {
  if (i1) {
   if (i4) {
    __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf(1, 2, 0, i18, i5, i24, i21, i20);
    break;
   }
   f2 = Math_fround(HEAPF32[i24 + 4 >> 2]);
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(f2 - f12) / f8);
   HEAPF32[i18 + 4 >> 2] = f2;
   f2 = Math_fround(HEAPF32[i24 >> 2]);
   f3 = Math_fround(-f2);
   if (f11 < f3) {
    f7 = Math_fround(f11 + f2);
    f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
    HEAPF32[i20 >> 2] = f7;
    HEAPF32[i18 >> 2] = f3;
   } else if (f11 > f2) {
    f7 = Math_fround(f11 - f2);
    f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
    HEAPF32[i20 >> 2] = f7;
    HEAPF32[i18 >> 2] = f2;
   } else f7 = Math_fround(0.0);
   i1 = i18 + 8 | 0;
   f2 = Math_fround(HEAPF32[i24 + 8 >> 2]);
   f3 = Math_fround(-f2);
   if (f13 < f3) {
    f36 = Math_fround(f13 + f2);
    HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
    HEAPF32[i1 >> 2] = f3;
    break;
   }
   if (!(f13 > f2)) break;
   f36 = Math_fround(f13 - f2);
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i1 >> 2] = f2;
   break;
  }
  if (i4) {
   f2 = Math_fround(HEAPF32[i24 + 8 >> 2]);
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(f2 - f13) / f10);
   HEAPF32[i18 + 8 >> 2] = f2;
   f2 = Math_fround(HEAPF32[i24 >> 2]);
   f3 = Math_fround(-f2);
   if (f11 < f3) {
    f7 = Math_fround(f11 + f2);
    f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
    HEAPF32[i20 >> 2] = f7;
    HEAPF32[i18 >> 2] = f3;
   } else if (f11 > f2) {
    f7 = Math_fround(f11 - f2);
    f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
    HEAPF32[i20 >> 2] = f7;
    HEAPF32[i18 >> 2] = f2;
   } else f7 = Math_fround(0.0);
   i1 = i18 + 4 | 0;
   f2 = Math_fround(HEAPF32[i24 + 4 >> 2]);
   f3 = Math_fround(-f2);
   if (f12 < f3) {
    f36 = Math_fround(f12 + f2);
    HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
    HEAPF32[i1 >> 2] = f3;
    break;
   }
   if (!(f12 > f2)) break;
   f36 = Math_fround(f12 - f2);
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i1 >> 2] = f2;
   break;
  }
  f2 = Math_fround(HEAPF32[i24 >> 2]);
  f3 = Math_fround(-f2);
  if (f11 < f3) {
   f7 = Math_fround(f11 + f2);
   f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i18 >> 2] = f3;
  } else if (f11 > f2) {
   f7 = Math_fround(f11 - f2);
   f7 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i18 >> 2] = f2;
  } else f7 = Math_fround(0.0);
  f2 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f3 = Math_fround(-f2);
  if (f12 < f3) {
   f36 = Math_fround(f12 + f2);
   f7 = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i19 >> 2] = f3;
  } else if (f12 > f2) {
   f36 = Math_fround(f12 - f2);
   f7 = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i20 >> 2] = f7;
   HEAPF32[i19 >> 2] = f2;
  }
  f2 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  f3 = Math_fround(-f2);
  if (f13 < f3) {
   f36 = Math_fround(f13 + f2);
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i17 >> 2] = f3;
  } else if (f13 > f2) {
   f36 = Math_fround(f13 - f2);
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(f36 * f36));
   HEAPF32[i17 >> 2] = f2;
  }
  HEAPF32[i21 >> 2] = Math_fround(0.0);
 } while (0);
 if (i16 << 24 >> 24) HEAPF32[i18 >> 2] = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
 if (i15 << 24 >> 24) {
  i16 = i18 + 4 | 0;
  HEAPF32[i16 >> 2] = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
 }
 if (!(i14 << 24 >> 24)) i6 = HEAP32[i17 >> 2] | 0; else {
  i6 = i18 + 8 | 0;
  f36 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i6 >> 2] = f36;
  i6 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i5 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i20 >> 2]);
 f2 = Math_fround(HEAPF32[i21 >> 2]);
 if (!(f2 >= Math_fround(0.0))) {
  if (i27 | 0) HEAPF32[i27 >> 2] = Math_fround(0.0);
  f36 = Math_fround(__ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i22, i25, i24, i23, i26));
  STACKTOP = i29;
  return Math_fround(f36);
 }
 i1 = (i27 | 0) != 0;
 if (!(f2 <= Math_fround(1.0))) {
  if (i1) HEAPF32[i27 >> 2] = Math_fround(1.0);
  f36 = Math_fround(__ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i28, i25, i24, i23, i26));
  STACKTOP = i29;
  return Math_fround(f36);
 }
 if (i1) HEAPF32[i27 >> 2] = f2;
 if (!i26) {
  f36 = f3;
  STACKTOP = i29;
  return Math_fround(f36);
 }
 HEAP32[i26 >> 2] = i5;
 HEAP32[i26 + 4 >> 2] = i4;
 HEAP32[i26 + 8 >> 2] = i6;
 f36 = f3;
 STACKTOP = i29;
 return Math_fround(f36);
}

function __ZN5Umbra12PortalCullerC2EPNS_12QueryContextEPNS_11TransformerEfPKNS_23ImpObjectDistanceParamsEii(i14, i7, i1, f3, i10, i6, i5) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i10 = i10 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, f8 = f0, f9 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 HEAP32[i14 >> 2] = i7;
 i18 = i14 + 4 | 0;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 292 >> 2] = 0;
 i13 = i14 + 296 | 0;
 HEAPF32[i13 >> 2] = f3;
 i12 = i14 + 328 | 0;
 i19 = i14 + 344 | 0;
 i20 = i14 + 348 | 0;
 i1 = i14 + 352 | 0;
 i2 = i14 + 312 | 0;
 i4 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = i7;
 HEAP32[i14 + 356 >> 2] = 0;
 HEAPF32[i14 + 360 >> 2] = Math_fround(1.0);
 HEAP32[i14 + 372 >> 2] = 0;
 HEAP32[i14 + 376 >> 2] = -1;
 HEAP32[i14 + 384 >> 2] = 0;
 HEAP32[i14 + 388 >> 2] = -1;
 HEAP32[i14 + 368 >> 2] = 0;
 HEAP32[i14 + 392 >> 2] = i7;
 HEAP32[i14 + 396 >> 2] = 0;
 HEAPF32[i14 + 400 >> 2] = Math_fround(1.0);
 HEAP32[i14 + 412 >> 2] = 0;
 HEAP32[i14 + 416 >> 2] = -1;
 HEAP32[i14 + 424 >> 2] = 0;
 HEAP32[i14 + 428 >> 2] = -1;
 HEAP32[i14 + 408 >> 2] = 0;
 __ZN5Umbra16TileTraverseTreeC2EPNS_12QueryContextEi(i14 + 432 | 0, i7, i5);
 HEAP32[i14 + 2296 >> 2] = i6;
 i16 = i14 + 2308 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 0;
 _memset(i14 + 2352 | 0, 0, 336) | 0;
 HEAP32[i14 + 2692 >> 2] = -1;
 HEAP32[i14 + 2696 >> 2] = 0;
 HEAP32[i14 + 2700 >> 2] = 0;
 HEAP32[i14 + 2704 >> 2] = 0;
 HEAP32[i14 + 2720 >> 2] = 0;
 HEAP32[i14 + 2724 >> 2] = 0;
 i16 = i7 + 4 | 0;
 HEAP32[i14 + 2824 >> 2] = i16;
 i2 = i7 + 44 | 0;
 HEAP32[i14 + 2836 >> 2] = i2;
 i1 = i7 + 48 | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 + 2840 >> 2] = i15;
 HEAP32[i14 + 2844 >> 2] = 36;
 HEAP32[i14 + 2860 >> 2] = i16;
 HEAP32[i14 + 2872 >> 2] = i2;
 HEAP32[i1 >> 2] = i15 + 2;
 HEAP32[i14 + 2876 >> 2] = i15 + 1;
 HEAP32[i14 + 2880 >> 2] = 8;
 i15 = i14 + 2900 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 HEAPF32[i14 + 7036 >> 2] = Math_fround(0.0);
 i15 = i7 + 16 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + ((i6 << 4) + 31 & -16) | 0;
 i16 = i7 + 12 | 0;
 if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) i1 = 0; else {
  HEAP32[i15 >> 2] = i2;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = i6;
   i1 = i1 + 16 | 0;
   if ((i6 | 0) > 0) {
    i2 = 0;
    do {
     i5 = i1 + (i2 << 4) + 8 | 0;
     HEAP8[i5 >> 0] = 0;
     HEAP8[i5 + 1 >> 0] = 0;
     HEAP8[i5 + 2 >> 0] = 0;
     HEAP8[i5 + 3 >> 0] = 0;
     HEAP32[i1 + (i2 << 4) + 12 >> 2] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i6 | 0));
   }
  }
 }
 HEAP32[i14 + 2300 >> 2] = i1;
 i4 = i14 + 2688 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 128 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 132 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 136 >> 2]);
 i1 = f3 >= Math_fround(0.0) & 1;
 HEAP32[i14 + 300 >> 2] = i1;
 if (f3 != f3 | Math_fround(0.0) != Math_fround(0.0) | f3 == Math_fround(0.0)) f3 = Math_fround(0.0); else {
  f3 = Math_fround(Math_abs(Math_fround(f3)));
  HEAP32[i4 >> 2] = i1;
 }
 i1 = f8 >= Math_fround(0.0) & 1;
 HEAP32[i14 + 304 >> 2] = i1;
 f8 = Math_fround(Math_abs(Math_fround(f8)));
 if (f8 > f3) {
  HEAP32[i4 >> 2] = i1 | 2;
  f3 = f8;
 }
 i1 = f9 >= Math_fround(0.0) & 1;
 HEAP32[i14 + 308 >> 2] = i1;
 if (Math_fround(Math_abs(Math_fround(f9))) > f3) HEAP32[i4 >> 2] = i1 | 4;
 i6 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i1 = HEAP32[i6 + 68 >> 2] | 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = (i1 | 0) == 0 ? 0 : i6 + i1 | 0;
 i1 = HEAP32[i6 + 72 >> 2] | 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = (i1 | 0) == 0 ? 0 : i6 + i1 | 0;
 HEAP32[i14 + 284 >> 2] = 0;
 i1 = (i10 | 0) == 0;
 if (i1) f3 = Math_fround(1.0); else {
  f3 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  if (f3 <= Math_fround(0.0)) f3 = Math_fround(1.0);
 }
 f9 = Math_fround(f3 * f3);
 HEAPF32[i14 + 312 >> 2] = f9;
 HEAPF32[i14 + 316 >> 2] = f9;
 HEAPF32[i14 + 320 >> 2] = f9;
 HEAPF32[i14 + 324 >> 2] = f9;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 f9 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 i6 = f3 <= Math_fround(1.0);
 f9 = Math_fround(f9 / (i6 ? f3 : Math_fround(1.0)));
 HEAPF32[i17 >> 2] = f9;
 i6 = Math_fround(HEAPF32[i13 >> 2]) >= f9;
 HEAP32[i13 >> 2] = HEAP32[(i6 ? i13 : i17) >> 2];
 if (i1) {
  HEAPF32[i14 + 7044 >> 2] = Math_fround(0.0);
  i11 = 13;
 } else {
  HEAP32[i14 + 7044 >> 2] = HEAP32[i10 + 20 >> 2];
  if (!(HEAP8[i10 + 16 >> 0] | 0)) i11 = 13; else {
   i6 = i10;
   i1 = i10 + 8 | 0;
   i4 = i10 + 4 | 0;
  }
 }
 if ((i11 | 0) == 13) {
  i6 = i2 + 1184 | 0;
  i1 = i2 + 1192 | 0;
  i4 = i2 + 1188 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (HEAP32[i7 + 72 >> 2] | 0) {
  f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f9 == Math_fround(HEAPF32[i2 + 1184 >> 2])) {
   f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f9 == Math_fround(HEAPF32[i2 + 1188 >> 2])) {
    f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (!(f9 != Math_fround(HEAPF32[i2 + 1192 >> 2]))) break;
   }
  }
  HEAPF32[i13 >> 2] = Math_fround(-1.0);
 } while (0);
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 + 332 >> 2] = i4;
 HEAP32[i14 + 336 >> 2] = i5;
 HEAPF32[i14 + 340 >> 2] = Math_fround(1.0);
 f25 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 92 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f28 = Math_fround(HEAPF32[i2 + 100 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + 108 >> 2]);
 i1 = i17 + 4 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 f29 = Math_fround(Math_fround(f23 * f8) - Math_fround(f9 * f27));
 f26 = Math_fround(Math_fround(f9 * f28) - Math_fround(f3 * f8));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f3 * f27) - Math_fround(f23 * f28));
 HEAPF32[i17 + 4 >> 2] = f29;
 HEAPF32[i17 + 8 >> 2] = f26;
 f26 = Math_fround(Math_fround(f25 * f27) - Math_fround(f22 * f8));
 f8 = Math_fround(Math_fround(f24 * f8) - Math_fround(f25 * f28));
 HEAPF32[i17 + 12 >> 2] = Math_fround(Math_fround(f22 * f28) - Math_fround(f24 * f27));
 HEAPF32[i17 + 16 >> 2] = f26;
 HEAPF32[i17 + 20 >> 2] = f8;
 f8 = Math_fround(Math_fround(f22 * f9) - Math_fround(f25 * f23));
 f9 = Math_fround(Math_fround(f25 * f3) - Math_fround(f24 * f9));
 HEAPF32[i17 + 24 >> 2] = Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f3));
 HEAPF32[i17 + 28 >> 2] = f8;
 HEAPF32[i17 + 32 >> 2] = f9;
 i1 = 0;
 do {
  i10 = 1 << i1 & 3;
  i11 = 1 << i10 & 3;
  i7 = i1 << 1;
  i12 = i7 | 1;
  i6 = (HEAP8[i2 + 1204 >> 0] | 0) != 0;
  i13 = i6 ? i12 : i7;
  i12 = i6 ? i7 : i12;
  f3 = Math_fround(HEAPF32[i17 + (i10 * 12 | 0) >> 2]);
  f8 = Math_fround(HEAPF32[i17 + (i11 * 12 | 0) >> 2]);
  f30 = Math_fround(-f8);
  f9 = Math_fround(-f3);
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) >> 2] = f3;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 4 >> 2] = f30;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 8 >> 2] = f9;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 12 >> 2] = f8;
  f23 = Math_fround(HEAPF32[i17 + (i10 * 12 | 0) + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i17 + (i11 * 12 | 0) + 4 >> 2]);
  f22 = Math_fround(-f24);
  f25 = Math_fround(-f23);
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 16 >> 2] = f23;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 20 >> 2] = f22;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 24 >> 2] = f25;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 28 >> 2] = f24;
  f27 = Math_fround(HEAPF32[i17 + (i10 * 12 | 0) + 8 >> 2]);
  f28 = Math_fround(HEAPF32[i17 + (i11 * 12 | 0) + 8 >> 2]);
  f26 = Math_fround(-f28);
  f29 = Math_fround(-f27);
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 32 >> 2] = f27;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 36 >> 2] = f26;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 40 >> 2] = f29;
  HEAPF32[i14 + 2368 + (i12 * 48 | 0) + 44 >> 2] = f28;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) >> 2] = f30;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 4 >> 2] = f3;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 8 >> 2] = f8;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 12 >> 2] = f9;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 16 >> 2] = f22;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 20 >> 2] = f23;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 24 >> 2] = f24;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 28 >> 2] = f25;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 32 >> 2] = f26;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 36 >> 2] = f27;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 40 >> 2] = f28;
  HEAPF32[i14 + 2368 + (i13 * 48 | 0) + 44 >> 2] = f29;
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i18 >> 2] | 0;
 } while ((i1 | 0) != 3);
 i6 = (HEAP32[i2 + 1376 >> 2] | 0) >>> 3;
 i7 = HEAP32[i2 + 1380 >> 2] | 0;
 i4 = HEAP32[i2 + 1384 >> 2] | 0;
 i5 = ((HEAP32[i2 + 1388 >> 2] | 0) + 3 | 0) >>> 2;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = i2 + 512 | 0;
 if (i1 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) i2 = 0; else HEAP32[i15 >> 2] = i1;
 i1 = (i4 << 13) + 57344 | 0;
 HEAP32[i19 >> 2] = i7 << 6 & 65280 | i6 & 255 | i1 & 16711680 | i5 << 24;
 HEAP32[i20 >> 2] = i2;
 if (!i2) {
  STACKTOP = i21;
  return;
 }
 _memset(i2 | 0, -1, Math_imul((i1 >>> 16 & 255) - (i6 & 255) << 2, (i5 & 255) - (i7 >>> 2 & 255) | 0) | 0) | 0;
 STACKTOP = i21;
 return;
}

function __ZN2UI13CanvasManager34EmitWorldScreenspaceCameraGeometryENS0_10CameraTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22 + 8 | 0;
 i19 = i22;
 i20 = i22 + 16 | 0;
 i3 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i18 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i18, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i3, i18, Math_fround(4.0), 0);
 i3 = __Z16GetRenderManagerv() | 0;
 i4 = __Z16GetRenderManagerv() | 0;
 HEAP16[i20 >> 1] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i16 = i1 + 4 | 0;
 if ((i5 | 0) == (HEAP32[i16 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 i17 = (i2 & 2 | 0) == 0;
 i14 = (i2 & 1 | 0) == 0;
 i15 = i3 + 8 | 0;
 i12 = i3 + 4 | 0;
 i13 = i4 + 20 | 0;
 i11 = i4 + 16 | 0;
 do {
  i10 = HEAP32[i5 >> 2] | 0;
  i3 = __ZNK2UI6Canvas13GetRenderModeEv(i10) | 0;
  i1 = i10;
  while (1) {
   i2 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i9 = HEAP32[i1 + 40 >> 2] | 0;
  i8 = (i3 | 0) == 1;
  L9 : do if ((i3 + -1 | 0) >>> 0 < 2) {
   L11 : do if (!i17) {
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) != (i11 | 0)) {
     i7 = (i9 | 0) == 0;
     if (i8) i6 = i2; else {
      i6 = i2;
      while (1) {
       i4 = i1 + 8 | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       if (!i1) i1 = 0; else {
        HEAP32[i19 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        if (!i1) i21 = 39; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
          i2 = HEAP32[i18 >> 2] | 0;
          i7 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 39; else {
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i21 = 41;
         }
        }
        if ((i21 | 0) == 39) i21 = 41;
        if ((i21 | 0) == 41) {
         i21 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
        }
       }
       __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i10, i1, i20, 0);
       i1 = HEAP32[i6 + 4 >> 2] | 0;
       i6 = i1;
       if ((i6 | 0) == (i11 | 0)) break L11;
      }
     }
     do {
      i4 = i1 + 8 | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = 0; else {
       HEAP32[i19 >> 2] = i1;
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i1) i21 = 17; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
         i2 = HEAP32[i18 >> 2] | 0;
         i23 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 17; else {
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i21 = 18;
        }
       }
       if ((i21 | 0) == 17) i21 = 18;
       if ((i21 | 0) == 18) {
        i21 = 0;
        i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
       }
      }
      if (i7) i2 = 0; else {
       HEAP32[i19 >> 2] = i9;
       i2 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i2) i21 = 27; else {
        if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
         i3 = HEAP32[i2 + 28 >> 2] | 0;
         i4 = HEAP32[i2 + 32 >> 2] | 0;
         i2 = i3 + (i4 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i2, i19);
         i3 = HEAP32[i18 >> 2] | 0;
         i23 = HEAP32[i2 + 28 >> 2] | 0;
         i4 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i3 | 0) == -1 ? i23 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
         i3 = HEAP32[i4 + 28 >> 2] | 0;
         i4 = HEAP32[i4 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i21 = 27; else {
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i21 = 28;
        }
       }
       if ((i21 | 0) == 27) i21 = 28;
       if ((i21 | 0) == 28) {
        i21 = 0;
        i2 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
       }
      }
      if ((i1 | 0) == (i2 | 0)) __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i10, i1, i20, 0);
      i1 = HEAP32[i6 + 4 >> 2] | 0;
      i6 = i1;
     } while ((i6 | 0) != (i11 | 0));
    }
   } while (0);
   if (!i14) {
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) != (i12 | 0)) {
     i7 = (i9 | 0) == 0;
     if (i8) i6 = i2; else {
      i6 = i2;
      while (1) {
       i4 = i1 + 8 | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       if (!i1) i1 = 0; else {
        HEAP32[i19 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        if (!i1) i21 = 76; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
          i2 = HEAP32[i18 >> 2] | 0;
          i23 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 76; else {
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i21 = 78;
         }
        }
        if ((i21 | 0) == 76) i21 = 78;
        if ((i21 | 0) == 78) {
         i21 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
        }
       }
       __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i10, i1, i20, 0);
       i1 = HEAP32[i6 + 4 >> 2] | 0;
       i6 = i1;
       if ((i6 | 0) == (i12 | 0)) break L9;
      }
     }
     do {
      i4 = i1 + 8 | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = 0; else {
       HEAP32[i19 >> 2] = i1;
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i1) i21 = 54; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
         i2 = HEAP32[i18 >> 2] | 0;
         i23 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 54; else {
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i21 = 55;
        }
       }
       if ((i21 | 0) == 54) i21 = 55;
       if ((i21 | 0) == 55) {
        i21 = 0;
        i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
       }
      }
      if (i7) i2 = 0; else {
       HEAP32[i19 >> 2] = i9;
       i2 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i2) i21 = 64; else {
        if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
         i3 = HEAP32[i2 + 28 >> 2] | 0;
         i4 = HEAP32[i2 + 32 >> 2] | 0;
         i2 = i3 + (i4 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i2, i19);
         i3 = HEAP32[i18 >> 2] | 0;
         i23 = HEAP32[i2 + 28 >> 2] | 0;
         i4 = HEAP32[gb + 1104264 >> 2] | 0;
         i2 = (i3 | 0) == -1 ? i23 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
         i3 = HEAP32[i4 + 28 >> 2] | 0;
         i4 = HEAP32[i4 + 32 >> 2] | 0;
        }
        if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i21 = 64; else {
         i2 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i2) i21 = 65;
        }
       }
       if ((i21 | 0) == 64) i21 = 65;
       if ((i21 | 0) == 65) {
        i21 = 0;
        i2 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
       }
      }
      if ((i1 | 0) == (i2 | 0)) __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i10, i1, i20, 0);
      i1 = HEAP32[i6 + 4 >> 2] | 0;
      i6 = i1;
     } while ((i6 | 0) != (i12 | 0));
    }
   }
  } while (0);
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) != (HEAP32[i16 >> 2] | 0));
 STACKTOP = i22;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i24, i25, i35, i1, i2, i50, i51, i52) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i55 + 64 | 0;
 i54 = i55 + 48 | 0;
 i26 = i55 + 32 | 0;
 i27 = i55 + 16 | 0;
 i28 = i55;
 if (i2 >>> 0 >= i50 >>> 0) {
  STACKTOP = i55;
  return;
 }
 i29 = i1 + 500 | 0;
 i30 = i54 + 4 | 0;
 i31 = i54 + 8 | 0;
 i32 = i54 + 12 | 0;
 i33 = i1 + 520 | 0;
 i34 = i54 + 4 | 0;
 i36 = i54 + 8 | 0;
 i37 = i54 + 12 | 0;
 i38 = i53 + 16 | 0;
 i39 = i53 + 32 | 0;
 i22 = i26 + 4 | 0;
 i23 = i26 + 8 | 0;
 i15 = i26 + 12 | 0;
 i16 = i27 + 4 | 0;
 i17 = i27 + 8 | 0;
 i18 = i27 + 12 | 0;
 i19 = i28 + 4 | 0;
 i20 = i28 + 8 | 0;
 i21 = i28 + 12 | 0;
 i40 = i52 + 12 | 0;
 i41 = i52 + 24 | 0;
 i42 = i52 + 4 | 0;
 i43 = i52 + 16 | 0;
 i44 = i52 + 28 | 0;
 i45 = i52 + 8 | 0;
 i46 = i52 + 20 | 0;
 i47 = i52 + 32 | 0;
 i48 = i1 + 120 | 0;
 i49 = i1 + 140 | 0;
 i14 = i1 + 160 | 0;
 do {
  i4 = (HEAP32[i29 >> 2] | 0) + (i2 << 2) | 0;
  i3 = (HEAP32[i4 + 4 >> 2] | 0) + -520366028 | 0;
  i5 = (HEAP32[i4 + 8 >> 2] | 0) + -520366028 | 0;
  i1 = (HEAP32[i4 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i54 >> 2] = (HEAP32[i4 >> 2] | 0) + -520366028;
  HEAP32[i30 >> 2] = i3;
  HEAP32[i31 >> 2] = i5;
  HEAP32[i32 >> 2] = i1;
  __Z17GenerateRandomNx3RKN4math5_int4E(i53, i54);
  i1 = (HEAP32[i33 >> 2] | 0) + (i2 << 2) | 0;
  f59 = Math_fround(HEAPF32[i1 >> 2]);
  f58 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f57 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f58 = Math_fround(f58 * Math_fround(.00999999977));
  f57 = Math_fround(f57 * Math_fround(.00999999977));
  f56 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i54 >> 2] = Math_fround(f59 * Math_fround(.00999999977));
  HEAPF32[i34 >> 2] = f58;
  HEAPF32[i36 >> 2] = f57;
  HEAPF32[i37 >> 2] = f56;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i26, i24, i54, i53);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i27, i25, i54, i38);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i28, i35, i54, i39);
  i1 = HEAP32[i26 >> 2] | 0;
  i5 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i10 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i28 >> 2] | 0;
  i11 = HEAP32[i19 >> 2] | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  if (i51) {
   f65 = Math_fround(HEAPF32[i52 >> 2]);
   f68 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f68 * f65);
   f67 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f67 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = Math_fround(f66 * f65);
   f61 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f61 * f65);
   f72 = Math_fround(HEAPF32[i40 >> 2]);
   f64 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f64 * f72);
   f63 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = Math_fround(f63 * f72);
   f62 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f62 * f72);
   f59 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f57 + f75);
   f74 = Math_fround(f69 + f74);
   f73 = Math_fround(f56 + f73);
   f72 = Math_fround(f65 + Math_fround(f59 * f72));
   f65 = Math_fround(HEAPF32[i41 >> 2]);
   f56 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f56 * f65);
   f57 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f70 = Math_fround(f57 * f65);
   f58 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f71 = Math_fround(f58 * f65);
   f60 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f75 + f69);
   f70 = Math_fround(f74 + f70);
   f71 = Math_fround(f73 + f71);
   f65 = Math_fround(f72 + Math_fround(f60 * f65));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   f65 = Math_fround(HEAPF32[i42 >> 2]);
   f71 = Math_fround(f68 * f65);
   f70 = Math_fround(f67 * f65);
   f69 = Math_fround(f66 * f65);
   f65 = Math_fround(f61 * f65);
   f72 = Math_fround(HEAPF32[i43 >> 2]);
   f71 = Math_fround(f71 + Math_fround(f64 * f72));
   f70 = Math_fround(f70 + Math_fround(f63 * f72));
   f69 = Math_fround(f69 + Math_fround(f62 * f72));
   f72 = Math_fround(f65 + Math_fround(f59 * f72));
   f65 = Math_fround(HEAPF32[i44 >> 2]);
   f71 = Math_fround(f71 + Math_fround(f56 * f65));
   f70 = Math_fround(f70 + Math_fround(f57 * f65));
   f69 = Math_fround(f69 + Math_fround(f58 * f65));
   f65 = Math_fround(f72 + Math_fround(f60 * f65));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   f65 = Math_fround(HEAPF32[i45 >> 2]);
   f68 = Math_fround(f68 * f65);
   f67 = Math_fround(f67 * f65);
   f66 = Math_fround(f66 * f65);
   f65 = Math_fround(f61 * f65);
   f61 = Math_fround(HEAPF32[i46 >> 2]);
   f64 = Math_fround(f68 + Math_fround(f64 * f61));
   f63 = Math_fround(f67 + Math_fround(f63 * f61));
   f62 = Math_fround(f66 + Math_fround(f62 * f61));
   f61 = Math_fround(f65 + Math_fround(f59 * f61));
   f59 = Math_fround(HEAPF32[i47 >> 2]);
   f56 = Math_fround(f64 + Math_fround(f56 * f59));
   f57 = Math_fround(f63 + Math_fround(f57 * f59));
   f58 = Math_fround(f62 + Math_fround(f58 * f59));
   f59 = Math_fround(f61 + Math_fround(f60 * f59));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i87 = (HEAP32[i48 >> 2] | 0) + (i2 << 2) | 0;
  f64 = Math_fround(HEAPF32[i87 >> 2]);
  i86 = i87 + 4 | 0;
  f65 = Math_fround(HEAPF32[i86 >> 2]);
  i85 = i87 + 8 | 0;
  f66 = Math_fround(HEAPF32[i85 >> 2]);
  i84 = i87 + 12 | 0;
  f67 = Math_fround(HEAPF32[i84 >> 2]);
  i83 = (HEAP32[i49 >> 2] | 0) + (i2 << 2) | 0;
  f68 = Math_fround(HEAPF32[i83 >> 2]);
  i82 = i83 + 4 | 0;
  f69 = Math_fround(HEAPF32[i82 >> 2]);
  i81 = i83 + 8 | 0;
  f70 = Math_fround(HEAPF32[i81 >> 2]);
  i80 = i83 + 12 | 0;
  f71 = Math_fround(HEAPF32[i80 >> 2]);
  i79 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f72 = Math_fround(HEAPF32[i79 >> 2]);
  i78 = i79 + 4 | 0;
  f73 = Math_fround(HEAPF32[i78 >> 2]);
  i77 = i79 + 8 | 0;
  f74 = Math_fround(HEAPF32[i77 >> 2]);
  i76 = i79 + 12 | 0;
  f75 = Math_fround(HEAPF32[i76 >> 2]);
  f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f64);
  f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f65);
  f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f66);
  f67 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f67);
  f68 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f68);
  f69 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f69);
  f70 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f70);
  f71 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f71);
  f72 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f72);
  f73 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f73);
  f74 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f74);
  f75 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f75);
  HEAPF32[i87 >> 2] = f64;
  HEAPF32[i86 >> 2] = f65;
  HEAPF32[i85 >> 2] = f66;
  HEAPF32[i84 >> 2] = f67;
  HEAPF32[i83 >> 2] = f68;
  HEAPF32[i82 >> 2] = f69;
  HEAPF32[i81 >> 2] = f70;
  HEAPF32[i80 >> 2] = f71;
  HEAPF32[i79 >> 2] = f72;
  HEAPF32[i78 >> 2] = f73;
  HEAPF32[i77 >> 2] = f74;
  HEAPF32[i76 >> 2] = f75;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i50 >>> 0);
 STACKTOP = i55;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij(i15, i17, i14, i8, i4, i16) {
 i15 = i15 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18;
 i12 = i18 + 104 | 0;
 i7 = i18 + 24 | 0;
 if (!(HEAP32[i17 >> 2] | 0)) {
  HEAP32[i15 + 464 >> 2] = 1;
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 switch (i4 | 0) {
 case 0:
  {
   i4 = HEAP32[i14 >> 2] | 0;
   i6 = HEAP32[i14 + 4 >> 2] | 0;
   i7 = HEAP32[i14 + 8 >> 2] | 0;
   i8 = HEAP32[i14 + 12 >> 2] | 0;
   i5 = HEAP32[i14 + 16 >> 2] | 0;
   i1 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i15 + 172 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (__ZN5Umbra5ArrayINS_20RuntimeTomeGenerator9EmptyTileEE6updateEibbb(i15 + 160 | 0, i3 + 1 | 0, 1, 0, 0) | 0) {
    i14 = HEAP32[i15 + 164 >> 2] | 0;
    HEAP32[i14 + (i3 * 40 | 0) >> 2] = i4;
    HEAP32[i14 + (i3 * 40 | 0) + 4 >> 2] = i6;
    HEAP32[i14 + (i3 * 40 | 0) + 8 >> 2] = i7;
    HEAP32[i14 + (i3 * 40 | 0) + 12 >> 2] = i8;
    HEAP32[i14 + (i3 * 40 | 0) + 16 >> 2] = i5;
    HEAP32[i14 + (i3 * 40 | 0) + 20 >> 2] = i1;
    i14 = i14 + (i3 * 40 | 0) + 24 | 0;
    HEAP32[i14 >> 2] = -1;
    HEAP32[i14 + 4 >> 2] = i16;
    HEAP32[i14 + 8 >> 2] = 0;
    HEAP32[i14 + 12 >> 2] = 0;
   }
   i3 = (HEAP32[i15 + 76 >> 2] | 0) + -1 + (HEAP32[i2 >> 2] | 0) | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i17 + 8 | 0;
   i5 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i5 + (HEAP32[i2 >> 2] << 3) >> 2] = i3 << 2 | 2;
   i16 = i1 + 36 | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   HEAP32[i16 >> 2] = (i2 | 0) >= (i15 | 0) ? i2 : i15;
   HEAP32[i5 + (i2 << 3) + 4 >> 2] = i3;
   i5 = i17 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if (!i3) {
    i17 = 1;
    STACKTOP = i18;
    return i17 | 0;
   }
   if ((i2 | 0) != ((HEAP32[i3 + 8 >> 2] | 0) + 1 | 0)) {
    i17 = 1;
    STACKTOP = i18;
    return i17 | 0;
   }
   i4 = __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(i1, i2) | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   i1 = (HEAP32[i3 + 8 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] << 3) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   switch (i2 & 3) {
   case 1:
    {
     HEAP32[i1 >> 2] = i2 & 15 | i4 << 4;
     i17 = 1;
     STACKTOP = i18;
     return i17 | 0;
    }
   case 0:
    {
     i17 = (HEAP32[i3 + 24 >> 2] | 0) + (i2 >>> 2 << 3) | 0;
     HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & 3 | i4 << 2;
     i17 = 1;
     STACKTOP = i18;
     return i17 | 0;
    }
   default:
    {
     i17 = 1;
     STACKTOP = i18;
     return i17 | 0;
    }
   }
  }
 case 1:
  {
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[(HEAP32[i15 + 56 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   i5 = i4 + 20 | 0;
   i6 = i4 + 32 | 0;
   i1 = i12 + 12 | 0;
   HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i2 = i14 + 12 | 0;
   f20 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - Math_fround(HEAPF32[i14 >> 2]));
   f19 = Math_fround(Math_fround(HEAPF32[i14 + 16 >> 2]) - Math_fround(HEAPF32[i14 + 4 >> 2]));
   f11 = Math_fround(Math_fround(HEAPF32[i14 + 20 >> 2]) - Math_fround(HEAPF32[i14 + 8 >> 2]));
   f9 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) - Math_fround(HEAPF32[i12 >> 2]));
   f10 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) - Math_fround(HEAPF32[i12 + 4 >> 2]));
   f9 = Math_fround(f20 - f9);
   f10 = Math_fround(f19 - f10);
   f11 = Math_fround(f11 - Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) - Math_fround(HEAPF32[i12 + 8 >> 2])));
   if (Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11)) > Math_fround(0.0)) {
    i13 = !(f9 >= f10) ? (f10 >= f11 ? 1 : 2) : f9 >= f11 ? 0 : 2;
    f20 = Math_fround(HEAPF32[i2 + (i13 << 2) >> 2]);
    i1 = i1 + (i13 << 2) | 0;
    i7 = f20 > Math_fround(HEAPF32[i1 >> 2]);
    i1 = __ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj(i15, i8, 1, i17, i14, i13, Math_fround(HEAPF32[(i7 ? i1 : i12 + (i13 << 2) | 0) >> 2]), 0, i16) | 0;
   } else {
    i1 = HEAP32[i15 + 76 >> 2] | 0;
    if ((i3 | 0) < (i1 | 0)) {
     i24 = HEAP32[i4 + 48 >> 2] | 0;
     i21 = HEAP32[i4 + 56 >> 2] | 0;
     i22 = HEAP32[i4 + 60 >> 2] | 0;
     i23 = (HEAP32[i4 + 44 >> 2] | 0) >>> 5;
     i24 = (i24 | 0) == 0 ? 0 : i4 + i24 | 0;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i13 + 4 >> 2] = 0;
     HEAP32[i13 + 8 >> 2] = 0;
     HEAP32[i13 + 12 >> 2] = 0;
     HEAP32[i13 + 16 >> 2] = 0;
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = HEAP32[i4 + 24 >> 2] | 0;
     i5 = HEAP32[i4 + 28 >> 2] | 0;
     i6 = HEAP32[i6 >> 2] | 0;
     i8 = HEAP32[i4 + 36 >> 2] | 0;
     i12 = HEAP32[i4 + 40 >> 2] | 0;
     HEAP32[i7 >> 2] = i23;
     HEAP32[i7 + 4 >> 2] = i24;
     HEAP32[i7 + 8 >> 2] = i24 + (((i23 << 1) + 31 | 0) >>> 5 << 2);
     HEAP32[i7 + 12 >> 2] = ((i22 | 0) == 0 ? 0 : i4 + i22 | 0) + -4;
     HEAP32[i7 + 16 >> 2] = 4;
     HEAP32[i7 + 20 >> 2] = 4;
     HEAP32[i7 + 24 >> 2] = i21;
     i4 = i7 + 28 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
     HEAP32[i7 + 52 >> 2] = 0;
     HEAP32[i7 + 56 >> 2] = i1;
     HEAP32[i7 + 60 >> 2] = i2;
     HEAP32[i7 + 64 >> 2] = i5;
     HEAP32[i7 + 68 >> 2] = i6;
     HEAP32[i7 + 72 >> 2] = i8;
     HEAP32[i7 + 76 >> 2] = i12;
    } else {
     HEAPF32[i7 + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
     i6 = i7 + 60 | 0;
     HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
     i12 = i7 + 64 | 0;
     HEAPF32[i12 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i7 + 68 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     i22 = i7 + 72 | 0;
     HEAPF32[i22 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     i24 = i7 + 76 | 0;
     HEAPF32[i24 >> 2] = Math_fround(-3402823469999999843913219.0e14);
     i4 = i15 + 200 | 0;
     HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
     HEAP32[i7 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
     HEAP32[i7 + 28 >> 2] = gb + 1451424 + -4;
     HEAP32[i7 + 32 >> 2] = 4;
     HEAP32[i7 + 36 >> 2] = 4;
     HEAP32[i7 + 40 >> 2] = -1;
     HEAP32[i7 + 44 >> 2] = 0;
     HEAP32[i7 + 48 >> 2] = -1;
     HEAP32[i7 + 52 >> 2] = 1;
     i4 = i3 - i1 | 0;
     i2 = HEAP32[i15 + 164 >> 2] | 0;
     i23 = HEAP32[i2 + (i4 * 40 | 0) + 20 >> 2] | 0;
     i21 = HEAP32[i2 + (i4 * 40 | 0) + 16 >> 2] | 0;
     i13 = HEAP32[i2 + (i4 * 40 | 0) + 12 >> 2] | 0;
     i8 = HEAP32[i2 + (i4 * 40 | 0) + 8 >> 2] | 0;
     i5 = HEAP32[i2 + (i4 * 40 | 0) + 4 >> 2] | 0;
     HEAP32[i7 + 56 >> 2] = HEAP32[i2 + (i4 * 40 | 0) >> 2];
     HEAP32[i6 >> 2] = i5;
     HEAP32[i12 >> 2] = i8;
     HEAP32[i7 + 68 >> 2] = i13;
     HEAP32[i22 >> 2] = i21;
     HEAP32[i24 >> 2] = i23;
    }
    i1 = __ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj(i15, i17, i3, i7, 0, i14, -1, 63, i16) | 0;
   }
   i24 = i1;
   STACKTOP = i18;
   return i24 | 0;
  }
 default:
  {
   i1 = i14 + 12 | 0;
   f20 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - Math_fround(HEAPF32[i14 >> 2]));
   i2 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) - Math_fround(HEAPF32[i14 + 4 >> 2])) >= f20 & 1;
   f20 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - Math_fround(HEAPF32[i14 + 8 >> 2]));
   i1 = !(f20 >= Math_fround(Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]) - Math_fround(HEAPF32[i14 + (i2 << 2) >> 2])));
   i2 = i1 ? i2 : 2;
   i1 = (i2 >>> 0) % 3 | 0;
   HEAP8[i13 >> 0] = 1;
   HEAPF32[i12 >> 2] = Math_fround(0.0);
   if (__ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb(i15, i8, i4, i14, i1, i12, i13) | 0) {
    f20 = Math_fround(HEAPF32[i12 >> 2]);
    if (!(__ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj(i15, i8, i4, i17, i14, i1, f20, (HEAP8[i13 >> 0] | 0) != 0, i16) | 0)) i3 = 21;
   } else i3 = 21;
   do if ((i3 | 0) == 21) {
    i1 = ((i2 + 1 | 0) >>> 0) % 3 | 0;
    HEAP8[i13 >> 0] = 1;
    HEAPF32[i12 >> 2] = Math_fround(0.0);
    if (__ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb(i15, i8, i4, i14, i1, i12, i13) | 0) {
     f20 = Math_fround(HEAPF32[i12 >> 2]);
     if (__ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj(i15, i8, i4, i17, i14, i1, f20, (HEAP8[i13 >> 0] | 0) != 0, i16) | 0) break;
    }
    i1 = ((i2 + 2 | 0) >>> 0) % 3 | 0;
    HEAP8[i13 >> 0] = 1;
    HEAPF32[i12 >> 2] = Math_fround(0.0);
    if (__ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb(i15, i8, i4, i14, i1, i12, i13) | 0) {
     f20 = Math_fround(HEAPF32[i12 >> 2]);
     if (__ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj(i15, i8, i4, i17, i14, i1, f20, (HEAP8[i13 >> 0] | 0) != 0, i16) | 0) break;
    }
    i24 = 0;
    STACKTOP = i18;
    return i24 | 0;
   } while (0);
   i24 = 1;
   STACKTOP = i18;
   return i24 | 0;
  }
 }
 return 0;
}

function __Z27OptimizeReorderVertexBufferR4Mesh(i29) {
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i38;
 i33 = i38 + 80 | 0;
 i35 = i38 + 60 | 0;
 i36 = i38 + 40 | 0;
 i37 = i38 + 24 | 0;
 i19 = i38 + 8 | 0;
 i30 = i29 + 32 | 0;
 i22 = HEAP32[i30 >> 2] | 0;
 i13 = (HEAP32[i22 + 132 >> 2] | 0) - (HEAP32[i22 + 128 >> 2] | 0) | 0;
 i18 = (i13 | 0) / 52 | 0;
 i12 = HEAP32[i22 + 100 >> 2] | 0;
 i23 = i22 + 164 | 0;
 HEAP32[i33 >> 2] = 0;
 i20 = i33 + 12 | 0;
 HEAP32[i20 >> 2] = 0;
 i32 = i33 + 16 | 0;
 HEAP32[i32 >> 2] = 0;
 i34 = i33 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, gb + 63664 | 0);
 i11 = i31;
 i6 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i21 = i34;
 HEAP32[i21 >> 2] = i6;
 HEAP32[i21 + 4 >> 2] = i11;
 i21 = i22 + 176 | 0;
 i2 = i11;
 if (HEAP32[i21 >> 2] | 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  if (!i1) {
   i3 = i23;
   i4 = i22 + 168 | 0;
   i5 = i33;
   i7 = 0;
   i8 = 0;
   i9 = 0;
   i10 = 0;
   i2 = i6;
   i1 = i11;
  } else {
   i4 = i22 + 168 | 0;
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i4, i2);
   i1 = i34;
   i3 = i23;
   i5 = i33;
   i7 = HEAP32[i23 >> 2] | 0;
   i8 = HEAP32[i33 >> 2] | 0;
   i9 = HEAP32[i20 >> 2] | 0;
   i10 = HEAP32[i32 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i7;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i21 >> 2] = i9;
  i26 = i22 + 180 | 0;
  HEAP32[i32 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i26 >> 2] = i10;
  i26 = i4;
  i27 = HEAP32[i26 + 4 >> 2] | 0;
  i28 = i34;
  HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i28 + 4 >> 2] = i27;
  i28 = i4;
  HEAP32[i28 >> 2] = i2;
  HEAP32[i28 + 4 >> 2] = i1;
 }
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 i25 = i35 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i35 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, gb + 63664 | 0);
 i16 = i31;
 i28 = HEAP32[i16 + 4 >> 2] | 0;
 i27 = i26;
 HEAP32[i27 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i27 + 4 >> 2] = i28;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i36 + 12 >> 2] = 0;
 i27 = i36 + 16 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i36 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, gb + 63664 | 0);
 i16 = i31;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i24 = i28;
 HEAP32[i24 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i24 + 4 >> 2] = i17;
 HEAP32[i31 >> 2] = -1;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i36, i12, i31, 1);
 HEAP32[i31 >> 2] = -1;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i35, i12, i31, 1);
 HEAP32[i37 >> 2] = 0;
 i24 = i37 + 4 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 L8 : do if ((i13 | 0) > 0) {
  i15 = i19 + 4 | 0;
  i16 = i19 + 8 | 0;
  i17 = i19 + 12 | 0;
  i12 = i19 + 12 | 0;
  i13 = i31 + 4 | 0;
  i14 = i29 + 4 | 0;
  i4 = 0;
  i11 = 0;
  while (1) {
   HEAP32[i19 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   i10 = HEAP32[i30 >> 2] | 0;
   switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i19, i11, i10 + 128 | 0, i10) | 0) {
   case 1:
    {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i14 >> 2] | 0, 0, 0);
     break;
    }
   case 4:
    {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i14 >> 2] | 0, 0, 0);
     break;
    }
   default:
    {}
   }
   i3 = (HEAP32[i15 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0;
   i10 = i3 >> 2;
   i5 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i37 >> 2] | 0;
   i1 = i5 - i2 >> 2;
   if (i10 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i37, i10 - i1 | 0); else if (i10 >>> 0 < i1 >>> 0) {
    i1 = i2 + (i10 << 2) | 0;
    if ((i5 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
   }
   if ((i3 | 0) > 0) {
    i7 = HEAP32[i19 >> 2] | 0;
    i8 = HEAP32[i35 >> 2] | 0;
    i9 = HEAP32[i36 >> 2] | 0;
    i1 = HEAP32[i37 >> 2] | 0;
    i6 = 0;
    do {
     i3 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
     i5 = i8 + (i3 << 2) | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) == -1) {
      HEAP32[i5 >> 2] = i4;
      HEAP32[i9 + (i4 << 2) >> 2] = i3;
      i4 = i4 + 1 | 0;
      i2 = HEAP32[i5 >> 2] | 0;
     }
     HEAP32[i1 + (i6 << 2) >> 2] = i2;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) < (i10 | 0));
   } else i1 = HEAP32[i37 >> 2] | 0;
   __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i29, i1, (HEAP32[i24 >> 2] | 0) - i1 >> 2, i11, 0, 4) | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i15 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i31 >> 2] = 1;
    HEAP32[i13 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i31);
   }
   i11 = i11 + 1 | 0;
   if ((i11 | 0) >= (i18 | 0)) break L8;
  }
 } else i4 = 0; while (0);
 __Z23RemapVertexDataChannelsPKjjR10VertexData(HEAP32[i36 >> 2] | 0, i4, (HEAP32[i30 >> 2] | 0) + 8 | 0);
 if (HEAP32[i20 >> 2] | 0) {
  HEAP32[i21 >> 2] = i4;
  i1 = i22 + 180 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i1 >> 2] = i4;
   HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i4 << 5, 16, i22 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 5, 16, i22 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i22 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i21 >> 2] << 5 | 0) | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i23 >> 2] = i22;
   break;
  } while (0);
  if ((i4 | 0) > 0) {
   i2 = HEAP32[i36 >> 2] | 0;
   i3 = HEAP32[i33 >> 2] | 0;
   i1 = 0;
   do {
    i22 = (HEAP32[i23 >> 2] | 0) + (i1 << 5) | 0;
    i21 = i3 + (HEAP32[i2 + (i1 << 2) >> 2] << 5) | 0;
    HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    HEAP32[i22 + 24 >> 2] = HEAP32[i21 + 24 >> 2];
    HEAP32[i22 + 28 >> 2] = HEAP32[i21 + 28 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 i12 = i29 + 72 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i29 + 84 | 0;
 i23 = HEAP32[i13 >> 2] | 0;
 i2 = i1 + (i23 * 40 | 0) | 0;
 if (i23 | 0) {
  i3 = HEAP32[i35 >> 2] | 0;
  do {
   i23 = i1 + 36 | 0;
   HEAP32[i23 >> 2] = HEAP32[i3 + (HEAP32[i23 >> 2] << 2) >> 2];
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i10 = i29 + 104 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i11 = i29 + 92 | 0;
  i9 = 0;
  do {
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i1 + (i9 * 12 | 0) + 4 >> 2] | 0;
   if (i2 | 0) {
    i4 = (HEAP32[i12 >> 2] | 0) + ((HEAP32[i1 + (i9 * 12 | 0) >> 2] | 0) * 40 | 0) | 0;
    HEAP32[i31 >> 2] = fb + 579;
    __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_(i4, i4 + (i2 * 40 | 0) | 0, i31);
    i4 = HEAP32[i11 >> 2] | 0;
    i8 = HEAP32[i4 + (i9 * 12 | 0) >> 2] | 0;
    i4 = i4 + (i9 * 12 | 0) + 4 | 0;
    i7 = HEAP32[i4 >> 2] | 0;
    if (i7 | 0) {
     i1 = i8 + -1 + i7 | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     if ((HEAP32[i3 + (i1 * 40 | 0) + 36 >> 2] | 0) == -1) {
      while (1) {
       if (i1 >>> 0 <= i8 >>> 0) break;
       i2 = i1 + -1 | 0;
       if ((HEAP32[i3 + (i2 * 40 | 0) + 36 >> 2] | 0) == -1) i1 = i2; else break;
      }
      i5 = i3 + (i1 * 40 | 0) | 0;
      i22 = i3 + (i8 * 40 | 0) + (i7 * 40 | 0) | 0;
      i23 = i22;
      _memmove(i5 | 0, i22 | 0, i3 + ((HEAP32[i13 >> 2] | 0) * 40 | 0) - i23 | 0) | 0;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) - ((i23 - i5 | 0) / 40 | 0);
      i1 = i1 - i8 | 0;
      HEAP32[i4 >> 2] = i1;
      i5 = HEAP32[i10 >> 2] | 0;
      if (i5 | 0) {
       i6 = HEAP32[i11 >> 2] | 0;
       i2 = i1 - i7 | 0;
       i1 = 0;
       do {
        i3 = i6 + (i1 * 12 | 0) | 0;
        i4 = HEAP32[i3 >> 2] | 0;
        if (i4 >>> 0 > i8 >>> 0) HEAP32[i3 >> 2] = i2 + i4;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i5 | 0));
      }
     }
    }
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 __ZN4Mesh16SetChannelsDirtyEjb(i29, HEAP32[(HEAP32[i30 >> 2] | 0) + 96 >> 2] | 0, 1);
 i1 = HEAP32[i37 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i24 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i37 = HEAP32[i37 + 12 >> 2] | 0;
  HEAP32[i31 >> 2] = 1;
  HEAP32[i31 + 4 >> 2] = i37;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i31);
 }
 if ((HEAP32[i27 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i28);
  HEAP32[i36 >> 2] = 0;
 }
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i35 >> 2] | 0, i26);
  HEAP32[i35 >> 2] = 0;
 }
 if ((HEAP32[i32 >> 2] | 0) <= -1) {
  STACKTOP = i38;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i33 >> 2] | 0, i34);
 HEAP32[i33 >> 2] = 0;
 STACKTOP = i38;
 return;
}

function __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i14, i12, i10, i8, i13, i11, i9) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 80 | 0;
 i1 = i15 + 64 | 0;
 i3 = i15 + 32 | 0;
 i4 = i15 + 16 | 0;
 i6 = i15;
 i7 = i14 + ((HEAPU16[i14 + 26 >> 1] | 0) + 144) | 0;
 i5 = i14 + (HEAPU16[i14 + 10 >> 1] | 0) | 0;
 if ((HEAPU8[i14 + 64 + i13 >> 0] | 0 | 0) == (i12 | 0)) {
  f20 = Math_fround(HEAPF32[i11 >> 2]);
  f17 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f20 = Math_fround(-f20);
  f17 = Math_fround(-f17);
  f22 = Math_fround(-Math_fround(HEAPF32[i11 + 8 >> 2]));
  f31 = Math_fround(HEAPF32[i11 + 16 >> 2]);
  f19 = Math_fround(HEAPF32[i11 + 20 >> 2]);
  f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
  f54 = Math_fround(-f31);
  f30 = Math_fround(-f19);
  f26 = Math_fround(-f23);
  i29 = i5 + (i13 << 5) + 16 | 0;
  f16 = Math_fround(HEAPF32[i29 >> 2]);
  i28 = i5 + (i13 << 5) + 20 | 0;
  f21 = Math_fround(HEAPF32[i28 >> 2]);
  i11 = i5 + (i13 << 5) + 24 | 0;
  f24 = Math_fround(HEAPF32[i11 >> 2]);
  f31 = Math_fround(Math_fround(Math_fround(f24 * f17) - Math_fround(f21 * f22)) - f31);
  f19 = Math_fround(Math_fround(Math_fround(f16 * f22) - Math_fround(f24 * f20)) - f19);
  f23 = Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f16 * f17)) - f23);
  i51 = i7 + (i13 * 160 | 0) | 0;
  f16 = Math_fround(HEAPF32[i51 >> 2]);
  i50 = i7 + (i13 * 160 | 0) + 4 | 0;
  f21 = Math_fround(HEAPF32[i50 >> 2]);
  i49 = i7 + (i13 * 160 | 0) + 8 | 0;
  f24 = Math_fround(HEAPF32[i49 >> 2]);
  i48 = i7 + (i13 * 160 | 0) + 32 | 0;
  f27 = Math_fround(HEAPF32[i48 >> 2]);
  i47 = i7 + (i13 * 160 | 0) + 36 | 0;
  f18 = Math_fround(HEAPF32[i47 >> 2]);
  i46 = i7 + (i13 * 160 | 0) + 40 | 0;
  f25 = Math_fround(HEAPF32[i46 >> 2]);
  i45 = i7 + (i13 * 160 | 0) + 64 | 0;
  f34 = Math_fround(HEAPF32[i45 >> 2]);
  i44 = i7 + (i13 * 160 | 0) + 68 | 0;
  f33 = Math_fround(HEAPF32[i44 >> 2]);
  i43 = i7 + (i13 * 160 | 0) + 72 | 0;
  f34 = Math_fround(f20 - Math_fround(Math_fround(f16 * f31) + Math_fround(Math_fround(f19 * f27) + Math_fround(f23 * f34))));
  f33 = Math_fround(f17 - Math_fround(Math_fround(f21 * f31) + Math_fround(Math_fround(f19 * f18) + Math_fround(f23 * f33))));
  f25 = Math_fround(f22 - Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f19 * f25) + Math_fround(f23 * Math_fround(HEAPF32[i43 >> 2])))));
  i42 = i7 + (i13 * 160 | 0) + 16 | 0;
  f24 = Math_fround(HEAPF32[i42 >> 2]);
  i41 = i7 + (i13 * 160 | 0) + 20 | 0;
  f22 = Math_fround(HEAPF32[i41 >> 2]);
  i40 = i7 + (i13 * 160 | 0) + 24 | 0;
  f18 = Math_fround(HEAPF32[i40 >> 2]);
  i39 = i7 + (i13 * 160 | 0) + 48 | 0;
  f21 = Math_fround(HEAPF32[i39 >> 2]);
  i38 = i7 + (i13 * 160 | 0) + 52 | 0;
  f17 = Math_fround(HEAPF32[i38 >> 2]);
  i37 = i7 + (i13 * 160 | 0) + 56 | 0;
  f27 = Math_fround(HEAPF32[i37 >> 2]);
  i36 = i7 + (i13 * 160 | 0) + 80 | 0;
  f16 = Math_fround(HEAPF32[i36 >> 2]);
  i35 = i7 + (i13 * 160 | 0) + 84 | 0;
  f20 = Math_fround(HEAPF32[i35 >> 2]);
  i32 = i7 + (i13 * 160 | 0) + 88 | 0;
  f16 = Math_fround(f54 - Math_fround(Math_fround(f31 * f24) + Math_fround(Math_fround(f19 * f21) + Math_fround(f23 * f16))));
  f20 = Math_fround(f30 - Math_fround(Math_fround(f31 * f22) + Math_fround(Math_fround(f19 * f17) + Math_fround(f23 * f20))));
  f27 = Math_fround(f26 - Math_fround(Math_fround(f31 * f18) + Math_fround(Math_fround(f19 * f27) + Math_fround(f23 * Math_fround(HEAPF32[i32 >> 2])))));
  i53 = i5 + (i13 << 5) | 0;
  f18 = Math_fround(HEAPF32[i53 >> 2]);
  i52 = i5 + (i13 << 5) + 4 | 0;
  f26 = Math_fround(HEAPF32[i52 >> 2]);
  i5 = i5 + (i13 << 5) + 8 | 0;
  f17 = Math_fround(HEAPF32[i5 >> 2]);
  f16 = Math_fround(f16 + Math_fround(Math_fround(f25 * f26) - Math_fround(f33 * f17)));
  f17 = Math_fround(f20 + Math_fround(Math_fround(f34 * f17) - Math_fround(f25 * f18)));
  f26 = Math_fround(f27 + Math_fround(Math_fround(f33 * f18) - Math_fround(f34 * f26)));
  f18 = Math_fround(HEAPF32[i10 >> 2]);
  f27 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f34 = Math_fround(f18 - f34);
  f33 = Math_fround(f27 - f33);
  f25 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f25);
  f27 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f18 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  f16 = Math_fround(f27 - f16);
  f17 = Math_fround(f18 - f17);
  f26 = Math_fround(Math_fround(HEAPF32[i10 + 24 >> 2]) - f26);
  HEAPF32[i4 >> 2] = f34;
  HEAPF32[i4 + 4 >> 2] = f33;
  HEAPF32[i4 + 8 >> 2] = f25;
  HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = f16;
  HEAPF32[i6 + 4 >> 2] = f17;
  HEAPF32[i6 + 8 >> 2] = f26;
  HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  __ZN5physx12_GLOBAL__N_122getImpulseResponseSimdERKNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES6_(i3, i14, i12, i1, i2);
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  i14 = i8 + 16 | 0;
  i12 = i3 + 16 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  f26 = Math_fround(HEAPF32[i8 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i8 + 20 >> 2]);
  f16 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f25 = Math_fround(HEAPF32[i8 >> 2]);
  f33 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i53 >> 2]);
  f27 = Math_fround(HEAPF32[i52 >> 2]);
  f20 = Math_fround(HEAPF32[i5 >> 2]);
  f25 = Math_fround(f25 - Math_fround(Math_fround(f16 * f27) - Math_fround(f17 * f20)));
  f20 = Math_fround(f33 - Math_fround(Math_fround(f26 * f20) - Math_fround(f16 * f18)));
  f27 = Math_fround(f34 - Math_fround(Math_fround(f17 * f18) - Math_fround(f26 * f27)));
  f18 = Math_fround(HEAPF32[i51 >> 2]);
  f34 = Math_fround(HEAPF32[i50 >> 2]);
  f34 = Math_fround(Math_fround(f27 * Math_fround(HEAPF32[i49 >> 2])) + Math_fround(Math_fround(f18 * f25) + Math_fround(f34 * f20)));
  f18 = Math_fround(HEAPF32[i48 >> 2]);
  f33 = Math_fround(HEAPF32[i47 >> 2]);
  f33 = Math_fround(Math_fround(Math_fround(f25 * f18) + Math_fround(f20 * f33)) + Math_fround(f27 * Math_fround(HEAPF32[i46 >> 2])));
  f18 = Math_fround(HEAPF32[i45 >> 2]);
  f22 = Math_fround(HEAPF32[i44 >> 2]);
  f22 = Math_fround(Math_fround(Math_fround(f25 * f18) + Math_fround(f20 * f22)) + Math_fround(f27 * Math_fround(HEAPF32[i43 >> 2])));
  f18 = Math_fround(HEAPF32[i42 >> 2]);
  f30 = Math_fround(HEAPF32[i41 >> 2]);
  f30 = Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f17 * f30)) + Math_fround(f16 * Math_fround(HEAPF32[i40 >> 2])));
  f18 = Math_fround(HEAPF32[i39 >> 2]);
  f21 = Math_fround(HEAPF32[i38 >> 2]);
  f21 = Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f17 * f21)) + Math_fround(f16 * Math_fround(HEAPF32[i37 >> 2])));
  f18 = Math_fround(HEAPF32[i36 >> 2]);
  f24 = Math_fround(HEAPF32[i35 >> 2]);
  f30 = Math_fround(f34 + f30);
  f21 = Math_fround(f33 + f21);
  f24 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f17 * f24)) + Math_fround(f16 * Math_fround(HEAPF32[i32 >> 2]))));
  f18 = Math_fround(f31 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 96 >> 2]));
  f18 = Math_fround(f18 + Math_fround(f19 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 112 >> 2])));
  f18 = Math_fround(f18 + Math_fround(f23 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 128 >> 2])));
  f22 = Math_fround(f31 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 100 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 116 >> 2])));
  f22 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 132 >> 2])));
  f31 = Math_fround(f31 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 104 >> 2]));
  f19 = Math_fround(f31 + Math_fround(f19 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 120 >> 2])));
  f18 = Math_fround(f30 + f18);
  f22 = Math_fround(f21 + f22);
  f23 = Math_fround(f24 + Math_fround(f19 + Math_fround(f23 * Math_fround(HEAPF32[i7 + (i13 * 160 | 0) + 136 >> 2]))));
  f19 = Math_fround(HEAPF32[i29 >> 2]);
  f24 = Math_fround(HEAPF32[i28 >> 2]);
  f21 = Math_fround(HEAPF32[i11 >> 2]);
  f20 = Math_fround(f20 - Math_fround(Math_fround(f18 * f21) - Math_fround(f19 * f23)));
  f19 = Math_fround(f27 - Math_fround(Math_fround(f22 * f19) - Math_fround(f18 * f24)));
  f18 = Math_fround(f26 - f18);
  f17 = Math_fround(f17 - f22);
  f16 = Math_fround(f16 - f23);
  HEAPF32[i9 >> 2] = Math_fround(f25 - Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)));
  HEAPF32[i9 + 4 >> 2] = f20;
  HEAPF32[i9 + 8 >> 2] = f19;
  HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 16 >> 2] = f18;
  HEAPF32[i9 + 20 >> 2] = f17;
  HEAPF32[i9 + 24 >> 2] = f16;
  HEAPF32[i9 + 28 >> 2] = Math_fround(0.0);
  STACKTOP = i15;
  return;
 } else {
  __ZN5physx22getImpulseResponseSlowERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_(i14, i12, i10, i8, i13, i11, i9);
  STACKTOP = i15;
  return;
 }
}

function __ZN5Umbra15PortalRayTracerC2EPNS_12QueryContextERKNS_7Vector3EPKNS_23ImpObjectDistanceParamsEPNS_11TransformerE(i39, i10, i1, i6, i9) {
 i39 = i39 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i42 + 4 | 0;
 i41 = i42;
 HEAP32[i39 >> 2] = i10;
 HEAP32[i39 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i39 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i39 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 i7 = i39 + 16 | 0;
 HEAP32[i7 >> 2] = i9;
 i26 = i39 + 20 | 0;
 HEAPF32[i26 >> 2] = Math_fround(1.0);
 i27 = i39 + 24 | 0;
 i28 = i39 + 40 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAPF32[i28 >> 2] = Math_fround(1.0);
 i29 = i39 + 44 | 0;
 i30 = i39 + 60 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAPF32[i30 >> 2] = Math_fround(1.0);
 i31 = i39 + 64 | 0;
 i32 = i39 + 80 | 0;
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAPF32[i32 >> 2] = Math_fround(1.0);
 i33 = i39 + 92 | 0;
 i34 = i39 + 96 | 0;
 i35 = i39 + 100 | 0;
 i36 = i39 + 104 | 0;
 i37 = i39 + 108 | 0;
 i38 = i39 + 112 | 0;
 i1 = i39 + 248 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i39 + 268 | 0;
 i5 = i39 + 4364 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i33 + 4 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 HEAP32[i33 + 12 >> 2] = 0;
 HEAP32[i33 + 16 >> 2] = 0;
 HEAP32[i33 + 20 >> 2] = 0;
 i3 = i39 + 128 | 0;
 i4 = i3 + 104 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 do {
  HEAP32[i1 + 4 >> 2] = -1;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i5 | 0));
 i1 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i25 = HEAP32[i1 + 64 >> 2] | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i39 + 4368 >> 2] = i4;
 i5 = i10 + 44 | 0;
 HEAP32[i39 + 4380 >> 2] = i5;
 i23 = i10 + 48 | 0;
 i22 = HEAP32[i23 >> 2] | 0;
 i24 = i22 + 1 | 0;
 HEAP32[i23 >> 2] = i24;
 HEAP32[i39 + 4384 >> 2] = i22;
 HEAP32[i39 + 4388 >> 2] = 24;
 HEAP32[i39 + 4400 >> 2] = i25;
 HEAP32[i39 + 4372 >> 2] = (i3 | 0) == 0 ? 0 : i1 + i3 | 0;
 i3 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i39 + 4404 >> 2] = i4;
 HEAP32[i39 + 4416 >> 2] = i5;
 HEAP32[i23 >> 2] = i22 + 2;
 HEAP32[i39 + 4420 >> 2] = i24;
 HEAP32[i39 + 4424 >> 2] = 32;
 HEAP32[i39 + 4436 >> 2] = i25;
 HEAP32[i39 + 4408 >> 2] = (i3 | 0) == 0 ? 0 : i1 + i3 | 0;
 i3 = HEAP32[i1 + 136 >> 2] | 0;
 if (!i3) i3 = 0; else i3 = ((HEAP32[i1 + i3 + (HEAP32[i1 + 144 >> 2] << 2) >> 2] | 0) + 31 >> 5 << 2) + 15 & -16;
 i4 = i10 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + i3 | 0;
 if (i3 >>> 0 > (HEAP32[i10 + 12 >> 2] | 0) >>> 0) i1 = 0; else HEAP32[i4 >> 2] = i3;
 HEAP32[i39 + 84 >> 2] = i1;
 if (!i6) {
  HEAPF32[i39 + 248 >> 2] = Math_fround(1.0);
  HEAPF32[i39 + 252 >> 2] = Math_fround(1.0);
  HEAPF32[i39 + 256 >> 2] = Math_fround(1.0);
  HEAPF32[i39 + 260 >> 2] = Math_fround(1.0);
  f2 = Math_fround(0.0);
 } else {
  f2 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  i25 = !(f2 <= Math_fround(0.0));
  f2 = i25 ? f2 : Math_fround(1.0);
  f2 = Math_fround(f2 * f2);
  HEAPF32[i39 + 248 >> 2] = f2;
  HEAPF32[i39 + 252 >> 2] = f2;
  HEAPF32[i39 + 256 >> 2] = f2;
  HEAPF32[i39 + 260 >> 2] = f2;
  f2 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 }
 HEAPF32[i39 + 264 >> 2] = f2;
 i23 = i39 + 240 | 0;
 HEAPF32[i23 >> 2] = Math_fround(1.0);
 if (!i9) {
  STACKTOP = i42;
  return;
 }
 HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i27 >> 2] = HEAP32[i9 + 4 >> 2];
 i25 = i39 + 28 | 0;
 HEAP32[i25 >> 2] = HEAP32[i9 + 8 >> 2];
 i24 = i39 + 32 | 0;
 HEAP32[i24 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i39 + 36 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i39 + 40 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i39 + 44 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i39 + 48 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i39 + 52 >> 2] = HEAP32[i9 + 32 >> 2];
 HEAP32[i39 + 56 >> 2] = HEAP32[i9 + 36 >> 2];
 HEAP32[i39 + 60 >> 2] = HEAP32[i9 + 40 >> 2];
 HEAP32[i39 + 64 >> 2] = HEAP32[i9 + 44 >> 2];
 HEAP32[i39 + 68 >> 2] = HEAP32[i9 + 48 >> 2];
 HEAP32[i39 + 72 >> 2] = HEAP32[i9 + 52 >> 2];
 HEAP32[i39 + 76 >> 2] = HEAP32[i9 + 56 >> 2];
 HEAP32[i39 + 80 >> 2] = HEAP32[i9 + 60 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i26, i26) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP8[i1 + 1364 >> 0] | 0)) {
  i4 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  f16 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 40 >> 2]);
  HEAPF32[i23 >> 2] = Math_fround(0.0);
  i4 = i1 + 32 | 0;
  i5 = i1 + 36 | 0;
  i6 = i1 + 40 | 0;
  i7 = i1 + 44 | 0;
  i9 = i1 + 48 | 0;
  i10 = i1 + 52 | 0;
  i22 = i1 + 56 | 0;
  i3 = i1 + 60 | 0;
  i1 = 0;
  f8 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  do {
   f12 = (i1 & 1 | 0) == 0 ? f16 : f19;
   f13 = (i1 & 2 | 0) == 0 ? f17 : f20;
   f14 = (i1 & 4 | 0) == 0 ? f18 : f21;
   f15 = Math_fround(f12 * Math_fround(HEAPF32[i4 >> 2]));
   f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i5 >> 2])));
   f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i6 >> 2])));
   f15 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f15);
   if (f15 >= Math_fround(0.0)) {
    f11 = Math_fround(f12 * Math_fround(HEAPF32[i9 >> 2]));
    f11 = Math_fround(f11 + Math_fround(f13 * Math_fround(HEAPF32[i10 >> 2])));
    f11 = Math_fround(f11 + Math_fround(f14 * Math_fround(HEAPF32[i22 >> 2])));
    f11 = Math_fround(f15 / Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f11));
    HEAPF32[i40 >> 2] = f11;
    i43 = HEAP32[(f8 >= f11 ? i23 : i40) >> 2] | 0;
    HEAP32[i23 >> 2] = i43;
    f8 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f11 = f8;
    f2 = f8;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 8);
  if (f11 == Math_fround(0.0)) {
   HEAPF32[i23 >> 2] = Math_fround(.990000009);
   f2 = Math_fround(.990000009);
  }
 } else f2 = Math_fround(HEAPF32[i23 >> 2]);
 f49 = Math_fround(HEAPF32[i26 >> 2]);
 f16 = Math_fround(f49 * Math_fround(0.0));
 f48 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f48 * Math_fround(0.0)));
 f47 = Math_fround(f2 * Math_fround(HEAPF32[i25 >> 2]));
 f16 = Math_fround(f16 + f47);
 f50 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f50 + f16);
 f45 = Math_fround(HEAPF32[i39 + 36 >> 2]);
 f18 = Math_fround(f45 * Math_fround(0.0));
 f44 = Math_fround(HEAPF32[i28 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f44 * Math_fround(0.0)));
 f8 = Math_fround(f2 * Math_fround(HEAPF32[i29 >> 2]));
 f18 = Math_fround(f18 + f8);
 f46 = Math_fround(HEAPF32[i39 + 48 >> 2]);
 f18 = Math_fround(f46 + f18);
 f12 = Math_fround(HEAPF32[i39 + 52 >> 2]);
 f15 = Math_fround(f12 * Math_fround(0.0));
 f13 = Math_fround(HEAPF32[i39 + 56 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(0.0)));
 f14 = Math_fround(f2 * Math_fround(HEAPF32[i30 >> 2]));
 f15 = Math_fround(f15 + f14);
 f11 = Math_fround(HEAPF32[i31 >> 2]);
 f15 = Math_fround(f11 + f15);
 f17 = Math_fround(HEAPF32[i39 + 68 >> 2]);
 f20 = Math_fround(f17 * Math_fround(0.0));
 f19 = Math_fround(HEAPF32[i39 + 72 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f19 * Math_fround(0.0)));
 f21 = Math_fround(f2 * Math_fround(HEAPF32[i39 + 76 >> 2]));
 f20 = Math_fround(f20 + f21);
 f2 = Math_fround(HEAPF32[i32 >> 2]);
 f20 = Math_fround(f2 + f20);
 f16 = Math_fround(f16 / f20);
 f18 = Math_fround(f18 / f20);
 f20 = Math_fround(f15 / f20);
 f15 = Math_fround(f2 + Math_fround(Math_fround(f17 + f19) + f21));
 f21 = Math_fround(f2 + Math_fround(Math_fround(f19 - f17) + f21));
 f17 = Math_fround(Math_fround(Math_fround(f50 + Math_fround(Math_fround(f48 - f49) + f47)) / f21) - f16);
 f19 = Math_fround(Math_fround(Math_fround(f46 + Math_fround(Math_fround(f44 - f45) + f8)) / f21) - f18);
 f21 = Math_fround(Math_fround(Math_fround(f11 + Math_fround(Math_fround(f13 - f12) + f14)) / f21) - f20);
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f50 + Math_fround(Math_fround(f49 + f48) + f47)) / f15) - f16) * Math_fround(.015625));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f46 + Math_fround(Math_fround(f45 + f44) + f8)) / f15) - f18) * Math_fround(.015625));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f11 + Math_fround(Math_fround(f12 + f13) + f14)) / f15) - f20) * Math_fround(.015625));
 HEAPF32[i33 >> 2] = f16;
 HEAPF32[i34 >> 2] = f18;
 HEAPF32[i35 >> 2] = f20;
 f17 = Math_fround(f17 * Math_fround(.015625));
 f19 = Math_fround(f19 * Math_fround(.015625));
 f21 = Math_fround(f21 * Math_fround(.015625));
 HEAPF32[i36 >> 2] = f17;
 HEAPF32[i37 >> 2] = f19;
 HEAPF32[i38 >> 2] = f21;
 i43 = i39 + 192 | 0;
 f16 = Math_fround(Math_abs(Math_fround(f16)));
 HEAPF32[i40 >> 2] = f16;
 f17 = Math_fround(Math_abs(Math_fround(f17)));
 HEAPF32[i41 >> 2] = f17;
 HEAP32[i43 >> 2] = HEAP32[(f16 >= f17 ? i40 : i41) >> 2];
 f18 = Math_fround(Math_abs(Math_fround(f18)));
 HEAPF32[i40 >> 2] = f18;
 f19 = Math_fround(Math_abs(Math_fround(f19)));
 HEAPF32[i41 >> 2] = f19;
 HEAP32[i43 + 4 >> 2] = HEAP32[(f18 >= f19 ? i40 : i41) >> 2];
 f20 = Math_fround(Math_abs(Math_fround(f20)));
 HEAPF32[i40 >> 2] = f20;
 f21 = Math_fround(Math_abs(Math_fround(f21)));
 HEAPF32[i41 >> 2] = f21;
 HEAP32[i43 + 8 >> 2] = HEAP32[(f20 >= f21 ? i40 : i41) >> 2];
 STACKTOP = i42;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i38, i2, i1, i55, i54) {
 i38 = i38 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i55 = i55 | 0;
 i54 = i54 | 0;
 var f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i50 = (i54 | 0) != 0;
 if (i50) if (!(HEAP16[i38 + 84 >> 1] | 0)) {
  f7 = Math_fround(HEAPF32[i38 + 32 >> 2]);
  f3 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * Math_fround(0.0));
  f3 = Math_fround(Math_fround(f3 + Math_fround(HEAPF32[i38 + 4 >> 2])) * Math_fround(0.0));
  f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i38 + 8 >> 2]) + f3) * Math_fround(0.0));
  f3 = Math_fround(Math_fround(HEAPF32[i38 + 12 >> 2]) + f3);
  f8 = Math_fround(Math_fround(0.0) - f7);
  f6 = Math_fround(f8 * Math_fround(HEAPF32[i38 + 16 >> 2]));
  f6 = Math_fround(f8 * Math_fround(f6 + Math_fround(HEAPF32[i38 + 20 >> 2])));
  f6 = Math_fround(f8 * Math_fround(Math_fround(HEAPF32[i38 + 24 >> 2]) + f6));
  f6 = Math_fround(Math_fround(HEAPF32[i38 + 28 >> 2]) + f6);
  i53 = f7 < Math_fround(0.0);
  f3 = i53 ? f6 : f3;
  f6 = Math_fround(Math_fround(HEAPF32[i54 >> 2]) * f3);
  f7 = Math_fround(Math_fround(HEAPF32[i54 + 4 >> 2]) * f3);
  f8 = Math_fround(Math_fround(HEAPF32[i54 + 8 >> 2]) * f3);
  f9 = Math_fround(Math_fround(HEAPF32[i54 + 12 >> 2]) * f3);
  f10 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 16 >> 2]));
  f11 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 20 >> 2]));
  f12 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 24 >> 2]));
  f13 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 28 >> 2]));
  f14 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 32 >> 2]));
  f15 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 36 >> 2]));
  f16 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 40 >> 2]));
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i54 + 44 >> 2]));
  if (i1 >>> 0 >= i55 >>> 0) return;
  i4 = HEAP32[i2 + 120 >> 2] | 0;
  i5 = HEAP32[i2 + 140 >> 2] | 0;
  i2 = HEAP32[i2 + 160 >> 2] | 0;
  do {
   i43 = i4 + (i1 << 2) | 0;
   f67 = Math_fround(HEAPF32[i43 >> 2]);
   i44 = i43 + 4 | 0;
   f66 = Math_fround(HEAPF32[i44 >> 2]);
   i45 = i43 + 8 | 0;
   f65 = Math_fround(HEAPF32[i45 >> 2]);
   i46 = i43 + 12 | 0;
   f64 = Math_fround(HEAPF32[i46 >> 2]);
   i47 = i5 + (i1 << 2) | 0;
   f63 = Math_fround(HEAPF32[i47 >> 2]);
   i48 = i47 + 4 | 0;
   f62 = Math_fround(HEAPF32[i48 >> 2]);
   i49 = i47 + 8 | 0;
   f61 = Math_fround(HEAPF32[i49 >> 2]);
   i50 = i47 + 12 | 0;
   f60 = Math_fround(HEAPF32[i50 >> 2]);
   i51 = i2 + (i1 << 2) | 0;
   f59 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i51 + 4 | 0;
   f58 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = i51 + 8 | 0;
   f57 = Math_fround(HEAPF32[i53 >> 2]);
   i54 = i51 + 12 | 0;
   f66 = Math_fround(f7 + f66);
   f65 = Math_fround(f8 + f65);
   f64 = Math_fround(f9 + f64);
   f63 = Math_fround(f10 + f63);
   f62 = Math_fround(f11 + f62);
   f61 = Math_fround(f12 + f61);
   f60 = Math_fround(f13 + f60);
   f59 = Math_fround(f14 + f59);
   f58 = Math_fround(f15 + f58);
   f57 = Math_fround(f16 + f57);
   f56 = Math_fround(f3 + Math_fround(HEAPF32[i54 >> 2]));
   HEAPF32[i43 >> 2] = Math_fround(f6 + f67);
   HEAPF32[i44 >> 2] = f66;
   HEAPF32[i45 >> 2] = f65;
   HEAPF32[i46 >> 2] = f64;
   HEAPF32[i47 >> 2] = f63;
   HEAPF32[i48 >> 2] = f62;
   HEAPF32[i49 >> 2] = f61;
   HEAPF32[i50 >> 2] = f60;
   HEAPF32[i51 >> 2] = f59;
   HEAPF32[i52 >> 2] = f58;
   HEAPF32[i53 >> 2] = f57;
   HEAPF32[i54 >> 2] = f56;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i55 >>> 0);
  return;
 }
 if (i1 >>> 0 >= i55 >>> 0) return;
 i51 = i2 + 520 | 0;
 i35 = i54 + 4 | 0;
 i36 = i54 + 8 | 0;
 i37 = i54 + 12 | 0;
 i27 = i54 + 16 | 0;
 i28 = i54 + 20 | 0;
 i29 = i54 + 24 | 0;
 i30 = i54 + 28 | 0;
 i31 = i54 + 32 | 0;
 i32 = i54 + 36 | 0;
 i33 = i54 + 40 | 0;
 i34 = i54 + 44 | 0;
 i52 = i38 + 32 | 0;
 i53 = i38 + 4 | 0;
 i39 = i38 + 8 | 0;
 i40 = i38 + 12 | 0;
 i41 = i38 + 16 | 0;
 i42 = i38 + 20 | 0;
 i43 = i38 + 24 | 0;
 i44 = i38 + 28 | 0;
 i45 = i2 + 120 | 0;
 i46 = i2 + 140 | 0;
 i47 = i2 + 160 | 0;
 i48 = i2 + 180 | 0;
 i49 = i2 + 200 | 0;
 i26 = i2 + 220 | 0;
 do {
  i25 = (HEAP32[i51 >> 2] | 0) + (i1 << 2) | 0;
  f3 = Math_fround(HEAPF32[i25 >> 2]);
  f6 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f3 = Math_fround(f3 * Math_fround(.00999999977));
  f6 = Math_fround(f6 * Math_fround(.00999999977));
  f7 = Math_fround(f7 * Math_fround(.00999999977));
  f8 = Math_fround(Math_fround(HEAPF32[i25 + 12 >> 2]) * Math_fround(.00999999977));
  if (i50) {
   i2 = i54;
   i4 = i27;
   i5 = i28;
   i17 = i29;
   i18 = i30;
   i19 = i31;
   i20 = i32;
   i21 = i33;
   i22 = i34;
   i23 = i35;
   i24 = i36;
   i25 = i37;
  } else {
   i25 = (HEAP32[i48 >> 2] | 0) + (i1 << 2) | 0;
   i18 = (HEAP32[i49 >> 2] | 0) + (i1 << 2) | 0;
   i22 = (HEAP32[i26 >> 2] | 0) + (i1 << 2) | 0;
   i2 = i25;
   i4 = i18;
   i5 = i18 + 4 | 0;
   i17 = i18 + 8 | 0;
   i18 = i18 + 12 | 0;
   i19 = i22;
   i20 = i22 + 4 | 0;
   i21 = i22 + 8 | 0;
   i22 = i22 + 12 | 0;
   i23 = i25 + 4 | 0;
   i24 = i25 + 8 | 0;
   i25 = i25 + 12 | 0;
  }
  f16 = Math_fround(HEAPF32[i22 >> 2]);
  f60 = Math_fround(HEAPF32[i21 >> 2]);
  f61 = Math_fround(HEAPF32[i20 >> 2]);
  f62 = Math_fround(HEAPF32[i19 >> 2]);
  f12 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  f59 = Math_fround(HEAPF32[i25 >> 2]);
  f58 = Math_fround(HEAPF32[i24 >> 2]);
  f57 = Math_fround(HEAPF32[i23 >> 2]);
  f56 = Math_fround(HEAPF32[i2 >> 2]);
  f64 = Math_fround(HEAPF32[i52 >> 2]);
  f73 = Math_fround(HEAPF32[i38 >> 2]);
  f13 = Math_fround(f3 * f73);
  f14 = Math_fround(f6 * f73);
  f15 = Math_fround(f7 * f73);
  f73 = Math_fround(f8 * f73);
  f67 = Math_fround(HEAPF32[i53 >> 2]);
  f13 = Math_fround(f3 * Math_fround(f13 + f67));
  f14 = Math_fround(f6 * Math_fround(f14 + f67));
  f15 = Math_fround(f7 * Math_fround(f15 + f67));
  f67 = Math_fround(f8 * Math_fround(f73 + f67));
  f73 = Math_fround(HEAPF32[i39 >> 2]);
  f13 = Math_fround(f3 * Math_fround(f73 + f13));
  f14 = Math_fround(f6 * Math_fround(f73 + f14));
  f15 = Math_fround(f7 * Math_fround(f73 + f15));
  f67 = Math_fround(f8 * Math_fround(f73 + f67));
  f73 = Math_fround(HEAPF32[i40 >> 2]);
  f13 = Math_fround(f73 + f13);
  f14 = Math_fround(f73 + f14);
  f15 = Math_fround(f73 + f15);
  f67 = Math_fround(f73 + f67);
  f73 = Math_fround(f3 - f64);
  f72 = Math_fround(f6 - f64);
  f71 = Math_fround(f7 - f64);
  f70 = Math_fround(f8 - f64);
  f69 = Math_fround(HEAPF32[i41 >> 2]);
  f68 = Math_fround(f73 * f69);
  f66 = Math_fround(f72 * f69);
  f65 = Math_fround(f71 * f69);
  f69 = Math_fround(f70 * f69);
  f63 = Math_fround(HEAPF32[i42 >> 2]);
  f68 = Math_fround(f73 * Math_fround(f68 + f63));
  f66 = Math_fround(f72 * Math_fround(f66 + f63));
  f65 = Math_fround(f71 * Math_fround(f65 + f63));
  f63 = Math_fround(f70 * Math_fround(f69 + f63));
  f69 = Math_fround(HEAPF32[i43 >> 2]);
  f68 = Math_fround(f73 * Math_fround(f69 + f68));
  f66 = Math_fround(f72 * Math_fround(f69 + f66));
  f65 = Math_fround(f71 * Math_fround(f69 + f65));
  f63 = Math_fround(f70 * Math_fround(f69 + f63));
  f69 = Math_fround(HEAPF32[i44 >> 2]);
  f68 = Math_fround(f69 + f68);
  f66 = Math_fround(f69 + f66);
  f65 = Math_fround(f69 + f65);
  f63 = Math_fround(f69 + f63);
  f13 = f3 > f64 ? f68 : f13;
  f14 = f6 > f64 ? f66 : f14;
  f15 = f7 > f64 ? f65 : f15;
  f67 = f8 > f64 ? f63 : f67;
  f56 = Math_fround(f56 * f13);
  f57 = Math_fround(f57 * f14);
  f58 = Math_fround(f58 * f15);
  f59 = Math_fround(f59 * f67);
  f9 = Math_fround(f9 * f13);
  f10 = Math_fround(f10 * f14);
  f11 = Math_fround(f11 * f15);
  f12 = Math_fround(f12 * f67);
  f13 = Math_fround(f62 * f13);
  f14 = Math_fround(f61 * f14);
  f15 = Math_fround(f60 * f15);
  f67 = Math_fround(f16 * f67);
  i2 = (HEAP32[i45 >> 2] | 0) + (i1 << 2) | 0;
  f16 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i2 + 4 | 0;
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i2 + 8 | 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  i17 = i2 + 12 | 0;
  f8 = Math_fround(HEAPF32[i17 >> 2]);
  i18 = (HEAP32[i46 >> 2] | 0) + (i1 << 2) | 0;
  f60 = Math_fround(HEAPF32[i18 >> 2]);
  i19 = i18 + 4 | 0;
  f61 = Math_fround(HEAPF32[i19 >> 2]);
  i20 = i18 + 8 | 0;
  f62 = Math_fround(HEAPF32[i20 >> 2]);
  i21 = i18 + 12 | 0;
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  i22 = (HEAP32[i47 >> 2] | 0) + (i1 << 2) | 0;
  f64 = Math_fround(HEAPF32[i22 >> 2]);
  i23 = i22 + 4 | 0;
  f65 = Math_fround(HEAPF32[i23 >> 2]);
  i24 = i22 + 8 | 0;
  f66 = Math_fround(HEAPF32[i24 >> 2]);
  i25 = i22 + 12 | 0;
  f57 = Math_fround(f6 + f57);
  f58 = Math_fround(f7 + f58);
  f59 = Math_fround(f8 + f59);
  f60 = Math_fround(f9 + f60);
  f61 = Math_fround(f10 + f61);
  f62 = Math_fround(f11 + f62);
  f63 = Math_fround(f12 + f63);
  f64 = Math_fround(f13 + f64);
  f65 = Math_fround(f14 + f65);
  f66 = Math_fround(f15 + f66);
  f67 = Math_fround(f67 + Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i2 >> 2] = Math_fround(f16 + f56);
  HEAPF32[i4 >> 2] = f57;
  HEAPF32[i5 >> 2] = f58;
  HEAPF32[i17 >> 2] = f59;
  HEAPF32[i18 >> 2] = f60;
  HEAPF32[i19 >> 2] = f61;
  HEAPF32[i20 >> 2] = f62;
  HEAPF32[i21 >> 2] = f63;
  HEAPF32[i22 >> 2] = f64;
  HEAPF32[i23 >> 2] = f65;
  HEAPF32[i24 >> 2] = f66;
  HEAPF32[i25 >> 2] = f67;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i55 >>> 0);
 return;
}

function __ZN14Texture2DArray8TransferI14SafeBinaryReadEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 8 | 0;
 i11 = i16 + 4 | 0;
 i14 = i16;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i12, i13);
 i15 = i12 + 80 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932215 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i13 + 16 | 0;
   i9 = HEAP32[i13 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i9 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i15, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i15 >> 2] = _llvm_bswap_i32(HEAP32[i15 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i15 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i9 = i12 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932223 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i7 = i12 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 853473 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i5 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags(i13, i12 + 92 | 0, gb + 410455 | 0, 0);
 i4 = i12 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 410444 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i5 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i5 = i12 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i4 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i2 = i12 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 431875 | 0, gb + 431893 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i13); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i4 = i12 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 932818 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i6 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i8 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i3 = i12 + 109 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i8 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i13 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i13, i14, gb + 411165 | 0, 1);
 i3 = i12 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i12 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i12 + 108 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i8 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i12 + 48 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  mftCall_vii(i6 | 0, i8 | 0, i10 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) {
  i11 = 0;
  HEAP32[i4 >> 2] = i11;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
  HEAP32[i3 >> 2] = i11;
  i15 = HEAP32[i15 >> 2] | 0;
  f18 = Math_fround(i15 | 0);
  f18 = Math_fround(Math_fround(1.0) / f18);
  i15 = HEAP32[i9 >> 2] | 0;
  f17 = Math_fround(i15 | 0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i15 = i12 + 68 | 0;
  HEAPF32[i15 >> 2] = f18;
  i15 = i12 + 72 | 0;
  HEAPF32[i15 >> 2] = f17;
  i15 = HEAP32[i14 >> 2] | 0;
  __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i13, i15, i11, 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  HEAP32[i4 >> 2] = i11;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
  HEAP32[i3 >> 2] = i11;
  i15 = HEAP32[i15 >> 2] | 0;
  f17 = Math_fround(i15 | 0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i15 = HEAP32[i9 >> 2] | 0;
  f18 = Math_fround(i15 | 0);
  f18 = Math_fround(Math_fround(1.0) / f18);
  i15 = i12 + 68 | 0;
  HEAPF32[i15 >> 2] = f17;
  i15 = i12 + 72 | 0;
  HEAPF32[i15 >> 2] = f18;
  i15 = HEAP32[i14 >> 2] | 0;
  __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i13, i15, i11, 0);
  STACKTOP = i16;
  return;
 }
 i11 = (i2 >>> 0) / (i1 >>> 0) | 0;
 HEAP32[i4 >> 2] = i11;
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
 HEAP32[i3 >> 2] = i11;
 i15 = HEAP32[i15 >> 2] | 0;
 f17 = Math_fround(i15 | 0);
 f17 = Math_fround(Math_fround(1.0) / f17);
 i15 = HEAP32[i9 >> 2] | 0;
 f18 = Math_fround(i15 | 0);
 f18 = Math_fround(Math_fround(1.0) / f18);
 i15 = i12 + 68 | 0;
 HEAPF32[i15 >> 2] = f17;
 i15 = i12 + 72 | 0;
 HEAPF32[i15 >> 2] = f18;
 i15 = HEAP32[i14 >> 2] | 0;
 __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i13, i15, i11, 0);
 STACKTOP = i16;
 return;
}

function __ZN9Rigidbody6CreateEb(i32, i33) {
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i35 + 16 | 0;
 i28 = i35 + 12 | 0;
 i14 = i35;
 i34 = i32 + 52 | 0;
 if (HEAP32[i34 >> 2] | 0) if ((HEAPU8[i32 + 80 >> 0] | 0) == (i33 & 1 | 0)) {
  STACKTOP = i35;
  return;
 }
 i11 = __Z21GetManagerFromContexti(9) | 0;
 i29 = HEAP32[i11 + 168 >> 2] | 0;
 i1 = HEAP32[i11 + 172 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i11 + 44 >> 2]);
 i11 = HEAP32[gb + 1457408 >> 2] | 0;
 i26 = HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0;
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i27 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 24 >> 2] = Math_fround(0.0);
 i11 = mftCall_iii(i26 | 0, i11 | 0, i27 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 292 >> 2] | 0, i11 | 0, i29 | 0, i1 | 0);
 mftCall_vif(HEAP32[(HEAP32[i11 >> 2] | 0) + 260 >> 2] | 0, i11 | 0, +f31);
 HEAP32[i11 + 8 >> 2] = i32;
 i1 = HEAP32[i34 >> 2] | 0;
 if (!i1) {
  HEAP8[i32 + 80 >> 0] = i33 & 1;
  HEAP32[i34 >> 2] = i11;
  i29 = HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0;
  HEAPF32[i27 >> 2] = Math_fround(1.0);
  HEAPF32[i27 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i27 + 8 >> 2] = Math_fround(1.0);
  mftCall_vii(i29 | 0, i11 | 0, i27 | 0);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 128 >> 2] | 0, i29 | 0, +Math_fround(HEAPF32[i32 + 68 >> 2]));
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 232 >> 2] | 0, i29 | 0, +Math_fround(HEAPF32[i32 + 72 >> 2]));
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 240 >> 2] | 0, i29 | 0, +Math_fround(HEAPF32[i32 + 76 >> 2]));
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 44 >> 2] | 0, i29 | 0, 2, (HEAP8[i32 + 83 >> 0] | 0) == 0 | 0);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 184 >> 2] | 0, i29 | 0, 1, (HEAP8[i32 + 84 >> 0] | 0) != 0 | 0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i27 | 0, i1 | 0);
  i15 = HEAP32[i27 + 16 >> 2] | 0;
  i16 = HEAP32[i27 + 20 >> 2] | 0;
  i17 = HEAP32[i27 + 24 >> 2] | 0;
  i5 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i27 | 0, i5 | 0);
  i5 = HEAP32[i27 >> 2] | 0;
  i8 = HEAP32[i27 + 4 >> 2] | 0;
  i9 = HEAP32[i27 + 8 >> 2] | 0;
  i10 = HEAP32[i27 + 12 >> 2] | 0;
  i4 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i27 | 0, i4 | 0);
  i4 = HEAP32[i27 >> 2] | 0;
  i3 = HEAP32[i27 + 4 >> 2] | 0;
  i1 = HEAP32[i27 + 8 >> 2] | 0;
  HEAP32[i14 >> 2] = i4;
  i12 = i14 + 4 | 0;
  HEAP32[i12 >> 2] = i3;
  i13 = i14 + 8 | 0;
  HEAP32[i13 >> 2] = i1;
  i18 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 152 >> 2] | 0, i27 | 0, i18 | 0);
  i18 = HEAP32[i27 >> 2] | 0;
  i19 = HEAP32[i27 + 4 >> 2] | 0;
  i20 = HEAP32[i27 + 8 >> 2] | 0;
  i21 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 160 >> 2] | 0, i27 | 0, i21 | 0);
  i21 = HEAP32[i27 >> 2] | 0;
  i22 = HEAP32[i27 + 4 >> 2] | 0;
  i23 = HEAP32[i27 + 8 >> 2] | 0;
  i25 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i25 >> 2] | 0) + 296 >> 2] | 0, i25 | 0, i27 | 0, i28 | 0);
  i25 = HEAP32[i27 >> 2] | 0;
  i26 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 296 >> 2] | 0, i26 | 0, i27 | 0, i28 | 0);
  i26 = HEAP32[i28 >> 2] | 0;
  i29 = HEAP32[i34 >> 2] | 0;
  f24 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i29 >> 2] | 0) + 264 >> 2] | 0, i29 | 0));
  i29 = HEAP32[i34 >> 2] | 0;
  f30 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i29 >> 2] | 0) + 252 >> 2] | 0, i29 | 0));
  i29 = HEAP32[i34 >> 2] | 0;
  f31 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i29 >> 2] | 0) + 220 >> 2] | 0, i29 | 0));
  __ZN9Rigidbody15CleanupInternalEb(i32, 1);
  HEAP8[i32 + 80 >> 0] = i33 & 1;
  HEAP32[i34 >> 2] = i11;
  i29 = i32 + 81 | 0;
  do if (!(HEAP8[i29 >> 0] | 0)) {
   f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAP8[i29 >> 0] = 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 124 >> 2] | 0, i27 | 0, i11 | 0);
   HEAP32[i27 >> 2] = i5;
   HEAP32[i27 + 4 >> 2] = i8;
   HEAP32[i27 + 8 >> 2] = i9;
   HEAP32[i27 + 12 >> 2] = i10;
   i1 = HEAP32[i34 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i27 | 0);
   i1 = i32 + 56 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i11 = __Z12GetIVehiclesv() | 0;
    mftCall_viif(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i32 + 68 >> 2]));
    f7 = Math_fround(HEAPF32[i14 >> 2]);
    f6 = Math_fround(HEAPF32[i12 >> 2]);
    f2 = Math_fround(HEAPF32[i13 >> 2]);
   }
   HEAP8[i29 >> 0] = 0;
   if (f7 > Math_fround(1.1920929e-07) & f6 > Math_fround(1.1920929e-07) & f2 > Math_fround(1.1920929e-07)) {
    i13 = HEAP32[i34 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 140 >> 2] | 0, i13 | 0, i14 | 0);
    break;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 733397 | 0, 0, gb + 732812 | 0, 779, 1, HEAP32[i32 + 4 >> 2] | 0, 0, 0);
    break;
   }
  } while (0);
  i1 = i32 + 82 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i14 = HEAP32[i34 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 124 >> 2] | 0, i27 | 0, i14 | 0);
   HEAP32[i27 + 16 >> 2] = i15;
   HEAP32[i27 + 20 >> 2] = i16;
   HEAP32[i27 + 24 >> 2] = i17;
   i17 = HEAP32[i34 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 120 >> 2] | 0, i17 | 0, i27 | 0);
   HEAP8[i1 >> 0] = 0;
   __ZN9Rigidbody22UpdateMassDistributionEv(i32);
   i1 = i32 + 56 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i17 = __Z12GetIVehiclesv() | 0;
    mftCall_viif(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i32 + 68 >> 2]));
   }
  }
  HEAP32[i27 >> 2] = i18;
  i4 = i27 + 4 | 0;
  HEAP32[i4 >> 2] = i19;
  i3 = i27 + 8 | 0;
  HEAP32[i3 >> 2] = i20;
  i5 = i32 + 88 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 & 2 | 0) HEAPF32[i27 >> 2] = Math_fround(0.0);
  if (i1 & 4 | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
  if (i1 & 8 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
  i4 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 156 >> 2] | 0, i4 | 0, i27 | 0, 1);
  HEAP32[i27 >> 2] = i21;
  i4 = i27 + 4 | 0;
  HEAP32[i4 >> 2] = i22;
  i3 = i27 + 8 | 0;
  HEAP32[i3 >> 2] = i23;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 & 16 | 0) HEAPF32[i27 >> 2] = Math_fround(0.0);
  if (i1 & 32 | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
  if (i1 & 64 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
  i3 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0, i3 | 0, i27 | 0, 1);
  i3 = HEAP32[i34 >> 2] | 0;
  i22 = HEAP32[i3 >> 2] | 0;
  i23 = HEAP32[i22 + 292 >> 2] | 0;
  mftCall_viii(HEAP32[i22 + 296 >> 2] | 0, i3 | 0, i27 | 0, i28 | 0);
  mftCall_viii(i23 | 0, i3 | 0, ((i25 | 0) < 1 ? 1 : (i25 | 0) > 255 ? 255 : i25) | 0, HEAP32[i28 >> 2] | 0);
  i3 = HEAP32[i34 >> 2] | 0;
  i23 = HEAP32[i3 >> 2] | 0;
  i25 = HEAP32[i23 + 292 >> 2] | 0;
  mftCall_viii(HEAP32[i23 + 296 >> 2] | 0, i3 | 0, i27 | 0, i28 | 0);
  mftCall_viii(i25 | 0, i3 | 0, HEAP32[i27 >> 2] | 0, ((i26 | 0) < 1 ? 1 : (i26 | 0) > 255 ? 255 : i26) | 0);
  i3 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i3 | 0, +f24);
  __ZN9Rigidbody14SetIsKinematicEb(i32, (HEAP8[i32 + 84 >> 0] | 0) != 0);
  i3 = i32 + 68 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  i28 = f2 < Math_fround(1.00000001e-07);
  i27 = f2 > Math_fround(1.0e9);
  f24 = i27 ? Math_fround(1.0e9) : f2;
  HEAPF32[i3 >> 2] = i28 ? Math_fround(1.00000001e-07) : f24;
  if (!(HEAP8[i29 >> 0] | 0)) {
   i29 = HEAP32[i34 >> 2] | 0;
   mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 128 >> 2] | 0, i29 | 0, +f2);
  } else __ZN9Rigidbody22UpdateMassDistributionEv(i32);
  i1 = i32 + 56 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i29 = __Z12GetIVehiclesv() | 0;
   mftCall_viif(HEAP32[(HEAP32[i29 >> 2] | 0) + 12 >> 2] | 0, i29 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i3 >> 2]));
  }
  f24 = Math_fround(HEAPF32[i32 + 72 >> 2]);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 232 >> 2] | 0, i29 | 0, +f24);
  f24 = Math_fround(HEAPF32[i32 + 76 >> 2]);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 240 >> 2] | 0, i29 | 0, +f24);
  i29 = i32 + 83 | 0;
  i28 = HEAP8[i29 >> 0] | 0;
  i27 = HEAP32[i34 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 44 >> 2] | 0, i27 | 0, 2, i28 << 24 >> 24 == 0 | 0);
  HEAP8[i29 >> 0] = i28;
  __ZN9Rigidbody25SetCollisionDetectionModeEi(i32, HEAP32[i32 + 92 >> 2] | 0);
  __ZN9Rigidbody19SetDetectCollisionsEb(i32, (HEAP8[i32 + 100 >> 0] | 0) != 0);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 248 >> 2] | 0, i29 | 0, +f30);
  i29 = HEAP32[i34 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i29 >> 2] | 0) + 216 >> 2] | 0, i29 | 0, +f31);
 }
 if (i33) {
  i33 = HEAP32[gb + 1457404 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 44 >> 2] | 0, i33 | 0, HEAP32[i34 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, HEAP32[(HEAP32[i32 + 28 >> 2] | 0) + 60 >> 2] | 0);
 }
 __ZN9Rigidbody23UpdateInterpolationNodeEv(i32);
 STACKTOP = i35;
 return;
}

function __Z16tesedgeIntersectP10TESSvertexS0_S0_S0_S0_(i3, i4, i7, i9, i19) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i19 = i19 | 0;
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, f8 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0;
 f1 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 do if (f1 < f2) {
  i12 = i3;
  i3 = i4;
 } else {
  if (f1 == f2) {
   f17 = Math_fround(HEAPF32[i3 + 28 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i4 + 28 >> 2])) {
    i12 = i3;
    i3 = i4;
    break;
   }
  }
  i12 = i4;
 } while (0);
 f1 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 do if (f1 < f2) {
  i10 = i7;
  i4 = i9;
 } else {
  if (f1 == f2) {
   f17 = Math_fround(HEAPF32[i7 + 28 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i9 + 28 >> 2])) {
    i10 = i7;
    i4 = i9;
    break;
   }
  }
  i10 = i9;
  i4 = i7;
  f1 = f2;
 } while (0);
 f2 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 do if (f2 < f1) {
  i7 = i12;
  i18 = i3;
  i3 = i4;
 } else {
  if (f2 == f1) {
   f17 = Math_fround(HEAPF32[i12 + 28 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i10 + 28 >> 2])) {
    i7 = i12;
    i18 = i3;
    i3 = i4;
    break;
   }
  }
  i7 = i10;
  i18 = i4;
  i10 = i12;
  f1 = f2;
 } while (0);
 i12 = i10 + 24 | 0;
 i4 = i18 + 24 | 0;
 f17 = Math_fround(HEAPF32[i4 >> 2]);
 do if (f1 < f17) i15 = 17; else {
  if (f1 == f17) {
   f16 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   if (f16 <= Math_fround(HEAPF32[i18 + 28 >> 2])) {
    i15 = 17;
    break;
   }
  }
  HEAPF32[i19 + 24 >> 2] = Math_fround(Math_fround(f1 + f17) * Math_fround(.5));
 } while (0);
 L24 : do if ((i15 | 0) == 17) {
  f16 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  do if (!(f17 < f16)) {
   if (f17 == f16) {
    f14 = Math_fround(HEAPF32[i18 + 28 >> 2]);
    if (f14 <= Math_fround(HEAPF32[i3 + 28 >> 2])) break;
   }
   f6 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f2 = Math_fround(f1 - f6);
   f5 = Math_fround(f17 - f1);
   if (Math_fround(f2 + f5) > Math_fround(0.0)) {
    f8 = Math_fround(HEAPF32[i10 + 28 >> 2]);
    f14 = Math_fround(f2 * Math_fround(f8 - Math_fround(HEAPF32[i18 + 28 >> 2])));
    f8 = Math_fround(f14 + Math_fround(f5 * Math_fround(f8 - Math_fround(HEAPF32[i7 + 28 >> 2]))));
   } else f8 = Math_fround(0.0);
   f5 = Math_fround(f16 - f6);
   f2 = Math_fround(f17 - f16);
   if (Math_fround(f5 + f2) > Math_fround(0.0)) {
    f17 = Math_fround(HEAPF32[i3 + 28 >> 2]);
    f14 = Math_fround(f5 * Math_fround(f17 - Math_fround(HEAPF32[i18 + 28 >> 2])));
    f2 = Math_fround(f14 + Math_fround(f2 * Math_fround(f17 - Math_fround(HEAPF32[i7 + 28 >> 2]))));
   } else f2 = Math_fround(0.0);
   f5 = Math_fround(-f2);
   i15 = Math_fround(f8 - f2) < Math_fround(0.0);
   f17 = Math_fround(-f8);
   f5 = i15 ? f2 : f5;
   f2 = i15 ? f17 : f8;
   i15 = f2 < Math_fround(0.0);
   f2 = i15 ? Math_fround(0.0) : f2;
   i15 = f5 < Math_fround(0.0);
   f5 = i15 ? Math_fround(0.0) : f5;
   do if (!(f2 <= f5)) f1 = Math_fround(f16 + Math_fround(Math_fround(f5 / Math_fround(f2 + f5)) * Math_fround(f1 - f16))); else if (f5 == Math_fround(0.0)) {
    f1 = Math_fround(Math_fround(f1 + f16) * Math_fround(.5));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(Math_fround(f2 / Math_fround(f2 + f5)) * Math_fround(f16 - f1)));
    break;
   } while (0);
   HEAPF32[i19 + 24 >> 2] = f1;
   break L24;
  } while (0);
  f2 = Math_fround(f1 - Math_fround(HEAPF32[i7 + 24 >> 2]));
  f14 = Math_fround(f17 - f1);
  f5 = Math_fround(f2 + f14);
  do if (f5 > Math_fround(0.0)) {
   f6 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   f8 = Math_fround(HEAPF32[i7 + 28 >> 2]);
   f11 = Math_fround(HEAPF32[i18 + 28 >> 2]);
   if (f2 < f14) {
    f13 = Math_fround(Math_fround(f6 - f8) + Math_fround(Math_fround(f2 / f5) * Math_fround(f8 - f11)));
    break;
   } else {
    f13 = Math_fround(Math_fround(f6 - f11) + Math_fround(Math_fround(f14 / f5) * Math_fround(f11 - f8)));
    break;
   }
  } else f13 = Math_fround(0.0); while (0);
  f2 = Math_fround(f16 - f17);
  f5 = Math_fround(f14 + f2);
  do if (f5 > Math_fround(0.0)) {
   f6 = Math_fround(HEAPF32[i18 + 28 >> 2]);
   f8 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   f11 = Math_fround(HEAPF32[i3 + 28 >> 2]);
   if (f14 < f2) {
    f2 = Math_fround(Math_fround(f6 - f8) + Math_fround(Math_fround(f14 / f5) * Math_fround(f8 - f11)));
    break;
   } else {
    f2 = Math_fround(Math_fround(f6 - f11) + Math_fround(Math_fround(f2 / f5) * Math_fround(f11 - f8)));
    break;
   }
  } else f2 = Math_fround(0.0); while (0);
  i15 = Math_fround(f13 + f2) < Math_fround(0.0);
  f16 = Math_fround(-f13);
  f5 = Math_fround(-f2);
  f5 = i15 ? f5 : f2;
  f2 = i15 ? f16 : f13;
  i15 = f2 < Math_fround(0.0);
  f2 = i15 ? Math_fround(0.0) : f2;
  i15 = f5 < Math_fround(0.0);
  f5 = i15 ? Math_fround(0.0) : f5;
  do if (!(f2 <= f5)) f1 = Math_fround(f17 + Math_fround(Math_fround(f5 / Math_fround(f2 + f5)) * Math_fround(f1 - f17))); else if (f5 == Math_fround(0.0)) {
   f1 = Math_fround(Math_fround(f1 + f17) * Math_fround(.5));
   break;
  } else {
   f1 = Math_fround(f1 + Math_fround(Math_fround(f2 / Math_fround(f2 + f5)) * f14));
   break;
  } while (0);
  HEAPF32[i19 + 24 >> 2] = f1;
 } while (0);
 f1 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f2 = Math_fround(HEAPF32[i18 + 28 >> 2]);
 do if (f1 < f2) {
  i9 = i7;
  i7 = i18;
 } else {
  if (f1 == f2) {
   f17 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i4 >> 2])) {
    i9 = i7;
    i7 = i18;
    break;
   }
  }
  i9 = i18;
 } while (0);
 f2 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 f1 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 do if (f2 < f1) i4 = i10; else {
  if (f2 == f1) {
   f17 = Math_fround(HEAPF32[i12 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i3 + 24 >> 2])) {
    i4 = i10;
    break;
   }
  }
  i4 = i3;
  i3 = i10;
  f2 = f1;
 } while (0);
 f1 = Math_fround(HEAPF32[i9 + 28 >> 2]);
 do if (f1 < f2) {
  i10 = i9;
  i12 = i7;
 } else {
  if (f1 == f2) {
   f17 = Math_fround(HEAPF32[i9 + 24 >> 2]);
   if (f17 <= Math_fround(HEAPF32[i4 + 24 >> 2])) {
    i10 = i9;
    i12 = i7;
    break;
   }
  }
  i10 = i4;
  i12 = i3;
  i4 = i9;
  i3 = i7;
 } while (0);
 f17 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f16 = Math_fround(HEAPF32[i12 + 28 >> 2]);
 do if (!(f17 < f16)) {
  if (f17 == f16) {
   f14 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   if (f14 <= Math_fround(HEAPF32[i12 + 24 >> 2])) break;
  }
  HEAPF32[i19 + 28 >> 2] = Math_fround(Math_fround(f17 + f16) * Math_fround(.5));
  return;
 } while (0);
 f14 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 do if (!(f16 < f14)) {
  if (f16 == f14) {
   f13 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   if (f13 <= Math_fround(HEAPF32[i3 + 24 >> 2])) break;
  }
  f6 = Math_fround(HEAPF32[i10 + 28 >> 2]);
  f1 = Math_fround(f17 - f6);
  f2 = Math_fround(f16 - f17);
  if (Math_fround(f1 + f2) > Math_fround(0.0)) {
   f5 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   f13 = Math_fround(f1 * Math_fround(f5 - Math_fround(HEAPF32[i12 + 24 >> 2])));
   f5 = Math_fround(f13 + Math_fround(f2 * Math_fround(f5 - Math_fround(HEAPF32[i10 + 24 >> 2]))));
  } else f5 = Math_fround(0.0);
  f2 = Math_fround(f14 - f6);
  f1 = Math_fround(f16 - f14);
  if (Math_fround(f2 + f1) > Math_fround(0.0)) {
   f16 = Math_fround(HEAPF32[i3 + 24 >> 2]);
   f13 = Math_fround(f2 * Math_fround(f16 - Math_fround(HEAPF32[i12 + 24 >> 2])));
   f1 = Math_fround(f13 + Math_fround(f1 * Math_fround(f16 - Math_fround(HEAPF32[i10 + 24 >> 2]))));
  } else f1 = Math_fround(0.0);
  f2 = Math_fround(-f1);
  i18 = Math_fround(f5 - f1) < Math_fround(0.0);
  f16 = Math_fround(-f5);
  f2 = i18 ? f1 : f2;
  f1 = i18 ? f16 : f5;
  i18 = f1 < Math_fround(0.0);
  f1 = i18 ? Math_fround(0.0) : f1;
  i18 = f2 < Math_fround(0.0);
  f2 = i18 ? Math_fround(0.0) : f2;
  do if (!(f1 <= f2)) f1 = Math_fround(f14 + Math_fround(Math_fround(f2 / Math_fround(f1 + f2)) * Math_fround(f17 - f14))); else if (f2 == Math_fround(0.0)) {
   f1 = Math_fround(Math_fround(f17 + f14) * Math_fround(.5));
   break;
  } else {
   f1 = Math_fround(f17 + Math_fround(Math_fround(f1 / Math_fround(f1 + f2)) * Math_fround(f14 - f17)));
   break;
  } while (0);
  HEAPF32[i19 + 28 >> 2] = f1;
  return;
 } while (0);
 f5 = Math_fround(f17 - Math_fround(HEAPF32[i10 + 28 >> 2]));
 f13 = Math_fround(f16 - f17);
 f6 = Math_fround(f5 + f13);
 do if (f6 > Math_fround(0.0)) {
  f8 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f1 = Math_fround(HEAPF32[i10 + 24 >> 2]);
  f2 = Math_fround(HEAPF32[i12 + 24 >> 2]);
  if (f5 < f13) {
   f11 = Math_fround(Math_fround(f8 - f1) + Math_fround(Math_fround(f5 / f6) * Math_fround(f1 - f2)));
   break;
  } else {
   f11 = Math_fround(Math_fround(f8 - f2) + Math_fround(Math_fround(f13 / f6) * Math_fround(f2 - f1)));
   break;
  }
 } else f11 = Math_fround(0.0); while (0);
 f6 = Math_fround(f14 - f16);
 f8 = Math_fround(f13 + f6);
 do if (f8 > Math_fround(0.0)) {
  f5 = Math_fround(HEAPF32[i12 + 24 >> 2]);
  f2 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f1 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  if (f13 < f6) {
   f1 = Math_fround(Math_fround(f5 - f2) + Math_fround(Math_fround(f13 / f8) * Math_fround(f2 - f1)));
   break;
  } else {
   f1 = Math_fround(Math_fround(f5 - f1) + Math_fround(Math_fround(f6 / f8) * Math_fround(f1 - f2)));
   break;
  }
 } else f1 = Math_fround(0.0); while (0);
 i18 = Math_fround(f11 + f1) < Math_fround(0.0);
 f14 = Math_fround(-f11);
 f2 = Math_fround(-f1);
 f2 = i18 ? f2 : f1;
 f1 = i18 ? f14 : f11;
 i18 = f1 < Math_fround(0.0);
 f1 = i18 ? Math_fround(0.0) : f1;
 i18 = f2 < Math_fround(0.0);
 f2 = i18 ? Math_fround(0.0) : f2;
 do if (!(f1 <= f2)) f1 = Math_fround(f16 + Math_fround(Math_fround(f2 / Math_fround(f1 + f2)) * Math_fround(f17 - f16))); else if (f2 == Math_fround(0.0)) {
  f1 = Math_fround(Math_fround(f17 + f16) * Math_fround(.5));
  break;
 } else {
  f1 = Math_fround(f17 + Math_fround(Math_fround(f1 / Math_fround(f1 + f2)) * f13));
  break;
 } while (0);
 HEAPF32[i19 + 28 >> 2] = f1;
 return;
}

function __ZL27PxcTestFacesSepAxesBackfaceRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ERfRSB_RjPjSG_fSD_(i6, i66, i70, i71, i1, i67, i63, f2, f3, f5, i61, i68, i62, i73, i74, f60, i72) {
 i6 = i6 | 0;
 i66 = i66 | 0;
 i70 = i70 | 0;
 i71 = i71 | 0;
 i1 = i1 | 0;
 i67 = i67 | 0;
 i63 = i63 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 i61 = i61 | 0;
 i68 = i68 | 0;
 i62 = i62 | 0;
 i73 = i73 | 0;
 i74 = i74 | 0;
 f60 = Math_fround(f60);
 i72 = i72 | 0;
 var i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, f47 = f0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i64 = 0, i65 = 0, i69 = 0, i75 = 0, f76 = f0, f77 = f0, f78 = f0, i79 = 0, i80 = 0, i81 = 0, f82 = f0, i83 = 0, f84 = f0, i85 = 0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i65 = i75 + 16 | 0;
 i64 = i75 + 12 | 0;
 i69 = i75;
 HEAP32[i62 >> 2] = -1;
 i54 = HEAP32[i6 + 16 >> 2] | 0;
 i56 = HEAP32[i6 + 28 >> 2] | 0;
 i57 = HEAP32[i6 + 24 >> 2] | 0;
 i58 = i1 + 36 | 0;
 f48 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * f2);
 i59 = i1 + 40 | 0;
 f47 = Math_fround(Math_fround(HEAPF32[i59 >> 2]) * f2);
 i55 = i1 + 44 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * f2);
 i51 = i1 + 48 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) * f3);
 i52 = i1 + 52 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i52 >> 2]) * f3);
 i53 = i1 + 56 | 0;
 f9 = Math_fround(f48 + f9);
 f10 = Math_fround(f47 + f10);
 f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i53 >> 2]) * f3));
 i49 = i1 + 60 | 0;
 f47 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f5);
 i50 = i1 + 64 | 0;
 f48 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f5);
 i46 = i1 + 68 | 0;
 f47 = Math_fround(f9 + f47);
 f48 = Math_fround(f10 + f48);
 f45 = Math_fround(f45 + Math_fround(Math_fround(HEAPF32[i46 >> 2]) * f5));
 i4 = i54 * 20 | 0;
 if (i4 | 0) {
  i1 = 0;
  do i1 = i1 + 128 | 0; while (i1 >>> 0 < i4 >>> 0);
 }
 L6 : do if (!i54) i1 = i73; else {
  i19 = i69 + 4 | 0;
  i20 = i69 + 8 | 0;
  i21 = i70 + 4 | 0;
  i22 = i70 + 8 | 0;
  i23 = i70 + 12 | 0;
  i24 = i70 + 16 | 0;
  i25 = i70 + 20 | 0;
  i26 = i70 + 24 | 0;
  i27 = i70 + 28 | 0;
  i28 = i70 + 32 | 0;
  i29 = i71 + 4 | 0;
  i30 = i71 + 8 | 0;
  i31 = i71 + 12 | 0;
  i32 = i71 + 16 | 0;
  i33 = i71 + 20 | 0;
  i34 = i71 + 24 | 0;
  i35 = i71 + 28 | 0;
  i36 = i71 + 32 | 0;
  i37 = i72 + 4 | 0;
  i38 = i72 + 8 | 0;
  i39 = i6 + 44 | 0;
  i40 = i6 + 48 | 0;
  i41 = i6 + 52 | 0;
  i42 = i66 + 44 | 0;
  i43 = i66 + 48 | 0;
  i44 = i66 + 52 | 0;
  i13 = i6 + 40 | 0;
  i14 = i66 + 40 | 0;
  i15 = i66 + 64 | 0;
  i16 = i68 + 4 | 0;
  i17 = i68 + 8 | 0;
  i18 = 0;
  i12 = i73;
  while (1) {
   i4 = i57 + (i18 * 20 | 0) | 0;
   f2 = Math_fround(HEAPF32[i4 >> 2]);
   f10 = Math_fround(f47 * f2);
   i6 = i57 + (i18 * 20 | 0) + 4 | 0;
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   f10 = Math_fround(f10 + Math_fround(f48 * f3));
   i11 = i57 + (i18 * 20 | 0) + 8 | 0;
   f5 = Math_fround(HEAPF32[i11 >> 2]);
   if (Math_fround(f10 + Math_fround(f45 * f5)) < Math_fround(0.0)) i1 = i12; else {
    f76 = Math_fround(f2 * Math_fround(HEAPF32[i58 >> 2]));
    f8 = Math_fround(f2 * Math_fround(HEAPF32[i59 >> 2]));
    f7 = Math_fround(f2 * Math_fround(HEAPF32[i55 >> 2]));
    f9 = Math_fround(f3 * Math_fround(HEAPF32[i51 >> 2]));
    f10 = Math_fround(f3 * Math_fround(HEAPF32[i52 >> 2]));
    f9 = Math_fround(f76 + f9);
    f10 = Math_fround(f8 + f10);
    f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i53 >> 2])));
    f2 = Math_fround(f5 * Math_fround(HEAPF32[i49 >> 2]));
    f3 = Math_fround(f5 * Math_fround(HEAPF32[i50 >> 2]));
    f2 = Math_fround(f9 + f2);
    f3 = Math_fround(f10 + f3);
    f5 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i46 >> 2])));
    HEAPF32[i69 >> 2] = f2;
    HEAPF32[i19 >> 2] = f3;
    HEAPF32[i20 >> 2] = f5;
    f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)))));
    if (f7 > Math_fround(0.0)) {
     f76 = Math_fround(Math_fround(1.0) / f7);
     f2 = Math_fround(f2 * f76);
     HEAPF32[i69 >> 2] = f2;
     f3 = Math_fround(f3 * f76);
     HEAPF32[i19 >> 2] = f3;
     f5 = Math_fround(f5 * f76);
     HEAPF32[i20 >> 2] = f5;
    }
    f89 = Math_fround(HEAPF32[i70 >> 2]);
    f9 = Math_fround(f2 * f89);
    f88 = Math_fround(HEAPF32[i21 >> 2]);
    f77 = Math_fround(f2 * f88);
    f84 = Math_fround(HEAPF32[i22 >> 2]);
    f8 = Math_fround(f2 * f84);
    f87 = Math_fround(HEAPF32[i23 >> 2]);
    f90 = Math_fround(f3 * f87);
    f86 = Math_fround(HEAPF32[i24 >> 2]);
    f76 = Math_fround(f3 * f86);
    f82 = Math_fround(HEAPF32[i25 >> 2]);
    f90 = Math_fround(f9 + f90);
    f76 = Math_fround(f77 + f76);
    f8 = Math_fround(f8 + Math_fround(f3 * f82));
    f77 = Math_fround(HEAPF32[i26 >> 2]);
    f9 = Math_fround(f5 * f77);
    f2 = Math_fround(HEAPF32[i27 >> 2]);
    f10 = Math_fround(f5 * f2);
    f78 = Math_fround(HEAPF32[i28 >> 2]);
    f9 = Math_fround(f90 + f9);
    f10 = Math_fround(f76 + f10);
    f8 = Math_fround(f8 + Math_fround(f5 * f78));
    f76 = Math_fround(HEAPF32[i61 >> 2]);
    f84 = Math_fround(Math_fround(Math_fround(f89 * f9) + Math_fround(f88 * f10)) + Math_fround(f84 * f8));
    f82 = Math_fround(Math_fround(Math_fround(f87 * f9) + Math_fround(f86 * f10)) + Math_fround(f82 * f8));
    f78 = Math_fround(Math_fround(Math_fround(f77 * f9) + Math_fround(f2 * f10)) + Math_fround(f78 * f8));
    i85 = (HEAPF32[tempDoublePtr >> 2] = f84, HEAP32[tempDoublePtr >> 2] | 0);
    i83 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
    i81 = (HEAPF32[tempDoublePtr >> 2] = f78, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(f9 * Math_fround(HEAPF32[i71 >> 2]));
    f2 = Math_fround(f2 + Math_fround(f10 * Math_fround(HEAPF32[i29 >> 2])));
    f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i30 >> 2])));
    f77 = Math_fround(f9 * Math_fround(HEAPF32[i31 >> 2]));
    f77 = Math_fround(f77 + Math_fround(f10 * Math_fround(HEAPF32[i32 >> 2])));
    f77 = Math_fround(f77 + Math_fround(f8 * Math_fround(HEAPF32[i33 >> 2])));
    f3 = Math_fround(f9 * Math_fround(HEAPF32[i34 >> 2]));
    f3 = Math_fround(f3 + Math_fround(f10 * Math_fround(HEAPF32[i35 >> 2])));
    f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i36 >> 2])));
    i80 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i79 = (HEAPF32[tempDoublePtr >> 2] = f77, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f9 * Math_fround(HEAPF32[i72 >> 2]));
    f5 = Math_fround(f5 + Math_fround(f10 * Math_fround(HEAPF32[i37 >> 2])));
    f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i38 >> 2])));
    i1 = HEAP32[i44 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
    f84 = Math_fround(f84 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i39 >> 2] | i85 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f82 = Math_fround(f84 + Math_fround(f82 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i40 >> 2] | i83 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
    f78 = Math_fround(f82 + Math_fround(f78 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i41 >> 2] | i81 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
    f2 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i42 >> 2] | i80 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f77 = Math_fround(f2 + Math_fround(f77 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i43 >> 2] | i79 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
    f3 = Math_fround(f77 + Math_fround(f3 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
    f77 = Math_fround(HEAPF32[i13 >> 2]);
    f2 = Math_fround(HEAPF32[i14 >> 2]);
    f2 = Math_fround((f78 > f77 ? f78 : f77) + (f3 > f2 ? f3 : f2));
    f3 = Math_fround(f5 + f2);
    f5 = Math_fround(f2 - f5);
    if (!((f3 < f5 ? f3 : f5) > f76)) {
     i1 = i12 + 4 | 0;
     HEAP32[i12 >> 2] = i18;
     f90 = Math_fround(Math_fround(1.0) / f7);
     i85 = HEAPU8[i57 + (i18 * 20 | 0) + 19 >> 0] | 0;
     f2 = Math_fround(HEAPF32[i4 >> 2]);
     f2 = Math_fround(f2 * Math_fround(HEAPF32[i56 + (i85 * 12 | 0) >> 2]));
     f3 = Math_fround(HEAPF32[i6 >> 2]);
     f3 = Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i56 + (i85 * 12 | 0) + 4 >> 2])));
     f2 = Math_fround(HEAPF32[i11 >> 2]);
     f2 = Math_fround(f90 * Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i56 + (i85 * 12 | 0) + 8 >> 2]))));
     f90 = Math_fround(f90 * Math_fround(HEAPF32[i57 + (i18 * 20 | 0) + 12 >> 2]));
     f3 = Math_fround(-f90);
     mftCall_viiiiii(HEAP32[i15 >> 2] | 0, i66 | 0, i69 | 0, i63 | 0, i67 | 0, i65 | 0, i64 | 0);
     f90 = Math_fround(f60 - f90);
     f5 = Math_fround(HEAPF32[i65 >> 2]);
     if (f90 < f5) break;
     f7 = Math_fround(HEAPF32[i64 >> 2]);
     if (Math_fround(f7 + f60) < f2) break;
     f90 = Math_fround(f3 - f5);
     f2 = Math_fround(f7 - f2);
     f2 = f90 < f2 ? f90 : f2;
     if (f2 < Math_fround(HEAPF32[i61 >> 2])) {
      HEAPF32[i68 >> 2] = f9;
      HEAPF32[i16 >> 2] = f10;
      HEAPF32[i17 >> 2] = f8;
      HEAPF32[i61 >> 2] = f2;
      HEAP32[i62 >> 2] = i18;
     }
    } else i1 = i12;
   }
   i18 = i18 + 1 | 0;
   if (i18 >>> 0 >= i54 >>> 0) break L6; else i12 = i1;
  }
  i85 = 0;
  STACKTOP = i75;
  return i85 | 0;
 } while (0);
 HEAP32[i74 >> 2] = i1 - i73 >> 2;
 i85 = 1;
 STACKTOP = i75;
 return i85 | 0;
}

function __ZN15ReflectionProbe8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i6, i1 + 36 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034151 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380944 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380958 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380976 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380989 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 64 | 0;
 i10 = HEAP32[gb + 37324 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381007 | 0, i10, i6, 0);
 i8 = i2 + 20 | 0;
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i7, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381017 | 0, i10, i6, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i7, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381029 | 0, i7, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381040 | 0, i7, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381050 | 0, i7, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381067 | 0, i7, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381080 | 0, HEAP32[gb + 36980 >> 2] | 0, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381098 | 0, gb + 1048681 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, i7, i6, 4194305);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381112 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381134 | 0, i6, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381150 | 0, i6, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381156 | 0, i6, i1 + 141 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381172 | 0, i6, i1 + 142 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381195 | 0, i6, i1 + 143 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381217 | 0, HEAP32[gb + 37240 >> 2] | 0, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381230 | 0, gb + 944590 | 0, i6, 0);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 124 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381251 | 0, gb + 944590 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i9 = i1 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i1 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
  i2 = i3;
 }
 HEAP32[i6 + 1332 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 1336 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i5 = i4;
 }
 HEAP32[i6 + 1340 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i6 + 1344 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 1348 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1349 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1350 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1351 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1352 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1353 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1354 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1355 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1356 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1357 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1358 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1359 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1360 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1361 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1362 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1363 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1364 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1365 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1366 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1367 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1368 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1369 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1370 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1371 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1372 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1373 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 1374 >> 0] = i1;
 i1 = i6 + 1375 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP32[i9 >> 2] = i3;
  i9 = i7;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx11MeshCleanerC2EjPKNS_6PxVec3EjPKjf(i31, i17, i30, i16, i7, f4) {
 i31 = i31 | 0;
 i17 = i17 | 0;
 i30 = i30 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, f33 = f0, i34 = 0, f35 = f0, f36 = f0, f37 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i32 + 5 | 0;
 i6 = i32 + 4 | 0;
 i18 = i32 + 3 | 0;
 i24 = i32 + 2 | 0;
 i28 = i32 + 1 | 0;
 i29 = i32;
 i1 = i17 * 12 | 0;
 i25 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32 + 9 | 0, i1, gb + 728825 | 0, 61) | 0;
 i26 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32 + 8 | 0, i16 * 12 | 0, gb + 728825 | 0, 64) | 0;
 i27 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32 + 7 | 0, i16 << 2, gb + 728825 | 0, 66) | 0;
 if (f4 != Math_fround(0.0)) {
  i2 = i17 << 2;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32 + 6 | 0, i2, gb + 728825 | 0, 71) | 0;
  f4 = Math_fround(Math_fround(1.0) / f4);
  if (!i17) i22 = i3; else {
   i1 = 0;
   do {
    HEAP32[i3 + (i1 << 2) >> 2] = i1;
    f33 = Math_fround(Math_floor(Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i30 + (i1 * 12 | 0) >> 2])) + Math_fround(.5))));
    f12 = Math_fround(Math_floor(Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i30 + (i1 * 12 | 0) + 4 >> 2])) + Math_fround(.5))));
    f13 = Math_fround(Math_floor(Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i30 + (i1 * 12 | 0) + 8 >> 2])) + Math_fround(.5))));
    HEAPF32[i25 + (i1 * 12 | 0) >> 2] = f33;
    HEAPF32[i25 + (i1 * 12 | 0) + 4 >> 2] = f12;
    HEAPF32[i25 + (i1 * 12 | 0) + 8 >> 2] = f13;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i17 | 0));
   i22 = i3;
  }
 } else {
  _memcpy(i25 | 0, i30 | 0, i1 | 0) | 0;
  i2 = i17 << 2;
  i22 = 0;
 }
 i21 = i16 >>> 0 < i17 >>> 0 ? i17 : i16;
 i19 = i21 >>> 1 | i21;
 i19 = i19 >>> 2 | i19;
 i19 = i19 >>> 4 | i19;
 i19 = i19 >>> 8 | i19;
 i19 = i19 >>> 16 | i19;
 i20 = i19 + 1 | 0;
 i21 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i20 + i21 << 2, gb + 728825 | 0, 90) | 0;
 i15 = i20 << 2;
 _memset(i21 | 0, -1, i15 | 0) | 0;
 i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i2, gb + 728825 | 0, 95) | 0;
 _memset(i11 | 0, -1, i2 | 0) | 0;
 i2 = i16 * 3 | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   i1 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
   if (i1 >>> 0 < i17 >>> 0) HEAP32[i11 + (i1 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 if (!i17) i14 = 0; else if (!i22) {
  i10 = 0;
  i1 = 0;
  while (1) {
   i9 = i11 + (i10 << 2) | 0;
   L19 : do if ((HEAP32[i9 >> 2] | 0) != -1) {
    i3 = HEAP32[i25 + (i10 * 12 | 0) >> 2] | 0;
    i5 = i25 + (i10 * 12 | 0) + 4 | 0;
    i34 = HEAP32[i5 >> 2] | 0;
    i6 = i25 + (i10 * 12 | 0) + 8 | 0;
    i14 = HEAP32[i6 >> 2] | 0;
    i8 = i3 + (i34 * 11 | 0) + (Math_imul(i14, -17) | 0) & 2147483647;
    i8 = i21 + (((i8 >>> 12 ^ i8 ^ i8 >>> 22) & i19) << 2) | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    L21 : do if ((i2 | 0) != -1) {
     while (1) {
      if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) >> 2]) != f4)) if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) + 4 >> 2]) != f12)) if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) + 8 >> 2]) != f13)) break;
      i2 = HEAP32[i21 + (i2 + i20 << 2) >> 2] | 0;
      if ((i2 | 0) == -1) break L21;
     }
     HEAP32[i9 >> 2] = i2;
     break L19;
    } while (0);
    HEAP32[i9 >> 2] = i1;
    HEAP32[i25 + (i1 * 12 | 0) >> 2] = i3;
    HEAP32[i25 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i25 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i21 + (i1 + i20 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while (0);
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i17 | 0)) {
    i14 = i1;
    break;
   }
  }
 } else {
  i10 = 0;
  i1 = 0;
  while (1) {
   i9 = i11 + (i10 << 2) | 0;
   L33 : do if ((HEAP32[i9 >> 2] | 0) != -1) {
    i3 = HEAP32[i25 + (i10 * 12 | 0) >> 2] | 0;
    i5 = i25 + (i10 * 12 | 0) + 4 | 0;
    i14 = HEAP32[i5 >> 2] | 0;
    i6 = i25 + (i10 * 12 | 0) + 8 | 0;
    i34 = HEAP32[i6 >> 2] | 0;
    i8 = i3 + (i14 * 11 | 0) + (Math_imul(i34, -17) | 0) & 2147483647;
    i8 = i21 + (((i8 >>> 12 ^ i8 ^ i8 >>> 22) & i19) << 2) | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    L35 : do if ((i2 | 0) != -1) {
     while (1) {
      if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) >> 2]) != f4)) if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) + 4 >> 2]) != f12)) if (!(Math_fround(HEAPF32[i25 + (i2 * 12 | 0) + 8 >> 2]) != f13)) break;
      i2 = HEAP32[i21 + (i2 + i20 << 2) >> 2] | 0;
      if ((i2 | 0) == -1) break L35;
     }
     HEAP32[i9 >> 2] = i2;
     break L33;
    } while (0);
    HEAP32[i9 >> 2] = i1;
    HEAP32[i25 + (i1 * 12 | 0) >> 2] = i3;
    HEAP32[i25 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i25 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i22 + (i1 << 2) >> 2] = i10;
    HEAP32[i21 + (i1 + i20 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while (0);
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == (i17 | 0)) {
    i14 = i1;
    break;
   }
  }
 }
 if (!i16) i1 = 0; else {
  i8 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = HEAP32[i7 + 8 >> 2] | 0;
   i7 = i7 + 12 | 0;
   if (i2 >>> 0 < i17 >>> 0 & i3 >>> 0 < i17 >>> 0 & i5 >>> 0 < i17 >>> 0) {
    f12 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) >> 2]);
    f36 = Math_fround(f12 - Math_fround(HEAPF32[i30 + (i3 * 12 | 0) >> 2]));
    f35 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(f35 - Math_fround(HEAPF32[i30 + (i3 * 12 | 0) + 4 >> 2]));
    f33 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) + 8 >> 2]);
    f37 = Math_fround(f33 - Math_fround(HEAPF32[i30 + (i3 * 12 | 0) + 8 >> 2]));
    f12 = Math_fround(f12 - Math_fround(HEAPF32[i30 + (i5 * 12 | 0) >> 2]));
    f35 = Math_fround(f35 - Math_fround(HEAPF32[i30 + (i5 * 12 | 0) + 4 >> 2]));
    f33 = Math_fround(f33 - Math_fround(HEAPF32[i30 + (i5 * 12 | 0) + 8 >> 2]));
    f13 = Math_fround(Math_fround(f4 * f33) - Math_fround(f37 * f35));
    f33 = Math_fround(Math_fround(f37 * f12) - Math_fround(f36 * f33));
    f12 = Math_fround(Math_fround(f36 * f35) - Math_fround(f4 * f12));
    if (!(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f13 * f13) + Math_fround(f33 * f33))) == Math_fround(0.0))) {
     i6 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
     i3 = HEAP32[i11 + (i3 << 2) >> 2] | 0;
     i2 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
     if (!((i2 | 0) == (i6 | 0) | ((i6 | 0) == (i3 | 0) | (i3 | 0) == (i2 | 0)))) {
      i34 = i1 * 3 | 0;
      HEAP32[i26 + (i34 << 2) >> 2] = i6;
      HEAP32[i26 + (i34 + 1 << 2) >> 2] = i3;
      HEAP32[i26 + (i34 + 2 << 2) >> 2] = i2;
      HEAP32[i27 + (i1 << 2) >> 2] = i8;
      i1 = i1 + 1 | 0;
     }
    }
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i16 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, i11);
 _memset(i21 | 0, -1, i15 | 0) | 0;
 if (!i1) {
  i3 = 1;
  i2 = 0;
 } else {
  i11 = 0;
  i3 = 1;
  i2 = 0;
  do {
   i9 = i26 + (i11 * 12 | 0) | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[i26 + (i11 * 12 | 0) + 4 >> 2] | 0;
   i8 = HEAP32[i26 + (i11 * 12 | 0) + 8 >> 2] | 0;
   i5 = i6 - i7 - i8 ^ i8 >>> 13;
   i10 = i7 - i8 - i5 ^ i5 << 8;
   i34 = i8 - i5 - i10 ^ i10 >>> 13;
   i5 = i5 - i10 - i34 ^ i34 >>> 12;
   i10 = i10 - i34 - i5 ^ i5 << 16;
   i34 = i34 - i5 - i10 ^ i10 >>> 5;
   i5 = i5 - i10 - i34 ^ i34 >>> 3;
   i10 = i10 - i34 - i5 ^ i5 << 10;
   i10 = i21 + (((i34 - i5 - i10 ^ i10 >>> 15) & i19) << 2) | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   L58 : do if ((i5 | 0) == -1) i23 = 41; else while (1) {
    if ((HEAP32[i26 + (i5 * 12 | 0) >> 2] | 0) == (i6 | 0)) if ((HEAP32[i26 + (i5 * 12 | 0) + 4 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i26 + (i5 * 12 | 0) + 8 >> 2] | 0) == (i8 | 0)) break L58;
    i5 = HEAP32[i21 + (i5 + i20 << 2) >> 2] | 0;
    if ((i5 | 0) == -1) {
     i23 = 41;
     break;
    }
   } while (0);
   if ((i23 | 0) == 41) {
    i23 = 0;
    i34 = HEAP32[i27 + (i11 << 2) >> 2] | 0;
    HEAP32[i27 + (i2 << 2) >> 2] = i34;
    i18 = i26 + (i2 * 12 | 0) | 0;
    HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i21 + (i2 + i20 << 2) >> 2] = HEAP32[i10 >> 2];
    HEAP32[i10 >> 2] = i2;
    i3 = i3 & (i34 | 0) == (i2 | 0);
    i2 = i2 + 1 | 0;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i1 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i21);
 if (i22 | 0) {
  if (i14 | 0) {
   i1 = 0;
   do {
    i34 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
    HEAP32[i25 + (i1 * 12 | 0) >> 2] = HEAP32[i30 + (i34 * 12 | 0) >> 2];
    HEAP32[i25 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i30 + (i34 * 12 | 0) + 4 >> 2];
    HEAP32[i25 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i30 + (i34 * 12 | 0) + 8 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, i22);
 }
 HEAP32[i31 >> 2] = i14;
 HEAP32[i31 + 4 >> 2] = i2;
 HEAP32[i31 + 8 >> 2] = i25;
 HEAP32[i31 + 12 >> 2] = i26;
 if (i3) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i29, i27);
  HEAP32[i31 + 16 >> 2] = 0;
  STACKTOP = i32;
  return;
 } else {
  HEAP32[i31 + 16 >> 2] = i27;
  STACKTOP = i32;
  return;
 }
}

function __ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b(i6, i1, i3, i5, i2, i4, i36) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i36 = i36 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i37 = 0, f38 = f0, f39 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37 + 36 | 0;
 i7 = i37;
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i1 >> 2]));
 f20 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f34 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f34 = Math_fround(f34 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f32 = Math_fround(f26 * Math_fround(HEAPF32[i3 >> 2]));
 f32 = Math_fround(f32 + Math_fround(f20 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f32 = Math_fround(f32 + Math_fround(f34 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f33 = Math_fround(f26 * Math_fround(HEAPF32[i3 + 12 >> 2]));
 f33 = Math_fround(f33 + Math_fround(f20 * Math_fround(HEAPF32[i3 + 16 >> 2])));
 f33 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i3 + 20 >> 2])));
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 f20 = Math_fround(f26 + Math_fround(f20 * Math_fround(HEAPF32[i3 + 28 >> 2])));
 f34 = Math_fround(f20 + Math_fround(f34 * Math_fround(HEAPF32[i3 + 32 >> 2])));
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f30 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f29 * f20) + Math_fround(f22 * f26)) + Math_fround(f31 * f27));
 HEAPF32[i35 >> 2] = f19;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f19))) + Math_fround(9.99999997e-07));
 f19 = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(f22 * f25)) + Math_fround(f31 * f24));
 HEAPF32[i35 + 4 >> 2] = f19;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f19))) + Math_fround(9.99999997e-07));
 f31 = Math_fround(Math_fround(Math_fround(f29 * f23) + Math_fround(f22 * f21)) + Math_fround(f31 * f30));
 HEAPF32[i35 + 8 >> 2] = f31;
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f31))) + Math_fround(9.99999997e-07));
 f31 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f31 * f20) + Math_fround(f22 * f26)) + Math_fround(f29 * f27));
 HEAPF32[i35 + 12 >> 2] = f19;
 HEAPF32[i7 + 12 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f19))) + Math_fround(9.99999997e-07));
 f19 = Math_fround(Math_fround(Math_fround(f31 * f28) + Math_fround(f22 * f25)) + Math_fround(f29 * f24));
 HEAPF32[i35 + 16 >> 2] = f19;
 HEAPF32[i7 + 16 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f19))) + Math_fround(9.99999997e-07));
 f29 = Math_fround(Math_fround(Math_fround(f31 * f23) + Math_fround(f22 * f21)) + Math_fround(f29 * f30));
 HEAPF32[i35 + 20 >> 2] = f29;
 HEAPF32[i7 + 20 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f29))) + Math_fround(9.99999997e-07));
 f29 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f27 = Math_fround(Math_fround(Math_fround(f29 * f20) + Math_fround(f22 * f26)) + Math_fround(f31 * f27));
 HEAPF32[i35 + 24 >> 2] = f27;
 HEAPF32[i7 + 24 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f27))) + Math_fround(9.99999997e-07));
 f24 = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(f22 * f25)) + Math_fround(f31 * f24));
 HEAPF32[i35 + 28 >> 2] = f24;
 HEAPF32[i7 + 28 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f24))) + Math_fround(9.99999997e-07));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f23) + Math_fround(f22 * f21)) + Math_fround(f31 * f30));
 HEAPF32[i35 + 32 >> 2] = f30;
 HEAPF32[i7 + 32 >> 2] = Math_fround(Math_fround(Math_abs(Math_fround(f30))) + Math_fround(9.99999997e-07));
 f30 = Math_fround(HEAPF32[i5 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(HEAPF32[i7 >> 2]);
 f29 = Math_fround(f30 * f23);
 f24 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f29 = Math_fround(f29 + Math_fround(f31 * f24));
 f25 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f32))) > Math_fround(f22 + Math_fround(f29 + Math_fround(f21 * f25)))) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 f26 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f20 = Math_fround(f30 * f27);
 f28 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f31 * f28));
 f29 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f33))) > Math_fround(f26 + Math_fround(f20 + Math_fround(f21 * f29)))) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 f18 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f17 = Math_fround(f30 * f20);
 f19 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f31 * f19));
 f14 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f34))) > Math_fround(f18 + Math_fround(f17 + Math_fround(f21 * f14)))) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 f17 = Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(f26 * f27)) + Math_fround(f18 * f20));
 f16 = Math_fround(HEAPF32[i35 >> 2]);
 f15 = Math_fround(f32 * f16);
 f12 = Math_fround(HEAPF32[i35 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f33 * f12));
 f13 = Math_fround(HEAPF32[i35 + 24 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f15 + Math_fround(f34 * f13)))) > Math_fround(f30 + f17)) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 f17 = Math_fround(Math_fround(Math_fround(f22 * f24) + Math_fround(f26 * f28)) + Math_fround(f18 * f19));
 f9 = Math_fround(HEAPF32[i35 + 4 >> 2]);
 f15 = Math_fround(f32 * f9);
 f10 = Math_fround(HEAPF32[i35 + 16 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f33 * f10));
 f11 = Math_fround(HEAPF32[i35 + 28 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f15 + Math_fround(f34 * f11)))) > Math_fround(f31 + f17)) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 f38 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f26 * f29)) + Math_fround(f18 * f14));
 f17 = Math_fround(HEAPF32[i35 + 8 >> 2]);
 f39 = Math_fround(f32 * f17);
 f15 = Math_fround(HEAPF32[i35 + 20 >> 2]);
 f39 = Math_fround(f39 + Math_fround(f33 * f15));
 f8 = Math_fround(HEAPF32[i35 + 32 >> 2]);
 if (Math_fround(Math_abs(Math_fround(f39 + Math_fround(f34 * f8)))) > Math_fround(f21 + f38)) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 if (i36) {
  if (Math_fround(Math_abs(Math_fround(Math_fround(f34 * f12) - Math_fround(f33 * f13)))) > Math_fround(Math_fround(Math_fround(f26 * f20) + Math_fround(f18 * f27)) + Math_fround(Math_fround(f31 * f25) + Math_fround(f21 * f24)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f34 * f10) - Math_fround(f33 * f11)))) > Math_fround(Math_fround(Math_fround(f26 * f19) + Math_fround(f18 * f28)) + Math_fround(Math_fround(f25 * f30) + Math_fround(f21 * f23)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f34 * f15) - Math_fround(f33 * f8)))) > Math_fround(Math_fround(Math_fround(f24 * f30) + Math_fround(f31 * f23)) + Math_fround(Math_fround(f26 * f14) + Math_fround(f18 * f29)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f13 * f32) - Math_fround(f34 * f16)))) > Math_fround(Math_fround(Math_fround(f21 * f28) + Math_fround(f31 * f29)) + Math_fround(Math_fround(f18 * f23) + Math_fround(f20 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f11 * f32) - Math_fround(f34 * f9)))) > Math_fround(Math_fround(Math_fround(f27 * f21) + Math_fround(f30 * f29)) + Math_fround(Math_fround(f18 * f24) + Math_fround(f19 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f8 * f32) - Math_fround(f34 * f17)))) > Math_fround(Math_fround(Math_fround(f27 * f31) + Math_fround(f28 * f30)) + Math_fround(Math_fround(f18 * f25) + Math_fround(f14 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f33 * f16) - Math_fround(f12 * f32)))) > Math_fround(Math_fround(Math_fround(f21 * f19) + Math_fround(f31 * f14)) + Math_fround(Math_fround(f26 * f23) + Math_fround(f27 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f33 * f9) - Math_fround(f10 * f32)))) > Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(f30 * f14)) + Math_fround(Math_fround(f26 * f24) + Math_fround(f28 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
  if (Math_fround(Math_abs(Math_fround(Math_fround(f33 * f17) - Math_fround(f15 * f32)))) > Math_fround(Math_fround(Math_fround(f20 * f31) + Math_fround(f19 * f30)) + Math_fround(Math_fround(f26 * f25) + Math_fround(f29 * f22)))) {
   i36 = 0;
   STACKTOP = i37;
   return i36 | 0;
  }
 }
 i36 = 1;
 STACKTOP = i37;
 return i36 | 0;
}

function __ZNSt3__2L10__init_patIwEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_(i9, i17, i1, i2, i11, i12) {
 i9 = i9 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i19 + 28 | 0;
 i7 = i19 + 24 | 0;
 i6 = i19 + 20 | 0;
 i13 = i19 + 16 | 0;
 i14 = i19 + 12 | 0;
 i15 = i19 + 8 | 0;
 i16 = i19 + 4 | 0;
 i10 = i19;
 if (i1) {
  i5 = HEAP8[i17 + 8 + 3 >> 0] | 0;
  i5 = ((i5 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i5 & 255) | 0) == 4;
 } else i5 = 0;
 L4 : do switch (i2 << 24 >> 24 | 0) {
 case 0:
  {
   if (i5) {
    i2 = HEAP8[i17 + 8 + 3 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    i1 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
    i2 = i3 ? HEAP32[i17 + 4 >> 2] | 0 : i2 & 255;
    i3 = i1;
    i4 = i1 + (i2 << 2) | 0;
    if ((i2 | 0) != 3) if ((i2 | 0) == 4) {
     HEAP32[i13 >> 2] = i3;
     HEAP32[i14 >> 2] = i4;
     HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
     __ZNSt3__214__rotate_rightINS_11__wrap_iterIPwEEEET_S4_S4_(i7, i8) | 0;
    } else {
     HEAP32[i15 >> 2] = i3;
     HEAP32[i16 >> 2] = i1 + 12;
     HEAP32[i10 >> 2] = i4;
     HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
     __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPwEEEET_S4_S4_S4_(i6, i7, i8) | 0;
    }
   }
   switch (i12 << 24 >> 24 | 0) {
   case 0:
    {
     HEAP8[i9 >> 0] = 3;
     HEAP8[i9 + 1 >> 0] = 4;
     HEAP8[i9 + 2 >> 0] = 0;
     HEAP8[i9 + 3 >> 0] = 2;
     switch (i11 << 24 >> 24 | 0) {
     case 2:
     case 0:
      break L4;
     case 1:
      break;
     default:
      {
       i18 = 75;
       break L4;
      }
     }
     if (i5) break L4;
     __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
     break L4;
    }
   case 1:
    {
     HEAP8[i9 >> 0] = 3;
     HEAP8[i9 + 3 >> 0] = 2;
     switch (i11 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i9 + 1 >> 0] = 4;
       HEAP8[i9 + 2 >> 0] = 0;
       break L4;
      }
     case 1:
      {
       HEAP8[i9 + 1 >> 0] = 4;
       HEAP8[i9 + 2 >> 0] = 0;
       if (i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i9 + 1 >> 0] = 1;
       HEAP8[i9 + 2 >> 0] = 4;
       if (!i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 2:
    {
     HEAP8[i9 >> 0] = 4;
     HEAP8[i9 + 3 >> 0] = 3;
     switch (i11 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i9 + 1 >> 0] = 0;
       HEAP8[i9 + 2 >> 0] = 2;
       break L4;
      }
     case 1:
      {
       if (!i5) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
       HEAP8[i9 + 1 >> 0] = 0;
       HEAP8[i9 + 2 >> 0] = 2;
       break L4;
      }
     case 2:
      {
       HEAP8[i9 + 1 >> 0] = 2;
       HEAP8[i9 + 2 >> 0] = 1;
       if (!i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 3:
    {
     HEAP8[i9 >> 0] = 4;
     HEAP8[i9 + 3 >> 0] = 2;
     switch (i11 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i9 + 1 >> 0] = 0;
       HEAP8[i9 + 2 >> 0] = 3;
       break L4;
      }
     case 1:
      {
       HEAP8[i9 + 1 >> 0] = 1;
       HEAP8[i9 + 2 >> 0] = 3;
       if (!i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i9 + 1 >> 0] = 3;
       HEAP8[i9 + 2 >> 0] = 0;
       if (i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 4:
    {
     HEAP8[i9 >> 0] = 4;
     HEAP8[i9 + 3 >> 0] = 3;
     switch (i11 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i9 + 1 >> 0] = 0;
       HEAP8[i9 + 2 >> 0] = 2;
       break L4;
      }
     case 1:
      {
       HEAP8[i9 + 1 >> 0] = 0;
       HEAP8[i9 + 2 >> 0] = 2;
       if (i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i9 + 1 >> 0] = 2;
       HEAP8[i9 + 2 >> 0] = 1;
       if (!i5) break L4;
       __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   default:
    {
     i18 = 75;
     break L4;
    }
   }
  }
 case 1:
  switch (i12 << 24 >> 24 | 0) {
  case 0:
   {
    HEAP8[i9 >> 0] = 3;
    HEAP8[i9 + 1 >> 0] = 2;
    HEAP8[i9 + 2 >> 0] = 0;
    HEAP8[i9 + 3 >> 0] = 4;
    switch (i11 << 24 >> 24 | 0) {
    case 2:
    case 0:
     break L4;
    case 1:
     break;
    default:
     {
      i18 = 75;
      break L4;
     }
    }
    if (i5) break L4;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i17, 0, 1, 32) | 0;
    break L4;
   }
  case 1:
   {
    HEAP8[i9 >> 0] = 3;
    HEAP8[i9 + 3 >> 0] = 4;
    switch (i11 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i9 + 1 >> 0] = 2;
      HEAP8[i9 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i9 + 1 >> 0] = 2;
      HEAP8[i9 + 2 >> 0] = 0;
      if (i5) break L4;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i9 + 1 >> 0] = 1;
      HEAP8[i9 + 2 >> 0] = 2;
      if (!i5) break L4;
      i1 = i17 + 8 + 3 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP32[(HEAP32[i17 >> 2] | 0) + (i16 << 2) >> 2] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP32[i17 + (i16 << 2) >> 2] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 2:
   {
    HEAP8[i9 >> 0] = 2;
    HEAP8[i9 + 3 >> 0] = 3;
    switch (i11 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i9 + 1 >> 0] = 0;
      HEAP8[i9 + 2 >> 0] = 4;
      break L4;
     }
    case 1:
     {
      HEAP8[i9 + 1 >> 0] = 0;
      HEAP8[i9 + 2 >> 0] = 4;
      if (i5) break L4;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i9 + 1 >> 0] = 4;
      HEAP8[i9 + 2 >> 0] = 1;
      if (!i5) break L4;
      i1 = i17 + 8 + 3 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP32[(HEAP32[i17 >> 2] | 0) + (i16 << 2) >> 2] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP32[i17 + (i16 << 2) >> 2] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 3:
   {
    HEAP8[i9 >> 0] = 3;
    HEAP8[i9 + 3 >> 0] = 4;
    switch (i11 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i9 + 1 >> 0] = 2;
      HEAP8[i9 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i9 + 1 >> 0] = 2;
      HEAP8[i9 + 2 >> 0] = 0;
      if (i5) break L4;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i9 + 1 >> 0] = 1;
      HEAP8[i9 + 2 >> 0] = 2;
      if (!i5) break L4;
      i1 = i17 + 8 + 3 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP32[(HEAP32[i17 >> 2] | 0) + (i16 << 2) >> 2] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP32[i17 + (i16 << 2) >> 2] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 4:
   {
    HEAP8[i9 >> 0] = 2;
    HEAP8[i9 + 3 >> 0] = 4;
    switch (i11 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i9 + 1 >> 0] = 3;
      HEAP8[i9 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i9 + 1 >> 0] = 3;
      HEAP8[i9 + 2 >> 0] = 1;
      if (!i5) break L4;
      i1 = i17 + 8 + 3 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP32[(HEAP32[i17 >> 2] | 0) + (i16 << 2) >> 2] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP32[i17 + (i16 << 2) >> 2] = 0;
       break L4;
      }
     }
    case 2:
     {
      HEAP8[i9 + 1 >> 0] = 0;
      HEAP8[i9 + 2 >> 0] = 3;
      if (i5) break L4;
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i17, 32);
      break L4;
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  default:
   {
    i18 = 75;
    break L4;
   }
  }
 default:
  i18 = 75;
 } while (0);
 if ((i18 | 0) == 75) {
  HEAP8[i9 >> 0] = 2;
  HEAP8[i9 + 1 >> 0] = 3;
  HEAP8[i9 + 2 >> 0] = 0;
  HEAP8[i9 + 3 >> 0] = 4;
 }
 STACKTOP = i19;
 return;
}

function __ZN5physx12PxcLtbFactorERNS_9PxcFsDataE(i47) {
 i47 = i47 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i48 + 384 | 0;
 i46 = i48 + 336 | 0;
 i5 = i48 + 288 | 0;
 i6 = i48 + 144 | 0;
 i15 = i48;
 i43 = HEAPU16[i47 + 24 >> 1] | 0;
 i44 = i47 + i43 | 0;
 i1 = (HEAPU16[i47 + 8 >> 1] | 0) + -1 | 0;
 if (i1 | 0) {
  i7 = i5 + 4 | 0;
  i8 = i5 + 8 | 0;
  i9 = i5 + 16 | 0;
  i10 = i5 + 20 | 0;
  i11 = i5 + 24 | 0;
  i12 = i5 + 32 | 0;
  i13 = i5 + 36 | 0;
  i14 = i5 + 40 | 0;
  i16 = i46 + 4 | 0;
  i17 = i46 + 8 | 0;
  i18 = i46 + 12 | 0;
  i19 = i46 + 16 | 0;
  i20 = i46 + 20 | 0;
  i21 = i46 + 24 | 0;
  i22 = i46 + 28 | 0;
  i23 = i46 + 32 | 0;
  i24 = i46 + 36 | 0;
  i25 = i46 + 40 | 0;
  i26 = i46 + 44 | 0;
  i27 = i45 + 16 | 0;
  i28 = i45 + 32 | 0;
  i29 = i45 + 48 | 0;
  i30 = i45 + 64 | 0;
  i31 = i45 + 80 | 0;
  i32 = i45 + 96 | 0;
  i33 = i45 + 112 | 0;
  i34 = i45 + 128 | 0;
  i35 = i6 + 16 | 0;
  i36 = i6 + 32 | 0;
  i37 = i6 + 48 | 0;
  i38 = i6 + 64 | 0;
  i39 = i6 + 80 | 0;
  i40 = i6 + 96 | 0;
  i41 = i6 + 112 | 0;
  i42 = i6 + 128 | 0;
  do {
   i2 = HEAPU8[i47 + 64 + i1 >> 0] | 0;
   i3 = i44 + (i1 * 400 | 0) | 0;
   __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i45, i3);
   i4 = i44 + (i1 * 400 | 0) + 240 | 0;
   __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i5, i45, i4, i4);
   f58 = Math_fround(HEAPF32[i5 >> 2]);
   f56 = Math_fround(HEAPF32[i7 >> 2]);
   f52 = Math_fround(HEAPF32[i8 >> 2]);
   f49 = Math_fround(HEAPF32[i9 >> 2]);
   f57 = Math_fround(HEAPF32[i10 >> 2]);
   f53 = Math_fround(HEAPF32[i11 >> 2]);
   f59 = Math_fround(HEAPF32[i12 >> 2]);
   f50 = Math_fround(HEAPF32[i13 >> 2]);
   f60 = Math_fround(HEAPF32[i14 >> 2]);
   f54 = Math_fround(Math_fround(f57 * f60) - Math_fround(f53 * f50));
   f53 = Math_fround(Math_fround(f53 * f59) - Math_fround(f49 * f60));
   f51 = Math_fround(Math_fround(f49 * f50) - Math_fround(f57 * f59));
   f55 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(-Math_fround(f56 * f53)) - Math_fround(f58 * f54)) - Math_fround(f52 * f51)));
   f53 = Math_fround(f55 * f53);
   f51 = Math_fround(f51 * f55);
   f52 = Math_fround(f55 * Math_fround(Math_fround(f58 * f60) - Math_fround(f52 * f59)));
   f50 = Math_fround(f55 * Math_fround(Math_fround(f56 * f59) - Math_fround(f58 * f50)));
   f49 = Math_fround(Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f49)) * f55);
   HEAPF32[i46 >> 2] = Math_fround(f55 * f54);
   HEAPF32[i16 >> 2] = f53;
   HEAPF32[i17 >> 2] = f51;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = f53;
   HEAPF32[i20 >> 2] = f52;
   HEAPF32[i21 >> 2] = f50;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   HEAPF32[i23 >> 2] = f51;
   HEAPF32[i24 >> 2] = f50;
   HEAPF32[i25 >> 2] = f49;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAP32[i3 >> 2] = HEAP32[i45 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 16 | 0;
   HEAP32[i3 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 32 | 0;
   HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 48 | 0;
   HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 64 | 0;
   HEAP32[i3 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 80 | 0;
   HEAP32[i3 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 96 | 0;
   HEAP32[i3 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 112 | 0;
   HEAP32[i3 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   i3 = i44 + (i1 * 400 | 0) + 128 | 0;
   HEAP32[i3 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) | 0;
   i4 = i44 + (i1 * 400 | 0) + 144 | 0;
   __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_(i6, i3, i46, i4, i4);
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 16 | 0;
   HEAP32[i3 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 32 | 0;
   HEAP32[i3 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 48 | 0;
   HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 64 | 0;
   HEAP32[i3 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 80 | 0;
   HEAP32[i3 >> 2] = HEAP32[i39 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 96 | 0;
   HEAP32[i3 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   i3 = i44 + (i2 * 400 | 0) + 112 | 0;
   HEAP32[i3 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
   i2 = i44 + (i2 * 400 | 0) + 128 | 0;
   HEAP32[i2 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   i2 = i44 + (i1 * 400 | 0) + 336 | 0;
   i3 = i46;
   i4 = i2 + 48 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
 }
 __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i15, i44);
 HEAP32[i44 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i44 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i46 = i47 + (i43 + 16) | 0;
 i45 = i15 + 16 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 32) | 0;
 i45 = i15 + 32 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 48) | 0;
 i45 = i15 + 48 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 64) | 0;
 i45 = i15 + 64 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 80) | 0;
 i45 = i15 + 80 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 96) | 0;
 i45 = i15 + 96 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i46 = i47 + (i43 + 112) | 0;
 i45 = i15 + 112 | 0;
 HEAP32[i46 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
 i47 = i47 + (i43 + 128) | 0;
 i46 = i15 + 128 | 0;
 HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
 STACKTOP = i48;
 return;
}

function _getifaddrs(i34) {
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 1728 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i35 + 80 | 0;
 i14 = i35 + 72 | 0;
 i13 = i35 + 64 | 0;
 i16 = i35 + 56 | 0;
 i15 = i35 + 48 | 0;
 i12 = i35 + 40 | 0;
 i31 = i35;
 i22 = i35 + 1208 | 0;
 i23 = i35 + 1184 | 0;
 i24 = i35 + 1180 | 0;
 i25 = i35 + 1176 | 0;
 i26 = i35 + 1172 | 0;
 i27 = i35 + 1188 | 0;
 i28 = i35 + 1144 | 0;
 i29 = i35 + 1140 | 0;
 i30 = i35 + 1136 | 0;
 i11 = i35 + 112 | 0;
 i4 = i35 + 104 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 i3 = _if_nameindex() | 0;
 if (!i3) i1 = -1; else {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == 0 ? (HEAP32[i3 + (i1 << 3) >> 2] | 0) == 0 : 0) {
    i33 = 5;
    break;
   }
   if (!(_list_add(i29, i30, i2) | 0)) {
    i33 = 4;
    break;
   } else i1 = i1 + 1 | 0;
  }
  L5 : do if ((i33 | 0) == 4) {
   _if_freenameindex(i3);
   i33 = 49;
  } else if ((i33 | 0) == 5) {
   _if_freenameindex(i3);
   i10 = _socket(2, 524290, 0) | 0;
   if ((i10 | 0) == -1) i33 = 49; else {
    HEAP32[i4 >> 2] = 1024;
    HEAP32[i4 + 4 >> 2] = i11;
    HEAP32[i31 >> 2] = i4;
    do if ((_ioctl(i10, 35090, i31) | 0) != -1) {
     i5 = (HEAP32[i4 >> 2] | 0) >>> 5;
     i1 = HEAP32[i29 >> 2] | 0;
     HEAP32[i30 >> 2] = i1;
     i6 = (i1 | 0) == 0;
     if (i6) {
      _close(i10) | 0;
      HEAP32[i30 >> 2] = i1;
      i2 = 0;
     } else {
      i7 = (i5 | 0) == 0;
      i8 = i31 + 16 | 0;
      i2 = i1;
      do {
       i9 = i2;
       i4 = i2;
       L15 : do if (!i7) {
        i3 = i9 + 112 | 0;
        i2 = 0;
        while (1) {
         if (!(_strcmp(i11 + (i2 << 5) | 0, i3) | 0)) break;
         i2 = i2 + 1 | 0;
         if (i2 >>> 0 >= i5 >>> 0) break L15;
        }
        i21 = i9 + 28 | 0;
        i20 = i11 + (i2 << 5) + 16 | 0;
        HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
        HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
        HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
        HEAP32[i21 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
        HEAP32[i9 + 12 >> 2] = i21;
       } while (0);
       HEAP32[i12 >> 2] = i9 + 112;
       _snprintf(i31, 16, gb + 1074693 | 0, i12) | 0;
       HEAP32[i15 >> 2] = i31;
       if ((_ioctl(i10, 35091, i15) | 0) == -1) {
        i33 = 24;
        break;
       }
       i2 = HEAP16[i8 >> 1] | 0;
       i3 = i9 + 8 | 0;
       HEAP32[i3 >> 2] = i2;
       if (HEAP32[i9 + 12 >> 2] | 0) {
        HEAP32[i3 >> 2] = i2 | 65536;
        HEAP32[i16 >> 2] = i31;
        if ((_ioctl(i10, 35099, i16) | 0) == -1) {
         i33 = 24;
         break;
        }
        i21 = i9 + 56 | 0;
        HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
        HEAP32[i21 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
        HEAP32[i21 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
        HEAP32[i21 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
        HEAP32[i9 + 16 >> 2] = i21;
        if (!(HEAP32[i9 + 8 >> 2] & 16)) {
         HEAP32[i14 >> 2] = i31;
         if ((_ioctl(i10, 35097, i14) | 0) == -1) {
          i33 = 24;
          break;
         }
         i21 = i9 + 84 | 0;
         HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
         HEAP32[i21 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
         HEAP32[i21 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
         HEAP32[i21 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
        } else {
         HEAP32[i13 >> 2] = i31;
         if ((_ioctl(i10, 35095, i13) | 0) == -1) {
          i33 = 24;
          break;
         }
         i21 = i9 + 84 | 0;
         HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
         HEAP32[i21 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
         HEAP32[i21 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
         HEAP32[i21 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
        }
        HEAP32[i9 + 20 >> 2] = i9 + 84;
       }
       i2 = HEAP32[i4 >> 2] | 0;
       HEAP32[i30 >> 2] = i2;
      } while ((i2 | 0) != 0);
      if ((i33 | 0) == 24) break;
      _close(i10) | 0;
      HEAP32[i30 >> 2] = i1;
      if (i6) i2 = 0; else {
       i2 = i1;
       while (1) {
        i3 = HEAP32[i2 >> 2] | 0;
        HEAP32[i30 >> 2] = i3;
        if (!i3) break; else i2 = i3;
       }
      }
     }
     HEAP32[i30 >> 2] = i2;
     i21 = _fopen(gb + 1074099 | 0, gb + 1074118 | 0) | 0;
     if (i21) {
      i2 = _fgets(i22, 512, i21) | 0;
      L42 : do if (i2) {
       i4 = i28 + 8 | 0;
       i5 = i28 + 8 | 0;
       i6 = i31 + 4 | 0;
       i7 = i31 + 5 | 0;
       i8 = i31 + 9 | 0;
       i9 = i31 + 10 | 0;
       i10 = i31 + 14 | 0;
       i11 = i31 + 15 | 0;
       i12 = i31 + 19 | 0;
       i13 = i31 + 20 | 0;
       i14 = i31 + 24 | 0;
       i15 = i31 + 25 | 0;
       i16 = i31 + 29 | 0;
       i17 = i31 + 30 | 0;
       i18 = i31 + 34 | 0;
       i19 = i31 + 35 | 0;
       i20 = i31 + 39 | 0;
       L44 : while (1) {
        HEAP32[i31 >> 2] = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
        HEAP8[i6 >> 0] = 58;
        i3 = i2 + 4 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP8[i7 >> 0] = i3;
        HEAP8[i7 + 1 >> 0] = i3 >> 8;
        HEAP8[i7 + 2 >> 0] = i3 >> 16;
        HEAP8[i7 + 3 >> 0] = i3 >> 24;
        HEAP8[i8 >> 0] = 58;
        i3 = i2 + 8 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP16[i9 >> 1] = i3;
        HEAP16[i9 + 2 >> 1] = i3 >>> 16;
        HEAP8[i10 >> 0] = 58;
        i3 = i2 + 12 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP8[i11 >> 0] = i3;
        HEAP8[i11 + 1 >> 0] = i3 >> 8;
        HEAP8[i11 + 2 >> 0] = i3 >> 16;
        HEAP8[i11 + 3 >> 0] = i3 >> 24;
        HEAP8[i12 >> 0] = 58;
        i3 = i2 + 16 | 0;
        HEAP32[i13 >> 2] = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP8[i14 >> 0] = 58;
        i3 = i2 + 20 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP8[i15 >> 0] = i3;
        HEAP8[i15 + 1 >> 0] = i3 >> 8;
        HEAP8[i15 + 2 >> 0] = i3 >> 16;
        HEAP8[i15 + 3 >> 0] = i3 >> 24;
        HEAP8[i16 >> 0] = 58;
        i3 = i2 + 24 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP16[i17 >> 1] = i3;
        HEAP16[i17 + 2 >> 1] = i3 >>> 16;
        HEAP8[i18 >> 0] = 58;
        i3 = i2 + 28 | 0;
        i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
        HEAP8[i19 >> 0] = i3;
        HEAP8[i19 + 1 >> 0] = i3 >> 8;
        HEAP8[i19 + 2 >> 0] = i3 >> 16;
        HEAP8[i19 + 3 >> 0] = i3 >> 24;
        HEAP8[i20 >> 0] = 0;
        HEAP32[i32 >> 2] = i23;
        HEAP32[i32 + 4 >> 2] = i24;
        HEAP32[i32 + 8 >> 2] = i25;
        HEAP32[i32 + 12 >> 2] = i26;
        HEAP32[i32 + 16 >> 2] = i27;
        if ((_sscanf(i2 + 33 | 0, gb + 1074122 | 0, i32) | 0) == 5) {
         HEAP32[i28 >> 2] = 0;
         HEAP32[i28 + 4 >> 2] = 0;
         HEAP32[i28 + 8 >> 2] = 0;
         HEAP32[i28 + 12 >> 2] = 0;
         HEAP32[i28 + 16 >> 2] = 0;
         HEAP32[i28 + 20 >> 2] = 0;
         HEAP32[i28 + 24 >> 2] = 0;
         L48 : do if ((_inet_pton(10, i31, i4) | 0) == 1) {
          HEAP16[i28 >> 1] = 10;
          i3 = _list_add(i29, i30, i27) | 0;
          if (!i3) break L44;
          i1 = i3 + 28 | 0;
          HEAP32[i1 >> 2] = HEAP32[i28 >> 2];
          HEAP32[i1 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
          HEAP32[i1 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
          HEAP32[i1 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
          HEAP32[i1 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
          HEAP32[i1 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
          HEAP32[i1 + 24 >> 2] = HEAP32[i28 + 24 >> 2];
          HEAP32[i3 + 12 >> 2] = i1;
          i1 = HEAP32[i24 >> 2] | 0;
          i36 = i1 >>> 3;
          i1 = i1 & 7;
          _memset(i5 | 0, -1, i36 | 0) | 0;
          i2 = i5 + i36 | 0;
          _memset(i2 | 0, 0, 16 - i36 | 0) | 0;
          if (i1 | 0) HEAP8[i2 >> 0] = 255 << 8 - i1;
          i2 = i3 + 56 | 0;
          HEAP32[i2 >> 2] = HEAP32[i28 >> 2];
          HEAP32[i2 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
          HEAP32[i2 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
          HEAP32[i2 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
          HEAP32[i2 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
          HEAP32[i2 + 20 >> 2] = HEAP32[i28 + 20 >> 2];
          HEAP32[i2 + 24 >> 2] = HEAP32[i28 + 24 >> 2];
          HEAP32[i3 + 16 >> 2] = i2;
          i2 = HEAP32[i29 >> 2] | 0;
          i1 = i2;
          L54 : do if (i2 | 0) {
           while (1) {
            if (!(_strcmp(i27, i2 + 112 | 0) | 0)) break;
            i2 = HEAP32[i2 >> 2] | 0;
            if (!i2) break L54;
           }
           HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
           break L48;
          } while (0);
          HEAP32[i3 + 8 >> 2] = 0;
         } else HEAP32[(___errno_location() | 0) >> 2] = 0; while (0);
        }
        i2 = _fgets(i22, 512, i21) | 0;
        if (!i2) break L42;
       }
       i1 = HEAP32[i29 >> 2] | 0;
      } while (0);
      _fclose(i21) | 0;
     }
     HEAP32[i34 >> 2] = i1;
     i1 = 0;
     break L5;
    } while (0);
    _close(i10) | 0;
    i33 = 49;
   }
  } while (0);
  if ((i33 | 0) == 49) {
   i1 = HEAP32[i29 >> 2] | 0;
   if (!i1) i1 = -1; else {
    do {
     i36 = i1;
     i1 = HEAP32[i1 >> 2] | 0;
     _free(i36);
    } while ((i1 | 0) != 0);
    i1 = -1;
   }
  }
 }
 STACKTOP = i35;
 return i1 | 0;
}

function __ZN5physx10PxsContextC2ERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS6_13EventProfilerEj(i18, i17, i5, i6, i12, i4) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 __ZN5physx19PxsSimObjectFactoryC2Ev(i18);
 i13 = i18 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i18 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i18 + 20 | 0;
 __ZN5physx19PxcScratchAllocatorC2Ev(i15);
 i16 = i18 + 44 | 0;
 __ZN5physx17PxcNpMemBlockPoolC2ERNS_19PxcScratchAllocatorE(i16, i15);
 i1 = HEAP32[(__ZN5physx6shdfnd9SListImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
  i11 = _PxGetFoundation() | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
  i1 = mftCall_iiiiii(i9 | 0, i10 | 0, i1 | 0, (i11 ? gb + 741043 | 0 : gb + 837976 | 0) | 0, gb + 741165 | 0, 86) | 0;
 }
 HEAP32[i18 + 224 >> 2] = i1;
 __ZN5physx6shdfnd9SListImplC2Ev(i1);
 i1 = i18 + 232 | 0;
 HEAP32[i1 >> 2] = 16;
 i11 = i18 + 236 | 0;
 HEAP32[i11 >> 2] = 1024;
 HEAP32[i18 + 240 >> 2] = 0;
 HEAP32[i18 + 248 >> 2] = 0;
 HEAP32[i18 + 252 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i9 | 0, i10 | 0, 4096, (i3 ? gb + 713623 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 46) | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i18 + 256 >> 2] = i3;
 HEAP32[i18 + 260 >> 2] = i18;
 HEAP32[i18 + 264 >> 2] = 0;
 HEAP32[i18 + 268 >> 2] = 0;
 i3 = i18 + 244 | 0;
 HEAP32[i3 >> 2] = 0;
 if (i11 >>> 0 > 1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) if ((i2 | 0) == (1 << i1 | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 }
 i1 = i18 + 276 | 0;
 HEAP32[i1 >> 2] = 256;
 i11 = i18 + 280 | 0;
 HEAP32[i11 >> 2] = 1024;
 HEAP32[i18 + 284 >> 2] = 0;
 HEAP32[i18 + 292 >> 2] = 0;
 HEAP32[i18 + 296 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i9 | 0, i10 | 0, 4096, (i3 ? gb + 713751 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 46) | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i18 + 300 >> 2] = i3;
 HEAP32[i18 + 304 >> 2] = i18;
 HEAP32[i18 + 308 >> 2] = 0;
 HEAP32[i18 + 312 >> 2] = 0;
 i3 = i18 + 288 | 0;
 HEAP32[i3 >> 2] = 0;
 if (i11 >>> 0 > 1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) if ((i2 | 0) == (1 << i1 | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 }
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
  i11 = _PxGetFoundation() | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
  i1 = mftCall_iiiiii(i9 | 0, i10 | 0, i1 | 0, (i11 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i18 + 320 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 __ZN5physx24PxsParticleSystemBatcherC2ERNS_10PxsContextE(i18 + 324 | 0, i18);
 i1 = i18 + 696 | 0;
 HEAP32[i1 >> 2] = 256;
 i11 = i18 + 700 | 0;
 HEAP32[i11 >> 2] = 4096;
 HEAP32[i18 + 704 >> 2] = 0;
 HEAP32[i18 + 712 >> 2] = 0;
 HEAP32[i18 + 716 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i9 | 0, i10 | 0, 16384, (i3 ? gb + 702609 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 46) | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i18 + 720 >> 2] = i3;
 HEAP32[i18 + 724 >> 2] = i18;
 HEAP32[i18 + 728 >> 2] = 0;
 HEAP32[i18 + 732 >> 2] = 0;
 i3 = i18 + 708 | 0;
 HEAP32[i3 >> 2] = 0;
 if (i11 >>> 0 > 1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) if ((i2 | 0) == (1 << i1 | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i18 + 1008 >> 2] = 0;
 HEAP8[i18 + 1e3 >> 0] = 1;
 HEAP32[i18 + 1004 >> 2] = i18 + 744;
 HEAP32[i18 + 1012 >> 2] = 64;
 HEAP32[i18 + 1016 >> 2] = 32;
 HEAP32[i18 + 1020 >> 2] = 0;
 HEAP32[i18 + 1024 >> 2] = 0;
 HEAP32[i18 + 1028 >> 2] = 7680;
 HEAP32[i18 + 1032 >> 2] = 0;
 HEAP32[i18 + 1304 >> 2] = 0;
 HEAP8[i18 + 1296 >> 0] = 1;
 HEAP32[i18 + 1300 >> 2] = i18 + 1040;
 HEAP32[i18 + 1308 >> 2] = 64;
 HEAP32[i18 + 1312 >> 2] = 32;
 HEAP32[i18 + 1316 >> 2] = 0;
 HEAP32[i18 + 1320 >> 2] = 0;
 HEAP32[i18 + 1324 >> 2] = 3072;
 HEAP32[i18 + 1328 >> 2] = 0;
 HEAP32[i18 + 1332 >> 2] = 0;
 HEAP32[i18 + 1336 >> 2] = 0;
 i10 = i18 + 1344 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i18 + 1348 | 0;
 HEAP32[i11 >> 2] = 0;
 i1 = i18 + 1368 | 0;
 i2 = i18 + 1444 | 0;
 i8 = i1;
 i9 = i8 + 72 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 __ZN5physx21PxsBodyTransformVaultC2Ev(i2);
 HEAP32[i18 + 5840 >> 2] = 0;
 HEAP32[i18 + 5844 >> 2] = 0;
 i1 = i18 + 5924 | 0;
 i8 = i18 + 5852 | 0;
 i9 = i8 + 68 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP32[i1 >> 2] = gb + 86472 + 8;
 i8 = i18 + 5928 | 0;
 i9 = i8 + 60 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 i7 = i18 + 6136 | 0;
 HEAPF32[i18 + 6160 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 6164 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 6168 >> 2] = Math_fround(0.0);
 __ZN5physx16PxsIslandManagerC2EjRNS_19PxcScratchAllocatorEPNS_2Cm13EventProfilerE(i18 + 6172 | 0, i4, i15, i12);
 i3 = i18 + 6900 | 0;
 HEAP16[i18 + 6904 >> 1] = -1;
 HEAP16[i18 + 6906 >> 1] = 0;
 HEAP32[i18 + 6908 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 6912 >> 2] = 0;
 HEAP32[i18 + 6916 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 102604 + 8;
 HEAP32[i18 + 6920 >> 2] = i18;
 HEAP32[i18 + 6924 >> 2] = gb + 713871;
 i3 = i18 + 6928 | 0;
 HEAP16[i18 + 6932 >> 1] = -1;
 HEAP16[i18 + 6934 >> 1] = 0;
 HEAP32[i18 + 6936 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 6940 >> 2] = 0;
 HEAP32[i18 + 6944 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 102648 + 8;
 HEAP32[i18 + 6948 >> 2] = i18;
 HEAP32[i18 + 6952 >> 2] = gb + 713913;
 HEAP32[i18 + 6956 >> 2] = i5;
 HEAP32[i18 + 6960 >> 2] = i6;
 i6 = i18 + 6964 | 0;
 HEAP32[i6 >> 2] = i12;
 _memset(i18 + 6980 | 0, 0, 624) | 0;
 i3 = HEAP16[i17 + 100 >> 1] | 0;
 HEAP8[i18 + 7604 >> 0] = (i3 & 65535) >>> 9 & 1;
 HEAP8[i18 + 7605 >> 0] = 0;
 HEAP8[i18 + 7606 >> 0] = (i3 & 65535) >>> 15;
 i3 = i18 + 7632 | 0;
 i4 = i18 + 7640 | 0;
 i5 = i18 + 7644 | 0;
 i2 = i18 + 7648 | 0;
 i1 = i18 + 7628 | 0;
 i8 = i18 + 7608 | 0;
 i9 = i8 + 44 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, 512);
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 & 2147483136) >>> 0 < 512) {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i4, 512);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 512;
 _memset(HEAP32[i4 >> 2] | 0, 0, i1 << 2 | 0) | 0;
 HEAP32[i3 >> 2] = 512;
 _memset(HEAP32[i10 >> 2] | 0, 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
 HEAP32[i18 + 1356 >> 2] = 0;
 HEAP32[i18 + 1360 >> 2] = 0;
 HEAP32[i18 + 1364 >> 2] = 0;
 HEAP32[i7 >> 2] = -25165825;
 HEAP32[i18 + 6140 >> 2] = -25165825;
 HEAP32[i18 + 6144 >> 2] = -25165825;
 HEAP32[i18 + 6148 >> 2] = 2122317823;
 HEAP32[i18 + 6152 >> 2] = 2122317823;
 HEAP32[i18 + 6156 >> 2] = 2122317823;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i11 | 0, i1 | 0, 51632, (i2 ? gb + 713953 | 0 : gb + 837976 | 0) | 0, gb + 714069 | 0, 122) | 0;
 __ZN5physx14PxsAABBManagerC2ERNS_2Cm13EventProfilerERNS_19PxcScratchAllocatorE(i2, i12, i15);
 HEAP32[i13 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i17 + 40 >> 2] | 0) == 1) {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i12 = _PxGetFoundation() | 0;
  i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0) | 0;
  i12 = mftCall_iiiiii(i10 | 0, i11 | 0, 124, (i12 ? gb + 714153 | 0 : gb + 837976 | 0) | 0, gb + 714069 | 0, 71) | 0;
  __ZN5physx16PxsBroadPhaseMBPC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerERKNS_11PxSceneDescEPNS_14PxsAABBManagerE(i12, i15, i1, i17, i2);
  i15 = i12;
  i13 = HEAP32[i13 >> 2] | 0;
  __ZN5physx14PxsAABBManager4initEPNS_13PxvBroadPhaseE(i13, i15);
  i15 = __ZN5physx18PxsDynamicsContext6createEPNS_10PxsContextE(i18) | 0;
  HEAP32[i14 >> 2] = i15;
  i14 = __ZN5physx13PxsCCDContext6createEPNS_10PxsContextE(i18) | 0;
  i15 = i18 + 16 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = i18 + 5988 | 0;
  _memset(i15 | 0, 0, 148) | 0;
  i15 = i17 + 136 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i18 = i17 + 140 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  __ZN5physx17PxcNpMemBlockPool4initEjj(i16, i15, i18);
  return;
 } else {
  i15 = __ZN5physx23PxsBroadPhaseContextSap6createERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i15, i1) | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  __ZN5physx14PxsAABBManager4initEPNS_13PxvBroadPhaseE(i13, i15);
  i15 = __ZN5physx18PxsDynamicsContext6createEPNS_10PxsContextE(i18) | 0;
  HEAP32[i14 >> 2] = i15;
  i14 = __ZN5physx13PxsCCDContext6createEPNS_10PxsContextE(i18) | 0;
  i15 = i18 + 16 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = i18 + 5988 | 0;
  _memset(i15 | 0, 0, 148) | 0;
  i15 = i17 + 136 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i18 = i17 + 140 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  __ZN5physx17PxcNpMemBlockPool4initEjj(i16, i15, i18);
  return;
 }
}

function __ZN5physx14PxsAABBManager13releaseVolumeEj(i22, i7) {
 i22 = i22 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23;
 i11 = i7 >>> 1;
 if (!(i7 & 1)) {
  i5 = i22 + 49860 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  L3 : do if (i1 | 0) {
   i6 = i22 + 49856 | 0;
   i4 = 0;
   while (1) {
    while (1) {
     i1 = i1 + -1 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     if ((HEAP32[i2 + (i4 * 12 | 0) >> 2] | 0) != (i11 | 0)) if ((HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] | 0) != (i11 | 0)) break;
     i3 = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] | 0;
     if (i3) {
      i2 = HEAP32[i3 >> 2] | 0;
      if (i2 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 8 | 0, i2);
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i3);
      i2 = HEAP32[i6 >> 2] | 0;
      HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = 0;
     }
     i21 = i2 + (i4 * 12 | 0) | 0;
     i20 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
     HEAP32[i5 >> 2] = i20;
     i20 = i2 + (i20 * 12 | 0) | 0;
     HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     if (!i1) break L3;
    }
    if (!i1) break; else i4 = i4 + 1 | 0;
   }
  } while (0);
  i3 = i7 >>> 6;
  i1 = (HEAP32[i22 + 68 >> 2] | 0) + (i3 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = 1 << (i11 & 31);
  if (i2 & i4 | 0) HEAP32[i1 >> 2] = i2 & ~i4;
  i1 = (HEAP32[i22 + 96 >> 2] | 0) + (i3 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & i4)) {
   i6 = (HEAP32[i22 + 124 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i4;
   i6 = 0;
  } else {
   HEAP32[i1 >> 2] = i2 & ~i4;
   i6 = 1;
  }
  i7 = i22 + 24 | 0;
  i2 = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i11 << 2) >> 2] | 0) >>> 1;
  i3 = (HEAP32[i22 + 156 >> 2] | 0) + (i2 << 2) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i8 = i22 + 28 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  do if ((i11 | 0) == (i1 | 0)) if ((i4 | 0) == 1073741823) {
   HEAP32[i3 >> 2] = 1073741823;
   i4 = i22 + 172 | 0;
   HEAP32[(HEAP32[i22 + 168 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) >> 2] = i2;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP32[i5 + (i11 << 2) >> 2] = 1073741823;
   i4 = 1;
   break;
  } else {
   HEAP32[i3 >> 2] = i4;
   i4 = 0;
   break;
  } else {
   while (1) {
    i2 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
    if ((i4 | 0) == (i11 | 0)) break; else {
     i1 = i4;
     i4 = i2;
    }
   }
   HEAP32[i5 + (i1 << 2) >> 2] = i2;
   HEAP32[i5 + (i11 << 2) >> 2] = 1073741823;
   i4 = 0;
  } while (0);
  if (!i6) {
   i22 = i4;
   STACKTOP = i23;
   return i22 | 0;
  }
  i2 = i22 + 32 | 0;
  i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  i1 = i22 + 20 | 0;
  do if ((i3 | 0) != 1073741823) if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + (i11 << 2) >> 2] | 0)) {
   i21 = i22 + 52 | 0;
   HEAP32[(HEAP32[i22 + 44 >> 2] | 0) + (i3 << 3) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i21 >> 2] = i3;
   break;
  } else {
   i21 = i22 + 64 | 0;
   HEAP32[(HEAP32[i22 + 56 >> 2] | 0) + (i3 << 4) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i21 >> 2] = i3;
   break;
  } while (0);
  i21 = HEAP32[i22 + 12 >> 2] | 0;
  HEAP32[i21 + (i11 * 24 | 0) + 8 >> 2] = -8388609;
  HEAP32[i21 + (i11 * 24 | 0) + 4 >> 2] = -8388609;
  HEAP32[i21 + (i11 * 24 | 0) >> 2] = -8388609;
  HEAP32[i21 + (i11 * 24 | 0) + 20 >> 2] = 8388608;
  HEAP32[i21 + (i11 * 24 | 0) + 16 >> 2] = 8388608;
  HEAP32[i21 + (i11 * 24 | 0) + 12 >> 2] = 8388608;
  HEAP32[(HEAP32[i22 + 16 >> 2] | 0) + (i11 << 2) >> 2] = 0;
  i21 = (HEAP32[i1 >> 2] | 0) + (i11 << 2) | 0;
  HEAP32[i21 >> 2] = 1073741823;
  HEAP32[(HEAP32[i7 >> 2] | 0) + (i11 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i11 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i11 << 2) >> 2] = 1073741823;
  i22 = i22 + 40 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i22 >> 2] = i11;
  i22 = i4;
  STACKTOP = i23;
  return i22 | 0;
 }
 i19 = i22 + 312 | 0;
 i1 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 i2 = i1 >>> 1;
 i20 = HEAP32[(HEAP32[i22 + 260 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 i21 = i22 + 180 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 if (!(HEAP8[i5 + (i20 * 1048 | 0) + 1024 >> 0] | 0)) {
  i18 = (HEAP32[i22 + 268 >> 2] | 0) + (i1 >>> 6 << 2) | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 1 << (i2 & 31);
 }
 i17 = (HEAP32[i22 + 252 >> 2] | 0) + i2 | 0;
 i18 = HEAP8[i17 >> 0] | 0;
 HEAP8[i17 >> 0] = i18 + -1 << 24 >> 24;
 if ((i18 & 255) > 1) i16 = 0; else {
  i16 = (HEAP32[i22 + 280 >> 2] | 0) + (i1 >>> 6 << 2) | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 1 << (i2 & 31);
  i16 = 1;
 }
 i17 = i5 + (i20 * 1048 | 0) + 1026 | 0;
 i4 = (HEAP8[i17 >> 0] | 0) + -1 << 24 >> 24;
 HEAP8[i17 >> 0] = i4;
 i17 = i20 >>> 5;
 i8 = i22 + 356 | 0;
 i1 = (HEAP32[i8 >> 2] | 0) + (i17 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i18 = 1 << (i20 & 31);
 if (!(i2 & i18)) HEAP32[i1 >> 2] = i2 | i18;
 i14 = i22 + 308 | 0;
 HEAP32[(HEAP32[i14 >> 2] | 0) + (i11 << 2) >> 2] = 1073741823;
 i15 = i22 + 320 | 0;
 HEAP32[(HEAP32[i15 >> 2] | 0) + (i11 << 2) >> 2] = 1073741823;
 i9 = i5 + (i20 * 1048 | 0) + 1032 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i11 | 0)) i1 = -1; else {
  i3 = HEAP32[i22 + 316 >> 2] | 0;
  i2 = i1;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i2 | 0) == (i11 | 0)) break; else i1 = i1 + 1 | 0;
  }
  i1 = -2 - i1 | 0;
 }
 i11 = i1 + (HEAPU8[i5 + (i20 * 1048 | 0) + 1025 >> 0] | 0) | 0;
 i13 = i22 + 184 | 0;
 i12 = (HEAP32[i13 >> 2] | 0) + (i20 << 4) + (i11 >>> 5 << 2) | 0;
 HEAP32[i12 >> 2] = 1 << (i11 & 31) | HEAP32[i12 >> 2];
 if (i4 << 24 >> 24) {
  i22 = i16;
  STACKTOP = i23;
  return i22 | 0;
 }
 i7 = HEAP32[i5 + (i20 * 1048 | 0) + 1028 >> 2] | 0;
 i5 = i22 + 49860 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 L66 : do if (i1 | 0) {
  i6 = i22 + 49856 | 0;
  i4 = 0;
  while (1) {
   while (1) {
    i1 = i1 + -1 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i2 + (i4 * 12 | 0) >> 2] | 0) != (i7 | 0)) if ((HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] | 0) != (i7 | 0)) break;
    i3 = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] | 0;
    if (i3) {
     i2 = HEAP32[i3 >> 2] | 0;
     if (i2 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 8 | 0, i2);
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i3);
     i2 = HEAP32[i6 >> 2] | 0;
     HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = 0;
    }
    i12 = i2 + (i4 * 12 | 0) | 0;
    i11 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
    HEAP32[i5 >> 2] = i11;
    i11 = i2 + (i11 * 12 | 0) | 0;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    if (!i1) break L66;
   }
   if (!i1) break; else i4 = i4 + 1 | 0;
  }
 } while (0);
 i1 = (HEAP32[i8 >> 2] | 0) + (i17 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 & i18 | 0) HEAP32[i1 >> 2] = i2 & ~i18;
 i4 = i7 >>> 5;
 i1 = (HEAP32[i22 + 68 >> 2] | 0) + (i4 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << (i7 & 31);
 if (i2 & i3 | 0) HEAP32[i1 >> 2] = i2 & ~i3;
 i1 = (HEAP32[i22 + 96 >> 2] | 0) + (i4 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & i3)) {
  i12 = (HEAP32[i22 + 124 >> 2] | 0) + (i4 << 2) | 0;
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i3;
 } else HEAP32[i1 >> 2] = i2 & ~i3;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != 1073741823) {
  i5 = i22 + 316 | 0;
  i6 = i22 + 300 | 0;
  i7 = i22 + 304 | 0;
  i8 = i22 + 328 | 0;
  i9 = i22 + 340 | 0;
  i10 = i22 + 332 | 0;
  i11 = i22 + 352 | 0;
  i12 = i22 + 344 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  do {
   i4 = i1;
   i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i2 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
   do if ((i2 | 0) != 1073741823) if (!(HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 2) >> 2] | 0)) {
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 3) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i2;
    break;
   } else {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 4) >> 2] = HEAP32[i11 >> 2];
    HEAP32[i11 >> 2] = i2;
    break;
   } while (0);
   i24 = HEAP32[i6 >> 2] | 0;
   HEAP32[i24 + (i4 * 24 | 0) + 8 >> 2] = -8388609;
   HEAP32[i24 + (i4 * 24 | 0) + 4 >> 2] = -8388609;
   HEAP32[i24 + (i4 * 24 | 0) >> 2] = -8388609;
   HEAP32[i24 + (i4 * 24 | 0) + 20 >> 2] = 8388608;
   HEAP32[i24 + (i4 * 24 | 0) + 16 >> 2] = 8388608;
   HEAP32[i24 + (i4 * 24 | 0) + 12 >> 2] = 8388608;
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = 0;
   i24 = (HEAP32[i14 >> 2] | 0) + (i4 << 2) | 0;
   HEAP32[i24 >> 2] = 1073741823;
   HEAP32[(HEAP32[i19 >> 2] | 0) + (i4 << 2) >> 2] = 1073741823;
   i3 = HEAP32[i15 >> 2] | 0;
   HEAP32[i3 + (i4 << 2) >> 2] = 1073741823;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i2 + (i4 << 2) >> 2] = 1073741823;
   HEAP32[i24 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i4;
  } while ((i1 | 0) != 1073741823);
 }
 i21 = HEAP32[i21 >> 2] | 0;
 HEAP8[i21 + (i20 * 1048 | 0) + 1024 >> 0] = 1;
 HEAP8[i21 + (i20 * 1048 | 0) + 1025 >> 0] = 0;
 HEAP8[i21 + (i20 * 1048 | 0) + 1026 >> 0] = 0;
 HEAP32[i21 + (i20 * 1048 | 0) + 1028 >> 2] = 1073741823;
 HEAP32[i21 + (i20 * 1048 | 0) + 1032 >> 2] = 1073741823;
 HEAP32[i21 + (i20 * 1048 | 0) + 1044 >> 2] = 0;
 i21 = ~i18;
 i24 = (HEAP32[i22 + 220 >> 2] | 0) + (i17 << 2) | 0;
 HEAP32[i24 >> 2] = HEAP32[i24 >> 2] & i21;
 i24 = (HEAP32[i22 + 232 >> 2] | 0) + (i17 << 2) | 0;
 HEAP32[i24 >> 2] = HEAP32[i24 >> 2] & i21;
 i24 = (HEAP32[i13 >> 2] | 0) + (i20 << 4) | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 i24 = (HEAP32[i22 + 188 >> 2] | 0) + (i20 << 4) | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 i24 = i16;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 3);
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i8, i10);
 i2 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946475 | 0, HEAP32[gb + 37260 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i10, i2, 1); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 52 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946482 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946492 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946508 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 58 | 0;
 i5 = HEAP32[gb + 37240 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946522 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 45; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 45; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034753 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 56; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 56; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946531 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 72 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034730 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 78; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 78; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 78) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034741 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 89; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 89; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034776 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034701 | 0, gb + 1034708 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN16b2PrismaticJoint24SolvePositionConstraintsERK12b2SolverData(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i37 + 24 | 0;
 i34 = i37 + 12 | 0;
 i35 = i37;
 i36 = i5 + 144 | 0;
 i18 = HEAP32[i36 >> 2] | 0;
 i26 = i1 + 24 | 0;
 i38 = HEAP32[i26 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i38 + (i18 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i38 + (i18 * 12 | 0) + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i38 + (i18 * 12 | 0) + 8 >> 2]);
 i18 = i5 + 148 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i38 + (i1 * 12 | 0) >> 2]);
 f20 = Math_fround(HEAPF32[i38 + (i1 * 12 | 0) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i38 + (i1 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(+Math_sin(+f17));
 f14 = Math_fround(+Math_cos(+f17));
 f29 = Math_fround(+Math_sin(+f21));
 f2 = Math_fround(+Math_cos(+f21));
 f22 = Math_fround(HEAPF32[i5 + 168 >> 2]);
 f23 = Math_fround(HEAPF32[i5 + 172 >> 2]);
 f24 = Math_fround(HEAPF32[i5 + 176 >> 2]);
 f25 = Math_fround(HEAPF32[i5 + 180 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i5 + 152 >> 2]));
 f11 = Math_fround(HEAPF32[i5 + 72 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i5 + 156 >> 2]));
 f16 = Math_fround(Math_fround(f14 * f3) - Math_fround(f9 * f11));
 f11 = Math_fround(Math_fround(f9 * f3) + Math_fround(f14 * f11));
 f3 = Math_fround(HEAPF32[i5 + 76 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i5 + 160 >> 2]));
 f12 = Math_fround(HEAPF32[i5 + 80 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i5 + 164 >> 2]));
 f6 = Math_fround(Math_fround(f2 * f3) - Math_fround(f29 * f12));
 f12 = Math_fround(Math_fround(f29 * f3) + Math_fround(f2 * f12));
 f2 = Math_fround(Math_fround(Math_fround(f19 + f6) - f10) - f16);
 f3 = Math_fround(Math_fround(Math_fround(f20 + f12) - f13) - f11);
 f29 = Math_fround(HEAPF32[i5 + 84 >> 2]);
 f27 = Math_fround(f14 * f29);
 f28 = Math_fround(HEAPF32[i5 + 88 >> 2]);
 f27 = Math_fround(f27 - Math_fround(f9 * f28));
 f28 = Math_fround(Math_fround(f9 * f29) + Math_fround(f14 * f28));
 f16 = Math_fround(f16 + f2);
 f11 = Math_fround(f11 + f3);
 f29 = Math_fround(Math_fround(f28 * f16) - Math_fround(f27 * f11));
 f30 = Math_fround(Math_fround(f6 * f28) - Math_fround(f12 * f27));
 f15 = Math_fround(HEAPF32[i5 + 92 >> 2]);
 f31 = Math_fround(f14 * f15);
 f32 = Math_fround(HEAPF32[i5 + 96 >> 2]);
 f31 = Math_fround(f31 - Math_fround(f9 * f32));
 f32 = Math_fround(Math_fround(f9 * f15) + Math_fround(f14 * f32));
 f11 = Math_fround(Math_fround(f32 * f16) - Math_fround(f31 * f11));
 f12 = Math_fround(Math_fround(f6 * f32) - Math_fround(f12 * f31));
 f6 = Math_fround(Math_fround(f31 * f2) + Math_fround(f32 * f3));
 f16 = Math_fround(f21 - f17);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i5 + 100 >> 2]));
 i1 = f6 > Math_fround(0.0);
 f14 = Math_fround(-f6);
 f6 = i1 ? f6 : f14;
 i1 = f16 > Math_fround(0.0);
 f15 = Math_fround(-f16);
 f16 = i1 ? f16 : f15;
 do if (!(HEAP8[i5 + 136 >> 0] | 0)) {
  i1 = 0;
  f2 = Math_fround(0.0);
 } else {
  f3 = Math_fround(Math_fround(f27 * f2) + Math_fround(f28 * f3));
  f4 = Math_fround(HEAPF32[i5 + 124 >> 2]);
  f2 = Math_fround(HEAPF32[i5 + 120 >> 2]);
  f8 = Math_fround(f4 - f2);
  i38 = f8 > Math_fround(0.0);
  f9 = Math_fround(-f8);
  if ((i38 ? f8 : f9) < Math_fround(.00999999977)) {
   f2 = Math_fround(HEAPF32[gb + 151880 >> 2]);
   f9 = Math_fround(-f2);
   f2 = f3 < f2 ? f3 : f2;
   i1 = f3 > Math_fround(0.0);
   f8 = Math_fround(-f3);
   f8 = i1 ? f3 : f8;
   f6 = f6 > f8 ? f6 : f8;
   i1 = 1;
   f2 = f2 < f9 ? f9 : f2;
   break;
  }
  if (f3 <= f2) {
   f9 = Math_fround(Math_fround(f3 - f2) + Math_fround(.00499999989));
   f8 = Math_fround(-Math_fround(HEAPF32[gb + 151880 >> 2]));
   i1 = f9 < Math_fround(0.0);
   f9 = i1 ? f9 : Math_fround(0.0);
   f2 = Math_fround(f2 - f3);
   f6 = f6 > f2 ? f6 : f2;
   i1 = 1;
   f2 = f9 < f8 ? f8 : f9;
   break;
  }
  if (!(f3 >= f4)) {
   i1 = 0;
   f2 = Math_fround(0.0);
  } else {
   f9 = Math_fround(f3 - f4);
   f8 = Math_fround(f9 + Math_fround(-.00499999989));
   f2 = Math_fround(HEAPF32[gb + 151880 >> 2]);
   f2 = f8 < f2 ? f8 : f2;
   i1 = f2 < Math_fround(0.0);
   f2 = i1 ? Math_fround(0.0) : f2;
   f6 = f6 > f9 ? f6 : f9;
   i1 = 1;
  }
 } while (0);
 f3 = Math_fround(f22 + f23);
 f4 = Math_fround(f24 * f11);
 f7 = Math_fround(f25 * f12);
 f8 = Math_fround(Math_fround(f12 * f7) + Math_fround(f3 + Math_fround(f11 * f4)));
 f9 = Math_fround(f7 + f4);
 if (i1) {
  f39 = Math_fround(Math_fround(f30 * f7) + Math_fround(f29 * f4));
  f40 = Math_fround(f24 + f25);
  i38 = f40 == Math_fround(0.0);
  f40 = i38 ? Math_fround(1.0) : f40;
  f7 = Math_fround(f24 * f29);
  f41 = Math_fround(f25 * f30);
  f4 = Math_fround(f41 + f7);
  f7 = Math_fround(Math_fround(f30 * f41) + Math_fround(f3 + Math_fround(f29 * f7)));
  HEAPF32[i33 >> 2] = f8;
  HEAPF32[i33 + 4 >> 2] = f9;
  HEAPF32[i33 + 8 >> 2] = f39;
  HEAPF32[i33 + 12 >> 2] = f9;
  HEAPF32[i33 + 16 >> 2] = f40;
  HEAPF32[i33 + 20 >> 2] = f4;
  HEAPF32[i33 + 24 >> 2] = f39;
  HEAPF32[i33 + 28 >> 2] = f4;
  HEAPF32[i33 + 32 >> 2] = f7;
  f9 = Math_fround(-f2);
  HEAPF32[i35 >> 2] = f14;
  HEAPF32[i35 + 4 >> 2] = f15;
  HEAPF32[i35 + 8 >> 2] = f9;
  __ZNK7b2Mat337Solve33ERK6b2Vec3(i34, i33, i35);
  i35 = HEAP32[i34 >> 2] | 0;
  i38 = HEAP32[i34 + 4 >> 2] | 0;
  f14 = Math_fround(HEAPF32[i34 + 8 >> 2]);
  f9 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(f31 * f9);
  f32 = Math_fround(f32 * f9);
  f15 = Math_fround(f27 * f14);
  f31 = Math_fround(f28 * f14);
  f15 = Math_fround(f8 + f15);
  f31 = Math_fround(f32 + f31);
  f32 = Math_fround(f11 * f9);
  f27 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f32 = Math_fround(f32 + f27);
  f29 = Math_fround(f29 * f14);
  f29 = Math_fround(f32 + f29);
  f32 = Math_fround(f12 * f9);
  f27 = Math_fround(f32 + f27);
  f32 = Math_fround(f30 * f14);
  f32 = Math_fround(f27 + f32);
  f27 = Math_fround(f22 * f15);
  f28 = Math_fround(f22 * f31);
  f27 = Math_fround(f10 - f27);
  f28 = Math_fround(f13 - f28);
  f29 = Math_fround(f24 * f29);
  f29 = Math_fround(f17 - f29);
  f30 = Math_fround(f23 * f15);
  f31 = Math_fround(f23 * f31);
  f30 = Math_fround(f19 + f30);
  f31 = Math_fround(f20 + f31);
  f32 = Math_fround(f25 * f32);
  f32 = Math_fround(f21 + f32);
  i38 = HEAP32[i36 >> 2] | 0;
  i35 = HEAP32[i26 >> 2] | 0;
  i34 = i35 + (i38 * 12 | 0) | 0;
  HEAPF32[i34 >> 2] = f27;
  i38 = i35 + (i38 * 12 | 0) + 4 | 0;
  HEAPF32[i38 >> 2] = f28;
  i38 = HEAP32[i36 >> 2] | 0;
  i36 = HEAP32[i26 >> 2] | 0;
  i38 = i36 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f29;
  i38 = HEAP32[i18 >> 2] | 0;
  i35 = i36 + (i38 * 12 | 0) | 0;
  HEAPF32[i35 >> 2] = f30;
  i38 = i36 + (i38 * 12 | 0) + 4 | 0;
  HEAPF32[i38 >> 2] = f31;
  i38 = HEAP32[i18 >> 2] | 0;
  i36 = HEAP32[i26 >> 2] | 0;
  i38 = i36 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f32;
  i38 = f6 <= Math_fround(.00499999989);
  i36 = f16 <= Math_fround(.0349065885);
  i38 = i36 & i38;
  STACKTOP = i37;
  return i38 | 0;
 } else {
  f39 = Math_fround(f24 + f25);
  i35 = f39 == Math_fround(0.0);
  f39 = i35 ? Math_fround(1.0) : f39;
  f41 = Math_fround(Math_fround(f39 * f8) - Math_fround(f9 * f9));
  i35 = f41 != Math_fround(0.0);
  f40 = Math_fround(Math_fround(1.0) / f41);
  f41 = i35 ? f40 : f41;
  f39 = Math_fround(Math_fround(Math_fround(f39 * f14) - Math_fround(f9 * f15)) * f41);
  i35 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  f41 = Math_fround(Math_fround(Math_fround(f8 * f15) - Math_fround(f9 * f14)) * f41);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
  f41 = Math_fround(0.0);
  f15 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f31 * f15);
  f31 = Math_fround(f32 * f15);
  f39 = Math_fround(f27 * f41);
  f40 = Math_fround(f28 * f41);
  f39 = Math_fround(f14 + f39);
  f40 = Math_fround(f31 + f40);
  f28 = Math_fround(f11 * f15);
  f31 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f28 + f31);
  f32 = Math_fround(f29 * f41);
  f32 = Math_fround(f28 + f32);
  f29 = Math_fround(f12 * f15);
  f31 = Math_fround(f29 + f31);
  f41 = Math_fround(f30 * f41);
  f41 = Math_fround(f31 + f41);
  f30 = Math_fround(f22 * f39);
  f31 = Math_fround(f22 * f40);
  f30 = Math_fround(f10 - f30);
  f31 = Math_fround(f13 - f31);
  f32 = Math_fround(f24 * f32);
  f32 = Math_fround(f17 - f32);
  f39 = Math_fround(f23 * f39);
  f40 = Math_fround(f23 * f40);
  f39 = Math_fround(f19 + f39);
  f40 = Math_fround(f20 + f40);
  f41 = Math_fround(f25 * f41);
  f41 = Math_fround(f21 + f41);
  i38 = HEAP32[i36 >> 2] | 0;
  i35 = HEAP32[i26 >> 2] | 0;
  i34 = i35 + (i38 * 12 | 0) | 0;
  HEAPF32[i34 >> 2] = f30;
  i38 = i35 + (i38 * 12 | 0) + 4 | 0;
  HEAPF32[i38 >> 2] = f31;
  i38 = HEAP32[i36 >> 2] | 0;
  i36 = HEAP32[i26 >> 2] | 0;
  i38 = i36 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f32;
  i38 = HEAP32[i18 >> 2] | 0;
  i35 = i36 + (i38 * 12 | 0) | 0;
  HEAPF32[i35 >> 2] = f39;
  i38 = i36 + (i38 * 12 | 0) + 4 | 0;
  HEAPF32[i38 >> 2] = f40;
  i38 = HEAP32[i18 >> 2] | 0;
  i36 = HEAP32[i26 >> 2] | 0;
  i38 = i36 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f41;
  i38 = f6 <= Math_fround(.00499999989);
  i36 = f16 <= Math_fround(.0349065885);
  i38 = i36 & i38;
  STACKTOP = i37;
  return i38 | 0;
 }
 return 0;
}

function __ZN5physx15PxSerialization14isSerializableERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_(i20, i23, i21) {
 i20 = i20 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25 + 40 | 0;
 i17 = i25 + 32 | 0;
 i18 = i25 + 24 | 0;
 i15 = i25 + 16 | 0;
 i16 = i25 + 8 | 0;
 i5 = i25;
 i14 = i25 + 56 | 0;
 i22 = i25 + 48 | 0;
 i19 = __Z18PxCreateCollectionv() | 0;
 L1 : do if (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0) | 0) {
  if (!i21) {
   i2 = 0;
   while (1) {
    i1 = mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 32 >> 2] | 0, i20 | 0, i2 | 0) | 0;
    i13 = mftCall_iii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, HEAP16[i1 + 4 >> 1] | 0) | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0) | 0) mftCall_viiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i1 | 0, 0, 0);
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0) | 0) >>> 0) break L1;
   }
  } else i4 = 0;
  while (1) {
   i3 = mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 32 >> 2] | 0, i20 | 0, i4 | 0) | 0;
   i13 = mftCall_iii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, HEAP16[i3 + 4 >> 1] | 0) | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0) | 0) mftCall_viiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i3 | 0, 0, 0);
   i2 = mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 52 >> 2] | 0, i20 | 0, i3 | 0) | 0;
   i1 = getTempRet0() | 0;
   if (!((i2 | 0) == 0 & (i1 | 0) == 0)) {
    i13 = mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 40 >> 2] | 0, i21 | 0, i2 | 0, i1 | 0) | 0;
    if (!((i13 | 0) == 0 | (i13 | 0) == (i3 | 0))) break;
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0) | 0) >>> 0) break L1;
  }
  mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 56 >> 2] | 0, i19 | 0);
  i24 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i23 = i5;
  HEAP32[i23 >> 2] = i2;
  HEAP32[i23 + 4 >> 2] = i1;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i24, 4, gb + 745680 | 0, 119, gb + 745781 | 0, i5);
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i13 = __Z18PxCreateCollectionv() | 0;
 HEAP32[i14 >> 2] = gb + 120040 + 8;
 HEAP32[i14 + 4 >> 2] = i13;
 L20 : do if (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0) | 0) {
  i6 = (i21 | 0) == 0;
  i7 = i13 + 64 | 0;
  i8 = i13 + 80 | 0;
  i9 = i13 + 56 | 0;
  i10 = i13 + 60 | 0;
  i5 = i13 + 52 | 0;
  i11 = i13 + 72 | 0;
  i12 = 0;
  L22 : while (1) {
   i2 = mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 32 >> 2] | 0, i20 | 0, i12 | 0) | 0;
   i4 = mftCall_iii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, HEAP16[i2 + 4 >> 1] | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 | 0, i14 | 0);
   L24 : do if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0) | 0) {
    if (i6) {
     i3 = 0;
     while (1) {
      i1 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i3 | 0) | 0;
      if (mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i19 | 0, i1 | 0); else if (!(mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] | 0, i20 | 0, i1 | 0) | 0)) {
       i3 = 27;
       break L22;
      }
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0) | 0) >>> 0) break L24;
     }
    } else i3 = 0;
    do {
     i1 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i3 | 0) | 0;
     if (mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i19 | 0, i1 | 0); else if (!(mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] | 0, i20 | 0, i1 | 0) | 0)) {
      if (!(mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, i1 | 0) | 0)) {
       i3 = 24;
       break L22;
      }
      i4 = mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 52 >> 2] | 0, i21 | 0, i1 | 0) | 0;
      if ((i4 | 0) == 0 & (getTempRet0() | 0) == 0) {
       i3 = 26;
       break L22;
      }
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0) | 0) >>> 0);
   } while (0);
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i8 >> 2] | 0) {
    _memset(HEAP32[i9 >> 2] | 0, -1, i1 << 2 | 0) | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    i4 = i2 + -1 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (i4) {
     i3 = 0;
     while (1) {
      i2 = i3 + 1 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
      HEAP32[i1 + (i3 << 2) >> 2] = i2;
      if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
     }
     i2 = HEAP32[i10 >> 2] | 0;
    }
    HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
   }
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0) | 0) >>> 0) break L20;
  }
  if ((i3 | 0) == 24) {
   i24 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i22 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0) | 0;
   i23 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
   HEAP32[i16 >> 2] = i22;
   HEAP32[i16 + 4 >> 2] = i23;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i24, 4, gb + 745680 | 0, 159, gb + 745922 | 0, i16);
  } else if ((i3 | 0) == 26) {
   i24 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i15 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i24, 4, gb + 745680 | 0, 166, gb + 746121 | 0, i15);
  } else if ((i3 | 0) == 27) {
   i24 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i22 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0) | 0;
   i23 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
   HEAP32[i18 >> 2] = i22;
   HEAP32[i18 + 4 >> 2] = i23;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i24, 4, gb + 745680 | 0, 175, gb + 746221 | 0, i18);
  }
  mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 56 >> 2] | 0, i19 | 0);
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 56 >> 2] | 0, i13 | 0);
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 56 >> 2] | 0, i13 | 0);
 i1 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 28 >> 2] | 0, i19 | 0) | 0;
 i2 = (i1 | 0) == 0;
 if (i2) mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 56 >> 2] | 0, i19 | 0); else {
  i3 = 0;
  do {
   i16 = mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 32 >> 2] | 0, i19 | 0, i3 | 0) | 0;
   i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i17 >> 2] = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0, i16 | 0) | 0;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 745680 | 0, 195, gb + 746418 | 0, i17);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
  mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 56 >> 2] | 0, i19 | 0);
  if (!i2) {
   i24 = 0;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 if (!i21) {
  i24 = 1;
  STACKTOP = i25;
  return i24 | 0;
 }
 i12 = __Z18PxCreateCollectionv() | 0;
 HEAP32[i22 >> 2] = gb + 120040 + 8;
 HEAP32[i22 + 4 >> 2] = i12;
 L69 : do if (mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0, i21 | 0) | 0) {
  i6 = i12 + 64 | 0;
  i7 = i12 + 80 | 0;
  i8 = i12 + 56 | 0;
  i9 = i12 + 60 | 0;
  i5 = i12 + 52 | 0;
  i10 = i12 + 72 | 0;
  i11 = 0;
  L71 : while (1) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i11 | 0) | 0;
   i19 = mftCall_iii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, HEAP16[i1 + 4 >> 1] | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i19 | 0, i1 | 0, i22 | 0);
   if (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0) | 0) {
    i3 = 0;
    do {
     i2 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0, i12 | 0, i3 | 0) | 0;
     i3 = i3 + 1 | 0;
     if (mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] | 0, i20 | 0, i2 | 0) | 0) break L71;
    } while (i3 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0) | 0) >>> 0);
   }
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i7 >> 2] | 0) {
    _memset(HEAP32[i8 >> 2] | 0, -1, i1 << 2 | 0) | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i4 = i2 + -1 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (i4) {
     i3 = 0;
     while (1) {
      i2 = i3 + 1 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
      HEAP32[i1 + (i3 << 2) >> 2] = i2;
      if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
     }
     i2 = HEAP32[i9 >> 2] | 0;
    }
    HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
   }
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0, i21 | 0) | 0) >>> 0) break L69;
  }
  mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 56 >> 2] | 0, i12 | 0);
  i23 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i21 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
  i22 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i24 >> 2] = i21;
  HEAP32[i24 + 4 >> 2] = i22;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i23, 4, gb + 745680 | 0, 229, gb + 746612 | 0, i24);
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 56 >> 2] | 0, i12 | 0);
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i24, i25, i35, i1, i2, i50, i51, i52) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i55 + 64 | 0;
 i54 = i55 + 48 | 0;
 i26 = i55 + 32 | 0;
 i27 = i55 + 16 | 0;
 i28 = i55;
 if (i2 >>> 0 >= i50 >>> 0) {
  STACKTOP = i55;
  return;
 }
 i29 = i1 + 500 | 0;
 i30 = i54 + 4 | 0;
 i31 = i54 + 8 | 0;
 i32 = i54 + 12 | 0;
 i33 = i1 + 520 | 0;
 i34 = i54 + 4 | 0;
 i36 = i54 + 8 | 0;
 i37 = i54 + 12 | 0;
 i38 = i53 + 16 | 0;
 i39 = i53 + 32 | 0;
 i22 = i26 + 4 | 0;
 i23 = i26 + 8 | 0;
 i15 = i26 + 12 | 0;
 i16 = i27 + 4 | 0;
 i17 = i27 + 8 | 0;
 i18 = i27 + 12 | 0;
 i19 = i28 + 4 | 0;
 i20 = i28 + 8 | 0;
 i21 = i28 + 12 | 0;
 i40 = i52 + 12 | 0;
 i41 = i52 + 24 | 0;
 i42 = i52 + 4 | 0;
 i43 = i52 + 16 | 0;
 i44 = i52 + 28 | 0;
 i45 = i52 + 8 | 0;
 i46 = i52 + 20 | 0;
 i47 = i52 + 32 | 0;
 i48 = i1 + 120 | 0;
 i49 = i1 + 140 | 0;
 i14 = i1 + 160 | 0;
 do {
  i4 = (HEAP32[i29 >> 2] | 0) + (i2 << 2) | 0;
  i3 = (HEAP32[i4 + 4 >> 2] | 0) + -520366028 | 0;
  i5 = (HEAP32[i4 + 8 >> 2] | 0) + -520366028 | 0;
  i1 = (HEAP32[i4 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i54 >> 2] = (HEAP32[i4 >> 2] | 0) + -520366028;
  HEAP32[i30 >> 2] = i3;
  HEAP32[i31 >> 2] = i5;
  HEAP32[i32 >> 2] = i1;
  __Z17GenerateRandomNx3RKN4math5_int4E(i53, i54);
  i1 = (HEAP32[i33 >> 2] | 0) + (i2 << 2) | 0;
  f59 = Math_fround(HEAPF32[i1 >> 2]);
  f58 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f57 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f58 = Math_fround(f58 * Math_fround(.00999999977));
  f57 = Math_fround(f57 * Math_fround(.00999999977));
  f56 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i54 >> 2] = Math_fround(f59 * Math_fround(.00999999977));
  HEAPF32[i34 >> 2] = f58;
  HEAPF32[i36 >> 2] = f57;
  HEAPF32[i37 >> 2] = f56;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i26, i24, i54, i53);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i27, i25, i54, i38);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i28, i35, i54, i39);
  i1 = HEAP32[i26 >> 2] | 0;
  i5 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i10 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i28 >> 2] | 0;
  i11 = HEAP32[i19 >> 2] | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  if (i51) {
   f65 = Math_fround(HEAPF32[i52 >> 2]);
   f68 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f57 = Math_fround(f68 * f65);
   f67 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f67 * f65);
   f66 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f56 = Math_fround(f66 * f65);
   f61 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f65 = Math_fround(f61 * f65);
   f72 = Math_fround(HEAPF32[i40 >> 2]);
   f64 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f64 * f72);
   f63 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f74 = Math_fround(f63 * f72);
   f62 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f73 = Math_fround(f62 * f72);
   f59 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = Math_fround(f57 + f75);
   f74 = Math_fround(f69 + f74);
   f73 = Math_fround(f56 + f73);
   f72 = Math_fround(f65 + Math_fround(f59 * f72));
   f65 = Math_fround(HEAPF32[i41 >> 2]);
   f56 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f56 * f65);
   f57 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f70 = Math_fround(f57 * f65);
   f58 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f71 = Math_fround(f58 * f65);
   f60 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f69 = Math_fround(f75 + f69);
   f70 = Math_fround(f74 + f70);
   f71 = Math_fround(f73 + f71);
   f65 = Math_fround(f72 + Math_fround(f60 * f65));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   f65 = Math_fround(HEAPF32[i42 >> 2]);
   f71 = Math_fround(f68 * f65);
   f70 = Math_fround(f67 * f65);
   f69 = Math_fround(f66 * f65);
   f65 = Math_fround(f61 * f65);
   f72 = Math_fround(HEAPF32[i43 >> 2]);
   f71 = Math_fround(f71 + Math_fround(f64 * f72));
   f70 = Math_fround(f70 + Math_fround(f63 * f72));
   f69 = Math_fround(f69 + Math_fround(f62 * f72));
   f72 = Math_fround(f65 + Math_fround(f59 * f72));
   f65 = Math_fround(HEAPF32[i44 >> 2]);
   f71 = Math_fround(f71 + Math_fround(f56 * f65));
   f70 = Math_fround(f70 + Math_fround(f57 * f65));
   f69 = Math_fround(f69 + Math_fround(f58 * f65));
   f65 = Math_fround(f72 + Math_fround(f60 * f65));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f71, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f70, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
   f65 = Math_fround(HEAPF32[i45 >> 2]);
   f68 = Math_fround(f68 * f65);
   f67 = Math_fround(f67 * f65);
   f66 = Math_fround(f66 * f65);
   f65 = Math_fround(f61 * f65);
   f61 = Math_fround(HEAPF32[i46 >> 2]);
   f64 = Math_fround(f68 + Math_fround(f64 * f61));
   f63 = Math_fround(f67 + Math_fround(f63 * f61));
   f62 = Math_fround(f66 + Math_fround(f62 * f61));
   f61 = Math_fround(f65 + Math_fround(f59 * f61));
   f59 = Math_fround(HEAPF32[i47 >> 2]);
   f56 = Math_fround(f64 + Math_fround(f56 * f59));
   f57 = Math_fround(f63 + Math_fround(f57 * f59));
   f58 = Math_fround(f62 + Math_fround(f58 * f59));
   f59 = Math_fround(f61 + Math_fround(f60 * f59));
   i13 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f57, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i87 = (HEAP32[i48 >> 2] | 0) + (i2 << 2) | 0;
  f64 = Math_fround(HEAPF32[i87 >> 2]);
  i86 = i87 + 4 | 0;
  f65 = Math_fround(HEAPF32[i86 >> 2]);
  i85 = i87 + 8 | 0;
  f66 = Math_fround(HEAPF32[i85 >> 2]);
  i84 = i87 + 12 | 0;
  f67 = Math_fround(HEAPF32[i84 >> 2]);
  i83 = (HEAP32[i49 >> 2] | 0) + (i2 << 2) | 0;
  f68 = Math_fround(HEAPF32[i83 >> 2]);
  i82 = i83 + 4 | 0;
  f69 = Math_fround(HEAPF32[i82 >> 2]);
  i81 = i83 + 8 | 0;
  f70 = Math_fround(HEAPF32[i81 >> 2]);
  i80 = i83 + 12 | 0;
  f71 = Math_fround(HEAPF32[i80 >> 2]);
  i79 = (HEAP32[i14 >> 2] | 0) + (i2 << 2) | 0;
  f72 = Math_fround(HEAPF32[i79 >> 2]);
  i78 = i79 + 4 | 0;
  f73 = Math_fround(HEAPF32[i78 >> 2]);
  i77 = i79 + 8 | 0;
  f74 = Math_fround(HEAPF32[i77 >> 2]);
  i76 = i79 + 12 | 0;
  f75 = Math_fround(HEAPF32[i76 >> 2]);
  f64 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f64);
  f65 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f65);
  f66 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f66);
  f67 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f67);
  f68 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f68);
  f69 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f69);
  f70 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f70);
  f71 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f71);
  f72 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f72);
  f73 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f73);
  f74 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f74);
  f75 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f75);
  HEAPF32[i87 >> 2] = f64;
  HEAPF32[i86 >> 2] = f65;
  HEAPF32[i85 >> 2] = f66;
  HEAPF32[i84 >> 2] = f67;
  HEAPF32[i83 >> 2] = f68;
  HEAPF32[i82 >> 2] = f69;
  HEAPF32[i81 >> 2] = f70;
  HEAPF32[i80 >> 2] = f71;
  HEAPF32[i79 >> 2] = f72;
  HEAPF32[i78 >> 2] = f73;
  HEAPF32[i77 >> 2] = f74;
  HEAPF32[i76 >> 2] = f75;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i50 >>> 0);
 STACKTOP = i55;
 return;
}

function __Z21GetImagePixelBilinearPKhii13TextureFormat15TextureWrapModeff(i22, i13, i23, i24, i25, i18, f1, f2) {
 i22 = i22 | 0;
 i13 = i13 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i18 = i18 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 16 | 0;
 i27 = i28;
 f1 = Math_fround(Math_fround(i23 | 0) * f1);
 f2 = Math_fround(Math_fround(i24 | 0) * f2);
 i20 = f1 >= Math_fround(0.0);
 f29 = Math_fround(f1 + Math_fround(-.99999994));
 i20 = ~~(i20 ? f1 : f29);
 i21 = f2 >= Math_fround(0.0);
 f29 = Math_fround(f2 + Math_fround(-.99999994));
 i21 = ~~(i21 ? f2 : f29);
 f1 = Math_fround(f1 - Math_fround(i20 | 0));
 f2 = Math_fround(f2 - Math_fround(i21 | 0));
 i4 = (i25 + -10 | 0) >>> 0 < 3;
 do if (i4) i19 = 6; else if (((i25 | 1) + -25 | 0) >>> 0 < 5) i19 = 6; else {
  i3 = i25 + -30 | 0;
  if (i3 >>> 0 < 15) if ((i25 + -48 | 0) >>> 0 < 12 | ((i25 + -45 | 0) >>> 0 < 3 | (30847 >>> (i3 & 65535) & 1) != 0)) {
   i19 = 6;
   break;
  } else {
   i19 = 23;
   break;
  } else if ((i25 + -45 | 0) >>> 0 < 3 | (i25 + -48 | 0) >>> 0 < 12) {
   i19 = 6;
   break;
  } else {
   i19 = 23;
   break;
  }
 } while (0);
 L7 : do if ((i19 | 0) == 6) {
  switch (i25 | 0) {
  case 10:
  case 11:
  case 12:
  case 26:
  case 27:
   break;
  default:
   {
    i3 = i25 | 1;
    if ((i3 | 0) != 25) if (i4 | (i3 + -25 | 0) >>> 0 < 5) {
     i19 = 26;
     break L7;
    } else {
     i19 = 23;
     break L7;
    }
   }
  }
  i3 = (i20 | 0) < 0;
  if (!i3) if ((i21 | 0) > -1 & (i20 + 1 | 0) < (i23 | 0) & (i21 + 1 | 0) < (i24 | 0)) {
   __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i13, i23, i24, i25, i20, i21, 2, 2, i26) | 0;
   i19 = 49;
   break;
  }
  i8 = (i23 | 0) == 0;
  i9 = (i24 | 0) == 0;
  i10 = i27 + 4 | 0;
  i11 = i27 + 8 | 0;
  i12 = i27 + 12 | 0;
  i4 = (i23 | 0) < 1;
  i5 = (i24 | 0) < 1;
  i6 = i24 + -1 | 0;
  i7 = i23 + -1 | 0;
  if (!i18) i6 = 0; else {
   i16 = i4 | i3 ? 0 : (i7 | 0) < (i20 | 0) ? i7 : i20;
   i15 = i5 | (i21 | 0) < 0 ? 0 : (i6 | 0) < (i21 | 0) ? i6 : i21;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i27, i13, i23, i24, i25, i18, i16, i15);
   i14 = HEAP32[i10 >> 2] | 0;
   i19 = HEAP32[i11 >> 2] | 0;
   i17 = HEAP32[i12 >> 2] | 0;
   HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + 4 >> 2] = i14;
   HEAP32[i26 + 8 >> 2] = i19;
   HEAP32[i26 + 12 >> 2] = i17;
   i17 = i20 + 1 | 0;
   i20 = i4 | (i20 | 0) < -1 ? 0 : (i7 | 0) < (i17 | 0) ? i7 : i17;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i27, i13, i23, i24, i25, i18, i20, i15);
   i15 = HEAP32[i10 >> 2] | 0;
   i17 = HEAP32[i11 >> 2] | 0;
   i19 = HEAP32[i12 >> 2] | 0;
   HEAP32[i26 + 16 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + 20 >> 2] = i15;
   HEAP32[i26 + 24 >> 2] = i17;
   HEAP32[i26 + 28 >> 2] = i19;
   i19 = i21 + 1 | 0;
   i19 = i5 | (i21 | 0) < -1 ? 0 : (i6 | 0) < (i19 | 0) ? i6 : i19;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i27, i13, i23, i24, i25, i18, i16, i19);
   i16 = HEAP32[i10 >> 2] | 0;
   i17 = HEAP32[i11 >> 2] | 0;
   i21 = HEAP32[i12 >> 2] | 0;
   HEAP32[i26 + 32 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + 36 >> 2] = i16;
   HEAP32[i26 + 40 >> 2] = i17;
   HEAP32[i26 + 44 >> 2] = i21;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i27, i13, i23, i24, i25, i18, i20, i19);
   i24 = HEAP32[i10 >> 2] | 0;
   i25 = HEAP32[i11 >> 2] | 0;
   i19 = HEAP32[i12 >> 2] | 0;
   HEAP32[i26 + 48 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + 52 >> 2] = i24;
   HEAP32[i26 + 56 >> 2] = i25;
   HEAP32[i26 + 60 >> 2] = i19;
   i19 = 49;
   break;
  }
  do {
   i3 = (i6 & 1) + i20 | 0;
   i5 = (i6 >>> 1 & 1) + i21 | 0;
   if (i8) i4 = 0; else {
    if ((i3 | 0) < 0) i3 = (Math_imul(1 - ((i3 | 0) / (i23 | 0) | 0) | 0, i23) | 0) + i3 | 0;
    i4 = (i3 | 0) % (i23 | 0) | 0;
   }
   if (i9) i3 = 0; else {
    if ((i5 | 0) < 0) i3 = (Math_imul(1 - ((i5 | 0) / (i24 | 0) | 0) | 0, i24) | 0) + i5 | 0; else i3 = i5;
    i3 = (i3 | 0) % (i24 | 0) | 0;
   }
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i27, i13, i23, i24, i25, 0, i4, i3);
   i17 = HEAP32[i10 >> 2] | 0;
   i18 = HEAP32[i11 >> 2] | 0;
   i19 = HEAP32[i12 >> 2] | 0;
   HEAP32[i26 + (i6 << 4) >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + (i6 << 4) + 4 >> 2] = i17;
   HEAP32[i26 + (i6 << 4) + 8 >> 2] = i18;
   HEAP32[i26 + (i6 << 4) + 12 >> 2] = i19;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 4);
  i19 = 49;
 } while (0);
 L33 : do if ((i19 | 0) == 23) {
  i3 = i25 + -30 | 0;
  if (i3 >>> 0 < 15) {
   if ((i25 + -48 | 0) >>> 0 < 12 | ((i25 + -45 | 0) >>> 0 < 3 | (30847 >>> (i3 & 65535) & 1) != 0)) {
    i19 = 26;
    break;
   }
  } else if ((i25 + -45 | 0) >>> 0 < 3 | (i25 + -48 | 0) >>> 0 < 12) {
   i19 = 26;
   break;
  }
  i17 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i23, i25) | 0;
  if (!i13) i19 = 31; else {
   if ((i25 | 0) < 9) i3 = 1; else i3 = (i25 | 0) == 1e3 | ((i25 | 0) == 23 | (i25 + -13 | 0) >>> 0 < 9);
   if (!((i23 | 0) > 0 & (i24 | 0) > 0 & (i25 | 0) > 0 & i3)) i19 = 31;
  }
  if ((i19 | 0) == 31) i13 = 0;
  i11 = (i23 | 0) == 0;
  i12 = (i24 | 0) == 0;
  i7 = (i23 | 0) < 1;
  i8 = (i24 | 0) < 1;
  i9 = i24 + -1 | 0;
  i10 = i23 + -1 | 0;
  i14 = i27 + 4 | 0;
  i15 = i27 + 8 | 0;
  i16 = i27 + 12 | 0;
  if (!i18) i6 = 0; else {
   i6 = 0;
   while (1) {
    i3 = (i6 & 1) + i20 | 0;
    i5 = (i6 >>> 1 & 1) + i21 | 0;
    i4 = (i3 | 0) < 0;
    if (i4) i19 = 46; else if (!((i5 | 0) < (i24 | 0) & ((i3 | 0) < (i23 | 0) & (i5 | 0) > -1))) i19 = 46;
    if ((i19 | 0) == 46) {
     i19 = 0;
     i3 = i7 | i4 ? 0 : (i10 | 0) < (i3 | 0) ? i10 : i3;
     if (i8 | (i5 | 0) < 0) i5 = 0; else i5 = (i9 | 0) < (i5 | 0) ? i9 : i5;
    }
    i11 = i13 + (Math_imul(i5, i17) | 0) | 0;
    __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i11 + (Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i25) | 0, i3) | 0) | 0, i25, i27);
    i11 = HEAP32[i14 >> 2] | 0;
    i12 = HEAP32[i15 >> 2] | 0;
    i18 = HEAP32[i16 >> 2] | 0;
    HEAP32[i26 + (i6 << 4) >> 2] = HEAP32[i27 >> 2];
    HEAP32[i26 + (i6 << 4) + 4 >> 2] = i11;
    HEAP32[i26 + (i6 << 4) + 8 >> 2] = i12;
    HEAP32[i26 + (i6 << 4) + 12 >> 2] = i18;
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == 4) {
     i19 = 49;
     break L33;
    }
   }
  }
  do {
   i4 = (i6 & 1) + i20 | 0;
   i3 = (i6 >>> 1 & 1) + i21 | 0;
   i5 = (i4 | 0) < 0;
   if (i5) i19 = 35; else if (!((i3 | 0) < (i24 | 0) & ((i4 | 0) < (i23 | 0) & (i3 | 0) > -1))) i19 = 35;
   if ((i19 | 0) == 35) {
    i19 = 0;
    if (i11) i4 = 0; else {
     if (i5) i4 = (Math_imul(1 - ((i4 | 0) / (i23 | 0) | 0) | 0, i23) | 0) + i4 | 0;
     i4 = (i4 | 0) % (i23 | 0) | 0;
    }
    if (i12) i3 = 0; else {
     if ((i3 | 0) < 0) i3 = (Math_imul(1 - ((i3 | 0) / (i24 | 0) | 0) | 0, i24) | 0) + i3 | 0;
     i3 = (i3 | 0) % (i24 | 0) | 0;
    }
   }
   i9 = i13 + (Math_imul(i3, i17) | 0) | 0;
   __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i9 + (Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i25) | 0, i4) | 0) | 0, i25, i27);
   i9 = HEAP32[i14 >> 2] | 0;
   i10 = HEAP32[i15 >> 2] | 0;
   i18 = HEAP32[i16 >> 2] | 0;
   HEAP32[i26 + (i6 << 4) >> 2] = HEAP32[i27 >> 2];
   HEAP32[i26 + (i6 << 4) + 4 >> 2] = i9;
   HEAP32[i26 + (i6 << 4) + 8 >> 2] = i10;
   HEAP32[i26 + (i6 << 4) + 12 >> 2] = i18;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 4);
  i19 = 49;
 } while (0);
 if ((i19 | 0) == 26) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1702, 1, 0, 0, 0);
  HEAPF32[i22 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i28;
  return;
 } else if ((i19 | 0) == 49) {
  f29 = Math_fround(Math_fround(1.0) - f1);
  f37 = Math_fround(f29 * Math_fround(HEAPF32[i26 >> 2]));
  f39 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 4 >> 2]));
  f33 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 8 >> 2]));
  f36 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 12 >> 2]));
  f34 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 16 >> 2]));
  f40 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 20 >> 2]));
  f38 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 24 >> 2]));
  f34 = Math_fround(f37 + f34);
  f40 = Math_fround(f39 + f40);
  f38 = Math_fround(f33 + f38);
  f36 = Math_fround(f36 + Math_fround(f1 * Math_fround(HEAPF32[i26 + 28 >> 2])));
  f33 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 32 >> 2]));
  f39 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 36 >> 2]));
  f37 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 40 >> 2]));
  f29 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 44 >> 2]));
  f32 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 48 >> 2]));
  f31 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 52 >> 2]));
  f30 = Math_fround(f1 * Math_fround(HEAPF32[i26 + 56 >> 2]));
  f35 = Math_fround(Math_fround(1.0) - f2);
  f31 = Math_fround(Math_fround(f35 * f40) + Math_fround(f2 * Math_fround(f39 + f31)));
  f30 = Math_fround(Math_fround(f35 * f38) + Math_fround(f2 * Math_fround(f37 + f30)));
  f29 = Math_fround(Math_fround(f35 * f36) + Math_fround(f2 * Math_fround(f29 + Math_fround(f1 * Math_fround(HEAPF32[i26 + 60 >> 2])))));
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(f35 * f34) + Math_fround(f2 * Math_fround(f33 + f32)));
  HEAPF32[i22 + 4 >> 2] = f31;
  HEAPF32[i22 + 8 >> 2] = f30;
  HEAPF32[i22 + 12 >> 2] = f29;
  STACKTOP = i28;
  return;
 }
}

function __ZN5physx22PxVehicleWheelsSimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx23PxVehicleWheels4SimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i20 >> 2] = HEAP32[gb + 163632 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 163632 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 163632 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 163632 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 163632 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 163632 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 163632 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 163632 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 163664 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 163664 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 163664 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 163664 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 163664 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 163664 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 163664 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 163664 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 163696 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 163696 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 163696 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 163696 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 163696 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 163696 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 163696 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 163696 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 163728 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 163728 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 163728 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 163728 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 163728 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 163728 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 163728 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 163728 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 163760 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 163760 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 163760 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 163760 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 163760 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 163760 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 163760 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 163760 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 163792 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 163792 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 163792 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 163792 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 163792 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 163792 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 163792 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 163792 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 162544 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 162544 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 162544 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 162544 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 162544 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 162544 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 162544 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 162544 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 163824 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 163824 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 163824 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 163824 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 163824 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 163824 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 163824 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 163824 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 163856 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 163856 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 163856 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 163856 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 163856 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 163856 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 163856 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 163856 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 163888 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 163888 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 163888 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 163888 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 163888 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 163888 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 163888 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 163888 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 163920 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 163920 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 163920 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 163920 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 163920 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 163920 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 163920 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 163920 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 163952 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 163952 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 163952 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 163952 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 163952 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 163952 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 163952 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 163952 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 163984 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 163984 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 163984 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 163984 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 163984 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 163984 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 163984 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 163984 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 164016 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 164016 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 164016 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 164016 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 164016 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 164016 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 164016 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 164016 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 164048 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 164048 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 164048 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 164048 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 164048 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 164048 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 164048 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 164048 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 164080 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 164080 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 164080 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 164080 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 164080 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 164080 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 164080 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 164080 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 164112 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 164112 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 164112 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 164112 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 164112 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 164112 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 164112 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 164112 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 164144 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 164144 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 164144 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 164144 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 164144 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 164144 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 164144 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 164144 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_PS2_RNS3_18ImpulseAccumulatorE(i1, i2, i112, i95, i92) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i112 = i112 | 0;
 i95 = i95 | 0;
 i92 = i92 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i84 = 0, i85 = 0, i86 = 0, i87 = 0, i88 = 0, i89 = 0, i90 = 0, i91 = 0, i93 = 0, i94 = 0, i96 = 0, i97 = 0, i98 = 0, i99 = 0, i100 = 0, i101 = 0, i102 = 0, i103 = 0, i104 = 0, i105 = 0, i106 = 0, i107 = 0, i108 = 0, i109 = 0, i110 = 0, i111 = 0, i113 = 0, i114 = 0, i115 = 0, i116 = 0, i117 = 0, i118 = 0, i119 = 0, i120 = 0, i121 = 0, i122 = 0, i123 = 0;
 i122 = STACKTOP;
 STACKTOP = STACKTOP + 1680 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i122 + 1648 | 0;
 i4 = i122 + 1632 | 0;
 i114 = i122 + 1616 | 0;
 i7 = i122 + 1608 | 0;
 i115 = i122 + 1592 | 0;
 i18 = i122 + 1576 | 0;
 i116 = i122 + 1560 | 0;
 i29 = i122 + 1544 | 0;
 i117 = i122 + 1528 | 0;
 i40 = i122 + 1512 | 0;
 i113 = i122 + 1496 | 0;
 i51 = i122 + 1480 | 0;
 i97 = i122 + 1464 | 0;
 i62 = i122 + 1456 | 0;
 i98 = i122 + 1440 | 0;
 i73 = i122 + 1424 | 0;
 i99 = i122 + 1408 | 0;
 i84 = i122 + 1392 | 0;
 i100 = i122 + 1376 | 0;
 i91 = i122 + 1360 | 0;
 i96 = i122 + 1344 | 0;
 i8 = i122 + 1328 | 0;
 i118 = i122 + 1312 | 0;
 i9 = i122 + 1296 | 0;
 i10 = i122 + 1280 | 0;
 i11 = i122 + 1264 | 0;
 i12 = i122 + 1248 | 0;
 i13 = i122 + 1232 | 0;
 i14 = i122 + 1216 | 0;
 i107 = i122 + 1200 | 0;
 i15 = i122 + 1184 | 0;
 i16 = i122 + 1168 | 0;
 i17 = i122 + 1152 | 0;
 i19 = i122 + 1136 | 0;
 i20 = i122 + 1120 | 0;
 i21 = i122 + 1104 | 0;
 i106 = i122 + 1088 | 0;
 i22 = i122 + 1072 | 0;
 i23 = i122 + 1056 | 0;
 i24 = i122 + 1040 | 0;
 i25 = i122 + 1024 | 0;
 i26 = i122 + 1008 | 0;
 i27 = i122 + 992 | 0;
 i105 = i122 + 976 | 0;
 i28 = i122 + 960 | 0;
 i104 = i122 + 944 | 0;
 i30 = i122 + 928 | 0;
 i31 = i122 + 912 | 0;
 i119 = i122 + 896 | 0;
 i108 = i122 + 880 | 0;
 i109 = i122 + 864 | 0;
 i32 = i122 + 848 | 0;
 i120 = i122 + 832 | 0;
 i33 = i122 + 816 | 0;
 i34 = i122 + 800 | 0;
 i35 = i122 + 784 | 0;
 i36 = i122 + 1670 | 0;
 i37 = i122 + 768 | 0;
 i93 = i122 + 752 | 0;
 i38 = i122 + 736 | 0;
 i39 = i122 + 720 | 0;
 i41 = i122 + 1669 | 0;
 i42 = i122 + 704 | 0;
 i43 = i122 + 688 | 0;
 i44 = i122 + 672 | 0;
 i45 = i122 + 656 | 0;
 i46 = i122 + 1668 | 0;
 i47 = i122 + 640 | 0;
 i48 = i122 + 624 | 0;
 i49 = i122 + 608 | 0;
 i50 = i122 + 592 | 0;
 i52 = i122 + 576 | 0;
 i53 = i122 + 1667 | 0;
 i101 = i122 + 560 | 0;
 i102 = i122 + 544 | 0;
 i103 = i122 + 528 | 0;
 i111 = i122 + 512 | 0;
 i54 = i122 + 496 | 0;
 i55 = i122 + 480 | 0;
 i56 = i122 + 1666 | 0;
 i57 = i122 + 464 | 0;
 i58 = i122 + 448 | 0;
 i59 = i122 + 432 | 0;
 i60 = i122 + 416 | 0;
 i61 = i122 + 400 | 0;
 i63 = i122 + 384 | 0;
 i64 = i122 + 368 | 0;
 i65 = i122 + 352 | 0;
 i66 = i122 + 336 | 0;
 i67 = i122 + 320 | 0;
 i68 = i122 + 304 | 0;
 i69 = i122 + 288 | 0;
 i70 = i122 + 272 | 0;
 i71 = i122 + 256 | 0;
 i72 = i122 + 240 | 0;
 i74 = i122 + 224 | 0;
 i75 = i122 + 208 | 0;
 i76 = i122 + 192 | 0;
 i77 = i122 + 176 | 0;
 i110 = i122 + 160 | 0;
 i78 = i122 + 144 | 0;
 i79 = i122 + 1665 | 0;
 i80 = i122 + 128 | 0;
 i81 = i122 + 112 | 0;
 i82 = i122 + 96 | 0;
 i94 = i122 + 80 | 0;
 i83 = i122 + 64 | 0;
 i85 = i122 + 1664 | 0;
 i121 = i122 + 48 | 0;
 i86 = i122 + 32 | 0;
 i87 = i122 + 16 | 0;
 i88 = i122;
 i89 = __ZN5physx5cloth5arrayERNS_6PxVec3E(HEAP32[i1 + 416 >> 2] | 0) | 0;
 i90 = __ZN5physx5cloth5arrayERNS_6PxVec3E(HEAP32[i1 + 424 >> 2] | 0) | 0;
 i6 = Math_fround(HEAPF32[(HEAP32[i1 + 432 >> 2] | 0) + 216 >> 2]) > Math_fround(0.0);
 __ZN8Scalar4fC2ERKS_(i4, i2);
 __ZN5physx5cloth12horizontalOrE8Scalar4f(i5, i4);
 i1 = HEAP32[(__ZN5simdi5arrayER8Scalar4f(i5) | 0) >> 2] | 0;
 if (!i1) {
  STACKTOP = i122;
  return;
 }
 i4 = i112 + 16 | 0;
 i5 = i112 + 32 | 0;
 i2 = i95 + 16 | 0;
 i3 = i95 + 32 | 0;
 do {
  i123 = (__ZN5physx5cloth10findBitSetEj(i1 & 0 - i1) | 0) << 4;
  i1 = i1 + -1 & i1;
  __Z11loadAlignedPKfj(i7, i89, i123);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i114, i7);
  __Z5splatILj0EE8Scalar4fRKS0_(i18, i114);
  __ZmiRK8Scalar4fS1_(i115, i112, i18);
  __Z5splatILj1EE8Scalar4fRKS0_(i29, i114);
  __ZmiRK8Scalar4fS1_(i116, i4, i29);
  __Z5splatILj2EE8Scalar4fRKS0_(i40, i114);
  __ZmiRK8Scalar4fS1_(i117, i5, i40);
  __Z5splatILj3EE8Scalar4fRKS0_(i51, i114);
  __ZmlRK8Scalar4fS1_(i113, i51, gb + 1458888 | 0);
  __Z11loadAlignedPKfj(i62, i90, i123);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i97, i62);
  __Z5splatILj0EE8Scalar4fRKS0_(i73, i97);
  __ZmiRK8Scalar4fS1_(i98, i95, i73);
  __Z5splatILj1EE8Scalar4fRKS0_(i84, i97);
  __ZmiRK8Scalar4fS1_(i99, i2, i84);
  __Z5splatILj2EE8Scalar4fRKS0_(i91, i97);
  __ZmiRK8Scalar4fS1_(i100, i3, i91);
  __Z5splatILj3EE8Scalar4fRKS0_(i8, i97);
  __ZmlRK8Scalar4fS1_(i96, i8, gb + 1458888 | 0);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i11, gb + 1097856 | 0);
  __ZmlRK8Scalar4fS1_(i12, i98, i98);
  __ZplRK8Scalar4fS1_(i10, i11, i12);
  __ZmlRK8Scalar4fS1_(i13, i99, i99);
  __ZplRK8Scalar4fS1_(i9, i10, i13);
  __ZmlRK8Scalar4fS1_(i14, i100, i100);
  __ZplRK8Scalar4fS1_(i118, i9, i14);
  __ZmlRK8Scalar4fS1_(i17, i115, i115);
  __ZmlRK8Scalar4fS1_(i19, i116, i116);
  __ZplRK8Scalar4fS1_(i16, i17, i19);
  __ZmlRK8Scalar4fS1_(i20, i117, i117);
  __ZplRK8Scalar4fS1_(i15, i16, i20);
  __ZmlRK8Scalar4fS1_(i21, i113, i113);
  __ZmiRK8Scalar4fS1_(i107, i15, i21);
  __ZmlRK8Scalar4fS1_(i24, i115, i98);
  __ZmlRK8Scalar4fS1_(i25, i116, i99);
  __ZplRK8Scalar4fS1_(i23, i24, i25);
  __ZmlRK8Scalar4fS1_(i26, i117, i100);
  __ZplRK8Scalar4fS1_(i22, i23, i26);
  __ZmlRK8Scalar4fS1_(i27, i113, i96);
  __ZmiRK8Scalar4fS1_(i106, i22, i27);
  __ZmlRK8Scalar4fS1_(i28, i96, i96);
  __ZmiRK8Scalar4fS1_(i105, i118, i28);
  __ZmlRK8Scalar4fS1_(i30, i106, i106);
  __ZmlRK8Scalar4fS1_(i31, i105, i107);
  __ZmiRK8Scalar4fS1_(i104, i30, i31);
  __Z4sqrtRK8Scalar4f(i119, i104);
  __ZmiRK8Scalar4fS1_(i108, i106, i107);
  __ZmiRK8Scalar4fS1_(i32, i106, i105);
  __ZplRK8Scalar4fS1_(i109, i32, i108);
  __Z5recipRK8Scalar4f(i33, i109);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i35, i36);
  __ZplRK8Scalar4fS1_(i37, i108, i119);
  __Z3minRK8Scalar4fS1_(i34, i35, i37);
  __ZmlRK8Scalar4fS1_(i120, i33, i34);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i39, i41);
  __ZltRK8Scalar4fS1_(i38, i120, i39);
  __ZltRK8Scalar4fS1_(i42, i108, i119);
  __ZanRK8Scalar4fS1_(i93, i38, i42);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i45, i46);
  __ZgeRK8Scalar4fS1_(i44, i104, i45);
  __ZanRK8Scalar4fS1_(i43, i93, i44);
  __ZN8Scalar4faSERKS_(i93, i43) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i50, gb + 1097856 | 0);
  __ZngRK8Scalar4f(i49, i50);
  __ZltRK8Scalar4fS1_(i48, i109, i49);
  __ZanRK8Scalar4fS1_(i47, i93, i48);
  __ZN8Scalar4faSERKS_(i93, i47) | 0;
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i52, i53);
  if (!(__Z8allEqualRK8Scalar4fS1_(i93, i52) | 0)) {
   __ZmiRK8Scalar4fS1_(i101, i115, i98);
   __ZmiRK8Scalar4fS1_(i102, i116, i99);
   __ZmiRK8Scalar4fS1_(i103, i117, i100);
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i55, i56);
   __ZmiRK8Scalar4fS1_(i54, i55, i120);
   __ZanRK8Scalar4fS1_(i111, i54, i93);
   __ZmlRK8Scalar4fS1_(i58, i101, i111);
   __ZplRK8Scalar4fS1_(i57, i98, i58);
   __ZN8Scalar4faSERKS_(i98, i57) | 0;
   __ZmlRK8Scalar4fS1_(i60, i102, i111);
   __ZplRK8Scalar4fS1_(i59, i99, i60);
   __ZN8Scalar4faSERKS_(i99, i59) | 0;
   __ZmlRK8Scalar4fS1_(i63, i103, i111);
   __ZplRK8Scalar4fS1_(i61, i100, i63);
   __ZN8Scalar4faSERKS_(i100, i61) | 0;
   __Z5splatILj0EE8Scalar4fRKS0_(i65, i97);
   __ZplRK8Scalar4fS1_(i64, i65, i98);
   __ZN8Scalar4faSERKS_(i95, i64) | 0;
   __Z5splatILj1EE8Scalar4fRKS0_(i67, i97);
   __ZplRK8Scalar4fS1_(i66, i67, i99);
   __ZN8Scalar4faSERKS_(i2, i66) | 0;
   __Z5splatILj2EE8Scalar4fRKS0_(i69, i97);
   __ZplRK8Scalar4fS1_(i68, i69, i100);
   __ZN8Scalar4faSERKS_(i3, i68) | 0;
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i74, gb + 1097856 | 0);
   __ZmlRK8Scalar4fS1_(i75, i98, i98);
   __ZplRK8Scalar4fS1_(i72, i74, i75);
   __ZmlRK8Scalar4fS1_(i76, i99, i99);
   __ZplRK8Scalar4fS1_(i71, i72, i76);
   __ZmlRK8Scalar4fS1_(i77, i100, i100);
   __ZplRK8Scalar4fS1_(i70, i71, i77);
   __ZN8Scalar4faSERKS_(i118, i70) | 0;
  }
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i78, i79);
  __Z5rsqrtRK8Scalar4f(i81, i118);
  __Z5splatILj3EE8Scalar4fRKS0_(i82, i97);
  __ZmlRK8Scalar4fS1_(i80, i81, i82);
  __ZmiRK8Scalar4fS1_(i110, i78, i80);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i83, i85);
  if (__Z10anyGreaterRK8Scalar4fS1_RS_(i83, i110, i94) | 0) {
   __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_(i92, i98, i99, i100, i110, i94);
   if (i6) {
    __ZmiRK8Scalar4fS1_(i121, i97, i114);
    __Z5splatILj0EE8Scalar4fRKS0_(i86, i121);
    __Z5splatILj1EE8Scalar4fRKS0_(i87, i121);
    __Z5splatILj2EE8Scalar4fRKS0_(i88, i121);
    __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_(i92, i86, i87, i88, i94);
   }
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i122;
 return;
}

function __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_(i1, i7, i2, i8, i3, i9, i4, i10, i5, i11, i6, i12, i13) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0;
 f47 = Math_fround(HEAPF32[i2 >> 2]);
 f41 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i7 >> 2]);
 f42 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f22 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f51 = Math_fround(HEAPF32[i8 >> 2]);
 f45 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f50 = Math_fround(HEAPF32[i9 >> 2]);
 f44 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f49 = Math_fround(HEAPF32[i10 >> 2]);
 f43 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f46 = Math_fround(HEAPF32[i11 >> 2]);
 f40 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f68 = Math_fround(f48 - f51);
 f59 = Math_fround(f48 - f50);
 f63 = Math_fround(f48 - f49);
 f54 = Math_fround(f48 - f46);
 f64 = Math_fround(f42 - f45);
 f62 = Math_fround(f42 - f44);
 f60 = Math_fround(f42 - f43);
 f58 = Math_fround(f42 - f40);
 f67 = Math_fround(f30 - f38);
 f69 = Math_fround(f30 - f35);
 f61 = Math_fround(f30 - f32);
 f65 = Math_fround(f30 - f27);
 f52 = Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f41 * f41)) + Math_fround(f29 * f29));
 f17 = Math_fround(Math_fround(f37 * f37) + Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)));
 f16 = Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)));
 f15 = Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)));
 f14 = Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)));
 f57 = Math_fround(Math_fround(f29 * f37) + Math_fround(Math_fround(f47 * f19) + Math_fround(f41 * f18)));
 f56 = Math_fround(Math_fround(f29 * f34) + Math_fround(Math_fround(f47 * f25) + Math_fround(f41 * f24)));
 f55 = Math_fround(Math_fround(f29 * f31) + Math_fround(Math_fround(f47 * f23) + Math_fround(f41 * f22)));
 f53 = Math_fround(Math_fround(f29 * f26) + Math_fround(Math_fround(f47 * f21) + Math_fround(f41 * f20)));
 f39 = Math_fround(Math_fround(f29 * f67) + Math_fround(Math_fround(f47 * f68) + Math_fround(f41 * f64)));
 f36 = Math_fround(Math_fround(f29 * f69) + Math_fround(Math_fround(f47 * f59) + Math_fround(f41 * f62)));
 f33 = Math_fround(Math_fround(f29 * f61) + Math_fround(Math_fround(f47 * f63) + Math_fround(f41 * f60)));
 f28 = Math_fround(Math_fround(f29 * f65) + Math_fround(Math_fround(f47 * f54) + Math_fround(f41 * f58)));
 f64 = Math_fround(Math_fround(f37 * f67) + Math_fround(Math_fround(f19 * f68) + Math_fround(f18 * f64)));
 f62 = Math_fround(Math_fround(f34 * f69) + Math_fround(Math_fround(f25 * f59) + Math_fround(f24 * f62)));
 f60 = Math_fround(Math_fround(f31 * f61) + Math_fround(Math_fround(f23 * f63) + Math_fround(f22 * f60)));
 f58 = Math_fround(Math_fround(f26 * f65) + Math_fround(Math_fround(f21 * f54) + Math_fround(f20 * f58)));
 f54 = Math_fround(Math_fround(1.0) / f52);
 f65 = Math_fround(Math_fround(1.0) / f17);
 f63 = Math_fround(Math_fround(1.0) / f16);
 f61 = Math_fround(Math_fround(1.0) / f15);
 f59 = Math_fround(Math_fround(1.0) / f14);
 f69 = Math_fround(Math_fround(f17 * f52) - Math_fround(f57 * f57));
 f68 = Math_fround(Math_fround(f16 * f52) - Math_fround(f56 * f56));
 f67 = Math_fround(Math_fround(f15 * f52) - Math_fround(f55 * f55));
 f66 = Math_fround(Math_fround(f14 * f52) - Math_fround(f53 * f53));
 f17 = Math_fround(Math_fround(Math_fround(f57 * f64) - Math_fround(f17 * f39)) / f69);
 f16 = Math_fround(Math_fround(Math_fround(f56 * f62) - Math_fround(f16 * f36)) / f68);
 f15 = Math_fround(Math_fround(Math_fround(f55 * f60) - Math_fround(f15 * f33)) / f67);
 f14 = Math_fround(Math_fround(Math_fround(f53 * f58) - Math_fround(f14 * f28)) / f66);
 i8 = f17 < Math_fround(1.0);
 f17 = i8 ? f17 : Math_fround(1.0);
 i8 = f16 < Math_fround(1.0);
 f16 = i8 ? f16 : Math_fround(1.0);
 i8 = f15 < Math_fround(1.0);
 f15 = i8 ? f15 : Math_fround(1.0);
 i8 = f14 < Math_fround(1.0);
 f14 = i8 ? f14 : Math_fround(1.0);
 i8 = f17 > Math_fround(0.0);
 f17 = i8 ? f17 : Math_fround(0.0);
 i8 = f16 > Math_fround(0.0);
 f16 = i8 ? f16 : Math_fround(0.0);
 i8 = f15 > Math_fround(0.0);
 f15 = i8 ? f15 : Math_fround(0.0);
 i8 = f14 > Math_fround(0.0);
 f14 = i8 ? f14 : Math_fround(0.0);
 i8 = f69 <= Math_fround(1.1920929e-07);
 i9 = f68 <= Math_fround(1.1920929e-07);
 i10 = f67 <= Math_fround(1.1920929e-07);
 i11 = f66 <= Math_fround(1.1920929e-07);
 f17 = i8 ? Math_fround(.5) : f17;
 f16 = i9 ? Math_fround(.5) : f16;
 f15 = i10 ? Math_fround(.5) : f15;
 f17 = Math_fround(f65 * Math_fround(f64 + Math_fround(f57 * f17)));
 f16 = Math_fround(f63 * Math_fround(f62 + Math_fround(f56 * f16)));
 f15 = Math_fround(f61 * Math_fround(f60 + Math_fround(f55 * f15)));
 f14 = Math_fround(f59 * Math_fround(f58 + Math_fround(f53 * (i11 ? Math_fround(.5) : f14))));
 i11 = f17 < Math_fround(1.0);
 f17 = i11 ? f17 : Math_fround(1.0);
 i11 = f16 < Math_fround(1.0);
 f16 = i11 ? f16 : Math_fround(1.0);
 i11 = f15 < Math_fround(1.0);
 f15 = i11 ? f15 : Math_fround(1.0);
 i11 = f14 < Math_fround(1.0);
 f14 = i11 ? f14 : Math_fround(1.0);
 i11 = f17 > Math_fround(0.0);
 f17 = i11 ? f17 : Math_fround(0.0);
 i11 = f16 > Math_fround(0.0);
 f16 = i11 ? f16 : Math_fround(0.0);
 i11 = f15 > Math_fround(0.0);
 f15 = i11 ? f15 : Math_fround(0.0);
 i11 = f14 > Math_fround(0.0);
 f14 = i11 ? f14 : Math_fround(0.0);
 f39 = Math_fround(f54 * Math_fround(Math_fround(f57 * f17) - f39));
 f36 = Math_fround(f54 * Math_fround(Math_fround(f56 * f16) - f36));
 f33 = Math_fround(f54 * Math_fround(Math_fround(f55 * f15) - f33));
 f28 = Math_fround(f54 * Math_fround(Math_fround(f53 * f14) - f28));
 i11 = f52 <= Math_fround(1.1920929e-07);
 i10 = f39 < Math_fround(1.0);
 f39 = i10 ? f39 : Math_fround(1.0);
 i10 = f36 < Math_fround(1.0);
 f36 = i10 ? f36 : Math_fround(1.0);
 i10 = f33 < Math_fround(1.0);
 f33 = i10 ? f33 : Math_fround(1.0);
 i10 = f28 < Math_fround(1.0);
 f28 = i10 ? f28 : Math_fround(1.0);
 i10 = f39 > Math_fround(0.0);
 f39 = i10 ? f39 : Math_fround(0.0);
 i10 = f36 > Math_fround(0.0);
 f36 = i10 ? f36 : Math_fround(0.0);
 i10 = f33 > Math_fround(0.0);
 f33 = i10 ? f33 : Math_fround(0.0);
 i10 = f28 > Math_fround(0.0);
 f28 = i10 ? f28 : Math_fround(0.0);
 f39 = i11 ? Math_fround(0.0) : f39;
 f36 = i11 ? Math_fround(0.0) : f36;
 f33 = i11 ? Math_fround(0.0) : f33;
 f28 = i11 ? Math_fround(0.0) : f28;
 HEAPF32[i12 >> 2] = f39;
 HEAPF32[i12 + 4 >> 2] = f36;
 HEAPF32[i12 + 8 >> 2] = f33;
 HEAPF32[i12 + 12 >> 2] = f28;
 HEAPF32[i13 >> 2] = f17;
 HEAPF32[i13 + 4 >> 2] = f16;
 HEAPF32[i13 + 8 >> 2] = f15;
 HEAPF32[i13 + 12 >> 2] = f14;
 f19 = Math_fround(Math_fround(f48 + Math_fround(f47 * f39)) - Math_fround(f51 + Math_fround(f19 * f17)));
 f25 = Math_fround(Math_fround(f48 + Math_fround(f47 * f36)) - Math_fround(f50 + Math_fround(f25 * f16)));
 f23 = Math_fround(Math_fround(f48 + Math_fround(f47 * f33)) - Math_fround(f49 + Math_fround(f23 * f15)));
 f21 = Math_fround(Math_fround(f48 + Math_fround(f47 * f28)) - Math_fround(f46 + Math_fround(f21 * f14)));
 f18 = Math_fround(Math_fround(f42 + Math_fround(f41 * f39)) - Math_fround(f45 + Math_fround(f18 * f17)));
 f24 = Math_fround(Math_fround(f42 + Math_fround(f41 * f36)) - Math_fround(f44 + Math_fround(f24 * f16)));
 f22 = Math_fround(Math_fround(f42 + Math_fround(f41 * f33)) - Math_fround(f43 + Math_fround(f22 * f15)));
 f20 = Math_fround(Math_fround(f42 + Math_fround(f41 * f28)) - Math_fround(f40 + Math_fround(f20 * f14)));
 f17 = Math_fround(Math_fround(f30 + Math_fround(f29 * f39)) - Math_fround(f38 + Math_fround(f37 * f17)));
 f16 = Math_fround(Math_fround(f30 + Math_fround(f29 * f36)) - Math_fround(f35 + Math_fround(f34 * f16)));
 f15 = Math_fround(Math_fround(f30 + Math_fround(f29 * f33)) - Math_fround(f32 + Math_fround(f31 * f15)));
 f14 = Math_fround(Math_fround(f30 + Math_fround(f29 * f28)) - Math_fround(f27 + Math_fround(f26 * f14)));
 f16 = Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f24 * f24) + Math_fround(f16 * f16)));
 f15 = Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f22 * f22) + Math_fround(f15 * f15)));
 f14 = Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f20 * f20) + Math_fround(f14 * f14)));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)));
 HEAPF32[i1 + 4 >> 2] = f16;
 HEAPF32[i1 + 8 >> 2] = f15;
 HEAPF32[i1 + 12 >> 2] = f14;
 return;
}

function __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i20, i17, i1, i18, i19, i15) {
 i20 = i20 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i16 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i22;
 i21 = i20 + 4 | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 if (i15) {
  f26 = Math_fround(HEAPF32[i17 >> 2]);
  f28 = Math_fround(-f26);
  f30 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f12 = Math_fround(-f30);
  f32 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f4 = Math_fround(-f32);
  f3 = Math_fround(HEAPF32[i17 + 12 >> 2]);
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  f24 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f10 = Math_fround(f24 * f28);
  f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f6 = Math_fround(f29 * f12);
  f31 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f27 = Math_fround(f3 * f31);
  f9 = Math_fround(Math_fround(Math_fround(f7 * f4) + Math_fround(Math_fround(f24 * f12) + f27)) - Math_fround(f29 * f28));
  f25 = Math_fround(f3 * f7);
  f6 = Math_fround(Math_fround(Math_fround(f25 + f10) + f6) - Math_fround(f31 * f4));
  f10 = Math_fround(f3 * f29);
  f12 = Math_fround(Math_fround(Math_fround(f31 * f28) + Math_fround(Math_fround(f24 * f4) + f10)) - Math_fround(f7 * f12));
  f25 = Math_fround(Math_fround(f24 * f26) + f25);
  f27 = Math_fround(Math_fround(f24 * f30) + f27);
  f10 = Math_fround(Math_fround(f24 * f32) + f10);
  f24 = Math_fround(f3 * f24);
  f3 = Math_fround(f26 * f7);
  f4 = Math_fround(f30 * f31);
  f28 = Math_fround(f32 * f29);
  f23 = Math_fround(Math_fround(f3 + f4) + f28);
  f5 = Math_fround(f24 - f23);
  f11 = Math_fround(Math_fround(f30 * f7) + Math_fround(f26 * f31));
  f26 = Math_fround(Math_fround(f32 * f7) + Math_fround(f26 * f29));
  f3 = Math_fround(Math_fround(Math_fround(f3 + f3) + f5) * Math_fround(.5));
  f7 = Math_fround(Math_fround(f11 + f10) * Math_fround(.5));
  f8 = Math_fround(Math_fround(f26 - f27) * Math_fround(.5));
  HEAPF32[i16 >> 2] = f3;
  HEAPF32[i16 + 4 >> 2] = f7;
  HEAPF32[i16 + 8 >> 2] = f8;
  f29 = Math_fround(Math_fround(f32 * f31) + Math_fround(f30 * f29));
  f10 = Math_fround(Math_fround(f11 - f10) * Math_fround(.5));
  f4 = Math_fround(Math_fround(Math_fround(f4 + f4) + f5) * Math_fround(.5));
  f11 = Math_fround(Math_fround(f25 + f29) * Math_fround(.5));
  HEAPF32[i16 + 12 >> 2] = f10;
  i1 = i16 + 16 | 0;
  HEAPF32[i1 >> 2] = f4;
  HEAPF32[i16 + 20 >> 2] = f11;
  f25 = Math_fround(Math_fround(f29 - f25) * Math_fround(.5));
  f5 = Math_fround(Math_fround(Math_fround(f28 + f28) + f5) * Math_fround(.5));
  HEAPF32[i16 + 24 >> 2] = Math_fround(Math_fround(f27 + f26) * Math_fround(.5));
  i13 = i16 + 28 | 0;
  HEAPF32[i13 >> 2] = f25;
  i14 = i16 + 32 | 0;
  HEAPF32[i14 >> 2] = f5;
  if (!(Math_fround(f24 + f23) != Math_fround(0.0))) {
   f3 = Math_fround(f3 + Math_fround(1.1920929e-07));
   HEAPF32[i16 >> 2] = f3;
   f4 = Math_fround(f4 + Math_fround(1.1920929e-07));
   HEAPF32[i1 >> 2] = f4;
   HEAPF32[i14 >> 2] = Math_fround(f5 + Math_fround(1.1920929e-07));
  }
  if (i15 & 1) {
   f32 = Math_fround(-f6);
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAPF32[i2 + 16 >> 2] = f3;
   HEAPF32[i2 + 20 >> 2] = f7;
   HEAPF32[i2 + 24 >> 2] = f8;
   HEAP32[i2 + 32 >> 2] = 0;
   HEAP32[i2 + 36 >> 2] = 0;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAPF32[i2 + 48 >> 2] = f3;
   HEAPF32[i2 + 52 >> 2] = f7;
   HEAPF32[i2 + 56 >> 2] = f8;
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
  if (i15 & 2) {
   f32 = Math_fround(-f9);
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAPF32[i2 + 16 >> 2] = f10;
   HEAPF32[i2 + 20 >> 2] = f4;
   HEAPF32[i2 + 24 >> 2] = f11;
   HEAP32[i2 + 32 >> 2] = 0;
   HEAP32[i2 + 36 >> 2] = 0;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAPF32[i2 + 48 >> 2] = f10;
   HEAPF32[i2 + 52 >> 2] = f4;
   HEAPF32[i2 + 56 >> 2] = f11;
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
  if (i15 & 4) {
   i16 = i16 + 24 | 0;
   f32 = Math_fround(-f12);
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 32 >> 2] = 0;
   HEAP32[i2 + 36 >> 2] = 0;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAP32[i2 + 48 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i2 + 52 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 56 >> 2] = HEAP32[i14 >> 2];
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
 }
 if (i19) {
  f8 = Math_fround(HEAPF32[i17 >> 2]);
  f29 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i17 + 12 >> 2]);
  f32 = Math_fround(f8 + f8);
  f9 = Math_fround(f29 + f29);
  f3 = Math_fround(f31 + f31);
  f11 = Math_fround(f29 * f9);
  f7 = Math_fround(f31 * f3);
  f29 = Math_fround(f32 * f29);
  f30 = Math_fround(f32 * f31);
  f10 = Math_fround(f32 * f6);
  f31 = Math_fround(f9 * f31);
  f9 = Math_fround(f9 * f6);
  f6 = Math_fround(f3 * f6);
  f3 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f7);
  f4 = Math_fround(f29 + f6);
  f5 = Math_fround(f30 - f9);
  f6 = Math_fround(f29 - f6);
  f32 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f32));
  f7 = Math_fround(f32 - f7);
  f8 = Math_fround(f31 + f10);
  f9 = Math_fround(f30 + f9);
  f10 = Math_fround(f31 - f10);
  f11 = Math_fround(f32 - f11);
  if (i19 & 1) {
   f32 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAPF32[i2 >> 2] = f3;
   HEAPF32[i2 + 4 >> 2] = f4;
   HEAPF32[i2 + 8 >> 2] = f5;
   f31 = Math_fround(HEAPF32[i20 + 12 >> 2]);
   f30 = Math_fround(f5 * f31);
   f29 = Math_fround(HEAPF32[i20 + 16 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f4 * f29));
   f29 = Math_fround(f3 * f29);
   f28 = Math_fround(HEAPF32[i20 + 8 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f5 * f28));
   f31 = Math_fround(Math_fround(f4 * f28) - Math_fround(f3 * f31));
   HEAPF32[i2 + 16 >> 2] = f30;
   HEAPF32[i2 + 20 >> 2] = f29;
   HEAPF32[i2 + 24 >> 2] = f31;
   HEAPF32[i2 + 32 >> 2] = f3;
   HEAPF32[i2 + 36 >> 2] = f4;
   HEAPF32[i2 + 40 >> 2] = f5;
   f31 = Math_fround(HEAPF32[i20 + 24 >> 2]);
   f29 = Math_fround(f5 * f31);
   f30 = Math_fround(HEAPF32[i20 + 28 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f4 * f30));
   f30 = Math_fround(f3 * f30);
   f28 = Math_fround(HEAPF32[i20 + 20 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f5 * f28));
   f31 = Math_fround(Math_fround(f4 * f28) - Math_fround(f3 * f31));
   HEAPF32[i2 + 48 >> 2] = f29;
   HEAPF32[i2 + 52 >> 2] = f30;
   HEAPF32[i2 + 56 >> 2] = f31;
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
  if (i19 & 2) {
   f32 = Math_fround(-Math_fround(HEAPF32[i18 + 4 >> 2]));
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAPF32[i2 >> 2] = f6;
   HEAPF32[i2 + 4 >> 2] = f7;
   HEAPF32[i2 + 8 >> 2] = f8;
   f31 = Math_fround(HEAPF32[i20 + 12 >> 2]);
   f30 = Math_fround(f8 * f31);
   f29 = Math_fround(HEAPF32[i20 + 16 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f7 * f29));
   f29 = Math_fround(f6 * f29);
   f28 = Math_fround(HEAPF32[i20 + 8 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f8 * f28));
   f31 = Math_fround(Math_fround(f7 * f28) - Math_fround(f6 * f31));
   HEAPF32[i2 + 16 >> 2] = f30;
   HEAPF32[i2 + 20 >> 2] = f29;
   HEAPF32[i2 + 24 >> 2] = f31;
   HEAPF32[i2 + 32 >> 2] = f6;
   HEAPF32[i2 + 36 >> 2] = f7;
   HEAPF32[i2 + 40 >> 2] = f8;
   f31 = Math_fround(HEAPF32[i20 + 24 >> 2]);
   f29 = Math_fround(f8 * f31);
   f30 = Math_fround(HEAPF32[i20 + 28 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f7 * f30));
   f30 = Math_fround(f6 * f30);
   f28 = Math_fround(HEAPF32[i20 + 20 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f8 * f28));
   f31 = Math_fround(Math_fround(f7 * f28) - Math_fround(f6 * f31));
   HEAPF32[i2 + 48 >> 2] = f29;
   HEAPF32[i2 + 52 >> 2] = f30;
   HEAPF32[i2 + 56 >> 2] = f31;
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
  if (i19 & 4) {
   f32 = Math_fround(-Math_fround(HEAPF32[i18 + 8 >> 2]));
   HEAP16[i2 + 78 >> 1] = 1024;
   HEAPF32[i2 >> 2] = f9;
   HEAPF32[i2 + 4 >> 2] = f10;
   HEAPF32[i2 + 8 >> 2] = f11;
   f31 = Math_fround(HEAPF32[i20 + 12 >> 2]);
   f30 = Math_fround(f11 * f31);
   f29 = Math_fround(HEAPF32[i20 + 16 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f10 * f29));
   f29 = Math_fround(f9 * f29);
   f28 = Math_fround(HEAPF32[i20 + 8 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f11 * f28));
   f31 = Math_fround(Math_fround(f10 * f28) - Math_fround(f9 * f31));
   HEAPF32[i2 + 16 >> 2] = f30;
   HEAPF32[i2 + 20 >> 2] = f29;
   HEAPF32[i2 + 24 >> 2] = f31;
   HEAPF32[i2 + 32 >> 2] = f9;
   HEAPF32[i2 + 36 >> 2] = f10;
   HEAPF32[i2 + 40 >> 2] = f11;
   f31 = Math_fround(HEAPF32[i20 + 24 >> 2]);
   f29 = Math_fround(f11 * f31);
   f30 = Math_fround(HEAPF32[i20 + 28 >> 2]);
   f29 = Math_fround(f29 - Math_fround(f10 * f30));
   f30 = Math_fround(f9 * f30);
   f28 = Math_fround(HEAPF32[i20 + 20 >> 2]);
   f30 = Math_fround(f30 - Math_fround(f11 * f28));
   f31 = Math_fround(Math_fround(f10 * f28) - Math_fround(f9 * f31));
   HEAPF32[i2 + 48 >> 2] = f29;
   HEAPF32[i2 + 52 >> 2] = f30;
   HEAPF32[i2 + 56 >> 2] = f31;
   HEAPF32[i2 + 12 >> 2] = f32;
   i2 = i2 + 80 | 0;
  }
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  HEAP32[i21 >> 2] = i2;
  STACKTOP = i22;
  return;
 }
 do {
  HEAP16[i1 + 76 >> 1] = 16;
  i1 = i1 + 80 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 HEAP32[i21 >> 2] = i2;
 STACKTOP = i22;
 return;
}

function __ZN12b2WheelJoint23InitVelocityConstraintsERK12b2SolverData(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, i37 = 0, i38 = 0, f39 = f0, f40 = f0;
 i34 = HEAP32[i17 + 48 >> 2] | 0;
 i35 = HEAP32[i34 + 8 >> 2] | 0;
 i30 = i17 + 132 | 0;
 HEAP32[i30 >> 2] = i35;
 i28 = HEAP32[i17 + 52 >> 2] | 0;
 i37 = HEAP32[i28 + 8 >> 2] | 0;
 i19 = i17 + 136 | 0;
 HEAP32[i19 >> 2] = i37;
 i12 = i34 + 28 | 0;
 i24 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i17 + 140 | 0;
 HEAP32[i2 >> 2] = i24;
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = i28 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i38 = i17 + 148 | 0;
 HEAP32[i38 >> 2] = i3;
 HEAP32[i38 + 4 >> 2] = i2;
 i38 = HEAP32[i34 + 120 >> 2] | 0;
 i25 = i17 + 156 | 0;
 HEAP32[i25 >> 2] = i38;
 i29 = HEAP32[i28 + 120 >> 2] | 0;
 i26 = i17 + 160 | 0;
 HEAP32[i26 >> 2] = i29;
 i34 = HEAP32[i34 + 128 >> 2] | 0;
 i27 = i17 + 164 | 0;
 HEAP32[i27 >> 2] = i34;
 f15 = Math_fround(HEAPF32[i28 + 128 >> 2]);
 i28 = i17 + 168 | 0;
 HEAPF32[i28 >> 2] = f15;
 f13 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i34 = HEAP32[i18 + 24 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) >> 2]);
 f11 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i34 + (i35 * 12 | 0) + 8 >> 2]);
 i29 = i18 + 28 | 0;
 i38 = HEAP32[i29 >> 2] | 0;
 i31 = HEAP32[i38 + (i35 * 12 | 0) >> 2] | 0;
 i32 = HEAP32[i38 + (i35 * 12 | 0) + 4 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i38 + (i35 * 12 | 0) + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) >> 2]);
 f22 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i34 + (i37 * 12 | 0) + 8 >> 2]);
 i34 = HEAP32[i38 + (i37 * 12 | 0) >> 2] | 0;
 i35 = HEAP32[i38 + (i37 * 12 | 0) + 4 >> 2] | 0;
 f36 = Math_fround(HEAPF32[i38 + (i37 * 12 | 0) + 8 >> 2]);
 f1 = Math_fround(+Math_sin(+f4));
 f4 = Math_fround(+Math_cos(+f4));
 f14 = Math_fround(+Math_sin(+f21));
 f21 = Math_fround(+Math_cos(+f21));
 f23 = Math_fround(HEAPF32[i17 + 76 >> 2]);
 f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(HEAPF32[i17 + 80 >> 2]);
 f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(Math_fround(f4 * f23) - Math_fround(f1 * f8));
 f8 = Math_fround(Math_fround(f1 * f23) + Math_fround(f4 * f8));
 f23 = Math_fround(HEAPF32[i17 + 84 >> 2]);
 f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f6 = Math_fround(HEAPF32[i17 + 88 >> 2]);
 f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f5 = Math_fround(Math_fround(f21 * f23) - Math_fround(f14 * f6));
 f6 = Math_fround(Math_fround(f14 * f23) + Math_fround(f21 * f6));
 f10 = Math_fround(Math_fround(Math_fround(f20 + f5) - f10) - f7);
 f11 = Math_fround(Math_fround(Math_fround(f22 + f6) - f11) - f8);
 f22 = Math_fround(HEAPF32[i17 + 100 >> 2]);
 f20 = Math_fround(f4 * f22);
 f21 = Math_fround(HEAPF32[i17 + 104 >> 2]);
 f20 = Math_fround(f20 - Math_fround(f1 * f21));
 f21 = Math_fround(Math_fround(f1 * f22) + Math_fround(f4 * f21));
 HEAPF32[i17 + 180 >> 2] = f20;
 HEAPF32[i17 + 184 >> 2] = f21;
 f7 = Math_fround(f7 + f10);
 f8 = Math_fround(f8 + f11);
 f22 = Math_fround(Math_fround(f21 * f7) - Math_fround(f20 * f8));
 HEAPF32[i17 + 196 >> 2] = f22;
 f23 = Math_fround(Math_fround(f5 * f21) - Math_fround(f6 * f20));
 HEAPF32[i17 + 200 >> 2] = f23;
 f9 = Math_fround(f13 + f9);
 f13 = Math_fround(Math_fround(f23 * Math_fround(f15 * f23)) + Math_fround(f9 + Math_fround(f22 * Math_fround(f16 * f22))));
 i2 = f13 > Math_fround(0.0);
 f14 = Math_fround(Math_fround(1.0) / f13);
 HEAPF32[i17 + 204 >> 2] = i2 ? f14 : f13;
 i2 = i17 + 212 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i17 + 216 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i12 = i17 + 220 | 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 f13 = Math_fround(HEAPF32[i17 + 68 >> 2]);
 i24 = f13 > Math_fround(0.0);
 if (i24) {
  f40 = Math_fround(HEAPF32[i17 + 92 >> 2]);
  f14 = Math_fround(f4 * f40);
  f39 = Math_fround(HEAPF32[i17 + 96 >> 2]);
  f14 = Math_fround(f14 - Math_fround(f1 * f39));
  f4 = Math_fround(Math_fround(f1 * f40) + Math_fround(f4 * f39));
  HEAPF32[i17 + 172 >> 2] = f14;
  HEAPF32[i17 + 176 >> 2] = f4;
  f1 = Math_fround(Math_fround(f7 * f4) - Math_fround(f8 * f14));
  HEAPF32[i17 + 188 >> 2] = f1;
  f8 = Math_fround(Math_fround(f5 * f4) - Math_fround(f6 * f14));
  HEAPF32[i17 + 192 >> 2] = f8;
  f1 = Math_fround(Math_fround(f8 * Math_fround(f15 * f8)) + Math_fround(f9 + Math_fround(f1 * Math_fround(f16 * f1))));
  if (f1 > Math_fround(0.0)) {
   f9 = Math_fround(Math_fround(1.0) / f1);
   f11 = Math_fround(Math_fround(f10 * f14) + Math_fround(f11 * f4));
   f39 = Math_fround(f13 * Math_fround(6.28318548));
   f40 = Math_fround(f9 * Math_fround(2.0));
   f40 = Math_fround(f39 * Math_fround(f40 * Math_fround(HEAPF32[i17 + 72 >> 2])));
   f39 = Math_fround(f39 * Math_fround(f9 * f39));
   f14 = Math_fround(HEAPF32[i18 >> 2]);
   f40 = Math_fround(f14 * Math_fround(f40 + Math_fround(f14 * f39)));
   i38 = f40 > Math_fround(0.0);
   f13 = Math_fround(Math_fround(1.0) / f40);
   f40 = i38 ? f13 : f40;
   HEAPF32[i12 >> 2] = f40;
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(f11 * f14) * f39) * f40);
   f40 = Math_fround(f1 + f40);
   i38 = f40 > Math_fround(0.0);
   f39 = Math_fround(Math_fround(1.0) / f40);
   HEAPF32[i2 >> 2] = i38 ? f39 : f40;
  }
 } else HEAPF32[i17 + 116 >> 2] = Math_fround(0.0);
 i3 = (HEAP8[i17 + 128 >> 0] | 0) == 0;
 if (i3) {
  HEAPF32[i17 + 208 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 112 >> 2] = Math_fround(0.0);
 } else {
  f1 = Math_fround(f15 + f16);
  i2 = i17 + 208 | 0;
  HEAPF32[i2 >> 2] = f1;
  if (f1 > Math_fround(0.0)) HEAPF32[i2 >> 2] = Math_fround(Math_fround(1.0) / f1);
 }
 if ((HEAP8[i18 + 20 >> 0] | 0) != 0 & (i24 | i3 ^ 1)) {
  f16 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  i37 = i17 + 108 | 0;
  f15 = Math_fround(f16 * Math_fround(HEAPF32[i37 >> 2]));
  HEAPF32[i37 >> 2] = f15;
  i37 = i17 + 116 | 0;
  f40 = Math_fround(f16 * Math_fround(HEAPF32[i37 >> 2]));
  HEAPF32[i37 >> 2] = f40;
  i37 = i17 + 112 | 0;
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i37 >> 2]));
  HEAPF32[i37 >> 2] = f16;
  f39 = Math_fround(f15 * f20);
  f21 = Math_fround(f15 * f21);
  f20 = Math_fround(f40 * Math_fround(HEAPF32[i17 + 172 >> 2]));
  f20 = Math_fround(f39 + f20);
  f21 = Math_fround(f21 + Math_fround(f40 * Math_fround(HEAPF32[i17 + 176 >> 2])));
  f39 = Math_fround(f15 * f22);
  f39 = Math_fround(f16 + Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i17 + 188 >> 2]))));
  f23 = Math_fround(f15 * f23);
  f40 = Math_fround(f16 + Math_fround(f23 + Math_fround(f40 * Math_fround(HEAPF32[i17 + 192 >> 2]))));
  f23 = Math_fround(HEAPF32[i25 >> 2]);
  f22 = Math_fround(f20 * f23);
  f23 = Math_fround(f21 * f23);
  f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f22);
  i37 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f39 = Math_fround(f33 - Math_fround(f39 * Math_fround(HEAPF32[i27 >> 2])));
  f33 = Math_fround(HEAPF32[i26 >> 2]);
  f23 = Math_fround(f20 * f33);
  f33 = Math_fround(f21 * f33);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f23);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
  f40 = Math_fround(f36 + Math_fround(f40 * Math_fround(HEAPF32[i28 >> 2])));
  i28 = i37;
  i37 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = i38;
  i38 = HEAP32[i30 >> 2] | 0;
  i34 = HEAP32[i29 >> 2] | 0;
  i31 = i34 + (i38 * 12 | 0) | 0;
  HEAP32[i31 >> 2] = i28;
  i38 = i34 + (i38 * 12 | 0) + 4 | 0;
  HEAP32[i38 >> 2] = i35;
  i38 = HEAP32[i30 >> 2] | 0;
  i35 = HEAP32[i29 >> 2] | 0;
  i38 = i35 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f39;
  i38 = HEAP32[i19 >> 2] | 0;
  i34 = i35 + (i38 * 12 | 0) | 0;
  HEAP32[i34 >> 2] = i32;
  i38 = i35 + (i38 * 12 | 0) + 4 | 0;
  HEAP32[i38 >> 2] = i37;
  i38 = HEAP32[i19 >> 2] | 0;
  i37 = HEAP32[i29 >> 2] | 0;
  i38 = i37 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f40;
  return;
 } else {
  HEAPF32[i17 + 108 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 116 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 112 >> 2] = Math_fround(0.0);
  f39 = f33;
  f40 = f36;
  i28 = i34;
  i37 = i35;
  i35 = i32;
  i38 = HEAP32[i30 >> 2] | 0;
  i34 = HEAP32[i29 >> 2] | 0;
  i32 = i34 + (i38 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i31;
  i38 = i34 + (i38 * 12 | 0) + 4 | 0;
  HEAP32[i38 >> 2] = i35;
  i38 = HEAP32[i30 >> 2] | 0;
  i35 = HEAP32[i29 >> 2] | 0;
  i38 = i35 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f39;
  i38 = HEAP32[i19 >> 2] | 0;
  i34 = i35 + (i38 * 12 | 0) | 0;
  HEAP32[i34 >> 2] = i28;
  i38 = i35 + (i38 * 12 | 0) + 4 | 0;
  HEAP32[i38 >> 2] = i37;
  i38 = HEAP32[i19 >> 2] | 0;
  i37 = HEAP32[i29 >> 2] | 0;
  i38 = i37 + (i38 * 12 | 0) + 8 | 0;
  HEAPF32[i38 >> 2] = f40;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEbT0_S9_T_(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 switch ((i5 - i6 | 0) / 12 | 0 | 0) {
 case 2:
  {
   i1 = i5 + -12 | 0;
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i6 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 3:
  {
   i3 = i6 + 12 | 0;
   i1 = i5 + -12 | 0;
   i5 = mftCall_iii(HEAP32[i7 >> 2] | 0, i3 | 0, i6 | 0) | 0;
   i2 = mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i3 | 0) | 0;
   if (!i5) {
    if (!i2) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i3 | 0, i6 | 0) | 0)) {
     i8 = 1;
     STACKTOP = i9;
     return i8 | 0;
    };
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i3 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i6, i6 + 12 | 0, i6 + 24 | 0, i5 + -12 | 0, i7) | 0;
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 5:
  {
   i2 = i6 + 12 | 0;
   i3 = i6 + 24 | 0;
   i4 = i6 + 36 | 0;
   i1 = i5 + -12 | 0;
   __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i6, i2, i3, i4, i7) | 0;
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i4 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, i2 | 0, i6 | 0) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   };
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 1:
 case 0:
  {
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i3 = i6 + 24 | 0;
   i1 = i6 + 12 | 0;
   i4 = mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i6 | 0) | 0;
   i2 = mftCall_iii(HEAP32[i7 >> 2] | 0, i3 | 0, i1 | 0) | 0;
   do if (i4) {
    if (i2) {
     HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     break;
    };
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    if (mftCall_iii(HEAP32[i7 >> 2] | 0, i3 | 0, i1 | 0) | 0) {
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    }
   } else if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    if (mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
     HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    }
   } while (0);
   i1 = i6 + 36 | 0;
   L13 : do if ((i1 | 0) == (i5 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       if ((i3 | 0) == (i6 | 0)) break;
       i4 = i3 + -12 | 0;
       if (mftCall_iii(HEAP32[i7 >> 2] | 0, i8 | 0, i4 | 0) | 0) {
        i10 = i3;
        i3 = i4;
        i4 = i10;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 12 | 0) == (i5 | 0);
       break L13;
      }
     }
     i3 = i1 + 12 | 0;
     if ((i3 | 0) == (i5 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i9;
   return i10 | 0;
  }
 }
 return 0;
}

function __Z18tessProjectPolygonP14TESStesselator(i34) {
 i34 = i34 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i36 + 60 | 0;
 i26 = i36 + 48 | 0;
 i31 = i36 + 36 | 0;
 i27 = i36 + 24 | 0;
 i28 = i36 + 12 | 0;
 i33 = i36;
 i35 = HEAP32[i34 >> 2] | 0;
 i29 = HEAP32[i34 + 8 >> 2] | 0;
 HEAP32[i33 >> 2] = i29;
 i24 = HEAP32[i34 + 12 >> 2] | 0;
 i30 = i33 + 4 | 0;
 HEAP32[i30 >> 2] = i24;
 f2 = Math_fround(HEAPF32[i34 + 16 >> 2]);
 i32 = i33 + 8 | 0;
 HEAPF32[i32 >> 2] = f2;
 f5 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i29 = f5 == Math_fround(0.0);
 f4 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f2 == Math_fround(0.0) & (i29 & f4 == Math_fround(0.0))) {
  i24 = HEAP32[i35 >> 2] | 0;
  i3 = i24 + 12 | 0;
  HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i28 >> 2] = i24;
  HEAP32[i27 >> 2] = i24;
  i3 = i26 + 4 | 0;
  i6 = i28 + 4 | 0;
  HEAP32[i6 >> 2] = i24;
  i7 = i25 + 4 | 0;
  i8 = i27 + 4 | 0;
  HEAP32[i8 >> 2] = i24;
  i16 = i26 + 8 | 0;
  i9 = i28 + 8 | 0;
  HEAP32[i9 >> 2] = i24;
  i10 = i25 + 8 | 0;
  i12 = i27 + 8 | 0;
  HEAP32[i12 >> 2] = i24;
  i29 = (i24 | 0) == (i35 | 0);
  if (i29) {
   f18 = Math_fround(HEAPF32[i7 >> 2]);
   f17 = Math_fround(HEAPF32[i3 >> 2]);
   f15 = Math_fround(HEAPF32[i25 >> 2]);
   f14 = Math_fround(HEAPF32[i26 >> 2]);
   f13 = Math_fround(HEAPF32[i10 >> 2]);
   f11 = Math_fround(HEAPF32[i16 >> 2]);
  } else {
   i1 = i24;
   f14 = Math_fround(HEAPF32[i26 >> 2]);
   do {
    f15 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    if (f15 < f14) {
     HEAPF32[i26 >> 2] = f15;
     HEAP32[i28 >> 2] = i1;
     f14 = f15;
    }
    f11 = Math_fround(HEAPF32[i25 >> 2]);
    if (f15 > f11) {
     HEAPF32[i25 >> 2] = f15;
     HEAP32[i27 >> 2] = i1;
    } else f15 = f11;
    f11 = Math_fround(HEAPF32[i1 + 16 >> 2]);
    f17 = Math_fround(HEAPF32[i3 >> 2]);
    if (f11 < f17) {
     HEAPF32[i3 >> 2] = f11;
     HEAP32[i6 >> 2] = i1;
     f17 = f11;
    }
    f18 = Math_fround(HEAPF32[i7 >> 2]);
    if (f11 > f18) {
     HEAPF32[i7 >> 2] = f11;
     HEAP32[i8 >> 2] = i1;
     f18 = f11;
    }
    f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
    f11 = Math_fround(HEAPF32[i16 >> 2]);
    if (f13 < f11) {
     HEAPF32[i16 >> 2] = f13;
     HEAP32[i9 >> 2] = i1;
     f11 = f13;
    }
    f19 = Math_fround(HEAPF32[i10 >> 2]);
    if (f13 > f19) {
     HEAPF32[i10 >> 2] = f13;
     HEAP32[i12 >> 2] = i1;
    } else f13 = f19;
    i1 = HEAP32[i1 >> 2] | 0;
   } while ((i1 | 0) != (i35 | 0));
  }
  i1 = Math_fround(f18 - f17) > Math_fround(f15 - f14) & 1;
  f22 = Math_fround(f13 - f11);
  f23 = Math_fround(HEAPF32[i25 + (i1 << 2) >> 2]);
  i16 = f22 > Math_fround(f23 - Math_fround(HEAPF32[i26 + (i1 << 2) >> 2]));
  i1 = i16 ? 2 : i1;
  f23 = Math_fround(HEAPF32[i26 + (i1 << 2) >> 2]);
  do if (!(f23 >= Math_fround(HEAPF32[i25 + (i1 << 2) >> 2]))) {
   i26 = HEAP32[i28 + (i1 << 2) >> 2] | 0;
   i28 = HEAP32[i27 + (i1 << 2) >> 2] | 0;
   f19 = Math_fround(HEAPF32[i26 + 12 >> 2]);
   f18 = Math_fround(HEAPF32[i28 + 12 >> 2]);
   f19 = Math_fround(f19 - f18);
   HEAPF32[i31 >> 2] = f19;
   f21 = Math_fround(HEAPF32[i26 + 16 >> 2]);
   f20 = Math_fround(HEAPF32[i28 + 16 >> 2]);
   f21 = Math_fround(f21 - f20);
   HEAPF32[i31 + 4 >> 2] = f21;
   f23 = Math_fround(HEAPF32[i26 + 20 >> 2]);
   f22 = Math_fround(HEAPF32[i28 + 20 >> 2]);
   f23 = Math_fround(f23 - f22);
   HEAPF32[i31 + 8 >> 2] = f23;
   if (!i29) {
    f17 = Math_fround(0.0);
    i1 = i24;
    while (1) {
     f14 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) - f18);
     f11 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) - f20);
     f15 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) - f22);
     f13 = Math_fround(Math_fround(f21 * f15) - Math_fround(f23 * f11));
     f15 = Math_fround(Math_fround(f23 * f14) - Math_fround(f19 * f15));
     f14 = Math_fround(Math_fround(f19 * f11) - Math_fround(f21 * f14));
     f11 = Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f13 * f13) + Math_fround(f15 * f15)));
     if (f11 > f17) {
      HEAPF32[i33 >> 2] = f13;
      HEAPF32[i30 >> 2] = f15;
      HEAPF32[i32 >> 2] = f14;
      f5 = f13;
      f2 = f14;
      f4 = f15;
     } else f11 = f17;
     i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == (i35 | 0)) break; else f17 = f11;
    }
    if (!(f11 <= Math_fround(0.0))) break;
   }
   HEAPF32[i32 >> 2] = Math_fround(0.0);
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   i28 = f21 < Math_fround(0.0);
   f4 = Math_fround(-f21);
   i29 = f19 < Math_fround(0.0);
   f2 = Math_fround(-f19);
   i29 = (i28 ? f4 : f21) > (i29 ? f2 : f19) & 1;
   i28 = f23 < Math_fround(0.0);
   f2 = Math_fround(-f23);
   f4 = Math_fround(HEAPF32[i31 + (i29 << 2) >> 2]);
   i31 = f4 < Math_fround(0.0);
   f5 = Math_fround(-f4);
   HEAPF32[i33 + (((i28 ? f2 : f23) > (i31 ? f5 : f4) ? 2 : i29) << 2) >> 2] = Math_fround(1.0);
   f4 = Math_fround(HEAPF32[i30 >> 2]);
   f5 = Math_fround(HEAPF32[i33 >> 2]);
   f2 = Math_fround(HEAPF32[i32 >> 2]);
  } else {
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   HEAPF32[i32 >> 2] = Math_fround(1.0);
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f2 = Math_fround(1.0);
  } while (0);
  i12 = 1;
 } else {
  i12 = 0;
  i24 = HEAP32[i35 >> 2] | 0;
 }
 i9 = i34 + 20 | 0;
 i16 = i34 + 32 | 0;
 i10 = f4 < Math_fround(0.0);
 f23 = Math_fround(-f4);
 i31 = f5 < Math_fround(0.0);
 f21 = Math_fround(-f5);
 i31 = (i10 ? f23 : f4) > (i31 ? f21 : f5) & 1;
 i10 = f2 < Math_fround(0.0);
 f21 = Math_fround(-f2);
 f23 = Math_fround(HEAPF32[i33 + (i31 << 2) >> 2]);
 i32 = f23 < Math_fround(0.0);
 f22 = Math_fround(-f23);
 i31 = (i10 ? f21 : f2) > (i32 ? f22 : f23) ? 2 : i31;
 HEAPF32[i34 + 20 + (i31 << 2) >> 2] = Math_fround(0.0);
 i32 = ((i31 + 1 | 0) >>> 0) % 3 | 0;
 HEAPF32[i34 + 20 + (i32 << 2) >> 2] = Math_fround(1.0);
 i10 = ((i31 + 2 | 0) >>> 0) % 3 | 0;
 HEAPF32[i34 + 20 + (i10 << 2) >> 2] = Math_fround(0.0);
 HEAPF32[i34 + 32 + (i31 << 2) >> 2] = Math_fround(0.0);
 i33 = Math_fround(HEAPF32[i33 + (i31 << 2) >> 2]) > Math_fround(0.0);
 HEAPF32[i34 + 32 + (i32 << 2) >> 2] = i33 ? Math_fround(-0.0) : Math_fround(0.0);
 HEAPF32[i34 + 32 + (i10 << 2) >> 2] = i33 ? Math_fround(1.0) : Math_fround(-1.0);
 i10 = (i24 | 0) == (i35 | 0);
 if (!i10) {
  i3 = i34 + 24 | 0;
  i6 = i34 + 28 | 0;
  i7 = i34 + 36 | 0;
  i8 = i34 + 40 | 0;
  i1 = i24;
  do {
   f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f20 = Math_fround(f21 * Math_fround(HEAPF32[i9 >> 2]));
   f22 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f20 = Math_fround(f20 + Math_fround(f22 * Math_fround(HEAPF32[i3 >> 2])));
   f23 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   HEAPF32[i1 + 24 >> 2] = Math_fround(f20 + Math_fround(f23 * Math_fround(HEAPF32[i6 >> 2])));
   f21 = Math_fround(f21 * Math_fround(HEAPF32[i16 >> 2]));
   f22 = Math_fround(f21 + Math_fround(f22 * Math_fround(HEAPF32[i7 >> 2])));
   HEAPF32[i1 + 28 >> 2] = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i8 >> 2])));
   i1 = HEAP32[i1 >> 2] | 0;
  } while ((i1 | 0) != (i35 | 0));
 }
 if (i12 | 0) {
  i7 = i35 + 44 | 0;
  f2 = Math_fround(0.0);
  i1 = i7;
  L48 : while (1) {
   while (1) {
    i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == (i7 | 0)) break L48;
    i6 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i6 + 28 >> 2] | 0) >= 1) {
     i3 = i6;
     break;
    }
   }
   while (1) {
    i32 = HEAP32[i3 + 16 >> 2] | 0;
    f22 = Math_fround(HEAPF32[i32 + 24 >> 2]);
    i33 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 16 >> 2] | 0;
    f22 = Math_fround(f22 - Math_fround(HEAPF32[i33 + 24 >> 2]));
    f23 = Math_fround(HEAPF32[i32 + 28 >> 2]);
    f2 = Math_fround(f2 + Math_fround(f22 * Math_fround(f23 + Math_fround(HEAPF32[i33 + 28 >> 2]))));
    i3 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i3 | 0) == (i6 | 0)) continue L48;
   }
  }
  if (f2 < Math_fround(0.0)) {
   if (!i10) {
    i1 = i24;
    do {
     i33 = i1 + 28 | 0;
     HEAPF32[i33 >> 2] = Math_fround(-Math_fround(HEAPF32[i33 >> 2]));
     i1 = HEAP32[i1 >> 2] | 0;
    } while ((i1 | 0) != (i35 | 0));
   }
   HEAPF32[i16 >> 2] = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
   i33 = i34 + 36 | 0;
   HEAPF32[i33 >> 2] = Math_fround(-Math_fround(HEAPF32[i33 >> 2]));
   i33 = i34 + 40 | 0;
   HEAPF32[i33 >> 2] = Math_fround(-Math_fround(HEAPF32[i33 >> 2]));
  }
 }
 if (i10) {
  STACKTOP = i36;
  return;
 }
 i8 = i34 + 44 | 0;
 i9 = i34 + 52 | 0;
 i10 = i34 + 48 | 0;
 i7 = i34 + 56 | 0;
 i3 = 0;
 i6 = i24;
 while (1) {
  i1 = i6 + 24 | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  if (i3) {
   if (f2 < Math_fround(HEAPF32[i8 >> 2])) {
    HEAPF32[i8 >> 2] = f2;
    f2 = Math_fround(HEAPF32[i1 >> 2]);
   }
   if (f2 > Math_fround(HEAPF32[i9 >> 2])) HEAPF32[i9 >> 2] = f2;
   i1 = i6 + 28 | 0;
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   if (f2 < Math_fround(HEAPF32[i10 >> 2])) {
    HEAPF32[i10 >> 2] = f2;
    f2 = Math_fround(HEAPF32[i1 >> 2]);
   }
   if (f2 > Math_fround(HEAPF32[i7 >> 2])) HEAPF32[i7 >> 2] = f2;
  } else {
   HEAPF32[i9 >> 2] = f2;
   HEAPF32[i8 >> 2] = f2;
   i34 = HEAP32[i6 + 28 >> 2] | 0;
   HEAP32[i7 >> 2] = i34;
   HEAP32[i10 >> 2] = i34;
  }
  i6 = HEAP32[i6 >> 2] | 0;
  if ((i6 | 0) == (i35 | 0)) break; else i3 = 1;
 }
 STACKTOP = i36;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold26reduceBatchContactsClusterEPKNS0_17PersistentContactEj(i6, i24, i23) {
 i6 = i6 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 16 | 0;
 i22 = i25;
 _memset(i21 | 0, 0, i23 | 0) | 0;
 i20 = (i23 | 0) == 0;
 if (i20) i18 = 0; else {
  f4 = Math_fround(-3402823469999999843913219.0e14);
  i5 = 0;
  i1 = 0;
  while (1) {
   f15 = Math_fround(HEAPF32[i24 + (i5 * 48 | 0) + 16 >> 2]);
   f16 = Math_fround(HEAPF32[i24 + (i5 * 48 | 0) + 20 >> 2]);
   f3 = Math_fround(HEAPF32[i24 + (i5 * 48 | 0) + 24 >> 2]);
   f3 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f3 * f3));
   i2 = f3 > f4;
   i1 = i2 ? i5 : i1;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i23 | 0)) {
    i18 = i1;
    break;
   } else f4 = i2 ? f3 : f4;
  }
 }
 i19 = i6 + 44 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i11 = i24 + (i18 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 HEAP8[i21 + i18 >> 0] = 1;
 HEAP32[i22 >> 2] = i18;
 f3 = Math_fround(HEAPF32[i24 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i24 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i24 + 24 >> 2]);
 i6 = HEAP32[i19 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f3 = Math_fround(f3 - f8);
 f4 = Math_fround(f4 - f9);
 f7 = Math_fround(f7 - f10);
 if (i23 >>> 0 > 1) {
  f4 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f7 * f7));
  i2 = 1;
  i5 = 0;
  while (1) {
   f15 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 16 >> 2]);
   f16 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 20 >> 2]);
   f15 = Math_fround(f15 - f8);
   f16 = Math_fround(f16 - f9);
   f3 = Math_fround(Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 24 >> 2]) - f10);
   f3 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f3 * f3));
   i1 = f3 > f4;
   i5 = i1 ? i2 : i5;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i23 | 0)) break; else f4 = i1 ? f3 : f4;
  }
 } else i5 = 0;
 i6 = i6 + 48 | 0;
 i11 = i24 + (i5 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 HEAP8[i21 + i5 >> 0] = 1;
 i17 = i22 + 4 | 0;
 HEAP32[i17 >> 2] = i5;
 i11 = HEAP32[i19 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i11 + 64 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + 68 >> 2]);
 f26 = Math_fround(HEAPF32[i11 + 72 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f3 = Math_fround(f3 - f8);
 f16 = Math_fround(f16 - f9);
 f26 = Math_fround(f26 - f10);
 f7 = Math_fround(HEAPF32[i11 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 40 >> 2]);
 f14 = Math_fround(Math_fround(f16 * f15) - Math_fround(f26 * f4));
 f15 = Math_fround(Math_fround(f26 * f7) - Math_fround(f3 * f15));
 f7 = Math_fround(Math_fround(f3 * f4) - Math_fround(f16 * f7));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))))));
 f14 = Math_fround(f14 * f16);
 f15 = Math_fround(f15 * f16);
 f16 = Math_fround(f7 * f16);
 if (i20) {
  f4 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i2 = -1;
  i1 = -1;
 } else {
  f4 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(3402823469999999843913219.0e14);
  i6 = 0;
  i2 = -1;
  i1 = -1;
  while (1) {
   if (!(HEAP8[i21 + i6 >> 0] | 0)) {
    f26 = Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 16 >> 2]);
    f3 = Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 20 >> 2]);
    f3 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(f26 - f8)) + Math_fround(f15 * Math_fround(f3 - f9))) + Math_fround(f16 * Math_fround(Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 24 >> 2]) - f10)));
    i13 = f3 > f4;
    f4 = i13 ? f3 : f4;
    i2 = i13 ? i6 : i2;
    if (f7 > f3) i1 = i6; else f3 = f7;
   } else f3 = f7;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i23 | 0)) break; else f7 = f3;
  }
 }
 i6 = i11 + 96 | 0;
 i11 = i24 + (i2 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 HEAP8[i21 + i2 >> 0] = 1;
 i13 = i22 + 8 | 0;
 HEAP32[i13 >> 2] = i2;
 if (!(!(Math_fround(f4 * f3) > Math_fround(0.0)) | i20)) {
  f4 = Math_fround(-3402823469999999843913219.0e14);
  i6 = 0;
  while (1) {
   if (!(HEAP8[i21 + i6 >> 0] | 0)) {
    f8 = Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 16 >> 2]);
    f10 = Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 20 >> 2]);
    f3 = Math_fround(HEAPF32[i24 + (i6 * 48 | 0) + 24 >> 2]);
    i12 = HEAP32[i19 >> 2] | 0;
    f9 = Math_fround(HEAPF32[i12 + 16 >> 2]);
    f26 = Math_fround(HEAPF32[i12 + 20 >> 2]);
    f3 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(f8 - f9)) + Math_fround(f15 * Math_fround(f10 - f26))) + Math_fround(f16 * Math_fround(f3 - Math_fround(HEAPF32[i12 + 24 >> 2]))));
    if (f3 > f4) i1 = i6; else f3 = f4;
   } else f3 = f4;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i23 | 0)) break; else f4 = f3;
  }
 }
 i6 = (HEAP32[i19 >> 2] | 0) + 144 | 0;
 i11 = i24 + (i1 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 HEAP8[i21 + i1 >> 0] = 1;
 i6 = i22 + 12 | 0;
 HEAP32[i6 >> 2] = i1;
 if (i20) {
  i11 = i18;
  i6 = HEAP32[i19 >> 2] | 0;
  i11 = i24 + (i11 * 48 | 0) | 0;
  i12 = i6 + 48 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   i6 = i6 + 4 | 0;
   i11 = i11 + 4 | 0;
  } while ((i6 | 0) < (i12 | 0));
  i6 = HEAP32[i19 >> 2] | 0;
  i6 = i6 + 48 | 0;
  i11 = i24 + (i5 * 48 | 0) | 0;
  i12 = i6 + 48 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   i6 = i6 + 4 | 0;
   i11 = i11 + 4 | 0;
  } while ((i6 | 0) < (i12 | 0));
  i6 = HEAP32[i19 >> 2] | 0;
  i6 = i6 + 96 | 0;
  i11 = i24 + (i2 * 48 | 0) | 0;
  i12 = i6 + 48 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   i6 = i6 + 4 | 0;
   i11 = i11 + 4 | 0;
  } while ((i6 | 0) < (i12 | 0));
  i6 = HEAP32[i19 >> 2] | 0;
  i6 = i6 + 144 | 0;
  i11 = i24 + (i1 * 48 | 0) | 0;
  i12 = i6 + 48 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   i6 = i6 + 4 | 0;
   i11 = i11 + 4 | 0;
  } while ((i6 | 0) < (i12 | 0));
  STACKTOP = i25;
  return;
 } else i2 = 0;
 do {
  if (!(HEAP8[i21 + i2 >> 0] | 0)) {
   f26 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 44 >> 2]);
   f7 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 16 >> 2]);
   f8 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 20 >> 2]);
   f16 = Math_fround(HEAPF32[i24 + (i2 * 48 | 0) + 24 >> 2]);
   i18 = HEAP32[i19 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i18 + 16 >> 2]);
   f9 = Math_fround(HEAPF32[i18 + 20 >> 2]);
   f14 = Math_fround(f7 - f14);
   f9 = Math_fround(f8 - f9);
   f10 = Math_fround(f16 - Math_fround(HEAPF32[i18 + 24 >> 2]));
   f10 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
   i1 = f10 < Math_fround(3402823469999999843913219.0e14);
   f10 = i1 ? f10 : Math_fround(3402823469999999843913219.0e14);
   f9 = Math_fround(HEAPF32[i18 + 64 >> 2]);
   f14 = Math_fround(HEAPF32[i18 + 68 >> 2]);
   f9 = Math_fround(f7 - f9);
   f14 = Math_fround(f8 - f14);
   f15 = Math_fround(f16 - Math_fround(HEAPF32[i18 + 72 >> 2]));
   f15 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
   i1 = f10 > f15;
   f10 = i1 ? f15 : f10;
   f15 = Math_fround(HEAPF32[i18 + 112 >> 2]);
   f14 = Math_fround(HEAPF32[i18 + 116 >> 2]);
   f15 = Math_fround(f7 - f15);
   f14 = Math_fround(f8 - f14);
   f9 = Math_fround(f16 - Math_fround(HEAPF32[i18 + 120 >> 2]));
   f9 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(f9 * f9));
   i20 = f10 > f9;
   f14 = Math_fround(HEAPF32[i18 + 160 >> 2]);
   f15 = Math_fround(HEAPF32[i18 + 164 >> 2]);
   f14 = Math_fround(f7 - f14);
   f15 = Math_fround(f8 - f15);
   f16 = Math_fround(f16 - Math_fround(HEAPF32[i18 + 168 >> 2]));
   i18 = (i20 ? f9 : f10) > Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
   i1 = i22 + ((i18 ? 3 : i20 ? 2 : i1 & 1) << 2) | 0;
   if (Math_fround(HEAPF32[i24 + ((HEAP32[i1 >> 2] | 0) * 48 | 0) + 44 >> 2]) > f26) HEAP32[i1 >> 2] = i2;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i23 | 0));
 i11 = HEAP32[i22 >> 2] | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i11 = i24 + (i11 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 i6 = HEAP32[i19 >> 2] | 0;
 i6 = i6 + 48 | 0;
 i11 = i24 + (i5 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 i6 = HEAP32[i19 >> 2] | 0;
 i6 = i6 + 96 | 0;
 i11 = i24 + (i2 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 i6 = HEAP32[i19 >> 2] | 0;
 i6 = i6 + 144 | 0;
 i11 = i24 + (i1 * 48 | 0) | 0;
 i12 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  i6 = i6 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i6 | 0) < (i12 | 0));
 STACKTOP = i25;
 return;
}

function __ZL24CollectForwardObjectsJobP27CollectForwardObjectsHeader(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0;
 i6 = HEAP32[i24 + 4 >> 2] | 0;
 i25 = i6 + 8 | 0;
 i26 = HEAP32[(HEAP32[i25 >> 2] | 0) + 1832 >> 2] | 0;
 i27 = HEAP32[i6 + 28 >> 2] | 0;
 i28 = i6 + 84 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i27 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i27;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i27 << 5, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i27 << 5, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i23 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 12 >> 2] << 5 | 0) | 0;
  HEAP32[i2 >> 2] = i27;
  HEAP32[i1 >> 2] = i23;
  break;
 } while (0);
 i22 = i6 + 80 | 0;
 HEAP8[i22 >> 0] = 0;
 i23 = i6 + 36 | 0;
 i1 = i6 + 48 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i27;
 i2 = i6 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i27 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i27;
  HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i27, 1, i6 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i27, 1, i6 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i27;
  HEAP32[i23 >> 2] = i21;
  break;
 } while (0);
 if (i27 >>> 0 > i4 >>> 0) {
  i1 = i27 - i4 | 0;
  if (i1 | 0) _memset((HEAP32[i23 >> 2] | 0) + i4 | 0, 0, i1 | 0) | 0;
 }
 f13 = Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + 792 >> 2]);
 if (!i27) return;
 i14 = i6 + 88 | 0;
 i15 = i6 + 16 | 0;
 i16 = i6 + 56 | 0;
 i17 = i6 + 60 | 0;
 i18 = i6 + 64 | 0;
 i19 = i6 + 68 | 0;
 i20 = i6 + 72 | 0;
 i21 = i6 + 76 | 0;
 i11 = i6 + 404 | 0;
 i10 = 0;
 do {
  i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i10 << 2) >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  i12 = i3 + (i2 << 5) | 0;
  i1 = HEAP16[i3 + (i2 << 5) + 16 >> 1] | 0;
  if (i1 << 16 >> 16 == -1) i6 = HEAP32[(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0) + 40 >> 2] | 0; else i6 = i1 << 16 >> 16;
  i8 = i3 + (i2 << 5) + 8 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i26 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i3 + (i2 << 5) + 24 >> 2]);
  if (f5 > f13) {
   i9 = HEAP32[i25 >> 2] | 0;
   f31 = Math_fround(HEAPF32[i9 + 1740 >> 2]);
   i7 = f31 < Math_fround(0.0);
   f32 = Math_fround(-f31);
   f31 = Math_fround(Math_fround(HEAPF32[i4 + (i1 * 360 | 0) + 140 >> 2]) * (i7 ? f32 : f31));
   f32 = Math_fround(HEAPF32[i9 + 1756 >> 2]);
   i7 = f32 < Math_fround(0.0);
   f30 = Math_fround(-f32);
   f32 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i4 + (i1 * 360 | 0) + 144 >> 2]) * (i7 ? f30 : f32)));
   f30 = Math_fround(HEAPF32[i9 + 1772 >> 2]);
   i9 = f30 < Math_fround(0.0);
   f31 = Math_fround(-f30);
   if (!(Math_fround(f5 - Math_fround(f32 + Math_fround(Math_fround(HEAPF32[i4 + (i1 * 360 | 0) + 148 >> 2]) * (i9 ? f31 : f30)))) > f13)) i29 = 19; else {
    i7 = 0;
    i1 = 0;
   }
  } else i29 = 19;
  if ((i29 | 0) == 19) {
   i29 = 0;
   HEAP8[(HEAP32[i23 >> 2] | 0) + i10 >> 0] = 1;
   i9 = i4 + (i1 * 360 | 0) + 232 | 0;
   if (!((HEAPU16[i9 >> 1] | HEAPU8[i9 + 2 >> 0] << 16) & 256)) {
    i7 = 1;
    i1 = 0;
   } else {
    i36 = i4 + (i1 * 360 | 0) + 128 | 0;
    f32 = Math_fround(HEAPF32[i36 >> 2]);
    i35 = i4 + (i1 * 360 | 0) + 140 | 0;
    f32 = Math_fround(f32 - Math_fround(HEAPF32[i35 >> 2]));
    i2 = i4 + (i1 * 360 | 0) + 132 | 0;
    f33 = Math_fround(HEAPF32[i2 >> 2]);
    i3 = i4 + (i1 * 360 | 0) + 144 | 0;
    f33 = Math_fround(f33 - Math_fround(HEAPF32[i3 >> 2]));
    i9 = i4 + (i1 * 360 | 0) + 136 | 0;
    f5 = Math_fround(HEAPF32[i9 >> 2]);
    i7 = i4 + (i1 * 360 | 0) + 148 | 0;
    f5 = Math_fround(f5 - Math_fround(HEAPF32[i7 >> 2]));
    f30 = Math_fround(HEAPF32[i16 >> 2]);
    f31 = Math_fround(HEAPF32[i17 >> 2]);
    f34 = Math_fround(HEAPF32[i18 >> 2]);
    HEAPF32[i16 >> 2] = f32 < f30 ? f32 : f30;
    HEAPF32[i17 >> 2] = f33 < f31 ? f33 : f31;
    HEAPF32[i18 >> 2] = f5 < f34 ? f5 : f34;
    f34 = Math_fround(HEAPF32[i36 >> 2]);
    f34 = Math_fround(f34 + Math_fround(HEAPF32[i35 >> 2]));
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
    f31 = Math_fround(HEAPF32[i9 >> 2]);
    f31 = Math_fround(f31 + Math_fround(HEAPF32[i7 >> 2]));
    f33 = Math_fround(HEAPF32[i19 >> 2]);
    f30 = Math_fround(HEAPF32[i20 >> 2]);
    f32 = Math_fround(HEAPF32[i21 >> 2]);
    HEAPF32[i19 >> 2] = f33 < f34 ? f34 : f33;
    HEAPF32[i20 >> 2] = f30 < f5 ? f5 : f30;
    HEAPF32[i21 >> 2] = f32 < f31 ? f31 : f32;
    i7 = 1;
    i1 = 1;
   }
  }
  if ((i6 | 0) == -1) {
   if (i1) HEAP8[i22 >> 0] = 1;
   i2 = HEAP32[i28 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i6 = i4 + 1 | 0;
   i7 = i2 + 16 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i9 = i8 & 2147483647;
   do if (i6 >>> 0 > i9 >>> 0) {
    i1 = i8 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i36 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i36 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 5 | 0) | 0;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = i36;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i6;
   i36 = (HEAP32[i2 >> 2] | 0) + (i4 << 5) | 0;
   HEAP32[i36 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i36 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i36 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i36 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i36 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i36 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP32[i36 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i36 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
  } else {
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i26 >> 2] | 0;
   i4 = (HEAPU16[i3 + (i2 * 360 | 0) + 224 >> 1] | 0) < 65534;
   i6 = HEAP8[i11 >> 0] | 0;
   i6 = __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i3 + (i2 * 360 | 0) | 0, (i6 & 2) != 0, (i6 & 1) != 0) | 0;
   if (i7) {
    i1 = i3 + (i2 * 360 | 0) + 232 | 0;
    i1 = ((HEAPU16[i1 >> 1] | HEAPU8[i1 + 2 >> 0] << 16) & 256 | 0) != 0;
   } else i1 = 0;
   if (i4 | i6) if (HEAP8[(HEAP32[i24 >> 2] | 0) + 172 >> 0] | 0) {
    if (i1) {
     i6 = i3 + (i2 * 360 | 0) + 128 | 0;
     f34 = Math_fround(HEAPF32[i6 >> 2]);
     i7 = i3 + (i2 * 360 | 0) + 140 | 0;
     f34 = Math_fround(f34 - Math_fround(HEAPF32[i7 >> 2]));
     i8 = i3 + (i2 * 360 | 0) + 132 | 0;
     f30 = Math_fround(HEAPF32[i8 >> 2]);
     i9 = i3 + (i2 * 360 | 0) + 144 | 0;
     f30 = Math_fround(f30 - Math_fround(HEAPF32[i9 >> 2]));
     i35 = i3 + (i2 * 360 | 0) + 136 | 0;
     f31 = Math_fround(HEAPF32[i35 >> 2]);
     i36 = i3 + (i2 * 360 | 0) + 148 | 0;
     f31 = Math_fround(f31 - Math_fround(HEAPF32[i36 >> 2]));
     f32 = Math_fround(HEAPF32[i16 >> 2]);
     f33 = Math_fround(HEAPF32[i17 >> 2]);
     f5 = Math_fround(HEAPF32[i18 >> 2]);
     HEAPF32[i16 >> 2] = f34 < f32 ? f34 : f32;
     HEAPF32[i17 >> 2] = f30 < f33 ? f30 : f33;
     HEAPF32[i18 >> 2] = f31 < f5 ? f31 : f5;
     f5 = Math_fround(HEAPF32[i6 >> 2]);
     f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 >> 2]));
     f31 = Math_fround(HEAPF32[i8 >> 2]);
     f31 = Math_fround(f31 + Math_fround(HEAPF32[i9 >> 2]));
     f33 = Math_fround(HEAPF32[i35 >> 2]);
     f33 = Math_fround(f33 + Math_fround(HEAPF32[i36 >> 2]));
     f30 = Math_fround(HEAPF32[i19 >> 2]);
     f32 = Math_fround(HEAPF32[i20 >> 2]);
     f34 = Math_fround(HEAPF32[i21 >> 2]);
     HEAPF32[i19 >> 2] = f30 < f5 ? f5 : f30;
     HEAPF32[i20 >> 2] = f32 < f31 ? f31 : f32;
     HEAPF32[i21 >> 2] = f34 < f33 ? f33 : f34;
     HEAP8[i22 >> 0] = 1;
    }
    i2 = HEAP32[i28 >> 2] | 0;
    i3 = i2 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i6 = i4 + 1 | 0;
    i7 = i2 + 16 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i6 >>> 0 > i9 >>> 0) {
     i1 = i8 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i7 >> 2] = i1;
      HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i36 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i36 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 5 | 0) | 0;
      HEAP32[i7 >> 2] = i1;
      HEAP32[i2 >> 2] = i36;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i6;
    i36 = (HEAP32[i2 >> 2] | 0) + (i4 << 5) | 0;
    HEAP32[i36 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i36 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i36 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i36 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i36 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    HEAP32[i36 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
    HEAP32[i36 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
    HEAP32[i36 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
    i36 = (HEAP32[i23 >> 2] | 0) + i10 | 0;
    HEAP8[i36 >> 0] = HEAPU8[i36 >> 0] | 2;
   }
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i27 | 0));
 return;
}

function __Z23GetLODGroupAABBUnawakenR10MinMaxAABBRK8LODGroup(i33, i1) {
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i41 + 136 | 0;
 i36 = i41 + 112 | 0;
 i37 = i41 + 48 | 0;
 i38 = i41 + 24 | 0;
 i39 = i41;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i37, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i33 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i33 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i33 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f44 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f43 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f42 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i30 = i33 + 12 | 0;
 HEAPF32[i30 >> 2] = f44;
 i31 = i33 + 16 | 0;
 HEAPF32[i31 >> 2] = f43;
 i32 = i33 + 20 | 0;
 HEAPF32[i32 >> 2] = f42;
 i34 = i1 + 60 | 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (((HEAP32[i34 >> 2] | 0) - i2 | 0) <= 0) {
  STACKTOP = i41;
  return;
 }
 i19 = i1 + 56 | 0;
 i20 = i38 + 4 | 0;
 i21 = i38 + 8 | 0;
 i22 = i38 + 12 | 0;
 i23 = i38 + 16 | 0;
 i24 = i38 + 20 | 0;
 i12 = i36 + 12 | 0;
 i13 = i36 + 16 | 0;
 i16 = i36 + 20 | 0;
 i25 = i38 + 12 | 0;
 i15 = i39 + 4 | 0;
 i18 = i39 + 8 | 0;
 i11 = i39 + 12 | 0;
 i14 = i39 + 16 | 0;
 i17 = i39 + 20 | 0;
 i26 = i33 + 4 | 0;
 i27 = i36 + 4 | 0;
 i28 = i33 + 8 | 0;
 i29 = i36 + 8 | 0;
 i10 = 0;
 i1 = i2;
 do {
  i2 = i1;
  if (HEAP32[i2 + (i10 * 28 | 0) + 20 >> 2] | 0) {
   i9 = 0;
   i1 = i2;
   do {
    i4 = (HEAP32[i1 + (i10 * 28 | 0) + 8 >> 2] | 0) + (i9 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i36 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i40 = 13; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i35, i1, i36);
       i2 = HEAP32[i35 >> 2] | 0;
       i8 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i40 = 13; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i40 = 15;
      }
     }
     if ((i40 | 0) == 13) i40 = 15;
     if ((i40 | 0) == 15) {
      i40 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     i2 = i1 + 28 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (i3 | 0) {
      i5 = i1 + 32 | 0;
      i4 = i5 + 240 | 0;
      i8 = HEAP16[i4 >> 1] | 0;
      if ((i8 & 65535) > 255 | (i8 & 255) << 24 >> 24 != 0) {
       mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0);
       HEAP8[i4 >> 0] = 0;
       HEAP8[i5 + 241 >> 0] = 0;
       i3 = HEAP32[i2 >> 2] | 0;
      }
      i8 = i5 + 4 | 0;
      i7 = i1 + 8 | 0;
      i6 = (((HEAP32[i7 >> 2] | 0) >>> 21) - (HEAP32[gb + 30912 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30912 + 28 >> 2] | 0) >>> 0 ? i1 : 0;
      i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 30872 | 0) | 0;
      if (i2 | 0) {
       i5 = __ZN10MeshFilter13GetSharedMeshEv(i2) | 0;
       if (i5 | 0) {
        HEAP32[i36 >> 2] = i5;
        i2 = HEAP32[gb + 1104264 >> 2] | 0;
        if (!i2) i40 = 26; else {
         if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
          i3 = HEAP32[i2 + 28 >> 2] | 0;
          i4 = HEAP32[i2 + 32 >> 2] | 0;
          i2 = i3 + (i4 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i35, i2, i36);
          i3 = HEAP32[i35 >> 2] | 0;
          i45 = HEAP32[i2 + 28 >> 2] | 0;
          i4 = HEAP32[gb + 1104264 >> 2] | 0;
          i2 = (i3 | 0) == -1 ? i45 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i45 + (i3 << 3) | 0;
          i3 = HEAP32[i4 + 28 >> 2] | 0;
          i4 = HEAP32[i4 + 32 >> 2] | 0;
         }
         if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i40 = 26; else {
          i2 = HEAP32[i2 + 4 >> 2] | 0;
          if (!i2) i40 = 28;
         }
        }
        if ((i40 | 0) == 26) i40 = 28;
        if ((i40 | 0) == 28) {
         i40 = 0;
         i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
        }
        if ((i6 | 0) != 0 & (i2 | 0) != 0) __ZN12MeshRenderer18CalculateLocalAABBER4AABBRKS_RK4Mesh(i38, i6, i2);
       }
      }
      do if ((((HEAP32[i7 >> 2] | 0) >>> 21) - (HEAP32[gb + 29752 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29752 + 28 >> 2] | 0) >>> 0) {
       i4 = HEAP32[i1 + 344 >> 2] | 0;
       if (i4 | 0) {
        HEAP32[i36 >> 2] = i4;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        if (!i1) i40 = 38; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i35, i1, i36);
          i2 = HEAP32[i35 >> 2] | 0;
          i45 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i45 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i45 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i40 = 38; else {
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i40 = 40;
         }
        }
        if ((i40 | 0) == 38) i40 = 40;
        if ((i40 | 0) == 40) {
         i40 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
         if (!i1) break;
        }
        __ZNK14BillboardAsset9GetBoundsEv(i35, i1);
        HEAP32[i38 >> 2] = HEAP32[i35 >> 2];
        HEAP32[i38 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
        HEAP32[i38 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
        HEAP32[i38 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
        HEAP32[i38 + 16 >> 2] = HEAP32[i35 + 16 >> 2];
        HEAP32[i38 + 20 >> 2] = HEAP32[i35 + 20 >> 2];
       }
      } while (0);
      if (((HEAP32[i38 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i20 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i21 >> 2] & 2139095040 | 0) != 2139095040) if (((HEAP32[i22 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i23 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i24 >> 2] & 2139095040 | 0) != 2139095040) {
       __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i37, i8, i35);
       HEAP32[i36 >> 2] = HEAP32[gb + 62500 >> 2];
       HEAP32[i36 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
       HEAP32[i36 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
       f51 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
       f42 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
       f46 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
       HEAPF32[i12 >> 2] = f51;
       HEAPF32[i13 >> 2] = f42;
       HEAPF32[i16 >> 2] = f46;
       f46 = Math_fround(HEAPF32[i38 >> 2]);
       f42 = Math_fround(HEAPF32[i25 >> 2]);
       f51 = Math_fround(f46 - f42);
       f48 = Math_fround(HEAPF32[i20 >> 2]);
       f43 = Math_fround(HEAPF32[i23 >> 2]);
       f50 = Math_fround(f48 - f43);
       f47 = Math_fround(HEAPF32[i21 >> 2]);
       f44 = Math_fround(HEAPF32[i24 >> 2]);
       f49 = Math_fround(f47 - f44);
       HEAPF32[i39 >> 2] = f51;
       HEAPF32[i15 >> 2] = f50;
       HEAPF32[i18 >> 2] = f49;
       f43 = Math_fround(f48 + f43);
       f44 = Math_fround(f47 + f44);
       HEAPF32[i11 >> 2] = Math_fround(f46 + f42);
       HEAPF32[i14 >> 2] = f43;
       HEAPF32[i17 >> 2] = f44;
       __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i39, i35, i36);
       f44 = Math_fround(HEAPF32[i33 >> 2]);
       f43 = Math_fround(HEAPF32[i36 >> 2]);
       f42 = Math_fround(HEAPF32[i26 >> 2]);
       f46 = Math_fround(HEAPF32[i27 >> 2]);
       f47 = Math_fround(HEAPF32[i28 >> 2]);
       f48 = Math_fround(HEAPF32[i29 >> 2]);
       HEAPF32[i33 >> 2] = f43 < f44 ? f43 : f44;
       HEAPF32[i26 >> 2] = f46 < f42 ? f46 : f42;
       HEAPF32[i28 >> 2] = f48 < f47 ? f48 : f47;
       f47 = Math_fround(HEAPF32[i30 >> 2]);
       f48 = Math_fround(HEAPF32[i12 >> 2]);
       f42 = Math_fround(HEAPF32[i31 >> 2]);
       f46 = Math_fround(HEAPF32[i13 >> 2]);
       f44 = Math_fround(HEAPF32[i32 >> 2]);
       f43 = Math_fround(HEAPF32[i16 >> 2]);
       HEAPF32[i30 >> 2] = f47 < f48 ? f48 : f47;
       HEAPF32[i31 >> 2] = f42 < f46 ? f46 : f42;
       HEAPF32[i32 >> 2] = f44 < f43 ? f43 : f44;
       break;
      }
     }
    } while (0);
    i9 = i9 + 1 | 0;
    i1 = HEAP32[i19 >> 2] | 0;
   } while (i9 >>> 0 < (HEAP32[i1 + (i10 * 28 | 0) + 20 >> 2] | 0) >>> 0);
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) < (((HEAP32[i34 >> 2] | 0) - i1 | 0) / 28 | 0 | 0));
 STACKTOP = i41;
 return;
}

function __ZN9rapidjson4UTF8IcE6EncodeINS_13GenericReaderIS1_S1_13JSONAllocatorE11StackStreamEEEvRT_j(i13, i12) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (i12 >>> 0 < 128) {
  i9 = i12 & 255;
  i6 = HEAP32[i13 >> 2] | 0;
  i10 = i6 + 12 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i8 = i6 + 16 | 0;
  i12 = HEAP32[i8 >> 2] | 0;
  i2 = i12;
  i7 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i12 >>> 0) {
   i3 = i6 + 8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4;
   if (!i4) {
    if (!(HEAP32[i6 >> 2] | 0)) {
     i12 = __Znwj(1) | 0;
     HEAP32[i6 >> 2] = i12;
     HEAP32[i6 + 4 >> 2] = i12;
    }
    i1 = HEAP32[i6 + 20 >> 2] | 0;
   } else {
    i1 = i2 - i5 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i7 = i7 - i5 | 0;
   i12 = i7 + 1 | 0;
   i12 = i1 >>> 0 < i12 >>> 0 ? i12 : i1;
   i11 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i12, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i3 >> 2] = i11;
   i1 = i11 + i7 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i11 + i12;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i9;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  return;
 }
 if (i12 >>> 0 < 2048) {
  i9 = (i12 >>> 6 | 192) & 255;
  i2 = HEAP32[i13 >> 2] | 0;
  i10 = i2 + 12 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i3 = i11;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i11 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i11 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i11;
     HEAP32[i2 + 4 >> 2] = i11;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i6 = i8 - i6 | 0;
   i11 = i6 + 1 | 0;
   i11 = i1 >>> 0 < i11 >>> 0 ? i11 : i1;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i8;
   i1 = i8 + i6 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i7 >> 2] = i8 + i11;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i9;
  i11 = i13 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  i10 = (i12 & 63 | 128) & 255;
  i2 = HEAP32[i13 >> 2] | 0;
  i9 = i2 + 12 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i13 = HEAP32[i7 >> 2] | 0;
  i3 = i13;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i13 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i13 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i2 + 4 >> 2] = i13;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i8 = i8 - i6 | 0;
   i13 = i8 + 1 | 0;
   i13 = i1 >>> 0 < i13 >>> 0 ? i13 : i1;
   i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i13, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i12;
   i1 = i12 + i8 | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i12 + i13;
  }
  HEAP32[i9 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i10;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  return;
 }
 if (i12 >>> 0 < 65536) {
  i9 = (i12 >>> 12 | 224) & 255;
  i2 = HEAP32[i13 >> 2] | 0;
  i10 = i2 + 12 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i3 = i11;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i11 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i11 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i11;
     HEAP32[i2 + 4 >> 2] = i11;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i6 = i8 - i6 | 0;
   i11 = i6 + 1 | 0;
   i11 = i1 >>> 0 < i11 >>> 0 ? i11 : i1;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i8;
   i1 = i8 + i6 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i7 >> 2] = i8 + i11;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i9;
  i11 = i13 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  i9 = (i12 >>> 6 & 63 | 128) & 255;
  i2 = HEAP32[i13 >> 2] | 0;
  i10 = i2 + 12 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = i6;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i6 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i3 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i3;
     HEAP32[i2 + 4 >> 2] = i3;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i3 = i8 - i6 | 0;
   i8 = i3 + 1 | 0;
   i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
   i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i6;
   i1 = i6 + i3 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i7 >> 2] = i6 + i8;
  }
  HEAP32[i10 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i9;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  i10 = (i12 & 63 | 128) & 255;
  i2 = HEAP32[i13 >> 2] | 0;
  i9 = i2 + 12 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i13 = HEAP32[i7 >> 2] | 0;
  i3 = i13;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i13 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i13 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i2 + 4 >> 2] = i13;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i8 = i8 - i6 | 0;
   i13 = i8 + 1 | 0;
   i13 = i1 >>> 0 < i13 >>> 0 ? i13 : i1;
   i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i13, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i12;
   i1 = i12 + i8 | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i12 + i13;
  }
  HEAP32[i9 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = i10;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  return;
 }
 i9 = (i12 >>> 18 | 240) & 255;
 i2 = HEAP32[i13 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 16 | 0;
 i11 = HEAP32[i7 >> 2] | 0;
 i3 = i11;
 i8 = i1;
 if ((i1 + 1 | 0) >>> 0 >= i11 >>> 0) {
  i4 = i2 + 8 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i11 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i11;
    HEAP32[i2 + 4 >> 2] = i11;
   }
   i1 = HEAP32[i2 + 20 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i6 = i8 - i6 | 0;
  i11 = i6 + 1 | 0;
  i11 = i1 >>> 0 < i11 >>> 0 ? i11 : i1;
  i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i8;
  i1 = i8 + i6 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i8 + i11;
 }
 HEAP32[i10 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i9;
 i11 = i13 + 4 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i9 = (i12 >>> 12 & 63 | 128) & 255;
 i2 = HEAP32[i13 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i3 = i6;
 i8 = i1;
 if ((i1 + 1 | 0) >>> 0 >= i6 >>> 0) {
  i4 = i2 + 8 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i3 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i2 + 4 >> 2] = i3;
   }
   i1 = HEAP32[i2 + 20 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i3 = i8 - i6 | 0;
  i8 = i3 + 1 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i6;
  i1 = i6 + i3 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i9;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i9 = (i12 >>> 6 & 63 | 128) & 255;
 i2 = HEAP32[i13 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i3 = i6;
 i8 = i1;
 if ((i1 + 1 | 0) >>> 0 >= i6 >>> 0) {
  i4 = i2 + 8 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i3 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i2 + 4 >> 2] = i3;
   }
   i1 = HEAP32[i2 + 20 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i3 = i8 - i6 | 0;
  i8 = i3 + 1 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i6;
  i1 = i6 + i3 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i9;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i10 = (i12 & 63 | 128) & 255;
 i2 = HEAP32[i13 >> 2] | 0;
 i9 = i2 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = i2 + 16 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 i3 = i13;
 i8 = i1;
 if ((i1 + 1 | 0) >>> 0 >= i13 >>> 0) {
  i4 = i2 + 8 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i13 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i13;
    HEAP32[i2 + 4 >> 2] = i13;
   }
   i1 = HEAP32[i2 + 20 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i8 = i8 - i6 | 0;
  i13 = i8 + 1 | 0;
  i13 = i1 >>> 0 < i13 >>> 0 ? i13 : i1;
  i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i13, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i12;
  i1 = i12 + i8 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i12 + i13;
 }
 HEAP32[i9 >> 2] = i1 + 1;
 HEAP8[i1 >> 0] = i10;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 return;
}

function __ZN5physx16PxVehicleNoDrive17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx14PxVehicleDrive17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx15PxVehicleWheels17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx21PxVehicleDriveSimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i20 >> 2] = HEAP32[gb + 161680 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 161680 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 161680 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 161680 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 161680 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 161680 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 161680 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 161680 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = gb + 833702;
 HEAP32[i19 + 4 >> 2] = gb + 828315;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 144;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 1;
 HEAP32[i19 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 161712 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 161712 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 161712 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 161712 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 161712 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 161712 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 161712 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 161712 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 161744 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 161744 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 161744 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 161744 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 161744 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 161744 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 161744 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 161744 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 161776 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 161776 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 161776 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 161776 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 161776 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 161776 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 161776 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 161776 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 161808 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 161808 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 161808 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 161808 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 161808 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 161808 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 161808 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 161808 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 161840 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 161840 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 161840 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 161840 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 161840 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 161840 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 161840 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 161840 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 161872 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 161872 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 161872 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 161872 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 161872 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 161872 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 161872 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 161872 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 161872 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 161872 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 161872 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 161872 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 161872 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 161872 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 161872 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 161872 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 161872 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 161872 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 161872 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 161872 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 161872 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 161872 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 161872 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 161872 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 161904 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 161904 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 161904 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 161904 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 161904 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 161904 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 161904 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 161904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 161904 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 161904 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 161904 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 161904 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 161904 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 161904 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 161904 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 161904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 161904 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 161904 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 161904 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 161904 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 161904 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 161904 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 161904 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 161904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 161904 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 161904 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 161904 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 161904 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 161904 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 161904 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 161904 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 161904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 161936 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 161936 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 161936 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 161936 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 161936 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 161936 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 161936 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 161936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 161936 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 161936 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 161936 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 161936 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 161936 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 161936 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 161936 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 161936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 161936 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 161936 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 161936 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 161936 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 161936 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 161936 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 161936 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 161936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 161936 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 161936 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 161936 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 161936 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 161936 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 161936 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 161936 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 161936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function _wprintf_core(i13, i1, i26, i27, i28) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, d30 = 0.0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i29 + 88 | 0;
 i21 = i29 + 72 | 0;
 i20 = i29 + 40 | 0;
 i19 = i29 + 32 | 0;
 i24 = i29 + 24 | 0;
 i23 = i29 + 16 | 0;
 i18 = i29 + 8 | 0;
 i14 = i29 + 108 | 0;
 i15 = i29;
 i16 = i29 + 112 | 0;
 i17 = i29 + 104 | 0;
 HEAP32[i14 >> 2] = i1;
 i12 = (i13 | 0) != 0;
 i2 = 0;
 i1 = 0;
 i5 = 0;
 L1 : while (1) {
  do if ((i1 | 0) > -1) {
   if ((i2 | 0) <= (2147483647 - i1 | 0)) {
    i1 = i2 + i1 | 0;
    break;
   }
   if (!(HEAP32[i13 >> 2] & 32)) {
    HEAP32[(___errno_location() | 0) >> 2] = 75;
    i1 = -1;
   } else i1 = -1;
  } while (0);
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) {
   i25 = 79;
   break;
  } else i3 = i4;
  L10 : while (1) {
   switch (i2 | 0) {
   case 37:
   case 0:
    break L10;
   default:
    {}
   }
   i11 = i3 + 4 | 0;
   HEAP32[i14 >> 2] = i11;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i11;
  }
  i2 = (_wcsspn(i3, gb + 208012 | 0) | 0) >>> 1;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i11 + (i2 << 1 << 2);
  i2 = i11 + (i2 << 2) - i4 >> 2;
  if (i12) _out(i13, i4, i2);
  if (i2 | 0) continue;
  i11 = (_iswdigit(HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0) | 0) == 0;
  i2 = HEAP32[i14 >> 2] | 0;
  if (i11) i25 = 16; else if ((HEAP32[i2 + 8 >> 2] | 0) == 36) {
   i11 = (HEAP32[i2 + 4 >> 2] | 0) + -48 | 0;
   i6 = 1;
   i5 = i2 + 12 | 0;
  } else i25 = 16;
  if ((i25 | 0) == 16) {
   i25 = 0;
   i11 = -1;
   i6 = i5;
   i5 = i2 + 4 | 0;
  }
  HEAP32[i14 >> 2] = i5;
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = i4 + -32 | 0;
  L24 : do if (i2 >>> 0 < 32) {
   i3 = 0;
   while (1) {
    if (!(1 << i2 & 75913)) break;
    i3 = 1 << i4 + -32 | i3;
    i5 = i5 + 4 | 0;
    HEAP32[i14 >> 2] = i5;
    i4 = HEAP32[i5 >> 2] | 0;
    i2 = i4 + -32 | 0;
    if (i2 >>> 0 >= 32) {
     i25 = 29;
     break L24;
    }
   }
   if ((i4 | 0) == 42) {
    if (!(_iswdigit(HEAP32[i5 + 4 >> 2] | 0) | 0)) i25 = 24; else {
     i4 = HEAP32[i14 >> 2] | 0;
     if ((HEAP32[i4 + 8 >> 2] | 0) == 36) {
      i2 = i4 + 4 | 0;
      HEAP32[i28 + ((HEAP32[i2 >> 2] | 0) + -48 << 2) >> 2] = 10;
      i2 = HEAP32[i27 + ((HEAP32[i2 >> 2] | 0) + -48 << 3) >> 2] | 0;
      i5 = 1;
      i4 = i4 + 12 | 0;
     } else i25 = 24;
    }
    if ((i25 | 0) == 24) {
     i25 = 0;
     if (i6 | 0) {
      i1 = -1;
      break L1;
     }
     if (i12) {
      i10 = (HEAP32[i26 >> 2] | 0) + (4 - 1) & ~(4 - 1);
      i2 = HEAP32[i10 >> 2] | 0;
      HEAP32[i26 >> 2] = i10 + 4;
     } else i2 = 0;
     i5 = 0;
     i4 = (HEAP32[i14 >> 2] | 0) + 4 | 0;
    }
    HEAP32[i14 >> 2] = i4;
    i10 = (i2 | 0) < 0;
    i2 = i10 ? 0 - i2 | 0 : i2;
    i3 = i10 ? i3 | 8192 : i3;
    i10 = i5;
   } else i25 = 29;
  } else {
   i3 = 0;
   i25 = 29;
  } while (0);
  if ((i25 | 0) == 29) {
   i25 = 0;
   i2 = _getint(i14) | 0;
   if ((i2 | 0) < 0) {
    i1 = -1;
    break;
   }
   i10 = i6;
   i4 = HEAP32[i14 >> 2] | 0;
  }
  do if ((HEAP32[i4 >> 2] | 0) == 46) {
   if ((HEAP32[i4 + 4 >> 2] | 0) != 42) {
    HEAP32[i14 >> 2] = i4 + 4;
    i9 = _getint(i14) | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    break;
   }
   i6 = i4 + 8 | 0;
   i5 = (HEAP32[i6 >> 2] | 0) + -48 | 0;
   if (i5 >>> 0 < 10) if ((HEAP32[i4 + 12 >> 2] | 0) == 36) {
    HEAP32[i28 + (i5 << 2) >> 2] = 10;
    i9 = HEAP32[i27 + ((HEAP32[i6 >> 2] | 0) + -48 << 3) >> 2] | 0;
    i4 = i4 + 16 | 0;
    HEAP32[i14 >> 2] = i4;
    break;
   }
   if (i10 | 0) {
    i1 = -1;
    break L1;
   }
   if (i12) {
    i9 = (HEAP32[i26 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i26 >> 2] = i9 + 4;
   } else i4 = 0;
   HEAP32[i14 >> 2] = i6;
   i9 = i4;
   i4 = i6;
  } else i9 = -1; while (0);
  i8 = 0;
  while (1) {
   i5 = (HEAP32[i4 >> 2] | 0) + -65 | 0;
   if (i5 >>> 0 > 57) {
    i1 = -1;
    break L1;
   }
   i4 = i4 + 4 | 0;
   HEAP32[i14 >> 2] = i4;
   i5 = HEAP8[gb + 1074700 + (i8 * 58 | 0) + i5 >> 0] | 0;
   i6 = i5 & 255;
   if ((i6 + -1 | 0) >>> 0 >= 8) break; else i8 = i6;
  }
  if (!(i5 << 24 >> 24)) {
   i1 = -1;
   break;
  }
  i7 = (i11 | 0) > -1;
  do if (i5 << 24 >> 24 == 19) if (i7) {
   i1 = -1;
   break L1;
  } else i25 = 51; else {
   if (i7) {
    HEAP32[i28 + (i11 << 2) >> 2] = i6;
    i7 = i27 + (i11 << 3) | 0;
    i11 = HEAP32[i7 + 4 >> 2] | 0;
    i25 = i15;
    HEAP32[i25 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i25 + 4 >> 2] = i11;
    i25 = 51;
    break;
   }
   if (!i12) {
    i1 = 0;
    break L1;
   }
   _pop_arg_481(i15, i6, i26);
   i4 = HEAP32[i14 >> 2] | 0;
  } while (0);
  if ((i25 | 0) == 51) {
   i25 = 0;
   if (!i12) {
    i2 = 0;
    i5 = i10;
    continue;
   }
  }
  i4 = HEAP32[i4 + -4 >> 2] | 0;
  i4 = (i8 | 0) != 0 & (i4 & 15 | 0) == 3 ? i4 & -33 : i4;
  switch (i4 | 0) {
  case 110:
   switch ((i8 & 255) << 24 >> 24) {
   case 0:
    {
     HEAP32[HEAP32[i15 >> 2] >> 2] = i1;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 1:
    {
     HEAP32[HEAP32[i15 >> 2] >> 2] = i1;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 2:
    {
     i2 = HEAP32[i15 >> 2] | 0;
     HEAP32[i2 >> 2] = i1;
     HEAP32[i2 + 4 >> 2] = ((i1 | 0) < 0) << 31 >> 31;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 3:
    {
     HEAP16[HEAP32[i15 >> 2] >> 1] = i1;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 4:
    {
     HEAP8[HEAP32[i15 >> 2] >> 0] = i1;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 6:
    {
     HEAP32[HEAP32[i15 >> 2] >> 2] = i1;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   case 7:
    {
     i2 = HEAP32[i15 >> 2] | 0;
     HEAP32[i2 >> 2] = i1;
     HEAP32[i2 + 4 >> 2] = ((i1 | 0) < 0) << 31 >> 31;
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   default:
    {
     i2 = 0;
     i5 = i10;
     continue L1;
    }
   }
  case 99:
   {
    _fputwc(_btowc(HEAP32[i15 >> 2] | 0) | 0, i13) | 0;
    i2 = 1;
    i5 = i10;
    continue L1;
   }
  case 67:
   {
    _fputwc(HEAP32[i15 >> 2] | 0, i13) | 0;
    i2 = 1;
    i5 = i10;
    continue L1;
   }
  case 83:
   {
    i5 = HEAP32[i15 >> 2] | 0;
    i4 = _wmemchr(i5, 0, i9) | 0;
    i4 = (i4 | 0) == 0 ? i9 : i4 - i5 >> 2;
    i2 = (i2 | 0) < (i4 | 0) ? i4 : i2;
    if (!(i3 & 8192)) {
     HEAP32[i18 >> 2] = i2 - i4;
     HEAP32[i18 + 4 >> 2] = gb + 1576256;
     _fprintf(i13, gb + 1075164 | 0, i18) | 0;
     _out(i13, i5, i4);
     i5 = i10;
     continue L1;
    } else {
     _out(i13, i5, i4);
     HEAP32[i23 >> 2] = i2 - i4;
     HEAP32[i23 + 4 >> 2] = gb + 1576256;
     _fprintf(i13, gb + 1075164 | 0, i23) | 0;
     i5 = i10;
     continue L1;
    }
   }
  case 115:
   {
    i8 = HEAP32[i15 >> 2] | 0;
    i5 = (i9 | 0) < 0 ? 2147483647 : i9;
    L94 : do if ((i5 | 0) > 0) {
     i6 = i8;
     i4 = 0;
     while (1) {
      i7 = _mbtowc(i17, i6, 4) | 0;
      if ((i7 | 0) <= 0) break;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) < (i5 | 0)) i6 = i6 + i7 | 0; else {
       i6 = i4;
       break L94;
      }
     }
     if ((i7 | 0) < 0) {
      i1 = -1;
      break L1;
     } else i6 = i4;
    } else i6 = 0; while (0);
    i2 = (i2 | 0) < (i6 | 0) ? i6 : i2;
    i5 = (i3 & 8192 | 0) != 0;
    if (!i5) {
     HEAP32[i24 >> 2] = i2 - i6;
     HEAP32[i24 + 4 >> 2] = gb + 1576256;
     _fprintf(i13, gb + 1075164 | 0, i24) | 0;
    }
    if (i6 | 0) {
     i3 = i8;
     i4 = i6;
     do {
      i4 = i4 + -1 | 0;
      i3 = i3 + (_mbtowc(i17, i3, 4) | 0) | 0;
      _fputwc(HEAP32[i17 >> 2] | 0, i13) | 0;
     } while ((i4 | 0) != 0);
    }
    if (!i5) {
     i5 = i10;
     continue L1;
    }
    HEAP32[i19 >> 2] = i2 - i6;
    HEAP32[i19 + 4 >> 2] = gb + 1576256;
    _fprintf(i13, gb + 1075164 | 0, i19) | 0;
    i5 = i10;
    continue L1;
   }
  default:
   {
    i11 = i4 | 32;
    i8 = HEAP8[i11 + -97 + (gb + 1075171) >> 0] | 0;
    HEAP32[i20 >> 2] = (i3 >>> 3 & 1 ^ 1) + (gb + 1075169);
    HEAP32[i20 + 4 >> 2] = (i3 >>> 11 & 1 ^ 1) + (gb + 1087706);
    HEAP32[i20 + 8 >> 2] = (i3 >>> 13 & 1 ^ 1) + (gb + 1087656);
    HEAP32[i20 + 12 >> 2] = (i3 & 1 ^ 1) + (gb + 1086395);
    HEAP32[i20 + 16 >> 2] = (i3 >>> 16 & 1 ^ 1) + (gb + 1075318);
    HEAP32[i20 + 20 >> 2] = i8;
    HEAP32[i20 + 24 >> 2] = i4;
    _snprintf(i16, 16, gb + 1075195 | 0, i20) | 0;
    switch (i11 | 0) {
    case 103:
    case 102:
    case 101:
    case 97:
     {
      d30 = +HEAPF64[i15 >> 3];
      HEAP32[i21 >> 2] = i2;
      HEAP32[i21 + 4 >> 2] = i9;
      HEAPF64[i21 + 8 >> 3] = d30;
      i2 = _fprintf(i13, i16, i21) | 0;
      i5 = i10;
      continue L1;
     }
    case 112:
    case 120:
    case 117:
    case 111:
    case 105:
    case 100:
     {
      i5 = i15;
      i11 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      HEAP32[i22 >> 2] = i2;
      HEAP32[i22 + 4 >> 2] = i9;
      i2 = i22 + 8 | 0;
      HEAP32[i2 >> 2] = i11;
      HEAP32[i2 + 4 >> 2] = i5;
      i2 = _fprintf(i13, i16, i22) | 0;
      i5 = i10;
      continue L1;
     }
    default:
     {
      i2 = 0;
      i5 = i10;
      continue L1;
     }
    }
   }
  }
 }
 L108 : do if ((i25 | 0) == 79) if (!i13) if (!i5) i1 = 0; else {
  i1 = 1;
  while (1) {
   i2 = HEAP32[i28 + (i1 << 2) >> 2] | 0;
   if (!i2) break;
   _pop_arg_481(i27 + (i1 << 3) | 0, i2, i26);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 10) {
    i1 = 1;
    break L108;
   }
  }
  while (1) {
   if (HEAP32[i28 + (i1 << 2) >> 2] | 0) {
    i1 = -1;
    break L108;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 10) {
    i1 = 1;
    break;
   }
  }
 } while (0);
 STACKTOP = i29;
 return i1 | 0;
}

function __ZN5physx3Cct9SweepTest18updateTouchedGeomsEPKNS0_30InternalCBData_FindTouchedGeomERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3ERKNS_19PxControllerFiltersERKNS_6PxVec3E(i34, i28, i29, i31, i1, i7) {
 i34 = i34 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i32 = 0, i33 = 0, i35 = 0, d36 = 0.0, d37 = 0.0, d38 = 0.0, f39 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i35 + 56 | 0;
 i33 = i35 + 72 | 0;
 i30 = i35 + 28 | 0;
 i32 = i35;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i26 = i1 + 8 | 0;
 i1 = HEAP16[i26 >> 1] | 0;
 HEAP8[i27 + 10 >> 0] = (i1 & 65535) >>> 2 & 1;
 HEAP8[i27 + 11 >> 0] = (i1 & 65535) >>> 3 & 1;
 i1 = __ZN5physx3Cct17getSceneTimestampEPKNS0_30InternalCBData_FindTouchedGeomE(i28) | 0;
 i2 = i34 + 296 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  i4 = i34 + 48 | 0;
  if (+HEAPF64[i4 >> 3] > +HEAPF64[i31 >> 3]) {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  } else if (+HEAPF64[i34 + 56 >> 3] > +HEAPF64[i31 + 8 >> 3]) {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  } else if (+HEAPF64[i34 + 64 >> 3] > +HEAPF64[i31 + 16 >> 3]) {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  } else if (+HEAPF64[i34 + 72 >> 3] < +HEAPF64[i31 + 24 >> 3]) {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  } else if (+HEAPF64[i34 + 80 >> 3] < +HEAPF64[i31 + 32 >> 3]) {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  } else if (!(+HEAPF64[i34 + 88 >> 3] < +HEAPF64[i31 + 40 >> 3])) {
   i1 = i34 + 308 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!(i2 & 128)) i4 = 0; else {
    HEAP32[i1 >> 2] = i2 & -129;
    HEAP32[i34 + 36 >> 2] = HEAP32[i34 + 112 >> 2];
    i25 = HEAP32[i34 + 116 >> 2] | 0;
    HEAP32[i34 + 12 >> 2] = i25;
    HEAP32[i34 + 24 >> 2] = i25;
    HEAP8[i27 + 8 >> 0] = 0;
    if (HEAP16[i26 >> 1] & 2) HEAP8[i27 + 9 >> 0] = 1;
    __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt(i28, i4, i34 + 8 | 0, i34 + 20 | 0, i34 + 32 | 0, i27, i34 + 224 | 0, i34 + 304 | 0);
    __ZN5physx3Cct9SweepTest20findTouchedObstaclesERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3E(i34, i29, i4);
    i4 = i34 + 302 | 0;
    HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
    i4 = 0;
   }
  } else {
   i22 = i4;
   i25 = i4;
   i8 = 13;
  }
 } else {
  HEAP32[i2 >> 2] = i1;
  i25 = i34 + 48 | 0;
  i22 = i25;
  i8 = 13;
 }
 if ((i8 | 0) == 13) {
  i5 = i25;
  i1 = i31;
  i6 = i5 + 48 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  f15 = Math_fround(HEAPF32[i34 + 288 >> 2]);
  d18 = +HEAPF64[i22 >> 3];
  i21 = i34 + 72 | 0;
  d3 = +HEAPF64[i21 >> 3];
  i9 = i34 + 56 | 0;
  d20 = +HEAPF64[i9 >> 3];
  i23 = i34 + 80 | 0;
  d17 = +HEAPF64[i23 >> 3];
  i10 = i34 + 64 | 0;
  d19 = +HEAPF64[i10 >> 3];
  i24 = i34 + 88 | 0;
  d16 = +HEAPF64[i24 >> 3];
  d38 = (d18 + d3) * .5;
  d37 = (d20 + d17) * .5;
  d36 = (d19 + d16) * .5;
  f13 = Math_fround(f15 * Math_fround(Math_fround(d17 - d20) * Math_fround(.5)));
  f14 = Math_fround(f15 * Math_fround(Math_fround(d16 - d19) * Math_fround(.5)));
  d18 = +Math_fround(f15 * Math_fround(Math_fround(d3 - d18) * Math_fround(.5)));
  d3 = d38 - d18;
  HEAPF64[i22 >> 3] = d3;
  d19 = +f13;
  d16 = d37 - d19;
  HEAPF64[i9 >> 3] = d16;
  d20 = +f14;
  d17 = d36 - d20;
  HEAPF64[i10 >> 3] = d17;
  d18 = d38 + d18;
  HEAPF64[i21 >> 3] = d18;
  d19 = d37 + d19;
  HEAPF64[i23 >> 3] = d19;
  d20 = d36 + d20;
  HEAPF64[i24 >> 3] = d20;
  f14 = Math_fround(HEAPF32[i7 >> 2]);
  i6 = f14 == Math_fround(0.0);
  f13 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  if (i6 & f13 == Math_fround(0.0)) {
   if (!(Math_fround(HEAPF32[i7 + 8 >> 2]) == Math_fround(0.0))) i8 = 15;
  } else i8 = 15;
  if ((i8 | 0) == 15) {
   f12 = Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13));
   f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f11 * f11));
   if (f12 > Math_fround(0.0)) {
    f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12))));
    f15 = Math_fround(f11 * f39);
    f12 = Math_fround(f13 * f39);
    f11 = Math_fround(f14 * f39);
   } else {
    f15 = Math_fround(0.0);
    f12 = Math_fround(0.0);
    f11 = Math_fround(0.0);
   }
   i4 = i31 + 24 | 0;
   f14 = Math_fround(+HEAPF64[i4 >> 3] - +HEAPF64[i31 >> 3]);
   i5 = i31 + 32 | 0;
   i1 = i31 + 8 | 0;
   f13 = Math_fround(+HEAPF64[i5 >> 3] - +HEAPF64[i1 >> 3]);
   i6 = i31 + 40 | 0;
   i2 = i31 + 16 | 0;
   f13 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f11 * Math_fround(d18 - d3)) + Math_fround(f12 * Math_fround(d19 - d16))) + Math_fround(f15 * Math_fround(d20 - d17))))) - Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f13)) + Math_fround(f15 * Math_fround(+HEAPF64[i6 >> 3] - +HEAPF64[i2 >> 3])))))) * Math_fround(.449999988));
   f14 = Math_fround(f12 * f13);
   f39 = Math_fround(f15 * f13);
   d36 = +Math_fround(f11 * f13);
   d38 = d3 + d36;
   HEAPF64[i22 >> 3] = d38;
   d37 = +f14;
   d16 = d16 + d37;
   HEAPF64[i9 >> 3] = d16;
   d3 = +f39;
   d17 = d17 + d3;
   HEAPF64[i10 >> 3] = d17;
   d18 = d18 + d36;
   HEAPF64[i21 >> 3] = d18;
   d19 = d19 + d37;
   HEAPF64[i23 >> 3] = d19;
   d20 = d3 + d20;
   HEAPF64[i24 >> 3] = d20;
   d3 = +HEAPF64[i31 >> 3];
   if (d38 > d3) HEAPF64[i22 >> 3] = d3;
   d3 = +HEAPF64[i1 >> 3];
   if (d16 > d3) HEAPF64[i9 >> 3] = d3;
   d3 = +HEAPF64[i2 >> 3];
   if (d17 > d3) HEAPF64[i10 >> 3] = d3;
   d3 = +HEAPF64[i4 >> 3];
   if (d18 < d3) HEAPF64[i21 >> 3] = d3;
   d3 = +HEAPF64[i5 >> 3];
   if (d19 < d3) HEAPF64[i23 >> 3] = d3;
   d3 = +HEAPF64[i6 >> 3];
   if (d20 < d3) HEAPF64[i24 >> 3] = d3;
  }
  i2 = i34 + 8 | 0;
  i4 = i34 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i34 + 20 | 0;
  HEAP32[i34 + 24 >> 2] = 0;
  i6 = i34 + 32 | 0;
  i7 = i34 + 36 | 0;
  HEAP32[i7 >> 2] = 0;
  i24 = i34 + 96 | 0;
  i1 = i34 + 300 | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
  i1 = i27 + 8 | 0;
  if (HEAP16[i26 >> 1] & 1) HEAP8[i1 >> 0] = 1;
  i8 = i27 + 9 | 0;
  HEAP8[i8 >> 0] = 0;
  i9 = i34 + 224 | 0;
  i10 = i34 + 304 | 0;
  __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt(i28, i25, i2, i5, i6, i27, i9, i10);
  HEAP32[i34 + 112 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i34 + 116 >> 2] = HEAP32[i4 >> 2];
  HEAP8[i1 >> 0] = 0;
  if (HEAP16[i26 >> 1] & 2) HEAP8[i8 >> 0] = 1;
  __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt(i28, i25, i2, i5, i6, i27, i9, i10);
  __ZN5physx3Cct9SweepTest20findTouchedObstaclesERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3E(i34, i29, i25);
  i4 = i34 + 308 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -129;
  i4 = 1;
 }
 i1 = HEAP32[i34 >> 2] | 0;
 if (!i1) {
  STACKTOP = i35;
  return;
 }
 i2 = i33 + 36 | 0;
 i5 = i33;
 i6 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i2 = i33 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i33 + 56 >> 2] = Math_fround(1.0);
 i2 = i33 + 60 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i33 + 76 >> 2] = Math_fround(1.0);
 i2 = i33 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i33 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i33 + 100 >> 2] = i1;
 i2 = i34 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 1) {
  __ZN5physx2Cm12RenderOutputlsEj(i33, -65281) | 0;
  f11 = Math_fround(+HEAPF64[i31 >> 3]);
  f12 = Math_fround(+HEAPF64[i31 + 8 >> 3]);
  f13 = Math_fround(+HEAPF64[i31 + 16 >> 3]);
  f14 = Math_fround(+HEAPF64[i31 + 24 >> 3]);
  f15 = Math_fround(+HEAPF64[i31 + 32 >> 3]);
  f39 = Math_fround(+HEAPF64[i31 + 40 >> 3]);
  HEAPF32[i30 >> 2] = f11;
  HEAPF32[i30 + 4 >> 2] = f12;
  HEAPF32[i30 + 8 >> 2] = f13;
  HEAPF32[i30 + 12 >> 2] = f14;
  HEAPF32[i30 + 16 >> 2] = f15;
  HEAPF32[i30 + 20 >> 2] = f39;
  HEAP8[i30 + 24 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i33, i30) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 2 | 0) {
  if (i4) __ZN5physx2Cm12RenderOutputlsEj(i33, -65536) | 0; else __ZN5physx2Cm12RenderOutputlsEj(i33, -16711936) | 0;
  f11 = Math_fround(+HEAPF64[i34 + 48 >> 3]);
  f12 = Math_fround(+HEAPF64[i34 + 56 >> 3]);
  f13 = Math_fround(+HEAPF64[i34 + 64 >> 3]);
  f14 = Math_fround(+HEAPF64[i34 + 72 >> 3]);
  f15 = Math_fround(+HEAPF64[i34 + 80 >> 3]);
  f39 = Math_fround(+HEAPF64[i34 + 88 >> 3]);
  HEAPF32[i32 >> 2] = f11;
  HEAPF32[i32 + 4 >> 2] = f12;
  HEAPF32[i32 + 8 >> 2] = f13;
  HEAPF32[i32 + 12 >> 2] = f14;
  HEAPF32[i32 + 16 >> 2] = f15;
  HEAPF32[i32 + 20 >> 2] = f39;
  HEAP8[i32 + 24 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i33, i32) | 0;
 }
 STACKTOP = i35;
 return;
}

function _gray_render_scanline(i36, i6, i1, i10, i2, i34) {
 i36 = i36 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i34 = i34 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0;
 i3 = i2 - i1 | 0;
 i5 = i1 >> 8;
 i29 = i2 >> 8;
 i1 = i1 - (i5 << 8) | 0;
 i33 = i2 - (i29 << 8) | 0;
 if ((i34 | 0) == (i10 | 0)) {
  i11 = i6 - (HEAP32[i36 + 20 >> 2] | 0) | 0;
  i8 = HEAP32[i36 + 16 >> 2] | 0;
  i8 = ((i8 | 0) < (i29 | 0) ? i8 : i29) - (HEAP32[i36 + 12 >> 2] | 0) | 0;
  i8 = (i8 | 0) > -1 ? i8 : -1;
  i9 = i36 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i8 | 0) == (i2 | 0)) {
   if ((i11 | 0) != (HEAP32[i36 + 8 >> 2] | 0)) i35 = 4;
  } else i35 = 4;
  if ((i35 | 0) == 4) {
   i10 = i36 + 36 | 0;
   L7 : do if (!(HEAP32[i36 + 44 >> 2] | 0)) {
    i6 = HEAP32[i10 >> 2] | 0;
    i1 = i36 + 40 | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    if (i7 | i6) {
     i5 = HEAP32[i36 + 28 >> 2] | 0;
     i5 = (i2 | 0) > (i5 | 0) ? i5 : i2;
     i3 = (HEAP32[i36 + 1256 >> 2] | 0) + (HEAP32[i36 + 8 >> 2] << 2) | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     L10 : do if (!i2) i35 = 11; else while (1) {
      i4 = HEAP32[i2 >> 2] | 0;
      if ((i4 | 0) > (i5 | 0)) {
       i35 = 11;
       break L10;
      }
      if ((i4 | 0) == (i5 | 0)) break L10;
      i3 = i2 + 12 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i35 = 11;
       break;
      }
     } while (0);
     do if ((i35 | 0) == 11) {
      i2 = i36 + 56 | 0;
      i4 = HEAP32[i2 >> 2] | 0;
      if ((i4 | 0) < (HEAP32[i36 + 52 >> 2] | 0)) {
       i35 = HEAP32[i36 + 48 >> 2] | 0;
       HEAP32[i2 >> 2] = i4 + 1;
       i2 = i35 + (i4 << 4) | 0;
       HEAP32[i2 >> 2] = i5;
       HEAP32[i35 + (i4 << 4) + 8 >> 2] = 0;
       HEAP32[i35 + (i4 << 4) + 4 >> 2] = 0;
       HEAP32[i35 + (i4 << 4) + 12 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i3 >> 2] = i2;
       if (!i2) break L7; else break;
      } else {
       HEAP32[i36 >> 2] = 64;
       break L7;
      }
     } while (0);
     i35 = i2 + 8 | 0;
     HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i6;
     i35 = i2 + 4 | 0;
     HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i7;
    }
   } else i1 = i36 + 40 | 0; while (0);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i36 + 8 >> 2] = i11;
  }
  if (i11 >>> 0 < (HEAP32[i36 + 32 >> 2] | 0) >>> 0) i1 = (i8 | 0) >= (HEAP32[i36 + 28 >> 2] | 0); else i1 = 1;
  HEAP32[i36 + 44 >> 2] = i1 & 1;
  return;
 }
 if ((i5 | 0) == (i29 | 0)) {
  i35 = i34 - i10 | 0;
  i33 = Math_imul(i33 + i1 | 0, i35) | 0;
  i34 = i36 + 36 | 0;
  HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i33;
  i36 = i36 + 40 | 0;
  HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + i35;
  return;
 }
 i7 = (i3 | 0) < 0;
 i28 = i3 >> 31;
 i32 = i28 + 256 & -256;
 i27 = i7 ? 0 - i3 | 0 : i3;
 i28 = i28 | 1;
 i7 = Math_imul(i7 ? i1 : 256 - i1 | 0, i34 - i10 | 0) | 0;
 i8 = (i7 | 0) % (i27 | 0) | 0;
 i7 = (i8 >> 31) + ((i7 | 0) / (i27 | 0) | 0) | 0;
 i9 = (i8 | 0) < 0 ? i27 : 0;
 i4 = Math_imul(i7, i32 + i1 | 0) | 0;
 i30 = i36 + 36 | 0;
 i4 = i4 + (HEAP32[i30 >> 2] | 0) | 0;
 HEAP32[i30 >> 2] = i4;
 i31 = i36 + 40 | 0;
 i1 = (HEAP32[i31 >> 2] | 0) + i7 | 0;
 HEAP32[i31 >> 2] = i1;
 i11 = i28 + i5 | 0;
 i23 = i6 - (HEAP32[i36 + 20 >> 2] | 0) | 0;
 i24 = HEAP32[i36 + 16 >> 2] | 0;
 i25 = HEAP32[i36 + 12 >> 2] | 0;
 i13 = ((i24 | 0) < (i11 | 0) ? i24 : i11) - i25 | 0;
 i13 = (i13 | 0) > -1 ? i13 : -1;
 i26 = i36 + 4 | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 if ((i13 | 0) == (i2 | 0)) {
  if ((i23 | 0) != (HEAP32[i36 + 8 >> 2] | 0)) i35 = 23;
 } else i35 = 23;
 if ((i35 | 0) == 23) {
  L37 : do if (!((HEAP32[i36 + 44 >> 2] | 0) != 0 | (i1 | i4 | 0) == 0)) {
   i6 = HEAP32[i36 + 28 >> 2] | 0;
   i6 = (i2 | 0) > (i6 | 0) ? i6 : i2;
   i3 = (HEAP32[i36 + 1256 >> 2] | 0) + (HEAP32[i36 + 8 >> 2] << 2) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   L39 : do if (!i2) i35 = 28; else while (1) {
    i5 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) > (i6 | 0)) {
     i35 = 28;
     break L39;
    }
    if ((i5 | 0) == (i6 | 0)) break L39;
    i3 = i2 + 12 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i35 = 28;
     break;
    }
   } while (0);
   do if ((i35 | 0) == 28) {
    i2 = i36 + 56 | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) < (HEAP32[i36 + 52 >> 2] | 0)) {
     i22 = HEAP32[i36 + 48 >> 2] | 0;
     HEAP32[i2 >> 2] = i5 + 1;
     i2 = i22 + (i5 << 4) | 0;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i22 + (i5 << 4) + 8 >> 2] = 0;
     HEAP32[i22 + (i5 << 4) + 4 >> 2] = 0;
     HEAP32[i22 + (i5 << 4) + 12 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i3 >> 2] = i2;
     if (!i2) break L37; else break;
    } else {
     HEAP32[i36 >> 2] = 64;
     break L37;
    }
   } while (0);
   i22 = i2 + 8 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i4;
   i22 = i2 + 4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + i1;
  } while (0);
  HEAP32[i30 >> 2] = 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i26 >> 2] = i13;
  HEAP32[i36 + 8 >> 2] = i23;
  i4 = 0;
  i1 = 0;
 }
 i5 = i23 >>> 0 < (HEAP32[i36 + 32 >> 2] | 0) >>> 0;
 if (i5) i2 = (i13 | 0) >= (HEAP32[i36 + 28 >> 2] | 0); else i2 = 1;
 i2 = i2 & 1;
 i22 = i36 + 44 | 0;
 HEAP32[i22 >> 2] = i2;
 i3 = i7 + i10 | 0;
 if ((i11 | 0) == (i29 | 0)) i2 = i4; else {
  i21 = i7 + i34 - i3 << 8;
  i20 = (i21 | 0) % (i27 | 0) | 0;
  i21 = (i20 >> 31) + ((i21 | 0) / (i27 | 0) | 0) | 0;
  i20 = ((i20 | 0) < 0 ? i27 : 0) + i20 | 0;
  i6 = i8 - i27 + i9 | 0;
  i14 = i36 + 8 | 0;
  i15 = i36 + 28 | 0;
  i16 = i36 + 1256 | 0;
  i17 = i36 + 56 | 0;
  i18 = i36 + 52 | 0;
  i19 = i36 + 48 | 0;
  if (i5) {
   i12 = HEAP32[i15 >> 2] | 0;
   i10 = i11;
   i9 = i6;
   i8 = i13;
   i5 = i13;
   do {
    i13 = i20 + i9 | 0;
    i11 = i21 + (i13 >>> 31 ^ 1) | 0;
    i9 = i13 - ((i13 | 0) > -1 ? i27 : 0) | 0;
    i4 = (i11 << 8) + i4 | 0;
    i1 = i11 + i1 | 0;
    i3 = i11 + i3 | 0;
    i10 = i10 + i28 | 0;
    i11 = ((i24 | 0) < (i10 | 0) ? i24 : i10) - i25 | 0;
    i13 = i8;
    i8 = (i11 | 0) > -1 ? i11 : -1;
    if ((i8 | 0) != (i13 | 0)) {
     L63 : do if (!((i2 | 0) != 0 | (i1 | i4 | 0) == 0)) {
      i7 = HEAP32[i15 >> 2] | 0;
      i7 = (i5 | 0) > (i7 | 0) ? i7 : i5;
      i5 = (HEAP32[i16 >> 2] | 0) + (i23 << 2) | 0;
      i2 = HEAP32[i5 >> 2] | 0;
      L65 : do if (!i2) i35 = 44; else while (1) {
       i6 = HEAP32[i2 >> 2] | 0;
       if ((i6 | 0) > (i7 | 0)) {
        i35 = 44;
        break L65;
       }
       if ((i6 | 0) == (i7 | 0)) break L65;
       i5 = i2 + 12 | 0;
       i2 = HEAP32[i5 >> 2] | 0;
       if (!i2) {
        i35 = 44;
        break;
       }
      } while (0);
      do if ((i35 | 0) == 44) {
       i35 = 0;
       i6 = HEAP32[i17 >> 2] | 0;
       if ((i6 | 0) < (HEAP32[i18 >> 2] | 0)) {
        i13 = HEAP32[i19 >> 2] | 0;
        HEAP32[i17 >> 2] = i6 + 1;
        i2 = i13 + (i6 << 4) | 0;
        HEAP32[i2 >> 2] = i7;
        HEAP32[i13 + (i6 << 4) + 8 >> 2] = 0;
        HEAP32[i13 + (i6 << 4) + 4 >> 2] = 0;
        HEAP32[i13 + (i6 << 4) + 12 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i5 >> 2] = i2;
        if (!i2) break L63; else break;
       } else {
        HEAP32[i36 >> 2] = 64;
        break L63;
       }
      } while (0);
      i13 = i2 + 8 | 0;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i4;
      i13 = i2 + 4 | 0;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i1;
     } while (0);
     HEAP32[i26 >> 2] = i8;
     HEAP32[i14 >> 2] = i23;
     i5 = i8;
     i1 = 0;
     i4 = 0;
    }
    i2 = (i8 | 0) >= (i12 | 0) & 1;
   } while ((i10 | 0) != (i29 | 0));
  } else {
   i10 = i11;
   i9 = i6;
   i8 = i13;
   i5 = i13;
   while (1) {
    i13 = i20 + i9 | 0;
    i12 = i21 + (i13 >>> 31 ^ 1) | 0;
    i9 = i13 - ((i13 | 0) > -1 ? i27 : 0) | 0;
    i4 = (i12 << 8) + i4 | 0;
    i1 = i12 + i1 | 0;
    i3 = i12 + i3 | 0;
    i10 = i10 + i28 | 0;
    i12 = ((i24 | 0) < (i10 | 0) ? i24 : i10) - i25 | 0;
    i13 = i8;
    i8 = (i12 | 0) > -1 ? i12 : -1;
    if ((i8 | 0) != (i13 | 0)) {
     L82 : do if (!((i2 | 0) != 0 | (i1 | i4 | 0) == 0)) {
      i7 = HEAP32[i15 >> 2] | 0;
      i7 = (i5 | 0) > (i7 | 0) ? i7 : i5;
      i5 = (HEAP32[i16 >> 2] | 0) + (i23 << 2) | 0;
      i2 = HEAP32[i5 >> 2] | 0;
      L84 : do if (!i2) i35 = 56; else while (1) {
       i6 = HEAP32[i2 >> 2] | 0;
       if ((i6 | 0) > (i7 | 0)) {
        i35 = 56;
        break L84;
       }
       if ((i6 | 0) == (i7 | 0)) break L84;
       i5 = i2 + 12 | 0;
       i2 = HEAP32[i5 >> 2] | 0;
       if (!i2) {
        i35 = 56;
        break;
       }
      } while (0);
      do if ((i35 | 0) == 56) {
       i35 = 0;
       i6 = HEAP32[i17 >> 2] | 0;
       if ((i6 | 0) < (HEAP32[i18 >> 2] | 0)) {
        i13 = HEAP32[i19 >> 2] | 0;
        HEAP32[i17 >> 2] = i6 + 1;
        i2 = i13 + (i6 << 4) | 0;
        HEAP32[i2 >> 2] = i7;
        HEAP32[i13 + (i6 << 4) + 8 >> 2] = 0;
        HEAP32[i13 + (i6 << 4) + 4 >> 2] = 0;
        HEAP32[i13 + (i6 << 4) + 12 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i5 >> 2] = i2;
        if (!i2) break L82; else break;
       } else {
        HEAP32[i36 >> 2] = 64;
        break L82;
       }
      } while (0);
      i13 = i2 + 8 | 0;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i4;
      i13 = i2 + 4 | 0;
      HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i1;
     } while (0);
     HEAP32[i26 >> 2] = i8;
     HEAP32[i14 >> 2] = i23;
     i5 = i8;
     i1 = 0;
     i4 = 0;
    }
    if ((i10 | 0) == (i29 | 0)) {
     i2 = 1;
     break;
    } else i2 = 1;
   }
  }
  HEAP32[i30 >> 2] = i4;
  HEAP32[i31 >> 2] = i1;
  HEAP32[i22 >> 2] = i2;
  i2 = i4;
 }
 i36 = i34 - i3 | 0;
 HEAP32[i30 >> 2] = (Math_imul(i36, i33 + 256 - i32 | 0) | 0) + i2;
 HEAP32[i31 >> 2] = i1 + i36;
 return;
}

function __ZNK8GUIStyle10DoCalcSizeER10GUIContentRK8Vector2f(i18, i19, i12, i16) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 8 | 0;
 i3 = i20;
 i6 = i12 + 40 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) i3 = 0; else {
  HEAP32[i3 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i7 = 7; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i3);
    i3 = HEAP32[i13 >> 2] | 0;
    i17 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i17 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i17 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i7 = 7; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i3 = i2;
 }
 i17 = i19 + 280 | 0;
 f1 = Math_fround(HEAPF32[i17 >> 2]);
 if (f1 != Math_fround(0.0)) {
  f5 = Math_fround(HEAPF32[i19 + 276 >> 2]);
  if (f5 != Math_fround(0.0)) {
   HEAPF32[i18 >> 2] = f5;
   HEAPF32[i18 + 4 >> 2] = f1;
   STACKTOP = i20;
   return;
  }
 }
 i15 = i12 + 4 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  i13 = 0;
  i2 = 0;
 } else if ((HEAP32[i19 + 256 >> 2] | 0) == 2) {
  i13 = 0;
  i2 = 0;
 } else {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  i2 = __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent(i19, i13, i12) | 0;
  if (!i2) {
   i13 = 0;
   i2 = 0;
  } else {
   i13 = HEAP32[i2 + 16 >> 2] | 0;
   i2 = HEAP32[i2 + 20 >> 2] | 0;
  }
 }
 i14 = (i3 | 0) == 0;
 i6 = i19 + 256 | 0;
 if (i14) {
  i4 = 0;
  i3 = 0;
 } else if ((HEAP32[i6 >> 2] | 0) == 3) {
  i4 = 0;
  i3 = 0;
 } else {
  f10 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0);
  f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i12 = HEAP32[i6 >> 2] | 0;
 switch (i12 | 0) {
 case 0:
  {
   do if ((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) {
    f11 = Math_fround(HEAPF32[gb + 1468168 >> 2]);
    i7 = f11 != Math_fround(0.0);
    f1 = Math_fround(HEAPF32[gb + 1468172 >> 2]);
    i7 = i7 & f1 != Math_fround(0.0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : i3;
    i4 = i7 ? i6 : i4;
    f11 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    if (f11 > Math_fround(0.0)) {
     f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f5 > f11) {
      f8 = Math_fround(HEAPF32[i16 >> 2]);
      if (f8 > Math_fround(0.0)) {
       f9 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (Math_fround(f9 + f10) > f8) {
        f1 = Math_fround(f11 / f5);
        if (f1 < Math_fround(f8 / f10)) {
         f10 = Math_fround(f10 * f1);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
         break;
        } else {
         f11 = Math_fround(f8 - f9);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
         f11 = Math_fround(f5 * Math_fround(f11 / f11));
         i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
         break;
        }
       }
      }
     }
     f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f1 > f11) {
      f10 = Math_fround(f11 / f1);
      f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f10);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
      break;
     }
    }
    f1 = Math_fround(HEAPF32[i16 >> 2]);
    if (f1 > Math_fround(0.0)) {
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) > f1) {
      f11 = Math_fround(f1 - f5);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
      f11 = Math_fround(f11 / f11);
      f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
     }
    }
   } while (0);
   f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f11 < f10 ? f10 : f11, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   do if (f10 > Math_fround(0.0)) {
    f9 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    if (f9 > Math_fround(0.0)) {
     f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (Math_fround(f1 + f10) > f9) {
      f5 = Math_fround(HEAPF32[i16 >> 2]);
      if (f5 > Math_fround(0.0)) {
       f8 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       if (f8 > f5) if (Math_fround(f9 / f10) < Math_fround(f5 / f8)) {
        f11 = Math_fround(f9 - f1);
        f10 = Math_fround(f8 * Math_fround(f11 / f10));
        i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
        i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
        break;
       } else {
        i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
        f11 = Math_fround(f10 * Math_fround(f5 / f5));
        i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
        break;
       }
      }
     }
     f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (Math_fround(f1 + f10) > f9) {
      f11 = Math_fround(f9 - f1);
      f10 = Math_fround(f11 / f10);
      f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f10);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
      break;
     }
    }
    f1 = Math_fround(HEAPF32[i16 >> 2]);
    i16 = f1 > Math_fround(0.0);
    if (i16 & (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f1) {
     i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
     f11 = Math_fround(f10 * Math_fround(f1 / f1));
     i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    }
   } while (0);
   f10 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f10 < f9 ? f9 : f10, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 2:
  {
   i6 = i4;
   i2 = i3;
   break;
  }
 case 3:
  {
   i6 = i13;
   break;
  }
 default:
  {
   i6 = 0;
   i2 = 0;
  }
 }
 if (!((i12 | 0) == 2 | i14 & (HEAP32[i15 >> 2] | 0) == 0 ^ 1)) {
  i2 = __ZNK8GUIStyle14GetCurrentFontEv(i19) | 0;
  do if (!i2) f1 = Math_fround(0.0); else {
   i3 = HEAP32[i19 + 284 >> 2] | 0;
   if (i3 | 0) {
    i4 = HEAP32[i2 + 36 >> 2] | 0;
    if (i4 | 0) {
     f1 = Math_fround(Math_fround(Math_fround(((i3 | 0) > 500 ? 500 : i3) | 0) * Math_fround(HEAPF32[i2 + 32 >> 2])) / Math_fround(i4 | 0));
     break;
    }
   }
   f1 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  } while (0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f9 = Math_fround((HEAP32[i19 + 212 >> 2] | 0) + (HEAP32[i19 + 208 >> 2] | 0) | 0);
 f11 = Math_fround((HEAP32[i19 + 220 >> 2] | 0) + (HEAP32[i19 + 216 >> 2] | 0) | 0);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f11);
 f8 = Math_fround(HEAPF32[i19 + 276 >> 2]);
 i16 = f8 != Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i17 >> 2]);
 i19 = f10 != Math_fround(0.0);
 HEAPF32[i18 >> 2] = i16 ? f8 : f9;
 HEAPF32[i18 + 4 >> 2] = i19 ? f10 : f11;
 STACKTOP = i20;
 return;
}

function __ZN15AABBTreeRaycastILb1EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE(i1, i35, i37, i2, i3, i34, i4, i36) {
 i1 = i1 | 0;
 i35 = i35 | 0;
 i37 = i37 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i34 = i34 | 0;
 i4 = i4 | 0;
 i36 = i36 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i38 + 8 | 0;
 i32 = i38;
 f6 = Math_fround(HEAPF32[i34 >> 2]);
 f30 = Math_fround(HEAPF32[i2 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i3 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f21 = Math_fround(-f28);
 f22 = Math_fround(-f29);
 f23 = Math_fround(-f24);
 f21 = f28 > f21 ? f28 : f21;
 f22 = f29 > f22 ? f29 : f22;
 f23 = f24 > f23 ? f24 : f23;
 if (!(f6 >= Math_fround(3402823469999999843913219.0e14))) {
  f7 = Math_fround(Math_fround(f6 * f24) + f27);
  f5 = Math_fround(Math_fround(f6 * f29) + f31);
  f6 = Math_fround(Math_fround(f6 * f28) + f30);
 } else {
  i19 = f28 == Math_fround(0.0);
  i11 = f28 >= Math_fround(0.0);
  f6 = i11 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f6 = i19 ? f30 : f6;
  i19 = f29 == Math_fround(0.0);
  i11 = f29 >= Math_fround(0.0);
  f5 = i11 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f5 = i19 ? f31 : f5;
  if (f24 == Math_fround(0.0)) f7 = f27; else {
   i19 = f24 >= Math_fround(0.0);
   f7 = i19 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  }
 }
 i19 = HEAP32[i37 + 4 >> 2] | 0;
 HEAP32[i33 >> 2] = i19;
 f16 = f27 > f7 ? f27 : f7;
 f17 = f31 > f5 ? f31 : f5;
 f18 = f30 > f6 ? f30 : f6;
 f15 = f27 < f7 ? f27 : f7;
 f14 = f31 < f5 ? f31 : f5;
 f13 = f30 < f6 ? f30 : f6;
 i1 = 0;
 L6 : while (1) {
  L8 : while (1) {
   i2 = HEAP32[i33 + (i1 << 2) >> 2] | 0;
   i40 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i2 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   f45 = Math_fround(f25 + Math_fround(Math_fround(i40 & 255 | 0) * f7));
   f41 = Math_fround(f26 + Math_fround(Math_fround(i10 & 255 | 0) * f7));
   f7 = Math_fround(f20 + Math_fround(Math_fround(i3 & 255 | 0) * f7));
   f46 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f44 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(f30 - f46);
   f9 = Math_fround(f31 - f44);
   f42 = Math_fround(f27 - f12);
   f6 = Math_fround(Math_fround(f28 * f9) - Math_fround(f29 * f5));
   f9 = Math_fround(Math_fround(f29 * f42) - Math_fround(f24 * f9));
   f42 = Math_fround(Math_fround(f24 * f5) - Math_fround(f28 * f42));
   f5 = Math_fround(Math_fround(f22 * f45) + Math_fround(f21 * f41));
   f8 = Math_fround(Math_fround(f23 * f41) + Math_fround(f22 * f7));
   f43 = Math_fround(Math_fround(f21 * f7) + Math_fround(f23 * f45));
   i3 = Math_fround(f46 + f45) >= f13;
   i10 = Math_fround(f44 + f41) >= f14;
   i40 = Math_fround(f12 + f7) >= f15;
   i4 = f18 >= Math_fround(f46 - f45);
   i11 = f17 >= Math_fround(f44 - f41);
   i39 = f16 >= Math_fround(f12 - f7);
   f7 = Math_fround(-f6);
   f12 = Math_fround(-f9);
   f41 = Math_fround(-f42);
   L10 : do if (f43 >= (f42 > f41 ? f42 : f41) & (i40 & i39) & (f5 >= (f6 > f7 ? f6 : f7) & (i3 & i4) & (f8 >= (f9 > f12 ? f9 : f12) & (i10 & i11)))) {
    HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
    L12 : while (1) {
     while (1) {
      i3 = i2 + 16 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i3 + 4 >> 2] | 0;
      if (!((i2 & 1 | 0) == 0 & 0 == 0)) break L12;
      i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
      getTempRet0() | 0;
      i4 = i4 & 524287;
      i10 = i19 + (i4 * 24 | 0) | 0;
      i47 = HEAP32[i10 >> 2] | 0;
      i39 = HEAP32[i19 + (i4 * 24 | 0) + 4 >> 2] | 0;
      i49 = HEAP32[i19 + (i4 * 24 | 0) + 8 >> 2] | 0;
      f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i19 + (i4 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
      f41 = Math_fround(f25 + Math_fround(Math_fround(i47 & 255 | 0) * f7));
      f43 = Math_fround(f26 + Math_fround(Math_fround(i39 & 255 | 0) * f7));
      f7 = Math_fround(f20 + Math_fround(Math_fround(i49 & 255 | 0) * f7));
      f12 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f8 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = Math_fround(f30 - f12);
      f50 = Math_fround(f31 - f9);
      f45 = Math_fround(f27 - f8);
      f6 = Math_fround(Math_fround(f28 * f50) - Math_fround(f29 * f5));
      f50 = Math_fround(Math_fround(f29 * f45) - Math_fround(f24 * f50));
      f45 = Math_fround(Math_fround(f24 * f5) - Math_fround(f28 * f45));
      f5 = Math_fround(Math_fround(f22 * f41) + Math_fround(f21 * f43));
      f46 = Math_fround(Math_fround(f23 * f43) + Math_fround(f22 * f7));
      f51 = Math_fround(Math_fround(f21 * f7) + Math_fround(f23 * f41));
      i49 = Math_fround(f12 + f41) >= f13;
      i39 = Math_fround(f9 + f43) >= f14;
      i47 = Math_fround(f8 + f7) >= f15;
      i11 = f18 >= Math_fround(f12 - f41);
      i3 = f17 >= Math_fround(f9 - f43);
      i40 = f16 >= Math_fround(f8 - f7);
      f7 = Math_fround(-f6);
      f43 = Math_fround(-f50);
      f41 = Math_fround(-f45);
      i3 = f51 >= (f45 > f41 ? f45 : f41) & (i47 & i40) & (f5 >= (f6 > f7 ? f6 : f7) & (i49 & i11) & (f46 >= (f50 > f43 ? f50 : f43) & (i39 & i3)));
      i39 = i4 + 1 | 0;
      i11 = i19 + (i39 * 24 | 0) | 0;
      i49 = HEAP32[i11 >> 2] | 0;
      i40 = HEAP32[i19 + (i39 * 24 | 0) + 4 >> 2] | 0;
      i47 = HEAP32[i19 + (i39 * 24 | 0) + 8 >> 2] | 0;
      f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i19 + (i39 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
      f50 = Math_fround(f25 + Math_fround(Math_fround(i49 & 255 | 0) * f43));
      f46 = Math_fround(f26 + Math_fround(Math_fround(i40 & 255 | 0) * f43));
      f43 = Math_fround(f20 + Math_fround(Math_fround(i47 & 255 | 0) * f43));
      f7 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = Math_fround(f30 - f7);
      f45 = Math_fround(f31 - f6);
      f51 = Math_fround(f27 - f5);
      f42 = Math_fround(Math_fround(f28 * f45) - Math_fround(f29 * f41));
      f45 = Math_fround(Math_fround(f29 * f51) - Math_fround(f24 * f45));
      f51 = Math_fround(Math_fround(f24 * f41) - Math_fround(f28 * f51));
      f41 = Math_fround(Math_fround(f22 * f50) + Math_fround(f21 * f46));
      f44 = Math_fround(Math_fround(f23 * f46) + Math_fround(f22 * f43));
      f52 = Math_fround(Math_fround(f21 * f43) + Math_fround(f23 * f50));
      i47 = Math_fround(f7 + f50) >= f13;
      i40 = Math_fround(f6 + f46) >= f14;
      i49 = Math_fround(f5 + f43) >= f15;
      i39 = f18 >= Math_fround(f7 - f50);
      i2 = f17 >= Math_fround(f6 - f46);
      i48 = f16 >= Math_fround(f5 - f43);
      f43 = Math_fround(-f42);
      f46 = Math_fround(-f45);
      f50 = Math_fround(-f51);
      i2 = f52 >= (f51 > f50 ? f51 : f50) & (i49 & i48) & (f41 >= (f42 > f43 ? f42 : f43) & (i47 & i39) & (f44 >= (f45 > f46 ? f45 : f46) & (i40 & i2)));
      if (i3 & i2) break;
      if (i3 | i2) i2 = i3 ? i10 : i11; else break L10;
     }
     i2 = Math_fround(Math_fround(Math_fround(f28 * Math_fround(f7 - f12)) + Math_fround(f29 * Math_fround(f6 - f9))) + Math_fround(f24 * Math_fround(f5 - f8))) > Math_fround(0.0) & 1;
     HEAP32[i33 + (i1 << 2) >> 2] = i19 + ((i2 + i4 | 0) * 24 | 0);
     i2 = i19 + (((i2 ^ 1) + i4 | 0) * 24 | 0) | 0;
     i1 = i1 + 1 | 0;
    }
    f6 = Math_fround(HEAPF32[i34 >> 2]);
    i48 = HEAP32[i37 >> 2] | 0;
    i49 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    if (!(mftCall_iiiii(HEAP32[HEAP32[i36 >> 2] >> 2] | 0, i36 | 0, i32 | 0, i35 + (HEAP32[i48 + ((i49 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
     i1 = 0;
     i2 = 18;
     break L6;
    }
    f5 = Math_fround(HEAPF32[i32 >> 2]);
    if (f5 < f6) break L8;
   } while (0);
   if (!i1) {
    i1 = 1;
    i2 = 18;
    break L6;
   } else i1 = i1 + -1 | 0;
  }
  HEAPF32[i34 >> 2] = f5;
  f7 = Math_fround(f30 + Math_fround(f28 * f5));
  f6 = Math_fround(f31 + Math_fround(f29 * f5));
  f5 = Math_fround(f27 + Math_fround(f24 * f5));
  if (!i1) {
   i1 = 1;
   i2 = 18;
   break;
  } else {
   f16 = f27 > f5 ? f27 : f5;
   f17 = f31 > f6 ? f31 : f6;
   f18 = f30 > f7 ? f30 : f7;
   f15 = f27 < f5 ? f27 : f5;
   f14 = f31 < f6 ? f31 : f6;
   f13 = f30 < f7 ? f30 : f7;
   i1 = i1 + -1 | 0;
  }
 }
 if ((i2 | 0) == 18) {
  STACKTOP = i38;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i36, i37, i38, i39, i40, i41, i42, i1) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i43 = 0, i44 = 0, i45 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i43 + 128 | 0;
 i1 = i43 + 112 | 0;
 i34 = i43 + 124 | 0;
 i35 = i43 + 120 | 0;
 i3 = i43 + 116 | 0;
 i4 = i43 + 108 | 0;
 i5 = i43 + 104 | 0;
 i6 = i43 + 100 | 0;
 i7 = i43 + 96 | 0;
 i8 = i43 + 92 | 0;
 i9 = i43 + 88 | 0;
 i10 = i43 + 84 | 0;
 i11 = i43 + 80 | 0;
 i12 = i43 + 76 | 0;
 i13 = i43 + 72 | 0;
 i14 = i43 + 68 | 0;
 i15 = i43 + 64 | 0;
 i16 = i43 + 60 | 0;
 i17 = i43 + 56 | 0;
 i18 = i43 + 52 | 0;
 i19 = i43 + 48 | 0;
 i20 = i43 + 44 | 0;
 i21 = i43 + 40 | 0;
 i22 = i43 + 36 | 0;
 i23 = i43 + 32 | 0;
 i24 = i43 + 28 | 0;
 i25 = i43 + 24 | 0;
 i26 = i43 + 20 | 0;
 i27 = i43 + 16 | 0;
 i28 = i43 + 12 | 0;
 i29 = i43 + 8 | 0;
 i30 = i43 + 4 | 0;
 i31 = i43;
 HEAP32[i40 >> 2] = 0;
 i32 = __ZNKSt3__28ios_base6getlocEv(i39) | 0;
 HEAP32[i2 >> 2] = i32;
 __THREW__ = 0;
 i33 = invoke_iii(fb + 1145 | 0, i2 | 0, gb + 1474588 | 0) | 0;
 i45 = __THREW__;
 __THREW__ = 0;
 if (i45 & 1) {
  i45 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i32) | 0;
  ___resumeException(i45 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i32) | 0;
 do switch (i42 << 24 >> 24 | 0) {
 case 65:
 case 97:
  {
   HEAP32[i34 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i34 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 24 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i35 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 16 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 99:
  {
   i42 = i36 + 8 | 0;
   i42 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 12 >> 2] | 0, i42 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i38 >> 2];
   i44 = HEAP8[i42 + 8 + 3 >> 0] | 0;
   i38 = i44 << 24 >> 24 < 0;
   i45 = i38 ? HEAP32[i42 >> 2] | 0 : i42;
   i44 = i45 + ((i38 ? HEAP32[i42 + 4 >> 2] | 0 : i44 & 255) << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, i45, i44) | 0;
   i44 = 28;
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i5 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 12 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 68:
  {
   HEAP32[i6 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, gb + 211124 | 0, gb + 211124 + 32 | 0) | 0;
   i44 = 28;
   break;
  }
 case 70:
  {
   HEAP32[i8 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, gb + 211156 | 0, gb + 211156 + 32 | 0) | 0;
   i44 = 28;
   break;
  }
 case 72:
  {
   HEAP32[i10 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 73:
  {
   HEAP32[i11 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 106:
  {
   HEAP32[i12 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 28 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 109:
  {
   HEAP32[i13 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 16 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 77:
  {
   HEAP32[i14 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 4 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i15 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i36, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 112:
  {
   HEAP32[i16 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 114:
  {
   HEAP32[i17 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, gb + 211188 | 0, gb + 211188 + 44 | 0) | 0;
   i44 = 28;
   break;
  }
 case 82:
  {
   HEAP32[i19 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, gb + 211232 | 0, gb + 211232 + 20 | 0) | 0;
   i44 = 28;
   break;
  }
 case 83:
  {
   HEAP32[i21 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 84:
  {
   HEAP32[i22 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, gb + 211252 | 0, gb + 211252 + 32 | 0) | 0;
   i44 = 28;
   break;
  }
 case 119:
  {
   HEAP32[i24 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i24 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 24 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 120:
  {
   i45 = HEAP32[(HEAP32[i36 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i26 >> 2];
   i1 = mftCall_iiiiiii(i45 | 0, i36 | 0, i1 | 0, i2 | 0, i39 | 0, i40 | 0, i41 | 0) | 0;
   break;
  }
 case 88:
  {
   i42 = i36 + 8 | 0;
   i42 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 24 >> 2] | 0, i42 | 0) | 0;
   HEAP32[i27 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i38 >> 2];
   i44 = HEAP8[i42 + 8 + 3 >> 0] | 0;
   i38 = i44 << 24 >> 24 < 0;
   i45 = i38 ? HEAP32[i42 >> 2] | 0 : i42;
   i44 = i45 + ((i38 ? HEAP32[i42 + 4 >> 2] | 0 : i44 & 255) << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i36, i1, i2, i39, i40, i41, i45, i44) | 0;
   i44 = 28;
   break;
  }
 case 121:
  {
   HEAP32[i29 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i29 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 20 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 89:
  {
   HEAP32[i30 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i30 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i36, i41 + 20 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 37:
  {
   HEAP32[i31 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i31 >> 2];
   __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i36, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 default:
  {
   HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
   i44 = 28;
  }
 } while (0);
 if ((i44 | 0) == 28) i1 = HEAP32[i37 >> 2] | 0;
 STACKTOP = i43;
 return i1 | 0;
}

function __ZNSt3__2L10__init_patIcEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_(i11, i17, i1, i2, i12, i13) {
 i11 = i11 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i19 + 20 | 0;
 i9 = i19 + 16 | 0;
 i8 = i19 + 12 | 0;
 i14 = i19 + 8 | 0;
 i15 = i19 + 4 | 0;
 i16 = i19;
 if (i1) {
  i7 = HEAP8[i17 + 11 >> 0] | 0;
  i7 = ((i7 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i7 & 255) | 0) == 4;
 } else i7 = 0;
 L4 : do switch (i2 << 24 >> 24 | 0) {
 case 0:
  {
   if (i7) {
    i3 = HEAP8[i17 + 11 >> 0] | 0;
    i4 = i3 << 24 >> 24 < 0;
    i1 = i4 ? HEAP32[i17 >> 2] | 0 : i17;
    i2 = i1 + 3 | 0;
    i3 = i4 ? HEAP32[i17 + 4 >> 2] | 0 : i3 & 255;
    i4 = i1 + i3 | 0;
    i5 = i1;
    i6 = i4;
    if ((i3 | 0) != 3) if ((i3 | 0) == 4) {
     i16 = HEAP8[i2 >> 0] | 0;
     _memmove(i4 + -3 | 0, i1 | 0, 3) | 0;
     HEAP8[i1 >> 0] = i16;
    } else {
     HEAP32[i14 >> 2] = i5;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i16 >> 2] = i6;
     HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
     __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPcEEEET_S4_S4_S4_(i8, i9, i10) | 0;
    }
   }
   switch (i13 << 24 >> 24 | 0) {
   case 0:
    {
     HEAP8[i11 >> 0] = 3;
     HEAP8[i11 + 1 >> 0] = 4;
     HEAP8[i11 + 2 >> 0] = 0;
     HEAP8[i11 + 3 >> 0] = 2;
     switch (i12 << 24 >> 24 | 0) {
     case 2:
     case 0:
      break L4;
     case 1:
      break;
     default:
      {
       i18 = 75;
       break L4;
      }
     }
     if (i7) break L4;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
     break L4;
    }
   case 1:
    {
     HEAP8[i11 >> 0] = 3;
     HEAP8[i11 + 3 >> 0] = 2;
     switch (i12 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i11 + 1 >> 0] = 4;
       HEAP8[i11 + 2 >> 0] = 0;
       break L4;
      }
     case 1:
      {
       HEAP8[i11 + 1 >> 0] = 4;
       HEAP8[i11 + 2 >> 0] = 0;
       if (i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i11 + 1 >> 0] = 1;
       HEAP8[i11 + 2 >> 0] = 4;
       if (!i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 2:
    {
     HEAP8[i11 >> 0] = 4;
     HEAP8[i11 + 3 >> 0] = 3;
     switch (i12 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i11 + 1 >> 0] = 0;
       HEAP8[i11 + 2 >> 0] = 2;
       break L4;
      }
     case 1:
      {
       if (!i7) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
       HEAP8[i11 + 1 >> 0] = 0;
       HEAP8[i11 + 2 >> 0] = 2;
       break L4;
      }
     case 2:
      {
       HEAP8[i11 + 1 >> 0] = 2;
       HEAP8[i11 + 2 >> 0] = 1;
       if (!i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 3:
    {
     HEAP8[i11 >> 0] = 4;
     HEAP8[i11 + 3 >> 0] = 2;
     switch (i12 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i11 + 1 >> 0] = 0;
       HEAP8[i11 + 2 >> 0] = 3;
       break L4;
      }
     case 1:
      {
       HEAP8[i11 + 1 >> 0] = 1;
       HEAP8[i11 + 2 >> 0] = 3;
       if (!i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i11 + 1 >> 0] = 3;
       HEAP8[i11 + 2 >> 0] = 0;
       if (i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   case 4:
    {
     HEAP8[i11 >> 0] = 4;
     HEAP8[i11 + 3 >> 0] = 3;
     switch (i12 << 24 >> 24 | 0) {
     case 0:
      {
       HEAP8[i11 + 1 >> 0] = 0;
       HEAP8[i11 + 2 >> 0] = 2;
       break L4;
      }
     case 1:
      {
       HEAP8[i11 + 1 >> 0] = 0;
       HEAP8[i11 + 2 >> 0] = 2;
       if (i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
       break L4;
      }
     case 2:
      {
       HEAP8[i11 + 1 >> 0] = 2;
       HEAP8[i11 + 2 >> 0] = 1;
       if (!i7) break L4;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i17, 0, 1) | 0;
       break L4;
      }
     default:
      {
       i18 = 75;
       break L4;
      }
     }
    }
   default:
    {
     i18 = 75;
     break L4;
    }
   }
  }
 case 1:
  switch (i13 << 24 >> 24 | 0) {
  case 0:
   {
    HEAP8[i11 >> 0] = 3;
    HEAP8[i11 + 1 >> 0] = 2;
    HEAP8[i11 + 2 >> 0] = 0;
    HEAP8[i11 + 3 >> 0] = 4;
    switch (i12 << 24 >> 24 | 0) {
    case 2:
    case 0:
     break L4;
    case 1:
     break;
    default:
     {
      i18 = 75;
      break L4;
     }
    }
    if (i7) break L4;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i17, 0, 1, 32) | 0;
    break L4;
   }
  case 1:
   {
    HEAP8[i11 >> 0] = 3;
    HEAP8[i11 + 3 >> 0] = 4;
    switch (i12 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i11 + 1 >> 0] = 2;
      HEAP8[i11 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i11 + 1 >> 0] = 2;
      HEAP8[i11 + 2 >> 0] = 0;
      if (i7) break L4;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i11 + 1 >> 0] = 1;
      HEAP8[i11 + 2 >> 0] = 2;
      if (!i7) break L4;
      i1 = i17 + 11 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP8[i17 + i16 >> 0] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 2:
   {
    HEAP8[i11 >> 0] = 2;
    HEAP8[i11 + 3 >> 0] = 3;
    switch (i12 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i11 + 1 >> 0] = 0;
      HEAP8[i11 + 2 >> 0] = 4;
      break L4;
     }
    case 1:
     {
      HEAP8[i11 + 1 >> 0] = 0;
      HEAP8[i11 + 2 >> 0] = 4;
      if (i7) break L4;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i11 + 1 >> 0] = 4;
      HEAP8[i11 + 2 >> 0] = 1;
      if (!i7) break L4;
      i1 = i17 + 11 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP8[i17 + i16 >> 0] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 3:
   {
    HEAP8[i11 >> 0] = 3;
    HEAP8[i11 + 3 >> 0] = 4;
    switch (i12 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i11 + 1 >> 0] = 2;
      HEAP8[i11 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i11 + 1 >> 0] = 2;
      HEAP8[i11 + 2 >> 0] = 0;
      if (i7) break L4;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i17, 32);
      break L4;
     }
    case 2:
     {
      HEAP8[i11 + 1 >> 0] = 1;
      HEAP8[i11 + 2 >> 0] = 2;
      if (!i7) break L4;
      i1 = i17 + 11 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP8[i17 + i16 >> 0] = 0;
       break L4;
      }
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  case 4:
   {
    HEAP8[i11 >> 0] = 2;
    HEAP8[i11 + 3 >> 0] = 4;
    switch (i12 << 24 >> 24 | 0) {
    case 0:
     {
      HEAP8[i11 + 1 >> 0] = 3;
      HEAP8[i11 + 2 >> 0] = 0;
      break L4;
     }
    case 1:
     {
      HEAP8[i11 + 1 >> 0] = 3;
      HEAP8[i11 + 2 >> 0] = 1;
      if (!i7) break L4;
      i1 = i17 + 11 | 0;
      i2 = HEAP8[i1 >> 0] | 0;
      if (i2 << 24 >> 24 < 0) {
       i15 = i17 + 4 | 0;
       i16 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
       HEAP32[i15 >> 2] = i16;
       HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = 0;
       break L4;
      } else {
       i16 = (i2 & 255) + -1 | 0;
       HEAP8[i1 >> 0] = i16;
       HEAP8[i17 + i16 >> 0] = 0;
       break L4;
      }
     }
    case 2:
     {
      HEAP8[i11 + 1 >> 0] = 0;
      HEAP8[i11 + 2 >> 0] = 3;
      if (i7) break L4;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i17, 32);
      break L4;
     }
    default:
     {
      i18 = 75;
      break L4;
     }
    }
   }
  default:
   {
    i18 = 75;
    break L4;
   }
  }
 default:
  i18 = 75;
 } while (0);
 if ((i18 | 0) == 75) {
  HEAP8[i11 >> 0] = 2;
  HEAP8[i11 + 1 >> 0] = 3;
  HEAP8[i11 + 2 >> 0] = 0;
  HEAP8[i11 + 3 >> 0] = 4;
 }
 STACKTOP = i19;
 return;
}

function __Z16BuildLineSegmentjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_11ColorRGBA32(i10, i13, i14, i11, i6, i15, i7) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, f9 = f0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18 + 16 | 0;
 i16 = i18;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
  i5 = HEAP32[i7 >> 2] | 0;
  i12 = i7;
  i1 = i5 >>> 16;
  i2 = i5;
  i4 = i5 & 255;
  i5 = i5 >>> 8 & 255;
 } else {
  i2 = HEAP32[i7 >> 2] | 0;
  i12 = i7;
  i1 = i2;
  i4 = HEAP8[i7 + 2 >> 0] | 0;
  i5 = HEAP8[i7 + 1 >> 0] | 0;
 }
 i5 = i2 & -16777216 | i1 << 16 & 16711680 | i4 & 255 | (i5 & 255) << 8;
 HEAP32[i12 >> 2] = i5;
 f9 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(.5));
 HEAPF32[i8 >> 2] = f9;
 i1 = (i10 | 0) == 0;
 if (i1) i2 = 0; else if (((HEAP32[i11 + 24 >> 2] | 0) + -1 | 0) >>> 0 > i10 >>> 0) if ((HEAP32[i11 + 16 >> 2] | 0) > 0) {
  __Z17BuildSmoothCornerjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_RK11ColorRGBA32(i10, i13, i14, i11, i8, i15, i7);
  STACKTOP = i18;
  return;
 } else i2 = 1; else i2 = 0;
 i6 = (HEAP32[i11 >> 2] | 0) + (i10 << 4) | 0;
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if (i2) if ((HEAP32[i11 + 16 >> 2] | 0) < 1) {
  i4 = HEAP32[i11 + 12 >> 2] | 0;
  i1 = i4 + (i10 + -1 << 3) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = HEAP32[i11 + 4 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i8 + (i10 + 1 << 2) >> 2]);
  f3 = Math_fround(HEAPF32[i8 + (i10 << 2) >> 2]);
  if (f19 < f9) if (((HEAP32[i11 + 24 >> 2] | 0) + -2 | 0) >>> 0 > i10 >>> 0) {
   i11 = i4 + (i10 << 3) | 0;
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   f20 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(f3 + Math_fround(Math_fround(f21 - f3) * Math_fround(.5)));
   f19 = Math_fround(f19 + Math_fround(Math_fround(f20 - f19) * Math_fround(.5)));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  } else i17 = 13; else i17 = 13;
  if ((i17 | 0) == 13) if (i10 >>> 0 > 1 & f3 < f9) {
   i11 = i4 + (i10 + -2 << 3) | 0;
   f20 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f19 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = Math_fround(f20 + Math_fround(Math_fround(f19 - f20) * Math_fround(.5)));
   f21 = Math_fround(f21 + Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21) * Math_fround(.5)));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f23 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(f23 * f9);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f9);
  f24 = Math_fround(HEAPF32[i16 >> 2]);
  f22 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f31 = Math_fround(f24 + f23);
  f20 = Math_fround(f9 + f22);
  f21 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  i16 = HEAP32[i13 >> 2] | 0;
  i29 = i14 + 16 | 0;
  f3 = Math_fround(f20 * Math_fround(HEAPF32[i29 >> 2]));
  i28 = i14 + 20 | 0;
  f32 = Math_fround(f20 * Math_fround(HEAPF32[i28 >> 2]));
  i27 = i14 + 24 | 0;
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i27 >> 2]));
  f30 = Math_fround(f31 * Math_fround(HEAPF32[i14 >> 2]));
  i26 = i14 + 4 | 0;
  f33 = Math_fround(f31 * Math_fround(HEAPF32[i26 >> 2]));
  i1 = i14 + 8 | 0;
  f30 = Math_fround(f3 + f30);
  f33 = Math_fround(f32 + f33);
  f31 = Math_fround(f20 + Math_fround(f31 * Math_fround(HEAPF32[i1 >> 2])));
  i2 = i14 + 48 | 0;
  f20 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i14 + 52 | 0;
  f32 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i14 + 56 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i14 + 32 | 0;
  f19 = Math_fround(f21 * Math_fround(HEAPF32[i7 >> 2]));
  i8 = i14 + 36 | 0;
  f25 = Math_fround(f21 * Math_fround(HEAPF32[i8 >> 2]));
  i10 = i14 + 40 | 0;
  f25 = Math_fround(f33 + Math_fround(f32 + f25));
  f3 = Math_fround(f31 + Math_fround(f3 + Math_fround(f21 * Math_fround(HEAPF32[i10 >> 2]))));
  HEAPF32[i16 >> 2] = Math_fround(f30 + Math_fround(f20 + f19));
  HEAPF32[i16 + 4 >> 2] = f25;
  HEAPF32[i16 + 8 >> 2] = f3;
  HEAP32[i16 + 12 >> 2] = i5;
  HEAP32[i16 + 16 >> 2] = HEAP32[i15 >> 2];
  HEAPF32[i16 + 20 >> 2] = Math_fround(1.0);
  f23 = Math_fround(f24 - f23);
  f9 = Math_fround(f22 - f9);
  i11 = i16 + 24 | 0;
  f22 = Math_fround(f9 * Math_fround(HEAPF32[i29 >> 2]));
  f24 = Math_fround(f9 * Math_fround(HEAPF32[i28 >> 2]));
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i27 >> 2]));
  f3 = Math_fround(f23 * Math_fround(HEAPF32[i14 >> 2]));
  f25 = Math_fround(f23 * Math_fround(HEAPF32[i26 >> 2]));
  f3 = Math_fround(f22 + f3);
  f25 = Math_fround(f24 + f25);
  f23 = Math_fround(f9 + Math_fround(f23 * Math_fround(HEAPF32[i1 >> 2])));
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f24 = Math_fround(HEAPF32[i4 >> 2]);
  f22 = Math_fround(HEAPF32[i6 >> 2]);
  f19 = Math_fround(f21 * Math_fround(HEAPF32[i7 >> 2]));
  f20 = Math_fround(f21 * Math_fround(HEAPF32[i8 >> 2]));
  f20 = Math_fround(f25 + Math_fround(f24 + f20));
  f21 = Math_fround(f23 + Math_fround(f22 + Math_fround(f21 * Math_fround(HEAPF32[i10 >> 2]))));
  HEAPF32[i11 >> 2] = Math_fround(f3 + Math_fround(f9 + f19));
  HEAPF32[i11 + 4 >> 2] = f20;
  HEAPF32[i11 + 8 >> 2] = f21;
  HEAP32[i16 + 36 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i16 + 40 >> 2] = HEAP32[i15 >> 2];
  HEAPF32[i16 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i13 >> 2] = i16 + 48;
 } else i17 = 16; else i17 = 16;
 if ((i17 | 0) == 16) {
  if (i1) if ((HEAP32[i11 + 20 >> 2] | 0) > 0) __Z8BuildCapjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfRKNS2_7_float4ERK11ColorRGBA32SA_b(0, i13, i14, i11, i8, i16, i7, i15, 0);
  i28 = i10 + 1 | 0;
  i29 = i11 + 24 | 0;
  i38 = (HEAP32[i29 >> 2] | 0) + -1 | 0;
  i28 = (HEAP32[i11 + 8 >> 2] | 0) + ((i38 >>> 0 < i28 >>> 0 ? i38 : i28) << 3) | 0;
  f22 = Math_fround(HEAPF32[i28 >> 2]);
  f22 = Math_fround(f22 * f9);
  f24 = Math_fround(Math_fround(HEAPF32[i28 + 4 >> 2]) * f9);
  f23 = Math_fround(HEAPF32[i16 >> 2]);
  f30 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f19 = Math_fround(f23 - f22);
  f32 = Math_fround(f30 - f24);
  f33 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  i28 = HEAP32[i13 >> 2] | 0;
  i38 = i14 + 16 | 0;
  f25 = Math_fround(f32 * Math_fround(HEAPF32[i38 >> 2]));
  i37 = i14 + 20 | 0;
  f9 = Math_fround(f32 * Math_fround(HEAPF32[i37 >> 2]));
  i36 = i14 + 24 | 0;
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i36 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i14 >> 2]));
  i35 = i14 + 4 | 0;
  f3 = Math_fround(f19 * Math_fround(HEAPF32[i35 >> 2]));
  i34 = i14 + 8 | 0;
  f20 = Math_fround(f25 + f20);
  f3 = Math_fround(f9 + f3);
  f19 = Math_fround(f32 + Math_fround(f19 * Math_fround(HEAPF32[i34 >> 2])));
  i1 = i14 + 48 | 0;
  f32 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i14 + 52 | 0;
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i14 + 56 | 0;
  f25 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i14 + 32 | 0;
  f31 = Math_fround(f33 * Math_fround(HEAPF32[i6 >> 2]));
  i17 = i14 + 36 | 0;
  f21 = Math_fround(f33 * Math_fround(HEAPF32[i17 >> 2]));
  i26 = i14 + 40 | 0;
  f21 = Math_fround(f3 + Math_fround(f9 + f21));
  f25 = Math_fround(f19 + Math_fround(f25 + Math_fround(f33 * Math_fround(HEAPF32[i26 >> 2]))));
  HEAPF32[i28 >> 2] = Math_fround(f20 + Math_fround(f32 + f31));
  HEAPF32[i28 + 4 >> 2] = f21;
  HEAPF32[i28 + 8 >> 2] = f25;
  HEAP32[i28 + 12 >> 2] = i5;
  HEAP32[i28 + 16 >> 2] = HEAP32[i15 >> 2];
  HEAPF32[i28 + 20 >> 2] = Math_fround(1.0);
  f23 = Math_fround(f22 + f23);
  f30 = Math_fround(f24 + f30);
  i27 = i28 + 24 | 0;
  f24 = Math_fround(f30 * Math_fround(HEAPF32[i38 >> 2]));
  f22 = Math_fround(f30 * Math_fround(HEAPF32[i37 >> 2]));
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i36 >> 2]));
  f25 = Math_fround(f23 * Math_fround(HEAPF32[i14 >> 2]));
  f21 = Math_fround(f23 * Math_fround(HEAPF32[i35 >> 2]));
  f25 = Math_fround(f24 + f25);
  f21 = Math_fround(f22 + f21);
  f23 = Math_fround(f30 + Math_fround(f23 * Math_fround(HEAPF32[i34 >> 2])));
  f30 = Math_fround(HEAPF32[i1 >> 2]);
  f22 = Math_fround(HEAPF32[i2 >> 2]);
  f24 = Math_fround(HEAPF32[i4 >> 2]);
  f31 = Math_fround(f33 * Math_fround(HEAPF32[i6 >> 2]));
  f32 = Math_fround(f33 * Math_fround(HEAPF32[i17 >> 2]));
  f32 = Math_fround(f21 + Math_fround(f22 + f32));
  f33 = Math_fround(f23 + Math_fround(f24 + Math_fround(f33 * Math_fround(HEAPF32[i26 >> 2]))));
  HEAPF32[i27 >> 2] = Math_fround(f25 + Math_fround(f30 + f31));
  HEAPF32[i27 + 4 >> 2] = f32;
  HEAPF32[i27 + 8 >> 2] = f33;
  HEAP32[i28 + 36 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i28 + 40 >> 2] = HEAP32[i15 >> 2];
  HEAPF32[i28 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i13 >> 2] = i28 + 48;
  if (((HEAP32[i29 >> 2] | 0) + -1 | 0) == (i10 | 0)) if ((HEAP32[i11 + 20 >> 2] | 0) > 0) __Z8BuildCapjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfRKNS2_7_float4ERK11ColorRGBA32SA_b(i10, i13, i14, i11, i8, i16, i7, i15, 1);
 }
 STACKTOP = i18;
 return;
}

function __ZN5physx2Gu19gjkRelativeFallbackERKNS0_7ConvexVES3_PNS0_10SupportMapES5_RKNS_6shdfnd3aos5Vec3VERS8_SB_SB_RNS7_6FloatVE(i5, i6, i36, i37, i2, i54, i55, i56, i57) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i2 = i2 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i58 = 0;
 i58 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i58 + 360 | 0;
 i35 = i58 + 256 | 0;
 i33 = i58 + 192 | 0;
 i34 = i58 + 128 | 0;
 i38 = i58 + 356 | 0;
 i43 = i58 + 112 | 0;
 i52 = i58 + 96 | 0;
 i53 = i58 + 80 | 0;
 i44 = i58 + 344 | 0;
 i40 = i58 + 64 | 0;
 i31 = i58 + 48 | 0;
 i41 = i58 + 32 | 0;
 i39 = i58 + 16 | 0;
 i32 = i58;
 i30 = i58 + 332 | 0;
 i51 = i58 + 320 | 0;
 HEAP32[i38 >> 2] = 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i28 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)) + Math_fround(f3 * f3)) > Math_fround(0.0);
 f7 = i28 ? f7 : Math_fround(1.0);
 f4 = i28 ? f4 : Math_fround(0.0);
 f3 = i28 ? f3 : Math_fround(0.0);
 HEAPF32[i43 >> 2] = f7;
 i28 = i43 + 4 | 0;
 HEAPF32[i28 >> 2] = f4;
 i29 = i43 + 8 | 0;
 HEAPF32[i29 >> 2] = f3;
 HEAPF32[i43 + 12 >> 2] = Math_fround(0.0);
 f18 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f18 = Math_fround((f18 > f14 ? f14 : f18) * Math_fround(.00999999977));
 i47 = i52 + 4 | 0;
 i48 = i52 + 8 | 0;
 i45 = i52 + 12 | 0;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 HEAP32[i52 + 12 >> 2] = 0;
 i49 = i53 + 4 | 0;
 i50 = i53 + 8 | 0;
 i46 = i53 + 12 | 0;
 i6 = i31 + 4 | 0;
 i19 = i31 + 8 | 0;
 i20 = i31 + 12 | 0;
 i21 = i40 + 4 | 0;
 i22 = i40 + 8 | 0;
 i23 = i41 + 4 | 0;
 i24 = i41 + 8 | 0;
 i25 = i39 + 4 | 0;
 i26 = i39 + 8 | 0;
 i27 = i39 + 12 | 0;
 HEAP32[i53 >> 2] = 0;
 HEAP32[i53 + 4 >> 2] = 0;
 HEAP32[i53 + 8 >> 2] = 0;
 HEAP32[i53 + 12 >> 2] = 0;
 f14 = Math_fround(0.0);
 f13 = Math_fround(0.0);
 f12 = Math_fround(0.0);
 f11 = Math_fround(0.0);
 f10 = Math_fround(0.0);
 f9 = Math_fround(0.0);
 f1 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  i2 = HEAP32[(HEAP32[i36 >> 2] | 0) + 4 >> 2] | 0;
  f17 = Math_fround(-f4);
  f15 = Math_fround(-f3);
  HEAPF32[i31 >> 2] = Math_fround(-f7);
  HEAPF32[i6 >> 2] = f17;
  HEAPF32[i19 >> 2] = f15;
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  mftCall_viii(i2 | 0, i40 | 0, i36 | 0, i31 | 0);
  mftCall_viii(HEAP32[(HEAP32[i37 >> 2] | 0) + 4 >> 2] | 0, i41 | 0, i37 | 0, i43 | 0);
  f15 = Math_fround(HEAPF32[i40 >> 2]);
  f7 = Math_fround(HEAPF32[i21 >> 2]);
  f17 = Math_fround(HEAPF32[i22 >> 2]);
  f8 = Math_fround(HEAPF32[i41 >> 2]);
  f16 = Math_fround(HEAPF32[i23 >> 2]);
  f8 = Math_fround(f15 - f8);
  f16 = Math_fround(f7 - f16);
  f17 = Math_fround(f17 - Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i39 >> 2] = f8;
  HEAPF32[i25 >> 2] = f16;
  HEAPF32[i26 >> 2] = f17;
  HEAPF32[i27 >> 2] = Math_fround(0.0);
  i2 = HEAP32[i38 >> 2] | 0;
  i5 = i33 + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  i5 = i34 + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  HEAP32[i38 >> 2] = i2 + 1;
  i5 = i35 + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  f7 = Math_fround(HEAPF32[i43 >> 2]);
  f15 = Math_fround(HEAPF32[i28 >> 2]);
  if (Math_fround(f1 * Math_fround(.000224999996)) > Math_fround(f1 - Math_fround(Math_fround(Math_fround(f7 * f8) + Math_fround(f15 * f16)) + Math_fround(Math_fround(HEAPF32[i29 >> 2]) * f17)))) {
   i2 = 3;
   break;
  }
  switch (i2 | 0) {
  case 0:
   {
    HEAP32[i52 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i52 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i52 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i52 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
    HEAP32[i53 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i53 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i53 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i53 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
    HEAP32[i32 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i32 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i32 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i32 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
    break;
   }
  case 1:
   {
    __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i32, i35, i39, i33, i40, i34, i41, i38, i52, i53);
    break;
   }
  case 2:
   {
    HEAP32[i42 >> 2] = HEAP32[gb + 101572 >> 2];
    HEAP32[i42 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
    HEAP32[i42 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
    __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_(i32, i35, i33, i34, i42, i38, i52, i53);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu36closestPtPointTetrahedronTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_RjRS3_S6_(i32, i35, i33, i34, i38, i52, i53);
    break;
   }
  default:
   {
    HEAP32[i32 >> 2] = HEAP32[i39 >> 2];
    HEAP32[i32 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
    HEAP32[i32 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
    HEAP32[i32 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
   }
  }
  HEAP32[i43 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  f15 = Math_fround(HEAPF32[i43 >> 2]);
  f16 = Math_fround(HEAPF32[i28 >> 2]);
  f17 = Math_fround(HEAPF32[i29 >> 2]);
  f8 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f17 * f17));
  HEAP32[i44 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  i5 = f1 > f8;
  f7 = Math_fround(HEAPF32[i52 >> 2]);
  f4 = Math_fround(HEAPF32[i47 >> 2]);
  f3 = Math_fround(HEAPF32[i48 >> 2]);
  if (!(f8 > f18 & i5)) {
   i2 = 12;
   break;
  }
  f12 = Math_fround(HEAPF32[i53 >> 2]);
  f13 = Math_fround(HEAPF32[i49 >> 2]);
  f14 = Math_fround(HEAPF32[i50 >> 2]);
  f11 = f3;
  f10 = f4;
  f9 = f7;
  f7 = f15;
  f4 = f16;
  f3 = f17;
  f1 = f8;
 }
 if ((i2 | 0) == 3) {
  f14 = Math_fround(HEAPF32[i53 >> 2]);
  f18 = Math_fround(HEAPF32[i49 >> 2]);
  f15 = Math_fround(HEAPF32[i50 >> 2]);
  f16 = Math_fround(HEAPF32[i52 >> 2]);
  f17 = Math_fround(HEAPF32[i47 >> 2]);
  f16 = Math_fround(f14 - f16);
  f17 = Math_fround(f18 - f17);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i48 >> 2]));
  f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f15 * f15)))));
  f16 = Math_fround(f16 * f18);
  f17 = Math_fround(f17 * f18);
  f18 = Math_fround(f15 * f18);
  HEAP32[i54 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i55 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  HEAPF32[i57 >> 2] = f1;
  i57 = i57 + 4 | 0;
  HEAP32[i57 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAPF32[i56 >> 2] = f16;
  HEAPF32[i56 + 4 >> 2] = f17;
  HEAPF32[i56 + 8 >> 2] = f18;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  i57 = 0;
  STACKTOP = i58;
  return i57 | 0;
 } else if ((i2 | 0) == 12) {
  f15 = i5 ? f7 : f9;
  f17 = i5 ? f4 : f10;
  f18 = i5 ? f3 : f11;
  HEAPF32[i52 >> 2] = f15;
  HEAPF32[i47 >> 2] = f17;
  HEAPF32[i48 >> 2] = f18;
  HEAPF32[i45 >> 2] = Math_fround(0.0);
  f10 = Math_fround(HEAPF32[i53 >> 2]);
  f11 = Math_fround(HEAPF32[i49 >> 2]);
  f16 = Math_fround(HEAPF32[i50 >> 2]);
  f12 = i5 ? f10 : f12;
  f13 = i5 ? f11 : f13;
  f16 = i5 ? f16 : f14;
  HEAPF32[i53 >> 2] = f12;
  HEAPF32[i49 >> 2] = f13;
  HEAPF32[i50 >> 2] = f16;
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  HEAP32[i54 >> 2] = HEAP32[i52 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
  HEAP32[i55 >> 2] = HEAP32[i53 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
  f15 = Math_fround(f12 - f15);
  f17 = Math_fround(f13 - f17);
  f18 = Math_fround(f16 - f18);
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)))));
  f17 = Math_fround(f17 * f16);
  f18 = Math_fround(f18 * f16);
  HEAPF32[i56 >> 2] = Math_fround(f15 * f16);
  HEAPF32[i56 + 4 >> 2] = f17;
  HEAPF32[i56 + 8 >> 2] = f18;
  HEAPF32[i56 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i57 >> 2] = i5 ? f8 : f1;
  i57 = i57 + 4 | 0;
  HEAP32[i57 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i57 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i57 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  i57 = i5 ? 1 : 3;
  STACKTOP = i58;
  return i57 | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc(i36, i37, i38, i39, i40, i41, i42, i1) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i43 = 0, i44 = 0, i45 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i43 + 128 | 0;
 i1 = i43 + 112 | 0;
 i34 = i43 + 124 | 0;
 i35 = i43 + 120 | 0;
 i3 = i43 + 116 | 0;
 i4 = i43 + 108 | 0;
 i5 = i43 + 104 | 0;
 i6 = i43 + 100 | 0;
 i7 = i43 + 96 | 0;
 i8 = i43 + 92 | 0;
 i9 = i43 + 88 | 0;
 i10 = i43 + 84 | 0;
 i11 = i43 + 80 | 0;
 i12 = i43 + 76 | 0;
 i13 = i43 + 72 | 0;
 i14 = i43 + 68 | 0;
 i15 = i43 + 64 | 0;
 i16 = i43 + 60 | 0;
 i17 = i43 + 56 | 0;
 i18 = i43 + 52 | 0;
 i19 = i43 + 48 | 0;
 i20 = i43 + 44 | 0;
 i21 = i43 + 40 | 0;
 i22 = i43 + 36 | 0;
 i23 = i43 + 32 | 0;
 i24 = i43 + 28 | 0;
 i25 = i43 + 24 | 0;
 i26 = i43 + 20 | 0;
 i27 = i43 + 16 | 0;
 i28 = i43 + 12 | 0;
 i29 = i43 + 8 | 0;
 i30 = i43 + 4 | 0;
 i31 = i43;
 HEAP32[i40 >> 2] = 0;
 i32 = __ZNKSt3__28ios_base6getlocEv(i39) | 0;
 HEAP32[i2 >> 2] = i32;
 __THREW__ = 0;
 i33 = invoke_iii(fb + 1145 | 0, i2 | 0, gb + 1474556 | 0) | 0;
 i45 = __THREW__;
 __THREW__ = 0;
 if (i45 & 1) {
  i45 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i32) | 0;
  ___resumeException(i45 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i32) | 0;
 do switch (i42 << 24 >> 24 | 0) {
 case 65:
 case 97:
  {
   HEAP32[i34 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i34 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 24 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 104:
 case 66:
 case 98:
  {
   HEAP32[i35 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i35 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 16 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 99:
  {
   i42 = i36 + 8 | 0;
   i42 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 12 >> 2] | 0, i42 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i38 >> 2];
   i44 = HEAP8[i42 + 11 >> 0] | 0;
   i38 = i44 << 24 >> 24 < 0;
   i45 = i38 ? HEAP32[i42 >> 2] | 0 : i42;
   i44 = i45 + (i38 ? HEAP32[i42 + 4 >> 2] | 0 : i44 & 255) | 0;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, i45, i44) | 0;
   i44 = 28;
   break;
  }
 case 101:
 case 100:
  {
   HEAP32[i5 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 12 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 68:
  {
   HEAP32[i6 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, gb + 1078721 | 0, gb + 1078721 + 8 | 0) | 0;
   i44 = 28;
   break;
  }
 case 70:
  {
   HEAP32[i8 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, gb + 1078729 | 0, gb + 1078729 + 8 | 0) | 0;
   i44 = 28;
   break;
  }
 case 72:
  {
   HEAP32[i10 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 73:
  {
   HEAP32[i11 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 106:
  {
   HEAP32[i12 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 28 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 109:
  {
   HEAP32[i13 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 16 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 77:
  {
   HEAP32[i14 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 4 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 116:
 case 110:
  {
   HEAP32[i15 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i36, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 112:
  {
   HEAP32[i16 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 8 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 114:
  {
   HEAP32[i17 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, gb + 1078737 | 0, gb + 1078737 + 11 | 0) | 0;
   i44 = 28;
   break;
  }
 case 82:
  {
   HEAP32[i19 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, gb + 1078748 | 0, gb + 1078748 + 5 | 0) | 0;
   i44 = 28;
   break;
  }
 case 83:
  {
   HEAP32[i21 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 84:
  {
   HEAP32[i22 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, gb + 1078753 | 0, gb + 1078753 + 8 | 0) | 0;
   i44 = 28;
   break;
  }
 case 119:
  {
   HEAP32[i24 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i24 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 24 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 120:
  {
   i45 = HEAP32[(HEAP32[i36 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i26 >> 2];
   i1 = mftCall_iiiiiii(i45 | 0, i36 | 0, i1 | 0, i2 | 0, i39 | 0, i40 | 0, i41 | 0) | 0;
   break;
  }
 case 88:
  {
   i42 = i36 + 8 | 0;
   i42 = mftCall_ii(HEAP32[(HEAP32[i42 >> 2] | 0) + 24 >> 2] | 0, i42 | 0) | 0;
   HEAP32[i27 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i38 >> 2];
   i44 = HEAP8[i42 + 11 >> 0] | 0;
   i38 = i44 << 24 >> 24 < 0;
   i45 = i38 ? HEAP32[i42 >> 2] | 0 : i42;
   i44 = i45 + (i38 ? HEAP32[i42 + 4 >> 2] | 0 : i44 & 255) | 0;
   HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i37 >> 2] = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i36, i1, i2, i39, i40, i41, i45, i44) | 0;
   i44 = 28;
   break;
  }
 case 121:
  {
   HEAP32[i29 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i29 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 20 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 89:
  {
   HEAP32[i30 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i30 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i36, i41 + 20 | 0, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 case 37:
  {
   HEAP32[i31 >> 2] = HEAP32[i38 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i31 >> 2];
   __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i36, i37, i2, i40, i33);
   i44 = 28;
   break;
  }
 default:
  {
   HEAP32[i40 >> 2] = HEAP32[i40 >> 2] | 4;
   i44 = 28;
  }
 } while (0);
 if ((i44 | 0) == 28) i1 = HEAP32[i37 >> 2] | 0;
 STACKTOP = i43;
 return i1 | 0;
}

function __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimDataNWEEEEEEEjT_j(i12, i17, i18) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i14 = i19 + 552 | 0;
 i16 = i19 + 296 | 0;
 i15 = i19 + 148 | 0;
 i6 = HEAP32[i12 + 8 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 i9 = i17 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i15 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i15);
 i10 = i17 + 8 | 0;
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i11 = i17 + 4 | 0;
 i7 = i17 + 12 | 0;
 i8 = i17 + 16 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 24 >> 2] | 0;
 i5 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i20 = i13;
  i4 = HEAP32[i20 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 40 >> 2] | 0;
 i5 = HEAP32[i12 + 32 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i13;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i20 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 56 >> 2] | 0;
 i5 = HEAP32[i12 + 48 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i13;
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i15 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i20 = i18 + 4 | 0;
  STACKTOP = i19;
  return i20 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i20 = i18 + 4 | 0;
 STACKTOP = i19;
 return i20 | 0;
}

function __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j(i12, i17, i18) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i14 = i19 + 552 | 0;
 i16 = i19 + 296 | 0;
 i15 = i19 + 148 | 0;
 i6 = HEAP32[i12 + 8 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 i9 = i17 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i15 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i15);
 i10 = i17 + 8 | 0;
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i11 = i17 + 4 | 0;
 i7 = i17 + 12 | 0;
 i8 = i17 + 16 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 24 >> 2] | 0;
 i5 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i20 = i13;
  i4 = HEAP32[i20 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 40 >> 2] | 0;
 i5 = HEAP32[i12 + 32 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i13;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i20 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 56 >> 2] | 0;
 i5 = HEAP32[i12 + 48 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i13;
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i15 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i20 = i18 + 4 | 0;
  STACKTOP = i19;
  return i20 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i20 = i18 + 4 | 0;
 STACKTOP = i19;
 return i20 | 0;
}

function __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveSimDataEEEEEEEjT_j(i12, i17, i18) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i14 = i19 + 552 | 0;
 i16 = i19 + 296 | 0;
 i15 = i19 + 148 | 0;
 i6 = HEAP32[i12 + 8 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 i9 = i17 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i15 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i15);
 i10 = i17 + 8 | 0;
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i11 = i17 + 4 | 0;
 i7 = i17 + 12 | 0;
 i8 = i17 + 16 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 24 >> 2] | 0;
 i5 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i20 = i13;
  i4 = HEAP32[i20 + 4 >> 2] | 0;
  i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 40 >> 2] | 0;
 i5 = HEAP32[i12 + 32 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i13;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i20 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 56 >> 2] | 0;
 i5 = HEAP32[i12 + 48 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i13;
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  i20 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i20 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i15 = HEAP32[i17 >> 2] | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i20 = i18 + 4 | 0;
  STACKTOP = i19;
  return i20 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i20 = i18 + 4 | 0;
 STACKTOP = i19;
 return i20 | 0;
}

function __ZNK5Umbra18ImpOcclusionBuffer13visualizeHullEPNS_12QueryContextE(i1, i74) {
 i1 = i1 | 0;
 i74 = i74 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, f84 = f0, f85 = f0, f86 = f0, d87 = 0.0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0;
 i83 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i78 = i83 + 112 | 0;
 i79 = i83 + 64 | 0;
 i80 = i83 + 16 | 0;
 i81 = i83;
 i82 = i1 + 1408 | 0;
 if (!(HEAP32[i82 >> 2] | 0)) {
  STACKTOP = i83;
  return;
 }
 HEAP32[i78 >> 2] = HEAP32[i1 >> 2];
 i75 = i78 + 4 | 0;
 HEAP32[i75 >> 2] = HEAP32[i1 + 4 >> 2];
 i76 = i78 + 8 | 0;
 HEAP32[i76 >> 2] = HEAP32[i1 + 8 >> 2];
 i77 = i78 + 12 | 0;
 HEAP32[i77 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i78 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i78 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i78 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i78 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i78 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i78 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i78 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i78 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i78 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i78 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i78 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i78 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i78, i78) | 0;
 i34 = i78 + 48 | 0;
 i35 = i78 + 52 | 0;
 i36 = i78 + 56 | 0;
 i37 = i78 + 60 | 0;
 i38 = i78 + 16 | 0;
 i39 = i78 + 20 | 0;
 i40 = i78 + 24 | 0;
 i41 = i78 + 28 | 0;
 i42 = i78 + 32 | 0;
 i43 = i78 + 36 | 0;
 i44 = i78 + 40 | 0;
 i45 = i78 + 44 | 0;
 i46 = i80 + 24 | 0;
 i47 = i80 + 28 | 0;
 i48 = i80 + 4 | 0;
 i49 = i80 + 32 | 0;
 i50 = i80 + 8 | 0;
 i51 = i80 + 12 | 0;
 i52 = i80 + 36 | 0;
 i53 = i81 + 4 | 0;
 i54 = i81 + 8 | 0;
 i55 = i81 + 12 | 0;
 i56 = i81 + 4 | 0;
 i57 = i81 + 8 | 0;
 i58 = i81 + 12 | 0;
 i59 = i79 + 36 | 0;
 i60 = i81 + 4 | 0;
 i61 = i81 + 8 | 0;
 i62 = i81 + 12 | 0;
 i63 = i79 + 24 | 0;
 i64 = i79 + 12 | 0;
 i65 = i81 + 4 | 0;
 i66 = i81 + 8 | 0;
 i67 = i81 + 12 | 0;
 i68 = i81 + 4 | 0;
 i69 = i81 + 8 | 0;
 i70 = i81 + 12 | 0;
 i28 = 0;
 do {
  i29 = i28;
  i28 = i28 + 1 | 0;
  i71 = i29 >>> 2 << 8;
  i72 = i29 << 2 & 12;
  i73 = i28 >>> 2 << 8;
  i31 = i28 << 2 & 12;
  i32 = (i29 | 0) == 0;
  i33 = (i28 | 0) == 63;
  i30 = 0;
  do {
   i11 = i30 >>> 2 << 4;
   i10 = i30 & 3;
   i27 = HEAP32[i82 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i27 + ((i10 | i72 | i11 + i71) << 2) >> 2]);
   L8 : do if (Math_fround(HEAPF32[i27 + ((i10 | i31 | i11 + i73) << 2) >> 2]) == f2) {
    i10 = i30 + 16 | 0;
    i10 = (i10 | 0) > 63 ? 63 : i10;
    i8 = i30 + 1 | 0;
    if ((i8 | 0) < (i10 | 0)) {
     i6 = i30;
     i1 = 0;
     i11 = i8;
     while (1) {
      i7 = i11 >>> 2 << 4;
      i9 = i11 & 3;
      if (!(Math_fround(HEAPF32[i27 + ((i9 | i72 | i7 + i71) << 2) >> 2]) == f2)) {
       i9 = i6;
       break L8;
      }
      if (!(Math_fround(HEAPF32[i27 + ((i9 | i31 | i7 + i73) << 2) >> 2]) == f2)) {
       i9 = i6;
       break L8;
      }
      i1 = i1 + 1 | 0;
      i6 = i11 + 1 | 0;
      if ((i6 | 0) < (i10 | 0)) {
       i9 = i11;
       i11 = i6;
       i6 = i9;
      } else {
       i9 = i11;
       break;
      }
     }
    } else {
     i9 = i30;
     i1 = 0;
    }
   } else {
    i9 = i30;
    i1 = 0;
    i8 = i30 + 1 | 0;
   } while (0);
   i6 = i79;
   i7 = i6 + 48 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   i1 = (i1 | 0) == 0;
   i6 = i80;
   i7 = i6 + 48 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   i6 = i30;
   i30 = i1 ? i8 : i9;
   f2 = Math_fround(HEAPF32[i34 >> 2]);
   f3 = Math_fround(HEAPF32[i35 >> 2]);
   f4 = Math_fround(HEAPF32[i36 >> 2]);
   f5 = Math_fround(HEAPF32[i37 >> 2]);
   f12 = Math_fround(HEAPF32[i78 >> 2]);
   f13 = Math_fround(HEAPF32[i75 >> 2]);
   f14 = Math_fround(HEAPF32[i76 >> 2]);
   f15 = Math_fround(HEAPF32[i77 >> 2]);
   f16 = Math_fround(HEAPF32[i38 >> 2]);
   f17 = Math_fround(HEAPF32[i39 >> 2]);
   f18 = Math_fround(HEAPF32[i40 >> 2]);
   f19 = Math_fround(HEAPF32[i41 >> 2]);
   f23 = Math_fround(HEAPF32[i42 >> 2]);
   f24 = Math_fround(HEAPF32[i43 >> 2]);
   f25 = Math_fround(HEAPF32[i44 >> 2]);
   f20 = Math_fround(f4 * Math_fround(0.0));
   f21 = Math_fround(f14 * Math_fround(0.0));
   f22 = Math_fround(f18 * Math_fround(0.0));
   i1 = 0;
   f26 = Math_fround(HEAPF32[i45 >> 2]);
   do {
    i10 = (i1 >> 1 | 0) == (i1 & 1 | 0) ? i6 : i30;
    i11 = i1 & 2 | 0 ? i28 : i29;
    f84 = Math_fround(HEAPF32[i27 + ((i11 << 2 & 12 | i10 & 3 | (i11 >>> 2 << 8) + (i10 >>> 2 << 4)) << 2) >> 2]);
    f89 = Math_fround(Math_fround(Math_fround(i10 | 0) * Math_fround(.03125)) + Math_fround(-1.0));
    f88 = Math_fround(Math_fround(Math_fround(i11 | 0) * Math_fround(.03125)) + Math_fround(-1.0));
    f90 = Math_fround(Math_fround(f89 * f2) + Math_fround(f88 * f3));
    d87 = 1.0 / +Math_fround(f5 + Math_fround(f90 + f20));
    f86 = Math_fround(Math_fround(f89 * f12) + Math_fround(f88 * f13));
    f85 = Math_fround(Math_fround(f89 * f16) + Math_fround(f88 * f17));
    f92 = Math_fround(d87 * +Math_fround(f19 + Math_fround(f85 + f22)));
    f91 = Math_fround(d87 * +Math_fround(f26 + Math_fround(Math_fround(Math_fround(f89 * f23) + Math_fround(f88 * f24)) + Math_fround(f25 * Math_fround(0.0)))));
    HEAPF32[i79 + (i1 * 12 | 0) >> 2] = Math_fround(d87 * +Math_fround(f15 + Math_fround(f86 + f21)));
    HEAPF32[i79 + (i1 * 12 | 0) + 4 >> 2] = f92;
    HEAPF32[i79 + (i1 * 12 | 0) + 8 >> 2] = f91;
    d87 = 1.0 / +Math_fround(f5 + Math_fround(f90 + Math_fround(f84 * f4)));
    f86 = Math_fround(d87 * +Math_fround(f15 + Math_fround(f86 + Math_fround(f84 * f14))));
    f85 = Math_fround(d87 * +Math_fround(f19 + Math_fround(f85 + Math_fround(f84 * f18))));
    f23 = Math_fround(HEAPF32[i42 >> 2]);
    f89 = Math_fround(f89 * f23);
    f24 = Math_fround(HEAPF32[i43 >> 2]);
    f88 = Math_fround(f89 + Math_fround(f88 * f24));
    f25 = Math_fround(HEAPF32[i44 >> 2]);
    f84 = Math_fround(f88 + Math_fround(f84 * f25));
    f26 = Math_fround(HEAPF32[i45 >> 2]);
    f84 = Math_fround(d87 * +Math_fround(f26 + f84));
    HEAPF32[i80 + (i1 * 12 | 0) >> 2] = f86;
    HEAPF32[i80 + (i1 * 12 | 0) + 4 >> 2] = f85;
    HEAPF32[i80 + (i1 * 12 | 0) + 8 >> 2] = f84;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   f4 = Math_fround(HEAPF32[i46 >> 2]);
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i80 >> 2]));
   f3 = Math_fround(HEAPF32[i47 >> 2]);
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i48 >> 2]));
   f2 = Math_fround(HEAPF32[i49 >> 2]);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i50 >> 2]));
   f5 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2));
   if (f5 != Math_fround(0.0)) {
    d87 = 1.0 / +Math_sqrt(+(+f5));
    f4 = Math_fround(+f4 * d87);
    f3 = Math_fround(+f3 * d87);
    f2 = Math_fround(+f2 * d87);
   }
   f92 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(.577350259)) + Math_fround(Math_fround(f3 * Math_fround(.577350259)) + Math_fround(f4 * Math_fround(.577350259)))) * Math_fround(.5)) + Math_fround(.5));
   HEAPF32[i81 >> 2] = Math_fround(0.0);
   HEAPF32[i53 >> 2] = f92;
   HEAPF32[i54 >> 2] = Math_fround(0.0);
   HEAPF32[i55 >> 2] = Math_fround(.5);
   i1 = HEAP32[(HEAP32[i74 >> 2] | 0) + 32 >> 2] | 0;
   if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i80 | 0, i51 | 0, i46 | 0, i52 | 0, i81 | 0);
   if (!i6) {
    HEAPF32[i81 >> 2] = Math_fround(0.0);
    HEAPF32[i56 >> 2] = Math_fround(.5);
    HEAPF32[i57 >> 2] = Math_fround(0.0);
    HEAPF32[i58 >> 2] = Math_fround(.5);
    i1 = HEAP32[(HEAP32[i74 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i79 | 0, i59 | 0, i52 | 0, i80 | 0, i81 | 0);
   }
   if ((i30 | 0) == 63) {
    HEAPF32[i81 >> 2] = Math_fround(0.0);
    HEAPF32[i60 >> 2] = Math_fround(.5);
    HEAPF32[i61 >> 2] = Math_fround(0.0);
    HEAPF32[i62 >> 2] = Math_fround(.5);
    i1 = HEAP32[(HEAP32[i74 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i64 | 0, i63 | 0, i46 | 0, i51 | 0, i81 | 0);
   }
   if (i32) {
    HEAPF32[i81 >> 2] = Math_fround(0.0);
    HEAPF32[i65 >> 2] = Math_fround(1.0);
    HEAPF32[i66 >> 2] = Math_fround(0.0);
    HEAPF32[i67 >> 2] = Math_fround(.5);
    i1 = HEAP32[(HEAP32[i74 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i79 | 0, i64 | 0, i51 | 0, i80 | 0, i81 | 0);
   }
   if (i33) {
    HEAPF32[i81 >> 2] = Math_fround(0.0);
    HEAPF32[i68 >> 2] = Math_fround(1.0);
    HEAPF32[i69 >> 2] = Math_fround(0.0);
    HEAPF32[i70 >> 2] = Math_fround(.5);
    i1 = HEAP32[(HEAP32[i74 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i59 | 0, i63 | 0, i46 | 0, i52 | 0, i81 | 0);
   }
  } while ((i30 | 0) < 63);
 } while ((i28 | 0) != 63);
 STACKTOP = i83;
 return;
}

function _unzOpen2(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 180 | 0;
 i15 = i16;
 if (!i1) _fill_fopen_filefunc(i15); else {
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i15 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i15 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 }
 i14 = i15 + 28 | 0;
 i8 = mftCall_iiii(HEAP32[i15 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0, 5) | 0;
 i12 = i15 + 32 | 0;
 HEAP32[i12 >> 2] = i8;
 if (!i8) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i15 + 16 | 0;
 if (!(mftCall_iiiii(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0, i8 | 0, 0, 2) | 0)) {
  i6 = mftCall_iii(HEAP32[i15 + 12 >> 2] | 0, HEAP32[i14 >> 2] | 0, i8 | 0) | 0;
  i4 = i6 >>> 0 < 65535 ? i6 : 65535;
  i9 = _malloc(1028) | 0;
  if (!i9) i9 = 0; else {
   i7 = i15 + 4 | 0;
   L11 : do if (i4 >>> 0 > 4) {
    i5 = 4;
    while (1) {
     i3 = i5 + 1024 | 0;
     i5 = i3 >>> 0 > i4 >>> 0 ? i4 : i3;
     i3 = i6 - i5 | 0;
     i1 = i5 >>> 0 > 1028 ? 1028 : i5;
     if (mftCall_iiiii(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0, i8 | 0, i3 | 0, 0) | 0) {
      i1 = 0;
      break L11;
     }
     if ((mftCall_iiiii(HEAP32[i7 >> 2] | 0, HEAP32[i14 >> 2] | 0, i8 | 0, i9 | 0, i1 | 0) | 0) != (i1 | 0)) {
      i1 = 0;
      break L11;
     }
     L16 : do if ((i1 | 0) > 3) {
      i2 = i1 + -4 | 0;
      while (1) {
       i1 = i9 + i2 | 0;
       if ((HEAP8[i1 >> 0] | 0) == 80) if ((HEAP8[i1 + 1 >> 0] | 0) == 75) if ((HEAP8[i1 + 2 >> 0] | 0) == 5) if ((HEAP8[i1 + 3 >> 0] | 0) == 6) break;
       if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break L16;
      }
      i1 = i2 + i3 | 0;
      if (i1 | 0) break L11;
     } while (0);
     if (i5 >>> 0 >= i4 >>> 0) {
      i1 = 0;
      break;
     }
    }
   } else i1 = 0; while (0);
   _free(i9);
   i9 = i1;
  }
 } else i9 = 0;
 i1 = (mftCall_iiiii(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] | 0, i9 | 0, 0) | 0) == 0;
 i1 = i1 ? ((i9 | 0) == 0) << 31 >> 31 : -1;
 i2 = HEAP32[i12 >> 2] | 0;
 i8 = i15 + 4 | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0, i11 | 0, 1) | 0) == 1) i13 = 23; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0) | 0)) i13 = 23; else i1 = -1;
 do if ((i13 | 0) == 23) {
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0, i11 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0) | 0) {
   i1 = -1;
   break;
  }
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0, i11 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0) | 0) {
   i1 = -1;
   break;
  }
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0, i11 | 0, 1) | 0) != 1) if (mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2 | 0) | 0) {
   i1 = -1;
   break;
  }
 } while (0);
 i3 = HEAP32[i12 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0, i11 | 0, 1) | 0) == 1) {
  i2 = HEAPU8[i11 >> 0] | 0;
  i13 = 36;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0) | 0)) {
  i2 = 0;
  i13 = 36;
 } else {
  i1 = -1;
  i2 = 0;
 }
 do if ((i13 | 0) == 36) if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0, i11 | 0, 1) | 0) == 1) i2 = HEAPU8[i11 >> 0] << 8 | i2; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0) | 0)) i2 = i2 * 257 | 0; else {
  i1 = -1;
  i2 = 0;
  break;
 } while (0);
 i4 = HEAP32[i12 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i4 | 0, i11 | 0, 1) | 0) == 1) {
  i3 = HEAPU8[i11 >> 0] | 0;
  i13 = 43;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i4 | 0) | 0)) {
  i3 = 0;
  i13 = 43;
 } else {
  i1 = -1;
  i3 = 0;
 }
 do if ((i13 | 0) == 43) if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i4 | 0, i11 | 0, 1) | 0) == 1) i3 = HEAPU8[i11 >> 0] << 8 | i3; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i4 | 0) | 0)) i3 = i3 * 257 | 0; else {
  i1 = -1;
  i3 = 0;
  break;
 } while (0);
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i15 + 36 | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i11 >> 0] | 0;
  i13 = 50;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) {
  i4 = 0;
  i13 = 50;
 } else {
  i1 = -1;
  i4 = 0;
 }
 do if ((i13 | 0) == 50) if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i4 = HEAPU8[i11 >> 0] << 8 | i4; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i4 = i4 * 257 | 0; else {
  i1 = -1;
  i4 = 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) {
  i4 = HEAPU8[i11 >> 0] | 0;
  i13 = 57;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) {
  i4 = 0;
  i13 = 57;
 } else {
  i1 = -1;
  i4 = 0;
 }
 do if ((i13 | 0) == 57) if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i4 = HEAPU8[i11 >> 0] << 8 | i4; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i4 = i4 * 257 | 0; else {
  i1 = -1;
  i4 = 0;
  break;
 } while (0);
 i2 = (i3 | i2 | 0 ? 1 : (i4 | 0) != (HEAP32[i6 >> 2] | 0)) ? -103 : i1;
 i5 = HEAP32[i12 >> 2] | 0;
 i7 = i15 + 64 | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) {
  i1 = HEAPU8[i11 >> 0] | 0;
  i13 = 64;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) {
  i1 = 0;
  i13 = 64;
 } else {
  i2 = -1;
  i1 = 0;
 }
 do if ((i13 | 0) == 64) {
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i3 = HEAPU8[i11 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i3 = i1; else {
   i2 = -1;
   i1 = 0;
   break;
  }
  i4 = i3 << 8 | i1;
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i1 = HEAPU8[i11 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i1 = i3; else {
   i2 = -1;
   i1 = 0;
   break;
  }
  i3 = (i1 << 16) + i4 | 0;
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i1 = HEAPU8[i11 >> 0] | 0; else if (mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0) {
   i2 = -1;
   i1 = 0;
   break;
  }
  i1 = i3 + (i1 << 24) | 0;
 } while (0);
 HEAP32[i7 >> 2] = i1;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i15 + 68 | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) {
  i1 = HEAPU8[i11 >> 0] | 0;
  i13 = 77;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) {
  i1 = 0;
  i13 = 77;
 } else {
  i2 = -1;
  i1 = 0;
 }
 do if ((i13 | 0) == 77) {
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i3 = HEAPU8[i11 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i3 = i1; else {
   i2 = -1;
   i1 = 0;
   break;
  }
  i4 = i3 << 8 | i1;
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i1 = HEAPU8[i11 >> 0] | 0; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0)) i1 = i3; else {
   i2 = -1;
   i1 = 0;
   break;
  }
  i3 = (i1 << 16) + i4 | 0;
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0, i11 | 0, 1) | 0) == 1) i1 = HEAPU8[i11 >> 0] | 0; else if (mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i5 | 0) | 0) {
   i2 = -1;
   i1 = 0;
   break;
  }
  i1 = i3 + (i1 << 24) | 0;
 } while (0);
 HEAP32[i6 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i15 + 40 | 0;
 if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0, i11 | 0, 1) | 0) == 1) {
  i1 = HEAPU8[i11 >> 0] | 0;
  i13 = 90;
 } else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0) | 0)) {
  i1 = 0;
  i13 = 90;
 } else {
  i2 = -1;
  i1 = 0;
 }
 do if ((i13 | 0) == 90) if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0, i11 | 0, 1) | 0) == 1) i1 = HEAPU8[i11 >> 0] << 8 | i1; else if (!(mftCall_iii(HEAP32[i15 + 24 >> 2] | 0, HEAP32[i14 >> 2] | 0, i3 | 0) | 0)) i1 = i1 * 257 | 0; else {
  i2 = -1;
  i1 = 0;
  break;
 } while (0);
 HEAP32[i4 >> 2] = i1;
 i1 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i6 >> 2] | 0) | 0;
 if (!((i2 | 0) == 0 & ((i2 | 0) != 0 | i9 >>> 0 >= i1 >>> 0))) {
  mftCall_iii(HEAP32[i15 + 20 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i15 + 44 >> 2] = i9 - i1;
 HEAP32[i15 + 60 >> 2] = i9;
 HEAP32[i15 + 156 >> 2] = 0;
 HEAP32[i15 + 160 >> 2] = 0;
 i1 = _malloc(180) | 0;
 _memcpy(i1 | 0, i15 | 0, 180) | 0;
 if (!i1) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i1 + 52 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = (_unzlocal_GetCurrentFileInfoInternal(i1, i1 + 72 | 0, i1 + 152 | 0, 0, 0, 0, 0, 0, 0) | 0) == 0 & 1;
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx17PxcSweepBoxConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i4 + 400 | 0;
 i16 = i4 + 384 | 0;
 i51 = i4 + 208 | 0;
 i52 = i4 + 192 | 0;
 i22 = i4 + 224 | 0;
 i19 = i4 + 96 | 0;
 i20 = i4 + 128 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i49 = HEAP32[i8 >> 2] | 0;
 i50 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i48 = HEAP32[i50 + 44 >> 2] | 0;
 i8 = HEAP32[i50 + 48 >> 2] | 0;
 HEAP32[i51 >> 2] = HEAP32[i50 + 40 >> 2];
 HEAP32[i51 + 4 >> 2] = i48;
 HEAP32[i51 + 8 >> 2] = i8;
 HEAPF32[i51 + 12 >> 2] = Math_fround(0.0);
 i8 = HEAP32[i50 + 56 >> 2] | 0;
 i48 = HEAP32[i50 + 60 >> 2] | 0;
 i47 = HEAP32[i50 + 64 >> 2] | 0;
 HEAP32[i52 >> 2] = HEAP32[i50 + 52 >> 2];
 HEAP32[i52 + 4 >> 2] = i8;
 HEAP32[i52 + 8 >> 2] = i48;
 HEAP32[i52 + 12 >> 2] = i47;
 i47 = HEAP32[i49 + 40 >> 2] | 0;
 i48 = HEAP32[i49 + 44 >> 2] | 0;
 i49 = HEAP32[i49 + 48 >> 2] | 0;
 i50 = HEAP32[i50 + 72 >> 2] | 0;
 i8 = i22 + 64 | 0;
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i22 + 80 >> 2] = 3;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i22 + 144 >> 2] = i47;
 HEAP32[i22 + 148 >> 2] = i48;
 HEAP32[i22 + 152 >> 2] = i49;
 HEAPF32[i22 + 156 >> 2] = Math_fround(0.0);
 f39 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f46 = f39 <= f46 ? f39 : f46;
 f45 = f46 <= f45 ? f46 : f45;
 HEAPF32[i22 + 16 >> 2] = Math_fround(f45 * Math_fround(.150000006));
 HEAPF32[i22 + 32 >> 2] = Math_fround(f45 * Math_fround(.0500000007));
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i21, i50, i16, i51, i52);
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i52 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i52 >> 2]);
 f25 = Math_fround(HEAPF32[i52 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i52 + 8 >> 2]);
 i52 = HEAP32[i12 >> 2] | 0;
 i51 = HEAP32[i12 + 4 >> 2] | 0;
 i50 = HEAP32[i12 + 8 >> 2] | 0;
 i49 = HEAP32[i12 + 12 >> 2] | 0;
 i5 = i6 + 16 | 0;
 i48 = HEAP32[i5 >> 2] | 0;
 i47 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i52;
 i6 = i19 + 4 | 0;
 HEAP32[i6 >> 2] = i51;
 i8 = i19 + 8 | 0;
 HEAP32[i8 >> 2] = i50;
 i9 = i19 + 12 | 0;
 HEAP32[i9 >> 2] = i49;
 HEAP32[i19 + 16 >> 2] = i48;
 HEAP32[i19 + 20 >> 2] = i47;
 HEAP32[i19 + 24 >> 2] = i5;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f29 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f38 = Math_fround(f25 - f24);
 f40 = Math_fround(f27 - f32);
 f41 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f31 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f23 * Math_fround(Math_fround(f28 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f23 * Math_fround(Math_fround(f38 * f42) - Math_fround(f28 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f23) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f23)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f28) + Math_fround(f23 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f33;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f36 + f36);
 f31 = Math_fround(f26 + f26);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f26 * f31);
 f37 = Math_fround(f39 * f34);
 f26 = Math_fround(f26 * f33);
 f40 = Math_fround(f39 * f33);
 f23 = Math_fround(f35 * f33);
 f39 = Math_fround(f39 * f31);
 f31 = Math_fround(f35 * f31);
 f34 = Math_fround(f35 * f34);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f33));
 f36 = Math_fround(f26 + f34);
 f35 = Math_fround(f40 - f31);
 f34 = Math_fround(f26 - f34);
 f26 = Math_fround(f33 - f37);
 f28 = Math_fround(f39 + f23);
 f31 = Math_fround(f40 + f31);
 f23 = Math_fround(f39 - f23);
 f33 = Math_fround(f33 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f33;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(HEAPF32[i9 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu4BoxVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, f7) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i52 = HEAP32[i3 + 4 >> 2] | 0;
 i51 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i52;
 HEAP32[i13 + 8 >> 2] = i51;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i52 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i51;
 HEAP32[i14 + 8 >> 2] = i52;
 STACKTOP = i4;
 return Math_fround(f46);
}

function _cff_parser_run(i15, i2, i18) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 16 | 0;
 i20 = i15 + 404 | 0;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i2;
 HEAP32[i15 + 8 >> 2] = i18;
 HEAP32[i15 + 12 >> 2] = i2;
 if (i2 >>> 0 >= i18 >>> 0) {
  i21 = 0;
  return i21 | 0;
 }
 i16 = i19;
 i17 = i15 + 408 | 0;
 i13 = i1 + 196 | 0;
 i14 = i15 + 412 | 0;
 i12 = i15 + 20 | 0;
 i1 = i2;
 L4 : while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  L6 : do if ((i3 & 255) > 26 & i3 << 24 >> 24 != 31) {
   i2 = HEAP32[i20 >> 2] | 0;
   if ((i2 - i16 | 0) > 380) {
    i1 = 6;
    i21 = 95;
    break L4;
   }
   HEAP32[i20 >> 2] = i2 + 4;
   HEAP32[i2 >> 2] = i1;
   switch (i3 << 24 >> 24) {
   case 30:
    {
     do {
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i18 >>> 0) {
       i1 = 0;
       i21 = 95;
       break L4;
      }
      i11 = HEAPU8[i1 >> 0] | 0;
     } while (!((i11 & 240 | 0) == 240 | (i11 & 15 | 0) == 15));
     break;
    }
   case 28:
    {
     i1 = i1 + 2 | 0;
     break L6;
    }
   case 29:
    {
     i1 = i1 + 4 | 0;
     break L6;
    }
   default:
    {
     i1 = (i3 & 255) > 246 ? i1 + 1 | 0 : i1;
     break L6;
    }
   }
  } else {
   i2 = i3 & 255;
   i11 = HEAP32[i20 >> 2] | 0;
   i4 = i11 - i16 >> 2;
   HEAP32[i11 >> 2] = i1;
   if (i3 << 24 >> 24 == 12) {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i18 >>> 0) {
     i1 = 6;
     i21 = 95;
     break L4;
    }
    i2 = HEAPU8[i1 >> 0] | 256;
    i11 = i1;
   } else i11 = i1;
   i3 = HEAP32[i17 >> 2] | i2;
   i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   L21 : do if (i2 | 0) {
    i6 = i1;
    while (1) {
     if ((HEAP32[i6 + 4 >> 2] | 0) == (i3 | 0)) break;
     i1 = i6 + 28 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break L21; else i6 = i1;
    }
    i1 = HEAP32[i14 >> 2] | 0;
    i7 = i1 + (HEAP32[i6 + 8 >> 2] | 0) | 0;
    if ((i4 | 0) == 0 & (i2 | 0) != 6) {
     i1 = 6;
     i21 = 95;
     break L4;
    }
    L27 : do switch (i2 | 0) {
    case 1:
    case 4:
    case 5:
     {
      i2 = HEAP32[i19 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP8[i2 >> 0] | 0;
      if (i3 << 24 >> 24 == 30) {
       i1 = (_cff_parse_real(i2, i1, 0, 0) | 0) >> 16;
       break L27;
      }
      i4 = i2 + 1 | 0;
      i5 = i3 & 255;
      switch (i3 << 24 >> 24) {
      case 28:
       {
        if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) {
         i1 = 0;
         break L27;
        }
        i1 = (HEAPU8[i4 >> 0] << 8 | HEAPU8[i2 + 2 >> 0]) << 16 >> 16;
        break L27;
       }
      case 29:
       {
        if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) {
         i1 = 0;
         break L27;
        }
        i1 = HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i2 + 3 >> 0] << 8 | HEAPU8[i2 + 4 >> 0];
        break L27;
       }
      default:
       {
        if ((i3 & 255) < 247) {
         i1 = i5 + -139 | 0;
         break L27;
        }
        i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
        if ((i3 & 255) < 251) {
         if (i1) {
          i1 = 0;
          break L27;
         }
         i1 = (HEAPU8[i4 >> 0] | (i5 << 8) + -63232) + 108 | 0;
         break L27;
        } else {
         if (i1) {
          i1 = 0;
          break L27;
         }
         i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
         break L27;
        }
       }
      }
     }
    case 2:
     {
      i2 = HEAP32[i19 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP8[i2 >> 0] | 0;
      if (i3 << 24 >> 24 == 30) {
       i1 = _cff_parse_real(i2, i1, 0, 0) | 0;
       break L27;
      }
      i4 = i2 + 1 | 0;
      i5 = i3 & 255;
      L51 : do switch (i3 << 24 >> 24) {
      case 28:
       {
        if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = (HEAPU8[i4 >> 0] << 8 | HEAPU8[i2 + 2 >> 0]) << 16 >> 16;
        break;
       }
      case 29:
       {
        if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
         i1 = HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i2 + 3 >> 0] << 8 | HEAPU8[i2 + 4 >> 0];
         i21 = 46;
        }
        break;
       }
      default:
       {
        if ((i3 & 255) < 247) {
         i1 = i5 + -139 | 0;
         break L51;
        }
        i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
        if ((i3 & 255) < 251) {
         if (i1) {
          i1 = 0;
          break L51;
         }
         i1 = (HEAPU8[i4 >> 0] | (i5 << 8) + -63232) + 108 | 0;
         i21 = 46;
         break L51;
        } else {
         if (i1) {
          i1 = 0;
          break L51;
         }
         i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
         i21 = 46;
         break L51;
        }
       }
      } while (0);
      if ((i21 | 0) == 46) {
       i21 = 0;
       if ((i1 | 0) > 32767) {
        i1 = 2147483647;
        break L27;
       }
      }
      i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
      break;
     }
    case 3:
     {
      i2 = HEAP32[i19 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP8[i2 >> 0] | 0;
      if (i3 << 24 >> 24 == 30) {
       i1 = _cff_parse_real(i2, i1, 3, 0) | 0;
       break L27;
      }
      i4 = i2 + 1 | 0;
      i5 = i3 & 255;
      L72 : do switch (i3 << 24 >> 24) {
      case 28:
       {
        if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) {
         i1 = 0;
         i2 = 0;
        } else {
         i1 = (HEAPU8[i4 >> 0] << 8 | HEAPU8[i2 + 2 >> 0]) << 16 >> 16;
         i21 = 62;
        }
        break;
       }
      case 29:
       {
        if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) {
         i1 = 0;
         i2 = 0;
        } else {
         i1 = HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i2 + 3 >> 0] << 8 | HEAPU8[i2 + 4 >> 0];
         i21 = 62;
        }
        break;
       }
      default:
       {
        if ((i3 & 255) < 247) {
         i1 = i5 + -139 | 0;
         i21 = 62;
         break L72;
        }
        i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
        if ((i3 & 255) < 251) {
         if (i1) {
          i1 = 0;
          i2 = 0;
          break L72;
         }
         i1 = (HEAPU8[i4 >> 0] | (i5 << 8) + -63232) + 108 | 0;
         i21 = 62;
         break L72;
        } else {
         if (i1) {
          i1 = 0;
          i2 = 0;
          break L72;
         }
         i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
         i21 = 62;
         break L72;
        }
       }
      } while (0);
      if ((i21 | 0) == 62) {
       i21 = 0;
       i2 = i1 * 1e3 | 0;
       if ((i2 | 0) > 32767) {
        i1 = 2147483647;
        break L27;
       }
      }
      i1 = Math_imul(i1, 65536e3) | 0;
      i1 = (i2 | 0) < -32767 ? -2147483647 : i1;
      break;
     }
    case 6:
     {
      i2 = HEAP32[i6 + 20 >> 2] | 0;
      i2 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
      HEAP8[i1 + (HEAP32[i6 + 24 >> 2] | 0) >> 0] = i2;
      if (!i2) break L21;
      i10 = i6 + 12 | 0;
      i9 = i19;
      i8 = 0;
      while (1) {
       i3 = HEAP32[i9 >> 2] | 0;
       i9 = i9 + 4 | 0;
       i1 = HEAP32[i9 >> 2] | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L93 : do if (i4 << 24 >> 24 == 30) i1 = (_cff_parse_real(i3, i1, 0, 0) | 0) >> 16; else {
        i5 = i3 + 1 | 0;
        i6 = i4 & 255;
        switch (i4 << 24 >> 24) {
        case 28:
         {
          if ((i3 + 3 | 0) >>> 0 > i1 >>> 0) {
           i1 = 0;
           break L93;
          }
          i1 = (HEAPU8[i5 >> 0] << 8 | HEAPU8[i3 + 2 >> 0]) << 16 >> 16;
          break L93;
         }
        case 29:
         {
          if ((i3 + 5 | 0) >>> 0 > i1 >>> 0) {
           i1 = 0;
           break L93;
          }
          i1 = HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i5 >> 0] << 24 | HEAPU8[i3 + 3 >> 0] << 8 | HEAPU8[i3 + 4 >> 0];
          break L93;
         }
        default:
         {
          if ((i4 & 255) < 247) {
           i1 = i6 + -139 | 0;
           break L93;
          }
          i1 = (i3 + 2 | 0) >>> 0 > i1 >>> 0;
          if ((i4 & 255) < 251) {
           if (i1) {
            i1 = 0;
            break L93;
           }
           i1 = (HEAPU8[i5 >> 0] | (i6 << 8) + -63232) + 108 | 0;
           break L93;
          } else {
           if (i1) {
            i1 = 0;
            break L93;
           }
           i1 = (251 - i6 << 8) + -108 - (HEAPU8[i5 >> 0] | 0) | 0;
           break L93;
          }
         }
        }
       } while (0);
       i8 = i1 + i8 | 0;
       i1 = HEAP8[i10 >> 0] | 0;
       switch (i1 << 24 >> 24) {
       case 1:
        {
         HEAP8[i7 >> 0] = i8;
         i1 = HEAP8[i10 >> 0] | 0;
         break;
        }
       case 2:
        {
         HEAP16[i7 >> 1] = i8;
         i1 = 2;
         break;
        }
       case 4:
        {
         HEAP32[i7 >> 2] = i8;
         i1 = 4;
         break;
        }
       default:
        HEAP32[i7 >> 2] = i8;
       }
       i2 = i2 + -1 | 0;
       if (!i2) break L21; else i7 = i7 + (i1 & 255) | 0;
      }
     }
    default:
     {
      i1 = mftCall_ii(HEAP32[i6 + 16 >> 2] | 0, i15 | 0) | 0;
      if (!i1) break L21; else {
       i21 = 95;
       break L4;
      }
     }
    } while (0);
    switch (HEAP8[i6 + 12 >> 0] | 0) {
    case 1:
     {
      HEAP8[i7 >> 0] = i1;
      break L21;
     }
    case 2:
     {
      HEAP16[i7 >> 1] = i1;
      break L21;
     }
    case 4:
     {
      HEAP32[i7 >> 2] = i1;
      break L21;
     }
    default:
     {
      HEAP32[i7 >> 2] = i1;
      break L21;
     }
    }
   } while (0);
   HEAP32[i20 >> 2] = i19;
   i1 = i11;
  } while (0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i18 >>> 0) {
   i1 = 0;
   i21 = 95;
   break;
  }
 }
 if ((i21 | 0) == 95) return i1 | 0;
 return 0;
}

function __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii(i1, i13, i14, i15, i16, i12, i8) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17;
 i10 = i1 + 72 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = (i13 | 0) > 0;
 if ((i2 & 1 | 0) == 0 & i7) if ((i16 | 0) > 0) {
  i3 = 0;
  do {
   i5 = Math_imul(i3, i16) | 0;
   f4 = Math_fround(HEAPF32[i15 + (i5 + i12 << 2) >> 2]);
   i1 = f4 != Math_fround(0.0);
   f4 = Math_fround(Math_fround(1.0) / f4);
   f4 = i1 ? f4 : Math_fround(0.0);
   i1 = 0;
   do {
    i6 = i15 + (i1 + i5 << 2) | 0;
    if ((i1 | 0) != (i12 | 0)) HEAPF32[i6 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i16 | 0));
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i13 | 0));
  i3 = 8;
 } else {
  i9 = 0;
  i1 = 0;
 } else i3 = 8;
 if ((i3 | 0) == 8) {
  i1 = (i16 | 0) > 0;
  if (i1) {
   i6 = (i2 & 2 | 0) != 0;
   i3 = 0;
   i5 = 0;
   do {
    if ((i5 | 0) != (i12 | 0) | i6) {
     HEAP16[i11 + (i3 << 1) >> 1] = i5;
     i3 = i3 + 1 | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i16 | 0));
   i9 = i3;
  } else {
   i9 = 0;
   i1 = 0;
  }
 }
 switch (i8 | 0) {
 case 0:
  {
   if (i7 & i1) i2 = 0; else {
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i12 = i1 + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i12 << 2) >> 2]);
     i10 = f4 < Math_fround(0.0);
     i11 = f4 > Math_fround(1.0);
     i11 = ~~(+Math_fround((i11 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + .5) & 255;
     HEAP8[i14 + i12 >> 0] = i10 ? 0 : i11;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i16 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 1:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   if ((i9 | 0) > 0) i2 = 0; else {
    i1 = 0;
    while (1) {
     if (!(i2 & 2)) {
      i11 = (Math_imul(i1, i16) | 0) + i12 | 0;
      f4 = Math_fround(HEAPF32[i15 + (i11 << 2) >> 2]);
      i8 = f4 < Math_fround(0.0);
      i9 = f4 > Math_fround(1.0);
      i9 = ~~(+Math_fround((i9 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + .5) & 255;
      HEAP8[i14 + i11 >> 0] = i8 ? 0 : i9;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i13 | 0)) break;
     i2 = HEAP32[i10 >> 2] | 0;
    }
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i8 = (HEAPU16[i11 + (i1 << 1) >> 1] | 0) + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i8 << 2) >> 2]);
     i6 = f4 > Math_fround(.000122070313);
     f4 = i6 ? f4 : Math_fround(.000122070313);
     i6 = f4 > Math_fround(.99999994);
     f4 = i6 ? Math_fround(.99999994) : f4;
     i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
     i7 = HEAP32[gb + 71904 + ((i6 + -956301312 | 0) >>> 20 << 2) >> 2] | 0;
     HEAP8[i14 + i8 >> 0] = ((Math_imul(i6 >>> 12 & 255, i7 & 65535) | 0) + (i7 >>> 16 << 9) | 0) >>> 16;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
    if (!(HEAP32[i10 >> 2] & 2)) {
     i8 = i3 + i12 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i8 << 2) >> 2]);
     i6 = f4 < Math_fround(0.0);
     i7 = f4 > Math_fround(1.0);
     i7 = ~~(+Math_fround((i7 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + .5) & 255;
     HEAP8[i14 + i8 >> 0] = i6 ? 0 : i7;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 2:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   if (i1) i2 = 0; else {
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i12 = i1 + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i12 << 2) >> 2]);
     i10 = f4 < Math_fround(0.0);
     i11 = f4 > Math_fround(1.0);
     i11 = ~~(+Math_fround((i11 ? Math_fround(1.0) : f4) * Math_fround(65535.0)) + .5) & 65535;
     HEAP16[i14 + (i12 << 1) >> 1] = i10 ? 0 : i11;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i16 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 3:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   i6 = (i2 & 2 | 0) == 0;
   if ((i9 | 0) > 0) i2 = 0; else {
    i1 = 0;
    do {
     if (i6) {
      i11 = (Math_imul(i1, i16) | 0) + i12 | 0;
      f4 = Math_fround(HEAPF32[i15 + (i11 << 2) >> 2]);
      i9 = f4 < Math_fround(0.0);
      i10 = f4 > Math_fround(1.0);
      i10 = ~~(+Math_fround((i10 ? Math_fround(1.0) : f4) * Math_fround(65535.0)) + .5) & 65535;
      HEAP16[i14 + (i11 << 1) >> 1] = i9 ? 0 : i10;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i13 | 0));
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i5 = (HEAPU16[i11 + (i1 << 1) >> 1] | 0) + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i5 << 2) >> 2]);
     i10 = f4 < Math_fround(0.0);
     i8 = f4 > Math_fround(1.0);
     f4 = i8 ? Math_fround(1.0) : f4;
     f4 = i10 ? Math_fround(0.0) : f4;
     if (!(f4 <= Math_fround(.00313080009))) f4 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666657)) * Math_fround(1.05499995)) + Math_fround(-.0549999997)); else f4 = Math_fround(f4 * Math_fround(12.9200001));
     HEAP16[i14 + (i5 << 1) >> 1] = ~~(+Math_fround(f4 * Math_fround(65535.0)) + .5);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
    if (i6) {
     i10 = i3 + i12 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i10 << 2) >> 2]);
     i7 = f4 < Math_fround(0.0);
     i8 = f4 > Math_fround(1.0);
     i8 = ~~(+Math_fround((i8 ? Math_fround(1.0) : f4) * Math_fround(65535.0)) + .5) & 65535;
     HEAP16[i14 + (i10 << 1) >> 1] = i7 ? 0 : i8;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 4:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   if (i1) i2 = 0; else {
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i12 = i1 + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i12 << 2) >> 2]);
     i10 = f4 < Math_fround(0.0);
     i11 = f4 > Math_fround(1.0);
     i11 = ~~(+(i11 ? Math_fround(1.0) : f4) * 4294967295.0 + .5) >>> 0;
     HEAP32[i14 + (i12 << 2) >> 2] = i10 ? 0 : i11;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i16 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 5:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   if ((i9 | 0) > 0) i2 = 0; else {
    i1 = 0;
    while (1) {
     if (!(i2 & 2)) {
      i11 = (Math_imul(i1, i16) | 0) + i12 | 0;
      f4 = Math_fround(HEAPF32[i15 + (i11 << 2) >> 2]);
      i8 = f4 < Math_fround(0.0);
      i9 = f4 > Math_fround(1.0);
      i9 = ~~(+(i9 ? Math_fround(1.0) : f4) * 4294967295.0 + .5);
      HEAP32[i14 + (i11 << 2) >> 2] = i8 ? 0 : i9;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i13 | 0)) break;
     i2 = HEAP32[i10 >> 2] | 0;
    }
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i5 = (HEAPU16[i11 + (i1 << 1) >> 1] | 0) + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i5 << 2) >> 2]);
     i8 = f4 < Math_fround(0.0);
     i7 = f4 > Math_fround(1.0);
     f4 = i7 ? Math_fround(1.0) : f4;
     f4 = i8 ? Math_fround(0.0) : f4;
     if (!(f4 <= Math_fround(.00313080009))) f4 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666657)) * Math_fround(1.05499995)) + Math_fround(-.0549999997)); else f4 = Math_fround(f4 * Math_fround(12.9200001));
     HEAP32[i14 + (i5 << 2) >> 2] = ~~(+f4 * 4294967295.0 + .5) >>> 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
    if (!(HEAP32[i10 >> 2] & 2)) {
     i8 = i3 + i12 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i8 << 2) >> 2]);
     i6 = f4 < Math_fround(0.0);
     i7 = f4 > Math_fround(1.0);
     i7 = ~~(+(i7 ? Math_fround(1.0) : f4) * 4294967295.0 + .5);
     HEAP32[i14 + (i8 << 2) >> 2] = i6 ? 0 : i7;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 6:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   if (i1) i2 = 0; else {
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i12 = i1 + i3 | 0;
     HEAP32[i14 + (i12 << 2) >> 2] = HEAP32[i15 + (i12 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i16 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 case 7:
  {
   if (!i7) {
    STACKTOP = i17;
    return;
   }
   i6 = (i2 & 2 | 0) == 0;
   if ((i9 | 0) > 0) i2 = 0; else {
    i1 = 0;
    do {
     if (i6) {
      i11 = (Math_imul(i1, i16) | 0) + i12 | 0;
      HEAP32[i14 + (i11 << 2) >> 2] = HEAP32[i15 + (i11 << 2) >> 2];
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i13 | 0));
    STACKTOP = i17;
    return;
   }
   do {
    i3 = Math_imul(i2, i16) | 0;
    i1 = 0;
    do {
     i5 = (HEAPU16[i11 + (i1 << 1) >> 1] | 0) + i3 | 0;
     f4 = Math_fround(HEAPF32[i15 + (i5 << 2) >> 2]);
     if (!(f4 <= Math_fround(.00313080009))) f4 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666657)) * Math_fround(1.05499995)) + Math_fround(-.0549999997)); else f4 = Math_fround(f4 * Math_fround(12.9200001));
     HEAPF32[i14 + (i5 << 2) >> 2] = f4;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
    if (i6) {
     i10 = i3 + i12 | 0;
     HEAP32[i14 + (i10 << 2) >> 2] = HEAP32[i15 + (i10 << 2) >> 2];
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i13 | 0));
   STACKTOP = i17;
   return;
  }
 default:
  {
   STACKTOP = i17;
   return;
  }
 }
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i15, i1, i13, i11, i12, i16) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1168 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 1144 | 0;
 i4 = i14 + 16 | 0;
 i3 = i14;
 i8 = i14 + 568 | 0;
 i10 = i14 + 24 | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832239 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i9, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break;
   i6 = mftCall_iiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 40 >> 2] | 0, i16 | 0, i1 | 0, i2 | 0) | 0;
   if (!i6) {
    i16 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i3 >> 2] = gb + 833471;
    i13 = i3 + 8 | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i16, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i3);
    break;
   }
   do if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832272 | 0, i8 | 0) | 0) {
    i1 = HEAP32[i8 >> 2] | 0;
    HEAP32[i9 >> 2] = i1;
    if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
     i5 = _strtoul(i1, i9, 10) | 0;
     if (!i5) break;
     if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832282 | 0, i8 | 0) | 0) {
      i1 = HEAP32[i8 >> 2] | 0;
      HEAP32[i9 >> 2] = i1;
      if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i9, 10) | 0;
     } else i1 = 0;
     i7 = __ZN5physx22PxVehicleWheelsSimData8allocateEj(i5) | 0;
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 44 >> 2] | 0, i13 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, gb + 833671 | 0) | 0) {
      HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i9, i13, i7, i11, i16) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0);
     HEAPF32[i8 + 80 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 84 >> 2] = Math_fround(500.0);
     HEAPF32[i8 + 88 >> 2] = Math_fround(600.0);
     HEAPF32[i8 + 92 >> 2] = Math_fround(.150000006);
     HEAPF32[i8 + 96 >> 2] = Math_fround(2.0);
     HEAPF32[i8 + 100 >> 2] = Math_fround(.349999994);
     HEAPF32[i8 >> 2] = Math_fround(0.0);
     HEAPF32[i8 + 4 >> 2] = Math_fround(.800000011);
     HEAPF32[i8 + 8 >> 2] = Math_fround(.330000013);
     HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 16 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 20 >> 2] = Math_fround(.800000011);
     HEAP32[i8 + 64 >> 2] = 3;
     HEAPF32[i8 + 104 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 108 >> 2] = Math_fround(.00166666671);
     HEAPF32[i8 + 240 >> 2] = Math_fround(4.0);
     HEAP32[i8 + 244 >> 2] = 7;
     HEAPF32[i8 + 248 >> 2] = Math_fround(.5);
     HEAPF32[i8 + 112 >> 2] = Math_fround(-4.0);
     HEAPF32[i8 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i8 + 120 >> 2] = Math_fround(4.0);
     HEAPF32[i8 + 124 >> 2] = Math_fround(2.0);
     HEAPF32[i8 + 128 >> 2] = Math_fround(1.5);
     HEAPF32[i8 + 132 >> 2] = Math_fround(1.10000002);
     HEAPF32[i8 + 136 >> 2] = Math_fround(1.0);
     i2 = i8 + 140 | 0;
     i3 = i2 + 100 | 0;
     do {
      HEAP32[i2 >> 2] = 0;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) < (i3 | 0));
     HEAPF32[i8 + 256 >> 2] = Math_fround(10.0);
     HEAP32[i8 + 260 >> 2] = 1;
     HEAP32[i8 + 264 >> 2] = 5;
     i2 = 0;
     do {
      HEAPF32[i8 + 272 + (i2 << 2) >> 2] = Math_fround(.649999976);
      HEAPF32[i8 + 400 + (i2 << 2) >> 2] = Math_fround(.5);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 32);
     HEAPF32[i8 + 276 >> 2] = Math_fround(.150000006);
     HEAPF32[i8 + 400 >> 2] = Math_fround(2.0);
     HEAPF32[i8 + 528 >> 2] = Math_fround(.449999988);
     HEAPF32[i8 + 532 >> 2] = Math_fround(.5);
     HEAPF32[i8 + 536 >> 2] = Math_fround(.5);
     HEAPF32[i8 + 540 >> 2] = Math_fround(1.29999995);
     HEAPF32[i8 + 544 >> 2] = Math_fround(1.29999995);
     HEAPF32[i8 + 548 >> 2] = Math_fround(1.29999995);
     HEAP32[i8 + 552 >> 2] = 0;
     HEAPF32[i8 + 560 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 564 >> 2] = Math_fround(0.0);
     HEAPF32[i8 + 568 >> 2] = Math_fround(0.0);
     HEAPF32[i8 + 572 >> 2] = Math_fround(0.0);
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 44 >> 2] | 0, i13 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, gb + 834565 | 0) | 0) {
      HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i9, i13, i8, i11, i16) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0);
     HEAPF32[i10 + 80 >> 2] = Math_fround(1.0);
     HEAPF32[i10 + 84 >> 2] = Math_fround(500.0);
     HEAPF32[i10 + 88 >> 2] = Math_fround(600.0);
     HEAPF32[i10 + 92 >> 2] = Math_fround(.150000006);
     HEAPF32[i10 + 96 >> 2] = Math_fround(2.0);
     HEAPF32[i10 + 100 >> 2] = Math_fround(.349999994);
     HEAPF32[i10 >> 2] = Math_fround(0.0);
     HEAPF32[i10 + 4 >> 2] = Math_fround(.800000011);
     HEAPF32[i10 + 8 >> 2] = Math_fround(.330000013);
     HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i10 + 16 >> 2] = Math_fround(1.0);
     HEAPF32[i10 + 20 >> 2] = Math_fround(.800000011);
     HEAP32[i10 + 64 >> 2] = 3;
     HEAPF32[i10 + 104 >> 2] = Math_fround(1.0);
     HEAPF32[i10 + 108 >> 2] = Math_fround(.00166666671);
     HEAPF32[i10 + 240 >> 2] = Math_fround(4.0);
     HEAP32[i10 + 244 >> 2] = 7;
     HEAPF32[i10 + 248 >> 2] = Math_fround(.5);
     HEAPF32[i10 + 112 >> 2] = Math_fround(-4.0);
     HEAPF32[i10 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i10 + 120 >> 2] = Math_fround(4.0);
     HEAPF32[i10 + 124 >> 2] = Math_fround(2.0);
     HEAPF32[i10 + 128 >> 2] = Math_fround(1.5);
     HEAPF32[i10 + 132 >> 2] = Math_fround(1.10000002);
     HEAPF32[i10 + 136 >> 2] = Math_fround(1.0);
     i2 = i10 + 140 | 0;
     i3 = i2 + 100 | 0;
     do {
      HEAP32[i2 >> 2] = 0;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) < (i3 | 0));
     HEAPF32[i10 + 256 >> 2] = Math_fround(10.0);
     HEAP32[i10 + 260 >> 2] = 1;
     HEAP32[i10 + 264 >> 2] = 5;
     i2 = 0;
     do {
      HEAPF32[i10 + 272 + (i2 << 2) >> 2] = Math_fround(.649999976);
      HEAPF32[i10 + 400 + (i2 << 2) >> 2] = Math_fround(.5);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 32);
     HEAPF32[i10 + 276 >> 2] = Math_fround(.150000006);
     HEAPF32[i10 + 400 >> 2] = Math_fround(2.0);
     HEAP32[i10 + 528 >> 2] = 0;
     HEAP32[i10 + 532 >> 2] = 0;
     HEAPF32[i10 + 536 >> 2] = Math_fround(0.0);
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 44 >> 2] | 0, i13 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, gb + 833686 | 0) | 0) {
      HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i9, i13, i8, i11, i16) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0);
     i8 = HEAP32[i12 >> 2] | 0;
     i4 = (HEAP16[i6 + 4 >> 1] | 0) == 5 ? i6 : 0;
     i6 = __ZN5physx16PxVehicleDriveNW8allocateEj(i5) | 0;
     __ZN5physx16PxVehicleDriveNW5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj(i6, i8, (HEAP16[i4 + 4 >> 1] | 0) == 5 ? i4 : 0, i7, i10, i5 - i1 | 0);
     HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDriveNWEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i9, i13, i6, i11, i16) | 0;
     i4 = HEAP32[i6 + 72 >> 2] | 0;
     i5 = i7 + 36 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) {
      i3 = 0;
      do {
       i2 = HEAP32[(HEAP32[i4 + (i3 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
       if (i2) {
        mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i2 | 0, 0, 0);
        i1 = HEAP32[i5 >> 2] | 0;
       }
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     __ZN5physx22PxVehicleWheelsSimData4freeEv(i7);
     HEAP32[i15 >> 2] = gb + 834943;
     HEAP32[i15 + 4 >> 2] = i6;
     i16 = i15 + 8 | 0;
     HEAP32[i16 >> 2] = i6;
     HEAP32[i16 + 4 >> 2] = 0;
     STACKTOP = i14;
     return;
    }
   } while (0);
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 833484 | 0, 88, gb + 833575 | 0, i4);
   HEAP32[i15 >> 2] = gb + 1576256;
   HEAP32[i15 + 4 >> 2] = 0;
   i16 = i15 + 8 | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   STACKTOP = i14;
   return;
  }
 } while (0);
 HEAP32[i15 >> 2] = gb + 1576256;
 HEAP32[i15 + 4 >> 2] = 0;
 i16 = i15 + 8 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN28BucketPrunerOverlapTraversalI24BucketPrunerAABBAABBTestLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i1, i26, i28, i27, i16) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 4 | 0;
 i15 = i29;
 i9 = i26 + 28 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i10 = i28 + 12 | 0;
  i11 = i28 + 4 | 0;
  i12 = i28 + 16 | 0;
  i13 = i28 + 8 | 0;
  i14 = i28 + 20 | 0;
  i8 = 0;
  while (1) {
   f5 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) >> 2]);
   f33 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) + 12 >> 2]);
   f2 = Math_fround(f5 + f33);
   f6 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) + 4 >> 2]);
   f32 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) + 16 >> 2]);
   f3 = Math_fround(f6 + f32);
   f7 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) + 8 >> 2]);
   f31 = Math_fround(HEAPF32[i26 + 160 + (i8 * 24 | 0) + 20 >> 2]);
   f2 = Math_fround(f2 * Math_fround(.5));
   f3 = Math_fround(f3 * Math_fround(.5));
   f4 = Math_fround(Math_fround(f7 + f31) * Math_fround(.5));
   f5 = Math_fround(Math_fround(f33 - f5) * Math_fround(.5));
   f6 = Math_fround(Math_fround(f32 - f6) * Math_fround(.5));
   f7 = Math_fround(Math_fround(f31 - f7) * Math_fround(.5));
   f31 = Math_fround(f2 + f5);
   if (!(Math_fround(HEAPF32[i28 >> 2]) > f31)) {
    f32 = Math_fround(f4 + f7);
    f34 = Math_fround(f3 + f6);
    f33 = Math_fround(f4 - f7);
    f31 = Math_fround(f3 - f6);
    f7 = Math_fround(f2 - f5);
    i24 = f7 > Math_fround(HEAPF32[i10 >> 2]);
    i24 = i24 | Math_fround(HEAPF32[i11 >> 2]) > f34;
    i24 = i24 | f31 > Math_fround(HEAPF32[i12 >> 2]);
    i24 = (i24 | Math_fround(HEAPF32[i13 >> 2]) > f32) ^ 1;
    if (!(f33 > Math_fround(HEAPF32[i14 >> 2])) & i24) {
     HEAPF32[i15 >> 2] = Math_fround(-1.0);
     if (!(mftCall_iiiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i15 | 0, i26 + 32 + (i8 << 3) | 0, 1) | 0)) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[i9 >> 2] | 0;
    }
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i1 >>> 0) break L1;
  }
  STACKTOP = i29;
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i26 + 584 >> 2] | 0)) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 f2 = Math_fround(HEAPF32[i26 + 608 >> 2]);
 f3 = Math_fround(HEAPF32[i26 + 624 >> 2]);
 f32 = Math_fround(HEAPF32[i26 + 612 >> 2]);
 f4 = Math_fround(HEAPF32[i26 + 628 >> 2]);
 f5 = Math_fround(f32 - f4);
 f33 = Math_fround(HEAPF32[i26 + 616 >> 2]);
 f6 = Math_fround(HEAPF32[i26 + 632 >> 2]);
 f7 = Math_fround(f33 - f6);
 f34 = Math_fround(f2 + f3);
 f4 = Math_fround(f32 + f4);
 f6 = Math_fround(f33 + f6);
 if (Math_fround(HEAPF32[i28 >> 2]) > f34) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 f34 = Math_fround(f2 - f3);
 i23 = i28 + 12 | 0;
 if (f34 > Math_fround(HEAPF32[i23 >> 2])) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 i24 = i28 + 4 | 0;
 if (Math_fround(HEAPF32[i24 >> 2]) > f4) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 i22 = i28 + 16 | 0;
 if (f5 > Math_fround(HEAPF32[i22 >> 2])) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 i21 = i28 + 8 | 0;
 if (Math_fround(HEAPF32[i21 >> 2]) > f6) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 i20 = i28 + 20 | 0;
 if (f7 > Math_fround(HEAPF32[i20 >> 2])) {
  i30 = 1;
  STACKTOP = i29;
  return i30 | 0;
 }
 i15 = HEAP32[i26 + 592 >> 2] | 0;
 i17 = HEAP32[i16 + (i15 << 2) >> 2] | 0;
 i15 = HEAP32[i16 + 12 + (i15 << 2) >> 2] | 0;
 i16 = (i17 | 0) < 0 ? ~i17 : i17 | -2147483648;
 i15 = (i15 | 0) < 0 ? ~i15 : i15 | -2147483648;
 i17 = i26 + 20 | 0;
 i18 = i26 + 24 | 0;
 i19 = 0;
 L33 : while (1) {
  if (HEAP32[i26 + 640 + (i19 << 2) >> 2] | 0) {
   f2 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) >> 2]);
   f3 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) + 16 >> 2]);
   f4 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) + 20 >> 2]);
   f6 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i26 + 688 + (i19 << 5) + 24 >> 2]);
   f34 = Math_fround(f2 + f3);
   if (!(Math_fround(HEAPF32[i28 >> 2]) > f34)) {
    f33 = Math_fround(f6 + f7);
    f31 = Math_fround(f4 + f5);
    f34 = Math_fround(f6 - f7);
    f32 = Math_fround(f4 - f5);
    f7 = Math_fround(f2 - f3);
    i14 = f7 > Math_fround(HEAPF32[i23 >> 2]);
    i14 = i14 | Math_fround(HEAPF32[i24 >> 2]) > f31;
    i14 = i14 | f32 > Math_fround(HEAPF32[i22 >> 2]);
    i14 = (i14 | Math_fround(HEAPF32[i21 >> 2]) > f33) ^ 1;
    if (!(f34 > Math_fround(HEAPF32[i20 >> 2])) & i14) {
     i13 = i26 + 660 + (i19 << 2) | 0;
     i14 = 0;
     do {
      if (HEAP32[i26 + 864 + (i19 * 224 | 0) + (i14 << 2) >> 2] | 0) {
       f2 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) >> 2]);
       f3 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) + 16 >> 2]);
       f4 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) + 4 >> 2]);
       f5 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) + 20 >> 2]);
       f6 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) + 8 >> 2]);
       f7 = Math_fround(HEAPF32[i26 + 864 + (i19 * 224 | 0) + 48 + (i14 << 5) + 24 >> 2]);
       f34 = Math_fround(f2 + f3);
       if (!(Math_fround(HEAPF32[i28 >> 2]) > f34)) {
        f33 = Math_fround(f6 + f7);
        f31 = Math_fround(f4 + f5);
        f34 = Math_fround(f6 - f7);
        f32 = Math_fround(f4 - f5);
        f7 = Math_fround(f2 - f3);
        i12 = f7 > Math_fround(HEAPF32[i23 >> 2]);
        i12 = i12 | Math_fround(HEAPF32[i24 >> 2]) > f31;
        i12 = i12 | f32 > Math_fround(HEAPF32[i22 >> 2]);
        i12 = (i12 | Math_fround(HEAPF32[i21 >> 2]) > f33) ^ 1;
        if (!(f34 > Math_fround(HEAPF32[i20 >> 2])) & i12) {
         i11 = i26 + 864 + (i19 * 224 | 0) + 20 + (i14 << 2) | 0;
         i12 = 0;
         do {
          i1 = HEAP32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + (i12 << 2) >> 2] | 0;
          do if (i1 | 0) {
           f2 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) >> 2]);
           f3 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) + 16 >> 2]);
           f4 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) + 4 >> 2]);
           f5 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) + 20 >> 2]);
           f6 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) + 8 >> 2]);
           f7 = Math_fround(HEAPF32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 48 + (i12 << 5) + 24 >> 2]);
           f34 = Math_fround(f2 + f3);
           if (Math_fround(HEAPF32[i28 >> 2]) > f34) break;
           f33 = Math_fround(f6 + f7);
           f31 = Math_fround(f4 + f5);
           f34 = Math_fround(f6 - f7);
           f32 = Math_fround(f4 - f5);
           f7 = Math_fround(f2 - f3);
           i10 = f7 > Math_fround(HEAPF32[i23 >> 2]);
           i10 = i10 | Math_fround(HEAPF32[i24 >> 2]) > f31;
           i10 = i10 | f32 > Math_fround(HEAPF32[i22 >> 2]);
           i10 = (i10 | Math_fround(HEAPF32[i21 >> 2]) > f33) ^ 1;
           if (!(!(f34 > Math_fround(HEAPF32[i20 >> 2])) & i10)) break;
           i10 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) + (HEAP32[i26 + 1984 + (i19 * 1120 | 0) + (i14 * 224 | 0) + 20 + (i12 << 2) >> 2] | 0) | 0;
           i9 = (HEAP32[i17 >> 2] | 0) + (i10 << 5) | 0;
           i10 = (HEAP32[i18 >> 2] | 0) + (i10 << 3) | 0;
           L51 : do {
            i1 = i1 + -1 | 0;
            i8 = i9;
            i9 = i9 + 32 | 0;
            do if ((HEAP32[i8 + 28 >> 2] | 0) >>> 0 >= i16 >>> 0) {
             if ((HEAP32[i8 + 12 >> 2] | 0) >>> 0 > i15 >>> 0) break L51;
             f3 = Math_fround(HEAPF32[i8 >> 2]);
             f4 = Math_fround(HEAPF32[i8 + 16 >> 2]);
             f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
             f6 = Math_fround(HEAPF32[i8 + 20 >> 2]);
             f7 = Math_fround(HEAPF32[i8 + 8 >> 2]);
             f2 = Math_fround(HEAPF32[i8 + 24 >> 2]);
             f34 = Math_fround(f3 + f4);
             if (Math_fround(HEAPF32[i28 >> 2]) > f34) break;
             f33 = Math_fround(f7 + f2);
             f31 = Math_fround(f5 + f6);
             f34 = Math_fround(f7 - f2);
             f32 = Math_fround(f5 - f6);
             f7 = Math_fround(f3 - f4);
             i8 = f7 > Math_fround(HEAPF32[i23 >> 2]);
             i8 = i8 | Math_fround(HEAPF32[i24 >> 2]) > f31;
             i8 = i8 | f32 > Math_fround(HEAPF32[i22 >> 2]);
             i8 = (i8 | Math_fround(HEAPF32[i21 >> 2]) > f33) ^ 1;
             if (!(!(f34 > Math_fround(HEAPF32[i20 >> 2])) & i8)) break;
             HEAPF32[i25 >> 2] = Math_fround(-1.0);
             if (!(mftCall_iiiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i25 | 0, i10 | 0, 1) | 0)) break L33;
            } while (0);
            i10 = i10 + 8 | 0;
           } while ((i1 | 0) != 0);
          } while (0);
          i12 = i12 + 1 | 0;
         } while (i12 >>> 0 < 5);
        }
       }
      }
      i14 = i14 + 1 | 0;
     } while (i14 >>> 0 < 5);
    }
   }
  }
  i19 = i19 + 1 | 0;
  if (i19 >>> 0 >= 5) {
   i1 = 1;
   i30 = 39;
   break;
  }
 }
 if ((i30 | 0) == 39) {
  STACKTOP = i29;
  return i1 | 0;
 }
 i30 = 0;
 STACKTOP = i29;
 return i30 | 0;
}

function __ZN12AudioManager8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 28 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 867642 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855945 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855959 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 120 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855974 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898090 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855995 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 856011 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 856031 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 856048 | 0, HEAP32[gb + 37260 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 224 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 856068 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 225 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 856083 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i21 + 96 | 0;
 i18 = i21 + 92 | 0;
 i13 = i21 + 88 | 0;
 i14 = i21 + 84 | 0;
 i15 = i21 + 80 | 0;
 i16 = i21 + 76 | 0;
 i10 = i21 + 72 | 0;
 i17 = i21 + 68 | 0;
 i12 = i21 + 64 | 0;
 i9 = i21;
 i7 = i20 + 1376 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i7 = HEAP32[i1 >> 2] | 0;
 f26 = Math_fround(Math_fround(64.0) / Math_fround((HEAP32[i1 + 8 >> 2] | 0) - i7 | 0));
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 f24 = Math_fround(Math_fround(64.0) / Math_fround((HEAP32[i1 + 12 >> 2] | 0) - i6 | 0));
 f25 = Math_fround(Math_fround(i7 | 0) * Math_fround(.015625));
 f27 = Math_fround(Math_fround(i6 | 0) * Math_fround(.015625));
 i6 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i11 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i11 + 40 >> 2] = Math_fround(1.0);
 i6 = i11 + 44 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i11 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i11 >> 2] = f26;
 HEAPF32[i11 + 20 >> 2] = f24;
 HEAPF32[i11 + 12 >> 2] = Math_fround(Math_fround(f26 + Math_fround(-1.0)) - Math_fround(Math_fround(f25 * Math_fround(2.0)) * f26));
 HEAPF32[i11 + 28 >> 2] = Math_fround(Math_fround(f24 + Math_fround(-1.0)) - Math_fround(Math_fround(f27 * Math_fround(2.0)) * f24));
 HEAP32[i9 >> 2] = HEAP32[i20 >> 2];
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i20 + 4 >> 2];
 i7 = i9 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i20 + 8 >> 2];
 i8 = i9 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAP32[i20 + 32 >> 2];
 HEAP32[i9 + 36 >> 2] = HEAP32[i20 + 36 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i20 + 40 >> 2];
 HEAP32[i9 + 44 >> 2] = HEAP32[i20 + 44 >> 2];
 HEAP32[i9 + 48 >> 2] = HEAP32[i20 + 48 >> 2];
 HEAP32[i9 + 52 >> 2] = HEAP32[i20 + 52 >> 2];
 HEAP32[i9 + 56 >> 2] = HEAP32[i20 + 56 >> 2];
 HEAP32[i9 + 60 >> 2] = HEAP32[i20 + 60 >> 2];
 __ZN5Umbra9Matrix4x4mLERKS0_(i9, i11) | 0;
 f24 = Math_fround(HEAPF32[i9 + 48 >> 2]);
 f27 = Math_fround(HEAPF32[i9 + 52 >> 2]);
 f26 = Math_fround(HEAPF32[i9 + 56 >> 2]);
 f25 = Math_fround(HEAPF32[i9 + 60 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 f23 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(f27 - f3);
 f29 = Math_fround(f26 - f22);
 f30 = Math_fround(f25 - f23);
 HEAPF32[i20 + 160 >> 2] = Math_fround(f24 - f4);
 HEAPF32[i20 + 164 >> 2] = f28;
 HEAPF32[i20 + 168 >> 2] = f29;
 HEAPF32[i20 + 172 >> 2] = f30;
 f3 = Math_fround(f27 + f3);
 f22 = Math_fround(f26 + f22);
 f23 = Math_fround(f25 + f23);
 HEAPF32[i20 + 176 >> 2] = Math_fround(f24 + f4);
 HEAPF32[i20 + 180 >> 2] = f3;
 HEAPF32[i20 + 184 >> 2] = f22;
 HEAPF32[i20 + 188 >> 2] = f23;
 f23 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i9 + 28 >> 2]);
 f30 = Math_fround(f27 - f22);
 f29 = Math_fround(f26 - f3);
 f28 = Math_fround(f25 - f4);
 HEAPF32[i20 + 192 >> 2] = Math_fround(f24 - f23);
 HEAPF32[i20 + 196 >> 2] = f30;
 HEAPF32[i20 + 200 >> 2] = f29;
 HEAPF32[i20 + 204 >> 2] = f28;
 f22 = Math_fround(f27 + f22);
 f3 = Math_fround(f26 + f3);
 f4 = Math_fround(f25 + f4);
 HEAPF32[i20 + 208 >> 2] = Math_fround(f24 + f23);
 HEAPF32[i20 + 212 >> 2] = f22;
 HEAPF32[i20 + 216 >> 2] = f3;
 HEAPF32[i20 + 220 >> 2] = f4;
 if (!(HEAP8[i20 + 1224 >> 0] | 0)) if (!(HEAP8[i20 + 1364 >> 0] | 0)) i19 = 6; else {
  HEAP32[i11 >> 2] = 2139095039;
  HEAP32[i18 >> 2] = 2139095039;
  HEAP32[i13 >> 2] = 2139095039;
  HEAP32[i14 >> 2] = -8388609;
  HEAP32[i15 >> 2] = -8388609;
  HEAP32[i16 >> 2] = -8388609;
  i1 = 0;
  f3 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(3402823469999999843913219.0e14);
  do {
   i2 = i1 >> 2;
   f26 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) >> 2]);
   f24 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 4 >> 2]);
   f29 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 8 >> 2]);
   f31 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 12 >> 2]);
   i2 = i1 >>> 1 & 1 | 2;
   f33 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) >> 2]);
   f34 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 12 >> 2]);
   i2 = i1 & 1 | 4;
   f25 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) >> 2]);
   f27 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 4 >> 2]);
   f35 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 8 >> 2]);
   f32 = Math_fround(HEAPF32[i20 + 128 + (i2 << 4) + 12 >> 2]);
   f28 = Math_fround(Math_fround(f34 * f35) - Math_fround(f37 * f27));
   f36 = Math_fround(Math_fround(f37 * f25) - Math_fround(f33 * f35));
   f22 = Math_fround(Math_fround(f33 * f27) - Math_fround(f34 * f25));
   f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f29 * f22) + Math_fround(Math_fround(f26 * f28) + Math_fround(f24 * f36))));
   f28 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f24 * f37) - Math_fround(f29 * f34)) * f32) + Math_fround(Math_fround(f31 * f28) + Math_fround(f23 * Math_fround(Math_fround(f29 * f27) - Math_fround(f24 * f35))))) * f30));
   f29 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f29 * f33) - Math_fround(f26 * f37)) * f32) + Math_fround(Math_fround(f31 * f36) + Math_fround(f23 * Math_fround(Math_fround(f26 * f35) - Math_fround(f29 * f25))))) * f30));
   f30 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f26 * f34) - Math_fround(f24 * f33)) * f32) + Math_fround(Math_fround(f31 * f22) + Math_fround(f23 * Math_fround(Math_fround(f24 * f25) - Math_fround(f26 * f27))))) * f30));
   HEAPF32[i10 >> 2] = f28;
   HEAPF32[i17 >> 2] = f29;
   HEAPF32[i12 >> 2] = f30;
   i2 = HEAP32[(f3 <= f28 ? i11 : i10) >> 2] | 0;
   i5 = HEAP32[(f4 <= f29 ? i18 : i17) >> 2] | 0;
   i6 = Math_fround(HEAPF32[i13 >> 2]) <= f30;
   i6 = HEAP32[(i6 ? i13 : i12) >> 2] | 0;
   HEAP32[i11 >> 2] = i2;
   HEAP32[i18 >> 2] = i5;
   HEAP32[i13 >> 2] = i6;
   i7 = Math_fround(HEAPF32[i14 >> 2]) >= f28;
   i7 = HEAP32[(i7 ? i14 : i10) >> 2] | 0;
   i8 = Math_fround(HEAPF32[i15 >> 2]) >= f29;
   i8 = HEAP32[(i8 ? i15 : i17) >> 2] | 0;
   i9 = Math_fround(HEAPF32[i16 >> 2]) >= f30;
   i9 = HEAP32[(i9 ? i16 : i12) >> 2] | 0;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i8;
   HEAP32[i16 >> 2] = i9;
   i1 = i1 + 1 | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i1 | 0) != 8);
  HEAP32[i20 + 1316 >> 2] = i2;
  HEAP32[i20 + 1320 >> 2] = i5;
  HEAP32[i20 + 1324 >> 2] = i6;
  HEAPF32[i20 + 1328 >> 2] = Math_fround(1.0);
  HEAP32[i20 + 1332 >> 2] = i7;
  HEAP32[i20 + 1336 >> 2] = i8;
  HEAP32[i20 + 1340 >> 2] = i9;
  HEAPF32[i20 + 1344 >> 2] = Math_fround(1.0);
 } else i19 = 6;
 if ((i19 | 0) == 6) {
  HEAPF32[i20 + 1316 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i20 + 1320 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i20 + 1324 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i20 + 1328 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i20 + 1332 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i20 + 1336 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i20 + 1340 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i20 + 1344 >> 2] = Math_fround(3402823469999999843913219.0e14);
 }
 i2 = i20 + 1196 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) i1 = 0; else {
  STACKTOP = i21;
  return;
 }
 do {
  HEAP32[i20 + 1228 + (i1 << 2) >> 2] = i1;
  i19 = i20 + 128 + (i1 << 4) | 0;
  i16 = HEAP32[i19 >> 2] | 0;
  i17 = HEAP32[i19 + 4 >> 2] | 0;
  i18 = HEAP32[i19 + 8 >> 2] | 0;
  i19 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i20 + 480 + (i1 << 4) >> 2] = i16;
  HEAP32[i20 + 480 + (i1 << 4) + 4 >> 2] = i17;
  HEAP32[i20 + 480 + (i1 << 4) + 8 >> 2] = i18;
  HEAP32[i20 + 480 + (i1 << 4) + 12 >> 2] = i19;
  i16 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
  i17 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
  i18 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
  i19 = ((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) << 31 >> 31;
  HEAP32[i20 + 832 + (i1 << 4) >> 2] = i16 << 31 >> 31;
  HEAP32[i20 + 832 + (i1 << 4) + 4 >> 2] = i17 << 31 >> 31;
  HEAP32[i20 + 832 + (i1 << 4) + 8 >> 2] = i18 << 31 >> 31;
  HEAP32[i20 + 832 + (i1 << 4) + 12 >> 2] = i19;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 STACKTOP = i21;
 return;
}

function _dispose_chunk(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = i1 + i3 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 do if (!(i2 & 1)) {
  i6 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & 3)) return;
  i11 = i1 + (0 - i6) | 0;
  i10 = i6 + i3 | 0;
  i8 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
  if (i11 >>> 0 < i8 >>> 0) _abort();
  if ((i11 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   i1 = i14 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 & 3 | 0) != 3) {
    i17 = i11;
    i5 = i10;
    break;
   }
   HEAP32[gb + 1470404 + 8 >> 2] = i10;
   HEAP32[i1 >> 2] = i2 & -2;
   HEAP32[i11 + 4 >> 2] = i10 | 1;
   HEAP32[i11 + i10 >> 2] = i10;
   return;
  }
  i4 = i6 >>> 3;
  if (i6 >>> 0 < 256) {
   i2 = HEAP32[i11 + 8 >> 2] | 0;
   i3 = HEAP32[i11 + 12 >> 2] | 0;
   i1 = gb + 1470404 + 40 + (i4 << 1 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    if (i2 >>> 0 < i8 >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i11 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i4);
    i17 = i11;
    i5 = i10;
    break;
   }
   if ((i3 | 0) == (i1 | 0)) i7 = i3 + 8 | 0; else {
    if (i3 >>> 0 < i8 >>> 0) _abort();
    i1 = i3 + 8 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) i7 = i1; else _abort();
   }
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i7 >> 2] = i2;
   i17 = i11;
   i5 = i10;
   break;
  }
  i6 = HEAP32[i11 + 24 >> 2] | 0;
  i3 = HEAP32[i11 + 12 >> 2] | 0;
  do if ((i3 | 0) == (i11 | 0)) {
   i3 = i11 + 16 | 0;
   i2 = i3 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i9 = 0;
     break;
    } else i2 = i3;
   }
   while (1) {
    i3 = i1 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i1 = i4;
     i2 = i3;
     continue;
    }
    i3 = i1 + 16 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) break; else {
     i1 = i4;
     i2 = i3;
    }
   }
   if (i2 >>> 0 < i8 >>> 0) _abort(); else {
    HEAP32[i2 >> 2] = 0;
    i9 = i1;
    break;
   }
  } else {
   i4 = HEAP32[i11 + 8 >> 2] | 0;
   if (i4 >>> 0 < i8 >>> 0) _abort();
   i1 = i4 + 12 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i11 | 0)) _abort();
   i2 = i3 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i11 | 0)) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i2 >> 2] = i4;
    i9 = i3;
    break;
   } else _abort();
  } while (0);
  if (!i6) {
   i17 = i11;
   i5 = i10;
  } else {
   i1 = HEAP32[i11 + 28 >> 2] | 0;
   i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
   if ((i11 | 0) == (HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = i9;
    if (!i9) {
     HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i1);
     i17 = i11;
     i5 = i10;
     break;
    }
   } else {
    if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i1 = i6 + 16 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) HEAP32[i1 >> 2] = i9; else HEAP32[i6 + 20 >> 2] = i9;
    if (!i9) {
     i17 = i11;
     i5 = i10;
     break;
    }
   }
   i3 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if (i9 >>> 0 < i3 >>> 0) _abort();
   HEAP32[i9 + 24 >> 2] = i6;
   i1 = i11 + 16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2 | 0) if (i2 >>> 0 < i3 >>> 0) _abort(); else {
    HEAP32[i9 + 16 >> 2] = i2;
    HEAP32[i2 + 24 >> 2] = i9;
    break;
   } while (0);
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i17 = i11;
    i5 = i10;
   } else if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
    HEAP32[i9 + 20 >> 2] = i1;
    HEAP32[i1 + 24 >> 2] = i9;
    i17 = i11;
    i5 = i10;
    break;
   }
  }
 } else {
  i17 = i1;
  i5 = i3;
 } while (0);
 i7 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
 if (i14 >>> 0 < i7 >>> 0) _abort();
 i1 = i14 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 2)) {
  if ((i14 | 0) == (HEAP32[gb + 1470404 + 24 >> 2] | 0)) {
   i16 = (HEAP32[gb + 1470404 + 12 >> 2] | 0) + i5 | 0;
   HEAP32[gb + 1470404 + 12 >> 2] = i16;
   HEAP32[gb + 1470404 + 24 >> 2] = i17;
   HEAP32[i17 + 4 >> 2] = i16 | 1;
   if ((i17 | 0) != (HEAP32[gb + 1470404 + 20 >> 2] | 0)) return;
   HEAP32[gb + 1470404 + 20 >> 2] = 0;
   HEAP32[gb + 1470404 + 8 >> 2] = 0;
   return;
  }
  if ((i14 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   i16 = (HEAP32[gb + 1470404 + 8 >> 2] | 0) + i5 | 0;
   HEAP32[gb + 1470404 + 8 >> 2] = i16;
   HEAP32[gb + 1470404 + 20 >> 2] = i17;
   HEAP32[i17 + 4 >> 2] = i16 | 1;
   HEAP32[i17 + i16 >> 2] = i16;
   return;
  }
  i5 = (i2 & -8) + i5 | 0;
  i4 = i2 >>> 3;
  do if (i2 >>> 0 < 256) {
   i2 = HEAP32[i14 + 8 >> 2] | 0;
   i3 = HEAP32[i14 + 12 >> 2] | 0;
   i1 = gb + 1470404 + 40 + (i4 << 1 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    if (i2 >>> 0 < i7 >>> 0) _abort();
    if ((HEAP32[i2 + 12 >> 2] | 0) != (i14 | 0)) _abort();
   }
   if ((i3 | 0) == (i2 | 0)) {
    HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i4);
    break;
   }
   if ((i3 | 0) == (i1 | 0)) i12 = i3 + 8 | 0; else {
    if (i3 >>> 0 < i7 >>> 0) _abort();
    i1 = i3 + 8 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i14 | 0)) i12 = i1; else _abort();
   }
   HEAP32[i2 + 12 >> 2] = i3;
   HEAP32[i12 >> 2] = i2;
  } else {
   i6 = HEAP32[i14 + 24 >> 2] | 0;
   i3 = HEAP32[i14 + 12 >> 2] | 0;
   do if ((i3 | 0) == (i14 | 0)) {
    i3 = i14 + 16 | 0;
    i2 = i3 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i1 = HEAP32[i3 >> 2] | 0;
     if (!i1) {
      i13 = 0;
      break;
     } else i2 = i3;
    }
    while (1) {
     i3 = i1 + 20 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (i4 | 0) {
      i1 = i4;
      i2 = i3;
      continue;
     }
     i3 = i1 + 16 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else {
      i1 = i4;
      i2 = i3;
     }
    }
    if (i2 >>> 0 < i7 >>> 0) _abort(); else {
     HEAP32[i2 >> 2] = 0;
     i13 = i1;
     break;
    }
   } else {
    i4 = HEAP32[i14 + 8 >> 2] | 0;
    if (i4 >>> 0 < i7 >>> 0) _abort();
    i1 = i4 + 12 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (i14 | 0)) _abort();
    i2 = i3 + 8 | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i14 | 0)) {
     HEAP32[i1 >> 2] = i3;
     HEAP32[i2 >> 2] = i4;
     i13 = i3;
     break;
    } else _abort();
   } while (0);
   if (i6 | 0) {
    i1 = HEAP32[i14 + 28 >> 2] | 0;
    i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
    if ((i14 | 0) == (HEAP32[i2 >> 2] | 0)) {
     HEAP32[i2 >> 2] = i13;
     if (!i13) {
      HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i1);
      break;
     }
    } else {
     if (i6 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
     i1 = i6 + 16 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i14 | 0)) HEAP32[i1 >> 2] = i13; else HEAP32[i6 + 20 >> 2] = i13;
     if (!i13) break;
    }
    i3 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
    if (i13 >>> 0 < i3 >>> 0) _abort();
    HEAP32[i13 + 24 >> 2] = i6;
    i1 = i14 + 16 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    do if (i2 | 0) if (i2 >>> 0 < i3 >>> 0) _abort(); else {
     HEAP32[i13 + 16 >> 2] = i2;
     HEAP32[i2 + 24 >> 2] = i13;
     break;
    } while (0);
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
     HEAP32[i13 + 20 >> 2] = i1;
     HEAP32[i1 + 24 >> 2] = i13;
     break;
    }
   }
  } while (0);
  HEAP32[i17 + 4 >> 2] = i5 | 1;
  HEAP32[i17 + i5 >> 2] = i5;
  if ((i17 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
   HEAP32[gb + 1470404 + 8 >> 2] = i5;
   return;
  }
 } else {
  HEAP32[i1 >> 2] = i2 & -2;
  HEAP32[i17 + 4 >> 2] = i5 | 1;
  HEAP32[i17 + i5 >> 2] = i5;
 }
 i1 = i5 >>> 3;
 if (i5 >>> 0 < 256) {
  i3 = gb + 1470404 + 40 + (i1 << 1 << 2) | 0;
  i2 = HEAP32[gb + 1470404 >> 2] | 0;
  i1 = 1 << i1;
  if (!(i2 & i1)) {
   HEAP32[gb + 1470404 >> 2] = i2 | i1;
   i15 = i3;
   i16 = i3 + 8 | 0;
  } else {
   i1 = i3 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
    i15 = i2;
    i16 = i1;
   }
  }
  HEAP32[i16 >> 2] = i17;
  HEAP32[i15 + 12 >> 2] = i17;
  HEAP32[i17 + 8 >> 2] = i15;
  HEAP32[i17 + 12 >> 2] = i3;
  return;
 }
 i1 = i5 >>> 8;
 if (!i1) i1 = 0; else if (i5 >>> 0 > 16777215) i1 = 31; else {
  i15 = (i1 + 1048320 | 0) >>> 16 & 8;
  i16 = i1 << i15;
  i14 = (i16 + 520192 | 0) >>> 16 & 4;
  i16 = i16 << i14;
  i1 = (i16 + 245760 | 0) >>> 16 & 2;
  i1 = 14 - (i14 | i15 | i1) + (i16 << i1 >>> 15) | 0;
  i1 = i5 >>> (i1 + 7 | 0) & 1 | i1 << 1;
 }
 i4 = gb + 1470404 + 304 + (i1 << 2) | 0;
 HEAP32[i17 + 28 >> 2] = i1;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i2 = HEAP32[gb + 1470404 + 4 >> 2] | 0;
 i3 = 1 << i1;
 if (!(i2 & i3)) {
  HEAP32[gb + 1470404 + 4 >> 2] = i2 | i3;
  HEAP32[i4 >> 2] = i17;
  HEAP32[i17 + 24 >> 2] = i4;
  HEAP32[i17 + 12 >> 2] = i17;
  HEAP32[i17 + 8 >> 2] = i17;
  return;
 }
 i2 = i5 << ((i1 | 0) == 31 ? 0 : 25 - (i1 >>> 1) | 0);
 i4 = HEAP32[i4 >> 2] | 0;
 while (1) {
  if ((HEAP32[i4 + 4 >> 2] & -8 | 0) == (i5 | 0)) {
   i1 = 127;
   break;
  }
  i3 = i4 + 16 + (i2 >>> 31 << 2) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i1 = 124;
   break;
  } else {
   i2 = i2 << 1;
   i4 = i1;
  }
 }
 if ((i1 | 0) == 124) {
  if (i3 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
  HEAP32[i3 >> 2] = i17;
  HEAP32[i17 + 24 >> 2] = i4;
  HEAP32[i17 + 12 >> 2] = i17;
  HEAP32[i17 + 8 >> 2] = i17;
  return;
 } else if ((i1 | 0) == 127) {
  i1 = i4 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i16 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
  if (!(i2 >>> 0 >= i16 >>> 0 & i4 >>> 0 >= i16 >>> 0)) _abort();
  HEAP32[i2 + 12 >> 2] = i17;
  HEAP32[i1 >> 2] = i17;
  HEAP32[i17 + 8 >> 2] = i2;
  HEAP32[i17 + 12 >> 2] = i4;
  HEAP32[i17 + 24 >> 2] = 0;
  return;
 }
}

function _inflate_table(i8, i22, i9, i27, i28, i23) {
 i8 = i8 | 0;
 i22 = i22 | 0;
 i9 = i9 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i29 + 32 | 0;
 i10 = i29;
 i1 = i24;
 i2 = i1 + 32 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i7 = (i9 | 0) == 0;
 if (i7) {
  i1 = HEAP32[i28 >> 2] | 0;
  i26 = 5;
 } else {
  i1 = 0;
  do {
   i25 = i24 + (HEAPU16[i22 + (i1 << 1) >> 1] << 1) | 0;
   HEAP16[i25 >> 1] = (HEAP16[i25 >> 1] | 0) + 1 << 16 >> 16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
  i2 = HEAP16[i24 + 30 >> 1] | 0;
  i1 = HEAP32[i28 >> 2] | 0;
  if (!(i2 << 16 >> 16)) i26 = 5; else {
   i4 = 15;
   i3 = 15;
  }
 }
 if ((i26 | 0) == 5) if (!(HEAP16[i24 + 28 >> 1] | 0)) if (!(HEAP16[i24 + 26 >> 1] | 0)) if (!(HEAP16[i24 + 24 >> 1] | 0)) if (!(HEAP16[i24 + 22 >> 1] | 0)) if (!(HEAP16[i24 + 20 >> 1] | 0)) if (!(HEAP16[i24 + 18 >> 1] | 0)) if (!(HEAP16[i24 + 16 >> 1] | 0)) if (!(HEAP16[i24 + 14 >> 1] | 0)) if (!(HEAP16[i24 + 12 >> 1] | 0)) if (!(HEAP16[i24 + 10 >> 1] | 0)) if (!(HEAP16[i24 + 8 >> 1] | 0)) if (!(HEAP16[i24 + 6 >> 1] | 0)) if (!(HEAP16[i24 + 4 >> 1] | 0)) if (!(HEAP16[i24 + 2 >> 1] | 0)) {
  i26 = HEAP32[i27 >> 2] | 0;
  HEAP32[i27 >> 2] = i26 + 4;
  HEAP8[i26 >> 0] = 64;
  HEAP8[i26 + 1 >> 0] = 1;
  HEAP16[i26 + 2 >> 1] = 0;
  i26 = HEAP32[i27 >> 2] | 0;
  HEAP32[i27 >> 2] = i26 + 4;
  HEAP8[i26 >> 0] = 64;
  HEAP8[i26 + 1 >> 0] = 1;
  HEAP16[i26 + 2 >> 1] = 0;
  HEAP32[i28 >> 2] = 1;
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 } else {
  i4 = 1;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 2;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 3;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 4;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 5;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 6;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 7;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 8;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 9;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 10;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 11;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 12;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 13;
  i2 = 0;
  i3 = 16;
 } else {
  i4 = 14;
  i2 = 0;
  i3 = 16;
 }
 i1 = i1 >>> 0 > i4 >>> 0 ? i4 : i1;
 i6 = HEAP16[i24 + 2 >> 1] | 0;
 if (!(i6 << 16 >> 16)) if (!(HEAP16[i24 + 4 >> 1] | 0)) if (!(HEAP16[i24 + 6 >> 1] | 0)) if (!(HEAP16[i24 + 8 >> 1] | 0)) if (!(HEAP16[i24 + 10 >> 1] | 0)) if (!(HEAP16[i24 + 12 >> 1] | 0)) if (!(HEAP16[i24 + 14 >> 1] | 0)) if (!(HEAP16[i24 + 16 >> 1] | 0)) if (!(HEAP16[i24 + 18 >> 1] | 0)) if (!(HEAP16[i24 + 20 >> 1] | 0)) if (!(HEAP16[i24 + 22 >> 1] | 0)) if (!(HEAP16[i24 + 24 >> 1] | 0)) if (!(HEAP16[i24 + 26 >> 1] | 0)) i5 = (HEAP16[i24 + 28 >> 1] | 0) == 0 ? i3 : 14; else i5 = 13; else i5 = 12; else i5 = 11; else i5 = 10; else i5 = 9; else i5 = 8; else i5 = 7; else i5 = 6; else i5 = 5; else i5 = 4; else i5 = 3; else i5 = 2; else i5 = 1;
 i25 = i1 >>> 0 < i5 >>> 0 ? i5 : i1;
 i1 = 2 - (i6 & 65535) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 4 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 6 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 8 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 10 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 12 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 14 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 16 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 18 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 20 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 22 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 24 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 26 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (HEAPU16[i24 + 28 >> 1] | 0) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = (i1 << 1) - (i2 & 65535) | 0;
 if ((i1 | 0) < 0) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 if (i1 | 0) if ((i8 | 0) == 0 | (i4 | 0) != 1) {
  i28 = -1;
  STACKTOP = i29;
  return i28 | 0;
 }
 HEAP16[i10 + 2 >> 1] = 0;
 HEAP16[i10 + 4 >> 1] = i6;
 i20 = (HEAPU16[i24 + 4 >> 1] | 0) + (i6 & 65535) | 0;
 HEAP16[i10 + 6 >> 1] = i20;
 i21 = HEAPU16[i24 + 6 >> 1] | 0;
 HEAP16[i10 + 8 >> 1] = i21 + i20;
 i21 = i20 + i21 | 0;
 i20 = HEAPU16[i24 + 8 >> 1] | 0;
 HEAP16[i10 + 10 >> 1] = i20 + i21;
 i20 = i21 + i20 | 0;
 i21 = HEAPU16[i24 + 10 >> 1] | 0;
 HEAP16[i10 + 12 >> 1] = i21 + i20;
 i21 = i20 + i21 | 0;
 i20 = HEAPU16[i24 + 12 >> 1] | 0;
 HEAP16[i10 + 14 >> 1] = i20 + i21;
 i20 = i21 + i20 | 0;
 i21 = HEAPU16[i24 + 14 >> 1] | 0;
 HEAP16[i10 + 16 >> 1] = i21 + i20;
 i21 = i20 + i21 | 0;
 i20 = HEAPU16[i24 + 16 >> 1] | 0;
 HEAP16[i10 + 18 >> 1] = i20 + i21;
 i20 = i21 + i20 | 0;
 i21 = HEAPU16[i24 + 18 >> 1] | 0;
 HEAP16[i10 + 20 >> 1] = i21 + i20;
 i21 = i20 + i21 | 0;
 i20 = HEAPU16[i24 + 20 >> 1] | 0;
 HEAP16[i10 + 22 >> 1] = i20 + i21;
 i20 = i21 + i20 | 0;
 i21 = HEAPU16[i24 + 22 >> 1] | 0;
 HEAP16[i10 + 24 >> 1] = i21 + i20;
 i21 = i20 + i21 | 0;
 i20 = HEAPU16[i24 + 24 >> 1] | 0;
 HEAP16[i10 + 26 >> 1] = i20 + i21;
 i20 = i21 + i20 | 0;
 i21 = HEAPU16[i24 + 26 >> 1] | 0;
 HEAP16[i10 + 28 >> 1] = i21 + i20;
 HEAP16[i10 + 30 >> 1] = (HEAPU16[i24 + 28 >> 1] | 0) + (i20 + i21);
 if (!i7) {
  i1 = 0;
  do {
   i2 = HEAP16[i22 + (i1 << 1) >> 1] | 0;
   if (i2 << 16 >> 16) {
    i20 = i10 + ((i2 & 65535) << 1) | 0;
    i21 = HEAP16[i20 >> 1] | 0;
    HEAP16[i20 >> 1] = i21 + 1 << 16 >> 16;
    HEAP16[i23 + ((i21 & 65535) << 1) >> 1] = i1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 L95 : do switch (i8 | 0) {
 case 0:
  {
   i14 = i23;
   i15 = i23;
   i16 = 19;
   i17 = 0;
   break;
  }
 case 1:
  {
   if (i25 >>> 0 > 10) i1 = 1; else {
    i14 = gb + 220360 + -514 | 0;
    i15 = gb + 220486 + -514 | 0;
    i16 = 256;
    i17 = 1;
    break L95;
   }
   STACKTOP = i29;
   return i1 | 0;
  }
 default:
  {
   i14 = gb + 220422 | 0;
   i15 = gb + 220548 | 0;
   i16 = -1;
   i17 = 0;
  }
 } while (0);
 i19 = 1 << i25;
 i20 = i19 + -1 | 0;
 i21 = i25 & 255;
 i2 = HEAP32[i27 >> 2] | 0;
 i18 = -1;
 i6 = 0;
 i3 = 0;
 i1 = i25;
 i7 = 0;
 L100 : while (1) {
  i12 = 1 << i1;
  i13 = i7;
  i11 = i5;
  while (1) {
   i8 = i11 - i3 | 0;
   i1 = i8 & 255;
   i5 = HEAP16[i23 + (i13 << 1) >> 1] | 0;
   i7 = i5 & 65535;
   do if ((i7 | 0) < (i16 | 0)) i10 = 0; else {
    if ((i7 | 0) <= (i16 | 0)) {
     i10 = 96;
     i5 = 0;
     break;
    }
    i10 = HEAP16[i14 + (i7 << 1) >> 1] & 255;
    i5 = HEAP16[i15 + (i7 << 1) >> 1] | 0;
   } while (0);
   i8 = 1 << i8;
   i9 = i6 >>> i3;
   i7 = i12;
   do {
    i7 = i7 - i8 | 0;
    i30 = i7 + i9 | 0;
    HEAP8[i2 + (i30 << 2) >> 0] = i10;
    HEAP8[i2 + (i30 << 2) + 1 >> 0] = i1;
    HEAP16[i2 + (i30 << 2) + 2 >> 1] = i5;
   } while ((i7 | 0) != 0);
   i5 = 1 << i11 + -1;
   while (1) if (!(i5 & i6)) break; else i5 = i5 >>> 1;
   i6 = (i5 | 0) == 0 ? 0 : (i5 + -1 & i6) + i5 | 0;
   i13 = i13 + 1 | 0;
   i10 = i24 + (i11 << 1) | 0;
   i30 = (HEAP16[i10 >> 1] | 0) + -1 << 16 >> 16;
   HEAP16[i10 >> 1] = i30;
   if (!(i30 << 16 >> 16)) {
    if ((i11 | 0) == (i4 | 0)) break L100;
    i5 = HEAPU16[i22 + (HEAPU16[i23 + (i13 << 1) >> 1] << 1) >> 1] | 0;
   } else i5 = i11;
   if (i5 >>> 0 <= i25 >>> 0) {
    i11 = i5;
    continue;
   }
   i9 = i6 & i20;
   if ((i9 | 0) != (i18 | 0)) break; else i11 = i5;
  }
  i3 = (i3 | 0) == 0 ? i25 : i3;
  i2 = i2 + (i12 << 2) | 0;
  i1 = i5 - i3 | 0;
  L120 : do if (i5 >>> 0 < i4 >>> 0) {
   i7 = 1 << i1;
   i8 = i5;
   while (1) {
    i7 = i7 - (HEAPU16[i24 + (i8 << 1) >> 1] | 0) | 0;
    if ((i7 | 0) < 1) break L120;
    i1 = i1 + 1 | 0;
    i8 = i1 + i3 | 0;
    if (i8 >>> 0 >= i4 >>> 0) break; else i7 = i7 << 1;
   }
  } while (0);
  i7 = (1 << i1) + i19 | 0;
  if (i17 & i7 >>> 0 > 1455) {
   i1 = 1;
   i26 = 45;
   break;
  }
  i18 = HEAP32[i27 >> 2] | 0;
  HEAP8[i18 + (i9 << 2) >> 0] = i1;
  HEAP8[i18 + (i9 << 2) + 1 >> 0] = i21;
  HEAP16[i18 + (i9 << 2) + 2 >> 1] = (i2 - i18 | 0) >>> 2;
  i18 = i9;
  i19 = i7;
  i7 = i13;
 }
 if ((i26 | 0) == 45) {
  STACKTOP = i29;
  return i1 | 0;
 }
 if (i6 | 0) while (1) {
  if ((i3 | 0) == 0 | (i6 & i20 | 0) == (i18 | 0)) i5 = i1; else {
   i2 = HEAP32[i27 >> 2] | 0;
   i3 = 0;
   i4 = i25;
   i5 = i21;
  }
  i1 = i6 >>> i3;
  HEAP8[i2 + (i1 << 2) >> 0] = 64;
  HEAP8[i2 + (i1 << 2) + 1 >> 0] = i5;
  HEAP16[i2 + (i1 << 2) + 2 >> 1] = 0;
  i1 = 1 << i4 + -1;
  while (1) if (!(i1 & i6)) break; else i1 = i1 >>> 1;
  i6 = (i1 | 0) == 0 ? 0 : (i1 + -1 & i6) + i1 | 0;
  if (!i6) break; else i1 = i5;
 }
 HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + (i19 << 2);
 HEAP32[i28 >> 2] = i25;
 i30 = 0;
 STACKTOP = i29;
 return i30 | 0;
}

function __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i1, i2, i21) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, i35 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i33 + 12 | 0;
 i26 = i33;
 i27 = i25 + 8 | 0;
 i28 = i26 + 8 | 0;
 i29 = i25 + 8 | 0;
 i30 = i26 + 8 | 0;
 i31 = i25 + 8 | 0;
 i11 = i26 + 8 | 0;
 i12 = i25 + 8 | 0;
 i13 = i26 + 8 | 0;
 i14 = i25 + 8 | 0;
 i15 = i26 + 8 | 0;
 i16 = i25 + 8 | 0;
 i17 = i26 + 8 | 0;
 i18 = i25 + 8 | 0;
 i19 = i26 + 8 | 0;
 i20 = i25 + 8 | 0;
 i22 = i26 + 8 | 0;
 i23 = i25 + 8 | 0;
 i24 = i26 + 8 | 0;
 L1 : while (1) {
  i9 = i2;
  i10 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i32 = 5;
      break L1;
     }
    case 3:
     {
      i32 = 7;
      break L1;
     }
    case 4:
     {
      i32 = 8;
      break L1;
     }
    case 5:
     {
      i32 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i32 = 46;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i32 = 11;
     break L1;
    }
    i6 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 << 2) | 0, i6, i6 + (i3 << 2) | 0, i10, i21) | 0;
    } else i3 = __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i1, i6, i10, i21) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f34 = Math_fround(HEAPF32[i27 >> 2]);
    __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f34 < Math_fround(HEAPF32[i28 >> 2])) {
     i4 = i10;
     break;
    } else i4 = i10;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i7 = HEAP32[i6 >> 2] | 0;
     __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f34 = Math_fround(HEAPF32[i29 >> 2]);
     __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f34 < Math_fround(HEAPF32[i30 >> 2])) {
      i32 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f34 = Math_fround(HEAPF32[i31 >> 2]);
    __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (!(f34 < Math_fround(HEAPF32[i11 >> 2]))) {
     if ((i3 | 0) == (i10 | 0)) {
      i32 = 46;
      break L1;
     }
     while (1) {
      i8 = HEAP32[i3 >> 2] | 0;
      __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f34 = Math_fround(HEAPF32[i16 >> 2]);
      __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      if (f34 < Math_fround(HEAPF32[i17 >> 2])) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i10 | 0)) {
       i32 = 46;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i10 >> 2] = i8;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i10 | 0)) {
     i32 = 46;
     break L1;
    } else i4 = i10;
    while (1) {
     while (1) {
      i5 = HEAP32[i3 >> 2] | 0;
      __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f34 = Math_fround(HEAPF32[i12 >> 2]);
      __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i5 = i3 + 4 | 0;
      if (f34 < Math_fround(HEAPF32[i13 >> 2])) break; else i3 = i5;
     }
     do {
      i4 = i4 + -4 | 0;
      i8 = HEAP32[i4 >> 2] | 0;
      __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f34 = Math_fround(HEAPF32[i14 >> 2]);
      __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     } while (f34 < Math_fround(HEAPF32[i15 >> 2]));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i32 | 0) == 29) {
    i32 = 0;
    i7 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i7 = i6;
    while (1) {
     while (1) {
      i6 = HEAP32[i7 >> 2] | 0;
      __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f34 = Math_fround(HEAPF32[i20 >> 2]);
      __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      i6 = i5 + 4 | 0;
      if (f34 < Math_fround(HEAPF32[i22 >> 2])) i5 = i6; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i35 = HEAP32[i7 >> 2] | 0;
      __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
      f34 = Math_fround(HEAPF32[i23 >> 2]);
      __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i35 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     } while (!(f34 < Math_fround(HEAPF32[i24 >> 2])));
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i7;
      break L35;
     }
     i35 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i35;
     i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
     i5 = i6;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i6; while (0);
   if ((i5 | 0) != (i4 | 0)) {
    i35 = HEAP32[i5 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    f34 = Math_fround(HEAPF32[i18 >> 2]);
    __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i35 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f34 < Math_fround(HEAPF32[i19 >> 2])) {
     i35 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i35;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR29ColliderHitsByDepthComparitorPP10Collider2DEEbT0_S6_T_(i1, i5, i21) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR29ColliderHitsByDepthComparitorPP10Collider2DEEbT0_S6_T_(i4, i2, i21) | 0) {
     i32 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i35 = i5;
   if ((i35 - i8 | 0) >= (i9 - i35 | 0)) {
    i32 = 44;
    break;
   }
   __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i1, i5, i21);
   i1 = i5 + 4 | 0;
  }
  if ((i32 | 0) == 44) {
   i32 = 0;
   __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i5 + 4 | 0, i2, i21);
   i2 = i5;
   continue;
  } else if ((i32 | 0) == 45) {
   i32 = 0;
   if (i3) {
    i32 = 46;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i32 | 0) == 5) {
  i35 = HEAP32[i1 >> 2] | 0;
  __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f34 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i35 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f34 < Math_fround(HEAPF32[i26 + 8 >> 2]))) {
   STACKTOP = i33;
   return;
  }
  i35 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i35;
  STACKTOP = i33;
  return;
 } else if ((i32 | 0) == 7) {
  __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i1, i1 + 4 | 0, i10, i21) | 0;
  STACKTOP = i33;
  return;
 } else if ((i32 | 0) == 8) {
  __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i10, i21) | 0;
  STACKTOP = i33;
  return;
 } else if ((i32 | 0) == 9) {
  __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i10, i21) | 0;
  STACKTOP = i33;
  return;
 } else if ((i32 | 0) == 11) {
  __ZNSt3__218__insertion_sort_3IR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i1, i2, i21);
  STACKTOP = i33;
  return;
 } else if ((i32 | 0) == 46) {
  STACKTOP = i33;
  return;
 }
}

function __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 64 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i19 = HEAP32[i20 + 24 >> 2] | 0;
 if (!i19) {
  STACKTOP = i21;
  return;
 }
 i2 = i19 + -1 | 0;
 L4 : do if ((i2 | 0) > 0) {
  i1 = 0;
  i5 = 0;
  L5 : while (1) {
   L7 : do if ((i2 | 0) > (i5 | 0)) {
    i16 = i20 + 2076 + (i5 << 3) | 0;
    i9 = i2;
    while (1) {
     if ((i9 - i5 | 0) >>> 0 < 5) break;
     i3 = i20 + 2076 + (((i9 + i5 | 0) / 2 | 0) << 3) | 0;
     f4 = Math_fround(HEAPF32[i3 >> 2]);
     f7 = Math_fround(HEAPF32[i16 >> 2]);
     if (f4 < f7) {
      i13 = i16;
      i15 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      i11 = i3;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i14 = i16;
      HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i14 + 4 >> 2] = i12;
      i14 = i3;
      HEAP32[i14 >> 2] = i15;
      HEAP32[i14 + 4 >> 2] = i13;
      f7 = Math_fround(HEAPF32[i16 >> 2]);
      f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     }
     i2 = i20 + 2076 + (i9 << 3) | 0;
     f8 = Math_fround(HEAPF32[i2 >> 2]);
     if (f8 < f7) {
      i13 = i16;
      i15 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      i11 = i2;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i14 = i16;
      HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i14 + 4 >> 2] = i12;
      i14 = i2;
      HEAP32[i14 >> 2] = i15;
      HEAP32[i14 + 4 >> 2] = i13;
      f8 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = Math_fround(HEAPF32[i3 >> 2]);
     }
     if (f8 < f4) {
      i14 = i3;
      i13 = HEAP32[i14 >> 2] | 0;
      i14 = HEAP32[i14 + 4 >> 2] | 0;
      i11 = i2;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i15 = i3;
      HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i15 + 4 >> 2] = i12;
      i15 = i2;
      HEAP32[i15 >> 2] = i13;
      HEAP32[i15 + 4 >> 2] = i14;
     }
     i14 = i9 + -1 | 0;
     i15 = i20 + 2076 + (i14 << 3) | 0;
     i13 = i3;
     i2 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i11 = i15;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = i15;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i3 + 4 >> 2] = i13;
     f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i2 = i5;
     i3 = i14;
     while (1) {
      i10 = i2;
      while (1) {
       i2 = i10 + 1 | 0;
       i6 = i20 + 2076 + (i2 << 3) | 0;
       if (Math_fround(HEAPF32[i6 >> 2]) < f4) i10 = i2; else {
        i14 = i10;
        break;
       }
      }
      do {
       i3 = i3 + -1 | 0;
       i10 = i20 + 2076 + (i3 << 3) | 0;
      } while (f4 < Math_fround(HEAPF32[i10 >> 2]));
      i13 = i6;
      i11 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      if ((i2 | 0) >= (i3 | 0)) {
       i12 = i2;
       i3 = i11;
       i2 = i13;
       i10 = i14;
       break;
      }
      i22 = i10;
      i12 = HEAP32[i22 + 4 >> 2] | 0;
      i14 = i6;
      HEAP32[i14 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i14 + 4 >> 2] = i12;
      i14 = i10;
      HEAP32[i14 >> 2] = i11;
      HEAP32[i14 + 4 >> 2] = i13;
      f4 = Math_fround(HEAPF32[i15 >> 2]);
     }
     i13 = i15;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i22 = i6;
     HEAP32[i22 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i22 + 4 >> 2] = i14;
     i22 = i15;
     HEAP32[i22 >> 2] = i3;
     HEAP32[i22 + 4 >> 2] = i2;
     i2 = i1 >>> 0 < 63;
     if ((i12 - i5 | 0) < (i9 - i12 | 0)) {
      i18 = 26;
      break;
     }
     if (!i2) {
      i18 = 30;
      break L5;
     }
     HEAP32[i17 + (i1 << 2) >> 2] = i10 + 2;
     i2 = i1 + 2 | 0;
     HEAP32[i17 + (i1 + 1 << 2) >> 2] = i9;
     if ((i10 | 0) > (i5 | 0)) {
      i1 = i2;
      i9 = i10;
     } else break L7;
    }
    if ((i18 | 0) == 26) {
     i18 = 0;
     if (!i2) {
      i18 = 27;
      break L5;
     }
     HEAP32[i17 + (i1 << 2) >> 2] = i5;
     HEAP32[i17 + (i1 + 1 << 2) >> 2] = i10;
     i1 = i1 + 2 | 0;
     i5 = i10 + 2 | 0;
     i2 = i9;
     continue L5;
    }
    do {
     i6 = i5;
     i5 = i5 + 1 | 0;
     i3 = i5;
     i2 = i6;
     while (1) {
      f8 = Math_fround(HEAPF32[i20 + 2076 + (i3 << 3) >> 2]);
      i22 = f8 < Math_fround(HEAPF32[i20 + 2076 + (i2 << 3) >> 2]);
      i2 = i22 ? i3 : i2;
      if ((i3 | 0) < (i9 | 0)) i3 = i3 + 1 | 0; else break;
     }
     if ((i2 | 0) != (i6 | 0)) {
      i15 = i20 + 2076 + (i2 << 3) | 0;
      i22 = i20 + 2076 + (i6 << 3) | 0;
      i18 = i15;
      i16 = HEAP32[i18 >> 2] | 0;
      i18 = HEAP32[i18 + 4 >> 2] | 0;
      i13 = i22;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i15 + 4 >> 2] = i14;
      HEAP32[i22 >> 2] = i16;
      HEAP32[i22 + 4 >> 2] = i18;
     }
    } while ((i5 | 0) != (i9 | 0));
    i18 = 32;
   } else i18 = 32; while (0);
   if ((i18 | 0) == 32) {
    i18 = 0;
    if (!i1) break L4; else i2 = i1;
   }
   i5 = i2 + -2 | 0;
   i1 = i5;
   i5 = HEAP32[i17 + (i5 << 2) >> 2] | 0;
   i2 = HEAP32[i17 + (i2 + -1 << 2) >> 2] | 0;
  }
  if ((i18 | 0) == 27) _memcpy(0, i17 | 0, i1 << 2 | 0) | 0; else if ((i18 | 0) == 30) _memcpy(0, i17 | 0, i1 << 2 | 0) | 0;
 } while (0);
 i10 = i20 + 2588 | 0;
 i11 = i20 + 2592 | 0;
 i15 = 0;
 do {
  i9 = HEAP32[i20 + 2076 + (i15 << 3) + 4 >> 2] | 0;
  i12 = HEAP32[i20 + 28 + (i9 << 5) + 20 >> 2] | 0;
  i13 = HEAP32[i20 + 28 + (i9 << 5) + 24 >> 2] | 0;
  i14 = HEAP32[i20 + 28 + (i9 << 5) + 28 >> 2] | 0;
  L54 : do switch (HEAP32[i20 + 28 + (i9 << 5) + 12 >> 2] | 0) {
  case 0:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = i11;
    while (1) {
     if (!i1) {
      i18 = 75;
      break L54;
     }
     if ((HEAP32[i2 >> 2] | 0) == (i12 | 0)) break L54;
     if ((HEAP32[i2 + 4 >> 2] | 0) == (i12 | 0)) break L54;
     if ((HEAP32[i2 + 8 >> 2] | 0) == (i12 | 0)) break; else {
      i1 = i1 + -1 | 0;
      i2 = i2 + 12 | 0;
     }
    }
    break;
   }
  case 1:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = i11;
    while (1) {
     if (!i1) {
      i18 = 75;
      break L54;
     }
     if ((HEAP32[i2 >> 2] | 0) == (i13 | 0)) break L54;
     if ((HEAP32[i2 + 4 >> 2] | 0) == (i13 | 0)) break L54;
     if ((HEAP32[i2 + 8 >> 2] | 0) == (i13 | 0)) break; else {
      i1 = i1 + -1 | 0;
      i2 = i2 + 12 | 0;
     }
    }
    break;
   }
  case 2:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = i11;
    while (1) {
     if (!i1) {
      i18 = 75;
      break L54;
     }
     if ((HEAP32[i2 >> 2] | 0) == (i14 | 0)) break L54;
     if ((HEAP32[i2 + 4 >> 2] | 0) == (i14 | 0)) break L54;
     if ((HEAP32[i2 + 8 >> 2] | 0) == (i14 | 0)) break; else {
      i1 = i1 + -1 | 0;
      i2 = i2 + 12 | 0;
     }
    }
    break;
   }
  case 3:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    if (!i1) i18 = 75; else {
     i6 = i11;
     while (1) {
      i1 = i1 + -1 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      i3 = HEAP32[i6 + 4 >> 2] | 0;
      i5 = HEAP32[i6 + 8 >> 2] | 0;
      i6 = i6 + 12 | 0;
      do if ((i2 | 0) == (i12 | 0)) {
       if ((i3 | 0) == (i13 | 0) | (i5 | 0) == (i13 | 0)) break L54;
      } else {
       if ((i3 | 0) == (i12 | 0)) if ((i2 | 0) == (i13 | 0) | (i5 | 0) == (i13 | 0)) break L54; else break;
       if ((i5 | 0) == (i12 | 0)) if ((i2 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0)) break L54;
      } while (0);
      if (!i1) {
       i18 = 75;
       break;
      }
     }
    }
    break;
   }
  case 4:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    if (!i1) i18 = 75; else {
     i6 = i11;
     while (1) {
      i1 = i1 + -1 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      i3 = HEAP32[i6 + 4 >> 2] | 0;
      i5 = HEAP32[i6 + 8 >> 2] | 0;
      i6 = i6 + 12 | 0;
      do if ((i2 | 0) == (i13 | 0)) {
       if ((i3 | 0) == (i14 | 0) | (i5 | 0) == (i14 | 0)) break L54;
      } else {
       if ((i3 | 0) == (i13 | 0)) if ((i2 | 0) == (i14 | 0) | (i5 | 0) == (i14 | 0)) break L54; else break;
       if ((i5 | 0) == (i13 | 0)) if ((i2 | 0) == (i14 | 0) | (i3 | 0) == (i14 | 0)) break L54;
      } while (0);
      if (!i1) {
       i18 = 75;
       break;
      }
     }
    }
    break;
   }
  case 5:
   {
    i1 = HEAP32[i10 >> 2] | 0;
    if (!i1) i18 = 75; else {
     i6 = i11;
     while (1) {
      i1 = i1 + -1 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      i3 = HEAP32[i6 + 4 >> 2] | 0;
      i5 = HEAP32[i6 + 8 >> 2] | 0;
      i6 = i6 + 12 | 0;
      do if ((i2 | 0) == (i12 | 0)) {
       if ((i3 | 0) == (i14 | 0) | (i5 | 0) == (i14 | 0)) break L54;
      } else {
       if ((i3 | 0) == (i12 | 0)) if ((i2 | 0) == (i14 | 0) | (i5 | 0) == (i14 | 0)) break L54; else break;
       if ((i5 | 0) == (i12 | 0)) if ((i2 | 0) == (i14 | 0) | (i3 | 0) == (i14 | 0)) break L54;
      } while (0);
      if (!i1) {
       i18 = 75;
       break;
      }
     }
    }
    break;
   }
  default:
   {}
  } while (0);
  if ((i18 | 0) == 75) {
   i18 = 0;
   f8 = Math_fround(HEAPF32[i20 + 2076 + (i15 << 3) >> 2]);
   __ZN12_GLOBAL__N_127SphereMeshContactGeneration10addContactERKN5physx6PxVec3Efj(i20, i20 + 28 + (i9 << 5) | 0, f8, HEAP32[i20 + 28 + (i9 << 5) + 16 >> 2] | 0);
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 >>> 0 < 64) {
   HEAP32[i10 >> 2] = i1 + 1;
   HEAP32[i20 + 2592 + (i1 * 12 | 0) >> 2] = i12;
   HEAP32[i20 + 2592 + (i1 * 12 | 0) + 4 >> 2] = i13;
   HEAP32[i20 + 2592 + (i1 * 12 | 0) + 8 >> 2] = i14;
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != (i19 | 0));
 STACKTOP = i21;
 return;
}

function __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 64 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14SubstanceInput8TransferI14SafeBinaryReadEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1037646 | 0, i3, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i9, 1); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431165 | 0, i3, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i2, 1); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431171 | 0, i3, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i2, 1); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431177 | 0, i3, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i2, 1); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead22ProceduralPropertyTypeEvRT_RT0_PKc17TransferMetaFlags(i11, i9 + 64 | 0, gb + 1047471 | 0, 0);
 i2 = i9 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034365 | 0, gb + 431187 | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SubstanceValue8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead18SubstanceInputTypeEvRT_RT0_PKc17TransferMetaFlags(i11, i9 + 88 | 0, gb + 431202 | 0, 0);
 i4 = i9 + 92 | 0;
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431215 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 36; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 36; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431229 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 47; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 47; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 104 | 0;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431248 | 0, i6, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 116 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 774422 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 64; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 64; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 64) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 774430 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 75; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 75; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 75) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431264 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 86; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 86; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 86) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i9 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1040342 | 0, i7, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 97; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 97; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 97) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431269 | 0, HEAP32[gb + 37228 >> 2] | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23setIjNS1_4lessIjEENS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i9 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431288 | 0, i6, i10, 1) | 0;
 if (!i1) {
  i11 = HEAP32[i4 >> 2] | 0;
  i11 = i11 & -13;
  i11 = i11 | 8;
  HEAP32[i4 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 i11 = HEAP32[i4 >> 2] | 0;
 i11 = i11 & -13;
 i11 = i11 | 8;
 HEAP32[i4 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN5physx33mergeKinematicProxiesBackToSourceERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjS8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERS4_PjSG_(i28, i29, i33, i31, i1, i19, i6, i27, i26) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i33 = i33 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i30 = 0, i32 = 0;
 i32 = i31 + 4 | 0;
 i23 = HEAP32[i32 >> 2] | 0;
 i13 = i31 + 24 | 0;
 i25 = HEAP32[i13 >> 2] | 0;
 i14 = HEAP32[i1 + 4 >> 2] | 0;
 i22 = HEAP32[i1 + 24 >> 2] | 0;
 i21 = i19 + 12 | 0;
 _memset(i27 | 0, -1, HEAP32[i21 >> 2] << 2 | 0) | 0;
 _memset(i26 | 0, -1, HEAP32[i21 >> 2] << 2 | 0) | 0;
 i21 = HEAP32[i28 >> 2] | 0;
 i24 = i28 + 4 | 0;
 i1 = HEAP32[i24 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i3 = 0;
   break;
  }
  i1 = HEAP32[i21 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i30 = 4;
   break;
  }
 }
 if ((i30 | 0) == 4) {
  i3 = i1 >>> 1 | i1;
  i3 = i3 >>> 2 | i3;
  i3 = i3 >>> 4 | i3;
  i3 = i3 >>> 8 | i3;
  i3 = (Math_imul(i3 >>> 16 | i3, 130329821) | 0) >>> 27;
  i3 = ((HEAP32[gb + 85120 + (i3 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i12 = HEAP32[i6 >> 2] | 0;
 i5 = 0;
 while (1) {
  i1 = HEAP32[i21 + (i5 << 2) >> 2] | 0;
  if (i1 | 0) {
   i4 = i5 << 5;
   do {
    i2 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i2 = HEAP32[i33 + ((HEAP32[gb + 90668 + (i2 << 2) >> 2] | i4) << 2) >> 2] | 0;
    if ((i2 | 0) != -1) do {
     i18 = i23 + (i2 * 12 | 0) + 8 | 0;
     HEAP8[i18 >> 0] = HEAPU8[i18 >> 0] | 0 | 32;
     i18 = HEAP32[i23 + (i2 * 12 | 0) + 4 >> 2] | 0;
     HEAP32[i27 + (i2 << 2) >> 2] = i18;
     HEAP32[i26 + (i2 << 2) >> 2] = -1;
     i20 = i12 + (i18 >>> 5 << 2) | 0;
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 1 << (i18 & 31);
     i2 = HEAP32[i33 + (i2 << 2) >> 2] | 0;
    } while ((i2 | 0) != -1);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  if ((i5 | 0) == (i3 | 0)) break; else i5 = i5 + 1 | 0;
 }
 i1 = HEAP32[i6 + 4 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i8 = 0;
   break;
  }
  i1 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i30 = 15;
   break;
  }
 }
 if ((i30 | 0) == 15) {
  i8 = i1 >>> 1 | i1;
  i8 = i8 >>> 2 | i8;
  i8 = i8 >>> 4 | i8;
  i8 = i8 >>> 8 | i8;
  i8 = (Math_imul(i8 >>> 16 | i8, 130329821) | 0) >>> 27;
  i8 = ((HEAP32[gb + 85120 + (i8 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i20 = i19 + 4 | 0;
 i11 = 0;
 while (1) {
  i1 = HEAP32[i12 + (i11 << 2) >> 2] | 0;
  if (i1 | 0) {
   i10 = i11 << 5;
   i9 = HEAP32[i20 >> 2] | 0;
   do {
    i7 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i7 = HEAP32[gb + 90668 + (i7 << 2) >> 2] | i10;
    i5 = HEAP32[i32 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i3 = i9 + (i7 << 4) | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    L31 : do if ((i2 | 0) == -1) i30 = 22; else {
     while (1) {
      if (!(HEAP8[i5 + (i2 * 12 | 0) + 8 >> 0] & 32)) break;
      i18 = i6 + (i2 << 2) | 0;
      i2 = HEAP32[i18 >> 2] | 0;
      HEAP32[i18 >> 2] = -1;
      if ((i2 | 0) == -1) {
       i30 = 22;
       break L31;
      }
     }
     HEAP32[i3 >> 2] = i2;
     i3 = i6 + (i2 << 2) | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     L36 : do if ((i4 | 0) != -1) do {
      while (1) {
       if (!(HEAP8[i5 + (i4 * 12 | 0) + 8 >> 0] & 32)) {
        i2 = i4;
        break;
       }
       i18 = i6 + (i4 << 2) | 0;
       i4 = HEAP32[i18 >> 2] | 0;
       HEAP32[i18 >> 2] = -1;
       if ((i4 | 0) == -1) break L36;
      }
      HEAP32[i3 >> 2] = i2;
      i3 = i6 + (i2 << 2) | 0;
      i4 = HEAP32[i3 >> 2] | 0;
     } while ((i4 | 0) != -1); while (0);
     HEAP32[i3 >> 2] = -1;
    } while (0);
    if ((i30 | 0) == 22) {
     i30 = 0;
     HEAP32[i3 >> 2] = -1;
     i2 = -1;
    }
    HEAP32[i9 + (i7 << 4) + 8 >> 2] = i2;
    i2 = HEAP32[i9 + (i7 << 4) + 4 >> 2] | 0;
    if ((i2 | 0) != -1) do {
     i4 = i14 + (i2 * 12 | 0) | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if ((i3 | 0) != -1) {
      i3 = HEAP32[i29 + (i3 << 2) >> 2] | 0;
      if ((i3 | 0) != -1) HEAP32[i4 >> 2] = i3;
     }
     i4 = i14 + (i2 * 12 | 0) + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if ((i3 | 0) != -1) {
      i3 = HEAP32[i29 + (i3 << 2) >> 2] | 0;
      if ((i3 | 0) != -1) HEAP32[i4 >> 2] = i3;
     }
     i2 = HEAP32[i22 + (i2 << 2) >> 2] | 0;
    } while ((i2 | 0) != -1);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  if ((i11 | 0) == (i8 | 0)) break; else i11 = i11 + 1 | 0;
 }
 i1 = HEAP32[i24 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i15 = 0;
   break;
  }
  i1 = HEAP32[i21 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i30 = 42;
   break;
  }
 }
 if ((i30 | 0) == 42) {
  i15 = i1 >>> 1 | i1;
  i15 = i15 >>> 2 | i15;
  i15 = i15 >>> 4 | i15;
  i15 = i15 >>> 8 | i15;
  i15 = (Math_imul(i15 >>> 16 | i15, 130329821) | 0) >>> 27;
  i15 = ((HEAP32[gb + 85120 + (i15 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i16 = i19 + 36 | 0;
 i17 = i19 + 16 | 0;
 i18 = i19 + 8 | 0;
 i12 = i19 + 20 | 0;
 i14 = 0;
 while (1) {
  i1 = HEAP32[i21 + (i14 << 2) >> 2] | 0;
  if (i1 | 0) {
   i13 = i14 << 5;
   do {
    i4 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i4 = HEAP32[i33 + ((HEAP32[gb + 90668 + (i4 << 2) >> 2] | i13) << 2) >> 2] | 0;
    if ((i4 | 0) != -1) {
     i2 = HEAP32[i27 + (i4 << 2) >> 2] | 0;
     if ((i2 | 0) == -1) i2 = -1; else while (1) {
      i3 = HEAP32[i26 + (i2 << 2) >> 2] | 0;
      if ((i3 | 0) == -1) break; else i2 = i3;
     }
     i11 = HEAP32[i29 + (i4 << 2) >> 2] | 0;
     i3 = HEAP32[i20 >> 2] | 0;
     HEAP32[i23 + (i11 * 12 | 0) + 4 >> 2] = i2;
     i19 = i3 + (i2 << 4) | 0;
     HEAP32[i25 + (i11 << 2) >> 2] = HEAP32[i19 >> 2];
     HEAP32[i19 >> 2] = i11;
     i3 = i3 + (i2 << 4) + 8 | 0;
     i19 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = (i19 | 0) == -1 ? i11 : i19;
     i3 = HEAP32[i33 + (i4 << 2) >> 2] | 0;
     if ((i3 | 0) != -1) do {
      i4 = HEAP32[i27 + (i3 << 2) >> 2] | 0;
      if ((i4 | 0) == -1) i4 = -1; else while (1) {
       i5 = HEAP32[i26 + (i4 << 2) >> 2] | 0;
       if ((i5 | 0) == -1) break; else i4 = i5;
      }
      if ((i2 | 0) != (i4 | 0)) {
       i9 = i4 >>> 5;
       i10 = 1 << (i4 & 31);
       if (HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + (i9 << 2) >> 2] & i10 | 0) {
        i11 = HEAP32[i20 >> 2] | 0;
        i8 = i11 + (i4 << 4) | 0;
        i6 = HEAP32[i8 >> 2] | 0;
        if ((i6 | 0) != -1) {
         i5 = i6;
         do {
          HEAP32[i23 + (i5 * 12 | 0) + 4 >> 2] = i2;
          i5 = HEAP32[i25 + (i5 << 2) >> 2] | 0;
         } while ((i5 | 0) != -1);
        }
        i5 = i11 + (i2 << 4) + 4 | 0;
        i7 = HEAP32[i11 + (i4 << 4) + 4 >> 2] | 0;
        if ((HEAP32[i5 >> 2] | 0) == -1) {
         HEAP32[i5 >> 2] = i7;
         HEAP32[i11 + (i2 << 4) + 12 >> 2] = HEAP32[i11 + (i4 << 4) + 12 >> 2];
        } else if ((i7 | 0) != -1) {
         i6 = i11 + (i2 << 4) + 12 | 0;
         HEAP32[i22 + (HEAP32[i6 >> 2] << 2) >> 2] = i7;
         HEAP32[i6 >> 2] = HEAP32[i11 + (i4 << 4) + 12 >> 2];
         i6 = HEAP32[i8 >> 2] | 0;
        }
        i5 = i11 + (i2 << 4) | 0;
        if ((HEAP32[i5 >> 2] | 0) == -1) {
         HEAP32[i5 >> 2] = i6;
         HEAP32[i11 + (i2 << 4) + 8 >> 2] = HEAP32[i11 + (i4 << 4) + 8 >> 2];
        } else if ((i6 | 0) != -1) {
         i19 = i11 + (i2 << 4) + 8 | 0;
         HEAP32[i25 + (HEAP32[i19 >> 2] << 2) >> 2] = i6;
         HEAP32[i19 >> 2] = HEAP32[i11 + (i4 << 4) + 8 >> 2];
        }
        i19 = i11 + (i4 << 4) | 0;
        HEAP32[i19 >> 2] = -1;
        HEAP32[i19 + 4 >> 2] = -1;
        HEAP32[i19 + 8 >> 2] = -1;
        HEAP32[i19 + 12 >> 2] = -1;
        HEAP32[(HEAP32[i18 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i17 >> 2];
        HEAP32[i17 >> 2] = i4;
        HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
        i19 = (HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + (i9 << 2) | 0;
        HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & ~i10;
        HEAP32[i26 + (i4 << 2) >> 2] = i2;
       }
      }
      i3 = HEAP32[i33 + (i3 << 2) >> 2] | 0;
     } while ((i3 | 0) != -1);
    }
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  if ((i14 | 0) == (i15 | 0)) break; else i14 = i14 + 1 | 0;
 }
 i9 = HEAP32[i28 >> 2] | 0;
 i2 = HEAP32[i24 >> 2] & 2147483647;
 while (1) {
  i1 = i2 + -1 | 0;
  if (!i2) {
   i8 = 1;
   break;
  }
  i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  if (!i2) i2 = i1; else {
   i30 = 71;
   break;
  }
 }
 if ((i30 | 0) == 71) {
  i8 = i2 >>> 1 | i2;
  i8 = i8 >>> 2 | i8;
  i8 = i8 >>> 4 | i8;
  i8 = i8 >>> 8 | i8;
  i8 = (Math_imul(i8 >>> 16 | i8, 130329821) | 0) >>> 27;
  i8 = (((HEAP32[gb + 85120 + (i8 << 2) >> 2] | 0) + (i1 << 5) | 0) >>> 5) + 1 | 0;
 }
 i6 = i31 + 16 | 0;
 i7 = i31 + 8 | 0;
 i3 = i31 + 20 | 0;
 i5 = 0;
 do {
  i1 = HEAP32[i9 + (i5 << 2) >> 2] | 0;
  if (i1 | 0) {
   i4 = i5 << 5;
   do {
    i2 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i2 = HEAP32[i33 + ((HEAP32[gb + 90668 + (i2 << 2) >> 2] | i4) << 2) >> 2] | 0;
    if ((i2 | 0) != -1) do {
     i31 = HEAP32[i32 >> 2] | 0;
     HEAP32[i31 + (i2 * 12 | 0) >> 2] = 0;
     HEAP32[i31 + (i2 * 12 | 0) + 4 >> 2] = -1;
     HEAP8[i31 + (i2 * 12 | 0) + 8 >> 0] = 0;
     HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = i2;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i2 = HEAP32[i33 + (i2 << 2) >> 2] | 0;
    } while ((i2 | 0) != -1);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i8 | 0));
 return;
}

function __ZN5physx2Gu33pcmDistanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_(i1, i7, i2, i8, i3, i9, i4, i10, i5, i11, i6, i12, i13) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0;
 f47 = Math_fround(HEAPF32[i2 >> 2]);
 f41 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f48 = Math_fround(HEAPF32[i7 >> 2]);
 f42 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f22 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f51 = Math_fround(HEAPF32[i8 >> 2]);
 f45 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f50 = Math_fround(HEAPF32[i9 >> 2]);
 f44 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f49 = Math_fround(HEAPF32[i10 >> 2]);
 f43 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f46 = Math_fround(HEAPF32[i11 >> 2]);
 f40 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f67 = Math_fround(f48 - f51);
 f58 = Math_fround(f48 - f50);
 f62 = Math_fround(f48 - f49);
 f53 = Math_fround(f48 - f46);
 f63 = Math_fround(f42 - f45);
 f61 = Math_fround(f42 - f44);
 f59 = Math_fround(f42 - f43);
 f57 = Math_fround(f42 - f40);
 f66 = Math_fround(f30 - f38);
 f68 = Math_fround(f30 - f35);
 f60 = Math_fround(f30 - f32);
 f64 = Math_fround(f30 - f27);
 f65 = Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f41 * f41)) + Math_fround(f29 * f29));
 f17 = Math_fround(Math_fround(f37 * f37) + Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)));
 f16 = Math_fround(Math_fround(f34 * f34) + Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)));
 f15 = Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)));
 f14 = Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)));
 f56 = Math_fround(Math_fround(f29 * f37) + Math_fround(Math_fround(f47 * f19) + Math_fround(f41 * f18)));
 f55 = Math_fround(Math_fround(f29 * f34) + Math_fround(Math_fround(f47 * f25) + Math_fround(f41 * f24)));
 f54 = Math_fround(Math_fround(f29 * f31) + Math_fround(Math_fround(f47 * f23) + Math_fround(f41 * f22)));
 f52 = Math_fround(Math_fround(f29 * f26) + Math_fround(Math_fround(f47 * f21) + Math_fround(f41 * f20)));
 f39 = Math_fround(Math_fround(f29 * f66) + Math_fround(Math_fround(f47 * f67) + Math_fround(f41 * f63)));
 f36 = Math_fround(Math_fround(f29 * f68) + Math_fround(Math_fround(f47 * f58) + Math_fround(f41 * f61)));
 f33 = Math_fround(Math_fround(f29 * f60) + Math_fround(Math_fround(f47 * f62) + Math_fround(f41 * f59)));
 f28 = Math_fround(Math_fround(f29 * f64) + Math_fround(Math_fround(f47 * f53) + Math_fround(f41 * f57)));
 f63 = Math_fround(Math_fround(f37 * f66) + Math_fround(Math_fround(f19 * f67) + Math_fround(f18 * f63)));
 f61 = Math_fround(Math_fround(f34 * f68) + Math_fround(Math_fround(f25 * f58) + Math_fround(f24 * f61)));
 f59 = Math_fround(Math_fround(f31 * f60) + Math_fround(Math_fround(f23 * f62) + Math_fround(f22 * f59)));
 f57 = Math_fround(Math_fround(f26 * f64) + Math_fround(Math_fround(f21 * f53) + Math_fround(f20 * f57)));
 f53 = Math_fround(Math_fround(1.0) / f65);
 f64 = Math_fround(Math_fround(1.0) / f17);
 f62 = Math_fround(Math_fround(1.0) / f16);
 f60 = Math_fround(Math_fround(1.0) / f15);
 f58 = Math_fround(Math_fround(1.0) / f14);
 f68 = Math_fround(Math_fround(f17 * f65) - Math_fround(f56 * f56));
 f67 = Math_fround(Math_fround(f16 * f65) - Math_fround(f55 * f55));
 f66 = Math_fround(Math_fround(f15 * f65) - Math_fround(f54 * f54));
 f65 = Math_fround(Math_fround(f14 * f65) - Math_fround(f52 * f52));
 f17 = Math_fround(Math_fround(Math_fround(f56 * f63) - Math_fround(f17 * f39)) / f68);
 f16 = Math_fround(Math_fround(Math_fround(f55 * f61) - Math_fround(f16 * f36)) / f67);
 f15 = Math_fround(Math_fround(Math_fround(f54 * f59) - Math_fround(f15 * f33)) / f66);
 f14 = Math_fround(Math_fround(Math_fround(f52 * f57) - Math_fround(f14 * f28)) / f65);
 i8 = f17 < Math_fround(1.0);
 f17 = i8 ? f17 : Math_fround(1.0);
 i8 = f16 < Math_fround(1.0);
 f16 = i8 ? f16 : Math_fround(1.0);
 i8 = f15 < Math_fround(1.0);
 f15 = i8 ? f15 : Math_fround(1.0);
 i8 = f14 < Math_fround(1.0);
 f14 = i8 ? f14 : Math_fround(1.0);
 i8 = f17 > Math_fround(0.0);
 f17 = i8 ? f17 : Math_fround(0.0);
 i8 = f16 > Math_fround(0.0);
 f16 = i8 ? f16 : Math_fround(0.0);
 i8 = f15 > Math_fround(0.0);
 f15 = i8 ? f15 : Math_fround(0.0);
 i8 = f14 > Math_fround(0.0);
 f14 = i8 ? f14 : Math_fround(0.0);
 i8 = f68 <= Math_fround(1.1920929e-07);
 i9 = f67 <= Math_fround(1.1920929e-07);
 i10 = f66 <= Math_fround(1.1920929e-07);
 i11 = f65 <= Math_fround(1.1920929e-07);
 f17 = i8 ? Math_fround(.5) : f17;
 f16 = i9 ? Math_fround(.5) : f16;
 f15 = i10 ? Math_fround(.5) : f15;
 f17 = Math_fround(f64 * Math_fround(f63 + Math_fround(f56 * f17)));
 f16 = Math_fround(f62 * Math_fround(f61 + Math_fround(f55 * f16)));
 f15 = Math_fround(f60 * Math_fround(f59 + Math_fround(f54 * f15)));
 f14 = Math_fround(f58 * Math_fround(f57 + Math_fround(f52 * (i11 ? Math_fround(.5) : f14))));
 i11 = f17 < Math_fround(1.0);
 f17 = i11 ? f17 : Math_fround(1.0);
 i11 = f16 < Math_fround(1.0);
 f16 = i11 ? f16 : Math_fround(1.0);
 i11 = f15 < Math_fround(1.0);
 f15 = i11 ? f15 : Math_fround(1.0);
 i11 = f14 < Math_fround(1.0);
 f14 = i11 ? f14 : Math_fround(1.0);
 i11 = f17 > Math_fround(0.0);
 f17 = i11 ? f17 : Math_fround(0.0);
 i11 = f16 > Math_fround(0.0);
 f16 = i11 ? f16 : Math_fround(0.0);
 i11 = f15 > Math_fround(0.0);
 f15 = i11 ? f15 : Math_fround(0.0);
 i11 = f14 > Math_fround(0.0);
 f14 = i11 ? f14 : Math_fround(0.0);
 f39 = Math_fround(f53 * Math_fround(Math_fround(f56 * f17) - f39));
 f36 = Math_fround(f53 * Math_fround(Math_fround(f55 * f16) - f36));
 f33 = Math_fround(f53 * Math_fround(Math_fround(f54 * f15) - f33));
 f28 = Math_fround(f53 * Math_fround(Math_fround(f52 * f14) - f28));
 i11 = f39 < Math_fround(1.0);
 f39 = i11 ? f39 : Math_fround(1.0);
 i11 = f36 < Math_fround(1.0);
 f36 = i11 ? f36 : Math_fround(1.0);
 i11 = f33 < Math_fround(1.0);
 f33 = i11 ? f33 : Math_fround(1.0);
 i11 = f28 < Math_fround(1.0);
 f28 = i11 ? f28 : Math_fround(1.0);
 i11 = f39 > Math_fround(0.0);
 f39 = i11 ? f39 : Math_fround(0.0);
 i11 = f36 > Math_fround(0.0);
 f36 = i11 ? f36 : Math_fround(0.0);
 i11 = f33 > Math_fround(0.0);
 f33 = i11 ? f33 : Math_fround(0.0);
 i11 = f28 > Math_fround(0.0);
 f28 = i11 ? f28 : Math_fround(0.0);
 HEAPF32[i12 >> 2] = f39;
 HEAPF32[i12 + 4 >> 2] = f36;
 HEAPF32[i12 + 8 >> 2] = f33;
 HEAPF32[i12 + 12 >> 2] = f28;
 HEAPF32[i13 >> 2] = f17;
 HEAPF32[i13 + 4 >> 2] = f16;
 HEAPF32[i13 + 8 >> 2] = f15;
 HEAPF32[i13 + 12 >> 2] = f14;
 f19 = Math_fround(Math_fround(f48 + Math_fround(f47 * f39)) - Math_fround(f51 + Math_fround(f19 * f17)));
 f25 = Math_fround(Math_fround(f48 + Math_fround(f47 * f36)) - Math_fround(f50 + Math_fround(f25 * f16)));
 f23 = Math_fround(Math_fround(f48 + Math_fround(f47 * f33)) - Math_fround(f49 + Math_fround(f23 * f15)));
 f21 = Math_fround(Math_fround(f48 + Math_fround(f47 * f28)) - Math_fround(f46 + Math_fround(f21 * f14)));
 f18 = Math_fround(Math_fround(f42 + Math_fround(f41 * f39)) - Math_fround(f45 + Math_fround(f18 * f17)));
 f24 = Math_fround(Math_fround(f42 + Math_fround(f41 * f36)) - Math_fround(f44 + Math_fround(f24 * f16)));
 f22 = Math_fround(Math_fround(f42 + Math_fround(f41 * f33)) - Math_fround(f43 + Math_fround(f22 * f15)));
 f20 = Math_fround(Math_fround(f42 + Math_fround(f41 * f28)) - Math_fround(f40 + Math_fround(f20 * f14)));
 f17 = Math_fround(Math_fround(f30 + Math_fround(f29 * f39)) - Math_fround(f38 + Math_fround(f37 * f17)));
 f16 = Math_fround(Math_fround(f30 + Math_fround(f29 * f36)) - Math_fround(f35 + Math_fround(f34 * f16)));
 f15 = Math_fround(Math_fround(f30 + Math_fround(f29 * f33)) - Math_fround(f32 + Math_fround(f31 * f15)));
 f14 = Math_fround(Math_fround(f30 + Math_fround(f29 * f28)) - Math_fround(f27 + Math_fround(f26 * f14)));
 f16 = Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f24 * f24) + Math_fround(f16 * f16)));
 f15 = Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f22 * f22) + Math_fround(f15 * f15)));
 f14 = Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f20 * f20) + Math_fround(f14 * f14)));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)));
 HEAPF32[i1 + 4 >> 2] = f16;
 HEAPF32[i1 + 8 >> 2] = f15;
 HEAPF32[i1 + 12 >> 2] = f14;
 return;
}

function __ZN5Unity5Cloth8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 24 | 0;
 i10 = i3 + 16 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839016 | 0, i6, i1 + 40 | 0, 0);
 i8 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839038 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839057 | 0, i12, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839070 | 0, i12, i1 + 45 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839083 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = i1 + 52 | 0;
 i9 = HEAP32[gb + 37324 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839093 | 0, i9, i12, 0);
 i11 = i2 + 20 | 0;
 i13 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i11) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 20 >> 2] = i13;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i12, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 64 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839116 | 0, i9, i6, 0);
 i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i11) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 20 >> 2] = i11;
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i11, i6, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i11, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i11, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839137 | 0, i11, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839158 | 0, i11, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839183 | 0, i11, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839194 | 0, i11, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839215 | 0, i6, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839240 | 0, i6, i1 + 93 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839262 | 0, i11, i1 + 120 | 0, 8388608);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839280 | 0, i11, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839297 | 0, i6, i1 + 128 | 0, 1);
 HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i9 = i4 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 839392 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839419 | 0, i11, i4, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839431 | 0, i11, i9, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839312 | 0, i6, i1 + 148 | 0, 0);
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 839370 | 0, i10, 0);
 i9 = i5 + 8 | 0;
 i11 = i9;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i10, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839331 | 0, i6, i1 + 168 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i4, 0);
 __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI24GenerateTypeTreeTransferEEvRS5_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN16b2PrismaticJoint23InitVelocityConstraintsERK12b2SolverData(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 i27 = HEAP32[i1 + 8 >> 2] | 0;
 i24 = i6 + 144 | 0;
 HEAP32[i24 >> 2] = i27;
 i5 = HEAP32[i6 + 52 >> 2] | 0;
 i43 = HEAP32[i5 + 8 >> 2] | 0;
 i8 = i6 + 148 | 0;
 HEAP32[i8 >> 2] = i43;
 i41 = i1 + 28 | 0;
 i42 = HEAP32[i41 >> 2] | 0;
 i41 = HEAP32[i41 + 4 >> 2] | 0;
 i39 = i6 + 152 | 0;
 HEAP32[i39 >> 2] = i42;
 HEAP32[i39 + 4 >> 2] = i41;
 i39 = i5 + 28 | 0;
 i40 = HEAP32[i39 >> 2] | 0;
 i39 = HEAP32[i39 + 4 >> 2] | 0;
 i38 = i6 + 160 | 0;
 HEAP32[i38 >> 2] = i40;
 HEAP32[i38 + 4 >> 2] = i39;
 i38 = HEAP32[i1 + 120 >> 2] | 0;
 HEAP32[i6 + 168 >> 2] = i38;
 i37 = HEAP32[i5 + 120 >> 2] | 0;
 HEAP32[i6 + 172 >> 2] = i37;
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 HEAP32[i6 + 176 >> 2] = i1;
 i5 = HEAP32[i5 + 128 >> 2] | 0;
 HEAP32[i6 + 180 >> 2] = i5;
 i26 = HEAP32[i7 + 24 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i26 + (i27 * 12 | 0) >> 2]);
 f3 = Math_fround(HEAPF32[i26 + (i27 * 12 | 0) + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i26 + (i27 * 12 | 0) + 8 >> 2]);
 i21 = i7 + 28 | 0;
 i44 = HEAP32[i21 >> 2] | 0;
 i22 = HEAP32[i44 + (i27 * 12 | 0) >> 2] | 0;
 i23 = HEAP32[i44 + (i27 * 12 | 0) + 4 >> 2] | 0;
 f25 = Math_fround(HEAPF32[i44 + (i27 * 12 | 0) + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i26 + (i43 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i26 + (i43 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i26 + (i43 * 12 | 0) + 8 >> 2]);
 i26 = HEAP32[i44 + (i43 * 12 | 0) >> 2] | 0;
 i27 = HEAP32[i44 + (i43 * 12 | 0) + 4 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i44 + (i43 * 12 | 0) + 8 >> 2]);
 f36 = Math_fround(+Math_sin(+f32));
 f32 = Math_fround(+Math_cos(+f32));
 f15 = Math_fround(+Math_sin(+f11));
 f11 = Math_fround(+Math_cos(+f11));
 f12 = Math_fround(HEAPF32[i6 + 68 >> 2]);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(HEAPF32[i6 + 72 >> 2]);
 f19 = Math_fround(f19 - (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f30 = Math_fround(Math_fround(f32 * f12) - Math_fround(f36 * f19));
 f19 = Math_fround(Math_fround(f36 * f12) + Math_fround(f32 * f19));
 f12 = Math_fround(HEAPF32[i6 + 76 >> 2]);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(HEAPF32[i6 + 80 >> 2]);
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f31 = Math_fround(Math_fround(f11 * f12) - Math_fround(f15 * f20));
 f20 = Math_fround(Math_fround(f15 * f12) + Math_fround(f11 * f20));
 f2 = Math_fround(Math_fround(Math_fround(f10 - f2) + f31) - f30);
 f3 = Math_fround(Math_fround(Math_fround(f9 - f3) + f20) - f19);
 f9 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(HEAPF32[i6 + 84 >> 2]);
 f13 = Math_fround(f32 * f15);
 f14 = Math_fround(HEAPF32[i6 + 88 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f36 * f14));
 f14 = Math_fround(Math_fround(f36 * f15) + Math_fround(f32 * f14));
 HEAPF32[i6 + 184 >> 2] = f13;
 HEAPF32[i6 + 188 >> 2] = f14;
 f30 = Math_fround(f30 + f2);
 f19 = Math_fround(f19 + f3);
 f15 = Math_fround(Math_fround(f30 * f14) - Math_fround(f19 * f13));
 HEAPF32[i6 + 208 >> 2] = f15;
 f16 = Math_fround(Math_fround(f31 * f14) - Math_fround(f20 * f13));
 HEAPF32[i6 + 212 >> 2] = f16;
 f33 = Math_fround(f9 + f10);
 f34 = Math_fround(f11 * f15);
 f29 = Math_fround(f12 * f16);
 f4 = Math_fround(Math_fround(f16 * f29) + Math_fround(f33 + Math_fround(f15 * f34)));
 i5 = f4 > Math_fround(0.0);
 f35 = Math_fround(Math_fround(1.0) / f4);
 HEAPF32[i6 + 252 >> 2] = i5 ? f35 : f4;
 f35 = Math_fround(HEAPF32[i6 + 92 >> 2]);
 f17 = Math_fround(f32 * f35);
 f18 = Math_fround(HEAPF32[i6 + 96 >> 2]);
 f17 = Math_fround(f17 - Math_fround(f36 * f18));
 f18 = Math_fround(Math_fround(f36 * f35) + Math_fround(f32 * f18));
 HEAPF32[i6 + 192 >> 2] = f17;
 HEAPF32[i6 + 196 >> 2] = f18;
 f19 = Math_fround(Math_fround(f30 * f18) - Math_fround(f19 * f17));
 HEAPF32[i6 + 200 >> 2] = f19;
 f20 = Math_fround(Math_fround(f31 * f18) - Math_fround(f20 * f17));
 HEAPF32[i6 + 204 >> 2] = f20;
 f31 = Math_fround(f11 * f19);
 f30 = Math_fround(f12 * f20);
 f33 = Math_fround(Math_fround(f20 * f30) + Math_fround(f33 + Math_fround(f19 * f31)));
 f32 = Math_fround(f31 + f30);
 f30 = Math_fround(Math_fround(f31 * f15) + Math_fround(f30 * f16));
 f31 = Math_fround(f11 + f12);
 i5 = f31 == Math_fround(0.0);
 f31 = i5 ? Math_fround(1.0) : f31;
 f29 = Math_fround(f34 + f29);
 HEAPF32[i6 + 216 >> 2] = f33;
 HEAPF32[i6 + 220 >> 2] = f32;
 HEAPF32[i6 + 224 >> 2] = f30;
 HEAPF32[i6 + 228 >> 2] = f32;
 HEAPF32[i6 + 232 >> 2] = f31;
 HEAPF32[i6 + 236 >> 2] = f29;
 HEAPF32[i6 + 240 >> 2] = f30;
 HEAPF32[i6 + 244 >> 2] = f29;
 HEAPF32[i6 + 248 >> 2] = f4;
 i5 = HEAP16[i6 + 136 >> 1] | 0;
 do if (!((i5 & 255) << 24 >> 24)) {
  HEAP32[i6 + 140 >> 2] = 0;
  HEAPF32[i6 + 112 >> 2] = Math_fround(0.0);
 } else {
  f3 = Math_fround(Math_fround(f2 * f13) + Math_fround(f3 * f14));
  f4 = Math_fround(HEAPF32[i6 + 124 >> 2]);
  f2 = Math_fround(HEAPF32[i6 + 120 >> 2]);
  f35 = Math_fround(f4 - f2);
  i44 = f35 > Math_fround(0.0);
  f36 = Math_fround(-f35);
  if ((i44 ? f35 : f36) < Math_fround(.00999999977)) {
   HEAP32[i6 + 140 >> 2] = 3;
   break;
  }
  if (f3 <= f2) {
   i1 = i6 + 140 | 0;
   if ((HEAP32[i1 >> 2] | 0) == 1) break;
   HEAP32[i1 >> 2] = 1;
   HEAPF32[i6 + 112 >> 2] = Math_fround(0.0);
   break;
  }
  i1 = i6 + 140 | 0;
  if (!(f3 >= f4)) {
   HEAP32[i1 >> 2] = 0;
   HEAPF32[i6 + 112 >> 2] = Math_fround(0.0);
   break;
  }
  if ((HEAP32[i1 >> 2] | 0) != 2) {
   HEAP32[i1 >> 2] = 2;
   HEAPF32[i6 + 112 >> 2] = Math_fround(0.0);
  }
 } while (0);
 if ((i5 & 65535) < 256) HEAPF32[i6 + 116 >> 2] = Math_fround(0.0);
 i1 = i6 + 104 | 0;
 if (!(HEAP8[i7 + 20 >> 0] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  f35 = f25;
  f36 = f28;
  i40 = i26;
  i38 = i22;
  i43 = i27;
  i42 = i23;
  i44 = HEAP32[i24 >> 2] | 0;
  i41 = HEAP32[i21 >> 2] | 0;
  i39 = i41 + (i44 * 12 | 0) | 0;
  HEAP32[i39 >> 2] = i38;
  i44 = i41 + (i44 * 12 | 0) + 4 | 0;
  HEAP32[i44 >> 2] = i42;
  i44 = HEAP32[i24 >> 2] | 0;
  i42 = HEAP32[i21 >> 2] | 0;
  i44 = i42 + (i44 * 12 | 0) + 8 | 0;
  HEAPF32[i44 >> 2] = f35;
  i44 = HEAP32[i8 >> 2] | 0;
  i41 = i42 + (i44 * 12 | 0) | 0;
  HEAP32[i41 >> 2] = i40;
  i44 = i42 + (i44 * 12 | 0) + 4 | 0;
  HEAP32[i44 >> 2] = i43;
  i44 = HEAP32[i8 >> 2] | 0;
  i43 = HEAP32[i21 >> 2] | 0;
  i44 = i43 + (i44 * 12 | 0) + 8 | 0;
  HEAPF32[i44 >> 2] = f36;
  return;
 } else {
  f33 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f31 = Math_fround(f33 * Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i1 >> 2] = f31;
  i38 = i6 + 108 | 0;
  f32 = Math_fround(f33 * Math_fround(HEAPF32[i38 >> 2]));
  HEAPF32[i38 >> 2] = f32;
  i38 = i6 + 112 | 0;
  f36 = Math_fround(f33 * Math_fround(HEAPF32[i38 >> 2]));
  HEAPF32[i38 >> 2] = f36;
  i38 = i6 + 116 | 0;
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i38 >> 2]));
  HEAPF32[i38 >> 2] = f33;
  f36 = Math_fround(f33 + f36);
  f33 = Math_fround(Math_fround(f31 * f17) + Math_fround(f13 * f36));
  f34 = Math_fround(Math_fround(f31 * f18) + Math_fround(f36 * f14));
  f35 = Math_fround(Math_fround(Math_fround(f31 * f19) + f32) + Math_fround(f36 * f15));
  f36 = Math_fround(Math_fround(f32 + Math_fround(f31 * f20)) + Math_fround(f36 * f16));
  f31 = Math_fround(f9 * f33);
  f32 = Math_fround(f9 * f34);
  f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f31);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f32);
  i42 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  f35 = Math_fround(f25 - Math_fround(f11 * f35));
  f33 = Math_fround(f10 * f33);
  f34 = Math_fround(f10 * f34);
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
  f36 = Math_fround(f28 + Math_fround(f12 * f36));
  i43 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i44 = HEAP32[i24 >> 2] | 0;
  i41 = HEAP32[i21 >> 2] | 0;
  i39 = i41 + (i44 * 12 | 0) | 0;
  HEAP32[i39 >> 2] = i38;
  i44 = i41 + (i44 * 12 | 0) + 4 | 0;
  HEAP32[i44 >> 2] = i42;
  i44 = HEAP32[i24 >> 2] | 0;
  i42 = HEAP32[i21 >> 2] | 0;
  i44 = i42 + (i44 * 12 | 0) + 8 | 0;
  HEAPF32[i44 >> 2] = f35;
  i44 = HEAP32[i8 >> 2] | 0;
  i41 = i42 + (i44 * 12 | 0) | 0;
  HEAP32[i41 >> 2] = i40;
  i44 = i42 + (i44 * 12 | 0) + 4 | 0;
  HEAP32[i44 >> 2] = i43;
  i44 = HEAP32[i8 >> 2] | 0;
  i43 = HEAP32[i21 >> 2] | 0;
  i44 = i43 + (i44 * 12 | 0) + 8 | 0;
  HEAPF32[i44 >> 2] = f36;
  return;
 }
}

function __ZN5physx2Sc9ClothCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx2Sc13ClothBulkData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i20 >> 2] = HEAP32[gb + 127140 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 127140 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 127140 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 127140 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 127140 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 127140 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 127140 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 127140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = gb + 748485;
 HEAP32[i19 + 4 >> 2] = gb + 748168;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 92;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 1;
 HEAP32[i19 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 127172 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 127172 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 127172 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 127172 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 127172 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 127172 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 127172 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 127172 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 127204 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 127204 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 127204 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 127204 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 127204 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 127204 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 127204 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 127204 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 127236 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 127236 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 127236 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 127236 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 127236 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 127236 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 127236 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 127236 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 127268 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 127268 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 127268 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 127268 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 127268 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 127268 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 127268 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 127268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 127300 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 127300 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 127300 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 127300 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 127300 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 127300 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 127300 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 127300 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 127332 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 127332 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 127332 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 127332 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 127332 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 127332 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 127332 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 127332 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 127364 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 127364 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 127364 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 127364 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 127364 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 127364 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 127364 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 127364 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 127396 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 127396 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 127396 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 127396 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 127396 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 127396 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 127396 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 127396 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 127428 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 127428 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 127428 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 127428 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 127428 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 127428 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 127428 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 127428 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 127460 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 127460 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 127460 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 127460 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 127460 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 127460 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 127460 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 127460 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 127492 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 127492 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 127492 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 127492 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 127492 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 127492 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 127492 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 127492 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 127524 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 127524 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 127524 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 127524 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 127524 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 127524 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 127524 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 127524 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 127556 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 127556 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 127556 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 127556 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 127556 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 127556 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 127556 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 127556 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 127588 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 127588 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 127588 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 127588 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 127588 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 127588 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 127588 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 127588 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 127620 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 127620 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 127620 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 127620 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 127620 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 127620 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 127620 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 127620 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 127652 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 127652 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 127652 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 127652 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 127652 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 127652 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 127652 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 127652 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z27InsertAnimationClipCurveIDsR14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEER13AnimationClip(i19, i15) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23;
 i21 = i23 + 24 | 0;
 i1 = HEAP32[i15 + 100 >> 2] | 0;
 i13 = i15 + 104 | 0;
 if ((i1 | 0) != (HEAP32[i13 >> 2] | 0)) {
  i7 = i20 + 4 | 0;
  i8 = i20 + 8 | 0;
  i9 = i20 + 12 | 0;
  i10 = i20 + 16 | 0;
  i14 = i19 + 68 | 0;
  i11 = i19 + 4 | 0;
  i12 = i20 + 20 | 0;
  do {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i6 = HEAP32[i1 >> 2] | 0; else i6 = i1;
   i5 = i1 + 200 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) {
    i2 = HEAP8[i6 >> 0] | 0;
    if (!(i2 << 24 >> 24)) i2 = 4; else {
     i3 = 0;
     i4 = i6;
     do {
      i18 = (i3 << 4) + (i2 << 24 >> 24) | 0;
      i17 = i18 & -268435456;
      i3 = (i17 >>> 24 | i17) ^ i18;
      i4 = i4 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     } while (i2 << 24 >> 24 != 0);
     i2 = i3 ^ 4;
    }
    i2 = i2 ^ 99729038;
    i2 = i2 >>> 0 < 2 ? 2 : i2;
    HEAP32[i5 >> 2] = i2;
   }
   HEAP32[i20 >> 2] = i6;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i8 >> 2] = gb + 896768;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i12 >> 2] = (HEAP32[i14 >> 2] | 0) - (HEAP32[i11 >> 2] | 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i19, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i21, i19, i20);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (HEAP32[i13 >> 2] | 0));
 }
 i1 = HEAP32[i15 + 116 >> 2] | 0;
 i11 = i15 + 120 | 0;
 if ((i1 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i7 = i20 + 4 | 0;
  i8 = i20 + 8 | 0;
  i9 = i20 + 12 | 0;
  i10 = i20 + 16 | 0;
  i12 = i19 + 68 | 0;
  i13 = i19 + 4 | 0;
  i14 = i20 + 20 | 0;
  do {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i6 = HEAP32[i1 >> 2] | 0; else i6 = i1;
   i5 = i1 + 168 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) {
    i2 = HEAP8[i6 >> 0] | 0;
    if (!(i2 << 24 >> 24)) i2 = 4; else {
     i3 = 0;
     i4 = i6;
     do {
      i18 = (i3 << 4) + (i2 << 24 >> 24) | 0;
      i17 = i18 & -268435456;
      i3 = (i17 >>> 24 | i17) ^ i18;
      i4 = i4 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     } while (i2 << 24 >> 24 != 0);
     i2 = i3 ^ 4;
    }
    i2 = i2 ^ 20485970;
    i2 = i2 >>> 0 < 2 ? 2 : i2;
    HEAP32[i5 >> 2] = i2;
   }
   HEAP32[i20 >> 2] = i6;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i8 >> 2] = gb + 896784;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i14 >> 2] = (HEAP32[i12 >> 2] | 0) - (HEAP32[i13 >> 2] | 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i19, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i21, i19, i20);
   i1 = i1 + 172 | 0;
  } while ((i1 | 0) != (HEAP32[i11 >> 2] | 0));
 }
 i1 = HEAP32[i15 + 132 >> 2] | 0;
 i11 = i15 + 136 | 0;
 if ((i1 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i7 = i20 + 4 | 0;
  i8 = i20 + 8 | 0;
  i9 = i20 + 12 | 0;
  i10 = i20 + 16 | 0;
  i12 = i19 + 68 | 0;
  i13 = i19 + 4 | 0;
  i14 = i20 + 20 | 0;
  do {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i6 = HEAP32[i1 >> 2] | 0; else i6 = i1;
   i5 = i1 + 168 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) {
    i2 = HEAP8[i6 >> 0] | 0;
    if (!(i2 << 24 >> 24)) i2 = 4; else {
     i3 = 0;
     i4 = i6;
     do {
      i18 = (i3 << 4) + (i2 << 24 >> 24) | 0;
      i17 = i18 & -268435456;
      i3 = (i17 >>> 24 | i17) ^ i18;
      i4 = i4 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     } while (i2 << 24 >> 24 != 0);
     i2 = i3 ^ 4;
    }
    i2 = i2 ^ 98156142;
    i2 = i2 >>> 0 < 2 ? 2 : i2;
    HEAP32[i5 >> 2] = i2;
   }
   HEAP32[i20 >> 2] = i6;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i8 >> 2] = gb + 896797;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i14 >> 2] = (HEAP32[i12 >> 2] | 0) - (HEAP32[i13 >> 2] | 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i19, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i21, i19, i20);
   i1 = i1 + 172 | 0;
  } while ((i1 | 0) != (HEAP32[i11 >> 2] | 0));
 }
 i1 = HEAP32[i15 + 148 >> 2] | 0;
 i11 = i15 + 152 | 0;
 if ((i1 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i7 = i20 + 4 | 0;
  i8 = i20 + 8 | 0;
  i9 = i20 + 12 | 0;
  i10 = i20 + 16 | 0;
  i12 = i19 + 68 | 0;
  i13 = i19 + 4 | 0;
  i14 = i20 + 20 | 0;
  do {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i6 = HEAP32[i1 >> 2] | 0; else i6 = i1;
   i5 = i1 + 168 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) {
    i2 = HEAP8[i6 >> 0] | 0;
    if (!(i2 << 24 >> 24)) i2 = 4; else {
     i3 = 0;
     i4 = i6;
     do {
      i18 = (i3 << 4) + (i2 << 24 >> 24) | 0;
      i17 = i18 & -268435456;
      i3 = (i17 >>> 24 | i17) ^ i18;
      i4 = i4 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     } while (i2 << 24 >> 24 != 0);
     i2 = i3 ^ 4;
    }
    i2 = i2 ^ 19768245;
    i2 = i2 >>> 0 < 2 ? 2 : i2;
    HEAP32[i5 >> 2] = i2;
   }
   HEAP32[i20 >> 2] = i6;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i8 >> 2] = gb + 896813;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i14 >> 2] = (HEAP32[i12 >> 2] | 0) - (HEAP32[i13 >> 2] | 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i19, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i21, i19, i20);
   i1 = i1 + 172 | 0;
  } while ((i1 | 0) != (HEAP32[i11 >> 2] | 0));
 }
 i1 = HEAP32[i15 + 164 >> 2] | 0;
 i15 = i15 + 168 | 0;
 if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i20 + 4 | 0;
 i12 = i20 + 8 | 0;
 i13 = i20 + 12 | 0;
 i14 = i20 + 16 | 0;
 i16 = i19 + 68 | 0;
 i17 = i19 + 4 | 0;
 i18 = i20 + 20 | 0;
 do {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i10 = HEAP32[i1 >> 2] | 0; else i10 = i1;
  i9 = HEAP32[i1 + 32 >> 2] | 0;
  i5 = i1 + 36 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i21 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i22 = 57; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
     i3 = HEAP32[i20 >> 2] | 0;
     i8 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i8 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i22 = 57; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i22 = 59;
    }
   }
   if ((i22 | 0) == 57) i22 = 59;
   if ((i22 | 0) == 59) {
    i22 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  i3 = i1 + 16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  i8 = i1 + 128 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (!i4) {
   i4 = HEAP8[i10 >> 0] | 0;
   if (!(i4 << 24 >> 24)) i7 = 4; else {
    i5 = 0;
    i6 = i10;
    do {
     i7 = (i5 << 4) + (i4 << 24 >> 24) | 0;
     i24 = i7 & -268435456;
     i5 = (i24 >>> 24 | i24) ^ i7;
     i6 = i6 + 1 | 0;
     i4 = HEAP8[i6 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
    i7 = i5 ^ 4;
   }
   i5 = HEAP8[i3 >> 0] | 0;
   if (!(i5 << 24 >> 24)) i4 = 0; else {
    i4 = 0;
    i6 = i3;
    do {
     i4 = (i4 << 4) + (i5 << 24 >> 24) | 0;
     i24 = i4 & -268435456;
     i4 = (i24 >>> 24 | i24) ^ i4;
     i6 = i6 + 1 | 0;
     i5 = HEAP8[i6 >> 0] | 0;
    } while (i5 << 24 >> 24 != 0);
   }
   i4 = i4 ^ i7;
   i4 = i4 >>> 0 < 2 ? 2 : i4;
   HEAP32[i8 >> 2] = i4;
  }
  HEAP32[i20 >> 2] = i10;
  HEAP32[i11 >> 2] = i9;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i18 >> 2] = (HEAP32[i16 >> 2] | 0) - (HEAP32[i17 >> 2] | 0);
  __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i19, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i21, i19, i20);
  i1 = i1 + 132 | 0;
 } while ((i1 | 0) != (HEAP32[i15 >> 2] | 0));
 STACKTOP = i23;
 return;
}

function __ZN9Texture3D8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i10, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i14 = i10 + 80 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932215 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i8 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i8 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i14, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i14 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i8 = i10 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932223 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 853473 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i6 = i10 + 92 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags(i11, i6, gb + 410455 | 0, 0);
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0) {
  HEAP8[i12 >> 0] = 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 411124 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
  if (i1 | 0) {
   do if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i12 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i12, 1);
   } else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i12 | 0, i11 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  if (!(HEAP8[i12 >> 0] | 0)) i1 = 1; else i1 = __Z22CalculateMipMapCount3Diii(HEAP32[i14 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  HEAP32[i10 + 76 >> 2] = i1;
 } else {
  i4 = i10 + 76 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 410444 | 0, i5, i9, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i11 + 16 | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 52; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 52; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
 }
 i4 = i10 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 64; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 64; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 64) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 431875 | 0, gb + 431893 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 105 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
 __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i11, i13, gb + 411165 | 0, 1);
 i1 = i10 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i10 + 104 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i4 >> 2] = i12;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = gb + 45784 + (i9 << 2) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i12 = i9 + i12 | 0;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
  HEAP32[i1 >> 2] = i12;
  i14 = HEAP32[i14 >> 2] | 0;
  f17 = Math_fround(i14 | 0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i14 = HEAP32[i8 >> 2] | 0;
  f16 = Math_fround(i14 | 0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  i14 = i10 + 68 | 0;
  HEAPF32[i14 >> 2] = f17;
  i14 = i10 + 72 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i11, i14, i12, 0);
  STACKTOP = i15;
  return;
 }
 i7 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 + 48 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i9 | 0);
 HEAP8[i2 >> 0] = 0;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i4 >> 2] = i12;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = gb + 45784 + (i9 << 2) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i12 = i9 + i12 | 0;
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
 HEAP32[i1 >> 2] = i12;
 i14 = HEAP32[i14 >> 2] | 0;
 f16 = Math_fround(i14 | 0);
 f16 = Math_fround(Math_fround(1.0) / f16);
 i14 = HEAP32[i8 >> 2] | 0;
 f17 = Math_fround(i14 | 0);
 f17 = Math_fround(Math_fround(1.0) / f17);
 i14 = i10 + 68 | 0;
 HEAPF32[i14 >> 2] = f16;
 i14 = i10 + 72 | 0;
 HEAPF32[i14 >> 2] = f17;
 i14 = HEAP32[i13 >> 2] | 0;
 __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i11, i14, i12, 0);
 STACKTOP = i15;
 return;
}

function __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 64 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN16b2PrismaticJoint24SolveVelocityConstraintsERK12b2SolverData(i28, i1) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i38 + 20 | 0;
 i34 = i38 + 8 | 0;
 i35 = i38;
 i36 = i28 + 144 | 0;
 i29 = HEAP32[i36 >> 2] | 0;
 i37 = i1 + 28 | 0;
 i21 = HEAP32[i37 >> 2] | 0;
 i4 = HEAP32[i21 + (i29 * 12 | 0) >> 2] | 0;
 i6 = HEAP32[i21 + (i29 * 12 | 0) + 4 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i21 + (i29 * 12 | 0) + 8 >> 2]);
 i29 = i28 + 148 | 0;
 i22 = HEAP32[i29 >> 2] | 0;
 i5 = HEAP32[i21 + (i22 * 12 | 0) >> 2] | 0;
 i7 = HEAP32[i21 + (i22 * 12 | 0) + 4 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i21 + (i22 * 12 | 0) + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i28 + 168 >> 2]);
 f31 = Math_fround(HEAPF32[i28 + 172 >> 2]);
 f32 = Math_fround(HEAPF32[i28 + 176 >> 2]);
 f33 = Math_fround(HEAPF32[i28 + 180 >> 2]);
 if (!(HEAP8[i28 + 137 >> 0] | 0)) {
  i1 = i5;
  i5 = i7;
 } else if ((HEAP32[i28 + 140 >> 2] | 0) == 3) {
  i1 = i5;
  i5 = i7;
 } else {
  f14 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = Math_fround(f14 - f10);
  f24 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f24 - f11);
  f23 = Math_fround(HEAPF32[i28 + 184 >> 2]);
  f12 = Math_fround(f12 * f23);
  f26 = Math_fround(HEAPF32[i28 + 188 >> 2]);
  f39 = Math_fround(f12 + Math_fround(f39 * f26));
  f12 = Math_fround(HEAPF32[i28 + 212 >> 2]);
  f39 = Math_fround(f39 + Math_fround(f3 * f12));
  f13 = Math_fround(HEAPF32[i28 + 208 >> 2]);
  f39 = Math_fround(f39 - Math_fround(f2 * f13));
  f25 = Math_fround(HEAPF32[i28 + 252 >> 2]);
  f39 = Math_fround(f25 * Math_fround(Math_fround(HEAPF32[i28 + 132 >> 2]) - f39));
  i4 = i28 + 116 | 0;
  f25 = Math_fround(HEAPF32[i4 >> 2]);
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i28 + 128 >> 2]));
  f39 = Math_fround(f25 + f39);
  f8 = Math_fround(-f9);
  f9 = f39 < f9 ? f39 : f9;
  f9 = f9 < f8 ? f8 : f9;
  HEAPF32[i4 >> 2] = f9;
  f25 = Math_fround(f9 - f25);
  f23 = Math_fround(f23 * f25);
  f26 = Math_fround(f26 * f25);
  f13 = Math_fround(f13 * f25);
  f25 = Math_fround(f12 * f25);
  f12 = Math_fround(f30 * f26);
  f10 = Math_fround(f10 - Math_fround(f30 * f23));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f12 = Math_fround(f11 - f12);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  f2 = Math_fround(f2 - Math_fround(f32 * f13));
  f26 = Math_fround(f31 * f26);
  f23 = Math_fround(f14 + Math_fround(f31 * f23));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(f24 + f26);
  f3 = Math_fround(f3 + Math_fround(f33 * f25));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f26 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f26 - f25);
 f24 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f24 - f23);
 i18 = i28 + 192 | 0;
 f10 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 i19 = i28 + 196 | 0;
 f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i19 >> 2])));
 i20 = i28 + 204 | 0;
 f10 = Math_fround(f10 + Math_fround(f3 * Math_fround(HEAPF32[i20 >> 2])));
 i21 = i28 + 200 | 0;
 f10 = Math_fround(f10 - Math_fround(f2 * Math_fround(HEAPF32[i21 >> 2])));
 f11 = Math_fround(f3 - f2);
 if (HEAP8[i28 + 136 >> 0] | 0) {
  i16 = i28 + 140 | 0;
  if (HEAP32[i16 >> 2] | 0) {
   i22 = i28 + 184 | 0;
   f12 = Math_fround(f9 * Math_fround(HEAPF32[i22 >> 2]));
   i17 = i28 + 188 | 0;
   f8 = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i17 >> 2])));
   i6 = i28 + 212 | 0;
   f8 = Math_fround(f8 + Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2])));
   i7 = i28 + 208 | 0;
   f8 = Math_fround(f8 - Math_fround(f2 * Math_fround(HEAPF32[i7 >> 2])));
   f12 = Math_fround(HEAPF32[i28 + 104 >> 2]);
   i4 = i28 + 108 | 0;
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i28 + 112 | 0;
   f14 = Math_fround(HEAPF32[i5 >> 2]);
   i15 = i28 + 216 | 0;
   f10 = Math_fround(-f10);
   f9 = Math_fround(-f11);
   f8 = Math_fround(-f8);
   HEAPF32[i34 >> 2] = f10;
   HEAPF32[i34 + 4 >> 2] = f9;
   HEAPF32[i34 + 8 >> 2] = f8;
   __ZNK7b2Mat337Solve33ERK6b2Vec3(i27, i15, i34);
   f8 = Math_fround(HEAPF32[i27 >> 2]);
   i1 = i28 + 104 | 0;
   HEAPF32[i1 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i1 >> 2]));
   f8 = Math_fround(HEAPF32[i27 + 4 >> 2]);
   HEAPF32[i4 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i4 >> 2]));
   f8 = Math_fround(HEAPF32[i27 + 8 >> 2]);
   f8 = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
   HEAPF32[i5 >> 2] = f8;
   switch (HEAP32[i16 >> 2] | 0) {
   case 1:
    {
     i27 = f8 > Math_fround(0.0);
     f8 = i27 ? f8 : Math_fround(0.0);
     HEAPF32[i5 >> 2] = f8;
     break;
    }
   case 2:
    {
     i27 = f8 < Math_fround(0.0);
     f8 = i27 ? f8 : Math_fround(0.0);
     HEAPF32[i5 >> 2] = f8;
     break;
    }
   default:
    {}
   }
   f39 = Math_fround(f8 - f14);
   f8 = Math_fround(HEAPF32[i28 + 240 >> 2]);
   f11 = Math_fround(f9 - Math_fround(f39 * Math_fround(HEAPF32[i28 + 244 >> 2])));
   HEAPF32[i34 >> 2] = Math_fround(f10 - Math_fround(f8 * f39));
   HEAPF32[i34 + 4 >> 2] = f11;
   __ZNK7b2Mat337Solve22ERK6b2Vec2(i35, i15, i34);
   f11 = Math_fround(f12 + Math_fround(HEAPF32[i35 >> 2]));
   f39 = Math_fround(f13 + Math_fround(HEAPF32[i35 + 4 >> 2]));
   HEAPF32[i1 >> 2] = f11;
   HEAPF32[i4 >> 2] = f39;
   f11 = Math_fround(f11 - f12);
   f12 = Math_fround(f39 - f13);
   f39 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f14);
   f14 = Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2]));
   f13 = Math_fround(f11 * Math_fround(HEAPF32[i19 >> 2]));
   f10 = Math_fround(f39 * Math_fround(HEAPF32[i22 >> 2]));
   f10 = Math_fround(f14 + f10);
   f13 = Math_fround(f13 + Math_fround(f39 * Math_fround(HEAPF32[i17 >> 2])));
   f14 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2])) + f12);
   f14 = Math_fround(f14 + Math_fround(f39 * Math_fround(HEAPF32[i7 >> 2])));
   f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i20 >> 2])));
   f39 = Math_fround(f11 + Math_fround(f39 * Math_fround(HEAPF32[i6 >> 2])));
   f11 = Math_fround(f30 * f13);
   f12 = Math_fround(f30 * f10);
   f13 = Math_fround(f31 * f13);
   f30 = Math_fround(f31 * f10);
   f23 = Math_fround(f23 - f11);
   f25 = Math_fround(f25 - f12);
   f31 = Math_fround(f24 + f13);
   f30 = Math_fround(f26 + f30);
   f32 = Math_fround(f32 * f14);
   f39 = Math_fround(f33 * f39);
   f33 = Math_fround(f2 - f32);
   f39 = Math_fround(f3 + f39);
   i35 = HEAP32[i36 >> 2] | 0;
   i34 = HEAP32[i37 >> 2] | 0;
   i28 = i34 + (i35 * 12 | 0) | 0;
   HEAPF32[i28 >> 2] = f25;
   i35 = i34 + (i35 * 12 | 0) + 4 | 0;
   HEAPF32[i35 >> 2] = f23;
   i36 = HEAP32[i36 >> 2] | 0;
   i35 = HEAP32[i37 >> 2] | 0;
   i36 = i35 + (i36 * 12 | 0) + 8 | 0;
   HEAPF32[i36 >> 2] = f33;
   i36 = HEAP32[i29 >> 2] | 0;
   i34 = i35 + (i36 * 12 | 0) | 0;
   HEAPF32[i34 >> 2] = f30;
   i36 = i35 + (i36 * 12 | 0) + 4 | 0;
   HEAPF32[i36 >> 2] = f31;
   i36 = HEAP32[i29 >> 2] | 0;
   i37 = HEAP32[i37 >> 2] | 0;
   i37 = i37 + (i36 * 12 | 0) + 8 | 0;
   HEAPF32[i37 >> 2] = f39;
   STACKTOP = i38;
   return;
  }
 }
 f39 = Math_fround(-f11);
 HEAPF32[i34 >> 2] = Math_fround(-f10);
 HEAPF32[i34 + 4 >> 2] = f39;
 __ZNK7b2Mat337Solve22ERK6b2Vec2(i27, i28 + 216 | 0, i34);
 f39 = Math_fround(HEAPF32[i27 >> 2]);
 i35 = i28 + 104 | 0;
 HEAPF32[i35 >> 2] = Math_fround(f39 + Math_fround(HEAPF32[i35 >> 2]));
 f11 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 i35 = i28 + 108 | 0;
 HEAPF32[i35 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i35 >> 2]));
 f10 = Math_fround(f39 * Math_fround(HEAPF32[i18 >> 2]));
 f13 = Math_fround(f39 * Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(Math_fround(f39 * Math_fround(HEAPF32[i21 >> 2])) + f11);
 f39 = Math_fround(f11 + Math_fround(f39 * Math_fround(HEAPF32[i20 >> 2])));
 f11 = Math_fround(f30 * f13);
 f12 = Math_fround(f30 * f10);
 f13 = Math_fround(f31 * f13);
 f30 = Math_fround(f31 * f10);
 f23 = Math_fround(f23 - f11);
 f25 = Math_fround(f25 - f12);
 f31 = Math_fround(f24 + f13);
 f30 = Math_fround(f26 + f30);
 f32 = Math_fround(f32 * f14);
 f39 = Math_fround(f33 * f39);
 f33 = Math_fround(f2 - f32);
 f39 = Math_fround(f3 + f39);
 i35 = HEAP32[i36 >> 2] | 0;
 i34 = HEAP32[i37 >> 2] | 0;
 i28 = i34 + (i35 * 12 | 0) | 0;
 HEAPF32[i28 >> 2] = f25;
 i35 = i34 + (i35 * 12 | 0) + 4 | 0;
 HEAPF32[i35 >> 2] = f23;
 i36 = HEAP32[i36 >> 2] | 0;
 i35 = HEAP32[i37 >> 2] | 0;
 i36 = i35 + (i36 * 12 | 0) + 8 | 0;
 HEAPF32[i36 >> 2] = f33;
 i36 = HEAP32[i29 >> 2] | 0;
 i34 = i35 + (i36 * 12 | 0) | 0;
 HEAPF32[i34 >> 2] = f30;
 i36 = i35 + (i36 * 12 | 0) + 4 | 0;
 HEAPF32[i36 >> 2] = f31;
 i36 = HEAP32[i29 >> 2] | 0;
 i37 = HEAP32[i37 >> 2] | 0;
 i37 = i37 + (i36 * 12 | 0) + 8 | 0;
 HEAPF32[i37 >> 2] = f39;
 STACKTOP = i38;
 return;
}

function __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf(i28, i14, i16, i31, i6, i27, i19, i29, i30) {
 i28 = i28 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i31 = i31 | 0;
 i6 = i6 | 0;
 i27 = i27 | 0;
 i19 = i19 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f15 = f0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i32 = 0, i33 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i32;
 i22 = i31 + (i14 << 2) | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 i24 = i27 + (i14 << 2) | 0;
 f13 = Math_fround(HEAPF32[i24 >> 2]);
 i8 = i7 + (i14 << 2) | 0;
 HEAPF32[i8 >> 2] = Math_fround(f20 + f13);
 i25 = i31 + (i16 << 2) | 0;
 f20 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i27 + (i16 << 2) | 0;
 f15 = Math_fround(HEAPF32[i26 >> 2]);
 f20 = Math_fround(f20 + f15);
 HEAPF32[i7 + (i16 << 2) >> 2] = f20;
 i7 = i6 + (i28 << 2) | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f21 = Math_fround(HEAPF32[i8 >> 2]);
 f12 = Math_fround(f1 * f21);
 i8 = i6 + (i14 << 2) | 0;
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i19 + (i28 << 2) | 0;
 f23 = Math_fround(HEAPF32[i9 >> 2]);
 i33 = !(f12 >= Math_fround(f17 * f23));
 f12 = Math_fround(f1 * f20);
 i6 = i6 + (i16 << 2) | 0;
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 i10 = f12 >= Math_fround(f23 * f18);
 if (!i33) {
  if (i10) {
   if (!i29) {
    STACKTOP = i32;
    return;
   }
   HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
   f23 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i7 >> 2]));
   f21 = Math_fround(HEAPF32[i8 >> 2]);
   f21 = Math_fround(f23 * Math_fround(f21 * Math_fround(HEAPF32[i9 >> 2])));
   HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f21);
   f21 = Math_fround(HEAPF32[i6 >> 2]);
   f21 = Math_fround(f23 * Math_fround(f21 * Math_fround(HEAPF32[i9 >> 2])));
   HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f21);
   HEAPF32[i29 >> 2] = Math_fround(-Math_fround(f23 * Math_fround(HEAPF32[i9 >> 2])));
   STACKTOP = i32;
   return;
  }
  f5 = Math_fround(Math_fround(f1 * f1) + Math_fround(f18 * f18));
  f4 = Math_fround(f1 * f23);
  f3 = Math_fround(f20 * f18);
  f1 = Math_fround(Math_fround(f21 * f5) - Math_fround(f17 * Math_fround(f4 + f3)));
  if (!(f1 <= Math_fround(Math_fround(f5 * Math_fround(2.0)) * f13))) {
   f1 = Math_fround(Math_fround(f17 * f17) + f5);
   f18 = Math_fround(HEAPF32[i19 + (i14 << 2) >> 2]);
   f21 = Math_fround(f3 + Math_fround(f4 + Math_fround(f17 * f18)));
   f1 = Math_fround(Math_fround(-f21) / f1);
   f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f23 * f23) + Math_fround(f18 * f18))) + Math_fround(f1 * f21));
   HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
   if (!i29) {
    STACKTOP = i32;
    return;
   }
   HEAPF32[i29 >> 2] = f1;
   HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
   HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
   HEAPF32[i25 >> 2] = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
   STACKTOP = i32;
   return;
  } else {
   f2 = Math_fround(f1 / f5);
   f18 = Math_fround(f21 - f2);
   f21 = Math_fround(f3 + Math_fround(f4 + Math_fround(f17 * f18)));
   f1 = Math_fround(Math_fround(-f21) / Math_fround(Math_fround(f17 * f17) + f5));
   f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f23 * f23) + Math_fround(f18 * f18))) + Math_fround(f1 * f21));
   HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
   if (!i29) {
    STACKTOP = i32;
    return;
   }
   HEAPF32[i29 >> 2] = f1;
   HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
   HEAPF32[i22 >> 2] = Math_fround(f2 - Math_fround(HEAPF32[i24 >> 2]));
   HEAPF32[i25 >> 2] = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
   STACKTOP = i32;
   return;
  }
 }
 f2 = Math_fround(f1 * f1);
 if (i10) {
  f4 = Math_fround(f2 + Math_fround(f17 * f17));
  f3 = Math_fround(Math_fround(f21 * f17) + Math_fround(f1 * f23));
  f1 = Math_fround(Math_fround(f20 * f4) - Math_fround(f18 * f3));
  if (!(f1 <= Math_fround(Math_fround(f4 * Math_fround(2.0)) * f15))) {
   f1 = Math_fround(f4 + Math_fround(f18 * f18));
   f17 = Math_fround(HEAPF32[i19 + (i16 << 2) >> 2]);
   f20 = Math_fround(f3 + Math_fround(f18 * f17));
   f1 = Math_fround(Math_fround(-f20) / f1);
   f23 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(f17 * f17)) + Math_fround(f1 * f20));
   HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
   if (!i29) {
    STACKTOP = i32;
    return;
   }
   HEAPF32[i29 >> 2] = f1;
   HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
   HEAPF32[i22 >> 2] = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
   HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
   STACKTOP = i32;
   return;
  } else {
   f2 = Math_fround(f1 / f4);
   f17 = Math_fround(f20 - f2);
   f20 = Math_fround(f3 + Math_fround(f18 * f17));
   f1 = Math_fround(Math_fround(-f20) / Math_fround(f4 + Math_fround(f18 * f18)));
   f23 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(f17 * f17)) + Math_fround(f1 * f20));
   HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
   if (!i29) {
    STACKTOP = i32;
    return;
   }
   HEAPF32[i29 >> 2] = f1;
   HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
   HEAPF32[i22 >> 2] = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
   HEAPF32[i25 >> 2] = Math_fround(f2 - Math_fround(HEAPF32[i26 >> 2]));
   STACKTOP = i32;
   return;
  }
 }
 f12 = Math_fround(f18 * f18);
 f3 = Math_fround(f2 + f12);
 f5 = Math_fround(f1 * f23);
 f11 = Math_fround(f20 * f18);
 f1 = Math_fround(Math_fround(f21 * f3) - Math_fround(f17 * Math_fround(f5 + f11)));
 if (f1 >= Math_fround(0.0)) if (!(f1 <= Math_fround(Math_fround(f3 * Math_fround(2.0)) * f13))) {
  f1 = Math_fround(Math_fround(f17 * f17) + f3);
  f18 = Math_fround(HEAPF32[i19 + (i14 << 2) >> 2]);
  f21 = Math_fround(f11 + Math_fround(f5 + Math_fround(f17 * f18)));
  f1 = Math_fround(Math_fround(-f21) / f1);
  f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f23 * f23) + Math_fround(f18 * f18))) + Math_fround(f1 * f21));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
  if (!i29) {
   STACKTOP = i32;
   return;
  }
  HEAPF32[i29 >> 2] = f1;
  HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
  HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
  HEAPF32[i25 >> 2] = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
  STACKTOP = i32;
  return;
 } else {
  f2 = Math_fround(f1 / f3);
  f18 = Math_fround(f21 - f2);
  f21 = Math_fround(f11 + Math_fround(f5 + Math_fround(f17 * f18)));
  f1 = Math_fround(Math_fround(-f21) / Math_fround(Math_fround(f17 * f17) + f3));
  f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f23 * f23) + Math_fround(f18 * f18))) + Math_fround(f1 * f21));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
  if (!i29) {
   STACKTOP = i32;
   return;
  }
  HEAPF32[i29 >> 2] = f1;
  HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
  HEAPF32[i22 >> 2] = Math_fround(f2 - Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i25 >> 2] = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
  STACKTOP = i32;
  return;
 }
 f4 = Math_fround(f2 + Math_fround(f17 * f17));
 f3 = Math_fround(Math_fround(f21 * f17) + f5);
 f1 = Math_fround(Math_fround(f20 * f4) - Math_fround(f18 * f3));
 if (!(f1 >= Math_fround(0.0))) {
  f18 = Math_fround(f3 + f11);
  f1 = Math_fround(Math_fround(-f18) / Math_fround(f4 + f12));
  f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23))) + Math_fround(f18 * f1));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
  if (!i29) {
   STACKTOP = i32;
   return;
  }
  HEAPF32[i29 >> 2] = f1;
  HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
  HEAPF32[i22 >> 2] = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i25 >> 2] = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
  STACKTOP = i32;
  return;
 }
 if (!(f1 <= Math_fround(Math_fround(f4 * Math_fround(2.0)) * f15))) {
  f1 = Math_fround(f4 + f12);
  f17 = Math_fround(HEAPF32[i19 + (i16 << 2) >> 2]);
  f20 = Math_fround(f3 + Math_fround(f18 * f17));
  f1 = Math_fround(Math_fround(-f20) / f1);
  f23 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(f17 * f17)) + Math_fround(f1 * f20));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
  if (!i29) {
   STACKTOP = i32;
   return;
  }
  HEAPF32[i29 >> 2] = f1;
  HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
  HEAPF32[i22 >> 2] = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  STACKTOP = i32;
  return;
 } else {
  f2 = Math_fround(f1 / f4);
  f17 = Math_fround(f20 - f2);
  f20 = Math_fround(f3 + Math_fround(f18 * f17));
  f1 = Math_fround(Math_fround(-f20) / Math_fround(f4 + f12));
  f23 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f23 * f23)) + Math_fround(f17 * f17)) + Math_fround(f1 * f20));
  HEAPF32[i30 >> 2] = Math_fround(Math_fround(HEAPF32[i30 >> 2]) + f23);
  if (!i29) {
   STACKTOP = i32;
   return;
  }
  HEAPF32[i29 >> 2] = f1;
  HEAP32[i31 + (i28 << 2) >> 2] = HEAP32[i27 + (i28 << 2) >> 2];
  HEAPF32[i22 >> 2] = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i25 >> 2] = Math_fround(f2 - Math_fround(HEAPF32[i26 >> 2]));
  STACKTOP = i32;
  return;
 }
}

function __Z31createFinalizeContacts_ParallelN5physx14PxFrictionType4EnumEPNS_17PxcSolverBodyDataERNS_16PxsThreadContextEffffPNS_10PxsContextEPijj(i65, i73, i3, f62, f67, f57, f64, i2, i75, i4, i63) {
 i65 = i65 | 0;
 i73 = i73 | 0;
 i3 = i3 | 0;
 f62 = Math_fround(f62);
 f67 = Math_fround(f67);
 f57 = Math_fround(f57);
 f64 = Math_fround(f64);
 i2 = i2 | 0;
 i75 = i75 | 0;
 i4 = i4 | 0;
 i63 = i63 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i66 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i74 = 0, i76 = 0;
 i76 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i76 + 352 | 0;
 i60 = i76 + 128 | 0;
 i69 = i76 + 112 | 0;
 i70 = i76 + 96 | 0;
 i71 = i76 + 80 | 0;
 i72 = i76 + 64 | 0;
 i58 = i76 + 48 | 0;
 i59 = i76 + 32 | 0;
 i66 = i76;
 i61 = i76 + 144 | 0;
 i55 = HEAP32[i3 + 8928 >> 2] | 0;
 i56 = HEAP32[i3 + 8940 >> 2] | 0;
 i74 = i2 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i74 >> 2] | 0) | 0;
 if (!i1) {
  i54 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i53 = HEAP32[(HEAP32[i54 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i53 | 0, i54 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i54 = i1 + 19 & -16;
   HEAP32[i54 + -4 >> 2] = i54 - i1;
   i1 = i54;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
  i54 = i1;
 } else i54 = i1;
 i26 = i54 + 16 | 0;
 i27 = i54 + 332 | 0;
 HEAP32[i54 + 336 >> 2] = 0;
 HEAP32[i54 + 340 >> 2] = 0;
 if (i4 >>> 0 >= i63 >>> 0) {
  i73 = 0;
  i74 = HEAP32[i74 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i74, i54);
  __ZN5physx6shdfnd9atomicAddEPVii(i75, i73) | 0;
  STACKTOP = i76;
  return i73 | 0;
 }
 i28 = i68 + 4 | 0;
 i29 = i68 + 8 | 0;
 i30 = i68 + 12 | 0;
 i31 = i60 + 4 | 0;
 i32 = i60 + 8 | 0;
 i33 = i60 + 12 | 0;
 i34 = i69 + 4 | 0;
 i35 = i69 + 8 | 0;
 i36 = i69 + 12 | 0;
 i37 = i70 + 4 | 0;
 i38 = i70 + 8 | 0;
 i39 = i70 + 12 | 0;
 i40 = i71 + 4 | 0;
 i41 = i71 + 8 | 0;
 i42 = i71 + 12 | 0;
 i43 = i72 + 4 | 0;
 i44 = i72 + 8 | 0;
 i45 = i72 + 12 | 0;
 i46 = i58 + 4 | 0;
 i47 = i58 + 8 | 0;
 i48 = i58 + 12 | 0;
 i49 = i59 + 4 | 0;
 i50 = i59 + 8 | 0;
 i51 = i59 + 12 | 0;
 i52 = gb + 106268 + (i65 << 2) | 0;
 i53 = i3 + 8788 | 0;
 i18 = i3 + 316 | 0;
 i19 = gb + 106280 + (i65 << 2) | 0;
 i20 = i66 + 4 | 0;
 i21 = i66 + 8 | 0;
 i22 = i66 + 12 | 0;
 i23 = i66 + 16 | 0;
 i24 = i66 + 20 | 0;
 i25 = i66 + 24 | 0;
 i1 = 0;
 do {
  i17 = i56 + (i4 << 3) | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i3 = i55 + (i15 << 5) | 0;
  L12 : do switch (HEAP16[i55 + (i15 << 5) + 26 >> 1] | 0) {
  case 1:
   {
    i11 = i56 + (i4 << 3) + 4 | 0;
    i2 = HEAP16[i11 >> 1] | 0;
    if (i2 << 16 >> 16 == 4) {
     i8 = i15 + 1 | 0;
     i5 = i55 + (i8 << 5) | 0;
     i9 = i15 + 2 | 0;
     i6 = i55 + (i9 << 5) | 0;
     i10 = i15 + 3 | 0;
     i7 = i55 + (i10 << 5) | 0;
     i13 = HEAP32[i55 + (i15 << 5) + 16 >> 2] | 0;
     i14 = HEAP32[i55 + (i8 << 5) + 16 >> 2] | 0;
     i16 = HEAP32[i55 + (i9 << 5) + 16 >> 2] | 0;
     i12 = HEAP32[i55 + (i10 << 5) + 16 >> 2] | 0;
     HEAP32[i68 >> 2] = i13 + 16;
     HEAP32[i28 >> 2] = i14 + 16;
     HEAP32[i29 >> 2] = i16 + 16;
     HEAP32[i30 >> 2] = i12 + 16;
     HEAP32[i60 >> 2] = i3;
     HEAP32[i31 >> 2] = i5;
     HEAP32[i32 >> 2] = i6;
     HEAP32[i33 >> 2] = i7;
     HEAP32[i69 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i34 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i36 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i70 >> 2] = HEAP32[i55 + (i15 << 5) + 4 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i55 + (i8 << 5) + 4 >> 2];
     HEAP32[i38 >> 2] = HEAP32[i55 + (i9 << 5) + 4 >> 2];
     HEAP32[i39 >> 2] = HEAP32[i55 + (i10 << 5) + 4 >> 2];
     HEAP32[i71 >> 2] = i73 + (HEAPU16[i55 + (i15 << 5) + 10 >> 1] << 6);
     HEAP32[i40 >> 2] = i73 + (HEAPU16[i55 + (i8 << 5) + 10 >> 1] << 6);
     HEAP32[i41 >> 2] = i73 + (HEAPU16[i55 + (i9 << 5) + 10 >> 1] << 6);
     HEAP32[i42 >> 2] = i73 + (HEAPU16[i55 + (i10 << 5) + 10 >> 1] << 6);
     HEAP32[i72 >> 2] = i73 + (HEAPU16[i55 + (i15 << 5) + 14 >> 1] << 6);
     HEAP32[i43 >> 2] = i73 + (HEAPU16[i55 + (i8 << 5) + 14 >> 1] << 6);
     HEAP32[i44 >> 2] = i73 + (HEAPU16[i55 + (i9 << 5) + 14 >> 1] << 6);
     HEAP32[i45 >> 2] = i73 + (HEAPU16[i55 + (i10 << 5) + 14 >> 1] << 6);
     HEAP32[i58 >> 2] = HEAP32[i13 + 80 >> 2];
     HEAP32[i46 >> 2] = HEAP32[i14 + 80 >> 2];
     HEAP32[i47 >> 2] = HEAP32[i16 + 80 >> 2];
     HEAP32[i48 >> 2] = HEAP32[i12 + 80 >> 2];
     HEAP32[i59 >> 2] = HEAP32[i13 + 84 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i14 + 84 >> 2];
     HEAP32[i50 >> 2] = HEAP32[i16 + 84 >> 2];
     HEAP32[i51 >> 2] = HEAP32[(HEAP32[i30 >> 2] | 0) + 68 >> 2];
     if ((mftCall_iiiiiiiiiiffffii(HEAP32[i52 >> 2] | 0, i68 | 0, i26 | 0, i60 | 0, i69 | 0, i70 | 0, i71 | 0, i72 | 0, i58 | 0, i59 | 0, +f67, +f57, +f64, +Math_fround(HEAPF32[i53 >> 2]), i18 | 0, i65 | 0) | 0) == 2) break L12;
     i2 = HEAP16[i11 >> 1] | 0;
    }
    if (i2 << 16 >> 16) {
     i10 = 0;
     do {
      i8 = (HEAP32[i17 >> 2] | 0) + i10 | 0;
      i2 = i55 + (i8 << 5) | 0;
      i3 = i55 + (i8 << 5) + 16 | 0;
      i9 = HEAP32[i3 >> 2] | 0;
      i5 = i9 + 16 | 0;
      if ((HEAP16[i55 + (i8 << 5) + 8 >> 1] | 0) == -1) i6 = i73 + (HEAPU16[i55 + (i8 << 5) + 10 >> 1] << 6) | 0; else i6 = i73;
      if ((HEAP16[i55 + (i8 << 5) + 12 >> 1] | 0) == -1) i7 = i73 + (HEAPU16[i55 + (i8 << 5) + 14 >> 1] << 6) | 0; else i7 = i73;
      mftCall_iiiiiiiiiiiiffffii(HEAP32[i19 >> 2] | 0, i5 | 0, i26 | 0, 0, 0, i2 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i55 + (i8 << 5) + 4 >> 2] | 0, i6 | 0, i7 | 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0, +f67, +f57, +f64, +Math_fround(HEAPF32[i53 >> 2]), i18 | 0, i65 | 0) | 0;
      HEAP16[i55 + (i8 << 5) + 26 >> 1] = (HEAP32[i9 + 20 >> 2] | 0) >>> 4;
      HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
      if (!(HEAP16[i9 + 114 >> 1] & 16)) {
       i2 = 0;
       i3 = 0;
      } else {
       i2 = (HEAP32[i9 + 44 >> 2] | 0) + ((HEAP32[i9 + 48 >> 2] | 0) + 15 & -16) | 0;
       i3 = HEAP16[i9 + 36 >> 1] | 0;
      }
      HEAP32[i55 + (i8 << 5) + 20 >> 2] = i2;
      HEAP16[i55 + (i8 << 5) + 24 >> 1] = i3;
      i1 = (HEAPU16[i9 + 32 >> 1] | 0) + i1 | 0;
      i10 = i10 + 1 | 0;
     } while (i10 >>> 0 < (HEAPU16[i11 >> 1] | 0) >>> 0);
    }
    break;
   }
  case 2:
   {
    i16 = i56 + (i4 << 3) + 4 | 0;
    i2 = HEAP16[i16 >> 1] | 0;
    if (i2 << 16 >> 16 == 4) {
     HEAPF32[i66 >> 2] = Math_fround(0.0);
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     HEAPF32[i22 >> 2] = Math_fround(1.0);
     HEAPF32[i23 >> 2] = Math_fround(0.0);
     HEAPF32[i24 >> 2] = Math_fround(0.0);
     HEAPF32[i25 >> 2] = Math_fround(0.0);
     i14 = 0;
     do {
      i8 = i15 + i14 | 0;
      i10 = i55 + (i8 << 5) | 0;
      i11 = HEAP32[i55 + (i8 << 5) + 16 >> 2] | 0;
      i12 = HEAP32[i11 + 16 >> 2] | 0;
      i13 = HEAP32[i11 + 12 >> 2] | 0;
      i2 = HEAP32[i11 + 36 >> 2] | 0;
      if (!i2) i9 = i66; else i9 = HEAP32[i2 + 64 >> 2] | 0;
      i2 = HEAP32[i11 + 40 >> 2] | 0;
      if (!i2) i7 = i66; else i7 = HEAP32[i2 + 64 >> 2] | 0;
      i3 = HEAP32[i10 >> 2] | 0;
      i5 = HEAP32[i55 + (i8 << 5) + 4 >> 2] | 0;
      if ((HEAP16[i55 + (i8 << 5) + 8 >> 1] | 0) == -1) i6 = HEAPU16[i55 + (i8 << 5) + 10 >> 1] | 0; else i6 = 0;
      if ((HEAP16[i55 + (i8 << 5) + 12 >> 1] | 0) == -1) i2 = HEAPU16[i55 + (i8 << 5) + 14 >> 1] | 0; else i2 = 0;
      HEAP32[i61 + (i14 * 52 | 0) + 32 >> 2] = HEAP32[i11 + 28 >> 2];
      HEAP32[i61 + (i14 * 52 | 0) + 36 >> 2] = i13;
      HEAP32[i61 + (i14 * 52 | 0) >> 2] = i11;
      HEAP32[i61 + (i14 * 52 | 0) + 40 >> 2] = i10;
      HEAP32[i61 + (i14 * 52 | 0) + 4 >> 2] = i9;
      HEAP32[i61 + (i14 * 52 | 0) + 8 >> 2] = i7;
      HEAP32[i61 + (i14 * 52 | 0) + 20 >> 2] = i73 + (i6 << 6);
      HEAP32[i61 + (i14 * 52 | 0) + 24 >> 2] = i73 + (i2 << 6);
      HEAP32[i61 + (i14 * 52 | 0) + 12 >> 2] = i3;
      HEAP32[i61 + (i14 * 52 | 0) + 16 >> 2] = i5;
      HEAP32[i61 + (i14 * 52 | 0) + 28 >> 2] = i12;
      i14 = i14 + 1 | 0;
     } while ((i14 | 0) != 4);
     if ((__ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i61, f62, f67, i27, i18) | 0) == 2) break L12;
     i2 = HEAP16[i16 >> 1] | 0;
    }
    if (i2 << 16 >> 16) {
     i2 = 0;
     do {
      i15 = (HEAP32[i17 >> 2] | 0) + i2 | 0;
      i1 = (__ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(HEAP32[i55 + (i15 << 5) + 16 >> 2] | 0, i73, i27, f62, f67, i55 + (i15 << 5) | 0, i18) | 0) + i1 | 0;
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < (HEAPU16[i16 >> 1] | 0) >>> 0);
    }
    break;
   }
  default:
   {}
  } while (0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i63 | 0));
 i74 = HEAP32[i74 >> 2] | 0;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i74, i54);
 __ZN5physx6shdfnd9atomicAddEPVii(i75, i1) | 0;
 STACKTOP = i76;
 return i1 | 0;
}

function __ZN9InputAxis18GetDescriptiveNameEb(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i8 = i11;
 if (i2) {
  i3 = i7 + 40 | 0;
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  if (i5) i2 = HEAP32[i7 + 44 >> 2] | 0; else i2 = i4 & 255;
  if (i2 | 0) {
   i6 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
   i3 = i5 ? HEAP32[i7 + 44 >> 2] | 0 : i4 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = 9;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i3;
    if (i3) i10 = 11;
   } else i10 = 9;
   if ((i10 | 0) == 9) {
    i8 = i3 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i2;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 8 >> 2] = i8 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i3;
    i1 = i9;
    i10 = 11;
   }
   if ((i10 | 0) == 11) _memcpy(i1 | 0, i6 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   STACKTOP = i11;
   return;
  }
  i3 = i7 + 24 | 0;
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i7 + 28 >> 2] | 0; else i2 = i2 & 255;
  if (!i2) {
   __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i8, i7 + 4 | 0, gb + 441157 | 0);
   i4 = i8 + 11 | 0;
   i5 = HEAP8[i4 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
   i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = 29;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (i5) i10 = 31;
   } else i10 = 29;
   if ((i10 | 0) == 29) {
    i6 = i5 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i2;
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i5;
    i1 = i7;
    i10 = 31;
   }
   if ((i10 | 0) == 31) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i10 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i9);
   }
   STACKTOP = i11;
   return;
  } else {
   __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i8, i3, gb + 441157 | 0);
   i4 = i8 + 11 | 0;
   i5 = HEAP8[i4 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
   i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = 20;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (i5) i10 = 22;
   } else i10 = 20;
   if ((i10 | 0) == 20) {
    i6 = i5 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i2;
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i5;
    i1 = i7;
    i10 = 22;
   }
   if ((i10 | 0) == 22) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i10 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i9);
   }
   STACKTOP = i11;
   return;
  }
 }
 i4 = i7 + 24 | 0;
 i5 = HEAP8[i4 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 if (i6) i2 = HEAP32[i7 + 28 >> 2] | 0; else i2 = i5 & 255;
 i3 = (HEAP32[i7 + 60 >> 2] | 0) != 0;
 if (!i2) {
  if (!i3) {
   i3 = i7 + 4 | 0;
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i2 ? HEAP32[i7 + 8 >> 2] | 0 : i4 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = 73;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i4;
    if (i4) i10 = 75;
   } else i10 = 73;
   if ((i10 | 0) == 73) {
    i8 = i4 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i2;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 8 >> 2] = i8 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i9;
    i10 = 75;
   }
   if ((i10 | 0) == 75) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   STACKTOP = i11;
   return;
  }
  __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i8, i7 + 4 | 0, gb + 441162 | 0);
  i4 = i8 + 11 | 0;
  i5 = HEAP8[i4 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i10 = 64;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i10 = 66;
  } else i10 = 64;
  if ((i10 | 0) == 64) {
   i6 = i5 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i2;
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i7;
   i10 = 66;
  }
  if ((i10 | 0) == 66) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i10 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i9);
  }
  STACKTOP = i11;
  return;
 }
 if (i3) {
  i2 = HEAP8[i7 + 40 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i7 + 44 >> 2] | 0; else i2 = i2 & 255;
  if (!i2) {
   __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i8, i4, gb + 441162 | 0);
   i4 = i8 + 11 | 0;
   i5 = HEAP8[i4 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
   i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i10 = 47;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (i5) i10 = 49;
   } else i10 = 47;
   if ((i10 | 0) == 47) {
    i6 = i5 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i2;
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i5;
    i1 = i7;
    i10 = 49;
   }
   if ((i10 | 0) == 49) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i10 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i9);
   }
   STACKTOP = i11;
   return;
  }
 }
 i4 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i6 ? HEAP32[i7 + 28 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i10 = 56;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (i3) i10 = 58;
 } else i10 = 56;
 if ((i10 | 0) == 56) {
  i8 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i9;
  i10 = 58;
 }
 if ((i10 | 0) == 58) _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 64 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZL21PxcFindSeparatingAxesRN5physx2Gu14SeparatingAxesEPKjjRKNS0_13PolygonalDataERKNS_2Cm8Matrix34ERKNS_7PxPlaneESB_RKNS_9PxBounds3EfRKNS8_23FastVertex2ShapeScalingE(i77, i1, i2, i74, i75, i76, i79, i73, i72, i69, f70, i78) {
 i77 = i77 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i76 = i76 | 0;
 i79 = i79 | 0;
 i73 = i73 | 0;
 i72 = i72 | 0;
 i69 = i69 | 0;
 f70 = Math_fround(f70);
 i78 = i78 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i71 = 0, i80 = 0, f81 = f0;
 i80 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i71 = i80;
 if (!i2) {
  STACKTOP = i80;
  return;
 }
 i37 = i78 + 4 | 0;
 i48 = i78 + 8 | 0;
 i59 = i78 + 12 | 0;
 i63 = i78 + 16 | 0;
 i64 = i78 + 20 | 0;
 i65 = i78 + 24 | 0;
 i66 = i78 + 28 | 0;
 i67 = i78 + 32 | 0;
 i68 = i73 + 4 | 0;
 i38 = i73 + 8 | 0;
 i39 = i73 + 12 | 0;
 i33 = i69 + 4 | 0;
 i34 = i69 + 8 | 0;
 i35 = i69 + 12 | 0;
 i36 = i69 + 16 | 0;
 i32 = i69 + 20 | 0;
 i40 = i72 + 12 | 0;
 i41 = i72 + 24 | 0;
 i42 = i72 + 36 | 0;
 i43 = i72 + 4 | 0;
 i44 = i40 + 4 | 0;
 i45 = i41 + 4 | 0;
 i46 = i42 + 4 | 0;
 i47 = i72 + 8 | 0;
 i49 = i40 + 8 | 0;
 i50 = i41 + 8 | 0;
 i51 = i42 + 8 | 0;
 i52 = i79 + 4 | 0;
 i53 = i79 + 8 | 0;
 i54 = i79 + 12 | 0;
 i55 = i79 + 16 | 0;
 i56 = i79 + 20 | 0;
 i57 = i79 + 24 | 0;
 i58 = i79 + 28 | 0;
 i60 = i79 + 32 | 0;
 i61 = i71 + 4 | 0;
 i62 = i71 + 8 | 0;
 do {
  i2 = i2 + -1 | 0;
  i28 = HEAP32[i1 >> 2] | 0;
  i1 = i1 + 4 | 0;
  i30 = HEAPU16[i74 + (i28 * 20 | 0) + 16 >> 1] | 0;
  i28 = HEAP8[i74 + (i28 * 20 | 0) + 18 >> 0] | 0;
  i31 = i28 & 255;
  i15 = HEAPU8[i76 + i30 >> 0] | 0;
  f20 = Math_fround(HEAPF32[i75 + (i15 * 12 | 0) >> 2]);
  f14 = Math_fround(HEAPF32[i78 >> 2]);
  f3 = Math_fround(f20 * f14);
  f13 = Math_fround(HEAPF32[i37 >> 2]);
  f10 = Math_fround(f20 * f13);
  f5 = Math_fround(HEAPF32[i48 >> 2]);
  f20 = Math_fround(f20 * f5);
  f29 = Math_fround(HEAPF32[i75 + (i15 * 12 | 0) + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i59 >> 2]);
  f26 = Math_fround(f29 * f6);
  f7 = Math_fround(HEAPF32[i63 >> 2]);
  f27 = Math_fround(f29 * f7);
  f8 = Math_fround(HEAPF32[i64 >> 2]);
  f26 = Math_fround(f3 + f26);
  f27 = Math_fround(f10 + f27);
  f29 = Math_fround(f20 + Math_fround(f29 * f8));
  f20 = Math_fround(HEAPF32[i75 + (i15 * 12 | 0) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i65 >> 2]);
  f3 = Math_fround(f20 * f10);
  f11 = Math_fround(HEAPF32[i66 >> 2]);
  f4 = Math_fround(f20 * f11);
  f12 = Math_fround(HEAPF32[i67 >> 2]);
  f3 = Math_fround(f26 + f3);
  f4 = Math_fround(f27 + f4);
  f20 = Math_fround(f29 + Math_fround(f20 * f12));
  L6 : do if (i28 << 24 >> 24) {
   f25 = Math_fround(HEAPF32[i39 >> 2]);
   f16 = Math_fround(HEAPF32[i73 >> 2]);
   f26 = Math_fround(f3 * f16);
   f17 = Math_fround(HEAPF32[i68 >> 2]);
   f26 = Math_fround(f26 + Math_fround(f4 * f17));
   f27 = Math_fround(HEAPF32[i38 >> 2]);
   f29 = f20;
   f18 = f27;
   f19 = f25;
   i15 = Math_fround(f25 + Math_fround(f26 + Math_fround(f20 * f27))) <= f70;
   i9 = 0;
   while (1) {
    i9 = i9 + 1 | 0;
    i28 = HEAPU8[i76 + ((i9 >>> 0 >= i31 >>> 0 ? 0 : i9) + i30) >> 0] | 0;
    f25 = Math_fround(HEAPF32[i75 + (i28 * 12 | 0) >> 2]);
    f27 = Math_fround(f25 * f14);
    f26 = Math_fround(f25 * f13);
    f25 = Math_fround(f25 * f5);
    f24 = Math_fround(HEAPF32[i75 + (i28 * 12 | 0) + 4 >> 2]);
    f27 = Math_fround(f27 + Math_fround(f24 * f6));
    f26 = Math_fround(f26 + Math_fround(f24 * f7));
    f24 = Math_fround(f25 + Math_fround(f24 * f8));
    f25 = Math_fround(HEAPF32[i75 + (i28 * 12 | 0) + 8 >> 2]);
    f27 = Math_fround(f27 + Math_fround(f25 * f10));
    f26 = Math_fround(f26 + Math_fround(f25 * f11));
    f25 = Math_fround(f24 + Math_fround(f25 * f12));
    i28 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f27 * f16) + Math_fround(f26 * f17)) + Math_fround(f25 * f18))) <= f70;
    if (i15 | i28) {
     f24 = Math_fround(HEAPF32[i69 >> 2]);
     f5 = Math_fround(HEAPF32[i33 >> 2]);
     f12 = Math_fround(HEAPF32[i34 >> 2]);
     f21 = Math_fround(HEAPF32[i35 >> 2]);
     f6 = Math_fround(HEAPF32[i36 >> 2]);
     f11 = Math_fround(HEAPF32[i32 >> 2]);
     f7 = Math_fround(f27 - f3);
     f18 = Math_fround(HEAPF32[i72 >> 2]);
     f19 = Math_fround(f7 * f18);
     f8 = Math_fround(f26 - f4);
     f22 = Math_fround(HEAPF32[i40 >> 2]);
     f19 = Math_fround(f19 + Math_fround(f8 * f22));
     f10 = Math_fround(f25 - f29);
     f23 = Math_fround(HEAPF32[i41 >> 2]);
     f19 = Math_fround(f19 + Math_fround(f10 * f23));
     f20 = Math_fround(f21 - f24);
     f13 = Math_fround(f3 + f27);
     f14 = Math_fround(f4 + f26);
     f16 = Math_fround(f29 + f25);
     f23 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(f14 * f22)) + Math_fround(f16 * f23));
     f21 = Math_fround(Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i42 >> 2]) * Math_fround(2.0))) - Math_fround(f24 + f21));
     f24 = Math_fround(Math_abs(Math_fround(f19)));
     if (!(Math_fround(Math_abs(Math_fround(f21))) > Math_fround(f20 + f24))) {
      f81 = Math_fround(HEAPF32[i43 >> 2]);
      f22 = Math_fround(f7 * f81);
      f18 = Math_fround(HEAPF32[i44 >> 2]);
      f22 = Math_fround(f22 + Math_fround(f8 * f18));
      f17 = Math_fround(HEAPF32[i45 >> 2]);
      f22 = Math_fround(f22 + Math_fround(f10 * f17));
      f23 = Math_fround(f6 - f5);
      f17 = Math_fround(Math_fround(Math_fround(f13 * f81) + Math_fround(f14 * f18)) + Math_fround(f16 * f17));
      f17 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i46 >> 2]) * Math_fround(2.0))) - Math_fround(f5 + f6));
      f18 = Math_fround(Math_abs(Math_fround(f22)));
      if (!(Math_fround(Math_abs(Math_fround(f17))) > Math_fround(f23 + f18))) {
       f81 = Math_fround(HEAPF32[i47 >> 2]);
       f7 = Math_fround(f7 * f81);
       f6 = Math_fround(HEAPF32[i49 >> 2]);
       f7 = Math_fround(f7 + Math_fround(f8 * f6));
       f5 = Math_fround(HEAPF32[i50 >> 2]);
       f7 = Math_fround(f7 + Math_fround(f10 * f5));
       f8 = Math_fround(f11 - f12);
       f5 = Math_fround(Math_fround(Math_fround(f13 * f81) + Math_fround(f14 * f6)) + Math_fround(f16 * f5));
       f5 = Math_fround(Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i51 >> 2]) * Math_fround(2.0))) - Math_fround(f12 + f11));
       f6 = Math_fround(Math_abs(Math_fround(f7)));
       if (!(Math_fround(Math_abs(Math_fround(f5))) > Math_fround(f8 + f6))) if (!(Math_fround(Math_abs(Math_fround(Math_fround(f22 * f5) - Math_fround(f17 * f7)))) > Math_fround(Math_fround(f8 * f18) + Math_fround(f23 * f6)))) if (!(Math_fround(Math_abs(Math_fround(Math_fround(f21 * f7) - Math_fround(f19 * f5)))) > Math_fround(Math_fround(f8 * f24) + Math_fround(f20 * f6)))) if (!(Math_fround(Math_abs(Math_fround(Math_fround(f19 * f17) - Math_fround(f21 * f22)))) > Math_fround(Math_fround(f23 * f24) + Math_fround(f20 * f18)))) {
        f7 = Math_fround(f3 - f27);
        f4 = Math_fround(f4 - f26);
        f3 = Math_fround(f29 - f25);
        f24 = Math_fround(f7 * Math_fround(HEAPF32[i79 >> 2]));
        f6 = Math_fround(f7 * Math_fround(HEAPF32[i52 >> 2]));
        f7 = Math_fround(f7 * Math_fround(HEAPF32[i53 >> 2]));
        f29 = Math_fround(f4 * Math_fround(HEAPF32[i54 >> 2]));
        f81 = Math_fround(f4 * Math_fround(HEAPF32[i55 >> 2]));
        f29 = Math_fround(f24 + f29);
        f81 = Math_fround(f6 + f81);
        f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i56 >> 2])));
        f7 = Math_fround(f3 * Math_fround(HEAPF32[i57 >> 2]));
        f6 = Math_fround(f3 * Math_fround(HEAPF32[i58 >> 2]));
        f7 = Math_fround(f29 + f7);
        f6 = Math_fround(f81 + f6);
        f3 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i60 >> 2])));
        f4 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f3 * f3));
        if (f4 > Math_fround(0.0)) {
         f81 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
         f5 = Math_fround(f3 * f81);
         f4 = Math_fround(f6 * f81);
         f3 = Math_fround(f7 * f81);
        } else {
         f5 = Math_fround(0.0);
         f4 = Math_fround(0.0);
         f3 = Math_fround(0.0);
        }
        HEAPF32[i71 >> 2] = f3;
        HEAPF32[i61 >> 2] = f4;
        HEAPF32[i62 >> 2] = f5;
        __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E(i77, i71) | 0;
       }
      }
     }
    }
    if ((i9 | 0) == (i31 | 0)) break L6;
    f14 = Math_fround(HEAPF32[i78 >> 2]);
    f13 = Math_fround(HEAPF32[i37 >> 2]);
    f5 = Math_fround(HEAPF32[i48 >> 2]);
    f6 = Math_fround(HEAPF32[i59 >> 2]);
    f7 = Math_fround(HEAPF32[i63 >> 2]);
    f8 = Math_fround(HEAPF32[i64 >> 2]);
    f10 = Math_fround(HEAPF32[i65 >> 2]);
    f11 = Math_fround(HEAPF32[i66 >> 2]);
    f12 = Math_fround(HEAPF32[i67 >> 2]);
    f16 = Math_fround(HEAPF32[i73 >> 2]);
    f17 = Math_fround(HEAPF32[i68 >> 2]);
    f18 = Math_fround(HEAPF32[i38 >> 2]);
    f3 = f27;
    f4 = f26;
    f29 = f25;
    f19 = Math_fround(HEAPF32[i39 >> 2]);
    i15 = i28;
   }
  } while (0);
 } while ((i2 | 0) != 0);
 STACKTOP = i80;
 return;
}

function __ZNK5physx2Gu10ConvexMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_9PxBounds3Eyfj(i19, i21, i20, i4, i18, i1, f2, i3) {
 i19 = i19 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0;
 i60 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i58 = i60 + 64 | 0;
 i59 = i60;
 L1 : do if (!((i18 & 1073741824 | 0) == 0 & 0 == 0)) {
  i7 = HEAP32[i19 + 56 >> 2] | 0;
  i57 = HEAP8[i19 + 55 >> 0] | 0;
  i8 = i57 & 255;
  i1 = i8 * 20 | 0;
  i9 = i7 + i1 | 0;
  if (i57 << 24 >> 24) {
   f10 = Math_fround(HEAPF32[i20 + 36 >> 2]);
   f11 = Math_fround(HEAPF32[i20 + 40 >> 2]);
   f12 = Math_fround(HEAPF32[i20 + 44 >> 2]);
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i4 + 20 >> 2]);
   i6 = 0;
   i3 = i7 + (((HEAPU8[i19 + 54 >> 0] | 0) * 15 | 0) + i1 + ((HEAPU16[i19 + 52 >> 1] | 0) << 1)) | 0;
   L4 : while (1) {
    i57 = HEAP8[i7 + (i6 * 20 | 0) + 18 >> 0] | 0;
    i1 = i57 & 255;
    if ((i57 & 255) > 1) {
     i4 = 1;
     do {
      i57 = HEAPU8[i3 + i4 >> 0] | 0;
      f29 = Math_fround(f10 + Math_fround(HEAPF32[i9 + (i57 * 12 | 0) >> 2]));
      f30 = Math_fround(f11 + Math_fround(HEAPF32[i9 + (i57 * 12 | 0) + 4 >> 2]));
      f2 = Math_fround(f12 + Math_fround(HEAPF32[i9 + (i57 * 12 | 0) + 8 >> 2]));
      if (f29 < f13 | f29 > f14 | f30 < f15 | f30 > f16 | f2 < f17) {
       i1 = 24;
       break L4;
      }
      i4 = i4 + 1 | 0;
      if (f2 > f5) {
       i1 = 24;
       break L4;
      }
     } while (i4 >>> 0 < i1 >>> 0);
    }
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= i8 >>> 0) break L1; else i3 = i3 + i1 | 0;
   }
   if ((i1 | 0) == 24) {
    STACKTOP = i60;
    return;
   }
  }
 } while (0);
 if ((i18 & 8192 | 0) == 0 & 0 == 0) {
  STACKTOP = i60;
  return;
 }
 i55 = i19 + 56 | 0;
 i3 = HEAP32[i55 >> 2] | 0;
 i54 = HEAP8[i19 + 55 >> 0] | 0;
 i56 = i54 & 255;
 i4 = i56 * 20 | 0;
 i57 = i3 + i4 | 0;
 i6 = HEAP8[i19 + 54 >> 0] | 0;
 i1 = HEAP16[i19 + 52 >> 1] | 0;
 __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_2Cm8Matrix34E(i59, i20);
 __ZN5physx2Cm12RenderOutputlsEj(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i21, i59) | 0, -65281) | 0;
 if (i54 << 24 >> 24) {
  i44 = i59 + 4 | 0;
  i45 = i59 + 8 | 0;
  i46 = i59 + 16 | 0;
  i47 = i59 + 20 | 0;
  i48 = i59 + 24 | 0;
  i49 = i59 + 32 | 0;
  i50 = i59 + 36 | 0;
  i51 = i59 + 40 | 0;
  i52 = i59 + 48 | 0;
  i53 = i59 + 52 | 0;
  i54 = i59 + 56 | 0;
  i43 = i21 + 100 | 0;
  i18 = i21 + 4 | 0;
  i19 = i58 + 4 | 0;
  i20 = i58 + 8 | 0;
  i21 = i58 + 12 | 0;
  i31 = i58 + 16 | 0;
  i32 = i58 + 20 | 0;
  i33 = i58 + 24 | 0;
  i34 = i58 + 28 | 0;
  i35 = i58 + 4 | 0;
  i36 = i58 + 8 | 0;
  i37 = i58 + 12 | 0;
  i38 = i58 + 16 | 0;
  i39 = i58 + 20 | 0;
  i40 = i58 + 24 | 0;
  i41 = i58 + 28 | 0;
  i42 = 0;
  i9 = i3 + (((i6 & 255) * 15 | 0) + i4 + ((i1 & 65535) << 1)) | 0;
  while (1) {
   i7 = HEAP8[(HEAP32[i55 >> 2] | 0) + (i42 * 20 | 0) + 18 >> 0] | 0;
   i8 = i7 & 255;
   i6 = HEAPU8[i9 >> 0] | 0;
   f14 = Math_fround(HEAPF32[i57 + (i6 * 12 | 0) >> 2]);
   f22 = Math_fround(HEAPF32[i57 + (i6 * 12 | 0) + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i57 + (i6 * 12 | 0) + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i59 >> 2]);
   f10 = Math_fround(f14 * f23);
   f27 = Math_fround(HEAPF32[i44 >> 2]);
   f17 = Math_fround(f14 * f27);
   f29 = Math_fround(HEAPF32[i45 >> 2]);
   f2 = Math_fround(f14 * f29);
   f28 = Math_fround(HEAPF32[i46 >> 2]);
   f12 = Math_fround(f22 * f28);
   f24 = Math_fround(HEAPF32[i47 >> 2]);
   f11 = Math_fround(f22 * f24);
   f25 = Math_fround(HEAPF32[i48 >> 2]);
   f12 = Math_fround(f10 + f12);
   f11 = Math_fround(f17 + f11);
   f2 = Math_fround(f2 + Math_fround(f22 * f25));
   f17 = Math_fround(HEAPF32[i49 >> 2]);
   f10 = Math_fround(f26 * f17);
   f15 = Math_fround(HEAPF32[i50 >> 2]);
   f5 = Math_fround(f26 * f15);
   f16 = Math_fround(HEAPF32[i51 >> 2]);
   f10 = Math_fround(f12 + f10);
   f5 = Math_fround(f11 + f5);
   f2 = Math_fround(f2 + Math_fround(f26 * f16));
   f11 = Math_fround(HEAPF32[i52 >> 2]);
   f12 = Math_fround(HEAPF32[i53 >> 2]);
   f13 = Math_fround(HEAPF32[i54 >> 2]);
   f10 = Math_fround(f10 + f11);
   f5 = Math_fround(f5 + f12);
   f2 = Math_fround(f2 + f13);
   if ((i7 & 255) > 1) {
    f26 = f29;
    f22 = f28;
    f14 = f17;
    i7 = 1;
    while (1) {
     i61 = HEAPU8[i9 + i7 >> 0] | 0;
     f28 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) >> 2]);
     f29 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) + 4 >> 2]);
     f30 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) + 8 >> 2]);
     f14 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f23) + Math_fround(f29 * f22)) + Math_fround(f30 * f14)) + f11);
     f12 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f29 * f24)) + Math_fround(f30 * f15)) + f12);
     f11 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f26) + Math_fround(f29 * f25)) + Math_fround(f30 * f16)) + f13);
     i61 = HEAP32[i43 >> 2] | 0;
     i1 = i61 + 16 | 0;
     HEAPF32[i58 >> 2] = f10;
     HEAPF32[i35 >> 2] = f5;
     HEAPF32[i36 >> 2] = f2;
     i3 = HEAP32[i18 >> 2] | 0;
     HEAP32[i37 >> 2] = i3;
     HEAPF32[i38 >> 2] = f14;
     HEAPF32[i39 >> 2] = f12;
     HEAPF32[i40 >> 2] = f11;
     HEAP32[i41 >> 2] = i3;
     i4 = i61 + 20 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i61 + 24 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
      i61 = HEAP32[i1 >> 2] | 0;
      HEAPF32[i61 + (i6 << 5) >> 2] = f10;
      HEAPF32[i61 + (i6 << 5) + 4 >> 2] = f5;
      HEAPF32[i61 + (i6 << 5) + 8 >> 2] = f2;
      HEAP32[i61 + (i6 << 5) + 12 >> 2] = i3;
      HEAPF32[i61 + (i6 << 5) + 16 >> 2] = f14;
      HEAPF32[i61 + (i6 << 5) + 20 >> 2] = f12;
      HEAPF32[i61 + (i6 << 5) + 24 >> 2] = f11;
      HEAP32[i61 + (i6 << 5) + 28 >> 2] = i3;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i58) | 0;
     i1 = i7 + 1 | 0;
     if ((i1 | 0) == (i8 | 0)) {
      f10 = f14;
      f5 = f12;
      f2 = f11;
      break;
     }
     f23 = Math_fround(HEAPF32[i59 >> 2]);
     f27 = Math_fround(HEAPF32[i44 >> 2]);
     f26 = Math_fround(HEAPF32[i45 >> 2]);
     f22 = Math_fround(HEAPF32[i46 >> 2]);
     f24 = Math_fround(HEAPF32[i47 >> 2]);
     f25 = Math_fround(HEAPF32[i48 >> 2]);
     f29 = Math_fround(HEAPF32[i49 >> 2]);
     f15 = Math_fround(HEAPF32[i50 >> 2]);
     f16 = Math_fround(HEAPF32[i51 >> 2]);
     f30 = Math_fround(HEAPF32[i52 >> 2]);
     f13 = Math_fround(HEAPF32[i53 >> 2]);
     f2 = f11;
     f5 = f12;
     f10 = f14;
     f14 = f29;
     f11 = f30;
     f12 = f13;
     f13 = Math_fround(HEAPF32[i54 >> 2]);
     i7 = i1;
    }
    i61 = HEAPU8[i9 >> 0] | 0;
    f14 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) >> 2]);
    f30 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) + 4 >> 2]);
    f26 = Math_fround(HEAPF32[i57 + (i61 * 12 | 0) + 8 >> 2]);
    f23 = Math_fround(HEAPF32[i59 >> 2]);
    f27 = Math_fround(HEAPF32[i44 >> 2]);
    f29 = Math_fround(HEAPF32[i45 >> 2]);
    f28 = Math_fround(HEAPF32[i46 >> 2]);
    f24 = Math_fround(HEAPF32[i47 >> 2]);
    f25 = Math_fround(HEAPF32[i48 >> 2]);
    f17 = Math_fround(HEAPF32[i49 >> 2]);
    f22 = Math_fround(HEAPF32[i50 >> 2]);
    f16 = Math_fround(HEAPF32[i51 >> 2]);
    f11 = Math_fround(HEAPF32[i52 >> 2]);
    f12 = Math_fround(HEAPF32[i53 >> 2]);
    f13 = Math_fround(HEAPF32[i54 >> 2]);
   } else {
    f30 = f22;
    f22 = f15;
   }
   f15 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f23) + Math_fround(f30 * f28)) + Math_fround(f26 * f17)) + f11);
   f12 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f27) + Math_fround(f30 * f24)) + Math_fround(f26 * f22)) + f12);
   f11 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f29) + Math_fround(f30 * f25)) + Math_fround(f26 * f16)) + f13);
   i61 = HEAP32[i43 >> 2] | 0;
   i1 = i61 + 16 | 0;
   HEAPF32[i58 >> 2] = f10;
   HEAPF32[i19 >> 2] = f5;
   HEAPF32[i20 >> 2] = f2;
   i3 = HEAP32[i18 >> 2] | 0;
   HEAP32[i21 >> 2] = i3;
   HEAPF32[i31 >> 2] = f15;
   HEAPF32[i32 >> 2] = f12;
   HEAPF32[i33 >> 2] = f11;
   HEAP32[i34 >> 2] = i3;
   i4 = i61 + 20 | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i61 + 24 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
    i61 = HEAP32[i1 >> 2] | 0;
    HEAPF32[i61 + (i6 << 5) >> 2] = f10;
    HEAPF32[i61 + (i6 << 5) + 4 >> 2] = f5;
    HEAPF32[i61 + (i6 << 5) + 8 >> 2] = f2;
    HEAP32[i61 + (i6 << 5) + 12 >> 2] = i3;
    HEAPF32[i61 + (i6 << 5) + 16 >> 2] = f15;
    HEAPF32[i61 + (i6 << 5) + 20 >> 2] = f12;
    HEAPF32[i61 + (i6 << 5) + 24 >> 2] = f11;
    HEAP32[i61 + (i6 << 5) + 28 >> 2] = i3;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i58) | 0;
   i42 = i42 + 1 | 0;
   if ((i42 | 0) == (i56 | 0)) break; else i9 = i9 + i8 | 0;
  }
 }
 STACKTOP = i60;
 return;
}

function __ZN13GfxDeviceGLES14BeforeDrawCallEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 80 | 0;
 i15 = i21 + 16 | 0;
 i17 = i21 + 12 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21;
 __ZN18GfxFramebufferGLES7PrepareEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i20 + 4616 >> 2] | 0) | 0);
 i14 = i20 + 6620 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i13 = i20 + 3420 | 0;
 i1 = i20 + 3612 | 0;
 if (HEAP32[i1 >> 2] & 3 | 0) {
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i20 + 1828 | 0, i13, i20 + 3548 | 0);
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -4;
 }
 i12 = HEAP32[i20 + 4228 >> 2] | 0;
 if (!((i11 & 7 | 0) == 0 | (HEAP32[i12 >> 2] | 0) < 0)) {
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i20 + 1764 | 0, i20 + 3548 | 0, i16);
  i6 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 8 >> 2] | 0;
  i1 = HEAP32[i20 + 7072 >> 2] | 0;
  i8 = i20 + 6624 | 0;
  L6 : do if (!i7) if (!(HEAP8[i12 + 16 >> 0] | 0)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i6 | 0, 1, 0, i16 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, 4, i16 | 0);
   break;
  } else if (i1 | 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i5 = i1;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = (i2 - i1 | 0) / 52 | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
     i3 = HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0;
     if ((i3 << 16 | i2 | 0) == (i7 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L6;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i8, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i8, i2, HEAP32[i5 + (i1 * 52 | 0) + 28 >> 2] | 0, i3) | 0, i6, i16, 64);
   }
  } while (0);
 }
 i7 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = (i11 & 3 | 0) == 0;
 L20 : do if (!(i10 | (i7 | 0) < 0)) {
  i6 = HEAP32[i12 + 28 >> 2] | 0;
  i1 = HEAP32[i20 + 7072 >> 2] | 0;
  i8 = i20 + 3548 | 0;
  i9 = i20 + 6624 | 0;
  if (!i6) if (!(HEAP8[i12 + 36 >> 0] | 0)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i7 | 0, 1, 0, i8 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i7 | 0, 4, i8 | 0);
   break;
  }
  if (i1 | 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i5 = i1;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = (i2 - i1 | 0) / 52 | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
     i3 = HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0;
     if ((i3 << 16 | i2 | 0) == (i6 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L20;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i9, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i9, i2, HEAP32[i5 + (i1 * 52 | 0) + 28 >> 2] | 0, i3) | 0, i7, i8, 64);
   }
  }
 } while (0);
 i1 = i12 + 80 | 0;
 if (!(i10 | (HEAP32[i1 >> 2] | 0) < 0)) {
  __Z21TransposeMatrix4x4REFPK10Matrix4x4fPS_(i20 + 3548 | 0, i16);
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i12 + 88 >> 2] | 0;
  i1 = HEAP32[i20 + 7072 >> 2] | 0;
  i8 = i20 + 6624 | 0;
  L37 : do if (!i7) if (!(HEAP8[i12 + 96 >> 0] | 0)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i6 | 0, 1, 0, i16 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, 4, i16 | 0);
   break;
  } else if (i1 | 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i5 = i1;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = (i2 - i1 | 0) / 52 | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
     i3 = HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0;
     if ((i3 << 16 | i2 | 0) == (i7 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L37;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i8, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i8, i2, HEAP32[i5 + (i1 * 52 | 0) + 28 >> 2] | 0, i3) | 0, i6, i16, 64);
   }
  } while (0);
 }
 i1 = i12 + 100 | 0;
 if (!(i10 | (HEAP32[i1 >> 2] | 0) < 0)) {
  __Z25InvertMatrix4x4_General3DPKfPf(i20 + 3548 | 0, i16) | 0;
  __Z21TransposeMatrix4x4REFPK10Matrix4x4fPS_(i16, i15);
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i12 + 108 >> 2] | 0;
  i1 = HEAP32[i20 + 7072 >> 2] | 0;
  i8 = i20 + 6624 | 0;
  L53 : do if (!i7) if (!(HEAP8[i12 + 116 >> 0] | 0)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i6 | 0, 1, 0, i15 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, 4, i15 | 0);
   break;
  } else if (i1 | 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i5 = i1;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = (i2 - i1 | 0) / 52 | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
     i3 = HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0;
     if ((i3 << 16 | i2 | 0) == (i7 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L53;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i8, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i8, i2, HEAP32[i5 + (i1 * 52 | 0) + 28 >> 2] | 0, i3) | 0, i6, i15, 64);
   }
  } while (0);
 }
 i8 = HEAP32[i12 + 40 >> 2] | 0;
 i9 = (i11 & 1 | 0) == 0;
 L67 : do if (!(i9 | (i8 | 0) < 0)) {
  i6 = HEAP32[i12 + 48 >> 2] | 0;
  i1 = HEAP32[i20 + 7072 >> 2] | 0;
  i7 = i20 + 6624 | 0;
  if (!i6) if (!(HEAP8[i12 + 56 >> 0] | 0)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i8 | 0, 1, 0, i13 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i8 | 0, 4, i13 | 0);
   break;
  }
  if (i1 | 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i5 = i1;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = (i2 - i1 | 0) / 52 | 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0;
     i3 = HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0;
     if ((i3 << 16 | i2 | 0) == (i6 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) break L67;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i7, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i7, i2, HEAP32[i5 + (i1 * 52 | 0) + 28 >> 2] | 0, i3) | 0, i8, i13, 64);
   }
  }
 } while (0);
 i8 = HEAP32[i12 + 60 >> 2] | 0;
 if (i9 | (i8 | 0) < 0) i1 = i20 + 6624 | 0; else {
  i7 = HEAP32[i12 + 68 >> 2] | 0;
  i2 = HEAP8[i12 + 76 >> 0] | 0;
  __Z25InvertMatrix4x4_General3DPKfPf(i13, i16) | 0;
  i3 = HEAP32[i20 + 7072 >> 2] | 0;
  i1 = i20 + 6624 | 0;
  L85 : do if (!i7) if (!(i2 << 24 >> 24)) {
   mftCall_viiii(HEAP32[i20 + 4784 >> 2] | 0, i8 | 0, 1, 0, i16 | 0);
   break;
  } else {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i8 | 0, 4, i16 | 0);
   break;
  } else if (i3 | 0) {
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i6 = i2;
   if ((i4 | 0) != (i2 | 0)) {
    i5 = (i4 - i2 | 0) / 52 | 0;
    i2 = 0;
    while (1) {
     i3 = HEAP32[i6 + (i2 * 52 | 0) >> 2] | 0;
     i4 = HEAP32[i6 + (i2 * 52 | 0) + 24 >> 2] | 0;
     if ((i4 << 16 | i3 | 0) == (i7 | 0)) break;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i5 >>> 0) break L85;
    }
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i1, __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i1, i3, HEAP32[i6 + (i2 * 52 | 0) + 28 >> 2] | 0, i4) | 0, i8, i16, 64);
   }
  } while (0);
 }
 HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -8;
 __ZN19ConstantBuffersGLES13UpdateBuffersEv(i1);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 i5 = i20 + 7196 | 0;
 if ((HEAP32[i5 >> 2] | 0) >= 0) {
  i6 = i20 + 7064 | 0;
  i4 = i19 + 4 | 0;
  i3 = 0;
  while (1) {
   i1 = HEAP32[i20 + 7200 + (i3 << 2) >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i20 + 7232 + (i3 << 2) >> 2] | 0;
    if (i1 | 0) {
     i2 = HEAP32[i6 >> 2] | 0;
     if (i3 >>> 0 < (HEAP32[i2 + 72 >> 2] | 0) >>> 0) {
      i14 = HEAP32[i2 + 60 >> 2] | 0;
      i13 = HEAP32[i14 + (i3 << 4) + 8 >> 2] | 0;
      i14 = HEAP32[i14 + (i3 << 4) + 12 >> 2] | 0;
      HEAP32[i18 >> 2] = i1;
      HEAP32[i19 >> 2] = i13;
      HEAP32[i4 >> 2] = i14;
      HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i16 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb(i20, i15, i3, i16, 0, 1);
     }
    }
   } else {
    HEAP32[i17 >> 2] = i1;
    HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
    __ZN13GfxDeviceGLES15SetImageTextureE9TextureIDi(i20, i16, i3);
   }
   if ((i3 | 0) < (HEAP32[i5 >> 2] | 0)) i3 = i3 + 1 | 0; else break;
  }
 }
 i4 = i20 + 7376 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i5 = i20 + 7380 | 0;
 i1 = HEAP32[i5 >> 2] & i1;
 if (i1 | 0) mftCall_vi(HEAP32[i20 + 4860 >> 2] | 0, i1 | 0);
 i2 = i20 + 5480 | 0;
 i3 = i20 + 7368 | 0;
 i1 = 0;
 do {
  i19 = HEAP32[i5 >> 2] & HEAP32[i4 >> 2];
  if (i19 & (__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0) | 0) {
   i17 = i3;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i20 + 7264 + (i1 << 3) | 0;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i19 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0);
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & i19;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 13);
 i18 = i3;
 i18 = _i64Add(HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, 1, 0) | 0;
 i19 = getTempRet0() | 0;
 i20 = i3;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i20 + 4 >> 2] = i19;
 HEAP32[i5 >> 2] = 15407;
 STACKTOP = i21;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap21batchUpdateFewUpdatesEjRPNS_17PxcBroadPhasePairERjS4_(i36, i9, i32, i35, i34) {
 i36 = i36 | 0;
 i9 = i9 | 0;
 i32 = i32 | 0;
 i35 = i35 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i40 + 25 | 0;
 i26 = i40 + 24 | 0;
 i30 = i40;
 i3 = HEAP32[i34 >> 2] | 0;
 i31 = HEAP32[i36 + 100 >> 2] | 0;
 i27 = HEAP32[i36 + 116 >> 2] | 0;
 HEAP32[i30 >> 2] = i27;
 i37 = HEAP32[i36 + 120 >> 2] | 0;
 HEAP32[i30 + 4 >> 2] = i37;
 HEAP32[i30 + 8 >> 2] = i37;
 i37 = HEAP32[i36 + 112 >> 2] | 0;
 HEAP32[i30 + 12 >> 2] = i37;
 HEAP32[i30 + 16 >> 2] = i37;
 HEAP32[i30 + 20 >> 2] = i27;
 i27 = HEAP32[i36 + 104 >> 2] | 0;
 i37 = HEAP32[i36 + 112 + (i9 << 2) >> 2] | 0;
 i38 = HEAP32[i36 + 124 + (i9 << 2) >> 2] | 0;
 i39 = HEAP32[i36 + 136 + (i9 << 2) >> 2] | 0;
 i29 = i9 << 1;
 i28 = HEAP32[i30 + (i29 << 2) >> 2] | 0;
 i29 = HEAP32[i30 + ((i29 | 1) << 2) >> 2] | 0;
 i30 = HEAP32[i36 + 148 >> 2] | 0;
 i7 = HEAP32[i36 + 168 >> 2] << 1 | 1;
 i2 = HEAP32[i39 + 4 >> 2] | 0;
 if ((i2 & -2 | 0) == 1073741822) {
  STACKTOP = i40;
  return;
 }
 i8 = i36 + 96 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 L4 : do if (i1 >>> 0 < 512) {
  if (!i1) {
   i2 = HEAP32[i36 + 152 >> 2] | 0;
   i1 = 0;
  } else {
   i4 = HEAP32[i36 + 92 >> 2] | 0;
   i5 = i9 + 3 | 0;
   i2 = HEAP32[i36 + 152 >> 2] | 0;
   i6 = 0;
   i7 = 0;
   while (1) {
    i24 = HEAP32[i4 + (i6 << 2) >> 2] | 0;
    i23 = HEAP32[i31 + (i24 * 24 | 0) + (i5 << 2) >> 2] | 0;
    i1 = i37 + (i24 << 3) | 0;
    HEAP32[i38 + (HEAP32[i1 >> 2] << 2) >> 2] = HEAP32[i31 + (i24 * 24 | 0) + (i9 << 2) >> 2];
    i24 = i37 + (i24 << 3) + 4 | 0;
    HEAP32[i38 + (HEAP32[i24 >> 2] << 2) >> 2] = i23;
    HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i1 >> 2];
    i1 = i7 + 2 | 0;
    HEAP32[i2 + ((i7 | 1) << 2) >> 2] = HEAP32[i24 >> 2];
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) break; else i7 = i1;
   }
  }
  __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i2, i1, i25, i26, 32);
  i24 = i1;
 } else if ((i7 | 0) == 1) i24 = 0; else {
  i6 = i36 + 152 | 0;
  if ((i2 & -2 | 0) == 1073741822) i24 = 0; else {
   i1 = 0;
   i5 = 1;
   while (1) {
    i4 = i2 >>> 1;
    if (HEAP8[i30 + i4 >> 0] | 0) {
     HEAP32[i38 + (i5 << 2) >> 2] = HEAP32[i31 + (i4 * 24 | 0) + ((0 - (i2 & 1) & 3) + i9 << 2) >> 2];
     HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i5;
     i1 = i1 + 1 | 0;
    }
    i5 = i5 + 1 | 0;
    if (i5 >>> 0 >= i7 >>> 0) {
     i24 = i1;
     break L4;
    }
    i2 = HEAP32[i39 + (i5 << 2) >> 2] | 0;
    if ((i2 & -2 | 0) == 1073741822) {
     i24 = i1;
     break;
    }
   }
  }
 } while (0);
 i22 = i36 + 156 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 if (!i24) {
  i2 = i1;
  i12 = i1;
  i1 = 0;
 } else {
  i23 = i36 + 152 | 0;
  i20 = i9 + 3 | 0;
  i18 = i36 + 164 | 0;
  i19 = i36 + 160 | 0;
  i5 = HEAP32[i18 >> 2] | 0;
  i2 = i1;
  i21 = 0;
  i4 = i1;
  i1 = 0;
  do {
   i17 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i21 << 2) >> 2] | 0;
   i6 = HEAP32[i39 + (i17 << 2) >> 2] | 0;
   i7 = HEAP32[i5 + (i17 << 2) >> 2] | 0;
   do {
    i15 = i6 >>> 1;
    i16 = HEAP32[i38 + (i17 << 2) >> 2] | 0;
    i9 = HEAP32[i31 + (i15 * 24 | 0) + (i20 << 2) >> 2] | 0;
    if ((HEAP32[i38 + (i7 << 2) >> 2] | 0) >>> 0 > i16 >>> 0) {
     i10 = HEAP32[i27 + (i15 << 2) >> 2] | 0;
     i11 = i28 + (i15 << 3) | 0;
     i12 = i28 + (i15 << 3) + 4 | 0;
     i13 = i29 + (i15 << 3) | 0;
     i14 = i29 + (i15 << 3) + 4 | 0;
     if (!(i6 & 1)) {
      i2 = i7;
      i6 = i17;
      do {
       i7 = HEAP32[i39 + (i2 << 2) >> 2] | 0;
       if (i7 & 1) {
        i8 = i7 >>> 1;
        if ((HEAP32[i38 + (HEAP32[i37 + (i8 << 3) >> 2] << 2) >> 2] | 0) >>> 0 < i9 >>> 0) if (((HEAP32[i12 >> 2] | 0) >>> 0 > (HEAP32[i28 + (i8 << 3) >> 2] | 0) >>> 0 ? (HEAP32[i28 + (i8 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0 : 0) & (HEAP32[i14 >> 2] | 0) >>> 0 > (HEAP32[i29 + (i8 << 3) >> 2] | 0) >>> 0 & (HEAP32[i29 + (i8 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i13 >> 2] | 0) >>> 0) if ((i10 | 0) != (HEAP32[i27 + (i8 << 2) >> 2] | 0)) {
         if ((i1 | 0) == (i3 | 0)) {
          i5 = HEAP32[i32 >> 2] | 0;
          i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i3 << 4, gb + 716671 | 0, 1486) | 0;
          _memcpy(i7 | 0, i5 | 0, i3 << 3 | 0) | 0;
          __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i5);
          HEAP32[i32 >> 2] = i7;
          i5 = HEAP32[i18 >> 2] | 0;
          i3 = i3 << 1;
         } else i7 = HEAP32[i32 >> 2] | 0;
         i41 = i15 >>> 0 < i8 >>> 0;
         HEAP32[i7 + (i1 << 3) >> 2] = i41 ? i8 : i15;
         HEAP32[i7 + (i1 << 3) + 4 >> 2] = i41 ? i15 : i8;
         i1 = i1 + 1 | 0;
        }
       }
       i6 = i6 + -1 | 0;
       i2 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
      } while (i16 >>> 0 < (HEAP32[i38 + (i2 << 2) >> 2] | 0) >>> 0);
     } else {
      i2 = i7;
      i6 = i17;
      do {
       i7 = HEAP32[i39 + (i2 << 2) >> 2] | 0;
       if (!(i7 & 1)) {
        i8 = i7 >>> 1;
        if (((HEAP32[i12 >> 2] | 0) >>> 0 > (HEAP32[i28 + (i8 << 3) >> 2] | 0) >>> 0 ? (HEAP32[i28 + (i8 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0 : 0) & (HEAP32[i14 >> 2] | 0) >>> 0 > (HEAP32[i29 + (i8 << 3) >> 2] | 0) >>> 0 & (HEAP32[i29 + (i8 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i13 >> 2] | 0) >>> 0) if ((i10 | 0) != (HEAP32[i27 + (i8 << 2) >> 2] | 0)) {
         if ((i1 | 0) == (i3 | 0)) {
          i5 = HEAP32[i32 >> 2] | 0;
          i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, i3 << 4, gb + 716671 | 0, 1486) | 0;
          _memcpy(i7 | 0, i5 | 0, i3 << 3 | 0) | 0;
          __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i5);
          HEAP32[i32 >> 2] = i7;
          i5 = HEAP32[i18 >> 2] | 0;
          i3 = i3 << 1;
         } else i7 = HEAP32[i32 >> 2] | 0;
         i41 = i15 >>> 0 < i8 >>> 0;
         HEAP32[i7 + (i1 << 3) >> 2] = i41 ? i15 : i8;
         HEAP32[i7 + (i1 << 3) + 4 >> 2] = i41 ? i8 : i15;
         i1 = i1 + 1 | 0;
        }
       }
       i6 = i6 + -1 | 0;
       i2 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
      } while (i16 >>> 0 < (HEAP32[i38 + (i2 << 2) >> 2] | 0) >>> 0);
     }
     i11 = HEAP32[i19 >> 2] | 0;
     i14 = i11 + (i17 << 2) | 0;
     i13 = HEAP32[i14 >> 2] | 0;
     i15 = i5 + (i17 << 2) | 0;
     i12 = HEAP32[i15 >> 2] | 0;
     i41 = i11 + (i2 << 2) | 0;
     i16 = HEAP32[i41 >> 2] | 0;
     HEAP32[i11 + (i12 << 2) >> 2] = i13;
     HEAP32[i5 + (i13 << 2) >> 2] = i12;
     HEAP32[i14 >> 2] = i16;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i5 + (i16 << 2) >> 2] = i17;
     HEAP32[i41 >> 2] = i17;
     i2 = i4;
     while (1) if (i6 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i2 = i2 + -8 | 0; else {
      i4 = i2;
      break;
     }
     i2 = HEAP32[i22 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i33 = 40; else if (i6 >>> 0 > ((HEAP32[i4 + 4 >> 2] | 0) + 1 | 0) >>> 0) i33 = 40;
     if ((i33 | 0) == 40) {
      i33 = 0;
      i4 = i4 + 8 | 0;
      HEAP32[i4 >> 2] = i6;
     }
     HEAP32[i4 + 4 >> 2] = i17;
    }
    i17 = i17 + 1 | 0;
    i6 = HEAP32[i39 + (i17 << 2) >> 2] | 0;
    i7 = HEAP32[i5 + (i17 << 2) >> 2] | 0;
    if ((i6 & -2 | 0) == 1073741822) break;
    if (HEAP8[i30 + (i6 >>> 1) >> 0] | 0) break;
   } while ((HEAP8[i30 + ((HEAP32[i39 + (i7 << 2) >> 2] | 0) >>> 1) >> 0] | 0) != 0);
   i21 = i21 + 1 | 0;
  } while ((i21 | 0) != (i24 | 0));
  i12 = i4;
 }
 HEAP32[i35 >> 2] = i1;
 HEAP32[i34 >> 2] = i3;
 i1 = i2 + 8 | 0;
 if (i1 >>> 0 > i12 >>> 0) {
  STACKTOP = i40;
  return;
 }
 i11 = i36 + 164 | 0;
 i10 = i36 + 160 | 0;
 i9 = i1;
 while (1) {
  i7 = i2 + 8 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = i2 + 12 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i1 >>> 0) i2 = i3; else {
   i4 = HEAP32[i11 >> 2] | 0;
   i2 = i3;
   do {
    HEAP32[i4 + (i2 << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while (i2 >>> 0 <= i1 >>> 0);
   i2 = HEAP32[i7 >> 2] | 0;
  }
  if (i2 >>> 0 <= i1 >>> 0) {
   i5 = HEAP32[i10 >> 2] | 0;
   i6 = HEAP32[i11 >> 2] | 0;
   i4 = i2 + -1 | 0;
   do {
    i4 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
    i3 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
    if ((i4 | 0) != (i2 | 0)) {
     i41 = i39 + (i3 << 2) | 0;
     i1 = HEAP32[i41 >> 2] | 0;
     i32 = i38 + (i2 << 2) | 0;
     i34 = HEAP32[i32 >> 2] | 0;
     i33 = i39 + (i2 << 2) | 0;
     i36 = HEAP32[i33 >> 2] | 0;
     i35 = i38 + (i3 << 2) | 0;
     HEAP32[i32 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i33 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i35 >> 2] = i34;
     HEAP32[i41 >> 2] = i36;
     i41 = i6 + (i2 << 2) | 0;
     HEAP32[i6 + (i3 << 2) >> 2] = HEAP32[i41 >> 2];
     HEAP32[i6 + (HEAP32[i41 >> 2] << 2) >> 2] = i3;
     HEAP32[i37 + (i1 >>> 1 << 3) + ((i1 & 1) << 2) >> 2] = i2;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 <= i1 >>> 0);
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i2 = i2 + -1 | 0;
  if (i2 >>> 0 <= i1 >>> 0) {
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = i2;
   do {
    i41 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i3 + (i1 << 2) >> 2] = i41;
    HEAP32[i4 + (i41 << 2) >> 2] = i1;
   } while (i1 >>> 0 <= (HEAP32[i8 >> 2] | 0) >>> 0);
  }
  i1 = i9 + 8 | 0;
  if (i1 >>> 0 > i12 >>> 0) break; else {
   i2 = i9;
   i9 = i1;
  }
 }
 STACKTOP = i40;
 return;
}

function __ZN5physx11growPatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjf(i45, i44, i42, i43, f1, i3, f46) {
 i45 = i45 | 0;
 i44 = i44 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 f1 = Math_fround(f1);
 i3 = i3 | 0;
 f46 = Math_fround(f46);
 var i2 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i41;
 i22 = i45 + 4232 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 <= i3 >>> 0) {
  STACKTOP = i41;
  return;
 }
 i34 = i42 + 12 | 0;
 i35 = i42 + 4 | 0;
 i36 = i42 + 8 | 0;
 i37 = i42 + 16 | 0;
 i38 = i42 + 20 | 0;
 i39 = i42 + 24 | 0;
 i23 = i40 + 4 | 0;
 i24 = i40 + 8 | 0;
 i25 = i43 + 16 | 0;
 i26 = i43 + 20 | 0;
 i27 = i43 + 24 | 0;
 i28 = i43 + 12 | 0;
 i29 = i43 + 4 | 0;
 i30 = i43 + 8 | 0;
 i31 = i40 + 12 | 0;
 i32 = i40 + 16 | 0;
 i33 = i40 + 20 | 0;
 do {
  i21 = i45 + 768 + (i3 * 96 | 0) + 16 | 0;
  i4 = HEAP16[i21 >> 1] | 0;
  if (i4 << 16 >> 16 != 2) {
   i5 = HEAP32[i45 + 3968 + (i3 << 2) >> 2] | 0;
   if ((i5 | 0) != 65535) {
    if (i4 << 16 >> 16 == 1) {
     f9 = Math_fround(Math_fround(HEAPF32[i45 + 768 + (i3 * 96 | 0) + 48 >> 2]) * Math_fround(2.0));
     f7 = Math_fround(Math_fround(HEAPF32[i45 + 768 + (i3 * 96 | 0) + 52 >> 2]) * Math_fround(2.0));
     f47 = Math_fround(Math_fround(HEAPF32[i45 + 768 + (i3 * 96 | 0) + 56 >> 2]) * Math_fround(2.0));
     f6 = Math_fround(HEAPF32[i34 >> 2]);
     f1 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
     f8 = Math_fround(HEAPF32[i42 >> 2]);
     f14 = Math_fround(f9 * f8);
     f10 = Math_fround(HEAPF32[i35 >> 2]);
     f14 = Math_fround(f14 + Math_fround(f7 * f10));
     f11 = Math_fround(HEAPF32[i36 >> 2]);
     f14 = Math_fround(f14 + Math_fround(f47 * f11));
     f12 = Math_fround(Math_fround(f8 * f14) + Math_fround(Math_fround(f9 * f1) + Math_fround(f6 * Math_fround(Math_fround(f47 * f10) - Math_fround(f7 * f11)))));
     f13 = Math_fround(Math_fround(f10 * f14) + Math_fround(Math_fround(f7 * f1) + Math_fround(f6 * Math_fround(Math_fround(f9 * f11) - Math_fround(f47 * f8)))));
     f14 = Math_fround(Math_fround(Math_fround(f47 * f1) + Math_fround(f6 * Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10)))) + Math_fround(f11 * f14));
     f12 = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f12);
     f13 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) + f13);
     f14 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) + f14);
     HEAPF32[i40 >> 2] = f12;
     HEAPF32[i23 >> 2] = f13;
     HEAPF32[i24 >> 2] = f14;
     i2 = 1;
    } else i2 = 0;
    i19 = i45 + 4100 + (i3 << 2) + 2 | 0;
    i20 = i45 + 4100 + (i3 << 2) | 0;
    f1 = Math_fround(0.0);
    while (1) {
     i17 = i45 + (i5 * 12 | 0) + 2 | 0;
     if (HEAP16[i17 >> 1] | 0) {
      i18 = i45 + (i5 * 12 | 0) | 0;
      i16 = 0;
      do {
       i15 = (HEAPU16[i18 >> 1] | 0) + (i16 & 65535) | 0;
       i4 = i44 + (i15 << 6) + 16 | 0;
       L18 : do if (Math_fround(HEAPF32[i44 + (i15 << 6) + 12 >> 2]) < f46) switch (i2 & 65535 | 0) {
       case 0:
        {
         HEAP16[i20 >> 1] = i15;
         HEAP32[i40 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i23 >> 2] = HEAP32[i44 + (i15 << 6) + 20 >> 2];
         HEAP32[i24 >> 2] = HEAP32[i44 + (i15 << 6) + 24 >> 2];
         i2 = i2 + 1 << 16 >> 16;
         break L18;
        }
       case 1:
        {
         f6 = Math_fround(HEAPF32[i4 >> 2]);
         f14 = Math_fround(f6 - Math_fround(HEAPF32[i40 >> 2]));
         f7 = Math_fround(HEAPF32[i44 + (i15 << 6) + 20 >> 2]);
         f47 = Math_fround(f7 - Math_fround(HEAPF32[i23 >> 2]));
         f8 = Math_fround(HEAPF32[i44 + (i15 << 6) + 24 >> 2]);
         f1 = Math_fround(f8 - Math_fround(HEAPF32[i24 >> 2]));
         f1 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f47 * f47)) + Math_fround(f1 * f1));
         if (!(f1 > Math_fround(.000625000044))) break L18;
         HEAP16[i19 >> 1] = i15;
         HEAPF32[i31 >> 2] = f6;
         HEAPF32[i32 >> 2] = f7;
         HEAPF32[i33 >> 2] = f8;
         i2 = i2 + 1 << 16 >> 16;
         break L18;
        }
       default:
        {
         f6 = Math_fround(HEAPF32[i4 >> 2]);
         f47 = Math_fround(f6 - Math_fround(HEAPF32[i40 >> 2]));
         f7 = Math_fround(HEAPF32[i44 + (i15 << 6) + 20 >> 2]);
         f14 = Math_fround(f7 - Math_fround(HEAPF32[i23 >> 2]));
         f8 = Math_fround(HEAPF32[i44 + (i15 << 6) + 24 >> 2]);
         f9 = Math_fround(f8 - Math_fround(HEAPF32[i24 >> 2]));
         f9 = Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f14 * f14)) + Math_fround(f9 * f9));
         f14 = Math_fround(f6 - Math_fround(HEAPF32[i31 >> 2]));
         f47 = Math_fround(f7 - Math_fround(HEAPF32[i32 >> 2]));
         f10 = Math_fround(f8 - Math_fround(HEAPF32[i33 >> 2]));
         f10 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f47 * f47)) + Math_fround(f10 * f10));
         if (f9 > f10) {
          if (!(f9 > f1)) break L18;
          HEAP16[i19 >> 1] = i15;
          HEAPF32[i31 >> 2] = f6;
          HEAPF32[i32 >> 2] = f7;
          HEAPF32[i33 >> 2] = f8;
          f1 = f9;
          break L18;
         } else {
          if (!(f10 > f1)) break L18;
          HEAP16[i20 >> 1] = i15;
          HEAPF32[i40 >> 2] = f6;
          HEAPF32[i23 >> 2] = f7;
          HEAPF32[i24 >> 2] = f8;
          f1 = f10;
          break L18;
         }
        }
       } while (0);
       i16 = i16 + 1 << 16 >> 16;
      } while ((i16 & 65535) < (HEAPU16[i17 >> 1] | 0));
     }
     i4 = HEAP16[i45 + (i5 * 12 | 0) + 4 >> 1] | 0;
     if (i4 << 16 >> 16 == -1) break; else i5 = i4 & 65535;
    }
    i4 = HEAP16[i21 >> 1] | 0;
    if ((i4 & 65535) < (i2 & 65535)) {
     f1 = Math_fround(HEAPF32[i34 >> 2]);
     f6 = Math_fround(Math_fround(f1 * f1) + Math_fround(-.5));
     f7 = Math_fround(HEAPF32[i42 >> 2]);
     f8 = Math_fround(HEAPF32[i35 >> 2]);
     f9 = Math_fround(HEAPF32[i36 >> 2]);
     f10 = Math_fround(HEAPF32[i28 >> 2]);
     f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
     f12 = Math_fround(HEAPF32[i43 >> 2]);
     f13 = Math_fround(HEAPF32[i29 >> 2]);
     f14 = Math_fround(HEAPF32[i30 >> 2]);
     i5 = i2 & 65535;
     i4 = i4 & 65535;
     do {
      f51 = Math_fround(HEAPF32[i40 + (i4 * 12 | 0) >> 2]);
      f54 = Math_fround(f51 - Math_fround(HEAPF32[i37 >> 2]));
      f49 = Math_fround(HEAPF32[i40 + (i4 * 12 | 0) + 4 >> 2]);
      f47 = Math_fround(f49 - Math_fround(HEAPF32[i38 >> 2]));
      f50 = Math_fround(HEAPF32[i40 + (i4 * 12 | 0) + 8 >> 2]);
      f54 = Math_fround(f54 * Math_fround(2.0));
      f47 = Math_fround(f47 * Math_fround(2.0));
      f53 = Math_fround(Math_fround(f50 - Math_fround(HEAPF32[i39 >> 2])) * Math_fround(2.0));
      f55 = Math_fround(Math_fround(Math_fround(f54 * f7) + Math_fround(f47 * f8)) + Math_fround(f53 * f9));
      f48 = Math_fround(Math_fround(f8 * f55) + Math_fround(Math_fround(f47 * f6) - Math_fround(f1 * Math_fround(Math_fround(f54 * f9) - Math_fround(f53 * f7)))));
      f52 = Math_fround(Math_fround(Math_fround(f53 * f6) - Math_fround(f1 * Math_fround(Math_fround(f47 * f7) - Math_fround(f54 * f8)))) + Math_fround(f9 * f55));
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 48 + (i4 * 12 | 0) >> 2] = Math_fround(Math_fround(f7 * f55) + Math_fround(Math_fround(f54 * f6) - Math_fround(f1 * Math_fround(Math_fround(f53 * f8) - Math_fround(f47 * f9)))));
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 48 + (i4 * 12 | 0) + 4 >> 2] = f48;
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 48 + (i4 * 12 | 0) + 8 >> 2] = f52;
      f51 = Math_fround(f51 - Math_fround(HEAPF32[i25 >> 2]));
      f49 = Math_fround(f49 - Math_fround(HEAPF32[i26 >> 2]));
      f51 = Math_fround(f51 * Math_fround(2.0));
      f49 = Math_fround(f49 * Math_fround(2.0));
      f50 = Math_fround(Math_fround(f50 - Math_fround(HEAPF32[i27 >> 2])) * Math_fround(2.0));
      f52 = Math_fround(Math_fround(Math_fround(f51 * f12) + Math_fround(f49 * f13)) + Math_fround(f50 * f14));
      f48 = Math_fround(Math_fround(f13 * f52) + Math_fround(Math_fround(f49 * f11) - Math_fround(f10 * Math_fround(Math_fround(f51 * f14) - Math_fround(f50 * f12)))));
      f47 = Math_fround(Math_fround(Math_fround(f50 * f11) - Math_fround(f10 * Math_fround(Math_fround(f49 * f12) - Math_fround(f51 * f13)))) + Math_fround(f14 * f52));
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 72 + (i4 * 12 | 0) >> 2] = Math_fround(Math_fround(f12 * f52) + Math_fround(Math_fround(f51 * f11) - Math_fround(f10 * Math_fround(Math_fround(f50 * f13) - Math_fround(f49 * f14)))));
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 72 + (i4 * 12 | 0) + 4 >> 2] = f48;
      HEAPF32[i45 + 768 + (i3 * 96 | 0) + 72 + (i4 * 12 | 0) + 8 >> 2] = f47;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i5 | 0));
    }
    if (!(i2 << 16 >> 16)) {
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 72 >> 2] = 0;
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 76 >> 2] = 0;
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 80 >> 2] = 0;
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 48 >> 2] = 0;
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 52 >> 2] = 0;
     HEAP32[i45 + 768 + (i3 * 96 | 0) + 56 >> 2] = 0;
    }
    HEAP16[i21 >> 1] = i2;
    i2 = HEAP32[i22 >> 2] | 0;
   }
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i2 >>> 0);
 STACKTOP = i41;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj(i14, i9, i15) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = i15 + 2 + (HEAP32[i2 >> 2] | 0) | 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i13;
  break;
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i13;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 34;
 i13 = i9;
 if (i15 | 0) {
  i1 = i13;
  do {
   i10 = HEAP8[i1 >> 0] | 0;
   i12 = i10 & 255;
   i11 = HEAP8[gb + 1035799 + i12 >> 0] | 0;
   if (!(i11 << 24 >> 24)) {
    i9 = HEAP32[i14 >> 2] | 0;
    i1 = i1 + 1 | 0;
    i3 = i9 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = i9 + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i5 >>> 0 > i8 >>> 0) {
     i2 = i7 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i2;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i2;
      HEAP32[i9 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i5;
    HEAP8[(HEAP32[i9 >> 2] | 0) + i4 >> 0] = i10;
   } else {
    i1 = i1 + 1 | 0;
    i3 = HEAP32[i14 >> 2] | 0;
    i4 = i3 + 12 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = i3 + 16 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i6 >>> 0 > i9 >>> 0) {
     i2 = i8 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i7 >> 2] = i2;
      HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = i2;
      HEAP32[i3 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i4 >> 2] = i6;
    HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = 92;
    i3 = HEAP32[i14 >> 2] | 0;
    i4 = i3 + 12 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i7 = i3 + 16 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i6 >>> 0 > i9 >>> 0) {
     i2 = i8 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i7 >> 2] = i2;
      HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = i2;
      HEAP32[i3 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i4 >> 2] = i6;
    HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = i11;
    if (i11 << 24 >> 24 == 117) {
     i6 = HEAP32[i14 >> 2] | 0;
     i7 = i6 + 12 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i9 = i8 + 1 | 0;
     i3 = i6 + 16 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i9 >>> 0 > i5 >>> 0) {
      i2 = i4 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i3 >> 2] = i2;
       HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
       HEAP32[i3 >> 2] = i2;
       HEAP32[i6 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i7 >> 2] = i9;
     HEAP8[(HEAP32[i6 >> 2] | 0) + i8 >> 0] = 48;
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = i3 + 12 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = i3 + 16 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
       HEAP32[i7 >> 2] = i2;
       HEAP32[i3 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i4 >> 2] = i6;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = 48;
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = HEAP8[(i12 >>> 4) + (gb + 1036055) >> 0] | 0;
     i5 = i3 + 12 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i7 = i6 + 1 | 0;
     i8 = i3 + 16 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     i10 = i9 & 2147483647;
     do if (i7 >>> 0 > i10 >>> 0) {
      i2 = i9 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
       HEAP32[i8 >> 2] = i2;
       HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
       HEAP32[i8 >> 2] = i2;
       HEAP32[i3 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i5 >> 2] = i7;
     HEAP8[(HEAP32[i3 >> 2] | 0) + i6 >> 0] = i4;
     i10 = HEAP32[i14 >> 2] | 0;
     i3 = HEAP8[(i12 & 15) + (gb + 1036055) >> 0] | 0;
     i4 = i10 + 12 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = i10 + 16 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     i9 = i8 & 2147483647;
     do if (i6 >>> 0 > i9 >>> 0) {
      i2 = i8 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
       HEAP32[i7 >> 2] = i2;
       HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i12 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
       HEAP32[i7 >> 2] = i2;
       HEAP32[i10 >> 2] = i12;
       break;
      }
     } while (0);
     HEAP32[i4 >> 2] = i6;
     HEAP8[(HEAP32[i10 >> 2] | 0) + i5 >> 0] = i3;
    }
   }
  } while ((i1 - i13 | 0) >>> 0 < i15 >>> 0);
 }
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i15 = HEAP32[i2 >> 2] | 0;
  i15 = i15 + i4 | 0;
  HEAP8[i15 >> 0] = 34;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i15 = HEAP32[i2 >> 2] | 0;
  i15 = i15 + i4 | 0;
  HEAP8[i15 >> 0] = 34;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i15 = HEAP32[i2 >> 2] | 0;
  i15 = i15 + i4 | 0;
  HEAP8[i15 >> 0] = 34;
  return 1;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i15;
  HEAP32[i3 >> 2] = i5;
  i15 = HEAP32[i2 >> 2] | 0;
  i15 = i15 + i4 | 0;
  HEAP8[i15 >> 0] = 34;
  return 1;
 }
 return 0;
}

function __Z12CreateMipMapPhiii13TextureFormat(i4, i5, i2, i3, i65) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i65 = i65 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, f72 = f0;
 i71 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i71;
 i66 = i71 + 68 | 0;
 i67 = i71 + 48 | 0;
 i68 = i71 + 28 | 0;
 i69 = i71 + 8 | 0;
 if ((i5 | 0) == 0 | (i2 | 0) == 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i2;
  __Z6FormatPKcz(i66, gb + 404433 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i66 + 11 >> 0] | 0) < 0 ? HEAP32[i66 >> 2] | 0 : i66, 0, gb + 404494 | 0, 325, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i66);
  STACKTOP = i71;
  return;
 }
 i36 = __Z25GetBytesFromTextureFormat13TextureFormat(i65) | 0;
 i35 = i5 >>> 0 > 65535;
 i34 = i35 ? i5 >>> 16 : i5;
 i35 = i35 ? 16 : 0;
 i37 = (i34 & 65280 | 0) == 0;
 i34 = i37 ? i34 : i34 >>> 8;
 i35 = i37 ? i35 : i35 | 8;
 i37 = (i34 & 240 | 0) == 0;
 i35 = (HEAP8[(i37 ? i34 : i34 >>> 4) + (gb + 936717) >> 0] | 0) + (i37 ? i35 : i35 | 4) | 0;
 i37 = i2 >>> 0 > 65535;
 i34 = i37 ? i2 >>> 16 : i2;
 i37 = i37 ? 16 : 0;
 i64 = (i34 & 65280 | 0) == 0;
 i34 = i64 ? i34 : i34 >>> 8;
 i37 = i64 ? i37 : i37 | 8;
 i64 = (i34 & 240 | 0) == 0;
 i37 = (HEAP8[(i64 ? i34 : i34 >>> 4) + (gb + 936717) >> 0] | 0) + (i64 ? i37 : i37 | 4) | 0;
 i35 = (i35 | 0) < (i37 | 0) ? i37 : i35;
 i37 = i3 >>> 0 > 65535;
 i64 = i37 ? i3 >>> 16 : i3;
 i37 = i37 ? 16 : 0;
 i34 = (i64 & 65280 | 0) == 0;
 i64 = i34 ? i64 : i64 >>> 8;
 i37 = i34 ? i37 : i37 | 8;
 i34 = (i64 & 240 | 0) == 0;
 i37 = (HEAP8[(i34 ? i64 : i64 >>> 4) + (gb + 936717) >> 0] | 0) + (i34 ? i37 : i37 | 4) | 0;
 i35 = (i35 | 0) < (i37 | 0) ? i37 : i35;
 i37 = __Z19IsHalfTextureFormat13TextureFormat(i65) | 0;
 i34 = i37 | (__Z20IsFloatTextureFormat13TextureFormat(i65) | 0);
 if ((i35 | 0) > 0) {
  i38 = i66 + 4 | 0;
  i39 = i66 + 8 | 0;
  i40 = i66 + 12 | 0;
  i41 = i66 + 16 | 0;
  i42 = i67 + 4 | 0;
  i43 = i67 + 8 | 0;
  i44 = i67 + 12 | 0;
  i45 = i67 + 16 | 0;
  i46 = i68 + 4 | 0;
  i47 = i68 + 8 | 0;
  i48 = i68 + 12 | 0;
  i49 = i68 + 16 | 0;
  i50 = i69 + 4 | 0;
  i51 = i69 + 8 | 0;
  i52 = i69 + 12 | 0;
  i53 = i69 + 16 | 0;
  i54 = i36 >>> 1;
  i55 = i36 >>> 2;
  i1 = (i65 | 0) < 9;
  i56 = (i65 | 0) > 0;
  i32 = (i65 | 0) == 1e3 | ((i65 | 0) == 23 | (i65 + -13 | 0) >>> 0 < 9);
  i57 = i66 + 4 | 0;
  i58 = i66 + 8 | 0;
  i59 = i66 + 12 | 0;
  i60 = i66 + 16 | 0;
  i61 = i67 + 4 | 0;
  i62 = i67 + 8 | 0;
  i63 = i67 + 12 | 0;
  i64 = i67 + 16 | 0;
  i33 = i1 | i32;
  i31 = i1 | i32;
  i32 = i1 | i32;
  i1 = 0;
  i30 = 0;
  i29 = i5;
  do {
   i6 = (i29 | 0) / 2 | 0;
   i28 = i29;
   i29 = (i6 | 0) < 1 ? 1 : i6;
   i6 = (i2 | 0) / 2 | 0;
   i27 = i2;
   i2 = (i6 | 0) < 1 ? 1 : i6;
   i6 = (i3 | 0) / 2 | 0;
   i26 = i3;
   i3 = (i6 | 0) < 1 ? 1 : i6;
   i6 = Math_imul(i28, i27) | 0;
   i5 = i4;
   i4 = i4 + (Math_imul(Math_imul(i26, i36) | 0, i6) | 0) | 0;
   if ((i26 | 0) > 1) {
    if (!i1) i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((Math_imul(Math_imul(i2, i36) | 0, i29) | 0) + i36 | 0, 1, gb + 64016 | 0, 0, gb + 404494 | 0, 349) | 0;
    if ((i3 | 0) > 0) {
     i26 = Math_imul(i28, i36) | 0;
     i14 = Math_imul(i6, i36) | 0;
     i15 = Math_imul(i29, i36) | 0;
     i16 = Math_imul(Math_imul(i2, i54) | 0, i29) | 0;
     i17 = (i16 | 0) > 0;
     i18 = Math_imul(Math_imul(i2, i55) | 0, i29) | 0;
     i19 = (i18 | 0) > 0;
     i20 = Math_imul(Math_imul(i2, i36) | 0, i29) | 0;
     i21 = (i20 | 0) > 0;
     i24 = i56 & ((i27 | 0) > 0 & (i28 | 0) > 0) & i33;
     i23 = i56 & ((i2 | 0) > 0 & (i29 | 0) > 0) & i33;
     i25 = (i1 | 0) != 0 & i23;
     i22 = (i1 | 0) == 0;
     i12 = i4;
     i13 = 0;
     while (1) {
      HEAP32[i38 >> 2] = i28;
      HEAP32[i39 >> 2] = i27;
      HEAP32[i66 >> 2] = i65;
      HEAP32[i40 >> 2] = i26;
      i7 = (i5 | 0) != 0 & i24;
      HEAP32[i41 >> 2] = i7 ? i5 : 0;
      i6 = i5 + i14 | 0;
      HEAP32[i42 >> 2] = i28;
      HEAP32[i43 >> 2] = i27;
      HEAP32[i67 >> 2] = i65;
      HEAP32[i44 >> 2] = i26;
      HEAP32[i45 >> 2] = (i6 | 0) != 0 & i24 ? i6 : 0;
      HEAP32[i46 >> 2] = i29;
      HEAP32[i47 >> 2] = i2;
      HEAP32[i68 >> 2] = i65;
      HEAP32[i48 >> 2] = i15;
      if ((i12 | 0) != 0 & i23) {
       HEAP32[i49 >> 2] = i12;
       if (!((i12 | 0) == 0 | ((i5 | 0) == 0 | i7 ^ 1))) __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i66, i68, 2);
      } else HEAP32[i49 >> 2] = 0;
      i5 = i6 + i14 | 0;
      HEAP32[i50 >> 2] = i29;
      HEAP32[i51 >> 2] = i2;
      HEAP32[i69 >> 2] = i65;
      HEAP32[i52 >> 2] = i15;
      if (i25) {
       HEAP32[i53 >> 2] = i1;
       if (!(i22 | (HEAP32[i45 >> 2] | 0) == 0)) __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i67, i69, 2);
      } else HEAP32[i53 >> 2] = 0;
      L27 : do if (i34) {
       if (!i37) {
        if (i19) i6 = 0; else break;
        while (1) {
         i11 = i12 + (i6 << 2) | 0;
         f72 = Math_fround(HEAPF32[i11 >> 2]);
         HEAPF32[i11 >> 2] = Math_fround(Math_fround(f72 + Math_fround(HEAPF32[i1 + (i6 << 2) >> 2])) * Math_fround(.5));
         i6 = i6 + 1 | 0;
         if ((i6 | 0) >= (i18 | 0)) break L27;
        }
       }
       if (i17) {
        i10 = 0;
        do {
         i11 = i12 + (i10 << 1) | 0;
         i8 = HEAPU16[i11 >> 1] | 0;
         i6 = i8 & 32767;
         L36 : do if (!i6) i6 = 0; else {
          i6 = i6 << 13;
          i7 = i6 & 260046848;
          L38 : do if ((i7 | 0) < 260046848) {
           switch (i7 | 0) {
           case 0:
            break;
           default:
            break L38;
           }
           f72 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
           i6 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
           break L36;
          } else {
           switch (i7 | 0) {
           case 260046848:
            break;
           default:
            break L38;
           }
           i6 = i6 | 1879048192;
           break L36;
          } while (0);
          i6 = i6 + 939524096 | 0;
         } while (0);
         i8 = i6 | i8 << 16 & -2147483648;
         i9 = HEAPU16[i1 + (i10 << 1) >> 1] | 0;
         i6 = i9 & 32767;
         L45 : do if (!i6) i6 = 0; else {
          i6 = i6 << 13;
          i7 = i6 & 260046848;
          L47 : do if ((i7 | 0) < 260046848) {
           switch (i7 | 0) {
           case 0:
            break;
           default:
            break L47;
           }
           f72 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
           i6 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
           break L45;
          } else {
           switch (i7 | 0) {
           case 260046848:
            break;
           default:
            break L47;
           }
           i6 = i6 | 1879048192;
           break L45;
          } while (0);
          i6 = i6 + 939524096 | 0;
         } while (0);
         f72 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         f72 = Math_fround(Math_fround(f72 + (HEAP32[tempDoublePtr >> 2] = i6 | i9 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
         i8 = (HEAPF32[tempDoublePtr >> 2] = f72, HEAP32[tempDoublePtr >> 2] | 0);
         i9 = i8 >>> 23 & 255;
         HEAP16[i11 >> 1] = i8 >>> 16 & 32768 | HEAPU16[gb + 1477124 + (i9 << 1) >> 1] | (i8 & 8388607) >>> (HEAPU8[gb + 1546331 + i9 >> 0] | 0);
         i10 = i10 + 1 | 0;
        } while ((i10 | 0) < (i16 | 0));
       }
      } else if (i21) {
       i6 = 0;
       do {
        i11 = i12 + i6 | 0;
        HEAP8[i11 >> 0] = ((HEAPU8[i1 + i6 >> 0] | 0) + (HEAPU8[i11 >> 0] | 0) | 0) >>> 1;
        i6 = i6 + 1 | 0;
       } while ((i6 | 0) < (i20 | 0));
      } while (0);
      i13 = i13 + 1 | 0;
      if ((i13 | 0) >= (i3 | 0)) break; else i12 = i12 + i20 | 0;
     }
    }
   } else {
    i26 = Math_imul(i28, i36) | 0;
    HEAP32[i57 >> 2] = i28;
    HEAP32[i58 >> 2] = i27;
    HEAP32[i66 >> 2] = i65;
    HEAP32[i59 >> 2] = i26;
    if (!i5) i70 = 40; else if (!(i56 & ((i27 | 0) > 0 & (i28 | 0) > 0) & i32)) i70 = 40;
    if ((i70 | 0) == 40) {
     i70 = 0;
     i5 = 0;
    }
    HEAP32[i60 >> 2] = i5;
    i28 = Math_imul(i29, i36) | 0;
    HEAP32[i61 >> 2] = i29;
    HEAP32[i62 >> 2] = i2;
    HEAP32[i67 >> 2] = i65;
    HEAP32[i63 >> 2] = i28;
    if (!i4) i70 = 43; else if (i56 & ((i2 | 0) > 0 & (i29 | 0) > 0) & i31) {
     HEAP32[i64 >> 2] = i4;
     if (i5 | 0) __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i66, i67, 2);
    } else i70 = 43;
    if ((i70 | 0) == 43) {
     i70 = 0;
     HEAP32[i64 >> 2] = 0;
    }
   }
   i30 = i30 + 1 | 0;
  } while ((i30 | 0) < (i35 | 0));
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 STACKTOP = i71;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i3, i9, i1, i2) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i12 = i13;
 i11 = i3 + ((i1 >> 1) * 12 | 0) | 0;
 if ((i1 | 0) < 65) {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i12;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i9, i11) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  STACKTOP = i13;
  return;
 }
 i4 = i1 >> 3;
 i5 = i4 << 1;
 i8 = i3 + (i4 * 12 | 0) | 0;
 i1 = i3 + (i5 * 12 | 0) | 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i1, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i3 = 0 - i4 | 0;
 i2 = i11 + (i3 * 12 | 0) | 0;
 i1 = i11 + (i4 * 12 | 0) | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i2 = i9 + ((0 - i5 | 0) * 12 | 0) | 0;
 i1 = i9 + (i3 * 12 | 0) | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i9, i1) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 };
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i3, i9, i1, i2) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i12 = i13;
 i11 = i3 + ((i1 >> 1) * 12 | 0) | 0;
 if ((i1 | 0) < 65) {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i12;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i9, i11) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i3) | 0) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  STACKTOP = i13;
  return;
 }
 i4 = i1 >> 3;
 i5 = i4 << 1;
 i8 = i3 + (i4 * 12 | 0) | 0;
 i1 = i3 + (i5 * 12 | 0) | 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i1, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i8, i3) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i3 = 0 - i4 | 0;
 i2 = i11 + (i3 * 12 | 0) | 0;
 i1 = i11 + (i4 * 12 | 0) | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i2 = i9 + ((0 - i5 | 0) * 12 | 0) | 0;
 i1 = i9 + (i3 * 12 | 0) | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i9, i1) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i1, i2) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 i5 = i12;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i1, i11) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i12, i11, i8) | 0) {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 };
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN5physx23PxVehicleDriveSimData4W17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i20 >> 2] = HEAP32[gb + 160912 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 160912 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 160912 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 160912 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 160912 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 160912 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 160912 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 160912 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 160944 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 160944 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 160944 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 160944 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 160944 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 160944 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 160944 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 160944 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 160976 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 160976 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 160976 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 160976 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 160976 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 160976 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 160976 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 160976 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 161008 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 161008 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 161008 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 161008 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 161008 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 161008 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 161008 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 161008 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 161040 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 161040 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 161040 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 161040 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 161040 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 161040 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 161040 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 161040 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 161072 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 161072 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 161072 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 161072 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 161072 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 161072 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 161072 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 161072 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 161104 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 161104 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 161104 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 161104 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 161104 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 161104 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 161104 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 161104 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 161136 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 161136 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 161136 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 161136 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 161136 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 161136 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 161136 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 161136 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 161168 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 161168 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 161168 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 161168 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 161168 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 161168 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 161168 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 161168 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 161200 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 161200 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 161200 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 161200 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 161200 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 161200 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 161200 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 161200 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 161232 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 161232 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 161232 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 161232 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 161232 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 161232 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 161232 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 161232 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 161264 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 161264 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 161264 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 161264 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 161264 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 161264 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 161264 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 161264 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 161296 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 161296 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 161296 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 161296 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 161296 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 161296 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 161296 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 161296 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 161328 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 161328 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 161328 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 161328 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 161328 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 161328 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 161328 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 161328 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 161360 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 161360 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 161360 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 161360 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 161360 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 161360 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 161360 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 161360 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 828505;
 HEAP32[i5 + 4 >> 2] = gb + 827821;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 576;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 161392 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 161392 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 161392 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 161392 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 161392 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 161392 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 161392 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 161392 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 161424 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 161424 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 161424 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 161424 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 161424 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 161424 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 161424 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 161424 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN9ShaderLab21SerializedShaderState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 56 | 0;
 i13 = i21 + 48 | 0;
 i12 = i21 + 40 | 0;
 i11 = i21 + 32 | 0;
 i15 = i21 + 24 | 0;
 i14 = i21 + 16 | 0;
 i10 = i21 + 8 | 0;
 i9 = i21;
 i5 = i21 + 60 | 0;
 i8 = i21 + 64 | 0;
 i6 = i18 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i7 = i18 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i20 = i19 + 16 | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i17 = i19 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i20 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i18 >> 2] | 0 : i18;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i20 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
 HEAP32[i9 >> 2] = 0;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i9);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 64 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i10 >> 2] = 1;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i10);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 120 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i14 >> 2] = 2;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i14);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 176 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i15 >> 2] = 3;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i15);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 232 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i11 >> 2] = 4;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i11);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 288 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i12 >> 2] = 5;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i12);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 344 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i13 >> 2] = 6;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i13);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 400 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i16 >> 2] = 7;
 __Z6FormatPKcz(i8, gb + 471386 | 0, i16);
 __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 456 | 0, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = i18 + 717 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
 i1 = i18 + 16 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 20 | 0, i19);
 i1 = i18 + 24 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 28 | 0, i19);
 i1 = i18 + 32 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 36 | 0, i19);
 i1 = i18 + 40 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 44 | 0, i19);
 i1 = i18 + 48 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 52 | 0, i19);
 i1 = i18 + 56 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 60 | 0, i19);
 __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 512 | 0, i19);
 __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 544 | 0, i19);
 __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 576 | 0, i19);
 i1 = i18 + 608 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 612 | 0, i19);
 i1 = i18 + 616 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 620 | 0, i19);
 i1 = i18 + 624 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 628 | 0, i19);
 i1 = i18 + 632 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 636 | 0, i19);
 i1 = i18 + 640 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 644 | 0, i19);
 i1 = i18 + 648 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 652 | 0, i19);
 __ZN9ShaderLab27SerializedShaderVectorValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 656 | 0, i19);
 i5 = i18 + 692 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i16 >> 2] = i1;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i20 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i16, 4);
  i3 = HEAP32[i20 >> 2] | 0;
  i4 = HEAP32[i17 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
 i1 = i18 + 696 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
 __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i18 + 700 | 0, i19);
 i1 = i18 + 712 | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i20 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 4);
  i4 = HEAP32[i20 >> 2] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
 }
 i1 = i18 + 716 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
  STACKTOP = i21;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i20, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i19);
  STACKTOP = i21;
  return;
 }
}

function __ZNK15TerrainRenderer27CreateSharedMeshDataPatchesER13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB(i6, i50, i51) {
 i6 = i6 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i55 + 56 | 0;
 i54 = i55;
 i53 = i55 + 64 | 0;
 i4 = i6 + 72 | 0;
 HEAP32[i54 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i52, i1, i54);
   i2 = HEAP32[i52 >> 2] | 0;
   i49 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i49 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i49 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i1 = i1 + 248 | 0;
 i46 = i6 + 28 | 0;
 i45 = HEAP32[i46 >> 2] | 0;
 i47 = 1 << i45;
 i48 = i50 + 12 | 0;
 HEAP32[i48 >> 2] = 0;
 i49 = i50 + 16 | 0;
 if ((i45 | 0) == 31) {
  STACKTOP = i55;
  return;
 }
 i36 = i6 + 16 | 0;
 i37 = i53 + 4 | 0;
 i38 = i53 + 8 | 0;
 i39 = i53 + 12 | 0;
 i40 = i53 + 16 | 0;
 i41 = i53 + 20 | 0;
 i42 = i1 + 88 | 0;
 i43 = i1 + 92 | 0;
 i44 = i1 + 96 | 0;
 i45 = i1 + 76 | 0;
 i22 = i1 + 4 | 0;
 i23 = i54 + 4 | 0;
 i24 = i54 + 8 | 0;
 i25 = i54 + 32 | 0;
 i26 = i54 + 48 | 0;
 i27 = i54 + 36 | 0;
 i28 = i54 + 40 | 0;
 i29 = i50 + 4 | 0;
 i30 = i54 + 28 | 0;
 i31 = i54 + 24 | 0;
 i32 = i54 + 20 | 0;
 i33 = i54 + 16 | 0;
 i34 = i54 + 12 | 0;
 i21 = 0;
 do {
  i35 = i21 << 4;
  i20 = 0;
  do {
   i19 = (i21 << HEAP32[i46 >> 2]) + i20 | 0;
   i18 = HEAP32[i36 >> 2] | 0;
   HEAP32[i53 >> 2] = HEAP32[i18 + (i19 << 6) + 36 >> 2];
   HEAP32[i37 >> 2] = HEAP32[i18 + (i19 << 6) + 40 >> 2];
   HEAP32[i38 >> 2] = HEAP32[i18 + (i19 << 6) + 44 >> 2];
   HEAP32[i39 >> 2] = HEAP32[i18 + (i19 << 6) + 48 >> 2];
   HEAP32[i40 >> 2] = HEAP32[i18 + (i19 << 6) + 52 >> 2];
   HEAP32[i41 >> 2] = HEAP32[i18 + (i19 << 6) + 56 >> 2];
   if (__Z17IntersectAABBAABBRK4AABBS1_(i53, i51) | 0) {
    i2 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 930611 | 0, 814) | 0;
    i14 = gb + 63232 | 0;
    i1 = HEAP32[i14 >> 2] | 0;
    i14 = HEAP32[i14 + 4 >> 2] | 0;
    HEAP32[i2 + 4 >> 2] = 1;
    HEAP32[i2 >> 2] = gb + 58104 + 8;
    i3 = i2 + 8 | 0;
    __ZN14VertexDataInfoC2Ev(i3);
    i15 = i2 + 112 | 0;
    HEAP32[i15 >> 2] = 0;
    i16 = i2 + 116 | 0;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i2 + 120 >> 2] = 0;
    HEAP32[i2 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    i17 = i2 + 128 | 0;
    HEAP32[i17 >> 2] = 0;
    i18 = i2 + 132 | 0;
    HEAP32[i18 >> 2] = 0;
    i19 = i2 + 136 | 0;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i2 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    i10 = i54;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i2 + 144 >> 2] = 0;
    HEAP32[i2 + 156 >> 2] = 0;
    HEAP32[i2 + 160 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i54);
    i10 = i52;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 148 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i54;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i14;
    HEAP32[i2 + 164 >> 2] = 0;
    HEAP32[i2 + 176 >> 2] = 0;
    HEAP32[i2 + 180 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i54);
    i12 = i52;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i2 + 168 | 0;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i54;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i2 + 184 >> 2] = 0;
    HEAP32[i2 + 196 >> 2] = 0;
    HEAP32[i2 + 200 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i54);
    i10 = i52;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 188 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i54;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i14;
    HEAP32[i2 + 204 >> 2] = 0;
    HEAP32[i2 + 216 >> 2] = 0;
    HEAP32[i2 + 220 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, i54);
    i12 = i52;
    i14 = HEAP32[i12 + 4 >> 2] | 0;
    i1 = i2 + 208 | 0;
    HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i1 + 4 >> 2] = i14;
    __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i3, 289, 1, 0, gb + 59212 | 0, gb + 1546313 | 0);
    i1 = HEAP32[i2 + 92 >> 2] | 0;
    if (!i1) {
     i14 = 0;
     i4 = 1;
    } else if (!(HEAP8[i2 + 11 >> 0] | 0)) {
     i14 = 0;
     i4 = 1;
    } else {
     i14 = HEAP16[i3 >> 1] | 0;
     i14 = i1 + (((i14 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i14 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i4 = HEAPU8[i3 + 32 + ((HEAPU8[i3 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
    f7 = Math_fround(HEAPF32[i42 >> 2]);
    f9 = Math_fround(HEAPF32[i43 >> 2]);
    f8 = Math_fround(HEAPF32[i44 >> 2]);
    f9 = Math_fround(f9 / Math_fround(32766.0));
    i5 = i20 << 4;
    i6 = HEAP32[i45 >> 2] | 0;
    i10 = HEAP32[i22 >> 2] | 0;
    i3 = 0;
    do {
     i1 = i3 + i5 | 0;
     i11 = Math_imul(i1, i6) | 0;
     i12 = i3 * 17 | 0;
     f13 = Math_fround(f7 * Math_fround(i1 | 0));
     i1 = 0;
     do {
      i57 = i1 + i35 | 0;
      f58 = Math_fround(f9 * Math_fround(HEAP16[i10 + (i57 + i11 << 1) >> 1] | 0));
      i56 = i14 + (Math_imul(i1 + i12 | 0, i4) | 0) | 0;
      HEAPF32[i56 >> 2] = f13;
      HEAPF32[i56 + 4 >> 2] = f58;
      HEAPF32[i56 + 8 >> 2] = Math_fround(f8 * Math_fround(i57 | 0));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 17);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 17);
    i5 = __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj(15, i52) | 0;
    i6 = HEAP32[i52 >> 2] << 1;
    i4 = HEAP32[i16 >> 2] | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = i4 - i1 | 0;
    if (i6 >>> 0 > i3 >>> 0) {
     __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i15, i6 - i3 | 0);
     i1 = HEAP32[i15 >> 2] | 0;
    } else if (i6 >>> 0 < i3 >>> 0) {
     i3 = i1 + i6 | 0;
     if ((i4 | 0) != (i3 | 0)) HEAP32[i16 >> 2] = i3;
    }
    _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
    HEAP32[i54 >> 2] = 0;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    HEAP32[i25 + 12 >> 2] = 0;
    HEAP32[i26 >> 2] = 289;
    HEAP32[i27 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i24 >> 2] = HEAP32[i53 >> 2];
    HEAP32[i24 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
    HEAP32[i24 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
    HEAP32[i24 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
    HEAP32[i24 + 16 >> 2] = HEAP32[i53 + 16 >> 2];
    HEAP32[i24 + 20 >> 2] = HEAP32[i53 + 20 >> 2];
    HEAP32[i28 >> 2] = 1;
    i1 = HEAP32[i18 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i19 >> 2] | 0)) __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i17, i54); else {
     i19 = i54;
     i56 = HEAP32[i19 + 4 >> 2] | 0;
     i57 = i1;
     HEAP32[i57 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i57 + 4 >> 2] = i56;
     HEAP32[i1 + 8 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i34 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i32 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i30 >> 2];
     i57 = i1 + 32 | 0;
     HEAP32[i57 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i57 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
     HEAP32[i57 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
     HEAP32[i57 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
     HEAP32[i57 + 16 >> 2] = HEAP32[i25 + 16 >> 2];
     HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 52;
    }
    i3 = HEAP32[i48 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i49 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i49 >> 2] = i1;
      HEAP32[i50 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i50 >> 2] | 0, i1 << 2, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i57 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i57 | 0, HEAP32[i50 >> 2] | 0, HEAP32[i48 >> 2] << 2 | 0) | 0;
      HEAP32[i49 >> 2] = i1;
      HEAP32[i50 >> 2] = i57;
      break;
     }
    } while (0);
    HEAP32[i48 >> 2] = i4;
    HEAP32[(HEAP32[i50 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) < (i47 | 0));
  i21 = i21 + 1 | 0;
 } while ((i21 | 0) < (i47 | 0));
 STACKTOP = i55;
 return;
}

function __ZNK6Camera27CalculateViewportRayVectorsERK5RectTIfEf21MonoOrStereoscopicEyeP8Vector3f(i1, i6, f27, i2, i28) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 f27 = Math_fround(f27);
 i2 = i2 | 0;
 i28 = i28 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i30;
 if ((i2 | 0) == 2) i1 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0; else {
  if (HEAP8[i1 + 1084 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) {
   i3 = __Z12GetIVRDevicev() | 0;
   mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i29 | 0, i3 | 0, i1 | 0, i2 | 0);
   i3 = i1 + 424 + (i2 << 6) | 0;
   i4 = i29;
   i5 = i3 + 64 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
  }
  i1 = i1 + 424 + (i2 << 6) | 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i1, i29) | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f26 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f12 = Math_fround(f12 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(HEAPF32[i6 + 12 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 * Math_fround(2.0)) + Math_fround(-1.0));
 f26 = Math_fround(Math_fround(f26 * Math_fround(2.0)) + Math_fround(-1.0));
 f13 = Math_fround(HEAPF32[i29 + 12 >> 2]);
 f10 = Math_fround(f11 * f13);
 f9 = Math_fround(HEAPF32[i29 + 28 >> 2]);
 f18 = Math_fround(f26 * f9);
 f7 = Math_fround(f10 + f18);
 f19 = Math_fround(Math_fround(HEAPF32[i29 + 44 >> 2]) * Math_fround(.949999988));
 f7 = Math_fround(f7 + f19);
 f20 = Math_fround(HEAPF32[i29 + 60 >> 2]);
 f7 = Math_fround(f20 + f7);
 i24 = f7 < Math_fround(0.0);
 f25 = Math_fround(-f7);
 if ((i24 ? f25 : f7) > Math_fround(1.00000001e-07)) {
  f25 = Math_fround(f11 * Math_fround(HEAPF32[i29 + 8 >> 2]));
  f25 = Math_fround(f25 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 24 >> 2])));
  f25 = Math_fround(f25 + Math_fround(Math_fround(HEAPF32[i29 + 40 >> 2]) * Math_fround(.949999988)));
  f25 = Math_fround(Math_fround(HEAPF32[i29 + 56 >> 2]) + f25);
  f23 = Math_fround(f11 * Math_fround(HEAPF32[i29 + 4 >> 2]));
  f23 = Math_fround(f23 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 20 >> 2])));
  f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i29 + 36 >> 2]) * Math_fround(.949999988)));
  f23 = Math_fround(Math_fround(HEAPF32[i29 + 52 >> 2]) + f23);
  f21 = Math_fround(f11 * Math_fround(HEAPF32[i29 >> 2]));
  f21 = Math_fround(f21 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 16 >> 2])));
  f21 = Math_fround(f21 + Math_fround(Math_fround(HEAPF32[i29 + 32 >> 2]) * Math_fround(.949999988)));
  f17 = Math_fround(Math_fround(1.0) / f7);
  f21 = Math_fround(f17 * Math_fround(Math_fround(HEAPF32[i29 + 48 >> 2]) + f21));
  f23 = Math_fround(f17 * f23);
  f25 = Math_fround(f17 * f25);
 } else {
  f21 = Math_fround(0.0);
  f23 = Math_fround(0.0);
  f25 = Math_fround(0.0);
 }
 HEAPF32[i28 >> 2] = f21;
 i22 = i28 + 4 | 0;
 HEAPF32[i22 >> 2] = f23;
 i24 = i28 + 8 | 0;
 HEAPF32[i24 >> 2] = f25;
 f14 = Math_fround(f26 + f8);
 f8 = Math_fround(f14 * f9);
 f7 = Math_fround(f20 + Math_fround(Math_fround(f10 + f8) + f19));
 i6 = f7 < Math_fround(0.0);
 f17 = Math_fround(-f7);
 if ((i6 ? f17 : f7) > Math_fround(1.00000001e-07)) {
  f17 = Math_fround(f11 * Math_fround(HEAPF32[i29 + 8 >> 2]));
  f17 = Math_fround(f17 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 24 >> 2])));
  f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i29 + 40 >> 2]) * Math_fround(.949999988)));
  f17 = Math_fround(Math_fround(HEAPF32[i29 + 56 >> 2]) + f17);
  f16 = Math_fround(f11 * Math_fround(HEAPF32[i29 + 4 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 20 >> 2])));
  f16 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i29 + 36 >> 2]) * Math_fround(.949999988)));
  f16 = Math_fround(Math_fround(HEAPF32[i29 + 52 >> 2]) + f16);
  f15 = Math_fround(f11 * Math_fround(HEAPF32[i29 >> 2]));
  f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 16 >> 2])));
  f15 = Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i29 + 32 >> 2]) * Math_fround(.949999988)));
  f10 = Math_fround(Math_fround(1.0) / f7);
  f15 = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i29 + 48 >> 2]) + f15));
  f16 = Math_fround(f10 * f16);
  f17 = Math_fround(f10 * f17);
 } else {
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
  f17 = Math_fround(0.0);
 }
 i4 = i28 + 12 | 0;
 HEAPF32[i4 >> 2] = f15;
 i5 = i28 + 16 | 0;
 HEAPF32[i5 >> 2] = f16;
 i6 = i28 + 20 | 0;
 HEAPF32[i6 >> 2] = f17;
 f12 = Math_fround(f11 + f12);
 f11 = Math_fround(f12 * f13);
 f7 = Math_fround(f20 + Math_fround(Math_fround(f11 + f8) + f19));
 i3 = f7 < Math_fround(0.0);
 f13 = Math_fround(-f7);
 if ((i3 ? f13 : f7) > Math_fround(1.00000001e-07)) {
  f10 = Math_fround(f12 * Math_fround(HEAPF32[i29 + 8 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 24 >> 2])));
  f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i29 + 40 >> 2]) * Math_fround(.949999988)));
  f10 = Math_fround(Math_fround(HEAPF32[i29 + 56 >> 2]) + f10);
  f9 = Math_fround(f12 * Math_fround(HEAPF32[i29 + 4 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 20 >> 2])));
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i29 + 36 >> 2]) * Math_fround(.949999988)));
  f9 = Math_fround(Math_fround(HEAPF32[i29 + 52 >> 2]) + f9);
  f8 = Math_fround(f12 * Math_fround(HEAPF32[i29 >> 2]));
  f8 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i29 + 16 >> 2])));
  f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i29 + 32 >> 2]) * Math_fround(.949999988)));
  f14 = Math_fround(Math_fround(1.0) / f7);
  f8 = Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i29 + 48 >> 2]) + f8));
  f9 = Math_fround(f14 * f9);
  f10 = Math_fround(f14 * f10);
 } else {
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
 }
 i1 = i28 + 24 | 0;
 HEAPF32[i1 >> 2] = f8;
 i2 = i28 + 28 | 0;
 HEAPF32[i2 >> 2] = f9;
 i3 = i28 + 32 | 0;
 HEAPF32[i3 >> 2] = f10;
 f7 = Math_fround(f20 + Math_fround(Math_fround(f11 + f18) + f19));
 i31 = f7 < Math_fround(0.0);
 f20 = Math_fround(-f7);
 if (!((i31 ? f20 : f7) > Math_fround(1.00000001e-07))) {
  f26 = Math_fround(0.0);
  f20 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  i32 = i28 + 36 | 0;
  i29 = i28 + 40 | 0;
  i31 = i28 + 44 | 0;
  f14 = Math_fround(-f25);
  f18 = Math_fround(-f17);
  f25 = Math_fround(-f10);
  f26 = Math_fround(-f26);
  f17 = Math_fround(f27 / f14);
  f21 = Math_fround(f21 * f17);
  HEAPF32[i28 >> 2] = f21;
  f23 = Math_fround(f17 * f23);
  HEAPF32[i22 >> 2] = f23;
  f23 = Math_fround(f17 * f14);
  HEAPF32[i24 >> 2] = f23;
  f23 = Math_fround(f27 / f18);
  f21 = Math_fround(f15 * f23);
  HEAPF32[i4 >> 2] = f21;
  f21 = Math_fround(f23 * f16);
  HEAPF32[i5 >> 2] = f21;
  f23 = Math_fround(f23 * f18);
  HEAPF32[i6 >> 2] = f23;
  f23 = Math_fround(f27 / f25);
  f21 = Math_fround(f8 * f23);
  HEAPF32[i1 >> 2] = f21;
  f21 = Math_fround(f23 * f9);
  HEAPF32[i2 >> 2] = f21;
  f25 = Math_fround(f23 * f25);
  HEAPF32[i3 >> 2] = f25;
  f27 = Math_fround(f27 / f26);
  f25 = Math_fround(f19 * f27);
  HEAPF32[i32 >> 2] = f25;
  f25 = Math_fround(f27 * f20);
  HEAPF32[i29 >> 2] = f25;
  f27 = Math_fround(f27 * f26);
  HEAPF32[i31 >> 2] = f27;
  STACKTOP = i30;
  return;
 }
 f18 = Math_fround(f12 * Math_fround(HEAPF32[i29 + 8 >> 2]));
 f18 = Math_fround(f18 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 24 >> 2])));
 f18 = Math_fround(f18 + Math_fround(Math_fround(HEAPF32[i29 + 40 >> 2]) * Math_fround(.949999988)));
 f18 = Math_fround(Math_fround(HEAPF32[i29 + 56 >> 2]) + f18);
 f20 = Math_fround(f12 * Math_fround(HEAPF32[i29 + 4 >> 2]));
 f20 = Math_fround(f20 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 20 >> 2])));
 f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i29 + 36 >> 2]) * Math_fround(.949999988)));
 f20 = Math_fround(Math_fround(HEAPF32[i29 + 52 >> 2]) + f20);
 f19 = Math_fround(f12 * Math_fround(HEAPF32[i29 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f26 * Math_fround(HEAPF32[i29 + 16 >> 2])));
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i29 + 32 >> 2]) * Math_fround(.949999988)));
 f14 = Math_fround(Math_fround(1.0) / f7);
 f26 = Math_fround(f14 * f18);
 f20 = Math_fround(f14 * f20);
 f19 = Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i29 + 48 >> 2]) + f19));
 i29 = i28 + 36 | 0;
 i31 = i28 + 40 | 0;
 i32 = i28 + 44 | 0;
 f14 = Math_fround(-f25);
 f18 = Math_fround(-f17);
 f25 = Math_fround(-f10);
 f26 = Math_fround(-f26);
 f17 = Math_fround(f27 / f14);
 f21 = Math_fround(f21 * f17);
 HEAPF32[i28 >> 2] = f21;
 f23 = Math_fround(f17 * f23);
 HEAPF32[i22 >> 2] = f23;
 f23 = Math_fround(f17 * f14);
 HEAPF32[i24 >> 2] = f23;
 f23 = Math_fround(f27 / f18);
 f21 = Math_fround(f15 * f23);
 HEAPF32[i4 >> 2] = f21;
 f21 = Math_fround(f23 * f16);
 HEAPF32[i5 >> 2] = f21;
 f23 = Math_fround(f23 * f18);
 HEAPF32[i6 >> 2] = f23;
 f23 = Math_fround(f27 / f25);
 f21 = Math_fround(f8 * f23);
 HEAPF32[i1 >> 2] = f21;
 f21 = Math_fround(f23 * f9);
 HEAPF32[i2 >> 2] = f21;
 f25 = Math_fround(f23 * f25);
 HEAPF32[i3 >> 2] = f25;
 f27 = Math_fround(f27 / f26);
 f25 = Math_fround(f19 * f27);
 HEAPF32[i29 >> 2] = f25;
 f25 = Math_fround(f27 * f20);
 HEAPF32[i31 >> 2] = f25;
 f27 = Math_fround(f27 * f26);
 HEAPF32[i32 >> 2] = f27;
 STACKTOP = i30;
 return;
}

function __ZN17ProceduralTexture8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN7Texture8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i2 = i6 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431722 | 0, gb + 431742 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI18ProceduralMaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 192 | 0;
 i5 = HEAP32[gb + 37296 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431767 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 8 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     i12 = i2;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     i2 = i4;
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
   if (HEAP32[i9 >> 2] & 512 | 0) {
    i11 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    i12 = i4 + 4 | 0;
    HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i11;
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ProceduralOutputTypeEvRT_RT0_PKc17TransferMetaFlags(i9, i6 + 156 | 0, gb + 773725 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ProceduralOutputTypeEvRT_RT0_PKc17TransferMetaFlags(i9, i6 + 164 | 0, gb + 431789 | 0, 0);
 i4 = i6 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431801 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i12 >>> 0) i8 = 23; else {
    i3 = i2 + 8 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
     i5 = i2;
     i11 = HEAP32[i5 + 4 >> 2] | 0;
     i12 = i4;
     HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
   if (HEAP32[i9 >> 2] & 512 | 0) {
    i11 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    i12 = i4 + 4 | 0;
    HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i11;
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 180 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431818 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i12 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 181 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431841 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i12 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 184 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431865 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i12 >>> 0) i8 = 52; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 52; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = i6 + 176 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21SubstanceOutputFormatEvRT_RT0_PKc17TransferMetaFlags(i9, i1, gb + 673385 | 0, 0);
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 3) HEAP32[i1 >> 2] = 0;
 i2 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431875 | 0, gb + 431893 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431911 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431923 | 0, gb + 431941 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN17ProceduralTexture17TextureParametersEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431959 | 0, gb + 431941 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN17ProceduralTexture17TextureParametersEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431979 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i12 >>> 0) i8 = 89; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 89; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932818 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i12 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i12 >>> 0) i8 = 100; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 100; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 100) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN17AmbientProbeBaker16BakeAmbientProbeEP8MaterialR20SphericalHarmonicsL2(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18;
 i12 = i18 + 200 | 0;
 i13 = i18 + 184 | 0;
 i14 = i18 + 160 | 0;
 i6 = i18 + 96 | 0;
 i7 = i18 + 80 | 0;
 i15 = i18 + 16 | 0;
 i16 = i18 + 4 | 0;
 __ZN20SphericalHarmonicsL27SetZeroEv(i1);
 if (!i10) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i1 + 4192 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 496 >> 2] | 0, i1 | 0);
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0) {
   i9 = 1;
   i17 = 4;
  } else {
   i1 = 0;
   i17 = 20;
  }
 } else {
  i9 = 0;
  i17 = 4;
 }
 if ((i17 | 0) == 4) {
  if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 235 >> 0] | 0)) i17 = 6; else {
   i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, 64, 64, 1, 2, 0, 0, 0, 1) | 0;
   if (!i1) i17 = 6; else {
    i5 = 6;
    i17 = 7;
   }
  }
  if ((i17 | 0) == 6) {
   i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, 64, 64, 1, 0, 0, 0, 0, 1) | 0;
   if (!i1) i1 = 0; else {
    i5 = 5;
    i17 = 7;
   }
  }
  if ((i17 | 0) == 7) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 252 >> 2] = 0;
   HEAP32[i12 + 256 >> 2] = 0;
   i2 = i12 + 260 | 0;
   i3 = i12 + 16 | 0;
   i4 = i3 + 40 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   HEAP32[i2 >> 2] = 1;
   HEAP32[i12 + 264 >> 2] = 0;
   i8 = i12 + 268 | 0;
   HEAP32[i8 >> 2] = -1;
   HEAP32[i8 + 4 >> 2] = -1;
   HEAP32[i8 + 8 >> 2] = -1;
   HEAP32[i8 + 12 >> 2] = -1;
   HEAP32[i12 + 284 >> 2] = 0;
   HEAP32[i12 + 288 >> 2] = 0;
   HEAP32[i12 + 292 >> 2] = 1;
   HEAP32[i12 + 296 >> 2] = 0;
   i8 = i12 + 300 | 0;
   HEAP32[i8 >> 2] = -1;
   HEAP32[i8 + 4 >> 2] = -1;
   HEAP32[i8 + 8 >> 2] = -1;
   HEAP32[i8 + 12 >> 2] = -1;
   __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext(i12, HEAP32[gb + 1166248 >> 2] | 0);
   i8 = __Z12GetGfxDevicev() | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i13 + 12 >> 2] = 0;
   __ZN5ImageC2Eii13TextureFormat(i14, 64, 64, i5);
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 88 >> 2] | 0, i8 | 0, 1);
   __ZN10Matrix4x4f14SetPerspectiveEffff(i6, Math_fround(90.0), Math_fround(1.0), Math_fround(.100000001), Math_fround(10.0)) | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 116 >> 2] | 0, i8 | 0, i6 | 0);
   i2 = __ZNK14RenderSettings6GetSunEv(__Z17GetRenderSettingsv() | 0) | 0;
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   i3 = i7 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   i5 = i7 + 8 | 0;
   HEAPF32[i5 >> 2] = Math_fround(-1.0);
   if (!i2) {
    i4 = 0;
    i3 = 0;
    i2 = -1082130432;
   } else {
    __ZNK9Transform18TransformDirectionERK8Vector3f(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i7);
    HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    i4 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i7 = i8 + 564 | 0;
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i8 + 548 >> 2] = i4;
   HEAP32[i8 + 552 >> 2] = i3;
   HEAP32[i8 + 556 >> 2] = i2;
   HEAPF32[i8 + 560 >> 2] = Math_fround(0.0);
   i2 = (__ZNK8Material12GetPassCountEv(i10) | 0) == 6;
   if (!(HEAP8[i1 + 118 >> 0] | 0)) i4 = (__Z19GetActiveColorSpacev() | 0) == 0; else i4 = 1;
   i3 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) == 0;
   i5 = i16 + 4 | 0;
   i6 = i16 + 8 | 0;
   if (i2) if (i3) {
    i2 = 0;
    do {
     i22 = i2 * 3 | 0;
     i3 = gb + 1113232 + (i22 * 12 | 0) | 0;
     i7 = gb + 1113232 + ((i22 + 1 | 0) * 12 | 0) | 0;
     i22 = i22 + 2 | 0;
     i23 = gb + 1113232 + (i22 * 12 | 0) | 0;
     __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i15, i3, i7, i23) | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, i15 | 0);
     mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, 7, i13 | 0, 1.0, 0);
     __ZN6Skybox16RenderSingleFaceEP8Materiali(i10, HEAP32[gb + 74084 + (i2 << 2) >> 2] | 0);
     mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 600 >> 2] | 0, i8 | 0, i14 | 0, 0, 0, 64, 64, 0, 0) | 0;
     __ZN14ImageReference10FlipImageYEv(i14);
     f21 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
     f20 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i22 * 12 | 0) + 4 >> 2]));
     f19 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i22 * 12 | 0) + 8 >> 2]));
     HEAPF32[i16 >> 2] = f21;
     HEAPF32[i5 >> 2] = f20;
     HEAPF32[i6 >> 2] = f19;
     __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b(i11, i14, i2, i3, i7, i16, i4);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 6);
   } else {
    i2 = 0;
    do {
     i7 = i2 * 3 | 0;
     i22 = gb + 1113232 + (i7 * 12 | 0) | 0;
     i23 = gb + 1113232 + ((i7 + 1 | 0) * 12 | 0) | 0;
     i7 = i7 + 2 | 0;
     i3 = gb + 1113232 + (i7 * 12 | 0) | 0;
     __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i15, i22, i23, i3) | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, i15 | 0);
     mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, 7, i13 | 0, 1.0, 0);
     __ZN6Skybox16RenderSingleFaceEP8Materiali(i10, HEAP32[gb + 74084 + (i2 << 2) >> 2] | 0);
     mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 600 >> 2] | 0, i8 | 0, i14 | 0, 0, 0, 64, 64, 0, 0) | 0;
     f19 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
     f20 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 4 >> 2]));
     f21 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 8 >> 2]));
     HEAPF32[i16 >> 2] = f19;
     HEAPF32[i5 >> 2] = f20;
     HEAPF32[i6 >> 2] = f21;
     __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b(i11, i14, i2, i22, i23, i16, i4);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 6);
   } else if (i3) {
    i2 = 0;
    do {
     i7 = i2 * 3 | 0;
     i22 = gb + 1113232 + (i7 * 12 | 0) | 0;
     i23 = gb + 1113232 + ((i7 + 1 | 0) * 12 | 0) | 0;
     i7 = i7 + 2 | 0;
     i3 = gb + 1113232 + (i7 * 12 | 0) | 0;
     __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i15, i22, i23, i3) | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, i15 | 0);
     mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, 7, i13 | 0, 1.0, 0);
     __ZN6Skybox14RenderAllFacesEP8Material(i10);
     mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 600 >> 2] | 0, i8 | 0, i14 | 0, 0, 0, 64, 64, 0, 0) | 0;
     __ZN14ImageReference10FlipImageYEv(i14);
     f19 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
     f20 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 4 >> 2]));
     f21 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 8 >> 2]));
     HEAPF32[i16 >> 2] = f19;
     HEAPF32[i5 >> 2] = f20;
     HEAPF32[i6 >> 2] = f21;
     __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b(i11, i14, i2, i22, i23, i16, i4);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 6);
   } else {
    i2 = 0;
    do {
     i7 = i2 * 3 | 0;
     i22 = gb + 1113232 + (i7 * 12 | 0) | 0;
     i23 = gb + 1113232 + ((i7 + 1 | 0) * 12 | 0) | 0;
     i7 = i7 + 2 | 0;
     i3 = gb + 1113232 + (i7 * 12 | 0) | 0;
     __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i15, i22, i23, i3) | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, i15 | 0);
     mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, 7, i13 | 0, 1.0, 0);
     __ZN6Skybox14RenderAllFacesEP8Material(i10);
     mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 600 >> 2] | 0, i8 | 0, i14 | 0, 0, 0, 64, 64, 0, 0) | 0;
     f19 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
     f20 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 4 >> 2]));
     f21 = Math_fround(-Math_fround(HEAPF32[gb + 1113232 + (i7 * 12 | 0) + 8 >> 2]));
     HEAPF32[i16 >> 2] = f19;
     HEAPF32[i5 >> 2] = f20;
     HEAPF32[i6 >> 2] = f21;
     __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b(i11, i14, i2, i22, i23, i16, i4);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 6);
   }
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 88 >> 2] | 0, i8 | 0, 0);
   __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext(i12, HEAP32[gb + 1166248 >> 2] | 0);
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i1);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 + 16 >> 2] | 0, gb + 63184 | 0);
   i1 = 1;
  }
  if (i9 << 24 >> 24) i17 = 20;
 }
 if ((i17 | 0) == 20) {
  i23 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 500 >> 2] | 0, i23 | 0);
 }
 i23 = i1;
 STACKTOP = i18;
 return i23 | 0;
}

function __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i7, i4, i5, i6, i3) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 if (f2 == Math_fround(1.0)) {
  f1 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  if (f1 == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(1.0)) {
   f1 = Math_fround(HEAPF32[i7 >> 2]);
   f26 = Math_fround(f1 + f1);
   f22 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f2 = Math_fround(f22 + f22);
   f17 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f10 = Math_fround(f17 + f17);
   f15 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f9 = Math_fround(f26 * f15);
   f13 = Math_fround(f2 * f15);
   f15 = Math_fround(f15 * f10);
   f16 = Math_fround(f1 * f2);
   f21 = Math_fround(f1 * f10);
   f2 = Math_fround(f22 * f2);
   f22 = Math_fround(f22 * f10);
   f10 = Math_fround(f17 * f10);
   f17 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f10);
   f11 = Math_fround(f16 + f15);
   f8 = Math_fround(f21 - f13);
   f15 = Math_fround(f16 - f15);
   f26 = Math_fround(Math_fround(1.0) - Math_fround(f1 * f26));
   f10 = Math_fround(f26 - f10);
   f1 = Math_fround(f22 + f9);
   f13 = Math_fround(f21 + f13);
   f9 = Math_fround(f22 - f9);
   f2 = Math_fround(f26 - f2);
   f26 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   f22 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f21 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f16 = Math_fround(HEAPF32[i4 >> 2]);
   f20 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f25 = Math_fround(f16 + f20);
   f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   f24 = Math_fround(f14 + f19);
   f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i4 + 20 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.5));
   f24 = Math_fround(f24 * Math_fround(.5));
   f23 = Math_fround(Math_fround(f12 + f18) * Math_fround(.5));
   f22 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f11 * f25) + Math_fround(f10 * f24)) + Math_fround(f9 * f23)));
   f21 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f8 * f25) + Math_fround(f1 * f24)) + Math_fround(f2 * f23)));
   HEAPF32[i6 >> 2] = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f17 * f25) + Math_fround(f15 * f24)) + Math_fround(f13 * f23)));
   HEAPF32[i6 + 4 >> 2] = f22;
   HEAPF32[i6 + 8 >> 2] = f21;
   f16 = Math_fround(Math_fround(f20 - f16) * Math_fround(.5));
   f14 = Math_fround(Math_fround(f19 - f14) * Math_fround(.5));
   f12 = Math_fround(Math_fround(f18 - f12) * Math_fround(.5));
   f11 = Math_fround(f11 * f16);
   f8 = Math_fround(f8 * f16);
   f10 = Math_fround(f10 * f14);
   f1 = Math_fround(f1 * f14);
   f9 = Math_fround(f9 * f12);
   f2 = Math_fround(f2 * f12);
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f17 * f16))) + Math_fround(Math_abs(Math_fround(f15 * f14)))) + Math_fround(Math_abs(Math_fround(f13 * f12))));
   HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f11))) + Math_fround(Math_abs(Math_fround(f10)))) + Math_fround(Math_abs(Math_fround(f9))));
   HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f8))) + Math_fround(Math_abs(Math_fround(f1)))) + Math_fround(Math_abs(Math_fround(f2))));
   return;
  } else f1 = Math_fround(1.0);
 } else f1 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 f33 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f34 = Math_fround(f10 + f10);
 f20 = Math_fround(f33 + f33);
 f8 = Math_fround(f31 + f31);
 f12 = Math_fround(f33 * f20);
 f23 = Math_fround(f31 * f8);
 f33 = Math_fround(f34 * f33);
 f29 = Math_fround(f34 * f31);
 f13 = Math_fround(f34 * f19);
 f31 = Math_fround(f20 * f31);
 f20 = Math_fround(f20 * f19);
 f19 = Math_fround(f8 * f19);
 f8 = Math_fround(Math_fround(Math_fround(1.0) - f12) - f23);
 f18 = Math_fround(f33 + f19);
 f11 = Math_fround(f29 - f20);
 f19 = Math_fround(f33 - f19);
 f34 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f34));
 f23 = Math_fround(f34 - f23);
 f10 = Math_fround(f31 + f13);
 f20 = Math_fround(f29 + f20);
 f13 = Math_fround(f31 - f13);
 f12 = Math_fround(f34 - f12);
 f34 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f33 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f32 = Math_fround(f34 + f34);
 f9 = Math_fround(f31 + f31);
 f25 = Math_fround(f29 + f29);
 f28 = Math_fround(f31 * f9);
 f14 = Math_fround(f29 * f25);
 f31 = Math_fround(f32 * f31);
 f21 = Math_fround(f32 * f29);
 f15 = Math_fround(f32 * f33);
 f29 = Math_fround(f9 * f29);
 f9 = Math_fround(f9 * f33);
 f33 = Math_fround(f25 * f33);
 f25 = Math_fround(Math_fround(Math_fround(1.0) - f28) - f14);
 f22 = Math_fround(f31 + f33);
 f35 = Math_fround(f21 - f9);
 f33 = Math_fround(f31 - f33);
 f32 = Math_fround(Math_fround(1.0) - Math_fround(f34 * f32));
 f14 = Math_fround(f32 - f14);
 f34 = Math_fround(f29 + f15);
 f9 = Math_fround(f21 + f9);
 f15 = Math_fround(f29 - f15);
 f28 = Math_fround(f32 - f28);
 f32 = Math_fround(f2 * f25);
 f29 = Math_fround(f2 * f33);
 f21 = Math_fround(f2 * f9);
 f31 = Math_fround(f1 * f22);
 f26 = Math_fround(f1 * f14);
 f16 = Math_fround(f1 * f15);
 f27 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f1 = Math_fround(f27 * f35);
 f30 = Math_fround(f27 * f34);
 f27 = Math_fround(f28 * f27);
 f17 = Math_fround(Math_fround(f35 * f1) + Math_fround(Math_fround(f25 * f32) + Math_fround(f22 * f31)));
 f24 = Math_fround(Math_fround(f35 * f30) + Math_fround(Math_fround(f25 * f29) + Math_fround(f22 * f26)));
 f22 = Math_fround(Math_fround(f35 * f27) + Math_fround(Math_fround(f25 * f21) + Math_fround(f22 * f16)));
 f2 = Math_fround(Math_fround(f34 * f1) + Math_fround(Math_fround(f33 * f32) + Math_fround(f14 * f31)));
 f25 = Math_fround(Math_fround(f34 * f30) + Math_fround(Math_fround(f33 * f29) + Math_fround(f14 * f26)));
 f14 = Math_fround(Math_fround(f34 * f27) + Math_fround(Math_fround(f33 * f21) + Math_fround(f14 * f16)));
 f1 = Math_fround(Math_fround(f28 * f1) + Math_fround(Math_fround(f9 * f32) + Math_fround(f15 * f31)));
 f26 = Math_fround(Math_fround(f28 * f30) + Math_fround(Math_fround(f9 * f29) + Math_fround(f15 * f26)));
 f16 = Math_fround(Math_fround(f28 * f27) + Math_fround(Math_fround(f9 * f21) + Math_fround(f15 * f16)));
 f15 = Math_fround(Math_fround(f20 * f22) + Math_fround(Math_fround(f8 * f17) + Math_fround(f19 * f24)));
 f21 = Math_fround(Math_fround(f13 * f22) + Math_fround(Math_fround(f18 * f17) + Math_fround(f23 * f24)));
 f24 = Math_fround(Math_fround(f12 * f22) + Math_fround(Math_fround(f11 * f17) + Math_fround(f10 * f24)));
 f17 = Math_fround(Math_fround(f20 * f14) + Math_fround(Math_fround(f8 * f2) + Math_fround(f19 * f25)));
 f22 = Math_fround(Math_fround(f13 * f14) + Math_fround(Math_fround(f18 * f2) + Math_fround(f23 * f25)));
 f25 = Math_fround(Math_fround(f12 * f14) + Math_fround(Math_fround(f11 * f2) + Math_fround(f10 * f25)));
 f19 = Math_fround(Math_fround(f20 * f16) + Math_fround(Math_fround(f8 * f1) + Math_fround(f19 * f26)));
 f23 = Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f1) + Math_fround(f23 * f26)));
 f26 = Math_fround(Math_fround(f12 * f16) + Math_fround(Math_fround(f11 * f1) + Math_fround(f10 * f26)));
 f1 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f2 = Math_fround(f16 + f12);
 f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f8 = Math_fround(f18 + f13);
 f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f2 = Math_fround(f2 * Math_fround(.5));
 f8 = Math_fround(f8 * Math_fround(.5));
 f9 = Math_fround(Math_fround(f20 + f14) * Math_fround(.5));
 f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f2 * f21) + Math_fround(f22 * f8)) + Math_fround(f23 * f9)));
 f11 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f2 * f24) + Math_fround(f25 * f8)) + Math_fround(f26 * f9)));
 HEAPF32[i6 >> 2] = Math_fround(f1 + Math_fround(Math_fround(Math_fround(f2 * f15) + Math_fround(f17 * f8)) + Math_fround(f19 * f9)));
 HEAPF32[i6 + 4 >> 2] = f10;
 HEAPF32[i6 + 8 >> 2] = f11;
 f16 = Math_fround(Math_fround(f12 - f16) * Math_fround(.5));
 f18 = Math_fround(Math_fround(f13 - f18) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f14 - f20) * Math_fround(.5));
 f21 = Math_fround(f21 * f16);
 f24 = Math_fround(f24 * f16);
 f22 = Math_fround(f22 * f18);
 f25 = Math_fround(f25 * f18);
 f23 = Math_fround(f23 * f20);
 f26 = Math_fround(f26 * f20);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f15 * f16))) + Math_fround(Math_abs(Math_fround(f17 * f18)))) + Math_fround(Math_abs(Math_fround(f19 * f20))));
 HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f21))) + Math_fround(Math_abs(Math_fround(f22)))) + Math_fround(Math_abs(Math_fround(f23))));
 HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f24))) + Math_fround(Math_abs(Math_fround(f25)))) + Math_fround(Math_abs(Math_fround(f26))));
 return;
}

function __ZN3MBP12updateObjectEjRK5IAABB(i29, i23, i26) {
 i29 = i29 | 0;
 i23 = i23 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 2064 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i35 + 2057 | 0;
 i33 = i35 + 2056 | 0;
 i21 = i35 + 1028 | 0;
 i27 = i35;
 i30 = i23 >>> 2;
 i20 = i23 & 1;
 i17 = HEAP32[i29 + 8 >> 2] | 0;
 i25 = HEAP32[i29 + 28 >> 2] | 0;
 i24 = HEAP32[i29 + 44 >> 2] | 0;
 i3 = i29 + 80 | 0;
 i34 = i23 >>> 7;
 i4 = i29 + 84 | 0;
 if (i34 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) i1 = HEAP32[i3 >> 2] | 0; else {
  i5 = i30 + 128 | 0;
  i5 = ((i5 & 31 | 0) != 0 & 1) + (i5 >>> 5) | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i5 << 2, gb + 717183 | 0, 412) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i2 = 0; else {
   _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, i2 << 2 | 0) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  if ((i5 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i5 - i2 << 2 | 0) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i33, i2);
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i5;
 }
 i32 = 1 << (i30 & 31);
 i22 = i1 + (i34 << 2) | 0;
 HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i32;
 i22 = i24 + (i30 * 12 | 0) + 4 | 0;
 i18 = HEAP16[i22 >> 1] | 0;
 i19 = i18 & 65535;
 i16 = i18 << 16 >> 16 == 1;
 if (i16) {
  i6 = i24 + (i30 * 12 | 0) + 8 | 0;
  i7 = HEAPU16[i6 + 2 >> 1] | 0;
  if (!(HEAP32[i25 + (i7 * 40 | 0) + 32 >> 2] | 0)) if ((HEAP32[i25 + (i7 * 40 | 0) + 4 >> 2] | 0) >>> 0 <= (HEAP32[i26 >> 2] | 0) >>> 0) if ((HEAP32[i25 + (i7 * 40 | 0) + 8 >> 2] | 0) >>> 0 <= (HEAP32[i26 + 4 >> 2] | 0) >>> 0) if ((HEAP32[i25 + (i7 * 40 | 0) + 12 >> 2] | 0) >>> 0 <= (HEAP32[i26 + 8 >> 2] | 0) >>> 0) if ((HEAP32[i25 + (i7 * 40 | 0) + 16 >> 2] | 0) >>> 0 >= (HEAP32[i26 + 12 >> 2] | 0) >>> 0) if ((HEAP32[i25 + (i7 * 40 | 0) + 20 >> 2] | 0) >>> 0 >= (HEAP32[i26 + 16 >> 2] | 0) >>> 0) if ((HEAP32[i25 + (i7 * 40 | 0) + 24 >> 2] | 0) >>> 0 >= (HEAP32[i26 + 20 >> 2] | 0) >>> 0) {
   i5 = i29 + 5252 | 0;
   i4 = i29 + 5256 | 0;
   if (i34 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) i1 = HEAP32[i5 >> 2] | 0; else {
    i3 = i30 + 128 | 0;
    i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i3 << 2, gb + 717183 | 0, 412) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) i2 = 0; else {
     _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    if ((i3 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i3 - i2 << 2 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (i2 | 0) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i33, i2);
     HEAP32[i5 >> 2] = 0;
    }
    HEAP32[i5 >> 2] = i1;
    HEAP32[i4 >> 2] = i3;
   }
   i34 = i1 + (i34 << 2) | 0;
   HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | i32;
   __ZN9BoxPruner12updateObjectERK5IAABBt(HEAP32[i25 + (i7 * 40 | 0) + 28 >> 2] | 0, i26, HEAP16[i6 >> 1] | 0);
   STACKTOP = i35;
   return 1;
  }
 }
 if (!i17) {
  i2 = 0;
  i10 = 1;
 } else {
  i9 = HEAP32[i26 >> 2] | 0;
  i10 = HEAP32[i26 + 12 >> 2] | 0;
  i11 = HEAP32[i26 + 4 >> 2] | 0;
  i12 = HEAP32[i26 + 16 >> 2] | 0;
  i13 = HEAP32[i26 + 8 >> 2] | 0;
  i14 = HEAP32[i26 + 20 >> 2] | 0;
  i2 = 0;
  i15 = 0;
  i1 = 1;
  do {
   i3 = HEAP32[i25 + (i15 * 40 | 0) + 16 >> 2] | 0;
   if (i3 >>> 0 >= i9 >>> 0) {
    i4 = HEAP32[i25 + (i15 * 40 | 0) + 4 >> 2] | 0;
    if (i10 >>> 0 >= i4 >>> 0) {
     i5 = HEAP32[i25 + (i15 * 40 | 0) + 20 >> 2] | 0;
     if (i5 >>> 0 >= i11 >>> 0) {
      i6 = HEAP32[i25 + (i15 * 40 | 0) + 8 >> 2] | 0;
      if (i12 >>> 0 >= i6 >>> 0) {
       i7 = HEAP32[i25 + (i15 * 40 | 0) + 24 >> 2] | 0;
       if (i7 >>> 0 >= i13 >>> 0) {
        i8 = HEAP32[i25 + (i15 * 40 | 0) + 12 >> 2] | 0;
        if (i14 >>> 0 >= i8 >>> 0) {
         HEAP32[i21 + (i2 << 2) >> 2] = i15;
         i2 = i2 + 1 | 0;
         i1 = i1 & (i7 >>> 0 >= i14 >>> 0 & ((i4 >>> 0 > i9 >>> 0 | i6 >>> 0 > i11 >>> 0 | i8 >>> 0 > i13 >>> 0 | i3 >>> 0 < i10 >>> 0 | i5 >>> 0 < i12 >>> 0) ^ 1));
        }
       }
      }
     }
    }
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i17 | 0));
  i10 = i1;
 }
 i1 = i24 + (i30 * 12 | 0) + 8 | 0;
 if (i16) {
  i9 = i1;
  i8 = i1;
  i28 = 41;
 } else {
  i1 = (HEAP32[i29 + 96 + (i19 << 4) + 8 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
  if (!(i18 << 16 >> 16)) {
   i6 = i2;
   i5 = 0;
  } else {
   i9 = i1;
   i8 = i1;
   i28 = 41;
  }
 }
 if ((i28 | 0) == 41) {
  i1 = i2;
  i7 = 0;
  i5 = 0;
  while (1) {
   i4 = i8 + (i7 << 2) | 0;
   i6 = HEAPU16[i8 + (i7 << 2) + 2 >> 1] | 0;
   L58 : do if (!i1) i28 = 48; else {
    i3 = 0;
    while (1) {
     i2 = i21 + (i3 << 2) | 0;
     i3 = i3 + 1 | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
     if (i3 >>> 0 >= i1 >>> 0) {
      i28 = 48;
      break L58;
     }
    }
    i1 = i1 + -1 | 0;
    HEAP32[i2 >> 2] = HEAP32[i21 + (i1 << 2) >> 2];
    __ZN9BoxPruner12updateObjectERK5IAABBt(HEAP32[i25 + (i6 * 40 | 0) + 28 >> 2] | 0, i26, HEAP16[i4 >> 1] | 0);
    HEAP32[i27 + (i5 << 2) >> 2] = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
    i5 = i5 + 1 | 0;
   } while (0);
   if ((i28 | 0) == 48) {
    i28 = 0;
    __ZN9BoxPruner12removeObjectEt(HEAP32[i25 + (i6 * 40 | 0) + 28 >> 2] | 0, HEAP16[i4 >> 1] | 0);
   }
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i19 | 0)) {
    i6 = i1;
    i1 = i9;
    break;
   }
  }
 }
 if (i6) {
  i2 = (i20 | 0) != 0;
  i3 = 0;
  i4 = i5;
  while (1) {
   i20 = HEAP32[i21 + (i3 << 2) >> 2] | 0;
   HEAP16[i27 + (i4 << 2) >> 1] = __ZN9BoxPruner9addObjectERK5IAABBjb(HEAP32[i25 + (i20 * 40 | 0) + 28 >> 2] | 0, i26, i23, i2) | 0;
   HEAP16[i27 + (i4 << 2) + 2 >> 1] = i20;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) break; else i4 = i4 + 1 | 0;
  }
  i5 = i6 + i5 | 0;
 }
 L73 : do if ((i19 | 0) == (i5 | 0)) if (!(i18 << 16 >> 16)) {
  HEAP16[i22 >> 1] = i5;
  break;
 } else {
  _memcpy(i1 | 0, i27 | 0, i19 << 2 | 0) | 0;
  i28 = 67;
  break;
 } else {
  if ((i18 & 65535) > 1) {
   i25 = HEAP32[i24 + (i30 * 12 | 0) + 8 >> 2] | 0;
   i26 = i29 + 4208 + (i19 << 2) | 0;
   HEAP32[(HEAP32[i29 + 96 + (i19 << 4) + 8 >> 2] | 0) + (i25 << 2) >> 2] = HEAP32[i26 >> 2];
   HEAP32[i26 >> 2] = i25;
  }
  switch (i5 | 0) {
  case 0:
   {
    i28 = 67;
    break L73;
   }
  case 1:
   {
    i26 = i24 + (i30 * 12 | 0) + 8 | 0;
    i27 = HEAP32[i27 >> 2] | 0;
    HEAP16[i26 >> 1] = i27;
    HEAP16[i26 + 2 >> 1] = i27 >>> 16;
    break;
   }
  default:
   {
    i4 = i29 + 96 + (i5 << 4) | 0;
    i1 = i29 + 4208 + (i5 << 2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) == -1) {
     i3 = i29 + 96 + (i5 << 4) + 4 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     HEAP32[i24 + (i30 * 12 | 0) + 8 >> 2] = i1;
     i2 = i5 & 1073741823;
     if ((i1 + i2 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
      __ZN5physx2Gu9Container6ResizeEj(i4, i2) | 0;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     i26 = (HEAP32[i29 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i1 << 2) | 0;
     HEAP32[i3 >> 2] = i1 + i2;
     i1 = i26;
    } else {
     HEAP32[i24 + (i30 * 12 | 0) + 8 >> 2] = i2;
     i26 = (HEAP32[i29 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i2 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
     i1 = i26;
    }
    _memcpy(i1 | 0, i27 | 0, i5 << 2 | 0) | 0;
   }
  }
  HEAP16[i22 >> 1] = i5;
 } while (0);
 if ((i28 | 0) == 67) {
  HEAP16[i22 >> 1] = i5;
  if (i18 << 16 >> 16 != 0 & (i5 | 0) == 0) {
   HEAP32[i24 + (i30 * 12 | 0) + 8 >> 2] = i23;
   i3 = HEAP32[i24 + (i30 * 12 | 0) >> 2] | 0;
   i2 = i29 + 5236 | 0;
   i4 = i29 + 5240 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
    __ZN5physx2Gu9Container6ResizeEj(i2, 1) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i4 >> 2] = i1 + 1;
   HEAP32[(HEAP32[i29 + 5244 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  }
 }
 i5 = i29 + 5252 | 0;
 i4 = i29 + 5256 | 0;
 i1 = i34 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0;
 if (i10) {
  if (i1) i1 = HEAP32[i5 >> 2] | 0; else {
   i3 = i30 + 128 | 0;
   i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i3 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   if ((i3 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i3 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i33, i2);
    HEAP32[i5 >> 2] = 0;
   }
   HEAP32[i5 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
  }
  i34 = i1 + (i34 << 2) | 0;
  HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | i32;
 } else {
  if (i1) i1 = HEAP32[i5 >> 2] | 0; else {
   i3 = i30 + 128 | 0;
   i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i3 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   if ((i3 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i3 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i33, i2);
    HEAP32[i5 >> 2] = 0;
   }
   HEAP32[i5 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
  }
  i34 = i1 + (i34 << 2) | 0;
  HEAP32[i34 >> 2] = HEAP32[i34 >> 2] & ~i32;
 }
 STACKTOP = i35;
 return 1;
}

function __ZN9InputAxis8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i3 = i9;
 i1 = i7 + 4 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i7 + 24 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i7 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i2 = i3 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, i6);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i8) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i7 + 60 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i2 = i3 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, i6);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i8) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i7 + 56 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i2 = i3 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, i6);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i8) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i7 + 68 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i2 = i3 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, i6);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i8) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i7 + 64 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i7 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i7 + 104 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i7 + 105 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i7 + 88 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i6 >> 2] = i2;
  i8 = i7;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN6Shader8TransferI14SafeBinaryReadEEvRT_(i27, i29) {
 i27 = i27 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 24 | 0;
 i6 = i30 + 16 | 0;
 i13 = i30 + 8 | 0;
 i16 = i30 + 116 | 0;
 i17 = i30 + 96 | 0;
 i20 = i30 + 76 | 0;
 i21 = i30 + 56 | 0;
 i24 = i30 + 36 | 0;
 i3 = i30;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i27, i29);
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i14;
 HEAP32[i16 >> 2] = 0;
 i5 = i16 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i13);
 i18 = i28;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i22 = i15;
 HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i22 + 4 >> 2] = i19;
 i22 = gb + 64016 | 0;
 i19 = HEAP32[i22 + 4 >> 2] | 0;
 i18 = i13;
 HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 i18 = i17 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i13);
 i22 = i28;
 i23 = HEAP32[i22 + 4 >> 2] | 0;
 i8 = i19;
 HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i8 + 4 >> 2] = i23;
 i8 = gb + 64016 | 0;
 i23 = HEAP32[i8 + 4 >> 2] | 0;
 i22 = i13;
 HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 i22 = i20 + 16 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i13);
 i8 = i28;
 i25 = HEAP32[i8 + 4 >> 2] | 0;
 i26 = i23;
 HEAP32[i26 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 i26 = gb + 64016 | 0;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i8 + 4 >> 2] = i25;
 HEAP32[i21 >> 2] = 0;
 i8 = i21 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i25 = i21 + 16 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i13);
 i9 = i28;
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 i12 = i26;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i24 >> 2] = 0;
 i9 = i24 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i24 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i13);
 i10 = i28;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = HEAP32[i27 + 96 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470263 | 0, gb + 470276 | 0, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16SerializedShader8TransferI14SafeBinaryReadEEvRT_(i2, i29); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470293 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i29, i16, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470303 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i29, i17, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i17 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470311 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i29, i20, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i20 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470329 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i29, i21, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i21 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470349 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i29, i24, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i24 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 if (HEAP32[i5 >> 2] | 0) {
  i2 = gb + 64016 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i4;
  HEAP32[i28 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  i7 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i28) | 0;
  i3 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i3 << 2) >> 2] | 0;
  L51 : do if ((i3 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i16 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L51;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i6 >> 2] = i4;
   __Z6FormatPKcz(i28, gb + 470364 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i28 + 11 >> 0] | 0) < 0 ? HEAP32[i28 >> 2] | 0 : i28, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   i4 = i27 + 60 | 0;
   i5 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i8 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i28 >> 2] = i5;
   HEAP32[i13 >> 2] = i8;
   if ((i8 | 0) != 0 & (i5 | 0 ? (HEAP32[i9 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i27 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i27 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i27 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i27 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i9;
     i1 = i9;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, (HEAP32[i24 >> 2] | 0) + i6 | 0, i13 | 0, i1 | 0, i28 | 0) | 0;
   }
  }
  if (i7 | 0) mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64016 | 0);
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i12);
  HEAP32[i24 >> 2] = 0;
 }
 if ((HEAP32[i25 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i26);
  HEAP32[i21 >> 2] = 0;
 }
 if ((HEAP32[i22 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i23);
  HEAP32[i20 >> 2] = 0;
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i19);
  HEAP32[i17 >> 2] = 0;
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
  HEAP32[i16 >> 2] = 0;
 }
 i2 = i27 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470499 | 0, i10, i28, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i29, i2, 0); else {
   i1 = HEAP32[i28 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i29 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i29);
 }
 i3 = i27 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i29, gb + 470514 | 0, HEAP32[gb + 36972 >> 2] | 0, i28, 0) | 0;
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i29 + 16 | 0;
  i28 = HEAP32[i29 + 20 >> 2] | 0;
  i2 = i28 + (HEAP32[(HEAP32[i29 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i29 + 36 >> 2] | 0, 0 - (HEAP32[i29 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i28 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i29 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i28 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i29 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i29);
 STACKTOP = i30;
 return;
}

function __ZN5audio5mixer18AudioMixerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 48 | 0;
 i6 = i3 + 16 | 0;
 i9 = i3;
 i11 = i2 + 4 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 4;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = i5;
 i5 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863147 | 0, i5, i9, 0);
 HEAP32[i6 >> 2] = -1;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP16[i7 + 8 >> 1] = 0;
 HEAP8[i7 + 10 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863506 | 0, i6, 0);
 __ZN5audio5mixer13GroupConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 8;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863154 | 0, i5, i9, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863904 | 0, i6, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 12 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 16;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863165 | 0, i5, i9, 0);
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 HEAP32[i6 + 8 >> 2] = -1;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP32[i6 + 16 >> 2] = -1;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863393 | 0, i6, 0);
 __ZN5audio5mixer14EffectConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 20;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863173 | 0, i5, i9, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863904 | 0, i6, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863185 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 24 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 32 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 36;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i10;
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863205 | 0, i10, i9, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 40;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i12;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863215 | 0, i10, i9, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863904 | 0, i6, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 48;
 HEAP32[i9 + 4 >> 2] = i1 + 44;
 HEAP32[i9 + 8 >> 2] = i12;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863229 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i12 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 56;
 HEAP32[i9 + 4 >> 2] = i1 + 52;
 HEAP32[i9 + 8 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863245 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 64;
 HEAP32[i9 + 4 >> 2] = i1 + 60;
 HEAP32[i9 + 8 >> 2] = i10;
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863264 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i12 = i1 + 68 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 72;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863287 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 76;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863309 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i11, i15, i9, f14, i6) {
 i11 = i11 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 f14 = Math_fround(f14);
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 92 | 0;
 i3 = i16 + 80 | 0;
 i8 = i16 + 68 | 0;
 i1 = i16 + 56 | 0;
 i10 = i16 + 28 | 0;
 i13 = i16 + 16 | 0;
 i12 = i16 + 4 | 0;
 switch (HEAP32[i11 >> 2] | 0) {
 case 0:
  {
   f14 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) + f14);
   i11 = i9 + 16 | 0;
   f2 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f14);
   i12 = i9 + 20 | 0;
   f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f14);
   i13 = i9 + 24 | 0;
   f4 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f14);
   HEAPF32[i15 >> 2] = f2;
   HEAPF32[i15 + 4 >> 2] = f5;
   HEAPF32[i15 + 8 >> 2] = f4;
   f4 = Math_fround(f14 + Math_fround(HEAPF32[i11 >> 2]));
   f5 = Math_fround(f14 + Math_fround(HEAPF32[i12 >> 2]));
   f14 = Math_fround(f14 + Math_fround(HEAPF32[i13 >> 2]));
   HEAPF32[i15 + 12 >> 2] = f4;
   HEAPF32[i15 + 16 >> 2] = f5;
   HEAPF32[i15 + 20 >> 2] = f14;
   STACKTOP = i16;
   return;
  }
 case 1:
  {
   __ZL18computePlaneBoundsRN5physx9PxBounds3ERKNS_11PxTransformEf(i15, i9, f14);
   STACKTOP = i16;
   return;
  }
 case 2:
  {
   f18 = Math_fround(HEAPF32[i9 >> 2]);
   f19 = Math_fround(f18 * Math_fround(2.0));
   f4 = Math_fround(HEAPF32[i9 + 12 >> 2]);
   f17 = Math_fround(f4 * Math_fround(2.0));
   f4 = Math_fround(Math_fround(f18 * f19) + Math_fround(Math_fround(f4 * f17) + Math_fround(-1.0)));
   f18 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   f5 = Math_fround(f18 * f17);
   f2 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   f5 = Math_fround(f5 + Math_fround(f19 * f2));
   f2 = Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f2));
   f17 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f4))) * f17) + f18) + f14);
   f5 = Math_fround(Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f5))) * f17) + f18) + f14);
   f14 = Math_fround(Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f2))) * f17) + f18) + f14);
   i11 = i9 + 16 | 0;
   f18 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f4);
   i12 = i9 + 20 | 0;
   f17 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f5);
   i13 = i9 + 24 | 0;
   f2 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f14);
   HEAPF32[i15 >> 2] = f18;
   HEAPF32[i15 + 4 >> 2] = f17;
   HEAPF32[i15 + 8 >> 2] = f2;
   f4 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f4);
   f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f5);
   f14 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f14);
   HEAPF32[i15 + 12 >> 2] = f4;
   HEAPF32[i15 + 16 >> 2] = f5;
   HEAPF32[i15 + 20 >> 2] = f14;
   STACKTOP = i16;
   return;
  }
 case 3:
  {
   f5 = Math_fround(HEAPF32[i9 >> 2]);
   f26 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i9 + 12 >> 2]);
   f21 = Math_fround(f5 + f5);
   f17 = Math_fround(f26 + f26);
   f25 = Math_fround(f4 + f4);
   f2 = Math_fround(f26 * f17);
   f22 = Math_fround(f4 * f25);
   f26 = Math_fround(f21 * f26);
   f19 = Math_fround(f21 * f4);
   f18 = Math_fround(f21 * f24);
   f4 = Math_fround(f17 * f4);
   f17 = Math_fround(f17 * f24);
   f24 = Math_fround(f25 * f24);
   f25 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f22);
   f23 = Math_fround(f26 + f24);
   f20 = Math_fround(f19 - f17);
   f24 = Math_fround(f26 - f24);
   f21 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f21));
   f22 = Math_fround(f21 - f22);
   f5 = Math_fround(f4 + f18);
   f17 = Math_fround(f19 + f17);
   f18 = Math_fround(f4 - f18);
   f2 = Math_fround(f21 - f2);
   f21 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   f17 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f21 * f25))) + Math_fround(Math_abs(Math_fround(f24 * f4)))) + Math_fround(Math_abs(Math_fround(f17 * f19))));
   f18 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f21 * f23))) + Math_fround(Math_abs(Math_fround(f22 * f4)))) + Math_fround(Math_abs(Math_fround(f18 * f19))));
   f19 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f21 * f20))) + Math_fround(Math_abs(Math_fround(f5 * f4)))) + Math_fround(Math_abs(Math_fround(f2 * f19))));
   i11 = i9 + 16 | 0;
   f2 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f17);
   i12 = i9 + 20 | 0;
   i13 = i9 + 24 | 0;
   f4 = Math_fround(Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f18) - f14);
   f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f19) - f14);
   HEAPF32[i15 >> 2] = Math_fround(f2 - f14);
   HEAPF32[i15 + 4 >> 2] = f4;
   HEAPF32[i15 + 8 >> 2] = f5;
   f17 = Math_fround(f17 + Math_fround(HEAPF32[i11 >> 2]));
   f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i12 >> 2])) + f14);
   f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i13 >> 2])) + f14);
   HEAPF32[i15 + 12 >> 2] = Math_fround(f17 + f14);
   HEAPF32[i15 + 16 >> 2] = f18;
   HEAPF32[i15 + 20 >> 2] = f19;
   STACKTOP = i16;
   return;
  }
 case 4:
  {
   if (!i6) __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, HEAP32[i11 + 36 >> 2] | 0, i11 + 4 | 0, i7, i3); else __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, i6, i11 + 4 | 0, i7, i3);
   f23 = Math_fround(HEAPF32[i7 >> 2]);
   f24 = Math_fround(HEAPF32[i3 >> 2]);
   f18 = Math_fround(f23 - f24);
   f21 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f19 = Math_fround(f21 - f25);
   f22 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f26 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f19 = Math_fround(f19 - f14);
   f20 = Math_fround(Math_fround(f22 - f26) - f14);
   HEAPF32[i15 >> 2] = Math_fround(f18 - f14);
   HEAPF32[i15 + 4 >> 2] = f19;
   HEAPF32[i15 + 8 >> 2] = f20;
   f25 = Math_fround(Math_fround(f21 + f25) + f14);
   f26 = Math_fround(Math_fround(f22 + f26) + f14);
   HEAPF32[i15 + 12 >> 2] = Math_fround(Math_fround(f23 + f24) + f14);
   HEAPF32[i15 + 16 >> 2] = f25;
   HEAPF32[i15 + 20 >> 2] = f26;
   STACKTOP = i16;
   return;
  }
 case 5:
  {
   if (!i6) __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, (HEAP32[i11 + 40 >> 2] | 0) + 128 | 0, i11 + 4 | 0, i8, i1); else __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, i6, i11 + 4 | 0, i8, i1);
   f23 = Math_fround(HEAPF32[i8 >> 2]);
   f24 = Math_fround(HEAPF32[i1 >> 2]);
   f18 = Math_fround(f23 - f24);
   f21 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f19 = Math_fround(f21 - f25);
   f22 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f26 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f19 = Math_fround(f19 - f14);
   f20 = Math_fround(Math_fround(f22 - f26) - f14);
   HEAPF32[i15 >> 2] = Math_fround(f18 - f14);
   HEAPF32[i15 + 4 >> 2] = f19;
   HEAPF32[i15 + 8 >> 2] = f20;
   f25 = Math_fround(Math_fround(f21 + f25) + f14);
   f26 = Math_fround(Math_fround(f22 + f26) + f14);
   HEAPF32[i15 + 12 >> 2] = Math_fround(Math_fround(f23 + f24) + f14);
   HEAPF32[i15 + 16 >> 2] = f25;
   HEAPF32[i15 + 20 >> 2] = f26;
   STACKTOP = i16;
   return;
  }
 case 6:
  {
   i7 = HEAP32[i11 + 8 >> 2] | 0;
   i8 = HEAP32[i11 + 16 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 4 >> 2] = i7;
   HEAP32[i10 + 8 >> 2] = i8;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   HEAP32[i10 + 24 >> 2] = 1065353216;
   if (!i6) {
    i1 = HEAP32[i11 + 24 >> 2] | 0;
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, i1 + 40 | 0, i10, i13, i12);
   } else {
    __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_(i9, i6, i10, i13, i12);
    i1 = HEAP32[i11 + 24 >> 2] | 0;
   }
   f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f24 = Math_fround(HEAPF32[i13 >> 2]);
   f25 = Math_fround(HEAPF32[i12 >> 2]);
   f20 = Math_fround(f24 - f25);
   f22 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f2 = Math_fround(f22 - f4);
   f23 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f26 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f2 = Math_fround(f2 - f14);
   f21 = Math_fround(Math_fround(f23 - f26) - f14);
   HEAPF32[i15 >> 2] = Math_fround(f20 - f14);
   i3 = i15 + 4 | 0;
   HEAPF32[i3 >> 2] = f2;
   HEAPF32[i15 + 8 >> 2] = f21;
   f4 = Math_fround(Math_fround(f22 + f4) + f14);
   f26 = Math_fround(Math_fround(f23 + f26) + f14);
   HEAPF32[i15 + 12 >> 2] = Math_fround(Math_fround(f24 + f25) + f14);
   i1 = i15 + 16 | 0;
   HEAPF32[i1 >> 2] = f4;
   HEAPF32[i15 + 20 >> 2] = f26;
   if (f5 < Math_fround(0.0)) {
    HEAPF32[i3 >> 2] = Math_fround(f5 + f2);
    STACKTOP = i16;
    return;
   } else {
    HEAPF32[i1 >> 2] = Math_fround(f5 + f4);
    STACKTOP = i16;
    return;
   }
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 676222 | 0, 297, gb + 676302 | 0, i16);
   STACKTOP = i16;
   return;
  }
 }
}

function __ZN14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj(i2, i1, i50, i51) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i54;
 i53 = i54 + 72 | 0;
 if (HEAP16[i1 + 14 >> 1] & 3) {
  STACKTOP = i54;
  return;
 }
 i48 = HEAP32[i1 >> 2] | 0;
 i49 = HEAP32[i48 + 8 >> 2] | 0;
 i41 = HEAP32[i1 + 4 >> 2] | 0;
 i42 = HEAP32[i41 + 8 >> 2] | 0;
 if (!i51) {
  STACKTOP = i54;
  return;
 }
 i43 = i52 + 60 | 0;
 i44 = i52 + 64 | 0;
 i45 = i52 + 68 | 0;
 i46 = i2 + 84 | 0;
 i47 = i2 + 88 | 0;
 i20 = i2 + 80 | 0;
 i21 = i52 + 60 | 0;
 i22 = i48 + 4 | 0;
 i23 = i52 + 4 | 0;
 i24 = i52 + 8 | 0;
 i25 = i41 + 4 | 0;
 i26 = i52 + 4 | 0;
 i27 = i52 + 8 | 0;
 i28 = i53 + 12 | 0;
 i29 = i53 + 16 | 0;
 i30 = i53 + 4 | 0;
 i31 = i52 + 24 | 0;
 i32 = i52 + 28 | 0;
 i33 = i52 + 32 | 0;
 i34 = i52 + 36 | 0;
 i35 = i52 + 40 | 0;
 i36 = i52 + 44 | 0;
 i37 = i52 + 48 | 0;
 i38 = i52 + 52 | 0;
 i39 = i52 + 56 | 0;
 i40 = i52 + 60 | 0;
 i19 = 0;
 do {
  i17 = i50 + (i19 << 5) | 0;
  i13 = i50 + (i19 << 5) + 20 | 0;
  if (!(HEAP16[i13 >> 1] & 3)) {
   i1 = HEAP32[i17 >> 2] | 0;
   if (!i1) i15 = 0; else i15 = HEAP32[i1 + 8 >> 2] | 0;
   i1 = HEAP32[i50 + (i19 << 5) + 4 >> 2] | 0;
   if (!i1) i16 = 0; else i16 = HEAP32[i1 + 8 >> 2] | 0;
   i1 = i52;
   i2 = i1 + 68 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i43 >> 2] = i43;
   HEAP32[i44 >> 2] = i43;
   HEAP32[i45 >> 2] = 0;
   i1 = HEAP32[i46 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i47 >> 2] | 0)) __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i20, i52); else {
    HEAP32[i1 >> 2] = HEAP32[i52 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i52 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i52 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i32 >> 2];
    HEAP32[i1 + 32 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i1 + 36 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i1 + 40 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i1 + 44 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i1 + 48 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i1 + 52 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i1 + 56 >> 2] = HEAP32[i39 >> 2];
    i12 = i1 + 60 | 0;
    HEAP32[i12 >> 2] = i12;
    HEAP32[i1 + 64 >> 2] = i12;
    i11 = i1 + 68 | 0;
    HEAP32[i11 >> 2] = 0;
    i1 = HEAP32[i44 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) != (i40 | 0)) {
     i9 = i12;
     i10 = 0;
     do {
      i14 = i1;
      i18 = i9;
      i9 = __Znwj(44) | 0;
      i57 = i14 + 8 | 0;
      i56 = HEAP32[i57 + 4 >> 2] | 0;
      i55 = i9 + 8 | 0;
      HEAP32[i55 >> 2] = HEAP32[i57 >> 2];
      HEAP32[i55 + 4 >> 2] = i56;
      HEAP32[i9 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
      HEAP32[i9 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
      HEAP32[i9 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
      HEAP32[i9 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
      HEAP32[i9 + 32 >> 2] = HEAP32[i14 + 32 >> 2];
      HEAP32[i9 + 36 >> 2] = HEAP32[i14 + 36 >> 2];
      HEAP32[i9 + 40 >> 2] = HEAP32[i14 + 40 >> 2];
      HEAP32[i9 + 4 >> 2] = i12;
      HEAP32[i9 >> 2] = i18;
      HEAP32[i18 + 4 >> 2] = i9;
      HEAP32[i12 >> 2] = i9;
      i10 = i10 + 1 | 0;
      HEAP32[i11 >> 2] = i10;
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      i2 = i1;
     } while ((i2 | 0) != (i40 | 0));
    }
    HEAP32[i46 >> 2] = (HEAP32[i46 >> 2] | 0) + 72;
   }
   if (HEAP32[i45 >> 2] | 0) {
    i1 = HEAP32[i44 >> 2] | 0;
    i57 = (HEAP32[i21 >> 2] | 0) + 4 | 0;
    i56 = HEAP32[i1 >> 2] | 0;
    HEAP32[i56 + 4 >> 2] = HEAP32[i57 >> 2];
    HEAP32[HEAP32[i57 >> 2] >> 2] = i56;
    HEAP32[i45 >> 2] = 0;
    if ((i1 | 0) != (i21 | 0)) do {
     i57 = i1;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     __ZdlPv(i57);
    } while ((i1 | 0) != (i21 | 0));
   }
   i18 = HEAP32[i46 >> 2] | 0;
   HEAP32[i18 + -64 >> 2] = i49;
   HEAP32[i18 + -60 >> 2] = i42;
   HEAP32[i18 + -56 >> 2] = i15;
   HEAP32[i18 + -52 >> 2] = i16;
   HEAP32[i18 + -72 >> 2] = HEAPU16[i50 + (i19 << 5) + 22 >> 1];
   i57 = HEAP16[i50 + (i19 << 5) + 16 >> 1] | 0;
   i1 = i57 & 65535;
   if (!(i57 << 16 >> 16)) {
    f5 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f3 = Math_fround(0.0);
   } else {
    i2 = HEAPU16[i13 >> 1] | 0;
    i14 = i18 + -12 | 0;
    HEAP32[i28 >> 2] = i1;
    HEAP32[i29 >> 2] = i1;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i52, gb + 64016 | 0);
    i56 = i52;
    i57 = HEAP32[i56 + 4 >> 2] | 0;
    i13 = i30;
    HEAP32[i13 >> 2] = HEAP32[i56 >> 2];
    HEAP32[i13 + 4 >> 2] = i57;
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 48 | 0, 4, i30, 0, gb + 1047584 | 0, 446) | 0;
    HEAP32[i53 >> 2] = i13;
    i13 = __ZNK5physx13PxContactPair15extractContactsEPNS_18PxContactPairPointEj(i17, i13, i1) | 0;
    if (!i13) {
     f5 = Math_fround(0.0);
     f4 = Math_fround(0.0);
     f3 = Math_fround(0.0);
    } else {
     i12 = i2 & 1 | 0 ? 0 : i15;
     i10 = i2 & 2 | 0 ? 0 : i16;
     i11 = i18 + -4 | 0;
     i9 = HEAP32[i53 >> 2] | 0;
     if (!(i2 & 32)) {
      i1 = 0;
      do {
       i58 = HEAP32[i9 + (i1 * 48 | 0) >> 2] | 0;
       i2 = HEAP32[i9 + (i1 * 48 | 0) + 4 >> 2] | 0;
       i15 = HEAP32[i9 + (i1 * 48 | 0) + 8 >> 2] | 0;
       i16 = HEAP32[i9 + (i1 * 48 | 0) + 16 >> 2] | 0;
       i17 = HEAP32[i9 + (i1 * 48 | 0) + 20 >> 2] | 0;
       i55 = HEAP32[i9 + (i1 * 48 | 0) + 24 >> 2] | 0;
       i56 = HEAP32[i9 + (i1 * 48 | 0) + 12 >> 2] | 0;
       i57 = __Znwj(44) | 0;
       HEAP32[i57 + 8 >> 2] = i12;
       HEAP32[i57 + 12 >> 2] = i10;
       HEAP32[i57 + 16 >> 2] = i58;
       HEAP32[i57 + 20 >> 2] = i2;
       HEAP32[i57 + 24 >> 2] = i15;
       HEAP32[i57 + 28 >> 2] = i16;
       HEAP32[i57 + 32 >> 2] = i17;
       HEAP32[i57 + 36 >> 2] = i55;
       HEAP32[i57 + 40 >> 2] = i56;
       HEAP32[i57 + 4 >> 2] = i14;
       i56 = HEAP32[i14 >> 2] | 0;
       HEAP32[i57 >> 2] = i56;
       HEAP32[i56 + 4 >> 2] = i57;
       HEAP32[i14 >> 2] = i57;
       HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i13 | 0));
      f5 = Math_fround(0.0);
      f4 = Math_fround(0.0);
      f3 = Math_fround(0.0);
     } else {
      i1 = 0;
      f5 = Math_fround(0.0);
      f4 = Math_fround(0.0);
      f3 = Math_fround(0.0);
      do {
       i2 = HEAP32[i9 + (i1 * 48 | 0) >> 2] | 0;
       i15 = HEAP32[i9 + (i1 * 48 | 0) + 4 >> 2] | 0;
       i16 = HEAP32[i9 + (i1 * 48 | 0) + 8 >> 2] | 0;
       i17 = HEAP32[i9 + (i1 * 48 | 0) + 16 >> 2] | 0;
       i55 = HEAP32[i9 + (i1 * 48 | 0) + 20 >> 2] | 0;
       i56 = HEAP32[i9 + (i1 * 48 | 0) + 24 >> 2] | 0;
       i57 = HEAP32[i9 + (i1 * 48 | 0) + 12 >> 2] | 0;
       i58 = __Znwj(44) | 0;
       HEAP32[i58 + 8 >> 2] = i12;
       HEAP32[i58 + 12 >> 2] = i10;
       HEAP32[i58 + 16 >> 2] = i2;
       HEAP32[i58 + 20 >> 2] = i15;
       HEAP32[i58 + 24 >> 2] = i16;
       HEAP32[i58 + 28 >> 2] = i17;
       HEAP32[i58 + 32 >> 2] = i55;
       HEAP32[i58 + 36 >> 2] = i56;
       HEAP32[i58 + 40 >> 2] = i57;
       HEAP32[i58 + 4 >> 2] = i14;
       i57 = HEAP32[i14 >> 2] | 0;
       HEAP32[i58 >> 2] = i57;
       HEAP32[i57 + 4 >> 2] = i58;
       HEAP32[i14 >> 2] = i58;
       HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
       f5 = Math_fround(f5 + Math_fround(HEAPF32[i9 + (i1 * 48 | 0) + 32 >> 2]));
       f4 = Math_fround(f4 + Math_fround(HEAPF32[i9 + (i1 * 48 | 0) + 36 >> 2]));
       f3 = Math_fround(f3 + Math_fround(HEAPF32[i9 + (i1 * 48 | 0) + 40 >> 2]));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i13 | 0));
     }
    }
    if ((HEAP32[i29 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i53 >> 2] | 0, i30);
     HEAP32[i53 >> 2] = 0;
    }
   }
   HEAPF32[i18 + -48 >> 2] = f5;
   HEAPF32[i18 + -44 >> 2] = f4;
   HEAPF32[i18 + -40 >> 2] = f3;
   HEAPF32[i18 + -36 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + -32 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + -28 >> 2] = Math_fround(0.0);
   if ((HEAP16[i22 >> 1] | 0) == 5) {
    mftCall_vii(HEAP32[(HEAP32[i48 >> 2] | 0) + 152 >> 2] | 0, i52 | 0, i48 | 0);
    f4 = Math_fround(HEAPF32[i52 >> 2]);
    f7 = Math_fround(HEAPF32[i23 >> 2]);
    f5 = Math_fround(HEAPF32[i24 >> 2]);
   } else {
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    f7 = Math_fround(0.0);
   }
   if ((HEAP16[i25 >> 1] | 0) == 5) {
    mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 152 >> 2] | 0, i52 | 0, i41 | 0);
    f3 = Math_fround(HEAPF32[i52 >> 2]);
    f6 = Math_fround(HEAPF32[i26 >> 2]);
    f8 = Math_fround(HEAPF32[i27 >> 2]);
   } else {
    f3 = Math_fround(0.0);
    f6 = Math_fround(0.0);
    f8 = Math_fround(0.0);
   }
   f7 = Math_fround(f7 - f6);
   f8 = Math_fround(f5 - f8);
   HEAPF32[i18 + -24 >> 2] = Math_fround(f4 - f3);
   HEAPF32[i18 + -20 >> 2] = f7;
   HEAPF32[i18 + -16 >> 2] = f8;
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != (i51 | 0));
 STACKTOP = i54;
 return;
}

function __ZN18GlslGpuProgramGLES6CreateE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER14ChannelAssigns(i19, i1, i2, i20) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 108 | 0;
 i13 = i18 + 96 | 0;
 i14 = i18 + 84 | 0;
 i15 = i18 + 72 | 0;
 i16 = i18 + 60 | 0;
 i17 = i18 + 48 | 0;
 i8 = i18 + 36 | 0;
 i9 = i18 + 24 | 0;
 i10 = i18 + 12 | 0;
 i11 = i18;
 HEAP32[i19 + 4 >> 2] = 6;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i1 + i5 | 0;
 i6 = i12 + 11 | 0;
 if (i5 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i12, 10, i5 + -10 | 0, 0, 0, 0, 0);
  i4 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = 4;
 } else if (!i5) i1 = i12; else {
  i4 = i12;
  i7 = 4;
 }
 if ((i7 | 0) == 4) {
  i2 = i4;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i1 = i4 + i5 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i5; else HEAP8[i6 >> 0] = i5;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, gb + 604612 | 0, 6);
 __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i15, i16, i12, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, gb + 604619 | 0, 8);
 __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i16, i17, i13, i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 604628 | 0, 8);
 __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i17, i8, i14, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 604637 | 0, 6);
 __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i8, i9, i13, i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 604644 | 0, 4);
 __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_(i9, i10, i14, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = i13 + 11 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i4 = i13 + 4 | 0;
 i2 = i1 ? HEAP32[i4 >> 2] | 0 : i2 & 255;
 i6 = i15 + 11 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 i7 = i7 << 24 >> 24 < 0 ? HEAP32[i15 + 4 >> 2] | 0 : i7 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i1 ? HEAP32[i13 >> 2] | 0 : i13, i2, i7 + i2 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i15, i10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = HEAP8[i3 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i4 >> 2] | 0 : i7 & 255;
 i2 = i16 + 11 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i16 + 4 >> 2] | 0 : i1 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i6 ? HEAP32[i13 >> 2] | 0 : i13, i7, i1 + i7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i16, i10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = i9 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 if (i2 >>> 0 > 2) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i7 = HEAP8[i3 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i4 >> 2] | 0 : i7 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i6 ? HEAP32[i13 >> 2] | 0 : i13, i7, i2 + i7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i1 = i8 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i2 & 255;
 if (i2 >>> 0 > 2) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i7 = HEAP8[i3 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i4 >> 2] | 0 : i7 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i6 ? HEAP32[i13 >> 2] | 0 : i13, i7, i2 + i7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i1 = i17 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i2 & 255;
 if (i2 >>> 0 > 2) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i7 = HEAP8[i3 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i4 >> 2] | 0 : i7 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i6 ? HEAP32[i13 >> 2] | 0 : i13, i7, i2 + i7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i17, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 604649 | 0, 3);
 __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i15, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i15, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i16, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i16, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i9, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i8, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i17, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i17, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i20 = __ZN18GlslGpuProgramGLES14CompileProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_S8_S8_S8_R14ChannelAssigns(i19, i15, i16, i17, i9, i8, i20) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i18;
 return i20 | 0;
}

function __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 do switch (i1 | 0) {
 case 1:
 case 8:
 case 3:
 case 14:
 case 4:
 case 5:
  {
   __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32(i5, i1, i2);
   i5 = HEAP32[i2 >> 2] | 0;
   f10 = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f9 = Math_fround(Math_fround(i5 >>> 16 & 255) / Math_fround(255.0));
   f8 = Math_fround(Math_fround(i5 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(i5 & 255) / Math_fround(255.0));
   HEAPF32[i6 + 4 >> 2] = f10;
   HEAPF32[i6 + 8 >> 2] = f9;
   HEAPF32[i6 + 12 >> 2] = f8;
   STACKTOP = i7;
   return;
  }
 case 13:
  {
   i5 = HEAP16[i5 >> 1] | 0;
   i4 = i5 & 65535;
   f8 = Math_fround(Math_fround(i4 >>> 8 & 15 | 0) * Math_fround(.0666666701));
   f9 = Math_fround(Math_fround(i4 >>> 4 & 15 | 0) * Math_fround(.0666666701));
   f10 = Math_fround(Math_fround(i4 & 15 | 0) * Math_fround(.0666666701));
   HEAPF32[i6 >> 2] = Math_fround(Math_fround((i5 & 65535) >>> 12 & 65535) * Math_fround(.0666666701));
   HEAPF32[i6 + 4 >> 2] = f8;
   HEAPF32[i6 + 8 >> 2] = f9;
   HEAPF32[i6 + 12 >> 2] = f10;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   i4 = HEAP16[i5 >> 1] | 0;
   i5 = i4 & 65535;
   f8 = Math_fround(Math_fround(i5 >>> 4 & 15 | 0) * Math_fround(.0666666701));
   f9 = Math_fround(Math_fround(i5 & 15 | 0) * Math_fround(.0666666701));
   f10 = Math_fround(Math_fround((i4 & 65535) >>> 12 & 65535) * Math_fround(.0666666701));
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(i5 >>> 8 & 15 | 0) * Math_fround(.0666666701));
   HEAPF32[i6 + 4 >> 2] = f8;
   HEAPF32[i6 + 8 >> 2] = f9;
   HEAPF32[i6 + 12 >> 2] = f10;
   STACKTOP = i7;
   return;
  }
 case 7:
  {
   i5 = HEAP16[i5 >> 1] | 0;
   i4 = i5 & 65535;
   f9 = Math_fround(Math_fround(i4 >>> 5 & 63 | 0) * Math_fround(.0158730168));
   f10 = Math_fround(Math_fround(i4 & 31 | 0) * Math_fround(.0322580636));
   HEAPF32[i6 >> 2] = Math_fround(Math_fround((i5 & 65535) >>> 11 & 65535) * Math_fround(.0322580636));
   HEAPF32[i6 + 4 >> 2] = f9;
   HEAPF32[i6 + 8 >> 2] = f10;
   HEAP32[i6 + 12 >> 2] = 1065353216;
   STACKTOP = i7;
   return;
  }
 case 18:
  {
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = 1065353216;
   HEAP32[i6 + 8 >> 2] = 1065353216;
   HEAP32[i6 + 12 >> 2] = 1065353216;
   STACKTOP = i7;
   return;
  }
 case 19:
  {
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = i4;
   HEAP32[i6 + 8 >> 2] = 1065353216;
   HEAP32[i6 + 12 >> 2] = 1065353216;
   STACKTOP = i7;
   return;
  }
 case 23:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = i3;
   HEAP32[i6 + 8 >> 2] = i4;
   HEAP32[i6 + 12 >> 2] = 1065353216;
   STACKTOP = i7;
   return;
  }
 case 20:
  {
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i4 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i3;
   HEAP32[i6 + 12 >> 2] = i4;
   STACKTOP = i7;
   return;
  }
 case 6:
  {
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i3;
   HEAP32[i6 + 12 >> 2] = i4;
   STACKTOP = i7;
   return;
  }
 case 15:
  {
   i3 = HEAPU16[i5 >> 1] | 0;
   i1 = i3 & 32767;
   L23 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L25 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L25;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L23;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L25;
     }
     i1 = i1 | 1879048192;
     break L23;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i6 >> 2] = i1 | i3 << 16 & -2147483648;
   HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
   STACKTOP = i7;
   return;
  }
 case 16:
  {
   i3 = HEAPU16[i5 >> 1] | 0;
   i1 = i3 & 32767;
   L34 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L36 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L36;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L34;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L36;
     }
     i1 = i1 | 1879048192;
     break L34;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i6 >> 2] = i1 | i3 << 16 & -2147483648;
   i4 = i6 + 4 | 0;
   i3 = HEAPU16[i5 + 2 >> 1] | 0;
   i1 = i3 & 32767;
   L43 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L45 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L45;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L43;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L45;
     }
     i1 = i1 | 1879048192;
     break L43;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i4 >> 2] = i1 | i3 << 16 & -2147483648;
   HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
   STACKTOP = i7;
   return;
  }
 case 17:
  {
   i3 = HEAPU16[i5 >> 1] | 0;
   i1 = i3 & 32767;
   L54 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L56 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L56;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L54;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L56;
     }
     i1 = i1 | 1879048192;
     break L54;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i6 >> 2] = i1 | i3 << 16 & -2147483648;
   i3 = i6 + 4 | 0;
   i4 = HEAPU16[i5 + 2 >> 1] | 0;
   i1 = i4 & 32767;
   L63 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L65 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L65;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L63;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L65;
     }
     i1 = i1 | 1879048192;
     break L63;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i3 >> 2] = i1 | i4 << 16 & -2147483648;
   i3 = i6 + 8 | 0;
   i4 = HEAPU16[i5 + 4 >> 1] | 0;
   i1 = i4 & 32767;
   L72 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L74 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L74;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L72;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L74;
     }
     i1 = i1 | 1879048192;
     break L72;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i3 >> 2] = i1 | i4 << 16 & -2147483648;
   i4 = i6 + 12 | 0;
   i3 = HEAPU16[i5 + 6 >> 1] | 0;
   i1 = i3 & 32767;
   L81 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i2 = i1 & 260046848;
    L83 : do if ((i2 | 0) < 260046848) {
     switch (i2 | 0) {
     case 0:
      break;
     default:
      break L83;
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     break L81;
    } else {
     switch (i2 | 0) {
     case 260046848:
      break;
     default:
      break L83;
     }
     i1 = i1 | 1879048192;
     break L81;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   HEAP32[i4 >> 2] = i1 | i3 << 16 & -2147483648;
   STACKTOP = i7;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1590, 1, 0, 0, 0);
   STACKTOP = i7;
   return;
  }
 } while (0);
}

function __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_(i1, i2, i23) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i57 + 64 | 0;
 i56 = i57;
 i49 = i56 + 20 | 0;
 i50 = i49 + 11 | 0;
 i51 = i56 + 32 | 0;
 i52 = i55 + 4 | 0;
 i53 = i56 + 4 | 0;
 i13 = i53 + 11 | 0;
 i14 = i56 + 16 | 0;
 i15 = i55 + 4 | 0;
 i16 = i56 + 20 | 0;
 i17 = i16 + 11 | 0;
 i18 = i56 + 32 | 0;
 i19 = i55 + 4 | 0;
 i20 = i56 + 4 | 0;
 i21 = i20 + 11 | 0;
 i22 = i56 + 16 | 0;
 i24 = i55 + 4 | 0;
 i25 = i56 + 20 | 0;
 i26 = i25 + 11 | 0;
 i27 = i56 + 32 | 0;
 i28 = i55 + 4 | 0;
 i29 = i56 + 4 | 0;
 i30 = i29 + 11 | 0;
 i31 = i56 + 16 | 0;
 i32 = i55 + 4 | 0;
 i33 = i56 + 20 | 0;
 i34 = i33 + 11 | 0;
 i35 = i56 + 32 | 0;
 i36 = i55 + 4 | 0;
 i37 = i56 + 4 | 0;
 i38 = i37 + 11 | 0;
 i39 = i56 + 16 | 0;
 i40 = i55 + 4 | 0;
 i41 = i56 + 20 | 0;
 i42 = i41 + 11 | 0;
 i43 = i56 + 32 | 0;
 i44 = i55 + 4 | 0;
 i45 = i56 + 4 | 0;
 i46 = i45 + 11 | 0;
 i47 = i56 + 16 | 0;
 i48 = i55 + 4 | 0;
 L1 : while (1) {
  i11 = i2;
  i12 = i2 + -64 | 0;
  while (1) {
   L5 : while (1) {
    i10 = i1;
    i3 = i11 - i10 | 0;
    i4 = i3 >> 6;
    switch (i4 | 0) {
    case 2:
     {
      i54 = 5;
      break L1;
     }
    case 3:
     {
      i54 = 11;
      break L1;
     }
    case 4:
     {
      i54 = 12;
      break L1;
     }
    case 5:
     {
      i54 = 13;
      break L1;
     }
    case 1:
    case 0:
     {
      i54 = 70;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 448) {
     i54 = 15;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 6) | 0;
    if ((i3 | 0) > 63936) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 6) | 0, i7, i7 + (i3 << 6) | 0, i12, i23) | 0;
    } else i3 = __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i1, i7, i12, i23) | 0;
    f8 = Math_fround(HEAPF32[i1 >> 2]);
    f6 = Math_fround(HEAPF32[i7 >> 2]);
    if (f8 < f6) {
     i4 = i12;
     break;
    } else i4 = i12;
    while (1) {
     i4 = i4 + -64 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (Math_fround(HEAPF32[i4 >> 2]) < f6) {
      i54 = 41;
      break L5;
     }
    }
    i3 = i1 + 64 | 0;
    if (!(f8 < Math_fround(HEAPF32[i12 >> 2]))) {
     if ((i3 | 0) == (i12 | 0)) {
      i54 = 70;
      break L1;
     }
     while (1) {
      if (f8 < Math_fround(HEAPF32[i3 >> 2])) break;
      i3 = i3 + 64 | 0;
      if ((i3 | 0) == (i12 | 0)) {
       i54 = 70;
       break L1;
      }
     }
     __ZN14AnimationEventC2ERKS_(i56, i3);
     __ZN14AnimationEventaSERKS_(i3, i12) | 0;
     __ZN14AnimationEventaSERKS_(i12, i56) | 0;
     if ((HEAP8[i17 >> 0] | 0) < 0) {
      i10 = HEAP32[i16 >> 2] | 0;
      i9 = HEAP32[i18 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i19 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i55);
     }
     if ((HEAP8[i21 >> 0] | 0) < 0) {
      i10 = HEAP32[i20 >> 2] | 0;
      i9 = HEAP32[i22 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i24 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i55);
     }
     i3 = i3 + 64 | 0;
    }
    if ((i3 | 0) == (i12 | 0)) {
     i54 = 70;
     break L1;
    } else i4 = i12;
    while (1) {
     f6 = Math_fround(HEAPF32[i1 >> 2]);
     while (1) {
      i5 = i3 + 64 | 0;
      if (f6 < Math_fround(HEAPF32[i3 >> 2])) break; else i3 = i5;
     }
     do i4 = i4 + -64 | 0; while (f6 < Math_fround(HEAPF32[i4 >> 2]));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     __ZN14AnimationEventC2ERKS_(i56, i3);
     __ZN14AnimationEventaSERKS_(i3, i4) | 0;
     __ZN14AnimationEventaSERKS_(i4, i56) | 0;
     if ((HEAP8[i50 >> 0] | 0) < 0) {
      i10 = HEAP32[i49 >> 2] | 0;
      i9 = HEAP32[i51 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i52 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i55);
     }
     if ((HEAP8[i13 >> 0] | 0) < 0) {
      i10 = HEAP32[i53 >> 2] | 0;
      i9 = HEAP32[i14 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i15 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i55);
     }
     i3 = i5;
    }
   }
   if ((i54 | 0) == 41) {
    i54 = 0;
    __ZN14AnimationEventC2ERKS_(i56, i1);
    __ZN14AnimationEventaSERKS_(i1, i4) | 0;
    __ZN14AnimationEventaSERKS_(i4, i56) | 0;
    if ((HEAP8[i42 >> 0] | 0) < 0) {
     i9 = HEAP32[i41 >> 2] | 0;
     i5 = HEAP32[i43 >> 2] | 0;
     HEAP32[i55 >> 2] = 66;
     HEAP32[i44 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i9, i55);
    }
    if ((HEAP8[i46 >> 0] | 0) < 0) {
     i9 = HEAP32[i45 >> 2] | 0;
     i5 = HEAP32[i47 >> 2] | 0;
     HEAP32[i55 >> 2] = 66;
     HEAP32[i48 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i9, i55);
    }
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 64 | 0;
   L53 : do if (i5 >>> 0 < i4 >>> 0) {
    i9 = i7;
    while (1) {
     f6 = Math_fround(HEAPF32[i9 >> 2]);
     while (1) {
      i7 = i5 + 64 | 0;
      if (Math_fround(HEAPF32[i5 >> 2]) < f6) i5 = i7; else break;
     }
     do i4 = i4 + -64 | 0; while (!(Math_fround(HEAPF32[i4 >> 2]) < f6));
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i9;
      break L53;
     }
     __ZN14AnimationEventC2ERKS_(i56, i5);
     __ZN14AnimationEventaSERKS_(i5, i4) | 0;
     __ZN14AnimationEventaSERKS_(i4, i56) | 0;
     if ((HEAP8[i34 >> 0] | 0) < 0) {
      i58 = HEAP32[i33 >> 2] | 0;
      i59 = HEAP32[i35 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i36 >> 2] = i59;
      __Z19free_alloc_internalPvRK10MemLabelId(i58, i55);
     }
     if ((HEAP8[i38 >> 0] | 0) < 0) {
      i59 = HEAP32[i37 >> 2] | 0;
      i58 = HEAP32[i39 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i40 >> 2] = i58;
      __Z19free_alloc_internalPvRK10MemLabelId(i59, i55);
     }
     i9 = (i9 | 0) == (i5 | 0) ? i4 : i9;
     i5 = i7;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) {
    f8 = Math_fround(HEAPF32[i4 >> 2]);
    if (f8 < Math_fround(HEAPF32[i5 >> 2])) {
     __ZN14AnimationEventC2ERKS_(i56, i5);
     __ZN14AnimationEventaSERKS_(i5, i4) | 0;
     __ZN14AnimationEventaSERKS_(i4, i56) | 0;
     if ((HEAP8[i26 >> 0] | 0) < 0) {
      i59 = HEAP32[i25 >> 2] | 0;
      i58 = HEAP32[i27 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i28 >> 2] = i58;
      __Z19free_alloc_internalPvRK10MemLabelId(i59, i55);
     }
     if ((HEAP8[i30 >> 0] | 0) < 0) {
      i59 = HEAP32[i29 >> 2] | 0;
      i58 = HEAP32[i31 >> 2] | 0;
      HEAP32[i55 >> 2] = 66;
      HEAP32[i32 >> 2] = i58;
      __Z19free_alloc_internalPvRK10MemLabelId(i59, i55);
     }
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR11EventSorterP14AnimationEventEEbT0_S5_T_(i1, i5, i23) | 0;
    i4 = i5 + 64 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR11EventSorterP14AnimationEventEEbT0_S5_T_(i4, i2, i23) | 0) {
     i54 = 69;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i59 = i5;
   if ((i59 - i10 | 0) >= (i11 - i59 | 0)) {
    i54 = 68;
    break;
   }
   __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_(i1, i5, i23);
   i1 = i5 + 64 | 0;
  }
  if ((i54 | 0) == 68) {
   i54 = 0;
   __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_(i5 + 64 | 0, i2, i23);
   i2 = i5;
   continue;
  } else if ((i54 | 0) == 69) {
   i54 = 0;
   if (i3) {
    i54 = 70;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i54 | 0) == 5) {
  f8 = Math_fround(HEAPF32[i12 >> 2]);
  if (!(f8 < Math_fround(HEAPF32[i1 >> 2]))) {
   STACKTOP = i57;
   return;
  }
  __ZN14AnimationEventC2ERKS_(i56, i1);
  __ZN14AnimationEventaSERKS_(i1, i12) | 0;
  __ZN14AnimationEventaSERKS_(i12, i56) | 0;
  i1 = i56 + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i59 = HEAP32[i1 >> 2] | 0;
   i58 = HEAP32[i56 + 32 >> 2] | 0;
   HEAP32[i55 >> 2] = 66;
   HEAP32[i55 + 4 >> 2] = i58;
   __Z19free_alloc_internalPvRK10MemLabelId(i59, i55);
  }
  i1 = i56 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i59 = HEAP32[i1 >> 2] | 0;
   i58 = HEAP32[i56 + 16 >> 2] | 0;
   HEAP32[i55 >> 2] = 66;
   HEAP32[i55 + 4 >> 2] = i58;
   __Z19free_alloc_internalPvRK10MemLabelId(i59, i55);
  }
  STACKTOP = i57;
  return;
 } else if ((i54 | 0) == 11) {
  __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i1, i1 + 64 | 0, i12, i23) | 0;
  STACKTOP = i57;
  return;
 } else if ((i54 | 0) == 12) {
  __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_(i1, i1 + 64 | 0, i1 + 128 | 0, i12, i23) | 0;
  STACKTOP = i57;
  return;
 } else if ((i54 | 0) == 13) {
  __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_(i1, i1 + 64 | 0, i1 + 128 | 0, i1 + 192 | 0, i12, i23) | 0;
  STACKTOP = i57;
  return;
 } else if ((i54 | 0) == 15) {
  __ZNSt3__218__insertion_sort_3IR11EventSorterP14AnimationEventEEvT0_S5_T_(i1, i2, i23);
  STACKTOP = i57;
  return;
 } else if ((i54 | 0) == 70) {
  STACKTOP = i57;
  return;
 }
}

function __ZL36PxcTestFacesSepAxesBackfaceRoughPassRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ESD_RfRSB_RjfSD_(i5, i64, i68, i69, i1, i65, i61, f2, f3, f4, i59, i66, i60, f58, i70) {
 i5 = i5 | 0;
 i64 = i64 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i1 = i1 | 0;
 i65 = i65 | 0;
 i61 = i61 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i59 = i59 | 0;
 i66 = i66 | 0;
 i60 = i60 | 0;
 f58 = Math_fround(f58);
 i70 = i70 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i62 = 0, i63 = 0, i67 = 0, i71 = 0, i72 = 0, f73 = f0, f74 = f0, f75 = f0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, f80 = f0, i81 = 0, f82 = f0, i83 = 0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0;
 i72 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i63 = i72 + 16 | 0;
 i62 = i72 + 12 | 0;
 i67 = i72;
 HEAP32[i60 >> 2] = -1;
 i52 = HEAP32[i5 + 16 >> 2] | 0;
 i54 = HEAP32[i5 + 24 >> 2] | 0;
 i55 = HEAP32[i5 + 28 >> 2] | 0;
 i56 = i1 + 36 | 0;
 f46 = Math_fround(Math_fround(HEAPF32[i56 >> 2]) * f2);
 i57 = i1 + 40 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i57 >> 2]) * f2);
 i53 = i1 + 44 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i53 >> 2]) * f2);
 i49 = i1 + 48 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i49 >> 2]) * f3);
 i50 = i1 + 52 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i50 >> 2]) * f3);
 i51 = i1 + 56 | 0;
 f8 = Math_fround(f46 + f8);
 f9 = Math_fround(f45 + f9);
 f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i51 >> 2]) * f3));
 i47 = i1 + 60 | 0;
 f45 = Math_fround(Math_fround(HEAPF32[i47 >> 2]) * f4);
 i48 = i1 + 64 | 0;
 f46 = Math_fround(Math_fround(HEAPF32[i48 >> 2]) * f4);
 i44 = i1 + 68 | 0;
 f45 = Math_fround(f8 + f45);
 f46 = Math_fround(f9 + f46);
 f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i44 >> 2]) * f4));
 if (!i52) {
  i71 = 1;
  STACKTOP = i72;
  return i71 | 0;
 }
 i18 = i67 + 4 | 0;
 i19 = i67 + 8 | 0;
 i20 = i68 + 4 | 0;
 i21 = i68 + 8 | 0;
 i22 = i68 + 12 | 0;
 i23 = i68 + 16 | 0;
 i24 = i68 + 20 | 0;
 i25 = i68 + 24 | 0;
 i26 = i68 + 28 | 0;
 i27 = i68 + 32 | 0;
 i28 = i69 + 4 | 0;
 i29 = i69 + 8 | 0;
 i30 = i69 + 12 | 0;
 i31 = i69 + 16 | 0;
 i32 = i69 + 20 | 0;
 i33 = i69 + 24 | 0;
 i34 = i69 + 28 | 0;
 i35 = i69 + 32 | 0;
 i36 = i70 + 4 | 0;
 i37 = i70 + 8 | 0;
 i38 = i5 + 44 | 0;
 i39 = i5 + 48 | 0;
 i40 = i5 + 52 | 0;
 i41 = i64 + 44 | 0;
 i42 = i64 + 48 | 0;
 i43 = i64 + 52 | 0;
 i11 = i5 + 40 | 0;
 i12 = i64 + 40 | 0;
 i13 = i64 + 64 | 0;
 i14 = i66 + 4 | 0;
 i15 = i66 + 8 | 0;
 i16 = 0;
 while (1) {
  i1 = i54 + (i16 * 20 | 0) | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(f45 * f2);
  i5 = i54 + (i16 * 20 | 0) + 4 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f46 * f3));
  i10 = i54 + (i16 * 20 | 0) + 8 | 0;
  f4 = Math_fround(HEAPF32[i10 >> 2]);
  if (!(Math_fround(f9 + Math_fround(f17 * f4)) < Math_fround(0.0))) {
   f73 = Math_fround(f2 * Math_fround(HEAPF32[i56 >> 2]));
   f7 = Math_fround(f2 * Math_fround(HEAPF32[i57 >> 2]));
   f6 = Math_fround(f2 * Math_fround(HEAPF32[i53 >> 2]));
   f8 = Math_fround(f3 * Math_fround(HEAPF32[i49 >> 2]));
   f9 = Math_fround(f3 * Math_fround(HEAPF32[i50 >> 2]));
   f8 = Math_fround(f73 + f8);
   f9 = Math_fround(f7 + f9);
   f6 = Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i51 >> 2])));
   f2 = Math_fround(f4 * Math_fround(HEAPF32[i47 >> 2]));
   f3 = Math_fround(f4 * Math_fround(HEAPF32[i48 >> 2]));
   f2 = Math_fround(f8 + f2);
   f3 = Math_fround(f9 + f3);
   f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i44 >> 2])));
   HEAPF32[i67 >> 2] = f2;
   HEAPF32[i18 >> 2] = f3;
   HEAPF32[i19 >> 2] = f4;
   f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)))));
   if (f6 > Math_fround(0.0)) {
    f73 = Math_fround(Math_fround(1.0) / f6);
    f2 = Math_fround(f2 * f73);
    HEAPF32[i67 >> 2] = f2;
    f3 = Math_fround(f3 * f73);
    HEAPF32[i18 >> 2] = f3;
    f4 = Math_fround(f4 * f73);
    HEAPF32[i19 >> 2] = f4;
   }
   f87 = Math_fround(HEAPF32[i68 >> 2]);
   f8 = Math_fround(f2 * f87);
   f86 = Math_fround(HEAPF32[i20 >> 2]);
   f74 = Math_fround(f2 * f86);
   f82 = Math_fround(HEAPF32[i21 >> 2]);
   f7 = Math_fround(f2 * f82);
   f85 = Math_fround(HEAPF32[i22 >> 2]);
   f88 = Math_fround(f3 * f85);
   f84 = Math_fround(HEAPF32[i23 >> 2]);
   f73 = Math_fround(f3 * f84);
   f80 = Math_fround(HEAPF32[i24 >> 2]);
   f88 = Math_fround(f8 + f88);
   f73 = Math_fround(f74 + f73);
   f7 = Math_fround(f7 + Math_fround(f3 * f80));
   f74 = Math_fround(HEAPF32[i25 >> 2]);
   f8 = Math_fround(f4 * f74);
   f2 = Math_fround(HEAPF32[i26 >> 2]);
   f9 = Math_fround(f4 * f2);
   f75 = Math_fround(HEAPF32[i27 >> 2]);
   f8 = Math_fround(f88 + f8);
   f9 = Math_fround(f73 + f9);
   f7 = Math_fround(f7 + Math_fround(f4 * f75));
   f73 = Math_fround(HEAPF32[i59 >> 2]);
   f82 = Math_fround(Math_fround(Math_fround(f87 * f8) + Math_fround(f86 * f9)) + Math_fround(f82 * f7));
   f80 = Math_fround(Math_fround(Math_fround(f85 * f8) + Math_fround(f84 * f9)) + Math_fround(f80 * f7));
   f75 = Math_fround(Math_fround(Math_fround(f74 * f8) + Math_fround(f2 * f9)) + Math_fround(f75 * f7));
   i83 = (HEAPF32[tempDoublePtr >> 2] = f82, HEAP32[tempDoublePtr >> 2] | 0);
   i81 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
   i79 = (HEAPF32[tempDoublePtr >> 2] = f75, HEAP32[tempDoublePtr >> 2] | 0);
   f2 = Math_fround(f8 * Math_fround(HEAPF32[i69 >> 2]));
   f2 = Math_fround(f2 + Math_fround(f9 * Math_fround(HEAPF32[i28 >> 2])));
   f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i29 >> 2])));
   f74 = Math_fround(f8 * Math_fround(HEAPF32[i30 >> 2]));
   f74 = Math_fround(f74 + Math_fround(f9 * Math_fround(HEAPF32[i31 >> 2])));
   f74 = Math_fround(f74 + Math_fround(f7 * Math_fround(HEAPF32[i32 >> 2])));
   f3 = Math_fround(f8 * Math_fround(HEAPF32[i33 >> 2]));
   f3 = Math_fround(f3 + Math_fround(f9 * Math_fround(HEAPF32[i34 >> 2])));
   f3 = Math_fround(f3 + Math_fround(f7 * Math_fround(HEAPF32[i35 >> 2])));
   i78 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i77 = (HEAPF32[tempDoublePtr >> 2] = f74, HEAP32[tempDoublePtr >> 2] | 0);
   f4 = Math_fround(f8 * Math_fround(HEAPF32[i70 >> 2]));
   f4 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i36 >> 2])));
   f4 = Math_fround(f4 + Math_fround(f7 * Math_fround(HEAPF32[i37 >> 2])));
   i76 = HEAP32[i43 >> 2] | (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
   f82 = Math_fround(f82 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i38 >> 2] | i83 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f80 = Math_fround(f82 + Math_fround(f80 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i39 >> 2] | i81 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f75 = Math_fround(f80 + Math_fround(f75 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i40 >> 2] | i79 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f2 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i41 >> 2] | i78 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f74 = Math_fround(f2 + Math_fround(f74 * (HEAP32[tempDoublePtr >> 2] = HEAP32[i42 >> 2] | i77 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f3 = Math_fround(f74 + Math_fround(f3 * (HEAP32[tempDoublePtr >> 2] = i76, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f74 = Math_fround(HEAPF32[i11 >> 2]);
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   f2 = Math_fround((f75 > f74 ? f75 : f74) + (f3 > f2 ? f3 : f2));
   f3 = Math_fround(f4 + f2);
   f4 = Math_fround(f2 - f4);
   if (!((f3 < f4 ? f3 : f4) > f73)) {
    f88 = Math_fround(Math_fround(1.0) / f6);
    i83 = HEAPU8[i54 + (i16 * 20 | 0) + 19 >> 0] | 0;
    f2 = Math_fround(HEAPF32[i1 >> 2]);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i55 + (i83 * 12 | 0) >> 2]));
    f3 = Math_fround(HEAPF32[i5 >> 2]);
    f3 = Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i55 + (i83 * 12 | 0) + 4 >> 2])));
    f2 = Math_fround(HEAPF32[i10 >> 2]);
    f2 = Math_fround(f88 * Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i55 + (i83 * 12 | 0) + 8 >> 2]))));
    f88 = Math_fround(f88 * Math_fround(HEAPF32[i54 + (i16 * 20 | 0) + 12 >> 2]));
    f3 = Math_fround(-f88);
    mftCall_viiiiii(HEAP32[i13 >> 2] | 0, i64 | 0, i67 | 0, i61 | 0, i65 | 0, i63 | 0, i62 | 0);
    f88 = Math_fround(f58 - f88);
    f4 = Math_fround(HEAPF32[i63 >> 2]);
    if (f88 < f4) break;
    f6 = Math_fround(HEAPF32[i62 >> 2]);
    if (Math_fround(f6 + f58) < f2) break;
    f88 = Math_fround(f3 - f4);
    f2 = Math_fround(f6 - f2);
    f2 = f88 < f2 ? f88 : f2;
    if (f2 < Math_fround(HEAPF32[i59 >> 2])) {
     HEAPF32[i66 >> 2] = f8;
     HEAPF32[i14 >> 2] = f9;
     HEAPF32[i15 >> 2] = f7;
     HEAPF32[i59 >> 2] = f2;
     HEAP32[i60 >> 2] = i16;
    }
   }
  }
  i16 = i16 + 1 | 0;
  if (i16 >>> 0 >= i52 >>> 0) {
   i1 = 1;
   i71 = 13;
   break;
  }
 }
 if ((i71 | 0) == 13) {
  STACKTOP = i72;
  return i1 | 0;
 }
 i83 = 0;
 STACKTOP = i72;
 return i83 | 0;
}

function __ZN10GameObject16CheckConsistencyEv(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 32 | 0;
 i19 = i22 + 24 | 0;
 i18 = i22 + 16 | 0;
 i12 = i22;
 i15 = i22 + 40 | 0;
 i13 = i22 + 36 | 0;
 i16 = i21 + 28 | 0;
 i17 = i21 + 40 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i9 = i21 + 8 | 0;
  i10 = i21 + 64 | 0;
  i11 = i15 + 11 | 0;
  i8 = i21 + 4 | 0;
  i7 = 0;
  do {
   i3 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i3 + (i7 << 3) + 4 >> 2] | 0;
   if (!i2) i4 = 0; else i4 = HEAP32[i2 + 4 >> 2] | 0;
   i6 = i7;
   i7 = i7 + 1 | 0;
   L8 : do if (i7 >>> 0 < i1 >>> 0) {
    i5 = i7;
    i2 = i3;
    do {
     while (1) {
      i3 = HEAP32[i2 + (i5 << 3) + 4 >> 2] | 0;
      if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
      if ((i4 | 0) != (i3 | 0)) break;
      i1 = HEAP32[gb + 1110260 >> 2] | 0;
      i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i9 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
      if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      i3 = HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 << 3) >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i12 + 4 >> 2] = i2;
      HEAP32[i12 + 8 >> 2] = i3;
      __Z6FormatPKcz(i15, gb + 368750 | 0, i12);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 368833 | 0, 674, 1, HEAP32[i8 >> 2] | 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      i3 = HEAP32[i16 >> 2] | 0;
      i2 = i3 + (i5 << 3) | 0;
      i1 = i2 + 8 | 0;
      _memmove(i2 | 0, i1 | 0, i3 + (HEAP32[i17 >> 2] << 3) - i1 | 0) | 0;
      i1 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
      HEAP32[i17 >> 2] = i1;
      if (i5 >>> 0 >= i1 >>> 0) break L8;
      i2 = HEAP32[i16 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < i1 >>> 0);
   } while (0);
  } while (i7 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i6 = (i21 | 0) == 0;
   i7 = i21 + 4 | 0;
   i5 = 0;
   L25 : do {
    L27 : do if (i6) while (1) {
     i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     if (!i1) i4 = 0; else i4 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i13 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i14 = 41; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i13);
       i2 = HEAP32[i15 >> 2] | 0;
       i12 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 41; else if (HEAP32[i1 + 4 >> 2] | 0) break L27;
     }
     if ((i14 | 0) == 41) i14 = 0;
     if (__ZN17PersistentManager17IsObjectAvailableEi(__Z20GetPersistentManagerv() | 0, i4) | 0) break L27;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 368908 | 0, 0, gb + 368833 | 0, 694, 1, 0, 0, 0);
     i12 = HEAP32[i16 >> 2] | 0;
     i11 = i12 + (i5 << 3) | 0;
     i1 = i11 + 8 | 0;
     _memmove(i11 | 0, i1 | 0, i12 + (HEAP32[i17 >> 2] << 3) - i1 | 0) | 0;
     i1 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
     HEAP32[i17 >> 2] = i1;
     if (i5 >>> 0 >= i1 >>> 0) break L25;
    } else while (1) {
     i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     if (!i1) i4 = 0; else i4 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i13 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i14 = 27; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i13);
       i2 = HEAP32[i15 >> 2] | 0;
       i12 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 27; else if (HEAP32[i1 + 4 >> 2] | 0) break L27;
     }
     if ((i14 | 0) == 27) i14 = 0;
     if (__ZN17PersistentManager17IsObjectAvailableEi(__Z20GetPersistentManagerv() | 0, i4) | 0) break L27;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 368908 | 0, 0, gb + 368833 | 0, 694, 1, HEAP32[i7 >> 2] | 0, 0, 0);
     i12 = HEAP32[i16 >> 2] | 0;
     i11 = i12 + (i5 << 3) | 0;
     i1 = i11 + 8 | 0;
     _memmove(i11 | 0, i1 | 0, i12 + (HEAP32[i17 >> 2] << 3) - i1 | 0) | 0;
     i1 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
     HEAP32[i17 >> 2] = i1;
     if (i5 >>> 0 >= i1 >>> 0) break L25;
    } while (0);
    i5 = i5 + 1 | 0;
    i1 = HEAP32[i17 >> 2] | 0;
   } while (i5 >>> 0 < i1 >>> 0);
   i6 = (i1 | 0) == 0;
   if (!i6) {
    i3 = HEAP32[i16 >> 2] | 0;
    i2 = 0;
    do {
     i4 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[(HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0) + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
     i5 = i3 + (i2 << 3) | 0;
     if ((HEAP32[i5 >> 2] | 0) != (i4 | 0)) HEAP32[i5 >> 2] = i4;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i1 >>> 0);
    if (!i6) {
     i6 = (i21 | 0) == 0;
     i7 = i15 + 11 | 0;
     i8 = i21 + 4 | 0;
     i9 = i15 + 11 | 0;
     i10 = i15 + 11 | 0;
     i5 = 0;
     do {
      L72 : while (1) {
       i2 = HEAP32[i16 >> 2] | 0;
       i4 = HEAP32[i2 + (i5 << 3) + 4 >> 2] | 0;
       do if (!i4) {
        HEAP32[i20 >> 2] = HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i5 << 3) >> 2] << 2) >> 2] | 0) + 8 >> 2];
        __Z6FormatPKcz(i15, gb + 369035 | 0, i20);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 368833 | 0, 747, 1, HEAP32[i8 >> 2] | 0, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
        i14 = 63;
       } else {
        i2 = i4 + 28 | 0;
        i3 = HEAP32[i2 >> 2] | 0;
        if ((i3 | 0) == (i21 | 0)) break L72;
        if (!i3) {
         HEAP32[i2 >> 2] = i21;
         i1 = HEAP32[gb + 1110260 >> 2] | 0;
         i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i4 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
         if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
         HEAP32[i18 >> 2] = i1;
         __Z6FormatPKcz(i15, gb + 368977 | 0, i18);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 368833 | 0, 736, 1, HEAP32[i8 >> 2] | 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
         i1 = HEAP32[i17 >> 2] | 0;
         break;
        }
        i1 = HEAP32[gb + 1110260 >> 2] | 0;
        i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i4 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
        if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
        HEAP32[i19 >> 2] = i1;
        __Z6FormatPKcz(i15, gb + 369035 | 0, i19);
        if (i6) i1 = 0; else i1 = HEAP32[i8 >> 2] | 0;
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 368833 | 0, 741, 1, i1, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, 61);
        i14 = 63;
       } while (0);
       if ((i14 | 0) == 63) {
        i14 = 0;
        i13 = HEAP32[i16 >> 2] | 0;
        i12 = i13 + (i5 << 3) | 0;
        i1 = i12 + 8 | 0;
        _memmove(i12 | 0, i1 | 0, i13 + (HEAP32[i17 >> 2] << 3) - i1 | 0) | 0;
        i1 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
        HEAP32[i17 >> 2] = i1;
       }
       if (i5 >>> 0 >= i1 >>> 0) break L1;
      }
      i5 = i5 + 1 | 0;
     } while (i5 >>> 0 < i1 >>> 0);
    }
   }
  }
 } while (0);
 if (__ZN10GameObject21EnsureUniqueTransformEbb(i21, 0, 0) | 0) {
  STACKTOP = i22;
  return;
 }
 if (!i21) i1 = 0; else i1 = HEAP32[i21 + 4 >> 2] | 0;
 if (!(HEAP32[i21 + 8 >> 2] & 1048576)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 369168 | 0, 0, gb + 368833 | 0, 761, 1, i1, 0, 0);
  STACKTOP = i22;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 369079 | 0, 0, gb + 368833 | 0, 759, 1, i1, 0, 0);
  STACKTOP = i22;
  return;
 }
}

function __ZNK12PhysXRaycast9IntersectERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_jR20BatchedRaycastResultb(i2, i62, i63, i64, f65, f66, i67, i68, i69, i4, i3) {
 i2 = i2 | 0;
 i62 = i62 | 0;
 i63 = i63 | 0;
 i64 = i64 | 0;
 f65 = Math_fround(f65);
 f66 = Math_fround(f66);
 i67 = i67 | 0;
 i68 = i68 | 0;
 i69 = i69 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var f1 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0;
 i70 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i70 + 188 | 0;
 i53 = i70 + 160 | 0;
 i54 = i70 + 120 | 0;
 i55 = i70 + 88 | 0;
 i56 = i70 + 216 | 0;
 i57 = i70 + 80 | 0;
 i58 = i70 + 48 | 0;
 i59 = i70;
 HEAP32[i57 >> 2] = 0;
 HEAPF32[i57 + 4 >> 2] = f66;
 HEAP32[i58 >> 2] = 0;
 HEAP32[i58 + 4 >> 2] = 0;
 HEAP32[i58 + 8 >> 2] = 0;
 HEAP32[i58 + 12 >> 2] = 1065353216;
 HEAP32[i58 + 16 >> 2] = HEAP32[i62 >> 2];
 i60 = i62 + 4 | 0;
 HEAP32[i58 + 20 >> 2] = HEAP32[i60 >> 2];
 i61 = i62 + 8 | 0;
 HEAP32[i58 + 24 >> 2] = HEAP32[i61 >> 2];
 i51 = i3 ? 515 : 519;
 f12 = i3 ? Math_fround(-1.0) : Math_fround(0.0);
 if (!i69) {
  f66 = Math_fround(inf);
  i69 = f66 < Math_fround(inf);
  STACKTOP = i70;
  return i69 | 0;
 }
 i15 = i59 + 4 | 0;
 i16 = i59 + 8 | 0;
 i17 = i59 + 12 | 0;
 i18 = i59 + 16 | 0;
 i19 = i59 + 40 | 0;
 i20 = i53 + 16 | 0;
 i21 = i53 + 20 | 0;
 i22 = i53 + 24 | 0;
 i23 = i52 + 12 | 0;
 i24 = i52 + 4 | 0;
 i25 = i52 + 8 | 0;
 i26 = i52 + 16 | 0;
 i27 = i52 + 20 | 0;
 i28 = i52 + 24 | 0;
 i29 = i53 + 12 | 0;
 i30 = i53 + 8 | 0;
 i31 = i53 + 4 | 0;
 i32 = i55 + 4 | 0;
 i33 = i55 + 8 | 0;
 i34 = i55 + 12 | 0;
 i35 = i55 + 16 | 0;
 i36 = i55 + 20 | 0;
 i37 = i55 + 24 | 0;
 i38 = i59 + 16 | 0;
 i39 = i59 + 20 | 0;
 i40 = i59 + 24 | 0;
 i41 = i4 + 52 | 0;
 i42 = i4 + 56 | 0;
 i43 = i4 + 4 | 0;
 i44 = i4 + 16 | 0;
 i45 = i4 + 28 | 0;
 i46 = i59 + 28 | 0;
 i47 = i4 + 40 | 0;
 f48 = Math_fround(f66 + Math_fround(9.99999997e-07));
 i49 = i4 + 32 | 0;
 i50 = i4 + 36 | 0;
 i13 = i4 + 40 | 0;
 i14 = i4 + 44 | 0;
 i10 = i4 + 48 | 0;
 f11 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 f1 = Math_fround(inf);
 i9 = 0;
 do {
  if (__Z26IntersectAABBAABBInclusiveRK4AABBS1_(i64, i68 + (i9 * 24 | 0) | 0) | 0) {
   i2 = HEAP32[i67 + (i9 << 4) + 4 >> 2] | 0;
   if (i2) {
    HEAP32[i59 >> 2] = 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i16 >> 2] = -1;
    HEAP16[i17 >> 1] = 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 + 12 >> 2] = 0;
    HEAP32[i18 + 16 >> 2] = 0;
    HEAP32[i18 + 20 >> 2] = 0;
    HEAPF32[i19 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i4 = HEAP32[i67 + (i9 << 4) >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i54 | 0, i2 | 0);
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i52 | 0, i4 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i53 | 0, i2 | 0);
    f77 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(2.0));
    f75 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * Math_fround(2.0));
    f5 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(2.0));
    f80 = Math_fround(HEAPF32[i23 >> 2]);
    f79 = Math_fround(Math_fround(f80 * f80) + Math_fround(-.5));
    f78 = Math_fround(HEAPF32[i52 >> 2]);
    f8 = Math_fround(f77 * f78);
    f76 = Math_fround(HEAPF32[i24 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f75 * f76));
    f74 = Math_fround(HEAPF32[i25 >> 2]);
    f8 = Math_fround(f8 + Math_fround(f5 * f74));
    f6 = Math_fround(Math_fround(f78 * f8) + Math_fround(Math_fround(f77 * f79) + Math_fround(f80 * Math_fround(Math_fround(f5 * f76) - Math_fround(f75 * f74)))));
    f7 = Math_fround(Math_fround(f76 * f8) + Math_fround(Math_fround(f75 * f79) + Math_fround(f80 * Math_fround(Math_fround(f77 * f74) - Math_fround(f5 * f78)))));
    f8 = Math_fround(Math_fround(Math_fround(f5 * f79) + Math_fround(f80 * Math_fround(Math_fround(f75 * f78) - Math_fround(f77 * f76)))) + Math_fround(f74 * f8));
    f6 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f6);
    f7 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f7);
    f8 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f8);
    f77 = Math_fround(HEAPF32[i53 >> 2]);
    f75 = Math_fround(f80 * f77);
    f79 = Math_fround(HEAPF32[i29 >> 2]);
    f75 = Math_fround(f75 + Math_fround(f78 * f79));
    f5 = Math_fround(HEAPF32[i30 >> 2]);
    f75 = Math_fround(f75 + Math_fround(f76 * f5));
    f73 = Math_fround(HEAPF32[i31 >> 2]);
    f72 = Math_fround(Math_fround(Math_fround(f74 * f77) + Math_fround(Math_fround(f76 * f79) + Math_fround(f80 * f73))) - Math_fround(f78 * f5));
    f71 = Math_fround(Math_fround(Math_fround(f78 * f73) + Math_fround(Math_fround(f74 * f79) + Math_fround(f80 * f5))) - Math_fround(f76 * f77));
    f5 = Math_fround(Math_fround(Math_fround(Math_fround(f80 * f79) - Math_fround(f78 * f77)) - Math_fround(f76 * f73)) - Math_fround(f74 * f5));
    HEAPF32[i55 >> 2] = Math_fround(f75 - Math_fround(f74 * f73));
    HEAPF32[i32 >> 2] = f72;
    HEAPF32[i33 >> 2] = f71;
    HEAPF32[i34 >> 2] = f5;
    HEAPF32[i35 >> 2] = f6;
    HEAPF32[i36 >> 2] = f7;
    HEAPF32[i37 >> 2] = f8;
    HEAP16[i56 >> 1] = i51;
    i4 = __ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i63, f65, i57, i58, i54, i55, i59, i56, Math_fround(0.0)) | 0;
    do if (i4 & Math_fround(HEAPF32[i19 >> 2]) > f12) {
     f5 = Math_fround(HEAPF32[i62 >> 2]);
     f5 = Math_fround(f5 - Math_fround(HEAPF32[i38 >> 2]));
     f6 = Math_fround(HEAPF32[i60 >> 2]);
     f6 = Math_fround(f6 - Math_fround(HEAPF32[i39 >> 2]));
     f7 = Math_fround(HEAPF32[i61 >> 2]);
     f7 = Math_fround(f7 - Math_fround(HEAPF32[i40 >> 2]));
     f8 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
     if (f8 < f1) {
      i2 = HEAP32[i2 + 8 >> 2] | 0;
      if (i2) {
       if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0) break;
       i3 = i2 + 4 | 0;
       HEAP32[i41 >> 2] = HEAP32[i3 >> 2];
       i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
       HEAP32[i42 >> 2] = HEAP32[((i4 | 0) == 0 ? i3 : i4 + 4 | 0) >> 2];
       HEAP32[i43 >> 2] = HEAP32[i62 >> 2];
       HEAP32[i43 + 4 >> 2] = HEAP32[i62 + 4 >> 2];
       HEAP32[i43 + 8 >> 2] = HEAP32[i62 + 8 >> 2];
       HEAP32[i44 >> 2] = HEAP32[i63 >> 2];
       HEAP32[i44 + 4 >> 2] = HEAP32[i63 + 4 >> 2];
       HEAP32[i44 + 8 >> 2] = HEAP32[i63 + 8 >> 2];
       if (!(Math_fround(HEAPF32[i19 >> 2]) <= Math_fround(0.0))) {
        HEAP32[i45 >> 2] = HEAP32[i46 >> 2];
        HEAP32[i45 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
        HEAP32[i45 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
        HEAP32[i47 >> 2] = HEAP32[i38 >> 2];
        HEAP32[i47 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
        HEAP32[i47 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
        f1 = Math_fround(HEAPF32[i45 >> 2]);
        f5 = Math_fround(HEAPF32[i49 >> 2]);
        f6 = Math_fround(HEAPF32[i50 >> 2]);
       } else {
        f1 = Math_fround(Math_sqrt(Math_fround(f8)));
        if (f1 > f11) {
         f80 = Math_fround(f5 / f1);
         i2 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
         f80 = Math_fround(f6 / f1);
         i3 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
         f80 = Math_fround(f7 / f1);
         i4 = (HEAPF32[tempDoublePtr >> 2] = f80, HEAP32[tempDoublePtr >> 2] | 0);
        } else {
         i2 = 0;
         i3 = 1065353216;
         i4 = 0;
        }
        HEAP32[i45 >> 2] = i2;
        HEAP32[i49 >> 2] = i3;
        HEAP32[i50 >> 2] = i4;
        f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f78 = Math_fround(f1 * f66);
        f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f79 = Math_fround(f5 * f66);
        f6 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        f80 = Math_fround(f6 * f66);
        f78 = Math_fround(Math_fround(HEAPF32[i62 >> 2]) - f78);
        f79 = Math_fround(Math_fround(HEAPF32[i60 >> 2]) - f79);
        f80 = Math_fround(Math_fround(HEAPF32[i61 >> 2]) - f80);
        HEAPF32[i13 >> 2] = f78;
        HEAPF32[i14 >> 2] = f79;
        HEAPF32[i10 >> 2] = f80;
       }
       f79 = Math_fround(f48 * f1);
       f80 = Math_fround(f48 * f5);
       f1 = Math_fround(f48 * f6);
       f79 = Math_fround(f79 + Math_fround(HEAPF32[i38 >> 2]));
       f80 = Math_fround(f80 + Math_fround(HEAPF32[i39 >> 2]));
       f1 = Math_fround(f1 + Math_fround(HEAPF32[i40 >> 2]));
       HEAPF32[i13 >> 2] = f79;
       HEAPF32[i14 >> 2] = f80;
       HEAPF32[i10 >> 2] = f1;
       f1 = f8;
      }
     }
    } while (0);
   }
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i69 | 0));
 i69 = f1 < Math_fround(inf);
 STACKTOP = i70;
 return i69 | 0;
}

function __ZN18BuoyancyEffector2D21ContactUpdateCallbackEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37 + 8 | 0;
 i4 = i37 + 52 | 0;
 i30 = i37 + 40 | 0;
 i36 = i37;
 i2 = __Z20GetPhysics2DSettingsv() | 0;
 f34 = Math_fround(Math_fround(1.0) / f1);
 f11 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 i26 = i3 + 76 | 0;
 i32 = HEAP32[i26 >> 2] | 0;
 i32 = i32 << 11 ^ i32;
 i33 = i3 + 80 | 0;
 HEAP32[i26 >> 2] = HEAP32[i33 >> 2];
 i26 = i3 + 84 | 0;
 HEAP32[i33 >> 2] = HEAP32[i26 >> 2];
 i33 = i3 + 88 | 0;
 i31 = HEAP32[i33 >> 2] | 0;
 HEAP32[i26 >> 2] = i31;
 i31 = i32 >>> 8 ^ i32 ^ i31 ^ i31 >>> 19;
 HEAP32[i33 >> 2] = i31;
 f28 = Math_fround(f11 + Math_fround(f28 * Math_fround(Math_fround((i31 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
 f11 = Math_fround(Math_fround(HEAPF32[i3 + 108 >> 2]) * Math_fround(.0174532924));
 f27 = Math_fround(Math_fround(+Math_cos(+f11)) * f28);
 f28 = Math_fround(Math_fround(+Math_sin(+f11)) * f28);
 i31 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i4, i31);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 __ZNK9Transform18GetWorldScaleLossyEv(i30, i31);
 f29 = Math_fround(HEAPF32[i30 + 4 >> 2]);
 f29 = Math_fround(f11 + Math_fround(f29 * Math_fround(HEAPF32[i3 + 92 >> 2])));
 i30 = i3 + 36 | 0;
 i31 = i3 + 48 | 0;
 i4 = HEAP32[i31 >> 2] | 0;
 if (!i4) {
  STACKTOP = i37;
  return;
 }
 i14 = HEAP32[i30 >> 2] | 0;
 i26 = i36 + 4 | 0;
 i32 = i3 + 96 | 0;
 i33 = i2 + 32 | 0;
 i24 = i2 + 36 | 0;
 i25 = i3 + 100 | 0;
 i20 = i3 + 104 | 0;
 i19 = i35 + 4 | 0;
 i21 = i35 + 8 | 0;
 i18 = i35 + 12 | 0;
 i22 = i35 + 16 | 0;
 i17 = i35 + 20 | 0;
 i23 = i35 + 24 | 0;
 i16 = i35 + 28 | 0;
 i15 = i14;
 i2 = i4;
 i3 = i14;
 do {
  i14 = HEAP32[i15 + 16 >> 2] | 0;
  i4 = HEAP32[i15 + 24 >> 2] | 0;
  do if ((HEAP32[i14 >> 2] | 0) == 2) if (!(HEAP8[i4 + 58 >> 0] | 0)) if (!(Math_fround(HEAPF32[i4 + 16 >> 2]) == Math_fround(0.0))) {
   i12 = HEAP32[i14 + 148 >> 2] | 0;
   if (HEAP8[i12 + 49 >> 0] | 0) if (!(HEAP32[i12 + 68 >> 2] | 0)) if (Math_fround(HEAPF32[i4 + 20 >> 2]) == Math_fround(0.0)) break;
   i3 = i14 + 12 | 0;
   i2 = HEAP32[i4 + 32 >> 2] | 0;
   i38 = HEAP32[i2 + 4 >> 2] | 0;
   i41 = gb + 1457504 | 0;
   i40 = HEAP32[i41 + 4 >> 2] | 0;
   i39 = i36;
   HEAP32[i39 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i39 + 4 >> 2] = i40;
   L14 : do switch (i38 | 0) {
   case 0:
    {
     f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
     f6 = Math_fround(HEAPF32[i14 + 24 >> 2]);
     f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
     f1 = Math_fround(f6 * f11);
     f7 = Math_fround(HEAPF32[i14 + 20 >> 2]);
     f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
     f1 = Math_fround(Math_fround(f1 - Math_fround(f7 * f5)) + Math_fround(HEAPF32[i3 >> 2]));
     f5 = Math_fround(Math_fround(Math_fround(f11 * f7) + Math_fround(f6 * f5)) + Math_fround(HEAPF32[i14 + 16 >> 2]));
     f6 = Math_fround(Math_fround(f5 + Math_fround(f1 * Math_fround(0.0))) - f29);
     f7 = Math_fround(-f6);
     if (!(Math_fround(Math_fround(1.17549435e-38) - f8) > f7)) if (f8 < f7) {
      HEAPF32[i36 >> 2] = f1;
      HEAPF32[i26 >> 2] = f5;
      f9 = Math_fround(f8 * Math_fround(f8 * Math_fround(3.14159274)));
      i13 = 19;
      break L14;
     } else {
      f9 = Math_fround(f8 * f8);
      f11 = Math_fround(f9 - Math_fround(f6 * f6));
      f9 = Math_fround(Math_fround(f9 * Math_fround(Math_fround(+Math_asin(+Math_fround(f7 / f8))) + Math_fround(1.57079637))) + Math_fround(Math_fround(Math_sqrt(Math_fround(f11))) * f7));
      f11 = Math_fround(Math_fround(Math_fround(+Math_pow(+f11, 1.5)) * Math_fround(-.666666686)) / f9);
      HEAPF32[i36 >> 2] = Math_fround(f1 + Math_fround(f11 * Math_fround(0.0)));
      HEAPF32[i26 >> 2] = Math_fround(f5 + f11);
      i13 = 19;
      break L14;
     }
     break;
    }
   case 2:
    {
     f9 = Math_fround(__Z29CalculatePolygonSubmergedAreaRK11b2TransformiPK6b2Vec2RK10b2MassDatafRS2_(i3, HEAP32[i2 + 148 >> 2] | 0, i2 + 20 | 0, i4, f29, i36));
     i13 = 19;
     break;
    }
   case 4:
    {
     f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
     f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
     f10 = Math_fround(HEAPF32[i2 + 16 >> 2]);
     f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
     f7 = Math_fround(HEAPF32[i2 + 24 >> 2]);
     f5 = Math_fround(f11 - f9);
     f1 = Math_fround(f7 - f10);
     f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f1 * f1))));
     if (!(f6 < Math_fround(1.1920929e-07))) {
      f6 = Math_fround(Math_fround(1.0) / f6);
      f5 = Math_fround(f5 * f6);
      f1 = Math_fround(f1 * f6);
     }
     f5 = Math_fround(f8 * f5);
     f42 = Math_fround(f9 - f5);
     f6 = Math_fround(f11 + f5);
     f11 = Math_fround(f8 * f1);
     f10 = Math_fround(f10 - f11);
     f9 = Math_fround(f7 + f11);
     f8 = Math_fround(f5 + f10);
     HEAPF32[i35 >> 2] = Math_fround(f42 - f11);
     HEAPF32[i19 >> 2] = f8;
     f10 = Math_fround(f10 - f5);
     HEAPF32[i21 >> 2] = Math_fround(f42 + f11);
     HEAPF32[i18 >> 2] = f10;
     f10 = Math_fround(f9 - f5);
     HEAPF32[i22 >> 2] = Math_fround(f6 + f11);
     HEAPF32[i17 >> 2] = f10;
     f9 = Math_fround(f5 + f9);
     HEAPF32[i23 >> 2] = Math_fround(f6 - f11);
     HEAPF32[i16 >> 2] = f9;
     f9 = Math_fround(__Z29CalculatePolygonSubmergedAreaRK11b2TransformiPK6b2Vec2RK10b2MassDatafRS2_(i3, 4, i35, i4, f29, i36));
     i13 = 19;
     break;
    }
   default:
    {}
   } while (0);
   if ((i13 | 0) == 19) {
    i13 = 0;
    if (!(f9 < Math_fround(1.1920929e-07))) {
     f42 = Math_fround(HEAPF32[gb + 151916 >> 2]);
     f42 = Math_fround(f42 * f42);
     f10 = Math_fround(HEAPF32[gb + 151920 >> 2]);
     f10 = Math_fround(f10 * f10);
     f45 = Math_fround(HEAPF32[i14 + 116 >> 2]);
     f5 = Math_fround(f27 * f9);
     f11 = Math_fround(f28 * f9);
     f1 = Math_fround(-Math_fround(f9 * Math_fround(HEAPF32[i32 >> 2])));
     f44 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f1);
     f1 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f1);
     f43 = Math_fround(HEAPF32[i12 + 44 >> 2]);
     f44 = Math_fround(f5 + Math_fround(f44 * f43));
     f43 = Math_fround(f11 + Math_fround(f1 * f43));
     f1 = Math_fround(HEAPF32[i14 + 72 >> 2]);
     f11 = Math_fround(HEAPF32[i36 >> 2]);
     f5 = Math_fround(f11 - Math_fround(HEAPF32[i14 + 44 >> 2]));
     f7 = Math_fround(HEAPF32[i26 >> 2]);
     f6 = Math_fround(HEAPF32[i14 + 48 >> 2]);
     f46 = Math_fround(f1 * Math_fround(f7 - f6));
     f8 = Math_fround(f1 * f5);
     f46 = Math_fround(Math_fround(HEAPF32[i14 + 64 >> 2]) - f46);
     f8 = Math_fround(f8 + Math_fround(HEAPF32[i14 + 68 >> 2]));
     i41 = HEAP32[i15 >> 2] | 0;
     f47 = Math_fround(HEAPF32[i41 + 72 >> 2]);
     f11 = Math_fround(f11 - Math_fround(HEAPF32[i41 + 44 >> 2]));
     f7 = Math_fround(f47 * Math_fround(f7 - Math_fround(HEAPF32[i41 + 48 >> 2])));
     f11 = Math_fround(f47 * f11);
     f7 = Math_fround(Math_fround(HEAPF32[i41 + 64 >> 2]) - f7);
     f7 = Math_fround(f46 - f7);
     f11 = Math_fround(f8 - Math_fround(f11 + Math_fround(HEAPF32[i41 + 68 >> 2])));
     f8 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
     f45 = Math_fround(f34 * f45);
     f8 = f45 < f8 ? f45 : f8;
     f7 = Math_fround(f44 - Math_fround(f7 * f8));
     f8 = Math_fround(f43 - Math_fround(f11 * f8));
     if (Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) > f42) if ((HEAP32[i14 >> 2] | 0) == 2) {
      i3 = i14 + 4 | 0;
      i2 = HEAP16[i3 >> 1] | 0;
      if (!(i2 & 2)) {
       i4 = i2 & 65535;
       if (!(i4 & 2)) {
        i2 = (i4 | 2) & 65535;
        HEAP16[i3 >> 1] = i2;
        HEAPF32[i14 + 144 >> 2] = Math_fround(0.0);
       }
      }
      if (i2 & 2) {
       i41 = i14 + 76 | 0;
       HEAPF32[i41 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i41 >> 2]));
       i41 = i14 + 80 | 0;
       HEAPF32[i41 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i41 >> 2]));
       f47 = Math_fround(Math_fround(f8 * f5) - Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f6)));
       i41 = i14 + 84 | 0;
       HEAPF32[i41 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f47);
      }
     }
     f47 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
     f46 = Math_fround(f34 * Math_fround(HEAPF32[i14 + 124 >> 2]));
     f1 = Math_fround(f1 * (f46 < f47 ? f46 : f47));
     if (Math_fround(f1 * f1) > f10) if ((HEAP32[i14 >> 2] | 0) == 2) {
      i3 = i14 + 4 | 0;
      i2 = HEAP16[i3 >> 1] | 0;
      if (!(i2 & 2)) {
       i4 = i2 & 65535;
       if (!(i4 & 2)) {
        i2 = (i4 | 2) & 65535;
        HEAP16[i3 >> 1] = i2;
        HEAPF32[i14 + 144 >> 2] = Math_fround(0.0);
       }
      }
      if (i2 & 2) {
       i41 = i14 + 84 | 0;
       HEAPF32[i41 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) - f1);
      }
     }
    }
   }
   i3 = HEAP32[i30 >> 2] | 0;
   i2 = HEAP32[i31 >> 2] | 0;
  } while (0);
  i15 = i15 + 40 | 0;
 } while ((i15 | 0) != (i3 + (i2 * 40 | 0) | 0));
 STACKTOP = i37;
 return;
}

function __ZN7mecanim5human21HumanSubColliderXformEPKNS0_5HumanERKN4math4trsXEi(i4, i5, i8, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0;
 i9 = i4 + 28 | 0;
 i10 = i4 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i10 >> 2] = 1065353216;
 HEAP32[i9 >> 2] = 1065353216;
 i11 = i4 + 32 | 0;
 HEAP32[i11 >> 2] = 1065353216;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 1065353216;
 i1 = HEAP32[i5 + 72 + (i3 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i6 = i5 + 40 | 0;
 i7 = i6;
 i2 = (HEAP32[i6 >> 2] | 0) + i7 + 4 | 0;
 i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 i1 = HEAP32[i5 + 264 + (i3 << 2) >> 2] | 0;
 if ((i1 | i2 | 0) <= -1) return;
 i26 = HEAP32[i8 + 4 >> 2] | 0;
 i17 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i27 = i4 + 4 | 0;
 HEAP32[i27 >> 2] = i26;
 i26 = i4 + 8 | 0;
 HEAP32[i26 >> 2] = i17;
 i17 = i4 + 12 | 0;
 i3 = HEAP32[i8 + 16 >> 2] | 0;
 i44 = HEAP32[i8 + 20 >> 2] | 0;
 i46 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i8 + 12 >> 2];
 i15 = i4 + 16 | 0;
 HEAP32[i15 >> 2] = i3;
 i3 = i4 + 20 | 0;
 HEAP32[i3 >> 2] = i44;
 HEAP32[i10 >> 2] = i46;
 i46 = HEAP32[i8 + 28 >> 2] | 0;
 i44 = HEAP32[i8 + 32 >> 2] | 0;
 i45 = HEAP32[i8 + 36 >> 2] | 0;
 HEAP32[i9 >> 2] = i46;
 HEAP32[i11 >> 2] = i44;
 HEAP32[i12 >> 2] = i45;
 i5 = i5 + 68 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 f30 = Math_fround(HEAPF32[i5 + (i1 * 72 | 0) + 24 >> 2]);
 f24 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i45 = Math_fround(Math_abs(Math_fround(f24))) < Math_fround(9.99999971e-10);
 i44 = Math_fround(Math_abs(Math_fround(f20))) < Math_fround(9.99999971e-10);
 i8 = Math_fround(Math_abs(Math_fround(f21))) < Math_fround(9.99999971e-10);
 f23 = Math_fround(Math_fround(1.0) / f24);
 f23 = i45 ? Math_fround(1.0) : f23;
 f18 = Math_fround(Math_fround(1.0) / f20);
 f18 = i44 ? Math_fround(1.0) : f18;
 f19 = Math_fround(Math_fround(1.0) / f21);
 f19 = i8 ? Math_fround(1.0) : f19;
 f41 = Math_fround(HEAPF32[i5 + (i1 * 72 | 0) >> 2]);
 f37 = Math_fround(HEAPF32[i5 + (i1 * 72 | 0) + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i5 + (i1 * 72 | 0) + 8 >> 2]);
 f40 = Math_fround(-f41);
 f31 = Math_fround(-f37);
 f38 = Math_fround(-f28);
 f32 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i1 * 72 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i1 * 72 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i1 * 72 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f32 * Math_fround(-2.0));
 f25 = Math_fround(f32 * Math_fround(2.0));
 f39 = Math_fround(f30 * f29);
 f42 = Math_fround(f36 * Math_fround(2.0));
 f14 = Math_fround(f36 * Math_fround(-2.0));
 f13 = Math_fround(f30 * f14);
 f35 = Math_fround(f34 * Math_fround(-2.0));
 f43 = Math_fround(f34 * Math_fround(2.0));
 f33 = Math_fround(f30 * f35);
 f41 = Math_fround(f24 * Math_fround(f23 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f32 * f29) - Math_fround(f36 * f42)) * f40) - f41) + Math_fround(Math_fround(Math_fround(f13 - Math_fround(f32 * f35)) * f31) + Math_fround(Math_fround(Math_fround(f43 * f36) - f39) * f38)))));
 f29 = Math_fround(f20 * Math_fround(f18 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f34 * f25) - f13) * f40) - f37) + Math_fround(Math_fround(Math_fround(Math_fround(f36 * f14) - Math_fround(f34 * f43)) * f31) + Math_fround(Math_fround(f33 - Math_fround(f36 * f29)) * f38)))));
 f38 = Math_fround(f21 * Math_fround(f19 * Math_fround(Math_fround(Math_fround(Math_fround(f39 - Math_fround(f34 * f14)) * f40) - f28) + Math_fround(Math_fround(Math_fround(Math_fround(f32 * f42) - f33) * f31) + Math_fround(Math_fround(Math_fround(f34 * f35) - Math_fround(f32 * f25)) * f38)))));
 f25 = Math_fround(HEAPF32[i15 >> 2]);
 f35 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f31 = Math_fround(HEAPF32[i10 >> 2]);
 f33 = Math_fround(HEAPF32[i3 >> 2]);
 f42 = Math_fround(f25 * Math_fround(-2.0));
 f28 = Math_fround(f25 * Math_fround(2.0));
 f40 = Math_fround(f42 * f31);
 f14 = Math_fround(f33 * Math_fround(2.0));
 f39 = Math_fround(f33 * Math_fround(-2.0));
 f43 = Math_fround(f31 * f39);
 f37 = Math_fround(f35 * Math_fround(-2.0));
 f13 = Math_fround(f35 * Math_fround(2.0));
 f16 = Math_fround(f31 * f37);
 f22 = Math_fround(Math_fround(f41 + Math_fround(f41 * Math_fround(Math_fround(f25 * f42) - Math_fround(f33 * f14)))) + Math_fround(Math_fround(f38 * Math_fround(Math_fround(f13 * f33) - f40)) + Math_fround(f29 * Math_fround(f43 - Math_fround(f25 * f37)))));
 f13 = Math_fround(Math_fround(f29 + Math_fround(f41 * Math_fround(Math_fround(f35 * f28) - f43))) + Math_fround(Math_fround(f38 * Math_fround(f16 - Math_fround(f42 * f33))) + Math_fround(f29 * Math_fround(Math_fround(f33 * f39) - Math_fround(f35 * f13)))));
 f16 = Math_fround(Math_fround(f38 + Math_fround(f41 * Math_fround(f40 - Math_fround(f35 * f39)))) + Math_fround(Math_fround(f38 * Math_fround(Math_fround(f35 * f37) - Math_fround(f25 * f28))) + Math_fround(f29 * Math_fround(Math_fround(f25 * f14) - f16))));
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f29 = Math_fround(HEAPF32[i27 >> 2]);
 f22 = Math_fround(f14 + f22);
 f13 = Math_fround(f29 + f13);
 f16 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f16);
 f29 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f25) - Math_fround(f36 * f31)) - Math_fround(f30 * f33)) - Math_fround(f32 * f35));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f31) - Math_fround(f34 * f35)) - Math_fround(f36 * f33)) - Math_fround(f32 * f25));
 f28 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f33) - Math_fround(f36 * f25)) - Math_fround(f34 * f31)) - Math_fround(f30 * f35));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33)) - Math_fround(f32 * f31)) - Math_fround(f30 * f25));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f23 = Math_fround(f24 * f23);
 f18 = Math_fround(f20 * f18);
 f19 = Math_fround(f21 * f19);
 HEAPF32[i4 >> 2] = f22;
 HEAPF32[i27 >> 2] = f13;
 HEAPF32[i26 >> 2] = f16;
 HEAPF32[i9 >> 2] = f23;
 HEAPF32[i11 >> 2] = f18;
 HEAPF32[i12 >> 2] = f19;
 i12 = (HEAP32[i6 >> 2] | 0) + i7 + 16 | 0;
 i12 = i12 + (HEAP32[i12 >> 2] | 0) | 0;
 f19 = Math_fround(HEAPF32[i12 + (i2 * 76 | 0) + 28 >> 2]);
 f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i2 * 76 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f23 * f18);
 f13 = Math_fround(f19 * f14);
 f22 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i2 * 76 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f21 * f22);
 f24 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i2 * 76 | 0) + 24 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f25 * f14)) - Math_fround(f19 * f22)) - Math_fround(f21 * f24));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f23 * f24)) - Math_fround(f25 * f22)) - Math_fround(f21 * f18));
 f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f25 * f18)) - Math_fround(f23 * f14)) - Math_fround(f19 * f24));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f14)) - Math_fround(f19 * f18));
 i12 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f18 = (HEAP32[tempDoublePtr >> 2] = i9 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f18 * f18);
 f16 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(f16 * f16);
 f14 = (HEAP32[tempDoublePtr >> 2] = i12 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f20 + f19)))));
 f16 = Math_fround(f19 * f16);
 f14 = Math_fround(f19 * f14);
 f13 = Math_fround(f19 * f13);
 HEAPF32[i17 >> 2] = Math_fround(f19 * f18);
 HEAPF32[i15 >> 2] = f16;
 HEAPF32[i3 >> 2] = f14;
 HEAPF32[i10 >> 2] = f13;
 return;
}

function __Z26OptimizeTransformHierarchyR10GameObjectPK8UnityStrj(i24, i19, i25) {
 i24 = i24 | 0;
 i19 = i19 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i33 + 24 | 0;
 i30 = i33;
 i31 = i33 + 76 | 0;
 i32 = i33 + 56 | 0;
 i22 = i33 + 40 | 0;
 i26 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i24, gb + 67008 | 0) | 0;
 if (!i26) {
  STACKTOP = i33;
  return;
 }
 if (!(__ZNK8Animator13IsOptimizableEv(i26) | 0)) {
  STACKTOP = i33;
  return;
 }
 if (!(HEAP8[i26 + 561 >> 0] | 0)) {
  STACKTOP = i33;
  return;
 }
 i8 = __ZN8Animator13GetAvatarRootEv(i26) | 0;
 if (!i8) {
  STACKTOP = i33;
  return;
 }
 i9 = HEAP32[i8 + 28 >> 2] | 0;
 i1 = __ZN6Avatar8GetAssetEv(__ZN8Animator9GetAvatarEv(i26) | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i33;
  return;
 }
 i7 = i2 + i1 | 0;
 i28 = gb + 64016 | 0;
 i27 = HEAP32[i28 + 4 >> 2] | 0;
 i3 = i30;
 HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i3 + 4 >> 2] = i27;
 HEAP32[i31 >> 2] = 0;
 i3 = i31 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i27 = i31 + 16 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i31 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i30);
 i18 = i29;
 i20 = HEAP32[i18 + 4 >> 2] | 0;
 i21 = i28;
 HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i9, 1, __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(137) | 0, i31);
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i30 + 12 | 0;
  i5 = i30 + 16 | 0;
  i6 = i30 + 4 | 0;
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i31 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (__ZN19SkinnedMeshRenderer11GetRootBoneEv(i2) | 0) {
    i20 = __ZN19SkinnedMeshRenderer11GetRootBoneEv(i2) | 0;
    i21 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
    __ZNK9Transform11GetPositionEv(i29, i20);
    __ZNK9Transform11GetRotationEv(i30, i20);
    __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i21, i29, i30);
   }
   __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform(i2, 0);
   HEAP32[i30 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, gb + 63664 | 0);
   i18 = i29;
   i20 = HEAP32[i18 + 4 >> 2] | 0;
   i21 = i6;
   HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE(i2, i30);
   if ((HEAP32[i5 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i6);
    HEAP32[i30 >> 2] = 0;
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = 0;
 i20 = i32 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i32 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, gb + 63664 | 0);
 i5 = i29;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i21;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZL33GetNonSkeletonTransformsRecursiveRKN7mecanim8skeleton8SkeletonERK9TransformS6_R13dynamic_arrayIPS5_Lj4EE(i7, i8, i8, i32);
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i9, gb + 28940 | 0) | 0;
 i4 = HEAP32[i3 + 92 >> 2] | 0;
 HEAP32[i30 + 12 >> 2] = i4;
 i5 = i30 + 16 | 0;
 HEAP32[i5 >> 2] = i4;
 i6 = i30 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, gb + 64016 | 0);
 i17 = i29;
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i30 >> 2] = i1;
 if ((i4 | 0) > 0) {
  i2 = i3 + 80 | 0;
  HEAP32[i1 >> 2] = HEAP32[HEAP32[i2 >> 2] >> 2];
  if ((i4 | 0) == 1) i1 = 0; else {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   i1 = 0;
  }
  do {
   __ZL40FlattenSkeletonTransformHierarchyRecurseRK13dynamic_arrayIPK9TransformLj4EERS0_S6_(i32, i3, HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i6);
  HEAP32[i30 >> 2] = 0;
 }
 __ZN8Animator11ClearObjectEv(i26);
 HEAP32[i30 >> 2] = 0;
 i18 = i30 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i30 + 12 >> 2] = i1;
 i17 = (i25 | 0) == 0;
 if (i17) i1 = HEAP32[i30 >> 2] | 0; else {
  if ((i25 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i30);
   i1 = HEAP32[i30 + 12 >> 2] | 0;
  }
  HEAP32[i29 >> 2] = 1;
  HEAP32[i29 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i25 << 4, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i30 >> 2] = i2;
  HEAP32[i30 + 8 >> 2] = i2 + (i25 << 4);
  i1 = i25;
  do {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i2 = (HEAP32[i18 >> 2] | 0) + 16 | 0;
   HEAP32[i18 >> 2] = i2;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
  i1 = HEAP32[i30 >> 2] | 0;
  if (!i17) {
   i11 = i22 + 12 | 0;
   i10 = i22 + 12 | 0;
   i12 = i29 + 4 | 0;
   i13 = i22 + 8 | 0;
   i14 = i22 + 4 | 0;
   i15 = i22 + 11 | 0;
   i16 = i29 + 4 | 0;
   i9 = 0;
   do {
    i8 = i1 + (i9 << 4) | 0;
    i2 = i19 + (i9 << 4) | 0;
    i3 = HEAP8[i2 + 11 >> 0] | 0;
    if (i3 << 24 >> 24 < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i3 = HEAP32[i19 + (i9 << 4) + 4 >> 2] | 0;
    } else i3 = i3 & 255;
    i3 = __Z24GetLastPathNameComponentPKcj(i2, i3) | 0;
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    HEAP32[i22 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i11 >> 2] = i2;
    i4 = _strlen(i3) | 0;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
     i2 = HEAP32[i10 >> 2] | 0;
     i23 = 34;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i15 >> 0] = i4;
     if (!i4) i2 = i22; else {
      i2 = i22;
      i23 = 36;
     }
    } else i23 = 34;
    if ((i23 | 0) == 34) {
     i7 = i4 + 16 & -16;
     HEAP32[i29 >> 2] = 66;
     HEAP32[i12 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i22 >> 2] = i2;
     HEAP32[i13 >> 2] = i7 | -2147483648;
     HEAP32[i14 >> 2] = i4;
     i23 = 36;
    }
    if ((i23 | 0) == 36) {
     i23 = 0;
     _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i2 + i4 >> 0] = 0;
    do if ((i8 | 0) != (i22 | 0)) {
     i7 = HEAP8[i15 >> 0] | 0;
     i4 = i7 << 24 >> 24 < 0;
     i6 = i4 ? HEAP32[i22 >> 2] | 0 : i22;
     i7 = i4 ? HEAP32[i14 >> 2] | 0 : i7 & 255;
     i4 = i8 + 11 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
     i3 = i2 << 24 >> 24 < 0;
     if (i3) i5 = (HEAP32[i1 + (i9 << 4) + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
     if (i7 >>> 0 > i5 >>> 0) {
      if (i3) i1 = HEAP32[i1 + (i9 << 4) + 4 >> 2] | 0; else i1 = i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i5, i7 - i5 | 0, i1, 0, i1, i7, i6);
      break;
     }
     if (i3) i2 = HEAP32[i8 >> 2] | 0; else i2 = i8;
     if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
     HEAP8[i2 + i7 >> 0] = 0;
     if ((HEAP8[i4 >> 0] | 0) < 0) {
      HEAP32[i1 + (i9 << 4) + 4 >> 2] = i7;
      break;
     } else {
      HEAP8[i4 >> 0] = i7;
      break;
     }
    } while (0);
    if ((HEAP8[i15 >> 0] | 0) < 0) {
     i8 = HEAP32[i22 >> 2] | 0;
     i7 = HEAP32[i10 >> 2] | 0;
     HEAP32[i29 >> 2] = 66;
     HEAP32[i16 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i29);
    }
    i9 = i9 + 1 | 0;
    i1 = HEAP32[i30 >> 2] | 0;
   } while ((i9 | 0) != (i25 | 0));
  }
 }
 __Z27RemoveUnnecessaryTransformsR10GameObjectPK16HumanDescriptionPK8UnityStrjb(i24, 0, i17 ? 0 : i1, i25, 0);
 __ZN8Animator24SetHasTransformHierarchyEb(i26, 0);
 i1 = HEAP32[i30 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i18 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i4 = i29 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i18 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i26 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i29 >> 2] = 66;
     HEAP32[i4 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i26, i29);
     i2 = HEAP32[i18 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i30 >> 2] | 0;
  }
  i30 = HEAP32[i30 + 12 >> 2] | 0;
  HEAP32[i29 >> 2] = 1;
  HEAP32[i29 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i29);
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i21);
  HEAP32[i32 >> 2] = 0;
 }
 if ((HEAP32[i27 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i28);
  HEAP32[i31 >> 2] = 0;
 }
 STACKTOP = i33;
 return;
}

function __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i22, i23) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i24 + 160 | 0;
 i11 = i24 + 128 | 0;
 i8 = i24 + 96 | 0;
 i14 = i24 + 48 | 0;
 i12 = i24;
 f26 = Math_fround(HEAPF32[i23 >> 2]);
 i20 = i23 + 4 | 0;
 f16 = Math_fround(HEAPF32[i20 >> 2]);
 i21 = i23 + 8 | 0;
 f18 = Math_fround(HEAPF32[i21 >> 2]);
 f28 = Math_fround(f26 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f25 = Math_fround(f26 * Math_fround(HEAPF32[i22 + 40 >> 2]));
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i22 + 44 >> 2]));
 f27 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 52 >> 2]));
 f17 = Math_fround(f16 * Math_fround(HEAPF32[i22 + 56 >> 2]));
 f27 = Math_fround(f28 + f27);
 f17 = Math_fround(f25 + f17);
 f16 = Math_fround(f26 + Math_fround(f16 * Math_fround(HEAPF32[i22 + 60 >> 2])));
 f26 = Math_fround(f18 * Math_fround(HEAPF32[i22 + 68 >> 2]));
 f25 = Math_fround(f18 * Math_fround(HEAPF32[i22 + 72 >> 2]));
 f26 = Math_fround(f27 + f26);
 f25 = Math_fround(f17 + f25);
 f18 = Math_fround(f16 + Math_fround(f18 * Math_fround(HEAPF32[i22 + 76 >> 2])));
 f16 = Math_fround(HEAPF32[i22 + 84 >> 2]);
 f17 = Math_fround(HEAPF32[i22 + 88 >> 2]);
 f16 = Math_fround(f26 + f16);
 f17 = Math_fround(f25 + f17);
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i22 + 92 >> 2]));
 HEAPF32[i23 >> 2] = f16;
 HEAPF32[i20 >> 2] = f17;
 HEAPF32[i21 >> 2] = f18;
 i19 = i22 + 32 | 0;
 i1 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
 HEAP32[i19 >> 2] = i1;
 L1 : do switch (HEAP32[i22 >> 2] | 0) {
 case 0:
  {
   i15 = HEAP32[i22 + 100 >> 2] | 0;
   i1 = i15 + 4 | 0;
   HEAPF32[i5 >> 2] = f16;
   HEAPF32[i5 + 4 >> 2] = f17;
   HEAPF32[i5 + 8 >> 2] = f18;
   i2 = HEAP32[i22 + 4 >> 2] | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   i3 = i15 + 8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i15 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    i15 = HEAP32[i1 >> 2] | 0;
    HEAPF32[i15 + (i4 << 4) >> 2] = f16;
    HEAPF32[i15 + (i4 << 4) + 4 >> 2] = f17;
    HEAPF32[i15 + (i4 << 4) + 8 >> 2] = f18;
    HEAP32[i15 + (i4 << 4) + 12 >> 2] = i2;
    HEAP32[i3 >> 2] = i4 + 1;
    i15 = 23;
    break L1;
   } else {
    __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i5) | 0;
    i15 = 23;
    break L1;
   }
  }
 case 1:
  {
   if ((i1 | 0) == 2) {
    i14 = HEAP32[i22 + 100 >> 2] | 0;
    i4 = i14 + 16 | 0;
    i1 = i22 + 8 | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    HEAP32[i11 >> 2] = i5;
    i3 = i22 + 12 | 0;
    i6 = HEAP32[i3 >> 2] | 0;
    HEAP32[i11 + 4 >> 2] = i6;
    i2 = i22 + 16 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    HEAP32[i11 + 8 >> 2] = i7;
    i8 = HEAP32[i22 + 4 >> 2] | 0;
    HEAP32[i11 + 12 >> 2] = i8;
    HEAPF32[i11 + 16 >> 2] = f16;
    HEAPF32[i11 + 20 >> 2] = f17;
    HEAPF32[i11 + 24 >> 2] = f18;
    HEAP32[i11 + 28 >> 2] = i8;
    i9 = i14 + 20 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    if ((HEAP32[i14 + 24 >> 2] & 2147483647) >>> 0 > i10 >>> 0) {
     i14 = HEAP32[i4 >> 2] | 0;
     HEAP32[i14 + (i10 << 5) >> 2] = i5;
     HEAP32[i14 + (i10 << 5) + 4 >> 2] = i6;
     HEAP32[i14 + (i10 << 5) + 8 >> 2] = i7;
     HEAP32[i14 + (i10 << 5) + 12 >> 2] = i8;
     HEAPF32[i14 + (i10 << 5) + 16 >> 2] = f16;
     HEAPF32[i14 + (i10 << 5) + 20 >> 2] = f17;
     HEAPF32[i14 + (i10 << 5) + 24 >> 2] = f18;
     HEAP32[i14 + (i10 << 5) + 28 >> 2] = i8;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i4, i11) | 0;
    HEAP32[i19 >> 2] = 0;
   } else i15 = 23;
   break;
  }
 case 2:
  {
   if (i1 >>> 0 > 1) {
    i15 = HEAP32[i22 + 100 >> 2] | 0;
    i1 = i15 + 16 | 0;
    i2 = HEAP32[i22 + 8 >> 2] | 0;
    HEAP32[i8 >> 2] = i2;
    i3 = HEAP32[i22 + 12 >> 2] | 0;
    HEAP32[i8 + 4 >> 2] = i3;
    i4 = HEAP32[i22 + 16 >> 2] | 0;
    HEAP32[i8 + 8 >> 2] = i4;
    i5 = HEAP32[i22 + 4 >> 2] | 0;
    HEAP32[i8 + 12 >> 2] = i5;
    HEAPF32[i8 + 16 >> 2] = f16;
    HEAPF32[i8 + 20 >> 2] = f17;
    HEAPF32[i8 + 24 >> 2] = f18;
    HEAP32[i8 + 28 >> 2] = i5;
    i6 = i15 + 20 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i15 + 24 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
     i15 = HEAP32[i1 >> 2] | 0;
     HEAP32[i15 + (i7 << 5) >> 2] = i2;
     HEAP32[i15 + (i7 << 5) + 4 >> 2] = i3;
     HEAP32[i15 + (i7 << 5) + 8 >> 2] = i4;
     HEAP32[i15 + (i7 << 5) + 12 >> 2] = i5;
     HEAPF32[i15 + (i7 << 5) + 16 >> 2] = f16;
     HEAPF32[i15 + (i7 << 5) + 20 >> 2] = f17;
     HEAPF32[i15 + (i7 << 5) + 24 >> 2] = f18;
     HEAP32[i15 + (i7 << 5) + 28 >> 2] = i5;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i15 = 23;
     break L1;
    } else {
     __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i8) | 0;
     i15 = 23;
     break L1;
    }
   } else i15 = 23;
   break;
  }
 case 3:
  {
   if ((i1 | 0) == 3) {
    i29 = HEAP32[i22 + 100 >> 2] | 0;
    i4 = i29 + 28 | 0;
    i1 = i22 + 8 | 0;
    i5 = HEAP32[i22 + 20 >> 2] | 0;
    HEAP32[i14 >> 2] = i5;
    i6 = HEAP32[i22 + 24 >> 2] | 0;
    HEAP32[i14 + 4 >> 2] = i6;
    i7 = HEAP32[i22 + 28 >> 2] | 0;
    HEAP32[i14 + 8 >> 2] = i7;
    i8 = HEAP32[i22 + 4 >> 2] | 0;
    HEAP32[i14 + 12 >> 2] = i8;
    i9 = HEAP32[i1 >> 2] | 0;
    HEAP32[i14 + 16 >> 2] = i9;
    i3 = i22 + 12 | 0;
    i10 = HEAP32[i3 >> 2] | 0;
    HEAP32[i14 + 20 >> 2] = i10;
    i2 = i22 + 16 | 0;
    i11 = HEAP32[i2 >> 2] | 0;
    HEAP32[i14 + 24 >> 2] = i11;
    HEAP32[i14 + 28 >> 2] = i8;
    HEAPF32[i14 + 32 >> 2] = f16;
    HEAPF32[i14 + 36 >> 2] = f17;
    HEAPF32[i14 + 40 >> 2] = f18;
    HEAP32[i14 + 44 >> 2] = i8;
    i12 = i29 + 32 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i29 + 36 >> 2] & 2147483647) >>> 0 > i13 >>> 0) {
     i29 = HEAP32[i4 >> 2] | 0;
     HEAP32[i29 + (i13 * 48 | 0) >> 2] = i5;
     HEAP32[i29 + (i13 * 48 | 0) + 4 >> 2] = i6;
     HEAP32[i29 + (i13 * 48 | 0) + 8 >> 2] = i7;
     HEAP32[i29 + (i13 * 48 | 0) + 12 >> 2] = i8;
     HEAP32[i29 + (i13 * 48 | 0) + 16 >> 2] = i9;
     HEAP32[i29 + (i13 * 48 | 0) + 20 >> 2] = i10;
     HEAP32[i29 + (i13 * 48 | 0) + 24 >> 2] = i11;
     HEAP32[i29 + (i13 * 48 | 0) + 28 >> 2] = i8;
     HEAPF32[i29 + (i13 * 48 | 0) + 32 >> 2] = f16;
     HEAPF32[i29 + (i13 * 48 | 0) + 36 >> 2] = f17;
     HEAPF32[i29 + (i13 * 48 | 0) + 40 >> 2] = f18;
     HEAP32[i29 + (i13 * 48 | 0) + 44 >> 2] = i8;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i4, i14) | 0;
    HEAP32[i19 >> 2] = 0;
   } else i15 = 23;
   break;
  }
 case 4:
  {
   if (i1 >>> 0 > 2) {
    i29 = HEAP32[i22 + 100 >> 2] | 0;
    i10 = i29 + 28 | 0;
    i2 = (i1 & 1 | 0) != 0;
    i7 = i22 + 8 | 0;
    i1 = i22 + 20 | 0;
    i3 = i2 ? i7 : i1;
    i7 = i2 ? i1 : i7;
    i1 = HEAP32[i3 >> 2] | 0;
    HEAP32[i12 >> 2] = i1;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i12 + 4 >> 2] = i2;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    HEAP32[i12 + 8 >> 2] = i3;
    i4 = HEAP32[i22 + 4 >> 2] | 0;
    HEAP32[i12 + 12 >> 2] = i4;
    i5 = HEAP32[i7 >> 2] | 0;
    HEAP32[i12 + 16 >> 2] = i5;
    i6 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i12 + 20 >> 2] = i6;
    i7 = HEAP32[i7 + 8 >> 2] | 0;
    HEAP32[i12 + 24 >> 2] = i7;
    HEAP32[i12 + 28 >> 2] = i4;
    HEAPF32[i12 + 32 >> 2] = f16;
    HEAPF32[i12 + 36 >> 2] = f17;
    HEAPF32[i12 + 40 >> 2] = f18;
    HEAP32[i12 + 44 >> 2] = i4;
    i8 = i29 + 32 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[i29 + 36 >> 2] & 2147483647) >>> 0 > i9 >>> 0) {
     i15 = HEAP32[i10 >> 2] | 0;
     HEAP32[i15 + (i9 * 48 | 0) >> 2] = i1;
     HEAP32[i15 + (i9 * 48 | 0) + 4 >> 2] = i2;
     HEAP32[i15 + (i9 * 48 | 0) + 8 >> 2] = i3;
     HEAP32[i15 + (i9 * 48 | 0) + 12 >> 2] = i4;
     HEAP32[i15 + (i9 * 48 | 0) + 16 >> 2] = i5;
     HEAP32[i15 + (i9 * 48 | 0) + 20 >> 2] = i6;
     HEAP32[i15 + (i9 * 48 | 0) + 24 >> 2] = i7;
     HEAP32[i15 + (i9 * 48 | 0) + 28 >> 2] = i4;
     HEAPF32[i15 + (i9 * 48 | 0) + 32 >> 2] = f16;
     HEAPF32[i15 + (i9 * 48 | 0) + 36 >> 2] = f17;
     HEAPF32[i15 + (i9 * 48 | 0) + 40 >> 2] = f18;
     HEAP32[i15 + (i9 * 48 | 0) + 44 >> 2] = i4;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     i15 = 23;
     break L1;
    } else {
     __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i12) | 0;
     i15 = 23;
     break L1;
    }
   } else i15 = 23;
   break;
  }
 default:
  i15 = 24;
 } while (0);
 if ((i15 | 0) == 23) {
  i1 = HEAP32[i19 >> 2] | 0;
  i15 = 24;
 }
 do if ((i15 | 0) == 24) {
  if (i1 >>> 0 <= 1) {
   i3 = i22 + 12 | 0;
   i2 = i22 + 16 | 0;
   i1 = i22 + 8 | 0;
   break;
  }
  i15 = i22 + 8 | 0;
  HEAP32[i22 + 20 >> 2] = HEAP32[i15 >> 2];
  i19 = i22 + 12 | 0;
  HEAP32[i22 + 24 >> 2] = HEAP32[i19 >> 2];
  i29 = i22 + 16 | 0;
  HEAP32[i22 + 28 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i21 >> 2];
  STACKTOP = i24;
  return i22 | 0;
 } while (0);
 HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
 STACKTOP = i24;
 return i22 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_(i1, i2, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 L1 : while (1) {
  i14 = i2;
  i17 = i2 + -8 | 0;
  i15 = i2 + -16 | 0;
  i18 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i3 = i14 - i13 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i19 = 5;
      break L1;
     }
    case 3:
     {
      i19 = 10;
      break L1;
     }
    case 4:
     {
      i19 = 11;
      break L1;
     }
    case 5:
     {
      i19 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i19 = 89;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 56) {
     i19 = 14;
     break L1;
    }
    i5 = (i4 | 0) / 2 | 0;
    i11 = i1 + (i5 << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + (i3 << 3) | 0, i11, i11 + (i3 << 3) | 0, i17, i16) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i11, i17, i16) | 0;
    f12 = Math_fround(HEAPF32[i1 >> 2]);
    f7 = Math_fround(HEAPF32[i11 >> 2]);
    if (f12 < f7) {
     i4 = i17;
     break;
    }
    if (!(f7 < f12)) if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < (HEAP32[i1 + (i5 << 3) + 4 >> 2] | 0) >>> 0) {
     i4 = i17;
     break;
    }
    if ((i1 | 0) != (i15 | 0)) {
     i9 = i1 + (i5 << 3) + 4 | 0;
     i5 = i17;
     i4 = i15;
     while (1) {
      f6 = Math_fround(HEAPF32[i4 >> 2]);
      if (f6 < f7) {
       i19 = 59;
       break L5;
      }
      if (!(f7 < f6)) {
       i8 = i5 + -4 | 0;
       i5 = HEAP32[i8 >> 2] | 0;
       if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
        i19 = 63;
        break L5;
       }
      }
      i5 = i4 + -8 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i10 = i4;
       i4 = i5;
       i5 = i10;
      }
     }
    }
    i3 = i1 + 8 | 0;
    f7 = Math_fround(HEAPF32[i17 >> 2]);
    do if (!(f12 < f7)) {
     if (!(f7 < f12)) if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) break;
     if ((i3 | 0) == (i17 | 0)) {
      i19 = 89;
      break L1;
     }
     i8 = i1 + 4 | 0;
     while (1) {
      f6 = Math_fround(HEAPF32[i3 >> 2]);
      if (f12 < f6) {
       i19 = 41;
       break;
      }
      if (!(f6 < f12)) {
       i5 = i3 + 4 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if ((HEAP32[i8 >> 2] | 0) >>> 0 < i4 >>> 0) break;
      }
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i17 | 0)) {
       i19 = 89;
       break L1;
      }
     }
     if ((i19 | 0) == 41) {
      i19 = 0;
      i4 = i3 + 4 | 0;
      i5 = i4;
      i4 = HEAP32[i4 >> 2] | 0;
     }
     HEAPF32[i3 >> 2] = f7;
     HEAPF32[i17 >> 2] = f6;
     HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i18 >> 2] = i4;
     i3 = i3 + 8 | 0;
    } while (0);
    if ((i3 | 0) == (i17 | 0)) {
     i19 = 89;
     break L1;
    }
    i8 = i1 + 4 | 0;
    i4 = i17;
    while (1) {
     f7 = Math_fround(HEAPF32[i1 >> 2]);
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     L45 : do if (!(f7 < f6)) do {
      if (!(f6 < f7)) if ((HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) break L45;
      i3 = i3 + 8 | 0;
      f6 = Math_fround(HEAPF32[i3 >> 2]);
     } while (!(f7 < f6)); while (0);
     while (1) {
      i5 = i4 + -8 | 0;
      f6 = Math_fround(HEAPF32[i5 >> 2]);
      if (f7 < f6) {
       i4 = i5;
       continue;
      }
      if (f6 < f7) break;
      if ((HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i4 + -4 >> 2] | 0) >>> 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i11 = HEAP32[i3 >> 2] | 0;
     HEAPF32[i3 >> 2] = f6;
     HEAP32[i5 >> 2] = i11;
     i11 = i3 + 4 | 0;
     i4 = i4 + -4 | 0;
     i13 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i13;
     i4 = i5;
     i3 = i3 + 8 | 0;
    }
   }
   if ((i19 | 0) == 59) {
    i5 = i5 + -4 | 0;
    i8 = i5;
    i5 = HEAP32[i5 >> 2] | 0;
    i19 = 63;
   }
   if ((i19 | 0) == 63) {
    i19 = 0;
    HEAPF32[i1 >> 2] = f6;
    HEAPF32[i4 >> 2] = f12;
    i9 = i1 + 4 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i8 >> 2] = i10;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L63 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    f7 = Math_fround(HEAPF32[i11 >> 2]);
    i9 = i11 + 4 | 0;
    i10 = i5;
    while (1) {
     f12 = Math_fround(HEAPF32[i10 >> 2]);
     if (!(f12 < f7)) {
      if (f7 < f12) break;
      if ((HEAP32[i10 + 4 >> 2] | 0) >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break;
     }
     i10 = i10 + 8 | 0;
    }
    i5 = i4 + -8 | 0;
    f6 = Math_fround(HEAPF32[i5 >> 2]);
    L73 : do if (!(f6 < f7)) while (1) {
     if (!(f7 < f6)) if ((HEAP32[i4 + -4 >> 2] | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) break L73;
     i8 = i5 + -8 | 0;
     f6 = Math_fround(HEAPF32[i8 >> 2]);
     if (f6 < f7) {
      i4 = i5;
      i5 = i8;
      break;
     } else {
      i4 = i5;
      i5 = i8;
     }
    } while (0);
    if (i10 >>> 0 > i5 >>> 0) {
     i5 = i10;
     break L63;
    }
    HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
    HEAPF32[i5 >> 2] = f12;
    i8 = i10 + 4 | 0;
    i4 = i4 + -4 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i9;
    i11 = (i11 | 0) == (i10 | 0) ? i5 : i11;
    i4 = i5;
    i5 = i10 + 8 | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   do if ((i5 | 0) != (i11 | 0)) {
    f6 = Math_fround(HEAPF32[i11 >> 2]);
    f7 = Math_fround(HEAPF32[i5 >> 2]);
    if (f6 < f7) {
     i8 = i5 + 4 | 0;
     i10 = i11 + 4 | 0;
     i4 = i10;
     i9 = i8;
     i10 = HEAP32[i10 >> 2] | 0;
     i8 = HEAP32[i8 >> 2] | 0;
    } else {
     if (f7 < f6) break;
     i4 = i11 + 4 | 0;
     i10 = HEAP32[i4 >> 2] | 0;
     i9 = i5 + 4 | 0;
     i8 = HEAP32[i9 >> 2] | 0;
     if (i10 >>> 0 >= i8 >>> 0) break;
    }
    HEAPF32[i5 >> 2] = f6;
    HEAPF32[i11 >> 2] = f7;
    HEAP32[i9 >> 2] = i10;
    HEAP32[i4 >> 2] = i8;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEbT0_S7_T_(i1, i5, i16) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEbT0_S7_T_(i4, i2, i16) | 0) {
     i19 = 88;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i11 = i5;
   if ((i11 - i13 | 0) >= (i14 - i11 | 0)) {
    i19 = 87;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_(i1, i5, i16);
   i1 = i5 + 8 | 0;
  }
  if ((i19 | 0) == 87) {
   i19 = 0;
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_(i5 + 8 | 0, i2, i16);
   i2 = i5;
   continue;
  } else if ((i19 | 0) == 88) {
   i19 = 0;
   if (i3) {
    i19 = 89;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i19 | 0) == 5) {
  f6 = Math_fround(HEAPF32[i17 >> 2]);
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  if (f6 < f7) {
   i3 = i1 + 4 | 0;
   i2 = i3;
   i4 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
  } else {
   if (f7 < f6) return;
   i4 = HEAP32[i18 >> 2] | 0;
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i4 >>> 0 >= i3 >>> 0) return;
  }
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i17 >> 2] = f7;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i18 >> 2] = i3;
  return;
 } else if ((i19 | 0) == 10) {
  __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i17, i16) | 0;
  return;
 } else if ((i19 | 0) == 11) {
  __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i17, i16) | 0;
  return;
 } else if ((i19 | 0) == 12) {
  __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i17, i16) | 0;
  return;
 } else if ((i19 | 0) == 14) {
  i4 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i4, i16) | 0;
  i3 = i1 + 24 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   f7 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   if (f7 < f6) {
    i10 = i3 + 4 | 0;
    i9 = i4 + 4 | 0;
    i5 = i9;
    i8 = i10;
    i9 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i10 >> 2] | 0;
    i19 = 19;
   } else if (!(f6 < f7)) {
    i8 = i3 + 4 | 0;
    i10 = HEAP32[i8 >> 2] | 0;
    i5 = i4 + 4 | 0;
    i9 = HEAP32[i5 >> 2] | 0;
    if (i10 >>> 0 < i9 >>> 0) i19 = 19;
   }
   if ((i19 | 0) == 19) {
    i19 = 0;
    HEAPF32[i3 >> 2] = f6;
    HEAP32[i8 >> 2] = i9;
    L111 : do if ((i4 | 0) != (i1 | 0)) {
     i11 = i4;
     while (1) {
      i4 = i11 + -8 | 0;
      f6 = Math_fround(HEAPF32[i4 >> 2]);
      if (f7 < f6) {
       i8 = i11 + -4 | 0;
       i5 = i8;
       i8 = HEAP32[i8 >> 2] | 0;
      } else {
       if (f6 < f7) {
        i4 = i11;
        break L111;
       }
       i9 = i11 + -4 | 0;
       i8 = HEAP32[i9 >> 2] | 0;
       if (i10 >>> 0 < i8 >>> 0) i5 = i9; else {
        i4 = i11;
        break L111;
       }
      }
      HEAPF32[i11 >> 2] = f6;
      HEAP32[i11 + 4 >> 2] = i8;
      if ((i4 | 0) == (i1 | 0)) break; else i11 = i4;
     }
    } while (0);
    HEAPF32[i4 >> 2] = f7;
    HEAP32[i5 >> 2] = i10;
   }
   i4 = i3 + 8 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i18 = i3;
    i3 = i4;
    i4 = i18;
   }
  }
  return;
 } else if ((i19 | 0) == 89) return;
}

function __ZN20TextRenderingPrivate7GUIText8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 3);
 i2 = i7 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946475 | 0, HEAP32[gb + 37260 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 54 | 0;
 i5 = HEAP32[gb + 37240 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946522 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 12; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034753 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 23; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 23; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946411 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 56 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946508 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   i3 = i1 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i1 >>> 0) i6 = 40; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i6 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946531 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 51; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 51; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034701 | 0, gb + 1034708 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946425 | 0, gb + 946436 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 76 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034730 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 74; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 74; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 74) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034741 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 85; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 85; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 85) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 64 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946451 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 65 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034776 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i54, i2, i17, i60, i59) {
 i54 = i54 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i60 = i60 | 0;
 i59 = i59 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i61 + 48 | 0;
 i56 = i61 + 32 | 0;
 i1 = i61 + 16 | 0;
 i57 = i61;
 i58 = (i59 | 0) != 0;
 if (i58) if (!(HEAP16[i54 + 84 >> 1] | 0)) {
  HEAP32[i55 >> 2] = 0;
  HEAP32[i55 + 4 >> 2] = 0;
  HEAP32[i55 + 8 >> 2] = 0;
  HEAP32[i55 + 12 >> 2] = 0;
  HEAP32[i56 >> 2] = 0;
  HEAP32[i56 + 4 >> 2] = 0;
  HEAP32[i56 + 8 >> 2] = 0;
  HEAP32[i56 + 12 >> 2] = 0;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i1, i54, i55, i56);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f6 = Math_fround(f3 * Math_fround(HEAPF32[i59 >> 2]));
  f7 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 4 >> 2]));
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 8 >> 2]));
  f9 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 12 >> 2]));
  f10 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 16 >> 2]));
  f11 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 20 >> 2]));
  f12 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 24 >> 2]));
  f13 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 28 >> 2]));
  f14 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 32 >> 2]));
  f15 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 36 >> 2]));
  f16 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 40 >> 2]));
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 44 >> 2]));
  if (i17 >>> 0 >= i60 >>> 0) {
   STACKTOP = i61;
   return;
  }
  i4 = HEAP32[i2 + 120 >> 2] | 0;
  i5 = HEAP32[i2 + 140 >> 2] | 0;
  i2 = HEAP32[i2 + 160 >> 2] | 0;
  i1 = i17;
  do {
   i48 = i4 + (i1 << 2) | 0;
   f73 = Math_fround(HEAPF32[i48 >> 2]);
   i49 = i48 + 4 | 0;
   f72 = Math_fround(HEAPF32[i49 >> 2]);
   i50 = i48 + 8 | 0;
   f71 = Math_fround(HEAPF32[i50 >> 2]);
   i51 = i48 + 12 | 0;
   f70 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i5 + (i1 << 2) | 0;
   f69 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = i52 + 4 | 0;
   f68 = Math_fround(HEAPF32[i53 >> 2]);
   i54 = i52 + 8 | 0;
   f67 = Math_fround(HEAPF32[i54 >> 2]);
   i55 = i52 + 12 | 0;
   f66 = Math_fround(HEAPF32[i55 >> 2]);
   i56 = i2 + (i1 << 2) | 0;
   f65 = Math_fround(HEAPF32[i56 >> 2]);
   i57 = i56 + 4 | 0;
   f64 = Math_fround(HEAPF32[i57 >> 2]);
   i58 = i56 + 8 | 0;
   f63 = Math_fround(HEAPF32[i58 >> 2]);
   i59 = i56 + 12 | 0;
   f72 = Math_fround(f7 + f72);
   f71 = Math_fround(f8 + f71);
   f70 = Math_fround(f9 + f70);
   f69 = Math_fround(f10 + f69);
   f68 = Math_fround(f11 + f68);
   f67 = Math_fround(f12 + f67);
   f66 = Math_fround(f13 + f66);
   f65 = Math_fround(f14 + f65);
   f64 = Math_fround(f15 + f64);
   f63 = Math_fround(f16 + f63);
   f62 = Math_fround(f3 + Math_fround(HEAPF32[i59 >> 2]));
   HEAPF32[i48 >> 2] = Math_fround(f6 + f73);
   HEAPF32[i49 >> 2] = f72;
   HEAPF32[i50 >> 2] = f71;
   HEAPF32[i51 >> 2] = f70;
   HEAPF32[i52 >> 2] = f69;
   HEAPF32[i53 >> 2] = f68;
   HEAPF32[i54 >> 2] = f67;
   HEAPF32[i55 >> 2] = f66;
   HEAPF32[i56 >> 2] = f65;
   HEAPF32[i57 >> 2] = f64;
   HEAPF32[i58 >> 2] = f63;
   HEAPF32[i59 >> 2] = f62;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i60 >>> 0);
  STACKTOP = i61;
  return;
 }
 if (i17 >>> 0 >= i60 >>> 0) {
  STACKTOP = i61;
  return;
 }
 i38 = i2 + 500 | 0;
 i39 = i55 + 4 | 0;
 i40 = i55 + 8 | 0;
 i41 = i55 + 12 | 0;
 i42 = i2 + 520 | 0;
 i43 = i56 + 4 | 0;
 i44 = i56 + 8 | 0;
 i45 = i56 + 12 | 0;
 i35 = i59 + 4 | 0;
 i36 = i59 + 8 | 0;
 i37 = i59 + 12 | 0;
 i27 = i59 + 16 | 0;
 i28 = i59 + 20 | 0;
 i29 = i59 + 24 | 0;
 i30 = i59 + 28 | 0;
 i31 = i59 + 32 | 0;
 i32 = i59 + 36 | 0;
 i33 = i59 + 40 | 0;
 i34 = i59 + 44 | 0;
 i46 = i57 + 4 | 0;
 i47 = i57 + 8 | 0;
 i48 = i57 + 12 | 0;
 i49 = i2 + 120 | 0;
 i50 = i2 + 140 | 0;
 i51 = i2 + 160 | 0;
 i52 = i2 + 180 | 0;
 i53 = i2 + 200 | 0;
 i26 = i2 + 220 | 0;
 i1 = i17;
 do {
  i22 = (HEAP32[i38 >> 2] | 0) + (i1 << 2) | 0;
  i24 = (HEAP32[i22 >> 2] | 0) + 3401255 | 0;
  i18 = (HEAP32[i22 + 4 >> 2] | 0) + 3401255 | 0;
  i20 = (HEAP32[i22 + 8 >> 2] | 0) + 3401255 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 3401255 | 0;
  i25 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i19 = (Math_imul(i18, 1790253981) | 0) + 1900727103 | 0;
  i21 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
  i23 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i24 = i24 << 11 ^ i24;
  i18 = i18 << 11 ^ i18;
  i20 = i20 << 11 ^ i20;
  i22 = i22 << 11 ^ i22;
  f72 = Math_fround(Math_fround((i19 ^ i18 ^ i18 >>> 8) & 8388607 ^ i19 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f71 = Math_fround(Math_fround((i21 ^ i20 ^ i20 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f70 = Math_fround(Math_fround((i23 ^ i22 ^ i22 >>> 8) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i55 >> 2] = Math_fround(Math_fround((i25 ^ i24 ^ i24 >>> 8) & 8388607 ^ i25 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i39 >> 2] = f72;
  HEAPF32[i40 >> 2] = f71;
  HEAPF32[i41 >> 2] = f70;
  i25 = (HEAP32[i42 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f72 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f71 = Math_fround(f71 * Math_fround(.00999999977));
  f72 = Math_fround(f72 * Math_fround(.00999999977));
  f73 = Math_fround(Math_fround(HEAPF32[i25 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i56 >> 2] = Math_fround(f70 * Math_fround(.00999999977));
  HEAPF32[i43 >> 2] = f71;
  HEAPF32[i44 >> 2] = f72;
  HEAPF32[i45 >> 2] = f73;
  if (i58) {
   i2 = i59;
   i4 = i27;
   i5 = i28;
   i17 = i29;
   i18 = i30;
   i19 = i31;
   i20 = i32;
   i21 = i33;
   i22 = i34;
   i23 = i35;
   i24 = i36;
   i25 = i37;
  } else {
   i25 = (HEAP32[i52 >> 2] | 0) + (i1 << 2) | 0;
   i18 = (HEAP32[i53 >> 2] | 0) + (i1 << 2) | 0;
   i22 = (HEAP32[i26 >> 2] | 0) + (i1 << 2) | 0;
   i2 = i25;
   i4 = i18;
   i5 = i18 + 4 | 0;
   i17 = i18 + 8 | 0;
   i18 = i18 + 12 | 0;
   i19 = i22;
   i20 = i22 + 4 | 0;
   i21 = i22 + 8 | 0;
   i22 = i22 + 12 | 0;
   i23 = i25 + 4 | 0;
   i24 = i25 + 8 | 0;
   i25 = i25 + 12 | 0;
  }
  f62 = Math_fround(HEAPF32[i22 >> 2]);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f64 = Math_fround(HEAPF32[i20 >> 2]);
  f65 = Math_fround(HEAPF32[i19 >> 2]);
  f12 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f7 = Math_fround(HEAPF32[i24 >> 2]);
  f6 = Math_fround(HEAPF32[i23 >> 2]);
  f16 = Math_fround(HEAPF32[i2 >> 2]);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i57, i54, i56, i55);
  f13 = Math_fround(HEAPF32[i57 >> 2]);
  f16 = Math_fround(f16 * f13);
  f14 = Math_fround(HEAPF32[i46 >> 2]);
  f6 = Math_fround(f6 * f14);
  f15 = Math_fround(HEAPF32[i47 >> 2]);
  f7 = Math_fround(f7 * f15);
  f73 = Math_fround(HEAPF32[i48 >> 2]);
  f8 = Math_fround(f8 * f73);
  f9 = Math_fround(f9 * f13);
  f10 = Math_fround(f10 * f14);
  f11 = Math_fround(f11 * f15);
  f12 = Math_fround(f12 * f73);
  f13 = Math_fround(f65 * f13);
  f14 = Math_fround(f64 * f14);
  f15 = Math_fround(f63 * f15);
  f73 = Math_fround(f62 * f73);
  i2 = (HEAP32[i49 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i2 + 4 | 0;
  f63 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i2 + 8 | 0;
  f64 = Math_fround(HEAPF32[i5 >> 2]);
  i17 = i2 + 12 | 0;
  f65 = Math_fround(HEAPF32[i17 >> 2]);
  i18 = (HEAP32[i50 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i18 >> 2]);
  i19 = i18 + 4 | 0;
  f67 = Math_fround(HEAPF32[i19 >> 2]);
  i20 = i18 + 8 | 0;
  f68 = Math_fround(HEAPF32[i20 >> 2]);
  i21 = i18 + 12 | 0;
  f69 = Math_fround(HEAPF32[i21 >> 2]);
  i22 = (HEAP32[i51 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i22 >> 2]);
  i23 = i22 + 4 | 0;
  f71 = Math_fround(HEAPF32[i23 >> 2]);
  i24 = i22 + 8 | 0;
  f72 = Math_fround(HEAPF32[i24 >> 2]);
  i25 = i22 + 12 | 0;
  f63 = Math_fround(f6 + f63);
  f64 = Math_fround(f7 + f64);
  f65 = Math_fround(f8 + f65);
  f66 = Math_fround(f9 + f66);
  f67 = Math_fround(f10 + f67);
  f68 = Math_fround(f11 + f68);
  f69 = Math_fround(f12 + f69);
  f70 = Math_fround(f13 + f70);
  f71 = Math_fround(f14 + f71);
  f72 = Math_fround(f15 + f72);
  f73 = Math_fround(f73 + Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i2 >> 2] = Math_fround(f16 + f62);
  HEAPF32[i4 >> 2] = f63;
  HEAPF32[i5 >> 2] = f64;
  HEAPF32[i17 >> 2] = f65;
  HEAPF32[i18 >> 2] = f66;
  HEAPF32[i19 >> 2] = f67;
  HEAPF32[i20 >> 2] = f68;
  HEAPF32[i21 >> 2] = f69;
  HEAPF32[i22 >> 2] = f70;
  HEAPF32[i23 >> 2] = f71;
  HEAPF32[i24 >> 2] = f72;
  HEAPF32[i25 >> 2] = f73;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i60 >>> 0);
 STACKTOP = i61;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_(i1, i2, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 L1 : while (1) {
  i14 = i2;
  i15 = i2 + -8 | 0;
  i16 = i2 + -16 | 0;
  i18 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i13 = i1;
    i3 = i14 - i13 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i19 = 5;
      break L1;
     }
    case 3:
     {
      i19 = 10;
      break L1;
     }
    case 4:
     {
      i19 = 11;
      break L1;
     }
    case 5:
     {
      i19 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i19 = 90;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 56) {
     i19 = 14;
     break L1;
    }
    i5 = (i4 | 0) / 2 | 0;
    i9 = i1 + (i5 << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + (i3 << 3) | 0, i9, i9 + (i3 << 3) | 0, i15, i17) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i9, i15, i17) | 0;
    i10 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i9 >> 2] | 0;
    if (i10 >>> 0 < i8 >>> 0) {
     i4 = i15;
     break;
    }
    if (i8 >>> 0 >= i10 >>> 0) if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < (HEAP32[i1 + (i5 << 3) + 4 >> 2] | 0) >>> 0) {
     i4 = i15;
     break;
    }
    if ((i1 | 0) != (i16 | 0)) {
     i7 = i1 + (i5 << 3) + 4 | 0;
     i5 = i15;
     i4 = i16;
     while (1) {
      i6 = HEAP32[i4 >> 2] | 0;
      if (i6 >>> 0 < i8 >>> 0) {
       i19 = 60;
       break L5;
      }
      if (i8 >>> 0 >= i6 >>> 0) {
       i5 = i5 + -4 | 0;
       if ((HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
        i19 = 64;
        break L5;
       }
      }
      i5 = i4 + -8 | 0;
      if ((i1 | 0) == (i5 | 0)) break; else {
       i12 = i4;
       i4 = i5;
       i5 = i12;
      }
     }
    }
    i3 = i1 + 8 | 0;
    i7 = HEAP32[i15 >> 2] | 0;
    do if (i10 >>> 0 >= i7 >>> 0) {
     if (i7 >>> 0 >= i10 >>> 0) if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) break;
     if ((i3 | 0) == (i15 | 0)) {
      i19 = 90;
      break L1;
     }
     i6 = i1 + 4 | 0;
     while (1) {
      i5 = HEAP32[i3 >> 2] | 0;
      if (i10 >>> 0 < i5 >>> 0) {
       i19 = 41;
       break;
      }
      if (i5 >>> 0 >= i10 >>> 0) {
       i4 = i3 + 4 | 0;
       if ((HEAP32[i6 >> 2] | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) break;
      }
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i15 | 0)) {
       i19 = 90;
       break L1;
      }
     }
     if ((i19 | 0) == 41) {
      i19 = 0;
      i4 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i7;
     HEAP32[i15 >> 2] = i5;
     i13 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i18 >> 2] = i13;
     i3 = i3 + 8 | 0;
    } while (0);
    if ((i3 | 0) == (i15 | 0)) {
     i19 = 90;
     break L1;
    }
    i10 = i1 + 4 | 0;
    i5 = i15;
    while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (i9 >>> 0 < i4 >>> 0) {
      i8 = i3;
      i7 = i3;
     } else {
      do {
       if (i4 >>> 0 >= i9 >>> 0) if ((HEAP32[i10 >> 2] | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) break;
       i3 = i3 + 8 | 0;
       i4 = HEAP32[i3 >> 2] | 0;
      } while (i9 >>> 0 >= i4 >>> 0);
      i8 = i3;
      i7 = i3;
     }
     i3 = i5;
     while (1) {
      i5 = i3 + -8 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if (i9 >>> 0 < i6 >>> 0) {
       i3 = i5;
       continue;
      }
      if (i6 >>> 0 < i9 >>> 0) break;
      if ((HEAP32[i10 >> 2] | 0) >>> 0 < (HEAP32[i3 + -4 >> 2] | 0) >>> 0) i3 = i5; else break;
     }
     if (i8 >>> 0 >= i5 >>> 0) {
      i1 = i8;
      continue L5;
     }
     HEAP32[i7 >> 2] = i6;
     HEAP32[i5 >> 2] = i4;
     i12 = i8 + 4 | 0;
     i3 = i3 + -4 | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i3 >> 2] = i13;
     i3 = i8 + 8 | 0;
    }
   }
   if ((i19 | 0) == 60) {
    i5 = i5 + -4 | 0;
    i19 = 64;
   }
   if ((i19 | 0) == 64) {
    i19 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i10;
    i11 = i1 + 4 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i12;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L64 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i10 = HEAP32[i9 >> 2] | 0;
    i11 = i9 + 4 | 0;
    while (1) {
     i12 = HEAP32[i5 >> 2] | 0;
     if (i12 >>> 0 >= i10 >>> 0) {
      if (i10 >>> 0 < i12 >>> 0) break;
      if ((HEAP32[i5 + 4 >> 2] | 0) >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break;
     }
     i5 = i5 + 8 | 0;
    }
    i7 = i4 + -8 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    L74 : do if (i6 >>> 0 < i10 >>> 0) i10 = i7; else {
     i8 = i7;
     while (1) {
      if (i10 >>> 0 >= i6 >>> 0) if ((HEAP32[i4 + -4 >> 2] | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
       i10 = i8;
       i7 = i8;
       break L74;
      }
      i7 = i8 + -8 | 0;
      i6 = HEAP32[i7 >> 2] | 0;
      if (i6 >>> 0 < i10 >>> 0) {
       i4 = i8;
       i10 = i7;
       break;
      } else {
       i4 = i8;
       i8 = i7;
      }
     }
    } while (0);
    if (i5 >>> 0 > i7 >>> 0) break L64;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i10 >> 2] = i12;
    i11 = i5 + 4 | 0;
    i4 = i4 + -4 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i12;
    i9 = (i9 | 0) == (i5 | 0) ? i7 : i9;
    i4 = i7;
    i5 = i5 + 8 | 0;
    i3 = i3 + 1 | 0;
   } while (0);
   do if ((i5 | 0) != (i9 | 0)) {
    i7 = HEAP32[i9 >> 2] | 0;
    i8 = HEAP32[i5 >> 2] | 0;
    if (i7 >>> 0 < i8 >>> 0) {
     i6 = i9 + 4 | 0;
     i4 = i5 + 4 | 0;
    } else {
     if (i8 >>> 0 < i7 >>> 0) break;
     i6 = i9 + 4 | 0;
     i4 = i5 + 4 | 0;
     if ((HEAP32[i6 >> 2] | 0) >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break;
    }
    HEAP32[i5 >> 2] = i7;
    HEAP32[i9 >> 2] = i8;
    i12 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i12;
    i3 = i3 + 1 | 0;
   } while (0);
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEbT0_S7_T_(i1, i5, i17) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEbT0_S7_T_(i4, i2, i17) | 0) {
     i19 = 89;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i12 = i5;
   if ((i12 - i13 | 0) >= (i14 - i12 | 0)) {
    i19 = 88;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_(i1, i5, i17);
   i1 = i5 + 8 | 0;
  }
  if ((i19 | 0) == 88) {
   i19 = 0;
   __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_(i5 + 8 | 0, i2, i17);
   i2 = i5;
   continue;
  } else if ((i19 | 0) == 89) {
   i19 = 0;
   if (i3) {
    i19 = 90;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i19 | 0) == 5) {
  i3 = i2 + -8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) i2 = i1 + 4 | 0; else {
   if (i5 >>> 0 < i4 >>> 0) return;
   i2 = i1 + 4 | 0;
   if ((HEAP32[i18 >> 2] | 0) >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  i19 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i18 >> 2] = i19;
  return;
 } else if ((i19 | 0) == 10) {
  __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i15, i17) | 0;
  return;
 } else if ((i19 | 0) == 11) {
  __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i15, i17) | 0;
  return;
 } else if ((i19 | 0) == 12) {
  __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i15, i17) | 0;
  return;
 } else if ((i19 | 0) == 14) {
  i4 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i4, i17) | 0;
  i3 = i1 + 24 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   i5 = HEAP32[i3 >> 2] | 0;
   i8 = HEAP32[i4 >> 2] | 0;
   if (i5 >>> 0 < i8 >>> 0) {
    i7 = i4 + 4 | 0;
    i5 = i7;
    i6 = i3 + 4 | 0;
    i7 = HEAP32[i7 >> 2] | 0;
    i19 = 19;
   } else if (i8 >>> 0 >= i5 >>> 0) {
    i6 = i3 + 4 | 0;
    i5 = i4 + 4 | 0;
    i7 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i6 >> 2] | 0) >>> 0 < i7 >>> 0) i19 = 19;
   }
   if ((i19 | 0) == 19) {
    i19 = 0;
    i11 = i3;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    HEAP32[i3 >> 2] = i8;
    HEAP32[i6 >> 2] = i7;
    L112 : do if ((i4 | 0) != (i1 | 0)) {
     i9 = i4;
     while (1) {
      i4 = i9 + -8 | 0;
      i8 = HEAP32[i4 >> 2] | 0;
      if (i10 >>> 0 < i8 >>> 0) {
       i6 = i9 + -4 | 0;
       i5 = i6;
       i6 = HEAP32[i6 >> 2] | 0;
      } else {
       if (i8 >>> 0 < i10 >>> 0) {
        i4 = i9;
        break L112;
       }
       i7 = i9 + -4 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       if (i11 >>> 0 < i6 >>> 0) i5 = i7; else {
        i4 = i9;
        break L112;
       }
      }
      HEAP32[i9 >> 2] = i8;
      HEAP32[i9 + 4 >> 2] = i6;
      if ((i4 | 0) == (i1 | 0)) break; else i9 = i4;
     }
    } while (0);
    HEAP32[i4 >> 2] = i10;
    HEAP32[i5 >> 2] = i11;
   }
   i4 = i3 + 8 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i18 = i3;
    i3 = i4;
    i4 = i18;
   }
  }
  return;
 } else if ((i19 | 0) == 90) return;
}

function __ZN15AABBTreeRaycastILb0EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE(i2, i32, i34, i3, i4, i31, i1, i33) {
 i2 = i2 | 0;
 i32 = i32 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i33 = i33 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i35 + 8 | 0;
 i29 = i35;
 f6 = Math_fround(HEAPF32[i31 >> 2]);
 f27 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f21 = Math_fround(-f25);
 f22 = Math_fround(-f26);
 f23 = Math_fround(-f20);
 f21 = f25 > f21 ? f25 : f21;
 f22 = f26 > f22 ? f26 : f22;
 f23 = f20 > f23 ? f20 : f23;
 if (!(f6 >= Math_fround(3402823469999999843913219.0e14))) {
  f7 = Math_fround(Math_fround(f6 * f20) + f24);
  f5 = Math_fround(Math_fround(f6 * f26) + f28);
  f6 = Math_fround(Math_fround(f6 * f25) + f27);
 } else {
  i19 = f25 == Math_fround(0.0);
  i11 = f25 >= Math_fround(0.0);
  f6 = i11 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f6 = i19 ? f27 : f6;
  i19 = f26 == Math_fround(0.0);
  i11 = f26 >= Math_fround(0.0);
  f5 = i11 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  f5 = i19 ? f28 : f5;
  if (f20 == Math_fround(0.0)) f7 = f24; else {
   i19 = f20 >= Math_fround(0.0);
   f7 = i19 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
  }
 }
 i19 = HEAP32[i34 + 4 >> 2] | 0;
 HEAP32[i30 >> 2] = i19;
 f16 = f24 > f7 ? f24 : f7;
 f17 = f28 > f5 ? f28 : f5;
 f18 = f27 > f6 ? f27 : f6;
 f15 = f24 < f7 ? f24 : f7;
 f14 = f28 < f5 ? f28 : f5;
 f13 = f27 < f6 ? f27 : f6;
 i1 = 0;
 L6 : while (1) {
  L8 : while (1) {
   i2 = HEAP32[i30 + (i1 << 2) >> 2] | 0;
   i37 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i2 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   f42 = Math_fround(Math_fround(i37 & 255 | 0) * f7);
   f38 = Math_fround(Math_fround(i10 & 255 | 0) * f7);
   f7 = Math_fround(Math_fround(i3 & 255 | 0) * f7);
   f43 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f41 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(f27 - f43);
   f9 = Math_fround(f28 - f41);
   f39 = Math_fround(f24 - f12);
   f6 = Math_fround(Math_fround(f25 * f9) - Math_fround(f26 * f5));
   f9 = Math_fround(Math_fround(f26 * f39) - Math_fround(f20 * f9));
   f39 = Math_fround(Math_fround(f20 * f5) - Math_fround(f25 * f39));
   f5 = Math_fround(Math_fround(f22 * f42) + Math_fround(f21 * f38));
   f8 = Math_fround(Math_fround(f23 * f38) + Math_fround(f22 * f7));
   f40 = Math_fround(Math_fround(f21 * f7) + Math_fround(f23 * f42));
   i3 = Math_fround(f43 + f42) >= f13;
   i10 = Math_fround(f41 + f38) >= f14;
   i37 = Math_fround(f12 + f7) >= f15;
   i4 = f18 >= Math_fround(f43 - f42);
   i11 = f17 >= Math_fround(f41 - f38);
   i36 = f16 >= Math_fround(f12 - f7);
   f7 = Math_fround(-f6);
   f12 = Math_fround(-f9);
   f38 = Math_fround(-f39);
   L10 : do if (f40 >= (f39 > f38 ? f39 : f38) & (i37 & i36) & (f5 >= (f6 > f7 ? f6 : f7) & (i3 & i4) & (f8 >= (f9 > f12 ? f9 : f12) & (i10 & i11)))) {
    HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
    L12 : while (1) {
     while (1) {
      i3 = i2 + 16 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i3 + 4 >> 2] | 0;
      if (!((i2 & 1 | 0) == 0 & 0 == 0)) break L12;
      i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
      getTempRet0() | 0;
      i4 = i4 & 524287;
      i10 = i19 + (i4 * 24 | 0) | 0;
      i44 = HEAP32[i10 >> 2] | 0;
      i36 = HEAP32[i19 + (i4 * 24 | 0) + 4 >> 2] | 0;
      i46 = HEAP32[i19 + (i4 * 24 | 0) + 8 >> 2] | 0;
      f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i19 + (i4 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
      f38 = Math_fround(Math_fround(i44 & 255 | 0) * f7);
      f40 = Math_fround(Math_fround(i36 & 255 | 0) * f7);
      f7 = Math_fround(Math_fround(i46 & 255 | 0) * f7);
      f12 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f8 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = Math_fround(f27 - f12);
      f47 = Math_fround(f28 - f9);
      f42 = Math_fround(f24 - f8);
      f6 = Math_fround(Math_fround(f25 * f47) - Math_fround(f26 * f5));
      f47 = Math_fround(Math_fround(f26 * f42) - Math_fround(f20 * f47));
      f42 = Math_fround(Math_fround(f20 * f5) - Math_fround(f25 * f42));
      f5 = Math_fround(Math_fround(f22 * f38) + Math_fround(f21 * f40));
      f43 = Math_fround(Math_fround(f23 * f40) + Math_fround(f22 * f7));
      f48 = Math_fround(Math_fround(f21 * f7) + Math_fround(f23 * f38));
      i46 = Math_fround(f12 + f38) >= f13;
      i36 = Math_fround(f9 + f40) >= f14;
      i44 = Math_fround(f8 + f7) >= f15;
      i11 = f18 >= Math_fround(f12 - f38);
      i3 = f17 >= Math_fround(f9 - f40);
      i37 = f16 >= Math_fround(f8 - f7);
      f7 = Math_fround(-f6);
      f40 = Math_fround(-f47);
      f38 = Math_fround(-f42);
      i3 = f48 >= (f42 > f38 ? f42 : f38) & (i44 & i37) & (f5 >= (f6 > f7 ? f6 : f7) & (i46 & i11) & (f43 >= (f47 > f40 ? f47 : f40) & (i36 & i3)));
      i36 = i4 + 1 | 0;
      i11 = i19 + (i36 * 24 | 0) | 0;
      i46 = HEAP32[i11 >> 2] | 0;
      i37 = HEAP32[i19 + (i36 * 24 | 0) + 4 >> 2] | 0;
      i44 = HEAP32[i19 + (i36 * 24 | 0) + 8 >> 2] | 0;
      f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i19 + (i36 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
      f47 = Math_fround(Math_fround(i46 & 255 | 0) * f40);
      f43 = Math_fround(Math_fround(i37 & 255 | 0) * f40);
      f40 = Math_fround(Math_fround(i44 & 255 | 0) * f40);
      f7 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f6 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f38 = Math_fround(f27 - f7);
      f42 = Math_fround(f28 - f6);
      f48 = Math_fround(f24 - f5);
      f39 = Math_fround(Math_fround(f25 * f42) - Math_fround(f26 * f38));
      f42 = Math_fround(Math_fround(f26 * f48) - Math_fround(f20 * f42));
      f48 = Math_fround(Math_fround(f20 * f38) - Math_fround(f25 * f48));
      f38 = Math_fround(Math_fround(f22 * f47) + Math_fround(f21 * f43));
      f41 = Math_fround(Math_fround(f23 * f43) + Math_fround(f22 * f40));
      f49 = Math_fround(Math_fround(f21 * f40) + Math_fround(f23 * f47));
      i44 = Math_fround(f7 + f47) >= f13;
      i37 = Math_fround(f6 + f43) >= f14;
      i46 = Math_fround(f5 + f40) >= f15;
      i36 = f18 >= Math_fround(f7 - f47);
      i2 = f17 >= Math_fround(f6 - f43);
      i45 = f16 >= Math_fround(f5 - f40);
      f40 = Math_fround(-f39);
      f43 = Math_fround(-f42);
      f47 = Math_fround(-f48);
      i2 = f49 >= (f48 > f47 ? f48 : f47) & (i46 & i45) & (f38 >= (f39 > f40 ? f39 : f40) & (i44 & i36) & (f41 >= (f42 > f43 ? f42 : f43) & (i37 & i2)));
      if (i3 & i2) break;
      if (i3 | i2) i2 = i3 ? i10 : i11; else break L10;
     }
     i2 = Math_fround(Math_fround(Math_fround(f25 * Math_fround(f7 - f12)) + Math_fround(f26 * Math_fround(f6 - f9))) + Math_fround(f20 * Math_fround(f5 - f8))) > Math_fround(0.0) & 1;
     HEAP32[i30 + (i1 << 2) >> 2] = i19 + ((i2 + i4 | 0) * 24 | 0);
     i2 = i19 + (((i2 ^ 1) + i4 | 0) * 24 | 0) | 0;
     i1 = i1 + 1 | 0;
    }
    f6 = Math_fround(HEAPF32[i31 >> 2]);
    i45 = HEAP32[i34 >> 2] | 0;
    i46 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    if (!(mftCall_iiiii(HEAP32[HEAP32[i33 >> 2] >> 2] | 0, i33 | 0, i29 | 0, i32 + (HEAP32[i45 + ((i46 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
     i1 = 0;
     i2 = 18;
     break L6;
    }
    f5 = Math_fround(HEAPF32[i29 >> 2]);
    if (f5 < f6) break L8;
   } while (0);
   if (!i1) {
    i1 = 1;
    i2 = 18;
    break L6;
   } else i1 = i1 + -1 | 0;
  }
  HEAPF32[i31 >> 2] = f5;
  f7 = Math_fround(f27 + Math_fround(f25 * f5));
  f6 = Math_fround(f28 + Math_fround(f26 * f5));
  f5 = Math_fround(f24 + Math_fround(f20 * f5));
  if (!i1) {
   i1 = 1;
   i2 = 18;
   break;
  } else {
   f16 = f24 > f5 ? f24 : f5;
   f17 = f28 > f6 ? f28 : f6;
   f18 = f27 > f7 ? f27 : f7;
   f15 = f24 < f5 ? f24 : f5;
   f14 = f28 < f6 ? f28 : f6;
   f13 = f27 < f7 ? f27 : f7;
   i1 = i1 + -1 | 0;
  }
 }
 if ((i2 | 0) == 18) {
  STACKTOP = i35;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Sc5Scene11collideStepEPNS_10PxBaseTaskE(i27, i3) {
 i27 = i27 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28;
 __ZN5physx2Sc8SimStats8simStartEv(HEAP32[i27 + 1184 >> 2] | 0);
 i4 = i27 + 1204 | 0;
 __ZN5physx10PxsContext11beginUpdateEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 1e3 >> 2] | 0);
 i13 = i27 + 148 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i1 = i27 + 144 | 0;
  i2 = 0;
  do {
   __ZN5physx2Sc17ParticleSystemSim9startStepEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 i2 = i27 + 1792 | 0;
 HEAP32[i27 + 1800 >> 2] = HEAP32[i3 + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 i24 = i27 + 1576 | 0;
 HEAP32[i27 + 1592 >> 2] = 1;
 i1 = i27 + 1588 | 0;
 HEAP32[i1 >> 2] = i3;
 if (i3 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
  HEAP32[i27 + 1584 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 i22 = i27 + 2152 | 0;
 HEAP32[i27 + 2168 >> 2] = 1;
 i23 = i27 + 2164 | 0;
 HEAP32[i23 >> 2] = i24;
 mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 16 >> 2] | 0, i24 | 0);
 i11 = i27 + 2160 | 0;
 HEAP32[i11 >> 2] = HEAP32[(HEAP32[i23 >> 2] | 0) + 8 >> 2];
 i23 = i27 + 2180 | 0;
 i10 = i27 + 2268 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i7 = i27 + 2192 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i7) | 0;
 i8 = i27 + 2188 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i26 >> 2] = i22;
 i11 = i27 + 2228 | 0;
 i12 = i27 + 2224 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i27 + 2220 >> 2] | 0) + (i1 << 2) >> 2] = i22;
  HEAP32[i12 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i27 + 2200 | 0, i26) | 0;
 mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, i22 | 0);
 i9 = i27 + 2264 | 0;
 HEAP8[i9 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 i17 = i27 + 2276 | 0;
 HEAP32[i27 + 2292 >> 2] = 1;
 i18 = i27 + 2288 | 0;
 HEAP32[i18 >> 2] = i23;
 mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0, i23 | 0);
 i20 = i27 + 2284 | 0;
 HEAP32[i20 >> 2] = HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2];
 i18 = i27 + 1456 | 0;
 i19 = i27 + 1544 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i19 >> 2] | 0);
 i14 = i27 + 1468 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i14) | 0;
 i15 = i27 + 1464 | 0;
 HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i26 >> 2] = i17;
 i20 = i27 + 1504 | 0;
 i21 = i27 + 1500 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((HEAP32[i20 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i27 + 1496 >> 2] | 0) + (i1 << 2) >> 2] = i17;
  HEAP32[i21 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i27 + 1476 | 0, i26) | 0;
 mftCall_vi(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0, i17 | 0);
 i16 = i27 + 1540 | 0;
 HEAP8[i16 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i19 >> 2] | 0);
 if (HEAP32[i13 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  if (!(HEAP32[i13 >> 2] | 0)) {
   mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 16 >> 2] | 0, i24 | 0);
   i5 = i24;
  } else i5 = __ZN5physx2Sc17ParticleSystemSim20scheduleCollisionCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i4 >> 2] | 0, i27 + 144 | 0, i24) | 0;
  i6 = __ZN5physx2Sc5Scene29scheduleParticleCollisionPrepERNS_10PxBaseTaskES3_(i27, i5, i2) | 0;
  if (!(HEAP32[i13 >> 2] | 0)) {
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
   i3 = i5;
  } else i3 = __ZN5physx2Sc17ParticleSystemSim19scheduleDynamicsCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i4 >> 2] | 0, i27 + 144 | 0, i5) | 0;
  i4 = __ZN5physx2Sc5Scene31scheduleParticleShapeGenerationERNS_10PxBaseTaskES3_(i27, i17, i3) | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
  __ZN5physx6shdfnd15atomicIncrementEPVi(i7) | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i26 >> 2] = i6;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   HEAP32[(HEAP32[i27 + 2220 >> 2] | 0) + (i1 << 2) >> 2] = i6;
   HEAP32[i12 >> 2] = i1 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i27 + 2200 | 0, i26) | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  HEAP8[i9 >> 0] = 1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
  mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 20 >> 2] | 0, i23 | 0);
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i19 >> 2] | 0);
  __ZN5physx6shdfnd15atomicIncrementEPVi(i14) | 0;
  HEAP32[i15 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i26 >> 2] = i4;
  i1 = HEAP32[i21 >> 2] | 0;
  if ((HEAP32[i20 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   HEAP32[(HEAP32[i27 + 1496 >> 2] | 0) + (i1 << 2) >> 2] = i4;
   HEAP32[i21 >> 2] = i1 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i27 + 1476 | 0, i26) | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  HEAP8[i16 >> 0] = 1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i19 >> 2] | 0);
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i18);
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 }
 __ZN5physx2Sc5Scene16scheduleClothGpuERNS_10PxBaseTaskE(i27, i2);
 i1 = i27 + 168 | 0;
 L36 : do if (!(HEAP32[i1 >> 2] | 0)) i25 = 31; else {
  i3 = i27 + 160 | 0;
  i4 = i27 + 156 | 0;
  i5 = 0;
  while (1) {
   if (i5 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break;
   if (!((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] | 0) | 0) & 4)) i5 = i5 + 1 | 0; else {
    i25 = 31;
    break L36;
   }
  }
  i13 = HEAP32[i1 >> 2] | 0;
  i2 = mftCall_iifi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, +Math_fround(HEAPF32[i27 + 64 >> 2]), i2 | 0) | 0;
  HEAP32[i27 + 1564 >> 2] = 1;
  i13 = i27 + 1560 | 0;
  HEAP32[i13 >> 2] = i2;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  HEAP32[i27 + 1556 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = i27 + 1548 | 0;
 } while (0);
 if ((i25 | 0) == 31) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i19 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i14) | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i26 >> 2] = i2;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((HEAP32[i20 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i27 + 1496 >> 2] | 0) + (i1 << 2) >> 2] = i2;
  HEAP32[i21 >> 2] = i1 + 1;
  i27 = HEAP32[i2 >> 2] | 0;
  i27 = i27 + 16 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i2 | 0);
  HEAP8[i16 >> 0] = 1;
  i27 = HEAP32[i19 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i27);
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i18);
  i27 = HEAP32[i2 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i2 | 0);
  i27 = HEAP32[i24 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i24 | 0);
  i27 = HEAP32[i22 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i22 | 0);
  i27 = HEAP32[i23 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i23 | 0);
  i27 = HEAP32[i17 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i17 | 0);
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i18);
  STACKTOP = i28;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i27 + 1476 | 0, i26) | 0;
  i27 = HEAP32[i2 >> 2] | 0;
  i27 = i27 + 16 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i2 | 0);
  HEAP8[i16 >> 0] = 1;
  i27 = HEAP32[i19 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i27);
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i18);
  i27 = HEAP32[i2 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i2 | 0);
  i27 = HEAP32[i24 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i24 | 0);
  i27 = HEAP32[i22 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i22 | 0);
  i27 = HEAP32[i23 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i23 | 0);
  i27 = HEAP32[i17 >> 2] | 0;
  i27 = i27 + 20 | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  mftCall_vi(i27 | 0, i17 | 0);
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i18);
  STACKTOP = i28;
  return;
 }
}

function __ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i17, i19) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 16 | 0;
 i3 = i23;
 i22 = i23 + 56 | 0;
 i20 = i23 + 32 | 0;
 i18 = __ZN4crnd12symbol_codec11decode_bitsEj(i17, 14) | 0;
 if (!i18) {
  HEAP32[i19 >> 2] = 0;
  i1 = i19 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
    HEAP32[i3 >> 2] = gb + 401209;
    HEAP32[i3 + 4 >> 2] = 2513;
    HEAP32[i3 + 8 >> 2] = gb + 401349;
    _sprintf(i22, gb + 401176 | 0, i3) | 0;
    _puts(i22) | 0;
   }
   HEAP32[i1 >> 2] = 0;
   HEAP32[i19 + 8 >> 2] = 0;
   HEAP32[i19 + 12 >> 2] = 0;
  }
  HEAP8[i19 + 16 >> 0] = 0;
  i1 = i19 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
  __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i2);
  HEAP32[i1 >> 2] = 0;
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 i16 = i19 + 4 | 0;
 i2 = i19 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i18 | 0)) {
  if (i1 >>> 0 <= i18 >>> 0) {
   do if ((HEAP32[i19 + 12 >> 2] | 0) >>> 0 < i18 >>> 0) {
    if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i16, i18, (i1 + 1 | 0) == (i18 | 0), 1, 0) | 0) {
     i1 = HEAP32[i2 >> 2] | 0;
     break;
    }
    HEAP8[i19 + 16 >> 0] = 1;
    i22 = 0;
    STACKTOP = i23;
    return i22 | 0;
   } while (0);
   _memset((HEAP32[i16 >> 2] | 0) + i1 | 0, 0, i18 - i1 | 0) | 0;
  }
  HEAP32[i2 >> 2] = i18;
 }
 _memset(HEAP32[i16 >> 2] | 0, 0, i18 | 0) | 0;
 i15 = i17 + 20 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) < 5) {
  i6 = i17 + 4 | 0;
  i3 = i17 + 16 | 0;
  i5 = HEAP32[i17 + 8 >> 2] | 0;
  i8 = 4 - i1 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i7 = i1;
  while (1) {
   if ((i2 | 0) == (i5 | 0)) {
    i2 = 0;
    i4 = i5;
   } else {
    i4 = i2 + 1 | 0;
    HEAP32[i6 >> 2] = i4;
    i2 = HEAPU8[i2 >> 0] | 0;
   }
   i14 = i7;
   i7 = i7 + 8 | 0;
   HEAP32[i15 >> 2] = i7;
   i2 = HEAP32[i3 >> 2] | i2 << 24 - i14;
   HEAP32[i3 >> 2] = i2;
   if ((i7 | 0) >= 5) break; else i2 = i4;
  }
  i1 = i1 + 8 + (i8 & -8) | 0;
 } else {
  i2 = i17 + 16 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i12 = i2 >>> 27;
 HEAP32[i3 >> 2] = i2 << 5;
 HEAP32[i15 >> 2] = i1 + -5;
 if ((i12 + -1 | 0) >>> 0 > 20) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i13 = i20 + 20 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP8[i20 + 16 >> 0] = 0;
 i1 = i20 + 4 | 0;
 i14 = i20 + 8 | 0;
 L41 : do if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i1, 21, 0, 1, 0) | 0) {
  i11 = HEAP32[i14 >> 2] | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  _memset(i8 + i11 | 0, 0, 21 - i11 | 0) | 0;
  HEAP32[i14 >> 2] = 21;
  if (i12 | 0) {
   i9 = i17 + 4 | 0;
   i10 = i17 + 8 | 0;
   i11 = i17 + 16 | 0;
   i7 = 0;
   do {
    i1 = HEAP32[i15 >> 2] | 0;
    if ((i1 | 0) < 3) {
     i4 = HEAP32[i10 >> 2] | 0;
     i6 = 2 - i1 | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     i5 = i1;
     while (1) {
      if ((i2 | 0) == (i4 | 0)) {
       i2 = 0;
       i3 = i4;
      } else {
       i3 = i2 + 1 | 0;
       HEAP32[i9 >> 2] = i3;
       i2 = HEAPU8[i2 >> 0] | 0;
      }
      i24 = i5;
      i5 = i5 + 8 | 0;
      HEAP32[i15 >> 2] = i5;
      i2 = HEAP32[i11 >> 2] | i2 << 24 - i24;
      HEAP32[i11 >> 2] = i2;
      if ((i5 | 0) >= 3) break; else i2 = i3;
     }
     i1 = i1 + 8 + (i6 & -8) | 0;
    } else i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = i2 << 3;
    HEAP32[i15 >> 2] = i1 + -3;
    HEAP8[i8 + (HEAPU8[gb + 401441 + i7 >> 0] | 0) >> 0] = i2 >>> 29;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i12 | 0));
  }
  if (__ZN4crnd25static_huffman_data_model22prepare_decoder_tablesEv(i20) | 0) {
   i9 = i17 + 4 | 0;
   i10 = i17 + 8 | 0;
   i11 = i17 + 16 | 0;
   i1 = 0;
   do {
    i8 = i18 - i1 | 0;
    i2 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i17, i20) | 0;
    L61 : do if (i2 >>> 0 < 17) {
     HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i2;
     i1 = i1 + 1 | 0;
    } else switch (i2 | 0) {
    case 17:
     {
      i2 = HEAP32[i15 >> 2] | 0;
      if ((i2 | 0) < 3) {
       i5 = HEAP32[i10 >> 2] | 0;
       i7 = 2 - i2 | 0;
       i3 = HEAP32[i9 >> 2] | 0;
       i6 = i2;
       while (1) {
        if ((i3 | 0) == (i5 | 0)) {
         i3 = 0;
         i4 = i5;
        } else {
         i4 = i3 + 1 | 0;
         HEAP32[i9 >> 2] = i4;
         i3 = HEAPU8[i3 >> 0] | 0;
        }
        i24 = i6;
        i6 = i6 + 8 | 0;
        HEAP32[i15 >> 2] = i6;
        i3 = HEAP32[i11 >> 2] | i3 << 24 - i24;
        HEAP32[i11 >> 2] = i3;
        if ((i6 | 0) >= 3) break; else i3 = i4;
       }
       i2 = i2 + 8 + (i7 & -8) | 0;
      } else i3 = HEAP32[i11 >> 2] | 0;
      HEAP32[i11 >> 2] = i3 << 3;
      HEAP32[i15 >> 2] = i2 + -3;
      i3 = (i3 >>> 29) + 3 | 0;
      i2 = i3 >>> 0 > i8 >>> 0;
      if (i2) {
       i3 = 0;
       break L41;
      } else {
       i1 = (i2 ? 0 : i3) + i1 | 0;
       break L61;
      }
     }
    case 18:
     {
      i2 = HEAP32[i15 >> 2] | 0;
      if ((i2 | 0) < 7) {
       i5 = HEAP32[i10 >> 2] | 0;
       i7 = 6 - i2 | 0;
       i3 = HEAP32[i9 >> 2] | 0;
       i6 = i2;
       while (1) {
        if ((i3 | 0) == (i5 | 0)) {
         i3 = 0;
         i4 = i5;
        } else {
         i4 = i3 + 1 | 0;
         HEAP32[i9 >> 2] = i4;
         i3 = HEAPU8[i3 >> 0] | 0;
        }
        i24 = i6;
        i6 = i6 + 8 | 0;
        HEAP32[i15 >> 2] = i6;
        i3 = HEAP32[i11 >> 2] | i3 << 24 - i24;
        HEAP32[i11 >> 2] = i3;
        if ((i6 | 0) >= 7) break; else i3 = i4;
       }
       i2 = i2 + 8 + (i7 & -8) | 0;
      } else i3 = HEAP32[i11 >> 2] | 0;
      HEAP32[i11 >> 2] = i3 << 7;
      HEAP32[i15 >> 2] = i2 + -7;
      i3 = (i3 >>> 25) + 11 | 0;
      i2 = i3 >>> 0 > i8 >>> 0;
      if (i2) {
       i3 = 0;
       break L41;
      } else {
       i1 = (i2 ? 0 : i3) + i1 | 0;
       break L61;
      }
     }
    default:
     {
      if ((i2 + -19 | 0) >>> 0 >= 2) {
       i3 = 0;
       break L41;
      }
      i7 = HEAP32[i15 >> 2] | 0;
      if ((i2 | 0) == 19) {
       if ((i7 | 0) < 2) {
        i4 = HEAP32[i10 >> 2] | 0;
        i6 = 1 - i7 | 0;
        i2 = HEAP32[i9 >> 2] | 0;
        i5 = i7;
        do {
         if ((i2 | 0) == (i4 | 0)) {
          i3 = 0;
          i2 = i4;
         } else {
          i24 = i2 + 1 | 0;
          HEAP32[i9 >> 2] = i24;
          i3 = HEAPU8[i2 >> 0] | 0;
          i2 = i24;
         }
         i24 = i5;
         i5 = i5 + 8 | 0;
         HEAP32[i15 >> 2] = i5;
         i3 = HEAP32[i11 >> 2] | i3 << 24 - i24;
         HEAP32[i11 >> 2] = i3;
        } while ((i5 | 0) < 2);
        i2 = i7 + 8 + (i6 & -8) | 0;
       } else {
        i3 = HEAP32[i11 >> 2] | 0;
        i2 = i7;
       }
       HEAP32[i11 >> 2] = i3 << 2;
       HEAP32[i15 >> 2] = i2 + -2;
       i2 = (i3 >>> 30) + 3 | 0;
      } else {
       if ((i7 | 0) < 6) {
        i4 = HEAP32[i10 >> 2] | 0;
        i6 = 5 - i7 | 0;
        i2 = HEAP32[i9 >> 2] | 0;
        i5 = i7;
        do {
         if ((i2 | 0) == (i4 | 0)) {
          i3 = 0;
          i2 = i4;
         } else {
          i24 = i2 + 1 | 0;
          HEAP32[i9 >> 2] = i24;
          i3 = HEAPU8[i2 >> 0] | 0;
          i2 = i24;
         }
         i24 = i5;
         i5 = i5 + 8 | 0;
         HEAP32[i15 >> 2] = i5;
         i3 = HEAP32[i11 >> 2] | i3 << 24 - i24;
         HEAP32[i11 >> 2] = i3;
        } while ((i5 | 0) < 6);
        i2 = i7 + 8 + (i6 & -8) | 0;
       } else {
        i3 = HEAP32[i11 >> 2] | 0;
        i2 = i7;
       }
       HEAP32[i11 >> 2] = i3 << 6;
       HEAP32[i15 >> 2] = i2 + -6;
       i2 = (i3 >>> 26) + 7 | 0;
      }
      if ((i1 | 0) == 0 | i2 >>> 0 > i8 >>> 0) {
       i3 = 0;
       break L41;
      }
      i3 = HEAP32[i16 >> 2] | 0;
      i4 = HEAP8[i3 + (i1 + -1) >> 0] | 0;
      if (!(i4 << 24 >> 24)) {
       i3 = 0;
       break L41;
      }
      i2 = i2 + i1 | 0;
      if (i1 >>> 0 >= i2 >>> 0) break L61;
      HEAP8[i3 + i1 >> 0] = i4;
      i1 = i1 + 1 | 0;
      do {
       HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i4;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i2 | 0));
      i1 = i2;
     }
    } while (0);
   } while (i18 >>> 0 > i1 >>> 0);
   if ((i18 | 0) == (i1 | 0)) i3 = __ZN4crnd25static_huffman_data_model22prepare_decoder_tablesEv(i19) | 0; else i3 = 0;
  } else i3 = 0;
 } else {
  HEAP8[i20 + 16 >> 0] = 1;
  i3 = 0;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i20 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i21 >> 2] = gb + 401209;
   HEAP32[i21 + 4 >> 2] = 2513;
   HEAP32[i21 + 8 >> 2] = gb + 401349;
   _sprintf(i22, gb + 401176 | 0, i21) | 0;
   _puts(i22) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
 }
 i24 = i3;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZN12AudioManager9CloseFMODEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20 + 40 | 0;
 i7 = i20 + 24 | 0;
 i11 = i20 + 8 | 0;
 i12 = i20;
 i18 = i20 + 76 | 0;
 i14 = i20 + 56 | 0;
 i19 = i13 + 88 | 0;
 if (!(HEAP32[i19 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i4 + 4 >> 2] = i16;
 HEAP32[i18 >> 2] = 0;
 i4 = i18 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i6 = i11;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i17;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 27592 | 0, i18, 0);
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i11 + 11 | 0;
  i6 = i11 + 11 | 0;
  i3 = 0;
  do {
   i1 = __ZNK13MonoBehaviour6GetDSPEv(HEAP32[(HEAP32[i18 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0;
   if (i1 | 0) {
    HEAP32[i12 >> 2] = 0;
    i2 = __ZN4FMOD3DSP11getUserDataEPPv(i1, i12) | 0;
    if (!i2) {
     i1 = __ZN4FMOD3DSP9getBypassEPb(i1, (HEAP32[i12 >> 2] | 0) + 13 | 0) | 0;
     if (i1 | 0) {
      i10 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
      HEAP32[i8 >> 2] = gb + 856220;
      HEAP32[i8 + 4 >> 2] = 1151;
      HEAP32[i8 + 8 >> 2] = gb + 857634;
      HEAP32[i8 + 12 >> 2] = i10;
      __Z6FormatPKcz(i11, gb + 883334 | 0, i8);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     }
    } else {
     i10 = __ZL16FMOD_ErrorString11FMOD_RESULT(i2) | 0;
     HEAP32[i7 >> 2] = gb + 856220;
     HEAP32[i7 + 4 >> 2] = 1149;
     HEAP32[i7 + 8 >> 2] = gb + 856340;
     HEAP32[i7 + 12 >> 2] = i10;
     __Z6FormatPKcz(i11, gb + 883334 | 0, i7);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    }
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i14 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i8 = i11;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 171656 | 0, i14, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN11AudioSource7CleanupEv(HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i4);
  HEAP32[i14 >> 2] = 0;
 }
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i12;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i14 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i6 = i11;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 171468 | 0, i14, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i7 = 0;
  do {
   i2 = HEAP32[(HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0) + 28 >> 2] | 0;
   if (i2) {
    i6 = i2 + 40 | 0;
    if ((HEAP32[i6 >> 2] | 0) > 0) {
     i5 = i2 + 28 | 0;
     i4 = 0;
     do {
      i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
      i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
      i3 = (i1 | 0) == 0;
      if (i3 | (i2 - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) {
       if (!(i3 | (i2 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
        i1 = HEAP32[i1 + 144 >> 2] | 0;
        if (i1 | 0) __ZN17AudioCustomFilter7CleanupEv(i1);
       }
      } else __ZN11AudioFilter7CleanupEv(i1);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
     i1 = HEAP32[i8 >> 2] | 0;
    }
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i10);
  HEAP32[i14 >> 2] = 0;
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i14 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i8 = i11;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 174088 | 0, i14, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN15AudioReverbZone7CleanupEv(HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i4);
  HEAP32[i14 >> 2] = 0;
 }
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i14 >> 2] = 0;
 i6 = i14 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i14 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i9 = i11;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 174128 | 0, i14, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i5 = 0;
  do {
   i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i2 + 76 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i2 + 72 >> 2] | 0;
    __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i4, i1, HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i2 + 32 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i8);
  HEAP32[i14 >> 2] = 0;
 }
 i1 = i13 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD12ChannelGroup7releaseEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i13 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD12ChannelGroup7releaseEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i13 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD12ChannelGroup7releaseEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i13 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD12ChannelGroup7releaseEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i6 = i13 + 236 | 0;
 __ZN4FMOD3DSP7releaseEv(HEAP32[i6 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i13 + 92 >> 2] = 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i14 >> 2] = 0;
 i4 = i14 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i14 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i10 = i11;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 170640 | 0, i14, 0);
 if (HEAP32[i4 >> 2] | 0) {
  i2 = 0;
  do {
   i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i1 = __Z24GetManagerPtrFromContexti(3) | 0;
   if (!i1) i15 = 53; else if (!(HEAP8[i1 + 224 >> 0] | 0)) i15 = 53;
   do if ((i15 | 0) == 53) {
    i15 = 0;
    __ZN11SoundHandle7ReleaseEv(i3 + 56 | 0);
    i1 = HEAP8[i3 + 72 + 11 >> 0] | 0;
    if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 76 >> 2] | 0; else i1 = i1 & 255;
    if (!i1) break;
    if (!(__Z24GetManagerPtrFromContexti(3) | 0)) break;
    __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i3);
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i6);
  HEAP32[i14 >> 2] = 0;
 }
 i1 = i13 + 220 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN12SoundManagerD2Ev(i2);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN4FMOD6System5closeEv(HEAP32[i19 >> 2] | 0) | 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
  HEAP32[i18 >> 2] = 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN26PlayerSettingsSplashScreen8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i2 = i8 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450096 | 0, HEAP32[gb + 36980 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 4 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450126 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 5 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450150 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 36 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450172 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen13AnimationModeEEvRT_RT0_PKc17TransferMetaFlags(i10, i8 + 12 | 0, gb + 450201 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen14UnityLogoStyleEEvRT_RT0_PKc17TransferMetaFlags(i10, i8 + 8 | 0, gb + 450225 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen8DrawModeEEvRT_RT0_PKc17TransferMetaFlags(i10, i8 + 16 | 0, gb + 450249 | 0, 0);
 i4 = i8 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450272 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 41; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450310 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 52; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 52; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i5 = i8 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450342 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i7 = 63; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 63; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 63) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450382 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 74; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 74; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 74) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i8 + 40 | 0, gb + 450421 | 0, 0);
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i8 + 56 | 0, gb + 450458 | 0, 0);
 i2 = i8 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450494 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (Math_fround(HEAPF32[i5 >> 2]) < Math_fround(0.0)) HEAPF32[i5 >> 2] = Math_fround(0.0);
 if (Math_fround(HEAPF32[i4 >> 2]) < Math_fround(0.0)) HEAPF32[i4 >> 2] = Math_fround(0.0);
 i2 = i8 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450514 | 0, gb + 1034905 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450548 | 0, gb + 1034905 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 450581 | 0, gb + 1034905 | 0, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physxL17updateStreamForceEPNS_6PxVec3EPNS_16PxsFluidParticleEPKS2_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE(i84, i88, i89, i86, i87, i1, i91) {
 i84 = i84 | 0;
 i88 = i88 | 0;
 i89 = i89 | 0;
 i86 = i86 | 0;
 i87 = i87 | 0;
 i1 = i1 | 0;
 i91 = i91 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0, i85 = 0, i90 = 0, i92 = 0, i93 = 0, f94 = f0, f95 = f0, f96 = f0, f97 = f0, f98 = f0, f99 = f0, f100 = f0, f101 = f0;
 i93 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i90 = i93 + 176 | 0;
 i85 = i93 + 112 | 0;
 i75 = i93 + 32 | 0;
 i76 = i93 + 16 | 0;
 i77 = i93;
 i92 = i93 + 48 | 0;
 if (!i87) {
  STACKTOP = i93;
  return;
 }
 i78 = i1 + 52 | 0;
 i79 = i1 + 24 | 0;
 i80 = i1 + 44 | 0;
 i81 = i1 + 28 | 0;
 i82 = i1 + 36 | 0;
 i83 = i1 + 48 | 0;
 i30 = i1 + 40 | 0;
 i31 = i90 + 4 | 0;
 i32 = i90 + 8 | 0;
 i33 = i90 + 12 | 0;
 i34 = i90 + 16 | 0;
 i35 = i90 + 20 | 0;
 i36 = i90 + 24 | 0;
 i37 = i90 + 28 | 0;
 i38 = i90 + 32 | 0;
 i39 = i90 + 36 | 0;
 i40 = i90 + 40 | 0;
 i41 = i90 + 44 | 0;
 i42 = i90 + 48 | 0;
 i43 = i90 + 52 | 0;
 i44 = i90 + 56 | 0;
 i45 = i90 + 60 | 0;
 i46 = i85 + 16 | 0;
 i47 = i85 + 32 | 0;
 i48 = i85 + 48 | 0;
 i49 = i92 + 4 | 0;
 i50 = i92 + 8 | 0;
 i51 = i92 + 12 | 0;
 i52 = i92 + 16 | 0;
 i53 = i92 + 20 | 0;
 i54 = i92 + 24 | 0;
 i55 = i92 + 28 | 0;
 i56 = i92 + 32 | 0;
 i57 = i92 + 36 | 0;
 i58 = i92 + 40 | 0;
 i59 = i92 + 44 | 0;
 i60 = i92 + 48 | 0;
 i61 = i92 + 52 | 0;
 i62 = i92 + 56 | 0;
 i63 = i92 + 60 | 0;
 i64 = i85 + 16 | 0;
 i65 = i85 + 32 | 0;
 i66 = i85 + 4 | 0;
 i67 = i85 + 20 | 0;
 i68 = i85 + 36 | 0;
 i69 = i85 + 8 | 0;
 i70 = i85 + 24 | 0;
 i71 = i85 + 40 | 0;
 i72 = i85 + 12 | 0;
 i73 = i85 + 28 | 0;
 i74 = i85 + 44 | 0;
 i1 = 0;
 do {
  i9 = HEAP32[i86 + (i1 << 2) >> 2] | 0;
  i8 = i88 + (i9 << 5) | 0;
  i6 = i1 + 2 | 0;
  i10 = HEAP32[i86 + (i1 + 1 << 2) >> 2] | 0;
  i11 = i10 >>> 2;
  if (!i11) i1 = i6; else {
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i8 + 4 >> 2] | 0;
   i29 = HEAP32[i8 + 8 >> 2] | 0;
   i1 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i90 >> 2] = i3;
   HEAP32[i31 >> 2] = i3;
   HEAP32[i32 >> 2] = i3;
   HEAP32[i33 >> 2] = i3;
   HEAP32[i34 >> 2] = i4;
   HEAP32[i35 >> 2] = i4;
   HEAP32[i36 >> 2] = i4;
   HEAP32[i37 >> 2] = i4;
   HEAP32[i38 >> 2] = i29;
   HEAP32[i39 >> 2] = i29;
   HEAP32[i40 >> 2] = i29;
   HEAP32[i41 >> 2] = i29;
   HEAP32[i42 >> 2] = i1;
   HEAP32[i43 >> 2] = i1;
   HEAP32[i44 >> 2] = i1;
   HEAP32[i45 >> 2] = i1;
   HEAP32[i85 >> 2] = 0;
   HEAP32[i85 + 4 >> 2] = 0;
   HEAP32[i85 + 8 >> 2] = 0;
   HEAP32[i85 + 12 >> 2] = 0;
   HEAP32[i75 >> 2] = 0;
   HEAP32[i75 + 4 >> 2] = 0;
   HEAP32[i75 + 8 >> 2] = 0;
   HEAP32[i75 + 12 >> 2] = 0;
   HEAP32[i76 >> 2] = 0;
   HEAP32[i76 + 4 >> 2] = 0;
   HEAP32[i76 + 8 >> 2] = 0;
   HEAP32[i76 + 12 >> 2] = 0;
   HEAP32[i77 >> 2] = 0;
   HEAP32[i77 + 4 >> 2] = 0;
   HEAP32[i77 + 8 >> 2] = 0;
   HEAP32[i77 + 12 >> 2] = 0;
   HEAP32[i46 >> 2] = HEAP32[i75 >> 2];
   HEAP32[i46 + 4 >> 2] = HEAP32[i75 + 4 >> 2];
   HEAP32[i46 + 8 >> 2] = HEAP32[i75 + 8 >> 2];
   HEAP32[i46 + 12 >> 2] = HEAP32[i75 + 12 >> 2];
   HEAP32[i47 >> 2] = HEAP32[i76 >> 2];
   HEAP32[i47 + 4 >> 2] = HEAP32[i76 + 4 >> 2];
   HEAP32[i47 + 8 >> 2] = HEAP32[i76 + 8 >> 2];
   HEAP32[i47 + 12 >> 2] = HEAP32[i76 + 12 >> 2];
   HEAP32[i48 >> 2] = HEAP32[i77 >> 2];
   HEAP32[i48 + 4 >> 2] = HEAP32[i77 + 4 >> 2];
   HEAP32[i48 + 8 >> 2] = HEAP32[i77 + 8 >> 2];
   HEAP32[i48 + 12 >> 2] = HEAP32[i77 + 12 >> 2];
   i1 = i88 + (i9 << 5) + 16 | 0;
   i29 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i92 >> 2] = i29;
   HEAP32[i49 >> 2] = i29;
   HEAP32[i50 >> 2] = i29;
   HEAP32[i51 >> 2] = i29;
   HEAP32[i52 >> 2] = i4;
   HEAP32[i53 >> 2] = i4;
   HEAP32[i54 >> 2] = i4;
   HEAP32[i55 >> 2] = i4;
   HEAP32[i56 >> 2] = i3;
   HEAP32[i57 >> 2] = i3;
   HEAP32[i58 >> 2] = i3;
   HEAP32[i59 >> 2] = i3;
   HEAP32[i60 >> 2] = i1;
   HEAP32[i61 >> 2] = i1;
   HEAP32[i62 >> 2] = i1;
   HEAP32[i63 >> 2] = i1;
   i1 = i11 << 2;
   i3 = 0;
   i4 = i6;
   while (1) {
    __ZN5physx19calcForce4_onlyPtrsERNS_6shdfnd3aos6Mat44VEPKNS_16PxsFluidParticleES6_S6_S6_RKS2_S8_RKNS_30PxsFluidDynamicsParametersSIMDE(i85, i89 + (HEAP32[i86 + (i4 << 2) >> 2] << 5) | 0, i89 + (HEAP32[i86 + (i4 + 1 << 2) >> 2] << 5) | 0, i89 + (HEAP32[i86 + (i4 + 2 << 2) >> 2] << 5) | 0, i89 + (HEAP32[i86 + (i4 + 3 << 2) >> 2] << 5) | 0, i90, i92, i91);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break; else i4 = i4 + 4 | 0;
   }
   f16 = Math_fround(HEAPF32[i85 >> 2]);
   f19 = Math_fround(HEAPF32[i64 >> 2]);
   f22 = Math_fround(HEAPF32[i65 >> 2]);
   f17 = Math_fround(HEAPF32[i66 >> 2]);
   f20 = Math_fround(HEAPF32[i67 >> 2]);
   f23 = Math_fround(HEAPF32[i68 >> 2]);
   f18 = Math_fround(HEAPF32[i69 >> 2]);
   f21 = Math_fround(HEAPF32[i70 >> 2]);
   f26 = Math_fround(HEAPF32[i71 >> 2]);
   f24 = Math_fround(HEAPF32[i72 >> 2]);
   f25 = Math_fround(HEAPF32[i73 >> 2]);
   f24 = Math_fround(Math_fround(f16 + f17) + Math_fround(f18 + f24));
   f25 = Math_fround(Math_fround(f19 + f20) + Math_fround(f21 + f25));
   f26 = Math_fround(Math_fround(f22 + f23) + Math_fround(f26 + Math_fround(HEAPF32[i74 >> 2])));
   i29 = i84 + (i9 * 12 | 0) | 0;
   HEAPF32[i29 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i29 >> 2]));
   i29 = i84 + (i9 * 12 | 0) + 4 | 0;
   HEAPF32[i29 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i29 >> 2]));
   i29 = i84 + (i9 * 12 | 0) + 8 | 0;
   HEAPF32[i29 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i29 >> 2]));
   i1 = i6 + i1 | 0;
  }
  i29 = i11 << 2;
  i27 = i10 - i29 | 0;
  if ((i10 | 0) != (i29 | 0)) {
   f12 = Math_fround(HEAPF32[i8 >> 2]);
   f13 = Math_fround(HEAPF32[i88 + (i9 << 5) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i88 + (i9 << 5) + 8 >> 2]);
   f15 = Math_fround(HEAPF32[i78 >> 2]);
   f16 = Math_fround(HEAPF32[i79 >> 2]);
   f18 = Math_fround(HEAPF32[i88 + (i9 << 5) + 12 >> 2]);
   f17 = Math_fround(HEAPF32[i80 >> 2]);
   f18 = Math_fround(f18 - f17);
   i28 = f18 > Math_fround(0.0);
   f18 = i28 ? f18 : Math_fround(0.0);
   f19 = Math_fround(HEAPF32[i81 >> 2]);
   f20 = Math_fround(f16 * Math_fround(2.0));
   f21 = Math_fround(HEAPF32[i82 >> 2]);
   f22 = Math_fround(HEAPF32[i83 >> 2]);
   f23 = Math_fround(HEAPF32[i30 >> 2]);
   f24 = Math_fround(HEAPF32[i88 + (i9 << 5) + 16 >> 2]);
   f25 = Math_fround(HEAPF32[i88 + (i9 << 5) + 20 >> 2]);
   f26 = Math_fround(HEAPF32[i88 + (i9 << 5) + 24 >> 2]);
   i28 = i84 + (i9 * 12 | 0) | 0;
   i29 = i84 + (i9 * 12 | 0) + 4 | 0;
   i8 = i84 + (i9 * 12 | 0) + 8 | 0;
   f7 = Math_fround(HEAPF32[i28 >> 2]);
   f5 = Math_fround(HEAPF32[i29 >> 2]);
   f2 = Math_fround(HEAPF32[i8 >> 2]);
   i6 = i10 - (i11 << 2) | 0;
   i6 = i6 >>> 0 > 1 ? i6 : 1;
   i3 = 0;
   i4 = i1;
   while (1) {
    i11 = HEAP32[i86 + (i4 << 2) >> 2] | 0;
    f100 = Math_fround(f12 - Math_fround(HEAPF32[i89 + (i11 << 5) >> 2]));
    f98 = Math_fround(f13 - Math_fround(HEAPF32[i89 + (i11 << 5) + 4 >> 2]));
    f99 = Math_fround(f14 - Math_fround(HEAPF32[i89 + (i11 << 5) + 8 >> 2]));
    f97 = Math_fround(f15 * Math_fround(Math_fround(Math_fround(f100 * f100) + Math_fround(f98 * f98)) + Math_fround(f99 * f99)));
    f95 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f97))));
    f97 = Math_fround(f95 * f97);
    f94 = Math_fround(f16 - f97);
    f96 = Math_fround(HEAPF32[i89 + (i11 << 5) + 12 >> 2]);
    f101 = Math_fround(f96 - f17);
    i10 = f101 > Math_fround(0.0);
    f95 = Math_fround(Math_fround(f18 + (i10 ? f101 : Math_fround(0.0))) * Math_fround(f21 * Math_fround(f97 + Math_fround(Math_fround(f95 * f19) - f20))));
    f100 = Math_fround(f22 * Math_fround(f100 * f95));
    f98 = Math_fround(f22 * Math_fround(f98 * f95));
    f95 = Math_fround(f22 * Math_fround(f99 * f95));
    f94 = Math_fround(f94 * f23);
    f99 = Math_fround(Math_fround(HEAPF32[i89 + (i11 << 5) + 16 >> 2]) - f24);
    f97 = Math_fround(Math_fround(HEAPF32[i89 + (i11 << 5) + 20 >> 2]) - f25);
    f96 = Math_fround(Math_fround(1.0) / f96);
    f7 = Math_fround(Math_fround(Math_fround(f100 + Math_fround(f94 * Math_fround(f22 * f99))) * f96) + f7);
    f5 = Math_fround(Math_fround(f96 * Math_fround(f98 + Math_fround(f94 * Math_fround(f22 * f97)))) + f5);
    f2 = Math_fround(f2 + Math_fround(f96 * Math_fround(f95 + Math_fround(f94 * Math_fround(f22 * Math_fround(Math_fround(HEAPF32[i89 + (i11 << 5) + 24 >> 2]) - f26))))));
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i27 >>> 0) break; else i4 = i4 + 1 | 0;
   }
   HEAPF32[i28 >> 2] = f7;
   HEAPF32[i29 >> 2] = f5;
   HEAPF32[i8 >> 2] = f2;
   i1 = i1 + i6 | 0;
  }
 } while (i1 >>> 0 < i87 >>> 0);
 STACKTOP = i93;
 return;
}

function _UNITY_png_colorspace_set_endpoints(i22, i23, i1, i24) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i28 + 68 | 0;
 i25 = i28 + 32 | 0;
 i26 = i28;
 i7 = i25;
 i5 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i6 = i25 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 L1 : do if ((i4 | 0) < 0) i27 = 42; else {
  i11 = i25 + 16 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  if ((i9 | 0) < 0) i27 = 42; else {
   i18 = i25 + 28 | 0;
   i15 = HEAP32[i18 >> 2] | 0;
   if ((i15 | 0) < 0) i27 = 42; else {
    i3 = HEAP32[i25 >> 2] | 0;
    if ((i3 | 0) < 0) i27 = 42; else {
     i10 = i25 + 12 | 0;
     i7 = HEAP32[i10 >> 2] | 0;
     if ((i7 | 0) < 0) i27 = 42; else {
      i16 = i25 + 24 | 0;
      i13 = HEAP32[i16 >> 2] | 0;
      if ((i13 | 0) < 0) i27 = 42; else {
       i8 = i25 + 8 | 0;
       i5 = HEAP32[i8 >> 2] | 0;
       if ((i5 | 0) < 0) i27 = 42; else {
        i14 = i25 + 20 | 0;
        i12 = HEAP32[i14 >> 2] | 0;
        if ((i12 | 0) < 0) i27 = 42; else {
         i20 = i25 + 32 | 0;
         i19 = HEAP32[i20 >> 2] | 0;
         if ((2147483647 - i4 | 0) < (i7 | 0) | (i19 | 0) < 0) i27 = 42; else {
          i1 = i9 + i4 | 0;
          if ((2147483647 - i1 | 0) < (i13 | 0)) i27 = 42; else {
           i17 = i15 + i1 | 0;
           if ((i17 | 0) < 1e5) switch (i17 | 0) {
           case 0:
            {
             i27 = 42;
             break L1;
            }
           default:
            i27 = 12;
           } else switch (i17 | 0) {
           case 1e5:
            break;
           default:
            i27 = 12;
           }
           do if ((i27 | 0) == 12) {
            if (!i3) i1 = 0; else {
             d2 = +Math_floor(+(+(i3 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i25 >> 2] = i1;
            if (!i4) i1 = 0; else {
             d2 = +Math_floor(+(+(i4 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i6 >> 2] = i1;
            if (!i5) i1 = 0; else {
             d2 = +Math_floor(+(+(i5 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i8 >> 2] = i1;
            if (!i7) i1 = 0; else {
             d2 = +Math_floor(+(+(i7 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i10 >> 2] = i1;
            if (!i9) i1 = 0; else {
             d2 = +Math_floor(+(+(i9 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i11 >> 2] = i1;
            if (!i12) i1 = 0; else {
             d2 = +Math_floor(+(+(i12 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i14 >> 2] = i1;
            if (!i13) i1 = 0; else {
             d2 = +Math_floor(+(+(i13 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i16 >> 2] = i1;
            if (!i15) i1 = 0; else {
             d2 = +Math_floor(+(+(i15 | 0) * 1.0e5 / +(i17 | 0) + .5));
             if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
              i27 = 42;
              break L1;
             }
             i1 = ~~d2;
            }
            HEAP32[i18 >> 2] = i1;
            if (!i19) {
             HEAP32[i20 >> 2] = 0;
             break;
            }
            d2 = +Math_floor(+(+(i19 | 0) * 1.0e5 / +(i17 | 0) + .5));
            if (!(d2 <= 2147483647.0 & d2 >= -2147483648.0)) {
             i27 = 42;
             break L1;
            }
            HEAP32[i20 >> 2] = ~~d2;
           } while (0);
           i1 = _UNITY_png_xy_from_XYZ(i26, i25) | 0;
           if (!i1) {
            i7 = i21;
            i1 = i25;
            i5 = i7 + 36 | 0;
            do {
             HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
             i7 = i7 + 4 | 0;
             i1 = i1 + 4 | 0;
            } while ((i7 | 0) < (i5 | 0));
            i1 = _UNITY_png_colorspace_check_xy(i21, i26) | 0;
           }
           switch (i1 | 0) {
           case 1:
            break L1;
           case 0:
            break;
           default:
            {
             i21 = i23 + 74 | 0;
             HEAP16[i21 >> 1] = HEAPU16[i21 >> 1] | 0 | 32768;
             _UNITY_png_error(i22, gb + 351033 | 0);
            }
           }
           i6 = i23 + 74 | 0;
           i4 = HEAPU16[i6 >> 1] | 0;
           if (i4 & 32768 | 0) {
            i27 = 0;
            STACKTOP = i28;
            return i27 | 0;
           }
           i1 = i23 + 4 | 0;
           i3 = HEAP32[i26 + 24 >> 2] | 0;
           L63 : do if (!((i24 | 0) > 1 | (i4 & 2 | 0) == 0)) {
            i21 = HEAP32[i23 + 28 >> 2] | 0;
            do if (!((i3 | 0) < (i21 + -100 | 0) | (i3 | 0) > (i21 + 100 | 0))) {
             i20 = HEAP32[i26 + 28 >> 2] | 0;
             i21 = HEAP32[i23 + 32 >> 2] | 0;
             if (!((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0))) {
              i20 = HEAP32[i26 >> 2] | 0;
              i21 = HEAP32[i1 >> 2] | 0;
              if (!((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0))) {
               i20 = HEAP32[i26 + 4 >> 2] | 0;
               i21 = HEAP32[i23 + 8 >> 2] | 0;
               if ((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0)) break;
               i20 = HEAP32[i26 + 8 >> 2] | 0;
               i21 = HEAP32[i23 + 12 >> 2] | 0;
               if ((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0)) break;
               i20 = HEAP32[i26 + 12 >> 2] | 0;
               i21 = HEAP32[i23 + 16 >> 2] | 0;
               if ((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0)) break;
               i20 = HEAP32[i26 + 16 >> 2] | 0;
               i21 = HEAP32[i23 + 20 >> 2] | 0;
               if ((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0)) break;
               i20 = HEAP32[i26 + 20 >> 2] | 0;
               i21 = HEAP32[i23 + 24 >> 2] | 0;
               if ((i20 | 0) < (i21 + -100 | 0) | (i20 | 0) > (i21 + 100 | 0)) break;
               if (!i24) i1 = 1; else break L63;
               STACKTOP = i28;
               return i1 | 0;
              }
             }
            } while (0);
            HEAP16[i6 >> 1] = i4 | 32768;
            _UNITY_png_benign_error(i22, gb + 350982 | 0);
            i27 = 0;
            STACKTOP = i28;
            return i27 | 0;
           } while (0);
           HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
           HEAP32[i1 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
           HEAP32[i1 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
           HEAP32[i1 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
           HEAP32[i1 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
           HEAP32[i1 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
           HEAP32[i1 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
           HEAP32[i1 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
           i7 = i23 + 36 | 0;
           i1 = i25;
           i5 = i7 + 36 | 0;
           do {
            HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
            i7 = i7 + 4 | 0;
            i1 = i1 + 4 | 0;
           } while ((i7 | 0) < (i5 | 0));
           do if ((i3 + -30270 | 0) >>> 0 > 2e3) i27 = 63; else if (((HEAP32[i26 + 28 >> 2] | 0) + -31900 | 0) >>> 0 > 2e3) i27 = 63; else if (((HEAP32[i26 >> 2] | 0) + -63e3 | 0) >>> 0 > 2e3) i27 = 63; else if (((HEAP32[i26 + 4 >> 2] | 0) + -32e3 | 0) >>> 0 > 2e3) i27 = 63; else {
            if (((HEAP32[i26 + 8 >> 2] | 0) + -29e3 | 0) >>> 0 > 2e3) {
             i27 = 63;
             break;
            }
            if (((HEAP32[i26 + 12 >> 2] | 0) + -59e3 | 0) >>> 0 > 2e3) {
             i27 = 63;
             break;
            }
            if (((HEAP32[i26 + 16 >> 2] | 0) + -14e3 | 0) >>> 0 > 2e3) {
             i27 = 63;
             break;
            }
            i1 = ((HEAP32[i26 + 20 >> 2] | 0) + -5e3 | 0) >>> 0 < 2001 ? i4 | 66 : i4 & 65469 | 2;
           } while (0);
           if ((i27 | 0) == 63) i1 = i4 & 65469 | 2;
           HEAP16[i6 >> 1] = i1;
           i27 = 2;
           STACKTOP = i28;
           return i27 | 0;
          }
         }
        }
       }
      }
     }
    }
   }
  }
 } while (0);
 i27 = i23 + 74 | 0;
 HEAP16[i27 >> 1] = HEAPU16[i27 >> 1] | 0 | 32768;
 _UNITY_png_benign_error(i22, gb + 351072 | 0);
 i27 = 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZNK11DynamicMesh12IntersectionER13dynamic_arrayI8Vector3fLj4EERKS0_I5PlaneLj4EES3_Ph(i3, i35, i36, i37, i38) {
 i3 = i3 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i44 + 144 | 0;
 i40 = i44 + 16 | 0;
 i34 = i44 + 8 | 0;
 i33 = i44 + 4 | 0;
 i32 = i44;
 i41 = HEAP32[i36 + 12 >> 2] | 0;
 i42 = i35 + 12 | 0;
 if (!(HEAP32[i42 >> 2] | 0)) i2 = 0; else {
  i1 = 0;
  do {
   HEAP8[i38 + i1 >> 0] = i1;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i42 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if (!i41) {
  STACKTOP = i44;
  return;
 }
 i25 = i3 + 8280 | 0;
 i26 = i37 + 12 | 0;
 i27 = i37 + 16 | 0;
 i28 = (i37 | 0) == (i35 | 0);
 i29 = i35 + 16 | 0;
 i30 = i35 + 4 | 0;
 i31 = i37 + 4 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i36 >> 2] | 0;
  f13 = Math_fround(HEAPF32[i25 >> 2]);
  i10 = HEAP32[i35 >> 2] | 0;
  f14 = Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]);
  f8 = Math_fround(f14 * Math_fround(HEAPF32[i10 >> 2]));
  f15 = Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f15 * Math_fround(HEAPF32[i10 + 4 >> 2])));
  f16 = Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f16 * Math_fround(HEAPF32[i10 + 8 >> 2])));
  f17 = Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]);
  f8 = Math_fround(f17 + f8);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i34 >> 2] = f8;
  i24 = f8 < Math_fround(0.0);
  f7 = Math_fround(-f8);
  if ((i24 ? f7 : f8) < f13) {
   HEAP32[i34 >> 2] = 0;
   i3 = 0;
  }
  HEAP32[i40 >> 2] = i3;
  HEAP32[i32 >> 2] = i3;
  HEAP32[i33 >> 2] = i3;
  f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i2 >>> 0 > 1) {
   i3 = 1;
   f7 = f4;
   do {
    f8 = Math_fround(f14 * Math_fround(HEAPF32[i10 + (i3 * 12 | 0) >> 2]));
    f8 = Math_fround(f8 + Math_fround(f15 * Math_fround(HEAPF32[i10 + (i3 * 12 | 0) + 4 >> 2])));
    f8 = Math_fround(f17 + Math_fround(f8 + Math_fround(f16 * Math_fround(HEAPF32[i10 + (i3 * 12 | 0) + 8 >> 2]))));
    HEAPF32[i34 >> 2] = f8;
    i24 = f8 < Math_fround(0.0);
    f45 = Math_fround(-f8);
    if ((i24 ? f45 : f8) < f13) {
     HEAP32[i34 >> 2] = 0;
     f8 = Math_fround(0.0);
    }
    i23 = HEAP32[(f8 < f4 ? i34 : i33) >> 2] | 0;
    HEAP32[i33 >> 2] = i23;
    i24 = HEAP32[(f7 < f8 ? i34 : i32) >> 2] | 0;
    HEAP32[i32 >> 2] = i24;
    HEAPF32[i40 + (i3 << 2) >> 2] = f8;
    i3 = i3 + 1 | 0;
    f4 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   } while ((i3 | 0) != (i2 | 0));
  } else f7 = f4;
  if (f7 < Math_fround(0.0)) i43 = 36; else {
   if (f4 > Math_fround(0.0)) break;
   if ((i2 | 0) == 1) i43 = 36; else {
    HEAP32[i26 >> 2] = 0;
    i5 = i2 + -1 | 0;
    L24 : do if (!i2) i2 = 0; else {
     i24 = (i1 | 128) & 255;
     i3 = 0;
     f4 = Math_fround(HEAPF32[i40 + (i5 << 2) >> 2]);
     i23 = 0;
     i9 = i10 + (i5 * 12 | 0) | 0;
     i6 = i10 + (i5 * 12 | 0) + 4 | 0;
     i5 = i10 + (i5 * 12 | 0) + 8 | 0;
     i22 = i10;
     while (1) {
      i21 = HEAP32[i5 >> 2] | 0;
      i19 = HEAP32[i6 >> 2] | 0;
      i18 = HEAP32[i9 >> 2] | 0;
      i9 = i22 + (i23 * 12 | 0) | 0;
      f7 = Math_fround(HEAPF32[i40 + (i23 << 2) >> 2]);
      i20 = f4 > Math_fround(0.0);
      if (i20 & f7 < Math_fround(0.0)) {
       f4 = Math_fround(Math_fround(-f7) / Math_fround(f4 - f7));
       i6 = HEAP32[i26 >> 2] | 0;
       i10 = i6 + 1 | 0;
       i11 = HEAP32[i27 >> 2] | 0;
       i12 = i11 & 2147483647;
       do if (i10 >>> 0 > i12 >>> 0) {
        i5 = i11 << 1;
        i5 = (i5 | 0) == 0 ? 1 : i5;
        if (i12 >>> 0 < i5 >>> 0) if ((i11 | 0) > -1) {
         HEAP32[i27 >> 2] = i5;
         HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i5 * 12 | 0, 4, i31, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 4, i31, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i12 | 0, HEAP32[i37 >> 2] | 0, (HEAP32[i26 >> 2] | 0) * 12 | 0) | 0;
         HEAP32[i27 >> 2] = i5;
         HEAP32[i37 >> 2] = i12;
         break;
        }
       } while (0);
       HEAP32[i26 >> 2] = i10;
       i12 = HEAP32[i37 >> 2] | 0;
       f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f4);
       f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f4);
       f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f4);
       f45 = Math_fround(Math_fround(1.0) - f4);
       f16 = Math_fround(f45 * Math_fround(HEAPF32[i9 >> 2]));
       f17 = Math_fround(f45 * Math_fround(HEAPF32[i22 + (i23 * 12 | 0) + 4 >> 2]));
       f17 = Math_fround(f13 + f17);
       f45 = Math_fround(f14 + Math_fround(f45 * Math_fround(HEAPF32[i22 + (i23 * 12 | 0) + 8 >> 2])));
       HEAPF32[i12 + (i6 * 12 | 0) >> 2] = Math_fround(f15 + f16);
       HEAPF32[i12 + (i6 * 12 | 0) + 4 >> 2] = f17;
       HEAPF32[i12 + (i6 * 12 | 0) + 8 >> 2] = f45;
       HEAP8[i39 + i3 >> 0] = i24;
       i3 = i3 + 1 | 0;
      } else if (f4 < Math_fround(0.0) & f7 > Math_fround(0.0)) {
       f4 = Math_fround(Math_fround(-f4) / Math_fround(f7 - f4));
       i6 = HEAP32[i26 >> 2] | 0;
       i10 = i6 + 1 | 0;
       i11 = HEAP32[i27 >> 2] | 0;
       i12 = i11 & 2147483647;
       do if (i10 >>> 0 > i12 >>> 0) {
        i5 = i11 << 1;
        i5 = (i5 | 0) == 0 ? 1 : i5;
        if (i12 >>> 0 < i5 >>> 0) if ((i11 | 0) > -1) {
         HEAP32[i27 >> 2] = i5;
         HEAP32[i37 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i37 >> 2] | 0, i5 * 12 | 0, 4, i31, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 4, i31, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i12 | 0, HEAP32[i37 >> 2] | 0, (HEAP32[i26 >> 2] | 0) * 12 | 0) | 0;
         HEAP32[i27 >> 2] = i5;
         HEAP32[i37 >> 2] = i12;
         break;
        }
       } while (0);
       HEAP32[i26 >> 2] = i10;
       i12 = HEAP32[i37 >> 2] | 0;
       f16 = Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2]));
       f17 = Math_fround(f4 * Math_fround(HEAPF32[i22 + (i23 * 12 | 0) + 4 >> 2]));
       f45 = Math_fround(f4 * Math_fround(HEAPF32[i22 + (i23 * 12 | 0) + 8 >> 2]));
       f14 = Math_fround(Math_fround(1.0) - f4);
       f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14);
       f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14);
       f17 = Math_fround(f13 + f17);
       f45 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14) + f45);
       HEAPF32[i12 + (i6 * 12 | 0) >> 2] = Math_fround(f15 + f16);
       HEAPF32[i12 + (i6 * 12 | 0) + 4 >> 2] = f17;
       HEAPF32[i12 + (i6 * 12 | 0) + 8 >> 2] = f45;
       HEAP8[i39 + i3 >> 0] = HEAP8[i38 + i23 >> 0] | 0;
       i3 = i3 + 1 | 0;
      }
      do if (f7 <= Math_fround(0.0)) {
       __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i37, i9);
       if (i20 & f7 == Math_fround(0.0)) {
        HEAP8[i39 + i3 >> 0] = i24;
        i3 = i3 + 1 | 0;
        break;
       } else {
        HEAP8[i39 + i3 >> 0] = HEAP8[i38 + i23 >> 0] | 0;
        i3 = i3 + 1 | 0;
        break;
       }
      } while (0);
      i5 = i23 + 1 | 0;
      if ((i5 | 0) == (i2 | 0)) {
       i2 = i3;
       break L24;
      }
      i21 = i22 + (i23 * 12 | 0) + 8 | 0;
      i6 = i22 + (i23 * 12 | 0) + 4 | 0;
      f4 = f7;
      i23 = i5;
      i5 = i21;
      i22 = HEAP32[i35 >> 2] | 0;
     }
    } while (0);
    _memcpy(i38 | 0, i39 | 0, i2 | 0) | 0;
    if (!i28) {
     i6 = HEAP32[i37 >> 2] | 0;
     i2 = (HEAP32[i26 >> 2] | 0) * 12 | 0;
     i3 = (i2 | 0) / 12 | 0;
     HEAP32[i42 >> 2] = i3;
     i5 = HEAP32[i29 >> 2] | 0;
     do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i29 >> 2] = i3;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i35 >> 2] | 0, i2, 4, i30, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i35 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i30, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i35 >> 2] | 0, (HEAP32[i42 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i29 >> 2] = i3;
      HEAP32[i35 >> 2] = i2;
      break;
     } else i2 = HEAP32[i35 >> 2] | 0; while (0);
     _memcpy(i2 | 0, i6 | 0, (HEAP32[i42 >> 2] | 0) * 12 | 0) | 0;
    }
   }
  }
  if ((i43 | 0) == 36) i43 = 0;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i41 >>> 0) {
   i43 = 47;
   break;
  }
  i2 = HEAP32[i42 >> 2] | 0;
 }
 if ((i43 | 0) == 47) {
  STACKTOP = i44;
  return;
 }
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i44;
 return;
}

function __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i7, i1, i2, i19, i20) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0, f55 = f0, i56 = 0, f57 = f0, i58 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 if (i2 >>> 0 >= i19 >>> 0) return;
 i21 = HEAP32[i1 + 520 >> 2] | 0;
 i22 = i7 + 32 | 0;
 i23 = i7 + 4 | 0;
 i8 = i7 + 8 | 0;
 i9 = i7 + 12 | 0;
 i10 = i7 + 16 | 0;
 i11 = i7 + 20 | 0;
 i12 = i7 + 24 | 0;
 i13 = i7 + 28 | 0;
 i14 = HEAP32[i1 + 120 >> 2] | 0;
 i15 = HEAP32[i1 + 140 >> 2] | 0;
 i16 = HEAP32[i1 + 160 >> 2] | 0;
 i17 = HEAP32[i1 + 60 >> 2] | 0;
 i18 = i1 + 80 | 0;
 i3 = i1 + 100 | 0;
 i4 = i20 + 4 | 0;
 i5 = i20 + 8 | 0;
 i6 = i20 + 12 | 0;
 i1 = i2;
 do {
  i37 = i21 + (i1 << 2) | 0;
  f27 = Math_fround(HEAPF32[i37 >> 2]);
  f29 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  f27 = Math_fround(f27 * Math_fround(.00999999977));
  f29 = Math_fround(f29 * Math_fround(.00999999977));
  f31 = Math_fround(f31 * Math_fround(.00999999977));
  f34 = Math_fround(Math_fround(HEAPF32[i37 + 12 >> 2]) * Math_fround(.00999999977));
  f36 = Math_fround(HEAPF32[i22 >> 2]);
  f52 = Math_fround(HEAPF32[i7 >> 2]);
  f69 = Math_fround(f27 * f52);
  f66 = Math_fround(f29 * f52);
  f63 = Math_fround(f31 * f52);
  f52 = Math_fround(f34 * f52);
  f60 = Math_fround(HEAPF32[i23 >> 2]);
  f69 = Math_fround(f27 * Math_fround(f69 + f60));
  f66 = Math_fround(f29 * Math_fround(f66 + f60));
  f63 = Math_fround(f31 * Math_fround(f63 + f60));
  f60 = Math_fround(f34 * Math_fround(f52 + f60));
  f52 = Math_fround(HEAPF32[i8 >> 2]);
  f69 = Math_fround(f27 * Math_fround(f52 + f69));
  f66 = Math_fround(f29 * Math_fround(f52 + f66));
  f63 = Math_fround(f31 * Math_fround(f52 + f63));
  f60 = Math_fround(f34 * Math_fround(f52 + f60));
  f52 = Math_fround(HEAPF32[i9 >> 2]);
  f69 = Math_fround(f52 + f69);
  f66 = Math_fround(f52 + f66);
  f63 = Math_fround(f52 + f63);
  f60 = Math_fround(f52 + f60);
  f52 = Math_fround(f27 - f36);
  f39 = Math_fround(f29 - f36);
  f24 = Math_fround(f31 - f36);
  f25 = Math_fround(f34 - f36);
  f26 = Math_fround(HEAPF32[i10 >> 2]);
  f28 = Math_fround(f52 * f26);
  f30 = Math_fround(f39 * f26);
  f32 = Math_fround(f24 * f26);
  f26 = Math_fround(f25 * f26);
  f38 = Math_fround(HEAPF32[i11 >> 2]);
  f28 = Math_fround(f52 * Math_fround(f28 + f38));
  f30 = Math_fround(f39 * Math_fround(f30 + f38));
  f32 = Math_fround(f24 * Math_fround(f32 + f38));
  f38 = Math_fround(f25 * Math_fround(f26 + f38));
  f26 = Math_fround(HEAPF32[i12 >> 2]);
  f28 = Math_fround(f52 * Math_fround(f26 + f28));
  f30 = Math_fround(f39 * Math_fround(f26 + f30));
  f32 = Math_fround(f24 * Math_fround(f26 + f32));
  f38 = Math_fround(f25 * Math_fround(f26 + f38));
  f26 = Math_fround(HEAPF32[i13 >> 2]);
  f28 = Math_fround(f26 + f28);
  f30 = Math_fround(f26 + f30);
  f32 = Math_fround(f26 + f32);
  f38 = Math_fround(f26 + f38);
  f69 = f27 > f36 ? f28 : f69;
  f66 = f29 > f36 ? f30 : f66;
  f63 = f31 > f36 ? f32 : f63;
  f60 = f34 > f36 ? f38 : f60;
  i37 = i14 + (i1 << 2) | 0;
  f38 = Math_fround(HEAPF32[i37 >> 2]);
  f36 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i37 + 12 >> 2]);
  i37 = i15 + (i1 << 2) | 0;
  f31 = Math_fround(HEAPF32[i37 >> 2]);
  f30 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  f28 = Math_fround(HEAPF32[i37 + 12 >> 2]);
  i37 = i16 + (i1 << 2) | 0;
  f27 = Math_fround(HEAPF32[i37 >> 2]);
  f26 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  f24 = Math_fround(HEAPF32[i37 + 12 >> 2]);
  i37 = i17 + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i37 >> 2]);
  i35 = i37 + 4 | 0;
  f52 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i37 + 8 | 0;
  f51 = Math_fround(HEAPF32[i33 >> 2]);
  i2 = i37 + 12 | 0;
  f50 = Math_fround(HEAPF32[i2 >> 2]);
  i58 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f49 = Math_fround(HEAPF32[i58 >> 2]);
  f48 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f47 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f46 = Math_fround(HEAPF32[i58 + 12 >> 2]);
  i58 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i58 >> 2]);
  f62 = Math_fround(HEAPF32[i58 + 4 >> 2]);
  f65 = Math_fround(HEAPF32[i58 + 8 >> 2]);
  f39 = Math_fround(f38 + f39);
  f52 = Math_fround(f36 + f52);
  f51 = Math_fround(f34 + f51);
  f50 = Math_fround(f32 + f50);
  f49 = Math_fround(f31 + f49);
  f48 = Math_fround(f30 + f48);
  f47 = Math_fround(f29 + f47);
  f46 = Math_fround(f28 + f46);
  f59 = Math_fround(f27 + f59);
  f62 = Math_fround(f26 + f62);
  f65 = Math_fround(f25 + f65);
  f68 = Math_fround(f24 + Math_fround(HEAPF32[i58 + 12 >> 2]));
  f61 = Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f49 * f49)) + Math_fround(f59 * f59));
  f64 = Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f48 * f48)) + Math_fround(f62 * f62));
  f67 = Math_fround(Math_fround(Math_fround(f51 * f51) + Math_fround(f47 * f47)) + Math_fround(f65 * f65));
  f70 = Math_fround(Math_fround(Math_fround(f50 * f50) + Math_fround(f46 * f46)) + Math_fround(f68 * f68));
  f45 = Math_fround(Math_sqrt(Math_fround(f61)));
  f57 = Math_fround(Math_fround(1.0) / f45);
  f44 = Math_fround(Math_sqrt(Math_fround(f64)));
  f55 = Math_fround(Math_fround(1.0) / f44);
  f43 = Math_fround(Math_sqrt(Math_fround(f67)));
  f53 = Math_fround(Math_fround(1.0) / f43);
  f40 = Math_fround(Math_sqrt(Math_fround(f70)));
  f41 = Math_fround(Math_fround(1.0) / f40);
  f39 = Math_fround(f39 * f57);
  f52 = Math_fround(f52 * f55);
  f51 = Math_fround(f51 * f53);
  f50 = Math_fround(f50 * f41);
  f49 = Math_fround(f49 * f57);
  f48 = Math_fround(f48 * f55);
  f47 = Math_fround(f47 * f53);
  f46 = Math_fround(f46 * f41);
  f57 = Math_fround(f59 * f57);
  f55 = Math_fround(f62 * f55);
  f53 = Math_fround(f65 * f53);
  f41 = Math_fround(f68 * f41);
  i58 = f61 > Math_fround(9.99999974e-06);
  i56 = f64 > Math_fround(9.99999974e-06);
  i54 = f67 > Math_fround(9.99999974e-06);
  i42 = f70 > Math_fround(9.99999974e-06);
  f70 = Math_fround((f45 > Math_fround(0.0) & 1) - (f45 < Math_fround(0.0) & 1) | 0);
  f67 = Math_fround((f44 > Math_fround(0.0) & 1) - (f44 < Math_fround(0.0) & 1) | 0);
  f64 = Math_fround((f43 > Math_fround(0.0) & 1) - (f43 < Math_fround(0.0) & 1) | 0);
  f61 = Math_fround((f40 > Math_fround(0.0) & 1) - (f40 < Math_fround(0.0) & 1) | 0);
  f45 = Math_fround(Math_abs(Math_fround(f45)));
  f44 = Math_fround(Math_abs(Math_fround(f44)));
  f43 = Math_fround(Math_abs(Math_fround(f43)));
  f40 = Math_fround(Math_abs(Math_fround(f40)));
  f68 = Math_fround(f69 - f45);
  f65 = Math_fround(f66 - f44);
  f62 = Math_fround(f63 - f43);
  f59 = Math_fround(f60 - f40);
  f68 = Math_fround(f68 * Math_fround(HEAPF32[i20 >> 2]));
  f65 = Math_fround(f65 * Math_fround(HEAPF32[i4 >> 2]));
  f62 = Math_fround(f62 * Math_fround(HEAPF32[i5 >> 2]));
  f68 = Math_fround(f45 + f68);
  f65 = Math_fround(f44 + f65);
  f62 = Math_fround(f43 + f62);
  f59 = Math_fround(f40 + Math_fround(f59 * Math_fround(HEAPF32[i6 >> 2])));
  f45 = Math_fround(f70 * (f45 > f69 ? f68 : f45));
  f44 = Math_fround(f67 * (f44 > f66 ? f65 : f44));
  f43 = Math_fround(f64 * (f43 > f63 ? f62 : f43));
  f40 = Math_fround(f61 * (f40 > f60 ? f59 : f40));
  f39 = Math_fround((i58 ? f39 : Math_fround(0.0)) * f45);
  f52 = Math_fround((i56 ? f52 : Math_fround(0.0)) * f44);
  f51 = Math_fround((i54 ? f51 : Math_fround(0.0)) * f43);
  f50 = Math_fround((i42 ? f50 : Math_fround(0.0)) * f40);
  f49 = Math_fround((i58 ? f49 : Math_fround(0.0)) * f45);
  f48 = Math_fround((i56 ? f48 : Math_fround(0.0)) * f44);
  f47 = Math_fround((i54 ? f47 : Math_fround(0.0)) * f43);
  f46 = Math_fround((i42 ? f46 : Math_fround(0.0)) * f40);
  f45 = Math_fround((i58 ? f57 : Math_fround(0.0)) * f45);
  f44 = Math_fround((i56 ? f55 : Math_fround(0.0)) * f44);
  f43 = Math_fround((i54 ? f53 : Math_fround(0.0)) * f43);
  f36 = Math_fround(f52 - f36);
  f34 = Math_fround(f51 - f34);
  f32 = Math_fround(f50 - f32);
  f31 = Math_fround(f49 - f31);
  f30 = Math_fround(f48 - f30);
  f29 = Math_fround(f47 - f29);
  f28 = Math_fround(f46 - f28);
  f27 = Math_fround(f45 - f27);
  f26 = Math_fround(f44 - f26);
  f25 = Math_fround(f43 - f25);
  f24 = Math_fround(Math_fround((i42 ? f41 : Math_fround(0.0)) * f40) - f24);
  HEAPF32[i37 >> 2] = Math_fround(f39 - f38);
  HEAPF32[i35 >> 2] = f36;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i2 >> 2] = f32;
  i2 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f31;
  HEAPF32[i2 + 4 >> 2] = f30;
  HEAPF32[i2 + 8 >> 2] = f29;
  HEAPF32[i2 + 12 >> 2] = f28;
  i2 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f27;
  HEAPF32[i2 + 4 >> 2] = f26;
  HEAPF32[i2 + 8 >> 2] = f25;
  HEAPF32[i2 + 12 >> 2] = f24;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i19 >>> 0);
 return;
}

function __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15;
 i8 = HEAP32[i11 >> 2] | 0;
 i13 = i12 + 84 | 0;
 HEAP16[i13 >> 1] = i8;
 switch (i8 | 0) {
 case 0:
  {
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
   __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i12 + 176 | 0, i9);
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
   __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i12 + 88 | 0, i9);
   f16 = Math_fround(HEAPF32[i11 + 20 >> 2]);
   HEAPF32[i12 + 80 >> 2] = f16;
   HEAP8[i12 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i12, i12 + 88 | 0, f16, HEAP16[i13 >> 1] | 0) | 0) & 1;
   STACKTOP = i15;
   return;
  }
 case 1:
  {
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
   __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i12 + 176 | 0, i9);
   i1 = HEAP32[i11 + 12 >> 2] | 0;
   if (!i1) {
    i1 = i12 + 88 | 0;
    i14 = 14;
   } else {
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = i12 + 88 | 0;
    if (!i8) i14 = 14; else {
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
     i5 = i12 + 116 | 0;
     i10 = i8 + 28 | 0;
     HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
     HEAP32[i5 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
     i5 = i12 + 144 | 0;
     if ((i8 | 0) != (i1 | 0)) {
      i6 = HEAP32[i8 + 56 >> 2] | 0;
      i7 = i12 + 156 | 0;
      i1 = HEAP32[i8 + 68 >> 2] << 4;
      i2 = i1 >> 4;
      HEAP32[i7 >> 2] = i2;
      i3 = i12 + 160 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i3 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i12 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i5 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i12 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
       HEAP32[i3 >> 2] = i2;
       HEAP32[i5 >> 2] = i1;
       break;
      } else i1 = HEAP32[i5 >> 2] | 0; while (0);
      _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     }
     i10 = i12 + 164 | 0;
     i9 = i8 + 76 | 0;
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    }
   }
   if ((i14 | 0) == 14) {
    HEAPF32[i10 >> 2] = Math_fround(1.0);
    __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
    __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i1, i9);
   }
   f16 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   HEAPF32[i12 + 80 >> 2] = f16;
   HEAP8[i12 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i12, i12 + 88 | 0, f16, HEAP16[i13 >> 1] | 0) | 0) & 1;
   STACKTOP = i15;
   return;
  }
 case 2:
  {
   i1 = HEAP32[i11 + 8 >> 2] | 0;
   if (!i1) {
    i1 = i12 + 176 | 0;
    i14 = 27;
   } else {
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = i12 + 176 | 0;
    if (!i8) i14 = 27; else {
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
     i5 = i12 + 204 | 0;
     i7 = i8 + 28 | 0;
     HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
     i5 = i12 + 232 | 0;
     if ((i8 | 0) != (i1 | 0)) {
      i6 = HEAP32[i8 + 56 >> 2] | 0;
      i7 = i12 + 244 | 0;
      i1 = HEAP32[i8 + 68 >> 2] << 4;
      i2 = i1 >> 4;
      HEAP32[i7 >> 2] = i2;
      i3 = i12 + 248 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i3 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i12 + 236 | 0, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i5 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i12 + 236 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
       HEAP32[i3 >> 2] = i2;
       HEAP32[i5 >> 2] = i1;
       break;
      } else i1 = HEAP32[i5 >> 2] | 0; while (0);
      _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     }
     i7 = i12 + 252 | 0;
     i8 = i8 + 76 | 0;
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    }
   }
   if ((i14 | 0) == 27) {
    HEAPF32[i10 >> 2] = Math_fround(1.0);
    __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
    __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i1, i9);
   }
   i1 = HEAP32[i11 + 12 >> 2] | 0;
   if (!i1) {
    i1 = i12 + 88 | 0;
    i14 = 39;
   } else {
    i8 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = i12 + 88 | 0;
    if (!i8) i14 = 39; else {
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
     i5 = i12 + 116 | 0;
     i10 = i8 + 28 | 0;
     HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
     HEAP32[i5 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
     HEAP32[i5 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
     i5 = i12 + 144 | 0;
     if ((i8 | 0) != (i1 | 0)) {
      i6 = HEAP32[i8 + 56 >> 2] | 0;
      i7 = i12 + 156 | 0;
      i1 = HEAP32[i8 + 68 >> 2] << 4;
      i2 = i1 >> 4;
      HEAP32[i7 >> 2] = i2;
      i3 = i12 + 160 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i3 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i12 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i5 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i12 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
       HEAP32[i3 >> 2] = i2;
       HEAP32[i5 >> 2] = i1;
       break;
      } else i1 = HEAP32[i5 >> 2] | 0; while (0);
      _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     }
     i10 = i12 + 164 | 0;
     i9 = i8 + 76 | 0;
     HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    }
   }
   if ((i14 | 0) == 39) {
    HEAPF32[i10 >> 2] = Math_fround(1.0);
    __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
    __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i1, i9);
   }
   f16 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   HEAPF32[i12 + 80 >> 2] = f16;
   HEAP8[i12 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i12, i12 + 88 | 0, f16, HEAP16[i13 >> 1] | 0) | 0) & 1;
   STACKTOP = i15;
   return;
  }
 default:
  {
   i14 = i11 + 20 | 0;
   f17 = Math_fround(HEAPF32[i11 + 16 >> 2]);
   f16 = Math_fround(HEAPF32[i14 >> 2]);
   f16 = f17 < f16 ? f16 : f17;
   i11 = f16 < Math_fround(.00100000005);
   f16 = i11 ? Math_fround(.00100000005) : f16;
   HEAPF32[i10 >> 2] = Math_fround(f17 / f16);
   __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
   __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i12 + 176 | 0, i9);
   HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) / f16);
   __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i10);
   __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i12 + 88 | 0, i9);
   HEAPF32[i12 + 80 >> 2] = f16;
   HEAP8[i12 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i12, i12 + 88 | 0, f16, HEAP16[i13 >> 1] | 0) | 0) & 1;
   STACKTOP = i15;
   return;
  }
 }
}

function __Z13StoreLineDataP15LineBuilderDataRfRKN4math8float4x4EPKNS2_14float3_storageE(i32, i33, i5, i6) {
 i32 = i32 | 0;
 i33 = i33 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 HEAPF32[i33 >> 2] = Math_fround(0.0);
 i30 = i32 + 24 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 i7 = (i1 | 0) == 0;
 if (i7) i1 = 0; else {
  i16 = HEAP32[i32 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f4 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f8 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + 28 >> 2]);
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f14 = Math_fround(HEAPF32[i5 + 48 >> 2]);
  f15 = Math_fround(HEAPF32[i5 + 52 >> 2]);
  f25 = Math_fround(HEAPF32[i5 + 56 >> 2]);
  f26 = Math_fround(HEAPF32[i5 + 60 >> 2]);
  f27 = Math_fround(HEAPF32[i5 + 32 >> 2]);
  f28 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  f29 = Math_fround(HEAPF32[i5 + 40 >> 2]);
  f2 = Math_fround(HEAPF32[i5 + 44 >> 2]);
  i5 = 0;
  do {
   i24 = i6 + (i5 * 12 | 0) | 0;
   f38 = Math_fround(HEAPF32[i24 >> 2]);
   f39 = Math_fround(HEAPF32[i24 + 4 >> 2]);
   f37 = Math_fround(HEAPF32[i24 + 8 >> 2]);
   f36 = Math_fround(Math_fround(Math_fround(f39 * f4) + Math_fround(f38 * f11)) + Math_fround(f15 + Math_fround(f37 * f28)));
   f35 = Math_fround(Math_fround(Math_fround(f39 * f8) + Math_fround(f38 * f12)) + Math_fround(f25 + Math_fround(f37 * f29)));
   f34 = Math_fround(Math_fround(Math_fround(f39 * f9) + Math_fround(f38 * f13)) + Math_fround(f26 + Math_fround(f37 * f2)));
   HEAPF32[i16 + (i5 << 4) >> 2] = Math_fround(Math_fround(Math_fround(f39 * f3) + Math_fround(f38 * f10)) + Math_fround(f14 + Math_fround(f37 * f27)));
   HEAPF32[i16 + (i5 << 4) + 4 >> 2] = f36;
   HEAPF32[i16 + (i5 << 4) + 8 >> 2] = f35;
   HEAPF32[i16 + (i5 << 4) + 12 >> 2] = f34;
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
  if (i7) i1 = 0; else {
   i23 = i32 + 4 | 0;
   i24 = i32 + 8 | 0;
   i22 = 0;
   do {
    i19 = (i22 | 0) < 1 ? 1 : i22;
    i16 = i19 + -1 | 0;
    i21 = HEAP32[i32 >> 2] | 0;
    f35 = Math_fround(HEAPF32[i21 + (i16 << 4) >> 2]);
    f36 = Math_fround(HEAPF32[i21 + (i16 << 4) + 4 >> 2]);
    f37 = Math_fround(HEAPF32[i21 + (i16 << 4) + 8 >> 2]);
    f2 = Math_fround(HEAPF32[i21 + (i16 << 4) + 12 >> 2]);
    i16 = i21 + (i19 << 4) | 0;
    f38 = Math_fround(HEAPF32[i16 >> 2]);
    i17 = i21 + (i19 << 4) + 4 | 0;
    f39 = Math_fround(HEAPF32[i17 >> 2]);
    i18 = i21 + (i19 << 4) + 8 | 0;
    f3 = Math_fround(HEAPF32[i18 >> 2]);
    f38 = Math_fround(f35 - f38);
    f39 = Math_fround(f36 - f39);
    f3 = Math_fround(f37 - f3);
    f2 = Math_fround(f2 - Math_fround(HEAPF32[i21 + (i19 << 4) + 12 >> 2]));
    i7 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)));
    f3 = Math_fround(Math_sqrt(Math_fround(f2)));
    i20 = (HEAP32[i23 >> 2] | 0) + (i22 << 2) | 0;
    if ((i22 | 0) > 0) {
     HEAPF32[i20 >> 2] = f3;
     HEAPF32[i33 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i33 >> 2]));
    } else HEAP32[i20 >> 2] = 0;
    do if (f2 < Math_fround(9.99999997e-07)) {
     if (i19 >>> 0 < (i1 + -1 | 0) >>> 0) {
      f35 = Math_fround(HEAPF32[i16 >> 2]);
      f36 = Math_fround(HEAPF32[i17 >> 2]);
      f39 = Math_fround(HEAPF32[i18 >> 2]);
      i7 = i19 + 1 | 0;
      f37 = Math_fround(HEAPF32[i21 + (i7 << 4) >> 2]);
      f38 = Math_fround(HEAPF32[i21 + (i7 << 4) + 4 >> 2]);
      f37 = Math_fround(f35 - f37);
      f38 = Math_fround(f36 - f38);
      f39 = Math_fround(f39 - Math_fround(HEAPF32[i21 + (i7 << 4) + 8 >> 2]));
      i7 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
      i31 = 16;
      break;
     }
     if (!i22) {
      i7 = 1065353216;
      i6 = 0;
      i5 = 0;
      i31 = 16;
     } else {
      i1 = HEAP32[i24 >> 2] | 0;
      i20 = i1 + (i22 + -1 << 3) | 0;
      i21 = HEAP32[i20 + 4 >> 2] | 0;
      i1 = i1 + (i22 << 3) | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = i21;
      i1 = HEAP32[i30 >> 2] | 0;
     }
    } else i31 = 16; while (0);
    if ((i31 | 0) == 16) {
     i31 = 0;
     f34 = Math_fround(HEAPF32[i21 + (i22 << 4) >> 2]);
     f37 = Math_fround(HEAPF32[i21 + (i22 << 4) + 4 >> 2]);
     f36 = Math_fround(HEAPF32[i21 + (i22 << 4) + 8 >> 2]);
     f39 = Math_fround(Math_abs(Math_fround(f34)));
     f35 = Math_fround(Math_abs(Math_fround(f37)));
     f38 = Math_fround(Math_abs(Math_fround(f36)));
     i19 = f39 > Math_fround(.00999999977);
     f39 = i19 ? f39 : Math_fround(.00999999977);
     i19 = f35 > Math_fround(.00999999977);
     f35 = i19 ? f35 : Math_fround(.00999999977);
     i19 = f38 > Math_fround(.00999999977);
     f38 = i19 ? f38 : Math_fround(.00999999977);
     i19 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
     i20 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
     i21 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
     f39 = Math_fround(f39 * (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f35 = Math_fround(f35 * (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f38 = Math_fround(f38 * (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f36 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f37 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f35 = Math_fround(f37 * f35);
     f36 = Math_fround(f36 * f38);
     f38 = Math_fround(f35 - Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f38));
     f39 = Math_fround(f36 - Math_fround(f37 * f39));
     f37 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39)) + Math_fround(0.0)))));
     f39 = Math_fround(f37 * f39);
     i21 = (HEAP32[i24 >> 2] | 0) + (i22 << 3) | 0;
     HEAPF32[i21 >> 2] = Math_fround(f37 * f38);
     HEAPF32[i21 + 4 >> 2] = f39;
    }
    i22 = i22 + 1 | 0;
   } while (i22 >>> 0 < i1 >>> 0);
   if ((i1 | 0) == 2) {
    f39 = Math_fround(HEAPF32[i33 >> 2]);
    f39 = Math_fround(_fmaxf(f39, Math_fround(9.99999997e-07)));
    HEAPF32[i33 >> 2] = f39;
    return;
   }
  }
 }
 i16 = HEAP32[i32 + 8 >> 2] | 0;
 i7 = HEAP32[i32 + 12 >> 2] | 0;
 i6 = i1 + -2 | 0;
 i1 = 0;
 do {
  i5 = i1;
  i1 = i1 + 1 | 0;
  i32 = i16 + (i1 << 3) | 0;
  f4 = Math_fround(HEAPF32[i32 >> 2]);
  f12 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f3 = Math_fround(-f4);
  f2 = Math_fround(-f12);
  i32 = i16 + (i5 + 2 << 3) | 0;
  f10 = Math_fround(HEAPF32[i32 >> 2]);
  f15 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f8 = Math_fround(-f10);
  f9 = Math_fround(-f15);
  f14 = Math_fround(f10 - f4);
  f15 = Math_fround(f15 - f12);
  f15 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(0.0)) * Math_fround(50.0))))));
  f14 = Math_fround(f8 - f4);
  f13 = Math_fround(f9 - f12);
  f13 = Math_fround(_fminf(f15, Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(0.0)) * Math_fround(50.0))))))));
  f14 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f3 / f12), Math_fround(-1.0e5))), Math_fround(1.0e5)));
  f15 = Math_fround(f2 - Math_fround(f14 * f3));
  f10 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f10 / f9), Math_fround(-1.0e5))), Math_fround(1.0e5)));
  f11 = Math_fround(f14 - f10);
  if (!(Math_fround(Math_abs(Math_fround(f11))) < Math_fround(9.99999974e-06))) {
   f2 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f10 * f8)) - f15) / f11);
   f3 = Math_fround(Math_fround(f13 * Math_fround(f4 + f2)) - f4);
   f2 = Math_fround(Math_fround(f13 * Math_fround(f12 + Math_fround(f15 + Math_fround(f14 * f2)))) - f12);
  }
  f4 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)) + Math_fround(0.0));
  if (f4 > Math_fround(16.0)) {
   f39 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
   f3 = Math_fround(Math_fround(f3 * f39) * Math_fround(4.0));
   f2 = Math_fround(Math_fround(f2 * f39) * Math_fround(4.0));
  }
  i32 = i7 + (i5 << 3) | 0;
  HEAPF32[i32 >> 2] = f3;
  HEAPF32[i32 + 4 >> 2] = f2;
 } while (i1 >>> 0 < i6 >>> 0);
 f39 = Math_fround(HEAPF32[i33 >> 2]);
 f39 = Math_fround(_fmaxf(f39, Math_fround(9.99999997e-07)));
 HEAPF32[i33 >> 2] = f39;
 return;
}

function _rgb_ycc_convert(i1, i7, i13, i8, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 switch (HEAP32[i1 + 40 >> 2] | 0) {
 case 6:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 >> 0] | 0;
     i16 = HEAPU8[i2 + 1 >> 0] | 0;
     i14 = HEAPU8[i2 + 2 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i16 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i14 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i16 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i14 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i16 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i14 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i4 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 >> 0] | 0;
     i14 = HEAPU8[i2 + 1 >> 0] | 0;
     i16 = HEAPU8[i2 + 2 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 + 2 >> 0] | 0;
     i14 = HEAPU8[i2 + 1 >> 0] | 0;
     i16 = HEAPU8[i2 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 + 2 >> 0] | 0;
     i14 = HEAPU8[i2 + 1 >> 0] | 0;
     i16 = HEAPU8[i2 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 + 3 >> 0] | 0;
     i14 = HEAPU8[i2 + 2 >> 0] | 0;
     i16 = HEAPU8[i2 + 1 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 + 1 >> 0] | 0;
     i14 = HEAPU8[i2 + 2 >> 0] | 0;
     i16 = HEAPU8[i2 + 3 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i12 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i13 + 4 | 0;
   i11 = i13 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     i15 = HEAPU8[i2 >> 0] | 0;
     i14 = HEAPU8[i2 + 1 >> 0] | 0;
     i16 = HEAPU8[i2 + 2 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 256) << 2) >> 2] | 0) + (HEAP32[i12 + (i15 << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i5 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1024) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 768) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
     HEAP8[i6 + i1 >> 0] = ((HEAP32[i12 + ((i14 | 1536) << 2) >> 2] | 0) + (HEAP32[i12 + ((i15 | 1280) << 2) >> 2] | 0) + (HEAP32[i12 + ((i16 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN5physx2Sc8ClothSim15addCollisionBoxEPKNS0_8ShapeSimE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 184 | 0;
 i1 = i15 + 156 | 0;
 i2 = i15 + 128 | 0;
 i11 = i15 + 32 | 0;
 i5 = i15 + 24 | 0;
 i10 = i15 + 16 | 0;
 i6 = i15 + 8 | 0;
 i7 = i13 + 92 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i13 + 52 >> 2] | 0;
 i3 = i13 + 96 | 0;
 i4 = (HEAP32[i9 + 80 >> 2] | 0) + i8 + ((HEAP32[i3 >> 2] | 0) * 6 | 0) | 0;
 if ((i4 + 6 | 0) >>> 0 > 32) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 342, gb + 719594 | 0, i15);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i17 = HEAP32[i13 + 88 >> 2] | 0;
 i16 = HEAP32[i13 + 84 >> 2] | 0;
 i18 = HEAP32[i14 + 28 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i1, i9);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i2, i14);
 f28 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f31 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f30 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f37 = Math_fround(f37 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f33 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f33 = Math_fround(f33 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f27 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f37 = Math_fround(f37 * Math_fround(2.0));
 f33 = Math_fround(f33 * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f27 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f42 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f24 = Math_fround(Math_fround(Math_fround(f37 * f28) + Math_fround(f33 * f20)) + Math_fround(f27 * f31));
 f23 = Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f42 * f37) + Math_fround(f30 * Math_fround(Math_fround(f27 * f20) - Math_fround(f33 * f31)))));
 f19 = Math_fround(Math_fround(f24 * f20) + Math_fround(Math_fround(f42 * f33) + Math_fround(f30 * Math_fround(Math_fround(f37 * f31) - Math_fround(f27 * f28)))));
 f24 = Math_fround(Math_fround(Math_fround(f42 * f27) + Math_fround(f30 * Math_fround(Math_fround(f33 * f28) - Math_fround(f37 * f20)))) + Math_fround(f24 * f31));
 f37 = Math_fround(HEAPF32[i2 >> 2]);
 f33 = Math_fround(f30 * f37);
 f27 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f27 * f28));
 f42 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f42 * f20));
 f25 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f33 = Math_fround(f33 - Math_fround(f25 * f31));
 f21 = Math_fround(Math_fround(Math_fround(f37 * f31) + Math_fround(Math_fround(f27 * f20) + Math_fround(f30 * f25))) - Math_fround(f42 * f28));
 f26 = Math_fround(Math_fround(Math_fround(f25 * f28) + Math_fround(Math_fround(f27 * f31) + Math_fround(f30 * f42))) - Math_fround(f37 * f20));
 f31 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f27) - Math_fround(f37 * f28)) - Math_fround(f25 * f20)) - Math_fround(f42 * f31));
 f42 = Math_fround(HEAPF32[i18 + 72 >> 2]);
 f20 = Math_fround(HEAPF32[i18 + 76 >> 2]);
 f25 = Math_fround(HEAPF32[i18 + 80 >> 2]);
 f42 = Math_fround(-f42);
 f28 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
 f37 = Math_fround(f33 * Math_fround(2.0));
 f27 = Math_fround(f21 * Math_fround(0.0));
 f30 = Math_fround(f26 * Math_fround(0.0));
 f44 = Math_fround(f30 + Math_fround(f37 + f27));
 f35 = Math_fround(f28 * Math_fround(2.0));
 f43 = Math_fround(f31 * Math_fround(f27 - f30));
 f41 = Math_fround(Math_fround(f33 * f44) + Math_fround(f35 + f43));
 f32 = Math_fround(f28 * Math_fround(0.0));
 f36 = Math_fround(f26 * Math_fround(2.0));
 f39 = Math_fround(f33 * Math_fround(0.0));
 f34 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f36 - f39))) + Math_fround(f21 * f44));
 f38 = Math_fround(f21 * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f39 - f38))) + Math_fround(f26 * f44));
 f29 = Math_fround(f42 - Math_fround(Math_fround(f24 * f44) + Math_fround(Math_fround(f23 * f41) + Math_fround(f19 * f34))));
 HEAPF32[i11 >> 2] = f41;
 HEAPF32[i11 + 4 >> 2] = f34;
 HEAPF32[i11 + 8 >> 2] = f44;
 HEAPF32[i11 + 12 >> 2] = f29;
 f29 = Math_fround(f33 * Math_fround(-2.0));
 f44 = Math_fround(f30 + Math_fround(f29 + f27));
 f28 = Math_fround(f28 * Math_fround(-2.0));
 f43 = Math_fround(Math_fround(f33 * f44) + Math_fround(f28 + f43));
 f34 = Math_fround(f26 * Math_fround(-2.0));
 f41 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f34 - f39))) + Math_fround(f21 * f44));
 f22 = Math_fround(f21 * Math_fround(-2.0));
 f44 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f39 - f22))) + Math_fround(f26 * f44));
 f42 = Math_fround(f42 - Math_fround(Math_fround(f24 * f44) + Math_fround(Math_fround(f23 * f43) + Math_fround(f19 * f41))));
 HEAPF32[i11 + 16 >> 2] = f43;
 HEAPF32[i11 + 20 >> 2] = f41;
 HEAPF32[i11 + 24 >> 2] = f44;
 HEAPF32[i11 + 28 >> 2] = f42;
 f20 = Math_fround(-f20);
 f42 = Math_fround(f30 + Math_fround(f39 + f38));
 f44 = Math_fround(Math_fround(f33 * f42) + Math_fround(f32 + Math_fround(f31 * Math_fround(f27 - f36))));
 f41 = Math_fround(f31 * Math_fround(f30 - f39));
 f43 = Math_fround(Math_fround(f35 + f41) + Math_fround(f21 * f42));
 f42 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f37 - f27))) + Math_fround(f26 * f42));
 f40 = Math_fround(f20 - Math_fround(Math_fround(f24 * f42) + Math_fround(Math_fround(f23 * f44) + Math_fround(f19 * f43))));
 HEAPF32[i11 + 32 >> 2] = f44;
 HEAPF32[i11 + 36 >> 2] = f43;
 HEAPF32[i11 + 40 >> 2] = f42;
 HEAPF32[i11 + 44 >> 2] = f40;
 f40 = Math_fround(f30 + Math_fround(f39 + f22));
 f42 = Math_fround(Math_fround(f33 * f40) + Math_fround(f32 + Math_fround(f31 * Math_fround(f27 - f34))));
 f41 = Math_fround(Math_fround(f28 + f41) + Math_fround(f21 * f40));
 f40 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f29 - f27))) + Math_fround(f26 * f40));
 f20 = Math_fround(f20 - Math_fround(Math_fround(f24 * f40) + Math_fround(Math_fround(f23 * f42) + Math_fround(f19 * f41))));
 HEAPF32[i11 + 48 >> 2] = f42;
 HEAPF32[i11 + 52 >> 2] = f41;
 HEAPF32[i11 + 56 >> 2] = f40;
 HEAPF32[i11 + 60 >> 2] = f20;
 f25 = Math_fround(-f25);
 f20 = Math_fround(f39 + f27);
 f36 = Math_fround(f36 + f20);
 f38 = Math_fround(Math_fround(f33 * f36) + Math_fround(f32 + Math_fround(f31 * Math_fround(f38 - f30))));
 f37 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f30 - f37))) + Math_fround(f21 * f36));
 f27 = Math_fround(f31 * Math_fround(f39 - f27));
 f36 = Math_fround(Math_fround(f35 + f27) + Math_fround(f26 * f36));
 f35 = Math_fround(f25 - Math_fround(Math_fround(f24 * f36) + Math_fround(Math_fround(f23 * f38) + Math_fround(f19 * f37))));
 HEAPF32[i11 + 64 >> 2] = f38;
 HEAPF32[i11 + 68 >> 2] = f37;
 HEAPF32[i11 + 72 >> 2] = f36;
 HEAPF32[i11 + 76 >> 2] = f35;
 f20 = Math_fround(f34 + f20);
 f22 = Math_fround(Math_fround(f33 * f20) + Math_fround(f32 + Math_fround(f31 * Math_fround(f22 - f30))));
 f21 = Math_fround(Math_fround(f32 + Math_fround(f31 * Math_fround(f30 - f29))) + Math_fround(f21 * f20));
 f20 = Math_fround(Math_fround(f28 + f27) + Math_fround(f26 * f20));
 f19 = Math_fround(f25 - Math_fround(Math_fround(f24 * f20) + Math_fround(Math_fround(f23 * f22) + Math_fround(f19 * f21))));
 HEAPF32[i11 + 80 >> 2] = f22;
 HEAPF32[i11 + 84 >> 2] = f21;
 HEAPF32[i11 + 88 >> 2] = f20;
 HEAPF32[i11 + 92 >> 2] = f19;
 i1 = i9 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i5 >> 2] = i11;
 HEAP32[i5 + 4 >> 2] = i11 + 96;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 mftCall_viiii(i18 | 0, i2 | 0, i12 | 0, i4 | 0, i4 | 0);
 i5 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i9 + 84 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = 63 << i4;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0;
 HEAP32[i6 >> 2] = i10;
 HEAP32[i6 + 4 >> 2] = i10 + 4;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 mftCall_viiii(i2 | 0, i1 | 0, i12 | 0, i5 | 0, i5 | 0);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i5 + 1;
 i5 = i17 + i8 + i16 + i5 | 0;
 i1 = i13 + 116 | 0;
 HEAP32[i12 >> 2] = 0;
 i3 = i13 + 120 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i13 + 124 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i12) | 0;
  i4 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i18 = HEAP32[i4 >> 2] | 0;
  HEAP32[i18 + (i1 << 2) >> 2] = HEAP32[i18 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i18 = i1;
   i1 = i2;
   i2 = i18;
  } else break;
 }
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = i14;
 i18 = 1;
 STACKTOP = i15;
 return i18 | 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager20ProcessEventQueueJobEPNS0_14CloudEventInfoE(i16, i14) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i21;
 i19 = i21 + 24 | 0;
 i20 = i21 + 8 | 0;
 i15 = i16 + 552 | 0;
 if ((HEAP32[i15 >> 2] | 0) == 4) if (!(__ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv(i16) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i17 = HEAP32[i15 >> 2] | 0;
 i18 = i16 + 40 + (i17 << 7) | 0;
 i12 = i16 + 40 + (i17 << 7) + 36 | 0;
 HEAP32[i20 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i13 = HEAP32[i14 + 40 >> 2] | 0;
 switch (i13 | 0) {
 case 2:
  {
   __Z11IntToStringi(i19, 2);
   i5 = HEAP8[i19 + 11 >> 0] | 0;
   i6 = i5 << 24 >> 24 < 0;
   i4 = i6 ? HEAP32[i19 >> 2] | 0 : i19;
   i5 = i6 ? HEAP32[i19 + 4 >> 2] | 0 : i5 & 255;
   i6 = i20 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i20 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   do if (i5 >>> 0 > i3 >>> 0) {
    i11 = i2 ? HEAP32[i20 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
   } else {
    i1 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
    if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i20 + 4 >> 2] = i5;
     break;
    } else {
     HEAP8[i6 >> 0] = i5;
     break;
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
   break;
  }
 case 3:
  {
   i1 = i14 + 16 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i2 >> 2] = 3;
   HEAP32[i2 + 4 >> 2] = i1;
   __Z6FormatPKcz(i19, gb + 1047177 | 0, i2);
   i5 = HEAP8[i19 + 11 >> 0] | 0;
   i6 = i5 << 24 >> 24 < 0;
   i4 = i6 ? HEAP32[i19 >> 2] | 0 : i19;
   i5 = i6 ? HEAP32[i19 + 4 >> 2] | 0 : i5 & 255;
   i6 = i20 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i20 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   do if (i5 >>> 0 > i3 >>> 0) {
    i11 = i2 ? HEAP32[i20 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i20, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
   } else {
    i1 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
    if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i20 + 4 >> 2] = i5;
     break;
    } else {
     HEAP8[i6 >> 0] = i5;
     break;
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
   break;
  }
 default:
  i6 = i20 + 11 | 0;
 }
 i11 = HEAP8[i6 >> 0] | 0;
 i7 = i11 << 24 >> 24 < 0;
 i8 = i20 + 4 | 0;
 i11 = i7 ? HEAP32[i8 >> 2] | 0 : i11 & 255;
 i10 = (i11 | 0) == 0;
 if (i10) {
  i1 = HEAP8[i12 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] | 0; else i1 = i1 & 255;
  if (!i1) {
   i4 = i16 + 40 + (i17 << 7) + 72 | 0;
   i3 = i16 + 40 + (i17 << 7) + 68 | 0;
   i9 = 85;
  } else i9 = 34;
 } else i9 = 34;
 do if ((i9 | 0) == 34) {
  i3 = i16 + 40 + (i17 << 7) + 68 | 0;
  i4 = i16 + 40 + (i17 << 7) + 72 | 0;
  if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = i16 + 40 + (i17 << 7) + 36 | 0;
   if ((i1 | 0) == (i20 | 0)) {
    i9 = 85;
    break;
   }
   i9 = i7 ? HEAP32[i20 >> 2] | 0 : i20;
   i7 = i1 + 11 | 0;
   i2 = HEAP8[i7 >> 0] | 0;
   i5 = i2 << 24 >> 24 < 0;
   if (i5) i8 = (HEAP32[i16 + 40 + (i17 << 7) + 44 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
   if (i11 >>> 0 > i8 >>> 0) {
    if (i5) i2 = HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i8, i11 - i8 | 0, i2, 0, i2, i11, i9);
    i9 = 85;
    break;
   }
   if (i5) i1 = HEAP32[i1 >> 2] | 0;
   if (!i10) _memmove(i1 | 0, i9 | 0, i11 | 0) | 0;
   HEAP8[i1 + i11 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] = i11;
    i9 = 85;
    break;
   } else {
    HEAP8[i7 >> 0] = i11;
    i9 = 85;
    break;
   }
  }
  i1 = HEAP8[i12 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i5 = HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else {
   i5 = i1 & 255;
   i2 = i12;
  }
  i1 = i11 >>> 0 < i5 >>> 0 ? i11 : i5;
  if (!i1) i9 = 56; else if (!(_memcmp(i2, i7 ? HEAP32[i20 >> 2] | 0 : i20, i1) | 0)) i9 = 56;
  if ((i9 | 0) == 56) if (!((i13 | 0) == 3 | (i11 | 0) != (i5 | 0))) {
   i9 = 85;
   break;
  }
  HEAP32[i16 + 560 >> 2] = 0;
  if ((HEAPU16[i16 + 40 + (i17 << 7) + 104 >> 1] | 0) == (HEAP32[i15 >> 2] | 0)) HEAP32[i15 >> 2] = 4;
  HEAP8[i16 + 40 + (i17 << 7) + 92 >> 0] = 0;
  HEAP8[i16 + 40 + (i17 << 7) + 91 >> 0] = 0;
  if (HEAP8[i16 + 40 + (i17 << 7) + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i18) | 0;
  i1 = HEAP32[i16 + 36 >> 2] | 0;
  do if (i1 | 0) {
   if ((HEAP32[i16 >> 2] | 0) != 1) if ((HEAP32[i16 >> 2] | 0) != 2) break;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i18 | 0);
  } while (0);
  if (!(HEAP8[i16 + 40 + (i17 << 7) + 90 >> 0] | 0)) __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i18);
  if ((HEAP32[i15 >> 2] | 0) == 4) if (!(__ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv(i16) | 0)) {
   i1 = 0;
   break;
  }
  __ZN11UnityEngine15CloudWebService16SessionContaineraSERKS1_(i18, i16 + 40 + (HEAP32[i15 >> 2] << 7) | 0) | 0;
  i1 = i16 + 40 + (i17 << 7) + 36 | 0;
  if ((i1 | 0) == (i20 | 0)) i9 = 85; else {
   i9 = HEAP8[i6 >> 0] | 0;
   i7 = i9 << 24 >> 24 < 0;
   i10 = i7 ? HEAP32[i20 >> 2] | 0 : i20;
   i9 = i7 ? HEAP32[i8 >> 2] | 0 : i9 & 255;
   i7 = i1 + 11 | 0;
   i2 = HEAP8[i7 >> 0] | 0;
   i5 = i2 << 24 >> 24 < 0;
   if (i5) i8 = (HEAP32[i16 + 40 + (i17 << 7) + 44 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
   if (i9 >>> 0 > i8 >>> 0) {
    if (i5) i2 = HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i8, i9 - i8 | 0, i2, 0, i2, i9, i10);
    i9 = 85;
    break;
   }
   if (i5) i1 = HEAP32[i1 >> 2] | 0;
   if (i9 | 0) _memmove(i1 | 0, i10 | 0, i9 | 0) | 0;
   HEAP8[i1 + i9 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i16 + 40 + (i17 << 7) + 40 >> 2] = i9;
    i9 = 85;
    break;
   } else {
    HEAP8[i7 >> 0] = i9;
    i9 = 85;
    break;
   }
  }
 } while (0);
 L121 : do if ((i9 | 0) == 85) {
  __ZN11UnityEngine15CloudWebService16SessionContainer8AddEventEPNS0_14CloudEventInfoE(i18, i14) | 0;
  i2 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2 >>> 0 >= (HEAP32[i16 + 4 >> 2] | 0) >>> 0;
  i1 = i2 & 1;
  if ((HEAP32[i16 >> 2] | 0) == 1) i9 = 87; else if ((HEAP32[i16 >> 2] | 0) == 2) i9 = 87; else {
   i14 = i16 + 556 | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2];
   if (!(i2 | (HEAP32[i14 >> 2] | 0) == 1)) {
    i1 = 1;
    break;
   }
  }
  do if ((i9 | 0) == 87) {
   i2 = HEAP32[i14 + 32 >> 2] | 0;
   if (!(i2 & 1)) {
    if (i2 & 2) {
     __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i18) | 0;
     i2 = HEAP32[i16 + 36 >> 2] | 0;
     if (i2) if (((HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) == 4) mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i18 | 0);
    }
   } else i1 = 1;
   i2 = i16 + 40 + (i17 << 7) + 91 | 0;
   if (!((HEAP8[i2 >> 0] | i1) << 24 >> 24)) {
    i15 = i16 + 40 + (i17 << 7) + 104 | 0;
    i18 = HEAP32[i15 + 4 >> 2] | 0;
    i1 = i16 + 568 | 0;
    HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i1 + 4 >> 2] = i18;
    HEAP8[i2 >> 0] = 1;
    HEAP8[i16 + 40 + (i17 << 7) + 92 >> 0] = 0;
    HEAP32[i16 + 560 >> 2] = 1;
    i1 = 1;
    break L121;
   } else if (!(i1 << 24 >> 24)) {
    i1 = 1;
    break L121;
   } else break;
  } while (0);
  HEAP32[i16 + 560 >> 2] = 0;
  if ((HEAPU16[i16 + 40 + (i17 << 7) + 104 >> 1] | 0) == (HEAP32[i15 >> 2] | 0)) HEAP32[i15 >> 2] = 4;
  HEAP8[i16 + 40 + (i17 << 7) + 92 >> 0] = 0;
  HEAP8[i16 + 40 + (i17 << 7) + 91 >> 0] = 0;
  if (HEAP8[i16 + 40 + (i17 << 7) + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i18) | 0;
  i1 = HEAP32[i16 + 36 >> 2] | 0;
  do if (i1 | 0) {
   if ((HEAP32[i16 >> 2] | 0) != 1) if ((HEAP32[i16 >> 2] | 0) != 2) break;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i18 | 0);
  } while (0);
  if (!(HEAP8[i16 + 40 + (i17 << 7) + 90 >> 0] | 0)) {
   __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i18);
   i1 = 1;
  } else i1 = 1;
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i18 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 12 >> 2] | 0;
  HEAP32[i19 >> 2] = 66;
  HEAP32[i19 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
 }
 i20 = i1;
 STACKTOP = i21;
 return i20 | 0;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i54, i2, i17, i60, i59) {
 i54 = i54 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i60 = i60 | 0;
 i59 = i59 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i61 + 48 | 0;
 i56 = i61 + 32 | 0;
 i1 = i61 + 16 | 0;
 i57 = i61;
 i58 = (i59 | 0) != 0;
 if (i58) if (!(HEAP16[i54 + 84 >> 1] | 0)) {
  HEAP32[i55 >> 2] = 0;
  HEAP32[i55 + 4 >> 2] = 0;
  HEAP32[i55 + 8 >> 2] = 0;
  HEAP32[i55 + 12 >> 2] = 0;
  HEAP32[i56 >> 2] = 0;
  HEAP32[i56 + 4 >> 2] = 0;
  HEAP32[i56 + 8 >> 2] = 0;
  HEAP32[i56 + 12 >> 2] = 0;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i1, i54, i55, i56);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f6 = Math_fround(f3 * Math_fround(HEAPF32[i59 >> 2]));
  f7 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 4 >> 2]));
  f8 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 8 >> 2]));
  f9 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 12 >> 2]));
  f10 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 16 >> 2]));
  f11 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 20 >> 2]));
  f12 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 24 >> 2]));
  f13 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 28 >> 2]));
  f14 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 32 >> 2]));
  f15 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 36 >> 2]));
  f16 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 40 >> 2]));
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i59 + 44 >> 2]));
  if (i17 >>> 0 >= i60 >>> 0) {
   STACKTOP = i61;
   return;
  }
  i4 = HEAP32[i2 + 120 >> 2] | 0;
  i5 = HEAP32[i2 + 140 >> 2] | 0;
  i2 = HEAP32[i2 + 160 >> 2] | 0;
  i1 = i17;
  do {
   i48 = i4 + (i1 << 2) | 0;
   f73 = Math_fround(HEAPF32[i48 >> 2]);
   i49 = i48 + 4 | 0;
   f72 = Math_fround(HEAPF32[i49 >> 2]);
   i50 = i48 + 8 | 0;
   f71 = Math_fround(HEAPF32[i50 >> 2]);
   i51 = i48 + 12 | 0;
   f70 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i5 + (i1 << 2) | 0;
   f69 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = i52 + 4 | 0;
   f68 = Math_fround(HEAPF32[i53 >> 2]);
   i54 = i52 + 8 | 0;
   f67 = Math_fround(HEAPF32[i54 >> 2]);
   i55 = i52 + 12 | 0;
   f66 = Math_fround(HEAPF32[i55 >> 2]);
   i56 = i2 + (i1 << 2) | 0;
   f65 = Math_fround(HEAPF32[i56 >> 2]);
   i57 = i56 + 4 | 0;
   f64 = Math_fround(HEAPF32[i57 >> 2]);
   i58 = i56 + 8 | 0;
   f63 = Math_fround(HEAPF32[i58 >> 2]);
   i59 = i56 + 12 | 0;
   f72 = Math_fround(f7 + f72);
   f71 = Math_fround(f8 + f71);
   f70 = Math_fround(f9 + f70);
   f69 = Math_fround(f10 + f69);
   f68 = Math_fround(f11 + f68);
   f67 = Math_fround(f12 + f67);
   f66 = Math_fround(f13 + f66);
   f65 = Math_fround(f14 + f65);
   f64 = Math_fround(f15 + f64);
   f63 = Math_fround(f16 + f63);
   f62 = Math_fround(f3 + Math_fround(HEAPF32[i59 >> 2]));
   HEAPF32[i48 >> 2] = Math_fround(f6 + f73);
   HEAPF32[i49 >> 2] = f72;
   HEAPF32[i50 >> 2] = f71;
   HEAPF32[i51 >> 2] = f70;
   HEAPF32[i52 >> 2] = f69;
   HEAPF32[i53 >> 2] = f68;
   HEAPF32[i54 >> 2] = f67;
   HEAPF32[i55 >> 2] = f66;
   HEAPF32[i56 >> 2] = f65;
   HEAPF32[i57 >> 2] = f64;
   HEAPF32[i58 >> 2] = f63;
   HEAPF32[i59 >> 2] = f62;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i60 >>> 0);
  STACKTOP = i61;
  return;
 }
 if (i17 >>> 0 >= i60 >>> 0) {
  STACKTOP = i61;
  return;
 }
 i38 = i2 + 500 | 0;
 i39 = i55 + 4 | 0;
 i40 = i55 + 8 | 0;
 i41 = i55 + 12 | 0;
 i42 = i2 + 520 | 0;
 i43 = i56 + 4 | 0;
 i44 = i56 + 8 | 0;
 i45 = i56 + 12 | 0;
 i35 = i59 + 4 | 0;
 i36 = i59 + 8 | 0;
 i37 = i59 + 12 | 0;
 i27 = i59 + 16 | 0;
 i28 = i59 + 20 | 0;
 i29 = i59 + 24 | 0;
 i30 = i59 + 28 | 0;
 i31 = i59 + 32 | 0;
 i32 = i59 + 36 | 0;
 i33 = i59 + 40 | 0;
 i34 = i59 + 44 | 0;
 i46 = i57 + 4 | 0;
 i47 = i57 + 8 | 0;
 i48 = i57 + 12 | 0;
 i49 = i2 + 120 | 0;
 i50 = i2 + 140 | 0;
 i51 = i2 + 160 | 0;
 i52 = i2 + 180 | 0;
 i53 = i2 + 200 | 0;
 i26 = i2 + 220 | 0;
 i1 = i17;
 do {
  i22 = (HEAP32[i38 >> 2] | 0) + (i1 << 2) | 0;
  i24 = (HEAP32[i22 >> 2] | 0) + 3401255 | 0;
  i18 = (HEAP32[i22 + 4 >> 2] | 0) + 3401255 | 0;
  i20 = (HEAP32[i22 + 8 >> 2] | 0) + 3401255 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 3401255 | 0;
  i25 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i19 = (Math_imul(i18, 1790253981) | 0) + 1900727103 | 0;
  i21 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
  i23 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i24 = i24 << 11 ^ i24;
  i18 = i18 << 11 ^ i18;
  i20 = i20 << 11 ^ i20;
  i22 = i22 << 11 ^ i22;
  f72 = Math_fround(Math_fround((i19 ^ i18 ^ i18 >>> 8) & 8388607 ^ i19 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f71 = Math_fround(Math_fround((i21 ^ i20 ^ i20 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f70 = Math_fround(Math_fround((i23 ^ i22 ^ i22 >>> 8) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i55 >> 2] = Math_fround(Math_fround((i25 ^ i24 ^ i24 >>> 8) & 8388607 ^ i25 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i39 >> 2] = f72;
  HEAPF32[i40 >> 2] = f71;
  HEAPF32[i41 >> 2] = f70;
  i25 = (HEAP32[i42 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i25 >> 2]);
  f71 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f72 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f71 = Math_fround(f71 * Math_fround(.00999999977));
  f72 = Math_fround(f72 * Math_fround(.00999999977));
  f73 = Math_fround(Math_fround(HEAPF32[i25 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i56 >> 2] = Math_fround(f70 * Math_fround(.00999999977));
  HEAPF32[i43 >> 2] = f71;
  HEAPF32[i44 >> 2] = f72;
  HEAPF32[i45 >> 2] = f73;
  if (i58) {
   i2 = i59;
   i4 = i27;
   i5 = i28;
   i17 = i29;
   i18 = i30;
   i19 = i31;
   i20 = i32;
   i21 = i33;
   i22 = i34;
   i23 = i35;
   i24 = i36;
   i25 = i37;
  } else {
   i25 = (HEAP32[i52 >> 2] | 0) + (i1 << 2) | 0;
   i18 = (HEAP32[i53 >> 2] | 0) + (i1 << 2) | 0;
   i22 = (HEAP32[i26 >> 2] | 0) + (i1 << 2) | 0;
   i2 = i25;
   i4 = i18;
   i5 = i18 + 4 | 0;
   i17 = i18 + 8 | 0;
   i18 = i18 + 12 | 0;
   i19 = i22;
   i20 = i22 + 4 | 0;
   i21 = i22 + 8 | 0;
   i22 = i22 + 12 | 0;
   i23 = i25 + 4 | 0;
   i24 = i25 + 8 | 0;
   i25 = i25 + 12 | 0;
  }
  f62 = Math_fround(HEAPF32[i22 >> 2]);
  f63 = Math_fround(HEAPF32[i21 >> 2]);
  f64 = Math_fround(HEAPF32[i20 >> 2]);
  f65 = Math_fround(HEAPF32[i19 >> 2]);
  f12 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f7 = Math_fround(HEAPF32[i24 >> 2]);
  f6 = Math_fround(HEAPF32[i23 >> 2]);
  f16 = Math_fround(HEAPF32[i2 >> 2]);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i57, i54, i56, i55);
  f13 = Math_fround(HEAPF32[i57 >> 2]);
  f16 = Math_fround(f16 * f13);
  f14 = Math_fround(HEAPF32[i46 >> 2]);
  f6 = Math_fround(f6 * f14);
  f15 = Math_fround(HEAPF32[i47 >> 2]);
  f7 = Math_fround(f7 * f15);
  f73 = Math_fround(HEAPF32[i48 >> 2]);
  f8 = Math_fround(f8 * f73);
  f9 = Math_fround(f9 * f13);
  f10 = Math_fround(f10 * f14);
  f11 = Math_fround(f11 * f15);
  f12 = Math_fround(f12 * f73);
  f13 = Math_fround(f65 * f13);
  f14 = Math_fround(f64 * f14);
  f15 = Math_fround(f63 * f15);
  f73 = Math_fround(f62 * f73);
  i2 = (HEAP32[i49 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i2 + 4 | 0;
  f63 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i2 + 8 | 0;
  f64 = Math_fround(HEAPF32[i5 >> 2]);
  i17 = i2 + 12 | 0;
  f65 = Math_fround(HEAPF32[i17 >> 2]);
  i18 = (HEAP32[i50 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i18 >> 2]);
  i19 = i18 + 4 | 0;
  f67 = Math_fround(HEAPF32[i19 >> 2]);
  i20 = i18 + 8 | 0;
  f68 = Math_fround(HEAPF32[i20 >> 2]);
  i21 = i18 + 12 | 0;
  f69 = Math_fround(HEAPF32[i21 >> 2]);
  i22 = (HEAP32[i51 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i22 >> 2]);
  i23 = i22 + 4 | 0;
  f71 = Math_fround(HEAPF32[i23 >> 2]);
  i24 = i22 + 8 | 0;
  f72 = Math_fround(HEAPF32[i24 >> 2]);
  i25 = i22 + 12 | 0;
  f63 = Math_fround(f6 + f63);
  f64 = Math_fround(f7 + f64);
  f65 = Math_fround(f8 + f65);
  f66 = Math_fround(f9 + f66);
  f67 = Math_fround(f10 + f67);
  f68 = Math_fround(f11 + f68);
  f69 = Math_fround(f12 + f69);
  f70 = Math_fround(f13 + f70);
  f71 = Math_fround(f14 + f71);
  f72 = Math_fround(f15 + f72);
  f73 = Math_fround(f73 + Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i2 >> 2] = Math_fround(f16 + f62);
  HEAPF32[i4 >> 2] = f63;
  HEAPF32[i5 >> 2] = f64;
  HEAPF32[i17 >> 2] = f65;
  HEAPF32[i18 >> 2] = f66;
  HEAPF32[i19 >> 2] = f67;
  HEAPF32[i20 >> 2] = f68;
  HEAPF32[i21 >> 2] = f69;
  HEAPF32[i22 >> 2] = f70;
  HEAPF32[i23 >> 2] = f71;
  HEAPF32[i24 >> 2] = f72;
  HEAPF32[i25 >> 2] = f73;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i60 >>> 0);
 STACKTOP = i61;
 return;
}

function __ZN5physx28computeVolumeIntegralsEberlyERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsERKNS_6PxVec3E(i2, f1, i34, i33) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i34 = i34 | 0;
 i33 = i33 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, d24 = 0.0, f25 = f0, i26 = 0, d27 = 0.0, d28 = 0.0, f29 = f0, d30 = 0.0, i31 = 0, i32 = 0, d35 = 0.0, d36 = 0.0, d37 = 0.0, d38 = 0.0, d39 = 0.0, d40 = 0.0, d41 = 0.0, d42 = 0.0, d43 = 0.0, d44 = 0.0, d45 = 0.0, d46 = 0.0, d47 = 0.0, d48 = 0.0, d49 = 0.0, d50 = 0.0, d51 = 0.0, d52 = 0.0, d53 = 0.0, d54 = 0.0, d55 = 0.0, d56 = 0.0, d57 = 0.0, d58 = 0.0, f59 = f0, f60 = f0;
 i9 = HEAP32[i2 + 16 >> 2] | 0;
 i20 = HEAP32[i2 + 20 >> 2] | 0;
 L1 : do if (!i20) {
  i31 = i33;
  i32 = i33 + 4 | 0;
  d24 = 0.0;
  d30 = 0.0;
  d27 = 0.0;
  d28 = 0.0;
  d8 = 0.0;
  d7 = 0.0;
  d6 = 0.0;
  d5 = 0.0;
  d4 = 0.0;
  d3 = 0.0;
 } else {
  i31 = HEAP16[i2 + 24 >> 1] | 0;
  i18 = HEAP32[i2 + 4 >> 2] | 0;
  i19 = HEAP32[i2 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i33 >> 2]);
  i32 = i33 + 4 | 0;
  f11 = Math_fround(HEAPF32[i32 >> 2]);
  f12 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  i16 = HEAP32[i2 + 12 >> 2] | 0;
  i17 = (i31 & 2) == 0;
  if (!(i31 & 1)) {
   d24 = 0.0;
   d30 = 0.0;
   d27 = 0.0;
   d28 = 0.0;
   d8 = 0.0;
   d7 = 0.0;
   d6 = 0.0;
   d5 = 0.0;
   d4 = 0.0;
   d3 = 0.0;
   i14 = 0;
   i15 = i9;
   while (1) {
    if (i17) {
     i2 = HEAP32[i15 >> 2] | 0;
     i9 = HEAP32[i15 + 4 >> 2] | 0;
     i10 = HEAP32[i15 + 8 >> 2] | 0;
    } else {
     i2 = HEAPU16[i15 >> 1] | 0;
     i9 = HEAPU16[i15 + 2 >> 1] | 0;
     i10 = HEAPU16[i15 + 4 >> 1] | 0;
    }
    i2 = Math_imul(i2, i19) | 0;
    f60 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f59 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    f13 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    i2 = Math_imul(i9, i19) | 0;
    f21 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f22 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    f23 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    i2 = Math_imul(i10, i19) | 0;
    f25 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f29 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    d40 = +f60;
    d47 = +f59;
    d39 = +f13;
    d38 = +f21;
    d45 = +f22;
    d36 = +f23;
    d42 = +f25;
    d48 = +f29;
    d41 = +Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    d58 = d38 - d40;
    d57 = d45 - d47;
    d51 = d36 - d39;
    d43 = d42 - d40;
    d50 = d48 - d47;
    d49 = d41 - d39;
    d52 = d57 * d49 - d51 * d50;
    d49 = d51 * d43 - d58 * d49;
    d43 = d58 * d50 - d57 * d43;
    d57 = d40 + d38;
    d50 = d57 + d42;
    d58 = d40 * d40;
    d57 = d58 + d38 * d57;
    d51 = d57 + d42 * d50;
    d55 = d47 + d45;
    d44 = d55 + d48;
    d56 = d47 * d47;
    d55 = d56 + d45 * d55;
    d46 = d55 + d48 * d44;
    d53 = d39 + d36;
    d35 = d53 + d41;
    d54 = d39 * d39;
    d53 = d54 + d36 * d53;
    d37 = d53 + d41 * d35;
    d24 = d24 + d50 * d52;
    d30 = d30 + d51 * d52;
    d27 = d27 + d46 * d49;
    d28 = d28 + d43 * d37;
    d8 = d8 + d52 * (d40 * d58 + d38 * d57 + d42 * d51);
    d7 = d7 + d49 * (d47 * d56 + d45 * d55 + d48 * d46);
    d6 = d6 + d43 * (d39 * d54 + d36 * d53 + d41 * d37);
    d5 = d5 + d52 * (d48 * (d51 + d42 * (d42 + d50)) + (d47 * (d51 + d40 * (d40 + d50)) + d45 * (d51 + d38 * (d38 + d50))));
    d4 = d4 + d49 * (d41 * (d46 + d48 * (d48 + d44)) + (d39 * (d46 + d47 * (d47 + d44)) + d36 * (d46 + d45 * (d45 + d44))));
    d3 = d3 + d43 * (d42 * (d37 + d41 * (d41 + d35)) + (d40 * (d37 + d39 * (d39 + d35)) + d38 * (d37 + d36 * (d36 + d35))));
    i2 = i14 + 1 | 0;
    if (i2 >>> 0 >= i20 >>> 0) {
     i31 = i33;
     break L1;
    }
    i14 = i2;
    i15 = i15 + i16 | 0;
   }
  } else {
   d24 = 0.0;
   d30 = 0.0;
   d27 = 0.0;
   d28 = 0.0;
   d8 = 0.0;
   d7 = 0.0;
   d6 = 0.0;
   d5 = 0.0;
   d4 = 0.0;
   d3 = 0.0;
   i14 = 0;
   i15 = i9;
   while (1) {
    if (i17) {
     i2 = HEAP32[i15 >> 2] | 0;
     i9 = HEAP32[i15 + 4 >> 2] | 0;
     i10 = HEAP32[i15 + 8 >> 2] | 0;
    } else {
     i2 = HEAPU16[i15 >> 1] | 0;
     i9 = HEAPU16[i15 + 2 >> 1] | 0;
     i10 = HEAPU16[i15 + 4 >> 1] | 0;
    }
    i2 = Math_imul(i2, i19) | 0;
    f13 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f21 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    f22 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    i2 = Math_imul(i10, i19) | 0;
    f23 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f25 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    f29 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    i2 = Math_imul(i9, i19) | 0;
    f59 = Math_fround(Math_fround(HEAPF32[i18 + i2 >> 2]) - f1);
    f60 = Math_fround(Math_fround(HEAPF32[i18 + (i2 + 4) >> 2]) - f11);
    d53 = +f13;
    d46 = +f21;
    d54 = +f22;
    d55 = +f23;
    d48 = +f25;
    d57 = +f29;
    d51 = +f59;
    d45 = +f60;
    d52 = +Math_fround(Math_fround(HEAPF32[i18 + (i2 + 8) >> 2]) - f12);
    d35 = d55 - d53;
    d36 = d48 - d46;
    d42 = d57 - d54;
    d50 = d51 - d53;
    d43 = d45 - d46;
    d44 = d52 - d54;
    d41 = d36 * d44 - d42 * d43;
    d44 = d42 * d50 - d35 * d44;
    d50 = d35 * d43 - d36 * d50;
    d36 = d53 + d55;
    d43 = d36 + d51;
    d35 = d53 * d53;
    d36 = d35 + d55 * d36;
    d42 = d36 + d51 * d43;
    d38 = d46 + d48;
    d49 = d38 + d45;
    d37 = d46 * d46;
    d38 = d37 + d48 * d38;
    d47 = d38 + d45 * d49;
    d40 = d54 + d57;
    d58 = d40 + d52;
    d39 = d54 * d54;
    d40 = d39 + d57 * d40;
    d56 = d40 + d52 * d58;
    d24 = d24 + d43 * d41;
    d30 = d30 + d42 * d41;
    d27 = d27 + d47 * d44;
    d28 = d28 + d50 * d56;
    d8 = d8 + d41 * (d53 * d35 + d55 * d36 + d51 * d42);
    d7 = d7 + d44 * (d46 * d37 + d48 * d38 + d45 * d47);
    d6 = d6 + d50 * (d54 * d39 + d57 * d40 + d52 * d56);
    d5 = d5 + d41 * (d45 * (d42 + d51 * (d51 + d43)) + (d46 * (d42 + d53 * (d53 + d43)) + d48 * (d42 + d55 * (d55 + d43))));
    d4 = d4 + d44 * (d52 * (d47 + d45 * (d45 + d49)) + (d54 * (d47 + d46 * (d46 + d49)) + d57 * (d47 + d48 * (d48 + d49))));
    d3 = d3 + d50 * (d51 * (d56 + d52 * (d52 + d58)) + (d53 * (d56 + d54 * (d54 + d58)) + d55 * (d56 + d57 * (d57 + d58))));
    i2 = i14 + 1 | 0;
    if (i2 >>> 0 >= i20 >>> 0) {
     i31 = i33;
     break L1;
    }
    i14 = i2;
    i15 = i15 + i16 | 0;
   }
  }
 } while (0);
 d24 = d24 * .1666666716337204;
 d57 = d8 * .01666666753590107;
 d56 = d7 * .01666666753590107;
 d58 = d6 * .01666666753590107;
 d8 = d5 * .008333333767950535;
 d7 = d4 * .008333333767950535;
 d6 = d3 * .008333333767950535;
 HEAPF64[i34 + 16 >> 3] = d24;
 f29 = Math_fround(d30 * .0416666679084301 / d24);
 HEAPF32[i34 >> 2] = f29;
 f25 = Math_fround(d27 * .0416666679084301 / d24);
 i26 = i34 + 4 | 0;
 HEAPF32[i26 >> 2] = f25;
 f13 = Math_fround(d28 * .0416666679084301 / d24);
 i2 = i34 + 8 | 0;
 HEAPF32[i2 >> 2] = f13;
 d3 = d58 + d56;
 i9 = i34 + 24 | 0;
 HEAPF64[i9 >> 3] = d3;
 d4 = d58 + d57;
 i10 = i34 + 56 | 0;
 HEAPF64[i10 >> 3] = d4;
 d5 = d56 + d57;
 i14 = i34 + 88 | 0;
 HEAPF64[i14 >> 3] = d5;
 d57 = -d8;
 i15 = i34 + 48 | 0;
 HEAPF64[i15 >> 3] = d57;
 i16 = i34 + 32 | 0;
 HEAPF64[i16 >> 3] = d57;
 d57 = -d7;
 i17 = i34 + 80 | 0;
 HEAPF64[i17 >> 3] = d57;
 i18 = i34 + 64 | 0;
 HEAPF64[i18 >> 3] = d57;
 d57 = -d6;
 i19 = i34 + 72 | 0;
 HEAPF64[i19 >> 3] = d57;
 i20 = i34 + 40 | 0;
 HEAPF64[i20 >> 3] = d57;
 f23 = Math_fround(f25 * f25);
 f22 = Math_fround(f13 * f13);
 f21 = Math_fround(f23 + f22);
 HEAPF64[i34 + 96 >> 3] = d3 - d24 * +f21;
 f12 = Math_fround(f29 * f29);
 f22 = Math_fround(f12 + f22);
 HEAPF64[i34 + 128 >> 3] = d4 - d24 * +f22;
 f23 = Math_fround(f12 + f23);
 HEAPF64[i34 + 160 >> 3] = d5 - d24 * +f23;
 d57 = +f29;
 d56 = +f25;
 d58 = d24 * d57 * d56 - d8;
 HEAPF64[i34 + 120 >> 3] = d58;
 HEAPF64[i34 + 104 >> 3] = d58;
 d58 = +f13;
 d56 = d24 * d56 * d58 - d7;
 HEAPF64[i34 + 152 >> 3] = d56;
 HEAPF64[i34 + 136 >> 3] = d56;
 d58 = d57 * (d24 * d58) - d6;
 HEAPF64[i34 + 144 >> 3] = d58;
 HEAPF64[i34 + 112 >> 3] = d58;
 f12 = Math_fround(HEAPF32[i31 >> 2]);
 i31 = f12 == Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = i31 & f11 == Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 if (i32 & f1 == Math_fround(0.0)) return 1;
 f12 = Math_fround(f29 + f12);
 f59 = Math_fround(f25 + f11);
 f60 = Math_fround(f13 + f1);
 f11 = Math_fround(f59 * f59);
 f1 = Math_fround(f60 * f60);
 HEAPF64[i9 >> 3] = d3 - d24 * +Math_fround(f21 - Math_fround(f11 + f1));
 f21 = Math_fround(f12 * f12);
 HEAPF64[i10 >> 3] = d4 - d24 * +Math_fround(f22 - Math_fround(f21 + f1));
 HEAPF64[i14 >> 3] = d5 - d24 * +Math_fround(f23 - Math_fround(f21 + f11));
 d58 = d24 * +Math_fround(Math_fround(f29 * f25) - Math_fround(f12 * f59)) - d8;
 HEAPF64[i15 >> 3] = d58;
 HEAPF64[i16 >> 3] = d58;
 d58 = d24 * +Math_fround(Math_fround(f25 * f13) - Math_fround(f59 * f60)) - d7;
 HEAPF64[i17 >> 3] = d58;
 HEAPF64[i18 >> 3] = d58;
 d58 = d24 * +Math_fround(Math_fround(f29 * f13) - Math_fround(f12 * f60)) - d6;
 HEAPF64[i19 >> 3] = d58;
 HEAPF64[i20 >> 3] = d58;
 HEAPF32[i34 >> 2] = f12;
 HEAPF32[i26 >> 2] = f59;
 HEAPF32[i2 >> 2] = f60;
 return 1;
}

function __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE(i11, i13, i12) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 if (!(HEAP8[i12 + ((HEAP32[gb + 1457208 + 68 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + 10) >> 0] | 0)) {
  i12 = (i3 & 64 | 0) == 0 ? i12 + 32 | 0 : (HEAP32[i12 + 8 >> 2] | 0) + 96 | 0;
  i13 = (HEAP32[i13 + 4 >> 2] & 4 | 0) == 0 ? i13 + 48 | 0 : HEAP32[i13 + 8 >> 2] | 0;
  f25 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) * Math_fround(2.0));
  f23 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) * Math_fround(2.0));
  f18 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) * Math_fround(2.0));
  f28 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f27 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
  f26 = Math_fround(HEAPF32[i12 >> 2]);
  f15 = Math_fround(f25 * f26);
  f24 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f23 * f24));
  f22 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f22));
  f17 = Math_fround(Math_fround(f26 * f15) + Math_fround(Math_fround(f25 * f27) + Math_fround(f28 * Math_fround(Math_fround(f18 * f24) - Math_fround(f23 * f22)))));
  f16 = Math_fround(Math_fround(f24 * f15) + Math_fround(Math_fround(f23 * f27) + Math_fround(f28 * Math_fround(Math_fround(f25 * f22) - Math_fround(f18 * f26)))));
  f15 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(f28 * Math_fround(Math_fround(f23 * f26) - Math_fround(f25 * f24)))) + Math_fround(f22 * f15));
  f17 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) + f17);
  f16 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) + f16);
  f15 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) + f15);
  f25 = Math_fround(HEAPF32[i13 >> 2]);
  f23 = Math_fround(f28 * f25);
  f27 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f26 * f27));
  f18 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f24 * f18));
  f21 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f20 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(Math_fround(f24 * f27) + Math_fround(f28 * f21))) - Math_fround(f26 * f18));
  f19 = Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(Math_fround(f22 * f27) + Math_fround(f28 * f18))) - Math_fround(f24 * f25));
  f18 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f21)) - Math_fround(f22 * f18));
  HEAPF32[i11 >> 2] = Math_fround(f23 - Math_fround(f22 * f21));
  HEAPF32[i11 + 4 >> 2] = f20;
  HEAPF32[i11 + 8 >> 2] = f19;
  HEAPF32[i11 + 12 >> 2] = f18;
  HEAPF32[i11 + 16 >> 2] = f17;
  HEAPF32[i11 + 20 >> 2] = f16;
  HEAPF32[i11 + 24 >> 2] = f15;
  STACKTOP = i14;
  return;
 }
 i4 = i12 + 236 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = i12 + 60 | 0;
 i5 = i12 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if (!(HEAP8[((i1 & 4096 | 0) == 0 ? i6 : i2 + 268 | 0) >> 0] & 1)) {
  i3 = i12 + 176 | 0;
  i4 = i3 + 24 | 0;
  i5 = i3 + 20 | 0;
  i6 = i3 + 16 | 0;
  i7 = i3 + 12 | 0;
  i8 = i3 + 8 | 0;
  i9 = i3 + 4 | 0;
 } else {
  if (!(i1 & 8192)) {
   if (i3 >>> 0 <= 3221225471) {
    i9 = __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i12 + 16 | 0, i10) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (i9) i7 = 9;
   }
  } else {
   HEAP32[i10 >> 2] = HEAP32[i2 + 192 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 196 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 200 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 204 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i2 + 208 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i2 + 212 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i2 + 216 >> 2];
   i7 = 9;
  }
  if ((i7 | 0) == 9) if (HEAP8[((i1 & 4096 | 0) == 0 ? i6 : i2 + 268 | 0) >> 0] & 2) {
   i4 = i10 + 24 | 0;
   i5 = i10 + 20 | 0;
   i6 = i10 + 16 | 0;
   i7 = i10 + 12 | 0;
   i8 = i10 + 8 | 0;
   i9 = i10 + 4 | 0;
   i3 = i10;
   break;
  }
  i3 = i12 + 176 | 0;
  i4 = i3 + 24 | 0;
  i5 = i3 + 20 | 0;
  i6 = i3 + 16 | 0;
  i7 = i3 + 12 | 0;
  i8 = i3 + 8 | 0;
  i9 = i3 + 4 | 0;
 } while (0);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f25 = Math_fround(HEAPF32[i9 >> 2]);
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 f24 = Math_fround(HEAPF32[i7 >> 2]);
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f27 = Math_fround(HEAPF32[i5 >> 2]);
 f30 = Math_fround(HEAPF32[i4 >> 2]);
 i12 = (i1 & 512 | 0) == 0 ? i12 + 64 | 0 : i2 + 144 | 0;
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f31 = Math_fround(f31 * Math_fround(-2.0));
 f33 = Math_fround(f33 * Math_fround(-2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) * Math_fround(-2.0));
 f23 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f34 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i12 >> 2]);
 f21 = Math_fround(f31 * f32);
 f28 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f33 * f28));
 f29 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f35 * f29));
 f22 = Math_fround(-f32);
 f16 = Math_fround(-f28);
 f15 = Math_fround(-f29);
 f17 = Math_fround(Math_fround(Math_fround(f32 * f21) + Math_fround(Math_fround(f31 * f34) - Math_fround(f23 * Math_fround(Math_fround(f35 * f28) - Math_fround(f33 * f29))))) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(Math_fround(f28 * f21) + Math_fround(Math_fround(f33 * f34) - Math_fround(f23 * Math_fround(Math_fround(f31 * f29) - Math_fround(f35 * f32))))) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f34) - Math_fround(f23 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f28)))) + Math_fround(f29 * f21)) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f28 = Math_fround(Math_fround(f20 * f21) + Math_fround(Math_fround(f18 * f17) + Math_fround(f25 * f19)));
 f26 = Math_fround(f26 + Math_fround(Math_fround(f18 * f28) + Math_fround(Math_fround(f29 * f17) + Math_fround(f24 * Math_fround(Math_fround(f25 * f21) - Math_fround(f20 * f19))))));
 f27 = Math_fround(f27 + Math_fround(Math_fround(f25 * f28) + Math_fround(Math_fround(f29 * f19) + Math_fround(f24 * Math_fround(Math_fround(f20 * f17) - Math_fround(f18 * f21))))));
 f28 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f29 * f21) + Math_fround(f24 * Math_fround(Math_fround(f18 * f19) - Math_fround(f25 * f17)))) + Math_fround(f20 * f28)));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f23) + Math_fround(f24 * f22)) + Math_fround(f25 * f15)) - Math_fround(f20 * f16));
 f19 = Math_fround(Math_fround(Math_fround(f20 * f22) + Math_fround(Math_fround(f25 * f23) + Math_fround(f24 * f16))) - Math_fround(f18 * f15));
 f21 = Math_fround(Math_fround(Math_fround(f18 * f16) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f15))) - Math_fround(f25 * f22));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f18 * f22)) - Math_fround(f25 * f16)) - Math_fround(f20 * f15));
 i13 = (HEAP32[i13 + 4 >> 2] & 4 | 0) == 0 ? i13 + 48 | 0 : HEAP32[i13 + 8 >> 2] | 0;
 f20 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(f19 * f16)) + Math_fround(f21 * f25));
 f26 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(Math_fround(f20 * f22) + Math_fround(f15 * Math_fround(Math_fround(f19 * f25) - Math_fround(f21 * f16))))) + f26);
 f27 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f22 * f16) + Math_fround(f15 * Math_fround(Math_fround(f20 * f21) - Math_fround(f17 * f25))))) + f27);
 f28 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f15 * Math_fround(Math_fround(f17 * f16) - Math_fround(f19 * f20)))) + Math_fround(f21 * f18)) + f28);
 f18 = Math_fround(HEAPF32[i13 >> 2]);
 f20 = Math_fround(f15 * f18);
 f16 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f17 * f16));
 f25 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f19 * f25));
 f22 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f23 = Math_fround(Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f19 * f16) + Math_fround(f15 * f22))) - Math_fround(f17 * f25));
 f24 = Math_fround(Math_fround(Math_fround(f17 * f22) + Math_fround(Math_fround(f21 * f16) + Math_fround(f15 * f25))) - Math_fround(f19 * f18));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f18)) - Math_fround(f19 * f22)) - Math_fround(f21 * f25));
 HEAPF32[i11 >> 2] = Math_fround(f20 - Math_fround(f21 * f22));
 HEAPF32[i11 + 4 >> 2] = f23;
 HEAPF32[i11 + 8 >> 2] = f24;
 HEAPF32[i11 + 12 >> 2] = f25;
 HEAPF32[i11 + 16 >> 2] = f26;
 HEAPF32[i11 + 20 >> 2] = f27;
 HEAPF32[i11 + 24 >> 2] = f28;
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sc5SceneD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN5physx2Cm9FlushPoolD2Ev(i5 + 2360 | 0);
 HEAP32[i5 + 2332 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2340 >> 2] = 0;
 HEAP32[i5 + 2304 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2312 >> 2] = 0;
 HEAP32[i5 + 2276 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2284 >> 2] = 0;
 __ZN5physx2Cm10FanoutTaskD2Ev(i5 + 2180 | 0);
 HEAP32[i5 + 2152 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2160 >> 2] = 0;
 HEAP32[i5 + 2124 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2132 >> 2] = 0;
 HEAP32[i5 + 2096 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2104 >> 2] = 0;
 HEAP32[i5 + 2068 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2076 >> 2] = 0;
 HEAP32[i5 + 2040 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2048 >> 2] = 0;
 HEAP32[i5 + 2012 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 2020 >> 2] = 0;
 HEAP32[i5 + 1984 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 1992 >> 2] = 0;
 HEAP32[i5 + 1956 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 1964 >> 2] = 0;
 i2 = i5 + 1940 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i5 + 1944 >> 2] | 0;
 i3 = i1 + (i4 * 28 | 0) | 0;
 if ((i4 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 i4 = HEAP32[i5 + 1948 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i2 = i5 + 1928 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i5 + 1932 >> 2] | 0;
 i3 = i1 + (i4 * 28 | 0) | 0;
 if ((i4 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 i4 = HEAP32[i5 + 1936 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i2 = i5 + 1916 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i5 + 1920 >> 2] | 0;
 i3 = i1 + (i4 * 28 | 0) | 0;
 if ((i4 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 i4 = HEAP32[i5 + 1924 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 HEAP32[i5 + 1888 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 1896 >> 2] = 0;
 __ZN5physx2Cm10FanoutTaskD2Ev(i5 + 1792 | 0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i5 + 1696 | 0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i5 + 1604 | 0);
 HEAP32[i5 + 1576 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 1584 >> 2] = 0;
 HEAP32[i5 + 1548 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 1556 >> 2] = 0;
 __ZN5physx2Cm10FanoutTaskD2Ev(i5 + 1456 | 0);
 i4 = HEAP32[i5 + 1272 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 1264 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i5 + 1252 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i5 + 1256 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 1260 | 0, i1);
 i4 = HEAP32[i5 + 1248 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 1240 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i5 + 1160 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 1152 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i5 + 1144 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 1136 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i5 + 1132 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 1124 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 if (HEAP32[i5 + 1088 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5 + 808 | 0);
 i3 = i5 + 1072 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 1076 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i5 + 1080 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 812 | 0) == (i1 | 0)) {
   HEAP8[i5 + 1068 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i5 + 792 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5 + 512 | 0);
 i3 = i5 + 776 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 + 780 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i5 + 784 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 516 | 0) == (i1 | 0)) {
   HEAP8[i5 + 772 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 if (HEAP32[i5 + 496 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5 + 216 | 0);
 i3 = i5 + 480 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 + 484 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i5 + 488 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 220 | 0) == (i1 | 0)) {
   HEAP8[i5 + 476 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 212 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 204 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 200 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 192 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 164 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 156 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 152 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 144 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 140 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 132 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 128 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 120 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 108 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 100 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i5 + 92 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 84 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 f42 = Math_fround(HEAPF32[i3 >> 2]);
 f41 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f40 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f38 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f35 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f34 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f33 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f30 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f61 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(f42 * f61);
 f60 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f41 * f60));
 f16 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f40 * f16));
 f59 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f21 = Math_fround(f42 * f59);
 f58 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f41 * f58));
 f15 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f40 * f15));
 f57 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(f42 * f57);
 f56 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f41 * f56));
 f14 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f40 * f14));
 f55 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f28 = Math_fround(f39 * f55);
 f50 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f8 * f50));
 f45 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f7 * f45));
 f54 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f27 = Math_fround(f39 * f54);
 f49 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f8 * f49));
 f44 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f7 * f44));
 f53 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f26 = Math_fround(f39 * f53);
 f48 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f8 * f48));
 f43 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f28 = Math_fround(f22 + f28);
 f27 = Math_fround(f21 + f27);
 f26 = Math_fround(f20 + Math_fround(f26 + Math_fround(f7 * f43)));
 f20 = Math_fround(Math_fround(Math_fround(f42 * f55) + Math_fround(f41 * f54)) + Math_fround(f40 * f53));
 f21 = Math_fround(Math_fround(Math_fround(f42 * f50) + Math_fround(f41 * f49)) + Math_fround(f40 * f48));
 f22 = Math_fround(Math_fround(Math_fround(f42 * f45) + Math_fround(f41 * f44)) + Math_fround(f40 * f43));
 f52 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f25 = Math_fround(f39 * f52);
 f51 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f8 * f51));
 f13 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f7 * f13));
 f47 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f24 = Math_fround(f39 * f47);
 f46 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f8 * f46));
 f12 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f7 * f12));
 f9 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f23 = Math_fround(f39 * f9);
 f10 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f8 * f10));
 f11 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f25 = Math_fround(f20 + f25);
 f24 = Math_fround(f21 + f24);
 f23 = Math_fround(f22 + Math_fround(f23 + Math_fround(f7 * f11)));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f61) + Math_fround(f37 * f60)) + Math_fround(f36 * f16)) + Math_fround(Math_fround(Math_fround(f35 * f55) + Math_fround(f34 * f50)) + Math_fround(f6 * f45)));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f59) + Math_fround(f37 * f58)) + Math_fround(f36 * f15)) + Math_fround(Math_fround(Math_fround(f35 * f54) + Math_fround(f34 * f49)) + Math_fround(f6 * f44)));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f57) + Math_fround(f37 * f56)) + Math_fround(f36 * f14)) + Math_fround(Math_fround(Math_fround(f35 * f53) + Math_fround(f34 * f48)) + Math_fround(f6 * f43)));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f55) + Math_fround(f37 * f54)) + Math_fround(f36 * f53)) + Math_fround(Math_fround(Math_fround(f35 * f52) + Math_fround(f34 * f51)) + Math_fround(f6 * f13)));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f50) + Math_fround(f37 * f49)) + Math_fround(f36 * f48)) + Math_fround(Math_fround(Math_fround(f35 * f47) + Math_fround(f34 * f46)) + Math_fround(f6 * f12)));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f45) + Math_fround(f37 * f44)) + Math_fround(f36 * f43)) + Math_fround(Math_fround(Math_fround(f35 * f9) + Math_fround(f34 * f10)) + Math_fround(f6 * f11)));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f61) + Math_fround(f32 * f60)) + Math_fround(f31 * f16)) + Math_fround(Math_fround(Math_fround(f30 * f55) + Math_fround(f29 * f50)) + Math_fround(f5 * f45)));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f59) + Math_fround(f32 * f58)) + Math_fround(f31 * f15)) + Math_fround(Math_fround(Math_fround(f30 * f54) + Math_fround(f29 * f49)) + Math_fround(f5 * f44)));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f57) + Math_fround(f32 * f56)) + Math_fround(f31 * f14)) + Math_fround(Math_fround(Math_fround(f30 * f53) + Math_fround(f29 * f48)) + Math_fround(f5 * f43)));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f55) + Math_fround(f32 * f54)) + Math_fround(f31 * f53)) + Math_fround(Math_fround(Math_fround(f30 * f52) + Math_fround(f29 * f51)) + Math_fround(f5 * f13)));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f50) + Math_fround(f32 * f49)) + Math_fround(f31 * f48)) + Math_fround(Math_fround(Math_fround(f30 * f47) + Math_fround(f29 * f46)) + Math_fround(f5 * f12)));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f45) + Math_fround(f32 * f44)) + Math_fround(f31 * f43)) + Math_fround(Math_fround(Math_fround(f30 * f9) + Math_fround(f29 * f10)) + Math_fround(f5 * f11)));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f28) + Math_fround(f41 * f27)) + Math_fround(f40 * f26)) + Math_fround(Math_fround(Math_fround(f39 * f25) + Math_fround(f8 * f24)) + Math_fround(f7 * f23)));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f22) + Math_fround(f41 * f21)) + Math_fround(f40 * f20)) + Math_fround(Math_fround(Math_fround(f39 * f19) + Math_fround(f8 * f18)) + Math_fround(f7 * f17)));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f16) + Math_fround(f41 * f15)) + Math_fround(f40 * f14)) + Math_fround(Math_fround(Math_fround(f39 * f13) + Math_fround(f8 * f12)) + Math_fround(f7 * f11)));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f22) + Math_fround(f37 * f21)) + Math_fround(f36 * f20)) + Math_fround(Math_fround(Math_fround(f35 * f19) + Math_fround(f34 * f18)) + Math_fround(f6 * f17)));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f16) + Math_fround(f37 * f15)) + Math_fround(f36 * f14)) + Math_fround(Math_fround(Math_fround(f35 * f13) + Math_fround(f34 * f12)) + Math_fround(f6 * f11)));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f16) + Math_fround(f32 * f15)) + Math_fround(f31 * f14)) + Math_fround(Math_fround(Math_fround(f30 * f13) + Math_fround(f29 * f12)) + Math_fround(f5 * f11)));
 HEAPF32[i2 >> 2] = f28;
 HEAPF32[i2 + 4 >> 2] = f27;
 HEAPF32[i2 + 8 >> 2] = f26;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f25;
 HEAPF32[i2 + 20 >> 2] = f24;
 HEAPF32[i2 + 24 >> 2] = f23;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 32 >> 2] = f22;
 HEAPF32[i2 + 36 >> 2] = f21;
 HEAPF32[i2 + 40 >> 2] = f20;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 48 >> 2] = f19;
 HEAPF32[i2 + 52 >> 2] = f18;
 HEAPF32[i2 + 56 >> 2] = f17;
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 64 >> 2] = f16;
 HEAPF32[i2 + 68 >> 2] = f15;
 HEAPF32[i2 + 72 >> 2] = f14;
 HEAPF32[i2 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 80 >> 2] = f13;
 HEAPF32[i2 + 84 >> 2] = f12;
 HEAPF32[i2 + 88 >> 2] = f11;
 HEAPF32[i2 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f9;
 HEAPF32[i4 + 8 >> 2] = f7;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 16 >> 2] = f9;
 HEAPF32[i4 + 20 >> 2] = f8;
 HEAPF32[i4 + 24 >> 2] = f6;
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 32 >> 2] = f7;
 HEAPF32[i4 + 36 >> 2] = f6;
 HEAPF32[i4 + 40 >> 2] = f5;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __ZN12TreeRendererC2ER12TreeDatabaseRK8Vector3f(i16, i7, i3) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18 + 16 | 0;
 i1 = i18;
 i2 = i18 + 8 | 0;
 i11 = i18 + 32 | 0;
 i12 = i18 + 28 | 0;
 HEAP32[i16 >> 2] = 0;
 i13 = i16 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 1;
 HEAP32[i16 + 8 >> 2] = gb + 33952 + 8;
 i4 = gb + 63616 | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = i8;
 HEAP32[i16 + 40 >> 2] = 0;
 HEAP32[i16 + 52 >> 2] = 0;
 HEAP32[i16 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i14 = i6;
 i8 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = i16 + 44 | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 i4 = gb + 63616 | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = i8;
 HEAP32[i16 + 60 >> 2] = 0;
 HEAP32[i16 + 72 >> 2] = 0;
 HEAP32[i16 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i14 = i6;
 i8 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = i16 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 i4 = gb + 63616 | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = i8;
 HEAP32[i16 + 80 >> 2] = 0;
 HEAP32[i16 + 92 >> 2] = 0;
 HEAP32[i16 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i14 = i6;
 i8 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = i16 + 84 | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i16 + 100 >> 2] = 0;
 HEAP32[i16 + 104 >> 2] = 0;
 i4 = gb + 63616 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i14 = i16 + 108 | 0;
 HEAP32[i14 >> 2] = i8;
 HEAP32[i14 + 4 >> 2] = i4;
 HEAP8[i16 + 116 >> 0] = 1;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 i14 = i16 + 120 | 0;
 HEAP32[i16 + 132 >> 2] = -1;
 i15 = i16 + 136 | 0;
 i17 = i16 + 148 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i16 + 152 >> 2] = 0;
 i10 = i1;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i16 + 156 >> 2] = 0;
 HEAP32[i16 + 168 >> 2] = 0;
 HEAP32[i16 + 172 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i10 = i6;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i16 + 160 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 i8 = gb + 63616 | 0;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i16 + 176 >> 2] = 0;
 HEAP32[i16 + 188 >> 2] = 0;
 HEAP32[i16 + 192 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i10 = i6;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i16 + 180 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 i8 = i16 + 196 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i16 + 200 >> 2] = __Z19GetActiveColorSpacev() | 0;
 i4 = i16 + 204 | 0;
 i10 = gb + 63616 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i16 + 208 >> 2] = i4;
 HEAP32[i16 + 212 >> 2] = 0;
 HEAP32[i16 + 216 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 + 220 >> 2] = 8192;
 i4 = i16 + 224 | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP8[i16 + 232 >> 0] = 0;
 i4 = gb + 63616 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i16 + 236 >> 2] = 0;
 HEAP32[i16 + 248 >> 2] = 0;
 HEAP32[i16 + 252 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i9 = i6;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i16 + 240 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 i4 = gb + 63616 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i16 + 256 >> 2] = 0;
 HEAP32[i16 + 268 >> 2] = 0;
 HEAP32[i16 + 272 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i9 = i6;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i16 + 260 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 i4 = gb + 63616 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i16 + 276 >> 2] = 0;
 HEAP32[i16 + 288 >> 2] = 0;
 HEAP32[i16 + 292 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i9 = i6;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i16 + 280 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i16 + 296 >> 2] = -1;
 HEAP32[i16 + 300 >> 2] = 0;
 i4 = gb + 63616 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN15LODGroupManagerC2E10MemLabelId(i16 + 304 | 0, i6);
 HEAPF32[i16 + 360 >> 2] = Math_fround(1.0);
 HEAP32[i16 + 364 >> 2] = 0;
 HEAP32[i16 + 368 >> 2] = 0;
 HEAP32[i16 + 372 >> 2] = 0;
 HEAP32[i16 + 376 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = gb + 63616 | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i16 + 380 >> 2] = 0;
 HEAP32[i16 + 392 >> 2] = 0;
 HEAP32[i16 + 396 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i10 = i6;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i16 + 384 | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = gb + 63616 | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i16 + 400 >> 2] = 0;
 HEAP32[i16 + 412 >> 2] = 0;
 HEAP32[i16 + 416 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i10 = i6;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i16 + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = gb + 63616 | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i16 + 420 >> 2] = 0;
 HEAP32[i16 + 432 >> 2] = 0;
 HEAP32[i16 + 436 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i1);
 i1 = i6;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i16 + 424 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i7 + 28 | 0;
 i10 = i7 + 32 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i18;
  return;
 }
 i2 = (i1 - i2 | 0) / 156 | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i4 + (i1 * 156 | 0) + 4 >> 2] | 0) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i5 = 15;
   break;
  }
 }
 if ((i5 | 0) == 15) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i16 >> 2] = i7;
 __ZNK9Heightmap7GetSizeEv(i6, (HEAP32[i7 >> 2] | 0) + 248 | 0);
 HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = __Znwj(116) | 0;
 __ZN21ImposterRenderTextureC2ERK12TreeDatabase(i1, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) {
  __ZN21ImposterRenderTextureD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i8 >> 2] = i1;
 i1 = __Z15GetScriptMapperv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 935182 | 0, 34);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 935217 | 0, 0, gb + 934736 | 0, 308, 1, 0, 0, 0);
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 935336 | 0, 7);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i5 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[i13 >> 2] = i5;
 HEAP32[i11 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i11, gb + 1046318 | 0);
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i5, i6) | 0) {
  i11 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i12, gb + 1046318 | 0);
  i13 = HEAP32[i8 >> 2] | 0;
  i13 = HEAP32[((HEAP8[i13 + 36 >> 0] | 0) == 0 ? i13 + 20 | 0 : i13 + 24 | 0) >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i11, i6, i13);
 }
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i(i7, i15, i14, 500) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) {
  __ZN14TreeBinaryTreeD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i17 >> 2] = i1;
 __ZN12TreeRenderer17PopulateRenderersEv(i16);
 STACKTOP = i18;
 return;
}

function __ZNK12TreeDatabase9Prototype17GetRepresentationER13dynamic_arrayINSt3__24pairIPK4Mesh10Matrix4x4fEELj4EE(i5, i18) {
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 32 | 0;
 i16 = i19 + 16 | 0;
 i14 = i19;
 switch (HEAP32[i5 + 4 >> 2] | 0) {
 case 1:
  {
   i4 = i5 + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    STACKTOP = i19;
    return;
   }
   HEAP32[i16 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
     i2 = HEAP32[i15 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 10;
    }
   }
   if ((i17 | 0) == 8) i17 = 10;
   if ((i17 | 0) == 10) {
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    if (!i1) {
     STACKTOP = i19;
     return;
    }
   }
   i3 = i18 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i18 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i2 = i7 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i2;
     HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i2 * 68 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 68 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i17 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 68 | 0) | 0;
     HEAP32[i6 >> 2] = i2;
     HEAP32[i18 >> 2] = i17;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   i2 = HEAP32[i18 >> 2] | 0;
   HEAP32[i2 + (i4 * 68 | 0) >> 2] = i1;
   i1 = i2 + (i4 * 68 | 0) + 4 | 0;
   i2 = gb + 1162292 | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i19;
   return;
  }
 case 2:
  {
   i4 = i5 + 8 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    STACKTOP = i19;
    return;
   }
   HEAP32[i16 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
     i2 = HEAP32[i15 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 25; else i6 = i1;
    }
   }
   if ((i17 | 0) == 23) i17 = 25;
   if ((i17 | 0) == 25) {
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    if (!i1) {
     STACKTOP = i19;
     return;
    } else i6 = i1;
   }
   i4 = i5 + 12 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (!i1) i17 = 36; else {
    HEAP32[i16 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i17 = 32; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
      i2 = HEAP32[i15 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 32; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i17 = 34;
    }
    if ((i17 | 0) == 32) i17 = 34;
    if ((i17 | 0) == 34) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
     i17 = 36;
     break;
    }
    i1 = (HEAP32[i6 + 60 >> 2] | 0) - (HEAP32[i6 + 56 >> 2] | 0) | 0;
    if ((i1 | 0) == 28) {
     STACKTOP = i19;
     return;
    } else i2 = 2;
   } while (0);
   if ((i17 | 0) == 36) {
    i1 = (HEAP32[i6 + 60 >> 2] | 0) - (HEAP32[i6 + 56 >> 2] | 0) | 0;
    i2 = 1;
   }
   i3 = __ZNK8LODGroup6GetLODEi(i6, ((i1 | 0) / 28 | 0) - i2 | 0) | 0;
   i12 = i3 + 20 | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   i13 = i18 + 16 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
    if ((i2 | 0) > -1) {
     HEAP32[i13 >> 2] = i1;
     HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 * 68 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    } else {
     i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 68 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i11 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i18 + 12 >> 2] | 0) * 68 | 0) | 0;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i18 >> 2] = i11;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   if (!i1) {
    STACKTOP = i19;
    return;
   }
   i9 = i3 + 8 | 0;
   i10 = i18 + 12 | 0;
   i11 = i18 + 4 | 0;
   i8 = 0;
   do {
    i6 = __Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E((HEAP32[i9 >> 2] | 0) + (i8 << 2) | 0) | 0;
    do if (i6 | 0) {
     i7 = HEAP32[i10 >> 2] | 0;
     i2 = i7 + 1 | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     i4 = i3 & 2147483647;
     do if (i2 >>> 0 > i4 >>> 0) {
      i1 = i3 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i13 >> 2] = i1;
       HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 * 68 | 0, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 68 | 0, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 68 | 0) | 0;
       HEAP32[i13 >> 2] = i1;
       HEAP32[i18 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i2;
     i5 = HEAP32[i18 >> 2] | 0;
     i4 = __ZNK12MeshRenderer13GetSharedMeshEv(i6) | 0;
     if (!i4) i1 = 0; else {
      HEAP32[i16 >> 2] = i4;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i17 = 56; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
        i2 = HEAP32[i15 >> 2] | 0;
        i20 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 56; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i17 = 58;
       }
      }
      if ((i17 | 0) == 56) i17 = 58;
      if ((i17 | 0) == 58) {
       i17 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
      }
     }
     HEAP32[i5 + (i7 * 68 | 0) >> 2] = i1;
     i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
     i1 = i5 + (i7 * 68 | 0) + 4 | 0;
     if (!i2) {
      i2 = gb + 1162292 | 0;
      i3 = i1 + 64 | 0;
      do {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       i1 = i1 + 4 | 0;
       i2 = i2 + 4 | 0;
      } while ((i1 | 0) < (i3 | 0));
      break;
     } else {
      __ZNK9Transform16GetLocalPositionEv(i15, i2);
      __ZNK9Transform16GetLocalRotationEv(i16, i2);
      __ZNK9Transform13GetLocalScaleEv(i14, i2);
      __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i1, i15, i16, i14);
      break;
     }
    } while (0);
    i8 = i8 + 1 | 0;
   } while (i8 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
   STACKTOP = i19;
   return;
  }
 default:
  {
   STACKTOP = i19;
   return;
  }
 }
}

function __ZN5physx14PxsAABBManager11shiftOriginERKNS_6PxVec3E(i16, i15) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i5 = HEAP32[i16 + 196 >> 2] | 0;
 if (i5 | 0) {
  i7 = i16 + 180 | 0;
  i8 = i16 + 12 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i16 + 96 | 0;
  i12 = i16 + 68 | 0;
  i13 = i16 + 300 | 0;
  i6 = i16 + 316 | 0;
  i14 = 0;
  do {
   i4 = HEAP32[i7 >> 2] | 0;
   if (HEAP8[i4 + (i14 * 1048 | 0) + 1025 >> 0] | 0) {
    i3 = HEAP32[i4 + (i14 * 1048 | 0) + 1028 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i25 = i1 + (i3 * 24 | 0) | 0;
    i26 = HEAP32[i25 >> 2] | 0;
    i23 = i1 + (i3 * 24 | 0) + 4 | 0;
    i24 = HEAP32[i23 >> 2] | 0;
    i21 = i1 + (i3 * 24 | 0) + 8 | 0;
    i22 = HEAP32[i21 >> 2] | 0;
    i19 = i1 + (i3 * 24 | 0) + 12 | 0;
    i20 = HEAP32[i19 >> 2] | 0;
    i17 = i1 + (i3 * 24 | 0) + 16 | 0;
    i18 = HEAP32[i17 >> 2] | 0;
    i1 = i1 + (i3 * 24 | 0) + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    f29 = Math_fround(HEAPF32[i15 >> 2]);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i26 | 0) < 0 ? i26 & 2147483647 : ~i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
    i26 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround(HEAPF32[i9 >> 2]);
    f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i24 | 0) < 0 ? i24 & 2147483647 : ~i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
    i24 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
    f27 = Math_fround(HEAPF32[i10 >> 2]);
    f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i22 | 0) < 0 ? i22 & 2147483647 : ~i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i20 | 0) < 0 ? i20 & 2147483647 : ~i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i18 | 0) < 0 ? i18 & 2147483647 : ~i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i2 | 0) < 0 ? i2 & 2147483647 : ~i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
    HEAP32[i25 >> 2] = ((i26 | 0) < 0 ? ~i26 : i26 | -2147483648) + -16 & -16;
    HEAP32[i23 >> 2] = ((i24 | 0) < 0 ? ~i24 : i24 | -2147483648) + -16 & -16;
    HEAP32[i21 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + -16 & -16;
    HEAP32[i19 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
    HEAP32[i17 >> 2] = ((i18 | 0) < 0 ? ~i18 : i18 | -2147483648) + 16 & -16 | 1;
    HEAP32[i1 >> 2] = ((i2 | 0) < 0 ? ~i2 : i2 | -2147483648) + 16 & -16 | 1;
    i1 = i3 >>> 5;
    i3 = 1 << (i3 & 31);
    if (!(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] & i3)) {
     i1 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!(i2 & i3)) HEAP32[i1 >> 2] = i2 | i3;
    }
    i1 = HEAP32[i4 + (i14 * 1048 | 0) + 1032 >> 2] | 0;
    if ((i1 | 0) != 1073741823) do {
     i26 = HEAP32[i13 >> 2] | 0;
     i4 = i26 + (i1 * 24 | 0) | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i18 = i26 + (i1 * 24 | 0) + 4 | 0;
     i17 = HEAP32[i18 >> 2] | 0;
     i20 = i26 + (i1 * 24 | 0) + 8 | 0;
     i19 = HEAP32[i20 >> 2] | 0;
     i22 = i26 + (i1 * 24 | 0) + 12 | 0;
     i21 = HEAP32[i22 >> 2] | 0;
     i24 = i26 + (i1 * 24 | 0) + 16 | 0;
     i23 = HEAP32[i24 >> 2] | 0;
     i26 = i26 + (i1 * 24 | 0) + 20 | 0;
     i25 = HEAP32[i26 >> 2] | 0;
     f28 = Math_fround(HEAPF32[i15 >> 2]);
     f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i3 | 0) < 0 ? i3 & 2147483647 : ~i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
     f29 = Math_fround(HEAPF32[i9 >> 2]);
     f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i17 | 0) < 0 ? i17 & 2147483647 : ~i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
     i17 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
     f30 = Math_fround(HEAPF32[i10 >> 2]);
     f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i19 | 0) < 0 ? i19 & 2147483647 : ~i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
     i19 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
     f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i21 | 0) < 0 ? i21 & 2147483647 : ~i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
     i21 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
     f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i23 | 0) < 0 ? i23 & 2147483647 : ~i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
     i23 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
     f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i25 | 0) < 0 ? i25 & 2147483647 : ~i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
     i25 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
     HEAP32[i4 >> 2] = ((i3 | 0) < 0 ? ~i3 : i3 | -2147483648) + -16 & -16;
     HEAP32[i18 >> 2] = ((i17 | 0) < 0 ? ~i17 : i17 | -2147483648) + -16 & -16;
     HEAP32[i20 >> 2] = ((i19 | 0) < 0 ? ~i19 : i19 | -2147483648) + -16 & -16;
     HEAP32[i22 >> 2] = ((i21 | 0) < 0 ? ~i21 : i21 | -2147483648) + 16 & -16 | 1;
     HEAP32[i24 >> 2] = ((i23 | 0) < 0 ? ~i23 : i23 | -2147483648) + 16 & -16 | 1;
     HEAP32[i26 >> 2] = ((i25 | 0) < 0 ? ~i25 : i25 | -2147483648) + 16 & -16 | 1;
     i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    } while ((i1 | 0) != 1073741823);
   }
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i5 | 0));
 }
 i5 = HEAP32[i16 + 164 >> 2] | 0;
 if (!i5) {
  i26 = i16 + 49828 | 0;
  i26 = HEAP32[i26 >> 2] | 0;
  i25 = HEAP32[i26 >> 2] | 0;
  i25 = i25 + 68 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  mftCall_vii(i25 | 0, i26 | 0, i15 | 0);
  return;
 }
 i6 = i16 + 156 | 0;
 i7 = i16 + 12 | 0;
 i8 = i15 + 4 | 0;
 i9 = i15 + 8 | 0;
 i10 = i16 + 96 | 0;
 i11 = i16 + 68 | 0;
 i12 = i16 + 28 | 0;
 i13 = 0;
 do {
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  if ((i1 | 0) != 1073741823) do {
   i2 = HEAP32[i7 >> 2] | 0;
   i18 = i2 + (i1 * 24 | 0) | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i20 = i2 + (i1 * 24 | 0) + 4 | 0;
   i19 = HEAP32[i20 >> 2] | 0;
   i22 = i2 + (i1 * 24 | 0) + 8 | 0;
   i21 = HEAP32[i22 >> 2] | 0;
   i24 = i2 + (i1 * 24 | 0) + 12 | 0;
   i23 = HEAP32[i24 >> 2] | 0;
   i26 = i2 + (i1 * 24 | 0) + 16 | 0;
   i25 = HEAP32[i26 >> 2] | 0;
   i2 = i2 + (i1 * 24 | 0) + 20 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   f28 = Math_fround(HEAPF32[i15 >> 2]);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i17 | 0) < 0 ? i17 & 2147483647 : ~i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
   i17 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   f29 = Math_fround(HEAPF32[i8 >> 2]);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i19 | 0) < 0 ? i19 & 2147483647 : ~i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
   i19 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround(HEAPF32[i9 >> 2]);
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i21 | 0) < 0 ? i21 & 2147483647 : ~i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
   i21 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i23 | 0) < 0 ? i23 & 2147483647 : ~i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
   i23 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i25 | 0) < 0 ? i25 & 2147483647 : ~i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 | 0) < 0 ? i4 & 2147483647 : ~i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f30);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   HEAP32[i18 >> 2] = ((i17 | 0) < 0 ? ~i17 : i17 | -2147483648) + -16 & -16;
   HEAP32[i20 >> 2] = ((i19 | 0) < 0 ? ~i19 : i19 | -2147483648) + -16 & -16;
   HEAP32[i22 >> 2] = ((i21 | 0) < 0 ? ~i21 : i21 | -2147483648) + -16 & -16;
   HEAP32[i24 >> 2] = ((i23 | 0) < 0 ? ~i23 : i23 | -2147483648) + 16 & -16 | 1;
   HEAP32[i26 >> 2] = ((i25 | 0) < 0 ? ~i25 : i25 | -2147483648) + 16 & -16 | 1;
   HEAP32[i2 >> 2] = ((i4 | 0) < 0 ? ~i4 : i4 | -2147483648) + 16 & -16 | 1;
   i2 = i1 >>> 5;
   i4 = 1 << (i1 & 31);
   if (!(HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] & i4)) {
    i2 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!(i3 & i4)) HEAP32[i2 >> 2] = i3 | i4;
   }
   i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != 1073741823);
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != (i5 | 0));
 i26 = i16 + 49828 | 0;
 i26 = HEAP32[i26 >> 2] | 0;
 i25 = HEAP32[i26 >> 2] | 0;
 i25 = i25 + 68 | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 mftCall_vii(i25 | 0, i26 | 0, i15 | 0);
 return;
}

function __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj(i2, i4, i5, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i1 + 192 | 0;
 i31 = i1 + 180 | 0;
 i30 = i1 + 168 | 0;
 i29 = i1 + 156 | 0;
 i28 = i1 + 144 | 0;
 i27 = i1 + 132 | 0;
 i26 = i1 + 120 | 0;
 i25 = i1 + 108 | 0;
 i24 = i1 + 96 | 0;
 i23 = i1 + 84 | 0;
 i22 = i1 + 72 | 0;
 i21 = i1 + 60 | 0;
 i20 = i1 + 48 | 0;
 i17 = i1 + 36 | 0;
 i15 = i1 + 24 | 0;
 i10 = i1 + 12 | 0;
 i6 = i1;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f39 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f36 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f33 = Math_fround(HEAPF32[i2 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f40 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f34 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f11 = Math_fround(Math_fround(Math_fround(f9 * f33) + Math_fround(f39 * f37)) + Math_fround(f35 * f40));
 f13 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f9 * f11) + Math_fround(Math_fround(f34 * f33) + Math_fround(f8 * Math_fround(Math_fround(f39 * f40) - Math_fround(f35 * f37))))) * Math_fround(2.0)));
 f12 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f39 * f11) + Math_fround(Math_fround(f34 * f37) + Math_fround(f8 * Math_fround(Math_fround(f35 * f33) - Math_fround(f9 * f40))))) * Math_fround(2.0)));
 f11 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(Math_fround(f34 * f40) + Math_fround(f8 * Math_fround(Math_fround(f9 * f37) - Math_fround(f39 * f33)))) + Math_fround(f35 * f11)) * Math_fround(2.0)));
 f35 = Math_fround(HEAPF32[i5 >> 2]);
 f33 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f37 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f40 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f16 = Math_fround(Math_fround(f37 * f37) + Math_fround(-.5));
 f7 = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f33 * f36)) + Math_fround(f39 * f32));
 f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f35 * f7) + Math_fround(Math_fround(f16 * f34) + Math_fround(f37 * Math_fround(Math_fround(f33 * f32) - Math_fround(f39 * f36))))) * Math_fround(2.0)));
 f8 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f33 * f7) + Math_fround(Math_fround(f16 * f36) + Math_fround(f37 * Math_fround(Math_fround(f39 * f34) - Math_fround(f35 * f32))))) * Math_fround(2.0)));
 f7 = Math_fround(f40 + Math_fround(Math_fround(Math_fround(Math_fround(f16 * f32) + Math_fround(f37 * Math_fround(Math_fround(f35 * f36) - Math_fround(f33 * f34)))) + Math_fround(f39 * f7)) * Math_fround(2.0)));
 f34 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f40 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f38 = Math_fround(Math_fround(Math_fround(f34 * f35) + Math_fround(f36 * f33)) + Math_fround(f32 * f39));
 f19 = Math_fround(f13 - Math_fround(f40 * Math_fround(Math_fround(Math_fround(f35 * f38) + Math_fround(Math_fround(f37 * Math_fround(Math_fround(f32 * f33) - Math_fround(f36 * f39))) + Math_fround(f34 * f16))) * Math_fround(2.0))));
 f18 = Math_fround(f12 - Math_fround(f40 * Math_fround(Math_fround(Math_fround(f33 * f38) + Math_fround(Math_fround(f37 * Math_fround(Math_fround(f34 * f39) - Math_fround(f32 * f35))) + Math_fround(f36 * f16))) * Math_fround(2.0))));
 f16 = Math_fround(f11 - Math_fround(f40 * Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(Math_fround(f37 * Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33))) + Math_fround(f32 * f16))) * Math_fround(2.0))));
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i5 = i14 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = Math_fround(1.0);
 i5 = i14 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(1.0);
 i5 = i14 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i14 + 60 >> 2] = Math_fround(1.0);
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -65281) | 0, i14) | 0, 1) | 0;
 HEAPF32[i31 >> 2] = f13;
 HEAPF32[i31 + 4 >> 2] = f12;
 HEAPF32[i31 + 8 >> 2] = f11;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i31) | 0;
 HEAPF32[i30 >> 2] = f19;
 HEAPF32[i30 + 4 >> 2] = f18;
 HEAPF32[i30 + 8 >> 2] = f16;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i30) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -16711681) | 0, i14) | 0, 1) | 0;
 f16 = Math_fround(f13 + Math_fround(0.0));
 f18 = Math_fround(f12 + Math_fround(.0500000007));
 f19 = Math_fround(f11 + Math_fround(0.0));
 HEAPF32[i29 >> 2] = f16;
 HEAPF32[i29 + 4 >> 2] = f18;
 HEAPF32[i29 + 8 >> 2] = f19;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i29) | 0;
 f18 = Math_fround(f12 + Math_fround(-.0500000007));
 HEAPF32[i28 >> 2] = f13;
 HEAPF32[i28 + 4 >> 2] = f18;
 HEAPF32[i28 + 8 >> 2] = f11;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i28) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -16711681) | 0, i14) | 0, 1) | 0;
 f18 = Math_fround(f12 + Math_fround(0.0));
 HEAPF32[i27 >> 2] = Math_fround(f13 + Math_fround(.0500000007));
 HEAPF32[i27 + 4 >> 2] = f18;
 HEAPF32[i27 + 8 >> 2] = f19;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i27) | 0;
 HEAPF32[i26 >> 2] = Math_fround(f13 + Math_fround(-.0500000007));
 HEAPF32[i26 + 4 >> 2] = f12;
 HEAPF32[i26 + 8 >> 2] = f11;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i26) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -16711681) | 0, i14) | 0, 1) | 0;
 f19 = Math_fround(f11 + Math_fround(.0500000007));
 HEAPF32[i25 >> 2] = f16;
 HEAPF32[i25 + 4 >> 2] = f18;
 HEAPF32[i25 + 8 >> 2] = f19;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i25) | 0;
 f19 = Math_fround(f11 + Math_fround(-.0500000007));
 HEAPF32[i24 >> 2] = f13;
 HEAPF32[i24 + 4 >> 2] = f12;
 HEAPF32[i24 + 8 >> 2] = f19;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i24) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -65536) | 0, i14) | 0, 1) | 0;
 f19 = Math_fround(f9 + Math_fround(0.0));
 f18 = Math_fround(f8 + Math_fround(.100000001));
 f16 = Math_fround(f7 + Math_fround(0.0));
 HEAPF32[i23 >> 2] = f19;
 HEAPF32[i23 + 4 >> 2] = f18;
 HEAPF32[i23 + 8 >> 2] = f16;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i23) | 0;
 f18 = Math_fround(f8 + Math_fround(-.100000001));
 HEAPF32[i22 >> 2] = f9;
 HEAPF32[i22 + 4 >> 2] = f18;
 HEAPF32[i22 + 8 >> 2] = f7;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i22) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -65536) | 0, i14) | 0, 1) | 0;
 f18 = Math_fround(f8 + Math_fround(0.0));
 HEAPF32[i21 >> 2] = Math_fround(f9 + Math_fround(.100000001));
 HEAPF32[i21 + 4 >> 2] = f18;
 HEAPF32[i21 + 8 >> 2] = f16;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i21) | 0;
 HEAPF32[i20 >> 2] = Math_fround(f9 + Math_fround(-.100000001));
 HEAPF32[i20 + 4 >> 2] = f8;
 HEAPF32[i20 + 8 >> 2] = f7;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i20) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -65536) | 0, i14) | 0, 1) | 0;
 f16 = Math_fround(f7 + Math_fround(.100000001));
 HEAPF32[i17 >> 2] = f19;
 HEAPF32[i17 + 4 >> 2] = f18;
 HEAPF32[i17 + 8 >> 2] = f16;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i17) | 0;
 f16 = Math_fround(f7 + Math_fround(-.100000001));
 HEAPF32[i15 >> 2] = f9;
 HEAPF32[i15 + 4 >> 2] = f8;
 HEAPF32[i15 + 8 >> 2] = f16;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i15) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i3, -65536) | 0, i14) | 0, 1) | 0;
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i10 + 4 >> 2] = f12;
 HEAPF32[i10 + 8 >> 2] = f11;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i10) | 0;
 HEAPF32[i6 >> 2] = f9;
 HEAPF32[i6 + 4 >> 2] = f8;
 HEAPF32[i6 + 8 >> 2] = f7;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i6) | 0;
 STACKTOP = i1;
 return;
}

function __ZL17CreateLogoPresetsj(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i7 = i10;
 i1 = __Z17GetPlayerSettingsv() | 0;
 if ((HEAP32[i1 + 228 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  HEAP32[gb + 1157880 >> 2] = 0;
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 216 >> 2] | 0;
 i8 = HEAP32[i6 + (i2 << 3) >> 2] | 0;
 i6 = HEAP32[i6 + (i2 << 3) + 4 >> 2] | 0;
 i4 = (i8 | 0) == 0;
 if (i4) i1 = 0; else {
  HEAP32[i7 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 11;
   }
  }
  if ((i9 | 0) == 9) i9 = 11;
  if ((i9 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
 }
 if ((i1 | 0) == (HEAP32[gb + 1157860 >> 2] | 0)) {
  d12 = +Math_fround(_fmaxf((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])), Math_fround(2.0)));
  HEAPF64[gb + 1098080 >> 3] = d12;
  HEAP32[gb + 1157876 >> 2] = HEAP32[gb + 1157864 >> 2];
  i4 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 20; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
     i2 = HEAP32[i5 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 20; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 22;
    }
   }
   if ((i9 | 0) == 20) i9 = 22;
   if ((i9 | 0) == 22) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
  HEAP32[gb + 1157880 >> 2] = i1;
  i7 = (HEAP32[(__Z17GetPlayerSettingsv() | 0) + 152 >> 2] | 0) == 0;
  i7 = i7 ? gb + 43052 | 0 : gb + 62560 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = HEAP32[i7 + 8 >> 2] | 0;
  i11 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[gb + 1157884 >> 2] = HEAP32[i7 >> 2];
  HEAP32[gb + 1157884 + 4 >> 2] = i8;
  HEAP32[gb + 1157884 + 8 >> 2] = i9;
  HEAP32[gb + 1157884 + 12 >> 2] = i11;
  __ZL9SetUvRectP6SpriteR5RectTIfE(HEAP32[gb + 1157860 >> 2] | 0, gb + 1157900 | 0);
  i11 = 1;
  STACKTOP = i10;
  return i11 | 0;
 }
 do if (i4) i9 = 70; else {
  HEAP32[i7 >> 2] = i8;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i9 = 31; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i2, i7);
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i2 = i11;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 31; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 33;
  }
  if ((i9 | 0) == 31) i9 = 33;
  if ((i9 | 0) == 33) {
   if (!(__Z31ReadObjectFromPersistentManageri(i8) | 0)) {
    i9 = 70;
    break;
   }
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i8;
  if (!i2) i9 = 40; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i2, i7);
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i2 = i11;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 40; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 42;
   }
  }
  if ((i9 | 0) == 40) i9 = 42;
  if ((i9 | 0) == 42) {
   i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  i11 = i1 + 32 | 0;
  f13 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f13 = Math_fround(f13 / Math_fround(HEAPF32[i11 + 12 >> 2]));
  HEAPF32[gb + 1157876 >> 2] = f13;
  HEAP32[i7 >> 2] = i8;
  if (!i2) i9 = 48; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i11 + (i3 << 3) | 0;
    i2 = i11;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i2, i7);
    i1 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i1 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 48; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 50;
   }
  }
  if ((i9 | 0) == 48) i9 = 50;
  if ((i9 | 0) == 50) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
  i4 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 57; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
     i2 = HEAP32[i5 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 57; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 59;
    }
   }
   if ((i9 | 0) == 57) i9 = 59;
   if ((i9 | 0) == 59) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
  HEAP32[gb + 1157880 >> 2] = i1;
  HEAP32[gb + 1157884 >> 2] = 1065353216;
  HEAP32[gb + 1157884 + 4 >> 2] = 1065353216;
  HEAP32[gb + 1157884 + 8 >> 2] = 1065353216;
  HEAP32[gb + 1157884 + 12 >> 2] = 1065353216;
  HEAP32[i7 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 66; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 66; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 68;
   }
  }
  if ((i9 | 0) == 66) i9 = 68;
  if ((i9 | 0) == 68) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
  __ZL9SetUvRectP6SpriteR5RectTIfE(i1, gb + 1157900 | 0);
 } while (0);
 if ((i9 | 0) == 70) HEAP32[gb + 1157880 >> 2] = 0;
 d12 = +Math_fround(_fmaxf((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])), Math_fround(2.0)));
 HEAPF64[gb + 1098080 >> 3] = d12;
 i11 = 1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj(i34, i29, i27, i28, i33, i38, i44) {
 i34 = i34 | 0;
 i29 = i29 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i33 = i33 | 0;
 i38 = i38 | 0;
 i44 = i44 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i30 = 0, i31 = 0, i32 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i45 = 0, i46 = 0, f47 = f0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i46 + 160 | 0;
 i39 = i46 + 144 | 0;
 i40 = i46 + 176 | 0;
 i41 = i46 + 128 | 0;
 i42 = i46 + 112 | 0;
 i43 = i46 + 96 | 0;
 i30 = i46 + 80 | 0;
 i31 = i46 + 64 | 0;
 i32 = i46 + 48 | 0;
 i35 = i46 + 32 | 0;
 i36 = i46 + 16 | 0;
 i37 = i46;
 HEAP32[i45 >> 2] = 0;
 HEAP32[i45 + 4 >> 2] = 0;
 HEAP32[i45 + 8 >> 2] = 0;
 HEAP32[i45 + 12 >> 2] = 0;
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 f7 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 i21 = i29 + 16 | 0;
 f25 = Math_fround(HEAPF32[i29 + 16 >> 2]);
 f26 = Math_fround(HEAPF32[i29 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i29 + 24 >> 2]);
 i3 = i29 + 32 | 0;
 f4 = Math_fround(HEAPF32[i29 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i29 + 36 >> 2]);
 f6 = Math_fround(HEAPF32[i29 + 40 >> 2]);
 f8 = Math_fround(HEAPF32[i29 + 48 >> 2]);
 f9 = Math_fround(HEAPF32[i29 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i29 + 56 >> 2]);
 f11 = Math_fround(f25 - f1);
 f12 = Math_fround(f26 - f7);
 f13 = Math_fround(f2 - f20);
 f14 = Math_fround(f4 - f1);
 f15 = Math_fround(f5 - f7);
 f16 = Math_fround(f6 - f20);
 f17 = Math_fround(Math_fround(f12 * f16) - Math_fround(f13 * f15));
 f18 = Math_fround(Math_fround(f13 * f14) - Math_fround(f11 * f16));
 f19 = Math_fround(Math_fround(f11 * f15) - Math_fround(f12 * f14));
 f47 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18))))));
 f22 = Math_fround(f8 - f1);
 f23 = Math_fround(f9 - f7);
 f24 = Math_fround(f10 - f20);
 if (Math_fround(Math_abs(Math_fround(Math_fround(f24 * Math_fround(f19 * f47)) + Math_fround(Math_fround(f22 * Math_fround(f17 * f47)) + Math_fround(f23 * Math_fround(f18 * f47)))))) < Math_fround(.0000999999974)) {
  HEAP32[i44 >> 2] = 3;
  __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj(i34, i29, i27, i28, i33, i38, i44);
  STACKTOP = i46;
  return;
 }
 f56 = Math_fround(f8 - f25);
 f54 = Math_fround(f9 - f26);
 f58 = Math_fround(f10 - f2);
 f55 = Math_fround(f4 - f25);
 f57 = Math_fround(f5 - f26);
 f47 = Math_fround(f6 - f2);
 f53 = Math_fround(Math_fround(f15 * f24) - Math_fround(f16 * f23));
 f52 = Math_fround(Math_fround(f16 * f22) - Math_fround(f14 * f24));
 f14 = Math_fround(Math_fround(f14 * f23) - Math_fround(f15 * f22));
 f15 = Math_fround(Math_fround(f13 * f23) - Math_fround(f12 * f24));
 f16 = Math_fround(Math_fround(f11 * f24) - Math_fround(f13 * f22));
 f22 = Math_fround(Math_fround(f12 * f22) - Math_fround(f11 * f23));
 f24 = Math_fround(Math_fround(f47 * f54) - Math_fround(f57 * f58));
 f47 = Math_fround(Math_fround(f55 * f58) - Math_fround(f47 * f56));
 f23 = Math_fround(Math_fround(f57 * f56) - Math_fround(f55 * f54));
 i49 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f1 * f17) + Math_fround(f7 * f18))) * Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(f8 * f17) + Math_fround(f9 * f18)))) >= Math_fround(-9.99999997e-07);
 i50 = Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(Math_fround(f1 * f53) + Math_fround(f7 * f52))) * Math_fround(Math_fround(f2 * f14) + Math_fround(Math_fround(f25 * f53) + Math_fround(f26 * f52)))) >= Math_fround(-9.99999997e-07);
 i48 = Math_fround(Math_fround(Math_fround(f20 * f22) + Math_fround(Math_fround(f1 * f15) + Math_fround(f7 * f16))) * Math_fround(Math_fround(f6 * f22) + Math_fround(Math_fround(f4 * f15) + Math_fround(f5 * f16)))) >= Math_fround(-9.99999997e-07);
 i51 = Math_fround(Math_fround(Math_fround(f2 * f23) + Math_fround(Math_fround(f25 * f24) + Math_fround(f26 * f47))) * Math_fround(Math_fround(f20 * f23) + Math_fround(Math_fround(f1 * f24) + Math_fround(f7 * f47)))) >= Math_fround(-9.99999997e-07);
 HEAP32[i39 >> 2] = i49 << 31 >> 31;
 HEAP32[i39 + 4 >> 2] = i50 << 31 >> 31;
 HEAP32[i39 + 8 >> 2] = i48 << 31 >> 31;
 HEAP32[i39 + 12 >> 2] = i51 << 31 >> 31;
 if (i51 | (i50 | i49 | i48)) {
  HEAP32[i40 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  __ZN5physx2GuL25getClosestPtPointTriangleEPNS_6shdfnd3aos5Vec3VERKNS2_5BoolVEPjRj(i34, i29, i39, i40, i44);
  i49 = HEAP32[i40 >> 2] | 0;
  i50 = i29 + (i49 << 4) | 0;
  HEAP32[i41 >> 2] = HEAP32[i50 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i50 + 8 >> 2];
  HEAP32[i41 + 12 >> 2] = HEAP32[i50 + 12 >> 2];
  i50 = HEAP32[i40 + 4 >> 2] | 0;
  i51 = i29 + (i50 << 4) | 0;
  HEAP32[i42 >> 2] = HEAP32[i51 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i51 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i51 + 8 >> 2];
  HEAP32[i42 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
  i51 = HEAP32[i40 + 8 >> 2] | 0;
  i44 = i29 + (i51 << 4) | 0;
  HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i27 + (i49 << 4) | 0;
  HEAP32[i30 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i27 + (i50 << 4) | 0;
  HEAP32[i31 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i27 + (i51 << 4) | 0;
  HEAP32[i32 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i28 + (i49 << 4) | 0;
  HEAP32[i35 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i28 + (i50 << 4) | 0;
  HEAP32[i36 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = i28 + (i51 << 4) | 0;
  HEAP32[i37 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i37 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i37 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  HEAP32[i37 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
  i44 = HEAP32[i33 + (i49 << 2) >> 2] | 0;
  i45 = HEAP32[i33 + (i50 << 2) >> 2] | 0;
  i48 = HEAP32[i33 + (i51 << 2) >> 2] | 0;
  i49 = HEAP32[i38 + (i49 << 2) >> 2] | 0;
  i50 = HEAP32[i38 + (i50 << 2) >> 2] | 0;
  i51 = HEAP32[i38 + (i51 << 2) >> 2] | 0;
  HEAP32[i29 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  i43 = i27 + 16 | 0;
  HEAP32[i43 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  i43 = i27 + 32 | 0;
  HEAP32[i43 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  HEAP32[i28 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
  i43 = i28 + 16 | 0;
  HEAP32[i43 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
  i43 = i28 + 32 | 0;
  HEAP32[i43 >> 2] = HEAP32[i37 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
  HEAP32[i43 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
  HEAP32[i33 >> 2] = i44;
  HEAP32[i33 + 4 >> 2] = i45;
  HEAP32[i33 + 8 >> 2] = i48;
  HEAP32[i38 >> 2] = i49;
  HEAP32[i38 + 4 >> 2] = i50;
  HEAP32[i38 + 8 >> 2] = i51;
  STACKTOP = i46;
  return;
 } else {
  HEAP32[i34 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
  STACKTOP = i46;
  return;
 }
}

function __ZL23contactHullHeightfield2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEb(i6, i4, i7, i8, i9, f2, i1, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 6800 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10 + 2376 | 0;
 i18 = i10 + 2400 | 0;
 i17 = i10 + 2328 | 0;
 i15 = i10 + 68 | 0;
 i19 = i10 + 40 | 0;
 i11 = i10 + 24 | 0;
 i12 = i10 + 96 | 0;
 i13 = i10;
 HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i14 + 16 >> 2] = i7;
 HEAPF32[i14 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i7 + 8 >> 2]));
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i7 + 12 >> 2]));
 HEAPF32[i14 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i7 + 16 >> 2]));
 f27 = Math_fround(HEAPF32[i8 >> 2]);
 f26 = Math_fround(f27 + f27);
 i39 = i8 + 4 | 0;
 f29 = Math_fround(HEAPF32[i39 >> 2]);
 f24 = Math_fround(f29 + f29);
 i40 = i8 + 8 | 0;
 f28 = Math_fround(HEAPF32[i40 >> 2]);
 f23 = Math_fround(f28 + f28);
 i41 = i8 + 12 | 0;
 f32 = Math_fround(HEAPF32[i41 >> 2]);
 f22 = Math_fround(f26 * f32);
 f20 = Math_fround(f24 * f32);
 f32 = Math_fround(f32 * f23);
 f26 = Math_fround(f27 * f26);
 f30 = Math_fround(f27 * f24);
 f27 = Math_fround(f27 * f23);
 f24 = Math_fround(f29 * f24);
 f29 = Math_fround(f29 * f23);
 f23 = Math_fround(f28 * f23);
 HEAPF32[i18 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f24) - f23);
 HEAPF32[i18 + 4 >> 2] = Math_fround(f30 + f32);
 HEAPF32[i18 + 8 >> 2] = Math_fround(f27 - f20);
 HEAPF32[i18 + 12 >> 2] = Math_fround(f30 - f32);
 f26 = Math_fround(Math_fround(1.0) - f26);
 HEAPF32[i18 + 16 >> 2] = Math_fround(f26 - f23);
 HEAPF32[i18 + 20 >> 2] = Math_fround(f29 + f22);
 HEAPF32[i18 + 24 >> 2] = Math_fround(f27 + f20);
 HEAPF32[i18 + 28 >> 2] = Math_fround(f29 - f22);
 HEAPF32[i18 + 32 >> 2] = Math_fround(f26 - f24);
 i47 = HEAP32[i8 + 16 >> 2] | 0;
 HEAP32[i18 + 36 >> 2] = i47;
 i37 = i8 + 20 | 0;
 i45 = HEAP32[i37 >> 2] | 0;
 HEAP32[i18 + 40 >> 2] = i45;
 i35 = i8 + 24 | 0;
 i43 = HEAP32[i35 >> 2] | 0;
 HEAP32[i18 + 44 >> 2] = i43;
 f24 = Math_fround(HEAPF32[i9 >> 2]);
 f26 = Math_fround(f24 + f24);
 i7 = i9 + 4 | 0;
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 f29 = Math_fround(f22 + f22);
 i33 = i9 + 8 | 0;
 f20 = Math_fround(HEAPF32[i33 >> 2]);
 f27 = Math_fround(f20 + f20);
 i34 = i9 + 12 | 0;
 f23 = Math_fround(HEAPF32[i34 >> 2]);
 f32 = Math_fround(f26 * f23);
 f30 = Math_fround(f29 * f23);
 f28 = Math_fround(f23 * f27);
 f26 = Math_fround(f24 * f26);
 f21 = Math_fround(f24 * f29);
 f31 = Math_fround(f24 * f27);
 f29 = Math_fround(f22 * f29);
 f25 = Math_fround(f22 * f27);
 f27 = Math_fround(f20 * f27);
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f29) - f27);
 HEAPF32[i17 + 4 >> 2] = Math_fround(f21 + f28);
 HEAPF32[i17 + 8 >> 2] = Math_fround(f31 - f30);
 HEAPF32[i17 + 12 >> 2] = Math_fround(f21 - f28);
 f26 = Math_fround(Math_fround(1.0) - f26);
 HEAPF32[i17 + 16 >> 2] = Math_fround(f26 - f27);
 HEAPF32[i17 + 20 >> 2] = Math_fround(f25 + f32);
 HEAPF32[i17 + 24 >> 2] = Math_fround(f31 + f30);
 HEAPF32[i17 + 28 >> 2] = Math_fround(f25 - f32);
 HEAPF32[i17 + 32 >> 2] = Math_fround(f26 - f29);
 i46 = HEAP32[i9 + 16 >> 2] | 0;
 HEAP32[i17 + 36 >> 2] = i46;
 i38 = i9 + 20 | 0;
 i44 = HEAP32[i38 >> 2] | 0;
 HEAP32[i17 + 40 >> 2] = i44;
 i36 = i9 + 24 | 0;
 i42 = HEAP32[i36 >> 2] | 0;
 HEAP32[i17 + 44 >> 2] = i42;
 f24 = Math_fround(-f24);
 f22 = Math_fround(-f22);
 f20 = Math_fround(-f20);
 f29 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f26 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f26 - (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f32 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f29 * Math_fround(2.0));
 f26 = Math_fround(f26 * Math_fround(2.0));
 f32 = Math_fround(Math_fround(f32 - (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f24) + Math_fround(f26 * f22)) + Math_fround(f32 * f20));
 f31 = Math_fround(Math_fround(f30 * f24) + Math_fround(Math_fround(f25 * f29) + Math_fround(f23 * Math_fround(Math_fround(f32 * f22) - Math_fround(f26 * f20)))));
 f27 = Math_fround(Math_fround(f30 * f22) + Math_fround(Math_fround(f25 * f26) + Math_fround(f23 * Math_fround(Math_fround(f29 * f20) - Math_fround(f32 * f24)))));
 f30 = Math_fround(Math_fround(Math_fround(f25 * f32) + Math_fround(f23 * Math_fround(Math_fround(f26 * f24) - Math_fround(f29 * f22)))) + Math_fround(f30 * f20));
 f29 = Math_fround(HEAPF32[i8 >> 2]);
 f26 = Math_fround(f23 * f29);
 f32 = Math_fround(HEAPF32[i41 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f32 * f24));
 f25 = Math_fround(HEAPF32[i40 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f25 * f22));
 f28 = Math_fround(HEAPF32[i39 >> 2]);
 f21 = Math_fround(Math_fround(Math_fround(f29 * f20) + Math_fround(Math_fround(f32 * f22) + Math_fround(f23 * f28))) - Math_fround(f25 * f24));
 f16 = Math_fround(Math_fround(Math_fround(f28 * f24) + Math_fround(Math_fround(f32 * f20) + Math_fround(f23 * f25))) - Math_fround(f29 * f22));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f32) - Math_fround(f29 * f24)) - Math_fround(f28 * f22)) - Math_fround(f25 * f20));
 HEAPF32[i15 >> 2] = Math_fround(f26 - Math_fround(f28 * f20));
 HEAPF32[i15 + 4 >> 2] = f21;
 HEAPF32[i15 + 8 >> 2] = f16;
 HEAPF32[i15 + 12 >> 2] = f22;
 HEAPF32[i15 + 16 >> 2] = f31;
 HEAPF32[i15 + 20 >> 2] = f27;
 HEAPF32[i15 + 24 >> 2] = f30;
 f29 = Math_fround(-f29);
 f28 = Math_fround(-f28);
 f25 = Math_fround(-f25);
 f30 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i8 + 16 >> 2]));
 f27 = Math_fround(HEAPF32[i38 >> 2]);
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i37 >> 2]));
 f31 = Math_fround(HEAPF32[i36 >> 2]);
 f30 = Math_fround(f30 * Math_fround(2.0));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f31 = Math_fround(Math_fround(f31 - Math_fround(HEAPF32[i35 >> 2])) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f27 * f28)) + Math_fround(f31 * f25));
 f21 = Math_fround(Math_fround(f16 * f29) + Math_fround(Math_fround(f22 * f30) + Math_fround(f32 * Math_fround(Math_fround(f31 * f28) - Math_fround(f27 * f25)))));
 f20 = Math_fround(Math_fround(f16 * f28) + Math_fround(Math_fround(f22 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f25) - Math_fround(f31 * f29)))));
 f16 = Math_fround(Math_fround(Math_fround(f22 * f31) + Math_fround(f32 * Math_fround(Math_fround(f27 * f29) - Math_fround(f30 * f28)))) + Math_fround(f16 * f25));
 f30 = Math_fround(HEAPF32[i9 >> 2]);
 f27 = Math_fround(f32 * f30);
 f31 = Math_fround(HEAPF32[i34 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f31 * f29));
 f22 = Math_fround(HEAPF32[i33 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f22 * f28));
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 f24 = Math_fround(Math_fround(Math_fround(f30 * f25) + Math_fround(Math_fround(f31 * f28) + Math_fround(f32 * f26))) - Math_fround(f22 * f29));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f29) + Math_fround(Math_fround(f31 * f25) + Math_fround(f32 * f22))) - Math_fround(f30 * f28));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f31) - Math_fround(f30 * f29)) - Math_fround(f26 * f28)) - Math_fround(f22 * f25));
 HEAPF32[i19 >> 2] = Math_fround(f27 - Math_fround(f26 * f25));
 HEAPF32[i19 + 4 >> 2] = f24;
 HEAPF32[i19 + 8 >> 2] = f23;
 HEAPF32[i19 + 12 >> 2] = f22;
 HEAPF32[i19 + 16 >> 2] = f21;
 HEAPF32[i19 + 20 >> 2] = f20;
 HEAPF32[i19 + 24 >> 2] = f16;
 __ZN5physx2Gu9ContainerC2Ev(i11);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i11, 1088, i10 + 2448 | 0, 1);
 f16 = Math_fround(HEAPF32[i1 + 4100 >> 2]);
 HEAP32[i12 >> 2] = gb + 84136 + 8;
 i7 = i12 + 4 | 0;
 __ZN5physx2Gu29ConvexVsMeshContactGenerationC2ERNS0_9ContainerERKNS_11PxTransformES6_RKNS0_13PolygonalDataERKNS_2Cm8Matrix34ESD_RKNSA_23FastVertex2ShapeScalingEfbfS6_S6_RNS0_13ContactBufferE(i7, i11, i15, i19, i6, i18, i17, i3, f2, i5, f16, i8, i9, i1);
 HEAP32[i12 + 2228 >> 2] = i14;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i13, i15, i4);
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i14, i9, i13, 0, i12) | 0;
 __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv(i7);
 i9 = (HEAP8[i12 + 2224 >> 0] | 0) != 0;
 __ZN5physx2Gu9ContainerD2Ev(i11);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration20generateLastContactsEv(i46) {
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i50 + 192 | 0;
 i44 = i50 + 48 | 0;
 i45 = i50 + 32 | 0;
 i47 = i50 + 16 | 0;
 i48 = i50;
 i1 = HEAP32[i46 + 4416 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i50;
  return;
 }
 i43 = (i2 >>> 0) / 15 | 0;
 i41 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 <= 14) {
  STACKTOP = i50;
  return;
 }
 i16 = i44 + 64 | 0;
 i17 = i44 + 80 | 0;
 i18 = i44 + 16 | 0;
 i19 = i44 + 32 | 0;
 i20 = i44 + 48 | 0;
 i21 = i44 + 96 | 0;
 i22 = i44 + 4 | 0;
 i23 = i44 + 8 | 0;
 i24 = i44 + 12 | 0;
 i25 = i44 + 100 | 0;
 i26 = i44 + 104 | 0;
 i27 = i44 + 108 | 0;
 i28 = i44 + 112 | 0;
 i29 = i44 + 116 | 0;
 i30 = i44 + 120 | 0;
 i31 = i44 + 124 | 0;
 i32 = i44 + 128 | 0;
 i33 = i44 + 132 | 0;
 i34 = i44 + 136 | 0;
 i35 = i44 + 140 | 0;
 i36 = i46 + 2324 | 0;
 i37 = i46 + 2320 | 0;
 i38 = i46 + 2176 | 0;
 i39 = i44 + 96 | 0;
 i40 = 0;
 do {
  i13 = HEAP32[i41 + (i40 * 60 | 0) + 36 >> 2] | 0;
  i14 = HEAP32[i41 + (i40 * 60 | 0) + 40 >> 2] | 0;
  i15 = HEAP32[i41 + (i40 * 60 | 0) + 44 >> 2] | 0;
  i7 = HEAP8[i41 + (i40 * 60 | 0) + 56 >> 0] | 0;
  i6 = i7 & 255;
  L9 : do if (!(i6 & 8)) {
   i3 = i13 >>> 0 < i14 >>> 0;
   i2 = i3 ? i13 : i14;
   i3 = i3 ? i14 : i13;
   i1 = i2 << 16 | i3;
   i1 = i1 + ~(i1 << 15) | 0;
   i1 = (i1 >>> 10 ^ i1) * 9 | 0;
   i1 = i1 >>> 6 ^ i1;
   i1 = i1 + ~(i1 << 11) | 0;
   i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i46 + 3488) >> 0] | 0;
   if (i1 << 24 >> 24 == -1) i49 = 10; else {
    i1 = i1 & 255;
    while (1) {
     if ((HEAP32[i46 + 2336 + (i1 << 3) >> 2] | 0) == (i2 | 0)) if ((HEAP32[i46 + 2336 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) break L9;
     i1 = HEAP8[i46 + 3360 + i1 >> 0] | 0;
     if (i1 << 24 >> 24 == -1) {
      i49 = 10;
      break;
     } else i1 = i1 & 255;
    }
   }
  } else i49 = 10; while (0);
  L17 : do if ((i49 | 0) == 10) {
   i49 = 0;
   if (!(i6 & 16)) {
    i3 = i14 >>> 0 < i15 >>> 0;
    i2 = i3 ? i14 : i15;
    i3 = i3 ? i15 : i14;
    i1 = i2 << 16 | i3;
    i1 = i1 + ~(i1 << 15) | 0;
    i1 = (i1 >>> 10 ^ i1) * 9 | 0;
    i1 = i1 >>> 6 ^ i1;
    i1 = i1 + ~(i1 << 11) | 0;
    i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i46 + 3488) >> 0] | 0;
    if (i1 << 24 >> 24 != -1) {
     i1 = i1 & 255;
     while (1) {
      if ((HEAP32[i46 + 2336 + (i1 << 3) >> 2] | 0) == (i2 | 0)) if ((HEAP32[i46 + 2336 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) break L17;
      i1 = HEAP8[i46 + 3360 + i1 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) break; else i1 = i1 & 255;
     }
    }
   }
   if (!(i6 & 32)) {
    i3 = i15 >>> 0 < i13 >>> 0;
    i2 = i3 ? i15 : i13;
    i3 = i3 ? i13 : i15;
    i1 = i2 << 16 | i3;
    i1 = i1 + ~(i1 << 15) | 0;
    i1 = (i1 >>> 10 ^ i1) * 9 | 0;
    i1 = i1 >>> 6 ^ i1;
    i1 = i1 + ~(i1 << 11) | 0;
    i1 = HEAP8[((i1 >>> 16 ^ i1) & 127) + (i46 + 3488) >> 0] | 0;
    if (i1 << 24 >> 24 != -1) {
     i1 = i1 & 255;
     while (1) {
      if ((HEAP32[i46 + 2336 + (i1 << 3) >> 2] | 0) == (i2 | 0)) if ((HEAP32[i46 + 2336 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) break L17;
      i1 = HEAP8[i46 + 3360 + i1 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) break; else i1 = i1 & 255;
     }
    }
   }
   HEAP32[i17 >> 2] = 7;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   HEAPF32[i20 >> 2] = Math_fround(0.0);
   HEAP32[i42 >> 2] = 0;
   HEAP32[i42 + 4 >> 2] = 0;
   HEAP32[i42 + 8 >> 2] = 0;
   HEAP32[i42 + 12 >> 2] = 0;
   HEAP32[i16 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i42 + 12 >> 2];
   i2 = HEAP32[i41 + (i40 * 60 | 0) >> 2] | 0;
   i3 = HEAP32[i41 + (i40 * 60 | 0) + 4 >> 2] | 0;
   i6 = HEAP32[i41 + (i40 * 60 | 0) + 8 >> 2] | 0;
   i8 = HEAP32[i41 + (i40 * 60 | 0) + 12 >> 2] | 0;
   i9 = HEAP32[i41 + (i40 * 60 | 0) + 16 >> 2] | 0;
   i10 = HEAP32[i41 + (i40 * 60 | 0) + 20 >> 2] | 0;
   i11 = HEAP32[i41 + (i40 * 60 | 0) + 24 >> 2] | 0;
   i1 = HEAP32[i41 + (i40 * 60 | 0) + 28 >> 2] | 0;
   i12 = HEAP32[i41 + (i40 * 60 | 0) + 32 >> 2] | 0;
   f51 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f51 = Math_fround(f51 + (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(f4 + (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f51 = Math_fround(f51 + (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f4 = Math_fround(f4 + (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f4 = Math_fround(f4 * Math_fround(.333332986));
   f5 = Math_fround(Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.333332986));
   HEAPF32[i44 >> 2] = Math_fround(f51 * Math_fround(.333332986));
   HEAPF32[i22 >> 2] = f4;
   HEAPF32[i23 >> 2] = f5;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   HEAP32[i21 >> 2] = i2;
   HEAP32[i25 >> 2] = i3;
   HEAP32[i26 >> 2] = i6;
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAP32[i28 >> 2] = i8;
   HEAP32[i29 >> 2] = i9;
   HEAP32[i30 >> 2] = i10;
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAP32[i32 >> 2] = i11;
   HEAP32[i33 >> 2] = i1;
   HEAP32[i34 >> 2] = i12;
   HEAPF32[i35 >> 2] = Math_fround(0.0);
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i12 = HEAP32[i36 >> 2] | 0;
   __ZN5physx2Gu32PCMConvexVsMeshContactGeneration31generatePolyDataContactManifoldERNS0_9TriangleVEjjhPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNS8_5Vec3VE(i46, i44, HEAP32[i41 + (i40 * 60 | 0) + 52 >> 2] | 0, HEAP32[i41 + (i40 * 60 | 0) + 48 >> 2] | 0, i7, HEAP32[i37 >> 2] | 0, i36, i38, i45) | 0;
   i1 = HEAP32[i36 >> 2] | 0;
   if (i1 >>> 0 > i12 >>> 0) {
    i9 = (i14 & 127) + (i46 + 4260) | 0;
    i10 = (i15 & 127) + (i46 + 4260) | 0;
    i11 = (i13 & 127) + (i46 + 4260) | 0;
    i2 = i1;
    i8 = i1;
    while (1) {
     i8 = i8 + -1 | 0;
     __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_((HEAP32[i37 >> 2] | 0) + (i8 << 6) + 16 | 0, i39, i28, i32, i47, i48);
     f4 = Math_fround(HEAPF32[i47 >> 2]);
     L41 : do if (f4 > Math_fround(.970000028)) {
      i1 = HEAP8[i9 >> 0] | 0;
      if (i1 << 24 >> 24 == -1) i1 = i2; else {
       i1 = i1 & 255;
       while (1) {
        if ((HEAP32[i46 + 3620 + (i1 << 2) >> 2] | 0) == (i14 | 0)) {
         i49 = 40;
         break L41;
        }
        i1 = HEAP8[i46 + 4132 + i1 >> 0] | 0;
        if (i1 << 24 >> 24 == -1) {
         i1 = i2;
         break;
        } else i1 = i1 & 255;
       }
      }
     } else {
      f5 = Math_fround(HEAPF32[i48 >> 2]);
      if (f5 > Math_fround(.970000028)) {
       i1 = HEAP8[i10 >> 0] | 0;
       if (i1 << 24 >> 24 == -1) {
        i1 = i2;
        break;
       }
       i1 = i1 & 255;
       while (1) {
        if ((HEAP32[i46 + 3620 + (i1 << 2) >> 2] | 0) == (i15 | 0)) {
         i49 = 40;
         break L41;
        }
        i1 = HEAP8[i46 + 4132 + i1 >> 0] | 0;
        if (i1 << 24 >> 24 == -1) {
         i1 = i2;
         break L41;
        } else i1 = i1 & 255;
       }
      }
      if (!(Math_fround(f4 + f5) <= Math_fround(.0299999714))) i1 = i2; else {
       i1 = HEAP8[i11 >> 0] | 0;
       if (i1 << 24 >> 24 == -1) i1 = i2; else {
        i1 = i1 & 255;
        while (1) {
         if ((HEAP32[i46 + 3620 + (i1 << 2) >> 2] | 0) == (i13 | 0)) {
          i49 = 40;
          break L41;
         }
         i1 = HEAP8[i46 + 4132 + i1 >> 0] | 0;
         if (i1 << 24 >> 24 == -1) {
          i1 = i2;
          break;
         } else i1 = i1 & 255;
        }
       }
      }
     } while (0);
     if ((i49 | 0) == 40) {
      i49 = 0;
      i1 = i2 + -1 | 0;
      if (i8 >>> 0 < i1 >>> 0) {
       i2 = i8;
       do {
        i6 = HEAP32[i37 >> 2] | 0;
        i3 = i6 + (i2 << 6) | 0;
        i2 = i2 + 1 | 0;
        i6 = i6 + (i2 << 6) | 0;
        i7 = i3 + 52 | 0;
        do {
         HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
         i3 = i3 + 4 | 0;
         i6 = i6 + 4 | 0;
        } while ((i3 | 0) < (i7 | 0));
       } while ((i2 | 0) != (i1 | 0));
      }
     }
     if (i8 >>> 0 <= i12 >>> 0) break; else i2 = i1;
    }
   }
   HEAP32[i36 >> 2] = i1;
   if ((i1 | 0) != (i12 | 0)) __ZN5physx2Gu32PCMConvexVsMeshContactGeneration18addContactsToPatchERKNS_6shdfnd3aos5Vec3VEjj(i46, i45, i12, i1 - i12 | 0);
  } while (0);
  i40 = i40 + 1 | 0;
 } while (i40 >>> 0 < i43 >>> 0);
 STACKTOP = i50;
 return;
}

function __ZN5physx7NpScene12removeActorsEPKPNS_7PxActorEjb(i22, i19, i21, i25) {
 i22 = i22 | 0;
 i19 = i19 | 0;
 i21 = i21 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i33 + 8 | 0;
 i23 = i33;
 i32 = i33 + 16 | 0;
 i7 = i22 + 16 | 0;
 i8 = i22 + 32 | 0;
 i16 = i22 + 3556 | 0;
 __ZN5physx2Sc5Scene24resizeReleasedBodyIDMapsEjj(i8, HEAP32[i16 >> 2] | 0, i21);
 i31 = i32 + 256 | 0;
 i28 = i32 + 260 | 0;
 i17 = i32 + 264 | 0;
 HEAP32[i17 >> 2] = 0;
 i29 = i32 + 268 | 0;
 HEAP8[i31 >> 0] = 1;
 HEAP32[i28 >> 2] = i32;
 HEAP32[i29 >> 2] = 64;
 i30 = i32 + 528 | 0;
 i18 = i32 + 532 | 0;
 i9 = i32 + 536 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i32 + 540 | 0;
 HEAP8[i30 >> 0] = 1;
 i27 = i32 + 272 | 0;
 HEAP32[i18 >> 2] = i27;
 HEAP32[i10 >> 2] = 64;
 i11 = i22 + 1268 | 0;
 HEAP32[i11 >> 2] = i32;
 L1 : do if (i21 | 0) {
  i12 = i22 + 3552 | 0;
  i13 = i22 + 3392 | 0;
  i14 = i22 + 3552 | 0;
  i20 = 0;
  L3 : while (1) {
   i3 = i20;
   i20 = i20 + 1 | 0;
   i15 = i20 >>> 0 < i21 >>> 0;
   if (i15) {
    i4 = HEAP32[i19 + (i20 << 2) >> 2] | 0;
    i2 = i4;
    i5 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
    i6 = getTempRet0() | 0;
    i2 = _i64Add(i2 | 0, 0, 287, 0) | 0;
    i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
    i1 = getTempRet0() | 0;
    i6 = _i64Subtract(1, 0, i5 | 0, i6 | 0) | 0;
    i1 = _i64Add(i6 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
    i2 = getTempRet0() | 0;
    while (1) {
     i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
     i2 = getTempRet0() | 0;
     if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i4 = i4 + 64 | 0;
    }
   }
   i6 = HEAP32[i19 + (i3 << 2) >> 2] | 0;
   i1 = HEAP16[i6 + 4 >> 1] | 0;
   if ((i22 | 0) != (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0) | 0)) {
    i26 = 7;
    break;
   }
   HEAP32[i17 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   L11 : do switch (i1 << 16 >> 16) {
   case 6:
    {
     i4 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0) | 0;
     i5 = i6 + 20 | 0;
     switch (HEAP16[i6 + 24 >> 1] | 0) {
     case 0:
      break;
     case 1:
      {
       i1 = i5;
       i26 = 12;
       break;
      }
     default:
      {
       i1 = HEAP32[i5 >> 2] | 0;
       i26 = 12;
      }
     }
     if ((i26 | 0) == 12) {
      i26 = 0;
      i3 = HEAP32[i1 >> 2] | 0;
      i2 = i3;
      i35 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
      i34 = getTempRet0() | 0;
      i2 = _i64Add(i2 | 0, 0, 207, 0) | 0;
      i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
      i1 = getTempRet0() | 0;
      i34 = _i64Subtract(1, 0, i35 | 0, i34 | 0) | 0;
      i1 = _i64Add(i34 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
      i2 = getTempRet0() | 0;
      while (1) {
       i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
       i2 = getTempRet0() | 0;
       if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
      }
     }
     __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_10StaticCoreE(i8, i6 + 64 | 0);
     i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) + -1 << 2) >> 2] | 0;
     i2 = i3;
     i34 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
     i35 = getTempRet0() | 0;
     i2 = _i64Add(i2 | 0, 0, 287, 0) | 0;
     i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
     i1 = getTempRet0() | 0;
     i35 = _i64Subtract(1, 0, i34 | 0, i35 | 0) | 0;
     i1 = _i64Add(i35 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
     i2 = getTempRet0() | 0;
     while (1) {
      i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
     }
     i1 = i6 + 48 | 0;
     if (!(i4 & 8)) __ZN5physx7NpActor26removeConstraintsFromSceneEv(i6 + 12 | 0);
     __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i5, i13);
     __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb(i7, i1, i25, (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i6 + 52 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 >> 1] & 8) != 0);
     i3 = i6 + 36 | 0;
     i1 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
     i35 = HEAP32[i3 >> 2] | 0;
     HEAP32[i16 >> 2] = i1;
     i34 = HEAP32[i14 >> 2] | 0;
     HEAP32[i34 + (i35 << 2) >> 2] = HEAP32[i34 + (i1 << 2) >> 2];
     if (i1 | 0) {
      i2 = HEAP32[i3 >> 2] | 0;
      if ((i1 | 0) != (i2 | 0)) {
       i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] | 0;
       switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
       case 0:
        {
         HEAP32[i1 + 36 >> 2] = HEAP32[i3 >> 2];
         break L11;
        }
       case 1:
        {
         HEAP32[i1 + 36 >> 2] = HEAP32[i3 >> 2];
         break L11;
        }
       default:
        break L11;
       }
      }
     }
     break;
    }
   case 5:
    {
     i4 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0) | 0;
     i5 = i6 + 20 | 0;
     switch (HEAP16[i6 + 24 >> 1] | 0) {
     case 0:
      break;
     case 1:
      {
       i1 = i5;
       i26 = 26;
       break;
      }
     default:
      {
       i1 = HEAP32[i5 >> 2] | 0;
       i26 = 26;
      }
     }
     if ((i26 | 0) == 26) {
      i26 = 0;
      i3 = HEAP32[i1 >> 2] | 0;
      i2 = i3;
      i34 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
      i35 = getTempRet0() | 0;
      i2 = _i64Add(i2 | 0, 0, 207, 0) | 0;
      i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
      i1 = getTempRet0() | 0;
      i35 = _i64Subtract(1, 0, i34 | 0, i35 | 0) | 0;
      i1 = _i64Add(i35 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
      i2 = getTempRet0() | 0;
      while (1) {
       i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
       i2 = getTempRet0() | 0;
       if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
      }
     }
     __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_8BodyCoreE(i8, i6 + 64 | 0);
     i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) + -1 << 2) >> 2] | 0;
     i2 = i3;
     i34 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
     i35 = getTempRet0() | 0;
     i2 = _i64Add(i2 | 0, 0, 287, 0) | 0;
     i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
     i1 = getTempRet0() | 0;
     i35 = _i64Subtract(1, 0, i34 | 0, i35 | 0) | 0;
     i1 = _i64Add(i35 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
     i2 = getTempRet0() | 0;
     while (1) {
      i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
     }
     i1 = i6 + 48 | 0;
     if (!(i4 & 8)) __ZN5physx7NpActor26removeConstraintsFromSceneEv(i6 + 12 | 0);
     __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i5, i13);
     __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i7, i1, i25, (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i6 + 52 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 >> 1] & 8) != 0);
     i3 = i6 + 36 | 0;
     i1 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
     i35 = HEAP32[i3 >> 2] | 0;
     HEAP32[i16 >> 2] = i1;
     i34 = HEAP32[i14 >> 2] | 0;
     HEAP32[i34 + (i35 << 2) >> 2] = HEAP32[i34 + (i1 << 2) >> 2];
     if (i1 | 0) {
      i2 = HEAP32[i3 >> 2] | 0;
      if ((i1 | 0) != (i2 | 0)) {
       i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] | 0;
       switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
       case 0:
        {
         HEAP32[i1 + 36 >> 2] = HEAP32[i3 >> 2];
         break L11;
        }
       case 1:
        {
         HEAP32[i1 + 36 >> 2] = HEAP32[i3 >> 2];
         break L11;
        }
       default:
        break L11;
       }
      }
     }
     break;
    }
   case 12:
   case 11:
   case 10:
    {
     __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb(i22, i6, i25, 1);
     break;
    }
   default:
    {
     i26 = 39;
     break L3;
    }
   } while (0);
   if (!i15) break L1;
  }
  if ((i26 | 0) == 7) {
   i35 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i23 >> 2] = gb + 709199;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i35, 8, gb + 678666 | 0, 76, gb + 708910 | 0, i23);
   break;
  } else if ((i26 | 0) == 39) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 645, gb + 709025 | 0, i24);
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = 0;
 i35 = HEAP32[i10 >> 2] | 0;
 do if ((i35 | 0) > -1 & (i35 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i18 >> 2] | 0;
  if ((i27 | 0) == (i1 | 0)) {
   HEAP8[i30 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i1 | 0);
  }
 } while (0);
 i35 = HEAP32[i29 >> 2] | 0;
 if (!((i35 | 0) > -1 & (i35 & 2147483647 | 0) != 0)) {
  STACKTOP = i33;
  return;
 }
 i1 = HEAP32[i28 >> 2] | 0;
 if ((i32 | 0) == (i1 | 0)) {
  HEAP8[i31 >> 0] = 0;
  STACKTOP = i33;
  return;
 }
 if (!i1) {
  STACKTOP = i33;
  return;
 }
 i35 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i35 >> 2] | 0) + 12 >> 2] | 0, i35 | 0, i1 | 0);
 STACKTOP = i33;
 return;
}

function __ZN5physx2Sc19ClothFabricBulkData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i2 + 800 | 0;
 i27 = i2 + 768 | 0;
 i26 = i2 + 736 | 0;
 i25 = i2 + 704 | 0;
 i24 = i2 + 672 | 0;
 i23 = i2 + 640 | 0;
 i22 = i2 + 608 | 0;
 i21 = i2 + 576 | 0;
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i28 >> 2] = HEAP32[gb + 128516 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 128516 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 128516 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 128516 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 128516 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 128516 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 128516 + 24 >> 2];
 HEAP32[i28 + 28 >> 2] = HEAP32[gb + 128516 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i28 | 0, 32) | 0;
 HEAP32[i27 >> 2] = HEAP32[gb + 128548 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[gb + 128548 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[gb + 128548 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[gb + 128548 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[gb + 128548 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[gb + 128548 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[gb + 128548 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[gb + 128548 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i27 | 0, 32) | 0;
 HEAP32[i26 >> 2] = gb + 1087820;
 HEAP32[i26 + 4 >> 2] = gb + 750149;
 HEAP32[i26 + 8 >> 2] = 4;
 HEAP32[i26 + 12 >> 2] = 4;
 HEAP32[i26 + 16 >> 2] = 1;
 HEAP32[i26 + 20 >> 2] = 0;
 HEAP32[i26 + 24 >> 2] = 8;
 HEAP32[i26 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i26 | 0, 32) | 0;
 HEAP32[i25 >> 2] = gb + 827882;
 HEAP32[i25 + 4 >> 2] = gb + 750163;
 HEAP32[i25 + 8 >> 2] = 8;
 HEAP32[i25 + 12 >> 2] = 4;
 HEAP32[i25 + 16 >> 2] = 1;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP32[i25 + 24 >> 2] = 0;
 HEAP32[i25 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i25 | 0, 32) | 0;
 HEAP32[i24 >> 2] = gb + 827882;
 HEAP32[i24 + 4 >> 2] = gb + 750177;
 HEAP32[i24 + 8 >> 2] = 12;
 HEAP32[i24 + 12 >> 2] = 4;
 HEAP32[i24 + 16 >> 2] = 1;
 HEAP32[i24 + 20 >> 2] = 0;
 HEAP32[i24 + 24 >> 2] = 2048;
 HEAP32[i24 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i24 | 0, 32) | 0;
 HEAP32[i23 >> 2] = gb + 827882;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 8;
 HEAP32[i23 + 12 >> 2] = 4;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 16;
 HEAP32[i23 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i23 | 0, 32) | 0;
 HEAP32[i22 >> 2] = gb + 1087820;
 HEAP32[i22 + 4 >> 2] = gb + 750195;
 HEAP32[i22 + 8 >> 2] = 16;
 HEAP32[i22 + 12 >> 2] = 4;
 HEAP32[i22 + 16 >> 2] = 1;
 HEAP32[i22 + 20 >> 2] = 0;
 HEAP32[i22 + 24 >> 2] = 8;
 HEAP32[i22 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i22 | 0, 32) | 0;
 HEAP32[i21 >> 2] = gb + 827882;
 HEAP32[i21 + 4 >> 2] = gb + 750207;
 HEAP32[i21 + 8 >> 2] = 20;
 HEAP32[i21 + 12 >> 2] = 4;
 HEAP32[i21 + 16 >> 2] = 1;
 HEAP32[i21 + 20 >> 2] = 0;
 HEAP32[i21 + 24 >> 2] = 0;
 HEAP32[i21 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i21 | 0, 32) | 0;
 HEAP32[i20 >> 2] = gb + 827882;
 HEAP32[i20 + 4 >> 2] = gb + 750219;
 HEAP32[i20 + 8 >> 2] = 24;
 HEAP32[i20 + 12 >> 2] = 4;
 HEAP32[i20 + 16 >> 2] = 1;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 24 >> 2] = 2048;
 HEAP32[i20 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = gb + 827882;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 20;
 HEAP32[i19 + 12 >> 2] = 4;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 16;
 HEAP32[i19 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = gb + 1087820;
 HEAP32[i18 + 4 >> 2] = gb + 750235;
 HEAP32[i18 + 8 >> 2] = 28;
 HEAP32[i18 + 12 >> 2] = 4;
 HEAP32[i18 + 16 >> 2] = 1;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 8;
 HEAP32[i18 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = gb + 827882;
 HEAP32[i17 + 4 >> 2] = gb + 750253;
 HEAP32[i17 + 8 >> 2] = 32;
 HEAP32[i17 + 12 >> 2] = 4;
 HEAP32[i17 + 16 >> 2] = 1;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = gb + 827882;
 HEAP32[i16 + 4 >> 2] = gb + 750271;
 HEAP32[i16 + 8 >> 2] = 36;
 HEAP32[i16 + 12 >> 2] = 4;
 HEAP32[i16 + 16 >> 2] = 1;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 2048;
 HEAP32[i16 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = gb + 827843;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 32;
 HEAP32[i15 + 12 >> 2] = 4;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 16;
 HEAP32[i15 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = gb + 1087820;
 HEAP32[i14 + 4 >> 2] = gb + 750293;
 HEAP32[i14 + 8 >> 2] = 40;
 HEAP32[i14 + 12 >> 2] = 4;
 HEAP32[i14 + 16 >> 2] = 1;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 8;
 HEAP32[i14 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = gb + 827882;
 HEAP32[i13 + 4 >> 2] = gb + 750308;
 HEAP32[i13 + 8 >> 2] = 44;
 HEAP32[i13 + 12 >> 2] = 4;
 HEAP32[i13 + 16 >> 2] = 1;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 HEAP32[i13 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = gb + 827882;
 HEAP32[i12 + 4 >> 2] = gb + 750323;
 HEAP32[i12 + 8 >> 2] = 48;
 HEAP32[i12 + 12 >> 2] = 4;
 HEAP32[i12 + 16 >> 2] = 1;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 2048;
 HEAP32[i12 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = gb + 827882;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 44;
 HEAP32[i11 + 12 >> 2] = 4;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 16;
 HEAP32[i11 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 1087820;
 HEAP32[i10 + 4 >> 2] = gb + 750342;
 HEAP32[i10 + 8 >> 2] = 52;
 HEAP32[i10 + 12 >> 2] = 4;
 HEAP32[i10 + 16 >> 2] = 1;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 8;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 827882;
 HEAP32[i9 + 4 >> 2] = gb + 750363;
 HEAP32[i9 + 8 >> 2] = 56;
 HEAP32[i9 + 12 >> 2] = 4;
 HEAP32[i9 + 16 >> 2] = 1;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = gb + 827882;
 HEAP32[i8 + 4 >> 2] = gb + 750384;
 HEAP32[i8 + 8 >> 2] = 60;
 HEAP32[i8 + 12 >> 2] = 4;
 HEAP32[i8 + 16 >> 2] = 1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 2048;
 HEAP32[i8 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 827882;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 56;
 HEAP32[i7 + 12 >> 2] = 4;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 16;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 1087820;
 HEAP32[i6 + 4 >> 2] = gb + 750409;
 HEAP32[i6 + 8 >> 2] = 64;
 HEAP32[i6 + 12 >> 2] = 4;
 HEAP32[i6 + 16 >> 2] = 1;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 8;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 827882;
 HEAP32[i5 + 4 >> 2] = gb + 750430;
 HEAP32[i5 + 8 >> 2] = 68;
 HEAP32[i5 + 12 >> 2] = 4;
 HEAP32[i5 + 16 >> 2] = 1;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 827882;
 HEAP32[i4 + 4 >> 2] = gb + 750451;
 HEAP32[i4 + 8 >> 2] = 72;
 HEAP32[i4 + 12 >> 2] = 4;
 HEAP32[i4 + 16 >> 2] = 1;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 2048;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = gb + 827843;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 68;
 HEAP32[i3 + 12 >> 2] = 4;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 16;
 HEAP32[i3 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Cct10Controller19rideOnTouchedObjectERNS0_11SweptVolumeERKNS_6PxVec3ERS4_PKNS_17PxObstacleContextE(i22, i21, i19, i20, i2) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i23 + 28 | 0;
 i13 = i23;
 i14 = i22 + 244 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) {
  f17 = Math_fround(HEAPF32[i22 + 468 >> 2]);
  i3 = i22 + 472 | 0;
  f1 = Math_fround(f17 - Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i3 >> 2] = f17;
  i3 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, HEAP32[i22 + 240 >> 2] | 0) | 0;
  i2 = HEAP32[i22 + 76 >> 2] | 0;
  if (!i2) i2 = 1; else i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0) | 0) & 255;
  f4 = Math_fround(HEAPF32[i22 + 300 >> 2]);
  f5 = Math_fround(HEAPF32[i22 + 304 >> 2]);
  f6 = Math_fround(HEAPF32[i22 + 308 >> 2]);
  f16 = Math_fround(HEAPF32[i22 + 288 >> 2]);
  f9 = Math_fround(HEAPF32[i22 + 292 >> 2]);
  f7 = Math_fround(HEAPF32[i22 + 296 >> 2]);
  f27 = Math_fround(+HEAPF64[i3 + 8 >> 3]);
  f28 = Math_fround(+HEAPF64[i3 + 16 >> 3]);
  f29 = Math_fround(+HEAPF64[i3 + 24 >> 3]);
  f26 = Math_fround(HEAPF32[i3 + 32 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 36 >> 2]);
  f15 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f24 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f16 = Math_fround(f16 * Math_fround(2.0));
  f9 = Math_fround(f9 * Math_fround(2.0));
  f7 = Math_fround(f7 * Math_fround(2.0));
  f17 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
  f25 = Math_fround(Math_fround(Math_fround(f16 * f26) + Math_fround(f9 * f8)) + Math_fround(f7 * f15));
  f6 = Math_fround(Math_fround(f29 + Math_fround(Math_fround(f15 * f25) + Math_fround(Math_fround(f24 * Math_fround(Math_fround(f9 * f26) - Math_fround(f16 * f8))) + Math_fround(f7 * f17)))) - f6);
  f5 = Math_fround(Math_fround(f28 + Math_fround(Math_fround(f8 * f25) + Math_fround(Math_fround(f24 * Math_fround(Math_fround(f16 * f15) - Math_fround(f7 * f26))) + Math_fround(f9 * f17)))) - f5);
  f4 = Math_fround(Math_fround(f27 + Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f15))) + Math_fround(f16 * f17)))) - f4);
  i11 = i2;
  i18 = 10;
 } else {
  i10 = i22 + 248 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  if ((HEAP16[i11 + 4 >> 1] | 0) == 6) {
   i2 = 0;
   i3 = 0;
   i10 = 0;
   i11 = 0;
   f17 = Math_fround(1.0);
  } else {
   i2 = HEAP32[i22 + 456 >> 2] | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0;
   i3 = i22 + 460 | 0;
   if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) i18 = 21; else {
    HEAP32[i3 >> 2] = i2;
    f29 = Math_fround(HEAPF32[i22 + 468 >> 2]);
    i2 = i22 + 472 | 0;
    f1 = Math_fround(f29 - Math_fround(HEAPF32[i2 >> 2]));
    HEAPF32[i2 >> 2] = f29;
    i2 = HEAP32[i22 + 76 >> 2] | 0;
    if (!i2) i2 = 0; else i2 = (mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0) & 255;
    i18 = HEAP32[i14 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i12 | 0, i11 | 0);
    mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 72 >> 2] | 0, i13 | 0, i18 | 0);
    f24 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) * Math_fround(2.0));
    f15 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) * Math_fround(2.0));
    f25 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) * Math_fround(2.0));
    f17 = Math_fround(HEAPF32[i12 + 12 >> 2]);
    f27 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
    f29 = Math_fround(HEAPF32[i12 >> 2]);
    f7 = Math_fround(f24 * f29);
    f6 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f7 = Math_fround(f7 + Math_fround(f15 * f6));
    f4 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    f7 = Math_fround(f7 + Math_fround(f25 * f4));
    f9 = Math_fround(Math_fround(f29 * f7) + Math_fround(Math_fround(f24 * f27) + Math_fround(f17 * Math_fround(Math_fround(f25 * f6) - Math_fround(f15 * f4)))));
    f8 = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f15 * f27) + Math_fround(f17 * Math_fround(Math_fround(f24 * f4) - Math_fround(f25 * f29)))));
    f7 = Math_fround(Math_fround(Math_fround(f25 * f27) + Math_fround(f17 * Math_fround(Math_fround(f15 * f29) - Math_fround(f24 * f6)))) + Math_fround(f4 * f7));
    f9 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) + f9);
    f8 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) + f8);
    f7 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) + f7);
    f24 = Math_fround(HEAPF32[i13 >> 2]);
    f15 = Math_fround(f17 * f24);
    f27 = Math_fround(HEAPF32[i13 + 12 >> 2]);
    f15 = Math_fround(f15 + Math_fround(f29 * f27));
    f25 = Math_fround(HEAPF32[i13 + 8 >> 2]);
    f15 = Math_fround(f15 + Math_fround(f6 * f25));
    f5 = Math_fround(HEAPF32[i13 + 4 >> 2]);
    f15 = Math_fround(f15 - Math_fround(f4 * f5));
    f26 = Math_fround(Math_fround(Math_fround(f4 * f24) + Math_fround(Math_fround(f6 * f27) + Math_fround(f17 * f5))) - Math_fround(f29 * f25));
    f28 = Math_fround(Math_fround(Math_fround(f29 * f5) + Math_fround(Math_fround(f4 * f27) + Math_fround(f17 * f25))) - Math_fround(f6 * f24));
    f25 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f27) - Math_fround(f29 * f24)) - Math_fround(f6 * f5)) - Math_fround(f4 * f25));
    f4 = Math_fround(HEAPF32[i22 + 276 >> 2]);
    f5 = Math_fround(HEAPF32[i22 + 280 >> 2]);
    f6 = Math_fround(HEAPF32[i22 + 284 >> 2]);
    f24 = Math_fround(Math_fround(HEAPF32[i22 + 264 >> 2]) * Math_fround(2.0));
    f29 = Math_fround(Math_fround(HEAPF32[i22 + 268 >> 2]) * Math_fround(2.0));
    f27 = Math_fround(Math_fround(HEAPF32[i22 + 272 >> 2]) * Math_fround(2.0));
    f17 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
    f16 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(f26 * f29)) + Math_fround(f28 * f27));
    f6 = Math_fround(Math_fround(f7 + Math_fround(Math_fround(Math_fround(f17 * f27) + Math_fround(f25 * Math_fround(Math_fround(f15 * f29) - Math_fround(f26 * f24)))) + Math_fround(f28 * f16))) - f6);
    f5 = Math_fround(Math_fround(f8 + Math_fround(Math_fround(f26 * f16) + Math_fround(Math_fround(f17 * f29) + Math_fround(f25 * Math_fround(Math_fround(f28 * f24) - Math_fround(f15 * f27)))))) - f5);
    f4 = Math_fround(Math_fround(f9 + Math_fround(Math_fround(f15 * f16) + Math_fround(Math_fround(f17 * f24) + Math_fround(f25 * Math_fround(Math_fround(f26 * f27) - Math_fround(f28 * f29)))))) - f4);
    i11 = i2;
    i18 = 10;
   }
  }
 }
 if ((i18 | 0) == 10) {
  f1 = Math_fround(Math_fround(1.0) / f1);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  if (!(i11 & 4)) {
   i10 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   f17 = f1;
  } else i18 = 21;
 }
 if ((i18 | 0) == 21) {
  i22 = (HEAP8[i22 + 485 >> 0] | 0) != 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 f16 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i14 = +Math_fround(Math_abs(Math_fround(f16))) > 1.0e-06;
 f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i14) i18 = 15; else if (+Math_fround(Math_abs(Math_fround(f15))) > 1.0e-06) i18 = 15; else {
  f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (+Math_fround(Math_abs(Math_fround(f1))) > 1.0e-06) i18 = 15; else {
   HEAP8[i22 + 485 >> 0] = 0;
   i2 = 0;
  }
 }
 if ((i18 | 0) == 15) {
  HEAP8[i22 + 485 >> 0] = 1;
  f4 = Math_fround(HEAPF32[i19 >> 2]);
  f29 = Math_fround(f16 * f4);
  f5 = Math_fround(HEAPF32[i19 + 4 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f15 * f5));
  f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f1 * f6));
  f4 = Math_fround(f4 * f29);
  f5 = Math_fround(f5 * f29);
  f6 = Math_fround(f6 * f29);
  f7 = Math_fround(f16 - f4);
  f8 = Math_fround(f15 - f5);
  f9 = Math_fround(f1 - f6);
  if (f29 > Math_fround(0.0)) {
   i19 = i21 + 8 | 0;
   HEAPF64[i19 >> 3] = +f4 + +HEAPF64[i19 >> 3];
   i19 = i21 + 16 | 0;
   HEAPF64[i19 >> 3] = +f5 + +HEAPF64[i19 >> 3];
   i21 = i21 + 24 | 0;
   HEAPF64[i21 >> 3] = +f6 + +HEAPF64[i21 >> 3];
  } else {
   HEAPF32[i20 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i20 >> 2]));
   i21 = i20 + 4 | 0;
   HEAPF32[i21 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i21 >> 2]));
   i21 = i20 + 8 | 0;
   HEAPF32[i21 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i21 >> 2]));
  }
  if (!(i11 & 1)) i2 = 1; else {
   HEAPF32[i20 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i20 >> 2]));
   i2 = i20 + 4 | 0;
   HEAPF32[i2 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
   i2 = i20 + 8 | 0;
   HEAPF32[i2 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i2 >> 2]));
   i2 = 1;
  }
 }
 f28 = Math_fround(f15 * f17);
 f29 = Math_fround(f1 * f17);
 HEAPF32[i22 + 432 >> 2] = Math_fround(f16 * f17);
 HEAPF32[i22 + 436 >> 2] = f28;
 HEAPF32[i22 + 440 >> 2] = f29;
 i22 = i2;
 STACKTOP = i23;
 return i22 | 0;
}

function __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E(i8, i1, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 56 | 0;
 i21 = i24 + 16 | 0;
 i4 = i24 + 64 | 0;
 i5 = i24;
 i18 = i24 + 8 | 0;
 i3 = i8;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if (!(i3 >>> 0 < 1 | (i3 | 0) == 1 & i2 >>> 0 < 0)) {
  i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i23 = i22;
  HEAP32[i23 >> 2] = i2;
  HEAP32[i23 + 4 >> 2] = i1;
  __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E(i22, i21, i4);
 }
 i23 = i5;
 HEAP32[i23 >> 2] = i2;
 HEAP32[i23 + 4 >> 2] = i3;
 HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i23 = __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i22, i21, i4) | 0;
 f9 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f27 = Math_fround(f9 * Math_fround(-2.0));
 f12 = Math_fround(f9 * Math_fround(2.0));
 f26 = Math_fround(f9 * f27);
 f30 = Math_fround(f17 * Math_fround(-2.0));
 f25 = Math_fround(f17 * Math_fround(2.0));
 f28 = Math_fround(f17 * f30);
 f31 = Math_fround(Math_fround(f26 + f28) + Math_fround(1.0));
 f29 = Math_fround(Math_fround(Math_fround(f20 * f12) + Math_fround(f10 * f25)) + Math_fround(0.0));
 f27 = Math_fround(Math_fround(Math_fround(f27 * f10) + Math_fround(f20 * f25)) + Math_fround(0.0));
 f16 = Math_fround(f20 * Math_fround(2.0));
 f19 = Math_fround(f20 * Math_fround(-2.0));
 f20 = Math_fround(f20 * f19);
 f30 = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(f10 * f30)) + Math_fround(0.0));
 f28 = Math_fround(Math_fround(f20 + f28) + Math_fround(1.0));
 f25 = Math_fround(Math_fround(Math_fround(f10 * f16) + Math_fround(f9 * f25)) + Math_fround(0.0));
 f16 = Math_fround(Math_fround(Math_fround(f12 * f10) + Math_fround(f16 * f17)) + Math_fround(0.0));
 f17 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f12 * f17)) + Math_fround(0.0));
 f20 = Math_fround(Math_fround(f26 + f20) + Math_fround(1.0));
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f10 = Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f19 * f16) + Math_fround(f12 * f30)));
 f9 = Math_fround(Math_fround(f26 * f29) + Math_fround(Math_fround(f19 * f17) + Math_fround(f12 * f28)));
 f12 = Math_fround(Math_fround(f26 * f27) + Math_fround(Math_fround(f20 * f19) + Math_fround(f12 * f25)));
 f19 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f26 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f14 = Math_fround(Math_fround(f31 * f19) + Math_fround(Math_fround(f30 * f26) + Math_fround(f16 * f13)));
 f15 = Math_fround(Math_fround(f29 * f19) + Math_fround(Math_fround(f28 * f26) + Math_fround(f17 * f13)));
 f13 = Math_fround(Math_fround(f27 * f19) + Math_fround(Math_fround(f25 * f26) + Math_fround(f20 * f13)));
 f26 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f16 = Math_fround(Math_fround(f31 * f26) + Math_fround(Math_fround(f30 * f19) + Math_fround(f16 * f11)));
 f17 = Math_fround(Math_fround(f29 * f26) + Math_fround(Math_fround(f28 * f19) + Math_fround(f17 * f11)));
 f11 = Math_fround(Math_fround(f27 * f26) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * f11)));
 if (!(HEAP32[i8 + 4 >> 2] | 0)) {
  i1 = i8;
  f19 = f14;
  f20 = f15;
  f14 = f16;
  f15 = f17;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i1 = i8;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i8 = i18;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  __Z24CalculateGlobalRSInverse23TransformAccessReadOnly(i21, i22);
  f35 = Math_fround(HEAPF32[i21 >> 2]);
  f32 = Math_fround(HEAPF32[i21 + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f20 = Math_fround(f10 * f35);
  f29 = Math_fround(f10 * f32);
  f19 = Math_fround(f10 * f26);
  f34 = Math_fround(HEAPF32[i21 + 24 >> 2]);
  f25 = Math_fround(HEAPF32[i21 + 28 >> 2]);
  f27 = Math_fround(HEAPF32[i21 + 32 >> 2]);
  f10 = Math_fround(f12 * f34);
  f30 = Math_fround(f12 * f25);
  f12 = Math_fround(f12 * f27);
  f33 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  f31 = Math_fround(HEAPF32[i21 + 16 >> 2]);
  f28 = Math_fround(HEAPF32[i21 + 20 >> 2]);
  f10 = Math_fround(f20 + Math_fround(f10 + Math_fround(f9 * f33)));
  f12 = Math_fround(f19 + Math_fround(f12 + Math_fround(f9 * f28)));
  f19 = Math_fround(Math_fround(f14 * f35) + Math_fround(Math_fround(f13 * f34) + Math_fround(f15 * f33)));
  f20 = Math_fround(Math_fround(f14 * f32) + Math_fround(Math_fround(f13 * f25) + Math_fround(f15 * f31)));
  f13 = Math_fround(Math_fround(f14 * f26) + Math_fround(Math_fround(f13 * f27) + Math_fround(f15 * f28)));
  f14 = Math_fround(Math_fround(f16 * f35) + Math_fround(Math_fround(f11 * f34) + Math_fround(f17 * f33)));
  f15 = Math_fround(Math_fround(f16 * f32) + Math_fround(Math_fround(f11 * f25) + Math_fround(f17 * f31)));
  f11 = Math_fround(Math_fround(f16 * f26) + Math_fround(Math_fround(f11 * f27) + Math_fround(f17 * f28)));
  f9 = Math_fround(f29 + Math_fround(f30 + Math_fround(f9 * f31)));
 }
 i3 = i2;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 f30 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 24 >> 2]);
 f31 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + (i1 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + (i1 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + (i1 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f31 * Math_fround(-2.0));
 f25 = Math_fround(f31 * Math_fround(2.0));
 f29 = Math_fround(f31 * f26);
 f33 = Math_fround(f17 * Math_fround(-2.0));
 f35 = Math_fround(f17 * Math_fround(2.0));
 f34 = Math_fround(f17 * f33);
 f32 = Math_fround(f27 * Math_fround(2.0));
 f16 = Math_fround(f27 * Math_fround(-2.0));
 f28 = Math_fround(f27 * f16);
 f33 = Math_fround(Math_fround(f10 * Math_fround(Math_fround(f29 + f34) + Math_fround(1.0))) + Math_fround(Math_fround(f12 * Math_fround(Math_fround(Math_fround(f32 * f17) + Math_fround(f30 * f25)) + Math_fround(0.0))) + Math_fround(f9 * Math_fround(Math_fround(Math_fround(f31 * f32) + Math_fround(f30 * f33)) + Math_fround(0.0)))));
 f34 = Math_fround(Math_fround(f19 * Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(f30 * f35)) + Math_fround(0.0))) + Math_fround(Math_fround(f13 * Math_fround(Math_fround(Math_fround(f30 * f16) + Math_fround(f17 * f25)) + Math_fround(0.0))) + Math_fround(f20 * Math_fround(Math_fround(f28 + f34) + Math_fround(1.0)))));
 f35 = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f30 * f26) + Math_fround(f27 * f35)) + Math_fround(0.0))) + Math_fround(Math_fround(f11 * Math_fround(Math_fround(f28 + f29) + Math_fround(1.0))) + Math_fround(f15 * Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f31 * f35)) + Math_fround(0.0)))));
 i6 = i8 + (i1 * 40 | 0) + 28 | 0;
 f31 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i8 + (i1 * 40 | 0) + 32 | 0;
 f32 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i8 + (i1 * 40 | 0) + 36 | 0;
 i18 = f35 != Math_fround(HEAPF32[i8 >> 2]) | (f33 != f31 | f34 != f32);
 HEAPF32[i6 >> 2] = f33;
 HEAPF32[i7 >> 2] = f34;
 HEAPF32[i8 >> 2] = f35;
 if (!i18) {
  i22 = 0;
  i23 = i23 | i22;
  STACKTOP = i24;
  return i23 | 0;
 }
 i4 = i21;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 __ZN17TransformInternal36OnScaleChangedCalculateTransformTypeE15TransformAccess(i22);
 i4 = HEAP32[i3 + 44 >> 2] | HEAP32[i3 + 40 >> 2] | HEAP32[i3 + 48 >> 2];
 i5 = HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i5) {
  i22 = 1;
  i23 = i23 | i22;
  STACKTOP = i24;
  return i23 | 0;
 }
 i6 = HEAP32[i3 + 60 >> 2] | 0;
 i7 = HEAP32[i3 + 56 >> 2] | 0;
 i8 = i3 + 36 | 0;
 i3 = HEAP32[i3 + 68 >> 2] | 0;
 i2 = 0;
 while (1) {
  i22 = HEAP32[i6 + (i1 << 2) >> 2] & i4;
  i21 = i7 + (i1 << 2) | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i22;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i22;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i5 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 i23 = i23 | i1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN8UVModule8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i8, i10);
 i2 = i8 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620385 | 0, gb + 620173 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620399 | 0, gb + 620173 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 536 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620410 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 540 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620417 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 544 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620424 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i3 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i5 >>> 0) i7 = 40; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i7 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 548 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620438 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 51; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 51; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 552 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048600 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 62; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 62; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 62) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 560 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620447 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 73; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 73; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 73) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 564 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620461 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 84; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 84; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 568 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620467 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 95; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 95; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i8 + 556 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 620473 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_S3_iiiiiiiiNS0_15FramebufferMaskE(i37, i10, i15, i17, i16, i26, i27, i18, i19, i28, i23, i24, i25, i9) {
 i37 = i37 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i28 = i28 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i20 = 0, i21 = 0, i22 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i38 + 4 | 0;
 i7 = i38;
 i8 = (i18 | 0) != (i24 | 0) | (i19 | 0) != (i25 | 0);
 i32 = i37 + 884 | 0;
 i30 = i32;
 i2 = HEAP32[i30 >> 2] | 0;
 i30 = HEAP32[i30 + 4 >> 2] | 0;
 i33 = i37 + 876 | 0;
 i34 = i33;
 i1 = HEAP32[i34 >> 2] | 0;
 i34 = HEAP32[i34 + 4 >> 2] | 0;
 i13 = i10;
 i3 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i35 = i37 + 876 | 0;
 i14 = (i3 | 0) == 0;
 if (i3 | i1 | 0) {
  i4 = i13;
  if (!((i3 | 0) == (i1 | 0) ? (HEAP32[i37 + 880 >> 2] | 0) == (i4 | 0) : 0)) {
   i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i37 + 860 >> 2] | 0, 0) | 0;
   if ((i5 | 0) == 36160) {
    i31 = i35;
    HEAP32[i31 >> 2] = i3;
    HEAP32[i31 + 4 >> 2] = i13;
    i31 = i32;
    HEAP32[i31 >> 2] = i3;
    HEAP32[i31 + 4 >> 2] = i13;
   } else {
    i31 = i33;
    HEAP32[i31 >> 2] = i3;
    HEAP32[i31 + 4 >> 2] = i13;
   }
   i6 = HEAP32[i37 + 544 >> 2] | 0;
   if (i14) i36 = 8; else if ((HEAP32[i37 + 1988 >> 2] | 0) == (i4 | 0)) i36 = 8; else i4 = -1;
   if ((i36 | 0) == 8) i4 = i3;
   mftCall_vii(i6 | 0, i5 | 0, i4 | 0);
  }
 }
 HEAP32[i7 >> 2] = 0;
 i6 = i37 + 88 | 0;
 mftCall_vii(HEAP32[i6 >> 2] | 0, 32937, i7 | 0);
 i31 = (HEAP32[i7 >> 2] | 0) != 0;
 i31 = i8 & i31;
 i12 = i31 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 672 >> 0] | 0) == 0;
 i8 = i31 ? 37051 : i8 ? 9729 : 9728;
 i31 = i37 + 860 | 0;
 i21 = __ZNK13TranslateGLES15FramebufferMaskEN2gl15FramebufferMaskE(HEAP32[i31 >> 2] | 0, i9) | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0)) i29 = 0; else if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 535 >> 0] | 0)) i29 = 0; else {
  i4 = i37 + 1592 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 & 64 | 0) == 0 | (i9 & 1 | 0) == 0) i29 = 0; else {
   HEAP32[i4 >> 2] = i5 & -65;
   i29 = HEAP32[i37 + 772 >> 2] | 0;
   mftCall_vi(i29 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i31 >> 2] | 0, 6) | 0);
   i29 = 1;
  }
 }
 i22 = i37 + 1988 | 0;
 if (i14) i36 = 16; else if ((HEAP32[i22 >> 2] | 0) == (HEAP32[i10 + 4 >> 2] | 0)) i36 = 16; else i7 = -1;
 if ((i36 | 0) == 16) i7 = i3;
 HEAP32[i11 >> 2] = 0;
 mftCall_vii(HEAP32[i6 >> 2] | 0, 3074, i11 | 0);
 i20 = HEAP32[i11 >> 2] | 0;
 if (i14) {
  if (HEAP32[i32 >> 2] | 0) i36 = 19;
 } else i36 = 19;
 do if ((i36 | 0) == 19) {
  i4 = i13;
  if ((HEAP32[i37 + 888 >> 2] | 0) == (i4 | 0)) if ((i3 | 0) == (HEAP32[i32 >> 2] | 0)) break;
  i6 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 1) | 0;
  if ((i6 | 0) == 36160) {
   i11 = i35;
   HEAP32[i11 >> 2] = i3;
   HEAP32[i11 + 4 >> 2] = i13;
  }
  i5 = i32;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i13;
  i5 = HEAP32[i37 + 544 >> 2] | 0;
  if (i14) i36 = 25; else if ((HEAP32[i22 >> 2] | 0) == (i4 | 0)) i36 = 25; else i3 = -1;
  mftCall_vii(i5 | 0, i6 | 0, i3 | 0);
 } while (0);
 i13 = (i15 | 0) != 1;
 if (i13) {
  i14 = HEAP32[i37 + 196 >> 2] | 0;
  mftCall_vi(i14 | 0, __ZNK13TranslateGLES15FramebufferReadEN2gl15FramebufferReadE(HEAP32[i31 >> 2] | 0, i7 | 0 ? i15 : 2) | 0);
 }
 if (i12) {
  i7 = i16;
  i3 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = (i3 | 0) == 0;
  if (i8) {
   if (HEAP32[i33 >> 2] | 0) i36 = 32;
  } else i36 = 32;
  do if ((i36 | 0) == 32) {
   i4 = i7;
   if ((HEAP32[i37 + 880 >> 2] | 0) == (i4 | 0)) if ((i3 | 0) == (HEAP32[i33 >> 2] | 0)) break;
   i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 0) | 0;
   if ((i5 | 0) == 36160) {
    i16 = i35;
    HEAP32[i16 >> 2] = i3;
    HEAP32[i16 + 4 >> 2] = i7;
    i16 = i32;
    HEAP32[i16 >> 2] = i3;
    HEAP32[i16 + 4 >> 2] = i7;
   } else {
    i16 = i33;
    HEAP32[i16 >> 2] = i3;
    HEAP32[i16 + 4 >> 2] = i7;
   }
   i6 = HEAP32[i37 + 544 >> 2] | 0;
   if (i8) i36 = 39; else if ((HEAP32[i22 >> 2] | 0) == (i4 | 0)) i36 = 39; else i4 = -1;
   if ((i36 | 0) == 39) i4 = i3;
   mftCall_vii(i6 | 0, i5 | 0, i4 | 0);
  } while (0);
  i11 = i37 + 548 | 0;
  i10 = i18 + i26 | 0;
  i9 = i19 + i27 | 0;
  mftCall_viiiiiiiiii(HEAP32[i11 >> 2] | 0, i26 | 0, i27 | 0, i10 | 0, i9 | 0, i26 | 0, i27 | 0, i10 | 0, i9 | 0, i21 | 0, 9728);
  if (i8) {
   if (HEAP32[i32 >> 2] | 0) i36 = 43;
  } else i36 = 43;
  do if ((i36 | 0) == 43) {
   i4 = i7;
   if ((HEAP32[i37 + 888 >> 2] | 0) == (i4 | 0)) if ((i3 | 0) == (HEAP32[i32 >> 2] | 0)) break;
   i6 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 1) | 0;
   if ((i6 | 0) == 36160) {
    i19 = i35;
    HEAP32[i19 >> 2] = i3;
    HEAP32[i19 + 4 >> 2] = i7;
   }
   i5 = i32;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i5 + 4 >> 2] = i7;
   i5 = HEAP32[i37 + 544 >> 2] | 0;
   if (i8) i36 = 49; else if ((HEAP32[i22 >> 2] | 0) == (i4 | 0)) i36 = 49; else i3 = -1;
   mftCall_vii(i5 | 0, i6 | 0, i3 | 0);
  } while (0);
  i4 = i17;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = (i3 | 0) == 0;
  if (i5) {
   if (HEAP32[i33 >> 2] | 0) i36 = 53;
  } else i36 = 53;
  do if ((i36 | 0) == 53) {
   i6 = i4;
   if ((HEAP32[i37 + 880 >> 2] | 0) == (i6 | 0)) if ((i3 | 0) == (HEAP32[i33 >> 2] | 0)) break;
   i7 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 0) | 0;
   if ((i7 | 0) == 36160) {
    i19 = i35;
    HEAP32[i19 >> 2] = i3;
    HEAP32[i19 + 4 >> 2] = i4;
    i19 = i32;
    HEAP32[i19 >> 2] = i3;
    HEAP32[i19 + 4 >> 2] = i4;
   } else {
    i19 = i33;
    HEAP32[i19 >> 2] = i3;
    HEAP32[i19 + 4 >> 2] = i4;
   }
   i4 = HEAP32[i37 + 544 >> 2] | 0;
   if (i5) i36 = 60; else if ((HEAP32[i22 >> 2] | 0) == (i6 | 0)) i36 = 60; else i3 = -1;
   mftCall_vii(i4 | 0, i7 | 0, i3 | 0);
  } while (0);
  mftCall_viiiiiiiiii(HEAP32[i11 >> 2] | 0, i26 | 0, i27 | 0, i10 | 0, i9 | 0, i28 | 0, i23 | 0, i24 + i28 | 0, i25 + i23 | 0, i21 | 0, 9729);
 } else {
  i4 = i17;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = (i3 | 0) == 0;
  if (i5) {
   if (HEAP32[i33 >> 2] | 0) i36 = 65;
  } else i36 = 65;
  do if ((i36 | 0) == 65) {
   i6 = i4;
   if ((HEAP32[i37 + 880 >> 2] | 0) == (i6 | 0)) if ((i3 | 0) == (HEAP32[i33 >> 2] | 0)) break;
   i7 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 0) | 0;
   if ((i7 | 0) == 36160) {
    i17 = i35;
    HEAP32[i17 >> 2] = i3;
    HEAP32[i17 + 4 >> 2] = i4;
    i17 = i32;
    HEAP32[i17 >> 2] = i3;
    HEAP32[i17 + 4 >> 2] = i4;
   } else {
    i17 = i33;
    HEAP32[i17 >> 2] = i3;
    HEAP32[i17 + 4 >> 2] = i4;
   }
   i4 = HEAP32[i37 + 544 >> 2] | 0;
   if (i5) i36 = 72; else if ((HEAP32[i22 >> 2] | 0) == (i6 | 0)) i36 = 72; else i3 = -1;
   mftCall_vii(i4 | 0, i7 | 0, i3 | 0);
  } while (0);
  mftCall_viiiiiiiiii(HEAP32[i37 + 548 >> 2] | 0, i26 | 0, i27 | 0, i18 + i26 | 0, i19 + i27 | 0, i28 | 0, i23 | 0, i24 + i28 | 0, i25 + i23 | 0, i21 | 0, i8 | 0);
 }
 i3 = (i2 | 0) == 0;
 if (i3) {
  if (HEAP32[i32 >> 2] | 0) i36 = 77;
 } else i36 = 77;
 do if ((i36 | 0) == 77) {
  i4 = i30;
  if ((HEAP32[i37 + 888 >> 2] | 0) == (i4 | 0)) if ((i2 | 0) == (HEAP32[i32 >> 2] | 0)) break;
  i6 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 1) | 0;
  if ((i6 | 0) == 36160) {
   i28 = i35;
   HEAP32[i28 >> 2] = i2;
   HEAP32[i28 + 4 >> 2] = i30;
  }
  i5 = i32;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i30;
  i5 = HEAP32[i37 + 544 >> 2] | 0;
  if (i3) i36 = 83; else if ((HEAP32[i22 >> 2] | 0) == (i4 | 0)) i36 = 83; else i2 = -1;
  mftCall_vii(i5 | 0, i6 | 0, i2 | 0);
 } while (0);
 if (i13) mftCall_vi(HEAP32[i37 + 196 >> 2] | 0, i20 | 0);
 i3 = (i1 | 0) == 0;
 if (i3) {
  if (HEAP32[i33 >> 2] | 0) i36 = 89;
 } else i36 = 89;
 do if ((i36 | 0) == 89) {
  i4 = i34;
  if ((HEAP32[i37 + 880 >> 2] | 0) == (i4 | 0)) if ((i1 | 0) == (HEAP32[i33 >> 2] | 0)) break;
  i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i31 >> 2] | 0, 0) | 0;
  if ((i5 | 0) == 36160) {
   HEAP32[i35 >> 2] = i1;
   HEAP32[i35 + 4 >> 2] = i34;
   i35 = i32;
   HEAP32[i35 >> 2] = i1;
   HEAP32[i35 + 4 >> 2] = i34;
  } else {
   i35 = i33;
   HEAP32[i35 >> 2] = i1;
   HEAP32[i35 + 4 >> 2] = i34;
  }
  i2 = HEAP32[i37 + 544 >> 2] | 0;
  if (i3) i36 = 96; else if ((HEAP32[i22 >> 2] | 0) == (i4 | 0)) i36 = 96; else i1 = -1;
  mftCall_vii(i2 | 0, i5 | 0, i1 | 0);
 } while (0);
 if (!i29) {
  STACKTOP = i38;
  return;
 }
 i1 = i37 + 1592 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((HEAP8[i37 + 1992 >> 0] | 0) == 0 | (i2 & 64 | 0) == 0)) {
  STACKTOP = i38;
  return;
 }
 HEAP32[i1 >> 2] = i2 | 64;
 i37 = HEAP32[i37 + 768 >> 2] | 0;
 mftCall_vi(i37 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i31 >> 2] | 0, 6) | 0);
 STACKTOP = i38;
 return;
}

function _UNITY_png_write_find_filter(i22, i1) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i15 = HEAP8[i22 + 430 >> 0] | 0;
 i21 = i1 + 4 | 0;
 i18 = HEAP32[i21 >> 2] | 0;
 i23 = i22 + 368 | 0;
 i15 = i15 << 24 >> 24 == -8 & (HEAP32[i23 >> 2] | 0) == 0 ? i15 & 95 : i15;
 i4 = ((HEAPU8[i1 + 11 >> 0] | 0) + 7 | 0) >>> 3;
 i19 = i22 + 376 | 0;
 i16 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 380 | 0;
 i17 = HEAP32[i20 >> 2] | 0;
 i14 = i15 & 255;
 if (i15 << 24 >> 24 == 8 | (i14 & 8 | 0) == 0) i11 = 2147483647; else if (!i18) i11 = 0; else {
  i2 = i17;
  i1 = 0;
  i3 = 0;
  do {
   i2 = i2 + 1 | 0;
   i12 = HEAP8[i2 >> 0] | 0;
   i13 = i12 & 255;
   i1 = (i12 << 24 >> 24 > -1 ? i13 : 256 - i13 | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i18 | 0));
  i11 = i1;
 }
 if (i15 << 24 >> 24 == 16) {
  i5 = i17 + 1 | 0;
  i9 = i22 + 384 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  i2 = i7 + 1 | 0;
  if (!i4) {
   i3 = i5;
   i1 = 0;
  } else {
   i8 = i4 + 1 | 0;
   i3 = i17 + i8 | 0;
   i6 = i5;
   i1 = 0;
   while (1) {
    HEAP8[i2 >> 0] = HEAP8[i6 >> 0] | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else {
     i6 = i6 + 1 | 0;
     i2 = i2 + 1 | 0;
    }
   }
   i2 = i7 + i8 | 0;
   i1 = i4;
  }
  if (i1 >>> 0 < i18 >>> 0) while (1) {
   HEAP8[i2 >> 0] = (HEAPU8[i3 >> 0] | 0) - (HEAPU8[i5 >> 0] | 0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i18 | 0)) break; else {
    i5 = i5 + 1 | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
   }
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i11;
 } else if (!(i14 & 16)) {
  i1 = i17;
  i2 = i11;
 } else {
  i9 = i17 + 1 | 0;
  i10 = i22 + 384 | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = i7 + 1 | 0;
  if (!i4) {
   i5 = i9;
   i3 = i1;
   i2 = 0;
   i1 = 0;
  } else {
   i8 = i4 + 1 | 0;
   i6 = i17 + i8 | 0;
   i5 = i9;
   i2 = 0;
   i3 = 0;
   while (1) {
    i12 = HEAP8[i5 >> 0] | 0;
    HEAP8[i1 >> 0] = i12;
    i13 = i12 & 255;
    i2 = (i12 << 24 >> 24 > -1 ? i13 : 256 - i13 | 0) + i2 | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else {
     i5 = i5 + 1 | 0;
     i1 = i1 + 1 | 0;
    }
   }
   i5 = i6;
   i3 = i7 + i8 | 0;
   i1 = i4;
  }
  L26 : do if (i1 >>> 0 < i18 >>> 0) {
   i6 = i9;
   while (1) {
    i13 = (HEAPU8[i5 >> 0] | 0) - (HEAPU8[i6 >> 0] | 0) | 0;
    HEAP8[i3 >> 0] = i13;
    i13 = i13 & 255;
    i2 = (i13 >>> 0 < 128 ? i13 : 256 - i13 | 0) + i2 | 0;
    if (i2 >>> 0 > i11 >>> 0) break L26;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i18 >>> 0) break; else {
     i6 = i6 + 1 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } while (0);
  if (i2 >>> 0 < i11 >>> 0) i1 = HEAP32[i10 >> 2] | 0; else {
   i1 = i17;
   i2 = i11;
  }
 }
 if (i15 << 24 >> 24 == 32) {
  i7 = i22 + 388 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i18) i12 = 40; else {
   i5 = 0;
   i6 = i16;
   i3 = i17;
   do {
    i6 = i6 + 1 | 0;
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
    HEAP8[i1 >> 0] = (HEAPU8[i3 >> 0] | 0) - (HEAPU8[i6 >> 0] | 0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i18 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
   i12 = 32;
  }
 } else if (!(i14 & 32)) i12 = 32; else {
  i9 = i22 + 388 | 0;
  if (!i18) i3 = 0; else {
   i5 = 0;
   i3 = 0;
   i6 = i17;
   i7 = HEAP32[i9 >> 2] | 0;
   i8 = i16;
   do {
    i8 = i8 + 1 | 0;
    i7 = i7 + 1 | 0;
    i6 = i6 + 1 | 0;
    i13 = (HEAPU8[i6 >> 0] | 0) - (HEAPU8[i8 >> 0] | 0) | 0;
    HEAP8[i7 >> 0] = i13;
    i13 = i13 & 255;
    i3 = (i13 >>> 0 < 128 ? i13 : 256 - i13 | 0) + i3 | 0;
    i5 = i5 + 1 | 0;
   } while (i3 >>> 0 <= i2 >>> 0 & i5 >>> 0 < i18 >>> 0);
  }
  if (i3 >>> 0 < i2 >>> 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i12 = 32;
  } else i12 = 32;
 }
 if ((i12 | 0) == 32) if (i15 << 24 >> 24 == 64) {
  i7 = i17 + 1 | 0;
  i11 = i22 + 392 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  i5 = i16 + 1 | 0;
  i3 = i9 + 1 | 0;
  if (!i4) {
   i6 = 0;
   i1 = i7;
  } else {
   i10 = i4 + 1 | 0;
   i8 = i16 + i10 | 0;
   i6 = 0;
   i1 = i7;
   while (1) {
    HEAP8[i3 >> 0] = (HEAPU8[i1 >> 0] | 0) - ((HEAPU8[i5 >> 0] | 0) >>> 1 & 255);
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i4 | 0)) break; else {
     i5 = i5 + 1 | 0;
     i3 = i3 + 1 | 0;
     i1 = i1 + 1 | 0;
    }
   }
   i6 = i4;
   i5 = i8;
   i3 = i9 + i10 | 0;
   i1 = i17 + i10 | 0;
  }
  if (i6 >>> 0 < i18 >>> 0) while (1) {
   HEAP8[i3 >> 0] = (HEAPU8[i1 >> 0] | 0) - (((HEAPU8[i7 >> 0] | 0) + (HEAPU8[i5 >> 0] | 0) | 0) >>> 1);
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i18 | 0)) break; else {
    i7 = i7 + 1 | 0;
    i5 = i5 + 1 | 0;
    i3 = i3 + 1 | 0;
    i1 = i1 + 1 | 0;
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
 } else i12 = 40;
 if ((i12 | 0) == 40) if (!(i14 & 64)) i3 = i2; else {
  i9 = i17 + 1 | 0;
  i13 = i22 + 392 | 0;
  i11 = HEAP32[i13 >> 2] | 0;
  i7 = i16 + 1 | 0;
  i6 = i11 + 1 | 0;
  if (!i4) {
   i8 = 0;
   i3 = 0;
   i5 = i9;
  } else {
   i12 = i4 + 1 | 0;
   i10 = i16 + i12 | 0;
   i8 = 0;
   i3 = 0;
   i5 = i9;
   while (1) {
    i24 = (HEAPU8[i5 >> 0] | 0) - ((HEAPU8[i7 >> 0] | 0) >>> 1 & 255) | 0;
    HEAP8[i6 >> 0] = i24;
    i24 = i24 & 255;
    i3 = (i24 >>> 0 < 128 ? i24 : 256 - i24 | 0) + i3 | 0;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i4 | 0)) break; else {
     i7 = i7 + 1 | 0;
     i6 = i6 + 1 | 0;
     i5 = i5 + 1 | 0;
    }
   }
   i8 = i4;
   i7 = i10;
   i6 = i11 + i12 | 0;
   i5 = i17 + i12 | 0;
  }
  L68 : do if (i8 >>> 0 < i18 >>> 0) while (1) {
   i24 = (HEAPU8[i5 >> 0] | 0) - (((HEAPU8[i9 >> 0] | 0) + (HEAPU8[i7 >> 0] | 0) | 0) >>> 1) | 0;
   HEAP8[i6 >> 0] = i24;
   i24 = i24 & 255;
   i3 = (i24 >>> 0 < 128 ? i24 : 256 - i24 | 0) + i3 | 0;
   if (i3 >>> 0 > i2 >>> 0) break L68;
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i18 >>> 0) break; else {
    i9 = i9 + 1 | 0;
    i7 = i7 + 1 | 0;
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
   }
  } while (0);
  if (i3 >>> 0 < i2 >>> 0) i1 = HEAP32[i13 >> 2] | 0; else i3 = i2;
 }
 if (i15 << 24 >> 24 == -128) {
  i6 = i17 + 1 | 0;
  i11 = i22 + 396 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  i5 = i16 + 1 | 0;
  i2 = i9 + 1 | 0;
  if (!i4) {
   i4 = 0;
   i3 = i5;
   i1 = i6;
  } else {
   i10 = i4 + 1 | 0;
   i3 = i16 + i10 | 0;
   i7 = 0;
   i8 = i5;
   i1 = i6;
   while (1) {
    HEAP8[i2 >> 0] = (HEAPU8[i1 >> 0] | 0) - (HEAPU8[i8 >> 0] | 0);
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i4 | 0)) break; else {
     i8 = i8 + 1 | 0;
     i2 = i2 + 1 | 0;
     i1 = i1 + 1 | 0;
    }
   }
   i2 = i9 + i10 | 0;
   i1 = i17 + i10 | 0;
  }
  if (i4 >>> 0 < i18 >>> 0) while (1) {
   i16 = HEAPU8[i3 >> 0] | 0;
   i17 = HEAPU8[i5 >> 0] | 0;
   i24 = HEAPU8[i6 >> 0] | 0;
   i15 = i16 - i17 | 0;
   i12 = i24 - i17 | 0;
   i13 = (i15 | 0) < 0 ? 0 - i15 | 0 : i15;
   i14 = (i12 | 0) < 0 ? 0 - i12 | 0 : i12;
   i15 = i12 + i15 | 0;
   i15 = (i15 | 0) < 0 ? 0 - i15 | 0 : i15;
   HEAP8[i2 >> 0] = (HEAPU8[i1 >> 0] | 0) - ((i13 | 0) > (i14 | 0) | (i13 | 0) > (i15 | 0) ? ((i14 | 0) <= (i15 | 0) ? i16 : i17) : i24);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i18 | 0)) break; else {
    i6 = i6 + 1 | 0;
    i5 = i5 + 1 | 0;
    i3 = i3 + 1 | 0;
    i2 = i2 + 1 | 0;
    i1 = i1 + 1 | 0;
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
 } else if (i14 & 128) {
  i12 = i17 + 1 | 0;
  i14 = i22 + 396 | 0;
  i10 = HEAP32[i14 >> 2] | 0;
  i13 = i16 + 1 | 0;
  i6 = i10 + 1 | 0;
  if (!i4) {
   i4 = 0;
   i2 = 0;
   i7 = i13;
   i5 = i12;
  } else {
   i11 = i4 + 1 | 0;
   i7 = i16 + i11 | 0;
   i8 = 0;
   i2 = 0;
   i9 = i13;
   i5 = i12;
   while (1) {
    i24 = (HEAPU8[i5 >> 0] | 0) - (HEAPU8[i9 >> 0] | 0) | 0;
    HEAP8[i6 >> 0] = i24;
    i24 = i24 & 255;
    i2 = (i24 >>> 0 < 128 ? i24 : 256 - i24 | 0) + i2 | 0;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i4 | 0)) break; else {
     i9 = i9 + 1 | 0;
     i6 = i6 + 1 | 0;
     i5 = i5 + 1 | 0;
    }
   }
   i6 = i10 + i11 | 0;
   i5 = i17 + i11 | 0;
  }
  L95 : do if (i4 >>> 0 < i18 >>> 0) {
   i9 = i12;
   i8 = i13;
   while (1) {
    i16 = HEAPU8[i7 >> 0] | 0;
    i17 = HEAPU8[i8 >> 0] | 0;
    i24 = HEAPU8[i9 >> 0] | 0;
    i15 = i16 - i17 | 0;
    i11 = i24 - i17 | 0;
    i12 = (i15 | 0) < 0 ? 0 - i15 | 0 : i15;
    i13 = (i11 | 0) < 0 ? 0 - i11 | 0 : i11;
    i15 = i11 + i15 | 0;
    i15 = (i15 | 0) < 0 ? 0 - i15 | 0 : i15;
    i24 = (HEAPU8[i5 >> 0] | 0) - ((i12 | 0) > (i13 | 0) | (i12 | 0) > (i15 | 0) ? ((i13 | 0) <= (i15 | 0) ? i16 : i17) : i24) | 0;
    HEAP8[i6 >> 0] = i24;
    i24 = i24 & 255;
    i2 = (i24 >>> 0 < 128 ? i24 : 256 - i24 | 0) + i2 | 0;
    if (i2 >>> 0 > i3 >>> 0) break L95;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= i18 >>> 0) break; else {
     i9 = i9 + 1 | 0;
     i8 = i8 + 1 | 0;
     i7 = i7 + 1 | 0;
     i6 = i6 + 1 | 0;
     i5 = i5 + 1 | 0;
    }
   }
  } while (0);
  if (i2 >>> 0 < i3 >>> 0) i1 = HEAP32[i14 >> 2] | 0;
 }
 _UNITY_png_compress_IDAT(i22, i1, (HEAP32[i21 >> 2] | 0) + 1 | 0, 0);
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i20 >> 2] = i1;
 }
 i24 = (HEAP32[i23 >> 2] | 0) + 1 | 0;
 HEAP32[i23 >> 2] = i24;
 if (i24 >>> 0 >= (HEAP32[i22 + 352 >> 2] | 0) >>> 0) _UNITY_png_compress_IDAT(i22, 0, 0, 4);
 i23 = i22 + 476 | 0;
 i24 = (HEAP32[i23 >> 2] | 0) + 1 | 0;
 HEAP32[i23 >> 2] = i24;
 if (((HEAP32[i22 + 472 >> 2] | 0) + -1 | 0) >>> 0 >= i24 >>> 0) return;
 _UNITY_png_write_flush(i22);
 return;
}

function __Z20ProcessFilterExtentsPffP10CBBoxInt32P13CImageSurfaceS3_S_jbfiR17PrecomputeContext(i33, f30, i31, i32, i36, i39, i23, i24, f19, i1, i2) {
 i33 = i33 | 0;
 f30 = Math_fround(f30);
 i31 = i31 | 0;
 i32 = i32 | 0;
 i36 = i36 | 0;
 i39 = i39 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 f19 = Math_fround(f19);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, d40 = 0.0, i41 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i38;
 i37 = HEAP32[i36 + 8 >> 2] | 0;
 i25 = HEAP32[i32 >> 2] | 0;
 i26 = Math_imul(HEAP32[i32 + 8 >> 2] | 0, i25) | 0;
 i27 = Math_imul(i25, i37) | 0;
 i35 = (i37 | 0) > 0;
 if (i35) _memset(i34 | 0, 0, i37 << 3 | 0) | 0;
 i28 = i33 + 4 | 0;
 i29 = i33 + 8 | 0;
 if ((i23 | 0) == 4) {
  i18 = 0;
  d3 = 0.0;
  do {
   i14 = HEAP32[i31 + (i18 * 24 | 0) >> 2] | 0;
   i15 = HEAP32[i31 + (i18 * 24 | 0) + 12 >> 2] | 0;
   if ((i14 | 0) <= (i15 | 0)) {
    i1 = HEAP32[i31 + (i18 * 24 | 0) + 4 >> 2] | 0;
    i16 = HEAP32[i31 + (i18 * 24 | 0) + 16 >> 2] | 0;
    if ((i1 | 0) <= (i16 | 0)) if ((HEAP32[i31 + (i18 * 24 | 0) + 8 >> 2] | 0) <= (HEAP32[i31 + (i18 * 24 | 0) + 20 >> 2] | 0)) {
     i11 = (Math_imul(i1, i25) | 0) + i14 | 0;
     i17 = HEAP32[i32 + (i18 << 4) + 8 >> 2] | 0;
     i10 = (HEAP32[i32 + (i18 << 4) + 12 >> 2] | 0) + ((Math_imul(i17, i11) | 0) << 2) | 0;
     i11 = (HEAP32[i36 + (i18 << 4) + 12 >> 2] | 0) + ((Math_imul(HEAP32[i36 + (i18 << 4) + 8 >> 2] | 0, i11) | 0) << 2) | 0;
     f7 = Math_fround(HEAPF32[i33 >> 2]);
     f12 = Math_fround(HEAPF32[i28 >> 2]);
     f13 = Math_fround(HEAPF32[i29 >> 2]);
     while (1) {
      if (i35) {
       i8 = i14;
       i9 = 0;
       i2 = 0;
       while (1) {
        i5 = i10 + (i9 << 2) | 0;
        f4 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f7);
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f12));
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f13));
        if (f4 >= f30 & f4 > Math_fround(0.0)) {
         f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) * Math_fround(+Math_pow(+f4, +f19)));
         i5 = 0;
         i6 = i2;
         while (1) {
          d40 = +Math_fround(f4 * Math_fround(HEAPF32[i11 + (i6 << 2) >> 2]));
          i24 = i34 + (i5 << 3) | 0;
          HEAPF64[i24 >> 3] = +HEAPF64[i24 >> 3] + d40;
          i5 = i5 + 1 | 0;
          if ((i5 | 0) == (i37 | 0)) break; else i6 = i6 + 1 | 0;
         }
         i2 = i37 + i2 | 0;
         d3 = d3 + +f4;
        } else i2 = i2 + i37 | 0;
        if ((i8 | 0) < (i15 | 0)) {
         i8 = i8 + 1 | 0;
         i9 = i17 + i9 | 0;
        } else break;
       }
      } else {
       i5 = i14;
       i6 = 0;
       while (1) {
        i2 = i10 + (i6 << 2) | 0;
        f4 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f7);
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f12));
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f13));
        if (f4 >= f30 & f4 > Math_fround(0.0)) d3 = d3 + +Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(+Math_pow(+f4, +f19)));
        if ((i5 | 0) < (i15 | 0)) {
         i5 = i5 + 1 | 0;
         i6 = i17 + i6 | 0;
        } else break;
       }
      }
      if ((i1 | 0) < (i16 | 0)) {
       i1 = i1 + 1 | 0;
       i10 = i10 + (i26 << 2) | 0;
       i11 = i11 + (i27 << 2) | 0;
      } else break;
     }
    }
   }
   i18 = i18 + 1 | 0;
  } while ((i18 | 0) != 6);
 } else {
  i22 = HEAP32[i2 + 96 >> 2] | 0;
  f20 = Math_fround((HEAP32[i2 + 100 >> 2] | 0) + -1 | 0);
  i21 = (i23 | 0) == 1;
  d3 = 0.0;
  i18 = 0;
  do {
   i14 = HEAP32[i31 + (i18 * 24 | 0) >> 2] | 0;
   i15 = HEAP32[i31 + (i18 * 24 | 0) + 12 >> 2] | 0;
   if ((i14 | 0) <= (i15 | 0)) {
    i1 = HEAP32[i31 + (i18 * 24 | 0) + 4 >> 2] | 0;
    i16 = HEAP32[i31 + (i18 * 24 | 0) + 16 >> 2] | 0;
    if ((i1 | 0) <= (i16 | 0)) if ((HEAP32[i31 + (i18 * 24 | 0) + 8 >> 2] | 0) <= (HEAP32[i31 + (i18 * 24 | 0) + 20 >> 2] | 0)) {
     i10 = (Math_imul(i1, i25) | 0) + i14 | 0;
     i11 = (HEAP32[i36 + (i18 << 4) + 12 >> 2] | 0) + ((Math_imul(HEAP32[i36 + (i18 << 4) + 8 >> 2] | 0, i10) | 0) << 2) | 0;
     i17 = HEAP32[i32 + (i18 << 4) + 8 >> 2] | 0;
     i10 = (HEAP32[i32 + (i18 << 4) + 12 >> 2] | 0) + ((Math_imul(i17, i10) | 0) << 2) | 0;
     f12 = Math_fround(HEAPF32[i33 >> 2]);
     f13 = Math_fround(HEAPF32[i28 >> 2]);
     f19 = Math_fround(HEAPF32[i29 >> 2]);
     while (1) {
      L39 : do if (i24) {
       i8 = i14;
       i2 = 0;
       i9 = 0;
       while (1) {
        i5 = i10 + (i9 << 2) | 0;
        f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f12);
        f7 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f13));
        f7 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f19));
        if (!(f7 >= f30)) i2 = i2 + i37 | 0; else {
         f4 = Math_fround(HEAPF32[i5 + 12 >> 2]);
         switch (i23 | 0) {
         case 5:
         case 3:
         case 1:
          {
           f4 = Math_fround(f4 * Math_fround(HEAPF32[i22 + (~~Math_fround(f7 * f20) << 2) >> 2]));
           break;
          }
         case 2:
          {
           if (f7 > Math_fround(0.0)) f4 = Math_fround(f7 * f4); else f4 = Math_fround(0.0);
           break;
          }
         default:
          {}
         }
         if (i35) {
          i5 = 0;
          i6 = i2;
          while (1) {
           d40 = +Math_fround(f4 * Math_fround(HEAPF32[i11 + (i6 << 2) >> 2]));
           i41 = i34 + (i5 << 3) | 0;
           HEAPF64[i41 >> 3] = +HEAPF64[i41 >> 3] + d40;
           i5 = i5 + 1 | 0;
           if ((i5 | 0) == (i37 | 0)) break; else i6 = i6 + 1 | 0;
          }
          i2 = i37 + i2 | 0;
         }
         d3 = d3 + +f4;
        }
        if ((i8 | 0) < (i15 | 0)) {
         i8 = i8 + 1 | 0;
         i9 = i17 + i9 | 0;
        } else break;
       }
      } else {
       if (i21) {
        i8 = i14;
        i2 = 0;
        i9 = 0;
        while (1) {
         i41 = i10 + (i9 << 2) | 0;
         f4 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f12);
         f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i41 + 4 >> 2]) * f13));
         f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i41 + 8 >> 2]) * f19));
         if (!(f4 >= f30)) i2 = i2 + i37 | 0; else {
          f4 = Math_fround(HEAPF32[i22 + (~~Math_fround(f4 * f20) << 2) >> 2]);
          if (i35) {
           i5 = 0;
           i6 = i2;
           while (1) {
            d40 = +Math_fround(f4 * Math_fround(HEAPF32[i11 + (i6 << 2) >> 2]));
            i41 = i34 + (i5 << 3) | 0;
            HEAPF64[i41 >> 3] = +HEAPF64[i41 >> 3] + d40;
            i5 = i5 + 1 | 0;
            if ((i5 | 0) == (i37 | 0)) break; else i6 = i6 + 1 | 0;
           }
           i2 = i37 + i2 | 0;
          }
          d3 = d3 + +f4;
         }
         if ((i8 | 0) < (i15 | 0)) {
          i8 = i8 + 1 | 0;
          i9 = i17 + i9 | 0;
         } else break L39;
        }
       } else {
        i8 = i14;
        i2 = 0;
        i9 = 0;
       }
       while (1) {
        i41 = i10 + (i9 << 2) | 0;
        f4 = Math_fround(Math_fround(HEAPF32[i41 >> 2]) * f12);
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i41 + 4 >> 2]) * f13));
        f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i41 + 8 >> 2]) * f19));
        if (!(f4 >= f30)) i2 = i2 + i37 | 0; else {
         switch (i23 | 0) {
         case 5:
         case 3:
         case 1:
          {
           f4 = Math_fround(HEAPF32[i22 + (~~Math_fround(f4 * f20) << 2) >> 2]);
           break;
          }
         case 2:
          {
           if (!(f4 > Math_fround(0.0))) f4 = Math_fround(0.0);
           break;
          }
         default:
          f4 = Math_fround(1.0);
         }
         if (i35) {
          i5 = 0;
          i6 = i2;
          while (1) {
           d40 = +Math_fround(f4 * Math_fround(HEAPF32[i11 + (i6 << 2) >> 2]));
           i41 = i34 + (i5 << 3) | 0;
           HEAPF64[i41 >> 3] = +HEAPF64[i41 >> 3] + d40;
           i5 = i5 + 1 | 0;
           if ((i5 | 0) == (i37 | 0)) break; else i6 = i6 + 1 | 0;
          }
          i2 = i37 + i2 | 0;
         }
         d3 = d3 + +f4;
        }
        if ((i8 | 0) < (i15 | 0)) {
         i8 = i8 + 1 | 0;
         i9 = i17 + i9 | 0;
        } else break;
       }
      } while (0);
      if ((i1 | 0) < (i16 | 0)) {
       i1 = i1 + 1 | 0;
       i10 = i10 + (i26 << 2) | 0;
       i11 = i11 + (i27 << 2) | 0;
      } else break;
     }
    }
   }
   i18 = i18 + 1 | 0;
  } while ((i18 | 0) != 6);
 }
 if (d3 != 0.0) {
  if (i35) i1 = 0; else {
   STACKTOP = i38;
   return;
  }
  do {
   HEAPF32[i39 + (i1 << 2) >> 2] = Math_fround(+HEAPF64[i34 + (i1 << 3) >> 3] / d3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i37 | 0));
  STACKTOP = i38;
  return;
 } else {
  i2 = __Z18GetCubeMapTexelPtrPfP13CImageSurface(i33, i36) | 0;
  if (i35) i1 = 0; else {
   STACKTOP = i38;
   return;
  }
  do {
   HEAP32[i39 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i37 | 0));
  STACKTOP = i38;
  return;
 }
}

function __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i3, i5, i4, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i15 = i19 + 16 | 0;
 i16 = i19 + 18 | 0;
 i17 = i19 + 17 | 0;
 i7 = i5;
 i6 = i3;
 i1 = i7 - i6 | 0;
 i2 = (i1 | 0) > 496;
 L1 : do if ((i4 | 0) > 0 & i2) {
  i14 = i7;
  while (1) {
   i13 = i5 + -16 | 0;
   while (1) {
    i10 = (i1 >> 4) + -1 | 0;
    HEAP8[i18 >> 0] = HEAP8[i15 >> 0] | 0;
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i3, i13, i10, i18);
    i1 = -1;
    i2 = i10;
    while (1) {
     i12 = i13;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     while (1) {
      i8 = i1 + 1 | 0;
      i9 = i3 + (i8 << 4) | 0;
      i7 = i9;
      i20 = HEAP32[i7 + 4 >> 2] | 0;
      if ((i8 | 0) == (i10 | 0) | (i20 >>> 0 > i12 >>> 0 | ((i20 | 0) == (i12 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 >= i11 >>> 0 : 0))) break; else i1 = i8;
     }
     do {
      i2 = i2 + -1 | 0;
      i7 = i3 + (i2 << 4) | 0;
      i20 = i7;
      i21 = HEAP32[i20 + 4 >> 2] | 0;
     } while (!((i2 | 0) == 0 | (i12 >>> 0 > i21 >>> 0 | ((i12 | 0) == (i21 | 0) ? i11 >>> 0 >= (HEAP32[i20 >> 2] | 0) >>> 0 : 0))));
     if ((i8 | 0) >= (i2 | 0)) break;
     HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     i1 = i8;
    }
    HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i18 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    i8 = i3 + (i1 + 2 << 4) | 0;
    i4 = ((i4 | 0) / 2 | 0) + ((i4 | 0) / 4 | 0) | 0;
    i9 = i3 + (i1 << 4) + 16 | 0;
    i10 = i9;
    i2 = i10 - i6 >> 4;
    i6 = i8;
    i1 = i14 - i6 | 0;
    i7 = i1 >> 4;
    if ((i2 | 0) >= (i7 | 0)) break;
    HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
    __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i3, i9, i2, i18);
    i2 = (i1 | 0) > 496;
    if (!((i4 | 0) > 0 & i2)) break L1; else i3 = i8;
   }
   HEAP8[i18 >> 0] = HEAP8[i17 >> 0] | 0;
   __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_(i8, i5, i7, i18);
   i6 = i3;
   i1 = i10 - i6 | 0;
   i2 = (i1 | 0) > 496;
   if ((i4 | 0) > 0 & i2) {
    i5 = i9;
    i14 = i10;
   } else {
    i8 = i3;
    i5 = i9;
    break;
   }
  }
 } else i8 = i3; while (0);
 if (!i2) {
  if (!(i8 >>> 0 < i5 >>> 0 & (i1 | 0) > 16)) {
   STACKTOP = i19;
   return;
  }
  i1 = i8;
  do {
   L26 : do if (i1 >>> 0 > i8 >>> 0) {
    i2 = i1;
    do {
     i3 = i2;
     i2 = i2 + -16 | 0;
     i20 = i3;
     i16 = HEAP32[i20 + 4 >> 2] | 0;
     i21 = i2;
     i17 = HEAP32[i21 + 4 >> 2] | 0;
     if (!(i16 >>> 0 < i17 >>> 0 | ((i16 | 0) == (i17 | 0) ? (HEAP32[i20 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0))) break L26;
     HEAP32[i18 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i18 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    } while (i2 >>> 0 > i8 >>> 0);
   } while (0);
   i1 = i1 + 16 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
  STACKTOP = i19;
  return;
 }
 i12 = i1 >> 4;
 i13 = (i12 + -2 | 0) / 2 | 0;
 i11 = i13;
 while (1) {
  i4 = i8 + (i11 << 4) | 0;
  i1 = i11 << 4;
  if ((i13 | 0) >= (i1 >> 4 | 0)) {
   i3 = i1 >> 3;
   i2 = i3 | 1;
   i1 = i8 + (i2 << 4) | 0;
   i3 = i3 + 2 | 0;
   if ((i3 | 0) < (i12 | 0)) {
    i20 = i1 + 16 | 0;
    i17 = i1;
    i15 = HEAP32[i17 + 4 >> 2] | 0;
    i21 = i20;
    i16 = HEAP32[i21 + 4 >> 2] | 0;
    i21 = i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
    i1 = i21 ? i20 : i1;
    i2 = i21 ? i3 : i2;
   }
   i21 = i1;
   i20 = HEAP32[i21 + 4 >> 2] | 0;
   i7 = i4;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   if (!(i20 >>> 0 < i7 >>> 0 | ((i20 | 0) == (i7 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i6 >>> 0 : 0))) {
    i10 = i8 + (i11 << 4) + 8 | 0;
    i9 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i3 = i4;
    while (1) {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     if ((i13 | 0) < (i2 | 0)) break;
     i2 = i2 << 1 | 1;
     i3 = i8 + (i2 << 4) | 0;
     i4 = i2 + 1 | 0;
     if ((i4 | 0) < (i12 | 0)) {
      i20 = i3 + 16 | 0;
      i17 = i3;
      i15 = HEAP32[i17 + 4 >> 2] | 0;
      i21 = i20;
      i16 = HEAP32[i21 + 4 >> 2] | 0;
      i21 = i15 >>> 0 < i16 >>> 0 | ((i15 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
      i3 = i21 ? i20 : i3;
      i2 = i21 ? i4 : i2;
     }
     i21 = i3;
     i20 = HEAP32[i21 + 4 >> 2] | 0;
     if (i20 >>> 0 < i7 >>> 0 | ((i20 | 0) == (i7 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i6 >>> 0 : 0)) break; else {
      i21 = i1;
      i1 = i3;
      i3 = i21;
     }
    }
    i21 = i1;
    HEAP32[i21 >> 2] = i6;
    HEAP32[i21 + 4 >> 2] = i7;
    i21 = i1 + 8 | 0;
    HEAP32[i21 >> 2] = i9;
    HEAP32[i21 + 4 >> 2] = i10;
   }
  }
  if ((i11 | 0) > 0) i11 = i11 + -1 | 0; else break;
 }
 i14 = i8 + 16 | 0;
 i15 = i8 + 32 | 0;
 i13 = i8 + 8 | 0;
 do {
  i5 = i5 + -16 | 0;
  HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  i1 = i12;
  i12 = i12 + -1 | 0;
  if ((i1 | 0) != 2) {
   i21 = i1 + -3 | 0;
   i6 = (i21 | 0) / 2 | 0;
   if ((i21 | 0) >= -1) {
    if ((i12 | 0) > 2) {
     i1 = i14;
     i20 = HEAP32[i1 + 4 >> 2] | 0;
     i2 = i15;
     i21 = HEAP32[i2 + 4 >> 2] | 0;
     i2 = i20 >>> 0 < i21 >>> 0 | ((i20 | 0) == (i21 | 0) ? (HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 : 0);
     i1 = i2 ? i15 : i14;
     i2 = i2 ? 2 : 1;
    } else {
     i1 = i14;
     i2 = 1;
    }
    i21 = i1;
    i20 = HEAP32[i21 + 4 >> 2] | 0;
    i9 = i8;
    i7 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    if (!(i20 >>> 0 < i9 >>> 0 | ((i20 | 0) == (i9 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) {
     i11 = i13;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     i3 = i8;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      if ((i6 | 0) < (i2 | 0)) break;
      i2 = i2 << 1 | 1;
      i3 = i8 + (i2 << 4) | 0;
      i4 = i2 + 1 | 0;
      if ((i4 | 0) < (i12 | 0)) {
       i20 = i3 + 16 | 0;
       i17 = i3;
       i22 = HEAP32[i17 + 4 >> 2] | 0;
       i21 = i20;
       i16 = HEAP32[i21 + 4 >> 2] | 0;
       i21 = i22 >>> 0 < i16 >>> 0 | ((i22 | 0) == (i16 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0);
       i3 = i21 ? i20 : i3;
       i2 = i21 ? i4 : i2;
      }
      i22 = i3;
      i21 = HEAP32[i22 + 4 >> 2] | 0;
      if (i21 >>> 0 < i9 >>> 0 | ((i21 | 0) == (i9 | 0) ? (HEAP32[i22 >> 2] | 0) >>> 0 < i7 >>> 0 : 0)) break; else {
       i22 = i1;
       i1 = i3;
       i3 = i22;
      }
     }
     i22 = i1;
     HEAP32[i22 >> 2] = i7;
     HEAP32[i22 + 4 >> 2] = i9;
     i22 = i1 + 8 | 0;
     HEAP32[i22 >> 2] = i10;
     HEAP32[i22 + 4 >> 2] = i11;
    }
   }
  }
 } while ((i12 | 0) > 1);
 STACKTOP = i19;
 return;
}

function __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i10, i1, i2, i23, i24) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, f40 = f0, i41 = 0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, f61 = f0, i62 = 0, f63 = f0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 32 | 0;
 i26 = i29 + 16 | 0;
 i27 = i29;
 if (i2 >>> 0 >= i23 >>> 0) {
  STACKTOP = i29;
  return;
 }
 i28 = i1 + 520 | 0;
 i11 = i25 + 4 | 0;
 i12 = i25 + 8 | 0;
 i13 = i25 + 12 | 0;
 i14 = i1 + 500 | 0;
 i15 = i26 + 4 | 0;
 i16 = i26 + 8 | 0;
 i17 = i26 + 12 | 0;
 i18 = i1 + 120 | 0;
 i19 = i1 + 140 | 0;
 i20 = i1 + 160 | 0;
 i21 = i1 + 60 | 0;
 i22 = i1 + 80 | 0;
 i3 = i1 + 100 | 0;
 i4 = i27 + 4 | 0;
 i5 = i27 + 8 | 0;
 i6 = i27 + 12 | 0;
 i7 = i24 + 4 | 0;
 i8 = i24 + 8 | 0;
 i9 = i24 + 12 | 0;
 i1 = i2;
 do {
  i2 = (HEAP32[i28 >> 2] | 0) + (i1 << 2) | 0;
  f38 = Math_fround(HEAPF32[i2 >> 2]);
  f44 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f44 = Math_fround(f44 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f40 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i25 >> 2] = Math_fround(f38 * Math_fround(.00999999977));
  HEAPF32[i11 >> 2] = f44;
  HEAPF32[i12 >> 2] = f42;
  HEAPF32[i13 >> 2] = f40;
  i2 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  i41 = (HEAP32[i2 >> 2] | 0) + 322376503 | 0;
  i48 = (HEAP32[i2 + 4 >> 2] | 0) + 322376503 | 0;
  i62 = (HEAP32[i2 + 8 >> 2] | 0) + 322376503 | 0;
  i2 = (HEAP32[i2 + 12 >> 2] | 0) + 322376503 | 0;
  i43 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
  i60 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i64 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
  i39 = (Math_imul(i2, 1790253981) | 0) + 1900727103 | 0;
  i41 = i41 << 11 ^ i41;
  i48 = i48 << 11 ^ i48;
  i62 = i62 << 11 ^ i62;
  i2 = i2 << 11 ^ i2;
  f40 = Math_fround(Math_fround((i60 ^ i48 ^ i48 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i64 ^ i62 ^ i62 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f44 = Math_fround(Math_fround((i39 ^ i2 ^ i2 >>> 8) & 8388607 ^ i39 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i26 >> 2] = Math_fround(Math_fround((i43 ^ i41 ^ i41 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i15 >> 2] = f40;
  HEAPF32[i16 >> 2] = f42;
  HEAPF32[i17 >> 2] = f44;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i27, i10, i25, i26);
  i43 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i43 >> 2]);
  f42 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0;
  f37 = Math_fround(HEAPF32[i43 >> 2]);
  f36 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i20 >> 2] | 0) + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i43 >> 2]);
  f32 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i21 >> 2] | 0) + (i1 << 2) | 0;
  f45 = Math_fround(HEAPF32[i43 >> 2]);
  i41 = i43 + 4 | 0;
  f58 = Math_fround(HEAPF32[i41 >> 2]);
  i39 = i43 + 8 | 0;
  f57 = Math_fround(HEAPF32[i39 >> 2]);
  i2 = i43 + 12 | 0;
  f56 = Math_fround(HEAPF32[i2 >> 2]);
  i64 = (HEAP32[i22 >> 2] | 0) + (i1 << 2) | 0;
  f55 = Math_fround(HEAPF32[i64 >> 2]);
  f54 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f53 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i64 + 12 >> 2]);
  i64 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  f71 = Math_fround(HEAPF32[i64 >> 2]);
  f72 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f74 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f45 = Math_fround(f44 + f45);
  f58 = Math_fround(f42 + f58);
  f57 = Math_fround(f40 + f57);
  f56 = Math_fround(f38 + f56);
  f55 = Math_fround(f37 + f55);
  f54 = Math_fround(f36 + f54);
  f53 = Math_fround(f35 + f53);
  f52 = Math_fround(f34 + f52);
  f71 = Math_fround(f33 + f71);
  f72 = Math_fround(f32 + f72);
  f74 = Math_fround(f31 + f74);
  f75 = Math_fround(f30 + Math_fround(HEAPF32[i64 + 12 >> 2]));
  f67 = Math_fround(Math_fround(Math_fround(f45 * f45) + Math_fround(f55 * f55)) + Math_fround(f71 * f71));
  f70 = Math_fround(Math_fround(Math_fround(f58 * f58) + Math_fround(f54 * f54)) + Math_fround(f72 * f72));
  f73 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f53 * f53)) + Math_fround(f74 * f74));
  f76 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f52 * f52)) + Math_fround(f75 * f75));
  f51 = Math_fround(Math_sqrt(Math_fround(f67)));
  f63 = Math_fround(Math_fround(1.0) / f51);
  f50 = Math_fround(Math_sqrt(Math_fround(f70)));
  f61 = Math_fround(Math_fround(1.0) / f50);
  f49 = Math_fround(Math_sqrt(Math_fround(f73)));
  f59 = Math_fround(Math_fround(1.0) / f49);
  f46 = Math_fround(Math_sqrt(Math_fround(f76)));
  f47 = Math_fround(Math_fround(1.0) / f46);
  f45 = Math_fround(f45 * f63);
  f58 = Math_fround(f58 * f61);
  f57 = Math_fround(f57 * f59);
  f56 = Math_fround(f56 * f47);
  f55 = Math_fround(f55 * f63);
  f54 = Math_fround(f54 * f61);
  f53 = Math_fround(f53 * f59);
  f52 = Math_fround(f52 * f47);
  f63 = Math_fround(f71 * f63);
  f61 = Math_fround(f72 * f61);
  f59 = Math_fround(f74 * f59);
  f47 = Math_fround(f75 * f47);
  i64 = f67 > Math_fround(9.99999974e-06);
  i62 = f70 > Math_fround(9.99999974e-06);
  i60 = f73 > Math_fround(9.99999974e-06);
  i48 = f76 > Math_fround(9.99999974e-06);
  f76 = Math_fround((f51 > Math_fround(0.0) & 1) - (f51 < Math_fround(0.0) & 1) | 0);
  f73 = Math_fround((f50 > Math_fround(0.0) & 1) - (f50 < Math_fround(0.0) & 1) | 0);
  f70 = Math_fround((f49 > Math_fround(0.0) & 1) - (f49 < Math_fround(0.0) & 1) | 0);
  f67 = Math_fround((f46 > Math_fround(0.0) & 1) - (f46 < Math_fround(0.0) & 1) | 0);
  f51 = Math_fround(Math_abs(Math_fround(f51)));
  f50 = Math_fround(Math_abs(Math_fround(f50)));
  f49 = Math_fround(Math_abs(Math_fround(f49)));
  f46 = Math_fround(Math_abs(Math_fround(f46)));
  f75 = Math_fround(HEAPF32[i27 >> 2]);
  f74 = Math_fround(f75 - f51);
  f72 = Math_fround(HEAPF32[i4 >> 2]);
  f71 = Math_fround(f72 - f50);
  f69 = Math_fround(HEAPF32[i5 >> 2]);
  f68 = Math_fround(f69 - f49);
  f66 = Math_fround(HEAPF32[i6 >> 2]);
  f65 = Math_fround(f66 - f46);
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i24 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i7 >> 2]));
  f68 = Math_fround(f68 * Math_fround(HEAPF32[i8 >> 2]));
  f74 = Math_fround(f51 + f74);
  f71 = Math_fround(f50 + f71);
  f68 = Math_fround(f49 + f68);
  f65 = Math_fround(f46 + Math_fround(f65 * Math_fround(HEAPF32[i9 >> 2])));
  f51 = Math_fround(f76 * (f51 > f75 ? f74 : f51));
  f50 = Math_fround(f73 * (f50 > f72 ? f71 : f50));
  f49 = Math_fround(f70 * (f49 > f69 ? f68 : f49));
  f46 = Math_fround(f67 * (f46 > f66 ? f65 : f46));
  f45 = Math_fround((i64 ? f45 : Math_fround(0.0)) * f51);
  f58 = Math_fround((i62 ? f58 : Math_fround(0.0)) * f50);
  f57 = Math_fround((i60 ? f57 : Math_fround(0.0)) * f49);
  f56 = Math_fround((i48 ? f56 : Math_fround(0.0)) * f46);
  f55 = Math_fround((i64 ? f55 : Math_fround(0.0)) * f51);
  f54 = Math_fround((i62 ? f54 : Math_fround(0.0)) * f50);
  f53 = Math_fround((i60 ? f53 : Math_fround(0.0)) * f49);
  f52 = Math_fround((i48 ? f52 : Math_fround(0.0)) * f46);
  f51 = Math_fround((i64 ? f63 : Math_fround(0.0)) * f51);
  f50 = Math_fround((i62 ? f61 : Math_fround(0.0)) * f50);
  f49 = Math_fround((i60 ? f59 : Math_fround(0.0)) * f49);
  f42 = Math_fround(f58 - f42);
  f40 = Math_fround(f57 - f40);
  f38 = Math_fround(f56 - f38);
  f37 = Math_fround(f55 - f37);
  f36 = Math_fround(f54 - f36);
  f35 = Math_fround(f53 - f35);
  f34 = Math_fround(f52 - f34);
  f33 = Math_fround(f51 - f33);
  f32 = Math_fround(f50 - f32);
  f31 = Math_fround(f49 - f31);
  f30 = Math_fround(Math_fround((i48 ? f47 : Math_fround(0.0)) * f46) - f30);
  HEAPF32[i43 >> 2] = Math_fround(f45 - f44);
  HEAPF32[i41 >> 2] = f42;
  HEAPF32[i39 >> 2] = f40;
  HEAPF32[i2 >> 2] = f38;
  i2 = (HEAP32[i22 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f37;
  HEAPF32[i2 + 4 >> 2] = f36;
  HEAPF32[i2 + 8 >> 2] = f35;
  HEAPF32[i2 + 12 >> 2] = f34;
  i2 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f33;
  HEAPF32[i2 + 4 >> 2] = f32;
  HEAPF32[i2 + 8 >> 2] = f31;
  HEAPF32[i2 + 12 >> 2] = f30;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i23 >>> 0);
 STACKTOP = i29;
 return;
}

function __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i7 + 16 | 0;
 i10 = i7 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = i2;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = i2;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = i2;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i3;
 }
 HEAP16[i6 + 32 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
  i3 = i1;
 }
 HEAP16[i6 + 34 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i1 = i3 + 2 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i3 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
  i3 = i4;
 }
 HEAP16[i6 + 36 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 38 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 40 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 42 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 44 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i4 = HEAP16[i8 >> 1] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i4;
  HEAP32[i9 >> 2] = i2;
  i1 = i2;
 }
 HEAP16[i6 + 46 >> 1] = _llvm_bswap_i16(i4 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 48 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 50 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 52 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 54 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 56 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 58 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i4 = HEAP16[i8 >> 1] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i4;
  HEAP32[i9 >> 2] = i2;
  i5 = i2;
  i1 = i3;
 }
 HEAP16[i6 + 60 >> 1] = _llvm_bswap_i16(i4 | 0) | 0;
 i2 = i5 + 2 | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP16[i8 >> 1] | 0;
 } else {
  i4 = HEAP16[i5 >> 1] | 0;
  HEAP16[i8 >> 1] = i4;
  HEAP32[i9 >> 2] = i2;
  i5 = i1;
  i1 = i4;
 }
 HEAP16[i6 + 62 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 64 >> 0] = i1;
 i1 = i6 + 65 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  __ZN8Gradient17ValidateColorKeysEv(i6);
  __ZN8Gradient17ValidateAlphaKeysEv(i6);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  __ZN8Gradient17ValidateColorKeysEv(i6);
  __ZN8Gradient17ValidateAlphaKeysEv(i6);
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = i2;
 L1 : while (1) {
  i11 = i14;
  i15 = i14 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i10 = i1;
    i2 = i11 - i10 | 0;
    i3 = i2 >> 2;
    switch (i3 | 0) {
    case 2:
     {
      i13 = 5;
      break L1;
     }
    case 3:
     {
      i13 = 7;
      break L1;
     }
    case 4:
     {
      i13 = 15;
      break L1;
     }
    case 5:
     {
      i13 = 27;
      break L1;
     }
    case 1:
    case 0:
     {
      i13 = 87;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 124) {
     i13 = 29;
     break L1;
    }
    i9 = i1 + (((i3 | 0) / 2 | 0) << 2) | 0;
    do if ((i2 | 0) > 3996) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i2 << 2) | 0, i9, i9 + (i2 << 2) | 0, i15, i12) | 0;
    } else {
     i3 = HEAP32[i9 >> 2] | 0;
     i6 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i3 + 4 >> 2] | 0;
     i5 = HEAP32[i6 + 4 >> 2] | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     i2 = (HEAP32[i4 + 4 >> 2] | 0) < (i8 | 0);
     if ((i8 | 0) >= (i5 | 0)) {
      if (!i2) {
       i2 = 0;
       break;
      }
      HEAP32[i9 >> 2] = i4;
      HEAP32[i15 >> 2] = i3;
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i2 + 4 >> 2] | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) {
       i2 = 1;
       break;
      }
      HEAP32[i1 >> 2] = i2;
      HEAP32[i9 >> 2] = i3;
      i2 = 2;
      break;
     }
     if (i2) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i15 >> 2] = i6;
      i2 = 1;
      break;
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i9 >> 2] = i6;
     i2 = HEAP32[i15 >> 2] | 0;
     if ((HEAP32[i2 + 4 >> 2] | 0) < (i5 | 0)) {
      HEAP32[i9 >> 2] = i2;
      HEAP32[i15 >> 2] = i6;
      i2 = 2;
     } else i2 = 1;
    } while (0);
    i4 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i4 + 4 >> 2] | 0;
    i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0;
    if ((i7 | 0) < (i5 | 0)) {
     i3 = i15;
     break;
    } else i3 = i15;
    while (1) {
     i3 = i3 + -4 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i6 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i6 + 4 >> 2] | 0) < (i5 | 0)) {
      i13 = 69;
      break L5;
     }
    }
    i2 = i1 + 4 | 0;
    i10 = HEAP32[i15 >> 2] | 0;
    i4 = i10;
    if ((i7 | 0) >= (HEAP32[i10 + 4 >> 2] | 0)) {
     if ((i2 | 0) == (i15 | 0)) {
      i13 = 87;
      break L1;
     }
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i7 | 0) < (HEAP32[i3 + 4 >> 2] | 0)) break;
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i15 | 0)) {
       i13 = 87;
       break L1;
      }
     }
     HEAP32[i2 >> 2] = i4;
     HEAP32[i15 >> 2] = i3;
     i2 = i2 + 4 | 0;
    }
    if ((i2 | 0) == (i15 | 0)) {
     i13 = 87;
     break L1;
    } else i4 = i15;
    while (1) {
     i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      i6 = i2 + 4 | 0;
      if ((i7 | 0) < (HEAP32[i3 + 4 >> 2] | 0)) break; else i2 = i6;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while ((i7 | 0) < (HEAP32[i5 + 4 >> 2] | 0));
     if (i2 >>> 0 >= i4 >>> 0) {
      i1 = i2;
      continue L5;
     }
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i3;
     i2 = i6;
    }
   }
   if ((i13 | 0) == 69) {
    i13 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i3 >> 2] = i4;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 4 | 0;
   L45 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0;
    while (1) {
     i5 = HEAP32[i4 >> 2] | 0;
     i7 = i4 + 4 | 0;
     if ((HEAP32[i5 + 4 >> 2] | 0) < (i8 | 0)) i4 = i7; else break;
    }
    do {
     i3 = i3 + -4 | 0;
     i6 = HEAP32[i3 >> 2] | 0;
    } while ((HEAP32[i6 + 4 >> 2] | 0) >= (i8 | 0));
    if (i4 >>> 0 > i3 >>> 0) {
     i5 = i9;
     i6 = i4;
     break L45;
    }
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i5;
    i9 = (i9 | 0) == (i4 | 0) ? i3 : i9;
    i4 = i7;
    i2 = i2 + 1 | 0;
   } else {
    i5 = i9;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i3 + 4 >> 2] | 0) < (HEAP32[i4 + 4 >> 2] | 0)) {
     HEAP32[i6 >> 2] = i3;
     HEAP32[i5 >> 2] = i4;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR17CompareInstanceIDPP6ObjectEEbT0_S6_T_(i1, i6, i12) | 0;
    i3 = i6 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR17CompareInstanceIDPP6ObjectEEbT0_S6_T_(i3, i14, i12) | 0) {
     i13 = 86;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i9 = i6;
   if ((i9 - i10 | 0) >= (i11 - i9 | 0)) {
    i13 = 85;
    break;
   }
   __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_(i1, i6, i12);
   i1 = i6 + 4 | 0;
  }
  if ((i13 | 0) == 85) {
   i13 = 0;
   __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_(i6 + 4 | 0, i14, i12);
   i14 = i6;
   continue;
  } else if ((i13 | 0) == 86) {
   i13 = 0;
   if (i2) {
    i13 = 87;
    break;
   } else {
    i14 = i6;
    continue;
   }
  }
 }
 if ((i13 | 0) == 5) {
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  return;
 } else if ((i13 | 0) == 7) {
  i7 = i1 + 4 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i2 = (HEAP32[i4 + 4 >> 2] | 0) < (i14 | 0);
  if ((i14 | 0) >= (i5 | 0)) {
   if (!i2) return;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i15 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i2 + 4 >> 2] | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   return;
  }
  if (i2) {
   HEAP32[i1 >> 2] = i4;
   HEAP32[i15 >> 2] = i6;
   return;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i6;
  i1 = HEAP32[i15 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) >= (i5 | 0)) return;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i15 >> 2] = i6;
  return;
 } else if ((i13 | 0) == 15) {
  i12 = i1 + 4 | 0;
  i11 = i1 + 8 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (i6 | 0) < (i14 | 0);
  i3 = i8;
  i9 = i5;
  i10 = i4;
  do if ((i14 | 0) < (i2 | 0)) {
   if (i7) {
    HEAP32[i1 >> 2] = i9;
    HEAP32[i11 >> 2] = i10;
    i3 = i10;
    break;
   }
   HEAP32[i1 >> 2] = i3;
   HEAP32[i12 >> 2] = i10;
   if ((i6 | 0) < (i2 | 0)) {
    HEAP32[i12 >> 2] = i9;
    HEAP32[i11 >> 2] = i10;
    i3 = i10;
   } else {
    i4 = i5;
    i3 = i9;
   }
  } else if (i7) {
   HEAP32[i12 >> 2] = i9;
   HEAP32[i11 >> 2] = i3;
   if ((i6 | 0) < (i2 | 0)) {
    HEAP32[i1 >> 2] = i9;
    HEAP32[i12 >> 2] = i10;
    i4 = i8;
    i3 = i8;
   } else i4 = i8;
  } else {
   i4 = i5;
   i3 = i9;
  } while (0);
  i2 = HEAP32[i15 >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) >= (HEAP32[i4 + 4 >> 2] | 0)) return;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  if ((i5 | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) return;
  i4 = i2;
  HEAP32[i12 >> 2] = i4;
  HEAP32[i11 >> 2] = i3;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) return;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i12 >> 2] = i2;
  return;
 } else if ((i13 | 0) == 27) {
  __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i15, i12) | 0;
  return;
 } else if ((i13 | 0) == 29) {
  i4 = i1 + 8 | 0;
  i9 = i1 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i11 = HEAP32[i1 >> 2] | 0;
  i15 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = (i2 | 0) < (i15 | 0);
  i6 = i10;
  i7 = i3;
  i8 = i11;
  do if ((i15 | 0) < (i12 | 0)) {
   if (i5) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i4 >> 2] = i8;
    i3 = i11;
    break;
   }
   HEAP32[i1 >> 2] = i6;
   HEAP32[i9 >> 2] = i8;
   if ((i2 | 0) < (i12 | 0)) {
    HEAP32[i9 >> 2] = i7;
    HEAP32[i4 >> 2] = i8;
    i3 = i11;
   }
  } else if (i5) {
   HEAP32[i9 >> 2] = i7;
   HEAP32[i4 >> 2] = i6;
   if ((i2 | 0) < (i12 | 0)) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i9 >> 2] = i8;
    i3 = i10;
   } else i3 = i10;
  } while (0);
  i2 = i1 + 12 | 0;
  if ((i2 | 0) == (i14 | 0)) return; else {
   i7 = i2;
   i2 = i3;
  }
  while (1) {
   i6 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i5 | 0) < (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = i4;
    i2 = i7;
    while (1) {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     if ((i3 | 0) == (i1 | 0)) break;
     i2 = i3 + -4 | 0;
     if ((i5 | 0) < (HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0)) {
      i15 = i3;
      i3 = i2;
      i2 = i15;
     } else break;
    }
    HEAP32[i3 >> 2] = i6;
   }
   i2 = i7 + 4 | 0;
   if ((i2 | 0) == (i14 | 0)) break;
   i15 = HEAP32[i7 >> 2] | 0;
   i4 = i7;
   i7 = i2;
   i2 = i15;
  }
  return;
 } else if ((i13 | 0) == 87) return;
}

function __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 12 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 28 | 0, gb + 1085935 | 0, 0);
 i1 = i8 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i9 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 } else i3 = i9 + 4 | 0;
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i2 + 4;
 HEAP32[i10 + 4 >> 2] = i2;
 HEAP32[i10 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i2 + 8;
 HEAP32[i10 + 4 >> 2] = i2;
 HEAP32[i10 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i2 + 16;
 HEAP32[i10 + 4 >> 2] = i2 + 12;
 HEAP32[i10 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i9 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 } else i3 = i9 + 4 | 0;
 i1 = i2 + i1 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i1 + 4;
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim4hand4HandEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i8 + 48 | 0, i9);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim4hand4HandEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i8 + 52 | 0, i9);
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + 60;
 HEAP32[i10 + 4 >> 2] = i8 + 56;
 HEAP32[i10 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + 68;
 HEAP32[i10 + 4 >> 2] = i8 + 64;
 HEAP32[i10 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i5 >>> 0 > 24 ? 24 : i5;
 i4 = i8 + 72 + (i5 << 2) | 0;
 if (i5 | 0) {
  i3 = i8 + 72 | 0;
  do {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
    i1 = HEAP32[i10 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i5 >>> 0 > 24 ? 24 : i5;
 i4 = i8 + 168 + (i5 << 2) | 0;
 if (i5 | 0) {
  i3 = i8 + 168 | 0;
  do {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
    i1 = HEAP32[i10 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i5 >>> 0 > 24 ? 24 : i5;
 i4 = i8 + 264 + (i5 << 2) | 0;
 if (i5 | 0) {
  i3 = i8 + 264 | 0;
  do {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
    i1 = HEAP32[i10 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 360 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 364 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 372 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 376 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 380 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 384 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i6 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 388 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i10 >> 0] = i5;
  HEAP32[i6 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 392 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 393 >> 0] = i1;
 i1 = i8 + 394 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i10 = HEAP8[i10 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i10 >> 0] = i8;
  HEAP32[i6 >> 2] = i3;
  i10 = i8;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN9SubModule8TransferI14SafeBinaryReadEEvRT_(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 8 | 0;
 i8 = i15;
 __ZN14SafeBinaryRead10SetVersionEi(i7, 2);
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i12, i7);
 i14 = i12 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619592 | 0, HEAP32[gb + 37316 >> 2] | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i7, i14, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i7, 1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = i12 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i8;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i11 = i12 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619604 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i8, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i9 = i8 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619641 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i9, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i6 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i6 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619658 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i8, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619678 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i9, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i6 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] = 1;
  HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i6 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] = 1;
  HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619699 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i8, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 619715 | 0, gb + 619620 | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i9, i7); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i8 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i8 + (i3 * 12 | 0) + 4 >> 2] = 2;
  HEAP32[i8 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i12 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = i12;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i12 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 + (i3 * 12 | 0) >> 2] = i2;
  HEAP32[i12 + (i3 * 12 | 0) + 4 >> 2] = 2;
  HEAP32[i12 + (i3 * 12 | 0) + 8 >> 2] = 0;
 }
 if (!(HEAP32[i10 >> 2] | 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i14, 1, i13, 1);
 }
 STACKTOP = i15;
 return;
}

function __Z16TexelCoordToVectiffiPfi(i10, f3, f4, i11, i13, i8) {
 i10 = i10 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i11 = i11 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, d7 = 0.0, i9 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, d20 = 0.0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0;
 i9 = (i11 | 0) > 1;
 if (i9 & (i8 | 0) == 7) {
  f1 = Math_fround(Math_fround(i11 | 0) + Math_fround(-1.0));
  f2 = Math_fround(Math_fround(f3 * Math_fround(2.0)) / f1);
  f1 = Math_fround(Math_fround(f4 * Math_fround(2.0)) / f1);
 } else {
  f1 = Math_fround(i11 | 0);
  f2 = Math_fround(Math_fround(Math_fround(f3 + Math_fround(.5)) * Math_fround(2.0)) / f1);
  f1 = Math_fround(Math_fround(Math_fround(f4 + Math_fround(.5)) * Math_fround(2.0)) / f1);
 }
 f5 = Math_fround(f1 + Math_fround(-1.0));
 f2 = Math_fround(f2 + Math_fround(-1.0));
 if (i9 & (i8 | 0) == 6) {
  f3 = Math_fround(i11 | 0);
  f3 = Math_fround(Math_fround(f3 * f3) / Math_fround(+Math_pow(+Math_fround(i11 + -1 | 0), 3.0)));
  f6 = Math_fround(f2 + Math_fround(f3 * Math_fround(+Math_pow(+f2, 3.0))));
  f5 = Math_fround(f5 + Math_fround(f3 * Math_fround(+Math_pow(+f5, 3.0))));
  f3 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) >> 2]) * f6);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(f6 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 4 >> 2]));
  i11 = i13 + 4 | 0;
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(f6 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 8 >> 2]));
  i12 = i13 + 8 | 0;
  HEAPF32[i12 >> 2] = f6;
  f1 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 12 >> 2]));
  f2 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 16 >> 2]));
  f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 20 >> 2]));
  f3 = Math_fround(f1 + f3);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(f2 + f4);
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(f5 + f6);
  HEAPF32[i12 >> 2] = f6;
  f3 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 24 >> 2]) + f3);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 28 >> 2]) + f4);
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 32 >> 2]) + f6);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))));
  HEAPF32[i13 >> 2] = Math_fround(f3 * f5);
  HEAPF32[i11 >> 2] = Math_fround(f5 * f4);
  HEAPF32[i12 >> 2] = Math_fround(f5 * f6);
  return;
 }
 f1 = Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) >> 2]);
 if (!(i9 & (i8 | 0) == 5)) {
  f3 = Math_fround(f2 * f1);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(f2 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 4 >> 2]));
  i11 = i13 + 4 | 0;
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(f2 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 8 >> 2]));
  i12 = i13 + 8 | 0;
  HEAPF32[i12 >> 2] = f6;
  f1 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 12 >> 2]));
  f2 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 16 >> 2]));
  f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 20 >> 2]));
  f3 = Math_fround(f1 + f3);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(f2 + f4);
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(f5 + f6);
  HEAPF32[i12 >> 2] = f6;
  f3 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 24 >> 2]) + f3);
  HEAPF32[i13 >> 2] = f3;
  f4 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 28 >> 2]) + f4);
  HEAPF32[i11 >> 2] = f4;
  f6 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i10 * 36 | 0) + 32 >> 2]) + f6);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))));
  HEAPF32[i13 >> 2] = Math_fround(f3 * f5);
  HEAPF32[i11 >> 2] = Math_fround(f5 * f4);
  HEAPF32[i12 >> 2] = Math_fround(f5 * f6);
  return;
 }
 i34 = f2 < Math_fround(0.0);
 f22 = i34 ? Math_fround(-1.0) : Math_fround(1.0);
 f24 = Math_fround(f22 * f1);
 i9 = gb + 41340 + (i10 * 36 | 0) + 4 | 0;
 f30 = Math_fround(HEAPF32[i9 >> 2]);
 f15 = Math_fround(f22 * f30);
 i8 = gb + 41340 + (i10 * 36 | 0) + 8 | 0;
 f27 = Math_fround(HEAPF32[i8 >> 2]);
 f22 = Math_fround(f22 * f27);
 i19 = gb + 41340 + (i10 * 36 | 0) + 12 | 0;
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 i33 = f5 < Math_fround(0.0);
 f16 = i33 ? Math_fround(-1.0) : Math_fround(1.0);
 f23 = Math_fround(f16 * f31);
 i18 = gb + 41340 + (i10 * 36 | 0) + 16 | 0;
 f29 = Math_fround(HEAPF32[i18 >> 2]);
 f21 = Math_fround(f16 * f29);
 i17 = gb + 41340 + (i10 * 36 | 0) + 20 | 0;
 f6 = Math_fround(HEAPF32[i17 >> 2]);
 f23 = Math_fround(f24 + f23);
 f21 = Math_fround(f15 + f21);
 f16 = Math_fround(f22 + Math_fround(f16 * f6));
 i14 = gb + 41340 + (i10 * 36 | 0) + 24 | 0;
 f22 = Math_fround(HEAPF32[i14 >> 2]);
 f23 = Math_fround(f23 + f22);
 i12 = gb + 41340 + (i10 * 36 | 0) + 28 | 0;
 f15 = Math_fround(HEAPF32[i12 >> 2]);
 f21 = Math_fround(f21 + f15);
 i10 = gb + 41340 + (i10 * 36 | 0) + 32 | 0;
 f24 = Math_fround(HEAPF32[i10 >> 2]);
 f16 = Math_fround(f16 + f24);
 f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f21 * f21)) + Math_fround(f16 * f16)))));
 f23 = Math_fround(f23 * f25);
 f21 = Math_fround(f21 * f25);
 f25 = Math_fround(f16 * f25);
 f16 = Math_fround(i11 + -1 | 0);
 f32 = Math_fround(Math_fround(f16 + Math_fround(.5)) * Math_fround(2.0));
 f26 = Math_fround(i11 | 0);
 f28 = Math_fround(Math_fround((i34 ? Math_fround(1.0) : f32) / f26) + Math_fround(-1.0));
 f26 = Math_fround(Math_fround((i33 ? Math_fround(1.0) : f32) / f26) + Math_fround(-1.0));
 f22 = Math_fround(Math_fround(Math_fround(f28 * f1) + Math_fround(f26 * f31)) + f22);
 f15 = Math_fround(Math_fround(Math_fround(f28 * f30) + Math_fround(f26 * f29)) + f15);
 f24 = Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f26 * f6)) + f24);
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f15 * f15)) + Math_fround(f24 * f24)))));
 f6 = Math_fround(+Math_acos(+Math_fround(Math_fround(f25 * Math_fround(f24 * f6)) + Math_fround(Math_fround(f23 * Math_fround(f22 * f6)) + Math_fround(f21 * Math_fround(f15 * f6))))));
 d20 = +f6;
 d7 = d20 * .5;
 f6 = Math_fround(d7 + (d20 - d7) * +Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_fround(Math_fround(+Math_log(+Math_fround(((i11 | 0) > 128 ? 128 : i11) | 0))) / Math_fround(.693147182)) + Math_fround(-1.0)) / Math_fround(6.0))));
 f15 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f3 * Math_fround(2.0)) / f16) + Math_fround(-1.0))));
 f3 = Math_fround(Math_abs(Math_fround(Math_fround(Math_fround(f4 * Math_fround(2.0)) / f16) + Math_fround(-1.0))));
 f6 = Math_fround(Math_fround((f15 < f3 ? f3 : f15) * f6) + Math_fround(0.0));
 f1 = Math_fround(f2 * f1);
 HEAPF32[i13 >> 2] = f1;
 f15 = Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2]));
 i9 = i13 + 4 | 0;
 HEAPF32[i9 >> 2] = f15;
 f3 = Math_fround(f2 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i13 + 8 | 0;
 HEAPF32[i8 >> 2] = f3;
 f16 = Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2]));
 f2 = Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2]));
 f4 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 f1 = Math_fround(f16 + f1);
 HEAPF32[i13 >> 2] = f1;
 f2 = Math_fround(f2 + f15);
 HEAPF32[i9 >> 2] = f2;
 f3 = Math_fround(f4 + f3);
 HEAPF32[i8 >> 2] = f3;
 f1 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f1);
 HEAPF32[i13 >> 2] = f1;
 f2 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f2);
 HEAPF32[i9 >> 2] = f2;
 f3 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f3);
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2))))));
 f1 = Math_fround(f1 * f4);
 HEAPF32[i13 >> 2] = f1;
 f2 = Math_fround(f4 * f2);
 HEAPF32[i9 >> 2] = f2;
 f3 = Math_fround(f4 * f3);
 HEAPF32[i8 >> 2] = f3;
 f4 = Math_fround(HEAPF32[i14 >> 2]);
 f5 = Math_fround(f4 * f1);
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f2));
 f5 = Math_fround(+Math_acos(+Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2])))));
 f6 = Math_fround(Math_fround(f6 / f5) + Math_fround(1.0));
 if (f5 == Math_fround(0.0)) {
  HEAPF32[i13 >> 2] = f4;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  return;
 }
 d7 = +f5;
 if (d7 == 3.141592653589793) {
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  return;
 } else {
  f32 = Math_fround(+Math_sin(+f5));
  f31 = Math_fround(Math_fround(+Math_sin(+Math_fround((1.0 - +f6) * d7))) / f32);
  f32 = Math_fround(Math_fround(+Math_sin(+Math_fround(f6 * f5))) / f32);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f4 * f31) + Math_fround(f1 * f32));
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(f31 * Math_fround(HEAPF32[i12 >> 2])) + Math_fround(f32 * f2));
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(f31 * Math_fround(HEAPF32[i10 >> 2])) + Math_fround(f32 * f3));
  return;
 }
}

function __ZNK5physx2Gu5RTree11traverseRayILi1EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(i19, i6, i7, i1, i2, i28, i3, f4) {
 i19 = i19 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i28 = i28 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var f5 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27 + 8 | 0;
 i26 = i27 + 4 | 0;
 i24 = i27;
 i15 = (HEAP32[i19 + 84 >> 2] & 2 | 0) == 0;
 if (i15) i23 = HEAP32[i19 + 92 >> 2] | 0; else i23 = 0;
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f21 = Math_fround(f21 + Math_fround(1.00000001e-07));
 f22 = Math_fround(f22 + Math_fround(1.00000001e-07));
 f20 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) + Math_fround(1.00000001e-07));
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 f16 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(-f16);
 f8 = Math_fround(-f17);
 f9 = Math_fround(-f18);
 f5 = f16 > f5 ? f16 : f5;
 f8 = f17 > f8 ? f17 : f8;
 f9 = f18 > f9 ? f18 : f9;
 i7 = f5 > Math_fround(9.99999971e-10);
 i1 = f8 > Math_fround(9.99999971e-10);
 i6 = f9 > Math_fround(9.99999971e-10);
 i2 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 814313567;
 i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) : 814313567;
 i7 = (i6 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 814313567) | i3 & -2147483648;
 f16 = (HEAP32[tempDoublePtr >> 2] = i2 | i10 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i1 | i11 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_fround(1.0) / f16);
 f8 = Math_fround(Math_fround(1.0) / f17);
 f9 = Math_fround(Math_fround(1.0) / f18);
 f16 = Math_fround(f5 * Math_fround(Math_fround(2.0) - Math_fround(f5 * f16)));
 f17 = Math_fround(f8 * Math_fround(Math_fround(2.0) - Math_fround(f8 * f17)));
 f18 = Math_fround(f9 * Math_fround(Math_fround(2.0) - Math_fround(f9 * f18)));
 f12 = Math_fround(Math_fround(0.0) - Math_fround(f12 * f16));
 f9 = Math_fround(Math_fround(0.0) - Math_fround(f13 * f17));
 f8 = Math_fround(Math_fround(0.0) - Math_fround(f14 * f18));
 i1 = HEAP32[i19 + 68 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if ((i2 | 0) <= -1) {
  STACKTOP = i27;
  return;
 }
 if (i15) {
  i3 = 0;
  while (1) {
   i3 = i3 + 1 | 0;
   HEAP32[i25 + (i3 << 2) >> 2] = i2 * 112;
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + -1 | 0;
  }
 } else {
  i2 = HEAP32[i19 + 92 >> 2] | 0;
  i3 = 0;
  do {
   i3 = i3 + 1 | 0;
   HEAP32[i25 + (i3 << 2) >> 2] = i2;
  } while ((i3 | 0) != (i1 | 0));
 }
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 L17 : while (1) {
  i6 = i1;
  while (1) {
   i1 = i6 + -1 | 0;
   i2 = i25 + (i6 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i26 >> 2] = i3;
   if (!(i3 & 1)) {
    f40 = Math_fround(HEAPF32[i23 + i3 >> 2]);
    f36 = Math_fround(HEAPF32[i23 + (i3 + 4) >> 2]);
    f32 = Math_fround(HEAPF32[i23 + (i3 + 8) >> 2]);
    f5 = Math_fround(HEAPF32[i23 + (i3 + 12) >> 2]);
    f29 = Math_fround(HEAPF32[i23 + (i3 + 16) >> 2]);
    f33 = Math_fround(HEAPF32[i23 + (i3 + 20) >> 2]);
    f37 = Math_fround(HEAPF32[i23 + (i3 + 24) >> 2]);
    f41 = Math_fround(HEAPF32[i23 + (i3 + 28) >> 2]);
    f61 = Math_fround(HEAPF32[i23 + (i3 + 32) >> 2]);
    f60 = Math_fround(HEAPF32[i23 + (i3 + 36) >> 2]);
    f59 = Math_fround(HEAPF32[i23 + (i3 + 40) >> 2]);
    f58 = Math_fround(HEAPF32[i23 + (i3 + 44) >> 2]);
    f39 = Math_fround(HEAPF32[i23 + (i3 + 48) >> 2]);
    f35 = Math_fround(HEAPF32[i23 + (i3 + 52) >> 2]);
    f31 = Math_fround(HEAPF32[i23 + (i3 + 56) >> 2]);
    f13 = Math_fround(HEAPF32[i23 + (i3 + 60) >> 2]);
    f45 = Math_fround(HEAPF32[i23 + (i3 + 64) >> 2]);
    f44 = Math_fround(HEAPF32[i23 + (i3 + 68) >> 2]);
    f43 = Math_fround(HEAPF32[i23 + (i3 + 72) >> 2]);
    f42 = Math_fround(HEAPF32[i23 + (i3 + 76) >> 2]);
    f38 = Math_fround(HEAPF32[i23 + (i3 + 80) >> 2]);
    f34 = Math_fround(HEAPF32[i23 + (i3 + 84) >> 2]);
    f30 = Math_fround(HEAPF32[i23 + (i3 + 88) >> 2]);
    f50 = Math_fround(f12 + Math_fround(f16 * Math_fround(f40 - f21)));
    f51 = Math_fround(f12 + Math_fround(f16 * Math_fround(f36 - f21)));
    f52 = Math_fround(f12 + Math_fround(f16 * Math_fround(f32 - f21)));
    f53 = Math_fround(f12 + Math_fround(f16 * Math_fround(f5 - f21)));
    f29 = Math_fround(f9 + Math_fround(f17 * Math_fround(f29 - f22)));
    f33 = Math_fround(f9 + Math_fround(f17 * Math_fround(f33 - f22)));
    f37 = Math_fround(f9 + Math_fround(f17 * Math_fround(f37 - f22)));
    f41 = Math_fround(f9 + Math_fround(f17 * Math_fround(f41 - f22)));
    f61 = Math_fround(f8 + Math_fround(f18 * Math_fround(f61 - f20)));
    f60 = Math_fround(f8 + Math_fround(f18 * Math_fround(f60 - f20)));
    f59 = Math_fround(f8 + Math_fround(f18 * Math_fround(f59 - f20)));
    f58 = Math_fround(f8 + Math_fround(f18 * Math_fround(f58 - f20)));
    f49 = Math_fround(f12 + Math_fround(f16 * Math_fround(f21 + f39)));
    f48 = Math_fround(f12 + Math_fround(f16 * Math_fround(f21 + f35)));
    f47 = Math_fround(f12 + Math_fround(f16 * Math_fround(f21 + f31)));
    f46 = Math_fround(f12 + Math_fround(f16 * Math_fround(f21 + f13)));
    f45 = Math_fround(f9 + Math_fround(f17 * Math_fround(f22 + f45)));
    f44 = Math_fround(f9 + Math_fround(f17 * Math_fround(f22 + f44)));
    f43 = Math_fround(f9 + Math_fround(f17 * Math_fround(f22 + f43)));
    f42 = Math_fround(f9 + Math_fround(f17 * Math_fround(f22 + f42)));
    f38 = Math_fround(f8 + Math_fround(f18 * Math_fround(f20 + f38)));
    f34 = Math_fround(f8 + Math_fround(f18 * Math_fround(f20 + f34)));
    f30 = Math_fround(f8 + Math_fround(f18 * Math_fround(f20 + f30)));
    f14 = Math_fround(f8 + Math_fround(f18 * Math_fround(f20 + Math_fround(HEAPF32[i23 + (i3 + 92) >> 2]))));
    f57 = f50 < f49 ? f50 : f49;
    f56 = f51 < f48 ? f51 : f48;
    f55 = f52 < f47 ? f52 : f47;
    f54 = f53 < f46 ? f53 : f46;
    f49 = f50 > f49 ? f50 : f49;
    f48 = f51 > f48 ? f51 : f48;
    f47 = f52 > f47 ? f52 : f47;
    f46 = f53 > f46 ? f53 : f46;
    f53 = f29 < f45 ? f29 : f45;
    f52 = f33 < f44 ? f33 : f44;
    f51 = f37 < f43 ? f37 : f43;
    f50 = f41 < f42 ? f41 : f42;
    f45 = f29 > f45 ? f29 : f45;
    f44 = f33 > f44 ? f33 : f44;
    f43 = f37 > f43 ? f37 : f43;
    f42 = f41 > f42 ? f41 : f42;
    f41 = f61 < f38 ? f61 : f38;
    f37 = f60 < f34 ? f60 : f34;
    f33 = f59 < f30 ? f59 : f30;
    f29 = f58 < f14 ? f58 : f14;
    f38 = f61 > f38 ? f61 : f38;
    f34 = f60 > f34 ? f60 : f34;
    f30 = f59 > f30 ? f59 : f30;
    f14 = f58 > f14 ? f58 : f14;
    f53 = f57 > f53 ? f57 : f53;
    f52 = f56 > f52 ? f56 : f52;
    f51 = f55 > f51 ? f55 : f51;
    f50 = f54 > f50 ? f54 : f50;
    f41 = f53 > f41 ? f53 : f41;
    f37 = f52 > f37 ? f52 : f37;
    f33 = f51 > f33 ? f51 : f33;
    f29 = f50 > f29 ? f50 : f29;
    f45 = f49 < f45 ? f49 : f45;
    f44 = f48 < f44 ? f48 : f44;
    f43 = f47 < f43 ? f47 : f43;
    f42 = f46 < f42 ? f46 : f42;
    f38 = f45 < f38 ? f45 : f38;
    f34 = f44 < f34 ? f44 : f34;
    f30 = f43 < f30 ? f43 : f30;
    f14 = f42 < f14 ? f42 : f14;
    i1 = (f41 > f38 | (f41 > f4 | (f40 > f39 | f38 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i11 = (f37 > f34 | (f37 > f4 | (f36 > f35 | f34 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i15 = (f33 > f30 | (f33 > f4 | (f32 > f31 | f30 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i19 = (f29 > f14 | (f29 > f4 | (f5 > f13 | f14 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    HEAP32[i2 >> 2] = HEAP32[i23 + (i3 + 96) >> 2];
    i1 = i1 + i6 | 0;
    HEAP32[i25 + (i1 + 1 << 2) >> 2] = HEAP32[i23 + (i3 + 100) >> 2];
    i1 = i11 + 1 + i1 | 0;
    HEAP32[i25 + (i1 + 1 << 2) >> 2] = HEAP32[i23 + (i3 + 104) >> 2];
    i1 = i15 + 1 + i1 | 0;
    HEAP32[i25 + (i1 + 1 << 2) >> 2] = HEAP32[i23 + (i3 + 108) >> 2];
    i1 = i19 + 1 + i1 | 0;
   } else {
    HEAP32[i26 >> 2] = i3 + -1;
    HEAPF32[i24 >> 2] = f4;
    if (!(mftCall_iiiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, 1, i26 | 0, i24 | 0) | 0)) {
     i1 = 17;
     break L17;
    }
    f5 = Math_fround(HEAPF32[i24 >> 2]);
    if (f4 != f5) {
     f4 = f5;
     break;
    }
   }
   if (!i1) {
    i1 = 17;
    break L17;
   } else i6 = i1;
  }
  if (!i1) {
   i1 = 17;
   break;
  }
 }
 if ((i1 | 0) == 17) {
  STACKTOP = i27;
  return;
 }
}

function __ZN5physx2Gu21computeMTD_CapsuleBoxERNS_6PxVec3ERfRKNS0_7CapsuleERKNS0_3BoxE(i28, i27, i26, i25) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i29 + 20 | 0;
 i23 = i29 + 16 | 0;
 i1 = i29 + 12 | 0;
 i3 = i29;
 i2 = i25 + 36 | 0;
 f14 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i26, i26 + 12 | 0, i2, i25 + 48 | 0, i25, i1, i3));
 f22 = Math_fround(HEAPF32[i26 + 24 >> 2]);
 if (f14 > Math_fround(f22 * f22)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 if (f14 != Math_fround(0.0)) {
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  f30 = Math_fround(HEAPF32[i26 + 12 >> 2]);
  f5 = Math_fround(HEAPF32[i26 >> 2]);
  f30 = Math_fround(f30 - f5);
  f16 = Math_fround(HEAPF32[i26 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f16 = Math_fround(f16 - f11);
  f12 = Math_fround(HEAPF32[i26 + 20 >> 2]);
  f13 = Math_fround(HEAPF32[i26 + 8 >> 2]);
  f30 = Math_fround(f5 + Math_fround(f6 * f30));
  f16 = Math_fround(f11 + Math_fround(f6 * f16));
  f13 = Math_fround(f13 + Math_fround(f6 * Math_fround(f12 - f13)));
  f12 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i25 >> 2]);
  f11 = Math_fround(f12 * f6);
  i7 = i25 + 4 | 0;
  f5 = Math_fround(HEAPF32[i7 >> 2]);
  f10 = Math_fround(f12 * f5);
  i1 = i25 + 8 | 0;
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f12 = Math_fround(f12 * f4);
  i20 = i3 + 4 | 0;
  f31 = Math_fround(HEAPF32[i20 >> 2]);
  f33 = Math_fround(f31 * Math_fround(HEAPF32[i25 + 12 >> 2]));
  f32 = Math_fround(f31 * Math_fround(HEAPF32[i25 + 16 >> 2]));
  f33 = Math_fround(f11 + f33);
  f32 = Math_fround(f10 + f32);
  f31 = Math_fround(f12 + Math_fround(f31 * Math_fround(HEAPF32[i25 + 20 >> 2])));
  i21 = i3 + 8 | 0;
  f12 = Math_fround(HEAPF32[i21 >> 2]);
  f10 = Math_fround(f12 * Math_fround(HEAPF32[i25 + 24 >> 2]));
  f11 = Math_fround(f12 * Math_fround(HEAPF32[i25 + 28 >> 2]));
  f10 = Math_fround(f33 + f10);
  f11 = Math_fround(f32 + f11);
  f12 = Math_fround(f31 + Math_fround(f12 * Math_fround(HEAPF32[i25 + 32 >> 2])));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i2 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i25 + 40 >> 2]));
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i25 + 44 >> 2]));
  HEAPF32[i3 >> 2] = f10;
  HEAPF32[i20 >> 2] = f11;
  HEAPF32[i21 >> 2] = f12;
  f10 = Math_fround(f30 - f10);
  f11 = Math_fround(f16 - f11);
  f12 = Math_fround(f13 - f12);
  f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)))));
  if (f13 != Math_fround(0.0)) {
   f31 = Math_fround(Math_fround(1.0) / f13);
   f32 = Math_fround(f11 * f31);
   f33 = Math_fround(f12 * f31);
   HEAPF32[i28 >> 2] = Math_fround(f10 * f31);
   HEAPF32[i28 + 4 >> 2] = f32;
   HEAPF32[i28 + 8 >> 2] = f33;
   f33 = Math_fround(f22 - Math_fround(Math_sqrt(Math_fround(f14))));
   i28 = f33 > Math_fround(0.0);
   HEAPF32[i27 >> 2] = i28 ? f33 : Math_fround(0.0);
   i28 = 1;
   STACKTOP = i29;
   return i28 | 0;
  } else i2 = i7;
 } else {
  f6 = Math_fround(HEAPF32[i25 >> 2]);
  i2 = i25 + 4 | 0;
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  i21 = i25 + 8 | 0;
  i1 = i21;
  f4 = Math_fround(HEAPF32[i21 >> 2]);
 }
 L10 : do if (__ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf(f6, f5, f4, i26, f22, i25, i15) | 0) {
  f4 = Math_fround(HEAPF32[i15 >> 2]);
  if (f4 < Math_fround(3402823469999999843913219.0e14)) {
   i7 = HEAP32[i1 >> 2] | 0;
   i8 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i25 >> 2] | 0;
  } else {
   i7 = 0;
   i8 = 0;
   i9 = 0;
   f4 = Math_fround(3402823469999999843913219.0e14);
  }
  i3 = i25 + 12 | 0;
  f32 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i25 + 16 | 0;
  f33 = Math_fround(HEAPF32[i2 >> 2]);
  i1 = i25 + 20 | 0;
  if (__ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf(f32, f33, Math_fround(HEAPF32[i1 >> 2]), i26, f22, i25, i15) | 0) {
   f5 = Math_fround(HEAPF32[i15 >> 2]);
   if (f5 < f4) {
    i7 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i3 >> 2] | 0;
    f4 = f5;
   }
   i1 = i25 + 24 | 0;
   f32 = Math_fround(HEAPF32[i1 >> 2]);
   i2 = i25 + 28 | 0;
   f33 = Math_fround(HEAPF32[i2 >> 2]);
   i3 = i25 + 32 | 0;
   if (__ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf(f32, f33, Math_fround(HEAPF32[i3 >> 2]), i26, f22, i25, i15) | 0) {
    f5 = Math_fround(HEAPF32[i15 >> 2]);
    if (f5 < f4) {
     i9 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i2 >> 2] | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     f4 = f5;
    }
    i17 = i26 + 12 | 0;
    f11 = Math_fround(HEAPF32[i17 >> 2]);
    f11 = Math_fround(f11 - Math_fround(HEAPF32[i26 >> 2]));
    i19 = i26 + 16 | 0;
    f10 = Math_fround(HEAPF32[i19 >> 2]);
    i18 = i26 + 4 | 0;
    f10 = Math_fround(f10 - Math_fround(HEAPF32[i18 >> 2]));
    i21 = i26 + 20 | 0;
    f6 = Math_fround(HEAPF32[i21 >> 2]);
    i20 = i26 + 8 | 0;
    f6 = Math_fround(f6 - Math_fround(HEAPF32[i20 >> 2]));
    f5 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f6 * f6));
    if (f5 > Math_fround(0.0)) {
     f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
     f16 = Math_fround(f6 * f13);
     f14 = Math_fround(f10 * f13);
     f13 = Math_fround(f11 * f13);
    } else {
     f16 = Math_fround(0.0);
     f14 = Math_fround(0.0);
     f13 = Math_fround(0.0);
    }
    i15 = 0;
    while (1) {
     f10 = Math_fround(HEAPF32[i25 + (i15 * 12 | 0) + 8 >> 2]);
     f11 = Math_fround(f14 * f10);
     f33 = Math_fround(HEAPF32[i25 + (i15 * 12 | 0) + 4 >> 2]);
     f11 = Math_fround(f11 - Math_fround(f16 * f33));
     f5 = Math_fround(HEAPF32[i25 + (i15 * 12 | 0) >> 2]);
     f10 = Math_fround(Math_fround(f16 * f5) - Math_fround(f13 * f10));
     f5 = Math_fround(Math_fround(f13 * f33) - Math_fround(f14 * f5));
     if (+Math_fround(Math_abs(Math_fround(f11))) > 1.0e-06) i24 = 15; else if (+Math_fround(Math_abs(Math_fround(f10))) > 1.0e-06) i24 = 15; else if (+Math_fround(Math_abs(Math_fround(f5))) > 1.0e-06) i24 = 15; else {
      i1 = i7;
      i2 = i8;
      i3 = i9;
     }
     if ((i24 | 0) == 15) {
      i24 = 0;
      f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)));
      if (f6 > Math_fround(0.0)) {
       f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
       f12 = Math_fround(f5 * f33);
       f6 = Math_fround(f10 * f33);
       f5 = Math_fround(f11 * f33);
      } else {
       f12 = Math_fround(0.0);
       f6 = Math_fround(0.0);
       f5 = Math_fround(0.0);
      }
      i3 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
      if (!(__ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf(f5, f6, f12, i26, f22, i25, i23) | 0)) {
       i1 = 0;
       break L10;
      }
      f5 = Math_fround(HEAPF32[i23 >> 2]);
      if (f5 < f4) f4 = f5; else {
       i1 = i7;
       i2 = i8;
       i3 = i9;
      }
     }
     i15 = i15 + 1 | 0;
     if (i15 >>> 0 >= 3) {
      f10 = f4;
      break;
     } else {
      i9 = i3;
      i8 = i2;
      i7 = i1;
     }
    }
    f5 = Math_fround(HEAPF32[i26 >> 2]);
    f5 = Math_fround(f5 + Math_fround(HEAPF32[i17 >> 2]));
    f4 = Math_fround(HEAPF32[i18 >> 2]);
    f4 = Math_fround(f4 + Math_fround(HEAPF32[i19 >> 2]));
    f33 = Math_fround(HEAPF32[i20 >> 2]);
    f5 = Math_fround(f5 * Math_fround(.5));
    f4 = Math_fround(f4 * Math_fround(.5));
    f33 = Math_fround(Math_fround(f33 + Math_fround(HEAPF32[i21 >> 2])) * Math_fround(.5));
    f6 = Math_fround(HEAPF32[i25 + 36 >> 2]);
    f32 = Math_fround(HEAPF32[i25 + 40 >> 2]);
    f6 = Math_fround(f5 - f6);
    f32 = Math_fround(f4 - f32);
    f33 = Math_fround(f33 - Math_fround(HEAPF32[i25 + 44 >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = Math_fround(f4 * f6);
    f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f32 = Math_fround(f6 + Math_fround(f5 * f32));
    f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (Math_fround(f32 + Math_fround(f6 * f33)) < Math_fround(0.0)) {
     f31 = Math_fround(-f4);
     f32 = Math_fround(-f5);
     f33 = Math_fround(-f6);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    }
    i26 = f10 > Math_fround(0.0);
    HEAPF32[i27 >> 2] = i26 ? f10 : Math_fround(0.0);
    HEAP32[i28 >> 2] = i3;
    HEAP32[i28 + 4 >> 2] = i2;
    HEAP32[i28 + 8 >> 2] = i1;
    i1 = 1;
   } else i1 = 0;
  } else i1 = 0;
 } else i1 = 0; while (0);
 i28 = i1;
 STACKTOP = i29;
 return i28 | 0;
}

function __ZN13AvatarBuilder10TPoseMatchERKN7mecanim9animation14AvatarConstantERKNSt3__26vectorINS_14NamedTransformENS5_9allocatorIS7_EEEERNS5_12basic_stringIcNS5_11char_traitsIcEENS8_IcEEEESI_(i6, i13, i14, i15) {
 i6 = i6 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 48 | 0;
 i20 = i24 + 32 | 0;
 i22 = i24 + 16 | 0;
 i19 = i24;
 i23 = i24 + 64 | 0;
 i17 = i6 + 20 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 }
 i18 = i17;
 i16 = i1 + i18 + 40 | 0;
 if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + i16 >> 2] | 0)) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 }
 i11 = gb + 64016 | 0;
 i16 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i19;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i16;
 HEAP32[i23 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, i19);
 i3 = i22;
 i16 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i23 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i16;
 i11 = (HEAP32[i17 >> 2] | 0) + i18 + 40 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 i16 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i16 | 0) == 0 ? 0 : i11 + i16 | 0, i23) | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i3 = i6 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i2 = (HEAP32[i17 >> 2] | 0) + i18 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE((i11 | 0) == 0 ? 0 : i11 + i6 | 0, (i12 | 0) == 0 ? 0 : i12 + i3 | 0, (i1 | 0) == 0 ? 0 : i2 + i1 | 0, i16);
 i1 = (HEAP32[i17 >> 2] | 0) + i18 + 40 | 0;
 i1 = HEAP32[i1 + (HEAP32[i1 >> 2] | 0) >> 2] | 0;
 HEAP32[i22 >> 2] = 0;
 i2 = i22 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i22 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 if (!i1) i4 = 0; else {
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i22);
  i12 = ((i1 + -1 | 0) >>> 5) + 1 | 0;
  i4 = __Znwj(i12 << 2) | 0;
  HEAP32[i22 >> 2] = i4;
  HEAP32[i3 >> 2] = i12;
  HEAP32[i2 >> 2] = i1;
  i2 = i1 >>> 5;
  _memset(i4 | 0, 0, i2 << 2 | 0) | 0;
  i1 = i1 - (i2 << 5) | 0;
  i2 = i4 + (i2 << 2) | 0;
  if (i1) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(-1 >>> (32 - i1 | 0));
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i3 = 0;
 i2 = i1 + i18 | 0;
 do {
  i2 = HEAP32[i2 + 72 + (i3 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i1 = i4 + (i2 >>> 5 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i2 & 31);
   i1 = HEAP32[i17 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
  i2 = i1 + i18 | 0;
 } while ((i3 | 0) != 24);
 if (HEAP32[i2 + 48 >> 2] | 0) {
  i3 = HEAP32[i22 >> 2] | 0;
  i2 = 0;
  do {
   i1 = i1 + i18 + 48 | 0;
   i1 = HEAP32[i1 + (HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) {
    i12 = i3 + (i1 >>> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1 << (i1 & 31);
   }
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
  } while ((i2 | 0) != 15);
 }
 if (HEAP32[i1 + i18 + 52 >> 2] | 0) {
  i3 = HEAP32[i22 >> 2] | 0;
  i2 = 0;
  do {
   i1 = i1 + i18 + 52 | 0;
   i1 = HEAP32[i1 + (HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) {
    i12 = i3 + (i1 >>> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1 << (i1 & 31);
   }
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
  } while ((i2 | 0) != 15);
 }
 i3 = i1 + i18 | 0;
 i1 = HEAP32[i3 + 76 >> 2] | 0;
 i12 = i3 + 40 | 0;
 if (i1 >>> 0 < (HEAP32[i12 + (HEAP32[i12 >> 2] | 0) >> 2] | 0) >>> 0) {
  i11 = i16 + 4 | 0;
  i12 = i11;
  i4 = i6 + 28 | 0;
  i6 = i4;
  i7 = i19 + 11 | 0;
  i8 = i19 + 4 | 0;
  i9 = i19 + 11 | 0;
  i10 = i19 + 4 | 0;
  i2 = 1;
  do {
   i30 = i3 + 44 | 0;
   i30 = (HEAP32[i30 >> 2] | 0) + i30 + 4 | 0;
   i30 = i30 + (HEAP32[i30 >> 2] | 0) | 0;
   i27 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   f29 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) >> 2]);
   f28 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 8 >> 2]);
   f26 = Math_fround(HEAPF32[i27 + (i1 * 40 | 0) >> 2]);
   f25 = Math_fround(HEAPF32[i27 + (i1 * 40 | 0) + 4 >> 2]);
   f26 = Math_fround(f29 - f26);
   f25 = Math_fround(f28 - f25);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i27 + (i1 * 40 | 0) + 8 >> 2]));
   f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25)) + Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)))));
   f5 = Math_fround(Math_fround(f5 / Math_fround(HEAPF32[i3 + 360 >> 2])) * Math_fround(1.0e3));
   if (f5 > Math_fround(1.0)) {
    i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + ((HEAP32[(HEAP32[i4 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) * 36 | 0) + 32 >> 2] | 0;
    HEAP32[i20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    HEAPF64[i20 + 8 >> 3] = +f5;
    __Z6FormatPKcz(i19, gb + 913206 | 0, i20);
    i2 = HEAP8[i7 >> 0] | 0;
    i30 = i2 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, i30 ? HEAP32[i19 >> 2] | 0 : i19, i30 ? HEAP32[i8 >> 2] | 0 : i2 & 255) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i2 = 0;
   }
   if (!(HEAP32[(HEAP32[i22 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) {
    i3 = (HEAP32[i17 >> 2] | 0) + i18 + 44 | 0;
    i3 = i3 + (HEAP32[i3 >> 2] | 0) + 4 | 0;
    i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
    f32 = Math_fround(HEAPF32[i3 + (i1 * 40 | 0) + 24 >> 2]);
    i30 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
    f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i1 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f33 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 12 >> 2]);
    f29 = Math_fround(f25 * f33);
    f28 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 24 >> 2]);
    f26 = Math_fround(f32 * f28);
    f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i1 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 16 >> 2]);
    f31 = Math_fround(f34 * f5);
    f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i1 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f35 = Math_fround(HEAPF32[i30 + (i1 * 40 | 0) + 20 >> 2]);
    f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f32 * f35)) - Math_fround(f34 * f28)) - Math_fround(f36 * f5));
    f26 = Math_fround(Math_fround(Math_fround(f26 - Math_fround(f36 * f33)) - Math_fround(f34 * f35)) - Math_fround(f25 * f5));
    f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(f25 * f35)) - Math_fround(f32 * f33)) - Math_fround(f36 * f28));
    f28 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * f33)) - Math_fround(f32 * f5)) - Math_fround(f25 * f28));
    i30 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
    i27 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f28 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f31 = Math_fround(f28 * f28);
    f29 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = Math_fround(f29 * f29);
    f5 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f31 + f25) + Math_fround(Math_fround(f26 * f26) + Math_fround(f5 * f5))))));
    f28 = Math_fround(f26 * f28);
    f29 = Math_fround(f26 * f29);
    f5 = Math_fround(f26 * f5);
    f5 = Math_fround(Math_fround(Math_fround(+Math_asin(+Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(Math_fround(f5 * f5) + Math_fround(0.0))))))) * Math_fround(57.2957802)) * Math_fround(2.0));
    if (f5 > Math_fround(.0500000007)) {
     i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + ((HEAP32[(HEAP32[i4 >> 2] | 0) + i6 + (i1 << 2) >> 2] | 0) * 36 | 0) + 32 >> 2] | 0;
     HEAP32[i21 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
     HEAPF64[i21 + 8 >> 3] = +f5;
     __Z6FormatPKcz(i19, gb + 913238 | 0, i21);
     i2 = HEAP8[i9 >> 0] | 0;
     i30 = i2 << 24 >> 24 < 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, i30 ? HEAP32[i19 >> 2] | 0 : i19, i30 ? HEAP32[i10 >> 2] | 0 : i2 & 255) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
     i2 = 0;
    }
   }
   i1 = i1 + 1 | 0;
   i3 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
   i30 = i3 + 40 | 0;
  } while (i1 >>> 0 < (HEAP32[i30 + (HEAP32[i30 >> 2] | 0) >> 2] | 0) >>> 0);
 } else i2 = 1;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i16, i23);
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 i30 = (i2 & 1) != 0;
 STACKTOP = i24;
 return i30 | 0;
}

function __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 f23 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f23 = Math_fround(Math_fround(f23 + f23) * Math_fround(.5));
 f10 = Math_fround(Math_fround(f8 + f10) * Math_fround(.5));
 f38 = Math_fround(Math_fround(f35 + f38) * Math_fround(.5));
 f13 = Math_fround(Math_fround(f13 + f13) * Math_fround(.5));
 f32 = Math_fround(Math_fround(f18 + f32) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f7 + f7) * Math_fround(.5));
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f18 = Math_fround(Math_fround(f18 + f18) * Math_fround(.5));
 f21 = Math_fround(Math_fround(f35 + f21) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f8 + f16) * Math_fround(.5));
 f19 = Math_fround(Math_fround(f19 + f19) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f11 + f22) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f17 + f17) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f13 * f7) - Math_fround(f32 * f32));
 f8 = Math_fround(Math_fround(f32 * f38) - Math_fround(f10 * f7));
 f35 = Math_fround(Math_fround(f10 * f32) - Math_fround(f13 * f38));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f38 * f35) + Math_fround(Math_fround(f23 * f11) + Math_fround(f10 * f8))));
 f11 = Math_fround(f11 * f29);
 f8 = Math_fround(f8 * f29);
 f35 = Math_fround(f35 * f29);
 f7 = Math_fround(Math_fround(Math_fround(f23 * f7) - Math_fround(f38 * f38)) * f29);
 f32 = Math_fround(Math_fround(Math_fround(f10 * f38) - Math_fround(f23 * f32)) * f29);
 f29 = Math_fround(Math_fround(Math_fround(f23 * f13) - Math_fround(f10 * f10)) * f29);
 f10 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f38 = Math_fround(-f10);
 f36 = Math_fround(-f13);
 f9 = Math_fround(-f23);
 f12 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f37 = Math_fround(-f12);
 f6 = Math_fround(-f14);
 f20 = Math_fround(-f26);
 f24 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f27 = Math_fround(-f24);
 f3 = Math_fround(-f25);
 f28 = Math_fround(-f15);
 f33 = Math_fround(Math_fround(Math_fround(f11 * f38) + Math_fround(f8 * f37)) + Math_fround(f35 * f27));
 f5 = Math_fround(Math_fround(Math_fround(f11 * f36) + Math_fround(f8 * f6)) + Math_fround(f35 * f3));
 f34 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(f8 * f20)) + Math_fround(f35 * f28));
 f30 = Math_fround(Math_fround(Math_fround(f8 * f38) + Math_fround(f7 * f37)) + Math_fround(f32 * f27));
 f4 = Math_fround(Math_fround(Math_fround(f8 * f36) + Math_fround(f7 * f6)) + Math_fround(f32 * f3));
 f31 = Math_fround(Math_fround(Math_fround(f8 * f9) + Math_fround(f7 * f20)) + Math_fround(f32 * f28));
 f27 = Math_fround(Math_fround(Math_fround(f35 * f38) + Math_fround(f32 * f37)) + Math_fround(f29 * f27));
 f3 = Math_fround(Math_fround(Math_fround(f35 * f36) + Math_fround(f32 * f6)) + Math_fround(f29 * f3));
 f28 = Math_fround(Math_fround(Math_fround(f35 * f9) + Math_fround(f32 * f20)) + Math_fround(f29 * f28));
 f18 = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f33 * f10) + Math_fround(f30 * f12)) + Math_fround(f27 * f24)));
 f20 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f10 * f5) + Math_fround(f4 * f12)) + Math_fround(f3 * f24)));
 f24 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f10 * f34) + Math_fround(f12 * f31)) + Math_fround(f28 * f24)));
 f21 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f33 * f13) + Math_fround(f30 * f14)) + Math_fround(f27 * f25)));
 f19 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f5 * f13) + Math_fround(f4 * f14)) + Math_fround(f3 * f25)));
 f25 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f34 * f13) + Math_fround(f31 * f14)) + Math_fround(f28 * f25)));
 f16 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f33 * f23) + Math_fround(f30 * f26)) + Math_fround(f27 * f15)));
 f22 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f5 * f23) + Math_fround(f4 * f26)) + Math_fround(f3 * f15)));
 f15 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f34 * f23) + Math_fround(f31 * f26)) + Math_fround(f28 * f15)));
 f26 = Math_fround(Math_fround(f19 * f15) - Math_fround(f25 * f22));
 f25 = Math_fround(Math_fround(f25 * f16) - Math_fround(f21 * f15));
 f23 = Math_fround(Math_fround(f21 * f22) - Math_fround(f19 * f16));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f18 * f26) + Math_fround(f20 * f25))));
 f26 = Math_fround(f17 * f26);
 f25 = Math_fround(f17 * f25);
 f23 = Math_fround(f17 * f23);
 f24 = Math_fround(f17 * Math_fround(Math_fround(f18 * f15) - Math_fround(f24 * f16)));
 f22 = Math_fround(f17 * Math_fround(Math_fround(f20 * f16) - Math_fround(f18 * f22)));
 f21 = Math_fround(f17 * Math_fround(Math_fround(f18 * f19) - Math_fround(f20 * f21)));
 f20 = Math_fround(Math_fround(f34 * f23) + Math_fround(Math_fround(f33 * f26) + Math_fround(f5 * f25)));
 f19 = Math_fround(Math_fround(f34 * f22) + Math_fround(Math_fround(f33 * f25) + Math_fround(f5 * f24)));
 f18 = Math_fround(Math_fround(f34 * f21) + Math_fround(Math_fround(f33 * f23) + Math_fround(f5 * f22)));
 f17 = Math_fround(Math_fround(f31 * f23) + Math_fround(Math_fround(f30 * f26) + Math_fround(f4 * f25)));
 f16 = Math_fround(Math_fround(f31 * f22) + Math_fround(Math_fround(f30 * f25) + Math_fround(f4 * f24)));
 f15 = Math_fround(Math_fround(f31 * f21) + Math_fround(Math_fround(f30 * f23) + Math_fround(f4 * f22)));
 f14 = Math_fround(Math_fround(f28 * f23) + Math_fround(Math_fround(f27 * f26) + Math_fround(f3 * f25)));
 f13 = Math_fround(Math_fround(f28 * f22) + Math_fround(Math_fround(f27 * f25) + Math_fround(f3 * f24)));
 f12 = Math_fround(Math_fround(f28 * f21) + Math_fround(Math_fround(f27 * f23) + Math_fround(f3 * f22)));
 f11 = Math_fround(f11 + Math_fround(Math_fround(f34 * f18) + Math_fround(Math_fround(f33 * f20) + Math_fround(f5 * f19))));
 f10 = Math_fround(f8 + Math_fround(Math_fround(f31 * f18) + Math_fround(Math_fround(f30 * f20) + Math_fround(f4 * f19))));
 f9 = Math_fround(f35 + Math_fround(Math_fround(f28 * f18) + Math_fround(Math_fround(f27 * f20) + Math_fround(f3 * f19))));
 f8 = Math_fround(f8 + Math_fround(Math_fround(f34 * f15) + Math_fround(Math_fround(f33 * f17) + Math_fround(f5 * f16))));
 f7 = Math_fround(f7 + Math_fround(Math_fround(f31 * f15) + Math_fround(Math_fround(f30 * f17) + Math_fround(f4 * f16))));
 f6 = Math_fround(f32 + Math_fround(Math_fround(f28 * f15) + Math_fround(Math_fround(f27 * f17) + Math_fround(f3 * f16))));
 f5 = Math_fround(f35 + Math_fround(Math_fround(f34 * f12) + Math_fround(Math_fround(f33 * f14) + Math_fround(f5 * f13))));
 f4 = Math_fround(f32 + Math_fround(Math_fround(f31 * f12) + Math_fround(Math_fround(f30 * f14) + Math_fround(f4 * f13))));
 f3 = Math_fround(f29 + Math_fround(Math_fround(f28 * f12) + Math_fround(Math_fround(f27 * f14) + Math_fround(f3 * f13))));
 HEAPF32[i2 >> 2] = f26;
 HEAPF32[i2 + 4 >> 2] = f25;
 HEAPF32[i2 + 8 >> 2] = f23;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f25;
 HEAPF32[i2 + 20 >> 2] = f24;
 HEAPF32[i2 + 24 >> 2] = f22;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 32 >> 2] = f23;
 HEAPF32[i2 + 36 >> 2] = f22;
 HEAPF32[i2 + 40 >> 2] = f21;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 48 >> 2] = f20;
 HEAPF32[i2 + 52 >> 2] = f19;
 HEAPF32[i2 + 56 >> 2] = f18;
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 64 >> 2] = f17;
 HEAPF32[i2 + 68 >> 2] = f16;
 HEAPF32[i2 + 72 >> 2] = f15;
 HEAPF32[i2 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 80 >> 2] = f14;
 HEAPF32[i2 + 84 >> 2] = f13;
 HEAPF32[i2 + 88 >> 2] = f12;
 HEAPF32[i2 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 96 >> 2] = f11;
 HEAPF32[i2 + 100 >> 2] = f10;
 HEAPF32[i2 + 104 >> 2] = f9;
 HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 112 >> 2] = f8;
 HEAPF32[i2 + 116 >> 2] = f7;
 HEAPF32[i2 + 120 >> 2] = f6;
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 128 >> 2] = f5;
 HEAPF32[i2 + 132 >> 2] = f4;
 HEAPF32[i2 + 136 >> 2] = f3;
 HEAPF32[i2 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __Z19pointConvexDistanceRN5physx6PxVec3ES1_RfRKS0_PKNS_2Gu10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformE(i12, i9, i14, i3, i1, i2, i10) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i15 + 528 | 0;
 i20 = i15 + 304 | 0;
 i8 = i15 + 208 | 0;
 i11 = i15 + 48 | 0;
 i13 = i15 + 32 | 0;
 i5 = i15 + 16 | 0;
 i4 = i15;
 i17 = i15 + 320 | 0;
 i16 = i15 + 240 | 0;
 i18 = i15 + 64 | 0;
 i21 = i15 + 544 | 0;
 f26 = Math_fround(HEAPF32[i3 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i5 + 8 >> 2] = i7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 i7 = i2 + 12 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i3;
 HEAP32[i4 + 12 >> 2] = i2;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i17, i1 + 16 | 0, i20, i5, i4);
 f39 = Math_fround(HEAPF32[i10 >> 2]);
 f36 = Math_fround(-f39);
 i2 = i10 + 4 | 0;
 f25 = Math_fround(HEAPF32[i2 >> 2]);
 f31 = Math_fround(-f25);
 i3 = i10 + 8 | 0;
 f33 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(-f33);
 i4 = i10 + 12 | 0;
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i10 + 16 | 0;
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i5 >> 2]));
 i6 = i10 + 20 | 0;
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i6 >> 2]));
 i7 = i10 + 24 | 0;
 f26 = Math_fround(f26 * Math_fround(2.0));
 f32 = Math_fround(f32 * Math_fround(2.0));
 f34 = Math_fround(Math_fround(f34 - Math_fround(HEAPF32[i7 >> 2])) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f37 = Math_fround(Math_fround(Math_fround(f26 * f36) + Math_fround(f32 * f31)) + Math_fround(f34 * f28));
 f22 = Math_fround(Math_fround(f37 * f31) + Math_fround(Math_fround(f35 * f32) + Math_fround(f23 * Math_fround(Math_fround(f26 * f28) - Math_fround(f34 * f36)))));
 f24 = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f23 * Math_fround(Math_fround(f32 * f36) - Math_fround(f26 * f31)))) + Math_fround(f37 * f28));
 f40 = Math_fround(f23 * Math_fround(0.0));
 f38 = Math_fround(f25 * Math_fround(-0.0));
 f29 = Math_fround(f33 * Math_fround(-0.0));
 f30 = Math_fround(Math_fround(f38 + Math_fround(f40 - f39)) - f29);
 f39 = Math_fround(f39 * Math_fround(-0.0));
 f25 = Math_fround(Math_fround(f29 + Math_fround(f40 - f25)) - f39);
 f33 = Math_fround(Math_fround(f39 + Math_fround(f40 - f33)) - f38);
 f29 = Math_fround(Math_fround(Math_fround(f23 - f39) - f38) - f29);
 HEAPF32[i16 + 48 >> 2] = Math_fround(Math_fround(f37 * f36) + Math_fround(Math_fround(f35 * f26) + Math_fround(f23 * Math_fround(Math_fround(f34 * f31) - Math_fround(f32 * f28)))));
 HEAPF32[i16 + 52 >> 2] = f22;
 HEAPF32[i16 + 56 >> 2] = f24;
 HEAPF32[i16 + 60 >> 2] = Math_fround(0.0);
 f24 = Math_fround(f30 + f30);
 f22 = Math_fround(f25 + f25);
 f28 = Math_fround(f33 + f33);
 f32 = Math_fround(f25 * f22);
 f31 = Math_fround(f33 * f28);
 f25 = Math_fround(f25 * f24);
 f34 = Math_fround(f33 * f24);
 f23 = Math_fround(f29 * f24);
 f33 = Math_fround(f33 * f22);
 f22 = Math_fround(f29 * f22);
 f28 = Math_fround(f29 * f28);
 f24 = Math_fround(Math_fround(1.0) - Math_fround(f30 * f24));
 f30 = Math_fround(f25 + f28);
 f29 = Math_fround(f34 - f22);
 f28 = Math_fround(f25 - f28);
 f25 = Math_fround(f24 - f31);
 f26 = Math_fround(f33 + f23);
 f22 = Math_fround(f34 + f22);
 f23 = Math_fround(f33 - f23);
 f24 = Math_fround(f24 - f32);
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f32) - f31);
 HEAPF32[i16 + 4 >> 2] = f30;
 HEAPF32[i16 + 8 >> 2] = f29;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 16 >> 2] = f28;
 HEAPF32[i16 + 20 >> 2] = f25;
 HEAPF32[i16 + 24 >> 2] = f26;
 HEAPF32[i16 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 32 >> 2] = f22;
 HEAPF32[i16 + 36 >> 2] = f23;
 HEAPF32[i16 + 40 >> 2] = f24;
 HEAPF32[i16 + 44 >> 2] = Math_fround(0.0);
 i1 = i18 + 64 | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i18 + 80 >> 2] = 4;
 HEAPF32[i18 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 128 >> 2] = Math_fround(0.0);
 i27 = i18 + 132 | 0;
 HEAP32[i27 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 f24 = Math_fround(HEAPF32[i20 >> 2]);
 f23 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 f26 = Math_fround(f23 + f23);
 f25 = Math_fround(f22 + f22);
 HEAPF32[i18 + 96 >> 2] = Math_fround(f24 + f24);
 HEAPF32[i18 + 100 >> 2] = f26;
 HEAPF32[i18 + 104 >> 2] = f25;
 HEAPF32[i18 + 108 >> 2] = Math_fround(0.0);
 f23 = Math_fround(f23 - f23);
 f22 = Math_fround(f22 - f22);
 HEAPF32[i18 + 112 >> 2] = Math_fround(f24 - f24);
 HEAPF32[i18 + 116 >> 2] = f23;
 HEAPF32[i18 + 120 >> 2] = f22;
 HEAPF32[i18 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 16 >> 2] = Math_fround(0.0);
 i20 = i18 + 20 | 0;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAPF32[i18 + 32 >> 2] = Math_fround(0.0);
 i20 = i18 + 36 | 0;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i19 >> 2] = -1;
 HEAP32[i19 + 4 >> 2] = -1;
 HEAP32[i19 + 8 >> 2] = -1;
 HEAP32[i19 + 12 >> 2] = -1;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 i1 = (__ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i18, i17, i16, i15 + 224 | 0, i8, i11, i13) | 0) == 1;
 if (i1) {
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  STACKTOP = i15;
  return i1 | 0;
 } else {
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  i20 = HEAP32[i11 + 4 >> 2] | 0;
  i27 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  i19 = i12 + 4 | 0;
  HEAP32[i19 >> 2] = i20;
  i20 = i12 + 8 | 0;
  HEAP32[i20 >> 2] = i27;
  i27 = HEAP32[i8 + 4 >> 2] | 0;
  i18 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  i21 = i9 + 4 | 0;
  HEAP32[i21 >> 2] = i27;
  i27 = i9 + 8 | 0;
  HEAP32[i27 >> 2] = i18;
  f38 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
  f30 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(2.0));
  f32 = Math_fround(HEAPF32[i4 >> 2]);
  f31 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
  f34 = Math_fround(HEAPF32[i10 >> 2]);
  f39 = Math_fround(f38 * f34);
  f36 = Math_fround(HEAPF32[i2 >> 2]);
  f39 = Math_fround(f39 + Math_fround(f30 * f36));
  f37 = Math_fround(HEAPF32[i3 >> 2]);
  f39 = Math_fround(f39 + Math_fround(f40 * f37));
  f33 = Math_fround(Math_fround(f36 * f39) + Math_fround(Math_fround(f30 * f31) + Math_fround(f32 * Math_fround(Math_fround(f38 * f37) - Math_fround(f40 * f34)))));
  f35 = Math_fround(Math_fround(Math_fround(f40 * f31) + Math_fround(f32 * Math_fround(Math_fround(f30 * f34) - Math_fround(f38 * f36)))) + Math_fround(f37 * f39));
  HEAPF32[i12 >> 2] = Math_fround(Math_fround(f34 * f39) + Math_fround(Math_fround(f38 * f31) + Math_fround(f32 * Math_fround(Math_fround(f40 * f36) - Math_fround(f30 * f37)))));
  HEAPF32[i19 >> 2] = f33;
  HEAPF32[i20 >> 2] = f35;
  f35 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
  f33 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * Math_fround(2.0));
  f30 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f33 * f36)) + Math_fround(f30 * f37));
  f38 = Math_fround(Math_fround(f34 * f40) + Math_fround(Math_fround(f35 * f31) + Math_fround(f32 * Math_fround(Math_fround(f30 * f36) - Math_fround(f33 * f37)))));
  f39 = Math_fround(Math_fround(f36 * f40) + Math_fround(Math_fround(f33 * f31) + Math_fround(f32 * Math_fround(Math_fround(f35 * f37) - Math_fround(f30 * f34)))));
  f40 = Math_fround(Math_fround(Math_fround(f30 * f31) + Math_fround(f32 * Math_fround(Math_fround(f33 * f34) - Math_fround(f35 * f36)))) + Math_fround(f37 * f40));
  f38 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f38);
  f39 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f39);
  f40 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f40);
  HEAPF32[i9 >> 2] = f38;
  HEAPF32[i21 >> 2] = f39;
  HEAPF32[i27 >> 2] = f40;
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i25, i26, i31, i4, i5, i2, i27, i28, i30, i32, i34) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i31 = i31 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 i32 = i32 | 0;
 i34 = i34 | 0;
 var f1 = f0, i3 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i29 = 0, i33 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 6432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36 + 6416 | 0;
 i22 = i36 + 6352 | 0;
 i23 = i36 + 6288 | 0;
 i24 = i36 + 6224 | 0;
 i35 = i36 + 32 | 0;
 i12 = i36 + 16 | 0;
 i20 = i36;
 i29 = i36 + 48 | 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i35 + 4 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 HEAP32[i35 + 12 >> 2] = 0;
 i3 = i2 & 255;
 HEAP32[i33 >> 2] = i3;
 f21 = Math_fround(HEAPF32[i25 + 32 >> 2]);
 f13 = Math_fround(HEAPF32[i26 + 32 >> 2]);
 f21 = Math_fround((f21 > f13 ? f13 : f21) * Math_fround(.100000001));
 f21 = Math_fround(f21 * f21);
 if (!(i2 << 24 >> 24)) {
  f9 = Math_fround(HEAPF32[i25 >> 2]);
  f10 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f1 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i26 >> 2]);
  f13 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f11 = Math_fround(f9 - f11);
  f13 = Math_fround(f10 - f13);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i26 + 8 >> 2]));
  i19 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)) + Math_fround(f1 * f1)) > Math_fround(0.0);
  f11 = i19 ? f11 : Math_fround(1.0);
  f13 = i19 ? f13 : Math_fround(0.0);
  f1 = i19 ? f1 : Math_fround(0.0);
  HEAPF32[i35 >> 2] = f11;
  HEAPF32[i35 + 4 >> 2] = f13;
  HEAPF32[i35 + 8 >> 2] = f1;
  HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
  f1 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i2 = 0;
  do {
   mftCall_viiiiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 8 >> 2] | 0, i31 | 0, HEAPU8[i4 + i2 >> 0] | 0 | 0, HEAPU8[i5 + i2 >> 0] | 0 | 0, i22 + (i2 << 4) | 0, i23 + (i2 << 4) | 0, i24 + (i2 << 4) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  if (i34) {
   HEAP32[i29 >> 2] = 0;
   i35 = i29 + 5648 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 5652 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 5912 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 6172 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = HEAP32[i33 >> 2] | 0;
   i35 = __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb(i29, i25, i26, i31, 0, i22, i23, i35, i27, i28, i30, i32, i34) | 0;
   STACKTOP = i36;
   return i35 | 0;
  }
  i19 = HEAP32[i33 >> 2] | 0;
  i2 = i24 + (i19 + -1 << 4) | 0;
  L10 : do switch (i19 | 0) {
  case 1:
   {
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    break;
   }
  case 2:
   {
    f1 = Math_fround(HEAPF32[i24 >> 2]);
    f6 = Math_fround(HEAPF32[i24 + 4 >> 2]);
    f7 = Math_fround(HEAPF32[i24 + 8 >> 2]);
    f8 = Math_fround(Math_fround(HEAPF32[i24 + 16 >> 2]) - f1);
    f9 = Math_fround(Math_fround(HEAPF32[i24 + 20 >> 2]) - f6);
    f10 = Math_fround(Math_fround(HEAPF32[i24 + 24 >> 2]) - f7);
    f11 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
    if (!(f11 <= Math_fround(1.1920929e-07))) {
     f37 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f6 * f9)) - Math_fround(f1 * f8)) - Math_fround(f7 * f10)) / f11);
     i19 = f37 > Math_fround(1.0);
     f37 = i19 ? Math_fround(1.0) : f37;
     i19 = f37 > Math_fround(0.0);
     f37 = i19 ? f37 : Math_fround(0.0);
     f11 = Math_fround(f6 + Math_fround(f9 * f37));
     f13 = Math_fround(f7 + Math_fround(f10 * f37));
     HEAPF32[i12 >> 2] = Math_fround(f1 + Math_fround(f8 * f37));
     HEAPF32[i12 + 4 >> 2] = f11;
     HEAPF32[i12 + 8 >> 2] = f13;
     HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
     break L10;
    } else {
     HEAP32[i33 >> 2] = 1;
     HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     break L10;
    }
   }
  case 3:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i12, i24, i22, i23, i33);
    break;
   }
  case 4:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i12, i24, i22, i23, i33);
    break;
   }
  default:
   {
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   }
  } while (0);
  HEAP32[i35 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  f13 = Math_fround(HEAPF32[i35 >> 2]);
  f37 = Math_fround(HEAPF32[i35 + 4 >> 2]);
  f1 = Math_fround(HEAPF32[i35 + 8 >> 2]);
  f1 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f37 * f37)) + Math_fround(f1 * f1));
  if (!(f1 > f21)) {
   HEAP32[i29 >> 2] = 0;
   i35 = i29 + 5648 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 5652 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 5912 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = i29 + 6172 | 0;
   HEAP32[i35 >> 2] = 0;
   i35 = HEAP32[i33 >> 2] | 0;
   i35 = __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb(i29, i25, i26, i31, 0, i22, i23, i35, i27, i28, i30, i32, i34) | 0;
   STACKTOP = i36;
   return i35 | 0;
  }
 }
 i3 = i35 + 4 | 0;
 i4 = i35 + 8 | 0;
 i5 = i24 + 4 | 0;
 i12 = i24 + 8 | 0;
 i14 = i24 + 16 | 0;
 i15 = i24 + 20 | 0;
 i16 = i24 + 24 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 do {
  i38 = HEAP32[i33 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, i35 | 0, i22 + (i38 << 4) | 0, i23 + (i38 << 4) | 0, i24 + (i38 << 4) | 0);
  i38 = HEAP32[i33 >> 2] | 0;
  HEAP32[i33 >> 2] = i38 + 1;
  i2 = i24 + (i38 << 4) | 0;
  L24 : do switch (i38 | 0) {
  case 0:
   {
    HEAP32[i20 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    break;
   }
  case 1:
   {
    f6 = Math_fround(HEAPF32[i24 >> 2]);
    f7 = Math_fround(HEAPF32[i5 >> 2]);
    f8 = Math_fround(HEAPF32[i12 >> 2]);
    f9 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f6);
    f10 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f7);
    f11 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f8);
    f13 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11));
    if (!(f13 <= Math_fround(1.1920929e-07))) {
     f39 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f10)) - Math_fround(f6 * f9)) - Math_fround(f8 * f11)) / f13);
     i38 = f39 > Math_fround(1.0);
     f39 = i38 ? Math_fround(1.0) : f39;
     i38 = f39 > Math_fround(0.0);
     f39 = i38 ? f39 : Math_fround(0.0);
     f13 = Math_fround(f7 + Math_fround(f10 * f39));
     f37 = Math_fround(f8 + Math_fround(f11 * f39));
     HEAPF32[i20 >> 2] = Math_fround(f6 + Math_fround(f9 * f39));
     HEAPF32[i17 >> 2] = f13;
     HEAPF32[i18 >> 2] = f37;
     HEAPF32[i19 >> 2] = Math_fround(0.0);
     break L24;
    } else {
     HEAP32[i33 >> 2] = 1;
     HEAP32[i20 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     break L24;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i20, i24, i22, i23, i33);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i20, i24, i22, i23, i33);
    break;
   }
  default:
   {
    HEAP32[i20 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   }
  } while (0);
  HEAP32[i35 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  f11 = Math_fround(HEAPF32[i35 >> 2]);
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f37 = Math_fround(HEAPF32[i4 >> 2]);
  f39 = f1;
  f1 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)) + Math_fround(f37 * f37));
 } while (f1 > f21 & f39 > f1);
 HEAP32[i29 >> 2] = 0;
 i38 = i29 + 5648 | 0;
 HEAP32[i38 >> 2] = 0;
 i38 = i29 + 5652 | 0;
 HEAP32[i38 >> 2] = 0;
 i38 = i29 + 5912 | 0;
 HEAP32[i38 >> 2] = 0;
 i38 = i29 + 6172 | 0;
 HEAP32[i38 >> 2] = 0;
 i38 = HEAP32[i33 >> 2] | 0;
 i38 = __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb(i29, i25, i26, i31, 0, i22, i23, i38, i27, i28, i30, i32, i34) | 0;
 STACKTOP = i36;
 return i38 | 0;
}

function __Z14FixupCubeEdgesP13CImageSurfaceii(i29, i25, i6) {
 i29 = i29 | 0;
 i25 = i25 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, d33 = 0.0, f34 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i31 + 32 | 0;
 i3 = i31;
 i30 = HEAP32[i29 + 8 >> 2] | 0;
 i8 = HEAP32[i29 >> 2] | 0;
 if ((i25 | 0) == 0 | (i6 | 0) == 0) {
  STACKTOP = i31;
  return;
 }
 L4 : do switch (i25 | 0) {
 case 5:
  {
   if (!((i8 | 0) == 1 & (i30 | 0) > 0)) {
    STACKTOP = i31;
    return;
   }
   break;
  }
 case 6:
  {
   if (!((i8 | 0) == 1 & (i30 | 0) > 0)) {
    STACKTOP = i31;
    return;
   }
   break;
  }
 case 7:
  {
   if (!((i8 | 0) == 1 & (i30 | 0) > 0)) {
    STACKTOP = i31;
    return;
   }
   break;
  }
 default:
  {
   if ((i8 | 0) == 1) {
    if ((i30 | 0) > 0) break L4;
    STACKTOP = i31;
    return;
   };
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   HEAP32[i3 + 24 >> 2] = 0;
   HEAP32[i3 + 28 >> 2] = 0;
   i26 = i8 + -1 | 0;
   i27 = Math_imul(i26, i30) | 0;
   i28 = Math_imul(i26, i8) | 0;
   i2 = Math_imul(i28, i30) | 0;
   i28 = Math_imul(i28 + i26 | 0, i30) | 0;
   i1 = 0;
   do {
    i20 = HEAP32[i29 + (i1 << 4) + 12 >> 2] | 0;
    i21 = i20;
    i22 = HEAP32[gb + 41652 + (i1 << 4) >> 2] | 0;
    i24 = i3 + (i22 << 2) | 0;
    i23 = HEAP32[i24 >> 2] | 0;
    HEAP32[i7 + (i22 * 12 | 0) + (i23 << 2) >> 2] = i20;
    HEAP32[i24 >> 2] = i23 + 1;
    i24 = HEAP32[gb + 41652 + (i1 << 4) + 4 >> 2] | 0;
    i23 = i3 + (i24 << 2) | 0;
    i22 = HEAP32[i23 >> 2] | 0;
    HEAP32[i7 + (i24 * 12 | 0) + (i22 << 2) >> 2] = i21 + (i27 << 2);
    HEAP32[i23 >> 2] = i22 + 1;
    i23 = HEAP32[gb + 41652 + (i1 << 4) + 8 >> 2] | 0;
    i22 = i3 + (i23 << 2) | 0;
    i24 = HEAP32[i22 >> 2] | 0;
    HEAP32[i7 + (i23 * 12 | 0) + (i24 << 2) >> 2] = i21 + (i2 << 2);
    HEAP32[i22 >> 2] = i24 + 1;
    i22 = HEAP32[gb + 41652 + (i1 << 4) + 12 >> 2] | 0;
    i24 = i3 + (i22 << 2) | 0;
    i23 = HEAP32[i24 >> 2] | 0;
    HEAP32[i7 + (i22 * 12 | 0) + (i23 << 2) >> 2] = i21 + (i28 << 2);
    HEAP32[i24 >> 2] = i23 + 1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 6);
   i24 = (i30 | 0) > 0;
   if (i24) {
    i2 = 0;
    do {
     i3 = HEAP32[i7 + (i2 * 12 | 0) >> 2] | 0;
     i4 = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] | 0;
     i5 = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] | 0;
     i1 = 0;
     do {
      i21 = i3 + (i1 << 2) | 0;
      f18 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + Math_fround(0.0));
      i22 = i4 + (i1 << 2) | 0;
      f18 = Math_fround(f18 + Math_fround(HEAPF32[i22 >> 2]));
      i23 = i5 + (i1 << 2) | 0;
      f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i23 >> 2])) * Math_fround(.333333343));
      HEAPF32[i21 >> 2] = f18;
      HEAPF32[i22 >> 2] = f18;
      HEAPF32[i23 >> 2] = f18;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i30 | 0));
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 8);
   }
   i20 = (i8 | 0) / 2 | 0;
   i20 = (i20 | 0) < (i6 | 0) ? i20 : i6;
   i21 = Math_imul(i8, i30) | 0;
   i22 = Math_imul(i21, i26) | 0;
   i23 = 0 - i30 | 0;
   i15 = Math_imul(i8, i23) | 0;
   i16 = (i26 | 0) > 1;
   i17 = (i20 | 0) > 1;
   f18 = Math_fround(i20 | 0);
   i19 = (i25 | 0) == 1;
   i14 = 0;
   do {
    i2 = HEAP32[gb + 41556 + (i14 << 3) >> 2] | 0;
    i4 = HEAP32[gb + 41556 + (i14 << 3) + 4 >> 2] | 0;
    i3 = HEAP8[gb + 397165 + (i2 << 3) + (i4 << 1) + 1 >> 0] | 0;
    i5 = i3 & 255;
    i1 = HEAP32[i29 + (i2 << 4) + 12 >> 2] | 0;
    i2 = HEAP32[i29 + ((HEAPU8[gb + 397165 + (i2 << 3) + (i4 << 1) >> 0] | 0) << 4) + 12 >> 2] | 0;
    switch (i4 | 0) {
    case 0:
     {
      i8 = i21;
      i13 = i30;
      break;
     }
    case 1:
     {
      i1 = i1 + (i27 << 2) | 0;
      i8 = i21;
      i13 = i23;
      break;
     }
    case 2:
     {
      i8 = i30;
      i13 = i21;
      break;
     }
    case 3:
     {
      i1 = i1 + (i22 << 2) | 0;
      i8 = i30;
      i13 = i15;
      break;
     }
    default:
     {
      i8 = 0;
      i13 = 0;
     }
    }
    L28 : do if ((i4 | 0) == (i5 | 0) | (i5 + i4 | 0) == 3) switch (i3 << 24 >> 24) {
    case 0:
     {
      i2 = i2 + (i22 << 2) | 0;
      i6 = i30;
      i7 = i15;
      break L28;
     }
    case 1:
     {
      i2 = i2 + (i28 << 2) | 0;
      i6 = i23;
      i7 = i15;
      break L28;
     }
    case 2:
     {
      i2 = i2 + (i27 << 2) | 0;
      i6 = i21;
      i7 = i23;
      break L28;
     }
    case 3:
     {
      i2 = i2 + (i28 << 2) | 0;
      i6 = i15;
      i7 = i23;
      break L28;
     }
    default:
     {
      i6 = 0;
      i7 = 0;
      break L28;
     }
    } else switch (i3 << 24 >> 24) {
    case 0:
     {
      i6 = i30;
      i7 = i21;
      break L28;
     }
    case 1:
     {
      i2 = i2 + (i27 << 2) | 0;
      i6 = i23;
      i7 = i21;
      break L28;
     }
    case 2:
     {
      i6 = i21;
      i7 = i30;
      break L28;
     }
    case 3:
     {
      i2 = i2 + (i22 << 2) | 0;
      i6 = i15;
      i7 = i30;
      break L28;
     }
    default:
     {
      i6 = 0;
      i7 = 0;
      break L28;
     }
    } while (0);
    if (i16) {
     i5 = 1;
     do {
      i1 = i1 + (i8 << 2) | 0;
      i2 = i2 + (i7 << 2) | 0;
      if (i24) {
       i4 = 0;
       do {
        i32 = i1 + (i4 << 2) | 0;
        f10 = Math_fround(HEAPF32[i32 >> 2]);
        i3 = i2 + (i4 << 2) | 0;
        f9 = Math_fround(HEAPF32[i3 >> 2]);
        f12 = Math_fround(Math_fround(f10 + f9) * Math_fround(.5));
        HEAPF32[i32 >> 2] = f12;
        HEAPF32[i3 >> 2] = f12;
        f10 = Math_fround(f10 - f12);
        f9 = Math_fround(f9 - f12);
        L48 : do if (i17) {
         if (i19) {
          i3 = 1;
          while (1) {
           f12 = Math_fround(Math_fround(i20 - i3 | 0) / f18);
           f11 = Math_fround(f10 * f12);
           i32 = i1 + ((Math_imul(i3, i13) | 0) << 2) + (i4 << 2) | 0;
           HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f11);
           f12 = Math_fround(f9 * f12);
           i32 = i2 + ((Math_imul(i3, i6) | 0) << 2) + (i4 << 2) | 0;
           HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f12);
           i3 = i3 + 1 | 0;
           if ((i20 | 0) <= (i3 | 0)) break L48;
          }
         } else i3 = 1;
         while (1) {
          f11 = Math_fround(Math_fround(i20 - i3 | 0) / f18);
          switch (i25 | 0) {
          case 4:
           {
            d33 = +f11;
            f11 = Math_fround(d33 * (d33 * (3.0 - d33 * 2.0)));
            f10 = Math_fround(Math_fround(HEAPF32[i1 + ((Math_imul(i3, i13) | 0) << 2) + (i4 << 2) >> 2]) - f12);
            f9 = Math_fround(Math_fround(HEAPF32[i2 + ((Math_imul(i3, i6) | 0) << 2) + (i4 << 2) >> 2]) - f12);
            break;
           }
          case 2:
           {
            d33 = +f11;
            f11 = Math_fround(d33 * (d33 * (3.0 - d33 * 2.0)));
            break;
           }
          case 3:
           {
            f10 = Math_fround(Math_fround(HEAPF32[i1 + ((Math_imul(i3, i13) | 0) << 2) + (i4 << 2) >> 2]) - f12);
            f9 = Math_fround(Math_fround(HEAPF32[i2 + ((Math_imul(i3, i6) | 0) << 2) + (i4 << 2) >> 2]) - f12);
            break;
           }
          default:
           f11 = Math_fround(0.0);
          }
          f34 = Math_fround(f10 * f11);
          i32 = i1 + ((Math_imul(i3, i13) | 0) << 2) + (i4 << 2) | 0;
          HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f34);
          f11 = Math_fround(f9 * f11);
          i32 = i2 + ((Math_imul(i3, i6) | 0) << 2) + (i4 << 2) | 0;
          HEAPF32[i32 >> 2] = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f11);
          i3 = i3 + 1 | 0;
          if ((i20 | 0) <= (i3 | 0)) break L48;
         }
        } while (0);
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i30 | 0));
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i26 | 0));
    }
    i14 = i14 + 1 | 0;
   } while ((i14 | 0) != 12);
   STACKTOP = i31;
   return;
  }
 } while (0);
 i3 = HEAP32[i29 + 12 >> 2] | 0;
 i4 = HEAP32[i29 + 28 >> 2] | 0;
 i5 = HEAP32[i29 + 44 >> 2] | 0;
 i6 = HEAP32[i29 + 60 >> 2] | 0;
 i7 = HEAP32[i29 + 76 >> 2] | 0;
 i2 = HEAP32[i29 + 92 >> 2] | 0;
 i1 = 0;
 do {
  i25 = i3 + (i1 << 2) | 0;
  f34 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + Math_fround(0.0));
  i26 = i4 + (i1 << 2) | 0;
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i26 >> 2]));
  i27 = i5 + (i1 << 2) | 0;
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i27 >> 2]));
  i28 = i6 + (i1 << 2) | 0;
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i28 >> 2]));
  i29 = i7 + (i1 << 2) | 0;
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i29 >> 2]));
  i32 = i2 + (i1 << 2) | 0;
  f34 = Math_fround(Math_fround(f34 + Math_fround(HEAPF32[i32 >> 2])) / Math_fround(6.0));
  HEAPF32[i25 >> 2] = f34;
  HEAPF32[i26 >> 2] = f34;
  HEAPF32[i27 >> 2] = f34;
  HEAPF32[i28 >> 2] = f34;
  HEAPF32[i29 >> 2] = f34;
  HEAPF32[i32 >> 2] = f34;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i30 | 0));
 STACKTOP = i31;
 return;
}

function __ZN11b2GearJoint24SolvePositionConstraintsERK12b2SolverData(i38, i1) {
 i38 = i38 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i39 = i38 + 160 | 0;
 i40 = HEAP32[i39 >> 2] | 0;
 i32 = i1 + 24 | 0;
 i35 = HEAP32[i32 >> 2] | 0;
 i36 = HEAP32[i35 + (i40 * 12 | 0) >> 2] | 0;
 i1 = i35 + (i40 * 12 | 0) + 4 | 0;
 i37 = HEAP32[i1 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i35 + (i40 * 12 | 0) + 8 >> 2]);
 i20 = i38 + 164 | 0;
 i24 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i35 + (i24 * 12 | 0) >> 2] | 0;
 i22 = HEAP32[i35 + (i24 * 12 | 0) + 4 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i35 + (i24 * 12 | 0) + 8 >> 2]);
 i24 = i38 + 168 | 0;
 i28 = HEAP32[i24 >> 2] | 0;
 i25 = HEAP32[i35 + (i28 * 12 | 0) >> 2] | 0;
 i26 = HEAP32[i35 + (i28 * 12 | 0) + 4 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i35 + (i28 * 12 | 0) + 8 >> 2]);
 i28 = i38 + 172 | 0;
 i41 = HEAP32[i28 >> 2] | 0;
 i29 = HEAP32[i35 + (i41 * 12 | 0) >> 2] | 0;
 i30 = HEAP32[i35 + (i41 * 12 | 0) + 4 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i35 + (i41 * 12 | 0) + 8 >> 2]);
 f2 = Math_fround(+Math_sin(+f19));
 f3 = Math_fround(+Math_cos(+f19));
 f6 = Math_fround(+Math_sin(+f23));
 f7 = Math_fround(+Math_cos(+f23));
 f4 = Math_fround(+Math_sin(+f27));
 f5 = Math_fround(+Math_cos(+f27));
 f10 = Math_fround(+Math_sin(+f31));
 f11 = Math_fround(+Math_cos(+f31));
 f33 = Math_fround(HEAPF32[i38 + 224 >> 2]);
 f34 = Math_fround(HEAPF32[i38 + 232 >> 2]);
 if ((HEAP32[i38 + 76 >> 2] | 0) == 1) {
  f2 = Math_fround(f33 + f34);
  f13 = Math_fround(f19 - f27);
  f17 = Math_fround(1.0);
  f18 = Math_fround(1.0);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i38 + 140 >> 2]));
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  f42 = Math_fround(HEAPF32[i38 + 124 >> 2]);
  f15 = Math_fround(f5 * f42);
  f9 = Math_fround(HEAPF32[i38 + 128 >> 2]);
  f15 = Math_fround(f15 - Math_fround(f4 * f9));
  f16 = Math_fround(Math_fround(f4 * f42) + Math_fround(f5 * f9));
  f8 = Math_fround(HEAPF32[i38 + 108 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i38 + 192 >> 2]));
  f13 = Math_fround(HEAPF32[i38 + 112 >> 2]);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i38 + 196 >> 2]));
  f18 = Math_fround(Math_fround(f5 * f8) - Math_fround(f4 * f13));
  f17 = Math_fround(Math_fround(f4 * f8) + Math_fround(f5 * f13));
  f43 = Math_fround(HEAPF32[i38 + 92 >> 2]);
  f43 = Math_fround(f43 - Math_fround(HEAPF32[i38 + 176 >> 2]));
  f12 = Math_fround(HEAPF32[i38 + 96 >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i38 + 180 >> 2]));
  f14 = Math_fround(Math_fround(f3 * f43) - Math_fround(f2 * f12));
  f12 = Math_fround(Math_fround(f2 * f43) + Math_fround(f3 * f12));
  f17 = Math_fround(Math_fround(f16 * f18) - Math_fround(f15 * f17));
  f18 = Math_fround(Math_fround(f16 * f14) - Math_fround(f15 * f12));
  f2 = Math_fround(HEAPF32[i38 + 216 >> 2]);
  f2 = Math_fround(Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i38 + 208 >> 2])) + Math_fround(f17 * Math_fround(f17 * f34))) + Math_fround(f18 * Math_fround(f33 * f18)));
  f43 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = Math_fround(f43 - (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f3 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f43 + f14);
  f12 = Math_fround(Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f12);
  f13 = Math_fround(Math_fround(f42 * Math_fround(Math_fround(Math_fround(f5 * f14) + Math_fround(f4 * f12)) - f8)) + Math_fround(f9 * Math_fround(Math_fround(Math_fround(f5 * f12) - Math_fround(f4 * f14)) - f13)));
 }
 f8 = Math_fround(f2 + Math_fround(0.0));
 f12 = Math_fround(HEAPF32[i38 + 152 >> 2]);
 f14 = Math_fround(HEAPF32[i38 + 228 >> 2]);
 if ((HEAP32[i38 + 80 >> 2] | 0) == 1) {
  f2 = Math_fround(f12 * f12);
  f6 = Math_fround(HEAPF32[i38 + 236 >> 2]);
  f2 = Math_fround(f2 * Math_fround(f14 + f6));
  f3 = Math_fround(f23 - f31);
  f7 = f12;
  f9 = f12;
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i38 + 144 >> 2]));
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 } else {
  f46 = Math_fround(HEAPF32[i38 + 132 >> 2]);
  f9 = Math_fround(f11 * f46);
  f44 = Math_fround(HEAPF32[i38 + 136 >> 2]);
  f9 = Math_fround(f9 - Math_fround(f10 * f44));
  f2 = Math_fround(Math_fround(f10 * f46) + Math_fround(f11 * f44));
  f45 = Math_fround(HEAPF32[i38 + 116 >> 2]);
  f45 = Math_fround(f45 - Math_fround(HEAPF32[i38 + 200 >> 2]));
  f3 = Math_fround(HEAPF32[i38 + 120 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i38 + 204 >> 2]));
  f47 = Math_fround(Math_fround(f11 * f45) - Math_fround(f10 * f3));
  f48 = Math_fround(Math_fround(f10 * f45) + Math_fround(f11 * f3));
  f4 = Math_fround(HEAPF32[i38 + 100 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i38 + 184 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + 104 >> 2]);
  f42 = Math_fround(f42 - Math_fround(HEAPF32[i38 + 188 >> 2]));
  f43 = Math_fround(Math_fround(f7 * f4) - Math_fround(f6 * f42));
  f42 = Math_fround(Math_fround(f6 * f4) + Math_fround(f7 * f42));
  f4 = Math_fround(f9 * f12);
  f5 = Math_fround(f2 * f12);
  f7 = Math_fround(f12 * Math_fround(Math_fround(f2 * f47) - Math_fround(f9 * f48)));
  f9 = Math_fround(f12 * Math_fround(Math_fround(f2 * f43) - Math_fround(f9 * f42)));
  f6 = Math_fround(f12 * f12);
  f2 = Math_fround(HEAPF32[i38 + 220 >> 2]);
  f2 = Math_fround(f6 * Math_fround(f2 + Math_fround(HEAPF32[i38 + 212 >> 2])));
  f6 = Math_fround(HEAPF32[i38 + 236 >> 2]);
  f2 = Math_fround(Math_fround(f2 + Math_fround(f7 * Math_fround(f7 * f6))) + Math_fround(f9 * Math_fround(f14 * f9)));
  f48 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f48 = Math_fround(f48 - (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f47 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = Math_fround(f48 + f43);
  f42 = Math_fround(Math_fround(f47 - (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f42);
  f3 = Math_fround(Math_fround(f46 * Math_fround(Math_fround(Math_fround(f11 * f43) + Math_fround(f10 * f42)) - f45)) + Math_fround(f44 * Math_fround(Math_fround(Math_fround(f11 * f42) - Math_fround(f10 * f43)) - f3)));
 }
 f2 = Math_fround(f8 + f2);
 if (f2 > Math_fround(0.0)) {
  f48 = Math_fround(f13 + Math_fround(f3 * f12));
  f2 = Math_fround(Math_fround(-Math_fround(f48 - Math_fround(HEAPF32[i38 + 148 >> 2]))) / f2);
 } else f2 = Math_fround(0.0);
 f13 = Math_fround(f2 * Math_fround(HEAPF32[i38 + 208 >> 2]));
 f12 = Math_fround(f15 * f13);
 f13 = Math_fround(f16 * f13);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f12);
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f13);
 f18 = Math_fround(f19 + Math_fround(f18 * Math_fround(f2 * f33)));
 f33 = Math_fround(f2 * Math_fround(HEAPF32[i38 + 212 >> 2]));
 f19 = Math_fround(f4 * f33);
 f33 = Math_fround(f5 * f33);
 f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
 f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
 f42 = Math_fround(f23 + Math_fround(f9 * Math_fround(f2 * f14)));
 f44 = Math_fround(f2 * Math_fround(HEAPF32[i38 + 216 >> 2]));
 f43 = Math_fround(f15 * f44);
 f44 = Math_fround(f16 * f44);
 f43 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f43);
 f44 = Math_fround((HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f44);
 f45 = Math_fround(f27 - Math_fround(f17 * Math_fround(f2 * f34)));
 f47 = Math_fround(f2 * Math_fround(HEAPF32[i38 + 220 >> 2]));
 f46 = Math_fround(f4 * f47);
 f47 = Math_fround(f5 * f47);
 f46 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f46);
 f47 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f47);
 f48 = Math_fround(f31 - Math_fround(f7 * Math_fround(f2 * f6)));
 HEAPF32[i35 + (i40 * 12 | 0) >> 2] = f12;
 HEAPF32[i1 >> 2] = f13;
 i40 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i40 + ((HEAP32[i39 >> 2] | 0) * 12 | 0) + 8 >> 2] = f18;
 i41 = HEAP32[i20 >> 2] | 0;
 HEAPF32[i40 + (i41 * 12 | 0) >> 2] = f19;
 HEAPF32[i40 + (i41 * 12 | 0) + 4 >> 2] = f33;
 i41 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i41 + ((HEAP32[i20 >> 2] | 0) * 12 | 0) + 8 >> 2] = f42;
 i40 = HEAP32[i24 >> 2] | 0;
 HEAPF32[i41 + (i40 * 12 | 0) >> 2] = f43;
 HEAPF32[i41 + (i40 * 12 | 0) + 4 >> 2] = f44;
 i40 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i40 + ((HEAP32[i24 >> 2] | 0) * 12 | 0) + 8 >> 2] = f45;
 i41 = HEAP32[i28 >> 2] | 0;
 HEAPF32[i40 + (i41 * 12 | 0) >> 2] = f46;
 HEAPF32[i40 + (i41 * 12 | 0) + 4 >> 2] = f47;
 HEAPF32[(HEAP32[i32 >> 2] | 0) + ((HEAP32[i28 >> 2] | 0) * 12 | 0) + 8 >> 2] = f48;
 return 1;
}

function __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj(i18, i16, i17) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 HEAP32[gb + 1457356 >> 2] = (HEAP32[gb + 1457356 >> 2] | 0) + 1;
 i15 = i18 + 16 | 0;
 i13 = i15;
 i12 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = _bitshift64Lshr(i12 | 0, i13 | 0, 21) | 0;
 getTempRet0() | 0;
 i9 = i9 & 524287;
 i10 = _bitshift64Lshr(i12 | 0, i13 | 0, 2) | 0;
 getTempRet0() | 0;
 i10 = i10 & 524287;
 i3 = HEAP32[i17 + (i9 << 2) >> 2] | 0;
 i11 = HEAP32[i16 + 20 >> 2] | 0;
 i5 = HEAP32[i11 + (i3 * 24 | 0) >> 2] | 0;
 i6 = HEAP32[i11 + (i3 * 24 | 0) + 4 >> 2] | 0;
 i7 = HEAP32[i11 + (i3 * 24 | 0) + 8 >> 2] | 0;
 i1 = HEAP32[i11 + (i3 * 24 | 0) + 12 >> 2] | 0;
 i2 = HEAP32[i11 + (i3 * 24 | 0) + 16 >> 2] | 0;
 i3 = HEAP32[i11 + (i3 * 24 | 0) + 20 >> 2] | 0;
 if (i10 >>> 0 > 1) {
  i8 = 1;
  do {
   i25 = HEAP32[i17 + (i8 + i9 << 2) >> 2] | 0;
   f22 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) + 8 >> 2]);
   f20 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f20 < f22 ? f20 : f22, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f24 < f4 ? f24 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f21 < f23 ? f21 : f23, HEAP32[tempDoublePtr >> 2] | 0);
   f23 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) + 12 >> 2]);
   f21 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) + 16 >> 2]);
   f4 = Math_fround(HEAPF32[i11 + (i25 * 24 | 0) + 20 >> 2]);
   f24 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f22 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f20 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f24 > f23 ? f24 : f23, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f22 > f21 ? f22 : f21, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f20 > f4 ? f20 : f4, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i10 | 0));
 }
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i7;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = i3;
 i8 = i15;
 HEAP32[i8 >> 2] = i12 | 1;
 HEAP32[i8 + 4 >> 2] = i13;
 __ZN5physx2Sq12AABBTreeNode9subdivideERKNS_9PxBounds3EPNS0_15AABBTreeBuilderEPj(i18, i14, i16, i17) | 0;
 f31 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = f31 > Math_fround(-9999999940000000065998519.0e8);
 f31 = i8 ? f31 : Math_fround(-9999999940000000065998519.0e8);
 i8 = f29 > Math_fround(-9999999940000000065998519.0e8);
 f29 = i8 ? f29 : Math_fround(-9999999940000000065998519.0e8);
 i8 = f27 > Math_fround(-9999999940000000065998519.0e8);
 f27 = i8 ? f27 : Math_fround(-9999999940000000065998519.0e8);
 f21 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = f21 < Math_fround(9999999940000000065998519.0e8);
 f21 = i8 ? f21 : Math_fround(9999999940000000065998519.0e8);
 i8 = f28 < Math_fround(9999999940000000065998519.0e8);
 f28 = i8 ? f28 : Math_fround(9999999940000000065998519.0e8);
 i8 = f30 < Math_fround(9999999940000000065998519.0e8);
 f30 = i8 ? f30 : Math_fround(9999999940000000065998519.0e8);
 f23 = Math_fround(Math_fround(f21 + f31) * Math_fround(.5));
 f24 = Math_fround(Math_fround(f28 + f29) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f30 + f27) * Math_fround(.5));
 f31 = Math_fround(Math_fround(f21 - f31) * Math_fround(.5));
 f29 = Math_fround(Math_fround(f28 - f29) * Math_fround(.5));
 f27 = Math_fround(Math_fround(f30 - f27) * Math_fround(.5));
 f30 = Math_fround(f23 * Math_fround(.0000999999974));
 f28 = Math_fround(f24 * Math_fround(.0000999999974));
 f21 = Math_fround(f4 * Math_fround(.0000999999974));
 f26 = Math_fround(-f30);
 f20 = Math_fround(-f28);
 f22 = Math_fround(-f21);
 f26 = Math_fround(f31 + Math_fround((f30 > f26 ? f30 : f26) + Math_fround(.0000999999974)));
 f20 = Math_fround(f29 + Math_fround((f28 > f20 ? f28 : f20) + Math_fround(.0000999999974)));
 f22 = Math_fround(f27 + Math_fround((f21 > f22 ? f21 : f22) + Math_fround(.0000999999974)));
 f21 = f20 > f22 ? f20 : f22;
 f21 = Math_fround((f26 > f21 ? f26 : f21) * Math_fround(.00392158423));
 f27 = Math_fround(Math_fround(f21 + Math_fround(f21 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
 i8 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 f21 = Math_fround(Math_fround(1.0) / f21);
 i1 = ~~Math_fround(Math_fround(f21 * f26) + Math_fround(1.0));
 i2 = ~~Math_fround(Math_fround(f21 * f20) + Math_fround(1.0));
 i14 = ~~Math_fround(Math_fround(f21 * f22) + Math_fround(1.0));
 i3 = f23 == Math_fround(0.0);
 i5 = f24 == Math_fround(0.0);
 i25 = f4 == Math_fround(0.0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = i14 | (i25 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -256);
 HEAP32[i18 >> 2] = i1 | (i3 ? 16777216 : i6 & -256);
 HEAP32[i18 + 4 >> 2] = i2 | (i5 ? 16777216 : i7 & -256);
 HEAP32[i18 + 8 >> 2] = i14;
 i2 = i15;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i14 = _bitshift64Shl(i8 >>> 8 | 0, 0, 40) | 0;
 i25 = getTempRet0() | 0 | i2 & 255;
 i3 = i15;
 HEAP32[i3 >> 2] = i14 | i1;
 HEAP32[i3 + 4 >> 2] = i25;
 i3 = HEAP32[i16 + 12 >> 2] | 0;
 if (!((i1 & 1 | 0) == 0 & 0 == 0)) {
  i25 = i15;
  i17 = i25;
  i17 = HEAP32[i17 >> 2] | 0;
  i25 = i25 + 4 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i13 = _bitshift64Lshr(i17 | 0, i25 | 0, 2) | 0;
  getTempRet0() | 0;
  i13 = i13 & 524287;
  i16 = i16 + 16 | 0;
  i14 = HEAP32[i16 >> 2] | 0;
  i14 = i13 + i14 | 0;
  HEAP32[i16 >> 2] = i14;
  i16 = i3;
  i16 = i18 - i16 | 0;
  i16 = (i16 | 0) / 24 | 0;
  i17 = i17 & -2097149;
  i16 = _bitshift64Shl(i16 | 0, 0, 2) | 0;
  i18 = getTempRet0() | 0;
  i16 = i17 | i16;
  i18 = i25 | i18;
  i25 = i15;
  i17 = i25;
  HEAP32[i17 >> 2] = i16;
  i25 = i25 + 4 | 0;
  HEAP32[i25 >> 2] = i18;
  STACKTOP = i19;
  return;
 }
 i1 = _bitshift64Lshr(i1 | 0, i2 | 0, 21) | 0;
 getTempRet0() | 0;
 i1 = i1 & 524287;
 i2 = i1 | 0 ? i3 + ((i1 + 1 | 0) * 24 | 0) | 0 : i3;
 if (i1 | 0) {
  __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj(i3 + (i1 * 24 | 0) | 0, i16, i17);
  i25 = i3 + (i1 * 24 | 0) + 16 | 0;
  i12 = i25;
  i14 = HEAP32[i12 + 4 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] & -2097149;
  i13 = _bitshift64Shl((i18 - i3 | 0) / 24 | 0 | 0, 0, 2) | 0;
  i14 = i14 | (getTempRet0() | 0);
  HEAP32[i25 >> 2] = i12 | i13;
  HEAP32[i25 + 4 >> 2] = i14;
 }
 if ((i2 | 0) == (i3 | 0)) {
  i25 = i15;
  i17 = i25;
  i17 = HEAP32[i17 >> 2] | 0;
  i25 = i25 + 4 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i13 = _bitshift64Lshr(i17 | 0, i25 | 0, 2) | 0;
  getTempRet0() | 0;
  i13 = i13 & 524287;
  i16 = i16 + 16 | 0;
  i14 = HEAP32[i16 >> 2] | 0;
  i14 = i13 + i14 | 0;
  HEAP32[i16 >> 2] = i14;
  i16 = i3;
  i16 = i18 - i16 | 0;
  i16 = (i16 | 0) / 24 | 0;
  i17 = i17 & -2097149;
  i16 = _bitshift64Shl(i16 | 0, 0, 2) | 0;
  i18 = getTempRet0() | 0;
  i16 = i17 | i16;
  i18 = i25 | i18;
  i25 = i15;
  i17 = i25;
  HEAP32[i17 >> 2] = i16;
  i25 = i25 + 4 | 0;
  HEAP32[i25 >> 2] = i18;
  STACKTOP = i19;
  return;
 }
 __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj(i2, i16, i17);
 i25 = i2 + 16 | 0;
 i14 = i25;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i14 = HEAP32[i14 >> 2] & -2097149;
 i13 = _bitshift64Shl((i18 - i3 | 0) / 24 | 0 | 0, 0, 2) | 0;
 i17 = i17 | (getTempRet0() | 0);
 HEAP32[i25 >> 2] = i14 | i13;
 HEAP32[i25 + 4 >> 2] = i17;
 i25 = i15;
 i17 = i25;
 i17 = HEAP32[i17 >> 2] | 0;
 i25 = i25 + 4 | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 i13 = _bitshift64Lshr(i17 | 0, i25 | 0, 2) | 0;
 getTempRet0() | 0;
 i13 = i13 & 524287;
 i16 = i16 + 16 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 i14 = i13 + i14 | 0;
 HEAP32[i16 >> 2] = i14;
 i16 = i3;
 i16 = i18 - i16 | 0;
 i16 = (i16 | 0) / 24 | 0;
 i17 = i17 & -2097149;
 i16 = _bitshift64Shl(i16 | 0, 0, 2) | 0;
 i18 = getTempRet0() | 0;
 i16 = i17 | i16;
 i18 = i25 | i18;
 i25 = i15;
 i17 = i25;
 HEAP32[i17 >> 2] = i16;
 i25 = i25 + 4 | 0;
 HEAP32[i25 >> 2] = i18;
 STACKTOP = i19;
 return;
}

function __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i10, i1, i2, i23, i24) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, f40 = f0, i41 = 0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, f61 = f0, i62 = 0, f63 = f0, i64 = 0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 32 | 0;
 i26 = i29 + 16 | 0;
 i27 = i29;
 if (i2 >>> 0 >= i23 >>> 0) {
  STACKTOP = i29;
  return;
 }
 i28 = i1 + 520 | 0;
 i11 = i25 + 4 | 0;
 i12 = i25 + 8 | 0;
 i13 = i25 + 12 | 0;
 i14 = i1 + 500 | 0;
 i15 = i26 + 4 | 0;
 i16 = i26 + 8 | 0;
 i17 = i26 + 12 | 0;
 i18 = i1 + 120 | 0;
 i19 = i1 + 140 | 0;
 i20 = i1 + 160 | 0;
 i21 = i1 + 60 | 0;
 i22 = i1 + 80 | 0;
 i3 = i1 + 100 | 0;
 i4 = i27 + 4 | 0;
 i5 = i27 + 8 | 0;
 i6 = i27 + 12 | 0;
 i7 = i24 + 4 | 0;
 i8 = i24 + 8 | 0;
 i9 = i24 + 12 | 0;
 i1 = i2;
 do {
  i2 = (HEAP32[i28 >> 2] | 0) + (i1 << 2) | 0;
  f38 = Math_fround(HEAPF32[i2 >> 2]);
  f44 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f44 = Math_fround(f44 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f40 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i25 >> 2] = Math_fround(f38 * Math_fround(.00999999977));
  HEAPF32[i11 >> 2] = f44;
  HEAPF32[i12 >> 2] = f42;
  HEAPF32[i13 >> 2] = f40;
  i2 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  i41 = (HEAP32[i2 >> 2] | 0) + 322376503 | 0;
  i48 = (HEAP32[i2 + 4 >> 2] | 0) + 322376503 | 0;
  i62 = (HEAP32[i2 + 8 >> 2] | 0) + 322376503 | 0;
  i2 = (HEAP32[i2 + 12 >> 2] | 0) + 322376503 | 0;
  i43 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
  i60 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i64 = (Math_imul(i62, 1790253981) | 0) + 1900727103 | 0;
  i39 = (Math_imul(i2, 1790253981) | 0) + 1900727103 | 0;
  i41 = i41 << 11 ^ i41;
  i48 = i48 << 11 ^ i48;
  i62 = i62 << 11 ^ i62;
  i2 = i2 << 11 ^ i2;
  f40 = Math_fround(Math_fround((i60 ^ i48 ^ i48 >>> 8) & 8388607 ^ i60 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i64 ^ i62 ^ i62 >>> 8) & 8388607 ^ i64 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f44 = Math_fround(Math_fround((i39 ^ i2 ^ i2 >>> 8) & 8388607 ^ i39 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i26 >> 2] = Math_fround(Math_fround((i43 ^ i41 ^ i41 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i15 >> 2] = f40;
  HEAPF32[i16 >> 2] = f42;
  HEAPF32[i17 >> 2] = f44;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i27, i10, i25, i26);
  i43 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i43 >> 2]);
  f42 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0;
  f37 = Math_fround(HEAPF32[i43 >> 2]);
  f36 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i20 >> 2] | 0) + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i43 >> 2]);
  f32 = Math_fround(HEAPF32[i43 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i43 + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i43 + 12 >> 2]);
  i43 = (HEAP32[i21 >> 2] | 0) + (i1 << 2) | 0;
  f45 = Math_fround(HEAPF32[i43 >> 2]);
  i41 = i43 + 4 | 0;
  f58 = Math_fround(HEAPF32[i41 >> 2]);
  i39 = i43 + 8 | 0;
  f57 = Math_fround(HEAPF32[i39 >> 2]);
  i2 = i43 + 12 | 0;
  f56 = Math_fround(HEAPF32[i2 >> 2]);
  i64 = (HEAP32[i22 >> 2] | 0) + (i1 << 2) | 0;
  f55 = Math_fround(HEAPF32[i64 >> 2]);
  f54 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f53 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i64 + 12 >> 2]);
  i64 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  f71 = Math_fround(HEAPF32[i64 >> 2]);
  f72 = Math_fround(HEAPF32[i64 + 4 >> 2]);
  f74 = Math_fround(HEAPF32[i64 + 8 >> 2]);
  f45 = Math_fround(f44 + f45);
  f58 = Math_fround(f42 + f58);
  f57 = Math_fround(f40 + f57);
  f56 = Math_fround(f38 + f56);
  f55 = Math_fround(f37 + f55);
  f54 = Math_fround(f36 + f54);
  f53 = Math_fround(f35 + f53);
  f52 = Math_fround(f34 + f52);
  f71 = Math_fround(f33 + f71);
  f72 = Math_fround(f32 + f72);
  f74 = Math_fround(f31 + f74);
  f75 = Math_fround(f30 + Math_fround(HEAPF32[i64 + 12 >> 2]));
  f67 = Math_fround(Math_fround(Math_fround(f45 * f45) + Math_fround(f55 * f55)) + Math_fround(f71 * f71));
  f70 = Math_fround(Math_fround(Math_fround(f58 * f58) + Math_fround(f54 * f54)) + Math_fround(f72 * f72));
  f73 = Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f53 * f53)) + Math_fround(f74 * f74));
  f76 = Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f52 * f52)) + Math_fround(f75 * f75));
  f51 = Math_fround(Math_sqrt(Math_fround(f67)));
  f63 = Math_fround(Math_fround(1.0) / f51);
  f50 = Math_fround(Math_sqrt(Math_fround(f70)));
  f61 = Math_fround(Math_fround(1.0) / f50);
  f49 = Math_fround(Math_sqrt(Math_fround(f73)));
  f59 = Math_fround(Math_fround(1.0) / f49);
  f46 = Math_fround(Math_sqrt(Math_fround(f76)));
  f47 = Math_fround(Math_fround(1.0) / f46);
  f45 = Math_fround(f45 * f63);
  f58 = Math_fround(f58 * f61);
  f57 = Math_fround(f57 * f59);
  f56 = Math_fround(f56 * f47);
  f55 = Math_fround(f55 * f63);
  f54 = Math_fround(f54 * f61);
  f53 = Math_fround(f53 * f59);
  f52 = Math_fround(f52 * f47);
  f63 = Math_fround(f71 * f63);
  f61 = Math_fround(f72 * f61);
  f59 = Math_fround(f74 * f59);
  f47 = Math_fround(f75 * f47);
  i64 = f67 > Math_fround(9.99999974e-06);
  i62 = f70 > Math_fround(9.99999974e-06);
  i60 = f73 > Math_fround(9.99999974e-06);
  i48 = f76 > Math_fround(9.99999974e-06);
  f76 = Math_fround((f51 > Math_fround(0.0) & 1) - (f51 < Math_fround(0.0) & 1) | 0);
  f73 = Math_fround((f50 > Math_fround(0.0) & 1) - (f50 < Math_fround(0.0) & 1) | 0);
  f70 = Math_fround((f49 > Math_fround(0.0) & 1) - (f49 < Math_fround(0.0) & 1) | 0);
  f67 = Math_fround((f46 > Math_fround(0.0) & 1) - (f46 < Math_fround(0.0) & 1) | 0);
  f51 = Math_fround(Math_abs(Math_fround(f51)));
  f50 = Math_fround(Math_abs(Math_fround(f50)));
  f49 = Math_fround(Math_abs(Math_fround(f49)));
  f46 = Math_fround(Math_abs(Math_fround(f46)));
  f75 = Math_fround(HEAPF32[i27 >> 2]);
  f74 = Math_fround(f75 - f51);
  f72 = Math_fround(HEAPF32[i4 >> 2]);
  f71 = Math_fround(f72 - f50);
  f69 = Math_fround(HEAPF32[i5 >> 2]);
  f68 = Math_fround(f69 - f49);
  f66 = Math_fround(HEAPF32[i6 >> 2]);
  f65 = Math_fround(f66 - f46);
  f74 = Math_fround(f74 * Math_fround(HEAPF32[i24 >> 2]));
  f71 = Math_fround(f71 * Math_fround(HEAPF32[i7 >> 2]));
  f68 = Math_fround(f68 * Math_fround(HEAPF32[i8 >> 2]));
  f74 = Math_fround(f51 + f74);
  f71 = Math_fround(f50 + f71);
  f68 = Math_fround(f49 + f68);
  f65 = Math_fround(f46 + Math_fround(f65 * Math_fround(HEAPF32[i9 >> 2])));
  f51 = Math_fround(f76 * (f51 > f75 ? f74 : f51));
  f50 = Math_fround(f73 * (f50 > f72 ? f71 : f50));
  f49 = Math_fround(f70 * (f49 > f69 ? f68 : f49));
  f46 = Math_fround(f67 * (f46 > f66 ? f65 : f46));
  f45 = Math_fround((i64 ? f45 : Math_fround(0.0)) * f51);
  f58 = Math_fround((i62 ? f58 : Math_fround(0.0)) * f50);
  f57 = Math_fround((i60 ? f57 : Math_fround(0.0)) * f49);
  f56 = Math_fround((i48 ? f56 : Math_fround(0.0)) * f46);
  f55 = Math_fround((i64 ? f55 : Math_fround(0.0)) * f51);
  f54 = Math_fround((i62 ? f54 : Math_fround(0.0)) * f50);
  f53 = Math_fround((i60 ? f53 : Math_fround(0.0)) * f49);
  f52 = Math_fround((i48 ? f52 : Math_fround(0.0)) * f46);
  f51 = Math_fround((i64 ? f63 : Math_fround(0.0)) * f51);
  f50 = Math_fround((i62 ? f61 : Math_fround(0.0)) * f50);
  f49 = Math_fround((i60 ? f59 : Math_fround(0.0)) * f49);
  f42 = Math_fround(f58 - f42);
  f40 = Math_fround(f57 - f40);
  f38 = Math_fround(f56 - f38);
  f37 = Math_fround(f55 - f37);
  f36 = Math_fround(f54 - f36);
  f35 = Math_fround(f53 - f35);
  f34 = Math_fround(f52 - f34);
  f33 = Math_fround(f51 - f33);
  f32 = Math_fround(f50 - f32);
  f31 = Math_fround(f49 - f31);
  f30 = Math_fround(Math_fround((i48 ? f47 : Math_fround(0.0)) * f46) - f30);
  HEAPF32[i43 >> 2] = Math_fround(f45 - f44);
  HEAPF32[i41 >> 2] = f42;
  HEAPF32[i39 >> 2] = f40;
  HEAPF32[i2 >> 2] = f38;
  i2 = (HEAP32[i22 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f37;
  HEAPF32[i2 + 4 >> 2] = f36;
  HEAPF32[i2 + 8 >> 2] = f35;
  HEAPF32[i2 + 12 >> 2] = f34;
  i2 = (HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0;
  HEAPF32[i2 >> 2] = f33;
  HEAPF32[i2 + 4 >> 2] = f32;
  HEAPF32[i2 + 8 >> 2] = f31;
  HEAPF32[i2 + 12 >> 2] = f30;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i23 >>> 0);
 STACKTOP = i29;
 return;
}

function _cf2_glyphpath_pushPrevElem(i19, i18, i20, i12, i14, i17) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i16 = i19 + 11748 | 0;
 i15 = (HEAP32[i16 >> 2] | 0) == 2;
 i9 = i15 ? i19 + 11752 | 0 : i19 + 11768 | 0;
 i15 = i15 ? i19 + 11760 | 0 : i19 + 11776 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i11 = i15 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i13 = i20 + 4 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
  i6 = 0;
  i9 = 0;
  i7 = 0;
 } else {
  i5 = HEAP32[i9 >> 2] | 0;
  i10 = i9 + 4 | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i7 = i12 + 16 - i3 >> 5;
  i8 = i14 + 16 - i4 >> 5;
  i1 = _UNITY_FT_MulFix(i1 + 16 - i5 >> 5, i8) | 0;
  i1 = i1 - (_UNITY_FT_MulFix(i2 + 16 - i6 >> 5, i7) | 0) | 0;
  if (!i1) {
   i6 = 0;
   i9 = 0;
   i7 = 0;
  } else {
   i2 = _UNITY_FT_MulFix(16 - i5 + i3 >> 5, i8) | 0;
   i1 = _UNITY_FT_DivFix(i2 - (_UNITY_FT_MulFix(16 - i6 + i4 >> 5, i7) | 0) | 0, i1) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i2 = (_UNITY_FT_MulFix(i1, (HEAP32[i15 >> 2] | 0) - i2 | 0) | 0) + i2 | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i3 = (_UNITY_FT_MulFix(i1, (HEAP32[i11 >> 2] | 0) - i3 | 0) | 0) + i3 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i15 >> 2] | 0;
   if ((i1 | 0) == (i8 | 0)) {
    i9 = i2 - i1 | 0;
    i2 = (((i9 | 0) < 0 ? 0 - i9 | 0 : i9) | 0) < (HEAP32[i19 + 11700 >> 2] | 0) ? i1 : i2;
   }
   i1 = HEAP32[i10 >> 2] | 0;
   i7 = HEAP32[i11 >> 2] | 0;
   if ((i1 | 0) == (i7 | 0)) {
    i11 = i3 - i1 | 0;
    i1 = (((i11 | 0) < 0 ? 0 - i11 | 0 : i11) | 0) < (HEAP32[i19 + 11700 >> 2] | 0) ? i1 : i3;
   } else i1 = i3;
   i6 = HEAP32[i20 >> 2] | 0;
   if ((i6 | 0) == (i12 | 0)) {
    i4 = i2 - i12 | 0;
    i4 = (((i4 | 0) < 0 ? 0 - i4 | 0 : i4) | 0) < (HEAP32[i19 + 11700 >> 2] | 0) ? i12 : i2;
   } else i4 = i2;
   i3 = HEAP32[i13 >> 2] | 0;
   if ((i3 | 0) == (i14 | 0)) {
    i2 = i1 - i14 | 0;
    i2 = (((i2 | 0) < 0 ? 0 - i2 | 0 : i2) | 0) < (HEAP32[i19 + 11700 >> 2] | 0);
    i5 = i2 ? i14 : i1;
    i2 = i2 ? i14 : i1;
   } else {
    i5 = i1;
    i2 = i1;
   }
   i14 = i4 - ((i6 + i8 | 0) / 2 | 0) | 0;
   i1 = HEAP32[i19 + 11696 >> 2] | 0;
   if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) > (i1 | 0)) {
    i6 = 0;
    i9 = i4;
    i7 = i5;
   } else {
    i14 = i2 - ((i3 + i7 | 0) / 2 | 0) | 0;
    if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) > (i1 | 0)) {
     i6 = 0;
     i9 = i4;
     i7 = i5;
    } else {
     i6 = i15;
     HEAP32[i6 >> 2] = i4;
     HEAP32[i6 + 4 >> 2] = i5;
     i6 = 1;
     i9 = i4;
     i7 = i5;
    }
   }
  }
 }
 i8 = i19 + 11728 | 0;
 i5 = i8;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i15 = i21;
 HEAP32[i15 >> 2] = i4;
 HEAP32[i15 + 4 >> 2] = i5;
 switch (HEAP32[i16 >> 2] | 0) {
 case 2:
  {
   HEAP32[i21 + 32 >> 2] = 2;
   i1 = HEAP32[i19 + 11760 >> 2] | 0;
   i2 = HEAP32[i19 + 11764 >> 2] | 0;
   i3 = HEAP32[i19 + 11644 >> 2] | 0;
   if (!(i17 << 24 >> 24)) {
    i15 = _UNITY_FT_MulFix(i3, i1) | 0;
    i15 = (_UNITY_FT_MulFix(HEAP32[i19 + 11648 >> 2] | 0, i2) | 0) + i15 | 0;
    i16 = _cf2_hintmap_map(i18, i2) | 0;
    i1 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i15) | 0;
    i1 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i16) | 0) + i1 | 0;
    i1 = i1 + (HEAP32[i19 + 11656 >> 2] | 0) | 0;
    i2 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i15) | 0;
    i2 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i16) | 0) + i2 | 0;
    i2 = i2 + (HEAP32[i19 + 11660 >> 2] | 0) | 0;
   } else {
    i15 = _UNITY_FT_MulFix(i3, i1) | 0;
    i15 = (_UNITY_FT_MulFix(HEAP32[i19 + 11648 >> 2] | 0, i2) | 0) + i15 | 0;
    i16 = _cf2_hintmap_map(i19 + 3876 | 0, i2) | 0;
    i1 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i15) | 0;
    i1 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i16) | 0) + i1 | 0;
    i1 = i1 + (HEAP32[i19 + 11656 >> 2] | 0) | 0;
    i2 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i15) | 0;
    i2 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i16) | 0) + i2 | 0;
    i2 = i2 + (HEAP32[i19 + 11660 >> 2] | 0) | 0;
   }
   HEAP32[i21 + 8 >> 2] = i1;
   HEAP32[i21 + 12 >> 2] = i2;
   if (!((i4 | 0) == (i1 | 0) & (i5 | 0) == (i2 | 0))) {
    i14 = HEAP32[i19 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[i14 + 4 >> 2] | 0, i14 | 0, i21 | 0);
    i14 = i21 + 8 | 0;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i8;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
   }
   break;
  }
 case 4:
  {
   HEAP32[i21 + 32 >> 2] = 4;
   i14 = HEAP32[i19 + 11764 >> 2] | 0;
   i11 = i19 + 11644 | 0;
   i13 = i19 + 11648 | 0;
   i16 = (_UNITY_FT_MulFix(HEAP32[i11 >> 2] | 0, HEAP32[i19 + 11760 >> 2] | 0) | 0) + (_UNITY_FT_MulFix(HEAP32[i13 >> 2] | 0, i14) | 0) | 0;
   i14 = _cf2_hintmap_map(i18, i14) | 0;
   i12 = i19 + 11656 | 0;
   HEAP32[i21 + 8 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i16) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i14) | 0) + (HEAP32[i12 >> 2] | 0);
   i15 = i19 + 11660 | 0;
   HEAP32[i21 + 12 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i16) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i14) | 0) + (HEAP32[i15 >> 2] | 0);
   i14 = HEAP32[i19 + 11772 >> 2] | 0;
   i16 = (_UNITY_FT_MulFix(HEAP32[i11 >> 2] | 0, HEAP32[i19 + 11768 >> 2] | 0) | 0) + (_UNITY_FT_MulFix(HEAP32[i13 >> 2] | 0, i14) | 0) | 0;
   i14 = _cf2_hintmap_map(i18, i14) | 0;
   HEAP32[i21 + 16 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i16) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i14) | 0) + (HEAP32[i12 >> 2] | 0);
   HEAP32[i21 + 20 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i16) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i14) | 0) + (HEAP32[i15 >> 2] | 0);
   i14 = i21 + 24 | 0;
   i16 = HEAP32[i19 + 11780 >> 2] | 0;
   i13 = (_UNITY_FT_MulFix(HEAP32[i11 >> 2] | 0, HEAP32[i19 + 11776 >> 2] | 0) | 0) + (_UNITY_FT_MulFix(HEAP32[i13 >> 2] | 0, i16) | 0) | 0;
   i16 = _cf2_hintmap_map(i18, i16) | 0;
   HEAP32[i14 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i13) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i16) | 0) + (HEAP32[i12 >> 2] | 0);
   HEAP32[i21 + 28 >> 2] = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i13) | 0) + (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i16) | 0) + (HEAP32[i15 >> 2] | 0);
   i15 = HEAP32[i19 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[i15 + 12 >> 2] | 0, i15 | 0, i21 | 0);
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i16 = i8;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = i15;
   break;
  }
 default:
  {}
 }
 i3 = i6 << 24 >> 24 != 0;
 i1 = i17 << 24 >> 24 == 0;
 do if (!(i1 & i3)) {
  if (i1) {
   i17 = HEAP32[i20 + 4 >> 2] | 0;
   i1 = _UNITY_FT_MulFix(HEAP32[i19 + 11644 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
   i1 = (_UNITY_FT_MulFix(HEAP32[i19 + 11648 >> 2] | 0, i17) | 0) + i1 | 0;
   i18 = _cf2_hintmap_map(i18, i17) | 0;
   i17 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i1) | 0;
   i17 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i18) | 0) + i17 | 0;
   HEAP32[i21 + 8 >> 2] = i17 + (HEAP32[i19 + 11656 >> 2] | 0);
   i1 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i1) | 0;
   i1 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i18) | 0) + i1 | 0;
   i1 = i1 + (HEAP32[i19 + 11660 >> 2] | 0) | 0;
  } else {
   i18 = HEAP32[i20 + 4 >> 2] | 0;
   i1 = _UNITY_FT_MulFix(HEAP32[i19 + 11644 >> 2] | 0, HEAP32[i20 >> 2] | 0) | 0;
   i1 = (_UNITY_FT_MulFix(HEAP32[i19 + 11648 >> 2] | 0, i18) | 0) + i1 | 0;
   i18 = _cf2_hintmap_map(i19 + 3876 | 0, i18) | 0;
   i17 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 60 >> 2] | 0, i1) | 0;
   i17 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 68 >> 2] | 0, i18) | 0) + i17 | 0;
   HEAP32[i21 + 8 >> 2] = i17 + (HEAP32[i19 + 11656 >> 2] | 0);
   i1 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 64 >> 2] | 0, i1) | 0;
   i1 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i19 >> 2] | 0) + 72 >> 2] | 0, i18) | 0) + i1 | 0;
   i1 = i1 + (HEAP32[i19 + 11660 >> 2] | 0) | 0;
  }
  HEAP32[i21 + 12 >> 2] = i1;
  i2 = i21 + 8 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i8 >> 2] | 0)) if ((i1 | 0) == (HEAP32[i19 + 11732 >> 2] | 0)) break;
  HEAP32[i21 + 32 >> 2] = 2;
  i16 = i8;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i18 = i21;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = HEAP32[i19 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[i18 + 4 >> 2] | 0, i18 | 0, i21 | 0);
  i18 = i2;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i21 = i8;
  HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i21 + 4 >> 2] = i19;
 } while (0);
 if (!i3) {
  STACKTOP = i22;
  return;
 }
 i21 = i20;
 HEAP32[i21 >> 2] = i9;
 HEAP32[i21 + 4 >> 2] = i7;
 STACKTOP = i22;
 return;
}

function __ZN13BuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 32 | 0;
 i6 = i3;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 443262 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 443269 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 443286 | 0, 0);
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443303 | 0, i12, i1 + 108 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443317 | 0, i12, i1 + 111 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443336 | 0, i12, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443355 | 0, i12, i1 + 113 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443374 | 0, i12, i1 + 114 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443385 | 0, i12, i1 + 115 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443405 | 0, i12, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443416 | 0, i12, i1 + 117 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443431 | 0, i12, i1 + 118 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443452 | 0, i12, i1 + 109 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443471 | 0, i12, i1 + 110 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443493 | 0, i12, i1 + 119 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443506 | 0, i12, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443524 | 0, i12, i1 + 121 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i12 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443544 | 0, i12, i1 + 140 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 1);
 i11 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i11, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443554 | 0, i12, i1 + 124 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i11, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37052 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443674 | 0, i11, i1 + 76 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 i10 = HEAP32[gb + 37152 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 i8 = HEAP32[gb + 37008 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i8, gb + 589182 | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37224 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i9, gb + 455698 | 0, i12, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i12, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443693 | 0, i11, i1 + 92 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i8, gb + 455698 | 0, i6, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i6 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i9, gb + 455698 | 0, i8, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 443706 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 156 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl4loadERNS_11PxInputDataERNS0_21SerializationRegistryE(i22, i1, i8) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i29 + 216 | 0;
 i28 = i29 + 152 | 0;
 i25 = i29 + 192 | 0;
 i21 = i29 + 76 | 0;
 i12 = i29 + 28 | 0;
 i6 = i29 + 64 | 0;
 i24 = i29;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, 0);
 i26 = i22 + 8 | 0;
 i20 = HEAP32[i26 >> 2] | 0;
 i27 = i22 + 16 | 0;
 HEAP32[i25 >> 2] = gb + 146644 + 8;
 HEAP32[i25 + 4 >> 2] = i20;
 HEAP32[i25 + 8 >> 2] = i27;
 HEAP32[i25 + 12 >> 2] = i20;
 HEAP32[i25 + 16 >> 2] = 0;
 i20 = i25 + 20 | 0;
 HEAP32[i20 >> 2] = 0;
 i25 = __ZN5physx6shdfnd13createFastXmlEPNS0_7FastXml8CallbackE(i25) | 0;
 mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i1 | 0, 0) | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 766736 | 0, 634, gb + 767076 | 0, i29 + 24 | 0);
  i28 = HEAP32[i25 >> 2] | 0;
  i28 = i28 + 8 | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  mftCall_vi(i28 | 0, i25 | 0);
  STACKTOP = i29;
  return;
 }
 i13 = HEAP32[i26 >> 2] | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i21 >> 2] = gb + 142044 + 8;
 i15 = i21 + 4 | 0;
 HEAP32[i15 >> 2] = i13;
 i13 = i21 + 8 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i21 + 12 >> 2] = i15;
 i18 = i21 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i21 + 20 | 0;
 HEAP32[i14 >> 2] = 0;
 i19 = i21 + 24 | 0;
 HEAP32[i19 >> 2] = 0;
 i7 = i21 + 28 | 0;
 HEAP32[i7 >> 2] = i15;
 i15 = i21 + 32 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAPF32[i21 + 56 >> 2] = Math_fround(.75);
 i16 = i21 + 60 | 0;
 HEAP32[i16 >> 2] = -1;
 HEAP32[i21 + 64 >> 2] = 0;
 i17 = i21 + 68 | 0;
 HEAP32[i17 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i7, 64);
 HEAP32[i21 + 72 >> 2] = 32;
 i7 = HEAP32[i26 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 i9 = (HEAP32[i26 >> 2] | 0) + 4 | 0;
 HEAP32[i12 >> 2] = gb + 146564 + 8;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i12 + 8 >> 2] = i9;
 i9 = i12 + 12 | 0;
 HEAP32[i9 >> 2] = i1;
 i7 = i12 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i12 + 20 >> 2] = i10;
 i10 = i12 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 28 >> 2] = 0;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 i4 = i22 + 144 | 0;
 i20 = i1 + 16 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L5 : do if (i2) {
  i3 = i2;
  do {
   if (!(_strcasecmp(HEAP32[i3 >> 2] | 0, gb + 766862 | 0) | 0)) {
    i5 = 5;
    break;
   }
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  } while ((i3 | 0) != 0);
  if ((i5 | 0) == 5) {
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (i3) if (HEAP8[i3 >> 0] | 0) {
    HEAP32[i28 >> 2] = i3;
    __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i23, i4, i28);
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = i2;
    i2 = HEAP32[i2 + 16 >> 2] | 0;
   }
  }
  if (i2) {
   while (1) {
    if (!(_strcasecmp(HEAP32[i2 >> 2] | 0, gb + 766871 | 0) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    if (!i2) break L5;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i1 = HEAP32[i22 + 160 >> 2] | 0;
   HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   __ZN5physx2Sn17readAllPropertiesINS_17PxTolerancesScaleEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i23, i12, i22 + 132 | 0, i21, i1) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) {
    i2 = HEAP32[i1 + 20 >> 2] | 0;
    if (i2) {
     HEAP32[i9 >> 2] = i2;
     i1 = i2;
    }
   }
  }
 } while (0);
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 L21 : do if (i1 | 0) {
  while (1) {
   if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, gb + 1039677 | 0) | 0)) break;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i1) break L21;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) HEAP32[i22 + 156 >> 2] = i2;
 } while (0);
 HEAP32[i12 >> 2] = gb + 146564 + 8;
 i11 = HEAP32[i11 >> 2] | 0;
 if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i12 = HEAP32[HEAP32[i12 + 20 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
  }
 }
 HEAP32[i21 >> 2] = gb + 142044 + 8;
 i1 = HEAP32[i18 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + (i12 << 2) | 0;
 if (i12 | 0) do {
  i12 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i14 >> 2] = 0;
 i1 = HEAP32[i21 + 52 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i17 >> 2] | 0) == 0)) {
  _memset(HEAP32[i21 + 44 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i21 + 48 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i21 + 40 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) {
  i17 = HEAP32[HEAP32[i21 + 28 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
 }
 i19 = HEAP32[i19 >> 2] | 0;
 if ((i19 | 0) > -1 & (i19 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i18 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i21 + 12 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  i28 = HEAP32[i25 >> 2] | 0;
  i28 = i28 + 8 | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  mftCall_vi(i28 | 0, i25 | 0);
  STACKTOP = i29;
  return;
 }
 i7 = i28 + 4 | 0;
 i8 = i28 + 8 | 0;
 i9 = i28 + 12 | 0;
 i10 = i28 + 16 | 0;
 i11 = i28 + 20 | 0;
 i12 = i7;
 i13 = i28 + 24 | 0;
 i14 = i28 + 28 | 0;
 i15 = i28 + 32 | 0;
 i16 = i24 + 4 | 0;
 i17 = i24 + 8 | 0;
 i18 = i24 + 16 | 0;
 i19 = i22 + 28 | 0;
 i20 = i22 + 24 | 0;
 i5 = i22 + 20 | 0;
 i6 = i28 + 20 | 0;
 i4 = i1;
 do {
  i1 = HEAP32[i4 >> 2] | 0;
  if (_strcasecmp(i1, gb + 767061 | 0) | 0) if (_strcasecmp(i1, gb + 1039677 | 0) | 0) if (_strcasecmp(i1, gb + 767067 | 0) | 0) {
   i1 = HEAP32[i26 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
   i3 = (HEAP32[i26 >> 2] | 0) + 4 | 0;
   HEAP32[i28 >> 2] = gb + 146564 + 8;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i11 >> 2] = i12;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i4 + 16 >> 2] | 0;
   L61 : do if (!i1) {
    i1 = 0;
    i2 = 0;
   } else {
    while (1) {
     if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, gb + 766945 | 0) | 0)) break;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
     if (!i1) {
      i1 = 0;
      i2 = 0;
      break L61;
     }
    }
    i22 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i23 >> 2] = i22;
    i1 = i22;
    if (!i22) {
     i1 = 0;
     i2 = 0;
    } else if (!(HEAP8[i1 >> 0] | 0)) {
     i1 = 0;
     i2 = 0;
    } else {
     i1 = _strtoull(i1, i23, 10) | 0;
     i2 = getTempRet0() | 0;
    }
   } while (0);
   HEAP32[i24 >> 2] = i3;
   HEAP32[i16 >> 2] = 0;
   i22 = i17;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i22 + 4 >> 2] = i2;
   HEAP32[i18 >> 2] = i4;
   i1 = HEAP32[i20 >> 2] | 0;
   if ((HEAP32[i19 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i22 = (HEAP32[i5 >> 2] | 0) + (i1 * 24 | 0) | 0;
    HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i24 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i24 + 20 >> 2];
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i27, i24) | 0;
   HEAP32[i28 >> 2] = gb + 146564 + 8;
   i22 = HEAP32[i15 >> 2] | 0;
   if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) {
     i22 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
    }
   }
  }
  i4 = HEAP32[i4 + 8 >> 2] | 0;
 } while ((i4 | 0) != 0);
 i28 = HEAP32[i25 >> 2] | 0;
 i28 = i28 + 8 | 0;
 i28 = HEAP32[i28 >> 2] | 0;
 mftCall_vi(i28 | 0, i25 | 0);
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMConvexVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj(i18, i5, i2, i3, i4, i1, i19) {
 i18 = i18 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 if (!(__ZNK5physx2Gu15OBBTriangleTest10obbTriTestERKNS_6PxVec3ES4_S4_(i18 + 5328 | 0, i2, i3, i4) | 0)) {
  STACKTOP = i17;
  return 1;
 }
 if (!(HEAP8[i18 + 16 >> 0] | 0)) {
  i12 = HEAP32[i18 + 8 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i2 >> 2]);
  f27 = Math_fround(f26 * Math_fround(HEAPF32[i12 >> 2]));
  i13 = i12 + 4 | 0;
  f28 = Math_fround(f26 * Math_fround(HEAPF32[i13 >> 2]));
  i14 = i12 + 8 | 0;
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i14 >> 2]));
  f23 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i15 = i12 + 12 | 0;
  f25 = Math_fround(f23 * Math_fround(HEAPF32[i15 >> 2]));
  i10 = i12 + 16 | 0;
  f24 = Math_fround(f23 * Math_fround(HEAPF32[i10 >> 2]));
  i8 = i12 + 20 | 0;
  f25 = Math_fround(f27 + f25);
  f24 = Math_fround(f28 + f24);
  f23 = Math_fround(f26 + Math_fround(f23 * Math_fround(HEAPF32[i8 >> 2])));
  f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i9 = i12 + 24 | 0;
  f28 = Math_fround(f26 * Math_fround(HEAPF32[i9 >> 2]));
  i7 = i12 + 28 | 0;
  f27 = Math_fround(f26 * Math_fround(HEAPF32[i7 >> 2]));
  i6 = i12 + 32 | 0;
  f28 = Math_fround(f25 + f28);
  f27 = Math_fround(f24 + f27);
  f26 = Math_fround(f23 + Math_fround(f26 * Math_fround(HEAPF32[i6 >> 2])));
  HEAPF32[i16 >> 2] = f28;
  HEAPF32[i16 + 4 >> 2] = f27;
  HEAPF32[i16 + 8 >> 2] = f26;
  f23 = Math_fround(HEAPF32[i3 >> 2]);
  f24 = Math_fround(f23 * Math_fround(HEAPF32[i12 >> 2]));
  f25 = Math_fround(f23 * Math_fround(HEAPF32[i13 >> 2]));
  f23 = Math_fround(f23 * Math_fround(HEAPF32[i14 >> 2]));
  f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f22 = Math_fround(f20 * Math_fround(HEAPF32[i15 >> 2]));
  f21 = Math_fround(f20 * Math_fround(HEAPF32[i10 >> 2]));
  f22 = Math_fround(f24 + f22);
  f21 = Math_fround(f25 + f21);
  f20 = Math_fround(f23 + Math_fround(f20 * Math_fround(HEAPF32[i8 >> 2])));
  f23 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f25 = Math_fround(f23 * Math_fround(HEAPF32[i9 >> 2]));
  f24 = Math_fround(f23 * Math_fround(HEAPF32[i7 >> 2]));
  f25 = Math_fround(f22 + f25);
  f24 = Math_fround(f21 + f24);
  f23 = Math_fround(f20 + Math_fround(f23 * Math_fround(HEAPF32[i6 >> 2])));
  HEAPF32[i16 + 12 >> 2] = f25;
  HEAPF32[i16 + 16 >> 2] = f24;
  HEAPF32[i16 + 20 >> 2] = f23;
  f20 = Math_fround(HEAPF32[i4 >> 2]);
  f21 = Math_fround(f20 * Math_fround(HEAPF32[i12 >> 2]));
  f22 = Math_fround(f20 * Math_fround(HEAPF32[i13 >> 2]));
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i14 >> 2]));
  f29 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f31 = Math_fround(f29 * Math_fround(HEAPF32[i15 >> 2]));
  f30 = Math_fround(f29 * Math_fround(HEAPF32[i10 >> 2]));
  f31 = Math_fround(f21 + f31);
  f30 = Math_fround(f22 + f30);
  f29 = Math_fround(f20 + Math_fround(f29 * Math_fround(HEAPF32[i8 >> 2])));
  f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f22 = Math_fround(f20 * Math_fround(HEAPF32[i9 >> 2]));
  f21 = Math_fround(f20 * Math_fround(HEAPF32[i7 >> 2]));
  f22 = Math_fround(f31 + f22);
  f21 = Math_fround(f30 + f21);
  f20 = Math_fround(f29 + Math_fround(f20 * Math_fround(HEAPF32[i6 >> 2])));
  HEAPF32[i16 + 24 >> 2] = f22;
  HEAPF32[i16 + 28 >> 2] = f21;
  HEAPF32[i16 + 32 >> 2] = f20;
  i6 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i16 >> 2] = i6;
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i16 + 4 >> 2] = i7;
  i9 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i16 + 8 >> 2] = i9;
  i8 = HEAP32[i3 >> 2] | 0;
  HEAP32[i16 + 12 >> 2] = i8;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i16 + 16 >> 2] = i10;
  i14 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i16 + 20 >> 2] = i14;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i16 + 24 >> 2] = i3;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i16 + 28 >> 2] = i2;
  i15 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i16 + 32 >> 2] = i15;
  i4 = i14;
 }
 i14 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i18 + 12 >> 2] | 0;
 if (!i1) i13 = 56; else i13 = HEAP8[i1 + i14 >> 0] | 0;
 i12 = i18 + 868 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == 16) {
  i11 = i18 + 880 | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 20 | 0, HEAP32[i18 + 788 >> 2] | 0, HEAP8[i18 + 852 >> 0] | 0, i18 + 596 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 56 | 0, HEAP32[i18 + 792 >> 2] | 0, HEAP8[i18 + 853 >> 0] | 0, i18 + 608 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 92 | 0, HEAP32[i18 + 796 >> 2] | 0, HEAP8[i18 + 854 >> 0] | 0, i18 + 620 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 128 | 0, HEAP32[i18 + 800 >> 2] | 0, HEAP8[i18 + 855 >> 0] | 0, i18 + 632 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 164 | 0, HEAP32[i18 + 804 >> 2] | 0, HEAP8[i18 + 856 >> 0] | 0, i18 + 644 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 200 | 0, HEAP32[i18 + 808 >> 2] | 0, HEAP8[i18 + 857 >> 0] | 0, i18 + 656 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 236 | 0, HEAP32[i18 + 812 >> 2] | 0, HEAP8[i18 + 858 >> 0] | 0, i18 + 668 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 272 | 0, HEAP32[i18 + 816 >> 2] | 0, HEAP8[i18 + 859 >> 0] | 0, i18 + 680 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 308 | 0, HEAP32[i18 + 820 >> 2] | 0, HEAP8[i18 + 860 >> 0] | 0, i18 + 692 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 344 | 0, HEAP32[i18 + 824 >> 2] | 0, HEAP8[i18 + 861 >> 0] | 0, i18 + 704 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 380 | 0, HEAP32[i18 + 828 >> 2] | 0, HEAP8[i18 + 862 >> 0] | 0, i18 + 716 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 416 | 0, HEAP32[i18 + 832 >> 2] | 0, HEAP8[i18 + 863 >> 0] | 0, i18 + 728 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 452 | 0, HEAP32[i18 + 836 >> 2] | 0, HEAP8[i18 + 864 >> 0] | 0, i18 + 740 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 488 | 0, HEAP32[i18 + 840 >> 2] | 0, HEAP8[i18 + 865 >> 0] | 0, i18 + 752 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 524 | 0, HEAP32[i18 + 844 >> 2] | 0, HEAP8[i18 + 866 >> 0] | 0, i18 + 764 | 0) | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i11, i18 + 560 | 0, HEAP32[i18 + 848 >> 2] | 0, HEAP8[i18 + 867 >> 0] | 0, i18 + 776 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  i11 = 0;
  i6 = HEAP32[i16 >> 2] | 0;
  i7 = HEAP32[i16 + 4 >> 2] | 0;
  i9 = HEAP32[i16 + 8 >> 2] | 0;
  i8 = HEAP32[i16 + 12 >> 2] | 0;
  i5 = HEAP32[i16 + 16 >> 2] | 0;
  i4 = HEAP32[i16 + 20 >> 2] | 0;
  i3 = HEAP32[i16 + 24 >> 2] | 0;
  i2 = HEAP32[i16 + 28 >> 2] | 0;
  i1 = HEAP32[i16 + 32 >> 2] | 0;
 } else {
  i11 = i1;
  i5 = i10;
  i1 = i15;
 }
 HEAP32[i12 >> 2] = i11 + 1;
 i12 = i11 * 3 | 0;
 HEAP32[i18 + 20 + (i12 * 12 | 0) >> 2] = i6;
 HEAP32[i18 + 20 + (i12 * 12 | 0) + 4 >> 2] = i7;
 HEAP32[i18 + 20 + (i12 * 12 | 0) + 8 >> 2] = i9;
 i15 = i12 + 1 | 0;
 HEAP32[i18 + 20 + (i15 * 12 | 0) >> 2] = i8;
 HEAP32[i18 + 20 + (i15 * 12 | 0) + 4 >> 2] = i5;
 HEAP32[i18 + 20 + (i15 * 12 | 0) + 8 >> 2] = i4;
 i16 = i12 + 2 | 0;
 HEAP32[i18 + 20 + (i16 * 12 | 0) >> 2] = i3;
 HEAP32[i18 + 20 + (i16 * 12 | 0) + 4 >> 2] = i2;
 HEAP32[i18 + 20 + (i16 * 12 | 0) + 8 >> 2] = i1;
 HEAP32[i18 + 596 + (i12 << 2) >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 596 + (i15 << 2) >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 596 + (i16 << 2) >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i18 + 788 + (i11 << 2) >> 2] = i14;
 HEAP8[i18 + 852 + i11 >> 0] = i13;
 STACKTOP = i17;
 return 1;
}

function __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i17, i28, i5) {
 i17 = i17 | 0;
 i28 = i28 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i33 + 12 | 0;
 i30 = i33;
 i31 = i17 + 100 | 0;
 i32 = i17 + 104 | 0;
 HEAP32[i32 >> 2] = 32;
 i11 = i17 + 116 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 112 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 120 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 124 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i29 >> 2] = 1;
 HEAP32[i29 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1408, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if (i1 | 0) {
  i27 = HEAP32[i10 >> 2] | 0;
  HEAP32[i29 >> 2] = 1;
  HEAP32[i29 + 4 >> 2] = i27;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i29);
 }
 HEAP32[i31 >> 2] = i2;
 i1 = i2 + ((HEAP32[i32 >> 2] | 0) * 44 | 0) | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i17 + 56 | 0;
  do {
   i14 = i2;
   i15 = i4;
   i16 = i14 + 44 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    i14 = i14 + 4 | 0;
    i15 = i15 + 4 | 0;
   } while ((i14 | 0) < (i16 | 0));
   i2 = i2 + 44 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i27 = i17 + 108 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 f3 = Math_fround(((HEAP32[i28 + 108 >> 2] | 0) - (HEAP32[i28 + 4 >> 2] | 0) | 0) >>> 0);
 i7 = 32;
 while (1) {
  if (i7 >>> 0 >= i5 >>> 0) {
   f8 = Math_fround(i7 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f3 >= f9)) break;
  }
  i7 = i7 << 1;
 }
 if (i7 >>> 0 > (HEAP32[i32 >> 2] | 0) >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i29 >> 2] = 1;
  HEAP32[i29 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 44 | 0, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i31 >> 2] | 0;
  i2 = HEAP32[i32 >> 2] | 0;
  i26 = i2 >>> 0 > i7 >>> 0 ? i7 : i2;
  i4 = i1 + (i26 * 44 | 0) | 0;
  if (i26) {
   i2 = i6;
   while (1) {
    i14 = i2;
    i15 = i1;
    i16 = i14 + 44 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     i14 = i14 + 4 | 0;
     i15 = i15 + 4 | 0;
    } while ((i14 | 0) < (i16 | 0));
    i1 = i1 + 44 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 44 | 0;
   }
   i2 = HEAP32[i32 >> 2] | 0;
  }
  i4 = i6 + (i7 * 44 | 0) | 0;
  if ((i2 | 0) != (i7 | 0)) {
   i5 = i17 + 56 | 0;
   i1 = i6 + (i2 * 44 | 0) | 0;
   do {
    i14 = i1;
    i15 = i5;
    i16 = i14 + 44 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     i14 = i14 + 4 | 0;
     i15 = i15 + 4 | 0;
    } while ((i14 | 0) < (i16 | 0));
    i1 = i1 + 44 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  i26 = HEAP32[i31 >> 2] | 0;
  i25 = HEAP32[i10 >> 2] | 0;
  HEAP32[i29 >> 2] = 1;
  HEAP32[i29 + 4 >> 2] = i25;
  __Z19free_alloc_internalPvRK10MemLabelId(i26, i29);
  HEAP32[i31 >> 2] = i6;
  HEAP32[i32 >> 2] = i7;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 }
 i19 = i28 + 100 | 0;
 i22 = HEAP32[i19 >> 2] | 0;
 i20 = i28 + 104 | 0;
 i1 = i22 + ((HEAP32[i20 >> 2] | 0) * 44 | 0) | 0;
 HEAP32[i29 >> 2] = i28;
 i21 = i29 + 4 | 0;
 HEAP32[i21 >> 2] = i22;
 HEAP32[i29 + 8 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i29);
 i1 = (HEAP32[i19 >> 2] | 0) + ((HEAP32[i20 >> 2] | 0) * 44 | 0) | 0;
 HEAP32[i30 >> 2] = i28;
 i22 = i30 + 4 | 0;
 HEAP32[i22 >> 2] = i1;
 i23 = i30 + 8 | 0;
 HEAP32[i23 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i30);
 i1 = HEAP32[i21 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i22 >> 2] | 0)) {
  STACKTOP = i33;
  return;
 }
 i24 = i17 + 56 | 0;
 i25 = i17 + 60 | 0;
 i26 = i17 + 64 | 0;
 i18 = i17 + 68 | 0;
 do {
  i17 = (HEAP32[i32 >> 2] | 0) + -1 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  switch (i2 | 0) {
  case 2:
  case 4:
   {
    i2 = 131074;
    break;
   }
  default:
   i2 = i2 * 65537 | 0;
  }
  i2 = i2 ^ i4;
  i16 = HEAP32[i31 >> 2] | 0;
  i11 = HEAP32[i24 >> 2] | 0;
  i10 = HEAP32[i25 >> 2] | 0;
  i12 = HEAP32[i26 >> 2] | 0;
  i15 = HEAP32[i18 >> 2] | 0;
  i13 = i15 & 65535;
  i14 = i15 >>> 24 & 255;
  i15 = i15 >>> 16 & 255;
  L36 : do switch (i10 | 0) {
  case 4:
   {
    i7 = 0;
    while (1) {
     i2 = i2 & i17;
     L57 : do if ((i11 | 0) == (HEAP32[i16 + (i2 * 44 | 0) >> 2] | 0)) {
      i4 = HEAP32[i16 + (i2 * 44 | 0) + 4 >> 2] | 0;
      switch (i4 | 0) {
      case 2:
      case 4:
       break;
      default:
       break L57;
      }
      if ((i12 | 0) == (HEAP32[i16 + (i2 * 44 | 0) + 8 >> 2] | 0)) {
       i5 = HEAP32[i16 + (i2 * 44 | 0) + 12 >> 2] | 0;
       i6 = i5 >>> 24 & 255;
       if (i13 << 16 >> 16 == (i5 & 65535) << 16 >> 16) {
        if (i15 << 24 >> 24 != (i5 >>> 16 & 255) << 24 >> 24) switch (i4 | 0) {
        case 2:
        case 4:
         break;
        default:
         break L57;
        }
        if (i14 << 24 >> 24 == i6 << 24 >> 24) break L36;
       }
      }
     } while (0);
     i10 = i7 + 1 | 0;
     i7 = i10;
     i2 = i10 + i2 | 0;
    }
   }
  case 2:
   {
    i7 = 0;
    while (1) {
     i2 = i2 & i17;
     L68 : do if ((i11 | 0) == (HEAP32[i16 + (i2 * 44 | 0) >> 2] | 0)) {
      i4 = HEAP32[i16 + (i2 * 44 | 0) + 4 >> 2] | 0;
      switch (i4 | 0) {
      case 2:
      case 4:
       break;
      default:
       break L68;
      }
      if ((i12 | 0) == (HEAP32[i16 + (i2 * 44 | 0) + 8 >> 2] | 0)) {
       i5 = HEAP32[i16 + (i2 * 44 | 0) + 12 >> 2] | 0;
       i6 = i5 >>> 24 & 255;
       if (i13 << 16 >> 16 == (i5 & 65535) << 16 >> 16) {
        if (i15 << 24 >> 24 != (i5 >>> 16 & 255) << 24 >> 24) switch (i4 | 0) {
        case 2:
        case 4:
         break;
        default:
         break L68;
        }
        if (i14 << 24 >> 24 == i6 << 24 >> 24) break L36;
       }
      }
     } while (0);
     i10 = i7 + 1 | 0;
     i7 = i10;
     i2 = i10 + i2 | 0;
    }
   }
  default:
   {
    i7 = 0;
    while (1) {
     i2 = i2 & i17;
     L39 : do if ((i11 | 0) == (HEAP32[i16 + (i2 * 44 | 0) >> 2] | 0)) {
      switch (i10 | 0) {
      case 2:
      case 4:
       {
        i4 = 2;
        break;
       }
      default:
       i4 = i10;
      }
      i6 = HEAP32[i16 + (i2 * 44 | 0) + 4 >> 2] | 0;
      switch (i6 | 0) {
      case 2:
      case 4:
       {
        i5 = 2;
        break;
       }
      default:
       i5 = i6;
      }
      if ((i4 | 0) == (i5 | 0)) if ((i12 | 0) == (HEAP32[i16 + (i2 * 44 | 0) + 8 >> 2] | 0)) {
       i4 = HEAP32[i16 + (i2 * 44 | 0) + 12 >> 2] | 0;
       i5 = i4 >>> 24 & 255;
       if (i13 << 16 >> 16 == (i4 & 65535) << 16 >> 16) {
        if (i15 << 24 >> 24 != (i4 >>> 16 & 255) << 24 >> 24) {
         switch (i10 | 0) {
         case 2:
         case 4:
          break;
         default:
          break L39;
         }
         switch (i6 | 0) {
         case 2:
         case 4:
          break;
         default:
          break L39;
         }
        }
        if (i14 << 24 >> 24 == i5 << 24 >> 24) break L36;
       }
      }
     } while (0);
     i6 = i7 + 1 | 0;
     i7 = i6;
     i2 = i6 + i2 | 0;
    }
   }
  } while (0);
  i14 = i16 + (i2 * 44 | 0) | 0;
  i15 = i1;
  i16 = i14 + 44 | 0;
  do {
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   i14 = i14 + 4 | 0;
   i15 = i15 + 4 | 0;
  } while ((i14 | 0) < (i16 | 0));
  HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + 1;
  HEAP32[i21 >> 2] = i1 + 44;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i29);
  i17 = (HEAP32[i19 >> 2] | 0) + ((HEAP32[i20 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i30 >> 2] = i28;
  HEAP32[i22 >> 2] = i17;
  HEAP32[i23 >> 2] = i17;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i30);
  i1 = HEAP32[i21 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i22 >> 2] | 0));
 STACKTOP = i33;
 return;
}

function _ycc_rgb_convert(i1, i17, i7, i8, i3) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 switch (HEAP32[i1 + 44 >> 2] | 0) {
 case 6:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i18 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i20 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i20 << 2) >> 2] | 0) + i18) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i20 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i18) >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i18) >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 3 >> 0] = -1;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 3 >> 0] = -1;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 + 3 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 >> 0] = -1;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 + 3 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 >> 0] = -1;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i13 = HEAP32[i1 + 420 >> 2] | 0;
   i16 = HEAP32[i1 + 92 >> 2] | 0;
   i9 = HEAP32[i1 + 288 >> 2] | 0;
   i10 = HEAP32[i13 + 8 >> 2] | 0;
   i11 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i14 = i17 + 4 | 0;
   i15 = i17 + 8 | 0;
   if (!i16) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = 0;
    while (1) {
     i20 = HEAPU8[i4 + i2 >> 0] | 0;
     i19 = HEAPU8[i5 + i2 >> 0] | 0;
     i18 = HEAPU8[i6 + i2 >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i9 + ((HEAP32[i10 + (i18 << 2) >> 2] | 0) + i20) >> 0] | 0;
     HEAP8[i1 + 1 >> 0] = HEAP8[i9 + (((HEAP32[i12 + (i18 << 2) >> 2] | 0) + (HEAP32[i13 + (i19 << 2) >> 2] | 0) >> 16) + i20) >> 0] | 0;
     HEAP8[i1 + 2 >> 0] = HEAP8[i9 + ((HEAP32[i11 + (i19 << 2) >> 2] | 0) + i20) >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i16 | 0)) break; else i1 = i1 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN5physx2Sc14ConstraintCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i19 >> 2] = HEAP32[gb + 129956 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 129956 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 129956 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 129956 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 129956 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 129956 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 129956 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 129956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = HEAP32[gb + 129988 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 129988 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 129988 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 129988 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 129988 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 129988 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 129988 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 129988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 130020 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 130020 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 130020 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 130020 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 130020 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 130020 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 130020 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 130020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 130052 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 130052 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 130052 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 130052 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 130052 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 130052 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 130052 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 130052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 130084 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 130084 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 130084 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 130084 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 130084 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 130084 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 130084 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 130084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 130116 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 130116 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 130116 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 130116 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 130116 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 130116 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 130116 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 130116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 130148 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 130148 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 130148 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 130148 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 130148 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 130148 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 130148 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 130148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 130180 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 130180 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 130180 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 130180 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 130180 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 130180 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 130180 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 130180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 130212 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 130212 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 130212 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 130212 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 130212 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 130212 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 130212 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 130212 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 130244 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 130244 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 130244 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 130244 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 130244 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 130244 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 130244 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 130244 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 130276 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 130276 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 130276 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 130276 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 130276 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 130276 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 130276 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 130276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 130308 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 130308 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 130308 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 130308 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 130308 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 130308 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 130308 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 130308 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 130340 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 130340 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 130340 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 130340 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 130340 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 130340 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 130340 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 130340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 130372 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 130372 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 130372 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 130372 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 130372 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 130372 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 130372 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 130372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 130404 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 130404 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 130404 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 130404 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 130404 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 130404 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 130404 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 130404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 130436 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 130436 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 130436 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 130436 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 130436 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 130436 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 130436 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 130436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 130468 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 130468 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 130468 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 130468 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 130468 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 130468 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 130468 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 130468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR12GCHandleLessPNS_4pairIyiEEEEbT0_S6_T_(i12, i11, i1) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 switch (i11 - i12 >> 4 | 0) {
 case 2:
  {
   i5 = i11 + -16 | 0;
   i2 = i5;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i12;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i10 = i12;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 4 >> 2] = i2;
   i10 = i5;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i10 + 4 >> 2] = i4;
   i10 = i12 + 8 | 0;
   i12 = i11 + -8 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i11;
   i12 = 1;
   return i12 | 0;
  }
 case 3:
  {
   i9 = i12 + 16 | 0;
   i2 = i9;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i7 = i12;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i8 = i11 + -16 | 0;
   i4 = i8;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i5 = i4 >>> 0 < i2 >>> 0 | (i4 | 0) == (i2 | 0) & i3 >>> 0 < i1 >>> 0;
   if (!(i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i6 >>> 0)) {
    if (!i5) {
     i12 = 1;
     return i12 | 0;
    }
    i5 = i9;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i4;
    i5 = i8;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i5 + 4 >> 2] = i2;
    i5 = i12 + 24 | 0;
    i2 = i11 + -8 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i2 >> 2] = i1;
    i2 = i9;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = i12;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
     i12 = 1;
     return i12 | 0;
    }
    i11 = i12;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 4 >> 2] = i2;
    i11 = i9;
    HEAP32[i11 >> 2] = i3;
    HEAP32[i11 + 4 >> 2] = i4;
    i11 = i12 + 8 | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i12;
    i12 = 1;
    return i12 | 0;
   }
   if (i5) {
    i10 = i12;
    HEAP32[i10 >> 2] = i3;
    HEAP32[i10 + 4 >> 2] = i4;
    i10 = i8;
    HEAP32[i10 >> 2] = i6;
    HEAP32[i10 + 4 >> 2] = i7;
    i10 = i12 + 8 | 0;
    i12 = i11 + -8 | 0;
    i11 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i12 >> 2] = i11;
    i12 = 1;
    return i12 | 0;
   }
   i4 = i12;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = i2;
   i4 = i9;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i4 + 4 >> 2] = i7;
   i4 = i12 + 8 | 0;
   i1 = i12 + 24 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i2;
   i4 = i8;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!(i4 >>> 0 < i7 >>> 0 | (i4 | 0) == (i7 | 0) & i3 >>> 0 < i6 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i12 = i9;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i12 + 4 >> 2] = i4;
   i12 = i8;
   HEAP32[i12 >> 2] = i6;
   HEAP32[i12 + 4 >> 2] = i7;
   i12 = i11 + -8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i2;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i12, i12 + 16 | 0, i12 + 32 | 0, i11 + -16 | 0, i1) | 0;
   i12 = 1;
   return i12 | 0;
  }
 case 5:
  {
   i10 = i12 + 16 | 0;
   i9 = i12 + 32 | 0;
   i6 = i12 + 48 | 0;
   __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i12, i10, i9, i6, i1) | 0;
   i1 = i11 + -16 | 0;
   i3 = i1;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i6;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (!(i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i8 = i6;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i3;
   i3 = i1;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i5;
   i3 = i12 + 56 | 0;
   i8 = i11 + -8 | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i7;
   i8 = i6;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = i9;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(i8 >>> 0 < i2 >>> 0 | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i1 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i4 = i9;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i4 + 4 >> 2] = i8;
   i4 = i6;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = i2;
   i4 = i12 + 40 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i3 >> 2] = i2;
   i2 = i10;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(i8 >>> 0 < i2 >>> 0 | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i1 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i3 = i10;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i3 + 4 >> 2] = i8;
   i3 = i9;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = i12 + 24 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i5;
   HEAP32[i4 >> 2] = i2;
   i2 = i12;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(i8 >>> 0 < i2 >>> 0 | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i1 >>> 0)) {
    i12 = 1;
    return i12 | 0;
   }
   i11 = i12;
   HEAP32[i11 >> 2] = i7;
   HEAP32[i11 + 4 >> 2] = i8;
   i11 = i10;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i11 + 4 >> 2] = i2;
   i11 = i12 + 8 | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i3 >> 2] = i12;
   i12 = 1;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   return i12 | 0;
  }
 default:
  {
   i3 = i12 + 32 | 0;
   i6 = i12 + 16 | 0;
   i2 = i6;
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i9 = i12;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i10 = i3;
   i8 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i10 >>> 0 < i2 >>> 0 | (i10 | 0) == (i2 | 0) & i8 >>> 0 < i5 >>> 0;
   do if (i2 >>> 0 < i9 >>> 0 | (i2 | 0) == (i9 | 0) & i5 >>> 0 < i7 >>> 0) {
    if (i1) {
     i4 = i12;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i4 + 4 >> 2] = i10;
     i10 = i3;
     HEAP32[i10 >> 2] = i7;
     HEAP32[i10 + 4 >> 2] = i9;
     i10 = i12 + 8 | 0;
     i4 = i12 + 40 | 0;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i2;
     i4 = i7;
     i2 = i9;
     break;
    }
    i1 = i12;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i1 + 4 >> 2] = i2;
    i5 = i6;
    HEAP32[i5 >> 2] = i7;
    HEAP32[i5 + 4 >> 2] = i9;
    i5 = i12 + 8 | 0;
    i1 = i12 + 24 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i2;
    if (i10 >>> 0 < i9 >>> 0 | (i10 | 0) == (i9 | 0) & i8 >>> 0 < i7 >>> 0) {
     i4 = i6;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i4 + 4 >> 2] = i10;
     i4 = i3;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i4 + 4 >> 2] = i9;
     i4 = i12 + 40 | 0;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i2;
     i4 = i7;
     i2 = i9;
    } else {
     i4 = i8;
     i2 = i10;
    }
   } else if (i1) {
    i1 = i6;
    HEAP32[i1 >> 2] = i8;
    HEAP32[i1 + 4 >> 2] = i10;
    i1 = i3;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i1 + 4 >> 2] = i2;
    i1 = i12 + 24 | 0;
    i13 = i12 + 40 | 0;
    i14 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    HEAP32[i1 >> 2] = i4;
    HEAP32[i13 >> 2] = i14;
    if (i10 >>> 0 < i9 >>> 0 | (i10 | 0) == (i9 | 0) & i8 >>> 0 < i7 >>> 0) {
     i13 = i12;
     HEAP32[i13 >> 2] = i8;
     HEAP32[i13 + 4 >> 2] = i10;
     i13 = i6;
     HEAP32[i13 >> 2] = i7;
     HEAP32[i13 + 4 >> 2] = i9;
     i13 = i12 + 8 | 0;
     i14 = HEAP32[i13 >> 2] | 0;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i1 >> 2] = i14;
     i4 = i5;
    } else i4 = i5;
   } else {
    i4 = i8;
    i2 = i10;
   } while (0);
   i1 = i12 + 48 | 0;
   L13 : do if ((i1 | 0) == (i11 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i10 = i1;
    i1 = 0;
    while (1) {
     i9 = i10;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     if (i9 >>> 0 < i2 >>> 0 | (i9 | 0) == (i2 | 0) & i8 >>> 0 < i4 >>> 0) {
      i7 = HEAP32[i10 + 8 >> 2] | 0;
      i5 = i10;
      while (1) {
       i6 = i5;
       HEAP32[i6 >> 2] = i4;
       HEAP32[i6 + 4 >> 2] = i2;
       i6 = i3 + 8 | 0;
       HEAP32[i5 + 8 >> 2] = HEAP32[i6 >> 2];
       if ((i3 | 0) == (i12 | 0)) break;
       i5 = i3 + -16 | 0;
       i2 = i5;
       i4 = HEAP32[i2 >> 2] | 0;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!(i9 >>> 0 < i2 >>> 0 | (i9 | 0) == (i2 | 0) & i8 >>> 0 < i4 >>> 0)) break; else {
        i14 = i3;
        i3 = i5;
        i5 = i14;
       }
      }
      i14 = i3;
      HEAP32[i14 >> 2] = i8;
      HEAP32[i14 + 4 >> 2] = i9;
      HEAP32[i6 >> 2] = i7;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i10 + 16 | 0) == (i11 | 0);
       break L13;
      }
     }
     i2 = i10 + 16 | 0;
     if ((i2 | 0) == (i11 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i4 = i10;
     i3 = i10;
     i10 = i2;
     i2 = HEAP32[i4 + 4 >> 2] | 0;
     i4 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   i14 = i1 | i2;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx14SingleAABBTask11runInternalEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 72 | 0;
 i10 = i19 + 48 | 0;
 i15 = i19 + 24 | 0;
 i14 = i19;
 HEAP32[i18 + 112 >> 2] = 0;
 HEAP32[i18 + 180 >> 2] = 0;
 HEAP32[i18 + 248 >> 2] = 0;
 HEAP32[i18 + 316 >> 2] = 0;
 HEAP32[i18 + 384 >> 2] = 0;
 HEAP32[i18 + 452 >> 2] = 0;
 i12 = i18 + 24 | 0;
 i1 = i18 + 28 | 0;
 i9 = i18 + 20 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i17 = i18 + 48 | 0;
 HEAP16[i18 + 52 >> 1] = -1;
 HEAP16[i18 + 54 >> 1] = 0;
 HEAP32[i18 + 56 >> 2] = 0;
 HEAP32[i17 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 60 >> 2] = 0;
 HEAP32[i18 + 64 >> 2] = 0;
 HEAP32[i17 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 68 >> 2] = i16;
 i16 = i18 + 72 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 92 >> 2] = i2;
 i2 = i18 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i8 = i18 + 116 | 0;
 HEAP16[i18 + 120 >> 1] = -1;
 HEAP16[i18 + 122 >> 1] = 0;
 HEAP32[i18 + 124 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 128 >> 2] = 0;
 HEAP32[i18 + 132 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 136 >> 2] = i16;
 i16 = i18 + 140 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 160 >> 2] = i17;
 i17 = i18 + 164 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i8 = i18 + 184 | 0;
 HEAP16[i18 + 188 >> 1] = -1;
 HEAP16[i18 + 190 >> 1] = 0;
 HEAP32[i18 + 192 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 196 >> 2] = 0;
 HEAP32[i18 + 200 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 204 >> 2] = i17;
 i17 = i18 + 208 | 0;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 228 >> 2] = i16;
 i16 = i18 + 232 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i8 = i18 + 252 | 0;
 HEAP16[i18 + 256 >> 1] = -1;
 HEAP16[i18 + 258 >> 1] = 0;
 HEAP32[i18 + 260 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 264 >> 2] = 0;
 HEAP32[i18 + 268 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 272 >> 2] = i16;
 i16 = i18 + 276 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 296 >> 2] = i17;
 i17 = i18 + 300 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i8 = i18 + 320 | 0;
 HEAP16[i18 + 324 >> 1] = -1;
 HEAP16[i18 + 326 >> 1] = 0;
 HEAP32[i18 + 328 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 332 >> 2] = 0;
 HEAP32[i18 + 336 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 340 >> 2] = i17;
 i17 = i18 + 344 | 0;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 364 >> 2] = i16;
 i16 = i18 + 368 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i8 = i18 + 388 | 0;
 HEAP16[i18 + 392 >> 1] = -1;
 HEAP16[i18 + 394 >> 1] = 0;
 HEAP32[i18 + 396 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i18 + 400 >> 2] = 0;
 HEAP32[i18 + 404 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 104588 + 8;
 HEAP32[i18 + 408 >> 2] = i16;
 i16 = i18 + 412 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i18 + 432 >> 2] = i17;
 i17 = i18 + 436 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i17 = HEAP32[i18 + 28 >> 2] | 0;
 i16 = i17 >>> 0 > 6 ? 6 : i17;
 i1 = HEAP32[i9 >> 2] | 0;
 do if (!(i1 & 1)) i8 = 0; else {
  i8 = HEAP32[(HEAP32[i12 >> 2] | 0) + 16912 >> 2] | 0;
  if (!i8) i8 = 0; else {
   if (!(i16 >>> 0 > 1 & i8 >>> 0 > 256)) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i18 + 100 >> 2] = i8;
    break;
   }
   i2 = (i8 + 255 | 0) >>> 8;
   i4 = (i2 >>> 0) / (i16 >>> 0) | 0;
   i7 = i4 << 8;
   i3 = (Math_imul(i4, i16) | 0) - i2 + i16 | 0;
   if (!i3) {
    i2 = 0;
    i4 = 0;
   } else {
    i5 = (Math_imul(i4 + 1 | 0, i16) | 0) - i2 | 0;
    i4 = 0;
    i6 = 0;
    while (1) {
     HEAP32[i11 + (i6 << 2) >> 2] = i4;
     HEAP32[i10 + (i6 << 2) >> 2] = i7;
     i2 = i4 + i7 | 0;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i5 | 0)) break; else i4 = i2;
    }
   }
   i5 = i7 + 256 | 0;
   if (i3 >>> 0 < i16 >>> 0) while (1) {
    HEAP32[i11 + (i3 << 2) >> 2] = i2;
    HEAP32[i10 + (i3 << 2) >> 2] = i5;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i16 | 0)) break; else i2 = i2 + i5 | 0;
   } else i2 = i4;
   HEAP32[i10 + (i16 + -1 << 2) >> 2] = i8 - i2;
   if (i16 >>> 0 < 6) {
    i7 = i17 >>> 0 < 6 ? ~i17 : -7;
    i6 = ~i7;
    i7 = (i7 << 2) + 28 | 0;
    _memset(i11 + (i6 << 2) | 0, 0, i7 | 0) | 0;
    _memset(i10 + (i6 << 2) | 0, 0, i7 | 0) | 0;
    if (!i16) break;
   }
   i1 = i17 >>> 0 < 6 ? i17 : 6;
   i2 = 0;
   do {
    i7 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
    HEAP32[i18 + 48 + (i2 * 68 | 0) + 48 >> 2] = HEAP32[i11 + (i2 << 2) >> 2];
    HEAP32[i18 + 48 + (i2 * 68 | 0) + 52 >> 2] = i7;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
 } while (0);
 do if (!(i1 & 2)) {
  i1 = 0;
  i13 = 28;
 } else {
  i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + 33328 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i13 = 28;
  } else {
   if (!(i16 >>> 0 > 1 & i1 >>> 0 > 256)) {
    HEAP32[i18 + 104 >> 2] = 0;
    HEAP32[i18 + 108 >> 2] = i1;
    i13 = 28;
    break;
   }
   i2 = (i1 + 255 | 0) >>> 8;
   i4 = (i2 >>> 0) / (i16 >>> 0) | 0;
   i7 = i4 << 8;
   i3 = (Math_imul(i4, i16) | 0) - i2 + i16 | 0;
   if (!i3) {
    i2 = 0;
    i4 = 0;
   } else {
    i5 = (Math_imul(i4 + 1 | 0, i16) | 0) - i2 | 0;
    i4 = 0;
    i6 = 0;
    while (1) {
     HEAP32[i15 + (i6 << 2) >> 2] = i4;
     HEAP32[i14 + (i6 << 2) >> 2] = i7;
     i2 = i4 + i7 | 0;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i5 | 0)) break; else i4 = i2;
    }
   }
   i5 = i7 + 256 | 0;
   if (i3 >>> 0 < i16 >>> 0) while (1) {
    HEAP32[i15 + (i3 << 2) >> 2] = i2;
    HEAP32[i14 + (i3 << 2) >> 2] = i5;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i16 | 0)) break; else i2 = i2 + i5 | 0;
   } else i2 = i4;
   HEAP32[i14 + (i16 + -1 << 2) >> 2] = i1 - i2;
   if (i16 >>> 0 < 6) {
    i12 = i17 >>> 0 < 6 ? ~i17 : -7;
    i11 = ~i12;
    i12 = (i12 << 2) + 28 | 0;
    _memset(i15 + (i11 << 2) | 0, 0, i12 | 0) | 0;
    _memset(i14 + (i11 << 2) | 0, 0, i12 | 0) | 0;
    if (!i16) break;
   }
   i2 = i17 >>> 0 < 6 ? i17 : 6;
   i3 = 0;
   do {
    i13 = HEAP32[i14 + (i3 << 2) >> 2] | 0;
    HEAP32[i18 + 48 + (i3 * 68 | 0) + 56 >> 2] = HEAP32[i15 + (i3 << 2) >> 2];
    HEAP32[i18 + 48 + (i3 * 68 | 0) + 60 >> 2] = i13;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i2 | 0));
   i13 = 28;
  }
 } while (0);
 if ((i13 | 0) == 28) if (i16 >>> 0 > 1) if (i8 >>> 0 > 256 | i1 >>> 0 > 256) {
  i1 = i18 + 12 | 0;
  i2 = i17 >>> 0 < 6 ? i17 : 6;
  i5 = 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i18 + 48 + (i5 * 68 | 0) + 16 >> 2] = 1;
   i4 = i18 + 48 + (i5 * 68 | 0) + 12 | 0;
   HEAP32[i4 >> 2] = i3;
   if (i3 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
    HEAP32[i18 + 48 + (i5 * 68 | 0) + 8 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i2 | 0));
  i1 = i17 >>> 0 < 6 ? i17 : 6;
  i2 = 0;
  do {
   i17 = i18 + 48 + (i2 * 68 | 0) | 0;
   mftCall_vi(HEAP32[(HEAP32[i17 >> 2] | 0) + 20 >> 2] | 0, i17 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  STACKTOP = i19;
  return;
 }
 i18 = i18 + 48 | 0;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0);
 STACKTOP = i19;
 return;
}

function __ZNK5Umbra18ImpOcclusionBuffer18isAABBFullyVisibleERKNS_7Vector3ES3_(i20, i1, i2) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 24 | 0;
 i22 = i24 + 8 | 0;
 i23 = i24;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i20 + 1208 >> 2]);
 f18 = Math_fround(HEAPF32[i20 + 1212 >> 2]);
 f19 = Math_fround(HEAPF32[i20 + 1216 >> 2]);
 f13 = Math_fround(HEAPF32[i20 + 1220 >> 2]);
 f14 = Math_fround(f14 - f17);
 f15 = Math_fround(f15 - f18);
 f16 = Math_fround(f16 - f19);
 f8 = Math_fround(Math_fround(1.0) - f13);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 f17 = Math_fround(f3 + f17);
 f18 = Math_fround(f4 + f18);
 f19 = Math_fround(f5 + f19);
 f13 = Math_fround(f13 + Math_fround(1.0));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i21 >> 2] = f14;
 HEAPF32[i21 + 4 >> 2] = f15;
 HEAPF32[i21 + 8 >> 2] = f16;
 HEAPF32[i21 + 12 >> 2] = f8;
 HEAPF32[i22 >> 2] = f17;
 HEAPF32[i22 + 4 >> 2] = f18;
 HEAPF32[i22 + 8 >> 2] = f19;
 HEAPF32[i22 + 12 >> 2] = f13;
 if (!(__ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_(i20, 0, i21, i22) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (!(HEAP32[i20 + 1408 >> 2] | 0)) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 }
 i31 = HEAP32[i20 + 832 >> 2] | 0;
 i30 = HEAP32[i20 + 836 >> 2] | 0;
 i29 = HEAP32[i20 + 840 >> 2] | 0;
 i28 = HEAP32[i20 + 844 >> 2] | 0;
 f25 = Math_fround(HEAPF32[i20 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i20 + 36 >> 2]);
 f26 = Math_fround(HEAPF32[i20 + 40 >> 2]);
 f27 = Math_fround(HEAPF32[i20 + 44 >> 2]);
 f13 = (HEAP32[tempDoublePtr >> 2] = i1 & ~i31 | i31 & i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f13 * f25);
 f8 = (HEAP32[tempDoublePtr >> 2] = i6 & ~i30 | i30 & i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f8 * f4);
 f5 = (HEAP32[tempDoublePtr >> 2] = i9 & ~i29 | i29 & i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f5 * f26);
 f3 = (HEAP32[tempDoublePtr >> 2] = i11 & ~i28 | i28 & i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(Math_fround(f3 * f27) + Math_fround(f26 + Math_fround(f25 + f4)));
 if (!(f4 <= Math_fround(0.0))) {
  f25 = Math_fround(f3 * Math_fround(HEAPF32[i20 + 60 >> 2]));
  f26 = Math_fround(f5 * Math_fround(HEAPF32[i20 + 56 >> 2]));
  f27 = Math_fround(f13 * Math_fround(HEAPF32[i20 + 48 >> 2]));
  f27 = Math_fround(f4 / Math_fround(f25 + Math_fround(f26 + Math_fround(f27 + Math_fround(f8 * Math_fround(HEAPF32[i20 + 52 >> 2]))))));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 } else i1 = 0;
 HEAP32[i21 >> 2] = i1;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 i31 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= Math_fround(0.0);
 i31 = HEAP32[(i31 ? i21 : i22) >> 2] | 0;
 HEAP32[i21 >> 2] = i31;
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i31 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(1.0);
 HEAP32[i21 >> 2] = HEAP32[(i31 ? i21 : i22) >> 2];
 i31 = i20 + 1376 | 0;
 i10 = HEAP32[i31 >> 2] | 0;
 i12 = HEAP32[i31 + 4 >> 2] | 0;
 i29 = HEAP32[i31 + 8 >> 2] | 0;
 i31 = HEAP32[i31 + 12 >> 2] | 0;
 f32 = Math_fround(f17 - f14);
 f4 = Math_fround(f18 - f15);
 f27 = Math_fround(f19 - f16);
 f8 = Math_fround(HEAPF32[i20 + 64 >> 2]);
 f13 = Math_fround(HEAPF32[i20 + 68 >> 2]);
 f38 = Math_fround(HEAPF32[i20 + 76 >> 2]);
 f36 = Math_fround(f32 * f8);
 f17 = Math_fround(f32 * f13);
 f32 = Math_fround(f32 * f38);
 f39 = Math_fround(HEAPF32[i20 + 80 >> 2]);
 f5 = Math_fround(HEAPF32[i20 + 84 >> 2]);
 f35 = Math_fround(HEAPF32[i20 + 92 >> 2]);
 f34 = Math_fround(f4 * f39);
 f40 = Math_fround(f4 * f5);
 f4 = Math_fround(f4 * f35);
 f19 = Math_fround(HEAPF32[i20 + 96 >> 2]);
 f3 = Math_fround(HEAPF32[i20 + 100 >> 2]);
 f33 = Math_fround(HEAPF32[i20 + 108 >> 2]);
 f25 = Math_fround(f27 * f19);
 f41 = Math_fround(f27 * f3);
 f27 = Math_fround(f27 * f33);
 f8 = Math_fround(f14 * f8);
 f13 = Math_fround(f14 * f13);
 f38 = Math_fround(f14 * f38);
 f39 = Math_fround(f15 * f39);
 f5 = Math_fround(f15 * f5);
 f35 = Math_fround(f15 * f35);
 f19 = Math_fround(f16 * f19);
 f3 = Math_fround(f16 * f3);
 f33 = Math_fround(f16 * f33);
 f37 = Math_fround(HEAPF32[i20 + 112 >> 2]);
 f18 = Math_fround(HEAPF32[i20 + 116 >> 2]);
 f37 = Math_fround(f8 + Math_fround(f39 + Math_fround(f19 + f37)));
 f18 = Math_fround(f13 + Math_fround(f5 + Math_fround(f3 + f18)));
 f33 = Math_fround(f38 + Math_fround(f35 + Math_fround(f33 + Math_fround(HEAPF32[i20 + 124 >> 2]))));
 f36 = Math_fround(f36 + f37);
 f17 = Math_fround(f17 + f18);
 f32 = Math_fround(f32 + f33);
 f35 = Math_fround(f34 + f36);
 f38 = Math_fround(f40 + f17);
 f3 = Math_fround(f4 + f32);
 f34 = Math_fround(f34 + f37);
 f40 = Math_fround(f40 + f18);
 f4 = Math_fround(f4 + f33);
 f5 = Math_fround(f25 + f37);
 f13 = Math_fround(f25 + f36);
 f19 = Math_fround(f25 + f35);
 f25 = Math_fround(f25 + f34);
 f16 = Math_fround(f41 + f18);
 f15 = Math_fround(f41 + f17);
 f39 = Math_fround(f41 + f38);
 f41 = Math_fround(f41 + f40);
 f8 = Math_fround(f27 + f33);
 f14 = Math_fround(f27 + f32);
 f26 = Math_fround(f27 + f3);
 f27 = Math_fround(f27 + f4);
 i9 = f33 == Math_fround(0.0);
 f33 = Math_fround(Math_fround(1.0) / f33);
 f33 = i9 ? Math_fround(1.0) : f33;
 i9 = f32 == Math_fround(0.0);
 f32 = Math_fround(Math_fround(1.0) / f32);
 f32 = i9 ? Math_fround(1.0) : f32;
 i9 = f3 == Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f3);
 f3 = i9 ? Math_fround(1.0) : f3;
 i9 = f4 == Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i9 ? Math_fround(1.0) : f4;
 i9 = f8 == Math_fround(0.0);
 f8 = Math_fround(Math_fround(1.0) / f8);
 f8 = i9 ? Math_fround(1.0) : f8;
 i9 = f14 == Math_fround(0.0);
 f14 = Math_fround(Math_fround(1.0) / f14);
 f14 = i9 ? Math_fround(1.0) : f14;
 i9 = f26 == Math_fround(0.0);
 f26 = Math_fround(Math_fround(1.0) / f26);
 f26 = i9 ? Math_fround(1.0) : f26;
 i9 = f27 == Math_fround(0.0);
 f27 = Math_fround(Math_fround(1.0) / f27);
 f27 = i9 ? Math_fround(1.0) : f27;
 f37 = Math_fround(f37 * f33);
 f36 = Math_fround(f36 * f32);
 f35 = Math_fround(f35 * f3);
 f34 = Math_fround(f34 * f4);
 f33 = Math_fround(f18 * f33);
 f32 = Math_fround(f17 * f32);
 f3 = Math_fround(f38 * f3);
 f4 = Math_fround(f40 * f4);
 f5 = Math_fround(f5 * f8);
 f13 = Math_fround(f13 * f14);
 f19 = Math_fround(f19 * f26);
 f25 = Math_fround(f25 * f27);
 f8 = Math_fround(f16 * f8);
 f14 = Math_fround(f15 * f14);
 f26 = Math_fround(f39 * f26);
 f27 = Math_fround(f41 * f27);
 f41 = f37 <= f5 ? f37 : f5;
 f39 = f36 <= f13 ? f36 : f13;
 f15 = f35 <= f19 ? f35 : f19;
 f16 = f34 <= f25 ? f34 : f25;
 f40 = f33 <= f8 ? f33 : f8;
 f38 = f32 <= f14 ? f32 : f14;
 f17 = f3 <= f26 ? f3 : f26;
 f18 = f4 <= f27 ? f4 : f27;
 f15 = f41 <= f15 ? f41 : f15;
 f17 = f40 <= f17 ? f40 : f17;
 f16 = f39 <= f16 ? f39 : f16;
 f18 = f38 <= f18 ? f38 : f18;
 f5 = f37 >= f5 ? f37 : f5;
 f13 = f36 >= f13 ? f36 : f13;
 f19 = f35 >= f19 ? f35 : f19;
 f25 = f34 >= f25 ? f34 : f25;
 f8 = f33 >= f8 ? f33 : f8;
 f14 = f32 >= f14 ? f32 : f14;
 f26 = f3 >= f26 ? f3 : f26;
 f27 = f4 >= f27 ? f4 : f27;
 f19 = f5 >= f19 ? f5 : f19;
 f26 = f8 >= f26 ? f8 : f26;
 f25 = f13 >= f25 ? f13 : f25;
 f27 = f14 >= f27 ? f14 : f27;
 i9 = ~~Math_fround(Math_fround((f15 <= f16 ? f15 : f16) * Math_fround(32.0)) + Math_fround(32.0));
 i11 = ~~Math_fround(Math_fround((f17 <= f18 ? f17 : f18) * Math_fround(32.0)) + Math_fround(32.0));
 i28 = ~~Math_fround(Math_fround((f19 >= f25 ? f19 : f25) * Math_fround(32.0)) + Math_fround(32.9999962));
 i30 = ~~Math_fround(Math_fround((f26 >= f27 ? f26 : f27) * Math_fround(32.0)) + Math_fround(32.9999962));
 HEAP32[i22 >> 2] = (i9 | 0) >= (i10 | 0) ? i9 : i10;
 HEAP32[i22 + 4 >> 2] = (i11 | 0) >= (i12 | 0) ? i11 : i12;
 HEAP32[i23 >> 2] = (i28 | 0) <= (i29 | 0) ? i28 : i29;
 HEAP32[i23 + 4 >> 2] = (i30 | 0) <= (i31 | 0) ? i30 : i31;
 i31 = __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f(i20, i22, i23, Math_fround(HEAPF32[i21 >> 2])) | 0;
 STACKTOP = i24;
 return i31 | 0;
}

function __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i2;
 L1 : while (1) {
  i8 = i11;
  i9 = i11 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i7 = i1;
    i2 = i8 - i7 | 0;
    i3 = i2 >> 3;
    switch (i3 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 8;
      break L1;
     }
    case 5:
     {
      i10 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 56;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 248) {
     i10 = 14;
     break L1;
    }
    i5 = i1 + (((i3 | 0) / 2 | 0) << 3) | 0;
    if ((i2 | 0) > 7992) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 << 3) | 0, i5, i5 + (i2 << 3) | 0, i9, i13) | 0;
    } else i2 = __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i5, i9, i13) | 0;
    if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i1, i5) | 0) {
     i3 = i9;
     break;
    } else i3 = i9;
    while (1) {
     i3 = i3 + -8 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i3, i5) | 0) {
      i10 = 39;
      break L5;
     }
    }
    i2 = i1 + 8 | 0;
    if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i1, i9) | 0)) {
     if ((i2 | 0) == (i9 | 0)) {
      i10 = 56;
      break L1;
     }
     while (1) {
      if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i1, i2) | 0) break;
      i2 = i2 + 8 | 0;
      if ((i2 | 0) == (i9 | 0)) {
       i10 = 56;
       break L1;
      }
     }
     i6 = i2;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     i3 = i9;
     i4 = HEAP32[i3 + 4 >> 2] | 0;
     i7 = i2;
     HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i7 + 4 >> 2] = i4;
     i7 = i9;
     HEAP32[i7 >> 2] = i5;
     HEAP32[i7 + 4 >> 2] = i6;
     i2 = i2 + 8 | 0;
    }
    if ((i2 | 0) == (i9 | 0)) {
     i10 = 56;
     break L1;
    } else i3 = i9;
    while (1) {
     while (1) {
      i4 = i2 + 8 | 0;
      if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i1, i2) | 0) break; else i2 = i4;
     }
     do i3 = i3 + -8 | 0; while (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i1, i3) | 0);
     if (i2 >>> 0 >= i3 >>> 0) {
      i1 = i2;
      continue L5;
     }
     i7 = i2;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     i15 = i3;
     i5 = HEAP32[i15 + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i3;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = i4;
    }
   }
   if ((i10 | 0) == 39) {
    i10 = 0;
    i6 = i1;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i17 = i3;
    i16 = HEAP32[i17 + 4 >> 2] | 0;
    i15 = i1;
    HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i15 + 4 >> 2] = i16;
    i15 = i3;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i15 + 4 >> 2] = i6;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 8 | 0;
   L35 : do if (i4 >>> 0 < i3 >>> 0) {
    i6 = i5;
    while (1) {
     while (1) {
      i5 = i4 + 8 | 0;
      if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i4, i6) | 0) i4 = i5; else break;
     }
     do i3 = i3 + -8 | 0; while (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i3, i6) | 0));
     if (i4 >>> 0 > i3 >>> 0) {
      i3 = i6;
      break L35;
     }
     i16 = i4;
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = HEAP32[i16 + 4 >> 2] | 0;
     i19 = i3;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i17 = i4;
     HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i17 + 4 >> 2] = i18;
     i17 = i3;
     HEAP32[i17 >> 2] = i15;
     HEAP32[i17 + 4 >> 2] = i16;
     i6 = (i6 | 0) == (i4 | 0) ? i3 : i6;
     i4 = i5;
     i2 = i2 + 1 | 0;
    }
   } else i3 = i5; while (0);
   if ((i4 | 0) != (i3 | 0)) if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i3, i4) | 0) {
    i18 = i4;
    i17 = HEAP32[i18 >> 2] | 0;
    i18 = HEAP32[i18 + 4 >> 2] | 0;
    i15 = i3;
    i16 = HEAP32[i15 + 4 >> 2] | 0;
    i19 = i4;
    HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i19 + 4 >> 2] = i16;
    i19 = i3;
    HEAP32[i19 >> 2] = i17;
    HEAP32[i19 + 4 >> 2] = i18;
    i2 = i2 + 1 | 0;
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEbT0_S5_T_(i1, i4, i13) | 0;
    i3 = i4 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEbT0_S5_T_(i3, i11, i13) | 0) {
     i10 = 55;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i19 = i4;
   if ((i19 - i7 | 0) >= (i8 - i19 | 0)) {
    i10 = 54;
    break;
   }
   __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_(i1, i4, i13);
   i1 = i4 + 8 | 0;
  }
  if ((i10 | 0) == 54) {
   i10 = 0;
   __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_(i4 + 8 | 0, i11, i13);
   i11 = i4;
   continue;
  } else if ((i10 | 0) == 55) {
   i10 = 0;
   if (i2) {
    i10 = 56;
    break;
   } else {
    i11 = i4;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i9, i1) | 0)) {
   STACKTOP = i14;
   return;
  }
  i18 = i1;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i9;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i9;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 7) {
  __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i9, i13) | 0;
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 8) {
  i2 = i1 + 8 | 0;
  i3 = i1 + 16 | 0;
  __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i2, i3, i13) | 0;
  if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i9, i3) | 0)) {
   STACKTOP = i14;
   return;
  }
  i18 = i3;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i9;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i3;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i9;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i3, i2) | 0)) {
   STACKTOP = i14;
   return;
  }
  i18 = i2;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i3;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i2;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i3;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i2, i1) | 0)) {
   STACKTOP = i14;
   return;
  }
  i18 = i1;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i15 = i2;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i2;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 12) {
  __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i9, i13) | 0;
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 14) {
  i2 = i1 + 16 | 0;
  __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i2, i13) | 0;
  i3 = i1 + 24 | 0;
  if ((i3 | 0) == (i11 | 0)) {
   STACKTOP = i14;
   return;
  }
  while (1) {
   if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i3, i2) | 0) {
    i18 = i3;
    i19 = HEAP32[i18 + 4 >> 2] | 0;
    i4 = i12;
    HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i4 + 4 >> 2] = i19;
    i4 = i3;
    while (1) {
     i17 = i2;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = i4;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     if ((i2 | 0) == (i1 | 0)) break;
     i4 = i2 + -8 | 0;
     if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i13, i12, i4) | 0) {
      i19 = i2;
      i2 = i4;
      i4 = i19;
     } else break;
    }
    i17 = i12;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i2;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
   }
   i2 = i3 + 8 | 0;
   if ((i2 | 0) == (i11 | 0)) break; else {
    i19 = i3;
    i3 = i2;
    i2 = i19;
   }
  }
  STACKTOP = i14;
  return;
 } else if ((i10 | 0) == 56) {
  STACKTOP = i14;
  return;
 }
}

function __ZN11AudioSource19ConfigureFMODGroupsEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 80 | 0;
 i15 = i19 + 64 | 0;
 i12 = i19 + 48 | 0;
 i9 = i19 + 32 | 0;
 i10 = i19 + 16 | 0;
 i8 = i19;
 i17 = i19 + 100 | 0;
 i13 = i19 + 96 | 0;
 i11 = i16 + 488 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i14 = i16 + 492 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i6 = i16 + 440 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) i7 = 38; else {
  HEAP32[i13 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
    i4 = HEAP32[i17 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
    i7 = 38;
    break;
   }
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
    i4 = HEAP32[i17 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) i7 = 20;
   }
  }
  if ((i7 | 0) == 18) i7 = 20;
  if ((i7 | 0) == 20) {
   i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  i5 = HEAP32[i2 + 52 >> 2] | 0;
  HEAP32[i13 >> 2] = i5;
  if (!i1) i7 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
    i4 = HEAP32[i17 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 26; else {
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) i7 = 28;
   }
  }
  if ((i7 | 0) == 26) i7 = 28;
  if ((i7 | 0) == 28) {
   i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 34; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
    i3 = HEAP32[i17 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i7 = 34; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 36;
   }
  }
  if ((i7 | 0) == 34) i7 = 36;
  if ((i7 | 0) == 36) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = __ZN10AudioMixer19GetFMODChannelGroupERK9UnityGUID(i2, i1 + 56 | 0) | 0;
  if (!i1) i7 = 38; else i2 = i1;
 } while (0);
 do if ((i7 | 0) == 38) {
  i7 = (HEAP8[i16 + 425 >> 0] | 0) == 0;
  i1 = (HEAP8[i16 + 496 >> 0] | 0) != 0;
  i2 = __Z15GetAudioManagerv() | 0;
  if (i7) if (i1) {
   i2 = HEAP32[i2 + 96 >> 2] | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 100 >> 2] | 0;
   break;
  } else if (i1) {
   i2 = HEAP32[i2 + 104 >> 2] | 0;
   break;
  } else {
   i2 = HEAP32[i2 + 108 >> 2] | 0;
   break;
  }
 } while (0);
 if (!(HEAP8[i16 + 424 >> 0] | 0)) {
  i1 = __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_(HEAP32[i11 >> 2] | 0, i13) | 0;
  if (i1 | 0) {
   i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i9 >> 2] = gb + 855390;
   HEAP32[i9 + 4 >> 2] = 414;
   HEAP32[i9 + 8 >> 2] = gb + 861761;
   HEAP32[i9 + 12 >> 2] = i10;
   __Z6FormatPKcz(i17, gb + 883334 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if ((HEAP32[i13 >> 2] | 0) != (i1 | 0)) {
   i1 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(i1, HEAP32[i11 >> 2] | 0) | 0;
   if (i1 | 0) {
    i11 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
    HEAP32[i12 >> 2] = gb + 855390;
    HEAP32[i12 + 4 >> 2] = 416;
    HEAP32[i12 + 8 >> 2] = gb + 861839;
    HEAP32[i12 + 12 >> 2] = i11;
    __Z6FormatPKcz(i17, gb + 883334 | 0, i12);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   }
  }
 } else {
  i1 = __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_(HEAP32[i11 >> 2] | 0, i13) | 0;
  if (i1 | 0) {
   i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i8 >> 2] = gb + 855390;
   HEAP32[i8 + 4 >> 2] = 404;
   HEAP32[i8 + 8 >> 2] = gb + 861761;
   HEAP32[i8 + 12 >> 2] = i12;
   __Z6FormatPKcz(i17, gb + 883334 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  }
  if ((HEAP32[i13 >> 2] | 0) != (i2 | 0)) {
   i1 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(i2, HEAP32[i11 >> 2] | 0) | 0;
   if (i1 | 0) {
    i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
    HEAP32[i10 >> 2] = gb + 855390;
    HEAP32[i10 + 4 >> 2] = 406;
    HEAP32[i10 + 8 >> 2] = gb + 861802;
    HEAP32[i10 + 12 >> 2] = i12;
    __Z6FormatPKcz(i17, gb + 883334 | 0, i10);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   }
  }
 }
 i1 = __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_(HEAP32[i14 >> 2] | 0, i13) | 0;
 if (i1 | 0) {
  i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
  HEAP32[i15 >> 2] = gb + 855390;
  HEAP32[i15 + 4 >> 2] = 421;
  HEAP32[i15 + 8 >> 2] = gb + 861872;
  HEAP32[i15 + 12 >> 2] = i12;
  __Z6FormatPKcz(i17, gb + 883334 | 0, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 }
 if ((HEAP32[i13 >> 2] | 0) != (i2 | 0)) {
  i1 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(i2, HEAP32[i14 >> 2] | 0) | 0;
  if (i1 | 0) {
   i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i18 >> 2] = gb + 855390;
   HEAP32[i18 + 4 >> 2] = 423;
   HEAP32[i18 + 8 >> 2] = gb + 861913;
   HEAP32[i18 + 12 >> 2] = i15;
   __Z6FormatPKcz(i17, gb + 883334 | 0, i18);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  }
 }
 __ZN11AudioSource12ApplyFiltersEv(i16);
 __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i16, 0);
 STACKTOP = i19;
 return;
}

function __ZN16CrashReportEventC2ERK8UnityStrS2_S2_(i11, i1, i4, i5) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i13 = i14;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = i10 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i10 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i10 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i6 = i11 + 16 | 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 28 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i11 + 28 >> 2] | 0;
  i7 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i7 = 12;
  }
 } else i7 = 10;
 if ((i7 | 0) == 10) {
  i10 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i11 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i11 + 20 >> 2] = i3;
  i7 = 12;
 }
 if ((i7 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i11 + 32 | 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i3 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 44 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i11 + 44 >> 2] | 0;
  i7 = 16;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i4 + 11 >> 0] = i3;
  if (!i3) i1 = i4; else {
   i1 = i4;
   i7 = 18;
  }
 } else i7 = 16;
 if ((i7 | 0) == 16) {
  i10 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i11 + 40 >> 2] = i10 | -2147483648;
  HEAP32[i11 + 36 >> 2] = i3;
  i7 = 18;
 }
 if ((i7 | 0) == 18) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i8 = i11 + 48 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = i11 + 64 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i11 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i10 = i11 + 80 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i11 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = i11 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i11 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i11 + 112 >> 2] = 1;
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i2 = i11 + 20 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 > 255) {
   HEAP8[(HEAP32[i6 >> 2] | 0) + 255 >> 0] = 0;
   HEAP32[i2 >> 2] = 255;
  }
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = i11 + 36 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 > 65535) {
   HEAP8[(HEAP32[i4 >> 2] | 0) + 65535 >> 0] = 0;
   HEAP32[i2 >> 2] = 65535;
  }
 }
 i3 = __Z17GetPlayerSettingsv() | 0;
 i2 = i3 + 572 | 0;
 do if ((i8 | 0) != (i2 | 0)) {
  i6 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
  i6 = i4 ? HEAP32[i3 + 576 >> 2] | 0 : i6 & 255;
  i4 = i8 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i11 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i11 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i2 = HEAP32[i8 >> 2] | 0; else i2 = i8;
  if (i6 | 0) _memmove(i2 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 52 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv(i13);
 i6 = i13 + 11 | 0;
 do if ((i9 | 0) != (i13 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
  i8 = i4 ? HEAP32[i13 + 4 >> 2] | 0 : i8 & 255;
  i4 = i9 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i11 + 72 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i11 + 68 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i2 = HEAP32[i9 >> 2] | 0; else i2 = i9;
  if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i2 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 68 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i9 = HEAP32[i13 >> 2] | 0;
  i8 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i12);
 }
 __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv(i13);
 i6 = i13 + 11 | 0;
 do if ((i10 | 0) != (i13 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
  i8 = i4 ? HEAP32[i13 + 4 >> 2] | 0 : i8 & 255;
  i4 = i10 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i11 + 88 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i11 + 84 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i2 = HEAP32[i10 >> 2] | 0; else i2 = i10;
  if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i2 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 84 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i10 = HEAP32[i13 >> 2] | 0;
  i9 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
 }
 __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv(i13);
 i6 = i13 + 11 | 0;
 do if ((i1 | 0) != (i13 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
  i8 = i4 ? HEAP32[i13 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i11 + 104 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i11 + 100 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 100 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 66;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
 STACKTOP = i14;
 return;
}

function __ZN5physx3Ext14SphericalJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i20 >> 2] = HEAP32[gb + 116752 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 116752 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 116752 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 116752 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 116752 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 116752 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 116752 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 116752 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 116784 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 116784 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 116784 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 116784 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 116784 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 116784 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 116784 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 116784 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = gb + 744155;
 HEAP32[i18 + 4 >> 2] = gb + 743927;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 120;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 1;
 HEAP32[i18 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 116816 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 116816 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 116816 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 116816 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 116816 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 116816 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 116816 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 116816 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 116848 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 116848 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 116848 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 116848 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 116848 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 116848 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 116848 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 116848 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 116880 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 116880 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 116880 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 116880 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 116880 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 116880 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 116880 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 116880 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 116912 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 116912 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 116912 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 116912 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 116912 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 116912 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 116912 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 116912 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 116944 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 116944 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 116944 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 116944 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 116944 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 116944 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 116944 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 116944 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 116976 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 116976 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 116976 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 116976 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 116976 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 116976 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 116976 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 116976 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 117008 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 117008 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 117008 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 117008 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 117008 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 117008 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 117008 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 117008 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 744174;
 HEAP32[i10 + 4 >> 2] = gb + 743901;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 84;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 744174;
 HEAP32[i9 + 4 >> 2] = gb + 829211;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 84;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 117040 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 117040 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 117040 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 117040 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 117040 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 117040 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 117040 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 117040 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext13DistanceJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2 + 544 | 0;
 i19 = i2 + 512 | 0;
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i20 >> 2] = HEAP32[gb + 117072 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[gb + 117072 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[gb + 117072 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[gb + 117072 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[gb + 117072 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[gb + 117072 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[gb + 117072 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[gb + 117072 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i20 | 0, 32) | 0;
 HEAP32[i19 >> 2] = HEAP32[gb + 117104 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[gb + 117104 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[gb + 117104 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[gb + 117104 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[gb + 117104 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[gb + 117104 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[gb + 117104 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[gb + 117104 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i19 | 0, 32) | 0;
 HEAP32[i18 >> 2] = gb + 744258;
 HEAP32[i18 + 4 >> 2] = gb + 743927;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 96;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 1;
 HEAP32[i18 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 117136 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 117136 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 117136 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 117136 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 117136 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 117136 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 117136 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 117136 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 117168 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 117168 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 117168 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 117168 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 117168 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 117168 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 117168 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 117168 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 117200 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 117200 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 117200 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 117200 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 117200 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 117200 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 117200 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 117200 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 117232 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 117232 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 117232 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 117232 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 117232 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 117232 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 117232 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 117232 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 128772 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 128772 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 128772 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 128772 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 128772 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 128772 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 128772 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 128772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 117264 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 117264 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 117264 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 117264 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 117264 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 117264 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 117264 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 117264 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 117296 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 117296 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 117296 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 117296 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 117296 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 117296 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 117296 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 117296 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 744276;
 HEAP32[i10 + 4 >> 2] = gb + 743901;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 84;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 744276;
 HEAP32[i9 + 4 >> 2] = gb + 829211;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 84;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 117328 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 117328 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 117328 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 117328 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 117328 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 117328 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 117328 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 117328 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN9InputAxis8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 16 | 0;
 i6 = i11 + 24 | 0;
 i7 = i11;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 3);
 i1 = i2 + 4 | 0;
 i8 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034561 | 0, i8, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 i9 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 i10 = i3 + 16 | 0;
 i4 = i3 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434610 | 0, i8, i2 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434626 | 0, i8, i2 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434650 | 0, i8, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  i12 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434665 | 0, i8, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i5);
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434680 | 0, i8, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i5);
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434698 | 0, i8, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i5);
 }
 i12 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434716 | 0, i12, i2 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434724 | 0, i12, i2 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434729 | 0, i12, i2 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434741 | 0, i12, i2 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434746 | 0, i12, i2 + 105 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 i12 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1047471 | 0, i12, i2 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434753 | 0, i12, i2 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 434758 | 0, i12, i2 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 STACKTOP = i11;
 return;
}

function __Z28CalculateGlobalMatrixInverse23TransformAccessReadOnly(i15, i1) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0;
 i21 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i28 = HEAP32[i1 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 24 >> 2]);
 f3 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i28 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i28 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i28 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f3 * Math_fround(-2.0));
 f29 = Math_fround(f3 * Math_fround(2.0));
 f30 = Math_fround(f3 * f12);
 f9 = Math_fround(f10 * Math_fround(-2.0));
 f4 = Math_fround(f10 * Math_fround(2.0));
 f7 = Math_fround(f10 * f9);
 f11 = Math_fround(Math_fround(f30 + f7) + Math_fround(1.0));
 f13 = Math_fround(Math_fround(Math_fround(f2 * f29) + Math_fround(f6 * f4)) + Math_fround(0.0));
 f12 = Math_fround(Math_fround(Math_fround(f6 * f12) + Math_fround(f2 * f4)) + Math_fround(0.0));
 i19 = i15 + 4 | 0;
 i20 = i15 + 8 | 0;
 f5 = Math_fround(f2 * Math_fround(2.0));
 f8 = Math_fround(f2 * Math_fround(-2.0));
 f2 = Math_fround(f2 * f8);
 f9 = Math_fround(Math_fround(Math_fround(f3 * f5) + Math_fround(f6 * f9)) + Math_fround(0.0));
 f7 = Math_fround(Math_fround(f2 + f7) + Math_fround(1.0));
 f4 = Math_fround(Math_fround(Math_fround(f6 * f5) + Math_fround(f3 * f4)) + Math_fround(0.0));
 i22 = i15 + 12 | 0;
 i23 = i15 + 16 | 0;
 i24 = i15 + 20 | 0;
 f5 = Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(f6 * f29)) + Math_fround(0.0));
 f29 = Math_fround(Math_fround(Math_fround(f6 * f8) + Math_fround(f10 * f29)) + Math_fround(0.0));
 f30 = Math_fround(Math_fround(f2 + f30) + Math_fround(1.0));
 i25 = i15 + 24 | 0;
 i26 = i15 + 28 | 0;
 i27 = i15 + 32 | 0;
 f2 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 32 >> 2]);
 f8 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 36 >> 2]);
 i18 = Math_fround(Math_abs(Math_fround(f2))) < Math_fround(9.99999971e-10);
 i17 = Math_fround(Math_abs(Math_fround(f10))) < Math_fround(9.99999971e-10);
 i16 = Math_fround(Math_abs(Math_fround(f8))) < Math_fround(9.99999971e-10);
 f2 = Math_fround(Math_fround(1.0) / f2);
 f2 = i18 ? Math_fround(1.0) : f2;
 f10 = Math_fround(Math_fround(1.0) / f10);
 f10 = i17 ? Math_fround(1.0) : f10;
 f8 = Math_fround(Math_fround(1.0) / f8);
 f8 = i16 ? Math_fround(1.0) : f8;
 f11 = Math_fround(f2 * f11);
 f13 = Math_fround(f13 * f10);
 f12 = Math_fround(f12 * f8);
 f9 = Math_fround(f2 * f9);
 f7 = Math_fround(f10 * f7);
 f4 = Math_fround(f4 * f8);
 f5 = Math_fround(f2 * f5);
 f10 = Math_fround(f29 * f10);
 f8 = Math_fround(f30 * f8);
 HEAPF32[i15 >> 2] = f11;
 HEAPF32[i19 >> 2] = f13;
 HEAPF32[i20 >> 2] = f12;
 HEAPF32[i22 >> 2] = f9;
 HEAPF32[i23 >> 2] = f7;
 HEAPF32[i24 >> 2] = f4;
 HEAPF32[i25 >> 2] = f5;
 HEAPF32[i26 >> 2] = f10;
 HEAPF32[i27 >> 2] = f8;
 f30 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) >> 2]);
 f29 = Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 4 >> 2]);
 f30 = Math_fround(-f30);
 f29 = Math_fround(-f29);
 f2 = Math_fround(-Math_fround(HEAPF32[i21 + (i28 * 40 | 0) + 8 >> 2]));
 f6 = Math_fround(Math_fround(f11 * f30) + Math_fround(Math_fround(f9 * f29) + Math_fround(f5 * f2)));
 f3 = Math_fround(Math_fround(f13 * f30) + Math_fround(Math_fround(f7 * f29) + Math_fround(f10 * f2)));
 f2 = Math_fround(Math_fround(f12 * f30) + Math_fround(Math_fround(f4 * f29) + Math_fround(f8 * f2)));
 i16 = i15 + 36 | 0;
 HEAPF32[i16 >> 2] = f6;
 i17 = i15 + 40 | 0;
 HEAPF32[i17 >> 2] = f3;
 i18 = i15 + 44 | 0;
 HEAPF32[i18 >> 2] = f2;
 i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 i1 = HEAP32[i14 + (i28 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 do {
  f32 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 24 >> 2]);
  f37 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f37 * Math_fround(-2.0));
  f35 = Math_fround(f37 * Math_fround(2.0));
  f42 = Math_fround(f37 * f34);
  f40 = Math_fround(f29 * Math_fround(-2.0));
  f39 = Math_fround(f29 * Math_fround(2.0));
  f38 = Math_fround(f29 * f40);
  f30 = Math_fround(Math_fround(f42 + f38) + Math_fround(1.0));
  f36 = Math_fround(Math_fround(Math_fround(f41 * f35) + Math_fround(f32 * f39)) + Math_fround(0.0));
  f34 = Math_fround(Math_fround(Math_fround(f32 * f34) + Math_fround(f41 * f39)) + Math_fround(0.0));
  f33 = Math_fround(f41 * Math_fround(2.0));
  f31 = Math_fround(f41 * Math_fround(-2.0));
  f41 = Math_fround(f41 * f31);
  f40 = Math_fround(Math_fround(Math_fround(f37 * f33) + Math_fround(f32 * f40)) + Math_fround(0.0));
  f38 = Math_fround(Math_fround(f41 + f38) + Math_fround(1.0));
  f39 = Math_fround(Math_fround(Math_fround(f32 * f33) + Math_fround(f37 * f39)) + Math_fround(0.0));
  f33 = Math_fround(Math_fround(Math_fround(f33 * f29) + Math_fround(f32 * f35)) + Math_fround(0.0));
  f35 = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(f29 * f35)) + Math_fround(0.0));
  f42 = Math_fround(Math_fround(f41 + f42) + Math_fround(1.0));
  f41 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 28 >> 2]);
  f29 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 32 >> 2]);
  f31 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 36 >> 2]);
  i44 = Math_fround(Math_abs(Math_fround(f41))) < Math_fround(9.99999971e-10);
  i43 = Math_fround(Math_abs(Math_fround(f29))) < Math_fround(9.99999971e-10);
  i28 = Math_fround(Math_abs(Math_fround(f31))) < Math_fround(9.99999971e-10);
  f41 = Math_fround(Math_fround(1.0) / f41);
  f41 = i44 ? Math_fround(1.0) : f41;
  f29 = Math_fround(Math_fround(1.0) / f29);
  f29 = i43 ? Math_fround(1.0) : f29;
  f31 = Math_fround(Math_fround(1.0) / f31);
  f31 = i28 ? Math_fround(1.0) : f31;
  f30 = Math_fround(f41 * f30);
  f36 = Math_fround(f36 * f29);
  f34 = Math_fround(f34 * f31);
  f40 = Math_fround(f41 * f40);
  f38 = Math_fround(f29 * f38);
  f39 = Math_fround(f39 * f31);
  f33 = Math_fround(f41 * f33);
  f29 = Math_fround(f35 * f29);
  f31 = Math_fround(f42 * f31);
  f42 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) >> 2]);
  f35 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 4 >> 2]);
  f42 = Math_fround(-f42);
  f35 = Math_fround(-f35);
  f41 = Math_fround(-Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 8 >> 2]));
  f32 = Math_fround(Math_fround(f30 * f42) + Math_fround(Math_fround(f33 * f41) + Math_fround(f40 * f35)));
  f37 = Math_fround(Math_fround(f36 * f42) + Math_fround(Math_fround(f29 * f41) + Math_fround(f38 * f35)));
  f35 = Math_fround(Math_fround(f34 * f42) + Math_fround(Math_fround(f31 * f41) + Math_fround(f39 * f35)));
  f6 = Math_fround(f6 + Math_fround(Math_fround(f11 * f32) + Math_fround(Math_fround(f35 * f5) + Math_fround(f37 * f9))));
  f3 = Math_fround(f3 + Math_fround(Math_fround(f13 * f32) + Math_fround(Math_fround(f35 * f10) + Math_fround(f37 * f7))));
  f2 = Math_fround(f2 + Math_fround(Math_fround(f32 * f12) + Math_fround(Math_fround(f35 * f8) + Math_fround(f37 * f4))));
  f37 = f11;
  f11 = Math_fround(Math_fround(f30 * f11) + Math_fround(Math_fround(f34 * f5) + Math_fround(f36 * f9)));
  f35 = f13;
  f13 = Math_fround(Math_fround(f30 * f13) + Math_fround(Math_fround(f34 * f10) + Math_fround(f36 * f7)));
  f32 = f12;
  f12 = Math_fround(Math_fround(f30 * f12) + Math_fround(Math_fround(f34 * f8) + Math_fround(f36 * f4)));
  f36 = f9;
  f9 = Math_fround(Math_fround(f40 * f37) + Math_fround(Math_fround(f39 * f5) + Math_fround(f38 * f9)));
  f34 = f7;
  f7 = Math_fround(Math_fround(f40 * f35) + Math_fround(Math_fround(f39 * f10) + Math_fround(f38 * f7)));
  f30 = f4;
  f4 = Math_fround(Math_fround(f40 * f32) + Math_fround(Math_fround(f39 * f8) + Math_fround(f38 * f4)));
  f5 = Math_fround(Math_fround(f33 * f37) + Math_fround(Math_fround(f31 * f5) + Math_fround(f29 * f36)));
  f10 = Math_fround(Math_fround(f33 * f35) + Math_fround(Math_fround(f31 * f10) + Math_fround(f29 * f34)));
  f8 = Math_fround(Math_fround(f33 * f32) + Math_fround(Math_fround(f31 * f8) + Math_fround(f29 * f30)));
  i1 = HEAP32[i14 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i15 >> 2] = f11;
 HEAPF32[i19 >> 2] = f13;
 HEAPF32[i20 >> 2] = f12;
 HEAPF32[i25 >> 2] = f5;
 HEAPF32[i26 >> 2] = f10;
 HEAPF32[i27 >> 2] = f8;
 HEAPF32[i22 >> 2] = f9;
 HEAPF32[i23 >> 2] = f7;
 HEAPF32[i24 >> 2] = f4;
 HEAPF32[i16 >> 2] = f6;
 HEAPF32[i17 >> 2] = f3;
 HEAPF32[i18 >> 2] = f2;
 return;
}

function __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 888 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 900 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 916 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 928 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 940 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 956 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 968 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 980 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 996 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 1008 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 1020 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 1036 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 1048 | 0, gb + 898508 | 0, 0);
 i2 = i8 + 1060 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i3 = i1;
  i4 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + i2 | 0, i9);
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 1064 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 1068 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 1072 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 1076 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 1080 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i6 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 1084 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  i1 = i5;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i5 >>> 0 > 155 ? 155 : i5;
 i4 = i8 + 1088 + (i5 << 2) | 0;
 if (i5 | 0) {
  i3 = i8 + 1088 | 0;
  do {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
    i1 = HEAP32[i10 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + 1712;
 HEAP32[i10 + 4 >> 2] = i8 + 1708;
 HEAP32[i10 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + 1720;
 HEAP32[i10 + 4 >> 2] = i8 + 1716;
 HEAP32[i10 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i9, i10, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1724 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1725 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1726 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1727 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1728 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1729 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1730 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1731 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1732 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i1 = HEAP8[i10 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i8 + 1733 >> 0] = i1;
 i1 = i8 + 1734 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 1);
  i10 = HEAP8[i10 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i10 >> 0] = i8;
  HEAP32[i6 >> 2] = i3;
  i10 = i8;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRK16MeshTriangleDataS3_EPS1_EEbT0_S8_T_(i7, i10, i9) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 switch (i10 - i7 >> 4 | 0) {
 case 2:
  {
   i1 = i10 + -16 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i7 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i9 = HEAP32[i7 >> 2] | 0;
   i6 = i7 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP16[i8 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   i10 = i10 + -12 | 0;
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP16[i6 + 8 >> 1] = HEAP16[i10 + 8 >> 1] | 0;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 3:
  {
   i4 = i7 + 16 | 0;
   i5 = i10 + -16 | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i7 | 0) | 0;
   i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i4 | 0) | 0;
   if (!i6) {
    if (!i1) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    }
    i6 = HEAP32[i4 >> 2] | 0;
    i1 = i7 + 20 | 0;
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP16[i8 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i10 = i10 + -12 | 0;
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP16[i1 + 8 >> 1] = HEAP16[i10 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i7 | 0) | 0)) {
     i10 = 1;
     STACKTOP = i11;
     return i10 | 0;
    }
    i10 = HEAP32[i7 >> 2] | 0;
    i9 = i7 + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP16[i8 + 8 >> 1] = HEAP16[i9 + 8 >> 1] | 0;
    HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP16[i9 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
    HEAP32[i4 >> 2] = i10;
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i1 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i7 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP16[i8 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
   if (i1) {
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    i10 = i10 + -12 | 0;
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP16[i3 + 8 >> 1] = HEAP16[i10 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   i1 = i7 + 20 | 0;
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP16[i3 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP16[i1 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i9 = HEAP32[i4 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP16[i8 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i10 = i10 + -12 | 0;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP16[i1 + 8 >> 1] = HEAP16[i10 + 8 >> 1] | 0;
   HEAP32[i5 >> 2] = i9;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_(i7, i7 + 16 | 0, i7 + 32 | 0, i10 + -16 | 0, i9) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i7, i7 + 16 | 0, i7 + 32 | 0, i7 + 48 | 0, i10 + -16 | 0, i9) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i3 = i7 + 32 | 0;
   i5 = i7 + 16 | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i7 | 0) | 0;
   i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i5 | 0) | 0;
   do if (i6) {
    i2 = HEAP32[i7 >> 2] | 0;
    i4 = i7 + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP16[i8 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
    if (i1) {
     HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
     i6 = i7 + 36 | 0;
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP16[i4 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP16[i6 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
     break;
    }
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    i1 = i7 + 20 | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP16[i4 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i1 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i5 | 0) | 0) {
     i4 = HEAP32[i5 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP16[i8 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     i6 = i7 + 36 | 0;
     HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP16[i1 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
     HEAP32[i3 >> 2] = i4;
     HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP16[i6 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    }
   } else if (i1) {
    i4 = HEAP32[i5 >> 2] | 0;
    i1 = i7 + 20 | 0;
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP16[i8 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    i6 = i7 + 36 | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP16[i1 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
    HEAP32[i3 >> 2] = i4;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP16[i6 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i7 | 0) | 0) {
     i6 = HEAP32[i7 >> 2] | 0;
     i4 = i7 + 4 | 0;
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP16[i8 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
     HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP16[i4 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
     HEAP32[i5 >> 2] = i6;
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP16[i1 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
    }
   } while (0);
   i1 = i7 + 48 | 0;
   L13 : do if ((i1 | 0) == (i10 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i8 + 4 | 0;
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       i5 = i4 + 4 | 0;
       i4 = i3 + 4 | 0;
       HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP16[i5 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
       if ((i3 | 0) == (i7 | 0)) break;
       i5 = i3 + -16 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i5 | 0) | 0) {
        i4 = i3;
        i3 = i5;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
      HEAP16[i4 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 16 | 0) == (i10 | 0);
       break L13;
      }
     }
     i3 = i1 + 16 | 0;
     if ((i3 | 0) == (i10 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i5 = i1;
      i1 = i3;
      i3 = i5;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZL16WalkDirtyRegionsP14TESStesselatorP12ActiveRegion(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = i18 + 64 | 0;
 i20 = i18 + 76 | 0;
 i21 = i18 + 72 | 0;
 i2 = HEAP32[HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
 L1 : while (1) {
  if (HEAP32[i2 + 20 >> 2] | 0) {
   i1 = i2;
   while (1) {
    i2 = HEAP32[HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
    if (!(HEAP32[i2 + 20 >> 2] | 0)) break; else i1 = i2;
   }
  }
  if (!(HEAP32[i1 + 20 >> 2] | 0)) {
   i3 = HEAP32[HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
   if (!i3) {
    i22 = 47;
    break;
   }
   if (!(HEAP32[i3 + 20 >> 2] | 0)) {
    i22 = 47;
    break;
   } else {
    i2 = i1;
    i1 = i3;
   }
  }
  i12 = i1 + 20 | 0;
  HEAP32[i12 >> 2] = 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i2 >> 2] | 0;
  i7 = i6 + 4 | 0;
  i13 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
  L11 : do if ((i13 | 0) == (HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + 16 >> 2] | 0)) i7 = i2; else {
   i17 = i1 + 4 | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i5 = HEAP32[HEAP32[i4 + 8 >> 2] >> 2] | 0;
   i14 = HEAP32[i5 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   i16 = i14 + 4 | 0;
   i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i15 + 24 >> 2]);
   do if (f9 < f11) i22 = 11; else {
    if (f9 == f11) {
     f10 = Math_fround(HEAPF32[i13 + 28 >> 2]);
     if (f10 <= Math_fround(HEAPF32[i15 + 28 >> 2])) {
      i22 = 11;
      break;
     }
    }
    i3 = HEAP32[i14 + 16 >> 2] | 0;
    f10 = Math_fround(f9 - f11);
    f9 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) - f9);
    if (Math_fround(f10 + f9) > Math_fround(0.0)) {
     f11 = Math_fround(HEAPF32[i13 + 28 >> 2]);
     f10 = Math_fround(f10 * Math_fround(f11 - Math_fround(HEAPF32[i3 + 28 >> 2])));
     if (Math_fround(f10 + Math_fround(f9 * Math_fround(f11 - Math_fround(HEAPF32[i15 + 28 >> 2])))) > Math_fround(0.0)) {
      i7 = i2;
      break L11;
     }
    }
    HEAP32[i5 + 20 >> 2] = 1;
    HEAP32[i12 >> 2] = 1;
    i3 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i18 >> 2] | 0, i14) | 0;
    if (!i3) {
     i22 = 23;
     break L1;
    }
    i15 = HEAP32[i3 + 4 >> 2] | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    i7 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] | 0;
    i13 = i3 + 8 | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    i16 = i7 + 8 | 0;
    i12 = HEAP32[i16 >> 2] | 0;
    HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i7;
    HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i3;
    HEAP32[i13 >> 2] = i12;
    HEAP32[i16 >> 2] = i4;
    i16 = HEAP32[i13 >> 2] | 0;
    i4 = i15 + 8 | 0;
    i12 = HEAP32[i4 >> 2] | 0;
    HEAP32[(HEAP32[i16 + 4 >> 2] | 0) + 12 >> 2] = i15;
    HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i3;
    HEAP32[i13 >> 2] = i12;
    HEAP32[i4 >> 2] = i16;
    HEAP32[i3 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    i4 = i15 + 4 | 0;
    i16 = HEAP32[i4 >> 2] | 0;
    HEAP32[(HEAP32[i16 + 16 >> 2] | 0) + 8 >> 2] = i16;
    HEAP32[i16 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i15 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
    HEAP32[i16 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
    if (!i15) {
     i22 = 23;
     break L1;
    }
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i18 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i3) | 0)) {
     i22 = 25;
     break L1;
    }
    HEAP8[(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0) + 21 >> 0] = HEAP32[i1 + 12 >> 2];
   } while (0);
   if ((i22 | 0) == 11) {
    i22 = 0;
    i3 = HEAP32[i6 + 16 >> 2] | 0;
    f10 = Math_fround(f11 - f9);
    f9 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) - f11);
    if (Math_fround(f10 + f9) > Math_fround(0.0)) {
     f11 = Math_fround(HEAPF32[i15 + 28 >> 2]);
     f10 = Math_fround(f10 * Math_fround(f11 - Math_fround(HEAPF32[i3 + 28 >> 2])));
     if (Math_fround(f10 + Math_fround(f9 * Math_fround(f11 - Math_fround(HEAPF32[i13 + 28 >> 2])))) < Math_fround(0.0)) {
      i7 = i2;
      break;
     }
    }
    HEAP32[i12 >> 2] = 1;
    HEAP32[(HEAP32[HEAP32[i4 + 4 >> 2] >> 2] | 0) + 20 >> 2] = 1;
    i3 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i18 >> 2] | 0, i6) | 0;
    if (!i3) {
     i22 = 15;
     break L1;
    }
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i14 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 12 >> 2] | 0;
    i12 = i14 + 8 | 0;
    i15 = HEAP32[i12 >> 2] | 0;
    i13 = i5 + 8 | 0;
    i7 = HEAP32[i13 >> 2] | 0;
    HEAP32[(HEAP32[i15 + 4 >> 2] | 0) + 12 >> 2] = i5;
    HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i14;
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i15;
    i13 = HEAP32[i12 >> 2] | 0;
    i15 = i3 + 8 | 0;
    i7 = HEAP32[i15 >> 2] | 0;
    HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 12 >> 2] = i3;
    HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i14;
    HEAP32[i12 >> 2] = i7;
    HEAP32[i15 >> 2] = i13;
    HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    i15 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[(HEAP32[i15 + 16 >> 2] | 0) + 8 >> 2] = i15;
    HEAP32[i15 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
    HEAP32[i15 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
    if (!i3) {
     i22 = 15;
     break L1;
    }
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i18 >> 2] | 0, HEAP32[i16 >> 2] | 0, i3) | 0)) {
     i22 = 17;
     break L1;
    }
    HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 21 >> 0] = HEAP32[i1 + 12 >> 2];
   }
   if (HEAP32[i2 + 24 >> 2] | 0) {
    HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] = 0;
    i16 = HEAP32[i19 >> 2] | 0;
    i15 = HEAP32[i2 + 4 >> 2] | 0;
    i14 = i15 + 8 | 0;
    i13 = HEAP32[i15 + 4 >> 2] | 0;
    HEAP32[i13 + 8 >> 2] = HEAP32[i14 >> 2];
    HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] = i13;
    i16 = HEAP32[i16 + 16 >> 2] | 0;
    HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i16 >> 2] = i15;
    i16 = HEAP32[i20 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i16 >> 2] = i2;
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i18 >> 2] | 0, i8) | 0)) {
     i22 = 29;
     break L1;
    }
    i7 = HEAP32[HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] >> 2] | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    break;
   }
   if (!(HEAP32[i1 + 24 >> 2] | 0)) i7 = i2; else {
    HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] = 0;
    i15 = HEAP32[i19 >> 2] | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i17 = i16 + 8 | 0;
    i14 = HEAP32[i16 + 4 >> 2] | 0;
    HEAP32[i14 + 8 >> 2] = HEAP32[i17 >> 2];
    HEAP32[(HEAP32[i17 >> 2] | 0) + 4 >> 2] = i14;
    i17 = HEAP32[i15 + 16 >> 2] | 0;
    HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i17 >> 2] = i16;
    i17 = HEAP32[i20 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i17 >> 2] = i1;
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i18 >> 2] | 0, i6) | 0)) {
     i22 = 33;
     break L1;
    }
    i1 = HEAP32[HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = i2;
   }
  } while (0);
  i2 = i6 + 16 | 0;
  i3 = i8 + 16 | 0;
  do if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
   i4 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 16 >> 2] | 0;
   i5 = HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + 16 >> 2] | 0;
   if ((i4 | 0) != (i5 | 0)) if (!(HEAP32[i1 + 24 >> 2] | 0)) if (!(HEAP32[i7 + 24 >> 2] | 0)) {
    i17 = HEAP32[i21 >> 2] | 0;
    if ((i4 | 0) == (i17 | 0) | (i5 | 0) == (i17 | 0)) if (!(__ZL17CheckForIntersectP14TESStesselatorP12ActiveRegion(i18, i1) | 0)) break; else {
     i22 = 47;
     break L1;
    }
   }
   __ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion(i18, i1) | 0;
  } while (0);
  if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
   i2 = i7;
   continue;
  }
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i3 + 16 >> 2] | 0)) {
   i2 = i7;
   continue;
  }
  i17 = i8 + 28 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i6 + 28 >> 2] | 0);
  i17 = i3 + 28 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i2 + 28 >> 2] | 0);
  HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] = 0;
  i17 = HEAP32[i19 >> 2] | 0;
  i16 = HEAP32[i1 + 4 >> 2] | 0;
  i15 = i16 + 8 | 0;
  i14 = HEAP32[i16 + 4 >> 2] | 0;
  HEAP32[i14 + 8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[(HEAP32[i15 >> 2] | 0) + 4 >> 2] = i14;
  i17 = HEAP32[i17 + 16 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i17 >> 2] = i16;
  i17 = HEAP32[i20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i17 >> 2] = i1;
  if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i18 >> 2] | 0, i6) | 0)) {
   i22 = 45;
   break;
  }
  i2 = i7;
  i1 = HEAP32[HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0;
 }
 if ((i22 | 0) == 15) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 17) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 23) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 25) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 29) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 33) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 45) _longjmp(i18 + 144 | 0, 1); else if ((i22 | 0) == 47) return;
}

function __ZN5physx7NpSceneD2Ev(i26) {
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i27 + 4 | 0;
 i6 = i27;
 HEAP32[i26 >> 2] = gb + 100552 + 8;
 i25 = i26 + 3576 | 0;
 i1 = i26 + 3580 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN5physx7NpScene15removeAggregateERNS_11PxAggregateEb(i26, HEAP32[HEAP32[i25 >> 2] >> 2] | 0, 0);
  if (HEAP32[i1 >> 2] | 0) do mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 64 >> 2] | 0, i26 | 0, HEAP32[HEAP32[i25 >> 2] >> 2] | 0, 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i22 = i26 + 3640 | 0;
 i1 = i26 + 3644 | 0;
 if (HEAP32[i1 >> 2] | 0) do mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 52 >> 2] | 0, i26 | 0, HEAP32[HEAP32[i22 >> 2] >> 2] | 0, 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 i20 = i26 + 3652 | 0;
 i1 = i26 + 3656 | 0;
 if (HEAP32[i1 >> 2] | 0) do mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 52 >> 2] | 0, i26 | 0, HEAP32[HEAP32[i20 >> 2] >> 2] | 0, 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 i24 = i26 + 3552 | 0;
 i1 = i26 + 3556 | 0;
 if (HEAP32[i1 >> 2] | 0) do mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 52 >> 2] | 0, i26 | 0, HEAP32[HEAP32[i24 >> 2] >> 2] | 0, 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 i23 = i26 + 3564 | 0;
 i1 = i26 + 3568 | 0;
 if (HEAP32[i1 >> 2] | 0) do mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, HEAP32[HEAP32[i23 >> 2] >> 2] | 0, 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 HEAP32[i19 >> 2] = 0;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i18 = i19 + 8 | 0;
 HEAP32[i18 >> 2] = 0;
 i21 = i26 + 3588 | 0;
 i17 = i26 + 3624 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i19, i1);
 i16 = i26 + 3600 | 0;
 L29 : do if (!(HEAP32[i26 + 3604 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i26 + 3608 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L29;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i14 = i26 + 3592 | 0;
 i15 = i26 + 3596 | 0;
 i13 = i26 + 3608 | 0;
 L36 : while (1) {
  do {
   if ((i1 | 0) == -1) break L36;
   i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i6 >> 2] = i3;
   i4 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i18 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i19 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i5 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i19, i6) | 0;
   i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L36;
   }
   i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i1 = i2; else continue L36;
  }
 }
 i8 = HEAP32[i5 >> 2] | 0;
 if (i8 | 0) {
  i9 = HEAP32[i19 >> 2] | 0;
  i10 = i26 + 3620 | 0;
  i11 = i26 + 3616 | 0;
  i12 = 0;
  do {
   i7 = HEAP32[i9 + (i12 << 2) >> 2] | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   L54 : do if (i1 | 0) {
    i2 = i7;
    i2 = i2 + ~(i2 << 15) | 0;
    i2 = (i2 >>> 10 ^ i2) * 9 | 0;
    i2 = i2 >>> 6 ^ i2;
    i2 = i2 + ~(i2 << 11) | 0;
    i2 = (HEAP32[i16 >> 2] | 0) + (((i2 >>> 16 ^ i2) & i1 + -1) << 2) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i5 = HEAP32[i14 >> 2] | 0;
     i6 = HEAP32[i15 >> 2] | 0;
     i4 = i2;
     while (1) {
      i2 = i4;
      i4 = i6 + (i1 << 2) | 0;
      i3 = i1;
      i1 = HEAP32[i4 >> 2] | 0;
      if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i7 | 0)) break;
      if ((i1 | 0) == -1) break L54;
     }
     HEAP32[i2 >> 2] = i1;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i3;
    }
   } while (0);
   if (i7 | 0) mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 60 >> 2] | 0, i7 | 0);
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < i8 >>> 0);
 }
 i6 = i26 + 16 | 0;
 i3 = (HEAP16[((HEAP32[i26 + 3388 >> 2] & 4 | 0) == 0 ? i26 + 1224 | 0 : i26 + 3364 | 0) >> 1] & 4096) == 0;
 i5 = i26 + 3628 | 0;
 i4 = i26 + 3632 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) do {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 __ZN5physx3Scb5Scene7releaseEv(i6);
 if (!i3) mftCall_vi(HEAP32[(HEAP32[i26 >> 2] | 0) + 404 >> 2] | 0, i26 | 0);
 __ZN5physx6shdfnd7TlsFreeEj(HEAP32[i26 + 3876 >> 2] | 0);
 i18 = HEAP32[i18 >> 2] | 0;
 if ((i18 | 0) > -1 & (i18 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (i1 | 0) {
   i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
  }
 }
 __ZN5physx6shdfnd13ReadWriteLockD2Ev(i26 + 3884 | 0);
 HEAP32[i26 + 3828 >> 2] = gb + 87404 + 8;
 HEAP32[i26 + 3836 >> 2] = 0;
 HEAP32[i26 + 3800 >> 2] = gb + 87404 + 8;
 HEAP32[i26 + 3808 >> 2] = 0;
 HEAP32[i26 + 3772 >> 2] = gb + 87404 + 8;
 HEAP32[i26 + 3780 >> 2] = 0;
 HEAP32[i26 + 3748 >> 2] = gb + 87404 + 8;
 HEAP32[i26 + 3756 >> 2] = 0;
 HEAP32[i26 + 3724 >> 2] = gb + 87404 + 8;
 HEAP32[i26 + 3732 >> 2] = 0;
 i19 = HEAP32[i26 + 3716 >> 2] | 0;
 if ((i19 | 0) > -1 & (i19 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i26 + 3708 >> 2] | 0;
  if (i1 | 0) {
   i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
  }
 }
 i1 = i26 + 3692 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
 }
 i1 = i26 + 3688 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
 }
 i19 = HEAP32[i26 + 3660 >> 2] | 0;
 if ((i19 | 0) > -1 & (i19 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) {
   i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
  }
 }
 i20 = HEAP32[i26 + 3648 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) {
   i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i26 + 3636 >> 2] | 0;
 if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i1);
 i22 = HEAP32[i26 + 3584 >> 2] | 0;
 do if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i25 >> 2] | 0;
  if (!i1) break;
  i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 } while (0);
 i25 = HEAP32[i26 + 3572 >> 2] | 0;
 do if ((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i23 >> 2] | 0;
  if (!i1) break;
  i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 } while (0);
 i25 = HEAP32[i26 + 3560 >> 2] | 0;
 do if ((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i24 >> 2] | 0;
  if (!i1) break;
  i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 } while (0);
 i25 = HEAP32[i26 + 3548 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  i25 = i26 + 3476 | 0;
  __ZN5physx2Cm12RenderBufferD2Ev(i25);
  HEAP32[i26 >> 2] = gb + 100104 + 8;
  i26 = i26 + 3392 | 0;
  __ZN5physx2Sq17SceneQueryManagerD2Ev(i26);
  __ZN5physx3Scb5SceneD2Ev(i6);
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i26 + 3540 >> 2] | 0;
 if (!i1) {
  i25 = i26 + 3476 | 0;
  __ZN5physx2Cm12RenderBufferD2Ev(i25);
  HEAP32[i26 >> 2] = gb + 100104 + 8;
  i26 = i26 + 3392 | 0;
  __ZN5physx2Sq17SceneQueryManagerD2Ev(i26);
  __ZN5physx3Scb5SceneD2Ev(i6);
  STACKTOP = i27;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 i25 = i26 + 3476 | 0;
 __ZN5physx2Cm12RenderBufferD2Ev(i25);
 HEAP32[i26 >> 2] = gb + 100104 + 8;
 i26 = i26 + 3392 | 0;
 __ZN5physx2Sq17SceneQueryManagerD2Ev(i26);
 __ZN5physx3Scb5SceneD2Ev(i6);
 STACKTOP = i27;
 return;
}

function _ft_stroker_cap(i18, i16) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 16 | 0;
 i19 = i20;
 i9 = i20 + 8 | 0;
 switch (HEAP32[i18 + 44 >> 2] | 0) {
 case 1:
  {
   HEAP32[i18 >> 2] = i16;
   HEAP32[i18 + 4 >> 2] = i16 + 11796480;
   i19 = _ft_stroker_arcto(i18, 0) | 0;
   STACKTOP = i20;
   return i19 | 0;
  }
 case 2:
  {
   i7 = HEAP32[i18 + 60 >> 2] | 0;
   _UNITY_FT_Vector_From_Polar(i9, i7, i16 + 5898240 | 0);
   _UNITY_FT_Vector_From_Polar(i19, i7, i16);
   i8 = i18 + 8 | 0;
   i1 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
   HEAP32[i19 >> 2] = i1;
   i10 = i18 + 12 | 0;
   i11 = i9 + 4 | 0;
   i12 = i19 + 4 | 0;
   i3 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = i3;
   i14 = i18 + 80 | 0;
   i13 = i18 + 64 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   L5 : do if (!(HEAP8[i14 >> 0] | 0)) {
    if (i2 | 0) {
     i4 = i2 + -1 | 0;
     i5 = HEAP32[i18 + 72 >> 2] | 0;
     if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) if ((1 - i3 + (HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
      i15 = 18;
      break;
     }
    }
    i6 = i18 + 68 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i1 = i2 + 1 | 0;
    HEAP32[i17 >> 2] = 0;
    do if (i1 >>> 0 > i4 >>> 0) {
     i2 = HEAP32[i18 + 88 >> 2] | 0;
     i5 = i4;
     do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
     i3 = i18 + 72 | 0;
     HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i17) | 0;
     i1 = HEAP32[i17 >> 2] | 0;
     if (!i1) {
      i1 = i18 + 76 | 0;
      i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i17) | 0;
      HEAP32[i1 >> 2] = i4;
      i1 = HEAP32[i17 >> 2] | 0;
      if (!i1) {
       HEAP32[i6 >> 2] = i5;
       i2 = HEAP32[i13 >> 2] | 0;
       i1 = i4;
       break;
      }
     }
     HEAP8[i14 >> 0] = 0;
     break L5;
    } else {
     i3 = i18 + 72 | 0;
     i1 = HEAP32[i18 + 76 >> 2] | 0;
    } while (0);
    i5 = i19;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i15 + 4 >> 2] = i6;
    HEAP8[i1 + i2 >> 0] = 1;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    i15 = 16;
   } else {
    i5 = i19;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i15 = (HEAP32[i18 + 72 >> 2] | 0) + (i2 + -1 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i15 + 4 >> 2] = i6;
    i15 = 16;
   } while (0);
   if ((i15 | 0) == 16) {
    HEAP8[i14 >> 0] = 0;
    i15 = 18;
   }
   L25 : do if ((i15 | 0) == 18) {
    _UNITY_FT_Vector_From_Polar(i9, i7, i16 + -5898240 | 0);
    _UNITY_FT_Vector_From_Polar(i19, i7, i16);
    i5 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i19 >> 2] | 0) | 0;
    HEAP32[i19 >> 2] = i5;
    i4 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i11 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i4;
    i2 = HEAP32[i13 >> 2] | 0;
    L27 : do if (!(HEAP8[i14 >> 0] | 0)) {
     if (i2 | 0) {
      i1 = i2 + -1 | 0;
      i3 = HEAP32[i18 + 72 >> 2] | 0;
      if (((HEAP32[i3 + (i1 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if ((1 - i4 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
       i1 = 0;
       break L25;
      }
     }
     i6 = i18 + 68 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i17 >> 2] = 0;
     do if (i1 >>> 0 > i4 >>> 0) {
      i2 = HEAP32[i18 + 88 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      i3 = i18 + 72 | 0;
      HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i17) | 0;
      i1 = HEAP32[i17 >> 2] | 0;
      if (!i1) {
       i1 = i18 + 76 | 0;
       i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i17) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i17 >> 2] | 0;
       if (!i1) {
        HEAP32[i6 >> 2] = i5;
        i2 = HEAP32[i13 >> 2] | 0;
        i1 = i4;
        break;
       }
      }
      break L27;
     } else {
      i3 = i18 + 72 | 0;
      i1 = HEAP32[i18 + 76 >> 2] | 0;
     } while (0);
     i17 = i19;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     HEAP8[i1 + i2 >> 0] = 1;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     i1 = 0;
    } else {
     i17 = i19;
     i19 = HEAP32[i17 + 4 >> 2] | 0;
     i1 = (HEAP32[i18 + 72 >> 2] | 0) + (i2 + -1 << 3) | 0;
     HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i1 + 4 >> 2] = i19;
     i1 = 0;
    } while (0);
    HEAP8[i14 >> 0] = 0;
   } while (0);
   i19 = i1;
   STACKTOP = i20;
   return i19 | 0;
  }
 case 0:
  {
   i7 = HEAP32[i18 + 60 >> 2] | 0;
   _UNITY_FT_Vector_From_Polar(i19, i7, i16 + 5898240 | 0);
   i8 = i18 + 8 | 0;
   i1 = (HEAP32[i19 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
   HEAP32[i19 >> 2] = i1;
   i9 = i18 + 12 | 0;
   i10 = i19 + 4 | 0;
   i3 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i10 >> 2] = i3;
   i12 = i18 + 80 | 0;
   i11 = i18 + 64 | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   L49 : do if (!(HEAP8[i12 >> 0] | 0)) {
    if (i2 | 0) {
     i4 = i2 + -1 | 0;
     i5 = HEAP32[i18 + 72 >> 2] | 0;
     if (((HEAP32[i5 + (i4 << 3) >> 2] | 0) + 1 - i1 | 0) >>> 0 < 3) if ((1 - i3 + (HEAP32[i5 + (i4 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
      i15 = 49;
      break;
     }
    }
    i6 = i18 + 68 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i1 = i2 + 1 | 0;
    HEAP32[i17 >> 2] = 0;
    do if (i1 >>> 0 > i4 >>> 0) {
     i2 = HEAP32[i18 + 88 >> 2] | 0;
     i5 = i4;
     do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
     i3 = i18 + 72 | 0;
     HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i17) | 0;
     i1 = HEAP32[i17 >> 2] | 0;
     if (!i1) {
      i1 = i18 + 76 | 0;
      i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i17) | 0;
      HEAP32[i1 >> 2] = i4;
      i1 = HEAP32[i17 >> 2] | 0;
      if (!i1) {
       HEAP32[i6 >> 2] = i5;
       i2 = HEAP32[i11 >> 2] | 0;
       i1 = i4;
       break;
      }
     }
     HEAP8[i12 >> 0] = 0;
     break L49;
    } else {
     i3 = i18 + 72 | 0;
     i1 = HEAP32[i18 + 76 >> 2] | 0;
    } while (0);
    i13 = i19;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    HEAP8[i1 + i2 >> 0] = 1;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    i15 = 47;
   } else {
    i13 = i19;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i15 = (HEAP32[i18 + 72 >> 2] | 0) + (i2 + -1 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    i15 = 47;
   } while (0);
   if ((i15 | 0) == 47) {
    HEAP8[i12 >> 0] = 0;
    i15 = 49;
   }
   L69 : do if ((i15 | 0) == 49) {
    _UNITY_FT_Vector_From_Polar(i19, i7, i16 + -5898240 | 0);
    i5 = (HEAP32[i19 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
    HEAP32[i19 >> 2] = i5;
    i4 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
    HEAP32[i10 >> 2] = i4;
    i2 = HEAP32[i11 >> 2] | 0;
    L71 : do if (!(HEAP8[i12 >> 0] | 0)) {
     if (i2 | 0) {
      i1 = i2 + -1 | 0;
      i3 = HEAP32[i18 + 72 >> 2] | 0;
      if (((HEAP32[i3 + (i1 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if ((1 - i4 + (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) {
       i1 = 0;
       break L69;
      }
     }
     i6 = i18 + 68 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i17 >> 2] = 0;
     do if (i1 >>> 0 > i4 >>> 0) {
      i2 = HEAP32[i18 + 88 >> 2] | 0;
      i5 = i4;
      do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
      i3 = i18 + 72 | 0;
      HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i17) | 0;
      i1 = HEAP32[i17 >> 2] | 0;
      if (!i1) {
       i1 = i18 + 76 | 0;
       i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i17) | 0;
       HEAP32[i1 >> 2] = i4;
       i1 = HEAP32[i17 >> 2] | 0;
       if (!i1) {
        HEAP32[i6 >> 2] = i5;
        i2 = HEAP32[i11 >> 2] | 0;
        i1 = i4;
        break;
       }
      }
      break L71;
     } else {
      i3 = i18 + 72 | 0;
      i1 = HEAP32[i18 + 76 >> 2] | 0;
     } while (0);
     i17 = i19;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     HEAP8[i1 + i2 >> 0] = 1;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i1 = 0;
    } else {
     i17 = i19;
     i19 = HEAP32[i17 + 4 >> 2] | 0;
     i1 = (HEAP32[i18 + 72 >> 2] | 0) + (i2 + -1 << 3) | 0;
     HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i1 + 4 >> 2] = i19;
     i1 = 0;
    } while (0);
    HEAP8[i12 >> 0] = 0;
   } while (0);
   i19 = i1;
   STACKTOP = i20;
   return i19 | 0;
  }
 default:
  {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZN7mecanim5human18HumanPoseBlendNodeERNS0_9HumanPoseEPS1_f(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i1 = 0;
 do {
  f6 = Math_fround(Math_fround(HEAPF32[i3 + 596 + (i1 << 2) >> 2]) * f4);
  i5 = i2 + 596 + (i1 << 2) | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 52);
 i1 = 0;
 do {
  f6 = Math_fround(Math_fround(HEAPF32[i3 + 364 + (i1 << 2) >> 2]) * f4);
  i5 = i2 + 364 + (i1 << 2) | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f6);
  f6 = Math_fround(Math_fround(HEAPF32[i3 + 500 + (i1 << 2) >> 2]) * f4);
  i5 = i2 + 500 + (i1 << 2) | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 i1 = 0;
 do {
  f20 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 4 >> 2]);
  f20 = Math_fround(f20 * f4);
  f6 = Math_fround(f6 * f4);
  f21 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 8 >> 2]) * f4);
  i15 = i2 + 68 + (i1 << 6) | 0;
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i15 >> 2]));
  i16 = i2 + 68 + (i1 << 6) + 4 | 0;
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i16 >> 2]));
  i17 = i2 + 68 + (i1 << 6) + 8 | 0;
  f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
  HEAPF32[i15 >> 2] = f20;
  HEAPF32[i16 >> 2] = f6;
  HEAPF32[i17 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 12 >> 2]);
  f6 = Math_fround(f21 * f4);
  f20 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 16 >> 2]);
  f8 = Math_fround(f20 * f4);
  f19 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 20 >> 2]);
  f10 = Math_fround(f19 * f4);
  f18 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 24 >> 2]);
  f12 = Math_fround(f18 * f4);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = i2 + 68 + (i1 << 6) + 12 | 0;
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  f21 = Math_fround(f12 * f21);
  i9 = i2 + 68 + (i1 << 6) + 16 | 0;
  f10 = Math_fround(HEAPF32[i9 >> 2]);
  f20 = Math_fround(f10 * f20);
  i7 = i2 + 68 + (i1 << 6) + 20 | 0;
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  f19 = Math_fround(f8 * f19);
  i5 = i2 + 68 + (i1 << 6) + 24 | 0;
  f6 = Math_fround(HEAPF32[i5 >> 2]);
  f18 = Math_fround(Math_fround(f21 + f20) + Math_fround(f19 + Math_fround(f6 * f18)));
  i14 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
  f12 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i14 ^ i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f10 = Math_fround(f10 + (HEAP32[tempDoublePtr >> 2] = i14 ^ i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f8 = Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i14 ^ i15, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f6 = Math_fround(f6 + (HEAP32[tempDoublePtr >> 2] = i14 ^ i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i11 >> 2] = f12;
  HEAPF32[i9 >> 2] = f10;
  HEAPF32[i7 >> 2] = f8;
  HEAPF32[i5 >> 2] = f6;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 * f4);
 f19 = Math_fround(f19 * f4);
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f4);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
 i7 = i2 + 4 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i7 >> 2]));
 i5 = i2 + 8 | 0;
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i2 >> 2] = f8;
 HEAPF32[i7 >> 2] = f19;
 HEAPF32[i5 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f19 = Math_fround(f6 * f4);
 f8 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f20 = Math_fround(f8 * f4);
 f10 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f21 = Math_fround(f10 * f4);
 f12 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f18 = Math_fround(f12 * f4);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = i2 + 12 | 0;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f6 = Math_fround(f18 * f6);
 i17 = i2 + 16 | 0;
 f21 = Math_fround(HEAPF32[i17 >> 2]);
 f8 = Math_fround(f21 * f8);
 i16 = i2 + 20 | 0;
 f20 = Math_fround(HEAPF32[i16 >> 2]);
 f10 = Math_fround(f20 * f10);
 i15 = i2 + 24 | 0;
 f19 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(Math_fround(f6 + f8) + Math_fround(f10 + Math_fround(f19 * f12)));
 i11 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
 f18 = Math_fround(f18 + (HEAP32[tempDoublePtr >> 2] = i11 ^ i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i11 ^ i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i11 ^ i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i11 ^ i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i14 >> 2] = f18;
 HEAPF32[i17 >> 2] = f21;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i15 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i3 + 804 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 808 >> 2]);
 f19 = Math_fround(f19 * f4);
 f20 = Math_fround(f20 * f4);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 812 >> 2]) * f4);
 i15 = i2 + 804 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 i16 = i2 + 808 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i17 = i2 + 812 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i15 >> 2] = f19;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i17 >> 2] = f21;
 f21 = Math_fround(HEAPF32[i3 + 816 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 820 >> 2]);
 f21 = Math_fround(f21 * f4);
 f20 = Math_fround(f20 * f4);
 f19 = Math_fround(Math_fround(HEAPF32[i3 + 824 >> 2]) * f4);
 i17 = i2 + 816 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 i16 = i2 + 820 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i15 = i2 + 824 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i17 >> 2] = f21;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i15 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i3 + 828 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 832 >> 2]);
 f19 = Math_fround(f19 * f4);
 f20 = Math_fround(f20 * f4);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 836 >> 2]) * f4);
 i15 = i2 + 828 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 i16 = i2 + 832 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i17 = i2 + 836 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i15 >> 2] = f19;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i17 >> 2] = f21;
 f21 = Math_fround(HEAPF32[i3 + 840 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 844 >> 2]);
 f21 = Math_fround(f21 * f4);
 f20 = Math_fround(f20 * f4);
 f19 = Math_fround(Math_fround(HEAPF32[i3 + 848 >> 2]) * f4);
 i17 = i2 + 840 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 i16 = i2 + 844 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i15 = i2 + 848 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i17 >> 2] = f21;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i15 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i3 + 852 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 856 >> 2]);
 f19 = Math_fround(f19 * f4);
 f20 = Math_fround(f20 * f4);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 860 >> 2]) * f4);
 i15 = i2 + 852 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 i16 = i2 + 856 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i17 = i2 + 860 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i15 >> 2] = f19;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i17 >> 2] = f21;
 f21 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 f21 = Math_fround(f21 * f4);
 f20 = Math_fround(f20 * f4);
 f19 = Math_fround(Math_fround(HEAPF32[i3 + 872 >> 2]) * f4);
 i17 = i2 + 864 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 i16 = i2 + 868 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i15 = i2 + 872 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i17 >> 2] = f21;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i15 >> 2] = f19;
 f19 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 880 >> 2]);
 f19 = Math_fround(f19 * f4);
 f20 = Math_fround(f20 * f4);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 884 >> 2]) * f4);
 i15 = i2 + 876 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i15 >> 2]));
 i16 = i2 + 880 | 0;
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i17 = i2 + 884 | 0;
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i15 >> 2] = f19;
 HEAPF32[i16 >> 2] = f20;
 HEAPF32[i17 >> 2] = f21;
 return;
}

function __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i3, i5, i4, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27 + 40 | 0;
 i26 = i27;
 i22 = i27 + 41 | 0;
 i23 = i27 + 43 | 0;
 i24 = i27 + 42 | 0;
 i7 = i5;
 i6 = i3;
 i1 = i7 - i6 | 0;
 i2 = (i1 | 0) > 1240;
 L1 : do if ((i4 | 0) > 0 & i2) while (1) {
  i19 = i5 + -40 | 0;
  i20 = i5 + -12 | 0;
  i21 = i5 + -8 | 0;
  while (1) {
   i18 = ((i1 | 0) / 40 | 0) + -1 | 0;
   HEAP8[i25 >> 0] = HEAP8[i22 >> 0] | 0;
   __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i3, i19, i18, i25);
   i1 = -1;
   i13 = i18;
   while (1) {
    i14 = HEAP32[i20 >> 2] | 0;
    while (1) {
     i16 = i1 + 1 | 0;
     i17 = i3 + (i16 * 40 | 0) | 0;
     i2 = HEAP32[i3 + (i16 * 40 | 0) + 28 >> 2] | 0;
     do if ((i2 | 0) == (i14 | 0)) {
      i8 = i17;
      i2 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i10 = i19;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      if ((i2 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
       i11 = HEAP16[i3 + (i16 * 40 | 0) + 32 >> 1] | 0;
       i12 = HEAP16[i21 >> 1] | 0;
       if (i11 << 16 >> 16 != i12 << 16 >> 16) {
        i2 = (i11 & 65535) > (i12 & 65535);
        break;
       }
      }
      i2 = i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i2 >>> 0 < i9 >>> 0;
     } else i2 = i2 >>> 0 < i14 >>> 0; while (0);
     if ((i16 | 0) == (i18 | 0) | i2 ^ 1) break; else i1 = i16;
    }
    do {
     i13 = i13 + -1 | 0;
     i15 = i3 + (i13 * 40 | 0) | 0;
     i2 = HEAP32[i3 + (i13 * 40 | 0) + 28 >> 2] | 0;
     do if ((i14 | 0) == (i2 | 0)) {
      i8 = i19;
      i2 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i10 = i15;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      if ((i2 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
       i11 = HEAP16[i21 >> 1] | 0;
       i12 = HEAP16[i3 + (i13 * 40 | 0) + 32 >> 1] | 0;
       if (i11 << 16 >> 16 != i12 << 16 >> 16) {
        i2 = (i11 & 65535) > (i12 & 65535);
        break;
       }
      }
      i2 = i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i2 >>> 0 < i9 >>> 0;
     } else i2 = i14 >>> 0 < i2 >>> 0; while (0);
    } while (!((i13 | 0) == 0 | i2 ^ 1));
    i2 = (i16 | 0) < (i13 | 0);
    i11 = i26;
    i12 = i17;
    i14 = i11 + 40 | 0;
    do {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     i11 = i11 + 4 | 0;
     i12 = i12 + 4 | 0;
    } while ((i11 | 0) < (i14 | 0));
    if (!i2) break;
    HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i17 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i17 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    HEAP32[i17 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
    HEAP32[i17 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
    HEAP16[i17 + 32 >> 1] = HEAP16[i15 + 32 >> 1] | 0;
    HEAP32[i15 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
    HEAP32[i15 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
    HEAP32[i15 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
    HEAP32[i15 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
    HEAP32[i15 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
    HEAP16[i15 + 32 >> 1] = HEAP16[i26 + 32 >> 1] | 0;
    i1 = i16;
   }
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
   HEAP32[i17 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
   HEAP32[i17 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
   HEAP16[i17 + 32 >> 1] = HEAP16[i19 + 32 >> 1] | 0;
   HEAP32[i19 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
   HEAP32[i19 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
   HEAP32[i19 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
   HEAP32[i19 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
   HEAP32[i19 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
   HEAP16[i19 + 32 >> 1] = HEAP16[i26 + 32 >> 1] | 0;
   i9 = i3 + ((i1 + 2 | 0) * 40 | 0) | 0;
   i4 = ((i4 | 0) / 2 | 0) + ((i4 | 0) / 4 | 0) | 0;
   i10 = i3 + (i1 * 40 | 0) + 40 | 0;
   i11 = i10;
   i8 = (i11 - i6 | 0) / 40 | 0;
   i6 = i9;
   i1 = i7 - i6 | 0;
   i2 = (i1 | 0) / 40 | 0;
   if ((i8 | 0) >= (i2 | 0)) break;
   HEAP8[i25 >> 0] = HEAP8[i23 >> 0] | 0;
   __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i3, i10, i8, i25);
   i2 = (i1 | 0) > 1240;
   if (!((i4 | 0) > 0 & i2)) {
    i13 = i9;
    i10 = i5;
    break L1;
   } else i3 = i9;
  }
  HEAP8[i25 >> 0] = HEAP8[i24 >> 0] | 0;
  __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i9, i5, i2, i25);
  i6 = i3;
  i1 = i11 - i6 | 0;
  i2 = (i1 | 0) > 1240;
  if ((i4 | 0) > 0 & i2) {
   i5 = i10;
   i7 = i11;
  } else {
   i13 = i3;
   break;
  }
 } else {
  i13 = i3;
  i10 = i5;
 } while (0);
 if (i2) {
  i2 = (i1 >>> 0) / 40 | 0;
  i1 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIR19ROSorterReplacementP17RODataReplacementEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i13, i10, i25, i2, i13 + (i1 * 40 | 0) | 0);
   if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
  }
  i1 = i10;
  do {
   i1 = i1 + -40 | 0;
   i11 = i26;
   i12 = i13;
   i14 = i11 + 40 | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    i11 = i11 + 4 | 0;
    i12 = i12 + 4 | 0;
   } while ((i11 | 0) < (i14 | 0));
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i13 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP16[i13 + 32 >> 1] = HEAP16[i1 + 32 >> 1] | 0;
   HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
   HEAP16[i1 + 32 >> 1] = HEAP16[i26 + 32 >> 1] | 0;
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIR19ROSorterReplacementP17RODataReplacementEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i13, i1, i25, i2, i13);
  } while ((i2 | 0) > 1);
  STACKTOP = i27;
  return;
 }
 if (!(i13 >>> 0 < i10 >>> 0 & (i1 | 0) > 40)) {
  STACKTOP = i27;
  return;
 }
 i7 = i13;
 do {
  L50 : do if (i7 >>> 0 > i13 >>> 0) {
   i8 = i7;
   do {
    i9 = i8;
    i8 = i8 + -40 | 0;
    i1 = HEAP32[i9 + 28 >> 2] | 0;
    i2 = HEAP32[i9 + -12 >> 2] | 0;
    do if ((i1 | 0) == (i2 | 0)) {
     i2 = i9;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     i4 = i8;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
      i5 = HEAP16[i9 + 32 >> 1] | 0;
      i6 = HEAP16[i9 + -8 >> 1] | 0;
      if (i5 << 16 >> 16 != i6 << 16 >> 16) if ((i5 & 65535) > (i6 & 65535)) break; else break L50;
     }
     if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) break L50;
    } else if (i1 >>> 0 >= i2 >>> 0) break L50; while (0);
    i11 = i26;
    i12 = i9;
    i14 = i11 + 40 | 0;
    do {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     i11 = i11 + 4 | 0;
     i12 = i12 + 4 | 0;
    } while ((i11 | 0) < (i14 | 0));
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    HEAP32[i9 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
    HEAP16[i9 + 32 >> 1] = HEAP16[i8 + 32 >> 1] | 0;
    HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
    HEAP32[i8 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
    HEAP32[i8 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
    HEAP32[i8 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
    HEAP16[i8 + 32 >> 1] = HEAP16[i26 + 32 >> 1] | 0;
   } while (i8 >>> 0 > i13 >>> 0);
  } while (0);
  i7 = i7 + 40 | 0;
 } while (i7 >>> 0 < i10 >>> 0);
 STACKTOP = i27;
 return;
}

function __ZN19SkinnedMeshRenderer19UpdateTransformInfoEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 168 | 0;
 i15 = i20 + 152 | 0;
 i16 = i20 + 136 | 0;
 i4 = i20 + 64 | 0;
 i17 = i20;
 i18 = i20 + 72 | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 + 380 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i19, i1, i15);
   i2 = HEAP32[i19 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 9;
  }
 }
 if ((i13 | 0) == 6) i13 = 9;
 if ((i13 | 0) == 9) i1 = __ZN8Renderer12GetTransformEv(i14) | 0;
 __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(i1, i15, i16);
 __ZN9Transform18GetTransformAccessEv(i17, i1);
 i11 = i17;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = i3;
 HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i12 = __Z31CalculateHierarchyTransformType23TransformAccessReadOnly(i19) | 0;
 i3 = i14 + 36 | 0;
 i11 = i14 + 356 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i4 = 1;
  i13 = 14;
 } else if (!(HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 176 >> 2] | 0)) if ((HEAP32[i14 + 504 >> 2] | 0) != 0 | (i12 | 0) == 0) {
  i4 = 0;
  i13 = 14;
 } else {
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i3);
  HEAP32[i14 + 212 >> 2] = i12;
  i2 = 0;
  i4 = 0;
  i3 = HEAP32[i14 + 464 >> 2] | 0;
  i13 = 15;
 } else {
  i4 = 1;
  i13 = 14;
 }
 if ((i13 | 0) == 14) {
  HEAP32[i14 + 212 >> 2] = i12 & 4;
  __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i3, i15, i16);
  i8 = (i12 | 0) != 0;
  i3 = HEAP32[i14 + 464 >> 2] | 0;
  if ((i3 & 255) << 24 >> 24 == 0 | i4 ^ 1) {
   i2 = i8;
   i13 = 15;
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) i9 = 0; else i9 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 156 >> 2] | 0;
   HEAP32[i19 >> 2] = 0;
   i10 = i19 + 4 | 0;
   i6 = gb + 63160 | 0;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i10;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = i7;
   i2 = i9 << 6;
   do if (!i2) {
    i3 = 0;
    i2 = 0;
   } else {
    i5 = (i2 | 4) + -1 | 0;
    if (i5 >>> 0 < 2e3) {
     i3 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     i2 = 0;
     break;
    } else {
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, gb + 64016 | 0, 0, gb + 429036 | 0, 1295) | 0;
     i7 = gb + 64016 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     HEAP32[i19 >> 2] = i2;
     i3 = i10;
     HEAP32[i3 >> 2] = i6;
     HEAP32[i3 + 4 >> 2] = i7;
     i3 = i2;
     break;
    }
   } while (0);
   i7 = i3 + 3 & -4;
   HEAP32[i17 >> 2] = HEAP32[gb + 62500 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
   f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
   f22 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f21 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   i3 = i17 + 12 | 0;
   HEAPF32[i3 >> 2] = f23;
   i5 = i17 + 16 | 0;
   HEAPF32[i5 >> 2] = f22;
   i6 = i17 + 20 | 0;
   HEAPF32[i6 >> 2] = f21;
   do if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i14, i7, i9) | 0) {
    if (!(__ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB(i14, i7, i9, i17) | 0)) {
     i2 = HEAP32[i19 >> 2] | 0;
     break;
    }
    f21 = Math_fround(HEAPF32[i17 >> 2]);
    f29 = Math_fround(HEAPF32[i3 >> 2]);
    f26 = Math_fround(f21 + f29);
    f22 = Math_fround(HEAPF32[i17 + 4 >> 2]);
    f28 = Math_fround(HEAPF32[i5 >> 2]);
    f25 = Math_fround(f22 + f28);
    f23 = Math_fround(HEAPF32[i17 + 8 >> 2]);
    f27 = Math_fround(HEAPF32[i6 >> 2]);
    f25 = Math_fround(f25 * Math_fround(.5));
    f24 = Math_fround(Math_fround(f23 + f27) * Math_fround(.5));
    f21 = Math_fround(Math_fround(f29 - f21) * Math_fround(.5));
    f22 = Math_fround(Math_fround(f28 - f22) * Math_fround(.5));
    f23 = Math_fround(Math_fround(f27 - f23) * Math_fround(.5));
    HEAPF32[i14 + 164 >> 2] = Math_fround(f26 * Math_fround(.5));
    HEAPF32[i14 + 168 >> 2] = f25;
    HEAPF32[i14 + 172 >> 2] = f24;
    HEAPF32[i14 + 176 >> 2] = f21;
    HEAPF32[i14 + 180 >> 2] = f22;
    HEAPF32[i14 + 184 >> 2] = f23;
    __Z20InverseTransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i14 + 164 | 0, i15, i16, i14 + 188 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i10);
    STACKTOP = i20;
    return;
   } while (0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
   i2 = i14 + 466 | 0;
   i7 = i2;
   i2 = HEAP8[i2 >> 0] | 0;
   i6 = i4;
  }
 }
 if ((i13 | 0) == 15) {
  i8 = i2;
  i7 = i14 + 466 | 0;
  i2 = i3 >>> 16 & 255;
  i6 = i4;
 }
 if (i2 << 24 >> 24) {
  HEAP32[i19 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f27 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f28 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f29 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i3 = i19 + 12 | 0;
  HEAPF32[i3 >> 2] = f27;
  i4 = i19 + 16 | 0;
  HEAPF32[i4 >> 2] = f28;
  i5 = i19 + 20 | 0;
  HEAPF32[i5 >> 2] = f29;
  if (i6) i13 = 31; else {
   i2 = HEAP32[i11 >> 2] | 0;
   if (!i2) i13 = 31; else {
    i10 = i2 + 48 | 0;
    i11 = i14 + 436 | 0;
    HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    HEAP8[i7 >> 0] = 0;
   }
  }
  do if ((i13 | 0) == 31) if (__ZN19SkinnedMeshRenderer29CalculateRootLocalSpaceBoundsER10MinMaxAABB(i14, i19) | 0) {
   f27 = Math_fround(HEAPF32[i19 >> 2]);
   f21 = Math_fround(HEAPF32[i3 >> 2]);
   f24 = Math_fround(f27 + f21);
   f28 = Math_fround(HEAPF32[i19 + 4 >> 2]);
   f22 = Math_fround(HEAPF32[i4 >> 2]);
   f25 = Math_fround(f28 + f22);
   f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i5 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.5));
   f26 = Math_fround(Math_fround(f29 + f23) * Math_fround(.5));
   f27 = Math_fround(Math_fround(f21 - f27) * Math_fround(.5));
   f28 = Math_fround(Math_fround(f22 - f28) * Math_fround(.5));
   f29 = Math_fround(Math_fround(f23 - f29) * Math_fround(.5));
   HEAPF32[i14 + 436 >> 2] = Math_fround(f24 * Math_fround(.5));
   HEAPF32[i14 + 440 >> 2] = f25;
   HEAPF32[i14 + 444 >> 2] = f26;
   HEAPF32[i14 + 448 >> 2] = f27;
   HEAPF32[i14 + 452 >> 2] = f28;
   HEAPF32[i14 + 456 >> 2] = f29;
   HEAP8[i7 >> 0] = 0;
   break;
  } else {
   i13 = i14 + 436 | 0;
   i11 = i17 + 12 | 0;
   HEAP32[i17 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   break;
  } while (0);
 }
 i2 = i14 + 188 | 0;
 i3 = i14 + 436 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 if (!i12) {
  __Z13TransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i2, i15, i16, i14 + 164 | 0);
  STACKTOP = i20;
  return;
 }
 __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i19);
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i2, i19, i14 + 164 | 0);
 if (i8) {
  __ZN10Matrix4x4f12SetTRInverseERK8Vector3fRK11Quaternionf(i17, i15, i16);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i17, i19, i18);
  __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i3, i18, i2);
 }
 STACKTOP = i20;
 return;
}

function __Z14b2TimeOfImpactP11b2TOIOutputPK10b2TOIInput(i51, i40) {
 i51 = i51 | 0;
 i40 = i40 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i53 = i55 + 312 | 0;
 i44 = i55 + 276 | 0;
 i45 = i55 + 240 | 0;
 i46 = i55 + 228 | 0;
 i47 = i55 + 136 | 0;
 i48 = i55 + 112 | 0;
 i49 = i55 + 8 | 0;
 i50 = i55 + 4 | 0;
 i41 = i55;
 HEAP32[gb + 1457484 >> 2] = (HEAP32[gb + 1457484 >> 2] | 0) + 1;
 HEAP32[i51 >> 2] = 0;
 i42 = HEAP32[i40 + 128 >> 2] | 0;
 i52 = i51 + 4 | 0;
 HEAP32[i52 >> 2] = i42;
 i43 = i40 + 28 | 0;
 i1 = i44;
 i3 = i40 + 56 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 i1 = i45;
 i3 = i40 + 92 | 0;
 i4 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 i21 = i44 + 24 | 0;
 f7 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(Math_fround(Math_floor(Math_fround(f7 / Math_fround(6.28318548)))) * Math_fround(6.28318548));
 f7 = Math_fround(f7 - f8);
 HEAPF32[i21 >> 2] = f7;
 i22 = i44 + 28 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f8);
 HEAPF32[i22 >> 2] = f8;
 i23 = i45 + 24 | 0;
 f5 = Math_fround(HEAPF32[i23 >> 2]);
 f6 = Math_fround(Math_fround(Math_floor(Math_fround(f5 / Math_fround(6.28318548)))) * Math_fround(6.28318548));
 f5 = Math_fround(f5 - f6);
 HEAPF32[i23 >> 2] = f5;
 i24 = i45 + 28 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f6);
 HEAPF32[i24 >> 2] = f6;
 f25 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(HEAPF32[i40 + 24 >> 2]);
 f26 = Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i40 + 52 >> 2])) + Math_fround(-.0149999997));
 i27 = f26 < Math_fround(.00499999989);
 f26 = i27 ? Math_fround(.00499999989) : f26;
 HEAP16[i46 + 4 >> 1] = 0;
 HEAP32[i47 >> 2] = HEAP32[i40 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
 HEAP32[i47 + 16 >> 2] = HEAP32[i40 + 16 >> 2];
 HEAP32[i47 + 20 >> 2] = HEAP32[i40 + 20 >> 2];
 HEAP32[i47 + 24 >> 2] = HEAP32[i40 + 24 >> 2];
 i27 = i47 + 28 | 0;
 HEAP32[i27 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[i43 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[i43 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[i43 + 24 >> 2];
 HEAP8[i47 + 88 >> 0] = 0;
 i27 = i44 + 8 | 0;
 i28 = i44 + 12 | 0;
 i29 = i44 + 16 | 0;
 i30 = i44 + 20 | 0;
 i31 = i44 + 4 | 0;
 i32 = i45 + 8 | 0;
 i33 = i45 + 12 | 0;
 i34 = i45 + 16 | 0;
 i35 = i45 + 20 | 0;
 i36 = i45 + 4 | 0;
 i14 = i47 + 56 | 0;
 i16 = i47 + 60 | 0;
 i18 = i47 + 64 | 0;
 i20 = i47 + 68 | 0;
 i13 = i47 + 72 | 0;
 i15 = i47 + 76 | 0;
 i17 = i47 + 80 | 0;
 i19 = i47 + 84 | 0;
 i37 = i48 + 16 | 0;
 f38 = Math_fround(f26 + Math_fround(.00124999997));
 f39 = Math_fround(f26 + Math_fround(-.00124999997));
 f2 = Math_fround(0.0);
 i1 = 0;
 while (1) {
  f11 = Math_fround(Math_fround(1.0) - f2);
  f9 = Math_fround(f11 * Math_fround(HEAPF32[i27 >> 2]));
  f58 = Math_fround(f11 * Math_fround(HEAPF32[i28 >> 2]));
  f59 = Math_fround(f2 * Math_fround(HEAPF32[i29 >> 2]));
  f59 = Math_fround(f9 + f59);
  f58 = Math_fround(f58 + Math_fround(f2 * Math_fround(HEAPF32[i30 >> 2])));
  f8 = Math_fround(Math_fround(f11 * f7) + Math_fround(f2 * f8));
  f7 = Math_fround(+Math_sin(+f8));
  f8 = Math_fround(+Math_cos(+f8));
  f9 = Math_fround(HEAPF32[i44 >> 2]);
  f57 = Math_fround(f8 * f9);
  f56 = Math_fround(HEAPF32[i31 >> 2]);
  f57 = Math_fround(f59 - Math_fround(f57 - Math_fround(f7 * f56)));
  f56 = Math_fround(f58 - Math_fround(Math_fround(f7 * f9) + Math_fround(f8 * f56)));
  f9 = Math_fround(f11 * Math_fround(HEAPF32[i32 >> 2]));
  f58 = Math_fround(f11 * Math_fround(HEAPF32[i33 >> 2]));
  f59 = Math_fround(f2 * Math_fround(HEAPF32[i34 >> 2]));
  f59 = Math_fround(f9 + f59);
  f58 = Math_fround(f58 + Math_fround(f2 * Math_fround(HEAPF32[i35 >> 2])));
  f5 = Math_fround(Math_fround(f11 * f5) + Math_fround(f2 * f6));
  f11 = Math_fround(+Math_sin(+f5));
  f5 = Math_fround(+Math_cos(+f5));
  f6 = Math_fround(HEAPF32[i45 >> 2]);
  f9 = Math_fround(f5 * f6);
  f10 = Math_fround(HEAPF32[i36 >> 2]);
  f9 = Math_fround(f59 - Math_fround(f9 - Math_fround(f11 * f10)));
  f10 = Math_fround(f58 - Math_fround(Math_fround(f11 * f6) + Math_fround(f5 * f10)));
  HEAPF32[i14 >> 2] = f57;
  HEAPF32[i16 >> 2] = f56;
  HEAPF32[i18 >> 2] = f7;
  HEAPF32[i20 >> 2] = f8;
  HEAPF32[i13 >> 2] = f9;
  HEAPF32[i15 >> 2] = f10;
  HEAPF32[i17 >> 2] = f11;
  HEAPF32[i19 >> 2] = f5;
  __Z10b2DistanceP16b2DistanceOutputP14b2SimplexCachePK15b2DistanceInput(i48, i46, i47);
  f5 = Math_fround(HEAPF32[i37 >> 2]);
  if (f5 <= Math_fround(0.0)) {
   f2 = Math_fround(0.0);
   i3 = 2;
   i54 = 21;
   break;
  }
  if (f5 < f38) {
   i3 = 3;
   i54 = 21;
   break;
  }
  Math_fround(__ZN20b2SeparationFunction10InitializeEPK14b2SimplexCachePK15b2DistanceProxyRK7b2SweepS5_S8_f(i49, i46, i40, i44, i43, i45, f2));
  f5 = Math_fround(__ZNK20b2SeparationFunction17FindMinSeparationEPiS0_f(i49, i50, i41, f25));
  L5 : do if (f5 > f38) i54 = 5; else {
   i12 = 0;
   f11 = f25;
   while (1) {
    if (f5 > f39) {
     f2 = f11;
     i3 = 0;
     break L5;
    }
    f6 = Math_fround(__ZNK20b2SeparationFunction8EvaluateEiif(i49, HEAP32[i50 >> 2] | 0, HEAP32[i41 >> 2] | 0, f2));
    if (f6 < f39) {
     i54 = 8;
     break;
    }
    if (!(f6 <= f38)) {
     f9 = f11;
     f10 = f2;
     i3 = 0;
     f8 = f6;
    } else {
     i54 = 10;
     break;
    }
    while (1) {
     if (!(i3 & 1)) f6 = Math_fround(Math_fround(f10 + f9) * Math_fround(.5)); else f6 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f26 - f8) * Math_fround(f9 - f10)) / Math_fround(f5 - f8)));
     i3 = i3 + 1 | 0;
     HEAP32[gb + 1457496 >> 2] = (HEAP32[gb + 1457496 >> 2] | 0) + 1;
     f7 = Math_fround(__ZNK20b2SeparationFunction8EvaluateEiif(i49, HEAP32[i50 >> 2] | 0, HEAP32[i41 >> 2] | 0, f6));
     f58 = Math_fround(f7 - f26);
     i4 = f58 > Math_fround(0.0);
     f59 = Math_fround(-f58);
     if ((i4 ? f58 : f59) < Math_fround(.00124999997)) break;
     i4 = f7 > f26;
     if ((i3 | 0) == 50) {
      f6 = f11;
      i3 = 50;
      break;
     } else {
      f9 = i4 ? f9 : f6;
      f10 = i4 ? f6 : f10;
      f8 = i4 ? f7 : f8;
      f5 = i4 ? f5 : f7;
     }
    }
    i4 = HEAP32[gb + 1457500 >> 2] | 0;
    HEAP32[gb + 1457500 >> 2] = (i4 | 0) > (i3 | 0) ? i4 : i3;
    i12 = i12 + 1 | 0;
    if ((i12 | 0) == 8) {
     i3 = 0;
     break L5;
    }
    f5 = Math_fround(__ZNK20b2SeparationFunction17FindMinSeparationEPiS0_f(i49, i50, i41, f6));
    if (f5 > f38) {
     i54 = 5;
     break L5;
    } else f11 = f6;
   }
   if ((i54 | 0) == 8) {
    i54 = 0;
    HEAP32[i51 >> 2] = 1;
    HEAPF32[i52 >> 2] = f2;
    i3 = 1;
    break;
   } else if ((i54 | 0) == 10) {
    i54 = 0;
    HEAP32[i51 >> 2] = 3;
    HEAPF32[i52 >> 2] = f2;
    i3 = 1;
    break;
   }
  } while (0);
  if ((i54 | 0) == 5) {
   i54 = 0;
   HEAP32[i51 >> 2] = 4;
   HEAP32[i52 >> 2] = i42;
   i3 = 1;
  }
  i1 = i1 + 1 | 0;
  HEAP32[gb + 1457488 >> 2] = (HEAP32[gb + 1457488 >> 2] | 0) + 1;
  if (i3) break;
  if ((i1 | 0) == 20) {
   i54 = 20;
   break;
  }
  f7 = Math_fround(HEAPF32[i21 >> 2]);
  f8 = Math_fround(HEAPF32[i22 >> 2]);
  f5 = Math_fround(HEAPF32[i23 >> 2]);
  f6 = Math_fround(HEAPF32[i24 >> 2]);
 }
 if ((i54 | 0) == 20) {
  HEAP32[i51 >> 2] = 1;
  HEAPF32[i52 >> 2] = f2;
  i1 = 20;
 } else if ((i54 | 0) == 21) {
  HEAP32[i51 >> 2] = i3;
  HEAPF32[i52 >> 2] = f2;
  i54 = i1;
  i52 = HEAP32[gb + 1457492 >> 2] | 0;
  i51 = (i52 | 0) > (i54 | 0);
  i54 = i51 ? i52 : i54;
  HEAP32[gb + 1457492 >> 2] = i54;
  f58 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i53));
  f59 = Math_fround(HEAPF32[gb + 1457480 >> 2]);
  i54 = f59 > f58;
  f59 = i54 ? f59 : f58;
  HEAPF32[gb + 1457480 >> 2] = f59;
  f59 = Math_fround(HEAPF32[gb + 1457476 >> 2]);
  f59 = Math_fround(f58 + f59);
  HEAPF32[gb + 1457476 >> 2] = f59;
  STACKTOP = i55;
  return;
 }
 i54 = i1;
 i52 = HEAP32[gb + 1457492 >> 2] | 0;
 i51 = (i52 | 0) > (i54 | 0);
 i54 = i51 ? i52 : i54;
 HEAP32[gb + 1457492 >> 2] = i54;
 f58 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i53));
 f59 = Math_fround(HEAPF32[gb + 1457480 >> 2]);
 i54 = f59 > f58;
 f59 = i54 ? f59 : f58;
 HEAPF32[gb + 1457480 >> 2] = f59;
 f59 = Math_fround(HEAPF32[gb + 1457476 >> 2]);
 f59 = Math_fround(f58 + f59);
 HEAPF32[gb + 1457476 >> 2] = f59;
 STACKTOP = i55;
 return;
}

function __ZN5physx21PxcContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i2, i12, i32, i3, i54, i1, i53) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i32 = i32 | 0;
 i3 = i3 | 0;
 i54 = i54 | 0;
 i1 = i1 | 0;
 i53 = i53 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, i52 = 0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i52;
 i41 = HEAP32[i12 + 36 >> 2] | 0;
 i40 = (HEAP32[i41 + 40 >> 2] | 0) + ((HEAPU8[i41 + 39 >> 0] | 0) * 20 | 0) | 0;
 i41 = HEAPU8[i41 + 38 >> 0] | 0;
 f25 = Math_fround(-Math_fround(HEAPF32[i32 >> 2]));
 i29 = i32 + 4 | 0;
 f28 = Math_fround(-Math_fround(HEAPF32[i29 >> 2]));
 i30 = i32 + 8 | 0;
 f21 = Math_fround(-Math_fround(HEAPF32[i30 >> 2]));
 i31 = i32 + 12 | 0;
 f46 = Math_fround(HEAPF32[i31 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 i36 = i32 + 16 | 0;
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i36 >> 2]));
 f27 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 i37 = i32 + 20 | 0;
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i37 >> 2]));
 f45 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 i38 = i32 + 24 | 0;
 f22 = Math_fround(f22 * Math_fround(2.0));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f45 - Math_fround(HEAPF32[i38 >> 2])) * Math_fround(2.0));
 f48 = Math_fround(Math_fround(f46 * f46) + Math_fround(-.5));
 f51 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f27 * f28)) + Math_fround(f45 * f21));
 f49 = Math_fround(Math_fround(f51 * f25) + Math_fround(Math_fround(f48 * f22) + Math_fround(f46 * Math_fround(Math_fround(f45 * f28) - Math_fround(f27 * f21)))));
 f50 = Math_fround(Math_fround(f51 * f28) + Math_fround(Math_fround(f48 * f27) + Math_fround(f46 * Math_fround(Math_fround(f22 * f21) - Math_fround(f45 * f25)))));
 f51 = Math_fround(Math_fround(Math_fround(f48 * f45) + Math_fround(f46 * Math_fround(Math_fround(f27 * f25) - Math_fround(f22 * f28)))) + Math_fround(f51 * f21));
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(f46 * f22);
 f45 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f45 * f25));
 f48 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f48 * f28));
 f24 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f27 = Math_fround(f27 - Math_fround(f24 * f21));
 f47 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f45 * f28) + Math_fround(f46 * f24))) - Math_fround(f48 * f25));
 f20 = Math_fround(Math_fround(Math_fround(f24 * f25) + Math_fround(Math_fround(f45 * f21) + Math_fround(f46 * f48))) - Math_fround(f22 * f28));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f46 * f45) - Math_fround(f22 * f25)) - Math_fround(f24 * f28)) - Math_fround(f48 * f21));
 f48 = Math_fround(f27 + f27);
 f28 = Math_fround(f47 + f47);
 f24 = Math_fround(f20 + f20);
 f25 = Math_fround(f48 * f21);
 f22 = Math_fround(f21 * f28);
 f21 = Math_fround(f21 * f24);
 f45 = Math_fround(f27 * f28);
 f46 = Math_fround(f27 * f24);
 f28 = Math_fround(f47 * f28);
 f47 = Math_fround(f47 * f24);
 f24 = Math_fround(f20 * f24);
 f20 = Math_fround(Math_fround(Math_fround(1.0) - f28) - f24);
 f23 = Math_fround(f21 + f45);
 f26 = Math_fround(f46 - f22);
 f21 = Math_fround(f45 - f21);
 f48 = Math_fround(Math_fround(1.0) - Math_fround(f27 * f48));
 f24 = Math_fround(f48 - f24);
 f27 = Math_fround(f25 + f47);
 f22 = Math_fround(f46 + f22);
 f25 = Math_fround(f47 - f25);
 f28 = Math_fround(f48 - f28);
 i1 = i12 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i12 + 8 >> 2]) == Math_fround(1.0)) i7 = Math_fround(HEAPF32[i12 + 12 >> 2]) == Math_fround(1.0); else i7 = 0; else i7 = 0;
 HEAP32[i8 >> 2] = 1065353216;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i4 = i8 + 16 | 0;
 HEAP32[i4 >> 2] = 1065353216;
 i5 = i8 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 i6 = i8 + 28 | 0;
 HEAP32[i6 >> 2] = 0;
 i17 = i8 + 32 | 0;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1065353216;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1065353216;
 if (i7) {
  f9 = Math_fround(1.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(1.0);
  f15 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f19 = Math_fround(0.0);
  f16 = Math_fround(1.0);
 } else {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i8, i1, i12 + 16 | 0);
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f13 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  f15 = Math_fround(HEAPF32[i5 >> 2]);
  f18 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f19 = Math_fround(HEAPF32[i6 >> 2]);
  f16 = Math_fround(HEAPF32[i17 >> 2]);
 }
 f47 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f21 * f10)) + Math_fround(f22 * f11));
 f48 = Math_fround(Math_fround(Math_fround(f23 * f9) + Math_fround(f24 * f10)) + Math_fround(f25 * f11));
 f44 = Math_fround(Math_fround(Math_fround(f26 * f9) + Math_fround(f27 * f10)) + Math_fround(f28 * f11));
 f45 = Math_fround(Math_fround(Math_fround(f20 * f13) + Math_fround(f21 * f14)) + Math_fround(f22 * f15));
 f46 = Math_fround(Math_fround(Math_fround(f23 * f13) + Math_fround(f24 * f14)) + Math_fround(f25 * f15));
 f43 = Math_fround(Math_fround(Math_fround(f26 * f13) + Math_fround(f27 * f14)) + Math_fround(f28 * f15));
 f42 = Math_fround(Math_fround(Math_fround(f20 * f18) + Math_fround(f21 * f19)) + Math_fround(f22 * f16));
 f39 = Math_fround(Math_fround(Math_fround(f23 * f18) + Math_fround(f24 * f19)) + Math_fround(f25 * f16));
 f35 = Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f27 * f19)) + Math_fround(f28 * f16));
 f27 = Math_fround(HEAPF32[i32 >> 2]);
 f21 = Math_fround(f27 + f27);
 f20 = Math_fround(HEAPF32[i29 >> 2]);
 f34 = Math_fround(f20 + f20);
 f22 = Math_fround(HEAPF32[i30 >> 2]);
 f26 = Math_fround(f22 + f22);
 f25 = Math_fround(HEAPF32[i31 >> 2]);
 f33 = Math_fround(f21 * f25);
 f28 = Math_fround(f34 * f25);
 f25 = Math_fround(f25 * f26);
 f16 = Math_fround(f27 * f34);
 f15 = Math_fround(f27 * f26);
 f34 = Math_fround(f20 * f34);
 f20 = Math_fround(f20 * f26);
 f26 = Math_fround(f22 * f26);
 f22 = Math_fround(Math_fround(Math_fround(1.0) - f34) - f26);
 f23 = Math_fround(f16 + f25);
 f24 = Math_fround(f15 - f28);
 f25 = Math_fround(f16 - f25);
 f21 = Math_fround(Math_fround(1.0) - Math_fround(f27 * f21));
 f26 = Math_fround(f21 - f26);
 f27 = Math_fround(f20 + f33);
 f28 = Math_fround(f15 + f28);
 f33 = Math_fround(f20 - f33);
 f34 = Math_fround(f21 - f34);
 f21 = Math_fround(HEAPF32[i36 >> 2]);
 f20 = Math_fround(HEAPF32[i37 >> 2]);
 f15 = Math_fround(HEAPF32[i38 >> 2]);
 f16 = Math_fround(-f22);
 f18 = Math_fround(-f23);
 f19 = Math_fround(-f24);
 i6 = i53 + 4096 | 0;
 i3 = i40;
 i2 = i41;
 i1 = 0;
 L8 : while (1) {
  f13 = Math_fround(HEAPF32[i54 >> 2]);
  i4 = i3;
  while (1) {
   i5 = i2 + -1 | 0;
   if (!i2) break L8;
   i3 = i4 + 12 | 0;
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f11 = Math_fround(f47 * f14);
   f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f45 * f10));
   f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f11 = Math_fround(f49 + Math_fround(f11 + Math_fround(f42 * f9)));
   if (!(f11 <= f13)) {
    i4 = i3;
    i2 = i5;
   } else {
    i2 = i5;
    break;
   }
  }
  f13 = Math_fround(f50 + Math_fround(Math_fround(Math_fround(f48 * f14) + Math_fround(f46 * f10)) + Math_fround(f39 * f9)));
  f9 = Math_fround(f51 + Math_fround(Math_fround(Math_fround(f44 * f14) + Math_fround(f43 * f10)) + Math_fround(f35 * f9)));
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 >>> 0 > 63) {
   i1 = 1;
   continue;
  }
  HEAP32[i6 >> 2] = i1 + 1;
  HEAPF32[i53 + (i1 << 6) >> 2] = f16;
  HEAPF32[i53 + (i1 << 6) + 4 >> 2] = f18;
  HEAPF32[i53 + (i1 << 6) + 8 >> 2] = f19;
  f10 = Math_fround(f20 + Math_fround(Math_fround(f33 * f9) + Math_fround(Math_fround(f23 * f11) + Math_fround(f26 * f13))));
  f14 = Math_fround(f15 + Math_fround(Math_fround(f34 * f9) + Math_fround(Math_fround(f24 * f11) + Math_fround(f27 * f13))));
  HEAPF32[i53 + (i1 << 6) + 16 >> 2] = Math_fround(f21 + Math_fround(Math_fround(f28 * f9) + Math_fround(Math_fround(f22 * f11) + Math_fround(f25 * f13))));
  HEAPF32[i53 + (i1 << 6) + 20 >> 2] = f10;
  HEAPF32[i53 + (i1 << 6) + 24 >> 2] = f14;
  HEAPF32[i53 + (i1 << 6) + 12 >> 2] = f11;
  HEAP32[i53 + (i1 << 6) + 48 >> 2] = -1;
  HEAP32[i53 + (i1 << 6) + 52 >> 2] = -1;
  i1 = 1;
 }
 STACKTOP = i52;
 return i1 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 40 | 0;
 i9 = i12 + 20 | 0;
 i8 = i12;
 L1 : do if ((i1 | 0) != (i3 | 0)) {
  L3 : do switch (HEAP8[i1 >> 0] | 0) {
  case 84:
   {
    i6 = i10 + 4 | 0;
    i5 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0) / 24 | 0;
    i7 = __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i10) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i4 = (i2 - (HEAP32[i10 >> 2] | 0) | 0) / 24 | 0;
    if (!((i7 | 0) != (i1 | 0) & (i4 | 0) == (i5 + 1 | 0))) while (1) {
     if ((i4 | 0) == (i5 | 0)) break L1;
     i3 = i2 + -24 | 0;
     while (1) {
      if ((i2 | 0) == (i3 | 0)) break;
      i11 = i2 + -24 | 0;
      HEAP32[i6 >> 2] = i11;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
      i2 = HEAP32[i6 >> 2] | 0;
     }
     i4 = i4 + -1 | 0;
     i2 = i3;
    }
    i5 = i10 + 16 | 0;
    HEAP32[i9 >> 2] = HEAP32[i10 + 12 >> 2];
    __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i11, i2 + -24 | 0, i9);
    i1 = i10 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i10 + 24 >> 2] | 0;
    i4 = i9;
    do if (i2 >>> 0 < i9 >>> 0) {
     HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
     i10 = i11 + 4 | 0;
     HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
     i9 = i11 + 8 | 0;
     HEAP32[i2 + 8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
    } else {
     i3 = HEAP32[i5 >> 2] | 0;
     i1 = i2 - i3 >> 4;
     i2 = i1 + 1 | 0;
     if (i2 >>> 0 > 268435455) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i5 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
      break L3;
     } else {
      i6 = i4 - i3 | 0;
      i9 = i6 >> 3;
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i8, i6 >> 4 >>> 0 < 134217727 ? (i9 >>> 0 < i2 >>> 0 ? i2 : i9) : 268435455, i1, i10 + 28 | 0);
      i10 = i8 + 8 | 0;
      i9 = HEAP32[i10 >> 2] | 0;
      HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
      i6 = i11 + 4 | 0;
      HEAP32[i9 + 4 >> 2] = HEAP32[i6 >> 2];
      i4 = i11 + 8 | 0;
      HEAP32[i9 + 8 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = 0;
      HEAP32[i6 >> 2] = 0;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i10 >> 2] = i9 + 16;
      __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i8);
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i8);
      break;
     }
    } while (0);
    __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
    i1 = i7;
    break L1;
   }
  case 68:
   {
    i6 = __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i10) | 0;
    if ((i6 | 0) == (i1 | 0)) break L1;
    i2 = HEAP32[i10 + 4 >> 2] | 0;
    if ((HEAP32[i10 >> 2] | 0) == (i2 | 0)) break L1;
    i5 = i10 + 16 | 0;
    HEAP32[i8 >> 2] = HEAP32[i10 + 12 >> 2];
    __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i11, i2 + -24 | 0, i8);
    i1 = i10 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i10 + 24 >> 2] | 0;
    i4 = i8;
    do if (i2 >>> 0 < i8 >>> 0) {
     HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
     i10 = i11 + 4 | 0;
     HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
     i9 = i11 + 8 | 0;
     HEAP32[i2 + 8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
    } else {
     i3 = HEAP32[i5 >> 2] | 0;
     i1 = i2 - i3 >> 4;
     i2 = i1 + 1 | 0;
     if (i2 >>> 0 > 268435455) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i5 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
      break L3;
     } else {
      i7 = i4 - i3 | 0;
      i8 = i7 >> 3;
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i9, i7 >> 4 >>> 0 < 134217727 ? (i8 >>> 0 < i2 >>> 0 ? i2 : i8) : 268435455, i1, i10 + 28 | 0);
      i10 = i9 + 8 | 0;
      i8 = HEAP32[i10 >> 2] | 0;
      HEAP32[i8 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      i7 = i11 + 4 | 0;
      HEAP32[i8 + 4 >> 2] = HEAP32[i7 >> 2];
      i4 = i11 + 8 | 0;
      HEAP32[i8 + 8 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i10 >> 2] = i8 + 16;
      __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i9);
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i9);
      break;
     }
    } while (0);
    __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i11);
    i1 = i6;
    break L1;
   }
  case 83:
   {
    i2 = __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i10) | 0;
    if ((i2 | 0) != (i1 | 0)) {
     i1 = i2;
     break L1;
    }
    if ((i3 - i1 | 0) <= 2) break L1;
    if ((HEAP8[i1 + 1 >> 0] | 0) != 116) break L1;
    i7 = i1 + 2 | 0;
    i6 = __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_(i7, i3, i10) | 0;
    if ((i6 | 0) == (i7 | 0)) break L1;
    i3 = i10 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i10 >> 2] | 0) == (i2 | 0)) break L1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i2 + -24 | 0, 0, gb + 1086591 | 0) | 0;
    i5 = i10 + 16 | 0;
    i1 = (HEAP32[i3 >> 2] | 0) + -24 | 0;
    HEAP32[i8 >> 2] = HEAP32[i10 + 12 >> 2];
    __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i9, i1, i8);
    i1 = i10 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i10 + 24 >> 2] | 0;
    i4 = i8;
    do if (i2 >>> 0 < i8 >>> 0) {
     HEAP32[i2 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
     i11 = i9 + 4 | 0;
     HEAP32[i2 + 4 >> 2] = HEAP32[i11 >> 2];
     i10 = i9 + 8 | 0;
     HEAP32[i2 + 8 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
    } else {
     i3 = HEAP32[i5 >> 2] | 0;
     i1 = i2 - i3 >> 4;
     i2 = i1 + 1 | 0;
     if (i2 >>> 0 > 268435455) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i5 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
      break L3;
     } else {
      i7 = i4 - i3 | 0;
      i8 = i7 >> 3;
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i11, i7 >> 4 >>> 0 < 134217727 ? (i8 >>> 0 < i2 >>> 0 ? i2 : i8) : 268435455, i1, i10 + 28 | 0);
      i10 = i11 + 8 | 0;
      i8 = HEAP32[i10 >> 2] | 0;
      HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
      i7 = i9 + 4 | 0;
      HEAP32[i8 + 4 >> 2] = HEAP32[i7 >> 2];
      i4 = i9 + 8 | 0;
      HEAP32[i8 + 8 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i4 >> 2] = 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i9 >> 2] = 0;
      HEAP32[i10 >> 2] = i8 + 16;
      __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i5, i11);
      __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i11);
      break;
     }
    } while (0);
    __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
    i1 = i6;
    break L1;
   }
  default:
   break L1;
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN5physxL24PxcSweepCapsuleTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf(i8, i4, i10, i11, i5, i6, f7, i13, i14, i1, i2, i3, i12, f9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 288 | 0;
 i16 = i4 + 272 | 0;
 i21 = i4 + 128 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i53 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i53 + 40 | 0;
 i52 = HEAP32[i8 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i53 + 44 >> 2]);
 f45 = Math_fround(f46 * Math_fround(0.0));
 i53 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 4;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i21 + 128 >> 2] = i52;
 f39 = Math_fround(f45 + Math_fround(0.0));
 HEAPF32[i21 + 96 >> 2] = Math_fround(f46 + Math_fround(0.0));
 HEAPF32[i21 + 100 >> 2] = f39;
 HEAPF32[i21 + 104 >> 2] = f39;
 HEAPF32[i21 + 108 >> 2] = Math_fround(0.0);
 f45 = Math_fround(Math_fround(0.0) - f45);
 HEAPF32[i21 + 112 >> 2] = Math_fround(Math_fround(0.0) - f46);
 HEAPF32[i21 + 116 >> 2] = f45;
 HEAPF32[i21 + 120 >> 2] = f45;
 HEAPF32[i21 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i21 + 16 >> 2] = i52;
 HEAP32[i21 + 32 >> 2] = i52;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = -1;
 HEAP32[i53 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i53 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 i53 = HEAP32[i10 >> 2] | 0;
 i52 = HEAP32[i10 + 4 >> 2] | 0;
 i51 = HEAP32[i10 + 8 >> 2] | 0;
 i50 = HEAP32[i10 + 12 >> 2] | 0;
 i47 = i5 + 16 | 0;
 i49 = HEAP32[i47 >> 2] | 0;
 i48 = HEAP32[i47 + 4 >> 2] | 0;
 i47 = HEAP32[i47 + 8 >> 2] | 0;
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i32 = i6 + 16 | 0;
 f29 = Math_fround(HEAPF32[i32 >> 2]);
 f24 = Math_fround(HEAPF32[i32 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i32 + 8 >> 2]);
 HEAP32[i19 >> 2] = i53;
 i32 = i19 + 4 | 0;
 HEAP32[i32 >> 2] = i52;
 i5 = i19 + 8 | 0;
 HEAP32[i5 >> 2] = i51;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = i50;
 HEAP32[i19 + 16 >> 2] = i49;
 HEAP32[i19 + 20 >> 2] = i48;
 HEAP32[i19 + 24 >> 2] = i47;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f29 - f23);
 f38 = Math_fround(f24 - f25);
 f40 = Math_fround(f26 - f31);
 f41 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f27 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f28 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f30 * Math_fround(Math_fround(f27 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f30 * Math_fround(Math_fround(f38 * f42) - Math_fround(f27 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f30) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f30)));
 f33 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f30)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f30)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f27) + Math_fround(f30 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f28;
 HEAPF32[i20 + 56 >> 2] = f22;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f22 = Math_fround(f36 + f36);
 f28 = Math_fround(f33 + f33);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f33 * f28);
 f37 = Math_fround(f39 * f34);
 f33 = Math_fround(f33 * f22);
 f40 = Math_fround(f39 * f22);
 f30 = Math_fround(f35 * f22);
 f39 = Math_fround(f39 * f28);
 f28 = Math_fround(f35 * f28);
 f34 = Math_fround(f35 * f34);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f22));
 f36 = Math_fround(f33 + f34);
 f35 = Math_fround(f40 - f28);
 f34 = Math_fround(f33 - f34);
 f33 = Math_fround(f22 - f37);
 f27 = Math_fround(f39 + f30);
 f28 = Math_fround(f40 + f28);
 f30 = Math_fround(f39 - f30);
 f22 = Math_fround(f22 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f33;
 HEAPF32[i20 + 24 >> 2] = f27;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f28;
 HEAPF32[i20 + 36 >> 2] = f30;
 HEAPF32[i20 + 40 >> 2] = f22;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(f9 - f23);
 f25 = Math_fround(f22 - f25);
 f31 = Math_fround(f30 - f31);
 f29 = Math_fround(f28 - f29);
 f24 = Math_fround(f27 - f24);
 f26 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) - f26);
 HEAPF32[i18 >> 2] = f29;
 HEAPF32[i18 + 4 >> 2] = f24;
 HEAPF32[i18 + 8 >> 2] = f26;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f29 = Math_fround(f23 - f29);
 f24 = Math_fround(f25 - f24);
 f26 = Math_fround(f31 - f26);
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(HEAPF32[i32 >> 2]);
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f27 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f31) + Math_fround(f24 * f25)) + Math_fround(f26 * f23));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f30) + Math_fround(Math_fround(f24 * f28) - Math_fround(f27 * Math_fround(Math_fround(f29 * f23) - Math_fround(f31 * f26))))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f23 * f30) + Math_fround(Math_fround(f26 * f28) - Math_fround(f27 * Math_fround(Math_fround(f24 * f31) - Math_fround(f29 * f25))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f22;
 HEAPF32[i15 + 8 >> 2] = f9;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i12, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f7)) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i53 = HEAP32[i3 + 4 >> 2] | 0;
 i52 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i53;
 HEAP32[i13 + 8 >> 2] = i52;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i53 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i52;
 HEAP32[i14 + 8 >> 2] = i53;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN14dtNavMeshQuery19updateNeighbourLinkEPK6dtLinkyyPK6dtNode(i24, i1, i2, i3, i15, i16, i23) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i23 = i23 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i27 + 12 | 0;
 i6 = i27;
 i22 = i1;
 i21 = HEAP32[i22 >> 2] | 0;
 i22 = HEAP32[i22 + 4 >> 2] | 0;
 if ((i21 | 0) == 0 & (i22 | 0) == 0 | (i21 | 0) == (i2 | 0) & (i22 | 0) == (i3 | 0)) {
  STACKTOP = i27;
  return;
 }
 i14 = i24 + 64 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i17 = (i21 & 983040 | 0) == 65536 & 0 == 0;
 if (i17) {
  i2 = i21 & 65535;
  if (i2 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
   i26 = _bitshift64Lshr(i21 | 0, i22 | 0, 48) | 0;
   getTempRet0() | 0;
   i1 = HEAP32[i1 + 48 >> 2] | 0;
   if ((i1 + (i2 * 104 | 0) | 0) == 0 ? 1 : (i26 | 0) != (HEAP32[i1 + (i2 * 104 | 0) + 92 >> 2] | 0)) i1 = 0; else i1 = HEAP32[i1 + (i2 * 104 | 0) + 76 >> 2] | 0;
  }
 } else {
  i3 = _bitshift64Lshr(i21 | 0, i22 | 0, 20) | 0;
  getTempRet0() | 0;
  i3 = i3 & 268435455;
  i4 = i21 & 65535;
  if (i3 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   i26 = _bitshift64Lshr(i21 | 0, i22 | 0, 48) | 0;
   getTempRet0() | 0;
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) == (i26 | 0)) {
    i2 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
    if (!i2) i1 = 0; else if (i4 >>> 0 < (HEAP32[i2 + 20 >> 2] | 0) >>> 0) i1 = HEAP32[(HEAP32[i1 + (i3 * 56 | 0) + 16 >> 2] | 0) + (i4 << 5) + 24 >> 2] | 0; else i1 = 0;
   } else i1 = 0;
  } else i1 = 0;
 }
 if (!(HEAP32[i5 + 128 >> 2] & i1)) {
  STACKTOP = i27;
  return;
 }
 i19 = i24 + 76 | 0;
 i26 = __ZN10dtNodePool7getNodeEy(HEAP32[i19 >> 2] | 0, i21, i22) | 0;
 if (!i26) {
  i26 = i24 + 8 | 0;
  HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | 32;
  STACKTOP = i27;
  return;
 }
 i20 = i26 + 20 | 0;
 if ((HEAP32[i20 >> 2] | 0) >>> 0 < 1073741824) {
  if ((__ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_(i24, i15, i16, i21, i22, i18, i6) | 0) < 0) {
   STACKTOP = i27;
   return;
  }
  f10 = Math_fround(HEAPF32[i6 >> 2]);
  f12 = Math_fround(HEAPF32[i18 >> 2]);
  f10 = Math_fround(f10 - f12);
  f11 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f11 = Math_fround(f11 - f13);
  f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f9 = Math_fround(f9 - f7);
  f8 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f9 * f9));
  if (f8 > Math_fround(.0000999999974)) {
   f29 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f12);
   f28 = Math_fround(Math_fround(HEAPF32[i23 + 4 >> 2]) - f13);
   f28 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f29) + Math_fround(f11 * f28)) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i23 + 8 >> 2]) - f7))) / f8);
   i1 = f28 < Math_fround(.0500000007);
   i2 = f28 > Math_fround(.949999988);
   f28 = i2 ? Math_fround(.949999988) : f28;
   f28 = i1 ? Math_fround(.0500000007) : f28;
   f12 = Math_fround(f12 + Math_fround(f10 * f28));
   f8 = Math_fround(f13 + Math_fround(f11 * f28));
   f7 = Math_fround(f7 + Math_fround(f9 * f28));
   HEAPF32[i26 >> 2] = f12;
   i1 = i26 + 4 | 0;
   HEAPF32[i1 >> 2] = f8;
   i2 = i26 + 8 | 0;
   HEAPF32[i2 >> 2] = f7;
   f9 = f12;
  } else {
   HEAPF32[i26 >> 2] = f12;
   i1 = i26 + 4 | 0;
   HEAPF32[i1 >> 2] = f13;
   i2 = i26 + 8 | 0;
   HEAPF32[i2 >> 2] = f7;
   f9 = f12;
   f8 = f13;
  }
  i5 = i1;
 } else {
  f9 = Math_fround(HEAPF32[i26 >> 2]);
  i5 = i26 + 4 | 0;
  f8 = Math_fround(HEAPF32[i5 >> 2]);
  i6 = i26 + 8 | 0;
  i2 = i6;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
 }
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f28 = Math_fround(f9 - Math_fround(HEAPF32[i23 >> 2]));
 f29 = Math_fround(f8 - Math_fround(HEAPF32[i23 + 4 >> 2]));
 f8 = Math_fround(f7 - Math_fround(HEAPF32[i23 + 8 >> 2]));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(f8 * f8))));
 i3 = HEAP32[i24 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 if ((i15 & 983040 | 0) == 65536 & 0 == 0) {
  i1 = i15 & 65535;
  if (i1 >>> 0 > (HEAP32[i3 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
   i15 = _bitshift64Lshr(i15 | 0, i16 | 0, 48) | 0;
   getTempRet0() | 0;
   i16 = HEAP32[i3 + 48 >> 2] | 0;
   i1 = (i15 | 0) == (HEAP32[i16 + (i1 * 104 | 0) + 92 >> 2] | 0) ? i16 + (i1 * 104 | 0) | 0 : 0;
  }
  f7 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  if (!(f7 != Math_fround(-1.0))) f7 = Math_fround(HEAPF32[i4 + ((HEAPU8[i1 + 80 >> 0] | 0) << 2) >> 2]);
 } else {
  i16 = _bitshift64Lshr(i15 | 0, i16 | 0, 20) | 0;
  getTempRet0() | 0;
  f7 = Math_fround(HEAPF32[i4 + ((HEAPU8[(HEAP32[(HEAP32[i3 + 20 >> 2] | 0) + ((i16 & 268435455) * 56 | 0) + 16 >> 2] | 0) + ((i15 & 65535) << 5) + 29 >> 0] | 0) << 2) >> 2]);
 }
 f8 = Math_fround(f10 + Math_fround(f8 * f7));
 i16 = i24 + 32 | 0;
 do if ((i21 | 0) == (HEAP32[i16 >> 2] | 0) ? (i22 | 0) == (HEAP32[i16 + 4 >> 2] | 0) : 0) {
  f28 = Math_fround(Math_fround(HEAPF32[i24 + 52 >> 2]) - f9);
  f29 = Math_fround(HEAPF32[i24 + 56 >> 2]);
  f29 = Math_fround(f29 - Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i24 + 60 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 >> 2]));
  f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(f9 * f9))));
  if (i17) {
   i1 = i21 & 65535;
   if (i1 >>> 0 > (HEAP32[i3 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
    i17 = _bitshift64Lshr(i21 | 0, i22 | 0, 48) | 0;
    getTempRet0() | 0;
    i18 = HEAP32[i3 + 48 >> 2] | 0;
    i1 = (i17 | 0) == (HEAP32[i18 + (i1 * 104 | 0) + 92 >> 2] | 0) ? i18 + (i1 * 104 | 0) | 0 : 0;
   }
   f7 = Math_fround(HEAPF32[i1 + 68 >> 2]);
   if (!(f7 != Math_fround(-1.0))) f7 = Math_fround(HEAPF32[i4 + ((HEAPU8[i1 + 80 >> 0] | 0) << 2) >> 2]);
  } else {
   i18 = _bitshift64Lshr(i21 | 0, i22 | 0, 20) | 0;
   getTempRet0() | 0;
   f7 = Math_fround(HEAPF32[i4 + ((HEAPU8[(HEAP32[(HEAP32[i3 + 20 >> 2] | 0) + ((i18 & 268435455) * 56 | 0) + 16 >> 2] | 0) + ((i21 & 65535) << 5) + 29 >> 0] | 0) << 2) >> 2]);
  }
  f8 = Math_fround(f8 + Math_fround(f9 * f7));
  f7 = Math_fround(0.0);
 } else {
  i1 = i24 + 52 | 0;
  if ((__ZNK14dtNavMeshQuery26closestPointOnPolyBoundaryEyPKfPf(i24, i21, i22, i1, i18) | 0) >= 0) {
   f28 = Math_fround(HEAPF32[i1 >> 2]);
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i18 >> 2]));
   f29 = Math_fround(HEAPF32[i24 + 56 >> 2]);
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i18 + 4 >> 2]));
   f7 = Math_fround(HEAPF32[i24 + 60 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 8 >> 2]));
   f7 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f29 * f29)) + Math_fround(f7 * f7)))) * Math_fround(.999000012));
   break;
  }
  STACKTOP = i27;
  return;
 } while (0);
 i1 = i24 + 20 | 0;
 if (f7 < Math_fround(HEAPF32[i1 >> 2])) {
  HEAPF32[i1 >> 2] = f7;
  HEAP32[i24 + 12 >> 2] = i26;
 }
 f7 = Math_fround(f7 + f8);
 i1 = HEAP32[i20 >> 2] | 0;
 i2 = i1 & 1073741824;
 i3 = (i2 | 0) == 0;
 if (!i3) if (f7 >= Math_fround(HEAPF32[i26 + 16 >> 2])) {
  STACKTOP = i27;
  return;
 }
 if ((i1 | 0) < 0) if (f7 >= Math_fround(HEAPF32[i26 + 16 >> 2])) {
  STACKTOP = i27;
  return;
 }
 if (!i23) i1 = 0; else i1 = (i23 - (HEAP32[HEAP32[i19 >> 2] >> 2] | 0) >> 5) + 1 & 1073741823;
 i23 = i26 + 24 | 0;
 HEAP32[i23 >> 2] = i21;
 HEAP32[i23 + 4 >> 2] = i22;
 HEAP32[i20 >> 2] = i2 | i1;
 HEAPF32[i26 + 12 >> 2] = f8;
 HEAPF32[i26 + 16 >> 2] = f7;
 if (i3) {
  HEAP32[i20 >> 2] = i1 | 1073741824;
  i6 = HEAP32[i24 + 80 >> 2] | 0;
  i25 = i6 + 8 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  HEAP32[i25 >> 2] = i1 + 1;
  L73 : do if ((i1 | 0) > 0) {
   i3 = i1;
   while (1) {
    i2 = i3 + -1 | 0;
    i1 = (i2 | 0) / 2 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    if (!(Math_fround(HEAPF32[i5 + 16 >> 2]) > f7)) {
     i1 = i3;
     break L73;
    }
    HEAP32[i4 + (i3 << 2) >> 2] = i5;
    if ((i2 | 0) > 1) i3 = i1; else break;
   }
  } while (0);
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i26;
  STACKTOP = i27;
  return;
 }
 i6 = HEAP32[i24 + 80 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i3 | 0) <= 0) {
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i1 + (i2 << 2) >> 2] | 0) == (i26 | 0)) break;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i3 | 0)) {
   i25 = 60;
   break;
  }
 }
 if ((i25 | 0) == 60) {
  STACKTOP = i27;
  return;
 }
 L89 : do if ((i2 | 0) > 0) {
  i5 = i2;
  while (1) {
   i4 = i5 + -1 | 0;
   i2 = (i4 | 0) / 2 | 0;
   i3 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
   if (!(Math_fround(HEAPF32[i3 + 16 >> 2]) > f7)) {
    i2 = i5;
    break L89;
   }
   HEAP32[i1 + (i5 << 2) >> 2] = i3;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i4 | 0) > 1) i5 = i2; else break;
  }
 } while (0);
 HEAP32[i1 + (i2 << 2) >> 2] = i26;
 STACKTOP = i27;
 return;
}

function __ZN5physx21PxcArticulationHelper16prepareLtbMatrixERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEf(i17, i16, i19, i18, f20) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 f20 = Math_fround(f20);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21;
 i1 = HEAP16[i17 + 8 >> 1] | 0;
 i13 = HEAPU16[i17 + 24 >> 1] | 0;
 i14 = i17 + i13 | 0;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 i12 = i17 + (i13 + 16) | 0;
 i22 = i16 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 32) | 0;
 i22 = i16 + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 48) | 0;
 i22 = i16 + 48 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 64) | 0;
 i22 = i16 + 64 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 80) | 0;
 i22 = i16 + 80 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 96) | 0;
 i22 = i16 + 96 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i12 = i17 + (i13 + 112) | 0;
 i22 = i16 + 112 | 0;
 HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i13 = i17 + (i13 + 128) | 0;
 i12 = i16 + 128 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 HEAPF32[i15 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 32 >> 2] = Math_fround(1.0);
 if ((i1 & 65535) <= 1) {
  STACKTOP = i21;
  return;
 }
 i1 = i1 & 65535;
 i12 = 1;
 do {
  i13 = i14 + (i12 * 400 | 0) | 0;
  i22 = i16 + (i12 * 144 | 0) | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 16 | 0;
  i22 = i16 + (i12 * 144 | 0) + 16 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 32 | 0;
  i22 = i16 + (i12 * 144 | 0) + 32 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 48 | 0;
  i22 = i16 + (i12 * 144 | 0) + 48 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 64 | 0;
  i22 = i16 + (i12 * 144 | 0) + 64 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 80 | 0;
  i22 = i16 + (i12 * 144 | 0) + 80 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 96 | 0;
  i22 = i16 + (i12 * 144 | 0) + 96 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 112 | 0;
  i22 = i16 + (i12 * 144 | 0) + 112 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = i14 + (i12 * 400 | 0) + 128 | 0;
  i22 = i16 + (i12 * 144 | 0) + 128 | 0;
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i13 = HEAPU8[i17 + 64 + i12 >> 0] | 0;
  f2 = Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 44 >> 2]);
  f3 = Math_fround(f2 - Math_fround(HEAPF32[i19 + (i13 * 28 | 0) + 16 >> 2]));
  f11 = Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 48 >> 2]);
  f4 = Math_fround(f11 - Math_fround(HEAPF32[i19 + (i13 * 28 | 0) + 20 >> 2]));
  f10 = Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 52 >> 2]);
  f5 = Math_fround(f10 - Math_fround(HEAPF32[i19 + (i13 * 28 | 0) + 24 >> 2]));
  f6 = Math_fround(f2 - Math_fround(HEAPF32[i19 + (i12 * 28 | 0) + 16 >> 2]));
  f7 = Math_fround(f11 - Math_fround(HEAPF32[i19 + (i12 * 28 | 0) + 20 >> 2]));
  f8 = Math_fround(f10 - Math_fround(HEAPF32[i19 + (i12 * 28 | 0) + 24 >> 2]));
  f9 = Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 16 >> 2]);
  f11 = Math_fround(Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 20 >> 2]) - f11);
  f10 = Math_fround(Math_fround(HEAPF32[i18 + (i12 * 84 | 0) + 24 >> 2]) - f10);
  f11 = Math_fround(f11 * Math_fround(.990000009));
  i13 = 0;
  do {
   i30 = HEAP32[i15 + (i13 * 12 | 0) >> 2] | 0;
   i29 = HEAP32[i15 + (i13 * 12 | 0) + 4 >> 2] | 0;
   i22 = HEAP32[i15 + (i13 * 12 | 0) + 8 >> 2] | 0;
   f24 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f4 * f24);
   f23 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = Math_fround(f25 - Math_fround(f5 * f23));
   f28 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(Math_fround(f5 * f28) - Math_fround(f3 * f24));
   f27 = Math_fround(Math_fround(f3 * f23) - Math_fround(f4 * f28));
   HEAP32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) >> 2] = i30;
   HEAP32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 4 >> 2] = i29;
   HEAP32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 8 >> 2] = i22;
   HEAPF32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 16 >> 2] = f25;
   HEAPF32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 20 >> 2] = f26;
   HEAPF32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 24 >> 2] = f27;
   HEAPF32[i14 + (i12 * 400 | 0) + 144 + (i13 << 5) + 28 >> 2] = Math_fround(0.0);
   f27 = Math_fround(-f23);
   f26 = Math_fround(-f24);
   f25 = Math_fround(-Math_fround(Math_fround(f7 * f24) - Math_fround(f8 * f23)));
   f24 = Math_fround(-Math_fround(Math_fround(f8 * f28) - Math_fround(f6 * f24)));
   f23 = Math_fround(-Math_fround(Math_fround(f6 * f23) - Math_fround(f7 * f28)));
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) >> 2] = Math_fround(-f28);
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 4 >> 2] = f27;
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 8 >> 2] = f26;
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 16 >> 2] = f25;
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 20 >> 2] = f24;
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 24 >> 2] = f23;
   HEAPF32[i14 + (i12 * 400 | 0) + 240 + (i13 << 5) + 28 >> 2] = Math_fround(0.0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != 3);
  f27 = Math_fround(f11 * f20);
  f28 = Math_fround(Math_fround(f10 * Math_fround(.990000009)) * f20);
  HEAPF32[i14 + (i12 * 400 | 0) + 384 >> 2] = Math_fround(Math_fround(Math_fround(f9 - f2) * Math_fround(.990000009)) * f20);
  HEAPF32[i14 + (i12 * 400 | 0) + 388 >> 2] = f27;
  HEAPF32[i14 + (i12 * 400 | 0) + 392 >> 2] = f28;
  HEAPF32[i14 + (i12 * 400 | 0) + 396 >> 2] = Math_fround(0.0);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i1 | 0));
 STACKTOP = i21;
 return;
}

function __ZN5physx2Gu27intersectHeightFieldCapsuleERKNS0_15HeightFieldUtilERKNS0_7CapsuleE(i53, i51) {
 i53 = i53 | 0;
 i51 = i51 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, f58 = f0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i57 + 108 | 0;
 i41 = i57 + 96 | 0;
 i37 = i57 + 72 | 0;
 i21 = i57 + 56 | 0;
 i54 = i57 + 44 | 0;
 i52 = i57 + 32 | 0;
 i55 = i57 + 28 | 0;
 i56 = i57 + 24 | 0;
 i47 = i57;
 i35 = i53 + 12 | 0;
 i32 = HEAP32[i35 >> 2] | 0;
 f46 = Math_fround(HEAPF32[i51 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i53 >> 2]);
 f29 = Math_fround(Math_abs(Math_fround(f23)));
 i36 = i53 + 8 | 0;
 f25 = Math_fround(HEAPF32[i36 >> 2]);
 f29 = Math_fround(f46 * f29);
 f30 = Math_fround(f46 * Math_fround(Math_abs(Math_fround(f25))));
 HEAP32[i37 >> 2] = HEAP32[i51 >> 2];
 i42 = i51 + 4 | 0;
 HEAP32[i37 + 4 >> 2] = HEAP32[i42 >> 2];
 i43 = i51 + 8 | 0;
 i5 = HEAP32[i43 >> 2] | 0;
 HEAP32[i37 + 8 >> 2] = i5;
 HEAP32[i37 + 12 >> 2] = HEAP32[i51 + 12 >> 2];
 i44 = i51 + 16 | 0;
 HEAP32[i37 + 16 >> 2] = HEAP32[i44 >> 2];
 i45 = i51 + 20 | 0;
 HEAP32[i37 + 20 >> 2] = HEAP32[i45 >> 2];
 f46 = Math_fround(f46 * f46);
 i22 = i32 + 16 | 0;
 i48 = i32 + 20 | 0;
 i31 = i53 + 16 | 0;
 i32 = i32 + 40 | 0;
 i33 = i21 + 4 | 0;
 i34 = i21 + 8 | 0;
 f26 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i5 = 0;
 i4 = 0;
 i3 = -1;
 i2 = -1;
 i1 = 0;
 L1 : while (1) {
  f28 = Math_fround(HEAPF32[i37 + (i1 * 12 | 0) >> 2]);
  f24 = Math_fround(f28 * f23);
  i14 = i37 + (i1 * 12 | 0) + 4 | 0;
  i15 = i37 + (i1 * 12 | 0) + 8 | 0;
  f23 = Math_fround(f26 * f25);
  i6 = ~~Math_fround(Math_floor(Math_fround(f24 - f29)));
  i17 = HEAP32[i22 >> 2] | 0;
  i16 = i17 + -2 | 0;
  i6 = (i6 | 0) > 0 ? i6 : 0;
  i6 = (i6 | 0) > (i16 | 0) ? i16 : i6;
  i16 = ~~Math_fround(Math_ceil(Math_fround(f29 + f24)));
  i17 = i17 + -1 | 0;
  i16 = (i16 | 0) > 0 ? i16 : 0;
  i16 = (i16 | 0) > (i17 | 0) ? i17 : i16;
  i17 = ~~Math_fround(Math_floor(Math_fround(f23 - f30)));
  i19 = HEAP32[i48 >> 2] | 0;
  i18 = i19 + -2 | 0;
  i17 = (i17 | 0) > 0 ? i17 : 0;
  i17 = (i17 | 0) > (i18 | 0) ? i18 : i17;
  i18 = ~~Math_fround(Math_ceil(Math_fround(f30 + f23)));
  i19 = i19 + -1 | 0;
  i18 = (i18 | 0) > 0 ? i18 : 0;
  i18 = (i18 | 0) > (i19 | 0) ? i19 : i18;
  i19 = i6 >>> 0 < i2 >>> 0 ? i6 : i2;
  i3 = i17 >>> 0 < i3 >>> 0 ? i17 : i3;
  i4 = i16 >>> 0 > i4 >>> 0 ? i16 : i4;
  i5 = i18 >>> 0 > i5 >>> 0 ? i18 : i5;
  f23 = Math_fround(f25 * f26);
  do if (f24 >= Math_fround(0.0) & f23 >= Math_fround(0.0)) {
   i2 = HEAP32[i35 >> 2] | 0;
   if (f24 < Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + Math_fround(1.0))) if (f23 < Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) + Math_fround(1.0))) {
    f23 = Math_fround(HEAPF32[(HEAP32[i31 >> 2] | 0) + 8 >> 2]);
    f23 = Math_fround(f23 * Math_fround(__ZNK5physx2Gu11HeightField17getHeightInternalEff(i2, f24, Math_fround(f26 * f25))));
    f23 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f23);
    f24 = Math_fround(HEAPF32[i32 >> 2]);
    if (!(f24 <= f23) | (!(f23 <= Math_fround(0.0)) | !(f24 <= Math_fround(0.0)))) if (!(f24 > f23 & (f23 > Math_fround(-0.0) & f24 > Math_fround(0.0)))) {
     i38 = 5;
     break;
    }
    if ((__ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff(i53, f28, f26) | 0) != -1) {
     i20 = 1;
     i38 = 37;
     break L1;
    }
   } else i38 = 5; else i38 = 5;
  } else i38 = 5; while (0);
  if ((i38 | 0) == 5) {
   i38 = 0;
   if (i6 >>> 0 < i16 >>> 0) {
    i13 = i17 >>> 0 < i18 >>> 0;
    do {
     if (i13) {
      i9 = HEAP32[i14 >> 2] | 0;
      i10 = HEAP32[i15 >> 2] | 0;
      f26 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f27 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i12 = i17;
      do {
       HEAPF32[i21 >> 2] = f28;
       HEAP32[i33 >> 2] = i9;
       HEAP32[i34 >> 2] = i10;
       i11 = __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb(i53, i6, i12, i21, i40, 0, 1, 1, 1) | 0;
       L19 : do if (i11 | 0) {
        f25 = Math_fround(HEAPF32[i32 >> 2]);
        i2 = f25 > Math_fround(0.0);
        if (f25 <= Math_fround(0.0)) {
         i8 = 0;
         while (1) {
          f23 = Math_fround(f28 - Math_fround(HEAPF32[i40 + (i8 * 12 | 0) >> 2]));
          f24 = Math_fround(f26 - Math_fround(HEAPF32[i40 + (i8 * 12 | 0) + 4 >> 2]));
          f25 = Math_fround(f27 - Math_fround(HEAPF32[i40 + (i8 * 12 | 0) + 8 >> 2]));
          if (f24 > Math_fround(0.0) | f24 < Math_fround(0.0) & i2) if (!(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f24 * f24)) + Math_fround(f25 * f25)) > f46)) {
           i38 = 36;
           break L1;
          }
          i8 = i8 + 1 | 0;
          if (i8 >>> 0 >= i11 >>> 0) break L19;
         }
        }
        if (i2) i2 = 0; else {
         i2 = 0;
         while (1) {
          i2 = i2 + 1 | 0;
          if (i2 >>> 0 >= i11 >>> 0) break L19;
         }
        }
        do {
         f23 = Math_fround(f28 - Math_fround(HEAPF32[i40 + (i2 * 12 | 0) >> 2]));
         f24 = Math_fround(f26 - Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 4 >> 2]));
         f25 = Math_fround(f27 - Math_fround(HEAPF32[i40 + (i2 * 12 | 0) + 8 >> 2]));
         if (f24 < Math_fround(0.0)) if (!(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f24 * f24)) + Math_fround(f25 * f25)) > f46)) {
          i38 = 36;
          break L1;
         }
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < i11 >>> 0);
       } while (0);
       i12 = i12 + 1 | 0;
      } while (i12 >>> 0 < i18 >>> 0);
     }
     i6 = i6 + 1 | 0;
    } while (i6 >>> 0 < i16 >>> 0);
   }
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= 2) {
   i39 = i4;
   i7 = i19;
   i49 = i5;
   i50 = i3;
   i38 = 2;
   break;
  }
  f23 = Math_fround(HEAPF32[i53 >> 2]);
  f26 = Math_fround(HEAPF32[i37 + (i1 * 12 | 0) + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i36 >> 2]);
  i2 = i19;
 }
 if ((i38 | 0) == 2) {
  if (i7 >>> 0 > i39 >>> 0) {
   i56 = 0;
   STACKTOP = i57;
   return i56 | 0;
  }
  i8 = i50 >>> 0 > i49 >>> 0;
  i9 = i54 + 4 | 0;
  i10 = i52 + 4 | 0;
  i11 = i54 + 8 | 0;
  i12 = i52 + 8 | 0;
  i13 = i47 + 4 | 0;
  i14 = i47 + 8 | 0;
  i15 = i47 + 12 | 0;
  i16 = i47 + 16 | 0;
  i17 = i47 + 20 | 0;
  i18 = i51 + 12 | 0;
  i19 = i40 + 4 | 0;
  i20 = i40 + 8 | 0;
  i21 = i41 + 4 | 0;
  i22 = i41 + 8 | 0;
  L45 : while (1) {
   if (!i8) {
    i3 = (i7 | 0) == (i39 | 0) ? 1 : 3;
    i6 = i50;
    do {
     i4 = (Math_imul(HEAP32[i48 >> 2] | 0, i7) | 0) + i6 | 0;
     i5 = i4 * 3 | 0;
     i1 = (i6 | 0) == (i49 | 0) ? 2 : 0;
     if (i1 >>> 0 < i3 >>> 0) do {
      i2 = i1 + i5 | 0;
      if ((__ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i53, i2, i4, i7, i6) | 0) != -1) {
       __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_(i53, i2, i4, i7, i6, i54, i52);
       f28 = Math_fround(HEAPF32[i54 >> 2]);
       f27 = Math_fround(f28 + Math_fround(HEAPF32[i52 >> 2]));
       f29 = Math_fround(HEAPF32[i9 >> 2]);
       f25 = Math_fround(f29 + Math_fround(HEAPF32[i10 >> 2]));
       f30 = Math_fround(HEAPF32[i11 >> 2]);
       f26 = Math_fround(f30 + Math_fround(HEAPF32[i12 >> 2]));
       HEAPF32[i47 >> 2] = f28;
       HEAPF32[i13 >> 2] = f29;
       HEAPF32[i14 >> 2] = f30;
       HEAPF32[i15 >> 2] = f27;
       HEAPF32[i16 >> 2] = f25;
       HEAPF32[i17 >> 2] = f26;
       f58 = Math_fround(HEAPF32[i18 >> 2]);
       f58 = Math_fround(f58 - Math_fround(HEAPF32[i51 >> 2]));
       f23 = Math_fround(HEAPF32[i44 >> 2]);
       f23 = Math_fround(f23 - Math_fround(HEAPF32[i42 >> 2]));
       f24 = Math_fround(HEAPF32[i45 >> 2]);
       f24 = Math_fround(f24 - Math_fround(HEAPF32[i43 >> 2]));
       HEAPF32[i40 >> 2] = f58;
       HEAPF32[i19 >> 2] = f23;
       HEAPF32[i20 >> 2] = f24;
       f29 = Math_fround(f25 - f29);
       f30 = Math_fround(f26 - f30);
       HEAPF32[i41 >> 2] = Math_fround(f27 - f28);
       HEAPF32[i21 >> 2] = f29;
       HEAPF32[i22 >> 2] = f30;
       if (Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i51, i40, i47, i41, i55, i56)) < f46) {
        i20 = 1;
        i38 = 37;
        break L45;
       }
      }
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i3 >>> 0);
     i6 = i6 + 1 | 0;
    } while (i6 >>> 0 <= i49 >>> 0);
   }
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 > i39 >>> 0) {
    i20 = 0;
    i38 = 37;
    break;
   }
  }
  if ((i38 | 0) == 37) {
   STACKTOP = i57;
   return i20 | 0;
  }
 } else if ((i38 | 0) == 36) {
  i56 = 1;
  STACKTOP = i57;
  return i56 | 0;
 } else if ((i38 | 0) == 37) {
  STACKTOP = i57;
  return i20 | 0;
 }
 return 0;
}

function __Z18ExpandVector3CurveR17AnimationCurveTplI8Vector3fEPPS_IfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = HEAP32[i8 + 132 >> 2] | 0;
 i6 = i7 << 4;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i11;
  break;
 } while (0);
 i10 = i9 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i11;
  break;
 } while (0);
 i11 = i9 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i1 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i6;
  break;
 } while (0);
 if ((i7 | 0) > 0) {
  i2 = i8 + 120 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[i2 >> 2] | 0;
   i12 = HEAP32[i5 + (i1 * 40 | 0) >> 2] | 0;
   i3 = i5 + (i1 * 40 | 0) + 4 | 0;
   i4 = i5 + (i1 * 40 | 0) + 16 | 0;
   i5 = i5 + (i1 * 40 | 0) + 28 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i13 = HEAP32[i4 >> 2] | 0;
   i14 = HEAP32[i5 >> 2] | 0;
   i15 = HEAP32[(HEAP32[i9 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i15 + (i1 << 4) >> 2] = i12;
   HEAP32[i15 + (i1 << 4) + 4 >> 2] = i6;
   HEAP32[i15 + (i1 << 4) + 8 >> 2] = i13;
   HEAP32[i15 + (i1 << 4) + 12 >> 2] = i14;
   i15 = HEAP32[i3 + 4 >> 2] | 0;
   i14 = HEAP32[i4 + 4 >> 2] | 0;
   i13 = HEAP32[i5 + 4 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i10 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = i12;
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i15;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i14;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i13;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
   i4 = HEAP32[i4 + 8 >> 2] | 0;
   i5 = HEAP32[i5 + 8 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = i12;
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i3;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i4;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 i2 = HEAP32[i8 + 140 >> 2] | 0;
 i1 = HEAP32[i8 + 144 >> 2] | 0;
 i8 = HEAP32[i8 + 148 >> 2] | 0;
 switch (i2 | 0) {
 case 1:
  {
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 1;
   i3 = i2 + 4 | 0;
   i4 = i2 + 32 | 0;
   i5 = i2 + 28 | 0;
   if ((i1 | 0) == 1) {
    HEAP32[i2 + 80 >> 2] = 1;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    HEAP32[i2 + 84 >> 2] = i8;
    i15 = HEAP32[i10 >> 2] | 0;
    HEAP32[i15 + 76 >> 2] = 1;
    HEAP32[i15 + 80 >> 2] = 1;
    HEAPF32[i15 + 4 >> 2] = Math_fround(inf);
    HEAP32[i15 >> 2] = 0;
    HEAPF32[i15 + 32 >> 2] = Math_fround(inf);
    HEAP32[i15 + 28 >> 2] = 0;
    HEAP32[i15 + 84 >> 2] = i8;
    i15 = HEAP32[i11 >> 2] | 0;
    HEAP32[i15 + 76 >> 2] = 1;
    HEAP32[i15 + 80 >> 2] = 1;
    HEAPF32[i15 + 4 >> 2] = Math_fround(inf);
    HEAP32[i15 >> 2] = 0;
    HEAPF32[i15 + 32 >> 2] = Math_fround(inf);
    HEAP32[i15 + 28 >> 2] = 0;
    HEAP32[i15 + 84 >> 2] = i8;
    return;
   } else {
    i14 = (i1 | 0) == 3 ? 3 : (i1 | 0) == 0 ? 0 : 2;
    HEAP32[i2 + 80 >> 2] = i14;
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i4 >> 2] = Math_fround(inf);
    HEAP32[i5 >> 2] = 0;
    HEAP32[i2 + 84 >> 2] = i8;
    i15 = HEAP32[i10 >> 2] | 0;
    HEAP32[i15 + 76 >> 2] = 1;
    HEAP32[i15 + 80 >> 2] = i14;
    HEAPF32[i15 + 4 >> 2] = Math_fround(inf);
    HEAP32[i15 >> 2] = 0;
    HEAPF32[i15 + 32 >> 2] = Math_fround(inf);
    HEAP32[i15 + 28 >> 2] = 0;
    HEAP32[i15 + 84 >> 2] = i8;
    i15 = HEAP32[i11 >> 2] | 0;
    HEAP32[i15 + 76 >> 2] = 1;
    HEAP32[i15 + 80 >> 2] = i14;
    HEAPF32[i15 + 4 >> 2] = Math_fround(inf);
    HEAP32[i15 >> 2] = 0;
    HEAPF32[i15 + 32 >> 2] = Math_fround(inf);
    HEAP32[i15 + 28 >> 2] = 0;
    HEAP32[i15 + 84 >> 2] = i8;
    return;
   }
  }
 case 0:
  {
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = 0;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP32[i2 + 76 >> 2] = 0;
   i3 = i2 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   i4 = i2 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i2 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i2 + 80 >> 2] = i1;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i2 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i2 + 84 >> 2] = i8;
   return;
  }
 default:
  {
   i6 = HEAP32[i9 >> 2] | 0;
   i7 = (i2 | 0) == 3 ? 3 : 2;
   HEAP32[i6 + 76 >> 2] = i7;
   i3 = i6 + 4 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   i4 = i6 + 32 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   i5 = i6 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i6 + 80 >> 2] = i2;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 + 84 >> 2] = i8;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 + 76 >> 2] = i7;
   i4 = i3 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   i5 = i3 + 32 | 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   i6 = i3 + 28 | 0;
   HEAP32[i6 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i2 = i1;
     break;
    }
   case 0:
    {
     i2 = 0;
     break;
    }
   case 3:
    {
     i2 = i1;
     break;
    }
   default:
    i2 = 2;
   }
   HEAP32[i3 + 80 >> 2] = i2;
   HEAPF32[i4 >> 2] = Math_fround(inf);
   HEAP32[i3 >> 2] = 0;
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 84 >> 2] = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   HEAP32[i5 + 76 >> 2] = i7;
   i2 = i5 + 4 | 0;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   i3 = i5 + 32 | 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   i4 = i5 + 28 | 0;
   HEAP32[i4 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    break;
   case 0:
    {
     i1 = 0;
     break;
    }
   case 3:
    break;
   default:
    i1 = 2;
   }
   HEAP32[i5 + 80 >> 2] = i1;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i5 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 + 84 >> 2] = i8;
   return;
  }
 }
}

function __ZN11TrailModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjRKf(i5, i3, i1, i58, i7, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i58 = i58 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var f4 = f0, i6 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, i63 = 0, i64 = 0, i65 = 0, f66 = f0, f67 = f0, i68 = 0, f69 = f0;
 i65 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i65 + 32 | 0;
 i63 = i65 + 16 | 0;
 i64 = i65;
 if ((HEAP16[gb + 1451728 + 6 >> 1] | 0) > -1) {
  HEAP32[i63 >> 2] = 0;
  HEAP32[i46 >> 2] = HEAP32[i63 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451728 | 0, i46);
  i47 = gb + 1451728 | 0;
 } else i47 = 0;
 i48 = i58 + 740 | 0;
 i49 = i58 + 824 | 0;
 i6 = HEAP32[i49 >> 2] | 0;
 f50 = Math_fround(HEAPF32[i5 + 276 >> 2]);
 f50 = Math_fround(f50 * f50);
 f51 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f52 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f53 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f54 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f55 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f56 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f57 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f59 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f60 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f61 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f62 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f45 = Math_fround(HEAPF32[i1 + 108 >> 2]);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 i24 = i5 + 868 | 0;
 HEAPF32[i24 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i24 >> 2]));
 i25 = HEAP32[i58 + 12 >> 2] | 0;
 i26 = HEAP32[i58 + 16 >> 2] & 2147483647;
 L4 : do if (i25 >>> 0 > i7 >>> 0) {
  i27 = i58 + 520 | 0;
  i28 = i58 + 500 | 0;
  i29 = i5 + 12 | 0;
  i30 = i46 + 12 | 0;
  i31 = i46 + 8 | 0;
  i32 = i46 + 4 | 0;
  i33 = i63 + 12 | 0;
  i34 = i63 + 8 | 0;
  i35 = i63 + 4 | 0;
  i36 = i5 + 96 | 0;
  i37 = i5 + 287 | 0;
  i38 = i58 + 540 | 0;
  i39 = i58 + 800 | 0;
  i40 = i5 + 8 | 0;
  i41 = i58 + 20 | 0;
  i42 = i58 + 40 | 0;
  i43 = i5 + 284 | 0;
  i44 = i58 + 760 | 0;
  i13 = i3 + 280 | 0;
  i14 = i58 + 780 | 0;
  i15 = i58 + 871 | 0;
  i16 = i58 + 420 | 0;
  i17 = i58 + 440 | 0;
  i18 = i58 + 460 | 0;
  i19 = i5 + 92 | 0;
  i20 = i64 + 12 | 0;
  i21 = i64 + 8 | 0;
  i22 = i64 + 4 | 0;
  i23 = i5 + 244 | 0;
  i12 = i5 + 156 | 0;
  i1 = i6;
  while (1) {
   f9 = Math_fround(Math_fround(HEAPF32[(HEAP32[i27 >> 2] | 0) + (i7 << 2) >> 2]) * Math_fround(.00999999977));
   i11 = (HEAP32[(HEAP32[i28 >> 2] | 0) + (i7 << 2) >> 2] | 0) + 884714267 | 0;
   i2 = (Math_imul(i11, 1790253981) | 0) + 1900727103 | 0;
   i11 = i11 << 11 ^ i11;
   f4 = Math_fround(Math_fround(((i2 ^ i11 ^ i11 >>> 8) & 8388607 ^ i2 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i30 >> 2] = f9;
   HEAPF32[i31 >> 2] = f9;
   HEAPF32[i32 >> 2] = f9;
   HEAPF32[i46 >> 2] = f9;
   HEAPF32[i33 >> 2] = f4;
   HEAPF32[i34 >> 2] = f4;
   HEAPF32[i35 >> 2] = f4;
   HEAPF32[i63 >> 2] = f4;
   i2 = HEAP32[i36 >> 2] | 0;
   L8 : do switch ((i2 & 65535) << 16 >> 16) {
   case 0:
    {
     i11 = HEAP32[i19 >> 2] | 0;
     HEAP32[i20 >> 2] = i11;
     HEAP32[i21 >> 2] = i11;
     HEAP32[i22 >> 2] = i11;
     HEAP32[i64 >> 2] = i11;
     break;
    }
   case 3:
    {
     f9 = Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + 4 >> 2]);
     f66 = Math_fround(HEAPF32[i19 >> 2]);
     f9 = Math_fround(f9 * f66);
     f9 = Math_fround(f9 + Math_fround(f4 * Math_fround(Math_fround(f66 * Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + 4 >> 2])) - f9)));
     HEAPF32[i64 >> 2] = f9;
     HEAPF32[i22 >> 2] = f9;
     HEAPF32[i21 >> 2] = f9;
     HEAPF32[i20 >> 2] = f9;
     break;
    }
   default:
    if (!(i2 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i64, i29, i46, i63);
     break L8;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i64, i29, i46, i63);
     break L8;
    }
   } while (0);
   f4 = Math_fround(HEAPF32[i64 >> 2]);
   do if (HEAP8[i37 >> 0] | 0) {
    i2 = (HEAP32[i16 >> 2] | 0) + (i7 << 2) | 0;
    if (!(HEAP8[i15 >> 0] | 0)) {
     f4 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
     break;
    } else {
     f9 = Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + (i7 << 2) >> 2]);
     f67 = Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + (i7 << 2) >> 2]);
     f66 = Math_fround(HEAPF32[i2 >> 2]);
     f9 = f9 < f67 ? f67 : f9;
     f4 = Math_fround(f4 * (f66 < f9 ? f9 : f66));
     break;
    }
   } while (0);
   f4 = Math_fround(f4 / Math_fround(HEAPF32[(HEAP32[i38 >> 2] | 0) + (i7 << 2) >> 2]));
   i2 = HEAP32[i39 >> 2] | 0;
   i8 = i2 + (i7 << 2) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   L22 : do if (!i3) i10 = 0; else {
    f9 = Math_fround(HEAPF32[i24 >> 2]);
    i10 = (HEAP32[i14 >> 2] | 0) + (i7 << 2) | 0;
    i11 = HEAP32[i48 >> 2] | 0;
    while (1) {
     i5 = HEAP32[i49 >> 2] | 0;
     i68 = Math_imul(i5, i7) | 0;
     i6 = HEAP32[i10 >> 2] | 0;
     if (!(f9 > Math_fround(f4 + Math_fround(HEAPF32[i11 + (i6 + i68 << 4) + 12 >> 2])))) {
      i10 = i3;
      break L22;
     }
     HEAP32[i10 >> 2] = ((i6 + 1 | 0) >>> 0) % (i5 >>> 0) | 0;
     i3 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
     HEAP32[i8 >> 2] = i3;
     if (!i3) {
      i10 = 0;
      break;
     }
    }
   } while (0);
   f4 = Math_fround(HEAPF32[i40 >> 2]);
   do if (f4 != Math_fround(0.0)) {
    i11 = (HEAP32[(HEAP32[i28 >> 2] | 0) + (i7 << 2) >> 2] | 0) + -1967131808 | 0;
    i68 = (Math_imul(i11, 1790253981) | 0) + 1900727103 | 0;
    i11 = i11 << 11 ^ i11;
    if (Math_fround(Math_fround(((i68 ^ i11 ^ i11 >>> 8) & 8388607 ^ i68 >>> 19) >>> 0) * Math_fround(1.19209304e-07)) <= f4) if (!(Math_fround(HEAPF32[(HEAP32[i27 >> 2] | 0) + (i7 << 2) >> 2]) >= Math_fround(100.0))) {
     i3 = HEAP32[(HEAP32[i58 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i6 = HEAP32[(HEAP32[i41 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i5 = HEAP32[(HEAP32[i42 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     if ((HEAP8[i43 >> 0] | 0) == 0 | (HEAP32[i13 >> 2] | 0) == 1) i8 = i6; else {
      f67 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = Math_fround(Math_fround(f51 * f67) + Math_fround(f54 * f4));
      f66 = Math_fround(Math_fround(f52 * f67) + Math_fround(f55 * f4));
      f4 = Math_fround(Math_fround(f53 * f67) + Math_fround(f56 * f4));
      f67 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = Math_fround(f9 + Math_fround(f61 + Math_fround(f57 * f67)));
      f66 = Math_fround(f66 + Math_fround(f62 + Math_fround(f59 * f67)));
      f67 = Math_fround(f4 + Math_fround(f45 + Math_fround(f60 * f67)));
      i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
      i5 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
     }
     if (i10 | 0) {
      i68 = Math_imul(HEAP32[i49 >> 2] | 0, i7) | 0;
      i68 = (HEAP32[i48 >> 2] | 0) + ((HEAP32[(HEAP32[i44 >> 2] | 0) + (i7 << 2) >> 2] | 0) + i68 << 4) | 0;
      f69 = Math_fround(HEAPF32[i68 >> 2]);
      f4 = Math_fround(HEAPF32[i68 + 4 >> 2]);
      f67 = Math_fround(HEAPF32[i68 + 8 >> 2]);
      f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f66 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f9 = Math_fround(f69 - f9);
      f66 = Math_fround(f4 - f66);
      f67 = Math_fround(f67 - (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      if (!(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f66 * f66)) + Math_fround(Math_fround(f67 * f67) + Math_fround(0.0))) > f50)) break;
     }
     i6 = i1 << 1;
     if ((i10 | 0) == (i1 | 0)) {
      __ZN14ParticleTrails10ReallocateEjj(i48, i26, i6);
      i1 = i6;
      i2 = HEAP32[i39 >> 2] | 0;
     }
     i11 = (HEAP32[i44 >> 2] | 0) + (i7 << 2) | 0;
     i68 = (((HEAP32[i11 >> 2] | 0) + 1 | 0) >>> 0) % ((HEAP32[i49 >> 2] | 0) >>> 0) | 0;
     HEAP32[i11 >> 2] = i68;
     i68 = (Math_imul(HEAP32[i49 >> 2] | 0, i7) | 0) + i68 | 0;
     i68 = (HEAP32[i48 >> 2] | 0) + (i68 << 4) | 0;
     i11 = HEAP32[i24 >> 2] | 0;
     HEAP32[i68 >> 2] = i3;
     HEAP32[i68 + 4 >> 2] = i8;
     HEAP32[i68 + 8 >> 2] = i5;
     HEAP32[i68 + 12 >> 2] = i11;
     i68 = i2 + (i7 << 2) | 0;
     HEAP32[i68 >> 2] = (HEAP32[i68 >> 2] | 0) + 1;
    }
   } while (0);
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i25 | 0)) break L4;
  }
 } while (0);
 if (!i47) {
  STACKTOP = i65;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i47);
 STACKTOP = i65;
 return;
}

function __ZN5physx20PxcSweepConvexConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i4 + 672 | 0;
 i48 = i4 + 240 | 0;
 i49 = i4 + 224 | 0;
 i51 = i4 + 144 | 0;
 i52 = i4 + 128 | 0;
 i22 = i4 + 464 | 0;
 i21 = i4 + 256 | 0;
 i19 = i4 + 96 | 0;
 i20 = i4 + 160 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i47 = HEAP32[i8 >> 2] | 0;
 i50 = HEAP32[i9 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i53 = HEAP32[i47 + 44 >> 2] | 0;
 i8 = HEAP32[i47 + 48 >> 2] | 0;
 HEAP32[i48 >> 2] = HEAP32[i47 + 40 >> 2];
 HEAP32[i48 + 4 >> 2] = i53;
 HEAP32[i48 + 8 >> 2] = i8;
 HEAPF32[i48 + 12 >> 2] = Math_fround(0.0);
 i8 = HEAP32[i47 + 56 >> 2] | 0;
 i53 = HEAP32[i47 + 60 >> 2] | 0;
 i9 = HEAP32[i47 + 64 >> 2] | 0;
 HEAP32[i49 >> 2] = HEAP32[i47 + 52 >> 2];
 HEAP32[i49 + 4 >> 2] = i8;
 HEAP32[i49 + 8 >> 2] = i53;
 HEAP32[i49 + 12 >> 2] = i9;
 i9 = HEAP32[i50 + 44 >> 2] | 0;
 i53 = HEAP32[i50 + 48 >> 2] | 0;
 HEAP32[i51 >> 2] = HEAP32[i50 + 40 >> 2];
 HEAP32[i51 + 4 >> 2] = i9;
 HEAP32[i51 + 8 >> 2] = i53;
 HEAPF32[i51 + 12 >> 2] = Math_fround(0.0);
 i53 = HEAP32[i50 + 56 >> 2] | 0;
 i9 = HEAP32[i50 + 60 >> 2] | 0;
 i8 = HEAP32[i50 + 64 >> 2] | 0;
 HEAP32[i52 >> 2] = HEAP32[i50 + 52 >> 2];
 HEAP32[i52 + 4 >> 2] = i53;
 HEAP32[i52 + 8 >> 2] = i9;
 HEAP32[i52 + 12 >> 2] = i8;
 i50 = HEAP32[i50 + 72 >> 2] | 0;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i22, HEAP32[i47 + 72 >> 2] | 0, i16, i48, i49);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i21, i50, i16, i51, i52);
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i52 = i5 + 16 | 0;
 f30 = Math_fround(HEAPF32[i52 >> 2]);
 f25 = Math_fround(HEAPF32[i52 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i52 + 8 >> 2]);
 i52 = HEAP32[i12 >> 2] | 0;
 i51 = HEAP32[i12 + 4 >> 2] | 0;
 i50 = HEAP32[i12 + 8 >> 2] | 0;
 i49 = HEAP32[i12 + 12 >> 2] | 0;
 i5 = i6 + 16 | 0;
 i48 = HEAP32[i5 >> 2] | 0;
 i47 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i52;
 i6 = i19 + 4 | 0;
 HEAP32[i6 >> 2] = i51;
 i8 = i19 + 8 | 0;
 HEAP32[i8 >> 2] = i50;
 i9 = i19 + 12 | 0;
 HEAP32[i9 >> 2] = i49;
 HEAP32[i19 + 16 >> 2] = i48;
 HEAP32[i19 + 20 >> 2] = i47;
 HEAP32[i19 + 24 >> 2] = i5;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f29 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f30 - f29);
 f38 = Math_fround(f25 - f24);
 f40 = Math_fround(f27 - f32);
 f41 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f28 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f31 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f23 * Math_fround(Math_fround(f28 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f23 * Math_fround(Math_fround(f38 * f42) - Math_fround(f28 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f23) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f23)));
 f26 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f23)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f23)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f28) + Math_fround(f23 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f31;
 HEAPF32[i20 + 56 >> 2] = f33;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f33 = Math_fround(f36 + f36);
 f31 = Math_fround(f26 + f26);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f26 * f31);
 f37 = Math_fround(f39 * f34);
 f26 = Math_fround(f26 * f33);
 f40 = Math_fround(f39 * f33);
 f23 = Math_fround(f35 * f33);
 f39 = Math_fround(f39 * f31);
 f31 = Math_fround(f35 * f31);
 f34 = Math_fround(f35 * f34);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f33));
 f36 = Math_fround(f26 + f34);
 f35 = Math_fround(f40 - f31);
 f34 = Math_fround(f26 - f34);
 f26 = Math_fround(f33 - f37);
 f28 = Math_fround(f39 + f23);
 f31 = Math_fround(f40 + f31);
 f23 = Math_fround(f39 - f23);
 f33 = Math_fround(f33 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f26;
 HEAPF32[i20 + 24 >> 2] = f28;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f31;
 HEAPF32[i20 + 36 >> 2] = f23;
 HEAPF32[i20 + 40 >> 2] = f33;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f10;
 f33 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f30 = Math_fround(f33 - f30);
 f25 = Math_fround(f10 - f25);
 f27 = Math_fround(f23 - f27);
 HEAPF32[i18 >> 2] = f30;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i18 + 8 >> 2] = f27;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(Math_fround(f31 - f29) - f30);
 f25 = Math_fround(Math_fround(f28 - f24) - f25);
 f27 = Math_fround(Math_fround(f26 - f32) - f27);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f24 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(HEAPF32[i9 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f31 = Math_fround(Math_fround(Math_fround(f30 * f32) + Math_fround(f25 * f26)) + Math_fround(f27 * f24));
 f23 = Math_fround(Math_fround(Math_fround(f26 * f31) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f32 * f27))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f32) - Math_fround(f30 * f26))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f23;
 HEAPF32[i15 + 8 >> 2] = f10;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i22, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, f7) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i53 = HEAP32[i3 + 4 >> 2] | 0;
 i52 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i53;
 HEAP32[i13 + 8 >> 2] = i52;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i53 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i52;
 HEAP32[i14 + 8 >> 2] = i53;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN5physx9NpFactory7releaseEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 4 | 0;
 i11 = i14;
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i13 + 480 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i12, i1);
 i8 = i13 + 456 | 0;
 L4 : do if (!(HEAP32[i13 + 460 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i13 + 464 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L4;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i13 + 448 | 0;
 i7 = i13 + 452 | 0;
 i5 = i13 + 464 | 0;
 L11 : while (1) {
  do {
   if ((i1 | 0) == -1) break L11;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i11 >> 2] = i3;
   i4 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i9 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i12, i11) | 0;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L11;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L11;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  do {
   i9 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i10 = HEAP32[i10 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i13 + 560 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i12, i1);
 i8 = i13 + 536 | 0;
 L37 : do if (!(HEAP32[i13 + 540 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i13 + 544 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L37;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i13 + 528 | 0;
 i7 = i13 + 532 | 0;
 i5 = i13 + 544 | 0;
 L44 : while (1) {
  do {
   if ((i1 | 0) == -1) break L44;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i11 >> 2] = i3;
   i4 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i9 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i12, i11) | 0;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L44;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L44;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  do {
   i9 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i10 = HEAP32[i10 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i13 + 520 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i12, i1);
 i8 = i13 + 496 | 0;
 L70 : do if (!(HEAP32[i13 + 500 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i13 + 504 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L70;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i13 + 488 | 0;
 i7 = i13 + 492 | 0;
 i5 = i13 + 504 | 0;
 L77 : while (1) {
  do {
   if ((i1 | 0) == -1) break L77;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i11 >> 2] = i3;
   i4 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i9 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i12, i11) | 0;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L77;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L77;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  do {
   i9 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i10 = HEAP32[i10 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i13 + 600 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i12, i1);
 i8 = i13 + 576 | 0;
 L103 : do if (!(HEAP32[i13 + 580 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i13 + 584 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L103;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i13 + 568 | 0;
 i7 = i13 + 572 | 0;
 i5 = i13 + 584 | 0;
 L110 : while (1) {
  do {
   if ((i1 | 0) == -1) break L110;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i11 >> 2] = i3;
   i4 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i9 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i12, i11) | 0;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L110;
   }
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L110;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  do {
   i11 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i11 = HEAP32[i10 >> 2] | 0;
 if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
  }
 }
 i1 = i13 + 640 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i13 + 608 | 0;
  do __ZN5physx7NpShape15releaseInternalEv(HEAP32[HEAP32[i2 >> 2] >> 2] | 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i1 = i13 + 3948 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __ZN5physx13GuMeshFactory7releaseEv(i13);
  STACKTOP = i14;
  return;
 }
 i2 = i13 + 3944 | 0;
 do {
  i12 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0);
 } while ((HEAP32[i1 >> 2] | 0) != 0);
 __ZN5physx13GuMeshFactory7releaseEv(i13);
 STACKTOP = i14;
 return;
}

function __ZN9AudioClip8TransferI14SafeBinaryReadEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i9, i10);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip8LoadTypeEEvRT_RT0_PKc17TransferMetaFlags(i10, i9 + 52 | 0, gb + 853560 | 0, 0);
 i4 = i9 + 36 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853571 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i9 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853582 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i9 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853594 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i9 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 906581 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i9 + 44 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853610 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i9 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853628 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i7 = 59; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i9 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853644 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i9 + 65 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853663 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i9 + 66 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853682 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i9 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853693 | 0, gb + 853704 | 0, i8, 1) | 0;
 if (!i1) {
  i9 = i9 + 104 | 0;
  __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip17CompressionFormatEEvRT_RT0_PKc17TransferMetaFlags(i10, i9, gb + 853721 | 0, 0);
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN16StreamedResource8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 i9 = i9 + 104 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip17CompressionFormatEEvRT_RT0_PKc17TransferMetaFlags(i10, i9, gb + 853721 | 0, 0);
 STACKTOP = i11;
 return;
}

function __ZN19SpriteMeshGenerator4path9clip_edgeEi(i34, i31) {
 i34 = i34 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, f4 = f0, f5 = f0, d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i38 + 32 | 0;
 i32 = i38;
 i36 = i34 + 4 | 0;
 i2 = HEAP32[i36 >> 2] | 0;
 i1 = HEAP32[i34 >> 2] | 0;
 i30 = i2 - i1 | 0;
 i33 = i30 >> 5;
 HEAP32[i35 >> 2] = 0;
 i37 = i35 + 4 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i35 + 8 >> 2] = 0;
 if ((i30 | 0) > 0) {
  i16 = i34 + 28 | 0;
  i17 = i32 + 16 | 0;
  i18 = i35 + 8 | 0;
  i19 = i32 + 8 | 0;
  i20 = i32 + 12 | 0;
  i21 = i34 + 36 | 0;
  i22 = i34 + 32 | 0;
  i23 = i34 + 40 | 0;
  i24 = i32 + 16 | 0;
  i25 = i32 + 8 | 0;
  i26 = i32 + 12 | 0;
  i27 = i32 + 16 | 0;
  i28 = i32 + 8 | 0;
  i29 = i32 + 12 | 0;
  i15 = 0;
  do {
   i1 = HEAP32[i34 >> 2] | 0;
   i10 = HEAP32[i1 + (i15 << 5) >> 2] | 0;
   i11 = HEAP32[i1 + (i15 << 5) + 4 >> 2] | 0;
   i15 = i15 + 1 | 0;
   i30 = (i15 | 0) < (i33 | 0);
   if (i30) i2 = i15; else i2 = (i15 | 0) % (i33 | 0) | 0;
   i13 = HEAP32[i1 + (i2 << 5) >> 2] | 0;
   i12 = HEAP32[i1 + (i2 << 5) + 4 >> 2] | 0;
   L8 : do switch (i31 | 0) {
   case 1:
    {
     f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = Math_fround(HEAPF32[i16 >> 2]);
     i1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f5;
     if (!(f4 >= f5)) if (i1) {
      i14 = 44;
      break L8;
     } else break L8; else if (i1) {
      i14 = 35;
      break L8;
     } else {
      i14 = 25;
      break L8;
     }
    }
   case 2:
    {
     f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = Math_fround(HEAPF32[i21 >> 2]);
     i1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= f5;
     if (!(f4 <= f5)) if (i1) {
      i14 = 44;
      break L8;
     } else break L8; else if (i1) {
      i14 = 35;
      break L8;
     } else {
      i14 = 25;
      break L8;
     }
    }
   case 8:
    {
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = Math_fround(HEAPF32[i22 >> 2]);
     i1 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f5;
     if (!(f4 >= f5)) if (i1) {
      i14 = 44;
      break L8;
     } else break L8; else if (i1) {
      i14 = 35;
      break L8;
     } else {
      i14 = 25;
      break L8;
     }
    }
   case 4:
    {
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = Math_fround(HEAPF32[i23 >> 2]);
     i1 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= f5;
     if (!(f4 <= f5)) if (i1) {
      i14 = 44;
      break L8;
     } else break L8; else if (i1) {
      i14 = 35;
      break L8;
     } else {
      i14 = 25;
      break L8;
     }
    }
   default:
    {}
   } while (0);
   if ((i14 | 0) == 25) {
    i14 = 0;
    f40 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = Math_fround(f40 - f5);
    f39 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    d8 = +Math_fround(f40 / Math_fround(f39 - f4));
    HEAPF64[tempDoublePtr >> 3] = d8;
    i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
    d3 = +f4;
    d9 = +f5 - d3 * d8;
    switch (i31 | 0) {
    case 2:
     {
      i1 = i21;
      i14 = 27;
      break;
     }
    case 1:
     {
      i1 = i16;
      i14 = 27;
      break;
     }
    case 8:
     {
      i1 = i22;
      i14 = 29;
      break;
     }
    case 4:
     {
      i1 = i23;
      i14 = 29;
      break;
     }
    default:
     {
      d7 = 0.0;
      d3 = 0.0;
     }
    }
    if ((i14 | 0) == 27) {
     d3 = +Math_fround(HEAPF32[i1 >> 2]);
     d7 = d9 + d8 * d3;
    } else if ((i14 | 0) == 29) {
     d6 = +Math_fround(HEAPF32[i1 >> 2]);
     if (0 == 0 & (i2 & 2146435072 | 0) == 2146435072) d7 = d6; else {
      d7 = d6;
      d3 = (d6 - d9) / d8;
     }
    }
    f5 = Math_fround(d3);
    f4 = Math_fround(d7);
    f39 = Math_fround(f5);
    f40 = Math_fround(f4);
    HEAP32[i27 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    HEAP32[i27 + 12 >> 2] = 0;
    i1 = i32;
    HEAPF32[i1 >> 2] = f39;
    HEAPF32[i1 + 4 >> 2] = f40;
    i1 = HEAP32[i37 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i35, i32); else {
     HEAPF32[i1 >> 2] = f5;
     HEAPF32[i1 + 4 >> 2] = f4;
     HEAP32[i1 + 8 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i29 >> 2];
     i14 = i1 + 16 | 0;
     HEAP32[i14 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     HEAP32[i37 >> 2] = i1 + 32;
    }
    i14 = 35;
   } else if ((i14 | 0) == 44) {
    i14 = 0;
    f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = Math_fround(f4 - f40);
    f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    d8 = +Math_fround(f4 / Math_fround(f5 - f39));
    HEAPF64[tempDoublePtr >> 3] = d8;
    i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
    d3 = +f39;
    d9 = +f40 - d3 * d8;
    switch (i31 | 0) {
    case 2:
     {
      i1 = i21;
      i14 = 46;
      break;
     }
    case 1:
     {
      i1 = i16;
      i14 = 46;
      break;
     }
    case 8:
     {
      i1 = i22;
      i14 = 48;
      break;
     }
    case 4:
     {
      i1 = i23;
      i14 = 48;
      break;
     }
    default:
     {
      d7 = 0.0;
      d3 = 0.0;
     }
    }
    if ((i14 | 0) == 46) {
     i14 = 0;
     d3 = +Math_fround(HEAPF32[i1 >> 2]);
     d7 = d9 + d8 * d3;
    } else if ((i14 | 0) == 48) {
     i14 = 0;
     d6 = +Math_fround(HEAPF32[i1 >> 2]);
     if (0 == 0 & (i2 & 2146435072 | 0) == 2146435072) d7 = d6; else {
      d7 = d6;
      d3 = (d6 - d9) / d8;
     }
    }
    f5 = Math_fround(d3);
    f4 = Math_fround(d7);
    f39 = Math_fround(f5);
    f40 = Math_fround(f4);
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i17 + 12 >> 2] = 0;
    i1 = i32;
    HEAPF32[i1 >> 2] = f39;
    HEAPF32[i1 + 4 >> 2] = f40;
    i1 = HEAP32[i37 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i35, i32); else {
     HEAPF32[i1 >> 2] = f5;
     HEAPF32[i1 + 4 >> 2] = f4;
     HEAP32[i1 + 8 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i20 >> 2];
     i13 = i1 + 16 | 0;
     HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     HEAP32[i37 >> 2] = i1 + 32;
    }
   }
   if ((i14 | 0) == 35) {
    i14 = 0;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    i1 = i32;
    HEAP32[i1 >> 2] = i13;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = HEAP32[i37 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i35, i32); else {
     HEAP32[i1 >> 2] = i13;
     HEAP32[i1 + 4 >> 2] = i12;
     HEAP32[i1 + 8 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i26 >> 2];
     i13 = i1 + 16 | 0;
     HEAP32[i13 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
     HEAP32[i37 >> 2] = i1 + 32;
    }
   }
  } while (i30);
  i2 = HEAP32[i36 >> 2] | 0;
  i1 = HEAP32[i34 >> 2] | 0;
 }
 if ((i2 | 0) != (i1 | 0)) HEAP32[i36 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 if ((i34 | 0) != (i35 | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i34, HEAP32[i35 >> 2] | 0, HEAP32[i37 >> 2] | 0);
 i1 = HEAP32[i35 >> 2] | 0;
 if (!i1) {
  STACKTOP = i38;
  return;
 }
 i2 = HEAP32[i37 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i37 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 __ZdlPv(i1);
 STACKTOP = i38;
 return;
}

function __ZN5physxL20PxcSweepBoxTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf(i8, i4, i10, i11, i5, i6, f7, i13, i14, i1, i2, i3, i12, f9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 304 | 0;
 i16 = i4 + 288 | 0;
 i21 = i4 + 128 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i52 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i50 = HEAP32[i52 + 40 >> 2] | 0;
 i51 = HEAP32[i52 + 44 >> 2] | 0;
 i52 = HEAP32[i52 + 48 >> 2] | 0;
 i49 = i21 + 64 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 80 >> 2] = 3;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i49 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i49 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i49 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i49 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i21 + 144 >> 2] = i50;
 HEAP32[i21 + 148 >> 2] = i51;
 HEAP32[i21 + 152 >> 2] = i52;
 HEAPF32[i21 + 156 >> 2] = Math_fround(0.0);
 f38 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f45 = f38 <= f45 ? f38 : f45;
 f44 = f45 <= f44 ? f45 : f44;
 HEAPF32[i21 + 16 >> 2] = Math_fround(f44 * Math_fround(.150000006));
 HEAPF32[i21 + 32 >> 2] = Math_fround(f44 * Math_fround(.0500000007));
 i52 = HEAP32[i10 >> 2] | 0;
 i51 = HEAP32[i10 + 4 >> 2] | 0;
 i50 = HEAP32[i10 + 8 >> 2] | 0;
 i49 = HEAP32[i10 + 12 >> 2] | 0;
 i46 = i5 + 16 | 0;
 i48 = HEAP32[i46 >> 2] | 0;
 i47 = HEAP32[i46 + 4 >> 2] | 0;
 i46 = HEAP32[i46 + 8 >> 2] | 0;
 f44 = Math_fround(HEAPF32[i11 >> 2]);
 f45 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f43 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i5 = i6 + 16 | 0;
 f29 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 HEAP32[i19 >> 2] = i52;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = i51;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = i50;
 i8 = i19 + 12 | 0;
 HEAP32[i8 >> 2] = i49;
 HEAP32[i19 + 16 >> 2] = i48;
 HEAP32[i19 + 20 >> 2] = i47;
 HEAP32[i19 + 24 >> 2] = i46;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f41 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = Math_fround(-f41);
 f36 = Math_fround(-f36);
 f33 = Math_fround(-f33);
 f23 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f29 - f23);
 f37 = Math_fround(f24 - f25);
 f39 = Math_fround(f26 - f31);
 f40 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f42 = Math_fround(Math_fround(Math_fround(f27 * f41) + Math_fround(f37 * f36)) + Math_fround(f39 * f33));
 f28 = Math_fround(Math_fround(Math_fround(f42 * f36) + Math_fround(Math_fround(f40 * f37) + Math_fround(f30 * Math_fround(Math_fround(f27 * f33) - Math_fround(f39 * f41))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) + Math_fround(f30 * Math_fround(Math_fround(f37 * f41) - Math_fround(f27 * f36)))) + Math_fround(f42 * f33)) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(f43 * f30) - Math_fround(Math_fround(Math_fround(f44 * f41) + Math_fround(f45 * f36)) + Math_fround(f38 * f33)));
 f35 = Math_fround(Math_fround(Math_fround(f38 * f36) - Math_fround(f45 * f33)) + Math_fround(Math_fround(f43 * f41) + Math_fround(f44 * f30)));
 f32 = Math_fround(Math_fround(Math_fround(f44 * f33) - Math_fround(f38 * f41)) + Math_fround(Math_fround(f43 * f36) + Math_fround(f45 * f30)));
 f38 = Math_fround(Math_fround(Math_fround(f45 * f41) - Math_fround(f44 * f36)) + Math_fround(Math_fround(f43 * f33) + Math_fround(f38 * f30)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(Math_fround(f40 * f27) + Math_fround(f30 * Math_fround(Math_fround(f39 * f36) - Math_fround(f37 * f33))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f28;
 HEAPF32[i20 + 56 >> 2] = f22;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f22 = Math_fround(f35 + f35);
 f28 = Math_fround(f32 + f32);
 f33 = Math_fround(f38 + f38);
 f37 = Math_fround(f32 * f28);
 f36 = Math_fround(f38 * f33);
 f32 = Math_fround(f32 * f22);
 f39 = Math_fround(f38 * f22);
 f30 = Math_fround(f34 * f22);
 f38 = Math_fround(f38 * f28);
 f28 = Math_fround(f34 * f28);
 f33 = Math_fround(f34 * f33);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f35 * f22));
 f35 = Math_fround(f32 + f33);
 f34 = Math_fround(f39 - f28);
 f33 = Math_fround(f32 - f33);
 f32 = Math_fround(f22 - f36);
 f27 = Math_fround(f38 + f30);
 f28 = Math_fround(f39 + f28);
 f30 = Math_fround(f38 - f30);
 f22 = Math_fround(f22 - f37);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f37) - f36);
 HEAPF32[i20 + 4 >> 2] = f35;
 HEAPF32[i20 + 8 >> 2] = f34;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f33;
 HEAPF32[i20 + 20 >> 2] = f32;
 HEAPF32[i20 + 24 >> 2] = f27;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f28;
 HEAPF32[i20 + 36 >> 2] = f30;
 HEAPF32[i20 + 40 >> 2] = f22;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(f9 - f23);
 f25 = Math_fround(f22 - f25);
 f31 = Math_fround(f30 - f31);
 f29 = Math_fround(f28 - f29);
 f24 = Math_fround(f27 - f24);
 f26 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) - f26);
 HEAPF32[i18 >> 2] = f29;
 HEAPF32[i18 + 4 >> 2] = f24;
 HEAPF32[i18 + 8 >> 2] = f26;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f29 = Math_fround(f23 - f29);
 f24 = Math_fround(f25 - f24);
 f26 = Math_fround(f31 - f26);
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f27 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f31) + Math_fround(f24 * f25)) + Math_fround(f26 * f23));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f30) + Math_fround(Math_fround(f24 * f28) - Math_fround(f27 * Math_fround(Math_fround(f29 * f23) - Math_fround(f31 * f26))))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f23 * f30) + Math_fround(Math_fround(f26 * f28) - Math_fround(f27 * Math_fround(Math_fround(f24 * f31) - Math_fround(f29 * f25))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f22;
 HEAPF32[i15 + 8 >> 2] = f9;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i12, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, f7) | 0)) {
  f45 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f45);
 }
 f45 = Math_fround(HEAPF32[i2 >> 2]);
 i52 = HEAP32[i3 + 4 >> 2] | 0;
 i51 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i52;
 HEAP32[i13 + 8 >> 2] = i51;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i52 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i51;
 HEAP32[i14 + 8 >> 2] = i52;
 STACKTOP = i4;
 return Math_fround(f45);
}

function __ZN5physx14PxsAABBManager16updateAABBsAndBPEjjjPNS_10PxBaseTaskEPjjbPi(i19, i1, i3, i4, i18, i8, i7, i5, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i18 = i18 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i20 + 20 | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i3;
 HEAP32[i17 + 8 >> 2] = i4;
 HEAP8[i17 + 12 >> 0] = i5 & 1;
 HEAP32[i17 + 16 >> 2] = i2;
 i1 = i19 + 512 | 0;
 i4 = HEAP32[i19 + 36 >> 2] | 0;
 if (i4 | 0) {
  do if (i4 >>> 0 > 4096) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i19 + 16896 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1, gb + 717789 | 0, 1930) | 0;
    HEAP32[i19 + 16900 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    HEAP32[i19 + 16900 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i19 + 16900 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i19 + 16904 >> 2] = i4;
 }
 HEAP32[i19 + 16912 >> 2] = 0;
 i1 = i19 + 16928 | 0;
 i4 = HEAP32[i19 + 324 >> 2] | 0;
 if (i4 | 0) {
  do if (i4 >>> 0 > 4096) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i19 + 33312 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1, gb + 717789 | 0, 1930) | 0;
    HEAP32[i19 + 33316 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    HEAP32[i19 + 33316 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i19 + 33316 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i19 + 33320 >> 2] = i4;
 }
 HEAP32[i19 + 33328 >> 2] = 0;
 i1 = i19 + 33344 | 0;
 i4 = HEAP32[i19 + 264 >> 2] | 0;
 if (i4 | 0) {
  do if (i4 >>> 0 > 1024) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i19 + 37440 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1, gb + 717789 | 0, 1930) | 0;
    HEAP32[i19 + 37444 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    HEAP32[i19 + 37444 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i19 + 37444 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i19 + 37448 >> 2] = i4;
 }
 i1 = i19 + 37456 | 0;
 i4 = HEAP32[i19 + 196 >> 2] | 0;
 if (i4 | 0) {
  do if (i4 >>> 0 > 1024) {
   i2 = i4 << 2;
   i1 = i2 + 15 & -16;
   i3 = HEAP32[i19 + 41552 >> 2] | 0;
   if (!i3) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1, gb + 717789 | 0, 1930) | 0;
    HEAP32[i19 + 41556 >> 2] = i1;
    break;
   } else {
    i1 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i1, 1) | 0;
    HEAP32[i19 + 41556 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i19 + 41556 >> 2] = i1;
   i2 = i4 << 2;
  } while (0);
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i19 + 41560 >> 2] = i4;
 }
 HEAP32[i19 + 41568 >> 2] = 0;
 __ZN5physx14PxsAABBManager22computeAABBUpdateListsEPjjRKNS_20PxsComputeAABBParamsE(i19, i8, i7, i17);
 __ZN5physx14PxsAABBManager31removeEmptyActorsFromAggregatesEv(i19);
 _memset(HEAP32[i19 + 280 >> 2] | 0, 0, HEAP32[i19 + 284 >> 2] << 2 | 0) | 0;
 i5 = HEAP32[i19 + 136 >> 2] | 0;
 i6 = HEAP32[i19 + 140 >> 2] | 0;
 if (i6 | 0) {
  i7 = i19 + 32 | 0;
  i2 = i19 + 20 | 0;
  i8 = i19 + 12 | 0;
  i9 = i19 + 16 | 0;
  i10 = i19 + 24 | 0;
  i11 = i19 + 28 | 0;
  i12 = i19 + 40 | 0;
  i13 = i19 + 52 | 0;
  i14 = i19 + 44 | 0;
  i15 = i19 + 64 | 0;
  i3 = i19 + 56 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i16 = 0;
  do {
   i4 = HEAP32[i5 + (i16 << 2) >> 2] | 0;
   i1 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   do if ((i1 | 0) != 1073741823) if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0)) {
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 3) >> 2] = HEAP32[i13 >> 2];
    HEAP32[i13 >> 2] = i1;
    break;
   } else {
    HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 4) >> 2] = HEAP32[i15 >> 2];
    HEAP32[i15 >> 2] = i1;
    break;
   } while (0);
   i21 = HEAP32[i8 >> 2] | 0;
   HEAP32[i21 + (i4 * 24 | 0) + 8 >> 2] = -8388609;
   HEAP32[i21 + (i4 * 24 | 0) + 4 >> 2] = -8388609;
   HEAP32[i21 + (i4 * 24 | 0) >> 2] = -8388609;
   HEAP32[i21 + (i4 * 24 | 0) + 20 >> 2] = 8388608;
   HEAP32[i21 + (i4 * 24 | 0) + 16 >> 2] = 8388608;
   HEAP32[i21 + (i4 * 24 | 0) + 12 >> 2] = 8388608;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = 0;
   i21 = (HEAP32[i2 >> 2] | 0) + (i4 << 2) | 0;
   HEAP32[i21 >> 2] = 1073741823;
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = 1073741823;
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + (i4 << 2) >> 2] = 1073741823;
   HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = 1073741823;
   HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i4;
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i6 | 0));
 }
 i2 = i19 + 49868 | 0;
 HEAP32[i19 + 49888 >> 2] = 3;
 i3 = i19 + 51100 | 0;
 HEAP32[i19 + 51120 >> 2] = 2;
 i4 = i19 + 51556 | 0;
 HEAP32[i19 + 51596 >> 2] = i19;
 HEAP32[i19 + 51124 >> 2] = i19;
 i5 = i19 + 51056 | 0;
 HEAP32[i19 + 51096 >> 2] = i19;
 i6 = i19 + 51012 | 0;
 HEAP32[i19 + 51032 >> 2] = i19;
 i7 = i19 + 50608 | 0;
 HEAP32[i19 + 50628 >> 2] = i19;
 HEAP32[i19 + 49892 >> 2] = i19;
 i8 = i19 + 50324 | 0;
 HEAP32[i19 + 50344 >> 2] = i19;
 i1 = i19 + 51576 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 51128 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 51076 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 51036 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 50632 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 49896 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i1 = i19 + 50348 | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i19 + 51572 >> 2] = 1;
 i1 = i19 + 51568 | 0;
 HEAP32[i1 >> 2] = i18;
 if (i18 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
  HEAP32[i19 + 51564 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 HEAP32[i19 + 51116 >> 2] = 1;
 i21 = i19 + 51112 | 0;
 HEAP32[i21 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 HEAP32[i19 + 51108 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 HEAP32[i19 + 51072 >> 2] = 1;
 i21 = i19 + 51068 | 0;
 HEAP32[i21 >> 2] = i3;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
 HEAP32[i19 + 51064 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 HEAP32[i19 + 51028 >> 2] = 1;
 i21 = i19 + 51024 | 0;
 HEAP32[i21 >> 2] = i5;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
 HEAP32[i19 + 51020 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 HEAP32[i19 + 50624 >> 2] = 1;
 i21 = i19 + 50620 | 0;
 HEAP32[i21 >> 2] = i6;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
 HEAP32[i19 + 50616 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 HEAP32[i19 + 49884 >> 2] = 1;
 i21 = i19 + 49880 | 0;
 HEAP32[i21 >> 2] = i7;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
 HEAP32[i19 + 49876 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 HEAP32[i19 + 50340 >> 2] = 1;
 i21 = i19 + 50336 | 0;
 HEAP32[i21 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 HEAP32[i19 + 50332 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 STACKTOP = i20;
 return;
}

function __ZN8GUIStyle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034568 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034591 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034599 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034608 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034618 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034629 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 136 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034639 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 156 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034650 | 0, gb + 1034577 | 0, i7, 0);
 __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 176 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034662 | 0, gb + 1033949 | 0, i7, 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 192 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034671 | 0, gb + 1033949 | 0, i7, 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 208 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034680 | 0, gb + 1033949 | 0, i7, 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 224 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034690 | 0, gb + 1033949 | 0, i7, 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 240 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034701 | 0, gb + 1034708 | 0, i7, 0);
 i6 = i8 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034730 | 0, i8, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034741 | 0, i8, i1 + 288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034753 | 0, i8, i1 + 244 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034765 | 0, i6, i1 + 248 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034776 | 0, i6, i1 + 249 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034787 | 0, i8, i1 + 252 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034802 | 0, i8, i1 + 256 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 260 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034818 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 264 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034834 | 0, i7, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034847 | 0, i7, i1 + 280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034861 | 0, i6, i1 + 292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034876 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 293 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __Z19SetupShadowCullDataR6CameraRK17ShaderReplaceDataPK22SceneCullingParametersR14ShadowCullData(i16, i17, i18, i19) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 96 | 0;
 i10 = i22 + 80 | 0;
 i15 = i22 + 16 | 0;
 i9 = i22;
 __ZNK6Camera13GetCameraRectEb(i10, i16, 1);
 f21 = Math_fround(__ZNK6Camera23CalculateShadowDistanceEv(i16));
 __ZNK6Camera22GetCameraToWorldMatrixEv(i15, i16);
 f4 = Math_fround(HEAPF32[i15 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i15 + 36 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 40 >> 2]);
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
 if (f7 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f4 = Math_fround(f4 / f7);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  f5 = Math_fround(f5 / f7);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  f7 = Math_fround(f6 / f7);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = HEAP32[gb + 1162364 >> 2] | 0;
  i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f5 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f6 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i8 = i19 + 516 | 0;
 __ZNK6Camera11GetPositionEv(i20, i16);
 HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAPF32[i19 + 528 >> 2] = f5;
 HEAPF32[i19 + 532 >> 2] = f6;
 HEAPF32[i19 + 536 >> 2] = f7;
 i1 = i19 + 448 | 0;
 i2 = __ZNK6Camera16GetCullingMatrixEv(i16) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i19 + 512 >> 2] = HEAP32[i16 + 880 >> 2];
 i15 = i19 + 548 | 0;
 HEAP8[i15 >> 0] = HEAP8[i18 + 818 >> 0] | 0;
 HEAP8[i19 + 549 >> 0] = HEAP8[i16 + 1088 >> 0] | 0;
 HEAP32[i19 + 552 >> 2] = HEAP32[i16 + 916 >> 2];
 __ZNK6Camera13GetCameraRectEb(i9, i16, 0);
 HEAPF32[i19 + 556 >> 2] = Math_fround(~~Math_fround(HEAPF32[i9 + 12 >> 2]) | 0);
 HEAPF32[i19 + 780 >> 2] = f21;
 i11 = i19 + 784 | 0;
 HEAPF32[i11 >> 2] = Math_fround(__ZNK6Camera17GetProjectionNearEv(i16));
 i12 = i19 + 788 | 0;
 HEAPF32[i12 >> 2] = Math_fround(__ZNK6Camera16GetProjectionFarEv(i16));
 HEAPF32[i19 + 792 >> 2] = Math_fround(__ZNK6Camera7GetNearEv(i16));
 HEAPF32[i19 + 796 >> 2] = Math_fround(__ZNK6Camera6GetFarEv(i16));
 i13 = i19 + 800 | 0;
 HEAPF32[i13 >> 2] = Math_fround(__ZNK6Camera6GetFovEv(i16));
 i14 = i19 + 804 | 0;
 HEAPF32[i14 >> 2] = Math_fround(__ZNK6Camera9GetAspectEv(i16));
 HEAPF32[i19 + 808 >> 2] = Math_fround(f21 / Math_fround(HEAPF32[i12 >> 2]));
 HEAP32[i19 + 540 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i19 + 544 >> 2] = HEAP32[i10 + 12 >> 2];
 __ZNK6Camera22GetCameraToWorldMatrixEv(i20, i16);
 i1 = i19;
 i2 = i20;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i9 = i19 + 192 | 0;
 i1 = i9;
 i2 = __ZNK6Camera20GetWorldToClipMatrixEv(i16) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i2 = i19 + 64 | 0;
 __Z20InvertMatrix4x4_FullPKfPf(i9, i2) | 0;
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f7 / Math_fround(HEAPF32[i11 >> 2]));
 __Z16GetFrustumPointsRK10Matrix4x4fP8Vector3f(i2, i20);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(HEAPF32[i19 + 520 >> 2]);
 f6 = Math_fround(HEAPF32[i19 + 524 >> 2]);
 i1 = 0;
 while (1) {
  i10 = i1 + 4 | 0;
  f25 = Math_fround(HEAPF32[i20 + (i1 * 12 | 0) >> 2]);
  f28 = Math_fround(f25 - f4);
  f24 = Math_fround(HEAPF32[i20 + (i1 * 12 | 0) + 4 >> 2]);
  f27 = Math_fround(f24 - f5);
  f23 = Math_fround(HEAPF32[i20 + (i1 * 12 | 0) + 8 >> 2]);
  f28 = Math_fround(f4 + Math_fround(f7 * f28));
  f27 = Math_fround(f5 + Math_fround(f7 * f27));
  f26 = Math_fround(f6 + Math_fround(f7 * Math_fround(f23 - f6)));
  f31 = Math_fround(HEAPF32[i20 + (i10 * 12 | 0) >> 2]);
  f28 = Math_fround(f28 - f31);
  f30 = Math_fround(HEAPF32[i20 + (i10 * 12 | 0) + 4 >> 2]);
  f27 = Math_fround(f27 - f30);
  f29 = Math_fround(HEAPF32[i20 + (i10 * 12 | 0) + 8 >> 2]);
  f26 = Math_fround(f26 - f29);
  f25 = Math_fround(f31 - f25);
  f24 = Math_fround(f30 - f24);
  f23 = Math_fround(f29 - f23);
  i1 = i1 + 1 | 0;
  if (!(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)) + Math_fround(f26 * f26)) <= Math_fround(Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)) + Math_fround(f23 * f23)) * Math_fround(.00999999977)))) {
   i1 = 7;
   break;
  }
  if ((i1 | 0) >= 4) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  f29 = Math_fround(__ZNK6Camera7GetNearEv(i16));
  f30 = Math_fround(__ZNK6Camera6GetFarEv(i16));
  f31 = Math_fround(__ZNK6Camera6GetFovEv(i16));
  __ZNK6Camera27GetImplicitProjectionMatrixEffffR10Matrix4x4f(i16, f29, f30, f31, Math_fround(__ZNK6Camera9GetAspectEv(i16)), i20);
  i10 = i19 + 128 | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i20, __ZNK6Camera22GetWorldToCameraMatrixEv(i16) | 0, i10);
  __Z20InvertMatrix4x4_FullPKfPf(i10, i2) | 0;
 } else if ((i1 | 0) == 8) {
  i1 = i19 + 128 | 0;
  i2 = i9;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
 }
 if (HEAP8[i15 >> 0] | 0) {
  i1 = i19 + 256 | 0;
  i2 = __ZNK6Camera26GetStereoWorldToClipMatrixE15StereoscopicEye(i16, 0) | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = i19 + 320 | 0;
  i2 = __ZNK6Camera26GetStereoWorldToClipMatrixE15StereoscopicEye(i16, 1) | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
 }
 f29 = Math_fround(HEAPF32[i11 >> 2]);
 f30 = Math_fround(HEAPF32[i12 >> 2]);
 f31 = Math_fround(HEAPF32[i13 >> 2]);
 __ZNK6Camera27GetImplicitProjectionMatrixEffffR10Matrix4x4f(i16, f29, f30, f31, Math_fround(HEAPF32[i14 >> 2]), i19 + 384 | 0);
 i13 = i19 + 660 | 0;
 i15 = i19 + 560 | 0;
 __ZNK6Camera22CalculateFrustumPlanesEP5PlaneRK10Matrix4x4ffRfb(i16, i13, i19 + 128 | 0, f21, i15, 1);
 i14 = i19 + 564 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i19 + 580 | 0;
 i13 = i19 + 676 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i19 + 596 | 0;
 i13 = i19 + 692 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i19 + 612 | 0;
 i13 = i19 + 708 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i19 + 628 | 0;
 i13 = i19 + 724 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i14 = i19 + 644 | 0;
 i13 = i19 + 740 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 f31 = Math_fround(HEAPF32[i15 >> 2]);
 HEAPF32[i19 + 656 >> 2] = Math_fround(f31 + Math_fround(__ZNK6Camera6GetFarEv(i16)));
 i15 = i19 + 756 | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i20 >> 2] = Math_fround(999999986.0e6);
 HEAP8[i19 + 776 >> 0] = (__ZL29CalculateSphericalShadowRangeRK6CameraR8Vector3fRf(i16, i15, i20) | 0) & 1;
 i20 = HEAP32[i20 >> 2] | 0;
 HEAP32[i19 + 768 >> 2] = i20;
 f31 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i19 + 772 >> 2] = Math_fround(f31 * f31);
 _memmove(i19 + 812 | 0, i16 + 932 | 0, 128) | 0;
 HEAP8[i19 + 940 >> 0] = HEAP8[i16 + 1090 >> 0] | 0;
 i16 = i17;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = i19 + 944 | 0;
 HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i20 + 4 >> 2] = i17;
 HEAP32[i19 + 952 >> 2] = i18;
 STACKTOP = i22;
 return;
}

function __ZN37ConvexVsMeshContactGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i16, i6, i2, i3, i4, i1, i17) {
 i16 = i16 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!(__ZNK5physx2Gu15OBBTriangleTest10obbTriTestERKNS_6PxVec3ES4_S4_(i16 + 3100 | 0, i2, i3, i4) | 0)) {
  STACKTOP = i15;
  return 1;
 }
 if (!(HEAP8[i16 + 3092 >> 0] | 0)) {
  i12 = HEAP32[i16 + 3084 >> 2] | 0;
  f24 = Math_fround(HEAPF32[i2 >> 2]);
  f25 = Math_fround(f24 * Math_fround(HEAPF32[i12 >> 2]));
  i13 = i12 + 4 | 0;
  f26 = Math_fround(f24 * Math_fround(HEAPF32[i13 >> 2]));
  i1 = i12 + 8 | 0;
  f24 = Math_fround(f24 * Math_fround(HEAPF32[i1 >> 2]));
  f21 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i11 = i12 + 12 | 0;
  f23 = Math_fround(f21 * Math_fround(HEAPF32[i11 >> 2]));
  i8 = i12 + 16 | 0;
  f22 = Math_fround(f21 * Math_fround(HEAPF32[i8 >> 2]));
  i10 = i12 + 20 | 0;
  f23 = Math_fround(f25 + f23);
  f22 = Math_fround(f26 + f22);
  f21 = Math_fround(f24 + Math_fround(f21 * Math_fround(HEAPF32[i10 >> 2])));
  f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i9 = i12 + 24 | 0;
  f26 = Math_fround(f24 * Math_fround(HEAPF32[i9 >> 2]));
  i7 = i12 + 28 | 0;
  f25 = Math_fround(f24 * Math_fround(HEAPF32[i7 >> 2]));
  i5 = i12 + 32 | 0;
  f26 = Math_fround(f23 + f26);
  f25 = Math_fround(f22 + f25);
  f24 = Math_fround(f21 + Math_fround(f24 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i14 >> 2] = f26;
  HEAPF32[i14 + 4 >> 2] = f25;
  HEAPF32[i14 + 8 >> 2] = f24;
  f21 = Math_fround(HEAPF32[i3 >> 2]);
  f22 = Math_fround(f21 * Math_fround(HEAPF32[i12 >> 2]));
  f23 = Math_fround(f21 * Math_fround(HEAPF32[i13 >> 2]));
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i1 >> 2]));
  f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f20 = Math_fround(f18 * Math_fround(HEAPF32[i11 >> 2]));
  f19 = Math_fround(f18 * Math_fround(HEAPF32[i8 >> 2]));
  f20 = Math_fround(f22 + f20);
  f19 = Math_fround(f23 + f19);
  f18 = Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPF32[i10 >> 2])));
  f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f23 = Math_fround(f21 * Math_fround(HEAPF32[i9 >> 2]));
  f22 = Math_fround(f21 * Math_fround(HEAPF32[i7 >> 2]));
  f23 = Math_fround(f20 + f23);
  f22 = Math_fround(f19 + f22);
  f21 = Math_fround(f18 + Math_fround(f21 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i14 + 12 >> 2] = f23;
  HEAPF32[i14 + 16 >> 2] = f22;
  HEAPF32[i14 + 20 >> 2] = f21;
  f18 = Math_fround(HEAPF32[i4 >> 2]);
  f19 = Math_fround(f18 * Math_fround(HEAPF32[i12 >> 2]));
  f20 = Math_fround(f18 * Math_fround(HEAPF32[i13 >> 2]));
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i1 >> 2]));
  f27 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f29 = Math_fround(f27 * Math_fround(HEAPF32[i11 >> 2]));
  f28 = Math_fround(f27 * Math_fround(HEAPF32[i8 >> 2]));
  f29 = Math_fround(f19 + f29);
  f28 = Math_fround(f20 + f28);
  f27 = Math_fround(f18 + Math_fround(f27 * Math_fround(HEAPF32[i10 >> 2])));
  f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f20 = Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2]));
  f19 = Math_fround(f18 * Math_fround(HEAPF32[i7 >> 2]));
  f20 = Math_fround(f29 + f20);
  f19 = Math_fround(f28 + f19);
  f18 = Math_fround(f27 + Math_fround(f18 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i14 + 24 >> 2] = f20;
  HEAPF32[i14 + 28 >> 2] = f19;
  HEAPF32[i14 + 32 >> 2] = f18;
  i5 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i14 >> 2] = i5;
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i14 + 4 >> 2] = i7;
  i9 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i14 + 8 >> 2] = i9;
  i10 = HEAP32[i3 >> 2] | 0;
  HEAP32[i14 + 12 >> 2] = i10;
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i14 + 16 >> 2] = i8;
  i11 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i14 + 20 >> 2] = i11;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i14 + 24 >> 2] = i13;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i14 + 28 >> 2] = i3;
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i14 + 32 >> 2] = i1;
  i4 = i13;
 }
 i12 = HEAP32[i6 + 8 >> 2] | 0;
 i13 = i16 + 856 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) == 16) {
  i2 = i16 + 860 | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 8 | 0, HEAP32[i16 + 776 >> 2] | 0, HEAP8[i16 + 840 >> 0] | 0, i16 + 584 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 44 | 0, HEAP32[i16 + 780 >> 2] | 0, HEAP8[i16 + 841 >> 0] | 0, i16 + 596 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 80 | 0, HEAP32[i16 + 784 >> 2] | 0, HEAP8[i16 + 842 >> 0] | 0, i16 + 608 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 116 | 0, HEAP32[i16 + 788 >> 2] | 0, HEAP8[i16 + 843 >> 0] | 0, i16 + 620 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 152 | 0, HEAP32[i16 + 792 >> 2] | 0, HEAP8[i16 + 844 >> 0] | 0, i16 + 632 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 188 | 0, HEAP32[i16 + 796 >> 2] | 0, HEAP8[i16 + 845 >> 0] | 0, i16 + 644 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 224 | 0, HEAP32[i16 + 800 >> 2] | 0, HEAP8[i16 + 846 >> 0] | 0, i16 + 656 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 260 | 0, HEAP32[i16 + 804 >> 2] | 0, HEAP8[i16 + 847 >> 0] | 0, i16 + 668 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 296 | 0, HEAP32[i16 + 808 >> 2] | 0, HEAP8[i16 + 848 >> 0] | 0, i16 + 680 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 332 | 0, HEAP32[i16 + 812 >> 2] | 0, HEAP8[i16 + 849 >> 0] | 0, i16 + 692 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 368 | 0, HEAP32[i16 + 816 >> 2] | 0, HEAP8[i16 + 850 >> 0] | 0, i16 + 704 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 404 | 0, HEAP32[i16 + 820 >> 2] | 0, HEAP8[i16 + 851 >> 0] | 0, i16 + 716 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 440 | 0, HEAP32[i16 + 824 >> 2] | 0, HEAP8[i16 + 852 >> 0] | 0, i16 + 728 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 476 | 0, HEAP32[i16 + 828 >> 2] | 0, HEAP8[i16 + 853 >> 0] | 0, i16 + 740 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 512 | 0, HEAP32[i16 + 832 >> 2] | 0, HEAP8[i16 + 854 >> 0] | 0, i16 + 752 | 0) | 0;
  __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i2, i16 + 548 | 0, HEAP32[i16 + 836 >> 2] | 0, HEAP8[i16 + 855 >> 0] | 0, i16 + 764 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i2 = 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i14 + 4 >> 2] | 0;
  i9 = HEAP32[i14 + 8 >> 2] | 0;
  i10 = HEAP32[i14 + 12 >> 2] | 0;
  i8 = HEAP32[i14 + 16 >> 2] | 0;
  i6 = HEAP32[i14 + 20 >> 2] | 0;
  i4 = HEAP32[i14 + 24 >> 2] | 0;
  i3 = HEAP32[i14 + 28 >> 2] | 0;
  i1 = HEAP32[i14 + 32 >> 2] | 0;
 } else i6 = i11;
 i14 = HEAP8[(HEAP32[i16 + 3088 >> 2] | 0) + i12 >> 0] | 0;
 HEAP32[i13 >> 2] = i2 + 1;
 i30 = i2 * 3 | 0;
 HEAP32[i16 + 8 + (i30 * 12 | 0) >> 2] = i5;
 HEAP32[i16 + 8 + (i30 * 12 | 0) + 4 >> 2] = i7;
 HEAP32[i16 + 8 + (i30 * 12 | 0) + 8 >> 2] = i9;
 i11 = i30 + 1 | 0;
 HEAP32[i16 + 8 + (i11 * 12 | 0) >> 2] = i10;
 HEAP32[i16 + 8 + (i11 * 12 | 0) + 4 >> 2] = i8;
 HEAP32[i16 + 8 + (i11 * 12 | 0) + 8 >> 2] = i6;
 i13 = i30 + 2 | 0;
 HEAP32[i16 + 8 + (i13 * 12 | 0) >> 2] = i4;
 HEAP32[i16 + 8 + (i13 * 12 | 0) + 4 >> 2] = i3;
 HEAP32[i16 + 8 + (i13 * 12 | 0) + 8 >> 2] = i1;
 HEAP32[i16 + 584 + (i30 << 2) >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 584 + (i11 << 2) >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i16 + 584 + (i13 << 2) >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 776 + (i2 << 2) >> 2] = i12;
 HEAP8[i16 + 840 + i2 >> 0] = i14;
 STACKTOP = i15;
 return 1;
}

function __ZN7mecanim9animation29GetWeightsFreeformDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb(i28, i26, i17, i30, f31, f32, i9) {
 i28 = i28 | 0;
 i26 = i26 | 0;
 i17 = i17 | 0;
 i30 = i30 | 0;
 f31 = Math_fround(f31);
 f32 = Math_fround(f32);
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i29 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i37 + 4 | 0;
 i33 = i37;
 i34 = i28 + 4 | 0;
 i3 = HEAP32[i34 >> 2] | 0;
 i29 = i34;
 i3 = (i3 | 0) == 0 ? 0 : i3 + i29 | 0;
 i36 = HEAP32[i28 >> 2] | 0;
 i6 = i28 + 12 | 0;
 i25 = HEAP32[i6 >> 2] | 0;
 i6 = (i25 | 0) == 0 ? 0 : i25 + i6 | 0;
 i25 = i28 + 36 | 0;
 i8 = HEAP32[i25 >> 2] | 0;
 i25 = (i8 | 0) == 0 ? 0 : i8 + i25 | 0;
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32))));
 f2 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
 i8 = (i36 | 0) != 0;
 L1 : do if (f2 == f31 ? Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]) == f32 : 0) {
  if (i8) {
   i1 = 0;
   do {
    f10 = Math_fround(f7 - Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]));
    HEAP32[i30 + (i1 << 3) >> 2] = 0;
    HEAPF32[i30 + (i1 << 3) + 4 >> 2] = f10;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i36 | 0));
  }
 } else if (i8) {
  i1 = 0;
  while (1) {
   f4 = Math_fround(HEAPF32[i3 + (i1 << 3) >> 2]);
   f5 = Math_fround(HEAPF32[i3 + (i1 << 3) + 4 >> 2]);
   if (f4 == f2 ? f5 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]) : 0) {
    f10 = Math_fround(f7 - Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]));
    HEAP32[i30 + (i1 << 3) >> 2] = 0;
    HEAPF32[i30 + (i1 << 3) + 4 >> 2] = f10;
   } else {
    f2 = Math_fround(Math_fround(Math_fround(f4 * f31) + Math_fround(f5 * f32)) / Math_fround(f7 * Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))));
    i24 = f2 > Math_fround(-1.0);
    f2 = i24 ? f2 : Math_fround(-1.0);
    i24 = f2 < Math_fround(1.0);
    f2 = Math_fround(+Math_acos(+(i24 ? f2 : Math_fround(1.0))));
    i24 = Math_fround(Math_fround(f4 * f32) - Math_fround(f5 * f31)) < Math_fround(0.0);
    f5 = Math_fround(-f2);
    f10 = Math_fround(f7 - Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]));
    HEAPF32[i30 + (i1 << 3) >> 2] = i24 ? f5 : f2;
    HEAPF32[i30 + (i1 << 3) + 4 >> 2] = f10;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i36 | 0)) break L1;
   f2 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
  }
 } while (0);
 if (i9) {
  if (!i8) {
   STACKTOP = i37;
   return;
  }
  i9 = i28 + 20 | 0;
  i11 = i9;
  i12 = i28 + 28 | 0;
  i13 = i12;
  i8 = 0;
  do {
   f2 = Math_fround(HEAPF32[i30 + (i8 << 3) >> 2]);
   f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f2))) * Math_fround(.318309873)));
   HEAPF32[i27 >> 2] = f4;
   i14 = i17 + (i8 << 2) | 0;
   HEAP32[i14 >> 2] = -1;
   i15 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = i30 + (i8 << 3) + 4 | 0;
   i6 = 0;
   f2 = f4;
   do {
    if ((i8 | 0) != (i6 | 0)) {
     i3 = (Math_imul(HEAP32[i28 >> 2] | 0, i6) | 0) + i8 | 0;
     i26 = (HEAP32[i9 >> 2] | 0) + i11 | 0;
     i1 = HEAP32[i26 + (i3 << 3) >> 2] | 0;
     f7 = Math_fround(HEAPF32[i26 + (i3 << 3) + 4 >> 2]);
     f10 = Math_fround(HEAPF32[i16 >> 2]);
     f10 = Math_fround(f10 * Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i13 + (i3 << 2) >> 2]));
     i3 = (HEAP32[i34 >> 2] | 0) + i29 | 0;
     f38 = Math_fround(HEAPF32[i3 + (i8 << 3) >> 2]);
     f5 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
     if (f38 == f5) {
      f38 = Math_fround(HEAPF32[i3 + (i8 << 3) + 4 >> 2]);
      if (f38 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
       i3 = i15;
       i1 = HEAP32[i30 + (i6 << 3) >> 2] | 0;
      } else i35 = 20;
     } else i35 = 20;
     do if ((i35 | 0) == 20) {
      i35 = 0;
      if (Math_fround(HEAPF32[i3 + (i6 << 3) >> 2]) == f5) {
       f38 = Math_fround(HEAPF32[i3 + (i6 << 3) + 4 >> 2]);
       if (f38 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
        i3 = i15;
        i1 = i15;
        break;
       }
      }
      if (!((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0))) if (!(f5 == f31 ? Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]) == f32 : 0)) {
       i3 = i15;
       break;
      }
      i3 = i1;
     } while (0);
     f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_fround(f7 * f10) + Math_fround(f5 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])))) / Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5))));
     HEAPF32[i33 >> 2] = f5;
     if (f5 <= Math_fround(0.0)) {
      i35 = 26;
      break;
     }
     if (f5 < f4) HEAP32[i14 >> 2] = i6;
     i26 = HEAP32[(f5 < f2 ? i33 : i27) >> 2] | 0;
     HEAP32[i27 >> 2] = i26;
     f4 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f2 = f4;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i36 >>> 0);
   if ((i35 | 0) == 26) {
    i35 = 0;
    HEAP32[i27 >> 2] = 0;
    HEAP32[i14 >> 2] = -1;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i36 | 0));
  STACKTOP = i37;
  return;
 }
 if (!i8) {
  STACKTOP = i37;
  return;
 }
 i21 = i28 + 20 | 0;
 i22 = i21;
 i23 = i28 + 28 | 0;
 i24 = i23;
 i20 = 0;
 do {
  f38 = Math_fround(HEAPF32[i30 + (i20 << 3) >> 2]);
  f2 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f38))) * Math_fround(.318309873)));
  HEAPF32[i27 >> 2] = f2;
  i11 = i25 + (i20 << 3) | 0;
  i12 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  L52 : do if (!(HEAP32[i11 >> 2] | 0)) i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0); else {
   i13 = i25 + (i20 << 3) + 4 | 0;
   i9 = HEAP32[i28 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i30 + (i20 << 3) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
   i13 = (HEAP32[i13 >> 2] | 0) + i13 | 0;
   i14 = (HEAP32[i21 >> 2] | 0) + i22 | 0;
   i15 = (HEAP32[i23 >> 2] | 0) + i24 | 0;
   i16 = (HEAP32[i34 >> 2] | 0) + i29 | 0;
   i17 = i16 + (i20 << 3) | 0;
   i18 = i16 + (i20 << 3) + 4 | 0;
   i19 = f10 == f31;
   i8 = 0;
   while (1) {
    i3 = HEAP32[i13 + (i8 << 2) >> 2] | 0;
    i6 = (Math_imul(i9, i3) | 0) + i20 | 0;
    i1 = HEAP32[i14 + (i6 << 3) >> 2] | 0;
    f4 = Math_fround(HEAPF32[i14 + (i6 << 3) + 4 >> 2]);
    f5 = Math_fround(f7 * Math_fround(HEAPF32[i15 + (i6 << 2) >> 2]));
    if (Math_fround(HEAPF32[i17 >> 2]) == f10) {
     f38 = Math_fround(HEAPF32[i18 >> 2]);
     if (f38 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
      i6 = i12;
      i1 = HEAP32[i30 + (i3 << 3) >> 2] | 0;
     } else i35 = 38;
    } else i35 = 38;
    do if ((i35 | 0) == 38) {
     i35 = 0;
     if (Math_fround(HEAPF32[i16 + (i3 << 3) >> 2]) == f10) {
      f38 = Math_fround(HEAPF32[i16 + (i3 << 3) + 4 >> 2]);
      if (f38 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
       i6 = i12;
       i1 = i12;
       break;
      }
     }
     if (!((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0))) if (!(i19 & Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]) == f32)) {
      i6 = i12;
      break;
     }
     i6 = i1;
    } while (0);
    f38 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_fround(f4 * f5) + Math_fround(f38 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])))) / Math_fround(Math_fround(f4 * f4) + Math_fround(f38 * f38))));
    HEAPF32[i33 >> 2] = f4;
    if (f4 <= Math_fround(0.0)) break;
    i1 = HEAP32[(f4 < f2 ? i33 : i27) >> 2] | 0;
    HEAP32[i27 >> 2] = i1;
    i8 = i8 + 1 | 0;
    f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (i8 >>> 0 >= (HEAP32[i11 >> 2] | 0) >>> 0) break L52;
   }
   HEAP32[i27 >> 2] = 0;
   i1 = 0;
  } while (0);
  HEAP32[i26 + (i20 << 2) >> 2] = i1;
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) != (i36 | 0));
 i3 = (i36 | 0) == 0;
 if (i3) {
  STACKTOP = i37;
  return;
 } else {
  i1 = 0;
  f2 = Math_fround(0.0);
 }
 do {
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i26 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i36 | 0));
 if (f2 > Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(1.0) / f2);
  if (i3) {
   STACKTOP = i37;
   return;
  } else i1 = 0;
  do {
   i35 = i26 + (i1 << 2) | 0;
   HEAPF32[i35 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i35 >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i36 | 0));
  STACKTOP = i37;
  return;
 } else {
  f2 = Math_fround(Math_fround(1.0) / Math_fround(i36 >>> 0));
  if (i3) {
   STACKTOP = i37;
   return;
  } else i1 = 0;
  do {
   HEAPF32[i26 + (i1 << 2) >> 2] = f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i36 | 0));
  STACKTOP = i37;
  return;
 }
}

function __ZN5physx5cloth8SwFabricC2ERNS0_9SwFactoryEjNS0_5RangeIKjEES6_NS4_IKfEES6_S6_S8_j(i40, i1, i2, i7, i8, i11, i10, i37, i38, i6) {
 i40 = i40 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i41 + 44 | 0;
 i19 = i41 + 52 | 0;
 i20 = i41 + 40 | 0;
 i21 = i41 + 50 | 0;
 i22 = i41 + 48 | 0;
 i23 = i41 + 36 | 0;
 i27 = i41 + 24 | 0;
 i31 = i41 + 12 | 0;
 i35 = i41;
 i39 = i41 + 8 | 0;
 HEAP16[i40 + 8 >> 1] = 0;
 HEAP32[i40 >> 2] = gb + 167120 + 8;
 HEAP32[i40 + 4 >> 2] = gb + 167120 + 60;
 i36 = i40 + 12 | 0;
 HEAP32[i36 >> 2] = i1;
 i18 = i40 + 16 | 0;
 HEAP32[i18 >> 2] = i2;
 i4 = i40 + 20 | 0;
 i5 = i40 + 24 | 0;
 i15 = i40 + 32 | 0;
 i16 = i40 + 36 | 0;
 i17 = i40 + 40 | 0;
 i24 = i40 + 44 | 0;
 i25 = i40 + 48 | 0;
 i26 = i40 + 52 | 0;
 i28 = i40 + 56 | 0;
 i29 = i40 + 60 | 0;
 i30 = i40 + 64 | 0;
 i32 = i40 + 68 | 0;
 i33 = i40 + 72 | 0;
 i34 = i40 + 76 | 0;
 i1 = i40 + 80 | 0;
 i2 = i4;
 i3 = i2 + 60 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAP32[i40 + 84 >> 2] = i6;
 i1 = HEAP32[i7 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj(i4, (HEAP32[i7 + 4 >> 2] | 0) - i1 >> 2);
 i2 = HEAP32[i4 >> 2] | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + (i14 << 2) | 0;
 if ((i14 | 0) > 0) while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 i14 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = (i14 - i3 >> 2) + 1 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj(i15, i1);
  i2 = HEAP32[i17 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj(i15, i9) | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i40 + 88 >> 2] = (HEAP32[i11 + 4 >> 2] | 0) - i13 >> 2;
 i12 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != (i14 | 0)) {
  i10 = i12;
  i7 = i13;
  i11 = i3;
  while (1) {
   i6 = i10;
   i1 = i7;
   i5 = HEAP32[i11 >> 2] | 0;
   i4 = i13 + (i5 << 2) | 0;
   i8 = i12 + (i5 << 1 << 2) | 0;
   i9 = (i4 - i1 | 0) >>> 2;
   if ((i7 | 0) != (i4 | 0)) {
    i1 = (i13 + (i5 + -1 << 2) - i1 | 0) >>> 2;
    i3 = i7;
    do {
     i2 = HEAP32[i25 >> 2] | 0;
     if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i24 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
      HEAP32[i25 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayIfNS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKf(i24, i3) | 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i4 | 0));
    i7 = i7 + (i1 + 1 << 2) | 0;
   }
   if ((i10 | 0) == (i8 | 0)) i5 = i10; else {
    i3 = (i12 + ((i5 << 1) + -1 << 2) - i6 | 0) >>> 2;
    i4 = i10;
    do {
     i1 = HEAP32[i4 >> 2] & 65535;
     HEAP16[i19 >> 1] = i1;
     i2 = HEAP32[i29 >> 2] | 0;
     if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP16[(HEAP32[i28 >> 2] | 0) + (i2 << 1) >> 1] = i1;
      HEAP32[i29 >> 2] = i2 + 1;
     } else __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt(i28, i19) | 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i8 | 0));
    i5 = i10 + (i3 + 1 << 2) | 0;
   }
   i1 = i9 & 3;
   if (i1 | 0) do {
    HEAPF32[i20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i2 = HEAP32[i25 >> 2] | 0;
    if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i24 >> 2] | 0) + (i2 << 2) >> 2] = -8388609;
     HEAP32[i25 >> 2] = i2 + 1;
    } else __ZN5physx6shdfnd5ArrayIfNS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKf(i24, i20) | 0;
    i4 = i1 + 65535 + (HEAP32[i18 >> 2] | 0) & 65535;
    HEAP16[i21 >> 1] = i4;
    i2 = HEAP32[i30 >> 2] | 0;
    i3 = HEAP32[i29 >> 2] | 0;
    if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP16[(HEAP32[i28 >> 2] | 0) + (i3 << 1) >> 1] = i4;
     i3 = i3 + 1 | 0;
     HEAP32[i29 >> 2] = i3;
    } else {
     __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt(i28, i21) | 0;
     i2 = HEAP32[i30 >> 2] | 0;
     i3 = HEAP32[i29 >> 2] | 0;
    }
    HEAP16[i22 >> 1] = i4;
    if ((i2 & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP16[(HEAP32[i28 >> 2] | 0) + (i3 << 1) >> 1] = i4;
     HEAP32[i29 >> 2] = i3 + 1;
    } else __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt(i28, i22) | 0;
    i1 = i1 + 1 & 3;
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i25 >> 2] | 0;
   HEAP32[i23 >> 2] = i1;
   i2 = HEAP32[i16 >> 2] | 0;
   if ((HEAP32[i17 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj(i15, i23) | 0;
   i11 = i11 + 4 | 0;
   if ((i11 | 0) == (i14 | 0)) break; else i10 = i5;
  }
 }
 i4 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 i6 = i27 + 4 | 0;
 i1 = (i1 | 0) < 0 ? 0 : i1 << 2 >> 2;
 HEAP32[i6 >> 2] = i1;
 i7 = i27 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 if (!i1) i2 = 0; else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i27, (i1 << 2) + 19 | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i2 = 0; else {
   i2 = i1 + 19 & -16;
   HEAP32[i2 + -4 >> 2] = i2 - i1;
  }
 }
 HEAP32[i27 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + (i1 << 2) | 0;
 i5 = i2;
 if ((i1 | 0) > 0) {
  i1 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i23 = HEAP32[i24 >> 2] | 0;
 HEAP32[i27 >> 2] = i23;
 HEAP32[i24 >> 2] = i5;
 HEAP32[i6 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i25 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i25 = HEAP32[i26 >> 2] | 0;
 HEAP32[i7 >> 2] = i25;
 HEAP32[i26 >> 2] = i1;
 i1 = i23;
 if (!((i25 & 2147483647 | 0) == 0 | (i25 | 0) < 0 | (i23 | 0) == 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i27, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 i5 = HEAP32[i28 >> 2] | 0;
 i1 = HEAP32[i29 >> 2] | 0;
 i7 = i31 + 4 | 0;
 i1 = (i1 | 0) < 0 ? 0 : i1 << 1 >> 1;
 HEAP32[i7 >> 2] = i1;
 i8 = i31 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 if (!i1) {
  HEAP32[i31 >> 2] = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31, i1 << 1, gb + 838004 | 0, 543) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i31 >> 2] = i1;
  i6 = i1 + (i2 << 1) | 0;
  i3 = i1;
  if ((i2 | 0) > 0) {
   i4 = i1;
   i1 = i5;
   while (1) {
    HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
    i4 = i4 + 2 | 0;
    if (i4 >>> 0 >= i6 >>> 0) break; else i1 = i1 + 2 | 0;
   }
  }
 }
 i1 = HEAP32[i28 >> 2] | 0;
 HEAP32[i31 >> 2] = i1;
 HEAP32[i28 >> 2] = i3;
 HEAP32[i7 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i29 >> 2] = i2;
 i28 = HEAP32[i8 >> 2] | 0;
 i29 = HEAP32[i30 >> 2] | 0;
 HEAP32[i8 >> 2] = i29;
 HEAP32[i30 >> 2] = i28;
 if ((i29 | 0) > -1 & (i29 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i31, i1);
 i6 = HEAP32[i37 + 4 >> 2] | 0;
 i7 = HEAP32[i37 >> 2] | 0;
 i2 = i7;
 i1 = (i6 - i2 >> 2) + 2 | 0;
 if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE8recreateEj(i32, i1);
 if (i7 >>> 0 < i6 >>> 0) {
  i4 = i35 + 4 | 0;
  i5 = i7 + 4 | 0;
  i5 = (((i6 >>> 0 > i5 >>> 0 ? i6 : i5) + ~i2 | 0) >>> 2) + 1 | 0;
  i1 = HEAP32[i38 >> 2] | 0;
  i3 = i7;
  i2 = i1;
  while (1) {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP16[i35 >> 1] = HEAP32[i3 >> 2];
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i33 >> 2] | 0;
   if ((HEAP32[i34 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i29 = i35;
    i30 = HEAP32[i29 + 4 >> 2] | 0;
    i31 = (HEAP32[i32 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i31 + 4 >> 2] = i30;
    HEAP32[i33 >> 2] = (HEAP32[i33 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE15growAndPushBackERKS3_(i32, i35) | 0;
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
   if (i3 >>> 0 >= i6 >>> 0) break; else i2 = i1;
  }
  HEAP32[i38 >> 2] = i1;
  HEAP32[i37 >> 2] = i7 + (i5 << 2);
 }
 i38 = HEAP32[i36 >> 2] | 0;
 i1 = i38 + 12 | 0;
 HEAP32[i39 >> 2] = i40;
 i2 = i38 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i38 + 20 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i40;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i41;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_5cloth8SwFabricENS0_9AllocatorEE15growAndPushBackERKS4_(i1, i39) | 0;
  STACKTOP = i41;
  return;
 }
}

function __ZN5Umbra12QueryContext16visualizeFrustumERKNS_11TransformerE(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i11 = i12;
 i1 = i9;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = 0;
 do {
  i8 = i1 >> 2;
  f13 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) >> 2]);
  f17 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 12 >> 2]);
  i8 = i1 >>> 1 & 1 | 2;
  f28 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) >> 2]);
  f24 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 12 >> 2]);
  i8 = i1 & 1 | 4;
  f26 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) >> 2]);
  f18 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i3 + 128 + (i8 << 4) + 12 >> 2]);
  f21 = Math_fround(Math_fround(f24 * f16) - Math_fround(f25 * f18));
  f14 = Math_fround(Math_fround(f25 * f26) - Math_fround(f28 * f16));
  f27 = Math_fround(Math_fround(f28 * f18) - Math_fround(f24 * f26));
  f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f19 * f27) + Math_fround(Math_fround(f13 * f21) + Math_fround(f17 * f14))));
  f14 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f19 * f28) - Math_fround(f13 * f25)) * f23) + Math_fround(Math_fround(f22 * f14) + Math_fround(f20 * Math_fround(Math_fround(f13 * f16) - Math_fround(f19 * f26))))) * f15));
  f13 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f13 * f24) - Math_fround(f17 * f28)) * f23) + Math_fround(Math_fround(f22 * f27) + Math_fround(f20 * Math_fround(Math_fround(f17 * f26) - Math_fround(f13 * f18))))) * f15));
  HEAPF32[i9 + (i1 * 12 | 0) >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f17 * f25) - Math_fround(f19 * f24)) * f23) + Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16))))) * f15));
  HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2] = f14;
  HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2] = f13;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i7 = i9 + 12 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 | 0, i7 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 i8 = i9 + 36 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 i6 = i9 + 24 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0, i6 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i6 | 0, i9 | 0, i11 | 0);
 if (!(HEAP8[i3 + 1364 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 } else i1 = 4;
 do {
  i5 = i1 >> 2;
  f28 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) >> 2]);
  f24 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 12 >> 2]);
  i5 = i1 >>> 1 & 1 | 2;
  f13 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) >> 2]);
  f17 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 12 >> 2]);
  i5 = i1 & 1 | 4;
  f15 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) >> 2]);
  f23 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i3 + 128 + (i5 << 4) + 12 >> 2]);
  f20 = Math_fround(Math_fround(f17 * f25) - Math_fround(f16 * f23));
  f27 = Math_fround(Math_fround(f16 * f15) - Math_fround(f13 * f25));
  f14 = Math_fround(Math_fround(f13 * f23) - Math_fround(f17 * f15));
  f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f22 * f14) + Math_fround(Math_fround(f28 * f20) + Math_fround(f24 * f27))));
  f27 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f22 * f13) - Math_fround(f28 * f16)) * f18) + Math_fround(Math_fround(f19 * f27) + Math_fround(f21 * Math_fround(Math_fround(f28 * f25) - Math_fround(f22 * f15))))) * f26));
  f28 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f28 * f17) - Math_fround(f24 * f13)) * f18) + Math_fround(Math_fround(f19 * f14) + Math_fround(f21 * Math_fround(Math_fround(f24 * f15) - Math_fround(f28 * f23))))) * f26));
  HEAPF32[i9 + (i1 * 12 | 0) >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f24 * f16) - Math_fround(f22 * f17)) * f18) + Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * Math_fround(Math_fround(f22 * f23) - Math_fround(f24 * f25))))) * f26));
  HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2] = f27;
  HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2] = f28;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i2 = i9 + 48 | 0;
 i4 = i9 + 60 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 i5 = i9 + 84 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 i3 = i9 + 72 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 | 0, i3 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 | 0, i2 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i4 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (!i1) i1 = 0; else {
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i6 | 0, i3 | 0, i11 | 0);
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0, i5 | 0, i11 | 0);
 STACKTOP = i12;
 return;
}

function _UNITY_TT_Load_Glyph(i19, i13, i15, i8) {
 i19 = i19 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 208 | 0;
 i17 = i20;
 i1 = HEAP32[i19 + 112 >> 2] | 0;
 do if ((i8 & 8 | 0) == 0 & (i1 | 0) != -1) {
  i2 = i13 + 4 | 0;
  i16 = HEAP32[i2 >> 2] | 0;
  if (mftCall_iiiiiiii(HEAP32[(HEAP32[i16 + 532 >> 2] | 0) + 72 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i8 | 0, HEAP32[i16 + 104 >> 2] | 0, i13 + 76 | 0, i14 | 0) | 0) break;
  HEAP16[i13 + 110 >> 1] = 0;
  HEAP16[i13 + 108 >> 1] = 0;
  HEAP32[i13 + 24 >> 2] = HEAPU16[i14 + 2 >> 1] << 6;
  HEAP32[i13 + 28 >> 2] = HEAPU16[i14 >> 1] << 6;
  i11 = HEAP16[i14 + 4 >> 1] | 0;
  HEAP32[i13 + 32 >> 2] = i11 << 6;
  i16 = HEAP16[i14 + 6 >> 1] | 0;
  HEAP32[i13 + 36 >> 2] = i16 << 6;
  i4 = i13 + 40 | 0;
  HEAP32[i4 >> 2] = HEAPU16[i14 + 8 >> 1] << 6;
  i12 = HEAP16[i14 + 10 >> 1] | 0;
  HEAP32[i13 + 44 >> 2] = i12 << 6;
  i1 = HEAP16[i14 + 12 >> 1] | 0;
  HEAP32[i13 + 48 >> 2] = i1 << 6;
  i5 = i13 + 52 | 0;
  HEAP32[i5 >> 2] = HEAPU16[i14 + 14 >> 1] << 6;
  HEAP32[i13 + 72 >> 2] = 1651078259;
  i14 = (i8 & 16 | 0) == 0;
  HEAP32[i13 + 100 >> 2] = i14 ? i11 : i12;
  HEAP32[i13 + 104 >> 2] = i14 ? i16 : i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP32[i1 + 8 >> 2] & 1)) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  i2 = HEAP32[i1 + 104 >> 2] | 0;
  _memset(i17 | 0, 0, 208) | 0;
  i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1735162214, i2 | 0, 0) | 0;
  if ((i3 & 255 | 0) == 142) {
   HEAP32[i17 + 84 >> 2] = 0;
   i18 = 9;
  } else if (!i3) {
   HEAP32[i17 + 84 >> 2] = _UNITY_FT_Stream_Pos(i2) | 0;
   i18 = 9;
  }
  if ((i18 | 0) == 9) {
   HEAP32[i17 + 16 >> 2] = i8;
   HEAP32[i17 >> 2] = i1;
   HEAP32[i17 + 4 >> 2] = i19;
   HEAP32[i17 + 8 >> 2] = i13;
   HEAP32[i17 + 24 >> 2] = i2;
  }
  _load_truetype_glyph(i17, i15, 0, 1) | 0;
  i2 = HEAP32[i17 + 60 >> 2] | 0;
  HEAP32[i13 + 56 >> 2] = i2;
  i1 = i13 + 60 | 0;
  HEAP32[i1 >> 2] = HEAP32[i17 + 180 >> 2];
  if (!((HEAP32[i4 >> 2] | 0) != 0 | (i2 | 0) == 0)) HEAP32[i4 >> 2] = _UNITY_FT_MulFix(i2, HEAP32[i19 + 16 >> 2] | 0) | 0;
  if (HEAP32[i5 >> 2] | 0) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  HEAP32[i5 >> 2] = _UNITY_FT_MulFix(i1, HEAP32[i19 + 20 >> 2] | 0) | 0;
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 } while (0);
 i16 = (i8 & 1 | 0) != 0;
 if (!i16) if (!(HEAP8[i19 + 108 >> 0] | 0)) {
  i19 = 36;
  STACKTOP = i20;
  return i19 | 0;
 }
 if (i8 & 16384 | 0) {
  i19 = 6;
  STACKTOP = i20;
  return i19 | 0;
 }
 i7 = i8 & 128;
 i9 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = HEAP32[i9 + 104 >> 2] | 0;
 _memset(i17 | 0, 0, 208) | 0;
 i12 = (i8 & 2 | 0) == 0;
 if (i12) {
  i1 = HEAP32[i19 + 296 >> 2] | 0;
  if ((i1 | 0) < 0) i18 = 21; else {
   i2 = HEAP32[i19 + 300 >> 2] | 0;
   if ((i2 | 0) < 0) i18 = 21; else {
    if (i1 | 0) {
     i19 = i1;
     STACKTOP = i20;
     return i19 | 0;
    }
    if (i2 | 0) {
     i19 = i2;
     STACKTOP = i20;
     return i19 | 0;
    }
   }
  }
  if ((i18 | 0) == 21) {
   i1 = _UNITY_tt_size_ready_bytecode(i19, i7) | 0;
   if (i1 | 0) {
    i19 = i1;
    STACKTOP = i20;
    return i19 | 0;
   }
  }
  i6 = HEAP32[i19 + 292 >> 2] | 0;
  if (!i6) {
   i19 = 153;
   STACKTOP = i20;
   return i19 | 0;
  }
  i2 = (i8 & 983040 | 0) != 131072;
  i1 = _UNITY_TT_Load_Context(i6, i9, i19) | 0;
  if (i1 | 0) {
   i19 = i1;
   STACKTOP = i20;
   return i19 | 0;
  }
  i1 = i6 + 608 | 0;
  if ((i2 & 1 | 0) != (HEAPU8[i1 >> 0] | 0)) {
   HEAP8[i1 >> 0] = i2 & 1;
   i2 = i19 + 240 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i3 = i9 + 648 | 0;
    i4 = i19 + 88 | 0;
    i5 = i19 + 244 | 0;
    i1 = 0;
    do {
     i11 = _UNITY_FT_MulFix(HEAP16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0, HEAP32[i4 >> 2] | 0) | 0;
     HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i11;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
   }
   i1 = _UNITY_tt_size_run_prep(i19, i7) | 0;
   if (i1 | 0) {
    i19 = i1;
    STACKTOP = i20;
    return i19 | 0;
   }
  }
  i11 = HEAP8[i6 + 336 >> 0] | 0;
  i2 = (i11 & 1) << 1 | i8;
  if (i11 & 2) {
   i1 = i6 + 284 | 0;
   i3 = gb + 185760 | 0;
   i4 = i1 + 68 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    i1 = i1 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i1 | 0) < (i4 | 0));
  }
  HEAP8[i6 + 561 >> 0] = i7;
  HEAP32[i17 + 160 >> 2] = i6;
  HEAP32[i17 + 164 >> 2] = HEAP32[i6 + 392 >> 2];
 } else i2 = i8;
 i1 = mftCall_iiiii(HEAP32[i9 + 508 >> 2] | 0, i9 | 0, 1735162214, i10 | 0, 0) | 0;
 do if ((i1 & 255 | 0) == 142) HEAP32[i17 + 84 >> 2] = 0; else if (!i1) {
  HEAP32[i17 + 84 >> 2] = _UNITY_FT_Stream_Pos(i10) | 0;
  break;
 } else {
  i19 = i1;
  STACKTOP = i20;
  return i19 | 0;
 } while (0);
 i11 = HEAP32[HEAP32[i13 + 156 >> 2] >> 2] | 0;
 _UNITY_FT_GlyphLoader_Rewind(i11);
 i5 = i17 + 12 | 0;
 HEAP32[i5 >> 2] = i11;
 i11 = i17 + 16 | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i17 >> 2] = i9;
 i7 = i17 + 4 | 0;
 HEAP32[i7 >> 2] = i19;
 i6 = i17 + 8 | 0;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i17 + 24 >> 2] = i10;
 i2 = i13 + 72 | 0;
 HEAP32[i2 >> 2] = 1869968492;
 i3 = i13 + 128 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i13 + 108 | 0;
 i9 = i13 + 124 | 0;
 HEAP32[i9 >> 2] = 0;
 i1 = _load_truetype_glyph(i17, i15, 0, 0) | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == 1668246896) {
   HEAP32[i3 >> 2] = HEAP32[i1 + 48 >> 2];
   HEAP32[i13 + 132 >> 2] = HEAP32[i1 + 52 >> 2];
  } else {
   i1 = i1 + 20 | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & -513;
   i1 = HEAP32[i17 + 68 >> 2] | 0;
   if (i1 | 0) _UNITY_FT_Outline_Translate(i4, 0 - i1 | 0, 0);
  }
  L80 : do if (i12) {
   i1 = HEAP32[i17 + 160 >> 2] | 0;
   if (!(HEAP8[i1 + 337 >> 0] | 0)) {
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 8;
    break;
   }
   switch (HEAP32[i1 + 340 >> 2] | 0) {
   case 1:
    break L80;
   case 0:
    {
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 32;
     break L80;
    }
   case 4:
    {
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 48;
     break L80;
    }
   case 5:
    {
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 16;
     break L80;
    }
   default:
    {
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 8;
     break L80;
    }
   }
  } while (0);
  i3 = HEAP32[i17 >> 2] | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!(HEAP32[i11 >> 2] & 1)) i4 = HEAP32[i1 + 20 >> 2] | 0; else i4 = 65536;
  if ((HEAP32[i8 + 72 >> 2] | 0) == 1668246896) {
   i13 = i17 + 36 | 0;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  } else _UNITY_FT_Outline_Get_CBox(i8 + 108 | 0, i14);
  HEAP32[i8 + 56 >> 2] = HEAP32[i17 + 60 >> 2];
  i5 = i8 + 32 | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  i2 = i14 + 12 | 0;
  HEAP32[i8 + 36 >> 2] = HEAP32[i2 >> 2];
  i6 = i8 + 40 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i17 + 76 >> 2] | 0) - (HEAP32[i17 + 68 >> 2] | 0);
  if (!(HEAP32[i3 + 480 >> 2] | 0)) if (!(HEAP32[i11 >> 2] & 2097154)) {
   i1 = _UNITY_tt_face_get_device_metrics(i3, HEAPU16[i1 + 12 >> 1] | 0, i15) | 0;
   if (i1 | 0) HEAP32[i6 >> 2] = HEAPU8[i1 >> 0] << 6;
  }
  HEAP32[i8 + 24 >> 2] = (HEAP32[i14 + 8 >> 2] | 0) - (HEAP32[i14 >> 2] | 0);
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i2 - (HEAP32[i14 + 4 >> 2] | 0) | 0;
  HEAP32[i8 + 28 >> 2] = i1;
  if (!(HEAP8[i3 + 292 >> 0] | 0)) i18 = 64; else if (!(HEAP16[i3 + 330 >> 1] | 0)) i18 = 64; else {
   i3 = i17 + 188 | 0;
   i2 = (_UNITY_FT_DivFix((HEAP32[i3 >> 2] | 0) - i2 | 0, i4) | 0) << 16 >> 16;
   i3 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i17 + 196 >> 2] | 0;
   if ((i3 | 0) > (i1 | 0)) i1 = (_UNITY_FT_DivFix(i3 - i1 | 0, i4) | 0) & 65535; else i1 = 0;
  }
  if ((i18 | 0) == 64) {
   i2 = (_UNITY_FT_DivFix(i1, i4) | 0) << 16 >> 16;
   if ((HEAP16[i3 + 364 >> 1] | 0) == -1) {
    i1 = HEAP32[i3 + 220 >> 2] | 0;
    i1 = (i1 << 16 >> 16) - (i1 >> 16) | 0;
   } else i1 = (HEAP16[i3 + 434 >> 1] | 0) - (HEAP16[i3 + 436 >> 1] | 0) | 0;
   i2 = (i1 - i2 | 0) / 2 | 0;
  }
  HEAP32[i8 + 60 >> 2] = i1;
  if (!(HEAP32[i11 >> 2] & 1)) {
   i2 = _UNITY_FT_MulFix(i2, i4) | 0;
   i1 = _UNITY_FT_MulFix(i1, i4) | 0;
  }
  HEAP32[i8 + 44 >> 2] = (HEAP32[i5 >> 2] | 0) - ((HEAP32[i6 >> 2] | 0) / 2 | 0);
  HEAP32[i8 + 48 >> 2] = i2;
  HEAP32[i8 + 52 >> 2] = i1;
  i1 = 0;
 }
 if (i16) {
  i19 = i1;
  STACKTOP = i20;
  return i19 | 0;
 }
 if ((HEAPU16[i19 + 14 >> 1] | 0) >= 24) {
  i19 = i1;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 256;
 i19 = i1;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN16MemoryFileSystem6DeleteER13FileEntryDatab(i24, i1, i6) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 32 | 0;
 i27 = i28 + 16 | 0;
 i5 = i28;
 HEAP32[i27 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i24, i1, i27);
 i25 = i27 + 11 | 0;
 i2 = HEAP8[i25 >> 0] | 0;
 i20 = i27 + 4 | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i20 >> 2] | 0 : i2 & 255) | 0)) i1 = 0; else {
  i23 = i24 + 4 | 0;
  i3 = (HEAP8[i25 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  i4 = _strlen(i3) | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i7 = 5;
  } else if (i4 >>> 0 < 11) {
   i1 = i5 + 11 | 0;
   HEAP8[i1 >> 0] = i4;
   if (!i4) i2 = i5; else {
    i2 = i5;
    i7 = 7;
   }
  } else i7 = 5;
  if ((i7 | 0) == 5) {
   i22 = i4 + 16 & -16;
   HEAP32[i26 >> 2] = 54;
   HEAP32[i26 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22, 16, i26, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 + 8 >> 2] = i22 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i1 = i5 + 11 | 0;
   i7 = 7;
  }
  if ((i7 | 0) == 7) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i22 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i23, i5) | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i21 = HEAP32[i5 >> 2] | 0;
   i19 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i26 >> 2] = 54;
   HEAP32[i26 + 4 >> 2] = i19;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i26);
  }
  i18 = i24 + 8 | 0;
  L15 : do if ((i22 | 0) == (i18 | 0)) i1 = 0; else {
   i21 = i22 + 16 | 0;
   i19 = i22 + 32 | 0;
   L17 : do if (!(HEAP32[HEAP32[i19 >> 2] >> 2] | 0)) {
    i1 = HEAP32[i22 + 4 >> 2] | 0;
    if (!i1) {
     i2 = i22;
     while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     }
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) != (i18 | 0)) {
     i11 = i6 ^ 1;
     i12 = i24 + 16 | 0;
     i13 = i24 + 12 | 0;
     i14 = i24 + 8 | 0;
     i15 = i26 + 4 | 0;
     i16 = i26 + 4 | 0;
     i17 = i26 + 4 | 0;
     i2 = i1;
     i10 = i1;
     L27 : while (1) {
      i8 = i10 + 16 | 0;
      i9 = i8 + 11 | 0;
      i3 = HEAP8[i9 >> 0] | 0;
      i6 = i3 << 24 >> 24 < 0;
      if (i6) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
      i4 = HEAP8[i25 >> 0] | 0;
      i5 = i4 << 24 >> 24 < 0;
      i1 = (_strncmp(i1, i5 ? HEAP32[i27 >> 2] | 0 : i27, i5 ? HEAP32[i20 >> 2] | 0 : i4 & 255) | 0) != 0;
      L33 : do if (i1 | i11) {
       i3 = i1 ? 3 : 1;
       i1 = i2;
      } else {
       if (i6) i1 = HEAP32[i10 + 20 >> 2] | 0; else i1 = i3 & 255;
       i3 = i5 ? HEAP32[i20 >> 2] | 0 : i4 & 255;
       do if (i1 >>> 0 > i3 >>> 0) {
        if (i6) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
        if ((HEAP8[i1 + i3 >> 0] | 0) != 47) {
         if (i6) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
         if ((HEAP8[i1 + i3 >> 0] | 0) == 47) break;
         i1 = HEAP32[i2 + 4 >> 2] | 0;
         if (!i1) while (1) {
          i1 = HEAP32[i2 + 8 >> 2] | 0;
          if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
         } else while (1) {
          i2 = HEAP32[i1 >> 2] | 0;
          if (!i2) break; else i1 = i2;
         }
         i3 = 2;
         break L33;
        }
       } while (0);
       i4 = i10 + 32 | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       if (!(HEAP32[i1 >> 2] | 0)) i7 = 41; else {
        i3 = HEAP32[i1 >> 2] | 0;
        i7 = i3 + 4 | 0;
        HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
        if (!(HEAP32[i7 >> 2] | 0)) {
         mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
         __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
         i1 = HEAP32[i4 >> 2] | 0;
         i7 = 41;
        } else i7 = 42;
       }
       if ((i7 | 0) == 41) {
        i7 = 0;
        if (!i1) i1 = 0; else i7 = 42;
       }
       if ((i7 | 0) == 42) {
        i3 = i1 + 24 | 0;
        if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
         i7 = HEAP32[i3 >> 2] | 0;
         i6 = HEAP32[i1 + 36 >> 2] | 0;
         HEAP32[i26 >> 2] = 54;
         HEAP32[i17 >> 2] = i6;
         __Z19free_alloc_internalPvRK10MemLabelId(i7, i26);
        }
       }
       __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
       HEAP32[i4 >> 2] = 0;
       i3 = HEAP32[i10 + 4 >> 2] | 0;
       i6 = (i3 | 0) == 0;
       if (i6) {
        i5 = i2;
        i4 = i5;
        while (1) {
         i1 = HEAP32[i4 + 8 >> 2] | 0;
         if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break; else i4 = i1;
        }
       } else {
        i1 = i3;
        while (1) {
         i4 = HEAP32[i1 >> 2] | 0;
         if (!i4) break; else i1 = i4;
        }
        i5 = i2;
       }
       if (i6) {
        i4 = i5;
        while (1) {
         i3 = HEAP32[i4 + 8 >> 2] | 0;
         if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
        }
       } else while (1) {
        i4 = HEAP32[i3 >> 2] | 0;
        if (!i4) break; else i3 = i4;
       }
       if ((HEAP32[i23 >> 2] | 0) == (i10 | 0)) HEAP32[i23 >> 2] = i3;
       HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
       __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 >> 2] | 0, i5);
       if ((HEAP8[i9 >> 0] | 0) < 0) {
        i9 = HEAP32[i8 >> 2] | 0;
        i10 = HEAP32[i10 + 28 >> 2] | 0;
        HEAP32[i26 >> 2] = 54;
        HEAP32[i15 >> 2] = i10;
        __Z19free_alloc_internalPvRK10MemLabelId(i9, i26);
       }
       i3 = HEAP32[i13 >> 2] | 0;
       HEAP32[i26 >> 2] = 54;
       HEAP32[i16 >> 2] = i3;
       __Z19free_alloc_internalPvRK10MemLabelId(i2, i26);
       i3 = 0;
      } while (0);
      switch (i3 & 3) {
      case 3:
       break L17;
      case 2:
      case 0:
       break;
      default:
       break L27;
      }
      i10 = i1;
      if ((i10 | 0) == (i18 | 0)) break L17; else i2 = i1;
     }
     if (i3 | 0) {
      i1 = 0;
      break L15;
     }
    }
   } while (0);
   i1 = HEAP32[i19 >> 2] | 0;
   if (!(HEAP32[i1 >> 2] | 0)) i7 = 63; else {
    i2 = HEAP32[i1 >> 2] | 0;
    i20 = i2 + 4 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
    if (!(HEAP32[i20 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
     i1 = HEAP32[i19 >> 2] | 0;
     i7 = 63;
    } else i7 = 64;
   }
   if ((i7 | 0) == 63) if (!i1) i1 = 0; else i7 = 64;
   if ((i7 | 0) == 64) {
    i2 = i1 + 24 | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i20 = HEAP32[i2 >> 2] | 0;
     i18 = HEAP32[i1 + 36 >> 2] | 0;
     HEAP32[i26 >> 2] = 54;
     HEAP32[i26 + 4 >> 2] = i18;
     __Z19free_alloc_internalPvRK10MemLabelId(i20, i26);
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
   HEAP32[i19 >> 2] = 0;
   i1 = HEAP32[i22 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i22;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i23 >> 2] | 0) == (i22 | 0)) HEAP32[i23 >> 2] = i1;
   i23 = i24 + 16 | 0;
   HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i24 + 8 >> 2] | 0, i22);
   if ((HEAP8[i21 + 11 >> 0] | 0) < 0) {
    i23 = HEAP32[i21 >> 2] | 0;
    i21 = HEAP32[i22 + 28 >> 2] | 0;
    HEAP32[i26 >> 2] = 54;
    HEAP32[i26 + 4 >> 2] = i21;
    __Z19free_alloc_internalPvRK10MemLabelId(i23, i26);
   }
   i1 = HEAP32[i24 + 12 >> 2] | 0;
   HEAP32[i26 >> 2] = 54;
   HEAP32[i26 + 4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i22, i26);
   i1 = 1;
  } while (0);
  i2 = HEAP8[i25 >> 0] | 0;
 }
 if (i2 << 24 >> 24 >= 0) {
  STACKTOP = i28;
  return i1 | 0;
 }
 i25 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 12 >> 2] | 0;
 HEAP32[i26 >> 2] = 54;
 HEAP32[i26 + 4 >> 2] = i27;
 __Z19free_alloc_internalPvRK10MemLabelId(i25, i26);
 STACKTOP = i28;
 return i1 | 0;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjPKjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSI_5Vec3VE(i17, i25, i28, i27, i26, i15, i1, i16, i12, i13, i11, i14) {
 i17 = i17 | 0;
 i25 = i25 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i29 + 72 | 0;
 i2 = i29 + 48 | 0;
 i8 = i29 + 32 | 0;
 i7 = i29 + 64 | 0;
 i18 = i29 + 16 | 0;
 i3 = i29;
 HEAP32[i9 >> 2] = 0;
 HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if (!(__ZN5physxL22testTriangleFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(i25, i1, i16, i11, i2, i29 + 68 | 0, i8, i9) | 0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i10 = i15 + 24 | 0;
 if (!(__ZN5physxL18testPolyFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(HEAP32[i15 + 16 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i15 + 28 >> 2] | 0, i1, i16, i11, i2, i7, i8, i9) | 0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 if (!(__ZN5physxL18testPolyEdgeNormalERKNS_2Gu9TriangleVEhRKNS0_15HullPolygonDataERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSH_RNSG_5Vec3VENS0_13FeatureStatusERSN_(i25, i26, i15, i1, i16, i11, i2, i8, i9) | 0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 f32 = Math_fround(HEAPF32[i25 + 112 >> 2]);
 i23 = i25 + 116 | 0;
 f6 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i25 + 120 | 0;
 f33 = Math_fround(HEAPF32[i24 >> 2]);
 f30 = Math_fround(HEAPF32[i25 + 96 >> 2]);
 i19 = i25 + 100 | 0;
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 i20 = i25 + 104 | 0;
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 f32 = Math_fround(f32 - f30);
 f6 = Math_fround(f6 - f31);
 f33 = Math_fround(f33 - f5);
 f34 = Math_fround(HEAPF32[i25 + 128 >> 2]);
 i21 = i25 + 132 | 0;
 f4 = Math_fround(HEAPF32[i21 >> 2]);
 i22 = i25 + 136 | 0;
 f30 = Math_fround(f34 - f30);
 f31 = Math_fround(f4 - f31);
 f5 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f5);
 f4 = Math_fround(Math_fround(f6 * f5) - Math_fround(f33 * f31));
 f5 = Math_fround(Math_fround(f33 * f30) - Math_fround(f32 * f5));
 f30 = Math_fround(Math_fround(f32 * f31) - Math_fround(f6 * f30));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f30 * f30) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))))));
 f4 = Math_fround(f6 * f4);
 f5 = Math_fround(f6 * f5);
 f6 = Math_fround(f30 * f6);
 HEAPF32[i18 >> 2] = f4;
 HEAPF32[i18 + 4 >> 2] = f5;
 HEAPF32[i18 + 8 >> 2] = f6;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 switch (HEAP32[i9 >> 2] | 0) {
 case 0:
  {
   i27 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i15, i16, i8) | 0;
   i27 = (HEAP32[i10 >> 2] | 0) + (i27 * 20 | 0) | 0;
   HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i25, i28, i26, i15, i27, i16, i12, i13, i11, i18);
   i28 = 1;
   STACKTOP = i29;
   return i28 | 0;
  }
 case 1:
  {
   i7 = HEAP32[i7 >> 2] | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i1 = i9 + (i7 * 20 | 0) | 0;
   i10 = HEAP32[i16 + 40 >> 2] | 0;
   f30 = Math_fround(HEAPF32[i1 >> 2]);
   f34 = Math_fround(HEAPF32[i9 + (i7 * 20 | 0) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i9 + (i7 * 20 | 0) + 8 >> 2]);
   f32 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i10 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i10 + 4 >> 2]))) + Math_fround(f33 * Math_fround(HEAPF32[i10 + 8 >> 2])));
   f31 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i10 + 16 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i10 + 20 >> 2]))) + Math_fround(f33 * Math_fround(HEAPF32[i10 + 24 >> 2])));
   f33 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i10 + 32 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i10 + 36 >> 2]))) + Math_fround(f33 * Math_fround(HEAPF32[i10 + 40 >> 2])));
   f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f31 * f31)) + Math_fround(f33 * f33)))));
   if (Math_fround(Math_fround(Math_fround(-Math_fround(Math_fround(f31 * f34) * f5)) - Math_fround(Math_fround(f32 * f34) * f4)) - Math_fround(Math_fround(f33 * f34) * f6)) > Math_fround(.707099974)) {
    HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
    __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i25, i28, i26, i15, i1, i16, i12, i13, i11, i18);
    i28 = 1;
    STACKTOP = i29;
    return i28 | 0;
   }
   i2 = HEAP32[i17 + 4416 >> 2] | 0;
   i3 = i2 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 + 15 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
    __ZN5physx2Gu9Container6ResizeEj(i2, 15) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i18 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP32[i3 >> 2] = i1 + 15;
   HEAP32[i18 + (i1 + 12 << 2) >> 2] = i28;
   HEAP32[i18 + (i1 + 13 << 2) >> 2] = i7;
   HEAP8[i18 + (i1 + 14 << 2) >> 0] = i26;
   HEAP32[i18 + (i1 + 9 << 2) >> 2] = HEAP32[i27 >> 2];
   HEAP32[i18 + (i1 + 10 << 2) >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i18 + (i1 + 11 << 2) >> 2] = HEAP32[i27 + 8 >> 2];
   i27 = HEAP32[i19 >> 2] | 0;
   i28 = HEAP32[i20 >> 2] | 0;
   HEAP32[i18 + (i1 << 2) >> 2] = HEAP32[i25 + 96 >> 2];
   HEAP32[i18 + (i1 + 1 << 2) >> 2] = i27;
   HEAP32[i18 + (i1 + 2 << 2) >> 2] = i28;
   i28 = HEAP32[i23 >> 2] | 0;
   i27 = HEAP32[i24 >> 2] | 0;
   HEAP32[i18 + (i1 + 3 << 2) >> 2] = HEAP32[i25 + 112 >> 2];
   HEAP32[i18 + (i1 + 4 << 2) >> 2] = i28;
   HEAP32[i18 + (i1 + 5 << 2) >> 2] = i27;
   i27 = HEAP32[i21 >> 2] | 0;
   i28 = HEAP32[i22 >> 2] | 0;
   HEAP32[i18 + (i1 + 6 << 2) >> 2] = HEAP32[i25 + 128 >> 2];
   HEAP32[i18 + (i1 + 7 << 2) >> 2] = i27;
   HEAP32[i18 + (i1 + 8 << 2) >> 2] = i28;
   i28 = 1;
   STACKTOP = i29;
   return i28 | 0;
  }
 default:
  {
   i23 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i15, i16, i8) | 0;
   HEAP32[i7 >> 2] = i23;
   i22 = HEAP32[i10 >> 2] | 0;
   i27 = i22 + (i23 * 20 | 0) | 0;
   i24 = HEAP32[i16 + 40 >> 2] | 0;
   f30 = Math_fround(HEAPF32[i27 >> 2]);
   f34 = Math_fround(HEAPF32[i22 + (i23 * 20 | 0) + 4 >> 2]);
   f31 = Math_fround(HEAPF32[i22 + (i23 * 20 | 0) + 8 >> 2]);
   f32 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i24 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i24 + 4 >> 2]))) + Math_fround(f31 * Math_fround(HEAPF32[i24 + 8 >> 2])));
   f33 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i24 + 16 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i24 + 20 >> 2]))) + Math_fround(f31 * Math_fround(HEAPF32[i24 + 24 >> 2])));
   f31 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i24 + 32 >> 2])) + Math_fround(f34 * Math_fround(HEAPF32[i24 + 36 >> 2]))) + Math_fround(f31 * Math_fround(HEAPF32[i24 + 40 >> 2])));
   f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f33 * f33)) + Math_fround(f31 * f31)))));
   f32 = Math_fround(f32 * f34);
   f33 = Math_fround(f33 * f34);
   f34 = Math_fround(f31 * f34);
   HEAPF32[i3 >> 2] = f32;
   HEAPF32[i3 + 4 >> 2] = f33;
   HEAPF32[i3 + 8 >> 2] = f34;
   HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
   f33 = Math_fround(-f33);
   f34 = Math_fround(-f34);
   HEAPF32[i14 >> 2] = Math_fround(-f32);
   HEAPF32[i14 + 4 >> 2] = f33;
   HEAPF32[i14 + 8 >> 2] = f34;
   HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
   __ZN5physxL21generatedPolyContactsERKNS_2Gu13PolygonalDataERKNS0_15HullPolygonDataERKNS0_9TriangleVEjhPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i15, i27, i25, i28, i26, i16, i12, i13, i11, i3);
   i28 = 1;
   STACKTOP = i29;
   return i28 | 0;
  }
 }
 return 0;
}

function __ZN14LineParameters8TransferI14SafeBinaryReadEEvRT_(i10, i14) {
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 32 | 0;
 i11 = i19 + 28 | 0;
 i12 = i19 + 24 | 0;
 i16 = i19 + 20 | 0;
 i17 = i19 + 16 | 0;
 i18 = i19;
 __ZN14SafeBinaryRead10SetVersionEi(i14, 2);
 i13 = i10 + 16 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405221 | 0, i7, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i8 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i13, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i13 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i6 = i10 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405237 | 0, gb + 1034188 | 0, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i6, i14); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i8 = i10 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405248 | 0, gb + 1033990 | 0, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i8, i14); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i4 = i10 + 180 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405262 | 0, i5, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i3 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i4 = i10 + 184 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405280 | 0, i5, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i14 + 16 | 0;
   i5 = HEAP32[i14 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 40; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13LineAlignmentEvRT_RT0_PKc17TransferMetaFlags(i14, i10 + 188 | 0, gb + 405295 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15LineTextureModeEvRT_RT0_PKc17TransferMetaFlags(i14, i10 + 192 | 0, gb + 619278 | 0, 0);
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i14, 1) | 0)) {
  STACKTOP = i19;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405305 | 0, i7, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i5 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 52; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 52; else {
     HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405316 | 0, i7, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i14 + 16 | 0;
   i7 = HEAP32[i14 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i14 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i14 + 36 >> 2] | 0, 0 - (HEAP32[i14 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i9 = 63; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i14 + 24 >> 2] | 0) >>> 0) i9 = 63; else {
     HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 63) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i12, 4);
   if (HEAP32[i14 >> 2] & 512 | 0) HEAP32[i12 >> 2] = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i12 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 f20 = Math_fround(HEAPF32[i11 >> 2]);
 i2 = f20 < Math_fround(HEAPF32[i12 >> 2]);
 i2 = i2 ? i12 : i11;
 i1 = Math_fround(HEAPF32[i2 >> 2]) > Math_fround(1.0);
 i2 = HEAP32[(i1 ? i2 : i15) >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i10 + 88 >> 2] = 0;
 HEAPF32[i16 >> 2] = Math_fround(f20 / (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 __ZN11KeyframeTplIfEC2EfRKf(i15, Math_fround(0.0), i16);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i6, i15) | 0;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 HEAPF32[i16 >> 2] = Math_fround(f20 / Math_fround(HEAPF32[i13 >> 2]));
 __ZN11KeyframeTplIfEC2EfRKf(i15, Math_fround(1.0), i16);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i6, i15) | 0;
 i2 = HEAP32[gb + 36980 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405325 | 0, i2, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i16, i14); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i14, gb + 405338 | 0, i2, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i17, i14); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i17 | 0, i14 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i14);
 }
 i16 = HEAP32[i16 >> 2] | 0;
 f22 = Math_fround(Math_fround((i16 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f23 = Math_fround(Math_fround(i16 >>> 16 & 255) / Math_fround(255.0));
 f21 = Math_fround(Math_fround(i16 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(i16 & 255) / Math_fround(255.0));
 HEAPF32[i15 + 4 >> 2] = f22;
 HEAPF32[i15 + 8 >> 2] = f23;
 HEAPF32[i15 + 12 >> 2] = f21;
 HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
 i17 = HEAP32[i17 >> 2] | 0;
 f23 = Math_fround(Math_fround((i17 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f22 = Math_fround(Math_fround(i17 >>> 16 & 255) / Math_fround(255.0));
 f20 = Math_fround(Math_fround(i17 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i15 + 20 >> 2] = Math_fround(Math_fround(i17 & 255) / Math_fround(255.0));
 HEAPF32[i15 + 24 >> 2] = f23;
 HEAPF32[i15 + 28 >> 2] = f22;
 HEAPF32[i15 + 32 >> 2] = f20;
 HEAPF32[i15 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i18 >> 2] = f21;
 HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 8 >> 2] = f20;
 HEAPF32[i18 + 12 >> 2] = Math_fround(1.0);
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i8, i15, 2);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i8, i18, 2);
 STACKTOP = i19;
 return;
}

function __ZN9BoxPruner14findOverlapsMTER15MBP_PairManagerPKjPK10MBP_Object(i18, i22, i20, i21) {
 i18 = i18 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = i18 + 116 | 0;
 if (!(HEAP32[i19 >> 2] | 0)) return;
 L4 : do if (HEAP8[i18 + 28 >> 0] | 0) {
  i16 = HEAP32[i18 >> 2] | 0;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i11 = HEAP32[i18 + 8 >> 2] | 0;
  i14 = HEAP32[i18 + 12 >> 2] | 0;
  i12 = HEAP32[i18 + 16 >> 2] | 0;
  i15 = HEAP32[i18 + 20 >> 2] | 0;
  i13 = HEAP32[i18 + 24 >> 2] | 0;
  if (i13 | 0) {
   if (!i15) break; else {
    i1 = 0;
    i9 = 0;
   }
   while (1) {
    i10 = HEAP32[i17 + (i9 * 24 | 0) + 12 >> 2] | 0;
    i2 = HEAP32[i17 + (i9 * 24 | 0) >> 2] | 0;
    i3 = i1;
    while (1) {
     i1 = HEAP32[i11 + (i3 * 24 | 0) >> 2] | 0;
     if (i1 >>> 0 < i2 >>> 0) i3 = i3 + 1 | 0; else break;
    }
    i8 = i9 + 1 | 0;
    if (i1 >>> 0 <= i10 >>> 0) {
     i4 = i17 + (i9 * 24 | 0) + 4 | 0;
     i5 = i17 + (i9 * 24 | 0) + 8 | 0;
     i6 = i17 + (i9 * 24 | 0) + 16 | 0;
     i7 = i17 + (i9 * 24 | 0) + 20 | 0;
     i1 = i14 + (i9 << 1) | 0;
     i2 = i3;
     do {
      if (!(((HEAP32[i11 + (i2 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i11 + (i2 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) & -2147483648 | ((HEAP32[i6 >> 2] | 0) - (HEAP32[i11 + (i2 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i11 + (i2 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i16 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, HEAP32[i16 + (HEAPU16[i12 + (i2 << 1) >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i2 = i2 + 1 | 0;
     } while ((HEAP32[i11 + (i2 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0);
    }
    if (i8 >>> 0 < i15 >>> 0 & i3 >>> 0 < i13 >>> 0) {
     i1 = i3;
     i9 = i8;
    } else {
     i1 = 0;
     i9 = 0;
     break;
    }
   }
   while (1) {
    i10 = HEAP32[i11 + (i9 * 24 | 0) + 12 >> 2] | 0;
    i2 = HEAP32[i11 + (i9 * 24 | 0) >> 2] | 0;
    i3 = i1;
    while (1) {
     i1 = HEAP32[i17 + (i3 * 24 | 0) >> 2] | 0;
     if (i1 >>> 0 > i2 >>> 0) break; else i3 = i3 + 1 | 0;
    }
    i8 = i9 + 1 | 0;
    if (i1 >>> 0 <= i10 >>> 0) {
     i4 = i11 + (i9 * 24 | 0) + 4 | 0;
     i5 = i11 + (i9 * 24 | 0) + 8 | 0;
     i6 = i11 + (i9 * 24 | 0) + 16 | 0;
     i7 = i11 + (i9 * 24 | 0) + 20 | 0;
     i1 = i12 + (i9 << 1) | 0;
     i2 = i3;
     do {
      if (!(((HEAP32[i17 + (i2 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i17 + (i2 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) & -2147483648 | ((HEAP32[i6 >> 2] | 0) - (HEAP32[i17 + (i2 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i17 + (i2 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i16 + (HEAPU16[i14 + (i2 << 1) >> 1] << 3) + 4 >> 2] | 0, HEAP32[i16 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i2 = i2 + 1 | 0;
     } while ((HEAP32[i17 + (i2 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0);
    }
    if (i8 >>> 0 < i13 >>> 0 & i3 >>> 0 < i15 >>> 0) {
     i1 = i3;
     i9 = i8;
    } else break;
   }
  }
  if (i15 | 0) {
   i1 = 0;
   i9 = 0;
   while (1) {
    i10 = HEAP32[i17 + (i9 * 24 | 0) + 12 >> 2] | 0;
    i3 = HEAP32[i17 + (i9 * 24 | 0) >> 2] | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + 1 | 0;
     if ((HEAP32[i17 + (i2 * 24 | 0) >> 2] | 0) >>> 0 < i3 >>> 0) i2 = i1; else break;
    }
    i8 = i9 + 1 | 0;
    if (i1 >>> 0 >= i15 >>> 0) break L4;
    if ((HEAP32[i17 + (i1 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0) {
     i4 = i17 + (i9 * 24 | 0) + 4 | 0;
     i5 = i17 + (i9 * 24 | 0) + 8 | 0;
     i6 = i17 + (i9 * 24 | 0) + 16 | 0;
     i7 = i17 + (i9 * 24 | 0) + 20 | 0;
     i2 = i14 + (i9 << 1) | 0;
     i3 = i1;
     do {
      if (!(((HEAP32[i17 + (i3 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i17 + (i3 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) & -2147483648 | ((HEAP32[i6 >> 2] | 0) - (HEAP32[i17 + (i3 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i17 + (i3 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i16 + (HEAPU16[i2 >> 1] << 3) + 4 >> 2] | 0, HEAP32[i16 + (HEAPU16[i14 + (i3 << 1) >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i3 = i3 + 1 | 0;
     } while ((HEAP32[i17 + (i3 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0);
    }
    if (i8 >>> 0 < i15 >>> 0) i9 = i8; else break;
   }
  }
 } while (0);
 if (HEAP8[i18 + 60 >> 0] | 0) {
  i12 = HEAP32[i18 + 36 >> 2] | 0;
  i13 = HEAP32[i18 + 40 >> 2] | 0;
  i14 = HEAP32[i18 + 32 >> 2] | 0;
  i15 = HEAP32[i18 + 44 >> 2] | 0;
  i16 = HEAP32[i18 + 48 >> 2] | 0;
  i17 = HEAP32[i18 + 52 >> 2] | 0;
  i11 = HEAP32[i18 + 56 >> 2] | 0;
  if ((i12 | 0) != 0 & (i13 | 0) != 0) {
   i1 = 0;
   i4 = 0;
   while (1) {
    i10 = HEAP32[i15 + (i4 * 24 | 0) + 12 >> 2] | 0;
    i2 = HEAP32[i15 + (i4 * 24 | 0) >> 2] | 0;
    i3 = i1;
    while (1) {
     i1 = HEAP32[i16 + (i3 * 24 | 0) >> 2] | 0;
     if (i1 >>> 0 < i2 >>> 0) i3 = i3 + 1 | 0; else break;
    }
    i9 = i4 + 1 | 0;
    if (i1 >>> 0 <= i10 >>> 0) {
     i5 = i15 + (i4 * 24 | 0) + 4 | 0;
     i6 = i15 + (i4 * 24 | 0) + 8 | 0;
     i7 = i15 + (i4 * 24 | 0) + 16 | 0;
     i8 = i15 + (i4 * 24 | 0) + 20 | 0;
     i1 = i11 + (i4 << 1) | 0;
     i4 = i3;
     do {
      if (!(((HEAP32[i16 + (i4 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i16 + (i4 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) & -2147483648 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i16 + (i4 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i8 >> 2] | 0) - (HEAP32[i16 + (i4 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i14 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, HEAP32[i14 + (HEAPU16[i17 + (i4 << 1) >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i2 = i4 + 1 | 0;
      if ((HEAP32[i16 + (i2 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0) if (!(((HEAP32[i16 + (i2 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i16 + (i2 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) & -2147483648 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i16 + (i2 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i8 >> 2] | 0) - (HEAP32[i16 + (i2 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i14 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, HEAP32[i14 + (HEAPU16[i17 + (i2 << 1) >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i4 = i4 + 2 | 0;
     } while ((HEAP32[i16 + (i4 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0);
    }
    if (i9 >>> 0 < i12 >>> 0 & i3 >>> 0 < i13 >>> 0) {
     i1 = i3;
     i4 = i9;
    } else {
     i1 = 0;
     i4 = 0;
     break;
    }
   }
   while (1) {
    i10 = HEAP32[i16 + (i4 * 24 | 0) + 12 >> 2] | 0;
    i2 = HEAP32[i16 + (i4 * 24 | 0) >> 2] | 0;
    i3 = i1;
    while (1) {
     i1 = HEAP32[i15 + (i3 * 24 | 0) >> 2] | 0;
     if (i1 >>> 0 > i2 >>> 0) break; else i3 = i3 + 1 | 0;
    }
    i9 = i4 + 1 | 0;
    if (i1 >>> 0 <= i10 >>> 0) {
     i5 = i16 + (i4 * 24 | 0) + 4 | 0;
     i6 = i16 + (i4 * 24 | 0) + 8 | 0;
     i7 = i16 + (i4 * 24 | 0) + 16 | 0;
     i8 = i16 + (i4 * 24 | 0) + 20 | 0;
     i1 = i17 + (i4 << 1) | 0;
     i4 = i3;
     do {
      if (!(((HEAP32[i15 + (i4 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i15 + (i4 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) & -2147483648 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i15 + (i4 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i8 >> 2] | 0) - (HEAP32[i15 + (i4 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i14 + (HEAPU16[i11 + (i4 << 1) >> 1] << 3) + 4 >> 2] | 0, HEAP32[i14 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i2 = i4 + 1 | 0;
      if ((HEAP32[i15 + (i2 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0) if (!(((HEAP32[i15 + (i2 * 24 | 0) + 20 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) >>> 1 & 1073741824 | (HEAP32[i15 + (i2 * 24 | 0) + 16 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) & -2147483648 | ((HEAP32[i7 >> 2] | 0) - (HEAP32[i15 + (i2 * 24 | 0) + 4 >> 2] | 0) | 0) >>> 2 & 536870912 | ((HEAP32[i8 >> 2] | 0) - (HEAP32[i15 + (i2 * 24 | 0) + 8 >> 2] | 0) | 0) >>> 3 & 268435456)) __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i22, HEAP32[i14 + (HEAPU16[i11 + (i2 << 1) >> 1] << 3) + 4 >> 2] | 0, HEAP32[i14 + (HEAPU16[i1 >> 1] << 3) + 4 >> 2] | 0, i20, i21) | 0;
      i4 = i4 + 2 | 0;
     } while ((HEAP32[i15 + (i4 * 24 | 0) >> 2] | 0) >>> 0 <= i10 >>> 0);
    }
    if (i9 >>> 0 < i13 >>> 0 & i3 >>> 0 < i12 >>> 0) {
     i1 = i3;
     i4 = i9;
    } else break;
   }
  }
 }
 HEAP32[i19 >> 2] = 0;
 return;
}

function __ZN13b2DynamicTree7BalanceEi(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i14 = HEAP32[i10 + 4 >> 2] | 0;
 i15 = i14 + (i11 * 36 | 0) | 0;
 i9 = i14 + (i11 * 36 | 0) + 24 | 0;
 i20 = HEAP32[i9 >> 2] | 0;
 if ((i20 | 0) == -1) {
  i20 = i11;
  return i20 | 0;
 }
 i16 = i14 + (i11 * 36 | 0) + 32 | 0;
 if ((HEAP32[i16 >> 2] | 0) < 2) {
  i20 = i11;
  return i20 | 0;
 }
 i8 = i14 + (i11 * 36 | 0) + 28 | 0;
 i17 = HEAP32[i8 >> 2] | 0;
 i12 = i14 + (i20 * 36 | 0) | 0;
 i13 = i14 + (i17 * 36 | 0) | 0;
 i18 = i14 + (i17 * 36 | 0) + 32 | 0;
 i19 = i14 + (i20 * 36 | 0) + 32 | 0;
 i1 = (HEAP32[i18 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0;
 if ((i1 | 0) > 1) {
  i9 = i14 + (i17 * 36 | 0) + 24 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i14 + (i17 * 36 | 0) + 28 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i14 + (i3 * 36 | 0) | 0;
  i7 = i14 + (i5 * 36 | 0) | 0;
  HEAP32[i9 >> 2] = i11;
  i9 = i14 + (i11 * 36 | 0) + 20 | 0;
  i2 = i14 + (i17 * 36 | 0) + 20 | 0;
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i17;
  i2 = HEAP32[i2 >> 2] | 0;
  do if ((i2 | 0) == -1) HEAP32[i10 >> 2] = i17; else {
   i1 = i14 + (i2 * 36 | 0) + 24 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) {
    HEAP32[i1 >> 2] = i17;
    break;
   } else {
    HEAP32[i14 + (i2 * 36 | 0) + 28 >> 2] = i17;
    break;
   }
  } while (0);
  i1 = i14 + (i3 * 36 | 0) + 32 | 0;
  i2 = i14 + (i5 * 36 | 0) + 32 | 0;
  if ((HEAP32[i1 >> 2] | 0) > (HEAP32[i2 >> 2] | 0)) {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i8 >> 2] = i5;
   HEAP32[i14 + (i5 * 36 | 0) + 20 >> 2] = i11;
   f26 = Math_fround(HEAPF32[i12 >> 2]);
   f21 = Math_fround(HEAPF32[i7 >> 2]);
   f21 = f26 < f21 ? f26 : f21;
   f26 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 4 >> 2]);
   f23 = f26 < f23 ? f26 : f23;
   HEAPF32[i15 >> 2] = f21;
   HEAPF32[i14 + (i11 * 36 | 0) + 4 >> 2] = f23;
   f26 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 12 >> 2]);
   f22 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 12 >> 2]);
   i15 = i14 + (i11 * 36 | 0) + 8 | 0;
   HEAPF32[i15 >> 2] = f26 > f25 ? f26 : f25;
   i20 = i14 + (i11 * 36 | 0) + 12 | 0;
   HEAPF32[i20 >> 2] = f24 > f22 ? f24 : f22;
   f22 = Math_fround(HEAPF32[i6 >> 2]);
   f24 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 4 >> 2]);
   HEAPF32[i13 >> 2] = f21 < f22 ? f21 : f22;
   HEAPF32[i14 + (i17 * 36 | 0) + 4 >> 2] = f23 < f24 ? f23 : f24;
   f24 = Math_fround(HEAPF32[i15 >> 2]);
   f23 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 8 >> 2]);
   f22 = Math_fround(HEAPF32[i20 >> 2]);
   f21 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 12 >> 2]);
   HEAPF32[i14 + (i17 * 36 | 0) + 8 >> 2] = f24 > f23 ? f24 : f23;
   HEAPF32[i14 + (i17 * 36 | 0) + 12 >> 2] = f22 > f21 ? f22 : f21;
   i19 = HEAP32[i19 >> 2] | 0;
   i20 = HEAP32[i2 >> 2] | 0;
   i20 = ((i19 | 0) > (i20 | 0) ? i19 : i20) + 1 | 0;
   HEAP32[i16 >> 2] = i20;
   i1 = HEAP32[i1 >> 2] | 0;
   i1 = (i20 | 0) > (i1 | 0) ? i20 : i1;
  } else {
   HEAP32[i4 >> 2] = i5;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i14 + (i3 * 36 | 0) + 20 >> 2] = i11;
   f21 = Math_fround(HEAPF32[i12 >> 2]);
   f26 = Math_fround(HEAPF32[i6 >> 2]);
   f26 = f21 < f26 ? f21 : f26;
   f21 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 4 >> 2]);
   f24 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 4 >> 2]);
   f24 = f21 < f24 ? f21 : f24;
   HEAPF32[i15 >> 2] = f26;
   HEAPF32[i14 + (i11 * 36 | 0) + 4 >> 2] = f24;
   f21 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 8 >> 2]);
   f22 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i14 + (i20 * 36 | 0) + 12 >> 2]);
   f25 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 12 >> 2]);
   i15 = i14 + (i11 * 36 | 0) + 8 | 0;
   HEAPF32[i15 >> 2] = f21 > f22 ? f21 : f22;
   i20 = i14 + (i11 * 36 | 0) + 12 | 0;
   HEAPF32[i20 >> 2] = f23 > f25 ? f23 : f25;
   f25 = Math_fround(HEAPF32[i7 >> 2]);
   f23 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 4 >> 2]);
   HEAPF32[i13 >> 2] = f26 < f25 ? f26 : f25;
   HEAPF32[i14 + (i17 * 36 | 0) + 4 >> 2] = f24 < f23 ? f24 : f23;
   f23 = Math_fround(HEAPF32[i15 >> 2]);
   f24 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i20 >> 2]);
   f26 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 12 >> 2]);
   HEAPF32[i14 + (i17 * 36 | 0) + 8 >> 2] = f23 > f24 ? f23 : f24;
   HEAPF32[i14 + (i17 * 36 | 0) + 12 >> 2] = f25 > f26 ? f25 : f26;
   i19 = HEAP32[i19 >> 2] | 0;
   i20 = HEAP32[i1 >> 2] | 0;
   i20 = ((i19 | 0) > (i20 | 0) ? i19 : i20) + 1 | 0;
   HEAP32[i16 >> 2] = i20;
   i1 = HEAP32[i2 >> 2] | 0;
   i1 = (i20 | 0) > (i1 | 0) ? i20 : i1;
  }
  HEAP32[i18 >> 2] = i1 + 1;
  i20 = i17;
  return i20 | 0;
 }
 if ((i1 | 0) >= -1) {
  i20 = i11;
  return i20 | 0;
 }
 i8 = i14 + (i20 * 36 | 0) + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i14 + (i20 * 36 | 0) + 28 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i14 + (i3 * 36 | 0) | 0;
 i7 = i14 + (i5 * 36 | 0) | 0;
 HEAP32[i8 >> 2] = i11;
 i8 = i14 + (i11 * 36 | 0) + 20 | 0;
 i2 = i14 + (i20 * 36 | 0) + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i20;
 i2 = HEAP32[i2 >> 2] | 0;
 do if ((i2 | 0) == -1) HEAP32[i10 >> 2] = i20; else {
  i1 = i14 + (i2 * 36 | 0) + 24 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i1 >> 2] = i20;
   break;
  } else {
   HEAP32[i14 + (i2 * 36 | 0) + 28 >> 2] = i20;
   break;
  }
 } while (0);
 i1 = i14 + (i3 * 36 | 0) + 32 | 0;
 i2 = i14 + (i5 * 36 | 0) + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) > (HEAP32[i2 >> 2] | 0)) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i14 + (i5 * 36 | 0) + 20 >> 2] = i11;
  f21 = Math_fround(HEAPF32[i13 >> 2]);
  f26 = Math_fround(HEAPF32[i7 >> 2]);
  f26 = f21 < f26 ? f21 : f26;
  f21 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 4 >> 2]);
  f24 = f21 < f24 ? f21 : f24;
  HEAPF32[i15 >> 2] = f26;
  HEAPF32[i14 + (i11 * 36 | 0) + 4 >> 2] = f24;
  f21 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 12 >> 2]);
  f25 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 12 >> 2]);
  i15 = i14 + (i11 * 36 | 0) + 8 | 0;
  HEAPF32[i15 >> 2] = f21 > f22 ? f21 : f22;
  i17 = i14 + (i11 * 36 | 0) + 12 | 0;
  HEAPF32[i17 >> 2] = f23 > f25 ? f23 : f25;
  f25 = Math_fround(HEAPF32[i6 >> 2]);
  f23 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 4 >> 2]);
  HEAPF32[i12 >> 2] = f26 < f25 ? f26 : f25;
  HEAPF32[i14 + (i20 * 36 | 0) + 4 >> 2] = f24 < f23 ? f24 : f23;
  f23 = Math_fround(HEAPF32[i15 >> 2]);
  f24 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i17 >> 2]);
  f26 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 12 >> 2]);
  HEAPF32[i14 + (i20 * 36 | 0) + 8 >> 2] = f23 > f24 ? f23 : f24;
  HEAPF32[i14 + (i20 * 36 | 0) + 12 >> 2] = f25 > f26 ? f25 : f26;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i2 >> 2] | 0;
  i18 = ((i17 | 0) > (i18 | 0) ? i17 : i18) + 1 | 0;
  HEAP32[i16 >> 2] = i18;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = (i18 | 0) > (i1 | 0) ? i18 : i1;
 } else {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i14 + (i3 * 36 | 0) + 20 >> 2] = i11;
  f21 = Math_fround(HEAPF32[i13 >> 2]);
  f26 = Math_fround(HEAPF32[i6 >> 2]);
  f26 = f21 < f26 ? f21 : f26;
  f21 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 4 >> 2]);
  f24 = f21 < f24 ? f21 : f24;
  HEAPF32[i15 >> 2] = f26;
  HEAPF32[i14 + (i11 * 36 | 0) + 4 >> 2] = f24;
  f21 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i14 + (i17 * 36 | 0) + 12 >> 2]);
  f25 = Math_fround(HEAPF32[i14 + (i3 * 36 | 0) + 12 >> 2]);
  i15 = i14 + (i11 * 36 | 0) + 8 | 0;
  HEAPF32[i15 >> 2] = f21 > f22 ? f21 : f22;
  i17 = i14 + (i11 * 36 | 0) + 12 | 0;
  HEAPF32[i17 >> 2] = f23 > f25 ? f23 : f25;
  f25 = Math_fround(HEAPF32[i7 >> 2]);
  f23 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 4 >> 2]);
  HEAPF32[i12 >> 2] = f26 < f25 ? f26 : f25;
  HEAPF32[i14 + (i20 * 36 | 0) + 4 >> 2] = f24 < f23 ? f24 : f23;
  f23 = Math_fround(HEAPF32[i15 >> 2]);
  f24 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i17 >> 2]);
  f26 = Math_fround(HEAPF32[i14 + (i5 * 36 | 0) + 12 >> 2]);
  HEAPF32[i14 + (i20 * 36 | 0) + 8 >> 2] = f23 > f24 ? f23 : f24;
  HEAPF32[i14 + (i20 * 36 | 0) + 12 >> 2] = f25 > f26 ? f25 : f26;
  i17 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i1 >> 2] | 0;
  i18 = ((i17 | 0) > (i18 | 0) ? i17 : i18) + 1 | 0;
  HEAP32[i16 >> 2] = i18;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (i18 | 0) > (i1 | 0) ? i18 : i1;
 }
 HEAP32[i19 >> 2] = i1 + 1;
 return i20 | 0;
}

function __ZN5physxL23PxcSweepSphereTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf(i8, i4, i10, i11, i5, i6, f7, i13, i14, i1, i2, i3, i12, f9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i4 + 288 | 0;
 i16 = i4 + 272 | 0;
 i21 = i4 + 128 | 0;
 i19 = i4 + 96 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i8 + 40 | 0;
 i52 = HEAP32[i8 >> 2] | 0;
 i53 = i21 + 64 | 0;
 HEAP32[i21 + 80 >> 2] = 4;
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 i50 = i21 + 96 | 0;
 i51 = i21 + 112 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 128 >> 2] = i52;
 HEAP32[i50 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i50 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i50 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i50 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i51 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i51 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i51 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = i52;
 HEAP32[i21 + 32 >> 2] = i52;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = -1;
 HEAP32[i53 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i53 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i53 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i53 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 i53 = HEAP32[i10 >> 2] | 0;
 i52 = HEAP32[i10 + 4 >> 2] | 0;
 i51 = HEAP32[i10 + 8 >> 2] | 0;
 i50 = HEAP32[i10 + 12 >> 2] | 0;
 i47 = i5 + 16 | 0;
 i49 = HEAP32[i47 >> 2] | 0;
 i48 = HEAP32[i47 + 4 >> 2] | 0;
 i47 = HEAP32[i47 + 8 >> 2] | 0;
 f45 = Math_fround(HEAPF32[i11 >> 2]);
 f46 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f44 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i32 = i6 + 16 | 0;
 f29 = Math_fround(HEAPF32[i32 >> 2]);
 f24 = Math_fround(HEAPF32[i32 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i32 + 8 >> 2]);
 HEAP32[i19 >> 2] = i53;
 i32 = i19 + 4 | 0;
 HEAP32[i32 >> 2] = i52;
 i5 = i19 + 8 | 0;
 HEAP32[i5 >> 2] = i51;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = i50;
 HEAP32[i19 + 16 >> 2] = i49;
 HEAP32[i19 + 20 >> 2] = i48;
 HEAP32[i19 + 24 >> 2] = i47;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f42 = (HEAP32[tempDoublePtr >> 2] = i53, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = Math_fround(-f42);
 f37 = Math_fround(-f37);
 f34 = Math_fround(-f34);
 f23 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f29 - f23);
 f38 = Math_fround(f24 - f25);
 f40 = Math_fround(f26 - f31);
 f41 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f43 = Math_fround(Math_fround(Math_fround(f27 * f42) + Math_fround(f38 * f37)) + Math_fround(f40 * f34));
 f28 = Math_fround(Math_fround(Math_fround(f43 * f37) + Math_fround(Math_fround(f41 * f38) + Math_fround(f30 * Math_fround(Math_fround(f27 * f34) - Math_fround(f40 * f42))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f30 * Math_fround(Math_fround(f38 * f42) - Math_fround(f27 * f37)))) + Math_fround(f43 * f34)) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(f44 * f30) - Math_fround(Math_fround(Math_fround(f45 * f42) + Math_fround(f46 * f37)) + Math_fround(f39 * f34)));
 f36 = Math_fround(Math_fround(Math_fround(f39 * f37) - Math_fround(f46 * f34)) + Math_fround(Math_fround(f44 * f42) + Math_fround(f45 * f30)));
 f33 = Math_fround(Math_fround(Math_fround(f45 * f34) - Math_fround(f39 * f42)) + Math_fround(Math_fround(f44 * f37) + Math_fround(f46 * f30)));
 f39 = Math_fround(Math_fround(Math_fround(f46 * f42) - Math_fround(f45 * f37)) + Math_fround(Math_fround(f44 * f34) + Math_fround(f39 * f30)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(Math_fround(f41 * f27) + Math_fround(f30 * Math_fround(Math_fround(f40 * f37) - Math_fround(f38 * f34))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f28;
 HEAPF32[i20 + 56 >> 2] = f22;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f22 = Math_fround(f36 + f36);
 f28 = Math_fround(f33 + f33);
 f34 = Math_fround(f39 + f39);
 f38 = Math_fround(f33 * f28);
 f37 = Math_fround(f39 * f34);
 f33 = Math_fround(f33 * f22);
 f40 = Math_fround(f39 * f22);
 f30 = Math_fround(f35 * f22);
 f39 = Math_fround(f39 * f28);
 f28 = Math_fround(f35 * f28);
 f34 = Math_fround(f35 * f34);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f36 * f22));
 f36 = Math_fround(f33 + f34);
 f35 = Math_fround(f40 - f28);
 f34 = Math_fround(f33 - f34);
 f33 = Math_fround(f22 - f37);
 f27 = Math_fround(f39 + f30);
 f28 = Math_fround(f40 + f28);
 f30 = Math_fround(f39 - f30);
 f22 = Math_fround(f22 - f38);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f38) - f37);
 HEAPF32[i20 + 4 >> 2] = f36;
 HEAPF32[i20 + 8 >> 2] = f35;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f34;
 HEAPF32[i20 + 20 >> 2] = f33;
 HEAPF32[i20 + 24 >> 2] = f27;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f28;
 HEAPF32[i20 + 36 >> 2] = f30;
 HEAPF32[i20 + 40 >> 2] = f22;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(f9 - f23);
 f25 = Math_fround(f22 - f25);
 f31 = Math_fround(f30 - f31);
 f29 = Math_fround(f28 - f29);
 f24 = Math_fround(f27 - f24);
 f26 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) - f26);
 HEAPF32[i18 >> 2] = f29;
 HEAPF32[i18 + 4 >> 2] = f24;
 HEAPF32[i18 + 8 >> 2] = f26;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f29 = Math_fround(f23 - f29);
 f24 = Math_fround(f25 - f24);
 f26 = Math_fround(f31 - f26);
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(HEAPF32[i32 >> 2]);
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f27 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f31) + Math_fround(f24 * f25)) + Math_fround(f26 * f23));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f30) + Math_fround(Math_fround(f24 * f28) - Math_fround(f27 * Math_fround(Math_fround(f29 * f23) - Math_fround(f31 * f26))))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f23 * f30) + Math_fround(Math_fround(f26 * f28) - Math_fround(f27 * Math_fround(Math_fround(f24 * f31) - Math_fround(f29 * f25))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f22;
 HEAPF32[i15 + 8 >> 2] = f9;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i12, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f7)) | 0)) {
  f46 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f46);
 }
 f46 = Math_fround(HEAPF32[i2 >> 2]);
 i53 = HEAP32[i3 + 4 >> 2] | 0;
 i52 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i53;
 HEAP32[i13 + 8 >> 2] = i52;
 i52 = HEAP32[i1 + 4 >> 2] | 0;
 i53 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i52;
 HEAP32[i14 + 8 >> 2] = i53;
 STACKTOP = i4;
 return Math_fround(f46);
}

function __ZN12_GLOBAL__N_16ParserILb1EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE(i2, i1, i59) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i59 = i59 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i60 = 0, i61 = 0, i62 = 0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i61 + 96 | 0;
 i53 = i61;
 i54 = i61 + 88 | 0;
 i55 = i61 + 80 | 0;
 i56 = i61 + 72 | 0;
 i57 = i61 + 32 | 0;
 i58 = i61 + 8 | 0;
 i52 = i2 + 32 | 0;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 44 >> 2] = i51;
 if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 36 >> 2] | 0, i52 | 0) | 0)) {
  STACKTOP = i61;
  return;
 }
 i1 = i2 + 52 | 0;
 i2 = i54 + 4 | 0;
 i3 = i55 + 4 | 0;
 i4 = i56 + 4 | 0;
 i5 = i60 + 4 | 0;
 i6 = i60 + 8 | 0;
 i7 = i60 + 12 | 0;
 i8 = i60 + 16 | 0;
 i9 = i60 + 20 | 0;
 i10 = i60 + 24 | 0;
 i11 = i60 + 28 | 0;
 i12 = i60 + 32 | 0;
 i13 = i60 + 36 | 0;
 i14 = i60 + 40 | 0;
 i15 = i60 + 44 | 0;
 i16 = i60 + 48 | 0;
 i17 = i60 + 52 | 0;
 i18 = i57 + 4 | 0;
 i19 = i57 + 8 | 0;
 i20 = i57 + 12 | 0;
 i21 = i57 + 16 | 0;
 i22 = i57 + 20 | 0;
 i23 = i57 + 24 | 0;
 i24 = i57 + 28 | 0;
 i25 = i57 + 32 | 0;
 i26 = i57 + 36 | 0;
 i27 = i57 + 4 | 0;
 i28 = i57 + 8 | 0;
 i29 = i57 + 12 | 0;
 i30 = i57 + 16 | 0;
 i31 = i57 + 20 | 0;
 i32 = i57 + 24 | 0;
 i33 = i57 + 28 | 0;
 i34 = i57 + 32 | 0;
 i35 = i57 + 36 | 0;
 i36 = i57 + 4 | 0;
 i37 = i57 + 8 | 0;
 i38 = i57 + 12 | 0;
 i39 = i57 + 16 | 0;
 i40 = i57 + 20 | 0;
 i41 = i57 + 24 | 0;
 i42 = i57 + 28 | 0;
 i43 = i57 + 32 | 0;
 i44 = i58 + 4 | 0;
 i45 = i58 + 20 | 0;
 i46 = i58 + 21 | 0;
 i47 = i58 + 22 | 0;
 i48 = i58 + 23 | 0;
 i49 = i58 + 8 | 0;
 i50 = i49 + 4 | 0;
 i51 = i49 + 8 | 0;
 L4 : while (1) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 40 >> 2] | 0, i52 | 0) | 0)) {
   i1 = 16;
   break;
  }
  i62 = HEAP32[i1 >> 2] | 0;
  HEAP32[i62 + 16 >> 2] = HEAP32[i62 + 12 >> 2];
  HEAP8[i60 >> 0] = 0;
  mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
  do switch (HEAPU8[i60 >> 0] | 0) {
  case 1:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 8 >> 2] | 0, i52 | 0, i53 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 8 >> 2] | 0, i59 | 0, i53 | 0);
    break;
   }
  case 2:
   {
    HEAP32[i54 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 24 >> 2] | 0, i52 | 0, i54 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 12 >> 2] | 0, i59 | 0, i54 | 0);
    break;
   }
  case 3:
   {
    HEAP32[i55 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 28 >> 2] | 0, i52 | 0, i55 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 16 >> 2] | 0, i59 | 0, i55 | 0);
    break;
   }
  case 4:
   {
    HEAP32[i56 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 32 >> 2] | 0, i52 | 0, i56 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 20 >> 2] | 0, i59 | 0, i56 | 0);
    break;
   }
  case 5:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i60 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i5 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i6 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i7 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i8 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i9 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i10 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i11 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i12 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i13 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i14 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i15 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i16 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i17 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 24 >> 2] | 0, i59 | 0, i60 | 0);
    break;
   }
  case 6:
   {
    __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE(i60, i52);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 28 >> 2] | 0, i59 | 0, i60 | 0);
    break;
   }
  case 7:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i18 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i19 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i20 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i21 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i22 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i23 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i24 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i25 | 0);
    HEAP8[i60 >> 0] = HEAP8[i26 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i26 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 32 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 8:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i27 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i28 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i29 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i30 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i31 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i32 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i33 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i34 | 0);
    HEAP8[i60 >> 0] = HEAP8[i35 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i35 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 36 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 9:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i36 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i37 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i38 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i39 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i40 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i41 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i42 | 0);
    HEAP8[i60 >> 0] = HEAP8[i43 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i43 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 40 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 10:
   {
    HEAP32[i58 >> 2] = 0;
    HEAP32[i44 >> 2] = 0;
    HEAP8[i45 >> 0] = 0;
    HEAP8[i46 >> 0] = 0;
    HEAP8[i47 >> 0] = 0;
    HEAP8[i48 >> 0] = -1;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 20 >> 2] | 0, i52 | 0, i58 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i49 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i50 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i51 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i45 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i46 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i47 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i48 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 44 >> 2] | 0, i59 | 0, i58 | 0);
    break;
   }
  default:
   {
    i1 = 16;
    break L4;
   }
  } while (0);
  if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 36 >> 2] | 0, i52 | 0) | 0)) {
   i1 = 16;
   break;
  }
 }
 if ((i1 | 0) == 16) {
  STACKTOP = i61;
  return;
 }
}

function __ZN12_GLOBAL__N_16ParserILb0EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE(i2, i1, i59) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i59 = i59 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i60 = 0, i61 = 0, i62 = 0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i61 + 96 | 0;
 i53 = i61;
 i54 = i61 + 88 | 0;
 i55 = i61 + 80 | 0;
 i56 = i61 + 72 | 0;
 i57 = i61 + 32 | 0;
 i58 = i61 + 8 | 0;
 i52 = i2 + 32 | 0;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 44 >> 2] = i51;
 if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 36 >> 2] | 0, i52 | 0) | 0)) {
  STACKTOP = i61;
  return;
 }
 i1 = i2 + 52 | 0;
 i2 = i54 + 4 | 0;
 i3 = i55 + 4 | 0;
 i4 = i56 + 4 | 0;
 i5 = i60 + 4 | 0;
 i6 = i60 + 8 | 0;
 i7 = i60 + 12 | 0;
 i8 = i60 + 16 | 0;
 i9 = i60 + 20 | 0;
 i10 = i60 + 24 | 0;
 i11 = i60 + 28 | 0;
 i12 = i60 + 32 | 0;
 i13 = i60 + 36 | 0;
 i14 = i60 + 40 | 0;
 i15 = i60 + 44 | 0;
 i16 = i60 + 48 | 0;
 i17 = i60 + 52 | 0;
 i18 = i57 + 4 | 0;
 i19 = i57 + 8 | 0;
 i20 = i57 + 12 | 0;
 i21 = i57 + 16 | 0;
 i22 = i57 + 20 | 0;
 i23 = i57 + 24 | 0;
 i24 = i57 + 28 | 0;
 i25 = i57 + 32 | 0;
 i26 = i57 + 36 | 0;
 i27 = i57 + 4 | 0;
 i28 = i57 + 8 | 0;
 i29 = i57 + 12 | 0;
 i30 = i57 + 16 | 0;
 i31 = i57 + 20 | 0;
 i32 = i57 + 24 | 0;
 i33 = i57 + 28 | 0;
 i34 = i57 + 32 | 0;
 i35 = i57 + 36 | 0;
 i36 = i57 + 4 | 0;
 i37 = i57 + 8 | 0;
 i38 = i57 + 12 | 0;
 i39 = i57 + 16 | 0;
 i40 = i57 + 20 | 0;
 i41 = i57 + 24 | 0;
 i42 = i57 + 28 | 0;
 i43 = i57 + 32 | 0;
 i44 = i58 + 4 | 0;
 i45 = i58 + 20 | 0;
 i46 = i58 + 21 | 0;
 i47 = i58 + 22 | 0;
 i48 = i58 + 23 | 0;
 i49 = i58 + 8 | 0;
 i50 = i49 + 4 | 0;
 i51 = i49 + 8 | 0;
 L4 : while (1) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 40 >> 2] | 0, i52 | 0) | 0)) {
   i1 = 16;
   break;
  }
  i62 = HEAP32[i1 >> 2] | 0;
  HEAP32[i62 + 16 >> 2] = HEAP32[i62 + 12 >> 2];
  HEAP8[i60 >> 0] = 0;
  mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
  do switch (HEAPU8[i60 >> 0] | 0) {
  case 1:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 8 >> 2] | 0, i52 | 0, i53 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 8 >> 2] | 0, i59 | 0, i53 | 0);
    break;
   }
  case 2:
   {
    HEAP32[i54 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 24 >> 2] | 0, i52 | 0, i54 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 12 >> 2] | 0, i59 | 0, i54 | 0);
    break;
   }
  case 3:
   {
    HEAP32[i55 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 28 >> 2] | 0, i52 | 0, i55 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 16 >> 2] | 0, i59 | 0, i55 | 0);
    break;
   }
  case 4:
   {
    HEAP32[i56 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 32 >> 2] | 0, i52 | 0, i56 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 20 >> 2] | 0, i59 | 0, i56 | 0);
    break;
   }
  case 5:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i60 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i5 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i6 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i7 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i8 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i9 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i10 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i11 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i12 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i13 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i14 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i15 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i16 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i17 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 24 >> 2] | 0, i59 | 0, i60 | 0);
    break;
   }
  case 6:
   {
    __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE(i60, i52);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 28 >> 2] | 0, i59 | 0, i60 | 0);
    break;
   }
  case 7:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i18 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i19 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i20 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i21 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i22 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i23 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i24 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i25 | 0);
    HEAP8[i60 >> 0] = HEAP8[i26 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i26 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 32 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 8:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i27 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i28 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i29 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i30 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i31 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i32 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i33 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i34 | 0);
    HEAP8[i60 >> 0] = HEAP8[i35 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i35 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 36 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 9:
   {
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i57 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i36 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i37 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i38 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i39 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i40 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i41 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i42 | 0);
    HEAP8[i60 >> 0] = HEAP8[i43 >> 0] | 0;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i60 | 0);
    HEAP8[i43 >> 0] = (HEAP8[i60 >> 0] | 0) != 0 & 1;
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 40 >> 2] | 0, i59 | 0, i57 | 0);
    break;
   }
  case 10:
   {
    HEAP32[i58 >> 2] = 0;
    HEAP32[i44 >> 2] = 0;
    HEAP8[i45 >> 0] = 0;
    HEAP8[i46 >> 0] = 0;
    HEAP8[i47 >> 0] = 0;
    HEAP8[i48 >> 0] = -1;
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 20 >> 2] | 0, i52 | 0, i58 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i49 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i50 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 12 >> 2] | 0, i52 | 0, i51 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i45 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i46 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i47 | 0);
    mftCall_vii(HEAP32[(HEAP32[i52 >> 2] | 0) + 16 >> 2] | 0, i52 | 0, i48 | 0);
    mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 44 >> 2] | 0, i59 | 0, i58 | 0);
    break;
   }
  default:
   {
    i1 = 16;
    break L4;
   }
  } while (0);
  if (!(mftCall_ii(HEAP32[(HEAP32[i52 >> 2] | 0) + 36 >> 2] | 0, i52 | 0) | 0)) {
   i1 = 16;
   break;
  }
 }
 if ((i1 | 0) == 16) {
  STACKTOP = i61;
  return;
 }
}

function __ZN14CachingManager9AuthorizeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_xiS8_(i12, i13, i7, i16, i17, i18, i19) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 32 | 0;
 i22 = i24 + 16 | 0;
 i21 = i24;
 i26 = i24 + 144 | 0;
 i20 = i24 + 156 | 0;
 i11 = i24 + 132 | 0;
 i1 = i24 + 120 | 0;
 i27 = i24 + 108 | 0;
 i2 = i24 + 96 | 0;
 i3 = i24 + 72 | 0;
 i4 = i24 + 84 | 0;
 i5 = i24 + 60 | 0;
 i14 = i24 + 48 | 0;
 i15 = i24 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i6 = i13 + 11 | 0;
 i28 = HEAP8[i6 >> 0] | 0;
 i8 = i13 + 4 | 0;
 i28 = i28 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i28 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, gb + 444549 | 0, 6, i28 + 6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i28) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i28 = HEAP8[i1 + 11 >> 0] | 0;
 i29 = i28 << 24 >> 24 < 0;
 i28 = i29 ? HEAP32[i1 + 4 >> 2] | 0 : i28 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i29 ? HEAP32[i1 >> 2] | 0 : i1, i28, i28 + 8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, gb + 444556 | 0, 8) | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i28 = HEAP8[i11 + 11 >> 0] | 0;
 i29 = i28 << 24 >> 24 < 0;
 i28 = i29 ? HEAP32[i11 + 4 >> 2] | 0 : i28 & 255;
 i9 = i7 + 11 | 0;
 i25 = HEAP8[i9 >> 0] | 0;
 i10 = i7 + 4 | 0;
 i25 = i25 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i25 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i20, i29 ? HEAP32[i11 >> 2] | 0 : i11, i28, i25 + i28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i25) | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i25 = HEAP8[i20 + 11 >> 0] | 0;
 i28 = i25 << 24 >> 24 < 0;
 i25 = i28 ? HEAP32[i20 + 4 >> 2] | 0 : i25 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i26, i28 ? HEAP32[i20 >> 2] | 0 : i20, i25, i25 + 6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i26, gb + 444565 | 0, 6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i27, i19);
 i25 = __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i(i26, i27, 2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (i25) HEAP32[i12 >> 2] = 2; else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i26 = HEAP8[i6 >> 0] | 0;
  i26 = i26 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i26 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i2, gb + 444549 | 0, 6, i26 + 6 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i2, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i26) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i26 = HEAP8[i2 + 11 >> 0] | 0;
  i28 = i26 << 24 >> 24 < 0;
  i26 = i28 ? HEAP32[i2 + 4 >> 2] | 0 : i26 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i28 ? HEAP32[i2 >> 2] | 0 : i2, i26, i26 + 8 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, gb + 444556 | 0, 8) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i26 = HEAP8[i1 + 11 >> 0] | 0;
  i28 = i26 << 24 >> 24 < 0;
  i26 = i28 ? HEAP32[i1 + 4 >> 2] | 0 : i26 & 255;
  i27 = HEAP8[i9 >> 0] | 0;
  i27 = i27 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i27 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i28 ? HEAP32[i1 >> 2] | 0 : i1, i26, i27 + i26 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i27) | 0;
  i27 = i21;
  HEAP32[i27 >> 2] = i16;
  HEAP32[i27 + 4 >> 2] = i17;
  __Z6FormatPKcz(i3, gb + 444572 | 0, i21);
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  i27 = HEAP8[i11 + 11 >> 0] | 0;
  i26 = i27 << 24 >> 24 < 0;
  i27 = i26 ? HEAP32[i11 + 4 >> 2] | 0 : i27 & 255;
  i28 = i3 + 11 | 0;
  i29 = HEAP8[i28 >> 0] | 0;
  i29 = i29 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i29 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i20, i26 ? HEAP32[i11 >> 2] | 0 : i11, i27, i29 + i27 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, (HEAP8[i28 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i29) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i20);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i19);
  i29 = __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i(i4, i5, 2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  if (!i29) {
   HEAP32[i22 >> 2] = i18;
   __Z6FormatPKcz(i21, gb + 444583 | 0, i22);
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   i1 = i20 + 11 | 0;
   i27 = HEAP8[i1 >> 0] | 0;
   i26 = i27 << 24 >> 24 < 0;
   i2 = i20 + 4 | 0;
   i27 = i26 ? HEAP32[i2 >> 2] | 0 : i27 & 255;
   i28 = i21 + 11 | 0;
   i29 = HEAP8[i28 >> 0] | 0;
   i29 = i29 << 24 >> 24 < 0 ? HEAP32[i21 + 4 >> 2] | 0 : i29 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i26 ? HEAP32[i20 >> 2] | 0 : i20, i27, i29 + i27 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, (HEAP8[i28 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, i29) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i15, i19);
   i29 = __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i(i14, i15, 2) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   if (!i29) {
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    HEAP32[i22 + 8 >> 2] = 0;
    i29 = HEAP8[i1 >> 0] | 0;
    i29 = i29 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i29 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i22, gb + 444598 | 0, 45, i29 + 45 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i22, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, i29) | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 444242 | 0, 944, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
    i29 = 0;
    STACKTOP = i24;
    return i29 | 0;
   }
  }
  HEAP32[i12 >> 2] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 }
 if ((i18 | 0) > 0) if ((_time(0) | 0) > (i18 | 0)) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i23 >> 2] = i18;
  __Z6FormatPKcz(i20, gb + 444644 | 0, i23);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 + 11 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, 0, gb + 444242 | 0, 957, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  i29 = 0;
  STACKTOP = i24;
  return i29 | 0;
 }
 __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb(i12, i13, i16, i17, 0);
 i29 = 1;
 STACKTOP = i24;
 return i29 | 0;
}

function __ZN13SpeedTreeWind8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481742 | 0, gb + 481752 | 0, i1, 0);
 __ZN13SpeedTreeWind7SParams8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481760 | 0, i5, i1 + 1332 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481778 | 0, i5, i1 + 1336 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481796 | 0, i5, i1 + 1340 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481814 | 0, i5, i1 + 1344 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481839 | 0, i5, i1 + 1348 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481851 | 0, i5, i1 + 1349 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481873 | 0, i5, i1 + 1350 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481889 | 0, i5, i1 + 1351 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481910 | 0, i5, i1 + 1352 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481937 | 0, i5, i1 + 1353 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481957 | 0, i5, i1 + 1354 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481971 | 0, i5, i1 + 1355 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481992 | 0, i5, i1 + 1356 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482008 | 0, i5, i1 + 1357 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482029 | 0, i5, i1 + 1358 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482056 | 0, i5, i1 + 1359 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482076 | 0, i5, i1 + 1360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482090 | 0, i5, i1 + 1361 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482111 | 0, i5, i1 + 1362 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482139 | 0, i5, i1 + 1363 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482162 | 0, i5, i1 + 1364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482176 | 0, i5, i1 + 1365 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482190 | 0, i5, i1 + 1366 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482207 | 0, i5, i1 + 1367 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482235 | 0, i5, i1 + 1368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482258 | 0, i5, i1 + 1369 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482272 | 0, i5, i1 + 1370 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482286 | 0, i5, i1 + 1371 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482303 | 0, i5, i1 + 1372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482326 | 0, i5, i1 + 1373 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482349 | 0, i5, i1 + 1374 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 482378 | 0, i5, i1 + 1375 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN19SpriteMeshGenerator9MakeShapeEP11ColorRGBA32iifhbjfi(i25, i5, i18, i19, f6, i11, i20, i12, f21, i26) {
 i25 = i25 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 f6 = Math_fround(f6);
 i11 = i11 | 0;
 i20 = i20 | 0;
 i12 = i12 | 0;
 f21 = Math_fround(f21);
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i28 + 32 | 0;
 i24 = i28 + 112 | 0;
 i27 = i28;
 i16 = i28 + 104 | 0;
 i17 = i28 + 100 | 0;
 i23 = i28 + 108 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155240 | 0, i22);
 __ZN19SpriteMeshGenerator4maskC2EP11ColorRGBA32iihj(i27, i5, i18, i19, i11, i12);
 i24 = i27;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i7 = i25 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = i25 + 20 | 0;
 i1 = HEAP32[i27 + 20 >> 2] | 0;
 i24 = i27 + 8 | 0;
 i10 = HEAP32[i24 + 4 >> 2] | 0;
 i9 = i22;
 HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i22 + 12 | 0;
 HEAP32[i9 >> 2] = i1;
 i10 = i22 + 16 | 0;
 i1 = (i1 + 31 | 0) >>> 5;
 HEAP32[i10 >> 2] = i1;
 if (!i1) {
  i1 = i22 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i22;
  i3 = 0;
  i4 = 0;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 391709 | 0, 70) | 0;
  i3 = i22 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
  _memset(i1 | 0, 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i1 = i3;
  i2 = i22;
  i3 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] << 2;
 }
 i24 = i27 + 16 | 0;
 _memcpy(i3 | 0, HEAP32[i24 >> 2] | 0, i4 | 0) | 0;
 i4 = i25 + 28 | 0;
 i15 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i15;
 i4 = i25 + 32 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i25 + 36 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i9;
 i9 = i7;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i22;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i22;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, i2);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i27 + 8 | 0);
 __ZN19SpriteMeshGenerator4maskC2EP11ColorRGBA32iihj(i27, i5, i18, i19, i11, i12);
 i24 = i27;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i9 = i25 + 40 | 0;
 HEAP32[i9 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i25 + 48 | 0;
 i1 = HEAP32[i27 + 20 >> 2] | 0;
 i24 = i27 + 8 | 0;
 i7 = HEAP32[i24 + 4 >> 2] | 0;
 i5 = i22;
 HEAP32[i5 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 i5 = i22 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 i7 = i22 + 16 | 0;
 i1 = (i1 + 31 | 0) >>> 5;
 HEAP32[i7 >> 2] = i1;
 if (!i1) {
  i1 = i22 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i22;
  i3 = 0;
  i4 = 0;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 391709 | 0, 70) | 0;
  i3 = i22 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
  _memset(i1 | 0, 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  i1 = i3;
  i2 = i22;
  i3 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] << 2;
 }
 i24 = i27 + 16 | 0;
 _memcpy(i3 | 0, HEAP32[i24 >> 2] | 0, i4 | 0) | 0;
 i11 = i25 + 56 | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i15;
 i11 = i25 + 60 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i10 = i25 + 64 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i11;
 i11 = i9;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i22;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = i7;
 i12 = i22;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, i2);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i27 + 8 | 0);
 HEAP32[i27 >> 2] = 0;
 i24 = i27 + 4 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 L9 : do if (__ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i25, i27, i16, i17) | 0) {
  f14 = Math_fround(Math_fround(Math_imul(i19, i18) | 0) * Math_fround(.25));
  i4 = f6 < Math_fround(0.0);
  i5 = i25 + 4 | 0;
  i7 = i25 + 8 | 0;
  i9 = i22 + 56 | 0;
  i10 = i22 + 44 | 0;
  i11 = i22 + 4 | 0;
  i12 = i22 + 48 | 0;
  i15 = i22 + 60 | 0;
  f8 = Math_fround(0.0);
  do {
   L13 : do if (i20) {
    if (!i4) {
     i1 = HEAP32[i16 >> 2] | 0;
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     break;
    }
    while (1) {
     i1 = HEAP32[i16 >> 2] | 0;
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     if (!((i1 | 0) == 45 & f13 < f14)) break L13;
     if (!(__ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i25, i27, i16, i17) | 0)) break L9;
    }
   } else if (i4) {
    while (1) {
     i1 = HEAP32[i16 >> 2] | 0;
     if ((i1 | 0) != 45) break;
     if (!(__ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i25, i27, i16, i17) | 0)) break L9;
    }
    f13 = Math_fround(HEAPF32[i17 >> 2]);
    break;
   } else {
    while (1) {
     i1 = HEAP32[i16 >> 2] | 0;
     if ((i1 | 0) != 45) break;
     if (!(__ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i25, i27, i16, i17) | 0)) break L9;
    }
    f13 = Math_fround(HEAPF32[i17 >> 2]);
    break;
   } while (0);
   f29 = Math_fround(-f13);
   f8 = Math_fround(f8 + ((i1 | 0) == 43 ? f13 : f29));
   __ZN19SpriteMeshGenerator4pathC2ERKNSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEiiiff(i22, i27, i18, i19, i1, f13, f21);
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i25, i22); else {
    __ZN19SpriteMeshGenerator4pathC2ERKS0_(i1, i22);
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 68;
   }
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i15 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    __ZdlPv(i1);
   }
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i12 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
    __ZdlPv(i1);
   }
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i11 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
    __ZdlPv(i1);
   }
  } while (__ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i25, i27, i16, i17) | 0);
 } else f8 = Math_fround(0.0); while (0);
 __Z12profiler_endP19ProfilerInformation(gb + 1155240 | 0);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155252 | 0, i22);
 if (f6 < Math_fround(0.0)) {
  i7 = i25 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i23 = i4 - i1 | 0;
  i5 = (i23 | 0) / 68 | 0;
  if ((i23 | 0) > 0) {
   i3 = 0;
   i2 = 0;
   do {
    if ((HEAP32[i1 + (i3 * 68 | 0) + 20 >> 2] | 0) == 45) i2 = i2 + 2 | 0; else i2 = i2 + -2 + ((HEAP32[i1 + (i3 * 68 | 0) + 4 >> 2] | 0) - (HEAP32[i1 + (i3 * 68 | 0) >> 2] | 0) >> 5) | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i5 | 0));
  } else i2 = 0;
  f6 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f8 * Math_fround(.000406901032)) / Math_fround(i2 | 0)));
  i3 = f6 < Math_fround(0.0);
  i5 = f6 > Math_fround(1.0);
  f6 = i5 ? Math_fround(1.0) : f6;
  f6 = i3 ? Math_fround(0.0) : f6;
  i3 = i7;
  i5 = i25;
 } else {
  i4 = i25 + 4 | 0;
  i3 = i4;
  i5 = i25;
  i4 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
 }
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  do {
   __ZN19SpriteMeshGenerator4path8simplifyEfi(i2, f6, i26);
   i2 = i2 + 68 | 0;
  } while ((i2 | 0) != (HEAP32[i3 >> 2] | 0));
  i1 = HEAP32[i5 >> 2] | 0;
  i4 = i2;
 }
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  do {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if ((i1 | 0) != (i3 | 0)) do {
    HEAPF32[i1 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(.5))));
    i26 = i1 + 4 | 0;
    HEAPF32[i26 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i26 >> 2]) + Math_fround(.5))));
    i1 = i1 + 32 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i2 + 68 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 __Z12profiler_endP19ProfilerInformation(gb + 1155252 | 0);
 i1 = HEAP32[i27 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i24 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 __ZdlPv(i1);
 STACKTOP = i28;
 return;
}

function __ZN7mecanim5human17NormalizedHandleXEPKNS0_5HumanEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, f30 = f0, f31 = f0;
 i29 = i2 + 60 | 0;
 i29 = (HEAP32[i29 >> 2] | 0) + i29 | 0;
 i28 = HEAP32[i2 + 72 + (HEAP32[i29 + (i3 * 48 | 0) + 40 >> 2] << 2) >> 2] | 0;
 i8 = i2 + 44 | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i8 + 4 | 0;
 i8 = i8 + (HEAP32[i8 >> 2] | 0) | 0;
 f25 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 16 >> 2]);
 f26 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 20 >> 2]);
 f27 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 28 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i8 + (i28 * 40 | 0) + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) >> 2]);
 f6 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 4 >> 2]);
 f5 = Math_fround(f10 * f5);
 f6 = Math_fround(f19 * f6);
 f12 = Math_fround(f4 * Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 8 >> 2]));
 f20 = Math_fround(f17 * Math_fround(-2.0));
 f9 = Math_fround(f17 * Math_fround(2.0));
 f21 = Math_fround(f20 * f27);
 f24 = Math_fround(f26 * Math_fround(2.0));
 f16 = Math_fround(f26 * Math_fround(-2.0));
 f31 = Math_fround(f27 * f16);
 f7 = Math_fround(f11 * Math_fround(-2.0));
 f30 = Math_fround(f11 * Math_fround(2.0));
 f15 = Math_fround(f7 * f27);
 f18 = Math_fround(f25 + Math_fround(Math_fround(f5 + Math_fround(Math_fround(Math_fround(f17 * f20) - Math_fround(f26 * f24)) * f5)) + Math_fround(Math_fround(Math_fround(f31 - Math_fround(f17 * f7)) * f6) + Math_fround(Math_fround(Math_fround(f30 * f26) - f21) * f12))));
 f20 = Math_fround(f13 + Math_fround(Math_fround(f6 + Math_fround(Math_fround(Math_fround(f11 * f9) - f31) * f5)) + Math_fround(Math_fround(Math_fround(Math_fround(f26 * f16) - Math_fround(f11 * f30)) * f6) + Math_fround(Math_fround(f15 - Math_fround(f20 * f26)) * f12))));
 f12 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(Math_fround(f21 - Math_fround(f11 * f16)) * f5) + f12) + Math_fround(Math_fround(Math_fround(Math_fround(f17 * f24) - f15) * f6) + Math_fround(Math_fround(Math_fround(f11 * f7) - Math_fround(f17 * f9)) * f12))));
 f9 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 12 >> 2]);
 f7 = Math_fround(f17 * f9);
 f6 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 24 >> 2]);
 f15 = Math_fround(f27 * f6);
 f24 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 16 >> 2]);
 f5 = Math_fround(f26 * f24);
 f16 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 20 >> 2]);
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f27 * f16)) - Math_fround(f26 * f6)) - Math_fround(f11 * f24));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f11 * f9)) - Math_fround(f26 * f16)) - Math_fround(f17 * f24));
 f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f17 * f16)) - Math_fround(f27 * f9)) - Math_fround(f11 * f6));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f16) - Math_fround(f26 * f9)) - Math_fround(f27 * f24)) - Math_fround(f17 * f6));
 i8 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i23 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f6 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 28 >> 2]);
 f5 = Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 32 >> 2]);
 f6 = Math_fround(f10 * f6);
 f5 = Math_fround(f19 * f5);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i29 + (i3 * 48 | 0) + 36 >> 2]));
 i2 = i2 + 40 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i3 = i2 + 16 | 0;
 i2 = i2 + 4 | 0;
 i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i28 << 3) + 4 >> 2] | 0;
 i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
 f19 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 24 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 28 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f19) - Math_fround(f27 * f7)) - Math_fround(f26 * f24)) - Math_fround(f11 * f10));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f24) - Math_fround(f11 * f19)) - Math_fround(f26 * f7)) - Math_fround(f17 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f10) - Math_fround(f17 * f7)) - Math_fround(f27 * f19)) - Math_fround(f11 * f24));
 f24 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f7) - Math_fround(f26 * f19)) - Math_fround(f27 * f10)) - Math_fround(f17 * f24));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 i28 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f24 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(f24 * f24);
 f9 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(f9 * f9);
 f10 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f10 * f10)) + Math_fround(f21 + f17)))));
 f24 = Math_fround(f17 * f24);
 f9 = Math_fround(f17 * f9);
 f10 = Math_fround(f17 * f10);
 f16 = Math_fround(f17 * f16);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i28 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f25 = Math_fround(f18 - f25);
 f13 = Math_fround(f20 - f13);
 f14 = Math_fround(f12 - f14);
 f12 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f12 * Math_fround(-2.0));
 f9 = Math_fround(f12 * Math_fround(2.0));
 f24 = Math_fround(f16 * f10);
 f17 = Math_fround(f18 * Math_fround(2.0));
 f21 = Math_fround(f18 * Math_fround(-2.0));
 f27 = Math_fround(f16 * f21);
 f19 = Math_fround(f20 * Math_fround(-2.0));
 f26 = Math_fround(f20 * Math_fround(2.0));
 f7 = Math_fround(f16 * f19);
 f11 = Math_fround(Math_fround(f25 + Math_fround(f25 * Math_fround(Math_fround(f12 * f10) - Math_fround(f18 * f17)))) + Math_fround(Math_fround(f13 * Math_fround(f27 - Math_fround(f12 * f19))) + Math_fround(f14 * Math_fround(Math_fround(f18 * f26) - f24))));
 f10 = Math_fround(Math_fround(f13 + Math_fround(f25 * Math_fround(Math_fround(f20 * f9) - f27))) + Math_fround(Math_fround(f13 * Math_fround(Math_fround(f18 * f21) - Math_fround(f20 * f26))) + Math_fround(f14 * Math_fround(f7 - Math_fround(f18 * f10)))));
 f9 = Math_fround(Math_fround(f14 + Math_fround(f25 * Math_fround(f24 - Math_fround(f20 * f21)))) + Math_fround(Math_fround(f13 * Math_fround(Math_fround(f12 * f17) - f7)) + Math_fround(f14 * Math_fround(Math_fround(f20 * f19) - Math_fround(f12 * f9)))));
 f19 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f19 * f12);
 f7 = Math_fround(f15 * f16);
 f17 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f17 * f18);
 f21 = (HEAP32[tempDoublePtr >> 2] = i8 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f21 * f16)) - Math_fround(f15 * f18)) - Math_fround(f17 * f20));
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f19 * f20)) - Math_fround(f21 * f18)) - Math_fround(f17 * f12));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f21 * f12)) - Math_fround(f19 * f16)) - Math_fround(f15 * f20));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f16)) - Math_fround(f15 * f12));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i1 >> 2] = f11;
 HEAPF32[i1 + 4 >> 2] = f10;
 HEAPF32[i1 + 8 >> 2] = f9;
 HEAP32[i1 + 12 >> 2] = i8 ^ -2147483648;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i3 ^ -2147483648;
 HEAPF32[i1 + 24 >> 2] = f7;
 HEAPF32[i1 + 28 >> 2] = f6;
 HEAPF32[i1 + 32 >> 2] = f5;
 HEAPF32[i1 + 36 >> 2] = f4;
 return;
}

function __ZNK20GpuProgramParameters23PrepareOverridingValuesERK19ShaderPropertySheetR13dynamic_arrayIhLj4EE(i21, i22, i25) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 4 | 0;
 i9 = i26;
 HEAP32[i9 >> 2] = i22;
 __ZL22PrepareValueParametersI27OverridingParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i21 + 16 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i21 + 4 >> 2] | 0, HEAP32[i21 + 8 >> 2] | 0, i25, i9);
 i6 = i21 + 80 | 0;
 i7 = i21 + 84 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i23 = i25 + 12 | 0;
 i24 = i25 + 16 | 0;
 if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) {
  i8 = i25 + 4 | 0;
  i5 = 0;
  do {
   if ((HEAP32[i1 + (i5 * 52 | 0) + 32 >> 2] | 0) == 2) {
    i2 = HEAP32[i23 >> 2] | 0;
    i1 = i2 + 4 | 0;
    HEAP32[i23 >> 2] = i1;
    i3 = HEAP32[i24 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i4 >>> 0 < i1 >>> 0) {
     i19 = i3 << 1;
     i1 = i19 >>> 0 > i1 >>> 0 ? i19 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i24 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i19 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
      HEAP32[i24 >> 2] = i1;
      HEAP32[i25 >> 2] = i19;
      break;
     }
    } while (0);
    i19 = (HEAP32[i25 >> 2] | 0) + i2 | 0;
    HEAP16[i19 >> 1] = 65535;
    HEAP16[i19 + 2 >> 1] = 65535 >>> 16;
   } else __ZL22PrepareValueParametersI27OverridingParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i1 + (i5 * 52 | 0) + 4 | 0, HEAP32[i1 + (i5 * 52 | 0) + 36 >> 2] | 0, HEAP32[i1 + (i5 * 52 | 0) + 40 >> 2] | 0, HEAP32[i1 + (i5 * 52 | 0) + 44 >> 2] | 0, i25, i9);
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i5 >>> 0 < (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 52 | 0) >>> 0);
 }
 i18 = i21 + 36 | 0;
 i19 = HEAP32[i23 >> 2] | 0;
 i1 = i19 + 4 | 0;
 HEAP32[i23 >> 2] = i1;
 i2 = HEAP32[i24 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 < i1 >>> 0) {
  i17 = i2 << 1;
  i1 = i17 >>> 0 > i1 >>> 0 ? i17 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i24 >> 2] = i1;
   HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i17 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
   HEAP32[i24 >> 2] = i1;
   HEAP32[i25 >> 2] = i17;
   break;
  }
 } while (0);
 HEAP32[(HEAP32[i25 >> 2] | 0) + i19 >> 2] = 0;
 i10 = i21 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i11 = i20 + 8 | 0;
  i12 = i25 + 4 | 0;
  i13 = i22 + 20 | 0;
  i14 = i22 + 24 | 0;
  i15 = i22 + 32 | 0;
  i16 = i22 + 52 | 0;
  i17 = i22 + 72 | 0;
  i3 = 0;
  i9 = 0;
  do {
   i8 = i2;
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   L28 : do if ((i4 | 0) < (i5 | 0)) {
    i6 = HEAP32[i15 >> 2] | 0;
    i7 = HEAP32[i8 + (i9 << 4) >> 2] | 0;
    while (1) {
     if ((HEAP32[i6 + (i4 << 2) >> 2] | 0) == (i7 | 0)) break;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) >= (i5 | 0)) break L28;
    }
    if ((i4 | 0) > -1) {
     i4 = (HEAP32[i17 >> 2] | 0) + (HEAP32[(HEAP32[i16 >> 2] | 0) + (i4 << 2) >> 2] & 1048575) | 0;
     i5 = HEAP32[i8 + (i9 << 4) + 12 >> 2] | 0;
     if (HEAP32[i4 >> 2] | 0) if ((i5 | 0) == 1 ? 1 : (HEAP32[i4 + 4 >> 2] | 0) == (i5 | 0)) {
      HEAP32[i11 >> 2] = 0;
      __ZNK9ShaderLab6TexEnv11PrepareDataEiiP15GfxTextureParam(i4, HEAP32[i8 + (i9 << 4) + 4 >> 2] | 0, HEAP32[i8 + (i9 << 4) + 8 >> 2] | 0, i20);
      i2 = HEAP32[i23 >> 2] | 0;
      i1 = i2 + 12 | 0;
      HEAP32[i23 >> 2] = i1;
      i4 = HEAP32[i24 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i5 >>> 0 < i1 >>> 0) {
       i8 = i4 << 1;
       i1 = i8 >>> 0 > i1 >>> 0 ? i8 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i24 >> 2] = i1;
        HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i8 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
        HEAP32[i24 >> 2] = i1;
        HEAP32[i25 >> 2] = i8;
        break;
       }
      } while (0);
      i1 = (HEAP32[i25 >> 2] | 0) + i2 | 0;
      HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i10 >> 2] | 0;
      i2 = HEAP32[i18 >> 2] | 0;
     }
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < i1 - i2 >> 4 >>> 0);
  if (i3 | 0) HEAP32[(HEAP32[i25 >> 2] | 0) + i19 >> 2] = i3;
 }
 i15 = i21 + 72 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) {
  i9 = i21 + 60 | 0;
  i10 = i25 + 4 | 0;
  i11 = i22 + 24 | 0;
  i12 = i22 + 28 | 0;
  i13 = i22 + 32 | 0;
  i14 = i22 + 52 | 0;
  i8 = i22 + 72 | 0;
  i7 = 0;
  do {
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   L52 : do if ((i2 | 0) < (i3 | 0)) {
    i4 = HEAP32[i13 >> 2] | 0;
    i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i7 << 4) >> 2] | 0;
    while (1) {
     if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i5 | 0)) break;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i3 | 0)) break L52;
    }
    if ((i2 | 0) > -1) {
     i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] & 1048575) >> 2] | 0;
     i4 = HEAP32[i23 >> 2] | 0;
     i1 = i4 + 4 | 0;
     HEAP32[i23 >> 2] = i1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2 & 2147483647;
     do if (i3 >>> 0 < i1 >>> 0) {
      i22 = i2 << 1;
      i1 = i22 >>> 0 > i1 >>> 0 ? i22 : i1;
      if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
       HEAP32[i24 >> 2] = i1;
       HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i22 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
       HEAP32[i24 >> 2] = i1;
       HEAP32[i25 >> 2] = i22;
       break;
      }
     } while (0);
     i1 = HEAP32[i25 >> 2] | 0;
     HEAP32[i1 + i4 >> 2] = i7;
     i5 = HEAP32[i23 >> 2] | 0;
     i2 = i5 + 4 | 0;
     HEAP32[i23 >> 2] = i2;
     i3 = HEAP32[i24 >> 2] | 0;
     i4 = i3 & 2147483647;
     do if (i4 >>> 0 < i2 >>> 0) {
      i22 = i3 << 1;
      i2 = i22 >>> 0 > i2 >>> 0 ? i22 : i2;
      if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i24 >> 2] = i2;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i25 >> 2] = i1;
       break;
      } else {
       i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i1 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
       HEAP32[i24 >> 2] = i2;
       HEAP32[i25 >> 2] = i1;
       break;
      }
     } while (0);
     HEAP32[i1 + i5 >> 2] = i6;
     i1 = HEAP32[i15 >> 2] | 0;
    }
   } while (0);
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i23 >> 2] = i1;
 i3 = HEAP32[i24 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i4 >>> 0 >= i1 >>> 0) {
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i2 | 0;
  HEAP32[i25 >> 2] = -1;
  STACKTOP = i26;
  return;
 }
 i22 = i3 << 1;
 i1 = i22 >>> 0 > i1 >>> 0 ? i22 : i1;
 if (i4 >>> 0 >= i1 >>> 0) {
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i2 | 0;
  HEAP32[i25 >> 2] = -1;
  STACKTOP = i26;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i24 >> 2] = i1;
  HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i2 | 0;
  HEAP32[i25 >> 2] = -1;
  STACKTOP = i26;
  return;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i25 >> 2] = i22;
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + i2 | 0;
  HEAP32[i25 >> 2] = -1;
  STACKTOP = i26;
  return;
 }
}

function __ZNK9ShaderLab11ShaderState20FindSubProgramsToUseEPK6ShaderPKNS_4PassER11SubProgramsRK17ShaderPassContext(i31, i34, i1, i35, i2) {
 i31 = i31 | 0;
 i34 = i34 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i33 + 40 | 0;
 i28 = i33 + 8 | 0;
 i29 = i33;
 i30 = i2 + 4 | 0;
 HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i27 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = HEAP32[i30 + 16 >> 2];
 HEAP32[i27 + 20 >> 2] = HEAP32[i30 + 20 >> 2];
 HEAP32[i27 + 24 >> 2] = HEAP32[i30 + 24 >> 2];
 HEAP32[i27 + 28 >> 2] = HEAP32[i30 + 28 >> 2];
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i28 + 16 >> 2] = 0;
 HEAP32[i28 + 20 >> 2] = 0;
 HEAP32[i28 + 24 >> 2] = 0;
 HEAP32[i28 + 28 >> 2] = 0;
 i30 = i31 + 700 | 0;
 i26 = i31 + 712 | 0;
 i7 = i2 + 149 | 0;
 i8 = i31 + 52 | 0;
 i9 = i31 + 28 | 0;
 i10 = i31 + 32 | 0;
 i11 = i35 + 4 | 0;
 i12 = i31 + 36 | 0;
 i13 = i35 + 8 | 0;
 i14 = i31 + 40 | 0;
 i15 = i35 + 12 | 0;
 i16 = i31 + 44 | 0;
 i17 = i35 + 16 | 0;
 i18 = i31 + 48 | 0;
 i19 = i35 + 20 | 0;
 i20 = i31 + 28 | 0;
 i21 = i31 + 32 | 0;
 i22 = i31 + 36 | 0;
 i23 = i31 + 40 | 0;
 i24 = i31 + 44 | 0;
 i25 = i31 + 48 | 0;
 i1 = 0;
 i3 = 0;
 i2 = 0;
 while (1) {
  i6 = 0;
  i4 = i1;
  while (1) {
   i1 = HEAP32[i31 + 28 + (i6 << 2) >> 2] | 0;
   if (!i1) {
    HEAP32[i35 + (i6 << 2) >> 2] = 0;
    i5 = i2;
   } else {
    HEAP32[i29 >> 2] = 0;
    HEAP32[i35 + (i6 << 2) >> 2] = __ZNK9ShaderLab7Program21GetMatchingSubProgramEPK6ShaderPKNS_4PassERK16ShaderKeywordSetjPS7_R19ShaderSnippetResult(i1, 0, 0, i27, 0, i28, i29) | 0;
    i5 = HEAP32[i29 >> 2] | 0;
    i4 = i4 | (i5 | 0) == 1;
    if ((i5 | 0) == 2) {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i9 >> 2] | 0, i28);
     }
     HEAP32[i35 >> 2] = 0;
     i1 = HEAP32[i10 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i10 >> 2] | 0, i28);
     }
     HEAP32[i11 >> 2] = 0;
     i1 = HEAP32[i12 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i12 >> 2] | 0, i28);
     }
     HEAP32[i13 >> 2] = 0;
     i1 = HEAP32[i14 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i14 >> 2] | 0, i28);
     }
     HEAP32[i15 >> 2] = 0;
     i1 = HEAP32[i16 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i16 >> 2] | 0, i28);
     }
     HEAP32[i17 >> 2] = 0;
     i1 = HEAP32[i18 >> 2] | 0;
     if (i1 | 0) {
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i1, i27);
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(HEAP32[i18 >> 2] | 0, i28);
     }
     HEAP32[i19 >> 2] = 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) < 10) {
      i32 = 11;
      break;
     } else {
      i3 = 1;
      i1 = 1;
     }
    } else i1 = i4;
    i5 = i2;
    i4 = i1;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) >= 6) break; else i2 = i5;
  }
  if ((i32 | 0) == 11) {
   i32 = 0;
   i1 = i4;
   i3 = 1;
   continue;
  }
  if (!i3) {
   i32 = 21;
   break;
  }
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 184 >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i1 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i2 << 5) | 0) | 0;
   }
  }
  i2 = HEAP32[i21 >> 2] | 0;
  if (i2 | 0) {
   i1 = HEAP32[i2 + 184 >> 2] | 0;
   if (i1 | 0) {
    i6 = HEAP32[i2 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i1 << 5) | 0) | 0;
   }
  }
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 184 >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i1 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i2 << 5) | 0) | 0;
   }
  }
  i1 = HEAP32[i23 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 184 >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i1 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i2 << 5) | 0) | 0;
   }
  }
  i1 = HEAP32[i24 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 184 >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i1 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i2 << 5) | 0) | 0;
   }
  }
  i1 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 184 >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i1 + 172 >> 2] | 0;
    __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i30, (HEAP32[i30 >> 2] | 0) + (HEAP32[i26 >> 2] << 5) | 0, i6, i6 + (i2 << 5) | 0) | 0;
   }
  }
  if (!(__ZNK9ShaderLab11ShaderState34ShouldRemoveAnyUnsupportedProgramsEv(i31) | 0)) {
   i32 = 19;
   break;
  }
  if (HEAP8[i7 >> 0] | 0) {
   i32 = 18;
   break;
  }
  __ZN9ShaderLab11ShaderState25RemoveUnsupportedProgramsEPK6Shader(i31, 0);
  if ((i5 | 0) < 10) {
   i1 = i4 | (HEAP8[i8 >> 0] | 0) != 0;
   i3 = 1;
   i2 = i5;
  } else {
   i2 = 1;
   break;
  }
 }
 if ((i32 | 0) == 18) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 481509 | 0, 0, gb + 481619 | 0, 497, 512, 0, 0, 0);
  i32 = 19;
 } else if ((i32 | 0) == 21) if (i4) i2 = 0; else {
  i2 = 0;
  i32 = 22;
 }
 if ((i32 | 0) == 19) if (i4 | (HEAP8[i8 >> 0] | 0) != 0) i2 = 1; else {
  i2 = 1;
  i32 = 22;
 }
 if ((i32 | 0) == 22) {
  if (HEAP32[i35 + 4 >> 2] | 0) {
   STACKTOP = i33;
   return;
  }
  i1 = HEAP32[i35 + 8 >> 2] | 0;
  if (!i1) {
   STACKTOP = i33;
   return;
  }
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   STACKTOP = i33;
   return;
  }
  if ((HEAP32[i1 + 4 >> 2] | 0) != 6) {
   STACKTOP = i33;
   return;
  }
 }
 i3 = HEAP32[(__ZN6Shader10GetDefaultEv() | 0) + 32 >> 2] | 0;
 i3 = HEAP32[HEAP32[HEAP32[(HEAP32[i3 >> 2] | 0) + (HEAP32[i3 + 48 >> 2] << 2) >> 2] >> 2] >> 2] | 0;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 >> 2] = i1;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 + 4 >> 2] = i1;
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 + 8 >> 2] = i1;
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 + 12 >> 2] = i1;
 i1 = HEAP32[i3 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 + 16 >> 2] = i1;
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 20 >> 2] | 0) > 0) {
  i1 = HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9ShaderLab10SubProgram7CompileEv(i1);
 } else i1 = 0;
 HEAP32[i35 + 20 >> 2] = i1;
 if (i2) {
  __ZN6Shader27MarkShaderStateNotSupportedEPKS_(i34);
  STACKTOP = i33;
  return;
 } else {
  __ZN6Shader19MarkShaderHasErrorsEPKS_(i34);
  STACKTOP = i33;
  return;
 }
}

function __ZN5physx2Sc9ClothCore17resolveReferencesERNS0_15ClothFabricCoreE(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 64 | 0;
 i7 = i11 + 56 | 0;
 i4 = i11 + 8 | 0;
 i5 = i11;
 i16 = i11 + 48 | 0;
 i15 = i11 + 40 | 0;
 i14 = i11 + 32 | 0;
 i13 = i11 + 24 | 0;
 i12 = i11 + 16 | 0;
 HEAP32[i10 + 32 >> 2] = i2;
 i9 = i10 + 36 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 __ZN5physx2Sc9ClothCore12initLowLevelERKNS_11PxTransformEPKNS_15PxClothParticleE(i10, i8 + 284 | 0, HEAP32[i8 >> 2] | 0);
 i8 = i10 + 28 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i18 = HEAP32[i17 + 36 >> 2] | 0;
 i17 = i18 + (HEAP32[i17 + 40 >> 2] << 4) | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 mftCall_viiii(i3 | 0, i2 | 0, i6 | 0, 0, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i17 = HEAP32[i16 + 48 >> 2] | 0;
 i16 = i17 + ((HEAP32[i16 + 52 >> 2] | 0) >>> 1 << 2) | 0;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 mftCall_viiii(i3 | 0, i2 | 0, i6 | 0, 0, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 i16 = HEAP32[i15 + 60 >> 2] | 0;
 i15 = i16 + (HEAP32[i15 + 64 >> 2] << 4) | 0;
 HEAP32[i14 >> 2] = i16;
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 mftCall_viiii(i3 | 0, i2 | 0, i6 | 0, 0, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 i15 = HEAP32[i14 + 72 >> 2] | 0;
 i14 = i15 + (HEAP32[i14 + 76 >> 2] << 2) | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiii(i3 | 0, i2 | 0, i6 | 0, 0, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 i14 = HEAP32[i13 + 84 >> 2] | 0;
 i13 = i14 + ((HEAP32[i13 + 88 >> 2] | 0) * 36 | 0) | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 mftCall_viiii(i3 | 0, i2 | 0, i6 | 0, 0, 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 if (i3) {
  i15 = HEAP32[i2 + 12 >> 2] | 0;
  i16 = HEAP32[i2 + 24 >> 2] | 0;
  i17 = i16 + ((HEAP32[i2 + 28 >> 2] | 0) * 12 | 0) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i18 = HEAP32[(HEAP32[i2 >> 2] | 0) + 232 >> 2] | 0;
  HEAP32[i4 >> 2] = i15;
  HEAP32[i4 + 4 >> 2] = i15 + (i3 >>> 2 << 4);
  HEAP32[i5 >> 2] = i16;
  HEAP32[i5 + 4 >> 2] = i17;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  mftCall_viii(i18 | 0, i2 | 0, i7 | 0, i6 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (HEAP32[i2 + 100 >> 2] | 0) {
  i2 = HEAP32[i2 + 96 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (!i2) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 264 >> 2] | 0, i3 | 0); else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i6 | 0, i3 | 0);
   i18 = HEAP32[i6 >> 2] | 0;
   _memcpy(i18 | 0, i2 | 0, (HEAP32[i6 + 4 >> 2] | 0) - i18 | 0) | 0;
  }
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (HEAP32[i2 + 112 >> 2] | 0) {
  i2 = HEAP32[i2 + 108 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (!i2) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 296 >> 2] | 0, i3 | 0); else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 292 >> 2] | 0, i6 | 0, i3 | 0);
   i18 = HEAP32[i6 >> 2] | 0;
   _memcpy(i18 | 0, i2 | 0, (HEAP32[i6 + 4 >> 2] | 0) - i18 | 0) | 0;
  }
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (HEAP32[i2 + 124 >> 2] | 0) {
  i2 = HEAP32[i2 + 120 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (!i2) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 312 >> 2] | 0, i3 | 0); else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 308 >> 2] | 0, i6 | 0, i3 | 0);
   i18 = HEAP32[i6 >> 2] | 0;
   _memcpy(i18 | 0, i2 | 0, (HEAP32[i6 + 4 >> 2] | 0) - i18 | 0) | 0;
  }
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i3 = HEAP32[i2 + 136 >> 2] | 0;
 if (i3) {
  i17 = HEAP32[i2 + 132 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i18 = HEAP32[(HEAP32[i2 >> 2] | 0) + 336 >> 2] | 0;
  HEAP32[i7 >> 2] = i17;
  HEAP32[i7 + 4 >> 2] = i17 + (i3 << 2);
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  mftCall_vii(i18 | 0, i2 | 0, i6 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (HEAP32[i2 + 148 >> 2] | 0) {
  i2 = HEAP32[i2 + 144 >> 2] | 0;
  if (!i2) i3 = 0; else {
   i3 = HEAP32[i8 >> 2] | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  }
  i18 = HEAP32[i8 >> 2] | 0;
  i17 = HEAP32[(HEAP32[i18 >> 2] | 0) + 344 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i2 + (i3 << 4);
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  mftCall_vii(i17 | 0, i18 | 0, i6 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i16 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i16 >> 2] | 0) + 244 >> 2] | 0, i16 | 0, +Math_fround(HEAPF32[i2 + 156 >> 2]));
 i16 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i16 >> 2] | 0) + 252 >> 2] | 0, i16 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 160 >> 2]));
 i16 = HEAP32[i8 >> 2] | 0;
 i18 = HEAP32[i9 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i18 + 164 >> 2]);
 mftCall_viff(HEAP32[(HEAP32[i16 >> 2] | 0) + 272 >> 2] | 0, i16 | 0, +f1, +Math_fround(HEAPF32[i18 + 168 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 284 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 172 >> 2]));
 i18 = HEAP32[i9 >> 2] | 0;
 i16 = HEAP32[i18 + 180 >> 2] | 0;
 i17 = HEAP32[i18 + 184 >> 2] | 0;
 HEAP32[i10 + 16 >> 2] = HEAP32[i18 + 176 >> 2];
 HEAP32[i10 + 20 >> 2] = i16;
 HEAP32[i10 + 24 >> 2] = i17;
 i17 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 88 >> 2] | 0, i17 | 0, i18 + 188 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 224 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 200 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 220 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 204 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 96 >> 2] | 0, i18 | 0, (HEAP32[i9 >> 2] | 0) + 208 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 104 >> 2] | 0, i18 | 0, (HEAP32[i9 >> 2] | 0) + 220 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 112 >> 2] | 0, i18 | 0, (HEAP32[i9 >> 2] | 0) + 232 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 120 >> 2] | 0, i18 | 0, (HEAP32[i9 >> 2] | 0) + 244 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 128 >> 2] | 0, i18 | 0, (HEAP32[i9 >> 2] | 0) + 256 | 0);
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 136 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 268 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 144 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 272 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 320 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 276 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 328 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 280 >> 2]));
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i18 >> 2] | 0) + 360 >> 2] | 0, i18 | 0, +Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 312 >> 2]));
 f1 = Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 316 >> 2]);
 if (f1 > Math_fround(4294967.0)) {
  i18 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 368 >> 2] | 0, i18 | 0, -1);
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i16 = ~~Math_fround(f1 * Math_fround(1.0e3)) >>> 0;
 i17 = (i16 >>> 0) / 5 | 0;
 i17 = i17 >>> 0 < 200 ? i17 : 200;
 i17 = i17 >>> 0 > 1 ? i17 : 1;
 i18 = HEAP32[i8 >> 2] | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 388 >> 2] | 0, i18 | 0) | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 368 >> 2] | 0, i15 | 0, i17 | 0);
 i15 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 376 >> 2] | 0, i15 | 0, (i16 >>> 0) / (i17 >>> 0) | 0 | 0);
 if (!(f1 == Math_fround(0.0) & i18)) {
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i18 = HEAP32[i8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 392 >> 2] | 0, i18 | 0);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN7mecanim9animation25InitClipMuscleDeltaValuesERNS0_18ClipMuscleConstantEb(i26, i27) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 1808 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i33 + 8 | 0;
 i11 = i33;
 i30 = i33 + 1784 | 0;
 i29 = i33 + 896 | 0;
 i2 = gb + 64016 | 0;
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i31 = i11;
 HEAP32[i31 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i31 + 4 >> 2] = i10;
 HEAP32[i30 >> 2] = gb + 175924 + 8;
 i31 = i30 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i11);
 i10 = i28;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i31;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 i5 = i26 + 1060 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i10 = i5;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i10 | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] | 0) | 0;
 i31 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4, 4, i31, 0, gb + 913345 | 0, 415) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i30 >> 2] >> 2] | 0, i30 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i31 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i10 | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] | 0) | 0;
 i25 = mftCall_iiii(HEAP32[HEAP32[i30 >> 2] >> 2] | 0, i30 | 0, 4, 4) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i30 >> 2] >> 2] | 0, i30 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i25 >> 2] = i1;
 i22 = HEAP32[i5 >> 2] | 0;
 i22 = (i22 | 0) == 0 ? 0 : i22 + i10 | 0;
 i4 = i22 + 8 | 0;
 i23 = i22 + 16 | 0;
 i22 = (HEAP32[i23 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) + (HEAP32[i22 + 36 >> 2] | 0) | 0;
 i24 = mftCall_iiii(HEAP32[HEAP32[i30 >> 2] >> 2] | 0, i30 | 0, 20, 4) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i24 + 16 >> 2] = i22 - i2 - (HEAP32[i23 >> 2] | 0);
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = 0;
 HEAP32[i28 + 16 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i30 >> 2] >> 2] | 0, i30 | 0, i2 * 20 | 0, 4) | 0;
  i3 = i1 + (i2 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i28 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i24 >> 2] = i1;
 HEAP32[i24 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i24 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP32[i11 >> 2] = HEAP32[i26 + 1064 >> 2];
 i3 = HEAP32[i5 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i3 | 0) == 0 ? 0 : i3 + i10 | 0, i11, i24, i31);
 HEAP32[i11 >> 2] = HEAP32[i26 + 1068 >> 2];
 i3 = HEAP32[i5 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i3 | 0) == 0 ? 0 : i3 + i10 | 0, i11, i24, i25);
 i3 = HEAP32[i26 + 1708 >> 2] | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if (i3 | 0) {
  i4 = i26 + 1712 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i5 = HEAP32[i25 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i4 + (i2 << 3) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
   HEAP32[i4 + (i2 << 3) + 4 >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i10 = HEAP32[i26 + 1116 >> 2] | 0;
 i11 = (i10 | 0) == -1;
 if (i11) i2 = 0; else i2 = HEAP32[i1 + (i10 << 2) >> 2] | 0;
 i12 = HEAP32[i26 + 1120 >> 2] | 0;
 i13 = (i12 | 0) == -1;
 if (i13) i3 = 0; else i3 = HEAP32[i1 + (i12 << 2) >> 2] | 0;
 i14 = HEAP32[i26 + 1124 >> 2] | 0;
 i15 = (i14 | 0) == -1;
 if (i15) i4 = 0; else i4 = HEAP32[i1 + (i14 << 2) >> 2] | 0;
 i16 = HEAP32[i26 + 1128 >> 2] | 0;
 i17 = (i16 | 0) == -1;
 if (i17) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i1 + (i16 << 2) >> 2]);
 i18 = HEAP32[i26 + 1132 >> 2] | 0;
 i19 = (i18 | 0) == -1;
 if (i19) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i1 + (i18 << 2) >> 2]);
 i20 = HEAP32[i26 + 1136 >> 2] | 0;
 i21 = (i20 | 0) == -1;
 if (i21) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i1 + (i20 << 2) >> 2]);
 i22 = HEAP32[i26 + 1140 >> 2] | 0;
 i23 = (i22 | 0) == -1;
 if (i23) f9 = Math_fround(1.0); else f9 = Math_fround(HEAPF32[i1 + (i22 << 2) >> 2]);
 f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9))))));
 f6 = Math_fround(f6 * f34);
 f7 = Math_fround(f7 * f34);
 f8 = Math_fround(f8 * f34);
 f9 = Math_fround(f9 * f34);
 HEAP32[i26 + 888 >> 2] = i2;
 HEAP32[i26 + 892 >> 2] = i3;
 HEAP32[i26 + 896 >> 2] = i4;
 HEAPF32[i26 + 900 >> 2] = f6;
 HEAPF32[i26 + 904 >> 2] = f7;
 HEAPF32[i26 + 908 >> 2] = f8;
 HEAPF32[i26 + 912 >> 2] = f9;
 HEAP32[i26 + 916 >> 2] = 1065353216;
 HEAP32[i26 + 920 >> 2] = 1065353216;
 HEAP32[i26 + 924 >> 2] = 1065353216;
 i5 = HEAP32[i25 >> 2] | 0;
 if (i11) i4 = 0; else i4 = HEAP32[i5 + (i10 << 2) >> 2] | 0;
 if (i13) i3 = 0; else i3 = HEAP32[i5 + (i12 << 2) >> 2] | 0;
 if (i15) i2 = 0; else i2 = HEAP32[i5 + (i14 << 2) >> 2] | 0;
 if (i17) f9 = Math_fround(0.0); else f9 = Math_fround(HEAPF32[i5 + (i16 << 2) >> 2]);
 if (i19) f8 = Math_fround(0.0); else f8 = Math_fround(HEAPF32[i5 + (i18 << 2) >> 2]);
 if (i21) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i5 + (i20 << 2) >> 2]);
 if (i23) f6 = Math_fround(1.0); else f6 = Math_fround(HEAPF32[i5 + (i22 << 2) >> 2]);
 f34 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6))))));
 f35 = Math_fround(f9 * f34);
 f8 = Math_fround(f8 * f34);
 f9 = Math_fround(f7 * f34);
 f34 = Math_fround(f6 * f34);
 HEAP32[i26 + 928 >> 2] = i4;
 HEAP32[i26 + 932 >> 2] = i3;
 HEAP32[i26 + 936 >> 2] = i2;
 HEAPF32[i26 + 940 >> 2] = f35;
 HEAPF32[i26 + 944 >> 2] = f8;
 HEAPF32[i26 + 948 >> 2] = f9;
 HEAPF32[i26 + 952 >> 2] = f34;
 HEAP32[i26 + 956 >> 2] = 1065353216;
 HEAP32[i26 + 960 >> 2] = 1065353216;
 HEAP32[i26 + 964 >> 2] = 1065353216;
 if (i27) {
  __ZN7mecanim5human9HumanPoseC2Ev(i28);
  __ZN7mecanim5human9HumanPoseC2Ev(i29);
  __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i26, HEAP32[i31 >> 2] | 0, i28);
  __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i26, HEAP32[i25 >> 2] | 0, i29);
  __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_(i26, i28, i29);
  i1 = HEAP32[i28 + 72 >> 2] | 0;
  i32 = HEAP32[i28 + 76 >> 2] | 0;
  HEAP32[i26 + 968 >> 2] = HEAP32[i28 + 68 >> 2];
  HEAP32[i26 + 972 >> 2] = i1;
  HEAP32[i26 + 976 >> 2] = i32;
  i32 = HEAP32[i28 + 84 >> 2] | 0;
  i1 = HEAP32[i28 + 88 >> 2] | 0;
  i29 = HEAP32[i28 + 92 >> 2] | 0;
  HEAP32[i26 + 980 >> 2] = HEAP32[i28 + 80 >> 2];
  HEAP32[i26 + 984 >> 2] = i32;
  HEAP32[i26 + 988 >> 2] = i1;
  HEAP32[i26 + 992 >> 2] = i29;
  i29 = HEAP32[i28 + 100 >> 2] | 0;
  i1 = HEAP32[i28 + 104 >> 2] | 0;
  HEAP32[i26 + 996 >> 2] = HEAP32[i28 + 96 >> 2];
  HEAP32[i26 + 1e3 >> 2] = i29;
  HEAP32[i26 + 1004 >> 2] = i1;
  i1 = HEAP32[i28 + 136 >> 2] | 0;
  i29 = HEAP32[i28 + 140 >> 2] | 0;
  HEAP32[i26 + 1008 >> 2] = HEAP32[i28 + 132 >> 2];
  HEAP32[i26 + 1012 >> 2] = i1;
  HEAP32[i26 + 1016 >> 2] = i29;
  i29 = HEAP32[i28 + 148 >> 2] | 0;
  i1 = HEAP32[i28 + 152 >> 2] | 0;
  i32 = HEAP32[i28 + 156 >> 2] | 0;
  HEAP32[i26 + 1020 >> 2] = HEAP32[i28 + 144 >> 2];
  HEAP32[i26 + 1024 >> 2] = i29;
  HEAP32[i26 + 1028 >> 2] = i1;
  HEAP32[i26 + 1032 >> 2] = i32;
  i32 = HEAP32[i28 + 164 >> 2] | 0;
  i1 = HEAP32[i28 + 168 >> 2] | 0;
  HEAP32[i26 + 1036 >> 2] = HEAP32[i28 + 160 >> 2];
  HEAP32[i26 + 1040 >> 2] = i32;
  HEAP32[i26 + 1044 >> 2] = i1;
  i1 = HEAP32[i31 >> 2] | 0;
  i32 = 44;
 } else if (i31 | 0) i32 = 44;
 if ((i32 | 0) == 44) {
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, i31 | 0);
 }
 if (i25 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, HEAP32[i25 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, i25 | 0);
 }
 if (!i24) {
  STACKTOP = i33;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, HEAP32[i24 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0, i30 | 0, i24 | 0);
 STACKTOP = i33;
 return;
}

function __ZN5physx27PxClothFabricRepXSerializer16objectToFileImplEPKNS_13PxClothFabricEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i3, i21, i2, i27, i26, i1) {
 i3 = i3 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25 + 280 | 0;
 i23 = i25 + 152 | 0;
 i11 = i25 + 144 | 0;
 i8 = i25 + 136 | 0;
 i6 = i25 + 128 | 0;
 i14 = i25;
 i2 = i25 + 304 | 0;
 i22 = i25 + 288 | 0;
 i12 = i25 + 432 | 0;
 i20 = HEAP32[i26 + 8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 24 >> 2] | 0, i21 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 28 >> 2] | 0, i21 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0) | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 36 >> 2] | 0, i21 | 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 40 >> 2] | 0, i21 | 0) | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 44 >> 2] | 0, i21 | 0) | 0;
 HEAP32[i22 >> 2] = i20;
 i20 = i22 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i19 = i22 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i13 = i10 >>> 0 < i5 >>> 0 ? i5 : i10;
 i13 = (i13 >>> 0 < i18 >>> 0 ? i18 : i13) << 2;
 i17 = i18 << 2;
 i13 = i13 >>> 0 < i17 >>> 0 ? i17 : i13;
 i17 = i3 << 3;
 HEAP8[i12 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i22, i13 >>> 0 < i17 >>> 0 ? i17 : i13, i12);
 i20 = HEAP32[i20 >> 2] | 0;
 i12 = i2;
 i13 = i12 + 128 | 0;
 do {
  HEAP8[i12 >> 0] = 0;
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) < (i13 | 0));
 HEAP32[i14 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i2, 128, gb + 1084495 | 0, i14) | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i17 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
  mftCall_iiii(i17 | 0, i26 | 0, i2 | 0, _strlen(i2) | 0) | 0;
 }
 HEAP8[i14 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i14 | 0, 1) | 0;
 i15 = i26 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674663 | 0, HEAP32[i15 >> 2] | 0);
 i16 = i26 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i26 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 48 >> 2] | 0, i21 | 0, i20 | 0, i3 | 0) | 0;
 i9 = (i20 | 0) != 0;
 if ((i3 | 0) != 0 & i9) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
   __ZN5physx16writeFabricPhaseERNS_14PxOutputStreamERKNS_18PxClothFabricPhaseE(i26, i20 + (i2 << 3) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP8[i14 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i14 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674675 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 60 >> 2] | 0, i21 | 0, i20 | 0, i5 | 0) | 0;
 if ((i5 | 0) != 0 & i9) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
   d4 = +Math_fround(HEAPF32[i20 + (i2 << 2) >> 2]);
   i12 = i14;
   i13 = i12 + 128 | 0;
   do {
    HEAP8[i12 >> 0] = 0;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i13 | 0));
   HEAPF64[i6 >> 3] = d4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i14, 128, gb + 832323 | 0, i6) | 0;
   if (HEAP8[i14 >> 0] | 0) {
    i13 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    mftCall_iiii(i13 | 0, i26 | 0, i14 | 0, _strlen(i14) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  HEAP8[i6 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i6 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 773316 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 52 >> 2] | 0, i21 | 0, i20 | 0, i7 | 0) | 0;
 if ((i7 | 0) != 0 & i9) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
   i12 = i14;
   i13 = i12 + 128 | 0;
   do {
    HEAP8[i12 >> 0] = 0;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i13 | 0));
   HEAP32[i8 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i14, 128, gb + 1084495 | 0, i8) | 0;
   if (HEAP8[i14 >> 0] | 0) {
    i13 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    mftCall_iiii(i13 | 0, i26 | 0, i14 | 0, _strlen(i14) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
  HEAP8[i8 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i8 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674682 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 56 >> 2] | 0, i21 | 0, i20 | 0, i10 | 0) | 0;
 if ((i10 | 0) != 0 & i9) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
   i12 = i14;
   i13 = i12 + 128 | 0;
   do {
    HEAP8[i12 >> 0] = 0;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i13 | 0));
   HEAP32[i11 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i14, 128, gb + 1084495 | 0, i11) | 0;
   if (HEAP8[i14 >> 0] | 0) {
    i13 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    mftCall_iiii(i13 | 0, i26 | 0, i14 | 0, _strlen(i14) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674687 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 }
 mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 64 >> 2] | 0, i21 | 0, i20 | 0, i18 | 0) | 0;
 i3 = (i18 | 0) != 0 & i9;
 if (i3) {
  i2 = 0;
  do {
   i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
   i12 = i14;
   i13 = i12 + 128 | 0;
   do {
    HEAP8[i12 >> 0] = 0;
    i12 = i12 + 1 | 0;
   } while ((i12 | 0) < (i13 | 0));
   HEAP32[i23 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i14, 128, gb + 1084495 | 0, i23) | 0;
   if (HEAP8[i14 >> 0] | 0) {
    i13 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    mftCall_iiii(i13 | 0, i26 | 0, i14 | 0, _strlen(i14) | 0) | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
  HEAP8[i23 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i23 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674703 | 0, HEAP32[i15 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
  mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 68 >> 2] | 0, i21 | 0, i20 | 0, i18 | 0) | 0;
  if (i3) {
   i2 = 0;
   do {
    i1 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
    if ((i2 | 0) != 0 & ((i2 >>> 0) % 18 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i26 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i26 | 0, gb + 1086395 | 0, 1) | 0;
    d4 = +Math_fround(HEAPF32[i20 + (i2 << 2) >> 2]);
    i12 = i23;
    i13 = i12 + 128 | 0;
    do {
     HEAP8[i12 >> 0] = 0;
     i12 = i12 + 1 | 0;
    } while ((i12 | 0) < (i13 | 0));
    HEAPF64[i24 >> 3] = d4;
    __ZN5physx6string9sprintf_sEPcjPKcz(i23, 128, gb + 832323 | 0, i24) | 0;
    if (HEAP8[i23 >> 0] | 0) {
     i21 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
     mftCall_iiii(i21 | 0, i26 | 0, i23 | 0, _strlen(i23) | 0) | 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i18 | 0));
   HEAP8[i24 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i24 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, gb + 674717 | 0, HEAP32[i15 >> 2] | 0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  }
 } else mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 68 >> 2] | 0, i21 | 0, i20 | 0, i18 | 0) | 0;
 i27 = HEAP32[i19 >> 2] | 0;
 if ((i20 | 0) == 0 | ((i27 | 0) < 0 | (i27 & 2147483647 | 0) == 0)) {
  STACKTOP = i25;
  return;
 }
 i27 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, i20 | 0);
 STACKTOP = i25;
 return;
}

function __ZN13SpeedTreeWind8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 __ZN13SpeedTreeWind7SParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i3 = i6 + 1332 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1336 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1340 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1344 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1348 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1349 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1350 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1351 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1352 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1353 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1354 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1355 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1356 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1357 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1358 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1359 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1360 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1361 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1362 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1363 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1364 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1365 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1366 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1367 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1368 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1369 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1370 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1371 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1372 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1373 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1374 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 1375 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  return;
 }
}

function __ZL31GeomOverlapCallback_PlaneConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i3, i5, i4, i6, i2) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var f1 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 80 | 0;
 i12 = i18 + 76 | 0;
 i13 = i18 + 64 | 0;
 i10 = i18 + 60 | 0;
 i9 = i18 + 56 | 0;
 i7 = i18 + 44 | 0;
 i3 = i18 + 16 | 0;
 i17 = i18;
 i8 = HEAP32[i4 + 32 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f14 = Math_fround(f14 * Math_fround(-2.0));
 f33 = Math_fround(f33 * Math_fround(-2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(-2.0));
 f31 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f34 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
 f21 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(f14 * f21);
 f30 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f33 * f30));
 f15 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f19 * f15));
 f32 = Math_fround(Math_fround(f21 * f20) + Math_fround(Math_fround(f14 * f34) - Math_fround(f31 * Math_fround(Math_fround(f19 * f30) - Math_fround(f33 * f15)))));
 f1 = Math_fround(Math_fround(f30 * f20) + Math_fround(Math_fround(f33 * f34) - Math_fround(f31 * Math_fround(Math_fround(f14 * f15) - Math_fround(f19 * f21)))));
 f20 = Math_fround(Math_fround(Math_fround(f19 * f34) - Math_fround(f31 * Math_fround(Math_fround(f33 * f21) - Math_fround(f14 * f30)))) + Math_fround(f15 * f20));
 f21 = Math_fround(-f21);
 f30 = Math_fround(-f30);
 f15 = Math_fround(-f15);
 f14 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f33 * f30)) + Math_fround(f19 * f15));
 f32 = Math_fround(f32 + Math_fround(Math_fround(f16 * f21) + Math_fround(Math_fround(f34 * f14) + Math_fround(f31 * Math_fround(Math_fround(f19 * f30) - Math_fround(f33 * f15))))));
 f1 = Math_fround(f1 + Math_fround(Math_fround(f16 * f30) + Math_fround(Math_fround(f34 * f33) + Math_fround(f31 * Math_fround(Math_fround(f14 * f15) - Math_fround(f19 * f21))))));
 f16 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f34 * f19) + Math_fround(f31 * Math_fround(Math_fround(f33 * f21) - Math_fround(f14 * f30)))) + Math_fround(f16 * f15)));
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f33 = Math_fround(f31 * f14);
 f19 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f19 * f21));
 f34 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f34 * f30));
 f20 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f28 = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(Math_fround(f19 * f30) + Math_fround(f31 * f20))) - Math_fround(f34 * f21));
 f27 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(Math_fround(f19 * f15) + Math_fround(f31 * f34))) - Math_fround(f14 * f30));
 f34 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f19) - Math_fround(f14 * f21)) - Math_fround(f20 * f30)) - Math_fround(f34 * f15));
 HEAPF32[i3 >> 2] = Math_fround(f33 - Math_fround(f20 * f15));
 HEAPF32[i3 + 4 >> 2] = f28;
 HEAPF32[i3 + 8 >> 2] = f27;
 HEAPF32[i3 + 12 >> 2] = f34;
 HEAPF32[i3 + 16 >> 2] = f32;
 HEAPF32[i3 + 20 >> 2] = f1;
 HEAPF32[i3 + 24 >> 2] = f16;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i17, i3);
 f16 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f1 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f32 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f34 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f27 = Math_fround(f16 + f16);
 f28 = Math_fround(f1 + f1);
 f15 = Math_fround(f32 + f32);
 f20 = Math_fround(f1 * f28);
 f33 = Math_fround(f32 * f15);
 f1 = Math_fround(f27 * f1);
 f30 = Math_fround(f27 * f32);
 f21 = Math_fround(f27 * f34);
 f32 = Math_fround(f28 * f32);
 f28 = Math_fround(f28 * f34);
 f34 = Math_fround(f15 * f34);
 f15 = Math_fround(Math_fround(Math_fround(1.0) - f20) - f33);
 f14 = Math_fround(f1 + f34);
 f19 = Math_fround(f30 - f28);
 f34 = Math_fround(f1 - f34);
 f27 = Math_fround(Math_fround(1.0) - Math_fround(f16 * f27));
 f33 = Math_fround(f27 - f33);
 f16 = Math_fround(f32 + f21);
 f28 = Math_fround(f30 + f28);
 f21 = Math_fround(f32 - f21);
 f20 = Math_fround(f27 - f20);
 f27 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f32 = Math_fround(f27 * f15);
 f30 = Math_fround(f27 * f34);
 f27 = Math_fround(f27 * f28);
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f31 = Math_fround(f14 * f1);
 f29 = Math_fround(f33 * f1);
 f1 = Math_fround(f21 * f1);
 f22 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f26 = Math_fround(f19 * f22);
 f24 = Math_fround(f16 * f22);
 f22 = Math_fround(f20 * f22);
 f25 = Math_fround(Math_fround(Math_fround(f15 * f32) + Math_fround(f14 * f31)) + Math_fround(f19 * f26));
 f23 = Math_fround(Math_fround(Math_fround(f15 * f30) + Math_fround(f14 * f29)) + Math_fround(f19 * f24));
 f19 = Math_fround(Math_fround(Math_fround(f15 * f27) + Math_fround(f14 * f1)) + Math_fround(f19 * f22));
 f14 = Math_fround(Math_fround(Math_fround(f34 * f32) + Math_fround(f33 * f31)) + Math_fround(f16 * f26));
 f15 = Math_fround(Math_fround(Math_fround(f34 * f30) + Math_fround(f33 * f29)) + Math_fround(f16 * f24));
 f16 = Math_fround(Math_fround(Math_fround(f34 * f27) + Math_fround(f33 * f1)) + Math_fround(f16 * f22));
 f26 = Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(f21 * f31)) + Math_fround(f20 * f26));
 f24 = Math_fround(Math_fround(Math_fround(f28 * f30) + Math_fround(f21 * f29)) + Math_fround(f20 * f24));
 f22 = Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f21 * f1)) + Math_fround(f20 * f22));
 f20 = Math_fround(HEAPF32[i17 >> 2]);
 f1 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f14 = Math_fround(Math_fround(f26 * f21) + Math_fround(Math_fround(f20 * f25) + Math_fround(f1 * f14)));
 f15 = Math_fround(Math_fround(f24 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f1 * f15)));
 f16 = Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f20 * f19) + Math_fround(f1 * f16)));
 HEAPF32[i13 >> 2] = f14;
 i3 = i13 + 4 | 0;
 HEAPF32[i3 >> 2] = f15;
 i4 = i13 + 8 | 0;
 HEAPF32[i4 >> 2] = f16;
 i2 = (HEAP32[i8 + 56 >> 2] | 0) + ((HEAPU8[i8 + 55 >> 0] | 0) * 20 | 0) | 0;
 i5 = i8 + 60 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 | 0) {
  i8 = HEAPU16[i6 >> 1] | 0;
  i6 = __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_(i13, i11, i12) | 0;
  f32 = Math_fround(Math_fround((i8 + -1 | 0) >>> 0) * Math_fround(.5));
  f34 = Math_fround(f32 * Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(1.0)));
  i11 = (Math_imul((~~Math_fround(f34 + Math_fround(.5)) >>> 0) + (Math_imul(i6, i8) | 0) | 0, i8) | 0) + (~~Math_fround(Math_fround(f32 * Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(1.0))) + Math_fround(.5)) >>> 0) | 0;
  i12 = HEAP32[i5 >> 2] | 0;
  i8 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAPU8[i8 + i11 >> 0];
  HEAP32[i9 >> 2] = HEAPU8[i8 + ((HEAPU16[i12 + 2 >> 1] | 0) + i11) >> 0];
  f32 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
  f34 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  f33 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i7 >> 2] = f32;
  HEAPF32[i7 + 4 >> 2] = f34;
  HEAPF32[i7 + 8 >> 2] = f33;
  __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE(i10, i7, i2, i12);
  __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE(i9, i13, i2, HEAP32[i5 >> 2] | 0);
  i12 = HEAP32[i10 >> 2] | 0;
  f33 = Math_fround(HEAPF32[i2 + (i12 * 12 | 0) >> 2]);
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i13 >> 2]));
  f34 = Math_fround(HEAPF32[i2 + (i12 * 12 | 0) + 4 >> 2]);
  f34 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i3 >> 2])));
  f33 = Math_fround(HEAPF32[i2 + (i12 * 12 | 0) + 8 >> 2]);
  f33 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i4 >> 2])));
  i17 = i17 + 12 | 0;
  f34 = Math_fround(HEAPF32[i17 >> 2]);
  f34 = Math_fround(-f34);
  i17 = f33 <= f34;
  STACKTOP = i18;
  return i17 | 0;
 }
 i3 = HEAPU8[i8 + 54 >> 0] | 0;
 f1 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  i3 = i3 + -1 | 0;
  f34 = Math_fround(f14 * Math_fround(HEAPF32[i2 >> 2]));
  f34 = Math_fround(f34 + Math_fround(f15 * Math_fround(HEAPF32[i2 + 4 >> 2])));
  f34 = Math_fround(f34 + Math_fround(f16 * Math_fround(HEAPF32[i2 + 8 >> 2])));
  f1 = f1 < f34 ? f1 : f34;
  if (!i3) break; else i2 = i2 + 12 | 0;
 }
 i17 = i17 + 12 | 0;
 f34 = Math_fround(HEAPF32[i17 >> 2]);
 f34 = Math_fround(-f34);
 i17 = f1 <= f34;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN10GUITexture8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i3 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i2 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 944580 | 0, gb + 944590 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 385675 | 0, HEAP32[gb + 37212 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 20; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 20; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 20) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 76 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 31; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 31; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 31) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 80 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034504 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i3 = i9 + 16 | 0;
     i2 = HEAP32[i9 + 20 >> 2] | 0;
     i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i3 >> 2] = i1;
     if (i1 >>> 0 < i2 >>> 0) i8 = 42; else {
      i2 = i1 + 4 | 0;
      if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 42; else {
       HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
       HEAP32[i3 >> 2] = i2;
      }
     }
     if ((i8 | 0) == 42) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 84 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034510 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i5 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i8 = 53; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 53; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 53) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 36 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 385688 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 68; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 68; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 385701 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 79; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 79; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 79) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 385715 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 90; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 90; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 90) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 385727 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 101; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 101; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 101) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx2Gu15OBBTriangleTest10obbTriTestERKNS_6PxVec3ES4_S4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f30 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f37 = Math_fround(HEAPF32[i2 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f29 = Math_fround(HEAPF32[i4 >> 2]);
 f32 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f34 = Math_fround(Math_fround(Math_fround(f17 + Math_fround(f18 * f37)) + Math_fround(f19 * f36)) + Math_fround(f25 * f23));
 f35 = Math_fround(Math_fround(Math_fround(f20 + Math_fround(f30 * f37)) + Math_fround(f24 * f36)) + Math_fround(f26 * f23));
 f23 = Math_fround(Math_fround(Math_fround(f22 + Math_fround(f33 * f37)) + Math_fround(f21 * f36)) + Math_fround(f28 * f23));
 f36 = Math_fround(Math_fround(Math_fround(f17 + Math_fround(f18 * f15)) + Math_fround(f19 * f16)) + Math_fround(f25 * f31));
 f37 = Math_fround(Math_fround(Math_fround(f20 + Math_fround(f30 * f15)) + Math_fround(f24 * f16)) + Math_fround(f26 * f31));
 f31 = Math_fround(Math_fround(Math_fround(f22 + Math_fround(f33 * f15)) + Math_fround(f21 * f16)) + Math_fround(f28 * f31));
 f25 = Math_fround(Math_fround(Math_fround(f17 + Math_fround(f18 * f29)) + Math_fround(f19 * f32)) + Math_fround(f25 * f27));
 f26 = Math_fround(Math_fround(Math_fround(f20 + Math_fround(f30 * f29)) + Math_fround(f24 * f32)) + Math_fround(f26 * f27));
 f27 = Math_fround(Math_fround(Math_fround(f22 + Math_fround(f33 * f29)) + Math_fround(f21 * f32)) + Math_fround(f28 * f27));
 f28 = Math_fround(-f5);
 f32 = Math_fround(-f6);
 f21 = Math_fround(-f7);
 f29 = f36 < f25 ? f36 : f25;
 f33 = f37 < f26 ? f37 : f26;
 f22 = f31 < f27 ? f31 : f27;
 f24 = f36 > f25 ? f36 : f25;
 f30 = f37 > f26 ? f37 : f26;
 f20 = f31 > f27 ? f31 : f27;
 if (((f23 > f20 ? f23 : f20) < f21 ? 1 : (f23 < f22 ? f23 : f22) > f7) | (((f34 > f24 ? f34 : f24) < f28 ? 1 : (f34 < f29 ? f34 : f29) > f5) | ((f35 > f30 ? f35 : f30) < f32 ? 1 : (f35 < f33 ? f35 : f33) > f6))) {
  i4 = 0;
  return i4 | 0;
 }
 f28 = Math_fround(f36 - f34);
 f29 = Math_fround(f37 - f35);
 f13 = Math_fround(f31 - f23);
 f32 = Math_fround(f34 - f25);
 f33 = Math_fround(f35 - f26);
 f16 = Math_fround(f23 - f27);
 f20 = Math_fround(Math_fround(f13 * f33) - Math_fround(f29 * f16));
 f22 = Math_fround(Math_fround(f28 * f16) - Math_fround(f13 * f32));
 f18 = Math_fround(Math_fround(f29 * f32) - Math_fround(f28 * f33));
 f24 = Math_fround(Math_fround(f23 * f18) + Math_fround(Math_fround(f34 * f20) + Math_fround(f35 * f22)));
 f21 = Math_fround(-f20);
 f30 = Math_fround(-f22);
 f19 = Math_fround(-f18);
 f30 = Math_fround(Math_fround(f7 * (f18 > f19 ? f18 : f19)) + Math_fround(Math_fround(f5 * (f20 > f21 ? f20 : f21)) + Math_fround(f6 * (f22 > f30 ? f22 : f30))));
 if (f24 > f30 | f24 < Math_fround(-f30)) {
  i4 = 0;
  return i4 | 0;
 }
 f30 = Math_fround(f5 + f5);
 f24 = Math_fround(f6 + f6);
 f12 = Math_fround(f7 + f7);
 f14 = Math_fround(-f28);
 f15 = Math_fround(-f29);
 f8 = Math_fround(-f13);
 f5 = Math_fround(f34 * Math_fround(0.0));
 f20 = Math_fround(Math_fround(f23 * f29) + Math_fround(f5 + Math_fround(f35 * f8)));
 f22 = Math_fround(Math_fround(f29 * f27) + Math_fround(Math_fround(f25 * Math_fround(0.0)) + Math_fround(f26 * f8)));
 f6 = Math_fround(f30 * Math_fround(-0.0));
 f21 = Math_fround(f20 + f22);
 f22 = Math_fround(Math_fround(Math_fround(f12 * (f29 > f15 ? f29 : f15)) + Math_fround(f6 + Math_fround(f24 * (f13 < f8 ? f8 : f13)))) + Math_fround(Math_abs(Math_fround(f20 - f22))));
 if (f21 > f22 | f21 < Math_fround(-f22)) {
  i4 = 0;
  return i4 | 0;
 }
 f17 = Math_fround(f25 - f36);
 f18 = Math_fround(f26 - f37);
 f9 = Math_fround(f27 - f31);
 f19 = Math_fround(-f17);
 f20 = Math_fround(-f18);
 f10 = Math_fround(-f9);
 f11 = Math_fround(Math_fround(f23 * f18) + Math_fround(f5 + Math_fround(f35 * f10)));
 f7 = Math_fround(f36 * Math_fround(0.0));
 f22 = Math_fround(Math_fround(f31 * f18) + Math_fround(f7 + Math_fround(f37 * f10)));
 f21 = Math_fround(f11 + f22);
 f22 = Math_fround(Math_fround(Math_fround(f12 * (f18 > f20 ? f18 : f20)) + Math_fround(f6 + Math_fround(f24 * (f9 < f10 ? f10 : f9)))) + Math_fround(Math_abs(Math_fround(f11 - f22))));
 if (f21 > f22 | f21 < Math_fround(-f22)) {
  i4 = 0;
  return i4 | 0;
 }
 f21 = Math_fround(-f32);
 f22 = Math_fround(-f33);
 f11 = Math_fround(-f16);
 f38 = Math_fround(Math_fround(f23 * f33) + Math_fround(f5 + Math_fround(f35 * f11)));
 f7 = Math_fround(Math_fround(f31 * f33) + Math_fround(f7 + Math_fround(f37 * f11)));
 f5 = Math_fround(f38 + f7);
 f7 = Math_fround(Math_fround(Math_fround(f12 * (f33 > f22 ? f33 : f22)) + Math_fround(f6 + Math_fround(f24 * (f16 < f11 ? f11 : f16)))) + Math_fround(Math_abs(Math_fround(f38 - f7))));
 if (f5 > f7 | f5 < Math_fround(-f7)) {
  i4 = 0;
  return i4 | 0;
 }
 f6 = Math_fround(f35 * Math_fround(0.0));
 f39 = Math_fround(Math_fround(f23 * f14) + Math_fround(f6 + Math_fround(f34 * f13)));
 f38 = Math_fround(Math_fround(f27 * f14) + Math_fround(Math_fround(f13 * f25) + Math_fround(f26 * Math_fround(0.0))));
 f7 = Math_fround(f24 * Math_fround(-0.0));
 f5 = Math_fround(f39 + f38);
 f38 = Math_fround(Math_fround(Math_fround(f12 * (f28 < f14 ? f14 : f28)) + Math_fround(f7 + Math_fround(f30 * (f13 > f8 ? f13 : f8)))) + Math_fround(Math_abs(Math_fround(f39 - f38))));
 if (f5 > f38 | f5 < Math_fround(-f38)) {
  i4 = 0;
  return i4 | 0;
 }
 f13 = Math_fround(Math_fround(f23 * f19) + Math_fround(f6 + Math_fround(f34 * f9)));
 f5 = Math_fround(f37 * Math_fround(0.0));
 f39 = Math_fround(Math_fround(f31 * f19) + Math_fround(f5 + Math_fround(f36 * f9)));
 f38 = Math_fround(f13 + f39);
 f39 = Math_fround(Math_fround(Math_fround(f12 * (f17 < f19 ? f19 : f17)) + Math_fround(f7 + Math_fround(f30 * (f9 > f10 ? f9 : f10)))) + Math_fround(Math_abs(Math_fround(f13 - f39))));
 if (f38 > f39 | f38 < Math_fround(-f39)) {
  i4 = 0;
  return i4 | 0;
 }
 f13 = Math_fround(Math_fround(f23 * f21) + Math_fround(f6 + Math_fround(f34 * f16)));
 f39 = Math_fround(Math_fround(f31 * f21) + Math_fround(f5 + Math_fround(f36 * f16)));
 f38 = Math_fround(f13 + f39);
 f39 = Math_fround(Math_fround(Math_fround(f12 * (f32 < f21 ? f21 : f32)) + Math_fround(f7 + Math_fround(f30 * (f16 > f11 ? f16 : f11)))) + Math_fround(Math_abs(Math_fround(f13 - f39))));
 if (f38 > f39 | f38 < Math_fround(-f39)) {
  i4 = 0;
  return i4 | 0;
 }
 f7 = Math_fround(f23 * Math_fround(0.0));
 f23 = Math_fround(f7 + Math_fround(Math_fround(f34 * f15) + Math_fround(f35 * f28)));
 f39 = Math_fround(Math_fround(f27 * Math_fround(0.0)) + Math_fround(Math_fround(f25 * f15) + Math_fround(f28 * f26)));
 f6 = Math_fround(f12 * Math_fround(-0.0));
 f38 = Math_fround(f23 + f39);
 f39 = Math_fround(Math_fround(f6 + Math_fround(Math_fround(f30 * (f29 < f15 ? f15 : f29)) + Math_fround(f24 * (f28 > f14 ? f28 : f14)))) + Math_fround(Math_abs(Math_fround(f23 - f39))));
 if (f38 > f39 | f38 < Math_fround(-f39)) {
  i4 = 0;
  return i4 | 0;
 }
 f29 = Math_fround(f7 + Math_fround(Math_fround(f34 * f20) + Math_fround(f35 * f17)));
 f5 = Math_fround(f31 * Math_fround(0.0));
 f39 = Math_fround(f5 + Math_fround(Math_fround(f36 * f20) + Math_fround(f37 * f17)));
 f38 = Math_fround(f29 + f39);
 f39 = Math_fround(Math_fround(f6 + Math_fround(Math_fround(f30 * (f18 < f20 ? f20 : f18)) + Math_fround(f24 * (f17 > f19 ? f17 : f19)))) + Math_fround(Math_abs(Math_fround(f29 - f39))));
 if (f38 > f39 | f38 < Math_fround(-f39)) {
  i4 = 0;
  return i4 | 0;
 }
 f35 = Math_fround(f7 + Math_fround(Math_fround(f34 * f22) + Math_fround(f35 * f32)));
 f39 = Math_fround(f5 + Math_fround(Math_fround(f36 * f22) + Math_fround(f37 * f32)));
 f38 = Math_fround(f35 + f39);
 f39 = Math_fround(Math_fround(f6 + Math_fround(Math_fround(f30 * (f33 < f22 ? f22 : f33)) + Math_fround(f24 * (f32 > f21 ? f32 : f21)))) + Math_fround(Math_abs(Math_fround(f35 - f39))));
 i4 = !(f38 < Math_fround(-f39)) & !(f38 > f39) & 1;
 return i4 | 0;
}

function __ZN13SpeedTreeWind16SBranchWindLevel8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486433 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486448 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486463 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486478 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486493 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486508 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486523 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486538 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486553 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486568 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486583 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486608 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486633 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486658 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486683 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486708 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486733 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486758 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486783 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486808 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486833 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486844 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486855 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486866 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486877 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486888 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486899 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486910 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486921 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486932 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486943 | 0, i5, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486957 | 0, i5, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486967 | 0, i5, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx35PxcSweepEstimateAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f(i8, i9, i10, i11, i2, i5, f1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, f4 = f0, f6 = f0, f7 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i49 + 120 | 0;
 i48 = i49 + 104 | 0;
 i3 = i49 + 96 | 0;
 i45 = i49 + 84 | 0;
 i46 = i49 + 72 | 0;
 i2 = i49 + 48 | 0;
 i44 = i49 + 36 | 0;
 i47 = i49 + 140 | 0;
 i36 = i49 + 24 | 0;
 i37 = i49 + 12 | 0;
 i38 = i49;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i43 + 12 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i43 + 16 >> 2] = i12 + 36;
 HEAPF32[i43 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i12 + 44 >> 2]));
 HEAPF32[i43 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i12 + 48 >> 2]));
 HEAPF32[i43 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i12 + 52 >> 2]));
 __ZN5physx2Gu9ContainerC2Ev(i48);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i48, 64, i49 + 176 | 0, 1);
 HEAP32[i3 >> 2] = gb + 102868 + 8;
 HEAP32[i3 + 4 >> 2] = i48;
 i12 = i48 + 4 | 0;
 if (HEAP32[i12 >> 2] | 0) HEAP32[i12 >> 2] = 0;
 f13 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i8 + 28 >> 2]));
 f14 = Math_fround(HEAPF32[i8 + 60 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i8 + 32 >> 2]));
 f25 = Math_fround(HEAPF32[i8 + 64 >> 2]);
 f25 = Math_fround(f25 - Math_fround(HEAPF32[i8 + 36 >> 2]));
 HEAPF32[i45 >> 2] = f13;
 HEAPF32[i45 + 4 >> 2] = f14;
 HEAPF32[i45 + 8 >> 2] = f25;
 i39 = i9 + 12 | 0;
 f40 = Math_fround(HEAPF32[i9 + 56 >> 2]);
 f40 = Math_fround(f40 - Math_fround(HEAPF32[i9 + 28 >> 2]));
 f41 = Math_fround(HEAPF32[i9 + 60 >> 2]);
 f41 = Math_fround(f41 - Math_fround(HEAPF32[i9 + 32 >> 2]));
 f42 = Math_fround(HEAPF32[i9 + 64 >> 2]);
 f42 = Math_fround(f42 - Math_fround(HEAPF32[i9 + 36 >> 2]));
 HEAPF32[i46 >> 2] = f40;
 HEAPF32[i46 + 4 >> 2] = f41;
 HEAPF32[i46 + 8 >> 2] = f42;
 f40 = Math_fround(f13 - f40);
 f41 = Math_fround(f14 - f41);
 f42 = Math_fround(f25 - f42);
 f25 = Math_fround(f40 * Math_fround(.5));
 f14 = Math_fround(f41 * Math_fround(.5));
 f13 = Math_fround(f42 * Math_fround(.5));
 f35 = Math_fround(Math_abs(Math_fround(f25)));
 f23 = Math_fround(Math_abs(Math_fround(f14)));
 f24 = Math_fround(Math_abs(Math_fround(f13)));
 i32 = i8 + 68 | 0;
 f35 = Math_fround(f35 + Math_fround(HEAPF32[i32 >> 2]));
 i33 = i8 + 72 | 0;
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i33 >> 2]));
 i34 = i8 + 76 | 0;
 f35 = Math_fround(f35 + f1);
 f23 = Math_fround(f23 + f1);
 f24 = Math_fround(Math_fround(f24 + Math_fround(HEAPF32[i34 >> 2])) + f1);
 i29 = i8 + 80 | 0;
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i29 >> 2]));
 i30 = i8 + 84 | 0;
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i30 >> 2]));
 i31 = i8 + 88 | 0;
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i31 >> 2]));
 f6 = Math_fround(f14 - f23);
 f7 = Math_fround(f13 - f24);
 f15 = Math_fround(f35 + f25);
 f14 = Math_fround(f23 + f14);
 f13 = Math_fround(f24 + f13);
 HEAPF32[i2 >> 2] = Math_fround(f25 - f35);
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = f15;
 HEAPF32[i2 + 16 >> 2] = f14;
 HEAPF32[i2 + 20 >> 2] = f13;
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i43, i5, i2, 1, i3) | 0;
 HEAP32[i44 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i44 + 4 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i44 + 8 >> 2] = HEAP32[i31 >> 2];
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 f15 = Math_fround(HEAPF32[i34 >> 2]);
 i34 = (i10 | 0) != 0;
 f7 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f7 = i34 ? f7 : Math_fround(0.0);
 i2 = (i11 | 0) != 0;
 f6 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f6 = i2 ? f6 : Math_fround(0.0);
 if (i34) f4 = Math_fround(HEAPF32[(HEAP32[i10 + 60 >> 2] | 0) + 4 >> 2]); else f4 = Math_fround(1.0);
 if (i2) f1 = Math_fround(HEAPF32[(HEAP32[i11 + 60 >> 2] | 0) + 4 >> 2]); else f1 = Math_fround(1.0);
 f35 = Math_fround((f7 > f6 ? f7 : f6) * (f4 < f1 ? f4 : f1));
 i12 = HEAP32[i12 >> 2] | 0;
 i26 = HEAP32[i48 + 8 >> 2] | 0;
 if (!i12) {
  f42 = Math_fround(3402823469999999843913219.0e14);
  __ZN5physx2Gu9ContainerD2Ev(i48);
  STACKTOP = i49;
  return Math_fround(f42);
 }
 i27 = i47 + 12 | 0;
 i28 = i47 + 16 | 0;
 i29 = i47 + 4 | 0;
 i30 = i47 + 20 | 0;
 i31 = i47 + 8 | 0;
 i32 = i47 + 24 | 0;
 i33 = i47 + 28 | 0;
 i34 = i47 + 32 | 0;
 f25 = Math_fround(f13 * Math_fround(1.10000002));
 f24 = Math_fround(f14 * Math_fround(1.10000002));
 f23 = Math_fround(f15 * Math_fround(1.10000002));
 i2 = i36 + 4 | 0;
 i3 = i36 + 8 | 0;
 i5 = i37 + 4 | 0;
 i8 = i37 + 8 | 0;
 i9 = i38 + 4 | 0;
 i10 = i38 + 8 | 0;
 i11 = 0;
 f1 = Math_fround(3402823469999999843913219.0e14);
 do {
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i43, i39, i47, 0, 0, HEAP32[i26 + (i11 << 2) >> 2] | 0, 1, 1) | 0;
  f14 = Math_fround(HEAPF32[i27 >> 2]);
  f15 = Math_fround(HEAPF32[i47 >> 2]);
  f4 = Math_fround(f14 - f15);
  f16 = Math_fround(HEAPF32[i28 >> 2]);
  f17 = Math_fround(HEAPF32[i29 >> 2]);
  f6 = Math_fround(f16 - f17);
  f18 = Math_fround(HEAPF32[i30 >> 2]);
  f19 = Math_fround(HEAPF32[i31 >> 2]);
  f52 = Math_fround(f18 - f19);
  f20 = Math_fround(HEAPF32[i32 >> 2]);
  f51 = Math_fround(f20 - f15);
  f21 = Math_fround(HEAPF32[i33 >> 2]);
  f13 = Math_fround(f21 - f17);
  f22 = Math_fround(HEAPF32[i34 >> 2]);
  f7 = Math_fround(f22 - f19);
  f50 = Math_fround(Math_fround(f6 * f7) - Math_fround(f52 * f13));
  f7 = Math_fround(Math_fround(f52 * f51) - Math_fround(f4 * f7));
  f51 = Math_fround(Math_fround(f4 * f13) - Math_fround(f6 * f51));
  f6 = Math_fround(-f50);
  f13 = Math_fround(-f7);
  f4 = Math_fround(-f51);
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f51 * f51) + Math_fround(Math_fround(f50 * f50) + Math_fround(f7 * f7)))));
  if (f7 > Math_fround(0.0)) {
   f52 = Math_fround(Math_fround(1.0) / f7);
   f6 = Math_fround(f52 * f6);
   f7 = Math_fround(f52 * f13);
   f4 = Math_fround(f52 * f4);
  } else f7 = f13;
  if (Math_fround(Math_fround(f42 * f4) + Math_fround(Math_fround(f41 * f7) + Math_fround(f40 * f6))) >= f35) {
   i58 = f15 > Math_fround(8507058669999999534545717.0e13);
   i57 = f17 > Math_fround(8507058669999999534545717.0e13);
   i56 = f19 > Math_fround(8507058669999999534545717.0e13);
   i55 = f15 < Math_fround(-8507058669999999534545717.0e13);
   i54 = f17 < Math_fround(-8507058669999999534545717.0e13);
   i53 = f19 < Math_fround(-8507058669999999534545717.0e13);
   f50 = i58 ? Math_fround(8507058669999999534545717.0e13) : f15;
   f50 = f50 < f14 ? f50 : f14;
   f51 = i57 ? Math_fround(8507058669999999534545717.0e13) : f17;
   f51 = f51 < f16 ? f51 : f16;
   f52 = i56 ? Math_fround(8507058669999999534545717.0e13) : f19;
   f52 = f52 < f18 ? f52 : f18;
   f15 = i55 ? Math_fround(-8507058669999999534545717.0e13) : f15;
   f15 = f15 > f14 ? f15 : f14;
   f17 = i54 ? Math_fround(-8507058669999999534545717.0e13) : f17;
   f17 = f17 > f16 ? f17 : f16;
   f19 = i53 ? Math_fround(-8507058669999999534545717.0e13) : f19;
   f18 = f19 > f18 ? f19 : f18;
   f50 = f50 < f20 ? f50 : f20;
   f51 = f51 < f21 ? f51 : f21;
   f52 = f52 < f22 ? f52 : f22;
   f20 = f15 > f20 ? f15 : f20;
   f21 = f17 > f21 ? f17 : f21;
   f22 = f18 > f22 ? f18 : f22;
   HEAPF32[i36 >> 2] = f25;
   HEAPF32[i2 >> 2] = f24;
   HEAPF32[i3 >> 2] = f23;
   f18 = Math_fround(Math_fround(f51 + f21) * Math_fround(.5));
   f19 = Math_fround(Math_fround(f52 + f22) * Math_fround(.5));
   HEAPF32[i37 >> 2] = Math_fround(Math_fround(f50 + f20) * Math_fround(.5));
   HEAPF32[i5 >> 2] = f18;
   HEAPF32[i8 >> 2] = f19;
   f51 = Math_fround(Math_fround(Math_fround(Math_fround(f21 - f51) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
   f52 = Math_fround(Math_fround(Math_fround(Math_fround(f22 - f52) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
   HEAPF32[i38 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f20 - f50) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
   HEAPF32[i9 >> 2] = f51;
   HEAPF32[i10 >> 2] = f52;
   f52 = Math_fround(__Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i44, i36, i37, i38, i45, i46));
   f1 = f1 < f52 ? f1 : f52;
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i12 | 0));
 __ZN5physx2Gu9ContainerD2Ev(i48);
 STACKTOP = i49;
 return Math_fround(f1);
}

function __ZN15PointEffector2D21ContactUpdateCallbackEf(i35, f36) {
 i35 = i35 | 0;
 f36 = Math_fround(f36);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i43;
 f10 = Math_fround(HEAPF32[i35 + 92 >> 2]);
 f38 = Math_fround(HEAPF32[i35 + 96 >> 2]);
 i34 = i35 + 76 | 0;
 i41 = HEAP32[i34 >> 2] | 0;
 i41 = i41 << 11 ^ i41;
 i40 = i35 + 80 | 0;
 HEAP32[i34 >> 2] = HEAP32[i40 >> 2];
 i34 = i35 + 84 | 0;
 HEAP32[i40 >> 2] = HEAP32[i34 >> 2];
 i40 = i35 + 88 | 0;
 i39 = HEAP32[i40 >> 2] | 0;
 HEAP32[i34 >> 2] = i39;
 i39 = i41 >>> 8 ^ i41 ^ i39 ^ i39 >>> 19;
 HEAP32[i40 >> 2] = i39;
 f38 = Math_fround(f10 + Math_fround(f38 * Math_fround(Math_fround((i39 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
 i39 = (HEAP32[i35 + 112 >> 2] | 0) == 0;
 i40 = (HEAP32[i35 + 116 >> 2] | 0) == 0;
 i41 = i35 + 36 | 0;
 i34 = HEAP32[i41 >> 2] | 0;
 i42 = i35 + 48 | 0;
 __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i34, i34 + ((HEAP32[i42 >> 2] | 0) * 40 | 0) | 0, i37);
 do if (i39) {
  i1 = HEAP32[i41 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP32[i2 + 148 >> 2] | 0)) {
   __ZNK9Transform11GetPositionEv(i37, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   i1 = HEAP32[i37 >> 2] | 0;
   i2 = HEAP32[i37 + 4 >> 2] | 0;
   break;
  } else {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = 0;
 } while (0);
 i25 = i35 + 104 | 0;
 i26 = i35 + 108 | 0;
 i27 = i35 + 100 | 0;
 i28 = i35 + 120 | 0;
 i29 = i37 + 8 | 0;
 i30 = i37 + 4 | 0;
 i31 = i37 + 12 | 0;
 i32 = i37 + 8 | 0;
 i33 = i37 + 4 | 0;
 i34 = i37 + 12 | 0;
 i22 = HEAP32[i41 >> 2] | 0;
 do {
  i24 = __ZN10Effector2D19FindContactGroupEndEPKNS_15EffectorContactE(i35, i22) | 0;
  i17 = i22 + 16 | 0;
  i23 = HEAP32[i17 >> 2] | 0;
  if ((HEAP32[i23 >> 2] | 0) == 2) {
   i4 = HEAP32[gb + 1457504 >> 2] | 0;
   i5 = HEAP32[gb + 1457504 + 4 >> 2] | 0;
   if (i22 >>> 0 > i24 >>> 0) {
    i11 = 0;
    i7 = i4;
    i8 = i4;
    i4 = i5;
    i12 = 2;
   } else {
    i15 = i23 + 44 | 0;
    i16 = i23 + 48 | 0;
    i18 = i22 + 24 | 0;
    i19 = i22 + 28 | 0;
    i20 = i22 + 8 | 0;
    i21 = i22 + 12 | 0;
    i11 = 0;
    i14 = i22;
    i7 = i4;
    i8 = i4;
    i4 = i5;
    do {
     if (!i39) {
      i1 = HEAP32[(HEAP32[i20 >> 2] | 0) + 32 >> 2] | 0;
      mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i37 | 0, (HEAP32[i22 >> 2] | 0) + 12 | 0, HEAP32[i21 >> 2] | 0, 1);
      f9 = Math_fround(HEAPF32[i37 >> 2]);
      f9 = Math_fround(f9 + Math_fround(HEAPF32[i32 >> 2]));
      f10 = Math_fround(HEAPF32[i33 >> 2]);
      f9 = Math_fround(f9 * Math_fround(.5));
      f10 = Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i34 >> 2])) * Math_fround(.5));
      i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     }
     if (i40) {
      i12 = HEAP32[i15 >> 2] | 0;
      i13 = HEAP32[i16 >> 2] | 0;
     } else {
      i12 = HEAP32[(HEAP32[i18 >> 2] | 0) + 32 >> 2] | 0;
      mftCall_viiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0, i37 | 0, (HEAP32[i17 >> 2] | 0) + 12 | 0, HEAP32[i19 >> 2] | 0, 1);
      f9 = Math_fround(HEAPF32[i37 >> 2]);
      f9 = Math_fround(f9 + Math_fround(HEAPF32[i29 >> 2]));
      f10 = Math_fround(HEAPF32[i30 >> 2]);
      f9 = Math_fround(f9 * Math_fround(.5));
      f10 = Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i31 >> 2])) * Math_fround(.5));
      i12 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     }
     f6 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
     f3 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f3);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f3 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6))));
     if (f9 < Math_fround(1.1920929e-07)) f9 = Math_fround(0.0); else {
      f10 = Math_fround(Math_fround(1.0) / f9);
      f6 = Math_fround(f6 * f10);
      f3 = Math_fround(f3 * f10);
     }
     f9 = Math_fround(f9 * Math_fround(HEAPF32[i27 >> 2]));
     i13 = f9 > Math_fround(1.0);
     f9 = i13 ? f9 : Math_fround(1.0);
     switch (HEAP32[i28 >> 2] | 0) {
     case 0:
      {
       f6 = Math_fround(f38 * f6);
       f3 = Math_fround(f38 * f3);
       break;
      }
     case 1:
      {
       f10 = Math_fround(f38 / f9);
       f6 = Math_fround(f6 * f10);
       f3 = Math_fround(f3 * f10);
       break;
      }
     case 2:
      {
       f10 = Math_fround(f38 / Math_fround(f9 * f9));
       f6 = Math_fround(f6 * f10);
       f3 = Math_fround(f3 * f10);
       break;
      }
     default:
      {}
     }
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
     i8 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f3);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     i14 = i14 + 40 | 0;
     i11 = i11 + 1 | 0;
    } while (i14 >>> 0 <= i24 >>> 0);
    i12 = HEAP32[i23 >> 2] | 0;
   }
   f3 = Math_fround(Math_fround(1.0) / Math_fround(i11 | 0));
   f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   if ((i12 | 0) == 2) {
    i5 = i23 + 4 | 0;
    i4 = HEAP16[i5 >> 1] | 0;
    if (!(i4 & 2)) {
     i7 = i4 & 65535;
     if (!(i7 & 2)) {
      i4 = (i7 | 2) & 65535;
      HEAP16[i5 >> 1] = i4;
      HEAPF32[i23 + 144 >> 2] = Math_fround(0.0);
     }
    }
    if (i4 & 2) {
     i22 = i23 + 76 | 0;
     HEAPF32[i22 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i22 >> 2]));
     i22 = i23 + 80 | 0;
     HEAPF32[i22 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i22 >> 2]));
     f10 = Math_fround(f10 - Math_fround(HEAPF32[i23 + 44 >> 2]));
     f10 = Math_fround(Math_fround(f3 * f10) - Math_fround(f6 * Math_fround(f9 - Math_fround(HEAPF32[i23 + 48 >> 2]))));
     i22 = i23 + 84 | 0;
     HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f10);
    }
   }
   f3 = Math_fround(HEAPF32[i25 >> 2]);
   if (f3 > Math_fround(0.0)) {
    i8 = i23 + 64 | 0;
    f10 = Math_fround(HEAPF32[i8 >> 2]);
    i7 = i23 + 68 | 0;
    f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f3 * f36) + Math_fround(1.0)));
    f3 = Math_fround(f6 * f10);
    f6 = Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2]));
    if (i12 | 0) {
     if (Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)) > Math_fround(0.0)) {
      i4 = i23 + 4 | 0;
      i5 = HEAPU16[i4 >> 1] | 0;
      if (!(i5 & 2)) {
       HEAP16[i4 >> 1] = i5 | 2;
       HEAPF32[i23 + 144 >> 2] = Math_fround(0.0);
      }
     }
     HEAPF32[i8 >> 2] = f3;
     HEAPF32[i7 >> 2] = f6;
    }
   }
   f3 = Math_fround(HEAPF32[i26 >> 2]);
   if (f3 > Math_fround(0.0)) {
    i7 = i23 + 72 | 0;
    f3 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f3 * f36) + Math_fround(1.0))) * Math_fround(HEAPF32[i7 >> 2]));
    if (i12) {
     i5 = i23 + 4 | 0;
     i4 = HEAP16[i5 >> 1] | 0;
     if (!(i4 & 16)) {
      if (Math_fround(f3 * f3) > Math_fround(0.0)) {
       i4 = i4 & 65535;
       if (!(i4 & 2)) {
        HEAP16[i5 >> 1] = i4 | 2;
        HEAPF32[i23 + 144 >> 2] = Math_fround(0.0);
       }
      }
      HEAPF32[i7 >> 2] = f3;
     }
    }
   }
  }
  i22 = i24 + 40 | 0;
 } while ((i22 | 0) != ((HEAP32[i41 >> 2] | 0) + ((HEAP32[i42 >> 2] | 0) * 40 | 0) | 0));
 STACKTOP = i43;
 return;
}

function __ZN20SweepCapsuleCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i32, i30, i2, i3, i4, i31, i1) {
 i32 = i32 | 0;
 i30 = i30 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i34 + 96 | 0;
 i22 = i34 + 92 | 0;
 i20 = i34 + 80 | 0;
 i24 = i34 + 44 | 0;
 i27 = i34 + 40 | 0;
 i29 = i34 + 28 | 0;
 i28 = i34 + 16 | 0;
 i25 = i34 + 4 | 0;
 i23 = i34;
 i9 = i34 + 100 | 0;
 i17 = HEAP32[i32 + 12 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f42 = Math_fround(HEAPF32[i17 >> 2]);
 f13 = Math_fround(f15 * f42);
 f41 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f5 = Math_fround(f15 * f41);
 f18 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f15 = Math_fround(f15 * f18);
 f39 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f35 = Math_fround(f39 * f38);
 f36 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 f37 = Math_fround(f39 * f36);
 f7 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f35 = Math_fround(f13 + f35);
 f37 = Math_fround(f5 + f37);
 f39 = Math_fround(f15 + Math_fround(f39 * f7));
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i17 + 24 >> 2]);
 f13 = Math_fround(f15 * f5);
 f6 = Math_fround(HEAPF32[i17 + 28 >> 2]);
 f14 = Math_fround(f15 * f6);
 f12 = Math_fround(HEAPF32[i17 + 32 >> 2]);
 f13 = Math_fround(f35 + f13);
 f14 = Math_fround(f37 + f14);
 f15 = Math_fround(f39 + Math_fround(f15 * f12));
 f39 = Math_fround(HEAPF32[i17 + 36 >> 2]);
 f13 = Math_fround(f13 + f39);
 f37 = Math_fround(HEAPF32[i17 + 40 >> 2]);
 f14 = Math_fround(f14 + f37);
 f35 = Math_fround(HEAPF32[i17 + 44 >> 2]);
 f15 = Math_fround(f15 + f35);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(f42 * f11);
 f10 = Math_fround(f41 * f11);
 f11 = Math_fround(f18 * f11);
 f40 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f38 * f40));
 f10 = Math_fround(f10 + Math_fround(f36 * f40));
 f40 = Math_fround(f11 + Math_fround(f7 * f40));
 f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(f39 + Math_fround(f8 + Math_fround(f5 * f11)));
 f10 = Math_fround(f37 + Math_fround(f10 + Math_fround(f6 * f11)));
 f11 = Math_fround(f35 + Math_fround(f40 + Math_fround(f12 * f11)));
 f40 = Math_fround(HEAPF32[i4 >> 2]);
 f42 = Math_fround(f42 * f40);
 f41 = Math_fround(f41 * f40);
 f40 = Math_fround(f18 * f40);
 f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f38 = Math_fround(f42 + Math_fround(f38 * f18));
 f36 = Math_fround(f41 + Math_fround(f36 * f18));
 f18 = Math_fround(f40 + Math_fround(f7 * f18));
 f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f5 = Math_fround(f39 + Math_fround(f38 + Math_fround(f5 * f7)));
 f6 = Math_fround(f37 + Math_fround(f36 + Math_fround(f6 * f7)));
 f7 = Math_fround(f35 + Math_fround(f18 + Math_fround(f12 * f7)));
 HEAPF32[i24 >> 2] = f13;
 HEAPF32[i24 + 4 >> 2] = f14;
 HEAPF32[i24 + 8 >> 2] = f15;
 i17 = i24 + 12 | 0;
 HEAPF32[i17 >> 2] = f8;
 HEAPF32[i24 + 16 >> 2] = f10;
 HEAPF32[i24 + 20 >> 2] = f11;
 i16 = i24 + 24 | 0;
 HEAPF32[i16 >> 2] = f5;
 HEAPF32[i24 + 28 >> 2] = f6;
 HEAPF32[i24 + 32 >> 2] = f7;
 f12 = Math_fround(HEAPF32[i32 + 16 >> 2]);
 i26 = i32 + 20 | 0;
 f18 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + Math_fround(.00100000005));
 f18 = f12 < f18 ? f12 : f18;
 i19 = HEAP32[i32 + 32 >> 2] | 0;
 do if (!(HEAP8[i32 + 54 >> 0] | 0)) {
  i1 = i32 + 36 | 0;
  i21 = HEAP32[i1 >> 2] | 0;
  i22 = (HEAP32[i32 + 8 >> 2] | 0) + 12 | 0;
  HEAP16[i9 >> 1] = HEAP16[HEAP32[i32 + 40 >> 2] >> 1] | 0;
  if (!(__ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE(1, i24, i19, i21, f18, 0, i22, i27, i28, i29, i23, i25, i9, (HEAP8[i32 + 28 >> 0] | 0) != 0, 0) | 0)) {
   i33 = 1;
   STACKTOP = i34;
   return i33 | 0;
  }
 } else {
  f12 = Math_fround(HEAPF32[i19 + 24 >> 2]);
  i1 = i32 + 36 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = (HEAP32[i32 + 8 >> 2] | 0) + 12 | 0;
  i4 = (HEAP8[i32 + 28 >> 0] | 0) != 0;
  i43 = HEAPU16[HEAP32[i32 + 40 >> 2] >> 1] | 0;
  i9 = (i43 & 128 | 0) != 0;
  if (!(i43 & 16)) {
   f40 = Math_fround(f8 - f13);
   f42 = Math_fround(f10 - f14);
   f39 = Math_fround(f11 - f15);
   f8 = Math_fround(f5 - f13);
   f41 = Math_fround(f6 - f14);
   f7 = Math_fround(f7 - f15);
   f6 = Math_fround(Math_fround(f42 * f7) - Math_fround(f39 * f41));
   f7 = Math_fround(Math_fround(f39 * f8) - Math_fround(f40 * f7));
   f8 = Math_fround(Math_fround(f40 * f41) - Math_fround(f42 * f8));
   if (!(i4 | i9)) {
    f42 = Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2]));
    f42 = Math_fround(f42 + Math_fround(f7 * Math_fround(HEAPF32[i2 + 4 >> 2])));
    if (Math_fround(f42 + Math_fround(f8 * Math_fround(HEAPF32[i2 + 8 >> 2]))) > Math_fround(0.0)) {
     i43 = 1;
     STACKTOP = i34;
     return i43 | 0;
    }
   }
   __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i20, i19, i24, i17, i16, i21, i22);
   f40 = Math_fround(HEAPF32[i20 >> 2]);
   f40 = Math_fround(f40 - Math_fround(HEAPF32[i19 >> 2]));
   f41 = Math_fround(HEAPF32[i20 + 4 >> 2]);
   f41 = Math_fround(f41 - Math_fround(HEAPF32[i19 + 4 >> 2]));
   f42 = Math_fround(HEAPF32[i20 + 8 >> 2]);
   f42 = Math_fround(f42 - Math_fround(HEAPF32[i19 + 8 >> 2]));
   if (Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f41 * f41)) + Math_fround(f42 * f42)) <= Math_fround(f12 * f12)) {
    HEAP32[i23 >> 2] = 0;
    HEAPF32[i27 >> 2] = Math_fround(0.0);
    f41 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
    f42 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
    f5 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
    HEAPF32[i28 >> 2] = f41;
    HEAPF32[i28 + 4 >> 2] = f42;
    HEAPF32[i28 + 8 >> 2] = f5;
    HEAP16[i3 >> 1] = 6;
    f5 = Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)));
    if (f5 > Math_fround(0.0)) {
     f42 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
     f40 = Math_fround(f6 * f42);
     f41 = Math_fround(f7 * f42);
     f42 = Math_fround(f8 * f42);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i2 = 0;
     i3 = 0;
     i4 = 0;
    }
    HEAP32[i25 >> 2] = i4;
    HEAP32[i25 + 4 >> 2] = i3;
    HEAP32[i25 + 8 >> 2] = i2;
    break;
   }
  }
  if (!(__ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb(1, i24, i19, f12, i2, f18, 0, i29, i28, i27, i23, i3, i25, i4, i9) | 0)) {
   i43 = 1;
   STACKTOP = i34;
   return i43 | 0;
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i25 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i1 >> 2]));
 f6 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i1 + 4 >> 2])));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f5 = Math_fround(-Math_fround(Math_abs(Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 8 >> 2]))))));
 f6 = Math_fround(HEAPF32[i27 >> 2]);
 i1 = i32 + 48 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i32 + 44 | 0;
 f8 = f6 > f7 ? f6 : f7;
 i43 = f8 < Math_fround(1.0);
 f8 = Math_fround(f8 * Math_fround(.00100000005));
 f8 = i43 ? Math_fround(.00100000005) : f8;
 if (Math_fround(f7 - f8) > f6) i33 = 14; else if (Math_fround(f7 + f8) > f6 ? Math_fround(HEAPF32[i2 >> 2]) > f5 : 0) i33 = 14;
 do if ((i33 | 0) == 14) {
  HEAPF32[i2 >> 2] = f5;
  HEAPF32[i26 >> 2] = f6;
  HEAPF32[i31 >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i32 + 24 >> 2]));
  f42 = Math_fround(HEAPF32[i1 >> 2]);
  HEAPF32[i1 >> 2] = f42 < f6 ? f42 : f6;
  i43 = i32 + 8 | 0;
  HEAPF32[(HEAP32[i43 >> 2] | 0) + 40 >> 2] = f6;
  i33 = HEAP32[i43 >> 2] | 0;
  HEAP32[i33 + 28 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i33 + 32 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i33 + 36 >> 2] = HEAP32[i28 + 8 >> 2];
  i33 = HEAP32[i43 >> 2] | 0;
  HEAP32[i33 + 16 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i33 + 20 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i33 + 24 >> 2] = HEAP32[i29 + 8 >> 2];
  HEAP32[(HEAP32[i43 >> 2] | 0) + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP8[i32 + 52 >> 0] = 1;
  if (Math_fround(HEAPF32[i27 >> 2]) == Math_fround(0.0)) {
   HEAP8[i32 + 53 >> 0] = 1;
   i43 = 0;
   STACKTOP = i34;
   return i43 | 0;
  } else {
   if (!(HEAP16[HEAP32[i32 + 40 >> 2] >> 1] & 64)) break; else i1 = 0;
   STACKTOP = i34;
   return i1 | 0;
  }
 } while (0);
 i43 = 1;
 STACKTOP = i34;
 return i43 | 0;
}

function __ZN5physx21updateCollDataDynamicERNS_19PxsParticleCollDataERKNS_11PxTransformERKNS_6PxVec3ES7_PKNS_11PxsBodyCoreES4_fRNS_25PxsFluidConstraintDynamicESC_(i34, i2, i28, i27, i38, i1, f29, i32, i33) {
 i34 = i34 | 0;
 i2 = i2 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 f29 = Math_fround(f29);
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i30 = 0, i31 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i39 + 24 | 0;
 i36 = i39 + 12 | 0;
 i37 = i39;
 i3 = i34 + 124 | 0;
 if (!(HEAP32[i3 >> 2] & 56)) {
  STACKTOP = i39;
  return;
 }
 f5 = Math_fround(Math_fround(HEAPF32[i34 + 144 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i34 + 148 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i34 + 152 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f5 * f17);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f16 * f15));
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f11));
 f7 = Math_fround(Math_fround(f15 * f9) + Math_fround(Math_fround(f16 * f4) + Math_fround(f12 * Math_fround(Math_fround(f5 * f11) - Math_fround(f10 * f17)))));
 f8 = Math_fround(Math_fround(Math_fround(f10 * f4) + Math_fround(f12 * Math_fround(Math_fround(f16 * f17) - Math_fround(f5 * f15)))) + Math_fround(f11 * f9));
 HEAPF32[i35 >> 2] = Math_fround(Math_fround(f17 * f9) + Math_fround(Math_fround(f5 * f4) + Math_fround(f12 * Math_fround(Math_fround(f10 * f15) - Math_fround(f16 * f11)))));
 i30 = i35 + 4 | 0;
 HEAPF32[i30 >> 2] = f7;
 i31 = i35 + 8 | 0;
 HEAPF32[i31 >> 2] = f8;
 f16 = Math_fround(Math_fround(HEAPF32[i34 + 160 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i34 + 164 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i34 + 168 >> 2]) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f16 * f17) + Math_fround(f10 * f15)) + Math_fround(f5 * f11));
 f13 = Math_fround(Math_fround(f17 * f9) + Math_fround(Math_fround(f16 * f4) + Math_fround(f12 * Math_fround(Math_fround(f5 * f15) - Math_fround(f10 * f11)))));
 f14 = Math_fround(Math_fround(f15 * f9) + Math_fround(Math_fround(f10 * f4) + Math_fround(f12 * Math_fround(Math_fround(f16 * f11) - Math_fround(f5 * f17)))));
 f9 = Math_fround(Math_fround(Math_fround(f5 * f4) + Math_fround(f12 * Math_fround(Math_fround(f10 * f17) - Math_fround(f16 * f15)))) + Math_fround(f11 * f9));
 f13 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f13);
 f14 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f14);
 f9 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f9);
 HEAPF32[i36 >> 2] = f13;
 i23 = i36 + 4 | 0;
 HEAPF32[i23 >> 2] = f14;
 i24 = i36 + 8 | 0;
 HEAPF32[i24 >> 2] = f9;
 i25 = i2 + 16 | 0;
 f11 = Math_fround(f13 - Math_fround(HEAPF32[i25 >> 2]));
 i26 = i2 + 20 | 0;
 f15 = Math_fround(f14 - Math_fround(HEAPF32[i26 >> 2]));
 i18 = i2 + 24 | 0;
 f16 = Math_fround(f9 - Math_fround(HEAPF32[i18 >> 2]));
 i19 = i27 + 4 | 0;
 f17 = Math_fround(HEAPF32[i19 >> 2]);
 f10 = Math_fround(f17 * f16);
 i20 = i27 + 8 | 0;
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f10 = Math_fround(f10 - Math_fround(f15 * f12));
 f12 = Math_fround(f11 * f12);
 f4 = Math_fround(HEAPF32[i27 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f16 * f4));
 f17 = Math_fround(Math_fround(f15 * f4) - Math_fround(f11 * f17));
 f4 = Math_fround(f10 + Math_fround(HEAPF32[i28 >> 2]));
 i21 = i28 + 4 | 0;
 f5 = Math_fround(f12 + Math_fround(HEAPF32[i21 >> 2]));
 i22 = i28 + 8 | 0;
 f6 = Math_fround(f17 + Math_fround(HEAPF32[i22 >> 2]));
 HEAPF32[i37 >> 2] = f4;
 HEAPF32[i37 + 4 >> 2] = f5;
 HEAPF32[i37 + 8 >> 2] = f6;
 i3 = HEAP32[i3 >> 2] | 0;
 if (i3 & 8 | 0) {
  i2 = i34 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -4 | 2;
  HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
  HEAPF32[i34 + 4 >> 2] = f7;
  HEAPF32[i34 + 8 >> 2] = f8;
  HEAPF32[i34 + 16 >> 2] = f13;
  HEAPF32[i34 + 20 >> 2] = f14;
  HEAPF32[i34 + 24 >> 2] = f9;
  HEAPF32[i34 + 32 >> 2] = f4;
  HEAPF32[i34 + 36 >> 2] = f5;
  HEAPF32[i34 + 40 >> 2] = f6;
  HEAP32[i34 + 108 >> 2] = i38;
  i2 = i34 + 60 | 0;
  HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 4;
 }
 if (i3 & 16 | 0) {
  i1 = i34 + 12 | 0;
  i40 = HEAP32[i1 >> 2] | 0;
  i2 = i40 | 1;
  HEAP32[i1 >> 2] = i2;
  if (!(i40 & 4)) {
   f8 = Math_fround(HEAPF32[i35 >> 2]);
   HEAPF32[i34 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i34 >> 2]));
   f8 = Math_fround(HEAPF32[i30 >> 2]);
   i40 = i34 + 4 | 0;
   HEAPF32[i40 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i40 >> 2]));
   f8 = Math_fround(HEAPF32[i31 >> 2]);
   i40 = i34 + 8 | 0;
   HEAPF32[i40 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i40 >> 2]));
   i40 = i34 + 32 | 0;
   HEAPF32[i40 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i40 >> 2]));
   i40 = i34 + 36 | 0;
   HEAPF32[i40 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i40 >> 2]));
   i40 = i34 + 40 | 0;
   HEAPF32[i40 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i40 >> 2]));
  } else {
   HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i34 + 4 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i34 + 8 >> 2] = HEAP32[i31 >> 2];
   HEAPF32[i34 + 32 >> 2] = f4;
   HEAPF32[i34 + 36 >> 2] = f5;
   HEAPF32[i34 + 40 >> 2] = f6;
   HEAP32[i1 >> 2] = i2 & -5;
  }
  i40 = i34 + 16 | 0;
  HEAPF32[i40 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i40 >> 2]));
  i40 = i34 + 20 | 0;
  HEAPF32[i40 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i40 >> 2]));
  i40 = i34 + 24 | 0;
  HEAPF32[i40 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i40 >> 2]));
  i40 = i34 + 28 | 0;
  HEAPF32[i40 >> 2] = Math_fround(Math_fround(HEAPF32[i40 >> 2]) + Math_fround(1.0));
  HEAP32[i34 + 108 >> 2] = i38;
  i40 = i34 + 60 | 0;
  HEAP16[i40 >> 1] = HEAPU16[i40 >> 1] | 0 | 4;
 }
 if (!(i3 & 40)) {
  STACKTOP = i39;
  return;
 }
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f15 * f15)) + Math_fround(f16 * f16))));
 f8 = Math_fround(f11 + Math_fround(f10 * f29));
 f7 = Math_fround(f15 + Math_fround(f12 * f29));
 f4 = Math_fround(f16 + Math_fround(f17 * f29));
 HEAPF32[i36 >> 2] = f8;
 HEAPF32[i23 >> 2] = f7;
 HEAPF32[i24 >> 2] = f4;
 f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)));
 if (f5 > Math_fround(0.0)) {
  f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
  f6 = Math_fround(f4 * f17);
  f5 = Math_fround(f7 * f17);
  f4 = Math_fround(f8 * f17);
 } else {
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f17 = Math_fround(f9 * f4);
 f4 = Math_fround(f9 * f5);
 f6 = Math_fround(f9 * f6);
 f16 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f29);
 f5 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f29);
 f7 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f29);
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i25 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i26 >> 2]));
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i18 >> 2]));
 HEAPF32[i36 >> 2] = Math_fround(f16 + f17);
 HEAPF32[i23 >> 2] = Math_fround(f5 + f4);
 HEAPF32[i24 >> 2] = Math_fround(f7 + f6);
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 f7 = Math_fround(HEAPF32[i31 >> 2]);
 f4 = Math_fround(f6 * f7);
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 f17 = Math_fround(HEAPF32[i30 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f5 * f17));
 f16 = Math_fround(HEAPF32[i35 >> 2]);
 f5 = Math_fround(f5 * f16);
 f15 = Math_fround(HEAPF32[i27 >> 2]);
 f5 = Math_fround(Math_fround(f5 - Math_fround(f7 * f15)) * f29);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f15) - Math_fround(f6 * f16)) * f29);
 f4 = Math_fround(f16 + Math_fround(f4 * f29));
 HEAPF32[i35 >> 2] = f4;
 f5 = Math_fround(f17 + f5);
 HEAPF32[i30 >> 2] = f5;
 f6 = Math_fround(f7 + f6);
 HEAPF32[i31 >> 2] = f6;
 f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)));
 if (f7 > Math_fround(0.0)) {
  f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
  f16 = Math_fround(f4 * f29);
  f17 = Math_fround(f5 * f29);
  f29 = Math_fround(f6 * f29);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 0;
 }
 HEAP32[i35 >> 2] = i3;
 HEAP32[i30 >> 2] = i2;
 HEAP32[i31 >> 2] = i1;
 __ZN5physx20addConstraintDynamicERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_PKNS_11PxsBodyCoreERNS_25PxsFluidConstraintDynamicES9_(i34, i35, i36, i37, i38, i32, i33);
 STACKTOP = i39;
 return;
}

function __ZN7b2World5SolveERK10b2TimeStep(i32, i22) {
 i32 = i32 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i42;
 i36 = i42 + 32 | 0;
 i41 = i42 + 84 | 0;
 i29 = i32 + 103012 | 0;
 HEAPF32[i29 >> 2] = Math_fround(0.0);
 i30 = i32 + 103016 | 0;
 HEAPF32[i30 >> 2] = Math_fround(0.0);
 i31 = i32 + 103020 | 0;
 HEAPF32[i31 >> 2] = Math_fround(0.0);
 i2 = i32 + 102964 | 0;
 i28 = HEAP32[i2 >> 2] | 0;
 i33 = i32 + 102872 | 0;
 i38 = HEAP32[i32 + 102936 >> 2] | 0;
 i39 = HEAP32[i32 + 102968 >> 2] | 0;
 i23 = i32 + 68 | 0;
 i27 = HEAP32[i32 + 102944 >> 2] | 0;
 HEAP32[i36 + 40 >> 2] = i28;
 HEAP32[i36 + 44 >> 2] = i38;
 HEAP32[i36 + 48 >> 2] = i39;
 i24 = i36 + 28 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i36 + 36 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i36 + 32 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i36 >> 2] = i23;
 HEAP32[i36 + 4 >> 2] = i27;
 i27 = __ZN16b2StackAllocator8AllocateEi(i23, i28 << 2) | 0;
 i35 = i36 + 8 | 0;
 HEAP32[i35 >> 2] = i27;
 i37 = i36 + 12 | 0;
 HEAP32[i37 >> 2] = __ZN16b2StackAllocator8AllocateEi(i23, i38 << 2) | 0;
 i38 = i36 + 16 | 0;
 HEAP32[i38 >> 2] = __ZN16b2StackAllocator8AllocateEi(i23, i39 << 2) | 0;
 i28 = i28 * 12 | 0;
 i39 = i36 + 24 | 0;
 HEAP32[i39 >> 2] = __ZN16b2StackAllocator8AllocateEi(i23, i28) | 0;
 i40 = i36 + 20 | 0;
 HEAP32[i40 >> 2] = __ZN16b2StackAllocator8AllocateEi(i23, i28) | 0;
 i28 = i32 + 102956 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) do {
  i21 = i1 + 4 | 0;
  HEAP16[i21 >> 1] = HEAPU16[i21 >> 1] & 65534;
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i32 + 102932 >> 2] | 0;
 if (i1 | 0) do {
  i21 = i1 + 4 | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & -2;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i32 + 102960 >> 2] | 0;
 if (i1 | 0) do {
  HEAP8[i1 + 60 >> 0] = 0;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i16 = __ZN16b2StackAllocator8AllocateEi(i23, HEAP32[i2 >> 2] << 2) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) {
  i17 = i32 + 102972 | 0;
  i18 = i32 + 102980 | 0;
  i19 = i34 + 12 | 0;
  i20 = i34 + 16 | 0;
  i21 = i34 + 20 | 0;
  do {
   i2 = i1 + 4 | 0;
   i3 = HEAP16[i2 >> 1] | 0;
   if ((i3 & 35) == 34) if (HEAP32[i1 >> 2] | 0) {
    HEAP32[i24 >> 2] = 0;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i26 >> 2] = 0;
    HEAP32[i16 >> 2] = i1;
    HEAP16[i2 >> 1] = i3 & 65535 | 1;
    i12 = HEAP32[i38 >> 2] | 0;
    i13 = HEAP32[i37 >> 2] | 0;
    i2 = 1;
    i11 = 0;
    i9 = 0;
    i15 = 0;
    while (1) {
     i2 = i2 + -1 | 0;
     i10 = HEAP32[i16 + (i2 << 2) >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i15;
     HEAP32[i27 + (i15 << 2) >> 2] = i10;
     i14 = i15 + 1 | 0;
     i3 = i10 + 4 | 0;
     i4 = HEAPU16[i3 >> 1] | 0;
     if (!(HEAP32[i10 >> 2] | 0)) {
      HEAP16[i3 >> 1] = i4 & 65533;
      HEAPF32[i10 + 144 >> 2] = Math_fround(0.0);
      i4 = i10 + 64 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i4 + 4 >> 2] = 0;
      HEAP32[i4 + 8 >> 2] = 0;
      HEAP32[i4 + 12 >> 2] = 0;
      HEAP32[i4 + 16 >> 2] = 0;
      HEAP32[i4 + 20 >> 2] = 0;
      i4 = i11;
      i3 = i9;
     } else {
      if (!(i4 & 2)) {
       HEAP16[i3 >> 1] = i4 | 2;
       HEAPF32[i10 + 144 >> 2] = Math_fround(0.0);
      }
      i3 = HEAP32[i10 + 112 >> 2] | 0;
      if (!i3) {
       i4 = i2;
       i3 = i9;
      } else while (1) {
       i6 = HEAP32[i3 + 4 >> 2] | 0;
       i7 = i6 + 4 | 0;
       i8 = HEAP32[i7 >> 2] | 0;
       do if ((i8 & 7 | 0) == 6) {
        i4 = HEAP32[i6 + 48 >> 2] | 0;
        if (!(HEAP8[i4 + 58 >> 0] | 0)) {
         i5 = HEAP32[i6 + 52 >> 2] | 0;
         if (!(HEAP8[i5 + 58 >> 0] | 0)) {
          if ((HEAP32[HEAP32[i4 + 28 >> 2] >> 2] | 0) != 2 ? (HEAP32[HEAP32[i5 + 28 >> 2] >> 2] | 0) != 2 : 0) {
           i5 = i9;
           break;
          }
          i5 = i9 + 1 | 0;
          HEAP32[i25 >> 2] = i5;
          HEAP32[i13 + (i9 << 2) >> 2] = i6;
          HEAP32[i7 >> 2] = i8 | 1;
          i4 = HEAP32[i3 >> 2] | 0;
          i6 = i4 + 4 | 0;
          i7 = HEAP16[i6 >> 1] | 0;
          if (i7 & 1) break;
          HEAP32[i16 + (i2 << 2) >> 2] = i4;
          HEAP16[i6 >> 1] = i7 & 65535 | 1;
          i2 = i2 + 1 | 0;
         } else i5 = i9;
        } else i5 = i9;
       } else i5 = i9; while (0);
       i3 = HEAP32[i3 + 12 >> 2] | 0;
       if (!i3) {
        i4 = i2;
        i3 = i5;
        break;
       } else i9 = i5;
      }
      i2 = HEAP32[i10 + 108 >> 2] | 0;
      if (!i2) {
       i2 = i4;
       i4 = i11;
      } else while (1) {
       i6 = i2 + 4 | 0;
       i7 = HEAP32[i6 >> 2] | 0;
       if (!(HEAP8[i7 + 60 >> 0] | 0)) {
        i8 = HEAP32[i2 >> 2] | 0;
        i9 = i8 + 4 | 0;
        i10 = HEAP16[i9 >> 1] | 0;
        if (!(i10 & 32)) i5 = i11; else {
         i5 = i11 + 1 | 0;
         HEAP32[i26 >> 2] = i5;
         HEAP32[i12 + (i11 << 2) >> 2] = i7;
         HEAP8[(HEAP32[i6 >> 2] | 0) + 60 >> 0] = 1;
         if (!(i10 & 1)) {
          HEAP32[i16 + (i4 << 2) >> 2] = i8;
          HEAP16[i9 >> 1] = i10 & 65535 | 1;
          i4 = i4 + 1 | 0;
         }
        }
       } else i5 = i11;
       i2 = HEAP32[i2 + 12 >> 2] | 0;
       if (!i2) {
        i2 = i4;
        i4 = i5;
        break;
       } else i11 = i5;
      }
     }
     if ((i2 | 0) > 0) {
      i11 = i4;
      i9 = i3;
      i15 = i14;
     } else break;
    }
    HEAP32[i24 >> 2] = i14;
    __ZN8b2Island5SolveEP9b2ProfileRK10b2TimeStepRK6b2Vec2b(i36, i34, i22, i17, (HEAP8[i18 >> 0] | 0) != 0);
    f43 = Math_fround(HEAPF32[i19 >> 2]);
    HEAPF32[i29 >> 2] = Math_fround(f43 + Math_fround(HEAPF32[i29 >> 2]));
    f43 = Math_fround(HEAPF32[i20 >> 2]);
    HEAPF32[i30 >> 2] = Math_fround(f43 + Math_fround(HEAPF32[i30 >> 2]));
    f43 = Math_fround(HEAPF32[i21 >> 2]);
    HEAPF32[i31 >> 2] = Math_fround(f43 + Math_fround(HEAPF32[i31 >> 2]));
    if ((i15 | 0) > -1) {
     i2 = 0;
     while (1) {
      i3 = HEAP32[i27 + (i2 << 2) >> 2] | 0;
      if (!(HEAP32[i3 >> 2] | 0)) {
       i14 = i3 + 4 | 0;
       HEAP16[i14 >> 1] = HEAPU16[i14 >> 1] & 65534;
      }
      if ((i2 | 0) < (i15 | 0)) i2 = i2 + 1 | 0; else break;
     }
    }
   }
   i1 = HEAP32[i1 + 96 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 __ZN16b2StackAllocator4FreeEPv(i23, i16);
 i1 = HEAP32[i28 >> 2] | 0;
 if (!i1) {
  __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i33, i33);
  f43 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i41));
  i41 = i32 + 103024 | 0;
  HEAPF32[i41 >> 2] = f43;
  i36 = HEAP32[i36 >> 2] | 0;
  i41 = HEAP32[i40 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i36, i41);
  i41 = HEAP32[i39 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i36, i41);
  i41 = HEAP32[i38 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i36, i41);
  i41 = HEAP32[i37 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i36, i41);
  i41 = HEAP32[i35 >> 2] | 0;
  __ZN16b2StackAllocator4FreeEPv(i36, i41);
  STACKTOP = i42;
  return;
 }
 i6 = i34 + 8 | 0;
 i7 = i34 + 12 | 0;
 i5 = i34 + 4 | 0;
 do {
  if (HEAP16[i1 + 4 >> 1] & 1) if (HEAP32[i1 >> 2] | 0) {
   f45 = Math_fround(HEAPF32[i1 + 52 >> 2]);
   f47 = Math_fround(+Math_sin(+f45));
   HEAPF32[i6 >> 2] = f47;
   f45 = Math_fround(+Math_cos(+f45));
   HEAPF32[i7 >> 2] = f45;
   f46 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   f44 = Math_fround(f45 * f46);
   f43 = Math_fround(HEAPF32[i1 + 32 >> 2]);
   f44 = Math_fround(f44 - Math_fround(f47 * f43));
   f43 = Math_fround(Math_fround(f47 * f46) + Math_fround(f45 * f43));
   f44 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) - f44);
   f43 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) - f43);
   HEAPF32[i34 >> 2] = f44;
   HEAPF32[i5 >> 2] = f43;
   i3 = (HEAP32[i1 + 88 >> 2] | 0) + 102872 | 0;
   i2 = HEAP32[i1 + 100 >> 2] | 0;
   if (i2 | 0) {
    i4 = i1 + 12 | 0;
    do {
     __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i2, i3, i34, i4);
     i2 = HEAP32[i2 + 24 >> 2] | 0;
    } while ((i2 | 0) != 0);
   }
  }
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i33, i33);
 f47 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i41));
 i41 = i32 + 103024 | 0;
 HEAPF32[i41 >> 2] = f47;
 i36 = HEAP32[i36 >> 2] | 0;
 i41 = HEAP32[i40 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i36, i41);
 i41 = HEAP32[i39 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i36, i41);
 i41 = HEAP32[i38 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i36, i41);
 i41 = HEAP32[i37 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i36, i41);
 i41 = HEAP32[i35 >> 2] | 0;
 __ZN16b2StackAllocator4FreeEPv(i36, i41);
 STACKTOP = i42;
 return;
}

function __ZN14PhysicsManager24ProcessTriggerEnterExitsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i39 + 28 | 0;
 i21 = i39;
 i31 = i39 + 8 | 0;
 if ((HEAP16[gb + 1452548 + 6 >> 1] | 0) > -1) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i16 >> 2] = HEAP32[i21 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452548 | 0, i16);
  i37 = gb + 1452548 | 0;
 } else i37 = 0;
 i35 = i4 + 68 | 0;
 i38 = i4 + 72 | 0;
 i5 = HEAP32[i38 >> 2] | 0;
 i2 = HEAP32[i35 >> 2] | 0;
 i3 = i2;
 i1 = i5;
 if ((i5 | 0) == (i2 | 0)) i2 = i5; else {
  i22 = i21 + 4 | 0;
  i17 = i31 + 4 | 0;
  i18 = i31 + 8 | 0;
  i19 = i31 + 12 | 0;
  i20 = i31 + 16 | 0;
  i23 = i4 + 136 | 0;
  i24 = i4 + 104 | 0;
  i25 = i4 + 108 | 0;
  i26 = i4 + 140 | 0;
  i27 = i4 + 148 | 0;
  i28 = i4 + 160 | 0;
  i29 = i4 + 164 | 0;
  i30 = i4 + 152 | 0;
  i32 = i4 + 116 | 0;
  i33 = i4 + 128 | 0;
  i34 = i4 + 132 | 0;
  i15 = i4 + 120 | 0;
  i14 = 0;
  i4 = 0;
  do {
   i12 = i3 + (i14 * 12 | 0) + 8 | 0;
   i13 = i3 + (i14 * 12 | 0) + 4 | 0;
   i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i6 + 36 >> 2] | 0;
   HEAP32[i21 >> 2] = i11;
   HEAP32[i22 >> 2] = i9;
   i8 = i11;
   if (!((i11 | 0) == 0 | (i9 | 0) == 0)) {
    L10 : do switch (HEAP32[i3 + (i14 * 12 | 0) >> 2] | 0) {
    case 4:
     {
      i1 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0) | 0;
      i1 = HEAP32[((i1 | 0) == 0 ? i6 : i1) + 28 >> 2] | 0;
      i11 = HEAP32[i13 >> 2] | 0;
      i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0;
      i2 = HEAP32[((i2 | 0) == 0 ? i11 : i2) + 28 >> 2] | 0;
      if (!(HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0) + 60 >> 2] & 512)) if (!(HEAP32[(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0) + 60 >> 2] & 512)) if (!(HEAP32[i1 + 60 >> 2] & 512)) if (!(HEAP32[i2 + 60 >> 2] & 512)) {
       i11 = __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_(i23, i21) | 0;
       i9 = HEAP32[i13 >> 2] | 0;
       i10 = HEAP32[i12 >> 2] | 0;
       HEAP8[i11 >> 0] = 0;
       HEAP32[i11 + 4 >> 2] = i9;
       HEAP32[i11 + 8 >> 2] = i10;
      } else i36 = 16; else i36 = 16; else i36 = 16; else i36 = 16;
      if ((i36 | 0) == 16) {
       i36 = 0;
       i11 = __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_(i24, i21) | 0;
       i9 = HEAP32[i13 >> 2] | 0;
       i10 = HEAP32[i12 >> 2] | 0;
       HEAP8[i11 >> 0] = 0;
       HEAP32[i11 + 4 >> 2] = i9;
       HEAP32[i11 + 8 >> 2] = i10;
      }
      i6 = HEAP32[gb + 1104736 >> 2] | 0;
      i5 = HEAP32[gb + 1104736 + 4 >> 2] | 0;
      i3 = HEAP32[gb + 1104736 + 8 >> 2] | 0;
      i2 = HEAP32[gb + 1104736 + 12 >> 2] | 0;
      i1 = HEAP32[gb + 1104736 + 16 >> 2] | 0;
      break;
     }
    case 16:
     {
      i6 = HEAP32[gb + 1104756 >> 2] | 0;
      i5 = HEAP32[gb + 1104756 + 4 >> 2] | 0;
      i11 = HEAP32[gb + 1104756 + 8 >> 2] | 0;
      i2 = HEAP32[gb + 1104756 + 12 >> 2] | 0;
      i1 = HEAP32[gb + 1104756 + 16 >> 2] | 0;
      i3 = HEAP32[i25 >> 2] | 0;
      do if (i3 | 0) {
       i4 = i25;
       L22 : while (1) {
        i7 = i3;
        while (1) {
         i3 = HEAP32[i7 + 16 >> 2] | 0;
         if ((i3 | 0) == (i8 | 0)) {
          if ((HEAP32[i7 + 20 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
         } else if (i3 >>> 0 >= i8 >>> 0) break;
         i3 = HEAP32[i7 + 4 >> 2] | 0;
         if (!i3) break L22; else i7 = i3;
        }
        i3 = HEAP32[i7 >> 2] | 0;
        if (!i3) {
         i4 = i7;
         break;
        } else i4 = i7;
       }
       if ((i4 | 0) != (i25 | 0)) {
        i3 = HEAP32[i4 + 16 >> 2] | 0;
        if ((i8 | 0) == (i3 | 0)) {
         if (i9 >>> 0 < (HEAP32[i4 + 20 >> 2] | 0) >>> 0) break;
        } else if (i8 >>> 0 < i3 >>> 0) break;
        if (!((HEAP8[i4 + 24 >> 0] | 0) != 0 | (i4 | 0) == (i25 | 0))) {
         i3 = i4 + 24 | 0;
         if (!(HEAP8[i3 >> 0] | 0)) {
          HEAP8[i3 >> 0] = 1;
          i4 = i4 + 16 | 0;
          i7 = HEAP32[i33 >> 2] | 0;
          i8 = i7 + 1 | 0;
          i9 = HEAP32[i34 >> 2] | 0;
          i10 = i9 & 2147483647;
          do if (i8 >>> 0 > i10 >>> 0) {
           i3 = i9 << 1;
           i3 = (i3 | 0) == 0 ? 1 : i3;
           if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
            HEAP32[i34 >> 2] = i3;
            HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i3 << 3, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
            break;
           } else {
            i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
            _memcpy(i10 | 0, HEAP32[i32 >> 2] | 0, HEAP32[i33 >> 2] << 3 | 0) | 0;
            HEAP32[i34 >> 2] = i3;
            HEAP32[i32 >> 2] = i10;
            break;
           }
          } while (0);
          HEAP32[i33 >> 2] = i8;
          i8 = i4;
          i9 = HEAP32[i8 + 4 >> 2] | 0;
          i10 = (HEAP32[i32 >> 2] | 0) + (i7 << 3) | 0;
          HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
          HEAP32[i10 + 4 >> 2] = i9;
         }
        }
       }
      } while (0);
      i3 = HEAP32[i26 >> 2] | 0;
      if (!i3) i3 = i11; else {
       i8 = HEAP32[i21 >> 2] | 0;
       i9 = HEAP32[i22 >> 2] | 0;
       i4 = i26;
       L48 : while (1) {
        i7 = i3;
        while (1) {
         i3 = HEAP32[i7 + 16 >> 2] | 0;
         if ((i3 | 0) == (i8 | 0)) {
          if ((HEAP32[i7 + 20 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
         } else if (i3 >>> 0 >= i8 >>> 0) break;
         i3 = HEAP32[i7 + 4 >> 2] | 0;
         if (!i3) break L48; else i7 = i3;
        }
        i3 = HEAP32[i7 >> 2] | 0;
        if (!i3) {
         i4 = i7;
         break;
        } else i4 = i7;
       }
       if ((i4 | 0) == (i26 | 0)) i3 = i11; else {
        i3 = HEAP32[i4 + 16 >> 2] | 0;
        if ((i8 | 0) == (i3 | 0)) {
         if (i9 >>> 0 < (HEAP32[i4 + 20 >> 2] | 0) >>> 0) {
          i3 = i11;
          break L10;
         }
        } else if (i8 >>> 0 < i3 >>> 0) {
         i3 = i11;
         break L10;
        }
        if ((HEAP8[i4 + 24 >> 0] | 0) != 0 | (i4 | 0) == (i26 | 0)) i3 = i11; else {
         i3 = i4 + 24 | 0;
         if (!(HEAP8[i3 >> 0] | 0)) {
          HEAP8[i3 >> 0] = 1;
          i4 = i4 + 16 | 0;
          i7 = HEAP32[i28 >> 2] | 0;
          i8 = i7 + 1 | 0;
          i9 = HEAP32[i29 >> 2] | 0;
          i10 = i9 & 2147483647;
          do if (i8 >>> 0 > i10 >>> 0) {
           i3 = i9 << 1;
           i3 = (i3 | 0) == 0 ? 1 : i3;
           if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
            HEAP32[i29 >> 2] = i3;
            HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i3 << 3, 4, i30, 0, gb + 1047584 | 0, 464) | 0;
            break;
           } else {
            i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i30, 0, gb + 1047584 | 0, 446) | 0;
            _memcpy(i10 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i28 >> 2] << 3 | 0) | 0;
            HEAP32[i29 >> 2] = i3;
            HEAP32[i27 >> 2] = i10;
            break;
           }
          } while (0);
          HEAP32[i28 >> 2] = i8;
          i9 = i4;
          i10 = HEAP32[i9 + 4 >> 2] | 0;
          i3 = (HEAP32[i27 >> 2] | 0) + (i7 << 3) | 0;
          HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
          HEAP32[i3 + 4 >> 2] = i10;
          i3 = i11;
         } else i3 = i11;
        }
       }
      }
      break;
     }
    default:
     {
      i6 = 0;
      i5 = 0;
      i3 = -1;
      i2 = i4;
      i1 = 1;
     }
    } while (0);
    i13 = HEAP32[i13 >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    HEAP32[i31 >> 2] = i6;
    HEAP32[i17 >> 2] = i5;
    HEAP32[i18 >> 2] = i3;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i20 >> 2] = i1;
    HEAP32[i16 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
    HEAP32[i16 + 16 >> 2] = HEAP32[i31 + 16 >> 2];
    __ZL16SendTriggerEventP8ColliderS0_17MessageIdentifier(i13, i4, i16);
    i1 = HEAP32[i38 >> 2] | 0;
    i4 = i2;
    i5 = i1;
    i2 = HEAP32[i35 >> 2] | 0;
   }
   i14 = i14 + 1 | 0;
   i3 = i2;
  } while (i14 >>> 0 < ((i5 - i2 | 0) / 12 | 0) >>> 0);
 }
 if ((i1 | 0) != (i3 | 0)) HEAP32[i38 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
 if (!i37) {
  STACKTOP = i39;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i37);
 STACKTOP = i39;
 return;
}

function __ZN9Texture2D13UploadTextureEv(i25) {
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 24 | 0;
 i2 = i28 + 4 | 0;
 i16 = i28;
 i14 = i28 + 16 | 0;
 i22 = i28 + 12 | 0;
 i26 = i28 + 8 | 0;
 i27 = i25 + 52 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410870 | 0, 0, gb + 410682 | 0, 586, 1, HEAP32[i25 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i28;
  return;
 }
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 if (!(HEAP32[i1 + 32 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 __ZN9Texture2D25CreateScaledAndPaddedDataEPP17SharedTextureDataS2_(i25, i2, i16);
 i17 = HEAP32[i25 + 56 >> 2] | 0;
 i13 = (i17 | 0) == 6;
 i12 = __Z20push_allocation_rootPvP13BaseAllocatorb(i25, 0, 0) | 0;
 if (i13) {
  i21 = HEAP32[i2 >> 2] | 0;
  i23 = HEAP32[i21 + 28 >> 2] | 0;
  HEAP32[i25 + 96 >> 2] = i23;
  i21 = HEAP32[i21 + 32 >> 2] | 0;
  HEAP32[i25 + 100 >> 2] = i21;
  f29 = Math_fround(Math_fround(1.0) / Math_fround(i21 | 0));
  HEAPF32[i25 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i23 | 0));
  HEAPF32[i25 + 72 >> 2] = f29;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 112 >> 2] | 0, i25 | 0) | 0) i19 = __Z22CalculateMipMapCount3Diii(HEAP32[i25 + 96 >> 2] | 0, HEAP32[i25 + 100 >> 2] | 0, 1) | 0; else i19 = 1;
 i18 = HEAP32[gb + 1158376 >> 2] | 0;
 i23 = i25 + 111 | 0;
 i7 = (HEAP8[i23 >> 0] | 0) == 0 ? 1 : 17;
 i21 = i25 + 48 | 0;
 i8 = HEAP32[i21 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 i2 = HEAP32[i11 + 40 >> 2] | 0;
 i9 = i11 + 28 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i11 + 32 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 + 36 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i6 = HEAP32[i25 + 60 >> 2] | 0; else i6 = 0;
 i20 = __Z21GetUncheckedGfxDevicev() | 0;
 HEAP32[i24 >> 2] = i8;
 HEAP32[i24 + 4 >> 2] = i1;
 HEAP32[i24 + 8 >> 2] = i2;
 HEAP32[i24 + 12 >> 2] = i3;
 HEAP32[i24 + 16 >> 2] = i4;
 HEAP32[i24 + 20 >> 2] = i19;
 HEAP32[i24 + 24 >> 2] = i5;
 HEAP32[i24 + 28 >> 2] = i7;
 HEAP32[i24 + 32 >> 2] = i17;
 HEAP32[i24 + 36 >> 2] = i6;
 HEAP32[i24 + 40 >> 2] = i18;
 HEAP32[i24 + 44 >> 2] = i20;
 __Z19UploadTexture2DDataRK23UploadTextureDataParams(i24) | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i20 = i25;
 i6 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i24 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 14;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 19;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 18;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 14) {
   HEAP32[i24 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 18) {
   HEAP32[i24 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 19) {
   HEAP32[i24 >> 2] = i1;
   i4 = i1;
   i3 = i24;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i20;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
  i15 = i6 + 8 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 if (!(i15 + -1 & i15)) {
  i4 = HEAP32[i10 >> 2] | 0;
  i4 = (i4 + -1 & i4 | 0) != 0;
 } else i4 = 1;
 i15 = i25 + 32 | 0;
 HEAP32[i14 >> 2] = HEAP32[i21 >> 2];
 i1 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 148 >> 2] | 0, i25 | 0) | 0;
 i2 = (HEAP32[i11 + 48 >> 2] | 0) > 1;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i3 = HEAP32[i25 + 60 >> 2] | 0; else i3 = 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 120 >> 2] | 0, i25 | 0) | 0;
 HEAP32[i24 >> 2] = HEAP32[i14 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i15, i24, i1, i2, i3, i10, i4);
 HEAP8[i25 + 109 >> 0] = 1;
 i14 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 292 >> 2] | 0, i14 | 0, i11 | 0);
 if (i12) __Z19pop_allocation_rootv();
 i1 = HEAP32[i27 >> 2] | 0;
 if ((HEAP32[i1 + 28 >> 2] | 0) == (HEAP32[i25 + 96 >> 2] | 0)) if (i13 | (HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[i25 + 100 >> 2] | 0)) i2 = 55; else i2 = 34; else if (i13) i2 = 55; else i2 = 34;
 if ((i2 | 0) == 34) {
  HEAP8[i25 + 110 >> 0] = 1;
  i9 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 96 >> 2] | 0, i25 | 0) | 0;
  i10 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i10 + 8 >> 2] | 0;
  i2 = HEAP32[i10 + 40 >> 2] | 0;
  i7 = i10 + 28 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = i10 + 32 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i10 + 36 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i6 = HEAP32[i25 + 60 >> 2] | 0; else i6 = 0;
  i16 = __Z21GetUncheckedGfxDevicev() | 0;
  HEAP32[i24 >> 2] = i9;
  HEAP32[i24 + 4 >> 2] = i1;
  HEAP32[i24 + 8 >> 2] = i2;
  HEAP32[i24 + 12 >> 2] = i3;
  HEAP32[i24 + 16 >> 2] = i4;
  HEAP32[i24 + 20 >> 2] = i19;
  HEAP32[i24 + 24 >> 2] = i5;
  HEAP32[i24 + 28 >> 2] = 1;
  HEAP32[i24 + 32 >> 2] = i17;
  HEAP32[i24 + 36 >> 2] = i6;
  HEAP32[i24 + 40 >> 2] = i18;
  HEAP32[i24 + 44 >> 2] = i16;
  __Z19UploadTexture2DDataRK23UploadTextureDataParams(i24) | 0;
  i5 = HEAP32[gb + 1158372 >> 2] | 0;
  i2 = i5 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  do if (!i1) {
   HEAP32[i24 >> 2] = i2;
   i4 = i2;
   i3 = i2;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i9 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 39;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i9 >>> 0) {
      i2 = 44;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 43;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 39) {
    HEAP32[i24 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 43) {
    HEAP32[i24 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 44) {
    HEAP32[i24 >> 2] = i1;
    i4 = i1;
    i3 = i24;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(24) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i20;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i5 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i1);
   i20 = i5 + 8 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
  }
  i20 = HEAP32[i7 >> 2] | 0;
  if (!(i20 + -1 & i20)) {
   i4 = HEAP32[i8 >> 2] | 0;
   i4 = (i4 + -1 & i4 | 0) != 0;
  } else i4 = 1;
  HEAP32[i22 >> 2] = i9;
  i1 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 148 >> 2] | 0, i25 | 0) | 0;
  i2 = (HEAP32[i10 + 48 >> 2] | 0) > 1;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i3 = HEAP32[i25 + 60 >> 2] | 0; else i3 = 0;
  i20 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 120 >> 2] | 0, i25 | 0) | 0;
  HEAP32[i24 >> 2] = HEAP32[i22 >> 2];
  __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i15, i24, i1, i2, i3, i20, i4);
  i22 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 292 >> 2] | 0, i22 | 0, i10 | 0);
 } else if ((i2 | 0) == 55) {
  i1 = HEAP32[i16 >> 2] | 0;
  i22 = i1 + 4 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
  if (!(HEAP32[i22 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
 }
 i22 = __Z12GetGfxDevicev() | 0;
 i20 = HEAP32[(HEAP32[i22 >> 2] | 0) + 680 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
 i25 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 36 >> 2] | 0, i25 | 0) | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 mftCall_viii(i20 | 0, i22 | 0, i24 | 0, i25 | 0);
 if (!(HEAP8[i23 >> 0] | 0)) {
  i1 = HEAP32[i27 >> 2] | 0;
  if (i1 | 0) {
   i26 = i1 + 4 | 0;
   HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + -1;
   if (!(HEAP32[i26 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
   }
   HEAP32[i27 >> 2] = 0;
  }
 }
 STACKTOP = i28;
 return;
}

function __ZN9InputAxis8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 16 | 0;
 i4 = i9;
 i1 = i8 + 4 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i8 + 24 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i8 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i4, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i2 = i4 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i6 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, i6);
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i3) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i8 + 60 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i4, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i2 = i4 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i6 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, i6);
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i3) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i8 + 56 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i4, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i2 = i4 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i6 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, i6);
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i3) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i8 + 68 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i4, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i2 = i4 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i5 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i6 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, i6);
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0)) i1 = 0; else {
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i3) | 0;
  if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) i1 = 0; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 }
 HEAP32[i8 + 64 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 i1 = i8 + 92 | 0;
 i6 = i7 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 96 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 100 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 104 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i8 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i8 + 76 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
  STACKTOP = i9;
  return;
 }
}

function __ZN7Terrain8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i4 = i3 + 16 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1016773 | 0, gb + 1016787 | 0, i4, 0);
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i4, 1);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931579 | 0, i9, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931594 | 0, i9, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931618 | 0, i9, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931640 | 0, i7, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931666 | 0, i9, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931689 | 0, i9, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931711 | 0, i9, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931733 | 0, i9, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931752 | 0, i9, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931774 | 0, i7, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931788 | 0, i7, i1 + 89 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931804 | 0, i7, i1 + 90 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 92 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931826 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 96 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931849 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931864 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931881 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931899 | 0, gb + 946436 | 0, i4, 0);
 i7 = i8 + 8 | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 152 | 0;
 i4 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931918 | 0, i4, i7, 8388609);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931934 | 0, i4, i7 + 2 | 0, 8388609);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 120 | 0;
 i4 = HEAP32[gb + 37328 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931957 | 0, i4, i7, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 136 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931980 | 0, i4, i7, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932010 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 188 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = i1 + 156 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932036 | 0, i4, i5, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 172 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932050 | 0, i4, i1, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14SoundHandleAPI7SetDataEPKfjj(i5, i1, i3, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 56 | 0;
 i11 = i21 + 40 | 0;
 i7 = i21 + 32 | 0;
 i8 = i21 + 16 | 0;
 i4 = i21;
 i19 = i21 + 104 | 0;
 i13 = i21 + 100 | 0;
 i12 = i21 + 96 | 0;
 i10 = i21 + 92 | 0;
 i17 = i21 + 88 | 0;
 i18 = i21 + 84 | 0;
 i14 = i21 + 80 | 0;
 i15 = i21 + 76 | 0;
 i6 = i21 + 72 | 0;
 if (!i5) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i16 = i5 + 40 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if (!i2) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (HEAP32[i5 + 48 >> 2] & 128 | 0) {
  i1 = HEAP32[i5 + 52 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 870859 | 0, 0, gb + 853741 | 0, 388, 1, i1, 0, 0);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (HEAP32[i5 + 56 >> 2] & 1 | 0) {
  i1 = HEAP32[i5 + 52 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 871146 | 0, 0, gb + 853741 | 0, 394, 1, i1, 0, 0);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(i2, 0, i13, i12, i10) | 0;
 if (i2 | 0) {
  i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 400;
  HEAP32[i4 + 8 >> 2] = gb + 871179;
  HEAP32[i4 + 12 >> 2] = i2;
  __Z6FormatPKcz(i19, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 }
 switch (HEAP32[i13 >> 2] | 0) {
 case 5:
 case 3:
 case 2:
 case 1:
  {
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i2 = __ZN4FMOD5Sound9getLengthEPjj(HEAP32[i16 >> 2] | 0, i6, 2) | 0;
   if (i2 | 0) {
    i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
    HEAP32[i8 >> 2] = gb + 853741;
    HEAP32[i8 + 4 >> 2] = 426;
    HEAP32[i8 + 8 >> 2] = gb + 871367;
    HEAP32[i8 + 12 >> 2] = i4;
    __Z6FormatPKcz(i19, gb + 883334 | 0, i8);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
   }
   if ((HEAP32[i6 >> 2] | 0) >>> 0 < i3 >>> 0) {
    i8 = HEAP32[i5 + 52 >> 2] | 0;
    i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
    i3 = i3 - (HEAP32[i6 >> 2] | 0) | 0;
    HEAP32[i7 >> 2] = i8;
    HEAP32[i7 + 4 >> 2] = i3;
    __Z6FormatPKcz(i19, gb + 871433 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 853741 | 0, 431, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i3 = HEAP32[i6 >> 2] | 0;
   }
   i8 = HEAP32[i12 >> 2] | 0;
   i9 = Math_imul(i8, i9) | 0;
   i2 = (HEAP32[i10 >> 2] | 0) / 8 | 0;
   i10 = Math_imul(i9, i2) | 0;
   i2 = Math_imul(Math_imul(i8, i3) | 0, i2) | 0;
   i2 = __ZN4FMOD5Sound4lockEjjPPvS2_PjS3_(HEAP32[i16 >> 2] | 0, i10, i2, i17, i18, i14, i15) | 0;
   if (!i2) {
    i4 = HEAP32[i13 >> 2] | 0;
    L38 : do if (!(HEAP32[i18 >> 2] | 0)) {
     i3 = Math_imul(HEAP32[i12 >> 2] | 0, i3) | 0;
     i5 = i1 + (i3 << 2) | 0;
     i2 = HEAP32[i17 >> 2] | 0;
     switch (i4 | 0) {
     case 1:
      {
       if (!i3) break L38;
       while (1) {
        HEAP8[i2 >> 0] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(128.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 1 | 0;
       }
       break;
      }
     case 2:
      {
       if (!i3) break L38;
       while (1) {
        HEAP16[i2 >> 1] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(32768.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 2 | 0;
       }
       break;
      }
     case 4:
      {
       if (!i3) break L38;
       while (1) {
        HEAP32[i2 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(-2147483650.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
       }
       break;
      }
     case 5:
      {
       _memcpy(i2 | 0, i1 | 0, i3 << 2 | 0) | 0;
       break L38;
      }
     default:
      break L38;
     }
    } else {
     i3 = (HEAP32[i14 >> 2] | 0) >>> 2;
     i5 = i1 + (i3 << 2) | 0;
     i2 = HEAP32[i17 >> 2] | 0;
     switch (i4 | 0) {
     case 1:
      {
       if (i3 | 0) {
        i3 = i1;
        while (1) {
         HEAP8[i2 >> 0] = ~~Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(128.0));
         i3 = i3 + 4 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 1 | 0;
        }
       }
       break;
      }
     case 2:
      {
       if (i3 | 0) {
        i3 = i1;
        while (1) {
         HEAP16[i2 >> 1] = ~~Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(32768.0));
         i3 = i3 + 4 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 2 | 0;
        }
       }
       break;
      }
     case 4:
      {
       if (i3 | 0) {
        i3 = i1;
        while (1) {
         HEAP32[i2 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(-2147483650.0));
         i3 = i3 + 4 | 0;
         if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
        }
       }
       break;
      }
     case 5:
      {
       _memcpy(i2 | 0, i1 | 0, i3 << 2 | 0) | 0;
       break;
      }
     default:
      {}
     }
     i4 = HEAP32[i14 >> 2] | 0;
     i3 = i4 >>> 2;
     i5 = i1 + (i3 << 2) | 0;
     i4 = ((HEAP32[i15 >> 2] | 0) + i4 | 0) >>> 2;
     i6 = i1 + (i4 << 2) | 0;
     i2 = HEAP32[i18 >> 2] | 0;
     switch (HEAP32[i13 >> 2] | 0) {
     case 1:
      {
       if ((i3 | 0) == (i4 | 0)) break L38; else i1 = i5;
       while (1) {
        HEAP8[i2 >> 0] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(128.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i6 | 0)) break; else i2 = i2 + 1 | 0;
       }
       break;
      }
     case 2:
      {
       if ((i3 | 0) == (i4 | 0)) break L38;
       i1 = i5;
       while (1) {
        HEAP16[i2 >> 1] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(32768.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i6 | 0)) break; else i2 = i2 + 2 | 0;
       }
       break;
      }
     case 4:
      {
       if ((i3 | 0) == (i4 | 0)) break L38;
       i1 = i5;
       while (1) {
        HEAP32[i2 >> 2] = ~~Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(-2147483650.0));
        i1 = i1 + 4 | 0;
        if ((i1 | 0) == (i6 | 0)) break; else i2 = i2 + 4 | 0;
       }
       break;
      }
     case 5:
      {
       _memcpy(i2 | 0, i5 | 0, i6 - i5 | 0) | 0;
       break L38;
      }
     default:
      break L38;
     }
    } while (0);
    i1 = __ZN4FMOD5Sound6unlockEPvS1_jj(HEAP32[i16 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
    if (!i1) i1 = 1; else {
     i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
     HEAP32[i20 >> 2] = gb + 853741;
     HEAP32[i20 + 4 >> 2] = 456;
     HEAP32[i20 + 8 >> 2] = gb + 871583;
     HEAP32[i20 + 12 >> 2] = i1;
     __Z6FormatPKcz(i19, gb + 883334 | 0, i20);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
     i1 = 1;
    }
   } else {
    i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
    HEAP32[i11 >> 2] = gb + 853741;
    HEAP32[i11 + 4 >> 2] = 442;
    HEAP32[i11 + 8 >> 2] = gb + 871496;
    HEAP32[i11 + 12 >> 2] = i1;
    __Z6FormatPKcz(i19, gb + 883334 | 0, i11);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i1 = 0;
   }
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 52 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 871253 | 0, 0, gb + 853741 | 0, 409, 1, i1, 0, 0);
   i1 = 0;
  }
 }
 i20 = i1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN5Unity14CharacterJoint8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 32 | 0;
 i3 = i10 + 16 | 0;
 i4 = i10;
 __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_(i8, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i2 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734686 | 0, HEAP32[gb + 37324 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i9, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734698 | 0, gb + 734714 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734736 | 0, gb + 734714 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i4, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i5 = i3 + 8 | 0;
  i2 = i4 + 8 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i1 = f11 < Math_fround(HEAPF32[i2 >> 2]);
  HEAP32[i8 + 108 >> 2] = HEAP32[(i1 ? i2 : i5) >> 2];
  i5 = i3 + 12 | 0;
  i2 = i4 + 12 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i1 = f11 < Math_fround(HEAPF32[i2 >> 2]);
  HEAP32[i8 + 112 >> 2] = HEAP32[(i1 ? i2 : i5) >> 2];
  HEAPF32[i8 + 124 >> 2] = Math_fround(0.0);
  HEAP32[i8 + 116 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 120 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAPF32[i8 + 136 >> 2] = Math_fround(0.0);
  HEAP32[i8 + 128 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 132 >> 2] = HEAP32[i4 + 4 >> 2];
 } else {
  i2 = i8 + 108 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734753 | 0, gb + 734772 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i2 = i8 + 116 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734698 | 0, gb + 734793 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i2 = i8 + 128 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734736 | 0, gb + 734793 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i9, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734808 | 0, gb + 734714 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734822 | 0, gb + 734714 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i4, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i5 = i3 + 8 | 0;
  i2 = i4 + 8 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i1 = f11 < Math_fround(HEAPF32[i2 >> 2]);
  HEAP32[i8 + 140 >> 2] = HEAP32[(i1 ? i2 : i5) >> 2];
  i5 = i3 + 12 | 0;
  i2 = i4 + 12 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  i1 = f11 < Math_fround(HEAPF32[i2 >> 2]);
  HEAP32[i8 + 144 >> 2] = HEAP32[(i1 ? i2 : i5) >> 2];
  HEAPF32[i8 + 156 >> 2] = Math_fround(0.0);
  HEAP32[i8 + 148 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 152 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAPF32[i8 + 168 >> 2] = Math_fround(0.0);
  HEAP32[i8 + 160 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 164 >> 2] = HEAP32[i4 + 4 >> 2];
 } else {
  i2 = i8 + 140 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734836 | 0, gb + 734772 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i2 = i8 + 148 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734808 | 0, gb + 734793 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i2 = i8 + 160 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734822 | 0, gb + 734793 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
 }
 i3 = i8 + 172 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734855 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 176 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734874 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 87; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 87; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 87) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734895 | 0, i5, i6, 0) | 0;
 if (!i1) {
  __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i8, i9);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i6 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 98; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 98; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 98) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i3 = i6 + 1332 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 1336 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 1340 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 1344 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 1348 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1349 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1350 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1351 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1352 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1353 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1354 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1355 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1356 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1357 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1358 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1359 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1360 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1361 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1362 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1363 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1364 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1365 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1366 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1367 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1368 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1369 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1370 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1371 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1372 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1373 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1374 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 1375 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 }
}

function __ZN13BuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i8 = i14;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i10 + 28 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i10 + 52 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i10 + 64 | 0, 0);
 i1 = i10 + 108 | 0;
 i13 = i9 + 16 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i12 = i9 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 111 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 112 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 113 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 114 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 115 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 116 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 117 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 118 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 109 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 110 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 119 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 120 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 121 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i6 = i10 + 140 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i10 + 144 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i11 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i11, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i6 = i10 + 124 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i10 + 128 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i11 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i11, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i6 = i10 + 84 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i10 + 80 >> 2] | 0;
 i2 = (i5 - i1 | 0) / 24 | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i13 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i8, 4);
  i1 = HEAP32[i10 + 80 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i5 | 0)) {
  i4 = i1;
  do {
   HEAP32[i11 >> 2] = -1;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i3 = -1; else {
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    HEAP32[i11 >> 2] = i3;
   }
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i13 >> 2] = i2;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i11, 4);
   __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 8 | 0, i9);
   i4 = i4 + 24 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i6 = i10 + 100 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i10 + 96 >> 2] | 0;
 i3 = i2 - i1 >> 5;
 HEAP32[i11 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i11, 4);
  i1 = HEAP32[i10 + 96 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 16 | 0, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i10 + 168 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i11, 4);
 i1 = HEAP32[i10 + 156 >> 2] | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i11 << 2) | 0;
 if (!i11) {
  STACKTOP = i14;
  return;
 }
 do {
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i14;
 return;
}

function __ZN13PhysicsModule28GetCollisionShapeForColliderEPKN5Unity9ComponentERN8IPhysics13ColliderShapeE(i1, i12, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 32 | 0;
 i7 = i11 + 16 | 0;
 i5 = i11;
 if (!i12) {
  i13 = 0;
  STACKTOP = i11;
  return i13 | 0;
 }
 i1 = i12 + 8 | 0;
 if ((((HEAP32[i1 >> 2] | 0) >>> 21) - (HEAP32[gb + 32548 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 32548 + 28 >> 2] | 0) >>> 0) {
  i13 = 0;
  STACKTOP = i11;
  return i13 | 0;
 }
 i4 = i12 + 28 | 0;
 i10 = __ZNK10GameObject23QueryComponentTransformEv(HEAP32[i4 >> 2] | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) >>> 21;
 if ((i1 - (HEAP32[gb + 112968 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 112968 + 28 >> 2] | 0) >>> 0) {
  i6 = __ZNK12MeshCollider13GetSharedMeshEv(i12) | 0;
  if (!i6) {
   i13 = 0;
   STACKTOP = i11;
   return i13 | 0;
  }
  HEAP32[i7 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i7);
    i4 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i4 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i8 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 12;
   }
  }
  if ((i8 | 0) == 10) i8 = 12;
  if ((i8 | 0) == 12) {
   i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
   if (!i1) {
    i13 = 0;
    STACKTOP = i11;
    return i13 | 0;
   }
  }
  __ZNK9Transform13GetWorldScaleEv(i9, i10);
  i7 = HEAP32[i9 >> 2] | 0;
  i8 = HEAP32[i9 + 16 >> 2] | 0;
  i9 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i13 + 4 >> 2] = 0;
  __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(i10, i13 + 8 | 0, i13 + 20 | 0);
  HEAP32[i13 + 36 >> 2] = i7;
  HEAP32[i13 + 40 >> 2] = i8;
  HEAP32[i13 + 44 >> 2] = i9;
  HEAP32[i13 + 48 >> 2] = i1;
  i13 = 1;
  STACKTOP = i11;
  return i13 | 0;
 } else {
  if ((i1 - (HEAP32[gb + 110912 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 110912 + 28 >> 2] | 0) >>> 0) {
   HEAP32[i13 >> 2] = i12;
   HEAP32[i13 + 4 >> 2] = 1;
   i8 = i13 + 8 | 0;
   __ZNK11BoxCollider15GetGlobalCenterEv(i9, i12);
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i8 = i13 + 20 | 0;
   __ZNK9Transform11GetRotationEv(i9, i10);
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i9, i12, gb + 62512 | 0);
   f14 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
   f2 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) * Math_fround(2.0));
   f3 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(2.0));
   HEAPF32[i13 + 36 >> 2] = f14;
   HEAPF32[i13 + 40 >> 2] = f2;
   HEAPF32[i13 + 44 >> 2] = f3;
   HEAP32[i13 + 48 >> 2] = 0;
   i13 = 1;
   STACKTOP = i11;
   return i13 | 0;
  }
  if ((i1 - (HEAP32[gb + 113668 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 113668 + 28 >> 2] | 0) >>> 0) {
   __ZNK9Transform18GetWorldScaleLossyEv(i9, i10);
   f14 = Math_fround(HEAPF32[i9 >> 2]);
   i8 = f14 < Math_fround(0.0);
   f16 = Math_fround(-f14);
   f14 = i8 ? f16 : f14;
   f16 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   i8 = f16 < Math_fround(0.0);
   f3 = Math_fround(-f16);
   f16 = i8 ? f3 : f16;
   f3 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   i8 = f3 < Math_fround(0.0);
   f2 = Math_fround(-f3);
   f3 = i8 ? f2 : f3;
   f2 = Math_fround(HEAPF32[i12 + 60 >> 2]);
   i8 = f2 < Math_fround(0.0);
   f15 = Math_fround(-f2);
   f14 = f14 < f16 ? f16 : f14;
   f14 = Math_fround(Math_fround((i8 ? f15 : f2) * (f14 < f3 ? f3 : f14)) * Math_fround(2.0));
   HEAP32[i13 >> 2] = i12;
   HEAP32[i13 + 4 >> 2] = 2;
   i8 = i13 + 8 | 0;
   __ZNK9Transform14TransformPointERK8Vector3f(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0, i12 + 64 | 0);
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i12 = i13 + 20 | 0;
   __ZNK9Transform11GetRotationEv(i9, i10);
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAPF32[i13 + 36 >> 2] = f14;
   HEAPF32[i13 + 40 >> 2] = f14;
   HEAPF32[i13 + 44 >> 2] = f14;
   HEAP32[i13 + 48 >> 2] = 0;
   i13 = 1;
   STACKTOP = i11;
   return i13 | 0;
  }
  if ((i1 - (HEAP32[gb + 64328 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 64328 + 28 >> 2] | 0) >>> 0) {
   i13 = 0;
   STACKTOP = i11;
   return i13 | 0;
  }
  __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f(i9, i12, gb + 62512 | 0);
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  f3 = Math_fround(f3 * Math_fround(2.0));
  f2 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) + f3);
  i9 = HEAP32[i12 + 68 >> 2] | 0;
  __ZNK9Transform11GetRotationEv(i7, i10);
  switch (i9 | 0) {
  case 0:
   {
    __Z16FromToQuaternionRK8Vector3fS1_(i5, gb + 62536 | 0, gb + 62524 | 0);
    i10 = i7 + 12 | 0;
    f24 = Math_fround(HEAPF32[i10 >> 2]);
    f22 = Math_fround(HEAPF32[i5 >> 2]);
    f19 = Math_fround(f24 * f22);
    f21 = Math_fround(HEAPF32[i7 >> 2]);
    f23 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    f19 = Math_fround(f19 + Math_fround(f21 * f23));
    i8 = i7 + 4 | 0;
    f20 = Math_fround(HEAPF32[i8 >> 2]);
    f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f19 = Math_fround(f19 + Math_fround(f20 * f16));
    i9 = i7 + 8 | 0;
    f18 = Math_fround(HEAPF32[i9 >> 2]);
    f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f14 = Math_fround(Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f23 * f20) + Math_fround(f24 * f17))) - Math_fround(f21 * f16));
    f15 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f16) + Math_fround(f23 * f18)) + Math_fround(f21 * f17)) - Math_fround(f22 * f20));
    f16 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f17)) - Math_fround(f16 * f18));
    HEAPF32[i7 >> 2] = Math_fround(f19 - Math_fround(f18 * f17));
    HEAPF32[i8 >> 2] = f14;
    HEAPF32[i9 >> 2] = f15;
    HEAPF32[i10 >> 2] = f16;
    break;
   }
  case 2:
   {
    __Z16FromToQuaternionRK8Vector3fS1_(i5, gb + 62536 | 0, gb + 62548 | 0);
    i10 = i7 + 12 | 0;
    f14 = Math_fround(HEAPF32[i10 >> 2]);
    f16 = Math_fround(HEAPF32[i5 >> 2]);
    f19 = Math_fround(f14 * f16);
    f17 = Math_fround(HEAPF32[i7 >> 2]);
    f15 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    f19 = Math_fround(f19 + Math_fround(f17 * f15));
    i8 = i7 + 4 | 0;
    f18 = Math_fround(HEAPF32[i8 >> 2]);
    f24 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f19 = Math_fround(f19 + Math_fround(f18 * f24));
    i9 = i7 + 8 | 0;
    f20 = Math_fround(HEAPF32[i9 >> 2]);
    f21 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f22 = Math_fround(Math_fround(Math_fround(f16 * f20) + Math_fround(Math_fround(f15 * f18) + Math_fround(f14 * f21))) - Math_fround(f17 * f24));
    f23 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f24) + Math_fround(f15 * f20)) + Math_fround(f17 * f21)) - Math_fround(f16 * f18));
    f24 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f17)) - Math_fround(f18 * f21)) - Math_fround(f24 * f20));
    HEAPF32[i7 >> 2] = Math_fround(f19 - Math_fround(f20 * f21));
    HEAPF32[i8 >> 2] = f22;
    HEAPF32[i9 >> 2] = f23;
    HEAPF32[i10 >> 2] = f24;
    break;
   }
  default:
   {}
  }
  HEAP32[i13 >> 2] = i12;
  HEAP32[i13 + 4 >> 2] = 3;
  i10 = i13 + 8 | 0;
  __ZNK15CapsuleCollider15GetGlobalCenterEv(i5, i12);
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i12 = i13 + 20 | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAPF32[i13 + 36 >> 2] = f3;
  HEAPF32[i13 + 40 >> 2] = f2;
  HEAPF32[i13 + 44 >> 2] = f3;
  HEAP32[i13 + 48 >> 2] = 0;
  i13 = 1;
  STACKTOP = i11;
  return i13 | 0;
 }
 return 0;
}
function __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i2, i5, i1, i32, i31) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i32 = i32 | 0;
 i31 = i31 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0;
 i3 = (i31 | 0) != 0;
 if (i3) if (!(HEAP16[i2 + 84 >> 1] | 0)) {
  f8 = Math_fround(HEAPF32[i2 + 80 >> 2]);
  f11 = Math_fround(f8 * Math_fround(HEAPF32[i31 >> 2]));
  f12 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 4 >> 2]));
  f13 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 8 >> 2]));
  f14 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 12 >> 2]));
  f15 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 16 >> 2]));
  f16 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 20 >> 2]));
  f17 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 24 >> 2]));
  f18 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 28 >> 2]));
  f19 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 32 >> 2]));
  f9 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 36 >> 2]));
  f10 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 40 >> 2]));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i31 + 44 >> 2]));
  if (i1 >>> 0 >= i32 >>> 0) return;
  i3 = HEAP32[i5 + 120 >> 2] | 0;
  i4 = HEAP32[i5 + 140 >> 2] | 0;
  i2 = HEAP32[i5 + 160 >> 2] | 0;
  do {
   i20 = i3 + (i1 << 2) | 0;
   f44 = Math_fround(HEAPF32[i20 >> 2]);
   i21 = i20 + 4 | 0;
   f43 = Math_fround(HEAPF32[i21 >> 2]);
   i22 = i20 + 8 | 0;
   f42 = Math_fround(HEAPF32[i22 >> 2]);
   i23 = i20 + 12 | 0;
   f41 = Math_fround(HEAPF32[i23 >> 2]);
   i24 = i4 + (i1 << 2) | 0;
   f40 = Math_fround(HEAPF32[i24 >> 2]);
   i25 = i24 + 4 | 0;
   f39 = Math_fround(HEAPF32[i25 >> 2]);
   i26 = i24 + 8 | 0;
   f38 = Math_fround(HEAPF32[i26 >> 2]);
   i27 = i24 + 12 | 0;
   f37 = Math_fround(HEAPF32[i27 >> 2]);
   i28 = i2 + (i1 << 2) | 0;
   f36 = Math_fround(HEAPF32[i28 >> 2]);
   i29 = i28 + 4 | 0;
   f35 = Math_fround(HEAPF32[i29 >> 2]);
   i30 = i28 + 8 | 0;
   f34 = Math_fround(HEAPF32[i30 >> 2]);
   i31 = i28 + 12 | 0;
   f43 = Math_fround(f12 + f43);
   f42 = Math_fround(f13 + f42);
   f41 = Math_fround(f14 + f41);
   f40 = Math_fround(f15 + f40);
   f39 = Math_fround(f16 + f39);
   f38 = Math_fround(f17 + f38);
   f37 = Math_fround(f18 + f37);
   f36 = Math_fround(f19 + f36);
   f35 = Math_fround(f9 + f35);
   f34 = Math_fround(f10 + f34);
   f33 = Math_fround(f8 + Math_fround(HEAPF32[i31 >> 2]));
   HEAPF32[i20 >> 2] = Math_fround(f11 + f44);
   HEAPF32[i21 >> 2] = f43;
   HEAPF32[i22 >> 2] = f42;
   HEAPF32[i23 >> 2] = f41;
   HEAPF32[i24 >> 2] = f40;
   HEAPF32[i25 >> 2] = f39;
   HEAPF32[i26 >> 2] = f38;
   HEAPF32[i27 >> 2] = f37;
   HEAPF32[i28 >> 2] = f36;
   HEAPF32[i29 >> 2] = f35;
   HEAPF32[i30 >> 2] = f34;
   HEAPF32[i31 >> 2] = f33;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i32 >>> 0);
  return;
 }
 if (i1 >>> 0 >= i32 >>> 0) return;
 i26 = i31 + 4 | 0;
 i27 = i31 + 8 | 0;
 i28 = i31 + 12 | 0;
 i7 = i31 + 20 | 0;
 i21 = i31 + 24 | 0;
 i22 = i31 + 28 | 0;
 i23 = i31 + 36 | 0;
 i24 = i31 + 40 | 0;
 i25 = i31 + 44 | 0;
 i30 = i2 + 80 | 0;
 i2 = i5 + 120 | 0;
 i20 = i5 + 140 | 0;
 i29 = i5 + 160 | 0;
 if (i3) {
  i6 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i2 = HEAP32[i29 >> 2] | 0;
  i3 = i31 + 32 | 0;
  i4 = i31 + 16 | 0;
  do {
   f33 = Math_fround(HEAPF32[i25 >> 2]);
   f18 = Math_fround(HEAPF32[i24 >> 2]);
   f17 = Math_fround(HEAPF32[i23 >> 2]);
   f16 = Math_fround(HEAPF32[i3 >> 2]);
   f15 = Math_fround(HEAPF32[i22 >> 2]);
   f14 = Math_fround(HEAPF32[i21 >> 2]);
   f13 = Math_fround(HEAPF32[i7 >> 2]);
   f12 = Math_fround(HEAPF32[i4 >> 2]);
   f11 = Math_fround(HEAPF32[i28 >> 2]);
   f10 = Math_fround(HEAPF32[i27 >> 2]);
   f9 = Math_fround(HEAPF32[i26 >> 2]);
   f19 = Math_fround(HEAPF32[i31 >> 2]);
   f44 = Math_fround(HEAPF32[i30 >> 2]);
   f19 = Math_fround(f19 * f44);
   f9 = Math_fround(f9 * f44);
   f10 = Math_fround(f10 * f44);
   f11 = Math_fround(f11 * f44);
   f12 = Math_fround(f12 * f44);
   f13 = Math_fround(f13 * f44);
   f14 = Math_fround(f14 * f44);
   f15 = Math_fround(f15 * f44);
   f16 = Math_fround(f16 * f44);
   f17 = Math_fround(f17 * f44);
   f18 = Math_fround(f18 * f44);
   f44 = Math_fround(f33 * f44);
   i54 = i6 + (i1 << 2) | 0;
   f33 = Math_fround(HEAPF32[i54 >> 2]);
   i53 = i54 + 4 | 0;
   f34 = Math_fround(HEAPF32[i53 >> 2]);
   i52 = i54 + 8 | 0;
   f35 = Math_fround(HEAPF32[i52 >> 2]);
   i51 = i54 + 12 | 0;
   f36 = Math_fround(HEAPF32[i51 >> 2]);
   i50 = i5 + (i1 << 2) | 0;
   f37 = Math_fround(HEAPF32[i50 >> 2]);
   i49 = i50 + 4 | 0;
   f38 = Math_fround(HEAPF32[i49 >> 2]);
   i48 = i50 + 8 | 0;
   f39 = Math_fround(HEAPF32[i48 >> 2]);
   i47 = i50 + 12 | 0;
   f40 = Math_fround(HEAPF32[i47 >> 2]);
   i46 = i2 + (i1 << 2) | 0;
   f41 = Math_fround(HEAPF32[i46 >> 2]);
   i45 = i46 + 4 | 0;
   f42 = Math_fround(HEAPF32[i45 >> 2]);
   i20 = i46 + 8 | 0;
   f43 = Math_fround(HEAPF32[i20 >> 2]);
   i29 = i46 + 12 | 0;
   f34 = Math_fround(f9 + f34);
   f35 = Math_fround(f10 + f35);
   f36 = Math_fround(f11 + f36);
   f37 = Math_fround(f12 + f37);
   f38 = Math_fround(f13 + f38);
   f39 = Math_fround(f14 + f39);
   f40 = Math_fround(f15 + f40);
   f41 = Math_fround(f16 + f41);
   f42 = Math_fround(f17 + f42);
   f43 = Math_fround(f18 + f43);
   f44 = Math_fround(f44 + Math_fround(HEAPF32[i29 >> 2]));
   HEAPF32[i54 >> 2] = Math_fround(f19 + f33);
   HEAPF32[i53 >> 2] = f34;
   HEAPF32[i52 >> 2] = f35;
   HEAPF32[i51 >> 2] = f36;
   HEAPF32[i50 >> 2] = f37;
   HEAPF32[i49 >> 2] = f38;
   HEAPF32[i48 >> 2] = f39;
   HEAPF32[i47 >> 2] = f40;
   HEAPF32[i46 >> 2] = f41;
   HEAPF32[i45 >> 2] = f42;
   HEAPF32[i20 >> 2] = f43;
   HEAPF32[i29 >> 2] = f44;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i32 >>> 0);
  return;
 } else {
  i6 = HEAP32[i5 + 180 >> 2] | 0;
  i7 = HEAP32[i5 + 200 >> 2] | 0;
  i5 = HEAP32[i5 + 220 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i20 >> 2] | 0;
  i2 = HEAP32[i29 >> 2] | 0;
  do {
   i29 = i6 + (i1 << 2) | 0;
   i31 = i7 + (i1 << 2) | 0;
   i45 = i5 + (i1 << 2) | 0;
   f33 = Math_fround(HEAPF32[i45 + 12 >> 2]);
   f18 = Math_fround(HEAPF32[i45 + 8 >> 2]);
   f17 = Math_fround(HEAPF32[i45 + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i45 >> 2]);
   f15 = Math_fround(HEAPF32[i31 + 12 >> 2]);
   f14 = Math_fround(HEAPF32[i31 + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i31 + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i31 >> 2]);
   f11 = Math_fround(HEAPF32[i29 + 12 >> 2]);
   f10 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i29 >> 2]);
   f44 = Math_fround(HEAPF32[i30 >> 2]);
   f19 = Math_fround(f19 * f44);
   f9 = Math_fround(f9 * f44);
   f10 = Math_fround(f10 * f44);
   f11 = Math_fround(f11 * f44);
   f12 = Math_fround(f12 * f44);
   f13 = Math_fround(f13 * f44);
   f14 = Math_fround(f14 * f44);
   f15 = Math_fround(f15 * f44);
   f16 = Math_fround(f16 * f44);
   f17 = Math_fround(f17 * f44);
   f18 = Math_fround(f18 * f44);
   f44 = Math_fround(f33 * f44);
   i29 = i4 + (i1 << 2) | 0;
   f33 = Math_fround(HEAPF32[i29 >> 2]);
   i31 = i29 + 4 | 0;
   f34 = Math_fround(HEAPF32[i31 >> 2]);
   i45 = i29 + 8 | 0;
   f35 = Math_fround(HEAPF32[i45 >> 2]);
   i46 = i29 + 12 | 0;
   f36 = Math_fround(HEAPF32[i46 >> 2]);
   i47 = i3 + (i1 << 2) | 0;
   f37 = Math_fround(HEAPF32[i47 >> 2]);
   i48 = i47 + 4 | 0;
   f38 = Math_fround(HEAPF32[i48 >> 2]);
   i49 = i47 + 8 | 0;
   f39 = Math_fround(HEAPF32[i49 >> 2]);
   i50 = i47 + 12 | 0;
   f40 = Math_fround(HEAPF32[i50 >> 2]);
   i51 = i2 + (i1 << 2) | 0;
   f41 = Math_fround(HEAPF32[i51 >> 2]);
   i52 = i51 + 4 | 0;
   f42 = Math_fround(HEAPF32[i52 >> 2]);
   i53 = i51 + 8 | 0;
   f43 = Math_fround(HEAPF32[i53 >> 2]);
   i54 = i51 + 12 | 0;
   f34 = Math_fround(f9 + f34);
   f35 = Math_fround(f10 + f35);
   f36 = Math_fround(f11 + f36);
   f37 = Math_fround(f12 + f37);
   f38 = Math_fround(f13 + f38);
   f39 = Math_fround(f14 + f39);
   f40 = Math_fround(f15 + f40);
   f41 = Math_fround(f16 + f41);
   f42 = Math_fround(f17 + f42);
   f43 = Math_fround(f18 + f43);
   f44 = Math_fround(f44 + Math_fround(HEAPF32[i54 >> 2]));
   HEAPF32[i29 >> 2] = Math_fround(f19 + f33);
   HEAPF32[i31 >> 2] = f34;
   HEAPF32[i45 >> 2] = f35;
   HEAPF32[i46 >> 2] = f36;
   HEAPF32[i47 >> 2] = f37;
   HEAPF32[i48 >> 2] = f38;
   HEAPF32[i49 >> 2] = f39;
   HEAPF32[i50 >> 2] = f40;
   HEAPF32[i51 >> 2] = f41;
   HEAPF32[i52 >> 2] = f42;
   HEAPF32[i53 >> 2] = f43;
   HEAPF32[i54 >> 2] = f44;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i32 >>> 0);
  return;
 }
}

function __ZN5physx3Scb5Scene15syncEntireSceneEPj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i12 = i14 + 20 | 0;
 i8 = i14 + 16 | 0;
 i7 = i14 + 8 | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = __ZN5physx2Sc5Scene13getErrorStateEv(i13 + 16 | 0) | 0;
 i11 = i13 + 2436 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 __ZN5physx3Scb5Scene9syncStateEv(i13);
 i3 = i13 + 2816 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i13 + 2784 | 0;
  i5 = i13 + 16 | 0;
  i6 = 0;
  do {
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i2 & -1073741824 | 0) == 1073741824) {
    HEAP32[i1 + 16 >> 2] = __ZN5physx2Sc5Scene15createAggregateEPvb(i5, HEAP32[i1 + 12 >> 2] | 0, (HEAP8[i1 + 24 >> 0] | 0) != 0) | 0;
    __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE(i1, i13);
   } else if (i2 & 268435456 | 0) __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE(i1, i13);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i13 + 2780 | 0);
 HEAP32[i13 + 2532 >> 2] = 0;
 i1 = i13 + 2540 | 0;
 i2 = HEAP32[i13 + 2544 >> 2] | 0;
 i3 = i13 + 2576 | 0;
 i9 = i13 + 16 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = 0;
  do {
   i4 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 & -1073741824 | 0) == 1073741824) __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6insertERNS0_2Sc5SceneERS2_(i9, i4); else if (i5 & 268435456 | 0) __ZN5physx3Scb11RigidStatic9syncStateEv(i4);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i1);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN5physx2Sc5Scene24initActiveBodiesIteratorERNS0_12BodyIteratorE(i9, i7);
 i1 = __ZN5physx2Sc12BodyIterator7getNextEv(i7) | 0;
 if (i1 | 0) do {
  i1 = i1 - (HEAP32[gb + 90260 + (HEAPU8[i1 + 10 >> 0] << 2) >> 2] | 0) | 0;
  if (!(HEAP32[i1 + 4 >> 2] & 268435456)) __ZN5physx3Scb4Body9syncStateEv(i1);
  i1 = __ZN5physx2Sc12BodyIterator7getNextEv(i7) | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i13 + 1144 >> 2] | 0;
 i2 = HEAP32[i13 + 1140 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   i3 = i3 - (HEAP32[gb + 90260 + (HEAPU8[i3 + 10 >> 0] << 2) >> 2] | 0) | 0;
   if (!(HEAP32[i3 + 4 >> 2] & 268435456)) __ZN5physx3Scb4Body9syncStateEv(i3);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i1 = i13 + 2580 | 0;
 i2 = HEAP32[i13 + 2584 >> 2] | 0;
 i3 = i13 + 2616 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = 0;
  do {
   i4 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 & -1073741824 | 0) == 1073741824) __ZN10ScSceneFnsIN5physx3Scb4BodyEE6insertERNS0_2Sc5SceneERS2_(i9, i4); else if (i5 & 268435456 | 0) __ZN5physx3Scb4Body9syncStateEv(i4);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i1);
 HEAP32[i13 + 2520 >> 2] = 0;
 i4 = i13 + 2500 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i13 + 2468 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (HEAP32[i2 + 4 >> 2] & 268435456) {
    __ZN5physx3Scb5Shape9syncStateEv(i2);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i13 + 2464 | 0);
 HEAP32[i13 + 2508 >> 2] = 0;
 i1 = __ZN5physx2Sc5Scene14getConstraintsEv(i9) | 0;
 i2 = __ZNK5physx2Sc5Scene16getNbConstraintsEv(i9) | 0;
 if (i2 | 0) {
  i4 = 0;
  do {
   i3 = (HEAP32[i1 + (i4 << 2) >> 2] | 0) + -12 | 0;
   if (!(HEAP32[i3 + 4 >> 2] & 268435456)) __ZN5physx3Scb10Constraint9syncStateEv(i3);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 i3 = i13 + 2660 | 0;
 i4 = HEAP32[i13 + 2664 >> 2] | 0;
 i5 = i13 + 2696 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i7 = 0;
  do {
   i6 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i1 & -1073741824 | 0) == 1073741824) {
    __ZN5physx34NpConstraintGetRigidObjectsFromScbERKNS_3Scb10ConstraintERPNS0_11RigidObjectES6_(i6, i12, i8);
    i1 = HEAP32[i12 >> 2] | 0;
    if (!i1) i2 = 0; else i2 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0;
    __ZN5physx2Sc5Scene13addConstraintERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_(i9, i6 + 12 | 0, i2, i1);
   } else if (i1 & 268435456 | 0) __ZN5physx3Scb10Constraint9syncStateEv(i6);
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i3);
 i1 = __ZN5physx2Sc5Scene16getArticulationsEv(i9) | 0;
 i2 = __ZNK5physx2Sc5Scene18getNbArticulationsEv(i9) | 0;
 if (i2 | 0) {
  i4 = 0;
  do {
   i3 = (HEAP32[i1 + (i4 << 2) >> 2] | 0) + -12 | 0;
   if (!(HEAP32[i3 + 4 >> 2] & 268435456)) __ZN5physx3Scb12Articulation9syncStateEv(i3);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 i1 = i13 + 2700 | 0;
 i2 = HEAP32[i13 + 2704 >> 2] | 0;
 i3 = i13 + 2736 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = 0;
  do {
   i4 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 & -1073741824 | 0) == 1073741824) __ZN5physx2Sc5Scene15addArticulationERNS0_16ArticulationCoreERNS0_8BodyCoreE(i9, i4 + 12 | 0, (__ZN5physx28NpArticulationGetRootFromScbERNS_3Scb12ArticulationE(i4) | 0) + 16 | 0); else if (i5 & 268435456 | 0) __ZN5physx3Scb12Articulation9syncStateEv(i4);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i1);
 i1 = i13 + 2740 | 0;
 i2 = HEAP32[i13 + 2744 >> 2] | 0;
 i3 = i13 + 2776 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = 0;
  do {
   i4 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i5 & -1073741824 | 0) == 1073741824) {
    __ZN5physx35NpArticulationJointGetBodiesFromScbERNS_3Scb17ArticulationJointERPNS0_4BodyES5_(i4, i12, i8);
    __ZN5physx2Sc5Scene20addArticulationJointERNS0_21ArticulationJointCoreERNS0_8BodyCoreES5_(i9, i4 + 12 | 0, (HEAP32[i12 >> 2] | 0) + 16 | 0, (HEAP32[i8 >> 2] | 0) + 16 | 0);
   } else if (i5 & 268435456 | 0) __ZN5physx3Scb17ArticulationJoint9syncStateEv(i4);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i1);
 i1 = __ZNK5physx2Sc5Scene20getNbParticleSystemsEv(i9) | 0;
 i2 = __ZN5physx2Sc5Scene18getParticleSystemsEv(i9) | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i8 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
   __ZN5physx3Scb14ParticleSystem9syncStateEv(i8 - (HEAP32[gb + 90260 + (HEAPU8[i8 + 10 >> 0] << 2) >> 2] | 0) | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i1 = i13 + 2656 | 0;
 L107 : do if (HEAP32[i1 >> 2] | 0) {
  i2 = i13 + 2624 | 0;
  i4 = 0;
  while (1) {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   switch ((HEAP32[i3 + 4 >> 2] | 0) >>> 30 | 0) {
   case 3:
    {
     __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv(i3 + 156 | 0);
     __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv(i3 + 168 | 0);
     break;
    }
   case 1:
    {
     __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE(i9, i3 + 12 | 0);
     break;
    }
   default:
    {}
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) break L107;
  }
 } while (0);
 __ZN5physx3Scb13ObjectTracker5clearEv(i13 + 2620 | 0);
 i1 = i13 + 2856 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i13 + 2824 | 0;
  i4 = 0;
  do {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if ((HEAP32[i3 + 4 >> 2] & -1073741824 | 0) == 1073741824) if (!(__ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE(i9, i3 + 12 | 0) | 0)) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 682639 | 0, 1263, gb + 682719 | 0, i10);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb13ObjectTracker5clearEv(i13 + 2820 | 0);
 i2 = i13 + 2452 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + 2 | 0;
 i4 = i13 + 2444 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 <= i3 >>> 0) {
  HEAP32[i2 >> 2] = 0;
  i13 = i13 + 2456 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
  STACKTOP = i14;
  return;
 }
 i5 = i13 + 2440 | 0;
 do {
  i9 = i1 + -1 | 0;
  i10 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  HEAP32[i4 >> 2] = i9;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, i10);
  i1 = HEAP32[i4 >> 2] | 0;
 } while (i1 >>> 0 > i3 >>> 0);
 HEAP32[i2 >> 2] = 0;
 i13 = i13 + 2456 | 0;
 HEAP32[i13 >> 2] = 0;
 i13 = HEAP32[i11 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_(i14, i15, i13, i11, i6, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 24 | 0;
 i16 = i19;
 i17 = __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_(i14, i15, i13, i11, i1) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i10 = i11 + 4 | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i16 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i16 + 16 | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i11 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i2 >> 2 << 2);
  }
 }
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 if ((i11 | 0) != (i6 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0);
 HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
 if ((i16 | 0) == (i6 | 0)) i1 = i6 + 4 | 0; else {
  i1 = i16 + 4 | 0;
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i6 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i12 = HEAP32[i8 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i11 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17 + 1 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i12 = i13 + 4 | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i16 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i13 + 8 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i2 >> 2 << 2);
  }
 }
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 if ((i13 | 0) != (i11 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, HEAP32[i11 + 4 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
 i1 = i16 + 4 | 0;
 if ((i16 | 0) != (i11 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i11 = HEAP32[i7 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17 + 2 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i11 = i15 + 4 | 0;
 i1 = HEAP32[i15 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i16 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i10 = i15 + 8 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i2 >> 2 << 2);
  }
 }
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 if ((i15 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
 i1 = i16 + 4 | 0;
 if ((i16 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i13 = HEAP32[i7 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i15 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17 + 3 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i7 = i14 + 4 | 0;
 i1 = HEAP32[i14 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i16 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i9 = i16 + 16 | 0;
 HEAP32[i9 >> 2] = i1;
 i6 = i14 + 8 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
  }
 }
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 if ((i14 | 0) != (i15 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i15 + 4 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 i1 = i16 + 4 | 0;
 if ((i16 | 0) != (i15 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i16 = HEAP32[i9 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i18 = i17 + 4 | 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN5physx23PxsBroadPhaseContextSapC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i25, i2, i1) {
 i25 = i25 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i26 + 16 | 0;
 i15 = i26 + 15 | 0;
 i16 = i26 + 14 | 0;
 i17 = i26 + 13 | 0;
 i18 = i26 + 12 | 0;
 i19 = i26 + 11 | 0;
 i20 = i26 + 10 | 0;
 i7 = i26 + 9 | 0;
 i8 = i26 + 8 | 0;
 i9 = i26 + 7 | 0;
 i10 = i26 + 6 | 0;
 i11 = i26 + 5 | 0;
 i12 = i26 + 4 | 0;
 i13 = i26 + 3 | 0;
 i22 = i26 + 2 | 0;
 i23 = i26 + 1 | 0;
 i24 = i26;
 HEAP32[i25 >> 2] = gb + 103840 + 8;
 HEAP32[i25 + 4 >> 2] = i2;
 HEAP32[i25 + 8 >> 2] = i1;
 i21 = i25 + 12 | 0;
 HEAP16[i25 + 16 >> 1] = -1;
 HEAP16[i25 + 18 >> 1] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP32[i21 >> 2] = gb + 87404 + 8;
 HEAP32[i25 + 24 >> 2] = 0;
 HEAP32[i25 + 28 >> 2] = 0;
 HEAP32[i21 >> 2] = gb + 103920 + 8;
 i21 = i25 + 44 | 0;
 HEAP16[i25 + 48 >> 1] = -1;
 HEAP16[i25 + 50 >> 1] = 0;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i21 >> 2] = gb + 87404 + 8;
 HEAP32[i25 + 56 >> 2] = 0;
 HEAP32[i25 + 60 >> 2] = 0;
 HEAP32[i21 >> 2] = gb + 103964 + 8;
 i21 = i25 + 192 | 0;
 __ZN5physx14SapPairManagerC2Ev(i21);
 i5 = i25 + 256 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP16[i25 + 260 >> 1] = -1;
 HEAP16[i25 + 262 >> 1] = 0;
 HEAP32[i25 + 264 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 87404 + 8;
 HEAP32[i25 + 268 >> 2] = 0;
 HEAP32[i25 + 272 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 104008 + 8;
 HEAP32[i25 + 276 >> 2] = 0;
 HEAP32[i25 + 280 >> 2] = -1;
 i5 = i25 + 284 | 0;
 i1 = i25 + 296 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP16[i25 + 300 >> 1] = -1;
 HEAP16[i25 + 302 >> 1] = 0;
 HEAP32[i25 + 304 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i25 + 308 >> 2] = 0;
 HEAP32[i25 + 312 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 104008 + 8;
 HEAP32[i25 + 316 >> 2] = 0;
 HEAP32[i25 + 320 >> 2] = -1;
 i1 = i25 + 324 | 0;
 i5 = i25 + 336 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP16[i25 + 340 >> 1] = -1;
 HEAP16[i25 + 342 >> 1] = 0;
 HEAP32[i25 + 344 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 87404 + 8;
 HEAP32[i25 + 348 >> 2] = 0;
 HEAP32[i25 + 352 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 104008 + 8;
 HEAP32[i25 + 356 >> 2] = 0;
 HEAP32[i25 + 360 >> 2] = -1;
 HEAP32[i25 + 364 >> 2] = 0;
 HEAP32[i25 + 368 >> 2] = 0;
 HEAP32[i25 + 372 >> 2] = 0;
 HEAP32[i25 + 168 >> 2] = 0;
 HEAP32[i25 + 172 >> 2] = 0;
 i5 = i25 + 108 | 0;
 HEAP32[i5 >> 2] = 64;
 i1 = i25 + 112 | 0;
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26 + 19 | 0, 512, gb + 716671 | 0, 460) | 0;
 i2 = i25 + 116 | 0;
 HEAP32[i2 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26 + 18 | 0, (HEAP32[i5 >> 2] << 3) + 15 & -16, gb + 716671 | 0, 461) | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26 + 17 | 0, (HEAP32[i5 >> 2] << 3) + 15 & -16, gb + 716671 | 0, 462) | 0;
 HEAP32[i25 + 120 >> 2] = i6;
 if (!(HEAP32[i5 >> 2] | 0)) i1 = 0; else {
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i4 + (i3 << 3) >> 2] = 1073741823;
   HEAP32[i4 + (i3 << 3) + 4 >> 2] = 1073741823;
   HEAP32[i2 + (i3 << 3) >> 2] = 1073741823;
   HEAP32[i2 + (i3 << 3) + 4 >> 2] = 1073741823;
   HEAP32[i6 + (i3 << 3) >> 2] = 1073741823;
   HEAP32[i6 + (i3 << 3) + 4 >> 2] = 1073741823;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = i1 + 15 & -16;
 }
 i5 = i25 + 176 | 0;
 HEAP32[i5 >> 2] = 130;
 HEAP32[i25 + 148 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, i1, gb + 716671 | 0, 476) | 0;
 HEAP32[i25 + 152 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i15, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 477) | 0;
 HEAP32[i25 + 156 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, (HEAP32[i5 >> 2] << 3) + 15 & -16, gb + 716671 | 0, 478) | 0;
 i16 = i25 + 124 | 0;
 HEAP32[i16 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 483) | 0;
 i17 = i25 + 128 | 0;
 HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 484) | 0;
 i3 = i25 + 132 | 0;
 HEAP32[i3 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 485) | 0;
 i18 = i25 + 136 | 0;
 HEAP32[i18 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i20, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 486) | 0;
 i1 = i25 + 140 | 0;
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 487) | 0;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 488) | 0;
 HEAP32[i25 + 144 >> 2] = i4;
 i19 = HEAP32[i16 >> 2] | 0;
 i20 = HEAP32[i18 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i20 >> 2] = 1073741822;
 HEAP32[i19 + 4 >> 2] = -1;
 HEAP32[i20 + 4 >> 2] = 1073741823;
 i20 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i1 >> 2] = 1073741822;
 HEAP32[i20 + 4 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 1073741823;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 1073741822;
 HEAP32[i3 + 4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 HEAP32[i25 + 180 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, 4096, gb + 716671 | 0, 499) | 0;
 HEAP32[i25 + 184 >> 2] = 0;
 HEAP32[i25 + 188 >> 2] = 1024;
 HEAP32[i25 + 236 >> 2] = 0;
 HEAP32[i25 + 248 >> 2] = 0;
 HEAP32[i25 + 232 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, 512, gb + 716671 | 0, 506) | 0;
 HEAP32[i25 + 240 >> 2] = 64;
 HEAP32[i25 + 244 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11, 512, gb + 716671 | 0, 508) | 0;
 HEAP32[i25 + 252 >> 2] = 64;
 i4 = i25 + 160 | 0;
 HEAP32[i4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 511) | 0;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, (HEAP32[i5 >> 2] << 2) + 15 & -16, gb + 716671 | 0, 512) | 0;
 HEAP32[i25 + 164 >> 2] = i3;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 1) i2 = 1; else {
  i19 = i1;
  i19 = i19 + -1 | 0;
  i20 = i4 + (i19 << 2) | 0;
  HEAP32[i20 >> 2] = i19;
  HEAP32[i3 >> 2] = 0;
  __ZN5physx14SapPairManager4initEj(i21, 64);
  i21 = i25 + 356 | 0;
  HEAP32[i21 >> 2] = i25;
  i21 = i25 + 360 | 0;
  HEAP32[i21 >> 2] = 2;
  i21 = i25 + 316 | 0;
  HEAP32[i21 >> 2] = i25;
  i21 = i25 + 320 | 0;
  HEAP32[i21 >> 2] = 1;
  i21 = i25 + 276 | 0;
  HEAP32[i21 >> 2] = i25;
  i21 = i25 + 280 | 0;
  HEAP32[i21 >> 2] = 0;
  i21 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i22, 65536, gb + 716671 | 0, 531) | 0;
  i22 = i25 + 364 | 0;
  HEAP32[i22 >> 2] = i21;
  i22 = i25 + 372 | 0;
  HEAP32[i22 >> 2] = 8192;
  i22 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, 65536, gb + 716671 | 0, 532) | 0;
  i23 = i25 + 324 | 0;
  HEAP32[i23 >> 2] = i22;
  i23 = i25 + 332 | 0;
  HEAP32[i23 >> 2] = 8192;
  i23 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i24, 65536, gb + 716671 | 0, 533) | 0;
  i24 = i25 + 284 | 0;
  HEAP32[i24 >> 2] = i23;
  i25 = i25 + 292 | 0;
  HEAP32[i25 >> 2] = 8192;
  STACKTOP = i26;
  return;
 }
 do {
  i1 = i2 + -1 | 0;
  HEAP32[i4 + (i1 << 2) >> 2] = i2;
  HEAP32[i3 + (i2 << 2) >> 2] = i1;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 i19 = i1 + -1 | 0;
 i20 = i4 + (i19 << 2) | 0;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx14SapPairManager4initEj(i21, 64);
 i21 = i25 + 356 | 0;
 HEAP32[i21 >> 2] = i25;
 i21 = i25 + 360 | 0;
 HEAP32[i21 >> 2] = 2;
 i21 = i25 + 316 | 0;
 HEAP32[i21 >> 2] = i25;
 i21 = i25 + 320 | 0;
 HEAP32[i21 >> 2] = 1;
 i21 = i25 + 276 | 0;
 HEAP32[i21 >> 2] = i25;
 i21 = i25 + 280 | 0;
 HEAP32[i21 >> 2] = 0;
 i21 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i22, 65536, gb + 716671 | 0, 531) | 0;
 i22 = i25 + 364 | 0;
 HEAP32[i22 >> 2] = i21;
 i22 = i25 + 372 | 0;
 HEAP32[i22 >> 2] = 8192;
 i22 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, 65536, gb + 716671 | 0, 532) | 0;
 i23 = i25 + 324 | 0;
 HEAP32[i23 >> 2] = i22;
 i23 = i25 + 332 | 0;
 HEAP32[i23 >> 2] = 8192;
 i23 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i24, 65536, gb + 716671 | 0, 533) | 0;
 i24 = i25 + 284 | 0;
 HEAP32[i24 >> 2] = i23;
 i25 = i25 + 292 | 0;
 HEAP32[i25 >> 2] = 8192;
 STACKTOP = i26;
 return;
}

function __ZN5physx23collideWithMeshTriangleERNS_6PxVec3ES1_S1_S1_RfS2_RKS0_S4_S4_S4_S4_bRKfS6_(i51, i52, i28, i29, i48, i49, i50, i5, i31, i43, i44, i25, i27, i1) {
 i51 = i51 | 0;
 i52 = i52 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i5 = i5 | 0;
 i31 = i31 | 0;
 i43 = i43 | 0;
 i44 = i44 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f26 = f0, i30 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, i45 = 0, f46 = f0, i47 = 0;
 f24 = Math_fround(HEAPF32[i27 >> 2]);
 f24 = Math_fround(f24 * f24);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(f23 * f23);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f42 = Math_fround(f13 - Math_fround(HEAPF32[i50 >> 2]));
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 i47 = i50 + 4 | 0;
 f40 = Math_fround(f15 - Math_fround(HEAPF32[i47 >> 2]));
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i45 = i50 + 8 | 0;
 f35 = Math_fround(f14 - Math_fround(HEAPF32[i45 >> 2]));
 f9 = Math_fround(HEAPF32[i31 >> 2]);
 f6 = Math_fround(f9 - f13);
 i30 = i31 + 4 | 0;
 f10 = Math_fround(HEAPF32[i30 >> 2]);
 f3 = Math_fround(f10 - f15);
 i33 = i31 + 8 | 0;
 f11 = Math_fround(HEAPF32[i33 >> 2]);
 f4 = Math_fround(f11 - f14);
 f19 = Math_fround(HEAPF32[i43 >> 2]);
 f7 = Math_fround(f19 * f19);
 i36 = i43 + 4 | 0;
 f20 = Math_fround(HEAPF32[i36 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f20 * f20));
 i37 = i43 + 8 | 0;
 f17 = Math_fround(HEAPF32[i37 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f17 * f17));
 f21 = Math_fround(HEAPF32[i44 >> 2]);
 f41 = Math_fround(f19 * f21);
 i38 = i44 + 4 | 0;
 f22 = Math_fround(HEAPF32[i38 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f20 * f22));
 i39 = i44 + 8 | 0;
 f18 = Math_fround(HEAPF32[i39 >> 2]);
 f41 = Math_fround(f41 + Math_fround(f17 * f18));
 f8 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f18 * f18));
 f2 = Math_fround(Math_fround(Math_fround(f6 * f19) + Math_fround(f3 * f20)) + Math_fround(f4 * f17));
 f4 = Math_fround(Math_fround(Math_fround(f6 * f21) + Math_fround(f3 * f22)) + Math_fround(f4 * f18));
 f3 = Math_fround(Math_fround(f41 * f4) - Math_fround(f2 * f8));
 f6 = Math_fround(Math_fround(f2 * f41) - Math_fround(f7 * f4));
 f46 = Math_fround(Math_fround(f7 * f8) - Math_fround(f41 * f41));
 do if (!(f3 <= Math_fround(0.0))) {
  if (f6 <= Math_fround(0.0)) {
   i1 = f7 > Math_fround(1.17549435e-38);
   f34 = i1 ? f7 : Math_fround(1.17549435e-38);
   f3 = Math_fround(Math_fround(-f2) / f34);
   f2 = Math_fround(0.0);
   f32 = f8;
   i1 = 0;
   break;
  }
  if (Math_fround(f3 + f6) > f46) {
   f3 = Math_fround(Math_fround(Math_fround(f7 + f8) - f41) - f41);
   f2 = Math_fround(Math_fround(Math_fround(f8 + f4) - f41) - f2);
   i1 = f3 > Math_fround(1.17549435e-38);
   f2 = Math_fround(f2 / (i1 ? f3 : Math_fround(1.17549435e-38)));
   f3 = f2;
   f2 = Math_fround(Math_fround(1.0) - f2);
   f34 = f7;
   f32 = f8;
   i1 = 0;
   break;
  } else {
   i1 = f46 > Math_fround(1.17549435e-38);
   f2 = Math_fround(Math_fround(1.0) / f46);
   f2 = i1 ? f2 : Math_fround(8507059170000000446965751.0e13);
   f3 = Math_fround(f3 * f2);
   f2 = Math_fround(f6 * f2);
   f34 = f7;
   f32 = f8;
   i1 = 1;
   break;
  }
 } else {
  i1 = f8 > Math_fround(1.17549435e-38);
  f32 = i1 ? f8 : Math_fround(1.17549435e-38);
  f3 = Math_fround(0.0);
  f2 = Math_fround(Math_fround(-f4) / f32);
  f34 = f7;
  i1 = 0;
 } while (0);
 i5 = f3 > Math_fround(0.0);
 f7 = i5 ? f3 : Math_fround(0.0);
 i5 = f2 > Math_fround(0.0);
 f8 = i5 ? f2 : Math_fround(0.0);
 i5 = f7 < Math_fround(1.0);
 f7 = i5 ? f7 : Math_fround(1.0);
 i5 = f8 < Math_fround(1.0);
 f8 = i5 ? f8 : Math_fround(1.0);
 f16 = Math_fround(Math_fround(Math_fround(f19 * f7) + f9) + Math_fround(f8 * f21));
 f9 = Math_fround(Math_fround(Math_fround(f7 * f20) + f10) + Math_fround(f8 * f22));
 f8 = Math_fround(Math_fround(Math_fround(f7 * f17) + f11) + Math_fround(f8 * f18));
 f7 = Math_fround(f13 - f16);
 f6 = Math_fround(f15 - f9);
 f2 = Math_fround(f14 - f8);
 f3 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f2 * f2));
 f26 = Math_fround(Math_fround(f20 * f18) - Math_fround(f17 * f22));
 f15 = Math_fround(Math_fround(f17 * f21) - Math_fround(f19 * f18));
 f13 = Math_fround(Math_fround(f19 * f22) - Math_fround(f20 * f21));
 f14 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f26 * f26) + Math_fround(f15 * f15)))));
 i5 = Math_fround(Math_fround(Math_fround(f7 * f26) + Math_fround(f15 * f6)) + Math_fround(f13 * f2)) > Math_fround(0.0);
 i12 = i5 & (i1 & f3 < f23);
 i5 = f3 < f24 & i5;
 if (i25) i1 = 0; else {
  if (i5) {
   if (f3 > Math_fround(9.99999974e-06)) {
    f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
    f4 = Math_fround(f2 * f24);
    f3 = Math_fround(f6 * f24);
    f2 = Math_fround(f7 * f24);
   } else {
    f2 = Math_fround(Math_fround(1.0) / f14);
    f4 = Math_fround(f13 * f2);
    f3 = Math_fround(f15 * f2);
    f2 = Math_fround(f26 * f2);
   }
   HEAPF32[i51 >> 2] = f2;
   HEAPF32[i51 + 4 >> 2] = f3;
   HEAPF32[i51 + 8 >> 2] = f4;
   f22 = Math_fround(HEAPF32[i27 >> 2]);
   f23 = Math_fround(f9 + Math_fround(f22 * f3));
   f24 = Math_fround(f8 + Math_fround(f22 * f4));
   HEAPF32[i52 >> 2] = Math_fround(f16 + Math_fround(f22 * f2));
   HEAPF32[i52 + 4 >> 2] = f23;
   HEAPF32[i52 + 8 >> 2] = f24;
   i1 = 16;
  } else i1 = 0;
  if (i12) {
   f41 = Math_fround(Math_fround(1.0) / f14);
   f46 = Math_fround(f26 * f41);
   f42 = Math_fround(f15 * f41);
   f41 = Math_fround(f13 * f41);
   HEAPF32[i28 >> 2] = f46;
   i51 = i28 + 4 | 0;
   HEAPF32[i51 >> 2] = f42;
   i52 = i28 + 8 | 0;
   HEAPF32[i52 >> 2] = f41;
   f40 = Math_fround(HEAPF32[i27 >> 2]);
   f42 = Math_fround(f9 + Math_fround(f40 * f42));
   f41 = Math_fround(f8 + Math_fround(f40 * f41));
   HEAPF32[i29 >> 2] = Math_fround(f16 + Math_fround(f40 * f46));
   HEAPF32[i29 + 4 >> 2] = f42;
   HEAPF32[i29 + 8 >> 2] = f41;
   f41 = Math_fround(HEAPF32[i50 >> 2]);
   f41 = Math_fround(f41 - Math_fround(HEAPF32[i31 >> 2]));
   f42 = Math_fround(HEAPF32[i47 >> 2]);
   f42 = Math_fround(f42 - Math_fround(HEAPF32[i30 >> 2]));
   f46 = Math_fround(HEAPF32[i45 >> 2]);
   f46 = Math_fround(f46 - Math_fround(HEAPF32[i33 >> 2]));
   f41 = Math_fround(f41 * Math_fround(HEAPF32[i28 >> 2]));
   f42 = Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i51 >> 2])));
   HEAPF32[i49 >> 2] = Math_fround(f42 + Math_fround(f46 * Math_fround(HEAPF32[i52 >> 2])));
   i52 = i1 | 32;
   return i52 | 0;
  }
 }
 if (i5 | i12) {
  i52 = i1;
  return i52 | 0;
 }
 f8 = Math_fround(HEAPF32[i31 >> 2]);
 f9 = Math_fround(HEAPF32[i50 >> 2]);
 f2 = Math_fround(f8 - f9);
 f6 = Math_fround(HEAPF32[i30 >> 2]);
 f7 = Math_fround(HEAPF32[i47 >> 2]);
 f11 = Math_fround(f6 - f7);
 f3 = Math_fround(HEAPF32[i33 >> 2]);
 f4 = Math_fround(HEAPF32[i45 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f26 * f2) + Math_fround(f15 * f11)) + Math_fround(f13 * Math_fround(f3 - f4)));
 f2 = Math_fround(Math_fround(f35 * f13) + Math_fround(Math_fround(f42 * f26) + Math_fround(f40 * f15)));
 if (!(!(f11 > Math_fround(0.0)) & !(f2 >= f11))) {
  i52 = i1;
  return i52 | 0;
 }
 f10 = Math_fround(f11 / f2);
 f24 = Math_fround(f8 - Math_fround(f9 + Math_fround(f42 * f10)));
 f42 = Math_fround(f6 - Math_fround(f7 + Math_fround(f40 * f10)));
 f2 = Math_fround(f3 - Math_fround(f4 + Math_fround(f35 * f10)));
 f3 = Math_fround(Math_fround(HEAPF32[i43 >> 2]) * f24);
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i36 >> 2]) * f42));
 f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i37 >> 2]) * f2) + f3);
 f4 = Math_fround(f24 * Math_fround(HEAPF32[i44 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f42 * Math_fround(HEAPF32[i38 >> 2])));
 f2 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i39 >> 2])));
 f4 = Math_fround(Math_fround(f41 * f2) - Math_fround(f32 * f3));
 f2 = Math_fround(Math_fround(f41 * f3) - Math_fround(f34 * f2));
 f3 = Math_fround(f46 * Math_fround(.0000999999974));
 f42 = Math_fround(-f3);
 if (!(f4 >= f42) | !(f2 >= f42)) {
  i52 = i1;
  return i52 | 0;
 }
 if (!(Math_fround(f4 + f2) <= Math_fround(f46 + f3))) {
  i52 = i1;
  return i52 | 0;
 }
 f41 = Math_fround(Math_fround(1.0) / f14);
 HEAPF32[i49 >> 2] = Math_fround(-Math_fround(f11 * f41));
 f42 = Math_fround(f15 * f41);
 f46 = Math_fround(f13 * f41);
 HEAPF32[i51 >> 2] = Math_fround(f26 * f41);
 HEAPF32[i51 + 4 >> 2] = f42;
 HEAPF32[i51 + 8 >> 2] = f46;
 HEAP32[i52 >> 2] = HEAP32[i50 >> 2];
 HEAP32[i52 + 4 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i52 + 8 >> 2] = HEAP32[i45 >> 2];
 HEAPF32[i48 >> 2] = f10;
 i52 = i1 | 8;
 return i52 | 0;
}

function __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i12, i14, i13, i1) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i10 = i14;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i12;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i9 | 0) == (i5 | 0) & (i10 | 0) == (i6 | 0)) {
  i11 = i14 + 8 | 0;
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = i12 + 8 | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i7 >>> 0 < i8 >>> 0 | ((i7 | 0) == (i8 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0 : 0);
 } else i1 = i10 >>> 0 < i6 >>> 0 | (i10 | 0) == (i6 | 0) & i9 >>> 0 < i5 >>> 0;
 i8 = i13;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 if ((i7 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
  i11 = i13 + 8 | 0;
  i3 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i14 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i3 >>> 0 < i4 >>> 0 | ((i3 | 0) == (i4 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 : 0);
 } else i2 = i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i7 >>> 0 < i9 >>> 0;
 if (!i1) {
  if (!i2) {
   i14 = 0;
   return i14 | 0;
  }
  i11 = i14 + 8 | 0;
  i1 = i11;
  i15 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i14;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i4 + 4 >> 2] = i8;
  i8 = i13 + 8 | 0;
  i4 = i8;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i11;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  i3 = i13;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i3 + 4 >> 2] = i10;
  HEAP32[i8 >> 2] = i15;
  HEAP32[i8 + 4 >> 2] = i1;
  i8 = i14 + 16 | 0;
  i1 = i8;
  i15 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = i14 + 24 | 0;
  i3 = i9;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i10 = i14 + 32 | 0;
  i4 = i10;
  i7 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i16 = i13 + 16 | 0;
  i18 = i16;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i6 = i8;
  HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i6 + 4 >> 2] = i17;
  i6 = i13 + 24 | 0;
  i17 = i6;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i5 = i9;
  HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i5 + 4 >> 2] = i18;
  i5 = i13 + 32 | 0;
  i18 = i5;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i13 = i10;
  HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i13 + 4 >> 2] = i17;
  i13 = i16;
  HEAP32[i13 >> 2] = i15;
  HEAP32[i13 + 4 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i5 + 4 >> 2] = i4;
  i5 = i14;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i12;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  do if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
   i18 = i11;
   i17 = HEAP32[i18 + 4 >> 2] | 0;
   i1 = i12 + 8 | 0;
   i2 = i1;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(i17 >>> 0 < i2 >>> 0 | ((i17 | 0) == (i2 | 0) ? (HEAP32[i18 >> 2] | 0) >>> 0 < i3 >>> 0 : 0))) {
    i18 = 1;
    return i18 | 0;
   }
  } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) {
   i1 = i12 + 8 | 0;
   i2 = i1;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  } else {
   i18 = 1;
   return i18 | 0;
  } while (0);
  i18 = i12;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  i18 = i11;
  i15 = HEAP32[i18 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i13 + 4 >> 2] = i15;
  i13 = i14;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i13 + 4 >> 2] = i7;
  i6 = i11;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i6 + 4 >> 2] = i2;
  i6 = i12 + 16 | 0;
  i13 = i6;
  i11 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i7 = i12 + 24 | 0;
  i15 = i7;
  i14 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 4 >> 2] | 0;
  i18 = i12 + 32 | 0;
  i17 = i18;
  i16 = HEAP32[i17 >> 2] | 0;
  i17 = HEAP32[i17 + 4 >> 2] | 0;
  i5 = i8;
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i12;
  i6 = i9;
  i12 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = i12;
  i7 = i10;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i18 + 4 >> 2] = i12;
  i18 = i8;
  HEAP32[i18 >> 2] = i11;
  HEAP32[i18 + 4 >> 2] = i13;
  i18 = i9;
  HEAP32[i18 >> 2] = i14;
  HEAP32[i18 + 4 >> 2] = i15;
  i18 = i10;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = 2;
  return i18 | 0;
 }
 i1 = i12 + 8 | 0;
 i4 = i1;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (i2) {
  i15 = i12;
  HEAP32[i15 >> 2] = i7;
  HEAP32[i15 + 4 >> 2] = i8;
  i15 = i13 + 8 | 0;
  i18 = i15;
  i9 = HEAP32[i18 + 4 >> 2] | 0;
  i10 = i1;
  HEAP32[i10 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  i10 = i13;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i10 + 4 >> 2] = i6;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i15 + 4 >> 2] = i4;
  i15 = i12 + 16 | 0;
  i10 = i15;
  i9 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i18 = i12 + 24 | 0;
  i14 = i18;
  i11 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i6 = i12 + 32 | 0;
  i17 = i6;
  i16 = HEAP32[i17 >> 2] | 0;
  i17 = HEAP32[i17 + 4 >> 2] | 0;
  i12 = i13 + 16 | 0;
  i7 = i12;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i15 + 4 >> 2] = i8;
  i15 = i13 + 24 | 0;
  i8 = i15;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i18 + 4 >> 2] = i7;
  i18 = i13 + 32 | 0;
  i7 = i18;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i13 = i6;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i13 + 4 >> 2] = i8;
  i13 = i12;
  HEAP32[i13 >> 2] = i9;
  HEAP32[i13 + 4 >> 2] = i10;
  HEAP32[i15 >> 2] = i11;
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = 1;
  return i18 | 0;
 }
 i11 = i12;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = i14 + 8 | 0;
 i9 = i11;
 i16 = HEAP32[i9 + 4 >> 2] | 0;
 i17 = i1;
 HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i17 + 4 >> 2] = i16;
 i17 = i14;
 HEAP32[i17 >> 2] = i5;
 HEAP32[i17 + 4 >> 2] = i6;
 i5 = i11;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i12 + 16 | 0;
 i17 = i5;
 i16 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i6 = i12 + 24 | 0;
 i9 = i6;
 i18 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i12 + 32 | 0;
 i7 = i8;
 i10 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i14 + 16 | 0;
 i12 = i4;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i15;
 i5 = i14 + 24 | 0;
 i15 = i5;
 i12 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 i6 = i14 + 32 | 0;
 i12 = i6;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 4 >> 2] = i15;
 i8 = i4;
 HEAP32[i8 >> 2] = i16;
 HEAP32[i8 + 4 >> 2] = i17;
 i8 = i5;
 HEAP32[i8 >> 2] = i18;
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i6;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i13;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i14;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 do if ((i7 | 0) == (i9 | 0) & (i8 | 0) == (i10 | 0)) {
  i1 = i13 + 8 | 0;
  i18 = i1;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = i11;
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(i17 >>> 0 < i2 >>> 0 | ((i17 | 0) == (i2 | 0) ? (HEAP32[i18 >> 2] | 0) >>> 0 < i3 >>> 0 : 0))) {
   i18 = 1;
   return i18 | 0;
  }
 } else if (i8 >>> 0 < i10 >>> 0 | (i8 | 0) == (i10 | 0) & i7 >>> 0 < i9 >>> 0) {
  i2 = i11;
  i1 = i13 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  break;
 } else {
  i18 = 1;
  return i18 | 0;
 } while (0);
 i12 = i14;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = i8;
 i12 = i1;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = i14;
 i11 = i13;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = i1;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i2;
 i11 = i4;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i14 = i5;
 i12 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i6;
 i16 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i9 = i13 + 16 | 0;
 i7 = i9;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i15 = i4;
 HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i15 + 4 >> 2] = i8;
 i15 = i13 + 24 | 0;
 i8 = i15;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i18 = i5;
 HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i18 + 4 >> 2] = i7;
 i18 = i13 + 32 | 0;
 i7 = i18;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i13 = i6;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 4 >> 2] = i8;
 i13 = i9;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i15 >> 2] = i12;
 HEAP32[i15 + 4 >> 2] = i14;
 HEAP32[i18 >> 2] = i16;
 HEAP32[i18 + 4 >> 2] = i17;
 i18 = 2;
 return i18 | 0;
}

function _UNITY_png_colorspace_check_xy(i23, i24) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, d34 = 0.0, d35 = 0.0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i33;
 i22 = HEAP32[i24 >> 2] | 0;
 if (i22 >>> 0 > 1e5) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i31 = i24 + 4 | 0;
 i2 = HEAP32[i31 >> 2] | 0;
 if ((i2 | 0) < 0 | (i2 | 0) > (1e5 - i22 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i25 = i24 + 8 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 if (i1 >>> 0 > 1e5) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i26 = i24 + 12 | 0;
 i5 = HEAP32[i26 >> 2] | 0;
 if ((i5 | 0) < 0 | (i5 | 0) > (1e5 - i1 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i27 = i24 + 16 | 0;
 i11 = HEAP32[i27 >> 2] | 0;
 if (i11 >>> 0 > 1e5) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i28 = i24 + 20 | 0;
 i6 = HEAP32[i28 >> 2] | 0;
 if ((i6 | 0) < 0 | (i6 | 0) > (1e5 - i11 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i29 = i24 + 24 | 0;
 i12 = HEAP32[i29 >> 2] | 0;
 if (i12 >>> 0 > 1e5) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i30 = i24 + 28 | 0;
 i21 = HEAP32[i30 >> 2] | 0;
 if ((i21 | 0) < 0 | (i21 | 0) > (1e5 - i12 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i8 = i1 - i11 | 0;
 i16 = i2 - i6 | 0;
 i7 = (i8 | 0) == 0;
 i17 = (i16 | 0) == 0;
 do if (i7 | i17) i2 = 0; else {
  d3 = +Math_floor(+(+(i8 | 0) * +(i16 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i2 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i9 = i5 - i6 | 0;
 i18 = i22 - i11 | 0;
 i10 = (i9 | 0) == 0;
 i19 = (i18 | 0) == 0;
 do if (i19 | i10) i1 = 0; else {
  d3 = +Math_floor(+(+(i18 | 0) * +(i9 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i20 = i2 - i1 | 0;
 i14 = i21 - i6 | 0;
 i15 = (i14 | 0) == 0;
 do if (i7 | i15) i2 = 0; else {
  d3 = +Math_floor(+(+(i8 | 0) * +(i14 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i2 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i5 = i12 - i11 | 0;
 i6 = (i5 | 0) == 0;
 do if (i10 | i6) i1 = 0; else {
  d3 = +Math_floor(+(+(i9 | 0) * +(i5 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i1 = i2 - i1 | 0;
 if (!i1) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i7 = (i21 | 0) == 0 | (i20 | 0) == 0;
 do if (i7) i8 = 0; else {
  d3 = +Math_floor(+(+(i21 | 0) * +(i20 | 0) / +(i1 | 0) + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i8 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 if ((i8 | 0) <= (i21 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 do if (i17 | i6) i2 = 0; else {
  d3 = +Math_floor(+(+(i16 | 0) * +(i5 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i2 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 do if (i19 | i15) i1 = 0; else {
  d3 = +Math_floor(+(+(i18 | 0) * +(i14 | 0) / 7.0 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 2;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 i1 = i2 - i1 | 0;
 if (!i1) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 do if (i7) i5 = 0; else {
  d3 = +Math_floor(+(+(i21 | 0) * +(i20 | 0) / +(i1 | 0) + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i5 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 if ((i5 | 0) <= (i21 | 0)) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 d35 = +Math_floor(+(1.0e10 / +(i21 | 0) + .5));
 d4 = +(i8 | 0);
 d34 = +Math_floor(+(1.0e10 / d4 + .5));
 d13 = +(i5 | 0);
 d3 = +Math_floor(+(1.0e10 / d13 + .5));
 i6 = (d35 <= 2147483647.0 & d35 >= -2147483648.0 ? ~~d35 : 0) - (d34 <= 2147483647.0 & d34 >= -2147483648.0 ? ~~d34 : 0) + (d3 <= 2147483647.0 & d3 >= -2147483648.0 ? 0 - ~~d3 | 0 : 0) | 0;
 if ((i6 | 0) < 1) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 if (!i8) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 do if (!i22) i1 = 0; else {
  d3 = +Math_floor(+(+(i22 | 0) * 1.0e5 / d4 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i23 >> 2] = i1;
 i2 = i23 + 4 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i1 | 0) * 1.0e5 / d4 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 8 | 0;
 i1 = 1e5 - (HEAP32[i24 >> 2] | 0) - (HEAP32[i31 >> 2] | 0) | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i1 | 0) * 1.0e5 / d4 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 12 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 if (!i5) {
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 }
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i1 | 0) * 1.0e5 / d13 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 16 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i1 | 0) * 1.0e5 / d13 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 20 | 0;
 i1 = 1e5 - (HEAP32[i25 >> 2] | 0) - (HEAP32[i26 >> 2] | 0) | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i1 | 0) * 1.0e5 / d13 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 24 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i6 | 0) * +(i1 | 0) / 1.0e5 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 28 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i6 | 0) * +(i1 | 0) / 1.0e5 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i2 = i23 + 32 | 0;
 i1 = 1e5 - (HEAP32[i27 >> 2] | 0) - (HEAP32[i28 >> 2] | 0) | 0;
 do if (!i1) i1 = 0; else {
  d3 = +Math_floor(+(+(i6 | 0) * +(i1 | 0) / 1.0e5 + .5));
  if (d3 <= 2147483647.0 & d3 >= -2147483648.0) {
   i1 = ~~d3;
   break;
  } else {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = i1;
 i1 = _UNITY_png_xy_from_XYZ(i32, i23) | 0;
 if (i1 | 0) {
  i32 = i1;
  STACKTOP = i33;
  return i32 | 0;
 }
 i23 = HEAP32[i29 >> 2] | 0;
 i29 = HEAP32[i32 + 24 >> 2] | 0;
 do if ((i23 | 0) < (i29 + -5 | 0) | (i23 | 0) > (i29 + 5 | 0)) i1 = 1; else {
  i29 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i32 + 28 >> 2] | 0;
  if ((i29 | 0) < (i30 + -5 | 0) | (i29 | 0) > (i30 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i29 = HEAP32[i24 >> 2] | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  if ((i29 | 0) < (i30 + -5 | 0) | (i29 | 0) > (i30 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i30 = HEAP32[i31 >> 2] | 0;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  if ((i30 | 0) < (i31 + -5 | 0) | (i30 | 0) > (i31 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i30 = HEAP32[i25 >> 2] | 0;
  i31 = HEAP32[i32 + 8 >> 2] | 0;
  if ((i30 | 0) < (i31 + -5 | 0) | (i30 | 0) > (i31 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i30 = HEAP32[i26 >> 2] | 0;
  i31 = HEAP32[i32 + 12 >> 2] | 0;
  if ((i30 | 0) < (i31 + -5 | 0) | (i30 | 0) > (i31 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i30 = HEAP32[i27 >> 2] | 0;
  i31 = HEAP32[i32 + 16 >> 2] | 0;
  if ((i30 | 0) < (i31 + -5 | 0) | (i30 | 0) > (i31 + 5 | 0)) {
   i1 = 1;
   break;
  }
  i2 = HEAP32[i28 >> 2] | 0;
  i1 = HEAP32[i32 + 20 >> 2] | 0;
  if ((i2 | 0) < (i1 + -5 | 0)) {
   i1 = 1;
   break;
  }
  i1 = (i2 | 0) > (i1 + 5 | 0);
 } while (0);
 i32 = i1 & 1;
 STACKTOP = i33;
 return i32 | 0;
}

function __Z19raycast_heightFieldRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i16, i24, i5, i10, f13, i38, i3, i39, i1, i2, i4) {
 i16 = i16 | 0;
 i24 = i24 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 f13 = Math_fround(f13);
 i38 = i38 | 0;
 i3 = i3 | 0;
 i39 = i39 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f40 = f0, f41 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i37 + 64 | 0;
 i21 = i37 + 44 | 0;
 i35 = i37 + 24 | 0;
 i2 = i37 + 12 | 0;
 i17 = i37;
 i30 = i16 + 4 | 0;
 i4 = HEAP32[i30 >> 2] | 0;
 i31 = i39 + 12 | 0;
 HEAP16[i31 >> 1] = 0;
 i32 = i24 + 16 | 0;
 f19 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i24 + 20 | 0;
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i24 + 24 | 0;
 f19 = Math_fround(f19 * Math_fround(-2.0));
 f14 = Math_fround(f14 * Math_fround(-2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) * Math_fround(-2.0));
 i18 = i24 + 12 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f40 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f6 = Math_fround(f19 * f15);
 i22 = i24 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f14 * f20));
 i23 = i24 + 8 | 0;
 f27 = Math_fround(HEAPF32[i23 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * f27));
 f9 = Math_fround(Math_fround(f15 * f6) + Math_fround(Math_fround(f19 * f40) - Math_fround(f8 * Math_fround(Math_fround(f7 * f20) - Math_fround(f14 * f27)))));
 f11 = Math_fround(Math_fround(f20 * f6) + Math_fround(Math_fround(f14 * f40) - Math_fround(f8 * Math_fround(Math_fround(f19 * f27) - Math_fround(f7 * f15)))));
 f6 = Math_fround(Math_fround(Math_fround(f7 * f40) - Math_fround(f8 * Math_fround(Math_fround(f14 * f15) - Math_fround(f19 * f20)))) + Math_fround(f27 * f6));
 f15 = Math_fround(-f15);
 f20 = Math_fround(-f20);
 f27 = Math_fround(-f27);
 f19 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(f14 * f20)) + Math_fround(f7 * f27));
 f9 = Math_fround(f9 + Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f40 * f19) + Math_fround(f8 * Math_fround(Math_fround(f7 * f20) - Math_fround(f14 * f27))))));
 f11 = Math_fround(f11 + Math_fround(Math_fround(f12 * f20) + Math_fround(Math_fround(f40 * f14) + Math_fround(f8 * Math_fround(Math_fround(f19 * f27) - Math_fround(f7 * f15))))));
 f12 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f40 * f7) + Math_fround(f8 * Math_fround(Math_fround(f14 * f15) - Math_fround(f19 * f20)))) + Math_fround(f12 * f27)));
 HEAPF32[i36 >> 2] = f9;
 i28 = i36 + 4 | 0;
 HEAPF32[i28 >> 2] = f11;
 i29 = i36 + 8 | 0;
 HEAPF32[i29 >> 2] = f12;
 f19 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(f14 * f20)) + Math_fround(f7 * f27));
 f25 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f40 * f19) + Math_fround(f8 * Math_fround(Math_fround(f7 * f20) - Math_fround(f14 * f27)))));
 f26 = Math_fround(Math_fround(f6 * f20) + Math_fround(Math_fround(f40 * f14) + Math_fround(f8 * Math_fround(Math_fround(f19 * f27) - Math_fround(f7 * f15)))));
 f27 = Math_fround(Math_fround(Math_fround(f40 * f7) + Math_fround(f8 * Math_fround(Math_fround(f14 * f15) - Math_fround(f19 * f20)))) + Math_fround(f6 * f27));
 i10 = HEAP32[i30 >> 2] | 0;
 HEAP32[i30 >> 2] = i4;
 i3 = i21 + 12 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i21 + 16 >> 2] = i16;
 i4 = i21 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i16 + 8 >> 2]));
 HEAPF32[i21 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i16 + 12 >> 2]));
 i5 = i21 + 8 | 0;
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i16 + 16 >> 2]));
 i1 = i35 + 16 | 0;
 HEAP8[i1 >> 0] = 0;
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26)))));
 if (f6 < Math_fround(9.99999968e-21)) {
  f6 = f27;
  f7 = f26;
  f8 = f25;
 } else {
  f8 = Math_fround(Math_fround(1.0) / f6);
  f6 = Math_fround(f27 * f8);
  f7 = Math_fround(f26 * f8);
  f8 = Math_fround(f25 * f8);
 }
 i16 = f13 < Math_fround(1.0e10);
 f19 = i16 ? f13 : Math_fround(1.0e10);
 f20 = Math_fround(Math_fround(f19 * f7) + f11);
 f40 = Math_fround(Math_fround(f19 * f6) + f12);
 HEAPF32[i2 >> 2] = Math_fround(f9 + Math_fround(f19 * f8));
 HEAPF32[i2 + 4 >> 2] = f20;
 HEAPF32[i2 + 8 >> 2] = f40;
 __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_15RayCastCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_(i21, i36, i2, i35, 0);
 if (!(HEAP8[i1 >> 0] | 0)) {
  i39 = 0;
  HEAP32[i30 >> 2] = i10;
  STACKTOP = i37;
  return i39 | 0;
 }
 HEAP32[i39 + 8 >> 2] = HEAP32[i35 + 12 >> 2];
 f19 = Math_fround(HEAPF32[i35 >> 2]);
 f20 = Math_fround(HEAPF32[i35 + 8 >> 2]);
 f40 = Math_fround(HEAPF32[i21 >> 2]);
 f14 = Math_fround(f19 * f40);
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 f41 = Math_fround(f20 * f8);
 __ZNK5physx2Gu11HeightField10getNormal_Efffff(i17, HEAP32[i3 >> 2] | 0, f14, f41, f40, Math_fround(HEAPF32[i4 >> 2]), f8);
 f8 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(2.0));
 f40 = Math_fround(Math_fround(HEAPF32[i17 + 4 >> 2]) * Math_fround(2.0));
 f41 = Math_fround(Math_fround(HEAPF32[i17 + 8 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i18 >> 2]);
 f15 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f13 = Math_fround(HEAPF32[i24 >> 2]);
 f7 = Math_fround(f8 * f13);
 f12 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f40 * f12));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f41 * f11));
 f6 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f8 * f15) + Math_fround(f14 * Math_fround(Math_fround(f41 * f12) - Math_fround(f40 * f11)))));
 f9 = Math_fround(Math_fround(f12 * f7) + Math_fround(Math_fround(f40 * f15) + Math_fround(f14 * Math_fround(Math_fround(f8 * f11) - Math_fround(f41 * f13)))));
 f7 = Math_fround(Math_fround(Math_fround(f41 * f15) + Math_fround(f14 * Math_fround(Math_fround(f40 * f13) - Math_fround(f8 * f12)))) + Math_fround(f11 * f7));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)))));
 if (f8 > Math_fround(0.0)) {
  f41 = Math_fround(Math_fround(1.0) / f8);
  f7 = Math_fround(f7 * f41);
  f8 = Math_fround(f9 * f41);
  f6 = Math_fround(f6 * f41);
 } else f8 = f9;
 i1 = HEAP16[i38 >> 1] | 0;
 if (i1 & 2) {
  HEAPF32[i39 + 28 >> 2] = f6;
  HEAPF32[i39 + 32 >> 2] = f8;
  HEAPF32[i39 + 36 >> 2] = f7;
  HEAP16[i31 >> 1] = HEAPU16[i31 >> 1] | 2;
 }
 if (i1 & 4) {
  f40 = Math_fround(f19 - Math_fround(HEAPF32[i36 >> 2]));
  f41 = Math_fround(HEAPF32[i35 + 4 >> 2]);
  f41 = Math_fround(f41 - Math_fround(HEAPF32[i28 >> 2]));
  HEAPF32[i39 + 40 >> 2] = Math_fround(Math_fround(Math_fround(f25 * f40) + Math_fround(f26 * f41)) + Math_fround(f27 * Math_fround(f20 - Math_fround(HEAPF32[i29 >> 2]))));
  HEAP16[i31 >> 1] = HEAPU16[i31 >> 1] | 4;
 }
 if (!(i1 & 1)) {
  i39 = 1;
  HEAP32[i30 >> 2] = i10;
  STACKTOP = i37;
  return i39 | 0;
 }
 f26 = Math_fround(f19 * Math_fround(2.0));
 f25 = Math_fround(Math_fround(HEAPF32[i35 + 4 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f41 = Math_fround(Math_fround(Math_fround(f26 * f13) + Math_fround(f25 * f12)) + Math_fround(f20 * f11));
 f27 = Math_fround(Math_fround(f13 * f41) + Math_fround(Math_fround(f26 * f15) + Math_fround(f14 * Math_fround(Math_fround(f20 * f12) - Math_fround(f25 * f11)))));
 f40 = Math_fround(Math_fround(f12 * f41) + Math_fround(Math_fround(f25 * f15) + Math_fround(f14 * Math_fround(Math_fround(f26 * f11) - Math_fround(f20 * f13)))));
 f41 = Math_fround(Math_fround(Math_fround(f20 * f15) + Math_fround(f14 * Math_fround(Math_fround(f25 * f13) - Math_fround(f26 * f12)))) + Math_fround(f11 * f41));
 f27 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) + f27);
 f40 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) + f40);
 f41 = Math_fround(Math_fround(HEAPF32[i34 >> 2]) + f41);
 HEAPF32[i39 + 16 >> 2] = f27;
 HEAPF32[i39 + 20 >> 2] = f40;
 HEAPF32[i39 + 24 >> 2] = f41;
 HEAP16[i31 >> 1] = HEAPU16[i31 >> 1] | 1;
 i39 = 1;
 HEAP32[i30 >> 2] = i10;
 STACKTOP = i37;
 return i39 | 0;
}

function __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, d10 = 0.0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 switch ((i1 & 255) << 24 >> 24) {
 case 0:
  {
   __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 0);
   i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteNullEv(i9) | 0;
   return i9 | 0;
  }
 case 1:
  {
   __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 1);
   i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb(i9, 0) | 0;
   return i9 | 0;
  }
 case 2:
  {
   __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 2);
   i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb(i9, 1) | 0;
   return i9 | 0;
  }
 case 3:
  {
   if (!(__ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv(i9) | 0)) {
    i9 = 0;
    return i9 | 0;
   }
   i4 = i5 + 4 | 0;
   L12 : do if (HEAP32[i4 >> 2] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    while (1) {
     if (!(HEAP32[i1 + 16 >> 2] & 4194304)) {
      i2 = HEAP32[i1 >> 2] | 0;
      i3 = HEAP32[i1 + 4 >> 2] | 0;
     } else {
      i2 = i1;
      i3 = 11 - (HEAP8[i1 + 11 >> 0] | 0) | 0;
     }
     __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 5);
     if (!(__ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj(i9, i2, i3) | 0)) {
      i1 = 0;
      i2 = 58;
      break;
     }
     if (!(__ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1 + 24 | 0, i9) | 0)) {
      i1 = 0;
      i2 = 58;
      break;
     }
     i1 = i1 + 48 | 0;
     if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 48 | 0) | 0)) break L12;
    }
    if ((i2 | 0) == 58) return i1 | 0;
   } while (0);
   i7 = i9 + 16 | 0;
   i8 = (HEAP32[i7 >> 2] | 0) + -8 | 0;
   HEAP32[i7 >> 2] = i8;
   if (HEAP32[i8 >> 2] | 0) {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = i2 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = i2 + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i5 >>> 0 > i8 >>> 0) {
     i1 = i7 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = i8;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i5;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 10;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv(i9);
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 125;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   if (!(__ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv(i9) | 0)) {
    i9 = 0;
    return i9 | 0;
   }
   i2 = i5 + 4 | 0;
   L48 : do if (HEAP32[i2 >> 2] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    while (1) {
     if (!(__ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1, i9) | 0)) {
      i1 = 0;
      break;
     }
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) | 0)) break L48;
    }
    return i1 | 0;
   } while (0);
   i7 = i9 + 16 | 0;
   i8 = (HEAP32[i7 >> 2] | 0) + -8 | 0;
   HEAP32[i7 >> 2] = i8;
   if (HEAP32[i8 >> 2] | 0) {
    i5 = HEAP32[i9 >> 2] | 0;
    i6 = i5 + 12 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 + 1 | 0;
    i2 = i5 + 16 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i8 >>> 0 > i4 >>> 0) {
     i1 = i3 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i2 >> 2] = i1;
      HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
      HEAP32[i2 >> 2] = i1;
      HEAP32[i5 >> 2] = i4;
      break;
     }
    } while (0);
    HEAP32[i6 >> 2] = i8;
    HEAP8[(HEAP32[i5 >> 2] | 0) + i7 >> 0] = 10;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv(i9);
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 93;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   if (!(i1 & 4194304)) {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i5 + 4 >> 2] | 0;
   } else {
    i2 = i5;
    i1 = 11 - (HEAP8[i5 + 11 >> 0] | 0) | 0;
   }
   __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 5);
   i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj(i9, i2, i1) | 0;
   return i9 | 0;
  }
 case 6:
  {
   if (i1 & 1024 | 0) {
    i8 = HEAP32[i5 >> 2] | 0;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 6);
    i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE8WriteIntEi(i9, i8) | 0;
    return i9 | 0;
   }
   if (i1 & 2048 | 0) {
    i8 = HEAP32[i5 >> 2] | 0;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 6);
    i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteUintEj(i9, i8) | 0;
    return i9 | 0;
   }
   if (i1 & 4096 | 0) {
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 6);
    i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10WriteInt64Ex(i9, i7, i8) | 0;
    return i9 | 0;
   }
   if (!(i1 & 8192)) {
    d10 = +HEAPF64[i5 >> 3];
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 6);
    i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteDoubleEd(i9, d10) | 0;
    return i9 | 0;
   } else {
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 6);
    i9 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteUint64Ey(i9, i7, i8) | 0;
    return i9 | 0;
   }
  }
 default:
  {
   i9 = 0;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i2, i3, i48, i49, i50, i51) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, i57 = 0, i58 = 0, f59 = f0, f60 = f0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i53 + 160 | 0;
 i45 = i53 + 96 | 0;
 i46 = i53 + 32 | 0;
 i39 = i53 + 260 | 0;
 i52 = i53 + 16 | 0;
 i43 = i53 + 248 | 0;
 i40 = i53;
 i29 = i53 + 236 | 0;
 i44 = i53 + 224 | 0;
 HEAP32[i39 >> 2] = 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(f1 - f9);
 f10 = Math_fround(f30 - f10);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 i41 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11)) > Math_fround(0.0);
 f9 = i41 ? f9 : Math_fround(1.0);
 f10 = i41 ? f10 : Math_fround(0.0);
 f11 = i41 ? f11 : Math_fround(0.0);
 HEAPF32[i52 >> 2] = f9;
 i41 = i52 + 4 | 0;
 HEAPF32[i41 >> 2] = f10;
 i42 = i52 + 8 | 0;
 HEAPF32[i42 >> 2] = f11;
 HEAPF32[i52 + 12 >> 2] = Math_fround(0.0);
 f30 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f1 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f30 = Math_fround((f30 > f1 ? f1 : f30) * Math_fround(.100000001));
 f30 = Math_fround(f30 * f30);
 i31 = i2 + 96 | 0;
 i32 = i2 + 100 | 0;
 i33 = i2 + 104 | 0;
 i34 = i2 + 112 | 0;
 i35 = i2 + 116 | 0;
 i36 = i2 + 120 | 0;
 i37 = i2 + 128 | 0;
 i38 = i2 + 132 | 0;
 i26 = i2 + 136 | 0;
 i27 = i3 + 144 | 0;
 i28 = i3 + 148 | 0;
 i8 = i3 + 152 | 0;
 i18 = i40 + 4 | 0;
 i19 = i40 + 8 | 0;
 i20 = i40 + 12 | 0;
 i21 = i47 + 4 | 0;
 i22 = i47 + 8 | 0;
 i23 = i47 + 16 | 0;
 i24 = i47 + 20 | 0;
 i25 = i47 + 24 | 0;
 f1 = Math_fround(3402823469999999843913219.0e14);
 i2 = 0;
 while (1) {
  f7 = Math_fround(-f9);
  f6 = Math_fround(-f10);
  f5 = Math_fround(-f11);
  f16 = Math_fround(HEAPF32[i31 >> 2]);
  f14 = Math_fround(HEAPF32[i32 >> 2]);
  f12 = Math_fround(HEAPF32[i33 >> 2]);
  f15 = Math_fround(HEAPF32[i34 >> 2]);
  f4 = Math_fround(HEAPF32[i35 >> 2]);
  f13 = Math_fround(HEAPF32[i36 >> 2]);
  f56 = Math_fround(HEAPF32[i37 >> 2]);
  f55 = Math_fround(HEAPF32[i38 >> 2]);
  f54 = Math_fround(HEAPF32[i26 >> 2]);
  f60 = Math_fround(Math_fround(Math_fround(f16 * f7) + Math_fround(f14 * f6)) + Math_fround(f12 * f5));
  f59 = Math_fround(Math_fround(Math_fround(f15 * f7) + Math_fround(f4 * f6)) + Math_fround(f13 * f5));
  f17 = Math_fround(Math_fround(Math_fround(f56 * f7) + Math_fround(f55 * f6)) + Math_fround(f54 * f5));
  i57 = f60 > f59 & f60 > f17;
  i58 = f59 > f17;
  f56 = i57 ? f16 : i58 ? f15 : f56;
  f55 = i57 ? f14 : i58 ? f4 : f55;
  f54 = i57 ? f12 : i58 ? f13 : f54;
  i58 = f9 > Math_fround(0.0);
  i57 = f10 > Math_fround(0.0);
  i3 = f11 > Math_fround(0.0);
  f13 = Math_fround(HEAPF32[i27 >> 2]);
  f12 = Math_fround(HEAPF32[i28 >> 2]);
  f4 = Math_fround(HEAPF32[i8 >> 2]);
  f14 = Math_fround(-f13);
  f15 = Math_fround(-f12);
  f16 = Math_fround(-f4);
  f14 = i58 ? f13 : f14;
  f15 = i57 ? f12 : f15;
  f16 = i3 ? f4 : f16;
  f4 = Math_fround(f56 - f14);
  f12 = Math_fround(f55 - f15);
  f13 = Math_fround(f54 - f16);
  f17 = Math_fround(f1 - Math_fround(Math_fround(f11 * f13) + Math_fround(Math_fround(f9 * f4) + Math_fround(f10 * f12))));
  HEAPF32[i45 + (i2 << 4) >> 2] = f56;
  HEAPF32[i45 + (i2 << 4) + 4 >> 2] = f55;
  HEAPF32[i45 + (i2 << 4) + 8 >> 2] = f54;
  HEAPF32[i45 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i46 + (i2 << 4) >> 2] = f14;
  HEAPF32[i46 + (i2 << 4) + 4 >> 2] = f15;
  HEAPF32[i46 + (i2 << 4) + 8 >> 2] = f16;
  HEAPF32[i46 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i47 + (i2 << 4) >> 2] = f4;
  HEAPF32[i47 + (i2 << 4) + 4 >> 2] = f12;
  HEAPF32[i47 + (i2 << 4) + 8 >> 2] = f13;
  HEAPF32[i47 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f1 * Math_fround(.000224999996)) > f17) {
   i8 = 3;
   break;
  }
  HEAP32[i39 >> 2] = i2 + 1;
  L4 : do switch (i2 | 0) {
  case 0:
   {
    HEAPF32[i40 >> 2] = f4;
    HEAPF32[i18 >> 2] = f12;
    HEAPF32[i19 >> 2] = f13;
    HEAPF32[i20 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f4 = Math_fround(HEAPF32[i47 >> 2]);
    f12 = Math_fround(HEAPF32[i21 >> 2]);
    f13 = Math_fround(HEAPF32[i22 >> 2]);
    f14 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f4);
    f15 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f12);
    f16 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f13);
    f17 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16));
    if (!(f17 <= Math_fround(1.1920929e-07))) {
     f56 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f12 * f15)) - Math_fround(f4 * f14)) - Math_fround(f13 * f16)) / f17);
     i58 = f56 > Math_fround(1.0);
     f56 = i58 ? Math_fround(1.0) : f56;
     i58 = f56 > Math_fround(0.0);
     f56 = i58 ? f56 : Math_fround(0.0);
     f59 = Math_fround(f12 + Math_fround(f15 * f56));
     f60 = Math_fround(f13 + Math_fround(f16 * f56));
     HEAPF32[i40 >> 2] = Math_fround(f4 + Math_fround(f14 * f56));
     HEAPF32[i18 >> 2] = f59;
     HEAPF32[i19 >> 2] = f60;
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i39 >> 2] = 1;
     HEAP32[i40 >> 2] = HEAP32[i47 >> 2];
     HEAP32[i40 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
     HEAP32[i40 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
     HEAP32[i40 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i40, i47, i45, i46, i39);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i40, i47, i45, i46, i39);
    break;
   }
  default:
   {
    HEAPF32[i40 >> 2] = f4;
    HEAPF32[i18 >> 2] = f12;
    HEAPF32[i19 >> 2] = f13;
    HEAPF32[i20 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i52 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  f12 = Math_fround(HEAPF32[i52 >> 2]);
  f13 = Math_fround(HEAPF32[i41 >> 2]);
  f14 = Math_fround(HEAPF32[i42 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14));
  HEAP32[i43 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i43 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
  HEAP32[i43 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
  i3 = f1 > f4;
  i2 = HEAP32[i39 >> 2] | 0;
  if (f4 > f30 & i3) {
   f1 = f4;
   f9 = f12;
   f10 = f13;
   f11 = f14;
  } else {
   i8 = 13;
   break;
  }
 }
 if ((i8 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i47, i45, i46, i52, i48, i49, i2);
  f55 = Math_fround(HEAPF32[i52 >> 2]);
  f59 = Math_fround(HEAPF32[i41 >> 2]);
  f60 = Math_fround(HEAPF32[i42 >> 2]);
  f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f59 * f59)) + Math_fround(f60 * f60)))));
  f59 = Math_fround(-Math_fround(f59 * f56));
  f60 = Math_fround(-Math_fround(f60 * f56));
  HEAPF32[i50 >> 2] = Math_fround(-Math_fround(f55 * f56));
  HEAPF32[i50 + 4 >> 2] = f59;
  HEAPF32[i50 + 8 >> 2] = f60;
  HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i51 >> 2] = f1;
  i58 = i51 + 4 | 0;
  HEAP32[i58 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  i58 = 0;
  STACKTOP = i53;
  return i58 | 0;
 } else if ((i8 | 0) == 13) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i47, i45, i46, i52, i48, i49, i2);
  f56 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11)))));
  f59 = Math_fround(f56 * f6);
  f60 = Math_fround(f56 * f5);
  HEAPF32[i50 >> 2] = Math_fround(f56 * f7);
  HEAPF32[i50 + 4 >> 2] = f59;
  HEAPF32[i50 + 8 >> 2] = f60;
  HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i51 >> 2] = i3 ? f4 : f1;
  i58 = i51 + 4 | 0;
  HEAP32[i58 >> 2] = HEAP32[i44 >> 2];
  HEAP32[i58 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
  HEAP32[i58 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
  i58 = i3 ? 1 : 3;
  STACKTOP = i53;
  return i58 | 0;
 }
 return 0;
}

function __ZN5physx2Sc5Scene16afterIntegrationEPNS_10PxBaseTaskE(i22, i18) {
 i22 = i22 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24;
 i14 = i24 + 8 | 0;
 i13 = i22 + 1204 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i1 + 1e3 >> 2] | 0;
 i19 = HEAP32[i3 + 6776 >> 2] | 0;
 i2 = HEAP32[i3 + 6764 >> 2] | 0;
 if (!i19) i23 = i3; else {
  i1 = HEAP32[i13 >> 2] | 0;
  i23 = HEAP32[i1 + 1e3 >> 2] | 0;
 }
 i17 = HEAP32[i23 + 6960 >> 2] | 0;
 if (!i2) i16 = 0; else i16 = HEAP32[(HEAP32[i3 + 6760 >> 2] | 0) + (i2 << 4) >> 2] | 0;
 i21 = i23 + 7612 | 0;
 i12 = HEAP32[i1 + 12 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i7 + (i12 << 2) | 0;
 i20 = i23 + 5912 | 0;
 i9 = i23 + 5916 | 0;
 _memset(HEAP32[i20 >> 2] | 0, 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
 if (i12 | 0) {
  i10 = i23 + 5920 | 0;
  i11 = 0;
  i4 = i7 + 64 | 0;
  do {
   if (i4 >>> 0 < i8 >>> 0) {
    i3 = HEAP32[i4 >> 2] | 0;
    i2 = i3;
    i5 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
    i6 = getTempRet0() | 0;
    i2 = _i64Add(i2 | 0, 0, 1023, 0) | 0;
    i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
    i1 = getTempRet0() | 0;
    i6 = _i64Subtract(1, 0, i5 | 0, i6 | 0) | 0;
    i1 = _i64Add(i6 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
    i2 = getTempRet0() | 0;
    while (1) {
     i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
     i2 = getTempRet0() | 0;
     if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
    }
    i4 = i4 + 4 | 0;
   }
   i5 = HEAP32[i7 + (i11 << 2) >> 2] | 0;
   __ZN5physx2Sc7BodySim19updateKinematicPoseEv(i5);
   i6 = HEAP32[i5 + 136 >> 2] | 0;
   if ((i6 | 0) != 1073741823) {
    i2 = (i6 + 32 | 0) >>> 5;
    if (i2 >>> 0 > (HEAP32[i9 >> 2] & 2147483647) >>> 0) {
     i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i2 << 2, gb + 769739 | 0, 329) | 0;
     i3 = HEAP32[i20 >> 2] | 0;
     if (i3 | 0) {
      _memcpy(i1 | 0, i3 | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
      if ((HEAP32[i9 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i20 >> 2] | 0);
     }
     i3 = HEAP32[i9 >> 2] | 0;
     _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i2 - i3 << 2 | 0) | 0;
     HEAP32[i20 >> 2] = i1;
     HEAP32[i9 >> 2] = i2;
    } else i1 = HEAP32[i20 >> 2] | 0;
    i3 = i1 + (i6 >>> 5 << 2) | 0;
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i6 & 31);
   }
   __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(i5, i21);
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i12 | 0));
 }
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i4 + (i3 << 2) | 0;
 i2 = i3 << 2;
 i13 = i2 >>> 0 > 1024;
 i9 = i15 + 4 | 0;
 HEAP8[i9 >> 0] = i13 & 1;
 if (i13) HEAP32[i15 >> 2] = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i14, i2, gb + 680241 | 0, 2188) | 0; else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i15 >> 2] = i1;
 }
 if ((i3 | 0) > 0) {
  i6 = i4 + (i3 + -1 << 2) | 0;
  i7 = i4;
  i5 = i4 + 32 | 0;
  i1 = 0;
  do {
   if (i5 >>> 0 <= i6 >>> 0) {
    i4 = HEAP32[i5 >> 2] | 0;
    i3 = i4;
    i13 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
    i14 = getTempRet0() | 0;
    i3 = _i64Add(i3 | 0, 0, 511, 0) | 0;
    i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
    i2 = getTempRet0() | 0;
    i14 = _i64Subtract(1, 0, i13 | 0, i14 | 0) | 0;
    i2 = _i64Add(i14 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
    i3 = getTempRet0() | 0;
    while (1) {
     i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
     i3 = getTempRet0() | 0;
     if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
    }
    i5 = i5 + 4 | 0;
   }
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 60 >> 2] | 0;
   if (i2) {
    i2 = __ZN5physx2Sc19ConstraintGroupNode7getRootEv(i2) | 0;
    i3 = i2 + 44 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if (!(i4 & 2)) if (HEAP32[i2 + 20 >> 2] | 0) {
     HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] = i2;
     HEAP8[i3 >> 0] = i4 & 255 | 2;
     i1 = i1 + 1 | 0;
    }
   }
   i7 = i7 + 4 | 0;
  } while (i7 >>> 0 < i8 >>> 0);
  if (i1 | 0) {
   i2 = HEAP32[i15 >> 2] | 0;
   do {
    i1 = i1 + -1 | 0;
    __ZN5physx2Sc19ConstraintGroupNode11projectPoseERS1_(HEAP32[i2 + (i1 << 2) >> 2] | 0);
    i2 = HEAP32[i15 >> 2] | 0;
    i14 = (HEAP32[i2 + (i1 << 2) >> 2] | 0) + 44 | 0;
    HEAP8[i14 >> 0] = HEAPU8[i14 >> 0] & 253;
   } while ((i1 | 0) != 0);
  }
 }
 if (HEAP8[i9 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i15, HEAP32[i15 >> 2] | 0);
 if (i16 | 0) {
  i2 = i22 + 1150 | 0;
  i3 = i22 + 64 | 0;
  i4 = i22 + 68 | 0;
  if (!i18) {
   i1 = 0;
   do {
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i17 >> 2] | 0);
    i18 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i17, 48, 16) | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i17 >> 2] | 0);
    i10 = i16 - i1 | 0;
    i13 = HEAP8[i2 >> 0] | 0;
    i11 = HEAP32[i3 >> 2] | 0;
    i12 = HEAP32[i4 >> 2] | 0;
    HEAP16[i18 + 4 >> 1] = -1;
    HEAP16[i18 + 6 >> 1] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 >> 2] = gb + 87404 + 8;
    i15 = i18 + 12 | 0;
    HEAP32[i15 >> 2] = 0;
    i14 = i18 + 16 | 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i18 >> 2] = gb + 106488 + 8;
    HEAP32[i18 + 20 >> 2] = i19 + (i1 << 2);
    HEAP32[i18 + 24 >> 2] = i10 >>> 0 < 128 ? i10 : 128;
    HEAP32[i18 + 28 >> 2] = i11;
    HEAP32[i18 + 32 >> 2] = i12;
    HEAP8[i18 + 36 >> 0] = i13;
    HEAP32[i18 + 40 >> 2] = i23;
    HEAP32[i18 + 44 >> 2] = i21;
    HEAP32[i14 >> 2] = 1;
    HEAP32[i15 >> 2] = 0;
    mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 20 >> 2] | 0, i18 | 0);
    i1 = i1 + 128 | 0;
   } while (i16 >>> 0 > i1 >>> 0);
  } else {
   i1 = 0;
   do {
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i17 >> 2] | 0);
    i15 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i17, 48, 16) | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i17 >> 2] | 0);
    i8 = i16 - i1 | 0;
    i11 = HEAP8[i2 >> 0] | 0;
    i9 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i4 >> 2] | 0;
    HEAP16[i15 + 4 >> 1] = -1;
    HEAP16[i15 + 6 >> 1] = 0;
    i14 = i15 + 8 | 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i15 >> 2] = gb + 87404 + 8;
    i13 = i15 + 12 | 0;
    HEAP32[i13 >> 2] = 0;
    i12 = i15 + 16 | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i15 >> 2] = gb + 106488 + 8;
    HEAP32[i15 + 20 >> 2] = i19 + (i1 << 2);
    HEAP32[i15 + 24 >> 2] = i8 >>> 0 < 128 ? i8 : 128;
    HEAP32[i15 + 28 >> 2] = i9;
    HEAP32[i15 + 32 >> 2] = i10;
    HEAP8[i15 + 36 >> 0] = i11;
    HEAP32[i15 + 40 >> 2] = i23;
    HEAP32[i15 + 44 >> 2] = i21;
    HEAP32[i12 >> 2] = 1;
    HEAP32[i13 >> 2] = i18;
    mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
    HEAP32[i14 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, i15 | 0);
    i1 = i1 + 128 | 0;
   } while (i16 >>> 0 > i1 >>> 0);
  }
 }
 i8 = i22 + 124 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i24;
  return;
 }
 i9 = i23 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i9 >> 2] | 0) | 0;
 if (!i1) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i18 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i18 | 0, i19 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i19 = i1 + 19 & -16;
   HEAP32[i19 + -4 >> 2] = i19 - i1;
   i1 = i19;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i23);
 }
 i4 = i1 + 9156 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i5 = i22 + 120 | 0;
  i6 = i22 + 64 | 0;
  i7 = i22 + 68 | 0;
  i2 = i22 + 1150 | 0;
  i3 = 0;
  do {
   f26 = Math_fround(HEAPF32[i6 >> 2]);
   f25 = Math_fround(HEAPF32[i7 >> 2]);
   __ZN5physx2Sc15ArticulationSim10sleepCheckEffb(HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] >> 2] | 0, f26, f25, (HEAP8[i2 >> 0] | 0) != 0);
   __ZN5physx2Sc15ArticulationSim22updateCachedTransformsERNS_17PxsTransformCacheEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] >> 2] | 0, i21, i4);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 i23 = (HEAP32[i23 + 12 >> 2] | 0) + 156 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i23 >> 2] | 0);
 __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj(i20, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 9160 >> 2] & 2147483647);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i23 >> 2] | 0);
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i9 >> 2] | 0, i1);
 STACKTOP = i24;
 return;
}

function __ZN27ConvexVsMeshOverlapCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i25, i1, i4, i5, i7, i2, i3) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 208 | 0;
 i23 = i24 + 64 | 0;
 i22 = i24;
 i9 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i19 = HEAP32[i4 + 8 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i20 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 f44 = Math_fround(HEAPF32[i25 + 64 >> 2]);
 f41 = Math_fround(HEAPF32[i25 + 68 >> 2]);
 f30 = Math_fround(HEAPF32[i25 + 72 >> 2]);
 f10 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = Math_fround(HEAPF32[i25 + 16 >> 2]);
 f27 = Math_fround(f10 * f43);
 f42 = Math_fround(HEAPF32[i25 + 32 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f11 * f42));
 f36 = Math_fround(HEAPF32[i25 + 48 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f12 * f36));
 f40 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 f31 = Math_fround(f10 * f40);
 f39 = Math_fround(HEAPF32[i25 + 36 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f11 * f39));
 f32 = Math_fround(HEAPF32[i25 + 52 >> 2]);
 f31 = Math_fround(f31 + Math_fround(f12 * f32));
 f34 = Math_fround(HEAPF32[i25 + 24 >> 2]);
 f35 = Math_fround(f10 * f34);
 f38 = Math_fround(HEAPF32[i25 + 40 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f11 * f38));
 f28 = Math_fround(HEAPF32[i25 + 56 >> 2]);
 f27 = Math_fround(f44 + f27);
 f31 = Math_fround(f41 + f31);
 f35 = Math_fround(f30 + Math_fround(f35 + Math_fround(f12 * f28)));
 f13 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f37 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f13 * f43) + Math_fround(f14 * f42)) + Math_fround(f15 * f36)));
 f33 = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(f14 * f39)) + Math_fround(f15 * f32)));
 f29 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f13 * f34) + Math_fround(f14 * f38)) + Math_fround(f15 * f28)));
 f16 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f16 * f43) + Math_fround(f17 * f42)) + Math_fround(f18 * f36)));
 f32 = Math_fround(f41 + Math_fround(Math_fround(Math_fround(f16 * f40) + Math_fround(f17 * f39)) + Math_fround(f18 * f32)));
 f28 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f16 * f34) + Math_fround(f17 * f38)) + Math_fround(f18 * f28)));
 f38 = f27 < f37 ? f27 : f37;
 f34 = f31 < f33 ? f31 : f33;
 f30 = f35 < f29 ? f35 : f29;
 f37 = f27 > f37 ? f27 : f37;
 f33 = f31 > f33 ? f31 : f33;
 f29 = f35 > f29 ? f35 : f29;
 f35 = Math_fround(HEAPF32[i25 + 80 >> 2]);
 f31 = Math_fround(HEAPF32[i25 + 84 >> 2]);
 f27 = Math_fround(HEAPF32[i25 + 88 >> 2]);
 if (((f38 < f36 ? f38 : f36) > f35 ? 1 : (f37 > f36 ? f37 : f36) < Math_fround(-f35)) | ((f34 < f32 ? f34 : f32) > f31 ? 1 : (f33 > f32 ? f33 : f32) < Math_fround(-f31)) | ((f30 < f28 ? f30 : f28) > f27 ? 1 : (f29 > f28 ? f29 : f28) < Math_fround(-f27))) {
  i26 = 1;
  STACKTOP = i24;
  return i26 | 0;
 }
 if (!(HEAP8[i25 + 433 >> 0] | 0)) {
  f36 = Math_fround(HEAPF32[i25 + 384 >> 2]);
  f35 = Math_fround(f10 * f36);
  f37 = Math_fround(HEAPF32[i25 + 400 >> 2]);
  f35 = Math_fround(f35 + Math_fround(f11 * f37));
  f42 = Math_fround(HEAPF32[i25 + 416 >> 2]);
  f35 = Math_fround(f35 + Math_fround(f12 * f42));
  f38 = Math_fround(HEAPF32[i25 + 388 >> 2]);
  f34 = Math_fround(f10 * f38);
  f39 = Math_fround(HEAPF32[i25 + 404 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f11 * f39));
  f43 = Math_fround(HEAPF32[i25 + 420 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f12 * f43));
  f40 = Math_fround(HEAPF32[i25 + 392 >> 2]);
  f33 = Math_fround(f10 * f40);
  f41 = Math_fround(HEAPF32[i25 + 408 >> 2]);
  f33 = Math_fround(f33 + Math_fround(f11 * f41));
  f44 = Math_fround(HEAPF32[i25 + 424 >> 2]);
  f33 = Math_fround(f33 + Math_fround(f12 * f44));
  i9 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround(Math_fround(Math_fround(f13 * f36) + Math_fround(f14 * f37)) + Math_fround(f15 * f42));
  f34 = Math_fround(Math_fround(Math_fround(f13 * f38) + Math_fround(f14 * f39)) + Math_fround(f15 * f43));
  f35 = Math_fround(Math_fround(Math_fround(f13 * f40) + Math_fround(f14 * f41)) + Math_fround(f15 * f44));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
  f42 = Math_fround(Math_fround(Math_fround(f16 * f36) + Math_fround(f17 * f37)) + Math_fround(f18 * f42));
  f43 = Math_fround(Math_fround(Math_fround(f16 * f38) + Math_fround(f17 * f39)) + Math_fround(f18 * f43));
  f44 = Math_fround(Math_fround(Math_fround(f16 * f40) + Math_fround(f17 * f41)) + Math_fround(f18 * f44));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i7 = i19;
  i5 = i20;
 }
 i20 = i23 + 64 | 0;
 HEAP32[i23 + 80 >> 2] = 7;
 HEAPF32[i23 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 f43 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f42 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f44 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = Math_fround(f43 + f41);
 f40 = Math_fround(f42 + f40);
 f44 = Math_fround(f44 + (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f42 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f43 = Math_fround(Math_fround(f40 + f43) * Math_fround(.333332986));
 f44 = Math_fround(Math_fround(f44 + (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.333332986));
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(f41 + f42) * Math_fround(.333332986));
 HEAPF32[i23 + 4 >> 2] = f43;
 HEAPF32[i23 + 8 >> 2] = f44;
 HEAPF32[i23 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i23 + 96 >> 2] = i9;
 HEAP32[i23 + 100 >> 2] = i8;
 HEAP32[i23 + 104 >> 2] = i7;
 HEAPF32[i23 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i23 + 112 >> 2] = i6;
 HEAP32[i23 + 116 >> 2] = i5;
 HEAP32[i23 + 120 >> 2] = i4;
 HEAPF32[i23 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i23 + 128 >> 2] = i3;
 HEAP32[i23 + 132 >> 2] = i2;
 HEAP32[i23 + 136 >> 2] = i1;
 HEAPF32[i23 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if ((__ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i23, i25 + 96 | 0, i25 + 304 | 0, i24 + 48 | 0, i24 + 32 | 0, i24 + 16 | 0, i22) | 0) == 1) i26 = 6; else {
  f44 = Math_fround(HEAPF32[i25 + 368 >> 2]);
  if (!(f44 >= Math_fround(HEAPF32[i22 >> 2]))) i1 = 1; else i26 = 6;
 }
 if ((i26 | 0) == 6) {
  HEAP8[i25 + 432 >> 0] = 1;
  i1 = 0;
 }
 i26 = i1;
 STACKTOP = i24;
 return i26 | 0;
}

function __ZN10systeminfo23GetSystemLanguageStringEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do switch (i2 | 0) {
 case 0:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455148 | 0, 9);
   return;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455158 | 0, 6);
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455165 | 0, 6);
   return;
  }
 case 3:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455172 | 0, 10);
   return;
  }
 case 4:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455183 | 0, 9);
   return;
  }
 case 5:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455193 | 0, 7);
   return;
  }
 case 6:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455201 | 0, 7);
   return;
  }
 case 31:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455209 | 0, 13);
   return;
  }
 case 7:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455223 | 0, 5);
   return;
  }
 case 8:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455229 | 0, 6);
   return;
  }
 case 9:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455236 | 0, 5);
   return;
  }
 case 10:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455242 | 0, 7);
   return;
  }
 case 11:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455250 | 0, 8);
   return;
  }
 case 12:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455259 | 0, 7);
   return;
  }
 case 13:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455267 | 0, 7);
   return;
  }
 case 14:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455275 | 0, 6);
   return;
  }
 case 15:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455282 | 0, 6);
   return;
  }
 case 16:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455289 | 0, 5);
   return;
  }
 case 17:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455295 | 0, 6);
   return;
  }
 case 18:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455302 | 0, 9);
   return;
  }
 case 19:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455312 | 0, 9);
   return;
  }
 case 20:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455322 | 0, 10);
   return;
  }
 case 21:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455333 | 0, 7);
   return;
  }
 case 22:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455341 | 0, 8);
   return;
  }
 case 23:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455350 | 0, 6);
   return;
  }
 case 24:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455357 | 0, 7);
   return;
  }
 case 25:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455365 | 0, 10);
   return;
  }
 case 26:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455376 | 0, 9);
   return;
  }
 case 27:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455386 | 0, 6);
   return;
  }
 case 28:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455393 | 0, 10);
   return;
  }
 case 29:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455404 | 0, 8);
   return;
  }
 case 30:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455413 | 0, 7);
   return;
  }
 case 32:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455421 | 0, 6);
   return;
  }
 case 33:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455428 | 0, 9);
   return;
  }
 case 34:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455438 | 0, 7);
   return;
  }
 case 35:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455446 | 0, 7);
   return;
  }
 case 36:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455454 | 0, 4);
   return;
  }
 case 37:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455459 | 0, 7);
   return;
  }
 case 38:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455467 | 0, 9);
   return;
  }
 case 39:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455477 | 0, 10);
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
   return;
  }
 } while (0);
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i1) {
  i1 = i2 + 4 | 0;
  i2 = i4 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i4 >> 2] = i8;
   break;
  } while (0);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i2 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 116;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i2 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 114;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i2 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 117;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i2 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 101;
  return 1;
 }
 i1 = i2 + 5 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = i8;
  break;
 } while (0);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 102;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 97;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 108;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 115;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 101;
 return 1;
}

function __ZN5physx24PxcArticulationFnsScalar13invertInertiaERKNS_9SpInertiaE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 f21 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f29 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f27 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f21 = Math_fround(Math_fround(f21 + f21) * Math_fround(.5));
 f37 = Math_fround(Math_fround(f28 + f37) * Math_fround(.5));
 f27 = Math_fround(Math_fround(f3 + f27) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f6 + f6) * Math_fround(.5));
 f32 = Math_fround(Math_fround(f29 + f32) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f7 + f7) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f35 + f20) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f8 + f16) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f11 + f22) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f6 * f7) - Math_fround(f32 * f32));
 f8 = Math_fround(Math_fround(f27 * f32) - Math_fround(f37 * f7));
 f35 = Math_fround(Math_fround(f37 * f32) - Math_fround(f6 * f27));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f27 * f35) + Math_fround(Math_fround(f37 * f8) + Math_fround(f21 * f11))));
 f11 = Math_fround(f11 * f29);
 f8 = Math_fround(f8 * f29);
 f35 = Math_fround(f35 * f29);
 f7 = Math_fround(Math_fround(Math_fround(f21 * f7) - Math_fround(f27 * f27)) * f29);
 f32 = Math_fround(Math_fround(Math_fround(f37 * f27) - Math_fround(f21 * f32)) * f29);
 f29 = Math_fround(Math_fround(Math_fround(f21 * f6) - Math_fround(f37 * f37)) * f29);
 f37 = Math_fround(-f12);
 f6 = Math_fround(-f14);
 f21 = Math_fround(-f26);
 f27 = Math_fround(-f24);
 f3 = Math_fround(-f25);
 f28 = Math_fround(-f15);
 f38 = Math_fround(-f10);
 f36 = Math_fround(-f13);
 f9 = Math_fround(-f23);
 f33 = Math_fround(Math_fround(f35 * f38) + Math_fround(Math_fround(f11 * f37) + Math_fround(f8 * f27)));
 f5 = Math_fround(Math_fround(f35 * f36) + Math_fround(Math_fround(f11 * f6) + Math_fround(f8 * f3)));
 f34 = Math_fround(Math_fround(f35 * f9) + Math_fround(Math_fround(f11 * f21) + Math_fround(f8 * f28)));
 f30 = Math_fround(Math_fround(f32 * f38) + Math_fround(Math_fround(f8 * f37) + Math_fround(f7 * f27)));
 f4 = Math_fround(Math_fround(f32 * f36) + Math_fround(Math_fround(f8 * f6) + Math_fround(f7 * f3)));
 f31 = Math_fround(Math_fround(f32 * f9) + Math_fround(Math_fround(f8 * f21) + Math_fround(f7 * f28)));
 f27 = Math_fround(Math_fround(f29 * f38) + Math_fround(Math_fround(f35 * f37) + Math_fround(f32 * f27)));
 f3 = Math_fround(Math_fround(f29 * f36) + Math_fround(Math_fround(f35 * f6) + Math_fround(f32 * f3)));
 f28 = Math_fround(Math_fround(f29 * f9) + Math_fround(Math_fround(f35 * f21) + Math_fround(f32 * f28)));
 f19 = Math_fround(Math_fround(Math_fround(f19 + f19) * Math_fround(.5)) + Math_fround(Math_fround(f10 * f27) + Math_fround(Math_fround(f12 * f33) + Math_fround(f24 * f30))));
 f21 = Math_fround(f20 + Math_fround(Math_fround(f10 * f3) + Math_fround(Math_fround(f12 * f5) + Math_fround(f24 * f4))));
 f24 = Math_fround(f16 + Math_fround(Math_fround(f10 * f28) + Math_fround(Math_fround(f12 * f34) + Math_fround(f24 * f31))));
 f20 = Math_fround(f20 + Math_fround(Math_fround(f13 * f27) + Math_fround(Math_fround(f14 * f33) + Math_fround(f25 * f30))));
 f18 = Math_fround(Math_fround(Math_fround(f18 + f18) * Math_fround(.5)) + Math_fround(Math_fround(f13 * f3) + Math_fround(Math_fround(f14 * f5) + Math_fround(f25 * f4))));
 f25 = Math_fround(f22 + Math_fround(Math_fround(f13 * f28) + Math_fround(Math_fround(f14 * f34) + Math_fround(f25 * f31))));
 f16 = Math_fround(f16 + Math_fround(Math_fround(f23 * f27) + Math_fround(Math_fround(f26 * f33) + Math_fround(f15 * f30))));
 f22 = Math_fround(f22 + Math_fround(Math_fround(f23 * f3) + Math_fround(Math_fround(f26 * f5) + Math_fround(f15 * f4))));
 f15 = Math_fround(Math_fround(Math_fround(f17 + f17) * Math_fround(.5)) + Math_fround(Math_fround(f23 * f28) + Math_fround(Math_fround(f26 * f34) + Math_fround(f15 * f31))));
 f26 = Math_fround(Math_fround(f18 * f15) - Math_fround(f25 * f22));
 f25 = Math_fround(Math_fround(f25 * f16) - Math_fround(f15 * f20));
 f23 = Math_fround(Math_fround(f22 * f20) - Math_fround(f18 * f16));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f21 * f25) + Math_fround(f19 * f26))));
 f26 = Math_fround(f17 * f26);
 f25 = Math_fround(f17 * f25);
 f23 = Math_fround(f17 * f23);
 f24 = Math_fround(f17 * Math_fround(Math_fround(f15 * f19) - Math_fround(f16 * f24)));
 f22 = Math_fround(f17 * Math_fround(Math_fround(f16 * f21) - Math_fround(f22 * f19)));
 f21 = Math_fround(f17 * Math_fround(Math_fround(f18 * f19) - Math_fround(f20 * f21)));
 f20 = Math_fround(Math_fround(f34 * f23) + Math_fround(Math_fround(f33 * f26) + Math_fround(f5 * f25)));
 f19 = Math_fround(Math_fround(f34 * f22) + Math_fround(Math_fround(f33 * f25) + Math_fround(f5 * f24)));
 f18 = Math_fround(Math_fround(f34 * f21) + Math_fround(Math_fround(f33 * f23) + Math_fround(f5 * f22)));
 f17 = Math_fround(Math_fround(f31 * f23) + Math_fround(Math_fround(f30 * f26) + Math_fround(f4 * f25)));
 f16 = Math_fround(Math_fround(f31 * f22) + Math_fround(Math_fround(f30 * f25) + Math_fround(f4 * f24)));
 f15 = Math_fround(Math_fround(f31 * f21) + Math_fround(Math_fround(f30 * f23) + Math_fround(f4 * f22)));
 f14 = Math_fround(Math_fround(f28 * f23) + Math_fround(Math_fround(f27 * f26) + Math_fround(f3 * f25)));
 f13 = Math_fround(Math_fround(f28 * f22) + Math_fround(Math_fround(f27 * f25) + Math_fround(f3 * f24)));
 f12 = Math_fround(Math_fround(f28 * f21) + Math_fround(Math_fround(f27 * f23) + Math_fround(f3 * f22)));
 f11 = Math_fround(f11 + Math_fround(Math_fround(f34 * f18) + Math_fround(Math_fround(f33 * f20) + Math_fround(f5 * f19))));
 f10 = Math_fround(f8 + Math_fround(Math_fround(f31 * f18) + Math_fround(Math_fround(f30 * f20) + Math_fround(f4 * f19))));
 f9 = Math_fround(f35 + Math_fround(Math_fround(f28 * f18) + Math_fround(Math_fround(f27 * f20) + Math_fround(f3 * f19))));
 f8 = Math_fround(f8 + Math_fround(Math_fround(f34 * f15) + Math_fround(Math_fround(f33 * f17) + Math_fround(f5 * f16))));
 f7 = Math_fround(f7 + Math_fround(Math_fround(f31 * f15) + Math_fround(Math_fround(f30 * f17) + Math_fround(f4 * f16))));
 f6 = Math_fround(f32 + Math_fround(Math_fround(f28 * f15) + Math_fround(Math_fround(f27 * f17) + Math_fround(f3 * f16))));
 f5 = Math_fround(f35 + Math_fround(Math_fround(f34 * f12) + Math_fround(Math_fround(f33 * f14) + Math_fround(f5 * f13))));
 f4 = Math_fround(f32 + Math_fround(Math_fround(f31 * f12) + Math_fround(Math_fround(f30 * f14) + Math_fround(f4 * f13))));
 f3 = Math_fround(f29 + Math_fround(Math_fround(f28 * f12) + Math_fround(Math_fround(f27 * f14) + Math_fround(f3 * f13))));
 HEAPF32[i2 >> 2] = f26;
 HEAPF32[i2 + 4 >> 2] = f25;
 HEAPF32[i2 + 8 >> 2] = f23;
 HEAPF32[i2 + 12 >> 2] = f25;
 HEAPF32[i2 + 16 >> 2] = f24;
 HEAPF32[i2 + 20 >> 2] = f22;
 HEAPF32[i2 + 24 >> 2] = f23;
 HEAPF32[i2 + 28 >> 2] = f22;
 HEAPF32[i2 + 32 >> 2] = f21;
 HEAPF32[i2 + 36 >> 2] = f20;
 HEAPF32[i2 + 40 >> 2] = f19;
 HEAPF32[i2 + 44 >> 2] = f18;
 HEAPF32[i2 + 48 >> 2] = f17;
 HEAPF32[i2 + 52 >> 2] = f16;
 HEAPF32[i2 + 56 >> 2] = f15;
 HEAPF32[i2 + 60 >> 2] = f14;
 HEAPF32[i2 + 64 >> 2] = f13;
 HEAPF32[i2 + 68 >> 2] = f12;
 HEAPF32[i2 + 72 >> 2] = f11;
 HEAPF32[i2 + 76 >> 2] = f10;
 HEAPF32[i2 + 80 >> 2] = f9;
 HEAPF32[i2 + 84 >> 2] = f8;
 HEAPF32[i2 + 88 >> 2] = f7;
 HEAPF32[i2 + 92 >> 2] = f6;
 HEAPF32[i2 + 96 >> 2] = f5;
 HEAPF32[i2 + 100 >> 2] = f4;
 HEAPF32[i2 + 104 >> 2] = f3;
 return;
}

function __ZN10systeminfo24GetSystemLanguageCultureEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do switch (i2 | 0) {
 case 0:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455024 | 0, 2);
   return;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455027 | 0, 2);
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455030 | 0, 2);
   return;
  }
 case 3:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455033 | 0, 2);
   return;
  }
 case 4:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455036 | 0, 2);
   return;
  }
 case 5:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455039 | 0, 2);
   return;
  }
 case 6:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455042 | 0, 2);
   return;
  }
 case 31:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455145 | 0, 2);
   return;
  }
 case 7:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455055 | 0, 2);
   return;
  }
 case 8:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455058 | 0, 2);
   return;
  }
 case 9:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455061 | 0, 2);
   return;
  }
 case 10:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455064 | 0, 2);
   return;
  }
 case 11:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455067 | 0, 2);
   return;
  }
 case 12:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455070 | 0, 2);
   return;
  }
 case 13:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455073 | 0, 2);
   return;
  }
 case 14:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455076 | 0, 2);
   return;
  }
 case 15:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455079 | 0, 2);
   return;
  }
 case 16:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455082 | 0, 2);
   return;
  }
 case 17:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455085 | 0, 2);
   return;
  }
 case 18:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455088 | 0, 2);
   return;
  }
 case 19:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455091 | 0, 2);
   return;
  }
 case 20:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1086430 | 0, 2);
   return;
  }
 case 21:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 870753 | 0, 2);
   return;
  }
 case 22:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455094 | 0, 2);
   return;
  }
 case 23:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455097 | 0, 2);
   return;
  }
 case 24:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455100 | 0, 2);
   return;
  }
 case 25:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455103 | 0, 2);
   return;
  }
 case 26:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 488717 | 0, 2);
   return;
  }
 case 27:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455106 | 0, 2);
   return;
  }
 case 28:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455109 | 0, 2);
   return;
  }
 case 29:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455112 | 0, 2);
   return;
  }
 case 30:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455115 | 0, 2);
   return;
  }
 case 32:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455121 | 0, 2);
   return;
  }
 case 33:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455124 | 0, 2);
   return;
  }
 case 34:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455127 | 0, 2);
   return;
  }
 case 35:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455130 | 0, 2);
   return;
  }
 case 36:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455133 | 0, 2);
   return;
  }
 case 37:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455136 | 0, 2);
   return;
  }
 case 38:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455139 | 0, 2);
   return;
  }
 case 39:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455142 | 0, 2);
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
   return;
  }
 } while (0);
}

function __ZN5physx23computeDiffTorqueRatiosERKNS_27PxVehicleDifferential4WDataEfPKfPf(i4, f2, i3, i19) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i19 = i19 | 0;
 var i1 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, f22 = f0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 L1 : do if (f2 > Math_fround(0.0)) switch (i1 | 0) {
 case 0:
  {
   i1 = 1;
   break L1;
  }
 case 3:
  {
   i1 = 4;
   break L1;
  }
 default:
  break L1;
 } while (0);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f2 = Math_fround(Math_fround(1.0) - f9);
 f11 = Math_fround(Math_fround(1.0) - f10);
 f18 = Math_fround(Math_fround(1.0) - f16);
 i5 = f13 <= Math_fround(-0.0);
 f6 = i5 ? Math_fround(0.0) : Math_fround(1.0);
 i5 = f13 >= Math_fround(0.0);
 f6 = i5 ? f6 : Math_fround(-1.0);
 L7 : do switch (i1 | 0) {
 case 0:
  {
   if (f6 != Math_fround(0.0)) {
    i5 = f14 <= Math_fround(-0.0);
    f20 = i5 ? Math_fround(0.0) : Math_fround(1.0);
    i5 = f14 >= Math_fround(0.0);
    if (f6 == (i5 ? f20 : Math_fround(-1.0))) {
     i5 = f17 <= Math_fround(-0.0);
     f20 = i5 ? Math_fround(0.0) : Math_fround(1.0);
     i5 = f17 >= Math_fround(0.0);
     if (f6 == (i5 ? f20 : Math_fround(-1.0))) {
      i5 = f15 <= Math_fround(-0.0);
      f20 = i5 ? Math_fround(0.0) : Math_fround(1.0);
      i5 = f15 >= Math_fround(0.0);
      if (f6 == (i5 ? f20 : Math_fround(-1.0))) {
       f22 = Math_fround(Math_abs(Math_fround(Math_abs(Math_fround(f13 + f14)))));
       f21 = Math_fround(Math_abs(Math_fround(Math_abs(Math_fround(f17 + f15)))));
       f20 = f22 > f21 ? f22 : f21;
       f6 = Math_fround(f20 - Math_fround(f7 * (f22 < f21 ? f22 : f21)));
       f20 = Math_fround(f6 / f20);
       i5 = f6 >= Math_fround(0.0);
       f20 = i5 ? f20 : Math_fround(0.0);
       f6 = Math_fround(Math_fround(1.0) - f20);
       f20 = Math_fround(f20 + Math_fround(1.0));
       i5 = Math_fround(f22 - f21) >= Math_fround(0.0);
       f7 = Math_fround(f9 * (i5 ? f6 : f20));
       f9 = Math_fround(f2 * (i5 ? f20 : f6));
       f6 = Math_fround(Math_fround(1.0) / Math_fround(f7 + f9));
       f7 = Math_fround(f6 * f7);
       f9 = Math_fround(f6 * f9);
       f6 = Math_fround(Math_abs(Math_fround(f13)));
       f13 = Math_fround(Math_abs(Math_fround(f14)));
       f20 = f6 > f13 ? f6 : f13;
       f14 = Math_fround(f20 - Math_fround(f8 * (f6 < f13 ? f6 : f13)));
       f20 = Math_fround(f14 / f20);
       i5 = f14 >= Math_fround(0.0);
       f20 = i5 ? f20 : Math_fround(0.0);
       f14 = Math_fround(Math_fround(1.0) - f20);
       f20 = Math_fround(f20 + Math_fround(1.0));
       i5 = Math_fround(f6 - f13) >= Math_fround(0.0);
       f13 = Math_fround(f10 * (i5 ? f14 : f20));
       f14 = Math_fround(f11 * (i5 ? f20 : f14));
       f11 = Math_fround(Math_fround(1.0) / Math_fround(f13 + f14));
       f13 = Math_fround(f11 * f13);
       f14 = Math_fround(f11 * f14);
       f11 = Math_fround(Math_abs(Math_fround(f17)));
       f15 = Math_fround(Math_abs(Math_fround(f15)));
       f17 = f11 > f15 ? f11 : f15;
       f20 = Math_fround(f17 - Math_fround(f12 * (f11 < f15 ? f11 : f15)));
       f17 = Math_fround(f20 / f17);
       i5 = f20 >= Math_fround(0.0);
       f17 = i5 ? f17 : Math_fround(0.0);
       f20 = Math_fround(Math_fround(1.0) - f17);
       f17 = Math_fround(f17 + Math_fround(1.0));
       i5 = Math_fround(f11 - f15) >= Math_fround(0.0);
       f16 = Math_fround(f16 * (i5 ? f20 : f17));
       f20 = Math_fround(f18 * (i5 ? f17 : f20));
       f17 = Math_fround(Math_fround(1.0) / Math_fround(f16 + f20));
       f18 = Math_fround(f17 * f16);
       f20 = Math_fround(f17 * f20);
       f17 = Math_fround(f7 * f13);
       i5 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       f17 = Math_fround(f7 * f14);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
       f18 = Math_fround(f9 * f18);
       i3 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
       f20 = Math_fround(f9 * f20);
       i1 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
       break L7;
      }
     }
    }
   }
   f20 = Math_fround(f9 * f10);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   f20 = Math_fround(f9 * f11);
   f21 = Math_fround(f2 * f16);
   f22 = Math_fround(f2 * f18);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   if (f6 != Math_fround(0.0)) {
    i5 = f14 <= Math_fround(-0.0);
    f22 = i5 ? Math_fround(0.0) : Math_fround(1.0);
    i5 = f14 >= Math_fround(0.0);
    if (f6 == (i5 ? f22 : Math_fround(-1.0))) {
     f18 = Math_fround(Math_abs(Math_fround(f13)));
     f20 = Math_fround(Math_abs(Math_fround(f14)));
     f21 = f18 > f20 ? f18 : f20;
     f22 = Math_fround(f21 - Math_fround(f8 * (f18 < f20 ? f18 : f20)));
     f21 = Math_fround(f22 / f21);
     i5 = f22 >= Math_fround(0.0);
     f21 = i5 ? f21 : Math_fround(0.0);
     f22 = Math_fround(Math_fround(1.0) - f21);
     f21 = Math_fround(f21 + Math_fround(1.0));
     i5 = Math_fround(f18 - f20) >= Math_fround(0.0);
     f20 = Math_fround(f10 * (i5 ? f22 : f21));
     f22 = Math_fround(f11 * (i5 ? f21 : f22));
     f21 = Math_fround(Math_fround(1.0) / Math_fround(f20 + f22));
     f20 = Math_fround(f21 * f20);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(f21 * f22);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = 0;
     i1 = 0;
     break L7;
    }
   }
   i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = 0;
   i1 = 0;
   break;
  }
 case 2:
  {
   i5 = f17 <= Math_fround(-0.0);
   f2 = i5 ? Math_fround(0.0) : Math_fround(1.0);
   i5 = f17 >= Math_fround(0.0);
   f2 = i5 ? f2 : Math_fround(-1.0);
   if (f2 != Math_fround(0.0)) {
    i5 = f15 <= Math_fround(-0.0);
    f22 = i5 ? Math_fround(0.0) : Math_fround(1.0);
    i5 = f15 >= Math_fround(0.0);
    if (f2 == (i5 ? f22 : Math_fround(-1.0))) {
     f17 = Math_fround(Math_abs(Math_fround(f17)));
     f20 = Math_fround(Math_abs(Math_fround(f15)));
     f21 = f17 > f20 ? f17 : f20;
     f22 = Math_fround(f21 - Math_fround(f12 * (f17 < f20 ? f17 : f20)));
     f21 = Math_fround(f22 / f21);
     i3 = f22 >= Math_fround(0.0);
     f21 = i3 ? f21 : Math_fround(0.0);
     f22 = Math_fround(Math_fround(1.0) - f21);
     f21 = Math_fround(f21 + Math_fround(1.0));
     i3 = Math_fround(f17 - f20) >= Math_fround(0.0);
     f20 = Math_fround(f16 * (i3 ? f22 : f21));
     f22 = Math_fround(f18 * (i3 ? f21 : f22));
     f21 = Math_fround(Math_fround(1.0) / Math_fround(f20 + f22));
     f20 = Math_fround(f21 * f20);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
     f22 = Math_fround(f21 * f22);
     i5 = 0;
     i4 = 0;
     i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     break L7;
    }
   }
   i5 = 0;
   i4 = 0;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 3:
  {
   f20 = Math_fround(f9 * f10);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   f20 = Math_fround(f9 * f11);
   f21 = Math_fround(f2 * f16);
   f22 = Math_fround(f2 * f18);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 4:
  {
   i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = 0;
   i1 = 0;
   break;
  }
 case 5:
  {
   i5 = 0;
   i4 = 0;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  {
   i5 = 0;
   i4 = 0;
   i3 = 0;
   i1 = 0;
  }
 } while (0);
 HEAP32[i19 >> 2] = i5;
 HEAP32[i19 + 4 >> 2] = i4;
 HEAP32[i19 + 8 >> 2] = i3;
 HEAP32[i19 + 12 >> 2] = i1;
 return;
}

function __ZNK5physx30PxVehicleTireDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 36 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj600ENS_22PxRepXPropertyAccessorILj600ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 52 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj601ENS_22PxRepXPropertyAccessorILj601ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 68 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj602ENS_22PxRepXPropertyAccessorILj602ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 84 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj603ENS_22PxRepXPropertyAccessorILj603ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i5 = i10 + 100 | 0;
  i6 = i9 + 7 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i5, i6);
  i6 = i10 + 116 | 0;
  i5 = i9 + 8 | 0;
  i7 = i10 + 132 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i12 = i10 + 136 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj(i8, i5, i6, i7, i12);
  i12 = i9 + 9 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i5 = i10 + 100 | 0;
 i6 = i9 + 7 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i5, i6);
 i6 = i10 + 116 | 0;
 i5 = i9 + 8 | 0;
 i7 = i10 + 132 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i12 = i10 + 136 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj(i8, i5, i6, i7, i12);
 i12 = i9 + 9 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf(i23, i21, i16, i10) {
 i23 = i23 | 0;
 i21 = i21 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i22 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i24 + 4 | 0;
 i17 = i24;
 HEAP32[i3 >> 2] = 0;
 if ((i16 | 0) > (i21 | 0)) {
  i4 = HEAP32[i23 + 396 >> 2] | 0;
  i2 = i21;
  f1 = Math_fround(0.0);
  do {
   i20 = i4 + (i2 << 2) | 0;
   i19 = Math_fround(HEAPF32[i20 >> 2]) < f1;
   i20 = HEAP32[(i19 ? i3 : i20) >> 2] | 0;
   HEAP32[i3 >> 2] = i20;
   i2 = i2 + 1 | 0;
   f1 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i2 | 0) != (i16 | 0));
  f7 = f1;
  i20 = ~~f1;
 } else {
  f7 = Math_fround(0.0);
  i20 = 0;
 }
 i19 = i23 + 184 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 i2 = ~~f7;
 i4 = HEAP32[i3 + 76 >> 2] | 0;
 i5 = HEAP32[i4 + 36 >> 2] | 0;
 i6 = (i5 | 0) == 0;
 f1 = Math_fround(HEAPF32[i3 + 192 >> 2]);
 if (!((i2 | 0) == 0 | i6)) {
  f18 = Math_fround(i5 | 0);
  f1 = Math_fround(Math_fround(f1 * Math_fround(((i2 | 0) > 500 ? 500 : i2) | 0)) / f18);
 }
 i8 = (HEAP8[i23 + 229 >> 0] | 0) == 0;
 if (i8) f18 = f1; else {
  f18 = Math_fround(HEAPF32[i23 + 248 >> 2]);
  f18 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f18) + Math_fround(.5)))) / f18);
 }
 i2 = ~~f7;
 f1 = Math_fround(HEAPF32[i3 + 196 >> 2]);
 if (!((i2 | 0) == 0 | i6)) {
  f13 = Math_fround(i5 | 0);
  f1 = Math_fround(Math_fround(f1 * Math_fround(((i2 | 0) > 500 ? 500 : i2) | 0)) / f13);
 }
 if (i8) f13 = f1; else {
  f13 = Math_fround(HEAPF32[i23 + 248 >> 2]);
  f13 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f13) + Math_fround(.5)))) / f13);
 }
 i2 = ~~f7;
 if ((i2 | 0) == 0 | i6) f1 = Math_fround(HEAPF32[i4 + 32 >> 2]); else f1 = Math_fround(Math_fround(Math_fround(((i2 | 0) > 500 ? 500 : i2) | 0) * Math_fround(HEAPF32[i4 + 32 >> 2])) / Math_fround(i5 | 0));
 if (!i8) {
  f7 = Math_fround(HEAPF32[i23 + 248 >> 2]);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f7) + Math_fround(.5)))) / f7);
 }
 i11 = i23 + 416 | 0;
 i12 = i23 + 428 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 if (!i15) if (i8) f1 = f18; else {
  f1 = Math_fround(HEAPF32[i23 + 248 >> 2]);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f18 * f1) + Math_fround(.5)))) / f1);
 } else {
  f1 = Math_fround(f1 - Math_fround(f18 - f13));
  f1 = Math_fround(f1 + Math_fround(f18 - Math_fround(HEAPF32[i23 + 296 >> 2])));
  f1 = Math_fround(Math_fround(HEAPF32[i23 + 240 >> 2]) * f1);
  if (!i8) {
   f7 = Math_fround(HEAPF32[i23 + 248 >> 2]);
   f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f7) + Math_fround(.5)))) / f7);
  }
 }
 HEAPF32[i10 >> 2] = f1;
 i14 = i21 << 2;
 i8 = i23 + 440 | 0;
 i9 = i23 + 356 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6 + (i21 << 3) | 0;
 i3 = i16 - i21 | 0;
 if (i3 | 0) {
  i4 = (HEAP32[i8 >> 2] | 0) + (i14 * 60 | 0) | 0;
  i5 = i3 << 2;
  while (1) {
   i5 = i5 + -1 | 0;
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
   i25 = i4 + 4 | 0;
   HEAPF32[i25 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i25 >> 2]));
   if (!i5) break; else i4 = i4 + 60 | 0;
  }
  if (i2 | 0) while (1) {
   i3 = i3 + -1 | 0;
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
   i25 = i2 + 4 | 0;
   HEAPF32[i25 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i25 >> 2]));
   if (!i3) break; else i2 = i2 + 8 | 0;
  }
 }
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 i10 = i23 + 324 | 0;
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i10 >> 2] = f1;
 f7 = Math_fround(f1 - f13);
 if (f7 > Math_fround(HEAPF32[i23 + 224 >> 2])) {
  HEAP8[i23 + 352 >> 0] = 0;
  if (!(HEAP8[i23 + 253 >> 0] | 0)) {
   i2 = i23 + 436 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + ((0 - ((HEAP32[i23 + 260 >> 2] | 0) - i21 << 2) | 0) * 60 | 0);
   i2 = i23 + 368 | 0;
   HEAP32[i2 >> 2] = i21;
   i3 = i23 + 372 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i21 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i21;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i21 << 3, 4, i23 + 360 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21 << 3, 4, i23 + 360 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
    HEAP32[i3 >> 2] = i21;
    HEAP32[i9 >> 2] = i25;
    break;
   } while (0);
   i2 = i23 + 376 | 0;
   i3 = i23 + 388 | 0;
   HEAP32[i3 >> 2] = i21;
   i4 = i23 + 392 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i21 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i21;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i14, 4, i23 + 380 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 4, i23 + 380 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i21;
    HEAP32[i2 >> 2] = i25;
    break;
   } while (0);
   i2 = i23 + 396 | 0;
   i3 = i23 + 408 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i21;
   i5 = i23 + 412 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   do if ((i6 & 2147483647) >>> 0 < i21 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i21;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i14, 4, i23 + 400 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 4, i23 + 400 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i25 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i21;
    HEAP32[i2 >> 2] = i25;
    break;
   } while (0);
   if (i4 >>> 0 >= i21 >>> 0) {
    i25 = 0;
    STACKTOP = i24;
    return i25 | 0;
   }
   _memset((HEAP32[i2 >> 2] | 0) + (i4 << 2) | 0, 0, i14 - (i4 << 2) | 0) | 0;
   i25 = 0;
   STACKTOP = i24;
   return i25 | 0;
  }
 }
 if (!(HEAP8[i23 + 254 >> 0] | 0)) {
  i25 = i23 + 288 | 0;
  f1 = Math_fround(f1 - f18);
  HEAPF32[i17 >> 2] = f1;
  i21 = f1 < Math_fround(HEAPF32[i25 >> 2]);
  HEAP32[i25 >> 2] = HEAP32[(i21 ? i17 : i25) >> 2];
  i25 = i23 + 292 | 0;
  HEAPF32[i17 >> 2] = f7;
  i21 = Math_fround(HEAPF32[i25 >> 2]) < f7;
  HEAP32[i25 >> 2] = HEAP32[(i21 ? i17 : i25) >> 2];
 } else {
  i5 = i16 << 2;
  if ((i14 | 0) < (i5 | 0)) {
   i6 = i23 + 288 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = i23 + 292 | 0;
   f1 = Math_fround(HEAPF32[i6 >> 2]);
   i2 = i14;
   f7 = Math_fround(HEAPF32[i4 >> 2]);
   do {
    i25 = i3 + (i2 * 60 | 0) + 4 | 0;
    i21 = Math_fround(HEAPF32[i25 >> 2]) < f1;
    i21 = HEAP32[(i21 ? i25 : i6) >> 2] | 0;
    HEAP32[i6 >> 2] = i21;
    i17 = f7 < Math_fround(HEAPF32[i25 >> 2]);
    i25 = HEAP32[(i17 ? i25 : i4) >> 2] | 0;
    HEAP32[i4 >> 2] = i25;
    i2 = i2 + 1 | 0;
    f1 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   } while ((i2 | 0) != (i5 | 0));
  }
 }
 HEAPF32[i23 + 296 >> 2] = f13;
 i3 = i15 + 1 | 0;
 i4 = i23 + 432 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 * 12 | 0, 4, i23 + 420 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i23 + 420 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i25 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i11 >> 2] = i25;
   break;
  }
 } while (0);
 HEAP32[i12 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i4 + (i15 * 12 | 0) >> 2] = HEAP32[i23 + 272 >> 2];
 i2 = HEAP32[(HEAP32[i19 >> 2] | 0) + 76 >> 2] | 0;
 if (!i20) i22 = 56; else {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  if (!i3) i22 = 56; else f1 = Math_fround(Math_fround(Math_fround(((i20 | 0) > 500 ? 500 : i20) | 0) * Math_fround(HEAPF32[i2 + 32 >> 2])) / Math_fround(i3 | 0));
 }
 if ((i22 | 0) == 56) f1 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 HEAP32[i4 + (i15 * 12 | 0) + 4 >> 2] = ~~f1;
 HEAPF32[i4 + (i15 * 12 | 0) + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f18);
 i25 = 1;
 STACKTOP = i24;
 return i25 | 0;
}

function __ZL11md5_processP11md5_contextPh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) | (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i2 + 3 >> 0] | 0) << 24;
 i18 = (HEAPU8[i2 + 5 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0) | (HEAPU8[i2 + 6 >> 0] | 0) << 16 | (HEAPU8[i2 + 7 >> 0] | 0) << 24;
 i11 = (HEAPU8[i2 + 9 >> 0] | 0) << 8 | (HEAPU8[i2 + 8 >> 0] | 0) | (HEAPU8[i2 + 10 >> 0] | 0) << 16 | (HEAPU8[i2 + 11 >> 0] | 0) << 24;
 i20 = (HEAPU8[i2 + 13 >> 0] | 0) << 8 | (HEAPU8[i2 + 12 >> 0] | 0) | (HEAPU8[i2 + 14 >> 0] | 0) << 16 | (HEAPU8[i2 + 15 >> 0] | 0) << 24;
 i13 = (HEAPU8[i2 + 17 >> 0] | 0) << 8 | (HEAPU8[i2 + 16 >> 0] | 0) | (HEAPU8[i2 + 18 >> 0] | 0) << 16 | (HEAPU8[i2 + 19 >> 0] | 0) << 24;
 i22 = (HEAPU8[i2 + 21 >> 0] | 0) << 8 | (HEAPU8[i2 + 20 >> 0] | 0) | (HEAPU8[i2 + 22 >> 0] | 0) << 16 | (HEAPU8[i2 + 23 >> 0] | 0) << 24;
 i15 = (HEAPU8[i2 + 25 >> 0] | 0) << 8 | (HEAPU8[i2 + 24 >> 0] | 0) | (HEAPU8[i2 + 26 >> 0] | 0) << 16 | (HEAPU8[i2 + 27 >> 0] | 0) << 24;
 i24 = (HEAPU8[i2 + 29 >> 0] | 0) << 8 | (HEAPU8[i2 + 28 >> 0] | 0) | (HEAPU8[i2 + 30 >> 0] | 0) << 16 | (HEAPU8[i2 + 31 >> 0] | 0) << 24;
 i17 = (HEAPU8[i2 + 33 >> 0] | 0) << 8 | (HEAPU8[i2 + 32 >> 0] | 0) | (HEAPU8[i2 + 34 >> 0] | 0) << 16 | (HEAPU8[i2 + 35 >> 0] | 0) << 24;
 i10 = (HEAPU8[i2 + 37 >> 0] | 0) << 8 | (HEAPU8[i2 + 36 >> 0] | 0) | (HEAPU8[i2 + 38 >> 0] | 0) << 16 | (HEAPU8[i2 + 39 >> 0] | 0) << 24;
 i19 = (HEAPU8[i2 + 41 >> 0] | 0) << 8 | (HEAPU8[i2 + 40 >> 0] | 0) | (HEAPU8[i2 + 42 >> 0] | 0) << 16 | (HEAPU8[i2 + 43 >> 0] | 0) << 24;
 i12 = (HEAPU8[i2 + 45 >> 0] | 0) << 8 | (HEAPU8[i2 + 44 >> 0] | 0) | (HEAPU8[i2 + 46 >> 0] | 0) << 16 | (HEAPU8[i2 + 47 >> 0] | 0) << 24;
 i21 = (HEAPU8[i2 + 49 >> 0] | 0) << 8 | (HEAPU8[i2 + 48 >> 0] | 0) | (HEAPU8[i2 + 50 >> 0] | 0) << 16 | (HEAPU8[i2 + 51 >> 0] | 0) << 24;
 i14 = (HEAPU8[i2 + 53 >> 0] | 0) << 8 | (HEAPU8[i2 + 52 >> 0] | 0) | (HEAPU8[i2 + 54 >> 0] | 0) << 16 | (HEAPU8[i2 + 55 >> 0] | 0) << 24;
 i23 = (HEAPU8[i2 + 57 >> 0] | 0) << 8 | (HEAPU8[i2 + 56 >> 0] | 0) | (HEAPU8[i2 + 58 >> 0] | 0) << 16 | (HEAPU8[i2 + 59 >> 0] | 0) << 24;
 i16 = (HEAPU8[i2 + 61 >> 0] | 0) << 8 | (HEAPU8[i2 + 60 >> 0] | 0) | (HEAPU8[i2 + 62 >> 0] | 0) << 16 | (HEAPU8[i2 + 63 >> 0] | 0) << 24;
 i7 = i1 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i26 = i25 + -680876936 + i8 + ((i1 ^ i4) & i6 ^ i1) | 0;
 i26 = (i26 << 7 | i26 >>> 25) + i6 | 0;
 i1 = i18 + -389564586 + i1 + (i26 & (i4 ^ i6) ^ i4) | 0;
 i1 = (i1 << 12 | i1 >>> 20) + i26 | 0;
 i4 = i11 + 606105819 + i4 + (i1 & (i26 ^ i6) ^ i6) | 0;
 i4 = (i4 << 17 | i4 >>> 15) + i1 | 0;
 i6 = i20 + -1044525330 + i6 + (i4 & (i1 ^ i26) ^ i26) | 0;
 i6 = (i6 << 22 | i6 >>> 10) + i4 | 0;
 i26 = i13 + -176418897 + i26 + (i6 & (i4 ^ i1) ^ i1) | 0;
 i26 = (i26 << 7 | i26 >>> 25) + i6 | 0;
 i1 = i22 + 1200080426 + i1 + (i26 & (i6 ^ i4) ^ i4) | 0;
 i1 = (i1 << 12 | i1 >>> 20) + i26 | 0;
 i4 = i15 + -1473231341 + i4 + (i1 & (i26 ^ i6) ^ i6) | 0;
 i4 = (i4 << 17 | i4 >>> 15) + i1 | 0;
 i6 = i24 + -45705983 + i6 + (i4 & (i1 ^ i26) ^ i26) | 0;
 i6 = (i6 << 22 | i6 >>> 10) + i4 | 0;
 i26 = i17 + 1770035416 + i26 + (i6 & (i4 ^ i1) ^ i1) | 0;
 i26 = (i26 << 7 | i26 >>> 25) + i6 | 0;
 i1 = i10 + -1958414417 + i1 + (i26 & (i6 ^ i4) ^ i4) | 0;
 i1 = (i1 << 12 | i1 >>> 20) + i26 | 0;
 i4 = i19 + -42063 + i4 + (i1 & (i26 ^ i6) ^ i6) | 0;
 i4 = (i4 << 17 | i4 >>> 15) + i1 | 0;
 i6 = i12 + -1990404162 + i6 + (i4 & (i1 ^ i26) ^ i26) | 0;
 i6 = (i6 << 22 | i6 >>> 10) + i4 | 0;
 i26 = i21 + 1804603682 + i26 + (i6 & (i4 ^ i1) ^ i1) | 0;
 i26 = (i26 << 7 | i26 >>> 25) + i6 | 0;
 i1 = i14 + -40341101 + i1 + (i26 & (i6 ^ i4) ^ i4) | 0;
 i1 = (i1 << 12 | i1 >>> 20) + i26 | 0;
 i4 = i23 + -1502002290 + i4 + (i1 & (i26 ^ i6) ^ i6) | 0;
 i4 = (i4 << 17 | i4 >>> 15) + i1 | 0;
 i6 = i16 + 1236535329 + i6 + (i4 & (i1 ^ i26) ^ i26) | 0;
 i6 = (i6 << 22 | i6 >>> 10) + i4 | 0;
 i26 = i18 + -165796510 + i26 + ((i6 ^ i4) & i1 ^ i4) | 0;
 i26 = (i26 << 5 | i26 >>> 27) + i6 | 0;
 i1 = i15 + -1069501632 + i1 + ((i26 ^ i6) & i4 ^ i6) | 0;
 i1 = (i1 << 9 | i1 >>> 23) + i26 | 0;
 i4 = i12 + 643717713 + i4 + ((i1 ^ i26) & i6 ^ i26) | 0;
 i4 = (i4 << 14 | i4 >>> 18) + i1 | 0;
 i6 = i25 + -373897302 + i6 + ((i4 ^ i1) & i26 ^ i1) | 0;
 i6 = (i6 << 20 | i6 >>> 12) + i4 | 0;
 i26 = i22 + -701558691 + i26 + ((i6 ^ i4) & i1 ^ i4) | 0;
 i26 = (i26 << 5 | i26 >>> 27) + i6 | 0;
 i1 = i19 + 38016083 + i1 + ((i26 ^ i6) & i4 ^ i6) | 0;
 i1 = (i1 << 9 | i1 >>> 23) + i26 | 0;
 i4 = i16 + -660478335 + i4 + ((i1 ^ i26) & i6 ^ i26) | 0;
 i4 = (i4 << 14 | i4 >>> 18) + i1 | 0;
 i6 = i13 + -405537848 + i6 + ((i4 ^ i1) & i26 ^ i1) | 0;
 i6 = (i6 << 20 | i6 >>> 12) + i4 | 0;
 i26 = i10 + 568446438 + i26 + ((i6 ^ i4) & i1 ^ i4) | 0;
 i26 = (i26 << 5 | i26 >>> 27) + i6 | 0;
 i1 = i23 + -1019803690 + i1 + ((i26 ^ i6) & i4 ^ i6) | 0;
 i1 = (i1 << 9 | i1 >>> 23) + i26 | 0;
 i4 = i20 + -187363961 + i4 + ((i1 ^ i26) & i6 ^ i26) | 0;
 i4 = (i4 << 14 | i4 >>> 18) + i1 | 0;
 i6 = i17 + 1163531501 + i6 + ((i4 ^ i1) & i26 ^ i1) | 0;
 i6 = (i6 << 20 | i6 >>> 12) + i4 | 0;
 i26 = i14 + -1444681467 + i26 + ((i6 ^ i4) & i1 ^ i4) | 0;
 i26 = (i26 << 5 | i26 >>> 27) + i6 | 0;
 i1 = i11 + -51403784 + i1 + ((i26 ^ i6) & i4 ^ i6) | 0;
 i1 = (i1 << 9 | i1 >>> 23) + i26 | 0;
 i4 = i24 + 1735328473 + i4 + ((i1 ^ i26) & i6 ^ i26) | 0;
 i4 = (i4 << 14 | i4 >>> 18) + i1 | 0;
 i9 = i4 ^ i1;
 i6 = i21 + -1926607734 + i6 + (i9 & i26 ^ i1) | 0;
 i6 = (i6 << 20 | i6 >>> 12) + i4 | 0;
 i9 = i22 + -378558 + i26 + (i9 ^ i6) | 0;
 i9 = (i9 << 4 | i9 >>> 28) + i6 | 0;
 i1 = i17 + -2022574463 + i1 + (i6 ^ i4 ^ i9) | 0;
 i1 = (i1 << 11 | i1 >>> 21) + i9 | 0;
 i4 = i12 + 1839030562 + i4 + (i9 ^ i6 ^ i1) | 0;
 i4 = (i4 << 16 | i4 >>> 16) + i1 | 0;
 i6 = i23 + -35309556 + i6 + (i1 ^ i9 ^ i4) | 0;
 i6 = (i6 << 23 | i6 >>> 9) + i4 | 0;
 i9 = i18 + -1530992060 + i9 + (i4 ^ i1 ^ i6) | 0;
 i9 = (i9 << 4 | i9 >>> 28) + i6 | 0;
 i1 = i13 + 1272893353 + i1 + (i6 ^ i4 ^ i9) | 0;
 i1 = (i1 << 11 | i1 >>> 21) + i9 | 0;
 i4 = i24 + -155497632 + i4 + (i9 ^ i6 ^ i1) | 0;
 i4 = (i4 << 16 | i4 >>> 16) + i1 | 0;
 i6 = i19 + -1094730640 + i6 + (i1 ^ i9 ^ i4) | 0;
 i6 = (i6 << 23 | i6 >>> 9) + i4 | 0;
 i9 = i14 + 681279174 + i9 + (i4 ^ i1 ^ i6) | 0;
 i9 = (i9 << 4 | i9 >>> 28) + i6 | 0;
 i1 = i25 + -358537222 + i1 + (i6 ^ i4 ^ i9) | 0;
 i1 = (i1 << 11 | i1 >>> 21) + i9 | 0;
 i4 = i20 + -722521979 + i4 + (i9 ^ i6 ^ i1) | 0;
 i4 = (i4 << 16 | i4 >>> 16) + i1 | 0;
 i6 = i15 + 76029189 + i6 + (i1 ^ i9 ^ i4) | 0;
 i6 = (i6 << 23 | i6 >>> 9) + i4 | 0;
 i9 = i10 + -640364487 + i9 + (i4 ^ i1 ^ i6) | 0;
 i9 = (i9 << 4 | i9 >>> 28) + i6 | 0;
 i1 = i21 + -421815835 + i1 + (i6 ^ i4 ^ i9) | 0;
 i1 = (i1 << 11 | i1 >>> 21) + i9 | 0;
 i4 = i16 + 530742520 + i4 + (i9 ^ i6 ^ i1) | 0;
 i4 = (i4 << 16 | i4 >>> 16) + i1 | 0;
 i6 = i11 + -995338651 + i6 + (i1 ^ i9 ^ i4) | 0;
 i6 = (i6 << 23 | i6 >>> 9) + i4 | 0;
 i9 = i25 + -198630844 + i9 + ((i6 | ~i1) ^ i4) | 0;
 i9 = (i9 << 6 | i9 >>> 26) + i6 | 0;
 i1 = i24 + 1126891415 + i1 + ((i9 | ~i4) ^ i6) | 0;
 i1 = (i1 << 10 | i1 >>> 22) + i9 | 0;
 i4 = i23 + -1416354905 + i4 + ((i1 | ~i6) ^ i9) | 0;
 i4 = (i4 << 15 | i4 >>> 17) + i1 | 0;
 i6 = i22 + -57434055 + i6 + ((i4 | ~i9) ^ i1) | 0;
 i6 = (i6 << 21 | i6 >>> 11) + i4 | 0;
 i9 = i21 + 1700485571 + i9 + ((i6 | ~i1) ^ i4) | 0;
 i9 = (i9 << 6 | i9 >>> 26) + i6 | 0;
 i1 = i20 + -1894986606 + i1 + ((i9 | ~i4) ^ i6) | 0;
 i1 = (i1 << 10 | i1 >>> 22) + i9 | 0;
 i4 = i19 + -1051523 + i4 + ((i1 | ~i6) ^ i9) | 0;
 i4 = (i4 << 15 | i4 >>> 17) + i1 | 0;
 i6 = i18 + -2054922799 + i6 + ((i4 | ~i9) ^ i1) | 0;
 i6 = (i6 << 21 | i6 >>> 11) + i4 | 0;
 i9 = i17 + 1873313359 + i9 + ((i6 | ~i1) ^ i4) | 0;
 i9 = (i9 << 6 | i9 >>> 26) + i6 | 0;
 i1 = i16 + -30611744 + i1 + ((i9 | ~i4) ^ i6) | 0;
 i1 = (i1 << 10 | i1 >>> 22) + i9 | 0;
 i4 = i15 + -1560198380 + i4 + ((i1 | ~i6) ^ i9) | 0;
 i4 = (i4 << 15 | i4 >>> 17) + i1 | 0;
 i6 = i14 + 1309151649 + i6 + ((i4 | ~i9) ^ i1) | 0;
 i6 = (i6 << 21 | i6 >>> 11) + i4 | 0;
 i9 = i13 + -145523070 + i9 + ((i6 | ~i1) ^ i4) | 0;
 i9 = (i9 << 6 | i9 >>> 26) + i6 | 0;
 i1 = i12 + -1120210379 + i1 + ((i9 | ~i4) ^ i6) | 0;
 i1 = (i1 << 10 | i1 >>> 22) + i9 | 0;
 i4 = i11 + 718787259 + i4 + ((i1 | ~i6) ^ i9) | 0;
 i4 = (i4 << 15 | i4 >>> 17) + i1 | 0;
 i6 = i10 + -343485551 + i6 + ((i4 | ~i9) ^ i1) | 0;
 HEAP32[i7 >> 2] = i9 + i8;
 HEAP32[i5 >> 2] = i4 + (HEAP32[i5 >> 2] | 0) + (i6 << 21 | i6 >>> 11);
 HEAP32[i3 >> 2] = i4 + (HEAP32[i3 >> 2] | 0);
 HEAP32[i2 >> 2] = i1 + (HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx13PxDiagonalizeERKNS_7PxMat33ERNS_6PxQuatE(i44, i2, i45) {
 i44 = i44 | 0;
 i2 = i2 | 0;
 i45 = i45 | 0;
 var f1 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i46 = 0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i46 + 40 | 0;
 i42 = i46;
 f34 = Math_fround(HEAPF32[i2 >> 2]);
 f38 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f40 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f41 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f35 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 i19 = i42 + 4 | 0;
 i20 = i42 + 8 | 0;
 i21 = i42 + 12 | 0;
 i22 = i42 + 16 | 0;
 i23 = i42 + 20 | 0;
 i24 = i42 + 24 | 0;
 i25 = i42 + 28 | 0;
 i26 = i42 + 32 | 0;
 i27 = i43 + 4 | 0;
 i28 = i43 + 8 | 0;
 i29 = i43 + 12 | 0;
 i30 = i43 + 4 | 0;
 i31 = i43 + 8 | 0;
 i32 = i43 + 12 | 0;
 i5 = 0;
 i6 = 0;
 i7 = 0;
 i8 = 1065353216;
 i33 = 0;
 while (1) {
  f14 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(f14 + f14);
  f54 = Math_fround(f15 + f15);
  f61 = Math_fround(f16 + f16);
  f51 = Math_fround(f15 * f54);
  f60 = Math_fround(f16 * f61);
  f47 = Math_fround(f15 * f59);
  f55 = Math_fround(f16 * f59);
  f53 = Math_fround(f17 * f59);
  f57 = Math_fround(f16 * f54);
  f54 = Math_fround(f17 * f54);
  f61 = Math_fround(f17 * f61);
  f3 = Math_fround(Math_fround(Math_fround(1.0) - f51) - f60);
  f50 = Math_fround(f61 + f47);
  f10 = Math_fround(f55 - f54);
  f61 = Math_fround(f47 - f61);
  f59 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f59));
  f60 = Math_fround(f59 - f60);
  f47 = Math_fround(f57 + f53);
  f55 = Math_fround(f54 + f55);
  f53 = Math_fround(f57 - f53);
  f51 = Math_fround(f59 - f51);
  f59 = Math_fround(Math_fround(Math_fround(f3 * f34) + Math_fround(f50 * f38)) + Math_fround(f10 * f39));
  f57 = Math_fround(Math_fround(Math_fround(f61 * f34) + Math_fround(f60 * f38)) + Math_fround(f47 * f39));
  f54 = Math_fround(Math_fround(Math_fround(f55 * f34) + Math_fround(f53 * f38)) + Math_fround(f51 * f39));
  f58 = Math_fround(Math_fround(Math_fround(f3 * f40) + Math_fround(f50 * f41)) + Math_fround(f10 * f35));
  f56 = Math_fround(Math_fround(Math_fround(f61 * f40) + Math_fround(f60 * f41)) + Math_fround(f47 * f35));
  f52 = Math_fround(Math_fround(Math_fround(f55 * f40) + Math_fround(f53 * f41)) + Math_fround(f51 * f35));
  f49 = Math_fround(Math_fround(Math_fround(f3 * f36) + Math_fround(f50 * f37)) + Math_fround(f10 * f18));
  f48 = Math_fround(Math_fround(Math_fround(f61 * f36) + Math_fround(f60 * f37)) + Math_fround(f47 * f18));
  f1 = Math_fround(Math_fround(Math_fround(f55 * f36) + Math_fround(f53 * f37)) + Math_fround(f51 * f18));
  f4 = Math_fround(Math_fround(Math_fround(f3 * f59) + Math_fround(f50 * f58)) + Math_fround(f10 * f49));
  f9 = Math_fround(Math_fround(Math_fround(f3 * f57) + Math_fround(f50 * f56)) + Math_fround(f10 * f48));
  f10 = Math_fround(Math_fround(Math_fround(f3 * f54) + Math_fround(f50 * f52)) + Math_fround(f10 * f1));
  f50 = Math_fround(Math_fround(Math_fround(f61 * f59) + Math_fround(f60 * f58)) + Math_fround(f47 * f49));
  f3 = Math_fround(Math_fround(Math_fround(f61 * f57) + Math_fround(f60 * f56)) + Math_fround(f47 * f48));
  f47 = Math_fround(Math_fround(Math_fround(f61 * f54) + Math_fround(f60 * f52)) + Math_fround(f47 * f1));
  f49 = Math_fround(Math_fround(Math_fround(f55 * f59) + Math_fround(f53 * f58)) + Math_fround(f51 * f49));
  f48 = Math_fround(Math_fround(Math_fround(f55 * f57) + Math_fround(f53 * f56)) + Math_fround(f51 * f48));
  f1 = Math_fround(Math_fround(Math_fround(f55 * f54) + Math_fround(f53 * f52)) + Math_fround(f51 * f1));
  HEAPF32[i42 >> 2] = f4;
  HEAPF32[i19 >> 2] = f9;
  HEAPF32[i20 >> 2] = f10;
  HEAPF32[i21 >> 2] = f50;
  HEAPF32[i22 >> 2] = f3;
  HEAPF32[i23 >> 2] = f47;
  HEAPF32[i24 >> 2] = f49;
  HEAPF32[i25 >> 2] = f48;
  HEAPF32[i26 >> 2] = f1;
  f47 = Math_fround(Math_abs(Math_fround(f47)));
  f10 = Math_fround(Math_abs(Math_fround(f10)));
  f9 = Math_fround(Math_abs(Math_fround(f9)));
  i13 = f47 > f10 & f47 > f9 ? 0 : f10 > f9 ? 1 : 2;
  i11 = i13 + 1 + (i13 >>> 1) | 0;
  i2 = i11 & 3;
  i11 = i11 + 1 + (i2 >>> 1) & 3;
  i12 = i42 + (i2 * 12 | 0) | 0;
  f9 = Math_fround(HEAPF32[i12 + (i11 << 2) >> 2]);
  if (f9 == Math_fround(0.0)) {
   i2 = 8;
   break;
  }
  f10 = Math_fround(HEAPF32[i12 + (i2 << 2) >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i42 + (i11 * 12 | 0) + (i11 << 2) >> 2]));
  f9 = Math_fround(f9 * Math_fround(2.0));
  if (+Math_fround(Math_abs(Math_fround(f10))) > +Math_fround(Math_abs(Math_fround(f9))) * 2.0e6) {
   i2 = 8;
   break;
  }
  f9 = Math_fround(f10 / f9);
  f10 = Math_fround(Math_abs(Math_fround(f9)));
  if (f10 > Math_fround(1.0e3)) {
   f61 = Math_fround(Math_fround(1.0) / Math_fround(f9 * Math_fround(4.0)));
   HEAPF32[i43 >> 2] = Math_fround(0.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   HEAPF32[i29 >> 2] = Math_fround(1.0);
   HEAPF32[i43 + (i13 << 2) >> 2] = f61;
   i2 = HEAP32[i43 >> 2] | 0;
   i5 = HEAP32[i29 >> 2] | 0;
   i6 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i27 >> 2] | 0;
  } else {
   f60 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(1.0))))));
   f60 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f60 * f60) + Math_fround(1.0)))));
   f61 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(1.0) - f60) * Math_fround(.5))));
   i2 = f9 >= Math_fround(0.0);
   f61 = Math_fround((i2 ? Math_fround(1.0) : Math_fround(-1.0)) * f61);
   f60 = Math_fround(Math_sqrt(Math_fround(Math_fround(f60 + Math_fround(1.0)) * Math_fround(.5))));
   HEAPF32[i43 >> 2] = Math_fround(0.0);
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   HEAPF32[i31 >> 2] = Math_fround(0.0);
   HEAPF32[i32 >> 2] = f60;
   HEAPF32[i43 + (i13 << 2) >> 2] = f61;
   i2 = HEAP32[i43 >> 2] | 0;
   i5 = HEAP32[i32 >> 2] | 0;
   i6 = HEAP32[i31 >> 2] | 0;
   i7 = HEAP32[i30 >> 2] | 0;
  }
  f56 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f17 * f56);
  f55 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(Math_fround(f14 * f55) + f58);
  f61 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(Math_fround(f15 * f61) + f58);
  f57 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f58 = Math_fround(f58 - Math_fround(f16 * f57));
  f59 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f55) + Math_fround(f17 * f57)) + Math_fround(f16 * f56)) - Math_fround(f14 * f61));
  f60 = Math_fround(Math_fround(Math_fround(f14 * f57) + Math_fround(Math_fround(f16 * f55) + Math_fround(f17 * f61))) - Math_fround(f15 * f56));
  f61 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f55) - Math_fround(f14 * f56)) - Math_fround(f15 * f57)) - Math_fround(f16 * f61));
  f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f61 * f61) + Math_fround(Math_fround(f60 * f60) + Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)))))));
  f58 = Math_fround(f57 * f58);
  f59 = Math_fround(f57 * f59);
  f60 = Math_fround(f57 * f60);
  f61 = Math_fround(f57 * f61);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f61, HEAP32[tempDoublePtr >> 2] | 0);
  i33 = i33 + 1 | 0;
  if (i33 >>> 0 >= 24) {
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) {
  HEAP32[i45 >> 2] = i5;
  HEAP32[i45 + 4 >> 2] = i6;
  HEAP32[i45 + 8 >> 2] = i7;
  HEAP32[i45 + 12 >> 2] = i8;
  HEAPF32[i44 >> 2] = f4;
  HEAPF32[i44 + 4 >> 2] = f3;
  HEAPF32[i44 + 8 >> 2] = f1;
  STACKTOP = i46;
  return;
 }
}

function __ZN14ParticleSystem21EmitParticlesExternalER24ParticleSystemEmitParamsj(i21, i17, i16) {
 i21 = i21 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, d5 = 0.0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, d26 = 0.0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 12 | 0;
 i18 = i24;
 i20 = i21 + 40 | 0;
 HEAP8[(HEAP32[i20 >> 2] | 0) + 26 >> 0] = 1;
 i1 = HEAP32[i21 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = HEAP32[i20 >> 2] | 0;
  i3 = i1 + 8 | 0;
  if ((HEAP32[i3 >> 2] | 0) != 1) {
   HEAP32[i3 >> 2] = 1;
   HEAP8[i1 + 13 >> 0] = 1;
  }
  __ZN14ParticleSystem12AddToManagerEv(i21);
 }
 i1 = i17 + 72 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f2);
 i3 = i17 + 76 | 0;
 f25 = Math_fround(HEAPF32[i3 >> 2]);
 f25 = Math_fround(f2 + Math_fround(f25 * f25));
 f2 = Math_fround(HEAPF32[i17 + 80 >> 2]);
 if (Math_fround(f25 + Math_fround(f2 * f2)) != Math_fround(0.0)) {
  i4 = HEAP32[i21 + 32 >> 2] | 0;
  if (!(HEAP8[i4 + 869 >> 0] | 0)) __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i4);
 }
 if (Math_fround(HEAPF32[i17 + 60 >> 2]) != Math_fround(0.0)) i23 = 13; else if (Math_fround(HEAPF32[i17 + 64 >> 2]) != Math_fround(0.0)) i23 = 13; else if (Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0)) i23 = 13; else if (Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0)) i23 = 13;
 if ((i23 | 0) == 13) {
  i1 = HEAP32[i21 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 870 >> 0] | 0)) __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
  HEAP8[(HEAP32[i20 >> 2] | 0) + 28 >> 0] = 1;
 }
 f2 = Math_fround(HEAPF32[i17 + 84 >> 2]);
 if (f2 != Math_fround(HEAPF32[i17 + 88 >> 2])) i23 = 18; else if (f2 != Math_fround(HEAPF32[i17 + 92 >> 2])) i23 = 18;
 if ((i23 | 0) == 18) {
  i1 = HEAP32[i21 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 871 >> 0] | 0)) __ZN23ParticleSystemParticles13SetUses3DSizeEv(i1);
  HEAP8[(HEAP32[i20 >> 2] | 0) + 29 >> 0] = 1;
 }
 f25 = Math_fround(HEAPF32[i17 + 48 >> 2]);
 f25 = Math_fround(f25 * f25);
 f2 = Math_fround(HEAPF32[i17 + 52 >> 2]);
 f2 = Math_fround(f25 + Math_fround(f2 * f2));
 f25 = Math_fround(HEAPF32[i17 + 56 >> 2]);
 if (Math_fround(f2 + Math_fround(f25 * f25)) != Math_fround(0.0)) {
  i1 = HEAP32[i21 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 868 >> 0] | 0)) __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
 }
 HEAP32[i22 >> 2] = 0;
 i19 = i22 + 4 | 0;
 i14 = gb + 63160 | 0;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = (i16 + 3 & -4) * 120 | 0;
 do if (!i1) i1 = 0; else {
  i3 = (i1 | 4) + -1 | 0;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 1601) | 0;
   i14 = gb + 64016 | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i22 >> 2] = i1;
   i15 = i19;
   HEAP32[i15 >> 2] = i13;
   HEAP32[i15 + 4 >> 2] = i14;
   break;
  }
 } while (0);
 i12 = i1 + 3 & -4;
 i10 = (i16 | 0) == 0;
 if (!i10) {
  i3 = i17 + 96 | 0;
  i4 = i17 + 100 | 0;
  i1 = 0;
  do {
   i7 = i12 + (i1 * 120 | 0) | 0;
   i8 = i17;
   i9 = i7 + 96 | 0;
   do {
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    i7 = i7 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i7 | 0) < (i9 | 0));
   HEAP32[i12 + (i1 * 120 | 0) + 96 >> 2] = HEAP32[i3 >> 2];
   i15 = i12 + (i1 * 120 | 0) + 100 | 0;
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   i15 = i12 + (i1 * 120 | 0) + 36 | 0;
   i14 = (HEAP32[i20 >> 2] | 0) + 292 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
 }
 i15 = i21 + 32 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i13 = i21 + 36 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!(HEAP32[i1 + 280 >> 2] | 0)) i4 = gb + 1162292 | 0; else i4 = (HEAP32[i20 >> 2] | 0) + 116 | 0;
 i14 = i21 + 44 | 0;
 __ZN13InitialModule13StartExternalERK27ParticleSystemReadOnlyStateRK23ParticleSystemParticlesRK10Matrix4x4fRK24ParticleSystemEmitParamsP22ParticleSystemParticlej(HEAP32[i14 >> 2] | 0, i1, i11, i4, i17, i12, i16);
 if (!i10) {
  i3 = (HEAP32[i20 >> 2] | 0) + 392 | 0;
  i1 = 0;
  do {
   i10 = i12 + (i1 * 120 | 0) + 104 | 0;
   i9 = i12 + (i1 * 120 | 0) + 108 | 0;
   f25 = Math_fround(HEAPF32[i9 >> 2]);
   i8 = f25 < Math_fround(HEAPF32[i10 >> 2]);
   HEAP32[i10 >> 2] = HEAP32[(i8 ? i9 : i10) >> 2];
   i10 = i12 + (i1 * 120 | 0) + 84 | 0;
   f25 = Math_fround(HEAPF32[i3 >> 2]);
   i9 = f25 < Math_fround(HEAPF32[i10 >> 2]);
   i10 = HEAP32[(i9 ? i10 : i3) >> 2] | 0;
   HEAP32[i3 >> 2] = i10;
   i9 = i12 + (i1 * 120 | 0) + 88 | 0;
   f25 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i10 = f25 < Math_fround(HEAPF32[i9 >> 2]);
   i9 = HEAP32[(i10 ? i9 : i3) >> 2] | 0;
   HEAP32[i3 >> 2] = i9;
   i10 = i12 + (i1 * 120 | 0) + 92 | 0;
   f25 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i9 = f25 < Math_fround(HEAPF32[i10 >> 2]);
   HEAP32[i3 >> 2] = HEAP32[(i9 ? i10 : i3) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
 }
 i7 = i11 + 12 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i3 = i9 + i16 | 0;
 i8 = HEAP32[(HEAP32[i14 >> 2] | 0) + 2548 >> 2] | 0;
 i3 = i8 >>> 0 < i3 >>> 0 ? i8 : i3;
 i8 = i3 - i9 | 0;
 i8 = i8 >>> 0 < i16 >>> 0 ? i8 : i16;
 i16 = i8 + (i9 + 3 | 3) & -4;
 __ZN23ParticleSystemParticles13array_reserveEj(i11, i16 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i11, i16);
 i9 = i3 >>> 0 < i9 >>> 0 ? i3 : i9;
 i3 = i9 + 3 & -4;
 __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii(i11, i12, i8, i3);
 if (!(HEAP8[i17 + 120 >> 0] | 0)) i23 = 38; else if (HEAP8[i17 + 129 >> 0] | 0) i23 = 38;
 if ((i23 | 0) == 38) {
  i1 = i21 + 48 | 0;
  if (HEAP8[i21 + 52 >> 0] | 0) {
   __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f(i1, (HEAP32[i20 >> 2] | 0) + 180 | 0);
   __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb(i1, HEAP32[i13 >> 2] | 0, HEAP32[i20 >> 2] | 0, i11, i4, i3, (HEAP8[i17 + 122 >> 0] | 0) == 0);
   __ZN11ShapeModule15ReleaseMeshDataEv(i1);
  }
 }
 i1 = HEAP32[i21 + 920 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN12LightsModule5StartER23ParticleSystemParticlesjj(i1, i11, i3, i8);
 i12 = HEAP32[i20 >> 2] | 0;
 i4 = i12 + 292 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i18 + 4 >> 2] = i10;
 HEAP32[i18 + 8 >> 2] = i16;
 i16 = HEAP32[i13 >> 2] | 0;
 __ZN14ParticleSystem13StartVelocityERS_RK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjRKN4math7_float3ERKfbb(i21, i16, i11, i3, i18, i12 + 396 | 0, (HEAP8[i17 + 121 >> 0] | 0) == 0, (HEAP32[i16 + 280 >> 2] | 0) == 1);
 if ((i3 | 0) != (i9 | 0)) {
  i4 = i3 - i9 | 0;
  i18 = i3 + i8 | 0;
  i4 = i18 - (i4 >>> 0 > i8 >>> 0 ? i8 : i4) | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i18 = i3 >>> 0 < i18 >>> 0 ? i3 : i18;
  i3 = i18 - i4 | 0;
  if (!(i18 >>> 0 <= i4 >>> 0 | (i3 | 0) == 0)) {
   i1 = 0;
   do {
    __ZN23ParticleSystemParticles14element_assignEjj(i11, i1 + i9 | 0, i1 + i4 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i11, i8 + i9 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 do if (!(HEAP8[i1 + 30 >> 0] | 0)) i23 = 50; else {
  d6 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i20 >> 2] | 0;
  d5 = +HEAPF64[i1 + 40 >> 3];
  i3 = HEAP32[i13 >> 2] | 0;
  if (!(HEAP8[i3 + 277 >> 0] | 0)) {
   d26 = d6 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f25 = Math_fround(HEAPF32[i3 + 264 >> 2]);
   if (d26 > +Math_fround(f25 + Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 88 >> 2]))) break;
  }
  if (!(HEAP8[i1 + 13 >> 0] | 0)) i23 = 50; else if (!(d6 - d5 > +Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 88 >> 2]))) i23 = 50;
 } while (0);
 if ((i23 | 0) == 50) if ((HEAP32[i1 + 8 >> 2] | 0) == 1) {
  i23 = HEAP32[i22 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i19);
  STACKTOP = i24;
  return;
 }
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i21, HEAP32[i15 >> 2] | 0, i1);
 i23 = HEAP32[i22 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i23, i19);
 STACKTOP = i24;
 return;
}

function __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = i3 + 16 | 0;
 i10 = i3 + 24 | 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 328 | 0, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 268 | 0;
 HEAP8[i6 >> 0] = ((HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3;
 i9 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931774 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i6 >> 0] = ((HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16777215) >>> 8 & 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 404998 | 0, i9, i6, 256);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i10 >> 0] = ((HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16777215) >>> 10 & 3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405015 | 0, i9, i10, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i6 >> 0] = ((HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16777215) >>> 16 & 3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405031 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i6 >> 0] = ((HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16777215) >>> 14 & 3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931826 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = i1 + 260 | 0;
 i8 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931918 | 0, i8, i9, 8388609);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931934 | 0, i8, i9 + 2 | 0, 8388609);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 228 | 0;
 i10 = HEAP32[gb + 37328 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931957 | 0, i10, i9, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 244 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 931980 | 0, i10, i9, 8388609);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405049 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 288 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 946436 | 0, i7, 0);
 i9 = i6 + 8 | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 216 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405061 | 0, gb + 405079 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405154 | 0, i8, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405167 | 0, i8, i1 + 218 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 308 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405095 | 0, gb + 842702 | 0, i8, 1);
 i9 = i6 + 8 | 0;
 i11 = i9;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 280 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405113 | 0, gb + 842702 | 0, i9, 0);
 i8 = i6 + 8 | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 276 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405127 | 0, gb + 932544 | 0, i8, 0);
 i7 = i6 + 8 | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011497 | 0, i6, i1 + 332 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011514 | 0, HEAP32[gb + 37240 >> 2] | 0, i1 + 336 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function _deflate_slow(i33, i30) {
 i33 = i33 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i34 = 0;
 i18 = i33 + 116 | 0;
 i23 = (i30 | 0) == 0;
 i24 = i33 + 72 | 0;
 i25 = i33 + 88 | 0;
 i32 = i33 + 108 | 0;
 i28 = i33 + 56 | 0;
 i26 = i33 + 84 | 0;
 i27 = i33 + 68 | 0;
 i8 = i33 + 52 | 0;
 i9 = i33 + 64 | 0;
 i10 = i33 + 96 | 0;
 i11 = i33 + 120 | 0;
 i12 = i33 + 112 | 0;
 i13 = i33 + 100 | 0;
 i14 = i33 + 5792 | 0;
 i15 = i33 + 5796 | 0;
 i16 = i33 + 5784 | 0;
 i17 = i33 + 5788 | 0;
 i19 = i33 + 104 | 0;
 i31 = i33 + 92 | 0;
 i20 = i33 + 128 | 0;
 i21 = i33 + 44 | 0;
 i22 = i33 + 136 | 0;
 i1 = 0;
 L1 : while (1) {
  i2 = HEAP32[i18 >> 2] | 0;
  while (1) {
   if (i2 >>> 0 < 262) {
    _fill_window(i33);
    i2 = HEAP32[i18 >> 2] | 0;
    if (i23 & i2 >>> 0 < 262) {
     i1 = 0;
     i29 = 52;
     break L1;
    }
    if (!i2) {
     i29 = 42;
     break L1;
    }
    if (i2 >>> 0 > 2) i29 = 7;
   } else i29 = 7;
   if ((i29 | 0) == 7) {
    i29 = 0;
    i6 = HEAP32[i32 >> 2] | 0;
    i7 = ((HEAPU8[(HEAP32[i28 >> 2] | 0) + (i6 + 2) >> 0] | 0) ^ HEAP32[i24 >> 2] << HEAP32[i25 >> 2]) & HEAP32[i26 >> 2];
    HEAP32[i24 >> 2] = i7;
    i7 = (HEAP32[i27 >> 2] | 0) + (i7 << 1) | 0;
    i1 = HEAP16[i7 >> 1] | 0;
    HEAP16[(HEAP32[i9 >> 2] | 0) + ((HEAP32[i8 >> 2] & i6) << 1) >> 1] = i1;
    HEAP16[i7 >> 1] = i6;
    i1 = i1 & 65535;
   }
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP32[i11 >> 2] = i2;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 >> 2] = 2;
   do if (!i1) {
    i3 = 2;
    i29 = 20;
   } else if (i2 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0) {
    i2 = (HEAP32[i32 >> 2] | 0) - i1 | 0;
    if (i2 >>> 0 > ((HEAP32[i21 >> 2] | 0) + -262 | 0) >>> 0) {
     i3 = 2;
     i29 = 20;
    } else {
     i3 = HEAP32[i22 >> 2] | 0;
     if ((i3 & -2 | 0) == 2) if ((i2 | 0) == 1 & (i3 | 0) == 3) {
      i2 = _longest_match_fast(i33, i1) | 0;
      i29 = 15;
     } else i2 = 2; else {
      i2 = _longest_match(i33, i1) | 0;
      i29 = 15;
     }
     if ((i29 | 0) == 15) {
      HEAP32[i10 >> 2] = i2;
      if (i2 >>> 0 >= 6) {
       i3 = i2;
       i29 = 20;
       break;
      }
     }
     if ((HEAP32[i22 >> 2] | 0) != 1) {
      if ((i2 | 0) != 3) {
       i3 = i2;
       i29 = 20;
       break;
      }
      if (((HEAP32[i32 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) >>> 0 <= 4096) {
       i3 = 3;
       i29 = 20;
       break;
      }
     }
     HEAP32[i10 >> 2] = 2;
     i3 = 2;
     i29 = 20;
    }
   } else i3 = 2; while (0);
   if ((i29 | 0) == 20) {
    i29 = 0;
    i2 = HEAP32[i11 >> 2] | 0;
   }
   if (!(i2 >>> 0 < 3 | i3 >>> 0 > i2 >>> 0)) break;
   if (!(HEAP32[i19 >> 2] | 0)) {
    HEAP32[i19 >> 2] = 1;
    HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
    i2 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
    HEAP32[i18 >> 2] = i2;
    continue;
   }
   i7 = HEAP8[(HEAP32[i28 >> 2] | 0) + ((HEAP32[i32 >> 2] | 0) + -1) >> 0] | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   HEAP16[(HEAP32[i15 >> 2] | 0) + (i6 << 1) >> 1] = 0;
   HEAP32[i14 >> 2] = i6 + 1;
   HEAP8[(HEAP32[i16 >> 2] | 0) + i6 >> 0] = i7;
   i7 = i33 + 148 + ((i7 & 255) << 2) | 0;
   HEAP16[i7 >> 1] = (HEAP16[i7 >> 1] | 0) + 1 << 16 >> 16;
   if ((HEAP32[i14 >> 2] | 0) == ((HEAP32[i17 >> 2] | 0) + -1 | 0)) {
    i2 = HEAP32[i31 >> 2] | 0;
    if ((i2 | 0) > -1) i3 = (HEAP32[i28 >> 2] | 0) + i2 | 0; else i3 = 0;
    _unity_z_tr_flush_block(i33, i3, (HEAP32[i32 >> 2] | 0) - i2 | 0, 0);
    HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
    i5 = HEAP32[i33 >> 2] | 0;
    i2 = i5 + 28 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i3 + 20 >> 2] | 0;
    i6 = i5 + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i4 = i4 >>> 0 > i7 >>> 0 ? i7 : i4;
    if (i4 | 0) {
     i7 = i5 + 12 | 0;
     _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i3 + 16 >> 2] | 0, i4 | 0) | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
     i2 = HEAP32[i2 >> 2] | 0;
     i3 = i2 + 16 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
     i7 = i5 + 20 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i4;
     i6 = i2 + 20 | 0;
     i7 = (HEAP32[i6 >> 2] | 0) - i4 | 0;
     HEAP32[i6 >> 2] = i7;
     if (!i7) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
    }
   }
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
   i2 = (HEAP32[i18 >> 2] | 0) + -1 | 0;
   HEAP32[i18 >> 2] = i2;
   if (!(HEAP32[(HEAP32[i33 >> 2] | 0) + 16 >> 2] | 0)) {
    i1 = 0;
    i29 = 52;
    break L1;
   }
  }
  i5 = HEAP32[i32 >> 2] | 0;
  i7 = i5 + -3 + (HEAP32[i18 >> 2] | 0) | 0;
  i6 = i2 + 253 | 0;
  i5 = i5 + 65535 - (HEAP32[i13 >> 2] | 0) | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP16[(HEAP32[i15 >> 2] | 0) + (i4 << 1) >> 1] = i5;
  HEAP32[i14 >> 2] = i4 + 1;
  HEAP8[(HEAP32[i16 >> 2] | 0) + i4 >> 0] = i6;
  i6 = i33 + 148 + ((HEAPU8[(i6 & 255) + (gb + 361974) >> 0] | 0 | 256) + 1 << 2) | 0;
  HEAP16[i6 >> 1] = (HEAP16[i6 >> 1] | 0) + 1 << 16 >> 16;
  i5 = i5 + 65535 & 65535;
  i5 = i33 + 2440 + ((HEAPU8[(i5 >>> 0 < 256 ? i5 : (i5 >>> 7) + 256 | 0) + (gb + 361462) >> 0] | 0) << 2) | 0;
  HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
  i5 = HEAP32[i14 >> 2] | 0;
  i6 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  HEAP32[i18 >> 2] = 1 - i4 + (HEAP32[i18 >> 2] | 0);
  i4 = i4 + -2 | 0;
  HEAP32[i11 >> 2] = i4;
  i3 = HEAP32[i32 >> 2] | 0;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP32[i32 >> 2] = i2;
   if (i2 >>> 0 <= i7 >>> 0) {
    i34 = ((HEAPU8[(HEAP32[i28 >> 2] | 0) + (i3 + 3) >> 0] | 0) ^ HEAP32[i24 >> 2] << HEAP32[i25 >> 2]) & HEAP32[i26 >> 2];
    HEAP32[i24 >> 2] = i34;
    i34 = (HEAP32[i27 >> 2] | 0) + (i34 << 1) | 0;
    i1 = HEAP16[i34 >> 1] | 0;
    HEAP16[(HEAP32[i9 >> 2] | 0) + ((HEAP32[i8 >> 2] & i2) << 1) >> 1] = i1;
    HEAP16[i34 >> 1] = i2;
    i1 = i1 & 65535;
   }
   i4 = i4 + -1 | 0;
   HEAP32[i11 >> 2] = i4;
   if (!i4) break; else i3 = i2;
  }
  HEAP32[i19 >> 2] = 0;
  HEAP32[i10 >> 2] = 2;
  i4 = i3 + 2 | 0;
  HEAP32[i32 >> 2] = i4;
  if ((i5 | 0) != (i6 | 0)) continue;
  i2 = HEAP32[i31 >> 2] | 0;
  if ((i2 | 0) > -1) i3 = (HEAP32[i28 >> 2] | 0) + i2 | 0; else i3 = 0;
  _unity_z_tr_flush_block(i33, i3, i4 - i2 | 0, 0);
  HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
  i5 = HEAP32[i33 >> 2] | 0;
  i2 = i5 + 28 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i3 + 20 >> 2] | 0;
  i6 = i5 + 16 | 0;
  i34 = HEAP32[i6 >> 2] | 0;
  i4 = i4 >>> 0 > i34 >>> 0 ? i34 : i4;
  if (i4 | 0) {
   i7 = i5 + 12 | 0;
   _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i3 + 16 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = i2 + 16 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
   i7 = i5 + 20 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i4;
   i7 = i2 + 20 | 0;
   i34 = (HEAP32[i7 >> 2] | 0) - i4 | 0;
   HEAP32[i7 >> 2] = i34;
   if (!i34) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i33 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i29 = 52;
   break;
  }
 }
 if ((i29 | 0) == 42) {
  if (HEAP32[i19 >> 2] | 0) {
   i34 = HEAP8[(HEAP32[i28 >> 2] | 0) + ((HEAP32[i32 >> 2] | 0) + -1) >> 0] | 0;
   i29 = HEAP32[i14 >> 2] | 0;
   HEAP16[(HEAP32[i15 >> 2] | 0) + (i29 << 1) >> 1] = 0;
   HEAP32[i14 >> 2] = i29 + 1;
   HEAP8[(HEAP32[i16 >> 2] | 0) + i29 >> 0] = i34;
   i34 = i33 + 148 + ((i34 & 255) << 2) | 0;
   HEAP16[i34 >> 1] = (HEAP16[i34 >> 1] | 0) + 1 << 16 >> 16;
   HEAP32[i19 >> 2] = 0;
  }
  i2 = HEAP32[i31 >> 2] | 0;
  if ((i2 | 0) > -1) i1 = (HEAP32[i28 >> 2] | 0) + i2 | 0; else i1 = 0;
  i6 = (i30 | 0) == 4;
  _unity_z_tr_flush_block(i33, i1, (HEAP32[i32 >> 2] | 0) - i2 | 0, i6 & 1);
  HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
  i4 = HEAP32[i33 >> 2] | 0;
  i1 = i4 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i5 = i4 + 16 | 0;
  i34 = HEAP32[i5 >> 2] | 0;
  i3 = i3 >>> 0 > i34 >>> 0 ? i34 : i3;
  if (i3 | 0) {
   i32 = i4 + 12 | 0;
   _memcpy(HEAP32[i32 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i3 | 0) | 0;
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + i3;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
   i32 = i4 + 20 | 0;
   HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i3;
   i32 = i1 + 20 | 0;
   i34 = (HEAP32[i32 >> 2] | 0) - i3 | 0;
   HEAP32[i32 >> 2] = i34;
   if (!i34) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i33 >> 2] | 0) + 16 >> 2] | 0)) {
   i34 = i6 ? 2 : 0;
   return i34 | 0;
  } else {
   i34 = i6 ? 3 : 1;
   return i34 | 0;
  }
 } else if ((i29 | 0) == 52) return i1 | 0;
 return 0;
}

function __ZNK20GpuProgramParameters13PrepareValuesEPK19ShaderPropertySheetS2_R13dynamic_arrayIhLj4EEjP12GfxPatchInfoPb(i15, i1, i2, i20, i3, i4, i13) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 32 | 0;
 i14 = i21 + 20 | 0;
 i17 = i21;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = i2;
 HEAP32[i17 + 8 >> 2] = i4;
 HEAP32[i17 + 12 >> 2] = i3;
 i12 = i17 + 16 | 0;
 HEAP8[i12 >> 0] = 0;
 i18 = i20 + 12 | 0;
 i1 = (HEAP32[i15 + 12 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) | 0;
 i19 = i20 + 16 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i20 >> 2] = i11;
  break;
 } while (0);
 __ZL22PrepareValueParametersI21FullParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i15 + 16 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, HEAP32[i15 + 8 >> 2] | 0, i20, i17);
 i6 = i15 + 80 | 0;
 i7 = i15 + 84 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) {
  i8 = i20 + 4 | 0;
  i5 = 0;
  do {
   if (!(HEAP32[i1 + (i5 * 52 | 0) + 32 >> 2] | 0)) __ZL22PrepareValueParametersI21FullParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_(i1 + (i5 * 52 | 0) + 4 | 0, HEAP32[i1 + (i5 * 52 | 0) + 36 >> 2] | 0, HEAP32[i1 + (i5 * 52 | 0) + 40 >> 2] | 0, HEAP32[i1 + (i5 * 52 | 0) + 44 >> 2] | 0, i20, i17); else {
    i2 = HEAP32[i18 >> 2] | 0;
    i1 = i2 + 4 | 0;
    HEAP32[i18 >> 2] = i1;
    i3 = HEAP32[i19 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i4 >>> 0 < i1 >>> 0) {
     i11 = i3 << 1;
     i1 = i11 >>> 0 > i1 >>> 0 ? i11 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i19 >> 2] = i1;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i1;
      HEAP32[i20 >> 2] = i11;
      break;
     }
    } while (0);
    i11 = (HEAP32[i20 >> 2] | 0) + i2 | 0;
    HEAP16[i11 >> 1] = 65535;
    HEAP16[i11 + 2 >> 1] = 65535 >>> 16;
   }
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i5 >>> 0 < (((HEAP32[i7 >> 2] | 0) - i1 | 0) / 52 | 0) >>> 0);
 }
 i10 = i15 + 36 | 0;
 i11 = HEAP32[i18 >> 2] | 0;
 i1 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i1;
 i2 = HEAP32[i19 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 < i1 >>> 0) {
  i9 = i2 << 1;
  i1 = i9 >>> 0 > i1 >>> 0 ? i9 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i19 >> 2] = i1;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i20 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[(HEAP32[i20 >> 2] | 0) + i11 >> 2] = 0;
 i7 = i15 + 40 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i7 >> 2] | 0) != (i2 | 0)) {
  i8 = i14 + 8 | 0;
  i9 = i20 + 4 | 0;
  i1 = 0;
  i6 = 0;
  do {
   if (__ZNK21FullParameterPreparer16OnPrepareTextureERPKN9ShaderLab6TexEnvERKN20GpuProgramParameters16TextureParameterEj(i17, i16, i2 + (i6 << 4) | 0, HEAP32[i18 >> 2] | 0) | 0) {
    HEAP32[i8 >> 2] = 0;
    i3 = HEAP32[i10 >> 2] | 0;
    __ZNK9ShaderLab6TexEnv11PrepareDataEiiP15GfxTextureParam(HEAP32[i16 >> 2] | 0, HEAP32[i3 + (i6 << 4) + 4 >> 2] | 0, HEAP32[i3 + (i6 << 4) + 8 >> 2] | 0, i14);
    i3 = HEAP32[i18 >> 2] | 0;
    i2 = i3 + 12 | 0;
    HEAP32[i18 >> 2] = i2;
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i5 >>> 0 < i2 >>> 0) {
     i22 = i4 << 1;
     i2 = i22 >>> 0 > i2 >>> 0 ? i22 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i19 >> 2] = i2;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i22 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i2;
      HEAP32[i20 >> 2] = i22;
      break;
     }
    } while (0);
    i22 = (HEAP32[i20 >> 2] | 0) + i3 | 0;
    HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i1 = i1 + 1 | 0;
   }
   i6 = i6 + 1 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } while (i6 >>> 0 < (HEAP32[i7 >> 2] | 0) - i2 >> 4 >>> 0);
  if (i1 | 0) HEAP32[(HEAP32[i20 >> 2] | 0) + i11 >> 2] = i1;
 }
 if (i13 | 0) HEAP8[i13 >> 0] = HEAP8[i12 >> 0] | 0;
 i9 = i15 + 72 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i7 = i15 + 60 | 0;
  i8 = i20 + 4 | 0;
  i6 = 0;
  do {
   HEAP32[i16 >> 2] = 0;
   if (__ZNK21FullParameterPreparer22OnPrepareComputeBufferER15ComputeBufferIDRKN20GpuProgramParameters15BufferParameterEj(i17, i16, (HEAP32[i7 >> 2] | 0) + (i6 << 4) | 0, (HEAP32[i18 >> 2] | 0) + 4 | 0) | 0) {
    i4 = HEAP32[i18 >> 2] | 0;
    i1 = i4 + 4 | 0;
    HEAP32[i18 >> 2] = i1;
    i2 = HEAP32[i19 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i3 >>> 0 < i1 >>> 0) {
     i22 = i2 << 1;
     i1 = i22 >>> 0 > i1 >>> 0 ? i22 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i19 >> 2] = i1;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i22 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i1;
      HEAP32[i20 >> 2] = i22;
      break;
     }
    } while (0);
    i1 = HEAP32[i20 >> 2] | 0;
    HEAP32[i1 + i4 >> 2] = i6;
    i5 = HEAP32[i18 >> 2] | 0;
    i2 = i5 + 4 | 0;
    HEAP32[i18 >> 2] = i2;
    i3 = HEAP32[i19 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i4 >>> 0 < i2 >>> 0) {
     i22 = i3 << 1;
     i2 = i22 >>> 0 > i2 >>> 0 ? i22 : i2;
     if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i19 >> 2] = i2;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i20 >> 2] = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i2;
      HEAP32[i20 >> 2] = i1;
      break;
     }
    } while (0);
    HEAP32[i1 + i5 >> 2] = HEAP32[i16 >> 2];
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i18 >> 2] = i1;
 i3 = HEAP32[i19 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i4 >>> 0 >= i1 >>> 0) {
  i22 = HEAP32[i20 >> 2] | 0;
  i22 = i22 + i2 | 0;
  HEAP32[i22 >> 2] = -1;
  STACKTOP = i21;
  return;
 }
 i22 = i3 << 1;
 i1 = i22 >>> 0 > i1 >>> 0 ? i22 : i1;
 if (i4 >>> 0 >= i1 >>> 0) {
  i22 = HEAP32[i20 >> 2] | 0;
  i22 = i22 + i2 | 0;
  HEAP32[i22 >> 2] = -1;
  STACKTOP = i21;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i22 = HEAP32[i20 >> 2] | 0;
  i22 = i22 + i2 | 0;
  HEAP32[i22 >> 2] = -1;
  STACKTOP = i21;
  return;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i18 >> 2] | 0) | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i20 >> 2] = i22;
  i22 = HEAP32[i20 >> 2] | 0;
  i22 = i22 + i2 | 0;
  HEAP32[i22 >> 2] = -1;
  STACKTOP = i21;
  return;
 }
}

function __ZN5physx10PxsContextD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 if (i1 | 0) __ZN5physx14PxsAABBManager8destroyVEv(i1);
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (i1 | 0) __ZN5physx18PxsDynamicsContext7destroyEv(i1);
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 if (i1 | 0) __ZN5physx13PxsCCDContext7destroyEv(i1);
 i5 = i6 + 696 | 0;
 __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE7destroyEv(i5);
 i4 = HEAP32[i6 + 7648 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 7640 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 7636 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 7628 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 7624 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 7616 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 HEAP32[i6 + 6928 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 6936 >> 2] = 0;
 HEAP32[i6 + 6900 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 6908 >> 2] = 0;
 __ZN5physx16PxsIslandManagerD2Ev(i6 + 6172 | 0);
 __ZN5physx2Cm12RenderBufferD2Ev(i6 + 5924 | 0);
 i1 = HEAP32[i6 + 5912 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i6 + 5916 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 5920 | 0, i1);
 i1 = HEAP32[i6 + 5876 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 i4 = HEAP32[i6 + 5872 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 5864 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 5860 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 5852 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i6 + 5840 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i6 + 5844 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 5848 | 0, i1);
 __ZN5physx21PxsBodyTransformVaultD2Ev(i6 + 1444 | 0);
 i4 = HEAP32[i6 + 1436 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1428 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 1424 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1416 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 1412 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1404 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 1400 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1392 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 1388 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1380 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i4 = HEAP32[i6 + 1376 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 1368 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i6 + 1344 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i6 + 1348 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 1352 | 0, i1);
 i1 = HEAP32[i6 + 1332 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i6 + 1336 >> 2] | 0) <= -1) break;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 1340 | 0, i1);
 } while (0);
 if (HEAP32[i6 + 1316 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 1036 | 0);
 i3 = i6 + 1300 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 + 1304 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1308 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 1040 | 0) == (i1 | 0)) {
   HEAP8[i6 + 1296 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 if (HEAP32[i6 + 1020 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 740 | 0);
 i3 = i6 + 1004 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 1008 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1012 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 744 | 0) == (i1 | 0)) {
   HEAP8[i6 + 1e3 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE7destroyEv(i5);
 i1 = HEAP32[i6 + 728 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i6 + 732 >> 2] | 0) <= -1) break;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 736 | 0, i1);
 } while (0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i6 + 600 | 0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i6 + 508 | 0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i6 + 416 | 0);
 __ZN5physx2Cm10FanoutTaskD2Ev(i6 + 324 | 0);
 i1 = i6 + 320 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 }
 __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE7destroyEv(i6 + 276 | 0);
 i1 = HEAP32[i6 + 308 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i6 + 312 >> 2] | 0) <= -1) break;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 316 | 0, i1);
 } while (0);
 __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE7destroyEv(i6 + 232 | 0);
 i1 = HEAP32[i6 + 264 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i6 + 268 >> 2] | 0) <= -1) break;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 272 | 0, i1);
 } while (0);
 i2 = i6 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 >> 2] | 0) | 0;
 if (i1 | 0) do {
  __ZN5physx16PxsThreadContextD2Ev(i1);
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
  i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 >> 2] | 0) | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 }
 __ZN5physx17PxcNpMemBlockPoolD2Ev(i6 + 44 | 0);
 i1 = i6 + 20 | 0;
 i8 = HEAP32[i6 + 32 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i6 + 24 >> 2] | 0;
  if (!i2) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
 } while (0);
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZN5physx19PxsSimObjectFactoryD2Ev(i6);
  STACKTOP = i7;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 __ZN5physx19PxsSimObjectFactoryD2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN7mecanim5human5Human8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i9, i10);
 i2 = i9 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i8 = i2;
  i1 = i1 | 0 ? i1 - i8 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i8;
 }
 __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + i2 | 0, i10);
 i1 = i9 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i8 = i1;
  i2 = i2 | 0 ? i2 - i8 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i8;
 }
 i5 = i2 + i1 | 0;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i7 = i10 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (i5 | 0) do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i1, i10);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 60, 4) | 0;
  __ZN7mecanim4hand4HandC2Ev(i2);
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i6 >> 2] = 15;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 15;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i4 = i3 + 60 | 0;
 i1 = i3;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i9 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 60, 4) | 0;
  __ZN7mecanim4hand4HandC2Ev(i2);
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 i3 = i2 + i1 | 0;
 HEAP32[i6 >> 2] = 15;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 15;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i4 = i3 + 60 | 0;
 i1 = i3;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i9 + 60;
 HEAP32[i6 + 4 >> 2] = i9 + 56;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i10, i6, 0);
 i1 = i9 + 68 | 0;
 i5 = i9 + 64 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 72 | 0) | 0;
 if (i5 | 0) do {
  __ZN4math8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i6 >> 2] = 24;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 24;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i2 = i9 + 168 | 0;
 i1 = i9 + 72 | 0;
 do {
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i6 >> 2] = 24;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 24;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i2 = i9 + 264 | 0;
 i1 = i9 + 168 | 0;
 do {
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i6 >> 2] = 24;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 24;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i2 = i9 + 360 | 0;
 i1 = i9 + 264 | 0;
 do {
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 360 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 364 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 376 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 380 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 384 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 388 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 392 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i9 + 393 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i9 + 394 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i11;
  return;
 }
}

function __Z22GenerateDitherTexturesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i1 = i7 + 8 | 0;
 i5 = i7;
 i2 = gb + 63520 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i1 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i6) | 0;
 HEAP32[gb + 1158152 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
 i1 = HEAP32[gb + 1158152 >> 2] | 0;
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, 4, 64, 1, 0, 1, -1, 0) | 0;
 i1 = HEAP32[gb + 1158152 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 403288 | 0);
 i1 = HEAP32[gb + 1158152 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1158152 >> 2] | 0;
 __ZN9Texture2D18UnshareTextureDataEv(i1);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) i4 = 0; else i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP8[i4 + 240 >> 0] = -1;
 HEAP8[i4 + 1 >> 0] = 0;
 HEAP8[i4 + 241 >> 0] = -1;
 HEAP8[i4 + 2 >> 0] = 0;
 HEAP8[i4 + 242 >> 0] = -1;
 HEAP8[i4 + 3 >> 0] = 0;
 HEAP8[i4 + 243 >> 0] = -1;
 HEAP8[i4 + 4 >> 0] = 0;
 HEAP8[i4 + 244 >> 0] = -1;
 HEAP8[i4 + 5 >> 0] = 0;
 HEAP8[i4 + 245 >> 0] = -1;
 HEAP8[i4 + 6 >> 0] = 0;
 HEAP8[i4 + 246 >> 0] = -1;
 HEAP8[i4 + 7 >> 0] = 0;
 HEAP8[i4 + 247 >> 0] = -1;
 HEAP8[i4 + 8 >> 0] = 0;
 HEAP8[i4 + 248 >> 0] = -1;
 HEAP8[i4 + 9 >> 0] = 0;
 HEAP8[i4 + 249 >> 0] = -1;
 HEAP8[i4 + 10 >> 0] = 0;
 HEAP8[i4 + 250 >> 0] = -1;
 HEAP8[i4 + 11 >> 0] = 0;
 HEAP8[i4 + 251 >> 0] = -1;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP8[i4 + 252 >> 0] = -1;
 HEAP8[i4 + 13 >> 0] = 0;
 HEAP8[i4 + 253 >> 0] = -1;
 HEAP8[i4 + 14 >> 0] = 0;
 HEAP8[i4 + 254 >> 0] = -1;
 HEAP8[i4 + 15 >> 0] = 0;
 HEAP8[i4 + 255 >> 0] = -1;
 HEAP8[i4 + 16 >> 0] = -1;
 HEAP8[i4 + 224 >> 0] = 0;
 HEAP8[i4 + 17 >> 0] = 0;
 HEAP8[i4 + 225 >> 0] = -1;
 HEAP8[i4 + 18 >> 0] = 0;
 HEAP8[i4 + 226 >> 0] = -1;
 HEAP8[i4 + 19 >> 0] = 0;
 HEAP8[i4 + 227 >> 0] = -1;
 HEAP8[i4 + 20 >> 0] = 0;
 HEAP8[i4 + 228 >> 0] = -1;
 HEAP8[i4 + 21 >> 0] = 0;
 HEAP8[i4 + 229 >> 0] = -1;
 HEAP8[i4 + 22 >> 0] = 0;
 HEAP8[i4 + 230 >> 0] = -1;
 HEAP8[i4 + 23 >> 0] = 0;
 HEAP8[i4 + 231 >> 0] = -1;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP8[i4 + 232 >> 0] = -1;
 HEAP8[i4 + 25 >> 0] = 0;
 HEAP8[i4 + 233 >> 0] = -1;
 HEAP8[i4 + 26 >> 0] = 0;
 HEAP8[i4 + 234 >> 0] = -1;
 HEAP8[i4 + 27 >> 0] = 0;
 HEAP8[i4 + 235 >> 0] = -1;
 HEAP8[i4 + 28 >> 0] = 0;
 HEAP8[i4 + 236 >> 0] = -1;
 HEAP8[i4 + 29 >> 0] = 0;
 HEAP8[i4 + 237 >> 0] = -1;
 HEAP8[i4 + 30 >> 0] = 0;
 HEAP8[i4 + 238 >> 0] = -1;
 HEAP8[i4 + 31 >> 0] = 0;
 HEAP8[i4 + 239 >> 0] = -1;
 i2 = i4 + 32 | 0;
 i3 = i4 + 208 | 0;
 i1 = 0;
 do {
  i8 = ((i1 | 0) == 0 | (i1 | 0) == 10) << 31 >> 31;
  HEAP8[i2 + i1 >> 0] = i8;
  HEAP8[i3 + i1 >> 0] = i8 & 255 ^ 255;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 HEAP8[i4 + 48 >> 0] = -1;
 HEAP8[i4 + 192 >> 0] = 0;
 HEAP8[i4 + 49 >> 0] = 0;
 HEAP8[i4 + 193 >> 0] = -1;
 HEAP8[i4 + 50 >> 0] = 0;
 HEAP8[i4 + 194 >> 0] = -1;
 HEAP8[i4 + 51 >> 0] = 0;
 HEAP8[i4 + 195 >> 0] = -1;
 HEAP8[i4 + 52 >> 0] = 0;
 HEAP8[i4 + 196 >> 0] = -1;
 HEAP8[i4 + 53 >> 0] = 0;
 HEAP8[i4 + 197 >> 0] = -1;
 HEAP8[i4 + 54 >> 0] = 0;
 HEAP8[i4 + 198 >> 0] = -1;
 HEAP8[i4 + 55 >> 0] = 0;
 HEAP8[i4 + 199 >> 0] = -1;
 HEAP8[i4 + 56 >> 0] = -1;
 HEAP8[i4 + 200 >> 0] = 0;
 HEAP8[i4 + 57 >> 0] = 0;
 HEAP8[i4 + 201 >> 0] = -1;
 HEAP8[i4 + 58 >> 0] = -1;
 HEAP8[i4 + 202 >> 0] = 0;
 HEAP8[i4 + 59 >> 0] = 0;
 HEAP8[i4 + 203 >> 0] = -1;
 HEAP8[i4 + 60 >> 0] = 0;
 HEAP8[i4 + 204 >> 0] = -1;
 HEAP8[i4 + 61 >> 0] = 0;
 HEAP8[i4 + 205 >> 0] = -1;
 HEAP8[i4 + 62 >> 0] = 0;
 HEAP8[i4 + 206 >> 0] = -1;
 HEAP8[i4 + 63 >> 0] = 0;
 HEAP8[i4 + 207 >> 0] = -1;
 HEAP8[i4 + 64 >> 0] = -1;
 HEAP8[i4 + 176 >> 0] = 0;
 HEAP8[i4 + 65 >> 0] = 0;
 HEAP8[i4 + 177 >> 0] = -1;
 HEAP8[i4 + 66 >> 0] = -1;
 HEAP8[i4 + 178 >> 0] = 0;
 HEAP8[i4 + 67 >> 0] = 0;
 HEAP8[i4 + 179 >> 0] = -1;
 HEAP8[i4 + 68 >> 0] = 0;
 HEAP8[i4 + 180 >> 0] = -1;
 HEAP8[i4 + 69 >> 0] = 0;
 HEAP8[i4 + 181 >> 0] = -1;
 HEAP8[i4 + 70 >> 0] = 0;
 HEAP8[i4 + 182 >> 0] = -1;
 HEAP8[i4 + 71 >> 0] = 0;
 HEAP8[i4 + 183 >> 0] = -1;
 HEAP8[i4 + 72 >> 0] = -1;
 HEAP8[i4 + 184 >> 0] = 0;
 HEAP8[i4 + 73 >> 0] = 0;
 HEAP8[i4 + 185 >> 0] = -1;
 HEAP8[i4 + 74 >> 0] = -1;
 HEAP8[i4 + 186 >> 0] = 0;
 HEAP8[i4 + 75 >> 0] = 0;
 HEAP8[i4 + 187 >> 0] = -1;
 HEAP8[i4 + 76 >> 0] = 0;
 HEAP8[i4 + 188 >> 0] = -1;
 HEAP8[i4 + 77 >> 0] = 0;
 HEAP8[i4 + 189 >> 0] = -1;
 HEAP8[i4 + 78 >> 0] = 0;
 HEAP8[i4 + 190 >> 0] = -1;
 HEAP8[i4 + 79 >> 0] = 0;
 HEAP8[i4 + 191 >> 0] = -1;
 HEAP8[i4 + 80 >> 0] = -1;
 HEAP8[i4 + 160 >> 0] = 0;
 HEAP8[i4 + 81 >> 0] = 0;
 HEAP8[i4 + 161 >> 0] = -1;
 HEAP8[i4 + 82 >> 0] = -1;
 HEAP8[i4 + 162 >> 0] = 0;
 HEAP8[i4 + 83 >> 0] = 0;
 HEAP8[i4 + 163 >> 0] = -1;
 HEAP8[i4 + 84 >> 0] = 0;
 HEAP8[i4 + 164 >> 0] = -1;
 HEAP8[i4 + 85 >> 0] = -1;
 HEAP8[i4 + 165 >> 0] = 0;
 HEAP8[i4 + 86 >> 0] = 0;
 HEAP8[i4 + 166 >> 0] = -1;
 HEAP8[i4 + 87 >> 0] = 0;
 HEAP8[i4 + 167 >> 0] = -1;
 HEAP8[i4 + 88 >> 0] = -1;
 HEAP8[i4 + 168 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 0;
 HEAP8[i4 + 169 >> 0] = -1;
 HEAP8[i4 + 90 >> 0] = -1;
 HEAP8[i4 + 170 >> 0] = 0;
 HEAP8[i4 + 91 >> 0] = 0;
 HEAP8[i4 + 171 >> 0] = -1;
 HEAP8[i4 + 92 >> 0] = 0;
 HEAP8[i4 + 172 >> 0] = -1;
 HEAP8[i4 + 93 >> 0] = 0;
 HEAP8[i4 + 173 >> 0] = -1;
 HEAP8[i4 + 94 >> 0] = 0;
 HEAP8[i4 + 174 >> 0] = -1;
 HEAP8[i4 + 95 >> 0] = 0;
 HEAP8[i4 + 175 >> 0] = -1;
 HEAP8[i4 + 96 >> 0] = -1;
 HEAP8[i4 + 144 >> 0] = 0;
 HEAP8[i4 + 97 >> 0] = 0;
 HEAP8[i4 + 145 >> 0] = -1;
 HEAP8[i4 + 98 >> 0] = -1;
 HEAP8[i4 + 146 >> 0] = 0;
 HEAP8[i4 + 99 >> 0] = 0;
 HEAP8[i4 + 147 >> 0] = -1;
 HEAP8[i4 + 100 >> 0] = 0;
 HEAP8[i4 + 148 >> 0] = -1;
 HEAP8[i4 + 101 >> 0] = -1;
 HEAP8[i4 + 149 >> 0] = 0;
 HEAP8[i4 + 102 >> 0] = 0;
 HEAP8[i4 + 150 >> 0] = -1;
 HEAP8[i4 + 103 >> 0] = 0;
 HEAP8[i4 + 151 >> 0] = -1;
 HEAP8[i4 + 104 >> 0] = -1;
 HEAP8[i4 + 152 >> 0] = 0;
 HEAP8[i4 + 105 >> 0] = 0;
 HEAP8[i4 + 153 >> 0] = -1;
 HEAP8[i4 + 106 >> 0] = -1;
 HEAP8[i4 + 154 >> 0] = 0;
 HEAP8[i4 + 107 >> 0] = 0;
 HEAP8[i4 + 155 >> 0] = -1;
 HEAP8[i4 + 108 >> 0] = 0;
 HEAP8[i4 + 156 >> 0] = -1;
 HEAP8[i4 + 109 >> 0] = 0;
 HEAP8[i4 + 157 >> 0] = -1;
 HEAP8[i4 + 110 >> 0] = 0;
 HEAP8[i4 + 158 >> 0] = -1;
 HEAP8[i4 + 111 >> 0] = -1;
 HEAP8[i4 + 159 >> 0] = 0;
 HEAP8[i4 + 112 >> 0] = -1;
 HEAP8[i4 + 128 >> 0] = 0;
 HEAP8[i4 + 113 >> 0] = 0;
 HEAP8[i4 + 129 >> 0] = -1;
 HEAP8[i4 + 114 >> 0] = -1;
 HEAP8[i4 + 130 >> 0] = 0;
 HEAP8[i4 + 115 >> 0] = 0;
 HEAP8[i4 + 131 >> 0] = -1;
 HEAP8[i4 + 116 >> 0] = 0;
 HEAP8[i4 + 132 >> 0] = -1;
 HEAP8[i4 + 117 >> 0] = -1;
 HEAP8[i4 + 133 >> 0] = 0;
 HEAP8[i4 + 118 >> 0] = 0;
 HEAP8[i4 + 134 >> 0] = -1;
 HEAP8[i4 + 119 >> 0] = 0;
 HEAP8[i4 + 135 >> 0] = -1;
 HEAP8[i4 + 120 >> 0] = -1;
 HEAP8[i4 + 136 >> 0] = 0;
 HEAP8[i4 + 121 >> 0] = 0;
 HEAP8[i4 + 137 >> 0] = -1;
 HEAP8[i4 + 122 >> 0] = -1;
 HEAP8[i4 + 138 >> 0] = 0;
 HEAP8[i4 + 123 >> 0] = 0;
 HEAP8[i4 + 139 >> 0] = -1;
 HEAP8[i4 + 124 >> 0] = 0;
 HEAP8[i4 + 140 >> 0] = -1;
 HEAP8[i4 + 125 >> 0] = -1;
 HEAP8[i4 + 141 >> 0] = 0;
 HEAP8[i4 + 126 >> 0] = 0;
 HEAP8[i4 + 142 >> 0] = -1;
 HEAP8[i4 + 127 >> 0] = -1;
 HEAP8[i4 + 143 >> 0] = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0)) {
  i8 = HEAP32[gb + 1158152 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i6 = i6 + 192 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(i6 | 0, i8 | 0);
  STACKTOP = i7;
  return;
 }
 i2 = gb + 63520 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i8 = __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId(4, i6) | 0;
 HEAP32[gb + 1158156 >> 2] = i8;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 48 >> 2] | 0, i8 | 0, 61);
 __ZN9Texture3D11InitTextureEiii13TextureFormatb(HEAP32[gb + 1158156 >> 2] | 0, 4, 4, 16, 1, 0) | 0;
 i8 = HEAP32[gb + 1158156 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, gb + 403306 | 0);
 i8 = HEAP32[gb + 1158156 >> 2] | 0;
 HEAP32[i8 + 36 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 92 >> 2] | 0, i8 | 0);
 i8 = HEAP32[gb + 1158156 >> 2] | 0;
 _memcpy(HEAP32[i8 + 96 >> 2] | 0, i4 | 0, 256) | 0;
 __ZN9Texture3D15UpdateImageDataEb(i8, 0);
 i8 = HEAP32[gb + 1158152 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i6 = i6 + 192 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(i6 | 0, i8 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx23PxcFsGetImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_(i11, i4, i2, i17) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i1 = 0, i3 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 32 | 0;
 i12 = i18;
 i3 = i11 + 26 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 i15 = i11 + ((i1 & 65535) + 144) | 0;
 i13 = i11 + (((HEAPU16[i11 + 8 >> 1] | 0) * 432 | 0) + (HEAPU16[i11 + 24 >> 1] | 0)) | 0;
 i14 = i11 + (HEAPU16[i11 + 10 >> 1] | 0) | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(-f6);
 f8 = Math_fround(-f8);
 f10 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(-f9);
 f7 = Math_fround(-f7);
 f5 = Math_fround(-Math_fround(HEAPF32[i2 + 24 >> 2]));
 if (i4) {
  i1 = i4;
  while (1) {
   f20 = Math_fround(HEAPF32[i14 + (i1 << 5) + 16 >> 2]);
   f25 = Math_fround(HEAPF32[i14 + (i1 << 5) + 20 >> 2]);
   f22 = Math_fround(HEAPF32[i14 + (i1 << 5) + 24 >> 2]);
   f24 = Math_fround(f9 + Math_fround(Math_fround(f8 * f22) - Math_fround(f10 * f25)));
   f22 = Math_fround(f7 + Math_fround(Math_fround(f10 * f20) - Math_fround(f6 * f22)));
   f20 = Math_fround(f5 + Math_fround(Math_fround(f6 * f25) - Math_fround(f8 * f20)));
   HEAPF32[i16 + (i1 << 4) >> 2] = f24;
   HEAPF32[i16 + (i1 << 4) + 4 >> 2] = f22;
   HEAPF32[i16 + (i1 << 4) + 8 >> 2] = f20;
   HEAPF32[i16 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   f25 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) >> 2]);
   f23 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 4 >> 2]);
   f29 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 8 >> 2]);
   f28 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 32 >> 2]);
   f26 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 36 >> 2]);
   f30 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 40 >> 2]);
   f32 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 64 >> 2]);
   f31 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 68 >> 2]);
   f32 = Math_fround(Math_fround(f25 * f24) + Math_fround(Math_fround(f22 * f28) + Math_fround(f20 * f32)));
   f31 = Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f22 * f26) + Math_fround(f20 * f31)));
   f30 = Math_fround(Math_fround(f24 * f29) + Math_fround(Math_fround(f22 * f30) + Math_fround(f20 * Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 72 >> 2]))));
   f29 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 16 >> 2]);
   f26 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 20 >> 2]);
   f23 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 24 >> 2]);
   f28 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 48 >> 2]);
   f25 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 52 >> 2]);
   f19 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 56 >> 2]);
   f27 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 80 >> 2]);
   f21 = Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 84 >> 2]);
   f6 = Math_fround(f6 - f32);
   f8 = Math_fround(f8 - f31);
   f10 = Math_fround(f10 - f30);
   f9 = Math_fround(f9 - Math_fround(Math_fround(f24 * f29) + Math_fround(Math_fround(f22 * f28) + Math_fround(f20 * f27))));
   f21 = Math_fround(f7 - Math_fround(Math_fround(f24 * f26) + Math_fround(Math_fround(f22 * f25) + Math_fround(f20 * f21))));
   f20 = Math_fround(f5 - Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f22 * f19) + Math_fround(f20 * Math_fround(HEAPF32[i15 + (i1 * 160 | 0) + 88 >> 2])))));
   f19 = Math_fround(HEAPF32[i14 + (i1 << 5) >> 2]);
   f5 = Math_fround(HEAPF32[i14 + (i1 << 5) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i14 + (i1 << 5) + 8 >> 2]);
   f9 = Math_fround(f9 + Math_fround(Math_fround(f10 * f5) - Math_fround(f8 * f7)));
   f7 = Math_fround(f21 + Math_fround(Math_fround(f6 * f7) - Math_fround(f10 * f19)));
   f5 = Math_fround(f20 + Math_fround(Math_fround(f8 * f19) - Math_fround(f6 * f5)));
   i1 = HEAP8[i11 + 64 + i1 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break; else i1 = i1 & 255;
  }
  i1 = HEAP16[i3 >> 1] | 0;
 }
 i1 = i1 & 65535;
 f20 = Math_fround(-f6);
 f31 = Math_fround(-f8);
 f25 = Math_fround(-f10);
 f22 = Math_fround(-f9);
 f26 = Math_fround(-f7);
 f32 = Math_fround(-f5);
 f33 = Math_fround(Math_fround(HEAPF32[i11 + i1 >> 2]) * f20);
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 16) >> 2]) * f31));
 f33 = Math_fround(f33 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 32) >> 2]) * f25));
 f5 = Math_fround(Math_fround(HEAPF32[i11 + (i1 + 4) >> 2]) * f20);
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 20) >> 2]) * f31));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 36) >> 2]) * f25));
 f6 = Math_fround(Math_fround(HEAPF32[i11 + (i1 + 8) >> 2]) * f20);
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 24) >> 2]) * f31));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 40) >> 2]) * f25));
 f7 = Math_fround(HEAPF32[i11 + (i1 + 48) >> 2]);
 f27 = Math_fround(f7 * f22);
 f9 = Math_fround(HEAPF32[i11 + (i1 + 64) >> 2]);
 f27 = Math_fround(f27 + Math_fround(f9 * f26));
 f19 = Math_fround(HEAPF32[i11 + (i1 + 80) >> 2]);
 f27 = Math_fround(f27 + Math_fround(f19 * f32));
 f8 = Math_fround(HEAPF32[i11 + (i1 + 52) >> 2]);
 f28 = Math_fround(f8 * f22);
 f10 = Math_fround(HEAPF32[i11 + (i1 + 68) >> 2]);
 f28 = Math_fround(f28 + Math_fround(f10 * f26));
 f21 = Math_fround(HEAPF32[i11 + (i1 + 84) >> 2]);
 f28 = Math_fround(f28 + Math_fround(f21 * f32));
 f23 = Math_fround(HEAPF32[i11 + (i1 + 56) >> 2]);
 f29 = Math_fround(f23 * f22);
 f24 = Math_fround(HEAPF32[i11 + (i1 + 72) >> 2]);
 f29 = Math_fround(f29 + Math_fround(f24 * f26));
 f30 = Math_fround(HEAPF32[i11 + (i1 + 88) >> 2]);
 f27 = Math_fround(f33 + f27);
 f28 = Math_fround(f5 + f28);
 f29 = Math_fround(f6 + Math_fround(f29 + Math_fround(f30 * f32)));
 f23 = Math_fround(Math_fround(Math_fround(f7 * f20) + Math_fround(f8 * f31)) + Math_fround(f23 * f25));
 f24 = Math_fround(Math_fround(Math_fround(f9 * f20) + Math_fround(f10 * f31)) + Math_fround(f24 * f25));
 f25 = Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * f31)) + Math_fround(f30 * f25));
 f30 = Math_fround(Math_fround(HEAPF32[i11 + (i1 + 96) >> 2]) * f22);
 f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 112) >> 2]) * f26));
 f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 128) >> 2]) * f32));
 f31 = Math_fround(Math_fround(HEAPF32[i11 + (i1 + 100) >> 2]) * f22);
 f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 116) >> 2]) * f26));
 f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 132) >> 2]) * f32));
 f22 = Math_fround(Math_fround(HEAPF32[i11 + (i1 + 104) >> 2]) * f22);
 f26 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 120) >> 2]) * f26));
 f30 = Math_fround(f23 + f30);
 f31 = Math_fround(f24 + f31);
 f32 = Math_fround(f25 + Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i11 + (i1 + 136) >> 2]) * f32)));
 HEAPF32[i17 >> 2] = f27;
 HEAPF32[i17 + 4 >> 2] = f28;
 HEAPF32[i17 + 8 >> 2] = f29;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 16 >> 2] = f30;
 HEAPF32[i17 + 20 >> 2] = f31;
 HEAPF32[i17 + 24 >> 2] = f32;
 HEAPF32[i17 + 28 >> 2] = Math_fround(0.0);
 i1 = i15 + (i4 * 160 | 0) + 152 | 0;
 i1 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, -1, -1) | 0;
 i2 = getTempRet0() | 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  STACKTOP = i18;
  return;
 }
 i3 = i17 + 16 | 0;
 i4 = i12 + 16 | 0;
 do {
  i34 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
  i11 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i11 = i1 | 0 ? HEAP32[gb + 90668 + (i34 << 2) >> 2] | 0 : (HEAP32[gb + 90668 + (i11 << 2) >> 2] | 0) + 32 | 0;
  __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i12, i15 + (i11 * 160 | 0) | 0, i14 + (i11 << 5) | 0, i16 + (i11 << 4) | 0, i17, i13 + (i11 * 96 | 0) | 0);
  HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i11 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i1 = i11 & i1;
  i2 = (getTempRet0() | 0) & i2;
 } while (!((i1 | 0) == 0 & (i2 | 0) == 0));
 STACKTOP = i18;
 return;
}

function __ZN9Texture2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i20, i21) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i23 + 16 | 0;
 i12 = i23 + 48 | 0;
 i22 = i23 + 28 | 0;
 i16 = i23 + 24 | 0;
 i13 = i23;
 i14 = i23 + 8 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i20, i21);
 i19 = i20 + 52 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i18 + 8 | 0);
  i2 = i1 + 28 | 0;
  i18 = i18 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  i2 = HEAP32[i19 >> 2] | 0;
  i18 = i2 + 4 | 0;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + -1;
  if (!(HEAP32[i18 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i19 >> 2] = i1;
 }
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 i17 = i22 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i2 = i15;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i18;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i21 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i21 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i11 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 i10 = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 i8 = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 1);
  i1 = HEAP8[i15 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i15 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i20 + 111 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i21);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i20 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i20 + 32 | 0, i21);
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i20 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i15, 4);
  i1 = HEAP32[i15 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i15 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i20 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i16 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i21, i16, gb + 411165 | 0, 1);
 HEAP32[i20 + 84 >> 2] = i11;
 HEAP32[i20 + 88 >> 2] = i10;
 HEAP32[i20 + 92 >> 2] = i8;
 i4 = (i6 | 0) > 1;
 i2 = i20 + 96 | 0;
 HEAP32[i2 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(i11, i4, i8) | 0;
 i3 = i20 + 100 | 0;
 HEAP32[i3 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(i10, i4, i8) | 0;
 i4 = i20 + 76 | 0;
 HEAP32[i4 >> 2] = i6;
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  i9 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i19 >> 2] = 0;
 }
 __ZN9Texture2D16DeleteGfxTextureEv(i20);
 __ZNK6Object14GetMemoryLabelEv(i15, i20);
 if ((HEAP32[i15 >> 2] | 0) == 22) __ZNK6Object14GetMemoryLabelEv(i13, i20); else {
  __ZNK6Object14GetMemoryLabelEv(i12, i20);
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = 19;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  i12 = i1 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i19 >> 2] = 0;
 }
 i12 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 888) | 0;
 i6 = i13;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i13 = i14;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = i9;
 i13 = HEAP32[i4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i12, i15, i11, i10, i8, i7, i5, i13, 1, 1);
 HEAP32[i19 >> 2] = i12;
 f25 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 >> 2] | 0));
 f24 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i3 >> 2] | 0));
 HEAPF32[i20 + 68 >> 2] = f25;
 HEAPF32[i20 + 72 >> 2] = f24;
 i15 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 136 >> 2] | 0, i20 | 0) | 0;
 if (!(i15 + -1 & i15)) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 140 >> 2] | 0, i20 | 0) | 0;
  i1 = (i1 + -1 & i1 | 0) == 0 & 1;
 } else i1 = 0;
 HEAP8[i20 + 108 >> 0] = i1;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i21, HEAP32[i16 >> 2] | 0, i1, 0);
 i2 = HEAP32[i16 >> 2] | 0;
 switch (i8 | 0) {
 case 6:
  {
   i3 = (i2 | 0) / 4 | 0;
   if ((i2 | 0) > 3) {
    i2 = 0;
    while (1) {
     HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
    }
   }
   break;
  }
 case 2:
 case 7:
 case 13:
  {
   i3 = (i2 | 0) / 2 | 0;
   if ((i2 | 0) > 1) {
    i2 = 0;
    while (1) {
     HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i21, 2, gb + 411176 | 0, i20 + 120 | 0, i1, 0);
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i23;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i18);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 L1 : while (1) {
  i9 = i2;
  i11 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 68;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    do if ((i3 | 0) > 3996) {
     i4 = (i4 | 0) / 4 | 0;
     i6 = i1 + (i4 << 2) | 0;
     i4 = i7 + (i4 << 2) | 0;
     i3 = __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i1, i6, i7, i4, i12) | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) {
      i5 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i5;
      i5 = i3 + 1 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
       i5 = HEAP32[i7 >> 2] | 0;
       HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i4 >> 2] = i5;
       i4 = i3 + 2 | 0;
       if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
        i5 = HEAP32[i6 >> 2] | 0;
        HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i7 >> 2] = i5;
        if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
         i5 = HEAP32[i1 >> 2] | 0;
         HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
         HEAP32[i6 >> 2] = i5;
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i4;
      } else i3 = i5;
     }
    } else {
     i6 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
     if (!i6) {
      if (!i3) {
       i3 = 0;
       break;
      }
      i6 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i6;
      if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i7 >> 2] = i3;
      i3 = 2;
      break;
     }
     i4 = HEAP32[i1 >> 2] | 0;
     if (i3) {
      HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i4;
      i3 = 1;
      break;
     }
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i7 >> 2] = i4;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0) {
      i3 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i3;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
      i10 = 51;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i10 = 68;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i10 = 68;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i8;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i10 = 68;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i5 = i3 + 4 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -4 | 0; while (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i10 | 0) == 51) {
    i10 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i6;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L48 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    while (1) {
     i6 = i5 + 4 | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) i5 = i6; else break;
    }
    do i4 = i4 + -4 | 0; while (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i7;
     break L48;
    }
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
    i5 = i6;
    i3 = i3 + 1 | 0;
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) {
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEbT0_SA_T_(i1, i5, i12) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEbT0_SA_T_(i4, i2, i12) | 0) {
     i10 = 67;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i8 | 0) >= (i9 - i13 | 0)) {
    i10 = 66;
    break;
   }
   __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i1, i5, i12);
   i1 = i5 + 4 | 0;
  }
  if ((i10 | 0) == 66) {
   i10 = 0;
   __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i5 + 4 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i10 | 0) == 67) {
   i10 = 0;
   if (i3) {
    i10 = 68;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 4 | 0;
  i13 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  if (!i13) {
   if (!i3) return;
   i13 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i13;
   if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
   i13 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i13;
   return;
  }
  i4 = HEAP32[i1 >> 2] | 0;
  if (i3) {
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i4;
   return;
  }
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0)) return;
  i13 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i11, i12) | 0;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 4 | 0;
  i3 = i1 + 8 | 0;
  i4 = i1 + 12 | 0;
  __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i1, i2, i3, i4, i12) | 0;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i3 >> 2] | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i13;
  HEAP32[i4 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i2 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i3 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i1, i2, i12);
  return;
 } else if ((i10 | 0) == 68) return;
}

function __ZN10__cxxabiv112_GLOBAL__N_123parse_binary_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_(i1, i2, i9, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i14 + 84 | 0;
 i16 = i14 + 72 | 0;
 i8 = i14 + 60 | 0;
 i10 = i14 + 48 | 0;
 i11 = i14 + 36 | 0;
 i12 = i14 + 24 | 0;
 i13 = i14 + 12 | 0;
 i15 = i14;
 i3 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i4) | 0;
 L1 : do if ((i3 | 0) != (i1 | 0)) {
  i7 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i3, i2, i4) | 0;
  i5 = i4 + 4 | 0;
  if ((i7 | 0) == (i3 | 0)) {
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = i3 + -24 | 0;
   while (1) {
    if ((i3 | 0) == (i2 | 0)) break L1;
    i17 = i3 + -24 | 0;
    HEAP32[i5 >> 2] = i17;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i17);
    i3 = HEAP32[i5 >> 2] | 0;
   }
  }
  i2 = HEAP32[i5 >> 2] | 0;
  if (((i2 - (HEAP32[i4 >> 2] | 0) | 0) / 24 | 0) >>> 0 >= 2) {
   __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i17, i2 + -24 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1 + -24 | 0;
   i3 = i1;
   while (1) {
    if ((i3 | 0) == (i2 | 0)) break;
    i6 = i3 + -24 | 0;
    HEAP32[i5 >> 2] = i6;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
    i3 = HEAP32[i5 >> 2] | 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4619 | 0, i16 | 0, i1 + -48 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    i5 = i1 + -24 | 0;
    i2 = i5 + 11 | 0;
    if ((HEAP8[i2 >> 0] | 0) < 0) {
     HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
     HEAP32[i1 + -20 >> 2] = 0;
    } else {
     HEAP8[i5 >> 0] = 0;
     HEAP8[i2 >> 0] = 0;
    }
    i3 = i9 + 11 | 0;
    i6 = HEAP8[i3 >> 0] | 0;
    i1 = i6 << 24 >> 24 < 0;
    i4 = i9 + 4 | 0;
    if (((i1 ? HEAP32[i4 >> 2] | 0 : i6 & 255) | 0) == 1) if (!(__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1 ? HEAP32[i9 >> 2] | 0 : i9, gb + 1086447 | 0, 1) | 0)) {
     __THREW__ = 0;
     invoke_vii(fb + 4620 | 0, i5 | 0, 40);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) i6 = 15; else i6 = 16;
    } else i6 = 16; else i6 = 16;
    L24 : do if ((i6 | 0) == 16) {
     __THREW__ = 0;
     invoke_viii(fb + 1067 | 0, i15 | 0, gb + 1086383 | 0, i16 | 0);
     i2 = __THREW__;
     __THREW__ = 0;
     if (i2 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      __THREW__ = 0;
      i2 = invoke_iii(fb + 1152 | 0, i15 | 0, gb + 1087675 | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       i1 = 0;
       while (1) {
        if ((i1 | 0) == 3) break;
        HEAP32[i2 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       }
       i2 = HEAP8[i3 >> 0] | 0;
       i1 = i2 << 24 >> 24 < 0;
       __THREW__ = 0;
       i2 = invoke_iiii(fb + 519 | 0, i13 | 0, (i1 ? HEAP32[i9 >> 2] | 0 : i9) | 0, (i1 ? HEAP32[i4 >> 2] | 0 : i2 & 255) | 0) | 0;
       i1 = __THREW__;
       __THREW__ = 0;
       if (i1 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        i1 = 0;
        while (1) {
         if ((i1 | 0) == 3) break;
         HEAP32[i2 + (i1 << 2) >> 2] = 0;
         i1 = i1 + 1 | 0;
        }
        __THREW__ = 0;
        i2 = invoke_iii(fb + 1152 | 0, i12 | 0, gb + 1086285 | 0) | 0;
        i1 = __THREW__;
        __THREW__ = 0;
        if (i1 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         i1 = 0;
         while (1) {
          if ((i1 | 0) == 3) break;
          HEAP32[i2 + (i1 << 2) >> 2] = 0;
          i1 = i1 + 1 | 0;
         }
         i2 = HEAP8[i17 + 11 >> 0] | 0;
         i1 = i2 << 24 >> 24 < 0;
         __THREW__ = 0;
         i2 = invoke_iiii(fb + 519 | 0, i11 | 0, (i1 ? HEAP32[i17 >> 2] | 0 : i17) | 0, (i1 ? HEAP32[i17 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
         i1 = __THREW__;
         __THREW__ = 0;
         if (i1 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
         } else {
          HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
          HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
          HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
          i1 = 0;
          while (1) {
           if ((i1 | 0) == 3) break;
           HEAP32[i2 + (i1 << 2) >> 2] = 0;
           i1 = i1 + 1 | 0;
          }
          __THREW__ = 0;
          i2 = invoke_iii(fb + 1152 | 0, i10 | 0, gb + 1086288 | 0) | 0;
          i1 = __THREW__;
          __THREW__ = 0;
          do if (i1 & 1) {
           i1 = ___cxa_find_matching_catch_2() | 0;
           getTempRet0() | 0;
          } else {
           HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
           HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
           HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
           i1 = 0;
           while (1) {
            if ((i1 | 0) == 3) break;
            HEAP32[i2 + (i1 << 2) >> 2] = 0;
            i1 = i1 + 1 | 0;
           }
           i2 = HEAP8[i8 + 11 >> 0] | 0;
           i1 = i2 << 24 >> 24 < 0;
           __THREW__ = 0;
           invoke_iiii(fb + 519 | 0, i5 | 0, (i1 ? HEAP32[i8 >> 2] | 0 : i8) | 0, (i1 ? HEAP32[i8 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
           i2 = __THREW__;
           __THREW__ = 0;
           if (i2 & 1) {
            i1 = ___cxa_find_matching_catch_2() | 0;
            getTempRet0() | 0;
            __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
            break;
           }
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i10);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
           i15 = HEAP8[i3 >> 0] | 0;
           i1 = i15 << 24 >> 24 < 0;
           do if (((i1 ? HEAP32[i4 >> 2] | 0 : i15 & 255) | 0) == 1) {
            if (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1 ? HEAP32[i9 >> 2] | 0 : i9, gb + 1086447 | 0, 1) | 0) break;
            __THREW__ = 0;
            invoke_vii(fb + 4620 | 0, i5 | 0, 41);
            i15 = __THREW__;
            __THREW__ = 0;
            if (i15 & 1) {
             i6 = 15;
             break L24;
            }
           } while (0);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
           __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
           i1 = i7;
           break L1;
          } while (0);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i10);
         }
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
     }
    } while (0);
    if ((i6 | 0) == 15) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i16);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
   ___resumeException(i1 | 0);
  }
 } while (0);
 STACKTOP = i14;
 return i1 | 0;
}

function __Z26CalculateSphereFrom4PointsPK8Vector3fRS_Rf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, d10 = 0.0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 i40 = i1 + 4 | 0;
 i38 = i9 + 16 | 0;
 HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
 i39 = i1 + 8 | 0;
 i37 = i9 + 32 | 0;
 HEAP32[i37 >> 2] = HEAP32[i39 >> 2];
 i36 = i9 + 48 | 0;
 HEAPF32[i36 >> 2] = Math_fround(1.0);
 i44 = i1 + 12 | 0;
 i32 = i9 + 4 | 0;
 HEAP32[i32 >> 2] = HEAP32[i44 >> 2];
 i34 = i1 + 16 | 0;
 i31 = i9 + 20 | 0;
 HEAP32[i31 >> 2] = HEAP32[i34 >> 2];
 i33 = i1 + 20 | 0;
 i30 = i9 + 36 | 0;
 HEAP32[i30 >> 2] = HEAP32[i33 >> 2];
 i29 = i9 + 52 | 0;
 HEAPF32[i29 >> 2] = Math_fround(1.0);
 i43 = i1 + 24 | 0;
 i25 = i9 + 8 | 0;
 HEAP32[i25 >> 2] = HEAP32[i43 >> 2];
 i27 = i1 + 28 | 0;
 i24 = i9 + 24 | 0;
 HEAP32[i24 >> 2] = HEAP32[i27 >> 2];
 i26 = i1 + 32 | 0;
 i23 = i9 + 40 | 0;
 HEAP32[i23 >> 2] = HEAP32[i26 >> 2];
 i22 = i9 + 56 | 0;
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i42 = i1 + 36 | 0;
 i17 = i9 + 12 | 0;
 HEAP32[i17 >> 2] = HEAP32[i42 >> 2];
 i20 = i1 + 40 | 0;
 i15 = i9 + 28 | 0;
 HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
 i19 = i1 + 44 | 0;
 i13 = i9 + 44 | 0;
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 i11 = i9 + 60 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 f8 = Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i9));
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i40 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i39 >> 2]);
 HEAPF32[i9 >> 2] = Math_fround(f7 + Math_fround(f5 * f5));
 HEAPF32[i38 >> 2] = f6;
 HEAPF32[i37 >> 2] = f5;
 HEAPF32[i36 >> 2] = Math_fround(1.0);
 i35 = i1 + 12 | 0;
 f5 = Math_fround(HEAPF32[i35 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i34 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f6 * f6));
 f7 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i32 >> 2] = Math_fround(f5 + Math_fround(f7 * f7));
 HEAPF32[i31 >> 2] = f6;
 HEAPF32[i30 >> 2] = f7;
 HEAPF32[i29 >> 2] = Math_fround(1.0);
 i28 = i1 + 24 | 0;
 f7 = Math_fround(HEAPF32[i28 >> 2]);
 f7 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i26 >> 2]);
 HEAPF32[i25 >> 2] = Math_fround(f7 + Math_fround(f5 * f5));
 HEAPF32[i24 >> 2] = f6;
 HEAPF32[i23 >> 2] = f5;
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i21 = i1 + 36 | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i20 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f6 * f6));
 f7 = Math_fround(HEAPF32[i19 >> 2]);
 HEAPF32[i17 >> 2] = Math_fround(f5 + Math_fround(f7 * f7));
 HEAPF32[i15 >> 2] = f6;
 HEAPF32[i13 >> 2] = f7;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 f7 = Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i9));
 i45 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i45;
 f6 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 * f6);
 f5 = Math_fround(HEAPF32[i40 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i39 >> 2]);
 HEAPF32[i38 >> 2] = Math_fround(f5 + Math_fround(f6 * f6));
 HEAPF32[i37 >> 2] = f6;
 HEAPF32[i36 >> 2] = Math_fround(1.0);
 i45 = HEAP32[i44 >> 2] | 0;
 HEAP32[i32 >> 2] = i45;
 f6 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 * f6);
 f5 = Math_fround(HEAPF32[i34 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i31 >> 2] = Math_fround(f5 + Math_fround(f6 * f6));
 HEAPF32[i30 >> 2] = f6;
 HEAPF32[i29 >> 2] = Math_fround(1.0);
 i45 = HEAP32[i43 >> 2] | 0;
 HEAP32[i25 >> 2] = i45;
 f6 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 * f6);
 f5 = Math_fround(HEAPF32[i27 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i26 >> 2]);
 HEAPF32[i24 >> 2] = Math_fround(f5 + Math_fround(f6 * f6));
 HEAPF32[i23 >> 2] = f6;
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i45 = HEAP32[i42 >> 2] | 0;
 HEAP32[i17 >> 2] = i45;
 f6 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 * f6);
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 HEAPF32[i15 >> 2] = Math_fround(f5 + Math_fround(f6 * f6));
 HEAPF32[i13 >> 2] = f6;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 f6 = Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i9));
 i45 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i45;
 i41 = HEAP32[i40 >> 2] | 0;
 HEAP32[i38 >> 2] = i41;
 f5 = (HEAP32[tempDoublePtr >> 2] = i45, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 * f5);
 f12 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f5 + Math_fround(f12 * f12));
 f5 = Math_fround(HEAPF32[i39 >> 2]);
 HEAPF32[i37 >> 2] = Math_fround(f12 + Math_fround(f5 * f5));
 HEAPF32[i36 >> 2] = Math_fround(1.0);
 i44 = HEAP32[i44 >> 2] | 0;
 HEAP32[i32 >> 2] = i44;
 i41 = HEAP32[i34 >> 2] | 0;
 HEAP32[i31 >> 2] = i41;
 f5 = (HEAP32[tempDoublePtr >> 2] = i44, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 * f5);
 f12 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f5 + Math_fround(f12 * f12));
 f5 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i30 >> 2] = Math_fround(f12 + Math_fround(f5 * f5));
 HEAPF32[i29 >> 2] = Math_fround(1.0);
 i43 = HEAP32[i43 >> 2] | 0;
 HEAP32[i25 >> 2] = i43;
 i41 = HEAP32[i27 >> 2] | 0;
 HEAP32[i24 >> 2] = i41;
 f5 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 * f5);
 f12 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f5 + Math_fround(f12 * f12));
 f5 = Math_fround(HEAPF32[i26 >> 2]);
 HEAPF32[i23 >> 2] = Math_fround(f12 + Math_fround(f5 * f5));
 HEAPF32[i22 >> 2] = Math_fround(1.0);
 i42 = HEAP32[i42 >> 2] | 0;
 HEAP32[i17 >> 2] = i42;
 i41 = HEAP32[i20 >> 2] | 0;
 HEAP32[i15 >> 2] = i41;
 f5 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 * f5);
 f12 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f5 + Math_fround(f12 * f12));
 f5 = Math_fround(HEAPF32[i19 >> 2]);
 HEAPF32[i13 >> 2] = Math_fround(f12 + Math_fround(f5 * f5));
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 f5 = Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i9));
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(f12 * f12);
 f16 = Math_fround(HEAPF32[i40 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f16 * f16));
 f18 = Math_fround(HEAPF32[i39 >> 2]);
 HEAPF32[i9 >> 2] = Math_fround(f14 + Math_fround(f18 * f18));
 HEAPF32[i38 >> 2] = f12;
 HEAPF32[i37 >> 2] = f16;
 HEAPF32[i36 >> 2] = f18;
 f18 = Math_fround(HEAPF32[i35 >> 2]);
 f16 = Math_fround(f18 * f18);
 f12 = Math_fround(HEAPF32[i34 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f12 * f12));
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 HEAPF32[i32 >> 2] = Math_fround(f16 + Math_fround(f14 * f14));
 HEAPF32[i31 >> 2] = f18;
 HEAPF32[i30 >> 2] = f12;
 HEAPF32[i29 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f14 * f14);
 f18 = Math_fround(HEAPF32[i27 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f18 * f18));
 f16 = Math_fround(HEAPF32[i26 >> 2]);
 HEAPF32[i25 >> 2] = Math_fround(f12 + Math_fround(f16 * f16));
 HEAPF32[i24 >> 2] = f14;
 HEAPF32[i23 >> 2] = f18;
 HEAPF32[i22 >> 2] = f16;
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f18 = Math_fround(f16 * f16);
 f14 = Math_fround(HEAPF32[i20 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f14));
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 HEAPF32[i17 >> 2] = Math_fround(f18 + Math_fround(f12 * f12));
 HEAPF32[i15 >> 2] = f16;
 HEAPF32[i13 >> 2] = f14;
 HEAPF32[i11 >> 2] = f12;
 d10 = +f8;
 f7 = Math_fround(+f7 * .5 / d10);
 f6 = Math_fround(+f6 * .5 / d10);
 f5 = Math_fround(+f5 * .5 / d10);
 HEAPF32[i3 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)) - Math_fround(Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i9)) / f8))));
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f5;
 STACKTOP = i4;
 return;
}

function __ZN15AnimationBinder18CalculateTargetPtrEiP6ObjectPKcPPvPi(i7, i8, i1, i12, i14, i15) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 24 | 0;
 i11 = i16;
 i9 = i16 + 8 | 0;
 switch (i8 | 0) {
 case 4:
  {
   if (!(_strcmp(i12, gb + 896797 | 0) | 0)) {
    HEAP32[i15 >> 2] = 1;
    HEAP32[i14 >> 2] = i1 + 56;
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
   if (!(_strcmp(i12, gb + 896813 | 0) | 0)) {
    HEAP32[i15 >> 2] = 3;
    HEAP32[i14 >> 2] = i1 + 68;
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
   if (!(_strcmp(i12, gb + 896768 | 0) | 0)) {
    HEAP32[i15 >> 2] = 2;
    HEAP32[i14 >> 2] = i1 + 40;
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
   if (!(_strcmp(i12, gb + 896784 | 0) | 0)) {
    HEAP32[i15 >> 2] = 4;
    HEAP32[i14 >> 2] = i1 + 40;
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
   break;
  }
 case 21:
  {
   i2 = HEAP8[i12 >> 0] | 0;
   do if (i2 << 24 >> 24 == 91) {
    i2 = i12;
    i1 = 91;
    L19 : while (1) {
     switch (i1 << 24 >> 24) {
     case 46:
      {
       i13 = 13;
       break L19;
      }
     case 0:
      {
       i1 = 0;
       i13 = 85;
       break L19;
      }
     default:
      {}
     }
     i1 = i2 + 1 | 0;
     i2 = i1;
     i1 = HEAP8[i1 >> 0] | 0;
    }
    if ((i13 | 0) == 13) {
     i1 = __Z11StringToIntPKc(i12 + 1 | 0) | 0;
     i8 = i2 + 1 | 0;
     i3 = i2;
     i2 = HEAP8[i2 >> 0] | 0;
     break;
    } else if ((i13 | 0) == 85) {
     STACKTOP = i16;
     return i1 | 0;
    }
   } else {
    i1 = 0;
    i8 = i12;
    i3 = i12;
   } while (0);
   L26 : do if (!(i2 << 24 >> 24)) i13 = 18; else {
    i4 = i8;
    i6 = -1;
    i7 = i3;
    while (1) {
     i6 = (i6 | 0) == -1 & i2 << 24 >> 24 == 46 ? i7 - i4 | 0 : i6;
     i3 = i7 + 1 | 0;
     i2 = HEAP8[i3 >> 0] | 0;
     if (!(i2 << 24 >> 24)) break; else i7 = i3;
    }
    if ((i6 | 0) == -1) i13 = 18; else {
     i5 = i8 + i6 | 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     if (i6 >>> 0 > 4294967279) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
      i13 = 22;
     } else if (i6 >>> 0 < 11) {
      HEAP8[i9 + 11 >> 0] = i6;
      if (!i6) {
       i2 = i9;
       i3 = 1;
      } else {
       i2 = i9;
       i13 = 24;
      }
     } else i13 = 22;
     if ((i13 | 0) == 22) {
      i12 = i6 + 16 & -16;
      i2 = __Znwj(i12) | 0;
      HEAP32[i9 >> 2] = i2;
      HEAP32[i9 + 8 >> 2] = i12 | -2147483648;
      HEAP32[i9 + 4 >> 2] = i6;
      i13 = 24;
     }
     if ((i13 | 0) == 24) {
      i3 = i2;
      i4 = i8;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
      }
      i2 = i2 + i6 | 0;
      i3 = i6 + 1 | 0;
     }
     HEAP8[i2 >> 0] = 0;
     i5 = __ZN9ShaderLab26GetFastPropertyIndexByNameEPKc((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     i2 = i8 + i3 | 0;
     switch (HEAP8[i2 >> 0] | 0) {
     case 121:
     case 103:
      {
       i3 = 268435456;
       i4 = 11;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     case 122:
     case 98:
      {
       i3 = 536870912;
       i4 = 11;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     case 119:
     case 97:
      {
       i3 = 805306368;
       i4 = 11;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     case 115:
      {
       i3 = (HEAP8[i7 >> 0] | 0) == 120 ? 0 : 268435456;
       i4 = 12;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     case 111:
      {
       i3 = (HEAP8[i7 >> 0] | 0) == 120 ? 536870912 : 805306368;
       i4 = 12;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     case 114:
      if ((i7 | 0) == (i2 | 0)) {
       i3 = 0;
       i4 = 11;
       i2 = i5;
       i13 = 34;
       break L26;
      } else {
       i5 = 0;
       i2 = 0;
       i1 = 0;
       break L26;
      }
     case 120:
      {
       i3 = 0;
       i4 = 11;
       i2 = i5;
       i13 = 34;
       break L26;
      }
     default:
      {
       i5 = 0;
       i2 = 0;
       i1 = 0;
       break L26;
      }
     }
    }
   } while (0);
   if ((i13 | 0) == 18) {
    i3 = 0;
    i4 = 10;
    i2 = __ZN9ShaderLab26GetFastPropertyIndexByNameEPKc(i8) | 0;
    i13 = 34;
   }
   if ((i13 | 0) == 34) {
    i5 = 1;
    i2 = i2 << 4 | i4 | i3;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i15 >> 2] = i2;
   i15 = i5;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 1:
  {
   if (!(_strcmp(i12, gb + 896826 | 0) | 0)) {
    HEAP32[i15 >> 2] = 7;
    HEAP32[i14 >> 2] = i1;
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
   break;
  }
 default:
  {}
 }
 i9 = (i8 | 0) == 114;
 i5 = i7 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 L61 : do if (!i4) i13 = 53; else {
  i2 = i4;
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) <= (i8 | 0)) {
    if ((i3 | 0) >= (i8 | 0)) break;
    i2 = i2 + 4 | 0;
   }
   i2 = HEAP32[i2 >> 2] | 0;
   if (!i2) {
    i13 = 53;
    break L61;
   }
  }
  i2 = i5;
  L70 : while (1) {
   i3 = i4;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i8 | 0)) break;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) break L70;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) == (i5 | 0)) i13 = 51; else if ((HEAP32[i2 + 16 >> 2] | 0) > (i8 | 0)) i13 = 51;
  if ((i13 | 0) == 51) i2 = i5;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
 } while (0);
 if ((i13 | 0) == 53) {
  i6 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63720 | 0, 16, gb + 896837 | 0, 317) | 0;
  __ZN8TypeTreeC2ERK10MemLabelId(i6, gb + 63720 | 0);
  __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i1, i6, 0);
  if (i9) i3 = i6; else {
   i2 = HEAP32[i5 >> 2] | 0;
   do if (!i2) {
    HEAP32[i10 >> 2] = i5;
    i3 = i5;
    i4 = i5;
    i13 = 64;
   } else {
    while (1) {
     i3 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i3 | 0) > (i8 | 0)) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i13 = 57;
       break;
      } else i2 = i3;
     } else {
      if ((i3 | 0) >= (i8 | 0)) {
       i13 = 63;
       break;
      }
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i13 = 61;
       break;
      } else i2 = i3;
     }
    }
    if ((i13 | 0) == 57) {
     HEAP32[i10 >> 2] = i2;
     i3 = i2;
     i4 = i2;
     i13 = 64;
     break;
    } else if ((i13 | 0) == 61) {
     HEAP32[i10 >> 2] = i2;
     i3 = i2;
     i13 = 64;
     break;
    } else if ((i13 | 0) == 63) {
     HEAP32[i10 >> 2] = i2;
     if (!i2) {
      i3 = i2;
      i4 = i10;
      i13 = 64;
      break;
     } else break;
    }
   } while (0);
   if ((i13 | 0) == 64) {
    i2 = __Znwj(24) | 0;
    HEAP32[i2 + 16 >> 2] = i8;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    if (!i3) i3 = i2; else {
     HEAP32[i7 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i3);
    i13 = i7 + 8 | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   }
   HEAP32[i2 + 20 >> 2] = i6;
   i3 = i6;
  }
 }
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = 0;
 __Z31FindAttributeInTypeTreeNoArraysRK16TypeTreeIteratorPKc(i10, i11, i12);
 if (HEAP32[i10 >> 2] | 0) if ((__ZNK16TypeTreeIterator10ByteOffsetEv(i10) | 0) != -1) {
  i13 = __Z21GetAnimatableBindTypeRK16TypeTreeIterator(i10) | 0;
  HEAP32[i15 >> 2] = i13;
  if (i13 | 0) {
   i2 = __ZNK16TypeTreeIterator10ByteOffsetEv(i10) | 0;
   if ((i2 | 0) < 0) i1 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i14 >> 2] = i1 + (i2 & 2147483647);
  }
 }
 if (i9) {
  if (i3 | 0) {
   i1 = i3 + 40 | 0;
   if ((HEAP32[i3 + 56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
    HEAP32[i1 >> 2] = 0;
   }
   if ((HEAP32[i3 + 36 >> 2] | 0) > -1) {
    i14 = i3 + 20 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i3 + 24 | 0);
    HEAP32[i14 >> 2] = 0;
   }
   if ((HEAP32[i3 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
    HEAP32[i3 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63720 | 0);
 }
 i15 = (HEAP32[i15 >> 2] | 0) != 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN11AudioSource11PlayOneShotER9AudioClipf(i12, i8, f9) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i11 = i14 + 4 | 0;
 i13 = i14;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) {
  STACKTOP = i14;
  return;
 }
 if (!(HEAP8[i12 + 33 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 864287 | 0, 0, gb + 855390 | 0, 1826, 512, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i14;
  return;
 }
 __ZN11AudioSource16CreateFMODGroupsEv(i12);
 i5 = i12 + 440 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i11 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
    i4 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i6 = 12;
  }
  if ((i6 | 0) == 10) i6 = 12;
  if ((i6 | 0) == 12) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
  if (!i1) i6 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
    i2 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 21;
   }
  }
  if ((i6 | 0) == 19) i6 = 21;
  if ((i6 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i4 = HEAP32[i1 + 52 >> 2] | 0;
  if (i4 | 0) {
   HEAP32[i11 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 28; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i7 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 28; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 30;
    }
   }
   if ((i6 | 0) == 28) i6 = 30;
   if ((i6 | 0) == 30) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   __ZN10AudioMixer16ResumeProcessingEv(i1);
  }
 } while (0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 92 >> 2] | 0, i8 | 0) | 0)) __ZN10SampleClip13LoadAudioDataEv(i8) | 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63328 | 0, 16, gb + 855390 | 0, 1843) | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i5;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i2 = __ZN10SampleClip15AllocateChannelEby(i8, 1, 0, 0) | 0;
 i1 = i2;
 i3 = (i2 | 0) == 0;
 if (!i3) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 if (i4 | 0) {
  i15 = i4 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
  }
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 do if (i3) i2 = 0; else {
  i15 = i2 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) {
    i2 = 0;
    break;
   }
  }
  if (HEAP32[i2 + 16 >> 2] | 0) {
   i1 = i8 + 120 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = (HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0) + 244 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   HEAPF32[i1 + 220 >> 2] = f9;
   __ZN20SoundChannelInstance12UpdateVolumeEv(i1);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   __ZN20SoundChannelInstance7SetLoopEb(i1, 0) | 0;
   HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0) + 240 >> 2] = i12;
   __ZN11AudioSource12ApplyFiltersEv(i12);
   i2 = i12 + 488 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
    __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE(i1, HEAP32[i2 >> 2] | 0) | 0;
   }
   __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   __ZN20SoundChannelInstance15set3DAttributesEPK11FMOD_VECTORS2_(i1, i11, 0) | 0;
   i1 = i12 + 428 | 0;
   if ((i5 | 0) != (i1 | 0)) {
    i2 = HEAP32[i5 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i2 + 4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[HEAP32[i6 >> 2] >> 2] = i2;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
    }
    i15 = HEAP32[i1 >> 2] | 0;
    HEAP32[i5 >> 2] = i15;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i15 + 4 >> 2] = i5;
    HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
   }
   __ZN11AudioSource11AssignPropsEv(i12);
   HEAP32[i13 >> 2] = 0;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i15 = i1 + 4 | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   }
   HEAP32[i13 >> 2] = i1;
   __ZN11AudioSource16UpdateParametersE12SoundChannel(i12, i13);
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   if (i1 | 0) {
    i15 = i1 + 4 | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    if (!(HEAP32[i15 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
    }
    HEAP32[i13 >> 2] = 0;
   }
   __ZN12AudioManager14AddAudioSourceEP11AudioSource(__Z15GetAudioManagerv() | 0, i12);
   HEAP8[i12 + 532 >> 0] = 0;
   __ZN11AudioSource16UpdatePauseStateEv(i12);
   STACKTOP = i14;
   return;
  }
 } while (0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 if (i2 | 0) {
  i15 = i2 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
  }
  HEAP32[i7 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63328 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu24computeMTD_CapsuleConvexERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES9_(i11, i10, i1, i2, i3, i4) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 464 | 0;
 i6 = i14 + 552 | 0;
 i17 = i14 + 536 | 0;
 i33 = i14 + 448 | 0;
 i38 = i14 + 224 | 0;
 i39 = i14 + 64 | 0;
 i8 = i14 + 240 | 0;
 i9 = i14 + 32 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i7 = i14 + 80 | 0;
 f30 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i1 >> 2]));
 f20 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f28 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f28 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f20 * f20)) + Math_fround(f28 * f28)))) * Math_fround(.5));
 i18 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i33 + 4 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 HEAP32[i33 + 12 >> 2] = 0;
 i37 = (HEAP32[i3 + 32 >> 2] | 0) + 16 | 0;
 i16 = i3 + 4 | 0;
 i15 = i3 + 8 | 0;
 i40 = HEAP32[i15 >> 2] | 0;
 i1 = i3 + 12 | 0;
 i41 = HEAP32[i1 >> 2] | 0;
 HEAP32[i38 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i38 + 4 >> 2] = i40;
 HEAP32[i38 + 8 >> 2] = i41;
 HEAPF32[i38 + 12 >> 2] = Math_fround(0.0);
 i41 = i3 + 16 | 0;
 i40 = HEAP32[i41 + 4 >> 2] | 0;
 i3 = HEAP32[i41 + 8 >> 2] | 0;
 i36 = HEAP32[i41 + 12 >> 2] | 0;
 HEAP32[i39 >> 2] = HEAP32[i41 >> 2];
 HEAP32[i39 + 4 >> 2] = i40;
 HEAP32[i39 + 8 >> 2] = i3;
 HEAP32[i39 + 12 >> 2] = i36;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i8, i37, i33, i38, i39);
 f20 = Math_fround(HEAPF32[i2 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i39 = i2 + 16 | 0;
 f23 = Math_fround(HEAPF32[i39 >> 2]);
 f27 = Math_fround(HEAPF32[i39 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i39 + 8 >> 2]);
 i39 = HEAP32[i4 >> 2] | 0;
 i38 = HEAP32[i4 + 4 >> 2] | 0;
 i37 = HEAP32[i4 + 8 >> 2] | 0;
 i36 = HEAP32[i4 + 12 >> 2] | 0;
 i4 = i4 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = i39;
 HEAP32[i9 + 4 >> 2] = i38;
 HEAP32[i9 + 8 >> 2] = i37;
 HEAP32[i9 + 12 >> 2] = i36;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = i3;
 HEAP32[i9 + 24 >> 2] = i4;
 HEAPF32[i9 + 28 >> 2] = Math_fround(0.0);
 f35 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f35 = Math_fround(-f35);
 f19 = Math_fround(-f19);
 f32 = Math_fround(-f32);
 f29 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f23 - f29);
 f21 = Math_fround(f27 - f21);
 f25 = Math_fround(f25 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f27 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f23 = Math_fround(Math_fround(Math_fround(f29 * f35) + Math_fround(f21 * f19)) + Math_fround(f25 * f32));
 f22 = Math_fround(Math_fround(Math_fround(f23 * f35) + Math_fround(Math_fround(f27 * f29) + Math_fround(f34 * Math_fround(Math_fround(f25 * f19) - Math_fround(f21 * f32))))) * Math_fround(2.0));
 f24 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(Math_fround(f27 * f21) + Math_fround(f34 * Math_fround(Math_fround(f29 * f32) - Math_fround(f25 * f35))))) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(f34 * Math_fround(Math_fround(f21 * f35) - Math_fround(f29 * f19)))) + Math_fround(f23 * f32)) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(f31 * f34) - Math_fround(Math_fround(Math_fround(f20 * f35) + Math_fround(f30 * f19)) + Math_fround(f26 * f32)));
 f21 = Math_fround(Math_fround(Math_fround(f26 * f19) - Math_fround(f30 * f32)) + Math_fround(Math_fround(f31 * f35) + Math_fround(f20 * f34)));
 f25 = Math_fround(Math_fround(Math_fround(f20 * f32) - Math_fround(f26 * f35)) + Math_fround(Math_fround(f31 * f19) + Math_fround(f30 * f34)));
 f34 = Math_fround(Math_fround(Math_fround(f30 * f35) - Math_fround(f20 * f19)) + Math_fround(Math_fround(f31 * f32) + Math_fround(f26 * f34)));
 f26 = Math_fround(f21 + f21);
 f32 = Math_fround(f25 + f25);
 f31 = Math_fround(f34 + f34);
 f19 = Math_fround(f25 * f32);
 f20 = Math_fround(f34 * f31);
 f25 = Math_fround(f25 * f26);
 f35 = Math_fround(f34 * f26);
 f30 = Math_fround(f29 * f26);
 f34 = Math_fround(f34 * f32);
 f32 = Math_fround(f29 * f32);
 f31 = Math_fround(f29 * f31);
 f26 = Math_fround(Math_fround(1.0) - Math_fround(f21 * f26));
 f21 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f20);
 f29 = Math_fround(f25 + f31);
 f27 = Math_fround(f35 - f32);
 f31 = Math_fround(f25 - f31);
 f20 = Math_fround(f26 - f20);
 f25 = Math_fround(f34 + f30);
 f32 = Math_fround(f35 + f32);
 f30 = Math_fround(f34 - f30);
 f19 = Math_fround(f26 - f19);
 HEAP32[i12 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 f26 = Math_fround(f28 * Math_fround(0.0));
 f21 = Math_fround(Math_fround(f26 * f32) + Math_fround(Math_fround(f26 * f31) + Math_fround(f28 * f21)));
 f20 = Math_fround(Math_fround(f26 * f30) + Math_fround(Math_fround(f28 * f29) + Math_fround(f26 * f20)));
 f19 = Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f26 * f25)) + Math_fround(f26 * f19));
 i4 = i7 + 64 | 0;
 HEAPF32[i7 >> 2] = f22;
 HEAPF32[i7 + 4 >> 2] = f24;
 HEAPF32[i7 + 8 >> 2] = f23;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 80 >> 2] = 4;
 HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 128 >> 2] = i18;
 i3 = i7 + 132 | 0;
 HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 f26 = Math_fround(f24 + f20);
 f25 = Math_fround(f23 + f19);
 HEAPF32[i7 + 96 >> 2] = Math_fround(f22 + f21);
 HEAPF32[i7 + 100 >> 2] = f26;
 HEAPF32[i7 + 104 >> 2] = f25;
 HEAPF32[i7 + 108 >> 2] = Math_fround(0.0);
 f20 = Math_fround(f24 - f20);
 f19 = Math_fround(f23 - f19);
 HEAPF32[i7 + 112 >> 2] = Math_fround(f22 - f21);
 HEAPF32[i7 + 116 >> 2] = f20;
 HEAPF32[i7 + 120 >> 2] = f19;
 HEAPF32[i7 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 16 >> 2] = i18;
 i3 = i7 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i7 + 32 >> 2] = i18;
 i3 = i7 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = -1;
 HEAP32[i5 + 8 >> 2] = -1;
 HEAP32[i5 + 12 >> 2] = -1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = Math_fround(HEAPF32[i16 >> 2]) == Math_fround(1.0);
 if (i4 & Math_fround(HEAPF32[i15 >> 2]) == Math_fround(1.0)) i1 = Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0); else i1 = 0;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i8, i1, i5);
 HEAP32[i6 + 32 >> 2] = i9;
 HEAP32[i6 + 36 >> 2] = i8 + 96;
 HEAP32[i6 + 40 >> 2] = i8 + 144;
 HEAP8[i6 + 44 >> 0] = i1 & 1;
 HEAP32[i6 >> 2] = i1 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i6 + 48 >> 2] = i8;
 i1 = __ZN5physx2Gu10computeMTDERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos6FloatVERNS9_5Vec3VE(i7, i5, i6, i13, i12) | 0;
 if (!i1) {
  STACKTOP = i14;
  return i1 | 0;
 }
 f35 = Math_fround(HEAPF32[i13 >> 2]);
 i40 = f35 > Math_fround(0.0);
 HEAPF32[i10 >> 2] = i40 ? f35 : Math_fround(0.0);
 i40 = HEAP32[i12 + 4 >> 2] | 0;
 i41 = HEAP32[i12 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = i40;
 HEAP32[i11 + 8 >> 2] = i41;
 STACKTOP = i14;
 return i1 | 0;
}

function __Z16RandomUnitVectorR5RandN(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0;
 i29 = HEAP32[i2 >> 2] | 0;
 i59 = i2 + 4 | 0;
 i28 = HEAP32[i59 >> 2] | 0;
 i57 = i2 + 8 | 0;
 i27 = HEAP32[i57 >> 2] | 0;
 i55 = i2 + 12 | 0;
 i34 = HEAP32[i55 >> 2] | 0;
 i29 = i29 << 11 ^ i29;
 i28 = i28 << 11 ^ i28;
 i27 = i27 << 11 ^ i27;
 i34 = i34 << 11 ^ i34;
 i53 = i2 + 16 | 0;
 i42 = HEAP32[i53 >> 2] | 0;
 i51 = i2 + 20 | 0;
 i40 = HEAP32[i51 >> 2] | 0;
 i49 = i2 + 24 | 0;
 i38 = HEAP32[i49 >> 2] | 0;
 i47 = i2 + 28 | 0;
 i36 = HEAP32[i47 >> 2] | 0;
 i46 = i2 + 32 | 0;
 i45 = i2 + 36 | 0;
 i60 = HEAP32[i45 >> 2] | 0;
 i44 = i2 + 40 | 0;
 i58 = HEAP32[i44 >> 2] | 0;
 i43 = i2 + 44 | 0;
 i56 = HEAP32[i43 >> 2] | 0;
 i33 = i2 + 48 | 0;
 i54 = HEAP32[i33 >> 2] | 0;
 i32 = i2 + 52 | 0;
 i52 = HEAP32[i32 >> 2] | 0;
 i31 = i2 + 56 | 0;
 i50 = HEAP32[i31 >> 2] | 0;
 i30 = i2 + 60 | 0;
 i48 = HEAP32[i30 >> 2] | 0;
 i29 = i29 >>> 8 ^ i29 ^ i54;
 i41 = i29 ^ i54 >>> 19;
 i28 = i28 >>> 8 ^ i28 ^ i52;
 i39 = i28 ^ i52 >>> 19;
 i27 = i27 >>> 8 ^ i27 ^ i50;
 i37 = i27 ^ i50 >>> 19;
 i34 = i34 >>> 8 ^ i34 ^ i48;
 i35 = i34 ^ i48 >>> 19;
 f6 = Math_fround(Math_fround(i41 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(i39 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(i37 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround(i35 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(Math_fround(1.0) - f6) - f6);
 f5 = Math_fround(Math_fround(Math_fround(1.0) - f5) - f5);
 f4 = Math_fround(Math_fround(Math_fround(1.0) - f4) - f4);
 f3 = Math_fround(Math_fround(Math_fround(1.0) - f3) - f3);
 i42 = i42 << 11 ^ i42;
 i40 = i40 << 11 ^ i40;
 i38 = i38 << 11 ^ i38;
 i36 = i36 << 11 ^ i36;
 HEAP32[i2 >> 2] = HEAP32[i46 >> 2];
 HEAP32[i59 >> 2] = i60;
 HEAP32[i57 >> 2] = i58;
 HEAP32[i55 >> 2] = i56;
 HEAP32[i53 >> 2] = i54;
 HEAP32[i51 >> 2] = i52;
 HEAP32[i49 >> 2] = i50;
 HEAP32[i47 >> 2] = i48;
 HEAP32[i46 >> 2] = i41;
 HEAP32[i45 >> 2] = i39;
 HEAP32[i44 >> 2] = i37;
 HEAP32[i43 >> 2] = i35;
 i29 = i42 >>> 8 ^ i42 ^ i41 ^ i29 >>> 19;
 i28 = i40 >>> 8 ^ i40 ^ i39 ^ i28 >>> 19;
 i27 = i38 >>> 8 ^ i38 ^ i37 ^ i27 >>> 19;
 i2 = i36 >>> 8 ^ i36 ^ i35 ^ i34 >>> 19;
 HEAP32[i33 >> 2] = i29;
 HEAP32[i32 >> 2] = i28;
 HEAP32[i31 >> 2] = i27;
 HEAP32[i30 >> 2] = i2;
 f8 = Math_fround(Math_fround(i29 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(i28 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f10 = Math_fround(Math_fround(i27 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f17 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f6 * f6))));
 f24 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f5 * f5))));
 f21 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f4 * f4))));
 f18 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f3 * f3))));
 f8 = Math_fround(Math_fround(Math_fround(f8 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f8) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f9 = Math_fround(Math_fround(Math_fround(f9 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f9) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f10 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f10) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f17 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f17) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f16 = Math_fround(+_roundf(+f8));
 f22 = Math_fround(+_roundf(+f9));
 f7 = Math_fround(+_roundf(+f10));
 f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f8 - f16))));
 f22 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f9 - f22))));
 f7 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f10 - f7))));
 f23 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f17 - Math_fround(+_roundf(+f17))))));
 f14 = Math_fround(f16 * f16);
 f13 = Math_fround(f22 * f22);
 f12 = Math_fround(f7 * f7);
 f11 = Math_fround(f23 * f23);
 f19 = Math_fround(f14 * f14);
 f25 = Math_fround(f13 * f13);
 f20 = Math_fround(f12 * f12);
 f26 = Math_fround(f11 * f11);
 f14 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f19 * f19) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f14 * Math_fround(41.3416595))) + Math_fround(f19 * Math_fround(Math_fround(81.6018218) - Math_fround(f14 * Math_fround(76.5686187)))))));
 f13 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f13 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f13 * Math_fround(76.5686187)))))));
 f12 = Math_fround(f7 * Math_fround(Math_fround(Math_fround(f20 * f20) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f12 * Math_fround(41.3416595))) + Math_fround(f20 * Math_fround(Math_fround(81.6018218) - Math_fround(f12 * Math_fround(76.5686187)))))));
 f11 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f26 * f26) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f11 * Math_fround(41.3416595))) + Math_fround(f26 * Math_fround(Math_fround(81.6018218) - Math_fround(f11 * Math_fround(76.5686187)))))));
 f8 = Math_fround(f8 + Math_fround(-.25));
 f9 = Math_fround(f9 + Math_fround(-.25));
 f10 = Math_fround(f10 + Math_fround(-.25));
 f17 = Math_fround(f17 + Math_fround(-.25));
 f26 = Math_fround(+_roundf(+f8));
 f23 = Math_fround(+_roundf(+f9));
 f20 = Math_fround(+_roundf(+f10));
 f26 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f8 - f26))));
 f23 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f9 - f23))));
 f20 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f10 - f20))));
 f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f17 - Math_fround(+_roundf(+f17))))));
 f10 = Math_fround(f26 * f26);
 f9 = Math_fround(f23 * f23);
 f8 = Math_fround(f20 * f20);
 f7 = Math_fround(f17 * f17);
 f25 = Math_fround(f10 * f10);
 f22 = Math_fround(f9 * f9);
 f19 = Math_fround(f8 * f8);
 f16 = Math_fround(f7 * f7);
 f13 = Math_fround(f24 * f13);
 f12 = Math_fround(f21 * f12);
 f11 = Math_fround(f18 * f11);
 f10 = Math_fround(f15 * Math_fround(f26 * Math_fround(Math_fround(Math_fround(f25 * f25) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f10 * Math_fround(41.3416595))) + Math_fround(f25 * Math_fround(Math_fround(81.6018218) - Math_fround(f10 * Math_fround(76.5686187))))))));
 f9 = Math_fround(f24 * Math_fround(f23 * Math_fround(Math_fround(Math_fround(f22 * f22) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f9 * Math_fround(41.3416595))) + Math_fround(f22 * Math_fround(Math_fround(81.6018218) - Math_fround(f9 * Math_fround(76.5686187))))))));
 f8 = Math_fround(f21 * Math_fround(f20 * Math_fround(Math_fround(Math_fround(f19 * f19) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f8 * Math_fround(41.3416595))) + Math_fround(f19 * Math_fround(Math_fround(81.6018218) - Math_fround(f8 * Math_fround(76.5686187))))))));
 f7 = Math_fround(f18 * Math_fround(f17 * Math_fround(Math_fround(Math_fround(f16 * f16) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f16 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187))))))));
 HEAPF32[i1 >> 2] = Math_fround(f15 * f14);
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = f11;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 28 >> 2] = f7;
 HEAPF32[i1 + 32 >> 2] = f6;
 HEAPF32[i1 + 36 >> 2] = f5;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAPF32[i1 + 44 >> 2] = f3;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap11batchUpdateEjRPNS_17PxcBroadPhasePairERjS4_(i35, i30, i31, i34, i33) {
 i35 = i35 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i34 = i34 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i39 + 25 | 0;
 i29 = i39 + 24 | 0;
 i2 = i39;
 i4 = i35 + 96 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i39;
  return;
 }
 if ((i1 * 5 | 0) >>> 0 < (HEAP32[i35 + 168 >> 2] | 0) >>> 0) {
  __ZN5physx23PxsBroadPhaseContextSap21batchUpdateFewUpdatesEjRPNS_17PxcBroadPhasePairERjS4_(i35, i30, i31, i34, i33);
  STACKTOP = i39;
  return;
 }
 i3 = HEAP32[i33 >> 2] | 0;
 i26 = HEAP32[i35 + 100 >> 2] | 0;
 i23 = HEAP32[i35 + 116 >> 2] | 0;
 HEAP32[i2 >> 2] = i23;
 i27 = HEAP32[i35 + 120 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i27;
 HEAP32[i2 + 8 >> 2] = i27;
 i27 = HEAP32[i35 + 112 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = i27;
 HEAP32[i2 + 16 >> 2] = i27;
 HEAP32[i2 + 20 >> 2] = i23;
 i23 = i30 << 1;
 i27 = HEAP32[i2 + (i23 << 2) >> 2] | 0;
 i23 = HEAP32[i2 + ((i23 | 1) << 2) >> 2] | 0;
 i24 = HEAP32[i35 + 104 >> 2] | 0;
 i36 = HEAP32[i35 + 112 + (i30 << 2) >> 2] | 0;
 i37 = HEAP32[i35 + 124 + (i30 << 2) >> 2] | 0;
 i38 = HEAP32[i35 + 136 + (i30 << 2) >> 2] | 0;
 i25 = HEAP32[i35 + 148 >> 2] | 0;
 i1 = HEAP32[i38 + 4 >> 2] | 0;
 if ((i1 & -2 | 0) == 1073741822) {
  STACKTOP = i39;
  return;
 }
 i7 = i1 >>> 1;
 HEAP32[i37 + 4 >> 2] = HEAP32[i26 + (i7 * 24 | 0) + (i30 << 2) >> 2];
 i5 = HEAP32[i4 >> 2] | 0;
 i7 = i25 + i7 | 0;
 i6 = HEAP8[i7 >> 0] | 0;
 i19 = i35 + 156 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i38 + 8 >> 2] | 0;
 L11 : do if ((i1 & -2 | 0) == 1073741822) {
  i2 = i4;
  i12 = i4;
  i1 = 0;
 } else {
  i20 = i35 + 164 | 0;
  i21 = i30 + 3 | 0;
  i22 = i35 + 160 | 0;
  i2 = i4;
  i8 = i1;
  i18 = 2;
  i1 = 0;
  i6 = (i5 << 1) - (i6 & 255) | 0;
  i7 = HEAP8[i7 >> 0] | 0;
  while (1) {
   i17 = i8 >>> 1;
   i5 = HEAP8[i25 + i17 >> 0] | 0;
   if (!((i5 | i7) << 24 >> 24)) if (!i6) {
    i12 = i4;
    break L11;
   } else i5 = i7; else {
    i6 = i6 - (i5 & 255) | 0;
    i8 = i8 & 1;
    i16 = HEAP32[i26 + (i17 * 24 | 0) + ((0 - i8 & 3) + i30 << 2) >> 2] | 0;
    HEAP32[i37 + (i18 << 2) >> 2] = i16;
    i7 = HEAP32[i20 >> 2] | 0;
    i9 = HEAP32[i7 + (i18 << 2) >> 2] | 0;
    if ((HEAP32[i37 + (i9 << 2) >> 2] | 0) >>> 0 > i16 >>> 0) {
     i10 = HEAP32[i26 + (i17 * 24 | 0) + (i21 << 2) >> 2] | 0;
     i11 = HEAP32[i24 + (i17 << 2) >> 2] | 0;
     i12 = i27 + (i17 << 3) | 0;
     i13 = i27 + (i17 << 3) + 4 | 0;
     i14 = i23 + (i17 << 3) | 0;
     i15 = i23 + (i17 << 3) + 4 | 0;
     if (!i8) {
      i2 = i9;
      i5 = i18;
      do {
       i8 = HEAP32[i38 + (i2 << 2) >> 2] | 0;
       if (i8 & 1) {
        i9 = i8 >>> 1;
        if ((HEAP32[i37 + (HEAP32[i36 + (i9 << 3) >> 2] << 2) >> 2] | 0) >>> 0 < i10 >>> 0) if (((HEAP32[i13 >> 2] | 0) >>> 0 > (HEAP32[i27 + (i9 << 3) >> 2] | 0) >>> 0 ? (HEAP32[i27 + (i9 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0 : 0) & (HEAP32[i15 >> 2] | 0) >>> 0 > (HEAP32[i23 + (i9 << 3) >> 2] | 0) >>> 0 & (HEAP32[i23 + (i9 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i14 >> 2] | 0) >>> 0) if ((i11 | 0) != (HEAP32[i24 + (i9 << 2) >> 2] | 0)) {
         if ((i1 | 0) == (i3 | 0)) {
          i7 = HEAP32[i31 >> 2] | 0;
          i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i28, i3 << 4, gb + 716671 | 0, 1486) | 0;
          _memcpy(i8 | 0, i7 | 0, i3 << 3 | 0) | 0;
          __ZN5physx6shdfnd9Allocator10deallocateEPv(i29, i7);
          HEAP32[i31 >> 2] = i8;
          i7 = HEAP32[i20 >> 2] | 0;
          i3 = i3 << 1;
         } else i8 = HEAP32[i31 >> 2] | 0;
         i40 = i17 >>> 0 < i9 >>> 0;
         HEAP32[i8 + (i1 << 3) >> 2] = i40 ? i9 : i17;
         HEAP32[i8 + (i1 << 3) + 4 >> 2] = i40 ? i17 : i9;
         i1 = i1 + 1 | 0;
        }
       }
       i5 = i5 + -1 | 0;
       i2 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
      } while (i16 >>> 0 < (HEAP32[i37 + (i2 << 2) >> 2] | 0) >>> 0);
     } else {
      i8 = i7;
      i2 = i9;
      i5 = i18;
      while (1) {
       i7 = HEAP32[i38 + (i2 << 2) >> 2] | 0;
       if (!(i7 & 1)) {
        i9 = i7 >>> 1;
        if (((HEAP32[i13 >> 2] | 0) >>> 0 > (HEAP32[i27 + (i9 << 3) >> 2] | 0) >>> 0 ? (HEAP32[i27 + (i9 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0 : 0) & (HEAP32[i15 >> 2] | 0) >>> 0 > (HEAP32[i23 + (i9 << 3) >> 2] | 0) >>> 0 & (HEAP32[i23 + (i9 << 3) + 4 >> 2] | 0) >>> 0 > (HEAP32[i14 >> 2] | 0) >>> 0) if ((i11 | 0) == (HEAP32[i24 + (i9 << 2) >> 2] | 0)) i7 = i8; else {
         if ((i1 | 0) == (i3 | 0)) {
          i7 = HEAP32[i31 >> 2] | 0;
          i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i28, i3 << 4, gb + 716671 | 0, 1486) | 0;
          _memcpy(i8 | 0, i7 | 0, i3 << 3 | 0) | 0;
          __ZN5physx6shdfnd9Allocator10deallocateEPv(i29, i7);
          HEAP32[i31 >> 2] = i8;
          i7 = HEAP32[i20 >> 2] | 0;
          i3 = i3 << 1;
         } else {
          i7 = i8;
          i8 = HEAP32[i31 >> 2] | 0;
         }
         i40 = i17 >>> 0 < i9 >>> 0;
         HEAP32[i8 + (i1 << 3) >> 2] = i40 ? i17 : i9;
         HEAP32[i8 + (i1 << 3) + 4 >> 2] = i40 ? i9 : i17;
         i1 = i1 + 1 | 0;
        } else i7 = i8;
       } else i7 = i8;
       i5 = i5 + -1 | 0;
       i2 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
       if (i16 >>> 0 < (HEAP32[i37 + (i2 << 2) >> 2] | 0) >>> 0) i8 = i7; else break;
      }
     }
     i12 = HEAP32[i22 >> 2] | 0;
     i15 = i12 + (i18 << 2) | 0;
     i14 = HEAP32[i15 >> 2] | 0;
     i16 = i7 + (i18 << 2) | 0;
     i13 = HEAP32[i16 >> 2] | 0;
     i40 = i12 + (i2 << 2) | 0;
     i17 = HEAP32[i40 >> 2] | 0;
     HEAP32[i12 + (i13 << 2) >> 2] = i14;
     HEAP32[i7 + (i14 << 2) >> 2] = i13;
     HEAP32[i15 >> 2] = i17;
     HEAP32[i16 >> 2] = i2;
     HEAP32[i7 + (i17 << 2) >> 2] = i18;
     HEAP32[i40 >> 2] = i18;
     i2 = i4;
     while (1) if (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i2 = i2 + -8 | 0; else {
      i4 = i2;
      break;
     }
     i2 = HEAP32[i19 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i32 = 31; else if (i5 >>> 0 > ((HEAP32[i4 + 4 >> 2] | 0) + 1 | 0) >>> 0) i32 = 31;
     if ((i32 | 0) == 31) {
      i32 = 0;
      i4 = i4 + 8 | 0;
      HEAP32[i4 >> 2] = i5;
     }
     HEAP32[i4 + 4 >> 2] = i18;
     i5 = 1;
    }
   }
   i18 = i18 + 1 | 0;
   i8 = HEAP32[i38 + (i18 << 2) >> 2] | 0;
   if ((i8 & -2 | 0) == 1073741822) {
    i12 = i4;
    break;
   } else i7 = i5;
  }
 } while (0);
 HEAP32[i34 >> 2] = i1;
 HEAP32[i33 >> 2] = i3;
 i1 = i2 + 8 | 0;
 i11 = i35 + 164 | 0;
 if (i1 >>> 0 <= i12 >>> 0) {
  i10 = i35 + 160 | 0;
  i9 = i1;
  while (1) {
   i7 = i2 + 8 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i8 = i2 + 12 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i3 >>> 0 > i1 >>> 0) i2 = i3; else {
    i4 = HEAP32[i11 >> 2] | 0;
    i2 = i3;
    do {
     HEAP32[i4 + (i2 << 2) >> 2] = i2;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    } while (i2 >>> 0 <= i1 >>> 0);
    i2 = HEAP32[i7 >> 2] | 0;
   }
   if (i2 >>> 0 <= i1 >>> 0) {
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    i4 = i2 + -1 | 0;
    do {
     i4 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
     i3 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
     if ((i4 | 0) != (i2 | 0)) {
      i40 = i38 + (i3 << 2) | 0;
      i1 = HEAP32[i40 >> 2] | 0;
      i31 = i37 + (i2 << 2) | 0;
      i33 = HEAP32[i31 >> 2] | 0;
      i32 = i38 + (i2 << 2) | 0;
      i35 = HEAP32[i32 >> 2] | 0;
      i34 = i37 + (i3 << 2) | 0;
      HEAP32[i31 >> 2] = HEAP32[i34 >> 2];
      HEAP32[i32 >> 2] = HEAP32[i40 >> 2];
      HEAP32[i34 >> 2] = i33;
      HEAP32[i40 >> 2] = i35;
      i40 = i6 + (i2 << 2) | 0;
      HEAP32[i6 + (i3 << 2) >> 2] = HEAP32[i40 >> 2];
      HEAP32[i6 + (HEAP32[i40 >> 2] << 2) >> 2] = i3;
      HEAP32[i36 + (i1 >>> 1 << 3) + ((i1 & 1) << 2) >> 2] = i2;
      i1 = HEAP32[i8 >> 2] | 0;
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 <= i1 >>> 0);
    i2 = HEAP32[i7 >> 2] | 0;
   }
   i2 = i2 + -1 | 0;
   if (i2 >>> 0 <= i1 >>> 0) {
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i1 = i2;
    do {
     i40 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i3 + (i1 << 2) >> 2] = i40;
     HEAP32[i4 + (i40 << 2) >> 2] = i1;
    } while (i1 >>> 0 <= (HEAP32[i8 >> 2] | 0) >>> 0);
   }
   i1 = i9 + 8 | 0;
   if (i1 >>> 0 > i12 >>> 0) break; else {
    i2 = i9;
    i9 = i1;
   }
  }
 }
 HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
 STACKTOP = i39;
 return;
}

function __ZN22BaseUnityConnectClient20LookForVersionChangeEb(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 592 | 0;
 i17 = i19 + 64 | 0;
 i18 = i19;
 i11 = i19 + 576 | 0;
 i12 = i19 + 560 | 0;
 __ZN11UnityEngine7Connect15DeviceInfoEventC2Ev(i17);
 i15 = i13 + 660 | 0;
 i10 = HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] | 0;
 i1 = __ZN11UnityEngine7Connect17DeviceInfoUpdater17LookForAppChangesERNS0_15DeviceInfoEventEj(i13 + 296 | 0, i17, i10) | 0;
 if ((i10 | 0) == (i1 | 0)) {
  __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i17);
  STACKTOP = i19;
  return;
 }
 HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] = i1;
 if (i14) {
  __ZN11UnityEngine7Connect14AppUpdateEventC2Ev(i18);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 + 12 >> 2] = i1;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = -2147483632;
  i2 = i11 + 4 | 0;
  HEAP32[i2 >> 2] = 13;
  i3 = i1;
  i4 = gb + 1040146 | 0;
  i5 = i3 + 13 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP8[i1 + 13 >> 0] = 0;
  i1 = (HEAP32[i15 >> 2] | 0) + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i10 = i11 + 11 | 0;
  do if (!(__Z6StrCmpPKcS0_(i1, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11) | 0)) i2 = 0; else {
   i4 = i18 + 32 | 0;
   i5 = HEAP8[i10 >> 0] | 0;
   i6 = i5 << 24 >> 24 < 0;
   i7 = i6 ? HEAP32[i11 >> 2] | 0 : i11;
   i5 = i6 ? HEAP32[i2 >> 2] | 0 : i5 & 255;
   i6 = i4 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i18 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i2 = i2 ? HEAP32[i18 + 36 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i3, i5 - i3 | 0, i2, 0, i2, i5, i7);
    i2 = 1;
    break;
   }
   i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
   if (i5 | 0) _memmove(i1 | 0, i7 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i18 + 36 >> 2] = i5;
    i2 = 1;
    break;
   } else {
    HEAP8[i6 >> 0] = i5;
    i2 = 1;
    break;
   }
  } while (0);
  __ZN15ApplicationInfo10GetVersionEv(i12, __Z18GetApplicationInfov() | 0);
  i1 = (HEAP32[i15 >> 2] | 0) + 36 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i8 = i12 + 11 | 0;
  do if (!(__Z6StrCmpPKcS0_(i1, (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12) | 0)) if (!(i2 << 24 >> 24)) i2 = 0; else i9 = 30; else {
   i1 = i18 + 48 | 0;
   i6 = HEAP8[i8 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i5 = i7 ? HEAP32[i12 >> 2] | 0 : i12;
   i6 = i7 ? HEAP32[i12 + 4 >> 2] | 0 : i6 & 255;
   i7 = i1 + 11 | 0;
   i2 = HEAP8[i7 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i4 = (HEAP32[i18 + 56 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i6 >>> 0 > i4 >>> 0) {
    i9 = i3 ? HEAP32[i18 + 52 >> 2] | 0 : i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i6 - i4 | 0, i9, 0, i9, i6, i5);
    i9 = 30;
    break;
   }
   i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i18 + 52 >> 2] = i6;
    i9 = 30;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    i9 = 30;
    break;
   }
  } while (0);
  if ((i9 | 0) == 30) {
   __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i13, i18, HEAP32[i13 + 12 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0, 1) | 0;
   i2 = 1;
  }
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   i9 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i16);
  }
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i12 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i16);
  }
  HEAP32[i18 >> 2] = gb + 188916 + 8;
  i1 = i18 + 48 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i18 + 60 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i16);
  }
  i1 = i18 + 32 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i18 + 44 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i16);
  }
  HEAP32[i18 >> 2] = gb + 190148 + 8;
  i1 = i18 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i18 + 16 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i16);
  }
  i1 = i2 << 24 >> 24 != 0;
 } else i1 = 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i13, i17, HEAP32[i13 + 12 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0, 1) | 0;
 if (!(i1 | i14 ^ 1)) {
  __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i17);
  STACKTOP = i19;
  return;
 }
 i9 = HEAP32[i15 >> 2] | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 HEAP32[i16 >> 2] = 66;
 HEAP32[i16 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i18 + 8 >> 2] = -2147483632;
 i2 = i18 + 4 | 0;
 HEAP32[i2 >> 2] = 13;
 i3 = i1;
 i4 = gb + 1040146 | 0;
 i5 = i3 + 13 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i1 + 13 >> 0] = 0;
 i1 = i9 + 20 | 0;
 i7 = i18 + 11 | 0;
 do if ((i1 | 0) != (i18 | 0)) {
  i6 = HEAP8[i7 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i8 = i4 ? HEAP32[i18 >> 2] | 0 : i18;
  i6 = i4 ? HEAP32[i2 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 28 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 24 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 24 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i14 = HEAP32[i18 >> 2] | 0;
  i13 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i14, i16);
 }
 i4 = HEAP32[i15 >> 2] | 0;
 __ZN15ApplicationInfo10GetVersionEv(i18, __Z18GetApplicationInfov() | 0);
 i1 = i4 + 36 | 0;
 i7 = i18 + 11 | 0;
 do if ((i1 | 0) != (i18 | 0)) {
  i9 = HEAP8[i7 >> 0] | 0;
  i5 = i9 << 24 >> 24 < 0;
  i8 = i5 ? HEAP32[i18 >> 2] | 0 : i18;
  i9 = i5 ? HEAP32[i18 + 4 >> 2] | 0 : i9 & 255;
  i5 = i1 + 11 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i6 = (HEAP32[i4 + 44 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i9 >>> 0 > i6 >>> 0) {
   if (i3) i2 = HEAP32[i4 + 40 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i6, i9 - i6 | 0, i2, 0, i2, i9, i8);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i9 | 0) _memmove(i1 | 0, i8 | 0, i9 | 0) | 0;
  HEAP8[i1 + i9 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i4 + 40 >> 2] = i9;
   break;
  } else {
   HEAP8[i5 >> 0] = i9;
   break;
  }
 } while (0);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i15 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
 }
 __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i17);
 STACKTOP = i19;
 return;
}

function __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 168 | 0, i7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 184 | 0, i7 + 1 | 0);
 i2 = i8 + 212 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 240 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 256 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 272 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 288 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 36 | 0;
 HEAP8[i3 >> 0] = 1;
 if (!i2) {
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i3 >> 0] = 0;
 i4 = i8 + 304 | 0;
 i5 = i7 + 9 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
 i5 = i8 + 320 | 0;
 i8 = i7 + 10 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
 i8 = i7 + 11 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags(i5, i10, i3) {
 i5 = i5 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 3232 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 24 | 0;
 i17 = i21;
 i20 = i21 + 2160 | 0;
 i19 = i21 + 1092 | 0;
 i18 = i21 + 32 | 0;
 i4 = i5 + 1040 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = i10 + 1040 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (i3 & 1) {
  mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i10 | 0, 1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i5 | 0) | 0) {
  HEAP32[i17 >> 2] = 0;
  i7 = i17 + 12 | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i17 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i17 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
  i13 = i15;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i16 = i9;
  HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i16 + 4 >> 2] = i14;
  HEAP32[i15 >> 2] = 0;
  i16 = HEAP32[i4 >> 2] | 0;
  mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 148 >> 2] | 0, i16 | 0, i5 | 0, i17 | 0, 0, i15 | 0, 0) | 0;
  i16 = HEAP32[i6 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 112 >> 2] | 0, i16 | 0, i10 | 0) | 0;
  L12 : do if (!(HEAP32[i7 >> 2] | 0)) i1 = 1; else {
   i4 = i20 + 1040 | 0;
   i5 = i19 + 11 | 0;
   i6 = i18 + 1040 | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   while (1) {
    HEAP8[i20 >> 0] = 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP32[i4 + 16 >> 2] = 0;
    __ZN15FileSystemEntry3SetEPKc(i20, i3);
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    HEAP32[i19 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, i10, _strlen(i10) | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i19, gb + 1087627 | 0) | 0;
    i1 = _strrchr(i20, 47) | 0;
    if (!i1) i1 = _strrchr(i20, 92) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i19, i1 | 0 ? i1 + 1 | 0 : i20) | 0;
    i2 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19;
    HEAP8[i18 >> 0] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    __ZN15FileSystemEntry3SetEPKc(i18, i2);
    i2 = __ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags(i20, i18, 1) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i18 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i20 | 0);
    i3 = i3 + 1088 | 0;
    if (!i2) {
     i1 = 0;
     break L12;
    }
    if ((i3 | 0) == ((HEAP32[i17 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 1088 | 0) | 0)) {
     i1 = 1;
     break;
    }
   }
  } while (0);
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i9);
   HEAP32[i17 >> 2] = 0;
  }
  i20 = i1;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (i3 & 4 | 0) {
  i16 = HEAP32[i4 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 156 >> 2] | 0, i16 | 0, i5 | 0) | 0) {
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) if ((HEAP32[i5 + 1044 >> 2] | 0) == (HEAP32[i10 + 1044 >> 2] | 0)) {
  i20 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0, i5 | 0, i10 | 0) | 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 __ZN12FileAccessorC2Ev(i20);
 __ZN12FileAccessorC2Ev(i19);
 i16 = i20 + 4 | 0;
 if ((i16 | 0) == (i5 | 0)) {
  i1 = i20 + 1056 | 0;
  i2 = i20 + 1048 | 0;
 } else {
  i2 = i20 + 1044 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i16 | 0);
  _strncpy(i16, i5, 1040) | 0;
  HEAP8[i20 + 1043 >> 0] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  i2 = i20 + 1048 | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + 1044 >> 2];
  HEAP32[i20 + 1052 >> 2] = 0;
  i1 = i20 + 1056 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i20 + 1060 >> 2] = 0;
  if (i3) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, i16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i13 = i20 + 1064 | 0;
 HEAP8[i13 >> 0] = 1;
 i12 = HEAP32[i2 >> 2] | 0;
 if (mftCall_iiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i16 | 0, 0, 0) | 0) {
  i12 = i19 + 4 | 0;
  if ((i12 | 0) == (i10 | 0)) {
   i1 = i19 + 1056 | 0;
   i2 = i19 + 1048 | 0;
  } else {
   i2 = i19 + 1044 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i12 | 0);
   _strncpy(i12, i10, 1040) | 0;
   HEAP8[i19 + 1043 >> 0] = 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 >> 2] = i3;
   i2 = i19 + 1048 | 0;
   HEAP32[i2 >> 2] = HEAP32[i10 + 1044 >> 2];
   HEAP32[i19 + 1052 >> 2] = 0;
   i1 = i19 + 1056 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i19 + 1060 >> 2] = 0;
   if (i3) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, i12 | 0);
  }
  HEAP32[i1 >> 2] = 0;
  i1 = i19 + 1064 | 0;
  HEAP8[i1 >> 0] = 1;
  i11 = HEAP32[i2 >> 2] | 0;
  if (mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i12 | 0, 1, 0) | 0) {
   i9 = i20 + 1048 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) {
    i3 = 0;
    i4 = 0;
   } else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i16 | 0) | 0;
    i3 = getTempRet0() | 0;
   }
   i11 = i3 >>> 0 < 0 | (i3 | 0) == 0 & i4 >>> 0 < 65536;
   i5 = i11 ? i4 : 65536;
   if (!i5) i2 = 1; else {
    i7 = gb + 64016 | 0;
    i11 = HEAP32[i7 + 4 >> 2] | 0;
    i10 = i17;
    HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    HEAP32[i18 >> 2] = 0;
    i10 = i18 + 16 | 0;
    i11 = i18 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i17);
    i7 = i15;
    i6 = HEAP32[i7 + 4 >> 2] | 0;
    i8 = i11;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = i6;
    HEAP32[i18 + 12 >> 2] = i5;
    HEAP32[i10 >> 2] = i5;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i5, 1, i11, 0, gb + 1047584 | 0, 464) | 0;
    i8 = i19 + 1048 | 0;
    i6 = 0;
    i7 = 0;
    while (1) {
     if ((i6 | 0) == (i4 | 0) & (i7 | 0) == (i3 | 0)) {
      i2 = 1;
      i14 = 36;
      break;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     if (!i2) {
      i2 = 0;
      i14 = 36;
      break;
     }
     if (!(mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i16 | 0, i5 | 0, 0, HEAP32[i18 >> 2] | 0, i15 | 0) | 0)) {
      i2 = 0;
      i14 = 36;
      break;
     }
     i2 = HEAP32[i8 >> 2] | 0;
     if (!i2) {
      i14 = 34;
      break;
     }
     i22 = i15;
     i2 = mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i12 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i22 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, i17 | 0) | 0;
     i22 = i17;
     i6 = _i64Add((i2 ? HEAP32[i22 >> 2] | 0 : 0) | 0, (i2 ? HEAP32[i22 + 4 >> 2] | 0 : 0) | 0, i6 | 0, i7 | 0) | 0;
     i7 = getTempRet0() | 0;
     if (!i2) {
      i2 = 0;
      break;
     }
    }
    do if ((i14 | 0) == 34) i2 = 0; else if ((i14 | 0) == 36) if (HEAP8[i1 >> 0] | 0) {
     i3 = HEAP32[i8 >> 2] | 0;
     if (!i3) {
      i2 = 0;
      break;
     }
     if (!(mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i12 | 0) | 0)) {
      i2 = 0;
      break;
     }
    } while (0);
    if ((HEAP32[i10 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i11);
     HEAP32[i18 >> 2] = 0;
    }
   }
  } else i2 = 0;
 } else {
  i2 = 0;
  i1 = i19 + 1064 | 0;
 }
 HEAP32[i19 >> 2] = gb + 70828 + 8;
 if (HEAP8[i1 >> 0] | 0) {
  i1 = HEAP32[i19 + 1048 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i19 + 4 | 0) | 0;
 }
 i1 = HEAP32[i19 + 1044 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i19 + 4 | 0);
 HEAP32[i20 >> 2] = gb + 70828 + 8;
 if (HEAP8[i13 >> 0] | 0) {
  i1 = HEAP32[i20 + 1048 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i16 | 0) | 0;
 }
 i1 = HEAP32[i20 + 1044 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i16 | 0);
 i22 = i2;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZN11b2WeldJoint23InitVelocityConstraintsERK12b2SolverData(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i25;
 i31 = HEAP32[i8 + 48 >> 2] | 0;
 i21 = HEAP32[i31 + 8 >> 2] | 0;
 i23 = i8 + 116 | 0;
 HEAP32[i23 >> 2] = i21;
 i1 = HEAP32[i8 + 52 >> 2] | 0;
 i34 = HEAP32[i1 + 8 >> 2] | 0;
 i15 = i8 + 120 | 0;
 HEAP32[i15 >> 2] = i34;
 i24 = i31 + 28 | 0;
 i7 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 i10 = i8 + 140 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i10 + 4 >> 2] = i24;
 i10 = i1 + 28 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i33 = i8 + 148 | 0;
 HEAP32[i33 >> 2] = i6;
 HEAP32[i33 + 4 >> 2] = i10;
 i33 = HEAP32[i31 + 120 >> 2] | 0;
 HEAP32[i8 + 156 >> 2] = i33;
 i32 = HEAP32[i1 + 120 >> 2] | 0;
 HEAP32[i8 + 160 >> 2] = i32;
 i31 = HEAP32[i31 + 128 >> 2] | 0;
 HEAP32[i8 + 164 >> 2] = i31;
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 HEAP32[i8 + 168 >> 2] = i1;
 i20 = HEAP32[i9 + 24 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i20 + (i21 * 12 | 0) + 8 >> 2]);
 i16 = i9 + 28 | 0;
 i35 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i35 + (i21 * 12 | 0) >> 2] | 0;
 i18 = HEAP32[i35 + (i21 * 12 | 0) + 4 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i35 + (i21 * 12 | 0) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i20 + (i34 * 12 | 0) + 8 >> 2]);
 i20 = HEAP32[i35 + (i34 * 12 | 0) >> 2] | 0;
 i21 = HEAP32[i35 + (i34 * 12 | 0) + 4 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i35 + (i34 * 12 | 0) + 8 >> 2]);
 f4 = Math_fround(+Math_sin(+f2));
 f12 = Math_fround(+Math_cos(+f2));
 f13 = Math_fround(+Math_sin(+f3));
 f11 = Math_fround(+Math_cos(+f3));
 f26 = Math_fround(HEAPF32[i8 + 80 >> 2]);
 f26 = Math_fround(f26 - (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f30 = Math_fround(HEAPF32[i8 + 84 >> 2]);
 f30 = Math_fround(f30 - (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f27 = Math_fround(Math_fround(f12 * f26) - Math_fround(f4 * f30));
 f30 = Math_fround(Math_fround(f4 * f26) + Math_fround(f12 * f30));
 i24 = i8 + 124 | 0;
 HEAPF32[i24 >> 2] = f27;
 i7 = i8 + 128 | 0;
 HEAPF32[i7 >> 2] = f30;
 f12 = Math_fround(HEAPF32[i8 + 88 >> 2]);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f26 = Math_fround(HEAPF32[i8 + 92 >> 2]);
 f26 = Math_fround(f26 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f26));
 f26 = Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * f26));
 i10 = i8 + 132 | 0;
 HEAPF32[i10 >> 2] = f4;
 i6 = i8 + 136 | 0;
 HEAPF32[i6 >> 2] = f26;
 f11 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = Math_fround(f11 + f12);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(f28 + Math_fround(f13 * Math_fround(f30 * f30))) + Math_fround(f14 * Math_fround(f26 * f26)));
 f29 = Math_fround(Math_fround(-Math_fround(f13 * Math_fround(f30 * f27))) - Math_fround(f14 * Math_fround(f26 * f4)));
 HEAPF32[i5 + 12 >> 2] = f29;
 f26 = Math_fround(Math_fround(-Math_fround(f13 * f30)) - Math_fround(f14 * f26));
 HEAPF32[i5 + 24 >> 2] = f26;
 HEAPF32[i5 + 4 >> 2] = f29;
 HEAPF32[i5 + 16 >> 2] = Math_fround(Math_fround(f28 + Math_fround(f13 * Math_fround(f27 * f27))) + Math_fround(f14 * Math_fround(f4 * f4)));
 f4 = Math_fround(Math_fround(f13 * f27) + Math_fround(f14 * f4));
 HEAPF32[i5 + 28 >> 2] = f4;
 HEAPF32[i5 + 8 >> 2] = f26;
 HEAPF32[i5 + 20 >> 2] = f4;
 f4 = Math_fround(f13 + f14);
 HEAPF32[i5 + 32 >> 2] = f4;
 i1 = i8 + 68 | 0;
 do if (Math_fround(HEAPF32[i1 >> 2]) > Math_fround(0.0)) {
  __ZNK7b2Mat3312GetInverse22EPS_(i5, i8 + 172 | 0);
  i35 = f4 > Math_fround(0.0);
  f28 = Math_fround(Math_fround(1.0) / f4);
  f28 = i35 ? f28 : Math_fround(0.0);
  f27 = Math_fround(f3 - f2);
  f27 = Math_fround(f27 - Math_fround(HEAPF32[i8 + 96 >> 2]));
  f29 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(6.28318548));
  f30 = Math_fround(f28 * Math_fround(2.0));
  f30 = Math_fround(f29 * Math_fround(f30 * Math_fround(HEAPF32[i8 + 72 >> 2])));
  f29 = Math_fround(f29 * Math_fround(f28 * f29));
  f28 = Math_fround(HEAPF32[i9 >> 2]);
  f30 = Math_fround(f28 * Math_fround(f30 + Math_fround(f28 * f29)));
  i35 = f30 != Math_fround(0.0);
  f30 = Math_fround(Math_fround(1.0) / f30);
  f30 = i35 ? f30 : Math_fround(0.0);
  HEAPF32[i8 + 100 >> 2] = f30;
  HEAPF32[i8 + 76 >> 2] = Math_fround(Math_fround(Math_fround(f27 * f28) * f29) * f30);
  f30 = Math_fround(f4 + f30);
  i35 = f30 != Math_fround(0.0);
  f30 = Math_fround(Math_fround(1.0) / f30);
  HEAPF32[i8 + 204 >> 2] = i35 ? f30 : Math_fround(0.0);
 } else {
  i1 = i8 + 172 | 0;
  if (f4 == Math_fround(0.0)) {
   __ZNK7b2Mat3312GetInverse22EPS_(i5, i1);
   HEAPF32[i8 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 76 >> 2] = Math_fround(0.0);
   break;
  } else {
   __ZNK7b2Mat3315GetSymInverse33EPS_(i5, i1);
   HEAPF32[i8 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 76 >> 2] = Math_fround(0.0);
   break;
  }
 } while (0);
 i1 = i8 + 104 | 0;
 if (!(HEAP8[i9 + 20 >> 0] | 0)) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 108 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 112 >> 2] = Math_fround(0.0);
  f29 = f19;
  f30 = f22;
  i31 = i20;
  i20 = i17;
  i34 = i21;
  i33 = i18;
  i35 = HEAP32[i23 >> 2] | 0;
  i32 = HEAP32[i16 >> 2] | 0;
  i24 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i24 >> 2] = i20;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i23 >> 2] | 0;
  i33 = HEAP32[i16 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f29;
  i35 = HEAP32[i15 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i31;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i15 >> 2] | 0;
  i34 = HEAP32[i16 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f30;
  STACKTOP = i25;
  return;
 } else {
  f26 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f30 = Math_fround(f26 * Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i1 >> 2] = f30;
  i34 = i8 + 108 | 0;
  f27 = Math_fround(f26 * Math_fround(HEAPF32[i34 >> 2]));
  HEAPF32[i34 >> 2] = f27;
  i34 = i8 + 112 | 0;
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i34 >> 2]));
  HEAPF32[i34 >> 2] = f26;
  f28 = Math_fround(f11 * f30);
  f29 = Math_fround(f11 * f27);
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f28);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  f29 = Math_fround(f27 * Math_fround(HEAPF32[i24 >> 2]));
  f29 = Math_fround(f19 - Math_fround(f13 * Math_fround(f26 + Math_fround(f29 - Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2]))))));
  f19 = Math_fround(f12 * f30);
  f28 = Math_fround(f12 * f27);
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i10 >> 2]));
  f30 = Math_fround(f22 + Math_fround(f14 * Math_fround(f26 + Math_fround(f27 - Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]))))));
  i21 = i34;
  i34 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = HEAP32[i23 >> 2] | 0;
  i32 = HEAP32[i16 >> 2] | 0;
  i24 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i24 >> 2] = i21;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i23 >> 2] | 0;
  i33 = HEAP32[i16 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f29;
  i35 = HEAP32[i15 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i31;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i15 >> 2] | 0;
  i34 = HEAP32[i16 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f30;
  STACKTOP = i25;
  return;
 }
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_(i18, i2, i1) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 24 | 0;
 i19 = i23;
 i8 = HEAP32[i18 >> 2] | 0;
 i3 = i8;
 i7 = (HEAP32[i2 >> 2] | 0) - i3 >> 4;
 i22 = i8 + (i7 << 4) | 0;
 i6 = i18 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i18 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  if ((i22 | 0) == (i4 | 0)) {
   i3 = HEAP8[i1 + 11 >> 0] | 0;
   i19 = i3 << 24 >> 24 < 0;
   i2 = i19 ? HEAP32[i1 >> 2] | 0 : i1;
   i3 = i19 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   HEAP32[i22 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 + (i7 << 4) + 12 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
    i1 = HEAP32[i8 + (i7 << 4) + 12 >> 2] | 0;
    i20 = 6;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 + 11 >> 0] = i3;
    if (!i3) i1 = i22; else {
     i1 = i22;
     i20 = 8;
    }
   } else i20 = 6;
   if ((i20 | 0) == 6) {
    i19 = i3 + 16 & -16;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i21 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i22 >> 2] = i1;
    HEAP32[i8 + (i7 << 4) + 8 >> 2] = i19 | -2147483648;
    HEAP32[i8 + (i7 << 4) + 4 >> 2] = i3;
    i20 = 8;
   }
   if ((i20 | 0) == 8) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
   STACKTOP = i23;
   return i22 | 0;
  }
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE12__move_rangeEPS1_S6_S6_(i18, i22, i4, i22 + 16 | 0);
  if (i22 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i6 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 16 | 0 : i1;
  if ((i22 | 0) == (i1 | 0)) {
   STACKTOP = i23;
   return i22 | 0;
  }
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  i3 = i22 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + (i7 << 4) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + (i7 << 4) + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i22, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
   STACKTOP = i23;
   return i22 | 0;
  }
  if (i2) i1 = HEAP32[i22 >> 2] | 0; else i1 = i22;
  if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + (i7 << 4) + 4 >> 2] = i5;
   STACKTOP = i23;
   return i22 | 0;
  } else {
   HEAP8[i3 >> 0] = i5;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 i7 = i18 + 12 | 0;
 i17 = i4 - i3 | 0;
 i4 = (i17 >> 4) + 1 | 0;
 if ((i17 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i18 >> 2] | 0;
 }
 i5 = i2 - i3 | 0;
 i6 = i5 >> 3;
 i6 = i5 >> 4 >>> 0 < 1073741823 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 2147483647;
 i4 = i22 - i3 | 0;
 i5 = i4 >> 4;
 HEAP32[i19 + 12 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = i7;
 if (!i6) i2 = 0; else {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i21 >> 2] = 34;
  HEAP32[i21 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i19 >> 2] = i2;
 i3 = i2 + (i5 << 4) | 0;
 i16 = i19 + 8 | 0;
 HEAP32[i16 >> 2] = i3;
 i15 = i19 + 4 | 0;
 HEAP32[i15 >> 2] = i3;
 i14 = i19 + 12 | 0;
 HEAP32[i14 >> 2] = i2 + (i6 << 4);
 do if ((i5 | 0) == (i6 | 0)) {
  if ((i4 | 0) > 0) {
   i14 = i3 + ((((i4 >> 4) + 1 | 0) / -2 | 0) << 4) | 0;
   HEAP32[i16 >> 2] = i14;
   HEAP32[i15 >> 2] = i14;
   break;
  }
  i12 = i6 << 4 >> 3;
  i12 = (i12 | 0) == 0 ? 1 : i12;
  i13 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i21 >> 2] = 34;
  HEAP32[i21 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 4, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  i10 = i2;
  i3 = i2 + (i12 >>> 2 << 4) | 0;
  i11 = i3;
  i12 = i2 + (i12 << 4) | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  i7 = HEAP32[i16 >> 2] | 0;
  if ((i2 | 0) == (i7 | 0)) {
   i2 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = i10;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i16 >> 2] = i11;
   HEAP32[i14 >> 2] = i12;
  } else {
   i8 = i21 + 4 | 0;
   i9 = i11;
   do {
    i6 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i6 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 + 12 >> 2] = i4;
    if (i6 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
     i4 = HEAP32[i3 + 12 >> 2] | 0;
     i20 = 41;
    } else if (i6 >>> 0 < 11) {
     HEAP8[i3 + 11 >> 0] = i6;
     if (i6) i20 = 43;
    } else i20 = 41;
    if ((i20 | 0) == 41) {
     i24 = i6 + 16 & -16;
     HEAP32[i21 >> 2] = 66;
     HEAP32[i8 >> 2] = i4;
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i3 >> 2] = i4;
     HEAP32[i3 + 8 >> 2] = i24 | -2147483648;
     HEAP32[i3 + 4 >> 2] = i6;
     i3 = i4;
     i20 = 43;
    }
    if ((i20 | 0) == 43) {
     i20 = 0;
     _memcpy(i3 | 0, i5 | 0, i6 | 0) | 0;
    }
    HEAP8[i3 + i6 >> 0] = 0;
    i3 = i9 + 16 | 0;
    i9 = i3;
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i7 | 0));
   i6 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = i10;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i16 >> 2] = i9;
   HEAP32[i14 >> 2] = i12;
   if ((i3 | 0) != (i6 | 0)) {
    i5 = i21 + 4 | 0;
    do {
     i4 = i3;
     i3 = i3 + -16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i24 = HEAP32[i3 >> 2] | 0;
      i14 = HEAP32[i4 + -4 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i5 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i24, i21);
     }
    } while ((i3 | 0) != (i6 | 0));
   }
  }
  if (i2 | 0) {
   i24 = HEAP32[i13 >> 2] | 0;
   HEAP32[i21 >> 2] = 34;
   HEAP32[i21 + 4 >> 2] = i24;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i21);
  }
 } while (0);
 i2 = HEAP32[i16 >> 2] | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i24 = i4 << 24 >> 24 < 0;
 i3 = i24 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i24 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  i20 = 55;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i2 + 11 >> 0] = i4;
  if (!i4) i1 = i2; else {
   i1 = i2;
   i20 = 57;
  }
 } else i20 = 55;
 if ((i20 | 0) == 55) {
  i24 = i4 + 16 & -16;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = i24 | -2147483648;
  HEAP32[i2 + 4 >> 2] = i4;
  i20 = 57;
 }
 if ((i20 | 0) == 57) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 16;
 i5 = __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EEPS1_(i18, i19, i22) | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i21 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i16 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i24 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i24, i21);
    i1 = HEAP32[i16 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  i24 = HEAP32[HEAP32[i17 >> 2] >> 2] | 0;
  HEAP32[i21 >> 2] = 34;
  HEAP32[i21 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
 }
 i24 = i5;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i21, i14, i10, i22, i27) {
 i21 = i21 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i22 = i22 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i28 + 56 | 0;
 i11 = i28 + 32 | 0;
 i12 = i28;
 i26 = i28 + 80 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i18 >> 2] = i1;
 i16 = i18 + 4 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = i2;
 i20 = i18 + 8 | 0;
 i3 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i20 >> 2] = i3;
 i13 = i18 + 12 | 0;
 i4 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 i17 = i18 + 16 | 0;
 i6 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i17 >> 2] = i6;
 i19 = i18 + 20 | 0;
 i10 = HEAP32[i10 + 20 >> 2] | 0;
 HEAP32[i19 >> 2] = i10;
 if (i22 & 1) {
  f29 = Math_fround(HEAPF32[i14 + 16 >> 2]);
  f30 = Math_fround(HEAPF32[i14 + 20 >> 2]);
  f29 = Math_fround(f29 * Math_fround(-2.0));
  f30 = Math_fround(f30 * Math_fround(-2.0));
  f32 = Math_fround(Math_fround(HEAPF32[i14 + 24 >> 2]) * Math_fround(-2.0));
  f9 = Math_fround(HEAPF32[i14 + 12 >> 2]);
  f31 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
  f5 = Math_fround(HEAPF32[i14 >> 2]);
  f25 = Math_fround(f29 * f5);
  f7 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f30 * f7));
  f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f32 * f8));
  f15 = Math_fround(Math_fround(f5 * f25) + Math_fround(Math_fround(f29 * f31) - Math_fround(f9 * Math_fround(Math_fround(f32 * f7) - Math_fround(f30 * f8)))));
  f24 = Math_fround(Math_fround(f7 * f25) + Math_fround(Math_fround(f30 * f31) - Math_fround(f9 * Math_fround(Math_fround(f29 * f8) - Math_fround(f32 * f5)))));
  f25 = Math_fround(Math_fround(Math_fround(f32 * f31) - Math_fround(f9 * Math_fround(Math_fround(f30 * f5) - Math_fround(f29 * f7)))) + Math_fround(f8 * f25));
  f7 = Math_fround(-f7);
  f8 = Math_fround(-f8);
  HEAPF32[i12 >> 2] = Math_fround(-f5);
  HEAPF32[i12 + 4 >> 2] = f7;
  HEAPF32[i12 + 8 >> 2] = f8;
  HEAPF32[i12 + 12 >> 2] = f9;
  HEAPF32[i12 + 16 >> 2] = f15;
  HEAPF32[i12 + 20 >> 2] = f24;
  HEAPF32[i12 + 24 >> 2] = f25;
  __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i11, i12, i18);
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i20 >> 2] = i3;
  i4 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  i6 = HEAP32[i11 + 16 >> 2] | 0;
  HEAP32[i17 >> 2] = i6;
  i10 = HEAP32[i11 + 20 >> 2] | 0;
  HEAP32[i19 >> 2] = i10;
 }
 f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(f30 * f8);
 HEAPF32[i18 >> 2] = f8;
 f31 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f25 = Math_fround(f31 * f25);
 HEAPF32[i16 >> 2] = f25;
 f32 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f9 = Math_fround(f32 * f9);
 HEAPF32[i20 >> 2] = f9;
 i1 = i18 + 12 | 0;
 f5 = Math_fround(f30 * f5);
 HEAPF32[i1 >> 2] = f5;
 f24 = Math_fround(f31 * f24);
 HEAPF32[i17 >> 2] = f24;
 f7 = Math_fround(f32 * f7);
 HEAPF32[i19 >> 2] = f7;
 i2 = HEAP32[i21 + 16 >> 2] | 0;
 if (Math_fround(HEAPF32[i2 + 12 >> 2]) < Math_fround(0.0)) {
  HEAPF32[i18 >> 2] = f5;
  HEAPF32[i1 >> 2] = f8;
  f15 = f5;
  f5 = f8;
 } else f15 = f8;
 if (Math_fround(HEAPF32[i2 + 16 >> 2]) < Math_fround(0.0)) {
  HEAPF32[i20 >> 2] = f7;
  HEAPF32[i19 >> 2] = f9;
  f8 = f7;
  f7 = f9;
 } else f8 = f9;
 i23 = i21 + 12 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if (f15 > Math_fround(i2 >>> 0)) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i10 = HEAP32[i4 + 20 >> 2] | 0;
 i3 = i10 + -1 | 0;
 if (f7 < Math_fround(0.0) | (f5 < Math_fround(0.0) | f8 > Math_fround(i3 >>> 0))) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i6 = ~~Math_fround(Math_floor(Math_fround(f15)));
 i21 = i1 + -2 | 0;
 i6 = (i6 | 0) > 0 ? i6 : 0;
 i6 = (i6 | 0) > (i21 | 0) ? i21 : i6;
 i21 = ~~Math_fround(Math_ceil(Math_fround(f5)));
 i21 = (i21 | 0) > 0 ? i21 : 0;
 i21 = (i21 | 0) > (i2 | 0) ? i2 : i21;
 i20 = ~~Math_fround(Math_floor(Math_fround(f8)));
 i18 = i10 + -2 | 0;
 i20 = (i20 | 0) > 0 ? i20 : 0;
 i20 = (i20 | 0) > (i18 | 0) ? i18 : i20;
 i18 = ~~Math_fround(Math_ceil(Math_fround(f7)));
 i18 = (i18 | 0) > 0 ? i18 : 0;
 i18 = (i18 | 0) > (i3 | 0) ? i3 : i18;
 i19 = i18 - i20 | 0;
 if (!(Math_imul(i21 - i6 << 1, i19) | 0)) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i16 = (i22 & 2 | 0) == 0;
 do if (i21 >>> 0 > i6 >>> 0) {
  i17 = i18 >>> 0 > i20 >>> 0;
  i13 = i4;
  i2 = 0;
  i1 = 0;
  i3 = (Math_imul(i10, i6) | 0) + i20 | 0;
  i14 = i6;
  L21 : while (1) {
   L23 : do if (i17) {
    if (i16) {
     i10 = i13;
     i12 = i20;
     i11 = i3;
    } else {
     i6 = HEAP32[i13 + 36 >> 2] | 0;
     i10 = HEAP32[i13 + 20 >> 2] | 0;
     i11 = i20;
     while (1) {
      f5 = Math_fround(HEAP16[i6 + (i3 << 2) >> 1] | 0);
      i12 = i3 + 1 | 0;
      f7 = Math_fround(HEAP16[i6 + (i12 << 2) >> 1] | 0);
      i22 = i10 + i3 | 0;
      f8 = Math_fround(HEAP16[i6 + (i22 << 2) >> 1] | 0);
      f9 = Math_fround(HEAP16[i6 + (i22 + 1 << 2) >> 1] | 0);
      if (!(f24 < f9 & (f24 < f8 & (f24 < f5 & f24 < f7)))) if (!(f25 > f9 & (f25 > f8 & (f25 > f5 & f25 > f7)))) {
       if ((HEAP8[i6 + (i3 << 2) + 2 >> 0] & 127) != 127) {
        i6 = 18;
        break L21;
       }
       if ((HEAP8[i6 + (i3 << 2) + 3 >> 0] & 127) != 127) {
        i6 = 22;
        break L21;
       }
      }
      i11 = i11 + 1 | 0;
      if (i11 >>> 0 >= i18 >>> 0) {
       i6 = i13;
       i3 = i12;
       break L23;
      } else i3 = i12;
     }
    }
    while (1) {
     i6 = HEAP32[i10 + 36 >> 2] | 0;
     f8 = Math_fround(HEAP16[i6 + (i11 << 2) >> 1] | 0);
     i3 = i11 + 1 | 0;
     f9 = Math_fround(HEAP16[i6 + (i3 << 2) >> 1] | 0);
     i22 = (HEAP32[i10 + 20 >> 2] | 0) + i11 | 0;
     f5 = Math_fround(HEAP16[i6 + (i22 << 2) >> 1] | 0);
     f7 = Math_fround(HEAP16[i6 + (i22 + 1 << 2) >> 1] | 0);
     if (!(f24 < f7 & (f24 < f5 & (f24 < f8 & f24 < f9)))) if (!(f25 > f7 & (f25 > f5 & (f25 > f8 & f25 > f9)))) {
      if ((HEAP8[i6 + (i11 << 2) + 2 >> 0] & 127) != 127) {
       if (i2 >>> 0 > 63) {
        mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, i2 | 0, i26 | 0) | 0;
        i2 = 0;
       }
       HEAP32[i26 + (i2 << 2) >> 2] = i11 << 1;
       i4 = HEAP32[i23 >> 2] | 0;
       i2 = i2 + 1 | 0;
       i1 = i1 + 1 | 0;
      }
      if ((HEAP8[(HEAP32[i4 + 36 >> 2] | 0) + (i11 << 2) + 3 >> 0] & 127) != 127) {
       if (i2 >>> 0 > 63) {
        mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, i2 | 0, i26 | 0) | 0;
        i2 = 0;
       }
       HEAP32[i26 + (i2 << 2) >> 2] = i11 << 1 | 1;
       i4 = HEAP32[i23 >> 2] | 0;
       i2 = i2 + 1 | 0;
       i1 = i1 + 1 | 0;
      }
     }
     i12 = i12 + 1 | 0;
     if (i12 >>> 0 >= i18 >>> 0) {
      i6 = i4;
      break;
     } else {
      i10 = i4;
      i11 = i3;
     }
    }
   } else i6 = i13; while (0);
   i14 = i14 + 1 | 0;
   if (i14 >>> 0 >= i21 >>> 0) {
    i6 = 38;
    break;
   } else {
    i13 = i6;
    i3 = i3 - i19 + (HEAP32[i6 + 20 >> 2] | 0) | 0;
   }
  }
  if ((i6 | 0) == 18) {
   if (i2 >>> 0 > 63) {
    mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, i2 | 0, i26 | 0) | 0;
    i2 = 0;
   }
   HEAP32[i26 + (i2 << 2) >> 2] = i3 << 1;
   i6 = 40;
  } else if ((i6 | 0) == 22) {
   if (i2 >>> 0 > 63) {
    mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, i2 | 0, i26 | 0) | 0;
    i2 = 0;
   }
   HEAP32[i26 + (i2 << 2) >> 2] = i3 << 1 | 1;
   i6 = 40;
  } else if ((i6 | 0) == 38) {
   if (!i2) break;
   i3 = i26;
   i4 = i27;
  }
  if ((i6 | 0) == 40) {
   i3 = i26;
   i4 = i27;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
  mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i27 | 0, i2 | 0, i3 | 0) | 0;
 } else i1 = 0; while (0);
 i27 = (i1 | 0) != 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN16Physics2DManagerC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 8 | 0;
 i16 = i12;
 HEAP32[i5 >> 2] = gb + 156040 + 8;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = i5 + 12 | 0;
 HEAP8[i4 >> 0] = 0;
 i2 = i5 + 13 | 0;
 HEAP8[i2 >> 0] = 0;
 i3 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i3 = i5 + 44 | 0;
 HEAP32[i3 >> 2] = 32;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f18 = Math_fround((HEAP32[i3 >> 2] | 0) >>> 0);
 HEAP32[i5 + 56 >> 2] = ~~Math_fround(f18 * Math_fround(.5)) >>> 0;
 HEAP32[i5 + 52 >> 2] = ~~Math_fround(f18 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 60 >> 0] = 0;
 i8 = i5 + 68 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 72 >> 2] = i8;
 i8 = i5 + 76 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 80 >> 2] = i8;
 i8 = i5 + 84 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 88 >> 2] = i8;
 i8 = i5 + 92 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 96 >> 2] = i8;
 i8 = i5 + 100 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 104 >> 2] = i8;
 i8 = i5 + 108 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 112 >> 2] = i8;
 i8 = i5 + 116 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 120 >> 2] = i8;
 i8 = i5 + 124 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 128 >> 2] = i8;
 i8 = i5 + 132 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 136 >> 2] = i8;
 i8 = i5 + 140 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 144 >> 2] = i8;
 i8 = i5 + 148 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 152 >> 2] = i8;
 i8 = i5 + 156 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 160 >> 2] = i8;
 i8 = i5 + 164 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 168 >> 2] = i8;
 i8 = i5 + 172 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 176 >> 2] = i8;
 i8 = i5 + 180 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 184 >> 2] = i8;
 i8 = i5 + 188 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 192 >> 2] = i8;
 i8 = i5 + 196 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 200 >> 2] = i8;
 i8 = i5 + 204 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 208 >> 2] = i8;
 i8 = i5 + 212 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 216 >> 2] = i8;
 i8 = i5 + 220 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 224 >> 2] = i8;
 i8 = i5 + 228 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 232 >> 2] = i8;
 i8 = i5 + 236 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 240 >> 2] = i8;
 i8 = i5 + 244 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 248 >> 2] = i8;
 i8 = i5 + 252 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 256 >> 2] = i8;
 i8 = i5 + 260 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 264 >> 2] = i8;
 i8 = i5 + 268 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 272 >> 2] = i8;
 i8 = i5 + 276 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 280 >> 2] = i8;
 i8 = i5 + 284 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 288 >> 2] = i8;
 i8 = i5 + 292 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 296 >> 2] = i8;
 i8 = i5 + 300 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 304 >> 2] = i8;
 i8 = i5 + 308 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 312 >> 2] = i8;
 i8 = i5 + 316 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 320 >> 2] = i8;
 i8 = i5 + 324 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 328 >> 2] = i8;
 i8 = i5 + 332 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 336 >> 2] = i8;
 i8 = i5 + 340 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 344 >> 2] = i8;
 i8 = i5 + 348 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 352 >> 2] = i8;
 i8 = i5 + 356 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 360 >> 2] = i8;
 i8 = i5 + 364 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 368 >> 2] = i8;
 i8 = i5 + 372 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 376 >> 2] = i8;
 i8 = i5 + 380 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 384 >> 2] = i8;
 i8 = i5 + 388 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 392 >> 2] = i8;
 i8 = i5 + 396 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 400 >> 2] = i8;
 i8 = i5 + 404 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 408 >> 2] = i8;
 i8 = i5 + 412 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 416 >> 2] = i8;
 i8 = i5 + 420 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 424 >> 2] = i8;
 i8 = i5 + 428 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 432 >> 2] = i8;
 i8 = i5 + 436 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 440 >> 2] = i8;
 i8 = i5 + 444 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 448 >> 2] = i8;
 i8 = i5 + 452 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 456 >> 2] = i8;
 i8 = i5 + 460 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 464 >> 2] = i8;
 i8 = i5 + 468 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 472 >> 2] = i8;
 i8 = i5 + 476 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 480 >> 2] = i8;
 i8 = i5 + 484 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 488 >> 2] = i8;
 i8 = i5 + 492 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 496 >> 2] = i8;
 i8 = i5 + 500 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 504 >> 2] = i8;
 i8 = i5 + 508 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 512 >> 2] = i8;
 i8 = i5 + 516 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 520 >> 2] = i8;
 i8 = i5 + 524 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 528 >> 2] = i8;
 i8 = i5 + 532 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 536 >> 2] = i8;
 i8 = i5 + 540 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 544 >> 2] = i8;
 i8 = i5 + 548 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 552 >> 2] = i8;
 i8 = i5 + 556 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 560 >> 2] = i8;
 i8 = i5 + 564 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 568 >> 2] = i8;
 i8 = i5 + 572 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i5 + 576 >> 2] = i8;
 i8 = i5 + 580 | 0;
 i9 = i5 + 584 | 0;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i9 >> 2] = i8;
 i10 = i5 + 588 | 0;
 i11 = i5 + 592 | 0;
 HEAP32[i10 >> 2] = i10;
 HEAP32[i11 >> 2] = i10;
 i6 = i5 + 596 | 0;
 i7 = i5 + 600 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i7 >> 2] = i6;
 i13 = i5 + 604 | 0;
 i17 = gb + 63400 | 0;
 i14 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i16;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i14;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i5 + 616 >> 2] = 0;
 HEAP32[i5 + 620 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i16);
 i16 = i1;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i5 + 608 | 0;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP8[i5 + 624 >> 0] = 1;
 HEAP8[i5 + 625 >> 0] = 1;
 __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE(gb + 32588 | 0, i13, 1);
 HEAP8[i2 >> 0] = 1;
 i2 = i5 + 28 | 0;
 i13 = i2;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = 0;
 i13 = (HEAP32[i3 >> 2] | 0) * 12 | 0;
 i14 = HEAP32[i5 + 64 >> 2] | 0;
 HEAP32[i1 >> 2] = 65;
 HEAP32[i1 + 4 >> 2] = i14;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 40 >> 2] = i1;
 i3 = i1 + ((HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv(i5 + 4 | 0);
 HEAP8[i4 >> 0] = 1;
 i2 = i5 + 16 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i5 + 24 >> 2] = 0;
 i2 = 0;
 do {
  i3 = i5 + 68 + (i2 << 3) | 0;
  i4 = i5 + 68 + (i2 << 3) + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i17 = i1 + 4 | 0;
   i16 = i1;
   i1 = HEAP32[i17 >> 2] | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
  } while ((i1 | 0) != (i3 | 0));
  HEAP32[i4 >> 2] = i3;
  HEAP32[i3 >> 2] = i3;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 64);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) do {
  i17 = i1 + 4 | 0;
  i16 = i1;
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 } while ((i1 | 0) != (i6 | 0));
 HEAP32[i7 >> 2] = i6;
 HEAP32[i6 >> 2] = i6;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) do {
  i17 = i1 + 4 | 0;
  i16 = i1;
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 } while ((i1 | 0) != (i8 | 0));
 HEAP32[i9 >> 2] = i8;
 HEAP32[i8 >> 2] = i8;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  HEAP32[i11 >> 2] = i10;
  HEAP32[i10 >> 2] = i10;
  STACKTOP = i12;
  return;
 }
 do {
  i17 = i1 + 4 | 0;
  i16 = i1;
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i17 >> 2] = 0;
 } while ((i1 | 0) != (i10 | 0));
 HEAP32[i11 >> 2] = i10;
 HEAP32[i10 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function _UNITY_FT_Stroker_LineTo(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 16 | 0;
 i14 = i27 + 8 | 0;
 i25 = i27;
 if (!((i18 | 0) != 0 & (i19 | 0) != 0)) {
  i26 = 6;
  STACKTOP = i27;
  return i26 | 0;
 }
 i26 = i18 + 8 | 0;
 i22 = (HEAP32[i19 >> 2] | 0) - (HEAP32[i26 >> 2] | 0) | 0;
 HEAP32[i25 >> 2] = i22;
 i20 = i19 + 4 | 0;
 i15 = i18 + 12 | 0;
 i24 = (HEAP32[i20 >> 2] | 0) - (HEAP32[i15 >> 2] | 0) | 0;
 i21 = i25 + 4 | 0;
 HEAP32[i21 >> 2] = i24;
 if (!(i22 | i24)) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i22 = _UNITY_FT_Vector_Length(i25) | 0;
 i24 = _UNITY_FT_Atan2(HEAP32[i25 >> 2] | 0, HEAP32[i21 >> 2] | 0) | 0;
 i1 = i18 + 60 | 0;
 i2 = i24 + 5898240 | 0;
 _UNITY_FT_Vector_From_Polar(i25, HEAP32[i1 >> 2] | 0, i2);
 i16 = i18 + 20 | 0;
 if (!(HEAP8[i16 >> 0] | 0)) {
  HEAP32[i18 + 4 >> 2] = i24;
  i1 = _UNITY_FT_Angle_Diff(HEAP32[i18 >> 2] | 0, i24) | 0;
  if (i1 | 0) {
   i1 = i1 >>> 31;
   i2 = _ft_stroker_inside(i18, i1, i22) | 0;
   if (i2 | 0) {
    i26 = i2;
    STACKTOP = i27;
    return i26 | 0;
   }
   i1 = _ft_stroker_outside(i18, i1 ^ 1, i22) | 0;
   if (i1 | 0) {
    i26 = i1;
    STACKTOP = i27;
    return i26 | 0;
   }
  }
 } else {
  _UNITY_FT_Vector_From_Polar(i14, HEAP32[i1 >> 2] | 0, i2);
  i9 = i18 + 8 | 0;
  i10 = (HEAP32[i14 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
  i13 = i14 + 4 | 0;
  i11 = (HEAP32[i13 >> 2] | 0) + (HEAP32[i15 >> 2] | 0) | 0;
  i3 = i18 + 84 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i12 = i18 + 64 | 0;
  if ((i1 | 0) > -1) {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i2 >>> 0 > (i1 + 1 | 0) >>> 0) {
    i6 = i2 + -1 | 0;
    HEAP32[i12 >> 2] = i6;
    i8 = HEAP32[i18 + 72 >> 2] | 0;
    i6 = i8 + (i6 << 3) | 0;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i8 + (i1 << 3) | 0;
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = i7;
    i8 = i18 + 76 | 0;
    i7 = (HEAP32[i8 >> 2] | 0) + i1 | 0;
    HEAP8[i7 >> 0] = HEAPU8[i7 >> 0] | 4;
    i8 = (HEAP32[i8 >> 2] | 0) + (i2 + -2) | 0;
    HEAP8[i8 >> 0] = HEAPU8[i8 >> 0] | 8;
   } else HEAP32[i12 >> 2] = i1;
   HEAP32[i3 >> 2] = -1;
   i8 = i18 + 80 | 0;
   HEAP8[i8 >> 0] = 0;
  } else i8 = i18 + 80 | 0;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP8[i8 >> 0] = 0;
  i4 = HEAP32[i12 >> 2] | 0;
  if (!i4) i17 = 13; else {
   i1 = i4 + -1 | 0;
   i2 = HEAP32[i18 + 72 >> 2] | 0;
   if ((1 - i10 + (HEAP32[i2 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) {
    if ((1 - i11 + (HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 >= 3) i17 = 13;
   } else i17 = 13;
  }
  if ((i17 | 0) == 13) {
   i7 = i18 + 68 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i1 = i4 + 1 | 0;
   HEAP32[i23 >> 2] = 0;
   do if (i1 >>> 0 > i5 >>> 0) {
    i2 = HEAP32[i18 + 88 >> 2] | 0;
    i6 = i5;
    do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
    i3 = i18 + 72 | 0;
    HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i5, i6, HEAP32[i3 >> 2] | 0, i23) | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    if (!i1) {
     i1 = i18 + 76 | 0;
     i4 = _UNITY_ft_mem_realloc(i2, 1, i5, i6, HEAP32[i1 >> 2] | 0, i23) | 0;
     HEAP32[i1 >> 2] = i4;
     i1 = HEAP32[i23 >> 2] | 0;
     if (!i1) {
      HEAP32[i7 >> 2] = i6;
      i2 = HEAP32[i12 >> 2] | 0;
      i1 = i4;
      break;
     }
    }
    HEAP8[i8 >> 0] = 0;
    i26 = i1;
    STACKTOP = i27;
    return i26 | 0;
   } else {
    i3 = i18 + 72 | 0;
    i2 = i4;
    i1 = HEAP32[i18 + 76 >> 2] | 0;
   } while (0);
   i7 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i7 + 4 >> 2] = i11;
   HEAP8[i1 + i2 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   HEAP8[i8 >> 0] = 0;
  }
  i11 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0;
  i9 = (HEAP32[i15 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
  i3 = i18 + 116 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = i18 + 96 | 0;
  if ((i1 | 0) > -1) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 >>> 0 > (i1 + 1 | 0) >>> 0) {
    i13 = i2 + -1 | 0;
    HEAP32[i10 >> 2] = i13;
    i15 = HEAP32[i18 + 104 >> 2] | 0;
    i13 = i15 + (i13 << 3) | 0;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i15 = i15 + (i1 << 3) | 0;
    HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i15 + 4 >> 2] = i14;
    i15 = i18 + 108 | 0;
    i14 = (HEAP32[i15 >> 2] | 0) + i1 | 0;
    HEAP8[i14 >> 0] = HEAPU8[i14 >> 0] | 4;
    i15 = (HEAP32[i15 >> 2] | 0) + (i2 + -2) | 0;
    HEAP8[i15 >> 0] = HEAPU8[i15 >> 0] | 8;
   } else HEAP32[i10 >> 2] = i1;
   HEAP32[i3 >> 2] = -1;
   i8 = i18 + 112 | 0;
   HEAP8[i8 >> 0] = 0;
  } else i8 = i18 + 112 | 0;
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP8[i8 >> 0] = 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (!i4) i17 = 31; else {
   i1 = i4 + -1 | 0;
   i2 = HEAP32[i18 + 104 >> 2] | 0;
   if ((1 - i11 + (HEAP32[i2 + (i1 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i9 + (HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) i1 = 0; else i17 = 31; else i17 = 31;
  }
  if ((i17 | 0) == 31) {
   i7 = i18 + 100 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i1 = i4 + 1 | 0;
   HEAP32[i23 >> 2] = 0;
   do if (i1 >>> 0 > i5 >>> 0) {
    i2 = HEAP32[i18 + 120 >> 2] | 0;
    i6 = i5;
    do i6 = i6 + 16 + (i6 >>> 1) | 0; while (i6 >>> 0 < i1 >>> 0);
    i3 = i18 + 104 | 0;
    HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i5, i6, HEAP32[i3 >> 2] | 0, i23) | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    if (!i1) {
     i1 = i18 + 108 | 0;
     i4 = _UNITY_ft_mem_realloc(i2, 1, i5, i6, HEAP32[i1 >> 2] | 0, i23) | 0;
     HEAP32[i1 >> 2] = i4;
     i1 = HEAP32[i23 >> 2] | 0;
     if (!i1) {
      HEAP32[i7 >> 2] = i6;
      i2 = HEAP32[i10 >> 2] | 0;
      i1 = i4;
      i17 = 39;
      break;
     }
    }
   } else {
    i3 = i18 + 104 | 0;
    i2 = i4;
    i1 = HEAP32[i18 + 108 >> 2] | 0;
    i17 = 39;
   } while (0);
   if ((i17 | 0) == 39) {
    i15 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i15 >> 2] = i11;
    HEAP32[i15 + 4 >> 2] = i9;
    HEAP8[i1 + i2 >> 0] = 1;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    i1 = 0;
   }
   HEAP8[i8 >> 0] = 0;
  }
  HEAP32[i18 + 24 >> 2] = i24;
  HEAP8[i16 >> 0] = 0;
  HEAP32[i18 + 36 >> 2] = i22;
  if (i1 | 0) {
   i26 = i1;
   STACKTOP = i27;
   return i26 | 0;
  }
 }
 i10 = 1;
 i11 = i18 + 64 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 L70 : while (1) {
  i7 = i1 + (HEAP32[i19 >> 2] | 0) | 0;
  i8 = i2 + (HEAP32[i20 >> 2] | 0) | 0;
  i9 = i11 + 16 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  do if (!(HEAP8[i9 >> 0] | 0)) {
   if (i5 | 0) {
    i3 = i5 + -1 | 0;
    i4 = HEAP32[i11 + 8 >> 2] | 0;
    if ((1 - i7 + (HEAP32[i4 + (i3 << 3) >> 2] | 0) | 0) >>> 0 < 3) if ((1 - i8 + (HEAP32[i4 + (i3 << 3) + 4 >> 2] | 0) | 0) >>> 0 < 3) break;
   }
   i6 = i11 + 4 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i1 = i5 + 1 | 0;
   HEAP32[i23 >> 2] = 0;
   if (i1 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i11 + 24 >> 2] | 0;
    i5 = i4;
    do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
    i3 = i11 + 8 | 0;
    HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i23) | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    if (i1 | 0) {
     i17 = 60;
     break L70;
    }
    i1 = i11 + 12 | 0;
    i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i23) | 0;
    HEAP32[i1 >> 2] = i4;
    i1 = HEAP32[i23 >> 2] | 0;
    if (i1 | 0) {
     i17 = 60;
     break L70;
    }
    HEAP32[i6 >> 2] = i5;
    i2 = HEAP32[i11 >> 2] | 0;
    i1 = i4;
   } else {
    i3 = i11 + 8 | 0;
    i2 = i5;
    i1 = HEAP32[i11 + 12 >> 2] | 0;
   }
   i17 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i17 >> 2] = i7;
   HEAP32[i17 + 4 >> 2] = i8;
   HEAP8[i1 + i2 >> 0] = 1;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i17 = 59;
  } else {
   i17 = (HEAP32[i11 + 8 >> 2] | 0) + (i5 + -1 << 3) | 0;
   HEAP32[i17 >> 2] = i7;
   HEAP32[i17 + 4 >> 2] = i8;
   i17 = 59;
  } while (0);
  if ((i17 | 0) == 59) {
   i17 = 0;
   HEAP8[i9 >> 0] = 1;
   i1 = HEAP32[i25 >> 2] | 0;
   i2 = HEAP32[i21 >> 2] | 0;
  }
  i1 = 0 - i1 | 0;
  HEAP32[i25 >> 2] = i1;
  i2 = 0 - i2 | 0;
  HEAP32[i21 >> 2] = i2;
  if ((i10 | 0) <= 0) {
   i17 = 62;
   break;
  } else {
   i10 = i10 + -1 | 0;
   i11 = i11 + 32 | 0;
  }
 }
 if ((i17 | 0) == 60) {
  HEAP8[i9 >> 0] = 1;
  i26 = i1;
  STACKTOP = i27;
  return i26 | 0;
 } else if ((i17 | 0) == 62) {
  HEAP32[i18 >> 2] = i24;
  i24 = i19;
  i25 = HEAP32[i24 + 4 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i26 + 4 >> 2] = i25;
  HEAP32[i18 + 16 >> 2] = i22;
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 return 0;
}

function __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 L1 : while (1) {
  i9 = i2;
  i11 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 68;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    do if ((i3 | 0) > 3996) {
     i4 = (i4 | 0) / 4 | 0;
     i6 = i1 + (i4 << 2) | 0;
     i4 = i7 + (i4 << 2) | 0;
     i3 = __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i1, i6, i7, i4, i12) | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) {
      i5 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i5;
      i5 = i3 + 1 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
       i5 = HEAP32[i7 >> 2] | 0;
       HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i4 >> 2] = i5;
       i4 = i3 + 2 | 0;
       if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
        i5 = HEAP32[i6 >> 2] | 0;
        HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i7 >> 2] = i5;
        if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
         i5 = HEAP32[i1 >> 2] | 0;
         HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
         HEAP32[i6 >> 2] = i5;
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i4;
      } else i3 = i5;
     }
    } else {
     i6 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
     if (!i6) {
      if (!i3) {
       i3 = 0;
       break;
      }
      i6 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i6;
      if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i7 >> 2] = i3;
      i3 = 2;
      break;
     }
     i4 = HEAP32[i1 >> 2] | 0;
     if (i3) {
      HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i4;
      i3 = 1;
      break;
     }
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i7 >> 2] = i4;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0) {
      i3 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i3;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
      i10 = 51;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i10 = 68;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i10 = 68;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i8;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i10 = 68;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i5 = i3 + 4 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -4 | 0; while (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i10 | 0) == 51) {
    i10 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i6;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L48 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    while (1) {
     i6 = i5 + 4 | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) i5 = i6; else break;
    }
    do i4 = i4 + -4 | 0; while (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i7;
     break L48;
    }
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
    i5 = i6;
    i3 = i3 + 1 | 0;
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) {
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbPN2UI6CanvasES3_EPS3_EEbT0_S8_T_(i1, i5, i12) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbPN2UI6CanvasES3_EPS3_EEbT0_S8_T_(i4, i2, i12) | 0) {
     i10 = 67;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i8 | 0) >= (i9 - i13 | 0)) {
    i10 = 66;
    break;
   }
   __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i1, i5, i12);
   i1 = i5 + 4 | 0;
  }
  if ((i10 | 0) == 66) {
   i10 = 0;
   __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i5 + 4 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i10 | 0) == 67) {
   i10 = 0;
   if (i3) {
    i10 = 68;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 4 | 0;
  i13 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  if (!i13) {
   if (!i3) return;
   i13 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i13;
   if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
   i13 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i13;
   return;
  }
  i4 = HEAP32[i1 >> 2] | 0;
  if (i3) {
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i4;
   return;
  }
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0)) return;
  i13 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i11, i12) | 0;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 4 | 0;
  i3 = i1 + 8 | 0;
  i4 = i1 + 12 | 0;
  __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i1, i2, i3, i4, i12) | 0;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i3 >> 2] | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i13;
  HEAP32[i4 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i2 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i3 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i1, i2, i12);
  return;
 } else if ((i10 | 0) == 68) return;
}

function __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 L1 : while (1) {
  i9 = i2;
  i11 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i10 = 5;
      break L1;
     }
    case 3:
     {
      i10 = 7;
      break L1;
     }
    case 4:
     {
      i10 = 15;
      break L1;
     }
    case 5:
     {
      i10 = 16;
      break L1;
     }
    case 1:
    case 0:
     {
      i10 = 68;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i10 = 22;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    do if ((i3 | 0) > 3996) {
     i4 = (i4 | 0) / 4 | 0;
     i6 = i1 + (i4 << 2) | 0;
     i4 = i7 + (i4 << 2) | 0;
     i3 = __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i1, i6, i7, i4, i12) | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) {
      i5 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i5;
      i5 = i3 + 1 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
       i5 = HEAP32[i7 >> 2] | 0;
       HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i4 >> 2] = i5;
       i4 = i3 + 2 | 0;
       if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
        i5 = HEAP32[i6 >> 2] | 0;
        HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i7 >> 2] = i5;
        if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
         i5 = HEAP32[i1 >> 2] | 0;
         HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
         HEAP32[i6 >> 2] = i5;
         i3 = i3 + 4 | 0;
        } else i3 = i3 + 3 | 0;
       } else i3 = i4;
      } else i3 = i5;
     }
    } else {
     i6 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
     if (!i6) {
      if (!i3) {
       i3 = 0;
       break;
      }
      i6 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i6;
      if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i7 >> 2] = i3;
      i3 = 2;
      break;
     }
     i4 = HEAP32[i1 >> 2] | 0;
     if (i3) {
      HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i4;
      i3 = 1;
      break;
     }
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i7 >> 2] = i4;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0) {
      i3 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i11 >> 2] = i3;
      i3 = 2;
     } else i3 = 1;
    } while (0);
    if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) {
      i10 = 51;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i10 = 68;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i10 = 68;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i8;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i10 = 68;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i5 = i3 + 4 | 0;
      if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -4 | 0; while (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i10 | 0) == 51) {
    i10 = 0;
    i6 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i6;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L48 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    while (1) {
     i6 = i5 + 4 | 0;
     if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) i5 = i6; else break;
    }
    do i4 = i4 + -4 | 0; while (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0));
    if (i5 >>> 0 > i4 >>> 0) {
     i4 = i7;
     break L48;
    }
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
    i5 = i6;
    i3 = i3 + 1 | 0;
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) {
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbP10GUIElementS2_EPS2_EEbT0_S7_T_(i1, i5, i12) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbP10GUIElementS2_EPS2_EEbT0_S7_T_(i4, i2, i12) | 0) {
     i10 = 67;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i8 | 0) >= (i9 - i13 | 0)) {
    i10 = 66;
    break;
   }
   __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i1, i5, i12);
   i1 = i5 + 4 | 0;
  }
  if ((i10 | 0) == 66) {
   i10 = 0;
   __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i5 + 4 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i10 | 0) == 67) {
   i10 = 0;
   if (i3) {
    i10 = 68;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i10 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 7) {
  i2 = i1 + 4 | 0;
  i13 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  i3 = mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  if (!i13) {
   if (!i3) return;
   i13 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i13;
   if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
   i13 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i13;
   return;
  }
  i4 = HEAP32[i1 >> 2] | 0;
  if (i3) {
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i4;
   return;
  }
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i4 | 0) | 0)) return;
  i13 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 15) {
  __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i11, i12) | 0;
  return;
 } else if ((i10 | 0) == 16) {
  i2 = i1 + 4 | 0;
  i3 = i1 + 8 | 0;
  i4 = i1 + 12 | 0;
  __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i1, i2, i3, i4, i12) | 0;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i13;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i3 >> 2] | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i13;
  HEAP32[i4 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i2 >> 2] | 0) | 0)) return;
  i11 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i3 >> 2] = i11;
  if (!(mftCall_iii(HEAP32[i12 >> 2] | 0, i13 | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i13;
  return;
 } else if ((i10 | 0) == 22) {
  __ZNSt3__218__insertion_sort_3IRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i1, i2, i12);
  return;
 } else if ((i10 | 0) == 68) return;
}

function __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i1, i37, i48, i49, i50, i51) {
 i1 = i1 | 0;
 i37 = i37 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i53 + 176 | 0;
 i45 = i53 + 112 | 0;
 i46 = i53 + 48 | 0;
 i44 = i53 + 276 | 0;
 i52 = i53 + 32 | 0;
 i42 = i53 + 264 | 0;
 i38 = i53 + 16 | 0;
 i39 = i53;
 i27 = i53 + 252 | 0;
 i43 = i53 + 240 | 0;
 HEAP32[i44 >> 2] = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i37 >> 2]);
 f9 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f8 = Math_fround(f2 - f8);
 f9 = Math_fround(f28 - f9);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i37 + 8 >> 2]));
 i40 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f8 = i40 ? f8 : Math_fround(1.0);
 f9 = i40 ? f9 : Math_fround(0.0);
 f10 = i40 ? f10 : Math_fround(0.0);
 HEAPF32[i52 >> 2] = f8;
 i40 = i52 + 4 | 0;
 HEAPF32[i40 >> 2] = f9;
 i41 = i52 + 8 | 0;
 HEAPF32[i41 >> 2] = f10;
 HEAPF32[i52 + 12 >> 2] = Math_fround(0.0);
 f28 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i37 + 32 >> 2]);
 f28 = Math_fround((f28 > f2 ? f2 : f28) * Math_fround(.100000001));
 f28 = Math_fround(f28 * f28);
 i29 = i1 + 96 | 0;
 i30 = i1 + 100 | 0;
 i31 = i1 + 104 | 0;
 i32 = i1 + 112 | 0;
 i33 = i1 + 116 | 0;
 i34 = i1 + 120 | 0;
 i35 = i1 + 128 | 0;
 i36 = i1 + 132 | 0;
 i7 = i1 + 136 | 0;
 i17 = i38 + 4 | 0;
 i18 = i38 + 8 | 0;
 i19 = i39 + 4 | 0;
 i20 = i39 + 8 | 0;
 i21 = i39 + 12 | 0;
 i22 = i47 + 4 | 0;
 i23 = i47 + 8 | 0;
 i24 = i47 + 16 | 0;
 i25 = i47 + 20 | 0;
 i26 = i47 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  f6 = Math_fround(-f8);
  f5 = Math_fround(-f9);
  f4 = Math_fround(-f10);
  f56 = Math_fround(HEAPF32[i29 >> 2]);
  f16 = Math_fround(HEAPF32[i30 >> 2]);
  f11 = Math_fround(HEAPF32[i31 >> 2]);
  f55 = Math_fround(HEAPF32[i32 >> 2]);
  f12 = Math_fround(HEAPF32[i33 >> 2]);
  f3 = Math_fround(HEAPF32[i34 >> 2]);
  f13 = Math_fround(HEAPF32[i35 >> 2]);
  f14 = Math_fround(HEAPF32[i36 >> 2]);
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  f59 = Math_fround(Math_fround(Math_fround(f56 * f6) + Math_fround(f16 * f5)) + Math_fround(f11 * f4));
  f58 = Math_fround(Math_fround(Math_fround(f55 * f6) + Math_fround(f12 * f5)) + Math_fround(f3 * f4));
  f57 = Math_fround(Math_fround(Math_fround(f13 * f6) + Math_fround(f14 * f5)) + Math_fround(f15 * f4));
  i54 = f59 > f58 & f59 > f57;
  i1 = f58 > f57;
  f13 = i54 ? f56 : i1 ? f55 : f13;
  f14 = i54 ? f16 : i1 ? f12 : f14;
  f15 = i54 ? f11 : i1 ? f3 : f15;
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i38, i37, i52);
  f3 = Math_fround(HEAPF32[i38 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f3 = Math_fround(f13 - f3);
  f11 = Math_fround(f14 - f11);
  f12 = Math_fround(f15 - Math_fround(HEAPF32[i18 >> 2]));
  f16 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f8 * f3) + Math_fround(f9 * f11)) + Math_fround(f12 * f10)));
  i1 = HEAP32[i44 >> 2] | 0;
  HEAPF32[i45 + (i1 << 4) >> 2] = f13;
  HEAPF32[i45 + (i1 << 4) + 4 >> 2] = f14;
  HEAPF32[i45 + (i1 << 4) + 8 >> 2] = f15;
  HEAPF32[i45 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i54 = i46 + (i1 << 4) | 0;
  HEAP32[i54 >> 2] = HEAP32[i38 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
  HEAP32[i54 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
  HEAPF32[i47 + (i1 << 4) >> 2] = f3;
  HEAPF32[i47 + (i1 << 4) + 4 >> 2] = f11;
  HEAPF32[i47 + (i1 << 4) + 8 >> 2] = f12;
  HEAPF32[i47 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f16) {
   i7 = 3;
   break;
  }
  HEAP32[i44 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i39 >> 2] = f3;
    HEAPF32[i19 >> 2] = f11;
    HEAPF32[i20 >> 2] = f12;
    HEAPF32[i21 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i47 >> 2]);
    f11 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(HEAPF32[i23 >> 2]);
    f13 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f3);
    f14 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f11);
    f15 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f12);
    f16 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
    if (!(f16 <= Math_fround(1.1920929e-07))) {
     f57 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f11 * f14)) - Math_fround(f3 * f13)) - Math_fround(f12 * f15)) / f16);
     i54 = f57 > Math_fround(1.0);
     f57 = i54 ? Math_fround(1.0) : f57;
     i54 = f57 > Math_fround(0.0);
     f57 = i54 ? f57 : Math_fround(0.0);
     f58 = Math_fround(f11 + Math_fround(f14 * f57));
     f59 = Math_fround(f12 + Math_fround(f15 * f57));
     HEAPF32[i39 >> 2] = Math_fround(f3 + Math_fround(f13 * f57));
     HEAPF32[i19 >> 2] = f58;
     HEAPF32[i20 >> 2] = f59;
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i44 >> 2] = 1;
     HEAP32[i39 >> 2] = HEAP32[i47 >> 2];
     HEAP32[i39 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
     HEAP32[i39 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
     HEAP32[i39 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i39, i47, i45, i46, i44);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i39, i47, i45, i46, i44);
    break;
   }
  default:
   {
    HEAPF32[i39 >> 2] = f3;
    HEAPF32[i19 >> 2] = f11;
    HEAPF32[i20 >> 2] = f12;
    HEAPF32[i21 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i52 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i52 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i52 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAP32[i52 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  f11 = Math_fround(HEAPF32[i52 >> 2]);
  f12 = Math_fround(HEAPF32[i40 >> 2]);
  f13 = Math_fround(HEAPF32[i41 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
  HEAP32[i42 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i42 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i42 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  i1 = f2 > f3;
  if (f3 > f28 & i1) {
   f2 = f3;
   f8 = f11;
   f9 = f12;
   f10 = f13;
  } else {
   i7 = 13;
   break;
  }
 }
 if ((i7 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i47, i45, i46, i52, i48, i49, i1);
  f56 = Math_fround(HEAPF32[i52 >> 2]);
  f58 = Math_fround(HEAPF32[i40 >> 2]);
  f59 = Math_fround(HEAPF32[i41 >> 2]);
  f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f56 * f56) + Math_fround(f58 * f58)) + Math_fround(f59 * f59)))));
  f58 = Math_fround(-Math_fround(f58 * f57));
  f59 = Math_fround(-Math_fround(f59 * f57));
  HEAPF32[i50 >> 2] = Math_fround(-Math_fround(f56 * f57));
  HEAPF32[i50 + 4 >> 2] = f58;
  HEAPF32[i50 + 8 >> 2] = f59;
  HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i51 >> 2] = f2;
  i54 = i51 + 4 | 0;
  HEAP32[i54 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  i54 = 0;
  STACKTOP = i53;
  return i54 | 0;
 } else if ((i7 | 0) == 13) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i47, i45, i46, i52, i48, i49, HEAP32[i44 >> 2] | 0);
  f57 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)))));
  f58 = Math_fround(f57 * f5);
  f59 = Math_fround(f57 * f4);
  HEAPF32[i50 >> 2] = Math_fround(f57 * f6);
  HEAPF32[i50 + 4 >> 2] = f58;
  HEAPF32[i50 + 8 >> 2] = f59;
  HEAPF32[i50 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i51 >> 2] = i1 ? f3 : f2;
  i54 = i51 + 4 | 0;
  HEAP32[i54 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  i54 = i1 ? 1 : 3;
  STACKTOP = i53;
  return i54 | 0;
 }
 return 0;
}

function _check_header(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = i11 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if (i2 >>> 0 < 2) {
  if (!i2) i4 = i11 + 68 | 0; else {
   i4 = i11 + 68 | 0;
   HEAP8[HEAP32[i4 >> 2] >> 0] = HEAP8[HEAP32[i11 >> 2] >> 0] | 0;
  }
  HEAP32[(___errno_location() | 0) >> 2] = 0;
  i3 = i11 + 64 | 0;
  i1 = _fread((HEAP32[i4 >> 2] | 0) + i2 | 0, 1, 16384 >>> i2, HEAP32[i3 >> 2] | 0) | 0;
  if (!i1) if (_ferror(HEAP32[i3 >> 2] | 0) | 0) HEAP32[i11 + 56 >> 2] = -1;
  i2 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
  HEAP32[i12 >> 2] = i2;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  if (i2 >>> 0 >= 2) {
   i10 = i11;
   break;
  }
  HEAP32[i11 + 88 >> 2] = i2;
  return;
 } else {
  i10 = i11;
  i1 = HEAP32[i11 >> 2] | 0;
 } while (0);
 if ((HEAP8[i1 >> 0] | 0) == 31) if ((HEAP8[i1 + 1 >> 0] | 0) == -117) {
  i2 = i2 + -2 | 0;
  HEAP32[i12 >> 2] = i2;
  i1 = i1 + 2 | 0;
  HEAP32[i10 >> 2] = i1;
  i9 = i11 + 60 | 0;
  L20 : do if (!(HEAP32[i9 >> 2] | 0)) {
   do if (!i2) {
    HEAP32[(___errno_location() | 0) >> 2] = 0;
    i1 = i11 + 68 | 0;
    i2 = i11 + 64 | 0;
    i3 = _fread(HEAP32[i1 >> 2] | 0, 1, 16384, HEAP32[i2 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i3;
    if (i3 | 0) {
     i8 = HEAP32[i1 >> 2] | 0;
     HEAP32[i11 >> 2] = i8;
     i4 = HEAP32[i9 >> 2] | 0;
     i2 = i3;
     i3 = i8;
     break;
    }
    HEAP32[i9 >> 2] = 1;
    if (!(_ferror(HEAP32[i2 >> 2] | 0) | 0)) break L20;
    HEAP32[i11 + 56 >> 2] = -1;
    break L20;
   } else {
    i4 = 0;
    i3 = i1;
   } while (0);
   i1 = i2 + -1 | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i10 >> 2] = i3 + 1;
   i5 = HEAP8[i3 >> 0] | 0;
   if (!i4) {
    do if (!i1) {
     HEAP32[(___errno_location() | 0) >> 2] = 0;
     i2 = i11 + 68 | 0;
     i3 = i11 + 64 | 0;
     i1 = _fread(HEAP32[i2 >> 2] | 0, 1, 16384, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i12 >> 2] = i1;
     if (i1 | 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      HEAP32[i11 >> 2] = i2;
      break;
     }
     HEAP32[i9 >> 2] = 1;
     if (!(_ferror(HEAP32[i3 >> 2] | 0) | 0)) break L20;
     HEAP32[i11 + 56 >> 2] = -1;
     break L20;
    } else i2 = HEAP32[i10 >> 2] | 0; while (0);
    i3 = i1 + -1 | 0;
    HEAP32[i12 >> 2] = i3;
    HEAP32[i10 >> 2] = i2 + 1;
    i6 = HEAPU8[i2 >> 0] | 0;
    if (i5 << 24 >> 24 == 8 & (i6 & 224 | 0) == 0) {
     i5 = i11 + 68 | 0;
     i7 = i11 + 64 | 0;
     i8 = i11 + 56 | 0;
     i4 = 0;
     i1 = i3;
     i2 = i3;
     do {
      L41 : do if (!(HEAP32[i9 >> 2] | 0)) {
       do if (!i2) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
        HEAP32[i12 >> 2] = i1;
        if (i1 | 0) {
         i2 = HEAP32[i5 >> 2] | 0;
         HEAP32[i11 >> 2] = i2;
         break;
        }
        HEAP32[i9 >> 2] = 1;
        if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) {
         i1 = 0;
         i2 = 0;
         break L41;
        }
        HEAP32[i8 >> 2] = -1;
        i1 = 0;
        i2 = 0;
        break L41;
       } else {
        i1 = i2;
        i2 = HEAP32[i10 >> 2] | 0;
       } while (0);
       i3 = i1 + -1 | 0;
       HEAP32[i12 >> 2] = i3;
       HEAP32[i10 >> 2] = i2 + 1;
       i1 = i3;
       i2 = i3;
      } while (0);
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != 6);
     L53 : do if (i6 & 4) {
      L55 : do if (!(HEAP32[i9 >> 2] | 0)) {
       do if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
        HEAP32[i12 >> 2] = i1;
        if (i1 | 0) {
         i2 = HEAP32[i5 >> 2] | 0;
         HEAP32[i11 >> 2] = i2;
         i4 = HEAP32[i9 >> 2] | 0;
         break;
        }
        HEAP32[i9 >> 2] = 1;
        if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) {
         i3 = -1;
         i2 = -1;
         i1 = 0;
         break L55;
        }
        HEAP32[i8 >> 2] = -1;
        i3 = -1;
        i2 = -1;
        i1 = 0;
        break L55;
       } else {
        i4 = 0;
        i2 = HEAP32[i10 >> 2] | 0;
       } while (0);
       i1 = i1 + -1 | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i10 >> 2] = i2 + 1;
       i3 = HEAPU8[i2 >> 0] | 0;
       if (!i4) {
        do if (!i1) {
         HEAP32[(___errno_location() | 0) >> 2] = 0;
         i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
         HEAP32[i12 >> 2] = i1;
         if (i1 | 0) {
          i2 = HEAP32[i5 >> 2] | 0;
          HEAP32[i11 >> 2] = i2;
          break;
         }
         HEAP32[i9 >> 2] = 1;
         if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) {
          i2 = -1;
          i1 = 0;
          break L55;
         }
         HEAP32[i8 >> 2] = -1;
         i2 = -1;
         i1 = 0;
         break L55;
        } else i2 = HEAP32[i10 >> 2] | 0; while (0);
        i1 = i1 + -1 | 0;
        HEAP32[i12 >> 2] = i1;
        HEAP32[i10 >> 2] = i2 + 1;
        i2 = HEAPU8[i2 >> 0] | 0;
       } else i2 = -1;
      } else {
       i3 = -1;
       i2 = -1;
      } while (0);
      i2 = (i2 << 8) + i3 | 0;
      if (i2) {
       while (1) {
        i2 = i2 + -1 | 0;
        if (HEAP32[i9 >> 2] | 0) break L53;
        if (!i1) {
         HEAP32[(___errno_location() | 0) >> 2] = 0;
         i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
         HEAP32[i12 >> 2] = i1;
         if (!i1) break;
         i3 = HEAP32[i5 >> 2] | 0;
         HEAP32[i11 >> 2] = i3;
        } else i3 = HEAP32[i10 >> 2] | 0;
        i1 = i1 + -1 | 0;
        HEAP32[i12 >> 2] = i1;
        HEAP32[i10 >> 2] = i3 + 1;
        if (!i2) break L53;
       }
       HEAP32[i9 >> 2] = 1;
       if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) i1 = 0; else {
        HEAP32[i8 >> 2] = -1;
        i1 = 0;
       }
      }
     } while (0);
     L86 : do if (i6 & 8) {
      while (1) {
       if (HEAP32[i9 >> 2] | 0) break L86;
       if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
        HEAP32[i12 >> 2] = i1;
        if (!i1) break;
        i2 = HEAP32[i5 >> 2] | 0;
        HEAP32[i11 >> 2] = i2;
       } else i2 = HEAP32[i10 >> 2] | 0;
       i1 = i1 + -1 | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i10 >> 2] = i2 + 1;
       if (!(HEAP8[i2 >> 0] | 0)) break L86;
      }
      HEAP32[i9 >> 2] = 1;
      if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) i1 = 0; else {
       HEAP32[i8 >> 2] = -1;
       i1 = 0;
      }
     } while (0);
     L98 : do if (i6 & 16) {
      while (1) {
       if (HEAP32[i9 >> 2] | 0) break L98;
       if (!i1) {
        HEAP32[(___errno_location() | 0) >> 2] = 0;
        i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
        HEAP32[i12 >> 2] = i1;
        if (!i1) break;
        i2 = HEAP32[i5 >> 2] | 0;
        HEAP32[i11 >> 2] = i2;
       } else i2 = HEAP32[i10 >> 2] | 0;
       i1 = i1 + -1 | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i10 >> 2] = i2 + 1;
       if (!(HEAP8[i2 >> 0] | 0)) break L98;
      }
      HEAP32[i9 >> 2] = 1;
      if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) i1 = 0; else {
       HEAP32[i8 >> 2] = -1;
       i1 = 0;
      }
     } while (0);
     L110 : do if (i6 & 2 | 0) if (!(HEAP32[i9 >> 2] | 0)) {
      do if (!i1) {
       HEAP32[(___errno_location() | 0) >> 2] = 0;
       i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
       HEAP32[i12 >> 2] = i1;
       if (i1 | 0) {
        i4 = HEAP32[i5 >> 2] | 0;
        HEAP32[i11 >> 2] = i4;
        i6 = HEAP32[i9 >> 2] | 0;
        i1 = i1 + -1 | 0;
        HEAP32[i12 >> 2] = i1;
        HEAP32[i10 >> 2] = i4 + 1;
        if (!i6) break; else break L110;
       }
       HEAP32[i9 >> 2] = 1;
       if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) break L110;
       HEAP32[i8 >> 2] = -1;
       break L110;
      } else {
       i6 = HEAP32[i10 >> 2] | 0;
       i1 = i1 + -1 | 0;
       HEAP32[i12 >> 2] = i1;
       HEAP32[i10 >> 2] = i6 + 1;
      } while (0);
      do if (!i1) {
       HEAP32[(___errno_location() | 0) >> 2] = 0;
       i1 = _fread(HEAP32[i5 >> 2] | 0, 1, 16384, HEAP32[i7 >> 2] | 0) | 0;
       HEAP32[i12 >> 2] = i1;
       if (i1 | 0) {
        i2 = HEAP32[i5 >> 2] | 0;
        HEAP32[i11 >> 2] = i2;
        break;
       }
       HEAP32[i9 >> 2] = 1;
       if (!(_ferror(HEAP32[i7 >> 2] | 0) | 0)) break L110;
       HEAP32[i8 >> 2] = -1;
       break L110;
      } else i2 = HEAP32[i10 >> 2] | 0; while (0);
      HEAP32[i12 >> 2] = i1 + -1;
      HEAP32[i10 >> 2] = i2 + 1;
     } while (0);
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2] | 0 ? -3 : 0;
     return;
    }
   }
  } while (0);
  HEAP32[i11 + 56 >> 2] = -3;
  return;
 }
 HEAP32[i11 + 88 >> 2] = 1;
 return;
}

function __ZL18getFrictionPatchesRN5physx26PxcFrictionPatchStreamPairERNS_20PxcCorrelationBufferEPKhjRKNS_11PxTransformES8_f(i27, i4, i3, i1, i2, f28) {
 i27 = i27 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f28 = Math_fround(f28);
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 if (!i4) {
  i27 = 1;
  return i27 | 0;
 }
 f8 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f21 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f31 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f18 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f30 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f29 = Math_fround(f29 * Math_fround(2.0));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f30 = Math_fround(Math_fround(f30 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
 f26 = Math_fround(Math_fround(Math_fround(f29 * f8) + Math_fround(f18 * f10)) + Math_fround(f30 * f21));
 f24 = Math_fround(Math_fround(f26 * f8) + Math_fround(Math_fround(f22 * f29) + Math_fround(f31 * Math_fround(Math_fround(f30 * f10) - Math_fround(f18 * f21)))));
 f25 = Math_fround(Math_fround(f26 * f10) + Math_fround(Math_fround(f22 * f18) + Math_fround(f31 * Math_fround(Math_fround(f29 * f21) - Math_fround(f30 * f8)))));
 f26 = Math_fround(Math_fround(Math_fround(f22 * f30) + Math_fround(f31 * Math_fround(Math_fround(f18 * f8) - Math_fround(f29 * f10)))) + Math_fround(f26 * f21));
 f29 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(f31 * f29);
 f30 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f30 * f8));
 f22 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f22 * f10));
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(f18 - Math_fround(f9 * f21));
 f19 = Math_fround(Math_fround(Math_fround(f29 * f21) + Math_fround(Math_fround(f30 * f10) + Math_fround(f31 * f9))) - Math_fround(f22 * f8));
 f20 = Math_fround(Math_fround(Math_fround(f9 * f8) + Math_fround(Math_fround(f30 * f21) + Math_fround(f31 * f22))) - Math_fround(f29 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f30) - Math_fround(f29 * f8)) - Math_fround(f9 * f10)) - Math_fround(f22 * f21));
 if (!i3) {
  i27 = 1;
  return i27 | 0;
 }
 f22 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 i23 = i27 + 4232 | 0;
 L7 : while (1) {
  i3 = i3 + -1 | 0;
  i6 = i4 + 96 | 0;
  do if (!(HEAP8[i4 >> 0] | 0)) {
   i7 = i4 + 16 | 0;
   i1 = HEAP16[i7 >> 1] | 0;
   if (i1 << 16 >> 16) {
    f8 = Math_fround(HEAPF32[i4 + 24 >> 2]);
    f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    f10 = Math_fround(HEAPF32[i4 + 32 >> 2]);
    i11 = i4 + 36 | 0;
    f30 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(2.0));
    i12 = i4 + 40 | 0;
    f29 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
    i13 = i4 + 44 | 0;
    f31 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(2.0));
    f32 = Math_fround(Math_fround(Math_fround(f18 * f30) + Math_fround(f19 * f29)) + Math_fround(f20 * f31));
    if (Math_fround(Math_fround(f10 * Math_fround(Math_fround(Math_fround(f22 * f31) + Math_fround(f21 * Math_fround(Math_fround(f18 * f29) - Math_fround(f19 * f30)))) + Math_fround(f20 * f32))) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f18 * f32) + Math_fround(Math_fround(f22 * f30) + Math_fround(f21 * Math_fround(Math_fround(f19 * f31) - Math_fround(f20 * f29)))))) + Math_fround(f9 * Math_fround(Math_fround(f19 * f32) + Math_fround(Math_fround(f22 * f29) + Math_fround(f21 * Math_fround(Math_fround(f20 * f30) - Math_fround(f18 * f31)))))))) > Math_fround(.999000012)) {
     i14 = i4 + 48 | 0;
     i15 = i4 + 72 | 0;
     f31 = Math_fround(HEAPF32[i15 >> 2]);
     i2 = i4 + 76 | 0;
     f30 = Math_fround(HEAPF32[i2 >> 2]);
     i5 = i4 + 80 | 0;
     f32 = Math_fround(HEAPF32[i5 >> 2]);
     f34 = Math_fround(HEAPF32[i14 >> 2]);
     i16 = i4 + 52 | 0;
     f33 = Math_fround(HEAPF32[i16 >> 2]);
     i17 = i4 + 56 | 0;
     f31 = Math_fround(f31 * Math_fround(2.0));
     f30 = Math_fround(f30 * Math_fround(2.0));
     f32 = Math_fround(f32 * Math_fround(2.0));
     f29 = Math_fround(Math_fround(Math_fround(f18 * f31) + Math_fround(f19 * f30)) + Math_fround(f20 * f32));
     if (Math_fround(Math_abs(Math_fround(Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i17 >> 2]) - Math_fround(f26 + Math_fround(Math_fround(Math_fround(f22 * f32) + Math_fround(f21 * Math_fround(Math_fround(f18 * f30) - Math_fround(f19 * f31)))) + Math_fround(f20 * f29))))) + Math_fround(Math_fround(f8 * Math_fround(f34 - Math_fround(f24 + Math_fround(Math_fround(f18 * f29) + Math_fround(Math_fround(f22 * f31) + Math_fround(f21 * Math_fround(Math_fround(f19 * f32) - Math_fround(f20 * f30)))))))) + Math_fround(f9 * Math_fround(f33 - Math_fround(f25 + Math_fround(Math_fround(f19 * f29) + Math_fround(Math_fround(f22 * f30) + Math_fround(f21 * Math_fround(Math_fround(f20 * f31) - Math_fround(f18 * f32)))))))))))) < f28) {
      if (i1 << 16 >> 16 == 2) {
       f33 = Math_fround(HEAPF32[i4 + 84 >> 2]);
       f32 = Math_fround(HEAPF32[i4 + 88 >> 2]);
       f34 = Math_fround(HEAPF32[i4 + 92 >> 2]);
       f29 = Math_fround(HEAPF32[i4 + 60 >> 2]);
       f30 = Math_fround(HEAPF32[i4 + 64 >> 2]);
       f33 = Math_fround(f33 * Math_fround(2.0));
       f32 = Math_fround(f32 * Math_fround(2.0));
       f34 = Math_fround(f34 * Math_fround(2.0));
       f31 = Math_fround(Math_fround(Math_fround(f18 * f33) + Math_fround(f19 * f32)) + Math_fround(f20 * f34));
       if (!(Math_fround(Math_abs(Math_fround(Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i4 + 68 >> 2]) - Math_fround(f26 + Math_fround(Math_fround(Math_fround(f22 * f34) + Math_fround(f21 * Math_fround(Math_fround(f18 * f32) - Math_fround(f19 * f33)))) + Math_fround(f20 * f31))))) + Math_fround(Math_fround(f8 * Math_fround(f29 - Math_fround(f24 + Math_fround(Math_fround(f18 * f31) + Math_fround(Math_fround(f22 * f33) + Math_fround(f21 * Math_fround(Math_fround(f19 * f34) - Math_fround(f20 * f32)))))))) + Math_fround(f9 * Math_fround(f30 - Math_fround(f25 + Math_fround(Math_fround(f19 * f31) + Math_fround(Math_fround(f22 * f32) + Math_fround(f21 * Math_fround(Math_fround(f20 * f33) - Math_fround(f18 * f34)))))))))))) < f28)) break;
      }
      i1 = HEAP32[i23 >> 2] | 0;
      if ((i1 | 0) == 32) {
       i1 = 0;
       i2 = 13;
       break L7;
      }
      HEAP16[i27 + 4100 + (i1 << 2) >> 1] = -1;
      HEAP16[i27 + 4100 + (HEAP32[i23 >> 2] << 2) + 2 >> 1] = -1;
      i1 = HEAP32[i23 >> 2] | 0;
      HEAP32[i23 >> 2] = i1 + 1;
      HEAP8[i27 + 768 + (i1 * 96 | 0) >> 0] = 0;
      HEAP16[i27 + 768 + (i1 * 96 | 0) + 16 >> 1] = HEAP16[i7 >> 1] | 0;
      HEAPF32[i27 + 768 + (i1 * 96 | 0) + 24 >> 2] = f8;
      HEAPF32[i27 + 768 + (i1 * 96 | 0) + 28 >> 2] = f9;
      HEAPF32[i27 + 768 + (i1 * 96 | 0) + 32 >> 2] = f10;
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 36 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 40 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 44 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 48 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 52 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 56 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 60 >> 2] = HEAP32[i4 + 60 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 64 >> 2] = HEAP32[i4 + 64 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 68 >> 2] = HEAP32[i4 + 68 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 72 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 76 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 80 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 84 >> 2] = HEAP32[i4 + 84 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 88 >> 2] = HEAP32[i4 + 88 >> 2];
      HEAP32[i27 + 768 + (i1 * 96 | 0) + 92 >> 2] = HEAP32[i4 + 92 >> 2];
      HEAP16[i27 + 768 + (i1 * 96 | 0) + 20 >> 1] = HEAP16[i4 + 20 >> 1] | 0;
      HEAP16[i27 + 768 + (i1 * 96 | 0) + 18 >> 1] = HEAP16[i4 + 18 >> 1] | 0;
      HEAP16[i27 + 768 + (i1 * 96 | 0) + 22 >> 1] = HEAP16[i4 + 22 >> 1] | 0;
     }
    }
   }
  } while (0);
  if (!i3) {
   i1 = 1;
   i2 = 13;
   break;
  } else i4 = i6;
 }
 if ((i2 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryE(i26, i27) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i33 + 98 | 0;
 i32 = i33 + 64 | 0;
 i28 = i33 + 48 | 0;
 i16 = i33 + 44 | 0;
 i17 = i33 + 40 | 0;
 i13 = i33 + 36 | 0;
 i19 = i33 + 32 | 0;
 i14 = i33 + 28 | 0;
 i20 = i33 + 24 | 0;
 i11 = i33 + 20 | 0;
 i18 = i33 + 16 | 0;
 i12 = i33 + 12 | 0;
 i25 = i33 + 8 | 0;
 i29 = i33 + 96 | 0;
 i24 = i33 + 4 | 0;
 i23 = i33;
 HEAP32[i32 >> 2] = gb + 120080 + 8;
 i22 = i32 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i22 + 16 >> 2] = 0;
 HEAP32[i22 + 20 >> 2] = 0;
 __ZNK5physx2Sn21SerializationRegistry17getBinaryMetaDataERNS_14PxOutputStreamE(i27, i32);
 HEAP32[i28 >> 2] = 0;
 i22 = i28 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i30 = i28 + 8 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i32 + 4 | 0;
 i15 = HEAP32[i32 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i15;
 i10 = HEAP32[i31 >> 2] | 0;
 if (i15 | 0) {
  i15 = 0;
  do {
   i9 = i10 + (i15 << 5) | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   L4 : do if (!i4) i1 = -1; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i8 = HEAP32[i28 >> 2] | 0;
    L6 : do if (i1 | 0) {
     i6 = i1;
     i7 = i8;
     while (1) {
      if (!(_strcmp(i7, i4) | 0)) {
       i1 = i7;
       break;
      } else i3 = i7;
      while (1) {
       i2 = i3 + 1 | 0;
       if (!(HEAP8[i3 >> 0] | 0)) {
        i3 = i2;
        break;
       } else i3 = i2;
      }
      i5 = i3;
      i2 = i7 + i6 | 0;
      if ((i2 | 0) == (i5 | 0)) break L6; else {
       i6 = i2 - i5 | 0;
       i7 = i3;
      }
     }
     i1 = i1 - i8 | 0;
     break L4;
    } while (0);
    i3 = HEAP8[i4 >> 0] | 0;
    if (!(i3 << 24 >> 24)) i2 = i1; else {
     i2 = i1;
     do {
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
       HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = i3;
       HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i4) | 0;
      i4 = i4 + 1 | 0;
      i3 = HEAP8[i4 >> 0] | 0;
      i2 = HEAP32[i22 >> 2] | 0;
     } while (i3 << 24 >> 24 != 0);
    }
    HEAP8[i21 >> 0] = 0;
    if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i21) | 0;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i1;
   i9 = i10 + (i15 << 5) + 4 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   L26 : do if (!i4) i1 = -1; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i8 = HEAP32[i28 >> 2] | 0;
    L28 : do if (i1 | 0) {
     i6 = i1;
     i7 = i8;
     while (1) {
      if (!(_strcmp(i7, i4) | 0)) {
       i1 = i7;
       break;
      } else i3 = i7;
      while (1) {
       i2 = i3 + 1 | 0;
       if (!(HEAP8[i3 >> 0] | 0)) {
        i3 = i2;
        break;
       } else i3 = i2;
      }
      i5 = i3;
      i2 = i7 + i6 | 0;
      if ((i2 | 0) == (i5 | 0)) break L28; else {
       i6 = i2 - i5 | 0;
       i7 = i3;
      }
     }
     i1 = i1 - i8 | 0;
     break L26;
    } while (0);
    i3 = HEAP8[i4 >> 0] | 0;
    if (!(i3 << 24 >> 24)) i2 = i1; else {
     i2 = i1;
     do {
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
       HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = i3;
       HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i4) | 0;
      i4 = i4 + 1 | 0;
      i3 = HEAP8[i4 >> 0] | 0;
      i2 = HEAP32[i22 >> 2] | 0;
     } while (i3 << 24 >> 24 != 0);
    }
    HEAP8[i21 >> 0] = 0;
    if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i21) | 0;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i1;
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
 }
 HEAP32[i17 >> 2] = __ZN5physx2Sn20getBinaryPlatformTagEv() | 0;
 HEAP32[i13 >> 2] = 32;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i14 >> 2] = 1096041805;
 HEAP32[i20 >> 2] = 50529024;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i18 >> 2] = 4;
 HEAP32[i12 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i14 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i20 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i11 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i12 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i18 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i17 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i13 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i19 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i16 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i10 | 0, HEAP32[i16 >> 2] << 5 | 0) | 0;
 HEAP32[i25 >> 2] = HEAP32[i27 + 44 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i25 | 0, 4) | 0;
 if (HEAP32[i25 >> 2] | 0) {
  i9 = 0;
  do {
   HEAP16[i29 >> 1] = __ZNK5physx2Sn21SerializationRegistry17getSerializerTypeEj(i27, i9) | 0;
   i4 = __ZNK5physx2Sn21SerializationRegistry17getSerializerNameEj(i27, i9) | 0;
   L53 : do if (!i4) i1 = -1; else {
    i1 = HEAP32[i22 >> 2] | 0;
    i8 = HEAP32[i28 >> 2] | 0;
    L55 : do if (i1 | 0) {
     i6 = i1;
     i7 = i8;
     while (1) {
      if (!(_strcmp(i7, i4) | 0)) {
       i1 = i7;
       break;
      } else i3 = i7;
      while (1) {
       i2 = i3 + 1 | 0;
       if (!(HEAP8[i3 >> 0] | 0)) {
        i3 = i2;
        break;
       } else i3 = i2;
      }
      i5 = i3;
      i2 = i7 + i6 | 0;
      if ((i2 | 0) == (i5 | 0)) break L55; else {
       i6 = i2 - i5 | 0;
       i7 = i3;
      }
     }
     i1 = i1 - i8 | 0;
     break L53;
    } while (0);
    i3 = HEAP8[i4 >> 0] | 0;
    if (!(i3 << 24 >> 24)) i2 = i1; else {
     i2 = i1;
     do {
      if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
       HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = i3;
       HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
      } else __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i4) | 0;
      i4 = i4 + 1 | 0;
      i3 = HEAP8[i4 >> 0] | 0;
      i2 = HEAP32[i22 >> 2] | 0;
     } while (i3 << 24 >> 24 != 0);
    }
    HEAP8[i21 >> 0] = 0;
    if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP8[(HEAP32[i28 >> 2] | 0) + i2 >> 0] = 0;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i28, i21) | 0;
     break;
    }
   } while (0);
   HEAP32[i24 >> 2] = i1;
   mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i29 | 0, 2) | 0;
   mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i24 | 0, 4) | 0;
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
 }
 HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
 i1 = HEAP32[i28 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i23 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i1 | 0, HEAP32[i23 >> 2] | 0) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i30 = HEAP32[i30 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i30 | 0) < 0 | (i30 & 2147483647 | 0) == 0))) {
  i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
 }
 HEAP32[i32 >> 2] = gb + 120080 + 8;
 i30 = HEAP32[i32 + 24 >> 2] | 0;
 if ((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i32 + 16 >> 2] | 0;
  if (i1 | 0) {
   i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
  }
 }
 i32 = HEAP32[i32 + 12 >> 2] | 0;
 if (!((i32 | 0) > -1 & (i32 & 2147483647 | 0) != 0)) {
  STACKTOP = i33;
  return;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 if (!i1) {
  STACKTOP = i33;
  return;
 }
 i32 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, i1 | 0);
 STACKTOP = i33;
 return;
}

function __ZN17PrePassRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDS3_RS3_RK8Vector4fRK14LightingLayersR10MinMaxAABBb(i25, i8, i18, i6, i7, i19, i11, i12, i1, i13) {
 i25 = i25 | 0;
 i8 = i8 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i19 = i19 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, i30 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i24 + 240 | 0;
 i21 = i24 + 36 | 0;
 i2 = i24 + 236 | 0;
 i3 = i24 + 232 | 0;
 i15 = i24 + 16 | 0;
 i16 = i24;
 i17 = i24 + 32 | 0;
 if ((HEAP16[gb + 1115024 + 6 >> 1] | 0) > -1) {
  HEAP32[i21 >> 2] = HEAP32[(HEAP32[i25 >> 2] | 0) + 8 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i21 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115024 | 0, i14);
  i20 = gb + 1115024 | 0;
 } else i20 = 0;
 i22 = HEAP32[gb + 1115024 >> 2] | 0;
 i9 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 648 >> 2] | 0, i9 | 0, i22 | 0);
 i22 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 5;
 i9 = __Z18GetQualitySettingsv() | 0;
 i9 = HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0;
 i10 = __Z18GetQualitySettingsv() | 0;
 i10 = HEAP32[(HEAP32[i10 + 28 >> 2] | 0) + ((HEAP32[i10 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] | 0;
 i23 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(__ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 2) | 0, gb + 1115112 | 0, 2);
 if (HEAP32[gb + 1115112 >> 2] | 0) {
  __Z15InitLightMeshesv();
  if (!(HEAP8[gb + 1544231 >> 0] | 0)) {
   HEAP32[gb + 1115144 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115144 | 0, gb + 386617 | 0);
   HEAP8[gb + 1544231 >> 0] = 1;
  }
  if (!(HEAP8[gb + 1544232 >> 0] | 0)) {
   HEAP32[gb + 1115148 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115148 | 0, gb + 386637 | 0);
   HEAP8[gb + 1544232 >> 0] = 1;
  }
  if (!(HEAP8[gb + 1544233 >> 0] | 0)) {
   HEAP32[gb + 1115152 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115152 | 0, gb + 386659 | 0);
   HEAP8[gb + 1544233 >> 0] = 1;
  }
  if (!(HEAP8[gb + 1544234 >> 0] | 0)) {
   HEAP32[gb + 1115156 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115156 | 0, gb + 386683 | 0);
   HEAP8[gb + 1544234 >> 0] = 1;
  }
  i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 100 >> 2] | 0, i7 | 0) | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 104 >> 2] | 0, i7 | 0) | 0;
  i1 = i23 + 36 | 0;
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) {
   i30 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 >> 2] = i30;
   i29 = i18 + 68 | 0;
   f27 = Math_fround(HEAPF32[i29 >> 2]);
   i6 = i18 + 72 | 0;
   f28 = Math_fround(HEAPF32[i6 >> 2]);
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff(i1, gb + 1115144 | 0, i14, i4, i5, f27, f28);
   HEAP32[i3 >> 2] = i30;
   f28 = Math_fround(HEAPF32[i29 >> 2]);
   f27 = Math_fround(HEAPF32[i6 >> 2]);
   HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
   __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff(i1, gb + 1115152 | 0, i14, i4, i5, f28, f27);
  }
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i1, gb + 1115148 | 0, i7);
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i1, gb + 1115156 | 0, i7);
  i4 = __Z12GetGfxDevicev() | 0;
  i3 = __Z12GetGfxDevicev() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0, 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 148 >> 2] | 0, i4 | 0, 0);
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0;
  HEAP8[i14 >> 0] = 0;
  HEAP8[i14 + 1 >> 0] = -1;
  HEAP8[i14 + 2 >> 0] = -1;
  HEAP8[i14 + 3 >> 0] = 0;
  HEAP8[i14 + 4 >> 0] = 8;
  HEAP8[i14 + 5 >> 0] = 0;
  HEAP8[i14 + 6 >> 0] = 0;
  HEAP8[i14 + 7 >> 0] = 0;
  HEAP8[i14 + 8 >> 0] = 8;
  HEAP8[i14 + 9 >> 0] = 0;
  HEAP8[i14 + 10 >> 0] = 0;
  HEAP8[i14 + 11 >> 0] = 0;
  i3 = mftCall_iii(i3 | 0, i4 | 0, i14 | 0) | 0;
  __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i21, __Z12GetGfxDevicev() | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, gb + 1162292 | 0);
  i30 = HEAP32[i25 >> 2] | 0;
  i29 = HEAP32[i30 + 8 >> 2] | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i29 + 1136 | 0, 6, i23, HEAP32[i30 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i29 + 4 >> 2] | 0);
  i29 = HEAP32[i25 >> 2] | 0;
  i30 = HEAP32[i29 + 8 >> 2] | 0;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i30 + 1136 | 0, 6, i23, HEAP32[i29 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i30 + 4 >> 2] | 0);
  if ((HEAP32[i8 >> 2] | 0) > 0) {
   i2 = i8 + 4 | 0;
   i1 = 0;
   do {
    __ZL11RenderLightRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionRP13RenderTextureS9_iiPK18DeviceStencilStateRK10MinMaxAABBRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(HEAP32[i25 >> 2] | 0, (HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) | 0, i9, i10, i19, i18, i3, i21, i11, i12, i13, i23);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i8 >> 2] | 0));
  }
  i1 = i8 + 8 | 0;
  if (HEAP32[i1 >> 2] | 0) __ZL11RenderLightRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionRP13RenderTextureS9_iiPK18DeviceStencilStateRK10MinMaxAABBRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(HEAP32[i25 >> 2] | 0, i1, i9, i10, i19, i18, i3, i21, i11, i12, i13, i23);
  __Z20SetNoShadowsKeywordsR17ShaderPassContext(i23);
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i4 + 708 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 + 712 >> 2] = i1;
  HEAP32[i4 + 716 >> 2] = 1065353216;
  HEAP32[i4 + 720 >> 2] = 1065353216;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 72 >> 2] | 0, i4 | 0, i3 | 0, 0);
  i1 = HEAP32[i19 >> 2] | 0;
  if (!i1) {
   i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, 16, 16, 0, 0, 0, 1, 0, 1) | 0;
   HEAP32[i19 >> 2] = i1;
   if (!i1) i1 = 0; else {
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 388149 | 0);
    i1 = HEAP32[i19 >> 2] | 0;
   }
   __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
   HEAPF32[i15 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i15 + 12 >> 2] = Math_fround(1.0);
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i16 + 12 >> 2] = 0;
   __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(1, HEAP8[(HEAP32[(HEAP32[i25 >> 2] | 0) + 8 >> 2] | 0) + 1092 >> 0] | 0 ? i16 : i15, Math_fround(1.0), 0, i23);
   __Z15gpu_time_samplev();
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 344 >> 2] | 0;
   HEAP32[i17 >> 2] = HEAP32[i18 + 136 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
   mftCall_vii(i1 | 0, i4 | 0, i14 | 0);
   i1 = HEAP32[i19 >> 2] | 0;
   if (i1 | 0) i26 = 23;
  } else i26 = 23;
  if ((i26 | 0) == 23) __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[(HEAP32[i25 >> 2] | 0) + 1888 >> 2] | 0, 8, i1);
  i30 = HEAP32[i25 >> 2] | 0;
  i29 = HEAP32[i30 + 8 >> 2] | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i29 + 1136 | 0, 7, i23, HEAP32[i30 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i29 + 4 >> 2] | 0);
  i29 = HEAP32[i25 >> 2] | 0;
  i30 = HEAP32[i29 + 8 >> 2] | 0;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i30 + 1136 | 0, 7, i23, HEAP32[i29 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i30 + 4 >> 2] | 0);
  __ZN22DeviceMVPMatricesStateD2Ev(i21);
  i30 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 96 >> 2] | 0, i30 | 0, i5 | 0);
 }
 HEAP32[gb + 1163232 >> 2] = i22;
 i30 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i30 >> 2] | 0) + 652 >> 2] | 0, i30 | 0);
 if (!i20) {
  STACKTOP = i24;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i20);
 STACKTOP = i24;
 return;
}

function __ZN2UI6Canvas8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN2UI6Canvas10RenderModeEEvRT_RT0_PKc17TransferMetaFlags(i9, i7 + 36 | 0, gb + 1011343 | 0, 0);
 i2 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011356 | 0, gb + 1011365 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6CameraE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 364 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011378 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 360 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011394 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 362 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011409 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 375 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011426 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 361 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011444 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 404 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011467 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i6 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 59; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 368 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011497 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i6 = 70; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 70; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 70) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 372 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011514 | 0, HEAP32[gb + 37240 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i11 >>> 0) i6 = 81; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 81; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 81) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 374 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1011529 | 0, HEAP32[gb + 37252 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i11 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN9ShaderLab14SerializedPass8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i6 = i10;
 i2 = i8 + 860 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470760 | 0, HEAP32[gb + 37052 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab14SerializedPass8PassTypeEEvRT_RT0_PKc17TransferMetaFlags(i9, i8, gb + 913271 | 0, 0);
 i2 = i8 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470774 | 0, gb + 470782 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab21SerializedShaderState8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 724 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470804 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 740 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470818 | 0, gb + 470829 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470847 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 752 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470861 | 0, gb + 470829 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470847 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 764 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470874 | 0, gb + 470829 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470847 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 776 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470887 | 0, gb + 470829 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470847 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 788 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470896 | 0, gb + 470829 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470847 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 HEAP8[i6 >> 0] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470907 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 800 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470930 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 816 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034561 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 832 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470940 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 848 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 470710 | 0, gb + 470717 | 0, i7, 1) | 0;
 if (!i1) {
  __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i8);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i8);
 STACKTOP = i10;
 return;
}

function __ZN12CubemapArray8TransferI14SafeBinaryReadEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i13 = i15;
 __ZN7Texture8TransferI14SafeBinaryReadEEvRT_(i11, i12);
 i14 = i11 + 80 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 932215 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i8 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i14, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i14 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i8 = i11 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 397038 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags(i12, i11 + 88 | 0, gb + 410455 | 0, 0);
 i4 = i11 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 410444 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i11 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i7 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 39; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i11 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 431875 | 0, gb + 431893 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i12); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 932818 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i7 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i11 + 105 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i12, i13, gb + 411165 | 0, 1);
 i3 = i11 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i11 + 100 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i11 + 104 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i7 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 + 48 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  mftCall_vii(i6 | 0, i7 | 0, i9 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) {
  i10 = 0;
  HEAP32[i4 >> 2] = i10;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
  HEAP32[i3 >> 2] = i10;
  i14 = HEAP32[i14 >> 2] | 0;
  f16 = Math_fround(i14 | 0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  i14 = i11 + 68 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = i11 + 72 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i12, i14, i10, 0);
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  HEAP32[i4 >> 2] = i10;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
  HEAP32[i3 >> 2] = i10;
  i14 = HEAP32[i14 >> 2] | 0;
  f16 = Math_fround(i14 | 0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  i14 = i11 + 68 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = i11 + 72 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i12, i14, i10, 0);
  STACKTOP = i15;
  return;
 }
 i10 = (i2 >>> 0) / ((i1 * 6 | 0) >>> 0) | 0;
 HEAP32[i4 >> 2] = i10;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
 HEAP32[i3 >> 2] = i10;
 i14 = HEAP32[i14 >> 2] | 0;
 f16 = Math_fround(i14 | 0);
 f16 = Math_fround(Math_fround(1.0) / f16);
 i14 = i11 + 68 | 0;
 HEAPF32[i14 >> 2] = f16;
 i14 = i11 + 72 | 0;
 HEAPF32[i14 >> 2] = f16;
 i14 = HEAP32[i13 >> 2] | 0;
 __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i12, i14, i10, 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx27updateIslandsSecondPassMainEjRNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjjRNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS0_13EventProfilerE(i48, i5, i1, i2, i6, i7, i9, i8, i10, i4, i3) {
 i48 = i48 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0;
 i39 = HEAP32[i4 + 72 >> 2] | 0;
 _memset(HEAP32[i39 >> 2] | 0, 0, HEAP32[i39 + 4 >> 2] << 2 | 0) | 0;
 __ZL28removeBrokenEdgesFromIslandsPKjjS0_jS0_RKN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerERNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEEPSD_(i1, i2, 0, 0, HEAP32[i4 >> 2] | 0, i6, i7, i9, i39, 0);
 __ZL24processBrokenEdgeIslandsRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerEPjSD_SD_RS4_(i39, i6, i7, i9, HEAP32[i4 + 84 >> 2] | 0, HEAP32[i4 + 88 >> 2] | 0, HEAP32[i4 + 92 >> 2] | 0, i5);
 i39 = HEAP32[i5 >> 2] | 0;
 i23 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i49 = i10 + 16 | 0;
 HEAP32[i49 >> 2] = 0;
 i38 = HEAP32[i6 + 4 >> 2] | 0;
 i36 = HEAP32[i6 + 24 >> 2] | 0;
 i37 = HEAP32[i7 + 4 >> 2] | 0;
 i35 = HEAP32[i7 + 24 >> 2] | 0;
 i34 = HEAP32[i8 + 4 >> 2] | 0;
 i24 = HEAP32[i9 + 4 >> 2] | 0;
 i25 = HEAP32[i10 + 36 >> 2] | 0;
 i26 = HEAP32[i10 + 8 >> 2] | 0;
 i9 = HEAP32[i10 + 20 >> 2] | 0;
 i27 = HEAP32[i10 + 44 >> 2] | 0;
 i28 = HEAP32[i10 + 56 >> 2] | 0;
 i29 = HEAP32[i10 + 68 >> 2] | 0;
 i30 = HEAP32[i10 + 72 >> 2] | 0;
 i31 = HEAP32[i10 + 84 >> 2] | 0;
 i32 = HEAP32[i10 + 96 >> 2] | 0;
 i41 = i10 + 108 | 0;
 i33 = HEAP32[i41 >> 2] | 0;
 i42 = i10 + 48 | 0;
 i1 = HEAP32[i42 >> 2] | 0;
 i43 = i10 + 60 | 0;
 i4 = HEAP32[i43 >> 2] | 0;
 i44 = i10 + 76 | 0;
 i5 = HEAP32[i44 >> 2] | 0;
 i45 = i10 + 88 | 0;
 i2 = HEAP32[i45 >> 2] | 0;
 i46 = i10 + 100 | 0;
 i3 = HEAP32[i46 >> 2] | 0;
 i47 = i10 + 112 | 0;
 i6 = HEAP32[i47 >> 2] | 0;
 i40 = i10 + 120 | 0;
 i7 = i23 & 2147483647;
 while (1) {
  i8 = i7 + -1 | 0;
  if (!i7) {
   i23 = 0;
   break;
  }
  i7 = HEAP32[i39 + (i8 << 2) >> 2] | 0;
  if (!i7) i7 = i8; else {
   i13 = 4;
   break;
  }
 }
 if ((i13 | 0) == 4) {
  i23 = i7 >>> 1 | i7;
  i23 = i23 >>> 2 | i23;
  i23 = i23 >>> 4 | i23;
  i23 = i23 >>> 8 | i23;
  i23 = (Math_imul(i23 >>> 16 | i23, 130329821) | 0) >>> 27;
  i23 = ((HEAP32[gb + 85120 + (i23 << 2) >> 2] | 0) + (i8 << 5) | 0) >>> 5;
 }
 i22 = i9 + -1 | 0;
 i7 = 0;
 i21 = 0;
 while (1) {
  i8 = HEAP32[i39 + (i21 << 2) >> 2] | 0;
  if (i8) {
   i20 = i21 << 5;
   do {
    i13 = (Math_imul(i8 & 0 - i8, 125613361) | 0) >>> 27;
    i13 = HEAP32[gb + 90668 + (i13 << 2) >> 2] | i20;
    i12 = i24 + (i13 << 4) | 0;
    i9 = HEAP32[i12 >> 2] | 0;
    L13 : do if ((i9 | 0) != -1) {
     i10 = 0;
     i11 = i9;
     do {
      i10 = HEAPU8[i38 + (i11 * 12 | 0) + 8 >> 0] | 0 | i10;
      i11 = HEAP32[i36 + (i11 << 2) >> 2] | 0;
     } while ((i11 | 0) != -1);
     if (!(i10 & 8)) while (1) {
      while (1) {
       i10 = i36 + (i9 << 2) | 0;
       i12 = i38 + (i9 * 12 | 0) + 8 | 0;
       i11 = HEAP8[i12 >> 0] | 0;
       if (!(i11 & 2)) {
        if (!(i11 & 1)) {
         i13 = 15;
         break;
        }
       } else if (i11 & 4) {
        i13 = 17;
        break;
       }
       i9 = HEAP32[i10 >> 2] | 0;
       if ((i9 | 0) == -1) break L13;
      }
      if ((i13 | 0) == 15) {
       HEAP8[i12 >> 0] = i11 & 255 | 16;
       HEAP32[i26 + (i22 - i7 << 2) >> 2] = HEAP32[i38 + (i9 * 12 | 0) >> 2];
       i9 = i10;
      } else if ((i13 | 0) == 17) {
       HEAP8[i12 >> 0] = i11 & 255 | 16;
       HEAP32[i26 + (i22 - i7 << 2) >> 2] = HEAP32[i34 + (HEAP32[i38 + (i9 * 12 | 0) >> 2] << 3) + 4 >> 2] | 1;
       i9 = i10;
      }
      i7 = i7 + 1 | 0;
      i9 = HEAP32[i9 >> 2] | 0;
      if ((i9 | 0) == -1) break L13;
     }
     i19 = i33 + (i6 << 4) + 4 | 0;
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & -2147483648 | i5 & 2147483647;
     HEAP32[i33 + (i6 << 4) >> 2] = i4;
     HEAP32[i33 + (i6 << 4) + 8 >> 2] = i2;
     HEAP32[i33 + (i6 << 4) + 12 >> 2] = i3;
     i6 = i6 + 1 | 0;
     i9 = i12;
     L31 : while (1) {
      L33 : while (1) {
       L35 : while (1) {
        while (1) {
         i10 = HEAP32[i9 >> 2] | 0;
         if ((i10 | 0) == -1) break L31;
         i9 = i36 + (i10 << 2) | 0;
         i11 = HEAP8[i38 + (i10 * 12 | 0) + 8 >> 0] | 0;
         if (i11 & 1) break;
         if (!(i11 & 2)) break L35;
         if (i11 & 4) break L33;
        }
        HEAP32[i25 + (i10 << 2) >> 2] = i1;
        HEAP32[i27 + (i1 << 2) >> 2] = (HEAP32[i38 + (i10 * 12 | 0) >> 2] | 0) + i48;
        i1 = i1 + 1 | 0;
       }
       HEAP32[i25 + (i10 << 2) >> 2] = i4;
       HEAP32[i28 + (i4 << 2) >> 2] = (HEAP32[i38 + (i10 * 12 | 0) >> 2] | 0) + i48;
       i4 = i4 + 1 | 0;
      }
      i17 = HEAP32[i38 + (i10 * 12 | 0) >> 2] | 0;
      i18 = HEAP32[i34 + (i17 << 3) + 4 >> 2] | 0;
      HEAP32[i29 + (i5 << 2) >> 2] = HEAP32[i34 + (i17 << 3) >> 2] & -64;
      HEAP32[i30 + (i5 << 2) >> 2] = i18;
      i5 = i5 + 1 | 0;
     }
     i10 = 0;
     i9 = i24 + (i13 << 4) + 4 | 0;
     L46 : while (1) {
      L48 : while (1) {
       while (1) {
        i17 = HEAP32[i9 >> 2] | 0;
        if ((i17 | 0) == -1) {
         i9 = i10;
         break L46;
        }
        i9 = i35 + (i17 << 2) | 0;
        i11 = HEAP32[i37 + (i17 * 12 | 0) >> 2] | 0;
        i15 = HEAP32[i37 + (i17 * 12 | 0) + 4 >> 2] | 0;
        do if ((i11 | 0) == -1) {
         i11 = -1;
         i10 = 1;
         i16 = 1;
         i13 = 3;
        } else {
         i12 = HEAP8[i38 + (i11 * 12 | 0) + 8 >> 0] | 0;
         if (!(i12 & 2)) {
          i13 = i12 & 1;
          i11 = HEAP32[i25 + (i11 << 2) >> 2] | 0;
          i16 = i13 << 24 >> 24 != 0;
          break;
         }
         i11 = HEAP32[i38 + (i11 * 12 | 0) >> 2] | 0;
         if (!(i12 & 4)) {
          i16 = 0;
          i13 = 2;
         } else {
          i11 = HEAP32[i34 + (i11 << 3) >> 2] | 0;
          i16 = 0;
          i13 = 2;
         }
        } while (0);
        do if ((i15 | 0) == -1) {
         i18 = -1;
         i10 = 1;
         i14 = 1;
         i12 = 3;
        } else {
         i14 = HEAP8[i38 + (i15 * 12 | 0) + 8 >> 0] | 0;
         if (!(i14 & 2)) {
          i12 = i14 & 1;
          i18 = HEAP32[i25 + (i15 << 2) >> 2] | 0;
          i14 = i12 << 24 >> 24 != 0;
          break;
         }
         i12 = HEAP32[i38 + (i15 * 12 | 0) >> 2] | 0;
         if (!(i14 & 4)) {
          i18 = i12;
          i14 = 0;
          i12 = 2;
         } else {
          i18 = HEAP32[i34 + (i12 << 3) >> 2] | 0;
          i14 = 0;
          i12 = 2;
         }
        } while (0);
        if (i16) i14 = i14 ^ 1; else i14 = 1;
        i15 = HEAP32[i37 + (i17 * 12 | 0) + 8 >> 2] | 0;
        i17 = i15;
        i16 = i17 & 1;
        i14 = i14 ^ 1;
        if (!((i16 | 0) != 0 | i14)) {
         i15 = i17;
         i14 = i18;
         break;
        }
        if (!(i15 >>> 0 <= 15 >>> 0 | (i16 | 0) == 0 | i14)) {
         i15 = i17;
         i14 = i18;
         break L48;
        }
       }
       HEAP32[i31 + (i2 << 4) + 12 >> 2] = i15 & -16;
       HEAP8[i31 + (i2 << 4) + 8 >> 0] = i13;
       HEAP8[i31 + (i2 << 4) + 9 >> 0] = i12;
       HEAP32[i31 + (i2 << 4) >> 2] = i11;
       HEAP32[i31 + (i2 << 4) + 4 >> 2] = i14;
       i2 = i2 + 1 | 0;
      }
      HEAP32[i32 + (i3 << 4) + 12 >> 2] = i15 & -16;
      HEAP8[i32 + (i3 << 4) + 8 >> 0] = i13;
      HEAP8[i32 + (i3 << 4) + 9 >> 0] = i12;
      HEAP32[i32 + (i3 << 4) >> 2] = i11;
      HEAP32[i32 + (i3 << 4) + 4 >> 2] = i14;
      i3 = i3 + 1 | 0;
     }
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & 2147483647 | (i9 & 1) << 31;
    } while (0);
    i8 = i8 + -1 & i8;
   } while ((i8 | 0) != 0);
  }
  if ((i21 | 0) == (i23 | 0)) break; else i21 = i21 + 1 | 0;
 }
 i48 = HEAP32[i41 >> 2] | 0;
 HEAP32[i48 + (i6 << 4) >> 2] = i4;
 i48 = i48 + (i6 << 4) + 4 | 0;
 HEAP32[i48 >> 2] = HEAP32[i48 >> 2] & -2147483648 | i5 & 2147483647;
 i48 = HEAP32[i41 >> 2] | 0;
 HEAP32[i48 + (i6 << 4) + 8 >> 2] = i2;
 HEAP32[i48 + (i6 << 4) + 12 >> 2] = i3;
 HEAP32[i49 >> 2] = i7;
 HEAP32[i42 >> 2] = i1;
 HEAP32[i43 >> 2] = i4;
 HEAP32[i44 >> 2] = i5;
 HEAP32[i45 >> 2] = i2;
 HEAP32[i46 >> 2] = i3;
 HEAP32[i47 >> 2] = i6;
 HEAP32[i40 >> 2] = 0;
 return;
}

function __Z22EulerToQuaternionCurveRK17AnimationCurveTplIfES2_S2_RS_I11QuaternionfE(i21, i15, i17, i22) {
 i21 = i21 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23 + 44 | 0;
 i11 = i23 + 32 | 0;
 i19 = i23 + 16 | 0;
 i20 = i23;
 HEAP32[i11 >> 2] = i21;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i17;
 i9 = i22 + 164 | 0;
 i10 = i18 + 4 | 0;
 i16 = i22 + 152 | 0;
 i8 = 0;
 i1 = i21;
 while (1) {
  i7 = HEAP32[i1 + 68 >> 2] | 0;
  if ((i7 | 0) > 0) {
   i6 = i1 + 56 | 0;
   i5 = 0;
   do {
    f14 = Math_fround(HEAPF32[(HEAP32[i6 >> 2] | 0) + (i5 << 4) >> 2]);
    i3 = HEAP32[i9 >> 2] | 0;
    L7 : do if (i3 | 0) {
     i1 = HEAP32[i16 >> 2] | 0;
     if ((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040) {
      i2 = i3 + -1 | 0;
      if ((HEAP32[i1 + (i2 * 52 | 0) >> 2] & 2139095040 | 0) != 2139095040) {
       f24 = Math_fround(HEAPF32[i1 >> 2]);
       if (f24 >= f14 ? 0 : !(Math_fround(HEAPF32[i1 + (i2 * 52 | 0) >> 2]) <= f14)) {
        i4 = i1;
        i1 = (i3 * 52 | 0) / 52 | 0;
        while (1) {
         while (1) {
          if (!i1) break L7;
          i2 = (i1 | 0) / 2 | 0;
          i3 = i4 + (i2 * 52 | 0) | 0;
          if (Math_fround(HEAPF32[i3 >> 2]) < f14) break; else i1 = i2;
         }
         i4 = i3 + 52 | 0;
         i1 = i1 + -1 - i2 | 0;
        }
       }
      }
     }
    } while (0);
    i1 = i10;
    i2 = i1 + 48 | 0;
    do {
     HEAP32[i1 >> 2] = 0;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) < (i2 | 0));
    HEAPF32[i18 >> 2] = f14;
    __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E(i22, i18) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  i1 = i8 + 1 | 0;
  if ((i1 | 0) == 3) break;
  i8 = i1;
  i1 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
 }
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) > 0) {
  i2 = i18 + 4 | 0;
  i3 = i18 + 8 | 0;
  i4 = i21 + 84 | 0;
  i1 = 0;
  do {
   i13 = HEAP32[i16 >> 2] | 0;
   f24 = Math_fround(HEAPF32[i13 + (i1 * 52 | 0) >> 2]);
   i13 = i13 + (i1 * 52 | 0) + 4 | 0;
   f25 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i21, f24, 0));
   f14 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, f24, 0));
   f14 = Math_fround(f14 * Math_fround(.0174532942));
   f24 = Math_fround(Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i17, f24, 0)) * Math_fround(.0174532942));
   HEAPF32[i18 >> 2] = Math_fround(f25 * Math_fround(.0174532942));
   HEAPF32[i2 >> 2] = f14;
   HEAPF32[i3 >> 2] = f24;
   __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i19, i18, HEAP32[i4 >> 2] | 0);
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  i13 = i5 + -1 | 0;
  if ((i5 | 0) > 1) {
   i2 = i18 + 4 | 0;
   i3 = i18 + 8 | 0;
   i4 = i21 + 84 | 0;
   i5 = i19 + 4 | 0;
   i6 = i19 + 8 | 0;
   i7 = i19 + 12 | 0;
   i8 = i18 + 4 | 0;
   i9 = i18 + 8 | 0;
   i10 = i20 + 4 | 0;
   i11 = i20 + 8 | 0;
   i12 = i20 + 12 | 0;
   i1 = 0;
   do {
    i29 = HEAP32[i16 >> 2] | 0;
    f24 = Math_fround(HEAPF32[i29 + (i1 * 52 | 0) >> 2]);
    i26 = i1;
    i1 = i1 + 1 | 0;
    f27 = Math_fround(HEAPF32[i29 + (i1 * 52 | 0) >> 2]);
    f31 = Math_fround(Math_fround(f24 * Math_fround(.999000012)) + Math_fround(f27 * Math_fround(.00100000005)));
    f30 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i21, f31, 0));
    f25 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, f31, 0));
    f25 = Math_fround(f25 * Math_fround(.0174532942));
    f31 = Math_fround(Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i17, f31, 0)) * Math_fround(.0174532942));
    HEAPF32[i18 >> 2] = Math_fround(f30 * Math_fround(.0174532942));
    HEAPF32[i2 >> 2] = f25;
    HEAPF32[i3 >> 2] = f31;
    __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i19, i18, HEAP32[i4 >> 2] | 0);
    i29 = HEAP32[i16 >> 2] | 0;
    f31 = Math_fround(HEAPF32[i19 >> 2]);
    f25 = Math_fround(f27 - f24);
    f31 = Math_fround(Math_fround(Math_fround(f31 - Math_fround(HEAPF32[i29 + (i26 * 52 | 0) + 4 >> 2])) * Math_fround(1.0e3)) / f25);
    f30 = Math_fround(HEAPF32[i5 >> 2]);
    f30 = Math_fround(Math_fround(Math_fround(f30 - Math_fround(HEAPF32[i29 + (i26 * 52 | 0) + 8 >> 2])) * Math_fround(1.0e3)) / f25);
    f28 = Math_fround(HEAPF32[i6 >> 2]);
    f28 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(HEAPF32[i29 + (i26 * 52 | 0) + 12 >> 2])) * Math_fround(1.0e3)) / f25);
    f14 = Math_fround(HEAPF32[i7 >> 2]);
    f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i29 + (i26 * 52 | 0) + 16 >> 2])) * Math_fround(1.0e3)) / f25);
    HEAPF32[i29 + (i26 * 52 | 0) + 36 >> 2] = f31;
    HEAPF32[i29 + (i26 * 52 | 0) + 40 >> 2] = f30;
    HEAPF32[i29 + (i26 * 52 | 0) + 44 >> 2] = f28;
    HEAPF32[i29 + (i26 * 52 | 0) + 48 >> 2] = f14;
    f27 = Math_fround(Math_fround(f24 * Math_fround(.00100000005)) + Math_fround(f27 * Math_fround(.999000012)));
    f24 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i21, f27, 0));
    f14 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, f27, 0));
    f14 = Math_fround(f14 * Math_fround(.0174532942));
    f27 = Math_fround(Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i17, f27, 0)) * Math_fround(.0174532942));
    HEAPF32[i18 >> 2] = Math_fround(f24 * Math_fround(.0174532942));
    HEAPF32[i8 >> 2] = f14;
    HEAPF32[i9 >> 2] = f27;
    __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i20, i18, HEAP32[i4 >> 2] | 0);
    i26 = HEAP32[i16 >> 2] | 0;
    f27 = Math_fround(HEAPF32[i26 + (i1 * 52 | 0) + 4 >> 2]);
    f27 = Math_fround(Math_fround(Math_fround(f27 - Math_fround(HEAPF32[i20 >> 2])) * Math_fround(1.0e3)) / f25);
    f14 = Math_fround(HEAPF32[i26 + (i1 * 52 | 0) + 8 >> 2]);
    f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i10 >> 2])) * Math_fround(1.0e3)) / f25);
    f24 = Math_fround(HEAPF32[i26 + (i1 * 52 | 0) + 12 >> 2]);
    f24 = Math_fround(Math_fround(Math_fround(f24 - Math_fround(HEAPF32[i11 >> 2])) * Math_fround(1.0e3)) / f25);
    f28 = Math_fround(HEAPF32[i26 + (i1 * 52 | 0) + 16 >> 2]);
    f25 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(HEAPF32[i12 >> 2])) * Math_fround(1.0e3)) / f25);
    HEAPF32[i26 + (i1 * 52 | 0) + 20 >> 2] = f27;
    HEAPF32[i26 + (i1 * 52 | 0) + 24 >> 2] = f14;
    HEAPF32[i26 + (i1 * 52 | 0) + 28 >> 2] = f24;
    HEAPF32[i26 + (i1 * 52 | 0) + 32 >> 2] = f25;
   } while ((i1 | 0) != (i13 | 0));
  }
 }
 i1 = HEAP32[i21 + 76 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  break;
 case 0:
  {
   i1 = 0;
   break;
  }
 case 3:
  break;
 default:
  i1 = 2;
 }
 HEAP32[i22 + 172 >> 2] = i1;
 i2 = i22 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(inf);
 HEAP32[i22 >> 2] = 0;
 i3 = i22 + 80 | 0;
 HEAPF32[i3 >> 2] = Math_fround(inf);
 i4 = i22 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i21 + 80 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   i26 = i1;
   i29 = i22 + 176 | 0;
   HEAP32[i29 >> 2] = i26;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i22 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE(i22);
   STACKTOP = i23;
   return;
  }
 case 3:
  {
   i26 = i1;
   i29 = i22 + 176 | 0;
   HEAP32[i29 >> 2] = i26;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i22 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE(i22);
   STACKTOP = i23;
   return;
  }
 case 0:
  {
   i26 = 0;
   i29 = i22 + 176 | 0;
   HEAP32[i29 >> 2] = i26;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i22 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE(i22);
   STACKTOP = i23;
   return;
  }
 default:
  {
   i26 = 2;
   i29 = i22 + 176 | 0;
   HEAP32[i29 >> 2] = i26;
   HEAPF32[i2 >> 2] = Math_fround(inf);
   HEAP32[i22 >> 2] = 0;
   HEAPF32[i3 >> 2] = Math_fround(inf);
   HEAP32[i4 >> 2] = 0;
   __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE(i22);
   STACKTOP = i23;
   return;
  }
 }
}

function __ZN18ProceduralMaterial8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i14 = i17 + 24 | 0;
 i8 = i17 + 16 | 0;
 __ZN8Material8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i11);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 932215 | 0, i7, i10 + 112 | 0, 0);
 i16 = i11 + 16 | 0;
 i12 = i11 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 932223 | 0, i7, i10 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431007 | 0, HEAP32[gb + 36972 >> 2] | 0, i10 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431025 | 0, HEAP32[gb + 37316 >> 2] | 0, i10 + 124 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i11, gb + 1041885 | 0, gb + 1041885 | 0, i14, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1041891 | 0, gb + 431362 | 0, i8, 0);
 i6 = i13 + 8 | 0;
 i15 = i6;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1048093 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1048102 | 0, i8, i6, 1);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i6 = i10 + 172 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 471855 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -131073;
 i6 = i10 + 256 | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431036 | 0, i7, i13, 0);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 i6 = i10 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431054 | 0, gb + 431073 | 0, i6, 0);
 i7 = i13 + 8 | 0;
 i15 = i7;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 i15 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1048093 | 0, i15, i6, 1);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i7 = i10 + 176 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431096 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i7 = i10 + 156 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431105 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i11, gb + 1041885 | 0, gb + 1041885 | 0, i13, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i14, 0);
 HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i8 = i7 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i9 = i10 + 160 | 0;
 if ((i6 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i6 & 255) | 0) {
  i14 = i10 + 264 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431121 | 0, i15, i14, 0);
  i15 = HEAP32[i16 >> 2] | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i16 = HEAP32[i12 >> 2] | 0;
  i16 = i15 + (i16 * 24 | 0) + 12 | 0;
  HEAP32[i16 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
  i16 = i10 + 240 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431143 | 0, gb + 455698 | 0, i16, 0);
  __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i16, i11);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
  STACKTOP = i17;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  i4 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i14 + 11 >> 0] = i3;
  if (!i3) i1 = i14; else {
   i1 = i14;
   i4 = 7;
  }
 } else i4 = 5;
 if ((i4 | 0) == 5) {
  i6 = i3 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i3;
  i4 = 7;
 }
 if ((i4 | 0) == 7) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i14 + 11 | 0;
 do if ((i7 | 0) != (i14 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
  i6 = i1 ? HEAP32[i14 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i8 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i10 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   HEAP32[i9 >> 2] = i6;
   break;
  } else {
   HEAP8[i8 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i9 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 }
 i14 = i10 + 264 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431121 | 0, i15, i14, 0);
 i15 = HEAP32[i16 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i16 = i15 + (i16 * 24 | 0) + 12 | 0;
 HEAP32[i16 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i16 = i10 + 240 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 431143 | 0, gb + 455698 | 0, i16, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i16, i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 STACKTOP = i17;
 return;
}

function __ZN10builtintex23GenerateBuiltinTexturesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 28 | 0;
 i7 = i8 + 8 | 0;
 i5 = i8;
 i1 = i8 + 24 | 0;
 i4 = i8 + 20 | 0;
 if (HEAP8[gb + 1545908 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[gb + 1545908 >> 0] = 1;
 HEAP32[i6 >> 2] = fb + 154;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403324 | 0, 4, 4, 4, i6, 0, 0) | 0;
 HEAP32[gb + 1158176 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 155;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403339 | 0, 4, 4, 4, i6, 1, 0) | 0;
 HEAP32[gb + 1158160 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 156;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403350 | 0, 4, 4, 4, i6, 1, 0) | 0;
 HEAP32[gb + 1157932 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 157;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403361 | 0, 16, 16, 4, i6, 0, 0) | 0;
 HEAP32[gb + 1158184 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 158;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403381 | 0, 4, 4, 4, i6, 1, 1) | 0;
 HEAP32[gb + 1158164 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 159;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403390 | 0, 4, 4, 4, i6, 1, 0) | 0;
 HEAP32[gb + 1158168 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 160;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403400 | 0, 256, 2, 4, i6, 0, 0) | 0;
 HEAP32[gb + 1158172 >> 2] = i3;
 HEAP32[i3 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0);
 HEAP32[i6 >> 2] = fb + 161;
 i3 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403419 | 0, 64, 64, 1, i6, 0, 0) | 0;
 HEAP32[gb + 1158192 >> 2] = i3;
 HEAP32[i3 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0);
 do if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 180 >> 0] | 0)) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0)) {
  HEAP32[i6 >> 2] = fb + 164;
  i2 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403429 | 0, 1024, 1, 1, i6, 0, 0) | 0;
  HEAP32[gb + 1158196 >> 2] = i2;
  break;
 } else {
  HEAP32[i6 >> 2] = fb + 163;
  i2 = __Z12BuildTextureIA4_tPFvP9Texture2DPS0_iiiiEES2_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403429 | 0, 1024, 1, 17, i6, 0, 0) | 0;
  HEAP32[gb + 1158196 >> 2] = i2;
  break;
 } else {
  HEAP32[i6 >> 2] = fb + 162;
  i2 = __Z12BuildTextureItPFvP9Texture2DPtiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403429 | 0, 1024, 1, 9, i6, 0, 0) | 0;
  HEAP32[gb + 1158196 >> 2] = i2;
 } while (0);
 HEAP32[i2 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 i3 = __ZL21BuildEmptyCubeTexturePKci11ColorRGBA3217TextureColorSpace(gb + 403446 | 0, i6) | 0;
 HEAP32[gb + 1158180 >> 2] = i3;
 HEAP32[i6 >> 2] = fb + 165;
 i3 = HEAP32[(__Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403461 | 0, 16, 16, 4, i6, 1, 0) | 0) + 48 >> 2] | 0;
 HEAP32[gb + 1157936 + 8 >> 2] = i3;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0) {
  i1 = gb + 63520 | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i3 = __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId(4, i6) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, 61);
  __ZN9Texture3D11InitTextureEiii13TextureFormatb(i3, 1, 1, 1, 4, 0) | 0;
  __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, gb + 403476 | 0);
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  HEAP8[i2 >> 0] = -2139062144;
  HEAP8[i2 + 1 >> 0] = -2139062144 >> 8;
  HEAP8[i2 + 2 >> 0] = -2139062144 >> 16;
  HEAP8[i2 + 3 >> 0] = -2139062144 >> 24;
  __ZN9Texture3D15UpdateImageDataEb(i3, 0);
  HEAP32[gb + 1157936 + 12 >> 2] = HEAP32[i3 + 48 >> 2];
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 482 >> 0] | 0) {
  i1 = gb + 63520 | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i3 = __Z20CreateObjectFromCodeI14Texture2DArrayEPT_17AwakeFromLoadMode10MemLabelId(4, i6) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, 61);
  __ZN14Texture2DArray11InitTextureEiii13TextureFormatb(i3, 1, 1, 1, 4, 0) | 0;
  __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, gb + 403491 | 0);
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  HEAP8[i2 >> 0] = -2139062144;
  HEAP8[i2 + 1 >> 0] = -2139062144 >> 8;
  HEAP8[i2 + 2 >> 0] = -2139062144 >> 16;
  HEAP8[i2 + 3 >> 0] = -2139062144 >> 24;
  __ZN14Texture2DArray15UpdateImageDataEb(i3, 0);
  HEAP32[gb + 1157936 + 20 >> 2] = HEAP32[i3 + 48 >> 2];
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 483 >> 0] | 0) {
  i3 = gb + 63520 | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i1 = __Z20CreateObjectFromCodeI12CubemapArrayEPT_17AwakeFromLoadMode10MemLabelId(4, i6) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
  __ZN12CubemapArray11InitTextureEiii13TextureFormatb(i1, 1, 1, 1, 4, 0) | 0;
  __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i1, 1);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 403511 | 0);
  i2 = HEAP32[i1 + 92 >> 2] | 0;
  i3 = i2 + 24 | 0;
  do {
   HEAP8[i2 >> 0] = 128;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN12CubemapArray15UpdateImageDataEb(i1, 0);
  HEAP32[gb + 1157936 + 24 >> 2] = HEAP32[i1 + 48 >> 2];
 }
 HEAP32[i4 >> 2] = -2139062144;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i2 = HEAP32[(__ZL21BuildEmptyCubeTexturePKci11ColorRGBA3217TextureColorSpace(gb + 403533 | 0, i6) | 0) + 48 >> 2] | 0;
 HEAP32[gb + 1157936 + 16 >> 2] = i2;
 HEAP32[i5 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, gb + 403550 | 0);
 i2 = i6 + 11 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[gb + 1157936 + (i1 << 2) >> 2] | 0;
  HEAP32[gb + 1157964 + (i1 * 20 | 0) >> 2] = i4;
  HEAP32[gb + 1157964 + (i1 * 20 | 0) + 4 >> 2] = i1;
  if (i4 | i1 | 0) {
   i3 = HEAP32[gb + 1157964 + (i1 * 20 | 0) + 8 >> 2] | 0;
   if (!((i3 | 0) == 1 | (i3 | 0) == (i1 | 0))) {
    i9 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
    i3 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
    i4 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i5) | 0;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i7 + 4 >> 2] = i3;
    HEAP32[i7 + 8 >> 2] = i4;
    __Z6FormatPKcz(i6, gb + 478736 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   }
  }
  HEAP32[gb + 1157964 + (i1 * 20 | 0) + 12 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 __Z22GenerateDitherTexturesv();
 do if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 180 >> 0] | 0)) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0)) {
  HEAP32[i6 >> 2] = fb + 168;
  i1 = __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403566 | 0, 256, 64, 1, i6, 0, 0) | 0;
  HEAP32[gb + 1158188 >> 2] = i1;
  break;
 } else {
  HEAP32[i6 >> 2] = fb + 167;
  i1 = __Z12BuildTextureIA4_tPFvP9Texture2DPS0_iiiiEES2_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403566 | 0, 256, 64, 17, i6, 0, 0) | 0;
  HEAP32[gb + 1158188 >> 2] = i1;
  break;
 } else {
  HEAP32[i6 >> 2] = fb + 166;
  i1 = __Z12BuildTextureItPFvP9Texture2DPtiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(gb + 403566 | 0, 256, 64, 9, i6, 0, 0) | 0;
  HEAP32[gb + 1158188 >> 2] = i1;
 } while (0);
 HEAP32[i1 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1157936 + 4 >> 2] = HEAP32[gb + 1157936 + 8 >> 2];
 __ZN10builtintex21ReinitBuiltinTexturesEv();
 STACKTOP = i8;
 return;
}

function __ZN22NavMeshProjectSettingsC2ER10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 169552 + 8;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 128 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 148 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 168 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 188 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 208 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 228 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 248 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 268 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 280 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 288 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 308 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 328 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 340 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 348 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 368 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 388 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 400 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 408 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 420 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 428 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 440 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 448 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 460 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 468 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 480 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 488 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 500 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 508 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 520 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 528 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 540 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 548 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 560 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 568 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 580 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 588 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 600 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 608 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 620 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 628 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 648 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 660 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i33, i29, i27, i28, i42) {
 i33 = i33 | 0;
 i29 = i29 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i42 = i42 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i43 + 144 | 0;
 i38 = i43 + 160 | 0;
 i39 = i43 + 128 | 0;
 i40 = i43 + 112 | 0;
 i41 = i43 + 96 | 0;
 i30 = i43 + 80 | 0;
 i31 = i43 + 64 | 0;
 i32 = i43 + 48 | 0;
 i34 = i43 + 32 | 0;
 i35 = i43 + 16 | 0;
 i36 = i43;
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 f7 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 i21 = i29 + 16 | 0;
 f25 = Math_fround(HEAPF32[i29 + 16 >> 2]);
 f26 = Math_fround(HEAPF32[i29 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i29 + 24 >> 2]);
 i3 = i29 + 32 | 0;
 f4 = Math_fround(HEAPF32[i29 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i29 + 36 >> 2]);
 f6 = Math_fround(HEAPF32[i29 + 40 >> 2]);
 f8 = Math_fround(HEAPF32[i29 + 48 >> 2]);
 f9 = Math_fround(HEAPF32[i29 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i29 + 56 >> 2]);
 f11 = Math_fround(f25 - f1);
 f12 = Math_fround(f26 - f7);
 f13 = Math_fround(f2 - f20);
 f14 = Math_fround(f4 - f1);
 f15 = Math_fround(f5 - f7);
 f16 = Math_fround(f6 - f20);
 f17 = Math_fround(Math_fround(f12 * f16) - Math_fround(f13 * f15));
 f18 = Math_fround(Math_fround(f13 * f14) - Math_fround(f11 * f16));
 f19 = Math_fround(Math_fround(f11 * f15) - Math_fround(f12 * f14));
 f44 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18))))));
 f22 = Math_fround(f8 - f1);
 f23 = Math_fround(f9 - f7);
 f24 = Math_fround(f10 - f20);
 if (Math_fround(Math_abs(Math_fround(Math_fround(f24 * Math_fround(f19 * f44)) + Math_fround(Math_fround(f22 * Math_fround(f17 * f44)) + Math_fround(f23 * Math_fround(f18 * f44)))))) < Math_fround(.0000999999974)) {
  HEAP32[i42 >> 2] = 3;
  __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i33, i29, i27, i28, i42);
  STACKTOP = i43;
  return;
 }
 f53 = Math_fround(f8 - f25);
 f51 = Math_fround(f9 - f26);
 f55 = Math_fround(f10 - f2);
 f52 = Math_fround(f4 - f25);
 f54 = Math_fround(f5 - f26);
 f44 = Math_fround(f6 - f2);
 f50 = Math_fround(Math_fround(f15 * f24) - Math_fround(f16 * f23));
 f49 = Math_fround(Math_fround(f16 * f22) - Math_fround(f14 * f24));
 f14 = Math_fround(Math_fround(f14 * f23) - Math_fround(f15 * f22));
 f15 = Math_fround(Math_fround(f13 * f23) - Math_fround(f12 * f24));
 f16 = Math_fround(Math_fround(f11 * f24) - Math_fround(f13 * f22));
 f22 = Math_fround(Math_fround(f12 * f22) - Math_fround(f11 * f23));
 f24 = Math_fround(Math_fround(f44 * f51) - Math_fround(f54 * f55));
 f44 = Math_fround(Math_fround(f52 * f55) - Math_fround(f44 * f53));
 f23 = Math_fround(Math_fround(f54 * f53) - Math_fround(f52 * f51));
 i46 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f1 * f17) + Math_fround(f7 * f18))) * Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(f8 * f17) + Math_fround(f9 * f18)))) >= Math_fround(-9.99999997e-07);
 i47 = Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(Math_fround(f1 * f50) + Math_fround(f7 * f49))) * Math_fround(Math_fround(f2 * f14) + Math_fround(Math_fround(f25 * f50) + Math_fround(f26 * f49)))) >= Math_fround(-9.99999997e-07);
 i45 = Math_fround(Math_fround(Math_fround(f20 * f22) + Math_fround(Math_fround(f1 * f15) + Math_fround(f7 * f16))) * Math_fround(Math_fround(f6 * f22) + Math_fround(Math_fround(f4 * f15) + Math_fround(f5 * f16)))) >= Math_fround(-9.99999997e-07);
 i48 = Math_fround(Math_fround(Math_fround(f2 * f23) + Math_fround(Math_fround(f25 * f24) + Math_fround(f26 * f44))) * Math_fround(Math_fround(f20 * f23) + Math_fround(Math_fround(f1 * f24) + Math_fround(f7 * f44)))) >= Math_fround(-9.99999997e-07);
 HEAP32[i37 >> 2] = i46 << 31 >> 31;
 HEAP32[i37 + 4 >> 2] = i47 << 31 >> 31;
 HEAP32[i37 + 8 >> 2] = i45 << 31 >> 31;
 HEAP32[i37 + 12 >> 2] = i48 << 31 >> 31;
 if (i48 | (i47 | i46 | i45)) {
  HEAP32[i38 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i38 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i38 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  __ZN5physx2GuL25getClosestPtPointTriangleEPNS_6shdfnd3aos5Vec3VERKNS2_5BoolVEPjRj(i33, i29, i37, i38, i42);
  i46 = HEAP32[i38 >> 2] | 0;
  i47 = i29 + (i46 << 4) | 0;
  HEAP32[i39 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i39 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  i47 = HEAP32[i38 + 4 >> 2] | 0;
  i48 = i29 + (i47 << 4) | 0;
  HEAP32[i40 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAP32[i40 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
  i48 = HEAP32[i38 + 8 >> 2] | 0;
  i45 = i29 + (i48 << 4) | 0;
  HEAP32[i41 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAP32[i41 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
  i45 = i27 + (i46 << 4) | 0;
  HEAP32[i30 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAP32[i30 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
  i45 = i27 + (i47 << 4) | 0;
  HEAP32[i31 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
  i45 = i27 + (i48 << 4) | 0;
  HEAP32[i32 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i45 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i45 + 8 >> 2];
  HEAP32[i32 + 12 >> 2] = HEAP32[i45 + 12 >> 2];
  i46 = i28 + (i46 << 4) | 0;
  HEAP32[i34 >> 2] = HEAP32[i46 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i34 + 8 >> 2] = HEAP32[i46 + 8 >> 2];
  HEAP32[i34 + 12 >> 2] = HEAP32[i46 + 12 >> 2];
  i47 = i28 + (i47 << 4) | 0;
  HEAP32[i35 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  i48 = i28 + (i48 << 4) | 0;
  HEAP32[i36 >> 2] = HEAP32[i48 >> 2];
  HEAP32[i36 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
  HEAP32[i36 + 8 >> 2] = HEAP32[i48 + 8 >> 2];
  HEAP32[i36 + 12 >> 2] = HEAP32[i48 + 12 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i39 + 12 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i41 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  i48 = i27 + 16 | 0;
  HEAP32[i48 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  i48 = i27 + 32 | 0;
  HEAP32[i48 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
  HEAP32[i28 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i34 + 12 >> 2];
  i48 = i28 + 16 | 0;
  HEAP32[i48 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
  i48 = i28 + 32 | 0;
  HEAP32[i48 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i48 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i48 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  HEAP32[i48 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
  STACKTOP = i43;
  return;
 } else {
  HEAP32[i33 >> 2] = 0;
  HEAP32[i33 + 4 >> 2] = 0;
  HEAP32[i33 + 8 >> 2] = 0;
  HEAP32[i33 + 12 >> 2] = 0;
  STACKTOP = i43;
  return;
 }
}

function __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i4, i1, i5, i18) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 32 | 0;
 i19 = i21 + 8 | 0;
 i17 = i21;
 i15 = i21 + 24 | 0;
 i16 = i21 + 16 | 0;
 i7 = i1;
 i6 = i4;
 i2 = i7 - i6 | 0;
 i3 = (i2 | 0) > 992;
 L1 : do if ((i5 | 0) > 0 & i3) {
  i14 = i18;
  i13 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i7;
  while (1) {
   i11 = i1 + -32 | 0;
   while (1) {
    i10 = i17;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    i10 = (i2 >> 5) + -1 | 0;
    i2 = i19;
    HEAP32[i2 >> 2] = i13;
    HEAP32[i2 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i4, i11, i10, i20);
    i2 = -1;
    i3 = i10;
    while (1) {
     while (1) {
      i8 = i2 + 1 | 0;
      i9 = i4 + (i8 << 5) | 0;
      if ((i8 | 0) == (i10 | 0) | (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i17, i9, i11) | 0) ^ 1) break; else i2 = i8;
     }
     do {
      i3 = i3 + -1 | 0;
      i7 = i4 + (i3 << 5) | 0;
     } while (!((i3 | 0) == 0 | (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i17, i11, i7) | 0) ^ 1));
     if ((i8 | 0) >= (i3 | 0)) break;
     HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i9 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
     HEAP32[i9 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i7 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i7 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i2 = i8;
    }
    HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    HEAP32[i20 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
    HEAP32[i20 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
    HEAP32[i20 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
    HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i11 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
    HEAP32[i11 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
    i8 = i4 + (i2 + 2 << 5) | 0;
    i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
    i9 = i4 + (i2 << 5) + 32 | 0;
    i10 = i9;
    i3 = i10 - i6 >> 5;
    i6 = i8;
    i2 = i12 - i6 | 0;
    i7 = i2 >> 5;
    if ((i3 | 0) >= (i7 | 0)) break;
    i10 = i15;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i4, i9, i3, i20);
    i3 = (i2 | 0) > 992;
    if (!((i5 | 0) > 0 & i3)) break L1; else i4 = i8;
   }
   i6 = i16;
   HEAP32[i6 >> 2] = i13;
   HEAP32[i6 + 4 >> 2] = i14;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i8, i1, i7, i20);
   i6 = i4;
   i2 = i10 - i6 | 0;
   i3 = (i2 | 0) > 992;
   if ((i5 | 0) > 0 & i3) {
    i1 = i9;
    i12 = i10;
   } else {
    i8 = i4;
    i1 = i9;
    break;
   }
  }
 } else i8 = i4; while (0);
 if (i3) {
  i5 = i18;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i20;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  i2 = i2 >> 5;
  i3 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIR26RenderDeferredObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i20, i2, i8 + (i3 << 5) | 0);
   if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
  }
  i18 = i19;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  do {
   i1 = i1 + -32 | 0;
   HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i20 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   HEAP32[i20 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i8 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIR26RenderDeferredObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i19, i2, i8);
  } while ((i2 | 0) > 1);
  STACKTOP = i21;
  return;
 }
 if ((i2 | 0) <= 32) {
  STACKTOP = i21;
  return;
 }
 i16 = i18;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 if (i8 >>> 0 < i1 >>> 0) {
  i2 = i8;
  do {
   L36 : do if (i2 >>> 0 > i8 >>> 0) {
    i3 = i2;
    do {
     i4 = i3;
     i3 = i3 + -32 | 0;
     if (!(__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i19, i4, i3) | 0)) break L36;
     HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i3 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
    } while (i3 >>> 0 > i8 >>> 0);
   } while (0);
   i2 = i2 + 32 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 STACKTOP = i21;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi(i30, i5, i2, i8, i26, i33) {
 i30 = i30 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i26 = i26 | 0;
 i33 = i33 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, f46 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i38 + 176 | 0;
 i35 = i38 + 152 | 0;
 i7 = i38 + 128 | 0;
 i36 = i38 + 32 | 0;
 i31 = i38 + 16 | 0;
 i32 = i38;
 i1 = i30 + 24 | 0;
 i29 = i2 << 1;
 if (((HEAP32[(HEAP32[i30 + 28 >> 2] | 0) + (i29 >> 5 << 2) >> 2] | 0) >>> (i29 & 30) & 3 | 0) != 3) {
  i37 = ((HEAP32[(HEAP32[i30 + 148 >> 2] | 0) + (i2 << 2) >> 2] | 0) >>> 31 ^ 1) + i8 | 0;
  __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi(i30, i5, ((__ZNK5Umbra6KDTree4rankEi(i1, i2) | 0) << 1) + -1 | 0, i37, i26, i33);
  __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi(i30, i5, (__ZNK5Umbra6KDTree4rankEi(i1, i2) | 0) << 1, i37, i26, i33);
  STACKTOP = i38;
  return;
 }
 i1 = HEAP32[i30 + 76 >> 2] | 0;
 i3 = (i1 | 0) > (i5 | 0);
 if (i3) {
  i29 = i30 + 68 | 0;
  i4 = HEAP32[i29 >> 2] | 0;
  i25 = HEAP32[i4 + (i5 << 5) >> 2] | 0;
  i27 = i25 + 12 | 0;
  i28 = i35 + 12 | 0;
  HEAP32[i35 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 } else {
  i4 = i5 - i1 | 0;
  i29 = HEAP32[i30 + 164 >> 2] | 0;
  HEAP32[i35 >> 2] = HEAP32[i29 + (i4 * 40 | 0) >> 2];
  HEAP32[i35 + 4 >> 2] = HEAP32[i29 + (i4 * 40 | 0) + 4 >> 2];
  HEAP32[i35 + 8 >> 2] = HEAP32[i29 + (i4 * 40 | 0) + 8 >> 2];
  HEAP32[i35 + 12 >> 2] = HEAP32[i29 + (i4 * 40 | 0) + 12 >> 2];
  HEAP32[i35 + 16 >> 2] = HEAP32[i29 + (i4 * 40 | 0) + 16 >> 2];
  HEAP32[i35 + 20 >> 2] = HEAP32[i29 + (i4 * 40 | 0) + 20 >> 2];
  i4 = i30 + 68 | 0;
  i29 = i4;
  i4 = HEAP32[i4 >> 2] | 0;
 }
 i27 = HEAP32[(HEAP32[i30 + 148 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 i28 = HEAP32[i4 + (i27 << 5) + 24 >> 2] | 0;
 if (i28 | 0) if (HEAP32[i4 + (i27 << 5) + 16 >> 2] | 0) {
  i6 = HEAP32[i4 + (i27 << 5) >> 2] | 0;
  if (!(HEAP32[i30 + 256 >> 2] | 0)) i3 = -1; else {
   if (i3) i1 = i4 + (i5 << 5) + 4 | 0; else i1 = (HEAP32[i30 + 164 >> 2] | 0) + ((i5 - i1 | 0) * 40 | 0) + 24 | 0;
   i3 = HEAP32[(HEAP32[i30 + 248 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
  }
  i2 = i6 + 12 | 0;
  i1 = i7 + 12 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i1 = i36 + 4 + 20 | 0;
  i2 = i1 + 72 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i1 = i7 + 12 | 0;
  i24 = HEAP32[i7 + 4 >> 2] | 0;
  i18 = HEAP32[i7 + 8 >> 2] | 0;
  i25 = HEAP32[i1 + 4 >> 2] | 0;
  i19 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i36 >> 2] = i24;
  HEAP32[i36 + 4 >> 2] = i18;
  HEAP32[i36 + 8 >> 2] = i25;
  HEAP32[i36 + 12 >> 2] = i19;
  HEAP32[i36 + 16 >> 2] = i24;
  HEAP32[i36 + 20 >> 2] = i18;
  HEAP32[i36 + 24 >> 2] = i25;
  HEAP32[i36 + 28 >> 2] = i19;
  i23 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i36 + 32 >> 2] = i18;
  HEAP32[i36 + 36 >> 2] = i23;
  HEAP32[i36 + 40 >> 2] = i19;
  HEAP32[i36 + 44 >> 2] = i1;
  HEAP32[i36 + 48 >> 2] = i18;
  HEAP32[i36 + 52 >> 2] = i23;
  HEAP32[i36 + 56 >> 2] = i19;
  HEAP32[i36 + 60 >> 2] = i1;
  HEAP32[i36 + 64 >> 2] = i23;
  HEAP32[i36 + 68 >> 2] = i24;
  HEAP32[i36 + 72 >> 2] = i1;
  HEAP32[i36 + 76 >> 2] = i25;
  HEAP32[i36 + 80 >> 2] = i23;
  HEAP32[i36 + 84 >> 2] = i24;
  HEAP32[i36 + 88 >> 2] = i1;
  HEAP32[i36 + 92 >> 2] = i25;
  i25 = i6 + 52 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  if (i1 & 65535 | 0) {
   i19 = (i3 | 0) == -1;
   f20 = Math_fround(HEAPF32[i35 + 12 >> 2]);
   f20 = Math_fround(f20 - Math_fround(HEAPF32[i35 >> 2]));
   f21 = Math_fround(HEAPF32[i35 + 16 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i35 + 4 >> 2]));
   f22 = Math_fround(HEAPF32[i35 + 20 >> 2]);
   f22 = Math_fround(f22 - Math_fround(HEAPF32[i35 + 8 >> 2]));
   i23 = i34 + 4 | 0;
   i24 = i34 + 8 | 0;
   i14 = i31 + 4 | 0;
   i16 = i31 + 8 | 0;
   i18 = i31 + 12 | 0;
   i13 = i32 + 4 | 0;
   i15 = i32 + 8 | 0;
   i17 = i32 + 12 | 0;
   i9 = i8 + -1 | 0;
   i10 = i30 + 268 | 0;
   i11 = i30 + 288 | 0;
   i12 = i30 + 248 | 0;
   i8 = i26 + 4 | 0;
   i7 = 0;
   do {
    i5 = (HEAP32[(HEAP32[i29 >> 2] | 0) + (i27 << 5) + 28 >> 2] | 0) + (HEAP32[i28 + (i7 << 3) >> 2] << 4) | 0;
    i6 = i28 + (i7 << 3) + 4 | 0;
    if ((HEAP32[i6 >> 2] | 0) > 0) {
     i1 = 0;
     do {
      i2 = i5 + (i1 << 4) | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if (i19) i37 = 22; else {
       i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + ((i3 & 67108863) << 2) >> 2] | 0;
       if ((i4 | 0) == -1) i37 = 22; else {
        HEAP32[i33 >> 2] = HEAP32[i33 >> 2] | 1 << (i3 >>> 29);
        i26 = (HEAP32[i8 >> 2] | 0) + (i4 >> 5 << 2) | 0;
        HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | 1 << (i4 & 31);
       }
      }
      if ((i37 | 0) == 22) {
       i37 = 0;
       i40 = HEAP32[i2 + 8 >> 2] | 0;
       i39 = HEAP32[i2 + 12 >> 2] | 0;
       HEAP32[i31 >> 2] = 0;
       HEAP32[i31 + 4 >> 2] = 0;
       HEAP32[i31 + 8 >> 2] = 0;
       HEAP32[i31 + 12 >> 2] = 0;
       HEAP32[i32 >> 2] = 0;
       HEAP32[i32 + 4 >> 2] = 0;
       HEAP32[i32 + 8 >> 2] = 0;
       HEAP32[i32 + 12 >> 2] = 0;
       i4 = HEAP32[i2 >> 2] | 0;
       i45 = i4 >>> 29;
       i4 = i4 >>> 30;
       i26 = ((i4 + 1 | 0) >>> 0) % 3 | 0;
       i4 = ((i4 + 2 | 0) >>> 0) % 3 | 0;
       HEAPF32[i34 >> 2] = f20;
       HEAPF32[i23 >> 2] = f21;
       HEAPF32[i24 >> 2] = f22;
       f42 = Math_fround(HEAPF32[i36 + (i45 << 4) >> 2]);
       f44 = Math_fround(HEAPF32[i35 + (i26 << 2) >> 2]);
       f42 = Math_fround(f42 - f44);
       f41 = Math_fround(HEAPF32[i34 + (i26 << 2) >> 2]);
       f42 = Math_fround(f42 / f41);
       f41 = Math_fround(Math_fround(Math_fround(HEAPF32[i36 + (i45 << 4) + 8 >> 2]) - f44) / f41);
       f44 = Math_fround(HEAPF32[i36 + (i45 << 4) + 4 >> 2]);
       f46 = Math_fround(HEAPF32[i35 + (i4 << 2) >> 2]);
       f44 = Math_fround(f44 - f46);
       f43 = Math_fround(HEAPF32[i34 + (i4 << 2) >> 2]);
       f44 = Math_fround(f44 / f43);
       f42 = Math_fround(~~Math_fround(f42 * Math_fround(65535.0)) | 0);
       f44 = Math_fround(~~Math_fround(f44 * Math_fround(65535.0)) | 0);
       f41 = Math_fround(Math_fround(~~Math_fround(f41 * Math_fround(65535.0)) | 0) - f42);
       f43 = Math_fround(Math_fround(~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i36 + (i45 << 4) + 12 >> 2]) - f46) / f43) * Math_fround(65535.0)) | 0) - f44);
       f41 = Math_fround(f41 * Math_fround(HEAPF32[gb + 1451560 >> 2]));
       f43 = Math_fround(f43 * Math_fround(HEAPF32[gb + 1451560 + 4 >> 2]));
       f46 = Math_fround(Math_fround(HEAPF32[gb + 1451560 + 8 >> 2]) * Math_fround(0.0));
       i45 = ~~Math_fround(f44 + Math_fround(f43 * Math_fround(i39 >>> 16 | 0)));
       i4 = ~~Math_fround(Math_fround(f46 * Math_fround(0.0)) + Math_fround(0.0));
       i26 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[gb + 1451560 + 12 >> 2]) * Math_fround(0.0)) * Math_fround(0.0)) + Math_fround(0.0));
       HEAP32[i31 >> 2] = ~~Math_fround(f42 + Math_fround(f41 * Math_fround(i40 >>> 16 | 0)));
       HEAP32[i14 >> 2] = i45;
       HEAP32[i16 >> 2] = i4;
       HEAP32[i18 >> 2] = i26;
       i39 = ~~Math_fround(f44 + Math_fround(f43 * Math_fround(i39 & 65535 | 0)));
       HEAP32[i32 >> 2] = ~~Math_fround(f42 + Math_fround(f41 * Math_fround(i40 & 65535 | 0)));
       HEAP32[i13 >> 2] = i39;
       HEAP32[i15 >> 2] = i4;
       HEAP32[i17 >> 2] = i26;
       i26 = __ZN5Umbra20RuntimeTomeGenerator13getParentCellEiii(i30, i27, i7, i9) | 0;
       __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_(i10, (HEAP32[i11 >> 2] | 0) + (i26 << 2) | 0, 0, i3 & -469762049 | 67108864, HEAP32[i2 + 4 >> 2] | 0, i31, i32);
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
     i1 = HEAP32[i25 >> 2] | 0;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (i1 & 65535 | 0));
  }
 }
 STACKTOP = i38;
 return;
}

function __ZN19SpriteMeshGenerator4path6selectEv(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i50 + 56 | 0;
 i30 = i50 + 48 | 0;
 i38 = i50 + 64 | 0;
 i39 = i50 + 40 | 0;
 i40 = i50 + 32 | 0;
 i41 = i50 + 24 | 0;
 i42 = i50 + 16 | 0;
 i43 = i50 + 8 | 0;
 i44 = i50;
 i47 = i24 + 4 | 0;
 i1 = HEAP32[i47 >> 2] | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 i49 = i1 - i2 | 0;
 i26 = i49 >> 5;
 if ((i49 | 0) < 160) {
  i49 = 0;
  STACKTOP = i50;
  return i49 | 0;
 }
 i27 = i26 + -1 | 0;
 i28 = i25 + 4 | 0;
 i29 = i30 + 4 | 0;
 i48 = i24 + 56 | 0;
 i49 = i24 + 60 | 0;
 i31 = i24 + 64 | 0;
 i32 = i39 + 4 | 0;
 i33 = i40 + 4 | 0;
 i34 = i41 + 4 | 0;
 i35 = i42 + 4 | 0;
 i36 = i43 + 4 | 0;
 i37 = i44 + 4 | 0;
 i1 = i1 - i2 | 0;
 if ((i1 | 0) > 0) i23 = 0; else {
  i49 = 0;
  STACKTOP = i50;
  return i49 | 0;
 }
 while (1) {
  i22 = i2;
  i4 = i1 >> 5;
  i3 = i2;
  i2 = 0;
  f6 = Math_fround(3402823469999999843913219.0e14);
  i1 = -1;
  while (1) {
   f7 = Math_fround(HEAPF32[i3 + (i2 << 5) + 24 >> 2]);
   if (f7 < Math_fround(0.0)) i46 = i1; else {
    f12 = Math_fround(f7 + Math_fround(HEAPF32[i3 + (i2 << 5) + 20 >> 2]));
    i21 = f12 < f6;
    i46 = i21 ? i2 : i1;
    f6 = i21 ? f12 : f6;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i4 | 0)) break; else i1 = i46;
  }
  if ((i46 | 0) < 0) {
   i1 = 0;
   i45 = 85;
   break;
  }
  i3 = i46 + -1 | 0;
  i19 = (i46 | 0) <= (i26 | 0);
  if (i19) if ((i46 | 0) > 0) i15 = i3; else i15 = i27 - ((0 - i46 | 0) % (i26 | 0) | 0) | 0; else i15 = (i3 | 0) % (i26 | 0) | 0;
  i14 = i22 + (i15 << 5) | 0;
  i2 = i46 + 1 | 0;
  i21 = (i2 | 0) < (i26 | 0);
  if (i21) if ((i46 | 0) > -2) i17 = i2; else i17 = i27 - ((-2 - i46 | 0) % (i26 | 0) | 0) | 0; else i17 = (i2 | 0) % (i26 | 0) | 0;
  i16 = i22 + (i17 << 5) | 0;
  i11 = i22 + (i46 << 5) + 24 | 0;
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  f6 = Math_fround(HEAPF32[i22 + (i46 << 5) + 28 >> 2]);
  do if ((HEAP32[i22 + (i46 << 5) + 16 >> 2] | 0) > 0) {
   i18 = HEAP32[i22 + (i15 << 5) + 4 >> 2] | 0;
   i19 = HEAP32[i16 >> 2] | 0;
   i20 = HEAP32[i22 + (i17 << 5) + 4 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i28 >> 2] = i18;
   HEAP32[i30 >> 2] = i19;
   HEAP32[i29 >> 2] = i20;
   if (__ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_(i24, i25, i30) | 0) {
    HEAPF32[i11 >> 2] = Math_fround(-1.0);
    i1 = 0;
    break;
   }
   i20 = i22 + (i15 << 5) + 20 | 0;
   HEAPF32[i20 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i20 >> 2]));
   i22 = i22 + (i17 << 5) + 20 | 0;
   HEAPF32[i22 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i22 >> 2]));
   if ((i46 | 0) < (i26 | 0)) if ((i46 | 0) > -1) i1 = i46; else i1 = i27 - ((~i46 | 0) % (i26 | 0) | 0) | 0; else i1 = (i46 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i1;
   i3 = HEAP32[i49 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i49 >> 2] = i3 + 4;
   }
   if (i21) if ((i46 | 0) > -2) i1 = i2; else i1 = i27 - ((-2 - i46 | 0) % (i26 | 0) | 0) | 0; else i1 = (i2 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i1;
   i2 = HEAP32[i49 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i2 >> 2] = i1;
    HEAP32[i49 >> 2] = i2 + 4;
   }
   i1 = 1;
  } else {
   i4 = i46 + -2 | 0;
   i18 = (i4 | 0) < (i26 | 0);
   if (i18) if ((i4 | 0) > -1) i13 = i4; else i13 = i27 - ((1 - i46 | 0) % (i26 | 0) | 0) | 0; else i13 = (i4 | 0) % (i26 | 0) | 0;
   i1 = i46 + 2 | 0;
   i20 = (i1 | 0) < (i26 | 0);
   if (i20) if ((i1 | 0) > -1) i5 = i1; else i5 = i27 - ((-3 - i46 | 0) % (i26 | 0) | 0) | 0; else i5 = (i1 | 0) % (i26 | 0) | 0;
   i53 = HEAP32[i22 + (i13 << 5) + 4 >> 2] | 0;
   i52 = HEAP32[i22 + (i5 << 5) >> 2] | 0;
   i51 = HEAP32[i22 + (i5 << 5) + 4 >> 2] | 0;
   f8 = Math_fround(f6 * Math_fround(HEAPF32[i22 + (i15 << 5) + 8 >> 2]));
   f10 = Math_fround(f6 * Math_fround(HEAPF32[i22 + (i15 << 5) + 12 >> 2]));
   f8 = Math_fround(f8 + Math_fround(HEAPF32[i14 >> 2]));
   i9 = i22 + (i15 << 5) + 4 | 0;
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i9 >> 2]));
   f54 = Math_fround(f6 * Math_fround(HEAPF32[i22 + (i17 << 5) + 8 >> 2]));
   f7 = Math_fround(f6 * Math_fround(HEAPF32[i22 + (i17 << 5) + 12 >> 2]));
   f6 = Math_fround(f54 + Math_fround(HEAPF32[i16 >> 2]));
   i5 = i22 + (i17 << 5) + 4 | 0;
   f7 = Math_fround(f7 + Math_fround(HEAPF32[i5 >> 2]));
   HEAP32[i39 >> 2] = HEAP32[i22 + (i13 << 5) >> 2];
   HEAP32[i32 >> 2] = i53;
   HEAPF32[i40 >> 2] = f8;
   HEAPF32[i33 >> 2] = f10;
   i13 = __ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_(i24, i39, i40) | 0;
   HEAPF32[i41 >> 2] = f8;
   HEAPF32[i34 >> 2] = f10;
   HEAPF32[i42 >> 2] = f6;
   HEAPF32[i35 >> 2] = f7;
   i13 = __ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_(i24, i41, i42) | 0 | i13;
   HEAPF32[i43 >> 2] = f6;
   HEAPF32[i36 >> 2] = f7;
   HEAP32[i44 >> 2] = i52;
   HEAP32[i37 >> 2] = i51;
   if (i13 | (__ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_(i24, i43, i44) | 0) | 0) {
    HEAPF32[i11 >> 2] = Math_fround(-1.0);
    i1 = 0;
    break;
   }
   HEAPF32[i14 >> 2] = f8;
   HEAPF32[i9 >> 2] = f10;
   HEAPF32[i16 >> 2] = f6;
   HEAPF32[i5 >> 2] = f7;
   i53 = i22 + (i15 << 5) + 20 | 0;
   HEAPF32[i53 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i53 >> 2]));
   i53 = i22 + (i17 << 5) + 20 | 0;
   HEAPF32[i53 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i53 >> 2]));
   if (i18) {
    if ((i4 | 0) <= -1) i4 = i27 - ((1 - i46 | 0) % (i26 | 0) | 0) | 0;
   } else i4 = (i4 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i4;
   i5 = HEAP32[i49 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i5 >> 2] = i4;
    HEAP32[i49 >> 2] = i5 + 4;
   }
   if (i19) {
    if ((i46 | 0) <= 0) i3 = i27 - ((0 - i46 | 0) % (i26 | 0) | 0) | 0;
   } else i3 = (i3 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i3;
   i4 = HEAP32[i49 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i4 >> 2] = i3;
    HEAP32[i49 >> 2] = i4 + 4;
   }
   if (i21) {
    if ((i46 | 0) <= -2) i2 = i27 - ((-2 - i46 | 0) % (i26 | 0) | 0) | 0;
   } else i2 = (i2 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i2;
   i3 = HEAP32[i49 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i49 >> 2] = i3 + 4;
   }
   if (i20) {
    if ((i1 | 0) <= -1) i1 = i27 - ((-3 - i46 | 0) % (i26 | 0) | 0) | 0;
   } else i1 = (i1 | 0) % (i26 | 0) | 0;
   HEAP32[i38 >> 2] = i1;
   i2 = HEAP32[i49 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i31 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i48, i38); else {
    HEAP32[i2 >> 2] = i1;
    HEAP32[i49 >> 2] = i2 + 4;
   }
   i1 = 1;
  } while (0);
  if ((i23 | 0) >= (i26 | 0)) {
   i45 = 76;
   break;
  }
  if (i1) break;
  i2 = HEAP32[i24 >> 2] | 0;
  i1 = (HEAP32[i47 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) <= 0) {
   i1 = 0;
   i45 = 85;
   break;
  } else i23 = i23 + 1 | 0;
 }
 if ((i45 | 0) == 76) {
  if (!i1) {
   i53 = 0;
   STACKTOP = i50;
   return i53 | 0;
  }
 } else if ((i45 | 0) == 85) {
  STACKTOP = i50;
  return i1 | 0;
 }
 i4 = (HEAP32[i24 >> 2] | 0) + (i46 << 5) | 0;
 i1 = i4 + 32 | 0;
 i2 = HEAP32[i47 >> 2] | 0;
 i3 = i2 - i1 | 0;
 i5 = i3 >> 5;
 if (i5) {
  _memmove(i4 | 0, i1 | 0, i3 | 0) | 0;
  i2 = HEAP32[i47 >> 2] | 0;
 }
 i1 = i4 + (i5 << 5) | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i47 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 i3 = HEAP32[i48 >> 2] | 0;
 i53 = (HEAP32[i49 >> 2] | 0) - i3 | 0;
 i2 = i53 >> 2;
 if ((i53 | 0) > 0) i1 = 0; else {
  i53 = 1;
  STACKTOP = i50;
  return i53 | 0;
 }
 do {
  i4 = i3 + (i1 << 2) | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) > (i46 | 0)) HEAP32[i4 >> 2] = i5 + -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = 1;
 STACKTOP = i50;
 return i1 | 0;
}

function __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i4, i1, i5, i18) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 32 | 0;
 i19 = i21 + 8 | 0;
 i17 = i21;
 i15 = i21 + 24 | 0;
 i16 = i21 + 16 | 0;
 i7 = i1;
 i6 = i4;
 i2 = i7 - i6 | 0;
 i3 = (i2 | 0) > 992;
 L1 : do if ((i5 | 0) > 0 & i3) {
  i14 = i18;
  i13 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i7;
  while (1) {
   i11 = i1 + -32 | 0;
   while (1) {
    i10 = i17;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    i10 = (i2 >> 5) + -1 | 0;
    i2 = i19;
    HEAP32[i2 >> 2] = i13;
    HEAP32[i2 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i4, i11, i10, i20);
    i2 = -1;
    i3 = i10;
    while (1) {
     while (1) {
      i8 = i2 + 1 | 0;
      i9 = i4 + (i8 << 5) | 0;
      if ((i8 | 0) == (i10 | 0) | (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i17, i9, i11) | 0) ^ 1) break; else i2 = i8;
     }
     do {
      i3 = i3 + -1 | 0;
      i7 = i4 + (i3 << 5) | 0;
     } while (!((i3 | 0) == 0 | (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i17, i11, i7) | 0) ^ 1));
     if ((i8 | 0) >= (i3 | 0)) break;
     HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i9 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
     HEAP32[i9 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i7 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i7 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
     i2 = i8;
    }
    HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i20 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i20 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    HEAP32[i20 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
    HEAP32[i20 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
    HEAP32[i20 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
    HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i11 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
    HEAP32[i11 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
    i8 = i4 + (i2 + 2 << 5) | 0;
    i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
    i9 = i4 + (i2 << 5) + 32 | 0;
    i10 = i9;
    i3 = i10 - i6 >> 5;
    i6 = i8;
    i2 = i12 - i6 | 0;
    i7 = i2 >> 5;
    if ((i3 | 0) >= (i7 | 0)) break;
    i10 = i15;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i4, i9, i3, i20);
    i3 = (i2 | 0) > 992;
    if (!((i5 | 0) > 0 & i3)) break L1; else i4 = i8;
   }
   i6 = i16;
   HEAP32[i6 >> 2] = i13;
   HEAP32[i6 + 4 >> 2] = i14;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_(i8, i1, i7, i20);
   i6 = i4;
   i2 = i10 - i6 | 0;
   i3 = (i2 | 0) > 992;
   if ((i5 | 0) > 0 & i3) {
    i1 = i9;
    i12 = i10;
   } else {
    i8 = i4;
    i1 = i9;
    break;
   }
  }
 } else i8 = i4; while (0);
 if (i3) {
  i5 = i18;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i20;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  i2 = i2 >> 5;
  i3 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIR25RenderPrePassObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i20, i2, i8 + (i3 << 5) | 0);
   if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
  }
  i18 = i19;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  do {
   i1 = i1 + -32 | 0;
   HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i20 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   HEAP32[i20 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i8 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIR25RenderPrePassObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i19, i2, i8);
  } while ((i2 | 0) > 1);
  STACKTOP = i21;
  return;
 }
 if ((i2 | 0) <= 32) {
  STACKTOP = i21;
  return;
 }
 i16 = i18;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 if (i8 >>> 0 < i1 >>> 0) {
  i2 = i8;
  do {
   L36 : do if (i2 >>> 0 > i8 >>> 0) {
    i3 = i2;
    do {
     i4 = i3;
     i3 = i3 + -32 | 0;
     if (!(__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i19, i4, i3) | 0)) break L36;
     HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
     HEAP32[i20 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
     HEAP32[i20 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
     HEAP32[i3 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
     HEAP32[i3 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
    } while (i3 >>> 0 > i8 >>> 0);
   } while (0);
   i2 = i2 + 32 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 STACKTOP = i21;
 return;
}

function __ZN5physx12enable3WModeEjjbRNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE(i10, i21, i9, i24, i14, i8) {
 i10 = i10 | 0;
 i21 = i21 | 0;
 i9 = i9 | 0;
 i24 = i24 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 4688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 2560 | 0;
 i18 = i25 + 2464 | 0;
 i22 = i25 + 2368 | 0;
 i20 = i25 + 152 | 0;
 i5 = i25 + 136 | 0;
 i6 = i25 + 80 | 0;
 i7 = i25 + 48 | 0;
 i13 = i25 + 36 | 0;
 i11 = i25 + 24 | 0;
 i12 = i25 + 12 | 0;
 i19 = i25 + 96 | 0;
 i16 = i25;
 i17 = i9 ? 0 : 2;
 i1 = i9 ? 1 : 3;
 __ZN5physx22PxVehicleWheelsSimData12disableWheelEj(i24, i17);
 __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji(i24, i17, -1);
 __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf(i14, i17, Math_fround(0.0));
 if (i9) {
  if (Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i24, 1) | 0) + 28 >> 2]) != Math_fround(0.0)) i15 = 4; else if (Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i24, 0) | 0) + 28 >> 2]) != Math_fround(0.0)) i15 = 4;
  if ((i15 | 0) == 4) {
   i15 = i8 + 560 | 0;
   HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE(i8, i5);
  }
  i15 = i8 + 528 | 0;
  HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
  HEAPF32[i7 + 16 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 } else {
  if (Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i24, 3) | 0) + 28 >> 2]) != Math_fround(0.0)) i15 = 7; else if (Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i24, 2) | 0) + 28 >> 2]) != Math_fround(0.0)) i15 = 7;
  if ((i15 | 0) == 7) {
   i15 = i8 + 560 | 0;
   HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE(i8, i6);
  }
  i15 = i8 + 528 | 0;
  HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
  HEAPF32[i7 + 20 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 }
 __ZN5physx23PxVehicleDriveSimData4W11setDiffDataERKNS_27PxVehicleDifferential4WDataE(i8, i7);
 i9 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i24, i1) | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAPF32[i13 + (i10 << 2) >> 2] = Math_fround(0.0);
 __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i24, i1, i13);
 i9 = __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj(i24, i1) | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAPF32[i11 + (i10 << 2) >> 2] = Math_fround(0.0);
 __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i24, i1, i11);
 i9 = __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj(i24, i1) | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAPF32[i12 + (i10 << 2) >> 2] = Math_fround(0.0);
 __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i24, i1, i12);
 f2 = Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, 0) | 0) + 16 >> 2]);
 f2 = Math_fround(f2 + Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, 1) | 0) + 16 >> 2]));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, 2) | 0) + 16 >> 2]));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, 3) | 0) + 16 >> 2]));
 i9 = i17 | 1;
 i6 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i24, i9) | 0;
 HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i24, i17 ^ 2) | 0;
 HEAP32[i19 + 12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i24, i17 + 3 & 3) | 0;
 HEAP32[i19 + 24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i19 + 32 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 8 >> 2] = Math_fround(0.0);
 i6 = ((i21 + 1 | 0) >>> 0) % 3 | 0;
 i5 = ((i21 + 2 | 0) >>> 0) % 3 | 0;
 HEAP32[i23 + 2116 >> 2] = 3;
 HEAP32[i18 + 92 >> 2] = 3;
 HEAP32[i23 >> 2] = HEAP32[i19 + (i6 << 2) >> 2];
 i8 = i19 + 12 | 0;
 HEAP32[i23 + 4 >> 2] = HEAP32[i8 + (i6 << 2) >> 2];
 i7 = i19 + 24 | 0;
 HEAP32[i23 + 8 >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
 HEAP32[i23 + 92 >> 2] = HEAP32[i19 + (i5 << 2) >> 2];
 HEAP32[i23 + 96 >> 2] = HEAP32[i8 + (i5 << 2) >> 2];
 HEAP32[i23 + 100 >> 2] = HEAP32[i7 + (i5 << 2) >> 2];
 HEAPF32[i23 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i23 + 188 >> 2] = Math_fround(1.0);
 HEAPF32[i23 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i18 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i16 + (i6 << 2) >> 2]));
 HEAPF32[i18 + 4 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i16 + (i5 << 2) >> 2]));
 HEAPF32[i18 + 8 >> 2] = f2;
 HEAP32[i22 + 92 >> 2] = 3;
 HEAP32[i20 + 2208 >> 2] = 0;
 __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i20, i23);
 __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i20, i18, i22);
 f2 = Math_fround(HEAPF32[i22 >> 2]);
 f3 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 i5 = i23 + 16 | 0;
 i6 = i23;
 i7 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, i9) | 0;
 i8 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i6 = i6 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(HEAPF32[i23 >> 2]) / f26)));
 f26 = Math_fround(Math_fround(f26 * f26) * f2);
 HEAPF32[i5 >> 2] = f2;
 HEAPF32[i23 >> 2] = f26;
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i24, i9, i23);
 i1 = i9 + 1 & 3;
 i6 = i23;
 i7 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, i1) | 0;
 i8 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i6 = i6 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(HEAPF32[i23 >> 2]) / f26)));
 f26 = Math_fround(Math_fround(f26 * f26) * f3);
 HEAPF32[i5 >> 2] = f3;
 HEAPF32[i23 >> 2] = f26;
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i24, i1, i23);
 i1 = i9 + 2 & 3;
 i6 = i23;
 i7 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i24, i1) | 0;
 i8 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i6 = i6 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(HEAPF32[i23 >> 2]) / f26)));
 f26 = Math_fround(Math_fround(f26 * f26) * f4);
 HEAPF32[i5 >> 2] = f4;
 HEAPF32[i23 >> 2] = f26;
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i24, i1, i23);
 STACKTOP = i25;
 return;
}

function __ZNSt3__211__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri(i1, i3, i2, i4, i7, i8, i9, i10, i5, i12) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i6 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 if (i1) {
  i6 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476276 | 0) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = i5 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP8[i5 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4512 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i11 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = i6;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = i5 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP8[i5 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4512 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i11 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = i6;
  }
  HEAP8[i7 >> 0] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
  HEAP8[i8 >> 0] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i11 | 0, i6 | 0);
  i1 = i9 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i11 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i11 | 0, i6 | 0);
  i1 = i10 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
  } else {
   HEAP8[i10 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i10 | 0, 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i11 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i1 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
 } else {
  i6 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476268 | 0) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = i5 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP8[i5 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4512 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i11 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = i6;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i11 | 0, i6 | 0);
   i1 = i5 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP8[i5 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4512 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i11 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = i6;
  }
  HEAP8[i7 >> 0] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
  HEAP8[i8 >> 0] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i11 | 0, i6 | 0);
  i1 = i9 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i11 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i11 | 0, i6 | 0);
  i1 = i10 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
  } else {
   HEAP8[i10 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i10 | 0, 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  };
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i11 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i1 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
 }
 HEAP32[i12 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 4;
 HEAP32[i8 + 4 >> 2] = i5;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i8, 0);
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 56 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 64 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 + 72 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i5 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 80 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i5 + 81 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i5 + 82 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i5 + 83 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i5 + 84 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i5 + 85 >> 0] = i1;
 i1 = i5 + 86 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP32[i9 >> 2] = i3;
  i9 = i7;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN8GUIStyle16CalcContentRectsERK5RectTIfE8Vector2fS4_RS1_S5_RfS6_iiS4_(i9, i15, i16, i13, i17, i12, i14, i11, i8, i10) {
 i9 = i9 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i18 = 0, i19 = 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 switch (i11 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   do if (f1 > Math_fround(0.0)) {
    f2 = Math_fround(HEAPF32[gb + 1468168 >> 2]);
    i3 = f2 == Math_fround(0.0);
    if (i3 | Math_fround(HEAPF32[gb + 1468172 >> 2]) == Math_fround(0.0)) {
     f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
     f7 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i16 >> 2])) / f1);
     f5 = Math_fround(HEAPF32[i9 + 12 >> 2]);
     i3 = i15 + 4 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     f5 = Math_fround(f5 / f6);
     f7 = f5 < f7 ? f5 : f7;
     i18 = f7 < Math_fround(0.0);
     i19 = f7 > Math_fround(1.0);
     f7 = i19 ? Math_fround(1.0) : f7;
     f7 = i18 ? Math_fround(0.0) : f7;
     f1 = Math_fround(Math_floor(Math_fround(Math_fround(f1 * f7) + Math_fround(.5))));
     HEAPF32[i15 >> 2] = f1;
     HEAPF32[i3 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(f6 * f7) + Math_fround(.5))));
     break;
    } else {
     HEAPF32[i15 >> 2] = f2;
     i3 = i15 + 4 | 0;
     HEAP32[i3 >> 2] = HEAP32[gb + 1468172 >> 2];
     f1 = f2;
     break;
    }
   } else i3 = i15 + 4 | 0; while (0);
   HEAPF32[i12 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i16 >> 2]));
   i19 = i16 + 4 | 0;
   i18 = Math_fround(HEAPF32[i3 >> 2]) < Math_fround(HEAPF32[i19 >> 2]);
   i19 = HEAP32[(i18 ? i19 : i3) >> 2] | 0;
   HEAP32[i14 >> 2] = i19;
   f5 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   do if (f1 > Math_fround(0.0)) {
    f2 = Math_fround(HEAPF32[gb + 1468168 >> 2]);
    i19 = f2 == Math_fround(0.0);
    if (i19 | Math_fround(HEAPF32[gb + 1468172 >> 2]) == Math_fround(0.0)) {
     f7 = Math_fround(HEAPF32[i9 + 12 >> 2]);
     f7 = Math_fround(f7 - Math_fround(HEAPF32[i16 + 4 >> 2]));
     i3 = i15 + 4 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     f7 = Math_fround(f7 / f6);
     f5 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) / f1);
     f7 = f5 < f7 ? f5 : f7;
     i19 = f7 < Math_fround(0.0);
     i18 = f7 > Math_fround(1.0);
     f7 = i18 ? Math_fround(1.0) : f7;
     f7 = i19 ? Math_fround(0.0) : f7;
     f1 = Math_fround(Math_floor(Math_fround(Math_fround(f1 * f7) + Math_fround(.5))));
     HEAPF32[i15 >> 2] = f1;
     HEAPF32[i3 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(f6 * f7) + Math_fround(.5))));
     break;
    } else {
     HEAPF32[i15 >> 2] = f2;
     i3 = i15 + 4 | 0;
     HEAP32[i3 >> 2] = HEAP32[gb + 1468172 >> 2];
     f1 = f2;
     break;
    }
   } else i3 = i15 + 4 | 0; while (0);
   i19 = f1 < Math_fround(HEAPF32[i16 >> 2]);
   HEAP32[i12 >> 2] = HEAP32[(i19 ? i16 : i15) >> 2];
   f5 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(HEAPF32[i16 + 4 >> 2]));
   HEAPF32[i14 >> 2] = f5;
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   do if (f1 > Math_fround(0.0)) {
    f2 = Math_fround(HEAPF32[gb + 1468168 >> 2]);
    i19 = f2 == Math_fround(0.0);
    if (i19 | Math_fround(HEAPF32[gb + 1468172 >> 2]) == Math_fround(0.0)) {
     f7 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) / f1);
     f5 = Math_fround(HEAPF32[i9 + 12 >> 2]);
     i3 = i15 + 4 | 0;
     f6 = Math_fround(HEAPF32[i3 >> 2]);
     f5 = Math_fround(f5 / f6);
     f7 = f5 < f7 ? f5 : f7;
     i19 = f7 > Math_fround(1.0);
     f7 = i19 ? Math_fround(1.0) : f7;
     f1 = Math_fround(Math_floor(Math_fround(Math_fround(f1 * f7) + Math_fround(.5))));
     HEAPF32[i15 >> 2] = f1;
     HEAPF32[i3 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(f6 * f7) + Math_fround(.5))));
     break;
    } else {
     HEAPF32[i15 >> 2] = f2;
     i3 = i15 + 4 | 0;
     HEAP32[i3 >> 2] = HEAP32[gb + 1468172 >> 2];
     f1 = f2;
     break;
    }
   } else i3 = i15 + 4 | 0; while (0);
   HEAPF32[i12 >> 2] = f1;
   i19 = HEAP32[i3 >> 2] | 0;
   HEAP32[i14 >> 2] = i19;
   f5 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 case 3:
  {
   HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i19;
   f5 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 default:
  f5 = Math_fround(0.0);
 }
 switch (i8 | 0) {
 case 8:
  {
   f1 = Math_fround(1.0);
   f2 = Math_fround(1.0);
   break;
  }
 case 1:
  {
   f1 = Math_fround(.5);
   f2 = Math_fround(0.0);
   break;
  }
 case 2:
  {
   f1 = Math_fround(1.0);
   f2 = Math_fround(0.0);
   break;
  }
 case 3:
  {
   f1 = Math_fround(0.0);
   f2 = Math_fround(.5);
   break;
  }
 case 4:
  {
   f1 = Math_fround(.5);
   f2 = Math_fround(.5);
   break;
  }
 case 5:
  {
   f1 = Math_fround(1.0);
   f2 = Math_fround(.5);
   break;
  }
 case 6:
  {
   f1 = Math_fround(0.0);
   f2 = Math_fround(1.0);
   break;
  }
 case 7:
  {
   f1 = Math_fround(.5);
   f2 = Math_fround(1.0);
   break;
  }
 default:
  {
   f1 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
 }
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f6 + Math_fround(f1 * Math_fround(f7 - f4)));
 f7 = Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f7) + Math_fround(.5))));
 f6 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) - f5)));
 f6 = Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) + f6) + Math_fround(.5))));
 switch (i11 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   if (f1 > Math_fround(0.0)) {
    f4 = Math_fround(HEAPF32[i15 + 4 >> 2]);
    f5 = Math_fround(f6 + Math_fround(Math_fround(f5 - f4) * Math_fround(.5)));
    HEAPF32[i13 >> 2] = f7;
    HEAPF32[i13 + 4 >> 2] = f5;
    HEAPF32[i13 + 8 >> 2] = f1;
    HEAPF32[i13 + 12 >> 2] = f4;
   }
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   if (!(f2 > Math_fround(0.0))) return;
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   if (f1 > Math_fround(0.0)) {
    f5 = Math_fround(Math_fround(f7 + f1) + Math_fround(1.0));
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f7 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    f6 = Math_fround(f6 + Math_fround(Math_fround(f4 - f7) * Math_fround(.5)));
    HEAPF32[i17 >> 2] = f5;
    HEAPF32[i17 + 4 >> 2] = f6;
    HEAPF32[i17 + 8 >> 2] = f2;
    HEAPF32[i17 + 12 >> 2] = f7;
    return;
   } else {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f5 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    f6 = Math_fround(f6 + Math_fround(Math_fround(f4 - f5) * Math_fround(.5)));
    HEAPF32[i17 >> 2] = f7;
    HEAPF32[i17 + 4 >> 2] = f6;
    HEAPF32[i17 + 8 >> 2] = f2;
    HEAPF32[i17 + 12 >> 2] = f5;
    return;
   }
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   if (f1 > Math_fround(0.0)) {
    f5 = Math_fround(Math_floor(Math_fround(Math_fround(f7 + Math_fround(Math_fround(f4 - f1) * Math_fround(.5))) + Math_fround(.5))));
    i19 = HEAP32[i15 + 4 >> 2] | 0;
    HEAPF32[i13 >> 2] = f5;
    HEAPF32[i13 + 4 >> 2] = f6;
    HEAPF32[i13 + 8 >> 2] = f1;
    HEAP32[i13 + 12 >> 2] = i19;
   }
   f1 = Math_fround(HEAPF32[i16 >> 2]);
   if (!(f1 > Math_fround(0.0))) return;
   f5 = Math_fround(Math_floor(Math_fround(Math_fround(f7 + Math_fround(Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f1) * Math_fround(.5))) + Math_fround(.5))));
   f7 = Math_fround(f6 + Math_fround(HEAPF32[i15 + 4 >> 2]));
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   HEAPF32[i17 >> 2] = f5;
   HEAPF32[i17 + 4 >> 2] = f7;
   HEAPF32[i17 + 8 >> 2] = f1;
   HEAP32[i17 + 12 >> 2] = i19;
   return;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i15 >> 2]);
   if (!(f1 > Math_fround(0.0))) return;
   f7 = Math_fround(Math_floor(Math_fround(Math_fround(f7 + Math_fround(Math_fround(f4 - f1) * Math_fround(.5))) + Math_fround(.5))));
   i19 = HEAP32[i15 + 4 >> 2] | 0;
   HEAPF32[i13 >> 2] = f7;
   HEAPF32[i13 + 4 >> 2] = f6;
   HEAPF32[i13 + 8 >> 2] = f1;
   HEAP32[i13 + 12 >> 2] = i19;
   return;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[i16 >> 2]);
   if (!(f1 > Math_fround(0.0))) return;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   HEAPF32[i17 >> 2] = f7;
   HEAPF32[i17 + 4 >> 2] = f6;
   HEAPF32[i17 + 8 >> 2] = f1;
   HEAP32[i17 + 12 >> 2] = i19;
   return;
  }
 default:
  return;
 }
}

function __ZN28LightProbeProxyVolumeManager22AllocateVolumeTexturesER21LightProbeProxyVolume(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 8 | 0;
 i7 = i13;
 i8 = i14 + 140 | 0;
 i9 = i14 + 144 | 0;
 i10 = i14 + 148 | 0;
 i6 = 0;
 do {
  i11 = i14 + 156 + (i6 << 2) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  L3 : do if (!i1) i5 = 59; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
     i2 = HEAP32[i12 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 11; else i5 = 12;
   }
   if ((i5 | 0) == 9) i5 = 11;
   if ((i5 | 0) == 11) {
    i5 = 0;
    if (__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0) i5 = 12;
   }
   do if ((i5 | 0) == 12) {
    i5 = 0;
    i4 = HEAP32[i8 >> 2] << 2;
    HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i5 = 17; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
      i2 = HEAP32[i12 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 17; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i5 = 19;
     }
    }
    if ((i5 | 0) == 17) i5 = 19;
    if ((i5 | 0) == 19) {
     i5 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
    }
    if ((i4 | 0) == (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0)) {
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i5 = 26; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i3 = HEAP32[i1 + 28 >> 2] | 0;
       i2 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i3 + (i2 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
       i2 = HEAP32[i12 >> 2] | 0;
       i15 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = HEAP32[i3 + 28 >> 2] | 0;
      }
      if ((i1 | 0) == (i3 + (i2 << 3) | 0)) i5 = 26; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i5 = 28;
      }
     }
     if ((i5 | 0) == 26) i5 = 28;
     if ((i5 | 0) == 28) {
      i5 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
     }
     if ((i4 | 0) == (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0)) {
      i4 = HEAP32[i10 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i5 = 35; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
        i2 = HEAP32[i12 >> 2] | 0;
        i15 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 35; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i5 = 37;
       }
      }
      if ((i5 | 0) == 35) i5 = 37;
      if ((i5 | 0) == 37) {
       i5 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
      }
      if ((i4 | 0) == (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0) | 0)) break;
     }
    }
    i1 = HEAP32[i11 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i7 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i5 = 45; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
       i2 = HEAP32[i12 >> 2] | 0;
       i15 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 45; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i5 = 47;
      }
     }
     if ((i5 | 0) == 45) i5 = 47;
     if ((i5 | 0) == 47) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
    }
    __Z19DestroySingleObjectP6Object(i1);
    HEAP32[i11 >> 2] = 0;
    i5 = 59;
    break L3;
   } while (0);
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) i5 = 59; else {
    HEAP32[i7 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i5 = 56; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i7);
      i2 = HEAP32[i12 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 56; else if (HEAP32[i1 + 4 >> 2] | 0) break;
    }
    if ((i5 | 0) == 56) i5 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0)) i5 = 59;
   }
  } while (0);
  if ((i5 | 0) == 59) {
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i15 = HEAP32[i10 >> 2] | 0;
   i2 = gb + 63520 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = i7;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   i1 = __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId(4, i12) | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
   __ZN9Texture3D11InitTextureEiii13TextureFormatb(i1, i4 << 2, i5, i15, 6, 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 380169 | 0);
   HEAP32[i1 + 36 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = 1;
   HEAP32[i1 + 44 >> 2] = 1;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 2);
 STACKTOP = i13;
 return;
}

function __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 168 | 0, i7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 184 | 0, i7 + 1 | 0);
 i2 = i8 + 212 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 240 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 256 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 272 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 288 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 36 | 0;
 HEAP8[i3 >> 0] = 1;
 if (!i2) {
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  i4 = i8 + 304 | 0;
  i5 = i7 + 9 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
  i5 = i8 + 320 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 11 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i3 >> 0] = 0;
 i4 = i8 + 304 | 0;
 i5 = i7 + 9 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i5);
 i5 = i8 + 320 | 0;
 i8 = i7 + 10 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
 i8 = i7 + 11 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN16PlayerConnectionC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEtb(i18, i5, i11, i6) {
 i18 = i18 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, d20 = 0.0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 48 | 0;
 i14 = i19 + 32 | 0;
 i13 = i19 + 16 | 0;
 i10 = i19 + 8 | 0;
 i3 = i19 + 64 | 0;
 i4 = i19 + 52 | 0;
 __ZN17GeneralConnectionC2Ev(i18);
 HEAP32[i18 >> 2] = gb + 65632 + 8;
 i16 = i18 + 148 | 0;
 HEAP8[i16 >> 0] = 0;
 i1 = i18 + 152 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 459312 | 0, 7);
 i2 = i18 + 168 | 0;
 i12 = i18 + 180 | 0;
 i7 = i18 + 192 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 __ZN12ServerSocketC2Eiii(i7, 2, 1, 6);
 i9 = i18 + 224 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 459605 | 0, 29);
 i15 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (i15) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 459605 | 0, 29);
  __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 i8 = i18 + 400 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i8 = i18 + 141 | 0;
 HEAP8[i8 >> 0] = 0;
 if (!(__ZN16PlayerConnection14ReadConfigFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i18, i5) | 0)) {
  HEAP32[i18 + 216 >> 2] = i6 & 1;
  _printf_console(gb + 459635 | 0, i19);
  STACKTOP = i19;
  return;
 }
 HEAP8[i8 >> 0] = 1;
 i15 = i18 + 144 | 0;
 if ((HEAP32[i15 >> 2] | 0) == 1) {
  i2 = i18 + 220 | 0;
  i3 = i9 + 11 | 0;
  i4 = i18 + 96 | 0;
  L10 : do if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = 0;
   while (1) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i9, i18 + 236 + (i1 << 4) | 0) | 0;
    if ((HEAP8[i3 >> 0] | 0) < 0) i5 = HEAP32[i9 >> 2] | 0; else i5 = i9;
    HEAP32[i10 >> 2] = i5;
    _printf_console(gb + 459694 | 0, i10);
    __ZN17GeneralConnection4PollEv(i18);
    switch (HEAP32[i15 >> 2] | 0) {
    case 0:
     {
      __ZN16PlayerConnection14PollListenModeEv(i18);
      break;
     }
    case 1:
     {
      __ZN16PlayerConnection15PollConnectModeEv(i18);
      break;
     }
    default:
     {}
    }
    i1 = i1 + 1 | 0;
    if (HEAP32[i4 >> 2] | 0) break;
    if ((i1 | 0) >= (HEAP32[i2 >> 2] | 0)) break L10;
   }
   STACKTOP = i19;
   return;
  } else if (HEAP32[i4 >> 2] | 0) {
   STACKTOP = i19;
   return;
  } while (0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459726 | 0, 0, gb + 459789 | 0, 103, 1, 0, 0, 0);
  HEAP8[i8 >> 0] = 0;
  STACKTOP = i19;
  return;
 }
 i8 = i18 + 164 | 0;
 HEAP16[i8 >> 1] = -10536;
 d20 = +_emscripten_get_now() * 1.0e6;
 i3 = __Z17TimeToNanosecondsy(~~d20 >>> 0, +Math_abs(d20) >= 1.0 ? (d20 > 0.0 ? ~~+Math_min(+Math_floor(d20 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d20 - +(~~d20 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 getTempRet0() | 0;
 i10 = (Math_imul(i3, 1790253981) | 0) + 1900727103 | 0;
 i10 = ((i10 ^ i3 ^ (i3 << 11 ^ i3) >>> 8 ^ i10 >>> 19) & 511) + (HEAPU16[i8 >> 1] | 0) | 0;
 i3 = i10 & 65535;
 HEAP16[i8 >> 1] = i3;
 i6 = i1 + 11 | 0;
 HEAP32[i13 >> 2] = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 HEAP32[i13 + 4 >> 2] = i10 & 65535;
 _printf_console(gb + 459885 | 0, i13);
 __ZN12ServerSocket14StartListeningEPKctb(i7, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, i3, 0) | 0;
 __Z11GetHostNamev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i13) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i18 + 172 >> 2] | 0;
 } else i3 = i3 & 255;
 i4 = i2 + i3 | 0;
 if (i3 | 0) do {
  if ((HEAP8[i2 >> 0] | 0) == 32) HEAP8[i2 >> 0] = 95;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 __ZN16PlayerConnection21ConstructWhoamiStringEv(i13, i18);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i12, i13) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZN16PlayerConnection26InitializeMulticastAddressEt(i18, i11);
 L38 : do if (!(HEAP8[i16 >> 0] | 0)) i1 = i18 + 96 | 0; else {
  d20 = +_emscripten_get_now() * 1.0e6;
  i4 = ~~d20 >>> 0;
  i5 = +Math_abs(d20) >= 1.0 ? (d20 > 0.0 ? ~~+Math_min(+Math_floor(d20 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d20 - +(~~d20 >>> 0)) / 4294967296.0) >>> 0) : 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i12 = HEAPU16[i8 >> 1] | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 4 >> 2] = i12;
  _printf_console(gb + 459938 | 0, i14);
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 459986 | 0, 23);
  i12 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  if (i12) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 459986 | 0, 23);
   __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i13);
   i12 = __Z11StringToIntPKc((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i1 = (i12 | 0) > 0;
   i3 = ___muldi3(i12 | 0, ((i12 | 0) < 0) << 31 >> 31 | 0, 1e9, 0) | 0;
   i2 = getTempRet0() | 0;
   i3 = i1 ? i3 : 705032704;
   i2 = i1 ? i2 : 1;
   i1 = i18 + 96 | 0;
   if (!i12) {
    if (HEAP32[i1 >> 2] | 0) break;
    while (1) {
     __ZN17GeneralConnection4PollEv(i18);
     switch (HEAP32[i15 >> 2] | 0) {
     case 0:
      {
       __ZN16PlayerConnection14PollListenModeEv(i18);
       break;
      }
     case 1:
      {
       __ZN16PlayerConnection15PollConnectModeEv(i18);
       break;
      }
     default:
      {}
     }
     if (HEAP32[i1 >> 2] | 0) break L38;
    }
   }
  } else {
   i2 = 1;
   i3 = 705032704;
   i1 = i18 + 96 | 0;
  }
  d20 = +_emscripten_get_now() * 1.0e6;
  i14 = _i64Subtract(~~d20 >>> 0 | 0, (+Math_abs(d20) >= 1.0 ? (d20 > 0.0 ? ~~+Math_min(+Math_floor(d20 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d20 - +(~~d20 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i4 | 0, i5 | 0) | 0;
  i14 = __Z17TimeToNanosecondsy(i14, getTempRet0() | 0) | 0;
  i13 = getTempRet0() | 0;
  if (i13 >>> 0 < i2 >>> 0 | (i13 | 0) == (i2 | 0) & i14 >>> 0 < i3 >>> 0) while (1) {
   if (HEAP32[i1 >> 2] | 0) break L38;
   __ZN17GeneralConnection4PollEv(i18);
   switch (HEAP32[i15 >> 2] | 0) {
   case 0:
    {
     __ZN16PlayerConnection14PollListenModeEv(i18);
     break;
    }
   case 1:
    {
     __ZN16PlayerConnection15PollConnectModeEv(i18);
     break;
    }
   default:
    {}
   }
   d20 = +_emscripten_get_now() * 1.0e6;
   i14 = _i64Subtract(~~d20 >>> 0 | 0, (+Math_abs(d20) >= 1.0 ? (d20 > 0.0 ? ~~+Math_min(+Math_floor(d20 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d20 - +(~~d20 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i4 | 0, i5 | 0) | 0;
   i14 = __Z17TimeToNanosecondsy(i14, getTempRet0() | 0) | 0;
   i13 = getTempRet0() | 0;
   if (!(i13 >>> 0 < i2 >>> 0 | (i13 | 0) == (i2 | 0) & i14 >>> 0 < i3 >>> 0)) break L38;
  }
 } while (0);
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i19;
  return;
 }
 if (!(HEAP8[i16 >> 0] | 0)) {
  STACKTOP = i19;
  return;
 }
 _printf_console(gb + 460010 | 0, i17);
 STACKTOP = i19;
 return;
}

function __ZNSt3__211__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri(i1, i3, i2, i4, i6, i7, i8, i9, i5, i11) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1) {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476292 | 0) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = i5 + 8 + 3 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP32[i5 >> 2] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i10 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = i5 + 8 + 3 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP32[i5 >> 2] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i10 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  }
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP32[i9 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 } else {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476284 | 0) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = i5 + 8 + 3 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP32[i5 >> 2] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i10 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP8[i4 + 1 >> 0] = i1 >> 8;
   HEAP8[i4 + 2 >> 0] = i1 >> 16;
   HEAP8[i4 + 3 >> 0] = i1 >> 24;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
   i1 = i5 + 8 + 3 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   } else {
    HEAP32[i5 >> 2] = 0;
    HEAP8[i1 >> 0] = 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4514 | 0, i5 | 0, 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   };
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i10 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  }
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP32[i9 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 }
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __Z11CopyTextureP7TextureiiiiiiS0_iiii(i11, i12, i19, i22, i23, i24, i25, i26, i27, i28, i13, i14) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i30 + 152 | 0;
 i9 = i30 + 132 | 0;
 i29 = i30 + 80 | 0;
 i8 = i30 + 72 | 0;
 i2 = i30 + 48 | 0;
 i3 = i30 + 24 | 0;
 i1 = i30;
 i15 = i30 + 104 | 0;
 i16 = i30 + 84 | 0;
 i17 = i30 + 128 | 0;
 i18 = i30 + 124 | 0;
 if (!(__ZL28CheckCopyTextureMipArgumentsP7TextureiiS0_ii(i11, i12, i19, i26, i27, i28) | 0)) {
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i20 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0) | 0;
 i21 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 116 >> 2] | 0, i26 | 0) | 0;
 if ((i23 | i22 | i24 | i25 | i13 | i14 | 0) < 0) {
  HEAP32[i1 >> 2] = i22;
  HEAP32[i1 + 4 >> 2] = i23;
  HEAP32[i1 + 8 >> 2] = i24;
  HEAP32[i1 + 12 >> 2] = i25;
  HEAP32[i1 + 16 >> 2] = i13;
  HEAP32[i1 + 20 >> 2] = i14;
  __Z6FormatPKcz(i10, gb + 399382 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 398117 | 0, 323, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i6 = (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0) | 0) >> i19;
 i6 = (i6 | 0) < 1 ? 1 : i6;
 i7 = (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0) >> i19;
 i7 = (i7 | 0) < 1 ? 1 : i7;
 if ((i25 + i23 | 0) > (i7 | 0) | ((i24 + i22 | 0) > (i6 | 0) | ((i6 | 0) < (i22 | 0) | (i7 | 0) < (i23 | 0)))) {
  HEAP32[i3 >> 2] = i22;
  HEAP32[i3 + 4 >> 2] = i23;
  HEAP32[i3 + 8 >> 2] = i24;
  HEAP32[i3 + 12 >> 2] = i25;
  HEAP32[i3 + 16 >> 2] = i19;
  __Z6FormatPKcz(i10, gb + 399514 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 398117 | 0, 333, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i6 = (mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 100 >> 2] | 0, i26 | 0) | 0) >> i28;
 i6 = (i6 | 0) < 1 ? 1 : i6;
 i7 = (mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 104 >> 2] | 0, i26 | 0) | 0) >> i28;
 i7 = (i7 | 0) < 1 ? 1 : i7;
 if ((i14 + i25 | 0) > (i7 | 0) | ((i13 + i24 | 0) > (i6 | 0) | ((i6 | 0) < (i13 | 0) | (i7 | 0) < (i14 | 0)))) {
  HEAP32[i2 >> 2] = i13;
  HEAP32[i2 + 4 >> 2] = i14;
  HEAP32[i2 + 8 >> 2] = i24;
  HEAP32[i2 + 12 >> 2] = i25;
  HEAP32[i2 + 16 >> 2] = i28;
  __Z6FormatPKcz(i10, gb + 399641 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 398117 | 0, 343, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i3 = i11 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (((i1 >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
  __ZN9Texture2D18UnshareTextureDataEv(i11);
  i1 = HEAP32[i11 + 52 >> 2] | 0;
  if (!i1) i2 = 0; else {
   i2 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i12) | 0;
   i2 = (HEAP32[i1 + 8 >> 2] | 0) + i2 | 0;
  }
  i5 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 184 >> 2] | 0, i11 | 0) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i5 = -1;
  i2 = 0;
 }
 i3 = i1 >>> 21;
 i6 = HEAP32[gb + 32072 + 24 >> 2] | 0;
 i4 = HEAP32[gb + 32072 + 28 >> 2] | 0;
 if ((i3 - i6 | 0) >>> 0 < i4 >>> 0) {
  i2 = (HEAP32[i11 + 96 >> 2] | 0) + (Math_imul(HEAP32[i11 + 104 >> 2] | 0, i12) | 0) | 0;
  i1 = HEAP32[i11 + 92 >> 2] | 0;
 } else i1 = i5;
 if ((i3 - (HEAP32[gb + 32112 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32112 + 28 >> 2] | 0) >>> 0) {
  i7 = HEAP32[i11 + 92 >> 2] | 0;
  i2 = HEAP32[i11 + 96 >> 2] | 0;
 } else i7 = i1;
 i5 = i26 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (((i3 >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
  __ZN9Texture2D18UnshareTextureDataEv(i26);
  i1 = HEAP32[i26 + 52 >> 2] | 0;
  if (!i1) i3 = 0; else {
   i3 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i27) | 0;
   i3 = (HEAP32[i1 + 8 >> 2] | 0) + i3 | 0;
  }
  i1 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 184 >> 2] | 0, i26 | 0) | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[gb + 32072 + 24 >> 2] | 0;
  i4 = HEAP32[gb + 32072 + 28 >> 2] | 0;
 } else {
  i1 = -1;
  i5 = i3;
  i3 = 0;
 }
 i5 = i5 >>> 21;
 if ((i5 - i6 | 0) >>> 0 < i4 >>> 0) {
  i3 = (HEAP32[i26 + 96 >> 2] | 0) + (Math_imul(HEAP32[i26 + 104 >> 2] | 0, i27) | 0) | 0;
  i1 = HEAP32[i26 + 92 >> 2] | 0;
 }
 if ((i5 - (HEAP32[gb + 32112 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32112 + 28 >> 2] | 0) >>> 0) {
  i6 = HEAP32[i26 + 92 >> 2] | 0;
  i3 = HEAP32[i26 + 96 >> 2] | 0;
 } else i6 = i1;
 i4 = i2;
 i5 = i3;
 L40 : do if ((i2 | 0) != 0 & (i3 | 0) != 0) {
  do if ((i7 + -10 | 0) >>> 0 >= 3) if (((i7 | 1) + -25 | 0) >>> 0 >= 5) {
   i1 = i7 + -30 | 0;
   if (i1 >>> 0 < 15) {
    if ((i7 + -48 | 0) >>> 0 < 12 | ((i7 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
   } else if ((i7 + -45 | 0) >>> 0 < 3 | (i7 + -48 | 0) >>> 0 < 12) break;
   do if ((i6 + -10 | 0) >>> 0 >= 3) if (((i6 | 1) + -25 | 0) >>> 0 >= 5) {
    i1 = i6 + -30 | 0;
    if (i1 >>> 0 < 15) {
     if ((i6 + -48 | 0) >>> 0 < 12 | ((i6 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
    } else if ((i6 + -45 | 0) >>> 0 < 3 | (i6 + -48 | 0) >>> 0 < 12) break;
    i29 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0;
    i4 = i4 + (__Z21CalculateMipMapOffsetii13TextureFormati(i29, mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0) | 0, i7, i19) | 0) | 0;
    i29 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 136 >> 2] | 0, i26 | 0) | 0;
    i29 = i5 + (__Z21CalculateMipMapOffsetii13TextureFormati(i29, mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 140 >> 2] | 0, i26 | 0) | 0, i6, i28) | 0) | 0;
    i3 = (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0) >> i19;
    i3 = (i3 | 0) < 1 ? 1 : i3;
    i2 = (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0) | 0) >> i19;
    i8 = (mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 136 >> 2] | 0, i26 | 0) | 0) >> i28;
    i8 = (i8 | 0) < 1 ? 1 : i8;
    i5 = (mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 140 >> 2] | 0, i26 | 0) | 0) >> i28;
    __ZN14ImageReferenceC2Eiii13TextureFormatPv(i10, i3, (i2 | 0) < 1 ? 1 : i2, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i3, i7) | 0, i7, i4);
    __ZN14ImageReferenceC2Eiii13TextureFormatPv(i9, i8, (i5 | 0) < 1 ? 1 : i5, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i8, i6) | 0, i6, i29);
    __ZNK14ImageReference9ClipImageEiiii(i15, i10, i22, i23, i24, i25);
    __ZNK14ImageReference9ClipImageEiiii(i16, i9, i13, i14, i24, i25);
    __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i16, i15, 0);
    break L40;
   } while (0);
   HEAP32[i29 >> 2] = i6;
   __Z6FormatPKcz(i10, gb + 399894 | 0, i29);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 398117 | 0, 209, 512, HEAP32[i26 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   break L40;
  } while (0);
  HEAP32[i8 >> 2] = i7;
  __Z6FormatPKcz(i10, gb + 399773 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 398117 | 0, 204, 512, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 } while (0);
 i15 = HEAP32[i11 + 48 >> 2] | 0;
 i16 = HEAP32[i26 + 48 >> 2] | 0;
 i29 = __Z12GetGfxDevicev() | 0;
 i26 = HEAP32[(HEAP32[i29 >> 2] | 0) + 476 >> 2] | 0;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i18 >> 2] = i16;
 HEAP32[i9 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i18 >> 2];
 mftCall_viiiiiiiiiiiiiii(i26 | 0, i29 | 0, i9 | 0, i12 | 0, i19 | 0, i20 | 0, i22 | 0, i23 | 0, i24 | 0, i25 | 0, i10 | 0, i27 | 0, i28 | 0, i21 | 0, i13 | 0, i14 | 0);
 i29 = 1;
 STACKTOP = i30;
 return i29 | 0;
}

function __ZN20TextRenderingPrivate15DynamicFontData19GetFaceForCharacterERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEERKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEjj(i30, i1, i31, i32, i33) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i36 + 56 | 0;
 i35 = i36 + 40 | 0;
 i27 = i36 + 24 | 0;
 i28 = i36 + 12 | 0;
 i29 = i36;
 i2 = HEAP32[i1 >> 2] | 0;
 i13 = i1 + 4 | 0;
 L1 : do if ((i2 | 0) != (HEAP32[i13 >> 2] | 0)) {
  i14 = i35 + 12 | 0;
  i15 = i34 + 11 | 0;
  i16 = i34 + 4 | 0;
  i17 = i27 + 12 | 0;
  i18 = i28 + 11 | 0;
  i19 = i28 + 4 | 0;
  i20 = i29 + 11 | 0;
  i21 = i29 + 4 | 0;
  i22 = i28 + 11 | 0;
  i23 = i28 + 4 | 0;
  i24 = i29 + 11 | 0;
  i25 = i29 + 4 | 0;
  i26 = i32 | 1;
  i1 = 0;
  i12 = i2;
  while (1) {
   i2 = HEAP8[i12 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i3 = HEAP32[i12 >> 2] | 0;
    i2 = HEAP32[i12 + 4 >> 2] | 0;
   } else {
    i3 = i12;
    i2 = i2 & 255;
   };
   HEAP32[i34 >> 2] = 0;
   HEAP32[i34 + 4 >> 2] = 0;
   HEAP32[i34 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i34, i3, i2);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i35, i34);
   HEAP32[i14 >> 2] = i32;
   i2 = __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj(i30, i35, i31, i33) | 0;
   if (!i2) {
    i6 = HEAP8[i15 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i3 = HEAP32[i34 >> 2] | 0;
    i5 = HEAP32[i16 >> 2] | 0;
    i4 = i2 ? i3 : i34;
    i2 = i2 ? i5 : i6 & 255;
    if (i2 >>> 0 < 5) i2 = i32; else {
     i11 = i4 + i2 | 0;
     i9 = i11;
     i10 = i4;
     L13 : do if ((i2 | 0) < 5) i4 = i9; else {
      i8 = i11 + -4 | 0;
      if ((i8 | 0) == (i4 | 0)) i4 = i9; else L15 : while (1) {
       while (1) {
        if ((HEAP8[i4 >> 0] | 0) == 32) {
         i2 = gb + 945469 | 0;
         i7 = i4;
         break;
        }
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (i8 | 0)) {
         i4 = i9;
         break L13;
        }
       }
       do {
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (gb + 945469 + 5 | 0)) break L15;
        i7 = i7 + 1 | 0;
       } while ((HEAP8[i7 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i8 | 0)) {
        i4 = i9;
        break L13;
       }
      }
     } while (0);
     i2 = i4 - i10 | 0;
     if ((i4 | 0) == (i11 | 0) | (i2 | 0) == -1) i2 = i32; else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i28, i34, 0, i2, i34);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i29, i34, i2 + 5 | 0, -1, i34);
      HEAP32[i27 >> 2] = 0;
      HEAP32[i27 + 4 >> 2] = 0;
      HEAP32[i27 + 8 >> 2] = 0;
      i6 = HEAP8[i22 >> 0] | 0;
      i3 = i6 << 24 >> 24 < 0;
      i6 = i3 ? HEAP32[i23 >> 2] | 0 : i6 & 255;
      i2 = HEAP8[i24 >> 0] | 0;
      i2 = i2 << 24 >> 24 < 0 ? HEAP32[i25 >> 2] | 0 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i27, i3 ? HEAP32[i28 >> 2] | 0 : i28, i6, i2 + i6 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i27, (HEAP8[i24 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29, i2) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i27) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
      i2 = i26;
      i6 = HEAP8[i15 >> 0] | 0;
      i3 = HEAP32[i34 >> 2] | 0;
      i5 = HEAP32[i16 >> 2] | 0;
     }
    }
    i11 = i6 << 24 >> 24 < 0;
    i4 = i11 ? i3 : i34;
    i3 = i11 ? i5 : i6 & 255;
    if (i3 >>> 0 >= 7) {
     i9 = i4 + i3 | 0;
     i7 = i9;
     i8 = i4;
     L30 : do if ((i3 | 0) < 7) i4 = i7; else {
      i6 = i9 + -6 | 0;
      if ((i6 | 0) == (i4 | 0)) i4 = i7; else L32 : while (1) {
       while (1) {
        if ((HEAP8[i4 >> 0] | 0) == 32) {
         i3 = gb + 945475 | 0;
         i5 = i4;
         break;
        }
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (i6 | 0)) {
         i4 = i7;
         break L30;
        }
       }
       do {
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (gb + 945475 + 7 | 0)) break L32;
        i5 = i5 + 1 | 0;
       } while ((HEAP8[i5 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i6 | 0)) {
        i4 = i7;
        break L30;
       }
      }
     } while (0);
     i3 = i4 - i8 | 0;
     if (!((i4 | 0) == (i9 | 0) | (i3 | 0) == -1)) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i28, i34, 0, i3, i34);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i29, i34, i3 + 7 | 0, -1, i34);
      HEAP32[i27 >> 2] = 0;
      HEAP32[i27 + 4 >> 2] = 0;
      HEAP32[i27 + 8 >> 2] = 0;
      i10 = HEAP8[i18 >> 0] | 0;
      i9 = i10 << 24 >> 24 < 0;
      i10 = i9 ? HEAP32[i19 >> 2] | 0 : i10 & 255;
      i11 = HEAP8[i20 >> 0] | 0;
      i11 = i11 << 24 >> 24 < 0 ? HEAP32[i21 >> 2] | 0 : i11 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i27, i9 ? HEAP32[i28 >> 2] | 0 : i28, i10, i11 + i10 | 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i27, (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29, i11) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i34, i27) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
      i2 = i2 | 2;
     }
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i27, i34);
    HEAP32[i17 >> 2] = i2;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i35, i27) | 0;
    HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
    i11 = __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj(i30, i35, i31, i33) | 0;
    i10 = (i11 | 0) == 0;
    i3 = i10 & 1 ^ 1;
    i1 = i10 ? i1 : i11;
   } else {
    i3 = 1;
    i1 = i2;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
   i12 = i12 + 16 | 0;
   if (i3 | 0) break;
   if ((i12 | 0) == (HEAP32[i13 >> 2] | 0)) break L1;
  }
  STACKTOP = i36;
  return i1 | 0;
 } while (0);
 i4 = __ZN20TextRenderingPrivate12GetFallbacksEv() | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = i4 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  i35 = 0;
  STACKTOP = i36;
  return i35 | 0;
 }
 i5 = i34 + 12 | 0;
 i3 = i1;
 while (1) {
  i1 = HEAP8[i3 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
  } else {
   i2 = i3;
   i1 = i1 & 255;
  };
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i35, i2, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i34, i35);
  HEAP32[i5 >> 2] = i32;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
  i1 = __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj(i30, i34, i31, i33) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
  i3 = i3 + 16 | 0;
  if (i1 | 0) {
   i2 = 41;
   break;
  }
  if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) {
   i1 = 0;
   i2 = 41;
   break;
  }
 }
 if ((i2 | 0) == 41) {
  STACKTOP = i36;
  return i1 | 0;
 }
 return 0;
}

function __GLOBAL__sub_I_runtime_camera_renderloops_lump_cpp() {
 var i1 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114552 | 0, gb + 386146 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114564 | 0, gb + 386166 | 0, 0, 0);
 i1 = gb + 1098040 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1114576 >> 2] = 0;
 HEAP32[gb + 1114576 + 4 >> 2] = 0;
 HEAP32[gb + 1114576 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114588 | 0, gb + 386193 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114600 | 0, gb + 386213 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114612 | 0, gb + 386236 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114624 | 0, gb + 386260 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114636 | 0, gb + 386281 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114648 | 0, gb + 386306 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114660 | 0, gb + 386343 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114672 | 0, gb + 386378 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114684 | 0, gb + 386405 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114696 | 0, gb + 386438 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114708 | 0, gb + 386467 | 0, 0, 0);
 HEAP32[gb + 1114720 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114720 | 0, gb + 386504 | 0);
 HEAP32[gb + 1114724 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114724 | 0, gb + 386514 | 0);
 HEAP32[gb + 1114728 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114728 | 0, gb + 386524 | 0);
 HEAP32[gb + 1114732 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114732 | 0, gb + 386536 | 0);
 HEAP32[gb + 1114736 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114736 | 0, gb + 386551 | 0);
 HEAP32[gb + 1114740 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114740 | 0, gb + 386564 | 0);
 HEAP32[gb + 1114744 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114744 | 0, gb + 386577 | 0);
 HEAP32[gb + 1114748 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114748 | 0, gb + 386599 | 0);
 HEAP32[gb + 1114752 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114752 | 0, gb + 386617 | 0);
 HEAP32[gb + 1114756 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114756 | 0, gb + 386637 | 0);
 HEAP32[gb + 1114760 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114760 | 0, gb + 386659 | 0);
 HEAP32[gb + 1114764 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114764 | 0, gb + 386683 | 0);
 HEAP32[gb + 1114768 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114768 | 0, gb + 386709 | 0);
 HEAP32[gb + 1114772 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114772 | 0, gb + 386735 | 0);
 HEAP32[gb + 1114772 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114772 + 4 | 0, gb + 386758 | 0);
 HEAP32[gb + 1114772 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114772 + 8 | 0, gb + 386781 | 0);
 HEAP32[gb + 1114772 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114772 + 12 | 0, gb + 386804 | 0);
 HEAP32[gb + 1114788 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114788 | 0, gb + 386827 | 0);
 HEAP32[gb + 1114792 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114792 | 0, gb + 386837 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114796 | 0, gb + 386847 | 0, 0, 0);
 HEAP32[gb + 1477012 >> 2] = 0;
 HEAP32[gb + 1477016 >> 2] = 0;
 HEAP32[gb + 1477020 >> 2] = 0;
 HEAP32[gb + 1114808 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114808 | 0, gb + 386536 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114812 | 0, gb + 386872 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114824 | 0, gb + 386900 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114836 | 0, gb + 386925 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114848 | 0, gb + 386960 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114860 | 0, gb + 386987 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114872 | 0, gb + 387014 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114884 | 0, gb + 387038 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114896 | 0, gb + 387064 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114908 | 0, gb + 387092 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114920 | 0, gb + 387131 | 0, 0, 0);
 HEAP32[gb + 1114932 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114932 | 0, gb + 386599 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114936 | 0, gb + 387164 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114948 | 0, gb + 387182 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114960 | 0, gb + 387202 | 0, 0, 0);
 HEAP32[gb + 1114972 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114972 | 0, gb + 387225 | 0);
 HEAP32[gb + 1114976 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114976 | 0, gb + 387246 | 0);
 HEAP32[gb + 1114980 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114980 | 0, gb + 387261 | 0);
 HEAP32[gb + 1114984 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114984 | 0, gb + 387272 | 0);
 HEAP32[gb + 1114988 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114988 | 0, gb + 387284 | 0);
 HEAP32[gb + 1114992 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114992 | 0, gb + 387299 | 0);
 HEAP32[gb + 1114996 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114996 | 0, gb + 387322 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115e3 | 0, gb + 387350 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115012 | 0, gb + 387369 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115024 | 0, gb + 387396 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115036 | 0, gb + 387419 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115048 | 0, gb + 387439 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115060 | 0, gb + 387463 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115072 | 0, gb + 387499 | 0, 0, 0);
 HEAP32[gb + 1115084 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115084 | 0, gb + 386504 | 0);
 HEAP32[gb + 1115088 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115088 | 0, gb + 386514 | 0);
 HEAP32[gb + 1115092 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115092 | 0, gb + 386524 | 0);
 HEAP32[gb + 1115096 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115096 | 0, gb + 386536 | 0);
 HEAP32[gb + 1115100 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115100 | 0, gb + 386551 | 0);
 HEAP32[gb + 1115104 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115104 | 0, gb + 386564 | 0);
 HEAP32[gb + 1115108 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115108 | 0, gb + 386599 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544228 | 0, 0, fb + 3344 | 0, 0, 0);
 return;
}

function __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObjectPP15Il2CppException(i2, i1, i19, i20) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 624 | 0;
 i11 = i24 + 568 | 0;
 i13 = i24 + 544 | 0;
 i12 = i24 + 536 | 0;
 i10 = i24 + 512 | 0;
 i16 = i24 + 584 | 0;
 i21 = i24 + 256 | 0;
 i25 = i24 + 576 | 0;
 i22 = i24 + 8 | 0;
 i8 = i24 + 560 | 0;
 i9 = i24 + 608 | 0;
 i3 = i24 + 528 | 0;
 i4 = i24 + 504 | 0;
 i5 = i24 + 592 | 0;
 i6 = i24 + 496 | 0;
 i17 = i24 + 248 | 0;
 i18 = i24;
 i15 = i1;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i16;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i1 + 4 >> 2] = i15;
 HEAP32[i23 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 i1 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i23) | 0;
 i16 = i2 + 20 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 i26 = i25;
 HEAP32[i26 >> 2] = i14;
 HEAP32[i26 + 4 >> 2] = i15;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i21, i7, i23);
 HEAP8[i21 + 233 >> 0] = 0;
 i7 = i14;
 if (!i1) {
  i26 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i21, i20, 0) | 0;
  STACKTOP = i24;
  return i26 | 0;
 }
 if (!i19) {
  i21 = i8;
  HEAP32[i21 >> 2] = i14;
  HEAP32[i21 + 4 >> 2] = i15;
  HEAP32[i23 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  i21 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i23) | 0;
  __ZN13MonoBehaviour18GetScriptClassNameEv(i9, i2);
  i26 = i9 + 11 | 0;
  i25 = (HEAP8[i26 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i10 >> 2] = i21;
  HEAP32[i10 + 4 >> 2] = i25;
  __Z6FormatPKcz(i22, gb + 587500 | 0, i10);
  if ((HEAP8[i26 >> 0] | 0) < 0) {
   i26 = HEAP32[i9 >> 2] | 0;
   i25 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i23 >> 2] = 66;
   HEAP32[i23 + 4 >> 2] = i25;
   __Z19free_alloc_internalPvRK10MemLabelId(i26, i23);
  }
  i26 = i3;
  HEAP32[i26 >> 2] = i14;
  HEAP32[i26 + 4 >> 2] = i15;
  HEAP32[i23 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i12 >> 2] = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i23) | 0;
  HEAP32[i12 + 4 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 587540 | 0, i12);
  i26 = HEAP8[i10 + 11 >> 0] | 0;
  i25 = i26 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i22, i25 ? HEAP32[i10 >> 2] | 0 : i10, i25 ? HEAP32[i10 + 4 >> 2] | 0 : i26 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 587199 | 0, 804, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  i26 = 0;
  STACKTOP = i24;
  return i26 | 0;
 }
 if ((i1 | 0) != 1) {
  i21 = i4;
  HEAP32[i21 >> 2] = i14;
  HEAP32[i21 + 4 >> 2] = i15;
  HEAP32[i23 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  i21 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i23) | 0;
  __ZN13MonoBehaviour18GetScriptClassNameEv(i5, i2);
  i26 = i5 + 11 | 0;
  i25 = (HEAP8[i26 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  HEAP32[i13 >> 2] = i21;
  HEAP32[i13 + 4 >> 2] = i25;
  __Z6FormatPKcz(i22, gb + 587500 | 0, i13);
  if ((HEAP8[i26 >> 0] | 0) < 0) {
   i26 = HEAP32[i5 >> 2] | 0;
   i25 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i23 >> 2] = 66;
   HEAP32[i23 + 4 >> 2] = i25;
   __Z19free_alloc_internalPvRK10MemLabelId(i26, i23);
  }
  i26 = i6;
  HEAP32[i26 >> 2] = i14;
  HEAP32[i26 + 4 >> 2] = i15;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 >> 2] = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i23) | 0;
  HEAP32[i11 + 4 >> 2] = i1;
  __Z6FormatPKcz(i13, gb + 587609 | 0, i11);
  i26 = HEAP8[i13 + 11 >> 0] | 0;
  i25 = i26 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i22, i25 ? HEAP32[i13 >> 2] | 0 : i13, i25 ? HEAP32[i13 + 4 >> 2] | 0 : i26 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22, 0, gb + 587199 | 0, 810, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  i26 = 0;
  STACKTOP = i24;
  return i26 | 0;
 }
 i2 = __Z26scripting_object_get_classP12Il2CppObject(i19) | 0;
 i3 = _il2cpp_method_get_param(i7 | 0, 0) | 0;
 i1 = __Z25scripting_class_from_typePK10Il2CppType(i3) | 0;
 i3 = __Z23scripting_type_get_typePK10Il2CppType(i3) | 0;
 L19 : do if ((i3 + -2 | 0) >>> 0 < 12) {
  i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(i19) | 0) | 0) | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i19; else {
   i2 = __Z14GetMonoManagerv() | 0;
   L23 : do switch (i3 | 0) {
   case 8:
    switch (i1 | 0) {
    case 12:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 80 >> 2] | 0) | 0;
      HEAP32[i1 + 8 >> 2] = ~~Math_fround(HEAPF32[i19 + 8 >> 2]);
      break L23;
     }
    case 13:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 80 >> 2] | 0) | 0;
      HEAP32[i1 + 8 >> 2] = ~~+HEAPF64[i19 + 8 >> 3];
      break L23;
     }
    default:
     break L19;
    }
   case 12:
    switch (i1 | 0) {
    case 8:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 132 >> 2] | 0) | 0;
      HEAPF32[i1 + 8 >> 2] = Math_fround(HEAP32[i19 + 8 >> 2] | 0);
      break L23;
     }
    case 13:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 132 >> 2] | 0) | 0;
      HEAPF32[i1 + 8 >> 2] = Math_fround(+HEAPF64[i19 + 8 >> 3]);
      break L23;
     }
    default:
     break L19;
    }
   case 13:
    switch (i1 | 0) {
    case 8:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 140 >> 2] | 0) | 0;
      HEAPF64[i1 + 8 >> 3] = +(HEAP32[i19 + 8 >> 2] | 0);
      break L23;
     }
    case 12:
     {
      i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[i2 + 140 >> 2] | 0) | 0;
      HEAPF64[i1 + 8 >> 3] = +Math_fround(HEAPF32[i19 + 8 >> 2]);
      break L23;
     }
    default:
     break L19;
    }
   default:
    break L19;
   } while (0);
   if (!i1) break;
  }
  __ZN18ScriptingArguments9AddStructEPKv(i21, i1 + 8 | 0);
 } else switch (i3 | 0) {
 case 17:
  {
   if ((i2 | 0) != (i1 | 0)) break L19;
   __ZN18ScriptingArguments9AddStructEPKv(i21, i19 + 8 | 0);
   break L19;
  }
 case 18:
  {
   if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i1) | 0)) break L19;
   __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, i19);
   break L19;
  }
 case 14:
  {
   if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i2) | 0) | 0) != 14) break L19;
   __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, i19);
   break L19;
  }
 case 28:
  {
   __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, i19);
   break L19;
  }
 default:
  break L19;
 } while (0);
 if ((__ZNK18ScriptingArguments8GetCountEv(i21) | 0) == 1) {
  i26 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i21, i20, 0) | 0;
  STACKTOP = i24;
  return i26 | 0;
 } else {
  i21 = (__Z23GetCoreScriptingClassesv() | 0) + 392 | 0;
  i25 = HEAP32[i21 + 4 >> 2] | 0;
  i26 = i17;
  HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i26 + 4 >> 2] = i25;
  HEAP32[i23 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i22, i23);
  HEAP8[i22 + 233 >> 0] = 0;
  __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i22, HEAP32[i16 >> 2] | 0);
  i26 = i18;
  HEAP32[i26 >> 2] = i14;
  HEAP32[i26 + 4 >> 2] = i15;
  HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  __ZN18ScriptingArguments9AddStringEPKc(i22, __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i23) | 0);
  __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i22, i19);
  i26 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i22, i20, 0) | 0;
  STACKTOP = i24;
  return i26 | 0;
 }
 return 0;
}

function __ZN11TrailModule8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 8 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619503 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619251 | 0, gb + 620173 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 276 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619260 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619278 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 284 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619290 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 285 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619301 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 286 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619318 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 287 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619335 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619355 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 292 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619376 | 0, gb + 620954 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 448 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619394 | 0, gb + 620173 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 712 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619409 | 0, gb + 620954 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 4 | 0;
 i7 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i4 = i8 + 28 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 470975 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853571 | 0, gb + 470987 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 853571 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i8 + 52 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471006 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i5 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i6 = 25; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 25; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 56 | 0;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471018 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i8 >> 2] & 255;
 HEAP8[i7 >> 0] = i1;
 i5 = HEAP32[gb + 37252 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471035 | 0, i5, i9, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 >= i4 >>> 0) {
    i2 = i1 + 1 | 0;
    if (i2 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP32[i3 >> 2] = i2;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 HEAP32[i8 >> 2] = i1 << 24 >> 24;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i7 >> 0] = i1;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471056 | 0, i5, i9, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 HEAP32[i4 >> 2] = i1 << 24 >> 24;
 i2 = i8 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471073 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471088 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471103 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471119 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471134 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471152 | 0, i6, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471177 | 0, i6, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_(i9, i10, i6, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 if (f3 != f2) i4 = f3 < f2; else i4 = (HEAP32[i10 + 4 >> 2] | 0) < (HEAP32[i9 + 4 >> 2] | 0);
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 if (f2 != f3) i1 = f2 < f3; else i1 = (HEAP32[i6 + 4 >> 2] | 0) < (HEAP32[i10 + 4 >> 2] | 0);
 do if (i4) {
  if (i1) {
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   i4 = 1;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  if (f2 != f3) {
   if (!(f2 < f3)) {
    i4 = 1;
    break;
   }
  } else if ((HEAP32[i6 + 4 >> 2] | 0) >= (HEAP32[i10 + 4 >> 2] | 0)) {
   i4 = 1;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i4 = 2;
 } else if (i1) {
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  if (f2 != f3) {
   if (!(f2 < f3)) {
    i4 = 1;
    break;
   }
  } else if ((HEAP32[i10 + 4 >> 2] | 0) >= (HEAP32[i9 + 4 >> 2] | 0)) {
   i4 = 1;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i4 = 2;
 } else i4 = 0; while (0);
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i4;
   STACKTOP = i8;
   return i10 | 0;
  }
 } else if ((HEAP32[i5 + 4 >> 2] | 0) >= (HEAP32[i6 + 4 >> 2] | 0)) {
  i10 = i4;
  STACKTOP = i8;
  return i10 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i1 = i4 + 1 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i1;
   STACKTOP = i8;
   return i10 | 0;
  }
 } else if ((HEAP32[i6 + 4 >> 2] | 0) >= (HEAP32[i10 + 4 >> 2] | 0)) {
  i10 = i1;
  STACKTOP = i8;
  return i10 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i1 = i4 + 2 | 0;
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i1;
   STACKTOP = i8;
   return i10 | 0;
  }
 } else if ((HEAP32[i10 + 4 >> 2] | 0) >= (HEAP32[i9 + 4 >> 2] | 0)) {
  i10 = i1;
  STACKTOP = i8;
  return i10 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i10 = i4 + 3 | 0;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i45, i50, i46, i44) {
 i45 = i45 | 0;
 i50 = i50 | 0;
 i46 = i46 | 0;
 i44 = i44 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i47 = 0, i48 = 0, i49 = 0;
 i49 = mftCall_iii(HEAP32[i44 >> 2] | 0, i50 | 0, i45 | 0) | 0;
 i1 = mftCall_iii(HEAP32[i44 >> 2] | 0, i46 | 0, i50 | 0) | 0;
 if (!i49) {
  if (!i1) {
   i50 = 0;
   return i50 | 0;
  }
  i22 = HEAP32[i50 >> 2] | 0;
  i43 = i50 + 4 | 0;
  i1 = HEAP32[i43 >> 2] | 0;
  i23 = i50 + 8 | 0;
  i2 = HEAP32[i23 >> 2] | 0;
  i24 = i50 + 12 | 0;
  i3 = HEAP32[i24 >> 2] | 0;
  i25 = i50 + 16 | 0;
  i4 = HEAP32[i25 >> 2] | 0;
  i26 = i50 + 20 | 0;
  i5 = HEAP32[i26 >> 2] | 0;
  i27 = i50 + 24 | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i28 = i50 + 28 | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i29 = i50 + 32 | 0;
  i8 = HEAP32[i29 >> 2] | 0;
  i30 = i50 + 36 | 0;
  i9 = HEAP32[i30 >> 2] | 0;
  i31 = i50 + 40 | 0;
  i10 = HEAP32[i31 >> 2] | 0;
  i32 = i50 + 44 | 0;
  i11 = HEAP32[i32 >> 2] | 0;
  i33 = i50 + 48 | 0;
  i12 = HEAP32[i33 >> 2] | 0;
  i34 = i50 + 52 | 0;
  i13 = HEAP32[i34 >> 2] | 0;
  i35 = i50 + 56 | 0;
  i14 = HEAP32[i35 >> 2] | 0;
  i36 = i50 + 60 | 0;
  i15 = HEAP32[i36 >> 2] | 0;
  i37 = i50 + 64 | 0;
  i16 = HEAP32[i37 >> 2] | 0;
  i38 = i50 + 68 | 0;
  i17 = HEAP32[i38 >> 2] | 0;
  i39 = i50 + 72 | 0;
  i18 = HEAP32[i39 >> 2] | 0;
  i40 = i50 + 76 | 0;
  i19 = HEAP32[i40 >> 2] | 0;
  i41 = i50 + 80 | 0;
  i20 = HEAP32[i41 >> 2] | 0;
  i42 = i50 + 84 | 0;
  i21 = HEAP32[i42 >> 2] | 0;
  i47 = i50;
  i48 = i46;
  i49 = i47 + 88 | 0;
  do {
   HEAP32[i47 >> 2] = HEAP32[i48 >> 2];
   i47 = i47 + 4 | 0;
   i48 = i48 + 4 | 0;
  } while ((i47 | 0) < (i49 | 0));
  HEAP32[i46 >> 2] = i22;
  HEAP32[i46 + 4 >> 2] = i1;
  HEAP32[i46 + 8 >> 2] = i2;
  HEAP32[i46 + 12 >> 2] = i3;
  HEAP32[i46 + 16 >> 2] = i4;
  HEAP32[i46 + 20 >> 2] = i5;
  HEAP32[i46 + 24 >> 2] = i6;
  HEAP32[i46 + 28 >> 2] = i7;
  HEAP32[i46 + 32 >> 2] = i8;
  HEAP32[i46 + 36 >> 2] = i9;
  HEAP32[i46 + 40 >> 2] = i10;
  HEAP32[i46 + 44 >> 2] = i11;
  HEAP32[i46 + 48 >> 2] = i12;
  HEAP32[i46 + 52 >> 2] = i13;
  HEAP32[i46 + 56 >> 2] = i14;
  HEAP32[i46 + 60 >> 2] = i15;
  HEAP32[i46 + 64 >> 2] = i16;
  HEAP32[i46 + 68 >> 2] = i17;
  HEAP32[i46 + 72 >> 2] = i18;
  HEAP32[i46 + 76 >> 2] = i19;
  HEAP32[i46 + 80 >> 2] = i20;
  HEAP32[i46 + 84 >> 2] = i21;
  if (!(mftCall_iii(HEAP32[i44 >> 2] | 0, i50 | 0, i45 | 0) | 0)) {
   i50 = 1;
   return i50 | 0;
  }
  i1 = HEAP32[i45 >> 2] | 0;
  i2 = HEAP32[i45 + 4 >> 2] | 0;
  i3 = HEAP32[i45 + 8 >> 2] | 0;
  i4 = HEAP32[i45 + 12 >> 2] | 0;
  i5 = HEAP32[i45 + 16 >> 2] | 0;
  i6 = HEAP32[i45 + 20 >> 2] | 0;
  i7 = HEAP32[i45 + 24 >> 2] | 0;
  i8 = HEAP32[i45 + 28 >> 2] | 0;
  i9 = HEAP32[i45 + 32 >> 2] | 0;
  i10 = HEAP32[i45 + 36 >> 2] | 0;
  i11 = HEAP32[i45 + 40 >> 2] | 0;
  i12 = HEAP32[i45 + 44 >> 2] | 0;
  i13 = HEAP32[i45 + 48 >> 2] | 0;
  i14 = HEAP32[i45 + 52 >> 2] | 0;
  i15 = HEAP32[i45 + 56 >> 2] | 0;
  i16 = HEAP32[i45 + 60 >> 2] | 0;
  i17 = HEAP32[i45 + 64 >> 2] | 0;
  i18 = HEAP32[i45 + 68 >> 2] | 0;
  i19 = HEAP32[i45 + 72 >> 2] | 0;
  i20 = HEAP32[i45 + 76 >> 2] | 0;
  i21 = HEAP32[i45 + 80 >> 2] | 0;
  i22 = HEAP32[i45 + 84 >> 2] | 0;
  i47 = i45;
  i48 = i50;
  i49 = i47 + 88 | 0;
  do {
   HEAP32[i47 >> 2] = HEAP32[i48 >> 2];
   i47 = i47 + 4 | 0;
   i48 = i48 + 4 | 0;
  } while ((i47 | 0) < (i49 | 0));
  HEAP32[i50 >> 2] = i1;
  HEAP32[i43 >> 2] = i2;
  HEAP32[i23 >> 2] = i3;
  HEAP32[i24 >> 2] = i4;
  HEAP32[i25 >> 2] = i5;
  HEAP32[i26 >> 2] = i6;
  HEAP32[i27 >> 2] = i7;
  HEAP32[i28 >> 2] = i8;
  HEAP32[i29 >> 2] = i9;
  HEAP32[i30 >> 2] = i10;
  HEAP32[i31 >> 2] = i11;
  HEAP32[i32 >> 2] = i12;
  HEAP32[i33 >> 2] = i13;
  HEAP32[i34 >> 2] = i14;
  HEAP32[i35 >> 2] = i15;
  HEAP32[i36 >> 2] = i16;
  HEAP32[i37 >> 2] = i17;
  HEAP32[i38 >> 2] = i18;
  HEAP32[i39 >> 2] = i19;
  HEAP32[i40 >> 2] = i20;
  HEAP32[i41 >> 2] = i21;
  HEAP32[i42 >> 2] = i22;
  i50 = 2;
  return i50 | 0;
 }
 i2 = HEAP32[i45 >> 2] | 0;
 i3 = HEAP32[i45 + 4 >> 2] | 0;
 i4 = HEAP32[i45 + 8 >> 2] | 0;
 i5 = HEAP32[i45 + 12 >> 2] | 0;
 i6 = HEAP32[i45 + 16 >> 2] | 0;
 i7 = HEAP32[i45 + 20 >> 2] | 0;
 i8 = HEAP32[i45 + 24 >> 2] | 0;
 i9 = HEAP32[i45 + 28 >> 2] | 0;
 i10 = HEAP32[i45 + 32 >> 2] | 0;
 i11 = HEAP32[i45 + 36 >> 2] | 0;
 i12 = HEAP32[i45 + 40 >> 2] | 0;
 i13 = HEAP32[i45 + 44 >> 2] | 0;
 i14 = HEAP32[i45 + 48 >> 2] | 0;
 i15 = HEAP32[i45 + 52 >> 2] | 0;
 i16 = HEAP32[i45 + 56 >> 2] | 0;
 i17 = HEAP32[i45 + 60 >> 2] | 0;
 i22 = HEAP32[i45 + 64 >> 2] | 0;
 i23 = HEAP32[i45 + 68 >> 2] | 0;
 i24 = HEAP32[i45 + 72 >> 2] | 0;
 i25 = HEAP32[i45 + 76 >> 2] | 0;
 i26 = HEAP32[i45 + 80 >> 2] | 0;
 i31 = HEAP32[i45 + 84 >> 2] | 0;
 if (i1) {
  i47 = i45;
  i48 = i46;
  i49 = i47 + 88 | 0;
  do {
   HEAP32[i47 >> 2] = HEAP32[i48 >> 2];
   i47 = i47 + 4 | 0;
   i48 = i48 + 4 | 0;
  } while ((i47 | 0) < (i49 | 0));
  HEAP32[i46 >> 2] = i2;
  HEAP32[i46 + 4 >> 2] = i3;
  HEAP32[i46 + 8 >> 2] = i4;
  HEAP32[i46 + 12 >> 2] = i5;
  HEAP32[i46 + 16 >> 2] = i6;
  HEAP32[i46 + 20 >> 2] = i7;
  HEAP32[i46 + 24 >> 2] = i8;
  HEAP32[i46 + 28 >> 2] = i9;
  HEAP32[i46 + 32 >> 2] = i10;
  HEAP32[i46 + 36 >> 2] = i11;
  HEAP32[i46 + 40 >> 2] = i12;
  HEAP32[i46 + 44 >> 2] = i13;
  HEAP32[i46 + 48 >> 2] = i14;
  HEAP32[i46 + 52 >> 2] = i15;
  HEAP32[i46 + 56 >> 2] = i16;
  HEAP32[i46 + 60 >> 2] = i17;
  HEAP32[i46 + 64 >> 2] = i22;
  HEAP32[i46 + 68 >> 2] = i23;
  HEAP32[i46 + 72 >> 2] = i24;
  HEAP32[i46 + 76 >> 2] = i25;
  HEAP32[i46 + 80 >> 2] = i26;
  HEAP32[i46 + 84 >> 2] = i31;
  i50 = 1;
  return i50 | 0;
 }
 i47 = i45;
 i48 = i50;
 i49 = i47 + 88 | 0;
 do {
  HEAP32[i47 >> 2] = HEAP32[i48 >> 2];
  i47 = i47 + 4 | 0;
  i48 = i48 + 4 | 0;
 } while ((i47 | 0) < (i49 | 0));
 HEAP32[i50 >> 2] = i2;
 i18 = i50 + 4 | 0;
 HEAP32[i18 >> 2] = i3;
 i19 = i50 + 8 | 0;
 HEAP32[i19 >> 2] = i4;
 i27 = i50 + 12 | 0;
 HEAP32[i27 >> 2] = i5;
 i28 = i50 + 16 | 0;
 HEAP32[i28 >> 2] = i6;
 i29 = i50 + 20 | 0;
 HEAP32[i29 >> 2] = i7;
 i30 = i50 + 24 | 0;
 HEAP32[i30 >> 2] = i8;
 i1 = i50 + 28 | 0;
 HEAP32[i1 >> 2] = i9;
 i2 = i50 + 32 | 0;
 HEAP32[i2 >> 2] = i10;
 i3 = i50 + 36 | 0;
 HEAP32[i3 >> 2] = i11;
 i4 = i50 + 40 | 0;
 HEAP32[i4 >> 2] = i12;
 i5 = i50 + 44 | 0;
 HEAP32[i5 >> 2] = i13;
 i6 = i50 + 48 | 0;
 HEAP32[i6 >> 2] = i14;
 i7 = i50 + 52 | 0;
 HEAP32[i7 >> 2] = i15;
 i8 = i50 + 56 | 0;
 HEAP32[i8 >> 2] = i16;
 i20 = i50 + 60 | 0;
 HEAP32[i20 >> 2] = i17;
 i21 = i50 + 64 | 0;
 HEAP32[i21 >> 2] = i22;
 i22 = i50 + 68 | 0;
 HEAP32[i22 >> 2] = i23;
 i23 = i50 + 72 | 0;
 HEAP32[i23 >> 2] = i24;
 i24 = i50 + 76 | 0;
 HEAP32[i24 >> 2] = i25;
 i25 = i50 + 80 | 0;
 HEAP32[i25 >> 2] = i26;
 i26 = i50 + 84 | 0;
 HEAP32[i26 >> 2] = i31;
 if (!(mftCall_iii(HEAP32[i44 >> 2] | 0, i46 | 0, i50 | 0) | 0)) {
  i50 = 1;
  return i50 | 0;
 }
 i33 = HEAP32[i50 >> 2] | 0;
 i32 = HEAP32[i18 >> 2] | 0;
 i31 = HEAP32[i19 >> 2] | 0;
 i19 = HEAP32[i27 >> 2] | 0;
 i18 = HEAP32[i28 >> 2] | 0;
 i17 = HEAP32[i29 >> 2] | 0;
 i16 = HEAP32[i30 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i20 >> 2] | 0;
 i6 = HEAP32[i21 >> 2] | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i2 = HEAP32[i25 >> 2] | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 i47 = i50;
 i48 = i46;
 i49 = i47 + 88 | 0;
 do {
  HEAP32[i47 >> 2] = HEAP32[i48 >> 2];
  i47 = i47 + 4 | 0;
  i48 = i48 + 4 | 0;
 } while ((i47 | 0) < (i49 | 0));
 HEAP32[i46 >> 2] = i33;
 HEAP32[i46 + 4 >> 2] = i32;
 HEAP32[i46 + 8 >> 2] = i31;
 HEAP32[i46 + 12 >> 2] = i19;
 HEAP32[i46 + 16 >> 2] = i18;
 HEAP32[i46 + 20 >> 2] = i17;
 HEAP32[i46 + 24 >> 2] = i16;
 HEAP32[i46 + 28 >> 2] = i15;
 HEAP32[i46 + 32 >> 2] = i14;
 HEAP32[i46 + 36 >> 2] = i13;
 HEAP32[i46 + 40 >> 2] = i12;
 HEAP32[i46 + 44 >> 2] = i11;
 HEAP32[i46 + 48 >> 2] = i10;
 HEAP32[i46 + 52 >> 2] = i9;
 HEAP32[i46 + 56 >> 2] = i8;
 HEAP32[i46 + 60 >> 2] = i7;
 HEAP32[i46 + 64 >> 2] = i6;
 HEAP32[i46 + 68 >> 2] = i5;
 HEAP32[i46 + 72 >> 2] = i4;
 HEAP32[i46 + 76 >> 2] = i3;
 HEAP32[i46 + 80 >> 2] = i2;
 HEAP32[i46 + 84 >> 2] = i1;
 i50 = 2;
 return i50 | 0;
}

function __Z31RegisterModuleClasses_Physics2Dv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 876;
 HEAP32[i2 + 8 >> 2] = gb + 801731;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 19;
 HEAP32[i2 + 20 >> 2] = 188;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156440;
 HEAP32[i2 + 44 >> 2] = fb + 238;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 239;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 877;
 HEAP32[i2 + 8 >> 2] = gb + 802696;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 50;
 HEAP32[i2 + 20 >> 2] = 228;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67088;
 HEAP32[i2 + 44 >> 2] = fb + 240;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 241;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 875;
 HEAP32[i2 + 8 >> 2] = gb + 801702;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 62;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156288;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI10Collider2DEvv();
 __Z13RegisterClassI16CircleCollider2DEvv();
 __Z13RegisterClassI17CapsuleCollider2DEvv();
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 878;
 HEAP32[i2 + 8 >> 2] = gb + 802541;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 60;
 HEAP32[i2 + 20 >> 2] = 172;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157088;
 HEAP32[i2 + 44 >> 2] = fb + 242;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 233;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI13BoxCollider2DEvv();
 __Z13RegisterClassI14EdgeCollider2DEvv();
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 874;
 HEAP32[i2 + 8 >> 2] = gb + 800807;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 230;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32628;
 HEAP32[i2 + 44 >> 2] = fb + 234;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 235;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI15AnchoredJoint2DEvv();
 __Z13RegisterClassI15DistanceJoint2DEvv();
 __Z13RegisterClassI15FrictionJoint2DEvv();
 __Z13RegisterClassI12HingeJoint2DEvv();
 HEAP32[i2 >> 2] = gb + 32628;
 HEAP32[i2 + 4 >> 2] = fb + 879;
 HEAP32[i2 + 8 >> 2] = gb + 802586;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 254;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157292;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 880;
 HEAP32[i2 + 8 >> 2] = gb + 802891;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 234;
 HEAP32[i2 + 20 >> 2] = 124;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157632;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 881;
 HEAP32[i2 + 8 >> 2] = gb + 803021;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 231;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157844;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 32628;
 HEAP32[i2 + 4 >> 2] = fb + 882;
 HEAP32[i2 + 8 >> 2] = gb + 803162;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 257;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 158272;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI12FixedJoint2DEvv();
 __Z13RegisterClassI12WheelJoint2DEvv();
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 883;
 HEAP32[i2 + 8 >> 2] = gb + 806798;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 246;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154956;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI15ConstantForce2DEvv();
 __Z13RegisterClassI10Effector2DEvv();
 __Z13RegisterClassI14AreaEffector2DEvv();
 __Z13RegisterClassI18BuoyancyEffector2DEvv();
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 884;
 HEAP32[i2 + 8 >> 2] = gb + 802334;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 250;
 HEAP32[i2 + 20 >> 2] = 124;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156888;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 885;
 HEAP32[i2 + 8 >> 2] = gb + 802207;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 251;
 HEAP32[i2 + 20 >> 2] = 92;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156664;
 HEAP32[i2 + 44 >> 2] = fb + 243;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 244;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 886;
 HEAP32[i2 + 8 >> 2] = gb + 803070;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 252;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 158068;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZN5physx10SubSortSAH5splitEPjj(i1, i38, i36) {
 i1 = i1 | 0;
 i38 = i38 | 0;
 i36 = i36 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i39 + 49 | 0;
 i35 = i39 + 48 | 0;
 i29 = i39 + 36 | 0;
 i37 = i39 + 24 | 0;
 i30 = i39 + 12 | 0;
 i31 = i39;
 if (i36 >>> 0 < 2) {
  i38 = 0;
  STACKTOP = i39;
  return i38 | 0;
 }
 if ((i36 | 0) == 2) {
  i38 = 1;
  STACKTOP = i39;
  return i38 | 0;
 }
 i25 = i36 >>> 0 > 3;
 i26 = i25 ? 2 : 1;
 i27 = i36 - i26 | 0;
 HEAP32[i30 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i31 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i1 + 28 >> 2];
 i14 = i1 + 8 | 0;
 i32 = i1 + 48 | 0;
 i15 = i1 + 4 | 0;
 i16 = (i27 | 0) < (i26 | 0);
 i17 = i36 + -1 | 0;
 i18 = i36 + -2 | 0;
 i19 = (i18 | 0) > (i27 | 0);
 i20 = i36 >>> 1;
 i21 = i27 - i26 | 0;
 i22 = (i21 | 0) < 0;
 i23 = i1 + 12 | 0;
 i24 = i1 + 16 | 0;
 i33 = i1 + 44 | 0;
 i12 = i36 + 1 - (i26 << 1) | 0;
 i13 = 0;
 do {
  i1 = HEAP32[i30 + (i13 << 2) >> 2] | 0;
  i6 = HEAP32[i31 + (i13 << 2) >> 2] | 0;
  if ((HEAP32[i32 >> 2] | 0) == (i36 | 0)) {
   i1 = HEAP32[i15 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i36 | 0));
  } else {
   i2 = HEAP32[i33 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i2 + (i5 << 2) >> 2] = HEAP32[i1 + (HEAP32[i38 + (i5 << 2) >> 2] << 2) >> 2];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i36 | 0));
   __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i2, i36, i34, i35, 32);
   i1 = HEAP32[i33 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i5 = 0;
   do {
    HEAP32[i2 + (i5 << 2) >> 2] = HEAP32[i6 + (HEAP32[i1 + (i5 << 2) >> 2] << 2) >> 2];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i36 | 0));
  }
  i6 = HEAP32[i15 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i14 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 + (i5 << 5) >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i5 << 5) + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i7 + (i5 << 5) + 8 >> 2]);
  f8 = Math_fround(HEAPF32[i7 + (i5 << 5) + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i7 + (i5 << 5) + 20 >> 2]);
  f3 = Math_fround(HEAPF32[i7 + (i5 << 5) + 24 >> 2]);
  if (i25) {
   i1 = 1;
   do {
    i5 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    f40 = Math_fround(HEAPF32[i7 + (i5 << 5) >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i5 << 5) + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i7 + (i5 << 5) + 8 >> 2]);
    f11 = f11 < f40 ? f11 : f40;
    f10 = f10 < f41 ? f10 : f41;
    f4 = f4 < f42 ? f4 : f42;
    f42 = Math_fround(HEAPF32[i7 + (i5 << 5) + 16 >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i5 << 5) + 20 >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i5 << 5) + 24 >> 2]);
    f8 = f8 > f42 ? f8 : f42;
    f9 = f9 > f41 ? f9 : f41;
    f3 = f3 > f40 ? f3 : f40;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i26 | 0));
  }
  if (!i16) {
   i5 = HEAP32[i23 >> 2] | 0;
   i1 = 0;
   i2 = i26;
   while (1) {
    i43 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) + 8 >> 2]);
    f11 = f11 < f41 ? f11 : f41;
    f10 = f10 < f40 ? f10 : f40;
    f4 = f4 < f42 ? f4 : f42;
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) + 16 >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 20 >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) + 24 >> 2]);
    f8 = f8 > f42 ? f8 : f42;
    f9 = f9 > f40 ? f9 : f40;
    f3 = f3 > f41 ? f3 : f41;
    f41 = Math_fround(f8 - f11);
    f40 = Math_fround(f9 - f10);
    f42 = Math_fround(f3 - f4);
    HEAPF32[i5 + (i1 << 2) >> 2] = Math_fround(Math_fround(f40 * f42) + Math_fround(Math_fround(f41 * f40) + Math_fround(f41 * f42)));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 1 | 0;
   }
  }
  i43 = HEAP32[i6 + (i17 << 2) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i7 + (i43 << 5) >> 2]);
  f4 = Math_fround(HEAPF32[i7 + (i43 << 5) + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i7 + (i43 << 5) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i43 << 5) + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i7 + (i43 << 5) + 20 >> 2]);
  f9 = Math_fround(HEAPF32[i7 + (i43 << 5) + 24 >> 2]);
  if (i19) {
   i1 = i18;
   do {
    i43 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) + 4 >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 8 >> 2]);
    f3 = f3 < f42 ? f3 : f42;
    f4 = f4 < f41 ? f4 : f41;
    f8 = f8 < f40 ? f8 : f40;
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 16 >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) + 20 >> 2]);
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) + 24 >> 2]);
    f10 = f10 > f40 ? f10 : f40;
    f11 = f11 > f41 ? f11 : f41;
    f9 = f9 > f42 ? f9 : f42;
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) > (i27 | 0));
  }
  if (!i16) {
   i5 = HEAP32[i24 >> 2] | 0;
   i1 = 0;
   i2 = i27;
   while (1) {
    i43 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) + 8 >> 2]);
    f3 = f3 < f41 ? f3 : f41;
    f4 = f4 < f40 ? f4 : f40;
    f8 = f8 < f42 ? f8 : f42;
    f42 = Math_fround(HEAPF32[i7 + (i43 << 5) + 16 >> 2]);
    f40 = Math_fround(HEAPF32[i7 + (i43 << 5) + 20 >> 2]);
    f41 = Math_fround(HEAPF32[i7 + (i43 << 5) + 24 >> 2]);
    f10 = f10 > f42 ? f10 : f42;
    f11 = f11 > f40 ? f11 : f40;
    f9 = f9 > f41 ? f9 : f41;
    f41 = Math_fround(f10 - f3);
    f40 = Math_fround(f11 - f4);
    f42 = Math_fround(f9 - f8);
    HEAPF32[i5 + (i1 << 2) >> 2] = Math_fround(Math_fround(f40 * f42) + Math_fround(Math_fround(f41 * f40) + Math_fround(f41 * f42)));
    if ((i2 | 0) <= (i26 | 0)) break; else {
     i1 = i1 + 1 | 0;
     i2 = i2 + -1 | 0;
    }
   }
  }
  if (i22) {
   f3 = Math_fround(3402823469999999843913219.0e14);
   i1 = 0;
  } else {
   i5 = HEAP32[i23 >> 2] | 0;
   i6 = HEAP32[i24 >> 2] | 0;
   i7 = 0;
   f4 = Math_fround(3402823469999999843913219.0e14);
   i2 = 0;
   while (1) {
    i1 = i7 + i26 | 0;
    f42 = Math_fround(i1 | 0);
    i43 = i21 - i7 | 0;
    f3 = Math_fround(i43 + i26 | 0);
    f42 = Math_fround(f42 * Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]));
    f3 = Math_fround(f42 + Math_fround(f3 * Math_fround(HEAPF32[i6 + (i43 << 2) >> 2])));
    if (f3 < f4) i28 = 26; else if (!(f3 <= f4)) {
     f3 = f4;
     i1 = i2;
    } else {
     i44 = i1 - i20 | 0;
     i43 = i2 - i20 | 0;
     if ((((i44 | 0) > -1 ? i44 : 0 - i44 | 0) | 0) < (((i43 | 0) > -1 ? i43 : 0 - i43 | 0) | 0)) i28 = 26; else {
      f3 = f4;
      i1 = i2;
     }
    }
    if ((i28 | 0) == 26) i28 = 0;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i12 | 0)) break; else {
     f4 = f3;
     i2 = i1;
    }
   }
  }
  HEAPF32[i29 + (i13 << 2) >> 2] = f3;
  HEAP32[i37 + (i13 << 2) >> 2] = i1;
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 3);
 f42 = Math_fround(HEAPF32[i29 >> 2]);
 f4 = Math_fround(HEAPF32[i29 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i29 + 8 >> 2]);
 if (!(f42 <= f4) | !(f42 <= f3)) if (!(f4 <= f3)) i7 = 2; else i7 = 1; else i7 = 0;
 i5 = HEAP32[i30 + (i7 << 2) >> 2] | 0;
 i6 = HEAP32[i31 + (i7 << 2) >> 2] | 0;
 if ((HEAP32[i32 >> 2] | 0) == (i36 | 0)) {
  i1 = 0;
  do {
   HEAP32[i38 + (i1 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i36 | 0));
 } else {
  i1 = HEAP32[i33 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i5 + (HEAP32[i38 + (i2 << 2) >> 2] << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i36 | 0));
  __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(HEAP32[i33 >> 2] | 0, i36, i34, i35, 32);
  i1 = HEAP32[i33 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i38 + (i2 << 2) >> 2] = HEAP32[i6 + (HEAP32[i1 + (i2 << 2) >> 2] << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i36 | 0));
 }
 i44 = HEAP32[i37 + (i7 << 2) >> 2] | 0;
 i44 = (i36 | 0) == 3 & (i44 | 0) == 0 ? 1 : i44;
 STACKTOP = i39;
 return i44 | 0;
}

function __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i11, i12, i23, i34) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i23 = i23 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0;
 if ((i23 | 0) <= 0) return;
 i55 = i11 + 868 | 0;
 i66 = i11 + 872 | 0;
 i67 = i11 + 870 | 0;
 i68 = i11 + 340 | 0;
 i69 = i11 + 869 | 0;
 i13 = i11 + 871 | 0;
 i14 = i11 + 420 | 0;
 i15 = i11 + 480 | 0;
 i16 = i11 + 500 | 0;
 i17 = i11 + 520 | 0;
 i18 = i11 + 540 | 0;
 i19 = i11 + 880 | 0;
 i20 = i11 + 440 | 0;
 i21 = i11 + 460 | 0;
 i22 = i11 + 400 | 0;
 i24 = i11 + 360 | 0;
 i25 = i11 + 380 | 0;
 i26 = i11 + 300 | 0;
 i27 = i11 + 320 | 0;
 i28 = i11 + 60 | 0;
 i29 = i11 + 120 | 0;
 i30 = i11 + 20 | 0;
 i31 = i11 + 80 | 0;
 i32 = i11 + 140 | 0;
 i33 = i11 + 40 | 0;
 i35 = i11 + 100 | 0;
 i36 = i11 + 160 | 0;
 i37 = i11 + 220 | 0;
 i38 = i11 + 200 | 0;
 i39 = i11 + 180 | 0;
 i40 = i11 + 60 | 0;
 i41 = i11 + 120 | 0;
 i42 = i11 + 240 | 0;
 i43 = i11 + 20 | 0;
 i44 = i11 + 80 | 0;
 i45 = i11 + 140 | 0;
 i46 = i11 + 260 | 0;
 i47 = i11 + 40 | 0;
 i48 = i11 + 100 | 0;
 i49 = i11 + 160 | 0;
 i50 = i11 + 280 | 0;
 i51 = i11 + 60 | 0;
 i52 = i11 + 120 | 0;
 i53 = i11 + 240 | 0;
 i54 = i11 + 180 | 0;
 i56 = i11 + 20 | 0;
 i57 = i11 + 80 | 0;
 i58 = i11 + 140 | 0;
 i59 = i11 + 260 | 0;
 i60 = i11 + 200 | 0;
 i61 = i11 + 40 | 0;
 i62 = i11 + 100 | 0;
 i63 = i11 + 160 | 0;
 i64 = i11 + 280 | 0;
 i65 = i11 + 220 | 0;
 i10 = 0;
 do {
  i9 = i10 + i34 | 0;
  i2 = i12 + (i10 * 120 | 0) | 0;
  i4 = i12 + (i10 * 120 | 0) + 12 | 0;
  i5 = i12 + (i10 * 120 | 0) + 24 | 0;
  i71 = HEAP32[i55 >> 2] | 0;
  i6 = i12 + (i10 * 120 | 0) + 48 | 0;
  i7 = (HEAP8[i66 >> 0] | 0) == 0;
  i8 = i12 + (i10 * 120 | 0) + 36 | 0;
  i1 = i71 >>> 16 & 255;
  do if (!((i71 & 255) << 24 >> 24)) {
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 >> 2] = HEAP32[(HEAP32[i28 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i29 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 >> 2] = HEAP32[gb + 62536 >> 2];
   if (i7) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[(HEAP32[i39 >> 2] | 0) + (i9 << 2) >> 2]);
   HEAPF32[i8 >> 2] = f3;
   HEAP32[i2 + 4 >> 2] = HEAP32[(HEAP32[i30 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[(HEAP32[i31 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[(HEAP32[i32 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
   if (i7) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[(HEAP32[i38 >> 2] | 0) + (i9 << 2) >> 2]);
   HEAPF32[i8 + 4 >> 2] = f3;
   HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i33 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[(HEAP32[i35 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[(HEAP32[i36 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
   if (i7) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[(HEAP32[i37 >> 2] | 0) + (i9 << 2) >> 2]);
   HEAPF32[i8 + 8 >> 2] = f3;
  } else if (i7) {
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 >> 2] = HEAP32[(HEAP32[i40 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i41 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 >> 2] = HEAP32[(HEAP32[i42 >> 2] | 0) + (i9 << 2) >> 2];
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAP32[i2 + 4 >> 2] = HEAP32[(HEAP32[i43 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[(HEAP32[i44 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[(HEAP32[i45 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[(HEAP32[i46 >> 2] | 0) + (i9 << 2) >> 2];
   HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
   HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i47 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[(HEAP32[i48 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[(HEAP32[i49 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[(HEAP32[i50 >> 2] | 0) + (i9 << 2) >> 2];
   HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
   break;
  } else {
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 >> 2] = HEAP32[(HEAP32[i51 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i52 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 >> 2] = HEAP32[(HEAP32[i53 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i8 >> 2] = HEAP32[(HEAP32[i54 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[(HEAP32[i56 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[(HEAP32[i57 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[(HEAP32[i58 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[(HEAP32[i59 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[(HEAP32[i60 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i61 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[(HEAP32[i62 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[(HEAP32[i63 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[(HEAP32[i64 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[(HEAP32[i65 >> 2] | 0) + (i9 << 2) >> 2];
   i1 = HEAP8[i67 >> 0] | 0;
   break;
  } while (0);
  i2 = i12 + (i10 * 120 | 0) + 60 | 0;
  if (!(i1 << 24 >> 24)) {
   i71 = HEAP32[(HEAP32[i68 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i12 + (i10 * 120 | 0) + 64 >> 2] = Math_fround(0.0);
   HEAP32[i12 + (i10 * 120 | 0) + 68 >> 2] = i71;
  } else {
   i8 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i71 = HEAP32[(HEAP32[i68 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i26 >> 2] | 0) + (i9 << 2) >> 2];
   HEAP32[i12 + (i10 * 120 | 0) + 64 >> 2] = i8;
   HEAP32[i12 + (i10 * 120 | 0) + 68 >> 2] = i71;
  }
  do if (HEAP8[i69 >> 0] | 0) {
   i1 = i12 + (i10 * 120 | 0) + 72 | 0;
   if (!(HEAP8[i67 >> 0] | 0)) {
    i71 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i9 << 2) >> 2] | 0;
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    HEAPF32[i12 + (i10 * 120 | 0) + 76 >> 2] = Math_fround(0.0);
    HEAP32[i12 + (i10 * 120 | 0) + 80 >> 2] = i71;
    break;
   } else {
    i8 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i9 << 2) >> 2] | 0;
    i71 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i9 << 2) >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[(HEAP32[i24 >> 2] | 0) + (i9 << 2) >> 2];
    HEAP32[i12 + (i10 * 120 | 0) + 76 >> 2] = i8;
    HEAP32[i12 + (i10 * 120 | 0) + 80 >> 2] = i71;
    break;
   }
  } while (0);
  i1 = i12 + (i10 * 120 | 0) + 84 | 0;
  i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  if (!(HEAP8[i13 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i12 + (i10 * 120 | 0) + 88 >> 2] = i2;
   HEAP32[i12 + (i10 * 120 | 0) + 92 >> 2] = i2;
  } else {
   i8 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i71 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i12 + (i10 * 120 | 0) + 88 >> 2] = i8;
   HEAP32[i12 + (i10 * 120 | 0) + 92 >> 2] = i71;
  }
  HEAP32[i12 + (i10 * 120 | 0) + 96 >> 2] = HEAP32[(HEAP32[i15 >> 2] | 0) + (i9 << 2) >> 2];
  HEAP32[i12 + (i10 * 120 | 0) + 100 >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + (i9 << 2) >> 2];
  f3 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + (i9 << 2) >> 2]) * Math_fround(.00999999977)));
  i2 = (HEAP32[i18 >> 2] | 0) + (i9 << 2) | 0;
  HEAPF32[i12 + (i10 * 120 | 0) + 104 >> 2] = Math_fround(f3 / Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i12 + (i10 * 120 | 0) + 108 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 >> 2]));
  i2 = HEAP32[i19 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[i12 + (i10 * 120 | 0) + 112 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i11 + 560 + (i1 * 20 | 0) >> 2] | 0) + (i9 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   if ((i1 | 0) < 2) i70 = 23;
  } else {
   i1 = 0;
   i70 = 23;
  }
  if ((i70 | 0) == 23) {
   i70 = 0;
   _memset(i12 + (i10 * 120 | 0) + 112 + (i1 << 2) | 0, 0, 8 - (i1 << 2) | 0) | 0;
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i23 | 0));
 return;
}

function __ZN5physx24PxcArticulationFnsScalar16multiplySubtractERKNS_9SpInertiaEPKNS_2Cm13SpatialVectorES7_(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0;
 f28 = Math_fround(HEAPF32[i3 >> 2]);
 f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f5 = Math_fround(f28 * f7);
 f6 = Math_fround(f30 * f7);
 f7 = Math_fround(f31 * f7);
 f17 = Math_fround(f28 * f19);
 f18 = Math_fround(f30 * f19);
 f19 = Math_fround(f31 * f19);
 f20 = Math_fround(f28 * f22);
 f21 = Math_fround(f30 * f22);
 f22 = Math_fround(f31 * f22);
 f23 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f41 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f33 = Math_fround(f28 * f23);
 f8 = Math_fround(f30 * f23);
 f11 = Math_fround(f31 * f23);
 f24 = Math_fround(f28 * f26);
 f25 = Math_fround(f30 * f26);
 f27 = Math_fround(f31 * f26);
 f28 = Math_fround(f28 * f41);
 f30 = Math_fround(f30 * f41);
 f31 = Math_fround(f31 * f41);
 f29 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f13 = Math_fround(f23 * f29);
 f12 = Math_fround(f23 * f14);
 f23 = Math_fround(f23 * f15);
 f10 = Math_fround(f26 * f29);
 f9 = Math_fround(f26 * f14);
 f26 = Math_fround(f26 * f15);
 f29 = Math_fround(f41 * f29);
 f14 = Math_fround(f41 * f14);
 f15 = Math_fround(f41 * f15);
 f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) - f6);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f7);
 f17 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) - f17);
 f18 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) - f18);
 f19 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) - f19);
 f20 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) - f20);
 f21 = Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) - f21);
 f22 = Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) - f22);
 f33 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) - f33);
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) - f8);
 f11 = Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) - f11);
 f24 = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) - f24);
 f25 = Math_fround(Math_fround(HEAPF32[i1 + 52 >> 2]) - f25);
 f27 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) - f27);
 f28 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) - f28);
 f30 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) - f30);
 f31 = Math_fround(Math_fround(HEAPF32[i1 + 68 >> 2]) - f31);
 f13 = Math_fround(Math_fround(HEAPF32[i1 + 72 >> 2]) - f13);
 f12 = Math_fround(Math_fround(HEAPF32[i1 + 76 >> 2]) - f12);
 f23 = Math_fround(Math_fround(HEAPF32[i1 + 80 >> 2]) - f23);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 84 >> 2]) - f10);
 f9 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) - f9);
 f26 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) - f26);
 f29 = Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) - f29);
 f14 = Math_fround(Math_fround(HEAPF32[i1 + 100 >> 2]) - f14);
 f15 = Math_fround(Math_fround(HEAPF32[i1 + 104 >> 2]) - f15);
 f41 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f40 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f39 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f54 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f51 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f48 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f32 = Math_fround(f41 * f54);
 f55 = Math_fround(f40 * f54);
 f54 = Math_fround(f39 * f54);
 f53 = Math_fround(f41 * f51);
 f52 = Math_fround(f40 * f51);
 f51 = Math_fround(f39 * f51);
 f50 = Math_fround(f41 * f48);
 f49 = Math_fround(f40 * f48);
 f48 = Math_fround(f39 * f48);
 f38 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f37 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 f47 = Math_fround(f41 * f38);
 f46 = Math_fround(f40 * f38);
 f45 = Math_fround(f39 * f38);
 f44 = Math_fround(f41 * f37);
 f43 = Math_fround(f40 * f37);
 f42 = Math_fround(f39 * f37);
 f41 = Math_fround(f41 * f16);
 f40 = Math_fround(f40 * f16);
 f39 = Math_fround(f39 * f16);
 f36 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f35 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f34 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f32 = Math_fround(f5 - f32);
 f55 = Math_fround(f6 - f55);
 f54 = Math_fround(f7 - f54);
 f53 = Math_fround(f17 - f53);
 f52 = Math_fround(f18 - f52);
 f51 = Math_fround(f19 - f51);
 f50 = Math_fround(f20 - f50);
 f49 = Math_fround(f21 - f49);
 f48 = Math_fround(f22 - f48);
 f47 = Math_fround(f33 - f47);
 f46 = Math_fround(f8 - f46);
 f45 = Math_fround(f11 - f45);
 f44 = Math_fround(f24 - f44);
 f43 = Math_fround(f25 - f43);
 f42 = Math_fround(f27 - f42);
 f41 = Math_fround(f28 - f41);
 f40 = Math_fround(f30 - f40);
 f39 = Math_fround(f31 - f39);
 f13 = Math_fround(f13 - Math_fround(f38 * f36));
 f12 = Math_fround(f12 - Math_fround(f38 * f35));
 f38 = Math_fround(f23 - Math_fround(f38 * f34));
 f10 = Math_fround(f10 - Math_fround(f37 * f36));
 f9 = Math_fround(f9 - Math_fround(f37 * f35));
 f37 = Math_fround(f26 - Math_fround(f37 * f34));
 f36 = Math_fround(f29 - Math_fround(f16 * f36));
 f35 = Math_fround(f14 - Math_fround(f16 * f35));
 f34 = Math_fround(f15 - Math_fround(f16 * f34));
 f16 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f29 = Math_fround(HEAPF32[i4 + 64 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 68 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 72 >> 2]);
 f31 = Math_fround(f16 * f29);
 f30 = Math_fround(f15 * f29);
 f29 = Math_fround(f14 * f29);
 f28 = Math_fround(f16 * f26);
 f27 = Math_fround(f15 * f26);
 f26 = Math_fround(f14 * f26);
 f25 = Math_fround(f16 * f23);
 f24 = Math_fround(f15 * f23);
 f23 = Math_fround(f14 * f23);
 f11 = Math_fround(HEAPF32[i4 + 80 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 84 >> 2]);
 f33 = Math_fround(HEAPF32[i4 + 88 >> 2]);
 f22 = Math_fround(f16 * f11);
 f21 = Math_fround(f15 * f11);
 f20 = Math_fround(f14 * f11);
 f19 = Math_fround(f16 * f8);
 f18 = Math_fround(f15 * f8);
 f17 = Math_fround(f14 * f8);
 f16 = Math_fround(f16 * f33);
 f15 = Math_fround(f15 * f33);
 f14 = Math_fround(f14 * f33);
 f7 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f30 = Math_fround(f55 - f30);
 f29 = Math_fround(f54 - f29);
 f28 = Math_fround(f53 - f28);
 f27 = Math_fround(f52 - f27);
 f26 = Math_fround(f51 - f26);
 f25 = Math_fround(f50 - f25);
 f24 = Math_fround(f49 - f24);
 f23 = Math_fround(f48 - f23);
 f22 = Math_fround(f47 - f22);
 f21 = Math_fround(f46 - f21);
 f20 = Math_fround(f45 - f20);
 f19 = Math_fround(f44 - f19);
 f18 = Math_fround(f43 - f18);
 f17 = Math_fround(f42 - f17);
 f16 = Math_fround(f41 - f16);
 f15 = Math_fround(f40 - f15);
 f14 = Math_fround(f39 - f14);
 f13 = Math_fround(f13 - Math_fround(f11 * f7));
 f12 = Math_fround(f12 - Math_fround(f11 * f6));
 f11 = Math_fround(f38 - Math_fround(f11 * f5));
 f10 = Math_fround(f10 - Math_fround(f8 * f7));
 f9 = Math_fround(f9 - Math_fround(f8 * f6));
 f8 = Math_fround(f37 - Math_fround(f8 * f5));
 f7 = Math_fround(f36 - Math_fround(f33 * f7));
 f6 = Math_fround(f35 - Math_fround(f33 * f6));
 f5 = Math_fround(f34 - Math_fround(f33 * f5));
 HEAPF32[i2 >> 2] = Math_fround(f32 - f31);
 HEAPF32[i2 + 4 >> 2] = f30;
 HEAPF32[i2 + 8 >> 2] = f29;
 HEAPF32[i2 + 12 >> 2] = f28;
 HEAPF32[i2 + 16 >> 2] = f27;
 HEAPF32[i2 + 20 >> 2] = f26;
 HEAPF32[i2 + 24 >> 2] = f25;
 HEAPF32[i2 + 28 >> 2] = f24;
 HEAPF32[i2 + 32 >> 2] = f23;
 HEAPF32[i2 + 36 >> 2] = f22;
 HEAPF32[i2 + 40 >> 2] = f21;
 HEAPF32[i2 + 44 >> 2] = f20;
 HEAPF32[i2 + 48 >> 2] = f19;
 HEAPF32[i2 + 52 >> 2] = f18;
 HEAPF32[i2 + 56 >> 2] = f17;
 HEAPF32[i2 + 60 >> 2] = f16;
 HEAPF32[i2 + 64 >> 2] = f15;
 HEAPF32[i2 + 68 >> 2] = f14;
 HEAPF32[i2 + 72 >> 2] = f13;
 HEAPF32[i2 + 76 >> 2] = f12;
 HEAPF32[i2 + 80 >> 2] = f11;
 HEAPF32[i2 + 84 >> 2] = f10;
 HEAPF32[i2 + 88 >> 2] = f9;
 HEAPF32[i2 + 92 >> 2] = f8;
 HEAPF32[i2 + 96 >> 2] = f7;
 HEAPF32[i2 + 100 >> 2] = f6;
 HEAPF32[i2 + 104 >> 2] = f5;
 return;
}

function __ZN5physx7NpScene9addActorsEPKPNS_7PxActorEj(i22, i21, i14) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i26 + 16 | 0;
 i15 = i26 + 8 | 0;
 i5 = i26 + 272 | 0;
 i18 = i26 + 240 | 0;
 i25 = i26 + 32 | 0;
 i6 = i26 + 24 | 0;
 i7 = i26 + 20 | 0;
 if (HEAP8[i22 + 3696 >> 0] | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 461, gb + 709260 | 0, i26);
  STACKTOP = i26;
  return;
 }
 i12 = i22 + 16 | 0;
 i17 = i22 + 32 | 0;
 __ZN5physx2Sc5Scene19startBatchInsertionERNS0_19BatchInsertionStateE(i17, i18);
 HEAP32[i18 + 12 >> 2] = 64;
 HEAP32[i18 + 16 >> 2] = 20;
 HEAP32[i18 + 20 >> 2] = 64;
 HEAP32[i18 + 24 >> 2] = 20;
 HEAP32[i18 + 28 >> 2] = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i24 = i25 + 192 | 0;
 i19 = i25 + 196 | 0;
 HEAP32[i25 + 200 >> 2] = 0;
 i20 = i25 + 204 | 0;
 HEAP8[i24 >> 0] = 1;
 HEAP32[i19 >> 2] = i25;
 HEAP32[i20 >> 2] = 8;
 L5 : do if (!i14) i23 = 52; else {
  i8 = i22 + 3552 | 0;
  i9 = i22 + 3556 | 0;
  i10 = i22 + 3560 | 0;
  i13 = 0;
  L7 : while (1) {
   i1 = i13;
   i13 = i13 + 1 | 0;
   i11 = i13 >>> 0 < i14 >>> 0;
   if (i11) {
    i4 = HEAP32[i21 + (i13 << 2) >> 2] | 0;
    i3 = i4;
    i28 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
    i27 = getTempRet0() | 0;
    i3 = _i64Add(i3 | 0, 0, 287, 0) | 0;
    i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
    i2 = getTempRet0() | 0;
    i27 = _i64Subtract(1, 0, i28 | 0, i27 | 0) | 0;
    i2 = _i64Add(i27 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
    i3 = getTempRet0() | 0;
    while (1) {
     i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
     i3 = getTempRet0() | 0;
     if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
    }
   }
   i4 = HEAP32[i21 + (i1 << 2) >> 2] | 0;
   i2 = HEAP16[i4 + 4 >> 1] | 0;
   switch ((HEAP32[i4 + ((HEAP32[gb + 1457020 + 68 + ((i2 & 65535) << 2) >> 2] | 0) + 4) >> 2] | 0) >>> 30 | 0) {
   case 0:
    break;
   case 3:
    {
     if ((__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i4) | 0) != (i22 | 0)) {
      i23 = 10;
      break L7;
     }
     break;
    }
   default:
    {
     i23 = 10;
     break L7;
    }
   }
   L17 : do switch (i2 << 16 >> 16) {
   case 6:
    {
     i1 = i4 + 48 | 0;
     i28 = HEAP32[i4 + 52 >> 2] | 0;
     if (!(HEAP16[((i28 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i28 >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 | 0 : HEAP32[i4 + 56 >> 2] | 0) >> 1] & 8)) {
      __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj(i25, HEAPU16[i4 + 24 >> 1] | 0);
      __ZN5physx2Sc5Scene9addStaticEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E(i17, i4, i18, HEAP32[i19 >> 2] | 0);
      __ZN5physx7NpScene24updateScbStateAndSetupSqERKNS_12PxRigidActorERNS_3Scb5ActorERNS_14NpShapeManagerEbPNS_9PxBounds3E(i22, i4, i4 + 48 | 0, i4 + 20 | 0, 0, HEAP32[i19 >> 2] | 0);
      i1 = HEAP32[i9 >> 2] | 0;
      HEAP32[i4 + 36 >> 2] = i1;
      HEAP32[i6 >> 2] = i4;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i4;
       HEAP32[i9 >> 2] = i1 + 1;
      } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) | 0;
      if (!(HEAP32[i4 + 16 >> 2] | 0)) break L17;
      __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i4 + 12 | 0);
      break L17;
     }
     i28 = ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0) | 0) & 8) != 0;
     __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb(i12, i1, i28);
     __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i4 + 20 | 0, i4);
     if (!i28) if (HEAP32[i4 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i4 + 12 | 0);
     i1 = HEAP32[i9 >> 2] | 0;
     HEAP32[i4 + 36 >> 2] = i1;
     HEAP32[i5 >> 2] = i4;
     if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
      HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i4;
      HEAP32[i9 >> 2] = i1 + 1;
     } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i5) | 0;
     break;
    }
   case 5:
    {
     i1 = i4 + 48 | 0;
     i28 = HEAP32[i4 + 52 >> 2] | 0;
     if (HEAP16[((i28 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i28 >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 | 0 : HEAP32[i4 + 56 >> 2] | 0) >> 1] & 8) {
      i28 = ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0) | 0) & 8) != 0;
      __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i12, i1, i28);
      __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i4 + 20 | 0, i4);
      if (!i28) if (HEAP32[i4 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i4 + 12 | 0);
      i1 = HEAP32[i9 >> 2] | 0;
      HEAP32[i4 + 36 >> 2] = i1;
      HEAP32[i5 >> 2] = i4;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i4;
       HEAP32[i9 >> 2] = i1 + 1;
      } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i5) | 0;
      break L17;
     }
     __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj(i25, HEAPU16[i4 + 24 >> 1] | 0);
     __ZN5physx2Sc5Scene7addBodyEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E(i17, i4, i18, HEAP32[i19 >> 2] | 0);
     i2 = i4 + 20 | 0;
     i3 = HEAP32[i19 >> 2] | 0;
     if (Math_fround(HEAPF32[i4 + 276 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 252 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 256 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 260 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 264 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 268 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 272 >> 2]) == Math_fround(0.0)) HEAP32[i4 + 280 >> 2] = 1; else i23 = 35; else i23 = 35; else i23 = 35; else i23 = 35; else i23 = 35; else i23 = 35; else i23 = 35;
     if ((i23 | 0) == 35) {
      i23 = 0;
      HEAP32[i4 + 280 >> 2] = 0;
     }
     __ZN5physx7NpScene24updateScbStateAndSetupSqERKNS_12PxRigidActorERNS_3Scb5ActorERNS_14NpShapeManagerEbPNS_9PxBounds3E(i22, i4, i1, i2, 1, i3);
     i1 = HEAP32[i9 >> 2] | 0;
     HEAP32[i4 + 36 >> 2] = i1;
     HEAP32[i7 >> 2] = i4;
     if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
      HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i4;
      HEAP32[i9 >> 2] = i1 + 1;
     } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i7) | 0;
     if (HEAP32[i4 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i4 + 12 | 0);
     break;
    }
   case 12:
   case 11:
   case 10:
    {
     __ZN5physx7NpScene16addActorInternalERNS_7PxActorE(i22, i4);
     break;
    }
   default:
    {
     i23 = 49;
     break L7;
    }
   } while (0);
   if (!i11) {
    i23 = 52;
    break L5;
   }
  }
  if ((i23 | 0) == 10) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 490, gb + 709322 | 0, i15);
   i2 = i1;
  } else if ((i23 | 0) == 49) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 543, gb + 709401 | 0, i16);
   i2 = i1;
  }
  __ZN5physx2Sc5Scene20finishBatchInsertionERNS0_19BatchInsertionStateE(i17, i18);
  if (i2 | 0) {
   i1 = 0;
   do {
    __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb(i22, HEAP32[i21 + (i1 << 2) >> 2] | 0, 0, 1);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 } while (0);
 if ((i23 | 0) == 52) __ZN5physx2Sc5Scene20finishBatchInsertionERNS0_19BatchInsertionStateE(i17, i18);
 i28 = HEAP32[i20 >> 2] | 0;
 do if ((i28 | 0) > -1 & (i28 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  if ((i25 | 0) == (i1 | 0)) {
   HEAP8[i24 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i26;
 return;
}

function __ZN9Rigidbody8TransferI14SafeBinaryReadEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i6 = i11 + 4 | 0;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i7, i10);
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i4 = i7 + 68 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827258 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802440 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802447 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i7 + 83 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 839070 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802877 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i7 + 102 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802800 | 0, HEAP32[gb + 37300 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i10, 1) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 737584 | 0, i4, i8, 0) | 0;
  if (!i1) i1 = 0; else {
   do if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i5 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i10);
   i1 = (HEAP8[i6 >> 0] | 0) == 0 ? 0 : 112;
  }
  HEAP32[i7 + 88 >> 2] = i1;
  i1 = HEAP32[gb + 37040 >> 2] | 0;
 } else {
  i5 = i7 + 88 | 0;
  i1 = HEAP32[gb + 37040 >> 2] | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802850 | 0, i1, i8, 0) | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 0) {
    i2 = i10 + 16 | 0;
    i6 = HEAP32[i10 + 20 >> 2] | 0;
    i3 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    if (i3 >>> 0 < i6 >>> 0) i9 = 77; else {
     i4 = i3 + 4 | 0;
     if (i4 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 77; else {
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i2 >> 2] = i4;
     }
    }
    if ((i9 | 0) == 77) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i2 = HEAP32[i8 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i5 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
 }
 i4 = i7 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802829 | 0, i1, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i8 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i8 >>> 0) i9 = 89; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 89; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i9 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN22RenderingCommandBuffer24PostExecuteCommandBufferER17ShaderPassContextP13RenderTexture(i13, i4, i3) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 40 | 0;
 i22 = i23 + 16 | 0;
 i19 = i23;
 i15 = i23 + 32 | 0;
 i16 = i23 + 28 | 0;
 i17 = i23 + 36 | 0;
 i18 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i18) {
  STACKTOP = i23;
  return;
 }
 if (!(HEAP8[i13 + 36 >> 0] | 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = i13 + 164 | 0;
 i14 = i1 + 11 | 0;
 if ((HEAP8[i14 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
 i2 = __Z26profiler_get_info_for_namePKc13ProfilerGroup(i2, 0) | 0;
 if ((HEAP16[i2 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i2, i21);
  i12 = i2;
 } else i12 = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 648 >> 2] | 0, i8 | 0, i11 | 0);
 HEAP32[i16 >> 2] = i3;
 i11 = i13 + 16 | 0;
 i8 = i4 + 36 | 0;
 i9 = i13 + 72 | 0;
 i10 = i13 + 60 | 0;
 i2 = 0;
 i4 = 21;
 L14 : do {
  i2 = i2 + 3 & -4;
  i5 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i5 + i2 >> 2] | 0;
  L16 : do switch (i3 | 0) {
  case 1:
   {
    i4 = 1;
    i2 = i2 + 99 & -4;
    break;
   }
  case 0:
   {
    i4 = 0;
    i2 = i2 + 31 & -4;
    break;
   }
  case 2:
   {
    i4 = 2;
    i2 = i2 + 103 & -4;
    break;
   }
  case 3:
   {
    i4 = 3;
    i2 = i2 + 103 & -4;
    break;
   }
  case 4:
   {
    i4 = 4;
    i2 = i2 + 35 & -4;
    break;
   }
  case 5:
   {
    i6 = i2 + 7 & -4;
    i2 = i6 + 28 | 0;
    i6 = i5 + i6 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i15 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i20 = 21; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i3, i15);
       i4 = HEAP32[i21 >> 2] | 0;
       i7 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i7 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i7 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i20 = 21; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i20 = 23;
      }
     }
     if ((i20 | 0) == 21) i20 = 23;
     if ((i20 | 0) == 23) {
      i20 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i16 >> 2] = i3;
    __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i13, HEAP32[i6 + 4 >> 2] | 0, i6 + 8 | 0, gb + 424362 | 0, i16) | 0;
    i4 = 5;
    break;
   }
  case 6:
   {
    i3 = i2 + 7 & -4;
    i2 = i3 + 196 | 0;
    i3 = i5 + i3 | 0;
    if ((HEAP32[i3 >> 2] | 0) > 0) {
     HEAP32[i16 >> 2] = HEAP32[i3 + 124 >> 2];
     __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i13, HEAP32[i3 + 36 >> 2] | 0, i3 + 68 | 0, gb + 424407 | 0, i16) | 0;
     i4 = 6;
    } else i4 = 6;
    break;
   }
  case 7:
   {
    i4 = 7;
    i2 = i2 + 59 & -4;
    break;
   }
  case 8:
   {
    i4 = 8;
    i2 = i2 + 35 & -4;
    break;
   }
  case 9:
   {
    i7 = i2 + 7 & -4;
    i2 = i7 + 36 | 0;
    i7 = i5 + i7 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    L43 : do if ((i4 | 0) == -1) i3 = HEAP32[i7 + 32 >> 2] | 0; else {
     i5 = HEAP32[i9 >> 2] | 0;
     L45 : do if (i5 | 0) {
      i6 = HEAP32[i10 >> 2] | 0;
      i3 = 0;
      while (1) {
       if ((HEAP32[i6 + (i3 << 3) >> 2] | 0) == (i4 | 0)) break;
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i5 | 0)) break L45;
      }
      i3 = HEAP32[i6 + (i3 << 3) + 4 >> 2] | 0;
      if (i3 | 0) break L43;
     } while (0);
     i3 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i7) | 0;
     if ((HEAP8[i14 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
     HEAP32[i19 >> 2] = i3;
     HEAP32[i19 + 4 >> 2] = i4;
     HEAP32[i19 + 8 >> 2] = gb + 424472;
     __Z6FormatPKcz(i21, gb + 423945 | 0, i19);
     __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 512, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
     i4 = 9;
     break L16;
    } while (0);
    __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i8, i7, i3);
    i4 = 9;
    break;
   }
  case 10:
   {
    i4 = 10;
    i2 = i2 + 11 & -4;
    break;
   }
  case 11:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i8, i4, Math_fround(HEAPF32[i4 + 4 >> 2]), 0);
    i4 = 11;
    i2 = i2 + 8 | 0;
    break;
   }
  case 12:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i8, i4, i4 + 4 | 0, 0);
    i4 = 12;
    i2 = i2 + 20 | 0;
    break;
   }
  case 13:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i8, i4, i4 + 4 | 0, 0);
    i4 = 13;
    i2 = i2 + 68 | 0;
    break;
   }
  case 16:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    i7 = HEAP32[i4 + 4 >> 2] | 0;
    i2 = i2 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i8, i4, 0, i5 + i2 | 0, 4, i7) | 0;
    i4 = 16;
    i2 = (i7 << 2) + i2 | 0;
    break;
   }
  case 17:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    i7 = HEAP32[i4 + 4 >> 2] | 0;
    i2 = i2 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i8, i4, 1, i5 + i2 | 0, 16, i7) | 0;
    i4 = 17;
    i2 = (i7 << 4) + i2 | 0;
    break;
   }
  case 18:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    i7 = HEAP32[i4 + 4 >> 2] | 0;
    i2 = i2 + 11 & -4;
    __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i8, i4, 2, i5 + i2 | 0, 64, i7) | 0;
    i4 = 18;
    i2 = (i7 << 6) + i2 | 0;
    break;
   }
  case 14:
   {
    i3 = i2 + 7 & -4;
    i2 = i3 + 20 | 0;
    i3 = i5 + i3 | 0;
    i4 = HEAP32[i3 + 16 >> 2] | 0;
    HEAP32[i21 >> 2] = i4;
    i5 = HEAP32[i3 + 8 >> 2] | 0;
    if ((i5 | 0) == -1) __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i8, i3, i4); else if (__ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i13, i5, i3 + 12 | 0, gb + 424496 | 0, i21) | 0) __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i8, i3, HEAP32[i21 >> 2] | 0);
    i4 = 14;
    break;
   }
  case 15:
   {
    i2 = i2 + 7 & -4;
    i4 = i5 + i2 | 0;
    HEAP32[i17 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
    __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i8, i4, i21, 0);
    i4 = 15;
    i2 = i2 + 8 | 0;
    break;
   }
  case 20:
   {
    i4 = 20;
    i2 = i2 + 15 & -4;
    break;
   }
  case 19:
   {
    i4 = 19;
    i2 = i2 + 27 & -4;
    break;
   }
  default:
   {
    i20 = 56;
    break L14;
   }
  } while (0);
 } while (i2 >>> 0 < i18 >>> 0);
 if ((i20 | 0) == 56) {
  if ((HEAP8[i14 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i22 >> 2] = i3;
  HEAP32[i22 + 4 >> 2] = i4;
  HEAP32[i22 + 8 >> 2] = i1;
  __Z6FormatPKcz(i21, gb + 424034 | 0, i22);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i21, 256, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 }
 i22 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 652 >> 2] | 0, i22 | 0);
 if (!i12) {
  STACKTOP = i23;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i23;
 return;
}

function __ZNK5physx2Gu5RTree11traverseRayILi0EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(i19, i6, i7, i2, i3, i25, i1, f4) {
 i19 = i19 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var f5 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 8 | 0;
 i23 = i24 + 4 | 0;
 i21 = i24;
 i15 = (HEAP32[i19 + 84 >> 2] & 2 | 0) == 0;
 if (i15) i20 = HEAP32[i19 + 92 >> 2] | 0; else i20 = 0;
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 f16 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(-f16);
 f8 = Math_fround(-f17);
 f9 = Math_fround(-f18);
 f5 = f16 > f5 ? f16 : f5;
 f8 = f17 > f8 ? f17 : f8;
 f9 = f18 > f9 ? f18 : f9;
 i7 = f5 > Math_fround(9.99999971e-10);
 i1 = f8 > Math_fround(9.99999971e-10);
 i6 = f9 > Math_fround(9.99999971e-10);
 i2 = i7 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 814313567;
 i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) : 814313567;
 i7 = (i6 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 814313567) | i3 & -2147483648;
 f16 = (HEAP32[tempDoublePtr >> 2] = i2 | i10 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i1 | i11 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_fround(1.0) / f16);
 f8 = Math_fround(Math_fround(1.0) / f17);
 f9 = Math_fround(Math_fround(1.0) / f18);
 f16 = Math_fround(f5 * Math_fround(Math_fround(2.0) - Math_fround(f5 * f16)));
 f17 = Math_fround(f8 * Math_fround(Math_fround(2.0) - Math_fround(f8 * f17)));
 f18 = Math_fround(f9 * Math_fround(Math_fround(2.0) - Math_fround(f9 * f18)));
 f12 = Math_fround(Math_fround(0.0) - Math_fround(f12 * f16));
 f9 = Math_fround(Math_fround(0.0) - Math_fround(f14 * f17));
 f8 = Math_fround(Math_fround(0.0) - Math_fround(f13 * f18));
 i1 = HEAP32[i19 + 68 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if ((i2 | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 if (i15) {
  i3 = 0;
  while (1) {
   i3 = i3 + 1 | 0;
   HEAP32[i22 + (i3 << 2) >> 2] = i2 * 112;
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + -1 | 0;
  }
 } else {
  i2 = HEAP32[i19 + 92 >> 2] | 0;
  i3 = 0;
  do {
   i3 = i3 + 1 | 0;
   HEAP32[i22 + (i3 << 2) >> 2] = i2;
  } while ((i3 | 0) != (i1 | 0));
 }
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 L17 : while (1) {
  i6 = i1;
  while (1) {
   i1 = i6 + -1 | 0;
   i2 = i22 + (i6 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i23 >> 2] = i3;
   if (!(i3 & 1)) {
    f37 = Math_fround(HEAPF32[i20 + i3 >> 2]);
    f33 = Math_fround(HEAPF32[i20 + (i3 + 4) >> 2]);
    f29 = Math_fround(HEAPF32[i20 + (i3 + 8) >> 2]);
    f5 = Math_fround(HEAPF32[i20 + (i3 + 12) >> 2]);
    f26 = Math_fround(HEAPF32[i20 + (i3 + 16) >> 2]);
    f30 = Math_fround(HEAPF32[i20 + (i3 + 20) >> 2]);
    f34 = Math_fround(HEAPF32[i20 + (i3 + 24) >> 2]);
    f38 = Math_fround(HEAPF32[i20 + (i3 + 28) >> 2]);
    f58 = Math_fround(HEAPF32[i20 + (i3 + 32) >> 2]);
    f57 = Math_fround(HEAPF32[i20 + (i3 + 36) >> 2]);
    f56 = Math_fround(HEAPF32[i20 + (i3 + 40) >> 2]);
    f55 = Math_fround(HEAPF32[i20 + (i3 + 44) >> 2]);
    f36 = Math_fround(HEAPF32[i20 + (i3 + 48) >> 2]);
    f32 = Math_fround(HEAPF32[i20 + (i3 + 52) >> 2]);
    f28 = Math_fround(HEAPF32[i20 + (i3 + 56) >> 2]);
    f13 = Math_fround(HEAPF32[i20 + (i3 + 60) >> 2]);
    f42 = Math_fround(HEAPF32[i20 + (i3 + 64) >> 2]);
    f41 = Math_fround(HEAPF32[i20 + (i3 + 68) >> 2]);
    f40 = Math_fround(HEAPF32[i20 + (i3 + 72) >> 2]);
    f39 = Math_fround(HEAPF32[i20 + (i3 + 76) >> 2]);
    f35 = Math_fround(HEAPF32[i20 + (i3 + 80) >> 2]);
    f31 = Math_fround(HEAPF32[i20 + (i3 + 84) >> 2]);
    f27 = Math_fround(HEAPF32[i20 + (i3 + 88) >> 2]);
    f47 = Math_fround(f12 + Math_fround(f16 * f37));
    f48 = Math_fround(f12 + Math_fround(f16 * f33));
    f49 = Math_fround(f12 + Math_fround(f16 * f29));
    f50 = Math_fround(f12 + Math_fround(f16 * f5));
    f26 = Math_fround(f9 + Math_fround(f17 * f26));
    f30 = Math_fround(f9 + Math_fround(f17 * f30));
    f34 = Math_fround(f9 + Math_fround(f17 * f34));
    f38 = Math_fround(f9 + Math_fround(f17 * f38));
    f58 = Math_fround(f8 + Math_fround(f18 * f58));
    f57 = Math_fround(f8 + Math_fround(f18 * f57));
    f56 = Math_fround(f8 + Math_fround(f18 * f56));
    f55 = Math_fround(f8 + Math_fround(f18 * f55));
    f46 = Math_fround(f12 + Math_fround(f16 * f36));
    f45 = Math_fround(f12 + Math_fround(f16 * f32));
    f44 = Math_fround(f12 + Math_fround(f16 * f28));
    f43 = Math_fround(f12 + Math_fround(f16 * f13));
    f42 = Math_fround(f9 + Math_fround(f17 * f42));
    f41 = Math_fround(f9 + Math_fround(f17 * f41));
    f40 = Math_fround(f9 + Math_fround(f17 * f40));
    f39 = Math_fround(f9 + Math_fround(f17 * f39));
    f35 = Math_fround(f8 + Math_fround(f18 * f35));
    f31 = Math_fround(f8 + Math_fround(f18 * f31));
    f27 = Math_fround(f8 + Math_fround(f18 * f27));
    f14 = Math_fround(f8 + Math_fround(f18 * Math_fround(HEAPF32[i20 + (i3 + 92) >> 2])));
    f54 = f47 < f46 ? f47 : f46;
    f53 = f48 < f45 ? f48 : f45;
    f52 = f49 < f44 ? f49 : f44;
    f51 = f50 < f43 ? f50 : f43;
    f46 = f47 > f46 ? f47 : f46;
    f45 = f48 > f45 ? f48 : f45;
    f44 = f49 > f44 ? f49 : f44;
    f43 = f50 > f43 ? f50 : f43;
    f50 = f26 < f42 ? f26 : f42;
    f49 = f30 < f41 ? f30 : f41;
    f48 = f34 < f40 ? f34 : f40;
    f47 = f38 < f39 ? f38 : f39;
    f42 = f26 > f42 ? f26 : f42;
    f41 = f30 > f41 ? f30 : f41;
    f40 = f34 > f40 ? f34 : f40;
    f39 = f38 > f39 ? f38 : f39;
    f38 = f58 < f35 ? f58 : f35;
    f34 = f57 < f31 ? f57 : f31;
    f30 = f56 < f27 ? f56 : f27;
    f26 = f55 < f14 ? f55 : f14;
    f35 = f58 > f35 ? f58 : f35;
    f31 = f57 > f31 ? f57 : f31;
    f27 = f56 > f27 ? f56 : f27;
    f14 = f55 > f14 ? f55 : f14;
    f50 = f54 > f50 ? f54 : f50;
    f49 = f53 > f49 ? f53 : f49;
    f48 = f52 > f48 ? f52 : f48;
    f47 = f51 > f47 ? f51 : f47;
    f38 = f50 > f38 ? f50 : f38;
    f34 = f49 > f34 ? f49 : f34;
    f30 = f48 > f30 ? f48 : f30;
    f26 = f47 > f26 ? f47 : f26;
    f42 = f46 < f42 ? f46 : f42;
    f41 = f45 < f41 ? f45 : f41;
    f40 = f44 < f40 ? f44 : f40;
    f39 = f43 < f39 ? f43 : f39;
    f35 = f42 < f35 ? f42 : f35;
    f31 = f41 < f31 ? f41 : f31;
    f27 = f40 < f27 ? f40 : f27;
    f14 = f39 < f14 ? f39 : f14;
    i1 = (f38 > f35 | (f38 > f4 | (f37 > f36 | f35 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i11 = (f34 > f31 | (f34 > f4 | (f33 > f32 | f31 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i15 = (f30 > f27 | (f30 > f4 | (f29 > f28 | f27 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    i19 = (f26 > f14 | (f26 > f4 | (f5 > f13 | f14 < Math_fround(9.99999971e-10)))) << 31 >> 31;
    HEAP32[i2 >> 2] = HEAP32[i20 + (i3 + 96) >> 2];
    i1 = i1 + i6 | 0;
    HEAP32[i22 + (i1 + 1 << 2) >> 2] = HEAP32[i20 + (i3 + 100) >> 2];
    i1 = i11 + 1 + i1 | 0;
    HEAP32[i22 + (i1 + 1 << 2) >> 2] = HEAP32[i20 + (i3 + 104) >> 2];
    i1 = i15 + 1 + i1 | 0;
    HEAP32[i22 + (i1 + 1 << 2) >> 2] = HEAP32[i20 + (i3 + 108) >> 2];
    i1 = i19 + 1 + i1 | 0;
   } else {
    HEAP32[i23 >> 2] = i3 + -1;
    HEAPF32[i21 >> 2] = f4;
    if (!(mftCall_iiiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, 1, i23 | 0, i21 | 0) | 0)) {
     i1 = 17;
     break L17;
    }
    f5 = Math_fround(HEAPF32[i21 >> 2]);
    if (f4 != f5) {
     f4 = f5;
     break;
    }
   }
   if (!i1) {
    i1 = 17;
    break L17;
   } else i6 = i1;
  }
  if (!i1) {
   i1 = 17;
   break;
  }
 }
 if ((i1 | 0) == 17) {
  STACKTOP = i24;
  return;
 }
}

function __ZN5physx10PxsCCDPair12sweepFindToiERNS_16PxsThreadContextEfj(i43, i42, f2, i1) {
 i43 = i43 | 0;
 i42 = i42 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i41 + 96 | 0;
 i47 = i41 + 64 | 0;
 i46 = i41 + 32 | 0;
 i45 = i41;
 i25 = i41 + 156 | 0;
 i40 = i41 + 144 | 0;
 i39 = i41 + 168 | 0;
 i38 = i41 + 136 | 0;
 i37 = i41 + 124 | 0;
 i21 = i43 + 60 | 0;
 __ZN5physx10PxsCCDPair12updateShapesEv(i43);
 i26 = HEAP32[i43 >> 2] | 0;
 i35 = HEAP32[i43 + 4 >> 2] | 0;
 i32 = HEAP32[i43 + 8 >> 2] | 0;
 i27 = HEAP32[i43 + 12 >> 2] | 0;
 i30 = HEAP32[i21 >> 2] | 0;
 i22 = i43 + 64 | 0;
 i31 = HEAP32[i22 >> 2] | 0;
 i24 = (i31 | 0) < (i30 | 0);
 i29 = i24 ? i30 : i31;
 i30 = i24 ? i31 : i30;
 i31 = i24 ? i32 : i27;
 i32 = i24 ? i27 : i32;
 i27 = i24 ? i26 : i35;
 i26 = i24 ? i35 : i26;
 HEAP32[i48 >> 2] = HEAP32[i32 + 40 >> 2];
 HEAP32[i48 + 4 >> 2] = HEAP32[i32 + 44 >> 2];
 HEAP32[i48 + 8 >> 2] = HEAP32[i32 + 48 >> 2];
 HEAP32[i48 + 12 >> 2] = HEAP32[i32 + 52 >> 2];
 i35 = i48 + 16 | 0;
 HEAP32[i35 >> 2] = HEAP32[i32 + 56 >> 2];
 i24 = i48 + 20 | 0;
 HEAP32[i24 >> 2] = HEAP32[i32 + 60 >> 2];
 i23 = i48 + 24 | 0;
 HEAP32[i23 >> 2] = HEAP32[i32 + 64 >> 2];
 HEAP32[i46 >> 2] = HEAP32[i32 + 12 >> 2];
 HEAP32[i46 + 4 >> 2] = HEAP32[i32 + 16 >> 2];
 HEAP32[i46 + 8 >> 2] = HEAP32[i32 + 20 >> 2];
 HEAP32[i46 + 12 >> 2] = HEAP32[i32 + 24 >> 2];
 i8 = HEAP32[i32 + 28 >> 2] | 0;
 HEAP32[i46 + 16 >> 2] = i8;
 i11 = HEAP32[i32 + 32 >> 2] | 0;
 HEAP32[i46 + 20 >> 2] = i11;
 i12 = HEAP32[i32 + 36 >> 2] | 0;
 HEAP32[i46 + 24 >> 2] = i12;
 HEAP32[i47 >> 2] = HEAP32[i31 + 40 >> 2];
 HEAP32[i47 + 4 >> 2] = HEAP32[i31 + 44 >> 2];
 HEAP32[i47 + 8 >> 2] = HEAP32[i31 + 48 >> 2];
 HEAP32[i47 + 12 >> 2] = HEAP32[i31 + 52 >> 2];
 i13 = HEAP32[i31 + 56 >> 2] | 0;
 HEAP32[i47 + 16 >> 2] = i13;
 i14 = HEAP32[i31 + 60 >> 2] | 0;
 HEAP32[i47 + 20 >> 2] = i14;
 i15 = HEAP32[i31 + 64 >> 2] | 0;
 HEAP32[i47 + 24 >> 2] = i15;
 HEAP32[i45 >> 2] = HEAP32[i31 + 12 >> 2];
 HEAP32[i45 + 4 >> 2] = HEAP32[i31 + 16 >> 2];
 HEAP32[i45 + 8 >> 2] = HEAP32[i31 + 20 >> 2];
 HEAP32[i45 + 12 >> 2] = HEAP32[i31 + 24 >> 2];
 i16 = HEAP32[i31 + 28 >> 2] | 0;
 HEAP32[i45 + 16 >> 2] = i16;
 i17 = HEAP32[i31 + 32 >> 2] | 0;
 HEAP32[i45 + 20 >> 2] = i17;
 i18 = HEAP32[i31 + 36 >> 2] | 0;
 HEAP32[i45 + 24 >> 2] = i18;
 f3 = Math_fround(HEAPF32[i35 >> 2]);
 f4 = Math_fround(HEAPF32[i24 >> 2]);
 f5 = Math_fround(HEAPF32[i23 >> 2]);
 HEAPF32[i25 >> 2] = Math_fround(0.0);
 i23 = i25 + 4 | 0;
 HEAPF32[i23 >> 2] = Math_fround(0.0);
 i24 = i25 + 8 | 0;
 HEAPF32[i24 >> 2] = Math_fround(0.0);
 HEAPF32[i40 >> 2] = Math_fround(0.0);
 i35 = i40 + 4 | 0;
 HEAPF32[i35 >> 2] = Math_fround(0.0);
 i36 = i40 + 8 | 0;
 HEAPF32[i36 >> 2] = Math_fround(0.0);
 i49 = HEAP32[gb + 102908 + (i30 * 28 | 0) + (i29 << 2) >> 2] | 0;
 i33 = i43 + 52 | 0;
 i44 = HEAP32[i33 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i44 + 108 >> 2]);
 i34 = f20 > Math_fround(0.0);
 f20 = i34 ? f20 : Math_fround(0.0);
 i34 = i42 + 16 | 0;
 HEAPF32[i42 + 8752 >> 2] = f2;
 i1 = i42 + 8760 | 0;
 HEAP32[i1 >> 2] = -1;
 i28 = i43 + 28 | 0;
 f2 = Math_fround(+mftCall_fiiiiiiiifiiiif(i49 | 0, i32 | 0, i31 | 0, i26 | 0, i27 | 0, i48 | 0, i47 | 0, i46 | 0, i45 | 0, +f20, i25 | 0, i40 | 0, i44 + 60 | 0, i34 | 0, +Math_fround(HEAPF32[i28 >> 2])));
 if (f2 >= Math_fround(1.0)) {
  HEAP32[i43 + 100 >> 2] = 1;
  HEAPF32[i43 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i43 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
  f20 = f2;
  STACKTOP = i41;
  return Math_fround(f20);
 }
 f20 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f50 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f51 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(Math_fround(f5 - f51) - Math_fround(f50 - f20));
 f19 = Math_fround(Math_fround(f4 - f6) - Math_fround(f9 - f19));
 f10 = Math_fround(Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - Math_fround(f7 - f10));
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i43 + 72 >> 2] = i11;
 f7 = Math_fround(HEAPF32[i25 >> 2]);
 f9 = Math_fround(-f7);
 f5 = Math_fround(HEAPF32[i23 >> 2]);
 f6 = Math_fround(-f5);
 f3 = Math_fround(HEAPF32[i24 >> 2]);
 f4 = Math_fround(-f3);
 f20 = Math_fround(Math_fround(Math_fround(f10 * f9) + Math_fround(f19 * f6)) + Math_fround(f20 * f4));
 if ((HEAP32[i22 >> 2] | 0) < (HEAP32[i21 >> 2] | 0)) {
  f19 = f3;
  f6 = f5;
  f9 = f7;
 } else {
  HEAPF32[i25 >> 2] = f9;
  HEAPF32[i23 >> 2] = f6;
  HEAPF32[i24 >> 2] = f4;
  f19 = f4;
 }
 HEAP32[i43 + 100 >> 2] = 1;
 f10 = Math_fround(HEAPF32[i32 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i31 + 8 >> 2]);
 if (f20 < Math_fround(f10 + f7)) {
  HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
  f51 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i41;
  return Math_fround(f51);
 }
 if (!(f2 <= Math_fround(0.0))) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 } else {
  i1 = (i26 | 0) != 0;
  if (i1) f3 = Math_fround(HEAPF32[(HEAP32[i26 + 60 >> 2] | 0) + 4 >> 2]); else f3 = Math_fround(1.0);
  i8 = (i27 | 0) != 0;
  if (i8) f5 = Math_fround(HEAPF32[(HEAP32[i27 + 60 >> 2] | 0) + 4 >> 2]); else f5 = Math_fround(1.0);
  f4 = Math_fround(-f2);
  if ((f3 < f5 ? f3 : f5) == Math_fround(1.0)) {
   if (i1) f3 = Math_fround(HEAPF32[(HEAP32[i26 + 64 >> 2] | 0) + 60 >> 2]); else f3 = Math_fround(1.0);
   if (i8) f2 = Math_fround(HEAPF32[(HEAP32[i27 + 64 >> 2] | 0) + 60 >> 2]); else f2 = Math_fround(1.0);
   f51 = i8 ? f7 : Math_fround(3402823469999999843913219.0e14);
   f3 = Math_fround(Math_fround((f10 < f51 ? f10 : f51) * (f3 < f2 ? f3 : f2)) / f20);
   f2 = Math_fround(0.0);
  } else {
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
 }
 HEAPF32[i28 >> 2] = f2;
 HEAPF32[i43 + 48 >> 2] = f4;
 HEAPF32[i43 + 32 >> 2] = f3;
 i47 = i43 + 36 | 0;
 HEAP32[i47 >> 2] = HEAP32[i40 >> 2];
 i48 = i43 + 40 | 0;
 HEAP32[i48 >> 2] = HEAP32[i35 >> 2];
 i49 = i43 + 44 | 0;
 HEAP32[i49 >> 2] = HEAP32[i36 >> 2];
 HEAPF32[i43 + 16 >> 2] = f9;
 HEAPF32[i43 + 20 >> 2] = f6;
 HEAPF32[i43 + 24 >> 2] = f19;
 i46 = i42 + 4496 | 0;
 HEAP32[i46 >> 2] = 0;
 HEAP32[i46 >> 2] = 1;
 HEAPF32[i42 + 400 >> 2] = f9;
 HEAPF32[i42 + 404 >> 2] = f6;
 HEAPF32[i42 + 408 >> 2] = f19;
 HEAP32[i42 + 416 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i42 + 420 >> 2] = HEAP32[i48 >> 2];
 HEAP32[i42 + 424 >> 2] = HEAP32[i49 >> 2];
 HEAPF32[i42 + 412 >> 2] = Math_fround(0.0);
 HEAP32[i42 + 448 >> 2] = (i30 + -5 | 0) >>> 0 < 2 ? i11 : -1;
 HEAP32[i42 + 452 >> 2] = (i29 + -5 | 0) >>> 0 < 2 ? i11 : -1;
 mftCall_iiiii(HEAP32[gb + 103104 + (i30 << 2) >> 2] | 0, HEAP32[i32 >> 2] | 0, 0, i34 | 0, i39 | 0) | 0;
 mftCall_iiiii(HEAP32[gb + 103104 + (i29 << 2) >> 2] | 0, HEAP32[i31 >> 2] | 0, 1, i34 | 0, i39 | 0) | 0;
 i49 = HEAP32[HEAP32[(HEAP32[i33 >> 2] | 0) + 96 >> 2] >> 2] | 0;
 i48 = i49 + ((HEAPU16[i39 >> 1] | 0) << 5) | 0;
 i47 = i39 + 2 | 0;
 i49 = i49 + ((HEAPU16[i47 >> 1] | 0) << 5) | 0;
 f51 = Math_fround(__ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i48, i49));
 __ZN5physx19PxsMaterialCombinerC2Eff(i38, Math_fround(1.0), Math_fround(1.0));
 __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i37, i38, i48, i49);
 i49 = HEAP32[i37 >> 2] | 0;
 i48 = HEAP32[i37 + 4 >> 2] | 0;
 HEAP16[i43 + 76 >> 1] = HEAP16[i39 >> 1] | 0;
 HEAP16[i43 + 78 >> 1] = HEAP16[i47 >> 1] | 0;
 HEAP32[i43 + 80 >> 2] = i48;
 HEAP32[i43 + 84 >> 2] = i49;
 HEAPF32[i43 + 88 >> 2] = f51;
 f51 = f2;
 STACKTOP = i41;
 return Math_fround(f51);
}

function __ZN8GUIStyle8TransferI8JSONReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i6 + 36 | 0;
 HEAP8[i8 >> 0] = 0;
 i9 = i6 + 40 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (!i4) HEAP8[i8 >> 0] = 0; else {
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034561 | 0) | 0;
   HEAP32[i9 >> 2] = i3;
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[gb + 37260 >> 2];
   if (i3 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i5);
    HEAP8[i8 >> 0] = 1;
    i3 = i6 + 56 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 16 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034568 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 36 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034591 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 56 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034599 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 76 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034608 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 96 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034618 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 116 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034629 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i1 = i5 + 136 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034639 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
  i3 = i5 + 156 | 0;
  HEAP8[i8 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1034650 | 0) | 0;
   HEAP32[i9 >> 2] = i11;
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = gb + 1034577;
   if (i11 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i3, i6);
    HEAP8[i8 >> 0] = 1;
    i11 = i6 + 56 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   }
   HEAP32[i9 >> 2] = i4;
   HEAP32[i1 >> 2] = i2;
  }
 }
 __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 176 | 0, gb + 1034662 | 0, 0, 0);
 __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 192 | 0, gb + 1034671 | 0, 0, 0);
 __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 208 | 0, gb + 1034680 | 0, 0, 0);
 __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 224 | 0, gb + 1034690 | 0, 0, 0);
 HEAP8[i8 >> 0] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) == 3) {
  i11 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i1, gb + 1034701 | 0) | 0;
  HEAP32[i9 >> 2] = i11;
  i2 = i6 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = gb + 1034708;
  if (i11 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
   HEAP32[i7 >> 2] = 0;
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1034719 | 0, 0, 0);
   HEAP32[i5 + 240 >> 2] = HEAP32[i7 >> 2];
   HEAP8[i8 >> 0] = 1;
   i11 = i6 + 56 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  }
  HEAP32[i9 >> 2] = i1;
  HEAP32[i2 >> 2] = i3;
 }
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 284 | 0, gb + 1034730 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 288 | 0, gb + 1034741 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 244 | 0, gb + 1034753 | 0, 0, 0);
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 248 | 0, gb + 1034765 | 0, 0, 0);
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 249 | 0, gb + 1034776 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 252 | 0, gb + 1034787 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 256 | 0, gb + 1034802 | 0, 0, 0);
 __ZN8JSONRead8TransferI8Vector2fEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 260 | 0, gb + 1034818 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 276 | 0, gb + 1034834 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 280 | 0, gb + 1034847 | 0, 0, 0);
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 292 | 0, gb + 1034861 | 0, 0, 0);
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 293 | 0, gb + 1034876 | 0, 0, 0);
 STACKTOP = i10;
 return;
}

function __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i1, i33, i35, i36) {
 i1 = i1 | 0;
 i33 = i33 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, i31 = 0, i32 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, i58 = 0, i59 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i44 + 164 | 0;
 i38 = i44 + 136 | 0;
 i39 = i44 + 96 | 0;
 i40 = i44 + 64 | 0;
 i41 = i44 + 40 | 0;
 i42 = i44 + 24 | 0;
 i34 = i44;
 i4 = i1 + 52 | 0;
 i32 = HEAP32[i4 >> 2] | 0;
 i32 = mftCall_ii(HEAP32[(HEAP32[i32 >> 2] | 0) + 104 >> 2] | 0, i32 | 0) | 0;
 if (!i32) {
  i43 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 84 >> 2] | 0, i37 | 0, i43 | 0);
  i43 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i43 >> 2] | 0) + 124 >> 2] | 0, i38 | 0, i43 | 0);
  f49 = Math_fround(Math_fround(HEAPF32[i38 + 16 >> 2]) * Math_fround(2.0));
  f51 = Math_fround(Math_fround(HEAPF32[i38 + 20 >> 2]) * Math_fround(2.0));
  f54 = Math_fround(Math_fround(HEAPF32[i38 + 24 >> 2]) * Math_fround(2.0));
  f52 = Math_fround(HEAPF32[i37 + 12 >> 2]);
  f53 = Math_fround(Math_fround(f52 * f52) + Math_fround(-.5));
  f50 = Math_fround(HEAPF32[i37 >> 2]);
  f30 = Math_fround(f49 * f50);
  f48 = Math_fround(HEAPF32[i37 + 4 >> 2]);
  f30 = Math_fround(f30 + Math_fround(f51 * f48));
  f47 = Math_fround(HEAPF32[i37 + 8 >> 2]);
  f30 = Math_fround(f30 + Math_fround(f54 * f47));
  f46 = Math_fround(Math_fround(f50 * f30) + Math_fround(Math_fround(f49 * f53) + Math_fround(f52 * Math_fround(Math_fround(f54 * f48) - Math_fround(f51 * f47)))));
  f45 = Math_fround(Math_fround(f48 * f30) + Math_fround(Math_fround(f51 * f53) + Math_fround(f52 * Math_fround(Math_fround(f49 * f47) - Math_fround(f54 * f50)))));
  f30 = Math_fround(Math_fround(Math_fround(f54 * f53) + Math_fround(f52 * Math_fround(Math_fround(f51 * f50) - Math_fround(f49 * f48)))) + Math_fround(f47 * f30));
  f46 = Math_fround(Math_fround(HEAPF32[i37 + 16 >> 2]) + f46);
  f45 = Math_fround(Math_fround(HEAPF32[i37 + 20 >> 2]) + f45);
  f30 = Math_fround(Math_fround(HEAPF32[i37 + 24 >> 2]) + f30);
  HEAPF32[i35 >> 2] = f46;
  HEAPF32[i35 + 4 >> 2] = f45;
  HEAPF32[i35 + 8 >> 2] = f30;
  f46 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f46);
  f45 = Math_fround(Math_fround(HEAPF32[i33 + 4 >> 2]) - f45);
  f30 = Math_fround(Math_fround(HEAPF32[i33 + 8 >> 2]) - f30);
  HEAPF32[i36 >> 2] = Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f45 * f45)) + Math_fround(f30 * f30));
  STACKTOP = i44;
  return;
 }
 HEAPF32[i36 >> 2] = Math_fround(inf);
 HEAP32[i42 >> 2] = 0;
 i43 = i42 + 4 | 0;
 i29 = gb + 63160 | 0;
 i31 = HEAP32[i29 + 4 >> 2] | 0;
 i1 = i43;
 HEAP32[i1 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i1 + 4 >> 2] = i31;
 i1 = i32 << 2;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i1 | 3;
  if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 394) | 0;
   i31 = gb + 64016 | 0;
   i29 = HEAP32[i31 >> 2] | 0;
   i31 = HEAP32[i31 + 4 >> 2] | 0;
   HEAP32[i42 >> 2] = i1;
   i2 = i43;
   HEAP32[i2 >> 2] = i29;
   HEAP32[i2 + 4 >> 2] = i31;
   i2 = i1;
   break;
  }
 } while (0);
 i31 = i2 + 3 & -4;
 i29 = HEAP32[i4 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i29 >> 2] | 0) + 108 >> 2] | 0, i29 | 0, i31 | 0, i32 | 0, 0) | 0;
 if ((i32 | 0) > 0) {
  i7 = i38 + 16 | 0;
  i8 = i38 + 20 | 0;
  i9 = i38 + 24 | 0;
  i10 = i37 + 12 | 0;
  i11 = i37 + 4 | 0;
  i12 = i37 + 8 | 0;
  i13 = i37 + 16 | 0;
  i14 = i37 + 20 | 0;
  i15 = i37 + 24 | 0;
  i16 = i38 + 12 | 0;
  i17 = i38 + 8 | 0;
  i18 = i38 + 4 | 0;
  i19 = i40 + 4 | 0;
  i20 = i40 + 8 | 0;
  i21 = i40 + 12 | 0;
  i22 = i40 + 16 | 0;
  i23 = i40 + 20 | 0;
  i24 = i40 + 24 | 0;
  i25 = i41 + 12 | 0;
  i26 = i41 + 16 | 0;
  i27 = i41 + 4 | 0;
  i28 = i41 + 20 | 0;
  i29 = i41 + 8 | 0;
  i2 = i34 + 12 | 0;
  i4 = i34 + 16 | 0;
  i6 = i34 + 20 | 0;
  i3 = i34 + 4 | 0;
  i5 = i34 + 8 | 0;
  i1 = 0;
  do {
   i58 = HEAP32[i31 + (i1 << 2) >> 2] | 0;
   i59 = mftCall_ii(HEAP32[(HEAP32[i58 >> 2] | 0) + 64 >> 2] | 0, i58 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i58 >> 2] | 0) + 32 >> 2] | 0, i39 | 0, i58 | 0);
   mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 84 >> 2] | 0, i37 | 0, i59 | 0);
   mftCall_vii(HEAP32[(HEAP32[i58 >> 2] | 0) + 72 >> 2] | 0, i38 | 0, i58 | 0);
   f45 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(2.0));
   f52 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * Math_fround(2.0));
   f48 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
   f57 = Math_fround(HEAPF32[i10 >> 2]);
   f56 = Math_fround(Math_fround(f57 * f57) + Math_fround(-.5));
   f55 = Math_fround(HEAPF32[i37 >> 2]);
   f47 = Math_fround(f45 * f55);
   f46 = Math_fround(HEAPF32[i11 >> 2]);
   f47 = Math_fround(f47 + Math_fround(f52 * f46));
   f30 = Math_fround(HEAPF32[i12 >> 2]);
   f47 = Math_fround(f47 + Math_fround(f48 * f30));
   f50 = Math_fround(Math_fround(f55 * f47) + Math_fround(Math_fround(f45 * f56) + Math_fround(f57 * Math_fround(Math_fround(f48 * f46) - Math_fround(f52 * f30)))));
   f53 = Math_fround(Math_fround(f46 * f47) + Math_fround(Math_fround(f52 * f56) + Math_fround(f57 * Math_fround(Math_fround(f45 * f30) - Math_fround(f48 * f55)))));
   f47 = Math_fround(Math_fround(Math_fround(f48 * f56) + Math_fround(f57 * Math_fround(Math_fround(f52 * f55) - Math_fround(f45 * f46)))) + Math_fround(f30 * f47));
   f50 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f50);
   f53 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f53);
   f47 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f47);
   f45 = Math_fround(HEAPF32[i38 >> 2]);
   f52 = Math_fround(f57 * f45);
   f56 = Math_fround(HEAPF32[i16 >> 2]);
   f52 = Math_fround(f52 + Math_fround(f55 * f56));
   f48 = Math_fround(HEAPF32[i17 >> 2]);
   f52 = Math_fround(f52 + Math_fround(f46 * f48));
   f49 = Math_fround(HEAPF32[i18 >> 2]);
   f51 = Math_fround(Math_fround(Math_fround(f30 * f45) + Math_fround(Math_fround(f46 * f56) + Math_fround(f57 * f49))) - Math_fround(f55 * f48));
   f54 = Math_fround(Math_fround(Math_fround(f55 * f49) + Math_fround(Math_fround(f30 * f56) + Math_fround(f57 * f48))) - Math_fround(f46 * f45));
   f48 = Math_fround(Math_fround(Math_fround(Math_fround(f57 * f56) - Math_fround(f55 * f45)) - Math_fround(f46 * f49)) - Math_fround(f30 * f48));
   HEAPF32[i40 >> 2] = Math_fround(f52 - Math_fround(f30 * f49));
   HEAPF32[i19 >> 2] = f51;
   HEAPF32[i20 >> 2] = f54;
   HEAPF32[i21 >> 2] = f48;
   HEAPF32[i22 >> 2] = f50;
   HEAPF32[i23 >> 2] = f53;
   HEAPF32[i24 >> 2] = f47;
   __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf(i41, i39, i40, Math_fround(1.0));
   f47 = Math_fround(HEAPF32[i25 >> 2]);
   f53 = Math_fround(HEAPF32[i41 >> 2]);
   f50 = Math_fround(f47 - f53);
   f48 = Math_fround(HEAPF32[i26 >> 2]);
   f54 = Math_fround(HEAPF32[i27 >> 2]);
   f51 = Math_fround(f48 - f54);
   f49 = Math_fround(HEAPF32[i28 >> 2]);
   f30 = Math_fround(HEAPF32[i29 >> 2]);
   f51 = Math_fround(f51 * Math_fround(.5));
   f52 = Math_fround(Math_fround(f49 - f30) * Math_fround(.5));
   f53 = Math_fround(Math_fround(f47 + f53) * Math_fround(.5));
   f54 = Math_fround(Math_fround(f48 + f54) * Math_fround(.5));
   f30 = Math_fround(Math_fround(f49 + f30) * Math_fround(.5));
   HEAPF32[i2 >> 2] = Math_fround(f50 * Math_fround(.5));
   HEAPF32[i4 >> 2] = f51;
   HEAPF32[i6 >> 2] = f52;
   HEAPF32[i34 >> 2] = f53;
   HEAPF32[i3 >> 2] = f54;
   HEAPF32[i5 >> 2] = f30;
   __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf(i33, i34, i37, i38);
   f30 = Math_fround(HEAPF32[i38 >> 2]);
   if (f30 < Math_fround(HEAPF32[i36 >> 2])) {
    HEAP32[i35 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    HEAPF32[i36 >> 2] = f30;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i32 | 0));
  i1 = HEAP32[i42 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i43);
 STACKTOP = i44;
 return;
}

function __ZN14ParticleSystem4EmitERS_RK21SubEmitterEmitCommand(i26, i17) {
 i26 = i26 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i32 + 248 | 0;
 i30 = i32 + 232 | 0;
 i31 = i32 + 224 | 0;
 i24 = i32 + 212 | 0;
 i14 = i32 + 176 | 0;
 i15 = i32 + 164 | 0;
 i16 = i32 + 152 | 0;
 i1 = i32 + 88 | 0;
 i18 = i32 + 24 | 0;
 i19 = i32 + 12 | 0;
 i20 = i32;
 i28 = HEAP32[i17 + 92 >> 2] | 0;
 HEAP32[i31 >> 2] = i28;
 if (!i28) {
  STACKTOP = i32;
  return;
 }
 i25 = i26 + 40 | 0;
 i27 = HEAP32[i25 >> 2] | 0;
 i28 = HEAP32[i26 + 36 >> 2] | 0;
 i21 = HEAP32[i17 + 96 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i17 + 100 >> 2]);
 f6 = Math_fround(HEAPF32[i17 + 104 >> 2]);
 i2 = HEAP32[i17 + 24 >> 2] | 0;
 i3 = HEAP32[i17 + 28 >> 2] | 0;
 i4 = HEAP32[i17 + 32 >> 2] | 0;
 i35 = HEAP32[i17 + 36 >> 2] | 0;
 HEAP32[i24 >> 2] = i35;
 i8 = i24 + 4 | 0;
 i34 = HEAP32[i17 + 40 >> 2] | 0;
 HEAP32[i8 >> 2] = i34;
 i9 = i24 + 8 | 0;
 i33 = HEAP32[i17 + 44 >> 2] | 0;
 HEAP32[i9 >> 2] = i33;
 f11 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f11 * f11);
 f12 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 + Math_fround(f12 * f12));
 f13 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f13 * f13))));
 f23 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 if (f5 > f23) {
  f36 = Math_fround(f11 / f5);
  HEAPF32[i15 >> 2] = f36;
  f7 = Math_fround(f12 / f5);
  HEAPF32[i15 + 4 >> 2] = f7;
  f10 = Math_fround(f13 / f5);
  HEAPF32[i15 + 8 >> 2] = f10;
  f5 = f36;
 } else {
  i33 = HEAP32[gb + 1162364 >> 2] | 0;
  HEAP32[i15 >> 2] = i33;
  i34 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i34;
  i35 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i35;
  f5 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f37 = Math_fround(HEAPF32[gb + 62548 >> 2]);
 f38 = Math_fround(f5 * f37);
 f39 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f7 * f39));
 f36 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
 f38 = Math_fround(f38 + Math_fround(f10 * f36));
 i35 = f38 < Math_fround(0.0);
 f5 = Math_fround(-f38);
 f38 = i35 ? f5 : f38;
 f5 = Math_fround(Math_fround(HEAPF32[gb + 62536 >> 2]) * f38);
 f10 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 4 >> 2]) * f38);
 f7 = Math_fround(Math_fround(1.0) - f38);
 f10 = Math_fround(f10 + Math_fround(f7 * f39));
 f36 = Math_fround(Math_fround(Math_fround(HEAPF32[gb + 62536 + 8 >> 2]) * f38) + Math_fround(f7 * f36));
 HEAPF32[i16 >> 2] = Math_fround(f5 + Math_fround(f7 * f37));
 HEAPF32[i16 + 4 >> 2] = f10;
 HEAPF32[i16 + 8 >> 2] = f36;
 if (!(__Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i15, i16, i14) | 0)) __ZN10Matrix3x3f11SetIdentityEv(i14) | 0;
 __ZN10Matrix3x3fmLERKS_(i14, i27 + 244 | 0) | 0;
 __ZN10Matrix4x4fC2ERK10Matrix3x3f(i1, i14);
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = i4;
 if ((HEAP32[i28 + 280 >> 2] | 0) == 1) {
  i3 = i18;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
 } else {
  i35 = i27 + 180 | 0;
  __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(i35, i1, i18);
  f37 = Math_fround(Math_fround(HEAPF32[i35 >> 2]) * f11);
  f37 = Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i27 + 196 >> 2]) * f12));
  f37 = Math_fround(f37 + Math_fround(Math_fround(HEAPF32[i27 + 212 >> 2]) * f13));
  f38 = Math_fround(f11 * Math_fround(HEAPF32[i27 + 184 >> 2]));
  f38 = Math_fround(f38 + Math_fround(f12 * Math_fround(HEAPF32[i27 + 200 >> 2])));
  f38 = Math_fround(f38 + Math_fround(f13 * Math_fround(HEAPF32[i27 + 216 >> 2])));
  f39 = Math_fround(f11 * Math_fround(HEAPF32[i27 + 188 >> 2]));
  f39 = Math_fround(f39 + Math_fround(f12 * Math_fround(HEAPF32[i27 + 204 >> 2])));
  f39 = Math_fround(f39 + Math_fround(f13 * Math_fround(HEAPF32[i27 + 220 >> 2])));
  HEAPF32[i24 >> 2] = f37;
  HEAPF32[i8 >> 2] = f38;
  HEAPF32[i9 >> 2] = f39;
 }
 f5 = Math_fround(HEAPF32[i17 + 108 >> 2]);
 f7 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
 if (HEAP8[i28 + 277 >> 0] | 0) f6 = Math_fround(_fmodf(f6, Math_fround(HEAPF32[i28 + 264 >> 2])));
 i15 = HEAP32[i26 + 32 >> 2] | 0;
 i35 = i26 + 44 | 0;
 i34 = i17 + 76 | 0;
 __ZN13InitialModule18SetInheritedParamsERK11ColorRGBA32RK8Vector3fS5_S5_(HEAP32[i35 >> 2] | 0, i17 + 48 | 0, i17 + 52 | 0, i17 + 64 | 0, i34);
 i9 = i15 + 12 | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 i33 = HEAP32[i31 >> 2] | 0;
 i8 = i33 + i14 | 0;
 i16 = HEAP32[(HEAP32[i35 >> 2] | 0) + 2548 >> 2] | 0;
 i8 = i16 >>> 0 < i8 >>> 0 ? i16 : i8;
 i16 = i8 - i14 | 0;
 i33 = i16 >>> 0 < i33 >>> 0 ? i16 : i33;
 HEAP32[i31 >> 2] = i33;
 i33 = i33 + (i14 + 3 | 3) & -4;
 __ZN23ParticleSystemParticles13array_reserveEj(i15, i33 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i15, i33);
 i14 = i8 >>> 0 < i14 >>> 0 ? i8 : i14;
 i8 = i14 + 3 & -4;
 f39 = Math_fround(HEAPF32[i34 >> 2]);
 f39 = Math_fround(f39 * f39);
 f38 = Math_fround(HEAPF32[i17 + 80 >> 2]);
 f38 = Math_fround(f39 + Math_fround(f38 * f38));
 f39 = Math_fround(HEAPF32[i17 + 84 >> 2]);
 __ZN14ParticleSystem12StartModulesERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK27ParticleSystemEmissionStatebRK8Vector3fRK10Matrix4x4fR23ParticleSystemParticlesjffjfjRjb(i26, i28, i27, i17, 1, i24, i18, i15, i8, f22, f6, i21, Math_fround(0.0), 0, i31, Math_fround(f38 + Math_fround(f39 * f39)) < f23);
 i35 = HEAP32[i35 >> 2] | 0;
 HEAP32[i29 >> 2] = -1;
 HEAPF32[i30 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 8 >> 2] = Math_fround(0.0);
 __ZN13InitialModule18SetInheritedParamsERK11ColorRGBA32RK8Vector3fS5_S5_(i35, i29, i30, i19, i20);
 if (!i8) {
  i1 = HEAP32[i26 + 28 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = HEAP32[i25 >> 2] | 0;
   i2 = i1 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) != 1) {
    HEAP32[i2 >> 2] = 1;
    HEAP8[i1 + 13 >> 0] = 1;
   }
   __ZN14ParticleSystem12AddToManagerEv(i26);
  }
  HEAP8[i27 + 13 >> 0] = 1;
  HEAPF64[i27 + 40 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 }
 if (!(!(f7 > Math_fround(.0000999999974)) | !(f5 >= f7))) {
  i1 = i30 + 12 | 0;
  i2 = i30 + 8 | 0;
  i3 = i30 + 4 | 0;
  do {
   f5 = Math_fround(f5 - f7);
   HEAPF32[i29 >> 2] = f7;
   i35 = HEAP32[i9 >> 2] | 0;
   HEAPF32[i1 >> 2] = f7;
   HEAPF32[i2 >> 2] = f7;
   HEAPF32[i3 >> 2] = f7;
   HEAPF32[i30 >> 2] = f7;
   __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i26, i28, i27, i15, i8, i35, i30);
   __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj(i26, i28, i27, i15, i8, i29, i31);
   HEAPF32[i30 >> 2] = f7;
   __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i26, i28, i27, i15, i8, i30);
  } while (f5 >= f7);
 }
 i4 = HEAP32[i31 >> 2] | 0;
 if ((i8 | 0) != (i14 | 0)) {
  i3 = i8 - i14 | 0;
  i35 = i4 + i8 | 0;
  i3 = i35 - (i3 >>> 0 > i4 >>> 0 ? i4 : i3) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i35 = i2 >>> 0 < i35 >>> 0 ? i2 : i35;
  i2 = i35 - i3 | 0;
  if (!(i35 >>> 0 <= i3 >>> 0 | (i2 | 0) == 0)) {
   i1 = 0;
   do {
    __ZN23ParticleSystemParticles14element_assignEjj(i15, i1 + i14 | 0, i1 + i3 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i15, i4 + i14 | 0);
 STACKTOP = i32;
 return;
}

function __ZN2UI15PixelAdjustRectEPNS_13RectTransformEPNS_6CanvasE(i53, i5, i6) {
 i53 = i53 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, i48 = 0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, i54 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i55 + 112 | 0;
 i48 = i55 + 48 | 0;
 i54 = i55;
 if (!i5) {
  HEAP32[i53 >> 2] = 0;
  HEAP32[i53 + 4 >> 2] = 0;
  HEAP32[i53 + 8 >> 2] = 0;
  HEAP32[i53 + 12 >> 2] = 0;
  STACKTOP = i55;
  return;
 }
 i4 = __ZNK2UI13RectTransform7GetRectEv(i5) | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 if (i6 | 0) if ((__ZNK2UI6Canvas13GetRenderModeEv(i6) | 0) != 2) {
  i1 = i6;
  while (1) {
   i2 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if (!(Math_fround(HEAPF32[i1 + 352 >> 2]) == Math_fround(0.0))) {
   i1 = i6;
   while (1) {
    i2 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i2) break;
    if (!(HEAP8[i1 + 361 >> 0] | 0)) i1 = i2; else break;
   }
   if (HEAP8[i1 + 360 >> 0] | 0) {
    i1 = i6;
    i2 = 0;
    while (1) {
     i3 = i1;
     while (1) {
      i4 = HEAP32[i3 + 344 >> 2] | 0;
      if (!i4) break;
      if (!(HEAP8[i3 + 361 >> 0] | 0)) i3 = i4; else break;
     }
     if (!(HEAP8[i3 + 360 >> 0] | 0)) {
      i1 = i2;
      break;
     }
     i2 = HEAP32[i1 + 344 >> 2] | 0;
     if (!i2) break; else {
      i4 = i1;
      i1 = i2;
      i2 = i4;
     }
    }
    i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
    if (!i4) {
     HEAP32[i53 >> 2] = i7;
     HEAP32[i53 + 4 >> 2] = i8;
     HEAPF32[i53 + 8 >> 2] = f9;
     HEAPF32[i53 + 12 >> 2] = f10;
     STACKTOP = i55;
     return;
    }
    __ZNK9Transform21GetWorldToLocalMatrixEv(i11, i4);
    __ZNK9Transform21GetLocalToWorldMatrixEv(i48, i5);
    __ZN10Matrix4x4fmLERKS_(i11, i48) | 0;
    i1 = i48;
    i2 = i11;
    i3 = i1 + 64 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    __Z20InvertMatrix4x4_FullPKfPf(i48, i48) | 0;
    i1 = __ZNK2UI13RectTransform7GetRectEv(i4) | 0;
    f51 = Math_fround(HEAPF32[i1 >> 2]);
    f52 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    i1 = i6;
    while (1) {
     i2 = HEAP32[i1 + 344 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    f49 = Math_fround(HEAPF32[i1 + 352 >> 2]);
    f35 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f34 = Math_fround(f35 + Math_fround(f9 * Math_fround(.5)));
    f14 = Math_fround(f10 * Math_fround(.5));
    f50 = Math_fround(Math_fround(1.0) / f49);
    f33 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f14 = Math_fround(f33 + f14);
    HEAP32[i54 >> 2] = i7;
    HEAPF32[i54 + 4 >> 2] = f14;
    HEAPF32[i54 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i54 + 12 >> 2] = f34;
    i7 = i54 + 16 | 0;
    HEAP32[i7 >> 2] = i8;
    HEAPF32[i54 + 20 >> 2] = Math_fround(0.0);
    i6 = i54 + 24 | 0;
    HEAPF32[i6 >> 2] = Math_fround(f35 + f9);
    HEAPF32[i54 + 28 >> 2] = f14;
    HEAPF32[i54 + 32 >> 2] = Math_fround(0.0);
    f33 = Math_fround(f33 + f10);
    HEAPF32[i54 + 36 >> 2] = f34;
    i5 = i54 + 40 | 0;
    HEAPF32[i5 >> 2] = f33;
    HEAPF32[i54 + 44 >> 2] = Math_fround(0.0);
    f33 = Math_fround(HEAPF32[i11 + 12 >> 2]);
    f34 = Math_fround(HEAPF32[i11 + 28 >> 2]);
    f35 = Math_fround(HEAPF32[i11 + 44 >> 2]);
    f36 = Math_fround(HEAPF32[i11 + 60 >> 2]);
    f37 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f38 = Math_fround(HEAPF32[i11 + 24 >> 2]);
    f39 = Math_fround(HEAPF32[i11 + 40 >> 2]);
    f40 = Math_fround(HEAPF32[i11 + 56 >> 2]);
    f41 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f42 = Math_fround(HEAPF32[i11 + 20 >> 2]);
    f43 = Math_fround(HEAPF32[i11 + 36 >> 2]);
    f44 = Math_fround(HEAPF32[i11 + 52 >> 2]);
    f45 = Math_fround(HEAPF32[i11 >> 2]);
    f46 = Math_fround(HEAPF32[i11 + 16 >> 2]);
    f47 = Math_fround(HEAPF32[i11 + 32 >> 2]);
    f28 = Math_fround(HEAPF32[i11 + 48 >> 2]);
    f29 = Math_fround(HEAPF32[i48 + 12 >> 2]);
    f30 = Math_fround(HEAPF32[i48 + 28 >> 2]);
    f31 = Math_fround(HEAPF32[i48 + 44 >> 2]);
    f32 = Math_fround(HEAPF32[i48 + 60 >> 2]);
    f17 = Math_fround(HEAPF32[i48 + 8 >> 2]);
    f18 = Math_fround(HEAPF32[i48 + 24 >> 2]);
    f19 = Math_fround(HEAPF32[i48 + 40 >> 2]);
    f20 = Math_fround(HEAPF32[i48 + 56 >> 2]);
    f21 = Math_fround(HEAPF32[i48 + 4 >> 2]);
    f22 = Math_fround(HEAPF32[i48 + 20 >> 2]);
    f23 = Math_fround(HEAPF32[i48 + 36 >> 2]);
    f24 = Math_fround(HEAPF32[i48 + 52 >> 2]);
    f25 = Math_fround(HEAPF32[i48 >> 2]);
    f26 = Math_fround(HEAPF32[i48 + 16 >> 2]);
    f27 = Math_fround(HEAPF32[i48 + 32 >> 2]);
    f16 = Math_fround(HEAPF32[i48 + 48 >> 2]);
    i4 = 0;
    f12 = Math_fround(0.0);
    while (1) {
     i1 = i54 + (i4 * 12 | 0) | 0;
     f10 = Math_fround(HEAPF32[i1 >> 2]);
     i2 = i54 + (i4 * 12 | 0) + 4 | 0;
     i3 = i54 + (i4 * 12 | 0) + 8 | 0;
     f9 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f10 * f33) + Math_fround(f14 * f34)) + Math_fround(f12 * f35)));
     i48 = f9 < Math_fround(0.0);
     f15 = Math_fround(-f9);
     if ((i48 ? f15 : f9) > Math_fround(1.00000001e-07)) {
      f9 = Math_fround(Math_fround(1.0) / f9);
      f15 = Math_fround(f9 * Math_fround(f40 + Math_fround(Math_fround(Math_fround(f10 * f37) + Math_fround(f14 * f38)) + Math_fround(f12 * f39))));
      f13 = Math_fround(f9 * Math_fround(f44 + Math_fround(Math_fround(Math_fround(f10 * f41) + Math_fround(f14 * f42)) + Math_fround(f12 * f43))));
      f9 = Math_fround(f9 * Math_fround(f28 + Math_fround(Math_fround(Math_fround(f10 * f45) + Math_fround(f14 * f46)) + Math_fround(f12 * f47))));
     } else {
      f15 = Math_fround(0.0);
      f13 = Math_fround(0.0);
      f9 = Math_fround(0.0);
     }
     f14 = Math_fround(f51 + Math_fround(f50 * Math_fround(Math_floor(Math_fround(Math_fround(f49 * Math_fround(f9 - f51)) + Math_fround(.5))))));
     f13 = Math_fround(f52 + Math_fround(f50 * Math_fround(Math_floor(Math_fround(Math_fround(f49 * Math_fround(f13 - f52)) + Math_fround(.5))))));
     HEAPF32[i1 >> 2] = f14;
     HEAPF32[i2 >> 2] = f13;
     HEAPF32[i3 >> 2] = f15;
     f9 = Math_fround(f32 + Math_fround(Math_fround(Math_fround(f14 * f29) + Math_fround(f13 * f30)) + Math_fround(f15 * f31)));
     i48 = f9 < Math_fround(0.0);
     f12 = Math_fround(-f9);
     if ((i48 ? f12 : f9) > Math_fround(1.00000001e-07)) {
      f9 = Math_fround(Math_fround(1.0) / f9);
      f10 = Math_fround(f9 * Math_fround(f20 + Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(f13 * f18)) + Math_fround(f15 * f19))));
      f12 = Math_fround(f9 * Math_fround(f24 + Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f13 * f22)) + Math_fround(f15 * f23))));
      f9 = Math_fround(f9 * Math_fround(f16 + Math_fround(Math_fround(Math_fround(f14 * f25) + Math_fround(f13 * f26)) + Math_fround(f15 * f27))));
     } else {
      f10 = Math_fround(0.0);
      f12 = Math_fround(0.0);
      f9 = Math_fround(0.0);
     }
     HEAPF32[i1 >> 2] = f9;
     HEAPF32[i2 >> 2] = f12;
     HEAPF32[i3 >> 2] = f10;
     i1 = i4 + 1 | 0;
     if ((i1 | 0) == 4) break;
     f14 = Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 4 >> 2]);
     i4 = i1;
     f12 = Math_fround(HEAPF32[i54 + (i1 * 12 | 0) + 8 >> 2]);
    }
    i48 = HEAP32[i54 >> 2] | 0;
    i54 = HEAP32[i7 >> 2] | 0;
    f51 = Math_fround(HEAPF32[i6 >> 2]);
    f51 = Math_fround(f51 - (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f52 = Math_fround(HEAPF32[i5 >> 2]);
    f52 = Math_fround(f52 - (HEAP32[tempDoublePtr >> 2] = i54, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAP32[i53 >> 2] = i48;
    HEAP32[i53 + 4 >> 2] = i54;
    HEAPF32[i53 + 8 >> 2] = f51;
    HEAPF32[i53 + 12 >> 2] = f52;
    STACKTOP = i55;
    return;
   }
  }
 }
 HEAP32[i53 >> 2] = i7;
 HEAP32[i53 + 4 >> 2] = i8;
 HEAPF32[i53 + 8 >> 2] = f9;
 HEAPF32[i53 + 12 >> 2] = f10;
 STACKTOP = i55;
 return;
}

function __ZN21LightProbeProxyVolume8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i10);
 i4 = i6 + 36 | 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378243 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 48 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378261 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378275 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378289 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378303 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 64 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378329 | 0, i3, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378347 | 0, i3, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378367 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 73; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 73; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 73) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 378384 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 84; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 84; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 84) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 380944 | 0, i7, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i8 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i8 >>> 0) i9 = 95; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 95; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i9 | 0) == 95) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator12collectTilesEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i20 = i22 + 128 | 0;
 HEAP32[i20 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i20 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 }
 i19 = i22 + 136 | 0;
 if ((HEAP32[i19 >> 2] | 0) < 0) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i1 = i22 + 132 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i21 = HEAP32[i20 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i21 = 10;
  }
 } else i21 = 10;
 if ((i21 | 0) == 10) HEAP32[i22 + 140 >> 2] = 0;
 i18 = i22 + 64 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 HEAP32[i18 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i18 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 }
 i17 = i22 + 60 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = i22 + 72 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) < (i5 | 0)) {
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 << 5 | 16 | 0, 0) | 0;
  if (!i1) {
   HEAP32[i22 + 464 >> 2] = 1;
   i22 = 0;
   return i22 | 0;
  }
  HEAP32[i1 >> 2] = i5;
  i4 = i1 + 16 | 0;
  if ((i5 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[i4 + (i1 << 5) >> 2] = 0;
    HEAP32[i4 + (i1 << 5) + 4 >> 2] = 0;
    HEAP32[i4 + (i1 << 5) + 8 >> 2] = 0;
    HEAP32[i4 + (i1 << 5) + 12 >> 2] = -1;
    HEAP32[i4 + (i1 << 5) + 16 >> 2] = 63;
    HEAP32[i4 + (i1 << 5) + 20 >> 2] = 63;
    HEAP32[i4 + (i1 << 5) + 24 >> 2] = 0;
    HEAP32[i4 + (i1 << 5) + 28 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  HEAP32[i6 >> 2] = i5;
  i3 = i22 + 68 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i2 = i5; else {
   i2 = HEAP32[i18 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + -16 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i4;
 }
 i16 = i22 + 76 | 0;
 HEAP32[i16 >> 2] = i5;
 if ((i2 | 0) < 0) {
  i3 = HEAP32[i18 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i1 = i22 + 68 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i21 = HEAP32[i18 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i21 = 28;
  }
 } else i21 = 28;
 if ((i21 | 0) == 28) HEAP32[i16 >> 2] = 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i15 = i22 + 56 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 L45 : do if ((i1 | 0) > 0) {
  i13 = i22 + 140 | 0;
  i12 = i22 + 132 | 0;
  i14 = i22 + 68 | 0;
  i11 = 0;
  L47 : while (1) {
   i9 = HEAP32[i2 + (i11 << 2) >> 2] | 0;
   if (!i9) {
    i21 = 32;
    break;
   }
   i10 = HEAP32[i9 >> 2] | 0;
   i2 = i10 & 65535;
   if ((i10 & -65536 | 0) == -704643072) {
    i1 = i2 >>> 0 > 18 ? 4 : 3;
    if ((i2 | 0) == 18) {
     if (i9 & 15 | 0) {
      i21 = 39;
      break;
     }
    } else i21 = 37;
   } else {
    i1 = (i2 | 0) == 214 ? 5 : 2;
    i21 = 37;
   }
   if ((i21 | 0) == 37) {
    i21 = 0;
    switch (i1 & 7) {
    case 2:
     {
      i21 = 38;
      break L47;
     }
    case 0:
     break;
    default:
     {
      i21 = 39;
      break L47;
     }
    }
   }
   i5 = HEAP32[i9 + 160 >> 2] | 0;
   i10 = HEAP32[i9 + 144 >> 2] | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i7 = HEAP32[i13 >> 2] | 0;
   i8 = i7 + 1 | 0;
   if ((HEAP32[i19 >> 2] | 0) > (i7 | 0)) i1 = HEAP32[i12 >> 2] | 0; else {
    i2 = i8 << 1;
    i2 = (i2 | 0) > 16 ? i2 : 16;
    i1 = HEAP32[i20 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
    if (!i1) {
     i21 = 51;
     break;
    }
    HEAP32[i1 >> 2] = i2;
    i1 = i1 + 16 | 0;
    HEAP32[i19 >> 2] = i2;
    i4 = HEAP32[i12 >> 2] | 0;
    if (i4 | 0) {
     i2 = HEAP32[i13 >> 2] | 0;
     if (i2 | 0) {
      i3 = (i2 | 0) <= (i8 | 0) ? i2 : i8;
      if ((i3 | 0) > 0) {
       i2 = 0;
       do {
        HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i3 | 0));
      }
     }
     i3 = HEAP32[i20 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 + -16 | 0);
    }
    HEAP32[i12 >> 2] = i1;
   }
   HEAP32[i13 >> 2] = i8;
   HEAP32[i1 + (i7 << 2) >> 2] = i6;
   if ((i10 | 0) > 0) {
    i2 = i9 + i5 | 0;
    i1 = 0;
    do {
     i3 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
     i4 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i11 << 2) >> 2] | 0;
     i5 = HEAP32[i16 >> 2] | 0;
     if (!(__ZN5Umbra5ArrayINS_20RuntimeTomeGenerator13GeneratorTileEE6updateEibbb(i18, i5 + 1 | 0, 1, 0, 0) | 0)) {
      i21 = 54;
      break L47;
     }
     i9 = HEAP32[i14 >> 2] | 0;
     HEAP32[i9 + (i5 << 5) >> 2] = (i3 | 0) == 0 ? 0 : i4 + i3 | 0;
     HEAP32[i9 + (i5 << 5) + 4 >> 2] = 0;
     HEAP32[i9 + (i5 << 5) + 8 >> 2] = i1;
     HEAP32[i9 + (i5 << 5) + 12 >> 2] = -1;
     HEAP32[i9 + (i5 << 5) + 16 >> 2] = 63;
     HEAP32[i9 + (i5 << 5) + 20 >> 2] = 63;
     HEAP32[i9 + (i5 << 5) + 24 >> 2] = 0;
     HEAP32[i9 + (i5 << 5) + 28 >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i10 | 0));
   }
   i11 = i11 + 1 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   if ((i11 | 0) >= (i1 | 0)) break L45;
  }
  if ((i21 | 0) == 32) {
   HEAP32[i22 + 464 >> 2] = 2;
   i22 = 0;
   return i22 | 0;
  } else if ((i21 | 0) == 38) {
   HEAP32[i22 + 464 >> 2] = 4;
   i22 = 0;
   return i22 | 0;
  } else if ((i21 | 0) == 39) {
   HEAP32[i22 + 464 >> 2] = 2;
   i22 = 0;
   return i22 | 0;
  } else if ((i21 | 0) == 51) {
   HEAP32[i22 + 464 >> 2] = 1;
   i22 = 0;
   return i22 | 0;
  } else if ((i21 | 0) == 54) {
   HEAP32[i22 + 464 >> 2] = 1;
   i22 = 0;
   return i22 | 0;
  }
 } while (0);
 __ZN5Umbra20RuntimeTomeGenerator12estimateTomeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEERNS0_8EstimateE(i2, i1, i18, i22 + 8 | 0);
 i1 = HEAP32[i22 >> 2] | 0;
 i6 = i22 + 144 | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i6 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 }
 i4 = HEAP32[i16 >> 2] | 0;
 i5 = i22 + 152 | 0;
 if ((HEAP32[i5 >> 2] | 0) < (i4 | 0)) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i4 << 2) + 16 | 0, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = i4;
   HEAP32[i5 >> 2] = i4;
   i1 = i22 + 148 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i21 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i21 = 65;
  }
 } else i21 = 65;
 if ((i21 | 0) == 65) HEAP32[i22 + 156 >> 2] = i4;
 if ((HEAP32[i5 >> 2] | 0) < 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i22 + 148 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i21 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i21 = 71;
  }
 } else i21 = 71;
 if ((i21 | 0) == 71) HEAP32[i22 + 156 >> 2] = 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i4 = i22 + 160 | 0;
 HEAP32[i4 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i4 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 }
 i2 = i22 + 168 | 0;
 if ((HEAP32[i2 >> 2] | 0) < 0) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, 0) | 0;
  if (!i3) {
   i22 = 1;
   return i22 | 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i22 + 164 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i21 = HEAP32[i4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = i3 + 16;
 }
 HEAP32[i22 + 172 >> 2] = 0;
 i22 = 1;
 return i22 | 0;
}

function __ZN5physx7NpScene11shiftOriginERKNS_6PxVec3E(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 4 | 0;
 i11 = i14 + 16 | 0;
 if (HEAP8[i14 + 2449 >> 0] | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 3026, gb + 703231 | 0, i15);
  STACKTOP = i15;
  return;
 }
 i9 = i14 + 3552 | 0;
 i10 = HEAP32[i14 + 3556 >> 2] | 0;
 i7 = i10 >>> 2;
 if (!i7) i1 = 0; else {
  i3 = i7 + -1 | 0;
  i4 = i13 + 4 | 0;
  i5 = i13 + 8 | 0;
  i8 = 0;
  i2 = 0;
  while (1) {
   i6 = i2 + 4 | 0;
   if (i8 >>> 0 >= i3 >>> 0) if (i6 >>> 0 < i10 >>> 0) {
    i1 = i6;
    do i1 = i1 + 1 | 0; while ((i1 | 0) != (i10 | 0));
   }
   do {
    i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
    case 1:
     {
      f17 = Math_fround(HEAPF32[i13 >> 2]);
      i16 = i1 + 240 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i4 >> 2]);
      i16 = i1 + 244 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i5 >> 2]);
      i16 = i1 + 248 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i1 + 64 | 0, i13);
      break;
     }
    case 0:
     {
      f17 = Math_fround(HEAPF32[i13 >> 2]);
      i16 = i1 + 96 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i4 >> 2]);
      i16 = i1 + 100 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i5 >> 2]);
      i16 = i1 + 104 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      break;
     }
    default:
     {
      f17 = Math_fround(HEAPF32[i13 >> 2]);
      i16 = i1 + 240 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i4 >> 2]);
      i16 = i1 + 244 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      f17 = Math_fround(HEAPF32[i5 >> 2]);
      i16 = i1 + 248 | 0;
      HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
      __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i1 + 64 | 0, i13);
     }
    }
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i6 >>> 0);
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i7 | 0)) break; else i2 = i6;
  }
  i1 = i7 << 2;
 }
 L24 : do if (i1 >>> 0 < i10 >>> 0) {
  i3 = i13 + 4 | 0;
  i4 = i13 + 8 | 0;
  while (1) {
   i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   switch (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0) {
   case 1:
    {
     f17 = Math_fround(HEAPF32[i13 >> 2]);
     i16 = i2 + 240 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i3 >> 2]);
     i16 = i2 + 244 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i4 >> 2]);
     i16 = i2 + 248 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i2 + 64 | 0, i13);
     break;
    }
   case 0:
    {
     f17 = Math_fround(HEAPF32[i13 >> 2]);
     i16 = i2 + 96 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i3 >> 2]);
     i16 = i2 + 100 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i4 >> 2]);
     i16 = i2 + 104 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     break;
    }
   default:
    {
     f17 = Math_fround(HEAPF32[i13 >> 2]);
     i16 = i2 + 240 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i3 >> 2]);
     i16 = i2 + 244 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     f17 = Math_fround(HEAPF32[i4 >> 2]);
     i16 = i2 + 248 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
     __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i2 + 64 | 0, i13);
    }
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i10 | 0)) break L24;
  }
 } while (0);
 i1 = i14 + 3568 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i14 + 3564 | 0;
  i3 = i13 + 4 | 0;
  i4 = i13 + 8 | 0;
  i8 = 0;
  do {
   i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i6 = HEAP32[i5 + 88 >> 2] | 0;
   L38 : do if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 108 >> 2] | 0, i5 | 0) | 0) {
    i9 = 0;
    while (1) {
     i7 = HEAP32[i6 + (i9 << 2) >> 2] | 0;
     switch (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0) {
     case 1:
      {
       f17 = Math_fround(HEAPF32[i13 >> 2]);
       i16 = i7 + 240 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i3 >> 2]);
       i16 = i7 + 244 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i4 >> 2]);
       i16 = i7 + 248 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i7 + 64 | 0, i13);
       break;
      }
     case 0:
      {
       f17 = Math_fround(HEAPF32[i13 >> 2]);
       i16 = i7 + 96 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i3 >> 2]);
       i16 = i7 + 100 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i4 >> 2]);
       i16 = i7 + 104 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       break;
      }
     default:
      {
       f17 = Math_fround(HEAPF32[i13 >> 2]);
       i16 = i7 + 240 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i3 >> 2]);
       i16 = i7 + 244 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       f17 = Math_fround(HEAPF32[i4 >> 2]);
       i16 = i7 + 248 | 0;
       HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f17);
       __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i7 + 64 | 0, i13);
      }
     }
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 108 >> 2] | 0, i5 | 0) | 0) >>> 0) break L38;
    }
   } while (0);
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 __ZN5physx3Scb5Scene11shiftOriginERKNS_6PxVec3E(i11, i13);
 __ZN5physx2Sq17SceneQueryManager11shiftOriginERKNS_6PxVec3E(i14 + 3392 | 0, i13);
 i7 = i14 + 3600 | 0;
 L48 : do if (!(HEAP32[i14 + 3604 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i14 + 3608 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L48;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i14 + 3592 | 0;
 i6 = i14 + 3596 | 0;
 i4 = i14 + 3608 | 0;
 L55 : while (1) {
  do {
   if ((i1 | 0) == -1) break L55;
   __ZN5physx13NpVolumeCache13onOriginShiftERKNS_6PxVec3E(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0, i13);
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L55;
   }
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L55;
  }
 }
 f19 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i13 + 4 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i13 + 8 >> 2]));
 HEAPF32[i12 >> 2] = f19;
 HEAPF32[i12 + 4 >> 2] = f18;
 HEAPF32[i12 + 8 >> 2] = f17;
 __ZN5physx2Cm12RenderBuffer5shiftERKNS_6PxVec3E(i14 + 3476 | 0, i12);
 STACKTOP = i15;
 return;
}

function __ZN15QualitySettings16CheckConsistencyEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 648 | 0;
 i7 = i11;
 i5 = i10 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i8 = i10 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = i7 + 648 | 0;
  i2 = i7;
  do {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i2 + 11 >> 0] = 7;
   HEAP8[i2 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
   HEAP8[i2 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
   HEAP8[i2 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
   HEAP8[i2 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
   HEAP8[i2 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
   HEAP8[i2 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
   HEAP8[i2 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
   HEAP8[i2 + 7 >> 0] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 1;
   HEAP32[i2 + 32 >> 2] = 1;
   HEAPF32[i2 + 36 >> 2] = Math_fround(15.0);
   HEAPF32[i2 + 40 >> 2] = Math_fround(3.0);
   HEAPF32[i2 + 44 >> 2] = Math_fround(.333333343);
   HEAPF32[i2 + 48 >> 2] = Math_fround(.0666666701);
   HEAPF32[i2 + 52 >> 2] = Math_fround(.200000003);
   HEAPF32[i2 + 56 >> 2] = Math_fround(.466666669);
   HEAP32[i2 + 60 >> 2] = 1;
   HEAP32[i2 + 64 >> 2] = 1;
   i4 = i2 + 68 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAPF32[i2 + 84 >> 2] = Math_fround(.300000012);
   HEAP32[i2 + 88 >> 2] = 0;
   HEAP32[i2 + 92 >> 2] = 4;
   HEAPF32[i2 + 96 >> 2] = Math_fround(512.0);
   HEAP32[i2 + 100 >> 2] = 2;
   HEAP32[i2 + 104 >> 2] = 4;
   i2 = i2 + 108 | 0;
  } while ((i2 | 0) != (i1 | 0));
  __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE(i7);
  i1 = i7 + 324 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i10 + 36 >> 2] | 0)) __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i1); else {
   i3 = HEAP8[i1 + 11 >> 0] | 0;
   i12 = i3 << 24 >> 24 < 0;
   i2 = i12 ? HEAP32[i1 >> 2] | 0 : i1;
   i3 = i12 ? HEAP32[i7 + 328 >> 2] | 0 : i3 & 255;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i4 + 12 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    i6 = 9;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i4 + 11 >> 0] = i3;
    if (!i3) i1 = i4; else {
     i1 = i4;
     i6 = 11;
    }
   } else i6 = 9;
   if ((i6 | 0) == 9) {
    i12 = i3 + 16 & -16;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i9 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i4 + 8 >> 2] = i12 | -2147483648;
    HEAP32[i4 + 4 >> 2] = i3;
    i6 = 11;
   }
   if ((i6 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = i4 + 16 | 0;
   i2 = i7 + 340 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 48 >> 2] = HEAP32[i7 + 372 >> 2];
   HEAP32[i4 + 52 >> 2] = HEAP32[i7 + 376 >> 2];
   HEAP32[i4 + 56 >> 2] = HEAP32[i7 + 380 >> 2];
   i1 = i4 + 60 | 0;
   i2 = i7 + 384 | 0;
   i3 = i1 + 48 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 108;
  }
  i2 = i9 + 4 | 0;
  i1 = i7 + 540 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i7 + 552 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  i1 = i7 + 432 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i7 + 444 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  i1 = i7 + 324 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i7 + 336 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  i1 = i7 + 216 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i7 + 228 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  i1 = i7 + 108 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i7 + 120 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
   i12 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i2 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i6 = i8;
  i3 = i1;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i6 = i8;
  i3 = i1;
 }
 i1 = i2 - i1 | 0;
 if (!i1) {
  i8 = (i1 | 0) / 108 | 0;
  i12 = i10 + 44 | 0;
  i8 = i8 + -1 | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i9 = (i10 | 0) < 0;
  i7 = (i10 | 0) > (i8 | 0);
  i10 = i7 ? i8 : i10;
  i10 = i9 ? 0 : i10;
  HEAP32[i12 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i4 = 0;
 do {
  i2 = i3 + (i4 * 108 | 0) + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (i1 | 0) < 0 ? 0 : i1;
  i2 = i3 + (i4 * 108 | 0) + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (i1 | 0) < 0 ? 0 : (i1 | 0) > 2 ? 2 : i1;
  i2 = i3 + (i4 * 108 | 0) + 24 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (i1 | 0) < 0 ? 0 : (i1 | 0) > 3 ? 3 : i1;
  i2 = i3 + (i4 * 108 | 0) + 28 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (i1 | 0) < 0 ? 0 : (i1 | 0) > 1 ? 1 : i1;
  i2 = i3 + (i4 * 108 | 0) + 32 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) < 1) i1 = 1; else if ((i1 | 0) > 4) i1 = 4; else i1 = (i1 | 0) == 3 ? 2 : i1;
  HEAP32[i2 >> 2] = i1;
  i1 = i3 + (i4 * 108 | 0) + 72 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  do if ((i2 | 0) < 2) HEAP32[i1 >> 2] = 0; else {
   if ((i2 | 0) < 4) {
    HEAP32[i1 >> 2] = 2;
    break;
   }
   if ((i2 | 0) < 8) {
    HEAP32[i1 >> 2] = 4;
    break;
   } else {
    HEAP32[i1 >> 2] = 8;
    break;
   }
  } while (0);
  i1 = i3 + (i4 * 108 | 0) + 36 | 0;
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i12 = Math_fround(HEAPF32[i1 >> 2]) < Math_fround(0.0);
  HEAP32[i1 >> 2] = HEAP32[(i12 ? i9 : i1) >> 2];
  i1 = i3 + (i4 * 108 | 0) + 40 | 0;
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i12 = Math_fround(HEAPF32[i1 >> 2]) < Math_fround(0.0);
  HEAP32[i1 >> 2] = HEAP32[(i12 ? i9 : i1) >> 2];
  i1 = i3 + (i4 * 108 | 0) + 60 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  i12 = (i12 | 0) < 1 ? 1 : i12;
  i12 = (i12 | 0) > 4 ? 4 : i12;
  HEAP32[i1 >> 2] = (i12 | 0) == 3 ? 2 : i12;
  i1 = i3 + (i4 * 108 | 0) + 64 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  i12 = (i12 | 0) < 0 ? 0 : i12;
  HEAP32[i1 >> 2] = (i12 | 0) > 10 ? 10 : i12;
  i1 = i3 + (i4 * 108 | 0) + 68 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = (i12 | 0) < 0 ? 0 : (i12 | 0) > 2 ? 2 : i12;
  i1 = i3 + (i4 * 108 | 0) + 76 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  i12 = (i12 | 0) < 0 ? 0 : i12;
  HEAP32[i1 >> 2] = (i12 | 0) > 2 ? 2 : i12;
  HEAPF32[i9 >> 2] = Math_fround(.00999999977);
  i1 = i3 + (i4 * 108 | 0) + 84 | 0;
  i12 = Math_fround(HEAPF32[i1 >> 2]) > Math_fround(.00999999977);
  HEAP32[i1 >> 2] = HEAP32[(i12 ? i1 : i9) >> 2];
  i1 = i3 + (i4 * 108 | 0) + 88 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = (i12 | 0) < 0 ? 0 : (i12 | 0) > 7 ? 7 : i12;
  i4 = i4 + 1 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i3 | 0) / 108 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 i12 = i10 + 44 | 0;
 i8 = i1 + -1 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i9 = (i10 | 0) < 0;
 i7 = (i10 | 0) > (i8 | 0);
 i10 = i7 ? i8 : i10;
 i10 = i9 ? 0 : i10;
 HEAP32[i12 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = i2;
 L1 : while (1) {
  i11 = i14;
  i15 = i14 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i10 = i1;
    i2 = i11 - i10 | 0;
    i3 = i2 >> 2;
    switch (i3 | 0) {
    case 2:
     {
      i13 = 5;
      break L1;
     }
    case 3:
     {
      i13 = 7;
      break L1;
     }
    case 4:
     {
      i13 = 15;
      break L1;
     }
    case 5:
     {
      i13 = 27;
      break L1;
     }
    case 1:
    case 0:
     {
      i13 = 87;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 124) {
     i13 = 29;
     break L1;
    }
    i9 = i1 + (((i3 | 0) / 2 | 0) << 2) | 0;
    do if ((i2 | 0) > 3996) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i2 << 2) | 0, i9, i9 + (i2 << 2) | 0, i15, i12) | 0;
    } else {
     i8 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     i2 = i4 >>> 0 < i8 >>> 0;
     i3 = i8;
     i6 = i5;
     if (i8 >>> 0 >= i5 >>> 0) {
      if (!i2) {
       i2 = 0;
       break;
      }
      HEAP32[i9 >> 2] = i4;
      HEAP32[i15 >> 2] = i3;
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if (i2 >>> 0 >= i3 >>> 0) {
       i2 = 1;
       break;
      }
      HEAP32[i1 >> 2] = i2;
      HEAP32[i9 >> 2] = i3;
      i2 = 2;
      break;
     }
     if (i2) {
      HEAP32[i1 >> 2] = i4;
      HEAP32[i15 >> 2] = i6;
      i2 = 1;
      break;
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i9 >> 2] = i6;
     i2 = HEAP32[i15 >> 2] | 0;
     if (i2 >>> 0 < i5 >>> 0) {
      HEAP32[i9 >> 2] = i2;
      HEAP32[i15 >> 2] = i6;
      i2 = 2;
     } else i2 = 1;
    } while (0);
    i6 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    if (i6 >>> 0 < i4 >>> 0) {
     i3 = i15;
     break;
    } else i3 = i15;
    while (1) {
     i3 = i3 + -4 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i5 = HEAP32[i3 >> 2] | 0;
     if (i5 >>> 0 < i4 >>> 0) {
      i13 = 69;
      break L5;
     }
    }
    i2 = i1 + 4 | 0;
    i10 = HEAP32[i15 >> 2] | 0;
    i4 = i10;
    if (i6 >>> 0 >= i10 >>> 0) {
     if ((i2 | 0) == (i15 | 0)) {
      i13 = 87;
      break L1;
     }
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (i6 >>> 0 < i3 >>> 0) break;
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i15 | 0)) {
       i13 = 87;
       break L1;
      }
     }
     HEAP32[i2 >> 2] = i4;
     HEAP32[i15 >> 2] = i3;
     i2 = i2 + 4 | 0;
    }
    if ((i2 | 0) == (i15 | 0)) {
     i13 = 87;
     break L1;
    } else i4 = i15;
    while (1) {
     i7 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      i6 = i2 + 4 | 0;
      if (i7 >>> 0 < i3 >>> 0) break; else i2 = i6;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while (i7 >>> 0 < i5 >>> 0);
     if (i2 >>> 0 >= i4 >>> 0) {
      i1 = i2;
      continue L5;
     }
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i3;
     i2 = i6;
    }
   }
   if ((i13 | 0) == 69) {
    i13 = 0;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i3 >> 2] = i6;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 4 | 0;
   L45 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i8 = HEAP32[i9 >> 2] | 0;
    while (1) {
     i5 = HEAP32[i4 >> 2] | 0;
     i7 = i4 + 4 | 0;
     if (i5 >>> 0 < i8 >>> 0) i4 = i7; else break;
    }
    do {
     i3 = i3 + -4 | 0;
     i6 = HEAP32[i3 >> 2] | 0;
    } while (i6 >>> 0 >= i8 >>> 0);
    if (i4 >>> 0 > i3 >>> 0) {
     i5 = i9;
     i6 = i4;
     break L45;
    }
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i5;
    i9 = (i9 | 0) == (i4 | 0) ? i3 : i9;
    i4 = i7;
    i2 = i2 + 1 | 0;
   } else {
    i5 = i9;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    if (i3 >>> 0 < i4 >>> 0) {
     HEAP32[i6 >> 2] = i3;
     HEAP32[i5 >> 2] = i4;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIR26ColliderIdentityComparitorPP10Collider2DEEbT0_S6_T_(i1, i6, i12) | 0;
    i3 = i6 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR26ColliderIdentityComparitorPP10Collider2DEEbT0_S6_T_(i3, i14, i12) | 0) {
     i13 = 86;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i9 = i6;
   if ((i9 - i10 | 0) >= (i11 - i9 | 0)) {
    i13 = 85;
    break;
   }
   __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_(i1, i6, i12);
   i1 = i6 + 4 | 0;
  }
  if ((i13 | 0) == 85) {
   i13 = 0;
   __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_(i6 + 4 | 0, i14, i12);
   i14 = i6;
   continue;
  } else if ((i13 | 0) == 86) {
   i13 = 0;
   if (i2) {
    i13 = 87;
    break;
   } else {
    i14 = i6;
    continue;
   }
  }
 }
 if ((i13 | 0) == 5) {
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 >= i3 >>> 0) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  return;
 } else if ((i13 | 0) == 7) {
  i7 = i1 + 4 | 0;
  i14 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i2 = i4 >>> 0 < i14 >>> 0;
  i3 = i14;
  i6 = i5;
  if (i14 >>> 0 >= i5 >>> 0) {
   if (!i2) return;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i15 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 >= i3 >>> 0) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   return;
  }
  if (i2) {
   HEAP32[i1 >> 2] = i4;
   HEAP32[i15 >> 2] = i6;
   return;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i6;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 >>> 0 >= i5 >>> 0) return;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i15 >> 2] = i6;
  return;
 } else if ((i13 | 0) == 15) {
  i10 = i1 + 4 | 0;
  i9 = i1 + 8 | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = i4 >>> 0 < i6 >>> 0;
  i3 = i6;
  i7 = i4;
  i8 = i2;
  do if (i6 >>> 0 < i2 >>> 0) {
   if (i5) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i9 >> 2] = i8;
    i4 = i2;
    i3 = i8;
    break;
   }
   HEAP32[i1 >> 2] = i3;
   HEAP32[i10 >> 2] = i8;
   if (i4 >>> 0 < i2 >>> 0) {
    HEAP32[i10 >> 2] = i7;
    HEAP32[i9 >> 2] = i8;
    i4 = i2;
    i3 = i8;
   } else i3 = i7;
  } else if (i5) {
   HEAP32[i10 >> 2] = i7;
   HEAP32[i9 >> 2] = i3;
   if (i4 >>> 0 < i2 >>> 0) {
    HEAP32[i1 >> 2] = i7;
    HEAP32[i10 >> 2] = i8;
    i4 = i6;
    i3 = i6;
   } else i4 = i6;
  } else i3 = i7; while (0);
  i2 = HEAP32[i15 >> 2] | 0;
  if (i2 >>> 0 >= i4 >>> 0) return;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 >= i2 >>> 0) return;
  i4 = i3;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i9 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i3 >>> 0 >= i2 >>> 0) return;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i10 >> 2] = i2;
  return;
 } else if ((i13 | 0) == 27) {
  __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i15, i12) | 0;
  return;
 } else if ((i13 | 0) == 29) {
  i10 = i1 + 8 | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = i5 >>> 0 < i3 >>> 0;
  i7 = i3;
  i8 = i5;
  i9 = i4;
  do if (i3 >>> 0 < i4 >>> 0) {
   if (i6) {
    HEAP32[i1 >> 2] = i8;
    HEAP32[i10 >> 2] = i9;
    i3 = i4;
    break;
   }
   HEAP32[i1 >> 2] = i7;
   HEAP32[i2 >> 2] = i9;
   if (i5 >>> 0 < i4 >>> 0) {
    HEAP32[i2 >> 2] = i8;
    HEAP32[i10 >> 2] = i9;
    i3 = i4;
   } else i3 = i5;
  } else if (i6) {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i10 >> 2] = i7;
   if (i5 >>> 0 < i4 >>> 0) {
    HEAP32[i1 >> 2] = i8;
    HEAP32[i2 >> 2] = i9;
   }
  } else i3 = i5; while (0);
  i2 = i1 + 12 | 0;
  if ((i2 | 0) == (i14 | 0)) return; else {
   i6 = i2;
   i2 = i10;
  }
  while (1) {
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i4;
   if (i4 >>> 0 < i3 >>> 0) {
    i3 = i2;
    i2 = i6;
    while (1) {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     if ((i3 | 0) == (i1 | 0)) break;
     i2 = i3 + -4 | 0;
     if (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) {
      i15 = i3;
      i3 = i2;
      i2 = i15;
     } else break;
    }
    HEAP32[i3 >> 2] = i5;
   }
   i2 = i6 + 4 | 0;
   if ((i2 | 0) == (i14 | 0)) break;
   i3 = HEAP32[i6 >> 2] | 0;
   i15 = i6;
   i6 = i2;
   i2 = i15;
  }
  return;
 } else if ((i13 | 0) == 87) return;
}

function __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi(i18, i19, i20) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0;
 i21 = i18 + 8 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (!(i1 & 536870912)) {
  i21 = i1;
  return i21 | 0;
 }
 i7 = HEAP32[i18 >> 2] | 0;
 i1 = i18 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 do if (!((i2 | 0) == 0 & (i1 | 0) == 0)) {
  i4 = _bitshift64Lshr(i2 | 0, i1 | 0, 48) | 0;
  getTempRet0() | 0;
  i3 = _bitshift64Lshr(i2 | 0, i1 | 0, 20) | 0;
  getTempRet0() | 0;
  i3 = i3 & 268435455;
  i5 = i2 & 65535;
  if ((i2 & 983040 | 0) == 65536 & 0 == 0) {
   if (i5 >>> 0 >= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) break;
   if ((HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + (i5 * 104 | 0) + 92 >> 2] | 0) != (i4 | 0)) break;
  } else {
   if (i3 >>> 0 >= (HEAP32[i7 + 16 >> 2] | 0) >>> 0) break;
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) break;
   i1 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
   if (!i1) break;
   if (i5 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) break;
  }
  i17 = i18 + 32 | 0;
  i1 = i17;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!((i2 | 0) == 0 & (i1 | 0) == 0)) {
   i4 = _bitshift64Lshr(i2 | 0, i1 | 0, 48) | 0;
   getTempRet0() | 0;
   i3 = _bitshift64Lshr(i2 | 0, i1 | 0, 20) | 0;
   getTempRet0() | 0;
   i3 = i3 & 268435455;
   i5 = i2 & 65535;
   if ((i2 & 983040 | 0) == 65536 & 0 == 0) {
    if (i5 >>> 0 >= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) break;
    if ((HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + (i5 * 104 | 0) + 92 >> 2] | 0) != (i4 | 0)) break;
   } else {
    if (i3 >>> 0 >= (HEAP32[i7 + 16 >> 2] | 0) >>> 0) break;
    i1 = HEAP32[i7 + 20 >> 2] | 0;
    if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) break;
    i1 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
    if (!i1) break;
    if (i5 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) break;
   }
   i16 = i18 + 80 | 0;
   L23 : do if ((i19 | 0) > 0) {
    i14 = i18 + 76 | 0;
    i1 = 0;
    L25 : while (1) {
     i8 = HEAP32[i16 >> 2] | 0;
     i3 = i8 + 8 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) break L23;
     i15 = i1 + 1 | 0;
     i4 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i4 >> 2] | 0;
     i5 = i2 + -1 | 0;
     HEAP32[i3 >> 2] = i5;
     i7 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
     L28 : do if ((i5 | 0) > 1) {
      i3 = 0;
      i1 = 1;
      while (1) {
       i2 = i1 + 1 | 0;
       if ((i2 | 0) < (i5 | 0)) {
        f6 = Math_fround(HEAPF32[(HEAP32[i4 + (i1 << 2) >> 2] | 0) + 16 >> 2]);
        if (f6 > Math_fround(HEAPF32[(HEAP32[i4 + (i2 << 2) >> 2] | 0) + 16 >> 2])) i1 = i2;
       }
       HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
       i2 = i1 << 1 | 1;
       if ((i2 | 0) >= (i5 | 0)) break;
       i3 = i1;
       i1 = i2;
       i4 = HEAP32[i8 >> 2] | 0;
      }
      if ((i1 | 0) > 0) {
       f6 = Math_fround(HEAPF32[i7 + 16 >> 2]);
       i3 = i1;
       while (1) {
        i2 = i3 + -1 | 0;
        i1 = (i2 | 0) / 2 | 0;
        i4 = HEAP32[i8 >> 2] | 0;
        i5 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
        if (!(Math_fround(HEAPF32[i5 + 16 >> 2]) > f6)) {
         i1 = i3;
         break L28;
        }
        HEAP32[i4 + (i3 << 2) >> 2] = i5;
        if ((i2 | 0) > 1) i3 = i1; else break;
       }
      }
     } else i1 = 0; while (0);
     HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i7;
     i12 = i13 + 20 | 0;
     i2 = HEAP32[i12 >> 2] & 1073741823;
     HEAP32[i12 >> 2] = i2 | -2147483648;
     i12 = i13 + 24 | 0;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     i10 = i17;
     if ((i11 | 0) == (HEAP32[i10 >> 2] | 0) ? (i12 | 0) == (HEAP32[i10 + 4 >> 2] | 0) : 0) {
      i7 = 34;
      break;
     }
     i10 = HEAP32[i18 >> 2] | 0;
     if ((i11 | 0) == 0 & (i12 | 0) == 0) {
      i7 = 44;
      break;
     }
     i8 = _bitshift64Lshr(i11 | 0, i12 | 0, 48) | 0;
     getTempRet0() | 0;
     i5 = _bitshift64Lshr(i11 | 0, i12 | 0, 20) | 0;
     getTempRet0() | 0;
     i5 = i5 & 268435455;
     i9 = i11 & 65535;
     i4 = (i11 & 983040 | 0) == 65536 & 0 == 0;
     if (i4) {
      if (i9 >>> 0 >= (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
       i7 = 44;
       break;
      }
      if ((HEAP32[(HEAP32[i10 + 48 >> 2] | 0) + (i9 * 104 | 0) + 92 >> 2] | 0) != (i8 | 0)) {
       i7 = 44;
       break;
      }
     } else {
      if (i5 >>> 0 >= (HEAP32[i10 + 16 >> 2] | 0) >>> 0) {
       i7 = 44;
       break;
      }
      i1 = HEAP32[i10 + 20 >> 2] | 0;
      if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i8 | 0)) {
       i7 = 44;
       break;
      }
      i1 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
      if (!i1) {
       i7 = 44;
       break;
      }
      if (i9 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
       i7 = 44;
       break;
      }
     }
     do if (!i2) if (i4) {
      i3 = 0;
      i2 = 0;
      i7 = 57;
     } else {
      i3 = 0;
      i2 = 0;
      i7 = 61;
     } else {
      i2 = (HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + (i2 + -1 << 5) + 24 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (i4) {
       if (i9 >>> 0 >= (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
        i7 = 54;
        break L25;
       }
       if ((HEAP32[(HEAP32[i10 + 48 >> 2] | 0) + (i9 * 104 | 0) + 92 >> 2] | 0) == (i8 | 0)) {
        i7 = 57;
        break;
       } else {
        i7 = 54;
        break L25;
       }
      }
      if (i5 >>> 0 >= (HEAP32[i10 + 16 >> 2] | 0) >>> 0) {
       i7 = 54;
       break L25;
      }
      i1 = HEAP32[i10 + 20 >> 2] | 0;
      if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i8 | 0)) {
       i7 = 54;
       break L25;
      }
      i1 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
      if (!i1) {
       i7 = 54;
       break L25;
      }
      if (i9 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) i7 = 61; else {
       i7 = 54;
       break L25;
      }
     } while (0);
     do if ((i7 | 0) == 57) {
      i7 = 0;
      if (i9 >>> 0 <= (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
       i1 = HEAP32[i10 + 48 >> 2] | 0;
       if (!((i1 + (i9 * 104 | 0) | 0) == 0 ? 1 : (i8 | 0) != (HEAP32[i1 + (i9 * 104 | 0) + 92 >> 2] | 0))) {
        i1 = HEAP32[i1 + (i9 * 104 | 0) + 88 >> 2] | 0;
        if ((i1 | 0) != -1) {
         i1 = (HEAP32[i10 + 36 >> 2] | 0) + (i1 << 4) | 0;
         i7 = 67;
        }
       }
      }
     } else if ((i7 | 0) == 61) {
      i7 = 0;
      if (i5 >>> 0 < (HEAP32[i10 + 16 >> 2] | 0) >>> 0) {
       i4 = HEAP32[i10 + 20 >> 2] | 0;
       if ((HEAP32[i4 + (i5 * 56 | 0) + 4 >> 2] | 0) == (i8 | 0)) {
        i1 = HEAP32[i4 + (i5 * 56 | 0) + 8 >> 2] | 0;
        if (i1 | 0) if (i9 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
         i1 = HEAP32[(HEAP32[i4 + (i5 * 56 | 0) + 12 >> 2] | 0) + (i9 << 2) >> 2] | 0;
         if ((i1 | 0) == -1) break;
         i1 = (HEAP32[i10 + 36 >> 2] | 0) + (i1 << 4) | 0;
         i7 = 67;
        }
       }
      }
     } while (0);
     L73 : do if ((i7 | 0) == 67) if (i1 | 0) do {
      __ZN14dtNavMeshQuery19updateNeighbourLinkEPK6dtLinkyyPK6dtNode(i18, i1, i3, i2, i11, i12, i13);
      i1 = HEAP32[i1 + 8 >> 2] | 0;
      if ((i1 | 0) == -1) break L73;
      i1 = (HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0) + (i1 << 4) | 0;
     } while ((i1 | 0) != 0); while (0);
     if ((i15 | 0) < (i19 | 0)) i1 = i15; else {
      i1 = i15;
      break L23;
     }
    }
    if ((i7 | 0) == 34) {
     HEAP32[i18 + 12 >> 2] = i13;
     i1 = HEAP32[i21 >> 2] & 16777215 | 1073741824;
     HEAP32[i21 >> 2] = i1;
     if (!i20) {
      i21 = i1;
      return i21 | 0;
     }
     HEAP32[i20 >> 2] = i15;
     i21 = HEAP32[i21 >> 2] | 0;
     return i21 | 0;
    } else if ((i7 | 0) == 44) {
     HEAP32[i21 >> 2] = -2147483648;
     if (!i20) {
      i21 = -2147483648;
      return i21 | 0;
     }
     HEAP32[i20 >> 2] = i15;
     i21 = -2147483648;
     return i21 | 0;
    } else if ((i7 | 0) == 54) {
     HEAP32[i21 >> 2] = -2147483648;
     if (!i20) {
      i21 = -2147483648;
      return i21 | 0;
     }
     HEAP32[i20 >> 2] = i15;
     i21 = -2147483648;
     return i21 | 0;
    }
   } else i1 = 0; while (0);
   if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0)) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & 16777215 | 1073741824;
   if (i20 | 0) HEAP32[i20 >> 2] = i1;
   i21 = HEAP32[i21 >> 2] | 0;
   return i21 | 0;
  }
 } while (0);
 HEAP32[i21 >> 2] = -2147483648;
 i21 = -2147483648;
 return i21 | 0;
}

function __ZN5Umbra9Matrix4x46invertERKS0_(i29, i1) {
 i29 = i29 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 f2 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 i28 = f2 == Math_fround(0.0);
 f3 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 if (i28 & f3 == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 56 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 60 >> 2]) == Math_fround(1.0)) {
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f20 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 32 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + 36 >> 2]);
  f30 = Math_fround(HEAPF32[i1 + 40 >> 2]);
  f15 = Math_fround(HEAPF32[i1 + 44 >> 2]);
  f32 = Math_fround(Math_fround(f9 * f30) - Math_fround(f2 * f21));
  f3 = Math_fround(Math_fround(f2 * f7) - Math_fround(f13 * f30));
  f19 = Math_fround(Math_fround(f13 * f21) - Math_fround(f9 * f7));
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f31 * f19) + Math_fround(Math_fround(f11 * f32) + Math_fround(f17 * f3))));
  f32 = Math_fround(f32 * f5);
  f3 = Math_fround(f3 * f5);
  f19 = Math_fround(f19 * f5);
  f11 = Math_fround(f11 * f5);
  f17 = Math_fround(f17 * f5);
  f5 = Math_fround(f31 * f5);
  f31 = Math_fround(Math_fround(f21 * f5) - Math_fround(f30 * f17));
  f33 = Math_fround(Math_fround(f2 * f17) - Math_fround(f9 * f5));
  HEAPF32[i29 >> 2] = f32;
  HEAPF32[i29 + 4 >> 2] = f31;
  HEAPF32[i29 + 8 >> 2] = f33;
  HEAPF32[i29 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f15 * f33) + Math_fround(Math_fround(f18 * f32) + Math_fround(f20 * f31))));
  f2 = Math_fround(Math_fround(f13 * f5) - Math_fround(f2 * f11));
  f5 = Math_fround(Math_fround(f30 * f11) - Math_fround(f7 * f5));
  HEAPF32[i29 + 16 >> 2] = f3;
  HEAPF32[i29 + 20 >> 2] = f5;
  HEAPF32[i29 + 24 >> 2] = f2;
  HEAPF32[i29 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(f15 * f2) + Math_fround(Math_fround(f18 * f3) + Math_fround(f20 * f5))));
  f21 = Math_fround(Math_fround(f7 * f17) - Math_fround(f21 * f11));
  f17 = Math_fround(Math_fround(f9 * f11) - Math_fround(f13 * f17));
  HEAPF32[i29 + 32 >> 2] = f19;
  HEAPF32[i29 + 36 >> 2] = f21;
  HEAPF32[i29 + 40 >> 2] = f17;
  HEAPF32[i29 + 44 >> 2] = Math_fround(-Math_fround(Math_fround(f15 * f17) + Math_fround(Math_fround(f18 * f19) + Math_fround(f20 * f21))));
  HEAPF32[i29 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i29 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i29 + 56 >> 2] = Math_fround(0.0);
  HEAPF32[i29 + 60 >> 2] = Math_fround(1.0);
  return i29 | 0;
 }
 f36 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f31 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f7 = Math_fround(Math_fround(f3 * f13) - Math_fround(f2 * f32));
 f5 = Math_fround(Math_fround(f36 * f13) - Math_fround(f2 * f11));
 f18 = Math_fround(Math_fround(f37 * f13) - Math_fround(f2 * f31));
 f15 = Math_fround(Math_fround(f36 * f32) - Math_fround(f3 * f11));
 f35 = Math_fround(Math_fround(f37 * f32) - Math_fround(f3 * f31));
 f38 = Math_fround(Math_fround(f37 * f11) - Math_fround(f36 * f31));
 HEAPF32[i29 >> 2] = Math_fround(Math_fround(f9 * f15) + Math_fround(Math_fround(f34 * f38) - Math_fround(f30 * f35)));
 i22 = i29 + 16 | 0;
 HEAPF32[i22 >> 2] = Math_fround(-Math_fround(Math_fround(f9 * f5) + Math_fround(Math_fround(f17 * f38) - Math_fround(f30 * f18))));
 i23 = i29 + 32 | 0;
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f17 * f35) - Math_fround(f34 * f18)));
 i24 = i29 + 48 | 0;
 HEAPF32[i24 >> 2] = Math_fround(-Math_fround(Math_fround(f30 * f7) + Math_fround(Math_fround(f17 * f15) - Math_fround(f34 * f5))));
 i25 = i29 + 4 | 0;
 HEAPF32[i25 >> 2] = Math_fround(-Math_fround(Math_fround(f21 * f15) + Math_fround(Math_fround(f20 * f38) - Math_fround(f33 * f35))));
 i26 = i29 + 20 | 0;
 HEAPF32[i26 >> 2] = Math_fround(Math_fround(f21 * f5) + Math_fround(Math_fround(f19 * f38) - Math_fround(f33 * f18)));
 i27 = i29 + 36 | 0;
 HEAPF32[i27 >> 2] = Math_fround(-Math_fround(Math_fround(f21 * f7) + Math_fround(Math_fround(f19 * f35) - Math_fround(f20 * f18))));
 i28 = i29 + 52 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(f33 * f7) + Math_fround(Math_fround(f19 * f15) - Math_fround(f20 * f5)));
 f5 = Math_fround(Math_fround(f37 * f17) - Math_fround(f2 * f9));
 f15 = Math_fround(Math_fround(f3 * f17) - Math_fround(f2 * f34));
 f7 = Math_fround(Math_fround(f36 * f17) - Math_fround(f2 * f30));
 f18 = Math_fround(Math_fround(f36 * f34) - Math_fround(f3 * f30));
 f35 = Math_fround(Math_fround(f37 * f34) - Math_fround(f3 * f9));
 f3 = Math_fround(Math_fround(f37 * f30) - Math_fround(f36 * f9));
 f2 = Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f20 * f3) - Math_fround(f33 * f35)));
 i1 = i29 + 8 | 0;
 HEAPF32[i1 >> 2] = f2;
 f3 = Math_fround(-Math_fround(Math_fround(f21 * f7) + Math_fround(Math_fround(f19 * f3) - Math_fround(f33 * f5))));
 i4 = i29 + 24 | 0;
 HEAPF32[i4 >> 2] = f3;
 f5 = Math_fround(Math_fround(f21 * f15) + Math_fround(Math_fround(f19 * f35) - Math_fround(f20 * f5)));
 i6 = i29 + 40 | 0;
 HEAPF32[i6 >> 2] = f5;
 f7 = Math_fround(-Math_fround(Math_fround(f33 * f15) + Math_fround(Math_fround(f19 * f18) - Math_fround(f20 * f7))));
 i8 = i29 + 56 | 0;
 HEAPF32[i8 >> 2] = f7;
 f18 = Math_fround(Math_fround(f17 * f32) - Math_fround(f34 * f13));
 f15 = Math_fround(Math_fround(f17 * f11) - Math_fround(f30 * f13));
 f13 = Math_fround(Math_fround(f17 * f31) - Math_fround(f9 * f13));
 f17 = Math_fround(Math_fround(f34 * f11) - Math_fround(f30 * f32));
 f32 = Math_fround(Math_fround(f34 * f31) - Math_fround(f9 * f32));
 f11 = Math_fround(Math_fround(f30 * f31) - Math_fround(f9 * f11));
 f9 = Math_fround(-Math_fround(Math_fround(f21 * f17) + Math_fround(Math_fround(f20 * f11) - Math_fround(f33 * f32))));
 i10 = i29 + 12 | 0;
 HEAPF32[i10 >> 2] = f9;
 f11 = Math_fround(Math_fround(f21 * f15) + Math_fround(Math_fround(f19 * f11) - Math_fround(f33 * f13)));
 i12 = i29 + 28 | 0;
 HEAPF32[i12 >> 2] = f11;
 f13 = Math_fround(-Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f19 * f32) - Math_fround(f20 * f13))));
 i14 = i29 + 44 | 0;
 HEAPF32[i14 >> 2] = f13;
 f15 = Math_fround(Math_fround(f33 * f18) + Math_fround(Math_fround(f19 * f17) - Math_fround(f20 * f15)));
 i16 = i29 + 60 | 0;
 HEAPF32[i16 >> 2] = f15;
 f17 = Math_fround(HEAPF32[i29 >> 2]);
 f19 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i22 >> 2]);
 f20 = Math_fround(f19 + Math_fround(f20 * f18));
 f19 = Math_fround(HEAPF32[i23 >> 2]);
 f33 = Math_fround(f20 + Math_fround(f33 * f19));
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f21 = Math_fround(f33 + Math_fround(f21 * f20));
 if (!(f21 != Math_fround(1.0))) return i29 | 0;
 f38 = Math_fround(Math_fround(1.0) / f21);
 HEAPF32[i29 >> 2] = Math_fround(f17 * f38);
 HEAPF32[i25 >> 2] = Math_fround(f38 * Math_fround(HEAPF32[i25 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f38 * f2);
 HEAPF32[i10 >> 2] = Math_fround(f38 * f9);
 HEAPF32[i22 >> 2] = Math_fround(f38 * f18);
 HEAPF32[i26 >> 2] = Math_fround(f38 * Math_fround(HEAPF32[i26 >> 2]));
 HEAPF32[i4 >> 2] = Math_fround(f38 * f3);
 HEAPF32[i12 >> 2] = Math_fround(f38 * f11);
 HEAPF32[i23 >> 2] = Math_fround(f38 * f19);
 HEAPF32[i27 >> 2] = Math_fround(f38 * Math_fround(HEAPF32[i27 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(f38 * f5);
 HEAPF32[i14 >> 2] = Math_fround(f38 * f13);
 HEAPF32[i24 >> 2] = Math_fround(f38 * f20);
 HEAPF32[i28 >> 2] = Math_fround(f38 * Math_fround(HEAPF32[i28 >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f38 * f7);
 HEAPF32[i16 >> 2] = Math_fround(f38 * f15);
 return i29 | 0;
}

function __ZN5physxL23PxcSweepConvexTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf(i8, i4, i10, i11, i5, i6, f7, i13, i14, i1, i2, i3, i12, f9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i4 + 224 | 0;
 i51 = i4 + 208 | 0;
 i52 = i4 + 128 | 0;
 i21 = i4 + 240 | 0;
 i19 = i4 + 96 | 0;
 i20 = i4 + 144 | 0;
 i17 = i4 + 80 | 0;
 i18 = i4 + 64 | 0;
 i15 = i4 + 48 | 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 16 | 0;
 i1 = i4;
 i50 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i46 = HEAP32[i50 + 44 >> 2] | 0;
 i48 = HEAP32[i50 + 48 >> 2] | 0;
 HEAP32[i51 >> 2] = HEAP32[i50 + 40 >> 2];
 HEAP32[i51 + 4 >> 2] = i46;
 HEAP32[i51 + 8 >> 2] = i48;
 HEAPF32[i51 + 12 >> 2] = Math_fround(0.0);
 i48 = HEAP32[i50 + 56 >> 2] | 0;
 i46 = HEAP32[i50 + 60 >> 2] | 0;
 i49 = HEAP32[i50 + 64 >> 2] | 0;
 HEAP32[i52 >> 2] = HEAP32[i50 + 52 >> 2];
 HEAP32[i52 + 4 >> 2] = i48;
 HEAP32[i52 + 8 >> 2] = i46;
 HEAP32[i52 + 12 >> 2] = i49;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i21, HEAP32[i50 + 72 >> 2] | 0, i16, i51, i52);
 i52 = HEAP32[i10 >> 2] | 0;
 i51 = HEAP32[i10 + 4 >> 2] | 0;
 i50 = HEAP32[i10 + 8 >> 2] | 0;
 i49 = HEAP32[i10 + 12 >> 2] | 0;
 i46 = i5 + 16 | 0;
 i48 = HEAP32[i46 >> 2] | 0;
 i47 = HEAP32[i46 + 4 >> 2] | 0;
 i46 = HEAP32[i46 + 8 >> 2] | 0;
 f44 = Math_fround(HEAPF32[i11 >> 2]);
 f45 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f43 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i5 = i6 + 16 | 0;
 f29 = Math_fround(HEAPF32[i5 >> 2]);
 f24 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 HEAP32[i19 >> 2] = i52;
 i5 = i19 + 4 | 0;
 HEAP32[i5 >> 2] = i51;
 i6 = i19 + 8 | 0;
 HEAP32[i6 >> 2] = i50;
 i8 = i19 + 12 | 0;
 HEAP32[i8 >> 2] = i49;
 HEAP32[i19 + 16 >> 2] = i48;
 HEAP32[i19 + 20 >> 2] = i47;
 HEAP32[i19 + 24 >> 2] = i46;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f41 = (HEAP32[tempDoublePtr >> 2] = i52, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = (HEAP32[tempDoublePtr >> 2] = i51, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = (HEAP32[tempDoublePtr >> 2] = i50, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i49, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = Math_fround(-f41);
 f36 = Math_fround(-f36);
 f33 = Math_fround(-f33);
 f23 = (HEAP32[tempDoublePtr >> 2] = i48, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i47, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i46, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(f29 - f23);
 f37 = Math_fround(f24 - f25);
 f39 = Math_fround(f26 - f31);
 f40 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f42 = Math_fround(Math_fround(Math_fround(f27 * f41) + Math_fround(f37 * f36)) + Math_fround(f39 * f33));
 f28 = Math_fround(Math_fround(Math_fround(f42 * f36) + Math_fround(Math_fround(f40 * f37) + Math_fround(f30 * Math_fround(Math_fround(f27 * f33) - Math_fround(f39 * f41))))) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) + Math_fround(f30 * Math_fround(Math_fround(f37 * f41) - Math_fround(f27 * f36)))) + Math_fround(f42 * f33)) * Math_fround(2.0));
 f34 = Math_fround(Math_fround(f43 * f30) - Math_fround(Math_fround(Math_fround(f44 * f41) + Math_fround(f45 * f36)) + Math_fround(f38 * f33)));
 f35 = Math_fround(Math_fround(Math_fround(f38 * f36) - Math_fround(f45 * f33)) + Math_fround(Math_fround(f43 * f41) + Math_fround(f44 * f30)));
 f32 = Math_fround(Math_fround(Math_fround(f44 * f33) - Math_fround(f38 * f41)) + Math_fround(Math_fround(f43 * f36) + Math_fround(f45 * f30)));
 f38 = Math_fround(Math_fround(Math_fround(f45 * f41) - Math_fround(f44 * f36)) + Math_fround(Math_fround(f43 * f33) + Math_fround(f38 * f30)));
 HEAPF32[i20 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(Math_fround(f40 * f27) + Math_fround(f30 * Math_fround(Math_fround(f39 * f36) - Math_fround(f37 * f33))))) * Math_fround(2.0));
 HEAPF32[i20 + 52 >> 2] = f28;
 HEAPF32[i20 + 56 >> 2] = f22;
 HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
 f22 = Math_fround(f35 + f35);
 f28 = Math_fround(f32 + f32);
 f33 = Math_fround(f38 + f38);
 f37 = Math_fround(f32 * f28);
 f36 = Math_fround(f38 * f33);
 f32 = Math_fround(f32 * f22);
 f39 = Math_fround(f38 * f22);
 f30 = Math_fround(f34 * f22);
 f38 = Math_fround(f38 * f28);
 f28 = Math_fround(f34 * f28);
 f33 = Math_fround(f34 * f33);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f35 * f22));
 f35 = Math_fround(f32 + f33);
 f34 = Math_fround(f39 - f28);
 f33 = Math_fround(f32 - f33);
 f32 = Math_fround(f22 - f36);
 f27 = Math_fround(f38 + f30);
 f28 = Math_fround(f39 + f28);
 f30 = Math_fround(f38 - f30);
 f22 = Math_fround(f22 - f37);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f37) - f36);
 HEAPF32[i20 + 4 >> 2] = f35;
 HEAPF32[i20 + 8 >> 2] = f34;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = f33;
 HEAPF32[i20 + 20 >> 2] = f32;
 HEAPF32[i20 + 24 >> 2] = f27;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = f28;
 HEAPF32[i20 + 36 >> 2] = f30;
 HEAPF32[i20 + 40 >> 2] = f22;
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f23 = Math_fround(f9 - f23);
 f25 = Math_fround(f22 - f25);
 f31 = Math_fround(f30 - f31);
 f29 = Math_fround(f28 - f29);
 f24 = Math_fround(f27 - f24);
 f26 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) - f26);
 HEAPF32[i18 >> 2] = f29;
 HEAPF32[i18 + 4 >> 2] = f24;
 HEAPF32[i18 + 8 >> 2] = f26;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f29 = Math_fround(f23 - f29);
 f24 = Math_fround(f25 - f24);
 f26 = Math_fround(f31 - f26);
 f31 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f27 = Math_fround(HEAPF32[i8 >> 2]);
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f30 = Math_fround(Math_fround(Math_fround(f29 * f31) + Math_fround(f24 * f25)) + Math_fround(f26 * f23));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f30) + Math_fround(Math_fround(f24 * f28) - Math_fround(f27 * Math_fround(Math_fround(f29 * f23) - Math_fround(f31 * f26))))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f23 * f30) + Math_fround(Math_fround(f26 * f28) - Math_fround(f27 * Math_fround(Math_fround(f24 * f31) - Math_fround(f29 * f25))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23))))) * Math_fround(2.0));
 HEAPF32[i15 + 4 >> 2] = f22;
 HEAPF32[i15 + 8 >> 2] = f9;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i12, i21, i20, i19, i18, i17, i16, i15, i2, i3, i1, f7) | 0)) {
  f45 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i4;
  return Math_fround(f45);
 }
 f45 = Math_fround(HEAPF32[i2 >> 2]);
 i52 = HEAP32[i3 + 4 >> 2] | 0;
 i51 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i52;
 HEAP32[i13 + 8 >> 2] = i51;
 i51 = HEAP32[i1 + 4 >> 2] | 0;
 i52 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = i51;
 HEAP32[i14 + 8 >> 2] = i52;
 STACKTOP = i4;
 return Math_fround(f45);
}

function __ZN5physx20AggregateOverlapTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 10304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 10289 | 0;
 i19 = i21 + 10288 | 0;
 i16 = i21 + 6176 | 0;
 i15 = i21 + 2064 | 0;
 i14 = i21;
 i20 = i1 + 40 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (HEAP32[i1 + 45696 >> 2] | 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i16 + 4096 >> 2] = i4;
  i12 = i16 + 4100 | 0;
  HEAP32[i12 >> 2] = 0;
  i8 = i16 + 4104 | 0;
  HEAP32[i8 >> 2] = 0;
  i6 = i15 + 4096 | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i9 = i15 + 4100 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i15 + 4104 | 0;
  HEAP32[i10 >> 2] = 0;
  i13 = i14 + 2048 | 0;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  i11 = i14 + 2052 | 0;
  HEAP32[i11 >> 2] = 0;
  i7 = i14 + 2056 | 0;
  HEAP32[i7 >> 2] = 0;
  i5 = HEAP32[i1 + 324 >> 2] | 0;
  i3 = i4;
  if (i5) {
   do if (i5 >>> 0 > 1024) {
    i1 = i5 << 2;
    i2 = i1 + 15 & -16;
    if (!i4) {
     i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, i2, gb + 717789 | 0, 1930) | 0;
     HEAP32[i12 >> 2] = i2;
     break;
    } else {
     i2 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i2, 1) | 0;
     HEAP32[i12 >> 2] = i2;
     break;
    }
   } else {
    HEAP32[i12 >> 2] = i16;
    i1 = i5 << 2;
    i2 = i16;
   } while (0);
   _memset(i2 | 0, 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = i5;
   i1 = HEAP32[i20 >> 2] | 0;
   i4 = HEAP32[i1 + 324 >> 2] | 0;
   if (i4) {
    do if (i4 >>> 0 > 1024) {
     i1 = i4 << 2;
     i3 = i1 + 15 & -16;
     i2 = HEAP32[i6 >> 2] | 0;
     if (!i2) {
      i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, i3, gb + 717789 | 0, 1930) | 0;
      HEAP32[i9 >> 2] = i2;
      break;
     } else {
      i2 = __ZN5physx19PxcScratchAllocator5allocEjb(i2, i3, 1) | 0;
      HEAP32[i9 >> 2] = i2;
      break;
     }
    } else {
     HEAP32[i9 >> 2] = i15;
     i1 = i4 << 2;
     i2 = i15;
    } while (0);
    _memset(i2 | 0, 0, i1 | 0) | 0;
    HEAP32[i10 >> 2] = i4;
    i1 = HEAP32[i20 >> 2] | 0;
   }
  }
  i4 = HEAP32[i1 + 196 >> 2] | 0;
  if (i4) {
   do if (i4 >>> 0 > 256) {
    i1 = i4 << 3;
    i2 = i1 + 15 & -16;
    i3 = HEAP32[i13 >> 2] | 0;
    if (!i3) {
     i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, i2, gb + 717789 | 0, 1930) | 0;
     HEAP32[i11 >> 2] = i2;
     break;
    } else {
     i2 = __ZN5physx19PxcScratchAllocator5allocEjb(i3, i2, 1) | 0;
     HEAP32[i11 >> 2] = i2;
     break;
    }
   } else {
    HEAP32[i11 >> 2] = i14;
    i1 = i4 << 3;
    i2 = i14;
   } while (0);
   _memset(i2 | 0, 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i4;
   i1 = HEAP32[i20 >> 2] | 0;
  }
  __ZN5physx14PxsAABBManager14sortAggregatesEPjjS1_jPNS_19AggregateSortedDataE(i1, HEAP32[i12 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0);
  __ZN5physx14PxsAABBManager21selfCollideAggregatesEPKNS_19AggregateSortedDataE(HEAP32[i20 >> 2] | 0, HEAP32[i11 >> 2] | 0);
  __ZN5physx14PxsAABBManager21processAggregatePairsEPKNS_19AggregateSortedDataE(HEAP32[i20 >> 2] | 0, HEAP32[i11 >> 2] | 0);
  i5 = HEAP32[i11 >> 2] | 0;
  do if (!((i5 | 0) == 0 | (i5 | 0) == (i14 | 0))) {
   i9 = HEAP32[i13 >> 2] | 0;
   if (!i9) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, i5);
    break;
   }
   i1 = HEAP32[i9 + 16 >> 2] | 0;
   if (i1 >>> 0 > i5 >>> 0) i17 = 27; else if ((i1 + (HEAP32[i9 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
    i6 = i9 + 8 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i9 + 4 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i1 = i7;
    while (1) {
     i3 = i1 + -1 | 0;
     i2 = i4 + (i3 << 2) | 0;
     if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
    }
    if (i1 >>> 0 < i7 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 < i7 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i7 | 0));
    }
    HEAP32[i6 >> 2] = i7 + -1;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
   } else i17 = 27;
   if ((i17 | 0) == 27) __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, i5);
  } while (0);
  __ZN5physx12InlineBufferIjLj1024EE4freeEv(i15);
  __ZN5physx12InlineBufferIjLj1024EE4freeEv(i16);
  i1 = HEAP32[i20 >> 2] | 0;
 }
 i3 = HEAP32[i1 + 49828 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0);
 i3 = HEAP32[i20 >> 2] | 0;
 i1 = i3 + 116 | 0;
 i2 = i3 + 120 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i17 = i3 + 108 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, HEAP32[i17 >> 2] | 0);
  HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, HEAP32[i2 >> 2] << 2, gb + 717789 | 0, 1328) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 HEAP32[i3 + 112 >> 2] = 0;
 i1 = HEAP32[i3 + 96 >> 2] | 0;
 if (i1 | 0) _memset(i1 | 0, 0, HEAP32[i3 + 100 >> 2] << 2 | 0) | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i1 = i3 + 88 | 0;
 i2 = i3 + 92 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i17 = i3 + 80 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, HEAP32[i17 >> 2] | 0);
  HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, HEAP32[i2 >> 2] << 2, gb + 717789 | 0, 1328) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 HEAP32[i3 + 84 >> 2] = 0;
 i1 = HEAP32[i3 + 68 >> 2] | 0;
 if (i1 | 0) _memset(i1 | 0, 0, HEAP32[i3 + 72 >> 2] << 2 | 0) | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i1 = i3 + 144 | 0;
 i2 = i3 + 148 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i17 = i3 + 136 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, HEAP32[i17 >> 2] | 0);
  HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, HEAP32[i2 >> 2] << 2, gb + 717789 | 0, 1328) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 HEAP32[i3 + 140 >> 2] = 0;
 i1 = HEAP32[i3 + 124 >> 2] | 0;
 if (i1 | 0) _memset(i1 | 0, 0, HEAP32[i3 + 128 >> 2] << 2 | 0) | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i1 = i3 + 376 | 0;
 i2 = i3 + 380 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i17 = i3 + 368 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, HEAP32[i17 >> 2] | 0);
  HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, HEAP32[i2 >> 2] << 2, gb + 717789 | 0, 1328) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 HEAP32[i3 + 372 >> 2] = 0;
 i1 = HEAP32[i3 + 356 >> 2] | 0;
 if (i1 | 0) _memset(i1 | 0, 0, HEAP32[i3 + 360 >> 2] << 2 | 0) | 0;
 __ZN5physx12InlineBufferIjLj4096EE4freeEv((HEAP32[i20 >> 2] | 0) + 512 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 16912 >> 2] = 0;
 __ZN5physx12InlineBufferIjLj4096EE4freeEv(i1 + 16928 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 33328 >> 2] = 0;
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i1 + 33344 | 0);
 __ZN5physx12InlineBufferIjLj1024EE4freeEv((HEAP32[i20 >> 2] | 0) + 37456 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 41568 >> 2] = 0;
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i1 + 41584 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 45696 >> 2] = 0;
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i1 + 45712 | 0);
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 49824 >> 2] = 0;
 _memset(HEAP32[i1 + 268 >> 2] | 0, 0, HEAP32[i1 + 272 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i3 = i1 + 196 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i20 = i1;
  __ZN5physx14PxsAABBManager31updateAggregateBPOverlapRecordsEv(i20);
  STACKTOP = i21;
  return;
 }
 i4 = i1 + 188 | 0;
 i1 = i1 + 184 | 0;
 i2 = 0;
 do {
  i18 = HEAP32[i4 >> 2] | 0;
  i19 = HEAP32[i1 >> 2] | 0;
  i17 = i18 + (i2 << 4) | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | HEAP32[i19 + (i2 << 4) >> 2];
  i17 = i18 + (i2 << 4) + 4 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | HEAP32[i19 + (i2 << 4) + 4 >> 2];
  i17 = i18 + (i2 << 4) + 8 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | HEAP32[i19 + (i2 << 4) + 8 >> 2];
  i18 = i18 + (i2 << 4) + 12 | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | HEAP32[i19 + (i2 << 4) + 12 >> 2];
  i19 = i19 + (i2 << 4) | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i20 = HEAP32[i20 >> 2] | 0;
 __ZN5physx14PxsAABBManager31updateAggregateBPOverlapRecordsEv(i20);
 STACKTOP = i21;
 return;
}

function __ZN4Mesh8TransferI17RemapPPtrTransferEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 24 | 0;
 i13 = i14;
 i11 = i14 + 288 | 0;
 i12 = i14 + 268 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i3, i4);
 i5 = i3 + 32 | 0;
 if ((HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i5 >> 2] | 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i5 >> 2] = i1;
 }
 i9 = i3 + 44 | 0;
 i1 = (HEAP8[i9 >> 0] & 16) == 0;
 __ZN4Mesh21UnswizzleVertexColorsEb(i3, 1);
 if (!(HEAP8[i3 + 40 >> 0] | 0)) i6 = 7; else if (!(HEAP32[i4 >> 2] & 16384)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  i8 = i13 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i2 = i10;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i8;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i3;
  __ZN14VertexDataInfoC2Ev(i10);
  __Z46get_current_allocation_root_reference_internalv() | 0;
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, 1);
  __ZN10VertexData8TransferI17RemapPPtrTransferEEvRT_(i10, i4);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
  __ZN10VertexDataD2Ev(i10);
  __Z19free_alloc_internalPvRK10MemLabelId(0, i8);
 } else i6 = 7;
 if ((i6 | 0) == 7) {
  i8 = (HEAP32[i5 >> 2] | 0) + 8 | 0;
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, 1);
  __ZN10VertexData8TransferI17RemapPPtrTransferEEvRT_(i8, i4);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
 }
 i19 = i10 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP8[i10 + 12 >> 0] = 0;
 i18 = i10 + 44 | 0;
 i17 = i10 + 72 | 0;
 i16 = i10 + 92 | 0;
 i15 = i10 + 120 | 0;
 i2 = i10 + 140 | 0;
 i3 = i10 + 168 | 0;
 i6 = i10 + 188 | 0;
 i7 = i10 + 208 | 0;
 i8 = i10 + 228 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP8[i19 + 24 >> 0] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP8[i18 + 24 >> 0] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP8[i17 + 16 >> 0] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP8[i16 + 24 >> 0] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP8[i15 + 16 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP8[i6 + 16 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
 __ZN14CompressedMeshD2Ev(i10);
 if (i1) {
  i15 = gb + 64016 | 0;
  i16 = i15;
  i16 = HEAP32[i16 >> 2] | 0;
  i15 = i15 + 4 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i19 = i13;
  i17 = i19;
  HEAP32[i17 >> 2] = i16;
  i19 = i19 + 4 | 0;
  HEAP32[i19 >> 2] = i15;
  HEAP32[i11 >> 2] = 0;
  i19 = i11 + 12 | 0;
  HEAP32[i19 >> 2] = 0;
  i19 = i11 + 16 | 0;
  HEAP32[i19 >> 2] = 0;
  i19 = i11 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i13);
  i15 = i10;
  i17 = i15;
  i17 = HEAP32[i17 >> 2] | 0;
  i15 = i15 + 4 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i16 = i19;
  i18 = i16;
  HEAP32[i18 >> 2] = i17;
  i16 = i16 + 4 | 0;
  HEAP32[i16 >> 2] = i15;
  i16 = gb + 64016 | 0;
  i15 = i16;
  i15 = HEAP32[i15 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i18 = i13;
  i17 = i18;
  HEAP32[i17 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i12 >> 2] = 0;
  i18 = i12 + 12 | 0;
  HEAP32[i18 >> 2] = 0;
  i18 = i12 + 16 | 0;
  HEAP32[i18 >> 2] = 0;
  i18 = i12 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i13);
  i16 = i10;
  i13 = i16;
  i13 = HEAP32[i13 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i17 = i18;
  i15 = i17;
  HEAP32[i15 >> 2] = i13;
  i17 = i17 + 4 | 0;
  HEAP32[i17 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(0, i18);
  __Z19free_alloc_internalPvRK10MemLabelId(0, i19);
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = i4 + 8 | 0;
 i2 = HEAP16[i4 + 18 >> 1] | 0;
 if ((i2 & 65535) < 1024 | (i2 & 255) != 2) {
  i6 = 0;
  i8 = 0;
  i1 = i2;
 } else {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   i8 = 1;
   i1 = i2;
  } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
   i6 = 0;
   i8 = 1;
   i1 = i2;
  } else {
   i19 = HEAP32[i4 + 16 >> 2] | 0;
   i6 = i1 + ((i19 >>> 8 & 255) + (HEAP32[i5 + 32 + ((i19 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i8 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i1 = i19 >>> 16 & 65535;
  }
 }
 if ((i1 & 65535) < 1024 | (i1 & 255) != 2) i7 = 0; else {
  i2 = HEAP32[i4 + 100 >> 2] | 0;
  i3 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i3) i7 = 0; else if (!(HEAP8[i4 + 19 >> 0] | 0)) i7 = 0; else {
   i1 = HEAP32[i4 + 16 >> 2] | 0;
   i7 = i3 + ((Math_imul(HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i2) | 0) + (HEAP32[i5 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0) + (i1 >>> 8 & 255)) | 0;
   i1 = i1 >>> 16 & 65535;
  }
 }
 if ((i1 & 65535) < 1024 | (i1 & 255) != 2) {
  i1 = 0;
  i5 = 0;
 } else {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i4 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i19 = HEAP16[i4 + 16 >> 1] | 0;
   i1 = i1 + (((i19 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i19 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if ((i6 | 0) != (i7 | 0)) {
  i4 = i1;
  i3 = i6;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = i2 & -16777216 | HEAPU8[i3 + 2 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | i2 << 16 & 16711680;
   i1 = i3 + i8 | 0;
   i2 = i4 + i5 | 0;
   if ((i1 | 0) == (i7 | 0)) break; else {
    i4 = i2;
    i3 = i1;
    i1 = i2;
   }
  }
 }
 HEAP8[i9 >> 0] = HEAP8[i9 >> 0] | 16;
 i15 = gb + 64016 | 0;
 i16 = i15;
 i16 = HEAP32[i16 >> 2] | 0;
 i15 = i15 + 4 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i19 = i13;
 i17 = i19;
 HEAP32[i17 >> 2] = i16;
 i19 = i19 + 4 | 0;
 HEAP32[i19 >> 2] = i15;
 HEAP32[i11 >> 2] = 0;
 i19 = i11 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i19 = i11 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i19 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i13);
 i15 = i10;
 i17 = i15;
 i17 = HEAP32[i17 >> 2] | 0;
 i15 = i15 + 4 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = i19;
 i18 = i16;
 HEAP32[i18 >> 2] = i17;
 i16 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i15;
 i16 = gb + 64016 | 0;
 i15 = i16;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = i16 + 4 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i18 = i13;
 i17 = i18;
 HEAP32[i17 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 HEAP32[i12 >> 2] = 0;
 i18 = i12 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i18 = i12 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i18 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i13);
 i16 = i10;
 i13 = i16;
 i13 = HEAP32[i13 >> 2] | 0;
 i16 = i16 + 4 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = i18;
 i15 = i17;
 HEAP32[i15 >> 2] = i13;
 i17 = i17 + 4 | 0;
 HEAP32[i17 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i18);
 __Z19free_alloc_internalPvRK10MemLabelId(0, i19);
 STACKTOP = i14;
 return;
}

function __ZN9ShaderLab11ShaderState25FromSerializedShaderStateERKNS_21SerializedShaderStateEP16PropertyNamesSet(i16, i17, i12) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 8 | 0;
 i13 = i18 + 4 | 0;
 i14 = i18;
 i1 = HEAP32[i17 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 32 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 556 >> 2] = i2;
 HEAP32[i16 + 560 >> 2] = i1;
 i1 = HEAP32[i17 + 52 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 48 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 564 >> 2] = i2;
 HEAP32[i16 + 568 >> 2] = i1;
 i3 = HEAP32[i17 + 44 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i3 | 0) == -1) {
  i2 = HEAP32[i17 + 40 >> 2] | 0;
  i3 = -1;
 } else i2 = 0;
 HEAP32[i16 + 572 >> 2] = i2;
 HEAP32[i16 + 576 >> 2] = i3;
 f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 | 0) == -1) {
  i10 = i16 + 564 | 0;
  if (f5 == Math_fround(1.0) & (i3 | 0) == -1) {
   i9 = i16 + 572 | 0;
   if (f4 == Math_fround(1.0)) if (HEAP32[i17 + 708 >> 2] | 0) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 480075 | 0, 9);
    i6 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 479733 | 0, 12);
    i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    i8 = i17 + 704 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if (i2 | 0) {
     i1 = i8;
     L15 : while (1) {
      i3 = i2;
      while (1) {
       if ((HEAP32[i3 + 16 >> 2] | 0) >= (i6 | 0)) break;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i2) break L15; else i3 = i2;
      }
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i1 = i3;
       break;
      } else i1 = i3;
     }
     if ((i1 | 0) != (i8 | 0)) if ((i6 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) if ((HEAP32[i1 + 20 >> 2] | 0) == (i7 | 0)) {
      HEAPF32[i10 >> 2] = Math_fround(0.0);
      HEAPF32[i9 >> 2] = Math_fround(0.0);
     }
    }
   }
  }
 }
 i6 = HEAP8[i17 + 717 >> 0] | 0;
 HEAP8[i16 + 536 >> 0] = i6;
 i6 = i6 << 24 >> 24 ? 8 : 1;
 i3 = 0;
 do {
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 4 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 12 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 8 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 8 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 12 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 20 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 16 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 16 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 20 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 28 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 24 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 24 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 28 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 52 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 48 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 48 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 52 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 36 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 32 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 32 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 36 >> 2] = i1;
  i1 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 44 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i17 + 64 + (i3 * 56 | 0) + 40 >> 2] | 0;
   i1 = -1;
  } else i2 = 0;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 40 >> 2] = i2;
  HEAP32[i16 + 80 + (i3 * 56 | 0) + 44 >> 2] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i1 = HEAP32[i17 + 60 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 56 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 528 >> 2] = i2;
 HEAP32[i16 + 532 >> 2] = i1;
 i1 = HEAP32[i17 + 20 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 16 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 548 >> 2] = i2;
 HEAP32[i16 + 552 >> 2] = i1;
 i1 = HEAP32[i17 + 28 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 24 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 540 >> 2] = i2;
 HEAP32[i16 + 544 >> 2] = i1;
 i3 = i17 + 628 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 624 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 20 >> 2] = i2;
 HEAP32[i16 + 24 >> 2] = i1;
 i8 = HEAP32[i3 >> 2] | 0;
 if (i8 >>> 0 <= 1073741823) {
  HEAP32[i14 >> 2] = i8;
  i2 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i9 - i2 >> 2;
  if (!i1) i1 = i2; else {
   i7 = i1;
   i1 = i2;
   while (1) {
    i10 = (i7 | 0) / 2 | 0;
    i6 = i2 + (i10 << 2) | 0;
    i3 = (HEAP32[i6 >> 2] | 0) < (i8 | 0);
    i6 = i6 + 4 | 0;
    i1 = i3 ? i6 : i1;
    i7 = i3 ? i7 + -1 - i10 | 0 : i10;
    if (!i7) break; else i2 = i3 ? i6 : i2;
   }
  }
  i2 = i1;
  if ((i1 | 0) == (i9 | 0)) i15 = 34; else if ((HEAP32[i1 >> 2] | 0) > (i8 | 0)) i15 = 34;
  if ((i15 | 0) == 34) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i12, i11, i14) | 0;
  }
 }
 i1 = HEAP32[i17 + 612 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 608 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 580 >> 2] = i2;
 HEAP32[i16 + 584 >> 2] = i1;
 i1 = HEAP32[i17 + 620 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = HEAP32[i17 + 616 >> 2] | 0;
  i1 = -1;
 } else i2 = 0;
 HEAP32[i16 + 588 >> 2] = i2;
 HEAP32[i16 + 592 >> 2] = i1;
 i15 = HEAP32[i17 + 540 >> 2] | 0;
 HEAP32[i16 + 596 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 536 >> 2] | 0 : 0;
 HEAP32[i16 + 600 >> 2] = i15;
 i15 = HEAP32[i17 + 516 >> 2] | 0;
 HEAP32[i16 + 604 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 512 >> 2] | 0 : 0;
 HEAP32[i16 + 608 >> 2] = i15;
 i15 = HEAP32[i17 + 524 >> 2] | 0;
 HEAP32[i16 + 612 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 520 >> 2] | 0 : 0;
 HEAP32[i16 + 616 >> 2] = i15;
 i15 = HEAP32[i17 + 532 >> 2] | 0;
 HEAP32[i16 + 620 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 528 >> 2] | 0 : 0;
 HEAP32[i16 + 624 >> 2] = i15;
 i15 = HEAP32[i17 + 572 >> 2] | 0;
 HEAP32[i16 + 628 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 568 >> 2] | 0 : 0;
 HEAP32[i16 + 632 >> 2] = i15;
 i15 = HEAP32[i17 + 548 >> 2] | 0;
 HEAP32[i16 + 636 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 544 >> 2] | 0 : 0;
 HEAP32[i16 + 640 >> 2] = i15;
 i15 = HEAP32[i17 + 556 >> 2] | 0;
 HEAP32[i16 + 644 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 552 >> 2] | 0 : 0;
 HEAP32[i16 + 648 >> 2] = i15;
 i15 = HEAP32[i17 + 564 >> 2] | 0;
 HEAP32[i16 + 652 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 560 >> 2] | 0 : 0;
 HEAP32[i16 + 656 >> 2] = i15;
 i15 = HEAP32[i17 + 604 >> 2] | 0;
 HEAP32[i16 + 660 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 600 >> 2] | 0 : 0;
 HEAP32[i16 + 664 >> 2] = i15;
 i15 = HEAP32[i17 + 580 >> 2] | 0;
 HEAP32[i16 + 668 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 576 >> 2] | 0 : 0;
 HEAP32[i16 + 672 >> 2] = i15;
 i15 = HEAP32[i17 + 588 >> 2] | 0;
 HEAP32[i16 + 676 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 584 >> 2] | 0 : 0;
 HEAP32[i16 + 680 >> 2] = i15;
 i15 = HEAP32[i17 + 596 >> 2] | 0;
 HEAP32[i16 + 684 >> 2] = (i15 | 0) == -1 ? HEAP32[i17 + 592 >> 2] | 0 : 0;
 HEAP32[i16 + 688 >> 2] = i15;
 HEAP32[i16 + 696 >> 2] = HEAP32[i17 + 696 >> 2];
 i17 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 __ZN9ShaderLab11ShaderState15AddDeviceStatesEjPK19ShaderPropertySheetS3_(i16, 0, i17, i17) | 0;
 STACKTOP = i18;
 return;
}

function __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i9, i11, i10, i12) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i7 = i11 + 8 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if ((i6 | 0) == (i1 | 0)) {
  f2 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f15 = Math_fround(f2 - f3);
  f15 = Math_fround(f15 * f15);
  if (f15 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   i4 = f2 > f3;
   break;
  } else {
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[HEAP32[i12 + 24 >> 2] >> 2] | 0;
   f18 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) + 8 >> 2]);
   i4 = HEAP32[i9 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i5 + (i4 * 24 | 0) + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   f18 = Math_fround(f18 - f2);
   f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f17 = Math_fround(f17 - f3);
   f15 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f16 = Math_fround(f16 - f15);
   f2 = Math_fround(f21 - f2);
   f3 = Math_fround(f20 - f3);
   f15 = Math_fround(f19 - f15);
   i4 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f16 * f16)) < Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f15 * f15));
   break;
  }
 } else i4 = (i6 | 0) > (i1 | 0); while (0);
 i5 = i10 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if ((i1 | 0) == (i6 | 0)) {
  f2 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f21 = Math_fround(f2 - f3);
  f21 = Math_fround(f21 * f21);
  if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   i1 = f2 > f3;
   break;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   i6 = HEAP32[HEAP32[i12 + 24 >> 2] >> 2] | 0;
   f16 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) + 8 >> 2]);
   i1 = HEAP32[i11 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) >> 2]);
   f3 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i6 + (i1 * 24 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i12 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f17 = Math_fround(f17 - f20);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f18 = Math_fround(f18 - f21);
   f19 = Math_fround(f2 - f19);
   f20 = Math_fround(f3 - f20);
   f21 = Math_fround(f15 - f21);
   i1 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21));
   break;
  }
 } else i1 = (i1 | 0) > (i6 | 0); while (0);
 if (!i4) {
  if (!i1) {
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  };
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if ((i4 | 0) == (i1 | 0)) {
   f2 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   f21 = Math_fround(f2 - f3);
   f21 = Math_fround(f21 * f21);
   if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
    if (f2 > f3) break; else i1 = 1;
    STACKTOP = i14;
    return i1 | 0;
   } else {
    i10 = HEAP32[i11 >> 2] | 0;
    i8 = HEAP32[HEAP32[i12 + 24 >> 2] >> 2] | 0;
    f16 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) >> 2]);
    f17 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) + 4 >> 2]);
    f18 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) + 8 >> 2]);
    i10 = HEAP32[i9 >> 2] | 0;
    f2 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) >> 2]);
    f3 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i8 + (i10 * 24 | 0) + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i12 >> 2]);
    f16 = Math_fround(f16 - f19);
    f20 = Math_fround(HEAPF32[i12 + 4 >> 2]);
    f17 = Math_fround(f17 - f20);
    f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    f18 = Math_fround(f18 - f21);
    f19 = Math_fround(f2 - f19);
    f20 = Math_fround(f3 - f20);
    f21 = Math_fround(f15 - f21);
    if (Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))) break; else i1 = 1;
    STACKTOP = i14;
    return i1 | 0;
   }
  } else if ((i4 | 0) <= (i1 | 0)) {
   i13 = 1;
   STACKTOP = i14;
   return i13 | 0;
  } while (0);
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i13 = 2;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (i1) {
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 };
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if ((i4 | 0) == (i1 | 0)) {
  f2 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f21 = Math_fround(f2 - f3);
  f21 = Math_fround(f21 * f21);
  if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f2 > f3) break; else i1 = 1;
   STACKTOP = i14;
   return i1 | 0;
  } else {
   i9 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[HEAP32[i12 + 24 >> 2] >> 2] | 0;
   f16 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) + 8 >> 2]);
   i9 = HEAP32[i11 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) >> 2]);
   f3 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i8 + (i9 * 24 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i12 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f17 = Math_fround(f17 - f20);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f18 = Math_fround(f18 - f21);
   f19 = Math_fround(f2 - f19);
   f20 = Math_fround(f3 - f20);
   f21 = Math_fround(f15 - f21);
   if (Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))) break; else i1 = 1;
   STACKTOP = i14;
   return i1 | 0;
  }
 } else if ((i4 | 0) <= (i1 | 0)) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i13 = 2;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb(i25, i1, f3, i2, i5, i4, i27, i26) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i29 + 12 | 0;
 i24 = i29;
 i28 = i29 + 24 | 0;
 f37 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f34 = Math_fround(f37 + f11);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(f18 + f17);
 f38 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f34 = Math_fround(Math_fround(f34 * Math_fround(.5)) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f8 * Math_fround(.5)) * Math_fround(2.0));
 f39 = Math_fround(Math_fround(Math_fround(f38 + f36) * Math_fround(.5)) * Math_fround(2.0));
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f40 = Math_fround(Math_fround(f7 * f7) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(f34 * f32);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f8 * f12));
 f35 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f39 * f35));
 f30 = Math_fround(Math_fround(f32 * f16) + Math_fround(Math_fround(f34 * f40) + Math_fround(f7 * Math_fround(Math_fround(f39 * f12) - Math_fround(f8 * f35)))));
 f9 = Math_fround(Math_fround(f12 * f16) + Math_fround(Math_fround(f8 * f40) + Math_fround(f7 * Math_fround(Math_fround(f34 * f35) - Math_fround(f32 * f39)))));
 f16 = Math_fround(Math_fround(Math_fround(f39 * f40) + Math_fround(f7 * Math_fround(Math_fround(f8 * f32) - Math_fround(f34 * f12)))) + Math_fround(f35 * f16));
 f30 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f30);
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f9);
 f16 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f16);
 i19 = i23 + 4 | 0;
 i20 = i23 + 8 | 0;
 f18 = Math_fround(Math_fround(f17 - f18) * Math_fround(.5));
 f38 = Math_fround(Math_fround(f36 - f38) * Math_fround(.5));
 i21 = i24 + 4 | 0;
 i22 = i24 + 8 | 0;
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(Math_fround(f11 - f37) * Math_fround(.5)) + f3);
 HEAPF32[i21 >> 2] = Math_fround(f18 + f3);
 HEAPF32[i22 >> 2] = Math_fround(f38 + f3);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i4 + 36 >> 2]));
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i4 + 40 >> 2]));
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i4 + 44 >> 2]));
 f38 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(f30 * f38);
 f37 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f9 * f37));
 f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f16 * f11));
 f36 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f17 = Math_fround(f30 * f36);
 f35 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f9 * f35));
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f16 * f12));
 f34 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f30 = Math_fround(f30 * f34);
 f32 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f9 = Math_fround(f30 + Math_fround(f9 * f32));
 f30 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f16 = Math_fround(f9 + Math_fround(f16 * f30));
 HEAPF32[i23 >> 2] = f18;
 HEAPF32[i19 >> 2] = f17;
 HEAPF32[i20 >> 2] = f16;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f40 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f39 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f33 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f38 * f9) + Math_fround(f37 * f8)) + Math_fround(f11 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f36 * f9) + Math_fround(f35 * f8)) + Math_fround(f12 * f7));
 f7 = Math_fround(Math_fround(Math_fround(f34 * f9) + Math_fround(f32 * f8)) + Math_fround(f30 * f7));
 f8 = Math_fround(Math_fround(Math_fround(f38 * f40) + Math_fround(f37 * f39)) + Math_fround(f11 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f36 * f40) + Math_fround(f35 * f39)) + Math_fround(f12 * f10));
 f10 = Math_fround(Math_fround(Math_fround(f34 * f40) + Math_fround(f32 * f39)) + Math_fround(f30 * f10));
 f11 = Math_fround(Math_fround(Math_fround(f38 * f33) + Math_fround(f37 * f31)) + Math_fround(f11 * f13));
 f12 = Math_fround(Math_fround(Math_fround(f36 * f33) + Math_fround(f35 * f31)) + Math_fround(f12 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f32 * f31)) + Math_fround(f30 * f13));
 HEAPF32[i28 >> 2] = f3;
 i1 = i28 + 4 | 0;
 HEAPF32[i1 >> 2] = f6;
 i2 = i28 + 8 | 0;
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i28 + 12 >> 2] = f8;
 i4 = i28 + 16 | 0;
 HEAPF32[i4 >> 2] = f9;
 i5 = i28 + 20 | 0;
 HEAPF32[i5 >> 2] = f10;
 HEAPF32[i28 + 24 >> 2] = f11;
 i14 = i28 + 28 | 0;
 HEAPF32[i14 >> 2] = f12;
 i15 = i28 + 32 | 0;
 HEAPF32[i15 >> 2] = f13;
 if (i26) {
  i27 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i41 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = i25 + 36 | 0;
  HEAP32[i4 >> 2] = i41;
  i4 = i25 + 40 | 0;
  HEAP32[i4 >> 2] = i1;
  i4 = i25 + 44 | 0;
  HEAP32[i4 >> 2] = i2;
  i4 = i25 + 48 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  HEAP32[i4 >> 2] = i24;
  i21 = HEAP32[i21 >> 2] | 0;
  i24 = i25 + 52 | 0;
  HEAP32[i24 >> 2] = i21;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i25 + 56 | 0;
  HEAP32[i24 >> 2] = i22;
  HEAP32[i25 >> 2] = i28;
  i28 = i25 + 4 | 0;
  HEAP32[i28 >> 2] = i5;
  i28 = i25 + 8 | 0;
  HEAP32[i28 >> 2] = i14;
  i28 = i25 + 12 | 0;
  HEAP32[i28 >> 2] = i15;
  i28 = i25 + 16 | 0;
  HEAP32[i28 >> 2] = i19;
  i28 = i25 + 20 | 0;
  HEAP32[i28 >> 2] = i20;
  i28 = i25 + 24 | 0;
  HEAP32[i28 >> 2] = i23;
  i28 = i25 + 28 | 0;
  HEAP32[i28 >> 2] = i26;
  i28 = i25 + 32 | 0;
  HEAP32[i28 >> 2] = i27;
  STACKTOP = i29;
  return;
 } else {
  __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i27, i23, i24, i28);
  i44 = HEAP32[i23 >> 2] | 0;
  i43 = HEAP32[i19 >> 2] | 0;
  i42 = HEAP32[i20 >> 2] | 0;
  i41 = HEAP32[i28 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i19 = HEAP32[i28 + 12 >> 2] | 0;
  i20 = HEAP32[i4 >> 2] | 0;
  i23 = HEAP32[i5 >> 2] | 0;
  i26 = HEAP32[i28 + 24 >> 2] | 0;
  i27 = HEAP32[i14 >> 2] | 0;
  i28 = HEAP32[i15 >> 2] | 0;
  i15 = i25 + 36 | 0;
  HEAP32[i15 >> 2] = i44;
  i15 = i25 + 40 | 0;
  HEAP32[i15 >> 2] = i43;
  i15 = i25 + 44 | 0;
  HEAP32[i15 >> 2] = i42;
  i15 = i25 + 48 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  HEAP32[i15 >> 2] = i24;
  i21 = HEAP32[i21 >> 2] | 0;
  i24 = i25 + 52 | 0;
  HEAP32[i24 >> 2] = i21;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i25 + 56 | 0;
  HEAP32[i24 >> 2] = i22;
  HEAP32[i25 >> 2] = i41;
  i41 = i25 + 4 | 0;
  HEAP32[i41 >> 2] = i1;
  i41 = i25 + 8 | 0;
  HEAP32[i41 >> 2] = i2;
  i41 = i25 + 12 | 0;
  HEAP32[i41 >> 2] = i19;
  i41 = i25 + 16 | 0;
  HEAP32[i41 >> 2] = i20;
  i41 = i25 + 20 | 0;
  HEAP32[i41 >> 2] = i23;
  i41 = i25 + 24 | 0;
  HEAP32[i41 >> 2] = i26;
  i41 = i25 + 28 | 0;
  HEAP32[i41 >> 2] = i27;
  i41 = i25 + 32 | 0;
  HEAP32[i41 >> 2] = i28;
  STACKTOP = i29;
  return;
 }
}

function __Z14DecompressBC6HiiiPKjPj13TextureFormat(i10, i11, i22, i32, i35, i36) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i22 = i22 | 0;
 i32 = i32 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i40;
 if ((i11 | 0) <= 0) {
  STACKTOP = i40;
  return;
 }
 i38 = i10 << 2;
 i39 = (i10 | 0) > 0;
 i12 = i22 << 2;
 i13 = i22 << 3;
 i14 = i37 + 16 | 0;
 i15 = i37 + 32 | 0;
 i16 = i37 + 48 | 0;
 i17 = i37 + 64 | 0;
 i18 = i37 + 80 | 0;
 i19 = i37 + 96 | 0;
 i20 = i37 + 112 | 0;
 i21 = i22 << 1;
 i23 = i37 + 128 | 0;
 i24 = i37 + 144 | 0;
 i25 = i37 + 160 | 0;
 i26 = i37 + 176 | 0;
 i27 = i22 * 3 | 0;
 i28 = i37 + 192 | 0;
 i29 = i37 + 208 | 0;
 i30 = i37 + 224 | 0;
 i31 = i37 + 240 | 0;
 i8 = 0;
 do {
  L6 : do if (i39) {
   i33 = Math_imul(i12, i8) | 0;
   i34 = Math_imul(i13, i8) | 0;
   i7 = 0;
   i9 = i32 + ((Math_imul(i38, i8) | 0) << 2) | 0;
   while (1) {
    i5 = i35 + (i7 << 2 << 2) + (i33 << 2) | 0;
    i6 = i35 + (i7 << 3 << 2) + (i34 << 2) | 0;
    __Z15DecodeBC6HBlockP9HDRColorAPKh(i37, i9);
    switch (i36 | 0) {
    case 17:
     {
      i1 = 0;
      do {
       i3 = i1 << 2;
       i4 = Math_imul(i1, i22) | 0;
       i2 = 0;
       do {
        i5 = i2 + i3 | 0;
        i45 = HEAP32[i37 + (i5 << 4) >> 2] | 0;
        i44 = i45 >>> 23 & 255;
        i41 = HEAP32[i37 + (i5 << 4) + 4 >> 2] | 0;
        i43 = i41 >>> 23 & 255;
        i43 = (HEAPU16[gb + 1477124 + (i43 << 1) >> 1] | 0 | i41 >>> 16 & 32768 | (i41 & 8388607) >>> (HEAPU8[gb + 1546331 + i43 >> 0] | 0)) & 65535;
        i41 = HEAP32[i37 + (i5 << 4) + 8 >> 2] | 0;
        i42 = i41 >>> 23 & 255;
        i42 = (HEAPU16[gb + 1477124 + (i42 << 1) >> 1] | 0 | i41 >>> 16 & 32768 | (i41 & 8388607) >>> (HEAPU8[gb + 1546331 + i42 >> 0] | 0)) & 65535;
        i5 = HEAP32[i37 + (i5 << 4) + 12 >> 2] | 0;
        i41 = i5 >>> 23 & 255;
        i41 = (HEAPU16[gb + 1477124 + (i41 << 1) >> 1] | 0 | i5 >>> 16 & 32768 | (i5 & 8388607) >>> (HEAPU8[gb + 1546331 + i41 >> 0] | 0)) & 65535;
        i5 = i6 + (i2 << 3) + (i4 << 3) | 0;
        HEAP16[i5 >> 1] = HEAPU16[gb + 1477124 + (i44 << 1) >> 1] | 0 | i45 >>> 16 & 32768 | (i45 & 8388607) >>> (HEAPU8[gb + 1546331 + i44 >> 0] | 0);
        HEAP16[i5 + 2 >> 1] = i43;
        HEAP16[i5 + 4 >> 1] = i42;
        HEAP16[i5 + 6 >> 1] = i41;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 4);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 4);
      break;
     }
    case 20:
     {
      HEAP32[i6 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
      HEAP32[i6 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
      i43 = i6 + 16 | 0;
      HEAP32[i43 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i43 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i43 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i43 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i44 = i6 + 32 | 0;
      HEAP32[i44 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i44 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i44 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i44 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i45 = i6 + 48 | 0;
      HEAP32[i45 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      i42 = i6 + (i22 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
      i42 = i43 + (i22 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
      i42 = i44 + (i22 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
      i42 = i45 + (i22 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
      i42 = i6 + (i21 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
      i42 = i43 + (i21 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i24 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
      i42 = i44 + (i21 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
      i42 = i45 + (i21 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
      i42 = i6 + (i27 << 4) | 0;
      HEAP32[i42 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i42 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
      HEAP32[i42 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
      HEAP32[i42 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
      i43 = i43 + (i27 << 4) | 0;
      HEAP32[i43 >> 2] = HEAP32[i29 >> 2];
      HEAP32[i43 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
      HEAP32[i43 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
      HEAP32[i43 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
      i44 = i44 + (i27 << 4) | 0;
      HEAP32[i44 >> 2] = HEAP32[i30 >> 2];
      HEAP32[i44 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
      HEAP32[i44 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
      HEAP32[i44 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
      i45 = i45 + (i27 << 4) | 0;
      HEAP32[i45 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i45 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
      HEAP32[i45 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
      HEAP32[i45 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
      break;
     }
    default:
     {
      i2 = 0;
      do {
       i3 = i2 << 2;
       i4 = Math_imul(i2, i22) | 0;
       i1 = 0;
       do {
        i44 = i1 + i3 | 0;
        f48 = Math_fround(HEAPF32[i37 + (i44 << 4) >> 2]);
        f49 = Math_fround(HEAPF32[i37 + (i44 << 4) + 4 >> 2]);
        f47 = Math_fround(HEAPF32[i37 + (i44 << 4) + 8 >> 2]);
        f46 = Math_fround(HEAPF32[i37 + (i44 << 4) + 12 >> 2]);
        i44 = f48 > Math_fround(0.0);
        f48 = i44 ? f48 : Math_fround(0.0);
        i44 = f48 < Math_fround(1.0);
        f48 = i44 ? f48 : Math_fround(1.0);
        i44 = f49 > Math_fround(0.0);
        f49 = i44 ? f49 : Math_fround(0.0);
        i44 = f49 < Math_fround(1.0);
        f49 = i44 ? f49 : Math_fround(1.0);
        i44 = f47 > Math_fround(0.0);
        f47 = i44 ? f47 : Math_fround(0.0);
        i44 = f47 < Math_fround(1.0);
        f47 = i44 ? f47 : Math_fround(1.0);
        i44 = f46 > Math_fround(0.0);
        f46 = i44 ? f46 : Math_fround(0.0);
        i44 = f46 < Math_fround(1.0);
        i45 = i5 + (i1 << 2) + (i4 << 2) | 0;
        i44 = (~~Math_fround(Math_fround(f49 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 8 | ~~Math_fround(Math_fround(f48 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255 | (~~Math_fround(Math_fround(f47 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 16 | (~~Math_fround(Math_fround((i44 ? f46 : Math_fround(1.0)) * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 24;
        HEAP8[i45 >> 0] = i44;
        HEAP8[i45 + 1 >> 0] = i44 >> 8;
        HEAP8[i45 + 2 >> 0] = i44 >> 16;
        HEAP8[i45 + 3 >> 0] = i44 >> 24;
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != 4);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != 4);
     }
    }
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i10 | 0)) break L6; else i9 = i9 + 16 | 0;
   }
  } while (0);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i11 | 0));
 STACKTOP = i40;
 return;
}

function __ZN5physx15PxGeometryQuery13pointDistanceERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEPS1_(i22, i14, i12, i23) {
 i22 = i22 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i23 = i23 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 44 | 0;
 i16 = i24 + 40 | 0;
 i21 = i24 + 72 | 0;
 i20 = i24 + 28 | 0;
 i10 = i24 + 16 | 0;
 i9 = i24 + 4 | 0;
 i11 = i24;
 switch (HEAP32[i14 >> 2] | 0) {
 case 0:
  {
   f6 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i22 >> 2]);
   f7 = Math_fround(HEAPF32[i12 + 16 >> 2]);
   f8 = Math_fround(f8 - f7);
   f5 = Math_fround(HEAPF32[i22 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i12 + 20 >> 2]);
   f5 = Math_fround(f5 - f4);
   f2 = Math_fround(HEAPF32[i22 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   f2 = Math_fround(f2 - f1);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f5 * f5)) + Math_fround(f2 * f2))));
   if (f3 <= f6) {
    f19 = Math_fround(0.0);
    STACKTOP = i24;
    return Math_fround(f19);
   }
   if (i23 | 0) {
    f25 = Math_fround(Math_fround(1.0) / f3);
    f5 = Math_fround(f4 + Math_fround(f6 * Math_fround(f5 * f25)));
    f19 = Math_fround(f1 + Math_fround(f6 * Math_fround(f2 * f25)));
    HEAPF32[i23 >> 2] = Math_fround(f7 + Math_fround(f6 * Math_fround(f8 * f25)));
    HEAPF32[i23 + 4 >> 2] = f5;
    HEAPF32[i23 + 8 >> 2] = f19;
   }
   f25 = Math_fround(f3 - f6);
   f25 = Math_fround(f25 * f25);
   STACKTOP = i24;
   return Math_fround(f25);
  }
 case 2:
  {
   f3 = Math_fround(HEAPF32[i12 >> 2]);
   f6 = Math_fround(f3 * Math_fround(2.0));
   f25 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f8 = Math_fround(f25 * Math_fround(2.0));
   f25 = Math_fround(Math_fround(f3 * f6) + Math_fround(Math_fround(f25 * f8) + Math_fround(-1.0)));
   f3 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(f3 * f8);
   f19 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f1 = Math_fround(f1 + Math_fround(f6 * f19));
   f19 = Math_fround(Math_fround(f6 * f3) - Math_fround(f8 * f19));
   f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f25 = Math_fround(f8 * f25);
   f1 = Math_fround(f8 * f1);
   f19 = Math_fround(f8 * f19);
   f8 = Math_fround(HEAPF32[i12 + 16 >> 2]);
   f3 = Math_fround(f8 + f25);
   f6 = Math_fround(HEAPF32[i12 + 20 >> 2]);
   f4 = Math_fround(f6 + f1);
   f7 = Math_fround(HEAPF32[i12 + 24 >> 2]);
   f5 = Math_fround(f19 + f7);
   HEAPF32[i15 >> 2] = f3;
   i9 = i15 + 4 | 0;
   HEAPF32[i9 >> 2] = f4;
   i10 = i15 + 8 | 0;
   HEAPF32[i10 >> 2] = f5;
   f1 = Math_fround(f6 - f1);
   f19 = Math_fround(f7 - f19);
   i11 = i15 + 12 | 0;
   HEAPF32[i11 >> 2] = Math_fround(f8 - f25);
   i12 = i15 + 16 | 0;
   HEAPF32[i12 >> 2] = f1;
   i13 = i15 + 20 | 0;
   HEAPF32[i13 >> 2] = f19;
   i21 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i15 + 24 >> 2] = i21;
   f19 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f1 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i15, i15 + 12 | 0, i22, i16));
   if (f1 <= Math_fround(f19 * f19)) {
    f25 = Math_fround(0.0);
    STACKTOP = i24;
    return Math_fround(f25);
   }
   f8 = Math_fround(Math_sqrt(Math_fround(f1)));
   if (i23 | 0) {
    f4 = Math_fround(HEAPF32[i16 >> 2]);
    f5 = Math_fround(HEAPF32[i11 >> 2]);
    f2 = Math_fround(HEAPF32[i15 >> 2]);
    f5 = Math_fround(f5 - f2);
    f6 = Math_fround(HEAPF32[i12 >> 2]);
    f1 = Math_fround(HEAPF32[i9 >> 2]);
    f6 = Math_fround(f6 - f1);
    f3 = Math_fround(HEAPF32[i13 >> 2]);
    f7 = Math_fround(HEAPF32[i10 >> 2]);
    f5 = Math_fround(f2 + Math_fround(f4 * f5));
    f6 = Math_fround(f1 + Math_fround(f4 * f6));
    f7 = Math_fround(f7 + Math_fround(f4 * Math_fround(f3 - f7)));
    f3 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f5);
    f4 = Math_fround(Math_fround(HEAPF32[i22 + 4 >> 2]) - f6);
    f1 = Math_fround(Math_fround(HEAPF32[i22 + 8 >> 2]) - f7);
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f1 * f1))));
    if (f2 > Math_fround(0.0)) {
     f25 = Math_fround(Math_fround(1.0) / f2);
     f3 = Math_fround(f3 * f25);
     f2 = Math_fround(f4 * f25);
     f1 = Math_fround(f1 * f25);
    } else f2 = f4;
    f6 = Math_fround(f6 + Math_fround(f19 * f2));
    f25 = Math_fround(f7 + Math_fround(f19 * f1));
    HEAPF32[i23 >> 2] = Math_fround(f5 + Math_fround(f19 * f3));
    HEAPF32[i23 + 4 >> 2] = f6;
    HEAPF32[i23 + 8 >> 2] = f25;
   }
   f25 = Math_fround(f8 - f19);
   f25 = Math_fround(f25 * f25);
   STACKTOP = i24;
   return Math_fround(f25);
  }
 case 3:
  {
   i27 = i21 + 36 | 0;
   HEAP32[i27 >> 2] = HEAP32[i12 + 16 >> 2];
   i17 = i21 + 40 | 0;
   HEAP32[i17 >> 2] = HEAP32[i12 + 20 >> 2];
   i18 = i21 + 44 | 0;
   HEAP32[i18 >> 2] = HEAP32[i12 + 24 >> 2];
   i26 = i21 + 48 | 0;
   HEAP32[i26 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i21 + 52 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i21 + 56 >> 2] = HEAP32[i14 + 12 >> 2];
   f7 = Math_fround(HEAPF32[i12 >> 2]);
   f8 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f6 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f1 = Math_fround(f7 + f7);
   f19 = Math_fround(f8 + f8);
   f4 = Math_fround(f28 + f28);
   f2 = Math_fround(f8 * f19);
   f3 = Math_fround(f28 * f4);
   f8 = Math_fround(f1 * f8);
   f29 = Math_fround(f1 * f28);
   f25 = Math_fround(f1 * f6);
   f28 = Math_fround(f19 * f28);
   f19 = Math_fround(f19 * f6);
   f6 = Math_fround(f4 * f6);
   f4 = Math_fround(f8 + f6);
   f5 = Math_fround(f29 - f19);
   f6 = Math_fround(f8 - f6);
   f1 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f1));
   f7 = Math_fround(f1 - f3);
   f8 = Math_fround(f28 + f25);
   f19 = Math_fround(f29 + f19);
   f25 = Math_fround(f28 - f25);
   f1 = Math_fround(f1 - f2);
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f2) - f3);
   i9 = i21 + 4 | 0;
   HEAPF32[i9 >> 2] = f4;
   i10 = i21 + 8 | 0;
   HEAPF32[i10 >> 2] = f5;
   i11 = i21 + 12 | 0;
   HEAPF32[i11 >> 2] = f6;
   i12 = i21 + 16 | 0;
   HEAPF32[i12 >> 2] = f7;
   i13 = i21 + 20 | 0;
   HEAPF32[i13 >> 2] = f8;
   i14 = i21 + 24 | 0;
   HEAPF32[i14 >> 2] = f19;
   i15 = i21 + 28 | 0;
   HEAPF32[i15 >> 2] = f25;
   i16 = i21 + 32 | 0;
   HEAPF32[i16 >> 2] = f1;
   f1 = Math_fround(__ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i22, i27, i26, i21, i20));
   if ((i23 | 0) != 0 & f1 != Math_fround(0.0)) {
    f29 = Math_fround(HEAPF32[i20 >> 2]);
    f28 = Math_fround(f29 * Math_fround(HEAPF32[i21 >> 2]));
    f25 = Math_fround(f29 * Math_fround(HEAPF32[i9 >> 2]));
    f29 = Math_fround(f29 * Math_fround(HEAPF32[i10 >> 2]));
    f19 = Math_fround(HEAPF32[i20 + 4 >> 2]);
    f7 = Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2]));
    f8 = Math_fround(f19 * Math_fround(HEAPF32[i12 >> 2]));
    f7 = Math_fround(f28 + f7);
    f8 = Math_fround(f25 + f8);
    f19 = Math_fround(f29 + Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2])));
    f29 = Math_fround(HEAPF32[i20 + 8 >> 2]);
    f25 = Math_fround(f29 * Math_fround(HEAPF32[i14 >> 2]));
    f28 = Math_fround(f29 * Math_fround(HEAPF32[i15 >> 2]));
    f25 = Math_fround(f7 + f25);
    f28 = Math_fround(f8 + f28);
    f29 = Math_fround(f19 + Math_fround(f29 * Math_fround(HEAPF32[i16 >> 2])));
    f25 = Math_fround(f25 + Math_fround(HEAPF32[i21 + 36 >> 2]));
    f28 = Math_fround(f28 + Math_fround(HEAPF32[i17 >> 2]));
    f29 = Math_fround(f29 + Math_fround(HEAPF32[i18 >> 2]));
    HEAPF32[i23 >> 2] = f25;
    HEAPF32[i23 + 4 >> 2] = f28;
    HEAPF32[i23 + 8 >> 2] = f29;
   }
   f29 = f1;
   STACKTOP = i24;
   return Math_fround(f29);
  }
 case 4:
  {
   if ((i23 | 0) != 0 & ((__Z19pointConvexDistanceRN5physx6PxVec3ES1_RfRKS0_PKNS_2Gu10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformE(i10, i9, i11, i22, HEAP32[i14 + 32 >> 2] | 0, i14 + 4 | 0, i12) | 0) ^ 1)) {
    HEAP32[i23 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i23 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i23 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   }
   f29 = Math_fround(HEAPF32[i11 >> 2]);
   STACKTOP = i24;
   return Math_fround(f29);
  }
 default:
  {
   f29 = Math_fround(-1.0);
   STACKTOP = i24;
   return Math_fround(f29);
  }
 }
 return f0;
}

function __ZN13SpeedTreeWind16SBranchWindLevel8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 108 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 116 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 120 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 124 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 128 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN5Umbra18ImpOcclusionBuffer7combineERKS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, i34 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i22 + 80 | 0;
 i6 = i22 + 40 | 0;
 i7 = i22;
 i8 = HEAP32[i5 + 1376 >> 2] | 0;
 i9 = HEAP32[i5 + 1380 >> 2] | 0;
 i11 = HEAP32[i5 + 1384 >> 2] | 0;
 i10 = HEAP32[i5 + 1388 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i5 + 1416 >> 2]);
 i1 = i4 + 1416 | 0;
 if (f2 > Math_fround(HEAPF32[i1 >> 2])) HEAPF32[i1 >> 2] = f2;
 i18 = HEAP32[i4 + 1376 >> 2] | 0;
 i19 = HEAP32[i4 + 1380 >> 2] | 0;
 i20 = HEAP32[i4 + 1384 >> 2] | 0;
 i21 = HEAP32[i4 + 1388 >> 2] | 0;
 HEAP32[i3 >> 2] = (i18 | 0) <= (i8 | 0) ? i18 : i8;
 HEAP32[i3 + 4 >> 2] = (i19 | 0) <= (i9 | 0) ? i19 : i9;
 HEAP32[i3 + 8 >> 2] = (i20 | 0) >= (i11 | 0) ? i20 : i11;
 HEAP32[i3 + 12 >> 2] = (i21 | 0) >= (i10 | 0) ? i21 : i10;
 __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE(i4, i3);
 if (!(HEAP32[i4 + 1408 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 if (!(HEAP32[i5 + 1408 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
 i19 = i6 + 20 | 0;
 HEAP32[i19 >> 2] = 0;
 i21 = i6 + 24 | 0;
 HEAP32[i21 >> 2] = -1;
 i17 = i6 + 32 | 0;
 HEAP32[i17 >> 2] = 0;
 i20 = i6 + 36 | 0;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i7 + 8 >> 2] = Math_fround(1.0);
 i15 = i7 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 i18 = i7 + 24 | 0;
 HEAP32[i18 >> 2] = -1;
 i14 = i7 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i7 + 36 | 0;
 HEAP32[i16 >> 2] = -1;
 HEAP32[i7 + 16 >> 2] = 0;
 i4 = i4 + 1424 | 0;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP8[i6 + 12 >> 0] = 0;
 i6 = i5 + 1424 | 0;
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP8[i7 + 12 >> 0] = 0;
 i8 = i8 >> 2;
 i3 = i9 >> 2;
 i1 = i3 << 10;
 i4 = i4 + i1 | 0;
 i3 = (i10 >>> 2) - i3 << 10;
 i12 = i4 + i3 | 0;
 i13 = i8 << 6;
 i10 = (((i11 >> 2) - i8 | 0) / 2 | 0) + -1 | 0;
 i1 = i6 + i1 | 0;
 i11 = i1 + i3 | 0;
 i3 = (i10 | 0) == 0;
 L10 : do if (!(i4 >>> 0 >= i12 >>> 0 & i3)) {
  i9 = i1 + i13 | 0;
  i7 = i4 + i13 | 0;
  i8 = i10;
  i5 = i10;
  i6 = i4;
  i4 = i3;
  while (1) {
   i3 = i6;
   while (1) {
    i6 = i7;
    i33 = i9;
    f2 = Math_fround(HEAPF32[i6 >> 2]);
    f23 = Math_fround(HEAPF32[i33 >> 2]);
    i24 = i6 + 4 | 0;
    f25 = Math_fround(HEAPF32[i24 >> 2]);
    f26 = Math_fround(HEAPF32[i33 + 4 >> 2]);
    i27 = i6 + 8 | 0;
    f28 = Math_fround(HEAPF32[i27 >> 2]);
    f29 = Math_fround(HEAPF32[i33 + 8 >> 2]);
    i30 = i6 + 12 | 0;
    f31 = Math_fround(HEAPF32[i30 >> 2]);
    f32 = Math_fround(HEAPF32[i33 + 12 >> 2]);
    HEAPF32[i6 >> 2] = f2 >= f23 ? f2 : f23;
    HEAPF32[i24 >> 2] = f25 >= f26 ? f25 : f26;
    HEAPF32[i27 >> 2] = f28 >= f29 ? f28 : f29;
    HEAPF32[i30 >> 2] = f31 >= f32 ? f31 : f32;
    i30 = i6 + 16 | 0;
    f32 = Math_fround(HEAPF32[i30 >> 2]);
    f31 = Math_fround(HEAPF32[i33 + 16 >> 2]);
    i27 = i6 + 20 | 0;
    f29 = Math_fround(HEAPF32[i27 >> 2]);
    f28 = Math_fround(HEAPF32[i33 + 20 >> 2]);
    i24 = i6 + 24 | 0;
    f26 = Math_fround(HEAPF32[i24 >> 2]);
    f25 = Math_fround(HEAPF32[i33 + 24 >> 2]);
    i34 = i6 + 28 | 0;
    f23 = Math_fround(HEAPF32[i34 >> 2]);
    f2 = Math_fround(HEAPF32[i33 + 28 >> 2]);
    HEAPF32[i30 >> 2] = f32 >= f31 ? f32 : f31;
    HEAPF32[i27 >> 2] = f29 >= f28 ? f29 : f28;
    HEAPF32[i24 >> 2] = f26 >= f25 ? f26 : f25;
    HEAPF32[i34 >> 2] = f23 >= f2 ? f23 : f2;
    i34 = i6 + 32 | 0;
    f2 = Math_fround(HEAPF32[i34 >> 2]);
    f23 = Math_fround(HEAPF32[i33 + 32 >> 2]);
    i24 = i6 + 36 | 0;
    f25 = Math_fround(HEAPF32[i24 >> 2]);
    f26 = Math_fround(HEAPF32[i33 + 36 >> 2]);
    i27 = i6 + 40 | 0;
    f28 = Math_fround(HEAPF32[i27 >> 2]);
    f29 = Math_fround(HEAPF32[i33 + 40 >> 2]);
    i30 = i6 + 44 | 0;
    f31 = Math_fround(HEAPF32[i30 >> 2]);
    f32 = Math_fround(HEAPF32[i33 + 44 >> 2]);
    HEAPF32[i34 >> 2] = f2 >= f23 ? f2 : f23;
    HEAPF32[i24 >> 2] = f25 >= f26 ? f25 : f26;
    HEAPF32[i27 >> 2] = f28 >= f29 ? f28 : f29;
    HEAPF32[i30 >> 2] = f31 >= f32 ? f31 : f32;
    i30 = i6 + 48 | 0;
    f32 = Math_fround(HEAPF32[i30 >> 2]);
    f31 = Math_fround(HEAPF32[i33 + 48 >> 2]);
    i27 = i6 + 52 | 0;
    f29 = Math_fround(HEAPF32[i27 >> 2]);
    f28 = Math_fround(HEAPF32[i33 + 52 >> 2]);
    i24 = i6 + 56 | 0;
    f26 = Math_fround(HEAPF32[i24 >> 2]);
    f25 = Math_fround(HEAPF32[i33 + 56 >> 2]);
    i34 = i6 + 60 | 0;
    f23 = Math_fround(HEAPF32[i34 >> 2]);
    f2 = Math_fround(HEAPF32[i33 + 60 >> 2]);
    HEAPF32[i30 >> 2] = f32 >= f31 ? f32 : f31;
    HEAPF32[i27 >> 2] = f29 >= f28 ? f29 : f28;
    HEAPF32[i24 >> 2] = f26 >= f25 ? f26 : f25;
    HEAPF32[i34 >> 2] = f23 >= f2 ? f23 : f2;
    i34 = i6 + 64 | 0;
    f2 = Math_fround(HEAPF32[i34 >> 2]);
    f23 = Math_fround(HEAPF32[i33 + 64 >> 2]);
    i24 = i6 + 68 | 0;
    f25 = Math_fround(HEAPF32[i24 >> 2]);
    f26 = Math_fround(HEAPF32[i33 + 68 >> 2]);
    i27 = i6 + 72 | 0;
    f28 = Math_fround(HEAPF32[i27 >> 2]);
    f29 = Math_fround(HEAPF32[i33 + 72 >> 2]);
    i30 = i6 + 76 | 0;
    f31 = Math_fround(HEAPF32[i30 >> 2]);
    f32 = Math_fround(HEAPF32[i33 + 76 >> 2]);
    HEAPF32[i34 >> 2] = f2 >= f23 ? f2 : f23;
    HEAPF32[i24 >> 2] = f25 >= f26 ? f25 : f26;
    HEAPF32[i27 >> 2] = f28 >= f29 ? f28 : f29;
    HEAPF32[i30 >> 2] = f31 >= f32 ? f31 : f32;
    i30 = i6 + 80 | 0;
    f32 = Math_fround(HEAPF32[i30 >> 2]);
    f31 = Math_fround(HEAPF32[i33 + 80 >> 2]);
    i27 = i6 + 84 | 0;
    f29 = Math_fround(HEAPF32[i27 >> 2]);
    f28 = Math_fround(HEAPF32[i33 + 84 >> 2]);
    i24 = i6 + 88 | 0;
    f26 = Math_fround(HEAPF32[i24 >> 2]);
    f25 = Math_fround(HEAPF32[i33 + 88 >> 2]);
    i34 = i6 + 92 | 0;
    f23 = Math_fround(HEAPF32[i34 >> 2]);
    f2 = Math_fround(HEAPF32[i33 + 92 >> 2]);
    HEAPF32[i30 >> 2] = f32 >= f31 ? f32 : f31;
    HEAPF32[i27 >> 2] = f29 >= f28 ? f29 : f28;
    HEAPF32[i24 >> 2] = f26 >= f25 ? f26 : f25;
    HEAPF32[i34 >> 2] = f23 >= f2 ? f23 : f2;
    i34 = i6 + 96 | 0;
    f2 = Math_fround(HEAPF32[i34 >> 2]);
    f23 = Math_fround(HEAPF32[i33 + 96 >> 2]);
    i24 = i6 + 100 | 0;
    f25 = Math_fround(HEAPF32[i24 >> 2]);
    f26 = Math_fround(HEAPF32[i33 + 100 >> 2]);
    i27 = i6 + 104 | 0;
    f28 = Math_fround(HEAPF32[i27 >> 2]);
    f29 = Math_fround(HEAPF32[i33 + 104 >> 2]);
    i30 = i6 + 108 | 0;
    f31 = Math_fround(HEAPF32[i30 >> 2]);
    f32 = Math_fround(HEAPF32[i33 + 108 >> 2]);
    HEAPF32[i34 >> 2] = f2 >= f23 ? f2 : f23;
    HEAPF32[i24 >> 2] = f25 >= f26 ? f25 : f26;
    HEAPF32[i27 >> 2] = f28 >= f29 ? f28 : f29;
    HEAPF32[i30 >> 2] = f31 >= f32 ? f31 : f32;
    i30 = i6 + 112 | 0;
    f32 = Math_fround(HEAPF32[i30 >> 2]);
    f31 = Math_fround(HEAPF32[i33 + 112 >> 2]);
    i27 = i6 + 116 | 0;
    f29 = Math_fround(HEAPF32[i27 >> 2]);
    f28 = Math_fround(HEAPF32[i33 + 116 >> 2]);
    i24 = i6 + 120 | 0;
    f26 = Math_fround(HEAPF32[i24 >> 2]);
    f25 = Math_fround(HEAPF32[i33 + 120 >> 2]);
    i6 = i6 + 124 | 0;
    f23 = Math_fround(HEAPF32[i6 >> 2]);
    f2 = Math_fround(HEAPF32[i33 + 124 >> 2]);
    HEAPF32[i30 >> 2] = f32 >= f31 ? f32 : f31;
    HEAPF32[i27 >> 2] = f29 >= f28 ? f29 : f28;
    HEAPF32[i24 >> 2] = f26 >= f25 ? f26 : f25;
    HEAPF32[i6 >> 2] = f23 >= f2 ? f23 : f2;
    if (i4) {
     i6 = i3 + 1024 | 0;
     i5 = i6 >>> 0 < i12 >>> 0;
     i7 = i5 ? i6 + i13 | 0 : i7;
     i5 = i5 ? i10 : 0;
    } else {
     i7 = i7 + 128 | 0;
     i5 = i5 + -1 | 0;
     i6 = i3;
    }
    if (!i8) break;
    i4 = (i5 | 0) == 0;
    if (i6 >>> 0 >= i12 >>> 0 & i4) break L10; else {
     i9 = i9 + 128 | 0;
     i8 = i8 + -1 | 0;
     i3 = i6;
    }
   }
   i1 = i1 + 1024 | 0;
   i3 = i1 >>> 0 < i11 >>> 0;
   i4 = (i5 | 0) == 0;
   if (i6 >>> 0 >= i12 >>> 0 & i4) break; else {
    i9 = i3 ? i1 + i13 | 0 : i9;
    i8 = i3 ? i10 : 0;
   }
  }
 } while (0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i18 >> 2];
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i20 >> 2];
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i21 >> 2];
 STACKTOP = i22;
 return;
}

function __ZN5physx18AdjacenciesBuilder4InitERKNS_17ADJACENCIESCREATEE(i22, i20) {
 i22 = i22 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i23;
 i16 = i23 + 68 | 0;
 i9 = i23 + 104 | 0;
 i17 = i23 + 56 | 0;
 i19 = i23 + 32 | 0;
 i21 = i23 + 8 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP32[i22 >> 2] = i1;
 i18 = i1 * 12 | 0;
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 i13 = _PxGetFoundation() | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0;
 i13 = mftCall_iiiiii(i11 | 0, i12 | 0, (i1 >>> 0 > 357913941 | i18 >>> 0 > 4294967291 ? -1 : i18 + 4 | 0) | 0, (i13 ? gb + 727608 | 0 : gb + 837976 | 0) | 0, gb + 727718 | 0, 804) | 0;
 HEAP32[i13 >> 2] = i1;
 i18 = i22 + 4 | 0;
 HEAP32[i18 >> 2] = i13 + 4;
 i13 = (HEAP32[i22 >> 2] | 0) * 3 | 0;
 i12 = i13 * 12 | 0;
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 i15 = _PxGetFoundation() | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
 i15 = mftCall_iiiiii(i10 | 0, i11 | 0, (i13 >>> 0 > 357913941 | i12 >>> 0 > 4294967291 ? -1 : i12 + 4 | 0) | 0, (i15 ? gb + 727798 | 0 : gb + 837976 | 0) | 0, gb + 727718 | 0, 806) | 0;
 HEAP32[i15 >> 2] = i13;
 i13 = i15 + 4 | 0;
 L4 : do if (!(HEAP32[i22 >> 2] | 0)) i3 = 0; else {
  i3 = HEAP32[i20 + 4 >> 2] | 0;
  i6 = HEAP32[i20 + 8 >> 2] | 0;
  i7 = (i6 | 0) == 0;
  i8 = HEAP32[i18 >> 2] | 0;
  if (!i3) {
   i1 = 0;
   i5 = 0;
  } else {
   i1 = 0;
   i2 = 0;
   while (1) {
    i7 = HEAP32[i3 + (i2 * 3 << 2) >> 2] | 0;
    i11 = HEAP32[i3 + ((i2 * 3 | 0) + 1 << 2) >> 2] | 0;
    i10 = HEAP32[i3 + ((i2 * 3 | 0) + 2 << 2) >> 2] | 0;
    HEAP32[i8 + (i2 * 12 | 0) >> 2] = -1;
    HEAP32[i8 + (i2 * 12 | 0) + 4 >> 2] = -1;
    HEAP32[i8 + (i2 * 12 | 0) + 8 >> 2] = -1;
    i12 = i7 >>> 0 < i11 >>> 0;
    HEAP32[i13 + (i1 * 12 | 0) >> 2] = i12 ? i7 : i11;
    HEAP32[i13 + (i1 * 12 | 0) + 4 >> 2] = i12 ? i11 : i7;
    HEAP32[i13 + (i1 * 12 | 0) + 8 >> 2] = i2;
    i12 = i1 + 1 | 0;
    i6 = i7 >>> 0 < i10 >>> 0;
    HEAP32[i13 + (i12 * 12 | 0) >> 2] = i6 ? i7 : i10;
    HEAP32[i13 + (i12 * 12 | 0) + 4 >> 2] = i6 ? i10 : i7;
    HEAP32[i13 + (i12 * 12 | 0) + 8 >> 2] = i2;
    i12 = i1 + 2 | 0;
    i7 = i11 >>> 0 < i10 >>> 0;
    HEAP32[i13 + (i12 * 12 | 0) >> 2] = i7 ? i11 : i10;
    HEAP32[i13 + (i12 * 12 | 0) + 4 >> 2] = i7 ? i10 : i11;
    HEAP32[i13 + (i12 * 12 | 0) + 8 >> 2] = i2;
    i1 = i1 + 3 | 0;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) {
     i3 = i1;
     break L4;
    }
   }
  }
  do {
   if (i7) {
    i2 = 0;
    i3 = 1;
    i4 = 2;
   } else {
    i2 = HEAPU16[i6 + (i5 * 3 << 1) >> 1] | 0;
    i3 = HEAPU16[i6 + ((i5 * 3 | 0) + 1 << 1) >> 1] | 0;
    i4 = HEAPU16[i6 + ((i5 * 3 | 0) + 2 << 1) >> 1] | 0;
   }
   HEAP32[i8 + (i5 * 12 | 0) >> 2] = -1;
   HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] = -1;
   HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] = -1;
   i12 = i2 >>> 0 < i3 >>> 0;
   HEAP32[i13 + (i1 * 12 | 0) >> 2] = i12 ? i2 : i3;
   HEAP32[i13 + (i1 * 12 | 0) + 4 >> 2] = i12 ? i3 : i2;
   HEAP32[i13 + (i1 * 12 | 0) + 8 >> 2] = i5;
   i12 = i1 + 1 | 0;
   i11 = i2 >>> 0 < i4 >>> 0;
   HEAP32[i13 + (i12 * 12 | 0) >> 2] = i11 ? i2 : i4;
   HEAP32[i13 + (i12 * 12 | 0) + 4 >> 2] = i11 ? i4 : i2;
   HEAP32[i13 + (i12 * 12 | 0) + 8 >> 2] = i5;
   i12 = i1 + 2 | 0;
   i11 = i3 >>> 0 < i4 >>> 0;
   HEAP32[i13 + (i12 * 12 | 0) >> 2] = i11 ? i3 : i4;
   HEAP32[i13 + (i12 * 12 | 0) + 4 >> 2] = i11 ? i4 : i3;
   HEAP32[i13 + (i12 * 12 | 0) + 8 >> 2] = i5;
   i1 = i1 + 3 | 0;
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
  i3 = i1;
 } while (0);
 i12 = HEAP32[i18 >> 2] | 0;
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i16);
 i1 = i3 >>> 0 > 1073741823 ? -1 : i3 << 2;
 if (!i1) i2 = 0; else {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = mftCall_iiiiii(i10 | 0, i11 | 0, i1 | 0, (i2 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 727718 | 0, 719) | 0;
 }
 if (!i3) __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i16, i2, 0, 0) | 0; else {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i13 + (i1 * 12 | 0) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i16, i2, i3, 0) | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i13 + (i1 * 12 | 0) + 4 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i16, i2, i3, 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
 i5 = HEAP32[i16 + 8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i9 = i17 + 4 | 0;
 i10 = i20 + 4 | 0;
 i11 = i20 + 8 | 0;
 i4 = 0;
 i2 = HEAP32[i13 + (i1 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i13 + (i1 * 12 | 0) + 4 >> 2] | 0;
 L26 : while (1) {
  while (1) {
   if (!i3) {
    i3 = 24;
    break L26;
   }
   i3 = i3 + -1 | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i5 = i5 + 4 | 0;
   i6 = HEAP32[i13 + (i7 * 12 | 0) + 8 >> 2] | 0;
   i8 = HEAP32[i13 + (i7 * 12 | 0) >> 2] | 0;
   i7 = HEAP32[i13 + (i7 * 12 | 0) + 4 >> 2] | 0;
   if (!((i8 | 0) == (i2 | 0) & (i7 | 0) == (i1 | 0))) break;
   HEAP32[i17 + (i4 << 2) >> 2] = i6;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == 3) {
    i3 = 20;
    break L26;
   }
  }
  if ((i4 | 0) == 2) if (!(__ZL10UpdateLinkjjjjPN5physx11AdjTriangleERKNS_17ADJACENCIESCREATEE(HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0, i2, i1, i12, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0)) {
   i3 = 33;
   break;
  }
  HEAP32[i17 >> 2] = i6;
  i4 = 1;
  i2 = i8;
  i1 = i7;
 }
 if ((i3 | 0) == 20) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 727718 | 0, 749, gb + 727886 | 0, i14);
  __ZN5physx2Gu17RadixSortBufferedD2Ev(i16);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i15);
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 } else if ((i3 | 0) == 24) {
  if ((i4 | 0) == 2) {
   i17 = __ZL10UpdateLinkjjjjPN5physx11AdjTriangleERKNS_17ADJACENCIESCREATEE(HEAP32[i17 >> 2] | 0, HEAP32[i9 >> 2] | 0, i2, i1, i12, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
   __ZN5physx2Gu17RadixSortBufferedD2Ev(i16);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i15);
   if (!i17) {
    i22 = 0;
    STACKTOP = i23;
    return i22 | 0;
   }
  } else {
   __ZN5physx2Gu17RadixSortBufferedD2Ev(i16);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i15);
  }
  i1 = HEAP32[i20 + 12 >> 2] | 0;
  if (!i1) {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP16[i19 + 12 >> 1] = 0;
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i11 >> 2];
  HEAP8[i19 + 12 >> 0] = 1;
  HEAP32[i19 + 16 >> 2] = i1;
  HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 16 >> 2];
  __ZN5physx2Gu15EdgeListBuilderC2Ev(i21);
  if (__ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE(i21, i19) | 0) if (HEAP32[i22 >> 2] | 0) {
   i3 = HEAP32[i21 + 12 >> 2] | 0;
   i1 = HEAP32[i18 >> 2] | 0;
   i2 = 0;
   do {
    i20 = i1 + (i2 * 12 | 0) | 0;
    i19 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = (HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0) > -1 ? i19 & -536870913 : i19 | 536870912;
    i20 = i1 + (i2 * 12 | 0) + 4 | 0;
    i19 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = (HEAP32[i3 + (i2 * 12 | 0) + 8 >> 2] | 0) > -1 ? i19 & -536870913 : i19 | 536870912;
    i20 = i1 + (i2 * 12 | 0) + 8 | 0;
    i19 = HEAP32[i20 >> 2] | 0;
    HEAP32[i20 >> 2] = (HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) > -1 ? i19 & -536870913 : i19 | 536870912;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
  }
  __ZN5physx2Gu8EdgeListD2Ev(i21);
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 } else if ((i3 | 0) == 33) {
  __ZN5physx2Gu17RadixSortBufferedD2Ev(i16);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i15);
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 return 0;
}

function __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = i2;
 L1 : while (1) {
  i11 = i15;
  i12 = i15 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i10 = i1;
    i2 = i11 - i10 | 0;
    i3 = i2 >> 2;
    switch (i3 | 0) {
    case 2:
     {
      i14 = 5;
      break L1;
     }
    case 3:
     {
      i14 = 7;
      break L1;
     }
    case 4:
     {
      i14 = 15;
      break L1;
     }
    case 5:
     {
      i14 = 27;
      break L1;
     }
    case 1:
    case 0:
     {
      i14 = 85;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 124) {
     i14 = 29;
     break L1;
    }
    i9 = i1 + (((i3 | 0) / 2 | 0) << 2) | 0;
    do if ((i2 | 0) > 3996) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_(i1, i1 + (i2 << 2) | 0, i9, i9 + (i2 << 2) | 0, i12, i13) | 0;
     i3 = i9;
     i7 = i1;
    } else {
     i2 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i12 >> 2] | 0;
     i4 = (i3 | 0) < (i2 | 0);
     if ((i2 | 0) >= (i5 | 0)) {
      if (!i4) {
       i2 = 0;
       i3 = i9;
       i7 = i1;
       break;
      }
      HEAP32[i9 >> 2] = i3;
      HEAP32[i12 >> 2] = i2;
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) >= (i3 | 0)) {
       i2 = 1;
       i3 = i9;
       i7 = i1;
       break;
      }
      HEAP32[i1 >> 2] = i2;
      HEAP32[i9 >> 2] = i3;
      i2 = 2;
      i3 = i9;
      i7 = i1;
      break;
     }
     if (i4) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i12 >> 2] = i5;
      i2 = 1;
      i3 = i9;
      i7 = i1;
      break;
     }
     HEAP32[i1 >> 2] = i2;
     HEAP32[i9 >> 2] = i5;
     i2 = HEAP32[i12 >> 2] | 0;
     if ((i2 | 0) < (i5 | 0)) {
      HEAP32[i9 >> 2] = i2;
      HEAP32[i12 >> 2] = i5;
      i2 = 2;
      i3 = i9;
      i7 = i1;
     } else {
      i2 = 1;
      i3 = i9;
      i7 = i1;
     }
    } while (0);
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    if ((i6 | 0) < (i5 | 0)) {
     i3 = i12;
     break;
    } else i3 = i12;
    while (1) {
     i3 = i3 + -4 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) < (i5 | 0)) {
      i14 = 68;
      break L5;
     }
    }
    i1 = i1 + 4 | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    if ((i6 | 0) >= (i3 | 0)) {
     if ((i1 | 0) == (i12 | 0)) {
      i14 = 85;
      break L1;
     }
     while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i6 | 0) < (i2 | 0)) break;
      i1 = i1 + 4 | 0;
      if ((i1 | 0) == (i12 | 0)) {
       i14 = 85;
       break L1;
      }
     }
     HEAP32[i1 >> 2] = i3;
     HEAP32[i12 >> 2] = i2;
     i1 = i1 + 4 | 0;
    }
    if ((i1 | 0) == (i12 | 0)) {
     i14 = 85;
     break L1;
    } else i2 = i12;
    while (1) {
     i6 = HEAP32[i7 >> 2] | 0;
     while (1) {
      i4 = HEAP32[i1 >> 2] | 0;
      i5 = i1 + 4 | 0;
      if ((i6 | 0) < (i4 | 0)) break; else i1 = i5;
     }
     do {
      i2 = i2 + -4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
     } while ((i6 | 0) < (i3 | 0));
     if (i1 >>> 0 >= i2 >>> 0) continue L5;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i2 >> 2] = i4;
     i1 = i5;
    }
   }
   if ((i14 | 0) == 68) {
    i14 = 0;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i3 >> 2] = i6;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 4 | 0;
   L44 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i8 = HEAP32[i9 >> 2] | 0;
    while (1) {
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i4 + 4 | 0;
     if ((i6 | 0) < (i8 | 0)) i4 = i7; else break;
    }
    do {
     i3 = i3 + -4 | 0;
     i5 = HEAP32[i3 >> 2] | 0;
    } while ((i5 | 0) >= (i8 | 0));
    if (i4 >>> 0 > i3 >>> 0) {
     i5 = i9;
     i6 = i4;
     break L44;
    }
    HEAP32[i4 >> 2] = i5;
    HEAP32[i3 >> 2] = i6;
    i9 = (i9 | 0) == (i4 | 0) ? i3 : i9;
    i4 = i7;
    i2 = i2 + 1 | 0;
   } else {
    i5 = i9;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) < (i4 | 0)) {
     HEAP32[i6 >> 2] = i3;
     HEAP32[i5 >> 2] = i4;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEbT0_S8_T_(i1, i6, i13) | 0;
    i3 = i6 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEbT0_S8_T_(i3, i15, i13) | 0) {
     i14 = 84;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i9 = i6;
   if ((i9 - i10 | 0) >= (i11 - i9 | 0)) {
    i14 = 83;
    break;
   }
   __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_(i1, i6, i13);
   i1 = i6 + 4 | 0;
  }
  if ((i14 | 0) == 83) {
   i14 = 0;
   __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_(i6 + 4 | 0, i15, i13);
   i15 = i6;
   continue;
  } else if ((i14 | 0) == 84) {
   i14 = 0;
   if (i2) {
    i14 = 85;
    break;
   } else {
    i15 = i6;
    continue;
   }
  }
 }
 if ((i14 | 0) == 5) {
  i3 = i15 + -4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) >= (i2 | 0)) return;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i3 >> 2] = i2;
  return;
 } else if ((i14 | 0) == 7) {
  i7 = i1 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = i15 + -4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = (i2 | 0) < (i4 | 0);
  if ((i4 | 0) >= (i6 | 0)) {
   if (!i3) return;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   return;
  }
  if (i3) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i5 >> 2] = i6;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i6;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) >= (i6 | 0)) return;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i6;
  return;
 } else if ((i14 | 0) == 15) {
  i7 = i1 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i5 = (i3 | 0) < (i4 | 0);
  do if ((i4 | 0) < (i2 | 0)) {
   if (i5) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    i4 = i2;
    break;
   }
   HEAP32[i1 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   if ((i3 | 0) < (i2 | 0)) {
    HEAP32[i7 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    i4 = i2;
   } else i4 = i3;
  } else if (i5) {
   HEAP32[i7 >> 2] = i3;
   HEAP32[i6 >> 2] = i4;
   if ((i3 | 0) < (i2 | 0)) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i7 >> 2] = i2;
   }
  } else i4 = i3; while (0);
  i2 = i15 + -4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) >= (i4 | 0)) return;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) return;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) return;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i2;
  return;
 } else if ((i14 | 0) == 27) {
  __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i12, i13) | 0;
  return;
 } else if ((i14 | 0) == 29) {
  i2 = i1 + 8 | 0;
  i3 = i1 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = (i6 | 0) < (i4 | 0);
  do if ((i4 | 0) < (i5 | 0)) {
   if (i7) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i2 >> 2] = i5;
    i4 = i5;
    break;
   }
   HEAP32[i1 >> 2] = i4;
   HEAP32[i3 >> 2] = i5;
   if ((i6 | 0) < (i5 | 0)) {
    HEAP32[i3 >> 2] = i6;
    HEAP32[i2 >> 2] = i5;
    i4 = i5;
   } else i4 = i6;
  } else if (i7) {
   HEAP32[i3 >> 2] = i6;
   HEAP32[i2 >> 2] = i4;
   if ((i6 | 0) < (i5 | 0)) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i3 >> 2] = i5;
   }
  } else i4 = i6; while (0);
  i3 = i1 + 12 | 0;
  if ((i3 | 0) == (i15 | 0)) return;
  while (1) {
   i6 = HEAP32[i3 >> 2] | 0;
   if ((i6 | 0) < (i4 | 0)) {
    i5 = i3;
    while (1) {
     HEAP32[i5 >> 2] = i4;
     if ((i2 | 0) == (i1 | 0)) {
      i2 = i1;
      break;
     }
     i5 = i2 + -4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     if ((i6 | 0) >= (i4 | 0)) break; else {
      i14 = i2;
      i2 = i5;
      i5 = i14;
     }
    }
    HEAP32[i2 >> 2] = i6;
   }
   i2 = i3 + 4 | 0;
   if ((i2 | 0) == (i15 | 0)) break;
   i4 = HEAP32[i3 >> 2] | 0;
   i14 = i3;
   i3 = i2;
   i2 = i14;
  }
  return;
 } else if ((i14 | 0) == 85) return;
}

function __ZN16ParticleAnimator8TransferI14SafeBinaryReadEEvRT_(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i12 = i13 + 4 | 0;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i8, i11);
 i3 = i8 + 112 | 0;
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048128 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 88 | 0;
 i3 = HEAP32[gb + 36980 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048148 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048166 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048184 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048202 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048220 | 0, i3, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 32 | 0;
 i6 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048238 | 0, i6, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048256 | 0, i6, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 84 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048274 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048283 | 0, i6, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i8 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048292 | 0, i6, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048298 | 0, i5, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 80; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 80; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 80) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f14 < Math_fround(0.0);
 i1 = f14 > Math_fround(1.0);
 f14 = i1 ? Math_fround(1.0) : f14;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f14;
 i3 = i8 + 113 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048306 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i7 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i8 + 108 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) != 0 & 1;
 HEAP8[i12 >> 0] = i1;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1048321 | 0, i9, i10, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i10 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i12 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i12, 1);
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i12 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP8[i12 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 if (HEAP32[i4 >> 2] | 0) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i4 >> 2] = 1;
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i12 = i16 + 4 | 0;
 i14 = i17 + 4 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i11;
 i14 = i16 + 8 | 0;
 i11 = i17 + 8 | 0;
 i12 = HEAP8[i14 >> 0] | 0;
 HEAP8[i14 >> 0] = HEAP8[i11 >> 0] | 0;
 HEAP8[i11 >> 0] = i12;
 i11 = i16 + 9 | 0;
 i12 = i17 + 9 | 0;
 i14 = HEAP8[i11 >> 0] | 0;
 HEAP8[i11 >> 0] = HEAP8[i12 >> 0] | 0;
 HEAP8[i12 >> 0] = i14;
 i12 = i18 + 20 | 0;
 i14 = i18 + 24 | 0;
 i11 = i18 + 4 | 0;
 i13 = i18 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 i2 = i16 + 12 | 0;
 i7 = i16 + 36 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i7;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = i14;
 HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i15 + 4 >> 2] = i10;
 HEAP8[i11 >> 0] = 0;
 do if ((i18 | 0) != (i2 | 0)) {
  i3 = HEAP32[i2 >> 2] | 0;
  i15 = (i3 | 0) == 0;
  i3 = i15 ? i16 + 16 | 0 : i3;
  i4 = HEAP32[i16 + 32 >> 2] | 0;
  i1 = i18 + 4 | 0;
  if (!((HEAP32[i16 + 16 >> 2] | 0) != 0 | i15)) {
   HEAP32[i18 >> 2] = i3;
   HEAP32[i12 >> 2] = i4;
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i4 >>> 0 > 15) {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i14, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i18 >> 2] = i15;
   HEAP32[i1 >> 2] = i4;
   i1 = (i15 | 0) == 0 ? i11 : i15;
  } else i1 = i11;
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i12 >> 2] = i4;
 } while (0);
 i8 = i16 + 44 | 0;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 i9 = i17 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i16 + 16 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 i10 = i17 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i16 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i10;
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = i16 + 16 | 0;
 HEAP8[i1 >> 0] = 0;
 i15 = (i16 | 0) == (i17 | 0);
 do if (i15) i6 = i9; else {
  i5 = HEAP32[i9 >> 2] | 0;
  i20 = (i5 | 0) == 0;
  i5 = i20 ? i17 + 16 | 0 : i5;
  i6 = HEAP32[i17 + 32 >> 2] | 0;
  i3 = i16 + 16 | 0;
  if (!((HEAP32[i17 + 16 >> 2] | 0) != 0 | i20)) {
   HEAP32[i2 >> 2] = i5;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i3 >> 2] = 0;
   i6 = i9;
   break;
  }
  if (i6 >>> 0 > 15) {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i2 >> 2] = i20;
   HEAP32[i3 >> 2] = i6;
   i1 = (i20 | 0) == 0 ? i1 : i20;
  }
  _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  HEAP32[i4 >> 2] = i6;
  i6 = i9;
 } while (0);
 i7 = i17 + 44 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i17 + 16 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 HEAP32[i6 >> 2] = 0;
 i5 = i17 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 i8 = i14;
 i20 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 i1 = i17 + 16 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i9 | 0) != (i18 | 0)) {
  i4 = HEAP32[i18 >> 2] | 0;
  i20 = (i4 | 0) == 0;
  i4 = i20 ? i11 : i4;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = i17 + 16 | 0;
  if (!((HEAP32[i18 + 4 >> 2] | 0) != 0 | i20)) {
   HEAP32[i6 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i3 >>> 0 > 15) {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i10, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i6 >> 2] = i20;
   HEAP32[i2 >> 2] = i3;
   i1 = (i20 | 0) == 0 ? i1 : i20;
  }
  _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i5 >> 2] = i3;
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i18 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 i12 = i18 + 20 | 0;
 i14 = i18 + 24 | 0;
 i11 = i18 + 4 | 0;
 i13 = i18 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 i2 = i16 + 48 | 0;
 i7 = i16 + 72 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i7;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i20 = i14;
 HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i20 + 4 >> 2] = i10;
 HEAP8[i11 >> 0] = 0;
 do if ((i18 | 0) != (i2 | 0)) {
  i3 = HEAP32[i2 >> 2] | 0;
  i20 = (i3 | 0) == 0;
  i3 = i20 ? i16 + 52 | 0 : i3;
  i4 = HEAP32[i16 + 68 >> 2] | 0;
  i1 = i18 + 4 | 0;
  if (!((HEAP32[i16 + 52 >> 2] | 0) != 0 | i20)) {
   HEAP32[i18 >> 2] = i3;
   HEAP32[i12 >> 2] = i4;
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i4 >>> 0 > 15) {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i14, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i18 >> 2] = i20;
   HEAP32[i1 >> 2] = i4;
   i1 = (i20 | 0) == 0 ? i11 : i20;
  } else i1 = i11;
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i12 >> 2] = i4;
 } while (0);
 i8 = i16 + 80 | 0;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 i9 = i17 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i16 + 52 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 i10 = i17 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i16 + 68 | 0;
 HEAP32[i6 >> 2] = 0;
 i5 = i10;
 i20 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 i1 = i16 + 52 | 0;
 HEAP8[i1 >> 0] = 0;
 do if (i15) i6 = i9; else {
  i4 = HEAP32[i9 >> 2] | 0;
  i20 = (i4 | 0) == 0;
  i4 = i20 ? i17 + 52 | 0 : i4;
  i5 = HEAP32[i17 + 68 >> 2] | 0;
  i3 = i16 + 52 | 0;
  if (!((HEAP32[i17 + 52 >> 2] | 0) != 0 | i20)) {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i3 >> 2] = 0;
   i6 = i9;
   break;
  }
  if (i5 >>> 0 > 15) {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i2 >> 2] = i20;
   HEAP32[i3 >> 2] = i5;
   i1 = (i20 | 0) == 0 ? i1 : i20;
  }
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i9;
 } while (0);
 i7 = i17 + 80 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i17 + 52 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 HEAP32[i6 >> 2] = 0;
 i5 = i17 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 i15 = i14;
 i20 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 i1 = i17 + 52 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i9 | 0) != (i18 | 0)) {
  i4 = HEAP32[i18 >> 2] | 0;
  i20 = (i4 | 0) == 0;
  i4 = i20 ? i11 : i4;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = i17 + 52 | 0;
  if (!((HEAP32[i18 + 4 >> 2] | 0) != 0 | i20)) {
   HEAP32[i6 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i3 >>> 0 > 15) {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i10, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i6 >> 2] = i20;
   HEAP32[i2 >> 2] = i3;
   i1 = (i20 | 0) == 0 ? i1 : i20;
  }
  _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i5 >> 2] = i3;
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i18 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 i13 = i16 + 84 | 0;
 i18 = i17 + 84 | 0;
 i20 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i18 >> 2] = i20;
 i18 = i16 + 88 | 0;
 i20 = i17 + 88 | 0;
 i13 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i13;
 i13 = i16 + 92 | 0;
 i15 = i17 + 92 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i14;
 f21 = Math_fround((HEAP32[i18 >> 2] | 0) >>> 0);
 HEAP32[i16 + 100 >> 2] = ~~Math_fround(f21 * Math_fround(.5)) >>> 0;
 HEAP32[i16 + 96 >> 2] = ~~Math_fround(f21 * Math_fround(.200000003)) >>> 0;
 HEAP8[i16 + 104 >> 0] = 0;
 f21 = Math_fround((HEAP32[i20 >> 2] | 0) >>> 0);
 HEAP32[i17 + 100 >> 2] = ~~Math_fround(f21 * Math_fround(.5)) >>> 0;
 HEAP32[i17 + 96 >> 2] = ~~Math_fround(f21 * Math_fround(.200000003)) >>> 0;
 HEAP8[i17 + 104 >> 0] = 0;
 STACKTOP = i19;
 return;
}

function __ZN5physx2Gu27intersectRayCapsuleInternalERKNS_6PxVec3ES3_S3_S3_fPf(i20, i15, i8, i1, f21, i25) {
 i20 = i20 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 f21 = Math_fround(f21);
 i25 = i25 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f22 = f0, f23 = f0, f24 = f0, f26 = f0, f27 = f0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(f6 - f18);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f4 = Math_fround(f7 - f19);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f3 = Math_fround(f5 - f16);
 f24 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(f3 * f3))));
 if (f24 != Math_fround(0.0)) {
  f23 = Math_fround(Math_fround(1.0) / f24);
  f2 = Math_fround(f2 * f23);
  f17 = Math_fround(f4 * f23);
  f3 = Math_fround(f3 * f23);
 } else f17 = f4;
 if (f24 <= Math_fround(9.99999997e-07)) {
  f17 = Math_fround(HEAPF32[i20 >> 2]);
  f18 = Math_fround(f17 - f18);
  f22 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f19 = Math_fround(f22 - f19);
  f24 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f23 = Math_fround(f24 - f16);
  f23 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)) + Math_fround(f23 * f23));
  f19 = Math_fround(f17 - f6);
  f22 = Math_fround(f22 - f7);
  f24 = Math_fround(f24 - f5);
  f24 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f22 * f22)) + Math_fround(f24 * f24));
  i25 = (__ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_(i20, i15, Math_fround(Math_fround((f23 > f24 ? f23 : f24) + f21) * Math_fround(2.0)), i8, f21, i25, 0) | 0) & 1;
  return i25 | 0;
 }
 do if (f24 > Math_fround(0.0)) if (!(Math_fround(Math_abs(Math_fround(f2))) >= Math_fround(Math_abs(Math_fround(f17))))) {
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f17 * f17)))));
  f11 = Math_fround(-Math_fround(f17 * f12));
  f12 = Math_fround(f3 * f12);
  f13 = Math_fround(0.0);
  break;
 } else {
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)))));
  f11 = Math_fround(f2 * f13);
  f12 = Math_fround(0.0);
  f13 = Math_fround(-Math_fround(f3 * f13));
  break;
 } else {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
 } while (0);
 f4 = Math_fround(Math_fround(f17 * f11) - Math_fround(f3 * f12));
 f6 = Math_fround(Math_fround(f3 * f13) - Math_fround(f2 * f11));
 f7 = Math_fround(Math_fround(f2 * f12) - Math_fround(f17 * f13));
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)))));
 if (f5 > Math_fround(0.0)) {
  f23 = Math_fround(Math_fround(1.0) / f5);
  f4 = Math_fround(f4 * f23);
  f6 = Math_fround(f6 * f23);
  f7 = Math_fround(f7 * f23);
 }
 f23 = Math_fround(HEAPF32[i15 >> 2]);
 f9 = Math_fround(f13 * f23);
 f26 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f12 * f26));
 f14 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f11 * f14));
 f10 = Math_fround(Math_fround(Math_fround(f4 * f23) + Math_fround(f6 * f26)) + Math_fround(f7 * f14));
 f14 = Math_fround(Math_fround(Math_fround(f2 * f23) + Math_fround(f17 * f26)) + Math_fround(f3 * f14));
 f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)))));
 i15 = f26 != Math_fround(0.0);
 f23 = Math_fround(Math_fround(1.0) / f26);
 f23 = i15 ? f23 : Math_fround(0.0);
 f9 = Math_fround(f9 * f23);
 f10 = Math_fround(f10 * f23);
 f22 = Math_fround(f14 * f23);
 f27 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f18);
 f18 = Math_fround(Math_fround(HEAPF32[i20 + 4 >> 2]) - f19);
 f19 = Math_fround(Math_fround(HEAPF32[i20 + 8 >> 2]) - f16);
 f5 = Math_fround(Math_fround(Math_fround(f13 * f27) + Math_fround(f12 * f18)) + Math_fround(f11 * f19));
 f4 = Math_fround(Math_fround(Math_fround(f4 * f27) + Math_fround(f6 * f18)) + Math_fround(f7 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f2 * f27) + Math_fround(f17 * f18)) + Math_fround(f3 * f19));
 f2 = Math_fround(f21 * f21);
 if (f26 < Math_fround(1.1920929e-07) | Math_fround(Math_abs(Math_fround(f22))) >= Math_fround(.99999988)) {
  f2 = Math_fround(Math_fround(f2 - Math_fround(f5 * f5)) - Math_fround(f4 * f4));
  i1 = f2 >= Math_fround(0.0);
  if (f14 < Math_fround(0.0) & i1) {
   f27 = Math_fround(Math_sqrt(Math_fround(f2)));
   HEAPF32[i25 >> 2] = Math_fround(f23 * Math_fround(f11 + f27));
   HEAPF32[i25 + 4 >> 2] = Math_fround(-Math_fround(f23 * Math_fround(Math_fround(f24 - f11) + f27)));
   i25 = 2;
   return i25 | 0;
  }
  if (!(f14 > Math_fround(0.0) & i1)) {
   i25 = 0;
   return i25 | 0;
  }
  f27 = Math_fround(Math_sqrt(Math_fround(f2)));
  HEAPF32[i25 >> 2] = Math_fround(-Math_fround(f23 * Math_fround(f11 + f27)));
  HEAPF32[i25 + 4 >> 2] = Math_fround(f23 * Math_fround(Math_fround(f24 - f11) + f27));
  i25 = 2;
  return i25 | 0;
 }
 f3 = Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10));
 f7 = Math_fround(Math_fround(f9 * f5) + Math_fround(f10 * f4));
 f6 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) - f2);
 f2 = Math_fround(Math_fround(f7 * f7) - Math_fround(f3 * f6));
 if (f2 < Math_fround(0.0)) {
  i25 = 0;
  return i25 | 0;
 }
 if (f2 > Math_fround(0.0)) {
  f4 = Math_fround(Math_sqrt(Math_fround(f2)));
  f3 = Math_fround(Math_fround(1.0) / f3);
  f2 = Math_fround(Math_fround(Math_fround(-f7) - f4) * f3);
  f27 = Math_fround(f11 + Math_fround(f22 * f2));
  f5 = Math_fround(f24 + Math_fround(.00100000005));
  if (!(f27 >= Math_fround(-.00100000005)) | !(f27 <= f5)) i1 = 0; else {
   HEAPF32[i25 >> 2] = Math_fround(f23 * f2);
   i1 = 1;
  }
  f2 = Math_fround(Math_fround(f4 - f7) * f3);
  f27 = Math_fround(f11 + Math_fround(f22 * f2));
  if (!(!(f27 >= Math_fround(-.00100000005)) | !(f27 <= f5))) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
 } else {
  f2 = Math_fround(Math_fround(-f7) / f3);
  f27 = Math_fround(f11 + Math_fround(f22 * f2));
  if (!(f27 >= Math_fround(0.0)) | !(f27 <= f24)) i1 = 0; else {
   HEAPF32[i25 >> 2] = Math_fround(f23 * f2);
   i25 = 1;
   return i25 | 0;
  }
 }
 f4 = Math_fround(Math_fround(f22 * f11) + f7);
 f5 = Math_fround(Math_fround(f11 * f11) + f6);
 f2 = Math_fround(Math_fround(f4 * f4) - f5);
 if (f2 > Math_fround(0.0)) {
  f3 = Math_fround(Math_sqrt(Math_fround(f2)));
  f2 = Math_fround(Math_fround(-f4) - f3);
  if (Math_fround(f11 + Math_fround(f22 * f2)) <= Math_fround(0.0)) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
  f2 = Math_fround(f3 - f4);
  if (Math_fround(f11 + Math_fround(f22 * f2)) <= Math_fround(0.0)) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
 } else if (f2 == Math_fround(0.0)) {
  f2 = Math_fround(-f4);
  if (Math_fround(f11 + Math_fround(f22 * f2)) <= Math_fround(0.0)) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
 }
 f4 = Math_fround(f4 - Math_fround(f24 * f22));
 f2 = Math_fround(Math_fround(f4 * f4) - Math_fround(Math_fround(f24 * Math_fround(f24 - Math_fround(f11 * Math_fround(2.0)))) + f5));
 if (f2 > Math_fround(0.0)) {
  f3 = Math_fround(Math_sqrt(Math_fround(f2)));
  f2 = Math_fround(Math_fround(-f4) - f3);
  if (Math_fround(f11 + Math_fround(f22 * f2)) >= f24) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
  f2 = Math_fround(f3 - f4);
  if (Math_fround(f11 + Math_fround(f22 * f2)) >= f24) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
 } else if (f2 == Math_fround(0.0)) {
  f2 = Math_fround(-f4);
  if (Math_fround(f11 + Math_fround(f22 * f2)) >= f24) {
   HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(f23 * f2);
   if ((i1 | 0) == 1) {
    i25 = 2;
    return i25 | 0;
   } else i1 = 1;
  }
 }
 i25 = i1;
 return i25 | 0;
}

function __Z22DestroyObjectHighLevelP6Objectb(i13, i3) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 36 | 0;
 i5 = i14 + 8 | 0;
 i2 = i14;
 i7 = i14 + 32 | 0;
 i11 = i14 + 20 | 0;
 if ((HEAP16[gb + 1162520 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162520 | 0, i6);
  i12 = gb + 1162520 | 0;
 } else i12 = 0;
 L4 : do if (i13 | 0) {
  i4 = i13 + 8 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 & 524288 | 0) {
   HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
   __Z6FormatPKcz(i6, gb + 447098 | 0, i2);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 444974 | 0, 1257, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   break;
  }
  i1 = i1 >>> 21;
  if ((i1 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
   if ((i1 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if ((i1 - (HEAP32[gb + 27368 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27368 + 28 >> 2] | 0) >>> 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447928 | 0, 0, gb + 444974 | 0, 1575, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
    break;
   } else {
    __Z19DestroySingleObjectP6Object(i13);
    break;
   }
   if ((__Z24GetExecutionRestrictionsv() | 0) & 1 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447694 | 0, 0, gb + 444974 | 0, 1540, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
    break;
   }
   i1 = HEAP32[i13 + 56 >> 2] | 0;
   if (i1 & 16 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447150 | 0, 0, gb + 444974 | 0, 1547, 1, 0, 0, 0);
    break;
   }
   if (i1 & 15 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447028 | 0, 0, gb + 444974 | 0, 1553, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
    break;
   }
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i13, gb + 28940 | 0) | 0;
   if (i1 | 0) {
    i1 = HEAP32[i1 + 100 >> 2] | 0;
    if (i1 | 0) if (HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 56 >> 2] & 5 | 0) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447849 | 0, 0, gb + 444974 | 0, 1563, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
     break;
    }
   }
   __Z26DestroyGameObjectHierarchyR10GameObject(i13);
   break;
  }
  if ((i1 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) if (HEAP8[i13 + 143 >> 0] | 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447150 | 0, 0, gb + 444974 | 0, 1443, 1, 0, 0, 0);
   break;
  }
  i9 = i13 + 28 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  if (!i8) mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0, i13 | 0); else {
   if ((__Z24GetExecutionRestrictionsv() | 0) & 1 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447257 | 0, 0, gb + 444974 | 0, 1453, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
    break;
   }
   i1 = HEAP32[i8 + 56 >> 2] | 0;
   if (i1 & 16 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447150 | 0, 0, gb + 444974 | 0, 1459, 1, 0, 0, 0);
    break;
   }
   if (i1 & 15 | 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447411 | 0, 0, gb + 444974 | 0, 1466, 1, HEAP32[i8 + 4 >> 2] | 0, 0, 0);
    break;
   };
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   if (!i3) if (!(__Z19CanReplaceComponentRN5Unity9ComponentEiPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i13, 0, i11) | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 444974 | 0, 1473, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    break;
   }
   i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i4 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
   switch (i1 | 0) {
   case 4:
   case 224:
    {
     i10 = __ZN6Object15ClassIDToStringEi(i1) | 0;
     i9 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
     HEAP32[i5 >> 2] = i10;
     HEAP32[i5 + 4 >> 2] = i9;
     HEAP32[i5 + 8 >> 2] = i10;
     __Z6FormatPKcz(i6, gb + 447488 | 0, i5);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i11, i6) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 444974 | 0, 1489, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     break L4;
    }
   default:
    {}
   }
   i4 = HEAP32[i13 + 4 >> 2] | 0;
   if (__ZNK10GameObject8IsActiveEv(i8) | 0) {
    mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 104 >> 2] | 0, i13 | 0, 1);
    if (!i4) i1 = 0; else {
     HEAP32[i7 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i10 = 29; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
       i2 = HEAP32[i6 >> 2] | 0;
       i5 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 29; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i10 = 31;
      }
     }
     if ((i10 | 0) == 29) i10 = 31;
     if ((i10 | 0) == 31) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
    if ((i1 | 0) != (i13 | 0)) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     break;
    }
   }
   mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0, i13 | 0);
   if (!i4) i1 = 0; else {
    HEAP32[i7 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i10 = 40; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
      i2 = HEAP32[i6 >> 2] | 0;
      i7 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 40; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i10 = 42;
     }
    }
    if ((i10 | 0) == 40) i10 = 42;
    if ((i10 | 0) == 42) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   }
   if ((i1 | 0) != (i13 | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    break;
   }
   i1 = __ZN10GameObject17GetComponentIndexEPN5Unity9ComponentE(i8, i13) | 0;
   if ((i1 | 0) == -1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447658 | 0, 0, gb + 444974 | 0, 1515, 1, 0, 0, 0); else __ZN10GameObject22RemoveComponentAtIndexEi(HEAP32[i9 >> 2] | 0, i1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
  __Z19DestroySingleObjectP6Object(i13);
 } while (0);
 if (!i12) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i23, i1, i22, i10, i16) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i28;
 i26 = (i16 | 0) != 0;
 i25 = i26 ? i1 | 32 : i1;
 i24 = i23 + 56 | 0;
 i1 = i23 + 32 | 0;
 i15 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i1 >> 2] | 0) | 0;
 i18 = HEAP32[i15 + 1104 >> 2] | 0;
 i21 = i23 + 44 | 0;
 i12 = HEAP32[i21 >> 2] | 0;
 i13 = i12 & 28672;
 i14 = i23 + 48 | 0;
 i27 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
 i27 = (i27 | 0) == (__ZNK5physx2Sc8ShapeSim8getRbSimEv(HEAP32[i1 >> 2] | 0) | 0);
 i20 = i23 + 36 | 0;
 i19 = HEAP32[(i27 ? i20 : i1) >> 2] | 0;
 i20 = HEAP32[(i27 ? i1 : i20) >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(i3 & 1)) {
  HEAP16[i2 >> 1] = i3 | 1;
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  i2 = i18 + 4 | 0;
  i3 = i18 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i18 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = i4 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i5) | 0;
  i1 = (HEAP32[i14 >> 2] | 0) + 16 | 0;
  HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i6 = HEAP32[i15 + 76 >> 2] | 0;
 i17 = HEAP32[i15 + 80 >> 2] | 0;
 i2 = i1 + 20 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 do if (!i4) {
  __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i1);
  i5 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i3 + 20 >> 2] | 0;
  i4 = i3 + 20 | 0;
  if (!i2) {
   __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i3);
   i11 = HEAP32[i4 >> 2] | 0;
   i1 = i11 + 12 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) != (i6 | 0);
   if (!i11) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i3);
    HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] = i6;
    if (i2) {
     i3 = i5;
     i1 = i5;
     i11 = 15;
     break;
    } else {
     i1 = i5;
     i3 = i5;
     i11 = 30;
     break;
    }
   } else {
    HEAP32[i1 >> 2] = i6;
    if (i2) {
     i3 = i5;
     i1 = i5;
     i11 = 15;
     break;
    } else {
     i1 = i5;
     i3 = i5;
     i11 = 30;
     break;
    }
   }
  } else {
   i3 = i5;
   i1 = i5;
   i11 = 11;
  }
 } else {
  i3 = i4;
  i1 = i4;
  i2 = i4;
  i11 = 11;
 } while (0);
 if ((i11 | 0) == 11) {
  i9 = i2 + 12 | 0;
  i11 = (HEAP32[i9 >> 2] | 0) == (i6 | 0);
  HEAP32[i9 >> 2] = i6;
  if (i11) i11 = 30; else i11 = 15;
 }
 do if ((i11 | 0) == 15) {
  i2 = i1 + 4 | 0;
  i4 = HEAP16[i2 >> 1] | 0;
  if (!(i4 << 16 >> 16)) {
   HEAP16[i2 >> 1] = 2;
   i4 = 2;
  }
  i8 = i1 + 10 | 0;
  i7 = HEAPU16[i8 >> 1] | 0;
  if ((i13 | 0) == 0 | i10) {
   HEAP16[i8 >> 1] = i7 & 31;
   i5 = 0;
  } else {
   i5 = i7 >>> 5 << 4;
   i2 = (i12 & 4096 | 0) == 0 ? 4 : 56;
   if (i12 & 8192) i2 = (i2 & 65535) + 52 & 65535;
   if (i12 & 16384) i2 = (i2 & 65535) + 60 & 65535;
   i2 = (i2 & 65535) + 4 | 0;
   i6 = i2 & 65535;
   if (i6 >>> 0 > i5 >>> 0) {
    HEAP16[i8 >> 1] = i7 & 31 | ((i2 & 15 | 0) != 0 & 1) + (i6 >>> 4) << 5;
    i5 = i6;
   }
  }
  i2 = __ZN5physx2Sc10NPhaseCore28reserveContactReportPairDataEjjRj(i18, i4 & 65535, i5, i1) | 0;
  if (!i5) {
   HEAP16[i1 + 6 >> 1] = 0;
   HEAP16[i1 + 8 >> 1] = 0;
   HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] & 65504;
   i11 = 47;
   break;
  }
  if (!i2) i11 = 50; else {
   HEAP16[i1 + 6 >> 1] = 0;
   HEAP16[i1 + 8 >> 1] = 0;
   HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] & 65504;
   i14 = HEAP32[i14 >> 2] | 0;
   __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPhjRKNS0_8RigidSimES5_jjj(i3, i2, i13, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i16, 0, 4);
   if ((i12 & 10240 | 0) == 10240) {
    HEAP8[i15 + 2392 >> 0] = 1;
    i9 = i8;
    i8 = i3;
   } else {
    i9 = i8;
    i8 = i3;
   }
  }
 } else if ((i11 | 0) == 30) {
  i7 = HEAP16[i1 + 6 >> 1] | 0;
  i9 = i7 & 65535;
  if (!(i7 << 16 >> 16)) i11 = 50; else {
   i2 = (HEAP32[i18 + 44 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0;
   if ((i13 | 0) == 0 | i10) i11 = 47; else {
    i5 = HEAP16[i1 + 8 >> 1] | 0;
    i8 = i5 << 16 >> 16 != 0;
    if (i8) i4 = HEAPU16[i2 >> 1] | 0; else i4 = -1;
    if ((i4 | 0) < (i16 | 0)) {
     i6 = i5 & 65535;
     i4 = (i12 & 4096 | 0) == 0 ? 4 : 56;
     if (i12 & 8192) i4 = (i4 & 65535) + 52 & 65535;
     if (i12 & 16384) i4 = (i4 & 65535) + 60 & 65535;
     if (!(i5 << 16 >> 16)) i4 = (i4 & 65535) + 4 & 65535;
     i4 = (i4 & 65535) + i6 & 65535;
     i5 = i1 + 10 | 0;
     if (i4 >>> 0 > (HEAPU16[i5 >> 1] | 0) >>> 5 << 4 >>> 0) {
      i10 = HEAP16[i1 + 4 >> 1] | 0;
      i4 = __ZN5physx2Sc10NPhaseCore27resizeContactReportPairDataEjjRNS0_20ContactStreamManagerE(i18, ((i7 & 65535) >= (i10 & 65535) & 1) + (i10 & 65535) | 0, i4, i3) | 0;
     } else i4 = i2;
     if (!i4) {
      HEAP16[i5 >> 1] = HEAP16[i5 >> 1] | 4;
      i11 = 47;
      break;
     }
     i14 = HEAP32[i14 >> 2] | 0;
     __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPhjRKNS0_8RigidSimES5_jjj(i3, i4, i13, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i16, i9, i8 ? i6 : 4);
     if ((i12 & 10240 | 0) == 10240) {
      HEAP8[i15 + 2392 >> 0] = 1;
      i9 = i5;
      i8 = i3;
      i2 = i4;
     } else {
      i9 = i5;
      i8 = i3;
      i2 = i4;
     }
    } else i11 = 47;
   }
  }
 } while (0);
 if ((i11 | 0) == 47) if (!i2) i11 = 50; else {
  i9 = i1 + 10 | 0;
  i8 = i3;
 }
 if ((i11 | 0) == 50) {
  i27 = i1 + 10 | 0;
  HEAP16[i27 >> 1] = HEAP16[i27 >> 1] | 2;
  STACKTOP = i28;
  return;
 }
 i4 = (HEAPU16[i9 >> 1] | 0) >>> 5 << 4;
 i2 = i2 + i4 | 0;
 i6 = i23 + 40 | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i17 | 0)) {
  i9 = HEAPU16[i23 + 64 >> 1] | 0;
  i23 = i2 + (i9 << 5) + 22 | 0;
  HEAP16[i23 >> 1] = HEAPU16[i23 >> 1] | i25;
  i23 = i2 + (i9 << 5) + 20 | 0;
  HEAP16[i23 >> 1] = HEAP16[i23 >> 1] | i22;
  i9 = i2 + (i9 << 5) | 0;
 } else {
  i7 = i1 + 6 | 0;
  i3 = HEAP16[i7 >> 1] | 0;
  i5 = i3 & 65535;
  do if ((i3 & 65535) < (HEAPU16[i1 + 4 >> 1] | 0)) i1 = i2 + (i5 << 5) | 0; else {
   i1 = __ZN5physx2Sc10NPhaseCore27resizeContactReportPairDataEjjRNS0_20ContactStreamManagerE(i18, i5 + 1 + (i5 >>> 1) | 0, i4, i8) | 0;
   i2 = HEAP16[i9 >> 1] | 0;
   if (i1 | 0) {
    i18 = HEAP16[i7 >> 1] | 0;
    i3 = i18;
    i1 = i1 + ((i2 & 65535) >>> 5 << 4) + ((i18 & 65535) << 5) | 0;
    break;
   }
   HEAP16[i9 >> 1] = i2 | 4;
   STACKTOP = i28;
   return;
  } while (0);
  HEAP16[i23 + 64 >> 1] = i3;
  HEAP32[i1 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i20 + 28 >> 2] | 0) | 0;
  HEAP32[i1 + 4 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i19 + 28 >> 2] | 0) | 0;
  i9 = i1 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP16[i1 + 20 >> 1] = i22;
  HEAP16[i1 + 22 >> 1] = i25;
  HEAP32[i1 + 24 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i19 + 20 >> 2];
  HEAP16[i7 >> 1] = (HEAP16[i7 >> 1] | 0) + 1 << 16 >> 16;
  HEAP32[i6 >> 2] = i17;
  i9 = i1;
 }
 i8 = HEAP32[i21 >> 2] | 0;
 if (!(i8 & 512)) {
  STACKTOP = i28;
  return;
 }
 i1 = HEAP32[i24 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i7 = i9 + 8 | 0;
 if (!((i25 & 272 | 0) == 0 & (HEAP32[i7 >> 2] | 0) == 0)) {
  STACKTOP = i28;
  return;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 i2 = (HEAP16[i1 + 114 >> 1] & 16) == 0 ? 0 : i4 + (i5 + 15 & -16) | 0;
 i1 = HEAPU16[i1 + 36 >> 1] | 0;
 if (i26 | (i5 | 0) == 0) {
  if (!i3) {
   STACKTOP = i28;
   return;
  }
  if ((HEAP16[i3 + 6 >> 1] | 0) != 0 | i26 ^ 1) {
   STACKTOP = i28;
   return;
  }
 }
 if (i26) {
  i1 = i3 + 8 | 0;
  i3 = HEAPU16[i3 + 4 >> 1] | 0;
  i2 = (i3 + 15 & 131056) + -8 | 0;
  i6 = i2;
  i4 = i1;
  i3 = i3 + -8 | 0;
  i2 = i1 + i2 | 0;
  i1 = 1;
 } else {
  i6 = i5 + 15 & -16;
  i3 = i5;
 }
 i26 = i9 + 20 | 0;
 i27 = HEAPU16[i26 >> 1] | (i27 ? 0 : 64) | i8 >>> 22 & 16;
 i25 = i2 | 0 ? i1 << 2 : 0;
 HEAP32[i7 >> 2] = i4;
 HEAP16[i9 + 16 >> 1] = i1;
 HEAP16[i9 + 18 >> 1] = i3;
 HEAP32[i9 + 12 >> 2] = i25 + i6;
 HEAP16[i26 >> 1] = (i25 | 0) == 0 ? i27 : i27 | 32;
 STACKTOP = i28;
 return;
}

function __ZN5physx21PxcFsApplyJointDrivesERNS_9PxcFsDataEPKNS_6shdfnd3aos5Vec3VE(i17, i10) {
 i17 = i17 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 5184 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i20 + 3136 | 0;
 i19 = i20 + 1088 | 0;
 i16 = i20 + 64 | 0;
 i8 = i20 + 32 | 0;
 i12 = i20;
 i9 = i17 + 26 | 0;
 i1 = HEAP16[i9 >> 1] | 0;
 i15 = i17 + ((i1 & 65535) + 144) | 0;
 i18 = i17 + 8 | 0;
 i7 = HEAP16[i18 >> 1] | 0;
 i2 = i7 & 65535;
 i13 = i17 + ((i2 * 432 | 0) + (HEAPU16[i17 + 24 >> 1] | 0)) | 0;
 i14 = i17 + (HEAPU16[i17 + 10 >> 1] | 0) | 0;
 _memset(i11 | 0, 0, i2 << 5 | 0) | 0;
 if ((i7 & 65535) > 1) {
  i3 = i8 + 4 | 0;
  i4 = i8 + 8 | 0;
  i5 = i8 + 16 | 0;
  i6 = i8 + 20 | 0;
  i7 = i8 + 24 | 0;
  i1 = i2;
  do {
   i1 = i1 + -1 | 0;
   i2 = HEAPU8[i17 + 64 + i1 >> 0] | 0;
   __ZN5physx22propagateDrivenImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKS8_(i8, i15 + (i1 * 160 | 0) | 0, i14 + (i1 << 5) | 0, i16 + (i1 << 4) | 0, i11 + (i1 << 5) | 0, i10 + (i1 << 4) | 0);
   i21 = i11 + (i2 << 5) | 0;
   f26 = Math_fround(HEAPF32[i21 >> 2]);
   i23 = i11 + (i2 << 5) + 4 | 0;
   f24 = Math_fround(HEAPF32[i23 >> 2]);
   i25 = i11 + (i2 << 5) + 8 | 0;
   f27 = Math_fround(HEAPF32[i25 >> 2]);
   f22 = Math_fround(HEAPF32[i8 >> 2]);
   f28 = Math_fround(HEAPF32[i3 >> 2]);
   f28 = Math_fround(f24 + f28);
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 >> 2]));
   HEAPF32[i21 >> 2] = Math_fround(f26 + f22);
   HEAPF32[i23 >> 2] = f28;
   HEAPF32[i25 >> 2] = f27;
   HEAPF32[i11 + (i2 << 5) + 12 >> 2] = Math_fround(0.0);
   i25 = i11 + (i2 << 5) + 16 | 0;
   f27 = Math_fround(HEAPF32[i25 >> 2]);
   i23 = i11 + (i2 << 5) + 20 | 0;
   f28 = Math_fround(HEAPF32[i23 >> 2]);
   i21 = i11 + (i2 << 5) + 24 | 0;
   f22 = Math_fround(HEAPF32[i21 >> 2]);
   f26 = Math_fround(HEAPF32[i5 >> 2]);
   f24 = Math_fround(HEAPF32[i6 >> 2]);
   f24 = Math_fround(f28 + f24);
   f22 = Math_fround(f22 + Math_fround(HEAPF32[i7 >> 2]));
   HEAPF32[i25 >> 2] = Math_fround(f27 + f26);
   HEAPF32[i23 >> 2] = f24;
   HEAPF32[i21 >> 2] = f22;
   HEAPF32[i11 + (i2 << 5) + 28 >> 2] = Math_fround(0.0);
  } while (i1 >>> 0 > 1);
  i1 = HEAP16[i9 >> 1] | 0;
 }
 i1 = i1 & 65535;
 f36 = Math_fround(HEAPF32[i11 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f36 = Math_fround(-f36);
 f27 = Math_fround(-f27);
 f31 = Math_fround(-Math_fround(HEAPF32[i11 + 8 >> 2]));
 f34 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f30 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f34 = Math_fround(-f34);
 f30 = Math_fround(-f30);
 f28 = Math_fround(-Math_fround(HEAPF32[i11 + 24 >> 2]));
 f44 = Math_fround(Math_fround(HEAPF32[i17 + i1 >> 2]) * f36);
 f44 = Math_fround(f44 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 16) >> 2]) * f27));
 f44 = Math_fround(f44 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 32) >> 2]) * f31));
 f43 = Math_fround(Math_fround(HEAPF32[i17 + (i1 + 4) >> 2]) * f36);
 f43 = Math_fround(f43 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 20) >> 2]) * f27));
 f43 = Math_fround(f43 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 36) >> 2]) * f31));
 f42 = Math_fround(Math_fround(HEAPF32[i17 + (i1 + 8) >> 2]) * f36);
 f42 = Math_fround(f42 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 24) >> 2]) * f27));
 f42 = Math_fround(f42 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 40) >> 2]) * f31));
 f41 = Math_fround(HEAPF32[i17 + (i1 + 48) >> 2]);
 f29 = Math_fround(f41 * f34);
 f39 = Math_fround(HEAPF32[i17 + (i1 + 64) >> 2]);
 f29 = Math_fround(f29 + Math_fround(f39 * f30));
 f37 = Math_fround(HEAPF32[i17 + (i1 + 80) >> 2]);
 f29 = Math_fround(f29 + Math_fround(f37 * f28));
 f40 = Math_fround(HEAPF32[i17 + (i1 + 52) >> 2]);
 f22 = Math_fround(f40 * f34);
 f38 = Math_fround(HEAPF32[i17 + (i1 + 68) >> 2]);
 f22 = Math_fround(f22 + Math_fround(f38 * f30));
 f35 = Math_fround(HEAPF32[i17 + (i1 + 84) >> 2]);
 f22 = Math_fround(f22 + Math_fround(f35 * f28));
 f33 = Math_fround(HEAPF32[i17 + (i1 + 56) >> 2]);
 f24 = Math_fround(f33 * f34);
 f32 = Math_fround(HEAPF32[i17 + (i1 + 72) >> 2]);
 f24 = Math_fround(f24 + Math_fround(f32 * f30));
 f26 = Math_fround(HEAPF32[i17 + (i1 + 88) >> 2]);
 f29 = Math_fround(f44 + f29);
 f22 = Math_fround(f43 + f22);
 f24 = Math_fround(f42 + Math_fround(f24 + Math_fround(f26 * f28)));
 f33 = Math_fround(Math_fround(Math_fround(f41 * f36) + Math_fround(f40 * f27)) + Math_fround(f33 * f31));
 f32 = Math_fround(Math_fround(Math_fround(f39 * f36) + Math_fround(f38 * f27)) + Math_fround(f32 * f31));
 f31 = Math_fround(Math_fround(Math_fround(f37 * f36) + Math_fround(f35 * f27)) + Math_fround(f26 * f31));
 f26 = Math_fround(Math_fround(HEAPF32[i17 + (i1 + 96) >> 2]) * f34);
 f26 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 112) >> 2]) * f30));
 f26 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 128) >> 2]) * f28));
 f27 = Math_fround(Math_fround(HEAPF32[i17 + (i1 + 100) >> 2]) * f34);
 f27 = Math_fround(f27 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 116) >> 2]) * f30));
 f27 = Math_fround(f27 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 132) >> 2]) * f28));
 f34 = Math_fround(Math_fround(HEAPF32[i17 + (i1 + 104) >> 2]) * f34);
 f30 = Math_fround(f34 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 120) >> 2]) * f30));
 f26 = Math_fround(f33 + f26);
 f27 = Math_fround(f32 + f27);
 f28 = Math_fround(f31 + Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i17 + (i1 + 136) >> 2]) * f28)));
 HEAPF32[i19 >> 2] = f29;
 HEAPF32[i19 + 4 >> 2] = f22;
 HEAPF32[i19 + 8 >> 2] = f24;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 16 >> 2] = f26;
 HEAPF32[i19 + 20 >> 2] = f27;
 HEAPF32[i19 + 24 >> 2] = f28;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP16[i18 >> 1] | 0;
 if ((i1 & 65535) > 1) {
  i2 = i12 + 16 | 0;
  i3 = 1;
  do {
   i1 = i19 + (i3 << 5) | 0;
   __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i12, i15 + (i3 * 160 | 0) | 0, i14 + (i3 << 5) | 0, i16 + (i3 << 4) | 0, i19 + ((HEAPU8[i17 + 64 + i3 >> 0] | 0) << 5) | 0, i13 + (i3 * 96 | 0) | 0);
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i1 = i19 + (i3 << 5) + 16 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i3 = i3 + 1 | 0;
   i1 = HEAP16[i18 >> 1] | 0;
  } while (i3 >>> 0 < (i1 & 65535) >>> 0);
 }
 i2 = i17 + 128 | 0;
 if (!(i1 << 16 >> 16)) {
  STACKTOP = i20;
  return;
 } else i1 = 0;
 do {
  i25 = i2 + (i1 << 5) | 0;
  f42 = Math_fround(HEAPF32[i25 >> 2]);
  i23 = i2 + (i1 << 5) + 4 | 0;
  f43 = Math_fround(HEAPF32[i23 >> 2]);
  i21 = i2 + (i1 << 5) + 8 | 0;
  f41 = Math_fround(HEAPF32[i21 >> 2]);
  f44 = Math_fround(HEAPF32[i19 + (i1 << 5) >> 2]);
  f40 = Math_fround(HEAPF32[i19 + (i1 << 5) + 4 >> 2]);
  f40 = Math_fround(f43 + f40);
  f41 = Math_fround(f41 + Math_fround(HEAPF32[i19 + (i1 << 5) + 8 >> 2]));
  HEAPF32[i25 >> 2] = Math_fround(f42 + f44);
  HEAPF32[i23 >> 2] = f40;
  HEAPF32[i21 >> 2] = f41;
  HEAPF32[i2 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
  i21 = i2 + (i1 << 5) + 16 | 0;
  f41 = Math_fround(HEAPF32[i21 >> 2]);
  i23 = i2 + (i1 << 5) + 20 | 0;
  f40 = Math_fround(HEAPF32[i23 >> 2]);
  i25 = i2 + (i1 << 5) + 24 | 0;
  f44 = Math_fround(HEAPF32[i25 >> 2]);
  f42 = Math_fround(HEAPF32[i19 + (i1 << 5) + 16 >> 2]);
  f43 = Math_fround(HEAPF32[i19 + (i1 << 5) + 20 >> 2]);
  f43 = Math_fround(f40 + f43);
  f44 = Math_fround(f44 + Math_fround(HEAPF32[i19 + (i1 << 5) + 24 >> 2]));
  HEAPF32[i21 >> 2] = Math_fround(f41 + f42);
  HEAPF32[i23 >> 2] = f43;
  HEAPF32[i25 >> 2] = f44;
  HEAPF32[i2 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAPU16[i18 >> 1] | 0) >>> 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx2Sc10NPhaseCoreD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb(i6, 0);
 i1 = i6 + 2512 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 if (HEAP32[i6 + 2496 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i6 + 2216 | 0);
 i4 = i6 + 2480 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i6 + 2484 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i8 = HEAP32[i6 + 2488 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i6 + 2220 | 0) == (i1 | 0)) {
   HEAP8[i6 + 2476 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 2200 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 1920 | 0);
 i3 = i6 + 2184 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 2188 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 2192 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 1924 | 0) == (i1 | 0)) {
   HEAP8[i6 + 2180 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 1904 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 1624 | 0);
 i3 = i6 + 1888 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 1892 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1896 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 1628 | 0) == (i1 | 0)) {
   HEAP8[i6 + 1884 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 1608 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 1328 | 0);
 i3 = i6 + 1592 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 1596 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1600 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 1332 | 0) == (i1 | 0)) {
   HEAP8[i6 + 1588 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 1312 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 1032 | 0);
 i3 = i6 + 1296 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 1300 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1304 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 1036 | 0) == (i1 | 0)) {
   HEAP8[i6 + 1292 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 1016 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 736 | 0);
 i3 = i6 + 1e3 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 1004 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 1008 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 740 | 0) == (i1 | 0)) {
   HEAP8[i6 + 996 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 if (HEAP32[i6 + 720 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 440 | 0);
 i3 = i6 + 704 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 708 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 712 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 444 | 0) == (i1 | 0)) {
   HEAP8[i6 + 700 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 if (HEAP32[i6 + 424 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i6 + 144 | 0);
 i3 = i6 + 408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 412 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 416 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 148 | 0) == (i1 | 0)) {
   HEAP8[i6 + 404 >> 0] = 0;
   break;
  }
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EED2Ev(i6 + 108 | 0);
 i1 = i6 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i6 + 44 >> 2] | 0);
 i8 = HEAP32[i6 + 40 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i6 + 24 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 16 >> 2] | 0;
  if (!i1) break;
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 } while (0);
 i8 = HEAP32[i6 + 12 >> 2] | 0;
 if (!((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_(i1, i11, i13, i14, i15, i16, i17) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f18 = f0, f19 = f0, f20 = f0;
 i9 = (i11 & 983040 | 0) == 65536 & 0 == 0;
 i10 = (i14 & 983040 | 0) == 65536 & 0 == 0;
 i12 = HEAP32[i1 >> 2] | 0;
 if (!(i9 | i10)) {
  if ((i11 | 0) == 0 & (i13 | 0) == 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i5 = _bitshift64Lshr(i11 | 0, i13 | 0, 20) | 0;
  getTempRet0() | 0;
  i5 = i5 & 268435455;
  i6 = i11 & 65535;
  i2 = HEAP32[i12 + 16 >> 2] | 0;
  if (i5 >>> 0 >= i2 >>> 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i4 = _bitshift64Lshr(i11 | 0, i13 | 0, 48) | 0;
  getTempRet0() | 0;
  i7 = HEAP32[i12 + 20 >> 2] | 0;
  if ((HEAP32[i7 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i1 = HEAP32[i7 + (i5 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i17 = -2147483640;
   return i17 | 0;
  }
  if (i6 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i4 = HEAP32[i7 + (i5 * 56 | 0) + 16 >> 2] | 0;
  if ((i14 | 0) == 0 & (i15 | 0) == 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i1 = _bitshift64Lshr(i14 | 0, i15 | 0, 20) | 0;
  getTempRet0() | 0;
  i1 = i1 & 268435455;
  if (i1 >>> 0 >= i2 >>> 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i3 = _bitshift64Lshr(i14 | 0, i15 | 0, 48) | 0;
  getTempRet0() | 0;
  if ((HEAP32[i7 + (i1 * 56 | 0) + 4 >> 2] | 0) != (i3 | 0)) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i1 = HEAP32[i7 + (i1 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i17 = -2147483640;
   return i17 | 0;
  }
  if ((i14 & 65535) >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i1 = HEAP32[(HEAP32[i7 + (i5 * 56 | 0) + 12 >> 2] | 0) + (i4 + (i6 << 5) - (HEAP32[i7 + (i5 * 56 | 0) + 16 >> 2] | 0) >> 5 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i1 = (HEAP32[i12 + 36 >> 2] | 0) + (i1 << 4) | 0;
  if (!i1) {
   i17 = -2147483640;
   return i17 | 0;
  }
  i3 = i12 + 36 | 0;
  while (1) {
   i2 = i1;
   if ((HEAP32[i2 >> 2] | 0) == (i14 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i15 | 0) : 0) {
    i2 = 44;
    break;
   }
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i8 = -2147483640;
    i2 = 27;
    break;
   }
   i2 = (HEAP32[i3 >> 2] | 0) + (i2 << 4) | 0;
   if (!i2) {
    i8 = -2147483640;
    i2 = 27;
    break;
   } else i1 = i2;
  }
  if ((i2 | 0) == 27) return i8 | 0; else if ((i2 | 0) == 44) {
   i15 = HEAP32[i1 + 12 >> 2] | 0;
   i1 = i15 & 255;
   i8 = i1 + 1 | 0;
   i8 = HEAPU16[i4 + (i6 << 5) + (((i8 | 0) == (HEAPU8[i4 + (i6 << 5) + 28 >> 0] | 0 | 0) ? 0 : i8) << 1) >> 1] | 0;
   i7 = HEAP32[i7 + (i5 * 56 | 0) + 20 >> 2] | 0;
   i1 = i7 + ((HEAPU16[i4 + (i6 << 5) + (i1 << 1) >> 1] | 0) * 3 << 2) | 0;
   HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
   i2 = i1 + 4 | 0;
   i3 = i16 + 4 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i4 = i1 + 8 | 0;
   i5 = i16 + 8 | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   i6 = i7 + (i8 * 3 << 2) | 0;
   HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
   i7 = i6 + 4 | 0;
   i8 = i17 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   i9 = i6 + 8 | 0;
   i10 = i17 + 8 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   i11 = i15 >>> 16 & 255;
   i12 = i15 >>> 24 & 255;
   if ((i15 & 65280 | 0) == 65280) {
    i17 = 1073741824;
    return i17 | 0;
   }
   if (i11 << 24 >> 24 == 0 & i12 << 24 >> 24 == -1) {
    i17 = 1073741824;
    return i17 | 0;
   }
   f20 = Math_fround(Math_fround(i11 & 255) * Math_fround(.00392156886));
   i15 = f20 > Math_fround(0.0);
   f20 = i15 ? f20 : Math_fround(0.0);
   f19 = Math_fround(Math_fround(i12 & 255) * Math_fround(.00392156886));
   i15 = f19 < Math_fround(1.0);
   f19 = i15 ? f19 : Math_fround(1.0);
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   HEAPF32[i16 >> 2] = Math_fround(f18 + Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f18)));
   f18 = Math_fround(HEAPF32[i2 >> 2]);
   HEAPF32[i3 >> 2] = Math_fround(f18 + Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f18)));
   f18 = Math_fround(HEAPF32[i4 >> 2]);
   HEAPF32[i5 >> 2] = Math_fround(f18 + Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f18)));
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   HEAPF32[i17 >> 2] = Math_fround(f18 + Math_fround(f19 * Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f18)));
   f18 = Math_fround(HEAPF32[i2 >> 2]);
   HEAPF32[i8 >> 2] = Math_fround(f18 + Math_fround(f19 * Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f18)));
   f18 = Math_fround(HEAPF32[i4 >> 2]);
   HEAPF32[i10 >> 2] = Math_fround(f18 + Math_fround(f19 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f18)));
   i17 = 1073741824;
   return i17 | 0;
  }
 }
 do if (i9) {
  i1 = i11 & 65535;
  if (i1 >>> 0 > (HEAP32[i12 + 44 >> 2] | 0) >>> 0) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i7 = _bitshift64Lshr(i11 | 0, i13 | 0, 48) | 0;
  getTempRet0() | 0;
  i2 = HEAP32[i12 + 48 >> 2] | 0;
  if ((i2 + (i1 * 104 | 0) | 0) == 0 ? 1 : (i7 | 0) != (HEAP32[i2 + (i1 * 104 | 0) + 92 >> 2] | 0)) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i1 = HEAP32[i2 + (i1 * 104 | 0) + 88 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i17 = -2147483648;
   return i17 | 0;
  } else {
   i1 = (HEAP32[i12 + 36 >> 2] | 0) + (i1 << 4) | 0;
   break;
  }
 } else {
  if ((i11 | 0) == 0 & (i13 | 0) == 0) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i1 = _bitshift64Lshr(i11 | 0, i13 | 0, 20) | 0;
  getTempRet0() | 0;
  i1 = i1 & 268435455;
  i2 = i11 & 65535;
  if (i1 >>> 0 >= (HEAP32[i12 + 16 >> 2] | 0) >>> 0) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i7 = _bitshift64Lshr(i11 | 0, i13 | 0, 48) | 0;
  getTempRet0() | 0;
  i3 = HEAP32[i12 + 20 >> 2] | 0;
  if ((HEAP32[i3 + (i1 * 56 | 0) + 4 >> 2] | 0) != (i7 | 0)) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i4 = HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] | 0;
  if (!i4) {
   i17 = -2147483648;
   return i17 | 0;
  }
  if (i2 >>> 0 >= (HEAP32[i4 + 20 >> 2] | 0) >>> 0) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i1 = HEAP32[(HEAP32[i3 + (i1 * 56 | 0) + 12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i17 = -2147483648;
   return i17 | 0;
  } else {
   i1 = (HEAP32[i12 + 36 >> 2] | 0) + (i1 << 4) | 0;
   break;
  }
 } while (0);
 if (!i1) {
  i17 = -2147483648;
  return i17 | 0;
 }
 i3 = i12 + 36 | 0;
 while (1) {
  i7 = i1;
  if ((HEAP32[i7 >> 2] | 0) == (i14 | 0) ? (HEAP32[i7 + 4 >> 2] | 0) == (i15 | 0) : 0) {
   i2 = 17;
   break;
  }
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if ((i2 | 0) == -1) {
   i8 = -2147483648;
   i2 = 27;
   break;
  }
  i2 = (HEAP32[i3 >> 2] | 0) + (i2 << 4) | 0;
  if (!i2) {
   i8 = -2147483648;
   i2 = 27;
   break;
  } else i1 = i2;
 }
 if ((i2 | 0) == 17) {
  i2 = HEAPU8[i1 + 12 >> 0] | 0;
  if (i9) {
   i1 = i11 & 65535;
   if (i1 >>> 0 > (HEAP32[i12 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
    i14 = _bitshift64Lshr(i11 | 0, i13 | 0, 48) | 0;
    getTempRet0() | 0;
    i15 = HEAP32[i12 + 48 >> 2] | 0;
    i1 = (i14 | 0) == (HEAP32[i15 + (i1 * 104 | 0) + 92 >> 2] | 0) ? i15 + (i1 * 104 | 0) | 0 : 0;
   }
   i13 = i1 + (i2 << 5) + 12 | 0;
   HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
   i14 = i1 + (i2 << 5) + 16 | 0;
   HEAP32[i16 + 4 >> 2] = HEAP32[i14 >> 2];
   i15 = i1 + (i2 << 5) + 20 | 0;
   HEAP32[i16 + 8 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i15 >> 2];
   i17 = 1073741824;
   return i17 | 0;
  }
  if (!i10) {
   i17 = -2147483648;
   return i17 | 0;
  }
  i1 = i14 & 65535;
  if (i1 >>> 0 > (HEAP32[i12 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
   i14 = _bitshift64Lshr(i14 | 0, i15 | 0, 48) | 0;
   getTempRet0() | 0;
   i15 = HEAP32[i12 + 48 >> 2] | 0;
   i1 = (i14 | 0) == (HEAP32[i15 + (i1 * 104 | 0) + 92 >> 2] | 0) ? i15 + (i1 * 104 | 0) | 0 : 0;
  }
  i13 = i1 + (i2 << 5) + 12 | 0;
  HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
  i14 = i1 + (i2 << 5) + 16 | 0;
  HEAP32[i16 + 4 >> 2] = HEAP32[i14 >> 2];
  i15 = i1 + (i2 << 5) + 20 | 0;
  HEAP32[i16 + 8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i15 >> 2];
  i17 = 1073741824;
  return i17 | 0;
 } else if ((i2 | 0) == 27) return i8 | 0;
 return 0;
}

function __ZN5Unity11SpringJoint8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN5Unity5Joint22JointTransferPreNoAxisI14SafeBinaryReadEEvRT_(i7, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i4 = i7 + 104 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 738014 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 738023 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864216 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864230 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 738032 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800780 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800793 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 88 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800723 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 89 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 738044 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZL9refitNodePN5physx2Sq12AABBTreeNodeEjPKNS_9PxBounds3EPjRS2_S7_RNS_6shdfnd3aos7VecU32VERNS9_5Vec3VESD_SD_SD_SD_(i24, i14, i23, i21, i22, i29, i2, i13, i28, i27, i25, i26) {
 i24 = i24 | 0;
 i14 = i14 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i29 = i29 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i13 + 4 >> 2] | 0;
  i6 = HEAP32[i13 + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = i5;
  HEAP32[i1 + 8 >> 2] = i6;
  i6 = i1 + 16 | 0;
  i5 = i6;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] & 255;
  i3 = _bitshift64Shl((HEAP32[i2 + 4 >> 2] | 0) >>> 8 | 0, 0, 40) | 0;
  i5 = getTempRet0() | 0 | i5;
  HEAP32[i6 >> 2] = i3 | i4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i22 >> 2] = 0;
 }
 if (HEAP32[i29 >> 2] | 0) {
  f8 = Math_fround(HEAPF32[i28 >> 2]);
  f10 = Math_fround(HEAPF32[i28 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i28 + 8 >> 2]);
  f17 = Math_fround(HEAPF32[i27 >> 2]);
  f11 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  i1 = f8 > Math_fround(-9999999940000000065998519.0e8);
  f8 = i1 ? f8 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f10 > Math_fround(-9999999940000000065998519.0e8);
  f10 = i1 ? f10 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f12 > Math_fround(-9999999940000000065998519.0e8);
  f12 = i1 ? f12 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f17 < Math_fround(9999999940000000065998519.0e8);
  f17 = i1 ? f17 : Math_fround(9999999940000000065998519.0e8);
  i1 = f11 < Math_fround(9999999940000000065998519.0e8);
  f11 = i1 ? f11 : Math_fround(9999999940000000065998519.0e8);
  i1 = f9 < Math_fround(9999999940000000065998519.0e8);
  f9 = i1 ? f9 : Math_fround(9999999940000000065998519.0e8);
  f19 = Math_fround(Math_fround(f8 + f17) * Math_fround(.5));
  f20 = Math_fround(Math_fround(f10 + f11) * Math_fround(.5));
  f7 = Math_fround(Math_fround(f12 + f9) * Math_fround(.5));
  f8 = Math_fround(Math_fround(f17 - f8) * Math_fround(.5));
  f10 = Math_fround(Math_fround(f11 - f10) * Math_fround(.5));
  f12 = Math_fround(Math_fround(f9 - f12) * Math_fround(.5));
  f9 = Math_fround(f19 * Math_fround(.0000999999974));
  f11 = Math_fround(f20 * Math_fround(.0000999999974));
  f17 = Math_fround(f7 * Math_fround(.0000999999974));
  f15 = Math_fround(-f9);
  f16 = Math_fround(-f11);
  f18 = Math_fround(-f17);
  f15 = Math_fround(f8 + Math_fround((f9 > f15 ? f9 : f15) + Math_fround(.0000999999974)));
  f16 = Math_fround(f10 + Math_fround((f11 > f16 ? f11 : f16) + Math_fround(.0000999999974)));
  f18 = Math_fround(f12 + Math_fround((f17 > f18 ? f17 : f18) + Math_fround(.0000999999974)));
  f17 = f16 > f18 ? f16 : f18;
  f17 = Math_fround((f15 > f17 ? f15 : f17) * Math_fround(.00392158423));
  f12 = Math_fround(Math_fround(f17 + Math_fround(f17 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
  HEAPF32[i2 >> 2] = f12;
  HEAPF32[i2 + 4 >> 2] = f12;
  HEAPF32[i2 + 8 >> 2] = f12;
  HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i1 = ~~Math_fround(Math_fround(f17 * f15) + Math_fround(1.0));
  i2 = ~~Math_fround(Math_fround(f17 * f16) + Math_fround(1.0));
  i31 = ~~Math_fround(Math_fround(f17 * f18) + Math_fround(1.0));
  i3 = f19 == Math_fround(0.0);
  i4 = f20 == Math_fround(0.0);
  i30 = f7 == Math_fround(0.0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i31 = i31 | (i30 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) & -256);
  HEAP32[i13 >> 2] = i1 | (i3 ? 16777216 : i5 & -256);
  HEAP32[i13 + 4 >> 2] = i2 | (i4 ? 16777216 : i6 & -256);
  HEAP32[i13 + 8 >> 2] = i31;
  HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i25 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i29 >> 2] = 0;
 }
 i13 = i24 + (i14 * 24 | 0) | 0;
 i3 = i24 + (i14 * 24 | 0) + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = _bitshift64Lshr(i1 | 0, HEAP32[i3 + 4 >> 2] | 0, 21) | 0;
 getTempRet0() | 0;
 i3 = i3 & 524287;
 if (!((i1 & 1 | 0) == 0 & 0 == 0)) {
  if ((i1 & 2 | 0) == 0 & 0 == 0) {
   i2 = 1967470361;
   i3 = 1967470361;
   i4 = 1967470361;
   i5 = -180013287;
   i6 = -180013287;
   i1 = -180013287;
  } else {
   i1 = HEAP32[i21 + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[i23 + (i1 * 24 | 0) >> 2] | 0;
   i3 = HEAP32[i23 + (i1 * 24 | 0) + 4 >> 2] | 0;
   i4 = HEAP32[i23 + (i1 * 24 | 0) + 8 >> 2] | 0;
   i5 = HEAP32[i23 + (i1 * 24 | 0) + 12 >> 2] | 0;
   i6 = HEAP32[i23 + (i1 * 24 | 0) + 16 >> 2] | 0;
   i1 = HEAP32[i23 + (i1 * 24 | 0) + 20 >> 2] | 0;
  }
  HEAP32[i28 >> 2] = i2;
  HEAP32[i28 + 4 >> 2] = i3;
  HEAP32[i28 + 8 >> 2] = i4;
  HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i27 >> 2] = i5;
  HEAP32[i27 + 4 >> 2] = i6;
  HEAP32[i27 + 8 >> 2] = i1;
  HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i29 >> 2] = i13;
  return;
 }
 i1 = i24 + (i3 * 24 | 0) | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  f15 = Math_fround(HEAPF32[i25 >> 2]);
  f16 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i26 >> 2]);
  f19 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 } else {
  i23 = HEAP32[i1 >> 2] | 0;
  i30 = HEAP32[i24 + (i3 * 24 | 0) + 4 >> 2] | 0;
  i31 = HEAP32[i24 + (i3 * 24 | 0) + 8 >> 2] | 0;
  f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i24 + (i3 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f18 = Math_fround(Math_fround(i23 & 255 | 0) * f20);
  f19 = Math_fround(Math_fround(i30 & 255 | 0) * f20);
  f20 = Math_fround(Math_fround(i31 & 255 | 0) * f20);
  f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f10 - f18);
  f11 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f11 - f19);
  f12 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = Math_fround(f12 - f20);
  f18 = Math_fround(f10 + f18);
  f19 = Math_fround(f11 + f19);
  f20 = Math_fround(f12 + f20);
 }
 i1 = i3 | 0 ? i24 + ((i3 + 1 | 0) * 24 | 0) | 0 : i24;
 if ((i1 | 0) == (i2 | 0)) {
  f8 = Math_fround(HEAPF32[i25 >> 2]);
  f9 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f10 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i26 >> 2]);
  f12 = Math_fround(HEAPF32[i26 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 } else {
  i26 = HEAP32[i1 >> 2] | 0;
  i30 = HEAP32[i1 + 4 >> 2] | 0;
  i31 = HEAP32[i1 + 8 >> 2] | 0;
  f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i1 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f11 = Math_fround(Math_fround(i26 & 255 | 0) * f7);
  f12 = Math_fround(Math_fround(i30 & 255 | 0) * f7);
  f7 = Math_fround(Math_fround(i31 & 255 | 0) * f7);
  f34 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(f34 - f11);
  f33 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = Math_fround(f33 - f12);
  f32 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f32 - f7);
  f11 = Math_fround(f34 + f11);
  f12 = Math_fround(f33 + f12);
  f7 = Math_fround(f32 + f7);
 }
 HEAPF32[i28 >> 2] = f8 < f15 ? f8 : f15;
 HEAPF32[i28 + 4 >> 2] = f9 < f16 ? f9 : f16;
 HEAPF32[i28 + 8 >> 2] = f10 < f17 ? f10 : f17;
 HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i27 >> 2] = f11 > f18 ? f11 : f18;
 HEAPF32[i27 + 4 >> 2] = f12 > f19 ? f12 : f19;
 HEAPF32[i27 + 8 >> 2] = f7 > f20 ? f7 : f20;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i29 >> 2] = i13;
 return;
}

function __ZN27NoiseModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 617165 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617165 + 27 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617193 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617193 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617222 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617222 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617251 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617251 + 21 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617273 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617273 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100001;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617293 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617293 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 5;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617322 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617322 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 6;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617346 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617346 + 30 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 7;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617377 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617377 + 24 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617402 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617402 + 25 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617428 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617428 + 25 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 10;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN15b2ContactSolver29InitializeVelocityConstraintsEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, i51 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i41 + 48 | 0;
 i35 = i41 + 32 | 0;
 i36 = i41;
 i37 = i1 + 48 | 0;
 if ((HEAP32[i37 >> 2] | 0) <= 0) {
  STACKTOP = i41;
  return;
 }
 i38 = i1 + 40 | 0;
 i39 = i1 + 36 | 0;
 i40 = i1 + 44 | 0;
 i34 = i1 + 24 | 0;
 i26 = i1 + 28 | 0;
 i27 = i33 + 8 | 0;
 i28 = i33 + 12 | 0;
 i29 = i35 + 8 | 0;
 i30 = i35 + 12 | 0;
 i25 = i33 + 4 | 0;
 i24 = i35 + 4 | 0;
 i23 = 0;
 do {
  i31 = HEAP32[i38 >> 2] | 0;
  i32 = HEAP32[i39 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 76 >> 2]);
  f3 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 80 >> 2]);
  i20 = (HEAP32[(HEAP32[i40 >> 2] | 0) + (HEAP32[i31 + (i23 * 156 | 0) + 152 >> 2] << 2) >> 2] | 0) + 64 | 0;
  i8 = HEAP32[i31 + (i23 * 156 | 0) + 112 >> 2] | 0;
  i9 = HEAP32[i31 + (i23 * 156 | 0) + 116 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 120 >> 2]);
  f5 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 124 >> 2]);
  f21 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 128 >> 2]);
  f22 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 132 >> 2]);
  f50 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 48 >> 2]);
  f48 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 52 >> 2]);
  f46 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 56 >> 2]);
  f44 = Math_fround(HEAPF32[i32 + (i23 * 88 | 0) + 60 >> 2]);
  i32 = HEAP32[i34 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i32 + (i8 * 12 | 0) >> 2]);
  f11 = Math_fround(HEAPF32[i32 + (i8 * 12 | 0) + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i32 + (i8 * 12 | 0) + 8 >> 2]);
  i6 = HEAP32[i26 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i6 + (i8 * 12 | 0) >> 2]);
  f13 = Math_fround(HEAPF32[i6 + (i8 * 12 | 0) + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i6 + (i8 * 12 | 0) + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) >> 2]);
  f16 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) + 4 >> 2]);
  f45 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) + 8 >> 2]);
  f17 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i6 + (i9 * 12 | 0) + 8 >> 2]);
  f47 = Math_fround(+Math_sin(+f49));
  HEAPF32[i27 >> 2] = f47;
  f49 = Math_fround(+Math_cos(+f49));
  HEAPF32[i28 >> 2] = f49;
  f43 = Math_fround(+Math_sin(+f45));
  HEAPF32[i29 >> 2] = f43;
  f45 = Math_fround(+Math_cos(+f45));
  HEAPF32[i30 >> 2] = f45;
  f42 = Math_fround(f11 - Math_fround(Math_fround(f48 * f49) + Math_fround(f50 * f47)));
  HEAPF32[i33 >> 2] = Math_fround(f10 - Math_fround(Math_fround(f50 * f49) - Math_fround(f48 * f47)));
  HEAPF32[i25 >> 2] = f42;
  f42 = Math_fround(f16 - Math_fround(Math_fround(f44 * f45) + Math_fround(f46 * f43)));
  HEAPF32[i35 >> 2] = Math_fround(f15 - Math_fround(Math_fround(f46 * f45) - Math_fround(f44 * f43)));
  HEAPF32[i24 >> 2] = f42;
  __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i36, i20, i33, f2, i35, f3);
  i20 = i31 + (i23 * 156 | 0) + 72 | 0;
  i9 = i36;
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  i32 = i20;
  HEAP32[i32 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i32 + 4 >> 2] = i6;
  i32 = i31 + (i23 * 156 | 0) + 148 | 0;
  i6 = HEAP32[i32 >> 2] | 0;
  do if ((i6 | 0) > 0) {
   i7 = i31 + (i23 * 156 | 0) + 76 | 0;
   f2 = Math_fround(f4 + f5);
   i8 = i31 + (i23 * 156 | 0) + 140 | 0;
   i1 = 0;
   do {
    i51 = i36 + 8 + (i1 << 3) | 0;
    f3 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f10);
    i9 = i36 + 8 + (i1 << 3) + 4 | 0;
    f50 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f11);
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) >> 2] = f3;
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 4 >> 2] = f50;
    f49 = Math_fround(Math_fround(HEAPF32[i51 >> 2]) - f15);
    f48 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f16);
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 8 >> 2] = f49;
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 12 >> 2] = f48;
    f46 = Math_fround(HEAPF32[i7 >> 2]);
    f45 = Math_fround(f3 * f46);
    f47 = Math_fround(HEAPF32[i20 >> 2]);
    f45 = Math_fround(f45 - Math_fround(f50 * f47));
    f47 = Math_fround(Math_fround(f46 * f49) - Math_fround(f47 * f48));
    f47 = Math_fround(Math_fround(f2 + Math_fround(f45 * Math_fround(f21 * f45))) + Math_fround(f47 * Math_fround(f22 * f47)));
    i9 = f47 > Math_fround(0.0);
    f47 = Math_fround(Math_fround(1.0) / f47);
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 24 >> 2] = i9 ? f47 : Math_fround(0.0);
    f47 = Math_fround(HEAPF32[i7 >> 2]);
    f45 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
    f46 = Math_fround(Math_fround(f3 * f45) - Math_fround(f47 * f50));
    f47 = Math_fround(Math_fround(f49 * f45) - Math_fround(f47 * f48));
    f47 = Math_fround(Math_fround(f2 + Math_fround(f46 * Math_fround(f21 * f46))) + Math_fround(f47 * Math_fround(f22 * f47)));
    i9 = f47 > Math_fround(0.0);
    f47 = Math_fround(Math_fround(1.0) / f47);
    HEAPF32[i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 28 >> 2] = i9 ? f47 : Math_fround(0.0);
    i9 = i31 + (i23 * 156 | 0) + (i1 * 36 | 0) + 32 | 0;
    HEAPF32[i9 >> 2] = Math_fround(0.0);
    f50 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f19 * f48)) - f12) + Math_fround(f14 * f50));
    f3 = Math_fround(Math_fround(Math_fround(f18 + Math_fround(f19 * f49)) - f13) - Math_fround(f14 * f3));
    f50 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f50);
    f3 = Math_fround(f50 + Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f3));
    if (f3 < Math_fround(-Math_fround(HEAPF32[gb + 151876 >> 2]))) HEAPF32[i9 >> 2] = Math_fround(-Math_fround(f3 * Math_fround(HEAPF32[i8 >> 2])));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
   if ((HEAP32[i32 >> 2] | 0) == 2) {
    f2 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) >> 2]);
    f48 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 76 >> 2]);
    f2 = Math_fround(f2 * f48);
    f47 = Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 4 >> 2]);
    f3 = Math_fround(HEAPF32[i20 >> 2]);
    f47 = Math_fround(f2 - Math_fround(f47 * f3));
    f2 = Math_fround(f48 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 8 >> 2]));
    f2 = Math_fround(f2 - Math_fround(f3 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 12 >> 2])));
    f50 = Math_fround(f48 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 36 >> 2]));
    f50 = Math_fround(f50 - Math_fround(f3 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 40 >> 2])));
    f48 = Math_fround(f48 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 44 >> 2]));
    f3 = Math_fround(f48 - Math_fround(f3 * Math_fround(HEAPF32[i31 + (i23 * 156 | 0) + 48 >> 2])));
    f48 = Math_fround(f4 + f5);
    f49 = Math_fround(f21 * f47);
    f4 = Math_fround(f22 * f2);
    f5 = Math_fround(Math_fround(f48 + Math_fround(f47 * f49)) + Math_fround(f2 * f4));
    f2 = Math_fround(Math_fround(f48 + Math_fround(f50 * Math_fround(f21 * f50))) + Math_fround(f3 * Math_fround(f22 * f3)));
    f3 = Math_fround(Math_fround(f48 + Math_fround(f49 * f50)) + Math_fround(f4 * f3));
    f4 = Math_fround(Math_fround(f5 * f2) - Math_fround(f3 * f3));
    if (Math_fround(f5 * f5) < Math_fround(f4 * Math_fround(1.0e3))) {
     HEAPF32[i31 + (i23 * 156 | 0) + 96 >> 2] = f5;
     HEAPF32[i31 + (i23 * 156 | 0) + 100 >> 2] = f3;
     HEAPF32[i31 + (i23 * 156 | 0) + 104 >> 2] = f3;
     HEAPF32[i31 + (i23 * 156 | 0) + 108 >> 2] = f2;
     i51 = f4 != Math_fround(0.0);
     f48 = Math_fround(Math_fround(1.0) / f4);
     f48 = i51 ? f48 : f4;
     f49 = Math_fround(-Math_fround(f48 * f3));
     f50 = Math_fround(f5 * f48);
     HEAPF32[i31 + (i23 * 156 | 0) + 80 >> 2] = Math_fround(f2 * f48);
     HEAPF32[i31 + (i23 * 156 | 0) + 84 >> 2] = f49;
     HEAPF32[i31 + (i23 * 156 | 0) + 88 >> 2] = f49;
     HEAPF32[i31 + (i23 * 156 | 0) + 92 >> 2] = f50;
     break;
    } else {
     HEAP32[i32 >> 2] = 1;
     break;
    }
   }
  } while (0);
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) < (HEAP32[i37 >> 2] | 0));
 STACKTOP = i41;
 return;
}

function _UNITY_tt_face_init(i1, i21, i18, i3, i4) {
 i1 = i1 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 i17 = i22 + 72 | 0;
 i19 = _UNITY_FT_Get_Module_Interface(HEAP32[(HEAP32[i21 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1007772 | 0) | 0;
 if (!i19) {
  i21 = 11;
  STACKTOP = i22;
  return i21 | 0;
 }
 i2 = _UNITY_FT_Stream_Seek(i1, 0) | 0;
 if (i2 | 0) {
  i21 = i2;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = mftCall_iiiiii(HEAP32[i19 + 4 >> 2] | 0, i1 | 0, i21 | 0, i18 | 0, i3 | 0, i4 | 0) | 0;
 i14 = i21 + 104 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = HEAP32[i21 + 148 >> 2] | 0;
 L10 : do if ((i1 | 0) < 131072) {
  switch (i1 | 0) {
  case 65536:
   break L10;
  default:
   i1 = 2;
  }
  STACKTOP = i22;
  return i1 | 0;
 } else if ((i1 | 0) < 1953658213) {
  switch (i1 | 0) {
  case 131072:
   break L10;
  default:
   i1 = 2;
  }
  STACKTOP = i22;
  return i1 | 0;
 } else {
  switch (i1 | 0) {
  case 1953658213:
   break L10;
  default:
   i1 = 2;
  }
  STACKTOP = i22;
  return i1 | 0;
 } while (0);
 i16 = i21 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 2048;
 if ((i18 | 0) < 0) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = mftCall_iiiiii(HEAP32[i19 + 8 >> 2] | 0, i15 | 0, i21 | 0, i18 | 0, i3 | 0, i4 | 0) | 0;
 if (i1 | 0) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = HEAP32[i21 + 20 >> 2] | 0;
 if (!i1) i13 = 17; else if (!(_strstr(i1, gb + 1007542 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 20 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 40 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 60 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 80 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 100 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 120 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 140 | 0) | 0)) if (!(_strstr(i1, gb + 1007542 + 160 | 0) | 0)) i13 = 17; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65; else i13 = 65;
 L36 : do if ((i13 | 0) == 17) {
  i1 = i20;
  i2 = i1 + 68 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i10 = i21 + 152 | 0;
  i1 = HEAP16[i10 >> 1] | 0;
  L38 : do if (!(i1 << 16 >> 16)) {
   i4 = 0;
   i13 = 46;
  } else {
   i11 = i21 + 156 | 0;
   i12 = i21 + 508 | 0;
   i9 = 0;
   i2 = 0;
   i8 = 0;
   while (1) {
    i4 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i4 + (i8 << 4) >> 2] | 0;
    L42 : do if ((i3 | 0) < 1718642541) switch (i3 | 0) {
    case 1668707360:
     {
      i7 = 0;
      i2 = 1;
      i13 = 25;
      break;
     }
    default:
     {}
    } else if ((i3 | 0) < 1886545264) {
     switch (i3 | 0) {
     case 1718642541:
      break;
     default:
      break L42;
     }
     i7 = 1;
     i13 = 25;
     break;
    } else {
     switch (i3 | 0) {
     case 1886545264:
      break;
     default:
      break L42;
     }
     i7 = 2;
     i13 = 25;
     break;
    } while (0);
    if ((i13 | 0) == 25) {
     i13 = 0;
     i1 = 0;
     i3 = 0;
     while (1) {
      if ((HEAP32[i4 + (i8 << 4) + 12 >> 2] | 0) == (HEAP32[gb + 186052 + (i1 * 24 | 0) + (i7 << 3) + 4 >> 2] | 0)) {
       do if (!i3) {
        i3 = HEAP32[i12 >> 2] | 0;
        if (!i3) i3 = 0; else if (!(mftCall_iiiii(i3 | 0, i21 | 0, HEAP32[i4 + (i8 << 4) >> 2] | 0, HEAP32[i14 >> 2] | 0, 0) | 0)) {
         i6 = HEAP32[i14 >> 2] | 0;
         i4 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 4) + 12 >> 2] | 0;
         if (_UNITY_FT_Stream_EnterFrame(i6, i4) | 0) {
          i3 = 0;
          break;
         }
         if (i4 >>> 0 > 3) {
          i3 = 0;
          i5 = i4;
          do {
           i3 = (_UNITY_FT_Stream_GetULong(i6) | 0) + i3 | 0;
           i5 = i5 + -4 | 0;
          } while (i5 >>> 0 > 3);
          i4 = i4 & 3;
         } else i3 = 0;
         if (i4) {
          i5 = 3;
          while (1) {
           i3 = (((_UNITY_FT_Stream_GetChar(i6) | 0) & 255) << (i5 << 3)) + i3 | 0;
           i4 = i4 + -1 | 0;
           if (!i4) break; else i5 = i5 + -1 | 0;
          }
         }
         _UNITY_FT_Stream_ExitFrame(i6);
        } else i3 = 0;
       } while (0);
       i5 = i20 + (i1 << 2) | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       i6 = i4 + 1 | 0;
       if ((HEAP32[gb + 186052 + (i1 * 24 | 0) + (i7 << 3) >> 2] | 0) == (i3 | 0)) {
        HEAP32[i5 >> 2] = i6;
        i4 = i6;
       }
       if ((i4 | 0) == 3) break L38;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= 17) break;
      i4 = HEAP32[i11 >> 2] | 0;
     }
     i1 = HEAP16[i10 >> 1] | 0;
    }
    i3 = i9 + 1 << 16 >> 16;
    if ((i3 & 65535) < (i1 & 65535)) {
     i9 = i3;
     i8 = i3 & 65535;
    } else break;
   }
   if (!(i2 << 24 >> 24)) {
    i4 = 0;
    i13 = 46;
   } else if ((HEAP32[i20 >> 2] | 0) != 3) if ((HEAP32[i20 + 4 >> 2] | 0) != 3) if ((HEAP32[i20 + 8 >> 2] | 0) != 3) if ((HEAP32[i20 + 12 >> 2] | 0) != 3) if ((HEAP32[i20 + 16 >> 2] | 0) != 3) if ((HEAP32[i20 + 20 >> 2] | 0) != 3) if ((HEAP32[i20 + 24 >> 2] | 0) != 3) if ((HEAP32[i20 + 28 >> 2] | 0) != 3) if ((HEAP32[i20 + 32 >> 2] | 0) != 3) {
    if ((HEAP32[i20 + 36 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 40 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 44 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 48 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 52 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 56 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 60 >> 2] | 0) == 3) break;
    if ((HEAP32[i20 + 64 >> 2] | 0) == 3) {
     i13 = 65;
     break L36;
    } else break L36;
   }
  } while (0);
  L96 : do if ((i13 | 0) == 46) {
   while (1) {
    i13 = 0;
    i2 = i20 + (i4 << 2) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i3 = i1 + 1 | 0;
    if (i4 >>> 0 >= 5) {
     HEAP32[i2 >> 2] = i3;
     i1 = i3;
    }
    i4 = i4 + 1 | 0;
    if ((i1 | 0) == 3) break L96;
    if ((i4 | 0) >= 17) break; else i13 = 46;
   }
   break L36;
  } while (0);
  i13 = 65;
 } while (0);
 if ((i13 | 0) == 65) HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 8192;
 i1 = _UNITY_tt_face_load_hdmx(i21, i15) | 0;
 if (i1 | 0) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 L111 : do if (!(HEAP32[i16 >> 2] & 1)) i1 = 0; else {
  i1 = _UNITY_tt_face_load_loca(i21, i15) | 0;
  if (!i1) {
   i1 = _UNITY_tt_face_load_cvt(i21, i15) | 0;
   if (!i1) {
    i1 = _UNITY_tt_face_load_fpgm(i21, i15) | 0;
    if (!i1) i1 = _UNITY_tt_face_load_prep(i21, i15) | 0;
   }
  }
  if (HEAP32[i21 + 28 >> 2] | 0) if (HEAP32[i21 + 700 >> 2] | 0) {
   i5 = i21 + 696 | 0;
   L120 : do if (HEAP32[i5 >> 2] | 0) {
    i2 = 0;
    i3 = 0;
    i4 = 0;
    do {
     _UNITY_tt_face_get_location(i21, i4, i20) | 0;
     if (HEAP32[i20 >> 2] | 0) {
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 > 1) break L120; else i3 = i4;
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
    if ((i2 | 0) == 1) {
     do if (i3) {
      i15 = (_UNITY_FT_Get_Glyph_Name(i21, i3, i17, 8) | 0) == 0;
      if (i15 & (HEAP8[i17 >> 0] | 0) == 46) if (!(_strncmp(i17, gb + 1007722 | 0, 8) | 0)) break; else break L111; else break L111;
     } while (0);
     HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & -2;
     break L111;
    }
   } while (0);
  }
 } while (0);
 i2 = i18 >> 16;
 do if ((i2 | 0) > 0 & (HEAP32[i16 >> 2] & 256 | 0) != 0) {
  i1 = _UNITY_TT_Get_MM_Var(i21, 0) | 0;
  if (i1 | 0) {
   i21 = i1;
   STACKTOP = i22;
   return i21 | 0;
  }
  i4 = i21 + 676 | 0;
  i1 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i5 = HEAP32[i21 + 100 >> 2] | 0;
   i3 = i1 + (i2 << 3) + -8 | 0;
   i1 = mftCall_iiii(HEAP32[i19 + 116 >> 2] | 0, i21 | 0, HEAP32[i3 + 4 >> 2] & 65535 | 0, i20 | 0) | 0;
   if (!i1) {
    i1 = i21 + 24 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     _UNITY_ft_mem_free(i5, i2);
     HEAP32[i1 >> 2] = 0;
    }
    HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
    i1 = _UNITY_TT_Set_Var_Design(i21, HEAP32[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    if (!i1) {
     i1 = 0;
     break;
    }
   }
   i21 = i1;
   STACKTOP = i22;
   return i21 | 0;
  }
 } while (0);
 _UNITY_TT_Init_Glyph_Loading(i21);
 i21 = i1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i41 + 32 | 0;
 i34 = i41 + 72 | 0;
 i35 = i41;
 i36 = i41 + 48 | 0;
 i37 = i41 + 84 | 0;
 i38 = i5 + 80 | 0;
 i39 = i5 + 84 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i38, HEAP32[i39 >> 2] | 0);
 i40 = i5 + 88 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i38 >> 2] = i39;
 HEAP32[i39 >> 2] = 0;
 i33 = i5 + 120 | 0;
 i2 = i5 + 124 | 0;
 HEAP32[i2 >> 2] = 32;
 HEAP32[i5 + 136 >> 2] = 16;
 HEAP32[i5 + 132 >> 2] = 6;
 HEAP8[i5 + 140 >> 0] = 0;
 i3 = i5 + 144 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i32 >> 2] = 65;
 HEAP32[i32 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
 i4 = HEAP32[i33 >> 2] | 0;
 if (i4 | 0) {
  i30 = HEAP32[i3 >> 2] | 0;
  HEAP32[i32 >> 2] = 65;
  HEAP32[i32 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i32);
 }
 HEAP32[i33 >> 2] = i1;
 i2 = i1 + (HEAP32[i2 >> 2] << 3) | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = i5 + 112 | 0;
  do {
   i28 = i3;
   i29 = HEAP32[i28 + 4 >> 2] | 0;
   i30 = i1;
   HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i30 + 4 >> 2] = i29;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i13 = i5 + 128 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i5 + 96 | 0;
 HEAP32[i14 >> 2] = 0;
 i1 = HEAP32[i5 + 68 >> 2] | 0;
 i15 = i5 + 72 | 0;
 i2 = i1;
 if ((i2 | 0) == (i15 | 0)) {
  STACKTOP = i41;
  return;
 }
 i16 = i36 + 12 | 0;
 i17 = i36 + 11 | 0;
 i18 = i36 + 4 | 0;
 i19 = i35 + 12 | 0;
 i12 = i35 + 12 | 0;
 i20 = i32 + 4 | 0;
 i21 = i35 + 8 | 0;
 i22 = i35 + 4 | 0;
 i23 = i35 + 16 | 0;
 i24 = i5 + 84 | 0;
 i25 = i35 + 11 | 0;
 i26 = i32 + 4 | 0;
 i27 = i35 + 4 | 0;
 i28 = i5 + 92 | 0;
 i29 = i32 + 4 | 0;
 i30 = i5 + 100 | 0;
 i11 = i5 + 104 | 0;
 i10 = i2;
 while (1) {
  i2 = i10 + 16 | 0;
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i35, i2, i3);
  __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i32, i35);
  __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i34, i32);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i32);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i35);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i37, i34);
  i9 = i10 + 32 | 0;
  HEAP32[i32 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i36, i37);
  HEAP32[i16 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  i4 = HEAP8[i17 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i36 >> 2] | 0 : i36;
  i4 = i2 ? HEAP32[i18 >> 2] | 0 : i4 & 255;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i19 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i35);
   i2 = HEAP32[i12 >> 2] | 0;
   i31 = 15;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i25 >> 0] = i4;
   if (!i4) i2 = i35; else {
    i2 = i35;
    i31 = 17;
   }
  } else i31 = 15;
  if ((i31 | 0) == 15) {
   i8 = i4 + 16 & -16;
   HEAP32[i32 >> 2] = 66;
   HEAP32[i20 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i35 >> 2] = i2;
   HEAP32[i21 >> 2] = i8 | -2147483648;
   HEAP32[i22 >> 2] = i4;
   i31 = 17;
  }
  if ((i31 | 0) == 17) {
   i31 = 0;
   _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i2 + i4 >> 0] = 0;
  HEAP32[i23 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i2 = HEAP32[i39 >> 2] | 0;
  do if (!i2) {
   i3 = i39;
   i4 = i39;
  } else {
   i8 = HEAP8[i25 >> 0] | 0;
   i7 = i8 << 24 >> 24 < 0;
   i8 = i7 ? HEAP32[i22 >> 2] | 0 : i8 & 255;
   i7 = i7 ? HEAP32[i35 >> 2] | 0 : i35;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i6 >>> 0 < i8 >>> 0 ? i6 : i8;
    if (!i3) i31 = 22; else {
     i3 = _memcmp(i7, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
     if (!i3) i31 = 22; else if ((i3 | 0) < 0) i31 = 24; else i31 = 26;
    }
    if ((i31 | 0) == 22) if (i8 >>> 0 < i6 >>> 0) i31 = 24; else i31 = 26;
    if ((i31 | 0) == 24) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i31 = 25;
      break;
     } else i2 = i3;
    } else if ((i31 | 0) == 26) {
     i4 = i2 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i31 = 28;
      break;
     } else i2 = i3;
    }
   }
   if ((i31 | 0) == 25) {
    i31 = 0;
    i3 = i2;
    i4 = i2;
    break;
   } else if ((i31 | 0) == 28) {
    i31 = 0;
    i3 = i2;
    break;
   }
  } while (0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i32, i38, i35);
  i2 = HEAP32[i32 >> 2] | 0;
  HEAP32[i32 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = i3;
  HEAP32[i4 >> 2] = i2;
  i3 = HEAP32[HEAP32[i38 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i38 >> 2] = i3;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i24 >> 2] | 0, i2);
  HEAP32[i40 >> 2] = (HEAP32[i40 >> 2] | 0) + 1;
  if ((HEAP8[i25 >> 0] | 0) < 0) {
   i8 = HEAP32[i35 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   HEAP32[i32 >> 2] = 66;
   HEAP32[i26 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i32);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i36);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i37);
  HEAP32[i35 >> 2] = HEAP32[i10 + 40 >> 2];
  HEAP32[i27 >> 2] = i9;
  __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj(i28, 1, 0);
  __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_(i32, i28, i35);
  if ((HEAP32[i32 >> 2] | 0) == -1) {
   i4 = HEAP32[i29 >> 2] | 0;
   if (!(HEAP8[i30 >> 0] | 0)) i31 = 38; else {
    i3 = HEAP32[i14 >> 2] | 0;
    if (!i3) i31 = 38; else {
     i2 = HEAP32[i33 >> 2] | 0;
     if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + (i4 << 3) >> 2] | 0)) HEAP32[i14 >> 2] = i3 + -1; else i31 = 38;
    }
   }
   if ((i31 | 0) == 38) {
    i31 = 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    i2 = HEAP32[i33 >> 2] | 0;
   }
   i8 = i35;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i2 + (i4 << 3) | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i34);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i15 | 0)) break; else {
   i1 = i2;
   i10 = i2;
  }
 }
 STACKTOP = i41;
 return;
}

function __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i23, i1, i22) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i30 + 232 | 0;
 i24 = i30 + 184 | 0;
 i29 = i30 + 136 | 0;
 i2 = i30 + 8 | 0;
 i3 = i30 + 128 | 0;
 i27 = i30 + 80 | 0;
 i20 = i30 + 176 | 0;
 i21 = i30 + 16 | 0;
 i19 = i30;
 __Z29CollectAndProduceClonedIslandR6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i23, i1, i22);
 if ((HEAP16[gb + 1155192 + 6 >> 1] | 0) > -1) {
  HEAP32[i24 >> 2] = i23;
  HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155192 | 0, i26);
  i28 = gb + 1155192 | 0;
 } else i28 = 0;
 i17 = gb + 64016 | 0;
 i1 = HEAP32[i17 + 4 >> 2] | 0;
 i18 = i2;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = i1;
 HEAP32[i26 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN22BlockMemoryCacheWriterC2E10MemLabelId(i29, i26);
 HEAP32[i3 >> 2] = gb + 37976 + 8;
 HEAP32[i3 + 4 >> 2] = i22;
 __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb(i27, 16384, 1);
 HEAP32[i27 + 16 >> 2] = i3;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i24 + 28 | 0;
  i8 = i24 + 32 | 0;
  i9 = i24 + 36 | 0;
  i10 = i24 + 40 | 0;
  i11 = i20 + 4 | 0;
  i12 = i29 + 32 | 0;
  i13 = i29 + 20 | 0;
  i14 = i29 + 4 | 0;
  i15 = i21 + 16 | 0;
  i16 = i21 + 8 | 0;
  i17 = i21 + 4 | 0;
  do {
   i5 = HEAP32[i2 >> 2] | 0;
   HEAP32[i24 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i25 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i1, i24);
     i3 = HEAP32[i26 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i25 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i25 = 13; else i6 = i1;
    }
   }
   if ((i25 | 0) == 11) i25 = 13;
   if ((i25 | 0) == 13) {
    i25 = 0;
    i6 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   }
   i5 = (HEAP32[i6 + 8 >> 2] | 0) >>> 21;
   if (!((i5 | 0) == (HEAP32[gb + 28940 + 24 >> 2] | 0) ? 1 : (i5 | 0) == (HEAP32[gb + 28900 + 24 >> 2] | 0))) {
    i5 = HEAP32[i2 + 4 >> 2] | 0;
    HEAP32[i24 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i25 = 20; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i1, i24);
      i3 = HEAP32[i26 >> 2] | 0;
      i31 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i31 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i31 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i25 = 20; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i25 = 22;
     }
    }
    if ((i25 | 0) == 20) i25 = 22;
    if ((i25 | 0) == 22) {
     i25 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    };
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAP32[i24 + 16 >> 2] = 0;
    HEAP32[i24 + 20 >> 2] = 0;
    HEAP32[i24 + 24 >> 2] = 0;
    HEAP32[i7 >> 2] = -1;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i9 >> 2] = -2;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i20 >> 2] = -2;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i26 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    i31 = __ZN19StreamedBinaryWriteILb0EE4InitE24TransferInstructionFlags20BuildTargetSelection(i24, 16384, i26) | 0;
    __ZN12CachedWriter9InitWriteER15CacheWriterBase(i31, i29);
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 64 >> 2] | 0, i6 | 0, i24 | 0);
    __ZN12CachedWriter15CompleteWritingEv(i31) | 0;
    __ZN22MemoryCacherReadBlocksC2EPPhij(i26, (HEAP32[i12 >> 2] | 0) == 0 ? 0 : HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, 256);
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    HEAP32[i21 + 12 >> 2] = 0;
    __ZN12CachedReaderC2Ev(i15);
    __ZNK6Object14GetMemoryLabelEv(i19, i1);
    i4 = i19;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = i16;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i21 >> 2] = 268451840;
    __ZN12CachedReader8InitReadER15CacheReaderBasejj(i15, i26, 0, __ZNK12CachedWriter11GetPositionEv(i31) | 0);
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i21 | 0);
    __ZN12CachedReader3EndEv(i15) | 0;
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i27 | 0);
    __ZN15CacheReaderBaseD2Ev(i26);
   }
   i2 = i2 + 8 | 0;
   i1 = HEAP32[i18 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i2 = HEAP32[i22 + 4 >> 2] | 0;
 }
 i7 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = i1 - i2 >> 3;
 i4 = i2;
 if (!i3) i2 = i4; else {
  i2 = i4;
  while (1) {
   i31 = (i3 | 0) / 2 | 0;
   i6 = i4 + (i31 << 3) | 0;
   i5 = (HEAP32[i6 >> 2] | 0) < (i7 | 0);
   i6 = i6 + 8 | 0;
   i2 = i5 ? i6 : i2;
   i3 = i5 ? i3 + -1 - i31 | 0 : i31;
   if (!i3) break; else i4 = i5 ? i6 : i4;
  }
 }
 if ((i2 | 0) == (i1 | 0)) i25 = 30; else if ((i7 | 0) < (HEAP32[i2 >> 2] | 0)) i25 = 30; else i1 = i2;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 do if (!i4) i5 = 0; else {
  HEAP32[i24 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i25 = 37; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i1, i24);
    i2 = HEAP32[i26 >> 2] | 0;
    i31 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i31 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i31 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i25 = 37; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i5 = i1;
     break;
    }
   }
  }
  i5 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 } while (0);
 i1 = HEAP32[i27 + 20 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i27 + 24 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i31 = HEAP32[i27 + 32 >> 2] | 0;
  HEAP32[i26 >> 2] = 1;
  HEAP32[i26 + 4 >> 2] = i31;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i26);
 }
 HEAP32[i29 >> 2] = gb + 37988 + 8;
 i2 = i29 + 20 | 0;
 i3 = i29 + 32 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i29 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 if ((HEAP32[i29 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i29 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if (!i28) {
  STACKTOP = i30;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i28);
 STACKTOP = i30;
 return i5 | 0;
}

function __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 16 | 0;
 i2 = i16;
 i15 = i16 + 28 | 0;
 i9 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 if (!i9) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 465763 | 0, 0, gb + 465174 | 0, 872, 1, 0, 0, 0);
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i9) | 0;
 if (!i1) {
  i12 = __Z24scripting_class_get_nameP11Il2CppClass(i9) | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i12, _strlen(i12) | 0);
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i12 = i14 + 11 | 0;
  i13 = HEAP8[i12 >> 0] | 0;
  i13 = i13 << 24 >> 24 < 0 ? HEAP32[i14 + 4 >> 2] | 0 : i13 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i15, gb + 465798 | 0, 82, i13 + 82 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, i13) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i13 = HEAP8[i15 + 11 >> 0] | 0;
  i12 = i13 << 24 >> 24 < 0;
  i13 = i12 ? HEAP32[i15 + 4 >> 2] | 0 : i13 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i2, i12 ? HEAP32[i15 >> 2] | 0 : i15, i13, i13 + 1 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i2, gb + 1087625 | 0, 1) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 465174 | 0, 880, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i15 >> 2] = 0;
 i8 = i15 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i15 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i2);
 i2 = i14;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(i1, i15, 1);
 HEAP32[i14 >> 2] = 0;
 i11 = i14 + 4 | 0;
 i7 = gb + 63160 | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = i2 << 2;
 do if (!i1) i1 = 0; else {
  i3 = i1 | 3;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 465174 | 0, 896) | 0;
   i7 = gb + 64016 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i1;
   i2 = i11;
   HEAP32[i2 >> 2] = i6;
   HEAP32[i2 + 4 >> 2] = i7;
   i2 = HEAP32[i8 >> 2] | 0;
   break;
  }
 } while (0);
 i7 = i1 + 3 & -4;
 if (!i2) i1 = __Z19scripting_array_newP11Il2CppClassjj(i9, 4, 0) | 0; else {
  i6 = (i4 | 0) == 1;
  if ((i4 | 0) == 2) {
   i3 = 0;
   i5 = 0;
   do {
    i4 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i4 + 8 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    do if (i6) {
     if (!(i1 & 1048576)) {
      i1 = i1 >>> 21;
      if ((i1 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if ((i4 | 0) == 0 | (__ZNK10GameObject8IsActiveEv(i4) | 0) ^ 1) break; else {
       i10 = 50;
       break;
      }
      if ((i1 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
       if ((i1 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
        i1 = HEAP32[i4 + 28 >> 2] | 0;
        if (!i1) break;
        if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
         i10 = 50;
         break;
        } else break;
       }
       if ((__ZNK13MonoBehaviour13GetScriptTypeEv(i4) | 0) == 1) i10 = 49; else {
        i1 = HEAP32[i4 + 28 >> 2] | 0;
        if (i1) if (__ZNK10GameObject8IsActiveEv(i1) | 0) i10 = 50;
       }
      } else i10 = 49;
     }
    } else i10 = 49; while (0);
    if ((i10 | 0) == 49) {
     i10 = 0;
     if (i4) i10 = 50;
    }
    L36 : do if ((i10 | 0) == 50) {
     i10 = 0;
     i1 = HEAP32[i4 + 20 >> 2] | 0;
     if (!i1) {
      i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
      if ((i1 | 0) == (gb + 27592 | 0)) break;
      while (1) {
       i2 = __Z21GetManagerFromContexti(5) | 0;
       i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
       if (i2 | 0) break;
       i1 = HEAP32[i1 >> 2] | 0;
       if ((i1 | 0) == (gb + 28304 | 0)) break L36;
      }
      i1 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i4) | 0;
      if (!i1) break;
     }
     if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i9) | 0) {
      HEAP32[i7 + (i3 << 2) >> 2] = i1;
      i3 = i3 + 1 | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
  } else {
   i3 = 0;
   i5 = 0;
   do {
    i4 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i4 + 8 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    L49 : do if (!(i1 & 32768)) {
     do if (i6) {
      if (i1 & 1048576 | 0) break L49;
      i1 = i1 >>> 21;
      if ((i1 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if ((i4 | 0) == 0 | (__ZNK10GameObject8IsActiveEv(i4) | 0) ^ 1) break L49; else break;
      if ((i1 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
       if ((i1 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
        i1 = HEAP32[i4 + 28 >> 2] | 0;
        if (!i1) break L49;
        if (__ZNK10GameObject8IsActiveEv(i1) | 0) break; else break L49;
       }
       if ((__ZNK13MonoBehaviour13GetScriptTypeEv(i4) | 0) == 1) i10 = 23; else {
        i1 = HEAP32[i4 + 28 >> 2] | 0;
        if (!i1) break L49;
        if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) break L49;
       }
      } else i10 = 23;
     } else i10 = 23; while (0);
     if ((i10 | 0) == 23) {
      i10 = 0;
      if (!i4) break;
     }
     i1 = HEAP32[i4 + 20 >> 2] | 0;
     if (!i1) {
      i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
      if ((i1 | 0) == (gb + 27592 | 0)) break;
      while (1) {
       i2 = __Z21GetManagerFromContexti(5) | 0;
       i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
       if (i2 | 0) break;
       i1 = HEAP32[i1 >> 2] | 0;
       if ((i1 | 0) == (gb + 28304 | 0)) break L49;
      }
      i1 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i4) | 0;
      if (!i1) break;
     }
     if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i9) | 0) {
      HEAP32[i7 + (i3 << 2) >> 2] = i1;
      i3 = i3 + 1 | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i9, 4, i3) | 0;
  if ((i3 | 0) > 0) {
   i2 = 0;
   do {
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i1, i2, HEAP32[i7 + (i2 << 2) >> 2] | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i11);
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i13);
  HEAP32[i15 >> 2] = 0;
 }
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN4Tree30ComputeSpeedTreeWindPropertiesERK18SpeedTreeWindAsset(i27, i25) {
 i27 = i27 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i32 + 8 | 0;
 i2 = i32;
 i29 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i27 + 28 >> 2] | 0, gb + 31312 | 0) | 0;
 i30 = i29 + 8 | 0;
 i28 = (HEAP32[gb + 1106156 + 4 + ((HEAP32[i30 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 29752 | 0);
 do if (mftCall_ii(HEAP32[(HEAP32[i29 >> 2] | 0) + 140 >> 2] | 0, i29 | 0) | 0) {
  i4 = mftCall_iii(HEAP32[(HEAP32[i29 >> 2] | 0) + 144 >> 2] | 0, i29 | 0, 0) | 0;
  if (i4 | 0) {
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i31 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i1, i2);
     i2 = HEAP32[i26 >> 2] | 0;
     i24 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i24 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i24 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i31 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i31 = 10;
    }
   }
   if ((i31 | 0) == 8) i31 = 10;
   if ((i31 | 0) == 10) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   i4 = i1 + 60 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i5 = HEAP32[gb + 1467740 >> 2] | 0;
    i1 = i4;
    L17 : while (1) {
     i3 = i2;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L17; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) if (!(Math_fround(HEAPF32[i1 + 20 >> 2]) == Math_fround(0.0))) {
     i13 = HEAP32[i29 + 312 >> 2] | 0;
     i11 = (i13 | 0) != 0;
     L27 : do if (i11) {
      i3 = i13 + 88 | 0;
      if (!(HEAP32[i3 >> 2] | 0)) i24 = i27; else {
       i4 = i13 + 76 | 0;
       i5 = i25 + 4 | 0;
       i2 = 0;
       while (1) {
        i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
        if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 30912 | 0)) {
         i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 184796 | 0) | 0;
         if (i1 | 0) if ((HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) break;
        }
        i2 = i2 + 1 | 0;
        if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
         i24 = i27;
         break L27;
        }
       }
       i24 = i1;
      }
     } else i24 = i27; while (0);
     i21 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i24 + 28 >> 2] | 0, gb + 31312 | 0) | 0;
     f22 = Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
     i23 = i24 + 36 | 0;
     if (f22 != Math_fround(HEAPF32[i23 >> 2])) {
      f6 = Math_fround(HEAPF32[gb + 62500 >> 2]);
      f7 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
      f17 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
      f14 = Math_fround(-f6);
      f12 = Math_fround(-f7);
      f10 = Math_fround(-f17);
      if (i11) {
       i20 = i13 + 88 | 0;
       if (!(HEAP32[i20 >> 2] | 0)) {
        f16 = f6;
        f15 = f17;
        f9 = f7;
        f8 = f6;
        f6 = f17;
       } else {
        i3 = i13 + 76 | 0;
        i4 = i25 + 4 | 0;
        i5 = i26 + 12 | 0;
        i11 = i26 + 4 | 0;
        i13 = i26 + 16 | 0;
        i18 = i26 + 8 | 0;
        i19 = i26 + 20 | 0;
        i2 = 0;
        f15 = f17;
        f9 = f7;
        do {
         i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0, gb + 184796 | 0) | 0;
         if (i1) if ((HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
          __ZN12BaseRenderer12GetWorldAABBER4AABB((HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 32 | 0, i26);
          f37 = Math_fround(HEAPF32[i26 >> 2]);
          f7 = Math_fround(HEAPF32[i5 >> 2]);
          f34 = Math_fround(f37 - f7);
          f36 = Math_fround(HEAPF32[i11 >> 2]);
          f8 = Math_fround(HEAPF32[i13 >> 2]);
          f17 = Math_fround(f36 - f8);
          f35 = Math_fround(HEAPF32[i18 >> 2]);
          f16 = Math_fround(HEAPF32[i19 >> 2]);
          f33 = Math_fround(f35 - f16);
          f7 = Math_fround(f37 + f7);
          f8 = Math_fround(f36 + f8);
          f16 = Math_fround(f35 + f16);
          f6 = f34 < f6 ? f34 : f6;
          f15 = f33 < f15 ? f33 : f15;
          f14 = f14 < f7 ? f7 : f14;
          f12 = f12 < f8 ? f8 : f12;
          f10 = f10 < f16 ? f16 : f10;
          f9 = f17 < f9 ? f17 : f9;
         }
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0);
        f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
        f7 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
        f16 = f6;
        f6 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
       }
      } else {
       f16 = f6;
       f15 = f17;
       f9 = f7;
       f8 = f6;
       f6 = f17;
      }
      do if (f16 == f8 & f9 == f7 & f15 == f6) i31 = 42; else {
       if (f14 == Math_fround(-f8)) if (!(f10 != Math_fround(-f6) | f12 != Math_fround(-f7))) {
        i31 = 42;
        break;
       }
       f33 = Math_fround(Math_fround(f9 + f12) * Math_fround(.5));
       f34 = Math_fround(Math_fround(f15 + f10) * Math_fround(.5));
       f35 = Math_fround(Math_fround(f14 - f16) * Math_fround(.5));
       f36 = Math_fround(Math_fround(f12 - f9) * Math_fround(.5));
       f37 = Math_fround(Math_fround(f10 - f15) * Math_fround(.5));
       HEAPF32[i26 >> 2] = Math_fround(Math_fround(f16 + f14) * Math_fround(.5));
       HEAPF32[i26 + 4 >> 2] = f33;
       HEAPF32[i26 + 8 >> 2] = f34;
       HEAPF32[i26 + 12 >> 2] = f35;
       HEAPF32[i26 + 16 >> 2] = f36;
       HEAPF32[i26 + 20 >> 2] = f37;
      } while (0);
      if ((i31 | 0) == 42) __ZN12BaseRenderer12GetWorldAABBER4AABB(i29 + 32 | 0, i26);
      i19 = i28 & (i24 | 0) == (i27 | 0);
      i20 = i24 + 44 | 0;
      i26 = __ZN20SpeedTreeWindManager8TickWindER18SpeedTreeWindTimesRP18SpeedTreeLocalWindRK4AABBRK18SpeedTreeWindAsset(__ZN20SpeedTreeWindManager11GetInstanceEv() | 0, i20, i24 + 40 | 0, i26, i25) | 0;
      i25 = __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i21) | 0;
      __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i25, i19);
      __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes(i25, i19, i26, i20);
      HEAPF32[i23 >> 2] = f22;
     }
     i1 = HEAP32[i21 + 224 >> 2] | 0;
     do if ((i24 | 0) == (i27 | 0)) i31 = 49; else {
      if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i30 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 30912 | 0)) {
       __ZN8Renderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i29, i1);
       i31 = 49;
       break;
      }
      if (i28) {
       i31 = __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i29) | 0;
       __ZN20SpeedTreeWindManager32FillGlobalWindOnlyPropertiesFromER19ShaderPropertySheetRKS0_(i31, i1);
       __ZN19ShaderPropertySheet11ComputeHashEv(i31);
       i31 = 50;
      }
     } while (0);
     if ((i31 | 0) == 49) if (i28) i31 = 50;
     if ((i31 | 0) == 50) HEAP32[i29 + 376 >> 2] = HEAP32[i24 + 48 >> 2];
     i31 = Math_fround(HEAPF32[HEAP32[i1 + 72 >> 2] >> 2]) == Math_fround(1.0);
     STACKTOP = i32;
     return i31 | 0;
    }
   }
  }
 } while (0);
 HEAPF32[i27 + 36 >> 2] = Math_fround(-1.0);
 __ZN8Renderer21ClearCustomPropertiesEv(i29);
 i31 = 0;
 STACKTOP = i32;
 return i31 | 0;
}

function __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 108 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 116 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 120 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 124 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 128 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function _sha512crypt(i15, i4, i1) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 208 | 0;
 i7 = i23 + 200 | 0;
 i17 = i23;
 i22 = i23 + 376 | 0;
 i18 = i23 + 312 | 0;
 i19 = i23 + 248 | 0;
 i20 = i23 + 224 | 0;
 i6 = i23 + 220 | 0;
 i2 = i20;
 i3 = i2 + 20 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i16 = 0;
 while (1) {
  if (!(HEAP8[i15 + i16 >> 0] | 0)) {
   i5 = 4;
   break;
  }
  i2 = i16 + 1 | 0;
  if (i2 >>> 0 < 257) i16 = i2; else {
   i1 = 0;
   break;
  }
 }
 L4 : do if ((i5 | 0) == 4) if (!(_strncmp(i4, gb + 1056977 | 0, 3) | 0)) {
  i2 = i4 + 3 | 0;
  do if (!(_strncmp(i2, gb + 1059600 | 0, 7) | 0)) {
   i2 = i4 + 10 | 0;
   if (((HEAP8[i2 >> 0] | 0) + -48 | 0) >>> 0 < 10) {
    i3 = _strtoul(i2, i6, 10) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if ((HEAP8[i2 >> 0] | 0) == 36) {
     i14 = i3 >>> 0 < 1e3 ? 1e3 : i3 >>> 0 > 9999999 ? 9999999 : i3;
     HEAP32[i7 >> 2] = i14;
     _sprintf(i20, gb + 1059608 | 0, i7) | 0;
     i13 = i2 + 1 | 0;
     break;
    }
   }
   i1 = 0;
   break L4;
  } else {
   i13 = i2;
   i14 = 5e3;
  } while (0);
  i2 = 0;
  L14 : do {
   switch (HEAP8[i13 + i2 >> 0] | 0) {
   case 58:
   case 10:
    {
     i1 = 0;
     break L4;
    }
   case 0:
   case 36:
    break L14;
   default:
    {}
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < 16);
  i5 = i17;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = i17 + 8 | 0;
  i6 = i5;
  HEAP32[i6 >> 2] = -205731576;
  HEAP32[i6 + 4 >> 2] = 1779033703;
  i6 = i17 + 16 | 0;
  i7 = i6;
  HEAP32[i7 >> 2] = -2067093701;
  HEAP32[i7 + 4 >> 2] = -1150833019;
  i7 = i17 + 24 | 0;
  i8 = i7;
  HEAP32[i8 >> 2] = -23791573;
  HEAP32[i8 + 4 >> 2] = 1013904242;
  i8 = i17 + 32 | 0;
  i9 = i8;
  HEAP32[i9 >> 2] = 1595750129;
  HEAP32[i9 + 4 >> 2] = -1521486534;
  i9 = i17 + 40 | 0;
  i10 = i9;
  HEAP32[i10 >> 2] = -1377402159;
  HEAP32[i10 + 4 >> 2] = 1359893119;
  i10 = i17 + 48 | 0;
  i11 = i10;
  HEAP32[i11 >> 2] = 725511199;
  HEAP32[i11 + 4 >> 2] = -1694144372;
  i11 = i17 + 56 | 0;
  i12 = i11;
  HEAP32[i12 >> 2] = -79577749;
  HEAP32[i12 + 4 >> 2] = 528734635;
  i12 = i17 + 64 | 0;
  i4 = i12;
  HEAP32[i4 >> 2] = 327033209;
  HEAP32[i4 + 4 >> 2] = 1541459225;
  _sha512_update(i17, i15, i16);
  _sha512_update(i17, i13, i2);
  _sha512_update(i17, i15, i16);
  _sha512_sum(i17, i22);
  i4 = i17;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = i5;
  HEAP32[i4 >> 2] = -205731576;
  HEAP32[i4 + 4 >> 2] = 1779033703;
  i4 = i6;
  HEAP32[i4 >> 2] = -2067093701;
  HEAP32[i4 + 4 >> 2] = -1150833019;
  i4 = i7;
  HEAP32[i4 >> 2] = -23791573;
  HEAP32[i4 + 4 >> 2] = 1013904242;
  i4 = i8;
  HEAP32[i4 >> 2] = 1595750129;
  HEAP32[i4 + 4 >> 2] = -1521486534;
  i4 = i9;
  HEAP32[i4 >> 2] = -1377402159;
  HEAP32[i4 + 4 >> 2] = 1359893119;
  i4 = i10;
  HEAP32[i4 >> 2] = 725511199;
  HEAP32[i4 + 4 >> 2] = -1694144372;
  i4 = i11;
  HEAP32[i4 >> 2] = -79577749;
  HEAP32[i4 + 4 >> 2] = 528734635;
  i4 = i12;
  HEAP32[i4 >> 2] = 327033209;
  HEAP32[i4 + 4 >> 2] = 1541459225;
  _sha512_update(i17, i15, i16);
  _sha512_update(i17, i13, i2);
  _hashmd_48(i17, i16, i22);
  i4 = (i16 | 0) == 0;
  if (i4) {
   _sha512_sum(i17, i22);
   i15 = i17;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   i15 = i5;
   HEAP32[i15 >> 2] = -205731576;
   HEAP32[i15 + 4 >> 2] = 1779033703;
   i15 = i6;
   HEAP32[i15 >> 2] = -2067093701;
   HEAP32[i15 + 4 >> 2] = -1150833019;
   i15 = i7;
   HEAP32[i15 >> 2] = -23791573;
   HEAP32[i15 + 4 >> 2] = 1013904242;
   i15 = i8;
   HEAP32[i15 >> 2] = 1595750129;
   HEAP32[i15 + 4 >> 2] = -1521486534;
   i15 = i9;
   HEAP32[i15 >> 2] = -1377402159;
   HEAP32[i15 + 4 >> 2] = 1359893119;
   i15 = i10;
   HEAP32[i15 >> 2] = 725511199;
   HEAP32[i15 + 4 >> 2] = -1694144372;
   i15 = i11;
   HEAP32[i15 >> 2] = -79577749;
   HEAP32[i15 + 4 >> 2] = 528734635;
   i15 = i12;
   HEAP32[i15 >> 2] = 327033209;
   HEAP32[i15 + 4 >> 2] = 1541459225;
  } else {
   i3 = i16;
   do {
    if (!(i3 & 1)) _sha512_update(i17, i15, i16); else _sha512_update(i17, i22, 64);
    i3 = i3 >>> 1;
   } while ((i3 | 0) != 0);
   _sha512_sum(i17, i22);
   i3 = i17;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i3 = i5;
   HEAP32[i3 >> 2] = -205731576;
   HEAP32[i3 + 4 >> 2] = 1779033703;
   i3 = i6;
   HEAP32[i3 >> 2] = -2067093701;
   HEAP32[i3 + 4 >> 2] = -1150833019;
   i3 = i7;
   HEAP32[i3 >> 2] = -23791573;
   HEAP32[i3 + 4 >> 2] = 1013904242;
   i3 = i8;
   HEAP32[i3 >> 2] = 1595750129;
   HEAP32[i3 + 4 >> 2] = -1521486534;
   i3 = i9;
   HEAP32[i3 >> 2] = -1377402159;
   HEAP32[i3 + 4 >> 2] = 1359893119;
   i3 = i10;
   HEAP32[i3 >> 2] = 725511199;
   HEAP32[i3 + 4 >> 2] = -1694144372;
   i3 = i11;
   HEAP32[i3 >> 2] = -79577749;
   HEAP32[i3 + 4 >> 2] = 528734635;
   i3 = i12;
   HEAP32[i3 >> 2] = 327033209;
   HEAP32[i3 + 4 >> 2] = 1541459225;
   if (!i4) {
    i3 = 0;
    do {
     _sha512_update(i17, i15, i16);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i16 | 0));
   }
  }
  _sha512_sum(i17, i18);
  i4 = i17;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = i5;
  HEAP32[i4 >> 2] = -205731576;
  HEAP32[i4 + 4 >> 2] = 1779033703;
  i4 = i6;
  HEAP32[i4 >> 2] = -2067093701;
  HEAP32[i4 + 4 >> 2] = -1150833019;
  i4 = i7;
  HEAP32[i4 >> 2] = -23791573;
  HEAP32[i4 + 4 >> 2] = 1013904242;
  i4 = i8;
  HEAP32[i4 >> 2] = 1595750129;
  HEAP32[i4 + 4 >> 2] = -1521486534;
  i4 = i9;
  HEAP32[i4 >> 2] = -1377402159;
  HEAP32[i4 + 4 >> 2] = 1359893119;
  i4 = i10;
  HEAP32[i4 >> 2] = 725511199;
  HEAP32[i4 + 4 >> 2] = -1694144372;
  i4 = i11;
  HEAP32[i4 >> 2] = -79577749;
  HEAP32[i4 + 4 >> 2] = 528734635;
  i4 = i12;
  HEAP32[i4 >> 2] = 327033209;
  HEAP32[i4 + 4 >> 2] = 1541459225;
  i4 = (HEAPU8[i22 >> 0] | 0) + 15 | 0;
  i3 = 0;
  while (1) {
   _sha512_update(i17, i13, i2);
   if ((i3 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
  _sha512_sum(i17, i19);
  if (i14 | 0) {
   i3 = 0;
   do {
    i4 = i17;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    i4 = i5;
    HEAP32[i4 >> 2] = -205731576;
    HEAP32[i4 + 4 >> 2] = 1779033703;
    i4 = i6;
    HEAP32[i4 >> 2] = -2067093701;
    HEAP32[i4 + 4 >> 2] = -1150833019;
    i4 = i7;
    HEAP32[i4 >> 2] = -23791573;
    HEAP32[i4 + 4 >> 2] = 1013904242;
    i4 = i8;
    HEAP32[i4 >> 2] = 1595750129;
    HEAP32[i4 + 4 >> 2] = -1521486534;
    i4 = i9;
    HEAP32[i4 >> 2] = -1377402159;
    HEAP32[i4 + 4 >> 2] = 1359893119;
    i4 = i10;
    HEAP32[i4 >> 2] = 725511199;
    HEAP32[i4 + 4 >> 2] = -1694144372;
    i4 = i11;
    HEAP32[i4 >> 2] = -79577749;
    HEAP32[i4 + 4 >> 2] = 528734635;
    i4 = i12;
    HEAP32[i4 >> 2] = 327033209;
    HEAP32[i4 + 4 >> 2] = 1541459225;
    i4 = (i3 & 1 | 0) != 0;
    if (i4) _hashmd_48(i17, i16, i18); else _sha512_update(i17, i22, 64);
    if ((i3 >>> 0) % 3 | 0 | 0) _sha512_update(i17, i19, i2);
    if ((i3 >>> 0) % 7 | 0 | 0) _hashmd_48(i17, i16, i18);
    if (i4) _sha512_update(i17, i22, 64); else _hashmd_48(i17, i16, i18);
    _sha512_sum(i17, i22);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i14 | 0));
  }
  HEAP32[i21 >> 2] = i20;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i13;
  i5 = _sprintf(i1, gb + 1056981 | 0, i21) | 0;
  i7 = i5 + 84 | 0;
  i5 = i1 + i5 | 0;
  i6 = 0;
  while (1) {
   i2 = HEAPU8[i22 + (HEAPU8[gb + 1056992 + (i6 * 3 | 0) + 1 >> 0] | 0) >> 0] << 8 | HEAPU8[i22 + (HEAPU8[gb + 1056992 + (i6 * 3 | 0) >> 0] | 0) >> 0] << 16 | HEAPU8[i22 + (HEAPU8[gb + 1056992 + (i6 * 3 | 0) + 2 >> 0] | 0) >> 0];
   i3 = i5;
   i4 = 4;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
    if ((i4 | 0) > 1) {
     i2 = i2 >>> 6;
     i3 = i3 + 1 | 0;
     i4 = i4 + -1 | 0;
    } else break;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 21) break; else i5 = i5 + 4 | 0;
  }
  i5 = i1 + i7 | 0;
  i2 = HEAPU8[i22 + 63 >> 0] | 0;
  i3 = i5;
  i4 = 2;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
   if ((i4 | 0) > 1) {
    i2 = i2 >>> 6;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else break;
  }
  HEAP8[i5 + 2 >> 0] = 0;
 } else i1 = 0; while (0);
 STACKTOP = i23;
 return i1 | 0;
}

function __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress(i34, i1, i2, i3, i5, i37, i32) {
 i34 = i34 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i37 = i37 | 0;
 i32 = i32 | 0;
 var i4 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i42 + 24 | 0;
 i33 = i42 + 16 | 0;
 i40 = i42 + 64 | 0;
 i41 = i42 + 44 | 0;
 i27 = i42;
 i28 = i42 + 40 | 0;
 i29 = i42 + 84 | 0;
 i30 = mftCall_iiii(HEAP32[(HEAP32[i34 >> 2] | 0) + 12 >> 2] | 0, i34 | 0, i1 | 0, 1) | 0;
 if ((i30 | 0) == -1) {
  i41 = 1;
  STACKTOP = i42;
  return i41 | 0;
 }
 i31 = HEAP32[(__ZN17PersistentManager26GetStreamNameSpaceInternalEi(i34, i30) | 0) >> 2] | 0;
 if (!i31) {
  i41 = 1;
  STACKTOP = i42;
  return i41 | 0;
 }
 i36 = gb + 64016 | 0;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 i4 = i33;
 HEAP32[i4 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i4 + 4 >> 2] = i35;
 HEAP32[i40 >> 2] = 0;
 i4 = i40 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i35 = i40 + 16 | 0;
 HEAP32[i35 >> 2] = 0;
 i36 = i40 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i33);
 i6 = i26;
 i38 = HEAP32[i6 + 4 >> 2] | 0;
 i39 = i36;
 HEAP32[i39 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i39 + 4 >> 2] = i38;
 i39 = gb + 64016 | 0;
 i38 = HEAP32[i39 + 4 >> 2] | 0;
 i6 = i33;
 HEAP32[i6 >> 2] = HEAP32[i39 >> 2];
 HEAP32[i6 + 4 >> 2] = i38;
 HEAP32[i41 >> 2] = 0;
 i6 = i41 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i38 = i41 + 16 | 0;
 HEAP32[i38 >> 2] = 0;
 i39 = i41 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i33);
 i23 = i26;
 i24 = HEAP32[i23 + 4 >> 2] | 0;
 i25 = i39;
 HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i25 + 4 >> 2] = i24;
 if ((i5 | 0) == -1) {
  __ZN17PersistentManager13GetAllFileIDsERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EE(i34, i1, i40);
  i3 = HEAP32[i40 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  f8 = Math_fround(i4 | 0);
  i1 = i32 + 8 | 0;
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f8);
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i4;
  i2 = HEAP32[i38 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i38 >> 2] = i4;
   HEAP32[i41 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i41 >> 2] | 0, i4 << 2, 4, i39, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i39, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i25 | 0, HEAP32[i41 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i38 >> 2] = i4;
   HEAP32[i41 >> 2] = i25;
   break;
  } while (0);
  if (i4 >>> 0 > i1 >>> 0) _memset((HEAP32[i41 >> 2] | 0) + (i1 << 2) | 0, 0, i4 - i1 << 2 | 0) | 0;
  i2 = i3;
  i25 = HEAP32[i41 >> 2] | 0;
  i5 = i4;
 } else i25 = i3;
 i6 = (i5 | 0) > 0;
 do if (i37) {
  if (i6) {
   i1 = 0;
   i3 = 0;
   i4 = 0;
   do {
    i24 = i2 + (i1 << 3) | 0;
    i22 = HEAP32[i24 >> 2] | 0;
    i24 = HEAP32[i24 + 4 >> 2] | 0;
    i23 = (i3 | 0) < (i24 | 0) | (i3 | 0) == (i24 | 0) & i4 >>> 0 < i22 >>> 0;
    i4 = i23 ? i22 : i4;
    i3 = i23 ? i24 : i3;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
   i1 = _bitshift64Shl(i4 | 0, i3 | 0, 1) | 0;
   i3 = getTempRet0() | 0;
  } else {
   i1 = 0;
   i3 = 0;
  }
  i24 = HEAP32[i34 + 56 >> 2] | 0;
  i22 = i24 + 24 | 0;
  i4 = (HEAP32[i22 >> 2] | 0) + 2 | 0;
  HEAP32[i24 + 28 >> 2] = i4;
  i23 = _i64Add(i4 | 0, 0, i1 | 0, i3 | 0) | 0;
  getTempRet0() | 0;
  HEAP32[i22 >> 2] = i23;
  HEAP32[i24 + 32 >> 2] = i23;
  HEAP32[i24 + 36 >> 2] = i30;
  if (i6) {
   i1 = 0;
   do {
    i24 = i2 + (i1 << 3) | 0;
    i24 = _bitshift64Shl(HEAP32[i24 >> 2] | 0, HEAP32[i24 + 4 >> 2] | 0, 1) | 0;
    i24 = _i64Add(i24 | 0, getTempRet0() | 0, i4 | 0, 0) | 0;
    getTempRet0() | 0;
    HEAP32[i25 + (i1 << 2) >> 2] = i24;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
   i9 = 22;
  } else {
   i1 = i34 + 84 | 0;
   HEAP32[i1 >> 2] = i30;
   break;
  }
 } else {
  if (i6) {
   i3 = i34 + 56 | 0;
   i4 = i26 + 8 | 0;
   i1 = 0;
   do {
    i22 = i2 + (i1 << 3) | 0;
    i21 = HEAP32[i22 >> 2] | 0;
    i22 = HEAP32[i22 + 4 >> 2] | 0;
    i24 = HEAP32[i3 >> 2] | 0;
    HEAP32[i26 >> 2] = i30;
    i23 = i4;
    HEAP32[i23 >> 2] = i21;
    HEAP32[i23 + 4 >> 2] = i22;
    HEAP32[i25 + (i1 << 2) >> 2] = __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(i24, i26) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  __ZN17PersistentManager22CheckInstanceIDsLoadedEPii(i34, i25, i5);
  i9 = 22;
 } while (0);
 L36 : do if ((i9 | 0) == 22) {
  i1 = i34 + 84 | 0;
  HEAP32[i1 >> 2] = i30;
  i24 = i34 + 192 | 0;
  if (i6) {
   i13 = i32 + 8 | 0;
   i14 = i32 + 12 | 0;
   i12 = i27 + 8 | 0;
   i15 = i37 ^ 1;
   i16 = i34 + 176 | 0;
   i17 = i34 + 120 | 0;
   i18 = i34 + 168 | 0;
   i19 = i34 + 172 | 0;
   i20 = i32 + 28 | 0;
   i21 = i32 + 16 | 0;
   i22 = i34 + 116 | 0;
   i23 = i32 + 4 | 0;
   i11 = 0;
   do {
    if (HEAP8[i24 >> 0] | 0) break L36;
    f8 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + Math_fround(1.0));
    HEAPF32[i26 >> 2] = f8;
    f7 = Math_fround(HEAPF32[i13 >> 2]);
    i10 = HEAP32[(f8 < f7 ? i26 : i13) >> 2] | 0;
    HEAP32[i14 >> 2] = i10;
    i3 = HEAP32[i32 >> 2] | 0;
    f8 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (i3 | 0) {
     if (f7 == Math_fround(0.0)) f7 = Math_fround(1.0); else f7 = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2])) / f7);
     HEAPF32[i3 >> 2] = f7;
    }
    i9 = HEAP32[i25 + (i11 << 2) >> 2] | 0;
    if (i9 | 0) {
     i4 = _bitshift64Ashr(0, HEAP32[i2 + (i11 << 3) >> 2] | 0, 32) | 0;
     i6 = getTempRet0() | 0;
     HEAP32[i27 >> 2] = i30;
     i3 = i12;
     HEAP32[i3 >> 2] = i4;
     HEAP32[i3 + 4 >> 2] = i6;
     HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i26 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
     HEAP32[i26 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
     HEAP32[i26 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
     i3 = __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib(i34, i31, i26, i9, 1) | 0;
     if (i3 | 0) {
      i10 = HEAP32[i3 + 8 >> 2] | 0;
      __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object(i31, i4, i6, 1, i15, i28, i29, i10);
      i4 = HEAP32[i28 >> 2] | 0;
      i6 = HEAP8[i29 >> 0] | 0;
      HEAP32[i33 >> 2] = i9;
      if ((HEAP32[i16 >> 2] | 0) == (HEAP32[i17 >> 2] | 0)) i3 = (HEAP32[i18 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 20 | 0) | 0; else {
       __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i26, i22, i33);
       i3 = HEAP32[i26 >> 2] | 0;
       i9 = HEAP32[i18 >> 2] | 0;
       i3 = (i3 | 0) == -1 ? i9 + ((HEAP32[i19 >> 2] | 0) * 20 | 0) | 0 : i9 + (i3 * 20 | 0) | 0;
      }
      i9 = HEAP32[i3 + 12 >> 2] | 0;
      mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0);
      HEAP32[i3 + 8 >> 2] = i4;
      HEAP8[i3 + 16 >> 0] = i6;
      HEAP8[i3 + 17 >> 0] = 1;
      if (HEAP32[i20 >> 2] | 0) {
       i3 = 0;
       do {
        i9 = HEAP32[i21 >> 2] | 0;
        mftCall_vii(HEAP32[i9 + (i3 << 3) >> 2] | 0, i10 | 0, HEAP32[i9 + (i3 << 3) + 4 >> 2] | 0);
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0);
      }
     }
    }
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) < (i5 | 0));
  }
 } while (0);
 HEAP32[i1 >> 2] = -1;
 __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i34);
 if (i37) {
  i37 = HEAP32[i34 + 56 >> 2] | 0;
  HEAP32[i37 + 28 >> 2] = 0;
  HEAP32[i37 + 32 >> 2] = 0;
  HEAP32[i37 + 36 >> 2] = -1;
 }
 if ((HEAP32[i38 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i41 >> 2] | 0, i39);
  HEAP32[i41 >> 2] = 0;
 }
 if ((HEAP32[i35 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i40 >> 2] | 0, i36);
  HEAP32[i40 >> 2] = 0;
 }
 i41 = 0;
 STACKTOP = i42;
 return i41 | 0;
}

function __Z19FlattenRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i14, i1, i11) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i1);
 i12 = i14 + 11 | 0;
 i2 = HEAP8[i12 >> 0] | 0;
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i14 >> 2] | 0 : i14;
 i13 = i14 + 4 | 0;
 i9 = i9 ? HEAP32[i13 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9) {
  do {
   if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i2 = HEAP8[i12 >> 0] | 0;
 }
 if (i2 << 24 >> 24 < 0) {
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
 } else {
  i1 = i2 & 255;
  i3 = i14;
 }
 L13 : do if (i1 >>> 0 >= 2) {
  i8 = i3 + i1 | 0;
  i6 = i8;
  i7 = i3;
  L15 : do if ((i1 | 0) < 2) i3 = i6; else {
   i5 = i8 + -1 | 0;
   if ((i5 | 0) == (i3 | 0)) i3 = i6; else L17 : while (1) {
    while (1) {
     if ((HEAP8[i3 >> 0] | 0) == 47) {
      i1 = gb + 488812 | 0;
      i4 = i3;
      break;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i5 | 0)) {
      i3 = i6;
      break L15;
     }
    }
    do {
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (gb + 488812 + 2 | 0)) break L17;
     i4 = i4 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i5 | 0)) {
     i3 = i6;
     break L15;
    }
   }
  } while (0);
  i1 = i3 - i7 | 0;
  if (!((i3 | 0) == (i8 | 0) | (i1 | 0) == -1)) do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKc(i14, i1, 2, gb + 1087627 | 0) | 0;
   i2 = HEAP8[i12 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i1 = HEAP32[i13 >> 2] | 0;
    i3 = HEAP32[i14 >> 2] | 0;
   } else {
    i1 = i2 & 255;
    i3 = i14;
   }
   if (i1 >>> 0 < 2) break L13;
   i8 = i3 + i1 | 0;
   i6 = i8;
   i7 = i3;
   L35 : do if ((i1 | 0) < 2) i3 = i6; else {
    i5 = i8 + -1 | 0;
    if ((i5 | 0) == (i3 | 0)) i3 = i6; else L37 : while (1) {
     while (1) {
      if ((HEAP8[i3 >> 0] | 0) == 47) {
       i1 = gb + 488812 | 0;
       i4 = i3;
       break;
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i5 | 0)) {
       i3 = i6;
       break L35;
      }
     }
     do {
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (gb + 488812 + 2 | 0)) break L37;
      i4 = i4 + 1 | 0;
     } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i5 | 0)) {
      i3 = i6;
      break L35;
     }
    }
   } while (0);
   i1 = i3 - i7 | 0;
  } while (!((i3 | 0) == (i8 | 0) | (i1 | 0) == -1));
 } while (0);
 i5 = i2 << 24 >> 24 < 0;
 if (i5) i1 = HEAP32[i13 >> 2] | 0; else i1 = i2 & 255;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 if (i5) {
  i4 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = i4;
 } else {
  i1 = i2 & 255;
  i3 = i14;
  i4 = HEAP32[i14 >> 2] | 0;
 }
 i7 = HEAP8[i3 >> 0] | 0;
 i8 = (HEAP8[i3 + (i1 + -1) >> 0] | 0) == 47;
 __Z27FindSeparatedPathComponentsPKcjc(i15, i5 ? i4 : i14, i5 ? HEAP32[i13 >> 2] | 0 : i2 & 255, 47);
 i1 = HEAP32[i15 >> 2] | 0;
 i9 = i15 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) != (HEAP32[i9 >> 2] | 0)) do {
  i4 = i1 + 11 | 0;
  i5 = HEAP8[i4 >> 0] | 0;
  i6 = i2 + 4 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  do if (((i5 << 24 >> 24 < 0 ? i3 : i5 & 255) | 0) == 1) {
   if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, gb + 1087625 | 0, 1) | 0) {
    i5 = HEAP8[i4 >> 0] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i10 = 52;
    break;
   }
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = i2 + (((i1 - i2 | 0) / 12 | 0) * 12 | 0) | 0;
   i2 = i1 + 12 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i3 = i1;
    i10 = 49;
   } else {
    i3 = i1;
    do {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
     i2 = i2 + 12 | 0;
     i3 = i3 + 12 | 0;
    } while ((i2 | 0) != (i4 | 0));
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) i10 = 49;
   }
   if ((i10 | 0) == 49) {
    i10 = 0;
    do {
     i6 = i2 + -12 | 0;
     HEAP32[i9 >> 2] = i6;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
     i2 = HEAP32[i9 >> 2] | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
  } else i10 = 52; while (0);
  L77 : do if ((i10 | 0) == 52) {
   i10 = 0;
   if (((i5 << 24 >> 24 < 0 ? i3 : i5 & 255) | 0) == 2) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, gb + 491572 | 0, 2) | 0)) {
    i3 = (i2 | 0) == (HEAP32[i15 >> 2] | 0);
    if (i3 & i11) {
     i1 = i2 + (((i1 - i2 | 0) / 12 | 0) * 12 | 0) | 0;
     i2 = i1 + 12 | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     if ((i2 | 0) == (i4 | 0)) {
      i3 = i1;
      i10 = 58;
     } else {
      i3 = i1;
      do {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
       i2 = i2 + 12 | 0;
       i3 = i3 + 12 | 0;
      } while ((i2 | 0) != (i4 | 0));
      i2 = HEAP32[i9 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) i10 = 58;
     }
     if ((i10 | 0) == 58) {
      i10 = 0;
      do {
       i6 = i2 + -12 | 0;
       HEAP32[i9 >> 2] = i6;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
       i2 = HEAP32[i9 >> 2] | 0;
      } while ((i2 | 0) != (i3 | 0));
     }
     break;
    }
    if (i3) {
     i1 = i2 + 12 | 0;
     break;
    }
    i3 = i2 + -12 | 0;
    i1 = i3;
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0)) {
     i5 = i3;
     i4 = i2;
     i10 = 65;
    } else {
     i4 = i2;
     i6 = i3;
     do {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i4) | 0;
      i4 = i4 + 12 | 0;
      i6 = i6 + 12 | 0;
     } while ((i4 | 0) != (i5 | 0));
     i4 = HEAP32[i9 >> 2] | 0;
     if ((i4 | 0) == (i6 | 0)) i4 = i6; else {
      i5 = i6;
      i10 = 65;
     }
    }
    if ((i10 | 0) == 65) {
     i10 = 0;
     do {
      i6 = i4 + -12 | 0;
      HEAP32[i9 >> 2] = i6;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
      i4 = HEAP32[i9 >> 2] | 0;
     } while ((i4 | 0) != (i5 | 0));
     i4 = i5;
    }
    if ((i2 | 0) != (i4 | 0)) {
     do {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
      i2 = i2 + 12 | 0;
      i3 = i3 + 12 | 0;
     } while ((i2 | 0) != (i4 | 0));
     i2 = HEAP32[i9 >> 2] | 0;
     if ((i2 | 0) == (i3 | 0)) break;
    }
    while (1) {
     i6 = i2 + -12 | 0;
     HEAP32[i9 >> 2] = i6;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
     i2 = HEAP32[i9 >> 2] | 0;
     if ((i2 | 0) == (i3 | 0)) break L77;
    }
   }
   i1 = i2 + 12 | 0;
  } while (0);
  i2 = i1;
 } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i14, 0, 0);
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  if (!(i7 << 24 >> 24 != 47 | i11)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, gb + 1087627 | 0) | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 | 0)) do {
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i10 = i11 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, i10 ? HEAP32[i1 >> 2] | 0 : i1, i10 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i14, gb + 1087627 | 0) | 0;
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (HEAP32[i9 >> 2] | 0));
  if (!i8) {
   i1 = HEAP8[i12 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) i1 = HEAP32[i13 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i14, i1 + -1 | 0, 0);
  }
  i1 = HEAP32[i15 >> 2] | 0;
 }
 if (i1 | 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i14 = i2 + -12 | 0;
    HEAP32[i9 >> 2] = i14;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i15 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_(i1, i2, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 L1 : while (1) {
  i10 = i2;
  i11 = i2 + -8 | 0;
  i13 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i10 - i9 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i12 = 5;
      break L1;
     }
    case 3:
     {
      i12 = 7;
      break L1;
     }
    case 4:
     {
      i12 = 8;
      break L1;
     }
    case 5:
     {
      i12 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i12 = 56;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 56) {
     i12 = 14;
     break L1;
    }
    i6 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_(i1, i1 + (i3 << 3) | 0, i6, i6 + (i3 << 3) | 0, i11, i15) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i1, i6, i11, i15) | 0;
    if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
     i5 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i5 = i4 + -8 | 0;
     if ((i1 | 0) == (i5 | 0)) break;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
      i12 = 39;
      break L5;
     } else i4 = i5;
    }
    i3 = i1 + 8 | 0;
    if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i11 | 0) | 0)) {
     if ((i3 | 0) == (i11 | 0)) {
      i12 = 56;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i12 = 56;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i8;
     i8 = i3 + 4 | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i13 >> 2] = i9;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i12 = 56;
     break L1;
    } else i4 = i11;
    while (1) {
     while (1) {
      i6 = i3 + 8 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i6;
     }
     while (1) {
      i5 = i4 + -8 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i5 | 0) | 0) i4 = i5; else break;
     }
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i9 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i9;
     i9 = i3 + 4 | 0;
     i4 = i4 + -4 | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     i4 = i5;
     i3 = i6;
    }
   }
   if ((i12 | 0) == 39) {
    i12 = 0;
    i17 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i17;
    i17 = i1 + 4 | 0;
    i8 = i4 + -4 | 0;
    i7 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i4 = i1 + 8 | 0;
   L35 : do if (i4 >>> 0 < i5 >>> 0) {
    i8 = i6;
    while (1) {
     while (1) {
      i7 = i4 + 8 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i4 | 0, i8 | 0) | 0) i4 = i7; else break;
     }
     while (1) {
      i6 = i5 + -8 | 0;
      if (mftCall_iii(HEAP32[i15 >> 2] | 0, i6 | 0, i8 | 0) | 0) break; else i5 = i6;
     }
     if (i4 >>> 0 > i6 >>> 0) {
      i5 = i8;
      i6 = i4;
      break L35;
     }
     i18 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = i18;
     i18 = i4 + 4 | 0;
     i5 = i5 + -4 | 0;
     i17 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i17;
     i8 = (i8 | 0) == (i4 | 0) ? i6 : i8;
     i5 = i6;
     i4 = i7;
     i3 = i3 + 1 | 0;
    }
   } else {
    i5 = i6;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) if (mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i6 | 0) | 0) {
    i8 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i5 >> 2] = i8;
    i8 = i6 + 4 | 0;
    i18 = i5 + 4 | 0;
    i17 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i18 >> 2] = i17;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEbT0_SB_T_(i1, i6, i15) | 0;
    i4 = i6 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEbT0_SB_T_(i4, i2, i15) | 0) {
     i12 = 55;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i18 = i6;
   if ((i18 - i9 | 0) >= (i10 - i18 | 0)) {
    i12 = 54;
    break;
   }
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_(i1, i6, i15);
   i1 = i6 + 8 | 0;
  }
  if ((i12 | 0) == 54) {
   i12 = 0;
   __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_(i6 + 8 | 0, i2, i15);
   i2 = i6;
   continue;
  } else if ((i12 | 0) == 55) {
   i12 = 0;
   if (i3) {
    i12 = 56;
    break;
   } else {
    i2 = i6;
    continue;
   }
  }
 }
 if ((i12 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i11 | 0, i1 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i17 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i17;
  i17 = i1 + 4 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i18;
  STACKTOP = i16;
  return;
 } else if ((i12 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i1, i1 + 8 | 0, i11, i15) | 0;
  STACKTOP = i16;
  return;
 } else if ((i12 | 0) == 8) {
  i4 = i1 + 8 | 0;
  i2 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i1, i4, i2, i15) | 0;
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i11 | 0, i2 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i3;
  i3 = i1 + 20 | 0;
  i18 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i18;
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i2 | 0, i4 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i18 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i18;
  i2 = i1 + 12 | 0;
  i18 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i18;
  if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i4 | 0, i1 | 0) | 0)) {
   STACKTOP = i16;
   return;
  }
  i17 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i17;
  i17 = i1 + 4 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i18;
  STACKTOP = i16;
  return;
 } else if ((i12 | 0) == 12) {
  __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i11, i15) | 0;
  STACKTOP = i16;
  return;
 } else if ((i12 | 0) == 14) {
  i3 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i1, i1 + 8 | 0, i3, i15) | 0;
  i4 = i1 + 24 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i16;
   return;
  }
  i7 = i14 + 4 | 0;
  while (1) {
   if (mftCall_iii(HEAP32[i15 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    i17 = i4;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i5 = i14;
    HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i5 + 4 >> 2] = i18;
    i5 = i4;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     i6 = i3 + 4 | 0;
     HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
     if ((i3 | 0) == (i1 | 0)) break;
     i5 = i3 + -8 | 0;
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i14 | 0, i5 | 0) | 0) {
      i18 = i3;
      i3 = i5;
      i5 = i18;
     } else break;
    }
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   }
   i3 = i4 + 8 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i18 = i4;
    i4 = i3;
    i3 = i18;
   }
  }
  STACKTOP = i16;
  return;
 } else if ((i12 | 0) == 56) {
  STACKTOP = i16;
  return;
 }
}

function __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i12) {
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i6 = i13;
 i8 = i12 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i7 + 4;
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i11 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i12, i11, 0);
 i5 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i3 = i5;
  i2 = i4 | 0 ? i4 - i3 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i3 | 0, i1 << 4);
 }
 i3 = i7 + 12 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i7 + 16;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i11 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i12, i11, 0);
 i5 = i7 + 20 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i3 = i5;
  i2 = i4 | 0 ? i4 - i3 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i3 | 0, i1 << 4);
 }
 i1 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i3 = i7 + 32 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i7 + 36;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i11 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i12, i11, 0);
 i5 = i7 + 40 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i3 = i5;
  i2 = i4 | 0 ? i4 - i3 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i3 | 0, i1 << 4);
 }
 i4 = i7 + 48 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 44 >> 2] = i1;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 1) | 0;
  _memset(i3 | 0, 0, i1 | 0) | 0;
  i2 = i4;
  i3 = i3 | 0 ? i3 - i2 | 0 : 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i3 + i2 | 0, i1);
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 i4 = i7 + 56 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 52 >> 2] = i1;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 1) | 0;
  _memset(i3 | 0, 0, i1 | 0) | 0;
  i2 = i4;
  i3 = i3 | 0 ? i3 - i2 | 0 : 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i3 + i2 | 0, i1);
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 i4 = i7 + 64 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 60 >> 2] = i1;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 1) | 0;
  _memset(i3 | 0, 0, i1 | 0) | 0;
  i2 = i4;
  i3 = i3 | 0 ? i3 - i2 | 0 : 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i3 + i2 | 0, i1);
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 i5 = i7 + 72 | 0;
 i6 = i7 + 68 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i4 | 0, i1 << 2);
 }
 i5 = i7 + 76 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i11, 4);
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i3;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i1 = i3 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i3 = i5;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i3 | 0, i1 << 2);
 STACKTOP = i13;
 return;
}

function __ZN13AnimationClip8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 16 | 0;
 i9 = i14;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i11);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i11, 6);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897930 | 0, i6, i10 + 212 | 0, 0);
 i12 = i11 + 16 | 0;
 i13 = i11 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i7 = i10 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897939 | 0, i6, i7, 16);
 HEAP32[(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897952 | 0, i6, i10 + 93 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i11);
 if (!(HEAP8[i7 >> 0] | 0)) {
  i9 = i10 + 100 | 0;
  i1 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897974 | 0, i1, i9, 1);
  __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897991 | 0, i1, i8, 1);
  __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i8, 0);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
  __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i8);
 } else {
  HEAP32[i9 >> 2] = 0;
  i6 = i9 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[gb + 37316 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897974 | 0, i1, i9, 1);
  __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
  if (!(HEAP32[i11 >> 2] & 33554432)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 897991 | 0, i1, i8, 1);
   __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i8, 0);
   __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i8);
  }
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i7 = i8 + 4 | 0;
    do {
     i4 = i3 + -204 | 0;
     HEAP32[i6 >> 2] = i4;
     i5 = i3 + -36 | 0;
     if ((HEAP32[i3 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3 + -32 | 0);
      HEAP32[i5 >> 2] = 0;
     }
     if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
      i5 = HEAP32[i4 >> 2] | 0;
      i4 = HEAP32[i3 + -192 >> 2] | 0;
      HEAP32[i8 >> 2] = 66;
      HEAP32[i7 >> 2] = i4;
      __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
     }
     i3 = HEAP32[i6 >> 2] | 0;
    } while ((i3 | 0) != (i2 | 0));
    i2 = HEAP32[i9 >> 2] | 0;
   }
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i8 >> 2] = 25;
   HEAP32[i8 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
  }
 }
 i9 = i10 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898018 | 0, i1, i9, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i9 = i10 + 132 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898032 | 0, i1, i9, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i9 = i10 + 148 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898049 | 0, i1, i9, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i9 = i10 + 164 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898063 | 0, i1, i9, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i9 = i10 + 180 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898077 | 0, i1, i9, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898090 | 0, HEAP32[gb + 37012 >> 2] | 0, i10 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 896261 | 0, HEAP32[gb + 37040 >> 2] | 0, i10 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i12 >> 2] >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i13 = i10 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898103 | 0, gb + 1034406 | 0, i13, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i11, i13, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i11, i10 + 284 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 HEAP32[i11 + 4 >> 2] = i10 + 56;
 __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE24GenerateTypeTreeTransferEvRPT_PKcRjS8_RT0_(i10 + 216 | 0, gb + 898128 | 0, i10 + 220 | 0, gb + 898141 | 0, i11);
 i13 = i10 + 224 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898158 | 0, gb + 898180 | 0, i13, 0);
 __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i13, i11);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 i13 = i10 + 196 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i11, gb + 898209 | 0, i1, i13, 1);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i13, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i11);
 STACKTOP = i14;
 return;
}

function __ZN18UnityConnectClient17InitConnectClientEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 64 | 0;
 i15 = i16 + 48 | 0;
 i11 = i16 + 32 | 0;
 i12 = i16 + 16 | 0;
 i13 = i16;
 if (!(__Z24GetManagerPtrFromContexti(22) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = __Z21GetManagerFromContexti(22) | 0;
 if (!(HEAP8[i7 + 197 >> 0] | 0)) if (__Z20IsHumanControllingUsv() | 0) {
  i1 = 0;
  i2 = 0;
  i9 = 39;
 } else i1 = 0; else {
  i3 = i7 + 216 | 0;
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i7 + 220 >> 2] | 0 : i4 & 255;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i9 = 6;
  } else if (i4 >>> 0 < 11) {
   i2 = i12 + 11 | 0;
   HEAP8[i2 >> 0] = i4;
   if (!i4) i1 = i12; else {
    i1 = i12;
    i9 = 8;
   }
  } else i9 = 6;
  if ((i9 | 0) == 6) {
   i2 = i4 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i4;
   i2 = i12 + 11 | 0;
   i9 = 8;
  }
  if ((i9 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  i6 = HEAP8[i2 >> 0] | 0;
  i8 = i6 << 24 >> 24 < 0;
  i5 = i8 ? HEAP32[i12 >> 2] | 0 : i12;
  i6 = i8 ? HEAP32[i12 + 4 >> 2] | 0 : i6 & 255;
  i8 = i15 + 11 | 0;
  i1 = HEAP8[i8 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i15 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   i3 = i3 ? HEAP32[i15 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i4, i6 - i4 | 0, i3, 0, i3, i6, i5);
  } else {
   i1 = i3 ? HEAP32[i15 >> 2] | 0 : i15;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i15 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i8 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   i6 = HEAP32[i12 >> 2] | 0;
   i5 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i14);
  }
  i3 = i7 + 200 | 0;
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i7 + 204 >> 2] | 0 : i4 & 255;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i9 = 23;
  } else if (i4 >>> 0 < 11) {
   i2 = i12 + 11 | 0;
   HEAP8[i2 >> 0] = i4;
   if (!i4) i1 = i12; else {
    i1 = i12;
    i9 = 25;
   }
  } else i9 = 23;
  if ((i9 | 0) == 23) {
   i2 = i4 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i4;
   i2 = i12 + 11 | 0;
   i9 = 25;
  }
  if ((i9 | 0) == 25) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  i6 = HEAP8[i2 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i12 >> 2] | 0 : i12;
  i6 = i7 ? HEAP32[i12 + 4 >> 2] | 0 : i6 & 255;
  i7 = i11 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   i9 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i4, i6 - i4 | 0, i9, 0, i9, i6, i5);
  } else {
   i1 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i11 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   i9 = HEAP32[i12 >> 2] | 0;
   i7 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
  }
  i1 = HEAP8[i8 >> 0] | 0;
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  i9 = 39;
 }
 if ((i9 | 0) == 39) {
  i3 = i1 << 24 >> 24 < 0;
  i7 = i3 ? i2 : i1 & 255;
  do if (i7 | 0) {
   i1 = i10 + 116 | 0;
   if ((i1 | 0) != (i15 | 0)) {
    i6 = i3 ? HEAP32[i15 >> 2] | 0 : i15;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i10 + 124 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i10 + 120 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i1 = HEAP32[i1 >> 2] | 0;
    _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i10 + 120 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   }
  } while (0);
  i7 = i11 + 11 | 0;
  i8 = HEAP8[i7 >> 0] | 0;
  i1 = i8 << 24 >> 24 < 0;
  i8 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  do if (i8 | 0) {
   i5 = i10 + 132 | 0;
   if ((i5 | 0) != (i11 | 0)) {
    i6 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
    i3 = i5 + 11 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i4 = (HEAP32[i10 + 140 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i8 >>> 0 > i4 >>> 0) {
     if (i2) i1 = HEAP32[i10 + 136 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i8 - i4 | 0, i1, 0, i1, i8, i6);
     break;
    }
    if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
    _memmove(i1 | 0, i6 | 0, i8 | 0) | 0;
    HEAP8[i1 + i8 >> 0] = 0;
    if ((HEAP8[i3 >> 0] | 0) < 0) {
     HEAP32[i10 + 136 >> 2] = i8;
     break;
    } else {
     HEAP8[i3 >> 0] = i8;
     break;
    }
   }
  } while (0);
  __ZN11UnityEngine15PlatformWrapper17GetCloudProjectIdEv(i12);
  __ZN11UnityEngine15PlatformWrapper14GetProductGUIDEv(i13);
  __ZN22BaseUnityConnectClient17InitializeSessionERK8UnityStrS2_N19CloudServiceHandler13InitModeFlagsE(i10, i12, i13, 0) | 0;
  if ((HEAP8[i13 + 11 >> 0] | 0) < 0) {
   i10 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i14);
  }
  if ((HEAP8[i12 + 11 >> 0] | 0) < 0) {
   i13 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
  }
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   i13 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
   i1 = 1;
  } else i1 = 1;
 }
 if ((HEAP8[i15 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
 }
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx25PxVehicleConstraintShader36vehicleSuspLimitConstraintSolverPrepEPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvRKNS_11PxTransformESB_(i12, i2, i5, i1, i11, i3, i4) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0;
 f15 = Math_fround(-Math_fround(HEAPF32[i11 + 348 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i11 + 352 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[i11 + 356 >> 2]));
 f18 = Math_fround(HEAPF32[i11 + 360 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f6 = Math_fround(f17 * f15);
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f18 * f16));
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f14 * f9));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f10 * f13));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f13) + Math_fround(f18 * f14)) + Math_fround(f10 * f15)) - Math_fround(f16 * f9));
 f8 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(f17 * f9) + Math_fround(f18 * f10))) - Math_fround(f14 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f13)) - Math_fround(f10 * f9));
 i2 = i11 + 48 | 0;
 f10 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
 i3 = i11 + 96 | 0;
 i4 = 0;
 i1 = 0;
 do {
  if (HEAP8[i11 + (i4 + 112) >> 0] | 0) {
   i5 = i2 + (i4 * 12 | 0) | 0;
   f18 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
   i20 = i2 + (i4 * 12 | 0) + 4 | 0;
   f14 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(2.0));
   i21 = i2 + (i4 * 12 | 0) + 8 | 0;
   f19 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * Math_fround(2.0));
   f15 = Math_fround(Math_fround(Math_fround(f6 * f18) + Math_fround(f7 * f14)) + Math_fround(f8 * f19));
   f16 = Math_fround(Math_fround(f7 * f15) + Math_fround(Math_fround(f10 * f14) + Math_fround(f9 * Math_fround(Math_fround(f8 * f18) - Math_fround(f6 * f19)))));
   f13 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f9 * Math_fround(Math_fround(f6 * f14) - Math_fround(f7 * f18)))) + Math_fround(f8 * f15));
   HEAPF32[i12 + (i1 * 80 | 0) >> 2] = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f10 * f18) + Math_fround(f9 * Math_fround(Math_fround(f7 * f19) - Math_fround(f8 * f14)))));
   HEAPF32[i12 + (i1 * 80 | 0) + 4 >> 2] = f16;
   HEAPF32[i12 + (i1 * 80 | 0) + 8 >> 2] = f13;
   f13 = Math_fround(HEAPF32[i11 + (i4 * 12 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i21 >> 2]);
   f14 = Math_fround(f13 * f16);
   f19 = Math_fround(HEAPF32[i11 + (i4 * 12 | 0) + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i20 >> 2]);
   f14 = Math_fround(f14 - Math_fround(f19 * f18));
   f15 = Math_fround(HEAPF32[i5 >> 2]);
   f19 = Math_fround(f19 * f15);
   f17 = Math_fround(HEAPF32[i11 + (i4 * 12 | 0) >> 2]);
   f14 = Math_fround(f14 * Math_fround(2.0));
   f16 = Math_fround(Math_fround(f19 - Math_fround(f16 * f17)) * Math_fround(2.0));
   f15 = Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f13 * f15)) * Math_fround(2.0));
   f13 = Math_fround(Math_fround(f8 * f15) + Math_fround(Math_fround(f6 * f14) + Math_fround(f7 * f16)));
   f17 = Math_fround(Math_fround(f7 * f13) + Math_fround(Math_fround(f10 * f16) + Math_fround(f9 * Math_fround(Math_fround(f8 * f14) - Math_fround(f6 * f15)))));
   f18 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(f9 * Math_fround(Math_fround(f6 * f16) - Math_fround(f7 * f14)))) + Math_fround(f8 * f13));
   HEAPF32[i12 + (i1 * 80 | 0) + 16 >> 2] = Math_fround(Math_fround(f6 * f13) + Math_fround(Math_fround(f10 * f14) + Math_fround(f9 * Math_fround(Math_fround(f7 * f15) - Math_fround(f8 * f16)))));
   HEAPF32[i12 + (i1 * 80 | 0) + 20 >> 2] = f17;
   HEAPF32[i12 + (i1 * 80 | 0) + 24 >> 2] = f18;
   HEAP32[i12 + (i1 * 80 | 0) + 12 >> 2] = HEAP32[i3 + (i4 << 2) >> 2];
   HEAP32[i12 + (i1 * 80 | 0) + 32 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 36 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 40 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 48 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 52 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 56 >> 2] = 0;
   HEAPF32[i12 + (i1 * 80 | 0) + 44 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i12 + (i1 * 80 | 0) + 60 >> 2] = Math_fround(0.0);
   HEAPF32[i12 + (i1 * 80 | 0) + 28 >> 2] = Math_fround(0.0);
   i1 = i1 + 1 | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 4);
 i2 = i11 + 116 | 0;
 i3 = i11 + 164 | 0;
 i4 = i11 + 212 | 0;
 i5 = 0;
 do {
  if (HEAP8[i11 + (i5 + 228) >> 0] | 0) {
   i21 = i3 + (i5 * 12 | 0) | 0;
   HEAP32[i12 + (i1 * 80 | 0) >> 2] = HEAP32[i21 >> 2];
   i20 = i3 + (i5 * 12 | 0) + 4 | 0;
   HEAP32[i12 + (i1 * 80 | 0) + 4 >> 2] = HEAP32[i20 >> 2];
   i22 = i3 + (i5 * 12 | 0) + 8 | 0;
   HEAP32[i12 + (i1 * 80 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
   f16 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i22 >> 2]);
   f17 = Math_fround(f16 * f18);
   f13 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i20 >> 2]);
   f17 = Math_fround(f17 - Math_fround(f13 * f14));
   f19 = Math_fround(HEAPF32[i21 >> 2]);
   f13 = Math_fround(f13 * f19);
   f15 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
   f18 = Math_fround(f13 - Math_fround(f18 * f15));
   f19 = Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f19));
   HEAPF32[i12 + (i1 * 80 | 0) + 16 >> 2] = f17;
   HEAPF32[i12 + (i1 * 80 | 0) + 20 >> 2] = f18;
   HEAPF32[i12 + (i1 * 80 | 0) + 24 >> 2] = f19;
   HEAPF32[i12 + (i1 * 80 | 0) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i12 + (i1 * 80 | 0) + 32 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 36 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 40 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 48 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 52 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 56 >> 2] = 0;
   HEAPF32[i12 + (i1 * 80 | 0) + 44 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i12 + (i1 * 80 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAP32[i12 + (i1 * 80 | 0) + 28 >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
   HEAPF32[i12 + (i1 * 80 | 0) + 68 >> 2] = Math_fround(1.0e3);
   HEAP16[i12 + (i1 * 80 | 0) + 76 >> 1] = 3;
   i1 = i1 + 1 | 0;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 4);
 i2 = i11 + 232 | 0;
 i3 = i11 + 280 | 0;
 i4 = i11 + 328 | 0;
 i5 = 0;
 do {
  if (HEAP8[i11 + (i5 + 344) >> 0] | 0) {
   i22 = i3 + (i5 * 12 | 0) | 0;
   HEAP32[i12 + (i1 * 80 | 0) >> 2] = HEAP32[i22 >> 2];
   i21 = i3 + (i5 * 12 | 0) + 4 | 0;
   HEAP32[i12 + (i1 * 80 | 0) + 4 >> 2] = HEAP32[i21 >> 2];
   i20 = i3 + (i5 * 12 | 0) + 8 | 0;
   HEAP32[i12 + (i1 * 80 | 0) + 8 >> 2] = HEAP32[i20 >> 2];
   f16 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i20 >> 2]);
   f17 = Math_fround(f16 * f18);
   f13 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i21 >> 2]);
   f17 = Math_fround(f17 - Math_fround(f13 * f14));
   f19 = Math_fround(HEAPF32[i22 >> 2]);
   f13 = Math_fround(f13 * f19);
   f15 = Math_fround(HEAPF32[i2 + (i5 * 12 | 0) >> 2]);
   f18 = Math_fround(f13 - Math_fround(f18 * f15));
   f19 = Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f19));
   HEAPF32[i12 + (i1 * 80 | 0) + 16 >> 2] = f17;
   HEAPF32[i12 + (i1 * 80 | 0) + 20 >> 2] = f18;
   HEAPF32[i12 + (i1 * 80 | 0) + 24 >> 2] = f19;
   HEAPF32[i12 + (i1 * 80 | 0) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i12 + (i1 * 80 | 0) + 32 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 36 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 40 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 48 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 52 >> 2] = 0;
   HEAP32[i12 + (i1 * 80 | 0) + 56 >> 2] = 0;
   HEAPF32[i12 + (i1 * 80 | 0) + 44 >> 2] = Math_fround(-3402823469999999843913219.0e14);
   HEAPF32[i12 + (i1 * 80 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAP32[i12 + (i1 * 80 | 0) + 28 >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
   HEAPF32[i12 + (i1 * 80 | 0) + 68 >> 2] = Math_fround(1.0e3);
   HEAP16[i12 + (i1 * 80 | 0) + 76 >> 1] = 3;
   i1 = i1 + 1 | 0;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 4);
 return i1 | 0;
}

function __ZN7mecanim9animation26InitializeMuscleClipTablesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1152 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i17 = i21 + 1024 | 0;
 i18 = i21 + 896 | 0;
 i19 = i21 + 768 | 0;
 i11 = i21 + 640 | 0;
 i12 = i21 + 512 | 0;
 i13 = i21 + 384 | 0;
 i14 = i21 + 256 | 0;
 i15 = i21 + 128 | 0;
 _strncpy(gb + 1553740 | 0, gb + 909862 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 127 >> 0] = 0;
 _strncpy(gb + 1553740 + 128 | 0, gb + 909872 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 255 >> 0] = 0;
 _strncpy(gb + 1553740 + 256 | 0, gb + 909882 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 383 >> 0] = 0;
 _strncpy(gb + 1553740 + 384 | 0, gb + 909892 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 511 >> 0] = 0;
 _strncpy(gb + 1553740 + 512 | 0, gb + 909902 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 639 >> 0] = 0;
 _strncpy(gb + 1553740 + 640 | 0, gb + 909912 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 767 >> 0] = 0;
 _strncpy(gb + 1553740 + 768 | 0, gb + 909922 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 895 >> 0] = 0;
 _strncpy(gb + 1553740 + 896 | 0, gb + 909932 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1023 >> 0] = 0;
 _strncpy(gb + 1553740 + 1024 | 0, gb + 909940 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1151 >> 0] = 0;
 _strncpy(gb + 1553740 + 1152 | 0, gb + 909948 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1279 >> 0] = 0;
 _strncpy(gb + 1553740 + 1280 | 0, gb + 909956 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1407 >> 0] = 0;
 _strncpy(gb + 1553740 + 1408 | 0, gb + 909964 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1535 >> 0] = 0;
 _strncpy(gb + 1553740 + 1536 | 0, gb + 909972 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1663 >> 0] = 0;
 _strncpy(gb + 1553740 + 1664 | 0, gb + 909980 | 0, 128) | 0;
 HEAP8[gb + 1553740 + 1791 >> 0] = 0;
 i16 = i20 + 127 | 0;
 i3 = i17 + 127 | 0;
 i4 = i18 + 127 | 0;
 i5 = i19 + 127 | 0;
 i6 = i11 + 127 | 0;
 i7 = i12 + 127 | 0;
 i8 = i13 + 127 | 0;
 i9 = i14 + 127 | 0;
 i10 = i15 + 127 | 0;
 i1 = 0;
 i2 = 14;
 while (1) {
  i23 = HEAP32[gb + 179492 + (i1 << 4) >> 2] | 0;
  _strncpy(i20, __ZN7mecanim5human8BoneNameEj(i23) | 0, 128) | 0;
  HEAP8[i16 >> 0] = 0;
  i22 = 128 - (_strlen(i20) | 0) | 0;
  _strncat(i20, gb + 1083701 | 0, i22) | 0;
  HEAP8[i16 >> 0] = 0;
  _strncpy(i17, i20, 128) | 0;
  HEAP8[i3 >> 0] = 0;
  i22 = 128 - (_strlen(i17) | 0) | 0;
  _strncat(i17, gb + 909988 | 0, i22) | 0;
  HEAP8[i3 >> 0] = 0;
  _strncpy(i18, i20, 128) | 0;
  HEAP8[i4 >> 0] = 0;
  i22 = 128 - (_strlen(i18) | 0) | 0;
  _strncat(i18, gb + 909991 | 0, i22) | 0;
  HEAP8[i4 >> 0] = 0;
  _strncpy(i19, i20, 128) | 0;
  HEAP8[i5 >> 0] = 0;
  i22 = 128 - (_strlen(i19) | 0) | 0;
  _strncat(i19, gb + 909994 | 0, i22) | 0;
  HEAP8[i5 >> 0] = 0;
  _strncpy(i11, __ZN7mecanim5human8BoneNameEj(i23) | 0, 128) | 0;
  HEAP8[i6 >> 0] = 0;
  i23 = 128 - (_strlen(i11) | 0) | 0;
  _strncat(i11, gb + 1083695 | 0, i23) | 0;
  HEAP8[i6 >> 0] = 0;
  _strncpy(i12, i11, 128) | 0;
  HEAP8[i7 >> 0] = 0;
  i23 = 128 - (_strlen(i12) | 0) | 0;
  _strncat(i12, gb + 909988 | 0, i23) | 0;
  HEAP8[i7 >> 0] = 0;
  _strncpy(i13, i11, 128) | 0;
  HEAP8[i8 >> 0] = 0;
  i23 = 128 - (_strlen(i13) | 0) | 0;
  _strncat(i13, gb + 909991 | 0, i23) | 0;
  HEAP8[i8 >> 0] = 0;
  _strncpy(i14, i11, 128) | 0;
  HEAP8[i9 >> 0] = 0;
  i23 = 128 - (_strlen(i14) | 0) | 0;
  _strncat(i14, gb + 909994 | 0, i23) | 0;
  HEAP8[i9 >> 0] = 0;
  _strncpy(i15, i11, 128) | 0;
  HEAP8[i10 >> 0] = 0;
  i23 = 128 - (_strlen(i15) | 0) | 0;
  _strncat(i15, gb + 909997 | 0, i23) | 0;
  HEAP8[i10 >> 0] = 0;
  i23 = i2 + 1 | 0;
  _strncpy(gb + 1553740 + (i2 << 7) | 0, i17, 128) | 0;
  HEAP8[gb + 1553740 + (i2 << 7) + 127 >> 0] = 0;
  i22 = i2 + 2 | 0;
  _strncpy(gb + 1553740 + (i23 << 7) | 0, i18, 128) | 0;
  HEAP8[gb + 1553740 + (i23 << 7) + 127 >> 0] = 0;
  i23 = i2 + 3 | 0;
  _strncpy(gb + 1553740 + (i22 << 7) | 0, i19, 128) | 0;
  HEAP8[gb + 1553740 + (i22 << 7) + 127 >> 0] = 0;
  i22 = i2 + 4 | 0;
  _strncpy(gb + 1553740 + (i23 << 7) | 0, i12, 128) | 0;
  HEAP8[gb + 1553740 + (i23 << 7) + 127 >> 0] = 0;
  i23 = i2 + 5 | 0;
  _strncpy(gb + 1553740 + (i22 << 7) | 0, i13, 128) | 0;
  HEAP8[gb + 1553740 + (i22 << 7) + 127 >> 0] = 0;
  i22 = i2 + 6 | 0;
  _strncpy(gb + 1553740 + (i23 << 7) | 0, i14, 128) | 0;
  HEAP8[gb + 1553740 + (i23 << 7) + 127 >> 0] = 0;
  _strncpy(gb + 1553740 + (i22 << 7) | 0, i15, 128) | 0;
  HEAP8[gb + 1553740 + (i22 << 7) + 127 >> 0] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 4) {
   i1 = 42;
   i2 = 0;
   break;
  } else i2 = i2 + 7 | 0;
 }
 while (1) {
  i23 = __ZN7mecanim5human10MuscleNameEj(i2) | 0;
  _strncpy(gb + 1553740 + (i1 << 7) | 0, i23, 128) | 0;
  HEAP8[gb + 1553740 + (i1 << 7) + 127 >> 0] = 0;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 52) break; else i1 = i1 + 1 | 0;
 }
 i5 = i20 + 127 | 0;
 i2 = 0;
 i3 = 94;
 while (1) {
  i1 = 0;
  i4 = i3;
  while (1) {
   _strncpy(i20, gb + 91e4 | 0, 128) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = __ZN7mecanim4hand10FingerNameEj(i2) | 0;
   _strncat(i20, i23, 128 - (_strlen(i20) | 0) | 0) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = 128 - (_strlen(i20) | 0) | 0;
   _strncat(i20, gb + 1087625 | 0, i23) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = __ZN7mecanim4hand13FingerDoFNameEj(i1) | 0;
   _strncat(i20, i23, 128 - (_strlen(i20) | 0) | 0) | 0;
   HEAP8[i5 >> 0] = 0;
   _strncpy(gb + 1553740 + (i4 << 7) | 0, i20, 128) | 0;
   HEAP8[gb + 1553740 + (i4 << 7) + 127 >> 0] = 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 4) break; else i4 = i4 + 1 | 0;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 5) break; else i3 = i3 + 4 | 0;
 }
 i5 = i20 + 127 | 0;
 i1 = 0;
 i3 = 114;
 while (1) {
  i2 = 0;
  i4 = i3;
  while (1) {
   _strncpy(i20, gb + 910010 | 0, 128) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = __ZN7mecanim4hand10FingerNameEj(i1) | 0;
   _strncat(i20, i23, 128 - (_strlen(i20) | 0) | 0) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = 128 - (_strlen(i20) | 0) | 0;
   _strncat(i20, gb + 1087625 | 0, i23) | 0;
   HEAP8[i5 >> 0] = 0;
   i23 = __ZN7mecanim4hand13FingerDoFNameEj(i2) | 0;
   _strncat(i20, i23, 128 - (_strlen(i20) | 0) | 0) | 0;
   HEAP8[i5 >> 0] = 0;
   _strncpy(gb + 1553740 + (i4 << 7) | 0, i20, 128) | 0;
   HEAP8[gb + 1553740 + (i4 << 7) + 127 >> 0] = 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 4) break; else i4 = i4 + 1 | 0;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 5) break; else i3 = i3 + 4 | 0;
 }
 i3 = i20 + 127 | 0;
 i4 = i17 + 127 | 0;
 i5 = i18 + 127 | 0;
 i6 = i19 + 127 | 0;
 i1 = 0;
 i2 = 134;
 while (1) {
  _strncpy(i20, __ZN7mecanim5human8BoneNameEj(__ZN7mecanim5human12BoneFromTDoFEi(i1) | 0) | 0, 128) | 0;
  HEAP8[i3 >> 0] = 0;
  i22 = 128 - (_strlen(i20) | 0) | 0;
  _strncat(i20, gb + 910021 | 0, i22) | 0;
  HEAP8[i3 >> 0] = 0;
  _strncpy(i17, i20, 128) | 0;
  HEAP8[i4 >> 0] = 0;
  i22 = 128 - (_strlen(i17) | 0) | 0;
  _strncat(i17, gb + 909988 | 0, i22) | 0;
  HEAP8[i4 >> 0] = 0;
  _strncpy(i18, i20, 128) | 0;
  HEAP8[i5 >> 0] = 0;
  i22 = 128 - (_strlen(i18) | 0) | 0;
  _strncat(i18, gb + 909991 | 0, i22) | 0;
  HEAP8[i5 >> 0] = 0;
  _strncpy(i19, i20, 128) | 0;
  HEAP8[i6 >> 0] = 0;
  i22 = 128 - (_strlen(i19) | 0) | 0;
  _strncat(i19, gb + 909994 | 0, i22) | 0;
  HEAP8[i6 >> 0] = 0;
  i22 = i2 + 1 | 0;
  _strncpy(gb + 1553740 + (i2 << 7) | 0, i17, 128) | 0;
  HEAP8[gb + 1553740 + (i2 << 7) + 127 >> 0] = 0;
  i23 = i2 + 2 | 0;
  _strncpy(gb + 1553740 + (i22 << 7) | 0, i18, 128) | 0;
  HEAP8[gb + 1553740 + (i22 << 7) + 127 >> 0] = 0;
  _strncpy(gb + 1553740 + (i23 << 7) | 0, i19, 128) | 0;
  HEAP8[gb + 1553740 + (i23 << 7) + 127 >> 0] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 7) {
   i4 = 0;
   break;
  } else i2 = i2 + 3 | 0;
 }
 do {
  HEAP32[gb + 1465304 + (i4 << 3) >> 2] = i4;
  i1 = gb + 1553740 + (i4 << 7) | 0;
  i23 = _strlen(i1) | 0;
  i3 = gb + 1553740 + (i4 << 7) + i23 | 0;
  if ((i23 | 0) > 0) {
   i2 = -1;
   do {
    i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = ~i2;
  } else i1 = 0;
  HEAP32[gb + 1465304 + (i4 << 3) + 4 >> 2] = i1;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 155);
 HEAP32[i20 >> 2] = fb + 954;
 __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_(gb + 1465304 | 0, gb + 1465304 + 1240 | 0, i20);
 STACKTOP = i21;
 return;
}

function __ZN5Umbra8QueryExt13getPortalInfoERNS_10PortalInfoEi(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i7 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i15 >> 2] = i7;
 i2 = HEAP32[i7 + 76 >> 2] | 0;
 HEAP32[i15 + 4 >> 2] = i2;
 i14 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i14 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i14 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i15 + 8 >> 2] = i1;
 HEAP32[i15 + 12 >> 2] = i1 + i4;
 i2 = i15 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i15 + 20 >> 2] = i4;
 i13 = i15 + 24 | 0;
 i14 = i15 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i15 + 40 >> 2] = -1;
 i13 = HEAP32[i7 + 84 >> 2] | 0;
 HEAP32[i15 + 44 >> 2] = i13;
 HEAP32[i15 + 48 >> 2] = i13;
 HEAP32[i15 + 52 >> 2] = 0;
 HEAP32[i15 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i15 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP32[i7 >> 2] | 0)) {
  i14 = 6;
  __ZN5Umbra12QueryContextD2Ev(i15);
  STACKTOP = i16;
  return i14 | 0;
 }
 i9 = i5 + 3 & -4;
 i13 = i9;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i8 = 9; else if (!(HEAP8[i1 + 24 >> 0] | 0)) i8 = 9; else {
  i3 = __ZN5Umbra10QueryState23findTomeByClusterPortalEi(i7, i6) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != -1 & (i1 | 0) != 0) {
   i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i3 << 5)) | 0;
   if (i1 | 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i12 + (HEAP32[i12 + 180 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i5 = i12 + (HEAP32[i12 + 184 >> 2] | 0) | 0;
    i10 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
    i5 = (HEAP32[i5 + (i3 + 1 << 2) >> 2] | 0) - i10 | 0;
    HEAP32[i7 + 92 >> 2] = i3;
    HEAP32[i7 + 96 >> 2] = i1;
    HEAP32[i7 + 100 >> 2] = i11;
    HEAP32[i7 + 104 >> 2] = i12;
    HEAP32[i7 + 108 >> 2] = i4;
    HEAP32[i7 + 112 >> 2] = i10;
    HEAP32[i7 + 116 >> 2] = i5;
    i6 = i6 - i10 | 0;
    i7 = i11;
    break;
   }
  }
  i11 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 + 92 >> 2] = 0;
  HEAP32[i7 + 96 >> 2] = 0;
  HEAP32[i7 + 100 >> 2] = i11;
  HEAP32[i7 + 104 >> 2] = i11;
  HEAP32[i7 + 108 >> 2] = 0;
  HEAP32[i7 + 112 >> 2] = 0;
  HEAP32[i7 + 116 >> 2] = 0;
  i12 = i11;
  i1 = 0;
  i7 = i11;
 } while (0);
 if ((i8 | 0) == 9) {
  i12 = HEAP32[i7 + 104 >> 2] | 0;
  i1 = HEAP32[i7 + 96 >> 2] | 0;
  i7 = HEAP32[i7 + 100 >> 2] | 0;
 }
 i8 = i7;
 if (!(HEAP32[i8 + 180 >> 2] | 0)) {
  i2 = (HEAP32[i8 + 124 >> 2] | 0) + -1 | 0;
  i11 = i7 + (HEAP32[i8 + 128 >> 2] | 0) | 0;
  i2 = (HEAP32[i11 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i11 + (i2 * 20 | 0) >> 2] | 0) | 0;
 } else i2 = HEAP32[i7 + (HEAP32[i8 + 184 >> 2] | 0) + (HEAP32[i8 + 176 >> 2] << 2) >> 2] | 0;
 if ((i6 | 0) < (i2 | 0)) {
  i3 = i7 + (HEAP32[i8 + 132 >> 2] | 0) | 0;
  i5 = i3 + (i6 << 4) | 0;
  i2 = i3 + (i6 << 4) + 12 | 0;
  i4 = i3 + (i6 << 4) + 4 | 0;
  i3 = i3 + (i6 << 4) + 8 | 0;
 } else {
  if (!i1) {
   i3 = 0;
   i4 = 0;
  } else {
   i3 = i12;
   i4 = HEAP32[i1 + 24 >> 2] | 0;
  }
  i11 = i6 - i2 | 0;
  i3 = i3 + i4 | 0;
  i5 = i3 + (i11 << 4) | 0;
  i2 = i3 + (i11 << 4) + 12 | 0;
  i4 = i3 + (i11 << 4) + 4 | 0;
  i3 = i3 + (i11 << 4) + 8 | 0;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = i3 & 67108863;
 HEAP32[i9 >> 2] = i7;
 i2 = i13 + 144 | 0;
 if (!(i3 & 134217728)) {
  HEAP8[i2 >> 0] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 72 >> 2] = 0;
  i10 = i3 >>> 30;
  f21 = Math_fround(i4 & 65535 | 0);
  f20 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
  f21 = Math_fround(f21 * f20);
  f17 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
  f20 = Math_fround(Math_fround(i6 >>> 16 | 0) * f20);
  f17 = Math_fround(Math_fround(i6 & 65535 | 0) * f17);
  f18 = Math_fround(Math_fround(i11 >>> 16 | 0) * f18);
  f19 = Math_fround(Math_fround(i11 & 65535 | 0) * Math_fround(HEAPF32[gb + 1451432 + 12 >> 2]));
  i7 = i8 + 20 | 0;
  f22 = Math_fround(HEAPF32[i7 + (i10 << 2) >> 2]);
  i9 = i8 + 32 | 0;
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f21) * f22) + Math_fround(f21 * Math_fround(HEAPF32[i9 + (i10 << 2) >> 2])));
  i12 = i13 + 24 | 0;
  HEAPF32[i12 + (i10 << 2) >> 2] = f21;
  i11 = i13 + 12 | 0;
  HEAPF32[i11 + (i10 << 2) >> 2] = f21;
  i10 = ((i10 + 1 | 0) >>> 0) % 3 | 0;
  i6 = i7 + (i10 << 2) | 0;
  f21 = Math_fround(HEAPF32[i6 >> 2]);
  i8 = i9 + (i10 << 2) | 0;
  HEAPF32[i11 + (i10 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f20) * f21) + Math_fround(f20 * Math_fround(HEAPF32[i8 >> 2])));
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  HEAPF32[i12 + (i10 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f17) * f20) + Math_fround(f17 * Math_fround(HEAPF32[i8 >> 2]))) + Math_fround(0.0));
  i10 = ((i10 + 1 | 0) >>> 0) % 3 | 0;
  i8 = i7 + (i10 << 2) | 0;
  f17 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i9 + (i10 << 2) | 0;
  HEAPF32[i11 + (i10 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f18) * f17) + Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2])));
  f18 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i12 + (i10 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f19) * f18) + Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2]))) + Math_fround(0.0));
  f19 = Math_fround(HEAPF32[i11 >> 2]);
  f19 = Math_fround(f19 + Math_fround(HEAPF32[i12 >> 2]));
  f18 = Math_fround(HEAPF32[i13 + 16 >> 2]);
  f18 = Math_fround(f18 + Math_fround(HEAPF32[i13 + 28 >> 2]));
  f17 = Math_fround(HEAPF32[i13 + 20 >> 2]);
  f18 = Math_fround(f18 * Math_fround(.5));
  f17 = Math_fround(Math_fround(f17 + Math_fround(HEAPF32[i13 + 32 >> 2])) * Math_fround(.5));
  HEAPF32[i13 + 36 >> 2] = Math_fround(f19 * Math_fround(.5));
  HEAPF32[i13 + 40 >> 2] = f18;
  HEAPF32[i13 + 44 >> 2] = f17;
 } else {
  HEAP8[i2 >> 0] = 1;
  i9 = i13 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i6 & 4095;
  if (i10 | 0) {
   i8 = i8 + 120 | 0;
   i5 = i6 >>> 12;
   i3 = i12;
   i4 = i1 + 16 | 0;
   if (!i1) {
    i2 = 0;
    i1 = 0;
    do {
     if ((i2 | 0) < 16) {
      HEAP32[i13 + 80 + (i1 << 2) >> 2] = HEAP32[i7 + (HEAP32[i8 >> 2] | 0) + (i2 + i5 << 2) >> 2];
      i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
      HEAP32[i9 >> 2] = i1;
     } else HEAP32[i14 >> 2] = 2;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i10 | 0));
   } else {
    i2 = 0;
    i1 = 0;
    do {
     if ((i2 | 0) < 16) {
      HEAP32[i13 + 80 + (i1 << 2) >> 2] = HEAP32[i7 + (HEAP32[i8 >> 2] | 0) + (i2 + i5 << 2) >> 2];
      i1 = i13 + 80 + (HEAP32[i9 >> 2] << 2) | 0;
      HEAP32[i1 >> 2] = HEAP32[i3 + (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2];
      i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
      HEAP32[i9 >> 2] = i1;
     } else HEAP32[i14 >> 2] = 2;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i10 | 0));
   }
  }
  HEAP32[i13 + 72 >> 2] = (i11 & 4095) + -3;
  i12 = i11 >>> 12;
  HEAP32[i13 + 76 >> 2] = i12 + 3;
  i6 = HEAP32[i13 >> 2] | 0;
  i7 = i13 + 36 | 0;
  i6 = i6 + (HEAP32[i6 + 112 >> 2] | 0) | 0;
  i8 = i6 + (i12 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i7 = i12 + 1 | 0;
  i8 = HEAP32[i6 + (i7 * 12 | 0) + 4 >> 2] | 0;
  i9 = HEAP32[i6 + (i7 * 12 | 0) + 8 >> 2] | 0;
  i12 = i12 + 2 | 0;
  i10 = HEAP32[i6 + (i12 * 12 | 0) >> 2] | 0;
  i11 = HEAP32[i6 + (i12 * 12 | 0) + 4 >> 2] | 0;
  i12 = HEAP32[i6 + (i12 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i13 + 48 >> 2] = HEAP32[i6 + (i7 * 12 | 0) >> 2];
  HEAP32[i13 + 52 >> 2] = i8;
  HEAP32[i13 + 56 >> 2] = i9;
  HEAP32[i13 + 60 >> 2] = i10;
  HEAP32[i13 + 64 >> 2] = i11;
  HEAP32[i13 + 68 >> 2] = i12;
 }
 i14 = HEAP32[i14 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i15);
 STACKTOP = i16;
 return i14 | 0;
}

function __ZN22ParticleSystemRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011343 | 0, i6, i1 + 340 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621597 | 0, i6, i1 + 342 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621608 | 0, i6, i1 + 344 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048520 | 0, i6, i1 + 348 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048449 | 0, i6, i1 + 352 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048504 | 0, i6, i1 + 356 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048490 | 0, i6, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621626 | 0, i6, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621641 | 0, i6, i1 + 368 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621659 | 0, i10, i1 + 372 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 376 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902162 | 0, HEAP32[gb + 37324 >> 2] | 0, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 380 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 384 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621677 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 388 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 392 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621702 | 0, i10, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 i6 = i1 + 552 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i6, 0);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 556 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621721 | 0, gb + 1048082 | 0, i7, 0);
 i10 = i9 + 8 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 560 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621729 | 0, gb + 1048082 | 0, i10, 0);
 i7 = i9 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 564 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621737 | 0, gb + 1048082 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim14ValueArrayLoopERKNS_10ValueArrayES2_RS0_fRKNS_14ValueArrayMaskE(i13, i14, i12, f15, i11) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 f15 = Math_fround(f15);
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i8 = HEAP32[i12 >> 2] | 0;
 if (i8 | 0) {
  i7 = i11 + 4 | 0;
  i9 = i12 + 4 | 0;
  i2 = i9;
  i3 = i13 + 4 | 0;
  i4 = i3;
  i5 = i14 + 4 | 0;
  i6 = i5;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i1 = 0;
  do {
   if (HEAP8[i7 + i1 >> 0] | 0) {
    i10 = (HEAP32[i9 >> 2] | 0) + i2 | 0;
    i19 = i10 + (i1 * 12 | 0) | 0;
    f22 = Math_fround(HEAPF32[i19 >> 2]);
    i17 = i10 + (i1 * 12 | 0) + 4 | 0;
    f26 = Math_fround(HEAPF32[i17 >> 2]);
    i10 = i10 + (i1 * 12 | 0) + 8 | 0;
    f24 = Math_fround(HEAPF32[i10 >> 2]);
    i23 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
    f21 = Math_fround(HEAPF32[i23 + (i1 * 12 | 0) >> 2]);
    f25 = Math_fround(HEAPF32[i23 + (i1 * 12 | 0) + 4 >> 2]);
    f16 = Math_fround(HEAPF32[i23 + (i1 * 12 | 0) + 8 >> 2]);
    i23 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    f20 = Math_fround(HEAPF32[i23 + (i1 * 12 | 0) >> 2]);
    f18 = Math_fround(HEAPF32[i23 + (i1 * 12 | 0) + 4 >> 2]);
    f18 = Math_fround(f26 + Math_fround(Math_fround(f25 - f18) * f15));
    f16 = Math_fround(f24 + Math_fround(Math_fround(f16 - Math_fround(HEAPF32[i23 + (i1 * 12 | 0) + 8 >> 2])) * f15));
    HEAPF32[i19 >> 2] = Math_fround(f22 + Math_fround(Math_fround(f21 - f20) * f15));
    HEAPF32[i17 >> 2] = f18;
    HEAPF32[i10 >> 2] = f16;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 i2 = HEAP32[i12 + 8 >> 2] | 0;
 if (i2 | 0) {
  i3 = i11 + 12 | 0;
  i4 = i3;
  i5 = i12 + 12 | 0;
  i6 = i5;
  i7 = i13 + 12 | 0;
  i8 = i7;
  i9 = i14 + 12 | 0;
  i10 = i9;
  i1 = 0;
  do {
   if (HEAP8[(HEAP32[i3 >> 2] | 0) + i4 + i1 >> 0] | 0) {
    i23 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    i27 = i23 + (i1 << 4) | 0;
    f33 = Math_fround(HEAPF32[i27 >> 2]);
    i17 = i23 + (i1 << 4) + 4 | 0;
    f21 = Math_fround(HEAPF32[i17 >> 2]);
    i19 = i23 + (i1 << 4) + 8 | 0;
    f31 = Math_fround(HEAPF32[i19 >> 2]);
    i23 = i23 + (i1 << 4) + 12 | 0;
    f18 = Math_fround(HEAPF32[i23 >> 2]);
    i28 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
    f35 = Math_fround(HEAPF32[i28 + (i1 << 4) >> 2]);
    f20 = Math_fround(HEAPF32[i28 + (i1 << 4) + 4 >> 2]);
    f37 = Math_fround(HEAPF32[i28 + (i1 << 4) + 8 >> 2]);
    f24 = Math_fround(HEAPF32[i28 + (i1 << 4) + 12 >> 2]);
    i28 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    f26 = Math_fround(HEAPF32[i28 + (i1 << 4) + 12 >> 2]);
    f16 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i28 + (i1 << 4) + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f32 = Math_fround(f35 * f16);
    f22 = Math_fround(f24 * f26);
    f34 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i28 + (i1 << 4) + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f25 = Math_fround(f20 * f34);
    f36 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i28 + (i1 << 4) >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f32 = Math_fround(Math_fround(Math_fround(f32 - Math_fround(f37 * f26)) - Math_fround(f24 * f34)) - Math_fround(f20 * f36));
    f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f35 * f36)) - Math_fround(f37 * f34)) - Math_fround(f20 * f16));
    f25 = Math_fround(Math_fround(Math_fround(f25 - Math_fround(f37 * f16)) - Math_fround(f35 * f26)) - Math_fround(f24 * f36));
    f16 = Math_fround(Math_fround(Math_fround(Math_fround(f37 * f36) - Math_fround(f35 * f34)) - Math_fround(f20 * f26)) - Math_fround(f24 * f16));
    i28 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
    i29 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f15);
    f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f15);
    f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f15);
    f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f32 * f32)) + Math_fround(Math_fround(f16 * f16) + Math_fround(f25 * f25))))));
    f16 = Math_fround(f24 * f16);
    f25 = Math_fround(f24 * f25);
    f32 = Math_fround(f24 * f32);
    f22 = Math_fround(f24 * f22);
    f24 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f16) - Math_fround(f18 * f32)) - Math_fround(f31 * f22)) - Math_fround(f33 * f25));
    f26 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f33 * f16)) - Math_fround(f31 * f32)) - Math_fround(f21 * f25));
    f20 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f25) - Math_fround(f21 * f32)) - Math_fround(f18 * f16)) - Math_fround(f33 * f22));
    f22 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f16)) - Math_fround(f18 * f25)) - Math_fround(f21 * f22));
    i28 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
    i29 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f22 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f22 * f22);
    f24 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(f24 * f24);
    f25 = (HEAP32[tempDoublePtr >> 2] = i28 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f20 + f21) + Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25))))));
    f24 = Math_fround(f21 * f24);
    f25 = Math_fround(f21 * f25);
    f26 = Math_fround(f21 * f26);
    HEAPF32[i27 >> 2] = Math_fround(f21 * f22);
    HEAPF32[i17 >> 2] = f24;
    HEAPF32[i19 >> 2] = f25;
    HEAPF32[i23 >> 2] = f26;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i12 + 16 >> 2] | 0;
 if (i2 | 0) {
  i9 = i11 + 20 | 0;
  i3 = i12 + 20 | 0;
  i4 = i3;
  i5 = i13 + 20 | 0;
  i6 = i5;
  i7 = i14 + 20 | 0;
  i8 = i7;
  i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
  i1 = 0;
  do {
   if (HEAP8[i9 + i1 >> 0] | 0) {
    i30 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
    i28 = i30 + (i1 * 12 | 0) | 0;
    f33 = Math_fround(HEAPF32[i28 >> 2]);
    i29 = i30 + (i1 * 12 | 0) + 4 | 0;
    f26 = Math_fround(HEAPF32[i29 >> 2]);
    i30 = i30 + (i1 * 12 | 0) + 8 | 0;
    f32 = Math_fround(HEAPF32[i30 >> 2]);
    i27 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    f34 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) >> 2]);
    f31 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 4 >> 2]);
    f37 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 8 >> 2]);
    i27 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
    f35 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) >> 2]);
    f36 = Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 4 >> 2]);
    f36 = Math_fround(f26 + Math_fround(Math_fround(f31 - f36) * f15));
    f37 = Math_fround(f32 + Math_fround(Math_fround(f37 - Math_fround(HEAPF32[i27 + (i1 * 12 | 0) + 8 >> 2])) * f15));
    HEAPF32[i28 >> 2] = Math_fround(f33 + Math_fround(Math_fround(f34 - f35) * f15));
    HEAPF32[i29 >> 2] = f36;
    HEAPF32[i30 >> 2] = f37;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i6 = HEAP32[i12 + 24 >> 2] | 0;
 if (!i6) return;
 i5 = i11 + 28 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i4 = i12 + 28 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i3 = i13 + 28 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i2 = i14 + 28 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 0;
 do {
  if (HEAP8[i5 + i1 >> 0] | 0) {
   i30 = i4 + (i1 << 2) | 0;
   f36 = Math_fround(HEAPF32[i30 >> 2]);
   f37 = Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]);
   HEAPF32[i30 >> 2] = Math_fround(f36 + Math_fround(Math_fround(f37 - Math_fround(HEAPF32[i2 + (i1 << 2) >> 2])) * f15));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function ___lgammaf_r(f1, i5) {
 f1 = Math_fround(f1);
 i5 = i5 | 0;
 var f2 = f0, f3 = f0, d4 = 0.0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i5 >> 2] = 1;
 i7 = i6 & 2147483647;
 do if (i7 >>> 0 > 2139095039) f1 = Math_fround(f1 * f1); else {
  i10 = (i6 | 0) < 0;
  if (i7 >>> 0 < 889192448) {
   if (i10) {
    HEAP32[i5 >> 2] = -1;
    f1 = Math_fround(-f1);
   }
   f1 = Math_fround(-Math_fround(+Math_log(+f1)));
   break;
  }
  if (i10) {
   f3 = Math_fround(-f1);
   f8 = Math_fround(f1 * Math_fround(-.5));
   f8 = Math_fround(Math_fround(f8 - Math_fround(Math_floor(Math_fround(f8)))) * Math_fround(2.0));
   i11 = (~~Math_fround(f8 * Math_fround(4.0)) + 1 | 0) / 2 | 0;
   d4 = +Math_fround(f8 - Math_fround(Math_fround(i11 | 0) * Math_fround(.5))) * 3.141592653589793;
   switch (i11 | 0) {
   case 3:
    {
     f2 = Math_fround(-Math_fround(___cosdf(d4)));
     break;
    }
   case 1:
    {
     f2 = Math_fround(___cosdf(d4));
     break;
    }
   case 2:
    {
     f2 = Math_fround(___sindf(-d4));
     break;
    }
   default:
    f2 = Math_fround(___sindf(d4));
   }
   if (f2 == Math_fround(0.0)) {
    f1 = Math_fround(Math_fround(1.0) / Math_fround(f1 - f1));
    break;
   }
   if (f2 > Math_fround(0.0)) {
    HEAP32[i5 >> 2] = -1;
    f1 = f2;
   } else f1 = Math_fround(-f2);
   f8 = Math_fround(+Math_log(+Math_fround(Math_fround(3.14159274) / Math_fround(f1 * f3))));
   f1 = f3;
  } else f8 = Math_fround(0.0);
  L26 : do if ((i6 | 0) < 1065353216) if ((i6 | 0) < -1073741824) switch (i6 | 0) {
  case -1082130432:
   {
    f1 = Math_fround(0.0);
    break L26;
   }
  default:
   {
    i9 = 20;
    break L26;
   }
  } else switch (i6 | 0) {
  case -1073741824:
   {
    f1 = Math_fround(0.0);
    break L26;
   }
  default:
   {
    i9 = 20;
    break L26;
   }
  } else if ((i6 | 0) < 1073741824) switch (i6 | 0) {
  case 1065353216:
   {
    f1 = Math_fround(0.0);
    break L26;
   }
  default:
   {
    i9 = 20;
    break L26;
   }
  } else switch (i6 | 0) {
  case 1073741824:
   {
    f1 = Math_fround(0.0);
    break L26;
   }
  default:
   {
    i9 = 20;
    break L26;
   }
  } while (0);
  L35 : do if ((i9 | 0) == 20) if (i7 >>> 0 < 1073741824) {
   do if (i7 >>> 0 < 1063675495) {
    f2 = Math_fround(-Math_fround(+Math_log(+f1)));
    if (i7 >>> 0 > 1060850207) {
     f3 = Math_fround(1.0);
     i9 = 28;
    } else {
     f3 = Math_fround(f1 + Math_fround(-.461632133));
     if (i7 >>> 0 > 1047343879) {
      f1 = f3;
      i9 = 29;
     } else i9 = 30;
    }
   } else if (i7 >>> 0 > 1071490583) {
    f2 = Math_fround(0.0);
    f3 = Math_fround(2.0);
    i9 = 28;
   } else if (i7 >>> 0 > 1067296287) {
    f2 = Math_fround(0.0);
    f1 = Math_fround(f1 + Math_fround(-1.46163213));
    i9 = 29;
    break;
   } else {
    f2 = Math_fround(0.0);
    f1 = Math_fround(f1 + Math_fround(-1.0));
    i9 = 30;
    break;
   } while (0);
   if ((i9 | 0) == 28) {
    f1 = Math_fround(f3 - f1);
    f3 = Math_fround(f1 * f1);
    f1 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(.0000252144564)) + Math_fround(.000220862785))) + Math_fround(.00119270768))) + Math_fround(.007385551))) + Math_fround(.0673523024))) + Math_fround(.0772156641))) + Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(.0000448640967)) + Math_fround(.000108011569))) + Math_fround(.000510069774))) + Math_fround(.00289051374))) + Math_fround(.0205808077))) + Math_fround(.322467029)))) - Math_fround(f1 * Math_fround(.5))));
    break;
   } else if ((i9 | 0) == 29) {
    f12 = Math_fround(f1 * f1);
    f3 = Math_fround(f1 * f12);
    f1 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f12 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(.00031563206)) + Math_fround(-.0014034647))) + Math_fround(.00610053865))) + Math_fround(-.0327885412))) + Math_fround(.483836114))) - Math_fround(Math_fround(6.69710065e-09) - Math_fround(f3 * Math_fround(Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(.000881081854) - Math_fround(f3 * Math_fround(.000312754157)))) + Math_fround(-.00368452026))) + Math_fround(.0179706756))) + Math_fround(-.147587717)) + Math_fround(f1 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(.000335529185)) + Math_fround(-.000538595312))) + Math_fround(.00225964771))) + Math_fround(-.0103142243))) + Math_fround(.0646249428))))))) + Math_fround(-.121486284)));
    break;
   } else if ((i9 | 0) == 30) {
    f1 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.0133810919)) + Math_fround(.228963733))) + Math_fround(.977717518))) + Math_fround(1.45492256))) + Math_fround(.632827044))) + Math_fround(-.0772156641))) / Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.00321709248)) + Math_fround(.104222648))) + Math_fround(.769285142))) + Math_fround(2.12848973))) + Math_fround(2.45597792))) + Math_fround(1.0))) - Math_fround(f1 * Math_fround(.5))));
    break;
   }
  } else {
   if (i7 >>> 0 >= 1090519040) {
    f2 = Math_fround(+Math_log(+f1));
    if (i7 >>> 0 < 1551892480) {
     f3 = Math_fround(Math_fround(1.0) / f1);
     f12 = Math_fround(f3 * f3);
     f1 = Math_fround(Math_fround(Math_fround(f3 * Math_fround(Math_fround(f12 * Math_fround(Math_fround(f12 * Math_fround(Math_fround(f12 * Math_fround(Math_fround(f12 * Math_fround(Math_fround(.000836339895) - Math_fround(f12 * Math_fround(.0016309293)))) + Math_fround(-.000595187536))) + Math_fround(.000793650572))) + Math_fround(-.00277777785))) + Math_fround(.0833333358))) + Math_fround(.418938547)) + Math_fround(Math_fround(f1 + Math_fround(-.5)) * Math_fround(f2 + Math_fround(-1.0))));
     break;
    } else {
     f1 = Math_fround(f1 * Math_fround(f2 + Math_fround(-1.0)));
     break;
    }
   }
   i11 = ~~f1;
   f3 = Math_fround(f1 - Math_fround(i11 | 0));
   f1 = Math_fround(Math_fround(f3 * Math_fround(.5)) + Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(.000031947533)) + Math_fround(.00184028456))) + Math_fround(.0266422704))) + Math_fround(.146350473))) + Math_fround(.325778782))) + Math_fround(.21498242))) + Math_fround(-.0772156641))) / Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(7.32668422e-06)) + Math_fround(.000777942477))) + Math_fround(.0186459199))) + Math_fround(.17193386))) + Math_fround(.72193557))) + Math_fround(1.39200532))) + Math_fround(1.0))));
   switch (i11 | 0) {
   case 7:
    {
     f2 = Math_fround(f3 + Math_fround(6.0));
     i9 = 34;
     break;
    }
   case 6:
    {
     f2 = Math_fround(1.0);
     i9 = 34;
     break;
    }
   case 5:
    {
     f2 = Math_fround(1.0);
     i9 = 35;
     break;
    }
   case 4:
    {
     f2 = Math_fround(1.0);
     i9 = 36;
     break;
    }
   case 3:
    {
     f2 = Math_fround(1.0);
     break;
    }
   default:
    break L35;
   }
   if ((i9 | 0) == 34) {
    f2 = Math_fround(Math_fround(f3 + Math_fround(5.0)) * f2);
    i9 = 35;
   }
   if ((i9 | 0) == 35) {
    f2 = Math_fround(Math_fround(f3 + Math_fround(4.0)) * f2);
    i9 = 36;
   }
   if ((i9 | 0) == 36) f2 = Math_fround(Math_fround(f3 + Math_fround(3.0)) * f2);
   f1 = Math_fround(f1 + Math_fround(+Math_log(+Math_fround(Math_fround(f3 + Math_fround(2.0)) * f2))));
   break;
  } while (0);
  f12 = Math_fround(f8 - f1);
  f1 = i10 ? f12 : f1;
 } while (0);
 return Math_fround(f1);
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 880 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 872 | 0;
 i3 = i5;
 i1 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 24 >> 2] = -1;
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 32 >> 2] = -1;
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 40 >> 2] = -1;
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 48 >> 2] = -1;
 HEAPF32[i3 + 52 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 56 >> 2] = -1;
 HEAPF32[i3 + 60 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 64 >> 2] = -1;
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 72 >> 2] = -1;
 HEAPF32[i3 + 76 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 80 >> 2] = -1;
 HEAPF32[i3 + 84 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 88 >> 2] = -1;
 HEAPF32[i3 + 92 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 96 >> 2] = -1;
 HEAPF32[i3 + 100 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 104 >> 2] = -1;
 HEAPF32[i3 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 112 >> 2] = -1;
 HEAPF32[i3 + 116 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 120 >> 2] = -1;
 HEAPF32[i3 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 128 >> 2] = -1;
 HEAPF32[i3 + 132 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 136 >> 2] = -1;
 HEAPF32[i3 + 140 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 144 >> 2] = -1;
 HEAPF32[i3 + 148 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 152 >> 2] = -1;
 HEAPF32[i3 + 156 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 160 >> 2] = -1;
 HEAPF32[i3 + 164 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 168 >> 2] = -1;
 HEAPF32[i3 + 172 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 176 >> 2] = -1;
 HEAPF32[i3 + 180 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 184 >> 2] = -1;
 HEAPF32[i3 + 188 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 192 >> 2] = -1;
 HEAPF32[i3 + 196 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 200 >> 2] = -1;
 HEAPF32[i3 + 204 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 208 >> 2] = -1;
 HEAPF32[i3 + 212 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 216 >> 2] = -1;
 HEAPF32[i3 + 220 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 224 >> 2] = -1;
 HEAPF32[i3 + 228 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 232 >> 2] = -1;
 HEAPF32[i3 + 236 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 240 >> 2] = -1;
 HEAPF32[i3 + 244 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 248 >> 2] = -1;
 HEAPF32[i3 + 252 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 256 >> 2] = -1;
 HEAPF32[i3 + 260 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 264 >> 2] = -1;
 HEAPF32[i3 + 268 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 272 >> 2] = -1;
 HEAPF32[i3 + 276 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 280 >> 2] = -1;
 HEAPF32[i3 + 284 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 288 >> 2] = -1;
 HEAPF32[i3 + 292 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 296 >> 2] = -1;
 HEAPF32[i3 + 300 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 304 >> 2] = -1;
 HEAPF32[i3 + 308 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 312 >> 2] = -1;
 HEAPF32[i3 + 316 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 320 >> 2] = -1;
 HEAPF32[i3 + 324 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 328 >> 2] = -1;
 HEAPF32[i3 + 332 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 336 >> 2] = -1;
 HEAPF32[i3 + 340 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 344 >> 2] = -1;
 HEAPF32[i3 + 348 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 352 >> 2] = -1;
 HEAPF32[i3 + 356 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 360 >> 2] = -1;
 HEAPF32[i3 + 364 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 368 >> 2] = -1;
 HEAPF32[i3 + 372 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 376 >> 2] = -1;
 HEAPF32[i3 + 380 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 384 >> 2] = -1;
 HEAPF32[i3 + 388 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 392 >> 2] = -1;
 HEAPF32[i3 + 396 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 400 >> 2] = -1;
 HEAPF32[i3 + 404 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 408 >> 2] = -1;
 HEAPF32[i3 + 412 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 416 >> 2] = -1;
 HEAPF32[i3 + 420 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 424 >> 2] = -1;
 HEAPF32[i3 + 428 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 432 >> 2] = -1;
 HEAPF32[i3 + 436 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 440 >> 2] = -1;
 HEAPF32[i3 + 444 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 448 >> 2] = -1;
 HEAPF32[i3 + 452 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 456 >> 2] = -1;
 HEAPF32[i3 + 460 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 464 >> 2] = -1;
 HEAPF32[i3 + 468 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 472 >> 2] = -1;
 HEAPF32[i3 + 476 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 480 >> 2] = -1;
 HEAPF32[i3 + 484 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 488 >> 2] = -1;
 HEAPF32[i3 + 492 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 496 >> 2] = -1;
 HEAPF32[i3 + 500 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 504 >> 2] = -1;
 HEAPF32[i3 + 508 >> 2] = Math_fround(15.0);
 HEAP32[i3 + 512 >> 2] = -1;
 HEAPF32[i3 + 516 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 520 >> 2] = -1;
 HEAPF32[i3 + 524 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 528 >> 2] = -1;
 HEAPF32[i3 + 532 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 536 >> 2] = -1;
 HEAPF32[i3 + 540 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 544 >> 2] = -1;
 HEAPF32[i3 + 548 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 552 >> 2] = -1;
 HEAPF32[i3 + 556 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 560 >> 2] = -1;
 HEAPF32[i3 + 564 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 568 >> 2] = -1;
 HEAPF32[i3 + 572 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 576 >> 2] = -1;
 HEAPF32[i3 + 580 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 584 >> 2] = -1;
 HEAPF32[i3 + 588 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 592 >> 2] = -1;
 HEAPF32[i3 + 596 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 600 >> 2] = -1;
 HEAPF32[i3 + 604 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 608 >> 2] = -1;
 HEAPF32[i3 + 612 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 616 >> 2] = -1;
 HEAPF32[i3 + 620 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 624 >> 2] = -1;
 HEAPF32[i3 + 628 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 632 >> 2] = -1;
 HEAPF32[i3 + 636 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 640 >> 2] = -1;
 HEAPF32[i3 + 644 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 648 >> 2] = -1;
 HEAPF32[i3 + 652 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 656 >> 2] = -1;
 HEAPF32[i3 + 660 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 664 >> 2] = -1;
 HEAPF32[i3 + 668 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 672 >> 2] = -1;
 HEAPF32[i3 + 676 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 680 >> 2] = -1;
 HEAPF32[i3 + 684 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 688 >> 2] = -1;
 HEAP32[i3 + 692 >> 2] = -1;
 HEAP32[i3 + 708 >> 2] = 0;
 HEAP32[i3 + 712 >> 2] = 0;
 HEAP32[i3 + 704 >> 2] = i3 + 708;
 HEAP8[i3 + 720 >> 0] = 0;
 HEAP8[i3 + 721 >> 0] = 0;
 i1 = i3 + 800 | 0;
 i4 = i3 + 724 | 0;
 i6 = i4 + 88 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i3 + 812 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i6 = i3 + 816 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i3 + 828 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i6 = i3 + 832 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i3 + 844 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i3 + 852 >> 2] = 0;
 HEAP32[i3 + 856 >> 2] = 0;
 HEAP32[i3 + 848 >> 2] = i3 + 852;
 HEAP32[i3 + 864 >> 2] = 0;
 HEAP32[i3 + 868 >> 2] = 0;
 HEAP32[i3 + 860 >> 2] = i3 + 864;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i7, gb + 1041885 | 0, gb + 1041885 | 0, i2, i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, gb + 470745 | 0, i3, 0);
 __ZN9ShaderLab14SerializedPass8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i7);
 __ZN9ShaderLab14SerializedPassD2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN13AnimationClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i8 = i14;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i13);
 i1 = i9 + 212 | 0;
 i11 = i13 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i13 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i3 = i9 + 92 | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i3, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 if (!(HEAP8[i3 >> 0] | 0)) {
  i3 = i9 + 100 | 0;
  i7 = i9 + 104 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = (i2 - i1 | 0) / 204 | 0;
  HEAP32[i10 >> 2] = i4;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i11 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN13AnimationClip15QuaternionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i8 >> 2] = 0;
  i6 = i8 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = (i2 - i1 | 0) / 88 | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = HEAP32[i11 >> 2] | 0;
  i5 = i4 + 4 | 0;
  if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i11 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN24CompressedAnimationCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i8);
 } else {
  __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i11 >> 2] = i2;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  if (!(HEAP32[i13 >> 2] & 33554432)) {
   HEAP32[i8 >> 2] = 0;
   i6 = i8 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   __ZN13AnimationClip14CompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i9, i8);
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = (i2 - i1 | 0) / 88 | 0;
   HEAP32[i10 >> 2] = i3;
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = i4 + 4 | 0;
   if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
    HEAP32[i4 >> 2] = i3;
    HEAP32[i11 >> 2] = i5;
   } else {
    __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   if ((i1 | 0) != (i2 | 0)) do {
    __ZN24CompressedAnimationCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
    i1 = i1 + 88 | 0;
   } while ((i1 | 0) != (i2 | 0));
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i8);
  }
 }
 i5 = i9 + 116 | 0;
 i7 = i9 + 120 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 172 | 0;
 HEAP32[i10 >> 2] = i6;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 132 | 0;
 i7 = i9 + 136 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 172 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 148 | 0;
 i7 = i9 + 152 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 172 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
  i1 = i1 + 172 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i13, i9 + 164 | 0, 0);
 i3 = i9 + 180 | 0;
 i7 = i9 + 184 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 60 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip9PPtrCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
  i1 = i1 + 60 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 88 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 272 | 0, i13);
 HEAP32[i13 + 4 >> 2] = i9 + 56;
 __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE19StreamedBinaryWriteILb0EEEvRPT_PKcRjS9_RT0_(i9 + 216 | 0, gb + 898128 | 0, i9 + 220 | 0, gb + 898141 | 0, i13);
 __ZN19StreamedBinaryWriteILb0EE8TransferIN11UnityEngine9Animation28AnimationClipBindingConstantEEEvRT_PKc17TransferMetaFlags(i13, i9 + 224 | 0, gb + 898158 | 0, 0);
 i6 = i9 + 196 | 0;
 i7 = i9 + 200 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 6;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  __ZN14AnimationEvent8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i13);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i14;
 return;
}

function __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i16) {
 i16 = i16 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i6 = i16 + 188 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if (!i2) {
  i5 = i16 + 360 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i9 = 8; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
     i3 = HEAP32[i13 >> 2] | 0;
     i18 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i18 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i18 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 8; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 10;
   }
   if ((i9 | 0) == 8) i9 = 10;
   if ((i9 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
    i2 = HEAP32[i6 >> 2] | 0;
    i9 = 19;
    break;
   }
   i2 = i16 + 192 | 0;
   __ZN20SphericalHarmonicsL27SetZeroEv(i2);
   i3 = i16 + 76 | 0;
   f1 = Math_fround(HEAPF32[i16 + 184 >> 2]);
   do if (!(f1 <= Math_fround(.0404499993))) {
    if (f1 < Math_fround(1.0)) {
     f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
   } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
   __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i2, i3, f1);
   STACKTOP = i17;
   return;
  }
 } else i9 = 19; while (0);
 if ((i9 | 0) == 19) if ((i2 | 0) == 4) {
  i4 = i16 + 192 | 0;
  i2 = i16 + 76 | 0;
  i3 = i4 + 108 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   i4 = i4 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  STACKTOP = i17;
  return;
 }
 f1 = Math_fround(HEAPF32[i16 + 28 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f12 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f12 = Math_fround(1.0); else f12 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f12 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f11 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f11 = Math_fround(1.0); else f11 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f11 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f10 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f10 = Math_fround(1.0); else f10 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f10 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 i9 = HEAP32[i16 + 40 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i16 + 44 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f7 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f8 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f8 = Math_fround(1.0); else f8 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f8 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 i18 = HEAP32[i16 + 56 >> 2] | 0;
 HEAPF32[i13 >> 2] = f7;
 i6 = i13 + 4 | 0;
 HEAPF32[i6 >> 2] = f8;
 i5 = i13 + 8 | 0;
 HEAPF32[i5 >> 2] = f1;
 i4 = i13 + 12 | 0;
 HEAP32[i4 >> 2] = i18;
 f1 = Math_fround(HEAPF32[i16 + 60 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f8 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f8 = Math_fround(1.0); else f8 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f8 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = Math_fround(HEAPF32[i16 + 64 >> 2]);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f7 = Math_fround(HEAPF32[i16 + 68 >> 2]);
 do if (!(f7 <= Math_fround(.0404499993))) {
  if (f7 < Math_fround(1.0)) {
   f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
 } else f7 = Math_fround(f7 / Math_fround(12.9200001)); while (0);
 i3 = HEAP32[i16 + 72 >> 2] | 0;
 switch (i2 | 0) {
 case 0:
 case 3:
  {
   HEAPF32[i13 >> 2] = f12;
   HEAPF32[i6 >> 2] = f11;
   HEAPF32[i5 >> 2] = f10;
   HEAP32[i4 >> 2] = i9;
   f8 = f12;
   f7 = f10;
   i2 = i9;
   f1 = f11;
   break;
  }
 default:
  i2 = i3;
 }
 i18 = i16 + 192 | 0;
 __ZN20SphericalHarmonicsL27SetZeroEv(i18);
 __ZN20SphericalHarmonicsL215AddAmbientLightERK10ColorRGBAf(i18, i13);
 f19 = Math_fround(f12 - Math_fround(HEAPF32[i13 >> 2]));
 f12 = Math_fround(f11 - Math_fround(HEAPF32[i6 >> 2]));
 f11 = Math_fround(f10 - Math_fround(HEAPF32[i5 >> 2]));
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f10);
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i14 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i15 >> 2] = f19;
 HEAPF32[i15 + 4 >> 2] = f12;
 HEAPF32[i15 + 8 >> 2] = f11;
 HEAPF32[i15 + 12 >> 2] = f10;
 __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i18, i14, i15);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i13 >> 2]));
 f10 = Math_fround(f1 - Math_fround(HEAPF32[i6 >> 2]));
 f11 = Math_fround(f7 - Math_fround(HEAPF32[i5 >> 2]));
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f12);
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[i14 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i15 >> 2] = f8;
 HEAPF32[i15 + 4 >> 2] = f10;
 HEAPF32[i15 + 8 >> 2] = f11;
 HEAPF32[i15 + 12 >> 2] = f12;
 __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i18, i14, i15);
 STACKTOP = i17;
 return;
}

function __ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy(i27, i17, i18, i19, i20, i30) {
 i27 = i27 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i32;
 if ((HEAP32[i17 >> 2] | 0) != 1145979222) {
  i31 = -2147483647;
  STACKTOP = i32;
  return i31 | 0;
 }
 if ((HEAP32[i17 + 4 >> 2] | 0) != 16) {
  i31 = -2147483646;
  STACKTOP = i32;
  return i31 | 0;
 }
 i28 = i17 + 8 | 0;
 i4 = HEAP32[i28 >> 2] | 0;
 i29 = i17 + 12 | 0;
 i5 = HEAP32[i29 >> 2] | 0;
 i24 = i27 + 4 | 0;
 i7 = HEAP32[i24 >> 2] | 0;
 i1 = (Math_imul(i5, -669632447) | 0) + (Math_imul(i4, -1918454973) | 0) & i7;
 i25 = i27 + 8 | 0;
 i8 = HEAP32[i25 >> 2] | 0;
 i1 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
 L7 : do if ((i1 | 0) != -1) {
  i3 = HEAP32[i27 + 20 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] | 0;
   if (i2 | 0) if ((HEAP32[i2 + 8 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i3 + (i1 * 56 | 0) >> 2] | 0) == (i20 | 0)) {
    i1 = -2147483648;
    break;
   }
   i1 = HEAP32[i3 + (i1 * 56 | 0) + 52 >> 2] | 0;
   if ((i1 | 0) == -1) break L7;
  }
  STACKTOP = i32;
  return i1 | 0;
 } while (0);
 i15 = HEAP32[i17 + 40 >> 2] << 4;
 i10 = i17 + 72 | 0;
 i11 = i10 + ((HEAP32[i17 + 24 >> 2] | 0) * 12 | 0) | 0;
 i12 = i11 + (HEAP32[i17 + 20 >> 2] << 5) | 0;
 i13 = i12 + ((HEAP32[i17 + 28 >> 2] | 0) * 12 | 0) | 0;
 i14 = i13 + ((HEAP32[i17 + 32 >> 2] | 0) * 12 | 0) | 0;
 i16 = i14 + (HEAP32[i17 + 36 >> 2] << 3) | 0;
 if ((i16 + i15 - i17 | 0) != (i18 | 0)) {
  i31 = -2147483648;
  STACKTOP = i32;
  return i31 | 0;
 }
 i9 = i27 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 do if ((i2 | 0) == -1) {
  i3 = i27 + 16 | 0;
  i23 = HEAP32[i3 >> 2] | 0;
  i1 = (i23 | 0) == 0 ? 4 : i23 << 1;
  if (i23 >>> 0 >= i1 >>> 0) {
   i31 = -2147483644;
   STACKTOP = i32;
   return i31 | 0;
  }
  i7 = i27 + 20 | 0;
  i4 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i7 >> 2] | 0, i1 * 56 | 0) | 0;
  if (!i4) i5 = HEAP32[i9 >> 2] | 0; else {
   HEAP32[i7 >> 2] = i4;
   i5 = HEAP32[i3 >> 2] | 0;
   i6 = i1 + -1 | 0;
   if (i5 >>> 0 < i6 >>> 0) {
    i2 = i5;
    do {
     HEAP32[i4 + (i2 * 56 | 0) + 4 >> 2] = 1;
     HEAP32[i4 + (i2 * 56 | 0) + 8 >> 2] = 0;
     i23 = i2;
     i2 = i2 + 1 | 0;
     HEAP32[i4 + (i23 * 56 | 0) + 52 >> 2] = i2;
    } while ((i2 | 0) != (i6 | 0));
   }
   HEAP32[i4 + (i6 * 56 | 0) + 4 >> 2] = 1;
   HEAP32[i4 + (i6 * 56 | 0) + 8 >> 2] = 0;
   HEAP32[i4 + (i6 * 56 | 0) + 52 >> 2] = -1;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i3 >> 2] = i1;
  }
  if ((i5 | 0) == -1) {
   i31 = -2147483644;
   STACKTOP = i32;
   return i31 | 0;
  } else {
   i23 = i7;
   i4 = HEAP32[i28 >> 2] | 0;
   i6 = HEAP32[i29 >> 2] | 0;
   i3 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i25 >> 2] | 0;
   i22 = i5;
   break;
  }
 } else {
  i23 = i27 + 20 | 0;
  i6 = i5;
  i3 = i7;
  i1 = i8;
  i22 = i2;
 } while (0);
 i21 = HEAP32[i23 >> 2] | 0;
 i8 = i21 + (i22 * 56 | 0) + 52 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = 0;
 i9 = i21 + (i22 * 56 | 0) | 0;
 i1 = i1 + (((Math_imul(i6, -669632447) | 0) + (Math_imul(i4, -1918454973) | 0) & i3) << 2) | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i22;
 HEAP32[i21 + (i22 * 56 | 0) + 20 >> 2] = i10;
 HEAP32[i21 + (i22 * 56 | 0) + 16 >> 2] = i11;
 HEAP32[i21 + (i22 * 56 | 0) + 24 >> 2] = i12;
 HEAP32[i21 + (i22 * 56 | 0) + 28 >> 2] = i13;
 HEAP32[i21 + (i22 * 56 | 0) + 32 >> 2] = i14;
 i1 = i21 + (i22 * 56 | 0) + 36 | 0;
 HEAP32[i1 >> 2] = i16;
 if (!i15) HEAP32[i1 >> 2] = 0;
 HEAP32[i9 >> 2] = i20;
 HEAP32[i21 + (i22 * 56 | 0) + 8 >> 2] = i17;
 HEAP32[i21 + (i22 * 56 | 0) + 12 >> 2] = 0;
 HEAP32[i21 + (i22 * 56 | 0) + 40 >> 2] = i17;
 HEAP32[i21 + (i22 * 56 | 0) + 44 >> 2] = i18;
 HEAP32[i21 + (i22 * 56 | 0) + 48 >> 2] = i19;
 __ZN9dtNavMesh15connectIntLinksEP10dtMeshTile(i27, i9);
 i5 = HEAP32[i28 >> 2] | 0;
 i6 = HEAP32[i29 >> 2] | 0;
 i1 = (Math_imul(i6, -669632447) | 0) + (Math_imul(i5, -1918454973) | 0) & HEAP32[i24 >> 2];
 i1 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i8 = 0; else {
  i7 = HEAP32[i23 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = i7 + (i1 * 56 | 0) | 0;
   i4 = HEAP32[i7 + (i1 * 56 | 0) + 8 >> 2] | 0;
   if (!i4) i3 = i2; else if ((HEAP32[i4 + 8 >> 2] | 0) == (i5 | 0)) if ((i2 | 0) < 32 ? (HEAP32[i4 + 12 >> 2] | 0) == (i6 | 0) : 0) {
    HEAP32[i26 + (i2 << 2) >> 2] = i3;
    i3 = i2 + 1 | 0;
   } else i3 = i2; else i3 = i2;
   i1 = HEAP32[i7 + (i1 * 56 | 0) + 52 >> 2] | 0;
   if ((i1 | 0) == -1) break; else i2 = i3;
  }
  if ((i3 | 0) > 0) {
   i1 = 0;
   do {
    i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
    if ((i2 | 0) != (i9 | 0)) {
     __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i(i27, i9, i2, -1);
     __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i(i27, i2, i9, -1);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i8 = 0;
  } else i8 = 0;
 }
 do {
  i2 = HEAP32[i28 >> 2] | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  switch (i8 | 0) {
  case 0:
   {
    i2 = i2 + 1 | 0;
    break;
   }
  case 1:
   {
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    break;
   }
  case 2:
   {
    i1 = i1 + 1 | 0;
    break;
   }
  case 3:
   {
    i1 = i1 + 1 | 0;
    i2 = i2 + -1 | 0;
    break;
   }
  case 4:
   {
    i2 = i2 + -1 | 0;
    break;
   }
  case 5:
   {
    i1 = i1 + -1 | 0;
    i2 = i2 + -1 | 0;
    break;
   }
  case 6:
   {
    i1 = i1 + -1 | 0;
    break;
   }
  case 7:
   {
    i1 = i1 + -1 | 0;
    i2 = i2 + 1 | 0;
    break;
   }
  default:
   {}
  }
  i3 = (Math_imul(i1, -669632447) | 0) + (Math_imul(i2, -1918454973) | 0) & HEAP32[i24 >> 2];
  i3 = HEAP32[(HEAP32[i25 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i3 | 0) != -1) {
   i7 = HEAP32[i23 >> 2] | 0;
   i4 = 0;
   do {
    i5 = i7 + (i3 * 56 | 0) | 0;
    i6 = HEAP32[i7 + (i3 * 56 | 0) + 8 >> 2] | 0;
    if (i6) if ((HEAP32[i6 + 8 >> 2] | 0) == (i2 | 0)) if ((i4 | 0) < 32 ? (HEAP32[i6 + 12 >> 2] | 0) == (i1 | 0) : 0) {
     HEAP32[i26 + (i4 << 2) >> 2] = i5;
     i4 = i4 + 1 | 0;
    }
    i3 = HEAP32[i7 + (i3 * 56 | 0) + 52 >> 2] | 0;
   } while ((i3 | 0) != -1);
   if ((i4 | 0) > 0) {
    i2 = i8 + 4 & 7;
    i1 = 0;
    do {
     i20 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
     __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i(i27, i9, i20, i8);
     __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i(i27, i20, i9, i2);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i4 | 0));
   }
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 8);
 i1 = HEAP32[i27 + 52 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i3 = i27 + 48 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do {
   i26 = i2 + (i1 * 104 | 0) + 24 | 0;
   if ((HEAP32[i26 >> 2] | 0) == 0 & (HEAP32[i26 + 4 >> 2] | 0) == 0) i31 = 38; else {
    i26 = i2 + (i1 * 104 | 0) + 56 | 0;
    if ((HEAP32[i26 >> 2] | 0) == 0 & (HEAP32[i26 + 4 >> 2] | 0) == 0) i31 = 38;
   }
   if ((i31 | 0) == 38) {
    i31 = 0;
    __ZN9dtNavMesh24connectOffMeshConnectionEj(i27, i1);
    i2 = HEAP32[i3 >> 2] | 0;
   }
   i1 = HEAP32[i2 + (i1 * 104 | 0) + 96 >> 2] | 0;
  } while ((i1 | 0) != -1);
 }
 if (i30 | 0) {
  i24 = (i9 - (HEAP32[i23 >> 2] | 0) | 0) / 56 | 0;
  i25 = _bitshift64Shl(HEAP32[i21 + (i22 * 56 | 0) + 4 >> 2] | 0, 0, 48) | 0;
  i26 = getTempRet0() | 0;
  i24 = _bitshift64Shl(i24 | 0, 0, 20) | 0;
  i26 = getTempRet0() | 0 | i26;
  i31 = i30;
  HEAP32[i31 >> 2] = i24 | i25;
  HEAP32[i31 + 4 >> 2] = i26;
 }
 i31 = i27 + 24 | 0;
 HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
 i31 = i27 + 60 | 0;
 i30 = HEAP32[i31 >> 2] | 0;
 i26 = HEAP32[i28 >> 2] | 0;
 HEAP32[i31 >> 2] = (i30 | 0) < (i26 | 0) ? i30 : i26;
 i31 = i27 + 68 | 0;
 i26 = HEAP32[i31 >> 2] | 0;
 i30 = HEAP32[i28 >> 2] | 0;
 HEAP32[i31 >> 2] = (i26 | 0) > (i30 | 0) ? i26 : i30;
 i31 = i27 + 64 | 0;
 i30 = HEAP32[i31 >> 2] | 0;
 i28 = HEAP32[i29 >> 2] | 0;
 HEAP32[i31 >> 2] = (i30 | 0) < (i28 | 0) ? i30 : i28;
 i31 = i27 + 72 | 0;
 i28 = HEAP32[i31 >> 2] | 0;
 i30 = HEAP32[i29 >> 2] | 0;
 HEAP32[i31 >> 2] = (i28 | 0) > (i30 | 0) ? i28 : i30;
 i31 = 1073741824;
 STACKTOP = i32;
 return i31 | 0;
}

function __ZN15QualitySettings14QualitySetting8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405573 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405589 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405597 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405614 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405631 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405646 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405661 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405683 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405703 | 0, HEAP32[gb + 37324 >> 2] | 0, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405723 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405736 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405751 | 0, i6, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405771 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405784 | 0, i7, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405798 | 0, i7, i1 + 81 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405813 | 0, i7, i1 + 82 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405838 | 0, i7, i1 + 83 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405867 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405878 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405886 | 0, i6, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405902 | 0, i6, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405924 | 0, i6, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405945 | 0, i6, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5IMGUI8DoWindowER8GUIStateiRK5RectTIfEP12Il2CppObjectR10GUIContentS7_S7_bb(i16, i15, i6, i9, i12, i10, i13, i14, i17, i5) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i11 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i18;
 i11 = i18 + 8 | 0;
 i1 = i15 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i7 = __Znwj(28) | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = -1;
  HEAP8[i7 + 16 >> 0] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAP32[i7 + 24 >> 2] = 0;
  HEAP32[i1 >> 2] = i7;
  i8 = i7;
  i1 = i7;
 } else {
  i8 = i2;
  i1 = i2;
 }
 if (HEAP32[i1 + 20 >> 2] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1018601 | 0, 0, gb + 1018710 | 0, 143, 1, 0, 0, 0);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 L8 : do if ((i1 | 0) == (i3 | 0)) i2 = 8; else {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = i1 + 4 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
   if ((i1 | 0) == (i3 | 0)) {
    i2 = 8;
    break L8;
   }
  }
  HEAP32[i11 >> 2] = i2;
  if (!i2) i2 = 13; else {
   i4 = i2;
   i2 = 21;
  }
 } while (0);
 do if ((i2 | 0) == 8) {
  i1 = HEAP32[i8 + 24 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i2 = 21;
   break;
  }
  HEAP32[i11 >> 2] = 0;
  i2 = 13;
 } while (0);
 L19 : do if ((i2 | 0) == 13) {
  if (i5) {
   i1 = i8 + 24 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    i2 = __Znwj(248) | 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i2 + 40 >> 2] = 0;
    HEAP32[i2 + 44 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
    i8 = i4;
    i5 = HEAP32[i8 + 4 >> 2] | 0;
    i7 = i2 + 32 | 0;
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i7 + 4 >> 2] = i5;
    i7 = i2 + 48 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    i7 = gb + 63672 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i2 + 72 >> 2] = 0;
    HEAP32[i2 + 76 >> 2] = 0;
    HEAP8[i2 + 80 >> 0] = 0;
    i8 = i2 + 84 | 0;
    HEAP32[i8 >> 2] = i5;
    HEAP32[i8 + 4 >> 2] = i7;
    HEAP32[i2 + 92 >> 2] = 0;
    HEAP32[i2 + 96 >> 2] = 0;
    HEAP8[i2 + 100 >> 0] = 0;
    i8 = i2 + 104 | 0;
    HEAP32[i8 >> 2] = i5;
    HEAP32[i8 + 4 >> 2] = i7;
    HEAP32[i2 + 112 >> 2] = 0;
    HEAP32[i2 + 124 >> 2] = 0;
    HEAP32[i2 + 120 >> 2] = 0;
    HEAP8[i2 + 118 >> 0] = 0;
    HEAP8[i2 + 117 >> 0] = 0;
    HEAP32[i2 + 128 >> 2] = 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 68 >> 2] = -1;
    HEAP32[i1 >> 2] = i2;
    i2 = 34;
    break;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1018779 | 0, 0, gb + 1018710 | 0, 152, 1, 0, 0, 0);
    HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    break;
   }
  }
  i2 = __Znwj(248) | 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAP32[i2 + 40 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i1 = i4;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i2 + 32 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  i5 = i2 + 48 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  i5 = gb + 63672 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i2 + 72 >> 2] = 0;
  HEAP32[i2 + 76 >> 2] = 0;
  HEAP8[i2 + 80 >> 0] = 0;
  i1 = i2 + 84 | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i5;
  HEAP32[i2 + 92 >> 2] = 0;
  HEAP32[i2 + 96 >> 2] = 0;
  HEAP8[i2 + 100 >> 0] = 0;
  i1 = i2 + 104 | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i5;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i2 + 124 >> 2] = 0;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP8[i2 + 118 >> 0] = 0;
  HEAP8[i2 + 117 >> 0] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 68 >> 2] = -1;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i8 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN5IMGUI9GUIWindowENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i11); else {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
  }
  HEAP8[i8 + 16 >> 0] = 1;
  i2 = 34;
 } else if ((i2 | 0) == 21) if (i5) {
  i1 = i8 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   if ((i2 | 0) == (i4 | 0)) {
    i2 = 34;
    break;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1018821 | 0, 0, gb + 1018710 | 0, 190, 1, 0, 0, 0);
   i2 = 34;
   break;
  }
  HEAP32[i1 >> 2] = i4;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2;
  L37 : do if ((i1 | 0) != (i2 | 0)) while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break L37;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i2 = 34;
    break L19;
   }
  } while (0);
  if ((i1 | 0) == (i2 | 0)) i2 = 34; else {
   i4 = i1 + 4 | 0;
   i3 = i3 - i4 | 0;
   i5 = i3 >> 2;
   if (i5) {
    _memmove(i1 | 0, i4 | 0, i3 | 0) | 0;
    i2 = HEAP32[i7 >> 2] | 0;
   }
   i1 = i1 + (i5 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   HEAP8[i8 + 16 >> 0] = 1;
   i2 = 34;
  }
 } else i2 = 34; while (0);
 if ((i2 | 0) == 34) {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1 + 117 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   i8 = i1 + 52 | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  } else HEAP8[i2 >> 0] = 0;
  __ZN11UTF16String10CopyStringERKS_(i1 + 72 | 0, i10);
  __ZN11UTF16String10CopyStringERKS_(i1 + 92 | 0, i10 + 20 | 0);
  HEAP32[i1 + 112 >> 2] = HEAP32[i10 + 40 >> 2];
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = i3 + 120 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __Z23scripting_gchandle_freej(i2);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + 124 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __Z23scripting_gchandle_freej(i2);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + 128 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __Z23scripting_gchandle_freej(i2);
   HEAP32[i1 >> 2] = 0;
  }
  i2 = __Z22scripting_gchandle_newP12Il2CppObject(i13) | 0;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 128 >> 2] = i2;
  i2 = __Z22scripting_gchandle_newP12Il2CppObject(i12) | 0;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 120 >> 2] = i2;
  i2 = __Z22scripting_gchandle_newP12Il2CppObject(i14) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i3 + 124 >> 2] = i2;
  HEAP8[i3 + 116 >> 0] = 1;
  HEAP8[i3 + 244 >> 0] = (HEAP32[i15 + 60 >> 2] | 0) != 0 & 1;
  i2 = HEAP32[i15 + 16 >> 2] | 0;
  i1 = HEAP32[i15 + 20 >> 2] | 0;
  i4 = HEAP32[i15 + 24 >> 2] | 0;
  HEAP32[i3 + 132 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i3 + 136 >> 2] = i2;
  HEAP32[i3 + 140 >> 2] = i1;
  HEAP32[i3 + 144 >> 2] = i4;
  i4 = HEAP32[i15 + 32 >> 2] | 0;
  i1 = HEAP32[i15 + 36 >> 2] | 0;
  i2 = HEAP32[i15 + 40 >> 2] | 0;
  HEAP32[i3 + 148 >> 2] = HEAP32[i15 + 28 >> 2];
  HEAP32[i3 + 152 >> 2] = i4;
  HEAP32[i3 + 156 >> 2] = i1;
  HEAP32[i3 + 160 >> 2] = i2;
  i2 = HEAP32[i15 + 48 >> 2] | 0;
  i1 = HEAP32[i15 + 52 >> 2] | 0;
  i4 = HEAP32[i15 + 56 >> 2] | 0;
  HEAP32[i3 + 164 >> 2] = HEAP32[i15 + 44 >> 2];
  HEAP32[i3 + 168 >> 2] = i2;
  HEAP32[i3 + 172 >> 2] = i1;
  HEAP32[i3 + 176 >> 2] = i4;
  i4 = i3 + 180 | 0;
  i1 = i15 + 108 | 0;
  i2 = i4 + 64 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  HEAP8[i3 + 118 >> 0] = i17 & 1;
  i17 = i3 + 52 | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 }
 STACKTOP = i18;
 return;
}

function __ZN13ComputeShader17CreateRuntimeDataEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 4 | 0;
 i15 = i20;
 i19 = __Z12GetGfxDevicev() | 0;
 i8 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i18, 22, 0) | 0;
 i16 = i8 + 8 | 0;
 i9 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i18, 22, 0) | 0;
 i6 = i9 + 20 | 0;
 i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
 if (i1 >>> 0 < 10) if (521 >>> (i1 & 1023) & 1) {
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i9 + 24 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) do {
   i2 = i1 + -20 | 0;
   HEAP32[i7 >> 2] = i2;
   i3 = HEAP32[i1 + -12 >> 2] | 0;
   i4 = i3;
   if (!i3) i1 = i2; else {
    i1 = i1 + -8 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
    __ZdlPv(i3);
    i1 = HEAP32[i7 >> 2] | 0;
   }
  } while ((i1 | 0) != (i5 | 0));
 }
 i12 = (HEAP32[i8 + 12 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0;
 i1 = (i12 | 0) / 96 | 0;
 i13 = i18 + 48 | 0;
 HEAP32[i13 >> 2] = i1;
 i2 = i1 * 976 | 0;
 i2 = __Znaj(i1 >>> 0 > 4400581 | i2 >>> 0 > 4294967291 ? -1 : i2 + 4 | 0) | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = i2 + 4 | 0;
 if (i12) {
  i1 = i2 + (i1 * 976 | 0) | 0;
  i3 = i2;
  do {
   HEAP32[i3 >> 2] = 0;
   i4 = i3 + 132 | 0;
   i5 = i4 + 64 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   i4 = i3 + 516 | 0;
   i5 = i4 + 64 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAP32[i3 + 964 >> 2] = 0;
   HEAP32[i3 + 968 >> 2] = 0;
   HEAP32[i3 + 972 >> 2] = 0;
   i4 = i3 + 772 | 0;
   i5 = i4 + 128 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   i3 = i3 + 976 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i12 = i18 + 44 | 0;
 HEAP32[i12 >> 2] = i2;
 L19 : do if ((i1 | 0) > 0) {
  i7 = i9 + 24 | 0;
  i1 = 0;
  while (1) {
   i10 = HEAP32[i16 >> 2] | 0;
   HEAP32[i2 + (i1 * 976 | 0) >> 2] = mftCall_iiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 784 >> 2] | 0, i19 | 0, HEAP32[i10 + (i1 * 96 | 0) + 64 >> 2] | 0, HEAP32[i10 + (i1 * 96 | 0) + 76 >> 2] | 0) | 0;
   i10 = HEAP32[(HEAP32[i19 >> 2] | 0) + 792 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i4 + (i1 * 976 | 0) >> 2];
   i5 = (HEAP32[i16 >> 2] | 0) + (i1 * 96 | 0) | 0;
   i11 = (HEAP8[(__ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i18, 22, 0) | 0) + 32 >> 0] | 0) != 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   mftCall_viiiiii(i10 | 0, i19 | 0, i14 | 0, i5 | 0, i6 | 0, i4 + (i1 * 976 | 0) + 964 | 0, i11 | 0);
   i11 = HEAP32[i16 >> 2] | 0;
   i4 = (HEAP32[i12 >> 2] | 0) + (i1 * 976 | 0) + 4 | 0;
   i5 = i4 + 64 | 0;
   do {
    HEAP32[i4 >> 2] = -1;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   i10 = HEAP32[i11 + (i1 * 96 | 0) + 4 >> 2] | 0;
   i8 = (HEAP32[i11 + (i1 * 96 | 0) + 8 >> 2] | 0) - i10 | 0;
   i9 = (i8 | 0) / 20 | 0;
   if (i8 | 0) {
    i5 = HEAP32[i6 >> 2] | 0;
    i8 = (HEAP32[i7 >> 2] | 0) - i5 | 0;
    i4 = (i8 | 0) / 20 | 0;
    if (i8 | 0) {
     i3 = 0;
     do {
      i8 = HEAP32[i10 + (i3 * 20 | 0) >> 2] | 0;
      i2 = 0;
      do {
       if ((HEAP32[i5 + (i2 * 20 | 0) >> 2] | 0) == (i8 | 0)) {
        i17 = 23;
        break;
       }
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i4 >>> 0);
      if ((i17 | 0) == 23) {
       i17 = 0;
       HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 * 976 | 0) + 4 + (i2 << 2) >> 2] = HEAP32[i10 + (i3 * 20 | 0) + 8 >> 2];
      }
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i9 >>> 0);
    }
   }
   i4 = HEAP32[i11 + (i1 * 96 | 0) + 16 >> 2] | 0;
   i10 = (HEAP32[i11 + (i1 * 96 | 0) + 20 >> 2] | 0) - i4 | 0;
   i3 = (i10 | 0) / 20 | 0;
   if (i10 | 0) {
    i5 = HEAP32[i12 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i5 + (i1 * 976 | 0) + 68 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 * 20 | 0) + 8 >> 2];
     HEAP32[i5 + (i1 * 976 | 0) + 132 + (i2 << 2) >> 2] = 0;
     HEAP32[i5 + (i1 * 976 | 0) + 196 + (i2 << 2) >> 2] = 2;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i3 >>> 0);
   }
   i4 = HEAP32[i11 + (i1 * 96 | 0) + 28 >> 2] | 0;
   i3 = (HEAP32[i11 + (i1 * 96 | 0) + 32 >> 2] | 0) - i4 >> 3;
   if (i3 | 0) {
    i5 = HEAP32[i12 >> 2] | 0;
    i2 = 0;
    do {
     HEAP32[i5 + (i1 * 976 | 0) + 260 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 3) >> 2] << 16 | HEAP32[i4 + (i2 << 3) + 4 >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   i4 = i11 + (i1 * 96 | 0) + 40 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i10 = (HEAP32[i11 + (i1 * 96 | 0) + 44 >> 2] | 0) - i2 | 0;
   i5 = (i10 | 0) / 20 | 0;
   if (i10 | 0) {
    i9 = i2;
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i2 + (i1 * 976 | 0) + 324 >> 2] = HEAP32[i9 + 8 >> 2];
    i9 = i9 + 12 | 0;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i2 = i2 + (i1 * 976 | 0) + 388 | 0;
    HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i2 + 4 >> 2] = i10;
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i2 + (i1 * 976 | 0) + 516 >> 2] = 0;
    if (i5 >>> 0 > 1) {
     i3 = 1;
     do {
      i8 = HEAP32[i4 >> 2] | 0;
      HEAP32[i2 + (i1 * 976 | 0) + 324 + (i3 << 2) >> 2] = HEAP32[i8 + (i3 * 20 | 0) + 8 >> 2];
      i8 = i8 + (i3 * 20 | 0) + 12 | 0;
      i9 = HEAP32[i8 + 4 >> 2] | 0;
      i10 = i2 + (i1 * 976 | 0) + 388 + (i3 << 3) | 0;
      HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i10 + 4 >> 2] = i9;
      i2 = HEAP32[i12 >> 2] | 0;
      HEAP32[i2 + (i1 * 976 | 0) + 516 + (i3 << 2) >> 2] = 0;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i5 >>> 0);
    }
   }
   i8 = i11 + (i1 * 96 | 0) + 52 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i11 = (HEAP32[i11 + (i1 * 96 | 0) + 56 >> 2] | 0) - i3 | 0;
   i5 = (i11 | 0) / 20 | 0;
   L49 : do if (i11 | 0) {
    i2 = 0;
    i4 = HEAP32[i12 >> 2] | 0;
    while (1) {
     HEAP32[i4 + (i1 * 976 | 0) + 580 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 * 20 | 0) + 8 >> 2];
     i10 = i3 + (i2 * 20 | 0) + 12 | 0;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i4 = i4 + (i1 * 976 | 0) + 644 + (i2 << 3) | 0;
     HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i4 + 4 >> 2] = i11;
     i4 = HEAP32[i12 >> 2] | 0;
     HEAP32[i4 + (i1 * 976 | 0) + 772 + (i2 << 2) >> 2] = 0;
     HEAP32[i4 + (i1 * 976 | 0) + 836 + (i2 << 2) >> 2] = 0;
     HEAP32[i4 + (i1 * 976 | 0) + 900 + (i2 << 2) >> 2] = 2;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i5 >>> 0) break L49;
     i3 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i13 >> 2] | 0)) break L19;
   i2 = HEAP32[i12 >> 2] | 0;
  }
 } else i7 = i9 + 24 | 0; while (0);
 HEAP32[i18 + 60 >> 2] = 0;
 i4 = i18 + 56 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i15 = 0;
  i17 = (i15 | 0) > -1;
  i17 = i17 ? i15 : -1;
  i17 = __Znaj(i17) | 0;
  i16 = i18 + 52 | 0;
  HEAP32[i16 >> 2] = i17;
  _memset(i17 | 0, 0, i15 | 0) | 0;
  i15 = HEAP32[i19 >> 2] | 0;
  i15 = i15 + 796 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i17 = HEAP32[i7 >> 2] | 0;
  i16 = HEAP32[i6 >> 2] | 0;
  i16 = i17 - i16 | 0;
  i16 = (i16 | 0) / 20 | 0;
  i17 = i18 + 128 | 0;
  i18 = i18 + 192 | 0;
  mftCall_viiii(i15 | 0, i19 | 0, i16 | 0, i17 | 0, i18 | 0);
  STACKTOP = i20;
  return;
 }
 i3 = (i1 - i2 | 0) / 20 | 0;
 i2 = 0;
 do {
  i1 = i5 + (i2 * 20 | 0) + 4 | 0;
  HEAP32[i18 + 128 + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
  HEAP32[i18 + 64 + (i2 << 2) >> 2] = HEAP32[i4 >> 2];
  i1 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 i15 = (i1 | 0) > -1;
 i15 = i15 ? i1 : -1;
 i15 = __Znaj(i15) | 0;
 i17 = i18 + 52 | 0;
 HEAP32[i17 >> 2] = i15;
 _memset(i15 | 0, 0, i1 | 0) | 0;
 i15 = HEAP32[i19 >> 2] | 0;
 i15 = i15 + 796 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i17 = HEAP32[i7 >> 2] | 0;
 i16 = HEAP32[i6 >> 2] | 0;
 i16 = i17 - i16 | 0;
 i16 = (i16 | 0) / 20 | 0;
 i17 = i18 + 128 | 0;
 i18 = i18 + 192 | 0;
 mftCall_viiii(i15 | 0, i19 | 0, i16 | 0, i17 | 0, i18 | 0);
 STACKTOP = i20;
 return;
}
function __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE(i20, i3, i18, i16, i19, f14, i11, i12, i21, f15, i4, i5, i6, f13, f17, i7, i8, i9, i2) {
 i20 = i20 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 f14 = Math_fround(f14);
 i11 = i11 | 0;
 i12 = i12 | 0;
 i21 = i21 | 0;
 f15 = Math_fround(f15);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f13 = Math_fround(f13);
 f17 = Math_fround(f17);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var f1 = f0, i10 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 8 | 0;
 i10 = i23;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 4 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 32 >> 2] = 0;
 HEAP32[i20 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i20 + 40 >> 2] = 0;
 HEAP32[i20 + 52 >> 2] = 0;
 HEAP32[i20 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 44 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 60 >> 2] = 0;
 HEAP32[i20 + 72 >> 2] = 0;
 HEAP32[i20 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 64 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i20 + 80 >> 2] = 0;
 HEAP32[i20 + 92 >> 2] = 0;
 HEAP32[i20 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 84 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 100 >> 2] = 0;
 HEAP32[i20 + 112 >> 2] = 0;
 HEAP32[i20 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 104 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i20 + 120 >> 2] = 0;
 HEAP32[i20 + 132 >> 2] = 0;
 HEAP32[i20 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 124 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 140 >> 2] = 0;
 HEAP32[i20 + 152 >> 2] = 0;
 HEAP32[i20 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 144 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i20 + 160 >> 2] = 0;
 HEAP32[i20 + 172 >> 2] = 0;
 HEAP32[i20 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 164 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 180 >> 2] = i2;
 HEAP32[i20 + 184 >> 2] = i18;
 i2 = (i19 | 0) != 0;
 if (i2) {
  f27 = Math_fround(Math_fround(Math_fround(i19 | 0) * f17) + Math_fround(.5));
  i26 = f27 >= Math_fround(0.0);
  f1 = Math_fround(f27 + Math_fround(-.99999994));
  f1 = i26 ? f27 : f1;
 } else {
  f27 = Math_fround(Math_fround(Math_fround(HEAP32[(HEAP32[i18 + 76 >> 2] | 0) + 36 >> 2] | 0) * f17) + Math_fround(.5));
  i26 = f27 >= Math_fround(0.0);
  f1 = Math_fround(f27 + Math_fround(-.99999994));
  f1 = i26 ? f27 : f1;
 }
 HEAP32[i20 + 188 >> 2] = ~~f1;
 HEAPF32[i20 + 192 >> 2] = f14;
 i24 = gb + 63672 | 0;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i10;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i20 + 196 | 0, i3, i22);
 HEAP32[i20 + 216 >> 2] = i4;
 HEAP32[i20 + 220 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i20 + 224 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP8[i20 + 228 >> 0] = i12 & 1;
 HEAP8[i20 + 229 >> 0] = i6 & 1;
 HEAP32[i20 + 232 >> 2] = i21;
 HEAP32[i20 + 236 >> 2] = i5;
 HEAPF32[i20 + 240 >> 2] = f15;
 HEAPF32[i20 + 244 >> 2] = f17;
 HEAPF32[i20 + 248 >> 2] = f13;
 HEAP8[i20 + 252 >> 0] = i7 & 1;
 HEAP8[i20 + 253 >> 0] = i8 & 1;
 HEAP8[i20 + 254 >> 0] = i9 & 1;
 HEAP32[i20 + 256 >> 2] = 0;
 HEAP32[i20 + 260 >> 2] = 0;
 HEAP32[i20 + 264 >> 2] = -1;
 HEAP32[i20 + 268 >> 2] = 0;
 HEAP32[i20 + 272 >> 2] = 0;
 HEAP32[i20 + 276 >> 2] = 0;
 i11 = i20 + 288 | 0;
 i12 = i20 + 332 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 i11 = HEAP32[i16 >> 2] | 0;
 if (i2) {
  f27 = Math_fround(Math_fround(Math_fround(i19 | 0) * f17) + Math_fround(.5));
  i26 = f27 >= Math_fround(0.0);
  f1 = Math_fround(f27 + Math_fround(-.99999994));
  f1 = i26 ? f27 : f1;
 } else {
  f27 = Math_fround(Math_fround(Math_fround(HEAP32[(HEAP32[i18 + 76 >> 2] | 0) + 36 >> 2] | 0) * f17) + Math_fround(.5));
  i26 = f27 >= Math_fround(0.0);
  f1 = Math_fround(f27 + Math_fround(-.99999994));
  f1 = i26 ? f27 : f1;
 }
 i3 = ~~f1;
 HEAP32[i12 >> 2] = 0;
 i4 = i20 + 344 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i20 + 348 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i20 + 336 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i9 = i22;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = HEAP32[i4 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i8 >>> 0 > i10 >>> 0) {
  i2 = i9 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 5, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i26 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i26 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] << 5 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i12 >> 2] = i26;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i8;
 i25 = HEAP32[i12 >> 2] | 0;
 HEAP32[i25 + (i7 << 5) >> 2] = 0;
 HEAP32[i25 + (i7 << 5) + 4 >> 2] = -1;
 i26 = i25 + (i7 << 5) + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAPF32[i25 + (i7 << 5) + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i25 + (i7 << 5) + 28 >> 2] = Math_fround(1.0);
 i25 = HEAP32[i12 >> 2] | 0;
 HEAP32[i25 + ((HEAP32[i4 >> 2] | 0) + -1 << 5) + 4 >> 2] = i11;
 i26 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i25 + (i26 << 5) + 8 >> 2] = i3;
 HEAP32[i25 + (i26 << 5) >> 2] = i21;
 HEAP8[i20 + 352 >> 0] = 1;
 HEAP32[i20 + 356 >> 2] = 0;
 HEAP32[i20 + 368 >> 2] = 0;
 HEAP32[i20 + 372 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 360 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 376 >> 2] = 0;
 HEAP32[i20 + 388 >> 2] = 0;
 HEAP32[i20 + 392 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 380 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 HEAP32[i20 + 396 >> 2] = 0;
 HEAP32[i20 + 408 >> 2] = 0;
 HEAP32[i20 + 412 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i26 = i22;
 i25 = HEAP32[i26 + 4 >> 2] | 0;
 i24 = i20 + 400 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 HEAP32[i20 + 416 >> 2] = 0;
 HEAP32[i20 + 428 >> 2] = 0;
 HEAP32[i20 + 432 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, gb + 63664 | 0);
 i24 = i22;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i26 = i20 + 420 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = i25;
 STACKTOP = i23;
 return;
}

function __ZN7mecanim9animation18ClipMuscleConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN7mecanim5human9HumanPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7 + 888 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7 + 928 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7 + 968 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7 + 1008 | 0, i8);
 i5 = i7 + 1048 | 0;
 i10 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i9 = i8 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 i2 = i7 + 1060 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i3 = i1;
  i4 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i5 = i2;
  i1 = i1 | 0 ? i1 - i5 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i5;
 }
 __ZN7mecanim9animation4Clip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + i2 | 0, i8);
 i1 = i7 + 1064 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 1068 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 1072 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 1076 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 1080 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 1084 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 155;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = 155;
  HEAP32[i10 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
 i2 = i7 + 1708 | 0;
 i1 = i7 + 1088 | 0;
 do {
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i7 + 1712;
 HEAP32[i6 + 4 >> 2] = i7 + 1708;
 HEAP32[i6 + 8 >> 2] = i4;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i8, i6, 0);
 i4 = i7 + 1720 | 0;
 i5 = i7 + 1716 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i7 + 1724 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1725 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1726 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1727 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1728 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1729 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1730 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1731 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1732 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1733 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 1734 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i22) {
 i5 = i5 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, f46 = f0;
 i23 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i25 = i23 + 4 | 0;
 i7 = HEAP32[i25 >> 2] | 0;
 i26 = i23 + 8 | 0;
 i6 = HEAP32[i26 >> 2] | 0;
 i27 = i23 + 16 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 i28 = i23 + 20 | 0;
 i2 = HEAP32[i28 >> 2] | 0;
 i24 = i23 + 24 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i9 = HEAP32[i5 + 16 >> 2] | 0;
 i21 = HEAP16[i5 + 26 >> 1] | 0;
 i20 = i9 + ((i21 & 65535) << 4) | 0;
 if (!(i21 << 16 >> 16)) {
  i19 = i6;
  i18 = i7;
  i17 = i4;
  i22 = i3;
  i21 = i2;
  i20 = i1;
  HEAP32[i23 >> 2] = i17;
  HEAP32[i25 >> 2] = i18;
  HEAP32[i26 >> 2] = i19;
  HEAP32[i27 >> 2] = i20;
  HEAP32[i28 >> 2] = i21;
  HEAP32[i24 >> 2] = i22;
  return;
 }
 i21 = i22 + 1 | 0;
 i5 = i7;
 do {
  i10 = i9 + 32 | 0;
  i7 = HEAP8[i9 + 5 >> 0] | 0;
  i14 = i7 & 255;
  i15 = HEAP8[i9 + 6 >> 0] | 0;
  i19 = i15 & 255;
  i18 = (i14 * 80 | 0) + 32 | 0;
  i17 = i9 + i18 | 0;
  i16 = HEAP32[i9 + 24 >> 2] | 0;
  if (!(i7 << 24 >> 24)) f8 = Math_fround(0.0); else {
   f11 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = Math_fround(0.0);
   i7 = 0;
   do {
    i45 = i7;
    i7 = i7 + 1 | 0;
    f38 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) >> 2]);
    f37 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 4 >> 2]);
    f36 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 8 >> 2]);
    f13 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 12 >> 2]);
    f33 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 16 >> 2]);
    f31 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 20 >> 2]);
    f43 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 24 >> 2]);
    i29 = i10 + (i45 * 80 | 0) + 28 | 0;
    f12 = Math_fround(HEAPF32[i29 >> 2]);
    f32 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 60 >> 2]);
    f44 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 44 >> 2]);
    f42 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 76 >> 2]);
    f41 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f30 = Math_fround(f41 * f38);
    f40 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f30 = Math_fround(f30 + Math_fround(f40 * f37));
    f39 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f30 = Math_fround(f30 + Math_fround(f39 * f36));
    f35 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f33 = Math_fround(f35 * f33);
    f34 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f31 = Math_fround(f33 + Math_fround(f34 * f31));
    f33 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f44 = Math_fround(Math_fround(f13 * f32) - f44);
    f43 = Math_fround(f30 + Math_fround(f31 + Math_fround(f33 * f43)));
    f31 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 48 >> 2]);
    f30 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 52 >> 2]);
    f32 = Math_fround(HEAPF32[i10 + (i45 * 80 | 0) + 56 >> 2]);
    f38 = Math_fround(f11 * f38);
    f37 = Math_fround(f11 * f37);
    f36 = Math_fround(f11 * f36);
    f43 = Math_fround(f44 - Math_fround(f13 * f43));
    f13 = Math_fround(-f12);
    f13 = Math_fround(f12 + (f43 > f13 ? f43 : f13));
    f13 = f13 > f42 ? f42 : f13;
    f12 = Math_fround(f13 - f12);
    f38 = Math_fround(f41 + Math_fround(f38 * f12));
    f37 = Math_fround(f40 + Math_fround(f37 * f12));
    f36 = Math_fround(f39 + Math_fround(f36 * f12));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    f31 = Math_fround(f35 + Math_fround(f31 * f12));
    f30 = Math_fround(f34 + Math_fround(f30 * f12));
    f12 = Math_fround(f33 + Math_fround(f32 * f12));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i29 >> 2] = f13;
    f8 = Math_fround(f8 + f13);
   } while ((i7 | 0) != (i14 | 0));
  }
  if (i15 << 24 >> 24 != 0 & (HEAP8[i22 >> 0] | 0) != 0) {
   f13 = Math_fround(f8 * Math_fround(HEAPF32[i9 + 16 >> 2]));
   f11 = Math_fround(f8 * Math_fround(HEAPF32[i9 + 20 >> 2]));
   f12 = Math_fround(-f11);
   f8 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = 0;
   while (1) {
    i10 = i7 + 1 | 0;
    f34 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) >> 2]);
    f35 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 4 >> 2]);
    f36 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 8 >> 2]);
    i14 = i17 + (i7 * 96 | 0) + 12 | 0;
    f42 = Math_fround(HEAPF32[i14 >> 2]);
    f38 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 16 >> 2]);
    f41 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 20 >> 2]);
    f43 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 24 >> 2]);
    f30 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 28 >> 2]);
    f44 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 44 >> 2]);
    f46 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 76 >> 2]);
    f31 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f31 * f34);
    f32 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f39 + Math_fround(f32 * f35));
    f33 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f39 + Math_fround(f33 * f36));
    f40 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f40 * f38);
    f37 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f41 = Math_fround(f38 + Math_fround(f37 * f41));
    f38 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f39 + Math_fround(f41 + Math_fround(f38 * f43)));
    f46 = Math_fround(f42 - Math_fround(f30 * Math_fround(f44 - f46)));
    i15 = i17 + (i7 * 96 | 0) + 48 | 0;
    f44 = Math_fround(HEAPF32[i15 >> 2]);
    f41 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 52 >> 2]);
    f39 = Math_fround(HEAPF32[i17 + (i7 * 96 | 0) + 56 >> 2]);
    i45 = i17 + (i7 * 96 | 0) + 60 | 0;
    f34 = Math_fround(f8 * f34);
    f35 = Math_fround(f8 * f35);
    f36 = Math_fround(f8 * f36);
    i29 = HEAP32[i45 >> 2] | 0;
    f43 = Math_fround(f46 - Math_fround(f30 * f43));
    i16 = Math_fround(Math_abs(Math_fround(f43))) > f13;
    f30 = f43 < f12 ? f12 : f43;
    f43 = i16 ? (f11 > f30 ? f30 : f11) : f43;
    f42 = Math_fround(f43 - f42);
    f34 = Math_fround(f31 + Math_fround(f34 * f42));
    f35 = Math_fround(f32 + Math_fround(f35 * f42));
    f36 = Math_fround(f33 + Math_fround(f36 * f42));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    f40 = Math_fround(f40 + Math_fround(f44 * f42));
    f41 = Math_fround(f37 + Math_fround(f41 * f42));
    f42 = Math_fround(f38 + Math_fround(f39 * f42));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i14 >> 2] = f43;
    HEAPF32[i15 >> 2] = f44;
    HEAP32[i45 >> 2] = i16 ? 1065353216 : i29;
    if ((i10 | 0) == (i19 | 0)) break; else i7 = i10;
   }
  }
  i9 = i9 + (i18 + (i19 * 96 | 0)) | 0;
 } while (i9 >>> 0 < i20 >>> 0);
 HEAP32[i23 >> 2] = i4;
 HEAP32[i25 >> 2] = i5;
 HEAP32[i26 >> 2] = i6;
 HEAP32[i27 >> 2] = i1;
 HEAP32[i28 >> 2] = i2;
 HEAP32[i24 >> 2] = i3;
 return;
}

function __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj(i25, i24, i3, i1, i2) {
 i25 = i25 | 0;
 i24 = i24 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f26 = f0, f27 = f0;
 i4 = i25 + 12 | 0;
 if (HEAP8[(HEAP32[i4 >> 2] | 0) + i24 >> 0] | 0) return;
 i18 = i25 + 40 | 0;
 HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
 mftCall_viiiii(HEAP32[i25 + 16 >> 2] | 0, i25 | 0, i24 | 0, i3 | 0, i1 | 0, i2 | 0);
 i18 = HEAP32[(HEAP32[i25 >> 2] | 0) + 4 >> 2] | 0;
 i7 = HEAP32[i18 + (i24 * 12 | 0) >> 2] | 0;
 i11 = HEAP32[i18 + (i24 * 12 | 0) + 4 >> 2] | 0;
 i18 = HEAP32[i18 + (i24 * 12 | 0) + 8 >> 2] | 0;
 i12 = i7 & 536870911;
 i8 = i7 >>> 30;
 i10 = i11 & 536870911;
 i9 = i11 >>> 30;
 i1 = i18 & 536870911;
 i17 = i18 >>> 30;
 HEAP8[(HEAP32[i4 >> 2] | 0) + i24 >> 0] = 1;
 if ((i12 | 0) == 536870911) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  i3 = 2139095039;
 } else {
  i3 = HEAP32[i25 + 36 >> 2] | 0;
  i23 = HEAP32[i25 + 32 >> 2] | 0;
  i21 = HEAP32[i3 + (i12 * 12 | 0) >> 2] | 0;
  i22 = HEAP32[i3 + (i12 * 12 | 0) + 4 >> 2] | 0;
  i3 = HEAP32[i3 + (i12 * 12 | 0) + 8 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) >> 2]));
  f6 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 4 >> 2]));
  f16 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 8 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i23 + (i3 * 12 | 0) >> 2]));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i23 + (i3 * 12 | 0) + 4 >> 2]));
  f5 = Math_fround(f5 * Math_fround(.333333343));
  f6 = Math_fround(f6 * Math_fround(.333333343));
  f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i23 + (i3 * 12 | 0) + 8 >> 2])) * Math_fround(.333333343));
  f5 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) - f5);
  f6 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) - f6);
  f16 = Math_fround(Math_fround(HEAPF32[i25 + 28 >> 2]) - f16);
  f16 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f16 * f16));
  f6 = f16;
  i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if ((i10 | 0) == 536870911) {
  f5 = Math_fround(3402823469999999843913219.0e14);
  i2 = 2139095039;
 } else {
  i2 = HEAP32[i25 + 36 >> 2] | 0;
  i23 = HEAP32[i25 + 32 >> 2] | 0;
  i21 = HEAP32[i2 + (i10 * 12 | 0) >> 2] | 0;
  i22 = HEAP32[i2 + (i10 * 12 | 0) + 4 >> 2] | 0;
  i2 = HEAP32[i2 + (i10 * 12 | 0) + 8 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) >> 2]);
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) >> 2]));
  f5 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 4 >> 2]));
  f16 = Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 8 >> 2]));
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i23 + (i2 * 12 | 0) >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 4 >> 2]));
  f26 = Math_fround(f26 * Math_fround(.333333343));
  f5 = Math_fround(f5 * Math_fround(.333333343));
  f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i23 + (i2 * 12 | 0) + 8 >> 2])) * Math_fround(.333333343));
  f26 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) - f26);
  f5 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) - f5);
  f16 = Math_fround(Math_fround(HEAPF32[i25 + 28 >> 2]) - f16);
  f16 = Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f5 * f5)) + Math_fround(f16 * f16));
  f5 = f16;
  i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if ((i1 | 0) == 536870911) {
  i1 = 536870911;
  i22 = 2139095039;
  f16 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i22 = HEAP32[i25 + 36 >> 2] | 0;
  i23 = HEAP32[i25 + 32 >> 2] | 0;
  i20 = HEAP32[i22 + (i1 * 12 | 0) >> 2] | 0;
  i21 = HEAP32[i22 + (i1 * 12 | 0) + 4 >> 2] | 0;
  i22 = HEAP32[i22 + (i1 * 12 | 0) + 8 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i23 + (i20 * 12 | 0) >> 2]);
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i23 + (i21 * 12 | 0) >> 2]));
  f26 = Math_fround(HEAPF32[i23 + (i20 * 12 | 0) + 4 >> 2]);
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 4 >> 2]));
  f16 = Math_fround(HEAPF32[i23 + (i20 * 12 | 0) + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i23 + (i21 * 12 | 0) + 8 >> 2]));
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) >> 2]));
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 4 >> 2]));
  f27 = Math_fround(f27 * Math_fround(.333333343));
  f26 = Math_fround(f26 * Math_fround(.333333343));
  f16 = Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i23 + (i22 * 12 | 0) + 8 >> 2])) * Math_fround(.333333343));
  f27 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) - f27);
  f26 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) - f26);
  f16 = Math_fround(Math_fround(HEAPF32[i25 + 28 >> 2]) - f16);
  f16 = Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f26 * f26)) + Math_fround(f16 * f16));
  i22 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f6 > f5) {
  f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = i3;
  i3 = i2;
  i15 = 0;
  i14 = 1;
  i21 = i8;
  i8 = i9;
  i20 = i12;
  i12 = i10;
  i19 = i7;
  i7 = i11;
 } else {
  i4 = i2;
  i15 = 1;
  i14 = 0;
  i21 = i9;
  i20 = i10;
  i19 = i11;
 }
 i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 if (f5 > f16) {
  f5 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i2 = i22;
  f16 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i23 = i4;
  i11 = i15;
  i13 = i21;
  i10 = i20;
  i9 = i19;
  i4 = i22;
  i15 = 2;
 } else {
  i23 = i22;
  i11 = 2;
  i13 = i17;
  i10 = i1;
  i9 = i18;
  i17 = i21;
  i1 = i20;
  i18 = i19;
 }
 if (f6 > f5) {
  f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = i3;
  i21 = i2;
  i20 = i14;
  i14 = i15;
  i19 = i8;
  i8 = i17;
  i17 = i12;
  i12 = i1;
  i15 = i7;
  i7 = i18;
 } else {
  i21 = i3;
  i20 = i15;
  i19 = i17;
  i17 = i1;
  i15 = i18;
 }
 if (f5 > f16) {
  f5 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i20;
  i2 = i19;
  i3 = i17;
  i4 = i15;
 } else {
  i1 = i11;
  i2 = i13;
  i3 = i10;
  i4 = i9;
  i11 = i20;
  i13 = i19;
  i10 = i17;
  i9 = i15;
 }
 if (f6 > f5) {
  i17 = i10;
  i18 = i13;
  i19 = i11;
  f5 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i15 = i9;
  i13 = i8;
 } else {
  i17 = i12;
  i18 = i8;
  i19 = i14;
  i15 = i7;
  i14 = i11;
  i12 = i10;
  i7 = i9;
 }
 if (f5 > f16) {
  i8 = i4;
  i9 = i3;
  i10 = i2;
  i11 = i1;
  i4 = i7;
  i3 = i12;
  i2 = i13;
  i1 = i14;
 } else {
  i8 = i7;
  i9 = i12;
  i10 = i13;
  i11 = i14;
 }
 if ((i15 & 536870911 | 0) != 536870911) __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj(i25, i17, i24, i18, i19);
 if ((i8 & 536870911 | 0) != 536870911) __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj(i25, i9, i24, i10, i11);
 if ((i4 & 536870911 | 0) == 536870911) return;
 __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj(i25, i3, i24, i2, i1);
 return;
}

function __ZNK20b2SeparationFunction17FindMinSeparationEPiS0_f(i7, i25, i26, f1) {
 i7 = i7 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f20 = Math_fround(Math_fround(1.0) - f1);
 f23 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 16 >> 2]));
 f12 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 20 >> 2]));
 f11 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * f1);
 f11 = Math_fround(f23 + f11);
 f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i7 + 28 >> 2]) * f1));
 f23 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 32 >> 2]));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i7 + 36 >> 2]) * f1));
 f22 = Math_fround(+Math_sin(+f23));
 f23 = Math_fround(+Math_cos(+f23));
 f19 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f18 = Math_fround(f23 * f19);
 f24 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f18 = Math_fround(f11 - Math_fround(f18 - Math_fround(f22 * f24)));
 f24 = Math_fround(f12 - Math_fround(Math_fround(f22 * f19) + Math_fround(f23 * f24)));
 f19 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 52 >> 2]));
 f12 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 56 >> 2]));
 f11 = Math_fround(Math_fround(HEAPF32[i7 + 60 >> 2]) * f1);
 f11 = Math_fround(f19 + f11);
 f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i7 + 64 >> 2]) * f1));
 f20 = Math_fround(f20 * Math_fround(HEAPF32[i7 + 68 >> 2]));
 f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i7 + 72 >> 2]) * f1));
 f19 = Math_fround(+Math_sin(+f20));
 f20 = Math_fround(+Math_cos(+f20));
 f13 = Math_fround(HEAPF32[i7 + 44 >> 2]);
 f17 = Math_fround(f20 * f13);
 f21 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f17 = Math_fround(f11 - Math_fround(f17 - Math_fround(f19 * f21)));
 f21 = Math_fround(f12 - Math_fround(Math_fround(f19 * f13) + Math_fround(f20 * f21)));
 switch (HEAP32[i7 + 80 >> 2] | 0) {
 case 0:
  {
   i14 = i7 + 92 | 0;
   f11 = Math_fround(HEAPF32[i14 >> 2]);
   f8 = Math_fround(f23 * f11);
   i15 = i7 + 96 | 0;
   f13 = Math_fround(HEAPF32[i15 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f22 * f13));
   f9 = Math_fround(Math_fround(f23 * f13) - Math_fround(f22 * f11));
   f11 = Math_fround(-f11);
   f13 = Math_fround(-f13);
   f10 = Math_fround(Math_fround(f20 * f11) + Math_fround(f19 * f13));
   f11 = Math_fround(Math_fround(f20 * f13) - Math_fround(f19 * f11));
   i6 = HEAP32[i7 >> 2] | 0;
   i16 = HEAP32[i6 + 16 >> 2] | 0;
   i6 = HEAP32[i6 + 20 >> 2] | 0;
   if ((i6 | 0) > 1) {
    f1 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
    i3 = 1;
    f1 = Math_fround(f1 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 4 >> 2])));
    i2 = 0;
    while (1) {
     f5 = Math_fround(f8 * Math_fround(HEAPF32[i16 + (i3 << 3) >> 2]));
     f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i16 + (i3 << 3) + 4 >> 2])));
     i4 = f5 > f1;
     i2 = i4 ? i3 : i2;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i6 | 0)) break; else f1 = i4 ? f5 : f1;
    }
   } else i2 = 0;
   HEAP32[i25 >> 2] = i2;
   i4 = HEAP32[i7 + 4 >> 2] | 0;
   i7 = HEAP32[i4 + 16 >> 2] | 0;
   i4 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i4 | 0) > 1) {
    f1 = Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2]));
    i3 = 1;
    f1 = Math_fround(f1 + Math_fround(f11 * Math_fround(HEAPF32[i7 + 4 >> 2])));
    i2 = 0;
    while (1) {
     f5 = Math_fround(f10 * Math_fround(HEAPF32[i7 + (i3 << 3) >> 2]));
     f5 = Math_fround(f5 + Math_fround(f11 * Math_fround(HEAPF32[i7 + (i3 << 3) + 4 >> 2])));
     i6 = f5 > f1;
     i2 = i6 ? i3 : i2;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i4 | 0)) break; else f1 = i6 ? f5 : f1;
    }
   } else i2 = 0;
   HEAP32[i26 >> 2] = i2;
   i26 = HEAP32[i25 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i16 + (i26 << 3) >> 2]);
   f13 = Math_fround(HEAPF32[i16 + (i26 << 3) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i7 + (i2 << 3) >> 2]);
   f11 = Math_fround(HEAPF32[i7 + (i2 << 3) + 4 >> 2]);
   f18 = Math_fround(Math_fround(f17 + Math_fround(Math_fround(f20 * f10) - Math_fround(f19 * f11))) - Math_fround(f18 + Math_fround(Math_fround(f23 * f12) - Math_fround(f22 * f13))));
   f24 = Math_fround(Math_fround(f21 + Math_fround(Math_fround(f19 * f10) + Math_fround(f20 * f11))) - Math_fround(f24 + Math_fround(Math_fround(f22 * f12) + Math_fround(f23 * f13))));
   f23 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f18);
   f24 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f24));
   return Math_fround(f24);
  }
 case 1:
  {
   f9 = Math_fround(HEAPF32[i7 + 92 >> 2]);
   f12 = Math_fround(f23 * f9);
   f13 = Math_fround(HEAPF32[i7 + 96 >> 2]);
   f12 = Math_fround(f12 - Math_fround(f22 * f13));
   f13 = Math_fround(Math_fround(f22 * f9) + Math_fround(f23 * f13));
   f9 = Math_fround(HEAPF32[i7 + 84 >> 2]);
   f11 = Math_fround(f23 * f9);
   f10 = Math_fround(HEAPF32[i7 + 88 >> 2]);
   f11 = Math_fround(f18 + Math_fround(f11 - Math_fround(f22 * f10)));
   f10 = Math_fround(f24 + Math_fround(Math_fround(f22 * f9) + Math_fround(f23 * f10)));
   f9 = Math_fround(-f12);
   f24 = Math_fround(-f13);
   f8 = Math_fround(Math_fround(f20 * f9) + Math_fround(f19 * f24));
   f9 = Math_fround(Math_fround(f20 * f24) - Math_fround(f19 * f9));
   HEAP32[i25 >> 2] = -1;
   i4 = HEAP32[i7 + 4 >> 2] | 0;
   i7 = HEAP32[i4 + 16 >> 2] | 0;
   i4 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i4 | 0) > 1) {
    f1 = Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2]));
    i3 = 1;
    f1 = Math_fround(f1 + Math_fround(f9 * Math_fround(HEAPF32[i7 + 4 >> 2])));
    i2 = 0;
    while (1) {
     f5 = Math_fround(f8 * Math_fround(HEAPF32[i7 + (i3 << 3) >> 2]));
     f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i7 + (i3 << 3) + 4 >> 2])));
     i6 = f5 > f1;
     i2 = i6 ? i3 : i2;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i4 | 0)) break; else f1 = i6 ? f5 : f1;
    }
   } else i2 = 0;
   HEAP32[i26 >> 2] = i2;
   f23 = Math_fround(HEAPF32[i7 + (i2 << 3) >> 2]);
   f24 = Math_fround(HEAPF32[i7 + (i2 << 3) + 4 >> 2]);
   f24 = Math_fround(Math_fround(f12 * Math_fround(Math_fround(f17 + Math_fround(Math_fround(f20 * f23) - Math_fround(f19 * f24))) - f11)) + Math_fround(f13 * Math_fround(Math_fround(f21 + Math_fround(Math_fround(f19 * f23) + Math_fround(f20 * f24))) - f10)));
   return Math_fround(f24);
  }
 case 2:
  {
   f9 = Math_fround(HEAPF32[i7 + 92 >> 2]);
   f12 = Math_fround(f20 * f9);
   f13 = Math_fround(HEAPF32[i7 + 96 >> 2]);
   f12 = Math_fround(f12 - Math_fround(f19 * f13));
   f13 = Math_fround(Math_fround(f19 * f9) + Math_fround(f20 * f13));
   f9 = Math_fround(HEAPF32[i7 + 84 >> 2]);
   f11 = Math_fround(f20 * f9);
   f10 = Math_fround(HEAPF32[i7 + 88 >> 2]);
   f11 = Math_fround(f17 + Math_fround(f11 - Math_fround(f19 * f10)));
   f10 = Math_fround(f21 + Math_fround(Math_fround(f19 * f9) + Math_fround(f20 * f10)));
   f9 = Math_fround(-f12);
   f21 = Math_fround(-f13);
   f8 = Math_fround(Math_fround(f23 * f9) + Math_fround(f22 * f21));
   f9 = Math_fround(Math_fround(f23 * f21) - Math_fround(f22 * f9));
   HEAP32[i26 >> 2] = -1;
   i4 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i4 + 16 >> 2] | 0;
   i4 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i4 | 0) > 1) {
    f1 = Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2]));
    i3 = 1;
    f1 = Math_fround(f1 + Math_fround(f9 * Math_fround(HEAPF32[i7 + 4 >> 2])));
    i2 = 0;
    while (1) {
     f5 = Math_fround(f8 * Math_fround(HEAPF32[i7 + (i3 << 3) >> 2]));
     f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i7 + (i3 << 3) + 4 >> 2])));
     i6 = f5 > f1;
     i2 = i6 ? i3 : i2;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i4 | 0)) break; else f1 = i6 ? f5 : f1;
    }
   } else i2 = 0;
   HEAP32[i25 >> 2] = i2;
   f20 = Math_fround(HEAPF32[i7 + (i2 << 3) >> 2]);
   f21 = Math_fround(HEAPF32[i7 + (i2 << 3) + 4 >> 2]);
   f24 = Math_fround(Math_fround(f12 * Math_fround(Math_fround(f18 + Math_fround(Math_fround(f23 * f20) - Math_fround(f22 * f21))) - f11)) + Math_fround(f13 * Math_fround(Math_fround(f24 + Math_fround(Math_fround(f22 * f20) + Math_fround(f23 * f21))) - f10)));
   return Math_fround(f24);
  }
 default:
  {
   HEAP32[i25 >> 2] = -1;
   HEAP32[i26 >> 2] = -1;
   f24 = Math_fround(0.0);
   return Math_fround(f24);
  }
 }
 return f0;
}

function __ZN5physx2Gu8gjkLocalINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i1, i34, i45, i46, i47, i48) {
 i1 = i1 | 0;
 i34 = i34 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 i48 = i48 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i49 = 0, i50 = 0, i51 = 0, f52 = f0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i50 + 176 | 0;
 i42 = i50 + 112 | 0;
 i43 = i50 + 48 | 0;
 i41 = i50 + 276 | 0;
 i49 = i50 + 32 | 0;
 i39 = i50 + 264 | 0;
 i35 = i50 + 16 | 0;
 i36 = i50;
 i27 = i50 + 252 | 0;
 i40 = i50 + 240 | 0;
 HEAP32[i41 >> 2] = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i34 >> 2]);
 f9 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 f8 = Math_fround(f2 - f8);
 f9 = Math_fround(f28 - f9);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i34 + 8 >> 2]));
 i37 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)) > Math_fround(0.0);
 f8 = i37 ? f8 : Math_fround(1.0);
 f9 = i37 ? f9 : Math_fround(0.0);
 f10 = i37 ? f10 : Math_fround(0.0);
 HEAPF32[i49 >> 2] = f8;
 i37 = i49 + 4 | 0;
 HEAPF32[i37 >> 2] = f9;
 i38 = i49 + 8 | 0;
 HEAPF32[i38 >> 2] = f10;
 HEAPF32[i49 + 12 >> 2] = Math_fround(0.0);
 f28 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i34 + 32 >> 2]);
 f28 = Math_fround((f28 > f2 ? f2 : f28) * Math_fround(.100000001));
 f28 = Math_fround(f28 * f28);
 i29 = i1 + 96 | 0;
 i30 = i1 + 100 | 0;
 i31 = i1 + 104 | 0;
 i32 = i1 + 112 | 0;
 i33 = i1 + 116 | 0;
 i7 = i1 + 120 | 0;
 i17 = i35 + 4 | 0;
 i18 = i35 + 8 | 0;
 i19 = i36 + 4 | 0;
 i20 = i36 + 8 | 0;
 i21 = i36 + 12 | 0;
 i22 = i44 + 4 | 0;
 i23 = i44 + 8 | 0;
 i24 = i44 + 16 | 0;
 i25 = i44 + 20 | 0;
 i26 = i44 + 24 | 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  f6 = Math_fround(-f8);
  f5 = Math_fround(-f9);
  f4 = Math_fround(-f10);
  f12 = Math_fround(HEAPF32[i29 >> 2]);
  f11 = Math_fround(HEAPF32[i30 >> 2]);
  f3 = Math_fround(HEAPF32[i31 >> 2]);
  f16 = Math_fround(Math_fround(Math_fround(f12 * f6) + Math_fround(f11 * f5)) + Math_fround(f3 * f4));
  f13 = Math_fround(HEAPF32[i32 >> 2]);
  f14 = Math_fround(HEAPF32[i33 >> 2]);
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  i1 = f16 > Math_fround(Math_fround(Math_fround(f13 * f6) + Math_fround(f14 * f5)) + Math_fround(f15 * f4));
  f13 = i1 ? f12 : f13;
  f14 = i1 ? f11 : f14;
  f15 = i1 ? f3 : f15;
  __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i35, i34, i49);
  f3 = Math_fround(HEAPF32[i35 >> 2]);
  f11 = Math_fround(HEAPF32[i17 >> 2]);
  f3 = Math_fround(f13 - f3);
  f11 = Math_fround(f14 - f11);
  f12 = Math_fround(f15 - Math_fround(HEAPF32[i18 >> 2]));
  f16 = Math_fround(f2 - Math_fround(Math_fround(Math_fround(f8 * f3) + Math_fround(f11 * f9)) + Math_fround(f12 * f10)));
  i1 = HEAP32[i41 >> 2] | 0;
  HEAPF32[i42 + (i1 << 4) >> 2] = f13;
  HEAPF32[i42 + (i1 << 4) + 4 >> 2] = f14;
  HEAPF32[i42 + (i1 << 4) + 8 >> 2] = f15;
  HEAPF32[i42 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i51 = i43 + (i1 << 4) | 0;
  HEAP32[i51 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
  HEAP32[i51 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
  HEAPF32[i44 + (i1 << 4) >> 2] = f3;
  HEAPF32[i44 + (i1 << 4) + 4 >> 2] = f11;
  HEAPF32[i44 + (i1 << 4) + 8 >> 2] = f12;
  HEAPF32[i44 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  if (Math_fround(f2 * Math_fround(.000224999996)) > f16) {
   i7 = 3;
   break;
  }
  HEAP32[i41 >> 2] = i1 + 1;
  L4 : do switch (i1 | 0) {
  case 0:
   {
    HEAPF32[i36 >> 2] = f3;
    HEAPF32[i19 >> 2] = f11;
    HEAPF32[i20 >> 2] = f12;
    HEAPF32[i21 >> 2] = Math_fround(0.0);
    break;
   }
  case 1:
   {
    f3 = Math_fround(HEAPF32[i44 >> 2]);
    f11 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(HEAPF32[i23 >> 2]);
    f13 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f3);
    f14 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f11);
    f15 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f12);
    f16 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f15 * f15));
    if (!(f16 <= Math_fround(1.1920929e-07))) {
     f52 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f11 * f14)) - Math_fround(f3 * f13)) - Math_fround(f12 * f15)) / f16);
     i51 = f52 > Math_fround(1.0);
     f52 = i51 ? Math_fround(1.0) : f52;
     i51 = f52 > Math_fround(0.0);
     f52 = i51 ? f52 : Math_fround(0.0);
     f14 = Math_fround(f11 + Math_fround(f14 * f52));
     f16 = Math_fround(f12 + Math_fround(f15 * f52));
     HEAPF32[i36 >> 2] = Math_fround(f3 + Math_fround(f13 * f52));
     HEAPF32[i19 >> 2] = f14;
     HEAPF32[i20 >> 2] = f16;
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     break L4;
    } else {
     HEAP32[i41 >> 2] = 1;
     HEAP32[i36 >> 2] = HEAP32[i44 >> 2];
     HEAP32[i36 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
     HEAP32[i36 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
     HEAP32[i36 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
     break L4;
    }
   }
  case 2:
   {
    __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i36, i44, i42, i43, i41);
    break;
   }
  case 3:
   {
    __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i36, i44, i42, i43, i41);
    break;
   }
  default:
   {
    HEAPF32[i36 >> 2] = f3;
    HEAPF32[i19 >> 2] = f11;
    HEAPF32[i20 >> 2] = f12;
    HEAPF32[i21 >> 2] = Math_fround(0.0);
   }
  } while (0);
  HEAP32[i49 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i49 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
  HEAP32[i49 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
  HEAP32[i49 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
  f11 = Math_fround(HEAPF32[i49 >> 2]);
  f12 = Math_fround(HEAPF32[i37 >> 2]);
  f13 = Math_fround(HEAPF32[i38 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
  HEAP32[i39 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  i1 = f2 > f3;
  if (f3 > f28 & i1) {
   f8 = f11;
   f9 = f12;
   f10 = f13;
   f2 = f3;
  } else {
   i7 = 13;
   break;
  }
 }
 if ((i7 | 0) == 3) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i44, i42, i43, i49, i45, i46, i1);
  f15 = Math_fround(HEAPF32[i49 >> 2]);
  f28 = Math_fround(HEAPF32[i37 >> 2]);
  f52 = Math_fround(HEAPF32[i38 >> 2]);
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f28 * f28)) + Math_fround(f52 * f52)))));
  f28 = Math_fround(-Math_fround(f28 * f16));
  f52 = Math_fround(-Math_fround(f52 * f16));
  HEAPF32[i47 >> 2] = Math_fround(-Math_fround(f15 * f16));
  HEAPF32[i47 + 4 >> 2] = f28;
  HEAPF32[i47 + 8 >> 2] = f52;
  HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i48 >> 2] = f2;
  i51 = i48 + 4 | 0;
  HEAP32[i51 >> 2] = HEAP32[i39 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i39 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i39 + 8 >> 2];
  i51 = 0;
  STACKTOP = i50;
  return i51 | 0;
 } else if ((i7 | 0) == 13) {
  __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i44, i42, i43, i49, i45, i46, HEAP32[i41 >> 2] | 0);
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10)))));
  f28 = Math_fround(f16 * f5);
  f52 = Math_fround(f16 * f4);
  HEAPF32[i47 >> 2] = Math_fround(f16 * f6);
  HEAPF32[i47 + 4 >> 2] = f28;
  HEAPF32[i47 + 8 >> 2] = f52;
  HEAPF32[i47 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i48 >> 2] = i1 ? f3 : f2;
  i51 = i48 + 4 | 0;
  HEAP32[i51 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i51 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
  HEAP32[i51 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
  i51 = i1 ? 1 : 3;
  STACKTOP = i50;
  return i51 | 0;
 }
 return 0;
}

function __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 L1 : while (1) {
  i9 = i2;
  i10 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i11 = 5;
      break L1;
     }
    case 3:
     {
      i11 = 7;
      break L1;
     }
    case 4:
     {
      i11 = 8;
      break L1;
     }
    case 5:
     {
      i11 = 12;
      break L1;
     }
    case 1:
    case 0:
     {
      i11 = 56;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 56) {
     i11 = 14;
     break L1;
    }
    i6 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + (i3 << 3) | 0, i6, i6 + (i3 << 3) | 0, i10, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i1, i6, i10, i13) | 0;
    if (mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
     i4 = i10;
     break;
    } else i4 = i10;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (mftCall_iii(HEAP32[i13 >> 2] | 0, i4 | 0, i6 | 0) | 0) {
      i11 = 39;
      break L5;
     }
    }
    i3 = i1 + 8 | 0;
    if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i10 | 0) | 0)) {
     if ((i3 | 0) == (i10 | 0)) {
      i11 = 56;
      break L1;
     }
     while (1) {
      if (mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i3 | 0) | 0) break;
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i10 | 0)) {
       i11 = 56;
       break L1;
      }
     }
     i6 = HEAP32[i3 >> 2] | 0;
     i7 = HEAP32[i3 + 4 >> 2] | 0;
     i4 = i10;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i8 = i3;
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i8 + 4 >> 2] = i5;
     i8 = i10;
     HEAP32[i8 >> 2] = i6;
     HEAP32[i8 + 4 >> 2] = i7;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i10 | 0)) {
     i11 = 56;
     break L1;
    } else i4 = i10;
    while (1) {
     while (1) {
      i5 = i3 + 8 | 0;
      if (mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i3 | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -8 | 0; while (mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i4 | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i7 = HEAP32[i3 >> 2] | 0;
     i8 = HEAP32[i3 + 4 >> 2] | 0;
     i15 = i4;
     i6 = HEAP32[i15 + 4 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i3 + 4 >> 2] = i6;
     i3 = i4;
     HEAP32[i3 >> 2] = i7;
     HEAP32[i3 + 4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i11 | 0) == 39) {
    i11 = 0;
    i5 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i17 = i4;
    i16 = HEAP32[i17 + 4 >> 2] | 0;
    i15 = i1;
    HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i15 + 4 >> 2] = i16;
    i15 = i4;
    HEAP32[i15 >> 2] = i5;
    HEAP32[i15 + 4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i7 = i6;
    while (1) {
     while (1) {
      i6 = i5 + 8 | 0;
      if (mftCall_iii(HEAP32[i13 >> 2] | 0, i5 | 0, i7 | 0) | 0) i5 = i6; else break;
     }
     do i4 = i4 + -8 | 0; while (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i4 | 0, i7 | 0) | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i7;
      break L35;
     }
     i15 = HEAP32[i5 >> 2] | 0;
     i16 = HEAP32[i5 + 4 >> 2] | 0;
     i19 = i4;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i17 = i5;
     HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i17 + 4 >> 2] = i18;
     i17 = i4;
     HEAP32[i17 >> 2] = i15;
     HEAP32[i17 + 4 >> 2] = i16;
     i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
     i5 = i6;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i6; while (0);
   if ((i5 | 0) != (i4 | 0)) if (mftCall_iii(HEAP32[i13 >> 2] | 0, i4 | 0, i5 | 0) | 0) {
    i17 = HEAP32[i5 >> 2] | 0;
    i18 = HEAP32[i5 + 4 >> 2] | 0;
    i15 = i4;
    i16 = HEAP32[i15 + 4 >> 2] | 0;
    i19 = i5;
    HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i19 + 4 >> 2] = i16;
    i19 = i4;
    HEAP32[i19 >> 2] = i17;
    HEAP32[i19 + 4 >> 2] = i18;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRPFbRK8Vector2fS3_EPS1_EEbT0_S8_T_(i1, i5, i13) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRPFbRK8Vector2fS3_EPS1_EEbT0_S8_T_(i4, i2, i13) | 0) {
     i11 = 55;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i19 = i5;
   if ((i19 - i8 | 0) >= (i9 - i19 | 0)) {
    i11 = 54;
    break;
   }
   __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_(i1, i5, i13);
   i1 = i5 + 8 | 0;
  }
  if ((i11 | 0) == 54) {
   i11 = 0;
   __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_(i5 + 8 | 0, i2, i13);
   i2 = i5;
   continue;
  } else if ((i11 | 0) == 55) {
   i11 = 0;
   if (i3) {
    i11 = 56;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i11 | 0) == 5) {
  if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i10 | 0, i1 | 0) | 0)) {
   STACKTOP = i14;
   return;
  }
  i17 = HEAP32[i1 >> 2] | 0;
  i18 = HEAP32[i1 + 4 >> 2] | 0;
  i15 = i10;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i10;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  STACKTOP = i14;
  return;
 } else if ((i11 | 0) == 7) {
  __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i1, i1 + 8 | 0, i10, i13) | 0;
  STACKTOP = i14;
  return;
 } else if ((i11 | 0) == 8) {
  i2 = i1 + 8 | 0;
  i3 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i1, i2, i3, i13) | 0;
  if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i10 | 0, i3 | 0) | 0)) {
   STACKTOP = i14;
   return;
  }
  i17 = HEAP32[i3 >> 2] | 0;
  i18 = HEAP32[i1 + 20 >> 2] | 0;
  i15 = i10;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i3;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i10;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
   STACKTOP = i14;
   return;
  }
  i17 = HEAP32[i2 >> 2] | 0;
  i18 = HEAP32[i1 + 12 >> 2] | 0;
  i15 = i3;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i2;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i3;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i2 | 0, i1 | 0) | 0)) {
   STACKTOP = i14;
   return;
  }
  i17 = HEAP32[i1 >> 2] | 0;
  i18 = HEAP32[i1 + 4 >> 2] | 0;
  i15 = i2;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i19 + 4 >> 2] = i16;
  i19 = i2;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i19 + 4 >> 2] = i18;
  STACKTOP = i14;
  return;
 } else if ((i11 | 0) == 12) {
  __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i10, i13) | 0;
  STACKTOP = i14;
  return;
 } else if ((i11 | 0) == 14) {
  i3 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i1, i1 + 8 | 0, i3, i13) | 0;
  i4 = i1 + 24 | 0;
  if ((i4 | 0) == (i2 | 0)) {
   STACKTOP = i14;
   return;
  }
  i6 = i12 + 4 | 0;
  while (1) {
   if (mftCall_iii(HEAP32[i13 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i4 + 4 >> 2];
    i5 = i4;
    while (1) {
     i17 = i3;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = i5;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     if ((i3 | 0) == (i1 | 0)) break;
     i5 = i3 + -8 | 0;
     if (mftCall_iii(HEAP32[i13 >> 2] | 0, i12 | 0, i5 | 0) | 0) {
      i19 = i3;
      i3 = i5;
      i5 = i19;
     } else break;
    }
    i17 = i12;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i3;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
   }
   i3 = i4 + 8 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else {
    i19 = i4;
    i4 = i3;
    i3 = i19;
   }
  }
  STACKTOP = i14;
  return;
 } else if ((i11 | 0) == 56) {
  STACKTOP = i14;
  return;
 }
}

function __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_(i21, i22, i23, i6) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, f25 = f0, f26 = f0, i27 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i24 + 128 | 0;
 i12 = i24 + 52 | 0;
 i19 = i24;
 if (!i22) {
  i1 = HEAP32[i21 + 76 >> 2] | 0;
  switch (i1 | 0) {
  case 1:
   break;
  case 0:
   {
    i1 = 0;
    break;
   }
  case 3:
   break;
  default:
   i1 = 2;
  }
  HEAP32[i23 + 172 >> 2] = i1;
  i2 = i23 + 4 | 0;
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAP32[i23 >> 2] = 0;
  i3 = i23 + 80 | 0;
  HEAPF32[i3 >> 2] = Math_fround(inf);
  i4 = i23 + 76 | 0;
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i21 + 80 >> 2] | 0;
  switch (i1 | 0) {
  case 1:
   break;
  case 0:
   {
    i1 = 0;
    break;
   }
  case 3:
   break;
  default:
   i1 = 2;
  }
  HEAP32[i23 + 176 >> 2] = i1;
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAP32[i23 >> 2] = 0;
  HEAPF32[i3 >> 2] = Math_fround(inf);
  HEAP32[i4 >> 2] = 0;
 }
 i11 = i23 + 164 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i21 + 68 >> 2] | 0;
  i1 = i23 + 152 | 0;
  HEAP32[i11 >> 2] = i2;
  i3 = i23 + 168 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
   if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 * 52 | 0, 4, i23 + 156 | 0, 0, gb + 1047584 | 0, 464) | 0;
   } else {
    i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 52 | 0, 4, i23 + 156 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i20 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 52 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 >> 2] = i20;
   }
   i2 = HEAP32[i11 >> 2] | 0;
  }
  if ((i2 | 0) > 0) {
   i3 = i21 + 56 | 0;
   i4 = i23 + 152 | 0;
   i1 = 0;
   do {
    i19 = HEAP32[i3 >> 2] | 0;
    i20 = HEAP32[i4 >> 2] | 0;
    HEAP32[i20 + (i1 * 52 | 0) >> 2] = HEAP32[i19 + (i1 << 4) >> 2];
    i17 = i20 + (i1 * 52 | 0) + 4 | 0;
    HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i18 = i20 + (i1 * 52 | 0) + 20 | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 + 12 >> 2] = 0;
    i20 = i20 + (i1 * 52 | 0) + 36 | 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP32[i20 + 8 >> 2] = 0;
    HEAP32[i20 + 12 >> 2] = 0;
    HEAP32[i17 + (i22 << 2) >> 2] = HEAP32[i19 + (i1 << 4) + 4 >> 2];
    HEAP32[i18 + (i22 << 2) >> 2] = HEAP32[i19 + (i1 << 4) + 8 >> 2];
    HEAP32[i20 + (i22 << 2) >> 2] = HEAP32[i19 + (i1 << 4) + 12 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAPF32[i23 + 4 >> 2] = Math_fround(inf);
  HEAP32[i23 >> 2] = 0;
  HEAPF32[i23 + 80 >> 2] = Math_fround(inf);
  HEAP32[i23 + 76 >> 2] = 0;
  HEAP32[i23 + 180 >> 2] = HEAP32[i21 + 84 >> 2];
  STACKTOP = i24;
  return;
 }
 i16 = i18 + 4 | 0;
 HEAPF32[i16 >> 2] = Math_fround(inf);
 HEAP32[i18 >> 2] = 0;
 i7 = i18 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i7 = i12 + 4 | 0;
 HEAPF32[i7 >> 2] = Math_fround(inf);
 HEAP32[i12 >> 2] = 0;
 i3 = i12 + 8 | 0;
 i2 = i3 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i17 = i21 + 68 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 if ((i8 | 0) > 0) {
  i9 = i21 + 56 | 0;
  i10 = i23 + 152 | 0;
  i6 = 0;
  do {
   i4 = (HEAP32[i9 >> 2] | 0) + (i6 << 4) | 0;
   if (!i1) {
    i1 = HEAP32[i10 >> 2] | 0;
    i20 = 32;
   } else {
    i2 = HEAP32[i10 >> 2] | 0;
    if ((HEAP32[i2 >> 2] & 2139095040 | 0) == 2139095040) {
     i1 = i2;
     i20 = 32;
    } else if ((i1 | 0) > 1 ? (HEAP32[i2 + ((i1 + -1 | 0) * 52 | 0) >> 2] & 2139095040 | 0) != 2139095040 : 0) {
     i2 = __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexERKNS1_5CacheEf(i23, i12, Math_fround(HEAPF32[i4 >> 2])) | 0;
     i14 = HEAP32[i10 >> 2] | 0;
     i1 = i14 + (i2 * 52 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     i15 = HEAP32[i1 >> 2] | 0;
     HEAP32[i7 >> 2] = i15;
     i2 = i14 + ((i2 + 1 | 0) * 52 | 0) | 0;
     f5 = Math_fround(HEAPF32[i4 >> 2]);
     f25 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i15 = f25 < Math_fround(0.0);
     f26 = Math_fround(-f25);
     if (!((i15 ? f26 : f25) <= Math_fround(1.99999999e-06))) {
      f26 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
      i15 = f26 < Math_fround(0.0);
      f25 = Math_fround(-f26);
      if (!((i15 ? f25 : f26) <= Math_fround(1.99999999e-06))) {
       __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f(i19, i1, i2, f5);
       __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E(i23, i19) | 0;
       HEAPF32[i7 >> 2] = Math_fround(inf);
       HEAP32[i12 >> 2] = 0;
      }
     }
    } else {
     i1 = i2;
     i20 = 32;
    }
   }
   if ((i20 | 0) == 32) {
    i20 = 0;
    i3 = i19;
    i2 = i3 + 52 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     i3 = i3 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i3 | 0) < (i2 | 0));
    HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
    __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E(i23, i19) | 0;
    HEAPF32[i7 >> 2] = Math_fround(inf);
    HEAP32[i12 >> 2] = 0;
   }
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } while ((i6 | 0) != (i8 | 0));
 }
 if ((i1 | 0) > 0) {
  i14 = i23 + 152 | 0;
  i15 = i21 + 56 | 0;
  i11 = i19 + 4 | 0;
  i12 = i19 + 8 | 0;
  i10 = i19 + 12 | 0;
  i9 = 0;
  do {
   i13 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   do if (!i2) {
    f5 = Math_fround(0.0);
    i20 = 45;
   } else {
    i3 = HEAP32[i15 >> 2] | 0;
    if ((HEAP32[i3 >> 2] & 2139095040 | 0) != 2139095040) if ((i2 | 0) > 1 ? (HEAP32[i3 + (i2 + -1 << 4) >> 2] & 2139095040 | 0) != 2139095040 : 0) {
     i27 = i13 + (i9 * 52 | 0) | 0;
     i6 = __ZNK17AnimationCurveTplIfE9FindIndexERKNS0_5CacheEf(i21, i18, Math_fround(HEAPF32[i27 >> 2])) | 0;
     i7 = HEAP32[i15 >> 2] | 0;
     i2 = i7 + (i6 << 4) | 0;
     HEAP32[i18 >> 2] = i6;
     i4 = HEAP32[i2 >> 2] | 0;
     HEAP32[i16 >> 2] = i4;
     i8 = i6 + 1 | 0;
     i3 = i7 + (i8 << 4) | 0;
     f5 = Math_fround(HEAPF32[i27 >> 2]);
     f26 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     i4 = f26 < Math_fround(0.0);
     f25 = Math_fround(-f26);
     if ((i4 ? f25 : f26) <= Math_fround(1.99999999e-06)) {
      i4 = HEAP32[i7 + (i6 << 4) + 12 >> 2] | 0;
      i3 = HEAP32[i7 + (i6 << 4) + 4 >> 2] | 0;
      i2 = HEAP32[i7 + (i6 << 4) + 8 >> 2] | 0;
      break;
     }
     f26 = Math_fround(f5 - Math_fround(HEAPF32[i3 >> 2]));
     i27 = f26 < Math_fround(0.0);
     f25 = Math_fround(-f26);
     if (!((i27 ? f25 : f26) <= Math_fround(1.99999999e-06))) {
      __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f(i19, i2, i3, f5);
      i4 = HEAP32[i10 >> 2] | 0;
      i3 = HEAP32[i11 >> 2] | 0;
      i2 = HEAP32[i12 >> 2] | 0;
      break;
     } else {
      i4 = HEAP32[i7 + (i8 << 4) + 12 >> 2] | 0;
      i3 = HEAP32[i7 + (i8 << 4) + 4 >> 2] | 0;
      i2 = HEAP32[i7 + (i8 << 4) + 8 >> 2] | 0;
      break;
     }
    }
    if ((i2 | 0) == 1) {
     f5 = Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2]);
     i20 = 45;
    } else {
     f5 = Math_fround(0.0);
     i20 = 45;
    }
   } while (0);
   if ((i20 | 0) == 45) {
    i20 = 0;
    i4 = 0;
    i3 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = 0;
   }
   HEAP32[i13 + (i9 * 52 | 0) + 4 + (i22 << 2) >> 2] = i3;
   HEAP32[i13 + (i9 * 52 | 0) + 20 + (i22 << 2) >> 2] = i2;
   HEAP32[i13 + (i9 * 52 | 0) + 36 + (i22 << 2) >> 2] = i4;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i1 | 0));
 }
 HEAPF32[i23 + 4 >> 2] = Math_fround(inf);
 HEAP32[i23 >> 2] = 0;
 HEAPF32[i23 + 80 >> 2] = Math_fround(inf);
 HEAP32[i23 + 76 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i9, i10, i8, i7, i3, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f4 = f0, f5 = f0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_(i9, i10, i8, i7, i11) | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = i7 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f15 = Math_fround(f4 - f5);
  f15 = Math_fround(f15 * f15);
  if (f15 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break; else i1 = i13;
   STACKTOP = i14;
   return i1 | 0;
  } else {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0;
   f18 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 8 >> 2]);
   i2 = HEAP32[i7 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 8 >> 2]);
   f4 = Math_fround(HEAPF32[i11 >> 2]);
   f18 = Math_fround(f18 - f4);
   f5 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f17 = Math_fround(f17 - f5);
   f15 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f16 = Math_fround(f16 - f15);
   f4 = Math_fround(f21 - f4);
   f5 = Math_fround(f20 - f5);
   f15 = Math_fround(f19 - f15);
   if (Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f16 * f16)) < Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f15 * f15))) break; else i1 = i13;
   STACKTOP = i14;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i1 | 0)) {
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 i1 = i13 + 1 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i6 = i8 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) {
  f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f21 = Math_fround(f4 - f5);
  f21 = Math_fround(f21 * f21);
  if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break;
   STACKTOP = i14;
   return i1 | 0;
  } else {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0;
   f16 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 8 >> 2]);
   i3 = HEAP32[i8 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i11 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f17 = Math_fround(f17 - f20);
   f21 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f18 = Math_fround(f18 - f21);
   f19 = Math_fround(f4 - f19);
   f20 = Math_fround(f5 - f20);
   f21 = Math_fround(f15 - f21);
   if (Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))) break;
   STACKTOP = i14;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 i1 = i13 + 2 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) {
  f4 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f21 = Math_fround(f4 - f5);
  f21 = Math_fround(f21 * f21);
  if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break;
   STACKTOP = i14;
   return i1 | 0;
  } else {
   i7 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0;
   f16 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) + 8 >> 2]);
   i7 = HEAP32[i10 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i3 + (i7 * 24 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i11 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f17 = Math_fround(f17 - f20);
   f21 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f18 = Math_fround(f18 - f21);
   f19 = Math_fround(f4 - f19);
   f20 = Math_fround(f5 - f20);
   f21 = Math_fround(f15 - f21);
   if (Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))) break;
   STACKTOP = i14;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 i1 = i13 + 3 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 + 8 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) {
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f21 = Math_fround(f4 - f5);
  f21 = Math_fround(f21 * f21);
  if (f21 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break;
   STACKTOP = i14;
   return i1 | 0;
  } else {
   i8 = HEAP32[i10 >> 2] | 0;
   i7 = HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0;
   f16 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 8 >> 2]);
   i8 = HEAP32[i9 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i11 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f17 = Math_fround(f17 - f20);
   f21 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f18 = Math_fround(f18 - f21);
   f19 = Math_fround(f4 - f19);
   f20 = Math_fround(f5 - f20);
   f21 = Math_fround(f15 - f21);
   if (Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)) < Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21))) break;
   STACKTOP = i14;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 i13 = i13 + 4 | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN23ArchiveStorageConverter24ReadHeaderFromMemoryFileEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 3312 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 2244 | 0;
 i14 = i18 + 80 | 0;
 i17 = i18 + 1184 | 0;
 i11 = i18;
 i8 = i18 + 1152 | 0;
 i12 = i16 + 32 | 0;
 i1 = i12;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i15 = i16 + 24 | 0;
 if ((i2 | 0) == 0 & (i1 | 0) == 0) {
  i9 = HEAP32[i15 >> 2] | 0;
  i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 44 >> 2] | 0, i9 | 0) | 0;
  i7 = getTempRet0() | 0;
  if (!(i7 >>> 0 < 0 | (i7 | 0) == 0 & i9 >>> 0 < 13)) {
   i9 = HEAP32[i15 >> 2] | 0;
   if (!(mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, 0, 0, 1) | 0)) {
    i17 = -1;
    STACKTOP = i18;
    return i17 | 0;
   }
   i5 = gb + 64016 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   i9 = i14;
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 + 4 >> 2] = i6;
   i9 = i13 + 1040 | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   i9 = __ZnwjRK10MemLabelIdiPKci(20, i14, 16, gb + 586372 | 0, 37) | 0;
   i6 = i14;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = gb + 70720 + 8;
   HEAP32[i9 + 4 >> 2] = i7;
   i7 = i9 + 8 | 0;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP8[i9 + 16 >> 0] = 0;
   HEAP32[i13 + 1044 >> 2] = i9;
   __ZN15FileSystemEntryC2ERK13FileEntryData(i17, i13);
   __ZN13FileEntryDataD2Ev(i13);
   __ZN12FileAccessorC2Ev(i14);
   if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i14, i17, 0, 0) | 0) {
    __ZN20ArchiveStorageHeader6HeaderC2Ev(i11);
    L10 : do if (!(__ZN20ArchiveStorageHeader19ReadHeaderSignatureER12FileAccessorRNS_6HeaderE(i14, i11) | 0)) {
     i7 = i11 + 11 | 0;
     i6 = HEAP8[i7 >> 0] | 0;
     i1 = i6 << 24 >> 24 < 0;
     i9 = i11 + 4 | 0;
     do if (((i1 ? HEAP32[i9 >> 2] | 0 : i6 & 255) | 0) == 8) {
      i1 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
      if (_memcmp(i1, gb + 489810 | 0, 8) | 0) if (_memcmp(i1, gb + 489801 | 0, 8) | 0) {
       i10 = 18;
       break;
      }
      i2 = i8 + 16 | 0;
      HEAP32[i2 >> 2] = 0;
      i6 = i8 + 20 | 0;
      HEAP32[i6 >> 2] = 0;
      HEAP32[i8 + 24 >> 2] = 0;
      HEAP32[i8 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
      i5 = HEAP8[i7 >> 0] | 0;
      i1 = i5 << 24 >> 24 < 0;
      do if (((i1 ? HEAP32[i9 >> 2] | 0 : i5 & 255) | 0) == 8) {
       i1 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
       if (_memcmp(i1, gb + 489810 | 0, 8) | 0) if (_memcmp(i1, gb + 489801 | 0, 8) | 0) {
        i1 = -1;
        break;
       }
       i1 = __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE(i14, i11, i8) | 0;
      } else i1 = -1; while (0);
      i5 = (i1 | 0) == 0;
      i2 = HEAP32[i2 >> 2] | 0;
      i3 = i2;
      if (i2 | 0) {
       i4 = HEAP32[i6 >> 2] | 0;
       if ((i4 | 0) != (i2 | 0)) HEAP32[i6 >> 2] = i4 + (~(((i4 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
       i8 = HEAP32[i8 + 28 >> 2] | 0;
       HEAP32[i13 >> 2] = 54;
       HEAP32[i13 + 4 >> 2] = i8;
       __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
      }
      if (!i5) {
       i2 = 1;
       break L10;
      }
     } else i10 = 18; while (0);
     if ((i10 | 0) == 18) {
      i1 = __ZN20ArchiveStorageHeader10ReadHeaderER12FileAccessorRNS_6HeaderE(i14, i11) | 0;
      if (i1 | 0) {
       i2 = 1;
       break;
      }
     }
     if (!(HEAP32[i11 + 72 >> 2] & 128)) i10 = 21; else {
      i8 = i11 + 56 | 0;
      if ((HEAP32[i8 >> 2] | 0) == 0 & (HEAP32[i8 + 4 >> 2] | 0) == 0) {
       i1 = 0;
       i2 = 0;
      } else i10 = 21;
     }
     L34 : do if ((i10 | 0) == 21) {
      i10 = HEAP8[i7 >> 0] | 0;
      i1 = i10 << 24 >> 24 < 0;
      do if (((i1 ? HEAP32[i9 >> 2] | 0 : i10 & 255) | 0) == 8) {
       i1 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
       if (_memcmp(i1, gb + 489810 | 0, 8) | 0) if (_memcmp(i1, gb + 489801 | 0, 8) | 0) break;
       i1 = HEAP32[i11 + 64 >> 2] | 0;
       i2 = 0;
       break L34;
      } while (0);
      i2 = __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE(i11) | 0;
      i1 = getTempRet0() | 0;
      i1 = _i64Add(HEAP32[i11 + 64 >> 2] | 0, 0, i2 | 0, i1 | 0) | 0;
      i2 = getTempRet0() | 0;
     } while (0);
     i10 = i12;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i10 + 4 >> 2] = i2;
     i2 = 0;
     i1 = 0;
    } else {
     i2 = 1;
     i1 = -1;
    } while (0);
    i3 = i11 + 36 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i10 = HEAP32[i3 >> 2] | 0;
     i9 = HEAP32[i11 + 48 >> 2] | 0;
     HEAP32[i13 >> 2] = 54;
     HEAP32[i13 + 4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i10, i13);
    }
    i3 = i11 + 20 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i10 = HEAP32[i3 >> 2] | 0;
     i9 = HEAP32[i11 + 32 >> 2] | 0;
     HEAP32[i13 >> 2] = 54;
     HEAP32[i13 + 4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i10, i13);
    }
    if ((HEAP8[i11 + 11 >> 0] | 0) < 0) {
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 12 >> 2] | 0;
     HEAP32[i13 >> 2] = 54;
     HEAP32[i13 + 4 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i10, i13);
    }
   } else {
    i2 = 1;
    i1 = -1;
   }
   __ZN12FileAccessorD2Ev(i14);
   __ZN13FileEntryDataD2Ev(i17);
   if (i2 | 0) {
    i17 = i1;
    STACKTOP = i18;
    return i17 | 0;
   }
  }
  i1 = i12;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i2 | 0) == 0 & (i1 | 0) == 0) {
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 i12 = HEAP32[i15 >> 2] | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0) | 0;
 i11 = getTempRet0() | 0;
 if (i1 >>> 0 > i11 >>> 0 | (i1 | 0) == (i11 | 0) & i2 >>> 0 > i12 >>> 0) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i11 = HEAP32[i15 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0, i11 | 0, 0, 0, 1) | 0;
 i11 = __ZnwjRK10MemLabelIdiPKci(2416, gb + 63552 | 0, 16, gb + 490147 | 0, 425) | 0;
 __ZN20ArchiveStorageReaderC2Ev(i11);
 i3 = i16 + 28 | 0;
 HEAP32[i3 >> 2] = i11;
 i11 = gb + 63552 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = i13 + 1040 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(20, i14, 16, gb + 586372 | 0, 37) | 0;
 i12 = i14;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 70720 + 8;
 HEAP32[i1 + 4 >> 2] = i10;
 i14 = i1 + 8 | 0;
 HEAP32[i14 >> 2] = i11;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i13 + 1044 >> 2] = i1;
 __ZN15FileSystemEntryC2ERK13FileEntryData(i17, i13);
 __ZN13FileEntryDataD2Ev(i13);
 i1 = __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy(HEAP32[i3 >> 2] | 0, i17, 0, 0) | 0;
 if (!i1) {
  i15 = HEAP32[i15 >> 2] | 0;
  i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = i16 + 16 | 0;
  HEAP32[i1 >> 2] = i15;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = i16 + 40 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i1 + 148 >> 2] | 0;
  if (!i2) {
   i1 = 0;
   i2 = 0;
  } else {
   i2 = (HEAP32[i1 + 136 >> 2] | 0) + (i2 + -1 << 3) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
  i15 = i16 + 48 | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 4 >> 2] = i2;
  HEAP8[i16 + 56 >> 0] = 1;
  i1 = 0;
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  i16 = i2 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 __ZN13FileEntryDataD2Ev(i17);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZNSt3__211__sift_downIRN22MotionVectorRenderLoop18RenderObjectSorterEP18RPDataMotionVectorEEvT0_S6_T_NS_15iterator_traitsIS6_E15difference_typeES6_(i20, i1, i15, i21, i16) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i21 = i21 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 192 | 0;
 i23 = i24;
 i1 = (i16 - i20 | 0) / 212 | 0;
 if ((i21 | 0) < 2) {
  STACKTOP = i24;
  return;
 }
 i19 = (i21 + -2 | 0) / 2 | 0;
 if ((i19 | 0) < (i1 | 0)) {
  STACKTOP = i24;
  return;
 }
 i3 = i1 << 1 | 1;
 i12 = i20 + (i3 * 212 | 0) | 0;
 i14 = i3 + 1 | 0;
 if ((i14 | 0) < (i21 | 0)) {
  i13 = i12 + 212 | 0;
  i9 = HEAP32[i15 >> 2] | 0;
  i10 = HEAP32[i20 + (i3 * 212 | 0) + 16 >> 2] | 0;
  i4 = HEAP32[i9 + 12 >> 2] | 0;
  i11 = HEAP32[i13 + 16 >> 2] | 0;
  i5 = HEAP32[i4 + (i10 << 5) + 8 >> 2] | 0;
  i9 = HEAP32[HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
  i8 = HEAP32[i4 + (i11 << 5) + 8 >> 2] | 0;
  i1 = HEAP32[i9 + (i5 * 360 | 0) + 184 >> 2] | 0;
  i2 = HEAP32[i9 + (i8 * 360 | 0) + 184 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i1 = HEAP16[i4 + (i10 << 5) + 12 >> 1] | 0;
   i2 = HEAP16[i4 + (i11 << 5) + 12 >> 1] | 0;
   if (i1 << 16 >> 16 != i2 << 16 >> 16) {
    i1 = i1 << 16 >> 16 < i2 << 16 >> 16;
    break;
   }
   f6 = Math_fround(HEAPF32[i4 + (i10 << 5) + 20 >> 2]);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
   f7 = Math_fround(HEAPF32[i4 + (i11 << 5) + 20 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
   if ((i1 | 0) != (i2 | 0)) {
    i1 = i1 >>> 0 < i2 >>> 0;
    break;
   }
   i1 = HEAP32[i4 + (i10 << 5) + 28 >> 2] | 0;
   i2 = HEAP32[i4 + (i11 << 5) + 28 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i1 = i1 >>> 0 > i2 >>> 0;
    break;
   }
   if (f6 != f7) {
    i1 = f6 > f7;
    break;
   }
   i2 = HEAP16[i9 + (i5 * 360 | 0) + 270 >> 1] | 0;
   i1 = HEAP16[i9 + (i8 * 360 | 0) + 270 >> 1] | 0;
   if (i2 << 16 >> 16 == i1 << 16 >> 16) {
    i1 = (i10 | 0) < (i11 | 0);
    break;
   } else {
    i1 = (i2 & 65535) > (i1 & 65535);
    break;
   }
  } else i1 = i1 >>> 0 < i2 >>> 0; while (0);
  i12 = i1 ? i13 : i12;
  i3 = i1 ? i14 : i3;
  i17 = i15;
 } else {
  i9 = HEAP32[i15 >> 2] | 0;
  i17 = i15;
  i4 = HEAP32[i9 + 12 >> 2] | 0;
  i9 = HEAP32[HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
 }
 i10 = HEAP32[i12 + 16 >> 2] | 0;
 i18 = HEAP32[i16 + 16 >> 2] | 0;
 i5 = HEAP32[i4 + (i10 << 5) + 8 >> 2] | 0;
 i8 = HEAP32[i4 + (i18 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i9 + (i5 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i9 + (i8 * 360 | 0) + 184 >> 2] | 0;
 do if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP16[i4 + (i10 << 5) + 12 >> 1] | 0;
  i2 = HEAP16[i4 + (i18 << 5) + 12 >> 1] | 0;
  if (i1 << 16 >> 16 != i2 << 16 >> 16) {
   if (i1 << 16 >> 16 >= i2 << 16 >> 16) break;
   STACKTOP = i24;
   return;
  }
  f6 = Math_fround(HEAPF32[i4 + (i10 << 5) + 20 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  f7 = Math_fround(HEAPF32[i4 + (i18 << 5) + 20 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  if ((i2 | 0) != (i1 | 0)) {
   if (i2 >>> 0 >= i1 >>> 0) break;
   STACKTOP = i24;
   return;
  }
  i2 = HEAP32[i4 + (i10 << 5) + 28 >> 2] | 0;
  i1 = HEAP32[i4 + (i18 << 5) + 28 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   if (i2 >>> 0 <= i1 >>> 0) break;
   STACKTOP = i24;
   return;
  }
  if (f6 != f7) {
   if (!(f6 > f7)) break;
   STACKTOP = i24;
   return;
  }
  i2 = HEAP16[i9 + (i5 * 360 | 0) + 270 >> 1] | 0;
  i1 = HEAP16[i9 + (i8 * 360 | 0) + 270 >> 1] | 0;
  if (i2 << 16 >> 16 == i1 << 16 >> 16) {
   if ((i10 | 0) >= (i18 | 0)) break;
   STACKTOP = i24;
   return;
  } else {
   if ((i2 & 65535) <= (i1 & 65535)) break;
   STACKTOP = i24;
   return;
  }
 } else if (i1 >>> 0 < i2 >>> 0) {
  STACKTOP = i24;
  return;
 } while (0);
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 _memcpy(i23 | 0, i16 + 20 | 0, 192) | 0;
 _memcpy(i16 | 0, i12 | 0, 212) | 0;
 L56 : do if ((i19 | 0) < (i3 | 0)) {
  i2 = i12;
  i1 = i12;
 } else {
  i2 = i12;
  i1 = i12;
  while (1) {
   i3 = i3 << 1 | 1;
   i14 = i20 + (i3 * 212 | 0) | 0;
   i16 = i3 + 1 | 0;
   if ((i16 | 0) < (i21 | 0)) {
    i15 = i14 + 212 | 0;
    i11 = HEAP32[i17 >> 2] | 0;
    i12 = HEAP32[i20 + (i3 * 212 | 0) + 16 >> 2] | 0;
    i8 = HEAP32[i11 + 12 >> 2] | 0;
    i13 = HEAP32[i15 + 16 >> 2] | 0;
    i9 = HEAP32[i8 + (i12 << 5) + 8 >> 2] | 0;
    i11 = HEAP32[HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
    i10 = HEAP32[i8 + (i13 << 5) + 8 >> 2] | 0;
    i4 = HEAP32[i11 + (i9 * 360 | 0) + 184 >> 2] | 0;
    i5 = HEAP32[i11 + (i10 * 360 | 0) + 184 >> 2] | 0;
    do if ((i4 | 0) == (i5 | 0)) {
     i4 = HEAP16[i8 + (i12 << 5) + 12 >> 1] | 0;
     i5 = HEAP16[i8 + (i13 << 5) + 12 >> 1] | 0;
     if (i4 << 16 >> 16 != i5 << 16 >> 16) {
      i4 = i4 << 16 >> 16 < i5 << 16 >> 16;
      break;
     }
     f6 = Math_fround(HEAPF32[i8 + (i12 << 5) + 20 >> 2]);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
     f7 = Math_fround(HEAPF32[i8 + (i13 << 5) + 20 >> 2]);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
     if ((i4 | 0) != (i5 | 0)) {
      i4 = i4 >>> 0 < i5 >>> 0;
      break;
     }
     i4 = HEAP32[i8 + (i12 << 5) + 28 >> 2] | 0;
     i5 = HEAP32[i8 + (i13 << 5) + 28 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      i4 = i4 >>> 0 > i5 >>> 0;
      break;
     }
     if (f6 != f7) {
      i4 = f6 > f7;
      break;
     }
     i5 = HEAP16[i11 + (i9 * 360 | 0) + 270 >> 1] | 0;
     i4 = HEAP16[i11 + (i10 * 360 | 0) + 270 >> 1] | 0;
     if (i5 << 16 >> 16 == i4 << 16 >> 16) {
      i4 = (i12 | 0) < (i13 | 0);
      break;
     } else {
      i4 = (i5 & 65535) > (i4 & 65535);
      break;
     }
    } else i4 = i4 >>> 0 < i5 >>> 0; while (0);
    i14 = i4 ? i15 : i14;
    i3 = i4 ? i16 : i3;
   } else {
    i11 = HEAP32[i17 >> 2] | 0;
    i8 = HEAP32[i11 + 12 >> 2] | 0;
    i11 = HEAP32[HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
   }
   i12 = HEAP32[i14 + 16 >> 2] | 0;
   i9 = HEAP32[i8 + (i12 << 5) + 8 >> 2] | 0;
   i10 = HEAP32[i8 + (i18 << 5) + 8 >> 2] | 0;
   i4 = HEAP32[i11 + (i9 * 360 | 0) + 184 >> 2] | 0;
   i5 = HEAP32[i11 + (i10 * 360 | 0) + 184 >> 2] | 0;
   do if ((i4 | 0) == (i5 | 0)) {
    i4 = HEAP16[i8 + (i12 << 5) + 12 >> 1] | 0;
    i5 = HEAP16[i8 + (i18 << 5) + 12 >> 1] | 0;
    if (i4 << 16 >> 16 != i5 << 16 >> 16) if (i4 << 16 >> 16 < i5 << 16 >> 16) break L56; else break;
    f6 = Math_fround(HEAPF32[i8 + (i12 << 5) + 20 >> 2]);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    f7 = Math_fround(HEAPF32[i8 + (i18 << 5) + 20 >> 2]);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    if ((i4 | 0) != (i5 | 0)) if (i4 >>> 0 < i5 >>> 0) break L56; else break;
    i5 = HEAP32[i8 + (i12 << 5) + 28 >> 2] | 0;
    i4 = HEAP32[i8 + (i18 << 5) + 28 >> 2] | 0;
    if ((i5 | 0) != (i4 | 0)) if (i5 >>> 0 > i4 >>> 0) break L56; else break;
    if (f6 != f7) if (f6 > f7) break L56; else break;
    i5 = HEAP16[i11 + (i9 * 360 | 0) + 270 >> 1] | 0;
    i4 = HEAP16[i11 + (i10 * 360 | 0) + 270 >> 1] | 0;
    if (i5 << 16 >> 16 == i4 << 16 >> 16) if ((i12 | 0) < (i18 | 0)) break L56; else break; else if ((i5 & 65535) > (i4 & 65535)) break L56; else break;
   } else if (i4 >>> 0 < i5 >>> 0) break L56; while (0);
   _memcpy(i2 | 0, i14 | 0, 212) | 0;
   if ((i19 | 0) < (i3 | 0)) {
    i2 = i14;
    i1 = i14;
    break;
   } else {
    i2 = i14;
    i1 = i14;
   }
  }
 } while (0);
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = i18;
 _memcpy(i2 + 20 | 0, i23 | 0, 192) | 0;
 STACKTOP = i24;
 return;
}

function __ZN26AnimatorOverrideController30PerformOverrideClipListCleanupEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20;
 i9 = i20 + 28 | 0;
 i15 = i20 + 8 | 0;
 i11 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i12) | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i15 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i15 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i10 = i8;
 i14 = HEAP32[i10 + 4 >> 2] | 0;
 i13 = i18;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i12 + 84 | 0;
 i14 = i12 + 96 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i10 = i11 + 12 | 0;
  i7 = HEAP32[i13 >> 2] | 0;
  do {
   i1 = HEAP32[i7 >> 2] | 0;
   do if (!i1) i19 = 22; else {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i19 = 9; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i2 = HEAP32[i8 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i19 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i19 = 11;
    }
    if ((i19 | 0) == 9) i19 = 11;
    if ((i19 | 0) == 11) {
     i19 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
      i19 = 22;
      break;
     }
    }
    i5 = i7 + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (!i1) i19 = 22; else {
     HEAP32[i9 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i19 = 18; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i4 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
       i4 = HEAP32[i8 >> 2] | 0;
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
       i1 = i3;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i19 = 18; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i19 = 20; else i2 = i1;
     }
     if ((i19 | 0) == 18) i19 = 20;
     if ((i19 | 0) == 20) {
      i19 = 0;
      if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
       i19 = 22;
       break;
      }
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
     }
     i1 = HEAP32[i11 >> 2] | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i6 = i1 + (i5 << 2) | 0;
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     if (!i2) i19 = 33; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
       i3 = HEAP32[i8 >> 2] | 0;
       i21 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i21 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i21 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i19 = 33; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i19 = 35;
      }
     }
     if ((i19 | 0) == 33) i19 = 35;
     if ((i19 | 0) == 35) {
      i19 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
     }
     HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
     L45 : do if (i5) while (1) {
      if (__ZN8FindClipclERK4PPtrI13AnimationClipE(i8, i1) | 0) break L45;
      i1 = i1 + 4 | 0;
      if ((i1 | 0) == (i6 | 0)) {
       i1 = i6;
       break;
      }
     } while (0);
     if ((i1 | 0) == ((HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] << 2) | 0)) {
      i2 = HEAP32[i16 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i17 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i17 >> 2] = i1;
        HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 3, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i21 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
        HEAP32[i17 >> 2] = i1;
        HEAP32[i15 >> 2] = i21;
        break;
       }
      } while (0);
      HEAP32[i16 >> 2] = i3;
      i5 = i7;
      i6 = HEAP32[i5 + 4 >> 2] | 0;
      i21 = (HEAP32[i15 >> 2] | 0) + (i2 << 3) | 0;
      HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i21 + 4 >> 2] = i6;
     }
    }
   } while (0);
   if ((i19 | 0) == 22) {
    i19 = 0;
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i17 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 3, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i21 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
      HEAP32[i17 >> 2] = i1;
      HEAP32[i15 >> 2] = i21;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i3;
    i5 = i7;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i21 = (HEAP32[i15 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i21 + 4 >> 2] = i6;
   }
   i7 = i7 + 8 | 0;
   i1 = HEAP32[i14 >> 2] | 0;
  } while ((i7 | 0) != ((HEAP32[i13 >> 2] | 0) + (i1 << 3) | 0));
  i3 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  if (i2 | 0) {
   i7 = i3;
   i6 = i3;
   while (1) {
    i3 = HEAP32[i13 >> 2] | 0;
    i5 = i3 + (i1 << 3) | 0;
    L71 : do if (!i1) i19 = 52; else {
     i4 = HEAP32[i7 >> 2] | 0;
     while (1) {
      if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) {
       i19 = 52;
       break L71;
      }
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i5 | 0)) {
       i3 = i6;
       break;
      }
     }
    } while (0);
    if ((i19 | 0) == 52) {
     i19 = 0;
     if ((i3 | 0) == (i5 | 0)) i3 = i6; else {
      i1 = i3 + 8 | 0;
      _memmove(i3 | 0, i1 | 0, i5 - i1 | 0) | 0;
      i1 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
      HEAP32[i14 >> 2] = i1;
      i3 = HEAP32[i15 >> 2] | 0;
      i2 = HEAP32[i16 >> 2] | 0;
     }
    }
    i7 = i7 + 8 | 0;
    if ((i7 | 0) == (i3 + (i2 << 3) | 0)) break; else i6 = i3;
   }
   if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 136 >> 2] | 0, i12 | 0);
  }
 }
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i12, gb + 1105796 | 0);
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i18);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZN15NavMeshObstacle8TransferI14SafeBinaryReadEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 16 | 0;
 i13 = i15 + 4 | 0;
 i10 = i15;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i11, i12);
 __ZN14SafeBinaryRead10SetVersionEi(i12, 3);
 i14 = i11 + 40 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20NavMeshObstacleShapeEvRT_RT0_PKc17TransferMetaFlags(i12, i14, gb + 842452 | 0, 0);
 i2 = i11 + 56 | 0;
 i6 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842460 | 0, i6, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 72 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842470 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i3 = i11 + 68 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842486 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i11 + 69 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842494 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i4 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i11 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1034411 | 0, i6, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i12); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i11 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842516 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 47; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 47; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i12, 1) | 0)) {
  if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i12, 2) | 0)) {
   STACKTOP = i15;
   return;
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 842535 | 0, i6, i8, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i13, i12); else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i13 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  switch (HEAP32[i14 >> 2] | 0) {
  case 0:
   {
    f16 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) * Math_fround(.5));
    i14 = HEAP32[i13 + 8 >> 2] | 0;
    HEAP32[i11 + 56 >> 2] = HEAP32[i13 >> 2];
    HEAPF32[i11 + 60 >> 2] = f16;
    HEAP32[i11 + 64 >> 2] = i14;
    HEAPF32[i11 + 48 >> 2] = f16;
    break;
   }
  case 1:
   {
    f18 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(.5));
    f17 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) * Math_fround(.5));
    f16 = Math_fround(Math_fround(HEAPF32[i13 + 8 >> 2]) * Math_fround(.5));
    HEAPF32[i11 + 56 >> 2] = f18;
    HEAPF32[i11 + 60 >> 2] = f17;
    HEAPF32[i11 + 64 >> 2] = f16;
    break;
   }
  default:
   {}
  }
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i15;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 843745 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i6 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 59; else {
     HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i13, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i13 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 932223 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i8 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 70; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i9 = 70; else {
     HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 70) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i13 = HEAP32[i13 >> 2] | 0;
 f18 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(.5));
 HEAP32[i11 + 56 >> 2] = i13;
 HEAPF32[i11 + 60 >> 2] = f18;
 HEAP32[i11 + 64 >> 2] = i13;
 HEAPF32[i11 + 48 >> 2] = f18;
 HEAP32[i14 >> 2] = 0;
 HEAP8[i5 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN7Striper16ComputeBestStripEjR14BestStripCache(i23, i12, i13) {
 i23 = i23 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 60 | 0;
 i19 = i24 + 48 | 0;
 i16 = i24 + 36 | 0;
 i21 = i24 + 24 | 0;
 i17 = i24 + 12 | 0;
 i18 = i24;
 i2 = HEAP32[i23 >> 2] | 0;
 i14 = HEAP32[i2 + 16 >> 2] | 0;
 i20 = HEAP32[i14 + (i12 * 24 | 0) >> 2] | 0;
 HEAP32[i17 >> 2] = i20;
 i15 = HEAP32[i14 + (i12 * 24 | 0) + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = i15;
 i14 = HEAP32[i14 + (i12 * 24 | 0) + 8 >> 2] | 0;
 HEAP32[i17 + 4 >> 2] = i14;
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i17 + 8 >> 2] = i15;
 HEAP32[i18 + 8 >> 2] = i14;
 i14 = i13 + 72 | 0;
 i15 = i13 + 76 | 0;
 i20 = i23 + 4 | 0;
 i1 = 0;
 while (1) {
  i6 = i13 + (i1 * 24 | 0) | 0;
  i8 = HEAP32[i2 + 12 >> 2] | 0;
  i3 = i8 + 5 | 0;
  i7 = i13 + (i1 * 24 | 0) + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = i2 - i4 >> 2;
  if (i3 >>> 0 > i5 >>> 0) {
   __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj(i6, i3 - i5 | 0);
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0;
  } else if (i3 >>> 0 < i5 >>> 0) {
   i3 = i4 + (i3 << 2) | 0;
   if ((i2 | 0) == (i3 | 0)) i3 = i8; else {
    i2 = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2) | 0;
    HEAP32[i7 >> 2] = i2;
    i3 = i8;
   }
  } else i3 = i8;
  i11 = (i4 | 0) == (i2 | 0) ? 0 : i4;
  HEAP32[i22 + (i1 << 2) >> 2] = i11;
  i4 = i13 + (i1 * 24 | 0) + 12 | 0;
  i5 = i3 + 2 | 0;
  i8 = i13 + (i1 * 24 | 0) + 16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = i2 - i7 >> 2;
  if (i5 >>> 0 > i6 >>> 0) {
   __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj(i4, i5 - i6 | 0);
   i4 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0;
  } else if (i5 >>> 0 < i6 >>> 0) {
   i4 = i7 + (i5 << 2) | 0;
   if ((i2 | 0) == (i4 | 0)) i4 = i7; else {
    i2 = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2) | 0;
    HEAP32[i8 >> 2] = i2;
    i4 = i7;
   }
  } else i4 = i7;
  i10 = (i4 | 0) == (i2 | 0) ? 0 : i4;
  HEAP32[i19 + (i1 << 2) >> 2] = i10;
  _memset(i11 | 0, -1, (i3 << 2) + 20 | 0) | 0;
  _memset(i10 | 0, -1, (HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] << 2) + 8 | 0) | 0;
  i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0;
  i5 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = i5 - i4 | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZNSt3__26vectorIcNS_9allocatorIcEEE8__appendEj(i14, i3 - i2 | 0);
   i4 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0;
  } else if (i3 >>> 0 < i2 >>> 0) {
   i2 = i4 + i3 | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i5; else HEAP32[i15 >> 2] = i2;
  } else i2 = i5;
  i9 = (i4 | 0) == (i2 | 0) ? 0 : i4;
  _memcpy(i9 | 0, HEAP32[i20 >> 2] | 0, i3 | 0) | 0;
  i4 = __ZN7Striper10TrackStripEjjjPjS0_Pbb(i23, i12, HEAP32[i17 + (i1 << 2) >> 2] | 0, HEAP32[i18 + (i1 << 2) >> 2] | 0, i11, i10, i9, 0) | 0;
  i8 = i16 + (i1 << 2) | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i21 + (i1 << 2) >> 2] = i4;
  if (i4 >>> 0 > 1) {
   i5 = i4 >>> 1;
   i2 = 0;
   i3 = 0;
   while (1) {
    i2 = i11 + (i2 + -1 + i4 << 2) | 0;
    i6 = i11 + (i3 << 2) | 0;
    i7 = HEAP32[i6 >> 2] ^ HEAP32[i2 >> 2];
    HEAP32[i6 >> 2] = i7;
    i7 = HEAP32[i2 >> 2] ^ i7;
    HEAP32[i2 >> 2] = i7;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] ^ i7;
    i6 = i3 + 1 | 0;
    if (i6 >>> 0 < i5 >>> 0) {
     i2 = ~i3;
     i3 = i6;
    } else break;
   }
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i7 = i4 + -2 | 0;
  if (i7 >>> 0 > 1) {
   i5 = i7 >>> 1;
   i2 = 0;
   i3 = 0;
   while (1) {
    i25 = i10 + (i2 + -3 + i4 << 2) | 0;
    i6 = i10 + (i3 << 2) | 0;
    i2 = HEAP32[i6 >> 2] ^ HEAP32[i25 >> 2];
    HEAP32[i6 >> 2] = i2;
    i2 = HEAP32[i25 >> 2] ^ i2;
    HEAP32[i25 >> 2] = i2;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] ^ i2;
    i6 = i3 + 1 | 0;
    if (i6 >>> 0 < i5 >>> 0) {
     i2 = ~i3;
     i3 = i6;
    } else break;
   }
   i2 = HEAP32[i8 >> 2] | 0;
  } else i2 = i4;
  i25 = i4 + -3 | 0;
  i6 = i11 + (i25 << 2) | 0;
  HEAP32[i8 >> 2] = (__ZN7Striper10TrackStripEjjjPjS0_Pbb(i23, i12, HEAP32[i6 >> 2] | 0, HEAP32[i11 + (i7 << 2) >> 2] | 0, i6, i10 + (i25 << 2) | 0, i9, 1) | 0) + -3 + i2;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 3) break;
  i2 = HEAP32[i23 >> 2] | 0;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 i25 = HEAP32[i16 + 4 >> 2] | 0;
 i6 = i25 >>> 0 > i1 >>> 0;
 i1 = i6 ? i25 : i1;
 i25 = HEAP32[i16 + 8 >> 2] | 0;
 i11 = i25 >>> 0 > i1 >>> 0;
 i1 = i11 ? i25 : i1;
 i6 = i11 ? 2 : i6 & 1;
 i11 = i1 + -2 | 0;
 if (i11 | 0) {
  i4 = HEAP32[i19 + (i6 << 2) >> 2] | 0;
  i3 = HEAP32[i20 >> 2] | 0;
  i2 = 0;
  do {
   HEAP8[i3 + (HEAP32[i4 + (i2 << 2) >> 2] | 0) >> 0] = 1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i11 >>> 0);
 }
 i3 = HEAP32[i21 + (i6 << 2) >> 2] | 0;
 do if (!(i3 & 1)) i2 = 41; else {
  if ((i1 + -3 | 0) >>> 0 < 2) {
   i2 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
   i21 = i2 + 8 | 0;
   i25 = HEAP32[i21 >> 2] | 0;
   i2 = i2 + 4 | 0;
   HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i25;
   i2 = 42;
   break;
  }
  i4 = i1 >>> 1;
  if (i4 | 0) {
   i5 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
   i2 = 0;
   do {
    i20 = i5 + (i1 - i2 + -1 << 2) | 0;
    i25 = i5 + (i2 << 2) | 0;
    i21 = HEAP32[i25 >> 2] ^ HEAP32[i20 >> 2];
    HEAP32[i25 >> 2] = i21;
    i21 = HEAP32[i20 >> 2] ^ i21;
    HEAP32[i20 >> 2] = i21;
    HEAP32[i25 >> 2] = HEAP32[i25 >> 2] ^ i21;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
  }
  if (!(i1 - i3 & 1)) i2 = 41; else {
   if (i1 | 0) {
    i3 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
    i2 = 0;
    do {
     i25 = i1 - i2 | 0;
     HEAP32[i3 + (i25 << 2) >> 2] = HEAP32[i3 + (i25 + -1 << 2) >> 2];
     i2 = i2 + 1 | 0;
    } while (i1 >>> 0 > i2 >>> 0);
   }
   i1 = i1 + 1 | 0;
   i2 = 41;
  }
 } while (0);
 if ((i2 | 0) == 41) if (!i1) i1 = 0; else i2 = 42;
 if ((i2 | 0) == 42) {
  i8 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
  i9 = HEAP32[i23 + 16 >> 2] | 0;
  i7 = 0;
  i2 = HEAP32[i9 >> 2] | 0;
  do {
   i10 = HEAP32[i8 + (i7 << 2) >> 2] | 0;
   i3 = i2 + 12 | 0;
   if (((HEAP32[i2 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
    i6 = __Znwj(16) | 0;
    i5 = i6 + 4 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    if (!i2) {
     i4 = 0;
     i3 = 0;
    } else {
     i4 = 1;
     i3 = HEAP32[i3 >> 2] << 1;
    }
    HEAP32[i6 + 12 >> 2] = i3;
    HEAP32[i5 >> 2] = __Znaj(i3) | 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i9 >> 2] = i6;
    if (i4) {
     HEAP32[i2 >> 2] = i6;
     i3 = i6;
     i2 = i6;
    } else {
     i3 = i6;
     i2 = i6;
    }
   } else i3 = i2;
   i25 = i3 + 8 | 0;
   i22 = HEAP32[i25 >> 2] | 0;
   HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + i22 >> 2] = i10;
   HEAP32[i25 >> 2] = i22 + 4;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
 }
 i4 = HEAP32[i23 + 12 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i5 + 12 | 0;
 if (((HEAP32[i5 + 8 >> 2] | 0) + 4 | 0) >>> 0 <= (HEAP32[i2 >> 2] | 0) >>> 0) {
  i25 = i5;
  i22 = i25 + 4 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i25 = i25 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i22 = i22 + i23 | 0;
  HEAP32[i22 >> 2] = i1;
  i23 = i23 + 4 | 0;
  HEAP32[i25 >> 2] = i23;
  STACKTOP = i24;
  return i11 | 0;
 }
 i6 = __Znwj(16) | 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!i5) {
  i3 = 0;
  i2 = 0;
 } else {
  i3 = 1;
  i2 = HEAP32[i2 >> 2] << 1;
 }
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i7 >> 2] = __Znaj(i2) | 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = i6;
 if (!i3) {
  i25 = i6;
  i22 = i25 + 4 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i25 = i25 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i22 = i22 + i23 | 0;
  HEAP32[i22 >> 2] = i1;
  i23 = i23 + 4 | 0;
  HEAP32[i25 >> 2] = i23;
  STACKTOP = i24;
  return i11 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i25 = i6;
 i22 = i25 + 4 | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 i25 = i25 + 8 | 0;
 i23 = HEAP32[i25 >> 2] | 0;
 i22 = i22 + i23 | 0;
 HEAP32[i22 >> 2] = i1;
 i23 = i23 + 4 | 0;
 HEAP32[i25 >> 2] = i23;
 STACKTOP = i24;
 return i11 | 0;
}

function __ZN5physx11HullLibrary8calchullEPNS_6float3EiRPiRiRS2_S5_if(i18, i2, i3, i20, i19, i6, i5, i1, f4) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 9 | 0;
 i17 = i22 + 8 | 0;
 i15 = i22 + 4 | 0;
 i14 = i22;
 i1 = __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif(i18, i2, i3, i1, f4) | 0;
 if ((i1 & -3 | 0) == 1) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 if ((i1 | 0) != 2) {
  HEAP32[i14 >> 2] = 0;
  i1 = HEAP32[i18 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) > 0) {
   i6 = 0;
   i9 = 0;
   i5 = 0;
   i3 = i1;
   i1 = 0;
   i7 = 0;
   i10 = 0;
   i13 = 0;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
    if (!i3) {
     i8 = i6;
     i2 = i10;
    } else {
     i8 = HEAP32[i3 >> 2] | 0;
     if ((i1 | 0) == (i7 | 0)) {
      i7 = (i1 | 0) == 0 ? 16 : i1 << 1;
      i3 = i10;
      i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i7 << 2, gb + 730303 | 0, 136) | 0;
      HEAP32[i14 >> 2] = i5;
      if ((i1 | 0) > 0) {
       i2 = 0;
       do {
        HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i1 | 0));
       i16 = 27;
      } else if (i10 | 0) i16 = 27;
      if ((i16 | 0) == 27) {
       i16 = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i10);
      }
      i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
      i6 = i5;
      i9 = i5;
      i2 = i3;
      i3 = HEAP32[i3 + (i13 << 2) >> 2] | 0;
     }
     i12 = i1 + 1 | 0;
     HEAP32[i5 + (i1 << 2) >> 2] = i8;
     i10 = HEAP32[i3 + 4 >> 2] | 0;
     if ((i12 | 0) == (i7 | 0)) {
      i6 = (i7 | 0) == 0 ? 16 : i7 << 1;
      i3 = HEAP32[i14 >> 2] | 0;
      i5 = i3;
      i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i6 << 2, gb + 730303 | 0, 136) | 0;
      HEAP32[i14 >> 2] = i8;
      if ((i7 | 0) > 0) {
       i2 = 0;
       do {
        HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i7 | 0));
       i16 = 52;
      } else if (i3 | 0) i16 = 52;
      if ((i16 | 0) == 52) {
       i16 = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i3);
      }
      i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
      i5 = i8;
      i3 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
      i11 = i6;
      i6 = i8;
     } else {
      i5 = i9;
      i11 = i7;
     }
     i9 = i1 + 2 | 0;
     HEAP32[i5 + (i12 << 2) >> 2] = i10;
     i8 = HEAP32[i3 + 8 >> 2] | 0;
     if ((i9 | 0) == (i11 | 0)) {
      i7 = (i11 | 0) == 0 ? 16 : i11 << 1;
      i3 = HEAP32[i14 >> 2] | 0;
      i5 = i3;
      i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i7 << 2, gb + 730303 | 0, 136) | 0;
      HEAP32[i14 >> 2] = i6;
      if ((i11 | 0) > 0) {
       i2 = 0;
       do {
        HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i11 | 0));
       i16 = 58;
      } else if (i3 | 0) i16 = 58;
      if ((i16 | 0) == 58) {
       i16 = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i3);
      }
      i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
      i2 = i3;
      i3 = HEAP32[i3 + (i13 << 2) >> 2] | 0;
     } else i7 = i11;
     HEAP32[i6 + (i9 << 2) >> 2] = i8;
     i1 = i1 + 3 | 0;
     HEAP32[i2 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
     i2 = i6;
     if (!i3) {
      i8 = i6;
      i9 = i6;
      i5 = i6;
     } else {
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i3);
      i8 = i6;
      i9 = i6;
      i5 = i6;
     }
    }
    i13 = i13 + 1 | 0;
    i3 = HEAP32[i18 >> 2] | 0;
    if ((i13 | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) break; else {
     i6 = i8;
     i10 = i2;
    }
   }
   i2 = HEAP32[i14 >> 2] | 0;
  } else {
   i1 = 0;
   i2 = 0;
  }
  HEAP32[i19 >> 2] = (i1 | 0) / 3 | 0;
  HEAP32[i20 >> 2] = i2;
  HEAP32[i14 >> 2] = 0;
  i2 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i1);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 __ZN5physx11HullLibrary10expandhullEPNS_6float3EiRS2_Rif(i18, i2, i3, i6, i5, Math_fround(0.0)) | 0;
 i1 = __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif(i18, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, 256, f4) | 0;
 if ((i1 & -3 | 0) == 1) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 HEAP32[i15 >> 2] = 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) > 0) {
  i3 = i1;
  i6 = 0;
  i8 = 0;
  i5 = 0;
  i1 = 0;
  i7 = 0;
  i10 = 0;
  i13 = 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
   if (!i3) {
    i9 = i6;
    i2 = i10;
   } else {
    i9 = HEAP32[i3 >> 2] | 0;
    if ((i1 | 0) == (i7 | 0)) {
     i7 = (i1 | 0) == 0 ? 16 : i1 << 1;
     i3 = i10;
     i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i7 << 2, gb + 730303 | 0, 136) | 0;
     HEAP32[i15 >> 2] = i5;
     if ((i1 | 0) > 0) {
      i2 = 0;
      do {
       HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i1 | 0));
      i16 = 11;
     } else if (i10 | 0) i16 = 11;
     if ((i16 | 0) == 11) {
      i16 = 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i10);
     }
     i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
     i6 = i5;
     i8 = i5;
     i2 = i3;
     i3 = HEAP32[i3 + (i13 << 2) >> 2] | 0;
    }
    i12 = i1 + 1 | 0;
    HEAP32[i5 + (i1 << 2) >> 2] = i9;
    i9 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i12 | 0) == (i7 | 0)) {
     i6 = (i7 | 0) == 0 ? 16 : i7 << 1;
     i3 = HEAP32[i15 >> 2] | 0;
     i5 = i3;
     i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i6 << 2, gb + 730303 | 0, 136) | 0;
     HEAP32[i15 >> 2] = i8;
     if ((i7 | 0) > 0) {
      i2 = 0;
      do {
       HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i7 | 0));
      i16 = 40;
     } else if (i3 | 0) i16 = 40;
     if ((i16 | 0) == 40) {
      i16 = 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i3);
     }
     i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
     i5 = i8;
     i3 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
     i11 = i6;
     i6 = i8;
    } else {
     i5 = i8;
     i11 = i7;
    }
    i10 = i1 + 2 | 0;
    HEAP32[i5 + (i12 << 2) >> 2] = i9;
    i8 = HEAP32[i3 + 8 >> 2] | 0;
    if ((i10 | 0) == (i11 | 0)) {
     i7 = (i11 | 0) == 0 ? 16 : i11 << 1;
     i3 = HEAP32[i15 >> 2] | 0;
     i5 = i3;
     i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i7 << 2, gb + 730303 | 0, 136) | 0;
     HEAP32[i15 >> 2] = i6;
     if ((i11 | 0) > 0) {
      i2 = 0;
      do {
       HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i11 | 0));
      i16 = 46;
     } else if (i3 | 0) i16 = 46;
     if ((i16 | 0) == 46) {
      i16 = 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i3);
     }
     i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + (i13 << 2) >> 2] | 0;
    } else i7 = i11;
    HEAP32[i6 + (i10 << 2) >> 2] = i8;
    i1 = i1 + 3 | 0;
    HEAP32[i2 + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
    i2 = i6;
    if (!i3) {
     i9 = i6;
     i8 = i6;
     i5 = i6;
    } else {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i3);
     i9 = i6;
     i8 = i6;
     i5 = i6;
    }
   }
   i13 = i13 + 1 | 0;
   i3 = HEAP32[i18 >> 2] | 0;
   if ((i13 | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) break; else {
    i6 = i9;
    i10 = i2;
   }
  }
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 HEAP32[i19 >> 2] = (i1 | 0) / 3 | 0;
 HEAP32[i20 >> 2] = i2;
 HEAP32[i15 >> 2] = 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i21 = 2;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5physx2Gu12TriangleMesh4loadERNS_13PxInputStreamE(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i12 = i16 + 15 | 0;
 i3 = i16 + 14 | 0;
 i4 = i16 + 12 | 0;
 i6 = i16 + 4 | 0;
 i11 = i15 + 16 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i11);
 if (!(__ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE(77, 69, 83, 72, i13, i12, i14) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 if ((HEAP32[i13 >> 2] | 0) >>> 0 < 10) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 689458 | 0, 98, gb + 724838 | 0, i16);
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14) | 0;
 HEAPF32[i15 + 192 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 i1 = __ZN5physx20InternalTriangleMesh16allocateVerticesEj(i11, __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14) | 0) | 0;
 i7 = __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb(i11, __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14) | 0, (i10 & 12 | 0) == 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, (HEAP32[i11 >> 2] | 0) * 12 | 0) | 0;
 if (HEAP8[i12 >> 0] | 0) if (HEAP32[i11 >> 2] | 0) {
  i2 = 0;
  do {
   i9 = i1 + (i2 * 12 | 0) | 0;
   i8 = HEAP8[i9 >> 0] | 0;
   i5 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i8;
   i5 = i9 + 1 | 0;
   i8 = HEAP8[i5 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i8;
   i9 = i1 + (i2 * 12 | 0) + 4 | 0;
   i8 = HEAP8[i9 >> 0] | 0;
   i5 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i8;
   i5 = i9 + 1 | 0;
   i8 = HEAP8[i5 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i8;
   i9 = i1 + (i2 * 12 | 0) + 8 | 0;
   i8 = HEAP8[i9 >> 0] | 0;
   i5 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i8;
   i5 = i9 + 1 | 0;
   i8 = HEAP8[i5 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i5 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i8;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 i9 = i15 + 20 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i2 * 3 | 0;
 L13 : do if (!(i10 & 4)) {
  i1 = (HEAP8[i15 + 172 >> 0] & 2) != 0;
  if (!(i10 & 8)) {
   if (!i1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i7 | 0, i2 * 12 | 0) | 0;
    if ((HEAP8[i12 >> 0] | 0) == 0 | (i8 | 0) == 0) break; else i1 = 0;
    while (1) {
     i6 = i7 + (i1 << 2) | 0;
     i5 = HEAP8[i6 >> 0] | 0;
     i4 = i6 + 3 | 0;
     HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
     HEAP8[i4 >> 0] = i5;
     i4 = i6 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
     i6 = i6 + 2 | 0;
     HEAP8[i4 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP8[i6 >> 0] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i8 | 0)) break L13;
    }
   }
   if (!i8) break;
   i2 = i6 + 3 | 0;
   i3 = i6 + 1 | 0;
   i4 = i6 + 2 | 0;
   i5 = 0;
   i1 = i7;
   while (1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i6 | 0, 4) | 0;
    if (HEAP8[i12 >> 0] | 0) {
     i7 = HEAP32[i6 >> 2] | 0;
     HEAP8[i6 >> 0] = i7 >>> 24;
     HEAP8[i2 >> 0] = i7;
     HEAP8[i3 >> 0] = i7 >>> 16;
     HEAP8[i4 >> 0] = (i7 & 65535) >>> 8;
    }
    HEAP16[i1 >> 1] = HEAP32[i6 >> 2];
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i8 | 0)) break; else i1 = i1 + 2 | 0;
   }
  } else {
   if (i1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i7 | 0, i2 * 6 | 0) | 0;
    if ((HEAP8[i12 >> 0] | 0) == 0 | (i8 | 0) == 0) break; else i1 = 0;
    while (1) {
     i4 = i7 + (i1 << 1) | 0;
     i5 = HEAP8[i4 >> 0] | 0;
     i6 = i4 + 1 | 0;
     HEAP8[i4 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP8[i6 >> 0] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i8 | 0)) break L13;
    }
   }
   if (!i8) break;
   i2 = i4 + 1 | 0;
   i3 = 0;
   i1 = i7;
   while (1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i4 | 0, 2) | 0;
    if (HEAP8[i12 >> 0] | 0) {
     i7 = HEAP16[i4 >> 1] | 0;
     HEAP8[i4 >> 0] = (i7 & 65535) >>> 8;
     HEAP8[i2 >> 0] = i7;
    }
    HEAP32[i1 >> 2] = HEAPU16[i4 >> 1];
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i8 | 0)) break; else i1 = i1 + 4 | 0;
   }
  }
 } else {
  i1 = (i8 | 0) == 0;
  if (!(HEAP8[i15 + 172 >> 0] & 2)) {
   if (i1) break;
   i2 = 0;
   i1 = i7;
   while (1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i3 | 0, 1) | 0;
    HEAP32[i1 >> 2] = HEAPU8[i3 >> 0];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 4 | 0;
   }
  } else {
   if (i1) break;
   i2 = 0;
   i1 = i7;
   while (1) {
    mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i3 | 0, 1) | 0;
    HEAP16[i1 >> 1] = HEAPU8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 2 | 0;
   }
  }
 } while (0);
 if (i10 & 1 | 0) {
  i1 = __ZN5physx20InternalTriangleMesh17allocateMaterialsEv(i11) | 0;
  mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, HEAP32[i9 >> 2] << 1 | 0) | 0;
  if (HEAP8[i12 >> 0] | 0) if (HEAP32[i9 >> 2] | 0) {
   i2 = 0;
   do {
    i6 = i1 + (i2 << 1) | 0;
    i7 = HEAP8[i6 >> 0] | 0;
    i8 = i6 + 1 | 0;
    HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
    HEAP8[i8 >> 0] = i7;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  }
 }
 if (i10 & 2 | 0) {
  i8 = __ZN5physx20InternalTriangleMesh17allocateFaceRemapEv(i11) | 0;
  i7 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14) | 0;
  __ZN5physx11readIndicesEjjPjRNS_13PxInputStreamEb(i7, HEAP32[i9 >> 2] | 0, i8, i14, (HEAP8[i12 >> 0] | 0) != 0);
 }
 if (i10 & 16 | 0) {
  i1 = __ZN5physx20InternalTriangleMesh19allocateAdjacenciesEv(i11) | 0;
  mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
  if (HEAP8[i12 >> 0] | 0) if ((HEAP32[i9 >> 2] | 0) * 3 | 0) {
   i2 = 0;
   do {
    i10 = i1 + (i2 << 2) | 0;
    i8 = HEAP8[i10 >> 0] | 0;
    i7 = i10 + 3 | 0;
    HEAP8[i10 >> 0] = HEAP8[i7 >> 0] | 0;
    HEAP8[i7 >> 0] = i8;
    i7 = i10 + 1 | 0;
    i8 = HEAP8[i7 >> 0] | 0;
    i10 = i10 + 2 | 0;
    HEAP8[i7 >> 0] = HEAP8[i10 >> 0] | 0;
    HEAP8[i10 >> 0] = i8;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < ((HEAP32[i9 >> 2] | 0) * 3 | 0) >>> 0);
  }
 }
 if (!(__ZN5physx20InternalTriangleMesh9loadRTreeERNS_13PxInputStreamEj(i11, i14, HEAP32[i13 >> 2] | 0) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAPF32[i15 + 36 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 144 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 148 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 152 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 156 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 160 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 HEAPF32[i15 + 164 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14));
 i1 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i12 >> 0] | 0) != 0, i14) | 0;
 if (!i1) {
  i15 = 1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 i13 = _PxGetFoundation() | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0;
 i13 = mftCall_iiiiii(i11 | 0, i12 | 0, i1 | 0, (i13 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 689458 | 0, 247) | 0;
 HEAP32[i15 + 168 >> 2] = i13;
 mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i13 | 0, i1 | 0) | 0;
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx2Sc8ClothSim18addCollisionConvexEPKNS0_8ShapeSimE(i41, i43) {
 i41 = i41 | 0;
 i43 = i43 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i44 = 0, i45 = 0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i44 + 216 | 0;
 i5 = i44 + 136 | 0;
 i1 = i44 + 184 | 0;
 i2 = i44 + 108 | 0;
 i3 = i44 + 80 | 0;
 i28 = i44 + 68 | 0;
 i29 = i44 + 48 | 0;
 i27 = i44 + 32 | 0;
 i37 = i44 + 24 | 0;
 i39 = i44 + 16 | 0;
 i38 = i44 + 8 | 0;
 i30 = i41 + 92 | 0;
 i31 = i41 + 96 | 0;
 i32 = (HEAP32[i41 + 88 >> 2] | 0) + (HEAP32[i41 + 84 >> 2] | 0) + (HEAP32[i30 >> 2] | 0) + (HEAP32[i31 >> 2] | 0) | 0;
 i33 = HEAP32[i41 + 52 >> 2] | 0;
 i4 = HEAP32[i43 + 28 >> 2] | 0;
 i26 = i4 + 100 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 i34 = mftCall_ii(HEAP32[(HEAP32[i34 >> 2] | 0) + 36 >> 2] | 0, i34 | 0) | 0;
 i35 = i41 + 112 | 0;
 i36 = (HEAP32[i30 >> 2] | 0) + (HEAP32[i33 + 80 >> 2] | 0) + ((HEAP32[i31 >> 2] | 0) * 6 | 0) + (HEAP32[i35 >> 2] | 0) | 0;
 if ((i36 + i34 | 0) >>> 0 > 32) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 406, gb + 719546 | 0, i44);
  i43 = 0;
  STACKTOP = i44;
  return i43 | 0;
 }
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i2, i33);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i3, i43);
 f12 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i2 + 20 >> 2]));
 f10 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f11 = Math_fround(f11 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f10 - Math_fround(HEAPF32[i2 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(f14 * f13)) + Math_fround(f10 * f17));
 f22 = Math_fround(Math_fround(f25 * f12) + Math_fround(Math_fround(f21 * f11) + Math_fround(f9 * Math_fround(Math_fround(f10 * f13) - Math_fround(f14 * f17)))));
 f24 = Math_fround(Math_fround(f25 * f13) + Math_fround(Math_fround(f21 * f14) + Math_fround(f9 * Math_fround(Math_fround(f11 * f17) - Math_fround(f10 * f12)))));
 f25 = Math_fround(Math_fround(Math_fround(f21 * f10) + Math_fround(f9 * Math_fround(Math_fround(f14 * f12) - Math_fround(f11 * f13)))) + Math_fround(f25 * f17));
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f9 * f11);
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f10 * f12));
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f21 * f13));
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f11 * f17) + Math_fround(Math_fround(f10 * f13) + Math_fround(f9 * f16))) - Math_fround(f21 * f12));
 f20 = Math_fround(Math_fround(Math_fround(f16 * f12) + Math_fround(Math_fround(f10 * f17) + Math_fround(f9 * f21))) - Math_fround(f11 * f13));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f10) - Math_fround(f11 * f12)) - Math_fround(f16 * f13)) - Math_fround(f21 * f17));
 HEAPF32[i1 >> 2] = Math_fround(f14 - Math_fround(f16 * f17));
 HEAPF32[i1 + 4 >> 2] = f18;
 HEAPF32[i1 + 8 >> 2] = f20;
 HEAPF32[i1 + 12 >> 2] = f21;
 HEAPF32[i1 + 16 >> 2] = f22;
 HEAPF32[i1 + 20 >> 2] = f24;
 HEAPF32[i1 + 24 >> 2] = f25;
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i5, i1, i4 + 72 | 0);
 HEAP32[i28 >> 2] = 0;
 i6 = i28 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i42 = i28 + 8 | 0;
 HEAP32[i42 >> 2] = 0;
 if (i34 | 0) {
  __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i28, i34);
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  i15 = i29 + 4 | 0;
  f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f18 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  i19 = i29 + 8 | 0;
  f20 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i5 + 28 >> 2]);
  f22 = Math_fround(HEAPF32[i5 + 32 >> 2]);
  i23 = i29 + 12 | 0;
  f24 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  f25 = Math_fround(HEAPF32[i5 + 40 >> 2]);
  f7 = Math_fround(HEAPF32[i5 + 44 >> 2]);
  i1 = i27 + 4 | 0;
  i2 = i27 + 8 | 0;
  i3 = i27 + 12 | 0;
  i5 = 0;
  do {
   i4 = HEAP32[i26 >> 2] | 0;
   mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i5 | 0, i29 | 0) | 0;
   f10 = Math_fround(HEAPF32[i29 >> 2]);
   f8 = Math_fround(f10 * f12);
   f9 = Math_fround(f10 * f13);
   f10 = Math_fround(f10 * f14);
   f11 = Math_fround(HEAPF32[i15 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f11 * f16));
   f9 = Math_fround(f9 + Math_fround(f11 * f17));
   f11 = Math_fround(f10 + Math_fround(f11 * f18));
   f10 = Math_fround(HEAPF32[i19 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f10 * f20));
   f9 = Math_fround(f9 + Math_fround(f10 * f21));
   f10 = Math_fround(f11 + Math_fround(f10 * f22));
   f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - Math_fround(Math_fround(Math_fround(f8 * f24) + Math_fround(f9 * f25)) + Math_fround(f10 * f7)));
   HEAPF32[i27 >> 2] = f8;
   HEAPF32[i1 >> 2] = f9;
   HEAPF32[i2 >> 2] = f10;
   HEAPF32[i3 >> 2] = f11;
   i4 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i42 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    i45 = HEAP32[i28 >> 2] | 0;
    HEAPF32[i45 + (i4 << 4) >> 2] = f8;
    HEAPF32[i45 + (i4 << 4) + 4 >> 2] = f9;
    HEAPF32[i45 + (i4 << 4) + 8 >> 2] = f10;
    HEAPF32[i45 + (i4 << 4) + 12 >> 2] = f11;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i28, i27) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i34 | 0));
 }
 i3 = i33 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0;
 i6 = HEAP32[i28 >> 2] | 0;
 HEAP32[i37 >> 2] = i6;
 HEAP32[i37 + 4 >> 2] = i6 + (i34 << 4);
 HEAP32[i40 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
 mftCall_viiii(i5 | 0, i1 | 0, i40 | 0, i36 | 0, i36 | 0);
 i1 = i41 + 100 | 0;
 i5 = (HEAP32[i30 >> 2] | 0) + (HEAP32[i33 + 84 >> 2] | 0) + (HEAP32[i31 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i39 >> 2] = (1 << i34) + -1 << i36;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0;
 HEAP32[i38 >> 2] = i39;
 HEAP32[i38 + 4 >> 2] = i39 + 4;
 HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
 mftCall_viiii(i2 | 0, i3 | 0, i40 | 0, i5 | 0, i5 | 0);
 HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + i34;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 i5 = i32 + i5 | 0;
 i1 = i41 + 116 | 0;
 HEAP32[i40 >> 2] = 0;
 i3 = i41 + 120 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i41 + 124 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i40) | 0;
  i4 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i45 = HEAP32[i4 >> 2] | 0;
  HEAP32[i45 + (i1 << 2) >> 2] = HEAP32[i45 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i45 = i1;
   i1 = i2;
   i2 = i45;
  } else break;
 }
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = i43;
 i45 = HEAP32[i42 >> 2] | 0;
 if (!((i45 & 2147483647 | 0) == 0 | (i45 | 0) < 0 | (i6 | 0) == 0)) {
  i45 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i45 >> 2] | 0) + 12 >> 2] | 0, i45 | 0, i6 | 0);
 }
 i45 = 1;
 STACKTOP = i44;
 return i45 | 0;
}

function __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i69, i70, i67, i34, i16, i68) {
 i69 = i69 | 0;
 i70 = i70 | 0;
 i67 = i67 | 0;
 i34 = i34 | 0;
 i16 = i16 | 0;
 i68 = i68 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0;
 i71 = __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_(i69, i70, i67, i34, i68) | 0;
 if (!(mftCall_iii(HEAP32[i68 >> 2] | 0, i16 | 0, i34 | 0) | 0)) {
  i74 = i71;
  return i74 | 0;
 }
 i23 = HEAP32[i34 >> 2] | 0;
 i24 = i34 + 4 | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i25 = i34 + 8 | 0;
 i2 = HEAP32[i25 >> 2] | 0;
 i26 = i34 + 12 | 0;
 i3 = HEAP32[i26 >> 2] | 0;
 i27 = i34 + 16 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i28 = i34 + 20 | 0;
 i5 = HEAP32[i28 >> 2] | 0;
 i29 = i34 + 24 | 0;
 i6 = HEAP32[i29 >> 2] | 0;
 i30 = i34 + 28 | 0;
 i7 = HEAP32[i30 >> 2] | 0;
 i31 = i34 + 32 | 0;
 i8 = HEAP32[i31 >> 2] | 0;
 i32 = i34 + 36 | 0;
 i9 = HEAP32[i32 >> 2] | 0;
 i33 = i34 + 40 | 0;
 i10 = HEAP32[i33 >> 2] | 0;
 i35 = i34 + 44 | 0;
 i11 = HEAP32[i35 >> 2] | 0;
 i36 = i34 + 48 | 0;
 i12 = HEAP32[i36 >> 2] | 0;
 i37 = i34 + 52 | 0;
 i13 = HEAP32[i37 >> 2] | 0;
 i38 = i34 + 56 | 0;
 i14 = HEAP32[i38 >> 2] | 0;
 i39 = i34 + 60 | 0;
 i15 = HEAP32[i39 >> 2] | 0;
 i40 = i34 + 64 | 0;
 i17 = HEAP32[i40 >> 2] | 0;
 i41 = i34 + 68 | 0;
 i18 = HEAP32[i41 >> 2] | 0;
 i42 = i34 + 72 | 0;
 i19 = HEAP32[i42 >> 2] | 0;
 i43 = i34 + 76 | 0;
 i20 = HEAP32[i43 >> 2] | 0;
 i44 = i34 + 80 | 0;
 i21 = HEAP32[i44 >> 2] | 0;
 i45 = i34 + 84 | 0;
 i22 = HEAP32[i45 >> 2] | 0;
 i72 = i34;
 i73 = i16;
 i74 = i72 + 88 | 0;
 do {
  HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
  i72 = i72 + 4 | 0;
  i73 = i73 + 4 | 0;
 } while ((i72 | 0) < (i74 | 0));
 HEAP32[i16 >> 2] = i23;
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = i2;
 HEAP32[i16 + 12 >> 2] = i3;
 HEAP32[i16 + 16 >> 2] = i4;
 HEAP32[i16 + 20 >> 2] = i5;
 HEAP32[i16 + 24 >> 2] = i6;
 HEAP32[i16 + 28 >> 2] = i7;
 HEAP32[i16 + 32 >> 2] = i8;
 HEAP32[i16 + 36 >> 2] = i9;
 HEAP32[i16 + 40 >> 2] = i10;
 HEAP32[i16 + 44 >> 2] = i11;
 HEAP32[i16 + 48 >> 2] = i12;
 HEAP32[i16 + 52 >> 2] = i13;
 HEAP32[i16 + 56 >> 2] = i14;
 HEAP32[i16 + 60 >> 2] = i15;
 HEAP32[i16 + 64 >> 2] = i17;
 HEAP32[i16 + 68 >> 2] = i18;
 HEAP32[i16 + 72 >> 2] = i19;
 HEAP32[i16 + 76 >> 2] = i20;
 HEAP32[i16 + 80 >> 2] = i21;
 HEAP32[i16 + 84 >> 2] = i22;
 if (!(mftCall_iii(HEAP32[i68 >> 2] | 0, i34 | 0, i67 | 0) | 0)) {
  i74 = i71 + 1 | 0;
  return i74 | 0;
 }
 i1 = HEAP32[i67 >> 2] | 0;
 i46 = i67 + 4 | 0;
 i2 = HEAP32[i46 >> 2] | 0;
 i47 = i67 + 8 | 0;
 i3 = HEAP32[i47 >> 2] | 0;
 i48 = i67 + 12 | 0;
 i4 = HEAP32[i48 >> 2] | 0;
 i49 = i67 + 16 | 0;
 i5 = HEAP32[i49 >> 2] | 0;
 i50 = i67 + 20 | 0;
 i6 = HEAP32[i50 >> 2] | 0;
 i51 = i67 + 24 | 0;
 i7 = HEAP32[i51 >> 2] | 0;
 i52 = i67 + 28 | 0;
 i8 = HEAP32[i52 >> 2] | 0;
 i53 = i67 + 32 | 0;
 i9 = HEAP32[i53 >> 2] | 0;
 i54 = i67 + 36 | 0;
 i10 = HEAP32[i54 >> 2] | 0;
 i55 = i67 + 40 | 0;
 i11 = HEAP32[i55 >> 2] | 0;
 i56 = i67 + 44 | 0;
 i12 = HEAP32[i56 >> 2] | 0;
 i57 = i67 + 48 | 0;
 i13 = HEAP32[i57 >> 2] | 0;
 i58 = i67 + 52 | 0;
 i14 = HEAP32[i58 >> 2] | 0;
 i59 = i67 + 56 | 0;
 i15 = HEAP32[i59 >> 2] | 0;
 i60 = i67 + 60 | 0;
 i16 = HEAP32[i60 >> 2] | 0;
 i61 = i67 + 64 | 0;
 i17 = HEAP32[i61 >> 2] | 0;
 i62 = i67 + 68 | 0;
 i18 = HEAP32[i62 >> 2] | 0;
 i63 = i67 + 72 | 0;
 i19 = HEAP32[i63 >> 2] | 0;
 i64 = i67 + 76 | 0;
 i20 = HEAP32[i64 >> 2] | 0;
 i65 = i67 + 80 | 0;
 i21 = HEAP32[i65 >> 2] | 0;
 i66 = i67 + 84 | 0;
 i22 = HEAP32[i66 >> 2] | 0;
 i72 = i67;
 i73 = i34;
 i74 = i72 + 88 | 0;
 do {
  HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
  i72 = i72 + 4 | 0;
  i73 = i73 + 4 | 0;
 } while ((i72 | 0) < (i74 | 0));
 HEAP32[i34 >> 2] = i1;
 HEAP32[i24 >> 2] = i2;
 HEAP32[i25 >> 2] = i3;
 HEAP32[i26 >> 2] = i4;
 HEAP32[i27 >> 2] = i5;
 HEAP32[i28 >> 2] = i6;
 HEAP32[i29 >> 2] = i7;
 HEAP32[i30 >> 2] = i8;
 HEAP32[i31 >> 2] = i9;
 HEAP32[i32 >> 2] = i10;
 HEAP32[i33 >> 2] = i11;
 HEAP32[i35 >> 2] = i12;
 HEAP32[i36 >> 2] = i13;
 HEAP32[i37 >> 2] = i14;
 HEAP32[i38 >> 2] = i15;
 HEAP32[i39 >> 2] = i16;
 HEAP32[i40 >> 2] = i17;
 HEAP32[i41 >> 2] = i18;
 HEAP32[i42 >> 2] = i19;
 HEAP32[i43 >> 2] = i20;
 HEAP32[i44 >> 2] = i21;
 HEAP32[i45 >> 2] = i22;
 if (!(mftCall_iii(HEAP32[i68 >> 2] | 0, i67 | 0, i70 | 0) | 0)) {
  i74 = i71 + 2 | 0;
  return i74 | 0;
 }
 i1 = HEAP32[i70 >> 2] | 0;
 i23 = i70 + 4 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 i24 = i70 + 8 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i25 = i70 + 12 | 0;
 i4 = HEAP32[i25 >> 2] | 0;
 i26 = i70 + 16 | 0;
 i5 = HEAP32[i26 >> 2] | 0;
 i27 = i70 + 20 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i28 = i70 + 24 | 0;
 i7 = HEAP32[i28 >> 2] | 0;
 i29 = i70 + 28 | 0;
 i8 = HEAP32[i29 >> 2] | 0;
 i30 = i70 + 32 | 0;
 i9 = HEAP32[i30 >> 2] | 0;
 i31 = i70 + 36 | 0;
 i10 = HEAP32[i31 >> 2] | 0;
 i32 = i70 + 40 | 0;
 i11 = HEAP32[i32 >> 2] | 0;
 i33 = i70 + 44 | 0;
 i12 = HEAP32[i33 >> 2] | 0;
 i34 = i70 + 48 | 0;
 i13 = HEAP32[i34 >> 2] | 0;
 i35 = i70 + 52 | 0;
 i14 = HEAP32[i35 >> 2] | 0;
 i36 = i70 + 56 | 0;
 i15 = HEAP32[i36 >> 2] | 0;
 i37 = i70 + 60 | 0;
 i16 = HEAP32[i37 >> 2] | 0;
 i38 = i70 + 64 | 0;
 i17 = HEAP32[i38 >> 2] | 0;
 i39 = i70 + 68 | 0;
 i18 = HEAP32[i39 >> 2] | 0;
 i40 = i70 + 72 | 0;
 i19 = HEAP32[i40 >> 2] | 0;
 i41 = i70 + 76 | 0;
 i20 = HEAP32[i41 >> 2] | 0;
 i42 = i70 + 80 | 0;
 i21 = HEAP32[i42 >> 2] | 0;
 i43 = i70 + 84 | 0;
 i22 = HEAP32[i43 >> 2] | 0;
 i72 = i70;
 i73 = i67;
 i74 = i72 + 88 | 0;
 do {
  HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
  i72 = i72 + 4 | 0;
  i73 = i73 + 4 | 0;
 } while ((i72 | 0) < (i74 | 0));
 HEAP32[i67 >> 2] = i1;
 HEAP32[i46 >> 2] = i2;
 HEAP32[i47 >> 2] = i3;
 HEAP32[i48 >> 2] = i4;
 HEAP32[i49 >> 2] = i5;
 HEAP32[i50 >> 2] = i6;
 HEAP32[i51 >> 2] = i7;
 HEAP32[i52 >> 2] = i8;
 HEAP32[i53 >> 2] = i9;
 HEAP32[i54 >> 2] = i10;
 HEAP32[i55 >> 2] = i11;
 HEAP32[i56 >> 2] = i12;
 HEAP32[i57 >> 2] = i13;
 HEAP32[i58 >> 2] = i14;
 HEAP32[i59 >> 2] = i15;
 HEAP32[i60 >> 2] = i16;
 HEAP32[i61 >> 2] = i17;
 HEAP32[i62 >> 2] = i18;
 HEAP32[i63 >> 2] = i19;
 HEAP32[i64 >> 2] = i20;
 HEAP32[i65 >> 2] = i21;
 HEAP32[i66 >> 2] = i22;
 if (!(mftCall_iii(HEAP32[i68 >> 2] | 0, i70 | 0, i69 | 0) | 0)) {
  i74 = i71 + 3 | 0;
  return i74 | 0;
 }
 i1 = HEAP32[i69 >> 2] | 0;
 i2 = HEAP32[i69 + 4 >> 2] | 0;
 i3 = HEAP32[i69 + 8 >> 2] | 0;
 i4 = HEAP32[i69 + 12 >> 2] | 0;
 i5 = HEAP32[i69 + 16 >> 2] | 0;
 i6 = HEAP32[i69 + 20 >> 2] | 0;
 i7 = HEAP32[i69 + 24 >> 2] | 0;
 i8 = HEAP32[i69 + 28 >> 2] | 0;
 i9 = HEAP32[i69 + 32 >> 2] | 0;
 i10 = HEAP32[i69 + 36 >> 2] | 0;
 i11 = HEAP32[i69 + 40 >> 2] | 0;
 i12 = HEAP32[i69 + 44 >> 2] | 0;
 i13 = HEAP32[i69 + 48 >> 2] | 0;
 i14 = HEAP32[i69 + 52 >> 2] | 0;
 i15 = HEAP32[i69 + 56 >> 2] | 0;
 i16 = HEAP32[i69 + 60 >> 2] | 0;
 i17 = HEAP32[i69 + 64 >> 2] | 0;
 i18 = HEAP32[i69 + 68 >> 2] | 0;
 i19 = HEAP32[i69 + 72 >> 2] | 0;
 i20 = HEAP32[i69 + 76 >> 2] | 0;
 i21 = HEAP32[i69 + 80 >> 2] | 0;
 i22 = HEAP32[i69 + 84 >> 2] | 0;
 i72 = i69;
 i73 = i70;
 i74 = i72 + 88 | 0;
 do {
  HEAP32[i72 >> 2] = HEAP32[i73 >> 2];
  i72 = i72 + 4 | 0;
  i73 = i73 + 4 | 0;
 } while ((i72 | 0) < (i74 | 0));
 HEAP32[i70 >> 2] = i1;
 HEAP32[i23 >> 2] = i2;
 HEAP32[i24 >> 2] = i3;
 HEAP32[i25 >> 2] = i4;
 HEAP32[i26 >> 2] = i5;
 HEAP32[i27 >> 2] = i6;
 HEAP32[i28 >> 2] = i7;
 HEAP32[i29 >> 2] = i8;
 HEAP32[i30 >> 2] = i9;
 HEAP32[i31 >> 2] = i10;
 HEAP32[i32 >> 2] = i11;
 HEAP32[i33 >> 2] = i12;
 HEAP32[i34 >> 2] = i13;
 HEAP32[i35 >> 2] = i14;
 HEAP32[i36 >> 2] = i15;
 HEAP32[i37 >> 2] = i16;
 HEAP32[i38 >> 2] = i17;
 HEAP32[i39 >> 2] = i18;
 HEAP32[i40 >> 2] = i19;
 HEAP32[i41 >> 2] = i20;
 HEAP32[i42 >> 2] = i21;
 HEAP32[i43 >> 2] = i22;
 i74 = i71 + 4 | 0;
 return i74 | 0;
}

function __ZN13SpeedTreeWind5ScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, f5 = f0;
 i3 = i1 + 424 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 428 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 432 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 436 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 440 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 444 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 448 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 452 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 456 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 460 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1216 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1220 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1224 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1228 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1232 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1236 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1240 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1244 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1248 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 1252 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 504 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 508 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 512 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 516 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 520 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 524 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 528 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 532 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 536 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 540 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 636 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 640 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 644 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 648 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 652 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 656 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 660 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 664 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 668 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 672 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = f2 != Math_fround(0.0);
 i4 = i1 + 768 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 772 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 776 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 780 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 784 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 788 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 792 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 796 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 800 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 i4 = i1 + 804 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 if (i3) {
  i4 = i1 + 984 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) / f2);
  i4 = i1 + 992 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 996 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1e3 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1004 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1008 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1012 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1016 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1020 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1024 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1028 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1208 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) / f2);
  i4 = i1 + 416 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1288 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 / f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1344 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 8 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1332 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1336 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1340 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f2 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f2;
  return;
 } else {
  i4 = i1 + 992 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 996 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1e3 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1004 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1008 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1012 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1016 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1020 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1024 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 1028 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
  i4 = i1 + 416 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1288 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 / f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1344 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 8 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1332 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1336 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  i4 = i1 + 1340 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f5 = Math_fround(f5 * f2);
  HEAPF32[i4 >> 2] = f5;
  return;
 }
}

function __ZN5Unity5Cloth15UpdateCollidersEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i32 + 192 | 0;
 i27 = i32 + 128 | 0;
 i28 = i32 + 64 | 0;
 i29 = i32;
 i30 = i23 + 208 | 0;
 HEAP32[i23 + 220 >> 2] = 0;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i28, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i23 + 28 >> 2] | 0, gb + 31632 | 0) | 0) | 0);
 i1 = HEAP32[i23 + 188 >> 2] | 0;
 i25 = HEAP32[i23 + 200 >> 2] | 0;
 i6 = i1 + (i25 << 2) | 0;
 if (i25 | 0) {
  i7 = i28 + 16 | 0;
  i8 = i26 + 4 | 0;
  i9 = i28 + 32 | 0;
  i10 = i26 + 8 | 0;
  i11 = i28 + 48 | 0;
  i12 = i28 + 4 | 0;
  i13 = i28 + 20 | 0;
  i14 = i28 + 36 | 0;
  i15 = i28 + 52 | 0;
  i16 = i28 + 8 | 0;
  i17 = i28 + 24 | 0;
  i18 = i28 + 40 | 0;
  i19 = i28 + 56 | 0;
  i20 = i26 + 4 | 0;
  i21 = i26 + 8 | 0;
  i22 = i26 + 12 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2 | 0) {
    HEAP32[i27 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i31 = 9; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i2, i27);
      i3 = HEAP32[i26 >> 2] | 0;
      i25 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i25 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i25 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i31 = 9; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i31 = 11;
     }
    }
    if ((i31 | 0) == 9) i31 = 11;
    if ((i31 | 0) == 11) {
     i31 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
     if (!i2) break;
    }
    __ZNK14SphereCollider15GetGlobalCenterEv(i26, i2);
    f35 = Math_fround(HEAPF32[i28 >> 2]);
    f36 = Math_fround(HEAPF32[i26 >> 2]);
    f35 = Math_fround(f35 * f36);
    f34 = Math_fround(HEAPF32[i7 >> 2]);
    f5 = Math_fround(HEAPF32[i8 >> 2]);
    f34 = Math_fround(f35 + Math_fround(f34 * f5));
    f35 = Math_fround(HEAPF32[i9 >> 2]);
    f33 = Math_fround(HEAPF32[i10 >> 2]);
    f35 = Math_fround(f34 + Math_fround(f35 * f33));
    f35 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f35);
    f34 = Math_fround(f36 * Math_fround(HEAPF32[i12 >> 2]));
    f34 = Math_fround(f34 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
    f34 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i14 >> 2])));
    f34 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f34);
    f36 = Math_fround(f36 * Math_fround(HEAPF32[i16 >> 2]));
    f5 = Math_fround(f36 + Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2])));
    f33 = Math_fround(f5 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2])));
    f33 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f33);
    f5 = Math_fround(__ZNK14SphereCollider15GetScaledRadiusERK8Vector3f(i2, gb + 62512 | 0));
    HEAPF32[i26 >> 2] = f35;
    HEAPF32[i20 >> 2] = f34;
    HEAPF32[i21 >> 2] = f33;
    HEAPF32[i22 >> 2] = f5;
    __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_(i30, i26);
   } while (0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i23 + 148 >> 2] | 0;
 i25 = HEAP32[i23 + 160 >> 2] | 0;
 i7 = i1 + (i25 << 2) | 0;
 if (!i25) {
  STACKTOP = i32;
  return;
 }
 i8 = i26 + 4 | 0;
 i9 = i27 + 16 | 0;
 i10 = i27 + 32 | 0;
 i11 = i27 + 48 | 0;
 i12 = i27 + 4 | 0;
 i13 = i27 + 20 | 0;
 i14 = i27 + 36 | 0;
 i15 = i27 + 52 | 0;
 i16 = i27 + 8 | 0;
 i17 = i27 + 24 | 0;
 i18 = i27 + 40 | 0;
 i19 = i27 + 56 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29 + 8 | 0;
 i22 = i29 + 12 | 0;
 i23 = i29 + 4 | 0;
 i24 = i29 + 8 | 0;
 i25 = i29 + 12 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  do if (i2 | 0) {
   HEAP32[i27 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i31 = 22; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i26, i2, i27);
     i3 = HEAP32[i26 >> 2] | 0;
     i6 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i6 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i31 = 22; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i31 = 24;
    }
   }
   if ((i31 | 0) == 22) i31 = 24;
   if ((i31 | 0) == 24) {
    i31 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
    if (!i2) break;
   }
   __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f(i26, i2, gb + 62512 | 0);
   f5 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * Math_fround(.5));
   i3 = i27;
   i4 = i28;
   i6 = i3 + 64 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i6 | 0));
   __ZNK15CapsuleCollider18CalculateTransformEv(i29, i2);
   __ZN10Matrix4x4fmLERKS_(i27, i29) | 0;
   f35 = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
   f35 = Math_fround(f35 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(0.0)));
   f35 = Math_fround(f35 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(0.0)));
   f35 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f35);
   f34 = Math_fround(f5 * Math_fround(HEAPF32[i12 >> 2]));
   f34 = Math_fround(f34 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(0.0)));
   f34 = Math_fround(f34 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(0.0)));
   f34 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f34);
   f36 = Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2]));
   f36 = Math_fround(f36 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(0.0)));
   f36 = Math_fround(f36 + Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(0.0)));
   f36 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f36);
   i6 = HEAP32[i26 >> 2] | 0;
   HEAPF32[i29 >> 2] = f35;
   HEAPF32[i20 >> 2] = f34;
   HEAPF32[i21 >> 2] = f36;
   HEAP32[i22 >> 2] = i6;
   __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_(i30, i29);
   f36 = Math_fround(-f5);
   f34 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f36);
   f34 = Math_fround(f34 - Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(0.0)));
   f34 = Math_fround(f34 - Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(0.0)));
   f34 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f34);
   f35 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f36);
   f35 = Math_fround(f35 - Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(0.0)));
   f35 = Math_fround(f35 - Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(0.0)));
   f35 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f35);
   f36 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f36);
   f36 = Math_fround(f36 - Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(0.0)));
   f36 = Math_fround(f36 - Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(0.0)));
   f36 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f36);
   i6 = HEAP32[i26 >> 2] | 0;
   HEAPF32[i29 >> 2] = f34;
   HEAPF32[i23 >> 2] = f35;
   HEAPF32[i24 >> 2] = f36;
   HEAP32[i25 >> 2] = i6;
   __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_(i30, i29);
  } while (0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i32;
 return;
}

function __ZN9ShaderLab4Pass24CreateFromSerializedPassERKNS_14SerializedPassEPK6Shader(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 8 | 0;
 i9 = i20 + 4 | 0;
 i10 = i20;
 if (!(HEAP8[(HEAP32[gb + 1166136 >> 2] | 0) + 518 >> 0] | 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 475709 | 0, 9);
  i4 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13) | 0;
  i5 = i18 + 708 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i6 = 10; else {
   i1 = i5;
   L4 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i4 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L4; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) == (i5 | 0)) i6 = 10; else if ((i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i6 = 10;
  }
  if ((i6 | 0) == 10) i1 = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  if ((i1 | 0) == (i5 | 0)) {
   i1 = i5;
   i8 = i5;
  } else {
   i17 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 475719 | 0, 8);
   i17 = (i17 | 0) == (__ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   if (i17) {
    i19 = 0;
    STACKTOP = i20;
    return i19 | 0;
   } else {
    i1 = i5;
    i8 = i5;
   }
  }
 } else {
  i8 = i18 + 708 | 0;
  i1 = i8;
 }
 i14 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1166404 >> 2] | 0, 0, 0) | 0;
 i15 = __ZnwjRK10MemLabelIdiPKci(784, gb + 63280 | 0, 16, gb + 472212 | 0, 357) | 0;
 __ZN9ShaderLab4PassC2ENS0_8PassTypeE(i15, 0);
 i16 = i15 + 4 | 0;
 i12 = i18 + 4 | 0;
 i17 = i15 + 772 | 0;
 __ZN9ShaderLab11ShaderState25FromSerializedShaderStateERKNS_21SerializedShaderStateEP16PropertyNamesSet(i16, i12, i17);
 i11 = i15 + 756 | 0;
 i2 = HEAP32[i18 + 704 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i15 + 760 | 0;
  i6 = i5;
  i7 = i15 + 764 | 0;
  i3 = i2;
  i1 = i2;
  while (1) {
   i3 = i3 + 16 | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   i4 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i11, i13, i9, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i22 = i3;
    i21 = HEAP32[i22 + 4 >> 2] | 0;
    i3 = i2 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i3 + 4 >> 2] = i21;
    i3 = HEAP32[i9 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i11 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 >> 2] | 0, i2);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i8 | 0)) break; else i3 = i1;
  }
 }
 L36 : do if (HEAP8[i18 + 720 >> 0] | 0) {
  i7 = i15 + 760 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = (i1 | 0) == 0;
  do if (i5) i6 = 40; else {
   i2 = i7;
   i4 = i1;
   L40 : while (1) {
    i3 = i4;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= 0) break;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i3) break L40;
    }
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) {
     i2 = i3;
     break;
    } else i2 = i3;
   }
   if ((i2 | 0) != (i7 | 0)) if (!((HEAP32[i2 + 16 >> 2] | 0) > 0 | (i2 | 0) == (i7 | 0))) break L36;
   if (i5) i6 = 40; else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i6 = 35;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= 0) {
       i6 = 41;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i6 = 39;
       break;
      } else i1 = i2;
     }
    }
    if ((i6 | 0) == 35) {
     HEAP32[i13 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     i6 = 42;
     break;
    } else if ((i6 | 0) == 39) {
     HEAP32[i13 >> 2] = i1;
     i2 = i1;
     i6 = 42;
     break;
    } else if ((i6 | 0) == 41) {
     HEAP32[i13 >> 2] = i1;
     if (!i1) {
      i2 = i1;
      i3 = i13;
      i6 = 42;
      break;
     } else break;
    }
   }
  } while (0);
  if ((i6 | 0) == 40) {
   HEAP32[i13 >> 2] = i7;
   i2 = i7;
   i3 = i7;
   i6 = 42;
  }
  if ((i6 | 0) == 42) {
   i1 = __Znwj(24) | 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i11 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i2);
   i22 = i15 + 764 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 20 >> 2] = 3;
 } while (0);
 i1 = i15 + 728 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i7 = HEAP8[i12 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i4 ? HEAP32[i18 + 8 >> 2] | 0 : i7 & 255;
  i4 = i15 + 739 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i15 + 736 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i15 + 732 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i15 + 732 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i5 = i18 + 724 | 0;
 i6 = i18 + 700 | 0;
 i4 = 0;
 do {
  if (HEAP32[i5 >> 2] & 1 << i4 | 0) {
   i7 = i18 + 728 + (i4 * 12 | 0) | 0;
   i21 = HEAP32[i6 >> 2] | 0;
   i22 = (HEAP32[i18 + 728 + (i4 * 12 | 0) + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = (i22 | 0) / 192 | 0;
   i9 = __Znwj(208) | 0;
   __ZN9ShaderLab7ProgramC2Ei10ShaderType(i9, i8, i4);
   HEAP32[i9 + 196 >> 2] = i21;
   if (i22 | 0) {
    i1 = 1;
    i3 = 0;
    do {
     i2 = __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader((HEAP32[i7 >> 2] | 0) + (i3 * 192 | 0) | 0, i17, i19) | 0;
     if (i2) {
      if (i1) __ZNK9ShaderLab10SubProgram14EnsureCompiledEv(i2);
      __ZN9ShaderLab7Program13AddSubProgramEPNS_10SubProgramE(i9, i2);
      i1 = 0;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i8 >>> 0);
   }
   __ZN9ShaderLab11ShaderState10SetProgramE10ShaderTypePNS_7ProgramEPK6Shader(i16, i4, i9, i19);
   i22 = i9 + 4 | 0;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
   if (!(HEAP32[i22 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 6);
 __ZN9ShaderLab11ShaderState25RemoveUnsupportedProgramsEPK6Shader(i16, i19);
 if (!i14) {
  i22 = i15;
  STACKTOP = i20;
  return i22 | 0;
 }
 __Z19pop_allocation_rootv();
 i22 = i15;
 STACKTOP = i20;
 return i22 | 0;
}

function __ZN5physx21PxClothRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i41, i1, i15, i12, i13, i14) {
 i41 = i41 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i40 + 156 | 0;
 i6 = i40;
 i5 = i40 + 152 | 0;
 i10 = i40 + 148 | 0;
 i4 = i40 + 144 | 0;
 i9 = i40 + 140 | 0;
 i20 = i40 + 136 | 0;
 i25 = i40 + 132 | 0;
 i27 = i40 + 128 | 0;
 i26 = i40 + 124 | 0;
 i28 = i40 + 120 | 0;
 i29 = i40 + 116 | 0;
 i31 = i40 + 112 | 0;
 i30 = i40 + 108 | 0;
 i34 = i40 + 104 | 0;
 i36 = i40 + 100 | 0;
 i21 = i40 + 96 | 0;
 i17 = i40 + 92 | 0;
 i23 = i40 + 88 | 0;
 i16 = i40 + 84 | 0;
 i22 = i40 + 80 | 0;
 i18 = i40 + 76 | 0;
 i24 = i40 + 72 | 0;
 i19 = i40 + 68 | 0;
 i35 = i40 + 64 | 0;
 i33 = i40 + 60 | 0;
 i37 = i40 + 56 | 0;
 i32 = i40 + 52 | 0;
 i38 = i40 + 48 | 0;
 i39 = i40 + 44 | 0;
 i8 = i40 + 16 | 0;
 i7 = i40 + 168 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i35 >> 2] = 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i39 >> 2] = 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 675258 | 0, i5 | 0) | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i2 = _strtoull(i1, i11, 10) | 0;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i1 | 0) == 0) break;
   i3 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i2 | 0, i1 | 0) | 0;
   if (!i3) {
    i39 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i6 >> 2] = gb + 764826;
    i38 = i6 + 8 | 0;
    HEAP32[i38 >> 2] = i2;
    HEAP32[i38 + 4 >> 2] = i1;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i39, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i6);
    break;
   }
   __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 773288 | 0, i9, i10, i4, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_22PxClothCollisionSphereEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675265 | 0, i25, i10, i20, i12);
   __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i15, gb + 675282 | 0, i26, i10, i27, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_21PxClothCollisionPlaneEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675303 | 0, i29, i10, i28, i12);
   __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i15, gb + 675319 | 0, i30, i10, i31, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_24PxClothCollisionTriangleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675340 | 0, i36, i10, i34, i12);
   if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 675496 | 0, i11 | 0) | 0) {
    HEAP32[i5 >> 2] = 0;
    __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(HEAP32[i11 >> 2] | 0, i12, i5, gb + 90152 | 0);
    i1 = HEAP32[i5 >> 2] & 65535;
   } else i1 = 0;
   __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675359 | 0, i21, i10, i17, i12);
   __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i15, gb + 675381 | 0, i23, i10, i16, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675402 | 0, i22, i10, i18, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675420 | 0, i24, i10, i19, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675442 | 0, i35, i10, i33, i12);
   __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i15, gb + 675456 | 0, i38, i10, i37, i12);
   __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i15, gb + 675479 | 0, i39, i10, i32, i12);
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
   i5 = HEAP32[i13 >> 2] | 0;
   i10 = HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP16[i7 >> 1] = i1;
   i6 = mftCall_iiiiii(i10 | 0, i5 | 0, i8 | 0, i3 | 0, i6 | 0, i7 | 0) | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   i5 = __ZN5physx2Sn17readAllPropertiesINS_7PxClothEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i11, i15, i6, i12, i14) | 0;
   i1 = HEAP32[i16 >> 2] | 0;
   if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 404 >> 2] | 0, i6 | 0, HEAP32[i23 >> 2] | 0, i1 | 0);
   if (HEAP32[i18 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 224 >> 2] | 0, i6 | 0, HEAP32[i22 >> 2] | 0);
   if (HEAP32[i19 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 244 >> 2] | 0, i6 | 0, HEAP32[i24 >> 2] | 0);
   if (HEAP32[i17 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 212 >> 2] | 0, i6 | 0, HEAP32[i21 >> 2] | 0);
   mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 284 >> 2] | 0, i6 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i20 >> 2] | 0);
   i1 = HEAP32[i27 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAP32[i26 >> 2] | 0;
    i2 = i1;
    while (1) {
     i1 = i3 + 8 | 0;
     mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 292 >> 2] | 0, i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
     i2 = i2 + -2 | 0;
     if (!i2) break; else i3 = i1;
    }
    HEAP32[i26 >> 2] = i1;
    HEAP32[i27 >> 2] = 0;
   }
   mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 312 >> 2] | 0, i6 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i28 >> 2] | 0);
   i3 = HEAP32[i31 >> 2] | 0;
   i1 = i3 + -1 | 0;
   HEAP32[i31 >> 2] = i1;
   if (i3 | 0) {
    i4 = HEAP32[i30 >> 2] | 0;
    i2 = i4;
    while (1) {
     mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 320 >> 2] | 0, i6 | 0, HEAP32[i2 >> 2] | 0);
     if (!i1) break; else {
      i2 = i2 + 4 | 0;
      i1 = i1 + -1 | 0;
     }
    }
    HEAP32[i30 >> 2] = i4 + (i3 << 2);
    HEAP32[i31 >> 2] = -1;
   }
   mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 340 >> 2] | 0, i6 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i34 >> 2] | 0);
   if (HEAP32[i33 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 416 >> 2] | 0, i6 | 0, HEAP32[i35 >> 2] | 0);
   i2 = (HEAP32[i32 >> 2] | 0) >>> 2;
   i1 = HEAP32[i37 >> 2] | 0;
   if ((i2 | 0) != 0 & (i1 | 0) != 0) mftCall_viiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 352 >> 2] | 0, i6 | 0, i2 | 0, HEAP32[i39 >> 2] | 0, i1 | 0, HEAP32[i38 >> 2] | 0);
   if (i5) {
    HEAP32[i41 >> 2] = gb + 764818;
    HEAP32[i41 + 4 >> 2] = i6;
    i41 = i41 + 8 | 0;
    HEAP32[i41 >> 2] = i6;
    HEAP32[i41 + 4 >> 2] = 0;
    STACKTOP = i40;
    return;
   } else {
    HEAP32[i41 >> 2] = gb + 1576256;
    HEAP32[i41 + 4 >> 2] = 0;
    i41 = i41 + 8 | 0;
    HEAP32[i41 >> 2] = 0;
    HEAP32[i41 + 4 >> 2] = 0;
    STACKTOP = i40;
    return;
   }
  }
 } while (0);
 HEAP32[i41 >> 2] = gb + 1576256;
 HEAP32[i41 + 4 >> 2] = 0;
 i41 = i41 + 8 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 STACKTOP = i40;
 return;
}

function __Z30GeomOverlapCallback_ConvexMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i22, i24, i23, i25, i1) {
 i22 = i22 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 800 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 720 | 0;
 i18 = i21 + 648 | 0;
 i19 = i21 + 600 | 0;
 i20 = i21 + 552 | 0;
 i16 = i21 + 464 | 0;
 i17 = i21 + 488 | 0;
 i15 = i21 + 448 | 0;
 i13 = i21;
 i1 = HEAP32[i22 + 32 >> 2] | 0;
 i10 = HEAP32[i23 + 36 >> 2] | 0;
 i12 = i22 + 4 | 0;
 if (Math_fround(HEAPF32[i12 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i22 + 8 >> 2]) == Math_fround(1.0)) i5 = Math_fround(HEAPF32[i22 + 12 >> 2]) == Math_fround(1.0); else i5 = 0; else i5 = 0;
 i2 = i23 + 4 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i23 + 8 >> 2]) == Math_fround(1.0)) i3 = Math_fround(HEAPF32[i23 + 12 >> 2]) == Math_fround(1.0); else i3 = 0; else i3 = 0;
 HEAP32[i14 >> 2] = 1065353216;
 i4 = i14 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i7 = i14 + 16 | 0;
 HEAP32[i7 >> 2] = 1065353216;
 i8 = i14 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 i9 = i14 + 28 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = 1065353216;
 HEAP32[i14 + 36 >> 2] = 1065353216;
 HEAP32[i14 + 40 >> 2] = 0;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 HEAP32[i14 + 52 >> 2] = 1065353216;
 HEAP32[i14 + 56 >> 2] = 0;
 HEAP32[i14 + 60 >> 2] = 0;
 HEAP32[i14 + 64 >> 2] = 0;
 HEAP32[i14 + 68 >> 2] = 1065353216;
 if (!i5) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i14, i12, i22 + 16 | 0);
 HEAP32[i18 >> 2] = 1065353216;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 1065353216;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = 0;
 HEAP32[i18 + 32 >> 2] = 1065353216;
 HEAP32[i18 + 36 >> 2] = 1065353216;
 HEAP32[i18 + 40 >> 2] = 0;
 HEAP32[i18 + 44 >> 2] = 0;
 HEAP32[i18 + 48 >> 2] = 0;
 HEAP32[i18 + 52 >> 2] = 1065353216;
 HEAP32[i18 + 56 >> 2] = 0;
 HEAP32[i18 + 60 >> 2] = 0;
 HEAP32[i18 + 64 >> 2] = 0;
 HEAP32[i18 + 68 >> 2] = 1065353216;
 if (!i3) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i18, i2, i23 + 16 | 0);
 f30 = Math_fround(HEAPF32[i24 >> 2]);
 f43 = Math_fround(f30 + f30);
 f36 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f44 = Math_fround(f36 + f36);
 f33 = Math_fround(HEAPF32[i24 + 8 >> 2]);
 f41 = Math_fround(f33 + f33);
 f31 = Math_fround(HEAPF32[i24 + 12 >> 2]);
 f28 = Math_fround(f43 * f31);
 f40 = Math_fround(f44 * f31);
 f31 = Math_fround(f31 * f41);
 f43 = Math_fround(f30 * f43);
 f42 = Math_fround(f30 * f44);
 f30 = Math_fround(f30 * f41);
 f44 = Math_fround(f36 * f44);
 f36 = Math_fround(f36 * f41);
 f41 = Math_fround(f33 * f41);
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f44) - f41);
 HEAPF32[i19 + 4 >> 2] = Math_fround(f42 + f31);
 HEAPF32[i19 + 8 >> 2] = Math_fround(f30 - f40);
 HEAPF32[i19 + 12 >> 2] = Math_fround(f42 - f31);
 f43 = Math_fround(Math_fround(1.0) - f43);
 HEAPF32[i19 + 16 >> 2] = Math_fround(f43 - f41);
 HEAPF32[i19 + 20 >> 2] = Math_fround(f36 + f28);
 HEAPF32[i19 + 24 >> 2] = Math_fround(f30 + f40);
 HEAPF32[i19 + 28 >> 2] = Math_fround(f36 - f28);
 HEAPF32[i19 + 32 >> 2] = Math_fround(f43 - f44);
 HEAP32[i19 + 36 >> 2] = HEAP32[i24 + 16 >> 2];
 HEAP32[i19 + 40 >> 2] = HEAP32[i24 + 20 >> 2];
 HEAP32[i19 + 44 >> 2] = HEAP32[i24 + 24 >> 2];
 f44 = Math_fround(HEAPF32[i25 >> 2]);
 f43 = Math_fround(f44 + f44);
 f28 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f36 = Math_fround(f28 + f28);
 f40 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f30 = Math_fround(f40 + f40);
 f41 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f31 = Math_fround(f43 * f41);
 f42 = Math_fround(f36 * f41);
 f41 = Math_fround(f41 * f30);
 f43 = Math_fround(f44 * f43);
 f33 = Math_fround(f44 * f36);
 f44 = Math_fround(f44 * f30);
 f36 = Math_fround(f28 * f36);
 f28 = Math_fround(f28 * f30);
 f30 = Math_fround(f40 * f30);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f36) - f30);
 HEAPF32[i20 + 4 >> 2] = Math_fround(f33 + f41);
 HEAPF32[i20 + 8 >> 2] = Math_fround(f44 - f42);
 HEAPF32[i20 + 12 >> 2] = Math_fround(f33 - f41);
 f43 = Math_fround(Math_fround(1.0) - f43);
 HEAPF32[i20 + 16 >> 2] = Math_fround(f43 - f30);
 HEAPF32[i20 + 20 >> 2] = Math_fround(f28 + f31);
 HEAPF32[i20 + 24 >> 2] = Math_fround(f44 + f42);
 HEAPF32[i20 + 28 >> 2] = Math_fround(f28 - f31);
 HEAPF32[i20 + 32 >> 2] = Math_fround(f43 - f36);
 HEAP32[i20 + 36 >> 2] = HEAP32[i25 + 16 >> 2];
 HEAP32[i20 + 40 >> 2] = HEAP32[i25 + 20 >> 2];
 HEAP32[i20 + 44 >> 2] = HEAP32[i25 + 24 >> 2];
 f36 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f43 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f31 = Math_fround(f36 + f43);
 f28 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f44 = Math_fround(f28 + f42);
 f30 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f41 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f31 = Math_fround(f31 * Math_fround(.5));
 f44 = Math_fround(f44 * Math_fround(.5));
 f33 = Math_fround(Math_fround(f30 + f41) * Math_fround(.5));
 f40 = Math_fround(HEAPF32[i14 >> 2]);
 f27 = Math_fround(f31 * f40);
 f38 = Math_fround(HEAPF32[i4 >> 2]);
 f32 = Math_fround(f31 * f38);
 f35 = Math_fround(HEAPF32[i6 >> 2]);
 f31 = Math_fround(f31 * f35);
 f39 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f46 = Math_fround(f44 * f39);
 f37 = Math_fround(HEAPF32[i7 >> 2]);
 f45 = Math_fround(f44 * f37);
 f29 = Math_fround(HEAPF32[i8 >> 2]);
 f46 = Math_fround(f27 + f46);
 f45 = Math_fround(f32 + f45);
 f44 = Math_fround(f31 + Math_fround(f44 * f29));
 f31 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f32 = Math_fround(f33 * f31);
 f27 = Math_fround(HEAPF32[i9 >> 2]);
 f34 = Math_fround(f33 * f27);
 f26 = Math_fround(HEAPF32[i11 >> 2]);
 f32 = Math_fround(f46 + f32);
 f34 = Math_fround(f45 + f34);
 f33 = Math_fround(f44 + Math_fround(f33 * f26));
 f36 = Math_fround(Math_fround(f43 - f36) * Math_fround(.5));
 f28 = Math_fround(Math_fround(f42 - f28) * Math_fround(.5));
 f30 = Math_fround(Math_fround(f41 - f30) * Math_fround(.5));
 f31 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f36 * f40))) + Math_fround(Math_abs(Math_fround(f28 * f39)))) + Math_fround(Math_abs(Math_fround(f30 * f31))));
 f27 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f36 * f38))) + Math_fround(Math_abs(Math_fround(f28 * f37)))) + Math_fround(Math_abs(Math_fround(f30 * f27))));
 f26 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f36 * f35))) + Math_fround(Math_abs(Math_fround(f28 * f29)))) + Math_fround(Math_abs(Math_fround(f30 * f26))));
 f30 = Math_fround(f34 - f27);
 f29 = Math_fround(f33 - f26);
 f28 = Math_fround(f32 + f31);
 f27 = Math_fround(f34 + f27);
 f26 = Math_fround(f33 + f26);
 HEAPF32[i16 >> 2] = Math_fround(f32 - f31);
 HEAPF32[i16 + 4 >> 2] = f30;
 HEAPF32[i16 + 8 >> 2] = f29;
 HEAPF32[i16 + 12 >> 2] = f28;
 HEAPF32[i16 + 16 >> 2] = f27;
 HEAPF32[i16 + 20 >> 2] = f26;
 __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb(i17, i16, Math_fround(0.0), i24, i19, i20, i18, i3);
 HEAP32[i15 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP32[i15 + 4 >> 2] = i10 + 48;
 HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 36 >> 2];
 __ZN27ConvexVsMeshOverlapCallbackC2ERKN5physx2Gu10ConvexMeshERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_bRKNS1_3BoxE(i13, i1, i12, i18, i24, i25, i3, i17);
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i17, 1, i15, i13, 0);
 STACKTOP = i21;
 return (HEAP8[i13 + 432 >> 0] | 0) != 0 | 0;
}

function __ZN12SoundManager6UpdateEv(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 8 | 0;
 i19 = i22;
 i17 = i22 + 24 | 0;
 i18 = i22 + 12 | 0;
 i1 = HEAP32[i21 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i21 | 0)) do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  i5 = i4 + 164 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i3 | 0) {
   i6 = i4 + 148 | 0;
   i2 = HEAP16[i6 >> 1] | 0;
   if (i2 & 512) {
    i15 = (__ZN4FMOD7Channel11setPositionEjj(i3, HEAP32[i4 + 116 >> 2] | 0, 2) | 0) == 0;
    i2 = HEAP16[i6 >> 1] | 0;
    i3 = i2 & -513;
    if (i15) {
     HEAP16[i6 >> 1] = i3;
     i2 = i3;
    }
   }
   if (i2 & 1024) if (!(__ZN4FMOD7Channel11setPositionEjj(HEAP32[i5 >> 2] | 0, HEAP32[i4 + 120 >> 2] | 0, 1) | 0)) HEAP16[i6 >> 1] = HEAP16[i6 >> 1] & -1025;
  }
  i2 = i1;
 } while ((i2 | 0) != (i21 | 0));
 i1 = HEAP32[i21 + 12 >> 2] | 0;
 i12 = i21 + 8 | 0;
 i2 = i1;
 if ((i2 | 0) == (i12 | 0)) i6 = 0; else {
  i13 = i21 + 16 | 0;
  i14 = i18 + 11 | 0;
  i15 = i18 + 11 | 0;
  i3 = 0;
  while (1) {
   i3 = i3 + 1 | 0;
   i11 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i11 = HEAP32[i11 + 8 >> 2] | 0;
   i10 = i11 + 112 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   __ZN11SoundHandle8Instance15UpdateLoadStateEv(i11);
   L18 : do if (i11 | 0) {
    switch (HEAP32[i11 + 44 >> 2] | 0) {
    case 3:
     break;
    case 4:
     {
      i2 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
      i5 = i11 + 116 | 0;
      if (HEAP8[i5 >> 0] | 0) break L18;
      i4 = i2 + 24 | 0;
      if ((i11 | 0) != (i4 | 0)) {
       i2 = HEAP32[i11 >> 2] | 0;
       if (!i2) i2 = i11 + 4 | 0; else {
        i10 = i11 + 4 | 0;
        HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
        HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
        HEAP32[i11 >> 2] = 0;
        HEAP32[i10 >> 2] = 0;
        i2 = i10;
       }
       i10 = HEAP32[i4 >> 2] | 0;
       HEAP32[i11 >> 2] = i10;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i10 + 4 >> 2] = i11;
       HEAP32[HEAP32[i2 >> 2] >> 2] = i11;
      }
      HEAP8[i5 >> 0] = 1;
      break L18;
     }
    default:
     break L18;
    }
    i4 = HEAP32[i11 + 100 >> 2] | 0;
    i8 = i11 + 96 | 0;
    if ((i4 | 0) != (i8 | 0)) {
     i9 = i11 + 40 | 0;
     i10 = i11 + 52 | 0;
     i2 = 1;
     i7 = i4;
     do {
      i6 = i7;
      i7 = HEAP32[i4 + 4 >> 2] | 0;
      HEAP32[i17 >> 2] = 0;
      i5 = i6 + 8 | 0;
      L35 : do if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 239 >> 0] | 0)) {
       i2 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
       i2 = __ZN4FMOD6System9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE(i2, -1, HEAP32[i9 >> 2] | 0, 1, i17) | 0;
       i4 = HEAP32[i17 >> 2] | 0;
       if (!((i2 | 0) != 0 | (i4 | 0) == 0)) {
        __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE(HEAP32[i5 >> 2] | 0, i4);
        i2 = HEAP32[i5 >> 2] | 0;
        i4 = HEAP32[i2 + 164 >> 2] | 0;
        if (i4 | 0) {
         __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE(i2 + 4 | 0, i4);
         __ZN20SoundChannelInstance12UpdateVolumeEv(i2);
         __ZN20SoundChannelInstance11UpdatePitchEv(i2);
         __ZN20SoundChannelInstance16UpdatePauseStateEv(i2);
         i2 = HEAP32[i2 + 240 >> 2] | 0;
         if (i2 | 0) __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i2, 0);
        }
        __ZN20SoundChannelInstance12UpdateVolumeEv(HEAP32[i5 >> 2] | 0);
        __ZN20SoundChannelInstance16UpdatePauseStateEv(HEAP32[i5 >> 2] | 0);
        i2 = 0;
        i16 = 32;
        break;
       }
       switch (i2 | 0) {
       case 10:
        {
         i2 = HEAP32[i10 >> 2] | 0;
         if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 864656 | 0, 0, gb + 853741 | 0, 1078, 512, i2, 0, 0);
         i2 = 0;
         break L35;
        }
       case 54:
        {
         HEAP32[i19 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT_486(54) | 0;
         __Z6FormatPKcz(i18, gb + 857699 | 0, i19);
         i2 = HEAP32[i10 >> 2] | 0;
         if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 853741 | 0, 1083, 512, i2, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
         i2 = 0;
         break L35;
        }
       default:
        {
         HEAP32[i20 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
         __Z6FormatPKcz(i18, gb + 864711 | 0, i20);
         i2 = HEAP32[i10 >> 2] | 0;
         if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 853741 | 0, 1088, 1, i2, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
         i2 = 0;
         break L35;
        }
       }
      } else i16 = 32; while (0);
      if ((i16 | 0) == 32) {
       i16 = 0;
       i4 = HEAP32[i6 >> 2] | 0;
       if (i4) {
        i5 = i6 + 4 | 0;
        HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
        HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
        HEAP32[i6 >> 2] = 0;
        HEAP32[i5 >> 2] = 0;
       }
      }
      i4 = i7;
     } while ((i4 | 0) != (i8 | 0));
     if (i2) {
      i2 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
      i5 = i11 + 116 | 0;
      if (HEAP8[i5 >> 0] | 0) break;
      i4 = i2 + 24 | 0;
      if ((i11 | 0) != (i4 | 0)) {
       i2 = HEAP32[i11 >> 2] | 0;
       if (!i2) i2 = i11 + 4 | 0; else {
        i10 = i11 + 4 | 0;
        HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
        HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
        HEAP32[i11 >> 2] = 0;
        HEAP32[i10 >> 2] = 0;
        i2 = i10;
       }
       i10 = HEAP32[i4 >> 2] | 0;
       HEAP32[i11 >> 2] = i10;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i10 + 4 >> 2] = i11;
       HEAP32[HEAP32[i2 >> 2] >> 2] = i11;
      }
      HEAP8[i5 >> 0] = 1;
      break;
     }
    }
    if ((i11 | 0) != (i13 | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     if (!i2) i2 = i11 + 4 | 0; else {
      i10 = i11 + 4 | 0;
      HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
      HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      i2 = i10;
     }
     i10 = HEAP32[i13 >> 2] | 0;
     HEAP32[i11 >> 2] = i10;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i10 + 4 >> 2] = i11;
     HEAP32[HEAP32[i2 >> 2] >> 2] = i11;
    }
   } while (0);
   i2 = i1;
   if ((i2 | 0) == (i12 | 0)) {
    i6 = i3;
    break;
   }
  }
 }
 i1 = HEAP32[i21 + 28 >> 2] | 0;
 i5 = i21 + 24 | 0;
 i2 = i1;
 L79 : do if ((i2 | 0) == (i5 | 0)) {
  i3 = 0;
  i4 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  do {
   while (1) {
    i4 = i4 + 1 | 0;
    i20 = i1;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = HEAP32[i20 + 8 >> 2] | 0;
    if (((HEAP32[i2 + 44 >> 2] | 0) + -3 | 0) >>> 0 >= 2) break;
    __ZN11SoundHandle8InstanceD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
    i2 = i1;
    if ((i2 | 0) == (i5 | 0)) break L79;
   }
   i3 = i3 + 1 | 0;
   __ZN11SoundHandle8Instance15UpdateLoadStateEv(i2);
   i2 = i1;
  } while ((i2 | 0) != (i5 | 0));
 } while (0);
 i5 = i21 + 16 | 0;
 i1 = HEAP32[i21 + 20 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i19 = 0;
  i20 = i21 + 36 | 0;
  HEAP32[i20 >> 2] = i19;
  i20 = i21 + 32 | 0;
  HEAP32[i20 >> 2] = i6;
  i20 = i21 + 40 | 0;
  HEAP32[i20 >> 2] = i4;
  i21 = i21 + 44 | 0;
  HEAP32[i21 >> 2] = i3;
  STACKTOP = i22;
  return;
 } else {
  i2 = i1;
  i1 = 0;
 }
 do {
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i5 | 0));
 i20 = i21 + 36 | 0;
 HEAP32[i20 >> 2] = i1;
 i20 = i21 + 32 | 0;
 HEAP32[i20 >> 2] = i6;
 i20 = i21 + 40 | 0;
 HEAP32[i20 >> 2] = i4;
 i21 = i21 + 44 | 0;
 HEAP32[i21 >> 2] = i3;
 STACKTOP = i22;
 return;
}

function __ZN9ShaderLab14SerializedPass8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 i9 = i15 + 4 | 0;
 __ZN9ShaderLab14SerializedPass16CreateNamesTableEv(i11);
 i1 = HEAP32[i11 + 868 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i13 = i12 + 16 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i14 = i12 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
 i3 = i11 + 864 | 0;
 i1 = HEAP32[i11 + 860 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   __ZN15SerializeTraitsINSt3__24pairI8UnityStriEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i2 + 16 | 0, i12);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 __ZN9ShaderLab21SerializedShaderState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 4 | 0, i12);
 i1 = i11 + 724 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
 }
 i5 = i11 + 740 | 0;
 i8 = i11 + 744 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 192 | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i3 + 4 | 0;
 if (i7 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i13 >> 2] = i7;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 752 | 0;
 i7 = i11 + 756 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 192 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i13 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 764 | 0;
 i7 = i11 + 768 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 192 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i13 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 776 | 0;
 i7 = i11 + 780 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 192 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i13 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 788 | 0;
 i7 = i11 + 792 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 192 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i13 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP8[i9 >> 0] = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i9, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 i6 = i11 + 800 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i11 + 804 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 i6 = i11 + 816 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i11 + 820 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 i6 = i11 + 832 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i11 + 836 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i10, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i10 = i2 << 24 >> 24 < 0;
 i1 = i10 ? HEAP32[i6 >> 2] | 0 : i6;
 i10 = i10 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i10 | 0;
 if (!i10) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
  i14 = i11 + 848 | 0;
  __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i14, i12);
  STACKTOP = i15;
  return;
 }
 do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 i14 = i11 + 848 | 0;
 __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i14, i12);
 STACKTOP = i15;
 return;
}

function __ZN11JpegDecoder11InitDecoderEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = 4;
 i11 = _malloc(40) | 0;
 HEAP32[i11 >> 2] = 0;
 __THREW__ = 0;
 i3 = invoke_ii(fb + 1570 | 0, 432) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
  if (!i2) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i2 = -1;
 i1 = getTempRet0() | 0;
 if ((i2 | 0) == 1) {
  i8 = 0;
  i7 = 0;
 } else {
  _memset(i3 | 0, 0, 432) | 0;
  i5 = i9 + 32 | 0;
  HEAP32[i5 >> 2] = i3;
  __THREW__ = 0;
  i3 = invoke_ii(fb + 1570 | 0, 288) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) {
   i8 = 0;
   i7 = i5;
  } else {
   _memset(i3 | 0, 0, 288) | 0;
   i4 = i9 + 36 | 0;
   HEAP32[i4 >> 2] = i3;
   __THREW__ = 0;
   i2 = invoke_ii(fb + 1571 | 0, i3 | 0) | 0;
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
    if (!i3) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i3 = -1;
   i1 = getTempRet0() | 0;
   if ((i3 | 0) == 1) {
    i8 = i4;
    i7 = i5;
   } else {
    HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 >> 2] = fb + 3368;
    i11 = _saveSetjmp(i1 + 132 | 0, 1, i11 | 0, i10 | 0) | 0;
    i10 = getTempRet0() | 0;
    __THREW__ = 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i8 = i4;
     i7 = i5;
    } else {
     i8 = i4;
     i7 = i5;
     i1 = 0;
    }
   }
  }
 }
 while (1) {
  if (i1 | 0) {
   HEAP8[i9 + 4 >> 0] = 1;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(fb + 3369 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i5 = i7;
     i6 = i8;
     i7 = i5;
     i8 = i6;
     continue;
    }
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(fb + 3370 | 0, i1 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) {
      i5 = i7;
      i6 = i8;
      i7 = i5;
      i8 = i6;
      continue;
     }
    }
   }
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) {
    i1 = 15;
    break;
   }
   __THREW__ = 0;
   invoke_vi(fb + 3370 | 0, i1 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i7;
    i6 = i8;
    i7 = i5;
    i8 = i6;
    continue;
   } else {
    i1 = 14;
    break;
   }
  }
  __THREW__ = 0;
  invoke_viii(fb + 503 | 0, HEAP32[i7 >> 2] | 0, 62, 432);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) {
   i5 = i7;
   i6 = i8;
   i7 = i5;
   i8 = i6;
   continue;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = i9 + 16 | 0;
  i4 = i1 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) {
   __THREW__ = 0;
   i2 = invoke_iiii(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 0, 65572) | 0;
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
    if (!i3) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i3 = -1;
   i1 = getTempRet0() | 0;
   if ((i3 | 0) == 1) {
    i5 = i7;
    i6 = i8;
    i7 = i5;
    i8 = i6;
    continue;
   }
   HEAP32[i4 >> 2] = i2;
  }
  HEAP32[i2 + 28 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = fb + 3371;
  HEAP32[i2 + 12 >> 2] = fb + 1572;
  HEAP32[i2 + 16 >> 2] = fb + 2401;
  HEAP32[i2 + 20 >> 2] = fb + 512;
  HEAP32[i2 + 24 >> 2] = fb + 3372;
  i5 = i2 + 32 | 0;
  __THREW__ = 0;
  i3 = invoke_iiii(HEAP32[i9 + 20 >> 2] | 0, HEAP32[i6 >> 2] | 0, i5 | 0, 65536) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i4 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   if (!i4) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i4 = -1;
  i1 = getTempRet0() | 0;
  if ((i4 | 0) == 1) {
   i5 = i7;
   i6 = i8;
   i7 = i5;
   i8 = i6;
   continue;
  }
  if (i3 >>> 0 < 65536) {
   HEAP8[i2 + 32 + i3 >> 0] = -1;
   HEAP8[i3 + 1 + (i2 + 32) >> 0] = -39;
   i1 = i3 + 2 | 0;
  } else i1 = i3;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i1;
  __THREW__ = 0;
  i4 = invoke_iii(fb + 557 | 0, HEAP32[i7 >> 2] | 0, 1) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) {
   i5 = i7;
   i6 = i8;
   i7 = i5;
   i8 = i6;
   continue;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i9 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 28 >> 2];
  i6 = HEAP32[i1 + 32 >> 2] | 0;
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = i6;
  if (!((i4 | 0) != 1 | (i6 | 0) == 0)) {
   i1 = 34;
   break;
  }
  HEAP8[i9 + 4 >> 0] = 1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  if (i1 | 0) {
   __THREW__ = 0;
   invoke_vi(fb + 3369 | 0, i1 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i7;
    i6 = i8;
    i7 = i5;
    i8 = i6;
    continue;
   }
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vi(fb + 3370 | 0, i1 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i5 = i7;
     i6 = i8;
     i7 = i5;
     i8 = i6;
     continue;
    }
   }
  }
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) {
   i1 = 33;
   break;
  }
  __THREW__ = 0;
  invoke_vi(fb + 3370 | 0, i1 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i1 = 32;
   break;
  } else {
   i5 = i7;
   i6 = i8;
   i7 = i5;
   i8 = i6;
  }
 }
 if ((i1 | 0) == 14) i1 = 15; else if ((i1 | 0) == 32) i1 = 33; else if ((i1 | 0) == 34) {
  _free(i11 | 0);
  return;
 }
 if ((i1 | 0) == 15) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  _free(i11 | 0);
  return;
 } else if ((i1 | 0) == 33) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  _free(i11 | 0);
  return;
 }
}

function __ZN5physx23AggregateAABBUpdateTask11runInternalEv(i35) {
 i35 = i35 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36;
 i2 = HEAP32[i35 + 52 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(0.0);
  i34 = ~~f1 >>> 0;
  i35 = i35 + 56 | 0;
  HEAP32[i35 >> 2] = i34;
  STACKTOP = i36;
  return;
 }
 i30 = i35 + 20 | 0;
 i3 = HEAP32[i30 >> 2] | 0;
 i31 = HEAP32[i3 + 368 >> 2] | 0;
 i32 = HEAP32[i3 + 12 >> 2] | 0;
 i29 = HEAP32[i3 + 300 >> 2] | 0;
 i4 = HEAP32[i35 + 48 >> 2] | 0;
 i19 = i4 + i2 | 0;
 if (i4 >>> 0 >= i19 >>> 0) {
  f1 = Math_fround(0.0);
  i34 = ~~f1 >>> 0;
  i35 = i35 + 56 | 0;
  HEAP32[i35 >> 2] = i34;
  STACKTOP = i36;
  return;
 }
 i20 = i35 + 44 | 0;
 i21 = i33 + 12 | 0;
 i22 = i33 + 4 | 0;
 i23 = i33 + 8 | 0;
 i24 = i21 + 4 | 0;
 i25 = i21 + 8 | 0;
 i26 = i33 + 16 | 0;
 i27 = i33 + 20 | 0;
 i28 = i35 + 36 | 0;
 i2 = i4;
 f1 = Math_fround(0.0);
 while (1) {
  i17 = HEAP32[i31 + (i2 << 2) >> 2] | 0;
  i18 = HEAP32[i3 + 180 >> 2] | 0;
  if (!(HEAP8[i18 + (i17 * 1048 | 0) + 1024 >> 0] | 0)) if (!(HEAP32[(HEAP32[i3 + 232 >> 2] | 0) + (i17 >>> 5 << 2) >> 2] & 1 << (i17 & 31))) {
   i4 = HEAP32[i18 + (i17 * 1048 | 0) + 1032 >> 2] | 0;
   if ((i4 | 0) != 1073741823) {
    i5 = HEAP32[i3 + 308 >> 2] | 0;
    i6 = i3 + 316 | 0;
    i7 = i3 + 312 | 0;
    do {
     if ((HEAP32[i5 + (i4 << 2) >> 2] | 0) != 1073741823) HEAP32[(HEAP32[i20 >> 2] | 0) + ((HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0) >>> 1 << 2) >> 2] = i4;
     i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    } while ((i4 | 0) != 1073741823);
   }
   i5 = HEAP32[i18 + (i17 * 1048 | 0) + 1040 >> 2] | 0;
   if ((i5 | 0) == 1073741823) {
    i8 = -25165825;
    i7 = -25165825;
    i6 = -25165825;
    i5 = 2122317823;
    i4 = 2122317823;
    i3 = 2122317823;
   } else {
    i16 = 2122317823;
    i4 = 2122317823;
    i15 = 2122317823;
    i6 = -25165825;
    i7 = -25165825;
    i8 = -25165825;
    while (1) {
     i13 = HEAP8[(HEAP32[i3 + 252 >> 2] | 0) + i5 >> 0] | 0;
     if (!(i13 << 24 >> 24)) {
      i9 = i15;
      i10 = i16;
     } else {
      i10 = (HEAP32[i3 + 248 >> 2] | 0) + (i5 * 24 | 0) | 0;
      i14 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i5 << 2) >> 2] | 0;
      i9 = HEAP32[(HEAP32[i3 + 320 >> 2] | 0) + (i14 << 2) >> 2] | 0;
      if (!(HEAP32[(HEAP32[i3 + 308 >> 2] | 0) + (i14 << 2) >> 2] | 0)) i34 = 21; else {
       i11 = HEAP32[i3 + 344 >> 2] | 0;
       i12 = HEAP32[i11 + (i9 << 4) + 4 >> 2] | 0;
       if (!i12) i34 = 21; else f1 = Math_fround(f1 + Math_fround(__ZN5physx14PxsComputeAABBEbPKNS_12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_((HEAP8[i28 >> 0] | 0) != 0, i12, HEAP32[i11 + (i9 << 4) + 8 >> 2] | 0, i10, i33)));
      }
      if ((i34 | 0) == 21) {
       i34 = 0;
       __ZN5physx14PxsComputeAABBEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS3_(HEAP32[(HEAP32[i3 + 332 >> 2] | 0) + (i9 << 3) + 4 >> 2] | 0, i10, i33);
      }
      if (i13 << 24 >> 24 == 1) {
       i3 = HEAP32[i33 >> 2] | 0;
       i9 = HEAP32[i22 >> 2] | 0;
       i10 = HEAP32[i23 >> 2] | 0;
       i11 = HEAP32[i21 >> 2] | 0;
       i12 = HEAP32[i24 >> 2] | 0;
       i13 = HEAP32[i25 >> 2] | 0;
       HEAP32[i29 + (i14 * 24 | 0) >> 2] = ((i3 | 0) < 0 ? ~i3 : i3 | -2147483648) + -16 & -16;
       HEAP32[i29 + (i14 * 24 | 0) + 4 >> 2] = ((i9 | 0) < 0 ? ~i9 : i9 | -2147483648) + -16 & -16;
       HEAP32[i29 + (i14 * 24 | 0) + 8 >> 2] = ((i10 | 0) < 0 ? ~i10 : i10 | -2147483648) + -16 & -16;
       HEAP32[i29 + (i14 * 24 | 0) + 12 >> 2] = ((i11 | 0) < 0 ? ~i11 : i11 | -2147483648) + 16 & -16 | 1;
       HEAP32[i29 + (i14 * 24 | 0) + 16 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + 16 & -16 | 1;
       HEAP32[i29 + (i14 * 24 | 0) + 20 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + 16 & -16 | 1;
      }
      f37 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f38 = Math_fround(HEAPF32[i33 >> 2]);
      f39 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f40 = Math_fround(HEAPF32[i22 >> 2]);
      f41 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f42 = Math_fround(HEAPF32[i23 >> 2]);
      i10 = (HEAPF32[tempDoublePtr >> 2] = f37 < f38 ? f37 : f38, HEAP32[tempDoublePtr >> 2] | 0);
      i4 = (HEAPF32[tempDoublePtr >> 2] = f39 < f40 ? f39 : f40, HEAP32[tempDoublePtr >> 2] | 0);
      i9 = (HEAPF32[tempDoublePtr >> 2] = f41 < f42 ? f41 : f42, HEAP32[tempDoublePtr >> 2] | 0);
      f42 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f41 = Math_fround(HEAPF32[i21 >> 2]);
      f40 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f39 = Math_fround(HEAPF32[i26 >> 2]);
      f38 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f37 = Math_fround(HEAPF32[i27 >> 2]);
      i6 = (HEAPF32[tempDoublePtr >> 2] = f42 > f41 ? f42 : f41, HEAP32[tempDoublePtr >> 2] | 0);
      i7 = (HEAPF32[tempDoublePtr >> 2] = f40 > f39 ? f40 : f39, HEAP32[tempDoublePtr >> 2] | 0);
      i3 = HEAP32[i30 >> 2] | 0;
      i8 = (HEAPF32[tempDoublePtr >> 2] = f38 > f37 ? f38 : f37, HEAP32[tempDoublePtr >> 2] | 0);
     }
     i5 = HEAP32[(HEAP32[i3 + 256 >> 2] | 0) + (i5 << 2) >> 2] | 0;
     if ((i5 | 0) == 1073741823) {
      i5 = i9;
      i3 = i10;
      break;
     } else {
      i16 = i10;
      i15 = i9;
     }
    }
   }
   i18 = HEAP32[i18 + (i17 * 1048 | 0) + 1028 >> 2] | 0;
   HEAP32[i32 + (i18 * 24 | 0) >> 2] = ((i3 | 0) < 0 ? ~i3 : i3 | -2147483648) + -16 & -16;
   HEAP32[i32 + (i18 * 24 | 0) + 4 >> 2] = ((i4 | 0) < 0 ? ~i4 : i4 | -2147483648) + -16 & -16;
   HEAP32[i32 + (i18 * 24 | 0) + 8 >> 2] = ((i5 | 0) < 0 ? ~i5 : i5 | -2147483648) + -16 & -16;
   HEAP32[i32 + (i18 * 24 | 0) + 12 >> 2] = ((i6 | 0) < 0 ? ~i6 : i6 | -2147483648) + 16 & -16 | 1;
   HEAP32[i32 + (i18 * 24 | 0) + 16 >> 2] = ((i7 | 0) < 0 ? ~i7 : i7 | -2147483648) + 16 & -16 | 1;
   HEAP32[i32 + (i18 * 24 | 0) + 20 >> 2] = ((i8 | 0) < 0 ? ~i8 : i8 | -2147483648) + 16 & -16 | 1;
  } else i34 = 6; else i34 = 6;
  if ((i34 | 0) == 6) {
   i34 = 0;
   i9 = HEAP32[i18 + (i17 * 1048 | 0) + 1032 >> 2] | 0;
   if ((i9 | 0) == 1073741823) {
    i8 = 8388608;
    i7 = -8388609;
    i6 = -8388609;
    i5 = 8388608;
    i4 = 8388608;
    i3 = -8388609;
   } else {
    i11 = HEAP32[i3 + 308 >> 2] | 0;
    i10 = HEAP32[i3 + 316 >> 2] | 0;
    i6 = -8388609;
    i7 = -8388609;
    i3 = -8388609;
    i4 = 8388608;
    i5 = 8388608;
    i8 = 8388608;
    do {
     if ((HEAP32[i11 + (i9 << 2) >> 2] | 0) != 1073741823) {
      i16 = HEAP32[i29 + (i9 * 24 | 0) >> 2] | 0;
      i15 = HEAP32[i29 + (i9 * 24 | 0) + 4 >> 2] | 0;
      i14 = HEAP32[i29 + (i9 * 24 | 0) + 8 >> 2] | 0;
      i13 = HEAP32[i29 + (i9 * 24 | 0) + 12 >> 2] | 0;
      i12 = HEAP32[i29 + (i9 * 24 | 0) + 16 >> 2] | 0;
      i43 = HEAP32[i29 + (i9 * 24 | 0) + 20 >> 2] | 0;
      i8 = i8 >>> 0 < i43 >>> 0 ? i43 : i8;
      i5 = i5 >>> 0 < i12 >>> 0 ? i12 : i5;
      i4 = i4 >>> 0 < i13 >>> 0 ? i13 : i4;
      i3 = i3 >>> 0 < i14 >>> 0 ? i3 : i14;
      i7 = i7 >>> 0 < i15 >>> 0 ? i7 : i15;
      i6 = i6 >>> 0 < i16 >>> 0 ? i6 : i16;
     }
     i9 = HEAP32[i10 + (i9 << 2) >> 2] | 0;
    } while ((i9 | 0) != 1073741823);
   }
   i43 = HEAP32[i18 + (i17 * 1048 | 0) + 1028 >> 2] | 0;
   HEAP32[i32 + (i43 * 24 | 0) >> 2] = i6;
   HEAP32[i32 + (i43 * 24 | 0) + 4 >> 2] = i7;
   HEAP32[i32 + (i43 * 24 | 0) + 8 >> 2] = i3;
   HEAP32[i32 + (i43 * 24 | 0) + 12 >> 2] = i4;
   HEAP32[i32 + (i43 * 24 | 0) + 16 >> 2] = i5;
   HEAP32[i32 + (i43 * 24 | 0) + 20 >> 2] = i8;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i19 | 0)) break;
  i3 = HEAP32[i30 >> 2] | 0;
 }
 i34 = ~~f1 >>> 0;
 i43 = i35 + 56 | 0;
 HEAP32[i43 >> 2] = i34;
 STACKTOP = i36;
 return;
}

function __ZL25CullAllPerObjectLightsJobP29CullAllPerObjectLightsJobDataj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i39;
 i1 = i39 + 4 | 0;
 if ((HEAP16[gb + 1114464 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i38 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114464 | 0, i38);
  i32 = gb + 1114464 | 0;
 } else i32 = 0;
 i1 = HEAP32[i3 + 172 + (i2 * 12 | 0) >> 2] | 0;
 i37 = HEAP32[i3 + 172 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i33 = HEAP32[i3 + 24 >> 2] | 0;
 i35 = HEAP16[i3 + 32 >> 1] | 0;
 i34 = (i35 & 255) << 24 >> 24 != 0;
 i35 = (i35 & 65535) > 255;
 i36 = HEAP32[i3 + 44 + (i2 << 2) >> 2] | 0;
 i28 = HEAP32[i3 + 108 + (i2 << 2) >> 2] | 0;
 if ((i1 | 0) < (i37 + i1 | 0)) {
  i29 = HEAP32[i3 + 20 >> 2] | 0;
  i30 = i36 + 12 | 0;
  i31 = i3 + 8 | 0;
  i27 = (HEAP32[i3 + 28 >> 2] | 0) != 0;
  i22 = i33 + 24 | 0;
  i23 = i33 + 28 | 0;
  i24 = i33 + 32 | 0;
  i25 = i33 + 36 | 0;
  i26 = i33 + 40 | 0;
  i21 = 0;
  while (1) {
   i19 = HEAP32[i30 >> 2] | 0;
   i11 = HEAP32[i29 >> 2] | 0;
   i16 = i11 + (i1 * 360 | 0) | 0;
   if (!(HEAP32[(HEAP32[i31 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) HEAP32[i28 + (i21 << 2) >> 2] = i19; else {
    i17 = 1 << HEAP32[i11 + (i1 * 360 | 0) + 240 >> 2];
    i15 = (HEAPU16[i11 + (i1 * 360 | 0) + 224 >> 1] | 0) < 65534;
    i15 = i15 | i27 & (__Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i16, i34, i35) | 0);
    i20 = HEAP32[i30 >> 2] | 0;
    i18 = i11 + (i1 * 360 | 0) + 128 | 0;
    i12 = HEAP32[i18 >> 2] | 0;
    i13 = HEAP32[i11 + (i1 * 360 | 0) + 132 >> 2] | 0;
    i14 = HEAP32[i11 + (i1 * 360 | 0) + 136 >> 2] | 0;
    i7 = HEAP32[i22 >> 2] | 0;
    if (!i7) i3 = 0; else {
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (i15) {
      i2 = 0;
      do {
       i10 = HEAP32[i33 >> 2] | 0;
       if (!((HEAP32[i10 + (i2 * 180 | 0) + 12 >> 2] | 0) == 1 ? 1 : (HEAP32[i10 + (i2 * 180 | 0) + 16 >> 2] & i17 | 0) == 0)) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i2, i36);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i7 | 0));
      i3 = i7;
     } else {
      i2 = 0;
      do {
       if (HEAP32[(HEAP32[i33 >> 2] | 0) + (i2 * 180 | 0) + 16 >> 2] & i17 | 0) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i2, i36);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i7 | 0));
      i3 = i7;
     }
    }
    i7 = (HEAP32[i23 >> 2] | 0) + i7 | 0;
    if (i3 >>> 0 < i7 >>> 0) {
     i2 = i11 + (i1 * 360 | 0) + 152 | 0;
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     do {
      if (!(__ZL17IsSpotLightCulledRK11ActiveLightibRK4AABBS4_RK10Matrix4x4f((HEAP32[i33 >> 2] | 0) + (i3 * 180 | 0) | 0, i17, i15, i18, i2, i16) | 0)) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i3, i36);
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
     i3 = i7;
    }
    i9 = (HEAP32[i24 >> 2] | 0) + i7 | 0;
    if (i3 >>> 0 < i9 >>> 0) {
     i7 = i11 + (i1 * 360 | 0) + 152 | 0;
     i8 = i11 + (i1 * 360 | 0) + 176 | 0;
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (i15) {
      do {
       i2 = HEAP32[i33 >> 2] | 0;
       if (!((HEAP32[i2 + (i3 * 180 | 0) + 12 >> 2] | 0) == 1 ? 1 : (HEAP32[i2 + (i3 * 180 | 0) + 16 >> 2] & i17 | 0) == 0)) {
        i2 = i2 + (i3 * 180 | 0) + 152 | 0;
        if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i18, i2) | 0) if (__Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere(i7, i16, HEAP32[i8 >> 2] | 0, i2) | 0) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i3, i36);
       }
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i9 | 0));
      i3 = i9;
     } else {
      do {
       i2 = HEAP32[i33 >> 2] | 0;
       if (HEAP32[i2 + (i3 * 180 | 0) + 16 >> 2] & i17 | 0) {
        i2 = i2 + (i3 * 180 | 0) + 152 | 0;
        if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i18, i2) | 0) if (__Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere(i7, i16, HEAP32[i8 >> 2] | 0, i2) | 0) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i3, i36);
       }
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i9 | 0));
      i3 = i9;
     }
    }
    i10 = HEAP32[i30 >> 2] | 0;
    i7 = (HEAP32[i25 >> 2] | 0) + i9 | 0;
    if (i3 >>> 0 < i7 >>> 0) {
     i2 = i11 + (i1 * 360 | 0) + 152 | 0;
     f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     do {
      if (!(__ZL17IsSpotLightCulledRK11ActiveLightibRK4AABBS4_RK10Matrix4x4f((HEAP32[i33 >> 2] | 0) + (i3 * 180 | 0) | 0, i17, i15, i18, i2, i16) | 0)) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f4, f5, f6, i3, i36);
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
     i3 = i7;
    }
    i8 = (HEAP32[i26 >> 2] | 0) + i7 | 0;
    if (i3 >>> 0 < i8 >>> 0) {
     i9 = i11 + (i1 * 360 | 0) + 152 | 0;
     i7 = i11 + (i1 * 360 | 0) + 176 | 0;
     f6 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (i15) do {
      i2 = HEAP32[i33 >> 2] | 0;
      if (!((HEAP32[i2 + (i3 * 180 | 0) + 12 >> 2] | 0) == 1 ? 1 : (HEAP32[i2 + (i3 * 180 | 0) + 16 >> 2] & i17 | 0) == 0)) {
       i2 = i2 + (i3 * 180 | 0) + 152 | 0;
       if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i18, i2) | 0) if (__Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere(i9, i16, HEAP32[i7 >> 2] | 0, i2) | 0) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f6, f5, f4, i3, i36);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i8 | 0)); else do {
      i2 = HEAP32[i33 >> 2] | 0;
      if (HEAP32[i2 + (i3 * 180 | 0) + 16 >> 2] & i17 | 0) {
       i2 = i2 + (i3 * 180 | 0) + 152 | 0;
       if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i18, i2) | 0) if (__Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere(i9, i16, HEAP32[i7 >> 2] | 0, i2) | 0) __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i33, f6, f5, f4, i3, i36);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i8 | 0));
    }
    i2 = HEAP32[i30 >> 2] | 0;
    if ((i2 | 0) != (i20 | 0)) {
     i18 = HEAP32[i36 >> 2] | 0;
     __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_(i18 + (i20 << 3) | 0, i18 + (i2 << 3) | 0, i38);
    }
    HEAP32[i28 + (i21 << 2) >> 2] = ((i2 | 0) != (i10 | 0) ? -2147483648 : 0) | i19;
   }
   i21 = i21 + 1 | 0;
   if ((i21 | 0) == (i37 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 if (!i32) {
  STACKTOP = i39;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i32);
 STACKTOP = i39;
 return;
}

function __ZN14ParticleSystem20SetParticlesExternalEP22ParticleSystemParticlei(i29, i8, i10) {
 i29 = i29 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i31 + 16 | 0;
 i27 = i31;
 i28 = i29 + 40 | 0;
 i4 = HEAP32[i28 >> 2] | 0;
 HEAP8[i4 + 26 >> 0] = 1;
 i9 = (i10 | 0) == 0;
 if (i9) {
  i1 = i4;
  i2 = 0;
 } else {
  i2 = i4 + 392 | 0;
  i1 = 0;
  do {
   i26 = i8 + (i1 * 120 | 0) + 104 | 0;
   i25 = i8 + (i1 * 120 | 0) + 108 | 0;
   f3 = Math_fround(HEAPF32[i25 >> 2]);
   i24 = f3 < Math_fround(HEAPF32[i26 >> 2]);
   HEAP32[i26 >> 2] = HEAP32[(i24 ? i25 : i26) >> 2];
   i26 = i8 + (i1 * 120 | 0) + 84 | 0;
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   i25 = f3 < Math_fround(HEAPF32[i26 >> 2]);
   i26 = HEAP32[(i25 ? i26 : i2) >> 2] | 0;
   HEAP32[i2 >> 2] = i26;
   i25 = i8 + (i1 * 120 | 0) + 88 | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i26 = f3 < Math_fround(HEAPF32[i25 >> 2]);
   i25 = HEAP32[(i26 ? i25 : i2) >> 2] | 0;
   HEAP32[i2 >> 2] = i25;
   i26 = i8 + (i1 * 120 | 0) + 92 | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i25 = f3 < Math_fround(HEAPF32[i26 >> 2]);
   HEAP32[i2 >> 2] = HEAP32[(i25 ? i26 : i2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
  i2 = (i10 | 0) != 0;
  if ((HEAP8[i4 + 28 >> 0] | 0) == 0 & i2) {
   i6 = i29 + 32 | 0;
   i5 = 0;
   i1 = i4;
   do {
    if (Math_fround(HEAPF32[i8 + (i5 * 120 | 0) + 60 >> 2]) != Math_fround(0.0)) i7 = 10; else if (Math_fround(HEAPF32[i8 + (i5 * 120 | 0) + 64 >> 2]) != Math_fround(0.0)) i7 = 10; else if (Math_fround(HEAPF32[i8 + (i5 * 120 | 0) + 72 >> 2]) != Math_fround(0.0)) i7 = 10; else if (Math_fround(HEAPF32[i8 + (i5 * 120 | 0) + 76 >> 2]) != Math_fround(0.0)) i7 = 10;
    if ((i7 | 0) == 10) {
     i7 = 0;
     i4 = HEAP32[i6 >> 2] | 0;
     if (!(HEAP8[i4 + 870 >> 0] | 0)) {
      __ZN23ParticleSystemParticles17SetUses3DRotationEv(i4);
      i1 = HEAP32[i28 >> 2] | 0;
     }
     HEAP8[i1 + 28 >> 0] = 1;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i10 | 0));
  } else i1 = i4;
 }
 i5 = i29 + 32 | 0;
 if ((HEAP8[i1 + 29 >> 0] | 0) == 0 & i2) {
  i4 = 0;
  do {
   f3 = Math_fround(HEAPF32[i8 + (i4 * 120 | 0) + 84 >> 2]);
   if (f3 != Math_fround(HEAPF32[i8 + (i4 * 120 | 0) + 88 >> 2])) i7 = 17; else if (f3 != Math_fround(HEAPF32[i8 + (i4 * 120 | 0) + 92 >> 2])) i7 = 17;
   if ((i7 | 0) == 17) {
    i7 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!(HEAP8[i2 + 871 >> 0] | 0)) {
     __ZN23ParticleSystemParticles13SetUses3DSizeEv(i2);
     i1 = HEAP32[i28 >> 2] | 0;
    }
    HEAP8[i1 + 29 >> 0] = 1;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i10 | 0));
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP8[i1 + 868 >> 0] | 0)) {
  __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(i1, 2);
 i26 = HEAP32[i5 >> 2] | 0;
 __ZN23ParticleSystemParticles13array_reserveEj(i26, i10 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i26, i10);
 __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii(i26, i8, i10, 0);
 if (i9) i1 = 0; else {
  i16 = i26 + 520 | 0;
  i17 = i27 + 4 | 0;
  i18 = i27 + 8 | 0;
  i19 = i27 + 12 | 0;
  i20 = i29 + 36 | 0;
  i21 = i30 + 4 | 0;
  i22 = i30 + 8 | 0;
  i23 = i30 + 12 | 0;
  i24 = i30 + 16 | 0;
  i25 = i30 + 20 | 0;
  i1 = i10;
  i8 = 0;
  i2 = i10;
  i4 = 0;
  i5 = 2;
  i6 = 3;
  i7 = 1;
  do {
   i15 = (HEAP32[i16 >> 2] | 0) + (i8 << 2) | 0;
   f33 = Math_fround(HEAPF32[i15 >> 2]);
   f32 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f3 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   i13 = (f33 > Math_fround(100.0)) << 31 >> 31;
   i12 = (f32 > Math_fround(100.0)) << 31 >> 31;
   i14 = (f3 > Math_fround(100.0)) << 31 >> 31;
   i15 = (Math_fround(HEAPF32[i15 + 12 >> 2]) > Math_fround(100.0)) << 31 >> 31;
   i13 = (i4 | 0) < (i2 | 0) ? i13 : 0;
   i12 = (i7 | 0) < (i2 | 0) ? i12 : 0;
   i14 = (i5 | 0) < (i2 | 0) ? i14 : 0;
   i15 = (i6 | 0) < (i2 | 0) ? i15 : 0;
   HEAP32[i27 >> 2] = i13;
   HEAP32[i17 >> 2] = i12;
   HEAP32[i18 >> 2] = i14;
   HEAP32[i19 >> 2] = i15;
   if ((i12 | i13 | i14 | i15 | 0) > -1) {
    i8 = i8 + 4 | 0;
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
    i7 = i7 + 4 | 0;
   } else {
    i15 = 3;
    while (1) {
     if (HEAP32[i27 + (i15 << 2) >> 2] | 0) {
      i9 = HEAP32[i20 >> 2] | 0;
      i10 = HEAP32[i28 >> 2] | 0;
      i11 = i15 + i8 | 0;
      i12 = i10 + 428 | 0;
      if (HEAP32[i12 >> 2] | 0) {
       i13 = i10 + 496 | 0;
       i14 = i10 + 424 | 0;
       i2 = 0;
       do {
        i34 = HEAP32[i13 >> 2] | 0;
        HEAPF32[i30 >> 2] = Math_fround(0.0);
        HEAPF32[i21 >> 2] = Math_fround(0.0);
        HEAP32[i22 >> 2] = i34;
        i34 = (Math_imul(i34, 1812433253) | 0) + 1 | 0;
        HEAP32[i23 >> 2] = i34;
        i34 = (Math_imul(i34, 1812433253) | 0) + 1 | 0;
        HEAP32[i24 >> 2] = i34;
        HEAP32[i25 >> 2] = (Math_imul(i34, 1812433253) | 0) + 1;
        __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i30, (HEAP32[i14 >> 2] | 0) + (i2 * 600 | 0) | 0, i9, i10, i26, 2, i2, i11, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
        i2 = i2 + 1 | 0;
       } while (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
      }
      i1 = i1 + -1 | 0;
      __ZN23ParticleSystemParticles14element_assignEjj(i26, i11, i1);
     }
     if ((i15 | 0) > 0) i15 = i15 + -1 | 0; else {
      i2 = i1;
      break;
     }
    }
   }
  } while (i8 >>> 0 < i1 >>> 0);
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i26, i1);
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i29, i26, HEAP32[i28 >> 2] | 0);
 i1 = i29 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 80260 | 0) | 0;
 if (!i2) {
  STACKTOP = i31;
  return;
 }
 i34 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i29, i34, i1 + 52 | 0, i1 + 244 | 0, i1 + 304 | 0, i1 + 316 | 0);
 i1 = HEAP32[i28 >> 2] | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i1 + 52 | 0, i1 + 180 | 0) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i1 + 368 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 380 >> 2]);
 f40 = Math_fround(f3 + f35);
 f32 = Math_fround(HEAPF32[i1 + 372 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 384 >> 2]);
 f39 = Math_fround(f32 + f37);
 f33 = Math_fround(HEAPF32[i1 + 376 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 388 >> 2]);
 f39 = Math_fround(f39 * Math_fround(.5));
 f38 = Math_fround(Math_fround(f33 + f36) * Math_fround(.5));
 HEAPF32[i30 >> 2] = Math_fround(f40 * Math_fround(.5));
 HEAPF32[i30 + 4 >> 2] = f39;
 HEAPF32[i30 + 8 >> 2] = f38;
 f32 = Math_fround(Math_fround(f37 - f32) * Math_fround(.5));
 f33 = Math_fround(Math_fround(f36 - f33) * Math_fround(.5));
 HEAPF32[i30 + 12 >> 2] = Math_fround(Math_fround(f35 - f3) * Math_fround(.5));
 HEAPF32[i30 + 16 >> 2] = f32;
 HEAPF32[i30 + 20 >> 2] = f33;
 if ((HEAP32[(HEAP32[i29 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1) __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i30, i1 + 52 | 0, i30);
 i34 = i2 + 568 | 0;
 HEAP32[i34 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i34 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i34 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 HEAP32[i34 + 16 >> 2] = HEAP32[i30 + 16 >> 2];
 HEAP32[i34 + 20 >> 2] = HEAP32[i30 + 20 >> 2];
 __ZN8Renderer18UpdateManagerStateEb(i2, 1);
 STACKTOP = i31;
 return;
}

function __ZN16Physics2DManager14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEji(i1, i55, i56, i57, i58, i2) {
 i1 = i1 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, f73 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i54 + 72 | 0;
 i51 = i54 + 56 | 0;
 i52 = i54 + 48 | 0;
 i53 = i54 + 8 | 0;
 i31 = i54;
 i32 = i55 + 12 | 0;
 if (!(HEAP32[i32 >> 2] | 0)) {
  STACKTOP = i54;
  return;
 }
 i26 = i50 + 4 | 0;
 i28 = i50 + 8 | 0;
 i30 = i50 + 12 | 0;
 i24 = i50 + 16 | 0;
 i25 = i50 + 20 | 0;
 i27 = i50 + 24 | 0;
 i29 = i50 + 28 | 0;
 i33 = i50 + 16 | 0;
 i34 = i51 + 4 | 0;
 i35 = i51 + 8 | 0;
 i36 = i51 + 12 | 0;
 i37 = i52 + 4 | 0;
 i38 = i31 + 4 | 0;
 f39 = Math_fround(HEAPF32[gb + 62460 >> 2]);
 f40 = Math_fround(-f39);
 i41 = i53 + 32 | 0;
 i42 = i57 + 12 | 0;
 i43 = i57 + 16 | 0;
 i44 = i57 + 4 | 0;
 i45 = i53 + 4 | 0;
 i46 = i53 + 16 | 0;
 i47 = i53 + 20 | 0;
 i23 = 0;
 do {
  i12 = HEAP32[i55 >> 2] | 0;
  f69 = Math_fround(HEAPF32[i12 + (i23 << 7) + 64 >> 2]);
  i48 = i12 + (i23 << 7) + 16 | 0;
  f69 = Math_fround(f69 - Math_fround(HEAPF32[i48 >> 2]));
  f68 = Math_fround(HEAPF32[i12 + (i23 << 7) + 68 >> 2]);
  f68 = Math_fround(f68 - Math_fround(HEAPF32[i12 + (i23 << 7) + 20 >> 2]));
  f67 = Math_fround(HEAPF32[i12 + (i23 << 7) + 72 >> 2]);
  f67 = Math_fround(f67 - Math_fround(HEAPF32[i12 + (i23 << 7) + 24 >> 2]));
  f66 = Math_fround(HEAPF32[i12 + (i23 << 7) + 76 >> 2]);
  f66 = Math_fround(f66 - Math_fround(HEAPF32[i12 + (i23 << 7) + 28 >> 2]));
  f73 = Math_fround(HEAPF32[i12 + (i23 << 7) + 80 >> 2]);
  i49 = i12 + (i23 << 7) + 32 | 0;
  f73 = Math_fround(f73 - Math_fround(HEAPF32[i49 >> 2]));
  f72 = Math_fround(HEAPF32[i12 + (i23 << 7) + 84 >> 2]);
  f72 = Math_fround(f72 - Math_fround(HEAPF32[i12 + (i23 << 7) + 36 >> 2]));
  f71 = Math_fround(HEAPF32[i12 + (i23 << 7) + 88 >> 2]);
  f71 = Math_fround(f71 - Math_fround(HEAPF32[i12 + (i23 << 7) + 40 >> 2]));
  f70 = Math_fround(HEAPF32[i12 + (i23 << 7) + 92 >> 2]);
  f70 = Math_fround(f70 - Math_fround(HEAPF32[i12 + (i23 << 7) + 44 >> 2]));
  f62 = Math_fround(Math_fround(f69 * f69) + Math_fround(f73 * f73));
  f61 = Math_fround(Math_fround(f68 * f68) + Math_fround(f72 * f72));
  f60 = Math_fround(Math_fround(f67 * f67) + Math_fround(f71 * f71));
  f59 = Math_fround(Math_fround(f66 * f66) + Math_fround(f70 * f70));
  f16 = Math_fround(Math_sqrt(Math_fround(f62)));
  f65 = Math_fround(Math_fround(1.0) / f16);
  f17 = Math_fround(Math_sqrt(Math_fround(f61)));
  f64 = Math_fround(Math_fround(1.0) / f17);
  f18 = Math_fround(Math_sqrt(Math_fround(f60)));
  f63 = Math_fround(Math_fround(1.0) / f18);
  f19 = Math_fround(Math_sqrt(Math_fround(f59)));
  f20 = Math_fround(Math_fround(1.0) / f19);
  f69 = Math_fround(f69 * f65);
  f68 = Math_fround(f68 * f64);
  f67 = Math_fround(f67 * f63);
  f66 = Math_fround(f66 * f20);
  f65 = Math_fround(f73 * f65);
  f64 = Math_fround(f72 * f64);
  f63 = Math_fround(f71 * f63);
  f20 = Math_fround(f70 * f20);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f69, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f68, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f67, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = f62 > Math_fround(9.99999974e-06);
  i7 = f61 > Math_fround(9.99999974e-06);
  i8 = f60 > Math_fround(9.99999974e-06);
  i9 = f59 > Math_fround(9.99999974e-06);
  i21 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) : 0;
  HEAP32[i50 >> 2] = i6 ? i10 : 0;
  HEAP32[i26 >> 2] = i7 ? i11 : 0;
  HEAP32[i28 >> 2] = i8 ? i1 : 0;
  HEAP32[i30 >> 2] = i9 ? i2 : 0;
  HEAP32[i24 >> 2] = i6 ? i3 : 0;
  HEAP32[i25 >> 2] = i7 ? i4 : 0;
  HEAP32[i27 >> 2] = i8 ? i5 : 0;
  HEAP32[i29 >> 2] = i21;
  HEAPF32[i51 >> 2] = f16;
  HEAPF32[i34 >> 2] = f17;
  HEAPF32[i35 >> 2] = f18;
  HEAPF32[i36 >> 2] = f19;
  i21 = i12 + (i23 << 7) | 0;
  i22 = i12 + (i23 << 7) + 48 | 0;
  i3 = i12 + (i23 << 7) + 112 | 0;
  i1 = 0;
  do {
   i4 = i21 + (i1 << 2) | 0;
   if ((HEAP32[i4 >> 2] | 0) >>> 0 < i56 >>> 0) {
    i5 = HEAP32[i48 + (i1 << 2) >> 2] | 0;
    i6 = HEAP32[i49 + (i1 << 2) >> 2] | 0;
    i7 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
    i8 = HEAP32[i50 + (i1 << 2) >> 2] | 0;
    i9 = HEAP32[i33 + (i1 << 2) >> 2] | 0;
    HEAP32[i52 >> 2] = i8;
    HEAP32[i37 >> 2] = i9;
    HEAP32[i31 >> 2] = i5;
    HEAP32[i38 >> 2] = i6;
    f73 = Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]);
    if ((__ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di(0, i31, f73, i52, Math_fround(HEAPF32[i51 + (i1 << 2) >> 2]), i58, f40, f39, 0, 0, i53, 1) | 0) > 0) {
     i10 = HEAP32[i41 >> 2] | 0;
     if (!i10) i15 = 0; else i15 = __ZNK10Collider2D20GetAttachedRigidbodyEb(i10, 0) | 0;
     i11 = HEAP32[i42 >> 2] | 0;
     i12 = i11 + 1 | 0;
     i13 = HEAP32[i43 >> 2] | 0;
     i14 = i13 & 2147483647;
     do if (i12 >>> 0 > i14 >>> 0) {
      i2 = i13 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i14 >>> 0 < i2 >>> 0) if ((i13 | 0) > -1) {
       HEAP32[i43 >> 2] = i2;
       HEAP32[i57 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i57 >> 2] | 0, i2 * 60 | 0, 4, i44, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 60 | 0, 4, i44, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i14 | 0, HEAP32[i57 >> 2] | 0, (HEAP32[i42 >> 2] | 0) * 60 | 0) | 0;
       HEAP32[i43 >> 2] = i2;
       HEAP32[i57 >> 2] = i14;
       break;
      }
     } while (0);
     HEAP32[i42 >> 2] = i12;
     i14 = HEAP32[i57 >> 2] | 0;
     HEAP32[i14 + (i11 * 60 | 0) >> 2] = HEAP32[i4 >> 2];
     HEAP32[i14 + (i11 * 60 | 0) + 4 >> 2] = i5;
     HEAP32[i14 + (i11 * 60 | 0) + 8 >> 2] = i6;
     HEAP32[i14 + (i11 * 60 | 0) + 12 >> 2] = i7;
     HEAP32[i14 + (i11 * 60 | 0) + 16 >> 2] = i8;
     HEAP32[i14 + (i11 * 60 | 0) + 20 >> 2] = i9;
     HEAPF32[i14 + (i11 * 60 | 0) + 24 >> 2] = Math_fround(0.0);
     f71 = Math_fround(HEAPF32[i53 >> 2]);
     f73 = Math_fround(HEAPF32[i45 >> 2]);
     i12 = HEAP32[i46 >> 2] | 0;
     i13 = HEAP32[i47 >> 2] | 0;
     HEAP32[i14 + (i11 * 60 | 0) + 28 >> 2] = i12;
     HEAP32[i14 + (i11 * 60 | 0) + 32 >> 2] = i13;
     HEAPF32[i14 + (i11 * 60 | 0) + 36 >> 2] = Math_fround(0.0);
     i10 = i10 + 4 | 0;
     HEAP32[i14 + (i11 * 60 | 0) + 52 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i14 + (i11 * 60 | 0) + 56 >> 2] = HEAP32[((i15 | 0) == 0 ? i10 : i15 + 4 | 0) >> 2];
     f70 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(9.99999997e-07));
     f72 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(9.99999997e-07));
     HEAPF32[i14 + (i11 * 60 | 0) + 40 >> 2] = Math_fround(f70 + f71);
     HEAPF32[i14 + (i11 * 60 | 0) + 44 >> 2] = Math_fround(f72 + f73);
     HEAPF32[i14 + (i11 * 60 | 0) + 48 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4);
  i23 = i23 + 1 | 0;
 } while (i23 >>> 0 < (HEAP32[i32 >> 2] | 0) >>> 0);
 STACKTOP = i54;
 return;
}

function __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorINS_10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEE(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i34 + 8 | 0;
 i20 = i34;
 i33 = i34 + 104 | 0;
 i23 = i34 + 80 | 0;
 i24 = i34 + 60 | 0;
 i25 = i34 + 40 | 0;
 if ((HEAP16[gb + 1459056 + 6 >> 1] | 0) > -1) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i31 >> 2] = HEAP32[i20 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459056 | 0, i31);
  i32 = gb + 1459056 | 0;
 } else i32 = 0;
 i3 = (HEAP32[i17 + 4 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0;
 i18 = (i3 | 0) / 40 | 0;
 HEAP32[i33 >> 2] = 0;
 i30 = i33 + 4 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i33 + 8 >> 2] = 0;
 HEAP32[i33 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7reserveEj(i33, 12);
 i22 = gb + 64016 | 0;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i21;
 HEAP32[i23 >> 2] = 0;
 i1 = i23 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i21 = i23 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i20);
 i19 = i31;
 i26 = HEAP32[i19 + 4 >> 2] | 0;
 i27 = i22;
 HEAP32[i27 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 i27 = gb + 64016 | 0;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i19 = i20;
 HEAP32[i19 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i19 + 4 >> 2] = i26;
 HEAP32[i24 >> 2] = 0;
 i19 = i24 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i26 = i24 + 16 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i20);
 i4 = i31;
 i28 = HEAP32[i4 + 4 >> 2] | 0;
 i29 = i27;
 HEAP32[i29 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i29 + 4 >> 2] = i28;
 i29 = gb + 64016 | 0;
 i28 = HEAP32[i29 + 4 >> 2] | 0;
 i4 = i20;
 HEAP32[i4 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i4 + 4 >> 2] = i28;
 HEAP32[i25 >> 2] = 0;
 i4 = i25 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i28 = i25 + 16 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, i20);
 i14 = i31;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i2 = i29;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i2 + 4 >> 2] = i15;
 i2 = HEAP32[i21 >> 2] | 0;
 do if ((i2 & 2147483646) >>> 0 < 6) if ((i2 | 0) > -1) {
  HEAP32[i21 >> 2] = 6;
  HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, 72, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i23 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i21 >> 2] = 6;
  HEAP32[i23 >> 2] = i15;
  break;
 } while (0);
 i1 = HEAP32[i26 >> 2] | 0;
 do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
  HEAP32[i26 >> 2] = 32;
  HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, 384, 4, i27, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i27, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i26 >> 2] = 32;
  HEAP32[i24 >> 2] = i15;
  break;
 } while (0);
 i1 = HEAP32[i28 >> 2] | 0;
 do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
  HEAP32[i28 >> 2] = 32;
  HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, 384, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i25 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i28 >> 2] = 32;
  HEAP32[i25 >> 2] = i15;
  break;
 } while (0);
 if (!i3) i4 = 0; else {
  i13 = i16 + 12 | 0;
  i14 = i16 + 40 | 0;
  i15 = i16 + 52 | 0;
  i4 = 0;
  i12 = 0;
  do {
   i1 = HEAP32[i17 >> 2] | 0;
   i9 = HEAP32[i13 >> 2] | 0;
   if (i9) {
    i10 = i1 + (i12 * 40 | 0) + 32 | 0;
    i11 = i1 + (i12 * 40 | 0) + 20 | 0;
    i8 = i1 + (i12 * 40 | 0) | 0;
    i7 = 0;
    i1 = 0;
    do {
     i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     HEAP32[i20 >> 2] = i3;
     i5 = HEAP32[i10 >> 2] | 0;
     L30 : do if (i5) {
      i6 = HEAP32[i11 >> 2] | 0;
      i2 = 0;
      while (1) {
       if ((HEAP32[i6 + (i2 << 2) >> 2] | 0) == (i3 | 0)) break;
       i2 = i2 + 1 | 0;
       if (i2 >>> 0 >= i5 >>> 0) break L30;
      }
      __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i16, i24, (HEAP32[i16 >> 2] | 0) + (i7 * 26 | 0) | 0);
      __ZNK11DynamicMesh12IntersectionER13dynamic_arrayI8Vector3fLj4EERKS0_I5PlaneLj4EES3_Ph(i16, i24, i8, i25, i31);
      if (HEAP32[i19 >> 2] | 0) {
       __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i16, i23, (HEAP32[i16 >> 2] | 0) + (i7 * 26 | 0) | 0);
       __ZNK11DynamicMesh8SubtractERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEERKS4_RS4_SC_PKhRKS2_I5PlaneLj4EE(i16, i33, i23, i24, i25, i31, i8);
       __ZN11DynamicMesh13MergePolygonsERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(0, i33);
       if ((i7 | 0) != (i1 | 0)) {
        i3 = HEAP32[i16 >> 2] | 0;
        i2 = i3 + (i7 * 26 | 0) | 0;
        i3 = i3 + (i1 * 26 | 0) | 0;
        i4 = i2 + 26 | 0;
        do {
         HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
         i2 = i2 + 2 | 0;
         i3 = i3 + 2 | 0;
        } while ((i2 | 0) < (i4 | 0));
        i6 = HEAP32[i14 >> 2] | 0;
        HEAP32[i6 + (i7 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
       }
       i1 = i1 + 1 | 0;
       i2 = HEAP32[i33 >> 2] | 0;
       if ((HEAP32[i30 >> 2] | 0) == (i2 | 0)) i4 = 1; else {
        i3 = 0;
        do {
         __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij(i16, i2 + (i3 * 20 | 0) | 0, i20, 1);
         i3 = i3 + 1 | 0;
         i2 = HEAP32[i33 >> 2] | 0;
        } while (i3 >>> 0 < (((HEAP32[i30 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0);
        i4 = 1;
       }
      }
     } while (0);
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i9 | 0));
    if (i1) {
     i11 = HEAP32[i16 >> 2] | 0;
     _memmove(i11 | 0, i11 + (i1 * 26 | 0) | 0, ((HEAP32[i13 >> 2] | 0) - i1 | 0) * 26 | 0) | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) - ((i1 * 26 | 0) / 26 | 0);
     i11 = HEAP32[i14 >> 2] | 0;
     _memmove(i11 | 0, i11 + (i1 << 2) | 0, (HEAP32[i15 >> 2] | 0) - i1 << 2 | 0) | 0;
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) - (i1 << 2 >> 2);
    }
   }
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < i18 >>> 0);
 }
 if ((HEAP32[i28 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i29);
  HEAP32[i25 >> 2] = 0;
 }
 if ((HEAP32[i26 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i27);
  HEAP32[i24 >> 2] = 0;
 }
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i22);
  HEAP32[i23 >> 2] = 0;
 }
 i1 = HEAP32[i33 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i30 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i30 >> 2] = i3;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i2 = HEAP32[i30 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i33 >> 2] | 0;
  }
  i33 = HEAP32[i33 + 12 >> 2] | 0;
  HEAP32[i31 >> 2] = 1;
  HEAP32[i31 + 4 >> 2] = i33;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i31);
 }
 if (!i32) {
  STACKTOP = i34;
  return i4 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i32);
 STACKTOP = i34;
 return i4 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i1, i18, i19, i2, i20, i16) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i13 = i17 + 208 | 0;
 i22 = i17 + 192 | 0;
 i21 = i17 + 180 | 0;
 i14 = i17 + 176 | 0;
 i10 = i17 + 16 | 0;
 i11 = i17 + 8 | 0;
 i12 = i17 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i22 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2804 | 0, i2 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 do if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i23 = 36;
 } else {
  HEAP32[i21 >> 2] = i1;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i21 | 0, gb + 1474588 | 0) | 0;
  i9 = __THREW__;
  __THREW__ = 0;
  if (!(i9 & 1)) {
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, gb + 1077991 | 0, gb + 1077991 + 26 | 0, i13 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (!(i9 & 1)) {
    __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i21 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i9 = i21 + 11 | 0;
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i21 | 0, i1 | 0, 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i1 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
     HEAP32[i14 >> 2] = i1;
     HEAP32[i11 >> 2] = i10;
     HEAP32[i12 >> 2] = 0;
     i6 = i21 + 4 | 0;
     i7 = i21 + 8 | 0;
     i3 = HEAP32[i18 >> 2] | 0;
     L21 : while (1) {
      if (!i3) {
       i8 = 0;
       i3 = 1;
      } else {
       i2 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
        i8 = __THREW__;
        __THREW__ = 0;
        if (i8 & 1) {
         i23 = 38;
         break;
        }
       } else i2 = HEAP32[i2 >> 2] | 0;
       if ((i2 | 0) == -1) {
        HEAP32[i18 >> 2] = 0;
        i8 = 0;
        i3 = 1;
       } else {
        i8 = i3;
        i3 = 0;
       }
      }
      i4 = HEAP32[i19 >> 2] | 0;
      do if (!i4) i23 = 26; else {
       i2 = HEAP32[i4 + 12 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
        __THREW__ = 0;
        i2 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
        i5 = __THREW__;
        __THREW__ = 0;
        if (i5 & 1) {
         i23 = 38;
         break L21;
        }
       } else i2 = HEAP32[i2 >> 2] | 0;
       if ((i2 | 0) == -1) {
        HEAP32[i19 >> 2] = 0;
        i23 = 26;
        break;
       } else if (i3) break; else {
        i23 = 48;
        break L21;
       }
      } while (0);
      if ((i23 | 0) == 26) {
       i23 = 0;
       if (i3) {
        i4 = 0;
        i23 = 48;
        break;
       } else i4 = 0;
      }
      i2 = HEAP8[i9 >> 0] | 0;
      i2 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
      if ((HEAP32[i14 >> 2] | 0) == (i1 + i2 | 0)) {
       __THREW__ = 0;
       invoke_viii(fb + 1039 | 0, i21 | 0, i2 << 1 | 0, 0);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i23 = 40;
        break;
       }
       if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i7 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
       __THREW__ = 0;
       invoke_viii(fb + 1039 | 0, i21 | 0, i1 | 0, 0);
       i5 = __THREW__;
       __THREW__ = 0;
       if (i5 & 1) {
        i23 = 40;
        break;
       }
       i1 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
       HEAP32[i14 >> 2] = i1 + i2;
      }
      i3 = i8 + 12 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      i5 = i8 + 16 | 0;
      if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
       __THREW__ = 0;
       i2 = invoke_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (i24 & 1) {
        i23 = 38;
        break;
       }
      } else i2 = HEAP32[i2 >> 2] | 0;
      if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i2, 16, i1, i14, i12, 0, i22, i10, i11, i13) | 0) {
       i23 = 48;
       break;
      }
      i2 = HEAP32[i3 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (i24 & 1) {
        i23 = 38;
        break;
       } else {
        i3 = i8;
        continue;
       }
      } else {
       HEAP32[i3 >> 2] = i2 + 4;
       i3 = i8;
       continue;
      }
     }
     if ((i23 | 0) == 38) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i23 | 0) == 40) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i23 | 0) == 48) {
      __THREW__ = 0;
      invoke_viii(fb + 1039 | 0, i21 | 0, (HEAP32[i14 >> 2] | 0) - i1 | 0, 0);
      i24 = __THREW__;
      __THREW__ = 0;
      L62 : do if (!(i24 & 1)) {
       i1 = HEAP8[i9 >> 0] | 0;
       i2 = HEAP32[i21 >> 2] | 0;
       __THREW__ = 0;
       i3 = invoke_i(fb + 314 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (!(i24 & 1)) {
        __THREW__ = 0;
        HEAP32[i15 >> 2] = i16;
        i1 = invoke_iiiii(fb + 200 | 0, (i1 << 24 >> 24 < 0 ? i2 : i21) | 0, i3 | 0, gb + 1078024 | 0, i15 | 0) | 0;
        i24 = __THREW__;
        __THREW__ = 0;
        if (!(i24 & 1)) {
         if ((i1 | 0) != 1) HEAP32[i20 >> 2] = 4;
         if (!i8) i2 = 1; else {
          i1 = HEAP32[i8 + 12 >> 2] | 0;
          if ((i1 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) {
           __THREW__ = 0;
           i1 = invoke_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
           i24 = __THREW__;
           __THREW__ = 0;
           if (i24 & 1) break;
          } else i1 = HEAP32[i1 >> 2] | 0;
          if ((i1 | 0) == -1) {
           HEAP32[i18 >> 2] = 0;
           i2 = 1;
          } else i2 = 0;
         }
         do if (!i4) i23 = 65; else {
          i1 = HEAP32[i4 + 12 >> 2] | 0;
          if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
           __THREW__ = 0;
           i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
           i24 = __THREW__;
           __THREW__ = 0;
           if (i24 & 1) break L62;
          } else i1 = HEAP32[i1 >> 2] | 0;
          if ((i1 | 0) == -1) {
           HEAP32[i19 >> 2] = 0;
           i23 = 65;
           break;
          } else if (i2) break; else {
           i23 = 67;
           break;
          }
         } while (0);
         if ((i23 | 0) == 65) if (i2) i23 = 67;
         if ((i23 | 0) == 67) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 2;
         i24 = HEAP32[i18 >> 2] | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
         STACKTOP = i17;
         return i24 | 0;
        }
       }
      } while (0);
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    break;
   }
  }
  i23 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  i1 = i23;
  i23 = 36;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN7mecanim5human16RetargetFromTDoFEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3EPNS0_9HumanPoseEPS8_SG_(i10, i1, i11, i12, i13, i14) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i15 = i10 + 40 | 0;
 i16 = i15;
 i17 = i14 + 4 | 0;
 i18 = i17;
 i4 = i1 + 4 | 0;
 i5 = i4;
 i6 = i10 + 360 | 0;
 i1 = 0;
 do {
  i7 = i12 + 804 + (i1 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i12 + 804 + (i1 * 12 | 0) + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i12 + 804 + (i1 * 12 | 0) + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  i2 = HEAP32[i10 + 72 + (HEAP32[gb + 177756 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  i3 = HEAP32[i10 + 72 + (HEAP32[gb + 177784 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  if ((i2 | 0) != -1 & (i3 | 0) != -1) {
   i40 = HEAP32[i15 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i40 | 0) == 0 ? 0 : i40 + i16 | 0, i13, i14, i2, -1);
   i40 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
   i41 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
   i39 = HEAP32[i41 + (i2 * 40 | 0) + 4 >> 2] | 0;
   i42 = HEAP32[i41 + (i2 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i40 + (i2 * 40 | 0) >> 2] = HEAP32[i41 + (i2 * 40 | 0) >> 2];
   HEAP32[i40 + (i2 * 40 | 0) + 4 >> 2] = i39;
   HEAP32[i40 + (i2 * 40 | 0) + 8 >> 2] = i42;
   i42 = HEAP32[i41 + (i2 * 40 | 0) + 16 >> 2] | 0;
   i39 = HEAP32[i41 + (i2 * 40 | 0) + 20 >> 2] | 0;
   i25 = HEAP32[i41 + (i2 * 40 | 0) + 24 >> 2] | 0;
   HEAP32[i40 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i41 + (i2 * 40 | 0) + 12 >> 2];
   HEAP32[i40 + (i2 * 40 | 0) + 16 >> 2] = i42;
   HEAP32[i40 + (i2 * 40 | 0) + 20 >> 2] = i39;
   HEAP32[i40 + (i2 * 40 | 0) + 24 >> 2] = i25;
   i25 = HEAP32[i41 + (i2 * 40 | 0) + 32 >> 2] | 0;
   i39 = HEAP32[i41 + (i2 * 40 | 0) + 36 >> 2] | 0;
   HEAP32[i40 + (i2 * 40 | 0) + 28 >> 2] = HEAP32[i41 + (i2 * 40 | 0) + 28 >> 2];
   HEAP32[i40 + (i2 * 40 | 0) + 32 >> 2] = i25;
   HEAP32[i40 + (i2 * 40 | 0) + 36 >> 2] = i39;
   i40 = HEAP32[i15 >> 2] | 0;
   __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i40 | 0) == 0 ? 0 : i40 + i16 | 0, i14, i13, i2, -1);
   i40 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
   f35 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) >> 2]);
   f32 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 4 >> 2]);
   f29 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 8 >> 2]);
   f27 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 12 >> 2]);
   f21 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 16 >> 2]);
   f33 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 20 >> 2]);
   f34 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 24 >> 2]);
   f24 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 28 >> 2]);
   f20 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 32 >> 2]);
   f22 = Math_fround(HEAPF32[i40 + (i3 * 40 | 0) + 36 >> 2]);
   i39 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
   i25 = i39 + 16 | 0;
   i39 = i39 + 4 | 0;
   i3 = HEAP32[i39 + (HEAP32[i39 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   i25 = i25 + (HEAP32[i25 >> 2] | 0) | 0;
   f31 = Math_fround(HEAPF32[i25 + (i3 * 76 | 0) + 16 >> 2]);
   f28 = Math_fround(HEAPF32[i25 + (i3 * 76 | 0) + 20 >> 2]);
   f38 = Math_fround(HEAPF32[i25 + (i3 * 76 | 0) + 24 >> 2]);
   f36 = Math_fround(HEAPF32[i25 + (i3 * 76 | 0) + 28 >> 2]);
   f26 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f31) - Math_fround(f34 * f38)) - Math_fround(f33 * f36)) - Math_fround(f27 * f28));
   f30 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f36) - Math_fround(f27 * f31)) - Math_fround(f33 * f38)) - Math_fround(f21 * f28));
   f19 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f28) - Math_fround(f21 * f38)) - Math_fround(f34 * f31)) - Math_fround(f27 * f36));
   f36 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f38) - Math_fround(f33 * f31)) - Math_fround(f34 * f28)) - Math_fround(f21 * f36));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i39 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f36 = (HEAP32[tempDoublePtr >> 2] = i25 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f19 = Math_fround(f36 * f36);
   f26 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(f26 * f26);
   f28 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f28 * f28)) + Math_fround(f19 + f21)))));
   f36 = Math_fround(f21 * f36);
   f26 = Math_fround(f21 * f26);
   f28 = Math_fround(f21 * f28);
   f30 = Math_fround(f21 * f30);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
   i39 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i25 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f28 = Math_fround(HEAPF32[i40 + (i2 * 40 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i40 + (i2 * 40 | 0) + 4 >> 2]);
   f35 = Math_fround(f28 - f35);
   f32 = Math_fround(f26 - f32);
   f29 = Math_fround(Math_fround(HEAPF32[i40 + (i2 * 40 | 0) + 8 >> 2]) - f29);
   f26 = (HEAP32[tempDoublePtr >> 2] = i39 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f36 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(f26 * Math_fround(-2.0));
   f19 = Math_fround(f26 * Math_fround(2.0));
   f34 = Math_fround(f30 * f21);
   f31 = Math_fround(f36 * Math_fround(2.0));
   f33 = Math_fround(f36 * Math_fround(-2.0));
   f38 = Math_fround(f30 * f33);
   f27 = Math_fround(f28 * Math_fround(-2.0));
   f37 = Math_fround(f28 * Math_fround(2.0));
   f30 = Math_fround(f30 * f27);
   f23 = Math_fround(Math_fround(f35 + Math_fround(f35 * Math_fround(Math_fround(f26 * f21) - Math_fround(f36 * f31)))) + Math_fround(Math_fround(f32 * Math_fround(f38 - Math_fround(f26 * f27))) + Math_fround(f29 * Math_fround(Math_fround(f36 * f37) - f34))));
   f21 = Math_fround(Math_fround(f32 + Math_fround(f35 * Math_fround(Math_fround(f28 * f19) - f38))) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f36 * f33) - Math_fround(f28 * f37))) + Math_fround(f29 * Math_fround(f30 - Math_fround(f36 * f21)))));
   f19 = Math_fround(Math_fround(f29 + Math_fround(f35 * Math_fround(f34 - Math_fround(f28 * f33)))) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f26 * f31) - f30)) + Math_fround(f29 * Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f19)))));
   i25 = Math_fround(Math_abs(Math_fround(f24))) < Math_fround(9.99999971e-10);
   i2 = Math_fround(Math_abs(Math_fround(f20))) < Math_fround(9.99999971e-10);
   i3 = Math_fround(Math_abs(Math_fround(f22))) < Math_fround(9.99999971e-10);
   f24 = Math_fround(Math_fround(1.0) / f24);
   f24 = i25 ? Math_fround(1.0) : f24;
   f20 = Math_fround(Math_fround(1.0) / f20);
   f20 = i2 ? Math_fround(1.0) : f20;
   f22 = Math_fround(Math_fround(1.0) / f22);
   f23 = Math_fround(f24 * f23);
   f21 = Math_fround(f20 * f21);
   f19 = Math_fround((i3 ? Math_fround(1.0) : f22) * f19);
   f22 = Math_fround(HEAPF32[i11 + (i1 * 12 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i11 + (i1 * 12 | 0) + 4 >> 2]);
   f22 = Math_fround(f23 - f22);
   f20 = Math_fround(f21 - f20);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i11 + (i1 * 12 | 0) + 8 >> 2]));
   f21 = Math_fround(HEAPF32[i6 >> 2]);
   f20 = Math_fround(f20 / f21);
   f19 = Math_fround(f19 / f21);
   HEAPF32[i7 >> 2] = Math_fround(f22 / f21);
   HEAPF32[i8 >> 2] = f20;
   HEAPF32[i9 >> 2] = f19;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 return;
}

function __ZN20ExternalForcesModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i3, i1, i2, i52, i53, i54, i55) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, f65 = f0, i66 = 0, f67 = f0, i68 = 0, f69 = f0, i70 = 0, f71 = f0, i72 = 0, f73 = f0, i74 = 0, f75 = f0, i76 = 0, f77 = f0, i78 = 0, f79 = f0;
 i59 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i59 + 48 | 0;
 i56 = i59 + 32 | 0;
 i57 = i59 + 16 | 0;
 i58 = i59;
 if ((HEAP16[gb + 1451788 + 6 >> 1] | 0) > -1) {
  HEAP32[i56 >> 2] = 0;
  HEAP32[i50 >> 2] = HEAP32[i56 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451788 | 0, i50);
  i51 = gb + 1451788 | 0;
 } else i51 = 0;
 i48 = (HEAP32[i1 + 280 >> 2] | 0) == 1 ? gb + 1162292 | 0 : i2 + 180 | 0;
 f18 = Math_fround(HEAPF32[i2 + 368 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 380 >> 2]);
 f11 = Math_fround(f18 + f16);
 f19 = Math_fround(HEAPF32[i2 + 372 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 384 >> 2]);
 f12 = Math_fround(f19 + f14);
 f20 = Math_fround(HEAPF32[i2 + 376 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 388 >> 2]);
 f12 = Math_fround(f12 * Math_fround(.5));
 f13 = Math_fround(Math_fround(f20 + f15) * Math_fround(.5));
 HEAPF32[i50 >> 2] = Math_fround(f11 * Math_fround(.5));
 HEAPF32[i50 + 4 >> 2] = f12;
 HEAPF32[i50 + 8 >> 2] = f13;
 f19 = Math_fround(Math_fround(f14 - f19) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f15 - f20) * Math_fround(.5));
 HEAPF32[i50 + 12 >> 2] = Math_fround(Math_fround(f16 - f18) * Math_fround(.5));
 HEAPF32[i50 + 16 >> 2] = f19;
 HEAPF32[i50 + 20 >> 2] = f20;
 i49 = i2 + 436 | 0;
 L4 : do if (HEAP32[i49 >> 2] | 0) {
  i34 = i2 + 432 | 0;
  i35 = i48 + 16 | 0;
  i36 = i48 + 32 | 0;
  i37 = i48 + 48 | 0;
  i38 = i48 + 4 | 0;
  i39 = i48 + 20 | 0;
  i40 = i48 + 36 | 0;
  i41 = i48 + 52 | 0;
  i42 = i56 + 4 | 0;
  i43 = i48 + 8 | 0;
  i44 = i48 + 24 | 0;
  i45 = i48 + 40 | 0;
  i46 = i48 + 56 | 0;
  i47 = i56 + 8 | 0;
  i22 = i3 + 8 | 0;
  i23 = i55 + 4 | 0;
  i24 = i55 + 8 | 0;
  i25 = i55 + 12 | 0;
  i26 = i57 + 4 | 0;
  i27 = i57 + 8 | 0;
  i28 = i57 + 12 | 0;
  i29 = i58 + 12 | 0;
  i30 = i53 >>> 0 < i54 >>> 0;
  i31 = i52 + 60 | 0;
  i32 = i52 + 80 | 0;
  i33 = i52 + 100 | 0;
  i21 = 0;
  while (1) {
   i17 = HEAP32[i34 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i48 >> 2]);
   f11 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) >> 2]);
   f19 = Math_fround(f4 * f11);
   f18 = Math_fround(HEAPF32[i35 >> 2]);
   f7 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 4 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f18 * f7));
   f5 = Math_fround(HEAPF32[i36 >> 2]);
   f9 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 8 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f5 * f9));
   HEAPF32[i56 >> 2] = Math_fround(Math_fround(HEAPF32[i37 >> 2]) + f19);
   f19 = Math_fround(HEAPF32[i38 >> 2]);
   f8 = Math_fround(f11 * f19);
   f20 = Math_fround(HEAPF32[i39 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f7 * f20));
   f6 = Math_fround(HEAPF32[i40 >> 2]);
   f8 = Math_fround(f8 + Math_fround(f9 * f6));
   HEAPF32[i42 >> 2] = Math_fround(Math_fround(HEAPF32[i41 >> 2]) + f8);
   f8 = Math_fround(HEAPF32[i43 >> 2]);
   f11 = Math_fround(f11 * f8);
   f12 = Math_fround(HEAPF32[i44 >> 2]);
   f7 = Math_fround(f11 + Math_fround(f7 * f12));
   f11 = Math_fround(HEAPF32[i45 >> 2]);
   f9 = Math_fround(f7 + Math_fround(f9 * f11));
   HEAPF32[i47 >> 2] = Math_fround(Math_fround(HEAPF32[i46 >> 2]) + f9);
   f9 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 12 >> 2]);
   f4 = Math_fround(f4 * f9);
   f7 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 16 >> 2]);
   f18 = Math_fround(f4 + Math_fround(f18 * f7));
   f4 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 20 >> 2]);
   f5 = Math_fround(f18 + Math_fround(f5 * f4));
   f6 = Math_fround(Math_fround(Math_fround(f9 * f19) + Math_fround(f7 * f20)) + Math_fround(f4 * f6));
   f11 = Math_fround(Math_fround(Math_fround(f9 * f8) + Math_fround(f7 * f12)) + Math_fround(f4 * f11));
   f4 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 28 >> 2]);
   f12 = Math_fround(HEAPF32[i17 + (i21 * 40 | 0) + 32 >> 2]);
   f12 = Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2]));
   f7 = Math_fround(Math_fround(HEAPF32[i55 >> 2]) * f12);
   f8 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
   f9 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
   f12 = Math_fround(f12 * Math_fround(HEAPF32[i25 >> 2]));
   HEAPF32[i57 >> 2] = f7;
   HEAPF32[i26 >> 2] = f8;
   HEAPF32[i27 >> 2] = f9;
   HEAPF32[i28 >> 2] = f12;
   L8 : do switch (HEAP32[i17 + (i21 * 40 | 0) + 24 >> 2] | 0) {
   case 1:
    {
     HEAP32[i58 >> 2] = HEAP32[i56 >> 2];
     HEAP32[i58 + 4 >> 2] = HEAP32[i56 + 4 >> 2];
     HEAP32[i58 + 8 >> 2] = HEAP32[i56 + 8 >> 2];
     HEAPF32[i29 >> 2] = f4;
     if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i50, i58) | 0) {
      __Z16ApplyRadialForceR23ParticleSystemParticlesjjRK8Vector3ffRKN4math7_float4E(i52, i53, i54, i56, f4, i57);
      break L8;
     } else break L8;
    }
   case 0:
    {
     if (i30) {
      i17 = HEAP32[i31 >> 2] | 0;
      i2 = HEAP32[i32 >> 2] | 0;
      i3 = HEAP32[i33 >> 2] | 0;
      f18 = Math_fround(f5 * f7);
      f19 = Math_fround(f5 * f8);
      f20 = Math_fround(f5 * f9);
      f13 = Math_fround(f5 * f12);
      f14 = Math_fround(f6 * f7);
      f15 = Math_fround(f6 * f8);
      f16 = Math_fround(f6 * f9);
      f10 = Math_fround(f6 * f12);
      f7 = Math_fround(f11 * f7);
      f6 = Math_fround(f11 * f8);
      f5 = Math_fround(f11 * f9);
      f4 = Math_fround(f11 * f12);
      i1 = i53;
      do {
       i78 = i17 + (i1 << 2) | 0;
       f79 = Math_fround(HEAPF32[i78 >> 2]);
       i76 = i78 + 4 | 0;
       f77 = Math_fround(HEAPF32[i76 >> 2]);
       i74 = i78 + 8 | 0;
       f75 = Math_fround(HEAPF32[i74 >> 2]);
       i72 = i78 + 12 | 0;
       f73 = Math_fround(HEAPF32[i72 >> 2]);
       i70 = i2 + (i1 << 2) | 0;
       f71 = Math_fround(HEAPF32[i70 >> 2]);
       i68 = i70 + 4 | 0;
       f69 = Math_fround(HEAPF32[i68 >> 2]);
       i66 = i70 + 8 | 0;
       f67 = Math_fround(HEAPF32[i66 >> 2]);
       i64 = i70 + 12 | 0;
       f65 = Math_fround(HEAPF32[i64 >> 2]);
       i63 = i3 + (i1 << 2) | 0;
       f8 = Math_fround(HEAPF32[i63 >> 2]);
       i62 = i63 + 4 | 0;
       f9 = Math_fround(HEAPF32[i62 >> 2]);
       i61 = i63 + 8 | 0;
       f11 = Math_fround(HEAPF32[i61 >> 2]);
       i60 = i63 + 12 | 0;
       f77 = Math_fround(f19 + f77);
       f75 = Math_fround(f20 + f75);
       f73 = Math_fround(f13 + f73);
       f71 = Math_fround(f14 + f71);
       f69 = Math_fround(f15 + f69);
       f67 = Math_fround(f16 + f67);
       f65 = Math_fround(f10 + f65);
       f8 = Math_fround(f7 + f8);
       f9 = Math_fround(f6 + f9);
       f11 = Math_fround(f5 + f11);
       f12 = Math_fround(f4 + Math_fround(HEAPF32[i60 >> 2]));
       HEAPF32[i78 >> 2] = Math_fround(f18 + f79);
       HEAPF32[i76 >> 2] = f77;
       HEAPF32[i74 >> 2] = f75;
       HEAPF32[i72 >> 2] = f73;
       HEAPF32[i70 >> 2] = f71;
       HEAPF32[i68 >> 2] = f69;
       HEAPF32[i66 >> 2] = f67;
       HEAPF32[i64 >> 2] = f65;
       HEAPF32[i63 >> 2] = f8;
       HEAPF32[i62 >> 2] = f9;
       HEAPF32[i61 >> 2] = f11;
       HEAPF32[i60 >> 2] = f12;
       i1 = i1 + 4 | 0;
      } while (i1 >>> 0 < i54 >>> 0);
     }
     break;
    }
   default:
    {}
   } while (0);
   i21 = i21 + 1 | 0;
   if (i21 >>> 0 >= (HEAP32[i49 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i51) {
  STACKTOP = i59;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i51);
 STACKTOP = i59;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEbT0_SE_T_(i25, i26, i1) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 switch ((i26 - i25 | 0) / 40 | 0 | 0) {
 case 2:
  {
   i9 = i26 + -40 | 0;
   i6 = i9;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i8 = i25;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   do if ((i5 | 0) == (i7 | 0) & (i6 | 0) == (i8 | 0)) {
    i1 = i26 + -32 | 0;
    i24 = i1;
    i23 = HEAP32[i24 + 4 >> 2] | 0;
    i3 = i25 + 8 | 0;
    i2 = i3;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!(i23 >>> 0 < i2 >>> 0 | ((i23 | 0) == (i2 | 0) ? (HEAP32[i24 >> 2] | 0) >>> 0 < i4 >>> 0 : 0))) {
     i26 = 1;
     return i26 | 0;
    }
   } else if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
    i3 = i25 + 8 | 0;
    i2 = i3;
    i1 = i26 + -32 | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    break;
   } else {
    i26 = 1;
    return i26 | 0;
   } while (0);
   i18 = i25;
   HEAP32[i18 >> 2] = i5;
   HEAP32[i18 + 4 >> 2] = i6;
   i18 = i1;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i23 = i3;
   HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i23 + 4 >> 2] = i19;
   i23 = i9;
   HEAP32[i23 >> 2] = i7;
   HEAP32[i23 + 4 >> 2] = i8;
   i23 = i1;
   HEAP32[i23 >> 2] = i4;
   HEAP32[i23 + 4 >> 2] = i2;
   i23 = i25 + 16 | 0;
   i19 = i23;
   i18 = HEAP32[i19 >> 2] | 0;
   i19 = HEAP32[i19 + 4 >> 2] | 0;
   i15 = i25 + 24 | 0;
   i22 = i15;
   i21 = HEAP32[i22 >> 2] | 0;
   i22 = HEAP32[i22 + 4 >> 2] | 0;
   i17 = i25 + 32 | 0;
   i25 = i17;
   i24 = HEAP32[i25 >> 2] | 0;
   i25 = HEAP32[i25 + 4 >> 2] | 0;
   i20 = i26 + -24 | 0;
   i16 = i20;
   i14 = HEAP32[i16 + 4 >> 2] | 0;
   HEAP32[i23 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i23 + 4 >> 2] = i14;
   i23 = i26 + -16 | 0;
   i14 = i23;
   i16 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   i26 = i26 + -8 | 0;
   i15 = i26;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   HEAP32[i20 >> 2] = i18;
   HEAP32[i20 + 4 >> 2] = i19;
   HEAP32[i23 >> 2] = i21;
   HEAP32[i23 + 4 >> 2] = i22;
   HEAP32[i26 >> 2] = i24;
   HEAP32[i26 + 4 >> 2] = i25;
   i26 = 1;
   return i26 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i25, i25 + 40 | 0, i26 + -40 | 0, i1) | 0;
   i26 = 1;
   return i26 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_(i25, i25 + 40 | 0, i25 + 80 | 0, i26 + -40 | 0, i1) | 0;
   i26 = 1;
   return i26 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_(i25, i25 + 40 | 0, i25 + 80 | 0, i25 + 120 | 0, i26 + -40 | 0, i1) | 0;
   i26 = 1;
   return i26 | 0;
  }
 case 1:
 case 0:
  {
   i26 = 1;
   return i26 | 0;
  }
 default:
  {
   i3 = i25 + 80 | 0;
   __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i25, i25 + 40 | 0, i3, i1) | 0;
   i1 = i25 + 120 | 0;
   L3 : do if ((i1 | 0) == (i26 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i23 = i1;
     i22 = HEAP32[i23 >> 2] | 0;
     i23 = HEAP32[i23 + 4 >> 2] | 0;
     i9 = i3;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     if ((i22 | 0) == (i8 | 0) & (i23 | 0) == (i9 | 0)) {
      i5 = i1 + 8 | 0;
      i6 = i5;
      i7 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
      i4 = i3 + 8 | 0;
      i21 = i4;
      i20 = HEAP32[i21 + 4 >> 2] | 0;
      if (i6 >>> 0 < i20 >>> 0 | ((i6 | 0) == (i20 | 0) ? i7 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0 : 0)) i24 = 15;
     } else if (i23 >>> 0 < i9 >>> 0 | (i23 | 0) == (i9 | 0) & i22 >>> 0 < i8 >>> 0) {
      i5 = i1 + 8 | 0;
      i7 = i5;
      i4 = i3 + 8 | 0;
      i6 = HEAP32[i7 + 4 >> 2] | 0;
      i7 = HEAP32[i7 >> 2] | 0;
      i24 = 15;
     }
     if ((i24 | 0) == 15) {
      i24 = 0;
      i11 = i1 + 16 | 0;
      i17 = i11;
      i16 = HEAP32[i17 >> 2] | 0;
      i17 = HEAP32[i17 + 4 >> 2] | 0;
      i12 = i1 + 24 | 0;
      i19 = i12;
      i18 = HEAP32[i19 >> 2] | 0;
      i19 = HEAP32[i19 + 4 >> 2] | 0;
      i15 = i1 + 32 | 0;
      i21 = i15;
      i20 = HEAP32[i21 >> 2] | 0;
      i21 = HEAP32[i21 + 4 >> 2] | 0;
      i14 = i1;
      HEAP32[i14 >> 2] = i8;
      HEAP32[i14 + 4 >> 2] = i9;
      i14 = i4;
      i13 = HEAP32[i14 + 4 >> 2] | 0;
      i9 = i5;
      HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i9 + 4 >> 2] = i13;
      i9 = i3 + 16 | 0;
      i13 = i9;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i8 = i11;
      HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 4 >> 2] = i14;
      i8 = i3 + 24 | 0;
      i14 = i8;
      i13 = HEAP32[i14 + 4 >> 2] | 0;
      i5 = i12;
      HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i5 + 4 >> 2] = i13;
      i5 = i3 + 32 | 0;
      i13 = i5;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i15 + 4 >> 2] = i14;
      L12 : do if ((i3 | 0) != (i25 | 0)) {
       i15 = i3;
       i14 = i4;
       while (1) {
        i3 = i15 + -40 | 0;
        i13 = i3;
        i12 = HEAP32[i13 >> 2] | 0;
        i13 = HEAP32[i13 + 4 >> 2] | 0;
        if ((i22 | 0) == (i12 | 0) & (i23 | 0) == (i13 | 0)) {
         i4 = i15 + -32 | 0;
         i11 = i4;
         i10 = HEAP32[i11 >> 2] | 0;
         i11 = HEAP32[i11 + 4 >> 2] | 0;
         if (i6 >>> 0 < i11 >>> 0 | (i6 | 0) == (i11 | 0) & i7 >>> 0 < i10 >>> 0) {
          i8 = i10;
          i5 = i11;
         } else {
          i4 = i14;
          i3 = i15;
          break L12;
         }
        } else {
         if (!(i23 >>> 0 < i13 >>> 0 | (i23 | 0) == (i13 | 0) & i22 >>> 0 < i12 >>> 0)) {
          i4 = i14;
          i3 = i15;
          break L12;
         }
         i4 = i15 + -32 | 0;
         i5 = i4;
         i8 = HEAP32[i5 >> 2] | 0;
         i5 = HEAP32[i5 + 4 >> 2] | 0;
        }
        i9 = i15;
        HEAP32[i9 >> 2] = i12;
        HEAP32[i9 + 4 >> 2] = i13;
        i9 = i15 + 8 | 0;
        HEAP32[i9 >> 2] = i8;
        HEAP32[i9 + 4 >> 2] = i5;
        i9 = i15 + -24 | 0;
        i13 = i9;
        i14 = HEAP32[i13 + 4 >> 2] | 0;
        i8 = i15 + 16 | 0;
        HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i8 + 4 >> 2] = i14;
        i8 = i15 + -16 | 0;
        i14 = i8;
        i13 = HEAP32[i14 + 4 >> 2] | 0;
        i5 = i15 + 24 | 0;
        HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i5 + 4 >> 2] = i13;
        i5 = i15 + -8 | 0;
        i13 = i5;
        i14 = HEAP32[i13 + 4 >> 2] | 0;
        i15 = i15 + 32 | 0;
        HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
        HEAP32[i15 + 4 >> 2] = i14;
        if ((i3 | 0) == (i25 | 0)) break; else {
         i15 = i3;
         i14 = i4;
        }
       }
      } while (0);
      i15 = i3;
      HEAP32[i15 >> 2] = i22;
      HEAP32[i15 + 4 >> 2] = i23;
      i23 = i4;
      HEAP32[i23 >> 2] = i7;
      HEAP32[i23 + 4 >> 2] = i6;
      i23 = i9;
      HEAP32[i23 >> 2] = i16;
      HEAP32[i23 + 4 >> 2] = i17;
      i23 = i8;
      HEAP32[i23 >> 2] = i18;
      HEAP32[i23 + 4 >> 2] = i19;
      i23 = i5;
      HEAP32[i23 >> 2] = i20;
      HEAP32[i23 + 4 >> 2] = i21;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 40 | 0) == (i26 | 0);
       break L3;
      }
     }
     i3 = i1 + 40 | 0;
     if ((i3 | 0) == (i26 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i23 = i1;
      i1 = i3;
      i3 = i23;
     }
    }
   } while (0);
   i26 = i1 | i2;
   return i26 | 0;
  }
 }
 return 0;
}

function __ZN7mecanim19ValueArrayBlendNodeERNS_10ValueArrayERNS_16ValueArrayWeightERNS_14ValueArrayMaskERKS0_RKS4_f(i17, i16, i15, i18, i14, f19) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f19 = Math_fround(f19);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i13 = HEAP32[i17 >> 2] | 0;
 if (i13 | 0) {
  i10 = i14 + 4 | 0;
  i2 = i15 + 4 | 0;
  i3 = i2;
  i4 = i16 + 4 | 0;
  i5 = i4;
  i6 = i17 + 4 | 0;
  i7 = i6;
  i8 = i18 + 4 | 0;
  i9 = i8;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i1 = 0;
  do {
   if (HEAP8[i10 + i1 >> 0] | 0) {
    i11 = (HEAP32[i2 >> 2] | 0) + i3 + i1 | 0;
    i12 = HEAP32[i4 >> 2] | 0;
    if (!(HEAP8[i11 >> 0] | 0)) {
     HEAPF32[i12 + i5 + (i1 << 2) >> 2] = Math_fround(0.0);
     i20 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
     HEAP32[i20 + (i1 * 12 | 0) >> 2] = 0;
     HEAP32[i20 + (i1 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i20 + (i1 * 12 | 0) + 8 >> 2] = 0;
     HEAP8[i11 >> 0] = 1;
    }
    i20 = i12 + i5 + (i1 << 2) | 0;
    HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f19);
    i20 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
    i11 = i20 + (i1 * 12 | 0) | 0;
    f24 = Math_fround(HEAPF32[i11 >> 2]);
    i12 = i20 + (i1 * 12 | 0) + 4 | 0;
    f26 = Math_fround(HEAPF32[i12 >> 2]);
    i20 = i20 + (i1 * 12 | 0) + 8 | 0;
    f21 = Math_fround(HEAPF32[i20 >> 2]);
    i25 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
    f23 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) >> 2]);
    f22 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 4 >> 2]);
    f22 = Math_fround(f26 + Math_fround(f22 * f19));
    f21 = Math_fround(f21 + Math_fround(Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 8 >> 2]) * f19));
    HEAPF32[i11 >> 2] = Math_fround(f24 + Math_fround(f23 * f19));
    HEAPF32[i12 >> 2] = f22;
    HEAPF32[i20 >> 2] = f21;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 i2 = HEAP32[i17 + 8 >> 2] | 0;
 if (i2 | 0) {
  i11 = i14 + 12 | 0;
  i3 = i15 + 12 | 0;
  i4 = i3;
  i5 = i16 + 12 | 0;
  i6 = i5;
  i7 = i17 + 12 | 0;
  i8 = i7;
  i9 = i18 + 12 | 0;
  i10 = i9;
  i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
  i1 = 0;
  do {
   if (HEAP8[i11 + i1 >> 0] | 0) {
    i12 = (HEAP32[i3 >> 2] | 0) + i4 + i1 | 0;
    i13 = HEAP32[i5 >> 2] | 0;
    if (!(HEAP8[i12 >> 0] | 0)) {
     HEAPF32[i13 + i6 + (i1 << 2) >> 2] = Math_fround(0.0);
     i25 = (HEAP32[i7 >> 2] | 0) + i8 + (i1 << 4) | 0;
     HEAP32[i25 >> 2] = 0;
     HEAP32[i25 + 4 >> 2] = 0;
     HEAP32[i25 + 8 >> 2] = 0;
     HEAP32[i25 + 12 >> 2] = 0;
     HEAP8[i12 >> 0] = 1;
    }
    i25 = i13 + i6 + (i1 << 2) | 0;
    HEAPF32[i25 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f19);
    i25 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
    i12 = i25 + (i1 << 4) | 0;
    f22 = Math_fround(HEAPF32[i12 >> 2]);
    i13 = i25 + (i1 << 4) + 4 | 0;
    f23 = Math_fround(HEAPF32[i13 >> 2]);
    i20 = i25 + (i1 << 4) + 8 | 0;
    f24 = Math_fround(HEAPF32[i20 >> 2]);
    i25 = i25 + (i1 << 4) + 12 | 0;
    f26 = Math_fround(HEAPF32[i25 >> 2]);
    i31 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    f34 = Math_fround(HEAPF32[i31 + (i1 << 4) >> 2]);
    f33 = Math_fround(HEAPF32[i31 + (i1 << 4) + 4 >> 2]);
    f32 = Math_fround(HEAPF32[i31 + (i1 << 4) + 8 >> 2]);
    f21 = Math_fround(HEAPF32[i31 + (i1 << 4) + 12 >> 2]);
    f38 = Math_fround(f34 * f19);
    f37 = Math_fround(f33 * f19);
    f36 = Math_fround(f32 * f19);
    f35 = Math_fround(f21 * f19);
    i31 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
    i30 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    i29 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    i27 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    f21 = Math_fround(Math_fround(Math_fround(f22 * f34) + Math_fround(f23 * f33)) + Math_fround(Math_fround(f24 * f32) + Math_fround(f26 * f21)));
    i28 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
    f22 = Math_fround(f22 + (HEAP32[tempDoublePtr >> 2] = i28 ^ i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f23 = Math_fround(f23 + (HEAP32[tempDoublePtr >> 2] = i28 ^ i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f24 = Math_fround(f24 + (HEAP32[tempDoublePtr >> 2] = i28 ^ i29, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f26 = Math_fround(f26 + (HEAP32[tempDoublePtr >> 2] = i28 ^ i27, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    HEAPF32[i12 >> 2] = f22;
    HEAPF32[i13 >> 2] = f23;
    HEAPF32[i20 >> 2] = f24;
    HEAPF32[i25 >> 2] = f26;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i4 = HEAP32[i17 + 16 >> 2] | 0;
 if (i4 | 0) {
  i13 = i14 + 20 | 0;
  i5 = i15 + 20 | 0;
  i6 = i5;
  i7 = i16 + 20 | 0;
  i8 = i7;
  i9 = i17 + 20 | 0;
  i10 = i9;
  i11 = i18 + 20 | 0;
  i12 = i11;
  i13 = (HEAP32[i13 >> 2] | 0) + i13 | 0;
  i1 = 0;
  do {
   if (HEAP8[i13 + i1 >> 0] | 0) {
    i2 = (HEAP32[i5 >> 2] | 0) + i6 + i1 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    if (!(HEAP8[i2 >> 0] | 0)) {
     HEAPF32[i3 + i8 + (i1 << 2) >> 2] = Math_fround(0.0);
     i31 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
     HEAP32[i31 + (i1 * 12 | 0) >> 2] = 0;
     HEAP32[i31 + (i1 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i31 + (i1 * 12 | 0) + 8 >> 2] = 0;
     HEAP8[i2 >> 0] = 1;
    }
    i31 = i3 + i8 + (i1 << 2) | 0;
    HEAPF32[i31 >> 2] = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f19);
    i31 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    i29 = i31 + (i1 * 12 | 0) | 0;
    f35 = Math_fround(HEAPF32[i29 >> 2]);
    i30 = i31 + (i1 * 12 | 0) + 4 | 0;
    f34 = Math_fround(HEAPF32[i30 >> 2]);
    i31 = i31 + (i1 * 12 | 0) + 8 | 0;
    f38 = Math_fround(HEAPF32[i31 >> 2]);
    i28 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
    f36 = Math_fround(HEAPF32[i28 + (i1 * 12 | 0) >> 2]);
    f37 = Math_fround(HEAPF32[i28 + (i1 * 12 | 0) + 4 >> 2]);
    f37 = Math_fround(f34 + Math_fround(f37 * f19));
    f38 = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i28 + (i1 * 12 | 0) + 8 >> 2]) * f19));
    HEAPF32[i29 >> 2] = Math_fround(f35 + Math_fround(f36 * f19));
    HEAPF32[i30 >> 2] = f37;
    HEAPF32[i31 >> 2] = f38;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i3 = HEAP32[i17 + 24 >> 2] | 0;
 if (i3 | 0) {
  i4 = i14 + 28 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i5 = i15 + 28 | 0;
  i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
  i6 = i16 + 36 | 0;
  i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
  i7 = i17 + 28 | 0;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i8 = i18 + 28 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i2 = 0;
  do {
   if (HEAP8[i4 + i2 >> 0] | 0) {
    i1 = i5 + i2 | 0;
    i9 = i6 + (i2 << 2) | 0;
    if (!(HEAP8[i1 >> 0] | 0)) {
     HEAPF32[i9 >> 2] = Math_fround(0.0);
     i31 = i7 + (i2 << 2) | 0;
     HEAP32[i31 >> 2] = 0;
     HEAP8[i1 >> 0] = 1;
     i1 = i31;
    } else i1 = i7 + (i2 << 2) | 0;
    HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f19);
    f38 = Math_fround(HEAPF32[i1 >> 2]);
    HEAPF32[i1 >> 2] = Math_fround(f38 + Math_fround(Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]) * f19));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i13 = HEAP32[i17 + 32 >> 2] | 0;
 if (!i13) return;
 i11 = i14 + 36 | 0;
 i12 = i11;
 i9 = i15 + 36 | 0;
 i10 = i9;
 i7 = i16 + 28 | 0;
 i8 = i7;
 i5 = i17 + 36 | 0;
 i6 = i5;
 i2 = i18 + 36 | 0;
 i3 = i2;
 i1 = 0;
 do {
  if (HEAP8[(HEAP32[i11 >> 2] | 0) + i12 + i1 >> 0] | 0) {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + i10 + i1 >> 0] | 0)) {
    HEAPF32[(HEAP32[i7 >> 2] | 0) + i8 + (i1 << 2) >> 2] = Math_fround(-1.0);
    HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] = 0;
    HEAP8[(HEAP32[i9 >> 2] | 0) + i10 + i1 >> 0] = 1;
   }
   i4 = (HEAP32[i7 >> 2] | 0) + i8 + (i1 << 2) | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) < f19) {
    HEAPF32[i4 >> 2] = f19;
    HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2];
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 return;
}

function __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i4, i1, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f9 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.5));
 f8 = Math_fround(+Math_cos(+f9));
 f9 = Math_fround(+Math_sin(+f9));
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(.5));
 f5 = Math_fround(+Math_cos(+f6));
 f6 = Math_fround(+Math_sin(+f6));
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(.5));
 f2 = Math_fround(+Math_cos(+f3));
 f3 = Math_fround(+Math_sin(+f3));
 switch (i7 | 0) {
 case 5:
  {
   f13 = Math_fround(f8 * Math_fround(0.0));
   f15 = Math_fround(f6 * Math_fround(0.0));
   f11 = Math_fround(Math_fround(Math_fround(f13 + Math_fround(f9 * f5)) + Math_fround(0.0)) - f15);
   f14 = Math_fround(f5 * Math_fround(0.0));
   f12 = Math_fround(f9 * Math_fround(0.0));
   f10 = Math_fround(Math_fround(Math_fround(f14 + Math_fround(f8 * f6)) + Math_fround(0.0)) - f12);
   f9 = Math_fround(Math_fround(f13 + f14) + Math_fround(f9 * f6));
   f15 = Math_fround(Math_fround(Math_fround(f8 * f5) - f12) - f15);
   f12 = Math_fround(f15 * Math_fround(0.0));
   f5 = Math_fround(f9 * Math_fround(0.0));
   f6 = Math_fround(Math_fround(f5 + Math_fround(f12 + Math_fround(f2 * f10))) - Math_fround(f11 * f3));
   f14 = Math_fround(f11 * Math_fround(0.0));
   f13 = Math_fround(f10 * Math_fround(0.0));
   f8 = Math_fround(Math_fround(f14 + Math_fround(Math_fround(f2 * f9) + Math_fround(f15 * f3))) - f13);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f15) - f14) - f13) - Math_fround(f9 * f3));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f12 + Math_fround(f2 * f11)) + Math_fround(f3 * f10)) - f5);
   HEAPF32[i4 + 4 >> 2] = f6;
   HEAPF32[i4 + 8 >> 2] = f8;
   HEAPF32[i4 + 12 >> 2] = f9;
   return;
  }
 case 2:
  {
   f17 = Math_fround(f8 * Math_fround(0.0));
   f10 = Math_fround(f3 * Math_fround(0.0));
   f16 = Math_fround(Math_fround(f17 + Math_fround(f9 * f2)) + f10);
   f12 = Math_fround(f2 * Math_fround(0.0));
   f17 = Math_fround(Math_fround(Math_fround(f17 + f12) + Math_fround(0.0)) - Math_fround(f9 * f3));
   f11 = Math_fround(f9 * Math_fround(0.0));
   f12 = Math_fround(f11 + Math_fround(f12 + Math_fround(f8 * f3)));
   f8 = Math_fround(Math_fround(Math_fround(f8 * f2) - f11) - f10);
   f10 = Math_fround(f8 * Math_fround(0.0));
   f11 = Math_fround(f17 * Math_fround(0.0));
   f15 = Math_fround(f12 * Math_fround(0.0));
   f9 = Math_fround(f16 * Math_fround(0.0));
   f13 = Math_fround(Math_fround(f15 + Math_fround(Math_fround(f6 * f8) + Math_fround(f5 * f17))) - f9);
   f14 = Math_fround(Math_fround(Math_fround(f6 * f16) + Math_fround(f10 + Math_fround(f5 * f12))) - f11);
   f15 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f8) - f9) - Math_fround(f6 * f17)) - f15);
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f16) + f10) + f11) - Math_fround(f6 * f12));
   HEAPF32[i4 + 4 >> 2] = f13;
   HEAPF32[i4 + 8 >> 2] = f14;
   HEAPF32[i4 + 12 >> 2] = f15;
   return;
  }
 case 1:
  {
   f16 = Math_fround(f5 * Math_fround(0.0));
   f17 = Math_fround(f2 * Math_fround(0.0));
   f11 = Math_fround(Math_fround(f16 + f17) + Math_fround(f6 * f3));
   f12 = Math_fround(f3 * Math_fround(0.0));
   f16 = Math_fround(Math_fround(Math_fround(f16 + Math_fround(f6 * f2)) + Math_fround(0.0)) - f12);
   f13 = Math_fround(f6 * Math_fround(0.0));
   f17 = Math_fround(Math_fround(Math_fround(f17 + Math_fround(f5 * f3)) + Math_fround(0.0)) - f13);
   f12 = Math_fround(Math_fround(Math_fround(f5 * f2) - f13) - f12);
   f13 = Math_fround(f16 * Math_fround(0.0));
   f14 = Math_fround(f17 * Math_fround(0.0));
   f10 = Math_fround(f12 * Math_fround(0.0));
   f6 = Math_fround(f11 * Math_fround(0.0));
   f15 = Math_fround(Math_fround(Math_fround(f9 * f17) + Math_fround(f10 + Math_fround(f8 * f16))) - f6);
   f16 = Math_fround(Math_fround(f6 + Math_fround(f10 + Math_fround(f8 * f17))) - Math_fround(f9 * f16));
   f17 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f11)) - f13) - f14);
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f11) + Math_fround(f9 * f12)) + f13) - f14);
   HEAPF32[i4 + 4 >> 2] = f15;
   HEAPF32[i4 + 8 >> 2] = f16;
   HEAPF32[i4 + 12 >> 2] = f17;
   return;
  }
 case 4:
  {
   f15 = Math_fround(f8 * Math_fround(0.0));
   f12 = Math_fround(f6 * Math_fround(0.0));
   f11 = Math_fround(Math_fround(f15 + Math_fround(f9 * f5)) + f12);
   f17 = Math_fround(f5 * Math_fround(0.0));
   f14 = Math_fround(f9 * Math_fround(0.0));
   f13 = Math_fround(f14 + Math_fround(f17 + Math_fround(f8 * f6)));
   f17 = Math_fround(Math_fround(Math_fround(f15 + f17) + Math_fround(0.0)) - Math_fround(f9 * f6));
   f8 = Math_fround(Math_fround(Math_fround(f8 * f5) - f14) - f12);
   f12 = Math_fround(f8 * Math_fround(0.0));
   f14 = Math_fround(f17 * Math_fround(0.0));
   f15 = Math_fround(Math_fround(f14 + Math_fround(f12 + Math_fround(f2 * f13))) - Math_fround(f11 * f3));
   f9 = Math_fround(f11 * Math_fround(0.0));
   f10 = Math_fround(f13 * Math_fround(0.0));
   f16 = Math_fround(Math_fround(f9 + Math_fround(Math_fround(f8 * f3) + Math_fround(f2 * f17))) - f10);
   f17 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f8) - f9) - f10) - Math_fround(f3 * f17));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f2) + f12) + Math_fround(f3 * f13)) - f14);
   HEAPF32[i4 + 4 >> 2] = f15;
   HEAPF32[i4 + 8 >> 2] = f16;
   HEAPF32[i4 + 12 >> 2] = f17;
   return;
  }
 case 3:
  {
   f10 = Math_fround(f8 * Math_fround(0.0));
   f12 = Math_fround(f3 * Math_fround(0.0));
   f13 = Math_fround(Math_fround(Math_fround(f10 + Math_fround(f9 * f2)) + Math_fround(0.0)) - f12);
   f14 = Math_fround(f2 * Math_fround(0.0));
   f10 = Math_fround(Math_fround(f9 * f3) + Math_fround(f10 + f14));
   f11 = Math_fround(f9 * Math_fround(0.0));
   f14 = Math_fround(Math_fround(Math_fround(f14 + Math_fround(f8 * f3)) + Math_fround(0.0)) - f11);
   f8 = Math_fround(Math_fround(Math_fround(f8 * f2) - f11) - f12);
   f12 = Math_fround(f8 * Math_fround(0.0));
   f11 = Math_fround(f10 * Math_fround(0.0));
   f17 = Math_fround(f14 * Math_fround(0.0));
   f9 = Math_fround(f13 * Math_fround(0.0));
   f15 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(f6 * f8)) + f17) - f9);
   f16 = Math_fround(Math_fround(Math_fround(f6 * f13) + Math_fround(f12 + Math_fround(f5 * f14))) - f11);
   f17 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f8) - f9) - Math_fround(f6 * f10)) - f17);
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(f11 + Math_fround(f12 + Math_fround(f5 * f13))) - Math_fround(f6 * f14));
   HEAPF32[i4 + 4 >> 2] = f15;
   HEAPF32[i4 + 8 >> 2] = f16;
   HEAPF32[i4 + 12 >> 2] = f17;
   return;
  }
 case 0:
  {
   f17 = Math_fround(f2 * Math_fround(0.0));
   f16 = Math_fround(f5 * Math_fround(0.0));
   f13 = Math_fround(Math_fround(Math_fround(f16 + f17) + Math_fround(0.0)) - Math_fround(f6 * f3));
   f12 = Math_fround(f3 * Math_fround(0.0));
   f16 = Math_fround(f12 + Math_fround(f16 + Math_fround(f6 * f2)));
   f11 = Math_fround(f6 * Math_fround(0.0));
   f17 = Math_fround(f11 + Math_fround(f17 + Math_fround(f5 * f3)));
   f12 = Math_fround(Math_fround(Math_fround(f5 * f2) - f11) - f12);
   f11 = Math_fround(f16 * Math_fround(0.0));
   f14 = Math_fround(f17 * Math_fround(0.0));
   f10 = Math_fround(f12 * Math_fround(0.0));
   f6 = Math_fround(f13 * Math_fround(0.0));
   f15 = Math_fround(Math_fround(Math_fround(f9 * f17) + Math_fround(Math_fround(f8 * f16) + f10)) - f6);
   f16 = Math_fround(Math_fround(f6 + Math_fround(f10 + Math_fround(f8 * f17))) - Math_fround(f9 * f16));
   f17 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f13)) - f11) - f14);
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(f11 + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f13))) - f14);
   HEAPF32[i4 + 4 >> 2] = f15;
   HEAPF32[i4 + 8 >> 2] = f16;
   HEAPF32[i4 + 12 >> 2] = f17;
   return;
  }
 default:
  return;
 }
}

function __ZN12FlareManager6UpdateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i39 + 64 | 0;
 i32 = i39 + 80 | 0;
 i33 = i39 + 48 | 0;
 i37 = i39 + 40 | 0;
 i38 = i39 + 24 | 0;
 i34 = i39 + 12 | 0;
 i35 = i39;
 i36 = __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
 i4 = i5 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  STACKTOP = i39;
  return;
 } else i1 = i4;
 L3 : while (1) {
  i3 = i2;
  while (1) {
   if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i36 >>> 0) break;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) break L3; else i3 = i2;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i1 = i3;
   break;
  } else i1 = i3;
 }
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i39;
  return;
 }
 if (i36 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  STACKTOP = i39;
  return;
 }
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = (HEAP32[i1 + 24 >> 2] | 0) == (i6 | 0) ? 0 : i6;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i38 >> 2] = 0;
 i30 = i38 + 4 | 0;
 i4 = gb + 63160 | 0;
 i29 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i30;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i29;
 i3 = i5 + 12 | 0;
 i29 = i5 + 16 | 0;
 i5 = HEAP32[i29 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i28 = i5 - i4 | 0;
 i1 = ((i28 | 0) / 52 | 0) << 3;
 do if (!i28) i1 = 0; else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 376088 | 0, 257) | 0;
   i5 = gb + 64016 | 0;
   i28 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i38 >> 2] = i1;
   i4 = i30;
   HEAP32[i4 >> 2] = i28;
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i29 >> 2] | 0;
   break;
  }
 } while (0);
 i28 = i1 + 3 & -4;
 if ((i4 | 0) == (i5 | 0)) i1 = 0; else {
  i12 = i36 + 924 | 0;
  i13 = i36 + 28 | 0;
  i8 = i36 + 864 | 0;
  i11 = i36 + 868 | 0;
  i9 = i36 + 872 | 0;
  i10 = i36 + 876 | 0;
  i14 = i31 + 8 | 0;
  i15 = i31 + 12 | 0;
  i16 = i31 + 4 | 0;
  i17 = i33 + 4 | 0;
  i18 = i33 + 8 | 0;
  i19 = i35 + 4 | 0;
  i20 = i35 + 8 | 0;
  i21 = i34 + 4 | 0;
  i22 = i34 + 8 | 0;
  i23 = i31 + 8 | 0;
  i24 = i31 + 12 | 0;
  i25 = i31 + 4 | 0;
  i26 = i33 + 4 | 0;
  i27 = i33 + 8 | 0;
  i2 = 0;
  i7 = i6;
  i1 = 0;
  while (1) {
   if (HEAP8[i4 + 49 >> 0] | 0) {
    if (!i2) {
     i2 = __ZnwjRK10MemLabelIdiPKci(220, gb + 64024 | 0, 16, gb + 376088 | 0, 269) | 0;
     HEAP32[i2 + 200 >> 2] = 0;
     HEAP32[i2 + 204 >> 2] = HEAP32[i12 >> 2];
     __ZNK9Transform11GetPositionEv(i2 + 208 | 0, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 28940 | 0) | 0);
    }
    i3 = HEAP32[i2 + 200 >> 2] | 0;
    if ((i3 | 0) == 10) {
     HEAP32[i28 + (i1 << 3) >> 2] = fb + 3325;
     HEAP32[i28 + (i1 << 3) + 4 >> 2] = i2;
     i3 = __ZnwjRK10MemLabelIdiPKci(220, gb + 64024 | 0, 16, gb + 376088 | 0, 276) | 0;
     HEAP32[i3 + 200 >> 2] = 0;
     HEAP32[i3 + 204 >> 2] = HEAP32[i12 >> 2];
     __ZNK9Transform11GetPositionEv(i3 + 208 | 0, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 28940 | 0) | 0);
     i1 = i1 + 1 | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 200 >> 2] | 0;
    }
    i6 = i2 + 200 | 0;
    HEAP32[i2 + (i3 << 2) >> 2] = i4;
    HEAP32[i2 + 40 + (HEAP32[i6 >> 2] << 2) >> 2] = i7;
    i3 = HEAP32[i6 >> 2] | 0;
    i5 = i2 + 80 + (i3 * 12 | 0) | 0;
    if (!(HEAP8[i4 + 48 >> 0] | 0)) {
     __ZNK6Camera18WorldToScreenPointERK8Vector3fPb(i33, i36, i4 + 16 | 0, i32);
     __ZL19GetCameraTargetRectRK6Camerab(i31, i36, 1);
     f44 = Math_fround(HEAPF32[i8 >> 2]);
     f43 = Math_fround(HEAPF32[i11 >> 2]);
     f42 = Math_fround(HEAPF32[i9 >> 2]);
     f41 = Math_fround(HEAPF32[i10 >> 2]);
     f46 = Math_fround(HEAPF32[i14 >> 2]);
     f45 = Math_fround(HEAPF32[i15 >> 2]);
     f44 = Math_fround(f44 * f46);
     f42 = Math_fround(f42 * f46);
     f43 = Math_fround(f43 * f45);
     f41 = Math_fround(f41 * f45);
     f48 = Math_fround(HEAPF32[i31 >> 2]);
     f47 = Math_fround(HEAPF32[i16 >> 2]);
     f44 = Math_fround(f44 + f48);
     f43 = Math_fround(f43 + f47);
     f42 = Math_fround(f42 + f44);
     f41 = Math_fround(f41 + f43);
     f46 = Math_fround(f46 + f48);
     f45 = Math_fround(f45 + f47);
     f44 = f44 < f48 ? f48 : f44;
     f43 = f43 < f47 ? f47 : f43;
     f42 = Math_fround((f42 > f46 ? f46 : f42) - f44);
     i40 = f42 < Math_fround(0.0);
     f42 = i40 ? Math_fround(0.0) : f42;
     f41 = Math_fround((f41 > f45 ? f45 : f41) - f43);
     i40 = f41 < Math_fround(0.0);
     f41 = i40 ? Math_fround(0.0) : f41;
     f42 = Math_fround(Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f44) / f42);
     f41 = Math_fround(Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f43) / f41);
     i40 = HEAP32[i18 >> 2] | 0;
     HEAPF32[i5 >> 2] = f42;
     HEAPF32[i2 + 80 + (i3 * 12 | 0) + 4 >> 2] = f41;
     HEAP32[i2 + 80 + (i3 * 12 | 0) + 8 >> 2] = i40;
    } else {
     __ZNK9Transform11GetPositionEv(i35, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 28940 | 0) | 0);
     f47 = Math_fround(HEAPF32[i35 >> 2]);
     f47 = Math_fround(f47 + Math_fround(HEAPF32[i4 + 16 >> 2]));
     f46 = Math_fround(HEAPF32[i19 >> 2]);
     f46 = Math_fround(f46 + Math_fround(HEAPF32[i4 + 20 >> 2]));
     f45 = Math_fround(HEAPF32[i20 >> 2]);
     f45 = Math_fround(f45 + Math_fround(HEAPF32[i4 + 24 >> 2]));
     HEAPF32[i34 >> 2] = f47;
     HEAPF32[i21 >> 2] = f46;
     HEAPF32[i22 >> 2] = f45;
     __ZNK6Camera18WorldToScreenPointERK8Vector3fPb(i33, i36, i34, i32);
     __ZL19GetCameraTargetRectRK6Camerab(i31, i36, 1);
     f45 = Math_fround(HEAPF32[i8 >> 2]);
     f46 = Math_fround(HEAPF32[i11 >> 2]);
     f47 = Math_fround(HEAPF32[i9 >> 2]);
     f48 = Math_fround(HEAPF32[i10 >> 2]);
     f43 = Math_fround(HEAPF32[i23 >> 2]);
     f44 = Math_fround(HEAPF32[i24 >> 2]);
     f45 = Math_fround(f45 * f43);
     f47 = Math_fround(f47 * f43);
     f46 = Math_fround(f46 * f44);
     f48 = Math_fround(f48 * f44);
     f41 = Math_fround(HEAPF32[i31 >> 2]);
     f42 = Math_fround(HEAPF32[i25 >> 2]);
     f45 = Math_fround(f45 + f41);
     f46 = Math_fround(f46 + f42);
     f47 = Math_fround(f47 + f45);
     f48 = Math_fround(f48 + f46);
     f43 = Math_fround(f43 + f41);
     f44 = Math_fround(f44 + f42);
     f45 = f45 < f41 ? f41 : f45;
     f46 = f46 < f42 ? f42 : f46;
     f47 = Math_fround((f47 > f43 ? f43 : f47) - f45);
     i40 = f47 < Math_fround(0.0);
     f47 = i40 ? Math_fround(0.0) : f47;
     f48 = Math_fround((f48 > f44 ? f44 : f48) - f46);
     i40 = f48 < Math_fround(0.0);
     f48 = i40 ? Math_fround(0.0) : f48;
     f47 = Math_fround(Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f45) / f47);
     f48 = Math_fround(Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f46) / f48);
     i40 = HEAP32[i27 >> 2] | 0;
     HEAPF32[i5 >> 2] = f47;
     HEAPF32[i2 + 80 + (i3 * 12 | 0) + 4 >> 2] = f48;
     HEAP32[i2 + 80 + (i3 * 12 | 0) + 8 >> 2] = i40;
    }
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    i5 = HEAP32[i29 >> 2] | 0;
   }
   i4 = i4 + 52 | 0;
   if ((i4 | 0) == (i5 | 0)) break; else i7 = i7 + 4 | 0;
  }
  if (i2) if (HEAP32[i2 + 200 >> 2] | 0) {
   HEAP32[i28 + (i1 << 3) >> 2] = fb + 3325;
   HEAP32[i28 + (i1 << 3) + 4 >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
 }
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i37, i28, i1, 0);
 if (HEAP32[i37 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i37);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i38 >> 2] | 0, i30);
 STACKTOP = i39;
 return;
}

function __ZN5physx2Sc5Scene20fireTriggerCallbacksEv(i28) {
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 848 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i29 + 784 | 0;
 i24 = i29;
 i25 = i28 + 100 | 0;
 i27 = i28 + 104 | 0;
 i22 = HEAP32[i27 >> 2] | 0;
 if (!i22) {
  HEAP32[i27 >> 2] = 0;
  i28 = i28 + 112 | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  i28 = i28 + 4 | 0;
  HEAP32[i28 >> 2] = 0;
  STACKTOP = i29;
  return;
 }
 i19 = i28 + 1196 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 i20 = (HEAP32[i28 + 116 >> 2] | 0) >>> 0 < i1 >>> 0;
 i21 = i28 + 1152 | 0;
 if ((HEAP32[i28 + 1156 >> 2] | 0) == 1) {
  i11 = HEAP32[(HEAP32[HEAP32[i21 >> 2] >> 2] | 0) + 16 >> 2] | 0;
  if (i11 | 0) {
   if (!i1) {
    mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i25 >> 2] | 0, i22 | 0);
    HEAP32[i27 >> 2] = 0;
    i28 = i28 + 112 | 0;
    i28 = HEAP32[i28 >> 2] | 0;
    i28 = i28 + 4 | 0;
    HEAP32[i28 >> 2] = 0;
    STACKTOP = i29;
    return;
   }
   i8 = i28 + 112 | 0;
   i9 = i2 + 20 | 0;
   i10 = i2 + 16 | 0;
   i7 = i2 + 16 | 0;
   i1 = HEAP32[i25 >> 2] | 0;
   i6 = 0;
   do {
    if (i20) i26 = 9; else if (HEAP8[i1 + (i6 * 24 | 0) + 20 >> 0] & 4) i26 = 9;
    if ((i26 | 0) == 9) {
     i26 = 0;
     i4 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 + (i6 * 12 | 0) >> 2] | 0;
     i3 = i2 >>> 5;
     i5 = HEAP32[i9 >> 2] & 2147483647;
     if (i3 >>> 0 < i5 >>> 0) i2 = (HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i2 & 31) | 0) != 0 & 1; else i2 = 0;
     i3 = HEAP32[i4 + (i6 * 12 | 0) + 4 >> 2] | 0;
     i4 = i3 >>> 5;
     if (i4 >>> 0 < i5 >>> 0) if (HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] & 1 << (i3 & 31)) i2 = (i2 & 255 | 2) & 255;
     HEAP8[i1 + (i6 * 24 | 0) + 20 >> 0] = i2;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i22 | 0));
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i1 | 0, i22 | 0);
   HEAP32[i27 >> 2] = 0;
   i28 = i28 + 112 | 0;
   i28 = HEAP32[i28 >> 2] | 0;
   i28 = i28 + 4 | 0;
   HEAP32[i28 >> 2] = 0;
   STACKTOP = i29;
   return;
  }
 };
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i16 = i28 + 112 | 0;
 i17 = i28 + 1152 | 0;
 i1 = 0;
 i18 = 0;
 i2 = 0;
 do {
  i10 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  i5 = HEAP8[i10 + (i2 * 12 | 0) + 10 >> 0] | 0;
  i3 = HEAP8[i10 + (i2 * 12 | 0) + 11 >> 0] | 0;
  i12 = i10 + (i2 * 12 | 0) + 8 | 0;
  i6 = HEAP8[i12 >> 0] | 0;
  i13 = i6 & 255;
  i8 = HEAP32[i17 >> 2] | 0;
  i11 = HEAP32[i8 + (i13 << 2) >> 2] | 0;
  i4 = HEAP8[i11 + 12 >> 0] | 0;
  i14 = i10 + (i2 * 12 | 0) + 9 | 0;
  i7 = HEAP8[i14 >> 0] | 0;
  i15 = i7 & 255;
  i8 = HEAP32[i8 + (i15 << 2) >> 2] | 0;
  i9 = HEAP8[i8 + 12 >> 0] | 0;
  if (!(HEAP32[i11 + 16 >> 2] | 0)) i11 = 0; else if (i6 << 24 >> 24 == i7 << 24 >> 24) i11 = 1; else i11 = (i3 & 1 & i4) << 24 >> 24 != 0;
  if ((HEAP32[i8 + 16 >> 2] | 0) == 0 ? 1 : i6 << 24 >> 24 == i7 << 24 >> 24) i9 = 0; else i9 = (i5 & 1 & i9) << 24 >> 24 != 0;
  i8 = HEAP32[i25 >> 2] | 0;
  if (i11 | i9) {
   if (i20) i26 = 26; else if (HEAP8[i8 + (i2 * 24 | 0) + 20 >> 0] & 4) i26 = 26;
   if ((i26 | 0) == 26) {
    i26 = 0;
    i6 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i10 + (i2 * 12 | 0) >> 2] | 0;
    i4 = i3 >>> 5;
    i7 = HEAP32[i6 + 20 >> 2] & 2147483647;
    if (i4 >>> 0 < i7 >>> 0) i3 = (HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + (i4 << 2) >> 2] & 1 << (i3 & 31) | 0) != 0 & 1; else i3 = 0;
    i4 = HEAP32[i10 + (i2 * 12 | 0) + 4 >> 2] | 0;
    i5 = i4 >>> 5;
    if (i5 >>> 0 < i7 >>> 0) if (HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + (i5 << 2) >> 2] & 1 << (i4 & 31)) i3 = (i3 & 255 | 2) & 255;
    HEAP8[i8 + (i2 * 24 | 0) + 20 >> 0] = i3;
   }
   if (i11) {
    i12 = i23 + (i13 >>> 3 << 2) | 0;
    HEAP32[i12 >> 2] = 1 << (i13 & 7) | HEAP32[i12 >> 2];
    i13 = i13 + 1 & 65535;
    i1 = (i13 & 65535) < (i1 & 65535) ? i1 : i13;
   } else HEAP8[i12 >> 0] = -128;
   if (i9) {
    i14 = i23 + (i15 >>> 3 << 2) | 0;
    HEAP32[i14 >> 2] = 1 << (i15 & 7) | HEAP32[i14 >> 2];
    i15 = i15 + 1 & 65535;
    i1 = (i15 & 65535) < (i1 & 65535) ? i1 : i15;
   } else HEAP8[i14 >> 0] = -128;
   i2 = i2 + 1 | 0;
  } else {
   i13 = i8 + (i2 * 24 | 0) | 0;
   i12 = (HEAP32[i27 >> 2] | 0) + -1 | 0;
   HEAP32[i27 >> 2] = i12;
   i15 = i8 + (i12 * 24 | 0) | 0;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   HEAP8[i8 + (i2 * 24 | 0) + 20 >> 0] = HEAP8[i8 + (i12 * 24 | 0) + 20 >> 0] | 0;
   i12 = HEAP32[i16 >> 2] | 0;
   i13 = HEAP32[i12 >> 2] | 0;
   i15 = i13 + (i2 * 12 | 0) | 0;
   i12 = i12 + 4 | 0;
   i14 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
   HEAP32[i12 >> 2] = i14;
   i14 = i13 + (i14 * 12 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i22 | 0));
 i12 = i24 + 768 | 0;
 i11 = i24 + 772 | 0;
 i9 = i24 + 776 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i24 + 780 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i11 >> 2] = i24;
 HEAP32[i10 >> 2] = 32;
 if (!(i1 << 16 >> 16)) i1 = 32; else {
  i7 = i28 + 112 | 0;
  i8 = i1 & 65535;
  if (!i2) {
   i1 = 0;
   do {
    if (HEAP32[i23 + (i1 >>> 3 << 2) >> 2] & 1 << (i1 & 7) | 0) {
     HEAP32[i9 >> 2] = 0;
     i26 = HEAP32[(HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 16 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 16 >> 2] | 0, i26 | 0, HEAP32[i11 >> 2] | 0, 0);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  } else {
   i5 = 0;
   do {
    if (HEAP32[i23 + (i5 >>> 3 << 2) >> 2] & 1 << (i5 & 7) | 0) {
     HEAP32[i9 >> 2] = 0;
     if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
      __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE8recreateEj(i24, i2);
      i6 = 0;
     } else i6 = 0;
     do {
      i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
      if ((HEAPU8[i1 + (i6 * 12 | 0) + 8 >> 0] | 0 | 0) == (i5 | 0)) i26 = 49; else if ((HEAPU8[i1 + (i6 * 12 | 0) + 9 >> 0] | 0 | 0) == (i5 | 0)) i26 = 49;
      do if ((i26 | 0) == 49) {
       i26 = 0;
       i1 = HEAP32[i25 >> 2] | 0;
       i3 = i1 + (i6 * 24 | 0) | 0;
       i4 = HEAP32[i9 >> 2] | 0;
       if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
        i22 = HEAP32[i11 >> 2] | 0;
        i20 = i22 + (i4 * 24 | 0) | 0;
        HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i20 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
        HEAP32[i20 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
        HEAP32[i20 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
        HEAP32[i20 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
        HEAP8[i22 + (i4 * 24 | 0) + 20 >> 0] = HEAP8[i1 + (i6 * 24 | 0) + 20 >> 0] | 0;
        HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_(i24, i3) | 0;
        break;
       }
      } while (0);
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i2 | 0));
     i22 = HEAP32[(HEAP32[(HEAP32[i21 >> 2] | 0) + (i5 << 2) >> 2] | 0) + 16 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, i22 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i9 >> 2] | 0);
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i1 = HEAP32[i10 >> 2] | 0;
 }
 do if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i24 | 0) == (i1 | 0)) {
   HEAP8[i12 >> 0] = 0;
   break;
  } else {
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i24, i1);
   break;
  }
 } while (0);
 HEAP32[i27 >> 2] = 0;
 i28 = i28 + 112 | 0;
 i28 = HEAP32[i28 >> 2] | 0;
 i28 = i28 + 4 | 0;
 HEAP32[i28 >> 2] = 0;
 STACKTOP = i29;
 return;
}

function __ZN5physx3Ext14PrismaticJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i2 + 480 | 0;
 i17 = i2 + 448 | 0;
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i18 >> 2] = HEAP32[gb + 118320 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 118320 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 118320 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[gb + 118320 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[gb + 118320 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[gb + 118320 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[gb + 118320 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[gb + 118320 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i18 | 0, 32) | 0;
 HEAP32[i17 >> 2] = HEAP32[gb + 118352 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 118352 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 118352 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[gb + 118352 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[gb + 118352 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[gb + 118352 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[gb + 118352 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[gb + 118352 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i17 | 0, 32) | 0;
 HEAP32[i16 >> 2] = gb + 744669;
 HEAP32[i16 + 4 >> 2] = gb + 743927;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 112;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 1;
 HEAP32[i16 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 118384 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 118384 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 118384 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 118384 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 118384 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 118384 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 118384 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 118384 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 118416 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 118416 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 118416 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 118416 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 118416 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 118416 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 118416 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 118416 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 118448 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 118448 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 118448 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 118448 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 118448 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 118448 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 118448 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 118448 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 118480 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 118480 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 118480 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 118480 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 118480 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 118480 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 118480 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 118480 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 118512 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 118512 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 118512 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 118512 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 118512 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 118512 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 118512 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 118512 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 744688;
 HEAP32[i10 + 4 >> 2] = gb + 743901;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 84;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 744688;
 HEAP32[i9 + 4 >> 2] = gb + 829211;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 84;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 118544 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 118544 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 118544 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 118544 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 118544 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 118544 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 118544 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 118544 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_120parse_function_paramINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 80 | 0;
 i8 = i13 + 60 | 0;
 i11 = i13 + 24 | 0;
 i6 = i13 + 48 | 0;
 i12 = i13 + 12 | 0;
 i9 = i13;
 L1 : do if ((i3 - i1 | 0) > 2) if ((HEAP8[i1 >> 0] | 0) == 102) {
  L4 : do switch (HEAP8[i1 + 1 >> 0] | 0) {
  case 112:
   {
    i2 = __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj(i1 + 2 | 0, i3, i7) | 0;
    i5 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i2, i3) | 0;
    L6 : do if ((i5 | 0) != (i3 | 0)) if ((HEAP8[i5 >> 0] | 0) == 95) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i12 + 4 >> 2] = 0;
     HEAP32[i12 + 8 >> 2] = 0;
     i4 = i5 - i2 | 0;
     if (i4 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
     if (i4 >>> 0 < 11) {
      HEAP8[i12 + 11 >> 0] = i4;
      i3 = i12;
     } else {
      i9 = i4 + 16 & -16;
      i3 = _malloc(i9) | 0;
      HEAP32[i12 >> 2] = i3;
      HEAP32[i12 + 8 >> 2] = i9 | -2147483648;
      HEAP32[i12 + 4 >> 2] = i4;
     }
     i1 = i2;
     i2 = i3;
     while (1) {
      if ((i1 | 0) == (i5 | 0)) break;
      HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
      i1 = i1 + 1 | 0;
      i2 = i2 + 1 | 0;
     }
     HEAP8[i3 + i4 >> 0] = 0;
     __THREW__ = 0;
     i2 = invoke_iiii(fb + 520 | 0, i12 | 0, 0, gb + 1087817 | 0) | 0;
     i9 = __THREW__;
     __THREW__ = 0;
     L20 : do if (i9 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      i1 = 0;
      while (1) {
       if ((i1 | 0) == 3) break;
       HEAP32[i2 + (i1 << 2) >> 2] = 0;
       i1 = i1 + 1 | 0;
      }
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i11, i6);
      i1 = i10 + 4 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      i9 = HEAP32[i10 + 8 >> 2] | 0;
      i4 = i9;
      do if (i2 >>> 0 < i9 >>> 0) {
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i11);
       HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
      } else {
       i3 = HEAP32[i10 >> 2] | 0;
       i1 = (i2 - i3 | 0) / 24 | 0;
       i2 = i1 + 1 | 0;
       if (i2 >>> 0 > 178956970) {
        __THREW__ = 0;
        invoke_vi(fb + 4014 | 0, i10 | 0);
        __THREW__ = 0;
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
        break L20;
       } else {
        i7 = (i4 - i3 | 0) / 24 | 0;
        i9 = i7 << 1;
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i8, i7 >>> 0 < 89478485 ? (i9 >>> 0 < i2 >>> 0 ? i2 : i9) : 178956970, i1, i10 + 12 | 0);
        i9 = i8 + 8 | 0;
        i7 = HEAP32[i9 >> 2] | 0;
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i7, i11);
        HEAP32[i9 >> 2] = i7 + 24;
        __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i8);
        __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i8);
        break;
       }
      } while (0);
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
      i1 = i5 + 1 | 0;
      break L6;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
     break L4;
    } while (0);
    break L1;
   }
  case 76:
   {
    i2 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i1 + 2 | 0, i3) | 0;
    L37 : do if ((i2 | 0) != (i3 | 0)) if ((HEAP8[i2 >> 0] | 0) == 112) {
     i2 = __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj(i2 + 1 | 0, i3, i8) | 0;
     i5 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i2, i3) | 0;
     if ((i5 | 0) != (i3 | 0)) if ((HEAP8[i5 >> 0] | 0) == 95) {
      HEAP32[i12 >> 2] = 0;
      HEAP32[i12 + 4 >> 2] = 0;
      HEAP32[i12 + 8 >> 2] = 0;
      i4 = i5 - i2 | 0;
      if (i4 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
      if (i4 >>> 0 < 11) {
       HEAP8[i12 + 11 >> 0] = i4;
       i3 = i12;
      } else {
       i8 = i4 + 16 & -16;
       i3 = _malloc(i8) | 0;
       HEAP32[i12 >> 2] = i3;
       HEAP32[i12 + 8 >> 2] = i8 | -2147483648;
       HEAP32[i12 + 4 >> 2] = i4;
      }
      i1 = i2;
      i2 = i3;
      while (1) {
       if ((i1 | 0) == (i5 | 0)) break;
       HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
       i1 = i1 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
      HEAP8[i3 + i4 >> 0] = 0;
      __THREW__ = 0;
      i2 = invoke_iiii(fb + 520 | 0, i12 | 0, 0, gb + 1087817 | 0) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      L53 : do if (i8 & 1) {
       i1 = ___cxa_find_matching_catch_2() | 0;
       getTempRet0() | 0;
      } else {
       HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i9 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       i1 = 0;
       while (1) {
        if ((i1 | 0) == 3) break;
        HEAP32[i2 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i11, i9);
       i1 = i10 + 4 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       i8 = HEAP32[i10 + 8 >> 2] | 0;
       i4 = i8;
       do if (i2 >>> 0 < i8 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i11);
        HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
       } else {
        i3 = HEAP32[i10 >> 2] | 0;
        i1 = (i2 - i3 | 0) / 24 | 0;
        i2 = i1 + 1 | 0;
        if (i2 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i10 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
         break L53;
        } else {
         i6 = (i4 - i3 | 0) / 24 | 0;
         i8 = i6 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i7, i6 >>> 0 < 89478485 ? (i8 >>> 0 < i2 >>> 0 ? i2 : i8) : 178956970, i1, i10 + 12 | 0);
         i8 = i7 + 8 | 0;
         i6 = HEAP32[i8 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i6, i11);
         HEAP32[i8 >> 2] = i6 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i7);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i7);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i11);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
       i1 = i5 + 1 | 0;
       break L37;
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i12);
      break L4;
     }
    } while (0);
    break L1;
   }
  default:
   break L1;
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN7mecanim5human20RetargetFromTDoFBaseEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3E(i4, i5, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i9 = i4 + 40 | 0;
 i10 = i9;
 i11 = i5 + 4 | 0;
 i12 = i11;
 i13 = i4 + 44 | 0;
 i14 = i13;
 i1 = 0;
 do {
  i15 = i8 + (i1 * 12 | 0) | 0;
  HEAP32[i15 >> 2] = 0;
  i6 = i8 + (i1 * 12 | 0) + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i8 + (i1 * 12 | 0) + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  i2 = HEAP32[i4 + 72 + (HEAP32[gb + 177756 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  i3 = HEAP32[i4 + 72 + (HEAP32[gb + 177784 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  if ((i2 | 0) != -1 & (i3 | 0) != -1) {
   i37 = HEAP32[i9 >> 2] | 0;
   i37 = ((i37 | 0) == 0 ? 0 : i37 + i10 | 0) + 4 | 0;
   i37 = HEAP32[i37 + (HEAP32[i37 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   i36 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   i39 = i36 + (i37 * 40 | 0) | 0;
   HEAP32[i39 >> 2] = 0;
   HEAP32[i39 + 4 >> 2] = 0;
   HEAP32[i39 + 8 >> 2] = 0;
   HEAP32[i39 + 12 >> 2] = 0;
   HEAP32[i39 + 16 >> 2] = 0;
   HEAP32[i39 + 20 >> 2] = 0;
   HEAP32[i36 + (i37 * 40 | 0) + 24 >> 2] = 1065353216;
   HEAP32[i36 + (i37 * 40 | 0) + 28 >> 2] = 1065353216;
   HEAP32[i36 + (i37 * 40 | 0) + 32 >> 2] = 1065353216;
   HEAP32[i36 + (i37 * 40 | 0) + 36 >> 2] = 1065353216;
   i37 = HEAP32[i13 >> 2] | 0;
   i37 = (i37 | 0) == 0 ? 0 : i37 + i14 | 0;
   i39 = i37 + 4 | 0;
   i39 = i39 + (HEAP32[i39 >> 2] | 0) | 0;
   i22 = HEAP32[i39 + (i3 * 40 | 0) + 4 >> 2] | 0;
   i40 = HEAP32[i39 + (i3 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i36 + (i3 * 40 | 0) >> 2] = HEAP32[i39 + (i3 * 40 | 0) >> 2];
   HEAP32[i36 + (i3 * 40 | 0) + 4 >> 2] = i22;
   HEAP32[i36 + (i3 * 40 | 0) + 8 >> 2] = i40;
   i40 = HEAP32[i39 + (i3 * 40 | 0) + 16 >> 2] | 0;
   i22 = HEAP32[i39 + (i3 * 40 | 0) + 20 >> 2] | 0;
   i38 = HEAP32[i39 + (i3 * 40 | 0) + 24 >> 2] | 0;
   HEAP32[i36 + (i3 * 40 | 0) + 12 >> 2] = HEAP32[i39 + (i3 * 40 | 0) + 12 >> 2];
   HEAP32[i36 + (i3 * 40 | 0) + 16 >> 2] = i40;
   HEAP32[i36 + (i3 * 40 | 0) + 20 >> 2] = i22;
   HEAP32[i36 + (i3 * 40 | 0) + 24 >> 2] = i38;
   i38 = HEAP32[i39 + (i3 * 40 | 0) + 32 >> 2] | 0;
   i22 = HEAP32[i39 + (i3 * 40 | 0) + 36 >> 2] | 0;
   HEAP32[i36 + (i3 * 40 | 0) + 28 >> 2] = HEAP32[i39 + (i3 * 40 | 0) + 28 >> 2];
   HEAP32[i36 + (i3 * 40 | 0) + 32 >> 2] = i38;
   HEAP32[i36 + (i3 * 40 | 0) + 36 >> 2] = i22;
   i36 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i36 | 0) == 0 ? 0 : i36 + i10 | 0, i37, i5, i2, i3);
   i37 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   f32 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) >> 2]);
   f29 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 4 >> 2]);
   f26 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 12 >> 2]);
   f17 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 16 >> 2]);
   f30 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 20 >> 2]);
   f31 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 24 >> 2]);
   f19 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 28 >> 2]);
   f21 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 32 >> 2]);
   f20 = Math_fround(HEAPF32[i37 + (i3 * 40 | 0) + 36 >> 2]);
   i36 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
   i22 = i36 + 16 | 0;
   i36 = i36 + 4 | 0;
   i3 = HEAP32[i36 + (HEAP32[i36 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   i22 = i22 + (HEAP32[i22 >> 2] | 0) | 0;
   f28 = Math_fround(HEAPF32[i22 + (i3 * 76 | 0) + 16 >> 2]);
   f25 = Math_fround(HEAPF32[i22 + (i3 * 76 | 0) + 20 >> 2]);
   f35 = Math_fround(HEAPF32[i22 + (i3 * 76 | 0) + 24 >> 2]);
   f33 = Math_fround(HEAPF32[i22 + (i3 * 76 | 0) + 28 >> 2]);
   f23 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f28) - Math_fround(f31 * f35)) - Math_fround(f30 * f33)) - Math_fround(f24 * f25));
   f27 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f33) - Math_fround(f24 * f28)) - Math_fround(f30 * f35)) - Math_fround(f17 * f25));
   f16 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f25) - Math_fround(f17 * f35)) - Math_fround(f31 * f28)) - Math_fround(f24 * f33));
   f33 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f35) - Math_fround(f30 * f28)) - Math_fround(f31 * f25)) - Math_fround(f17 * f33));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i36 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f33 = (HEAP32[tempDoublePtr >> 2] = i22 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = Math_fround(f33 * f33);
   f23 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f23 * f23);
   f25 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f16 + f17)))));
   f33 = Math_fround(f17 * f33);
   f23 = Math_fround(f17 * f23);
   f25 = Math_fround(f17 * f25);
   f27 = Math_fround(f17 * f27);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i36 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i22 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f25 = Math_fround(HEAPF32[i37 + (i2 * 40 | 0) >> 2]);
   f23 = Math_fround(HEAPF32[i37 + (i2 * 40 | 0) + 4 >> 2]);
   f32 = Math_fround(f25 - f32);
   f29 = Math_fround(f23 - f29);
   f26 = Math_fround(Math_fround(HEAPF32[i37 + (i2 * 40 | 0) + 8 >> 2]) - f26);
   f23 = (HEAP32[tempDoublePtr >> 2] = i36 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = Math_fround(f23 * Math_fround(-2.0));
   f16 = Math_fround(f23 * Math_fround(2.0));
   f31 = Math_fround(f27 * f17);
   f28 = Math_fround(f33 * Math_fround(2.0));
   f30 = Math_fround(f33 * Math_fround(-2.0));
   f35 = Math_fround(f27 * f30);
   f24 = Math_fround(f25 * Math_fround(-2.0));
   f34 = Math_fround(f25 * Math_fround(2.0));
   f27 = Math_fround(f27 * f24);
   f18 = Math_fround(Math_fround(f32 + Math_fround(f32 * Math_fround(Math_fround(f23 * f17) - Math_fround(f33 * f28)))) + Math_fround(Math_fround(f29 * Math_fround(f35 - Math_fround(f23 * f24))) + Math_fround(f26 * Math_fround(Math_fround(f33 * f34) - f31))));
   f17 = Math_fround(Math_fround(f29 + Math_fround(f32 * Math_fround(Math_fround(f25 * f16) - f35))) + Math_fround(Math_fround(f29 * Math_fround(Math_fround(f33 * f30) - Math_fround(f25 * f34))) + Math_fround(f26 * Math_fround(f27 - Math_fround(f33 * f17)))));
   f16 = Math_fround(Math_fround(f26 + Math_fround(f32 * Math_fround(f31 - Math_fround(f25 * f30)))) + Math_fround(Math_fround(f29 * Math_fround(Math_fround(f23 * f28) - f27)) + Math_fround(f26 * Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f16)))));
   i22 = Math_fround(Math_abs(Math_fround(f19))) < Math_fround(9.99999971e-10);
   i2 = Math_fround(Math_abs(Math_fround(f21))) < Math_fround(9.99999971e-10);
   i3 = Math_fround(Math_abs(Math_fround(f20))) < Math_fround(9.99999971e-10);
   f19 = Math_fround(Math_fround(1.0) / f19);
   f19 = i22 ? Math_fround(1.0) : f19;
   f21 = Math_fround(Math_fround(1.0) / f21);
   f21 = i2 ? Math_fround(1.0) : f21;
   f20 = Math_fround(Math_fround(1.0) / f20);
   f17 = Math_fround(f21 * f17);
   f16 = Math_fround((i3 ? Math_fround(1.0) : f20) * f16);
   HEAPF32[i15 >> 2] = Math_fround(f19 * f18);
   HEAPF32[i6 >> 2] = f17;
   HEAPF32[i7 >> 2] = f16;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 return;
}

function __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7 + 888 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7 + 928 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7 + 968 | 0, i8);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7 + 1008 | 0, i8);
 i5 = i7 + 1048 | 0;
 i10 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i9 = i8 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i5, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i1;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i2 = i7 + 1060 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i3 = i1;
  i4 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i5 = i2;
  i1 = i1 | 0 ? i1 - i5 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i5;
 }
 __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i8);
 i1 = i7 + 1064 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i7 + 1068 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i7 + 1072 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i7 + 1076 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i7 + 1080 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i7 + 1084 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i7 + 1088 | 0, i1 << 2);
 i3 = i8 + 4 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 >> 2] = i7 + 1712;
 HEAP32[i6 + 4 >> 2] = i7 + 1708;
 HEAP32[i6 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i8, i6, 0);
 i5 = i7 + 1720 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 1716 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i2 + i4 | 0, i1 << 2);
 }
 i1 = i7 + 1724 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1725 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1726 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1727 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1728 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1729 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1730 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1731 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1732 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1733 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 1734 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN14SubstanceInput8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 24 | 0;
 i5 = i10 + 20 | 0;
 i7 = i10;
 i8 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, i8, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i6 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i5, 0);
 i9 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431165 | 0, i8, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431171 | 0, i8, i1 + 32 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431177 | 0, i8, i1 + 48 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047471 | 0, i8, i4, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i6 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034365 | 0, gb + 431187 | 0, i6, 0);
 __ZN14SubstanceValue8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 88 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431202 | 0, i8, i4, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431215 | 0, i6, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431229 | 0, i6, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431248 | 0, i8, i1 + 104 | 0, 0);
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i10 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i5, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
 }
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 774422 | 0, i11, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 774430 | 0, i11, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431264 | 0, i11, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040342 | 0, i6, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431269 | 0, HEAP32[gb + 37228 >> 2] | 0, i1 + 144 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431288 | 0, i8, i11, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i11, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i10;
 return;
}

function __Z14UpdateVehiclesf(f24) {
 f24 = Math_fround(f24);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26 + 16 | 0;
 i20 = i26;
 i21 = HEAP32[gb + 1458700 >> 2] | 0;
 i23 = i21 + 4 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 i22 = i1 - i2 >> 2;
 if (i22) {
  i10 = i20 + 8 | 0;
  i11 = i20 + 8 | 0;
  i12 = i20 + 8 | 0;
  i13 = i25 + 4 | 0;
  i14 = i25 + 8 | 0;
  i15 = i25 + 12 | 0;
  i16 = i25 + 16 | 0;
  i17 = i25 + 20 | 0;
  i18 = i25 + 24 | 0;
  i19 = i25 + 28 | 0;
  i9 = 0;
  do {
   i8 = HEAP32[i2 + (i9 << 2) >> 2] | 0;
   i1 = (HEAP32[(HEAP32[gb + 1458780 >> 2] | 0) + 8 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i4 = 1 << (i8 & 31);
   if (i3 & i4) {
    HEAP32[i1 >> 2] = i3 & ~i4;
    i7 = HEAP32[(HEAP32[HEAP32[gb + 1458540 >> 2] >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i2 = HEAP32[i7 + 104 >> 2] | 0;
    i6 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0) | 0;
    i3 = i6 >>> 3;
    i4 = i3 << 3;
    i6 = i6 - i4 | 0;
    if (i3 | 0) {
     i5 = (i8 << 16) + 65536 | 0;
     i1 = 0;
     do {
      mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i25 | 0, 8, i1 << 3 | 0) | 0;
      i27 = HEAP32[i25 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i25 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i13 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i13 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i14 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i14 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i15 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i15 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i16 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i16 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i17 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i17 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i18 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i18 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i27 = HEAP32[i19 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i27 | 0);
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 65535 | i5;
      i27 = HEAP32[i19 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    if (i6 | 0) {
     mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i25 | 0, i6 | 0, i4 | 0) | 0;
     i2 = (i8 << 16) + 65536 | 0;
     i1 = 0;
     do {
      i27 = i25 + (i1 << 2) | 0;
      i5 = HEAP32[i27 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i20 | 0, i5 | 0);
      HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & 65535 | i2;
      i27 = HEAP32[i27 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i27 >> 2] | 0) + 88 >> 2] | 0, i27 | 0, i20 | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i6 | 0));
    }
    i4 = i7 + 8 | 0;
    i3 = HEAP32[i7 + 48 >> 2] | 0;
    if (i3 | 0) {
     i2 = (i8 << 16) + 65536 | 0;
     i1 = 0;
     do {
      i27 = __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i4, i1) | 0;
      HEAP32[i20 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i20 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i20 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      HEAP32[i20 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & 65535 | i2;
      __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i4, i1, i20);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    i2 = HEAP32[i21 >> 2] | 0;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i22 | 0));
  i1 = HEAP32[i23 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i23 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 i1 = HEAP32[gb + 1458780 >> 2] | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) _memset(HEAP32[i1 + 8 >> 2] | 0, 0, HEAP32[i1 + 16 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[gb + 1458872 >> 2] | 0;
 if ((HEAP32[i1 + 20 >> 2] | 0) >>> 0 < (HEAP32[gb + 1458868 >> 2] | 0) >>> 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63400 | 0);
  i27 = HEAP32[gb + 1458876 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i27 >> 2] | 0) + 32 >> 2] | 0, i27 | 0);
  i27 = (HEAP32[gb + 1458868 >> 2] | 0) + 32 | 0;
  i20 = i27 * 80 | 0;
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20 + 24 + (i27 << 6) | 0, 16, gb + 63400 | 0, 0, gb + 835805 | 0, 73) | 0;
  i21 = i17 + 8 | 0;
  HEAP32[i21 >> 2] = fb + 157;
  i22 = i17 + 12 | 0;
  HEAP32[i22 >> 2] = 0;
  i23 = i17 + 16 | 0;
  HEAP32[i23 >> 2] = 0;
  i19 = i17 + 24 | 0;
  HEAP32[i17 >> 2] = i19;
  i18 = i17 + 4 | 0;
  HEAP32[i18 >> 2] = i19 + i20;
  i20 = i17 + 20 | 0;
  HEAP32[i20 >> 2] = i27;
  HEAP32[gb + 1458872 >> 2] = i17;
  i27 = __Z16GetDynamicsScenev() | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i19 = i25 + 40 | 0;
  i16 = i19 + 4 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  HEAP32[i16 + 16 >> 2] = 0;
  HEAP32[i16 + 20 >> 2] = 0;
  HEAP32[i16 + 24 >> 2] = 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
  HEAP32[i25 + 16 >> 2] = 0;
  HEAP32[i25 + 20 >> 2] = 0;
  HEAP32[i25 + 24 >> 2] = 0;
  HEAP32[i25 + 28 >> 2] = 0;
  HEAP8[i25 + 32 >> 0] = 0;
  HEAP32[i25 + 72 >> 2] = i20;
  HEAP32[i25 + 76 >> 2] = 0;
  HEAP32[i25 + 80 >> 2] = 0;
  HEAP8[i25 + 84 >> 0] = 1;
  HEAP32[i25 + 36 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i25 + 60 >> 2] = i20;
  HEAP32[i25 + 8 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i25 + 16 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i25 + 20 >> 2] = HEAP32[i23 >> 2];
  i27 = mftCall_iii(HEAP32[(HEAP32[i27 >> 2] | 0) + 328 >> 2] | 0, i27 | 0, i25 | 0) | 0;
  HEAP32[gb + 1458876 >> 2] = i27;
 }
 i1 = HEAP32[gb + 1458540 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - i2 >> 2;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i27 = HEAP32[gb + 1458872 >> 2] | 0;
 __ZN5physx27PxVehicleSuspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb(HEAP32[gb + 1458876 >> 2] | 0, i1, i2, HEAP32[i27 + 20 >> 2] | 0, HEAP32[i27 >> 2] | 0, 0);
 i27 = HEAP32[HEAP32[gb + 1458620 >> 2] >> 2] | 0;
 i23 = __Z16GetDynamicsScenev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 252 >> 2] | 0, i25 | 0, i23 | 0);
 __ZN5physx16PxVehicleUpdatesEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f24, i25, HEAP32[gb + 1458880 >> 2] | 0, i1, i2, i27, 0);
 STACKTOP = i26;
 return;
}

function __ZN14b2PolygonShape3SetEPK6b2Vec2i(i17, i12, i4) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 32 | 0;
 i16 = i18;
 if ((i4 | 0) < 3) {
  HEAP32[i17 + 148 >> 2] = 4;
  HEAPF32[i17 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 24 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 28 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 32 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 36 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 44 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 48 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 88 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 92 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 96 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 100 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 104 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 108 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 16 >> 2] = Math_fround(0.0);
  STACKTOP = i18;
  return;
 }
 i11 = (i4 | 0) < 8 ? i4 : 8;
 i8 = 0;
 i5 = 0;
 while (1) {
  i6 = HEAP32[i12 + (i8 << 3) >> 2] | 0;
  i7 = HEAP32[i12 + (i8 << 3) + 4 >> 2] | 0;
  L7 : do if ((i5 | 0) > 0) {
   f1 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = 0;
   while (1) {
    f9 = Math_fround(f1 - Math_fround(HEAPF32[i15 + (i4 << 3) >> 2]));
    f10 = Math_fround(f2 - Math_fround(HEAPF32[i15 + (i4 << 3) + 4 >> 2]));
    i4 = i4 + 1 | 0;
    if (Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) < Math_fround(6.24999984e-06)) {
     i14 = i5;
     break L7;
    }
    if ((i4 | 0) >= (i5 | 0)) {
     i13 = 9;
     break;
    }
   }
  } else i13 = 9; while (0);
  if ((i13 | 0) == 9) {
   i13 = 0;
   HEAP32[i15 + (i5 << 3) >> 2] = i6;
   HEAP32[i15 + (i5 << 3) + 4 >> 2] = i7;
   i14 = i5 + 1 | 0;
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) >= (i11 | 0)) break; else i5 = i14;
 }
 if ((i14 | 0) < 3) {
  HEAP32[i17 + 148 >> 2] = 4;
  HEAPF32[i17 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 24 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 28 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 32 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 36 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 44 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 48 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 88 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 92 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 96 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 100 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 104 >> 2] = Math_fround(1.0);
  HEAPF32[i17 + 108 >> 2] = Math_fround(-1.0);
  HEAPF32[i17 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 16 >> 2] = Math_fround(0.0);
 } else {
  i5 = 1;
  f1 = Math_fround(HEAPF32[i15 >> 2]);
  i4 = 0;
  do {
   f2 = Math_fround(HEAPF32[i15 + (i5 << 3) >> 2]);
   if (f2 > f1) i13 = 25; else if (f2 == f1) {
    f10 = Math_fround(HEAPF32[i15 + (i5 << 3) + 4 >> 2]);
    if (f10 < Math_fround(HEAPF32[i15 + (i4 << 3) + 4 >> 2])) i13 = 25;
   }
   if ((i13 | 0) == 25) {
    i13 = 0;
    f1 = f2;
    i4 = i5;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
  if ((i14 | 0) > 1) {
   i12 = i4;
   i5 = 0;
   while (1) {
    HEAP32[i16 + (i5 << 2) >> 2] = i12;
    i8 = i15 + (i12 << 3) | 0;
    i11 = i15 + (i12 << 3) + 4 | 0;
    i6 = 1;
    i7 = 0;
    do {
     if ((i7 | 0) == (i12 | 0)) i7 = i6; else {
      f1 = Math_fround(HEAPF32[i15 + (i7 << 3) >> 2]);
      f3 = Math_fround(HEAPF32[i8 >> 2]);
      f1 = Math_fround(f1 - f3);
      f2 = Math_fround(HEAPF32[i15 + (i7 << 3) + 4 >> 2]);
      f9 = Math_fround(HEAPF32[i11 >> 2]);
      f2 = Math_fround(f2 - f9);
      f3 = Math_fround(Math_fround(HEAPF32[i15 + (i6 << 3) >> 2]) - f3);
      f9 = Math_fround(Math_fround(HEAPF32[i15 + (i6 << 3) + 4 >> 2]) - f9);
      f10 = Math_fround(Math_fround(f1 * f9) - Math_fround(f2 * f3));
      i13 = f10 < Math_fround(0.0);
      i7 = i13 ? i6 : i7;
      if (f10 == Math_fround(0.0)) if (Math_fround(Math_fround(f3 * f3) + Math_fround(f9 * f9)) > Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2))) i7 = i6;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i14 | 0));
    i6 = i5 + 1 | 0;
    if ((i7 | 0) == (i4 | 0)) {
     i11 = i6;
     break;
    } else {
     i12 = i7;
     i5 = i6;
    }
   }
  } else {
   i7 = (i4 | 0) == 0;
   i5 = 0;
   while (1) {
    HEAP32[i16 + (i5 << 2) >> 2] = i4;
    i6 = i5 + 1 | 0;
    if (i7) {
     i11 = i6;
     break;
    } else {
     i4 = 0;
     i5 = i6;
    }
   }
  }
  HEAP32[i17 + 148 >> 2] = i11;
  i6 = (i5 | 0) < 0;
  if (i6) {
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  } else {
   i4 = 0;
   while (1) {
    i12 = i15 + (HEAP32[i16 + (i4 << 2) >> 2] << 3) | 0;
    i13 = HEAP32[i12 + 4 >> 2] | 0;
    i14 = i17 + 20 + (i4 << 3) | 0;
    HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i14 + 4 >> 2] = i13;
    if ((i4 | 0) == (i5 | 0)) break; else i4 = i4 + 1 | 0;
   }
   if (i6) {
    f3 = Math_fround(0.0);
    f2 = Math_fround(0.0);
    f1 = Math_fround(0.0);
   } else {
    i4 = 0;
    do {
     i6 = i4;
     i4 = i4 + 1 | 0;
     i8 = (i6 | 0) < (i5 | 0) ? i4 : 0;
     f3 = Math_fround(HEAPF32[i17 + 20 + (i8 << 3) >> 2]);
     f3 = Math_fround(f3 - Math_fround(HEAPF32[i17 + 20 + (i6 << 3) >> 2]));
     f1 = Math_fround(HEAPF32[i17 + 20 + (i8 << 3) + 4 >> 2]);
     f1 = Math_fround(f1 - Math_fround(HEAPF32[i17 + 20 + (i6 << 3) + 4 >> 2]));
     f2 = Math_fround(-f3);
     i8 = i17 + 84 + (i6 << 3) | 0;
     HEAPF32[i8 >> 2] = f1;
     i7 = i17 + 84 + (i6 << 3) + 4 | 0;
     HEAPF32[i7 >> 2] = f2;
     f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1))));
     if (!(f3 < Math_fround(1.1920929e-07))) {
      f10 = Math_fround(Math_fround(1.0) / f3);
      HEAPF32[i8 >> 2] = Math_fround(f1 * f10);
      HEAPF32[i7 >> 2] = Math_fround(f10 * f2);
     }
    } while ((i6 | 0) != (i5 | 0));
    i6 = i17 + 20 | 0;
    if ((i5 | 0) > -1) {
     i4 = 0;
     f1 = Math_fround(0.0);
     f2 = Math_fround(0.0);
     do {
      f1 = Math_fround(f1 + Math_fround(HEAPF32[i17 + 20 + (i4 << 3) >> 2]));
      f2 = Math_fround(f2 + Math_fround(HEAPF32[i17 + 20 + (i4 << 3) + 4 >> 2]));
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i11 | 0));
     f9 = Math_fround(Math_fround(1.0) / Math_fround(i11 | 0));
     f10 = Math_fround(f9 * f1);
     f9 = Math_fround(f9 * f2);
     i4 = 0;
     f3 = Math_fround(0.0);
     f2 = Math_fround(0.0);
     f1 = Math_fround(0.0);
     do {
      f23 = Math_fround(HEAPF32[i17 + 20 + (i4 << 3) >> 2]);
      f21 = Math_fround(HEAPF32[i17 + 20 + (i4 << 3) + 4 >> 2]);
      i16 = i4;
      i4 = i4 + 1 | 0;
      i16 = (i16 | 0) < (i5 | 0) ? i17 + 20 + (i4 << 3) | 0 : i6;
      f22 = Math_fround(HEAPF32[i16 >> 2]);
      f20 = Math_fround(HEAPF32[i16 + 4 >> 2]);
      f19 = Math_fround(Math_fround(Math_fround(Math_fround(f23 - f10) * Math_fround(f20 - f9)) - Math_fround(Math_fround(f21 - f9) * Math_fround(f22 - f10))) * Math_fround(.5));
      f3 = Math_fround(f3 + f19);
      f19 = Math_fround(f19 * Math_fround(.333333343));
      f2 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f10 + f23) + f22) * f19));
      f1 = Math_fround(f1 + Math_fround(Math_fround(Math_fround(f9 + f21) + f20) * f19));
     } while ((i4 | 0) != (i11 | 0));
    } else {
     f3 = Math_fround(0.0);
     f2 = Math_fround(0.0);
     f1 = Math_fround(0.0);
    }
   }
  }
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f3))));
  f23 = Math_fround(f1 * f22);
  HEAPF32[i17 + 12 >> 2] = Math_fround(f2 * f22);
  HEAPF32[i17 + 16 >> 2] = f23;
 }
 STACKTOP = i18;
 return;
}

function __ZNK27StateMachineBehaviourPlayer13FireBehaviourER8StateKeyR18ScriptingArgumentsN7mecanim12statemachine19StateMachineMessageEb(i42, i9, i44, i45, i46) {
 i42 = i42 | 0;
 i9 = i9 | 0;
 i44 = i44 | 0;
 i45 = i45 | 0;
 i46 = i46 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i52 = i55 + 272 | 0;
 i53 = i55 + 264 | 0;
 i47 = i55 + 248 | 0;
 i48 = i55 + 256 | 0;
 i49 = i55;
 i50 = i55 + 240 | 0;
 i51 = i42 + 8 | 0;
 i43 = HEAP32[i51 >> 2] | 0;
 i43 = mftCall_ii(HEAP32[(HEAP32[i43 >> 2] | 0) + 8 >> 2] | 0, i43 | 0) | 0;
 i11 = HEAP32[i51 >> 2] | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0;
 i10 = HEAP32[i51 >> 2] | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0) | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 i1 = i10 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i7 = HEAP32[i9 >> 2] | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i6 = i1;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i6 | 0) / 2 | 0;
   i4 = i3 + (i2 << 4) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) == (i7 | 0)) {
    if ((HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0) < (i8 | 0)) i54 = 7;
   } else if (i5 >>> 0 < i7 >>> 0) i54 = 7;
   if ((i54 | 0) == 7) {
    i54 = 0;
    i3 = i4 + 16 | 0;
    i2 = i6 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i6 = i2;
  }
 }
 do if ((i1 | 0) == (i10 | 0)) i54 = 12; else {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i9 + 4 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0)) {
   i54 = 12;
   break;
  } else break; else if (i2 >>> 0 < i3 >>> 0) {
   i54 = 12;
   break;
  } else break;
 } while (0);
 if ((i54 | 0) == 12) i1 = i10;
 i41 = HEAP32[i51 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0) | 0) + 8 >> 2] | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = i1 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i41 = i1 + i2 | 0;
 if (i2 >>> 0 >= i41 >>> 0) {
  i54 = 0;
  STACKTOP = i55;
  return i54 | 0;
 }
 i17 = i11 + 16 | 0;
 i18 = i43 + 12 | 0;
 i19 = i52 + 11 | 0;
 i20 = i47 + 4 | 0;
 i7 = i48 + 4 | 0;
 i21 = i42 + 4 | 0;
 i8 = i50 + 4 | 0;
 i22 = i49 + 96 | 0;
 i23 = i44 + 96 | 0;
 i24 = i49 + 100 | 0;
 i25 = i44 + 100 | 0;
 i26 = i49 + 104 | 0;
 i27 = i44 + 104 | 0;
 i28 = i49 + 108 | 0;
 i29 = i44 + 108 | 0;
 i30 = i49 + 112 | 0;
 i31 = i44 + 112 | 0;
 i32 = i49 + 116 | 0;
 i33 = i44 + 116 | 0;
 i34 = i49 + 120 | 0;
 i35 = i44 + 120 | 0;
 i36 = i49 + 124 | 0;
 i37 = i44 + 124 | 0;
 i38 = i49 + 128 | 0;
 i39 = i44 + 128 | 0;
 i40 = i49 + 132 | 0;
 i9 = i44 + 132 | 0;
 i10 = i49 + 136 | 0;
 i11 = i44 + 136 | 0;
 i12 = i49 + 140 | 0;
 i13 = i44 + 140 | 0;
 i14 = i49 + 144 | 0;
 i15 = i44 + 144 | 0;
 i16 = i49 + 216 | 0;
 i1 = 0;
 i6 = i2;
 while (1) {
  i5 = HEAP32[i51 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0) | 0)) {
   i54 = 18;
   break;
  }
  i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  L29 : do if (i2 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0) {
   i5 = (HEAP32[i43 >> 2] | 0) + (i2 << 2) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    HEAP32[i47 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i54 = 26; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i52, i2, i47);
      i3 = HEAP32[i52 >> 2] | 0;
      i56 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i56 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i56 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i54 = 26; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i54 = 28;
     }
    }
    if ((i54 | 0) == 26) i54 = 28;
    if ((i54 | 0) == 28) {
     i54 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i2) break;
    }
    i4 = i2 + 20 | 0;
    if (HEAP32[i4 >> 2] | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) {
     switch (i45 | 0) {
     case 1:
      {
       i3 = 20;
       break;
      }
     case 2:
      {
       i3 = 21;
       break;
      }
     case 4:
      {
       i3 = 22;
       break;
      }
     case 8:
      {
       i3 = 23;
       break;
      }
     case 16:
      {
       i3 = 24;
       break;
      }
     case 32:
      {
       i3 = 25;
       break;
      }
     case 64:
      {
       i3 = 26;
       break;
      }
     default:
      {
       HEAP32[i53 >> 2] = i45;
       __Z6FormatPKcz(i52, gb + 900139 | 0, i53);
       i2 = HEAP32[i42 >> 2] | 0;
       if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 >> 0] | 0) < 0 ? HEAP32[i52 >> 2] | 0 : i52, 0, gb + 900161 | 0, 63, 512, i2, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i52);
       break L29;
      }
     }
     i56 = HEAP32[i2 + 60 >> 2] | 0;
     i5 = HEAP32[i56 + (i3 << 3) >> 2] | 0;
     i3 = HEAP32[i56 + (i3 << 3) + 4 >> 2] | 0;
     if (i5) {
      HEAP32[i20 >> 2] = 0;
      HEAP32[i47 >> 2] = 0;
      HEAP32[i48 >> 2] = i5;
      HEAP32[i7 >> 2] = i3;
      HEAP32[i52 >> 2] = HEAP32[i48 >> 2];
      HEAP32[i52 + 4 >> 2] = HEAP32[i48 + 4 >> 2];
      i56 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i52) | 0;
      if (i46 ? (i56 | 0) == 4 : (i56 | 0) == 3) {
       __ZN8Playable6HandleEv(i52, HEAP32[i21 >> 2] | 0);
       i58 = i52;
       i57 = HEAP32[i58 + 4 >> 2] | 0;
       i56 = i47;
       HEAP32[i56 >> 2] = HEAP32[i58 >> 2];
       HEAP32[i56 + 4 >> 2] = i57;
       __ZN18ScriptingArguments9AddStructEPKv(i44, i47);
      }
      i4 = HEAP32[i4 >> 2] | 0;
      HEAP32[i50 >> 2] = i5;
      HEAP32[i8 >> 2] = i3;
      HEAP32[i52 >> 2] = HEAP32[i50 >> 2];
      HEAP32[i52 + 4 >> 2] = HEAP32[i50 + 4 >> 2];
      __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i49, i4, i52);
      HEAP32[i52 >> 2] = 0;
      i3 = i49;
      i4 = i44;
      i5 = i3 + 96 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i5 | 0));
      HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
      HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
      HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
      HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
      HEAP32[i38 >> 2] = HEAP32[i39 >> 2];
      HEAP32[i40 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
      i3 = i14;
      i4 = i15;
      i5 = i3 + 52 | 0;
      do {
       HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 4 | 0;
       i4 = i4 + 4 | 0;
      } while ((i3 | 0) < (i5 | 0));
      HEAP32[i16 >> 2] = HEAP32[i2 + 4 >> 2];
      __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i49, i52, 0) | 0;
      i1 = i1 | (HEAP32[i52 >> 2] | 0) == 0;
     }
    }
   }
  } while (0);
  i6 = i6 + 1 | 0;
  if (i6 >>> 0 >= i41 >>> 0) {
   i54 = 18;
   break;
  }
 }
 if ((i54 | 0) == 18) {
  STACKTOP = i55;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i32, i31) {
 i32 = i32 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i33 + 348 | 0;
 i2 = i33 + 336 | 0;
 i13 = i33 + 324 | 0;
 i24 = i33 + 312 | 0;
 i25 = i33 + 300 | 0;
 i26 = i33 + 288 | 0;
 i27 = i33 + 276 | 0;
 i28 = i33 + 264 | 0;
 i29 = i33 + 252 | 0;
 i30 = i33 + 240 | 0;
 i3 = i33 + 228 | 0;
 i4 = i33 + 216 | 0;
 i5 = i33 + 204 | 0;
 i6 = i33 + 192 | 0;
 i7 = i33 + 180 | 0;
 i8 = i33 + 168 | 0;
 i9 = i33 + 156 | 0;
 i10 = i33 + 144 | 0;
 i11 = i33 + 132 | 0;
 i12 = i33 + 120 | 0;
 i14 = i33 + 108 | 0;
 i15 = i33 + 96 | 0;
 i16 = i33 + 84 | 0;
 i17 = i33 + 72 | 0;
 i18 = i33 + 60 | 0;
 i19 = i33 + 48 | 0;
 i20 = i33 + 36 | 0;
 i21 = i33 + 24 | 0;
 i22 = i33 + 12 | 0;
 i23 = i33;
 if (!(HEAP8[i31 + 24 >> 0] | 0)) {
  HEAP32[i32 >> 2] = 4;
  HEAP32[i32 + 32 >> 2] = 0;
  i27 = i31 + 4 | 0;
  i24 = HEAP32[i27 >> 2] | 0;
  i28 = i31 + 8 | 0;
  i29 = HEAP32[i28 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i9 + 4 >> 2] = i24;
  HEAP32[i9 + 8 >> 2] = i29;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i9) | 0;
  i29 = i31 + 16 | 0;
  i24 = HEAP32[i29 >> 2] | 0;
  i25 = HEAP32[i28 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i10 + 4 >> 2] = i24;
  HEAP32[i10 + 8 >> 2] = i25;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i10) | 0;
  i25 = i31 + 12 | 0;
  i24 = HEAP32[i27 >> 2] | 0;
  i30 = HEAP32[i28 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i11 + 4 >> 2] = i24;
  HEAP32[i11 + 8 >> 2] = i30;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i11) | 0;
  i30 = HEAP32[i29 >> 2] | 0;
  i24 = HEAP32[i28 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i12 + 4 >> 2] = i30;
  HEAP32[i12 + 8 >> 2] = i24;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i12) | 0;
  i24 = HEAP32[i29 >> 2] | 0;
  i30 = i31 + 20 | 0;
  i26 = HEAP32[i30 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i14 + 4 >> 2] = i24;
  HEAP32[i14 + 8 >> 2] = i26;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i14) | 0;
  i26 = HEAP32[i29 >> 2] | 0;
  i24 = HEAP32[i28 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i15 + 4 >> 2] = i26;
  HEAP32[i15 + 8 >> 2] = i24;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i15) | 0;
  i24 = HEAP32[i29 >> 2] | 0;
  i26 = HEAP32[i30 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i16 + 4 >> 2] = i24;
  HEAP32[i16 + 8 >> 2] = i26;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i16) | 0;
  i26 = HEAP32[i27 >> 2] | 0;
  i24 = HEAP32[i28 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i17 + 4 >> 2] = i26;
  HEAP32[i17 + 8 >> 2] = i24;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i17) | 0;
  i24 = HEAP32[i27 >> 2] | 0;
  i26 = HEAP32[i30 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i18 + 4 >> 2] = i24;
  HEAP32[i18 + 8 >> 2] = i26;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i18) | 0;
  i26 = HEAP32[i27 >> 2] | 0;
  i28 = HEAP32[i28 >> 2] | 0;
  HEAP32[i19 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i19 + 4 >> 2] = i26;
  HEAP32[i19 + 8 >> 2] = i28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i19) | 0;
  i28 = HEAP32[i27 >> 2] | 0;
  i26 = HEAP32[i30 >> 2] | 0;
  HEAP32[i20 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i20 + 4 >> 2] = i28;
  HEAP32[i20 + 8 >> 2] = i26;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i20) | 0;
  i26 = HEAP32[i29 >> 2] | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  HEAP32[i21 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i21 + 4 >> 2] = i26;
  HEAP32[i21 + 8 >> 2] = i28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i21) | 0;
  i27 = HEAP32[i27 >> 2] | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  HEAP32[i22 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i22 + 4 >> 2] = i27;
  HEAP32[i22 + 8 >> 2] = i28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i22) | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  i30 = HEAP32[i30 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i23 + 4 >> 2] = i29;
  HEAP32[i23 + 8 >> 2] = i30;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i23) | 0;
  STACKTOP = i33;
  return i32 | 0;
 } else {
  HEAP32[i32 >> 2] = 2;
  i19 = i32 + 32 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i31 + 4 | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  i22 = i31 + 8 | 0;
  i21 = HEAP32[i22 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i1 + 4 >> 2] = i18;
  HEAP32[i1 + 8 >> 2] = i21;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i1) | 0;
  i21 = i31 + 12 | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  i23 = HEAP32[i22 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i2 + 4 >> 2] = i18;
  HEAP32[i2 + 8 >> 2] = i23;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i2) | 0;
  i23 = i31 + 16 | 0;
  i18 = HEAP32[i23 >> 2] | 0;
  i17 = HEAP32[i22 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i13 + 4 >> 2] = i18;
  HEAP32[i13 + 8 >> 2] = i17;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i13) | 0;
  i17 = HEAP32[i23 >> 2] | 0;
  i18 = HEAP32[i22 >> 2] | 0;
  HEAP32[i24 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i24 + 4 >> 2] = i17;
  HEAP32[i24 + 8 >> 2] = i18;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i24) | 0;
  i24 = HEAP32[i20 >> 2] | 0;
  i18 = HEAP32[i22 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i25 + 4 >> 2] = i24;
  HEAP32[i25 + 8 >> 2] = i18;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i25) | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  i25 = i31 + 20 | 0;
  i24 = HEAP32[i25 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i26 + 4 >> 2] = i18;
  HEAP32[i26 + 8 >> 2] = i24;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i26) | 0;
  i24 = HEAP32[i20 >> 2] | 0;
  i26 = HEAP32[i25 >> 2] | 0;
  HEAP32[i27 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i27 + 4 >> 2] = i24;
  HEAP32[i27 + 8 >> 2] = i26;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i27) | 0;
  i26 = HEAP32[i23 >> 2] | 0;
  i27 = HEAP32[i25 >> 2] | 0;
  HEAP32[i28 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i28 + 4 >> 2] = i26;
  HEAP32[i28 + 8 >> 2] = i27;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i28) | 0;
  i27 = HEAP32[i23 >> 2] | 0;
  i28 = HEAP32[i25 >> 2] | 0;
  HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i29 + 4 >> 2] = i27;
  HEAP32[i29 + 8 >> 2] = i28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i29) | 0;
  i28 = HEAP32[i20 >> 2] | 0;
  i29 = HEAP32[i25 >> 2] | 0;
  HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i30 + 4 >> 2] = i28;
  HEAP32[i30 + 8 >> 2] = i29;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i30) | 0;
  HEAP32[i32 >> 2] = 1;
  HEAP32[i19 >> 2] = 0;
  i30 = HEAP32[i20 >> 2] | 0;
  i29 = HEAP32[i22 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i3 + 4 >> 2] = i30;
  HEAP32[i3 + 8 >> 2] = i29;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i3) | 0;
  i29 = HEAP32[i20 >> 2] | 0;
  i30 = HEAP32[i25 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i4 + 4 >> 2] = i29;
  HEAP32[i4 + 8 >> 2] = i30;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i4) | 0;
  i30 = HEAP32[i23 >> 2] | 0;
  i29 = HEAP32[i22 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i5 + 4 >> 2] = i30;
  HEAP32[i5 + 8 >> 2] = i29;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i5) | 0;
  i29 = HEAP32[i23 >> 2] | 0;
  i30 = HEAP32[i25 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i6 + 4 >> 2] = i29;
  HEAP32[i6 + 8 >> 2] = i30;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i6) | 0;
  i30 = HEAP32[i23 >> 2] | 0;
  i29 = HEAP32[i22 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i7 + 4 >> 2] = i30;
  HEAP32[i7 + 8 >> 2] = i29;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i7) | 0;
  i29 = HEAP32[i23 >> 2] | 0;
  i30 = HEAP32[i25 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i8 + 4 >> 2] = i29;
  HEAP32[i8 + 8 >> 2] = i30;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i8) | 0;
  STACKTOP = i33;
  return i32 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_123SphericalJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i19, i18, i2, i7, i1) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 28 | 0;
 i16 = i17;
 f10 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(HEAPF32[i18 + 20 >> 2]) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(f10 * f4);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f3 * f9));
 f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f25 * f21));
 f8 = Math_fround(Math_fround(f4 * f22) + Math_fround(Math_fround(f10 * f5) + Math_fround(f6 * Math_fround(Math_fround(f25 * f9) - Math_fround(f3 * f21)))));
 f20 = Math_fround(Math_fround(f9 * f22) + Math_fround(Math_fround(f3 * f5) + Math_fround(f6 * Math_fround(Math_fround(f10 * f21) - Math_fround(f25 * f4)))));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f5) + Math_fround(f6 * Math_fround(Math_fround(f3 * f4) - Math_fround(f10 * f9)))) + Math_fround(f21 * f22));
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f8);
 f20 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f20);
 f22 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f22);
 f10 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(f6 * f10);
 f5 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f4 * f5));
 f25 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f9 * f25));
 f15 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f23 = Math_fround(Math_fround(Math_fround(f21 * f10) + Math_fround(Math_fround(f9 * f5) + Math_fround(f6 * f15))) - Math_fround(f4 * f25));
 f24 = Math_fround(Math_fround(Math_fround(f4 * f15) + Math_fround(Math_fround(f21 * f5) + Math_fround(f6 * f25))) - Math_fround(f9 * f10));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f5) - Math_fround(f4 * f10)) - Math_fround(f9 * f15)) - Math_fround(f21 * f25));
 HEAPF32[i1 >> 2] = Math_fround(f3 - Math_fround(f21 * f15));
 i2 = i1 + 4 | 0;
 HEAPF32[i2 >> 2] = f23;
 i11 = i1 + 8 | 0;
 HEAPF32[i11 >> 2] = f24;
 i12 = i1 + 12 | 0;
 HEAPF32[i12 >> 2] = f25;
 HEAPF32[i1 + 16 >> 2] = f8;
 HEAPF32[i1 + 20 >> 2] = f20;
 HEAPF32[i1 + 24 >> 2] = f22;
 f22 = Math_fround(Math_fround(HEAPF32[i18 + 44 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(HEAPF32[i18 + 48 >> 2]) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(HEAPF32[i18 + 52 >> 2]) * Math_fround(2.0));
 f25 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f24 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i7 >> 2]);
 f15 = Math_fround(f22 * f23);
 f21 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f20 * f21));
 f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f8 * f3));
 f9 = Math_fround(Math_fround(f23 * f15) + Math_fround(Math_fround(f22 * f24) + Math_fround(f25 * Math_fround(Math_fround(f8 * f21) - Math_fround(f20 * f3)))));
 f10 = Math_fround(Math_fround(f21 * f15) + Math_fround(Math_fround(f20 * f24) + Math_fround(f25 * Math_fround(Math_fround(f22 * f3) - Math_fround(f8 * f23)))));
 f15 = Math_fround(Math_fround(Math_fround(f8 * f24) + Math_fround(f25 * Math_fround(Math_fround(f20 * f23) - Math_fround(f22 * f21)))) + Math_fround(f3 * f15));
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f9);
 f10 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f10);
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f15);
 f22 = Math_fround(HEAPF32[i18 + 28 >> 2]);
 f20 = Math_fround(f25 * f22);
 f24 = Math_fround(HEAPF32[i18 + 40 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f23 * f24));
 f8 = Math_fround(HEAPF32[i18 + 36 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f21 * f8));
 f4 = Math_fround(HEAPF32[i18 + 32 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f3 * f22) + Math_fround(Math_fround(f21 * f24) + Math_fround(f25 * f4))) - Math_fround(f23 * f8));
 f6 = Math_fround(Math_fround(Math_fround(f23 * f4) + Math_fround(Math_fround(f3 * f24) + Math_fround(f25 * f8))) - Math_fround(f21 * f22));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f4)) - Math_fround(f3 * f8));
 HEAPF32[i16 >> 2] = Math_fround(f20 - Math_fround(f3 * f4));
 i7 = i16 + 4 | 0;
 HEAPF32[i7 >> 2] = f5;
 i13 = i16 + 8 | 0;
 HEAPF32[i13 >> 2] = f6;
 i14 = i16 + 12 | 0;
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i16 + 16 >> 2] = f9;
 HEAPF32[i16 + 20 >> 2] = f10;
 HEAPF32[i16 + 24 >> 2] = f15;
 mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 | 0, i16 | 0);
 if (!(HEAP16[i18 + 116 >> 1] & 2)) {
  STACKTOP = i17;
  return;
 }
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i16 >> 2]);
 f25 = Math_fround(f10 * f6);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f9 * f3));
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f5 = Math_fround(HEAPF32[i13 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f8 * f5));
 f15 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(HEAPF32[i14 >> 2]);
 if (Math_fround(f25 + Math_fround(f15 * f4)) < Math_fround(0.0)) {
  f6 = Math_fround(-f6);
  f3 = Math_fround(-f3);
  f5 = Math_fround(-f5);
  f4 = Math_fround(-f4);
  HEAPF32[i16 >> 2] = f6;
  HEAPF32[i7 >> 2] = f3;
  HEAPF32[i13 >> 2] = f5;
  HEAPF32[i14 >> 2] = f4;
 }
 f23 = Math_fround(-f10);
 f24 = Math_fround(-f9);
 f25 = Math_fround(-f8);
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f6) + Math_fround(f4 * f23)) + Math_fround(f5 * f24)) - Math_fround(f3 * f25));
 f9 = Math_fround(Math_fround(Math_fround(f6 * f25) + Math_fround(Math_fround(f4 * f24) + Math_fround(f15 * f3))) - Math_fround(f5 * f23));
 f10 = Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(Math_fround(f4 * f25) + Math_fround(f15 * f5))) - Math_fround(f6 * f24));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f4) - Math_fround(f6 * f23)) - Math_fround(f3 * f24)) - Math_fround(f5 * f25));
 if (f8 != Math_fround(0.0)) {
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(0.0)) + Math_fround(f3 * f3)))));
  f4 = Math_fround(f8 * f6);
  f5 = Math_fround(f6 * Math_fround(0.0));
  f6 = Math_fround(f3 * f6);
 } else {
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(1.0);
 }
 f23 = Math_fround(-f4);
 f25 = Math_fround(-f5);
 f21 = Math_fround(f3 * f25);
 f22 = Math_fround(f8 * f25);
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f3 * f6) - Math_fround(f8 * f23)) - Math_fround(f9 * f25)) - Math_fround(f10 * f25)) + Math_fround(1.0));
 f24 = Math_fround(Math_fround(Math_fround(f22 + Math_fround(Math_fround(f10 * f6) + f21)) - Math_fround(f9 * f23)) / f25);
 f25 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f9 * f6) + f21) + Math_fround(f10 * f23)) - f22) / f25));
 f22 = Math_fround(HEAPF32[i18 + 104 >> 2]);
 f23 = Math_fround(HEAPF32[i18 + 100 >> 2]);
 f21 = Math_fround(HEAPF32[i18 + 108 >> 2]);
 f24 = Math_fround(Math_abs(Math_fround(f24)));
 f25 = Math_fround(Math_abs(Math_fround(f25)));
 f24 = Math_fround(Math_fround(Math_fround(f21 + f24) / Math_fround(Math_fround(1.0) - Math_fround(f21 * f24))) / f22);
 f25 = Math_fround(Math_fround(Math_fround(f21 + f25) / Math_fround(Math_fround(1.0) - Math_fround(f21 * f25))) / f23);
 mftCall_viiffi(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, i19 | 0, i16 | 0, +f22, +f23, !(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) <= Math_fround(1.0)) | 0);
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_(i18, i19, i16, i13, i9, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0;
 i17 = __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_(i18, i19, i16, i13, i1) | 0;
 i5 = i9;
 i8 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i13;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 do if ((i8 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
  i1 = i9 + 8 | 0;
  i15 = i1;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i3 = i13 + 8 | 0;
  i2 = i3;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(i14 >>> 0 < i2 >>> 0 | ((i14 | 0) == (i2 | 0) ? (HEAP32[i15 >> 2] | 0) >>> 0 < i4 >>> 0 : 0))) {
   i19 = i17;
   return i19 | 0;
  }
 } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i8 >>> 0 < i6 >>> 0) {
  i3 = i13 + 8 | 0;
  i2 = i3;
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  break;
 } else {
  i19 = i17;
  return i19 | 0;
 } while (0);
 i11 = i13;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i5;
 i11 = i1;
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i3;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i5;
 i10 = i9;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = i2;
 i10 = i13 + 16 | 0;
 i5 = i10;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i11 = i13 + 24 | 0;
 i8 = i11;
 i15 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i13 + 32 | 0;
 i7 = i12;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i9 + 16 | 0;
 i21 = i1;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i14 = i10;
 HEAP32[i14 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i14 + 4 >> 2] = i20;
 i14 = i9 + 24 | 0;
 i20 = i14;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i21;
 i2 = i9 + 32 | 0;
 i21 = i2;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i9 + 4 >> 2] = i20;
 i9 = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i14;
 HEAP32[i9 >> 2] = i15;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i17 + 1 | 0;
 i7 = i13;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i16;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 do if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
  i21 = i3;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i4 = i16 + 8 | 0;
  i1 = i4;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i20 >>> 0 < i1 >>> 0 | ((i20 | 0) == (i1 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) i2 = i5; else {
   i21 = i2;
   return i21 | 0;
  }
 } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
  i4 = i16 + 8 | 0;
  i1 = i4;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  break;
 } else {
  i21 = i2;
  return i21 | 0;
 } while (0);
 i14 = i16;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i7;
 i14 = i3;
 i20 = HEAP32[i14 + 4 >> 2] | 0;
 i21 = i4;
 HEAP32[i21 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i13 + 4 >> 2] = i9;
 i13 = i3;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i1;
 i13 = i16 + 16 | 0;
 i21 = i13;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 i14 = i16 + 24 | 0;
 i9 = i14;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = i16 + 32 | 0;
 i7 = i15;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i13;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i11;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i14;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = i12;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i15;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i10;
 HEAP32[i2 >> 2] = i20;
 HEAP32[i2 + 4 >> 2] = i21;
 i2 = i11;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = i12;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i17 + 2 | 0;
 i7 = i16;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i19;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 do if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
  i21 = i4;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = i19 + 8 | 0;
  i1 = i3;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i20 >>> 0 < i1 >>> 0 | ((i20 | 0) == (i1 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) {
   i12 = i3;
   i2 = i5;
  } else {
   i21 = i2;
   return i21 | 0;
  }
 } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
  i12 = i19 + 8 | 0;
  i1 = i12;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  break;
 } else {
  i21 = i2;
  return i21 | 0;
 } while (0);
 i10 = i19;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i4;
 i20 = HEAP32[i10 + 4 >> 2] | 0;
 i21 = i12;
 HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 i21 = i16;
 HEAP32[i21 >> 2] = i8;
 HEAP32[i21 + 4 >> 2] = i9;
 i9 = i4;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i19 + 16 | 0;
 i21 = i9;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 i10 = i19 + 24 | 0;
 i8 = i10;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i19 + 32 | 0;
 i6 = i11;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i13;
 i16 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i16;
 i2 = i14;
 i16 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i16;
 i4 = i15;
 i16 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i16;
 i2 = i13;
 HEAP32[i2 >> 2] = i20;
 HEAP32[i2 + 4 >> 2] = i21;
 i2 = i14;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i15;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = i17 + 3 | 0;
 i6 = i19;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i18;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 do if ((i5 | 0) == (i7 | 0) & (i6 | 0) == (i8 | 0)) {
  i21 = i12;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = i18 + 8 | 0;
  i1 = i3;
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i20 >>> 0 < i1 >>> 0 | ((i20 | 0) == (i1 | 0) ? (HEAP32[i21 >> 2] | 0) >>> 0 < i4 >>> 0 : 0)) i2 = i4; else {
   i21 = i2;
   return i21 | 0;
  }
 } else if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
  i3 = i18 + 8 | 0;
  i1 = i3;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  break;
 } else {
  i21 = i2;
  return i21 | 0;
 } while (0);
 i16 = i18;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i6;
 i16 = i12;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i3;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 i14 = i19;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i14 + 4 >> 2] = i8;
 i8 = i12;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i18 + 16 | 0;
 i14 = i8;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i18 + 24 | 0;
 i16 = i12;
 i15 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i21 = i18 + 32 | 0;
 i20 = i21;
 i19 = HEAP32[i20 >> 2] | 0;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 i7 = i9;
 i18 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i18;
 i8 = i10;
 i18 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i18;
 i12 = i11;
 i18 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = i18;
 i21 = i9;
 HEAP32[i21 >> 2] = i13;
 HEAP32[i21 + 4 >> 2] = i14;
 i21 = i10;
 HEAP32[i21 >> 2] = i15;
 HEAP32[i21 + 4 >> 2] = i16;
 i21 = i11;
 HEAP32[i21 >> 2] = i19;
 HEAP32[i21 + 4 >> 2] = i20;
 i21 = i17 + 4 | 0;
 return i21 | 0;
}

function __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i15, i10) {
 i15 = i15 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 8 | 0;
 i11 = i17;
 i13 = i17 + 28 | 0;
 i14 = i17 + 16 | 0;
 i4 = i15 + 68 | 0;
 HEAP8[i4 >> 0] = 0;
 i5 = i15 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) i2 = 0; else {
  i3 = 0;
  do {
   __ZN9ShaderLab9SubShader8PostLoadEP6Shader(HEAP32[i1 + (i3 << 2) >> 2] | 0, i10);
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP8[i4 >> 0] = HEAP8[i4 >> 0] | HEAP8[(HEAP32[i2 + (i3 << 2) >> 2] | 0) + 47 >> 0];
   i3 = i3 + 1 | 0;
   i1 = i2;
   i2 = (HEAP32[i5 >> 2] | 0) - i1 >> 2;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i7 = HEAP32[i15 + 56 >> 2] | 0;
 i7 = (i7 | 0) == -1 ? HEAP32[gb + 1166412 >> 2] | 0 : i7;
 i9 = i15 + 48 | 0;
 HEAP32[i9 >> 2] = -1;
 if (!i2) {
  HEAP32[i15 + 24 >> 2] = -1;
  HEAP32[i15 + 28 >> 2] = -1;
  HEAP32[i15 + 32 >> 2] = -1;
  HEAP32[i15 + 36 >> 2] = -1;
  HEAP32[i15 + 40 >> 2] = -1;
  HEAP32[i15 + 44 >> 2] = -1;
  i16 = 19;
 } else {
  i6 = 0;
  while (1) {
   i8 = i15 + 24 + (i6 << 2) | 0;
   HEAP32[i8 >> 2] = -1;
   i4 = HEAP32[i15 >> 2] | 0;
   i5 = 1 << i6;
   i1 = 0;
   do {
    i3 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    if ((HEAP32[i3 + 20 >> 2] | 0) > 0) if ((HEAP32[i3 + 36 >> 2] | 0) <= (i7 | 0)) {
     if ((HEAP32[i9 >> 2] | 0) < 0) HEAP32[i9 >> 2] = i1;
     if (HEAP32[i3 + 40 >> 2] & i5 | 0) {
      i16 = 9;
      break;
     }
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
   if ((i16 | 0) == 9) {
    i16 = 0;
    HEAP32[i8 >> 2] = i1;
   }
   if ((i6 | 0) == 1) {
    i6 = 2;
    continue;
   }
   i3 = HEAP32[i8 >> 2] | 0;
   L22 : do if ((i3 | 0) != -1 & (i6 | 0) > 0) {
    i1 = 0;
    while (1) {
     i5 = HEAP32[i15 + 24 + (i1 << 2) >> 2] | 0;
     if ((i5 | 0) != -1 & (i5 | 0) < (i3 | 0)) break;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i6 | 0)) break L22;
    }
    HEAP32[i8 >> 2] = -1;
   } while (0);
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 6) break;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) < 0) i16 = 19;
 }
 if ((i16 | 0) == 19) {
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!(HEAP8[gb + 1546613 >> 0] | 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 481178 | 0, 15);
  i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  HEAP32[gb + 1170584 >> 2] = i9;
  HEAP8[gb + 1546613 >> 0] = 1;
 }
 if (!(HEAP8[gb + 1546614 >> 0] | 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1087447 | 0, 4);
  i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  HEAP32[gb + 1170588 >> 2] = i9;
  HEAP8[gb + 1546614 >> 0] = 1;
 }
 if (!(HEAP8[gb + 1546615 >> 0] | 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 481194 | 0, 9);
  i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  HEAP32[gb + 1170592 >> 2] = i9;
  HEAP8[gb + 1546615 >> 0] = 1;
 }
 i5 = i15 + 52 | 0;
 HEAP32[i5 >> 2] = 2e3;
 i7 = i1 + 28 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) HEAP8[i15 + 60 >> 0] = 0; else {
  i1 = i7;
  i4 = i3;
  L43 : while (1) {
   i2 = i4;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= 7) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L43;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i7 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) < 8) {
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   i1 = HEAP32[gb + 1166564 >> 2] | 0;
   i4 = i1 + 4 | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1;
   L53 : do if ((i2 | 0) == (i4 | 0)) i16 = 42; else {
    while (1) {
     if ((HEAP32[i2 + 20 >> 2] | 0) == (i3 | 0)) break;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (i4 | 0)) {
      i16 = 42;
      break L53;
     } else i1 = i2;
    }
    i9 = HEAP32[i2 + 16 >> 2] | 0;
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i9, _strlen(i9) | 0);
   } while (0);
   if ((i16 | 0) == 42) {
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 480497 | 0, 13);
   }
   if (!(__ZN9ShaderLab19ParseQueueAndOffsetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERi(i13, i5) | 0)) {
    if (!i10) {
     i1 = (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
     HEAP32[i12 >> 2] = gb + 585672;
     HEAP32[i12 + 4 >> 2] = i1;
     __Z6FormatPKcz(i14, gb + 481204 | 0, i12);
     i1 = 0;
    } else {
     i12 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
     i1 = (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
     HEAP32[i11 >> 2] = i12;
     HEAP32[i11 + 4 >> 2] = i1;
     __Z6FormatPKcz(i14, gb + 481204 | 0, i11);
     i1 = HEAP32[i10 + 4 >> 2] | 0;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 481096 | 0, 223, 1, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i5 = i15 + 60 | 0;
  HEAP8[i5 >> 0] = 0;
  i6 = (i3 | 0) == 0;
  if (!i6) {
   i1 = i7;
   i4 = i3;
   L76 : while (1) {
    i2 = i4;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >= 10) break;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) break L76;
    }
    i4 = HEAP32[i2 >> 2] | 0;
    if (!i4) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
   if ((i1 | 0) == (i7 | 0)) i16 = 59; else if ((HEAP32[i1 + 16 >> 2] | 0) < 11) if ((HEAP32[i1 + 20 >> 2] | 0) == 6) {
    HEAP8[i5 >> 0] = 1;
    i1 = i15 + 64 | 0;
    HEAP32[i1 >> 2] = 0;
    if (i6) {
     STACKTOP = i17;
     return;
    } else i5 = i1;
   } else i16 = 59; else i16 = 59;
   if ((i16 | 0) == 59) {
    i1 = i15 + 64 | 0;
    HEAP32[i1 >> 2] = 0;
    if (i6) {
     STACKTOP = i17;
     return;
    } else i5 = i1;
   }
   i4 = HEAP32[gb + 1170584 >> 2] | 0;
   i1 = i7;
   L92 : while (1) {
    i2 = i3;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) break L92;
    }
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
   if ((i1 | 0) == (i7 | 0)) {
    STACKTOP = i17;
    return;
   }
   if ((i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
    STACKTOP = i17;
    return;
   }
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[gb + 1170588 >> 2] | 0)) {
    HEAP32[i5 >> 2] = 1;
    STACKTOP = i17;
    return;
   }
   if ((i1 | 0) != (HEAP32[gb + 1170592 >> 2] | 0)) {
    STACKTOP = i17;
    return;
   }
   HEAP32[i5 >> 2] = 2;
   STACKTOP = i17;
   return;
  }
 }
 HEAP32[i15 + 64 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx23PxVehicleWheels4SimDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 12 >> 2] = Math_fround(.100000001);
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 60 >> 2] = Math_fround(.100000001);
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 108 >> 2] = Math_fround(.100000001);
 i2 = i1 + 112 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 156 >> 2] = Math_fround(.100000001);
 i2 = i1 + 160 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 192 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(.25);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1500.0);
 i2 = i1 + 216 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i1 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 248 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 256 >> 2] = Math_fround(.25);
 HEAPF32[i1 + 260 >> 2] = Math_fround(1500.0);
 i2 = i1 + 264 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i1 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 296 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 300 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 304 >> 2] = Math_fround(.25);
 HEAPF32[i1 + 308 >> 2] = Math_fround(1500.0);
 i2 = i1 + 312 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i1 + 336 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 344 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 352 >> 2] = Math_fround(.25);
 HEAPF32[i1 + 356 >> 2] = Math_fround(1500.0);
 i2 = i1 + 360 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i1 + 384 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 388 >> 2] = Math_fround(17.9049301);
 HEAPF32[i1 + 392 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 396 >> 2] = Math_fround(5.72957754);
 HEAP32[i1 + 424 >> 2] = 0;
 HEAPF32[i1 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 404 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 408 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 412 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 416 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 420 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 428 >> 2] = Math_fround(.00100000005);
 HEAPF32[i1 + 432 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 436 >> 2] = Math_fround(1.11111116);
 HEAPF32[i1 + 448 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 452 >> 2] = Math_fround(17.9049301);
 HEAPF32[i1 + 456 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 460 >> 2] = Math_fround(5.72957754);
 HEAP32[i1 + 488 >> 2] = 0;
 HEAPF32[i1 + 464 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 468 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 472 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 476 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 480 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 484 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 492 >> 2] = Math_fround(.00100000005);
 HEAPF32[i1 + 496 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 500 >> 2] = Math_fround(1.11111116);
 HEAPF32[i1 + 512 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 516 >> 2] = Math_fround(17.9049301);
 HEAPF32[i1 + 520 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 524 >> 2] = Math_fround(5.72957754);
 HEAP32[i1 + 552 >> 2] = 0;
 HEAPF32[i1 + 528 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 532 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 536 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 540 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 544 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 548 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 556 >> 2] = Math_fround(.00100000005);
 HEAPF32[i1 + 560 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 564 >> 2] = Math_fround(1.11111116);
 HEAPF32[i1 + 576 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 580 >> 2] = Math_fround(17.9049301);
 HEAPF32[i1 + 584 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 588 >> 2] = Math_fround(5.72957754);
 HEAP32[i1 + 616 >> 2] = 0;
 HEAPF32[i1 + 592 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 596 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 600 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 604 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 608 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 612 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 620 >> 2] = Math_fround(.00100000005);
 HEAPF32[i1 + 624 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 628 >> 2] = Math_fround(1.11111116);
 i2 = i1 + 864 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 880 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 896 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 912 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = 0;
 HEAP32[i1 + 644 >> 2] = 0;
 HEAP32[i1 + 648 >> 2] = 0;
 HEAP32[i1 + 688 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 696 >> 2] = 0;
 HEAP32[i1 + 736 >> 2] = 0;
 HEAP32[i1 + 740 >> 2] = 0;
 HEAP32[i1 + 744 >> 2] = 0;
 HEAP32[i1 + 784 >> 2] = 0;
 HEAP32[i1 + 788 >> 2] = 0;
 HEAP32[i1 + 792 >> 2] = 0;
 HEAPF32[i1 + 832 >> 2] = Math_fround(1520.0);
 HEAPF32[i1 + 848 >> 2] = Math_fround(.000657894765);
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 656 >> 2] = 0;
 HEAP32[i1 + 660 >> 2] = 0;
 HEAP32[i1 + 700 >> 2] = 0;
 HEAP32[i1 + 704 >> 2] = 0;
 HEAP32[i1 + 708 >> 2] = 0;
 HEAP32[i1 + 748 >> 2] = 0;
 HEAP32[i1 + 752 >> 2] = 0;
 HEAP32[i1 + 756 >> 2] = 0;
 HEAP32[i1 + 796 >> 2] = 0;
 HEAP32[i1 + 800 >> 2] = 0;
 HEAP32[i1 + 804 >> 2] = 0;
 HEAPF32[i1 + 836 >> 2] = Math_fround(1520.0);
 HEAPF32[i1 + 852 >> 2] = Math_fround(.000657894765);
 HEAP32[i1 + 664 >> 2] = 0;
 HEAP32[i1 + 668 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 HEAP32[i1 + 716 >> 2] = 0;
 HEAP32[i1 + 720 >> 2] = 0;
 HEAP32[i1 + 760 >> 2] = 0;
 HEAP32[i1 + 764 >> 2] = 0;
 HEAP32[i1 + 768 >> 2] = 0;
 HEAP32[i1 + 808 >> 2] = 0;
 HEAP32[i1 + 812 >> 2] = 0;
 HEAP32[i1 + 816 >> 2] = 0;
 HEAPF32[i1 + 840 >> 2] = Math_fround(1520.0);
 HEAPF32[i1 + 856 >> 2] = Math_fround(.000657894765);
 HEAP32[i1 + 676 >> 2] = 0;
 HEAP32[i1 + 680 >> 2] = 0;
 HEAP32[i1 + 684 >> 2] = 0;
 HEAP32[i1 + 724 >> 2] = 0;
 HEAP32[i1 + 728 >> 2] = 0;
 HEAP32[i1 + 732 >> 2] = 0;
 HEAP32[i1 + 772 >> 2] = 0;
 HEAP32[i1 + 776 >> 2] = 0;
 HEAP32[i1 + 780 >> 2] = 0;
 HEAP32[i1 + 820 >> 2] = 0;
 HEAP32[i1 + 824 >> 2] = 0;
 HEAP32[i1 + 828 >> 2] = 0;
 HEAPF32[i1 + 844 >> 2] = Math_fround(1520.0);
 HEAPF32[i1 + 860 >> 2] = Math_fround(.000657894765);
 return;
}

function __ZN5Umbra17LineSegmentFinder7executeEPNS_19ImpLineSegmentQueryEi(i22, i12, i14) {
 i22 = i22 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 if (!i14) {
  STACKTOP = i23;
  return;
 }
 L4 : do if ((i14 | 0) > 1) {
  f3 = Math_fround(HEAPF32[i12 >> 2]);
  i2 = i12 + 4 | 0;
  i4 = i12 + 8 | 0;
  i1 = 1;
  while (1) {
   if (!(Math_fround(HEAPF32[i12 + (i1 << 6) >> 2]) == f3)) {
    i8 = 0;
    break L4;
   }
   f24 = Math_fround(HEAPF32[i12 + (i1 << 6) + 4 >> 2]);
   if (!(f24 == Math_fround(HEAPF32[i2 >> 2]))) {
    i8 = 0;
    break L4;
   }
   f24 = Math_fround(HEAPF32[i12 + (i1 << 6) + 8 >> 2]);
   i1 = i1 + 1 | 0;
   if (f24 != Math_fround(HEAPF32[i4 >> 2])) {
    i8 = 0;
    break L4;
   }
   if ((i1 | 0) >= (i14 | 0)) {
    i8 = 1;
    break;
   }
  }
 } else i8 = 1; while (0);
 i6 = HEAP32[i22 >> 2] | 0;
 i2 = i6 + 16 | 0;
 i19 = HEAP32[i2 >> 2] | 0;
 i20 = i19 + 384 | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i13 = i20 >>> 0 > i5 >>> 0;
 i20 = i13 ? i19 : i20;
 i19 = i13 ? 0 : i19;
 i17 = i20 + 384 | 0;
 i15 = i17 >>> 0 > i5 >>> 0;
 i17 = i15 ? i20 : i17;
 i20 = i15 ? 0 : i20;
 i1 = i17 + 256 | 0;
 i16 = i1 >>> 0 > i5 >>> 0;
 i1 = i16 ? i17 : i1;
 i17 = i16 ? 0 : i17;
 i4 = i1 + 256 | 0;
 i5 = i4 >>> 0 > i5 >>> 0;
 i18 = i5 ? 0 : i1;
 if (!(i13 & i15 & i16 & i5)) HEAP32[i2 >> 2] = i5 ? i1 : i4;
 do if (i8) {
  i4 = __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i6, i12) | 0;
  if ((i4 | 0) == -1) {
   i1 = i22 + 4144 | 0;
   i16 = -1;
   i15 = -1;
   i2 = i1;
  } else {
   HEAP32[i7 >> 2] = -1;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = i7 + 28 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i7 + 32 >> 2] = 0;
   __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i6, i7, i4);
   i2 = HEAP32[i2 >> 2] | 0;
   if (!i2) {
    i2 = 0;
    i1 = -1;
    i4 = -1;
    i5 = 0;
   } else {
    i1 = __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i6, i2, i12) | 0;
    if ((i1 | 0) == -1) {
     i2 = 0;
     i1 = -1;
     i4 = -1;
     i5 = 0;
    } else {
     i5 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i2, i1, i12) | 0;
     i16 = (i5 | 0) < (HEAP32[i2 + 52 >> 2] & 65535 | 0);
     i2 = i16 ? 0 : 0;
     i1 = i4;
     i4 = i16 ? i5 : -1;
     i5 = 0;
    }
   }
   i6 = i22 + 4144 | 0;
   i1 = i2 | i1;
   i2 = i4 | i5;
   if (i8) {
    i16 = i1;
    i15 = i2;
    i2 = i6;
    i1 = i6;
   } else {
    i16 = i1;
    i15 = i2;
    i1 = i6;
    i2 = i6;
    i21 = 18;
    break;
   }
  }
  i4 = 0;
  while (1) {
   i13 = (i14 | 0) > 32 ? 32 : i14;
   i6 = (i14 | 0) > 0;
   if (i6) {
    i5 = 0;
    do {
     i11 = i19 + (i5 * 12 | 0) | 0;
     i10 = i12 + (i5 << 6) | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i11 = i20 + (i5 * 12 | 0) | 0;
     i10 = i12 + (i5 << 6) + 12 | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i11 = i17 + (i5 << 3) | 0;
     HEAP32[i11 >> 2] = i16;
     HEAP32[i11 + 4 >> 2] = i15;
     i11 = i18 + (i5 << 3) | 0;
     HEAP32[i11 >> 2] = -1;
     HEAP32[i11 + 4 >> 2] = -1;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (i13 | 0));
    if (i6) {
     i11 = 0;
     do {
      i9 = i17 + (i11 << 3) | 0;
      if ((HEAP32[i9 >> 2] | 0) == -1) i21 = 33; else if ((HEAP32[i17 + (i11 << 3) + 4 >> 2] | 0) == -1) i21 = 33; else {
       i8 = i12 + (i11 << 6) + 28 | 0;
       i10 = HEAP32[i8 >> 2] | 0;
       if (!((i10 | 0) == 0 | (i10 | 0) == (i4 | 0))) {
        i5 = HEAP32[i1 >> 2] | 0;
        i7 = HEAP32[i22 >> 2] | 0;
        i4 = i7 + 16 | 0;
        if (!i5) i5 = HEAP32[i4 >> 2] | 0; else HEAP32[i4 >> 2] = i5;
        HEAP32[i10 + 8 >> 2] = 0;
        i4 = (HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + 64 >> 2] | 0) + 31 >> 5 << 2;
        i6 = i5 + (i4 + 15 & -16) | 0;
        if (i6 >>> 0 > (HEAP32[i7 + 12 >> 2] | 0) >>> 0) {
         i5 = 0;
         i4 = i10;
        } else {
         HEAP32[i7 + 16 >> 2] = i6;
         if (!i5) {
          i5 = 0;
          i4 = i10;
         } else {
          _memset(i5 | 0, 0, i4 | 0) | 0;
          i4 = HEAP32[i8 >> 2] | 0;
         }
        }
        HEAP32[i1 >> 2] = i5;
       }
       HEAP32[i12 + (i11 << 6) + 24 >> 2] = (__ZN5Umbra17LineSegmentFinder13queryInternalILb1EEEbRKNS_7Vector3ES4_RNS_4CellES6_PNS_8UserListIiEE(i22, i19 + (i11 * 12 | 0) | 0, i20 + (i11 * 12 | 0) | 0, i9, i18 + (i11 << 3) | 0, i10) | 0) & 1;
      }
      if ((i21 | 0) == 33) {
       i21 = 0;
       HEAP32[i12 + (i11 << 6) + 24 >> 2] = 2;
      }
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) < (i13 | 0));
    }
   }
   i14 = i14 - i13 | 0;
   if (!i14) break; else i12 = i12 + (i13 << 6) | 0;
  }
 } else {
  i2 = i22 + 4144 | 0;
  i16 = -1;
  i15 = -1;
  i1 = i2;
  i21 = 18;
 } while (0);
 if ((i21 | 0) == 18) {
  i4 = 0;
  while (1) {
   i13 = (i14 | 0) > 32 ? 32 : i14;
   i6 = (i14 | 0) > 0;
   if (i6) {
    i5 = 0;
    do {
     i11 = i19 + (i5 * 12 | 0) | 0;
     i10 = i12 + (i5 << 6) | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i11 = i20 + (i5 * 12 | 0) | 0;
     i10 = i12 + (i5 << 6) + 12 | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i11 = i17 + (i5 << 3) | 0;
     HEAP32[i11 >> 2] = i16;
     HEAP32[i11 + 4 >> 2] = i15;
     i11 = i18 + (i5 << 3) | 0;
     HEAP32[i11 >> 2] = -1;
     HEAP32[i11 + 4 >> 2] = -1;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (i13 | 0));
    __ZN5Umbra12QueryContext17findMultipleCellsEPKNS_7Vector3EPNS_4CellEi(HEAP32[i22 >> 2] | 0, i19, i17, i13);
    if (i6) {
     i11 = 0;
     do {
      i9 = i17 + (i11 << 3) | 0;
      if ((HEAP32[i9 >> 2] | 0) == -1) i21 = 44; else if ((HEAP32[i17 + (i11 << 3) + 4 >> 2] | 0) == -1) i21 = 44; else {
       i8 = i12 + (i11 << 6) + 28 | 0;
       i10 = HEAP32[i8 >> 2] | 0;
       if (!((i10 | 0) == 0 | (i10 | 0) == (i4 | 0))) {
        i5 = HEAP32[i1 >> 2] | 0;
        i7 = HEAP32[i22 >> 2] | 0;
        i4 = i7 + 16 | 0;
        if (!i5) i5 = HEAP32[i4 >> 2] | 0; else HEAP32[i4 >> 2] = i5;
        HEAP32[i10 + 8 >> 2] = 0;
        i4 = (HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + 64 >> 2] | 0) + 31 >> 5 << 2;
        i6 = i5 + (i4 + 15 & -16) | 0;
        if (i6 >>> 0 > (HEAP32[i7 + 12 >> 2] | 0) >>> 0) {
         i5 = 0;
         i4 = i10;
        } else {
         HEAP32[i7 + 16 >> 2] = i6;
         if (!i5) {
          i5 = 0;
          i4 = i10;
         } else {
          _memset(i5 | 0, 0, i4 | 0) | 0;
          i4 = HEAP32[i8 >> 2] | 0;
         }
        }
        HEAP32[i1 >> 2] = i5;
       }
       HEAP32[i12 + (i11 << 6) + 24 >> 2] = (__ZN5Umbra17LineSegmentFinder13queryInternalILb1EEEbRKNS_7Vector3ES4_RNS_4CellES6_PNS_8UserListIiEE(i22, i19 + (i11 * 12 | 0) | 0, i20 + (i11 * 12 | 0) | 0, i9, i18 + (i11 << 3) | 0, i10) | 0) & 1;
      }
      if ((i21 | 0) == 44) {
       i21 = 0;
       HEAP32[i12 + (i11 << 6) + 24 >> 2] = 2;
      }
      i11 = i11 + 1 | 0;
     } while ((i11 | 0) < (i13 | 0));
    }
   } else __ZN5Umbra12QueryContext17findMultipleCellsEPKNS_7Vector3EPNS_4CellEi(HEAP32[i22 >> 2] | 0, i19, i17, i13);
   i14 = i14 - i13 | 0;
   if (!i14) break; else i12 = i12 + (i13 << 6) | 0;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] = i1;
 if (i18 | 0) HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] = i18;
 if (i17 | 0) HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] = i17;
 if (i20 | 0) HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] = i20;
 if (i19 | 0) HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] = i19;
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i22, i2, i24, i25, i21, i26, i1) {
 i22 = i22 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i21 = i21 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f23 = f0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, f49 = f0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0;
 if (!(HEAP8[i2 + 869 >> 0] | 0)) return;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (i21 >>> 0 >= i26 >>> 0) return;
 i15 = HEAP32[i2 + 60 >> 2] | 0;
 i16 = HEAP32[i2 + 80 >> 2] | 0;
 i17 = HEAP32[i2 + 100 >> 2] | 0;
 i18 = HEAP32[i2 + 120 >> 2] | 0;
 i19 = HEAP32[i2 + 140 >> 2] | 0;
 i20 = HEAP32[i2 + 160 >> 2] | 0;
 i2 = HEAP32[i2 + 500 >> 2] | 0;
 i3 = i25 + 4 | 0;
 i4 = i25 + 8 | 0;
 i5 = i25 + 12 | 0;
 i6 = i22 + 32 | 0;
 i7 = i22 + 4 | 0;
 i8 = i22 + 8 | 0;
 i9 = i22 + 12 | 0;
 i10 = i22 + 16 | 0;
 i11 = i22 + 20 | 0;
 i12 = i22 + 24 | 0;
 i13 = i22 + 28 | 0;
 i1 = i21;
 do {
  i47 = i15 + (i1 << 2) | 0;
  f56 = Math_fround(HEAPF32[i47 >> 2]);
  f35 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f45 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  i47 = i16 + (i1 << 2) | 0;
  f48 = Math_fround(HEAPF32[i47 >> 2]);
  f51 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f52 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  i47 = i17 + (i1 << 2) | 0;
  f54 = Math_fround(HEAPF32[i47 >> 2]);
  f27 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f37 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  i47 = i18 + (i1 << 2) | 0;
  f31 = Math_fround(HEAPF32[i47 >> 2]);
  f55 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f40 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  i47 = i19 + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i47 >> 2]);
  f36 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f41 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i47 + 12 >> 2]);
  i47 = i20 + (i1 << 2) | 0;
  f49 = Math_fround(HEAPF32[i47 >> 2]);
  f46 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f43 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f31 = Math_fround(f56 + f31);
  f55 = Math_fround(f35 + f55);
  f34 = Math_fround(f42 + f34);
  f40 = Math_fround(f45 + f40);
  f33 = Math_fround(f48 + f33);
  f36 = Math_fround(f51 + f36);
  f41 = Math_fround(f52 + f41);
  f39 = Math_fround(f53 + f39);
  f49 = Math_fround(f54 + f49);
  f46 = Math_fround(f27 + f46);
  f43 = Math_fround(f29 + f43);
  f37 = Math_fround(f37 + Math_fround(HEAPF32[i47 + 12 >> 2]));
  f49 = Math_fround(f14 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f33 * f33)) + Math_fround(f49 * f49))))));
  f46 = Math_fround(f14 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f36 * f36)) + Math_fround(f46 * f46))))));
  f43 = Math_fround(f14 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f41 * f41)) + Math_fround(f43 * f43))))));
  f37 = Math_fround(f14 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f39 * f39)) + Math_fround(f37 * f37))))));
  i47 = f49 < Math_fround(0.0);
  f49 = i47 ? Math_fround(0.0) : f49;
  i47 = f46 < Math_fround(0.0);
  f46 = i47 ? Math_fround(0.0) : f46;
  i47 = f43 < Math_fround(0.0);
  f43 = i47 ? Math_fround(0.0) : f43;
  i47 = f37 < Math_fround(0.0);
  f37 = i47 ? Math_fround(0.0) : f37;
  i47 = f49 > Math_fround(1.0);
  f49 = i47 ? Math_fround(1.0) : f49;
  i47 = f46 > Math_fround(1.0);
  f46 = i47 ? Math_fround(1.0) : f46;
  i47 = f43 > Math_fround(1.0);
  f43 = i47 ? Math_fround(1.0) : f43;
  i47 = f37 > Math_fround(1.0);
  f37 = i47 ? Math_fround(1.0) : f37;
  i47 = i2 + (i1 << 2) | 0;
  i21 = (HEAP32[i47 >> 2] | 0) + -13913692 | 0;
  i30 = (HEAP32[i47 + 4 >> 2] | 0) + -13913692 | 0;
  i38 = (HEAP32[i47 + 8 >> 2] | 0) + -13913692 | 0;
  i47 = (HEAP32[i47 + 12 >> 2] | 0) + -13913692 | 0;
  i28 = (Math_imul(i21, 1790253981) | 0) + 1900727103 | 0;
  i32 = (Math_imul(i30, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i38, 1790253981) | 0) + 1900727103 | 0;
  i50 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
  i21 = i21 << 11 ^ i21;
  i30 = i30 << 11 ^ i30;
  i38 = i38 << 11 ^ i38;
  i47 = i47 << 11 ^ i47;
  f39 = Math_fround(Math_fround((i28 ^ i21 ^ i21 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f40 = Math_fround(Math_fround((i32 ^ i30 ^ i30 >>> 8) & 8388607 ^ i32 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i44 ^ i38 ^ i38 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f34 = Math_fround(Math_fround((i50 ^ i47 ^ i47 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i50 = f39 > Math_fround(HEAPF32[i25 >> 2]);
  i47 = f40 > Math_fround(HEAPF32[i3 >> 2]);
  i44 = f41 > Math_fround(HEAPF32[i4 >> 2]);
  i38 = f34 > Math_fround(HEAPF32[i5 >> 2]);
  i32 = i24 + (i1 << 2) | 0;
  f34 = Math_fround(HEAPF32[i32 >> 2]);
  i30 = i32 + 4 | 0;
  f41 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i32 + 8 | 0;
  f40 = Math_fround(HEAPF32[i28 >> 2]);
  i21 = i32 + 12 | 0;
  f39 = Math_fround(HEAPF32[i21 >> 2]);
  f36 = Math_fround(HEAPF32[i6 >> 2]);
  f55 = Math_fround(HEAPF32[i22 >> 2]);
  f33 = Math_fround(f49 * f55);
  f31 = Math_fround(f46 * f55);
  f29 = Math_fround(f43 * f55);
  f55 = Math_fround(f37 * f55);
  f27 = Math_fround(HEAPF32[i7 >> 2]);
  f33 = Math_fround(f49 * Math_fround(f33 + f27));
  f31 = Math_fround(f46 * Math_fround(f31 + f27));
  f29 = Math_fround(f43 * Math_fround(f29 + f27));
  f27 = Math_fround(f37 * Math_fround(f55 + f27));
  f55 = Math_fround(HEAPF32[i8 >> 2]);
  f33 = Math_fround(f49 * Math_fround(f55 + f33));
  f31 = Math_fround(f46 * Math_fround(f55 + f31));
  f29 = Math_fround(f43 * Math_fround(f55 + f29));
  f27 = Math_fround(f37 * Math_fround(f55 + f27));
  f55 = Math_fround(HEAPF32[i9 >> 2]);
  f33 = Math_fround(f55 + f33);
  f31 = Math_fround(f55 + f31);
  f29 = Math_fround(f55 + f29);
  f27 = Math_fround(f55 + f27);
  f55 = Math_fround(f49 - f36);
  f54 = Math_fround(f46 - f36);
  f53 = Math_fround(f43 - f36);
  f52 = Math_fround(f37 - f36);
  f51 = Math_fround(HEAPF32[i10 >> 2]);
  f48 = Math_fround(f55 * f51);
  f45 = Math_fround(f54 * f51);
  f42 = Math_fround(f53 * f51);
  f51 = Math_fround(f52 * f51);
  f35 = Math_fround(HEAPF32[i11 >> 2]);
  f48 = Math_fround(f55 * Math_fround(f48 + f35));
  f45 = Math_fround(f54 * Math_fround(f45 + f35));
  f42 = Math_fround(f53 * Math_fround(f42 + f35));
  f35 = Math_fround(f52 * Math_fround(f51 + f35));
  f51 = Math_fround(HEAPF32[i12 >> 2]);
  f48 = Math_fround(f55 * Math_fround(f51 + f48));
  f45 = Math_fround(f54 * Math_fround(f51 + f45));
  f42 = Math_fround(f53 * Math_fround(f51 + f42));
  f35 = Math_fround(f52 * Math_fround(f51 + f35));
  f51 = Math_fround(HEAPF32[i13 >> 2]);
  f48 = Math_fround(f51 + f48);
  f45 = Math_fround(f51 + f45);
  f42 = Math_fround(f51 + f42);
  f35 = Math_fround(f51 + f35);
  f33 = Math_fround((i50 ? Math_fround(1.0) : Math_fround(-1.0)) * (f49 > f36 ? f48 : f33));
  f31 = Math_fround((i47 ? Math_fround(1.0) : Math_fround(-1.0)) * (f46 > f36 ? f45 : f31));
  f29 = Math_fround((i44 ? Math_fround(1.0) : Math_fround(-1.0)) * (f43 > f36 ? f42 : f29));
  f31 = Math_fround(f41 + f31);
  f29 = Math_fround(f40 + f29);
  f27 = Math_fround(f39 + Math_fround((i38 ? Math_fround(1.0) : Math_fround(-1.0)) * (f37 > f36 ? f35 : f27)));
  HEAPF32[i32 >> 2] = Math_fround(f34 + f33);
  HEAPF32[i30 >> 2] = f31;
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i21 >> 2] = f27;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i26 >>> 0);
 return;
}

function __ZN5physx2Sc5Scene26fireQueuedContactCallbacksEb(i2, i34) {
 i2 = i2 | 0;
 i34 = i34 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i37;
 if (i34) i32 = 1; else i32 = (HEAP32[i2 + 116 >> 2] | 0) == (HEAP32[(HEAP32[i2 + 1196 >> 2] | 0) + 32 >> 2] | 0) ? 1 : 17;
 i33 = i2 + 1104 | 0;
 i1 = HEAP32[i33 >> 2] | 0;
 i30 = HEAP32[i1 + 4 >> 2] | 0;
 i31 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i31) {
  i36 = i1;
  i35 = i36 + 48 | 0;
  HEAP32[i35 >> 2] = 0;
  i35 = i36 + 60 | 0;
  HEAP32[i35 >> 2] = -1;
  __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb(i36, i34);
  STACKTOP = i37;
  return;
 }
 i23 = i31 + -1 | 0;
 i24 = i2 + 1200 | 0;
 i25 = i35 + 14 | 0;
 i26 = i35 + 4 | 0;
 i27 = i35 + 8 | 0;
 i28 = i35 + 12 | 0;
 i29 = i2 + 1152 | 0;
 i22 = i2 + 1196 | 0;
 i1 = 0;
 do {
  i16 = HEAP32[i30 + (i1 << 2) >> 2] | 0;
  i14 = i16 + 20 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  if (!i2) {
   __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
   i2 = HEAP32[i14 >> 2] | 0;
  }
  i19 = i2 + 10 | 0;
  i15 = HEAPU16[i19 >> 1] | 0;
  if (!(i15 & 2)) {
   i20 = HEAP16[i2 + 6 >> 1] | 0;
   i17 = HEAP32[(HEAP32[i33 >> 2] | 0) + 44 >> 2] | 0;
   i18 = HEAP32[i2 >> 2] | 0;
   i21 = i17 + (i18 + (i15 >>> 5 << 4)) | 0;
   if (i15 & i32 | 0) {
    i10 = i20 & 65535;
    i3 = HEAP32[i22 >> 2] | 0;
    if (i20 << 16 >> 16) {
     i11 = HEAP32[i3 + 20 >> 2] & 2147483647;
     i7 = HEAP32[i3 + 16 >> 2] | 0;
     i9 = 0;
     do {
      i4 = HEAP32[i21 + (i9 << 5) + 24 >> 2] | 0;
      i6 = HEAP32[i21 + (i9 << 5) + 28 >> 2] | 0;
      i8 = i21 + (i9 << 5) + 20 | 0;
      i3 = HEAP16[i8 >> 1] | 0;
      i5 = i4 >>> 5;
      if (i5 >>> 0 < i11 >>> 0) if (HEAP32[i7 + (i5 << 2) >> 2] & 1 << (i4 & 31)) i3 = (i3 & 65535 | 1) & 65535;
      i4 = i6 >>> 5;
      if (i4 >>> 0 < i11 >>> 0) if (HEAP32[i7 + (i4 << 2) >> 2] & 1 << (i6 & 31)) i3 = (i3 & 65535 | 2) & 65535;
      HEAP16[i8 >> 1] = i3;
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i10 | 0));
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i31 >>> 0) {
    i3 = HEAP32[i30 + (i1 << 2) >> 2] | 0;
    i13 = i3 + 20 | 0;
    i13 = HEAP32[i13 >> 2] | 0;
    if (!i13) __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i3);
    i3 = HEAP32[i14 >> 2] | 0;
   } else i3 = i2;
   do if (!i3) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
    i3 = HEAP32[i14 >> 2] | 0;
    i8 = HEAP8[i3 + 32 >> 0] | 0;
    if (i3 | 0) {
     i4 = i3;
     i5 = HEAP8[i3 + 33 >> 0] | 0;
     i3 = i8;
     i36 = 30;
     break;
    }
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
    i3 = HEAP32[i14 >> 2] | 0;
    i5 = HEAP8[i3 + 33 >> 0] | 0;
    if (!i3) {
     __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
     i4 = HEAP32[i14 >> 2] | 0;
     i7 = HEAP8[i4 + 34 >> 0] | 0;
     if (!i4) {
      __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
      i4 = HEAP32[i14 >> 2] | 0;
      i6 = HEAP8[i4 + 35 >> 0] | 0;
      i3 = HEAP32[i24 >> 2] | 0;
      HEAP16[i25 >> 1] = 0;
      if (!i4) {
       __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
       i4 = HEAP32[i14 >> 2] | 0;
       i10 = i3;
       i13 = i8;
       i12 = i5;
       i11 = i7;
      } else {
       i10 = i3;
       i13 = i8;
       i12 = i5;
       i11 = i7;
      }
     } else {
      i3 = i8;
      i36 = 32;
     }
    } else {
     i4 = i3;
     i3 = i8;
     i36 = 30;
    }
   } else {
    i4 = i3;
    i5 = HEAP8[i3 + 33 >> 0] | 0;
    i3 = HEAP8[i3 + 32 >> 0] | 0;
    i36 = 30;
   } while (0);
   if ((i36 | 0) == 30) {
    i7 = HEAP8[i4 + 34 >> 0] | 0;
    i36 = 32;
   }
   if ((i36 | 0) == 32) {
    i36 = 0;
    i6 = HEAP8[i4 + 35 >> 0] | 0;
    i10 = HEAP32[i24 >> 2] | 0;
    HEAP16[i25 >> 1] = 0;
    i13 = i3;
    i12 = i5;
    i11 = i7;
   }
   HEAP32[i35 >> 2] = HEAP32[i4 + 24 >> 2];
   i3 = HEAP32[i14 >> 2] | 0;
   if (!i3) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
    i3 = HEAP32[i14 >> 2] | 0;
   }
   HEAP32[i26 >> 2] = HEAP32[i3 + 28 >> 2];
   i3 = HEAP32[i14 >> 2] | 0;
   if (!i3) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
    i5 = HEAP32[i14 >> 2] | 0;
   } else i5 = i3;
   i3 = HEAP32[i5 + 16 >> 2] | 0;
   i4 = i3 >>> 5;
   i8 = i10 + 20 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   if (i4 >>> 0 < (i7 & 2147483647) >>> 0) i3 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i4 << 2) >> 2] & 1 << (i3 & 31); else i3 = 0;
   i9 = (i3 | 0) != 0;
   i3 = i9 & 1;
   if (!i5) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i16);
    i4 = HEAP32[i14 >> 2] | 0;
    i7 = HEAP32[i8 >> 2] | 0;
   } else i4 = i5;
   i4 = HEAP32[i4 + 20 >> 2] | 0;
   i5 = i4 >>> 5;
   if (i5 >>> 0 < (i7 & 2147483647) >>> 0) if (HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i5 << 2) >> 2] & 1 << (i4 & 31)) i3 = (i9 & 1 | 2) & 65535;
   HEAP16[i25 >> 1] = i3;
   i7 = i2 + 8 | 0;
   i3 = HEAP16[i7 >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    HEAP32[i27 >> 2] = 0;
    i3 = 0;
   } else {
    i3 = (i3 & 65535) + 65532 & 65535;
    HEAP32[i27 >> 2] = i17 + (i18 + 4);
    if (i15 & 8) {
     i5 = HEAP32[i16 >> 2] | 0;
     i4 = HEAP32[i16 + 4 >> 2] | 0;
     if (!(HEAP8[i5 + 50 >> 0] | 0)) {
      HEAP32[i17 + (i18 + 12) >> 2] = 0;
      HEAP32[i17 + (i18 + 16) >> 2] = 0;
      HEAP32[i17 + (i18 + 20) >> 2] = 0;
      HEAP32[i17 + (i18 + 36) >> 2] = 0;
      HEAP32[i17 + (i18 + 40) >> 2] = 0;
      HEAP32[i17 + (i18 + 44) >> 2] = 0;
     } else {
      i16 = HEAP32[i5 + 52 >> 2] | 0;
      HEAP32[i17 + (i18 + 12) >> 2] = HEAP32[i16 + 80 >> 2];
      HEAP32[i17 + (i18 + 16) >> 2] = HEAP32[i16 + 84 >> 2];
      HEAP32[i17 + (i18 + 20) >> 2] = HEAP32[i16 + 88 >> 2];
      HEAP32[i17 + (i18 + 36) >> 2] = HEAP32[i16 + 96 >> 2];
      HEAP32[i17 + (i18 + 40) >> 2] = HEAP32[i16 + 100 >> 2];
      HEAP32[i17 + (i18 + 44) >> 2] = HEAP32[i16 + 104 >> 2];
     }
     if (!(HEAP8[i4 + 50 >> 0] | 0)) {
      HEAP32[i17 + (i18 + 24) >> 2] = 0;
      HEAP32[i17 + (i18 + 28) >> 2] = 0;
      HEAP32[i17 + (i18 + 32) >> 2] = 0;
      HEAP32[i17 + (i18 + 48) >> 2] = 0;
      HEAP32[i17 + (i18 + 52) >> 2] = 0;
      HEAP32[i17 + (i18 + 56) >> 2] = 0;
     } else {
      i16 = HEAP32[i4 + 52 >> 2] | 0;
      HEAP32[i17 + (i18 + 24) >> 2] = HEAP32[i16 + 80 >> 2];
      HEAP32[i17 + (i18 + 28) >> 2] = HEAP32[i16 + 84 >> 2];
      HEAP32[i17 + (i18 + 32) >> 2] = HEAP32[i16 + 88 >> 2];
      HEAP32[i17 + (i18 + 48) >> 2] = HEAP32[i16 + 96 >> 2];
      HEAP32[i17 + (i18 + 52) >> 2] = HEAP32[i16 + 100 >> 2];
      HEAP32[i17 + (i18 + 56) >> 2] = HEAP32[i16 + 104 >> 2];
     }
     HEAP16[i19 >> 1] = HEAPU16[i19 >> 1] & 65527;
    }
   }
   HEAP16[i28 >> 1] = i3;
   i3 = HEAP32[(HEAP32[i29 >> 2] | 0) + ((i13 & 255) << 2) >> 2] | 0;
   i4 = HEAP32[i3 + 16 >> 2] | 0;
   do if (i4 | 0) {
    if (i13 << 24 >> 24 != i12 << 24 >> 24) if (!((i6 & 2 & HEAP8[i3 + 12 >> 0]) << 24 >> 24)) break;
    mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i35 | 0, i21 | 0, i20 & 65535 | 0);
   } while (0);
   do if (i13 << 24 >> 24 != i12 << 24 >> 24) {
    i3 = HEAP32[(HEAP32[i29 >> 2] | 0) + ((i12 & 255) << 2) >> 2] | 0;
    i4 = HEAP32[i3 + 16 >> 2] | 0;
    if (i4 | 0) {
     if (!((i11 & 2 & HEAP8[i3 + 12 >> 0]) << 24 >> 24)) break;
     mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i35 | 0, i21 | 0, i20 & 65535 | 0);
    }
   } while (0);
   HEAP16[i2 + 4 >> 1] = i20;
   i21 = HEAPU16[i7 >> 1] | 0;
   HEAP16[i19 >> 1] = ((i21 & 15 | 0) != 0 & 1) + (i21 >>> 4) << 5 | HEAPU16[i19 >> 1] & 31;
  } else i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i31 | 0));
 i36 = HEAP32[i33 >> 2] | 0;
 i35 = i36 + 48 | 0;
 HEAP32[i35 >> 2] = 0;
 i35 = i36 + 60 | 0;
 HEAP32[i35 >> 2] = -1;
 __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb(i36, i34);
 STACKTOP = i37;
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE8EvaluateEfPNS1_5CacheE(i12, i6, f13, i1) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 f13 = Math_fround(f13);
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 20 | 0;
 i8 = i16 + 16 | 0;
 i14 = i16;
 i15 = i6 + 164 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 if ((i5 | 0) == 1) {
  i15 = (HEAP32[i6 + 152 >> 2] | 0) + 4 | 0;
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  STACKTOP = i16;
  return;
 }
 i10 = (i1 | 0) == 0 ? i6 : i1;
 i11 = i10 + 4 | 0;
 f3 = Math_fround(HEAPF32[i11 >> 2]);
 if (f3 <= f13) if (Math_fround(HEAPF32[i10 + 8 >> 2]) > f13) {
  f18 = Math_fround(f13 - f3);
  f17 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f3 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  f17 = Math_fround(f18 * f17);
  f3 = Math_fround(f18 * f3);
  f4 = Math_fround(f18 * f4);
  f13 = Math_fround(f18 * Math_fround(HEAPF32[i10 + 24 >> 2]));
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 28 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 + 32 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 36 >> 2]));
  f17 = Math_fround(f18 * f17);
  f3 = Math_fround(f18 * f3);
  f4 = Math_fround(f18 * f4);
  f13 = Math_fround(f18 * Math_fround(f13 + Math_fround(HEAPF32[i10 + 40 >> 2])));
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 44 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 + 48 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 52 >> 2]));
  f17 = Math_fround(f18 * f17);
  f3 = Math_fround(f18 * f3);
  f4 = Math_fround(f18 * f4);
  f13 = Math_fround(f18 * Math_fround(f13 + Math_fround(HEAPF32[i10 + 56 >> 2])));
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 60 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 + 64 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 68 >> 2]));
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 + 72 >> 2]));
  HEAPF32[i14 >> 2] = f17;
  HEAPF32[i14 + 4 >> 2] = f3;
  HEAPF32[i14 + 8 >> 2] = f4;
  HEAPF32[i14 + 12 >> 2] = f13;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  STACKTOP = i16;
  return;
 }
 if (i5 | 0) {
  i9 = i6 + 152 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040) {
   i1 = i5 + -1 | 0;
   if ((HEAP32[i2 + (i1 * 52 | 0) >> 2] & 2139095040 | 0) != 2139095040) {
    f4 = Math_fround(HEAPF32[i2 >> 2]);
    f3 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) >> 2]);
    L14 : do if (!(f3 <= f13)) {
     if (!(f4 > f13)) {
      __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i6, i10, f13, i7, i8);
      __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i6, i10, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, Math_fround(0.0));
      break;
     }
     switch (HEAP32[i6 + 172 >> 2] | 0) {
     case 2:
      {
       HEAPF32[i11 >> 2] = Math_fround(f13 + Math_fround(-1.0e3));
       HEAPF32[i10 + 8 >> 2] = f4;
       i1 = i10 + 12 | 0;
       i2 = i1 + 48 | 0;
       do {
        HEAP32[i1 >> 2] = 0;
        i1 = i1 + 4 | 0;
       } while ((i1 | 0) < (i2 | 0));
       i15 = i10 + 60 | 0;
       i9 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
       HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i15 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i15 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i15 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       break L14;
      }
     case 1:
      {
       f17 = Math_fround(f13 - f4);
       f18 = Math_fround(f3 - f4);
       f18 = Math_fround(f4 + Math_fround(f17 - Math_fround(f18 * Math_fround(Math_floor(Math_fround(f17 / f18))))));
       __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i6, i10, f18, i7, i8);
       __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i6, i10, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, Math_fround(f13 - f18));
       break L14;
      }
     default:
      {
       __ZNK17AnimationCurveTplI11QuaternionfE20EvaluateWithoutCacheEfRS0_(i6, f13, i14);
       HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
       HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
       STACKTOP = i16;
       return;
      }
     }
    } else switch (HEAP32[i6 + 176 >> 2] | 0) {
    case 2:
     {
      HEAPF32[i11 >> 2] = f3;
      HEAPF32[i10 + 8 >> 2] = Math_fround(inf);
      i1 = i10 + 12 | 0;
      i2 = i1 + 48 | 0;
      do {
       HEAP32[i1 >> 2] = 0;
       i1 = i1 + 4 | 0;
      } while ((i1 | 0) < (i2 | 0));
      i8 = i10 + 60 | 0;
      i15 = (HEAP32[i9 >> 2] | 0) + (((HEAP32[i15 >> 2] | 0) + -1 | 0) * 52 | 0) + 4 | 0;
      HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      break L14;
     }
    case 1:
     {
      f17 = Math_fround(f13 - f4);
      f18 = Math_fround(f3 - f4);
      f18 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f4 + Math_fround(f17 - Math_fround(f18 * Math_fround(Math_floor(Math_fround(f17 / f18)))))), f4)), f3));
      __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i6, i10, f18, i7, i8);
      __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i6, i10, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, Math_fround(f13 - f18));
      break L14;
     }
    default:
     {
      __ZNK17AnimationCurveTplI11QuaternionfE20EvaluateWithoutCacheEfRS0_(i6, f13, i14);
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      STACKTOP = i16;
      return;
     }
    } while (0);
    f3 = Math_fround(f13 - Math_fround(HEAPF32[i11 >> 2]));
    f4 = Math_fround(HEAPF32[i10 + 12 >> 2]);
    f13 = Math_fround(HEAPF32[i10 + 16 >> 2]);
    f17 = Math_fround(HEAPF32[i10 + 20 >> 2]);
    f4 = Math_fround(f4 * f3);
    f13 = Math_fround(f3 * f13);
    f17 = Math_fround(f3 * f17);
    f18 = Math_fround(f3 * Math_fround(HEAPF32[i10 + 24 >> 2]));
    f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 28 >> 2]));
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 + 32 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 36 >> 2]));
    f4 = Math_fround(f3 * f4);
    f13 = Math_fround(f3 * f13);
    f17 = Math_fround(f3 * f17);
    f18 = Math_fround(f3 * Math_fround(f18 + Math_fround(HEAPF32[i10 + 40 >> 2])));
    f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 44 >> 2]));
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 + 48 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 52 >> 2]));
    f4 = Math_fround(f3 * f4);
    f13 = Math_fround(f3 * f13);
    f17 = Math_fround(f3 * f17);
    f18 = Math_fround(f3 * Math_fround(f18 + Math_fround(HEAPF32[i10 + 56 >> 2])));
    f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 60 >> 2]));
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 + 64 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 68 >> 2]));
    f18 = Math_fround(f18 + Math_fround(HEAPF32[i10 + 72 >> 2]));
    HEAPF32[i14 >> 2] = f4;
    HEAPF32[i14 + 4 >> 2] = f13;
    HEAPF32[i14 + 8 >> 2] = f17;
    HEAPF32[i14 + 12 >> 2] = f18;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    STACKTOP = i16;
    return;
   }
  }
 };
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN19SpriteMeshGenerator4path3optEf(i21, f22) {
 i21 = i21 | 0;
 f22 = Math_fround(f22);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 60 | 0;
 i24 = i28 + 48 | 0;
 i18 = i28 + 16 | 0;
 i23 = i28;
 i20 = i21 + 4 | 0;
 i27 = (HEAP32[i20 >> 2] | 0) - (HEAP32[i21 >> 2] | 0) | 0;
 i4 = i27 >> 5;
 if ((i27 | 0) < 96) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 HEAP32[i26 >> 2] = 0;
 i27 = i26 + 4 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i24 + 4 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 i5 = i26 + 8 | 0;
 __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i26, i23);
 HEAP32[i23 >> 2] = 0;
 i6 = i4 + -1 | 0;
 i7 = i18 + 4 | 0;
 i8 = i18 + 8 | 0;
 i12 = i18 + 12 | 0;
 i13 = i18 + 16 | 0;
 i14 = i18 + 20 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 28 | 0;
 i1 = -1;
 i17 = 0;
 do {
  i3 = HEAP32[i21 >> 2] | 0;
  f9 = Math_fround(HEAPF32[i3 + (i17 << 5) >> 2]);
  f11 = Math_fround(HEAPF32[i3 + (i17 << 5) + 4 >> 2]);
  i2 = i17 + 1 | 0;
  if ((i2 | 0) < (i4 | 0)) {
   if ((i17 | 0) <= -2) i2 = i6 - ((-2 - i17 | 0) % (i4 | 0) | 0) | 0;
  } else i2 = (i2 | 0) % (i4 | 0) | 0;
  f10 = Math_fround(HEAPF32[i3 + (i2 << 5) >> 2]);
  f10 = Math_fround(f9 - f10);
  f9 = Math_fround(f11 - Math_fround(HEAPF32[i3 + (i2 << 5) + 4 >> 2]));
  if (f10 > Math_fround(0.0)) i2 = 7; else i2 = (((f10 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
  i29 = f9 > Math_fround(0.0);
  i3 = (f9 < Math_fround(0.0)) << 31 >> 31;
  i2 = i2 - (i29 ? 1 : i3) | 0;
  i3 = HEAP32[gb + 38036 + (i2 << 2) >> 2] | 0;
  do if ((i2 | 0) != 4) {
   HEAP32[i18 + (i3 << 2) >> 2] = 1;
   if ((i1 | 0) < 0) i1 = i3; else {
    i2 = i1 + -1 | 0;
    if ((i1 | 0) < 9) {
     if ((i1 | 0) <= 0) i2 = 7 - ((0 - i1 | 0) % 8 | 0) | 0;
    } else i2 = i2 & 7;
    if ((i3 | 0) == (i2 | 0)) i19 = 23; else {
     i2 = i1 + 1 | 0;
     if ((i2 | 0) < 8) {
      if ((i1 | 0) <= -2) i2 = 7 - ((-2 - i1 | 0) % 8 | 0) | 0;
     } else i2 = i2 & 7;
     if ((i3 | 0) == (i1 | 0) | (i3 | 0) == (i2 | 0)) i19 = 23;
    }
    if ((i19 | 0) == 23) {
     i19 = 0;
     if (((HEAP32[i7 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) + (HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) | 0) <= 2) break;
    };
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 + 12 >> 2] = 0;
    HEAP32[i18 + 16 >> 2] = 0;
    HEAP32[i18 + 20 >> 2] = 0;
    HEAP32[i18 + 24 >> 2] = 0;
    HEAP32[i18 + 28 >> 2] = 0;
    i1 = HEAP32[i27 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
     __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i26, i23);
     i1 = -1;
     break;
    } else {
     HEAP32[i1 >> 2] = i17;
     HEAP32[i27 >> 2] = i1 + 4;
     i1 = -1;
     break;
    }
   }
  } while (0);
  i17 = (HEAP32[i23 >> 2] | 0) + 1 | 0;
  HEAP32[i23 >> 2] = i17;
 } while ((i17 | 0) < (i4 | 0));
 i1 = HEAP32[i26 >> 2] | 0;
 i3 = (HEAP32[i27 >> 2] | 0) - i1 | 0;
 i4 = i3 >> 2;
 if ((i3 | 0) > 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) > 4) {
   i3 = 1;
   do {
    __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii(i21, i24, i2, HEAP32[i1 + (i3 << 2) >> 2] | 0);
    i1 = HEAP32[i26 >> 2] | 0;
    i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i4 | 0));
  } else i3 = 1;
  __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii(i21, i24, i2, HEAP32[i1 + (((i3 | 0) % (i4 | 0) | 0) << 2) >> 2] | 0);
 }
 HEAP32[i23 >> 2] = 0;
 i13 = i23 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 i5 = i2 - i1 | 0;
 i6 = i5 >> 5;
 i3 = i1;
 i4 = i2;
 if (!i6) {
  i12 = i21;
  i7 = 0;
 } else {
  if (i6 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i23);
   i1 = HEAP32[i21 >> 2] | 0;
   i2 = HEAP32[i20 >> 2] | 0;
   i8 = i21;
   i3 = i1;
   i4 = i2;
  } else i8 = i21;
  i7 = __Znwj(i5) | 0;
  HEAP32[i13 >> 2] = i7;
  HEAP32[i23 >> 2] = i7;
  HEAP32[i23 + 8 >> 2] = i7 + (i6 << 5);
  if ((i3 | 0) == (i4 | 0)) i12 = i8; else {
   i5 = ((i4 + -32 - i3 | 0) >>> 5) + 1 | 0;
   i1 = i3;
   i2 = i7;
   i3 = i7;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    i29 = i2 + 16 | 0;
    i19 = i1 + 16 | 0;
    HEAP32[i29 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    i1 = i1 + 32 | 0;
    i3 = i3 + 32 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i3;
   }
   HEAP32[i13 >> 2] = i7 + (i5 << 5);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i20 >> 2] | 0;
   i12 = i8;
   i4 = i2;
   i3 = i1;
  }
 }
 if ((i4 | 0) != (i3 | 0)) {
  i4 = i4 + (~((i4 + -32 - i3 | 0) >>> 5) << 5) | 0;
  HEAP32[i20 >> 2] = i4;
  i2 = i4;
 }
 i6 = HEAP32[i25 >> 2] | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 if ((i6 | 0) != (i3 | 0)) {
  i8 = i21 + 8 | 0;
  i1 = 0;
  i2 = i3;
  while (1) {
   i3 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i5 = i7 + (i3 << 5) | 0;
   if ((i4 | 0) == (HEAP32[i8 >> 2] | 0)) {
    __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i21, i5);
    i3 = HEAP32[i25 >> 2] | 0;
    i2 = HEAP32[i24 >> 2] | 0;
   } else {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i7 + (i3 << 5) + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i7 + (i3 << 5) + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i7 + (i3 << 5) + 12 >> 2];
    i29 = i4 + 16 | 0;
    i3 = i7 + (i3 << 5) + 16 | 0;
    HEAP32[i29 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 32;
    i3 = i6;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 - i2 >> 2 >>> 0) break;
   i7 = HEAP32[i23 >> 2] | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   i6 = i3;
  }
  i2 = HEAP32[i20 >> 2] | 0;
  i1 = HEAP32[i21 >> 2] | 0;
 }
 i2 = i2 - i1 | 0;
 i3 = i2 >> 5;
 i2 = (i2 | 0) > 0;
 if (i2) {
  i1 = 0;
  do {
   __ZN19SpriteMeshGenerator4path3decEi(i21, i1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  if (i2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = 0;
   do {
    f10 = Math_fround(Math_fround(HEAPF32[i2 + (i1 << 5) + 8 >> 2]) * f22);
    f11 = Math_fround(Math_fround(HEAPF32[i2 + (i1 << 5) + 12 >> 2]) * f22);
    i29 = i2 + (i1 << 5) | 0;
    HEAPF32[i29 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i29 >> 2]));
    i29 = i2 + (i1 << 5) + 4 | 0;
    HEAPF32[i29 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i29 >> 2]));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
 }
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i3 + (~((i3 + -32 - i2 | 0) >>> 5) << 5);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i24 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i25 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i25 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i26 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i27 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i27 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i29 = 1;
 STACKTOP = i28;
 return i29 | 0;
}

function __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = i2;
 L1 : while (1) {
  i11 = i15;
  i14 = i15 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i10 = i1;
    i2 = i11 - i10 | 0;
    i3 = i2 >> 2;
    switch (i3 | 0) {
    case 2:
     {
      i13 = 5;
      break L1;
     }
    case 3:
     {
      i13 = 7;
      break L1;
     }
    case 4:
     {
      i13 = 15;
      break L1;
     }
    case 5:
     {
      i13 = 27;
      break L1;
     }
    case 1:
    case 0:
     {
      i13 = 85;
      break L1;
     }
    default:
     {}
    }
    if ((i2 | 0) < 124) {
     i13 = 29;
     break L1;
    }
    i9 = i1 + (((i3 | 0) / 2 | 0) << 2) | 0;
    do if ((i2 | 0) > 3996) {
     i2 = (i3 | 0) / 4 | 0;
     i2 = __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i2 << 2) | 0, i9, i9 + (i2 << 2) | 0, i14, i12) | 0;
    } else {
     i2 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = (i3 | 0) < (i2 | 0);
     if ((i2 | 0) >= (i5 | 0)) {
      if (!i4) {
       i2 = 0;
       break;
      }
      HEAP32[i9 >> 2] = i3;
      HEAP32[i14 >> 2] = i2;
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) >= (i3 | 0)) {
       i2 = 1;
       break;
      }
      HEAP32[i1 >> 2] = i2;
      HEAP32[i9 >> 2] = i3;
      i2 = 2;
      break;
     }
     if (i4) {
      HEAP32[i1 >> 2] = i3;
      HEAP32[i14 >> 2] = i5;
      i2 = 1;
      break;
     }
     HEAP32[i1 >> 2] = i2;
     HEAP32[i9 >> 2] = i5;
     i2 = HEAP32[i14 >> 2] | 0;
     if ((i2 | 0) < (i5 | 0)) {
      HEAP32[i9 >> 2] = i2;
      HEAP32[i14 >> 2] = i5;
      i2 = 2;
     } else i2 = 1;
    } while (0);
    i6 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i6 | 0) < (i5 | 0)) {
     i3 = i14;
     break;
    } else i3 = i14;
    while (1) {
     i3 = i3 + -4 | 0;
     if ((i1 | 0) == (i3 | 0)) break;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) < (i5 | 0)) {
      i13 = 68;
      break L5;
     }
    }
    i2 = i1 + 4 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    if ((i6 | 0) >= (i4 | 0)) {
     if ((i2 | 0) == (i14 | 0)) {
      i13 = 85;
      break L1;
     }
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i6 | 0) < (i3 | 0)) break;
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i14 | 0)) {
       i13 = 85;
       break L1;
      }
     }
     HEAP32[i2 >> 2] = i4;
     HEAP32[i14 >> 2] = i3;
     i2 = i2 + 4 | 0;
    }
    if ((i2 | 0) == (i14 | 0)) {
     i13 = 85;
     break L1;
    } else i3 = i14;
    while (1) {
     i7 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i5 = HEAP32[i2 >> 2] | 0;
      i6 = i2 + 4 | 0;
      if ((i7 | 0) < (i5 | 0)) break; else i2 = i6;
     }
     do {
      i3 = i3 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
     } while ((i7 | 0) < (i4 | 0));
     if (i2 >>> 0 >= i3 >>> 0) {
      i1 = i2;
      continue L5;
     }
     HEAP32[i2 >> 2] = i4;
     HEAP32[i3 >> 2] = i5;
     i2 = i6;
    }
   }
   if ((i13 | 0) == 68) {
    i13 = 0;
    HEAP32[i1 >> 2] = i4;
    HEAP32[i3 >> 2] = i6;
    i2 = i2 + 1 | 0;
   }
   i4 = i1 + 4 | 0;
   L44 : do if (i4 >>> 0 < i3 >>> 0) while (1) {
    i8 = HEAP32[i9 >> 2] | 0;
    while (1) {
     i6 = HEAP32[i4 >> 2] | 0;
     i7 = i4 + 4 | 0;
     if ((i6 | 0) < (i8 | 0)) i4 = i7; else break;
    }
    do {
     i3 = i3 + -4 | 0;
     i5 = HEAP32[i3 >> 2] | 0;
    } while ((i5 | 0) >= (i8 | 0));
    if (i4 >>> 0 > i3 >>> 0) {
     i5 = i9;
     i6 = i4;
     break L44;
    }
    HEAP32[i4 >> 2] = i5;
    HEAP32[i3 >> 2] = i6;
    i9 = (i9 | 0) == (i4 | 0) ? i3 : i9;
    i4 = i7;
    i2 = i2 + 1 | 0;
   } else {
    i5 = i9;
    i6 = i4;
   } while (0);
   if ((i6 | 0) != (i5 | 0)) {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) < (i4 | 0)) {
     HEAP32[i6 >> 2] = i3;
     HEAP32[i5 >> 2] = i4;
     i2 = i2 + 1 | 0;
    }
   }
   if (!i2) {
    i2 = __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIiEEPiEEbT0_S5_T_(i1, i6, i12) | 0;
    i3 = i6 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_4lessIiEEPiEEbT0_S5_T_(i3, i15, i12) | 0) {
     i13 = 84;
     break;
    }
    if (i2) {
     i1 = i3;
     continue;
    }
   }
   i9 = i6;
   if ((i9 - i10 | 0) >= (i11 - i9 | 0)) {
    i13 = 83;
    break;
   }
   __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_(i1, i6, i12);
   i1 = i6 + 4 | 0;
  }
  if ((i13 | 0) == 83) {
   i13 = 0;
   __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_(i6 + 4 | 0, i15, i12);
   i15 = i6;
   continue;
  } else if ((i13 | 0) == 84) {
   i13 = 0;
   if (i2) {
    i13 = 85;
    break;
   } else {
    i15 = i6;
    continue;
   }
  }
 }
 if ((i13 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) >= (i3 | 0)) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  return;
 } else if ((i13 | 0) == 7) {
  i6 = i1 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i4 = (i3 | 0) < (i2 | 0);
  if ((i2 | 0) >= (i5 | 0)) {
   if (!i4) return;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
   return;
  }
  if (i4) {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i14 >> 2] = i5;
   return;
  }
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) >= (i5 | 0)) return;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  return;
 } else if ((i13 | 0) == 15) {
  i7 = i1 + 4 | 0;
  i6 = i1 + 8 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = (i4 | 0) < (i3 | 0);
  do if ((i3 | 0) < (i2 | 0)) {
   if (i5) {
    HEAP32[i1 >> 2] = i4;
    HEAP32[i6 >> 2] = i2;
    i3 = i2;
    break;
   }
   HEAP32[i1 >> 2] = i3;
   HEAP32[i7 >> 2] = i2;
   if ((i4 | 0) < (i2 | 0)) {
    HEAP32[i7 >> 2] = i4;
    HEAP32[i6 >> 2] = i2;
    i3 = i2;
   } else i3 = i4;
  } else if (i5) {
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i3;
   if ((i4 | 0) < (i2 | 0)) {
    HEAP32[i1 >> 2] = i4;
    HEAP32[i7 >> 2] = i2;
   }
  } else i3 = i4; while (0);
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 | 0) >= (i3 | 0)) return;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) return;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) return;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i2;
  return;
 } else if ((i13 | 0) == 27) {
  __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i12) | 0;
  return;
 } else if ((i13 | 0) == 29) {
  i2 = i1 + 8 | 0;
  i3 = i1 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = (i6 | 0) < (i4 | 0);
  do if ((i4 | 0) < (i5 | 0)) {
   if (i7) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i2 >> 2] = i5;
    i4 = i5;
    break;
   }
   HEAP32[i1 >> 2] = i4;
   HEAP32[i3 >> 2] = i5;
   if ((i6 | 0) < (i5 | 0)) {
    HEAP32[i3 >> 2] = i6;
    HEAP32[i2 >> 2] = i5;
    i4 = i5;
   } else i4 = i6;
  } else if (i7) {
   HEAP32[i3 >> 2] = i6;
   HEAP32[i2 >> 2] = i4;
   if ((i6 | 0) < (i5 | 0)) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i3 >> 2] = i5;
   }
  } else i4 = i6; while (0);
  i3 = i1 + 12 | 0;
  if ((i3 | 0) == (i15 | 0)) return;
  while (1) {
   i6 = HEAP32[i3 >> 2] | 0;
   if ((i6 | 0) < (i4 | 0)) {
    i5 = i3;
    while (1) {
     HEAP32[i5 >> 2] = i4;
     if ((i2 | 0) == (i1 | 0)) {
      i2 = i1;
      break;
     }
     i5 = i2 + -4 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     if ((i6 | 0) >= (i4 | 0)) break; else {
      i14 = i2;
      i2 = i5;
      i5 = i14;
     }
    }
    HEAP32[i2 >> 2] = i6;
   }
   i2 = i3 + 4 | 0;
   if ((i2 | 0) == (i15 | 0)) break;
   i4 = HEAP32[i3 >> 2] | 0;
   i14 = i3;
   i3 = i2;
   i2 = i14;
  }
  return;
 } else if ((i13 | 0) == 85) return;
}

function __ZN15b2RevoluteJoint23InitVelocityConstraintsERK12b2SolverData(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i25 = HEAP32[i5 + 48 >> 2] | 0;
 i18 = HEAP32[i25 + 8 >> 2] | 0;
 i16 = i5 + 128 | 0;
 HEAP32[i16 >> 2] = i18;
 i1 = HEAP32[i5 + 52 >> 2] | 0;
 i34 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = i5 + 132 | 0;
 HEAP32[i11 >> 2] = i34;
 i32 = i25 + 28 | 0;
 i33 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 4 >> 2] | 0;
 i30 = i5 + 152 | 0;
 HEAP32[i30 >> 2] = i33;
 HEAP32[i30 + 4 >> 2] = i32;
 i30 = i1 + 28 | 0;
 i31 = HEAP32[i30 >> 2] | 0;
 i30 = HEAP32[i30 + 4 >> 2] | 0;
 i29 = i5 + 160 | 0;
 HEAP32[i29 >> 2] = i31;
 HEAP32[i29 + 4 >> 2] = i30;
 i29 = HEAP32[i25 + 120 >> 2] | 0;
 HEAP32[i5 + 168 >> 2] = i29;
 i28 = HEAP32[i1 + 120 >> 2] | 0;
 HEAP32[i5 + 172 >> 2] = i28;
 i25 = HEAP32[i25 + 128 >> 2] | 0;
 HEAP32[i5 + 176 >> 2] = i25;
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 HEAP32[i5 + 180 >> 2] = i1;
 i17 = HEAP32[i6 + 24 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i17 + (i18 * 12 | 0) + 8 >> 2]);
 i12 = i6 + 28 | 0;
 i35 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i35 + (i18 * 12 | 0) >> 2] | 0;
 i14 = HEAP32[i35 + (i18 * 12 | 0) + 4 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i35 + (i18 * 12 | 0) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + (i34 * 12 | 0) + 8 >> 2]);
 i17 = HEAP32[i35 + (i34 * 12 | 0) >> 2] | 0;
 i18 = HEAP32[i35 + (i34 * 12 | 0) + 4 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i35 + (i34 * 12 | 0) + 8 >> 2]);
 f22 = Math_fround(+Math_sin(+f2));
 f8 = Math_fround(+Math_cos(+f2));
 f9 = Math_fround(+Math_sin(+f3));
 f7 = Math_fround(+Math_cos(+f3));
 f23 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f21 = Math_fround(HEAPF32[i5 + 72 >> 2]);
 f21 = Math_fround(f21 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(Math_fround(f8 * f23) - Math_fround(f22 * f21));
 f21 = Math_fround(Math_fround(f22 * f23) + Math_fround(f8 * f21));
 HEAPF32[i5 + 136 >> 2] = f20;
 HEAPF32[i5 + 140 >> 2] = f21;
 f8 = Math_fround(HEAPF32[i5 + 76 >> 2]);
 f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f23 = Math_fround(HEAPF32[i5 + 80 >> 2]);
 f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f22 = Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f23));
 f23 = Math_fround(Math_fround(f9 * f8) + Math_fround(f7 * f23));
 HEAPF32[i5 + 144 >> 2] = f22;
 HEAPF32[i5 + 148 >> 2] = f23;
 f7 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f9 + f10);
 i1 = f4 == Math_fround(0.0);
 f24 = Math_fround(f7 + f8);
 HEAPF32[i5 + 184 >> 2] = Math_fround(Math_fround(f24 + Math_fround(f9 * Math_fround(f21 * f21))) + Math_fround(f10 * Math_fround(f23 * f23)));
 f27 = Math_fround(Math_fround(-Math_fround(f9 * Math_fround(f21 * f20))) - Math_fround(f10 * Math_fround(f23 * f22)));
 HEAPF32[i5 + 196 >> 2] = f27;
 f26 = Math_fround(Math_fround(-Math_fround(f9 * f21)) - Math_fround(f10 * f23));
 HEAPF32[i5 + 208 >> 2] = f26;
 HEAPF32[i5 + 188 >> 2] = f27;
 HEAPF32[i5 + 200 >> 2] = Math_fround(Math_fround(f24 + Math_fround(f9 * Math_fround(f20 * f20))) + Math_fround(f10 * Math_fround(f22 * f22)));
 f24 = Math_fround(Math_fround(f9 * f20) + Math_fround(f10 * f22));
 HEAPF32[i5 + 212 >> 2] = f24;
 HEAPF32[i5 + 192 >> 2] = f26;
 HEAPF32[i5 + 204 >> 2] = f24;
 HEAPF32[i5 + 216 >> 2] = f4;
 i25 = f4 > Math_fround(0.0);
 f24 = Math_fround(Math_fround(1.0) / f4);
 HEAPF32[i5 + 220 >> 2] = i25 ? f24 : f4;
 if (i1 | (HEAP8[i5 + 100 >> 0] | 0) == 0) HEAPF32[i5 + 96 >> 2] = Math_fround(0.0);
 do if (i1 | (HEAP8[i5 + 112 >> 0] | 0) == 0) HEAP32[i5 + 224 >> 2] = 0; else {
  f3 = Math_fround(f3 - f2);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i5 + 116 >> 2]));
  f4 = Math_fround(HEAPF32[i5 + 124 >> 2]);
  f2 = Math_fround(HEAPF32[i5 + 120 >> 2]);
  f26 = Math_fround(f4 - f2);
  i35 = f26 > Math_fround(0.0);
  f27 = Math_fround(-f26);
  if ((i35 ? f26 : f27) < Math_fround(.069813177)) {
   HEAP32[i5 + 224 >> 2] = 3;
   break;
  }
  if (f3 <= f2) {
   i1 = i5 + 224 | 0;
   if ((HEAP32[i1 >> 2] | 0) != 1) HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
   HEAP32[i1 >> 2] = 1;
   break;
  }
  i1 = i5 + 224 | 0;
  if (!(f3 >= f4)) {
   HEAP32[i1 >> 2] = 0;
   HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
   break;
  }
  if ((HEAP32[i1 >> 2] | 0) != 2) HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
  HEAP32[i1 >> 2] = 2;
 } while (0);
 i1 = i5 + 84 | 0;
 if (!(HEAP8[i6 + 20 >> 0] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  f26 = f15;
  f27 = f19;
  i31 = i17;
  i29 = i13;
  i34 = i18;
  i33 = i14;
  i35 = HEAP32[i16 >> 2] | 0;
  i32 = HEAP32[i12 >> 2] | 0;
  i30 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i30 >> 2] = i29;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i16 >> 2] | 0;
  i33 = HEAP32[i12 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f26;
  i35 = HEAP32[i11 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i31;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i11 >> 2] | 0;
  i34 = HEAP32[i12 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f27;
  return;
 } else {
  f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f27 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i1 >> 2] = f27;
  i29 = i5 + 88 | 0;
  f4 = Math_fround(f3 * Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i29 >> 2] = f4;
  i29 = i5 + 92 | 0;
  f2 = Math_fround(f3 * Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i29 >> 2] = f2;
  i29 = i5 + 96 | 0;
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i29 >> 2] = f3;
  f24 = Math_fround(f7 * f27);
  f26 = Math_fround(f7 * f4);
  f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f24);
  i29 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(f15 - Math_fround(f9 * Math_fround(f2 + Math_fround(f3 + Math_fround(Math_fround(f4 * f20) - Math_fround(f27 * f21))))));
  f21 = Math_fround(f8 * f27);
  f24 = Math_fround(f8 * f4);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f21);
  i31 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
  f27 = Math_fround(f19 + Math_fround(f10 * Math_fround(f2 + Math_fround(f3 + Math_fround(Math_fround(f4 * f22) - Math_fround(f27 * f23))))));
  i34 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = HEAP32[i16 >> 2] | 0;
  i32 = HEAP32[i12 >> 2] | 0;
  i30 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i30 >> 2] = i29;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i16 >> 2] | 0;
  i33 = HEAP32[i12 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f26;
  i35 = HEAP32[i11 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i31;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i11 >> 2] | 0;
  i34 = HEAP32[i12 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f27;
  return;
 }
}

function __ZN12AudioManager8InitFMODEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 120 | 0;
 i5 = i16 + 104 | 0;
 i11 = i16 + 168 | 0;
 i2 = i16 + 164 | 0;
 i3 = i16 + 160 | 0;
 i7 = i16 + 156 | 0;
 i8 = i16 + 152 | 0;
 i9 = i16 + 148 | 0;
 i10 = i16;
 i15 = i16 + 136 | 0;
 i4 = i14 + 224 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 if (!(_FMOD_Debug_GetLevel(i2) | 0)) {
  i1 = HEAP32[gb + 1459940 >> 2] | 0;
  if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) if ((_FMOD_Debug_SetLevel(i1) | 0) == 80) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 859912 | 0, 0, gb + 856220 | 0, 492, 1, 0, 0, 0);
 }
 i13 = i14 + 88 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, _FMOD_System_Create(i13) | 0, gb + 860085 | 0) | 0) {
  __ZN4FMOD6System13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i(HEAP32[i13 >> 2] | 0, fb + 160 | 0, fb + 921 | 0, fb + 161 | 0, fb + 431 | 0, 0, 0, -1) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i6 = 9;
 } else i1 = 0; else i6 = 9;
 if ((i6 | 0) == 9) {
  HEAP32[i3 >> 2] = 0;
  i1 = __ZN4FMOD6System10getVersionEPj(i1, i3) | 0;
  if (i1 | 0) {
   i6 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
   HEAP32[i5 >> 2] = gb + 856220;
   HEAP32[i5 + 4 >> 2] = 513;
   HEAP32[i5 + 8 >> 2] = gb + 860116;
   HEAP32[i5 + 12 >> 2] = i6;
   __Z6FormatPKcz(i11, gb + 883334 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
  do if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System19setStreamBufferSizeEjj(HEAP32[i13 >> 2] | 0, 64e3, 8) | 0, gb + 860085 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E(HEAP32[i13 >> 2] | 0, fb + 166 | 0) | 0, gb + 860151 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE(HEAP32[i13 >> 2] | 0, fb + 18 | 0) | 0, gb + 860194 | 0) | 0) {
   if (!(__ZN12AudioManager10InitNormalEv(i14) | 0)) {
    __ZN12AudioManager9CloseFMODEv(i14);
    __ZN4FMOD6System7releaseEv(HEAP32[i13 >> 2] | 0) | 0;
    HEAP32[i13 >> 2] = 0;
    HEAP8[i4 >> 0] = 1;
    i1 = 0;
    break;
   }
   i5 = i14 + 92 | 0;
   if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE(HEAP32[i13 >> 2] | 0, i5) | 0, gb + 860238 | 0) | 0) {
    HEAP32[i7 >> 2] = 0;
    __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i13 >> 2] | 0, i7, 0, 0, 0, 0, 0) | 0;
    HEAP32[gb + 1097872 + 12 >> 2] = HEAP32[i7 >> 2];
    __ZN4FMOD6System16getDSPBufferSizeEPjPi(HEAP32[i13 >> 2] | 0, gb + 1097872 + 16 | 0, 0) | 0;
    __ZN4FMOD6System11getDSPClockEPjS1_(HEAP32[i13 >> 2] | 0, i9, i8) | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = gb + 1097872 | 0;
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i1 + 4 >> 2] = i3;
    i1 = i10;
    i3 = i1 + 104 | 0;
    do {
     HEAP32[i1 >> 2] = 0;
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    i1 = i10 + 32 | 0;
    i2 = gb + 860279 | 0;
    i3 = i1 + 10 | 0;
    do {
     HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i1 | 0) < (i3 | 0));
    HEAP32[i10 >> 2] = 104;
    HEAP32[i10 + 4 >> 2] = 56;
    HEAP32[i10 + 76 >> 2] = fb + 137;
    __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i15, i10, 0);
    i1 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i15, HEAP32[i13 >> 2] | 0, gb + 1097872 | 0, 0, 0) | 0;
    HEAP32[i14 + 236 >> 2] = i1;
    i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[i5 >> 2] | 0, i1, 0) | 0;
    if (i1 | 0) {
     i10 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
     HEAP32[i12 >> 2] = gb + 856220;
     HEAP32[i12 + 4 >> 2] = 574;
     HEAP32[i12 + 8 >> 2] = gb + 860289;
     HEAP32[i12 + 12 >> 2] = i10;
     __Z6FormatPKcz(i11, gb + 883334 | 0, i12);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    }
    i1 = i14 + 96 | 0;
    do if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[i13 >> 2] | 0, gb + 874346 | 0, i1) | 0, gb + 860238 | 0) | 0) {
     i2 = i14 + 100 | 0;
     if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[i13 >> 2] | 0, gb + 874359 | 0, i2) | 0, gb + 860238 | 0) | 0) {
      i3 = i14 + 104 | 0;
      if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[i13 >> 2] | 0, gb + 874369 | 0, i3) | 0, gb + 860238 | 0) | 0) {
       i4 = i14 + 108 | 0;
       if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[i13 >> 2] | 0, gb + 874384 | 0, i4) | 0, gb + 860238 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0, gb + 860238 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0, gb + 860238 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0, gb + 860238 | 0) | 0) {
        if (!(__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i14, __ZN4FMOD12ChannelGroup8addGroupEPS0_(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0, gb + 860238 | 0) | 0)) {
         i1 = 0;
         break;
        }
        __ZN12AudioManager21FixMasterGroupRoutingEv(i14);
        HEAP32[i14 + 160 >> 2] = HEAP32[i14 + 124 >> 2];
        HEAP32[i14 + 164 >> 2] = HEAP32[i14 + 128 >> 2];
        HEAP32[i14 + 156 >> 2] = HEAP32[i14 + 120 >> 2];
        HEAP32[i14 + 168 >> 2] = HEAP32[i14 + 132 >> 2];
        HEAP32[i14 + 172 >> 2] = HEAP32[i14 + 136 >> 2];
        HEAP8[i14 + 176 >> 0] = HEAP8[i14 + 225 >> 0] | 0;
        i1 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63328 | 0, 16, gb + 856220 | 0, 619) | 0;
        __ZN12SoundManagerC2Ev(i1);
        HEAP32[i14 + 220 >> 2] = i1;
        i1 = 1;
       } else i1 = 0; else i1 = 0; else i1 = 0; else i1 = 0;
      } else i1 = 0;
     } else i1 = 0;
    } else i1 = 0; while (0);
    i8 = HEAP32[i15 >> 2] | 0;
    if (i8 | 0) {
     i14 = i8 + 200 | 0;
     i15 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
     HEAP32[i14 >> 2] = i15;
     if (!i15) {
      i6 = i8 + 60 | 0;
      i3 = HEAP32[i6 >> 2] | 0;
      i7 = i8 + 64 | 0;
      i2 = HEAP32[i7 >> 2] | 0;
      if ((i3 | 0) > 0) {
       i5 = 0;
       do {
        i4 = HEAP32[i2 + (i5 * 48 | 0) + 44 >> 2] | 0;
        if (i4) {
         __ZdaPv(i4);
         i3 = HEAP32[i6 >> 2] | 0;
         i2 = HEAP32[i7 >> 2] | 0;
        }
        i5 = i5 + 1 | 0;
       } while ((i5 | 0) < (i3 | 0));
      }
      if (i2 | 0) __ZdaPv(i2);
      i2 = HEAP32[i8 + 180 >> 2] | 0;
      if (i2 | 0) __ZdaPv(i2);
      __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 63328 | 0);
     }
    }
   } else i1 = 0;
  } else i1 = 0; else i1 = 0; else i1 = 0; while (0);
 }
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN20ArchiveStorageReader10ReadHeaderEy(i26, i19, i22) {
 i26 = i26 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 2192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i27 + 1116 | 0;
 i2 = i27 + 16 | 0;
 i8 = i27 + 1112 | 0;
 i9 = i27 + 1108 | 0;
 i17 = i27 + 1096 | 0;
 i18 = i27 + 1084 | 0;
 i13 = i27 + 8 | 0;
 i15 = i27 + 24 | 0;
 i14 = i27;
 i20 = i26 + 1248 | 0;
 __ZN12FileAccessor4SeekEx10FileOrigin(i20, i19, i22, 1) | 0;
 i24 = i26 + 8 | 0;
 if (__ZN20ArchiveStorageHeader19ReadHeaderSignatureER12FileAccessorRNS_6HeaderE(i20, i24) | 0) {
  i26 = -1;
  STACKTOP = i27;
  return i26 | 0;
 }
 i21 = i24 + 11 | 0;
 i12 = HEAP8[i21 >> 0] | 0;
 i1 = i12 << 24 >> 24 < 0;
 i25 = i26 + 12 | 0;
 L4 : do switch ((i1 ? HEAP32[i25 >> 2] | 0 : i12 & 255) | 0) {
 case 12:
  {
   if (!(_memcmp(i1 ? HEAP32[i24 >> 2] | 0 : i24, gb + 489819 | 0, 12) | 0)) i23 = 5; else i23 = 11;
   break;
  }
 case 8:
  {
   if (!(_memcmp(i1 ? HEAP32[i24 >> 2] | 0 : i24, gb + 489801 | 0, 8) | 0)) i23 = 5; else {
    i1 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
    if (!(_memcmp(i1, gb + 489810 | 0, 8) | 0)) i23 = 9; else {
     if (_memcmp(i1, gb + 489801 | 0, 8) | 0) {
      i23 = 11;
      break L4;
     }
     if (!(_memcmp(i1, gb + 489801 | 0, 8) | 0)) i23 = 9; else i1 = -1;
    }
    if ((i23 | 0) == 9) i1 = __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE(i20, i24, i26 + 88 | 0) | 0;
    HEAP8[i26 + 184 >> 0] = 0;
    i23 = 37;
   }
   break;
  }
 default:
  i23 = 11;
 } while (0);
 do if ((i23 | 0) == 5) {
  i1 = __ZN20ArchiveStorageHeader7ReadAllER12FileAccessorRNS_6HeaderERNS_10BlocksInfoERNS_13DirectoryInfoE(i20, i24, i26 + 88 | 0, i26 + 120 | 0) | 0;
  HEAP8[i26 + 184 >> 0] = (i1 | 0) == 0 & 1;
  i23 = 37;
 } else if ((i23 | 0) == 11) {
  i1 = __ZN20ArchiveStorageHeader10ReadHeaderER12FileAccessorRNS_6HeaderE(i20, i24) | 0;
  if (i1 | 0) {
   i26 = i1;
   STACKTOP = i27;
   return i26 | 0;
  }
  i12 = __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE(i24) | 0;
  i12 = _i64Add(i12 | 0, getTempRet0() | 0, i19 | 0, i22 | 0) | 0;
  if (!(__ZN12FileAccessor4SeekEx10FileOrigin(i20, i12, getTempRet0() | 0, 1) | 0)) {
   i26 = 1;
   STACKTOP = i27;
   return i26 | 0;
  }
  i10 = i26 + 80 | 0;
  i1 = HEAP32[i10 >> 2] & 63;
  if (!i1) {
   i1 = __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE(i20, 0, i26 + 88 | 0) | 0;
   if (i1 | 0) {
    i26 = i1;
    STACKTOP = i27;
    return i26 | 0;
   }
   if (!(HEAP32[i10 >> 2] & 64)) {
    HEAP8[i26 + 184 >> 0] = 1;
    break;
   }
   i1 = __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE(i20, i24, i26 + 120 | 0) | 0;
   i18 = (i1 | 0) == 0;
   HEAP8[i26 + 184 >> 0] = i18 & 1;
   if (i18) break;
   STACKTOP = i27;
   return i1 | 0;
  }
  i7 = gb + 64016 | 0;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i11 = i2;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i11 = __Z18CreateDecompressor15CompressionType10MemLabelId(i1, i16) | 0;
  if (!i11) {
   i26 = -1;
   STACKTOP = i27;
   return i26 | 0;
  }
  i1 = HEAP32[i26 + 72 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  i7 = i26 + 76 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i17 >> 2] = 0;
  i12 = i17 + 4 | 0;
  i5 = gb + 63160 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i12;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i5;
  do if (!i1) {
   i6 = 0;
   i1 = i5;
  } else if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i6 = i2;
   i1 = i5;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, gb + 64016 | 0, 0, gb + 489692 | 0, 241) | 0;
   i4 = gb + 64016 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = i6;
   i1 = i12;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = gb + 63160 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   break;
  } while (0);
  HEAP32[i18 >> 2] = 0;
  i5 = i18 + 4 | 0;
  i2 = i5;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i1;
  do if (!i3) i2 = 0; else if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, gb + 64016 | 0, 0, gb + 489692 | 0, 243) | 0;
   i3 = gb + 64016 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i2;
   i4 = i5;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = i3;
   break;
  } while (0);
  i4 = i13;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = HEAP32[i8 >> 2] | 0;
  __ZN12FileAccessor4ReadEyPvPy(i20, i4, 0, i6, i13) | 0;
  if ((HEAP32[i13 + 4 >> 2] | 0) == 0 ? (HEAP32[i13 >> 2] | 0) == (i4 | 0) : 0) if (mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i6 | 0, i8 | 0, i2 | 0, i9 | 0) | 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
    i8 = gb + 64016 | 0;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i13 = i14;
    HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i13 + 4 >> 2] = i9;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    __ZN10MemoryFile21CreateFileSystemEntryE10MemLabelId14FilePermissionPvjb(i15, i16, 0, i2, i1, 0);
    __ZN12FileAccessorC2Ev(i16);
    if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i16, i15, 0, 0) | 0) {
     i1 = __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE(i16, 0, i26 + 88 | 0) | 0;
     if (!i1) {
      if (!(HEAP32[i10 >> 2] & 64)) i1 = 0; else i1 = __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE(i16, i24, i26 + 120 | 0) | 0;
      HEAP8[i26 + 184 >> 0] = (i1 | 0) == 0 & 1;
     }
    } else i1 = 1;
    __ZN12FileAccessorD2Ev(i16);
    __ZN13FileEntryDataD2Ev(i15);
   } else i1 = 1;
  } else i1 = 1; else i1 = 1;
  mftCall_vi(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 64016 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i5);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i12);
  if (i1 | 0) {
   i26 = i1;
   STACKTOP = i27;
   return i26 | 0;
  }
 } while (0);
 if ((i23 | 0) == 37) if (i1 | 0) {
  i26 = i1;
  STACKTOP = i27;
  return i26 | 0;
 }
 i23 = __ZN20ArchiveStorageHeader13GetDataOffsetERKNS_6HeaderE(i24) | 0;
 i22 = _i64Add(i23 | 0, getTempRet0() | 0, i19 | 0, i22 | 0) | 0;
 i23 = getTempRet0() | 0;
 i19 = i26 + 2320 | 0;
 HEAP32[i19 >> 2] = i22;
 HEAP32[i19 + 4 >> 2] = i23;
 if (!(__ZN12FileAccessor4SeekEx10FileOrigin(i20, i22, i23, 1) | 0)) {
  i26 = 1;
  STACKTOP = i27;
  return i26 | 0;
 }
 i22 = __ZNK12FileAccessor8PositionEv(i20) | 0;
 i1 = getTempRet0() | 0;
 i23 = i26 + 2328 | 0;
 HEAP32[i23 >> 2] = i22;
 HEAP32[i23 + 4 >> 2] = i1;
 i23 = HEAP8[i21 >> 0] | 0;
 i1 = i23 << 24 >> 24 < 0;
 if (((i1 ? HEAP32[i25 >> 2] | 0 : i23 & 255) | 0) != 8) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 if (_memcmp(i1 ? HEAP32[i24 >> 2] | 0 : i24, gb + 489810 | 0, 8) | 0) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i1 = HEAP32[i26 + 104 >> 2] | 0;
 if ((HEAP32[i26 + 108 >> 2] | 0) == (i1 | 0)) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 <= 8) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 HEAP8[i26 + 2360 >> 0] = 1;
 HEAP32[i1 >> 2] = i2 + -8;
 i26 = 0;
 STACKTOP = i27;
 return i26 | 0;
}

function __Z16computeAABBNoCCDRKN5physx18PxcAABBDataDynamicERKNS_20PxsComputeAABBParamsE(i10, i9, i1) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 28 | 0;
 i5 = i8;
 i6 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 i2 = HEAP32[i9 + 8 >> 2] | 0;
 i3 = i6 + 36 | 0;
 f4 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 if (!(HEAP32[i9 + 4 >> 2] | 0)) {
  f20 = Math_fround(f4 * Math_fround(2.0));
  f18 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) * Math_fround(2.0));
  f13 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(2.0));
  f23 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f22 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
  f21 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f20 * f21);
  f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f18 * f19));
  f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f13 * f17));
  f12 = Math_fround(Math_fround(f21 * f4) + Math_fround(Math_fround(f20 * f22) + Math_fround(f23 * Math_fround(Math_fround(f13 * f19) - Math_fround(f18 * f17)))));
  f11 = Math_fround(Math_fround(f19 * f4) + Math_fround(Math_fround(f18 * f22) + Math_fround(f23 * Math_fround(Math_fround(f20 * f17) - Math_fround(f13 * f21)))));
  f4 = Math_fround(Math_fround(Math_fround(f13 * f22) + Math_fround(f23 * Math_fround(Math_fround(f18 * f21) - Math_fround(f20 * f19)))) + Math_fround(f17 * f4));
  f12 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f12);
  f11 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f11);
  f4 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f4);
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  f18 = Math_fround(f23 * f20);
  f22 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f21 * f22));
  f13 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f19 * f13));
  f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f15 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f19 * f22) + Math_fround(f23 * f16))) - Math_fround(f21 * f13));
  f14 = Math_fround(Math_fround(Math_fround(f21 * f16) + Math_fround(Math_fround(f17 * f22) + Math_fround(f23 * f13))) - Math_fround(f19 * f20));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f19 * f16)) - Math_fround(f17 * f13));
  HEAPF32[i5 >> 2] = Math_fround(f18 - Math_fround(f17 * f16));
  HEAPF32[i5 + 4 >> 2] = f15;
  HEAPF32[i5 + 8 >> 2] = f14;
  HEAPF32[i5 + 12 >> 2] = f13;
  HEAPF32[i5 + 16 >> 2] = f12;
  HEAPF32[i5 + 20 >> 2] = f11;
  HEAPF32[i5 + 24 >> 2] = f4;
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i3, i10, i5, Math_fround(HEAPF32[i6 + 28 >> 2]), i7);
  STACKTOP = i8;
  return;
 } else {
  f23 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  f11 = Math_fround(HEAPF32[i2 + 52 >> 2]);
  f23 = Math_fround(f23 * Math_fround(-2.0));
  f11 = Math_fround(f11 * Math_fround(-2.0));
  f21 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) * Math_fround(-2.0));
  f19 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f13 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f16 = Math_fround(f23 * f17);
  f25 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f11 * f25));
  f18 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f21 * f18));
  f20 = Math_fround(-f17);
  f15 = Math_fround(-f25);
  f24 = Math_fround(-f18);
  f12 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f23 * f13) - Math_fround(f19 * Math_fround(Math_fround(f21 * f25) - Math_fround(f11 * f18))))) * Math_fround(2.0));
  f14 = Math_fround(Math_fround(Math_fround(f25 * f16) + Math_fround(Math_fround(f11 * f13) - Math_fround(f19 * Math_fround(Math_fround(f23 * f18) - Math_fround(f21 * f17))))) * Math_fround(2.0));
  f16 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f13) - Math_fround(f19 * Math_fround(Math_fround(f11 * f17) - Math_fround(f23 * f25)))) + Math_fround(f18 * f16)) * Math_fround(2.0));
  f18 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f25 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
  f23 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround(f23 * f12);
  f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f11 * f14));
  f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f17 = Math_fround(Math_fround(f13 * f16) + f17);
  f21 = Math_fround(Math_fround(f23 * f17) + Math_fround(Math_fround(f25 * f12) + Math_fround(f18 * Math_fround(Math_fround(f11 * f16) - Math_fround(f13 * f14)))));
  f22 = Math_fround(Math_fround(f11 * f17) + Math_fround(Math_fround(f25 * f14) + Math_fround(f18 * Math_fround(Math_fround(f13 * f12) - Math_fround(f23 * f16)))));
  f17 = Math_fround(Math_fround(Math_fround(f25 * f16) + Math_fround(f18 * Math_fround(Math_fround(f23 * f14) - Math_fround(f11 * f12)))) + Math_fround(f13 * f17));
  f21 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f21);
  f22 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f22);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f17);
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f20) + Math_fround(f19 * f23)) + Math_fround(f11 * f24)) - Math_fround(f13 * f15));
  f14 = Math_fround(Math_fround(Math_fround(f13 * f20) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f11))) - Math_fround(f23 * f24));
  f16 = Math_fround(Math_fround(Math_fround(f23 * f15) + Math_fround(Math_fround(f18 * f24) + Math_fround(f19 * f13))) - Math_fround(f11 * f20));
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f23 * f20)) - Math_fround(f11 * f15)) - Math_fround(f13 * f24));
  f13 = Math_fround(f4 * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) * Math_fround(2.0));
  f11 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
  f23 = Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(f14 * f15)) + Math_fround(f16 * f11));
  f21 = Math_fround(f21 + Math_fround(Math_fround(f12 * f23) + Math_fround(Math_fround(f20 * f13) + Math_fround(f24 * Math_fround(Math_fround(f14 * f11) - Math_fround(f16 * f15))))));
  f22 = Math_fround(f22 + Math_fround(Math_fround(f14 * f23) + Math_fround(Math_fround(f20 * f15) + Math_fround(f24 * Math_fround(Math_fround(f16 * f13) - Math_fround(f12 * f11))))));
  f23 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f20 * f11) + Math_fround(f24 * Math_fround(Math_fround(f12 * f15) - Math_fround(f14 * f13)))) + Math_fround(f16 * f23)));
  f13 = Math_fround(HEAPF32[i6 >> 2]);
  f15 = Math_fround(f24 * f13);
  f11 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f12 * f11));
  f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f14 * f20));
  f17 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(f14 * f11) + Math_fround(f24 * f17))) - Math_fround(f12 * f20));
  f19 = Math_fround(Math_fround(Math_fround(f12 * f17) + Math_fround(Math_fround(f16 * f11) + Math_fround(f24 * f20))) - Math_fround(f14 * f13));
  f20 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f11) - Math_fround(f12 * f13)) - Math_fround(f14 * f17)) - Math_fround(f16 * f20));
  HEAPF32[i1 >> 2] = Math_fround(f15 - Math_fround(f16 * f17));
  HEAPF32[i1 + 4 >> 2] = f18;
  HEAPF32[i1 + 8 >> 2] = f19;
  HEAPF32[i1 + 12 >> 2] = f20;
  HEAPF32[i1 + 16 >> 2] = f21;
  HEAPF32[i1 + 20 >> 2] = f22;
  HEAPF32[i1 + 24 >> 2] = f23;
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i3, i10, i1, Math_fround(HEAPF32[i6 + 28 >> 2]), i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN13BuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 24 | 0;
 i8 = i11;
 i9 = i11 + 28 | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i3 = i6 + 28 | 0;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 68 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 108 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 111 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 112 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 113 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 114 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 115 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 116 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 117 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 118 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 109 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 110 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 119 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 120 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 121 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = i6 + 140 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 124 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN12UnityVersionC2EPKc(i9, i1);
 __ZN12UnityVersionC2EPKc(i8, gb + 443566 | 0);
 if (__ZNK12UnityVersionltERKS_(i9, i8) | 0) {
  __Z6FormatPKcz(i8, gb + 443574 | 0, i10);
  __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE(i8, 0, gb + 443603 | 0, 203, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  _exit(1);
 } else {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags(i7, i6 + 76 | 0, 0);
  __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(HEAP32[i6 + 80 >> 2] | 0, HEAP32[i6 + 84 >> 2] | 0, i8);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags(i7, i6 + 92 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 156 | 0, 0);
  STACKTOP = i11;
  return;
 }
}

function __Z27compute_intervals_isectlinePfS_S_ffffffffS_S_S_S_(i1, i2, i8, f9, f10, f11, f12, f13, f14, f15, f3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i16 = 0, f17 = f0;
 if (f15 > Math_fround(0.0)) {
  f3 = Math_fround(f14 / Math_fround(f14 - f12));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f9 - f11) * f3) + f11);
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f17 = Math_fround(HEAPF32[i8 >> 2]);
  f9 = Math_fround(f9 - f17);
  f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  i16 = i8 + 4 | 0;
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i16 >> 2]));
  f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i4 = i8 + 8 | 0;
  f15 = Math_fround(f3 * f15);
  f12 = Math_fround(f3 * Math_fround(f12 - Math_fround(HEAPF32[i4 >> 2])));
  HEAPF32[i6 >> 2] = Math_fround(f17 + Math_fround(f3 * f9));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i16 >> 2]));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i4 >> 2]));
  f12 = Math_fround(f14 / Math_fround(f14 - f13));
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(f10 - f11) * f12) + f11);
  f13 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(HEAPF32[i8 >> 2]);
  f13 = Math_fround(f13 - f11);
  f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i16 >> 2]));
  f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f14 = Math_fround(f12 * f14);
  f15 = Math_fround(f12 * Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2])));
  HEAPF32[i7 >> 2] = Math_fround(f11 + Math_fround(f12 * f13));
  HEAPF32[i7 + 4 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i16 >> 2]));
  HEAPF32[i7 + 8 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  i8 = 0;
  return i8 | 0;
 }
 if (f3 > Math_fround(0.0)) {
  f3 = Math_fround(f13 / Math_fround(f13 - f12));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f9 - f10) * f3) + f10);
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround(f17 - f9);
  f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  i4 = i2 + 4 | 0;
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i16 = i2 + 8 | 0;
  f15 = Math_fround(f3 * f15);
  f12 = Math_fround(f3 * Math_fround(f12 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i6 >> 2] = Math_fround(f9 + Math_fround(f3 * f17));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i16 >> 2]));
  f13 = Math_fround(f13 / Math_fround(f13 - f14));
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(f11 - f10) * f13) + f10);
  f14 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  f14 = Math_fround(f14 - f12);
  f15 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f17 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f15 = Math_fround(f13 * f15);
  f17 = Math_fround(f13 * Math_fround(f17 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f13 * f14));
  HEAPF32[i7 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i7 + 8 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
  i16 = 0;
  return i16 | 0;
 }
 if (f12 != Math_fround(0.0) | Math_fround(f13 * f14) > Math_fround(0.0)) {
  f3 = Math_fround(f12 / Math_fround(f12 - f13));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f10 - f9) * f3) + f9);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  f17 = Math_fround(f17 - f10);
  f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i4 = i1 + 4 | 0;
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i16 = i1 + 8 | 0;
  f15 = Math_fround(f3 * f15);
  f13 = Math_fround(f3 * Math_fround(f13 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i6 >> 2] = Math_fround(f10 + Math_fround(f3 * f17));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i16 >> 2]));
  f13 = Math_fround(f12 / Math_fround(f12 - f14));
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(f11 - f9) * f13) + f9);
  f14 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  f14 = Math_fround(f14 - f12);
  f15 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f17 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f15 = Math_fround(f13 * f15);
  f17 = Math_fround(f13 * Math_fround(f17 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f13 * f14));
  HEAPF32[i7 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i7 + 8 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
  i16 = 0;
  return i16 | 0;
 }
 if (f13 != Math_fround(0.0)) {
  f3 = Math_fround(f13 / Math_fround(f13 - f12));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f9 - f10) * f3) + f10);
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround(f17 - f9);
  f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  i4 = i2 + 4 | 0;
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i16 = i2 + 8 | 0;
  f15 = Math_fround(f3 * f15);
  f12 = Math_fround(f3 * Math_fround(f12 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i6 >> 2] = Math_fround(f9 + Math_fround(f3 * f17));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i16 >> 2]));
  f13 = Math_fround(f13 / Math_fround(f13 - f14));
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(f11 - f10) * f13) + f10);
  f14 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  f14 = Math_fround(f14 - f12);
  f15 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
  f17 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f15 = Math_fround(f13 * f15);
  f17 = Math_fround(f13 * Math_fround(f17 - Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f13 * f14));
  HEAPF32[i7 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i7 + 8 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
  i16 = 0;
  return i16 | 0;
 }
 if (!(f14 != Math_fround(0.0))) {
  i16 = 1;
  return i16 | 0;
 }
 f3 = Math_fround(f14 / Math_fround(f14 - f12));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f9 - f11) * f3) + f11);
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(f17 - f9);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i4 = i8 + 4 | 0;
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i16 = i8 + 8 | 0;
 f15 = Math_fround(f3 * f15);
 f12 = Math_fround(f3 * Math_fround(f12 - Math_fround(HEAPF32[i16 >> 2])));
 HEAPF32[i6 >> 2] = Math_fround(f9 + Math_fround(f3 * f17));
 HEAPF32[i6 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i6 + 8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i16 >> 2]));
 f13 = Math_fround(f14 / Math_fround(f14 - f13));
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(f10 - f11) * f13) + f11);
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f14 = Math_fround(f14 - f12);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i4 >> 2]));
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(f13 * f15);
 f17 = Math_fround(f13 * Math_fround(f17 - Math_fround(HEAPF32[i16 >> 2])));
 HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f13 * f14));
 HEAPF32[i7 + 4 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
 i16 = 0;
 return i16 | 0;
}

function __ZN5physx17ConvexHullBuilder4InitEjPKNS_6PxVec3EjPKjjPKNS_13PxHullPolygonE(i30, i2, i3, i1, i16, i28, i25) {
 i30 = i30 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i28 = i28 | 0;
 i25 = i25 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i29 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i31;
 i22 = i31 + 24 | 0;
 i29 = i31 + 8 | 0;
 i17 = i31 + 30 | 0;
 i18 = i31 + 29 | 0;
 i19 = i31 + 28 | 0;
 i21 = i31 + 4 | 0;
 i27 = i30 + 4 | 0;
 i24 = i30 + 8 | 0;
 i23 = i30 + 32 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = 0;
 HEAP32[i23 >> 2] = i1;
 i26 = i30 + 20 | 0;
 HEAP8[(HEAP32[i26 >> 2] | 0) + 38 >> 0] = i2;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i31 + 31 | 0, (i2 & 255) * 12 | 0, gb + 726825 | 0, 938) | 0;
 HEAP32[i30 >> 2] = i4;
 _memcpy(i4 | 0, i3 | 0, (HEAPU8[(HEAP32[i26 >> 2] | 0) + 38 >> 0] | 0) * 12 | 0) | 0;
 i4 = (i25 | 0) != 0;
 if (!((i16 | 0) == 0 | i4)) {
  i2 = HEAP32[i23 >> 2] | 0;
  i1 = i2 >>> 0 > 357913941 ? -1 : i2 * 12 | 0;
  if (!i1) {
   i3 = 0;
   i1 = i2;
  } else {
   i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
   i3 = _PxGetFoundation() | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
   i3 = mftCall_iiiiii(i14 | 0, i15 | 0, i1 | 0, (i3 ? gb + 726918 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 944) | 0;
   i1 = HEAP32[i23 >> 2] | 0;
  }
  HEAP32[i30 + 36 >> 2] = i3;
  if (i1 | 0) {
   i1 = 0;
   do {
    i15 = i1 * 3 | 0;
    HEAP32[i3 + (i1 * 12 | 0) >> 2] = HEAP32[i16 + (i15 << 2) >> 2];
    HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i16 + (i15 + 1 << 2) >> 2];
    HEAP32[i3 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i16 + (i15 + 2 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i23 >> 2] | 0) >>> 0);
  }
 }
 __ZN5physx2Gu9ContainerC2Ev(i29);
 if (!((i28 | 0) == 0 | i4 ^ 1)) {
  i13 = i29 + 4 | 0;
  i14 = i29 + 8 | 0;
  i15 = 0;
  do {
   i6 = i25 + (i15 * 20 | 0) + 16 | 0;
   i2 = HEAP16[i6 >> 1] | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i29 >> 2] | 0)) {
    __ZN5physx2Gu9Container6ResizeEj(i29, 1) | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    i3 = HEAP16[i6 >> 1] | 0;
   } else i3 = i2;
   HEAP32[i13 >> 2] = i1 + 1;
   i7 = HEAP32[i14 >> 2] | 0;
   HEAP32[i7 + (i1 << 2) >> 2] = i2 & 65535;
   if (i3 << 16 >> 16) {
    i5 = i25 + (i15 * 20 | 0) + 18 | 0;
    i4 = 0;
    do {
     i2 = HEAP32[i16 + ((HEAPU16[i5 >> 1] | 0) + i4 << 2) >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i29 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i29, 1) | 0;
      i1 = HEAP32[i13 >> 2] | 0;
      i7 = HEAP32[i14 >> 2] | 0;
      i3 = HEAP16[i6 >> 1] | 0;
     }
     HEAP32[i13 >> 2] = i1 + 1;
     HEAP32[i7 + (i1 << 2) >> 2] = i2;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (i3 & 65535) >>> 0);
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i28 | 0));
  if ((i28 | 0) != 0 & (i7 | 0) != 0) {
   HEAP8[(HEAP32[i26 >> 2] | 0) + 39 >> 0] = 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i24 >> 2] | 0);
   HEAP32[i24 >> 2] = 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, HEAP32[i27 >> 2] | 0);
   HEAP32[i27 >> 2] = 0;
   if (i28 >>> 0 > 255) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726825 | 0, 995, gb + 730155 | 0, i20);
    i30 = 0;
    __ZN5physx2Gu9ContainerD2Ev(i29);
    STACKTOP = i31;
    return i30 | 0;
   }
   HEAP8[(HEAP32[i26 >> 2] | 0) + 39 >> 0] = i28;
   HEAP32[i27 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, (i28 & 255) * 20 | 0, gb + 726825 | 0, 1001) | 0;
   i3 = i7;
   i1 = 0;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    i1 = i2 + i1 | 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i28 | 0)) break; else i3 = i3 + (i2 + 1 << 2) | 0;
   }
   if (!i1) i1 = 0; else {
    i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i21 = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0;
    i23 = _PxGetFoundation() | 0;
    i23 = mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 24 >> 2] | 0, i23 | 0) | 0;
    i1 = mftCall_iiiiii(i21 | 0, i22 | 0, i1 | 0, (i23 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1016) | 0;
   }
   HEAP32[i24 >> 2] = i1;
   i6 = i1;
   i3 = HEAP32[i27 >> 2] | 0;
   i5 = i1;
   i2 = 0;
   while (1) {
    HEAP16[i3 + (i2 * 20 | 0) + 16 >> 1] = i5 - i6;
    i4 = HEAP32[i7 >> 2] | 0;
    HEAP8[i3 + (i2 * 20 | 0) + 18 >> 0] = i4;
    if (!i4) i1 = i3; else {
     i1 = 0;
     do {
      i23 = i1;
      i1 = i1 + 1 | 0;
      HEAP8[i5 + i23 >> 0] = HEAP32[i7 + (i1 << 2) >> 2];
     } while ((i1 | 0) != (i4 | 0));
     i1 = HEAP32[i27 >> 2] | 0;
    }
    i21 = HEAP32[i25 + (i2 * 20 | 0) + 4 >> 2] | 0;
    i22 = HEAP32[i25 + (i2 * 20 | 0) + 8 >> 2] | 0;
    i23 = HEAP32[i25 + (i2 * 20 | 0) + 12 >> 2] | 0;
    HEAP32[i1 + (i2 * 20 | 0) >> 2] = HEAP32[i25 + (i2 * 20 | 0) >> 2];
    HEAP32[i1 + (i2 * 20 | 0) + 4 >> 2] = i21;
    HEAP32[i1 + (i2 * 20 | 0) + 8 >> 2] = i22;
    HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2] = i23;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i28 | 0)) break;
    i6 = HEAP32[i24 >> 2] | 0;
    i3 = i1;
    i7 = i7 + (i4 + 1 << 2) | 0;
    i5 = i5 + i4 | 0;
   }
   if (!(__ZN5physx17ConvexHullBuilder23CalculateVertexMapTableEjb(i30, i28, 1) | 0)) {
    i30 = 0;
    __ZN5physx2Gu9ContainerD2Ev(i29);
    STACKTOP = i31;
    return i30 | 0;
   }
   i13 = HEAP8[(HEAP32[i26 >> 2] | 0) + 38 >> 0] | 0;
   i14 = HEAP32[i30 >> 2] | 0;
   i5 = HEAP32[i27 >> 2] | 0;
   i6 = i13 << 24 >> 24 == 0;
   i7 = 0;
   do {
    if (i6) i1 = -1; else {
     f8 = Math_fround(HEAPF32[i5 + (i7 * 20 | 0) >> 2]);
     f9 = Math_fround(HEAPF32[i5 + (i7 * 20 | 0) + 4 >> 2]);
     f10 = Math_fround(HEAPF32[i5 + (i7 * 20 | 0) + 8 >> 2]);
     i3 = i14;
     i4 = 0;
     i1 = -1;
     f12 = Math_fround(3402823469999999843913219.0e14);
     while (1) {
      f11 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f8);
      f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f9));
      f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f10));
      i2 = f11 < f12;
      i1 = i2 ? i4 : i1;
      i4 = i4 + 1 << 24 >> 24;
      if ((i4 & 255) >= (i13 & 255)) break; else {
       i3 = i3 + 12 | 0;
       f12 = i2 ? f11 : f12;
      }
     }
    }
    HEAP8[i5 + (i7 * 20 | 0) + 19 >> 0] = i1;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i28 | 0));
   if (!(__ZN5physx17ConvexHullBuilder27CreateTrianglesFromPolygonsEv(i30) | 0)) {
    i30 = 0;
    __ZN5physx2Gu9ContainerD2Ev(i29);
    STACKTOP = i31;
    return i30 | 0;
   }
   i30 = __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv(i30) | 0;
   __ZN5physx2Gu9ContainerD2Ev(i29);
   STACKTOP = i31;
   return i30 | 0;
  }
 }
 i3 = HEAP32[i30 + 36 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAPU8[(HEAP32[i26 >> 2] | 0) + 38 >> 0];
 __ZL9CleanHullRjPN5physx2Gu9TriangleTIjEES_PNS0_6PxVec3E(i23, i3, i21, HEAP32[i30 >> 2] | 0);
 i2 = HEAP32[i21 >> 2] | 0;
 HEAP8[(HEAP32[i26 >> 2] | 0) + 38 >> 0] = i2;
 i1 = HEAP32[i30 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 if (!(__ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb(i22, i3, 0) | 0)) {
  i30 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i29);
  STACKTOP = i31;
  return i30 | 0;
 }
 if (!(__ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb(i2 & 255, i1, HEAP32[i22 >> 2] | 0, i3, 0) | 0)) {
  i30 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i29);
  STACKTOP = i31;
  return i30 | 0;
 }
 if (!(__ZN5physx17ConvexHullBuilder17CreatePolygonDataEv(i30) | 0)) {
  i30 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i29);
  STACKTOP = i31;
  return i30 | 0;
 }
 i30 = __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv(i30) | 0;
 __ZN5physx2Gu9ContainerD2Ev(i29);
 STACKTOP = i31;
 return i30 | 0;
}

function __ZN9ShaderLab14SerializedPassaSERKS0_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 20 | 0;
 i13 = i16 + 16 | 0;
 i14 = i16 + 12 | 0;
 i15 = i16;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 i7 = i12 + 4 | 0;
 i1 = i10 + 4 | 0;
 i8 = (i12 | 0) == (i10 | 0);
 do if (!i8) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i10 + 8 >> 2] | 0 : i6 & 255;
  i3 = i7 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i12 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i12 + 8 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i12 + 8 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 _memcpy(i12 + 20 | 0, i10 + 20 | 0, 684) | 0;
 __ZN9ShaderLab16SerializedTagMapaSERKS0_(i12 + 704 | 0, i10 + 704 | 0) | 0;
 i9 = i12 + 716 | 0;
 i7 = i10 + 716 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP16[i9 + 4 >> 1] = HEAP16[i7 + 4 >> 1] | 0;
 HEAP32[i12 + 724 >> 2] = HEAP32[i10 + 724 >> 2];
 do if (!i8) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 728 | 0, HEAP32[i10 + 728 >> 2] | 0, HEAP32[i10 + 732 >> 2] | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 740 | 0, HEAP32[i10 + 740 >> 2] | 0, HEAP32[i10 + 744 >> 2] | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 752 | 0, HEAP32[i10 + 752 >> 2] | 0, HEAP32[i10 + 756 >> 2] | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 764 | 0, HEAP32[i10 + 764 >> 2] | 0, HEAP32[i10 + 768 >> 2] | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 776 | 0, HEAP32[i10 + 776 >> 2] | 0, HEAP32[i10 + 780 >> 2] | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 788 | 0, HEAP32[i10 + 788 >> 2] | 0, HEAP32[i10 + 792 >> 2] | 0);
  i1 = i12 + 800 | 0;
  i6 = i10 + 800 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i10 + 804 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 808 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 804 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i12 + 804 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  i1 = i12 + 816 | 0;
  i6 = i10 + 816 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i10 + 820 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 824 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 820 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i12 + 820 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  i1 = i12 + 832 | 0;
  i6 = i10 + 832 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i10 + 836 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 840 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 836 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i12 + 836 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 __ZN9ShaderLab16SerializedTagMapaSERKS0_(i12 + 848 | 0, i10 + 848 | 0) | 0;
 i9 = i12 + 860 | 0;
 if (i8) {
  STACKTOP = i16;
  return i12 | 0;
 }
 i1 = i12 + 864 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i9, HEAP32[i1 >> 2] | 0);
 i8 = i12 + 868 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i10 + 860 >> 2] | 0;
 i7 = i10 + 864 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i16;
  return i12 | 0;
 }
 i6 = i12 + 864 | 0;
 i3 = i2;
 while (1) {
  i3 = i3 + 16 | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  i5 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_(i9, i11, i13, i3) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i15, i9, i3);
   i3 = HEAP32[i15 >> 2] | 0;
   HEAP32[i15 >> 2] = 0;
   i4 = HEAP32[i13 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   i4 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i9 >> 2] = i4;
    i3 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i3);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
    i2 = i3;
    break;
   } else i2 = i3;
  } else {
   i2 = i3;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
  }
  if ((i2 | 0) == (i7 | 0)) break; else i3 = i2;
 }
 STACKTOP = i16;
 return i12 | 0;
}

function __ZN21GLESGpuProgramApplier11ApplyVectorERKN20GpuProgramParameters14ValueParameterEPK8Vector4ft(i13, i17, i15, i14) {
 i13 = i13 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i10 = i13 + 12 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != -1) {
  if (!(HEAP32[i17 + 12 >> 2] | 0)) {
   i1 = (HEAP32[i13 + 16 >> 2] | 0) + 6624 | 0;
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   if (i14 << 16 >> 16 == 1) {
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i1, i3, i2, i15, HEAPU8[i17 + 17 >> 0] << 2);
    STACKTOP = i18;
    return;
   } else {
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i1, i3, i2, i15, (i14 & 65535) << 4);
    STACKTOP = i18;
    return;
   }
  }
  HEAP32[i16 >> 2] = 0;
  i9 = i16 + 4 | 0;
  i12 = gb + 63160 | 0;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = (i14 & 65535) << 4;
  i4 = i14 << 16 >> 16 == 0;
  do if (i4) i2 = 0; else {
   i3 = (i1 | 4) + -1 | 0;
   if (i3 >>> 0 < 2e3) {
    i2 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 626) | 0;
    i11 = gb + 64016 | 0;
    i8 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    HEAP32[i16 >> 2] = i2;
    i12 = i9;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i11;
    break;
   }
  } while (0);
  i7 = i2 + 3 & -4;
  i8 = i7;
  _memset(i8 | 0, 0, i1 | 0) | 0;
  if (!i4) {
   i12 = HEAP8[i17 + 17 >> 0] | 0;
   i3 = i12 & 255;
   if (i12 << 24 >> 24) {
    i6 = 0;
    do {
     i4 = i15 + (i6 << 4) | 0;
     i5 = i6 << 2;
     i2 = 0;
     do {
      HEAP32[i7 + (i2 + i5 << 2) >> 2] = ~~Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
     i6 = i6 + 1 | 0;
    } while ((i6 & 65535) << 16 >> 16 != i14 << 16 >> 16);
   }
   if (i14 << 16 >> 16 == 1) i1 = HEAPU8[i17 + 17 >> 0] << 2;
  }
  __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi((HEAP32[i13 + 16 >> 2] | 0) + 6624 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i8, i1);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i9);
  STACKTOP = i18;
  return;
 }
 i10 = ((i17 - (HEAP32[i13 + 4 >> 2] | 0) | 0) / 20 | 0) + (HEAP32[i13 + 8 >> 2] | 0) | 0;
 i11 = i17 + 17 | 0;
 i2 = HEAP8[i11 >> 0] | 0;
 i1 = (HEAP32[i17 + 12 >> 2] | 0) == 0;
 if (i2 << 24 >> 24 == 4) {
  if (i1) {
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i14 & 65535;
   i4 = i3 << 2;
   i2 = (HEAP32[i2 + 20 >> 2] | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] << 2) | 0;
   L33 : do if (i4 >>> 0 <= 64) {
    if (!(i14 << 16 >> 16)) {
     STACKTOP = i18;
     return;
    } else i1 = 0;
    do {
     if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) != (HEAP32[i15 + (i1 << 2) >> 2] | 0)) break L33;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
    STACKTOP = i18;
    return;
   } while (0);
   _memcpy(i2 | 0, i15 | 0, i3 << 4 | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i3 | 0, i15 | 0);
   STACKTOP = i18;
   return;
  }
 } else if (i1) {
  HEAP32[i16 >> 2] = 0;
  i8 = i16 + 4 | 0;
  i1 = gb + 63160 | 0;
  i7 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = i8;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
  i9 = i14 & 65535;
  i7 = Math_imul(i2 & 255, i9) | 0;
  i1 = i7 << 2;
  do if (!i7) i1 = 0; else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 654) | 0;
    i6 = gb + 64016 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    HEAP32[i16 >> 2] = i1;
    i7 = i8;
    HEAP32[i7 >> 2] = i5;
    HEAP32[i7 + 4 >> 2] = i6;
    break;
   }
  } while (0);
  i2 = i1 + 3 & -4;
  i7 = i2;
  if (i14 << 16 >> 16) {
   i6 = HEAP8[i11 >> 0] | 0;
   i3 = i6 & 255;
   if (i6 << 24 >> 24) {
    i6 = 0;
    do {
     i4 = i15 + (i6 << 4) | 0;
     i5 = Math_imul(i3, i6) | 0;
     i1 = 0;
     do {
      HEAP32[i7 + (i5 + i1 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
     i6 = i6 + 1 | 0;
    } while ((i6 & 65535) << 16 >> 16 != i14 << 16 >> 16);
   }
  }
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i2;
  i5 = Math_imul(HEAPU8[i11 >> 0] | 0, i9) | 0;
  i3 = (HEAP32[i3 + 20 >> 2] | 0) + (HEAP32[(HEAP32[i3 >> 2] | 0) + (i10 << 2) >> 2] << 2) | 0;
  L59 : do if (i5 >>> 0 > 64) i12 = 39; else if (i5 | 0) {
   i1 = 0;
   do {
    if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) != (HEAP32[i2 + (i1 << 2) >> 2] | 0)) {
     i12 = 39;
     break L59;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
  } while (0);
  L64 : do if ((i12 | 0) == 39) {
   _memcpy(i3 | 0, i4 | 0, i5 << 2 | 0) | 0;
   switch (HEAP8[i11 >> 0] | 0) {
   case 2:
    {
     mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 136 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i9 | 0, i7 | 0);
     break L64;
    }
   case 3:
    {
     mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 144 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i9 | 0, i7 | 0);
     break L64;
    }
   default:
    break L64;
   }
  } while (0);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
  STACKTOP = i18;
  return;
 }
 HEAP32[i16 >> 2] = 0;
 i8 = i16 + 4 | 0;
 i1 = gb + 63160 | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i14 & 65535;
 i7 = Math_imul(i2 & 255, i9) | 0;
 i1 = i7 << 2;
 do if (!i7) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 671) | 0;
   i6 = gb + 64016 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = i1;
   i7 = i8;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 i7 = i3;
 if (i14 << 16 >> 16) {
  i6 = HEAP8[i11 >> 0] | 0;
  i2 = i6 & 255;
  if (i6 << 24 >> 24) {
   i6 = 0;
   do {
    i4 = i15 + (i6 << 4) | 0;
    i5 = Math_imul(i2, i6) | 0;
    i1 = 0;
    do {
     HEAP32[i7 + (i5 + i1 << 2) >> 2] = ~~Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
    i6 = i6 + 1 | 0;
   } while ((i6 & 65535) << 16 >> 16 != i14 << 16 >> 16);
  }
 }
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = Math_imul(HEAPU8[i11 >> 0] | 0, i9) | 0;
 i2 = (HEAP32[i2 + 20 >> 2] | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] << 2) | 0;
 L86 : do if (i4 >>> 0 > 64) i12 = 56; else if (i4 | 0) {
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) != (HEAP32[i7 + (i1 << 2) >> 2] | 0)) {
    i12 = 56;
    break L86;
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 L91 : do if ((i12 | 0) == 56) {
  _memcpy(i2 | 0, i3 | 0, i4 << 2 | 0) | 0;
  switch (HEAP8[i11 >> 0] | 0) {
  case 2:
   {
    mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 140 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i9 | 0, i7 | 0);
    break L91;
   }
  case 3:
   {
    mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 148 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i9 | 0, i7 | 0);
    break L91;
   }
  case 4:
   {
    mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 156 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i9 | 0, i7 | 0);
    break L91;
   }
  default:
   break L91;
  }
 } while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
 STACKTOP = i18;
 return;
}

function __ZN5physx6shdfnd8internal7median3INS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEvPT_iiRT0_(i8, i5, i9, i4) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 20 | 0;
 i11 = i12;
 i7 = (i9 + i5 | 0) / 2 | 0;
 i1 = i8 + (i7 * 40 | 0) | 0;
 i3 = i8 + (i5 * 40 | 0) | 0;
 if (mftCall_iii(HEAP32[i4 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
  i13 = i8 + (i5 * 40 | 0) + 4 | 0;
  i17 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
  i16 = i8 + (i5 * 40 | 0) + 8 | 0;
  i16 = HEAPU16[i16 >> 1] | HEAPU16[i16 + 2 >> 1] << 16;
  i2 = i8 + (i5 * 40 | 0) + 12 | 0;
  i6 = i8 + (i5 * 40 | 0) + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  i14 = HEAP32[i2 >> 2] | 0;
  i18 = i8 + (i5 * 40 | 0) + 20 | 0;
  HEAP32[i11 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  i15 = i8 + (i7 * 40 | 0) + 4 | 0;
  i19 = i15;
  i21 = i19;
  i21 = HEAPU16[i21 >> 1] | HEAPU16[i21 + 2 >> 1] << 16;
  i19 = i19 + 4 | 0;
  i19 = HEAPU16[i19 >> 1] | HEAPU16[i19 + 2 >> 1] << 16;
  i20 = i13;
  HEAP16[i20 >> 1] = i21;
  HEAP16[i20 + 2 >> 1] = i21 >>> 16;
  i13 = i13 + 4 | 0;
  HEAP16[i13 >> 1] = i19;
  HEAP16[i13 + 2 >> 1] = i19 >>> 16;
  i13 = i8 + (i7 * 40 | 0) + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  i2 = i8 + (i7 * 40 | 0) + 16 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  i6 = i8 + (i7 * 40 | 0) + 20 | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP16[i15 >> 1] = i17;
  HEAP16[i15 + 2 >> 1] = i17 >>> 16;
  i15 = i8 + (i7 * 40 | 0) + 8 | 0;
  HEAP16[i15 >> 1] = i16;
  HEAP16[i15 + 2 >> 1] = i16 >>> 16;
  HEAP32[i13 >> 2] = i14;
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 }
 i2 = i8 + (i9 * 40 | 0) | 0;
 if (mftCall_iii(HEAP32[i4 >> 2] | 0, i2 | 0, i3 | 0) | 0) {
  i19 = i8 + (i5 * 40 | 0) + 4 | 0;
  i15 = HEAPU16[i19 >> 1] | HEAPU16[i19 + 2 >> 1] << 16;
  i16 = i8 + (i5 * 40 | 0) + 8 | 0;
  i16 = HEAPU16[i16 >> 1] | HEAPU16[i16 + 2 >> 1] << 16;
  i20 = i8 + (i5 * 40 | 0) + 12 | 0;
  i21 = i8 + (i5 * 40 | 0) + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i21 >> 2];
  i18 = HEAP32[i20 >> 2] | 0;
  i14 = i8 + (i5 * 40 | 0) + 20 | 0;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  i17 = i8 + (i9 * 40 | 0) + 4 | 0;
  i13 = i17;
  i5 = i13;
  i5 = HEAPU16[i5 >> 1] | HEAPU16[i5 + 2 >> 1] << 16;
  i13 = i13 + 4 | 0;
  i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
  i6 = i19;
  HEAP16[i6 >> 1] = i5;
  HEAP16[i6 + 2 >> 1] = i5 >>> 16;
  i19 = i19 + 4 | 0;
  HEAP16[i19 >> 1] = i13;
  HEAP16[i19 + 2 >> 1] = i13 >>> 16;
  i19 = i8 + (i9 * 40 | 0) + 12 | 0;
  HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
  i20 = i8 + (i9 * 40 | 0) + 16 | 0;
  HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
  i21 = i8 + (i9 * 40 | 0) + 20 | 0;
  HEAP32[i14 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
  HEAP16[i17 >> 1] = i15;
  HEAP16[i17 + 2 >> 1] = i15 >>> 16;
  i17 = i8 + (i9 * 40 | 0) + 8 | 0;
  HEAP16[i17 >> 1] = i16;
  HEAP16[i17 + 2 >> 1] = i16 >>> 16;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 }
 if (mftCall_iii(HEAP32[i4 >> 2] | 0, i2 | 0, i1 | 0) | 0) {
  i3 = i8 + (i7 * 40 | 0) + 4 | 0;
  i16 = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
  i4 = i8 + (i7 * 40 | 0) + 8 | 0;
  i17 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
  i5 = i8 + (i7 * 40 | 0) + 12 | 0;
  i6 = i8 + (i7 * 40 | 0) + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  i19 = HEAP32[i5 >> 2] | 0;
  i1 = i8 + (i7 * 40 | 0) + 20 | 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  i18 = i8 + (i9 * 40 | 0) + 4 | 0;
  i21 = i18;
  i15 = i21;
  i15 = HEAPU16[i15 >> 1] | HEAPU16[i15 + 2 >> 1] << 16;
  i21 = i21 + 4 | 0;
  i21 = HEAPU16[i21 >> 1] | HEAPU16[i21 + 2 >> 1] << 16;
  i20 = i3;
  i2 = i20;
  HEAP16[i2 >> 1] = i15;
  HEAP16[i2 + 2 >> 1] = i15 >>> 16;
  i20 = i20 + 4 | 0;
  HEAP16[i20 >> 1] = i21;
  HEAP16[i20 + 2 >> 1] = i21 >>> 16;
  i20 = i8 + (i9 * 40 | 0) + 12 | 0;
  HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
  i21 = i8 + (i9 * 40 | 0) + 16 | 0;
  HEAP32[i6 >> 2] = HEAP32[i21 >> 2];
  i2 = i8 + (i9 * 40 | 0) + 20 | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP16[i18 >> 1] = i16;
  HEAP16[i18 + 2 >> 1] = i16 >>> 16;
  i18 = i8 + (i9 * 40 | 0) + 8 | 0;
  HEAP16[i18 >> 1] = i17;
  HEAP16[i18 + 2 >> 1] = i17 >>> 16;
  HEAP32[i20 >> 2] = i19;
  HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  i2 = i3;
 } else {
  i3 = i8 + (i7 * 40 | 0) + 4 | 0;
  i4 = i8 + (i7 * 40 | 0) + 8 | 0;
  i5 = i8 + (i7 * 40 | 0) + 12 | 0;
  i6 = i8 + (i7 * 40 | 0) + 16 | 0;
  i1 = i8 + (i7 * 40 | 0) + 20 | 0;
  i2 = i3;
 }
 i17 = i9 + -1 | 0;
 i14 = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
 i16 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 i18 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 i15 = i8 + (i17 * 40 | 0) + 4 | 0;
 i20 = i15;
 i13 = i20;
 i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
 i20 = i20 + 4 | 0;
 i20 = HEAPU16[i20 >> 1] | HEAPU16[i20 + 2 >> 1] << 16;
 i19 = i2;
 i21 = i19;
 HEAP16[i21 >> 1] = i13;
 HEAP16[i21 + 2 >> 1] = i13 >>> 16;
 i19 = i19 + 4 | 0;
 HEAP16[i19 >> 1] = i20;
 HEAP16[i19 + 2 >> 1] = i20 >>> 16;
 i19 = i8 + (i17 * 40 | 0) + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
 i20 = i8 + (i17 * 40 | 0) + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 i21 = i8 + (i17 * 40 | 0) + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
 HEAP16[i15 >> 1] = i14;
 HEAP16[i15 + 2 >> 1] = i14 >>> 16;
 i17 = i8 + (i17 * 40 | 0) + 8 | 0;
 HEAP16[i17 >> 1] = i16;
 HEAP16[i17 + 2 >> 1] = i16 >>> 16;
 HEAP32[i19 >> 2] = i18;
 HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 48 | 0;
 i17 = i19 + 32 | 0;
 i11 = i19 + 16 | 0;
 i8 = i19;
 i9 = (HEAP32[i10 + 72 >> 2] | 0) - (HEAP32[i10 + 68 >> 2] | 0) >> 2;
 i15 = i14 + 64 | 0;
 HEAP32[i15 >> 2] = i9;
 i13 = i14 + 12 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i12 = i9 >>> 0 <= i12 >>> 0 | (i12 | 0) == 0 ? i9 : i12;
 HEAP32[i15 >> 2] = i12;
 if (!i12) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i6 = i1 + 52 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i10 + 36 | 0;
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i5 = i1 ? HEAP32[i10 + 40 >> 2] | 0 : i5 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i18 = 5;
 } else if (i5 >>> 0 < 11) {
  i2 = i17 + 11 | 0;
  HEAP8[i2 >> 0] = i5;
  if (!i5) {
   i1 = i17;
   i12 = i2;
  } else {
   i1 = i17;
   i18 = 7;
  }
 } else i18 = 5;
 if ((i18 | 0) == 5) {
  i2 = i5 + 16 & -16;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i5;
  i2 = i17 + 11 | 0;
  i18 = 7;
 }
 if ((i18 | 0) == 7) {
  _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  i12 = i2;
 }
 HEAP8[i1 + i5 >> 0] = 0;
 i7 = HEAP8[i12 >> 0] | 0;
 i1 = i7 << 24 >> 24 < 0;
 i9 = i17 + 4 | 0;
 if ((i1 ? HEAP32[i9 >> 2] | 0 : i7 & 255) | 0) i4 = __Z11StringToIntPKc(i1 ? HEAP32[i17 >> 2] | 0 : i17) | 0;
 do if ((i4 | 0) == 3) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i5 = HEAP8[i12 >> 0] | 0;
  i7 = i5 << 24 >> 24 < 0;
  i1 = i7 ? HEAP32[i17 >> 2] | 0 : i17;
  i5 = i7 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
  if (!i5) {
   i1 = 0;
   i2 = 0;
  } else {
   i4 = i1 + i5 | 0;
   i2 = i4;
   i3 = i1;
   L20 : do if ((i5 | 0) >= 1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 124) break;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) break L20;
    }
    i2 = i1;
   } while (0);
   i1 = i2 - i3 | 0;
   if ((i2 | 0) == (i4 | 0) | (i1 | 0) == -1) {
    i1 = 0;
    i2 = 0;
   } else {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 < i5 >>> 0) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_(i8, i17, i1, -1, i17 + 12 | 0);
     i4 = i8 + 11 | 0;
     i6 = HEAP8[i4 >> 0] | 0;
     i7 = i6 << 24 >> 24 < 0;
     i5 = i7 ? HEAP32[i8 >> 2] | 0 : i8;
     i6 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
     i7 = i11 + 11 | 0;
     i2 = HEAP8[i7 >> 0] | 0;
     i3 = i2 << 24 >> 24 < 0;
     if (i3) i1 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
     do if (i6 >>> 0 > i1 >>> 0) {
      i3 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i2 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i1, i6 - i1 | 0, i3, 0, i3, i6, i5);
     } else {
      i1 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
      if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
      HEAP8[i1 + i6 >> 0] = 0;
      if ((HEAP8[i7 >> 0] | 0) < 0) {
       HEAP32[i11 + 4 >> 2] = i6;
       break;
      } else {
       HEAP8[i7 >> 0] = i6;
       break;
      }
     } while (0);
     if ((HEAP8[i4 >> 0] | 0) < 0) {
      i6 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 12 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i16 + 4 >> 2] = i8;
      __Z19free_alloc_internalPvRK10MemLabelId(i6, i16);
     }
     i1 = HEAP8[i7 >> 0] | 0;
     i2 = HEAP32[i11 + 4 >> 2] | 0;
    } else {
     i1 = 0;
     i2 = 0;
    }
   }
  }
  i8 = i11 + 11 | 0;
  i4 = i1 << 24 >> 24 < 0;
  i5 = i11 + 4 | 0;
  do if (!((i4 ? i2 : i1 & 255) | 0)) {
   i2 = HEAP8[i12 >> 0] | 0;
   i7 = i2 << 24 >> 24 < 0;
   i3 = i7 ? HEAP32[i17 >> 2] | 0 : i17;
   i2 = i7 ? HEAP32[i9 >> 2] | 0 : i2 & 255;
   if (i4) i1 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
   if (i2 >>> 0 > i1 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i1, i2 - i1 | 0, 0, 0, 0, i2, i3);
    break;
   }
   i1 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
   if (i2 | 0) _memmove(i1 | 0, i3 | 0, i2 | 0) | 0;
   HEAP8[i1 + i2 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i5 >> 2] = i2;
    break;
   } else {
    HEAP8[i8 >> 0] = i2;
    break;
   }
  } while (0);
  i1 = HEAP32[i14 + 96 >> 2] | 0;
  mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0);
  i1 = HEAP32[HEAP32[i10 + 68 >> 2] >> 2] | 0;
  i5 = i14 + 112 | 0;
  do if ((i5 | 0) != (i1 | 0)) {
   i6 = HEAP8[i1 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
   i3 = i5 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i14 + 120 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i6 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i14 + 116 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i6 - i4 | 0, i1, 0, i1, i6, i7);
    break;
   }
   if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
   if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i14 + 116 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
  HEAP32[i15 >> 2] = 1;
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i16 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i16);
  }
 } else {
  i1 = HEAP32[i14 + 96 >> 2] | 0;
  i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i4 | 0) == 1) {
   mftCall_vii(i2 | 0, i1 | 0, i3 + 68 | 0);
   __ZN11UnityEngine15CloudWebService16SessionContainer21GetJsonArrayDataBlockEjRK8UnityStrS4_RS2_Pj(i10, HEAP32[i15 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 20 | 0, i6, i14 + 112 | 0, i14 + 68 | 0) | 0;
   break;
  } else {
   mftCall_vii(i2 | 0, i1 | 0, i3 + 84 | 0);
   __ZN11UnityEngine15CloudWebService16SessionContainer16GetJsonDataBlockEjRK8UnityStrRS2_Pj(i10, HEAP32[i15 >> 2] | 0, (HEAP32[i13 >> 2] | 0) + 36 | 0, i14 + 112 | 0, i14 + 68 | 0) | 0;
   break;
  }
 } while (0);
 __ZN11UnityEngine15CloudWebService14DataDispatcher15SetupWebRequestEv(i14);
 i3 = i14 + 88 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) i18 = 65; else {
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  if (i4 >>> 0 > i2 >>> 0 & (i1 | 0) != 0) {
   HEAP32[i3 >> 2] = 1;
   HEAP32[i14 + 84 >> 2] = i1;
   i1 = 0;
   i2 = HEAP32[i15 >> 2] | 0;
  } else i18 = 65;
 }
 if ((i18 | 0) == 65) {
  __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv(i14);
  i1 = 1;
  i2 = 0;
 }
 if ((HEAP8[i12 >> 0] | 0) < 0) {
  i18 = HEAP32[i17 >> 2] | 0;
  i17 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 66;
  HEAP32[i16 + 4 >> 2] = i17;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i16);
 }
 if (!i1) {
  i18 = i2;
  STACKTOP = i19;
  return i18 | 0;
 }
 i18 = HEAP32[i15 >> 2] | 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i2, i1, i37, i36) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i37 = i37 | 0;
 i36 = i36 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, i39 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i38 + 112 | 0;
 i12 = i38 + 96 | 0;
 i34 = i38 + 80 | 0;
 i29 = i38 + 64 | 0;
 i30 = i38 + 130 | 0;
 i33 = i38 + 60 | 0;
 i31 = i38 + 128 | 0;
 i32 = i38 + 32 | 0;
 i14 = i38 + 16 | 0;
 i15 = i38;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = -1;
 if (!i36) {
  i39 = 1;
  STACKTOP = i38;
  return i39 | 0;
 }
 i25 = i29 + 4 | 0;
 i26 = i2 + 20 | 0;
 i35 = i2 + 12 | 0;
 i27 = i2 + 41 | 0;
 i28 = i2 + 16 | 0;
 i16 = i2 + 24 | 0;
 i17 = i2 + 4 | 0;
 i18 = i2 + 32 | 0;
 i19 = i29 + 8 | 0;
 i20 = i29 + 12 | 0;
 i21 = i2 + 8 | 0;
 i22 = i2 + 39 | 0;
 i23 = i2 + 28 | 0;
 i24 = i2 + 38 | 0;
 i10 = i2 + 36 | 0;
 i11 = 0;
 L4 : while (1) {
  HEAP32[i29 >> 2] = 0;
  HEAP32[i25 >> 2] = 0;
  __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E(i37 + (i11 << 3) | 0, i29);
  i1 = HEAP32[i26 >> 2] | 0;
  i9 = HEAP16[i1 + 16 >> 1] | 0;
  HEAP16[i30 >> 1] = i9;
  i8 = HEAP8[i27 >> 0] | 0;
  i2 = (i9 << 16 >> 16 < 0 ? 1 : (HEAP32[(HEAP32[i35 >> 2] | 0) + 28 >> 2] | 0) != 0) & i8 << 24 >> 24 == 0 ? 1 : 2;
  HEAP32[i33 >> 2] = i2;
  HEAP16[i31 >> 1] = HEAP16[i28 >> 1] | 0;
  if (!(i8 << 24 >> 24)) {
   i8 = (__ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj(i29, i33, i30, i1, HEAP32[i16 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i18 >> 2] | 0, i31) | 0) ^ 1;
   i1 = HEAP32[i33 >> 2] | 0;
   if (!((i1 | 0) == 0 | i8)) {
    i2 = i1;
    i39 = 5;
   }
  } else i39 = 5;
  L8 : do if ((i39 | 0) == 5) {
   i39 = 0;
   i1 = HEAP32[i19 >> 2] | 0;
   __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE(i32, i1, HEAP32[i20 >> 2] | 0);
   if (!(HEAP32[i1 + 4 >> 2] & 1)) i3 = i1 + 84 | 0; else i3 = (HEAP32[i1 + 8 >> 2] | 0) + 56 | 0;
   i5 = HEAP32[i35 >> 2] | 0;
   i1 = HEAP32[i5 + 32 >> 2] | 0;
   i1 = (HEAP32[i5 + 28 >> 2] | 0) >>> 0 > i1 >>> 0 ? (HEAP32[i5 + 24 >> 2] | 0) + (i1 << 4) | 0 : i34;
   i5 = HEAP32[i21 >> 2] | 0;
   i4 = HEAP32[i5 + 12 >> 2] | 0;
   i5 = HEAP32[i5 + 16 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i17 >> 2] | 0) + 3400 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   if ((i7 | 0) > (i8 | 0)) {
    if (!(mftCall_iiiiii(HEAP32[i6 + (i8 * 28 | 0) + (i7 << 2) >> 2] | 0, i3 | 0, i32 | 0, i4 | 0, i5 | 0, 0) | 0)) break;
   } else if (!(mftCall_iiiiii(HEAP32[i6 + (i7 * 28 | 0) + (i8 << 2) >> 2] | 0, i4 | 0, i5 | 0, i3 | 0, i32 | 0, 0) | 0)) break;
   HEAP32[i1 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i25 >> 2];
   if (!(i9 & 8)) {
    if ((i2 | 0) != 0 & (HEAP8[i22 >> 0] | 0) != 0) {
     i39 = 30;
     break L4;
    }
    switch (((HEAP8[i24 >> 0] | 0) == 0 ? i2 : 1) | 0) {
    case 1:
     break;
    case 2:
     {
      if (!(Math_fround(HEAPF32[i23 >> 2]) >= Math_fround(-1.0))) break L8;
      i9 = (HEAP32[i35 >> 2] | 0) + 4 | 0;
      HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP8[(HEAP32[i35 >> 2] | 0) + 20 >> 0] = 1;
      break L8;
     }
    default:
     break L8;
    }
    i3 = HEAP32[i35 >> 2] | 0;
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i10 >> 0] | 0)) break;
    if (!(Math_fround(HEAPF32[i23 >> 2]) >= Math_fround(-1.0))) break;
    i2 = HEAP32[i3 + 32 >> 2] | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i9 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i3 + 24 >> 2] | 0, i4 | 0) | 0;
     HEAP8[i10 >> 0] = i9 & 1;
     if (!i9) {
      i1 = 0;
      i39 = 42;
      break L4;
     }
     HEAP32[(HEAP32[i35 >> 2] | 0) + 32 >> 2] = 0;
     i2 = HEAP32[i35 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 32 >> 2] | 0;
    }
    i9 = HEAP32[i3 + 24 >> 2] | 0;
    HEAP32[i3 + 32 >> 2] = i2 + 1;
    i9 = i9 + (i2 << 4) | 0;
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    break;
   }
   do if (!(HEAP8[i27 >> 0] | 0)) {
    i3 = HEAP32[i16 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i26 >> 2] | 0, i1 | 0) | 0;
     break;
    }
    if (HEAP32[i18 >> 2] | 0) {
     i3 = HEAP32[i18 >> 2] | 0;
     i4 = HEAP32[i3 + 12 >> 2] | 0;
     if (i4) {
      i9 = HEAP32[i26 >> 2] | 0;
      HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      i9 = (HEAP32[i19 >> 2] | 0) + 16 | 0;
      HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i15 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i15 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i15 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      i9 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i2 = mftCall_iiiiii(i4 | 0, i12 | 0, i13 | 0, i9 | 0, i2 | 0, i1 | 0) | 0;
     }
    }
   } while (0);
   if ((i2 | 0) != 0 & (HEAP8[i22 >> 0] | 0) != 0) {
    i39 = 30;
    break L4;
   }
   switch (((HEAP8[i24 >> 0] | 0) == 0 ? i2 : 1) | 0) {
   case 1:
    break;
   case 2:
    {
     if (!(Math_fround(HEAPF32[i23 >> 2]) >= Math_fround(-1.0))) break L8;
     i9 = (HEAP32[i35 >> 2] | 0) + 4 | 0;
     HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP8[(HEAP32[i35 >> 2] | 0) + 20 >> 0] = 1;
     break L8;
    }
   default:
    break L8;
   }
   i3 = HEAP32[i35 >> 2] | 0;
   i4 = HEAP32[i3 + 28 >> 2] | 0;
   if (i4 | 0) if (HEAP8[i10 >> 0] | 0) if (Math_fround(HEAPF32[i23 >> 2]) >= Math_fround(-1.0)) {
    i2 = HEAP32[i3 + 32 >> 2] | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i9 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i3 + 24 >> 2] | 0, i4 | 0) | 0;
     HEAP8[i10 >> 0] = i9 & 1;
     if (!i9) {
      i1 = 0;
      i39 = 42;
      break L4;
     }
     HEAP32[(HEAP32[i35 >> 2] | 0) + 32 >> 2] = 0;
     i2 = HEAP32[i35 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 32 >> 2] | 0;
    }
    i9 = HEAP32[i3 + 24 >> 2] | 0;
    HEAP32[i3 + 32 >> 2] = i2 + 1;
    i9 = i9 + (i2 << 4) | 0;
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   }
  } while (0);
  i11 = i11 + 1 | 0;
  if (i11 >>> 0 >= i36 >>> 0) {
   i1 = 1;
   i39 = 42;
   break;
  }
 }
 if ((i39 | 0) == 30) {
  i39 = (HEAP32[i35 >> 2] | 0) + 4 | 0;
  HEAP32[i39 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i39 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i39 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i39 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP8[(HEAP32[i35 >> 2] | 0) + 20 >> 0] = 1;
  i39 = 0;
  STACKTOP = i38;
  return i39 | 0;
 } else if ((i39 | 0) == 42) {
  STACKTOP = i38;
  return i1 | 0;
 }
 return 0;
}

function runPostSets152() {
 HEAP32[gb + 141068 >> 2] = (HEAP32[gb + 141068 >> 2] | 0) + (gb + 759712 | 0);
 HEAP32[gb + 141072 >> 2] = (HEAP32[gb + 141072 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141076 >> 2] = (HEAP32[gb + 141076 >> 2] | 0) + (gb + 759732 | 0);
 HEAP32[gb + 141080 >> 2] = (HEAP32[gb + 141080 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141084 >> 2] = (HEAP32[gb + 141084 >> 2] | 0) + (gb + 759756 | 0);
 HEAP32[gb + 141088 >> 2] = (HEAP32[gb + 141088 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141092 >> 2] = (HEAP32[gb + 141092 >> 2] | 0) + (gb + 759783 | 0);
 HEAP32[gb + 141096 >> 2] = (HEAP32[gb + 141096 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141100 >> 2] = (HEAP32[gb + 141100 >> 2] | 0) + (gb + 759811 | 0);
 HEAP32[gb + 141104 >> 2] = (HEAP32[gb + 141104 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141108 >> 2] = (HEAP32[gb + 141108 >> 2] | 0) + (gb + 759837 | 0);
 HEAP32[gb + 141112 >> 2] = (HEAP32[gb + 141112 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141116 >> 2] = (HEAP32[gb + 141116 >> 2] | 0) + (gb + 759852 | 0);
 HEAP32[gb + 141120 >> 2] = (HEAP32[gb + 141120 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141124 >> 2] = (HEAP32[gb + 141124 >> 2] | 0) + (gb + 759871 | 0);
 HEAP32[gb + 141128 >> 2] = (HEAP32[gb + 141128 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141132 >> 2] = (HEAP32[gb + 141132 >> 2] | 0) + (gb + 759899 | 0);
 HEAP32[gb + 141136 >> 2] = (HEAP32[gb + 141136 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141140 >> 2] = (HEAP32[gb + 141140 >> 2] | 0) + (gb + 759919 | 0);
 HEAP32[gb + 141144 >> 2] = (HEAP32[gb + 141144 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141148 >> 2] = (HEAP32[gb + 141148 >> 2] | 0) + (gb + 759939 | 0);
 HEAP32[gb + 141152 >> 2] = (HEAP32[gb + 141152 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141156 >> 2] = (HEAP32[gb + 141156 >> 2] | 0) + (gb + 759963 | 0);
 HEAP32[gb + 141160 >> 2] = (HEAP32[gb + 141160 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141164 >> 2] = (HEAP32[gb + 141164 >> 2] | 0) + (gb + 759988 | 0);
 HEAP32[gb + 141168 >> 2] = (HEAP32[gb + 141168 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 141172 >> 2] = (HEAP32[gb + 141172 >> 2] | 0) + (gb + 760013 | 0);
 HEAP32[gb + 141176 >> 2] = (HEAP32[gb + 141176 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141180 >> 2] = (HEAP32[gb + 141180 >> 2] | 0) + (gb + 760047 | 0);
 HEAP32[gb + 141184 >> 2] = (HEAP32[gb + 141184 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141188 >> 2] = (HEAP32[gb + 141188 >> 2] | 0) + (gb + 760076 | 0);
 HEAP32[gb + 141192 >> 2] = (HEAP32[gb + 141192 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141196 >> 2] = (HEAP32[gb + 141196 >> 2] | 0) + (gb + 760106 | 0);
 HEAP32[gb + 141200 >> 2] = (HEAP32[gb + 141200 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 141204 >> 2] = (HEAP32[gb + 141204 >> 2] | 0) + (gb + 760144 | 0);
 HEAP32[gb + 141208 >> 2] = (HEAP32[gb + 141208 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141212 >> 2] = (HEAP32[gb + 141212 >> 2] | 0) + (gb + 760172 | 0);
 HEAP32[gb + 141216 >> 2] = (HEAP32[gb + 141216 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141220 >> 2] = (HEAP32[gb + 141220 >> 2] | 0) + (gb + 760205 | 0);
 HEAP32[gb + 141224 >> 2] = (HEAP32[gb + 141224 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141228 >> 2] = (HEAP32[gb + 141228 >> 2] | 0) + (gb + 760233 | 0);
 HEAP32[gb + 141232 >> 2] = (HEAP32[gb + 141232 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141236 >> 2] = (HEAP32[gb + 141236 >> 2] | 0) + (gb + 760262 | 0);
 HEAP32[gb + 141240 >> 2] = (HEAP32[gb + 141240 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 141244 >> 2] = (HEAP32[gb + 141244 >> 2] | 0) + (gb + 760299 | 0);
 HEAP32[gb + 141248 >> 2] = (HEAP32[gb + 141248 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 141252 >> 2] = (HEAP32[gb + 141252 >> 2] | 0) + (gb + 760333 | 0);
 HEAP32[gb + 141256 >> 2] = (HEAP32[gb + 141256 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 141260 >> 2] = (HEAP32[gb + 141260 >> 2] | 0) + (gb + 760368 | 0);
 HEAP32[gb + 141264 >> 2] = (HEAP32[gb + 141264 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141268 >> 2] = (HEAP32[gb + 141268 >> 2] | 0) + (gb + 760401 | 0);
 HEAP32[gb + 141272 >> 2] = (HEAP32[gb + 141272 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141276 >> 2] = (HEAP32[gb + 141276 >> 2] | 0) + (gb + 760429 | 0);
 HEAP32[gb + 141280 >> 2] = (HEAP32[gb + 141280 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141284 >> 2] = (HEAP32[gb + 141284 >> 2] | 0) + (gb + 760458 | 0);
 HEAP32[gb + 141288 >> 2] = (HEAP32[gb + 141288 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 141292 >> 2] = (HEAP32[gb + 141292 >> 2] | 0) + (gb + 760495 | 0);
 HEAP32[gb + 141296 >> 2] = (HEAP32[gb + 141296 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 141300 >> 2] = (HEAP32[gb + 141300 >> 2] | 0) + (gb + 760523 | 0);
 HEAP32[gb + 141304 >> 2] = (HEAP32[gb + 141304 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 141308 >> 2] = (HEAP32[gb + 141308 >> 2] | 0) + (gb + 760551 | 0);
 HEAP32[gb + 141312 >> 2] = (HEAP32[gb + 141312 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141316 >> 2] = (HEAP32[gb + 141316 >> 2] | 0) + (gb + 760577 | 0);
 HEAP32[gb + 141320 >> 2] = (HEAP32[gb + 141320 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141324 >> 2] = (HEAP32[gb + 141324 >> 2] | 0) + (gb + 760604 | 0);
 HEAP32[gb + 141328 >> 2] = (HEAP32[gb + 141328 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141332 >> 2] = (HEAP32[gb + 141332 >> 2] | 0) + (gb + 760634 | 0);
 HEAP32[gb + 141336 >> 2] = (HEAP32[gb + 141336 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141340 >> 2] = (HEAP32[gb + 141340 >> 2] | 0) + (gb + 760659 | 0);
 HEAP32[gb + 141344 >> 2] = (HEAP32[gb + 141344 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141348 >> 2] = (HEAP32[gb + 141348 >> 2] | 0) + (gb + 760685 | 0);
 HEAP32[gb + 141352 >> 2] = (HEAP32[gb + 141352 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141356 >> 2] = (HEAP32[gb + 141356 >> 2] | 0) + (gb + 760712 | 0);
 HEAP32[gb + 141360 >> 2] = (HEAP32[gb + 141360 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141364 >> 2] = (HEAP32[gb + 141364 >> 2] | 0) + (gb + 760742 | 0);
 HEAP32[gb + 141368 >> 2] = (HEAP32[gb + 141368 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141372 >> 2] = (HEAP32[gb + 141372 >> 2] | 0) + (gb + 760767 | 0);
 HEAP32[gb + 141376 >> 2] = (HEAP32[gb + 141376 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141380 >> 2] = (HEAP32[gb + 141380 >> 2] | 0) + (gb + 760793 | 0);
 HEAP32[gb + 141384 >> 2] = (HEAP32[gb + 141384 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141388 >> 2] = (HEAP32[gb + 141388 >> 2] | 0) + (gb + 760820 | 0);
 HEAP32[gb + 141392 >> 2] = (HEAP32[gb + 141392 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141396 >> 2] = (HEAP32[gb + 141396 >> 2] | 0) + (gb + 760850 | 0);
 HEAP32[gb + 141400 >> 2] = (HEAP32[gb + 141400 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141404 >> 2] = (HEAP32[gb + 141404 >> 2] | 0) + (gb + 760875 | 0);
 HEAP32[gb + 141408 >> 2] = (HEAP32[gb + 141408 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141412 >> 2] = (HEAP32[gb + 141412 >> 2] | 0) + (gb + 760905 | 0);
 HEAP32[gb + 141416 >> 2] = (HEAP32[gb + 141416 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141420 >> 2] = (HEAP32[gb + 141420 >> 2] | 0) + (gb + 760936 | 0);
 HEAP32[gb + 141424 >> 2] = (HEAP32[gb + 141424 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141428 >> 2] = (HEAP32[gb + 141428 >> 2] | 0) + (gb + 760970 | 0);
 HEAP32[gb + 141432 >> 2] = (HEAP32[gb + 141432 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141436 >> 2] = (HEAP32[gb + 141436 >> 2] | 0) + (gb + 760999 | 0);
 HEAP32[gb + 141440 >> 2] = (HEAP32[gb + 141440 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141444 >> 2] = (HEAP32[gb + 141444 >> 2] | 0) + (gb + 761029 | 0);
 HEAP32[gb + 141448 >> 2] = (HEAP32[gb + 141448 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141452 >> 2] = (HEAP32[gb + 141452 >> 2] | 0) + (gb + 761060 | 0);
 HEAP32[gb + 141456 >> 2] = (HEAP32[gb + 141456 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141460 >> 2] = (HEAP32[gb + 141460 >> 2] | 0) + (gb + 761094 | 0);
 HEAP32[gb + 141464 >> 2] = (HEAP32[gb + 141464 >> 2] | 0) + (gb + 1576256 | 0);
 runPostSets153();
}

function runPostSets153() {
 HEAP32[gb + 141468 >> 2] = (HEAP32[gb + 141468 >> 2] | 0) + (gb + 761123 | 0);
 HEAP32[gb + 141472 >> 2] = (HEAP32[gb + 141472 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141476 >> 2] = (HEAP32[gb + 141476 >> 2] | 0) + (gb + 761153 | 0);
 HEAP32[gb + 141480 >> 2] = (HEAP32[gb + 141480 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141484 >> 2] = (HEAP32[gb + 141484 >> 2] | 0) + (gb + 761184 | 0);
 HEAP32[gb + 141488 >> 2] = (HEAP32[gb + 141488 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141492 >> 2] = (HEAP32[gb + 141492 >> 2] | 0) + (gb + 761218 | 0);
 HEAP32[gb + 141496 >> 2] = (HEAP32[gb + 141496 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141500 >> 2] = (HEAP32[gb + 141500 >> 2] | 0) + (gb + 761247 | 0);
 HEAP32[gb + 141504 >> 2] = (HEAP32[gb + 141504 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 141508 >> 2] = (HEAP32[gb + 141508 >> 2] | 0) + (gb + 761271 | 0);
 HEAP32[gb + 141512 >> 2] = (HEAP32[gb + 141512 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 141516 >> 2] = (HEAP32[gb + 141516 >> 2] | 0) + (gb + 761302 | 0);
 HEAP32[gb + 141520 >> 2] = (HEAP32[gb + 141520 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 141524 >> 2] = (HEAP32[gb + 141524 >> 2] | 0) + (gb + 761334 | 0);
 HEAP32[gb + 141528 >> 2] = (HEAP32[gb + 141528 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 141532 >> 2] = (HEAP32[gb + 141532 >> 2] | 0) + (gb + 761377 | 0);
 HEAP32[gb + 141536 >> 2] = (HEAP32[gb + 141536 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 141540 >> 2] = (HEAP32[gb + 141540 >> 2] | 0) + (gb + 761422 | 0);
 HEAP32[gb + 141544 >> 2] = (HEAP32[gb + 141544 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141548 >> 2] = (HEAP32[gb + 141548 >> 2] | 0) + (gb + 761452 | 0);
 HEAP32[gb + 141552 >> 2] = (HEAP32[gb + 141552 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141556 >> 2] = (HEAP32[gb + 141556 >> 2] | 0) + (gb + 761483 | 0);
 HEAP32[gb + 141560 >> 2] = (HEAP32[gb + 141560 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141564 >> 2] = (HEAP32[gb + 141564 >> 2] | 0) + (gb + 761512 | 0);
 HEAP32[gb + 141568 >> 2] = (HEAP32[gb + 141568 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141572 >> 2] = (HEAP32[gb + 141572 >> 2] | 0) + (gb + 761530 | 0);
 HEAP32[gb + 141576 >> 2] = (HEAP32[gb + 141576 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141580 >> 2] = (HEAP32[gb + 141580 >> 2] | 0) + (gb + 761552 | 0);
 HEAP32[gb + 141584 >> 2] = (HEAP32[gb + 141584 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 141588 >> 2] = (HEAP32[gb + 141588 >> 2] | 0) + (gb + 761591 | 0);
 HEAP32[gb + 141592 >> 2] = (HEAP32[gb + 141592 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 141596 >> 2] = (HEAP32[gb + 141596 >> 2] | 0) + (gb + 761631 | 0);
 HEAP32[gb + 141600 >> 2] = (HEAP32[gb + 141600 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141604 >> 2] = (HEAP32[gb + 141604 >> 2] | 0) + (gb + 761664 | 0);
 HEAP32[gb + 141608 >> 2] = (HEAP32[gb + 141608 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141612 >> 2] = (HEAP32[gb + 141612 >> 2] | 0) + (gb + 761698 | 0);
 HEAP32[gb + 141616 >> 2] = (HEAP32[gb + 141616 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141620 >> 2] = (HEAP32[gb + 141620 >> 2] | 0) + (gb + 761730 | 0);
 HEAP32[gb + 141624 >> 2] = (HEAP32[gb + 141624 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141628 >> 2] = (HEAP32[gb + 141628 >> 2] | 0) + (gb + 761751 | 0);
 HEAP32[gb + 141632 >> 2] = (HEAP32[gb + 141632 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141636 >> 2] = (HEAP32[gb + 141636 >> 2] | 0) + (gb + 761776 | 0);
 HEAP32[gb + 141640 >> 2] = (HEAP32[gb + 141640 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141644 >> 2] = (HEAP32[gb + 141644 >> 2] | 0) + (gb + 761804 | 0);
 HEAP32[gb + 141648 >> 2] = (HEAP32[gb + 141648 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141652 >> 2] = (HEAP32[gb + 141652 >> 2] | 0) + (gb + 761832 | 0);
 HEAP32[gb + 141656 >> 2] = (HEAP32[gb + 141656 >> 2] | 0) + (gb + 761858 | 0);
 HEAP32[gb + 141660 >> 2] = (HEAP32[gb + 141660 >> 2] | 0) + (gb + 761864 | 0);
 HEAP32[gb + 141664 >> 2] = (HEAP32[gb + 141664 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141668 >> 2] = (HEAP32[gb + 141668 >> 2] | 0) + (gb + 761887 | 0);
 HEAP32[gb + 141672 >> 2] = (HEAP32[gb + 141672 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141676 >> 2] = (HEAP32[gb + 141676 >> 2] | 0) + (gb + 761911 | 0);
 HEAP32[gb + 141680 >> 2] = (HEAP32[gb + 141680 >> 2] | 0) + (gb + 761946 | 0);
 HEAP32[gb + 141684 >> 2] = (HEAP32[gb + 141684 >> 2] | 0) + (gb + 761968 | 0);
 HEAP32[gb + 141688 >> 2] = (HEAP32[gb + 141688 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141692 >> 2] = (HEAP32[gb + 141692 >> 2] | 0) + (gb + 762001 | 0);
 HEAP32[gb + 141696 >> 2] = (HEAP32[gb + 141696 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141700 >> 2] = (HEAP32[gb + 141700 >> 2] | 0) + (gb + 762035 | 0);
 HEAP32[gb + 141704 >> 2] = (HEAP32[gb + 141704 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141708 >> 2] = (HEAP32[gb + 141708 >> 2] | 0) + (gb + 762067 | 0);
 HEAP32[gb + 141712 >> 2] = (HEAP32[gb + 141712 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141716 >> 2] = (HEAP32[gb + 141716 >> 2] | 0) + (gb + 762088 | 0);
 HEAP32[gb + 141720 >> 2] = (HEAP32[gb + 141720 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141724 >> 2] = (HEAP32[gb + 141724 >> 2] | 0) + (gb + 762113 | 0);
 HEAP32[gb + 141728 >> 2] = (HEAP32[gb + 141728 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141732 >> 2] = (HEAP32[gb + 141732 >> 2] | 0) + (gb + 762147 | 0);
 HEAP32[gb + 141736 >> 2] = (HEAP32[gb + 141736 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141740 >> 2] = (HEAP32[gb + 141740 >> 2] | 0) + (gb + 762176 | 0);
 HEAP32[gb + 141744 >> 2] = (HEAP32[gb + 141744 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141748 >> 2] = (HEAP32[gb + 141748 >> 2] | 0) + (gb + 762206 | 0);
 HEAP32[gb + 141752 >> 2] = (HEAP32[gb + 141752 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 141756 >> 2] = (HEAP32[gb + 141756 >> 2] | 0) + (gb + 762244 | 0);
 HEAP32[gb + 141760 >> 2] = (HEAP32[gb + 141760 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 141764 >> 2] = (HEAP32[gb + 141764 >> 2] | 0) + (gb + 762272 | 0);
 HEAP32[gb + 141768 >> 2] = (HEAP32[gb + 141768 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 141772 >> 2] = (HEAP32[gb + 141772 >> 2] | 0) + (gb + 762300 | 0);
 HEAP32[gb + 141776 >> 2] = (HEAP32[gb + 141776 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141780 >> 2] = (HEAP32[gb + 141780 >> 2] | 0) + (gb + 762330 | 0);
 HEAP32[gb + 141784 >> 2] = (HEAP32[gb + 141784 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141788 >> 2] = (HEAP32[gb + 141788 >> 2] | 0) + (gb + 762362 | 0);
 HEAP32[gb + 141792 >> 2] = (HEAP32[gb + 141792 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 141796 >> 2] = (HEAP32[gb + 141796 >> 2] | 0) + (gb + 762393 | 0);
 HEAP32[gb + 141800 >> 2] = (HEAP32[gb + 141800 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141804 >> 2] = (HEAP32[gb + 141804 >> 2] | 0) + (gb + 762428 | 0);
 HEAP32[gb + 141808 >> 2] = (HEAP32[gb + 141808 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 141812 >> 2] = (HEAP32[gb + 141812 >> 2] | 0) + (gb + 762470 | 0);
 HEAP32[gb + 141816 >> 2] = (HEAP32[gb + 141816 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 141820 >> 2] = (HEAP32[gb + 141820 >> 2] | 0) + (gb + 762513 | 0);
 HEAP32[gb + 141824 >> 2] = (HEAP32[gb + 141824 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141828 >> 2] = (HEAP32[gb + 141828 >> 2] | 0) + (gb + 762547 | 0);
 HEAP32[gb + 141832 >> 2] = (HEAP32[gb + 141832 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141836 >> 2] = (HEAP32[gb + 141836 >> 2] | 0) + (gb + 762582 | 0);
 HEAP32[gb + 141840 >> 2] = (HEAP32[gb + 141840 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141844 >> 2] = (HEAP32[gb + 141844 >> 2] | 0) + (gb + 762615 | 0);
 HEAP32[gb + 141848 >> 2] = (HEAP32[gb + 141848 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141852 >> 2] = (HEAP32[gb + 141852 >> 2] | 0) + (gb + 762637 | 0);
 HEAP32[gb + 141856 >> 2] = (HEAP32[gb + 141856 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141860 >> 2] = (HEAP32[gb + 141860 >> 2] | 0) + (gb + 762663 | 0);
 HEAP32[gb + 141864 >> 2] = (HEAP32[gb + 141864 >> 2] | 0) + (gb + 1075318 | 0);
 runPostSets154();
}

function runPostSets157() {
 HEAP32[gb + 143076 >> 2] = (HEAP32[gb + 143076 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143080 >> 2] = (HEAP32[gb + 143080 >> 2] | 0) + (gb + 760551 | 0);
 HEAP32[gb + 143084 >> 2] = (HEAP32[gb + 143084 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143088 >> 2] = (HEAP32[gb + 143088 >> 2] | 0) + (gb + 760577 | 0);
 HEAP32[gb + 143092 >> 2] = (HEAP32[gb + 143092 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143096 >> 2] = (HEAP32[gb + 143096 >> 2] | 0) + (gb + 760604 | 0);
 HEAP32[gb + 143100 >> 2] = (HEAP32[gb + 143100 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143104 >> 2] = (HEAP32[gb + 143104 >> 2] | 0) + (gb + 760634 | 0);
 HEAP32[gb + 143108 >> 2] = (HEAP32[gb + 143108 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143112 >> 2] = (HEAP32[gb + 143112 >> 2] | 0) + (gb + 760659 | 0);
 HEAP32[gb + 143116 >> 2] = (HEAP32[gb + 143116 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143120 >> 2] = (HEAP32[gb + 143120 >> 2] | 0) + (gb + 760685 | 0);
 HEAP32[gb + 143124 >> 2] = (HEAP32[gb + 143124 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143128 >> 2] = (HEAP32[gb + 143128 >> 2] | 0) + (gb + 760712 | 0);
 HEAP32[gb + 143132 >> 2] = (HEAP32[gb + 143132 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143136 >> 2] = (HEAP32[gb + 143136 >> 2] | 0) + (gb + 760742 | 0);
 HEAP32[gb + 143140 >> 2] = (HEAP32[gb + 143140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143144 >> 2] = (HEAP32[gb + 143144 >> 2] | 0) + (gb + 760767 | 0);
 HEAP32[gb + 143148 >> 2] = (HEAP32[gb + 143148 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143152 >> 2] = (HEAP32[gb + 143152 >> 2] | 0) + (gb + 760793 | 0);
 HEAP32[gb + 143156 >> 2] = (HEAP32[gb + 143156 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143160 >> 2] = (HEAP32[gb + 143160 >> 2] | 0) + (gb + 760820 | 0);
 HEAP32[gb + 143164 >> 2] = (HEAP32[gb + 143164 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143168 >> 2] = (HEAP32[gb + 143168 >> 2] | 0) + (gb + 760850 | 0);
 HEAP32[gb + 143172 >> 2] = (HEAP32[gb + 143172 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143176 >> 2] = (HEAP32[gb + 143176 >> 2] | 0) + (gb + 760875 | 0);
 HEAP32[gb + 143180 >> 2] = (HEAP32[gb + 143180 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143184 >> 2] = (HEAP32[gb + 143184 >> 2] | 0) + (gb + 760905 | 0);
 HEAP32[gb + 143188 >> 2] = (HEAP32[gb + 143188 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143192 >> 2] = (HEAP32[gb + 143192 >> 2] | 0) + (gb + 760936 | 0);
 HEAP32[gb + 143196 >> 2] = (HEAP32[gb + 143196 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143200 >> 2] = (HEAP32[gb + 143200 >> 2] | 0) + (gb + 760970 | 0);
 HEAP32[gb + 143204 >> 2] = (HEAP32[gb + 143204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143208 >> 2] = (HEAP32[gb + 143208 >> 2] | 0) + (gb + 760999 | 0);
 HEAP32[gb + 143212 >> 2] = (HEAP32[gb + 143212 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143216 >> 2] = (HEAP32[gb + 143216 >> 2] | 0) + (gb + 761029 | 0);
 HEAP32[gb + 143220 >> 2] = (HEAP32[gb + 143220 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143224 >> 2] = (HEAP32[gb + 143224 >> 2] | 0) + (gb + 761060 | 0);
 HEAP32[gb + 143228 >> 2] = (HEAP32[gb + 143228 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143232 >> 2] = (HEAP32[gb + 143232 >> 2] | 0) + (gb + 761094 | 0);
 HEAP32[gb + 143236 >> 2] = (HEAP32[gb + 143236 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143240 >> 2] = (HEAP32[gb + 143240 >> 2] | 0) + (gb + 761123 | 0);
 HEAP32[gb + 143244 >> 2] = (HEAP32[gb + 143244 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143248 >> 2] = (HEAP32[gb + 143248 >> 2] | 0) + (gb + 761153 | 0);
 HEAP32[gb + 143252 >> 2] = (HEAP32[gb + 143252 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143256 >> 2] = (HEAP32[gb + 143256 >> 2] | 0) + (gb + 761184 | 0);
 HEAP32[gb + 143260 >> 2] = (HEAP32[gb + 143260 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143264 >> 2] = (HEAP32[gb + 143264 >> 2] | 0) + (gb + 761218 | 0);
 HEAP32[gb + 143268 >> 2] = (HEAP32[gb + 143268 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143272 >> 2] = (HEAP32[gb + 143272 >> 2] | 0) + (gb + 761247 | 0);
 HEAP32[gb + 143276 >> 2] = (HEAP32[gb + 143276 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143280 >> 2] = (HEAP32[gb + 143280 >> 2] | 0) + (gb + 761271 | 0);
 HEAP32[gb + 143284 >> 2] = (HEAP32[gb + 143284 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 143288 >> 2] = (HEAP32[gb + 143288 >> 2] | 0) + (gb + 761302 | 0);
 HEAP32[gb + 143292 >> 2] = (HEAP32[gb + 143292 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 143296 >> 2] = (HEAP32[gb + 143296 >> 2] | 0) + (gb + 761334 | 0);
 HEAP32[gb + 143300 >> 2] = (HEAP32[gb + 143300 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 143304 >> 2] = (HEAP32[gb + 143304 >> 2] | 0) + (gb + 761377 | 0);
 HEAP32[gb + 143308 >> 2] = (HEAP32[gb + 143308 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 143312 >> 2] = (HEAP32[gb + 143312 >> 2] | 0) + (gb + 763868 | 0);
 HEAP32[gb + 143316 >> 2] = (HEAP32[gb + 143316 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 143320 >> 2] = (HEAP32[gb + 143320 >> 2] | 0) + (gb + 763895 | 0);
 HEAP32[gb + 143324 >> 2] = (HEAP32[gb + 143324 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 143328 >> 2] = (HEAP32[gb + 143328 >> 2] | 0) + (gb + 763922 | 0);
 HEAP32[gb + 143332 >> 2] = (HEAP32[gb + 143332 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143336 >> 2] = (HEAP32[gb + 143336 >> 2] | 0) + (gb + 763953 | 0);
 HEAP32[gb + 143340 >> 2] = (HEAP32[gb + 143340 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143344 >> 2] = (HEAP32[gb + 143344 >> 2] | 0) + (gb + 761422 | 0);
 HEAP32[gb + 143348 >> 2] = (HEAP32[gb + 143348 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143352 >> 2] = (HEAP32[gb + 143352 >> 2] | 0) + (gb + 761452 | 0);
 HEAP32[gb + 143356 >> 2] = (HEAP32[gb + 143356 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143360 >> 2] = (HEAP32[gb + 143360 >> 2] | 0) + (gb + 761483 | 0);
 HEAP32[gb + 143364 >> 2] = (HEAP32[gb + 143364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143368 >> 2] = (HEAP32[gb + 143368 >> 2] | 0) + (gb + 761512 | 0);
 HEAP32[gb + 143372 >> 2] = (HEAP32[gb + 143372 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143376 >> 2] = (HEAP32[gb + 143376 >> 2] | 0) + (gb + 761552 | 0);
 HEAP32[gb + 143380 >> 2] = (HEAP32[gb + 143380 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 143384 >> 2] = (HEAP32[gb + 143384 >> 2] | 0) + (gb + 761591 | 0);
 HEAP32[gb + 143388 >> 2] = (HEAP32[gb + 143388 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 143392 >> 2] = (HEAP32[gb + 143392 >> 2] | 0) + (gb + 763984 | 0);
 HEAP32[gb + 143396 >> 2] = (HEAP32[gb + 143396 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 143400 >> 2] = (HEAP32[gb + 143400 >> 2] | 0) + (gb + 764014 | 0);
 HEAP32[gb + 143404 >> 2] = (HEAP32[gb + 143404 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 143408 >> 2] = (HEAP32[gb + 143408 >> 2] | 0) + (gb + 764044 | 0);
 HEAP32[gb + 143412 >> 2] = (HEAP32[gb + 143412 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143416 >> 2] = (HEAP32[gb + 143416 >> 2] | 0) + (gb + 764078 | 0);
 HEAP32[gb + 143420 >> 2] = (HEAP32[gb + 143420 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143424 >> 2] = (HEAP32[gb + 143424 >> 2] | 0) + (gb + 761631 | 0);
 HEAP32[gb + 143428 >> 2] = (HEAP32[gb + 143428 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143432 >> 2] = (HEAP32[gb + 143432 >> 2] | 0) + (gb + 761664 | 0);
 HEAP32[gb + 143436 >> 2] = (HEAP32[gb + 143436 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143440 >> 2] = (HEAP32[gb + 143440 >> 2] | 0) + (gb + 761698 | 0);
 HEAP32[gb + 143444 >> 2] = (HEAP32[gb + 143444 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143448 >> 2] = (HEAP32[gb + 143448 >> 2] | 0) + (gb + 761730 | 0);
 HEAP32[gb + 143452 >> 2] = (HEAP32[gb + 143452 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143456 >> 2] = (HEAP32[gb + 143456 >> 2] | 0) + (gb + 761776 | 0);
 HEAP32[gb + 143460 >> 2] = (HEAP32[gb + 143460 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143464 >> 2] = (HEAP32[gb + 143464 >> 2] | 0) + (gb + 761804 | 0);
 HEAP32[gb + 143468 >> 2] = (HEAP32[gb + 143468 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143472 >> 2] = (HEAP32[gb + 143472 >> 2] | 0) + (gb + 761832 | 0);
 runPostSets158();
}

function runPostSets162() {
 HEAP32[gb + 145076 >> 2] = (HEAP32[gb + 145076 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145080 >> 2] = (HEAP32[gb + 145080 >> 2] | 0) + (gb + 760767 | 0);
 HEAP32[gb + 145084 >> 2] = (HEAP32[gb + 145084 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145088 >> 2] = (HEAP32[gb + 145088 >> 2] | 0) + (gb + 760793 | 0);
 HEAP32[gb + 145092 >> 2] = (HEAP32[gb + 145092 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145096 >> 2] = (HEAP32[gb + 145096 >> 2] | 0) + (gb + 760820 | 0);
 HEAP32[gb + 145100 >> 2] = (HEAP32[gb + 145100 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145104 >> 2] = (HEAP32[gb + 145104 >> 2] | 0) + (gb + 760850 | 0);
 HEAP32[gb + 145108 >> 2] = (HEAP32[gb + 145108 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145112 >> 2] = (HEAP32[gb + 145112 >> 2] | 0) + (gb + 760875 | 0);
 HEAP32[gb + 145116 >> 2] = (HEAP32[gb + 145116 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145120 >> 2] = (HEAP32[gb + 145120 >> 2] | 0) + (gb + 760905 | 0);
 HEAP32[gb + 145124 >> 2] = (HEAP32[gb + 145124 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145128 >> 2] = (HEAP32[gb + 145128 >> 2] | 0) + (gb + 760936 | 0);
 HEAP32[gb + 145132 >> 2] = (HEAP32[gb + 145132 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145136 >> 2] = (HEAP32[gb + 145136 >> 2] | 0) + (gb + 760970 | 0);
 HEAP32[gb + 145140 >> 2] = (HEAP32[gb + 145140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145144 >> 2] = (HEAP32[gb + 145144 >> 2] | 0) + (gb + 760999 | 0);
 HEAP32[gb + 145148 >> 2] = (HEAP32[gb + 145148 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145152 >> 2] = (HEAP32[gb + 145152 >> 2] | 0) + (gb + 761029 | 0);
 HEAP32[gb + 145156 >> 2] = (HEAP32[gb + 145156 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145160 >> 2] = (HEAP32[gb + 145160 >> 2] | 0) + (gb + 761060 | 0);
 HEAP32[gb + 145164 >> 2] = (HEAP32[gb + 145164 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145168 >> 2] = (HEAP32[gb + 145168 >> 2] | 0) + (gb + 761094 | 0);
 HEAP32[gb + 145172 >> 2] = (HEAP32[gb + 145172 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145176 >> 2] = (HEAP32[gb + 145176 >> 2] | 0) + (gb + 761123 | 0);
 HEAP32[gb + 145180 >> 2] = (HEAP32[gb + 145180 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145184 >> 2] = (HEAP32[gb + 145184 >> 2] | 0) + (gb + 761153 | 0);
 HEAP32[gb + 145188 >> 2] = (HEAP32[gb + 145188 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145192 >> 2] = (HEAP32[gb + 145192 >> 2] | 0) + (gb + 761184 | 0);
 HEAP32[gb + 145196 >> 2] = (HEAP32[gb + 145196 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145200 >> 2] = (HEAP32[gb + 145200 >> 2] | 0) + (gb + 761218 | 0);
 HEAP32[gb + 145204 >> 2] = (HEAP32[gb + 145204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145208 >> 2] = (HEAP32[gb + 145208 >> 2] | 0) + (gb + 761247 | 0);
 HEAP32[gb + 145212 >> 2] = (HEAP32[gb + 145212 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145216 >> 2] = (HEAP32[gb + 145216 >> 2] | 0) + (gb + 761271 | 0);
 HEAP32[gb + 145220 >> 2] = (HEAP32[gb + 145220 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 145224 >> 2] = (HEAP32[gb + 145224 >> 2] | 0) + (gb + 761302 | 0);
 HEAP32[gb + 145228 >> 2] = (HEAP32[gb + 145228 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 145232 >> 2] = (HEAP32[gb + 145232 >> 2] | 0) + (gb + 761334 | 0);
 HEAP32[gb + 145236 >> 2] = (HEAP32[gb + 145236 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 145240 >> 2] = (HEAP32[gb + 145240 >> 2] | 0) + (gb + 761377 | 0);
 HEAP32[gb + 145244 >> 2] = (HEAP32[gb + 145244 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 145248 >> 2] = (HEAP32[gb + 145248 >> 2] | 0) + (gb + 763868 | 0);
 HEAP32[gb + 145252 >> 2] = (HEAP32[gb + 145252 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 145256 >> 2] = (HEAP32[gb + 145256 >> 2] | 0) + (gb + 763895 | 0);
 HEAP32[gb + 145260 >> 2] = (HEAP32[gb + 145260 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 145264 >> 2] = (HEAP32[gb + 145264 >> 2] | 0) + (gb + 763922 | 0);
 HEAP32[gb + 145268 >> 2] = (HEAP32[gb + 145268 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145272 >> 2] = (HEAP32[gb + 145272 >> 2] | 0) + (gb + 763953 | 0);
 HEAP32[gb + 145276 >> 2] = (HEAP32[gb + 145276 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145280 >> 2] = (HEAP32[gb + 145280 >> 2] | 0) + (gb + 761422 | 0);
 HEAP32[gb + 145284 >> 2] = (HEAP32[gb + 145284 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145288 >> 2] = (HEAP32[gb + 145288 >> 2] | 0) + (gb + 761452 | 0);
 HEAP32[gb + 145292 >> 2] = (HEAP32[gb + 145292 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145296 >> 2] = (HEAP32[gb + 145296 >> 2] | 0) + (gb + 761483 | 0);
 HEAP32[gb + 145300 >> 2] = (HEAP32[gb + 145300 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145304 >> 2] = (HEAP32[gb + 145304 >> 2] | 0) + (gb + 761512 | 0);
 HEAP32[gb + 145308 >> 2] = (HEAP32[gb + 145308 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145312 >> 2] = (HEAP32[gb + 145312 >> 2] | 0) + (gb + 761552 | 0);
 HEAP32[gb + 145316 >> 2] = (HEAP32[gb + 145316 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 145320 >> 2] = (HEAP32[gb + 145320 >> 2] | 0) + (gb + 761591 | 0);
 HEAP32[gb + 145324 >> 2] = (HEAP32[gb + 145324 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 145328 >> 2] = (HEAP32[gb + 145328 >> 2] | 0) + (gb + 763984 | 0);
 HEAP32[gb + 145332 >> 2] = (HEAP32[gb + 145332 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 145336 >> 2] = (HEAP32[gb + 145336 >> 2] | 0) + (gb + 764014 | 0);
 HEAP32[gb + 145340 >> 2] = (HEAP32[gb + 145340 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 145344 >> 2] = (HEAP32[gb + 145344 >> 2] | 0) + (gb + 764044 | 0);
 HEAP32[gb + 145348 >> 2] = (HEAP32[gb + 145348 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145352 >> 2] = (HEAP32[gb + 145352 >> 2] | 0) + (gb + 764078 | 0);
 HEAP32[gb + 145356 >> 2] = (HEAP32[gb + 145356 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145360 >> 2] = (HEAP32[gb + 145360 >> 2] | 0) + (gb + 761631 | 0);
 HEAP32[gb + 145364 >> 2] = (HEAP32[gb + 145364 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145368 >> 2] = (HEAP32[gb + 145368 >> 2] | 0) + (gb + 761664 | 0);
 HEAP32[gb + 145372 >> 2] = (HEAP32[gb + 145372 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145376 >> 2] = (HEAP32[gb + 145376 >> 2] | 0) + (gb + 761698 | 0);
 HEAP32[gb + 145380 >> 2] = (HEAP32[gb + 145380 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145384 >> 2] = (HEAP32[gb + 145384 >> 2] | 0) + (gb + 761730 | 0);
 HEAP32[gb + 145388 >> 2] = (HEAP32[gb + 145388 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145392 >> 2] = (HEAP32[gb + 145392 >> 2] | 0) + (gb + 761776 | 0);
 HEAP32[gb + 145396 >> 2] = (HEAP32[gb + 145396 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145400 >> 2] = (HEAP32[gb + 145400 >> 2] | 0) + (gb + 761804 | 0);
 HEAP32[gb + 145404 >> 2] = (HEAP32[gb + 145404 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145408 >> 2] = (HEAP32[gb + 145408 >> 2] | 0) + (gb + 761832 | 0);
 HEAP32[gb + 145412 >> 2] = (HEAP32[gb + 145412 >> 2] | 0) + (gb + 761858 | 0);
 HEAP32[gb + 145416 >> 2] = (HEAP32[gb + 145416 >> 2] | 0) + (gb + 761864 | 0);
 HEAP32[gb + 145420 >> 2] = (HEAP32[gb + 145420 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145424 >> 2] = (HEAP32[gb + 145424 >> 2] | 0) + (gb + 761887 | 0);
 HEAP32[gb + 145428 >> 2] = (HEAP32[gb + 145428 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145432 >> 2] = (HEAP32[gb + 145432 >> 2] | 0) + (gb + 761911 | 0);
 HEAP32[gb + 145436 >> 2] = (HEAP32[gb + 145436 >> 2] | 0) + (gb + 761946 | 0);
 HEAP32[gb + 145440 >> 2] = (HEAP32[gb + 145440 >> 2] | 0) + (gb + 764112 | 0);
 HEAP32[gb + 145444 >> 2] = (HEAP32[gb + 145444 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 145448 >> 2] = (HEAP32[gb + 145448 >> 2] | 0) + (gb + 764142 | 0);
 HEAP32[gb + 145452 >> 2] = (HEAP32[gb + 145452 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 145456 >> 2] = (HEAP32[gb + 145456 >> 2] | 0) + (gb + 764172 | 0);
 HEAP32[gb + 145460 >> 2] = (HEAP32[gb + 145460 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145464 >> 2] = (HEAP32[gb + 145464 >> 2] | 0) + (gb + 764206 | 0);
 HEAP32[gb + 145468 >> 2] = (HEAP32[gb + 145468 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145472 >> 2] = (HEAP32[gb + 145472 >> 2] | 0) + (gb + 761968 | 0);
 runPostSets163();
}

function runPostSets159() {
 HEAP32[gb + 143876 >> 2] = (HEAP32[gb + 143876 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143880 >> 2] = (HEAP32[gb + 143880 >> 2] | 0) + (gb + 763222 | 0);
 HEAP32[gb + 143884 >> 2] = (HEAP32[gb + 143884 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143888 >> 2] = (HEAP32[gb + 143888 >> 2] | 0) + (gb + 763257 | 0);
 HEAP32[gb + 143892 >> 2] = (HEAP32[gb + 143892 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 143896 >> 2] = (HEAP32[gb + 143896 >> 2] | 0) + (gb + 763300 | 0);
 HEAP32[gb + 143900 >> 2] = (HEAP32[gb + 143900 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143904 >> 2] = (HEAP32[gb + 143904 >> 2] | 0) + (gb + 763334 | 0);
 HEAP32[gb + 143908 >> 2] = (HEAP32[gb + 143908 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143912 >> 2] = (HEAP32[gb + 143912 >> 2] | 0) + (gb + 763368 | 0);
 HEAP32[gb + 143916 >> 2] = (HEAP32[gb + 143916 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143920 >> 2] = (HEAP32[gb + 143920 >> 2] | 0) + (gb + 763405 | 0);
 HEAP32[gb + 143924 >> 2] = (HEAP32[gb + 143924 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 143928 >> 2] = (HEAP32[gb + 143928 >> 2] | 0) + (gb + 764504 | 0);
 HEAP32[gb + 143932 >> 2] = (HEAP32[gb + 143932 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143936 >> 2] = (HEAP32[gb + 143936 >> 2] | 0) + (gb + 764517 | 0);
 HEAP32[gb + 143940 >> 2] = (HEAP32[gb + 143940 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 143944 >> 2] = (HEAP32[gb + 143944 >> 2] | 0) + (gb + 764536 | 0);
 HEAP32[gb + 143948 >> 2] = (HEAP32[gb + 143948 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143952 >> 2] = (HEAP32[gb + 143952 >> 2] | 0) + (gb + 764559 | 0);
 HEAP32[gb + 143956 >> 2] = (HEAP32[gb + 143956 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143960 >> 2] = (HEAP32[gb + 143960 >> 2] | 0) + (gb + 764579 | 0);
 HEAP32[gb + 143964 >> 2] = (HEAP32[gb + 143964 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143968 >> 2] = (HEAP32[gb + 143968 >> 2] | 0) + (gb + 764606 | 0);
 HEAP32[gb + 143972 >> 2] = (HEAP32[gb + 143972 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 143976 >> 2] = (HEAP32[gb + 143976 >> 2] | 0) + (gb + 764646 | 0);
 HEAP32[gb + 143980 >> 2] = (HEAP32[gb + 143980 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143984 >> 2] = (HEAP32[gb + 143984 >> 2] | 0) + (gb + 764685 | 0);
 HEAP32[gb + 143988 >> 2] = (HEAP32[gb + 143988 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143992 >> 2] = (HEAP32[gb + 143992 >> 2] | 0) + (gb + 764704 | 0);
 HEAP32[gb + 143996 >> 2] = (HEAP32[gb + 143996 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144e3 >> 2] = (HEAP32[gb + 144e3 >> 2] | 0) + (gb + 764733 | 0);
 HEAP32[gb + 144004 >> 2] = (HEAP32[gb + 144004 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144008 >> 2] = (HEAP32[gb + 144008 >> 2] | 0) + (gb + 764760 | 0);
 HEAP32[gb + 144012 >> 2] = (HEAP32[gb + 144012 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144016 >> 2] = (HEAP32[gb + 144016 >> 2] | 0) + (gb + 764784 | 0);
 HEAP32[gb + 144020 >> 2] = (HEAP32[gb + 144020 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144024 >> 2] = (HEAP32[gb + 144024 >> 2] | 0) + (gb + 763448 | 0);
 HEAP32[gb + 144028 >> 2] = (HEAP32[gb + 144028 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 144032 >> 2] = (HEAP32[gb + 144032 >> 2] | 0) + (gb + 757085 | 0);
 HEAP32[gb + 144036 >> 2] = (HEAP32[gb + 144036 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144040 >> 2] = (HEAP32[gb + 144040 >> 2] | 0) + (gb + 757110 | 0);
 HEAP32[gb + 144044 >> 2] = (HEAP32[gb + 144044 >> 2] | 0) + (gb + 757133 | 0);
 HEAP32[gb + 144048 >> 2] = (HEAP32[gb + 144048 >> 2] | 0) + (gb + 757138 | 0);
 HEAP32[gb + 144052 >> 2] = (HEAP32[gb + 144052 >> 2] | 0) + (gb + 757162 | 0);
 HEAP32[gb + 144056 >> 2] = (HEAP32[gb + 144056 >> 2] | 0) + (gb + 756598 | 0);
 HEAP32[gb + 144060 >> 2] = (HEAP32[gb + 144060 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144064 >> 2] = (HEAP32[gb + 144064 >> 2] | 0) + (gb + 756630 | 0);
 HEAP32[gb + 144068 >> 2] = (HEAP32[gb + 144068 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144072 >> 2] = (HEAP32[gb + 144072 >> 2] | 0) + (gb + 756654 | 0);
 HEAP32[gb + 144076 >> 2] = (HEAP32[gb + 144076 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 144080 >> 2] = (HEAP32[gb + 144080 >> 2] | 0) + (gb + 756693 | 0);
 HEAP32[gb + 144084 >> 2] = (HEAP32[gb + 144084 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 144088 >> 2] = (HEAP32[gb + 144088 >> 2] | 0) + (gb + 756737 | 0);
 HEAP32[gb + 144092 >> 2] = (HEAP32[gb + 144092 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144096 >> 2] = (HEAP32[gb + 144096 >> 2] | 0) + (gb + 756769 | 0);
 HEAP32[gb + 144100 >> 2] = (HEAP32[gb + 144100 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 144104 >> 2] = (HEAP32[gb + 144104 >> 2] | 0) + (gb + 756804 | 0);
 HEAP32[gb + 144108 >> 2] = (HEAP32[gb + 144108 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 144112 >> 2] = (HEAP32[gb + 144112 >> 2] | 0) + (gb + 756842 | 0);
 HEAP32[gb + 144116 >> 2] = (HEAP32[gb + 144116 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144120 >> 2] = (HEAP32[gb + 144120 >> 2] | 0) + (gb + 756875 | 0);
 HEAP32[gb + 144124 >> 2] = (HEAP32[gb + 144124 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144128 >> 2] = (HEAP32[gb + 144128 >> 2] | 0) + (gb + 756911 | 0);
 HEAP32[gb + 144132 >> 2] = (HEAP32[gb + 144132 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144136 >> 2] = (HEAP32[gb + 144136 >> 2] | 0) + (gb + 756945 | 0);
 HEAP32[gb + 144140 >> 2] = (HEAP32[gb + 144140 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144144 >> 2] = (HEAP32[gb + 144144 >> 2] | 0) + (gb + 756981 | 0);
 HEAP32[gb + 144148 >> 2] = (HEAP32[gb + 144148 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144152 >> 2] = (HEAP32[gb + 144152 >> 2] | 0) + (gb + 757012 | 0);
 HEAP32[gb + 144156 >> 2] = (HEAP32[gb + 144156 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144160 >> 2] = (HEAP32[gb + 144160 >> 2] | 0) + (gb + 757046 | 0);
 HEAP32[gb + 144164 >> 2] = (HEAP32[gb + 144164 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144168 >> 2] = (HEAP32[gb + 144168 >> 2] | 0) + (gb + 757165 | 0);
 HEAP32[gb + 144172 >> 2] = (HEAP32[gb + 144172 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144176 >> 2] = (HEAP32[gb + 144176 >> 2] | 0) + (gb + 757192 | 0);
 HEAP32[gb + 144180 >> 2] = (HEAP32[gb + 144180 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144184 >> 2] = (HEAP32[gb + 144184 >> 2] | 0) + (gb + 757218 | 0);
 HEAP32[gb + 144188 >> 2] = (HEAP32[gb + 144188 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144192 >> 2] = (HEAP32[gb + 144192 >> 2] | 0) + (gb + 757329 | 0);
 HEAP32[gb + 144196 >> 2] = (HEAP32[gb + 144196 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144200 >> 2] = (HEAP32[gb + 144200 >> 2] | 0) + (gb + 757346 | 0);
 HEAP32[gb + 144204 >> 2] = (HEAP32[gb + 144204 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 144208 >> 2] = (HEAP32[gb + 144208 >> 2] | 0) + (gb + 757386 | 0);
 HEAP32[gb + 144212 >> 2] = (HEAP32[gb + 144212 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 144216 >> 2] = (HEAP32[gb + 144216 >> 2] | 0) + (gb + 757440 | 0);
 HEAP32[gb + 144220 >> 2] = (HEAP32[gb + 144220 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144224 >> 2] = (HEAP32[gb + 144224 >> 2] | 0) + (gb + 757472 | 0);
 HEAP32[gb + 144228 >> 2] = (HEAP32[gb + 144228 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 144232 >> 2] = (HEAP32[gb + 144232 >> 2] | 0) + (gb + 757509 | 0);
 HEAP32[gb + 144236 >> 2] = (HEAP32[gb + 144236 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 144240 >> 2] = (HEAP32[gb + 144240 >> 2] | 0) + (gb + 757533 | 0);
 HEAP32[gb + 144244 >> 2] = (HEAP32[gb + 144244 >> 2] | 0) + (gb + 757555 | 0);
 HEAP32[gb + 144248 >> 2] = (HEAP32[gb + 144248 >> 2] | 0) + (gb + 757560 | 0);
 HEAP32[gb + 144252 >> 2] = (HEAP32[gb + 144252 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144256 >> 2] = (HEAP32[gb + 144256 >> 2] | 0) + (gb + 757579 | 0);
 HEAP32[gb + 144260 >> 2] = (HEAP32[gb + 144260 >> 2] | 0) + (gb + 757593 | 0);
 HEAP32[gb + 144264 >> 2] = (HEAP32[gb + 144264 >> 2] | 0) + (gb + 757645 | 0);
 HEAP32[gb + 144268 >> 2] = (HEAP32[gb + 144268 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144272 >> 2] = (HEAP32[gb + 144272 >> 2] | 0) + (gb + 757675 | 0);
 runPostSets160();
}

function runPostSets163() {
 HEAP32[gb + 145476 >> 2] = (HEAP32[gb + 145476 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145480 >> 2] = (HEAP32[gb + 145480 >> 2] | 0) + (gb + 762001 | 0);
 HEAP32[gb + 145484 >> 2] = (HEAP32[gb + 145484 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145488 >> 2] = (HEAP32[gb + 145488 >> 2] | 0) + (gb + 762035 | 0);
 HEAP32[gb + 145492 >> 2] = (HEAP32[gb + 145492 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145496 >> 2] = (HEAP32[gb + 145496 >> 2] | 0) + (gb + 762067 | 0);
 HEAP32[gb + 145500 >> 2] = (HEAP32[gb + 145500 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145504 >> 2] = (HEAP32[gb + 145504 >> 2] | 0) + (gb + 762113 | 0);
 HEAP32[gb + 145508 >> 2] = (HEAP32[gb + 145508 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145512 >> 2] = (HEAP32[gb + 145512 >> 2] | 0) + (gb + 762147 | 0);
 HEAP32[gb + 145516 >> 2] = (HEAP32[gb + 145516 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145520 >> 2] = (HEAP32[gb + 145520 >> 2] | 0) + (gb + 762176 | 0);
 HEAP32[gb + 145524 >> 2] = (HEAP32[gb + 145524 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145528 >> 2] = (HEAP32[gb + 145528 >> 2] | 0) + (gb + 762206 | 0);
 HEAP32[gb + 145532 >> 2] = (HEAP32[gb + 145532 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 145536 >> 2] = (HEAP32[gb + 145536 >> 2] | 0) + (gb + 762244 | 0);
 HEAP32[gb + 145540 >> 2] = (HEAP32[gb + 145540 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 145544 >> 2] = (HEAP32[gb + 145544 >> 2] | 0) + (gb + 762272 | 0);
 HEAP32[gb + 145548 >> 2] = (HEAP32[gb + 145548 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 145552 >> 2] = (HEAP32[gb + 145552 >> 2] | 0) + (gb + 762300 | 0);
 HEAP32[gb + 145556 >> 2] = (HEAP32[gb + 145556 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145560 >> 2] = (HEAP32[gb + 145560 >> 2] | 0) + (gb + 762330 | 0);
 HEAP32[gb + 145564 >> 2] = (HEAP32[gb + 145564 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145568 >> 2] = (HEAP32[gb + 145568 >> 2] | 0) + (gb + 762362 | 0);
 HEAP32[gb + 145572 >> 2] = (HEAP32[gb + 145572 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 145576 >> 2] = (HEAP32[gb + 145576 >> 2] | 0) + (gb + 762393 | 0);
 HEAP32[gb + 145580 >> 2] = (HEAP32[gb + 145580 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145584 >> 2] = (HEAP32[gb + 145584 >> 2] | 0) + (gb + 762428 | 0);
 HEAP32[gb + 145588 >> 2] = (HEAP32[gb + 145588 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 145592 >> 2] = (HEAP32[gb + 145592 >> 2] | 0) + (gb + 762470 | 0);
 HEAP32[gb + 145596 >> 2] = (HEAP32[gb + 145596 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 145600 >> 2] = (HEAP32[gb + 145600 >> 2] | 0) + (gb + 764240 | 0);
 HEAP32[gb + 145604 >> 2] = (HEAP32[gb + 145604 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 145608 >> 2] = (HEAP32[gb + 145608 >> 2] | 0) + (gb + 764271 | 0);
 HEAP32[gb + 145612 >> 2] = (HEAP32[gb + 145612 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 145616 >> 2] = (HEAP32[gb + 145616 >> 2] | 0) + (gb + 764302 | 0);
 HEAP32[gb + 145620 >> 2] = (HEAP32[gb + 145620 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145624 >> 2] = (HEAP32[gb + 145624 >> 2] | 0) + (gb + 764337 | 0);
 HEAP32[gb + 145628 >> 2] = (HEAP32[gb + 145628 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145632 >> 2] = (HEAP32[gb + 145632 >> 2] | 0) + (gb + 762513 | 0);
 HEAP32[gb + 145636 >> 2] = (HEAP32[gb + 145636 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145640 >> 2] = (HEAP32[gb + 145640 >> 2] | 0) + (gb + 762547 | 0);
 HEAP32[gb + 145644 >> 2] = (HEAP32[gb + 145644 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145648 >> 2] = (HEAP32[gb + 145648 >> 2] | 0) + (gb + 762582 | 0);
 HEAP32[gb + 145652 >> 2] = (HEAP32[gb + 145652 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145656 >> 2] = (HEAP32[gb + 145656 >> 2] | 0) + (gb + 762615 | 0);
 HEAP32[gb + 145660 >> 2] = (HEAP32[gb + 145660 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145664 >> 2] = (HEAP32[gb + 145664 >> 2] | 0) + (gb + 762663 | 0);
 HEAP32[gb + 145668 >> 2] = (HEAP32[gb + 145668 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145672 >> 2] = (HEAP32[gb + 145672 >> 2] | 0) + (gb + 762698 | 0);
 HEAP32[gb + 145676 >> 2] = (HEAP32[gb + 145676 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145680 >> 2] = (HEAP32[gb + 145680 >> 2] | 0) + (gb + 762728 | 0);
 HEAP32[gb + 145684 >> 2] = (HEAP32[gb + 145684 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145688 >> 2] = (HEAP32[gb + 145688 >> 2] | 0) + (gb + 762759 | 0);
 HEAP32[gb + 145692 >> 2] = (HEAP32[gb + 145692 >> 2] | 0) + (gb + 762798 | 0);
 HEAP32[gb + 145696 >> 2] = (HEAP32[gb + 145696 >> 2] | 0) + (gb + 762803 | 0);
 HEAP32[gb + 145700 >> 2] = (HEAP32[gb + 145700 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145704 >> 2] = (HEAP32[gb + 145704 >> 2] | 0) + (gb + 762832 | 0);
 HEAP32[gb + 145708 >> 2] = (HEAP32[gb + 145708 >> 2] | 0) + (gb + 762861 | 0);
 HEAP32[gb + 145712 >> 2] = (HEAP32[gb + 145712 >> 2] | 0) + (gb + 762875 | 0);
 HEAP32[gb + 145716 >> 2] = (HEAP32[gb + 145716 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145720 >> 2] = (HEAP32[gb + 145720 >> 2] | 0) + (gb + 762912 | 0);
 HEAP32[gb + 145724 >> 2] = (HEAP32[gb + 145724 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 145728 >> 2] = (HEAP32[gb + 145728 >> 2] | 0) + (gb + 762955 | 0);
 HEAP32[gb + 145732 >> 2] = (HEAP32[gb + 145732 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 145736 >> 2] = (HEAP32[gb + 145736 >> 2] | 0) + (gb + 764372 | 0);
 HEAP32[gb + 145740 >> 2] = (HEAP32[gb + 145740 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 145744 >> 2] = (HEAP32[gb + 145744 >> 2] | 0) + (gb + 764403 | 0);
 HEAP32[gb + 145748 >> 2] = (HEAP32[gb + 145748 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 145752 >> 2] = (HEAP32[gb + 145752 >> 2] | 0) + (gb + 764434 | 0);
 HEAP32[gb + 145756 >> 2] = (HEAP32[gb + 145756 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145760 >> 2] = (HEAP32[gb + 145760 >> 2] | 0) + (gb + 764469 | 0);
 HEAP32[gb + 145764 >> 2] = (HEAP32[gb + 145764 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145768 >> 2] = (HEAP32[gb + 145768 >> 2] | 0) + (gb + 762999 | 0);
 HEAP32[gb + 145772 >> 2] = (HEAP32[gb + 145772 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145776 >> 2] = (HEAP32[gb + 145776 >> 2] | 0) + (gb + 763033 | 0);
 HEAP32[gb + 145780 >> 2] = (HEAP32[gb + 145780 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145784 >> 2] = (HEAP32[gb + 145784 >> 2] | 0) + (gb + 763068 | 0);
 HEAP32[gb + 145788 >> 2] = (HEAP32[gb + 145788 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145792 >> 2] = (HEAP32[gb + 145792 >> 2] | 0) + (gb + 763101 | 0);
 HEAP32[gb + 145796 >> 2] = (HEAP32[gb + 145796 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145800 >> 2] = (HEAP32[gb + 145800 >> 2] | 0) + (gb + 763149 | 0);
 HEAP32[gb + 145804 >> 2] = (HEAP32[gb + 145804 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145808 >> 2] = (HEAP32[gb + 145808 >> 2] | 0) + (gb + 763188 | 0);
 HEAP32[gb + 145812 >> 2] = (HEAP32[gb + 145812 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145816 >> 2] = (HEAP32[gb + 145816 >> 2] | 0) + (gb + 763222 | 0);
 HEAP32[gb + 145820 >> 2] = (HEAP32[gb + 145820 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145824 >> 2] = (HEAP32[gb + 145824 >> 2] | 0) + (gb + 763257 | 0);
 HEAP32[gb + 145828 >> 2] = (HEAP32[gb + 145828 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 145832 >> 2] = (HEAP32[gb + 145832 >> 2] | 0) + (gb + 763300 | 0);
 HEAP32[gb + 145836 >> 2] = (HEAP32[gb + 145836 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 145840 >> 2] = (HEAP32[gb + 145840 >> 2] | 0) + (gb + 763334 | 0);
 HEAP32[gb + 145844 >> 2] = (HEAP32[gb + 145844 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 145848 >> 2] = (HEAP32[gb + 145848 >> 2] | 0) + (gb + 763368 | 0);
 HEAP32[gb + 145852 >> 2] = (HEAP32[gb + 145852 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145856 >> 2] = (HEAP32[gb + 145856 >> 2] | 0) + (gb + 763405 | 0);
 HEAP32[gb + 145860 >> 2] = (HEAP32[gb + 145860 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 145864 >> 2] = (HEAP32[gb + 145864 >> 2] | 0) + (gb + 764504 | 0);
 HEAP32[gb + 145868 >> 2] = (HEAP32[gb + 145868 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145872 >> 2] = (HEAP32[gb + 145872 >> 2] | 0) + (gb + 764517 | 0);
 runPostSets164();
}

function runPostSets160() {
 HEAP32[gb + 144276 >> 2] = (HEAP32[gb + 144276 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144280 >> 2] = (HEAP32[gb + 144280 >> 2] | 0) + (gb + 757694 | 0);
 HEAP32[gb + 144284 >> 2] = (HEAP32[gb + 144284 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 144288 >> 2] = (HEAP32[gb + 144288 >> 2] | 0) + (gb + 757734 | 0);
 HEAP32[gb + 144292 >> 2] = (HEAP32[gb + 144292 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144296 >> 2] = (HEAP32[gb + 144296 >> 2] | 0) + (gb + 757763 | 0);
 HEAP32[gb + 144300 >> 2] = (HEAP32[gb + 144300 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144304 >> 2] = (HEAP32[gb + 144304 >> 2] | 0) + (gb + 757789 | 0);
 HEAP32[gb + 144308 >> 2] = (HEAP32[gb + 144308 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144312 >> 2] = (HEAP32[gb + 144312 >> 2] | 0) + (gb + 757845 | 0);
 HEAP32[gb + 144316 >> 2] = (HEAP32[gb + 144316 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144320 >> 2] = (HEAP32[gb + 144320 >> 2] | 0) + (gb + 757870 | 0);
 HEAP32[gb + 144324 >> 2] = (HEAP32[gb + 144324 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144328 >> 2] = (HEAP32[gb + 144328 >> 2] | 0) + (gb + 757890 | 0);
 HEAP32[gb + 144332 >> 2] = (HEAP32[gb + 144332 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 144336 >> 2] = (HEAP32[gb + 144336 >> 2] | 0) + (gb + 757916 | 0);
 HEAP32[gb + 144340 >> 2] = (HEAP32[gb + 144340 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144344 >> 2] = (HEAP32[gb + 144344 >> 2] | 0) + (gb + 757946 | 0);
 HEAP32[gb + 144348 >> 2] = (HEAP32[gb + 144348 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144352 >> 2] = (HEAP32[gb + 144352 >> 2] | 0) + (gb + 757973 | 0);
 HEAP32[gb + 144356 >> 2] = (HEAP32[gb + 144356 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144360 >> 2] = (HEAP32[gb + 144360 >> 2] | 0) + (gb + 758119 | 0);
 HEAP32[gb + 144364 >> 2] = (HEAP32[gb + 144364 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144368 >> 2] = (HEAP32[gb + 144368 >> 2] | 0) + (gb + 758031 | 0);
 HEAP32[gb + 144372 >> 2] = (HEAP32[gb + 144372 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144376 >> 2] = (HEAP32[gb + 144376 >> 2] | 0) + (gb + 758061 | 0);
 HEAP32[gb + 144380 >> 2] = (HEAP32[gb + 144380 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144384 >> 2] = (HEAP32[gb + 144384 >> 2] | 0) + (gb + 758081 | 0);
 HEAP32[gb + 144388 >> 2] = (HEAP32[gb + 144388 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 144392 >> 2] = (HEAP32[gb + 144392 >> 2] | 0) + (gb + 758145 | 0);
 HEAP32[gb + 144396 >> 2] = (HEAP32[gb + 144396 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144400 >> 2] = (HEAP32[gb + 144400 >> 2] | 0) + (gb + 758175 | 0);
 HEAP32[gb + 144404 >> 2] = (HEAP32[gb + 144404 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144408 >> 2] = (HEAP32[gb + 144408 >> 2] | 0) + (gb + 758206 | 0);
 HEAP32[gb + 144412 >> 2] = (HEAP32[gb + 144412 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144416 >> 2] = (HEAP32[gb + 144416 >> 2] | 0) + (gb + 758235 | 0);
 HEAP32[gb + 144420 >> 2] = (HEAP32[gb + 144420 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 144424 >> 2] = (HEAP32[gb + 144424 >> 2] | 0) + (gb + 758270 | 0);
 HEAP32[gb + 144428 >> 2] = (HEAP32[gb + 144428 >> 2] | 0) + (gb + 758304 | 0);
 HEAP32[gb + 144432 >> 2] = (HEAP32[gb + 144432 >> 2] | 0) + (gb + 763521 | 0);
 HEAP32[gb + 144436 >> 2] = (HEAP32[gb + 144436 >> 2] | 0) + (gb + 758342 | 0);
 HEAP32[gb + 144440 >> 2] = (HEAP32[gb + 144440 >> 2] | 0) + (gb + 758348 | 0);
 HEAP32[gb + 144444 >> 2] = (HEAP32[gb + 144444 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 144448 >> 2] = (HEAP32[gb + 144448 >> 2] | 0) + (gb + 758404 | 0);
 HEAP32[gb + 144452 >> 2] = (HEAP32[gb + 144452 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144456 >> 2] = (HEAP32[gb + 144456 >> 2] | 0) + (gb + 758458 | 0);
 HEAP32[gb + 144460 >> 2] = (HEAP32[gb + 144460 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 144464 >> 2] = (HEAP32[gb + 144464 >> 2] | 0) + (gb + 758509 | 0);
 HEAP32[gb + 144468 >> 2] = (HEAP32[gb + 144468 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144472 >> 2] = (HEAP32[gb + 144472 >> 2] | 0) + (gb + 758542 | 0);
 HEAP32[gb + 144476 >> 2] = (HEAP32[gb + 144476 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144480 >> 2] = (HEAP32[gb + 144480 >> 2] | 0) + (gb + 758573 | 0);
 HEAP32[gb + 144484 >> 2] = (HEAP32[gb + 144484 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144488 >> 2] = (HEAP32[gb + 144488 >> 2] | 0) + (gb + 758603 | 0);
 HEAP32[gb + 144492 >> 2] = (HEAP32[gb + 144492 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 144496 >> 2] = (HEAP32[gb + 144496 >> 2] | 0) + (gb + 758641 | 0);
 HEAP32[gb + 144500 >> 2] = (HEAP32[gb + 144500 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144504 >> 2] = (HEAP32[gb + 144504 >> 2] | 0) + (gb + 758676 | 0);
 HEAP32[gb + 144508 >> 2] = (HEAP32[gb + 144508 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144512 >> 2] = (HEAP32[gb + 144512 >> 2] | 0) + (gb + 758703 | 0);
 HEAP32[gb + 144516 >> 2] = (HEAP32[gb + 144516 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144520 >> 2] = (HEAP32[gb + 144520 >> 2] | 0) + (gb + 758731 | 0);
 HEAP32[gb + 144524 >> 2] = (HEAP32[gb + 144524 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144528 >> 2] = (HEAP32[gb + 144528 >> 2] | 0) + (gb + 758770 | 0);
 HEAP32[gb + 144532 >> 2] = (HEAP32[gb + 144532 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144536 >> 2] = (HEAP32[gb + 144536 >> 2] | 0) + (gb + 758809 | 0);
 HEAP32[gb + 144540 >> 2] = (HEAP32[gb + 144540 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 144544 >> 2] = (HEAP32[gb + 144544 >> 2] | 0) + (gb + 758861 | 0);
 HEAP32[gb + 144548 >> 2] = (HEAP32[gb + 144548 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 144552 >> 2] = (HEAP32[gb + 144552 >> 2] | 0) + (gb + 763551 | 0);
 HEAP32[gb + 144556 >> 2] = (HEAP32[gb + 144556 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144560 >> 2] = (HEAP32[gb + 144560 >> 2] | 0) + (gb + 763588 | 0);
 HEAP32[gb + 144564 >> 2] = (HEAP32[gb + 144564 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144568 >> 2] = (HEAP32[gb + 144568 >> 2] | 0) + (gb + 763626 | 0);
 HEAP32[gb + 144572 >> 2] = (HEAP32[gb + 144572 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 144576 >> 2] = (HEAP32[gb + 144576 >> 2] | 0) + (gb + 758899 | 0);
 HEAP32[gb + 144580 >> 2] = (HEAP32[gb + 144580 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 144584 >> 2] = (HEAP32[gb + 144584 >> 2] | 0) + (gb + 758937 | 0);
 HEAP32[gb + 144588 >> 2] = (HEAP32[gb + 144588 >> 2] | 0) + (gb + 758974 | 0);
 HEAP32[gb + 144592 >> 2] = (HEAP32[gb + 144592 >> 2] | 0) + (gb + 758989 | 0);
 HEAP32[gb + 144596 >> 2] = (HEAP32[gb + 144596 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 144600 >> 2] = (HEAP32[gb + 144600 >> 2] | 0) + (gb + 759026 | 0);
 HEAP32[gb + 144604 >> 2] = (HEAP32[gb + 144604 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 144608 >> 2] = (HEAP32[gb + 144608 >> 2] | 0) + (gb + 763672 | 0);
 HEAP32[gb + 144612 >> 2] = (HEAP32[gb + 144612 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 144616 >> 2] = (HEAP32[gb + 144616 >> 2] | 0) + (gb + 759064 | 0);
 HEAP32[gb + 144620 >> 2] = (HEAP32[gb + 144620 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144624 >> 2] = (HEAP32[gb + 144624 >> 2] | 0) + (gb + 759088 | 0);
 HEAP32[gb + 144628 >> 2] = (HEAP32[gb + 144628 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 144632 >> 2] = (HEAP32[gb + 144632 >> 2] | 0) + (gb + 759118 | 0);
 HEAP32[gb + 144636 >> 2] = (HEAP32[gb + 144636 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144640 >> 2] = (HEAP32[gb + 144640 >> 2] | 0) + (gb + 759152 | 0);
 HEAP32[gb + 144644 >> 2] = (HEAP32[gb + 144644 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144648 >> 2] = (HEAP32[gb + 144648 >> 2] | 0) + (gb + 759183 | 0);
 HEAP32[gb + 144652 >> 2] = (HEAP32[gb + 144652 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144656 >> 2] = (HEAP32[gb + 144656 >> 2] | 0) + (gb + 759349 | 0);
 HEAP32[gb + 144660 >> 2] = (HEAP32[gb + 144660 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144664 >> 2] = (HEAP32[gb + 144664 >> 2] | 0) + (gb + 759249 | 0);
 HEAP32[gb + 144668 >> 2] = (HEAP32[gb + 144668 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144672 >> 2] = (HEAP32[gb + 144672 >> 2] | 0) + (gb + 759283 | 0);
 runPostSets161();
}

function runPostSets158() {
 HEAP32[gb + 143476 >> 2] = (HEAP32[gb + 143476 >> 2] | 0) + (gb + 761858 | 0);
 HEAP32[gb + 143480 >> 2] = (HEAP32[gb + 143480 >> 2] | 0) + (gb + 761864 | 0);
 HEAP32[gb + 143484 >> 2] = (HEAP32[gb + 143484 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143488 >> 2] = (HEAP32[gb + 143488 >> 2] | 0) + (gb + 761887 | 0);
 HEAP32[gb + 143492 >> 2] = (HEAP32[gb + 143492 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143496 >> 2] = (HEAP32[gb + 143496 >> 2] | 0) + (gb + 761911 | 0);
 HEAP32[gb + 143500 >> 2] = (HEAP32[gb + 143500 >> 2] | 0) + (gb + 761946 | 0);
 HEAP32[gb + 143504 >> 2] = (HEAP32[gb + 143504 >> 2] | 0) + (gb + 764112 | 0);
 HEAP32[gb + 143508 >> 2] = (HEAP32[gb + 143508 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 143512 >> 2] = (HEAP32[gb + 143512 >> 2] | 0) + (gb + 764142 | 0);
 HEAP32[gb + 143516 >> 2] = (HEAP32[gb + 143516 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 143520 >> 2] = (HEAP32[gb + 143520 >> 2] | 0) + (gb + 764172 | 0);
 HEAP32[gb + 143524 >> 2] = (HEAP32[gb + 143524 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143528 >> 2] = (HEAP32[gb + 143528 >> 2] | 0) + (gb + 764206 | 0);
 HEAP32[gb + 143532 >> 2] = (HEAP32[gb + 143532 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143536 >> 2] = (HEAP32[gb + 143536 >> 2] | 0) + (gb + 761968 | 0);
 HEAP32[gb + 143540 >> 2] = (HEAP32[gb + 143540 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143544 >> 2] = (HEAP32[gb + 143544 >> 2] | 0) + (gb + 762001 | 0);
 HEAP32[gb + 143548 >> 2] = (HEAP32[gb + 143548 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143552 >> 2] = (HEAP32[gb + 143552 >> 2] | 0) + (gb + 762035 | 0);
 HEAP32[gb + 143556 >> 2] = (HEAP32[gb + 143556 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143560 >> 2] = (HEAP32[gb + 143560 >> 2] | 0) + (gb + 762067 | 0);
 HEAP32[gb + 143564 >> 2] = (HEAP32[gb + 143564 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143568 >> 2] = (HEAP32[gb + 143568 >> 2] | 0) + (gb + 762113 | 0);
 HEAP32[gb + 143572 >> 2] = (HEAP32[gb + 143572 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143576 >> 2] = (HEAP32[gb + 143576 >> 2] | 0) + (gb + 762147 | 0);
 HEAP32[gb + 143580 >> 2] = (HEAP32[gb + 143580 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143584 >> 2] = (HEAP32[gb + 143584 >> 2] | 0) + (gb + 762176 | 0);
 HEAP32[gb + 143588 >> 2] = (HEAP32[gb + 143588 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143592 >> 2] = (HEAP32[gb + 143592 >> 2] | 0) + (gb + 762206 | 0);
 HEAP32[gb + 143596 >> 2] = (HEAP32[gb + 143596 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 143600 >> 2] = (HEAP32[gb + 143600 >> 2] | 0) + (gb + 762244 | 0);
 HEAP32[gb + 143604 >> 2] = (HEAP32[gb + 143604 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143608 >> 2] = (HEAP32[gb + 143608 >> 2] | 0) + (gb + 762272 | 0);
 HEAP32[gb + 143612 >> 2] = (HEAP32[gb + 143612 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 143616 >> 2] = (HEAP32[gb + 143616 >> 2] | 0) + (gb + 762300 | 0);
 HEAP32[gb + 143620 >> 2] = (HEAP32[gb + 143620 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143624 >> 2] = (HEAP32[gb + 143624 >> 2] | 0) + (gb + 762330 | 0);
 HEAP32[gb + 143628 >> 2] = (HEAP32[gb + 143628 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143632 >> 2] = (HEAP32[gb + 143632 >> 2] | 0) + (gb + 762362 | 0);
 HEAP32[gb + 143636 >> 2] = (HEAP32[gb + 143636 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 143640 >> 2] = (HEAP32[gb + 143640 >> 2] | 0) + (gb + 762393 | 0);
 HEAP32[gb + 143644 >> 2] = (HEAP32[gb + 143644 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143648 >> 2] = (HEAP32[gb + 143648 >> 2] | 0) + (gb + 762428 | 0);
 HEAP32[gb + 143652 >> 2] = (HEAP32[gb + 143652 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 143656 >> 2] = (HEAP32[gb + 143656 >> 2] | 0) + (gb + 762470 | 0);
 HEAP32[gb + 143660 >> 2] = (HEAP32[gb + 143660 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 143664 >> 2] = (HEAP32[gb + 143664 >> 2] | 0) + (gb + 764240 | 0);
 HEAP32[gb + 143668 >> 2] = (HEAP32[gb + 143668 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 143672 >> 2] = (HEAP32[gb + 143672 >> 2] | 0) + (gb + 764271 | 0);
 HEAP32[gb + 143676 >> 2] = (HEAP32[gb + 143676 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 143680 >> 2] = (HEAP32[gb + 143680 >> 2] | 0) + (gb + 764302 | 0);
 HEAP32[gb + 143684 >> 2] = (HEAP32[gb + 143684 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143688 >> 2] = (HEAP32[gb + 143688 >> 2] | 0) + (gb + 764337 | 0);
 HEAP32[gb + 143692 >> 2] = (HEAP32[gb + 143692 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143696 >> 2] = (HEAP32[gb + 143696 >> 2] | 0) + (gb + 762513 | 0);
 HEAP32[gb + 143700 >> 2] = (HEAP32[gb + 143700 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143704 >> 2] = (HEAP32[gb + 143704 >> 2] | 0) + (gb + 762547 | 0);
 HEAP32[gb + 143708 >> 2] = (HEAP32[gb + 143708 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143712 >> 2] = (HEAP32[gb + 143712 >> 2] | 0) + (gb + 762582 | 0);
 HEAP32[gb + 143716 >> 2] = (HEAP32[gb + 143716 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143720 >> 2] = (HEAP32[gb + 143720 >> 2] | 0) + (gb + 762615 | 0);
 HEAP32[gb + 143724 >> 2] = (HEAP32[gb + 143724 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143728 >> 2] = (HEAP32[gb + 143728 >> 2] | 0) + (gb + 762663 | 0);
 HEAP32[gb + 143732 >> 2] = (HEAP32[gb + 143732 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143736 >> 2] = (HEAP32[gb + 143736 >> 2] | 0) + (gb + 762698 | 0);
 HEAP32[gb + 143740 >> 2] = (HEAP32[gb + 143740 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143744 >> 2] = (HEAP32[gb + 143744 >> 2] | 0) + (gb + 762728 | 0);
 HEAP32[gb + 143748 >> 2] = (HEAP32[gb + 143748 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143752 >> 2] = (HEAP32[gb + 143752 >> 2] | 0) + (gb + 762759 | 0);
 HEAP32[gb + 143756 >> 2] = (HEAP32[gb + 143756 >> 2] | 0) + (gb + 762798 | 0);
 HEAP32[gb + 143760 >> 2] = (HEAP32[gb + 143760 >> 2] | 0) + (gb + 762803 | 0);
 HEAP32[gb + 143764 >> 2] = (HEAP32[gb + 143764 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143768 >> 2] = (HEAP32[gb + 143768 >> 2] | 0) + (gb + 762832 | 0);
 HEAP32[gb + 143772 >> 2] = (HEAP32[gb + 143772 >> 2] | 0) + (gb + 762861 | 0);
 HEAP32[gb + 143776 >> 2] = (HEAP32[gb + 143776 >> 2] | 0) + (gb + 762875 | 0);
 HEAP32[gb + 143780 >> 2] = (HEAP32[gb + 143780 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143784 >> 2] = (HEAP32[gb + 143784 >> 2] | 0) + (gb + 762912 | 0);
 HEAP32[gb + 143788 >> 2] = (HEAP32[gb + 143788 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 143792 >> 2] = (HEAP32[gb + 143792 >> 2] | 0) + (gb + 762955 | 0);
 HEAP32[gb + 143796 >> 2] = (HEAP32[gb + 143796 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 143800 >> 2] = (HEAP32[gb + 143800 >> 2] | 0) + (gb + 764372 | 0);
 HEAP32[gb + 143804 >> 2] = (HEAP32[gb + 143804 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 143808 >> 2] = (HEAP32[gb + 143808 >> 2] | 0) + (gb + 764403 | 0);
 HEAP32[gb + 143812 >> 2] = (HEAP32[gb + 143812 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 143816 >> 2] = (HEAP32[gb + 143816 >> 2] | 0) + (gb + 764434 | 0);
 HEAP32[gb + 143820 >> 2] = (HEAP32[gb + 143820 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143824 >> 2] = (HEAP32[gb + 143824 >> 2] | 0) + (gb + 764469 | 0);
 HEAP32[gb + 143828 >> 2] = (HEAP32[gb + 143828 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 143832 >> 2] = (HEAP32[gb + 143832 >> 2] | 0) + (gb + 762999 | 0);
 HEAP32[gb + 143836 >> 2] = (HEAP32[gb + 143836 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143840 >> 2] = (HEAP32[gb + 143840 >> 2] | 0) + (gb + 763033 | 0);
 HEAP32[gb + 143844 >> 2] = (HEAP32[gb + 143844 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 143848 >> 2] = (HEAP32[gb + 143848 >> 2] | 0) + (gb + 763068 | 0);
 HEAP32[gb + 143852 >> 2] = (HEAP32[gb + 143852 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143856 >> 2] = (HEAP32[gb + 143856 >> 2] | 0) + (gb + 763101 | 0);
 HEAP32[gb + 143860 >> 2] = (HEAP32[gb + 143860 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 143864 >> 2] = (HEAP32[gb + 143864 >> 2] | 0) + (gb + 763149 | 0);
 HEAP32[gb + 143868 >> 2] = (HEAP32[gb + 143868 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143872 >> 2] = (HEAP32[gb + 143872 >> 2] | 0) + (gb + 763188 | 0);
 runPostSets159();
}

function runPostSets155() {
 HEAP32[gb + 142276 >> 2] = (HEAP32[gb + 142276 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 142280 >> 2] = (HEAP32[gb + 142280 >> 2] | 0) + (gb + 757440 | 0);
 HEAP32[gb + 142284 >> 2] = (HEAP32[gb + 142284 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142288 >> 2] = (HEAP32[gb + 142288 >> 2] | 0) + (gb + 757472 | 0);
 HEAP32[gb + 142292 >> 2] = (HEAP32[gb + 142292 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 142296 >> 2] = (HEAP32[gb + 142296 >> 2] | 0) + (gb + 757509 | 0);
 HEAP32[gb + 142300 >> 2] = (HEAP32[gb + 142300 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 142304 >> 2] = (HEAP32[gb + 142304 >> 2] | 0) + (gb + 757533 | 0);
 HEAP32[gb + 142308 >> 2] = (HEAP32[gb + 142308 >> 2] | 0) + (gb + 757555 | 0);
 HEAP32[gb + 142312 >> 2] = (HEAP32[gb + 142312 >> 2] | 0) + (gb + 757560 | 0);
 HEAP32[gb + 142316 >> 2] = (HEAP32[gb + 142316 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142320 >> 2] = (HEAP32[gb + 142320 >> 2] | 0) + (gb + 757579 | 0);
 HEAP32[gb + 142324 >> 2] = (HEAP32[gb + 142324 >> 2] | 0) + (gb + 757593 | 0);
 HEAP32[gb + 142328 >> 2] = (HEAP32[gb + 142328 >> 2] | 0) + (gb + 757645 | 0);
 HEAP32[gb + 142332 >> 2] = (HEAP32[gb + 142332 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142336 >> 2] = (HEAP32[gb + 142336 >> 2] | 0) + (gb + 757675 | 0);
 HEAP32[gb + 142340 >> 2] = (HEAP32[gb + 142340 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142344 >> 2] = (HEAP32[gb + 142344 >> 2] | 0) + (gb + 757694 | 0);
 HEAP32[gb + 142348 >> 2] = (HEAP32[gb + 142348 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 142352 >> 2] = (HEAP32[gb + 142352 >> 2] | 0) + (gb + 757734 | 0);
 HEAP32[gb + 142356 >> 2] = (HEAP32[gb + 142356 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142360 >> 2] = (HEAP32[gb + 142360 >> 2] | 0) + (gb + 757763 | 0);
 HEAP32[gb + 142364 >> 2] = (HEAP32[gb + 142364 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142368 >> 2] = (HEAP32[gb + 142368 >> 2] | 0) + (gb + 757789 | 0);
 HEAP32[gb + 142372 >> 2] = (HEAP32[gb + 142372 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142376 >> 2] = (HEAP32[gb + 142376 >> 2] | 0) + (gb + 757845 | 0);
 HEAP32[gb + 142380 >> 2] = (HEAP32[gb + 142380 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142384 >> 2] = (HEAP32[gb + 142384 >> 2] | 0) + (gb + 757870 | 0);
 HEAP32[gb + 142388 >> 2] = (HEAP32[gb + 142388 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142392 >> 2] = (HEAP32[gb + 142392 >> 2] | 0) + (gb + 757890 | 0);
 HEAP32[gb + 142396 >> 2] = (HEAP32[gb + 142396 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 142400 >> 2] = (HEAP32[gb + 142400 >> 2] | 0) + (gb + 757916 | 0);
 HEAP32[gb + 142404 >> 2] = (HEAP32[gb + 142404 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142408 >> 2] = (HEAP32[gb + 142408 >> 2] | 0) + (gb + 757946 | 0);
 HEAP32[gb + 142412 >> 2] = (HEAP32[gb + 142412 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142416 >> 2] = (HEAP32[gb + 142416 >> 2] | 0) + (gb + 757973 | 0);
 HEAP32[gb + 142420 >> 2] = (HEAP32[gb + 142420 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142424 >> 2] = (HEAP32[gb + 142424 >> 2] | 0) + (gb + 758119 | 0);
 HEAP32[gb + 142428 >> 2] = (HEAP32[gb + 142428 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142432 >> 2] = (HEAP32[gb + 142432 >> 2] | 0) + (gb + 758031 | 0);
 HEAP32[gb + 142436 >> 2] = (HEAP32[gb + 142436 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142440 >> 2] = (HEAP32[gb + 142440 >> 2] | 0) + (gb + 758061 | 0);
 HEAP32[gb + 142444 >> 2] = (HEAP32[gb + 142444 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142448 >> 2] = (HEAP32[gb + 142448 >> 2] | 0) + (gb + 758081 | 0);
 HEAP32[gb + 142452 >> 2] = (HEAP32[gb + 142452 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 142456 >> 2] = (HEAP32[gb + 142456 >> 2] | 0) + (gb + 758145 | 0);
 HEAP32[gb + 142460 >> 2] = (HEAP32[gb + 142460 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142464 >> 2] = (HEAP32[gb + 142464 >> 2] | 0) + (gb + 758175 | 0);
 HEAP32[gb + 142468 >> 2] = (HEAP32[gb + 142468 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142472 >> 2] = (HEAP32[gb + 142472 >> 2] | 0) + (gb + 758206 | 0);
 HEAP32[gb + 142476 >> 2] = (HEAP32[gb + 142476 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142480 >> 2] = (HEAP32[gb + 142480 >> 2] | 0) + (gb + 758235 | 0);
 HEAP32[gb + 142484 >> 2] = (HEAP32[gb + 142484 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 142488 >> 2] = (HEAP32[gb + 142488 >> 2] | 0) + (gb + 758270 | 0);
 HEAP32[gb + 142492 >> 2] = (HEAP32[gb + 142492 >> 2] | 0) + (gb + 758304 | 0);
 HEAP32[gb + 142496 >> 2] = (HEAP32[gb + 142496 >> 2] | 0) + (gb + 763521 | 0);
 HEAP32[gb + 142500 >> 2] = (HEAP32[gb + 142500 >> 2] | 0) + (gb + 758342 | 0);
 HEAP32[gb + 142504 >> 2] = (HEAP32[gb + 142504 >> 2] | 0) + (gb + 758348 | 0);
 HEAP32[gb + 142508 >> 2] = (HEAP32[gb + 142508 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 142512 >> 2] = (HEAP32[gb + 142512 >> 2] | 0) + (gb + 758404 | 0);
 HEAP32[gb + 142516 >> 2] = (HEAP32[gb + 142516 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142520 >> 2] = (HEAP32[gb + 142520 >> 2] | 0) + (gb + 758458 | 0);
 HEAP32[gb + 142524 >> 2] = (HEAP32[gb + 142524 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 142528 >> 2] = (HEAP32[gb + 142528 >> 2] | 0) + (gb + 758509 | 0);
 HEAP32[gb + 142532 >> 2] = (HEAP32[gb + 142532 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142536 >> 2] = (HEAP32[gb + 142536 >> 2] | 0) + (gb + 758542 | 0);
 HEAP32[gb + 142540 >> 2] = (HEAP32[gb + 142540 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142544 >> 2] = (HEAP32[gb + 142544 >> 2] | 0) + (gb + 758573 | 0);
 HEAP32[gb + 142548 >> 2] = (HEAP32[gb + 142548 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142552 >> 2] = (HEAP32[gb + 142552 >> 2] | 0) + (gb + 758603 | 0);
 HEAP32[gb + 142556 >> 2] = (HEAP32[gb + 142556 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 142560 >> 2] = (HEAP32[gb + 142560 >> 2] | 0) + (gb + 758641 | 0);
 HEAP32[gb + 142564 >> 2] = (HEAP32[gb + 142564 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142568 >> 2] = (HEAP32[gb + 142568 >> 2] | 0) + (gb + 758676 | 0);
 HEAP32[gb + 142572 >> 2] = (HEAP32[gb + 142572 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142576 >> 2] = (HEAP32[gb + 142576 >> 2] | 0) + (gb + 758703 | 0);
 HEAP32[gb + 142580 >> 2] = (HEAP32[gb + 142580 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142584 >> 2] = (HEAP32[gb + 142584 >> 2] | 0) + (gb + 758731 | 0);
 HEAP32[gb + 142588 >> 2] = (HEAP32[gb + 142588 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142592 >> 2] = (HEAP32[gb + 142592 >> 2] | 0) + (gb + 758770 | 0);
 HEAP32[gb + 142596 >> 2] = (HEAP32[gb + 142596 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142600 >> 2] = (HEAP32[gb + 142600 >> 2] | 0) + (gb + 758809 | 0);
 HEAP32[gb + 142604 >> 2] = (HEAP32[gb + 142604 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 142608 >> 2] = (HEAP32[gb + 142608 >> 2] | 0) + (gb + 758861 | 0);
 HEAP32[gb + 142612 >> 2] = (HEAP32[gb + 142612 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 142616 >> 2] = (HEAP32[gb + 142616 >> 2] | 0) + (gb + 763551 | 0);
 HEAP32[gb + 142620 >> 2] = (HEAP32[gb + 142620 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142624 >> 2] = (HEAP32[gb + 142624 >> 2] | 0) + (gb + 763588 | 0);
 HEAP32[gb + 142628 >> 2] = (HEAP32[gb + 142628 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142632 >> 2] = (HEAP32[gb + 142632 >> 2] | 0) + (gb + 763626 | 0);
 HEAP32[gb + 142636 >> 2] = (HEAP32[gb + 142636 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 142640 >> 2] = (HEAP32[gb + 142640 >> 2] | 0) + (gb + 758899 | 0);
 HEAP32[gb + 142644 >> 2] = (HEAP32[gb + 142644 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 142648 >> 2] = (HEAP32[gb + 142648 >> 2] | 0) + (gb + 758937 | 0);
 HEAP32[gb + 142652 >> 2] = (HEAP32[gb + 142652 >> 2] | 0) + (gb + 758974 | 0);
 HEAP32[gb + 142656 >> 2] = (HEAP32[gb + 142656 >> 2] | 0) + (gb + 758989 | 0);
 HEAP32[gb + 142660 >> 2] = (HEAP32[gb + 142660 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 142664 >> 2] = (HEAP32[gb + 142664 >> 2] | 0) + (gb + 759026 | 0);
 HEAP32[gb + 142668 >> 2] = (HEAP32[gb + 142668 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 142672 >> 2] = (HEAP32[gb + 142672 >> 2] | 0) + (gb + 763672 | 0);
 runPostSets156();
}

function runPostSets164() {
 HEAP32[gb + 145876 >> 2] = (HEAP32[gb + 145876 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 145880 >> 2] = (HEAP32[gb + 145880 >> 2] | 0) + (gb + 764536 | 0);
 HEAP32[gb + 145884 >> 2] = (HEAP32[gb + 145884 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145888 >> 2] = (HEAP32[gb + 145888 >> 2] | 0) + (gb + 764559 | 0);
 HEAP32[gb + 145892 >> 2] = (HEAP32[gb + 145892 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145896 >> 2] = (HEAP32[gb + 145896 >> 2] | 0) + (gb + 764579 | 0);
 HEAP32[gb + 145900 >> 2] = (HEAP32[gb + 145900 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145904 >> 2] = (HEAP32[gb + 145904 >> 2] | 0) + (gb + 764606 | 0);
 HEAP32[gb + 145908 >> 2] = (HEAP32[gb + 145908 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 145912 >> 2] = (HEAP32[gb + 145912 >> 2] | 0) + (gb + 764646 | 0);
 HEAP32[gb + 145916 >> 2] = (HEAP32[gb + 145916 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145920 >> 2] = (HEAP32[gb + 145920 >> 2] | 0) + (gb + 764685 | 0);
 HEAP32[gb + 145924 >> 2] = (HEAP32[gb + 145924 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 145928 >> 2] = (HEAP32[gb + 145928 >> 2] | 0) + (gb + 764704 | 0);
 HEAP32[gb + 145932 >> 2] = (HEAP32[gb + 145932 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 145936 >> 2] = (HEAP32[gb + 145936 >> 2] | 0) + (gb + 764733 | 0);
 HEAP32[gb + 145940 >> 2] = (HEAP32[gb + 145940 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145944 >> 2] = (HEAP32[gb + 145944 >> 2] | 0) + (gb + 764760 | 0);
 HEAP32[gb + 145948 >> 2] = (HEAP32[gb + 145948 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 145952 >> 2] = (HEAP32[gb + 145952 >> 2] | 0) + (gb + 764784 | 0);
 HEAP32[gb + 145956 >> 2] = (HEAP32[gb + 145956 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145960 >> 2] = (HEAP32[gb + 145960 >> 2] | 0) + (gb + 765231 | 0);
 HEAP32[gb + 145964 >> 2] = (HEAP32[gb + 145964 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 145968 >> 2] = (HEAP32[gb + 145968 >> 2] | 0) + (gb + 765252 | 0);
 HEAP32[gb + 145972 >> 2] = (HEAP32[gb + 145972 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145976 >> 2] = (HEAP32[gb + 145976 >> 2] | 0) + (gb + 765280 | 0);
 HEAP32[gb + 145980 >> 2] = (HEAP32[gb + 145980 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145984 >> 2] = (HEAP32[gb + 145984 >> 2] | 0) + (gb + 765304 | 0);
 HEAP32[gb + 145988 >> 2] = (HEAP32[gb + 145988 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145992 >> 2] = (HEAP32[gb + 145992 >> 2] | 0) + (gb + 765331 | 0);
 HEAP32[gb + 145996 >> 2] = (HEAP32[gb + 145996 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 146e3 >> 2] = (HEAP32[gb + 146e3 >> 2] | 0) + (gb + 765359 | 0);
 HEAP32[gb + 146004 >> 2] = (HEAP32[gb + 146004 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146008 >> 2] = (HEAP32[gb + 146008 >> 2] | 0) + (gb + 765391 | 0);
 HEAP32[gb + 146012 >> 2] = (HEAP32[gb + 146012 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146016 >> 2] = (HEAP32[gb + 146016 >> 2] | 0) + (gb + 765420 | 0);
 HEAP32[gb + 146020 >> 2] = (HEAP32[gb + 146020 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146024 >> 2] = (HEAP32[gb + 146024 >> 2] | 0) + (gb + 765445 | 0);
 HEAP32[gb + 146028 >> 2] = (HEAP32[gb + 146028 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 146032 >> 2] = (HEAP32[gb + 146032 >> 2] | 0) + (gb + 765483 | 0);
 HEAP32[gb + 146036 >> 2] = (HEAP32[gb + 146036 >> 2] | 0) + (gb + 765513 | 0);
 HEAP32[gb + 146040 >> 2] = (HEAP32[gb + 146040 >> 2] | 0) + (gb + 765519 | 0);
 HEAP32[gb + 146044 >> 2] = (HEAP32[gb + 146044 >> 2] | 0) + (gb + 765548 | 0);
 HEAP32[gb + 146048 >> 2] = (HEAP32[gb + 146048 >> 2] | 0) + (gb + 765552 | 0);
 HEAP32[gb + 146052 >> 2] = (HEAP32[gb + 146052 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 146056 >> 2] = (HEAP32[gb + 146056 >> 2] | 0) + (gb + 765585 | 0);
 HEAP32[gb + 146060 >> 2] = (HEAP32[gb + 146060 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146064 >> 2] = (HEAP32[gb + 146064 >> 2] | 0) + (gb + 765617 | 0);
 HEAP32[gb + 146068 >> 2] = (HEAP32[gb + 146068 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 146072 >> 2] = (HEAP32[gb + 146072 >> 2] | 0) + (gb + 765655 | 0);
 HEAP32[gb + 146076 >> 2] = (HEAP32[gb + 146076 >> 2] | 0) + (gb + 765690 | 0);
 HEAP32[gb + 146080 >> 2] = (HEAP32[gb + 146080 >> 2] | 0) + (gb + 765695 | 0);
 HEAP32[gb + 146084 >> 2] = (HEAP32[gb + 146084 >> 2] | 0) + (gb + 765723 | 0);
 HEAP32[gb + 146088 >> 2] = (HEAP32[gb + 146088 >> 2] | 0) + (gb + 765729 | 0);
 HEAP32[gb + 146092 >> 2] = (HEAP32[gb + 146092 >> 2] | 0) + (gb + 765760 | 0);
 HEAP32[gb + 146096 >> 2] = (HEAP32[gb + 146096 >> 2] | 0) + (gb + 765766 | 0);
 HEAP32[gb + 146100 >> 2] = (HEAP32[gb + 146100 >> 2] | 0) + (gb + 765792 | 0);
 HEAP32[gb + 146104 >> 2] = (HEAP32[gb + 146104 >> 2] | 0) + (gb + 765797 | 0);
 HEAP32[gb + 146108 >> 2] = (HEAP32[gb + 146108 >> 2] | 0) + (gb + 765830 | 0);
 HEAP32[gb + 146112 >> 2] = (HEAP32[gb + 146112 >> 2] | 0) + (gb + 765838 | 0);
 HEAP32[gb + 146116 >> 2] = (HEAP32[gb + 146116 >> 2] | 0) + (gb + 765877 | 0);
 HEAP32[gb + 146120 >> 2] = (HEAP32[gb + 146120 >> 2] | 0) + (gb + 765908 | 0);
 HEAP32[gb + 146124 >> 2] = (HEAP32[gb + 146124 >> 2] | 0) + (gb + 765943 | 0);
 HEAP32[gb + 146128 >> 2] = (HEAP32[gb + 146128 >> 2] | 0) + (gb + 766044 | 0);
 HEAP32[gb + 146132 >> 2] = (HEAP32[gb + 146132 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 146136 >> 2] = (HEAP32[gb + 146136 >> 2] | 0) + (gb + 766071 | 0);
 HEAP32[gb + 146140 >> 2] = (HEAP32[gb + 146140 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146144 >> 2] = (HEAP32[gb + 146144 >> 2] | 0) + (gb + 766102 | 0);
 HEAP32[gb + 146148 >> 2] = (HEAP32[gb + 146148 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146152 >> 2] = (HEAP32[gb + 146152 >> 2] | 0) + (gb + 766130 | 0);
 HEAP32[gb + 146156 >> 2] = (HEAP32[gb + 146156 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146160 >> 2] = (HEAP32[gb + 146160 >> 2] | 0) + (gb + 766154 | 0);
 HEAP32[gb + 146164 >> 2] = (HEAP32[gb + 146164 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 146168 >> 2] = (HEAP32[gb + 146168 >> 2] | 0) + (gb + 766191 | 0);
 HEAP32[gb + 146172 >> 2] = (HEAP32[gb + 146172 >> 2] | 0) + (gb + 765513 | 0);
 HEAP32[gb + 146176 >> 2] = (HEAP32[gb + 146176 >> 2] | 0) + (gb + 766220 | 0);
 HEAP32[gb + 146180 >> 2] = (HEAP32[gb + 146180 >> 2] | 0) + (gb + 765548 | 0);
 HEAP32[gb + 146184 >> 2] = (HEAP32[gb + 146184 >> 2] | 0) + (gb + 766248 | 0);
 HEAP32[gb + 146188 >> 2] = (HEAP32[gb + 146188 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 146192 >> 2] = (HEAP32[gb + 146192 >> 2] | 0) + (gb + 766280 | 0);
 HEAP32[gb + 146196 >> 2] = (HEAP32[gb + 146196 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 146200 >> 2] = (HEAP32[gb + 146200 >> 2] | 0) + (gb + 766311 | 0);
 HEAP32[gb + 146204 >> 2] = (HEAP32[gb + 146204 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 146208 >> 2] = (HEAP32[gb + 146208 >> 2] | 0) + (gb + 766348 | 0);
 HEAP32[gb + 146212 >> 2] = (HEAP32[gb + 146212 >> 2] | 0) + (gb + 765690 | 0);
 HEAP32[gb + 146216 >> 2] = (HEAP32[gb + 146216 >> 2] | 0) + (gb + 766382 | 0);
 HEAP32[gb + 146220 >> 2] = (HEAP32[gb + 146220 >> 2] | 0) + (gb + 765723 | 0);
 HEAP32[gb + 146224 >> 2] = (HEAP32[gb + 146224 >> 2] | 0) + (gb + 766409 | 0);
 HEAP32[gb + 146228 >> 2] = (HEAP32[gb + 146228 >> 2] | 0) + (gb + 765760 | 0);
 HEAP32[gb + 146232 >> 2] = (HEAP32[gb + 146232 >> 2] | 0) + (gb + 766439 | 0);
 HEAP32[gb + 146236 >> 2] = (HEAP32[gb + 146236 >> 2] | 0) + (gb + 766464 | 0);
 HEAP32[gb + 146240 >> 2] = (HEAP32[gb + 146240 >> 2] | 0) + (gb + 766469 | 0);
 HEAP32[gb + 146244 >> 2] = (HEAP32[gb + 146244 >> 2] | 0) + (gb + 765830 | 0);
 HEAP32[gb + 146248 >> 2] = (HEAP32[gb + 146248 >> 2] | 0) + (gb + 766501 | 0);
 HEAP32[gb + 146252 >> 2] = (HEAP32[gb + 146252 >> 2] | 0) + (gb + 766527 | 0);
 HEAP32[gb + 146256 >> 2] = (HEAP32[gb + 146256 >> 2] | 0) + (gb + 766530 | 0);
 HEAP32[gb + 146260 >> 2] = (HEAP32[gb + 146260 >> 2] | 0) + (gb + 766556 | 0);
 HEAP32[gb + 146264 >> 2] = (HEAP32[gb + 146264 >> 2] | 0) + (gb + 766558 | 0);
 HEAP32[gb + 146268 >> 2] = (HEAP32[gb + 146268 >> 2] | 0) + (gb + 757555 | 0);
 HEAP32[gb + 146272 >> 2] = (HEAP32[gb + 146272 >> 2] | 0) + (gb + 766595 | 0);
 runPostSets165();
}

function runPostSets161() {
 HEAP32[gb + 144676 >> 2] = (HEAP32[gb + 144676 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144680 >> 2] = (HEAP32[gb + 144680 >> 2] | 0) + (gb + 759307 | 0);
 HEAP32[gb + 144684 >> 2] = (HEAP32[gb + 144684 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 144688 >> 2] = (HEAP32[gb + 144688 >> 2] | 0) + (gb + 759379 | 0);
 HEAP32[gb + 144692 >> 2] = (HEAP32[gb + 144692 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144696 >> 2] = (HEAP32[gb + 144696 >> 2] | 0) + (gb + 759413 | 0);
 HEAP32[gb + 144700 >> 2] = (HEAP32[gb + 144700 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 144704 >> 2] = (HEAP32[gb + 144704 >> 2] | 0) + (gb + 759448 | 0);
 HEAP32[gb + 144708 >> 2] = (HEAP32[gb + 144708 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 144712 >> 2] = (HEAP32[gb + 144712 >> 2] | 0) + (gb + 759487 | 0);
 HEAP32[gb + 144716 >> 2] = (HEAP32[gb + 144716 >> 2] | 0) + (gb + 759522 | 0);
 HEAP32[gb + 144720 >> 2] = (HEAP32[gb + 144720 >> 2] | 0) + (gb + 759526 | 0);
 HEAP32[gb + 144724 >> 2] = (HEAP32[gb + 144724 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 144728 >> 2] = (HEAP32[gb + 144728 >> 2] | 0) + (gb + 759565 | 0);
 HEAP32[gb + 144732 >> 2] = (HEAP32[gb + 144732 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 144736 >> 2] = (HEAP32[gb + 144736 >> 2] | 0) + (gb + 759604 | 0);
 HEAP32[gb + 144740 >> 2] = (HEAP32[gb + 144740 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 144744 >> 2] = (HEAP32[gb + 144744 >> 2] | 0) + (gb + 759658 | 0);
 HEAP32[gb + 144748 >> 2] = (HEAP32[gb + 144748 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 144752 >> 2] = (HEAP32[gb + 144752 >> 2] | 0) + (gb + 763718 | 0);
 HEAP32[gb + 144756 >> 2] = (HEAP32[gb + 144756 >> 2] | 0) + (gb + 758342 | 0);
 HEAP32[gb + 144760 >> 2] = (HEAP32[gb + 144760 >> 2] | 0) + (gb + 759712 | 0);
 HEAP32[gb + 144764 >> 2] = (HEAP32[gb + 144764 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144768 >> 2] = (HEAP32[gb + 144768 >> 2] | 0) + (gb + 763748 | 0);
 HEAP32[gb + 144772 >> 2] = (HEAP32[gb + 144772 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 144776 >> 2] = (HEAP32[gb + 144776 >> 2] | 0) + (gb + 763780 | 0);
 HEAP32[gb + 144780 >> 2] = (HEAP32[gb + 144780 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 144784 >> 2] = (HEAP32[gb + 144784 >> 2] | 0) + (gb + 763812 | 0);
 HEAP32[gb + 144788 >> 2] = (HEAP32[gb + 144788 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144792 >> 2] = (HEAP32[gb + 144792 >> 2] | 0) + (gb + 763840 | 0);
 HEAP32[gb + 144796 >> 2] = (HEAP32[gb + 144796 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 144800 >> 2] = (HEAP32[gb + 144800 >> 2] | 0) + (gb + 759756 | 0);
 HEAP32[gb + 144804 >> 2] = (HEAP32[gb + 144804 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 144808 >> 2] = (HEAP32[gb + 144808 >> 2] | 0) + (gb + 759783 | 0);
 HEAP32[gb + 144812 >> 2] = (HEAP32[gb + 144812 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 144816 >> 2] = (HEAP32[gb + 144816 >> 2] | 0) + (gb + 759811 | 0);
 HEAP32[gb + 144820 >> 2] = (HEAP32[gb + 144820 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144824 >> 2] = (HEAP32[gb + 144824 >> 2] | 0) + (gb + 759837 | 0);
 HEAP32[gb + 144828 >> 2] = (HEAP32[gb + 144828 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 144832 >> 2] = (HEAP32[gb + 144832 >> 2] | 0) + (gb + 759871 | 0);
 HEAP32[gb + 144836 >> 2] = (HEAP32[gb + 144836 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144840 >> 2] = (HEAP32[gb + 144840 >> 2] | 0) + (gb + 759899 | 0);
 HEAP32[gb + 144844 >> 2] = (HEAP32[gb + 144844 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144848 >> 2] = (HEAP32[gb + 144848 >> 2] | 0) + (gb + 759919 | 0);
 HEAP32[gb + 144852 >> 2] = (HEAP32[gb + 144852 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144856 >> 2] = (HEAP32[gb + 144856 >> 2] | 0) + (gb + 759939 | 0);
 HEAP32[gb + 144860 >> 2] = (HEAP32[gb + 144860 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144864 >> 2] = (HEAP32[gb + 144864 >> 2] | 0) + (gb + 759963 | 0);
 HEAP32[gb + 144868 >> 2] = (HEAP32[gb + 144868 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144872 >> 2] = (HEAP32[gb + 144872 >> 2] | 0) + (gb + 759988 | 0);
 HEAP32[gb + 144876 >> 2] = (HEAP32[gb + 144876 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 144880 >> 2] = (HEAP32[gb + 144880 >> 2] | 0) + (gb + 760013 | 0);
 HEAP32[gb + 144884 >> 2] = (HEAP32[gb + 144884 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144888 >> 2] = (HEAP32[gb + 144888 >> 2] | 0) + (gb + 760047 | 0);
 HEAP32[gb + 144892 >> 2] = (HEAP32[gb + 144892 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144896 >> 2] = (HEAP32[gb + 144896 >> 2] | 0) + (gb + 760076 | 0);
 HEAP32[gb + 144900 >> 2] = (HEAP32[gb + 144900 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144904 >> 2] = (HEAP32[gb + 144904 >> 2] | 0) + (gb + 760106 | 0);
 HEAP32[gb + 144908 >> 2] = (HEAP32[gb + 144908 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 144912 >> 2] = (HEAP32[gb + 144912 >> 2] | 0) + (gb + 760144 | 0);
 HEAP32[gb + 144916 >> 2] = (HEAP32[gb + 144916 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 144920 >> 2] = (HEAP32[gb + 144920 >> 2] | 0) + (gb + 760172 | 0);
 HEAP32[gb + 144924 >> 2] = (HEAP32[gb + 144924 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144928 >> 2] = (HEAP32[gb + 144928 >> 2] | 0) + (gb + 760205 | 0);
 HEAP32[gb + 144932 >> 2] = (HEAP32[gb + 144932 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144936 >> 2] = (HEAP32[gb + 144936 >> 2] | 0) + (gb + 760233 | 0);
 HEAP32[gb + 144940 >> 2] = (HEAP32[gb + 144940 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144944 >> 2] = (HEAP32[gb + 144944 >> 2] | 0) + (gb + 760262 | 0);
 HEAP32[gb + 144948 >> 2] = (HEAP32[gb + 144948 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 144952 >> 2] = (HEAP32[gb + 144952 >> 2] | 0) + (gb + 760299 | 0);
 HEAP32[gb + 144956 >> 2] = (HEAP32[gb + 144956 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 144960 >> 2] = (HEAP32[gb + 144960 >> 2] | 0) + (gb + 760333 | 0);
 HEAP32[gb + 144964 >> 2] = (HEAP32[gb + 144964 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 144968 >> 2] = (HEAP32[gb + 144968 >> 2] | 0) + (gb + 760368 | 0);
 HEAP32[gb + 144972 >> 2] = (HEAP32[gb + 144972 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144976 >> 2] = (HEAP32[gb + 144976 >> 2] | 0) + (gb + 760401 | 0);
 HEAP32[gb + 144980 >> 2] = (HEAP32[gb + 144980 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144984 >> 2] = (HEAP32[gb + 144984 >> 2] | 0) + (gb + 760429 | 0);
 HEAP32[gb + 144988 >> 2] = (HEAP32[gb + 144988 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 144992 >> 2] = (HEAP32[gb + 144992 >> 2] | 0) + (gb + 760458 | 0);
 HEAP32[gb + 144996 >> 2] = (HEAP32[gb + 144996 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 145e3 >> 2] = (HEAP32[gb + 145e3 >> 2] | 0) + (gb + 760495 | 0);
 HEAP32[gb + 145004 >> 2] = (HEAP32[gb + 145004 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 145008 >> 2] = (HEAP32[gb + 145008 >> 2] | 0) + (gb + 760523 | 0);
 HEAP32[gb + 145012 >> 2] = (HEAP32[gb + 145012 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 145016 >> 2] = (HEAP32[gb + 145016 >> 2] | 0) + (gb + 760551 | 0);
 HEAP32[gb + 145020 >> 2] = (HEAP32[gb + 145020 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145024 >> 2] = (HEAP32[gb + 145024 >> 2] | 0) + (gb + 760577 | 0);
 HEAP32[gb + 145028 >> 2] = (HEAP32[gb + 145028 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145032 >> 2] = (HEAP32[gb + 145032 >> 2] | 0) + (gb + 760604 | 0);
 HEAP32[gb + 145036 >> 2] = (HEAP32[gb + 145036 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145040 >> 2] = (HEAP32[gb + 145040 >> 2] | 0) + (gb + 760634 | 0);
 HEAP32[gb + 145044 >> 2] = (HEAP32[gb + 145044 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 145048 >> 2] = (HEAP32[gb + 145048 >> 2] | 0) + (gb + 760659 | 0);
 HEAP32[gb + 145052 >> 2] = (HEAP32[gb + 145052 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145056 >> 2] = (HEAP32[gb + 145056 >> 2] | 0) + (gb + 760685 | 0);
 HEAP32[gb + 145060 >> 2] = (HEAP32[gb + 145060 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 145064 >> 2] = (HEAP32[gb + 145064 >> 2] | 0) + (gb + 760712 | 0);
 HEAP32[gb + 145068 >> 2] = (HEAP32[gb + 145068 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 145072 >> 2] = (HEAP32[gb + 145072 >> 2] | 0) + (gb + 760742 | 0);
 runPostSets162();
}

function runPostSets151() {
 HEAP32[gb + 140668 >> 2] = (HEAP32[gb + 140668 >> 2] | 0) + (gb + 757916 | 0);
 HEAP32[gb + 140672 >> 2] = (HEAP32[gb + 140672 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140676 >> 2] = (HEAP32[gb + 140676 >> 2] | 0) + (gb + 757946 | 0);
 HEAP32[gb + 140680 >> 2] = (HEAP32[gb + 140680 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140684 >> 2] = (HEAP32[gb + 140684 >> 2] | 0) + (gb + 757973 | 0);
 HEAP32[gb + 140688 >> 2] = (HEAP32[gb + 140688 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140692 >> 2] = (HEAP32[gb + 140692 >> 2] | 0) + (gb + 758007 | 0);
 HEAP32[gb + 140696 >> 2] = (HEAP32[gb + 140696 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140700 >> 2] = (HEAP32[gb + 140700 >> 2] | 0) + (gb + 758031 | 0);
 HEAP32[gb + 140704 >> 2] = (HEAP32[gb + 140704 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140708 >> 2] = (HEAP32[gb + 140708 >> 2] | 0) + (gb + 758061 | 0);
 HEAP32[gb + 140712 >> 2] = (HEAP32[gb + 140712 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140716 >> 2] = (HEAP32[gb + 140716 >> 2] | 0) + (gb + 758081 | 0);
 HEAP32[gb + 140720 >> 2] = (HEAP32[gb + 140720 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140724 >> 2] = (HEAP32[gb + 140724 >> 2] | 0) + (gb + 758119 | 0);
 HEAP32[gb + 140728 >> 2] = (HEAP32[gb + 140728 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140732 >> 2] = (HEAP32[gb + 140732 >> 2] | 0) + (gb + 758145 | 0);
 HEAP32[gb + 140736 >> 2] = (HEAP32[gb + 140736 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140740 >> 2] = (HEAP32[gb + 140740 >> 2] | 0) + (gb + 758175 | 0);
 HEAP32[gb + 140744 >> 2] = (HEAP32[gb + 140744 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140748 >> 2] = (HEAP32[gb + 140748 >> 2] | 0) + (gb + 758206 | 0);
 HEAP32[gb + 140752 >> 2] = (HEAP32[gb + 140752 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140756 >> 2] = (HEAP32[gb + 140756 >> 2] | 0) + (gb + 758235 | 0);
 HEAP32[gb + 140760 >> 2] = (HEAP32[gb + 140760 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 140764 >> 2] = (HEAP32[gb + 140764 >> 2] | 0) + (gb + 758270 | 0);
 HEAP32[gb + 140768 >> 2] = (HEAP32[gb + 140768 >> 2] | 0) + (gb + 758304 | 0);
 HEAP32[gb + 140772 >> 2] = (HEAP32[gb + 140772 >> 2] | 0) + (gb + 758306 | 0);
 HEAP32[gb + 140776 >> 2] = (HEAP32[gb + 140776 >> 2] | 0) + (gb + 758342 | 0);
 HEAP32[gb + 140780 >> 2] = (HEAP32[gb + 140780 >> 2] | 0) + (gb + 758348 | 0);
 HEAP32[gb + 140784 >> 2] = (HEAP32[gb + 140784 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 140788 >> 2] = (HEAP32[gb + 140788 >> 2] | 0) + (gb + 758404 | 0);
 HEAP32[gb + 140792 >> 2] = (HEAP32[gb + 140792 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140796 >> 2] = (HEAP32[gb + 140796 >> 2] | 0) + (gb + 758458 | 0);
 HEAP32[gb + 140800 >> 2] = (HEAP32[gb + 140800 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 140804 >> 2] = (HEAP32[gb + 140804 >> 2] | 0) + (gb + 758509 | 0);
 HEAP32[gb + 140808 >> 2] = (HEAP32[gb + 140808 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140812 >> 2] = (HEAP32[gb + 140812 >> 2] | 0) + (gb + 758542 | 0);
 HEAP32[gb + 140816 >> 2] = (HEAP32[gb + 140816 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140820 >> 2] = (HEAP32[gb + 140820 >> 2] | 0) + (gb + 758573 | 0);
 HEAP32[gb + 140824 >> 2] = (HEAP32[gb + 140824 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140828 >> 2] = (HEAP32[gb + 140828 >> 2] | 0) + (gb + 758603 | 0);
 HEAP32[gb + 140832 >> 2] = (HEAP32[gb + 140832 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 140836 >> 2] = (HEAP32[gb + 140836 >> 2] | 0) + (gb + 758641 | 0);
 HEAP32[gb + 140840 >> 2] = (HEAP32[gb + 140840 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140844 >> 2] = (HEAP32[gb + 140844 >> 2] | 0) + (gb + 758676 | 0);
 HEAP32[gb + 140848 >> 2] = (HEAP32[gb + 140848 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140852 >> 2] = (HEAP32[gb + 140852 >> 2] | 0) + (gb + 758703 | 0);
 HEAP32[gb + 140856 >> 2] = (HEAP32[gb + 140856 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140860 >> 2] = (HEAP32[gb + 140860 >> 2] | 0) + (gb + 758731 | 0);
 HEAP32[gb + 140864 >> 2] = (HEAP32[gb + 140864 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140868 >> 2] = (HEAP32[gb + 140868 >> 2] | 0) + (gb + 758770 | 0);
 HEAP32[gb + 140872 >> 2] = (HEAP32[gb + 140872 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140876 >> 2] = (HEAP32[gb + 140876 >> 2] | 0) + (gb + 758809 | 0);
 HEAP32[gb + 140880 >> 2] = (HEAP32[gb + 140880 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 140884 >> 2] = (HEAP32[gb + 140884 >> 2] | 0) + (gb + 758861 | 0);
 HEAP32[gb + 140888 >> 2] = (HEAP32[gb + 140888 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 140892 >> 2] = (HEAP32[gb + 140892 >> 2] | 0) + (gb + 758899 | 0);
 HEAP32[gb + 140896 >> 2] = (HEAP32[gb + 140896 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 140900 >> 2] = (HEAP32[gb + 140900 >> 2] | 0) + (gb + 758937 | 0);
 HEAP32[gb + 140904 >> 2] = (HEAP32[gb + 140904 >> 2] | 0) + (gb + 758974 | 0);
 HEAP32[gb + 140908 >> 2] = (HEAP32[gb + 140908 >> 2] | 0) + (gb + 758989 | 0);
 HEAP32[gb + 140912 >> 2] = (HEAP32[gb + 140912 >> 2] | 0) + (gb + 758847 | 0);
 HEAP32[gb + 140916 >> 2] = (HEAP32[gb + 140916 >> 2] | 0) + (gb + 759026 | 0);
 HEAP32[gb + 140920 >> 2] = (HEAP32[gb + 140920 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 140924 >> 2] = (HEAP32[gb + 140924 >> 2] | 0) + (gb + 759064 | 0);
 HEAP32[gb + 140928 >> 2] = (HEAP32[gb + 140928 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140932 >> 2] = (HEAP32[gb + 140932 >> 2] | 0) + (gb + 759088 | 0);
 HEAP32[gb + 140936 >> 2] = (HEAP32[gb + 140936 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 140940 >> 2] = (HEAP32[gb + 140940 >> 2] | 0) + (gb + 759118 | 0);
 HEAP32[gb + 140944 >> 2] = (HEAP32[gb + 140944 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140948 >> 2] = (HEAP32[gb + 140948 >> 2] | 0) + (gb + 759152 | 0);
 HEAP32[gb + 140952 >> 2] = (HEAP32[gb + 140952 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140956 >> 2] = (HEAP32[gb + 140956 >> 2] | 0) + (gb + 759183 | 0);
 HEAP32[gb + 140960 >> 2] = (HEAP32[gb + 140960 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140964 >> 2] = (HEAP32[gb + 140964 >> 2] | 0) + (gb + 759221 | 0);
 HEAP32[gb + 140968 >> 2] = (HEAP32[gb + 140968 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140972 >> 2] = (HEAP32[gb + 140972 >> 2] | 0) + (gb + 759249 | 0);
 HEAP32[gb + 140976 >> 2] = (HEAP32[gb + 140976 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140980 >> 2] = (HEAP32[gb + 140980 >> 2] | 0) + (gb + 759283 | 0);
 HEAP32[gb + 140984 >> 2] = (HEAP32[gb + 140984 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140988 >> 2] = (HEAP32[gb + 140988 >> 2] | 0) + (gb + 759307 | 0);
 HEAP32[gb + 140992 >> 2] = (HEAP32[gb + 140992 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140996 >> 2] = (HEAP32[gb + 140996 >> 2] | 0) + (gb + 759349 | 0);
 HEAP32[gb + 141e3 >> 2] = (HEAP32[gb + 141e3 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 141004 >> 2] = (HEAP32[gb + 141004 >> 2] | 0) + (gb + 759379 | 0);
 HEAP32[gb + 141008 >> 2] = (HEAP32[gb + 141008 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 141012 >> 2] = (HEAP32[gb + 141012 >> 2] | 0) + (gb + 759413 | 0);
 HEAP32[gb + 141016 >> 2] = (HEAP32[gb + 141016 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 141020 >> 2] = (HEAP32[gb + 141020 >> 2] | 0) + (gb + 759448 | 0);
 HEAP32[gb + 141024 >> 2] = (HEAP32[gb + 141024 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 141028 >> 2] = (HEAP32[gb + 141028 >> 2] | 0) + (gb + 759487 | 0);
 HEAP32[gb + 141032 >> 2] = (HEAP32[gb + 141032 >> 2] | 0) + (gb + 759522 | 0);
 HEAP32[gb + 141036 >> 2] = (HEAP32[gb + 141036 >> 2] | 0) + (gb + 759526 | 0);
 HEAP32[gb + 141040 >> 2] = (HEAP32[gb + 141040 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 141044 >> 2] = (HEAP32[gb + 141044 >> 2] | 0) + (gb + 759565 | 0);
 HEAP32[gb + 141048 >> 2] = (HEAP32[gb + 141048 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 141052 >> 2] = (HEAP32[gb + 141052 >> 2] | 0) + (gb + 759604 | 0);
 HEAP32[gb + 141056 >> 2] = (HEAP32[gb + 141056 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 141060 >> 2] = (HEAP32[gb + 141060 >> 2] | 0) + (gb + 759658 | 0);
 HEAP32[gb + 141064 >> 2] = (HEAP32[gb + 141064 >> 2] | 0) + (gb + 756979 | 0);
 runPostSets152();
}

function __ZN5physx6shdfnd8internal9partitionINS_23PxcSolverConstraintDescEKNS_14ConstraintLessEEEiPT_iiRT0_(i10, i2, i9, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = (i9 + i2 | 0) / 2 | 0;
 i1 = i10 + (i8 << 5) | 0;
 i7 = i10 + (i2 << 5) | 0;
 i8 = i10 + (i8 << 5) + 16 | 0;
 i4 = i10 + (i2 << 5) + 16 | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0;
 if ((HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0) >>> 0 > i3 >>> 0) {
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0;
 } else i5 = i3;
 i6 = i10 + (i9 << 5) | 0;
 i4 = i10 + (i9 << 5) + 16 | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0;
 }
 if (i3 >>> 0 > (HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0) >>> 0) {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 }
 i9 = i9 + -1 | 0;
 i5 = i10 + (i9 << 5) | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 i4 = i10 + (i9 << 5) + 16 | 0;
 i1 = i9;
 while (1) {
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0;
  do i2 = i2 + 1 | 0; while ((HEAP32[(HEAP32[i10 + (i2 << 5) + 16 >> 2] | 0) + 56 >> 2] | 0) >>> 0 > i3 >>> 0);
  do i1 = i1 + -1 | 0; while (i3 >>> 0 > (HEAP32[(HEAP32[i10 + (i1 << 5) + 16 >> 2] | 0) + 56 >> 2] | 0) >>> 0);
  i3 = i1;
  i1 = i10 + (i2 << 5) | 0;
  if ((i2 | 0) >= (i3 | 0)) break;
  i9 = i10 + (i3 << 5) | 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  i1 = i3;
 }
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 STACKTOP = i12;
 return i2 | 0;
}

function runPostSets156() {
 HEAP32[gb + 142676 >> 2] = (HEAP32[gb + 142676 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 142680 >> 2] = (HEAP32[gb + 142680 >> 2] | 0) + (gb + 759064 | 0);
 HEAP32[gb + 142684 >> 2] = (HEAP32[gb + 142684 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142688 >> 2] = (HEAP32[gb + 142688 >> 2] | 0) + (gb + 759088 | 0);
 HEAP32[gb + 142692 >> 2] = (HEAP32[gb + 142692 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 142696 >> 2] = (HEAP32[gb + 142696 >> 2] | 0) + (gb + 759118 | 0);
 HEAP32[gb + 142700 >> 2] = (HEAP32[gb + 142700 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142704 >> 2] = (HEAP32[gb + 142704 >> 2] | 0) + (gb + 759152 | 0);
 HEAP32[gb + 142708 >> 2] = (HEAP32[gb + 142708 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142712 >> 2] = (HEAP32[gb + 142712 >> 2] | 0) + (gb + 759183 | 0);
 HEAP32[gb + 142716 >> 2] = (HEAP32[gb + 142716 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142720 >> 2] = (HEAP32[gb + 142720 >> 2] | 0) + (gb + 759349 | 0);
 HEAP32[gb + 142724 >> 2] = (HEAP32[gb + 142724 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142728 >> 2] = (HEAP32[gb + 142728 >> 2] | 0) + (gb + 759249 | 0);
 HEAP32[gb + 142732 >> 2] = (HEAP32[gb + 142732 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142736 >> 2] = (HEAP32[gb + 142736 >> 2] | 0) + (gb + 759283 | 0);
 HEAP32[gb + 142740 >> 2] = (HEAP32[gb + 142740 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142744 >> 2] = (HEAP32[gb + 142744 >> 2] | 0) + (gb + 759307 | 0);
 HEAP32[gb + 142748 >> 2] = (HEAP32[gb + 142748 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 142752 >> 2] = (HEAP32[gb + 142752 >> 2] | 0) + (gb + 759379 | 0);
 HEAP32[gb + 142756 >> 2] = (HEAP32[gb + 142756 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142760 >> 2] = (HEAP32[gb + 142760 >> 2] | 0) + (gb + 759413 | 0);
 HEAP32[gb + 142764 >> 2] = (HEAP32[gb + 142764 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142768 >> 2] = (HEAP32[gb + 142768 >> 2] | 0) + (gb + 759448 | 0);
 HEAP32[gb + 142772 >> 2] = (HEAP32[gb + 142772 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 142776 >> 2] = (HEAP32[gb + 142776 >> 2] | 0) + (gb + 759487 | 0);
 HEAP32[gb + 142780 >> 2] = (HEAP32[gb + 142780 >> 2] | 0) + (gb + 759522 | 0);
 HEAP32[gb + 142784 >> 2] = (HEAP32[gb + 142784 >> 2] | 0) + (gb + 759526 | 0);
 HEAP32[gb + 142788 >> 2] = (HEAP32[gb + 142788 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 142792 >> 2] = (HEAP32[gb + 142792 >> 2] | 0) + (gb + 759565 | 0);
 HEAP32[gb + 142796 >> 2] = (HEAP32[gb + 142796 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 142800 >> 2] = (HEAP32[gb + 142800 >> 2] | 0) + (gb + 759604 | 0);
 HEAP32[gb + 142804 >> 2] = (HEAP32[gb + 142804 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 142808 >> 2] = (HEAP32[gb + 142808 >> 2] | 0) + (gb + 759658 | 0);
 HEAP32[gb + 142812 >> 2] = (HEAP32[gb + 142812 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142816 >> 2] = (HEAP32[gb + 142816 >> 2] | 0) + (gb + 763718 | 0);
 HEAP32[gb + 142820 >> 2] = (HEAP32[gb + 142820 >> 2] | 0) + (gb + 758342 | 0);
 HEAP32[gb + 142824 >> 2] = (HEAP32[gb + 142824 >> 2] | 0) + (gb + 759712 | 0);
 HEAP32[gb + 142828 >> 2] = (HEAP32[gb + 142828 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142832 >> 2] = (HEAP32[gb + 142832 >> 2] | 0) + (gb + 763748 | 0);
 HEAP32[gb + 142836 >> 2] = (HEAP32[gb + 142836 >> 2] | 0) + (gb + 763772 | 0);
 HEAP32[gb + 142840 >> 2] = (HEAP32[gb + 142840 >> 2] | 0) + (gb + 763780 | 0);
 HEAP32[gb + 142844 >> 2] = (HEAP32[gb + 142844 >> 2] | 0) + (gb + 763804 | 0);
 HEAP32[gb + 142848 >> 2] = (HEAP32[gb + 142848 >> 2] | 0) + (gb + 763812 | 0);
 HEAP32[gb + 142852 >> 2] = (HEAP32[gb + 142852 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142856 >> 2] = (HEAP32[gb + 142856 >> 2] | 0) + (gb + 763840 | 0);
 HEAP32[gb + 142860 >> 2] = (HEAP32[gb + 142860 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 142864 >> 2] = (HEAP32[gb + 142864 >> 2] | 0) + (gb + 759756 | 0);
 HEAP32[gb + 142868 >> 2] = (HEAP32[gb + 142868 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 142872 >> 2] = (HEAP32[gb + 142872 >> 2] | 0) + (gb + 759783 | 0);
 HEAP32[gb + 142876 >> 2] = (HEAP32[gb + 142876 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 142880 >> 2] = (HEAP32[gb + 142880 >> 2] | 0) + (gb + 759811 | 0);
 HEAP32[gb + 142884 >> 2] = (HEAP32[gb + 142884 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142888 >> 2] = (HEAP32[gb + 142888 >> 2] | 0) + (gb + 759837 | 0);
 HEAP32[gb + 142892 >> 2] = (HEAP32[gb + 142892 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142896 >> 2] = (HEAP32[gb + 142896 >> 2] | 0) + (gb + 759871 | 0);
 HEAP32[gb + 142900 >> 2] = (HEAP32[gb + 142900 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142904 >> 2] = (HEAP32[gb + 142904 >> 2] | 0) + (gb + 759899 | 0);
 HEAP32[gb + 142908 >> 2] = (HEAP32[gb + 142908 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142912 >> 2] = (HEAP32[gb + 142912 >> 2] | 0) + (gb + 759919 | 0);
 HEAP32[gb + 142916 >> 2] = (HEAP32[gb + 142916 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142920 >> 2] = (HEAP32[gb + 142920 >> 2] | 0) + (gb + 759939 | 0);
 HEAP32[gb + 142924 >> 2] = (HEAP32[gb + 142924 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142928 >> 2] = (HEAP32[gb + 142928 >> 2] | 0) + (gb + 759963 | 0);
 HEAP32[gb + 142932 >> 2] = (HEAP32[gb + 142932 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142936 >> 2] = (HEAP32[gb + 142936 >> 2] | 0) + (gb + 759988 | 0);
 HEAP32[gb + 142940 >> 2] = (HEAP32[gb + 142940 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 142944 >> 2] = (HEAP32[gb + 142944 >> 2] | 0) + (gb + 760013 | 0);
 HEAP32[gb + 142948 >> 2] = (HEAP32[gb + 142948 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142952 >> 2] = (HEAP32[gb + 142952 >> 2] | 0) + (gb + 760047 | 0);
 HEAP32[gb + 142956 >> 2] = (HEAP32[gb + 142956 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142960 >> 2] = (HEAP32[gb + 142960 >> 2] | 0) + (gb + 760076 | 0);
 HEAP32[gb + 142964 >> 2] = (HEAP32[gb + 142964 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142968 >> 2] = (HEAP32[gb + 142968 >> 2] | 0) + (gb + 760106 | 0);
 HEAP32[gb + 142972 >> 2] = (HEAP32[gb + 142972 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 142976 >> 2] = (HEAP32[gb + 142976 >> 2] | 0) + (gb + 760144 | 0);
 HEAP32[gb + 142980 >> 2] = (HEAP32[gb + 142980 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 142984 >> 2] = (HEAP32[gb + 142984 >> 2] | 0) + (gb + 760172 | 0);
 HEAP32[gb + 142988 >> 2] = (HEAP32[gb + 142988 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142992 >> 2] = (HEAP32[gb + 142992 >> 2] | 0) + (gb + 760205 | 0);
 HEAP32[gb + 142996 >> 2] = (HEAP32[gb + 142996 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143e3 >> 2] = (HEAP32[gb + 143e3 >> 2] | 0) + (gb + 760233 | 0);
 HEAP32[gb + 143004 >> 2] = (HEAP32[gb + 143004 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143008 >> 2] = (HEAP32[gb + 143008 >> 2] | 0) + (gb + 760262 | 0);
 HEAP32[gb + 143012 >> 2] = (HEAP32[gb + 143012 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 143016 >> 2] = (HEAP32[gb + 143016 >> 2] | 0) + (gb + 760299 | 0);
 HEAP32[gb + 143020 >> 2] = (HEAP32[gb + 143020 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143024 >> 2] = (HEAP32[gb + 143024 >> 2] | 0) + (gb + 760333 | 0);
 HEAP32[gb + 143028 >> 2] = (HEAP32[gb + 143028 >> 2] | 0) + (gb + 760360 | 0);
 HEAP32[gb + 143032 >> 2] = (HEAP32[gb + 143032 >> 2] | 0) + (gb + 760368 | 0);
 HEAP32[gb + 143036 >> 2] = (HEAP32[gb + 143036 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143040 >> 2] = (HEAP32[gb + 143040 >> 2] | 0) + (gb + 760401 | 0);
 HEAP32[gb + 143044 >> 2] = (HEAP32[gb + 143044 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143048 >> 2] = (HEAP32[gb + 143048 >> 2] | 0) + (gb + 760429 | 0);
 HEAP32[gb + 143052 >> 2] = (HEAP32[gb + 143052 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 143056 >> 2] = (HEAP32[gb + 143056 >> 2] | 0) + (gb + 760458 | 0);
 HEAP32[gb + 143060 >> 2] = (HEAP32[gb + 143060 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 143064 >> 2] = (HEAP32[gb + 143064 >> 2] | 0) + (gb + 760495 | 0);
 HEAP32[gb + 143068 >> 2] = (HEAP32[gb + 143068 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 143072 >> 2] = (HEAP32[gb + 143072 >> 2] | 0) + (gb + 760523 | 0);
 runPostSets157();
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher30FindSessionContainerToDispatchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i45;
 i14 = i45 + 52 | 0;
 i42 = i45 + 32 | 0;
 i35 = i45 + 16 | 0;
 HEAP32[i42 >> 2] = 0;
 i40 = i42 + 12 | 0;
 HEAP32[i40 >> 2] = 0;
 i43 = i42 + 16 | 0;
 HEAP32[i43 >> 2] = 0;
 i44 = i42 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i15 = i11;
 i13 = HEAP32[i15 + 4 >> 2] | 0;
 i12 = i44;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = _time(0) | 0;
 i13 = i1 + 8 | 0;
 i15 = i35 + 12 | 0;
 i16 = i1 + 16 | 0;
 i17 = i16 + 11 | 0;
 i18 = i35 + 11 | 0;
 i19 = i35 + 12 | 0;
 i20 = i11 + 4 | 0;
 i21 = i11 + 11 | 0;
 i22 = i11 + 4 | 0;
 i23 = i35 + 8 | 0;
 i24 = i35 + 4 | 0;
 i25 = i1 + 36 | 0;
 i26 = i25 + 11 | 0;
 i27 = i1 + 40 | 0;
 i28 = i1 + 264 | 0;
 i29 = i1 + 268 | 0;
 i30 = i1 + 136 | 0;
 i31 = i1 + 276 | 0;
 i32 = i1 + 272 | 0;
 i33 = i1 + 268 | 0;
 i34 = i11 + 4 | 0;
 i36 = i11 + 4 | 0;
 i37 = i1 + 12 | 0;
 i38 = i1 + 92 | 0;
 i39 = i1 + 56 | 0;
 i10 = i1 + 60 | 0;
 i1 = 0;
 i9 = 0;
 i2 = 1;
 i5 = 0;
 while (1) {
  if ((HEAP32[i13 >> 2] | 0) != 1) if ((HEAP32[i13 >> 2] | 0) != 2) break;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  HEAP32[i15 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i35 >> 2] = 0;
  HEAP32[i35 + 4 >> 2] = 0;
  HEAP32[i35 + 8 >> 2] = 0;
  if (i2) {
   i2 = __Z13GetFileSystemv() | 0;
   if ((HEAP8[i17 >> 0] | 0) < 0) i3 = HEAP32[i16 >> 2] | 0; else i3 = i16;
   if (__ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i2, i3, i42, 0, 10) | 0) {
    i3 = HEAP32[i42 >> 2] | 0;
    if (!(HEAP32[i40 >> 2] | 0)) {
     i6 = 3;
     i4 = i9;
     i2 = 0;
    } else {
     i8 = i3;
     i41 = 9;
    }
   } else {
    i6 = 3;
    i4 = i9;
    i2 = 0;
    i3 = i5;
   }
  } else {
   i8 = i5;
   i41 = 9;
  }
  do if ((i41 | 0) == 9) {
   i41 = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i8, _strlen(i8) | 0);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11, i14);
   i6 = HEAP8[i21 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   i5 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
   i6 = i2 ? HEAP32[i22 >> 2] | 0 : i6 & 255;
   i2 = HEAP8[i18 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i4 = (HEAP32[i23 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   do if (i6 >>> 0 > i4 >>> 0) {
    i7 = i3 ? HEAP32[i24 >> 2] | 0 : i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i35, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
   } else {
    i2 = i3 ? HEAP32[i35 >> 2] | 0 : i35;
    if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
    HEAP8[i2 + i6 >> 0] = 0;
    if ((HEAP8[i18 >> 0] | 0) < 0) {
     HEAP32[i24 >> 2] = i6;
     break;
    } else {
     HEAP8[i18 >> 0] = i6;
     break;
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i4 = HEAP8[i18 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i24 >> 2] | 0 : i4 & 255;
   i6 = HEAP8[i26 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i27 >> 2] | 0 : i6 & 255;
   i7 = i6 >>> 0 < i4 >>> 0;
   i2 = i7 ? i6 : i4;
   if (!i2) i41 = 20; else if (!(_memcmp(i3 ? HEAP32[i35 >> 2] | 0 : i35, i5 ? HEAP32[i25 >> 2] | 0 : i25, i2) | 0)) i41 = 20;
   if ((i41 | 0) == 20) {
    i41 = 0;
    if (i4 >>> 0 >= i6 >>> 0 & (i7 ^ 1)) {
     i6 = 3;
     i4 = i9;
     i2 = 0;
     i3 = i8;
     break;
    }
   }
   i4 = __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_(i28, i35) | 0;
   i5 = (i4 | 0) != (i29 | 0);
   if (!i5) {
    HEAP32[i11 >> 2] = 0;
    HEAP16[i14 >> 1] = 0;
    __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeERK8UnityStrPjPt(i35, i11, i14);
    i7 = HEAP32[i11 >> 2] | 0;
    if ((i7 + -1 | 0) >>> 0 < i12 >>> 0 ? ((HEAP32[(HEAP32[i37 >> 2] | 0) + 8 >> 2] | 0) + -1 | 0) >>> 0 < (i12 - i7 | 0) >>> 0 : 0) HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + 1; else if (!(__ZN11UnityEngine15CloudWebService16SessionContainer12IsDispatchedERK8UnityStr(i30, i35) | 0)) if (__ZN11UnityEngine15CloudWebService16SessionContainer7RestoreERK8UnityStrPvy(i30, i35, HEAP32[i39 >> 2] | 0, HEAP32[i10 >> 2] | 0, 0) | 0) {
     i6 = 3;
     i4 = i9;
     i1 = i30;
     i2 = 0;
     i3 = i8;
     break;
    }
   }
   do if (__ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i30, i35) | 0) {
    if (i5) {
     i2 = HEAP32[i4 + 4 >> 2] | 0;
     if (!i2) {
      i3 = i4;
      while (1) {
       i2 = HEAP32[i3 + 8 >> 2] | 0;
       if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
      }
     } else while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) break; else i2 = i3;
     }
     if ((HEAP32[i28 >> 2] | 0) == (i4 | 0)) HEAP32[i28 >> 2] = i2;
     HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + -1;
     __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i33 >> 2] | 0, i4);
     i2 = i4 + 16 | 0;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i7 = HEAP32[i2 >> 2] | 0;
      i6 = HEAP32[i4 + 28 >> 2] | 0;
      HEAP32[i11 >> 2] = 66;
      HEAP32[i34 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i11);
     }
     i7 = HEAP32[i32 >> 2] | 0;
     HEAP32[i11 >> 2] = 85;
     HEAP32[i36 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
    }
   } else {
    i4 = __ZNKSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i28, i11, i35) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     __ZNSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE25__construct_node_with_keyERS6_(i14, i28, i35);
     i2 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = 0;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = i3;
     HEAP32[i4 >> 2] = i2;
     i3 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
     if (!i3) i3 = i2; else {
      HEAP32[i28 >> 2] = i3;
      i3 = HEAP32[i4 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i33 >> 2] | 0, i3);
     HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
    }
    i2 = i2 + 32 | 0;
    if (i5) {
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     break;
    } else {
     HEAP32[i2 >> 2] = 1;
     break;
    }
   } while (0);
   i3 = i8 + 1088 | 0;
   i2 = (i3 | 0) != ((HEAP32[i42 >> 2] | 0) + ((HEAP32[i40 >> 2] | 0) * 1088 | 0) | 0);
   i6 = i2 | i9 ^ 1;
   i2 = i6 ^ i2;
   i6 = i6 ? 0 : 3;
   i4 = i9 | i2;
  } while (0);
  if ((HEAP8[i18 >> 0] | 0) < 0) {
   i9 = HEAP32[i35 >> 2] | 0;
   i8 = HEAP32[i19 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i20 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
  }
  if (!i6) {
   i9 = i4;
   i5 = i3;
  } else break;
 }
 if ((HEAP32[i43 >> 2] | 0) <= -1) {
  STACKTOP = i45;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i42 >> 2] | 0, i44);
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i45;
 return i1 | 0;
}

function runPostSets138() {
 HEAP32[gb + 121352 >> 2] = (HEAP32[gb + 121352 >> 2] | 0) + (gb + 754363 | 0);
 HEAP32[gb + 121380 >> 2] = (HEAP32[gb + 121380 >> 2] | 0) + (gb + 754319 | 0);
 HEAP32[gb + 121384 >> 2] = (HEAP32[gb + 121384 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 121412 >> 2] = (HEAP32[gb + 121412 >> 2] | 0) + (gb + 754342 | 0);
 HEAP32[gb + 121416 >> 2] = (HEAP32[gb + 121416 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 121444 >> 2] = (HEAP32[gb + 121444 >> 2] | 0) + (gb + 827530 | 0);
 HEAP32[gb + 121476 >> 2] = (HEAP32[gb + 121476 >> 2] | 0) + (gb + 754342 | 0);
 HEAP32[gb + 121480 >> 2] = (HEAP32[gb + 121480 >> 2] | 0) + (gb + 754349 | 0);
 HEAP32[gb + 121508 >> 2] = (HEAP32[gb + 121508 >> 2] | 0) + (gb + 754319 | 0);
 HEAP32[gb + 121512 >> 2] = (HEAP32[gb + 121512 >> 2] | 0) + (gb + 754331 | 0);
 HEAP32[gb + 121540 >> 2] = (HEAP32[gb + 121540 >> 2] | 0) + (gb + 752142 | 0);
 HEAP32[gb + 121572 >> 2] = (HEAP32[gb + 121572 >> 2] | 0) + (gb + 774345 | 0);
 HEAP32[gb + 121576 >> 2] = (HEAP32[gb + 121576 >> 2] | 0) + (gb + 754309 | 0);
 HEAP32[gb + 121604 >> 2] = (HEAP32[gb + 121604 >> 2] | 0) + (gb + 754297 | 0);
 HEAP32[gb + 121636 >> 2] = (HEAP32[gb + 121636 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 121640 >> 2] = (HEAP32[gb + 121640 >> 2] | 0) + (gb + 767061 | 0);
 HEAP32[gb + 121668 >> 2] = (HEAP32[gb + 121668 >> 2] | 0) + (gb + 774405 | 0);
 HEAP32[gb + 121672 >> 2] = (HEAP32[gb + 121672 >> 2] | 0) + (gb + 932511 | 0);
 HEAP32[gb + 121700 >> 2] = (HEAP32[gb + 121700 >> 2] | 0) + (gb + 754270 | 0);
 HEAP32[gb + 121732 >> 2] = (HEAP32[gb + 121732 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121736 >> 2] = (HEAP32[gb + 121736 >> 2] | 0) + (gb + 754249 | 0);
 HEAP32[gb + 121764 >> 2] = (HEAP32[gb + 121764 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121768 >> 2] = (HEAP32[gb + 121768 >> 2] | 0) + (gb + 754226 | 0);
 HEAP32[gb + 121796 >> 2] = (HEAP32[gb + 121796 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121800 >> 2] = (HEAP32[gb + 121800 >> 2] | 0) + (gb + 754216 | 0);
 HEAP32[gb + 121828 >> 2] = (HEAP32[gb + 121828 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121832 >> 2] = (HEAP32[gb + 121832 >> 2] | 0) + (gb + 754201 | 0);
 HEAP32[gb + 121860 >> 2] = (HEAP32[gb + 121860 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121864 >> 2] = (HEAP32[gb + 121864 >> 2] | 0) + (gb + 754190 | 0);
 HEAP32[gb + 121892 >> 2] = (HEAP32[gb + 121892 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 121896 >> 2] = (HEAP32[gb + 121896 >> 2] | 0) + (gb + 1040342 | 0);
 HEAP32[gb + 121924 >> 2] = (HEAP32[gb + 121924 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 121928 >> 2] = (HEAP32[gb + 121928 >> 2] | 0) + (gb + 754165 | 0);
 HEAP32[gb + 121956 >> 2] = (HEAP32[gb + 121956 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121960 >> 2] = (HEAP32[gb + 121960 >> 2] | 0) + (gb + 754153 | 0);
 HEAP32[gb + 121988 >> 2] = (HEAP32[gb + 121988 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121992 >> 2] = (HEAP32[gb + 121992 >> 2] | 0) + (gb + 754137 | 0);
 HEAP32[gb + 122020 >> 2] = (HEAP32[gb + 122020 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122024 >> 2] = (HEAP32[gb + 122024 >> 2] | 0) + (gb + 754122 | 0);
 HEAP32[gb + 122052 >> 2] = (HEAP32[gb + 122052 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122056 >> 2] = (HEAP32[gb + 122056 >> 2] | 0) + (gb + 754110 | 0);
 HEAP32[gb + 122084 >> 2] = (HEAP32[gb + 122084 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122088 >> 2] = (HEAP32[gb + 122088 >> 2] | 0) + (gb + 1048298 | 0);
 HEAP32[gb + 122116 >> 2] = (HEAP32[gb + 122116 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122120 >> 2] = (HEAP32[gb + 122120 >> 2] | 0) + (gb + 754100 | 0);
 HEAP32[gb + 122148 >> 2] = (HEAP32[gb + 122148 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122152 >> 2] = (HEAP32[gb + 122152 >> 2] | 0) + (gb + 754082 | 0);
 HEAP32[gb + 122180 >> 2] = (HEAP32[gb + 122180 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122184 >> 2] = (HEAP32[gb + 122184 >> 2] | 0) + (gb + 754071 | 0);
 HEAP32[gb + 122212 >> 2] = (HEAP32[gb + 122212 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 122216 >> 2] = (HEAP32[gb + 122216 >> 2] | 0) + (gb + 754057 | 0);
 HEAP32[gb + 122244 >> 2] = (HEAP32[gb + 122244 >> 2] | 0) + (gb + 754033 | 0);
 HEAP32[gb + 122248 >> 2] = (HEAP32[gb + 122248 >> 2] | 0) + (gb + 754041 | 0);
 HEAP32[gb + 122276 >> 2] = (HEAP32[gb + 122276 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 122280 >> 2] = (HEAP32[gb + 122280 >> 2] | 0) + (gb + 754011 | 0);
 HEAP32[gb + 122308 >> 2] = (HEAP32[gb + 122308 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 122312 >> 2] = (HEAP32[gb + 122312 >> 2] | 0) + (gb + 753998 | 0);
 HEAP32[gb + 122340 >> 2] = (HEAP32[gb + 122340 >> 2] | 0) + (gb + 747491 | 0);
 HEAP32[gb + 122372 >> 2] = (HEAP32[gb + 122372 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 122376 >> 2] = (HEAP32[gb + 122376 >> 2] | 0) + (gb + 828662 | 0);
 HEAP32[gb + 122404 >> 2] = (HEAP32[gb + 122404 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 122408 >> 2] = (HEAP32[gb + 122408 >> 2] | 0) + (gb + 747203 | 0);
 HEAP32[gb + 122436 >> 2] = (HEAP32[gb + 122436 >> 2] | 0) + (gb + 827530 | 0);
 HEAP32[gb + 122440 >> 2] = (HEAP32[gb + 122440 >> 2] | 0) + (gb + 747503 | 0);
 HEAP32[gb + 122468 >> 2] = (HEAP32[gb + 122468 >> 2] | 0) + (gb + 747259 | 0);
 HEAP32[gb + 122500 >> 2] = (HEAP32[gb + 122500 >> 2] | 0) + (gb + 747491 | 0);
 HEAP32[gb + 122504 >> 2] = (HEAP32[gb + 122504 >> 2] | 0) + (gb + 747212 | 0);
 HEAP32[gb + 122532 >> 2] = (HEAP32[gb + 122532 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 122536 >> 2] = (HEAP32[gb + 122536 >> 2] | 0) + (gb + 754422 | 0);
 HEAP32[gb + 122564 >> 2] = (HEAP32[gb + 122564 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 122568 >> 2] = (HEAP32[gb + 122568 >> 2] | 0) + (gb + 747203 | 0);
 HEAP32[gb + 122596 >> 2] = (HEAP32[gb + 122596 >> 2] | 0) + (gb + 747491 | 0);
 HEAP32[gb + 122600 >> 2] = (HEAP32[gb + 122600 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 122628 >> 2] = (HEAP32[gb + 122628 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 122632 >> 2] = (HEAP32[gb + 122632 >> 2] | 0) + (gb + 747197 | 0);
 HEAP32[gb + 122660 >> 2] = (HEAP32[gb + 122660 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 122664 >> 2] = (HEAP32[gb + 122664 >> 2] | 0) + (gb + 747187 | 0);
 HEAP32[gb + 122692 >> 2] = (HEAP32[gb + 122692 >> 2] | 0) + (gb + 747491 | 0);
 HEAP32[gb + 122724 >> 2] = (HEAP32[gb + 122724 >> 2] | 0) + (gb + 747076 | 0);
 HEAP32[gb + 122756 >> 2] = (HEAP32[gb + 122756 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 122760 >> 2] = (HEAP32[gb + 122760 >> 2] | 0) + (gb + 747335 | 0);
 HEAP32[gb + 122788 >> 2] = (HEAP32[gb + 122788 >> 2] | 0) + (gb + 747259 | 0);
 HEAP32[gb + 122792 >> 2] = (HEAP32[gb + 122792 >> 2] | 0) + (gb + 747475 | 0);
 HEAP32[gb + 122820 >> 2] = (HEAP32[gb + 122820 >> 2] | 0) + (gb + 754681 | 0);
 HEAP32[gb + 122852 >> 2] = (HEAP32[gb + 122852 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 122856 >> 2] = (HEAP32[gb + 122856 >> 2] | 0) + (gb + 747466 | 0);
 HEAP32[gb + 122884 >> 2] = (HEAP32[gb + 122884 >> 2] | 0) + (gb + 751640 | 0);
 HEAP32[gb + 122888 >> 2] = (HEAP32[gb + 122888 >> 2] | 0) + (gb + 747456 | 0);
 HEAP32[gb + 122916 >> 2] = (HEAP32[gb + 122916 >> 2] | 0) + (gb + 754692 | 0);
 HEAP32[gb + 122948 >> 2] = (HEAP32[gb + 122948 >> 2] | 0) + (gb + 833471 | 0);
 HEAP32[gb + 122952 >> 2] = (HEAP32[gb + 122952 >> 2] | 0) + (gb + 747394 | 0);
 HEAP32[gb + 122980 >> 2] = (HEAP32[gb + 122980 >> 2] | 0) + (gb + 833471 | 0);
 HEAP32[gb + 122984 >> 2] = (HEAP32[gb + 122984 >> 2] | 0) + (gb + 747386 | 0);
 HEAP32[gb + 123012 >> 2] = (HEAP32[gb + 123012 >> 2] | 0) + (gb + 747864 | 0);
 HEAP32[gb + 123016 >> 2] = (HEAP32[gb + 123016 >> 2] | 0) + (gb + 829255 | 0);
 HEAP32[gb + 123044 >> 2] = (HEAP32[gb + 123044 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 123048 >> 2] = (HEAP32[gb + 123048 >> 2] | 0) + (gb + 747377 | 0);
 HEAP32[gb + 123076 >> 2] = (HEAP32[gb + 123076 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 123080 >> 2] = (HEAP32[gb + 123080 >> 2] | 0) + (gb + 747360 | 0);
 HEAP32[gb + 123108 >> 2] = (HEAP32[gb + 123108 >> 2] | 0) + (gb + 754717 | 0);
 runPostSets139();
}

function runPostSets240() {
 HEAP32[gb + 214284 >> 2] = fb + 3187;
 HEAP32[gb + 214288 >> 2] = fb + 1413;
 HEAP32[gb + 12832 >> 2] = (HEAP32[gb + 12832 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12836 >> 2] = (HEAP32[gb + 12836 >> 2] | 0) + (gb + 1082634 | 0);
 HEAP32[gb + 12840 >> 2] = (HEAP32[gb + 12840 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 214292 >> 2] = (HEAP32[gb + 214292 >> 2] | 0) + (gb + 1083659 | 0);
 HEAP32[gb + 214300 >> 2] = (HEAP32[gb + 214300 >> 2] | 0) + (gb + 1083661 | 0);
 HEAP32[gb + 214308 >> 2] = (HEAP32[gb + 214308 >> 2] | 0) + (gb + 1083663 | 0);
 HEAP32[gb + 214316 >> 2] = (HEAP32[gb + 214316 >> 2] | 0) + (gb + 1083665 | 0);
 HEAP32[gb + 214324 >> 2] = (HEAP32[gb + 214324 >> 2] | 0) + (gb + 1083667 | 0);
 HEAP32[gb + 214332 >> 2] = (HEAP32[gb + 214332 >> 2] | 0) + (gb + 1083669 | 0);
 HEAP32[gb + 214340 >> 2] = (HEAP32[gb + 214340 >> 2] | 0) + (gb + 1083671 | 0);
 HEAP32[gb + 214348 >> 2] = (HEAP32[gb + 214348 >> 2] | 0) + (gb + 1083673 | 0);
 HEAP32[gb + 214356 >> 2] = (HEAP32[gb + 214356 >> 2] | 0) + (gb + 1083675 | 0);
 HEAP32[gb + 214364 >> 2] = (HEAP32[gb + 214364 >> 2] | 0) + (gb + 1083677 | 0);
 HEAP32[gb + 214372 >> 2] = (HEAP32[gb + 214372 >> 2] | 0) + (gb + 1083679 | 0);
 HEAP32[gb + 214380 >> 2] = (HEAP32[gb + 214380 >> 2] | 0) + (gb + 1083681 | 0);
 HEAP32[gb + 214388 >> 2] = (HEAP32[gb + 214388 >> 2] | 0) + (gb + 1083683 | 0);
 HEAP32[gb + 214396 >> 2] = (HEAP32[gb + 214396 >> 2] | 0) + (gb + 1083685 | 0);
 HEAP32[gb + 214404 >> 2] = (HEAP32[gb + 214404 >> 2] | 0) + (gb + 1083687 | 0);
 HEAP32[gb + 214412 >> 2] = (HEAP32[gb + 214412 >> 2] | 0) + (gb + 1083691 | 0);
 HEAP32[gb + 214420 >> 2] = (HEAP32[gb + 214420 >> 2] | 0) + (gb + 1083693 | 0);
 HEAP32[gb + 214428 >> 2] = (HEAP32[gb + 214428 >> 2] | 0) + (gb + 1083695 | 0);
 HEAP32[gb + 214436 >> 2] = (HEAP32[gb + 214436 >> 2] | 0) + (gb + 1083697 | 0);
 HEAP32[gb + 214444 >> 2] = (HEAP32[gb + 214444 >> 2] | 0) + (gb + 1083699 | 0);
 HEAP32[gb + 214452 >> 2] = (HEAP32[gb + 214452 >> 2] | 0) + (gb + 1083701 | 0);
 HEAP32[gb + 214460 >> 2] = (HEAP32[gb + 214460 >> 2] | 0) + (gb + 1083703 | 0);
 HEAP32[gb + 214468 >> 2] = (HEAP32[gb + 214468 >> 2] | 0) + (gb + 1083705 | 0);
 HEAP32[gb + 214476 >> 2] = (HEAP32[gb + 214476 >> 2] | 0) + (gb + 1083707 | 0);
 HEAP32[gb + 214484 >> 2] = (HEAP32[gb + 214484 >> 2] | 0) + (gb + 1083709 | 0);
 HEAP32[gb + 214492 >> 2] = (HEAP32[gb + 214492 >> 2] | 0) + (gb + 1083711 | 0);
 HEAP32[gb + 214500 >> 2] = (HEAP32[gb + 214500 >> 2] | 0) + (gb + 1083713 | 0);
 HEAP32[gb + 214508 >> 2] = (HEAP32[gb + 214508 >> 2] | 0) + (gb + 1085926 | 0);
 HEAP32[gb + 214516 >> 2] = (HEAP32[gb + 214516 >> 2] | 0) + (gb + 1083715 | 0);
 HEAP32[gb + 214524 >> 2] = (HEAP32[gb + 214524 >> 2] | 0) + (gb + 1083721 | 0);
 HEAP32[gb + 214532 >> 2] = (HEAP32[gb + 214532 >> 2] | 0) + (gb + 1083731 | 0);
 HEAP32[gb + 214540 >> 2] = (HEAP32[gb + 214540 >> 2] | 0) + (gb + 1083742 | 0);
 HEAP32[gb + 214548 >> 2] = (HEAP32[gb + 214548 >> 2] | 0) + (gb + 1085890 | 0);
 HEAP32[gb + 214556 >> 2] = (HEAP32[gb + 214556 >> 2] | 0) + (gb + 1083751 | 0);
 HEAP32[gb + 214564 >> 2] = (HEAP32[gb + 214564 >> 2] | 0) + (gb + 1083761 | 0);
 HEAP32[gb + 214572 >> 2] = (HEAP32[gb + 214572 >> 2] | 0) + (gb + 1085908 | 0);
 HEAP32[gb + 214580 >> 2] = (HEAP32[gb + 214580 >> 2] | 0) + (gb + 1083771 | 0);
 HEAP32[gb + 214588 >> 2] = (HEAP32[gb + 214588 >> 2] | 0) + (gb + 1083787 | 0);
 HEAP32[gb + 214596 >> 2] = (HEAP32[gb + 214596 >> 2] | 0) + (gb + 1083798 | 0);
 HEAP32[gb + 214604 >> 2] = (HEAP32[gb + 214604 >> 2] | 0) + (gb + 1083816 | 0);
 HEAP32[gb + 214612 >> 2] = (HEAP32[gb + 214612 >> 2] | 0) + (gb + 1083822 | 0);
 HEAP32[gb + 214620 >> 2] = (HEAP32[gb + 214620 >> 2] | 0) + (gb + 1083828 | 0);
 HEAP32[gb + 214628 >> 2] = (HEAP32[gb + 214628 >> 2] | 0) + (gb + 1086046 | 0);
 HEAP32[gb + 214636 >> 2] = (HEAP32[gb + 214636 >> 2] | 0) + (gb + 1083842 | 0);
 HEAP32[gb + 214644 >> 2] = (HEAP32[gb + 214644 >> 2] | 0) + (gb + 1086055 | 0);
 HEAP32[gb + 214652 >> 2] = (HEAP32[gb + 214652 >> 2] | 0) + (gb + 1083854 | 0);
 HEAP32[gb + 214660 >> 2] = (HEAP32[gb + 214660 >> 2] | 0) + (gb + 1083860 | 0);
 HEAP32[gb + 214668 >> 2] = (HEAP32[gb + 214668 >> 2] | 0) + (gb + 1083872 | 0);
 HEAP32[gb + 214676 >> 2] = (HEAP32[gb + 214676 >> 2] | 0) + (gb + 1086037 | 0);
 HEAP32[gb + 214684 >> 2] = (HEAP32[gb + 214684 >> 2] | 0) + (gb + 1083889 | 0);
 HEAP32[gb + 214692 >> 2] = (HEAP32[gb + 214692 >> 2] | 0) + (gb + 1083894 | 0);
 HEAP32[gb + 214700 >> 2] = (HEAP32[gb + 214700 >> 2] | 0) + (gb + 1083904 | 0);
 HEAP32[gb + 214708 >> 2] = (HEAP32[gb + 214708 >> 2] | 0) + (gb + 1083909 | 0);
 HEAP32[gb + 214716 >> 2] = (HEAP32[gb + 214716 >> 2] | 0) + (gb + 1086064 | 0);
 HEAP32[gb + 214724 >> 2] = (HEAP32[gb + 214724 >> 2] | 0) + (gb + 1083919 | 0);
 HEAP32[gb + 214732 >> 2] = (HEAP32[gb + 214732 >> 2] | 0) + (gb + 1083932 | 0);
 HEAP32[gb + 214740 >> 2] = (HEAP32[gb + 214740 >> 2] | 0) + (gb + 1085917 | 0);
 HEAP32[gb + 214748 >> 2] = (HEAP32[gb + 214748 >> 2] | 0) + (gb + 1083950 | 0);
 HEAP32[gb + 214756 >> 2] = (HEAP32[gb + 214756 >> 2] | 0) + (gb + 1083957 | 0);
 HEAP32[gb + 214764 >> 2] = (HEAP32[gb + 214764 >> 2] | 0) + (gb + 1085953 | 0);
 HEAP32[gb + 214772 >> 2] = (HEAP32[gb + 214772 >> 2] | 0) + (gb + 1085962 | 0);
 HEAP32[gb + 214780 >> 2] = (HEAP32[gb + 214780 >> 2] | 0) + (gb + 1083970 | 0);
 HEAP32[gb + 214788 >> 2] = (HEAP32[gb + 214788 >> 2] | 0) + (gb + 1085971 | 0);
 HEAP32[gb + 214796 >> 2] = (HEAP32[gb + 214796 >> 2] | 0) + (gb + 1083972 | 0);
 HEAP32[gb + 214804 >> 2] = (HEAP32[gb + 214804 >> 2] | 0) + (gb + 1083983 | 0);
 HEAP32[gb + 214812 >> 2] = (HEAP32[gb + 214812 >> 2] | 0) + (gb + 1084002 | 0);
 HEAP32[gb + 214820 >> 2] = (HEAP32[gb + 214820 >> 2] | 0) + (gb + 1084019 | 0);
 HEAP32[gb + 214828 >> 2] = (HEAP32[gb + 214828 >> 2] | 0) + (gb + 1084039 | 0);
 HEAP32[gb + 214836 >> 2] = (HEAP32[gb + 214836 >> 2] | 0) + (gb + 1084054 | 0);
 HEAP32[gb + 214844 >> 2] = (HEAP32[gb + 214844 >> 2] | 0) + (gb + 1085980 | 0);
 HEAP32[gb + 214852 >> 2] = (HEAP32[gb + 214852 >> 2] | 0) + (gb + 1086007 | 0);
 HEAP32[gb + 214860 >> 2] = (HEAP32[gb + 214860 >> 2] | 0) + (gb + 1084063 | 0);
 HEAP32[gb + 214868 >> 2] = (HEAP32[gb + 214868 >> 2] | 0) + (gb + 1084071 | 0);
 HEAP32[gb + 214876 >> 2] = (HEAP32[gb + 214876 >> 2] | 0) + (gb + 1084076 | 0);
 HEAP32[gb + 214884 >> 2] = (HEAP32[gb + 214884 >> 2] | 0) + (gb + 1086016 | 0);
 HEAP32[gb + 214892 >> 2] = (HEAP32[gb + 214892 >> 2] | 0) + (gb + 1084088 | 0);
 HEAP32[gb + 214900 >> 2] = (HEAP32[gb + 214900 >> 2] | 0) + (gb + 1084092 | 0);
 HEAP32[gb + 214908 >> 2] = (HEAP32[gb + 214908 >> 2] | 0) + (gb + 1084094 | 0);
 HEAP32[gb + 214916 >> 2] = (HEAP32[gb + 214916 >> 2] | 0) + (gb + 1084107 | 0);
 HEAP32[gb + 214924 >> 2] = (HEAP32[gb + 214924 >> 2] | 0) + (gb + 1084114 | 0);
 HEAP32[gb + 214932 >> 2] = (HEAP32[gb + 214932 >> 2] | 0) + (gb + 1084124 | 0);
 HEAP32[gb + 214940 >> 2] = (HEAP32[gb + 214940 >> 2] | 0) + (gb + 1084126 | 0);
 HEAP32[gb + 214948 >> 2] = (HEAP32[gb + 214948 >> 2] | 0) + (gb + 1084140 | 0);
 HEAP32[gb + 214956 >> 2] = (HEAP32[gb + 214956 >> 2] | 0) + (gb + 1084155 | 0);
 HEAP32[gb + 214964 >> 2] = (HEAP32[gb + 214964 >> 2] | 0) + (gb + 1084157 | 0);
 HEAP32[gb + 214972 >> 2] = (HEAP32[gb + 214972 >> 2] | 0) + (gb + 1084173 | 0);
 HEAP32[gb + 214980 >> 2] = (HEAP32[gb + 214980 >> 2] | 0) + (gb + 1084185 | 0);
 HEAP32[gb + 214988 >> 2] = (HEAP32[gb + 214988 >> 2] | 0) + (gb + 1084205 | 0);
 HEAP32[gb + 214996 >> 2] = (HEAP32[gb + 214996 >> 2] | 0) + (gb + 1084223 | 0);
 HEAP32[gb + 215004 >> 2] = (HEAP32[gb + 215004 >> 2] | 0) + (gb + 1085935 | 0);
 HEAP32[gb + 215012 >> 2] = (HEAP32[gb + 215012 >> 2] | 0) + (gb + 1084244 | 0);
 HEAP32[gb + 215020 >> 2] = (HEAP32[gb + 215020 >> 2] | 0) + (gb + 1084254 | 0);
 HEAP32[gb + 215028 >> 2] = (HEAP32[gb + 215028 >> 2] | 0) + (gb + 1084260 | 0);
 HEAP32[gb + 215036 >> 2] = (HEAP32[gb + 215036 >> 2] | 0) + (gb + 1084264 | 0);
 HEAP32[gb + 215044 >> 2] = (HEAP32[gb + 215044 >> 2] | 0) + (gb + 1084270 | 0);
 runPostSets241();
}

function runPostSets139() {
 HEAP32[gb + 123140 >> 2] = (HEAP32[gb + 123140 >> 2] | 0) + (gb + 747791 | 0);
 HEAP32[gb + 123144 >> 2] = (HEAP32[gb + 123144 >> 2] | 0) + (gb + 747850 | 0);
 HEAP32[gb + 123172 >> 2] = (HEAP32[gb + 123172 >> 2] | 0) + (gb + 747220 | 0);
 HEAP32[gb + 123176 >> 2] = (HEAP32[gb + 123176 >> 2] | 0) + (gb + 747341 | 0);
 HEAP32[gb + 123204 >> 2] = (HEAP32[gb + 123204 >> 2] | 0) + (gb + 754705 | 0);
 HEAP32[gb + 123208 >> 2] = (HEAP32[gb + 123208 >> 2] | 0) + (gb + 747137 | 0);
 HEAP32[gb + 123236 >> 2] = (HEAP32[gb + 123236 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 123240 >> 2] = (HEAP32[gb + 123240 >> 2] | 0) + (gb + 747335 | 0);
 HEAP32[gb + 123268 >> 2] = (HEAP32[gb + 123268 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 123272 >> 2] = (HEAP32[gb + 123272 >> 2] | 0) + (gb + 774868 | 0);
 HEAP32[gb + 123300 >> 2] = (HEAP32[gb + 123300 >> 2] | 0) + (gb + 754751 | 0);
 HEAP32[gb + 123332 >> 2] = (HEAP32[gb + 123332 >> 2] | 0) + (gb + 747761 | 0);
 HEAP32[gb + 123336 >> 2] = (HEAP32[gb + 123336 >> 2] | 0) + (gb + 747784 | 0);
 HEAP32[gb + 123364 >> 2] = (HEAP32[gb + 123364 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 123368 >> 2] = (HEAP32[gb + 123368 >> 2] | 0) + (gb + 747251 | 0);
 HEAP32[gb + 123396 >> 2] = (HEAP32[gb + 123396 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 123400 >> 2] = (HEAP32[gb + 123400 >> 2] | 0) + (gb + 747244 | 0);
 HEAP32[gb + 123428 >> 2] = (HEAP32[gb + 123428 >> 2] | 0) + (gb + 747220 | 0);
 HEAP32[gb + 123460 >> 2] = (HEAP32[gb + 123460 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 123464 >> 2] = (HEAP32[gb + 123464 >> 2] | 0) + (gb + 747212 | 0);
 HEAP32[gb + 123492 >> 2] = (HEAP32[gb + 123492 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 123496 >> 2] = (HEAP32[gb + 123496 >> 2] | 0) + (gb + 754422 | 0);
 HEAP32[gb + 123524 >> 2] = (HEAP32[gb + 123524 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 123528 >> 2] = (HEAP32[gb + 123528 >> 2] | 0) + (gb + 747203 | 0);
 HEAP32[gb + 123556 >> 2] = (HEAP32[gb + 123556 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 123560 >> 2] = (HEAP32[gb + 123560 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 123588 >> 2] = (HEAP32[gb + 123588 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 123592 >> 2] = (HEAP32[gb + 123592 >> 2] | 0) + (gb + 747197 | 0);
 HEAP32[gb + 123620 >> 2] = (HEAP32[gb + 123620 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 123624 >> 2] = (HEAP32[gb + 123624 >> 2] | 0) + (gb + 747187 | 0);
 HEAP32[gb + 123652 >> 2] = (HEAP32[gb + 123652 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 123684 >> 2] = (HEAP32[gb + 123684 >> 2] | 0) + (gb + 747172 | 0);
 HEAP32[gb + 123716 >> 2] = (HEAP32[gb + 123716 >> 2] | 0) + (gb + 754461 | 0);
 HEAP32[gb + 123720 >> 2] = (HEAP32[gb + 123720 >> 2] | 0) + (gb + 747164 | 0);
 HEAP32[gb + 123748 >> 2] = (HEAP32[gb + 123748 >> 2] | 0) + (gb + 754461 | 0);
 HEAP32[gb + 123752 >> 2] = (HEAP32[gb + 123752 >> 2] | 0) + (gb + 747148 | 0);
 HEAP32[gb + 123780 >> 2] = (HEAP32[gb + 123780 >> 2] | 0) + (gb + 754705 | 0);
 HEAP32[gb + 123812 >> 2] = (HEAP32[gb + 123812 >> 2] | 0) + (gb + 747685 | 0);
 HEAP32[gb + 123816 >> 2] = (HEAP32[gb + 123816 >> 2] | 0) + (gb + 747137 | 0);
 HEAP32[gb + 123844 >> 2] = (HEAP32[gb + 123844 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 123848 >> 2] = (HEAP32[gb + 123848 >> 2] | 0) + (gb + 747127 | 0);
 HEAP32[gb + 123876 >> 2] = (HEAP32[gb + 123876 >> 2] | 0) + (gb + 747111 | 0);
 HEAP32[gb + 123880 >> 2] = (HEAP32[gb + 123880 >> 2] | 0) + (gb + 747119 | 0);
 HEAP32[gb + 123908 >> 2] = (HEAP32[gb + 123908 >> 2] | 0) + (gb + 747111 | 0);
 HEAP32[gb + 123940 >> 2] = (HEAP32[gb + 123940 >> 2] | 0) + (gb + 754779 | 0);
 HEAP32[gb + 123972 >> 2] = (HEAP32[gb + 123972 >> 2] | 0) + (gb + 748703 | 0);
 HEAP32[gb + 123976 >> 2] = (HEAP32[gb + 123976 >> 2] | 0) + (gb + 748723 | 0);
 HEAP32[gb + 124004 >> 2] = (HEAP32[gb + 124004 >> 2] | 0) + (gb + 754771 | 0);
 HEAP32[gb + 124036 >> 2] = (HEAP32[gb + 124036 >> 2] | 0) + (gb + 747667 | 0);
 HEAP32[gb + 124040 >> 2] = (HEAP32[gb + 124040 >> 2] | 0) + (gb + 747678 | 0);
 HEAP32[gb + 124068 >> 2] = (HEAP32[gb + 124068 >> 2] | 0) + (gb + 754779 | 0);
 HEAP32[gb + 124072 >> 2] = (HEAP32[gb + 124072 >> 2] | 0) + (gb + 747098 | 0);
 HEAP32[gb + 124100 >> 2] = (HEAP32[gb + 124100 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 124104 >> 2] = (HEAP32[gb + 124104 >> 2] | 0) + (gb + 747084 | 0);
 HEAP32[gb + 124132 >> 2] = (HEAP32[gb + 124132 >> 2] | 0) + (gb + 754793 | 0);
 HEAP32[gb + 124164 >> 2] = (HEAP32[gb + 124164 >> 2] | 0) + (gb + 747511 | 0);
 HEAP32[gb + 124168 >> 2] = (HEAP32[gb + 124168 >> 2] | 0) + (gb + 747636 | 0);
 HEAP32[gb + 124196 >> 2] = (HEAP32[gb + 124196 >> 2] | 0) + (gb + 754810 | 0);
 HEAP32[gb + 124228 >> 2] = (HEAP32[gb + 124228 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 124260 >> 2] = (HEAP32[gb + 124260 >> 2] | 0) + (gb + 747172 | 0);
 HEAP32[gb + 124264 >> 2] = (HEAP32[gb + 124264 >> 2] | 0) + (gb + 747321 | 0);
 HEAP32[gb + 124292 >> 2] = (HEAP32[gb + 124292 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 124296 >> 2] = (HEAP32[gb + 124296 >> 2] | 0) + (gb + 747314 | 0);
 HEAP32[gb + 124324 >> 2] = (HEAP32[gb + 124324 >> 2] | 0) + (gb + 747941 | 0);
 HEAP32[gb + 124328 >> 2] = (HEAP32[gb + 124328 >> 2] | 0) + (gb + 747308 | 0);
 HEAP32[gb + 124356 >> 2] = (HEAP32[gb + 124356 >> 2] | 0) + (gb + 754717 | 0);
 HEAP32[gb + 124360 >> 2] = (HEAP32[gb + 124360 >> 2] | 0) + (gb + 747302 | 0);
 HEAP32[gb + 124388 >> 2] = (HEAP32[gb + 124388 >> 2] | 0) + (gb + 754751 | 0);
 HEAP32[gb + 124392 >> 2] = (HEAP32[gb + 124392 >> 2] | 0) + (gb + 747288 | 0);
 HEAP32[gb + 124420 >> 2] = (HEAP32[gb + 124420 >> 2] | 0) + (gb + 754732 | 0);
 HEAP32[gb + 124424 >> 2] = (HEAP32[gb + 124424 >> 2] | 0) + (gb + 747251 | 0);
 HEAP32[gb + 124452 >> 2] = (HEAP32[gb + 124452 >> 2] | 0) + (gb + 747220 | 0);
 HEAP32[gb + 124456 >> 2] = (HEAP32[gb + 124456 >> 2] | 0) + (gb + 747276 | 0);
 HEAP32[gb + 124484 >> 2] = (HEAP32[gb + 124484 >> 2] | 0) + (gb + 747259 | 0);
 HEAP32[gb + 124516 >> 2] = (HEAP32[gb + 124516 >> 2] | 0) + (gb + 747402 | 0);
 HEAP32[gb + 124520 >> 2] = (HEAP32[gb + 124520 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 124548 >> 2] = (HEAP32[gb + 124548 >> 2] | 0) + (gb + 754673 | 0);
 HEAP32[gb + 124580 >> 2] = (HEAP32[gb + 124580 >> 2] | 0) + (gb + 833471 | 0);
 HEAP32[gb + 124584 >> 2] = (HEAP32[gb + 124584 >> 2] | 0) + (gb + 828947 | 0);
 HEAP32[gb + 124612 >> 2] = (HEAP32[gb + 124612 >> 2] | 0) + (gb + 747923 | 0);
 HEAP32[gb + 124616 >> 2] = (HEAP32[gb + 124616 >> 2] | 0) + (gb + 747934 | 0);
 HEAP32[gb + 124644 >> 2] = (HEAP32[gb + 124644 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 124648 >> 2] = (HEAP32[gb + 124648 >> 2] | 0) + (gb + 747335 | 0);
 HEAP32[gb + 124676 >> 2] = (HEAP32[gb + 124676 >> 2] | 0) + (gb + 747402 | 0);
 HEAP32[gb + 124680 >> 2] = (HEAP32[gb + 124680 >> 2] | 0) + (gb + 747423 | 0);
 HEAP32[gb + 124708 >> 2] = (HEAP32[gb + 124708 >> 2] | 0) + (gb + 754659 | 0);
 HEAP32[gb + 124740 >> 2] = (HEAP32[gb + 124740 >> 2] | 0) + (gb + 748057 | 0);
 HEAP32[gb + 124744 >> 2] = (HEAP32[gb + 124744 >> 2] | 0) + (gb + 747443 | 0);
 HEAP32[gb + 124772 >> 2] = (HEAP32[gb + 124772 >> 2] | 0) + (gb + 754644 | 0);
 HEAP32[gb + 124804 >> 2] = (HEAP32[gb + 124804 >> 2] | 0) + (gb + 747542 | 0);
 HEAP32[gb + 124836 >> 2] = (HEAP32[gb + 124836 >> 2] | 0) + (gb + 754470 | 0);
 HEAP32[gb + 124840 >> 2] = (HEAP32[gb + 124840 >> 2] | 0) + (gb + 747663 | 0);
 HEAP32[gb + 124868 >> 2] = (HEAP32[gb + 124868 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 124872 >> 2] = (HEAP32[gb + 124872 >> 2] | 0) + (gb + 1041262 | 0);
 HEAP32[gb + 124900 >> 2] = (HEAP32[gb + 124900 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 124904 >> 2] = (HEAP32[gb + 124904 >> 2] | 0) + (gb + 747652 | 0);
 HEAP32[gb + 124932 >> 2] = (HEAP32[gb + 124932 >> 2] | 0) + (gb + 747511 | 0);
 HEAP32[gb + 124964 >> 2] = (HEAP32[gb + 124964 >> 2] | 0) + (gb + 748145 | 0);
 HEAP32[gb + 124968 >> 2] = (HEAP32[gb + 124968 >> 2] | 0) + (gb + 747636 | 0);
 HEAP32[gb + 124996 >> 2] = (HEAP32[gb + 124996 >> 2] | 0) + (gb + 747589 | 0);
 runPostSets140();
}

function runPostSets136() {
 HEAP32[gb + 117780 >> 2] = (HEAP32[gb + 117780 >> 2] | 0) + (gb + 744484 | 0);
 HEAP32[gb + 117808 >> 2] = (HEAP32[gb + 117808 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117812 >> 2] = (HEAP32[gb + 117812 >> 2] | 0) + (gb + 744475 | 0);
 HEAP32[gb + 117840 >> 2] = (HEAP32[gb + 117840 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117844 >> 2] = (HEAP32[gb + 117844 >> 2] | 0) + (gb + 744464 | 0);
 HEAP32[gb + 117872 >> 2] = (HEAP32[gb + 117872 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117876 >> 2] = (HEAP32[gb + 117876 >> 2] | 0) + (gb + 744455 | 0);
 HEAP32[gb + 117904 >> 2] = (HEAP32[gb + 117904 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117908 >> 2] = (HEAP32[gb + 117908 >> 2] | 0) + (gb + 744446 | 0);
 HEAP32[gb + 117936 >> 2] = (HEAP32[gb + 117936 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117940 >> 2] = (HEAP32[gb + 117940 >> 2] | 0) + (gb + 744435 | 0);
 HEAP32[gb + 117968 >> 2] = (HEAP32[gb + 117968 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117972 >> 2] = (HEAP32[gb + 117972 >> 2] | 0) + (gb + 744424 | 0);
 HEAP32[gb + 118e3 >> 2] = (HEAP32[gb + 118e3 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118004 >> 2] = (HEAP32[gb + 118004 >> 2] | 0) + (gb + 744412 | 0);
 HEAP32[gb + 118032 >> 2] = (HEAP32[gb + 118032 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118036 >> 2] = (HEAP32[gb + 118036 >> 2] | 0) + (gb + 744401 | 0);
 HEAP32[gb + 118064 >> 2] = (HEAP32[gb + 118064 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118068 >> 2] = (HEAP32[gb + 118068 >> 2] | 0) + (gb + 744387 | 0);
 HEAP32[gb + 118096 >> 2] = (HEAP32[gb + 118096 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118100 >> 2] = (HEAP32[gb + 118100 >> 2] | 0) + (gb + 744035 | 0);
 HEAP32[gb + 118128 >> 2] = (HEAP32[gb + 118128 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118132 >> 2] = (HEAP32[gb + 118132 >> 2] | 0) + (gb + 744008 | 0);
 HEAP32[gb + 118160 >> 2] = (HEAP32[gb + 118160 >> 2] | 0) + (gb + 744345 | 0);
 HEAP32[gb + 118192 >> 2] = (HEAP32[gb + 118192 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 118196 >> 2] = (HEAP32[gb + 118196 >> 2] | 0) + (gb + 744370 | 0);
 HEAP32[gb + 118224 >> 2] = (HEAP32[gb + 118224 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 118228 >> 2] = (HEAP32[gb + 118228 >> 2] | 0) + (gb + 744353 | 0);
 HEAP32[gb + 118256 >> 2] = (HEAP32[gb + 118256 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 118260 >> 2] = (HEAP32[gb + 118260 >> 2] | 0) + (gb + 747203 | 0);
 HEAP32[gb + 118288 >> 2] = (HEAP32[gb + 118288 >> 2] | 0) + (gb + 744333 | 0);
 HEAP32[gb + 118320 >> 2] = (HEAP32[gb + 118320 >> 2] | 0) + (gb + 744703 | 0);
 HEAP32[gb + 118324 >> 2] = (HEAP32[gb + 118324 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 118352 >> 2] = (HEAP32[gb + 118352 >> 2] | 0) + (gb + 744669 | 0);
 HEAP32[gb + 118384 >> 2] = (HEAP32[gb + 118384 >> 2] | 0) + (gb + 744725 | 0);
 HEAP32[gb + 118388 >> 2] = (HEAP32[gb + 118388 >> 2] | 0) + (gb + 744104 | 0);
 HEAP32[gb + 118416 >> 2] = (HEAP32[gb + 118416 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118420 >> 2] = (HEAP32[gb + 118420 >> 2] | 0) + (gb + 744035 | 0);
 HEAP32[gb + 118448 >> 2] = (HEAP32[gb + 118448 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118452 >> 2] = (HEAP32[gb + 118452 >> 2] | 0) + (gb + 744008 | 0);
 HEAP32[gb + 118480 >> 2] = (HEAP32[gb + 118480 >> 2] | 0) + (gb + 744703 | 0);
 HEAP32[gb + 118484 >> 2] = (HEAP32[gb + 118484 >> 2] | 0) + (gb + 743997 | 0);
 HEAP32[gb + 118512 >> 2] = (HEAP32[gb + 118512 >> 2] | 0) + (gb + 744688 | 0);
 HEAP32[gb + 118544 >> 2] = (HEAP32[gb + 118544 >> 2] | 0) + (gb + 744669 | 0);
 HEAP32[gb + 118576 >> 2] = (HEAP32[gb + 118576 >> 2] | 0) + (gb + 744748 | 0);
 HEAP32[gb + 118608 >> 2] = (HEAP32[gb + 118608 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118612 >> 2] = (HEAP32[gb + 118612 >> 2] | 0) + (gb + 744035 | 0);
 HEAP32[gb + 118640 >> 2] = (HEAP32[gb + 118640 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 118644 >> 2] = (HEAP32[gb + 118644 >> 2] | 0) + (gb + 744008 | 0);
 HEAP32[gb + 118672 >> 2] = (HEAP32[gb + 118672 >> 2] | 0) + (gb + 744763 | 0);
 HEAP32[gb + 118704 >> 2] = (HEAP32[gb + 118704 >> 2] | 0) + (gb + 744748 | 0);
 HEAP32[gb + 118736 >> 2] = (HEAP32[gb + 118736 >> 2] | 0) + (gb + 744886 | 0);
 HEAP32[gb + 118740 >> 2] = (HEAP32[gb + 118740 >> 2] | 0) + (gb + 774357 | 0);
 HEAP32[gb + 118768 >> 2] = (HEAP32[gb + 118768 >> 2] | 0) + (gb + 744839 | 0);
 HEAP32[gb + 118772 >> 2] = (HEAP32[gb + 118772 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 118800 >> 2] = (HEAP32[gb + 118800 >> 2] | 0) + (gb + 744930 | 0);
 HEAP32[gb + 118832 >> 2] = (HEAP32[gb + 118832 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 118836 >> 2] = (HEAP32[gb + 118836 >> 2] | 0) + (gb + 744923 | 0);
 HEAP32[gb + 118864 >> 2] = (HEAP32[gb + 118864 >> 2] | 0) + (gb + 754342 | 0);
 HEAP32[gb + 118868 >> 2] = (HEAP32[gb + 118868 >> 2] | 0) + (gb + 1047471 | 0);
 HEAP32[gb + 118896 >> 2] = (HEAP32[gb + 118896 >> 2] | 0) + (gb + 744903 | 0);
 HEAP32[gb + 118928 >> 2] = (HEAP32[gb + 118928 >> 2] | 0) + (gb + 744886 | 0);
 HEAP32[gb + 118932 >> 2] = (HEAP32[gb + 118932 >> 2] | 0) + (gb + 1086430 | 0);
 HEAP32[gb + 118960 >> 2] = (HEAP32[gb + 118960 >> 2] | 0) + (gb + 754342 | 0);
 HEAP32[gb + 118964 >> 2] = (HEAP32[gb + 118964 >> 2] | 0) + (gb + 1047471 | 0);
 HEAP32[gb + 118992 >> 2] = (HEAP32[gb + 118992 >> 2] | 0) + (gb + 744866 | 0);
 HEAP32[gb + 119024 >> 2] = (HEAP32[gb + 119024 >> 2] | 0) + (gb + 744839 | 0);
 HEAP32[gb + 119028 >> 2] = (HEAP32[gb + 119028 >> 2] | 0) + (gb + 744857 | 0);
 HEAP32[gb + 119056 >> 2] = (HEAP32[gb + 119056 >> 2] | 0) + (gb + 744814 | 0);
 HEAP32[gb + 119088 >> 2] = (HEAP32[gb + 119088 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 119092 >> 2] = (HEAP32[gb + 119092 >> 2] | 0) + (gb + 744774 | 0);
 HEAP32[gb + 119120 >> 2] = (HEAP32[gb + 119120 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 119124 >> 2] = (HEAP32[gb + 119124 >> 2] | 0) + (gb + 744809 | 0);
 HEAP32[gb + 119152 >> 2] = (HEAP32[gb + 119152 >> 2] | 0) + (gb + 744784 | 0);
 HEAP32[gb + 119184 >> 2] = (HEAP32[gb + 119184 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 119188 >> 2] = (HEAP32[gb + 119188 >> 2] | 0) + (gb + 744774 | 0);
 HEAP32[gb + 119216 >> 2] = (HEAP32[gb + 119216 >> 2] | 0) + (gb + 829211 | 0);
 HEAP32[gb + 119248 >> 2] = (HEAP32[gb + 119248 >> 2] | 0) + (gb + 743927 | 0);
 HEAP32[gb + 119280 >> 2] = (HEAP32[gb + 119280 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 119284 >> 2] = (HEAP32[gb + 119284 >> 2] | 0) + (gb + 745061 | 0);
 HEAP32[gb + 119312 >> 2] = (HEAP32[gb + 119312 >> 2] | 0) + (gb + 754397 | 0);
 HEAP32[gb + 119316 >> 2] = (HEAP32[gb + 119316 >> 2] | 0) + (gb + 745048 | 0);
 HEAP32[gb + 119344 >> 2] = (HEAP32[gb + 119344 >> 2] | 0) + (gb + 745017 | 0);
 HEAP32[gb + 119348 >> 2] = (HEAP32[gb + 119348 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 119376 >> 2] = (HEAP32[gb + 119376 >> 2] | 0) + (gb + 744571 | 0);
 HEAP32[gb + 119408 >> 2] = (HEAP32[gb + 119408 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119412 >> 2] = (HEAP32[gb + 119412 >> 2] | 0) + (gb + 754100 | 0);
 HEAP32[gb + 119440 >> 2] = (HEAP32[gb + 119440 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119444 >> 2] = (HEAP32[gb + 119444 >> 2] | 0) + (gb + 1048298 | 0);
 HEAP32[gb + 119472 >> 2] = (HEAP32[gb + 119472 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119476 >> 2] = (HEAP32[gb + 119476 >> 2] | 0) + (gb + 745037 | 0);
 HEAP32[gb + 119504 >> 2] = (HEAP32[gb + 119504 >> 2] | 0) + (gb + 745017 | 0);
 HEAP32[gb + 119508 >> 2] = (HEAP32[gb + 119508 >> 2] | 0) + (gb + 1040342 | 0);
 HEAP32[gb + 119536 >> 2] = (HEAP32[gb + 119536 >> 2] | 0) + (gb + 744948 | 0);
 HEAP32[gb + 119568 >> 2] = (HEAP32[gb + 119568 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119572 >> 2] = (HEAP32[gb + 119572 >> 2] | 0) + (gb + 754153 | 0);
 HEAP32[gb + 119600 >> 2] = (HEAP32[gb + 119600 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119604 >> 2] = (HEAP32[gb + 119604 >> 2] | 0) + (gb + 745001 | 0);
 HEAP32[gb + 119632 >> 2] = (HEAP32[gb + 119632 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119636 >> 2] = (HEAP32[gb + 119636 >> 2] | 0) + (gb + 754100 | 0);
 runPostSets137();
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i7, i1, i13, i12) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i15 = i14 + 12 | 0;
 HEAP32[i15 >> 2] = i1;
 i5 = HEAP32[i14 >> 2] | 0;
 i6 = i14 + 4 | 0;
 HEAP32[i6 >> 2] = i5;
 i2 = i5 + 1 | 0;
 HEAP32[i14 >> 2] = i2;
 L1 : while (1) {
  i1 = HEAP8[i2 >> 0] | 0;
  L3 : do switch (i1 << 24 >> 24) {
  case 34:
   {
    i3 = 26;
    break L1;
   }
  case 0:
   {
    i3 = 21;
    break L1;
   }
  case 92:
   {
    i4 = i2 + 2 | 0;
    HEAP32[i14 >> 2] = i4;
    i1 = HEAP8[i2 + 1 >> 0] | 0;
    i2 = HEAP8[(i1 & 255) + (gb + 1035343) >> 0] | 0;
    if (i2 << 24 >> 24) {
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i2;
     break L3;
    }
    if (i1 << 24 >> 24 != 117) {
     i3 = 20;
     break L1;
    }
    i3 = __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_25GenericInsituStringStreamIS2_EEEEjRT_(i7, i14) | 0;
    if ((i3 & -1024 | 0) == 55296) {
     i2 = HEAP32[i14 >> 2] | 0;
     i1 = i2 + 1 | 0;
     HEAP32[i14 >> 2] = i1;
     if ((HEAP8[i2 >> 0] | 0) != 92) {
      i3 = 9;
      break L1;
     }
     i2 = i2 + 2 | 0;
     HEAP32[i14 >> 2] = i2;
     if ((HEAP8[i1 >> 0] | 0) != 117) {
      i1 = i2;
      i3 = 9;
      break L1;
     }
     i1 = __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_25GenericInsituStringStreamIS2_EEEEjRT_(i7, i14) | 0;
     if ((i1 & -1024 | 0) != 56320) {
      i3 = 11;
      break L1;
     }
     i1 = (i1 + -56320 | (i3 << 10) + -56623104) + 65536 | 0;
    } else i1 = i3;
    if (i1 >>> 0 < 128) {
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1;
     break L3;
    }
    if (i1 >>> 0 < 2048) {
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 6 | 192;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 & 63 | 128;
     break L3;
    }
    if (i1 >>> 0 < 65536) {
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 12 | 224;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 6 & 63 | 128;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 & 63 | 128;
     break L3;
    } else {
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 18 | 240;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 12 & 63 | 128;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 >>> 6 & 63 | 128;
     i11 = HEAP32[i6 >> 2] | 0;
     HEAP32[i6 >> 2] = i11 + 1;
     HEAP8[i11 >> 0] = i1 & 63 | 128;
     break L3;
    }
   }
  default:
   {
    if ((i1 & 255) < 32) {
     i3 = 23;
     break L1;
    }
    HEAP32[i14 >> 2] = i2 + 1;
    i10 = HEAP8[i2 >> 0] | 0;
    i11 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i11 + 1;
    HEAP8[i11 >> 0] = i10;
   }
  } while (0);
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if ((i3 | 0) == 9) {
  i13 = i1 + -2 - (HEAP32[i14 + 8 >> 2] | 0) | 0;
  HEAP32[i7 + 24 >> 2] = 9;
  HEAP32[i7 + 28 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 11) {
  i13 = (HEAP32[i14 >> 2] | 0) + -2 - (HEAP32[i14 + 8 >> 2] | 0) | 0;
  HEAP32[i7 + 24 >> 2] = 9;
  HEAP32[i7 + 28 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 20) {
  i13 = i4 + -1 - (HEAP32[i14 + 8 >> 2] | 0) | 0;
  HEAP32[i7 + 24 >> 2] = 10;
  HEAP32[i7 + 28 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 21) {
  i13 = i2 + -1 - (HEAP32[i14 + 8 >> 2] | 0) | 0;
  HEAP32[i7 + 24 >> 2] = 11;
  HEAP32[i7 + 28 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 23) {
  i13 = i2 + -1 - (HEAP32[i14 + 8 >> 2] | 0) | 0;
  HEAP32[i7 + 24 >> 2] = 10;
  HEAP32[i7 + 28 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  STACKTOP = i16;
  return;
 } else if ((i3 | 0) == 26) {
  HEAP32[i14 >> 2] = i2 + 1;
  i11 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i11 + 1;
  HEAP8[i11 >> 0] = 0;
  if (HEAP32[i7 + 24 >> 2] | 0) {
   i15 = HEAP32[i15 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   STACKTOP = i16;
   return;
  }
  i11 = i5;
  i9 = (HEAP32[i6 >> 2] | 0) - i11 + -1 | 0;
  i5 = i13 + 28 | 0;
  i10 = i13 + 40 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = i13 + 44 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i2 = (i1 + 24 | 0) >>> 0 < i6 >>> 0;
  i8 = i1;
  if (i12) {
   if (!i2) {
    i2 = i13 + 36 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = i3;
    if (!i3) {
     if (!(HEAP32[i5 >> 2] | 0)) {
      i12 = __Znwj(1) | 0;
      HEAP32[i5 >> 2] = i12;
      HEAP32[i13 + 32 >> 2] = i12;
     }
     i1 = HEAP32[i13 + 48 >> 2] | 0;
    } else {
     i1 = i6 - i4 | 0;
     i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
    }
    i8 = i8 - i4 | 0;
    i13 = i8 + 24 | 0;
    i13 = i1 >>> 0 < i13 >>> 0 ? i13 : i1;
    i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i13, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
    HEAP32[i2 >> 2] = i12;
    i1 = i12 + i8 | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i7 >> 2] = i12 + i13;
   }
   HEAP32[i10 >> 2] = i1 + 24;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 1048581;
   HEAP32[i1 >> 2] = i11;
   HEAP32[i1 + 4 >> 2] = i9;
   i15 = HEAP32[i15 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   STACKTOP = i16;
   return;
  } else {
   if (!i2) {
    i2 = i13 + 36 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = i3;
    if (!i3) {
     if (!(HEAP32[i5 >> 2] | 0)) {
      i12 = __Znwj(1) | 0;
      HEAP32[i5 >> 2] = i12;
      HEAP32[i13 + 32 >> 2] = i12;
     }
     i1 = HEAP32[i13 + 48 >> 2] | 0;
    } else {
     i1 = i6 - i4 | 0;
     i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
    }
    i8 = i8 - i4 | 0;
    i13 = i8 + 24 | 0;
    i13 = i1 >>> 0 < i13 >>> 0 ? i13 : i1;
    i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i13, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
    HEAP32[i2 >> 2] = i12;
    i1 = i12 + i8 | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i7 >> 2] = i12 + i13;
   }
   HEAP32[i10 >> 2] = i1 + 24;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 1048581;
   HEAP32[i1 >> 2] = i11;
   HEAP32[i1 + 4 >> 2] = i9;
   i15 = HEAP32[i15 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   STACKTOP = i16;
   return;
  }
 }
}

function runPostSets141() {
 HEAP32[gb + 126856 >> 2] = (HEAP32[gb + 126856 >> 2] | 0) + (gb + 748386 | 0);
 HEAP32[gb + 126884 >> 2] = (HEAP32[gb + 126884 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 126888 >> 2] = (HEAP32[gb + 126888 >> 2] | 0) + (gb + 748366 | 0);
 HEAP32[gb + 126916 >> 2] = (HEAP32[gb + 126916 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 126920 >> 2] = (HEAP32[gb + 126920 >> 2] | 0) + (gb + 748346 | 0);
 HEAP32[gb + 126948 >> 2] = (HEAP32[gb + 126948 >> 2] | 0) + (gb + 774412 | 0);
 HEAP32[gb + 126952 >> 2] = (HEAP32[gb + 126952 >> 2] | 0) + (gb + 748333 | 0);
 HEAP32[gb + 126980 >> 2] = (HEAP32[gb + 126980 >> 2] | 0) + (gb + 748269 | 0);
 HEAP32[gb + 126984 >> 2] = (HEAP32[gb + 126984 >> 2] | 0) + (gb + 748317 | 0);
 HEAP32[gb + 127012 >> 2] = (HEAP32[gb + 127012 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127016 >> 2] = (HEAP32[gb + 127016 >> 2] | 0) + (gb + 748299 | 0);
 HEAP32[gb + 127044 >> 2] = (HEAP32[gb + 127044 >> 2] | 0) + (gb + 754470 | 0);
 HEAP32[gb + 127048 >> 2] = (HEAP32[gb + 127048 >> 2] | 0) + (gb + 748286 | 0);
 HEAP32[gb + 127076 >> 2] = (HEAP32[gb + 127076 >> 2] | 0) + (gb + 748269 | 0);
 HEAP32[gb + 127108 >> 2] = (HEAP32[gb + 127108 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127140 >> 2] = (HEAP32[gb + 127140 >> 2] | 0) + (gb + 748485 | 0);
 HEAP32[gb + 127172 >> 2] = (HEAP32[gb + 127172 >> 2] | 0) + (gb + 748666 | 0);
 HEAP32[gb + 127176 >> 2] = (HEAP32[gb + 127176 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 127204 >> 2] = (HEAP32[gb + 127204 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 127208 >> 2] = (HEAP32[gb + 127208 >> 2] | 0) + (gb + 748209 | 0);
 HEAP32[gb + 127236 >> 2] = (HEAP32[gb + 127236 >> 2] | 0) + (gb + 748703 | 0);
 HEAP32[gb + 127240 >> 2] = (HEAP32[gb + 127240 >> 2] | 0) + (gb + 748723 | 0);
 HEAP32[gb + 127268 >> 2] = (HEAP32[gb + 127268 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 127272 >> 2] = (HEAP32[gb + 127272 >> 2] | 0) + (gb + 748691 | 0);
 HEAP32[gb + 127300 >> 2] = (HEAP32[gb + 127300 >> 2] | 0) + (gb + 748666 | 0);
 HEAP32[gb + 127304 >> 2] = (HEAP32[gb + 127304 >> 2] | 0) + (gb + 748679 | 0);
 HEAP32[gb + 127332 >> 2] = (HEAP32[gb + 127332 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127336 >> 2] = (HEAP32[gb + 127336 >> 2] | 0) + (gb + 748651 | 0);
 HEAP32[gb + 127364 >> 2] = (HEAP32[gb + 127364 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127368 >> 2] = (HEAP32[gb + 127368 >> 2] | 0) + (gb + 748639 | 0);
 HEAP32[gb + 127396 >> 2] = (HEAP32[gb + 127396 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 127400 >> 2] = (HEAP32[gb + 127400 >> 2] | 0) + (gb + 748623 | 0);
 HEAP32[gb + 127428 >> 2] = (HEAP32[gb + 127428 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 127432 >> 2] = (HEAP32[gb + 127432 >> 2] | 0) + (gb + 748606 | 0);
 HEAP32[gb + 127460 >> 2] = (HEAP32[gb + 127460 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 127464 >> 2] = (HEAP32[gb + 127464 >> 2] | 0) + (gb + 748591 | 0);
 HEAP32[gb + 127492 >> 2] = (HEAP32[gb + 127492 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 127496 >> 2] = (HEAP32[gb + 127496 >> 2] | 0) + (gb + 748574 | 0);
 HEAP32[gb + 127524 >> 2] = (HEAP32[gb + 127524 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 127528 >> 2] = (HEAP32[gb + 127528 >> 2] | 0) + (gb + 748556 | 0);
 HEAP32[gb + 127556 >> 2] = (HEAP32[gb + 127556 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 127560 >> 2] = (HEAP32[gb + 127560 >> 2] | 0) + (gb + 748541 | 0);
 HEAP32[gb + 127588 >> 2] = (HEAP32[gb + 127588 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 127592 >> 2] = (HEAP32[gb + 127592 >> 2] | 0) + (gb + 748531 | 0);
 HEAP32[gb + 127620 >> 2] = (HEAP32[gb + 127620 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 127624 >> 2] = (HEAP32[gb + 127624 >> 2] | 0) + (gb + 748517 | 0);
 HEAP32[gb + 127652 >> 2] = (HEAP32[gb + 127652 >> 2] | 0) + (gb + 748499 | 0);
 HEAP32[gb + 127684 >> 2] = (HEAP32[gb + 127684 >> 2] | 0) + (gb + 748499 | 0);
 HEAP32[gb + 127716 >> 2] = (HEAP32[gb + 127716 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127720 >> 2] = (HEAP32[gb + 127720 >> 2] | 0) + (gb + 750009 | 0);
 HEAP32[gb + 127748 >> 2] = (HEAP32[gb + 127748 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127752 >> 2] = (HEAP32[gb + 127752 >> 2] | 0) + (gb + 749982 | 0);
 HEAP32[gb + 127780 >> 2] = (HEAP32[gb + 127780 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127784 >> 2] = (HEAP32[gb + 127784 >> 2] | 0) + (gb + 749959 | 0);
 HEAP32[gb + 127812 >> 2] = (HEAP32[gb + 127812 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127816 >> 2] = (HEAP32[gb + 127816 >> 2] | 0) + (gb + 749937 | 0);
 HEAP32[gb + 127844 >> 2] = (HEAP32[gb + 127844 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127848 >> 2] = (HEAP32[gb + 127848 >> 2] | 0) + (gb + 749910 | 0);
 HEAP32[gb + 127876 >> 2] = (HEAP32[gb + 127876 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 127880 >> 2] = (HEAP32[gb + 127880 >> 2] | 0) + (gb + 749896 | 0);
 HEAP32[gb + 127908 >> 2] = (HEAP32[gb + 127908 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 127912 >> 2] = (HEAP32[gb + 127912 >> 2] | 0) + (gb + 749887 | 0);
 HEAP32[gb + 127940 >> 2] = (HEAP32[gb + 127940 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127944 >> 2] = (HEAP32[gb + 127944 >> 2] | 0) + (gb + 749877 | 0);
 HEAP32[gb + 127972 >> 2] = (HEAP32[gb + 127972 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 127976 >> 2] = (HEAP32[gb + 127976 >> 2] | 0) + (gb + 749857 | 0);
 HEAP32[gb + 128004 >> 2] = (HEAP32[gb + 128004 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128008 >> 2] = (HEAP32[gb + 128008 >> 2] | 0) + (gb + 749845 | 0);
 HEAP32[gb + 128036 >> 2] = (HEAP32[gb + 128036 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128040 >> 2] = (HEAP32[gb + 128040 >> 2] | 0) + (gb + 749832 | 0);
 HEAP32[gb + 128068 >> 2] = (HEAP32[gb + 128068 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128072 >> 2] = (HEAP32[gb + 128072 >> 2] | 0) + (gb + 749817 | 0);
 HEAP32[gb + 128100 >> 2] = (HEAP32[gb + 128100 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128104 >> 2] = (HEAP32[gb + 128104 >> 2] | 0) + (gb + 749801 | 0);
 HEAP32[gb + 128132 >> 2] = (HEAP32[gb + 128132 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128136 >> 2] = (HEAP32[gb + 128136 >> 2] | 0) + (gb + 749781 | 0);
 HEAP32[gb + 128164 >> 2] = (HEAP32[gb + 128164 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128168 >> 2] = (HEAP32[gb + 128168 >> 2] | 0) + (gb + 749764 | 0);
 HEAP32[gb + 128196 >> 2] = (HEAP32[gb + 128196 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128200 >> 2] = (HEAP32[gb + 128200 >> 2] | 0) + (gb + 749744 | 0);
 HEAP32[gb + 128228 >> 2] = (HEAP32[gb + 128228 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128232 >> 2] = (HEAP32[gb + 128232 >> 2] | 0) + (gb + 749721 | 0);
 HEAP32[gb + 128260 >> 2] = (HEAP32[gb + 128260 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128264 >> 2] = (HEAP32[gb + 128264 >> 2] | 0) + (gb + 749697 | 0);
 HEAP32[gb + 128292 >> 2] = (HEAP32[gb + 128292 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 128296 >> 2] = (HEAP32[gb + 128296 >> 2] | 0) + (gb + 749685 | 0);
 HEAP32[gb + 128324 >> 2] = (HEAP32[gb + 128324 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128328 >> 2] = (HEAP32[gb + 128328 >> 2] | 0) + (gb + 749669 | 0);
 HEAP32[gb + 128356 >> 2] = (HEAP32[gb + 128356 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128360 >> 2] = (HEAP32[gb + 128360 >> 2] | 0) + (gb + 749656 | 0);
 HEAP32[gb + 128388 >> 2] = (HEAP32[gb + 128388 >> 2] | 0) + (gb + 748703 | 0);
 HEAP32[gb + 128420 >> 2] = (HEAP32[gb + 128420 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 128424 >> 2] = (HEAP32[gb + 128424 >> 2] | 0) + (gb + 750133 | 0);
 HEAP32[gb + 128452 >> 2] = (HEAP32[gb + 128452 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 128456 >> 2] = (HEAP32[gb + 128456 >> 2] | 0) + (gb + 750114 | 0);
 HEAP32[gb + 128484 >> 2] = (HEAP32[gb + 128484 >> 2] | 0) + (gb + 750090 | 0);
 HEAP32[gb + 128516 >> 2] = (HEAP32[gb + 128516 >> 2] | 0) + (gb + 750090 | 0);
 HEAP32[gb + 128548 >> 2] = (HEAP32[gb + 128548 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 128552 >> 2] = (HEAP32[gb + 128552 >> 2] | 0) + (gb + 750476 | 0);
 HEAP32[gb + 128580 >> 2] = (HEAP32[gb + 128580 >> 2] | 0) + (gb + 750489 | 0);
 runPostSets142();
}

function runPostSets191() {
 HEAP32[gb + 162032 >> 2] = (HEAP32[gb + 162032 >> 2] | 0) + (gb + 828954 | 0);
 HEAP32[gb + 162036 >> 2] = (HEAP32[gb + 162036 >> 2] | 0) + (gb + 828977 | 0);
 HEAP32[gb + 162064 >> 2] = (HEAP32[gb + 162064 >> 2] | 0) + (gb + 832257 | 0);
 HEAP32[gb + 162068 >> 2] = (HEAP32[gb + 162068 >> 2] | 0) + (gb + 828947 | 0);
 HEAP32[gb + 162096 >> 2] = (HEAP32[gb + 162096 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162100 >> 2] = (HEAP32[gb + 162100 >> 2] | 0) + (gb + 828928 | 0);
 HEAP32[gb + 162128 >> 2] = (HEAP32[gb + 162128 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 162132 >> 2] = (HEAP32[gb + 162132 >> 2] | 0) + (gb + 828900 | 0);
 HEAP32[gb + 162160 >> 2] = (HEAP32[gb + 162160 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 162164 >> 2] = (HEAP32[gb + 162164 >> 2] | 0) + (gb + 828662 | 0);
 HEAP32[gb + 162192 >> 2] = (HEAP32[gb + 162192 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 162196 >> 2] = (HEAP32[gb + 162196 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 162224 >> 2] = (HEAP32[gb + 162224 >> 2] | 0) + (gb + 829056 | 0);
 HEAP32[gb + 162256 >> 2] = (HEAP32[gb + 162256 >> 2] | 0) + (gb + 829193 | 0);
 HEAP32[gb + 162260 >> 2] = (HEAP32[gb + 162260 >> 2] | 0) + (gb + 829199 | 0);
 HEAP32[gb + 162288 >> 2] = (HEAP32[gb + 162288 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162292 >> 2] = (HEAP32[gb + 162292 >> 2] | 0) + (gb + 829185 | 0);
 HEAP32[gb + 162320 >> 2] = (HEAP32[gb + 162320 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162324 >> 2] = (HEAP32[gb + 162324 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 162352 >> 2] = (HEAP32[gb + 162352 >> 2] | 0) + (gb + 828954 | 0);
 HEAP32[gb + 162384 >> 2] = (HEAP32[gb + 162384 >> 2] | 0) + (gb + 829085 | 0);
 HEAP32[gb + 162388 >> 2] = (HEAP32[gb + 162388 >> 2] | 0) + (gb + 829169 | 0);
 HEAP32[gb + 162416 >> 2] = (HEAP32[gb + 162416 >> 2] | 0) + (gb + 829056 | 0);
 HEAP32[gb + 162420 >> 2] = (HEAP32[gb + 162420 >> 2] | 0) + (gb + 829147 | 0);
 HEAP32[gb + 162448 >> 2] = (HEAP32[gb + 162448 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162452 >> 2] = (HEAP32[gb + 162452 >> 2] | 0) + (gb + 829136 | 0);
 HEAP32[gb + 162480 >> 2] = (HEAP32[gb + 162480 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162484 >> 2] = (HEAP32[gb + 162484 >> 2] | 0) + (gb + 829125 | 0);
 HEAP32[gb + 162512 >> 2] = (HEAP32[gb + 162512 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162516 >> 2] = (HEAP32[gb + 162516 >> 2] | 0) + (gb + 829109 | 0);
 HEAP32[gb + 162544 >> 2] = (HEAP32[gb + 162544 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 162548 >> 2] = (HEAP32[gb + 162548 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 162576 >> 2] = (HEAP32[gb + 162576 >> 2] | 0) + (gb + 829085 | 0);
 HEAP32[gb + 162608 >> 2] = (HEAP32[gb + 162608 >> 2] | 0) + (gb + 829056 | 0);
 HEAP32[gb + 162640 >> 2] = (HEAP32[gb + 162640 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 162672 >> 2] = (HEAP32[gb + 162672 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 162704 >> 2] = (HEAP32[gb + 162704 >> 2] | 0) + (gb + 829030 | 0);
 HEAP32[gb + 162736 >> 2] = (HEAP32[gb + 162736 >> 2] | 0) + (gb + 829363 | 0);
 HEAP32[gb + 162768 >> 2] = (HEAP32[gb + 162768 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 162772 >> 2] = (HEAP32[gb + 162772 >> 2] | 0) + (gb + 829450 | 0);
 HEAP32[gb + 162800 >> 2] = (HEAP32[gb + 162800 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 162804 >> 2] = (HEAP32[gb + 162804 >> 2] | 0) + (gb + 829444 | 0);
 HEAP32[gb + 162832 >> 2] = (HEAP32[gb + 162832 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 162836 >> 2] = (HEAP32[gb + 162836 >> 2] | 0) + (gb + 829429 | 0);
 HEAP32[gb + 162864 >> 2] = (HEAP32[gb + 162864 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 162868 >> 2] = (HEAP32[gb + 162868 >> 2] | 0) + (gb + 829416 | 0);
 HEAP32[gb + 162896 >> 2] = (HEAP32[gb + 162896 >> 2] | 0) + (gb + 829295 | 0);
 HEAP32[gb + 162928 >> 2] = (HEAP32[gb + 162928 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 162932 >> 2] = (HEAP32[gb + 162932 >> 2] | 0) + (gb + 829402 | 0);
 HEAP32[gb + 162960 >> 2] = (HEAP32[gb + 162960 >> 2] | 0) + (gb + 829267 | 0);
 HEAP32[gb + 162992 >> 2] = (HEAP32[gb + 162992 >> 2] | 0) + (gb + 829363 | 0);
 HEAP32[gb + 162996 >> 2] = (HEAP32[gb + 162996 >> 2] | 0) + (gb + 829387 | 0);
 HEAP32[gb + 163024 >> 2] = (HEAP32[gb + 163024 >> 2] | 0) + (gb + 829295 | 0);
 HEAP32[gb + 163028 >> 2] = (HEAP32[gb + 163028 >> 2] | 0) + (gb + 829340 | 0);
 HEAP32[gb + 163056 >> 2] = (HEAP32[gb + 163056 >> 2] | 0) + (gb + 829295 | 0);
 HEAP32[gb + 163060 >> 2] = (HEAP32[gb + 163060 >> 2] | 0) + (gb + 829320 | 0);
 HEAP32[gb + 163088 >> 2] = (HEAP32[gb + 163088 >> 2] | 0) + (gb + 829030 | 0);
 HEAP32[gb + 163120 >> 2] = (HEAP32[gb + 163120 >> 2] | 0) + (gb + 829267 | 0);
 HEAP32[gb + 163124 >> 2] = (HEAP32[gb + 163124 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 163152 >> 2] = (HEAP32[gb + 163152 >> 2] | 0) + (gb + 829242 | 0);
 HEAP32[gb + 163156 >> 2] = (HEAP32[gb + 163156 >> 2] | 0) + (gb + 829255 | 0);
 HEAP32[gb + 163184 >> 2] = (HEAP32[gb + 163184 >> 2] | 0) + (gb + 828315 | 0);
 HEAP32[gb + 163188 >> 2] = (HEAP32[gb + 163188 >> 2] | 0) + (gb + 829233 | 0);
 HEAP32[gb + 163216 >> 2] = (HEAP32[gb + 163216 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 163220 >> 2] = (HEAP32[gb + 163220 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 163248 >> 2] = (HEAP32[gb + 163248 >> 2] | 0) + (gb + 829085 | 0);
 HEAP32[gb + 163280 >> 2] = (HEAP32[gb + 163280 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163284 >> 2] = (HEAP32[gb + 163284 >> 2] | 0) + (gb + 829670 | 0);
 HEAP32[gb + 163312 >> 2] = (HEAP32[gb + 163312 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163316 >> 2] = (HEAP32[gb + 163316 >> 2] | 0) + (gb + 829648 | 0);
 HEAP32[gb + 163344 >> 2] = (HEAP32[gb + 163344 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163348 >> 2] = (HEAP32[gb + 163348 >> 2] | 0) + (gb + 829627 | 0);
 HEAP32[gb + 163376 >> 2] = (HEAP32[gb + 163376 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163380 >> 2] = (HEAP32[gb + 163380 >> 2] | 0) + (gb + 829600 | 0);
 HEAP32[gb + 163408 >> 2] = (HEAP32[gb + 163408 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163412 >> 2] = (HEAP32[gb + 163412 >> 2] | 0) + (gb + 829576 | 0);
 HEAP32[gb + 163440 >> 2] = (HEAP32[gb + 163440 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163444 >> 2] = (HEAP32[gb + 163444 >> 2] | 0) + (gb + 829567 | 0);
 HEAP32[gb + 163472 >> 2] = (HEAP32[gb + 163472 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 163476 >> 2] = (HEAP32[gb + 163476 >> 2] | 0) + (gb + 829539 | 0);
 HEAP32[gb + 163504 >> 2] = (HEAP32[gb + 163504 >> 2] | 0) + (gb + 829030 | 0);
 HEAP32[gb + 163508 >> 2] = (HEAP32[gb + 163508 >> 2] | 0) + (gb + 829519 | 0);
 HEAP32[gb + 163536 >> 2] = (HEAP32[gb + 163536 >> 2] | 0) + (gb + 829487 | 0);
 HEAP32[gb + 163540 >> 2] = (HEAP32[gb + 163540 >> 2] | 0) + (gb + 829508 | 0);
 HEAP32[gb + 163568 >> 2] = (HEAP32[gb + 163568 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 163572 >> 2] = (HEAP32[gb + 163572 >> 2] | 0) + (gb + 829461 | 0);
 HEAP32[gb + 163600 >> 2] = (HEAP32[gb + 163600 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 163604 >> 2] = (HEAP32[gb + 163604 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 163632 >> 2] = (HEAP32[gb + 163632 >> 2] | 0) + (gb + 829860 | 0);
 HEAP32[gb + 163664 >> 2] = (HEAP32[gb + 163664 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163668 >> 2] = (HEAP32[gb + 163668 >> 2] | 0) + (gb + 829996 | 0);
 HEAP32[gb + 163696 >> 2] = (HEAP32[gb + 163696 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163700 >> 2] = (HEAP32[gb + 163700 >> 2] | 0) + (gb + 829969 | 0);
 HEAP32[gb + 163728 >> 2] = (HEAP32[gb + 163728 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163732 >> 2] = (HEAP32[gb + 163732 >> 2] | 0) + (gb + 829950 | 0);
 HEAP32[gb + 163760 >> 2] = (HEAP32[gb + 163760 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163764 >> 2] = (HEAP32[gb + 163764 >> 2] | 0) + (gb + 829923 | 0);
 HEAP32[gb + 163792 >> 2] = (HEAP32[gb + 163792 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 163796 >> 2] = (HEAP32[gb + 163796 >> 2] | 0) + (gb + 829910 | 0);
 HEAP32[gb + 163824 >> 2] = (HEAP32[gb + 163824 >> 2] | 0) + (gb + 828992 | 0);
 runPostSets192();
}

function runPostSets143() {
 HEAP32[gb + 130276 >> 2] = (HEAP32[gb + 130276 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130280 >> 2] = (HEAP32[gb + 130280 >> 2] | 0) + (gb + 751249 | 0);
 HEAP32[gb + 130308 >> 2] = (HEAP32[gb + 130308 >> 2] | 0) + (gb + 751216 | 0);
 HEAP32[gb + 130312 >> 2] = (HEAP32[gb + 130312 >> 2] | 0) + (gb + 751238 | 0);
 HEAP32[gb + 130340 >> 2] = (HEAP32[gb + 130340 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130344 >> 2] = (HEAP32[gb + 130344 >> 2] | 0) + (gb + 751206 | 0);
 HEAP32[gb + 130372 >> 2] = (HEAP32[gb + 130372 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 130376 >> 2] = (HEAP32[gb + 130376 >> 2] | 0) + (gb + 751188 | 0);
 HEAP32[gb + 130404 >> 2] = (HEAP32[gb + 130404 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 130408 >> 2] = (HEAP32[gb + 130408 >> 2] | 0) + (gb + 751169 | 0);
 HEAP32[gb + 130436 >> 2] = (HEAP32[gb + 130436 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 130440 >> 2] = (HEAP32[gb + 130440 >> 2] | 0) + (gb + 751147 | 0);
 HEAP32[gb + 130468 >> 2] = (HEAP32[gb + 130468 >> 2] | 0) + (gb + 751133 | 0);
 HEAP32[gb + 130472 >> 2] = (HEAP32[gb + 130472 >> 2] | 0) + (gb + 750541 | 0);
 HEAP32[gb + 130500 >> 2] = (HEAP32[gb + 130500 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 130532 >> 2] = (HEAP32[gb + 130532 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130536 >> 2] = (HEAP32[gb + 130536 >> 2] | 0) + (gb + 904295 | 0);
 HEAP32[gb + 130564 >> 2] = (HEAP32[gb + 130564 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130568 >> 2] = (HEAP32[gb + 130568 >> 2] | 0) + (gb + 904301 | 0);
 HEAP32[gb + 130596 >> 2] = (HEAP32[gb + 130596 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130600 >> 2] = (HEAP32[gb + 130600 >> 2] | 0) + (gb + 904307 | 0);
 HEAP32[gb + 130628 >> 2] = (HEAP32[gb + 130628 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 130632 >> 2] = (HEAP32[gb + 130632 >> 2] | 0) + (gb + 751571 | 0);
 HEAP32[gb + 130660 >> 2] = (HEAP32[gb + 130660 >> 2] | 0) + (gb + 751465 | 0);
 HEAP32[gb + 130692 >> 2] = (HEAP32[gb + 130692 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 130696 >> 2] = (HEAP32[gb + 130696 >> 2] | 0) + (gb + 751561 | 0);
 HEAP32[gb + 130724 >> 2] = (HEAP32[gb + 130724 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 130728 >> 2] = (HEAP32[gb + 130728 >> 2] | 0) + (gb + 751552 | 0);
 HEAP32[gb + 130756 >> 2] = (HEAP32[gb + 130756 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 130760 >> 2] = (HEAP32[gb + 130760 >> 2] | 0) + (gb + 754057 | 0);
 HEAP32[gb + 130788 >> 2] = (HEAP32[gb + 130788 >> 2] | 0) + (gb + 751505 | 0);
 HEAP32[gb + 130792 >> 2] = (HEAP32[gb + 130792 >> 2] | 0) + (gb + 751540 | 0);
 HEAP32[gb + 130820 >> 2] = (HEAP32[gb + 130820 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 130824 >> 2] = (HEAP32[gb + 130824 >> 2] | 0) + (gb + 751532 | 0);
 HEAP32[gb + 130852 >> 2] = (HEAP32[gb + 130852 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 130856 >> 2] = (HEAP32[gb + 130856 >> 2] | 0) + (gb + 751518 | 0);
 HEAP32[gb + 130884 >> 2] = (HEAP32[gb + 130884 >> 2] | 0) + (gb + 751505 | 0);
 HEAP32[gb + 130888 >> 2] = (HEAP32[gb + 130888 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 130916 >> 2] = (HEAP32[gb + 130916 >> 2] | 0) + (gb + 751495 | 0);
 HEAP32[gb + 130948 >> 2] = (HEAP32[gb + 130948 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 130952 >> 2] = (HEAP32[gb + 130952 >> 2] | 0) + (gb + 751478 | 0);
 HEAP32[gb + 130980 >> 2] = (HEAP32[gb + 130980 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 130984 >> 2] = (HEAP32[gb + 130984 >> 2] | 0) + (gb + 748231 | 0);
 HEAP32[gb + 131012 >> 2] = (HEAP32[gb + 131012 >> 2] | 0) + (gb + 751465 | 0);
 HEAP32[gb + 131016 >> 2] = (HEAP32[gb + 131016 >> 2] | 0) + (gb + 750514 | 0);
 HEAP32[gb + 131044 >> 2] = (HEAP32[gb + 131044 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131048 >> 2] = (HEAP32[gb + 131048 >> 2] | 0) + (gb + 748639 | 0);
 HEAP32[gb + 131076 >> 2] = (HEAP32[gb + 131076 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 131080 >> 2] = (HEAP32[gb + 131080 >> 2] | 0) + (gb + 751442 | 0);
 HEAP32[gb + 131108 >> 2] = (HEAP32[gb + 131108 >> 2] | 0) + (gb + 751653 | 0);
 HEAP32[gb + 131112 >> 2] = (HEAP32[gb + 131112 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 131140 >> 2] = (HEAP32[gb + 131140 >> 2] | 0) + (gb + 751624 | 0);
 HEAP32[gb + 131144 >> 2] = (HEAP32[gb + 131144 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 131172 >> 2] = (HEAP32[gb + 131172 >> 2] | 0) + (gb + 751640 | 0);
 HEAP32[gb + 131204 >> 2] = (HEAP32[gb + 131204 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131208 >> 2] = (HEAP32[gb + 131208 >> 2] | 0) + (gb + 754137 | 0);
 HEAP32[gb + 131236 >> 2] = (HEAP32[gb + 131236 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131240 >> 2] = (HEAP32[gb + 131240 >> 2] | 0) + (gb + 754122 | 0);
 HEAP32[gb + 131268 >> 2] = (HEAP32[gb + 131268 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131272 >> 2] = (HEAP32[gb + 131272 >> 2] | 0) + (gb + 754153 | 0);
 HEAP32[gb + 131300 >> 2] = (HEAP32[gb + 131300 >> 2] | 0) + (gb + 751624 | 0);
 HEAP32[gb + 131304 >> 2] = (HEAP32[gb + 131304 >> 2] | 0) + (gb + 1040342 | 0);
 HEAP32[gb + 131332 >> 2] = (HEAP32[gb + 131332 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 131336 >> 2] = (HEAP32[gb + 131336 >> 2] | 0) + (gb + 751604 | 0);
 HEAP32[gb + 131364 >> 2] = (HEAP32[gb + 131364 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 131368 >> 2] = (HEAP32[gb + 131368 >> 2] | 0) + (gb + 751532 | 0);
 HEAP32[gb + 131396 >> 2] = (HEAP32[gb + 131396 >> 2] | 0) + (gb + 763461 | 0);
 HEAP32[gb + 131400 >> 2] = (HEAP32[gb + 131400 >> 2] | 0) + (gb + 751592 | 0);
 HEAP32[gb + 131428 >> 2] = (HEAP32[gb + 131428 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 131432 >> 2] = (HEAP32[gb + 131432 >> 2] | 0) + (gb + 751577 | 0);
 HEAP32[gb + 131460 >> 2] = (HEAP32[gb + 131460 >> 2] | 0) + (gb + 751685 | 0);
 HEAP32[gb + 131492 >> 2] = (HEAP32[gb + 131492 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 131496 >> 2] = (HEAP32[gb + 131496 >> 2] | 0) + (gb + 751980 | 0);
 HEAP32[gb + 131524 >> 2] = (HEAP32[gb + 131524 >> 2] | 0) + (gb + 751769 | 0);
 HEAP32[gb + 131528 >> 2] = (HEAP32[gb + 131528 >> 2] | 0) + (gb + 752664 | 0);
 HEAP32[gb + 131556 >> 2] = (HEAP32[gb + 131556 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 131560 >> 2] = (HEAP32[gb + 131560 >> 2] | 0) + (gb + 751965 | 0);
 HEAP32[gb + 131588 >> 2] = (HEAP32[gb + 131588 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 131592 >> 2] = (HEAP32[gb + 131592 >> 2] | 0) + (gb + 751039 | 0);
 HEAP32[gb + 131620 >> 2] = (HEAP32[gb + 131620 >> 2] | 0) + (gb + 751673 | 0);
 HEAP32[gb + 131652 >> 2] = (HEAP32[gb + 131652 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 131656 >> 2] = (HEAP32[gb + 131656 >> 2] | 0) + (gb + 751950 | 0);
 HEAP32[gb + 131684 >> 2] = (HEAP32[gb + 131684 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131688 >> 2] = (HEAP32[gb + 131688 >> 2] | 0) + (gb + 751939 | 0);
 HEAP32[gb + 131716 >> 2] = (HEAP32[gb + 131716 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 131720 >> 2] = (HEAP32[gb + 131720 >> 2] | 0) + (gb + 1047867 | 0);
 HEAP32[gb + 131748 >> 2] = (HEAP32[gb + 131748 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131752 >> 2] = (HEAP32[gb + 131752 >> 2] | 0) + (gb + 751916 | 0);
 HEAP32[gb + 131780 >> 2] = (HEAP32[gb + 131780 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 131784 >> 2] = (HEAP32[gb + 131784 >> 2] | 0) + (gb + 751905 | 0);
 HEAP32[gb + 131812 >> 2] = (HEAP32[gb + 131812 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131816 >> 2] = (HEAP32[gb + 131816 >> 2] | 0) + (gb + 751883 | 0);
 HEAP32[gb + 131844 >> 2] = (HEAP32[gb + 131844 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131848 >> 2] = (HEAP32[gb + 131848 >> 2] | 0) + (gb + 751862 | 0);
 HEAP32[gb + 131876 >> 2] = (HEAP32[gb + 131876 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131880 >> 2] = (HEAP32[gb + 131880 >> 2] | 0) + (gb + 751842 | 0);
 HEAP32[gb + 131908 >> 2] = (HEAP32[gb + 131908 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131912 >> 2] = (HEAP32[gb + 131912 >> 2] | 0) + (gb + 751828 | 0);
 HEAP32[gb + 131940 >> 2] = (HEAP32[gb + 131940 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 131944 >> 2] = (HEAP32[gb + 131944 >> 2] | 0) + (gb + 751813 | 0);
 runPostSets144();
}

function runPostSets145() {
 HEAP32[gb + 133672 >> 2] = (HEAP32[gb + 133672 >> 2] | 0) + (gb + 752189 | 0);
 HEAP32[gb + 133700 >> 2] = (HEAP32[gb + 133700 >> 2] | 0) + (gb + 752155 | 0);
 HEAP32[gb + 133732 >> 2] = (HEAP32[gb + 133732 >> 2] | 0) + (gb + 754619 | 0);
 HEAP32[gb + 133764 >> 2] = (HEAP32[gb + 133764 >> 2] | 0) + (gb + 752505 | 0);
 HEAP32[gb + 133768 >> 2] = (HEAP32[gb + 133768 >> 2] | 0) + (gb + 752526 | 0);
 HEAP32[gb + 133796 >> 2] = (HEAP32[gb + 133796 >> 2] | 0) + (gb + 752175 | 0);
 HEAP32[gb + 133800 >> 2] = (HEAP32[gb + 133800 >> 2] | 0) + (gb + 752189 | 0);
 HEAP32[gb + 133828 >> 2] = (HEAP32[gb + 133828 >> 2] | 0) + (gb + 752532 | 0);
 HEAP32[gb + 133860 >> 2] = (HEAP32[gb + 133860 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133864 >> 2] = (HEAP32[gb + 133864 >> 2] | 0) + (gb + 753025 | 0);
 HEAP32[gb + 133892 >> 2] = (HEAP32[gb + 133892 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133896 >> 2] = (HEAP32[gb + 133896 >> 2] | 0) + (gb + 753016 | 0);
 HEAP32[gb + 133924 >> 2] = (HEAP32[gb + 133924 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 133928 >> 2] = (HEAP32[gb + 133928 >> 2] | 0) + (gb + 753010 | 0);
 HEAP32[gb + 133956 >> 2] = (HEAP32[gb + 133956 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 133960 >> 2] = (HEAP32[gb + 133960 >> 2] | 0) + (gb + 753003 | 0);
 HEAP32[gb + 133988 >> 2] = (HEAP32[gb + 133988 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133992 >> 2] = (HEAP32[gb + 133992 >> 2] | 0) + (gb + 752986 | 0);
 HEAP32[gb + 134020 >> 2] = (HEAP32[gb + 134020 >> 2] | 0) + (gb + 752972 | 0);
 HEAP32[gb + 134052 >> 2] = (HEAP32[gb + 134052 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134056 >> 2] = (HEAP32[gb + 134056 >> 2] | 0) + (gb + 752967 | 0);
 HEAP32[gb + 134084 >> 2] = (HEAP32[gb + 134084 >> 2] | 0) + (gb + 752671 | 0);
 HEAP32[gb + 134116 >> 2] = (HEAP32[gb + 134116 >> 2] | 0) + (gb + 752532 | 0);
 HEAP32[gb + 134120 >> 2] = (HEAP32[gb + 134120 >> 2] | 0) + (gb + 752960 | 0);
 HEAP32[gb + 134148 >> 2] = (HEAP32[gb + 134148 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 134152 >> 2] = (HEAP32[gb + 134152 >> 2] | 0) + (gb + 752947 | 0);
 HEAP32[gb + 134180 >> 2] = (HEAP32[gb + 134180 >> 2] | 0) + (gb + 752899 | 0);
 HEAP32[gb + 134184 >> 2] = (HEAP32[gb + 134184 >> 2] | 0) + (gb + 752940 | 0);
 HEAP32[gb + 134212 >> 2] = (HEAP32[gb + 134212 >> 2] | 0) + (gb + 752639 | 0);
 HEAP32[gb + 134244 >> 2] = (HEAP32[gb + 134244 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134248 >> 2] = (HEAP32[gb + 134248 >> 2] | 0) + (gb + 752751 | 0);
 HEAP32[gb + 134276 >> 2] = (HEAP32[gb + 134276 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134280 >> 2] = (HEAP32[gb + 134280 >> 2] | 0) + (gb + 752737 | 0);
 HEAP32[gb + 134308 >> 2] = (HEAP32[gb + 134308 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 134312 >> 2] = (HEAP32[gb + 134312 >> 2] | 0) + (gb + 752727 | 0);
 HEAP32[gb + 134340 >> 2] = (HEAP32[gb + 134340 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 134344 >> 2] = (HEAP32[gb + 134344 >> 2] | 0) + (gb + 752716 | 0);
 HEAP32[gb + 134372 >> 2] = (HEAP32[gb + 134372 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 134376 >> 2] = (HEAP32[gb + 134376 >> 2] | 0) + (gb + 752701 | 0);
 HEAP32[gb + 134404 >> 2] = (HEAP32[gb + 134404 >> 2] | 0) + (gb + 752671 | 0);
 HEAP32[gb + 134408 >> 2] = (HEAP32[gb + 134408 >> 2] | 0) + (gb + 752685 | 0);
 HEAP32[gb + 134436 >> 2] = (HEAP32[gb + 134436 >> 2] | 0) + (gb + 774412 | 0);
 HEAP32[gb + 134440 >> 2] = (HEAP32[gb + 134440 >> 2] | 0) + (gb + 752325 | 0);
 HEAP32[gb + 134468 >> 2] = (HEAP32[gb + 134468 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 134472 >> 2] = (HEAP32[gb + 134472 >> 2] | 0) + (gb + 752664 | 0);
 HEAP32[gb + 134500 >> 2] = (HEAP32[gb + 134500 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 134532 >> 2] = (HEAP32[gb + 134532 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 134564 >> 2] = (HEAP32[gb + 134564 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 134596 >> 2] = (HEAP32[gb + 134596 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134628 >> 2] = (HEAP32[gb + 134628 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134660 >> 2] = (HEAP32[gb + 134660 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 134692 >> 2] = (HEAP32[gb + 134692 >> 2] | 0) + (gb + 752505 | 0);
 HEAP32[gb + 134724 >> 2] = (HEAP32[gb + 134724 >> 2] | 0) + (gb + 752639 | 0);
 HEAP32[gb + 134728 >> 2] = (HEAP32[gb + 134728 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 134756 >> 2] = (HEAP32[gb + 134756 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 134760 >> 2] = (HEAP32[gb + 134760 >> 2] | 0) + (gb + 752622 | 0);
 HEAP32[gb + 134788 >> 2] = (HEAP32[gb + 134788 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134792 >> 2] = (HEAP32[gb + 134792 >> 2] | 0) + (gb + 752611 | 0);
 HEAP32[gb + 134820 >> 2] = (HEAP32[gb + 134820 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134824 >> 2] = (HEAP32[gb + 134824 >> 2] | 0) + (gb + 752598 | 0);
 HEAP32[gb + 134852 >> 2] = (HEAP32[gb + 134852 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134856 >> 2] = (HEAP32[gb + 134856 >> 2] | 0) + (gb + 752582 | 0);
 HEAP32[gb + 134884 >> 2] = (HEAP32[gb + 134884 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 134888 >> 2] = (HEAP32[gb + 134888 >> 2] | 0) + (gb + 752561 | 0);
 HEAP32[gb + 134916 >> 2] = (HEAP32[gb + 134916 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 134920 >> 2] = (HEAP32[gb + 134920 >> 2] | 0) + (gb + 754434 | 0);
 HEAP32[gb + 134948 >> 2] = (HEAP32[gb + 134948 >> 2] | 0) + (gb + 752532 | 0);
 HEAP32[gb + 134952 >> 2] = (HEAP32[gb + 134952 >> 2] | 0) + (gb + 752546 | 0);
 HEAP32[gb + 134980 >> 2] = (HEAP32[gb + 134980 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 135012 >> 2] = (HEAP32[gb + 135012 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135044 >> 2] = (HEAP32[gb + 135044 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135076 >> 2] = (HEAP32[gb + 135076 >> 2] | 0) + (gb + 752764 | 0);
 HEAP32[gb + 135108 >> 2] = (HEAP32[gb + 135108 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135112 >> 2] = (HEAP32[gb + 135112 >> 2] | 0) + (gb + 752935 | 0);
 HEAP32[gb + 135140 >> 2] = (HEAP32[gb + 135140 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135144 >> 2] = (HEAP32[gb + 135144 >> 2] | 0) + (gb + 752930 | 0);
 HEAP32[gb + 135172 >> 2] = (HEAP32[gb + 135172 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135176 >> 2] = (HEAP32[gb + 135176 >> 2] | 0) + (gb + 752925 | 0);
 HEAP32[gb + 135204 >> 2] = (HEAP32[gb + 135204 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135208 >> 2] = (HEAP32[gb + 135208 >> 2] | 0) + (gb + 752920 | 0);
 HEAP32[gb + 135236 >> 2] = (HEAP32[gb + 135236 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135240 >> 2] = (HEAP32[gb + 135240 >> 2] | 0) + (gb + 752915 | 0);
 HEAP32[gb + 135268 >> 2] = (HEAP32[gb + 135268 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135272 >> 2] = (HEAP32[gb + 135272 >> 2] | 0) + (gb + 752910 | 0);
 HEAP32[gb + 135300 >> 2] = (HEAP32[gb + 135300 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135304 >> 2] = (HEAP32[gb + 135304 >> 2] | 0) + (gb + 752905 | 0);
 HEAP32[gb + 135332 >> 2] = (HEAP32[gb + 135332 >> 2] | 0) + (gb + 752899 | 0);
 HEAP32[gb + 135364 >> 2] = (HEAP32[gb + 135364 >> 2] | 0) + (gb + 774398 | 0);
 HEAP32[gb + 135368 >> 2] = (HEAP32[gb + 135368 >> 2] | 0) + (gb + 752888 | 0);
 HEAP32[gb + 135396 >> 2] = (HEAP32[gb + 135396 >> 2] | 0) + (gb + 774398 | 0);
 HEAP32[gb + 135400 >> 2] = (HEAP32[gb + 135400 >> 2] | 0) + (gb + 752877 | 0);
 HEAP32[gb + 135428 >> 2] = (HEAP32[gb + 135428 >> 2] | 0) + (gb + 774398 | 0);
 HEAP32[gb + 135432 >> 2] = (HEAP32[gb + 135432 >> 2] | 0) + (gb + 752864 | 0);
 HEAP32[gb + 135460 >> 2] = (HEAP32[gb + 135460 >> 2] | 0) + (gb + 774398 | 0);
 HEAP32[gb + 135464 >> 2] = (HEAP32[gb + 135464 >> 2] | 0) + (gb + 752848 | 0);
 HEAP32[gb + 135492 >> 2] = (HEAP32[gb + 135492 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135496 >> 2] = (HEAP32[gb + 135496 >> 2] | 0) + (gb + 752838 | 0);
 HEAP32[gb + 135524 >> 2] = (HEAP32[gb + 135524 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135528 >> 2] = (HEAP32[gb + 135528 >> 2] | 0) + (gb + 752824 | 0);
 HEAP32[gb + 135556 >> 2] = (HEAP32[gb + 135556 >> 2] | 0) + (gb + 827882 | 0);
 runPostSets146();
}

function runPostSets142() {
 HEAP32[gb + 128612 >> 2] = (HEAP32[gb + 128612 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 128616 >> 2] = (HEAP32[gb + 128616 >> 2] | 0) + (gb + 750912 | 0);
 HEAP32[gb + 128644 >> 2] = (HEAP32[gb + 128644 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 128648 >> 2] = (HEAP32[gb + 128648 >> 2] | 0) + (gb + 750902 | 0);
 HEAP32[gb + 128676 >> 2] = (HEAP32[gb + 128676 >> 2] | 0) + (gb + 774405 | 0);
 HEAP32[gb + 128680 >> 2] = (HEAP32[gb + 128680 >> 2] | 0) + (gb + 827430 | 0);
 HEAP32[gb + 128708 >> 2] = (HEAP32[gb + 128708 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 128712 >> 2] = (HEAP32[gb + 128712 >> 2] | 0) + (gb + 750887 | 0);
 HEAP32[gb + 128740 >> 2] = (HEAP32[gb + 128740 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128744 >> 2] = (HEAP32[gb + 128744 >> 2] | 0) + (gb + 827416 | 0);
 HEAP32[gb + 128772 >> 2] = (HEAP32[gb + 128772 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128776 >> 2] = (HEAP32[gb + 128776 >> 2] | 0) + (gb + 1048298 | 0);
 HEAP32[gb + 128804 >> 2] = (HEAP32[gb + 128804 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128808 >> 2] = (HEAP32[gb + 128808 >> 2] | 0) + (gb + 750874 | 0);
 HEAP32[gb + 128836 >> 2] = (HEAP32[gb + 128836 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128840 >> 2] = (HEAP32[gb + 128840 >> 2] | 0) + (gb + 750860 | 0);
 HEAP32[gb + 128868 >> 2] = (HEAP32[gb + 128868 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128872 >> 2] = (HEAP32[gb + 128872 >> 2] | 0) + (gb + 750841 | 0);
 HEAP32[gb + 128900 >> 2] = (HEAP32[gb + 128900 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128904 >> 2] = (HEAP32[gb + 128904 >> 2] | 0) + (gb + 750822 | 0);
 HEAP32[gb + 128932 >> 2] = (HEAP32[gb + 128932 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128936 >> 2] = (HEAP32[gb + 128936 >> 2] | 0) + (gb + 750810 | 0);
 HEAP32[gb + 128964 >> 2] = (HEAP32[gb + 128964 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 128968 >> 2] = (HEAP32[gb + 128968 >> 2] | 0) + (gb + 750798 | 0);
 HEAP32[gb + 128996 >> 2] = (HEAP32[gb + 128996 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129e3 >> 2] = (HEAP32[gb + 129e3 >> 2] | 0) + (gb + 750772 | 0);
 HEAP32[gb + 129028 >> 2] = (HEAP32[gb + 129028 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 129032 >> 2] = (HEAP32[gb + 129032 >> 2] | 0) + (gb + 750759 | 0);
 HEAP32[gb + 129060 >> 2] = (HEAP32[gb + 129060 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 129064 >> 2] = (HEAP32[gb + 129064 >> 2] | 0) + (gb + 750749 | 0);
 HEAP32[gb + 129092 >> 2] = (HEAP32[gb + 129092 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129096 >> 2] = (HEAP32[gb + 129096 >> 2] | 0) + (gb + 750729 | 0);
 HEAP32[gb + 129124 >> 2] = (HEAP32[gb + 129124 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129128 >> 2] = (HEAP32[gb + 129128 >> 2] | 0) + (gb + 750711 | 0);
 HEAP32[gb + 129156 >> 2] = (HEAP32[gb + 129156 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129160 >> 2] = (HEAP32[gb + 129160 >> 2] | 0) + (gb + 750696 | 0);
 HEAP32[gb + 129188 >> 2] = (HEAP32[gb + 129188 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129192 >> 2] = (HEAP32[gb + 129192 >> 2] | 0) + (gb + 750682 | 0);
 HEAP32[gb + 129220 >> 2] = (HEAP32[gb + 129220 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129224 >> 2] = (HEAP32[gb + 129224 >> 2] | 0) + (gb + 750656 | 0);
 HEAP32[gb + 129252 >> 2] = (HEAP32[gb + 129252 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 129256 >> 2] = (HEAP32[gb + 129256 >> 2] | 0) + (gb + 750643 | 0);
 HEAP32[gb + 129284 >> 2] = (HEAP32[gb + 129284 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129288 >> 2] = (HEAP32[gb + 129288 >> 2] | 0) + (gb + 750632 | 0);
 HEAP32[gb + 129316 >> 2] = (HEAP32[gb + 129316 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129320 >> 2] = (HEAP32[gb + 129320 >> 2] | 0) + (gb + 750621 | 0);
 HEAP32[gb + 129348 >> 2] = (HEAP32[gb + 129348 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129352 >> 2] = (HEAP32[gb + 129352 >> 2] | 0) + (gb + 750608 | 0);
 HEAP32[gb + 129380 >> 2] = (HEAP32[gb + 129380 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129384 >> 2] = (HEAP32[gb + 129384 >> 2] | 0) + (gb + 750594 | 0);
 HEAP32[gb + 129412 >> 2] = (HEAP32[gb + 129412 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129416 >> 2] = (HEAP32[gb + 129416 >> 2] | 0) + (gb + 750581 | 0);
 HEAP32[gb + 129444 >> 2] = (HEAP32[gb + 129444 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129448 >> 2] = (HEAP32[gb + 129448 >> 2] | 0) + (gb + 750568 | 0);
 HEAP32[gb + 129476 >> 2] = (HEAP32[gb + 129476 >> 2] | 0) + (gb + 750546 | 0);
 HEAP32[gb + 129508 >> 2] = (HEAP32[gb + 129508 >> 2] | 0) + (gb + 750520 | 0);
 HEAP32[gb + 129512 >> 2] = (HEAP32[gb + 129512 >> 2] | 0) + (gb + 750541 | 0);
 HEAP32[gb + 129540 >> 2] = (HEAP32[gb + 129540 >> 2] | 0) + (gb + 750489 | 0);
 HEAP32[gb + 129544 >> 2] = (HEAP32[gb + 129544 >> 2] | 0) + (gb + 750514 | 0);
 HEAP32[gb + 129572 >> 2] = (HEAP32[gb + 129572 >> 2] | 0) + (gb + 750923 | 0);
 HEAP32[gb + 129604 >> 2] = (HEAP32[gb + 129604 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 129608 >> 2] = (HEAP32[gb + 129608 >> 2] | 0) + (gb + 751109 | 0);
 HEAP32[gb + 129636 >> 2] = (HEAP32[gb + 129636 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 129640 >> 2] = (HEAP32[gb + 129640 >> 2] | 0) + (gb + 751085 | 0);
 HEAP32[gb + 129668 >> 2] = (HEAP32[gb + 129668 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 129672 >> 2] = (HEAP32[gb + 129672 >> 2] | 0) + (gb + 751061 | 0);
 HEAP32[gb + 129700 >> 2] = (HEAP32[gb + 129700 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 129704 >> 2] = (HEAP32[gb + 129704 >> 2] | 0) + (gb + 751039 | 0);
 HEAP32[gb + 129732 >> 2] = (HEAP32[gb + 129732 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129736 >> 2] = (HEAP32[gb + 129736 >> 2] | 0) + (gb + 751019 | 0);
 HEAP32[gb + 129764 >> 2] = (HEAP32[gb + 129764 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129768 >> 2] = (HEAP32[gb + 129768 >> 2] | 0) + (gb + 751004 | 0);
 HEAP32[gb + 129796 >> 2] = (HEAP32[gb + 129796 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129800 >> 2] = (HEAP32[gb + 129800 >> 2] | 0) + (gb + 750988 | 0);
 HEAP32[gb + 129828 >> 2] = (HEAP32[gb + 129828 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 129832 >> 2] = (HEAP32[gb + 129832 >> 2] | 0) + (gb + 750976 | 0);
 HEAP32[gb + 129860 >> 2] = (HEAP32[gb + 129860 >> 2] | 0) + (gb + 750959 | 0);
 HEAP32[gb + 129892 >> 2] = (HEAP32[gb + 129892 >> 2] | 0) + (gb + 750943 | 0);
 HEAP32[gb + 129896 >> 2] = (HEAP32[gb + 129896 >> 2] | 0) + (gb + 750541 | 0);
 HEAP32[gb + 129924 >> 2] = (HEAP32[gb + 129924 >> 2] | 0) + (gb + 750923 | 0);
 HEAP32[gb + 129928 >> 2] = (HEAP32[gb + 129928 >> 2] | 0) + (gb + 750514 | 0);
 HEAP32[gb + 129956 >> 2] = (HEAP32[gb + 129956 >> 2] | 0) + (gb + 751409 | 0);
 HEAP32[gb + 129960 >> 2] = (HEAP32[gb + 129960 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 129988 >> 2] = (HEAP32[gb + 129988 >> 2] | 0) + (gb + 751427 | 0);
 HEAP32[gb + 130020 >> 2] = (HEAP32[gb + 130020 >> 2] | 0) + (gb + 751409 | 0);
 HEAP32[gb + 130024 >> 2] = (HEAP32[gb + 130024 >> 2] | 0) + (gb + 752664 | 0);
 HEAP32[gb + 130052 >> 2] = (HEAP32[gb + 130052 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 130056 >> 2] = (HEAP32[gb + 130056 >> 2] | 0) + (gb + 751391 | 0);
 HEAP32[gb + 130084 >> 2] = (HEAP32[gb + 130084 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 130088 >> 2] = (HEAP32[gb + 130088 >> 2] | 0) + (gb + 751377 | 0);
 HEAP32[gb + 130116 >> 2] = (HEAP32[gb + 130116 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 130120 >> 2] = (HEAP32[gb + 130120 >> 2] | 0) + (gb + 751362 | 0);
 HEAP32[gb + 130148 >> 2] = (HEAP32[gb + 130148 >> 2] | 0) + (gb + 829211 | 0);
 HEAP32[gb + 130152 >> 2] = (HEAP32[gb + 130152 >> 2] | 0) + (gb + 751351 | 0);
 HEAP32[gb + 130180 >> 2] = (HEAP32[gb + 130180 >> 2] | 0) + (gb + 751322 | 0);
 HEAP32[gb + 130184 >> 2] = (HEAP32[gb + 130184 >> 2] | 0) + (gb + 751342 | 0);
 HEAP32[gb + 130212 >> 2] = (HEAP32[gb + 130212 >> 2] | 0) + (gb + 751287 | 0);
 HEAP32[gb + 130216 >> 2] = (HEAP32[gb + 130216 >> 2] | 0) + (gb + 751310 | 0);
 HEAP32[gb + 130244 >> 2] = (HEAP32[gb + 130244 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 130248 >> 2] = (HEAP32[gb + 130248 >> 2] | 0) + (gb + 751272 | 0);
 runPostSets143();
}

function runPostSets140() {
 HEAP32[gb + 125e3 >> 2] = (HEAP32[gb + 125e3 >> 2] | 0) + (gb + 747613 | 0);
 HEAP32[gb + 125028 >> 2] = (HEAP32[gb + 125028 >> 2] | 0) + (gb + 747542 | 0);
 HEAP32[gb + 125032 >> 2] = (HEAP32[gb + 125032 >> 2] | 0) + (gb + 747572 | 0);
 HEAP32[gb + 125060 >> 2] = (HEAP32[gb + 125060 >> 2] | 0) + (gb + 747542 | 0);
 HEAP32[gb + 125064 >> 2] = (HEAP32[gb + 125064 >> 2] | 0) + (gb + 747555 | 0);
 HEAP32[gb + 125092 >> 2] = (HEAP32[gb + 125092 >> 2] | 0) + (gb + 747667 | 0);
 HEAP32[gb + 125124 >> 2] = (HEAP32[gb + 125124 >> 2] | 0) + (gb + 748485 | 0);
 HEAP32[gb + 125128 >> 2] = (HEAP32[gb + 125128 >> 2] | 0) + (gb + 747678 | 0);
 HEAP32[gb + 125156 >> 2] = (HEAP32[gb + 125156 >> 2] | 0) + (gb + 747685 | 0);
 HEAP32[gb + 125188 >> 2] = (HEAP32[gb + 125188 >> 2] | 0) + (gb + 747736 | 0);
 HEAP32[gb + 125192 >> 2] = (HEAP32[gb + 125192 >> 2] | 0) + (gb + 747748 | 0);
 HEAP32[gb + 125220 >> 2] = (HEAP32[gb + 125220 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 125224 >> 2] = (HEAP32[gb + 125224 >> 2] | 0) + (gb + 752129 | 0);
 HEAP32[gb + 125252 >> 2] = (HEAP32[gb + 125252 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 125256 >> 2] = (HEAP32[gb + 125256 >> 2] | 0) + (gb + 747723 | 0);
 HEAP32[gb + 125284 >> 2] = (HEAP32[gb + 125284 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 125288 >> 2] = (HEAP32[gb + 125288 >> 2] | 0) + (gb + 747710 | 0);
 HEAP32[gb + 125316 >> 2] = (HEAP32[gb + 125316 >> 2] | 0) + (gb + 747761 | 0);
 HEAP32[gb + 125348 >> 2] = (HEAP32[gb + 125348 >> 2] | 0) + (gb + 750546 | 0);
 HEAP32[gb + 125352 >> 2] = (HEAP32[gb + 125352 >> 2] | 0) + (gb + 747784 | 0);
 HEAP32[gb + 125380 >> 2] = (HEAP32[gb + 125380 >> 2] | 0) + (gb + 747791 | 0);
 HEAP32[gb + 125412 >> 2] = (HEAP32[gb + 125412 >> 2] | 0) + (gb + 750959 | 0);
 HEAP32[gb + 125416 >> 2] = (HEAP32[gb + 125416 >> 2] | 0) + (gb + 747850 | 0);
 HEAP32[gb + 125444 >> 2] = (HEAP32[gb + 125444 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 125448 >> 2] = (HEAP32[gb + 125448 >> 2] | 0) + (gb + 747829 | 0);
 HEAP32[gb + 125476 >> 2] = (HEAP32[gb + 125476 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 125480 >> 2] = (HEAP32[gb + 125480 >> 2] | 0) + (gb + 747809 | 0);
 HEAP32[gb + 125508 >> 2] = (HEAP32[gb + 125508 >> 2] | 0) + (gb + 747864 | 0);
 HEAP32[gb + 125540 >> 2] = (HEAP32[gb + 125540 >> 2] | 0) + (gb + 751427 | 0);
 HEAP32[gb + 125544 >> 2] = (HEAP32[gb + 125544 >> 2] | 0) + (gb + 829255 | 0);
 HEAP32[gb + 125572 >> 2] = (HEAP32[gb + 125572 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 125576 >> 2] = (HEAP32[gb + 125576 >> 2] | 0) + (gb + 747908 | 0);
 HEAP32[gb + 125604 >> 2] = (HEAP32[gb + 125604 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 125608 >> 2] = (HEAP32[gb + 125608 >> 2] | 0) + (gb + 747892 | 0);
 HEAP32[gb + 125636 >> 2] = (HEAP32[gb + 125636 >> 2] | 0) + (gb + 751409 | 0);
 HEAP32[gb + 125640 >> 2] = (HEAP32[gb + 125640 >> 2] | 0) + (gb + 747880 | 0);
 HEAP32[gb + 125668 >> 2] = (HEAP32[gb + 125668 >> 2] | 0) + (gb + 747923 | 0);
 HEAP32[gb + 125700 >> 2] = (HEAP32[gb + 125700 >> 2] | 0) + (gb + 751495 | 0);
 HEAP32[gb + 125704 >> 2] = (HEAP32[gb + 125704 >> 2] | 0) + (gb + 747934 | 0);
 HEAP32[gb + 125732 >> 2] = (HEAP32[gb + 125732 >> 2] | 0) + (gb + 747941 | 0);
 HEAP32[gb + 125764 >> 2] = (HEAP32[gb + 125764 >> 2] | 0) + (gb + 751698 | 0);
 HEAP32[gb + 125768 >> 2] = (HEAP32[gb + 125768 >> 2] | 0) + (gb + 748047 | 0);
 HEAP32[gb + 125796 >> 2] = (HEAP32[gb + 125796 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 125800 >> 2] = (HEAP32[gb + 125800 >> 2] | 0) + (gb + 748027 | 0);
 HEAP32[gb + 125828 >> 2] = (HEAP32[gb + 125828 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 125832 >> 2] = (HEAP32[gb + 125832 >> 2] | 0) + (gb + 748006 | 0);
 HEAP32[gb + 125860 >> 2] = (HEAP32[gb + 125860 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 125864 >> 2] = (HEAP32[gb + 125864 >> 2] | 0) + (gb + 747985 | 0);
 HEAP32[gb + 125892 >> 2] = (HEAP32[gb + 125892 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 125896 >> 2] = (HEAP32[gb + 125896 >> 2] | 0) + (gb + 747829 | 0);
 HEAP32[gb + 125924 >> 2] = (HEAP32[gb + 125924 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 125928 >> 2] = (HEAP32[gb + 125928 >> 2] | 0) + (gb + 747809 | 0);
 HEAP32[gb + 125956 >> 2] = (HEAP32[gb + 125956 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 125960 >> 2] = (HEAP32[gb + 125960 >> 2] | 0) + (gb + 747968 | 0);
 HEAP32[gb + 125988 >> 2] = (HEAP32[gb + 125988 >> 2] | 0) + (gb + 748057 | 0);
 HEAP32[gb + 126020 >> 2] = (HEAP32[gb + 126020 >> 2] | 0) + (gb + 751991 | 0);
 HEAP32[gb + 126024 >> 2] = (HEAP32[gb + 126024 >> 2] | 0) + (gb + 748074 | 0);
 HEAP32[gb + 126052 >> 2] = (HEAP32[gb + 126052 >> 2] | 0) + (gb + 747951 | 0);
 HEAP32[gb + 126084 >> 2] = (HEAP32[gb + 126084 >> 2] | 0) + (gb + 747531 | 0);
 HEAP32[gb + 126116 >> 2] = (HEAP32[gb + 126116 >> 2] | 0) + (gb + 748131 | 0);
 HEAP32[gb + 126120 >> 2] = (HEAP32[gb + 126120 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 126148 >> 2] = (HEAP32[gb + 126148 >> 2] | 0) + (gb + 747700 | 0);
 HEAP32[gb + 126180 >> 2] = (HEAP32[gb + 126180 >> 2] | 0) + (gb + 748113 | 0);
 HEAP32[gb + 126184 >> 2] = (HEAP32[gb + 126184 >> 2] | 0) + (gb + 748124 | 0);
 HEAP32[gb + 126212 >> 2] = (HEAP32[gb + 126212 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 126216 >> 2] = (HEAP32[gb + 126216 >> 2] | 0) + (gb + 748099 | 0);
 HEAP32[gb + 126244 >> 2] = (HEAP32[gb + 126244 >> 2] | 0) + (gb + 748082 | 0);
 HEAP32[gb + 126248 >> 2] = (HEAP32[gb + 126248 >> 2] | 0) + (gb + 748088 | 0);
 HEAP32[gb + 126276 >> 2] = (HEAP32[gb + 126276 >> 2] | 0) + (gb + 748145 | 0);
 HEAP32[gb + 126308 >> 2] = (HEAP32[gb + 126308 >> 2] | 0) + (gb + 748427 | 0);
 HEAP32[gb + 126312 >> 2] = (HEAP32[gb + 126312 >> 2] | 0) + (gb + 748253 | 0);
 HEAP32[gb + 126340 >> 2] = (HEAP32[gb + 126340 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 126344 >> 2] = (HEAP32[gb + 126344 >> 2] | 0) + (gb + 748231 | 0);
 HEAP32[gb + 126372 >> 2] = (HEAP32[gb + 126372 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 126376 >> 2] = (HEAP32[gb + 126376 >> 2] | 0) + (gb + 748209 | 0);
 HEAP32[gb + 126404 >> 2] = (HEAP32[gb + 126404 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 126408 >> 2] = (HEAP32[gb + 126408 >> 2] | 0) + (gb + 748195 | 0);
 HEAP32[gb + 126436 >> 2] = (HEAP32[gb + 126436 >> 2] | 0) + (gb + 754270 | 0);
 HEAP32[gb + 126440 >> 2] = (HEAP32[gb + 126440 >> 2] | 0) + (gb + 748182 | 0);
 HEAP32[gb + 126468 >> 2] = (HEAP32[gb + 126468 >> 2] | 0) + (gb + 748427 | 0);
 HEAP32[gb + 126500 >> 2] = (HEAP32[gb + 126500 >> 2] | 0) + (gb + 748443 | 0);
 HEAP32[gb + 126532 >> 2] = (HEAP32[gb + 126532 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 126536 >> 2] = (HEAP32[gb + 126536 >> 2] | 0) + (gb + 748481 | 0);
 HEAP32[gb + 126564 >> 2] = (HEAP32[gb + 126564 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 126568 >> 2] = (HEAP32[gb + 126568 >> 2] | 0) + (gb + 748477 | 0);
 HEAP32[gb + 126596 >> 2] = (HEAP32[gb + 126596 >> 2] | 0) + (gb + 748269 | 0);
 HEAP32[gb + 126628 >> 2] = (HEAP32[gb + 126628 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 126632 >> 2] = (HEAP32[gb + 126632 >> 2] | 0) + (gb + 932479 | 0);
 HEAP32[gb + 126660 >> 2] = (HEAP32[gb + 126660 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 126664 >> 2] = (HEAP32[gb + 126664 >> 2] | 0) + (gb + 748469 | 0);
 HEAP32[gb + 126692 >> 2] = (HEAP32[gb + 126692 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 126696 >> 2] = (HEAP32[gb + 126696 >> 2] | 0) + (gb + 748460 | 0);
 HEAP32[gb + 126724 >> 2] = (HEAP32[gb + 126724 >> 2] | 0) + (gb + 748443 | 0);
 HEAP32[gb + 126728 >> 2] = (HEAP32[gb + 126728 >> 2] | 0) + (gb + 1040342 | 0);
 HEAP32[gb + 126756 >> 2] = (HEAP32[gb + 126756 >> 2] | 0) + (gb + 748427 | 0);
 HEAP32[gb + 126788 >> 2] = (HEAP32[gb + 126788 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 126792 >> 2] = (HEAP32[gb + 126792 >> 2] | 0) + (gb + 748416 | 0);
 HEAP32[gb + 126820 >> 2] = (HEAP32[gb + 126820 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 126824 >> 2] = (HEAP32[gb + 126824 >> 2] | 0) + (gb + 748402 | 0);
 HEAP32[gb + 126852 >> 2] = (HEAP32[gb + 126852 >> 2] | 0) + (gb + 1087825 | 0);
 runPostSets141();
}

function __ZN18GfxFramebufferGLES13ReadbackImageER14ImageReferenceiiiiii(i21, i14, i15, i16, i17, i18, i6, i7) {
 i21 = i21 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27 + 52 | 0;
 i25 = i27 + 32 | 0;
 i20 = i27 + 16 | 0;
 i22 = i27;
 i2 = i27 + 24 | 0;
 i23 = i27 + 8 | 0;
 i24 = i21 + 336 | 0;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i20, HEAP32[i24 >> 2] | 0, 0);
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i22, HEAP32[i24 >> 2] | 0, 1);
 i1 = HEAP32[i24 >> 2] | 0;
 i11 = i20;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i19 = i2;
 HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i19 + 4 >> 2] = i12;
 HEAP32[i26 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i1, 1, i26);
 i1 = HEAP32[i21 + 92 >> 2] | 0;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = 3;
 i19 = __ZN12_GLOBAL__N_127PrepareReadback_ResolveMSAAER18GfxFramebufferGLESR7ApiGLESP17RenderSurfaceGLESS5_(i21, HEAP32[i24 >> 2] | 0, i1, i1) | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 i11 = (i8 | 0) == 5;
 i10 = __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace(HEAP32[(HEAP32[i24 >> 2] | 0) + 860 >> 2] | 0, i11 ? 0 : i8, 0) | 0;
 i9 = i11 ? 0 : HEAP32[i10 + 8 >> 2] | 0;
 i10 = i11 ? 0 : HEAP32[i10 + 4 >> 2] | 0;
 i11 = (i8 | 0) == 17;
 i12 = (i8 | 0) == 20;
 switch (i8 | 0) {
 case 6:
 case 17:
 case 20:
  {
   i2 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1;
   i2 = i2 ? 36193 : 5131;
   break;
  }
 default:
  i2 = 5121;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 721 >> 0] | 0)) {
  i5 = 6408;
  i4 = i2;
 } else {
  i1 = i8 + -4 | 0;
  if (i1 >>> 0 < 11) if (!(1545 >>> (i1 & 2047) & 1)) {
   i5 = 6408;
   i4 = i2;
  } else {
   i5 = __ZNK7ApiGLES3GetEj(HEAP32[i24 >> 2] | 0, 35739) | 0;
   i4 = __ZNK7ApiGLES3GetEj(HEAP32[i24 >> 2] | 0, 35738) | 0;
  } else {
   i5 = 6408;
   i4 = i2;
  }
 }
 L12 : do switch (i8 | 0) {
 case 1:
  {
   i3 = (i5 | 0) != 6406;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + i6 | 0;
   i13 = 20;
   break;
  }
 case 7:
  {
   i3 = (i5 | 0) != 33635;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 1) | 0;
   i13 = 20;
   break;
  }
 case 3:
  {
   i3 = (i5 | 0) != 6407;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 * 3 | 0) | 0;
   i13 = 20;
   break;
  }
 case 4:
  {
   i3 = (i5 | 0) != 6408;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 2) | 0;
   i13 = 20;
   break;
  }
 case 5:
  {
   i1 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 2) | 0;
   L18 : do if ((i5 | 0) < 6408) switch (i5 | 0) {
   case 6406:
   case 6407:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    {}
   } else if ((i5 | 0) < 33635) switch (i5 | 0) {
   case 6408:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    break L18;
   } else switch (i5 | 0) {
   case 33635:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    break L18;
   } while (0);
   i3 = 0;
   i2 = i1;
   i13 = 20;
   break;
  }
 case 17:
  {
   i3 = (i5 | 0) != 6408;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 3) | 0;
   i13 = 20;
   break;
  }
 case 6:
  {
   i1 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 4) | 0;
   L27 : do if ((i5 | 0) < 6408) switch (i5 | 0) {
   case 6406:
   case 6407:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    {}
   } else if ((i5 | 0) < 33635) switch (i5 | 0) {
   case 6408:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    break L27;
   } else switch (i5 | 0) {
   case 33635:
    {
     i3 = 1;
     i2 = i1;
     i13 = 20;
     break L12;
    }
   default:
    break L27;
   } while (0);
   i3 = 0;
   i2 = i1;
   i13 = 20;
   break;
  }
 case 20:
  {
   i3 = (i5 | 0) != 6408;
   i2 = (HEAP32[i14 + 16 >> 2] | 0) + (Math_imul(HEAP32[i14 + 12 >> 2] | 0, i7) | 0) + (i6 << 4) | 0;
   i13 = 20;
   break;
  }
 default:
  i4 = 0;
 } while (0);
 do if ((i13 | 0) == 20) if (!i2) i4 = 1; else {
  if ((i9 | 0) == (i4 | 0) & (i10 | 0) == (i5 | 0)) {
   if (i3 | (HEAP32[i14 + 4 >> 2] | 0) != (i17 | 0)) i13 = 23;
  } else i13 = 23;
  if ((i13 | 0) == 23) if (!(i12 & ((i4 | 0) == 5131 | (i4 | 0) == 36193))) if (!(i11 & ((i4 | 0) == 5126 & ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 > 3))) {
   L44 : do if ((i4 | 0) < 5131) switch (i4 | 0) {
   case 5126:
    {
     i13 = 27;
     break;
    }
   default:
    i13 = 28;
   } else if ((i4 | 0) < 36193) switch (i4 | 0) {
   case 5131:
    {
     i13 = 27;
     break L44;
    }
   default:
    {
     i13 = 28;
     break L44;
    }
   } else switch (i4 | 0) {
   case 36193:
    {
     i13 = 27;
     break L44;
    }
   default:
    {
     i13 = 28;
     break L44;
    }
   } while (0);
   if ((i13 | 0) == 27) switch (i8 | 0) {
   case 6:
   case 17:
   case 20:
    {
     i1 = 20;
     break;
    }
   default:
    i13 = 28;
   }
   if ((i13 | 0) == 28) i1 = 4;
   i13 = __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace(HEAP32[(HEAP32[i24 >> 2] | 0) + 860 >> 2] | 0, i1, 0) | 0;
   i4 = __Z18CalculateImageSizeii13TextureFormat(i17, i18, i1) | 0;
   i4 = __Znaj((i4 | 0) > -1 ? i4 : -1) | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i24 >> 2] | 0) + 116 >> 2] | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0, i4 | 0);
   __ZN14ImageReferenceC2Eiii13TextureFormatPv(i26, i17, i18, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i17, i1) | 0, i1, i4);
   __ZN14ImageReferenceC2Eiii13TextureFormatPv(i25, i17, i18, HEAP32[i14 + 12 >> 2] | 0, HEAP32[i14 >> 2] | 0, i2);
   __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i25, i26, 0);
   __ZdaPv(i4);
   i4 = 1;
   break;
  }
  mftCall_viiiiiii(HEAP32[(HEAP32[i24 >> 2] | 0) + 116 >> 2] | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i10 | 0, i9 | 0, i2 | 0);
  i4 = 1;
 } while (0);
 i3 = HEAP32[i24 >> 2] | 0;
 i2 = i20;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i19) {
  i25 = i3;
  i20 = i22;
  i20 = HEAP32[i20 >> 2] | 0;
  i22 = i22 + 4 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  i24 = i23;
  i21 = i24;
  HEAP32[i21 >> 2] = i20;
  i24 = i24 + 4 | 0;
  HEAP32[i24 >> 2] = i22;
  HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i25, 1, i26);
  STACKTOP = i27;
  return i4 | 0;
 }
 i20 = i25;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i20 + 4 >> 2] = i2;
 HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i3, 0, i26);
 __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES(i21, i19, 0);
 i25 = __Z16GetRealGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 388 >> 2] | 0, i25 | 0, i19 | 0);
 i25 = HEAP32[i24 >> 2] | 0;
 i20 = i22;
 i20 = HEAP32[i20 >> 2] | 0;
 i22 = i22 + 4 | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 i24 = i23;
 i21 = i24;
 HEAP32[i21 >> 2] = i20;
 i24 = i24 + 4 | 0;
 HEAP32[i24 >> 2] = i22;
 HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i25, 1, i26);
 STACKTOP = i27;
 return i4 | 0;
}

function runPostSets190() {
 HEAP32[gb + 160180 >> 2] = (HEAP32[gb + 160180 >> 2] | 0) + (gb + 827888 | 0);
 HEAP32[gb + 160208 >> 2] = (HEAP32[gb + 160208 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 160212 >> 2] = (HEAP32[gb + 160212 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 160240 >> 2] = (HEAP32[gb + 160240 >> 2] | 0) + (gb + 827709 | 0);
 HEAP32[gb + 160272 >> 2] = (HEAP32[gb + 160272 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160276 >> 2] = (HEAP32[gb + 160276 >> 2] | 0) + (gb + 827862 | 0);
 HEAP32[gb + 160304 >> 2] = (HEAP32[gb + 160304 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160308 >> 2] = (HEAP32[gb + 160308 >> 2] | 0) + (gb + 827850 | 0);
 HEAP32[gb + 160336 >> 2] = (HEAP32[gb + 160336 >> 2] | 0) + (gb + 827821 | 0);
 HEAP32[gb + 160368 >> 2] = (HEAP32[gb + 160368 >> 2] | 0) + (gb + 827793 | 0);
 HEAP32[gb + 160372 >> 2] = (HEAP32[gb + 160372 >> 2] | 0) + (gb + 827813 | 0);
 HEAP32[gb + 160400 >> 2] = (HEAP32[gb + 160400 >> 2] | 0) + (gb + 827767 | 0);
 HEAP32[gb + 160404 >> 2] = (HEAP32[gb + 160404 >> 2] | 0) + (gb + 827786 | 0);
 HEAP32[gb + 160432 >> 2] = (HEAP32[gb + 160432 >> 2] | 0) + (gb + 827739 | 0);
 HEAP32[gb + 160436 >> 2] = (HEAP32[gb + 160436 >> 2] | 0) + (gb + 827759 | 0);
 HEAP32[gb + 160464 >> 2] = (HEAP32[gb + 160464 >> 2] | 0) + (gb + 827709 | 0);
 HEAP32[gb + 160468 >> 2] = (HEAP32[gb + 160468 >> 2] | 0) + (gb + 827730 | 0);
 HEAP32[gb + 160496 >> 2] = (HEAP32[gb + 160496 >> 2] | 0) + (gb + 828331 | 0);
 HEAP32[gb + 160528 >> 2] = (HEAP32[gb + 160528 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160532 >> 2] = (HEAP32[gb + 160532 >> 2] | 0) + (gb + 828486 | 0);
 HEAP32[gb + 160560 >> 2] = (HEAP32[gb + 160560 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 160564 >> 2] = (HEAP32[gb + 160564 >> 2] | 0) + (gb + 828472 | 0);
 HEAP32[gb + 160592 >> 2] = (HEAP32[gb + 160592 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 160596 >> 2] = (HEAP32[gb + 160596 >> 2] | 0) + (gb + 828457 | 0);
 HEAP32[gb + 160624 >> 2] = (HEAP32[gb + 160624 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 160628 >> 2] = (HEAP32[gb + 160628 >> 2] | 0) + (gb + 828440 | 0);
 HEAP32[gb + 160656 >> 2] = (HEAP32[gb + 160656 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 160660 >> 2] = (HEAP32[gb + 160660 >> 2] | 0) + (gb + 828427 | 0);
 HEAP32[gb + 160688 >> 2] = (HEAP32[gb + 160688 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 160692 >> 2] = (HEAP32[gb + 160692 >> 2] | 0) + (gb + 828415 | 0);
 HEAP32[gb + 160720 >> 2] = (HEAP32[gb + 160720 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160724 >> 2] = (HEAP32[gb + 160724 >> 2] | 0) + (gb + 828402 | 0);
 HEAP32[gb + 160752 >> 2] = (HEAP32[gb + 160752 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160756 >> 2] = (HEAP32[gb + 160756 >> 2] | 0) + (gb + 828386 | 0);
 HEAP32[gb + 160784 >> 2] = (HEAP32[gb + 160784 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160788 >> 2] = (HEAP32[gb + 160788 >> 2] | 0) + (gb + 828367 | 0);
 HEAP32[gb + 160816 >> 2] = (HEAP32[gb + 160816 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 160820 >> 2] = (HEAP32[gb + 160820 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 160848 >> 2] = (HEAP32[gb + 160848 >> 2] | 0) + (gb + 828300 | 0);
 HEAP32[gb + 160880 >> 2] = (HEAP32[gb + 160880 >> 2] | 0) + (gb + 828331 | 0);
 HEAP32[gb + 160884 >> 2] = (HEAP32[gb + 160884 >> 2] | 0) + (gb + 828353 | 0);
 HEAP32[gb + 160912 >> 2] = (HEAP32[gb + 160912 >> 2] | 0) + (gb + 828579 | 0);
 HEAP32[gb + 160944 >> 2] = (HEAP32[gb + 160944 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160948 >> 2] = (HEAP32[gb + 160948 >> 2] | 0) + (gb + 828742 | 0);
 HEAP32[gb + 160976 >> 2] = (HEAP32[gb + 160976 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160980 >> 2] = (HEAP32[gb + 160980 >> 2] | 0) + (gb + 828721 | 0);
 HEAP32[gb + 161008 >> 2] = (HEAP32[gb + 161008 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161012 >> 2] = (HEAP32[gb + 161012 >> 2] | 0) + (gb + 828701 | 0);
 HEAP32[gb + 161040 >> 2] = (HEAP32[gb + 161040 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161044 >> 2] = (HEAP32[gb + 161044 >> 2] | 0) + (gb + 828689 | 0);
 HEAP32[gb + 161072 >> 2] = (HEAP32[gb + 161072 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161076 >> 2] = (HEAP32[gb + 161076 >> 2] | 0) + (gb + 828678 | 0);
 HEAP32[gb + 161104 >> 2] = (HEAP32[gb + 161104 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161108 >> 2] = (HEAP32[gb + 161108 >> 2] | 0) + (gb + 828668 | 0);
 HEAP32[gb + 161136 >> 2] = (HEAP32[gb + 161136 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 161140 >> 2] = (HEAP32[gb + 161140 >> 2] | 0) + (gb + 828662 | 0);
 HEAP32[gb + 161168 >> 2] = (HEAP32[gb + 161168 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161172 >> 2] = (HEAP32[gb + 161172 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 161200 >> 2] = (HEAP32[gb + 161200 >> 2] | 0) + (gb + 828529 | 0);
 HEAP32[gb + 161232 >> 2] = (HEAP32[gb + 161232 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161236 >> 2] = (HEAP32[gb + 161236 >> 2] | 0) + (gb + 828652 | 0);
 HEAP32[gb + 161264 >> 2] = (HEAP32[gb + 161264 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161268 >> 2] = (HEAP32[gb + 161268 >> 2] | 0) + (gb + 828640 | 0);
 HEAP32[gb + 161296 >> 2] = (HEAP32[gb + 161296 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161300 >> 2] = (HEAP32[gb + 161300 >> 2] | 0) + (gb + 828629 | 0);
 HEAP32[gb + 161328 >> 2] = (HEAP32[gb + 161328 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161332 >> 2] = (HEAP32[gb + 161332 >> 2] | 0) + (gb + 828613 | 0);
 HEAP32[gb + 161360 >> 2] = (HEAP32[gb + 161360 >> 2] | 0) + (gb + 828505 | 0);
 HEAP32[gb + 161392 >> 2] = (HEAP32[gb + 161392 >> 2] | 0) + (gb + 828579 | 0);
 HEAP32[gb + 161396 >> 2] = (HEAP32[gb + 161396 >> 2] | 0) + (gb + 828607 | 0);
 HEAP32[gb + 161424 >> 2] = (HEAP32[gb + 161424 >> 2] | 0) + (gb + 828529 | 0);
 HEAP32[gb + 161428 >> 2] = (HEAP32[gb + 161428 >> 2] | 0) + (gb + 828560 | 0);
 HEAP32[gb + 161456 >> 2] = (HEAP32[gb + 161456 >> 2] | 0) + (gb + 828782 | 0);
 HEAP32[gb + 161488 >> 2] = (HEAP32[gb + 161488 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 161492 >> 2] = (HEAP32[gb + 161492 >> 2] | 0) + (gb + 828845 | 0);
 HEAP32[gb + 161520 >> 2] = (HEAP32[gb + 161520 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 161524 >> 2] = (HEAP32[gb + 161524 >> 2] | 0) + (gb + 828829 | 0);
 HEAP32[gb + 161552 >> 2] = (HEAP32[gb + 161552 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161556 >> 2] = (HEAP32[gb + 161556 >> 2] | 0) + (gb + 828810 | 0);
 HEAP32[gb + 161584 >> 2] = (HEAP32[gb + 161584 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 161588 >> 2] = (HEAP32[gb + 161588 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 161616 >> 2] = (HEAP32[gb + 161616 >> 2] | 0) + (gb + 828758 | 0);
 HEAP32[gb + 161648 >> 2] = (HEAP32[gb + 161648 >> 2] | 0) + (gb + 828782 | 0);
 HEAP32[gb + 161652 >> 2] = (HEAP32[gb + 161652 >> 2] | 0) + (gb + 828607 | 0);
 HEAP32[gb + 161680 >> 2] = (HEAP32[gb + 161680 >> 2] | 0) + (gb + 833702 | 0);
 HEAP32[gb + 161712 >> 2] = (HEAP32[gb + 161712 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161716 >> 2] = (HEAP32[gb + 161716 >> 2] | 0) + (gb + 828887 | 0);
 HEAP32[gb + 161744 >> 2] = (HEAP32[gb + 161744 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161748 >> 2] = (HEAP32[gb + 161748 >> 2] | 0) + (gb + 828873 | 0);
 HEAP32[gb + 161776 >> 2] = (HEAP32[gb + 161776 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161780 >> 2] = (HEAP32[gb + 161780 >> 2] | 0) + (gb + 828859 | 0);
 HEAP32[gb + 161808 >> 2] = (HEAP32[gb + 161808 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 161812 >> 2] = (HEAP32[gb + 161812 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 161840 >> 2] = (HEAP32[gb + 161840 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161872 >> 2] = (HEAP32[gb + 161872 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161904 >> 2] = (HEAP32[gb + 161904 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161936 >> 2] = (HEAP32[gb + 161936 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 161968 >> 2] = (HEAP32[gb + 161968 >> 2] | 0) + (gb + 828315 | 0);
 HEAP32[gb + 162e3 >> 2] = (HEAP32[gb + 162e3 >> 2] | 0) + (gb + 828992 | 0);
 HEAP32[gb + 162004 >> 2] = (HEAP32[gb + 162004 >> 2] | 0) + (gb + 829015 | 0);
 runPostSets191();
}

function runPostSets135() {
 HEAP32[gb + 116064 >> 2] = (HEAP32[gb + 116064 >> 2] | 0) + (gb + 674827 | 0);
 HEAP32[gb + 116080 >> 2] = (HEAP32[gb + 116080 >> 2] | 0) + (gb + 743298 | 0);
 HEAP32[gb + 116088 >> 2] = (HEAP32[gb + 116088 >> 2] | 0) + (gb + 743315 | 0);
 HEAP32[gb + 116096 >> 2] = (HEAP32[gb + 116096 >> 2] | 0) + (gb + 743332 | 0);
 HEAP32[gb + 116104 >> 2] = (HEAP32[gb + 116104 >> 2] | 0) + (gb + 743352 | 0);
 HEAP32[gb + 116112 >> 2] = (HEAP32[gb + 116112 >> 2] | 0) + (gb + 743366 | 0);
 HEAP32[gb + 116120 >> 2] = (HEAP32[gb + 116120 >> 2] | 0) + (gb + 743391 | 0);
 HEAP32[gb + 116128 >> 2] = (HEAP32[gb + 116128 >> 2] | 0) + (gb + 743418 | 0);
 HEAP32[gb + 116144 >> 2] = (HEAP32[gb + 116144 >> 2] | 0) + (gb + 743901 | 0);
 HEAP32[gb + 116176 >> 2] = (HEAP32[gb + 116176 >> 2] | 0) + (gb + 743976 | 0);
 HEAP32[gb + 116180 >> 2] = (HEAP32[gb + 116180 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 116208 >> 2] = (HEAP32[gb + 116208 >> 2] | 0) + (gb + 743909 | 0);
 HEAP32[gb + 116240 >> 2] = (HEAP32[gb + 116240 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116244 >> 2] = (HEAP32[gb + 116244 >> 2] | 0) + (gb + 744141 | 0);
 HEAP32[gb + 116272 >> 2] = (HEAP32[gb + 116272 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116276 >> 2] = (HEAP32[gb + 116276 >> 2] | 0) + (gb + 744125 | 0);
 HEAP32[gb + 116304 >> 2] = (HEAP32[gb + 116304 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116308 >> 2] = (HEAP32[gb + 116308 >> 2] | 0) + (gb + 744110 | 0);
 HEAP32[gb + 116336 >> 2] = (HEAP32[gb + 116336 >> 2] | 0) + (gb + 744080 | 0);
 HEAP32[gb + 116340 >> 2] = (HEAP32[gb + 116340 >> 2] | 0) + (gb + 744104 | 0);
 HEAP32[gb + 116368 >> 2] = (HEAP32[gb + 116368 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116372 >> 2] = (HEAP32[gb + 116372 >> 2] | 0) + (gb + 744073 | 0);
 HEAP32[gb + 116400 >> 2] = (HEAP32[gb + 116400 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116404 >> 2] = (HEAP32[gb + 116404 >> 2] | 0) + (gb + 744067 | 0);
 HEAP32[gb + 116432 >> 2] = (HEAP32[gb + 116432 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116436 >> 2] = (HEAP32[gb + 116436 >> 2] | 0) + (gb + 744061 | 0);
 HEAP32[gb + 116464 >> 2] = (HEAP32[gb + 116464 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116468 >> 2] = (HEAP32[gb + 116468 >> 2] | 0) + (gb + 744035 | 0);
 HEAP32[gb + 116496 >> 2] = (HEAP32[gb + 116496 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116500 >> 2] = (HEAP32[gb + 116500 >> 2] | 0) + (gb + 744008 | 0);
 HEAP32[gb + 116528 >> 2] = (HEAP32[gb + 116528 >> 2] | 0) + (gb + 743976 | 0);
 HEAP32[gb + 116532 >> 2] = (HEAP32[gb + 116532 >> 2] | 0) + (gb + 743997 | 0);
 HEAP32[gb + 116560 >> 2] = (HEAP32[gb + 116560 >> 2] | 0) + (gb + 743937 | 0);
 HEAP32[gb + 116592 >> 2] = (HEAP32[gb + 116592 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 116596 >> 2] = (HEAP32[gb + 116596 >> 2] | 0) + (gb + 747335 | 0);
 HEAP32[gb + 116624 >> 2] = (HEAP32[gb + 116624 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 116628 >> 2] = (HEAP32[gb + 116628 >> 2] | 0) + (gb + 743965 | 0);
 HEAP32[gb + 116656 >> 2] = (HEAP32[gb + 116656 >> 2] | 0) + (gb + 829242 | 0);
 HEAP32[gb + 116660 >> 2] = (HEAP32[gb + 116660 >> 2] | 0) + (gb + 743951 | 0);
 HEAP32[gb + 116688 >> 2] = (HEAP32[gb + 116688 >> 2] | 0) + (gb + 743927 | 0);
 HEAP32[gb + 116692 >> 2] = (HEAP32[gb + 116692 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 116720 >> 2] = (HEAP32[gb + 116720 >> 2] | 0) + (gb + 743909 | 0);
 HEAP32[gb + 116752 >> 2] = (HEAP32[gb + 116752 >> 2] | 0) + (gb + 744189 | 0);
 HEAP32[gb + 116756 >> 2] = (HEAP32[gb + 116756 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 116784 >> 2] = (HEAP32[gb + 116784 >> 2] | 0) + (gb + 744155 | 0);
 HEAP32[gb + 116816 >> 2] = (HEAP32[gb + 116816 >> 2] | 0) + (gb + 744241 | 0);
 HEAP32[gb + 116820 >> 2] = (HEAP32[gb + 116820 >> 2] | 0) + (gb + 744104 | 0);
 HEAP32[gb + 116848 >> 2] = (HEAP32[gb + 116848 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116852 >> 2] = (HEAP32[gb + 116852 >> 2] | 0) + (gb + 744230 | 0);
 HEAP32[gb + 116880 >> 2] = (HEAP32[gb + 116880 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116884 >> 2] = (HEAP32[gb + 116884 >> 2] | 0) + (gb + 744219 | 0);
 HEAP32[gb + 116912 >> 2] = (HEAP32[gb + 116912 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116916 >> 2] = (HEAP32[gb + 116916 >> 2] | 0) + (gb + 744211 | 0);
 HEAP32[gb + 116944 >> 2] = (HEAP32[gb + 116944 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 116948 >> 2] = (HEAP32[gb + 116948 >> 2] | 0) + (gb + 744035 | 0);
 HEAP32[gb + 116976 >> 2] = (HEAP32[gb + 116976 >> 2] | 0) + (gb + 744189 | 0);
 HEAP32[gb + 116980 >> 2] = (HEAP32[gb + 116980 >> 2] | 0) + (gb + 743997 | 0);
 HEAP32[gb + 117008 >> 2] = (HEAP32[gb + 117008 >> 2] | 0) + (gb + 744174 | 0);
 HEAP32[gb + 117040 >> 2] = (HEAP32[gb + 117040 >> 2] | 0) + (gb + 744155 | 0);
 HEAP32[gb + 117072 >> 2] = (HEAP32[gb + 117072 >> 2] | 0) + (gb + 744290 | 0);
 HEAP32[gb + 117076 >> 2] = (HEAP32[gb + 117076 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 117104 >> 2] = (HEAP32[gb + 117104 >> 2] | 0) + (gb + 744258 | 0);
 HEAP32[gb + 117136 >> 2] = (HEAP32[gb + 117136 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117140 >> 2] = (HEAP32[gb + 117140 >> 2] | 0) + (gb + 744321 | 0);
 HEAP32[gb + 117168 >> 2] = (HEAP32[gb + 117168 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117172 >> 2] = (HEAP32[gb + 117172 >> 2] | 0) + (gb + 839419 | 0);
 HEAP32[gb + 117200 >> 2] = (HEAP32[gb + 117200 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117204 >> 2] = (HEAP32[gb + 117204 >> 2] | 0) + (gb + 744311 | 0);
 HEAP32[gb + 117232 >> 2] = (HEAP32[gb + 117232 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 117236 >> 2] = (HEAP32[gb + 117236 >> 2] | 0) + (gb + 754100 | 0);
 HEAP32[gb + 117264 >> 2] = (HEAP32[gb + 117264 >> 2] | 0) + (gb + 744290 | 0);
 HEAP32[gb + 117268 >> 2] = (HEAP32[gb + 117268 >> 2] | 0) + (gb + 743997 | 0);
 HEAP32[gb + 117296 >> 2] = (HEAP32[gb + 117296 >> 2] | 0) + (gb + 744276 | 0);
 HEAP32[gb + 117328 >> 2] = (HEAP32[gb + 117328 >> 2] | 0) + (gb + 744258 | 0);
 HEAP32[gb + 117360 >> 2] = (HEAP32[gb + 117360 >> 2] | 0) + (gb + 744645 | 0);
 HEAP32[gb + 117364 >> 2] = (HEAP32[gb + 117364 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 117392 >> 2] = (HEAP32[gb + 117392 >> 2] | 0) + (gb + 744333 | 0);
 HEAP32[gb + 117424 >> 2] = (HEAP32[gb + 117424 >> 2] | 0) + (gb + 744645 | 0);
 HEAP32[gb + 117428 >> 2] = (HEAP32[gb + 117428 >> 2] | 0) + (gb + 744662 | 0);
 HEAP32[gb + 117456 >> 2] = (HEAP32[gb + 117456 >> 2] | 0) + (gb + 744614 | 0);
 HEAP32[gb + 117460 >> 2] = (HEAP32[gb + 117460 >> 2] | 0) + (gb + 744633 | 0);
 HEAP32[gb + 117488 >> 2] = (HEAP32[gb + 117488 >> 2] | 0) + (gb + 744241 | 0);
 HEAP32[gb + 117492 >> 2] = (HEAP32[gb + 117492 >> 2] | 0) + (gb + 744603 | 0);
 HEAP32[gb + 117520 >> 2] = (HEAP32[gb + 117520 >> 2] | 0) + (gb + 744080 | 0);
 HEAP32[gb + 117524 >> 2] = (HEAP32[gb + 117524 >> 2] | 0) + (gb + 744592 | 0);
 HEAP32[gb + 117552 >> 2] = (HEAP32[gb + 117552 >> 2] | 0) + (gb + 744571 | 0);
 HEAP32[gb + 117556 >> 2] = (HEAP32[gb + 117556 >> 2] | 0) + (gb + 744586 | 0);
 HEAP32[gb + 117584 >> 2] = (HEAP32[gb + 117584 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 117588 >> 2] = (HEAP32[gb + 117588 >> 2] | 0) + (gb + 744557 | 0);
 HEAP32[gb + 117616 >> 2] = (HEAP32[gb + 117616 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 117620 >> 2] = (HEAP32[gb + 117620 >> 2] | 0) + (gb + 744537 | 0);
 HEAP32[gb + 117648 >> 2] = (HEAP32[gb + 117648 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 117652 >> 2] = (HEAP32[gb + 117652 >> 2] | 0) + (gb + 744516 | 0);
 HEAP32[gb + 117680 >> 2] = (HEAP32[gb + 117680 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 117684 >> 2] = (HEAP32[gb + 117684 >> 2] | 0) + (gb + 744509 | 0);
 HEAP32[gb + 117712 >> 2] = (HEAP32[gb + 117712 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 117716 >> 2] = (HEAP32[gb + 117716 >> 2] | 0) + (gb + 744501 | 0);
 HEAP32[gb + 117744 >> 2] = (HEAP32[gb + 117744 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 117748 >> 2] = (HEAP32[gb + 117748 >> 2] | 0) + (gb + 744493 | 0);
 HEAP32[gb + 117776 >> 2] = (HEAP32[gb + 117776 >> 2] | 0) + (gb + 827843 | 0);
 runPostSets136();
}

function runPostSets192() {
 HEAP32[gb + 163856 >> 2] = (HEAP32[gb + 163856 >> 2] | 0) + (gb + 829860 | 0);
 HEAP32[gb + 163860 >> 2] = (HEAP32[gb + 163860 >> 2] | 0) + (gb + 829888 | 0);
 HEAP32[gb + 163888 >> 2] = (HEAP32[gb + 163888 >> 2] | 0) + (gb + 829683 | 0);
 HEAP32[gb + 163892 >> 2] = (HEAP32[gb + 163892 >> 2] | 0) + (gb + 829844 | 0);
 HEAP32[gb + 163920 >> 2] = (HEAP32[gb + 163920 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 163924 >> 2] = (HEAP32[gb + 163924 >> 2] | 0) + (gb + 829125 | 0);
 HEAP32[gb + 163952 >> 2] = (HEAP32[gb + 163952 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 163956 >> 2] = (HEAP32[gb + 163956 >> 2] | 0) + (gb + 829109 | 0);
 HEAP32[gb + 163984 >> 2] = (HEAP32[gb + 163984 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 163988 >> 2] = (HEAP32[gb + 163988 >> 2] | 0) + (gb + 829818 | 0);
 HEAP32[gb + 164016 >> 2] = (HEAP32[gb + 164016 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164020 >> 2] = (HEAP32[gb + 164020 >> 2] | 0) + (gb + 829790 | 0);
 HEAP32[gb + 164048 >> 2] = (HEAP32[gb + 164048 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 164052 >> 2] = (HEAP32[gb + 164052 >> 2] | 0) + (gb + 829761 | 0);
 HEAP32[gb + 164080 >> 2] = (HEAP32[gb + 164080 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 164084 >> 2] = (HEAP32[gb + 164084 >> 2] | 0) + (gb + 829731 | 0);
 HEAP32[gb + 164112 >> 2] = (HEAP32[gb + 164112 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 164116 >> 2] = (HEAP32[gb + 164116 >> 2] | 0) + (gb + 829707 | 0);
 HEAP32[gb + 164144 >> 2] = (HEAP32[gb + 164144 >> 2] | 0) + (gb + 829683 | 0);
 HEAP32[gb + 164176 >> 2] = (HEAP32[gb + 164176 >> 2] | 0) + (gb + 830246 | 0);
 HEAP32[gb + 164208 >> 2] = (HEAP32[gb + 164208 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164212 >> 2] = (HEAP32[gb + 164212 >> 2] | 0) + (gb + 830757 | 0);
 HEAP32[gb + 164240 >> 2] = (HEAP32[gb + 164240 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164244 >> 2] = (HEAP32[gb + 164244 >> 2] | 0) + (gb + 830739 | 0);
 HEAP32[gb + 164272 >> 2] = (HEAP32[gb + 164272 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164276 >> 2] = (HEAP32[gb + 164276 >> 2] | 0) + (gb + 830723 | 0);
 HEAP32[gb + 164304 >> 2] = (HEAP32[gb + 164304 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164308 >> 2] = (HEAP32[gb + 164308 >> 2] | 0) + (gb + 830713 | 0);
 HEAP32[gb + 164336 >> 2] = (HEAP32[gb + 164336 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164340 >> 2] = (HEAP32[gb + 164340 >> 2] | 0) + (gb + 830701 | 0);
 HEAP32[gb + 164368 >> 2] = (HEAP32[gb + 164368 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164372 >> 2] = (HEAP32[gb + 164372 >> 2] | 0) + (gb + 830687 | 0);
 HEAP32[gb + 164400 >> 2] = (HEAP32[gb + 164400 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164404 >> 2] = (HEAP32[gb + 164404 >> 2] | 0) + (gb + 830663 | 0);
 HEAP32[gb + 164432 >> 2] = (HEAP32[gb + 164432 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164436 >> 2] = (HEAP32[gb + 164436 >> 2] | 0) + (gb + 830645 | 0);
 HEAP32[gb + 164464 >> 2] = (HEAP32[gb + 164464 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164468 >> 2] = (HEAP32[gb + 164468 >> 2] | 0) + (gb + 830624 | 0);
 HEAP32[gb + 164496 >> 2] = (HEAP32[gb + 164496 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164500 >> 2] = (HEAP32[gb + 164500 >> 2] | 0) + (gb + 830609 | 0);
 HEAP32[gb + 164528 >> 2] = (HEAP32[gb + 164528 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 164532 >> 2] = (HEAP32[gb + 164532 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 164560 >> 2] = (HEAP32[gb + 164560 >> 2] | 0) + (gb + 830219 | 0);
 HEAP32[gb + 164592 >> 2] = (HEAP32[gb + 164592 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164596 >> 2] = (HEAP32[gb + 164596 >> 2] | 0) + (gb + 830601 | 0);
 HEAP32[gb + 164624 >> 2] = (HEAP32[gb + 164624 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164628 >> 2] = (HEAP32[gb + 164628 >> 2] | 0) + (gb + 830594 | 0);
 HEAP32[gb + 164656 >> 2] = (HEAP32[gb + 164656 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164660 >> 2] = (HEAP32[gb + 164660 >> 2] | 0) + (gb + 830588 | 0);
 HEAP32[gb + 164688 >> 2] = (HEAP32[gb + 164688 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164692 >> 2] = (HEAP32[gb + 164692 >> 2] | 0) + (gb + 828159 | 0);
 HEAP32[gb + 164720 >> 2] = (HEAP32[gb + 164720 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164724 >> 2] = (HEAP32[gb + 164724 >> 2] | 0) + (gb + 830575 | 0);
 HEAP32[gb + 164752 >> 2] = (HEAP32[gb + 164752 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164756 >> 2] = (HEAP32[gb + 164756 >> 2] | 0) + (gb + 830559 | 0);
 HEAP32[gb + 164784 >> 2] = (HEAP32[gb + 164784 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164788 >> 2] = (HEAP32[gb + 164788 >> 2] | 0) + (gb + 830539 | 0);
 HEAP32[gb + 164816 >> 2] = (HEAP32[gb + 164816 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164820 >> 2] = (HEAP32[gb + 164820 >> 2] | 0) + (gb + 830529 | 0);
 HEAP32[gb + 164848 >> 2] = (HEAP32[gb + 164848 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164852 >> 2] = (HEAP32[gb + 164852 >> 2] | 0) + (gb + 830519 | 0);
 HEAP32[gb + 164880 >> 2] = (HEAP32[gb + 164880 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164884 >> 2] = (HEAP32[gb + 164884 >> 2] | 0) + (gb + 830506 | 0);
 HEAP32[gb + 164912 >> 2] = (HEAP32[gb + 164912 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164916 >> 2] = (HEAP32[gb + 164916 >> 2] | 0) + (gb + 828023 | 0);
 HEAP32[gb + 164944 >> 2] = (HEAP32[gb + 164944 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 164948 >> 2] = (HEAP32[gb + 164948 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 164976 >> 2] = (HEAP32[gb + 164976 >> 2] | 0) + (gb + 830194 | 0);
 HEAP32[gb + 165008 >> 2] = (HEAP32[gb + 165008 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165012 >> 2] = (HEAP32[gb + 165012 >> 2] | 0) + (gb + 830495 | 0);
 HEAP32[gb + 165040 >> 2] = (HEAP32[gb + 165040 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165044 >> 2] = (HEAP32[gb + 165044 >> 2] | 0) + (gb + 830484 | 0);
 HEAP32[gb + 165072 >> 2] = (HEAP32[gb + 165072 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165076 >> 2] = (HEAP32[gb + 165076 >> 2] | 0) + (gb + 830447 | 0);
 HEAP32[gb + 165104 >> 2] = (HEAP32[gb + 165104 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165108 >> 2] = (HEAP32[gb + 165108 >> 2] | 0) + (gb + 830416 | 0);
 HEAP32[gb + 165136 >> 2] = (HEAP32[gb + 165136 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165140 >> 2] = (HEAP32[gb + 165140 >> 2] | 0) + (gb + 830395 | 0);
 HEAP32[gb + 165168 >> 2] = (HEAP32[gb + 165168 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 165172 >> 2] = (HEAP32[gb + 165172 >> 2] | 0) + (gb + 828662 | 0);
 HEAP32[gb + 165200 >> 2] = (HEAP32[gb + 165200 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165204 >> 2] = (HEAP32[gb + 165204 >> 2] | 0) + (gb + 830353 | 0);
 HEAP32[gb + 165232 >> 2] = (HEAP32[gb + 165232 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165236 >> 2] = (HEAP32[gb + 165236 >> 2] | 0) + (gb + 830318 | 0);
 HEAP32[gb + 165264 >> 2] = (HEAP32[gb + 165264 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165268 >> 2] = (HEAP32[gb + 165268 >> 2] | 0) + (gb + 830283 | 0);
 HEAP32[gb + 165296 >> 2] = (HEAP32[gb + 165296 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165300 >> 2] = (HEAP32[gb + 165300 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 165328 >> 2] = (HEAP32[gb + 165328 >> 2] | 0) + (gb + 829683 | 0);
 HEAP32[gb + 165360 >> 2] = (HEAP32[gb + 165360 >> 2] | 0) + (gb + 830246 | 0);
 HEAP32[gb + 165364 >> 2] = (HEAP32[gb + 165364 >> 2] | 0) + (gb + 830270 | 0);
 HEAP32[gb + 165392 >> 2] = (HEAP32[gb + 165392 >> 2] | 0) + (gb + 830219 | 0);
 HEAP32[gb + 165396 >> 2] = (HEAP32[gb + 165396 >> 2] | 0) + (gb + 830238 | 0);
 HEAP32[gb + 165424 >> 2] = (HEAP32[gb + 165424 >> 2] | 0) + (gb + 830194 | 0);
 HEAP32[gb + 165428 >> 2] = (HEAP32[gb + 165428 >> 2] | 0) + (gb + 830212 | 0);
 HEAP32[gb + 165456 >> 2] = (HEAP32[gb + 165456 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 165460 >> 2] = (HEAP32[gb + 165460 >> 2] | 0) + (gb + 830164 | 0);
 HEAP32[gb + 165488 >> 2] = (HEAP32[gb + 165488 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 165492 >> 2] = (HEAP32[gb + 165492 >> 2] | 0) + (gb + 830138 | 0);
 HEAP32[gb + 165520 >> 2] = (HEAP32[gb + 165520 >> 2] | 0) + (gb + 829437 | 0);
 runPostSets193();
}

function runPostSets144() {
 HEAP32[gb + 131972 >> 2] = (HEAP32[gb + 131972 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 131976 >> 2] = (HEAP32[gb + 131976 >> 2] | 0) + (gb + 751798 | 0);
 HEAP32[gb + 132004 >> 2] = (HEAP32[gb + 132004 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 132008 >> 2] = (HEAP32[gb + 132008 >> 2] | 0) + (gb + 751786 | 0);
 HEAP32[gb + 132036 >> 2] = (HEAP32[gb + 132036 >> 2] | 0) + (gb + 751769 | 0);
 HEAP32[gb + 132040 >> 2] = (HEAP32[gb + 132040 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132068 >> 2] = (HEAP32[gb + 132068 >> 2] | 0) + (gb + 751698 | 0);
 HEAP32[gb + 132100 >> 2] = (HEAP32[gb + 132100 >> 2] | 0) + (gb + 751673 | 0);
 HEAP32[gb + 132104 >> 2] = (HEAP32[gb + 132104 >> 2] | 0) + (gb + 750514 | 0);
 HEAP32[gb + 132132 >> 2] = (HEAP32[gb + 132132 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 132136 >> 2] = (HEAP32[gb + 132136 >> 2] | 0) + (gb + 749669 | 0);
 HEAP32[gb + 132164 >> 2] = (HEAP32[gb + 132164 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 132168 >> 2] = (HEAP32[gb + 132168 >> 2] | 0) + (gb + 751752 | 0);
 HEAP32[gb + 132196 >> 2] = (HEAP32[gb + 132196 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 132200 >> 2] = (HEAP32[gb + 132200 >> 2] | 0) + (gb + 749656 | 0);
 HEAP32[gb + 132228 >> 2] = (HEAP32[gb + 132228 >> 2] | 0) + (gb + 751725 | 0);
 HEAP32[gb + 132232 >> 2] = (HEAP32[gb + 132232 >> 2] | 0) + (gb + 751738 | 0);
 HEAP32[gb + 132260 >> 2] = (HEAP32[gb + 132260 >> 2] | 0) + (gb + 751991 | 0);
 HEAP32[gb + 132292 >> 2] = (HEAP32[gb + 132292 >> 2] | 0) + (gb + 751685 | 0);
 HEAP32[gb + 132296 >> 2] = (HEAP32[gb + 132296 >> 2] | 0) + (gb + 750514 | 0);
 HEAP32[gb + 132324 >> 2] = (HEAP32[gb + 132324 >> 2] | 0) + (gb + 751711 | 0);
 HEAP32[gb + 132356 >> 2] = (HEAP32[gb + 132356 >> 2] | 0) + (gb + 752095 | 0);
 HEAP32[gb + 132360 >> 2] = (HEAP32[gb + 132360 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 132388 >> 2] = (HEAP32[gb + 132388 >> 2] | 0) + (gb + 752030 | 0);
 HEAP32[gb + 132392 >> 2] = (HEAP32[gb + 132392 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132420 >> 2] = (HEAP32[gb + 132420 >> 2] | 0) + (gb + 752006 | 0);
 HEAP32[gb + 132424 >> 2] = (HEAP32[gb + 132424 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132452 >> 2] = (HEAP32[gb + 132452 >> 2] | 0) + (gb + 748168 | 0);
 HEAP32[gb + 132484 >> 2] = (HEAP32[gb + 132484 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 132488 >> 2] = (HEAP32[gb + 132488 >> 2] | 0) + (gb + 752129 | 0);
 HEAP32[gb + 132516 >> 2] = (HEAP32[gb + 132516 >> 2] | 0) + (gb + 752120 | 0);
 HEAP32[gb + 132520 >> 2] = (HEAP32[gb + 132520 >> 2] | 0) + (gb + 750541 | 0);
 HEAP32[gb + 132548 >> 2] = (HEAP32[gb + 132548 >> 2] | 0) + (gb + 752095 | 0);
 HEAP32[gb + 132552 >> 2] = (HEAP32[gb + 132552 >> 2] | 0) + (gb + 752108 | 0);
 HEAP32[gb + 132580 >> 2] = (HEAP32[gb + 132580 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132584 >> 2] = (HEAP32[gb + 132584 >> 2] | 0) + (gb + 752084 | 0);
 HEAP32[gb + 132612 >> 2] = (HEAP32[gb + 132612 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132616 >> 2] = (HEAP32[gb + 132616 >> 2] | 0) + (gb + 752063 | 0);
 HEAP32[gb + 132644 >> 2] = (HEAP32[gb + 132644 >> 2] | 0) + (gb + 752030 | 0);
 HEAP32[gb + 132648 >> 2] = (HEAP32[gb + 132648 >> 2] | 0) + (gb + 752047 | 0);
 HEAP32[gb + 132676 >> 2] = (HEAP32[gb + 132676 >> 2] | 0) + (gb + 752006 | 0);
 HEAP32[gb + 132680 >> 2] = (HEAP32[gb + 132680 >> 2] | 0) + (gb + 752017 | 0);
 HEAP32[gb + 132708 >> 2] = (HEAP32[gb + 132708 >> 2] | 0) + (gb + 752155 | 0);
 HEAP32[gb + 132740 >> 2] = (HEAP32[gb + 132740 >> 2] | 0) + (gb + 774333 | 0);
 HEAP32[gb + 132744 >> 2] = (HEAP32[gb + 132744 >> 2] | 0) + (gb + 1034510 | 0);
 HEAP32[gb + 132772 >> 2] = (HEAP32[gb + 132772 >> 2] | 0) + (gb + 752462 | 0);
 HEAP32[gb + 132776 >> 2] = (HEAP32[gb + 132776 >> 2] | 0) + (gb + 752490 | 0);
 HEAP32[gb + 132804 >> 2] = (HEAP32[gb + 132804 >> 2] | 0) + (gb + 752462 | 0);
 HEAP32[gb + 132808 >> 2] = (HEAP32[gb + 132808 >> 2] | 0) + (gb + 752475 | 0);
 HEAP32[gb + 132836 >> 2] = (HEAP32[gb + 132836 >> 2] | 0) + (gb + 752462 | 0);
 HEAP32[gb + 132840 >> 2] = (HEAP32[gb + 132840 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 132868 >> 2] = (HEAP32[gb + 132868 >> 2] | 0) + (gb + 752364 | 0);
 HEAP32[gb + 132872 >> 2] = (HEAP32[gb + 132872 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 132900 >> 2] = (HEAP32[gb + 132900 >> 2] | 0) + (gb + 752331 | 0);
 HEAP32[gb + 132904 >> 2] = (HEAP32[gb + 132904 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 132932 >> 2] = (HEAP32[gb + 132932 >> 2] | 0) + (gb + 752249 | 0);
 HEAP32[gb + 132964 >> 2] = (HEAP32[gb + 132964 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 132968 >> 2] = (HEAP32[gb + 132968 >> 2] | 0) + (gb + 752457 | 0);
 HEAP32[gb + 132996 >> 2] = (HEAP32[gb + 132996 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133e3 >> 2] = (HEAP32[gb + 133e3 >> 2] | 0) + (gb + 752449 | 0);
 HEAP32[gb + 133028 >> 2] = (HEAP32[gb + 133028 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133032 >> 2] = (HEAP32[gb + 133032 >> 2] | 0) + (gb + 752440 | 0);
 HEAP32[gb + 133060 >> 2] = (HEAP32[gb + 133060 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133064 >> 2] = (HEAP32[gb + 133064 >> 2] | 0) + (gb + 752431 | 0);
 HEAP32[gb + 133092 >> 2] = (HEAP32[gb + 133092 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133096 >> 2] = (HEAP32[gb + 133096 >> 2] | 0) + (gb + 752421 | 0);
 HEAP32[gb + 133124 >> 2] = (HEAP32[gb + 133124 >> 2] | 0) + (gb + 752155 | 0);
 HEAP32[gb + 133128 >> 2] = (HEAP32[gb + 133128 >> 2] | 0) + (gb + 752413 | 0);
 HEAP32[gb + 133156 >> 2] = (HEAP32[gb + 133156 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133160 >> 2] = (HEAP32[gb + 133160 >> 2] | 0) + (gb + 752403 | 0);
 HEAP32[gb + 133188 >> 2] = (HEAP32[gb + 133188 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133192 >> 2] = (HEAP32[gb + 133192 >> 2] | 0) + (gb + 752383 | 0);
 HEAP32[gb + 133220 >> 2] = (HEAP32[gb + 133220 >> 2] | 0) + (gb + 752364 | 0);
 HEAP32[gb + 133224 >> 2] = (HEAP32[gb + 133224 >> 2] | 0) + (gb + 1040342 | 0);
 HEAP32[gb + 133252 >> 2] = (HEAP32[gb + 133252 >> 2] | 0) + (gb + 752331 | 0);
 HEAP32[gb + 133256 >> 2] = (HEAP32[gb + 133256 >> 2] | 0) + (gb + 752357 | 0);
 HEAP32[gb + 133284 >> 2] = (HEAP32[gb + 133284 >> 2] | 0) + (gb + 774412 | 0);
 HEAP32[gb + 133288 >> 2] = (HEAP32[gb + 133288 >> 2] | 0) + (gb + 752325 | 0);
 HEAP32[gb + 133316 >> 2] = (HEAP32[gb + 133316 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133320 >> 2] = (HEAP32[gb + 133320 >> 2] | 0) + (gb + 752314 | 0);
 HEAP32[gb + 133348 >> 2] = (HEAP32[gb + 133348 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133352 >> 2] = (HEAP32[gb + 133352 >> 2] | 0) + (gb + 752300 | 0);
 HEAP32[gb + 133380 >> 2] = (HEAP32[gb + 133380 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133384 >> 2] = (HEAP32[gb + 133384 >> 2] | 0) + (gb + 752293 | 0);
 HEAP32[gb + 133412 >> 2] = (HEAP32[gb + 133412 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133416 >> 2] = (HEAP32[gb + 133416 >> 2] | 0) + (gb + 752286 | 0);
 HEAP32[gb + 133444 >> 2] = (HEAP32[gb + 133444 >> 2] | 0) + (gb + 752265 | 0);
 HEAP32[gb + 133448 >> 2] = (HEAP32[gb + 133448 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 133476 >> 2] = (HEAP32[gb + 133476 >> 2] | 0) + (gb + 754632 | 0);
 HEAP32[gb + 133508 >> 2] = (HEAP32[gb + 133508 >> 2] | 0) + (gb + 752249 | 0);
 HEAP32[gb + 133512 >> 2] = (HEAP32[gb + 133512 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 133540 >> 2] = (HEAP32[gb + 133540 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133544 >> 2] = (HEAP32[gb + 133544 >> 2] | 0) + (gb + 752235 | 0);
 HEAP32[gb + 133572 >> 2] = (HEAP32[gb + 133572 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 133576 >> 2] = (HEAP32[gb + 133576 >> 2] | 0) + (gb + 752224 | 0);
 HEAP32[gb + 133604 >> 2] = (HEAP32[gb + 133604 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133608 >> 2] = (HEAP32[gb + 133608 >> 2] | 0) + (gb + 752213 | 0);
 HEAP32[gb + 133636 >> 2] = (HEAP32[gb + 133636 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 133640 >> 2] = (HEAP32[gb + 133640 >> 2] | 0) + (gb + 752202 | 0);
 HEAP32[gb + 133668 >> 2] = (HEAP32[gb + 133668 >> 2] | 0) + (gb + 752175 | 0);
 runPostSets145();
}

function runPostSets146() {
 HEAP32[gb + 135560 >> 2] = (HEAP32[gb + 135560 >> 2] | 0) + (gb + 752813 | 0);
 HEAP32[gb + 135588 >> 2] = (HEAP32[gb + 135588 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135592 >> 2] = (HEAP32[gb + 135592 >> 2] | 0) + (gb + 752801 | 0);
 HEAP32[gb + 135620 >> 2] = (HEAP32[gb + 135620 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135624 >> 2] = (HEAP32[gb + 135624 >> 2] | 0) + (gb + 752789 | 0);
 HEAP32[gb + 135652 >> 2] = (HEAP32[gb + 135652 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135656 >> 2] = (HEAP32[gb + 135656 >> 2] | 0) + (gb + 752781 | 0);
 HEAP32[gb + 135684 >> 2] = (HEAP32[gb + 135684 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 135688 >> 2] = (HEAP32[gb + 135688 >> 2] | 0) + (gb + 752664 | 0);
 HEAP32[gb + 135716 >> 2] = (HEAP32[gb + 135716 >> 2] | 0) + (gb + 752764 | 0);
 HEAP32[gb + 135720 >> 2] = (HEAP32[gb + 135720 >> 2] | 0) + (gb + 752774 | 0);
 HEAP32[gb + 135748 >> 2] = (HEAP32[gb + 135748 >> 2] | 0) + (gb + 752764 | 0);
 HEAP32[gb + 135780 >> 2] = (HEAP32[gb + 135780 >> 2] | 0) + (gb + 753223 | 0);
 HEAP32[gb + 135812 >> 2] = (HEAP32[gb + 135812 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135816 >> 2] = (HEAP32[gb + 135816 >> 2] | 0) + (gb + 753356 | 0);
 HEAP32[gb + 135844 >> 2] = (HEAP32[gb + 135844 >> 2] | 0) + (gb + 753057 | 0);
 HEAP32[gb + 135876 >> 2] = (HEAP32[gb + 135876 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 135880 >> 2] = (HEAP32[gb + 135880 >> 2] | 0) + (gb + 753349 | 0);
 HEAP32[gb + 135908 >> 2] = (HEAP32[gb + 135908 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 135912 >> 2] = (HEAP32[gb + 135912 >> 2] | 0) + (gb + 753342 | 0);
 HEAP32[gb + 135940 >> 2] = (HEAP32[gb + 135940 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 135944 >> 2] = (HEAP32[gb + 135944 >> 2] | 0) + (gb + 753016 | 0);
 HEAP32[gb + 135972 >> 2] = (HEAP32[gb + 135972 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 135976 >> 2] = (HEAP32[gb + 135976 >> 2] | 0) + (gb + 753332 | 0);
 HEAP32[gb + 136004 >> 2] = (HEAP32[gb + 136004 >> 2] | 0) + (gb + 753101 | 0);
 HEAP32[gb + 136036 >> 2] = (HEAP32[gb + 136036 >> 2] | 0) + (gb + 774412 | 0);
 HEAP32[gb + 136040 >> 2] = (HEAP32[gb + 136040 >> 2] | 0) + (gb + 752325 | 0);
 HEAP32[gb + 136068 >> 2] = (HEAP32[gb + 136068 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 136072 >> 2] = (HEAP32[gb + 136072 >> 2] | 0) + (gb + 753318 | 0);
 HEAP32[gb + 136100 >> 2] = (HEAP32[gb + 136100 >> 2] | 0) + (gb + 753057 | 0);
 HEAP32[gb + 136104 >> 2] = (HEAP32[gb + 136104 >> 2] | 0) + (gb + 753308 | 0);
 HEAP32[gb + 136132 >> 2] = (HEAP32[gb + 136132 >> 2] | 0) + (gb + 753143 | 0);
 HEAP32[gb + 136136 >> 2] = (HEAP32[gb + 136136 >> 2] | 0) + (gb + 753290 | 0);
 HEAP32[gb + 136164 >> 2] = (HEAP32[gb + 136164 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 136168 >> 2] = (HEAP32[gb + 136168 >> 2] | 0) + (gb + 753281 | 0);
 HEAP32[gb + 136196 >> 2] = (HEAP32[gb + 136196 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136200 >> 2] = (HEAP32[gb + 136200 >> 2] | 0) + (gb + 753265 | 0);
 HEAP32[gb + 136228 >> 2] = (HEAP32[gb + 136228 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136232 >> 2] = (HEAP32[gb + 136232 >> 2] | 0) + (gb + 753253 | 0);
 HEAP32[gb + 136260 >> 2] = (HEAP32[gb + 136260 >> 2] | 0) + (gb + 753223 | 0);
 HEAP32[gb + 136264 >> 2] = (HEAP32[gb + 136264 >> 2] | 0) + (gb + 753243 | 0);
 HEAP32[gb + 136292 >> 2] = (HEAP32[gb + 136292 >> 2] | 0) + (gb + 754608 | 0);
 HEAP32[gb + 136324 >> 2] = (HEAP32[gb + 136324 >> 2] | 0) + (gb + 753101 | 0);
 HEAP32[gb + 136328 >> 2] = (HEAP32[gb + 136328 >> 2] | 0) + (gb + 753116 | 0);
 HEAP32[gb + 136356 >> 2] = (HEAP32[gb + 136356 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 136360 >> 2] = (HEAP32[gb + 136360 >> 2] | 0) + (gb + 753097 | 0);
 HEAP32[gb + 136388 >> 2] = (HEAP32[gb + 136388 >> 2] | 0) + (gb + 753033 | 0);
 HEAP32[gb + 136392 >> 2] = (HEAP32[gb + 136392 >> 2] | 0) + (gb + 753082 | 0);
 HEAP32[gb + 136420 >> 2] = (HEAP32[gb + 136420 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 136424 >> 2] = (HEAP32[gb + 136424 >> 2] | 0) + (gb + 830588 | 0);
 HEAP32[gb + 136452 >> 2] = (HEAP32[gb + 136452 >> 2] | 0) + (gb + 774450 | 0);
 HEAP32[gb + 136456 >> 2] = (HEAP32[gb + 136456 >> 2] | 0) + (gb + 753073 | 0);
 HEAP32[gb + 136484 >> 2] = (HEAP32[gb + 136484 >> 2] | 0) + (gb + 752175 | 0);
 HEAP32[gb + 136488 >> 2] = (HEAP32[gb + 136488 >> 2] | 0) + (gb + 752189 | 0);
 HEAP32[gb + 136516 >> 2] = (HEAP32[gb + 136516 >> 2] | 0) + (gb + 753057 | 0);
 HEAP32[gb + 136548 >> 2] = (HEAP32[gb + 136548 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 136580 >> 2] = (HEAP32[gb + 136580 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136612 >> 2] = (HEAP32[gb + 136612 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136644 >> 2] = (HEAP32[gb + 136644 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136676 >> 2] = (HEAP32[gb + 136676 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136680 >> 2] = (HEAP32[gb + 136680 >> 2] | 0) + (gb + 753047 | 0);
 HEAP32[gb + 136708 >> 2] = (HEAP32[gb + 136708 >> 2] | 0) + (gb + 753033 | 0);
 HEAP32[gb + 136740 >> 2] = (HEAP32[gb + 136740 >> 2] | 0) + (gb + 753126 | 0);
 HEAP32[gb + 136772 >> 2] = (HEAP32[gb + 136772 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 136776 >> 2] = (HEAP32[gb + 136776 >> 2] | 0) + (gb + 754446 | 0);
 HEAP32[gb + 136804 >> 2] = (HEAP32[gb + 136804 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 136808 >> 2] = (HEAP32[gb + 136808 >> 2] | 0) + (gb + 753215 | 0);
 HEAP32[gb + 136836 >> 2] = (HEAP32[gb + 136836 >> 2] | 0) + (gb + 753143 | 0);
 HEAP32[gb + 136868 >> 2] = (HEAP32[gb + 136868 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 136872 >> 2] = (HEAP32[gb + 136872 >> 2] | 0) + (gb + 753207 | 0);
 HEAP32[gb + 136900 >> 2] = (HEAP32[gb + 136900 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 136904 >> 2] = (HEAP32[gb + 136904 >> 2] | 0) + (gb + 752224 | 0);
 HEAP32[gb + 136932 >> 2] = (HEAP32[gb + 136932 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 136936 >> 2] = (HEAP32[gb + 136936 >> 2] | 0) + (gb + 753198 | 0);
 HEAP32[gb + 136964 >> 2] = (HEAP32[gb + 136964 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 136968 >> 2] = (HEAP32[gb + 136968 >> 2] | 0) + (gb + 753016 | 0);
 HEAP32[gb + 136996 >> 2] = (HEAP32[gb + 136996 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 137e3 >> 2] = (HEAP32[gb + 137e3 >> 2] | 0) + (gb + 753186 | 0);
 HEAP32[gb + 137028 >> 2] = (HEAP32[gb + 137028 >> 2] | 0) + (gb + 753126 | 0);
 HEAP32[gb + 137032 >> 2] = (HEAP32[gb + 137032 >> 2] | 0) + (gb + 753175 | 0);
 HEAP32[gb + 137060 >> 2] = (HEAP32[gb + 137060 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137064 >> 2] = (HEAP32[gb + 137064 >> 2] | 0) + (gb + 753160 | 0);
 HEAP32[gb + 137092 >> 2] = (HEAP32[gb + 137092 >> 2] | 0) + (gb + 753033 | 0);
 HEAP32[gb + 137124 >> 2] = (HEAP32[gb + 137124 >> 2] | 0) + (gb + 753143 | 0);
 HEAP32[gb + 137128 >> 2] = (HEAP32[gb + 137128 >> 2] | 0) + (gb + 829289 | 0);
 HEAP32[gb + 137156 >> 2] = (HEAP32[gb + 137156 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 137160 >> 2] = (HEAP32[gb + 137160 >> 2] | 0) + (gb + 753134 | 0);
 HEAP32[gb + 137188 >> 2] = (HEAP32[gb + 137188 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137220 >> 2] = (HEAP32[gb + 137220 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137252 >> 2] = (HEAP32[gb + 137252 >> 2] | 0) + (gb + 753126 | 0);
 HEAP32[gb + 137284 >> 2] = (HEAP32[gb + 137284 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137288 >> 2] = (HEAP32[gb + 137288 >> 2] | 0) + (gb + 753047 | 0);
 HEAP32[gb + 137316 >> 2] = (HEAP32[gb + 137316 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137348 >> 2] = (HEAP32[gb + 137348 >> 2] | 0) + (gb + 753954 | 0);
 HEAP32[gb + 137352 >> 2] = (HEAP32[gb + 137352 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 137380 >> 2] = (HEAP32[gb + 137380 >> 2] | 0) + (gb + 753896 | 0);
 HEAP32[gb + 137412 >> 2] = (HEAP32[gb + 137412 >> 2] | 0) + (gb + 753954 | 0);
 HEAP32[gb + 137416 >> 2] = (HEAP32[gb + 137416 >> 2] | 0) + (gb + 828662 | 0);
 HEAP32[gb + 137444 >> 2] = (HEAP32[gb + 137444 >> 2] | 0) + (gb + 754297 | 0);
 HEAP32[gb + 137448 >> 2] = (HEAP32[gb + 137448 >> 2] | 0) + (gb + 767061 | 0);
 runPostSets147();
}

function __ZNK18AssetBundleManager24GetAssetBundleScenePathsERK8UnityStrRS0_S3_(i1, i8, i2, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 68 | 0;
 i11 = i16 + 56 | 0;
 i12 = i16 + 40 | 0;
 i13 = i16 + 24 | 0;
 i14 = i16 + 12 | 0;
 i15 = i16;
 HEAP32[i11 >> 2] = 0;
 __ZNK18AssetBundleManager37GetAssetBundleAndScenePathBySceneNameERK8UnityStrRP11AssetBundleRS0_(i1, i8, i11, i2);
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 148 >> 2] | 0;
  if (i1 | 0) if (HEAP8[i1 + 184 >> 0] | 0) {
   i2 = HEAP32[i1 + 120 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i1 + 124 >> 2] | 0)) {
    i1 = i2 + 20 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i12 + 12 >> 2] = i2;
    i3 = _strlen(i1) | 0;
    if (i3 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
     i2 = HEAP32[i12 + 12 >> 2] | 0;
     i4 = 11;
    } else if (i3 >>> 0 < 11) {
     HEAP8[i12 + 11 >> 0] = i3;
     if (!i3) i1 = i12; else {
      i2 = i12;
      i4 = 13;
     }
    } else i4 = 11;
    if ((i4 | 0) == 11) {
     i7 = i3 + 16 & -16;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i9 + 4 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i12 + 8 >> 2] = i7 | -2147483648;
     HEAP32[i12 + 4 >> 2] = i3;
     i4 = 13;
    }
    if ((i4 | 0) == 13) {
     _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
     i1 = i2;
    }
    HEAP8[i1 + i3 >> 0] = 0;
    i4 = i12 + 11 | 0;
    do if ((i12 | 0) != (i10 | 0)) {
     i6 = HEAP8[i4 >> 0] | 0;
     i7 = i6 << 24 >> 24 < 0;
     i5 = i7 ? HEAP32[i12 >> 2] | 0 : i12;
     i6 = i7 ? HEAP32[i12 + 4 >> 2] | 0 : i6 & 255;
     i7 = i10 + 11 | 0;
     i1 = HEAP8[i7 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
     if (i6 >>> 0 > i3 >>> 0) {
      i7 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i6 - i3 | 0, i7, 0, i7, i6, i5);
      break;
     }
     i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
     if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
     HEAP8[i1 + i6 >> 0] = 0;
     if ((HEAP8[i7 >> 0] | 0) < 0) {
      HEAP32[i10 + 4 >> 2] = i6;
      break;
     } else {
      HEAP8[i7 >> 0] = i6;
      break;
     }
    } while (0);
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     i7 = HEAP32[i12 >> 2] | 0;
     i6 = HEAP32[i12 + 12 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i9 + 4 >> 2] = i6;
     __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
    }
    i6 = i10 + 11 | 0;
    i2 = HEAP8[i6 >> 0] | 0;
    i1 = i2 << 24 >> 24 < 0;
    i7 = i10 + 4 | 0;
    i4 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
    i2 = i1 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, i2);
    i2 = HEAP32[gb + 27264 >> 2] | 0;
    __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9, i12);
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    i4 = _strlen(i2) | 0;
    i1 = i9 + 11 | 0;
    i5 = HEAP8[i1 >> 0] | 0;
    i5 = i5 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i2, i4, i5 + i4 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, i5) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i5 = HEAP8[i11 + 11 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i4 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
    i5 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255;
    i1 = HEAP8[i6 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    do if (i5 >>> 0 > i3 >>> 0) {
     i2 = i2 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i2, 0, i2, i5, i4);
    } else {
     i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
     if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
     HEAP8[i1 + i5 >> 0] = 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) {
      HEAP32[i7 >> 2] = i5;
      break;
     } else {
      HEAP8[i6 >> 0] = i5;
      break;
     }
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    i1 = HEAP8[i6 >> 0] | 0;
    i5 = i1 << 24 >> 24 < 0;
    i4 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
    i1 = i5 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, i1);
    i1 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i1 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i1 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i5, i1);
    __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9, i15);
    __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i9);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = 0;
    HEAP32[i13 + 8 >> 2] = 0;
    i1 = i14 + 11 | 0;
    i5 = HEAP8[i1 >> 0] | 0;
    i5 = i5 << 24 >> 24 < 0 ? HEAP32[i14 + 4 >> 2] | 0 : i5 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, gb + 368404 | 0, 12, i5 + 12 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, i5) | 0;
    __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i12, i13);
    i5 = HEAP8[i11 + 11 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i4 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
    i5 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255;
    i1 = HEAP8[i6 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    do if (i5 >>> 0 > i3 >>> 0) {
     i9 = i2 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i9, 0, i9, i5, i4);
    } else {
     i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
     if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
     HEAP8[i1 + i5 >> 0] = 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) {
      HEAP32[i7 >> 2] = i5;
      break;
     } else {
      HEAP8[i6 >> 0] = i5;
      break;
     }
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   }
  }
 }
 i15 = 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 348 | 0, gb + 734938 | 0, 0);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 116 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 124 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 128 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 148 | 0, i5);
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 160 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 172 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 176 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 180 | 0, i5);
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 192 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 296 | 0, gb + 735185 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 324 | 0, gb + 735202 | 0, 0);
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 204 | 0, i5);
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 216 | 0, i5);
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 228 | 0, i5);
 __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 308 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 336 | 0, gb + 735263 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 288 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 252 | 0, i5);
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 240 | 0, i5);
 __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 264 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 276 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 280 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 284 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 292 >> 0] = i1;
 i1 = i4 + 293 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__211__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri(i1, i2, i3, i6, i7, i8, i9, i5, i4, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1) {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476292 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP8[i3 + 1 >> 0] = i1 >> 8;
  HEAP8[i3 + 2 >> 0] = i1 >> 16;
  HEAP8[i3 + 3 >> 0] = i1 >> 24;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i4 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i4 >> 2] >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
  } else {
   HEAP32[i4 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i4 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  };
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i5 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
  } else {
   HEAP32[i5 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i5 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  };
  HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP32[i9 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 } else {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476284 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP8[i3 + 1 >> 0] = i1 >> 8;
  HEAP8[i3 + 2 >> 0] = i1 >> 16;
  HEAP8[i3 + 3 >> 0] = i1 >> 24;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i4 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i4 >> 2] >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
  } else {
   HEAP32[i4 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i4 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  };
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i5 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i5 >> 2] >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
  } else {
   HEAP32[i5 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i5 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  };
  HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 8 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP32[i9 >> 2] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4514 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 }
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sq16BucketPrunerCoreC2Eb(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i8 + 544 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAPF32[i8 + 568 >> 2] = Math_fround(.75);
 HEAP32[i8 + 572 >> 2] = -1;
 HEAP32[i8 + 576 >> 2] = 0;
 HEAP32[i8 + 580 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i5, 64);
 HEAP32[i8 + 584 >> 2] = 0;
 HEAP32[i8 + 588 >> 2] = 0;
 HEAP32[i8 + 592 >> 2] = 0;
 i5 = i8 + 608 | 0;
 HEAP32[i8 + 688 >> 2] = 0;
 HEAP32[i8 + 692 >> 2] = 0;
 HEAP32[i8 + 696 >> 2] = 0;
 HEAP32[i8 + 704 >> 2] = -25165825;
 HEAP32[i8 + 708 >> 2] = -25165825;
 HEAP32[i8 + 712 >> 2] = -25165825;
 HEAP32[i8 + 720 >> 2] = 0;
 HEAP32[i8 + 724 >> 2] = 0;
 HEAP32[i8 + 728 >> 2] = 0;
 HEAP32[i8 + 736 >> 2] = -25165825;
 HEAP32[i8 + 740 >> 2] = -25165825;
 HEAP32[i8 + 744 >> 2] = -25165825;
 HEAP32[i8 + 752 >> 2] = 0;
 HEAP32[i8 + 756 >> 2] = 0;
 HEAP32[i8 + 760 >> 2] = 0;
 HEAP32[i8 + 768 >> 2] = -25165825;
 HEAP32[i8 + 772 >> 2] = -25165825;
 HEAP32[i8 + 776 >> 2] = -25165825;
 HEAP32[i8 + 784 >> 2] = 0;
 HEAP32[i8 + 788 >> 2] = 0;
 HEAP32[i8 + 792 >> 2] = 0;
 HEAP32[i8 + 800 >> 2] = -25165825;
 HEAP32[i8 + 804 >> 2] = -25165825;
 HEAP32[i8 + 808 >> 2] = -25165825;
 HEAP32[i8 + 816 >> 2] = 0;
 HEAP32[i8 + 820 >> 2] = 0;
 HEAP32[i8 + 824 >> 2] = 0;
 HEAP32[i8 + 832 >> 2] = -25165825;
 HEAP32[i8 + 836 >> 2] = -25165825;
 HEAP32[i8 + 840 >> 2] = -25165825;
 i7 = i8 + 864 | 0;
 i1 = i8 + 1984 | 0;
 i2 = i7;
 do {
  HEAP32[i2 + 48 >> 2] = 0;
  HEAP32[i2 + 52 >> 2] = 0;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 64 >> 2] = -25165825;
  HEAP32[i2 + 68 >> 2] = -25165825;
  HEAP32[i2 + 72 >> 2] = -25165825;
  HEAP32[i2 + 80 >> 2] = 0;
  HEAP32[i2 + 84 >> 2] = 0;
  HEAP32[i2 + 88 >> 2] = 0;
  HEAP32[i2 + 96 >> 2] = -25165825;
  HEAP32[i2 + 100 >> 2] = -25165825;
  HEAP32[i2 + 104 >> 2] = -25165825;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i2 + 116 >> 2] = 0;
  HEAP32[i2 + 120 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = -25165825;
  HEAP32[i2 + 132 >> 2] = -25165825;
  HEAP32[i2 + 136 >> 2] = -25165825;
  HEAP32[i2 + 144 >> 2] = 0;
  HEAP32[i2 + 148 >> 2] = 0;
  HEAP32[i2 + 152 >> 2] = 0;
  HEAP32[i2 + 160 >> 2] = -25165825;
  HEAP32[i2 + 164 >> 2] = -25165825;
  HEAP32[i2 + 168 >> 2] = -25165825;
  HEAP32[i2 + 176 >> 2] = 0;
  HEAP32[i2 + 180 >> 2] = 0;
  HEAP32[i2 + 184 >> 2] = 0;
  HEAP32[i2 + 192 >> 2] = -25165825;
  HEAP32[i2 + 196 >> 2] = -25165825;
  HEAP32[i2 + 200 >> 2] = -25165825;
  i2 = i2 + 224 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i1 = i8 + 640 | 0;
 i4 = i8 + 1984 | 0;
 i2 = i8 + 7584 | 0;
 i3 = i4;
 do {
  HEAP32[i3 + 48 >> 2] = 0;
  HEAP32[i3 + 52 >> 2] = 0;
  HEAP32[i3 + 56 >> 2] = 0;
  HEAP32[i3 + 64 >> 2] = -25165825;
  HEAP32[i3 + 68 >> 2] = -25165825;
  HEAP32[i3 + 72 >> 2] = -25165825;
  HEAP32[i3 + 80 >> 2] = 0;
  HEAP32[i3 + 84 >> 2] = 0;
  HEAP32[i3 + 88 >> 2] = 0;
  HEAP32[i3 + 96 >> 2] = -25165825;
  HEAP32[i3 + 100 >> 2] = -25165825;
  HEAP32[i3 + 104 >> 2] = -25165825;
  HEAP32[i3 + 112 >> 2] = 0;
  HEAP32[i3 + 116 >> 2] = 0;
  HEAP32[i3 + 120 >> 2] = 0;
  HEAP32[i3 + 128 >> 2] = -25165825;
  HEAP32[i3 + 132 >> 2] = -25165825;
  HEAP32[i3 + 136 >> 2] = -25165825;
  HEAP32[i3 + 144 >> 2] = 0;
  HEAP32[i3 + 148 >> 2] = 0;
  HEAP32[i3 + 152 >> 2] = 0;
  HEAP32[i3 + 160 >> 2] = -25165825;
  HEAP32[i3 + 164 >> 2] = -25165825;
  HEAP32[i3 + 168 >> 2] = -25165825;
  HEAP32[i3 + 176 >> 2] = 0;
  HEAP32[i3 + 180 >> 2] = 0;
  HEAP32[i3 + 184 >> 2] = 0;
  HEAP32[i3 + 192 >> 2] = -25165825;
  HEAP32[i3 + 196 >> 2] = -25165825;
  HEAP32[i3 + 200 >> 2] = -25165825;
  i3 = i3 + 224 | 0;
 } while ((i3 | 0) != (i2 | 0));
 HEAP8[i8 + 7584 >> 0] = 1;
 HEAP8[i8 + 7585 >> 0] = i6 & 1 ^ 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 612 >> 2] = 0;
 HEAP32[i8 + 616 >> 2] = 0;
 HEAP32[i8 + 624 >> 2] = -25165825;
 HEAP32[i8 + 628 >> 2] = -25165825;
 HEAP32[i8 + 632 >> 2] = -25165825;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i7;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 1088 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 1312 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 1536 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 1760 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i4;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 2208 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 2432 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 2656 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 2880 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 3104 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 3328 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 3552 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 3776 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 4e3 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 4224 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 4448 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 4672 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 4896 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 5120 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 5344 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 5568 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 5792 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 6016 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 6240 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 6464 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 6688 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 6912 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 7136 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i8 + 7360 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN15DirectorManager17RemoveFromManagerEP18PlayableController(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i13 = i18 + 24 | 0;
 i10 = i16 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[i15 + 444 >> 2] | 0;
  i12 = i15 + 456 | 0;
  i9 = i16 + 4 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i8 = 0;
  i2 = i5;
  i7 = i5;
  i6 = i5;
  while (1) {
   L5 : do if (!i2) {
    i3 = i5;
    i4 = i7;
    i5 = i6;
    i2 = 0;
   } else {
    i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    L7 : do if (!i2) {
     i2 = i11 + (i7 << 2) | 0;
     i3 = i11;
     while (1) {
      if (!(HEAP32[i3 >> 2] | 0)) {
       i2 = 0;
       i1 = i3;
       break L7;
      }
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i2 | 0)) {
       i3 = i5;
       i4 = i7;
       i5 = i7;
       i2 = i7;
       break L5;
      }
     }
    } else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     i3 = i11 + (i6 << 2) | 0;
     i4 = i11;
     while (1) {
      if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) {
       i1 = i4;
       break L7;
      }
      i4 = i4 + 4 | 0;
      if ((i4 | 0) == (i3 | 0)) {
       i3 = i5;
       i4 = i7;
       i5 = i6;
       i2 = i6;
       break L5;
      }
     }
    } while (0);
    i3 = i11 + (i5 + -1 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i3 >> 2] = i2;
    i2 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
    HEAP32[i12 >> 2] = i2;
    i3 = i2;
    i4 = i2;
    i5 = i2;
    i1 = HEAP32[i10 >> 2] | 0;
   } while (0);
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i1 >>> 0) break; else {
    i7 = i4;
    i6 = i5;
    i5 = i3;
   }
  }
 }
 i3 = HEAP32[i15 + 364 >> 2] | 0;
 i4 = i15 + 376 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L19 : do if (!i5) i3 = 0; else {
  i6 = i3 + (i5 << 2) | 0;
  i1 = i3;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i16 | 0)) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i3 = 0;
    break L19;
   }
  }
  i12 = i5 + -1 | 0;
  i3 = i3 + (i12 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  HEAP32[i4 >> 2] = i12;
  i3 = 1;
 } while (0);
 i4 = HEAP32[i15 + 384 >> 2] | 0;
 i5 = i15 + 396 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L26 : do if (!i6) i14 = 23; else {
  i7 = i4 + (i6 << 2) | 0;
  i1 = i4;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == (i16 | 0)) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i7 | 0)) {
    i14 = 23;
    break L26;
   }
  }
  i12 = i6 + -1 | 0;
  i11 = i4 + (i12 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i11 >> 2] = i2;
  HEAP32[i5 >> 2] = i12;
 } while (0);
 if ((i14 | 0) == 23) if (!i3) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = 0;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 63664 | 0);
 i1 = i17;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = HEAP32[i16 + 160 >> 2] | 0;
 i5 = i15 + 140 + (i7 * 20 | 0) + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 L36 : do if (i1 | 0) {
  i6 = i15 + 140 + (i7 * 20 | 0) | 0;
  i4 = 0;
  do {
   while (1) {
    i2 = HEAP32[i6 >> 2] | 0;
    i3 = i2 + (i4 * 24 | 0) | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i16 | 0)) break;
    i1 = i2 + ((i1 + -1 | 0) * 24 | 0) | 0;
    HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i17 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i17 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
    i1 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
    HEAP32[i5 >> 2] = i1;
    if (i4 >>> 0 >= i1 >>> 0) break L36;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 } while (0);
 i6 = i15 + (i7 * 20 | 0) + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 L45 : do if (i1 | 0) {
  i5 = i15 + (i7 * 20 | 0) | 0;
  i4 = 0;
  do {
   while (1) {
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i2 + (i4 * 24 | 0) | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i16 | 0)) break;
    i1 = i2 + ((i1 + -1 | 0) * 24 | 0) | 0;
    HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i17 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i17 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
    i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
    HEAP32[i6 >> 2] = i1;
    if (i4 >>> 0 >= i1 >>> 0) break L45;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 } while (0);
 i8 = 0;
 do {
  i10 = i15 + 280 + (i8 * 12 | 0) | 0;
  i11 = i15 + 280 + (i8 * 12 | 0) + 4 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i9 = 0;
   do {
    if ((i2 | 0) == (i1 | 0)) i2 = i1; else {
     i7 = 0;
     do {
      i6 = i1 + (i7 * 24 | 0) + 16 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      L62 : do if (i2 | 0) {
       i5 = i1 + (i7 * 24 | 0) + 4 | 0;
       i4 = 0;
       i1 = i2;
       do {
        while (1) {
         i2 = HEAP32[i5 >> 2] | 0;
         i3 = i2 + (i4 * 24 | 0) | 0;
         if ((HEAP32[i3 >> 2] | 0) != (i16 | 0)) break;
         i1 = i2 + ((i1 + -1 | 0) * 24 | 0) | 0;
         HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
         HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
         HEAP32[i17 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
         HEAP32[i17 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
         HEAP32[i17 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
         HEAP32[i17 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
         HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
         HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
         HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
         HEAP32[i1 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
         HEAP32[i1 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
         i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
         HEAP32[i6 >> 2] = i1;
         if (i4 >>> 0 >= i1 >>> 0) break L62;
        }
        i4 = i4 + 1 | 0;
       } while (i4 >>> 0 < i1 >>> 0);
      } while (0);
      i7 = i7 + 1 | 0;
      i2 = HEAP32[i11 >> 2] | 0;
      i1 = HEAP32[i10 >> 2] | 0;
     } while (i7 >>> 0 < ((i2 - i1 | 0) / 24 | 0) >>> 0);
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < ((i2 - i1 | 0) / 24 | 0) >>> 0);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 7);
 __Z19free_alloc_internalPvRK10MemLabelId(0, i12);
 STACKTOP = i18;
 return;
}

function __ZN4math8Collider8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906345 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 913271 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906349 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906363 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906377 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 56 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906391 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 56; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 56; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906403 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 67; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 67; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 67) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906415 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 78; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 78; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 78) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906427 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 89; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 89; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 89) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i23, i2, i25, i26, i22, i27, i1) {
 i23 = i23 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i22 = i22 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f24 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31 + 32 | 0;
 i29 = i31 + 16 | 0;
 i30 = i31;
 if (!(HEAP8[i2 + 869 >> 0] | 0)) {
  STACKTOP = i31;
  return;
 }
 f24 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (i22 >>> 0 >= i27 >>> 0) {
  STACKTOP = i31;
  return;
 }
 i13 = i2 + 60 | 0;
 i14 = i2 + 80 | 0;
 i15 = i2 + 100 | 0;
 i16 = i2 + 120 | 0;
 i17 = i2 + 140 | 0;
 i18 = i2 + 160 | 0;
 i19 = i28 + 4 | 0;
 i20 = i28 + 8 | 0;
 i21 = i28 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i29 + 4 | 0;
 i4 = i29 + 8 | 0;
 i5 = i29 + 12 | 0;
 i6 = i26 + 4 | 0;
 i7 = i26 + 8 | 0;
 i8 = i26 + 12 | 0;
 i9 = i30 + 4 | 0;
 i10 = i30 + 8 | 0;
 i11 = i30 + 12 | 0;
 i1 = i22;
 do {
  i45 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f65 = Math_fround(HEAPF32[i45 >> 2]);
  f64 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f63 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f61 = Math_fround(HEAPF32[i45 >> 2]);
  f60 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f58 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i45 >> 2]);
  f56 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f54 = Math_fround(HEAPF32[i45 >> 2]);
  f52 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i17 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i45 >> 2]);
  f51 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i45 >> 2]);
  f41 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f54 = Math_fround(f65 + f54);
  f52 = Math_fround(f64 + f52);
  f32 = Math_fround(f63 + f32);
  f36 = Math_fround(f62 + f36);
  f53 = Math_fround(f61 + f53);
  f51 = Math_fround(f60 + f51);
  f34 = Math_fround(f59 + f34);
  f38 = Math_fround(f58 + f38);
  f39 = Math_fround(f57 + f39);
  f41 = Math_fround(f56 + f41);
  f42 = Math_fround(f55 + f42);
  f43 = Math_fround(f43 + Math_fround(HEAPF32[i45 + 12 >> 2]));
  f39 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f53 * f53)) + Math_fround(f39 * f39))))));
  f41 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51)) + Math_fround(f41 * f41))))));
  f42 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f34 * f34)) + Math_fround(f42 * f42))))));
  f43 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f38 * f38)) + Math_fround(f43 * f43))))));
  i45 = f39 < Math_fround(0.0);
  f39 = i45 ? Math_fround(0.0) : f39;
  i45 = f41 < Math_fround(0.0);
  f41 = i45 ? Math_fround(0.0) : f41;
  i45 = f42 < Math_fround(0.0);
  f42 = i45 ? Math_fround(0.0) : f42;
  i45 = f43 < Math_fround(0.0);
  f43 = i45 ? Math_fround(0.0) : f43;
  i45 = f39 > Math_fround(1.0);
  f39 = i45 ? Math_fround(1.0) : f39;
  i45 = f41 > Math_fround(1.0);
  f41 = i45 ? Math_fround(1.0) : f41;
  i45 = f42 > Math_fround(1.0);
  f42 = i45 ? Math_fround(1.0) : f42;
  i45 = f43 > Math_fround(1.0);
  f43 = i45 ? Math_fround(1.0) : f43;
  HEAPF32[i28 >> 2] = f39;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f42;
  HEAPF32[i21 >> 2] = f43;
  i45 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i22 = HEAP32[i45 >> 2] | 0;
  i35 = HEAP32[i45 + 4 >> 2] | 0;
  i40 = HEAP32[i45 + 8 >> 2] | 0;
  i45 = HEAP32[i45 + 12 >> 2] | 0;
  i37 = i22 + -557535583 | 0;
  i50 = i35 + -557535583 | 0;
  i48 = i40 + -557535583 | 0;
  i46 = i45 + -557535583 | 0;
  i33 = (Math_imul(i37, 1790253981) | 0) + 1900727103 | 0;
  i49 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
  i47 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
  i37 = i37 << 11 ^ i37;
  i50 = i50 << 11 ^ i50;
  i48 = i48 << 11 ^ i48;
  i46 = i46 << 11 ^ i46;
  f43 = Math_fround(Math_fround((i49 ^ i50 ^ i50 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i47 ^ i48 ^ i48 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i44 ^ i46 ^ i46 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i29 >> 2] = Math_fround(Math_fround((i33 ^ i37 ^ i37 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  i22 = i22 + -13913692 | 0;
  i35 = i35 + -13913692 | 0;
  i40 = i40 + -13913692 | 0;
  i45 = i45 + -13913692 | 0;
  i33 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i22 = i22 << 11 ^ i22;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i45 = i45 << 11 ^ i45;
  f41 = Math_fround(Math_fround((i33 ^ i22 ^ i22 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f43 = Math_fround(Math_fround((i44 ^ i40 ^ i40 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f39 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i46 = f41 > Math_fround(HEAPF32[i26 >> 2]);
  i45 = f42 > Math_fround(HEAPF32[i6 >> 2]);
  i44 = f43 > Math_fround(HEAPF32[i7 >> 2]);
  i40 = f39 > Math_fround(HEAPF32[i8 >> 2]);
  i37 = i25 + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i37 >> 2]);
  i35 = i37 + 4 | 0;
  f43 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i37 + 8 | 0;
  f42 = Math_fround(HEAPF32[i33 >> 2]);
  i22 = i37 + 12 | 0;
  f41 = Math_fround(HEAPF32[i22 >> 2]);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i30, i23, i28, i29);
  f38 = Math_fround(HEAPF32[i30 >> 2]);
  f38 = Math_fround((i46 ? Math_fround(1.0) : Math_fround(-1.0)) * f38);
  f36 = Math_fround(HEAPF32[i9 >> 2]);
  f36 = Math_fround((i45 ? Math_fround(1.0) : Math_fround(-1.0)) * f36);
  f34 = Math_fround(HEAPF32[i10 >> 2]);
  f34 = Math_fround((i44 ? Math_fround(1.0) : Math_fround(-1.0)) * f34);
  f32 = Math_fround(HEAPF32[i11 >> 2]);
  f36 = Math_fround(f43 + f36);
  f34 = Math_fround(f42 + f34);
  f32 = Math_fround(f41 + Math_fround((i40 ? Math_fround(1.0) : Math_fround(-1.0)) * f32));
  HEAPF32[i37 >> 2] = Math_fround(f39 + f38);
  HEAPF32[i35 >> 2] = f36;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i22 >> 2] = f32;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i27 >>> 0);
 STACKTOP = i31;
 return;
}

function __Z17UnloadAssetBundleR11AssetBundleb(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 60 | 0;
 i18 = i22 + 48 | 0;
 i11 = i22 + 36 | 0;
 i19 = i22 + 24 | 0;
 i20 = i22 + 12 | 0;
 i21 = i22;
 i14 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = __Z21GetAssetBundleManagerv() | 0;
 if (!i14) i1 = 0; else {
  HEAP32[i18 >> 2] = i14;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i18);
    i2 = HEAP32[i17 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i4 = 9;
   }
  }
  if ((i4 | 0) == 7) i4 = 9;
  if ((i4 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i14) | 0;
 }
 __ZN18AssetBundleManager17UnloadAssetBundleEP11AssetBundle(i5, i1);
 i15 = __Z20GetPersistentManagerv() | 0;
 i16 = HEAP32[i6 + 148 >> 2] | 0;
 if (!i16) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 584200 | 0, 0, gb + 584241 | 0, 687, 1, 0, 0, 0);
  STACKTOP = i22;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i19, i6 + 152 | 0);
 i12 = (HEAP8[i6 + 164 >> 0] | 0) == 0;
 i13 = i16 + 120 | 0;
 i1 = (HEAP32[i13 >> 2] | 0) + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, _strlen(i1) | 0);
 __Z28GetAbsoluteAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i20, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i9 = i16 + 124 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i9 >> 2] | 0) != (i1 | 0)) {
  i6 = i11 + 4 | 0;
  i7 = i11 + 8 | 0;
  i8 = i11 + 4 | 0;
  i5 = 0;
  do {
   do if (HEAP32[i1 + (i5 * 40 | 0) + 16 >> 2] & 4 | 0) {
    i1 = i1 + (i5 * 40 | 0) + 20 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i1, _strlen(i1) | 0);
    __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i17, i20, i18);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i21, i17) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    if (!i10) {
     __ZN17PersistentManager21RemoveObjectsFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i15, i21) | 0;
     break;
    }
    HEAP32[i6 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i11 >> 2] = i8;
    __ZN17PersistentManager26GetLoadedInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE(__Z20GetPersistentManagerv() | 0, i21, i11);
    i1 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) != (i8 | 0)) {
     i2 = i1;
     while (1) {
      HEAP32[i18 >> 2] = HEAP32[i2 + 16 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i1 = 0; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i3 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i18);
        i3 = HEAP32[i17 >> 2] | 0;
        i23 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i3 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
      }
      __Z22delete_object_internalP6Object(i1);
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((i1 | 0) == (i8 | 0)) break; else i2 = i1;
     }
    }
    __ZN17PersistentManager21RemoveObjectsFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z20GetPersistentManagerv() | 0, i21) | 0;
    __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i11, HEAP32[i8 >> 2] | 0);
   } while (0);
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i13 >> 2] | 0;
  } while (i5 >>> 0 < (((HEAP32[i9 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0);
 }
 __Z43DestroyWithoutLoadingButDontDestroyFromFilei(i14);
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i4 = 0;
  while (1) {
   i2 = i1;
   if (!(HEAP32[i2 + (i4 * 40 | 0) + 16 >> 2] & 4)) i2 = i3; else {
    i1 = i2 + (i4 * 40 | 0) + 20 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i18 + 4 >> 2] = 0;
    HEAP32[i18 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i1, _strlen(i1) | 0);
    __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i17, i20, i18);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i21, i17) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i15, i21, 1);
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= ((i2 - i1 | 0) / 40 | 0) >>> 0) break; else i3 = i2;
  }
 }
 __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader(__Z24GetAssetBundleFileSystemv() | 0, i16);
 i23 = i16 + 4 | 0;
 HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
 if (!(HEAP32[i23 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i16, gb + 63552 | 0);
 }
 i23 = HEAP8[i19 + 11 >> 0] | 0;
 do if ((i23 << 24 >> 24 < 0 ? HEAP32[i19 + 4 >> 2] | 0 : i23 & 255) | 0) if (i12) {
  __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i19) | 0;
  __ZN10FileSystem23UnmountMemoryFileSystemEv(__Z13GetFileSystemv() | 0);
  break;
 } else {
  __ZN14CachingManager20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z17GetCachingManagerv() | 0, i19);
  break;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 STACKTOP = i22;
 return;
}

function _UNITY_png_handle_iTXt(i23, i21, i6) {
 i23 = i23 | 0;
 i21 = i21 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24;
 i1 = i23 + 632 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 switch (i2 | 0) {
 case 0:
  break;
 case 1:
  {
   _UNITY_png_crc_finish(i23, i6) | 0;
   STACKTOP = i24;
   return;
  }
 default:
  i14 = 3;
 }
 if ((i14 | 0) == 3) {
  i20 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i20;
  if ((i20 | 0) == 1) {
   _UNITY_png_crc_finish(i23, i6) | 0;
   _UNITY_png_chunk_benign_error(i23, gb + 352181 | 0);
   STACKTOP = i24;
   return;
  }
 }
 i1 = i23 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 1)) _UNITY_png_chunk_error(i23, gb + 352205 | 0);
 if (i2 & 4 | 0) HEAP32[i1 >> 2] = i2 | 8;
 i3 = i6 + 1 | 0;
 i20 = i23 + 644 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i14 = 12; else {
  i2 = i23 + 648 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < i3 >>> 0) {
   HEAP32[i20 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   _UNITY_png_free(i23, i1);
   i14 = 12;
  } else i19 = i1;
 }
 do if ((i14 | 0) == 12) {
  i1 = _UNITY_png_malloc_base(i23, i3) | 0;
  if (i1 | 0) {
   HEAP32[i20 >> 2] = i1;
   HEAP32[i23 + 648 >> 2] = i3;
   i19 = i1;
   break;
  }
  _UNITY_png_crc_finish(i23, i6) | 0;
  _UNITY_png_chunk_benign_error(i23, gb + 661520 | 0);
  STACKTOP = i24;
  return;
 } while (0);
 _UNITY_png_read_data(i23, i19, i6);
 _UNITY_png_calculate_crc(i23, i19, i6);
 if (_UNITY_png_crc_finish(i23, 0) | 0) {
  STACKTOP = i24;
  return;
 }
 L28 : do if (!i6) i1 = gb + 352289 | 0; else {
  i1 = 0;
  do {
   if (!(HEAP8[i19 + i1 >> 0] | 0)) break;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i6 >>> 0);
  if ((i1 + -1 | 0) >>> 0 > 78) i1 = gb + 352289 | 0; else if ((i1 + 5 | 0) >>> 0 > i6 >>> 0) i1 = gb + 352279 | 0; else {
   i2 = HEAP8[i19 + (i1 + 1) >> 0] | 0;
   switch (i2 << 24 >> 24) {
   case 0:
    break;
   case 1:
    {
     if (HEAP8[i19 + (i1 + 2) >> 0] | 0) {
      i1 = gb + 352258 | 0;
      break L28;
     }
     break;
    }
   default:
    {
     i1 = gb + 352258 | 0;
     break L28;
    }
   }
   i18 = i2 << 24 >> 24 != 0;
   i17 = i1 + 3 | 0;
   L38 : do if (i17 >>> 0 < i6 >>> 0) {
    i1 = i17;
    do {
     if (!(HEAP8[i19 + i1 >> 0] | 0)) break L38;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i6 >>> 0);
   } else i1 = i17; while (0);
   i16 = i1 + 1 | 0;
   L43 : do if (i16 >>> 0 < i6 >>> 0) {
    i1 = i16;
    while (1) {
     if (!(HEAP8[i19 + i1 >> 0] | 0)) {
      i5 = i1;
      break L43;
     }
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i6 >>> 0) {
      i5 = i1;
      break;
     }
    }
   } else i5 = i16; while (0);
   i15 = i5 + 1 | 0;
   L48 : do if (i18 | i15 >>> 0 > i6 >>> 0) {
    if (!(i18 & i15 >>> 0 < i6 >>> 0)) {
     i1 = gb + 352279 | 0;
     break L28;
    }
    i1 = HEAP32[i23 + 636 >> 2] | 0;
    switch (i1 | 0) {
    case -1:
    case 0:
     {
      i1 = -1;
      i2 = i5 + 2 | 0;
      i14 = 35;
      break;
     }
    default:
     {
      i2 = i5 + 2 | 0;
      if (i1 >>> 0 < i2 >>> 0) {
       _UNITY_png_zstream_error(i23, -4);
       i3 = -1;
      } else i14 = 35;
     }
    }
    L55 : do if ((i14 | 0) == 35) {
     i1 = i1 - i2 | 0;
     i4 = i23 + 372 | 0;
     if (!(_UNITY_png_inflate_claim(i23, HEAP32[i4 >> 2] | 0) | 0)) {
      i12 = i6 - i15 | 0;
      i13 = i23 + 216 | 0;
      do if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
       i6 = i23 + 220 | 0;
       HEAP32[i6 >> 2] = (HEAP32[i20 >> 2] | 0) + i15;
       i11 = i23 + 224 | 0;
       i10 = i23 + 236 | 0;
       i8 = i23 + 232 | 0;
       HEAP32[i11 >> 2] = i12;
       HEAP32[i8 >> 2] = i22;
       i2 = i1 >>> 0 < 1024 ? i1 : 1024;
       HEAP32[i10 >> 2] = i2;
       i2 = i1 - i2 | 0;
       i3 = _unity_z_inflate(i6, (i2 | 0) == 0 ? 4 : 0) | 0;
       if (!i3) do {
        i3 = (HEAP32[i10 >> 2] | 0) + i2 | 0;
        HEAP32[i8 >> 2] = i22;
        i2 = i3 >>> 0 < 1024 ? i3 : 1024;
        HEAP32[i10 >> 2] = i2;
        i2 = i3 - i2 | 0;
        i3 = _unity_z_inflate(i6, (i2 | 0) == 0 ? 4 : 0) | 0;
       } while ((i3 | 0) == 0);
       HEAP32[i8 >> 2] = 0;
       i9 = i1 - i2 - (HEAP32[i10 >> 2] | 0) | 0;
       i2 = i12 - (HEAP32[i11 >> 2] | 0) | 0;
       _UNITY_png_zstream_error(i23, i3);
       if ((i3 | 0) == 1) {
        if (_unity_z_inflateReset(i6) | 0) {
         _UNITY_png_zstream_error(i23, 1);
         i1 = i9;
         break;
        }
        i5 = i5 + 2 + i9 | 0;
        i7 = _UNITY_png_malloc_base(i23, i5) | 0;
        if (!i7) {
         _UNITY_png_zstream_error(i23, -4);
         i1 = i9;
         break;
        }
        i1 = i7 + i15 | 0;
        do if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
         HEAP32[i6 >> 2] = (HEAP32[i20 >> 2] | 0) + i15;
         HEAP32[i11 >> 2] = 0;
         HEAP32[i10 >> 2] = 0;
         i3 = (i1 | 0) == 0;
         do if (i3) {
          HEAP32[i11 >> 2] = i2;
          HEAP32[i8 >> 2] = i22;
          i1 = i9 >>> 0 < 1024 ? i9 : 1024;
          HEAP32[i10 >> 2] = i1;
          i1 = i9 - i1 | 0;
          i4 = _unity_z_inflate(i6, (i1 | 0) == 0 ? 4 : 0) | 0;
          if (i4) {
           i14 = 50;
           break;
          }
          do {
           i4 = (HEAP32[i10 >> 2] | 0) + i1 | 0;
           HEAP32[i8 >> 2] = i22;
           i1 = i4 >>> 0 < 1024 ? i4 : 1024;
           HEAP32[i10 >> 2] = i1;
           i1 = i4 - i1 | 0;
           i4 = _unity_z_inflate(i6, (i1 | 0) == 0 ? 4 : 0) | 0;
          } while ((i4 | 0) == 0);
          i14 = 49;
         } else {
          HEAP32[i8 >> 2] = i1;
          HEAP32[i11 >> 2] = i2;
          HEAP32[i10 >> 2] = i9;
          i4 = _unity_z_inflate(i6, 4) | 0;
          if (i4 | 0) {
           i1 = 0;
           break;
          }
          do i4 = _unity_z_inflate(i6, 4) | 0; while (!(i4 | 0));
          i1 = 0;
          i14 = 49;
         } while (0);
         if ((i14 | 0) == 49) if (i3) i14 = 50;
         if ((i14 | 0) == 50) HEAP32[i8 >> 2] = 0;
         i3 = (HEAP32[i10 >> 2] | 0) + i1 | 0;
         i1 = i9 - i3 | 0;
         i2 = i2 - (HEAP32[i11 >> 2] | 0) | 0;
         _UNITY_png_zstream_error(i23, i4);
         if ((i4 | 0) != 1) {
          i3 = i7;
          break;
         }
         if (i3 | 0) {
          i3 = i7;
          i4 = -7;
          break;
         }
         HEAP8[i7 + (i9 + i15) >> 0] = 0;
         i3 = HEAP32[i20 >> 2] | 0;
         if (i15 | 0) _memcpy(i7 | 0, i3 | 0, i15 | 0) | 0;
         HEAP32[i20 >> 2] = i7;
         HEAP32[i23 + 648 >> 2] = i5;
         i4 = 1;
        } else {
         HEAP32[i23 + 244 >> 2] = gb + 352218;
         i3 = i7;
         i4 = -2;
         i1 = i9;
        } while (0);
        _UNITY_png_free(i23, i3);
        if ((i12 | 0) == (i2 | 0) | (i4 | 0) != 1) {
         HEAP32[i13 >> 2] = 0;
         if ((i4 | 0) != 1) {
          i3 = i1;
          break L55;
         }
        } else {
         _UNITY_png_chunk_benign_error(i23, gb + 352236 | 0);
         HEAP32[i13 >> 2] = 0;
        }
        i2 = HEAP32[i20 >> 2] | 0;
        break L48;
       } else i1 = i9;
      } else HEAP32[i23 + 244 >> 2] = gb + 352218; while (0);
      HEAP32[i13 >> 2] = 0;
      i3 = i1;
     } else i3 = i1;
    } while (0);
    i1 = HEAP32[i23 + 244 >> 2] | 0;
    if (!i1) {
     i2 = i19;
     i1 = i3;
    } else break L28;
   } else {
    i2 = i19;
    i1 = i6 - i15 | 0;
   } while (0);
   HEAP8[i2 + (i1 + i15) >> 0] = 0;
   HEAP32[i22 >> 2] = i18 ? 1 : 2;
   HEAP32[i22 + 4 >> 2] = i2;
   HEAP32[i22 + 20 >> 2] = i2 + i17;
   HEAP32[i22 + 24 >> 2] = i2 + i16;
   HEAP32[i22 + 8 >> 2] = i2 + i15;
   HEAP32[i22 + 12 >> 2] = 0;
   HEAP32[i22 + 16 >> 2] = i1;
   if (!(_UNITY_png_set_text_2(i23, i21, i22, 1) | 0)) {
    STACKTOP = i24;
    return;
   } else i1 = gb + 362452 | 0;
  }
 } while (0);
 _UNITY_png_chunk_benign_error(i23, i1);
 STACKTOP = i24;
 return;
}

function __ZN5physx2Gu25contactCapsuleHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i1 + 136 | 0;
 i10 = i1 + 112 | 0;
 i8 = i1 + 80 | 0;
 i9 = i1 + 56 | 0;
 i11 = i1 + 32 | 0;
 i14 = i1;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f43 = Math_fround(f20 * Math_fround(2.0));
 i31 = i6 + 12 | 0;
 f21 = Math_fround(HEAPF32[i31 >> 2]);
 f44 = Math_fround(f21 * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f20 * f43) + Math_fround(Math_fround(f21 * f44) + Math_fround(-1.0)));
 i30 = i6 + 8 | 0;
 f20 = Math_fround(HEAPF32[i30 >> 2]);
 f28 = Math_fround(f20 * f44);
 i29 = i6 + 4 | 0;
 f24 = Math_fround(HEAPF32[i29 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f43 * f24));
 f24 = Math_fround(Math_fround(f43 * f20) - Math_fround(f44 * f24));
 i13 = i4 + 8 | 0;
 f44 = Math_fround(HEAPF32[i13 >> 2]);
 f21 = Math_fround(f44 * f21);
 f28 = Math_fround(f44 * f28);
 f24 = Math_fround(f44 * f24);
 i37 = i6 + 16 | 0;
 f44 = Math_fround(HEAPF32[i37 >> 2]);
 f20 = Math_fround(f44 + f21);
 i35 = i6 + 20 | 0;
 f43 = Math_fround(HEAPF32[i35 >> 2]);
 f18 = Math_fround(f43 + f28);
 i33 = i6 + 24 | 0;
 f25 = Math_fround(HEAPF32[i33 >> 2]);
 f17 = Math_fround(f24 + f25);
 f21 = Math_fround(f44 - f21);
 f28 = Math_fround(f43 - f28);
 f24 = Math_fround(f25 - f24);
 i41 = i4 + 4 | 0;
 f25 = Math_fround(HEAPF32[i41 >> 2]);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i3 >> 2]));
 i36 = i7 + 16 | 0;
 f43 = Math_fround(HEAPF32[i36 >> 2]);
 f20 = Math_fround(f20 - f43);
 i34 = i7 + 20 | 0;
 f44 = Math_fround(HEAPF32[i34 >> 2]);
 f18 = Math_fround(f18 - f44);
 i32 = i7 + 24 | 0;
 f45 = Math_fround(HEAPF32[i32 >> 2]);
 f20 = Math_fround(f20 * Math_fround(2.0));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - f45) * Math_fround(2.0));
 i38 = i7 + 12 | 0;
 f16 = Math_fround(HEAPF32[i38 >> 2]);
 f22 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f42 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(f20 * f42);
 i40 = i7 + 4 | 0;
 f15 = Math_fround(HEAPF32[i40 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f18 * f15));
 i39 = i7 + 8 | 0;
 f27 = Math_fround(HEAPF32[i39 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f17 * f27));
 f23 = Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f18 * f22) - Math_fround(f16 * Math_fround(Math_fround(f20 * f27) - Math_fround(f17 * f42)))));
 f26 = Math_fround(Math_fround(Math_fround(f17 * f22) - Math_fround(f16 * Math_fround(Math_fround(f18 * f42) - Math_fround(f20 * f15)))) + Math_fround(f27 * f19));
 f43 = Math_fround(Math_fround(f21 - f43) * Math_fround(2.0));
 f44 = Math_fround(Math_fround(f28 - f44) * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f24 - f45) * Math_fround(2.0));
 f24 = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f44 * f15)) + Math_fround(f45 * f27));
 f28 = Math_fround(Math_fround(f42 * f24) + Math_fround(Math_fround(f43 * f22) - Math_fround(f16 * Math_fround(Math_fround(f45 * f15) - Math_fround(f44 * f27)))));
 f21 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f44 * f22) - Math_fround(f16 * Math_fround(Math_fround(f43 * f27) - Math_fround(f45 * f42)))));
 f24 = Math_fround(Math_fround(Math_fround(f45 * f22) - Math_fround(f16 * Math_fround(Math_fround(f44 * f42) - Math_fround(f43 * f15)))) + Math_fround(f27 * f24));
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(f42 * f19) + Math_fround(Math_fround(f20 * f22) - Math_fround(f16 * Math_fround(Math_fround(f17 * f15) - Math_fround(f18 * f27)))));
 HEAPF32[i12 + 4 >> 2] = f23;
 HEAPF32[i12 + 8 >> 2] = f26;
 HEAPF32[i12 + 12 >> 2] = f28;
 HEAPF32[i12 + 16 >> 2] = f21;
 HEAPF32[i12 + 20 >> 2] = f24;
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 16 >> 2] = i5;
 HEAPF32[i10 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 8 >> 2]));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 12 >> 2]));
 HEAPF32[i10 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 16 >> 2]));
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i41 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 84404 + 8;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i7;
 HEAP32[i8 + 12 >> 2] = i12;
 HEAPF32[i8 + 16 >> 2] = f25;
 HEAP32[i8 + 20 >> 2] = i4;
 HEAP32[i8 + 24 >> 2] = i3;
 HEAP32[i8 + 28 >> 2] = i10;
 i3 = i9 + 12 | 0;
 f24 = Math_fround(f25 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i3 >> 2] = f24;
 i4 = i9 + 16 | 0;
 HEAPF32[i4 >> 2] = f25;
 i5 = i9 + 20 | 0;
 HEAPF32[i5 >> 2] = f25;
 f25 = Math_fround(-f25);
 HEAPF32[i9 >> 2] = Math_fround(-f24);
 i13 = i9 + 4 | 0;
 HEAPF32[i13 >> 2] = f25;
 i12 = i9 + 8 | 0;
 HEAPF32[i12 >> 2] = f25;
 f25 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
 f24 = Math_fround(-Math_fround(HEAPF32[i40 >> 2]));
 f21 = Math_fround(-Math_fround(HEAPF32[i39 >> 2]));
 f28 = Math_fround(HEAPF32[i38 >> 2]);
 f26 = Math_fround(HEAPF32[i37 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i36 >> 2]));
 f23 = Math_fround(HEAPF32[i35 >> 2]);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i34 >> 2]));
 f27 = Math_fround(HEAPF32[i33 >> 2]);
 f26 = Math_fround(f26 * Math_fround(2.0));
 f23 = Math_fround(f23 * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f27 - Math_fround(HEAPF32[i32 >> 2])) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f23 * f24)) + Math_fround(f27 * f21));
 f17 = Math_fround(Math_fround(f15 * f25) + Math_fround(Math_fround(f18 * f26) + Math_fround(f28 * Math_fround(Math_fround(f27 * f24) - Math_fround(f23 * f21)))));
 f16 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f18 * f23) + Math_fround(f28 * Math_fround(Math_fround(f26 * f21) - Math_fround(f27 * f25)))));
 f15 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(f28 * Math_fround(Math_fround(f23 * f25) - Math_fround(f26 * f24)))) + Math_fround(f15 * f21));
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(f28 * f26);
 f27 = Math_fround(HEAPF32[i31 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f27 * f25));
 f18 = Math_fround(HEAPF32[i30 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f18 * f24));
 f22 = Math_fround(HEAPF32[i29 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(Math_fround(f27 * f24) + Math_fround(f28 * f22))) - Math_fround(f18 * f25));
 f19 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(Math_fround(f27 * f21) + Math_fround(f28 * f18))) - Math_fround(f26 * f24));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f22 * f24)) - Math_fround(f18 * f21));
 HEAPF32[i14 >> 2] = Math_fround(f23 - Math_fround(f22 * f21));
 HEAPF32[i14 + 4 >> 2] = f20;
 HEAPF32[i14 + 8 >> 2] = f19;
 HEAPF32[i14 + 12 >> 2] = f18;
 HEAPF32[i14 + 16 >> 2] = f17;
 HEAPF32[i14 + 20 >> 2] = f16;
 HEAPF32[i14 + 24 >> 2] = f15;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i11, i14, i9);
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i11 + 20 >> 2];
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i10, i7, i9, 0, i8) | 0;
 STACKTOP = i1;
 return (HEAP32[i2 + 4096 >> 2] | 0) != 0 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEbT0_S5_T_(i16, i15, i17) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18;
 switch ((i15 - i16 | 0) / 12 | 0 | 0) {
 case 2:
  {
   i5 = i15 + -12 | 0;
   i1 = HEAP32[i15 + -4 >> 2] | 0;
   i2 = HEAP32[i16 + 8 >> 2] | 0;
   do if ((i1 | 0) == (i2 | 0)) {
    f3 = Math_fround(HEAPF32[i15 + -8 >> 2]);
    f4 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    f10 = Math_fround(f3 - f4);
    f10 = Math_fround(f10 * f10);
    if (f10 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
     if (f3 > f4) break; else i1 = 1;
     STACKTOP = i18;
     return i1 | 0;
    } else {
     i15 = HEAP32[i5 >> 2] | 0;
     i14 = HEAP32[HEAP32[i17 + 24 >> 2] >> 2] | 0;
     f21 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) >> 2]);
     f20 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) + 4 >> 2]);
     f19 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) + 8 >> 2]);
     i15 = HEAP32[i16 >> 2] | 0;
     f24 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) >> 2]);
     f23 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) + 4 >> 2]);
     f22 = Math_fround(HEAPF32[i14 + (i15 * 24 | 0) + 8 >> 2]);
     f3 = Math_fround(HEAPF32[i17 >> 2]);
     f21 = Math_fround(f21 - f3);
     f4 = Math_fround(HEAPF32[i17 + 4 >> 2]);
     f20 = Math_fround(f20 - f4);
     f10 = Math_fround(HEAPF32[i17 + 8 >> 2]);
     f19 = Math_fround(f19 - f10);
     f3 = Math_fround(f24 - f3);
     f4 = Math_fround(f23 - f4);
     f10 = Math_fround(f22 - f10);
     if (Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)) + Math_fround(f19 * f19)) < Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f10 * f10))) break; else i1 = 1;
     STACKTOP = i18;
     return i1 | 0;
    }
   } else if ((i1 | 0) <= (i2 | 0)) {
    i17 = 1;
    STACKTOP = i18;
    return i17 | 0;
   } while (0);
   HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i16, i16 + 12 | 0, i15 + -12 | 0, i17) | 0;
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_(i16, i16 + 12 | 0, i16 + 24 | 0, i15 + -12 | 0, i17) | 0;
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i16, i16 + 12 | 0, i16 + 24 | 0, i16 + 36 | 0, i15 + -12 | 0, i17) | 0;
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 case 1:
 case 0:
  {
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 default:
  {
   i2 = i16 + 24 | 0;
   __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i16, i16 + 12 | 0, i2, i17) | 0;
   i1 = i16 + 36 | 0;
   L3 : do if ((i1 | 0) == (i15 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    f10 = Math_fround(HEAPF32[gb + 62452 >> 2]);
    i11 = i17 + 24 | 0;
    i12 = i17 + 4 | 0;
    i13 = i17 + 8 | 0;
    i9 = i1;
    i1 = 0;
    while (1) {
     i8 = HEAP32[i9 + 8 >> 2] | 0;
     i5 = HEAP32[i2 + 8 >> 2] | 0;
     do if ((i8 | 0) == (i5 | 0)) {
      f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
      f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
      f24 = Math_fround(f3 - f4);
      if (Math_fround(f24 * f24) > f10) if (f3 > f4) {
       i14 = 19;
       break;
      } else break; else {
       i7 = HEAP32[i9 >> 2] | 0;
       i6 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
       f19 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) >> 2]);
       f20 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 4 >> 2]);
       f21 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 8 >> 2]);
       i7 = HEAP32[i2 >> 2] | 0;
       f26 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) >> 2]);
       f25 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 4 >> 2]);
       f4 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 8 >> 2]);
       f22 = Math_fround(HEAPF32[i17 >> 2]);
       f19 = Math_fround(f19 - f22);
       f23 = Math_fround(HEAPF32[i12 >> 2]);
       f20 = Math_fround(f20 - f23);
       f24 = Math_fround(HEAPF32[i13 >> 2]);
       f21 = Math_fround(f21 - f24);
       f22 = Math_fround(f26 - f22);
       f23 = Math_fround(f25 - f23);
       f24 = Math_fround(f4 - f24);
       if (Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21)) < Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f23 * f23)) + Math_fround(f24 * f24))) {
        i14 = 19;
        break;
       } else break;
      }
     } else if ((i8 | 0) > (i5 | 0)) {
      f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
      i14 = 19;
     } while (0);
     if ((i14 | 0) == 19) {
      i14 = 0;
      i7 = HEAP32[i9 >> 2] | 0;
      HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      L16 : do if ((i2 | 0) == (i16 | 0)) i2 = i16; else while (1) {
       i6 = i2;
       i2 = i2 + -12 | 0;
       i5 = HEAP32[i6 + -4 >> 2] | 0;
       do if ((i8 | 0) == (i5 | 0)) {
        f4 = Math_fround(HEAPF32[i6 + -8 >> 2]);
        f26 = Math_fround(f3 - f4);
        if (Math_fround(f26 * f26) > f10) if (f3 > f4) break; else {
         i2 = i6;
         break L16;
        } else {
         i27 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
         f21 = Math_fround(HEAPF32[i27 + (i7 * 24 | 0) >> 2]);
         f22 = Math_fround(HEAPF32[i27 + (i7 * 24 | 0) + 4 >> 2]);
         f23 = Math_fround(HEAPF32[i27 + (i7 * 24 | 0) + 8 >> 2]);
         i5 = HEAP32[i2 >> 2] | 0;
         f4 = Math_fround(HEAPF32[i27 + (i5 * 24 | 0) >> 2]);
         f19 = Math_fround(HEAPF32[i27 + (i5 * 24 | 0) + 4 >> 2]);
         f20 = Math_fround(HEAPF32[i27 + (i5 * 24 | 0) + 8 >> 2]);
         f24 = Math_fround(HEAPF32[i17 >> 2]);
         f21 = Math_fround(f21 - f24);
         f25 = Math_fround(HEAPF32[i12 >> 2]);
         f22 = Math_fround(f22 - f25);
         f26 = Math_fround(HEAPF32[i13 >> 2]);
         f23 = Math_fround(f23 - f26);
         f24 = Math_fround(f4 - f24);
         f25 = Math_fround(f19 - f25);
         f26 = Math_fround(f20 - f26);
         if (Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f23 * f23)) < Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26))) break; else {
          i2 = i6;
          break L16;
         }
        }
       } else if ((i8 | 0) <= (i5 | 0)) {
        i2 = i6;
        break L16;
       } while (0);
       HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
       if ((i2 | 0) == (i16 | 0)) {
        i2 = i16;
        break;
       }
      } while (0);
      HEAP32[i2 >> 2] = i7;
      HEAPF32[i2 + 4 >> 2] = f3;
      HEAP32[i2 + 8 >> 2] = i8;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i9 + 12 | 0) == (i15 | 0);
       break L3;
      }
     }
     i2 = i9 + 12 | 0;
     if ((i2 | 0) == (i15 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i27 = i9;
      i9 = i2;
      i2 = i27;
     }
    }
   } while (0);
   i27 = i1 | i2;
   STACKTOP = i18;
   return i27 | 0;
  }
 }
 return 0;
}

function __ZN9ShaderLab4Pass16SetupPassOptionsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 12 | 0;
 i5 = i12;
 i8 = i10 + 760 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i8 = 0;
  i9 = 0;
  i11 = i10 + 696 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 752 | 0;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i12;
  return;
 } else {
  i1 = i8;
  i4 = i3;
 }
 L3 : while (1) {
  i2 = i4;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i8 | 0)) i1 = 0; else if ((HEAP32[i1 + 16 >> 2] | 0) > 0) i1 = 0; else {
  i3 = HEAP32[i1 + 20 >> 2] | 0;
  i2 = HEAP32[gb + 1166564 >> 2] | 0;
  i4 = i2 + 4 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i2;
  L13 : do if ((i1 | 0) == (i4 | 0)) i9 = 16; else {
   while (1) {
    if ((HEAP32[i1 + 20 >> 2] | 0) == (i3 | 0)) break;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i4 | 0)) {
     i9 = 16;
     break L13;
    } else i2 = i1;
   }
   i7 = HEAP32[i1 + 16 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i7, _strlen(i7) | 0);
  } while (0);
  if ((i9 | 0) == 16) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 480497 | 0, 13);
  }
  i2 = i11 + 11 | 0;
  i1 = 0;
  while (1) {
   if (!(__Z7StrICmpPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, HEAP32[gb + 68848 + (i1 << 2) >> 2] | 0) | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 13) {
    i9 = 20;
    break;
   }
  }
  if ((i9 | 0) == 20) if ((i1 | 0) == 13) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i1 = HEAP8[i2 >> 0] | 0;
   i1 = i1 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, gb + 480963 | 0, 19, i1 + 19 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, i1) | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 480983 | 0, 169, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i1 = 0;
  } else i1 = 13;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i3 = HEAP32[i8 >> 2] | 0;
 }
 if (!i3) {
  i8 = i1;
  i9 = 0;
  i11 = i10 + 696 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 752 | 0;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i12;
  return;
 } else {
  i2 = i8;
  i5 = i3;
 }
 L38 : while (1) {
  i4 = i5;
  while (1) {
   if ((HEAP32[i4 + 16 >> 2] | 0) >= 8) break;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i4) break L38;
  }
  i5 = HEAP32[i4 >> 2] | 0;
  if (!i5) {
   i2 = i4;
   break;
  } else i2 = i4;
 }
 if ((i2 | 0) == (i8 | 0)) i7 = 0; else if ((HEAP32[i2 + 16 >> 2] | 0) < 9) {
  i4 = HEAP32[i2 + 20 >> 2] | 0;
  i3 = HEAP32[gb + 1166564 >> 2] | 0;
  i5 = i3 + 4 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i2 = i3;
  L48 : do if ((i2 | 0) == (i5 | 0)) i9 = 38; else {
   while (1) {
    if ((HEAP32[i2 + 20 >> 2] | 0) == (i4 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((i2 | 0) == (i5 | 0)) {
     i9 = 38;
     break L48;
    } else i3 = i2;
   }
   i7 = HEAP32[i2 + 16 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i7, _strlen(i7) | 0);
  } while (0);
  if ((i9 | 0) == 38) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 480497 | 0, 13);
  }
  i5 = i11 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i6 = i11 + 4 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i4 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0) {
   i4 = i4 ? i2 : i11;
   do {
    i7 = HEAP8[i4 >> 0] | 0;
    i3 = i7 << 24 >> 24;
    HEAP8[i4 >> 0] = (i7 + -97 & 255) < 26 ? i3 + 224 | 0 : i3;
    i4 = i4 + 1 | 0;
    i3 = HEAP8[i5 >> 0] | 0;
    i7 = i3 << 24 >> 24 < 0;
    i2 = HEAP32[i11 >> 2] | 0;
   } while ((i4 | 0) != ((i7 ? i2 : i11) + (i7 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0));
  }
  i7 = (_strstr(i3 << 24 >> 24 < 0 ? i2 : i11, gb + 481065 | 0) | 0) != 0 & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i3 = HEAP32[i8 >> 2] | 0;
 } else i7 = 0;
 if (!i3) {
  i8 = i1;
  i9 = i7;
  i11 = i10 + 696 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 752 | 0;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i12;
  return;
 } else i2 = i8;
 L71 : while (1) {
  i4 = i3;
  while (1) {
   if ((HEAP32[i4 + 16 >> 2] | 0) >= 12) break;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i3) break L71; else i4 = i3;
  }
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) {
   i2 = i4;
   break;
  } else i2 = i4;
 }
 if ((i2 | 0) == (i8 | 0)) {
  i8 = i1;
  i9 = i7;
  i11 = i10 + 696 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 752 | 0;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) >= 13) {
  i8 = i1;
  i9 = i7;
  i11 = i10 + 696 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 752 | 0;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i12;
  return;
 }
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i2 = HEAP32[gb + 1166564 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i2;
 L84 : do if ((i3 | 0) == (i5 | 0)) i9 = 58; else {
  while (1) {
   if ((HEAP32[i3 + 20 >> 2] | 0) == (i4 | 0)) break;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) break; else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i3 = i2;
      break;
     } else i2 = i3;
    }
   }
   if ((i3 | 0) == (i5 | 0)) {
    i9 = 58;
    break L84;
   } else i2 = i3;
  }
  i8 = HEAP32[i3 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i8, _strlen(i8) | 0);
 } while (0);
 if ((i9 | 0) == 58) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 480497 | 0, 13);
 }
 i5 = i11 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i6 = i11 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i4 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0) {
  i4 = i4 ? i2 : i11;
  do {
   i9 = HEAP8[i4 >> 0] | 0;
   i3 = i9 << 24 >> 24;
   HEAP8[i4 >> 0] = (i9 + -97 & 255) < 26 ? i3 + 224 | 0 : i3;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   i9 = i3 << 24 >> 24 < 0;
   i2 = HEAP32[i11 >> 2] | 0;
  } while ((i4 | 0) != ((i9 ? i2 : i11) + (i9 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0));
 }
 i9 = (_strstr(i3 << 24 >> 24 < 0 ? i2 : i11, gb + 481080 | 0) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i8 = i1;
 i9 = i9 ? i7 : i7 | 2;
 i11 = i10 + 696 | 0;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 752 | 0;
 HEAP32[i11 >> 2] = i9;
 STACKTOP = i12;
 return;
}

function __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, i4, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 8 | 0;
 i7 = i21 + 72 | 0;
 i18 = i21 + 56 | 0;
 i19 = i21 + 40 | 0;
 i9 = i21 + 16 | 0;
 i14 = i21;
 i1 = i8 + 24 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i8 + 28 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 i3 = __Z14SkipPathPrefixPKcS0_jb(i4, i3, i1, 0) | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i17 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i18 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i18;
   i16 = i2;
  } else {
   i1 = i18;
   i17 = 9;
  }
 } else i17 = 7;
 if ((i17 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i20 >> 2] = 54;
  HEAP32[i20 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i18 + 4 >> 2] = i4;
  i2 = i18 + 11 | 0;
  i17 = 9;
 }
 if ((i17 | 0) == 9) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i16 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = HEAP8[i16 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 i6 = i18 + 4 | 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i1 & 255;
 do if (i1 | 0) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i18 >> 2] | 0;
  if ((HEAP8[(i3 ? i2 : i18) + i1 >> 0] | 0) == 47) if (i3) {
   HEAP8[i2 + i1 >> 0] = 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   HEAP8[i18 + i1 >> 0] = 0;
   HEAP8[i16 >> 0] = i1;
   break;
  }
 } while (0);
 __Z7ToLowerINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEET_RKS8_(i19, i18);
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i19 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 i15 = i19 + 11 | 0;
 if ((HEAP8[i15 >> 0] | 0) < 0) {
  i2 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i19 + 4 >> 2] | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
   i1 = HEAP32[i5 >> 2] | 0;
   i17 = 20;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i9 + 11 >> 0] = i3;
   if (!i3) i1 = i9; else {
    i1 = i9;
    i17 = 22;
   }
  } else i17 = 20;
  if ((i17 | 0) == 20) {
   i13 = i3 + 16 & -16;
   HEAP32[i20 >> 2] = 54;
   HEAP32[i20 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i9 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i9 + 4 >> 2] = i3;
   i17 = 22;
  }
  if ((i17 | 0) == 22) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
 } else {
  HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 }
 HEAP32[i9 + 16 >> 2] = 0;
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE12__find_equalIS8_EERPNS_16__tree_node_baseIPvEESO_RKT_(i4, i20, i9) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE16__construct_nodeERKNS_4pairIKS8_SB_EE(i7, i4, i9);
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i2 = HEAP32[i20 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 8 >> 2] | 0, i2);
  i13 = i8 + 16 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 }
 if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i5 >> 2] | 0;
  HEAP32[i20 >> 2] = 54;
  HEAP32[i20 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i20);
 }
 i13 = i1 + 32 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 492052 | 0, 721) | 0;
  HEAP32[i1 >> 2] = 0;
  i12 = i1 + 4 | 0;
  __ZN8DateTimeC2Ev(i12);
  HEAP32[i1 + 12 >> 2] = 8;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  i11 = i1 + 24 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  if (i10) i2 = 0; else {
   i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63552 | 0, 16, gb + 492052 | 0, 722) | 0;
   i8 = gb + 63552 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i14;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i2, i20, 8192);
  }
  HEAP32[i1 >> 2] = i2;
  i3 = HEAP8[i15 >> 0] | 0;
  i7 = i3 << 24 >> 24 < 0;
  i3 = i3 & 255;
  i8 = i7 ? HEAP32[i19 + 4 >> 2] | 0 : i3;
  i10 = HEAP8[i16 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i6 >> 2] | 0 : i10 & 255;
  L48 : do if ((i8 | 0) == (i10 | 0)) {
   i4 = HEAP32[i19 >> 2] | 0;
   i5 = i7 ? i4 : i19;
   i2 = i9 ? HEAP32[i18 >> 2] | 0 : i18;
   i6 = (i8 | 0) == 0;
   if (i7) {
    if (i6) break;
    if (!(_memcmp(i5, i2, i8) | 0)) break; else {
     i17 = 41;
     break;
    }
   }
   if (!i6) if ((i4 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
    i4 = i19;
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L48;
     i2 = i2 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i17 = 41;
      break;
     }
    }
   } else i17 = 41;
  } else i17 = 41; while (0);
  do if ((i17 | 0) == 41) if ((i11 | 0) != (i18 | 0)) {
   i6 = i9 ? HEAP32[i18 >> 2] | 0 : i18;
   i4 = i1 + 35 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i1 + 32 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i10 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i1 + 28 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i5, i10 - i5 | 0, i2, 0, i2, i10, i6);
    break;
   }
   if (i3) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
   if (i10 | 0) _memmove(i2 | 0, i6 | 0, i10 | 0) | 0;
   HEAP8[i2 + i10 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i1 + 28 >> 2] = i10;
    break;
   } else {
    HEAP8[i4 >> 0] = i10;
    break;
   }
  } while (0);
  __ZN8DateTimeC2Ev(i20);
  i11 = i20;
  i14 = HEAP32[i11 + 4 >> 2] | 0;
  i17 = i12;
  HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i17 + 4 >> 2] = i14;
  HEAP32[i13 >> 2] = i1;
 }
 if ((HEAP8[i15 >> 0] | 0) < 0) {
  i17 = HEAP32[i19 >> 2] | 0;
  i19 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i20 >> 2] = 54;
  HEAP32[i20 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i20);
 }
 if ((HEAP8[i16 >> 0] | 0) >= 0) {
  STACKTOP = i21;
  return i1 | 0;
 }
 i19 = HEAP32[i18 >> 2] | 0;
 i18 = HEAP32[i18 + 12 >> 2] | 0;
 HEAP32[i20 >> 2] = 54;
 HEAP32[i20 + 4 >> 2] = i18;
 __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
 STACKTOP = i21;
 return i1 | 0;
}

function __Z13GetLocalEuler15TransformAccessN4math13RotationOrderE(i16, i1, i3) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 24 >> 2]);
 f10 = Math_fround(Math_fround(f6 * f9) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f7 * f9) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f8 * f9) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f6 * f7) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f7 * f8) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(f6 * f8) * Math_fround(2.0));
 f6 = Math_fround(f6 * f6);
 f7 = Math_fround(f7 * f7);
 f8 = Math_fround(f8 * f8);
 f9 = Math_fround(f9 * f9);
 switch (i3 | 0) {
 case 5:
  {
   f2 = Math_fround(f15 + f11);
   if (Math_fround(f2 * f2) < Math_fround(.999995946)) {
    f4 = Math_fround(+Math_atan2(+Math_fround(f12 - f13), +Math_fround(Math_fround(Math_fround(f6 + f9) - f7) - f8)));
    f2 = Math_fround(+Math_asin(+f2));
    f15 = Math_fround(+Math_atan2(+Math_fround(f10 - f14), +Math_fround(Math_fround(Math_fround(f8 + f9) - f7) - f6)));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f4 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f15 * f10)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f10 * f10) - Math_fround(f14 * f14)) + Math_fround(Math_fround(f11 * f11) - Math_fround(f15 * f15)))));
    f2 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f2, Math_fround(-1.0))), Math_fround(1.0)))));
    i1 = 0;
   }
   i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 4:
  {
   f2 = Math_fround(f14 - f10);
   if (Math_fround(f2 * f2) < Math_fround(.999995946)) {
    f14 = Math_fround(+Math_atan2(+Math_fround(f13 + f12), +Math_fround(Math_fround(Math_fround(f7 + f9) - f6) - f8)));
    f4 = Math_fround(+Math_asin(+f2));
    f15 = Math_fround(+Math_atan2(+Math_fround(f15 + f11), +Math_fround(Math_fround(Math_fround(f8 + f9) - f6) - f7)));
    f2 = f14;
    i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f4 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f2, Math_fround(-1.0))), Math_fround(1.0)))));
    f2 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f15 * f10)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f10 * f10) - Math_fround(f14 * f14)) + Math_fround(Math_fround(f11 * f11) - Math_fround(f15 * f15)))));
    i3 = 0;
   }
   f15 = Math_fround(-f4);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 3:
  {
   f2 = Math_fround(f14 + f10);
   if (Math_fround(f2 * f2) < Math_fround(.999995946)) {
    f4 = Math_fround(+Math_atan2(+Math_fround(f11 - f15), +Math_fround(Math_fround(Math_fround(f8 + f9) - f6) - f7)));
    f2 = Math_fround(+Math_asin(+f2));
    f15 = Math_fround(+Math_atan2(+Math_fround(f12 - f13), +Math_fround(Math_fround(Math_fround(f7 + f9) - f8) - f6)));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f4 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f13 * f10) + Math_fround(f14 * f12)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f12 * f12) - Math_fround(f13 * f13)) + Math_fround(Math_fround(f10 * f10) - Math_fround(f14 * f14)))));
    f2 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f2, Math_fround(-1.0))), Math_fround(1.0)))));
    i3 = 0;
   }
   i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i3;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 2:
  {
   f2 = Math_fround(f13 - f12);
   if (Math_fround(f2 * f2) < Math_fround(.999995946)) {
    f13 = Math_fround(+Math_atan2(+Math_fround(f15 + f11), +Math_fround(Math_fround(Math_fround(f6 + f9) - f8) - f7)));
    f4 = Math_fround(+Math_asin(+f2));
    f15 = Math_fround(+Math_atan2(+Math_fround(f14 + f10), +Math_fround(Math_fround(Math_fround(f7 + f9) - f6) - f8)));
    f2 = f13;
    i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f4 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f2, Math_fround(-1.0))), Math_fround(1.0)))));
    f2 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f13 * f10) + Math_fround(f14 * f12)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f12 * f12) - Math_fround(f13 * f13)) + Math_fround(Math_fround(f10 * f10) - Math_fround(f14 * f14)))));
    i1 = 0;
   }
   f15 = Math_fround(-f4);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   f4 = Math_fround(f13 + f12);
   if (Math_fround(f4 * f4) < Math_fround(.999995946)) {
    f2 = Math_fround(+Math_atan2(+Math_fround(f10 - f14), +Math_fround(Math_fround(Math_fround(f7 + f9) - f8) - f6)));
    f4 = Math_fround(+Math_asin(+f4));
    f15 = Math_fround(+Math_atan2(+Math_fround(f11 - f15), +Math_fround(Math_fround(Math_fround(f6 + f9) - f7) - f8)));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f2 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f13 * f11) + Math_fround(f15 * f12)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f12 * f12) - Math_fround(f13 * f13)) + Math_fround(Math_fround(f11 * f11) - Math_fround(f15 * f15)))));
    f4 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f4, Math_fround(-1.0))), Math_fround(1.0)))));
    i3 = 0;
   }
   i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 0:
  {
   f2 = Math_fround(f15 - f11);
   if (Math_fround(f2 * f2) < Math_fround(.999995946)) {
    f14 = Math_fround(+Math_atan2(+Math_fround(f14 + f10), +Math_fround(Math_fround(Math_fround(f8 + f9) - f7) - f6)));
    f4 = Math_fround(+Math_asin(+f2));
    f15 = Math_fround(+Math_atan2(+Math_fround(f13 + f12), +Math_fround(Math_fround(Math_fround(f6 + f9) - f7) - f8)));
    f2 = f14;
    i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    f4 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f2, Math_fround(-1.0))), Math_fround(1.0)))));
    f2 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f13 * f11) + Math_fround(f15 * f12)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f12 * f12) - Math_fround(f13 * f13)) + Math_fround(Math_fround(f11 * f11) - Math_fround(f15 * f15)))));
    i3 = 0;
   }
   f15 = Math_fround(-f4);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i3;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  {
   i1 = 0;
   i5 = 0;
   i3 = 0;
  }
 }
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 * Math_fround(57.2957802));
 f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(57.2957802));
 HEAPF32[i16 >> 2] = Math_fround(f13 * Math_fround(57.2957802));
 HEAPF32[i16 + 4 >> 2] = f14;
 HEAPF32[i16 + 8 >> 2] = f15;
 return;
}

function __ZN5physx2Sc5Scene18updateCCDMultiPassEPNS_10PxBaseTaskE(i37, i38) {
 i37 = i37 | 0;
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i39 + 56 | 0;
 i32 = i39 + 28 | 0;
 i35 = i39;
 i36 = i37 + 1204 | 0;
 __ZN5physx16PxsIslandManager11freeBuffersEv(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i36 >> 2] | 0) | 0);
 if (!(HEAP16[i37 + 1192 >> 1] & 4)) {
  STACKTOP = i39;
  return;
 }
 if (HEAP8[i37 + 2392 >> 0] | 0) __ZN5physx2Sc5Scene36collectPostSolverVelocitiesBeforeCCDEv(i37);
 i33 = i37 + 1940 | 0;
 i34 = i37 + 1944 | 0;
 i2 = HEAP32[i34 >> 2] | 0;
 if ((i2 | 0) != 2) {
  i1 = HEAP32[i33 >> 2] | 0;
  i3 = i1 + (i2 * 28 | 0) | 0;
  if ((i2 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
  HEAP32[i34 >> 2] = 0;
  i29 = i37 + 1916 | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  i30 = i37 + 1920 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i2 = i1 + (i28 * 28 | 0) | 0;
  if ((i28 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  HEAP32[i30 >> 2] = 0;
  i27 = i37 + 1928 | 0;
  i1 = HEAP32[i27 >> 2] | 0;
  i28 = i37 + 1932 | 0;
  i26 = HEAP32[i28 >> 2] | 0;
  i2 = i1 + (i26 * 28 | 0) | 0;
  if ((i26 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  HEAP32[i28 >> 2] = 0;
  i2 = i37 + 1948 | 0;
  if ((HEAP32[i2 >> 2] & 2147483646) >>> 0 < 2) __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i33, 2);
  i3 = i37 + 1924 | 0;
  if ((HEAP32[i3 >> 2] & 2147483646) >>> 0 < 2) __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i29, 2);
  i4 = i37 + 1936 | 0;
  if ((HEAP32[i4 >> 2] & 2147483646) >>> 0 < 2) __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i27, 2);
  i5 = i31 + 4 | 0;
  i6 = i31 + 6 | 0;
  i7 = i31 + 8 | 0;
  i8 = i31 + 12 | 0;
  i9 = i31 + 16 | 0;
  i10 = i31 + 20 | 0;
  i11 = i31 + 24 | 0;
  i12 = i32 + 4 | 0;
  i13 = i32 + 6 | 0;
  i14 = i32 + 8 | 0;
  i15 = i32 + 12 | 0;
  i16 = i32 + 16 | 0;
  i17 = i32 + 20 | 0;
  i18 = i32 + 24 | 0;
  i19 = i35 + 4 | 0;
  i20 = i35 + 6 | 0;
  i21 = i35 + 8 | 0;
  i22 = i35 + 12 | 0;
  i23 = i35 + 16 | 0;
  i24 = i35 + 20 | 0;
  i25 = i35 + 24 | 0;
  i26 = 0;
  do {
   HEAP16[i5 >> 1] = -1;
   HEAP16[i6 >> 1] = 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i31 >> 2] = gb + 87404 + 8;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i31 >> 2] = gb + 106532 + 8;
   HEAP32[i10 >> 2] = i37;
   HEAP32[i11 >> 2] = gb + 722202;
   i1 = HEAP32[i34 >> 2] | 0;
   if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i42 = HEAP32[i33 >> 2] | 0;
    i41 = i42 + (i1 * 28 | 0) | 0;
    i43 = i5;
    i45 = HEAP32[i43 >> 2] | 0;
    i43 = HEAP32[i43 + 4 >> 2] | 0;
    i40 = i42 + (i1 * 28 | 0) + 4 | 0;
    i44 = i40;
    HEAP16[i44 >> 1] = i45;
    HEAP16[i44 + 2 >> 1] = i45 >>> 16;
    i40 = i40 + 4 | 0;
    HEAP16[i40 >> 1] = i43;
    HEAP16[i40 + 2 >> 1] = i43 >>> 16;
    HEAP32[i41 >> 2] = gb + 87404 + 8;
    i40 = i42 + (i1 * 28 | 0) + 12 | 0;
    HEAP32[i40 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i42 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i40 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i41 >> 2] = gb + 106532 + 8;
    i41 = i10;
    i40 = HEAP32[i41 + 4 >> 2] | 0;
    i1 = i42 + (i1 * 28 | 0) + 20 | 0;
    HEAP32[i1 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i1 + 4 >> 2] = i40;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i33, i31) | 0;
   HEAP32[i31 >> 2] = gb + 87404 + 8;
   HEAP32[i7 >> 2] = 0;
   HEAP16[i12 >> 1] = -1;
   HEAP16[i13 >> 1] = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i32 >> 2] = gb + 87404 + 8;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i32 >> 2] = gb + 106576 + 8;
   HEAP32[i17 >> 2] = i37;
   HEAP32[i18 >> 2] = gb + 722222;
   i1 = HEAP32[i30 >> 2] | 0;
   if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i45 = HEAP32[i29 >> 2] | 0;
    i43 = i45 + (i1 * 28 | 0) | 0;
    i42 = i12;
    i40 = HEAP32[i42 >> 2] | 0;
    i42 = HEAP32[i42 + 4 >> 2] | 0;
    i44 = i45 + (i1 * 28 | 0) + 4 | 0;
    i41 = i44;
    HEAP16[i41 >> 1] = i40;
    HEAP16[i41 + 2 >> 1] = i40 >>> 16;
    i44 = i44 + 4 | 0;
    HEAP16[i44 >> 1] = i42;
    HEAP16[i44 + 2 >> 1] = i42 >>> 16;
    HEAP32[i43 >> 2] = gb + 87404 + 8;
    i44 = i45 + (i1 * 28 | 0) + 12 | 0;
    HEAP32[i44 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i45 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i44 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i43 >> 2] = gb + 106576 + 8;
    i43 = i17;
    i44 = HEAP32[i43 + 4 >> 2] | 0;
    i45 = i45 + (i1 * 28 | 0) + 20 | 0;
    HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i45 + 4 >> 2] = i44;
    HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i29, i32) | 0;
   HEAP32[i32 >> 2] = gb + 87404 + 8;
   HEAP32[i14 >> 2] = 0;
   HEAP16[i19 >> 1] = -1;
   HEAP16[i20 >> 1] = 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i35 >> 2] = gb + 87404 + 8;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i35 >> 2] = gb + 106620 + 8;
   HEAP32[i24 >> 2] = i37;
   HEAP32[i25 >> 2] = gb + 722250;
   i1 = HEAP32[i28 >> 2] | 0;
   if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i45 = HEAP32[i27 >> 2] | 0;
    i43 = i45 + (i1 * 28 | 0) | 0;
    i42 = i19;
    i40 = HEAP32[i42 >> 2] | 0;
    i42 = HEAP32[i42 + 4 >> 2] | 0;
    i44 = i45 + (i1 * 28 | 0) + 4 | 0;
    i41 = i44;
    HEAP16[i41 >> 1] = i40;
    HEAP16[i41 + 2 >> 1] = i40 >>> 16;
    i44 = i44 + 4 | 0;
    HEAP16[i44 >> 1] = i42;
    HEAP16[i44 + 2 >> 1] = i42 >>> 16;
    HEAP32[i43 >> 2] = gb + 87404 + 8;
    i44 = i45 + (i1 * 28 | 0) + 12 | 0;
    HEAP32[i44 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i45 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i44 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i43 >> 2] = gb + 106620 + 8;
    i43 = i24;
    i44 = HEAP32[i43 + 4 >> 2] | 0;
    i45 = i45 + (i1 * 28 | 0) + 20 | 0;
    HEAP32[i45 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i45 + 4 >> 2] = i44;
    HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i27, i35) | 0;
   HEAP32[i35 >> 2] = gb + 87404 + 8;
   HEAP32[i21 >> 2] = 0;
   i26 = i26 + 1 | 0;
  } while ((i26 | 0) != 2);
 }
 __ZN5physx10PxsContext19resetThreadContextsEv(HEAP32[(HEAP32[i36 >> 2] | 0) + 1e3 >> 2] | 0);
 __ZN5physx10PxsContext14updateCCDBeginEv(HEAP32[(HEAP32[i36 >> 2] | 0) + 1e3 >> 2] | 0);
 i1 = i37 + 1928 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 16 >> 2] = 1;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = i38;
 if (i38 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i38 >> 2] | 0) + 16 >> 2] | 0, i38 | 0);
  HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
 }
 i45 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i45 >> 2] | 0) + 20 >> 2] | 0, i45 | 0);
 STACKTOP = i39;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i23, i2, i25, i26, i22, i27, i1) {
 i23 = i23 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i22 = i22 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f24 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31 + 32 | 0;
 i29 = i31 + 16 | 0;
 i30 = i31;
 if (!(HEAP8[i2 + 869 >> 0] | 0)) {
  STACKTOP = i31;
  return;
 }
 f24 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (i22 >>> 0 >= i27 >>> 0) {
  STACKTOP = i31;
  return;
 }
 i13 = i2 + 60 | 0;
 i14 = i2 + 80 | 0;
 i15 = i2 + 100 | 0;
 i16 = i2 + 120 | 0;
 i17 = i2 + 140 | 0;
 i18 = i2 + 160 | 0;
 i19 = i28 + 4 | 0;
 i20 = i28 + 8 | 0;
 i21 = i28 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i29 + 4 | 0;
 i4 = i29 + 8 | 0;
 i5 = i29 + 12 | 0;
 i6 = i26 + 4 | 0;
 i7 = i26 + 8 | 0;
 i8 = i26 + 12 | 0;
 i9 = i30 + 4 | 0;
 i10 = i30 + 8 | 0;
 i11 = i30 + 12 | 0;
 i1 = i22;
 do {
  i45 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f65 = Math_fround(HEAPF32[i45 >> 2]);
  f64 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f63 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f61 = Math_fround(HEAPF32[i45 >> 2]);
  f60 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f58 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i45 >> 2]);
  f56 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f54 = Math_fround(HEAPF32[i45 >> 2]);
  f52 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i17 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i45 >> 2]);
  f51 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i45 + 12 >> 2]);
  i45 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i45 >> 2]);
  f41 = Math_fround(HEAPF32[i45 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i45 + 8 >> 2]);
  f54 = Math_fround(f65 + f54);
  f52 = Math_fround(f64 + f52);
  f32 = Math_fround(f63 + f32);
  f36 = Math_fround(f62 + f36);
  f53 = Math_fround(f61 + f53);
  f51 = Math_fround(f60 + f51);
  f34 = Math_fround(f59 + f34);
  f38 = Math_fround(f58 + f38);
  f39 = Math_fround(f57 + f39);
  f41 = Math_fround(f56 + f41);
  f42 = Math_fround(f55 + f42);
  f43 = Math_fround(f43 + Math_fround(HEAPF32[i45 + 12 >> 2]));
  f39 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f53 * f53)) + Math_fround(f39 * f39))))));
  f41 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51)) + Math_fround(f41 * f41))))));
  f42 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f34 * f34)) + Math_fround(f42 * f42))))));
  f43 = Math_fround(f12 + Math_fround(f24 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f38 * f38)) + Math_fround(f43 * f43))))));
  i45 = f39 < Math_fround(0.0);
  f39 = i45 ? Math_fround(0.0) : f39;
  i45 = f41 < Math_fround(0.0);
  f41 = i45 ? Math_fround(0.0) : f41;
  i45 = f42 < Math_fround(0.0);
  f42 = i45 ? Math_fround(0.0) : f42;
  i45 = f43 < Math_fround(0.0);
  f43 = i45 ? Math_fround(0.0) : f43;
  i45 = f39 > Math_fround(1.0);
  f39 = i45 ? Math_fround(1.0) : f39;
  i45 = f41 > Math_fround(1.0);
  f41 = i45 ? Math_fround(1.0) : f41;
  i45 = f42 > Math_fround(1.0);
  f42 = i45 ? Math_fround(1.0) : f42;
  i45 = f43 > Math_fround(1.0);
  f43 = i45 ? Math_fround(1.0) : f43;
  HEAPF32[i28 >> 2] = f39;
  HEAPF32[i19 >> 2] = f41;
  HEAPF32[i20 >> 2] = f42;
  HEAPF32[i21 >> 2] = f43;
  i45 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i22 = HEAP32[i45 >> 2] | 0;
  i35 = HEAP32[i45 + 4 >> 2] | 0;
  i40 = HEAP32[i45 + 8 >> 2] | 0;
  i45 = HEAP32[i45 + 12 >> 2] | 0;
  i37 = i22 + -557535583 | 0;
  i50 = i35 + -557535583 | 0;
  i48 = i40 + -557535583 | 0;
  i46 = i45 + -557535583 | 0;
  i33 = (Math_imul(i37, 1790253981) | 0) + 1900727103 | 0;
  i49 = (Math_imul(i50, 1790253981) | 0) + 1900727103 | 0;
  i47 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
  i37 = i37 << 11 ^ i37;
  i50 = i50 << 11 ^ i50;
  i48 = i48 << 11 ^ i48;
  i46 = i46 << 11 ^ i46;
  f43 = Math_fround(Math_fround((i49 ^ i50 ^ i50 >>> 8) & 8388607 ^ i49 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i47 ^ i48 ^ i48 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i44 ^ i46 ^ i46 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i29 >> 2] = Math_fround(Math_fround((i33 ^ i37 ^ i37 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  i22 = i22 + -13913692 | 0;
  i35 = i35 + -13913692 | 0;
  i40 = i40 + -13913692 | 0;
  i45 = i45 + -13913692 | 0;
  i33 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i22 = i22 << 11 ^ i22;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i45 = i45 << 11 ^ i45;
  f41 = Math_fround(Math_fround((i33 ^ i22 ^ i22 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f43 = Math_fround(Math_fround((i44 ^ i40 ^ i40 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f39 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i46 = f41 > Math_fround(HEAPF32[i26 >> 2]);
  i45 = f42 > Math_fround(HEAPF32[i6 >> 2]);
  i44 = f43 > Math_fround(HEAPF32[i7 >> 2]);
  i40 = f39 > Math_fround(HEAPF32[i8 >> 2]);
  i37 = i25 + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i37 >> 2]);
  i35 = i37 + 4 | 0;
  f43 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i37 + 8 | 0;
  f42 = Math_fround(HEAPF32[i33 >> 2]);
  i22 = i37 + 12 | 0;
  f41 = Math_fround(HEAPF32[i22 >> 2]);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i30, i23, i28, i29);
  f38 = Math_fround(HEAPF32[i30 >> 2]);
  f38 = Math_fround((i46 ? Math_fround(1.0) : Math_fround(-1.0)) * f38);
  f36 = Math_fround(HEAPF32[i9 >> 2]);
  f36 = Math_fround((i45 ? Math_fround(1.0) : Math_fround(-1.0)) * f36);
  f34 = Math_fround(HEAPF32[i10 >> 2]);
  f34 = Math_fround((i44 ? Math_fround(1.0) : Math_fround(-1.0)) * f34);
  f32 = Math_fround(HEAPF32[i11 >> 2]);
  f36 = Math_fround(f43 + f36);
  f34 = Math_fround(f42 + f34);
  f32 = Math_fround(f41 + Math_fround((i40 ? Math_fround(1.0) : Math_fround(-1.0)) * f32));
  HEAPF32[i37 >> 2] = Math_fround(f39 + f38);
  HEAPF32[i35 >> 2] = f36;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i22 >> 2] = f32;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i27 >>> 0);
 STACKTOP = i31;
 return;
}

function __ZNSt3__211__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri(i1, i2, i3, i6, i7, i8, i9, i5, i4, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1) {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476276 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP8[i3 + 1 >> 0] = i1 >> 8;
  HEAP8[i3 + 2 >> 0] = i1 >> 16;
  HEAP8[i3 + 3 >> 0] = i1 >> 24;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i4 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i4 >> 2] >> 0] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
  } else {
   HEAP8[i4 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i4 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  };
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i5 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
  } else {
   HEAP8[i5 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i5 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  };
  HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP8[i6 >> 0] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP8[i7 >> 0] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 } else {
  i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476268 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP8[i3 + 1 >> 0] = i1 >> 8;
  HEAP8[i3 + 2 >> 0] = i1 >> 16;
  HEAP8[i3 + 3 >> 0] = i1 >> 24;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i4 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i4 >> 2] >> 0] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
  } else {
   HEAP8[i4 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i4 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  };
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i5 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
  } else {
   HEAP8[i5 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i5 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  };
  HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  HEAP8[i6 >> 0] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  HEAP8[i7 >> 0] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i8 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i8 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i2 | 0);
  i1 = i9 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4512 | 0, i9 | 0, 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  };
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 }
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN11Tetrahedron8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378859 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378870 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378881 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378892 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378903 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378916 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378929 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378942 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 83; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 83; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 378955 | 0, gb + 378962 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN10Matrix3x4f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE(i34, i32, i33, i35) {
 i34 = i34 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i35 = i35 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i39 + 20 | 0;
 i31 = i39 + 8 | 0;
 i37 = i39;
 i29 = i32 >>> 0 > 1024;
 i36 = i37 + 4 | 0;
 HEAP8[i36 >> 0] = i29 & 1;
 if (i29) i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i39 + 32 | 0, i32, gb + 730220 | 0, 1258) | 0; else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i32 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 }
 HEAP32[i37 >> 2] = i1;
 _memset(i1 | 0, 0, i32 | 0) | 0;
 i24 = (i32 | 0) > 0;
 i29 = i33 + 4 | 0;
 i28 = i33 + 8 | 0;
 i25 = i30 + 4 | 0;
 i26 = i30 + 8 | 0;
 i27 = i31 + 4 | 0;
 i23 = i31 + 8 | 0;
 i2 = HEAP32[i37 >> 2] | 0;
 L5 : while (1) {
  if (i24) {
   f4 = Math_fround(HEAPF32[i33 >> 2]);
   f5 = Math_fround(HEAPF32[i29 >> 2]);
   f3 = Math_fround(HEAPF32[i28 >> 2]);
   i6 = 0;
   i1 = -1;
   do {
    do if (!(HEAP8[i2 + i6 >> 0] | 0)) {
     if ((i1 | 0) != -1) {
      f21 = Math_fround(HEAPF32[i34 + (i6 * 12 | 0) >> 2]);
      f19 = Math_fround(HEAPF32[i34 + (i6 * 12 | 0) + 4 >> 2]);
      f19 = Math_fround(Math_fround(Math_fround(f4 * f21) + Math_fround(f5 * f19)) + Math_fround(f3 * Math_fround(HEAPF32[i34 + (i6 * 12 | 0) + 8 >> 2])));
      f21 = Math_fround(HEAPF32[i34 + (i1 * 12 | 0) >> 2]);
      f22 = Math_fround(HEAPF32[i34 + (i1 * 12 | 0) + 4 >> 2]);
      if (!(f19 > Math_fround(Math_fround(Math_fround(f4 * f21) + Math_fround(f5 * f22)) + Math_fround(f3 * Math_fround(HEAPF32[i34 + (i1 * 12 | 0) + 8 >> 2]))))) break;
     }
     i1 = i6;
    } while (0);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i32 | 0));
  } else i1 = -1;
  if ((HEAP32[(HEAP32[i35 >> 2] | 0) + (i1 << 2) >> 2] | 0) == 3) break;
  f10 = Math_fround(HEAPF32[i33 >> 2]);
  f11 = Math_fround(HEAPF32[i29 >> 2]);
  f12 = Math_fround(HEAPF32[i28 >> 2]);
  f19 = Math_fround(f12 * Math_fround(0.0));
  f22 = Math_fround(f11 - f19);
  f3 = Math_fround(f19 - f10);
  f4 = Math_fround(f10 * Math_fround(0.0));
  f9 = Math_fround(f11 * Math_fround(0.0));
  f21 = Math_fround(f4 - f9);
  HEAPF32[i30 >> 2] = f22;
  HEAPF32[i25 >> 2] = f3;
  HEAPF32[i26 >> 2] = f21;
  f5 = Math_fround(f9 - f12);
  f4 = Math_fround(f19 - f4);
  f9 = Math_fround(f10 - f9);
  HEAPF32[i31 >> 2] = f5;
  HEAPF32[i27 >> 2] = f4;
  HEAPF32[i23 >> 2] = f9;
  i6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(Math_fround(f22 * f22) + Math_fround(f3 * f3))))) > Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
  i6 = i6 ? i30 : i31;
  f4 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i6 + 4 | 0;
  f5 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i6 + 8 | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f9 * f9))));
  if (f3 == Math_fround(0.0)) {
   _puts(gb + 730491 | 0) | 0;
   f4 = Math_fround(HEAPF32[i6 >> 2]);
   f5 = Math_fround(HEAPF32[i7 >> 2]);
   f9 = Math_fround(HEAPF32[i8 >> 2]);
   f10 = Math_fround(HEAPF32[i33 >> 2]);
   f11 = Math_fround(HEAPF32[i29 >> 2]);
   f12 = Math_fround(HEAPF32[i28 >> 2]);
   i2 = HEAP32[i37 >> 2] | 0;
   f3 = Math_fround(.100000001);
  }
  f14 = Math_fround(Math_fround(1.0) / f3);
  f22 = Math_fround(f4 * f14);
  f21 = Math_fround(f5 * f14);
  f14 = Math_fround(f9 * f14);
  f15 = Math_fround(Math_fround(f21 * f12) - Math_fround(f14 * f11));
  f16 = Math_fround(Math_fround(f14 * f10) - Math_fround(f22 * f12));
  f17 = Math_fround(Math_fround(f22 * f11) - Math_fround(f21 * f10));
  i18 = (i1 | 0) == -1;
  i6 = -1;
  i20 = 0;
  while (1) {
   f19 = Math_fround(i20 | 0);
   f5 = Math_fround(f19 * Math_fround(.0174532924));
   f9 = Math_fround(+Math_sin(+f5));
   f5 = Math_fround(+Math_cos(+f5));
   f3 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f15 * f5)) * Math_fround(.0250000004)));
   f4 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f21 * f9) + Math_fround(f16 * f5)) * Math_fround(.0250000004)));
   f5 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f14 * f9) + Math_fround(f17 * f5)) * Math_fround(.0250000004)));
   if (i24) {
    i8 = 0;
    i7 = -1;
    do {
     do if (!(HEAP8[i2 + i8 >> 0] | 0)) {
      if ((i7 | 0) != -1) {
       f40 = Math_fround(HEAPF32[i34 + (i8 * 12 | 0) >> 2]);
       f41 = Math_fround(HEAPF32[i34 + (i8 * 12 | 0) + 4 >> 2]);
       f41 = Math_fround(Math_fround(Math_fround(f3 * f40) + Math_fround(f4 * f41)) + Math_fround(f5 * Math_fround(HEAPF32[i34 + (i8 * 12 | 0) + 8 >> 2])));
       f40 = Math_fround(HEAPF32[i34 + (i7 * 12 | 0) >> 2]);
       f9 = Math_fround(HEAPF32[i34 + (i7 * 12 | 0) + 4 >> 2]);
       if (!(f41 > Math_fround(Math_fround(Math_fround(f3 * f40) + Math_fround(f4 * f9)) + Math_fround(f5 * Math_fround(HEAPF32[i34 + (i7 * 12 | 0) + 8 >> 2]))))) break;
      }
      i7 = i8;
     } while (0);
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i32 | 0));
    i13 = i7;
   } else i13 = -1;
   if ((i6 | 0) == (i1 | 0) & (i13 | 0) == (i1 | 0)) {
    i38 = 23;
    break L5;
   }
   L35 : do if (!((i6 | 0) == -1 | (i6 | 0) == (i13 | 0))) {
    f3 = Math_fround(f19 + Math_fround(-40.0));
    if (f3 <= f19) {
     if (!i24) while (1) {
      if ((i6 | 0) == (i1 | 0) & i18) {
       i1 = -1;
       i38 = 36;
       break L5;
      }
      f3 = Math_fround(f3 + Math_fround(5.0));
      if (!(f3 <= f19)) break L35; else i6 = -1;
     }
     while (1) {
      f9 = Math_fround(f3 * Math_fround(.0174532924));
      f41 = Math_fround(+Math_sin(+f9));
      f9 = Math_fround(+Math_cos(+f9));
      f4 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f22 * f41) + Math_fround(f15 * f9)) * Math_fround(.0250000004)));
      f5 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f21 * f41) + Math_fround(f16 * f9)) * Math_fround(.0250000004)));
      f9 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f14 * f41) + Math_fround(f17 * f9)) * Math_fround(.0250000004)));
      i8 = 0;
      i7 = -1;
      do {
       do if (!(HEAP8[i2 + i8 >> 0] | 0)) {
        if ((i7 | 0) != -1) {
         f40 = Math_fround(HEAPF32[i34 + (i8 * 12 | 0) >> 2]);
         f42 = Math_fround(HEAPF32[i34 + (i8 * 12 | 0) + 4 >> 2]);
         f42 = Math_fround(Math_fround(Math_fround(f4 * f40) + Math_fround(f5 * f42)) + Math_fround(f9 * Math_fround(HEAPF32[i34 + (i8 * 12 | 0) + 8 >> 2])));
         f40 = Math_fround(HEAPF32[i34 + (i7 * 12 | 0) >> 2]);
         f41 = Math_fround(HEAPF32[i34 + (i7 * 12 | 0) + 4 >> 2]);
         if (!(f42 > Math_fround(Math_fround(Math_fround(f4 * f40) + Math_fround(f5 * f41)) + Math_fround(f9 * Math_fround(HEAPF32[i34 + (i7 * 12 | 0) + 8 >> 2]))))) break;
        }
        i7 = i8;
       } while (0);
       i8 = i8 + 1 | 0;
      } while ((i8 | 0) != (i32 | 0));
      if ((i6 | 0) == (i1 | 0) & (i7 | 0) == (i1 | 0)) {
       i38 = 36;
       break L5;
      }
      f3 = Math_fround(f3 + Math_fround(5.0));
      if (!(f3 <= f19)) break; else i6 = i7;
     }
    }
   } while (0);
   i20 = i20 + 45 | 0;
   if ((i20 | 0) > 360) break; else i6 = i13;
  }
  HEAP8[i2 + i1 >> 0] = 1;
 }
 if ((i38 | 0) == 23) HEAP32[(HEAP32[i35 >> 2] | 0) + (i1 << 2) >> 2] = 3; else if ((i38 | 0) == 36) HEAP32[(HEAP32[i35 >> 2] | 0) + (i1 << 2) >> 2] = 3;
 if (!(HEAP8[i36 >> 0] | 0)) {
  STACKTOP = i39;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i37, i2);
 STACKTOP = i39;
 return i1 | 0;
}

function __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i6 + 48 | 0, gb + 405703 | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i6 + 80 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 81 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 82 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 83 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_(i8, i7, i9, i48, i53, i1, i47, i61, i60, i58, i59, i62) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i48 = i48 | 0;
 i53 = i53 | 0;
 i1 = i1 | 0;
 i47 = i47 | 0;
 i61 = i61 | 0;
 i60 = i60 | 0;
 i58 = i58 | 0;
 i59 = i59 | 0;
 i62 = i62 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i63 = 0, f64 = f0, f65 = f0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, f70 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i63 + 84 | 0;
 i50 = i63 + 32 | 0;
 i49 = i63 + 16 | 0;
 i51 = i63;
 i41 = i63 + 72 | 0;
 i40 = i63 + 60 | 0;
 i52 = i63 + 48 | 0;
 f2 = Math_fround(HEAPF32[i58 >> 2]);
 i54 = i58 + 4 | 0;
 f3 = Math_fround(HEAPF32[i54 >> 2]);
 i55 = i58 + 8 | 0;
 f4 = Math_fround(HEAPF32[i55 >> 2]);
 i56 = i58 + 12 | 0;
 f5 = Math_fround(HEAPF32[i56 >> 2]);
 f46 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f42 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f43 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f38 = Math_fround(HEAPF32[i7 >> 2]);
 f37 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f44 = Math_fround(f38 * Math_fround(HEAPF32[i1 >> 2]));
 f44 = Math_fround(f44 + Math_fround(f37 * Math_fround(HEAPF32[i1 + 16 >> 2])));
 f44 = Math_fround(f44 + Math_fround(f36 * Math_fround(HEAPF32[i1 + 32 >> 2])));
 f45 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f45 = Math_fround(f45 + Math_fround(f37 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f45 = Math_fround(f45 + Math_fround(f36 * Math_fround(HEAPF32[i1 + 36 >> 2])));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f37 = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i1 + 24 >> 2])));
 f44 = Math_fround(f46 + f44);
 f45 = Math_fround(f42 + f45);
 f36 = Math_fround(f43 + Math_fround(f37 + Math_fround(f36 * Math_fround(HEAPF32[i1 + 40 >> 2]))));
 f37 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 f38 = Math_fround(HEAPF32[i7 + 44 >> 2]);
 f39 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f30 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f31 = Math_fround(-f38);
 f32 = Math_fround(-f39);
 f33 = Math_fround(-f30);
 i34 = i8 + 16 | 0;
 L1 : do if (!(HEAP32[i34 >> 2] | 0)) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
 } else {
  i35 = i8 + 24 | 0;
  i29 = i8 + 28 | 0;
  i8 = i9 + 40 | 0;
  i9 = i53 + 16 | 0;
  i17 = i53 + 32 | 0;
  i18 = i53 + 4 | 0;
  i19 = i53 + 20 | 0;
  i20 = i53 + 36 | 0;
  i21 = i53 + 8 | 0;
  i22 = i53 + 24 | 0;
  i23 = i53 + 40 | 0;
  i24 = i51 + 4 | 0;
  i25 = i51 + 8 | 0;
  i26 = i51 + 12 | 0;
  i27 = i50 + 4 | 0;
  i28 = i49 + 4 | 0;
  f6 = Math_fround(3402823469999999843913219.0e14);
  f16 = f4;
  i1 = 0;
  i7 = 0;
  while (1) {
   i68 = HEAP32[i35 >> 2] | 0;
   i67 = HEAPU8[i68 + (i7 * 20 | 0) + 19 >> 0] | 0;
   i66 = HEAP32[i29 >> 2] | 0;
   f70 = Math_fround(HEAPF32[i66 + (i67 * 12 | 0) >> 2]);
   f64 = Math_fround(HEAPF32[i66 + (i67 * 12 | 0) + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i66 + (i67 * 12 | 0) + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i68 + (i7 * 20 | 0) + 12 >> 2]);
   f69 = Math_fround(HEAPF32[i68 + (i7 * 20 | 0) >> 2]);
   f65 = Math_fround(HEAPF32[i68 + (i7 * 20 | 0) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i68 + (i7 * 20 | 0) + 8 >> 2]);
   i68 = HEAP32[i8 >> 2] | 0;
   f15 = Math_fround(f69 * Math_fround(HEAPF32[i68 >> 2]));
   f15 = Math_fround(f15 + Math_fround(f65 * Math_fround(HEAPF32[i68 + 4 >> 2])));
   f15 = Math_fround(f15 + Math_fround(f10 * Math_fround(HEAPF32[i68 + 8 >> 2])));
   f14 = Math_fround(f69 * Math_fround(HEAPF32[i68 + 16 >> 2]));
   f14 = Math_fround(f14 + Math_fround(f65 * Math_fround(HEAPF32[i68 + 20 >> 2])));
   f14 = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i68 + 24 >> 2])));
   f4 = Math_fround(f69 * Math_fround(HEAPF32[i68 + 32 >> 2]));
   f4 = Math_fround(f4 + Math_fround(f65 * Math_fround(HEAPF32[i68 + 36 >> 2])));
   f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i68 + 40 >> 2])));
   f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(f4 * f4)))));
   f10 = Math_fround(Math_fround(Math_fround(Math_fround(f70 * f69) + Math_fround(f64 * f65)) + Math_fround(f12 * f10)) * f13);
   f11 = Math_fround(f11 * f13);
   f12 = Math_fround(-f11);
   f15 = Math_fround(f15 * f13);
   f14 = Math_fround(f14 * f13);
   f4 = Math_fround(f13 * f4);
   f13 = Math_fround(f15 * Math_fround(HEAPF32[i53 >> 2]));
   f13 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i9 >> 2])));
   f13 = Math_fround(f13 + Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2])));
   f65 = Math_fround(f15 * Math_fround(HEAPF32[i18 >> 2]));
   f65 = Math_fround(f65 + Math_fround(f14 * Math_fround(HEAPF32[i19 >> 2])));
   f65 = Math_fround(f65 + Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2])));
   f64 = Math_fround(f15 * Math_fround(HEAPF32[i21 >> 2]));
   f64 = Math_fround(f64 + Math_fround(f14 * Math_fround(HEAPF32[i22 >> 2])));
   f64 = Math_fround(f64 + Math_fround(f4 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i51 >> 2] = f13;
   HEAPF32[i24 >> 2] = f65;
   HEAPF32[i25 >> 2] = f64;
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   i68 = f13 > Math_fround(0.0);
   i67 = f65 > Math_fround(0.0);
   i66 = f64 > Math_fround(0.0);
   f64 = Math_fround(Math_fround(Math_fround(f13 * (i68 ? f38 : f31)) + Math_fround(f65 * (i67 ? f39 : f32))) + Math_fround(f64 * (i66 ? f30 : f33)));
   f64 = f64 > f37 ? f64 : f37;
   f65 = Math_fround(Math_fround(f36 * f4) + Math_fround(Math_fround(f44 * f15) + Math_fround(f45 * f14)));
   f13 = Math_fround(f65 - f64);
   f64 = Math_fround(f65 + f64);
   if (Math_fround((f64 < f12 ? f64 : f12) - (f10 > f13 ? f10 : f13)) > f6) f4 = f16; else {
    f70 = Math_fround(Math_fround(f43 * f4) + Math_fround(Math_fround(f46 * f15) + Math_fround(f42 * f14)));
    mftCall_viiii(HEAP32[(HEAP32[i48 >> 2] | 0) + 12 >> 2] | 0, i48 | 0, i51 | 0, i50 | 0, i49 | 0);
    f13 = Math_fround(f70 + Math_fround(HEAPF32[i50 >> 2]));
    HEAPF32[i50 >> 2] = f13;
    HEAP32[i27 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i27 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i27 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    f70 = Math_fround(f70 + Math_fround(HEAPF32[i49 >> 2]));
    HEAPF32[i49 >> 2] = f70;
    HEAP32[i28 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i28 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i28 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    f69 = Math_fround(HEAPF32[i47 >> 2]);
    if (f13 > Math_fround(f69 - f11) | f10 > Math_fround(f69 + f70)) {
     i1 = 0;
     break;
    }
    f10 = Math_fround(f12 - f13);
    if (f6 > f10) {
     HEAP32[i57 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i57 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
     HEAP32[i57 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
     f6 = f10;
     f5 = Math_fround(0.0);
     f3 = f14;
     f2 = f15;
     i1 = i7;
    } else f4 = f16;
   }
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 >= (HEAP32[i34 >> 2] | 0) >>> 0) break L1; else f16 = f4;
  }
  STACKTOP = i63;
  return i1 | 0;
 } while (0);
 if (Math_fround(HEAPF32[i61 >> 2]) > f6) {
  i68 = i61 + 4 | 0;
  HEAPF32[i58 >> 2] = f2;
  HEAPF32[i54 >> 2] = f3;
  HEAPF32[i55 >> 2] = f4;
  HEAPF32[i56 >> 2] = f5;
  HEAPF32[i61 >> 2] = f6;
  HEAP32[i68 >> 2] = HEAP32[i57 >> 2];
  HEAP32[i68 + 4 >> 2] = HEAP32[i57 + 4 >> 2];
  HEAP32[i68 + 8 >> 2] = HEAP32[i57 + 8 >> 2];
  HEAP32[i62 >> 2] = i59;
 }
 HEAP32[i60 >> 2] = i1;
 i68 = 1;
 STACKTOP = i63;
 return i68 | 0;
}
function __ZN5physx2Sc24ConstraintProjectionTree20buildProjectionTreesERNS0_19ConstraintGroupNodeE(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i27;
 i16 = i27 + 803 | 0;
 i26 = i27 + 16 | 0;
 i14 = i27 + 4 | 0;
 i17 = i27 + 802 | 0;
 i18 = i27 + 801 | 0;
 i21 = i27 + 800 | 0;
 i25 = i26 + 768 | 0;
 i22 = i26 + 772 | 0;
 i20 = i26 + 776 | 0;
 HEAP32[i20 >> 2] = 0;
 i23 = i26 + 780 | 0;
 HEAP8[i25 >> 0] = 1;
 HEAP32[i22 >> 2] = i26;
 HEAP32[i23 >> 2] = 64;
 i12 = i14 + 8 | 0;
 i13 = i14 + 4 | 0;
 i15 = i24;
 do {
  i2 = HEAP32[i15 >> 2] | 0;
  i11 = i15 + 44 | 0;
  i1 = HEAPU8[i11 >> 0] | 0;
  do if (!(HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 44 >> 0] & 1)) {
   HEAP8[i11 >> 0] = i1 & 254;
   HEAP32[i14 >> 2] = i15;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   i1 = HEAP32[i2 + 20 >> 2] | 0;
   i9 = HEAP32[i2 + 28 >> 2] | 0;
   i10 = i1 + (i9 << 2) | 0;
   if ((i9 | 0) > 0) {
    i9 = i1;
    i1 = 0;
    i3 = 0;
    i8 = 402653184;
    while (1) {
     i2 = HEAP32[i9 >> 2] | 0;
     do if ((HEAP8[i2 + 20 >> 0] | 0) == 1) {
      i7 = HEAP32[i2 + 32 >> 2] | 0;
      i6 = HEAP32[i15 >> 2] | 0;
      i4 = __ZNK5physx2Sc13ConstraintSim8isBrokenEv(i7) | 0;
      i5 = HEAPU16[HEAP32[i7 + 100 >> 2] >> 1] | 0;
      i2 = i7 + 108 | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) {
       i6 = i4 ? 0 : i5 & 4;
       i4 = i4 ? 0 : i5 & 2;
       i2 = i7 + 112 | 0;
      } else {
       i6 = i4 ? 0 : i5 & 2;
       i4 = i4 ? 0 : i5 & 4;
      }
      i2 = HEAP32[i2 >> 2] | 0;
      i5 = (i2 | 0) == 0;
      if (!i5) if (!(HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 44 >> 0] & 1)) {
       i4 = (i4 | 0) != 0;
       i2 = (i6 | 0) != 0;
       do if (i4 & i2) {
        i1 = i1 & -268435457;
        HEAP32[i12 >> 2] = i1;
        i2 = i8 & -268435457;
       } else {
        if (i2) {
         i1 = i1 & -402653185;
         HEAP32[i12 >> 2] = i1;
         i2 = i8 & -402653185;
         break;
        }
        if (i4) {
         i1 = i8 & 402653184 | i1 | -2147483648;
         HEAP32[i12 >> 2] = i1;
         i2 = i8;
        } else i2 = i8;
       } while (0);
       i1 = i1 + 1 | 0;
       HEAP32[i12 >> 2] = i1;
       break;
      }
      if (!i6) {
       i2 = i8;
       i4 = 0;
      } else {
       i1 = i1 & -402653185;
       HEAP32[i12 >> 2] = i1;
       i2 = 0;
       i4 = -2147483648;
      }
      i4 = i4 | (i5 ? 1073741824 : 536870912);
      if ((i3 | 0) == 0 | i4 >>> 0 > i1 >>> 0) {
       HEAP32[i13 >> 2] = i7;
       i3 = i7;
      }
      i1 = i1 | i4;
      HEAP32[i12 >> 2] = i1;
     } else i2 = i8; while (0);
     i9 = i9 + 4 | 0;
     if (i9 >>> 0 >= i10 >>> 0) break; else i8 = i2;
    }
    if (i1 >>> 0 > 2415919103) HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 1;
   }
   i1 = HEAP32[i20 >> 2] | 0;
   if ((HEAP32[i23 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i11 = (HEAP32[i22 >> 2] | 0) + (i1 * 12 | 0) | 0;
    HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayINS_2Sc8BodyRankENS0_15InlineAllocatorILj768ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i26, i14) | 0;
    break;
   }
  } else HEAP8[i11 >> 0] = i1 | 1; while (0);
  i15 = HEAP32[i15 + 16 >> 2] | 0;
 } while ((i15 | 0) != 0);
 i1 = HEAP32[i20 >> 2] | 0;
 do if (i1 | 0) {
  __ZN5physx6shdfnd4sortINS_2Sc8BodyRankENS0_7GreaterIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i22 >> 2] | 0, i1, i17, i16, 32);
  i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, HEAP32[i20 >> 2] << 2, gb + 702956 | 0, 235) | 0;
  if (!i11) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 702956 | 0, 378, gb + 703059 | 0, i19);
   break;
  }
  i3 = 0;
  i1 = 0;
  i10 = 0;
  i8 = -1879048192;
  i9 = 0;
  i5 = HEAP32[i20 >> 2] | 0;
  while (1) {
   L49 : do if (i3 >>> 0 < i5 >>> 0) {
    i7 = i1;
    i2 = i11;
    while (1) {
     i4 = HEAP32[i22 >> 2] | 0;
     i6 = i4 + (i3 * 12 | 0) + 8 | 0;
     if ((HEAP32[i6 >> 2] | 0) >>> 0 < i8 >>> 0) {
      i1 = i7;
      break L49;
     }
     i1 = HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0;
     i4 = i4 + (i3 * 12 | 0) + 4 | 0;
     __ZN5physx2Sc19ConstraintGroupNode18initProjectionDataEPS1_PNS0_13ConstraintSimE(i1, 0, HEAP32[i4 >> 2] | 0);
     if (!(HEAP32[i6 >> 2] & 1610612736)) i2 = i2 + ((__ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_(i1, HEAP32[i4 >> 2] | 0, i2) | 0) << 2) | 0; else {
      HEAP32[i2 >> 2] = i1;
      i2 = i2 + 4 | 0;
     }
     HEAP32[i1 + 24 >> 2] = i7;
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 < i5 >>> 0) i7 = i1; else break;
    }
   } else i2 = i11; while (0);
   if ((i11 | 0) != (i2 | 0)) {
    i4 = i11;
    do {
     i19 = HEAP32[i4 >> 2] | 0;
     i4 = i4 + 4 | 0;
     i2 = i2 + ((__ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_(i19, HEAP32[i19 + 40 >> 2] | 0, i2) | 0) << 2) | 0;
    } while ((i4 | 0) != (i2 | 0));
   }
   i3 = i3 + i9 | 0;
   i2 = HEAP32[i20 >> 2] | 0;
   L62 : do if (i3 >>> 0 < i2 >>> 0) {
    i7 = i3;
    i8 = 0;
    i9 = i3;
    while (1) {
     i4 = HEAP32[i22 >> 2] | 0;
     if ((HEAP32[i4 + (i7 * 12 | 0) + 8 >> 2] | 0) >>> 0 <= 2281701375) {
      i4 = i8;
      i5 = i9;
      break L62;
     }
     i5 = (HEAP32[i4 + (i7 * 12 | 0) >> 2] | 0) + 44 | 0;
     i6 = HEAPU8[i5 >> 0] | 0;
     if (!(i6 & 1)) {
      HEAP8[i5 >> 0] = i6 | 1;
      i2 = i4 + (i9 * 12 | 0) | 0;
      i4 = i4 + (i7 * 12 | 0) | 0;
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
      i2 = HEAP32[i20 >> 2] | 0;
      i4 = i8;
      i5 = i9 + 1 | 0;
     } else {
      i4 = i8 + 1 | 0;
      i5 = i9;
     }
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 >= i2 >>> 0) break; else {
      i8 = i4;
      i9 = i5;
     }
    }
   } else {
    i4 = 0;
    i5 = i3;
   } while (0);
   i10 = i10 + 1 | 0;
   if ((i10 | 0) == 2) break; else {
    i8 = -2013265920;
    i9 = i4;
   }
  }
  if (i3 >>> 0 < i2 >>> 0) {
   i7 = i3;
   do {
    i3 = HEAP32[i22 >> 2] | 0;
    i6 = HEAP32[i3 + (i7 * 12 | 0) >> 2] | 0;
    i4 = i6 + 44 | 0;
    i5 = HEAPU8[i4 >> 0] | 0;
    if (!(i5 & 1)) {
     HEAP8[i4 >> 0] = i5 | 1;
     i2 = i11 + ((__ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_(i6, HEAP32[i3 + (i7 * 12 | 0) + 4 >> 2] | 0, i11) | 0) << 2) | 0;
     if ((i11 | 0) != (i2 | 0)) {
      i3 = i11;
      do {
       i19 = HEAP32[i3 >> 2] | 0;
       i3 = i3 + 4 | 0;
       i2 = i2 + ((__ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_(i19, HEAP32[i19 + 40 >> 2] | 0, i2) | 0) << 2) | 0;
      } while ((i3 | 0) != (i2 | 0));
     }
     HEAP32[i6 + 24 >> 2] = i1;
     i2 = HEAP32[i20 >> 2] | 0;
     i1 = i6;
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i2 >>> 0);
  }
  HEAP32[i24 + 20 >> 2] = i1;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i11);
 } while (0);
 i24 = HEAP32[i23 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i26 | 0) == (i1 | 0)) {
  HEAP8[i25 >> 0] = 0;
  STACKTOP = i27;
  return;
 }
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 i26 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0, i1 | 0);
 STACKTOP = i27;
 return;
}

function __ZN14EmissionModule8TransferI14SafeBinaryReadEEvRT_(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 4 | 0;
 i13 = i20;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i17, i18);
 __ZN14SafeBinaryRead10SetVersionEi(i18, 3);
 i19 = i17 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 620496 | 0, gb + 620173 | 0, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i19, i18); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i19 | 0, i18 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
 }
 i14 = i17 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 620509 | 0, gb + 620173 | 0, i15, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i14, i18); else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i18 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
 }
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i11 = i18 + 16 | 0;
 i7 = i18 + 80 | 0;
 i8 = i18 + 20 | 0;
 i9 = i18 + 32 | 0;
 i10 = i18 + 36 | 0;
 i12 = i18 + 24 | 0;
 i3 = 0;
 do {
  i4 = i17 + 552 + (i3 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, HEAP32[gb + 82968 + (i3 << 2) >> 2] | 0, i6, i15, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i5 = HEAP32[i8 >> 2] | 0;
    i1 = i5 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    if (i1 >>> 0 < i5 >>> 0) i16 = 20; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i16 = 20; else {
      HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i11 >> 2] = i2;
     }
    }
    if ((i16 | 0) == 20) {
     i16 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i11, i4, 4);
    }
    if (HEAP32[i18 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i15 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i18 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i18);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 4);
 i3 = 0;
 do {
  i4 = i17 + 568 + (i3 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, HEAP32[gb + 82984 + (i3 << 2) >> 2] | 0, i6, i15, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i5 = HEAP32[i8 >> 2] | 0;
    i1 = i5 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    if (i1 >>> 0 < i5 >>> 0) i16 = 33; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i16 = 33; else {
      HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i11 >> 2] = i2;
     }
    }
    if ((i16 | 0) == 33) {
     i16 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i11, i4, 4);
    }
    if (HEAP32[i18 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i15 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i18 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i18);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 4);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i3 = 0;
 do {
  i4 = i17 + 536 + (i3 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, HEAP32[gb + 83e3 + (i3 << 2) >> 2] | 0, i5, i15, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i2 = HEAP32[i8 >> 2] | 0;
    i1 = i2 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    if (i1 >>> 0 < i2 >>> 0) i16 = 58; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i16 = 58; else {
      HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i11 >> 2] = i2;
     }
    }
    if ((i16 | 0) == 58) {
     i16 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i11, i4, 4);
    }
    if (HEAP32[i18 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i15 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i18 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i18);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 4);
 i3 = i17 + 584 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 620526 | 0, i6, i15, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i5 = HEAP32[i8 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i16 = 45; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i16 = 45; else {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i11 >> 2] = i2;
    }
   }
   if ((i16 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i3, 4);
   if (HEAP32[i18 >> 2] & 512 | 0) HEAP32[i3 >> 2] = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i18 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i18, 1) | 0) {
  HEAP32[i17 + 568 >> 2] = HEAP32[i17 + 552 >> 2];
  HEAP32[i17 + 572 >> 2] = HEAP32[i17 + 556 >> 2];
  HEAP32[i17 + 576 >> 2] = HEAP32[i17 + 560 >> 2];
  HEAP32[i17 + 580 >> 2] = HEAP32[i17 + 564 >> 2];
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i18, 2) | 0)) {
  STACKTOP = i20;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 913271 | 0, i6, i15, 0) | 0;
 if (!i1) i16 = 78; else {
  if ((i1 | 0) > 0) {
   i8 = HEAP32[i8 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   if (i1 >>> 0 < i8 >>> 0) i16 = 72; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) i16 = 72; else {
     HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i11 >> 2] = i2;
    }
   }
   if ((i16 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i13, 4);
   if (HEAP32[i18 >> 2] & 512 | 0) HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i15 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i13 | 0, i18 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
  if (!(HEAP32[i13 >> 2] | 0)) i16 = 78; else {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 620539 | 0, gb + 620173 | 0, i15, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i14, i18); else {
     i1 = HEAP32[i15 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i18 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i18);
   }
   HEAPF32[i17 + 88 >> 2] = Math_fround(0.0);
   HEAP8[i17 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i19, i17 + 96 | 0, Math_fround(0.0), HEAP16[i17 + 92 >> 1] | 0) | 0) & 1;
   HEAP32[i3 >> 2] = 0;
  }
 }
 if ((i16 | 0) == 78) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 620539 | 0, gb + 620173 | 0, i15, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i19, i18); else {
    i1 = HEAP32[i15 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i19 | 0, i18 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i18);
  }
  HEAPF32[i17 + 352 >> 2] = Math_fround(0.0);
  HEAP8[i17 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i14, i17 + 360 | 0, Math_fround(0.0), HEAP16[i17 + 356 >> 1] | 0) | 0) & 1;
 }
 STACKTOP = i20;
 return;
}

function __ZN20LightPropertyBinding14GenerateHashesEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 67) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 4 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 67) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 8 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 103) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 67) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 12 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 98) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 67) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 16 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 67) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 107) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 83) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 122) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 20 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 68) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 114) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 119) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 72) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 108) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 24 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 73) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 116) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 28 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 121) << 2) >> 2] ^ i1 >>> 8);
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 82) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 110) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 103) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 32 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 101) << 2) >> 2] ^ i1 >>> 8);
 i1 = gb + 379848 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 379848 + 20 | 0));
 HEAP32[i3 + 36 >> 2] = ~i2;
 i1 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 83) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 104) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 100) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 111) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 119) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 109) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 95) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 66) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 105) << 2) >> 2] ^ i1 >>> 8;
 i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 97) << 2) >> 2] ^ i1 >>> 8;
 HEAP32[i3 + 40 >> 2] = ~(HEAP32[gb + 1111240 + ((i1 & 255 ^ 115) << 2) >> 2] ^ i1 >>> 8);
 i1 = gb + 379869 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 379869 + 22 | 0));
 HEAP32[i3 + 44 >> 2] = ~i2;
 i1 = gb + 379892 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 379892 + 21 | 0));
 HEAP32[i3 + 48 >> 2] = ~i2;
 i2 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 95) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 83) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 112) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 111) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 65) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 110) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 103) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 108) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[i3 + 52 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8);
 return;
}

function __ZN9Texture2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i21, i22) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i24 + 16 | 0;
 i8 = i24 + 72 | 0;
 i23 = i24 + 52 | 0;
 i11 = i24 + 48 | 0;
 i12 = i24 + 44 | 0;
 i13 = i24 + 40 | 0;
 i14 = i24 + 36 | 0;
 i15 = i24 + 32 | 0;
 i7 = i24 + 28 | 0;
 i19 = i24 + 24 | 0;
 i9 = i24;
 i10 = i24 + 8 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i21, i22);
 i20 = i21 + 52 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i18 + 8 | 0);
  i2 = i1 + 28 | 0;
  i18 = i18 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  i2 = HEAP32[i20 >> 2] | 0;
  i18 = i2 + 4 | 0;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + -1;
  if (!(HEAP32[i18 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i20 >> 2] = i1;
 }
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i17 = i23 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i2 = i16;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i18;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i7 >> 2] = 1;
 i6 = i22 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i22 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i11, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i12, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i1;
 }
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i14, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i13, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i1;
 }
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i21 + 111 | 0;
 if ((i2 + 1 | 0) >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i22);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i15, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i21 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i21 + 32 | 0, i22);
 i1 = i21 + 56 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i21 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i19 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i22, i19, gb + 411165 | 0, 1);
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i21 + 84 >> 2] = i4;
 HEAP32[i21 + 88 >> 2] = HEAP32[i12 >> 2];
 i3 = HEAP32[i13 >> 2] | 0;
 HEAP32[i21 + 92 >> 2] = i3;
 i2 = i21 + 96 | 0;
 HEAP32[i2 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(i4, (HEAP32[i7 >> 2] | 0) > 1, i3) | 0;
 i3 = i21 + 100 | 0;
 HEAP32[i3 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i12 >> 2] | 0, (HEAP32[i7 >> 2] | 0) > 1, HEAP32[i13 >> 2] | 0) | 0;
 i4 = i21 + 76 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i20 >> 2] = 0;
 }
 __ZN9Texture2D16DeleteGfxTextureEv(i21);
 __ZNK6Object14GetMemoryLabelEv(i16, i21);
 if ((HEAP32[i16 >> 2] | 0) == 22) __ZNK6Object14GetMemoryLabelEv(i9, i21); else {
  __ZNK6Object14GetMemoryLabelEv(i8, i21);
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = 19;
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  if (!(HEAP32[i8 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i20 >> 2] = 0;
 }
 i8 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 888) | 0;
 i6 = i9;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i8, i16, i9, i11, i12, i13, i14, i15, 1, 1);
 HEAP32[i20 >> 2] = i8;
 f26 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 >> 2] | 0));
 f25 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i3 >> 2] | 0));
 HEAPF32[i21 + 68 >> 2] = f26;
 HEAPF32[i21 + 72 >> 2] = f25;
 i16 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 136 >> 2] | 0, i21 | 0) | 0;
 if (!(i16 + -1 & i16)) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 140 >> 2] | 0, i21 | 0) | 0;
  i1 = (i1 + -1 & i1 | 0) == 0 & 1;
 } else i1 = 0;
 HEAP8[i21 + 108 >> 0] = i1;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i22, HEAP32[i19 >> 2] | 0, i1, 0);
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i22, 2, gb + 411176 | 0, i21 + 120 | 0, i1, 0);
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i18);
 HEAP32[i23 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __Z11raycast_boxRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i8, i21, i20, i22, f17, i15, i3, i23, i1, i2, i4) {
 i8 = i8 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 f17 = Math_fround(f17);
 i15 = i15 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i19 + 64 | 0;
 i1 = i19 + 52 | 0;
 i16 = i19 + 40 | 0;
 i2 = i19 + 36 | 0;
 i25 = i19 + 24 | 0;
 i26 = i19 + 12 | 0;
 i18 = i19;
 f27 = Math_fround(HEAPF32[i20 >> 2]);
 i5 = i21 + 16 | 0;
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i5 >> 2]));
 i6 = i20 + 4 | 0;
 f33 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i21 + 20 | 0;
 f33 = Math_fround(f33 - Math_fround(HEAPF32[i7 >> 2]));
 i3 = i20 + 8 | 0;
 f37 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i21 + 24 | 0;
 f27 = Math_fround(f27 * Math_fround(2.0));
 f33 = Math_fround(f33 * Math_fround(2.0));
 f37 = Math_fround(Math_fround(f37 - Math_fround(HEAPF32[i4 >> 2])) * Math_fround(2.0));
 i10 = i21 + 12 | 0;
 f34 = Math_fround(HEAPF32[i10 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f38 = Math_fround(HEAPF32[i21 >> 2]);
 f28 = Math_fround(f27 * f38);
 i11 = i21 + 4 | 0;
 f32 = Math_fround(HEAPF32[i11 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f33 * f32));
 i12 = i21 + 8 | 0;
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f37 * f9));
 f31 = Math_fround(Math_fround(f32 * f28) + Math_fround(Math_fround(f33 * f35) - Math_fround(f34 * Math_fround(Math_fround(f27 * f9) - Math_fround(f37 * f38)))));
 f36 = Math_fround(Math_fround(Math_fround(f37 * f35) - Math_fround(f34 * Math_fround(Math_fround(f33 * f38) - Math_fround(f27 * f32)))) + Math_fround(f9 * f28));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(f38 * f28) + Math_fround(Math_fround(f27 * f35) - Math_fround(f34 * Math_fround(Math_fround(f37 * f32) - Math_fround(f33 * f9)))));
 HEAPF32[i24 + 4 >> 2] = f31;
 HEAPF32[i24 + 8 >> 2] = f36;
 f36 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(2.0));
 i13 = i22 + 4 | 0;
 f31 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(2.0));
 i14 = i22 + 8 | 0;
 f33 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(2.0));
 f37 = Math_fround(Math_fround(Math_fround(f36 * f38) + Math_fround(f31 * f32)) + Math_fround(f33 * f9));
 f27 = Math_fround(Math_fround(f32 * f37) + Math_fround(Math_fround(f31 * f35) - Math_fround(f34 * Math_fround(Math_fround(f36 * f9) - Math_fround(f33 * f38)))));
 f28 = Math_fround(Math_fround(Math_fround(f33 * f35) - Math_fround(f34 * Math_fround(Math_fround(f31 * f38) - Math_fround(f36 * f32)))) + Math_fround(f9 * f37));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f38 * f37) + Math_fround(Math_fround(f36 * f35) - Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f9)))));
 HEAPF32[i1 + 4 >> 2] = f27;
 HEAPF32[i1 + 8 >> 2] = f28;
 i30 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i25 >> 2] = i30;
 i29 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i25 + 4 >> 2] = i29;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i25 + 8 >> 2] = i8;
 f28 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f27 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f9 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i26 >> 2] = f28;
 HEAPF32[i26 + 4 >> 2] = f27;
 HEAPF32[i26 + 8 >> 2] = f9;
 i8 = __ZN5physx2Gu17rayAABBIntersect2ERKNS_6PxVec3ES3_S3_S3_RS1_Rf(i26, i25, i24, i1, i16, i2) | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if ((i8 | 0) == 0 | f9 > f17) {
  i30 = 0;
  STACKTOP = i19;
  return i30 | 0;
 }
 HEAPF32[i23 + 40 >> 2] = f9;
 HEAP32[i23 + 8 >> 2] = -1;
 HEAPF32[i23 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i23 + 48 >> 2] = Math_fround(0.0);
 i2 = HEAP16[i15 >> 1] | 0;
 do if (!(i2 & 1)) i1 = 4; else {
  i1 = i23 + 16 | 0;
  if (f9 != Math_fround(0.0)) {
   f33 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * Math_fround(2.0));
   f31 = Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) * Math_fround(2.0));
   f17 = Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) * Math_fround(2.0));
   f28 = Math_fround(HEAPF32[i10 >> 2]);
   f27 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
   f32 = Math_fround(HEAPF32[i21 >> 2]);
   f38 = Math_fround(f33 * f32);
   f34 = Math_fround(HEAPF32[i11 >> 2]);
   f38 = Math_fround(f38 + Math_fround(f31 * f34));
   f35 = Math_fround(HEAPF32[i12 >> 2]);
   f38 = Math_fround(f38 + Math_fround(f17 * f35));
   f36 = Math_fround(Math_fround(f32 * f38) + Math_fround(Math_fround(f33 * f27) + Math_fround(f28 * Math_fround(Math_fround(f17 * f34) - Math_fround(f31 * f35)))));
   f37 = Math_fround(Math_fround(f34 * f38) + Math_fround(Math_fround(f31 * f27) + Math_fround(f28 * Math_fround(Math_fround(f33 * f35) - Math_fround(f17 * f32)))));
   f38 = Math_fround(Math_fround(Math_fround(f17 * f27) + Math_fround(f28 * Math_fround(Math_fround(f31 * f32) - Math_fround(f33 * f34)))) + Math_fround(f35 * f38));
   f36 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f36);
   f37 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f37);
   f38 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f38);
   HEAPF32[i1 >> 2] = f36;
   HEAPF32[i23 + 20 >> 2] = f37;
   HEAPF32[i23 + 24 >> 2] = f38;
   i1 = 5;
   break;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i23 + 20 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i23 + 24 >> 2] = HEAP32[i3 >> 2];
   i1 = 5;
   break;
  }
 } while (0);
 do if (!(i2 & 2)) {
  HEAP32[i23 + 28 >> 2] = 0;
  HEAP32[i23 + 32 >> 2] = 0;
  HEAP32[i23 + 36 >> 2] = 0;
 } else {
  i1 = (i1 & 65535 | 2) & 65535;
  if (f9 == Math_fround(0.0)) {
   f36 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
   f37 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
   f38 = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
   HEAPF32[i23 + 28 >> 2] = f36;
   HEAPF32[i23 + 32 >> 2] = f37;
   HEAPF32[i23 + 36 >> 2] = f38;
   break;
  } else {
   i26 = i8 + -1 | 0;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   i29 = i18 + 4 | 0;
   HEAPF32[i29 >> 2] = Math_fround(0.0);
   i30 = i18 + 8 | 0;
   HEAPF32[i30 >> 2] = Math_fround(0.0);
   i25 = Math_fround(HEAPF32[i16 + (i26 << 2) >> 2]) > Math_fround(0.0);
   HEAPF32[i18 + (i26 << 2) >> 2] = i25 ? Math_fround(1.0) : Math_fround(-1.0);
   f28 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(2.0));
   f35 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * Math_fround(2.0));
   f33 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * Math_fround(2.0));
   f32 = Math_fround(HEAPF32[i10 >> 2]);
   f31 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
   f17 = Math_fround(HEAPF32[i21 >> 2]);
   f27 = Math_fround(f28 * f17);
   f34 = Math_fround(HEAPF32[i11 >> 2]);
   f27 = Math_fround(f27 + Math_fround(f35 * f34));
   f36 = Math_fround(HEAPF32[i12 >> 2]);
   f27 = Math_fround(f27 + Math_fround(f33 * f36));
   f37 = Math_fround(Math_fround(f34 * f27) + Math_fround(Math_fround(f35 * f31) + Math_fround(f32 * Math_fround(Math_fround(f28 * f36) - Math_fround(f33 * f17)))));
   f38 = Math_fround(Math_fround(Math_fround(f33 * f31) + Math_fround(f32 * Math_fround(Math_fround(f35 * f17) - Math_fround(f28 * f34)))) + Math_fround(f36 * f27));
   HEAPF32[i23 + 28 >> 2] = Math_fround(Math_fround(f17 * f27) + Math_fround(Math_fround(f28 * f31) + Math_fround(f32 * Math_fround(Math_fround(f33 * f34) - Math_fround(f35 * f36)))));
   HEAPF32[i23 + 32 >> 2] = f37;
   HEAPF32[i23 + 36 >> 2] = f38;
   break;
  }
 } while (0);
 HEAP16[i23 + 12 >> 1] = i1;
 i30 = 1;
 STACKTOP = i19;
 return i30 | 0;
}

function __Z29AddRotationCurveToClipBuilderR17AnimationCurveTplI11QuaternionfERK8UnityStrR18MecanimClipBuilderb(i20, i21, i22, i3) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i23 + 8 | 0;
 i7 = i23;
 f19 = Math_fround(HEAPF32[i22 + 1084 >> 2]);
 i1 = i20 + 164 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i23;
  return;
 }
 __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i6, i20);
 if ((HEAP32[i6 >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i23;
  return;
 }
 __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i7, i20);
 if ((HEAP32[i7 + 4 >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i23;
  return;
 }
 i4 = i20 + 152 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 L11 : do if ((i8 | 0) > 0) {
  i2 = 0;
  f13 = f15;
  f9 = f18;
  f11 = f16;
  f12 = f17;
  while (1) {
   f24 = Math_fround(f13 - f15);
   f25 = Math_fround(f11 - f16);
   f26 = Math_fround(f12 - f17);
   f27 = Math_fround(f9 - f18);
   if (!(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)))) <= Math_fround(9.99999996e-13))) {
    f27 = Math_fround(f15 + f13);
    f26 = Math_fround(f16 + f11);
    f25 = Math_fround(f17 + f12);
    f24 = Math_fround(f18 + f9);
    if (!(Math_fround(Math_fround(f24 * f24) + Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f26 * f26) + Math_fround(f27 * f27)))) <= Math_fround(9.99999996e-13))) break;
   }
   f9 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 20 >> 2]);
   f12 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 24 >> 2]);
   f13 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 28 >> 2]);
   f11 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 32 >> 2]);
   if (!(Math_fround(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f12 * f12)) + Math_fround(f13 * f13)) + Math_fround(f11 * f11)) <= Math_fround(9.99999996e-13))) {
    f24 = Math_fround(f9 + Math_fround(0.0));
    f25 = Math_fround(f12 + Math_fround(0.0));
    f26 = Math_fround(f13 + Math_fround(0.0));
    f27 = Math_fround(f11 + Math_fround(0.0));
    if (!(Math_fround(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26)) + Math_fround(f27 * f27)) <= Math_fround(9.99999996e-13))) break;
   }
   f9 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 36 >> 2]);
   f12 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 40 >> 2]);
   f13 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 44 >> 2]);
   f11 = Math_fround(HEAPF32[i5 + (i2 * 52 | 0) + 48 >> 2]);
   if (!(Math_fround(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f12 * f12)) + Math_fround(f13 * f13)) + Math_fround(f11 * f11)) <= Math_fround(9.99999996e-13))) {
    f24 = Math_fround(f9 + Math_fround(0.0));
    f25 = Math_fround(f12 + Math_fround(0.0));
    f26 = Math_fround(f13 + Math_fround(0.0));
    f27 = Math_fround(f11 + Math_fround(0.0));
    if (!(Math_fround(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26)) + Math_fround(f27 * f27)) <= Math_fround(9.99999996e-13))) break;
   }
   i1 = i2 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) {
    i14 = 2;
    break L11;
   }
   f13 = Math_fround(HEAPF32[i5 + (i1 * 52 | 0) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i5 + (i1 * 52 | 0) + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i5 + (i1 * 52 | 0) + 12 >> 2]);
   i2 = i1;
   f9 = Math_fround(HEAPF32[i5 + (i1 * 52 | 0) + 16 >> 2]);
  }
  if (i3) i14 = 0; else {
   f9 = Math_fround(Math_fround(1.0) / f19);
   L26 : do if (((HEAP32[i5 + 20 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i5 + 24 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i5 + 28 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i5 + 32 >> 2] & 2139095040 | 0) != 2139095040) if (((HEAP32[i5 + 36 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i5 + 40 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i5 + 44 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i5 + 48 >> 2] & 2139095040 | 0) != 2139095040) {
    __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i6, i20);
    f27 = Math_fround(HEAPF32[i6 + 4 >> 2]);
    __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i7, i20);
    if (!(Math_fround((i8 * 76 | 0) >>> 0) < Math_fround(Math_fround(Math_fround(f27 - Math_fround(HEAPF32[i7 >> 2])) / f9) * Math_fround(16.0)))) {
     if ((i8 | 0) > 1) {
      i2 = HEAP32[i4 >> 2] | 0;
      i1 = 1;
      do {
       if (!(((HEAP32[i2 + (i1 * 52 | 0) + 20 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + (i1 * 52 | 0) + 24 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + (i1 * 52 | 0) + 28 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i2 + (i1 * 52 | 0) + 32 >> 2] & 2139095040 | 0) != 2139095040)) break L26;
       if (!(((HEAP32[i2 + (i1 * 52 | 0) + 36 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + (i1 * 52 | 0) + 40 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + (i1 * 52 | 0) + 44 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i2 + (i1 * 52 | 0) + 48 >> 2] & 2139095040 | 0) != 2139095040)) break L26;
       f27 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) >> 2]);
       if (Math_fround(Math_fround(Math_abs(Math_fround(f27 - Math_fround(HEAPF32[i2 + ((i1 + -1 | 0) * 52 | 0) >> 2])))) - f9) < Math_fround(-.000500000024)) break L26;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) < (i8 | 0));
     }
     i14 = 1;
     break L11;
    }
   } while (0);
   i14 = 0;
  }
 } else i14 = 2; while (0);
 i10 = i22 + 620 + (i14 * 148 | 0) + 40 | 0;
 i2 = i20;
 i3 = i22 + 620 + (i14 * 148 | 0) + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i22 + 620 + (i14 * 148 | 0) + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i22 + 620 + (i14 * 148 | 0) + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22 + 620 + (i14 * 148 | 0) + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i20 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = i20;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i2 = i22 + 620 + (i14 * 148 | 0) + 128 | 0;
 i3 = i22 + 620 + (i14 * 148 | 0) + 140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i22 + 620 + (i14 * 148 | 0) + 144 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i22 + 620 + (i14 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i22 + 620 + (i14 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i22 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i22;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE(i21, 2, (HEAP32[i2 >> 2] | 0) + (i4 << 4) | 0);
 STACKTOP = i23;
 return;
}

function __ZL16CreateSplashQuadR9Transform4PPtrI9Texture2DERK8Vector3fS6_(i18, i14, i19, i20) {
 i18 = i18 | 0;
 i14 = i14 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24;
 i13 = i24 + 40 | 0;
 i3 = i24 + 56 | 0;
 i21 = i24 + 16 | 0;
 i12 = i24 + 12 | 0;
 i16 = i24 + 52 | 0;
 i22 = i24 + 36 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1046280 | 0, 4);
 HEAP32[i17 >> 2] = gb + 1046285;
 HEAP32[i17 + 4 >> 2] = gb + 1046296;
 HEAP32[i17 + 8 >> 2] = 0;
 i23 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i13, gb + 1044255 | 0, i17) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i23, gb + 30872 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1046309 | 0, 8);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i13) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
 __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i1 = __ZN10MeshFilter19GetInstantiatedMeshEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i23, gb + 30872 | 0) | 0) | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = i9;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i15 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
   i2 = HEAP32[i17 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i15 = 12;
  }
 }
 if ((i15 | 0) == 10) i15 = 12;
 if ((i15 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
 i8 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] | 0;
 HEAP32[i21 >> 2] = 0;
 i7 = i21 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i10 = i21 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 63664 | 0);
 i4 = i17;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 L19 : do if ((i8 | 0) > 0) {
  i1 = 0;
  i4 = 0;
  i6 = 0;
  while (1) {
   i3 = i4 + 1 | 0;
   i5 = i6 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i5 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i10 >> 2] = i2;
     HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 4, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
     HEAP32[i10 >> 2] = i2;
     HEAP32[i21 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i3;
   i6 = HEAP32[i21 >> 2] | 0;
   HEAPF32[i6 + (i4 << 4) >> 2] = Math_fround(.5);
   HEAPF32[i6 + (i4 << 4) + 4 >> 2] = Math_fround(.5);
   HEAPF32[i6 + (i4 << 4) + 8 >> 2] = Math_fround(.5);
   HEAPF32[i6 + (i4 << 4) + 12 >> 2] = Math_fround(.5);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i8 | 0)) break L19;
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i10 >> 2] | 0;
  }
 } while (0);
 HEAP32[i13 >> 2] = i9;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i15 = 20; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
   i2 = HEAP32[i17 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 20; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i15 = 22;
  }
 }
 if ((i15 | 0) == 20) i15 = 22;
 if ((i15 | 0) == 22) i1 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
 __ZN4Mesh9SetColorsEPK10ColorRGBAfj(i1, HEAP32[i21 >> 2] | 0, i8);
 HEAP32[i12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i12, gb + 1046318 | 0);
 i4 = __Z15GetScriptMapperv() | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, gb + 1046327 | 0, 26);
 i4 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i17) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 i4 = __ZN8Material14CreateMaterialER6Shaderib(i4, 61, 0) | 0;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 if (!i14) i1 = 0; else {
  HEAP32[i13 >> 2] = i14;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i15 = 29; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i13);
    i2 = HEAP32[i17 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 29; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i15 = 31;
   }
  }
  if ((i15 | 0) == 29) i15 = 31;
  if ((i15 | 0) == 31) i1 = __Z31ReadObjectFromPersistentManageri(i14) | 0;
 };
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i4, i17, i1);
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i23, gb + 31312 | 0) | 0;
 if (!i4) i1 = 0; else i1 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = i1;
 HEAP32[i17 >> 2] = HEAP32[i22 >> 2];
 __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i2, i17, 0);
 i23 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i23, gb + 28940 | 0) | 0;
 __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i23, i18, 1) | 0;
 __ZN9Transform16SetLocalPositionERK8Vector3f(i23, i19);
 __ZN9Transform13SetLocalScaleERK8Vector3f(i23, i20);
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i11);
 HEAP32[i21 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __ZN15b2DistanceJoint23InitVelocityConstraintsERK12b2SolverData(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0;
 i11 = HEAP32[i17 + 48 >> 2] | 0;
 i28 = HEAP32[i11 + 8 >> 2] | 0;
 i25 = i17 + 108 | 0;
 HEAP32[i25 >> 2] = i28;
 i27 = HEAP32[i17 + 52 >> 2] | 0;
 i34 = HEAP32[i27 + 8 >> 2] | 0;
 i21 = i17 + 112 | 0;
 HEAP32[i21 >> 2] = i34;
 i32 = i11 + 28 | 0;
 i33 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 4 >> 2] | 0;
 i3 = i17 + 140 | 0;
 HEAP32[i3 >> 2] = i33;
 HEAP32[i3 + 4 >> 2] = i32;
 i3 = i27 + 28 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i17 + 148 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i17 + 156 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 + 120 >> 2];
 i9 = i17 + 160 | 0;
 HEAP32[i9 >> 2] = HEAP32[i27 + 120 >> 2];
 i7 = i17 + 164 | 0;
 HEAP32[i7 >> 2] = HEAP32[i11 + 128 >> 2];
 i11 = i17 + 168 | 0;
 HEAP32[i11 >> 2] = HEAP32[i27 + 128 >> 2];
 i27 = HEAP32[i18 + 24 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i27 + (i28 * 12 | 0) >> 2]);
 f2 = Math_fround(HEAPF32[i27 + (i28 * 12 | 0) + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i27 + (i28 * 12 | 0) + 8 >> 2]);
 i22 = i18 + 28 | 0;
 i35 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i35 + (i28 * 12 | 0) >> 2] | 0;
 i24 = HEAP32[i35 + (i28 * 12 | 0) + 4 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i35 + (i28 * 12 | 0) + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i27 + (i34 * 12 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i27 + (i34 * 12 | 0) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i27 + (i34 * 12 | 0) + 8 >> 2]);
 i27 = HEAP32[i35 + (i34 * 12 | 0) >> 2] | 0;
 i28 = HEAP32[i35 + (i34 * 12 | 0) + 4 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i35 + (i34 * 12 | 0) + 8 >> 2]);
 f19 = Math_fround(+Math_sin(+f13));
 f13 = Math_fround(+Math_cos(+f13));
 f12 = Math_fround(+Math_sin(+f14));
 f14 = Math_fround(+Math_cos(+f14));
 f20 = Math_fround(HEAPF32[i17 + 80 >> 2]);
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f31 = Math_fround(HEAPF32[i17 + 84 >> 2]);
 f31 = Math_fround(f31 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f30 = Math_fround(Math_fround(f13 * f20) - Math_fround(f19 * f31));
 f31 = Math_fround(Math_fround(f19 * f20) + Math_fround(f13 * f31));
 HEAPF32[i17 + 124 >> 2] = f30;
 HEAPF32[i17 + 128 >> 2] = f31;
 f13 = Math_fround(HEAPF32[i17 + 88 >> 2]);
 f13 = Math_fround(f13 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(HEAPF32[i17 + 92 >> 2]);
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f20));
 f20 = Math_fround(Math_fround(f12 * f13) + Math_fround(f14 * f20));
 HEAPF32[i17 + 132 >> 2] = f19;
 HEAPF32[i17 + 136 >> 2] = f20;
 f1 = Math_fround(Math_fround(Math_fround(f15 + f19) - f1) - f30);
 f2 = Math_fround(Math_fround(Math_fround(f16 + f20) - f2) - f31);
 i3 = i17 + 116 | 0;
 HEAPF32[i3 >> 2] = f1;
 i4 = i17 + 120 | 0;
 HEAPF32[i4 >> 2] = f2;
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2))));
 if (f16 > Math_fround(.00499999989)) {
  f14 = Math_fround(Math_fround(1.0) / f16);
  f15 = Math_fround(f1 * f14);
  HEAPF32[i3 >> 2] = f15;
  f14 = Math_fround(f14 * f2);
 } else {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
 }
 HEAPF32[i4 >> 2] = f14;
 f2 = Math_fround(Math_fround(f14 * f30) - Math_fround(f31 * f15));
 f1 = Math_fround(Math_fround(f14 * f19) - Math_fround(f15 * f20));
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(f13 + Math_fround(f2 * Math_fround(f2 * f12)));
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 f2 = Math_fround(f10 + f2);
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f1 = Math_fround(f2 + Math_fround(f1 * Math_fround(f1 * f8)));
 i3 = f1 != Math_fround(0.0);
 f2 = Math_fround(Math_fround(1.0) / f1);
 f2 = i3 ? f2 : Math_fround(0.0);
 i3 = i17 + 172 | 0;
 HEAPF32[i3 >> 2] = f2;
 f5 = Math_fround(HEAPF32[i17 + 68 >> 2]);
 if (f5 > Math_fround(0.0)) {
  f36 = Math_fround(f16 - Math_fround(HEAPF32[i17 + 104 >> 2]));
  f5 = Math_fround(f5 * Math_fround(6.28318548));
  f37 = Math_fround(f2 * Math_fround(2.0));
  f37 = Math_fround(f5 * Math_fround(f37 * Math_fround(HEAPF32[i17 + 72 >> 2])));
  f5 = Math_fround(f5 * Math_fround(f5 * f2));
  f16 = Math_fround(HEAPF32[i18 >> 2]);
  f2 = Math_fround(f16 * Math_fround(f37 + Math_fround(f5 * f16)));
  i35 = f2 != Math_fround(0.0);
  f2 = Math_fround(Math_fround(1.0) / f2);
  f2 = i35 ? f2 : Math_fround(0.0);
  f16 = Math_fround(Math_fround(f5 * Math_fround(f36 * f16)) * f2);
  f1 = Math_fround(f1 + f2);
  i35 = f1 != Math_fround(0.0);
  f1 = Math_fround(Math_fround(1.0) / f1);
  HEAPF32[i3 >> 2] = i35 ? f1 : Math_fround(0.0);
  f1 = f16;
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i17 + 96 >> 2] = f2;
 HEAPF32[i17 + 76 >> 2] = f1;
 if (!(HEAP8[i18 + 20 >> 0] | 0)) {
  HEAPF32[i17 + 100 >> 2] = Math_fround(0.0);
  f36 = f26;
  f37 = f29;
  i34 = i28;
  i33 = i24;
  i35 = HEAP32[i25 >> 2] | 0;
  i32 = HEAP32[i22 >> 2] | 0;
  i28 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i28 >> 2] = i23;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i25 >> 2] | 0;
  i33 = HEAP32[i22 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f36;
  i35 = HEAP32[i21 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i27;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i21 >> 2] | 0;
  i34 = HEAP32[i22 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f37;
  return;
 } else {
  f16 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  i34 = i17 + 100 | 0;
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i34 >> 2]));
  HEAPF32[i34 >> 2] = f16;
  f37 = Math_fround(f16 * f15);
  f16 = Math_fround(f16 * f14);
  f15 = Math_fround(f37 * f13);
  f36 = Math_fround(f16 * f13);
  f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f15);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f36);
  i33 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  f36 = Math_fround(f26 - Math_fround(f12 * Math_fround(Math_fround(f16 * f30) - Math_fround(f37 * f31))));
  f30 = Math_fround(f37 * f10);
  f31 = Math_fround(f16 * f10);
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
  f37 = Math_fround(f29 + Math_fround(f8 * Math_fround(Math_fround(f16 * f19) - Math_fround(f37 * f20))));
  i28 = i24;
  i24 = i34;
  i34 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i35 = HEAP32[i25 >> 2] | 0;
  i32 = HEAP32[i22 >> 2] | 0;
  i27 = i32 + (i35 * 12 | 0) | 0;
  HEAP32[i27 >> 2] = i24;
  i35 = i32 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i33;
  i35 = HEAP32[i25 >> 2] | 0;
  i33 = HEAP32[i22 >> 2] | 0;
  i35 = i33 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f36;
  i35 = HEAP32[i21 >> 2] | 0;
  i32 = i33 + (i35 * 12 | 0) | 0;
  HEAP32[i32 >> 2] = i28;
  i35 = i33 + (i35 * 12 | 0) + 4 | 0;
  HEAP32[i35 >> 2] = i34;
  i35 = HEAP32[i21 >> 2] | 0;
  i34 = HEAP32[i22 >> 2] | 0;
  i35 = i34 + (i35 * 12 | 0) + 8 | 0;
  HEAPF32[i35 >> 2] = f37;
  return;
 }
}

function __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i24, i22, i23) {
 i24 = i24 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 176 | 0;
 i11 = i28 + 168 | 0;
 i16 = i28 + 132 | 0;
 i18 = i28 + 96 | 0;
 i20 = i28 + 64 | 0;
 i21 = i28 + 32 | 0;
 i27 = i28;
 i26 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[i24 + 36 >> 2] | 0, 0, 0) | 0;
 i14 = HEAP32[i24 + 40 >> 2] | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 i19 = i20 + 24 | 0;
 i2 = i23 + 24 | 0;
 i15 = HEAP32[i2 + 4 >> 2] | 0;
 i17 = i19;
 HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i17 + 4 >> 2] = i15;
 HEAP8[i20 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i20, i23);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 i17 = i18 + 24 | 0;
 i15 = i19;
 i2 = HEAP32[i15 + 4 >> 2] | 0;
 i4 = i17;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP8[i18 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i18, i20);
 i4 = i18 + 32 | 0;
 HEAP32[i4 >> 2] = i22;
 HEAP32[i16 >> 2] = 0;
 i2 = i16 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i15 = i16 + 24 | 0;
 i1 = i17;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i15;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i13;
 i3 = i16 + 4 | 0;
 HEAP8[i3 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i16, i18);
 i13 = i16 + 32 | 0;
 HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
 i4 = i14 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i4;
  i2 = i4;
  i3 = i4;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  i9 = HEAP32[i16 >> 2] | 0;
  i9 = (i9 | 0) == 0 ? i3 : i9;
  while (1) {
   i7 = HEAP32[i1 + 16 >> 2] | 0;
   i8 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = i10 >>> 0 > i8 >>> 0 ? i8 : i10;
   L6 : do if (!i2) i12 = 5; else {
    i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
    i4 = i9;
    while (1) {
     i5 = HEAP8[i4 >> 0] | 0;
     i6 = HEAP8[i3 >> 0] | 0;
     if (i5 << 24 >> 24 != i6 << 24 >> 24) break;
     i2 = i2 + -1 | 0;
     if (!i2) {
      i12 = 5;
      break L6;
     } else {
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     }
    }
    i2 = (i5 & 255) - (i6 & 255) | 0;
   } while (0);
   if ((i12 | 0) == 5) {
    i12 = 0;
    i2 = i10 - i8 | 0;
   }
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i12 = 11;
     break;
    } else i1 = i2;
   } else {
    i2 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
    L18 : do if (!i2) i12 = 14; else {
     i6 = i9;
     i3 = (i7 | 0) == 0 ? i1 + 20 | 0 : i7;
     while (1) {
      i4 = HEAP8[i3 >> 0] | 0;
      i5 = HEAP8[i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i12 = 14;
       break L18;
      } else {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
      }
     }
     i2 = (i4 & 255) - (i5 & 255) | 0;
    } while (0);
    if ((i12 | 0) == 14) {
     i12 = 0;
     i2 = i8 - i10 | 0;
    }
    if ((i2 | 0) >= 0) {
     i12 = 22;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i12 = 21;
     break;
    } else i1 = i2;
   }
  }
  if ((i12 | 0) == 11) {
   HEAP32[i11 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i12 | 0) == 21) {
   HEAP32[i11 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i12 | 0) == 22) {
   HEAP32[i11 >> 2] = i1;
   i2 = i1;
   i3 = i11;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  HEAP32[i25 >> 2] = 6;
  HEAP32[i25 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
  i21 = i1 + 16 | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  i10 = i15;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i1 + 40 | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP8[i1 + 20 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i21, i16);
  HEAP32[i1 + 48 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i14 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 + 4 >> 2] | 0, i1);
  i1 = i14 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i16 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  i1 = HEAP32[i18 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i18 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i20 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
 } else {
  i2 = (HEAP32[i23 + 20 >> 2] | 0) == 0;
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i16 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  i1 = HEAP32[i18 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i18 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i20 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
  if (!i2) {
   __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i21, gb + 370933 | 0, i23);
   HEAP32[i25 >> 2] = 0;
   i1 = i25 + 20 | 0;
   HEAP32[i1 >> 2] = 0;
   i4 = i25 + 24 | 0;
   i20 = gb + 64016 | 0;
   i2 = HEAP32[i20 + 4 >> 2] | 0;
   i3 = i4;
   HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = i25 + 4 | 0;
   HEAP8[i3 >> 0] = 0;
   i2 = (HEAP32[i21 + 20 >> 2] | 0) + 19 | 0;
   if (i2 >>> 0 >= 15) __ZN4core20StringStorageDefaultIcE10reallocateEj(i25, i2);
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i25, i21);
   __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i25, HEAP32[i1 >> 2] | 0, 0, gb + 370962 | 0, 19);
   if (!i24) i1 = 0; else i1 = HEAP32[i24 + 4 >> 2] | 0;
   i20 = HEAP32[i25 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i20 | 0) == 0 ? i3 : i20, 0, gb + 370982 | 0, 100, 4, i1, 0, 0);
   i1 = HEAP32[i25 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i25 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
   i1 = HEAP32[i21 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i21 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i21 + 24 | 0);
  }
 }
 if (!(HEAP32[i24 + 44 + (i22 << 5) + 20 >> 2] | 0)) __ZN4core20StringStorageDefaultIcE6assignERKS1_(i24 + 44 + (i22 << 5) | 0, i23); else {
  __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i27, gb + 371057 | 0, i23);
  HEAP32[i25 >> 2] = 0;
  i1 = i25 + 20 | 0;
  HEAP32[i1 >> 2] = 0;
  i4 = i25 + 24 | 0;
  i23 = gb + 64016 | 0;
  i3 = HEAP32[i23 + 4 >> 2] | 0;
  i2 = i4;
  HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = i25 + 4 | 0;
  HEAP8[i2 >> 0] = 0;
  i3 = (HEAP32[i27 + 20 >> 2] | 0) + 19 | 0;
  if (i3 >>> 0 >= 15) __ZN4core20StringStorageDefaultIcE10reallocateEj(i25, i3);
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i25, i27);
  __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i25, HEAP32[i1 >> 2] | 0, 0, gb + 370962 | 0, 19);
  i1 = HEAP32[i25 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i1 | 0) == 0 ? i2 : i1, 0, gb + 370982 | 0, 105, 4, HEAP32[i24 + 4 >> 2] | 0, 0, 0);
  i1 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i25 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
  i1 = HEAP32[i27 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i27 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i27 + 24 | 0);
 }
 if (!i26) {
  STACKTOP = i28;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i28;
 return;
}

function __ZN5physx2Gu30computeCapsule_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbRNS_10PxSweepHitE(i56, i55, i53, f7, f1, i54, i3) {
 i56 = i56 | 0;
 i55 = i55 | 0;
 i53 = i53 | 0;
 f7 = Math_fround(f7);
 f1 = Math_fround(f1);
 i54 = i54 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0;
 i75 = STACKTOP;
 STACKTOP = STACKTOP + 6144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i75 + 80 | 0;
 i50 = i75 + 5580 | 0;
 i47 = i75 + 64 | 0;
 i52 = i75 + 5584 | 0;
 i73 = i75 + 4224 | 0;
 i71 = i75 + 48 | 0;
 i44 = i75 + 32 | 0;
 i72 = i75 + 16 | 0;
 i74 = i75 + 4216 | 0;
 i49 = i75;
 i46 = i75 + 4188 | 0;
 i43 = i75 + 5520 | 0;
 i22 = i75 + 4176 | 0;
 i51 = i75 + 4240 | 0;
 i23 = i56 + 36 | 0;
 i42 = HEAP32[(HEAP32[i23 >> 2] | 0) + 168 >> 2] | 0;
 HEAP32[i50 >> 2] = 0;
 HEAPF32[i47 >> 2] = Math_fround(f7 * Math_fround(1.14999998));
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i52, i55, i56 + 4 | 0);
 __ZN5physx2Gu9ContainerC2Ev(i73);
 __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i73, 128, i75 + 5632 | 0, 1);
 i68 = i71 + 4 | 0;
 i69 = i71 + 8 | 0;
 HEAP32[i71 >> 2] = 0;
 HEAP32[i71 + 4 >> 2] = 0;
 HEAP32[i71 + 8 >> 2] = 0;
 HEAP32[i71 + 12 >> 2] = 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = 0;
 HEAP32[i44 + 12 >> 2] = 0;
 i70 = i72 + 4 | 0;
 i59 = i72 + 8 | 0;
 i60 = i72 + 12 | 0;
 HEAP32[i72 >> 2] = 0;
 HEAP32[i72 + 4 >> 2] = 0;
 HEAP32[i72 + 8 >> 2] = 0;
 HEAP32[i72 + 12 >> 2] = 0;
 HEAP32[i74 >> 2] = 268435455;
 i24 = i73 + 4 | 0;
 i25 = i53 + 96 | 0;
 i26 = i53 + 100 | 0;
 i27 = i53 + 104 | 0;
 i28 = i53 + 108 | 0;
 i29 = i46 + 4 | 0;
 i30 = i46 + 8 | 0;
 i31 = i53 + 112 | 0;
 i32 = i53 + 116 | 0;
 i33 = i53 + 120 | 0;
 i34 = i53 + 124 | 0;
 i35 = i46 + 12 | 0;
 i36 = i46 + 16 | 0;
 i37 = i46 + 20 | 0;
 i38 = i46 + 24 | 0;
 i39 = i73 + 8 | 0;
 i40 = i49 + 4 | 0;
 i41 = i53 + 128 | 0;
 i61 = i3 + 40 | 0;
 i62 = i3 + 16 | 0;
 i63 = i3 + 20 | 0;
 i64 = i3 + 24 | 0;
 i65 = i3 + 28 | 0;
 i66 = i3 + 32 | 0;
 i67 = i3 + 36 | 0;
 i58 = i3 + 8 | 0;
 i17 = i53 + 4 | 0;
 i18 = i53 + 8 | 0;
 i19 = i53 + 12 | 0;
 i20 = i53 + 96 | 0;
 i21 = i53 + 112 | 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 i45 = 0;
 i3 = 0;
 while (1) {
  if (HEAP32[i24 >> 2] | 0) HEAP32[i24 >> 2] = 0;
  i4 = HEAP32[i26 >> 2] | 0;
  i16 = HEAP32[i27 >> 2] | 0;
  HEAP32[i46 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i29 >> 2] = i4;
  HEAP32[i30 >> 2] = i16;
  i16 = HEAP32[i32 >> 2] | 0;
  i4 = HEAP32[i33 >> 2] | 0;
  HEAP32[i35 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i36 >> 2] = i16;
  HEAP32[i37 >> 2] = i4;
  HEAPF32[i38 >> 2] = f7;
  __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE(i46, i43);
  __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE(i56, i55, i43, i73);
  i4 = HEAP32[i24 >> 2] | 0;
  if (!i4) {
   i3 = i45;
   i57 = 5;
   break;
  }
  i8 = HEAP32[i39 >> 2] | 0;
  HEAPF32[i49 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i40 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i40 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i40 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i9 = (i4 + 31 | 0) >>> 5;
  if (!i9) {
   i3 = i45;
   i57 = 14;
   break;
  }
  i13 = 0;
  i14 = 0;
  i15 = ~i4;
  while (1) {
   i10 = i15 >>> 0 > 4294967263 ? ~i15 : 32;
   i11 = i13 << 5;
   i12 = i4 - i11 | 0;
   i12 = i12 >>> 0 < 32 ? i12 : 32;
   if (i12 | 0) {
    i16 = 0;
    do {
     i76 = HEAP32[i8 + (i16 + i11 << 2) >> 2] | 0;
     __ZNK5physx2Gu12TriangleMesh20computeWorldTriangleERNS_10PxTriangleEjRKNS_2Cm8Matrix34EPjS8_(HEAP32[i23 >> 2] | 0, i51 + (i16 * 40 | 0) | 0, i76, i52, 0, 0);
     HEAP8[i51 + (i16 * 40 | 0) + 36 >> 0] = HEAP8[i42 + i76 >> 0] | 0;
     i16 = i16 + 1 | 0;
    } while ((i16 | 0) != (i10 | 0));
   }
   i14 = i14 | (__Z12calculateMTDRKN5physx2Gu8CapsuleVERKNS_6shdfnd3aos6FloatVEbPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS5_5Vec3VESG_SG_SE_RS6_(i53, i47, i54, i51, i12, i11, i48, i50, i72, i71, i44, i74, i49) | 0);
   i13 = i13 + 1 | 0;
   if ((i13 | 0) == (i9 | 0)) break; else i15 = i15 + 32 | 0;
  }
  if (!i14) {
   i3 = i45;
   i57 = 14;
   break;
  }
  i4 = HEAP32[i8 + (HEAP32[i74 >> 2] << 2) >> 2] | 0;
  HEAP32[i74 >> 2] = i4;
  f6 = Math_fround(HEAPF32[i49 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i41 >> 2]));
  if (!(f6 <= Math_fround(0.0))) {
   i57 = 13;
   break;
  }
  f79 = Math_fround(HEAPF32[i53 >> 2]);
  f80 = Math_fround(HEAPF32[i17 >> 2]);
  f82 = Math_fround(HEAPF32[i18 >> 2]);
  f78 = Math_fround(HEAPF32[i72 >> 2]);
  f77 = Math_fround(HEAPF32[i70 >> 2]);
  f78 = Math_fround(f6 * f78);
  f77 = Math_fround(f6 * f77);
  f81 = Math_fround(f6 * Math_fround(HEAPF32[i59 >> 2]));
  f1 = Math_fround(f1 - f78);
  f2 = Math_fround(f2 - f77);
  f5 = Math_fround(f5 - f81);
  f78 = Math_fround(f79 - f78);
  f77 = Math_fround(f80 - f77);
  f81 = Math_fround(f82 - f81);
  f79 = Math_fround(f78 - f79);
  f80 = Math_fround(f77 - f80);
  f6 = Math_fround(f81 - f82);
  HEAPF32[i53 >> 2] = f78;
  HEAPF32[i17 >> 2] = f77;
  HEAPF32[i18 >> 2] = f81;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  f81 = Math_fround(HEAPF32[i20 >> 2]);
  f77 = Math_fround(HEAPF32[i26 >> 2]);
  f77 = Math_fround(f80 + f77);
  f78 = Math_fround(f6 + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i20 >> 2] = Math_fround(f79 + f81);
  HEAPF32[i26 >> 2] = f77;
  HEAPF32[i27 >> 2] = f78;
  HEAPF32[i28 >> 2] = Math_fround(0.0);
  f78 = Math_fround(HEAPF32[i21 >> 2]);
  f77 = Math_fround(HEAPF32[i32 >> 2]);
  f77 = Math_fround(f80 + f77);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i33 >> 2]));
  HEAPF32[i21 >> 2] = Math_fround(f79 + f78);
  HEAPF32[i32 >> 2] = f77;
  HEAPF32[i33 >> 2] = f6;
  HEAPF32[i34 >> 2] = Math_fround(0.0);
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= 4) {
   f7 = f5;
   i3 = 1;
   break;
  } else i45 = 1;
 }
 if ((i57 | 0) == 5) f7 = f5; else if ((i57 | 0) == 13) if (!i3) {
  HEAPF32[i61 >> 2] = Math_fround(0.0);
  i76 = HEAP32[i68 >> 2] | 0;
  i74 = HEAP32[i69 >> 2] | 0;
  HEAP32[i62 >> 2] = HEAP32[i71 >> 2];
  HEAP32[i63 >> 2] = i76;
  HEAP32[i64 >> 2] = i74;
  i74 = HEAP32[i70 >> 2] | 0;
  i76 = HEAP32[i59 >> 2] | 0;
  HEAP32[i65 >> 2] = HEAP32[i72 >> 2];
  HEAP32[i66 >> 2] = i74;
  HEAP32[i67 >> 2] = i76;
  HEAP32[i58 >> 2] = i4;
  i76 = 1;
  __ZN5physx2Gu9ContainerD2Ev(i73);
  STACKTOP = i75;
  return i76 | 0;
 } else {
  i3 = 1;
  i57 = 14;
 }
 if ((i57 | 0) == 14) f7 = f5;
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)))));
 f82 = Math_fround(Math_fround(1.0) / f6);
 f5 = Math_fround(f1 * f82);
 f2 = Math_fround(f2 * f82);
 f1 = Math_fround(f7 * f82);
 HEAPF32[i72 >> 2] = f5;
 HEAPF32[i70 >> 2] = f2;
 HEAPF32[i59 >> 2] = f1;
 HEAPF32[i60 >> 2] = Math_fround(0.0);
 if (!i3) {
  i76 = 0;
  __ZN5physx2Gu9ContainerD2Ev(i73);
  STACKTOP = i75;
  return i76 | 0;
 }
 HEAPF32[i61 >> 2] = Math_fround(-f6);
 i72 = HEAP32[i68 >> 2] | 0;
 i76 = HEAP32[i69 >> 2] | 0;
 HEAP32[i62 >> 2] = HEAP32[i71 >> 2];
 HEAP32[i63 >> 2] = i72;
 HEAP32[i64 >> 2] = i76;
 HEAPF32[i65 >> 2] = f5;
 HEAPF32[i66 >> 2] = f2;
 HEAPF32[i67 >> 2] = f1;
 HEAP32[i58 >> 2] = HEAP32[i74 >> 2];
 i76 = 1;
 __ZN5physx2Gu9ContainerD2Ev(i73);
 STACKTOP = i75;
 return i76 | 0;
}

function __ZN7Terrain8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i5 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 HEAP32[i8 >> 2] = 0;
 __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i7);
 __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i6, i8);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i6 + 88 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 89 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 90 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i6 + 96 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 100 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 i1 = i6 + 108 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i6 + 112 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i8 >> 2] = (i5 | 0) == 3 ? i2 : 0;
   __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i1, i8, (i5 | 0) == 0 ? gb + 184364 | 0 : (i5 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0);
  }
 }
 i4 = i6 + 152 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i4 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
 } else {
  i5 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP16[i4 + 2 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 120 | 0, i7);
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 136 | 0, i7);
 i1 = i6 + 188 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 156 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 172 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 156 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 172 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 }
}

function runPostSets44() {
 HEAP32[gb + 59944 >> 2] = (HEAP32[gb + 59944 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59948 >> 2] = (HEAP32[gb + 59948 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59952 >> 2] = (HEAP32[gb + 59952 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59956 >> 2] = (HEAP32[gb + 59956 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59960 >> 2] = (HEAP32[gb + 59960 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59964 >> 2] = (HEAP32[gb + 59964 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59968 >> 2] = (HEAP32[gb + 59968 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59972 >> 2] = (HEAP32[gb + 59972 >> 2] | 0) + (gb + 434575 | 0);
 HEAP32[gb + 59976 >> 2] = (HEAP32[gb + 59976 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59980 >> 2] = (HEAP32[gb + 59980 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59984 >> 2] = (HEAP32[gb + 59984 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59988 >> 2] = (HEAP32[gb + 59988 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59992 >> 2] = (HEAP32[gb + 59992 >> 2] | 0) + (gb + 1084278 | 0);
 HEAP32[gb + 59996 >> 2] = (HEAP32[gb + 59996 >> 2] | 0) + (gb + 1087681 | 0);
 HEAP32[gb + 6e4 >> 2] = (HEAP32[gb + 6e4 >> 2] | 0) + (gb + 1046779 | 0);
 HEAP32[gb + 60004 >> 2] = (HEAP32[gb + 60004 >> 2] | 0) + (gb + 1075169 | 0);
 HEAP32[gb + 60008 >> 2] = (HEAP32[gb + 60008 >> 2] | 0) + (gb + 434777 | 0);
 HEAP32[gb + 60012 >> 2] = (HEAP32[gb + 60012 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60016 >> 2] = (HEAP32[gb + 60016 >> 2] | 0) + (gb + 1086433 | 0);
 HEAP32[gb + 60020 >> 2] = (HEAP32[gb + 60020 >> 2] | 0) + (gb + 434779 | 0);
 HEAP32[gb + 60024 >> 2] = (HEAP32[gb + 60024 >> 2] | 0) + (gb + 1086383 | 0);
 HEAP32[gb + 60028 >> 2] = (HEAP32[gb + 60028 >> 2] | 0) + (gb + 1086288 | 0);
 HEAP32[gb + 60032 >> 2] = (HEAP32[gb + 60032 >> 2] | 0) + (gb + 1086428 | 0);
 HEAP32[gb + 60036 >> 2] = (HEAP32[gb + 60036 >> 2] | 0) + (gb + 1087706 | 0);
 HEAP32[gb + 60040 >> 2] = (HEAP32[gb + 60040 >> 2] | 0) + (gb + 1087585 | 0);
 HEAP32[gb + 60044 >> 2] = (HEAP32[gb + 60044 >> 2] | 0) + (gb + 1087656 | 0);
 HEAP32[gb + 60048 >> 2] = (HEAP32[gb + 60048 >> 2] | 0) + (gb + 1087625 | 0);
 HEAP32[gb + 60052 >> 2] = (HEAP32[gb + 60052 >> 2] | 0) + (gb + 1087627 | 0);
 HEAP32[gb + 60056 >> 2] = (HEAP32[gb + 60056 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 60060 >> 2] = (HEAP32[gb + 60060 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 60064 >> 2] = (HEAP32[gb + 60064 >> 2] | 0) + (gb + 588243 | 0);
 HEAP32[gb + 60068 >> 2] = (HEAP32[gb + 60068 >> 2] | 0) + (gb + 434781 | 0);
 HEAP32[gb + 60072 >> 2] = (HEAP32[gb + 60072 >> 2] | 0) + (gb + 758402 | 0);
 HEAP32[gb + 60076 >> 2] = (HEAP32[gb + 60076 >> 2] | 0) + (gb + 434783 | 0);
 HEAP32[gb + 60080 >> 2] = (HEAP32[gb + 60080 >> 2] | 0) + (gb + 766556 | 0);
 HEAP32[gb + 60084 >> 2] = (HEAP32[gb + 60084 >> 2] | 0) + (gb + 758304 | 0);
 HEAP32[gb + 60088 >> 2] = (HEAP32[gb + 60088 >> 2] | 0) + (gb + 434785 | 0);
 HEAP32[gb + 60092 >> 2] = (HEAP32[gb + 60092 >> 2] | 0) + (gb + 434787 | 0);
 HEAP32[gb + 60096 >> 2] = (HEAP32[gb + 60096 >> 2] | 0) + (gb + 459166 | 0);
 HEAP32[gb + 60100 >> 2] = (HEAP32[gb + 60100 >> 2] | 0) + (gb + 434789 | 0);
 HEAP32[gb + 60104 >> 2] = (HEAP32[gb + 60104 >> 2] | 0) + (gb + 1086445 | 0);
 HEAP32[gb + 60108 >> 2] = (HEAP32[gb + 60108 >> 2] | 0) + (gb + 1087558 | 0);
 HEAP32[gb + 60112 >> 2] = (HEAP32[gb + 60112 >> 2] | 0) + (gb + 1086447 | 0);
 HEAP32[gb + 60116 >> 2] = (HEAP32[gb + 60116 >> 2] | 0) + (gb + 434791 | 0);
 HEAP32[gb + 60120 >> 2] = (HEAP32[gb + 60120 >> 2] | 0) + (gb + 434793 | 0);
 HEAP32[gb + 60124 >> 2] = (HEAP32[gb + 60124 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60128 >> 2] = (HEAP32[gb + 60128 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60132 >> 2] = (HEAP32[gb + 60132 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60136 >> 2] = (HEAP32[gb + 60136 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60140 >> 2] = (HEAP32[gb + 60140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60144 >> 2] = (HEAP32[gb + 60144 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60148 >> 2] = (HEAP32[gb + 60148 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60152 >> 2] = (HEAP32[gb + 60152 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60156 >> 2] = (HEAP32[gb + 60156 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60160 >> 2] = (HEAP32[gb + 60160 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60164 >> 2] = (HEAP32[gb + 60164 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60168 >> 2] = (HEAP32[gb + 60168 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60172 >> 2] = (HEAP32[gb + 60172 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60176 >> 2] = (HEAP32[gb + 60176 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60180 >> 2] = (HEAP32[gb + 60180 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60184 >> 2] = (HEAP32[gb + 60184 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60188 >> 2] = (HEAP32[gb + 60188 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60192 >> 2] = (HEAP32[gb + 60192 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60196 >> 2] = (HEAP32[gb + 60196 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60200 >> 2] = (HEAP32[gb + 60200 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60204 >> 2] = (HEAP32[gb + 60204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60208 >> 2] = (HEAP32[gb + 60208 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60212 >> 2] = (HEAP32[gb + 60212 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60216 >> 2] = (HEAP32[gb + 60216 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60220 >> 2] = (HEAP32[gb + 60220 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60224 >> 2] = (HEAP32[gb + 60224 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60228 >> 2] = (HEAP32[gb + 60228 >> 2] | 0) + (gb + 1073935 | 0);
 HEAP32[gb + 60232 >> 2] = (HEAP32[gb + 60232 >> 2] | 0) + (gb + 585717 | 0);
 HEAP32[gb + 60236 >> 2] = (HEAP32[gb + 60236 >> 2] | 0) + (gb + 1086372 | 0);
 HEAP32[gb + 60240 >> 2] = (HEAP32[gb + 60240 >> 2] | 0) + (gb + 1087632 | 0);
 HEAP32[gb + 60244 >> 2] = (HEAP32[gb + 60244 >> 2] | 0) + (gb + 434795 | 0);
 HEAP32[gb + 60248 >> 2] = (HEAP32[gb + 60248 >> 2] | 0) + (gb + 434797 | 0);
 HEAP32[gb + 60252 >> 2] = (HEAP32[gb + 60252 >> 2] | 0) + (gb + 1085926 | 0);
 HEAP32[gb + 60256 >> 2] = (HEAP32[gb + 60256 >> 2] | 0) + (gb + 1085890 | 0);
 HEAP32[gb + 60260 >> 2] = (HEAP32[gb + 60260 >> 2] | 0) + (gb + 1085908 | 0);
 HEAP32[gb + 60264 >> 2] = (HEAP32[gb + 60264 >> 2] | 0) + (gb + 1086046 | 0);
 HEAP32[gb + 60268 >> 2] = (HEAP32[gb + 60268 >> 2] | 0) + (gb + 1086055 | 0);
 HEAP32[gb + 60272 >> 2] = (HEAP32[gb + 60272 >> 2] | 0) + (gb + 1086037 | 0);
 HEAP32[gb + 60276 >> 2] = (HEAP32[gb + 60276 >> 2] | 0) + (gb + 1086064 | 0);
 HEAP32[gb + 60280 >> 2] = (HEAP32[gb + 60280 >> 2] | 0) + (gb + 1085917 | 0);
 HEAP32[gb + 60284 >> 2] = (HEAP32[gb + 60284 >> 2] | 0) + (gb + 1085953 | 0);
 HEAP32[gb + 60288 >> 2] = (HEAP32[gb + 60288 >> 2] | 0) + (gb + 1085962 | 0);
 HEAP32[gb + 60292 >> 2] = (HEAP32[gb + 60292 >> 2] | 0) + (gb + 1083970 | 0);
 HEAP32[gb + 60296 >> 2] = (HEAP32[gb + 60296 >> 2] | 0) + (gb + 1085971 | 0);
 HEAP32[gb + 60300 >> 2] = (HEAP32[gb + 60300 >> 2] | 0) + (gb + 1085980 | 0);
 HEAP32[gb + 60304 >> 2] = (HEAP32[gb + 60304 >> 2] | 0) + (gb + 1086007 | 0);
 HEAP32[gb + 60308 >> 2] = (HEAP32[gb + 60308 >> 2] | 0) + (gb + 1086016 | 0);
 HEAP32[gb + 60312 >> 2] = (HEAP32[gb + 60312 >> 2] | 0) + (gb + 1084092 | 0);
 HEAP32[gb + 60316 >> 2] = (HEAP32[gb + 60316 >> 2] | 0) + (gb + 1084124 | 0);
 HEAP32[gb + 60320 >> 2] = (HEAP32[gb + 60320 >> 2] | 0) + (gb + 1084155 | 0);
 HEAP32[gb + 60324 >> 2] = (HEAP32[gb + 60324 >> 2] | 0) + (gb + 1085935 | 0);
 HEAP32[gb + 60328 >> 2] = (HEAP32[gb + 60328 >> 2] | 0) + (gb + 1085944 | 0);
 HEAP32[gb + 60332 >> 2] = (HEAP32[gb + 60332 >> 2] | 0) + (gb + 1087504 | 0);
 HEAP32[gb + 60336 >> 2] = (HEAP32[gb + 60336 >> 2] | 0) + (gb + 1085869 | 0);
 HEAP32[gb + 60340 >> 2] = (HEAP32[gb + 60340 >> 2] | 0) + (gb + 1085899 | 0);
 runPostSets45();
}

function ___intscan(i13, i4, i6, i1, i2) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : do if (i4 >>> 0 > 36) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i2 = 0;
  i1 = 0;
 } else {
  i15 = i13 + 4 | 0;
  i14 = i13 + 100 | 0;
  do {
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
    HEAP32[i15 >> 2] = i3 + 1;
    i3 = HEAPU8[i3 >> 0] | 0;
   } else i3 = ___shgetc(i13) | 0;
  } while ((_isspace(i3) | 0) != 0);
  L11 : do switch (i3 | 0) {
  case 43:
  case 45:
   {
    i3 = ((i3 | 0) == 45) << 31 >> 31;
    i5 = HEAP32[i15 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
     HEAP32[i15 >> 2] = i5 + 1;
     i12 = i3;
     i3 = HEAPU8[i5 >> 0] | 0;
     break L11;
    } else {
     i12 = i3;
     i3 = ___shgetc(i13) | 0;
     break L11;
    }
   }
  default:
   i12 = 0;
  } while (0);
  i5 = (i4 | 0) == 0;
  do if ((i4 | 16 | 0) == 16 & (i3 | 0) == 48) {
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
    HEAP32[i15 >> 2] = i3 + 1;
    i3 = HEAPU8[i3 >> 0] | 0;
   } else i3 = ___shgetc(i13) | 0;
   if ((i3 | 32 | 0) != 120) if (i5) {
    i4 = 8;
    i10 = 46;
    break;
   } else {
    i10 = 32;
    break;
   }
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
    HEAP32[i15 >> 2] = i3 + 1;
    i3 = HEAPU8[i3 >> 0] | 0;
   } else i3 = ___shgetc(i13) | 0;
   if ((HEAPU8[gb + 1056462 + 1 + i3 >> 0] | 0) > 15) {
    i1 = (HEAP32[i14 >> 2] | 0) == 0;
    if (!i1) HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    if (!i6) {
     ___shlim(i13, 0);
     i2 = 0;
     i1 = 0;
     break L1;
    }
    if (i1) {
     i2 = 0;
     i1 = 0;
     break L1;
    }
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    i2 = 0;
    i1 = 0;
    break L1;
   } else {
    i4 = 16;
    i10 = 46;
   }
  } else {
   i4 = i5 ? 10 : i4;
   if ((HEAPU8[gb + 1056462 + 1 + i3 >> 0] | 0) >>> 0 < i4 >>> 0) i10 = 32; else {
    if (HEAP32[i14 >> 2] | 0) HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    ___shlim(i13, 0);
    HEAP32[(___errno_location() | 0) >> 2] = 22;
    i2 = 0;
    i1 = 0;
    break L1;
   }
  } while (0);
  if ((i10 | 0) == 32) if ((i4 | 0) == 10) {
   i4 = i3 + -48 | 0;
   if (i4 >>> 0 < 10) {
    i3 = 0;
    i5 = i4;
    do {
     i3 = (i3 * 10 | 0) + i5 | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     if (i4 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = i4 + 1;
      i4 = HEAPU8[i4 >> 0] | 0;
     } else i4 = ___shgetc(i13) | 0;
     i5 = i4 + -48 | 0;
    } while (i5 >>> 0 < 10 & i3 >>> 0 < 429496729);
    i6 = 0;
   } else {
    i4 = i3;
    i3 = 0;
    i6 = 0;
   }
   i5 = i4 + -48 | 0;
   if (i5 >>> 0 < 10) {
    i9 = i5;
    while (1) {
     i5 = ___muldi3(i3 | 0, i6 | 0, 10, 0) | 0;
     i7 = getTempRet0() | 0;
     i8 = ((i9 | 0) < 0) << 31 >> 31;
     i11 = ~i8;
     if (i7 >>> 0 > i11 >>> 0 | (i7 | 0) == (i11 | 0) & i5 >>> 0 > ~i9 >>> 0) {
      i5 = i4;
      i4 = i9;
      break;
     }
     i3 = _i64Add(i5 | 0, i7 | 0, i9 | 0, i8 | 0) | 0;
     i6 = getTempRet0() | 0;
     i4 = HEAP32[i15 >> 2] | 0;
     if (i4 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = i4 + 1;
      i4 = HEAPU8[i4 >> 0] | 0;
     } else i4 = ___shgetc(i13) | 0;
     i7 = i4 + -48 | 0;
     if (i7 >>> 0 < 10 & (i6 >>> 0 < 429496729 | (i6 | 0) == 429496729 & i3 >>> 0 < 2576980378)) i9 = i7; else {
      i5 = i4;
      i4 = i7;
      break;
     }
    }
    if (i4 >>> 0 > 9) {
     i5 = i12;
     i4 = i6;
    } else {
     i4 = 10;
     i10 = 72;
    }
   } else {
    i5 = i12;
    i4 = i6;
   }
  } else i10 = 46;
  L63 : do if ((i10 | 0) == 46) {
   if (!(i4 + -1 & i4)) {
    i10 = HEAP8[((i4 * 23 | 0) >>> 5 & 7) + (gb + 1056719) >> 0] | 0;
    i6 = HEAP8[gb + 1056462 + 1 + i3 >> 0] | 0;
    i5 = i6 & 255;
    if (i5 >>> 0 < i4 >>> 0) {
     i3 = 0;
     i7 = i5;
     do {
      i3 = i7 | i3 << i10;
      i5 = HEAP32[i15 >> 2] | 0;
      if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
       HEAP32[i15 >> 2] = i5 + 1;
       i5 = HEAPU8[i5 >> 0] | 0;
      } else i5 = ___shgetc(i13) | 0;
      i6 = HEAP8[gb + 1056462 + 1 + i5 >> 0] | 0;
      i7 = i6 & 255;
     } while (i3 >>> 0 < 134217728 & i7 >>> 0 < i4 >>> 0);
     i7 = 0;
    } else {
     i5 = i3;
     i7 = 0;
     i3 = 0;
    }
    i8 = _bitshift64Lshr(-1, -1, i10 | 0) | 0;
    i9 = getTempRet0() | 0;
    if ((i6 & 255) >>> 0 >= i4 >>> 0 | (i7 >>> 0 > i9 >>> 0 | (i7 | 0) == (i9 | 0) & i3 >>> 0 > i8 >>> 0)) {
     i6 = i7;
     i10 = 72;
     break;
    } else i5 = i7;
    while (1) {
     i3 = _bitshift64Shl(i3 | 0, i5 | 0, i10 | 0) | 0;
     i7 = getTempRet0() | 0;
     i3 = i6 & 255 | i3;
     i5 = HEAP32[i15 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = i5 + 1;
      i5 = HEAPU8[i5 >> 0] | 0;
     } else i5 = ___shgetc(i13) | 0;
     i6 = HEAP8[gb + 1056462 + 1 + i5 >> 0] | 0;
     if ((i6 & 255) >>> 0 >= i4 >>> 0 | (i7 >>> 0 > i9 >>> 0 | (i7 | 0) == (i9 | 0) & i3 >>> 0 > i8 >>> 0)) {
      i6 = i7;
      i10 = 72;
      break L63;
     } else i5 = i7;
    }
   }
   i6 = HEAP8[gb + 1056462 + 1 + i3 >> 0] | 0;
   i5 = i6 & 255;
   if (i5 >>> 0 < i4 >>> 0) {
    i3 = 0;
    i7 = i5;
    do {
     i3 = i7 + (Math_imul(i3, i4) | 0) | 0;
     i5 = HEAP32[i15 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = i5 + 1;
      i5 = HEAPU8[i5 >> 0] | 0;
     } else i5 = ___shgetc(i13) | 0;
     i6 = HEAP8[gb + 1056462 + 1 + i5 >> 0] | 0;
     i7 = i6 & 255;
    } while (i3 >>> 0 < 119304647 & i7 >>> 0 < i4 >>> 0);
    i7 = 0;
   } else {
    i5 = i3;
    i3 = 0;
    i7 = 0;
   }
   if ((i6 & 255) >>> 0 < i4 >>> 0) {
    i10 = ___udivdi3(-1, -1, i4 | 0, 0) | 0;
    i11 = getTempRet0() | 0;
    i9 = i7;
    while (1) {
     if (i9 >>> 0 > i11 >>> 0 | (i9 | 0) == (i11 | 0) & i3 >>> 0 > i10 >>> 0) {
      i6 = i9;
      i10 = 72;
      break L63;
     }
     i7 = ___muldi3(i3 | 0, i9 | 0, i4 | 0, 0) | 0;
     i8 = getTempRet0() | 0;
     i6 = i6 & 255;
     if (i8 >>> 0 > 4294967295 | (i8 | 0) == -1 & i7 >>> 0 > ~i6 >>> 0) {
      i6 = i9;
      i10 = 72;
      break L63;
     }
     i3 = _i64Add(i6 | 0, 0, i7 | 0, i8 | 0) | 0;
     i7 = getTempRet0() | 0;
     i5 = HEAP32[i15 >> 2] | 0;
     if (i5 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = i5 + 1;
      i5 = HEAPU8[i5 >> 0] | 0;
     } else i5 = ___shgetc(i13) | 0;
     i6 = HEAP8[gb + 1056462 + 1 + i5 >> 0] | 0;
     if ((i6 & 255) >>> 0 >= i4 >>> 0) {
      i6 = i7;
      i10 = 72;
      break;
     } else i9 = i7;
    }
   } else {
    i6 = i7;
    i10 = 72;
   }
  } while (0);
  if ((i10 | 0) == 72) if ((HEAPU8[gb + 1056462 + 1 + i5 >> 0] | 0) >>> 0 < i4 >>> 0) {
   do {
    i3 = HEAP32[i15 >> 2] | 0;
    if (i3 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
     HEAP32[i15 >> 2] = i3 + 1;
     i3 = HEAPU8[i3 >> 0] | 0;
    } else i3 = ___shgetc(i13) | 0;
   } while ((HEAPU8[gb + 1056462 + 1 + i3 >> 0] | 0) >>> 0 < i4 >>> 0);
   HEAP32[(___errno_location() | 0) >> 2] = 34;
   i5 = (i1 & 1 | 0) == 0 & 0 == 0 ? i12 : 0;
   i4 = i2;
   i3 = i1;
  } else {
   i5 = i12;
   i4 = i6;
  }
  if (HEAP32[i14 >> 2] | 0) HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(i4 >>> 0 < i2 >>> 0 | (i4 | 0) == (i2 | 0) & i3 >>> 0 < i1 >>> 0)) {
   if (!((i1 & 1 | 0) != 0 | 0 != 0 | (i5 | 0) != 0)) {
    HEAP32[(___errno_location() | 0) >> 2] = 34;
    i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
    i2 = getTempRet0() | 0;
    break;
   }
   if (i4 >>> 0 > i2 >>> 0 | (i4 | 0) == (i2 | 0) & i3 >>> 0 > i1 >>> 0) {
    HEAP32[(___errno_location() | 0) >> 2] = 34;
    break;
   }
  }
  i1 = ((i5 | 0) < 0) << 31 >> 31;
  i1 = _i64Subtract(i3 ^ i5 | 0, i4 ^ i1 | 0, i5 | 0, i1 | 0) | 0;
  i2 = getTempRet0() | 0;
 } while (0);
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function _cf2_blues_init(i24, i23) {
 i24 = i24 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i25 + 28 | 0;
 i11 = i25 + 24 | 0;
 i13 = i25 + 20 | 0;
 i15 = i25 + 16 | 0;
 i2 = i25 + 12 | 0;
 i12 = i25 + 8 | 0;
 i14 = i25 + 4 | 0;
 i20 = i25;
 i21 = HEAP32[i23 + 132 >> 2] | 0;
 _memset(i24 + 4 | 0, 0, 304) | 0;
 HEAP32[i24 >> 2] = HEAP32[i23 + 48 >> 2];
 i22 = i24 + 12 | 0;
 _cf2_getBlueMetrics(i21, i22, i24 + 16 | 0, i24 + 20 | 0);
 _cf2_getBlueValues(i21, i1, i2);
 _cf2_getOtherBlues(i21, i11, i12);
 _cf2_getFamilyBlues(i21, i13, i14);
 _cf2_getFamilyOtherBlues(i21, i15, i20);
 i21 = (_cf2_getLanguageGroup(i21) | 0) == 1;
 i1 = HEAP32[i1 >> 2] | 0;
 L1 : do if (i21) {
  switch (i1 | 0) {
  case 0:
   break;
  case 4:
   {
    i1 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i1 >> 2] & 65535) << 16 >> 16 >= -120) {
     i1 = 4;
     i3 = 3;
     break L1;
    }
    if ((HEAP32[i1 + 4 >> 2] & 65535) << 16 >> 16 >= -120) {
     i1 = 4;
     i3 = 3;
     break L1;
    }
    if ((HEAP32[i1 + 8 >> 2] & 65535) << 16 >> 16 <= 880) {
     i1 = 4;
     i3 = 3;
     break L1;
    }
    if ((HEAP32[i1 + 12 >> 2] & 65535) << 16 >> 16 <= 880) {
     i1 = 4;
     i3 = 3;
     break L1;
    }
    break;
   }
  default:
   {
    i3 = 3;
    break L1;
   }
  }
  HEAP32[i24 + 56 >> 2] = -7864321;
  HEAP32[i24 + 60 >> 2] = ((_UNITY_FT_MulFix(-7864321, HEAP32[i24 >> 2] | 0) | 0) + 32768 & -65536) + -32768;
  i22 = HEAP32[i24 >> 2] | 0;
  HEAP32[i24 + 64 >> 2] = i22;
  HEAP32[i24 + 48 >> 2] = 49;
  i23 = (HEAP32[i23 + 188 >> 2] << 1) + 57671681 | 0;
  HEAP32[i24 + 36 >> 2] = i23;
  HEAP32[i24 + 40 >> 2] = (_UNITY_FT_MulFix(i23, i22) | 0) + 32768 & -65536 | 32768;
  HEAP32[i24 + 44 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i24 + 28 >> 2] = 50;
  HEAP8[i24 + 9 >> 0] = 1;
  STACKTOP = i25;
  return;
 } else if (!i1) i2 = 0; else i3 = 3; while (0);
 if ((i3 | 0) == 3) {
  i8 = HEAP32[i2 >> 2] | 0;
  i9 = i24 + 4 | 0;
  i10 = i23 + 188 | 0;
  i2 = 0;
  i7 = 0;
  i3 = HEAP32[i9 >> 2] | 0;
  do {
   HEAP32[i24 + 68 + (i3 * 20 | 0) >> 2] = HEAP32[i8 + (i7 << 2) >> 2] << 16;
   HEAP32[i24 + 68 + ((HEAP32[i9 >> 2] | 0) * 20 | 0) + 4 >> 2] = HEAP32[i8 + ((i7 | 1) << 2) >> 2] << 16;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = i24 + 68 + (i3 * 20 | 0) + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5 - (HEAP32[i24 + 68 + (i3 * 20 | 0) >> 2] | 0) | 0;
   if ((i6 | 0) >= 0) {
    if (!i7) {
     HEAP8[i24 + 68 + (i3 * 20 | 0) + 16 >> 0] = 1;
     i21 = HEAP32[i9 >> 2] | 0;
     HEAP32[i24 + 68 + (i21 * 20 | 0) + 8 >> 2] = HEAP32[i24 + 68 + (i21 * 20 | 0) + 4 >> 2];
    } else {
     i19 = HEAP32[i10 >> 2] << 1;
     HEAP32[i4 >> 2] = i19 + i5;
     i21 = i24 + 68 + ((HEAP32[i9 >> 2] | 0) * 20 | 0) | 0;
     HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i19;
     HEAP8[i24 + 68 + ((HEAP32[i9 >> 2] | 0) * 20 | 0) + 16 >> 0] = 0;
     i21 = HEAP32[i9 >> 2] | 0;
     HEAP32[i24 + 68 + (i21 * 20 | 0) + 8 >> 2] = HEAP32[i24 + 68 + (i21 * 20 | 0) >> 2];
    }
    i3 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
    HEAP32[i9 >> 2] = i3;
    i2 = (i6 | 0) > (i2 | 0) ? i6 : i2;
   }
   i7 = i7 + 2 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 i6 = HEAP32[i11 >> 2] | 0;
 if (!i6) i7 = i24 + 4 | 0; else {
  i5 = HEAP32[i12 >> 2] | 0;
  i7 = i24 + 4 | 0;
  i4 = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i24 + 68 + (i1 * 20 | 0) >> 2] = HEAP32[i5 + (i4 << 2) >> 2] << 16;
   HEAP32[i24 + 68 + ((HEAP32[i7 >> 2] | 0) * 20 | 0) + 4 >> 2] = HEAP32[i5 + ((i4 | 1) << 2) >> 2] << 16;
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = (HEAP32[i24 + 68 + (i1 * 20 | 0) + 4 >> 2] | 0) - (HEAP32[i24 + 68 + (i1 * 20 | 0) >> 2] | 0) | 0;
   if ((i3 | 0) >= 0) {
    HEAP8[i24 + 68 + (i1 * 20 | 0) + 16 >> 0] = 1;
    i1 = HEAP32[i7 >> 2] | 0;
    HEAP32[i24 + 68 + (i1 * 20 | 0) + 8 >> 2] = HEAP32[i24 + 68 + (i1 * 20 | 0) + 4 >> 2];
    i1 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
    HEAP32[i7 >> 2] = i1;
    i2 = (i3 | 0) > (i2 | 0) ? i3 : i2;
   }
   i4 = i4 + 2 | 0;
  } while (i4 >>> 0 < i6 >>> 0);
 }
 i21 = _UNITY_FT_DivFix(65536, HEAP32[i24 >> 2] | 0) | 0;
 L32 : do if (HEAP32[i7 >> 2] | 0) {
  i18 = HEAP32[i13 >> 2] | 0;
  i19 = i18 >>> 0 > 2;
  i16 = HEAP32[i14 >> 2] | 0;
  i17 = i23 + 188 | 0;
  i13 = HEAP32[i15 >> 2] | 0;
  i14 = (i13 | 0) != 0;
  i11 = i16 + 4 | 0;
  i12 = HEAP32[i20 >> 2] | 0;
  if (i18 >>> 0 > 1) i8 = 0; else {
   i8 = 0;
   while (1) {
    i9 = i24 + 68 + (i8 * 20 | 0) + 8 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    L37 : do if (!(HEAP8[i24 + 68 + (i8 * 20 | 0) + 16 >> 0] | 0)) {
     if (i19) {
      i6 = HEAP32[i17 >> 2] << 1;
      i5 = 2;
      i1 = 2147483647;
      do {
       i3 = i6 + (HEAP32[i16 + (i5 << 2) >> 2] << 16) | 0;
       i4 = i10 - i3 | 0;
       i4 = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
       if ((i4 | 0) < (i1 | 0) & (i4 | 0) < (i21 | 0)) {
        HEAP32[i9 >> 2] = i3;
        if (!i4) break L37; else i1 = i4;
       }
       i5 = i5 + 2 | 0;
      } while (i5 >>> 0 < i18 >>> 0);
     }
    } else if (i14) {
     i5 = 0;
     i1 = 2147483647;
     do {
      i3 = HEAP32[i12 + ((i5 | 1) << 2) >> 2] << 16;
      i4 = i10 - i3 | 0;
      i4 = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
      if ((i4 | 0) < (i1 | 0) & (i4 | 0) < (i21 | 0)) {
       HEAP32[i9 >> 2] = i3;
       if (!i4) break L37; else i1 = i4;
      }
      i5 = i5 + 2 | 0;
     } while (i5 >>> 0 < i13 >>> 0);
    } while (0);
    i8 = i8 + 1 | 0;
    if (i8 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break L32;
   }
  }
  do {
   i9 = i24 + 68 + (i8 * 20 | 0) + 8 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   L54 : do if (!(HEAP8[i24 + 68 + (i8 * 20 | 0) + 16 >> 0] | 0)) {
    if (i19) {
     i6 = HEAP32[i17 >> 2] << 1;
     i5 = 2;
     i1 = 2147483647;
     do {
      i3 = i6 + (HEAP32[i16 + (i5 << 2) >> 2] << 16) | 0;
      i4 = i10 - i3 | 0;
      i4 = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
      if ((i4 | 0) < (i1 | 0) & (i4 | 0) < (i21 | 0)) {
       HEAP32[i9 >> 2] = i3;
       if (!i4) break L54; else i1 = i4;
      }
      i5 = i5 + 2 | 0;
     } while (i5 >>> 0 < i18 >>> 0);
    }
   } else {
    L63 : do if (i14) {
     i5 = 0;
     i1 = 2147483647;
     do {
      i3 = HEAP32[i12 + ((i5 | 1) << 2) >> 2] << 16;
      i4 = i10 - i3 | 0;
      i4 = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
      if ((i4 | 0) < (i1 | 0) & (i4 | 0) < (i21 | 0)) {
       HEAP32[i9 >> 2] = i3;
       if (!i4) {
        i1 = 0;
        break L63;
       } else i1 = i4;
      }
      i5 = i5 + 2 | 0;
     } while (i5 >>> 0 < i13 >>> 0);
    } else i1 = 2147483647; while (0);
    i3 = HEAP32[i11 >> 2] << 16;
    i20 = i10 - i3 | 0;
    i20 = (i20 | 0) < 0 ? 0 - i20 | 0 : i20;
    if ((i20 | 0) < (i1 | 0) & (i20 | 0) < (i21 | 0)) HEAP32[i9 >> 2] = i3;
   } while (0);
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if ((i2 | 0) > 0) {
  i21 = HEAP32[i22 >> 2] | 0;
  if ((i21 | 0) > (_UNITY_FT_DivFix(65536, i2) | 0)) HEAP32[i22 >> 2] = _UNITY_FT_DivFix(65536, i2) | 0;
 }
 i2 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i2 | 0) < (i1 | 0)) {
  HEAP8[i24 + 8 >> 0] = 1;
  i22 = 39322 - (_UNITY_FT_MulDiv(39322, i2, i1) | 0) | 0;
  HEAP32[i24 + 24 >> 2] = (i22 | 0) > 32767 ? 32767 : i22;
 }
 if (HEAP8[i23 + 142 >> 0] | 0) HEAP32[i24 + 24 >> 2] = 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i25;
  return;
 }
 i2 = i24 + 24 | 0;
 i1 = 0;
 do {
  i22 = (HEAP8[i24 + 68 + (i1 * 20 | 0) + 16 >> 0] | 0) == 0;
  i21 = _UNITY_FT_MulFix(HEAP32[i24 + 68 + (i1 * 20 | 0) + 8 >> 2] | 0, HEAP32[i24 >> 2] | 0) | 0;
  i23 = HEAP32[i2 >> 2] | 0;
  HEAP32[i24 + 68 + (i1 * 20 | 0) + 12 >> 2] = i21 + 32768 + (i22 ? i23 : 0 - i23 | 0) & -65536;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 STACKTOP = i25;
 return;
}

function __ZN22BaseUnityConnectClient19OnEnterStateStartedEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 112 | 0;
 i15 = i20 + 64 | 0;
 i14 = i20;
 i12 = i20 + 96 | 0;
 HEAP32[i16 + 4 >> 2] = 3;
 i19 = i16 + 108 | 0;
 i2 = i16 + 64 | 0;
 if (!(HEAP8[i19 >> 0] | 0)) {
  i13 = i2;
  i1 = i16 + 384 | 0;
  i17 = i1;
  if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i17 >> 2] | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (HEAP32[i17 + 4 >> 2] | 0) : 0) {
   i17 = i16 + 280 | 0;
   i1 = 0;
  } else i3 = 5;
 } else {
  i1 = i16 + 384 | 0;
  i3 = 5;
 }
 if ((i3 | 0) == 5) {
  i17 = i16 + 280 | 0;
  __ZN19CloudServiceHandler22ResetNetworkRetryIndexEv(HEAP32[i17 >> 2] | 0);
  i11 = i2;
  i13 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  i1 = 1;
 }
 HEAP8[i16 + 408 >> 0] = HEAP8[(__Z16GetBuildSettingsv() | 0) + 119 >> 0] | 0;
 HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZN11UnityEngine7Connect18ConnectSessionInfo12ToJsonStringER8UnityStr(i16 + 352 | 0, i15);
 __ZN19CloudServiceHandler17StartEventHandlerERK8UnityStrii(HEAP32[i17 >> 2] | 0, i15, HEAP32[i16 + 632 >> 2] | 0, HEAP32[i16 + 644 >> 2] | 0) | 0;
 if ((HEAP8[i15 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  i11 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i18);
 }
 __ZN22BaseUnityConnectClient20StartEventDispatcherEv(i16) | 0;
 i11 = i16 + 660 | 0;
 i13 = (HEAP8[(HEAP32[i11 >> 2] | 0) + 56 >> 0] | 0) != 0;
 if (i1) {
  __ZN11UnityEngine7Connect13AppStartEventC2Ev(i15);
  i9 = i16 + 12 | 0;
  i10 = i16 + 8 | 0;
  __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i16, i15, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 1) | 0;
  if (!i13) {
   __ZN11UnityEngine7Connect15AppInstallEventC2Ev(i14);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 + 12 >> 2] = i1;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i18 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = -2147483632;
   i5 = i12 + 4 | 0;
   HEAP32[i5 >> 2] = 13;
   i2 = i1;
   i3 = gb + 1040146 | 0;
   i4 = i2 + 13 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i1 + 13 >> 0] = 0;
   i4 = i14 + 32 | 0;
   i7 = i12 + 11 | 0;
   i6 = HEAP8[i7 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i8 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
   i5 = i1 ? HEAP32[i5 >> 2] | 0 : i6 & 255;
   i6 = i4 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i14 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   do if (i5 >>> 0 > i3 >>> 0) {
    i6 = i2 ? HEAP32[i14 + 36 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i3, i5 - i3 | 0, i6, 0, i6, i5, i8);
   } else {
    i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
    if (i5 | 0) _memmove(i1 | 0, i8 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i14 + 36 >> 2] = i5;
     break;
    } else {
     HEAP8[i6 >> 0] = i5;
     break;
    }
   } while (0);
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    i8 = HEAP32[i12 >> 2] | 0;
    i7 = HEAP32[i12 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i18 + 4 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i18);
   }
   __ZN15ApplicationInfo10GetVersionEv(i12, __Z18GetApplicationInfov() | 0);
   i1 = i14 + 48 | 0;
   i5 = i12 + 11 | 0;
   i7 = HEAP8[i5 >> 0] | 0;
   i8 = i7 << 24 >> 24 < 0;
   i6 = i8 ? HEAP32[i12 >> 2] | 0 : i12;
   i7 = i8 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
   i8 = i1 + 11 | 0;
   i2 = HEAP8[i8 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i4 = (HEAP32[i14 + 56 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   do if (i7 >>> 0 > i4 >>> 0) {
    i8 = i3 ? HEAP32[i14 + 52 >> 2] | 0 : i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i7 - i4 | 0, i8, 0, i8, i7, i6);
   } else {
    i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i8 >> 0] | 0) < 0) {
     HEAP32[i14 + 52 >> 2] = i7;
     break;
    } else {
     HEAP8[i8 >> 0] = i7;
     break;
    }
   } while (0);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i8 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 12 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i18 + 4 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i18);
   }
   __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i16, i14, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 1) | 0;
   HEAP8[(HEAP32[i11 >> 2] | 0) + 56 >> 0] = 1;
   HEAP32[i14 >> 2] = gb + 188916 + 8;
   i1 = i14 + 48 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i14 + 60 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i18 + 4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i18);
   }
   i1 = i14 + 32 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i14 + 44 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i18 + 4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i18);
   }
   HEAP32[i14 >> 2] = gb + 190148 + 8;
   i1 = i14 + 4 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i1 >> 2] | 0;
    i14 = HEAP32[i14 + 16 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i18 + 4 >> 2] = i14;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i18);
   }
  }
  HEAP32[i15 >> 2] = gb + 190148 + 8;
  i1 = i15 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i14 = HEAP32[i1 >> 2] | 0;
   i15 = HEAP32[i15 + 16 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i18 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i14, i18);
  }
 }
 __ZN22BaseUnityConnectClient20LookForVersionChangeEb(i16, i13);
 __ZN22BaseUnityConnectClient17SaveSessionValuesEv(i16);
 i8 = i16 + 668 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i16 + 664 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  i5 = i18 + 4 | 0;
  i6 = i18 + 4 | 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   __ZN19CloudServiceHandler10QueueEventEPN11UnityEngine15CloudWebService14CloudEventInfoE(HEAP32[i17 >> 2] | 0, i3) | 0;
   i16 = i3 + 44 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   if (!(HEAP32[i16 >> 2] | 0)) {
    i4 = i3 + 16 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i16 = HEAP32[i4 >> 2] | 0;
     i15 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i5 >> 2] = i15;
     __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i16 = HEAP32[i3 >> 2] | 0;
     i15 = HEAP32[i3 + 12 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i6 >> 2] = i15;
     __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63800 | 0);
   }
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if ((i2 | 0) == (i1 | 0)) {
  HEAP8[i19 >> 0] = 0;
  STACKTOP = i20;
  return;
 }
 HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 HEAP8[i19 >> 0] = 0;
 STACKTOP = i20;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRK6b2PairS3_EPS1_EEbT0_S8_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 switch (i7 - i8 >> 3 | 0) {
 case 2:
  {
   i1 = i7 + -8 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i8 | 0) | 0)) {
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i7 = i8;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i4 = i1;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = i8;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = i5;
   i9 = i1;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i7;
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 3:
  {
   i5 = i8 + 8 | 0;
   i1 = i7 + -8 | 0;
   i7 = mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i8 | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i5 | 0) | 0;
   if (!i7) {
    if (!i2) {
     i9 = 1;
     STACKTOP = i10;
     return i9 | 0;
    }
    i6 = i5;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i2 = i1;
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    i7 = i5;
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i7 + 4 >> 2] = i3;
    i7 = i1;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i7 + 4 >> 2] = i6;
    if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i8 | 0) | 0)) {
     i9 = 1;
     STACKTOP = i10;
     return i9 | 0;
    }
    i7 = i8;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    i3 = i5;
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    i9 = i8;
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i9 + 4 >> 2] = i4;
    i9 = i5;
    HEAP32[i9 >> 2] = i6;
    HEAP32[i9 + 4 >> 2] = i7;
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i4 = i8;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (i2) {
    i6 = i1;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i9 = i8;
    HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i9 + 4 >> 2] = i7;
    i9 = i1;
    HEAP32[i9 >> 2] = i3;
    HEAP32[i9 + 4 >> 2] = i4;
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i6 = i5;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = i7;
   i8 = i5;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = i4;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i5 | 0) | 0)) {
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i8 = i5;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i4 = i1;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = i6;
   i9 = i1;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i9 + 4 >> 2] = i8;
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i7 + -8 | 0, i9) | 0;
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 5:
  {
   i2 = i8 + 8 | 0;
   i3 = i8 + 16 | 0;
   i4 = i8 + 24 | 0;
   i1 = i7 + -8 | 0;
   __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i8, i2, i3, i4, i9) | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i4 | 0) | 0)) {
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i6 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i12 = i1;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i7 = i4;
   HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i7 + 4 >> 2] = i11;
   i7 = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
    i12 = 1;
    STACKTOP = i10;
    return i12 | 0;
   }
   i11 = i3;
   i7 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i5 = i4;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i12 = i3;
   HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i12 + 4 >> 2] = i6;
   i12 = i4;
   HEAP32[i12 >> 2] = i7;
   HEAP32[i12 + 4 >> 2] = i11;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
    i12 = 1;
    STACKTOP = i10;
    return i12 | 0;
   }
   i11 = i2;
   i7 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i12 + 4 >> 2] = i6;
   i12 = i3;
   HEAP32[i12 >> 2] = i7;
   HEAP32[i12 + 4 >> 2] = i11;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i2 | 0, i8 | 0) | 0)) {
    i12 = 1;
    STACKTOP = i10;
    return i12 | 0;
   }
   i11 = i8;
   i9 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i6 = i2;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i12 = i8;
   HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i12 + 4 >> 2] = i7;
   i12 = i2;
   HEAP32[i12 >> 2] = i9;
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = 1;
   STACKTOP = i10;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   STACKTOP = i10;
   return i12 | 0;
  }
 default:
  {
   i3 = i8 + 16 | 0;
   i1 = i8 + 8 | 0;
   i12 = mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i8 | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i1 | 0) | 0;
   do if (i12) {
    i5 = i8;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if (i2) {
     i2 = i3;
     i11 = HEAP32[i2 + 4 >> 2] | 0;
     i12 = i8;
     HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     i12 = i3;
     HEAP32[i12 >> 2] = i4;
     HEAP32[i12 + 4 >> 2] = i5;
     break;
    }
    i2 = i1;
    i11 = HEAP32[i2 + 4 >> 2] | 0;
    i12 = i8;
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i1;
    HEAP32[i12 >> 2] = i4;
    HEAP32[i12 + 4 >> 2] = i5;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i1 | 0) | 0) {
     i11 = i1;
     i5 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     i2 = i3;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     i12 = i1;
     HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i12 + 4 >> 2] = i4;
     i12 = i3;
     HEAP32[i12 >> 2] = i5;
     HEAP32[i12 + 4 >> 2] = i11;
    }
   } else if (i2) {
    i11 = i1;
    i5 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i2 = i3;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    i12 = i1;
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = i4;
    i12 = i3;
    HEAP32[i12 >> 2] = i5;
    HEAP32[i12 + 4 >> 2] = i11;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i8 | 0) | 0) {
     i11 = i8;
     i5 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     i2 = i1;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     i12 = i8;
     HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i12 + 4 >> 2] = i4;
     i12 = i1;
     HEAP32[i12 >> 2] = i5;
     HEAP32[i12 + 4 >> 2] = i11;
    }
   } while (0);
   i1 = i8 + 24 | 0;
   L13 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      i11 = i1;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i4 = i6;
      HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i4 + 4 >> 2] = i12;
      i4 = i1;
      while (1) {
       i5 = i3;
       i11 = HEAP32[i5 + 4 >> 2] | 0;
       i12 = i4;
       HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i12 + 4 >> 2] = i11;
       if ((i3 | 0) == (i8 | 0)) break;
       i4 = i3 + -8 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, i4 | 0) | 0) {
        i12 = i3;
        i3 = i4;
        i4 = i12;
       } else break;
      }
      i5 = i6;
      i11 = HEAP32[i5 + 4 >> 2] | 0;
      i12 = i3;
      HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i7 | 0);
       break L13;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i12 = i1;
      i1 = i3;
      i3 = i12;
     }
    }
   } while (0);
   i12 = i1 | i2;
   STACKTOP = i10;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_(i20, i19, i2, i21, i1) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f22 = f0;
 i17 = HEAP32[i1 >> 2] | 0;
 i18 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f15 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + 36 >> 2]);
 f13 = Math_fround(HEAPF32[i21 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f14 * f7) + Math_fround(f15 * f22)) + Math_fround(f16 * f5));
 f4 = Math_fround(Math_fround(Math_fround(f8 * f7) + Math_fround(f9 * f22)) + Math_fround(f10 * f5));
 f5 = Math_fround(Math_fround(Math_fround(f11 * f7) + Math_fround(f12 * f22)) + Math_fround(f13 * f5));
 f22 = Math_fround(Math_abs(Math_fround(f3)));
 f7 = Math_fround(Math_abs(Math_fround(f4)));
 f6 = Math_fround(Math_abs(Math_fround(f5)));
 if (!(!(f22 >= f7) | !(f22 >= f6))) {
  i2 = f3 > Math_fround(0.0);
  f4 = Math_fround(-f14);
  f3 = Math_fround(-f15);
  f5 = Math_fround(-f16);
  HEAPF32[i19 >> 2] = i2 ? f4 : f14;
  HEAPF32[i19 + 4 >> 2] = i2 ? f3 : f15;
  HEAPF32[i19 + 8 >> 2] = i2 ? f5 : f16;
  HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
  f5 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(-f5);
  f5 = i2 ? f3 : f5;
  f3 = Math_fround(f14 * f5);
  f4 = Math_fround(f15 * f5);
  f5 = Math_fround(f16 * f5);
  f22 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(f22 * f8);
  f7 = Math_fround(f22 * f9);
  f8 = Math_fround(f22 * f10);
  f22 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f22 * f11);
  f16 = Math_fround(f22 * f12);
  f22 = Math_fround(f22 * f13);
  f14 = Math_fround(HEAPF32[i21 + 48 >> 2]);
  f12 = Math_fround(HEAPF32[i21 + 52 >> 2]);
  f14 = Math_fround(f3 + f14);
  f12 = Math_fround(f4 + f12);
  f13 = Math_fround(f5 + Math_fround(HEAPF32[i21 + 56 >> 2]));
  f9 = Math_fround(f6 + f15);
  f10 = Math_fround(f7 + f16);
  f11 = Math_fround(f8 + f22);
  f15 = Math_fround(f6 - f15);
  f16 = Math_fround(f7 - f16);
  f22 = Math_fround(f8 - f22);
  f8 = Math_fround(f10 + f12);
  f7 = Math_fround(f11 + f13);
  HEAPF32[i20 >> 2] = Math_fround(f9 + f14);
  HEAPF32[i20 + 4 >> 2] = f8;
  HEAPF32[i20 + 8 >> 2] = f7;
  HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
  f7 = Math_fround(f16 + f12);
  f8 = Math_fround(f22 + f13);
  HEAPF32[i20 + 16 >> 2] = Math_fround(f15 + f14);
  HEAPF32[i20 + 20 >> 2] = f7;
  HEAPF32[i20 + 24 >> 2] = f8;
  HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
  f10 = Math_fround(f12 - f10);
  f11 = Math_fround(f13 - f11);
  HEAPF32[i20 + 32 >> 2] = Math_fround(f14 - f9);
  HEAPF32[i20 + 36 >> 2] = f10;
  HEAPF32[i20 + 40 >> 2] = f11;
  HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
  f16 = Math_fround(f12 - f16);
  f22 = Math_fround(f13 - f22);
  HEAPF32[i20 + 48 >> 2] = Math_fround(f14 - f15);
  HEAPF32[i20 + 52 >> 2] = f16;
  HEAPF32[i20 + 56 >> 2] = f22;
  HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
  return;
 }
 if (!(f7 >= f6)) {
  i2 = f5 > Math_fround(0.0);
  f5 = Math_fround(-f11);
  f7 = Math_fround(-f12);
  f4 = Math_fround(-f13);
  HEAPF32[i19 >> 2] = i2 ? f5 : f11;
  HEAPF32[i19 + 4 >> 2] = i2 ? f7 : f12;
  HEAPF32[i19 + 8 >> 2] = i2 ? f4 : f13;
  HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
  f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(-f4);
  f4 = i2 ? f7 : f4;
  f7 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f7 * f14);
  f6 = Math_fround(f7 * f15);
  f7 = Math_fround(f7 * f16);
  f22 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f22 * f8);
  f16 = Math_fround(f22 * f9);
  f22 = Math_fround(f22 * f10);
  f10 = Math_fround(f11 * f4);
  f9 = Math_fround(f12 * f4);
  f13 = Math_fround(f13 * f4);
  f14 = Math_fround(HEAPF32[i21 + 48 >> 2]);
  f12 = Math_fround(HEAPF32[i21 + 52 >> 2]);
  f14 = Math_fround(f10 + f14);
  f12 = Math_fround(f9 + f12);
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i21 + 56 >> 2]));
  f9 = Math_fround(f5 + f15);
  f10 = Math_fround(f6 + f16);
  f11 = Math_fround(f7 + f22);
  f15 = Math_fround(f5 - f15);
  f16 = Math_fround(f6 - f16);
  f22 = Math_fround(f7 - f22);
  f8 = Math_fround(f10 + f12);
  f7 = Math_fround(f11 + f13);
  HEAPF32[i20 >> 2] = Math_fround(f9 + f14);
  HEAPF32[i20 + 4 >> 2] = f8;
  HEAPF32[i20 + 8 >> 2] = f7;
  HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
  f7 = Math_fround(f16 + f12);
  f8 = Math_fround(f22 + f13);
  HEAPF32[i20 + 16 >> 2] = Math_fround(f15 + f14);
  HEAPF32[i20 + 20 >> 2] = f7;
  HEAPF32[i20 + 24 >> 2] = f8;
  HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
  f10 = Math_fround(f12 - f10);
  f11 = Math_fround(f13 - f11);
  HEAPF32[i20 + 32 >> 2] = Math_fround(f14 - f9);
  HEAPF32[i20 + 36 >> 2] = f10;
  HEAPF32[i20 + 40 >> 2] = f11;
  HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
  f16 = Math_fround(f12 - f16);
  f22 = Math_fround(f13 - f22);
  HEAPF32[i20 + 48 >> 2] = Math_fround(f14 - f15);
  HEAPF32[i20 + 52 >> 2] = f16;
  HEAPF32[i20 + 56 >> 2] = f22;
  HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
  return;
 } else {
  i2 = f4 > Math_fround(0.0);
  f5 = Math_fround(-f8);
  f7 = Math_fround(-f9);
  f22 = Math_fround(-f10);
  HEAPF32[i19 >> 2] = i2 ? f5 : f8;
  HEAPF32[i19 + 4 >> 2] = i2 ? f7 : f9;
  HEAPF32[i19 + 8 >> 2] = i2 ? f22 : f10;
  HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
  f22 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(-f22);
  f22 = i2 ? f7 : f22;
  f7 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(f7 * f14);
  f6 = Math_fround(f7 * f15);
  f7 = Math_fround(f7 * f16);
  f4 = Math_fround(f8 * f22);
  f8 = Math_fround(f9 * f22);
  f9 = Math_fround(f10 * f22);
  f22 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f22 * f11);
  f16 = Math_fround(f22 * f12);
  f22 = Math_fround(f22 * f13);
  f14 = Math_fround(HEAPF32[i21 + 48 >> 2]);
  f12 = Math_fround(HEAPF32[i21 + 52 >> 2]);
  f14 = Math_fround(f4 + f14);
  f12 = Math_fround(f8 + f12);
  f13 = Math_fround(f9 + Math_fround(HEAPF32[i21 + 56 >> 2]));
  f9 = Math_fround(f5 + f15);
  f10 = Math_fround(f6 + f16);
  f11 = Math_fround(f7 + f22);
  f15 = Math_fround(f5 - f15);
  f16 = Math_fround(f6 - f16);
  f22 = Math_fround(f7 - f22);
  f8 = Math_fround(f10 + f12);
  f7 = Math_fround(f11 + f13);
  HEAPF32[i20 >> 2] = Math_fround(f9 + f14);
  HEAPF32[i20 + 4 >> 2] = f8;
  HEAPF32[i20 + 8 >> 2] = f7;
  HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
  f7 = Math_fround(f16 + f12);
  f8 = Math_fround(f22 + f13);
  HEAPF32[i20 + 16 >> 2] = Math_fround(f15 + f14);
  HEAPF32[i20 + 20 >> 2] = f7;
  HEAPF32[i20 + 24 >> 2] = f8;
  HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
  f10 = Math_fround(f12 - f10);
  f11 = Math_fround(f13 - f11);
  HEAPF32[i20 + 32 >> 2] = Math_fround(f14 - f9);
  HEAPF32[i20 + 36 >> 2] = f10;
  HEAPF32[i20 + 40 >> 2] = f11;
  HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
  f16 = Math_fround(f12 - f16);
  f22 = Math_fround(f13 - f22);
  HEAPF32[i20 + 48 >> 2] = Math_fround(f14 - f15);
  HEAPF32[i20 + 52 >> 2] = f16;
  HEAPF32[i20 + 56 >> 2] = f22;
  HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
  return;
 }
}

function __ZN4Mesh10CreateMeshEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i25 + 32 | 0;
 i13 = i25;
 i16 = i25 + 124 | 0;
 if ((HEAP16[gb + 1161424 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = i22;
  HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161424 | 0, i8);
  i23 = gb + 1161424 | 0;
 } else i23 = 0;
 i24 = __Z20push_allocation_rootPvP13BaseAllocatorb(i22, 0, 0) | 0;
 i20 = i22 + 44 | 0;
 i17 = HEAP8[i20 >> 0] | 0;
 i21 = (i17 & 255) >>> 2 & 1;
 i17 = (i17 & 255) >>> 3 & 1;
 i15 = i22 + 32 | 0;
 i18 = HEAP32[i15 >> 2] | 0;
 i19 = i18 + 4 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 i19 = __Z21GetUncheckedGfxDevicev() | 0;
 i1 = HEAP8[i20 >> 0] | 0;
 if (i1 & 1) {
  i1 = i8;
  i3 = i1 + 92 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i4 = HEAP32[i15 >> 2] | 0;
  i1 = i4 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  i1 = i8 + 32 | 0;
  i2 = i4 + 40 | 0;
  i3 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i6 = i8 + 80 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 + 92 >> 2];
  HEAP32[i8 + 84 >> 2] = HEAP32[i4 + 104 >> 2];
  i7 = i8 + 88 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 + 100 >> 2];
  i1 = i22 + 192 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i12 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 236 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i22 + 196 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i12 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 236 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i22 + 200 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i12 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 236 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i3 = i22 + 36 | 0;
  i2 = 0;
  do {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i7 >> 2] | 0) > 0 ? (HEAP32[i8 + 32 + (i2 * 12 | 0) >> 2] | 0) != 0 : 0) {
    i5 = i4 + 12 + (i2 << 3) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (!i1) i14 = 17; else if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
     i1 = HEAP32[i5 >> 2] | 0;
     if (!i1) i14 = 17; else {
      mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 236 >> 2] | 0, i19 | 0, i1 | 0);
      HEAP32[i5 >> 2] = 0;
      i14 = 17;
     }
    }
    if ((i14 | 0) == 17) {
     i14 = 0;
     HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 220 >> 2] | 0, i19 | 0) | 0;
    }
    i12 = i8 + 32 + (i2 * 12 | 0) + 10 | 0;
    i10 = Math_imul(HEAPU8[i12 >> 0] | 0, HEAP32[i7 >> 2] | 0) | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 224 >> 2] | 0, i19 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 12 + (i2 << 3) >> 2] | 0, i21 | 0, i17 | 0, i10 | 0, (HEAP32[i6 >> 2] | 0) + (HEAP32[i8 + 32 + (i2 * 12 | 0) + 4 >> 2] | 0) | 0, 1);
    i10 = HEAP32[(HEAP32[i19 >> 2] | 0) + 688 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i3 >> 2] | 0) + 12 + (i2 << 3) >> 2] | 0;
    mftCall_viii(i10 | 0, i19 | 0, i11 | 0, mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0);
    HEAP32[i4 + 12 + (i2 << 3) + 4 >> 2] = HEAPU8[i12 >> 0];
   } else __ZN23SharedMeshRenderingData18UnloadVertexStreamEi(i4, i2);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i12 = __Z26GetMeshVertexFormatManagerv() | 0;
  __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo(i13, i8);
  HEAP32[i1 + 44 >> 2] = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i12, i13) | 0;
  i1 = HEAP8[i20 >> 0] | 0;
 }
 do if (i1 & 2) {
  i11 = HEAP32[i15 >> 2] | 0;
  i12 = i22 + 36 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if (((HEAP32[i11 + 116 >> 2] | 0) - (HEAP32[i11 + 112 >> 2] | 0) | 0) >>> 0 <= 1) {
   __ZN23SharedMeshRenderingData17UnloadIndexBufferEv(i1);
   break;
  }
  if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN23SharedMeshRenderingData17CreateIndexBufferEv(i1);
  i11 = gb + 64016 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i13;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i16 >> 2] = 0;
  i9 = i16 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i16 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i16 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i13);
  i4 = i8;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i11;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  i5 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i5 + 112 >> 2] | 0;
  i4 = HEAP32[i5 + 116 >> 2] | 0;
  i1 = (i3 | 0) == (i4 | 0) ? 0 : i3;
  i3 = (i4 - i3 | 0) >>> 1;
  i4 = HEAP32[i5 + 132 >> 2] | 0;
  i5 = HEAP32[i5 + 128 >> 2] | 0;
  i6 = (i4 | 0) == (i5 | 0);
  i8 = i5;
  L38 : do if (i6) i2 = 1; else {
   i7 = (i4 - i5 | 0) / 52 | 0;
   i2 = 0;
   while (1) {
    if ((HEAP32[i8 + (i2 * 52 | 0) + 40 >> 2] | 0) == 2) break;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i7 >>> 0) {
     i14 = 29;
     break;
    }
   }
   L43 : do if ((i14 | 0) == 29) {
    if (i6) {
     i2 = 1;
     break L38;
    }
    i4 = (i4 - i5 | 0) / 52 | 0;
    i2 = 0;
    while (1) {
     if ((HEAP32[i8 + (i2 * 52 | 0) + 40 >> 2] | 0) == 1) break L43;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i4 >>> 0) {
      i2 = 1;
      break L38;
     }
    }
   } while (0);
   HEAP32[i9 >> 2] = i3;
   if (!i3) {
    i2 = 0;
    i4 = i16;
    i3 = 0;
   } else {
    HEAP32[i10 >> 2] = i3;
    i2 = i3 << 1;
    i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2, 2, i11, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i16 >> 2] = i3;
    i4 = i16;
   }
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   __Z27ConvertSubMeshesToTrianglesRNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEER13dynamic_arrayItLj2EE((HEAP32[i15 >> 2] | 0) + 128 | 0, i16);
   i3 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = 0;
  } while (0);
  mftCall_viiiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 224 >> 2] | 0, i19 | 0, HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i21 | 0, i17 | 0, i3 << 1 | 0, i1 | 0, i2 | 0);
  i17 = HEAP32[(HEAP32[i19 >> 2] | 0) + 688 >> 2] | 0;
  i21 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
  mftCall_viii(i17 | 0, i19 | 0, i21 | 0, mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 36 >> 2] | 0, i22 | 0) | 0);
  if ((HEAP32[i10 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i11);
   HEAP32[i16 >> 2] = 0;
  }
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 288 >> 2] | 0, i19 | 0, i18 | 0);
 HEAP8[i20 >> 0] = HEAP8[i20 >> 0] & -4;
 i1 = i22 + 192 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i21 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 236 >> 2] | 0, i21 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 196 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i21 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 236 >> 2] | 0, i21 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i22 + 200 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i22 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 236 >> 2] | 0, i22 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if (i24) __Z19pop_allocation_rootv();
 if (!i23) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i23);
 STACKTOP = i25;
 return;
}

function __ZN20b2SeparationFunction10InitializeEPK14b2SimplexCachePK15b2DistanceProxyRK7b2SweepS5_S8_f(i27, i18, i16, i1, i17, i6, f2) {
 i27 = i27 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f28 = f0, f29 = f0;
 HEAP32[i27 >> 2] = i16;
 HEAP32[i27 + 4 >> 2] = i17;
 i11 = HEAP16[i18 + 4 >> 1] | 0;
 i8 = i27 + 8 | 0;
 i7 = i8;
 i4 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i4 | 0));
 i9 = i27 + 44 | 0;
 i7 = i9;
 i1 = i6;
 i4 = i7 + 36 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i4 | 0));
 f23 = Math_fround(Math_fround(1.0) - f2);
 f26 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 16 >> 2]));
 f14 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 20 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) * f2);
 f13 = Math_fround(f26 + f13);
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i27 + 28 >> 2]) * f2));
 f26 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 32 >> 2]));
 f26 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i27 + 36 >> 2]) * f2));
 f25 = Math_fround(+Math_sin(+f26));
 f26 = Math_fround(+Math_cos(+f26));
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f21 = Math_fround(f26 * f22);
 f24 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f21 = Math_fround(f13 - Math_fround(f21 - Math_fround(f25 * f24)));
 f24 = Math_fround(f14 - Math_fround(Math_fround(f25 * f22) + Math_fround(f26 * f24)));
 f22 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 52 >> 2]));
 f14 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 56 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i27 + 60 >> 2]) * f2);
 f13 = Math_fround(f22 + f13);
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i27 + 64 >> 2]) * f2));
 f23 = Math_fround(f23 * Math_fround(HEAPF32[i27 + 68 >> 2]));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i27 + 72 >> 2]) * f2));
 f22 = Math_fround(+Math_sin(+f23));
 f23 = Math_fround(+Math_cos(+f23));
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(f23 * f15);
 f20 = Math_fround(HEAPF32[i27 + 48 >> 2]);
 f19 = Math_fround(f13 - Math_fround(f19 - Math_fround(f22 * f20)));
 f20 = Math_fround(f14 - Math_fround(Math_fround(f22 * f15) + Math_fround(f23 * f20)));
 if (i11 << 16 >> 16 == 1) {
  HEAP32[i27 + 80 >> 2] = 0;
  i4 = HEAPU8[i18 + 6 >> 0] | 0;
  i1 = HEAP32[i16 + 16 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i1 + (i4 << 3) >> 2]);
  f3 = Math_fround(HEAPF32[i1 + (i4 << 3) + 4 >> 2]);
  i4 = HEAPU8[i18 + 9 >> 0] | 0;
  i1 = HEAP32[i17 + 16 >> 2] | 0;
  f14 = Math_fround(HEAPF32[i1 + (i4 << 3) >> 2]);
  f15 = Math_fround(HEAPF32[i1 + (i4 << 3) + 4 >> 2]);
  f5 = Math_fround(Math_fround(f19 + Math_fround(Math_fround(f23 * f14) - Math_fround(f22 * f15))) - Math_fround(f21 + Math_fround(Math_fround(f26 * f2) - Math_fround(f25 * f3))));
  f3 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(f22 * f14) + Math_fround(f23 * f15))) - Math_fround(f24 + Math_fround(Math_fround(f25 * f2) + Math_fround(f26 * f3))));
  i4 = i27 + 92 | 0;
  HEAPF32[i4 >> 2] = f5;
  i1 = i27 + 96 | 0;
  HEAPF32[i1 >> 2] = f3;
  f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))));
  if (f2 < Math_fround(1.1920929e-07)) {
   f26 = Math_fround(0.0);
   return Math_fround(f26);
  }
  f26 = Math_fround(Math_fround(1.0) / f2);
  HEAPF32[i4 >> 2] = Math_fround(f5 * f26);
  HEAPF32[i1 >> 2] = Math_fround(f26 * f3);
  f26 = f2;
  return Math_fround(f26);
 }
 i6 = i18 + 6 | 0;
 i11 = HEAP16[i6 >> 1] | 0;
 i1 = i27 + 80 | 0;
 if ((i11 & 255) << 24 >> 24 == ((i11 & 65535) >>> 8 & 255) << 24 >> 24) {
  HEAP32[i1 >> 2] = 2;
  i4 = HEAPU8[i18 + 9 >> 0] | 0;
  i1 = HEAP32[i17 + 16 >> 2] | 0;
  f14 = Math_fround(HEAPF32[i1 + (i4 << 3) >> 2]);
  f15 = Math_fround(HEAPF32[i1 + (i4 << 3) + 4 >> 2]);
  i4 = HEAPU8[i18 + 10 >> 0] | 0;
  f12 = Math_fround(HEAPF32[i1 + (i4 << 3) >> 2]);
  f13 = Math_fround(HEAPF32[i1 + (i4 << 3) + 4 >> 2]);
  f3 = Math_fround(f12 - f14);
  f2 = Math_fround(f13 - f15);
  f5 = Math_fround(-f3);
  i4 = i27 + 92 | 0;
  HEAPF32[i4 >> 2] = f2;
  i1 = i27 + 96 | 0;
  HEAPF32[i1 >> 2] = f5;
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
  if (f3 < Math_fround(1.1920929e-07)) {
   f10 = f2;
   f3 = f5;
  } else {
   f3 = Math_fround(Math_fround(1.0) / f3);
   f10 = Math_fround(f2 * f3);
   HEAPF32[i4 >> 2] = f10;
   f3 = Math_fround(f3 * f5);
   HEAPF32[i1 >> 2] = f3;
  }
  f28 = Math_fround(Math_fround(f23 * f10) - Math_fround(f22 * f3));
  f5 = Math_fround(Math_fround(f22 * f10) + Math_fround(f23 * f3));
  f14 = Math_fround(Math_fround(f14 + f12) * Math_fround(.5));
  f2 = Math_fround(Math_fround(f15 + f13) * Math_fround(.5));
  HEAPF32[i27 + 84 >> 2] = f14;
  HEAPF32[i27 + 88 >> 2] = f2;
  f19 = Math_fround(f19 + Math_fround(Math_fround(f23 * f14) - Math_fround(f22 * f2)));
  f2 = Math_fround(f20 + Math_fround(Math_fround(f22 * f14) + Math_fround(f23 * f2)));
  i27 = HEAPU8[i6 >> 0] | 0;
  i18 = HEAP32[i16 + 16 >> 2] | 0;
  f22 = Math_fround(HEAPF32[i18 + (i27 << 3) >> 2]);
  f23 = Math_fround(HEAPF32[i18 + (i27 << 3) + 4 >> 2]);
  f2 = Math_fround(Math_fround(f28 * Math_fround(Math_fround(f21 + Math_fround(Math_fround(f26 * f22) - Math_fround(f25 * f23))) - f19)) + Math_fround(f5 * Math_fround(Math_fround(f24 + Math_fround(Math_fround(f25 * f22) + Math_fround(f26 * f23))) - f2)));
  if (!(f2 < Math_fround(0.0))) {
   f28 = f2;
   return Math_fround(f28);
  }
  f28 = Math_fround(-f3);
  HEAPF32[i4 >> 2] = Math_fround(-f10);
  HEAPF32[i1 >> 2] = f28;
  f28 = Math_fround(-f2);
  return Math_fround(f28);
 } else {
  HEAP32[i1 >> 2] = 1;
  i4 = HEAP16[i6 >> 1] | 0;
  i11 = i4 & 255;
  i1 = HEAP32[i16 + 16 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i1 + (i11 << 3) >> 2]);
  f13 = Math_fround(HEAPF32[i1 + (i11 << 3) + 4 >> 2]);
  i4 = (i4 & 65535) >>> 8 & 65535;
  f14 = Math_fround(HEAPF32[i1 + (i4 << 3) >> 2]);
  f15 = Math_fround(HEAPF32[i1 + (i4 << 3) + 4 >> 2]);
  f3 = Math_fround(f14 - f12);
  f2 = Math_fround(f15 - f13);
  f5 = Math_fround(-f3);
  i4 = i27 + 92 | 0;
  HEAPF32[i4 >> 2] = f2;
  i1 = i27 + 96 | 0;
  HEAPF32[i1 >> 2] = f5;
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
  if (f3 < Math_fround(1.1920929e-07)) {
   f10 = f2;
   f3 = f5;
  } else {
   f3 = Math_fround(Math_fround(1.0) / f3);
   f10 = Math_fround(f2 * f3);
   HEAPF32[i4 >> 2] = f10;
   f3 = Math_fround(f3 * f5);
   HEAPF32[i1 >> 2] = f3;
  }
  f29 = Math_fround(Math_fround(f26 * f10) - Math_fround(f25 * f3));
  f5 = Math_fround(Math_fround(f25 * f10) + Math_fround(f26 * f3));
  f28 = Math_fround(Math_fround(f12 + f14) * Math_fround(.5));
  f2 = Math_fround(Math_fround(f13 + f15) * Math_fround(.5));
  HEAPF32[i27 + 84 >> 2] = f28;
  HEAPF32[i27 + 88 >> 2] = f2;
  f21 = Math_fround(f21 + Math_fround(Math_fround(f26 * f28) - Math_fround(f25 * f2)));
  f2 = Math_fround(f24 + Math_fround(Math_fround(f25 * f28) + Math_fround(f26 * f2)));
  i27 = HEAPU8[i18 + 9 >> 0] | 0;
  i18 = HEAP32[i17 + 16 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i18 + (i27 << 3) >> 2]);
  f28 = Math_fround(HEAPF32[i18 + (i27 << 3) + 4 >> 2]);
  f2 = Math_fround(Math_fround(f29 * Math_fround(Math_fround(f19 + Math_fround(Math_fround(f23 * f26) - Math_fround(f22 * f28))) - f21)) + Math_fround(f5 * Math_fround(Math_fround(f20 + Math_fround(Math_fround(f22 * f26) + Math_fround(f23 * f28))) - f2)));
  if (!(f2 < Math_fround(0.0))) {
   f29 = f2;
   return Math_fround(f29);
  }
  f29 = Math_fround(-f3);
  HEAPF32[i4 >> 2] = Math_fround(-f10);
  HEAPF32[i1 >> 2] = f29;
  f29 = Math_fround(-f2);
  return Math_fround(f29);
 }
 return f0;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1 + 4;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901608 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 16 | 0, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i3 + 12 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901635 | 0, i7, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901655 | 0, i7, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901672 | 0, i7, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901689 | 0, i8, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901707 | 0, i8, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901736 | 0, i7, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901753 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901780 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901804 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901827 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901847 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901867 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901895 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901920 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901945 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901967 | 0, i6, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903232 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903253 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901984 | 0, i6, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902010 | 0, i6, i1 + 81 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902025 | 0, i6, i1 + 82 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902047 | 0, i6, i1 + 83 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902065 | 0, i6, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902083 | 0, i6, i1 + 85 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902106 | 0, i6, i1 + 86 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function _strstr(i1, i16) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 1024 | 0;
 i18 = i19;
 i7 = HEAP8[i16 >> 0] | 0;
 do if (i7 << 24 >> 24) {
  i15 = _strchr(i1, i7 << 24 >> 24) | 0;
  if (!i15) i1 = 0; else {
   i4 = HEAP8[i16 + 1 >> 0] | 0;
   if (!(i4 << 24 >> 24)) i1 = i15; else {
    i2 = i15 + 1 | 0;
    i8 = HEAP8[i2 >> 0] | 0;
    if (!(i8 << 24 >> 24)) i1 = 0; else {
     i5 = HEAP8[i16 + 2 >> 0] | 0;
     if (!(i5 << 24 >> 24)) {
      i4 = i4 & 255 | (i7 & 255) << 8;
      i3 = HEAPU8[i15 >> 0] << 8 | i8 & 255;
      i1 = i8;
      while (1) {
       i3 = i3 & 65535;
       if ((i3 | 0) == (i4 | 0)) break;
       i2 = i2 + 1 | 0;
       i1 = HEAP8[i2 >> 0] | 0;
       if (!(i1 << 24 >> 24)) {
        i1 = 0;
        break;
       } else i3 = i1 & 255 | i3 << 8;
      }
      i1 = i1 << 24 >> 24 ? i2 + -1 | 0 : 0;
      break;
     }
     i2 = i15 + 2 | 0;
     i1 = HEAP8[i2 >> 0] | 0;
     if (!(i1 << 24 >> 24)) i1 = 0; else {
      i3 = HEAP8[i16 + 3 >> 0] | 0;
      if (!(i3 << 24 >> 24)) {
       i4 = (i4 & 255) << 16 | (i7 & 255) << 24 | (i5 & 255) << 8;
       i3 = (i1 & 255) << 8 | (i8 & 255) << 16 | HEAPU8[i15 >> 0] << 24;
       if ((i3 | 0) != (i4 | 0)) do {
        i2 = i2 + 1 | 0;
        i1 = HEAP8[i2 >> 0] | 0;
        i3 = (i1 & 255 | i3) << 8;
       } while (!(i1 << 24 >> 24 == 0 | (i3 | 0) == (i4 | 0)));
       i1 = i1 << 24 >> 24 ? i2 + -2 | 0 : 0;
       break;
      }
      i2 = i15 + 3 | 0;
      i6 = HEAP8[i2 >> 0] | 0;
      if (!(i6 << 24 >> 24)) i1 = 0; else {
       if (!(HEAP8[i16 + 4 >> 0] | 0)) {
        i4 = (i4 & 255) << 16 | (i7 & 255) << 24 | (i5 & 255) << 8 | i3 & 255;
        i3 = (i1 & 255) << 8 | (i8 & 255) << 16 | i6 & 255 | HEAPU8[i15 >> 0] << 24;
        if ((i3 | 0) == (i4 | 0)) i1 = i6; else do {
         i2 = i2 + 1 | 0;
         i1 = HEAP8[i2 >> 0] | 0;
         i3 = i1 & 255 | i3 << 8;
        } while (!(i1 << 24 >> 24 == 0 | (i3 | 0) == (i4 | 0)));
        i1 = i1 << 24 >> 24 ? i2 + -3 | 0 : 0;
        break;
       };
       HEAP32[i17 >> 2] = 0;
       HEAP32[i17 + 4 >> 2] = 0;
       HEAP32[i17 + 8 >> 2] = 0;
       HEAP32[i17 + 12 >> 2] = 0;
       HEAP32[i17 + 16 >> 2] = 0;
       HEAP32[i17 + 20 >> 2] = 0;
       HEAP32[i17 + 24 >> 2] = 0;
       HEAP32[i17 + 28 >> 2] = 0;
       i14 = 0;
       i1 = i7;
       while (1) {
        if (!(HEAP8[i15 + i14 >> 0] | 0)) {
         i1 = 0;
         break;
        }
        i13 = i17 + (((i1 & 255) >>> 5 & 255) << 2) | 0;
        HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1 << (i1 & 31);
        i13 = i14 + 1 | 0;
        HEAP32[i18 + ((i1 & 255) << 2) >> 2] = i13;
        i1 = HEAP8[i16 + i13 >> 0] | 0;
        if (!(i1 << 24 >> 24)) {
         i9 = 23;
         break;
        } else i14 = i13;
       }
       L32 : do if ((i9 | 0) == 23) {
        L34 : do if (i13 >>> 0 > 1) {
         i2 = 0;
         i7 = -1;
         i3 = 1;
         L35 : while (1) {
          i4 = 1;
          i1 = i2;
          while (1) {
           i2 = i3;
           L39 : while (1) {
            i6 = 1;
            while (1) {
             i3 = HEAP8[i16 + (i6 + i7) >> 0] | 0;
             i5 = HEAP8[i16 + i2 >> 0] | 0;
             if (i3 << 24 >> 24 != i5 << 24 >> 24) break L39;
             if ((i6 | 0) == (i4 | 0)) break;
             i6 = i6 + 1 | 0;
             i2 = i6 + i1 | 0;
             if (i2 >>> 0 >= i13 >>> 0) {
              i8 = i4;
              i1 = i7;
              break L35;
             }
            }
            i1 = i1 + i4 | 0;
            i2 = i1 + 1 | 0;
            if (i2 >>> 0 >= i13 >>> 0) {
             i8 = i4;
             i1 = i7;
             break L35;
            }
           }
           i4 = i2 - i7 | 0;
           if ((i3 & 255) <= (i5 & 255)) break;
           i3 = i2 + 1 | 0;
           if (i3 >>> 0 >= i13 >>> 0) {
            i8 = i4;
            i1 = i7;
            break L35;
           } else i1 = i2;
          }
          i3 = i1 + 2 | 0;
          if (i3 >>> 0 >= i13 >>> 0) {
           i8 = 1;
           break;
          } else {
           i2 = i1 + 1 | 0;
           i7 = i1;
          }
         }
         i4 = 0;
         i9 = -1;
         i5 = 1;
         while (1) {
          i3 = 1;
          i2 = i4;
          while (1) {
           i4 = i5;
           L54 : while (1) {
            i7 = 1;
            while (1) {
             i5 = HEAP8[i16 + (i7 + i9) >> 0] | 0;
             i6 = HEAP8[i16 + i4 >> 0] | 0;
             if (i5 << 24 >> 24 != i6 << 24 >> 24) break L54;
             if ((i7 | 0) == (i3 | 0)) break;
             i7 = i7 + 1 | 0;
             i4 = i7 + i2 | 0;
             if (i4 >>> 0 >= i13 >>> 0) {
              i4 = i8;
              i2 = i9;
              break L34;
             }
            }
            i2 = i2 + i3 | 0;
            i4 = i2 + 1 | 0;
            if (i4 >>> 0 >= i13 >>> 0) {
             i4 = i8;
             i2 = i9;
             break L34;
            }
           }
           i3 = i4 - i9 | 0;
           if ((i5 & 255) >= (i6 & 255)) break;
           i5 = i4 + 1 | 0;
           if (i5 >>> 0 >= i13 >>> 0) {
            i4 = i8;
            i2 = i9;
            break L34;
           } else i2 = i4;
          }
          i5 = i2 + 2 | 0;
          if (i5 >>> 0 >= i13 >>> 0) {
           i4 = i8;
           i3 = 1;
           break;
          } else {
           i4 = i2 + 1 | 0;
           i9 = i2;
          }
         }
        } else {
         i4 = 1;
         i1 = -1;
         i3 = 1;
         i2 = -1;
        } while (0);
        i11 = (i2 + 1 | 0) >>> 0 > (i1 + 1 | 0) >>> 0;
        i3 = i11 ? i3 : i4;
        i11 = i11 ? i2 : i1;
        i12 = i11 + 1 | 0;
        if (!(_memcmp(i16, i16 + i3 | 0, i12) | 0)) i10 = i13 - i3 | 0; else {
         i3 = i13 - i11 + -1 | 0;
         i10 = 0;
         i3 = (i11 >>> 0 > i3 >>> 0 ? i11 : i3) + 1 | 0;
        }
        i7 = i13 | 63;
        i8 = (i10 | 0) != 0;
        i9 = i13 - i3 | 0;
        i1 = i15;
        i6 = 0;
        i2 = i15;
        L69 : while (1) {
         i4 = i1;
         do if ((i2 - i4 | 0) >>> 0 < i13 >>> 0) {
          i5 = _memchr(i2, 0, i7) | 0;
          if (!i5) {
           i5 = i2 + i7 | 0;
           break;
          } else if ((i5 - i4 | 0) >>> 0 < i13 >>> 0) {
           i1 = 0;
           break L32;
          } else break;
         } else i5 = i2; while (0);
         i2 = HEAP8[i1 + i14 >> 0] | 0;
         if (!(1 << (i2 & 31) & HEAP32[i17 + (((i2 & 255) >>> 5 & 255) << 2) >> 2])) {
          i1 = i1 + i13 | 0;
          i6 = 0;
          i2 = i5;
          continue;
         }
         i2 = i13 - (HEAP32[i18 + ((i2 & 255) << 2) >> 2] | 0) | 0;
         if (i2 | 0) {
          i1 = i1 + (i8 & (i6 | 0) != 0 & i2 >>> 0 < i3 >>> 0 ? i9 : i2) | 0;
          i6 = 0;
          i2 = i5;
          continue;
         }
         i2 = i12 >>> 0 > i6 >>> 0 ? i12 : i6;
         i4 = HEAP8[i16 + i2 >> 0] | 0;
         L83 : do if (!(i4 << 24 >> 24)) i2 = i12; else {
          while (1) {
           if (i4 << 24 >> 24 != (HEAP8[i1 + i2 >> 0] | 0)) break;
           i2 = i2 + 1 | 0;
           i4 = HEAP8[i16 + i2 >> 0] | 0;
           if (!(i4 << 24 >> 24)) {
            i2 = i12;
            break L83;
           }
          }
          i1 = i1 + (i2 - i11) | 0;
          i6 = 0;
          i2 = i5;
          continue L69;
         } while (0);
         do {
          if (i2 >>> 0 <= i6 >>> 0) break L32;
          i2 = i2 + -1 | 0;
         } while ((HEAP8[i16 + i2 >> 0] | 0) == (HEAP8[i1 + i2 >> 0] | 0));
         i1 = i1 + i3 | 0;
         i6 = i10;
         i2 = i5;
        }
       } while (0);
      }
     }
    }
   }
  }
 } while (0);
 STACKTOP = i19;
 return i1 | 0;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i1, i26, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i1, i26, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i1, i26, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i1, i26, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __ZN5physx14PxVehicleGraph15setupWheelGraphEffffRKNS_6PxVec3ES3_S3_(i8, f6, f7, f4, f5, i1, i2, i3) {
 i8 = i8 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 576 | 0;
 i11 = i9 + 512 | 0;
 i17 = i9 + 448 | 0;
 i20 = i9 + 384 | 0;
 i21 = i9 + 320 | 0;
 i22 = i9 + 256 | 0;
 i23 = i9 + 192 | 0;
 i24 = i9 + 128 | 0;
 i25 = i9 + 64 | 0;
 i26 = i9;
 i27 = i9 + 648 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i1 + 4 >> 2] | 0;
 i28 = HEAP32[i1 + 8 >> 2] | 0;
 f6 = Math_fround(f6 * Math_fround(.5));
 HEAPF32[i8 + 15808 >> 2] = Math_fround(f4 - f6);
 HEAPF32[i8 + 15812 >> 2] = Math_fround(f6 + f4);
 f7 = Math_fround(f7 * Math_fround(.5));
 HEAPF32[i8 + 15816 >> 2] = Math_fround(f5 - f7);
 HEAPF32[i8 + 15820 >> 2] = Math_fround(f7 + f5);
 HEAP32[i8 + 15792 >> 2] = i13;
 HEAP32[i8 + 15796 >> 2] = i15;
 HEAP32[i8 + 15800 >> 2] = i28;
 HEAP32[i8 + 15804 >> 2] = 1056964608;
 HEAP32[i8 + 15828 >> 2] = 11;
 i28 = HEAP32[i2 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = i2 + 8 | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i29 = HEAP32[i3 >> 2] | 0;
 i12 = i3 + 4 | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i14 = i3 + 8 | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i27, 64, gb + 835520 | 0, i26) | 0;
 HEAP32[i8 >> 2] = -1102263091;
 HEAP32[i8 + 48 >> 2] = 1053609165;
 HEAP32[i8 + 96 >> 2] = 0;
 HEAP32[i8 + 144 >> 2] = i29;
 HEAP32[i8 + 148 >> 2] = i18;
 HEAP32[i8 + 152 >> 2] = i19;
 HEAP32[i8 + 288 >> 2] = i28;
 HEAP32[i8 + 292 >> 2] = i15;
 HEAP32[i8 + 296 >> 2] = i16;
 _strncpy(i8 + 432 | 0, i27, 256) | 0;
 HEAP8[i8 + 687 >> 0] = 0;
 i27 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i28 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i26, 64, gb + 835531 | 0, i25) | 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1184645120;
 HEAP32[i8 + 100 >> 2] = 0;
 HEAP32[i8 + 156 >> 2] = i28;
 HEAP32[i8 + 160 >> 2] = i19;
 HEAP32[i8 + 164 >> 2] = i18;
 HEAP32[i8 + 300 >> 2] = i27;
 HEAP32[i8 + 304 >> 2] = i16;
 HEAP32[i8 + 308 >> 2] = i15;
 _strncpy(i8 + 688 | 0, i26, 256) | 0;
 HEAP8[i8 + 943 >> 0] = 0;
 i26 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i27 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i25, 64, gb + 835541 | 0, i24) | 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 56 >> 2] = 1184645120;
 HEAP32[i8 + 104 >> 2] = 0;
 HEAP32[i8 + 168 >> 2] = i27;
 HEAP32[i8 + 172 >> 2] = i18;
 HEAP32[i8 + 176 >> 2] = i19;
 HEAP32[i8 + 312 >> 2] = i26;
 HEAP32[i8 + 316 >> 2] = i15;
 HEAP32[i8 + 320 >> 2] = i16;
 _strncpy(i8 + 944 | 0, i25, 256) | 0;
 HEAP8[i8 + 1199 >> 0] = 0;
 i25 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i26 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i24, 64, gb + 835550 | 0, i23) | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 1077936128;
 HEAP32[i8 + 108 >> 2] = 1065353216;
 HEAP32[i8 + 180 >> 2] = i26;
 HEAP32[i8 + 184 >> 2] = i19;
 HEAP32[i8 + 188 >> 2] = i18;
 HEAP32[i8 + 324 >> 2] = i25;
 HEAP32[i8 + 328 >> 2] = i16;
 HEAP32[i8 + 332 >> 2] = i15;
 _strncpy(i8 + 1200 | 0, i24, 256) | 0;
 HEAP8[i8 + 1455 >> 0] = 0;
 i24 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i25 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i23, 64, gb + 835563 | 0, i22) | 0;
 HEAP32[i8 + 16 >> 2] = -1035468800;
 HEAP32[i8 + 64 >> 2] = 1132068864;
 HEAP32[i8 + 112 >> 2] = 0;
 HEAP32[i8 + 192 >> 2] = i25;
 HEAP32[i8 + 196 >> 2] = i18;
 HEAP32[i8 + 200 >> 2] = i19;
 HEAP32[i8 + 336 >> 2] = i24;
 HEAP32[i8 + 340 >> 2] = i15;
 HEAP32[i8 + 344 >> 2] = i16;
 _strncpy(i8 + 1456 | 0, i23, 256) | 0;
 HEAP8[i8 + 1711 >> 0] = 0;
 i23 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i24 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 64, gb + 835574 | 0, i21) | 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1066192077;
 HEAP32[i8 + 116 >> 2] = 1065353216;
 HEAP32[i8 + 204 >> 2] = i24;
 HEAP32[i8 + 208 >> 2] = i19;
 HEAP32[i8 + 212 >> 2] = i18;
 HEAP32[i8 + 348 >> 2] = i23;
 HEAP32[i8 + 352 >> 2] = i16;
 HEAP32[i8 + 356 >> 2] = i15;
 _strncpy(i8 + 1712 | 0, i22, 256) | 0;
 HEAP8[i8 + 1967 >> 0] = 0;
 i22 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i23 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i21, 64, gb + 835583 | 0, i20) | 0;
 HEAP32[i8 + 24 >> 2] = -1102263091;
 HEAP32[i8 + 72 >> 2] = 1045220557;
 HEAP32[i8 + 120 >> 2] = 0;
 HEAP32[i8 + 216 >> 2] = i23;
 HEAP32[i8 + 220 >> 2] = i18;
 HEAP32[i8 + 224 >> 2] = i19;
 HEAP32[i8 + 360 >> 2] = i22;
 HEAP32[i8 + 364 >> 2] = i15;
 HEAP32[i8 + 368 >> 2] = i16;
 _strncpy(i8 + 1968 | 0, i21, 256) | 0;
 HEAP8[i8 + 2223 >> 0] = 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i22 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 64, gb + 835596 | 0, i17) | 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 76 >> 2] = 1073741824;
 HEAP32[i8 + 124 >> 2] = 1065353216;
 HEAP32[i8 + 228 >> 2] = i22;
 HEAP32[i8 + 232 >> 2] = i19;
 HEAP32[i8 + 236 >> 2] = i18;
 HEAP32[i8 + 372 >> 2] = i21;
 HEAP32[i8 + 376 >> 2] = i16;
 HEAP32[i8 + 380 >> 2] = i15;
 _strncpy(i8 + 2224 | 0, i20, 256) | 0;
 HEAP8[i8 + 2479 >> 0] = 0;
 i20 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i21 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i17, 64, gb + 835614 | 0, i11) | 0;
 HEAP32[i8 + 32 >> 2] = -1082130432;
 HEAP32[i8 + 80 >> 2] = 1065353216;
 HEAP32[i8 + 128 >> 2] = 0;
 HEAP32[i8 + 240 >> 2] = i21;
 HEAP32[i8 + 244 >> 2] = i18;
 HEAP32[i8 + 248 >> 2] = i19;
 HEAP32[i8 + 384 >> 2] = i20;
 HEAP32[i8 + 388 >> 2] = i15;
 HEAP32[i8 + 392 >> 2] = i16;
 _strncpy(i8 + 2480 | 0, i17, 256) | 0;
 HEAP8[i8 + 2735 >> 0] = 0;
 i17 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i20 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i11, 64, gb + 835626 | 0, i10) | 0;
 HEAP32[i8 + 36 >> 2] = 0;
 HEAP32[i8 + 84 >> 2] = 1073741824;
 HEAP32[i8 + 132 >> 2] = 1065353216;
 HEAP32[i8 + 252 >> 2] = i20;
 HEAP32[i8 + 256 >> 2] = i19;
 HEAP32[i8 + 260 >> 2] = i18;
 HEAP32[i8 + 396 >> 2] = i17;
 HEAP32[i8 + 400 >> 2] = i16;
 HEAP32[i8 + 404 >> 2] = i15;
 _strncpy(i8 + 2736 | 0, i11, 256) | 0;
 HEAP8[i8 + 2991 >> 0] = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 64, gb + 835643 | 0, i9 + 640 | 0) | 0;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 88 >> 2] = 1073741824;
 HEAP32[i8 + 136 >> 2] = 1065353216;
 HEAP32[i8 + 264 >> 2] = i13;
 HEAP32[i8 + 268 >> 2] = i12;
 HEAP32[i8 + 272 >> 2] = i3;
 HEAP32[i8 + 408 >> 2] = i11;
 HEAP32[i8 + 412 >> 2] = i1;
 HEAP32[i8 + 416 >> 2] = i2;
 _strncpy(i8 + 2992 | 0, i10, 256) | 0;
 HEAP8[i8 + 3247 >> 0] = 0;
 STACKTOP = i9;
 return;
}

function __ZN19SkinnedMeshRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 i6 = i3 + 20 | 0;
 i11 = i3 + 16 | 0;
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i12 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429171 | 0, i12, i1 + 460 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429181 | 0, i8, i1 + 464 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429203 | 0, i8, i1 + 465 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = i1 + 352 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i8, 0);
 i7 = i10 + 8 | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i12, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429226 | 0, i7, i1 + 360 | 0, 1);
 HEAP32[i11 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 842702 | 0, i11, 0);
 i9 = i10 + 8 | 0;
 i13 = i9;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i12, i11, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429234 | 0, i7, i1 + 416 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 380 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429254 | 0, gb + 842702 | 0, i6, 0);
 i9 = i10 + 8 | 0;
 i11 = i9;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 436 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429265 | 0, gb + 1034406 | 0, i9, 0);
 i8 = HEAP32[gb + 37324 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034411 | 0, i8, i9, 0);
 i6 = i2 + 20 | 0;
 i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 440 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i7, i1 + 444 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 448 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034420 | 0, i8, i7, 0);
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 452 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 456 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429272 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 466 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN26ContactCapsuleMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i17, i5, i2, i3, i4, i1, i18) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 if (!(HEAP8[i17 + 40 >> 0] | 0)) {
  i6 = HEAP32[i17 + 36 >> 2] | 0;
  f25 = Math_fround(HEAPF32[i2 >> 2]);
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i6 >> 2]));
  i7 = i6 + 4 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i7 >> 2]));
  i8 = i6 + 8 | 0;
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i8 >> 2]));
  f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i9 = i6 + 12 | 0;
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i9 >> 2]));
  i10 = i6 + 16 | 0;
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i10 >> 2]));
  i11 = i6 + 20 | 0;
  f24 = Math_fround(f26 + f24);
  f23 = Math_fround(f27 + f23);
  f22 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i11 >> 2])));
  f25 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i12 = i6 + 24 | 0;
  f27 = Math_fround(f25 * Math_fround(HEAPF32[i12 >> 2]));
  i13 = i6 + 28 | 0;
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i13 >> 2]));
  i14 = i6 + 32 | 0;
  f27 = Math_fround(f24 + f27);
  f26 = Math_fround(f23 + f26);
  f25 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 >> 2] = f27;
  HEAPF32[i15 + 4 >> 2] = f26;
  HEAPF32[i15 + 8 >> 2] = f25;
  f22 = Math_fround(HEAPF32[i3 >> 2]);
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i6 >> 2]));
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i7 >> 2]));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i8 >> 2]));
  f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i10 >> 2]));
  f21 = Math_fround(f23 + f21);
  f20 = Math_fround(f24 + f20);
  f19 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2])));
  f22 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f24 = Math_fround(f22 * Math_fround(HEAPF32[i12 >> 2]));
  f23 = Math_fround(f22 * Math_fround(HEAPF32[i13 >> 2]));
  f24 = Math_fround(f21 + f24);
  f23 = Math_fround(f20 + f23);
  f22 = Math_fround(f19 + Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 12 >> 2] = f24;
  HEAPF32[i15 + 16 >> 2] = f23;
  HEAPF32[i15 + 20 >> 2] = f22;
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i6 >> 2]));
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2]));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2]));
  f28 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f30 = Math_fround(f28 * Math_fround(HEAPF32[i9 >> 2]));
  f29 = Math_fround(f28 * Math_fround(HEAPF32[i10 >> 2]));
  f30 = Math_fround(f20 + f30);
  f29 = Math_fround(f21 + f29);
  f28 = Math_fround(f19 + Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2])));
  f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(f19 * Math_fround(HEAPF32[i12 >> 2]));
  f20 = Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2]));
  f21 = Math_fround(f30 + f21);
  f20 = Math_fround(f29 + f20);
  f19 = Math_fround(f28 + Math_fround(f19 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i15 + 24 >> 2] = f21;
  HEAPF32[i15 + 28 >> 2] = f20;
  HEAPF32[i15 + 32 >> 2] = f19;
  i14 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i11 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i14 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i14;
  i13 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i13;
  i12 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i12;
  i11 = HEAP32[i3 >> 2] | 0;
  HEAP32[i15 + 12 >> 2] = i11;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i15 + 16 >> 2] = i10;
  i9 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i15 + 20 >> 2] = i9;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i15 + 24 >> 2] = i8;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i15 + 28 >> 2] = i7;
  i6 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
 }
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i17 + 896 >> 2] | 0) + 152 >> 2] | 0;
 if (!i1) i3 = 56; else i3 = HEAP8[i1 + i4 >> 0] | 0;
 i1 = i17 + 892 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 16) {
  i15 = i2;
  i32 = i14;
  i31 = i13;
  i13 = i12;
  i2 = i11;
  i5 = i10;
  i11 = i9;
  i9 = i7;
  i10 = i6;
  i12 = i15 + 1 | 0;
  HEAP32[i1 >> 2] = i12;
  i12 = i15 * 3 | 0;
  i14 = i17 + 44 + (i12 * 12 | 0) | 0;
  HEAP32[i14 >> 2] = i32;
  i14 = i17 + 44 + (i12 * 12 | 0) + 4 | 0;
  HEAP32[i14 >> 2] = i31;
  i14 = i17 + 44 + (i12 * 12 | 0) + 8 | 0;
  HEAP32[i14 >> 2] = i13;
  i14 = i12 + 1 | 0;
  i13 = i17 + 44 + (i14 * 12 | 0) | 0;
  HEAP32[i13 >> 2] = i2;
  i13 = i17 + 44 + (i14 * 12 | 0) + 4 | 0;
  HEAP32[i13 >> 2] = i5;
  i13 = i17 + 44 + (i14 * 12 | 0) + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i12 + 2 | 0;
  i11 = i17 + 44 + (i13 * 12 | 0) | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i17 + 44 + (i13 * 12 | 0) + 4 | 0;
  HEAP32[i11 >> 2] = i9;
  i11 = i17 + 44 + (i13 * 12 | 0) + 8 | 0;
  HEAP32[i11 >> 2] = i10;
  i11 = HEAP32[i18 >> 2] | 0;
  i12 = i17 + 620 + (i12 << 2) | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i18 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i14 = i17 + 620 + (i14 << 2) | 0;
  HEAP32[i14 >> 2] = i12;
  i14 = i18 + 8 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i18 = i17 + 620 + (i13 << 2) | 0;
  HEAP32[i18 >> 2] = i14;
  i18 = i17 + 812 + (i15 << 2) | 0;
  HEAP32[i18 >> 2] = i4;
  i18 = i17 + 876 + i15 | 0;
  HEAP8[i18 >> 0] = i3;
  STACKTOP = i16;
  return 1;
 }
 __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE(i17 + 8 | 0, i17 + 44 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i32 = 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i15 + 4 >> 2] | 0;
 i31 = HEAP32[i15 + 8 >> 2] | 0;
 i8 = HEAP32[i15 + 12 >> 2] | 0;
 i9 = HEAP32[i15 + 16 >> 2] | 0;
 i13 = HEAP32[i15 + 20 >> 2] | 0;
 i10 = HEAP32[i15 + 24 >> 2] | 0;
 i11 = HEAP32[i15 + 28 >> 2] | 0;
 i12 = HEAP32[i15 + 32 >> 2] | 0;
 i14 = i32 + 1 | 0;
 HEAP32[i1 >> 2] = i14;
 i14 = i32 * 3 | 0;
 i15 = i17 + 44 + (i14 * 12 | 0) | 0;
 HEAP32[i15 >> 2] = i6;
 i15 = i17 + 44 + (i14 * 12 | 0) + 4 | 0;
 HEAP32[i15 >> 2] = i7;
 i15 = i17 + 44 + (i14 * 12 | 0) + 8 | 0;
 HEAP32[i15 >> 2] = i31;
 i15 = i14 + 1 | 0;
 i31 = i17 + 44 + (i15 * 12 | 0) | 0;
 HEAP32[i31 >> 2] = i8;
 i31 = i17 + 44 + (i15 * 12 | 0) + 4 | 0;
 HEAP32[i31 >> 2] = i9;
 i31 = i17 + 44 + (i15 * 12 | 0) + 8 | 0;
 HEAP32[i31 >> 2] = i13;
 i31 = i14 + 2 | 0;
 i13 = i17 + 44 + (i31 * 12 | 0) | 0;
 HEAP32[i13 >> 2] = i10;
 i13 = i17 + 44 + (i31 * 12 | 0) + 4 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i17 + 44 + (i31 * 12 | 0) + 8 | 0;
 HEAP32[i13 >> 2] = i12;
 i13 = HEAP32[i18 >> 2] | 0;
 i14 = i17 + 620 + (i14 << 2) | 0;
 HEAP32[i14 >> 2] = i13;
 i14 = i18 + 4 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = i17 + 620 + (i15 << 2) | 0;
 HEAP32[i15 >> 2] = i14;
 i18 = i18 + 8 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i31 = i17 + 620 + (i31 << 2) | 0;
 HEAP32[i31 >> 2] = i18;
 i31 = i17 + 812 + (i32 << 2) | 0;
 HEAP32[i31 >> 2] = i4;
 i32 = i17 + 876 + i32 | 0;
 HEAP8[i32 >> 0] = i3;
 STACKTOP = i16;
 return 1;
}

function __ZN11ShapeModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047471 | 0, i9, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 753604 | 0, i8, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620620 | 0, i8, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620626 | 0, i8, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620633 | 0, i8, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620638 | 0, i8, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620643 | 0, i8, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620648 | 0, i8, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620652 | 0, i9, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i8, 0);
 i7 = i10 + 8 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620666 | 0, gb + 620681 | 0, i7, 0);
 i9 = i10 + 8 | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620700 | 0, gb + 620722 | 0, i9, 0);
 i7 = i10 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620748 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620768 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620787 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620799 | 0, i7, i1 + 213 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620822 | 0, i7, i1 + 214 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620838 | 0, i7, i1 + 212 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620855 | 0, i6, i1 + 204 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620877 | 0, i6, i1 + 208 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function runPostSets45() {
 HEAP32[gb + 60344 >> 2] = (HEAP32[gb + 60344 >> 2] | 0) + (gb + 1085989 | 0);
 HEAP32[gb + 60348 >> 2] = (HEAP32[gb + 60348 >> 2] | 0) + (gb + 1085998 | 0);
 HEAP32[gb + 60352 >> 2] = (HEAP32[gb + 60352 >> 2] | 0) + (gb + 1084342 | 0);
 HEAP32[gb + 60356 >> 2] = (HEAP32[gb + 60356 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60360 >> 2] = (HEAP32[gb + 60360 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60364 >> 2] = (HEAP32[gb + 60364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60368 >> 2] = (HEAP32[gb + 60368 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60372 >> 2] = (HEAP32[gb + 60372 >> 2] | 0) + (gb + 434799 | 0);
 HEAP32[gb + 60376 >> 2] = (HEAP32[gb + 60376 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60380 >> 2] = (HEAP32[gb + 60380 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60384 >> 2] = (HEAP32[gb + 60384 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60388 >> 2] = (HEAP32[gb + 60388 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60392 >> 2] = (HEAP32[gb + 60392 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60396 >> 2] = (HEAP32[gb + 60396 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60400 >> 2] = (HEAP32[gb + 60400 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60404 >> 2] = (HEAP32[gb + 60404 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60408 >> 2] = (HEAP32[gb + 60408 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60412 >> 2] = (HEAP32[gb + 60412 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60416 >> 2] = (HEAP32[gb + 60416 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60420 >> 2] = (HEAP32[gb + 60420 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60424 >> 2] = (HEAP32[gb + 60424 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60428 >> 2] = (HEAP32[gb + 60428 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60432 >> 2] = (HEAP32[gb + 60432 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60436 >> 2] = (HEAP32[gb + 60436 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60440 >> 2] = (HEAP32[gb + 60440 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60444 >> 2] = (HEAP32[gb + 60444 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60448 >> 2] = (HEAP32[gb + 60448 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60452 >> 2] = (HEAP32[gb + 60452 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60456 >> 2] = (HEAP32[gb + 60456 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60460 >> 2] = (HEAP32[gb + 60460 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60464 >> 2] = (HEAP32[gb + 60464 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60468 >> 2] = (HEAP32[gb + 60468 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60472 >> 2] = (HEAP32[gb + 60472 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60476 >> 2] = (HEAP32[gb + 60476 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60480 >> 2] = (HEAP32[gb + 60480 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60484 >> 2] = (HEAP32[gb + 60484 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60488 >> 2] = (HEAP32[gb + 60488 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60492 >> 2] = (HEAP32[gb + 60492 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60496 >> 2] = (HEAP32[gb + 60496 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60500 >> 2] = (HEAP32[gb + 60500 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 60504 >> 2] = (HEAP32[gb + 60504 >> 2] | 0) + (gb + 434806 | 0);
 HEAP32[gb + 60508 >> 2] = (HEAP32[gb + 60508 >> 2] | 0) + (gb + 434814 | 0);
 HEAP32[gb + 60512 >> 2] = (HEAP32[gb + 60512 >> 2] | 0) + (gb + 434822 | 0);
 HEAP32[gb + 60516 >> 2] = (HEAP32[gb + 60516 >> 2] | 0) + (gb + 434830 | 0);
 HEAP32[gb + 60520 >> 2] = (HEAP32[gb + 60520 >> 2] | 0) + (gb + 434838 | 0);
 HEAP32[gb + 60524 >> 2] = (HEAP32[gb + 60524 >> 2] | 0) + (gb + 434846 | 0);
 HEAP32[gb + 60528 >> 2] = (HEAP32[gb + 60528 >> 2] | 0) + (gb + 434854 | 0);
 HEAP32[gb + 60532 >> 2] = (HEAP32[gb + 60532 >> 2] | 0) + (gb + 434862 | 0);
 HEAP32[gb + 60536 >> 2] = (HEAP32[gb + 60536 >> 2] | 0) + (gb + 434870 | 0);
 HEAP32[gb + 60540 >> 2] = (HEAP32[gb + 60540 >> 2] | 0) + (gb + 434878 | 0);
 HEAP32[gb + 60544 >> 2] = (HEAP32[gb + 60544 >> 2] | 0) + (gb + 434886 | 0);
 HEAP32[gb + 60548 >> 2] = (HEAP32[gb + 60548 >> 2] | 0) + (gb + 434895 | 0);
 HEAP32[gb + 60552 >> 2] = (HEAP32[gb + 60552 >> 2] | 0) + (gb + 434904 | 0);
 HEAP32[gb + 60556 >> 2] = (HEAP32[gb + 60556 >> 2] | 0) + (gb + 434913 | 0);
 HEAP32[gb + 60560 >> 2] = (HEAP32[gb + 60560 >> 2] | 0) + (gb + 434922 | 0);
 HEAP32[gb + 60564 >> 2] = (HEAP32[gb + 60564 >> 2] | 0) + (gb + 434931 | 0);
 HEAP32[gb + 60568 >> 2] = (HEAP32[gb + 60568 >> 2] | 0) + (gb + 434940 | 0);
 HEAP32[gb + 60572 >> 2] = (HEAP32[gb + 60572 >> 2] | 0) + (gb + 434949 | 0);
 HEAP32[gb + 60576 >> 2] = (HEAP32[gb + 60576 >> 2] | 0) + (gb + 434958 | 0);
 HEAP32[gb + 60580 >> 2] = (HEAP32[gb + 60580 >> 2] | 0) + (gb + 434967 | 0);
 HEAP32[gb + 60584 >> 2] = (HEAP32[gb + 60584 >> 2] | 0) + (gb + 434976 | 0);
 HEAP32[gb + 60588 >> 2] = (HEAP32[gb + 60588 >> 2] | 0) + (gb + 434985 | 0);
 HEAP32[gb + 60592 >> 2] = (HEAP32[gb + 60592 >> 2] | 0) + (gb + 434994 | 0);
 HEAP32[gb + 60596 >> 2] = (HEAP32[gb + 60596 >> 2] | 0) + (gb + 435003 | 0);
 HEAP32[gb + 60600 >> 2] = (HEAP32[gb + 60600 >> 2] | 0) + (gb + 435012 | 0);
 HEAP32[gb + 60604 >> 2] = (HEAP32[gb + 60604 >> 2] | 0) + (gb + 435021 | 0);
 HEAP32[gb + 60608 >> 2] = (HEAP32[gb + 60608 >> 2] | 0) + (gb + 435030 | 0);
 HEAP32[gb + 60612 >> 2] = (HEAP32[gb + 60612 >> 2] | 0) + (gb + 435039 | 0);
 HEAP32[gb + 60616 >> 2] = (HEAP32[gb + 60616 >> 2] | 0) + (gb + 435048 | 0);
 HEAP32[gb + 60620 >> 2] = (HEAP32[gb + 60620 >> 2] | 0) + (gb + 435057 | 0);
 HEAP32[gb + 60624 >> 2] = (HEAP32[gb + 60624 >> 2] | 0) + (gb + 435066 | 0);
 HEAP32[gb + 60628 >> 2] = (HEAP32[gb + 60628 >> 2] | 0) + (gb + 435075 | 0);
 HEAP32[gb + 60632 >> 2] = (HEAP32[gb + 60632 >> 2] | 0) + (gb + 435084 | 0);
 HEAP32[gb + 60636 >> 2] = (HEAP32[gb + 60636 >> 2] | 0) + (gb + 435093 | 0);
 HEAP32[gb + 60640 >> 2] = (HEAP32[gb + 60640 >> 2] | 0) + (gb + 435102 | 0);
 HEAP32[gb + 60644 >> 2] = (HEAP32[gb + 60644 >> 2] | 0) + (gb + 435111 | 0);
 HEAP32[gb + 60648 >> 2] = (HEAP32[gb + 60648 >> 2] | 0) + (gb + 435120 | 0);
 HEAP32[gb + 60652 >> 2] = (HEAP32[gb + 60652 >> 2] | 0) + (gb + 435129 | 0);
 HEAP32[gb + 60656 >> 2] = (HEAP32[gb + 60656 >> 2] | 0) + (gb + 435138 | 0);
 HEAP32[gb + 60660 >> 2] = (HEAP32[gb + 60660 >> 2] | 0) + (gb + 435147 | 0);
 HEAP32[gb + 60664 >> 2] = (HEAP32[gb + 60664 >> 2] | 0) + (gb + 435156 | 0);
 HEAP32[gb + 60668 >> 2] = (HEAP32[gb + 60668 >> 2] | 0) + (gb + 435165 | 0);
 HEAP32[gb + 60672 >> 2] = (HEAP32[gb + 60672 >> 2] | 0) + (gb + 435174 | 0);
 HEAP32[gb + 60676 >> 2] = (HEAP32[gb + 60676 >> 2] | 0) + (gb + 435183 | 0);
 HEAP32[gb + 60680 >> 2] = (HEAP32[gb + 60680 >> 2] | 0) + (gb + 435192 | 0);
 HEAP32[gb + 60684 >> 2] = (HEAP32[gb + 60684 >> 2] | 0) + (gb + 435201 | 0);
 HEAP32[gb + 60688 >> 2] = (HEAP32[gb + 60688 >> 2] | 0) + (gb + 435210 | 0);
 HEAP32[gb + 60692 >> 2] = (HEAP32[gb + 60692 >> 2] | 0) + (gb + 435219 | 0);
 HEAP32[gb + 60696 >> 2] = (HEAP32[gb + 60696 >> 2] | 0) + (gb + 435228 | 0);
 HEAP32[gb + 60700 >> 2] = (HEAP32[gb + 60700 >> 2] | 0) + (gb + 435237 | 0);
 HEAP32[gb + 60704 >> 2] = (HEAP32[gb + 60704 >> 2] | 0) + (gb + 435246 | 0);
 HEAP32[gb + 60708 >> 2] = (HEAP32[gb + 60708 >> 2] | 0) + (gb + 435255 | 0);
 HEAP32[gb + 60712 >> 2] = (HEAP32[gb + 60712 >> 2] | 0) + (gb + 435264 | 0);
 HEAP32[gb + 60716 >> 2] = (HEAP32[gb + 60716 >> 2] | 0) + (gb + 435273 | 0);
 HEAP32[gb + 60720 >> 2] = (HEAP32[gb + 60720 >> 2] | 0) + (gb + 435282 | 0);
 HEAP32[gb + 60724 >> 2] = (HEAP32[gb + 60724 >> 2] | 0) + (gb + 435291 | 0);
 HEAP32[gb + 60728 >> 2] = (HEAP32[gb + 60728 >> 2] | 0) + (gb + 435300 | 0);
 HEAP32[gb + 60732 >> 2] = (HEAP32[gb + 60732 >> 2] | 0) + (gb + 435309 | 0);
 HEAP32[gb + 60736 >> 2] = (HEAP32[gb + 60736 >> 2] | 0) + (gb + 435318 | 0);
 HEAP32[gb + 60740 >> 2] = (HEAP32[gb + 60740 >> 2] | 0) + (gb + 435327 | 0);
 runPostSets46();
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i26, i1, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i26, i1, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i26, i1, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i25, i26, i1, i2) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 32 | 0;
 i21 = i24 + 16 | 0;
 i22 = i24;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i10 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i10) {
  STACKTOP = i24;
  return;
 }
 i11 = i3 + 60 | 0;
 i12 = i3 + 80 | 0;
 i13 = i3 + 100 | 0;
 i14 = i3 + 120 | 0;
 i15 = i3 + 140 | 0;
 i16 = i3 + 160 | 0;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i2 = i3 + 500 | 0;
 i3 = i21 + 4 | 0;
 i4 = i21 + 8 | 0;
 i5 = i21 + 12 | 0;
 i6 = i22 + 4 | 0;
 i7 = i22 + 8 | 0;
 i8 = i22 + 12 | 0;
 i1 = 0;
 do {
  i29 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f70 = Math_fround(HEAPF32[i29 >> 2]);
  f69 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f68 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f67 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f66 = Math_fround(HEAPF32[i29 >> 2]);
  f65 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f64 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f63 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f62 = Math_fround(HEAPF32[i29 >> 2]);
  f61 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f60 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f59 = Math_fround(HEAPF32[i29 >> 2]);
  f57 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f53 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f58 = Math_fround(HEAPF32[i29 >> 2]);
  f56 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f54 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f52 = Math_fround(HEAPF32[i29 + 12 >> 2]);
  i29 = (HEAP32[i16 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i29 >> 2]);
  f48 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  f59 = Math_fround(f70 + f59);
  f57 = Math_fround(f69 + f57);
  f55 = Math_fround(f68 + f55);
  f53 = Math_fround(f67 + f53);
  f58 = Math_fround(f66 + f58);
  f56 = Math_fround(f65 + f56);
  f54 = Math_fround(f64 + f54);
  f52 = Math_fround(f63 + f52);
  f51 = Math_fround(f62 + f51);
  f48 = Math_fround(f61 + f48);
  f49 = Math_fround(f60 + f49);
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i29 + 12 >> 2]));
  f51 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f59 * f59) + Math_fround(f58 * f58)) + Math_fround(f51 * f51))))));
  f48 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f57 * f57) + Math_fround(f56 * f56)) + Math_fround(f48 * f48))))));
  f49 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f55 * f55) + Math_fround(f54 * f54)) + Math_fround(f49 * f49))))));
  f50 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f53 * f53) + Math_fround(f52 * f52)) + Math_fround(f50 * f50))))));
  i29 = f51 < Math_fround(0.0);
  f51 = i29 ? Math_fround(0.0) : f51;
  i29 = f48 < Math_fround(0.0);
  f48 = i29 ? Math_fround(0.0) : f48;
  i29 = f49 < Math_fround(0.0);
  f49 = i29 ? Math_fround(0.0) : f49;
  i29 = f50 < Math_fround(0.0);
  f50 = i29 ? Math_fround(0.0) : f50;
  i29 = f51 > Math_fround(1.0);
  f51 = i29 ? Math_fround(1.0) : f51;
  i29 = f48 > Math_fround(1.0);
  f48 = i29 ? Math_fround(1.0) : f48;
  i29 = f49 > Math_fround(1.0);
  f49 = i29 ? Math_fround(1.0) : f49;
  i29 = f50 > Math_fround(1.0);
  f50 = i29 ? Math_fround(1.0) : f50;
  HEAPF32[i20 >> 2] = f51;
  HEAPF32[i17 >> 2] = f48;
  HEAPF32[i18 >> 2] = f49;
  HEAPF32[i19 >> 2] = f50;
  i29 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i39 = (HEAP32[i29 >> 2] | 0) + 1089181156 | 0;
  i35 = (HEAP32[i29 + 4 >> 2] | 0) + 1089181156 | 0;
  i40 = (HEAP32[i29 + 8 >> 2] | 0) + 1089181156 | 0;
  i29 = (HEAP32[i29 + 12 >> 2] | 0) + 1089181156 | 0;
  i44 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i39 = i39 << 11 ^ i39;
  i35 = i35 << 11 ^ i35;
  i40 = i40 << 11 ^ i40;
  i29 = i29 << 11 ^ i29;
  f50 = Math_fround(Math_fround((i37 ^ i35 ^ i35 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f49 = Math_fround(Math_fround((i42 ^ i40 ^ i40 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f48 = Math_fround(Math_fround((i34 ^ i29 ^ i29 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i21 >> 2] = Math_fround(Math_fround((i44 ^ i39 ^ i39 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f50;
  HEAPF32[i4 >> 2] = f49;
  HEAPF32[i5 >> 2] = f48;
  __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i22, i26, i20, i21);
  i44 = HEAP32[i22 >> 2] | 0;
  i39 = HEAP32[i6 >> 2] | 0;
  i34 = HEAP32[i7 >> 2] | 0;
  i29 = HEAP32[i8 >> 2] | 0;
  i42 = i25 + (i1 << 2) | 0;
  i40 = HEAP32[i42 >> 2] | 0;
  i37 = i42 + 4 | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i42 + 8 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i42 + 12 | 0;
  i47 = HEAP32[i27 >> 2] | 0;
  i45 = (Math_imul(i40 & 255, i44 & 255) | 0) + 128 | 0;
  i46 = (Math_imul(i40 >>> 8 & 255, i44 >>> 8 & 255) | 0) + 128 | 0;
  i43 = (Math_imul(i40 >>> 16 & 255, i44 >>> 16 & 255) | 0) + 128 | 0;
  i44 = (Math_imul(i40 >>> 24, i44 >>> 24) | 0) + 128 | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i47 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i47 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i47 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i47 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  HEAP32[i42 >> 2] = (i46 >>> 8) + i46 & 261888 | ((i45 >>> 8) + i45 | 0) >>> 8 | ((i44 >>> 8) + i44 | 0) >>> 8 << 24 | ((i43 >>> 8) + i43 | 0) >>> 8 << 16;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 STACKTOP = i24;
 return;
}

function __ZN14VRSplashScreen23UpdateTagalongTransformEPFvRK11QuaternionfRK8Vector3fS5_E(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, d21 = 0.0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i20 + 64 | 0;
 i13 = i20 + 48 | 0;
 i16 = i20 + 32 | 0;
 i17 = i20 + 16 | 0;
 i18 = i20;
 i19 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 4 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetRotationEv(i10, i19);
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 8 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i13, i8);
 __ZNK9Transform11GetPositionEv(i16, i19);
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i16 + 4 >> 2]));
 f12 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i16 + 8 >> 2]));
 d21 = +__Z19GetTimeSinceStartupv();
 i2 = i6 + 56 | 0;
 f14 = Math_fround(d21 - +HEAPF64[i2 >> 3]);
 HEAPF64[i2 >> 3] = d21;
 i2 = i6 + 45 | 0;
 i15 = (HEAP8[i2 >> 0] | 0) == 0;
 if (i15) {
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP8[i2 >> 0] = 1;
 } else {
  __ZNK9Transform11GetRotationEv(i16, i8);
  f25 = Math_fround(HEAPF32[i10 >> 2]);
  f31 = Math_fround(f25 * Math_fround(2.0));
  f29 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f24 = Math_fround(f29 * Math_fround(2.0));
  f26 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f3 = Math_fround(f26 * Math_fround(2.0));
  f1 = Math_fround(f25 * f31);
  f28 = Math_fround(f29 * f24);
  f26 = Math_fround(f26 * f3);
  f4 = Math_fround(f25 * f24);
  f25 = Math_fround(f25 * f3);
  f29 = Math_fround(f29 * f3);
  f30 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f31 = Math_fround(f31 * f30);
  f24 = Math_fround(f24 * f30);
  f3 = Math_fround(f30 * f3);
  f30 = Math_fround(Math_fround(f25 + f24) + Math_fround(Math_fround(Math_fround(f4 - f3) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f28 + f26)) * Math_fround(0.0))));
  f26 = Math_fround(Math_fround(f29 - f31) + Math_fround(Math_fround(Math_fround(f4 + f3) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f1 + f26)) * Math_fround(0.0))));
  f31 = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f1 + f28)) + Math_fround(Math_fround(Math_fround(f25 - f24) * Math_fround(0.0)) + Math_fround(Math_fround(f29 + f31) * Math_fround(0.0))));
  f29 = Math_fround(HEAPF32[i16 >> 2]);
  f24 = Math_fround(f29 * Math_fround(2.0));
  f25 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f28 = Math_fround(f25 * Math_fround(2.0));
  f1 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f3 = Math_fround(f1 * Math_fround(2.0));
  f4 = Math_fround(f29 * f24);
  f27 = Math_fround(f25 * f28);
  f1 = Math_fround(f1 * f3);
  f23 = Math_fround(f29 * f28);
  f29 = Math_fround(f29 * f3);
  f25 = Math_fround(f25 * f3);
  f32 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  f24 = Math_fround(f24 * f32);
  f28 = Math_fround(f28 * f32);
  f3 = Math_fround(f32 * f3);
  f1 = Math_fround(Math_fround(+Math_acos(+Math_fround(Math_fround(f31 * Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f4 + f27)) + Math_fround(Math_fround(Math_fround(f29 - f28) * Math_fround(0.0)) + Math_fround(Math_fround(f25 + f24) * Math_fround(0.0))))) + Math_fround(Math_fround(f30 * Math_fround(Math_fround(f29 + f28) + Math_fround(Math_fround(Math_fround(f23 - f3) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f27 + f1)) * Math_fround(0.0))))) + Math_fround(f26 * Math_fround(Math_fround(f25 - f24) + Math_fround(Math_fround(Math_fround(f23 + f3) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f4 + f1)) * Math_fround(0.0))))))))) * Math_fround(57.2957763));
  i2 = f1 < Math_fround(7.5);
  f1 = Math_fround(f1 * Math_fround(-.0500000007));
  f1 = i2 ? f1 : Math_fround(.0500000007);
  i2 = i6 + 52 | 0;
  f1 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(f14 * f1));
  i5 = f1 < Math_fround(-.0500000007);
  i22 = f1 > Math_fround(.0500000007);
  f1 = i22 ? Math_fround(.0500000007) : f1;
  f1 = i5 ? Math_fround(-.0500000007) : f1;
  HEAPF32[i2 >> 2] = f1;
  f1 = Math_fround(f14 * f1);
  i5 = i6 + 48 | 0;
  f1 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f1);
  HEAPF32[i5 >> 2] = f1;
  if (f1 < Math_fround(0.0)) {
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   f1 = Math_fround(0.0);
  } else if (f1 > Math_fround(.0500000007)) {
   HEAPF32[i5 >> 2] = Math_fround(.0500000007);
   f1 = Math_fround(.0500000007);
  }
  __Z5SlerpRK11QuaternionfS1_f(i17, i16, i10, f1);
  HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 }
 __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i16, i13, 4);
 HEAPF32[i16 + 8 >> 2] = Math_fround(0.0);
 __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i17, i16, 4);
 HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 f27 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f32 = Math_fround(HEAPF32[i13 >> 2]);
 f4 = Math_fround(f32 * Math_fround(2.0));
 f30 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f31 = Math_fround(f30 * Math_fround(2.0));
 f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f26 = Math_fround(f3 * Math_fround(2.0));
 f28 = Math_fround(f32 * f4);
 f29 = Math_fround(f30 * f31);
 f3 = Math_fround(f3 * f26);
 f25 = Math_fround(f32 * f31);
 f32 = Math_fround(f32 * f26);
 f30 = Math_fround(f30 * f26);
 f1 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f4 = Math_fround(f4 * f1);
 f31 = Math_fround(f31 * f1);
 f26 = Math_fround(f1 * f26);
 f1 = Math_fround(f27 * Math_fround(Math_fround(f32 + f31) + Math_fround(Math_fround(Math_fround(f25 - f26) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f29 + f3)) * Math_fround(0.0)))));
 f3 = Math_fround(f27 * Math_fround(Math_fround(f30 - f4) + Math_fround(Math_fround(Math_fround(f25 + f26) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f28 + f3)) * Math_fround(0.0)))));
 f4 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f28 + f29)) + Math_fround(Math_fround(Math_fround(f32 - f31) * Math_fround(0.0)) + Math_fround(Math_fround(f30 + f4) * Math_fround(0.0)))));
 HEAPF32[i16 >> 2] = f1;
 HEAPF32[i16 + 4 >> 2] = f3;
 HEAPF32[i16 + 8 >> 2] = f4;
 __ZNK9Transform11GetPositionEv(i18, i19);
 f30 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f1);
 f31 = Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) + f3);
 f32 = Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) + f4);
 HEAPF32[i17 >> 2] = f30;
 HEAPF32[i17 + 4 >> 2] = f31;
 HEAPF32[i17 + 8 >> 2] = f32;
 __ZN9Transform16SetLocalPositionERK8Vector3f(i8, i17);
 __ZN9Transform16SetLocalRotationERK11Quaternionf(i8, i13);
 if (!i7) {
  STACKTOP = i20;
  return;
 }
 if (i15) {
  mftCall_viii(i7 | 0, i10 | 0, i16 | 0, gb + 1162364 | 0);
  STACKTOP = i20;
  return;
 } else {
  f31 = Math_fround(f3 - f11);
  f32 = Math_fround(f4 - f12);
  HEAPF32[i17 >> 2] = Math_fround(Math_fround(f1 - f9) / f14);
  HEAPF32[i17 + 4 >> 2] = Math_fround(f31 / f14);
  HEAPF32[i17 + 8 >> 2] = Math_fround(f32 / f14);
  mftCall_viii(i7 | 0, i10 | 0, i16 | 0, i17 | 0);
  STACKTOP = i20;
  return;
 }
}

function __ZN8Material8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i32, i33) {
 i32 = i32 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i35 + 60 | 0;
 i25 = i35 + 48 | 0;
 i34 = i35 + 32 | 0;
 i26 = i35 + 16 | 0;
 i27 = i35;
 __ZN8Material43AddDefaultShaderPropertiesToSavedPropertiesEv(i32);
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i32, i33);
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i32 + 32 | 0, i33);
 i6 = i32 + 80 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i32 + 84 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i31 >> 2] = i1;
 i29 = i33 + 16 | 0;
 i3 = HEAP32[i29 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i30 = i33 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i29 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i29, i31, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i24 = i2 << 24 >> 24 < 0;
 i1 = i24 ? HEAP32[i6 >> 2] | 0 : i6;
 i24 = i24 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i24 | 0;
 if (i24 | 0) do {
  i2 = HEAP32[i29 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i29, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i33);
 i1 = i32 + 96 | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i30 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i29 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i29, i1, 4);
  i3 = HEAP32[i29 >> 2] | 0;
  i4 = HEAP32[i30 >> 2] | 0;
 }
 i1 = i32 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i29 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i29, i1, 4);
 i22 = i34 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i23 = i34 + 12 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i34 + 4 | 0;
 HEAP32[i34 >> 2] = i24;
 i1 = HEAP32[i32 + 100 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = HEAP32[i1 + 176 >> 2] | 0;
  i11 = i1 + 180 | 0;
  if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) i1 = 0; else {
   i12 = i27 + 11 | 0;
   i13 = i27 + 4 | 0;
   i14 = i26 + 12 | 0;
   i10 = i26 + 12 | 0;
   i15 = i31 + 4 | 0;
   i16 = i26 + 8 | 0;
   i17 = i26 + 4 | 0;
   i18 = i31 + 11 | 0;
   i19 = i31 + 4 | 0;
   i20 = i26 + 11 | 0;
   i21 = i31 + 4 | 0;
   do {
    __ZN9shadertag16GetShaderTagNameEi(i27, HEAP32[i2 >> 2] | 0);
    i4 = HEAP8[i12 >> 0] | 0;
    i1 = i4 << 24 >> 24 < 0;
    i3 = i1 ? HEAP32[i27 >> 2] | 0 : i27;
    i4 = i1 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i26 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i14 >> 2] = i1;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i26);
     i1 = HEAP32[i10 >> 2] | 0;
     i28 = 21;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i20 >> 0] = i4;
     if (!i4) i1 = i26; else {
      i1 = i26;
      i28 = 23;
     }
    } else i28 = 21;
    if ((i28 | 0) == 21) {
     i9 = i4 + 16 & -16;
     HEAP32[i31 >> 2] = 66;
     HEAP32[i15 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i26 >> 2] = i1;
     HEAP32[i16 >> 2] = i9 | -2147483648;
     HEAP32[i17 >> 2] = i4;
     i28 = 23;
    }
    if ((i28 | 0) == 23) {
     i28 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i3 = __ZNKSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i34, i31, i26) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     __ZNSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE25__construct_node_with_keyERS6_(i25, i34, i26);
     i4 = HEAP32[i25 >> 2] | 0;
     HEAP32[i25 >> 2] = 0;
     i1 = HEAP32[i31 >> 2] | 0;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i4 + 4 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = i1;
     HEAP32[i3 >> 2] = i4;
     i1 = HEAP32[HEAP32[i34 >> 2] >> 2] | 0;
     if (!i1) i1 = i4; else {
      HEAP32[i34 >> 2] = i1;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i22 >> 2] | 0, i1);
     HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
     i1 = i4;
    }
    i3 = i1 + 32 | 0;
    __ZN9shadertag16GetShaderTagNameEi(i31, HEAP32[i2 + 4 >> 2] | 0);
    i9 = HEAP8[i18 >> 0] | 0;
    i6 = i9 << 24 >> 24 < 0;
    i8 = i6 ? HEAP32[i31 >> 2] | 0 : i31;
    i9 = i6 ? HEAP32[i19 >> 2] | 0 : i9 & 255;
    i6 = i3 + 11 | 0;
    i4 = HEAP8[i6 >> 0] | 0;
    i5 = i4 << 24 >> 24 < 0;
    if (i5) i7 = (HEAP32[i1 + 40 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
    do if (i9 >>> 0 > i7 >>> 0) {
     if (i5) i1 = HEAP32[i1 + 36 >> 2] | 0; else i1 = i4 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i7, i9 - i7 | 0, i1, 0, i1, i9, i8);
    } else {
     if (i5) i3 = HEAP32[i3 >> 2] | 0;
     if (i9 | 0) _memmove(i3 | 0, i8 | 0, i9 | 0) | 0;
     HEAP8[i3 + i9 >> 0] = 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) {
      HEAP32[i1 + 36 >> 2] = i9;
      break;
     } else {
      HEAP8[i6 >> 0] = i9;
      break;
     }
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
    if ((HEAP8[i20 >> 0] | 0) < 0) {
     i9 = HEAP32[i26 >> 2] | 0;
     i8 = HEAP32[i10 >> 2] | 0;
     HEAP32[i31 >> 2] = 66;
     HEAP32[i21 >> 2] = i8;
     __Z19free_alloc_internalPvRK10MemLabelId(i9, i31);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (HEAP32[i11 >> 2] | 0));
   i1 = HEAP32[i23 >> 2] | 0;
  }
 }
 HEAP32[i31 >> 2] = i1;
 i2 = HEAP32[i29 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i29 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i29, i31, 4);
 i1 = HEAP32[i34 >> 2] | 0;
 if ((i1 | 0) == (i24 | 0)) {
  i32 = i32 + 44 | 0;
  __ZN18UnityPropertySheet8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i32, i33);
  i33 = HEAP32[i24 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i34, i33);
  STACKTOP = i35;
  return;
 }
 i2 = i1;
 while (1) {
  __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i2 + 16 | 0, i33);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i24 | 0)) break; else i2 = i1;
 }
 i32 = i32 + 44 | 0;
 __ZN18UnityPropertySheet8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i32, i33);
 i33 = HEAP32[i24 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i34, i33);
 STACKTOP = i35;
 return;
}

function __ZN15QualitySettings14QualitySetting8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i9 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i9 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 80 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 81 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 82 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 83 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 76 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 }
}

function runPostSets154() {
 HEAP32[gb + 141868 >> 2] = (HEAP32[gb + 141868 >> 2] | 0) + (gb + 762698 | 0);
 HEAP32[gb + 141872 >> 2] = (HEAP32[gb + 141872 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141876 >> 2] = (HEAP32[gb + 141876 >> 2] | 0) + (gb + 762728 | 0);
 HEAP32[gb + 141880 >> 2] = (HEAP32[gb + 141880 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141884 >> 2] = (HEAP32[gb + 141884 >> 2] | 0) + (gb + 762759 | 0);
 HEAP32[gb + 141888 >> 2] = (HEAP32[gb + 141888 >> 2] | 0) + (gb + 762798 | 0);
 HEAP32[gb + 141892 >> 2] = (HEAP32[gb + 141892 >> 2] | 0) + (gb + 762803 | 0);
 HEAP32[gb + 141896 >> 2] = (HEAP32[gb + 141896 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141900 >> 2] = (HEAP32[gb + 141900 >> 2] | 0) + (gb + 762832 | 0);
 HEAP32[gb + 141904 >> 2] = (HEAP32[gb + 141904 >> 2] | 0) + (gb + 762861 | 0);
 HEAP32[gb + 141908 >> 2] = (HEAP32[gb + 141908 >> 2] | 0) + (gb + 762875 | 0);
 HEAP32[gb + 141912 >> 2] = (HEAP32[gb + 141912 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141916 >> 2] = (HEAP32[gb + 141916 >> 2] | 0) + (gb + 762912 | 0);
 HEAP32[gb + 141920 >> 2] = (HEAP32[gb + 141920 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 141924 >> 2] = (HEAP32[gb + 141924 >> 2] | 0) + (gb + 762955 | 0);
 HEAP32[gb + 141928 >> 2] = (HEAP32[gb + 141928 >> 2] | 0) + (gb + 761414 | 0);
 HEAP32[gb + 141932 >> 2] = (HEAP32[gb + 141932 >> 2] | 0) + (gb + 762999 | 0);
 HEAP32[gb + 141936 >> 2] = (HEAP32[gb + 141936 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141940 >> 2] = (HEAP32[gb + 141940 >> 2] | 0) + (gb + 763033 | 0);
 HEAP32[gb + 141944 >> 2] = (HEAP32[gb + 141944 >> 2] | 0) + (gb + 758496 | 0);
 HEAP32[gb + 141948 >> 2] = (HEAP32[gb + 141948 >> 2] | 0) + (gb + 763068 | 0);
 HEAP32[gb + 141952 >> 2] = (HEAP32[gb + 141952 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141956 >> 2] = (HEAP32[gb + 141956 >> 2] | 0) + (gb + 763101 | 0);
 HEAP32[gb + 141960 >> 2] = (HEAP32[gb + 141960 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 141964 >> 2] = (HEAP32[gb + 141964 >> 2] | 0) + (gb + 763123 | 0);
 HEAP32[gb + 141968 >> 2] = (HEAP32[gb + 141968 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141972 >> 2] = (HEAP32[gb + 141972 >> 2] | 0) + (gb + 763149 | 0);
 HEAP32[gb + 141976 >> 2] = (HEAP32[gb + 141976 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141980 >> 2] = (HEAP32[gb + 141980 >> 2] | 0) + (gb + 763188 | 0);
 HEAP32[gb + 141984 >> 2] = (HEAP32[gb + 141984 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141988 >> 2] = (HEAP32[gb + 141988 >> 2] | 0) + (gb + 763222 | 0);
 HEAP32[gb + 141992 >> 2] = (HEAP32[gb + 141992 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 141996 >> 2] = (HEAP32[gb + 141996 >> 2] | 0) + (gb + 763257 | 0);
 HEAP32[gb + 142e3 >> 2] = (HEAP32[gb + 142e3 >> 2] | 0) + (gb + 758265 | 0);
 HEAP32[gb + 142004 >> 2] = (HEAP32[gb + 142004 >> 2] | 0) + (gb + 763300 | 0);
 HEAP32[gb + 142008 >> 2] = (HEAP32[gb + 142008 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 142012 >> 2] = (HEAP32[gb + 142012 >> 2] | 0) + (gb + 763334 | 0);
 HEAP32[gb + 142016 >> 2] = (HEAP32[gb + 142016 >> 2] | 0) + (gb + 760326 | 0);
 HEAP32[gb + 142020 >> 2] = (HEAP32[gb + 142020 >> 2] | 0) + (gb + 763368 | 0);
 HEAP32[gb + 142024 >> 2] = (HEAP32[gb + 142024 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142028 >> 2] = (HEAP32[gb + 142028 >> 2] | 0) + (gb + 763405 | 0);
 HEAP32[gb + 142032 >> 2] = (HEAP32[gb + 142032 >> 2] | 0) + (gb + 761370 | 0);
 HEAP32[gb + 142036 >> 2] = (HEAP32[gb + 142036 >> 2] | 0) + (gb + 763448 | 0);
 HEAP32[gb + 142040 >> 2] = (HEAP32[gb + 142040 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 142052 >> 2] = fb + 1920;
 HEAP32[gb + 142056 >> 2] = fb + 1921;
 HEAP32[gb + 142060 >> 2] = fb + 364;
 HEAP32[gb + 142064 >> 2] = fb + 1373;
 HEAP32[gb + 142068 >> 2] = fb + 969;
 HEAP32[gb + 142072 >> 2] = (HEAP32[gb + 142072 >> 2] | 0) + (gb + 757085 | 0);
 HEAP32[gb + 142076 >> 2] = (HEAP32[gb + 142076 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142080 >> 2] = (HEAP32[gb + 142080 >> 2] | 0) + (gb + 757110 | 0);
 HEAP32[gb + 142084 >> 2] = (HEAP32[gb + 142084 >> 2] | 0) + (gb + 757133 | 0);
 HEAP32[gb + 142088 >> 2] = (HEAP32[gb + 142088 >> 2] | 0) + (gb + 757138 | 0);
 HEAP32[gb + 142092 >> 2] = (HEAP32[gb + 142092 >> 2] | 0) + (gb + 757162 | 0);
 HEAP32[gb + 142096 >> 2] = (HEAP32[gb + 142096 >> 2] | 0) + (gb + 756598 | 0);
 HEAP32[gb + 142100 >> 2] = (HEAP32[gb + 142100 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 142104 >> 2] = (HEAP32[gb + 142104 >> 2] | 0) + (gb + 756630 | 0);
 HEAP32[gb + 142108 >> 2] = (HEAP32[gb + 142108 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142112 >> 2] = (HEAP32[gb + 142112 >> 2] | 0) + (gb + 756654 | 0);
 HEAP32[gb + 142116 >> 2] = (HEAP32[gb + 142116 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 142120 >> 2] = (HEAP32[gb + 142120 >> 2] | 0) + (gb + 756693 | 0);
 HEAP32[gb + 142124 >> 2] = (HEAP32[gb + 142124 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 142128 >> 2] = (HEAP32[gb + 142128 >> 2] | 0) + (gb + 756737 | 0);
 HEAP32[gb + 142132 >> 2] = (HEAP32[gb + 142132 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142136 >> 2] = (HEAP32[gb + 142136 >> 2] | 0) + (gb + 756769 | 0);
 HEAP32[gb + 142140 >> 2] = (HEAP32[gb + 142140 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 142144 >> 2] = (HEAP32[gb + 142144 >> 2] | 0) + (gb + 756804 | 0);
 HEAP32[gb + 142148 >> 2] = (HEAP32[gb + 142148 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 142152 >> 2] = (HEAP32[gb + 142152 >> 2] | 0) + (gb + 756842 | 0);
 HEAP32[gb + 142156 >> 2] = (HEAP32[gb + 142156 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142160 >> 2] = (HEAP32[gb + 142160 >> 2] | 0) + (gb + 756875 | 0);
 HEAP32[gb + 142164 >> 2] = (HEAP32[gb + 142164 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142168 >> 2] = (HEAP32[gb + 142168 >> 2] | 0) + (gb + 756911 | 0);
 HEAP32[gb + 142172 >> 2] = (HEAP32[gb + 142172 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142176 >> 2] = (HEAP32[gb + 142176 >> 2] | 0) + (gb + 756945 | 0);
 HEAP32[gb + 142180 >> 2] = (HEAP32[gb + 142180 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142184 >> 2] = (HEAP32[gb + 142184 >> 2] | 0) + (gb + 756981 | 0);
 HEAP32[gb + 142188 >> 2] = (HEAP32[gb + 142188 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142192 >> 2] = (HEAP32[gb + 142192 >> 2] | 0) + (gb + 757012 | 0);
 HEAP32[gb + 142196 >> 2] = (HEAP32[gb + 142196 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 142200 >> 2] = (HEAP32[gb + 142200 >> 2] | 0) + (gb + 757046 | 0);
 HEAP32[gb + 142204 >> 2] = (HEAP32[gb + 142204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142208 >> 2] = (HEAP32[gb + 142208 >> 2] | 0) + (gb + 757165 | 0);
 HEAP32[gb + 142212 >> 2] = (HEAP32[gb + 142212 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142216 >> 2] = (HEAP32[gb + 142216 >> 2] | 0) + (gb + 757192 | 0);
 HEAP32[gb + 142220 >> 2] = (HEAP32[gb + 142220 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142224 >> 2] = (HEAP32[gb + 142224 >> 2] | 0) + (gb + 757218 | 0);
 HEAP32[gb + 142228 >> 2] = (HEAP32[gb + 142228 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142232 >> 2] = (HEAP32[gb + 142232 >> 2] | 0) + (gb + 757241 | 0);
 HEAP32[gb + 142236 >> 2] = (HEAP32[gb + 142236 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142240 >> 2] = (HEAP32[gb + 142240 >> 2] | 0) + (gb + 757269 | 0);
 HEAP32[gb + 142244 >> 2] = (HEAP32[gb + 142244 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 142248 >> 2] = (HEAP32[gb + 142248 >> 2] | 0) + (gb + 757296 | 0);
 HEAP32[gb + 142252 >> 2] = (HEAP32[gb + 142252 >> 2] | 0) + (gb + 757323 | 0);
 HEAP32[gb + 142256 >> 2] = (HEAP32[gb + 142256 >> 2] | 0) + (gb + 757329 | 0);
 HEAP32[gb + 142260 >> 2] = (HEAP32[gb + 142260 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 142264 >> 2] = (HEAP32[gb + 142264 >> 2] | 0) + (gb + 757346 | 0);
 HEAP32[gb + 142268 >> 2] = (HEAP32[gb + 142268 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 142272 >> 2] = (HEAP32[gb + 142272 >> 2] | 0) + (gb + 757386 | 0);
 runPostSets155();
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv(i1, i18, i19, i2, i20, i16) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i13 = i17 + 204 | 0;
 i22 = i17 + 192 | 0;
 i21 = i17 + 180 | 0;
 i14 = i17 + 176 | 0;
 i10 = i17 + 16 | 0;
 i11 = i17 + 8 | 0;
 i12 = i17 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i22 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2804 | 0, i2 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 do if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i23 = 35;
 } else {
  HEAP32[i21 >> 2] = i1;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i21 | 0, gb + 1474556 | 0) | 0;
  i9 = __THREW__;
  __THREW__ = 0;
  if (!(i9 & 1)) {
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, gb + 1077991 | 0, gb + 1077991 + 26 | 0, i13 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (!(i9 & 1)) {
    __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i21 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i9 = i21 + 11 | 0;
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i21 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i21 | 0, i1 | 0, 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
     HEAP32[i14 >> 2] = i2;
     HEAP32[i11 >> 2] = i10;
     HEAP32[i12 >> 2] = 0;
     i7 = i21 + 4 | 0;
     i8 = i21 + 8 | 0;
     i1 = HEAP32[i18 >> 2] | 0;
     L21 : while (1) {
      if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
       __THREW__ = 0;
       i3 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i6 = __THREW__;
       __THREW__ = 0;
       if (i6 & 1) {
        i23 = 37;
        break;
       }
       if ((i3 | 0) == -1) {
        HEAP32[i18 >> 2] = 0;
        i1 = 0;
       }
      }
      i3 = (i1 | 0) == 0;
      i5 = HEAP32[i19 >> 2] | 0;
      do if (!i5) i23 = 25; else {
       if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i3) break; else {
        i23 = 47;
        break L21;
       }
       __THREW__ = 0;
       i4 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
       i6 = __THREW__;
       __THREW__ = 0;
       if (i6 & 1) {
        i23 = 37;
        break L21;
       }
       if ((i4 | 0) == -1) {
        HEAP32[i19 >> 2] = 0;
        i23 = 25;
        break;
       } else if (i3) break; else {
        i23 = 47;
        break L21;
       }
      } while (0);
      if ((i23 | 0) == 25) {
       i23 = 0;
       if (i3) {
        i5 = 0;
        i23 = 47;
        break;
       } else i5 = 0;
      }
      i3 = HEAP8[i9 >> 0] | 0;
      i3 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
      if ((HEAP32[i14 >> 2] | 0) == (i2 + i3 | 0)) {
       __THREW__ = 0;
       invoke_viii(fb + 1039 | 0, i21 | 0, i3 << 1 | 0, 0);
       i6 = __THREW__;
       __THREW__ = 0;
       if (i6 & 1) {
        i23 = 39;
        break;
       }
       if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
       __THREW__ = 0;
       invoke_viii(fb + 1039 | 0, i21 | 0, i2 | 0, 0);
       i6 = __THREW__;
       __THREW__ = 0;
       if (i6 & 1) {
        i23 = 39;
        break;
       }
       i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
       HEAP32[i14 >> 2] = i2 + i3;
      }
      i4 = i1 + 12 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      i6 = i1 + 16 | 0;
      if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
       __THREW__ = 0;
       i3 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (i24 & 1) {
        i23 = 37;
        break;
       }
      } else i3 = HEAPU8[i3 >> 0] | 0;
      if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i3 & 255, 16, i2, i14, i12, 0, i22, i10, i11, i13) | 0) {
       i23 = 47;
       break;
      }
      i3 = HEAP32[i4 >> 2] | 0;
      if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
       __THREW__ = 0;
       invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (i24 & 1) {
        i23 = 37;
        break;
       } else continue;
      } else {
       HEAP32[i4 >> 2] = i3 + 1;
       continue;
      }
     }
     if ((i23 | 0) == 37) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i23 | 0) == 39) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else if ((i23 | 0) == 47) {
      __THREW__ = 0;
      invoke_viii(fb + 1039 | 0, i21 | 0, (HEAP32[i14 >> 2] | 0) - i2 | 0, 0);
      i24 = __THREW__;
      __THREW__ = 0;
      L60 : do if (!(i24 & 1)) {
       i2 = HEAP8[i9 >> 0] | 0;
       i3 = HEAP32[i21 >> 2] | 0;
       __THREW__ = 0;
       i4 = invoke_i(fb + 314 | 0) | 0;
       i24 = __THREW__;
       __THREW__ = 0;
       if (!(i24 & 1)) {
        __THREW__ = 0;
        HEAP32[i15 >> 2] = i16;
        i2 = invoke_iiiii(fb + 200 | 0, (i2 << 24 >> 24 < 0 ? i3 : i21) | 0, i4 | 0, gb + 1078024 | 0, i15 | 0) | 0;
        i24 = __THREW__;
        __THREW__ = 0;
        if (!(i24 & 1)) {
         if ((i2 | 0) != 1) HEAP32[i20 >> 2] = 4;
         if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
          __THREW__ = 0;
          i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
          i24 = __THREW__;
          __THREW__ = 0;
          if (i24 & 1) break;
          if ((i2 | 0) == -1) {
           HEAP32[i18 >> 2] = 0;
           i1 = 0;
          }
         }
         i2 = (i1 | 0) == 0;
         L73 : do if (!i5) i23 = 63; else {
          do if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
           __THREW__ = 0;
           i1 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
           i24 = __THREW__;
           __THREW__ = 0;
           if (i24 & 1) break L60;
           if ((i1 | 0) != -1) break;
           HEAP32[i19 >> 2] = 0;
           i23 = 63;
           break L73;
          } while (0);
          if (!i2) i23 = 64;
         } while (0);
         if ((i23 | 0) == 63) if (i2) i23 = 64;
         if ((i23 | 0) == 64) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 2;
         i24 = HEAP32[i18 >> 2] | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
         STACKTOP = i17;
         return i24 | 0;
        }
       }
      } while (0);
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    break;
   }
  }
  i23 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  i1 = i23;
  i23 = 35;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0;
 i38 = HEAP32[i4 >> 2] | 0;
 i47 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = HEAP32[i38 >> 2] | 0;
 i48 = i38 + 4 | 0;
 i13 = HEAP32[i48 >> 2] | 0;
 i49 = i38 + 8 | 0;
 i12 = HEAP32[i49 >> 2] | 0;
 i7 = HEAP32[i47 >> 2] | 0;
 i39 = i47 + 4 | 0;
 i8 = HEAP32[i39 >> 2] | 0;
 i40 = i47 + 8 | 0;
 i15 = HEAP32[i40 >> 2] | 0;
 i41 = i38 + 16 | 0;
 i9 = HEAP32[i41 >> 2] | 0;
 i42 = i38 + 20 | 0;
 i5 = HEAP32[i42 >> 2] | 0;
 i43 = i38 + 24 | 0;
 i6 = HEAP32[i43 >> 2] | 0;
 i44 = i47 + 16 | 0;
 i1 = HEAP32[i44 >> 2] | 0;
 i45 = i47 + 20 | 0;
 i2 = HEAP32[i45 >> 2] | 0;
 i46 = i47 + 24 | 0;
 i3 = HEAP32[i46 >> 2] | 0;
 i16 = HEAP32[i4 + 16 >> 2] | 0;
 i11 = HEAP16[i16 + 2 >> 1] | 0;
 i37 = i16 + (i11 & 65535) | 0;
 if (!(i11 << 16 >> 16)) {
  i4 = i12;
  i50 = i13;
  i13 = i15;
  i12 = i8;
  i11 = i7;
  i20 = i6;
  i16 = i5;
  i15 = i9;
  i37 = i3;
  i36 = i2;
  i35 = i1;
  HEAP32[i38 >> 2] = i10;
  HEAP32[i48 >> 2] = i50;
  HEAP32[i49 >> 2] = i4;
  HEAP32[i47 >> 2] = i11;
  HEAP32[i39 >> 2] = i12;
  HEAP32[i40 >> 2] = i13;
  HEAP32[i41 >> 2] = i15;
  HEAP32[i42 >> 2] = i16;
  HEAP32[i43 >> 2] = i20;
  HEAP32[i44 >> 2] = i35;
  HEAP32[i45 >> 2] = i36;
  HEAP32[i46 >> 2] = i37;
  return;
 } else {
  i4 = i9;
  i9 = i15;
 }
 while (1) {
  i15 = i16 + 48 | 0;
  i50 = HEAP8[i16 + 1 >> 0] | 0;
  i20 = i50 & 255;
  f14 = Math_fround(HEAPF32[i16 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f19 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  f29 = Math_fround(f14 * f21);
  f30 = Math_fround(f17 * f21);
  f31 = Math_fround(f19 * f21);
  f32 = Math_fround(f14 * f22);
  f33 = Math_fround(f17 * f22);
  f34 = Math_fround(f19 * f22);
  i35 = i20 * 80 | 0;
  i36 = i16 + (i35 + 48) | 0;
  i11 = i16 + ((i11 & 65535) + 32) | 0;
  f27 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(i50 << 24 >> 24)) f14 = Math_fround(0.0); else {
   f18 = Math_fround(Math_fround(Math_fround(f27 * f14) + Math_fround(f25 * f17)) + Math_fround(f23 * f19));
   f17 = Math_fround(Math_fround(Math_fround(f28 * f14) + Math_fround(f26 * f17)) + Math_fround(f24 * f19));
   f14 = Math_fround(0.0);
   i8 = 0;
   while (1) {
    i7 = i8 + 1 | 0;
    f61 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) >> 2]);
    f57 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 4 >> 2]);
    f59 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 8 >> 2]);
    i50 = i15 + (i8 * 80 | 0) + 12 | 0;
    f51 = Math_fround(HEAPF32[i50 >> 2]);
    f55 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 16 >> 2]);
    f60 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 20 >> 2]);
    f65 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 24 >> 2]);
    f19 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 28 >> 2]);
    f58 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 36 >> 2]);
    f66 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 32 >> 2]);
    f64 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 40 >> 2]);
    f63 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f61 = Math_fround(f63 * f61);
    f62 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f57 = Math_fround(f61 + Math_fround(f62 * f57));
    f61 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f59 = Math_fround(f57 + Math_fround(f61 * f59));
    f57 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f55 = Math_fround(f57 * f55);
    f56 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f60 = Math_fround(f55 + Math_fround(f56 * f60));
    f55 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f66 = Math_fround(Math_fround(f19 * f58) - f66);
    f65 = Math_fround(Math_fround(f18 + f59) - Math_fround(f17 + Math_fround(f60 + Math_fround(f55 * f65))));
    f60 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 48 >> 2]);
    f59 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 52 >> 2]);
    f58 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 56 >> 2]);
    f54 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 64 >> 2]);
    f53 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 68 >> 2]);
    f52 = Math_fround(HEAPF32[i15 + (i8 * 80 | 0) + 72 >> 2]);
    f65 = Math_fround(f66 - Math_fround(f19 * f65));
    f19 = Math_fround(-f51);
    f19 = Math_fround(f51 + (f65 > f19 ? f65 : f19));
    f19 = f19 > f64 ? f64 : f19;
    f51 = Math_fround(f19 - f51);
    f60 = Math_fround(f63 + Math_fround(f60 * f51));
    f59 = Math_fround(f62 + Math_fround(f59 * f51));
    f58 = Math_fround(f61 + Math_fround(f58 * f51));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f59, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f58, HEAP32[tempDoublePtr >> 2] | 0);
    f54 = Math_fround(f57 + Math_fround(f54 * f51));
    f53 = Math_fround(f56 + Math_fround(f53 * f51));
    f52 = Math_fround(f55 + Math_fround(f52 * f51));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f53, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
    f18 = Math_fround(f18 + Math_fround(f21 * f51));
    f17 = Math_fround(f17 + Math_fround(f22 * f51));
    f14 = Math_fround(f14 + f51);
    HEAPF32[i50 >> 2] = f19;
    HEAPF32[i11 + (i8 << 2) >> 2] = f19;
    if ((i7 | 0) == (i20 | 0)) break; else i8 = i7;
   }
  }
  f66 = Math_fround(f27 + Math_fround(f29 * f14));
  f65 = Math_fround(f25 + Math_fround(f30 * f14));
  f64 = Math_fround(f23 + Math_fround(f31 * f14));
  i10 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  f64 = Math_fround(f28 + Math_fround(f32 * f14));
  f65 = Math_fround(f26 + Math_fround(f33 * f14));
  f66 = Math_fround(f24 + Math_fround(f34 * f14));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f64, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f65, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f66, HEAP32[tempDoublePtr >> 2] | 0);
  if (i36 >>> 0 >= i37 >>> 0) {
   i11 = i13;
   break;
  }
  i11 = HEAP16[i16 + (i35 + 50) >> 1] | 0;
  i16 = i36;
 }
 HEAP32[i38 >> 2] = i10;
 HEAP32[i48 >> 2] = i11;
 HEAP32[i49 >> 2] = i12;
 HEAP32[i47 >> 2] = i7;
 HEAP32[i39 >> 2] = i8;
 HEAP32[i40 >> 2] = i9;
 HEAP32[i41 >> 2] = i4;
 HEAP32[i42 >> 2] = i5;
 HEAP32[i43 >> 2] = i6;
 HEAP32[i44 >> 2] = i1;
 HEAP32[i45 >> 2] = i2;
 HEAP32[i46 >> 2] = i3;
 return;
}

function __ZN27AnimationLayerMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i27, i24, i23, i28) {
 i27 = i27 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29 + 8 | 0;
 i22 = i29;
 i20 = i29 + 36 | 0;
 i21 = i29 + 24 | 0;
 i6 = gb + 64016 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i25 = i22;
 HEAP32[i25 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i25 + 4 >> 2] = i3;
 HEAP32[i20 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i26, i22);
 i25 = i26;
 i3 = HEAP32[i25 + 4 >> 2] | 0;
 i6 = i20 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = HEAP8[i24 + 33 >> 0] | 0;
 i3 = HEAP16[i24 + 34 >> 1] | 0;
 i25 = i3 & 255;
 i3 = (i3 & 65535) > 255;
 i18 = i27 + 8 | 0;
 i19 = HEAP32[(HEAP32[i18 >> 2] | 0) + 28 >> 2] | 0;
 if ((i19 | 0) == 1) {
  i1 = i27;
  do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!(HEAP32[i1 + 28 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 4 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  } while ((HEAP32[i1 + 16 >> 2] | 0) != 0);
  i3 = HEAP32[i27 + 100 >> 2] | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  if (!i2) i2 = HEAP32[i23 + 8 >> 2] | 0;
  HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  HEAP8[i26 + 4 >> 0] = HEAP8[i3 + 1 >> 0] | 0;
  i4 = i26 + 8 | 0;
  HEAP32[i4 >> 2] = i2;
  i3 = i27 + 120 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) i2 = 0; else i2 = HEAP32[HEAP32[HEAP32[i27 + 80 >> 2] >> 2] >> 2] | 0;
  HEAP32[i26 + 12 >> 2] = i2;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i24 | 0, i26 | 0, i28 | 0);
  if (i5 | 0) __ZN7mecanim12AndValueMaskEPNS_14ValueArrayMaskEPKS0_(HEAP32[(HEAP32[i28 >> 2] | 0) + 4 >> 2] | 0, i5);
  i1 = i25 << 24 >> 24 != 0;
  if (i1) __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseERKNS_6bitsetILj66EEE(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  if (HEAP8[i3 >> 0] | 0) __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE(HEAP32[i28 >> 2] | 0, HEAP32[HEAP32[i27 + 80 >> 2] >> 2] | 0, i6 << 24 >> 24 != 0, i1, HEAP32[i4 >> 2] | 0);
  STACKTOP = i29;
  return;
 }
 __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(HEAP32[(HEAP32[i28 >> 2] | 0) + 4 >> 2] | 0, 1);
 i15 = i6 << 24 >> 24 != 0;
 i16 = i25 << 24 >> 24 == 0;
 i17 = i16 & (i15 ^ 1);
 if (!i17) {
  __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0);
  if (!i16) {
   __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0);
   i1 = HEAP32[(HEAP32[i28 >> 2] | 0) + 16 >> 2] | 0;
   if (i1 | 0) __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(i1);
  }
 }
 if ((i19 | 0) > 0) {
  i14 = i27 + 120 | 0;
  if (!(HEAP8[i14 >> 0] | 0)) {
   i2 = 0;
   i1 = __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE(HEAP32[i24 >> 2] | 0, i15, i25 << 24 >> 24 != 0, i3, i20) | 0;
   i13 = 24;
  } else {
   i12 = 0;
   i1 = 0;
   i9 = 1;
  }
  while (1) {
   if ((i13 | 0) == 24) {
    i13 = 0;
    i12 = i2;
    i9 = HEAP8[i14 >> 0] | 0;
   }
   i2 = i9 << 24 >> 24 == 0;
   if ((i12 | 0) >= (i19 | 0)) break;
   if (!i2) i1 = HEAP32[(HEAP32[i27 + 80 >> 2] | 0) + (i12 << 2) >> 2] | 0;
   i2 = HEAP32[i27 + 100 >> 2] | 0;
   f11 = Math_fround(HEAPF32[(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0) + (i12 << 3) >> 2]);
   if (f11 > Math_fround(0.0)) {
    i6 = HEAP8[i2 + (i12 * 12 | 0) + 1 >> 0] | 0;
    i10 = i6 << 24 >> 24 != 0;
    i7 = (HEAP8[i2 + (i12 * 12 | 0) >> 0] | 0) != 0;
    i8 = HEAP32[i2 + (i12 * 12 | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i2 + (i12 * 12 | 0) + 8 >> 2] | 0;
    if (!i2) i2 = HEAP32[i23 + 8 >> 2] | 0;
    i5 = i12;
    i4 = i27;
    while (1) {
     i3 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i3 + 28 >> 2] | 0) >>> 0 <= i5 >>> 0) {
      i4 = 0;
      break;
     }
     i4 = HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     if (!i4) {
      i4 = 0;
      break;
     }
     if (!(HEAP32[i4 + 16 >> 2] | 0)) break; else i5 = 0;
    }
    HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i26 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    HEAP32[i26 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
    HEAP8[i26 + 4 >> 0] = i6;
    HEAP32[i26 + 8 >> 2] = i2;
    if (!(i9 << 24 >> 24)) i3 = 0; else i3 = HEAP32[HEAP32[HEAP32[i27 + 80 >> 2] >> 2] >> 2] | 0;
    HEAP32[i26 + 12 >> 2] = i3;
    i6 = i22 + 4 | 0;
    HEAP8[i6 >> 0] = 0;
    HEAP32[i22 >> 2] = i1;
    mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 72 >> 2] | 0, i4 | 0, i24 | 0, i26 | 0, i22 | 0);
    i9 = i28 + 4 | 0;
    HEAP8[i9 >> 0] = HEAP8[i9 >> 0] | HEAP8[i6 >> 0];
    if (i8 | 0) __ZN7mecanim12AndValueMaskEPNS_14ValueArrayMaskEPKS0_(HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0, i8);
    i8 = HEAP32[i22 >> 2] | 0;
    i9 = HEAP32[i28 >> 2] | 0;
    __ZN7mecanim13ValueArrayAddEPKNS_10ValueArrayES2_PKNS_14ValueArrayMaskEfbPS0_PS3_(HEAP32[i24 + 4 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, f11, i10, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0);
    if (!(i17 | i10)) __ZN7mecanim9animation22MotionAddOverrideLayerEPNS0_12MotionOutputEPKS1_fbbRKNS_6bitsetILj66EEE(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, f11, i15 & i7, i25 << 24 >> 24 != 0, i2);
    if (!i16) {
     i4 = (HEAP32[i24 + 8 >> 2] | 0) + 20 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i3 = (i3 | 0) == 0 ? 0 : i4 + i3 | 0;
     HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i4 = i21 + 4 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (!(i2 & 33554432)) i13 = 46; else if (!(HEAP8[i3 + 392 >> 0] | 0)) i13 = 46; else i2 = i2 | 33554432;
     if ((i13 | 0) == 46) {
      i13 = 0;
      i2 = i2 & -33554433;
     }
     HEAP32[i4 >> 2] = i2;
     if (!(i2 & 67108864)) i13 = 50; else if (!(HEAP8[i3 + 393 >> 0] | 0)) i13 = 50; else i2 = i2 | 67108864;
     if ((i13 | 0) == 50) i2 = i2 & -67108865;
     HEAP32[i4 >> 2] = i2;
     i2 = HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0;
     i3 = HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0;
     do if (i10) {
      __ZN7mecanim5human25HumanPoseAddAdditiveLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i2, i3, f11, i21);
      i2 = HEAP32[(HEAP32[i28 >> 2] | 0) + 16 >> 2] | 0;
      if (!i2) break;
      if (!(HEAP32[i21 >> 2] & 1)) break;
      __ZN7mecanim5human25HumanPoseAddAdditiveLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i2, HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, f11, i21);
     } else {
      __ZN7mecanim5human25HumanPoseAddOverrideLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i2, i3, f11, i21);
      i2 = HEAP32[(HEAP32[i28 >> 2] | 0) + 16 >> 2] | 0;
      if (!i2) break;
      if (!(HEAP32[i21 >> 2] & 1)) break;
      __ZN7mecanim5human25HumanPoseAddOverrideLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE(i2, HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, f11, i21);
     } while (0);
    }
   }
   i2 = i12 + 1 | 0;
   i13 = 24;
  }
  if (i2) __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(i1, i20);
 }
 __ZN7mecanim15InvertValueMaskEPNS_14ValueArrayMaskE(HEAP32[(HEAP32[i28 >> 2] | 0) + 4 >> 2] | 0);
 STACKTOP = i29;
 return;
}

function __Z10PlayerLoopv() {
 var i1 = 0;
 if (HEAP8[gb + 1546597 >> 0] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 452443 | 0, 0, gb + 452653 | 0, 56, 1, 0, 0, 0);
  return;
 }
 HEAP8[gb + 1546597 >> 0] = 1;
 i1 = (__Z14IsWorldPlayingv() | 0) & 1;
 HEAP8[gb + 1546598 >> 0] = i1;
 i1 = HEAP32[gb + 1115296 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 4 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 8 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 16 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 20 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 24 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 28 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 32 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 36 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 40 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 44 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 48 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 52 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 56 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 60 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 64 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 68 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 72 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 76 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 80 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 84 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 88 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 92 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 96 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 100 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 104 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 108 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 112 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 116 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 120 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 124 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 if (__ZN11TimeManager13StepFixedTimeEv(__Z14GetTimeManagerv() | 0) | 0) do {
  i1 = HEAP32[gb + 1115296 + 128 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 132 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 136 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 140 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 144 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 148 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 152 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 156 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 160 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 164 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
  i1 = HEAP32[gb + 1115296 + 168 >> 2] | 0;
  if (i1 | 0) mftCall_v(i1 | 0);
 } while (__ZN11TimeManager13StepFixedTimeEv(__Z14GetTimeManagerv() | 0) | 0);
 i1 = HEAP32[gb + 1115296 + 172 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 176 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 180 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 184 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 188 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 192 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 196 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 200 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 208 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 212 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 216 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 220 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 224 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 228 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 232 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 236 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 240 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 244 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 248 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 252 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 268 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 272 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 256 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 260 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 264 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 276 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 280 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 284 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 288 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 292 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 296 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 300 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 304 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 308 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 312 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 316 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 320 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 324 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 328 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 332 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 336 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 340 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 344 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 392 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 352 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 356 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 360 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 364 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 368 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 372 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 376 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 380 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 384 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 388 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 HEAP8[gb + 1546597 >> 0] = 0;
 return;
}

function runPostSets245() {
 HEAP32[gb + 13572 >> 2] = (HEAP32[gb + 13572 >> 2] | 0) + (gb + 13536 | 0);
 HEAP32[gb + 13576 >> 2] = (HEAP32[gb + 13576 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13580 >> 2] = (HEAP32[gb + 13580 >> 2] | 0) + (gb + 1085926 | 0);
 HEAP32[gb + 13584 >> 2] = (HEAP32[gb + 13584 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13588 >> 2] = (HEAP32[gb + 13588 >> 2] | 0) + (gb + 1085928 | 0);
 HEAP32[gb + 13596 >> 2] = (HEAP32[gb + 13596 >> 2] | 0) + (gb + 13576 | 0);
 HEAP32[gb + 13600 >> 2] = (HEAP32[gb + 13600 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13604 >> 2] = (HEAP32[gb + 13604 >> 2] | 0) + (gb + 1085931 | 0);
 HEAP32[gb + 13612 >> 2] = (HEAP32[gb + 13612 >> 2] | 0) + (gb + 13576 | 0);
 HEAP32[gb + 13616 >> 2] = (HEAP32[gb + 13616 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13620 >> 2] = (HEAP32[gb + 13620 >> 2] | 0) + (gb + 1085935 | 0);
 HEAP32[gb + 13624 >> 2] = (HEAP32[gb + 13624 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13628 >> 2] = (HEAP32[gb + 13628 >> 2] | 0) + (gb + 1085937 | 0);
 HEAP32[gb + 13636 >> 2] = (HEAP32[gb + 13636 >> 2] | 0) + (gb + 13616 | 0);
 HEAP32[gb + 13640 >> 2] = (HEAP32[gb + 13640 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13644 >> 2] = (HEAP32[gb + 13644 >> 2] | 0) + (gb + 1085940 | 0);
 HEAP32[gb + 13652 >> 2] = (HEAP32[gb + 13652 >> 2] | 0) + (gb + 13616 | 0);
 HEAP32[gb + 13656 >> 2] = (HEAP32[gb + 13656 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13660 >> 2] = (HEAP32[gb + 13660 >> 2] | 0) + (gb + 1085944 | 0);
 HEAP32[gb + 13664 >> 2] = (HEAP32[gb + 13664 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13668 >> 2] = (HEAP32[gb + 13668 >> 2] | 0) + (gb + 1085946 | 0);
 HEAP32[gb + 13676 >> 2] = (HEAP32[gb + 13676 >> 2] | 0) + (gb + 13656 | 0);
 HEAP32[gb + 13680 >> 2] = (HEAP32[gb + 13680 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13684 >> 2] = (HEAP32[gb + 13684 >> 2] | 0) + (gb + 1085949 | 0);
 HEAP32[gb + 13692 >> 2] = (HEAP32[gb + 13692 >> 2] | 0) + (gb + 13656 | 0);
 HEAP32[gb + 13696 >> 2] = (HEAP32[gb + 13696 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13700 >> 2] = (HEAP32[gb + 13700 >> 2] | 0) + (gb + 1085953 | 0);
 HEAP32[gb + 13704 >> 2] = (HEAP32[gb + 13704 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13708 >> 2] = (HEAP32[gb + 13708 >> 2] | 0) + (gb + 1085955 | 0);
 HEAP32[gb + 13716 >> 2] = (HEAP32[gb + 13716 >> 2] | 0) + (gb + 13696 | 0);
 HEAP32[gb + 13720 >> 2] = (HEAP32[gb + 13720 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13724 >> 2] = (HEAP32[gb + 13724 >> 2] | 0) + (gb + 1085958 | 0);
 HEAP32[gb + 13732 >> 2] = (HEAP32[gb + 13732 >> 2] | 0) + (gb + 13696 | 0);
 HEAP32[gb + 13736 >> 2] = (HEAP32[gb + 13736 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13740 >> 2] = (HEAP32[gb + 13740 >> 2] | 0) + (gb + 1085962 | 0);
 HEAP32[gb + 13744 >> 2] = (HEAP32[gb + 13744 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13748 >> 2] = (HEAP32[gb + 13748 >> 2] | 0) + (gb + 1085964 | 0);
 HEAP32[gb + 13756 >> 2] = (HEAP32[gb + 13756 >> 2] | 0) + (gb + 13736 | 0);
 HEAP32[gb + 13760 >> 2] = (HEAP32[gb + 13760 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13764 >> 2] = (HEAP32[gb + 13764 >> 2] | 0) + (gb + 1085967 | 0);
 HEAP32[gb + 13772 >> 2] = (HEAP32[gb + 13772 >> 2] | 0) + (gb + 13736 | 0);
 HEAP32[gb + 13776 >> 2] = (HEAP32[gb + 13776 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13780 >> 2] = (HEAP32[gb + 13780 >> 2] | 0) + (gb + 1085971 | 0);
 HEAP32[gb + 13784 >> 2] = (HEAP32[gb + 13784 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13788 >> 2] = (HEAP32[gb + 13788 >> 2] | 0) + (gb + 1085973 | 0);
 HEAP32[gb + 13796 >> 2] = (HEAP32[gb + 13796 >> 2] | 0) + (gb + 13776 | 0);
 HEAP32[gb + 13800 >> 2] = (HEAP32[gb + 13800 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13804 >> 2] = (HEAP32[gb + 13804 >> 2] | 0) + (gb + 1085976 | 0);
 HEAP32[gb + 13812 >> 2] = (HEAP32[gb + 13812 >> 2] | 0) + (gb + 13776 | 0);
 HEAP32[gb + 13816 >> 2] = (HEAP32[gb + 13816 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13820 >> 2] = (HEAP32[gb + 13820 >> 2] | 0) + (gb + 1085980 | 0);
 HEAP32[gb + 13824 >> 2] = (HEAP32[gb + 13824 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13828 >> 2] = (HEAP32[gb + 13828 >> 2] | 0) + (gb + 1085982 | 0);
 HEAP32[gb + 13836 >> 2] = (HEAP32[gb + 13836 >> 2] | 0) + (gb + 13816 | 0);
 HEAP32[gb + 13840 >> 2] = (HEAP32[gb + 13840 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13844 >> 2] = (HEAP32[gb + 13844 >> 2] | 0) + (gb + 1085985 | 0);
 HEAP32[gb + 13852 >> 2] = (HEAP32[gb + 13852 >> 2] | 0) + (gb + 13816 | 0);
 HEAP32[gb + 13856 >> 2] = (HEAP32[gb + 13856 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13860 >> 2] = (HEAP32[gb + 13860 >> 2] | 0) + (gb + 1085989 | 0);
 HEAP32[gb + 13864 >> 2] = (HEAP32[gb + 13864 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13868 >> 2] = (HEAP32[gb + 13868 >> 2] | 0) + (gb + 1085991 | 0);
 HEAP32[gb + 13876 >> 2] = (HEAP32[gb + 13876 >> 2] | 0) + (gb + 13856 | 0);
 HEAP32[gb + 13880 >> 2] = (HEAP32[gb + 13880 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13884 >> 2] = (HEAP32[gb + 13884 >> 2] | 0) + (gb + 1085994 | 0);
 HEAP32[gb + 13892 >> 2] = (HEAP32[gb + 13892 >> 2] | 0) + (gb + 13856 | 0);
 HEAP32[gb + 13896 >> 2] = (HEAP32[gb + 13896 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13900 >> 2] = (HEAP32[gb + 13900 >> 2] | 0) + (gb + 1085998 | 0);
 HEAP32[gb + 13904 >> 2] = (HEAP32[gb + 13904 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13908 >> 2] = (HEAP32[gb + 13908 >> 2] | 0) + (gb + 1086e3 | 0);
 HEAP32[gb + 13916 >> 2] = (HEAP32[gb + 13916 >> 2] | 0) + (gb + 13896 | 0);
 HEAP32[gb + 13920 >> 2] = (HEAP32[gb + 13920 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13924 >> 2] = (HEAP32[gb + 13924 >> 2] | 0) + (gb + 1086003 | 0);
 HEAP32[gb + 13932 >> 2] = (HEAP32[gb + 13932 >> 2] | 0) + (gb + 13896 | 0);
 HEAP32[gb + 13936 >> 2] = (HEAP32[gb + 13936 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13940 >> 2] = (HEAP32[gb + 13940 >> 2] | 0) + (gb + 1086007 | 0);
 HEAP32[gb + 13944 >> 2] = (HEAP32[gb + 13944 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13948 >> 2] = (HEAP32[gb + 13948 >> 2] | 0) + (gb + 1086009 | 0);
 HEAP32[gb + 13956 >> 2] = (HEAP32[gb + 13956 >> 2] | 0) + (gb + 13936 | 0);
 HEAP32[gb + 13960 >> 2] = (HEAP32[gb + 13960 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13964 >> 2] = (HEAP32[gb + 13964 >> 2] | 0) + (gb + 1086012 | 0);
 HEAP32[gb + 13972 >> 2] = (HEAP32[gb + 13972 >> 2] | 0) + (gb + 13936 | 0);
 HEAP32[gb + 13976 >> 2] = (HEAP32[gb + 13976 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13980 >> 2] = (HEAP32[gb + 13980 >> 2] | 0) + (gb + 1086016 | 0);
 HEAP32[gb + 13984 >> 2] = (HEAP32[gb + 13984 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13988 >> 2] = (HEAP32[gb + 13988 >> 2] | 0) + (gb + 1086018 | 0);
 HEAP32[gb + 13996 >> 2] = (HEAP32[gb + 13996 >> 2] | 0) + (gb + 13976 | 0);
 HEAP32[gb + 14e3 >> 2] = (HEAP32[gb + 14e3 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14004 >> 2] = (HEAP32[gb + 14004 >> 2] | 0) + (gb + 1086021 | 0);
 HEAP32[gb + 14012 >> 2] = (HEAP32[gb + 14012 >> 2] | 0) + (gb + 13976 | 0);
 HEAP32[gb + 14016 >> 2] = (HEAP32[gb + 14016 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14020 >> 2] = (HEAP32[gb + 14020 >> 2] | 0) + (gb + 1086025 | 0);
 HEAP32[gb + 14024 >> 2] = (HEAP32[gb + 14024 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14028 >> 2] = (HEAP32[gb + 14028 >> 2] | 0) + (gb + 1086028 | 0);
 HEAP32[gb + 14036 >> 2] = (HEAP32[gb + 14036 >> 2] | 0) + (gb + 14016 | 0);
 HEAP32[gb + 14040 >> 2] = (HEAP32[gb + 14040 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14044 >> 2] = (HEAP32[gb + 14044 >> 2] | 0) + (gb + 1086032 | 0);
 HEAP32[gb + 14052 >> 2] = (HEAP32[gb + 14052 >> 2] | 0) + (gb + 14016 | 0);
 HEAP32[gb + 14056 >> 2] = (HEAP32[gb + 14056 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14060 >> 2] = (HEAP32[gb + 14060 >> 2] | 0) + (gb + 1086037 | 0);
 HEAP32[gb + 14064 >> 2] = (HEAP32[gb + 14064 >> 2] | 0) + (gb + 216576 | 0);
 runPostSets246();
}

function __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE(i1, i43, i2, i39) {
 i1 = i1 | 0;
 i43 = i43 | 0;
 i2 = i2 | 0;
 i39 = i39 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, i41 = 0, i42 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i44 + 176 | 0;
 i34 = i44 + 152 | 0;
 i35 = i44 + 124 | 0;
 i36 = i44 + 96 | 0;
 i41 = i44 + 32 | 0;
 i42 = i44;
 i3 = HEAP16[i1 + 4 >> 1] | 0;
 if (i3 << 16 >> 16 == 1) i38 = i1; else i38 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 84 >> 2] | 0, i37 | 0, i39 | 0);
 if ((i3 & 65535) > 1) i40 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i2 >> 2] | 0) + 296 >> 2] | 0, i2 | 0, 15)) != Math_fround(0.0); else if (!(i3 << 16 >> 16)) {
  STACKTOP = i44;
  return;
 } else i40 = 0;
 i10 = i36 + 16 | 0;
 i11 = i36 + 20 | 0;
 i12 = i36 + 24 | 0;
 i13 = i37 + 12 | 0;
 i14 = i37 + 4 | 0;
 i15 = i37 + 8 | 0;
 i16 = i37 + 16 | 0;
 i17 = i37 + 20 | 0;
 i18 = i37 + 24 | 0;
 i19 = i36 + 12 | 0;
 i20 = i36 + 8 | 0;
 i21 = i36 + 4 | 0;
 i22 = i35 + 4 | 0;
 i23 = i35 + 8 | 0;
 i24 = i35 + 12 | 0;
 i25 = i35 + 16 | 0;
 i26 = i35 + 20 | 0;
 i27 = i35 + 24 | 0;
 i28 = i34 + 4 | 0;
 i29 = i34 + 8 | 0;
 i30 = i34 + 12 | 0;
 i31 = i34 + 16 | 0;
 i32 = i34 + 20 | 0;
 i33 = i3 & 65535;
 if (i40) {
  i1 = 2122317823;
  i2 = 2122317823;
  i3 = 2122317823;
  i4 = -25165825;
  i5 = -25165825;
  i6 = -25165825;
  i9 = 0;
  do {
   i7 = i38 + (i9 << 2) | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   if (HEAP8[((HEAP32[i8 + 36 >> 2] & 64 | 0) == 0 ? i8 + 112 | 0 : (HEAP32[i8 + 40 >> 2] | 0) + 52 | 0) >> 0] & 8) {
    mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 164 >> 2] | 0, i8 | 0, i43 | 0, i39 | 0);
    i8 = HEAP32[i7 >> 2] | 0;
    if (!(HEAP32[i8 + 36 >> 2] & 1)) i7 = i8 + 116 | 0; else i7 = (HEAP32[i8 + 40 >> 2] | 0) + 56 | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 72 >> 2] | 0, i36 | 0, i8 | 0);
    f55 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
    f53 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(2.0));
    f48 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(2.0));
    f58 = Math_fround(HEAPF32[i13 >> 2]);
    f57 = Math_fround(Math_fround(f58 * f58) + Math_fround(-.5));
    f56 = Math_fround(HEAPF32[i37 >> 2]);
    f45 = Math_fround(f55 * f56);
    f54 = Math_fround(HEAPF32[i14 >> 2]);
    f45 = Math_fround(f45 + Math_fround(f53 * f54));
    f52 = Math_fround(HEAPF32[i15 >> 2]);
    f45 = Math_fround(f45 + Math_fround(f48 * f52));
    f47 = Math_fround(Math_fround(f56 * f45) + Math_fround(Math_fround(f55 * f57) + Math_fround(f58 * Math_fround(Math_fround(f48 * f54) - Math_fround(f53 * f52)))));
    f46 = Math_fround(Math_fround(f54 * f45) + Math_fround(Math_fround(f53 * f57) + Math_fround(f58 * Math_fround(Math_fround(f55 * f52) - Math_fround(f48 * f56)))));
    f45 = Math_fround(Math_fround(Math_fround(f48 * f57) + Math_fround(f58 * Math_fround(Math_fround(f53 * f56) - Math_fround(f55 * f54)))) + Math_fround(f52 * f45));
    f47 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f47);
    f46 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f46);
    f45 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f45);
    f55 = Math_fround(HEAPF32[i36 >> 2]);
    f53 = Math_fround(f58 * f55);
    f57 = Math_fround(HEAPF32[i19 >> 2]);
    f53 = Math_fround(f53 + Math_fround(f56 * f57));
    f48 = Math_fround(HEAPF32[i20 >> 2]);
    f53 = Math_fround(f53 + Math_fround(f54 * f48));
    f51 = Math_fround(HEAPF32[i21 >> 2]);
    f50 = Math_fround(Math_fround(Math_fround(f52 * f55) + Math_fround(Math_fround(f54 * f57) + Math_fround(f58 * f51))) - Math_fround(f56 * f48));
    f49 = Math_fround(Math_fround(Math_fround(f56 * f51) + Math_fround(Math_fround(f52 * f57) + Math_fround(f58 * f48))) - Math_fround(f54 * f55));
    f48 = Math_fround(Math_fround(Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f55)) - Math_fround(f54 * f51)) - Math_fround(f52 * f48));
    HEAPF32[i35 >> 2] = Math_fround(f53 - Math_fround(f52 * f51));
    HEAPF32[i22 >> 2] = f50;
    HEAPF32[i23 >> 2] = f49;
    HEAPF32[i24 >> 2] = f48;
    HEAPF32[i25 >> 2] = f47;
    HEAPF32[i26 >> 2] = f46;
    HEAPF32[i27 >> 2] = f45;
    __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i7, i34, i35, Math_fround(0.0), 0);
    f45 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f46 = Math_fround(HEAPF32[i34 >> 2]);
    f47 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f48 = Math_fround(HEAPF32[i28 >> 2]);
    f49 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f50 = Math_fround(HEAPF32[i29 >> 2]);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f45 < f46 ? f45 : f46, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f47 < f48 ? f47 : f48, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f49 < f50 ? f49 : f50, HEAP32[tempDoublePtr >> 2] | 0);
    f50 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f49 = Math_fround(HEAPF32[i30 >> 2]);
    f48 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f47 = Math_fround(HEAPF32[i31 >> 2]);
    f46 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(HEAPF32[i32 >> 2]);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f50 > f49 ? f50 : f49, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f48 > f47 ? f48 : f47, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f46 > f45 ? f46 : f45, HEAP32[tempDoublePtr >> 2] | 0);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i33 | 0));
 } else {
  i2 = 0;
  do {
   i1 = HEAP32[i38 + (i2 << 2) >> 2] | 0;
   if (HEAP8[((HEAP32[i1 + 36 >> 2] & 64 | 0) == 0 ? i1 + 112 | 0 : (HEAP32[i1 + 40 >> 2] | 0) + 52 | 0) >> 0] & 8) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, i43 | 0, i39 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i33 | 0));
  i6 = -25165825;
  i5 = -25165825;
  i4 = -25165825;
  i3 = 2122317823;
  i2 = 2122317823;
  i1 = 2122317823;
 }
 if (!i40) {
  STACKTOP = i44;
  return;
 }
 f58 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f58 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
  STACKTOP = i44;
  return;
 }
 i43 = __ZN5physx2Cm12RenderOutputlsEj(i43, -65281) | 0;
 HEAPF32[i41 >> 2] = Math_fround(1.0);
 i40 = i41 + 4 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAPF32[i41 + 20 >> 2] = Math_fround(1.0);
 i40 = i41 + 24 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAPF32[i41 + 40 >> 2] = Math_fround(1.0);
 i40 = i41 + 44 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAPF32[i41 + 60 >> 2] = Math_fround(1.0);
 i43 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i43, i41) | 0;
 HEAP32[i42 >> 2] = i1;
 HEAP32[i42 + 4 >> 2] = i2;
 HEAP32[i42 + 8 >> 2] = i3;
 HEAP32[i42 + 12 >> 2] = i4;
 HEAP32[i42 + 16 >> 2] = i5;
 HEAP32[i42 + 20 >> 2] = i6;
 HEAP8[i42 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i43, i42) | 0;
 STACKTOP = i44;
 return;
}

function __ZN13b2PulleyJoint23InitVelocityConstraintsERK12b2SolverData(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0;
 i17 = HEAP32[i18 + 48 >> 2] | 0;
 i29 = HEAP32[i17 + 8 >> 2] | 0;
 i26 = i18 + 120 | 0;
 HEAP32[i26 >> 2] = i29;
 i28 = HEAP32[i18 + 52 >> 2] | 0;
 i33 = HEAP32[i28 + 8 >> 2] | 0;
 i22 = i18 + 124 | 0;
 HEAP32[i22 >> 2] = i33;
 i10 = i17 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i18 + 160 | 0;
 HEAP32[i6 >> 2] = i11;
 HEAP32[i6 + 4 >> 2] = i10;
 i6 = i28 + 28 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = i18 + 168 | 0;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i12 + 4 >> 2] = i6;
 i12 = i18 + 176 | 0;
 HEAP32[i12 >> 2] = HEAP32[i17 + 120 >> 2];
 i16 = i18 + 180 | 0;
 HEAP32[i16 >> 2] = HEAP32[i28 + 120 >> 2];
 i15 = i18 + 184 | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 + 128 >> 2];
 i17 = i18 + 188 | 0;
 HEAP32[i17 >> 2] = HEAP32[i28 + 128 >> 2];
 i28 = HEAP32[i19 + 24 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i28 + (i29 * 12 | 0) >> 2]);
 f2 = Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2]);
 i23 = i19 + 28 | 0;
 i34 = HEAP32[i23 >> 2] | 0;
 i24 = HEAP32[i34 + (i29 * 12 | 0) >> 2] | 0;
 i25 = HEAP32[i34 + (i29 * 12 | 0) + 4 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i34 + (i29 * 12 | 0) + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i28 + (i33 * 12 | 0) >> 2]);
 f5 = Math_fround(HEAPF32[i28 + (i33 * 12 | 0) + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i28 + (i33 * 12 | 0) + 8 >> 2]);
 i28 = HEAP32[i34 + (i33 * 12 | 0) >> 2] | 0;
 i29 = HEAP32[i34 + (i33 * 12 | 0) + 4 >> 2] | 0;
 f30 = Math_fround(HEAPF32[i34 + (i33 * 12 | 0) + 8 >> 2]);
 f20 = Math_fround(+Math_sin(+f7));
 f7 = Math_fround(+Math_cos(+f7));
 f14 = Math_fround(+Math_sin(+f3));
 f3 = Math_fround(+Math_cos(+f3));
 f21 = Math_fround(HEAPF32[i18 + 92 >> 2]);
 f21 = Math_fround(f21 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f32 = Math_fround(HEAPF32[i18 + 96 >> 2]);
 f32 = Math_fround(f32 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f31 = Math_fround(Math_fround(f7 * f21) - Math_fround(f20 * f32));
 f32 = Math_fround(Math_fround(f20 * f21) + Math_fround(f7 * f32));
 HEAPF32[i18 + 144 >> 2] = f31;
 HEAPF32[i18 + 148 >> 2] = f32;
 f7 = Math_fround(HEAPF32[i18 + 100 >> 2]);
 f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f21 = Math_fround(HEAPF32[i18 + 104 >> 2]);
 f21 = Math_fround(f21 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(Math_fround(f3 * f7) - Math_fround(f14 * f21));
 f21 = Math_fround(Math_fround(f14 * f7) + Math_fround(f3 * f21));
 HEAPF32[i18 + 152 >> 2] = f20;
 HEAPF32[i18 + 156 >> 2] = f21;
 f1 = Math_fround(f1 + f31);
 f2 = Math_fround(f2 + f32);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i18 + 68 >> 2]));
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i18 + 72 >> 2]));
 i6 = i18 + 128 | 0;
 HEAPF32[i6 >> 2] = f1;
 i9 = i18 + 132 | 0;
 HEAPF32[i9 >> 2] = f2;
 f4 = Math_fround(f4 + f20);
 f5 = Math_fround(f5 + f21);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i18 + 76 >> 2]));
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i18 + 80 >> 2]));
 i10 = i18 + 136 | 0;
 HEAPF32[i10 >> 2] = f4;
 i11 = i18 + 140 | 0;
 HEAPF32[i11 >> 2] = f5;
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2))));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))));
 if (f3 > Math_fround(.049999997)) {
  f13 = Math_fround(Math_fround(1.0) / f3);
  f14 = Math_fround(f1 * f13);
  HEAPF32[i6 >> 2] = f14;
  f13 = Math_fround(f13 * f2);
 } else {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
 }
 HEAPF32[i9 >> 2] = f13;
 if (f7 > Math_fround(.049999997)) {
  f7 = Math_fround(Math_fround(1.0) / f7);
  f8 = Math_fround(f7 * f4);
  HEAPF32[i10 >> 2] = f8;
  f7 = Math_fround(f7 * f5);
 } else {
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
 }
 HEAPF32[i11 >> 2] = f7;
 f36 = Math_fround(Math_fround(f31 * f13) - Math_fround(f32 * f14));
 f35 = Math_fround(Math_fround(f20 * f7) - Math_fround(f21 * f8));
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f36 = Math_fround(f5 + Math_fround(f36 * Math_fround(f36 * f4)));
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f1 = Math_fround(HEAPF32[i17 >> 2]);
 f35 = Math_fround(f3 + Math_fround(f35 * Math_fround(f35 * f1)));
 f2 = Math_fround(HEAPF32[i18 + 112 >> 2]);
 f35 = Math_fround(f36 + Math_fround(Math_fround(f2 * f2) * f35));
 i34 = f35 > Math_fround(0.0);
 f36 = Math_fround(Math_fround(1.0) / f35);
 HEAPF32[i18 + 192 >> 2] = i34 ? f36 : f35;
 if (!(HEAP8[i19 + 20 >> 0] | 0)) {
  HEAPF32[i18 + 116 >> 2] = Math_fround(0.0);
  f35 = f27;
  f36 = f30;
  i19 = i28;
  i33 = i29;
  i29 = i25;
  i34 = HEAP32[i26 >> 2] | 0;
  i28 = HEAP32[i23 >> 2] | 0;
  i25 = i28 + (i34 * 12 | 0) | 0;
  HEAP32[i25 >> 2] = i24;
  i34 = i28 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i29;
  i34 = HEAP32[i26 >> 2] | 0;
  i29 = HEAP32[i23 >> 2] | 0;
  i34 = i29 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f35;
  i34 = HEAP32[i22 >> 2] | 0;
  i28 = i29 + (i34 * 12 | 0) | 0;
  HEAP32[i28 >> 2] = i19;
  i34 = i29 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i33;
  i34 = HEAP32[i22 >> 2] | 0;
  i33 = HEAP32[i23 >> 2] | 0;
  i34 = i33 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f36;
  return;
 } else {
  f36 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  i19 = i18 + 116 | 0;
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i19 >> 2]));
  HEAPF32[i19 >> 2] = f36;
  f37 = Math_fround(-f36);
  f35 = Math_fround(f14 * f37);
  f13 = Math_fround(f13 * f37);
  f14 = Math_fround(-Math_fround(f36 * f2));
  f36 = Math_fround(f8 * f14);
  f14 = Math_fround(f7 * f14);
  f7 = Math_fround(f35 * f5);
  f8 = Math_fround(f13 * f5);
  f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f7);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f8);
  i34 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  f35 = Math_fround(f27 + Math_fround(f4 * Math_fround(Math_fround(f13 * f31) - Math_fround(f35 * f32))));
  f31 = Math_fround(f36 * f3);
  f32 = Math_fround(f14 * f3);
  f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
  f36 = Math_fround(f30 + Math_fround(f1 * Math_fround(Math_fround(f14 * f20) - Math_fround(f36 * f21))));
  i33 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i29 = i34;
  i34 = HEAP32[i26 >> 2] | 0;
  i28 = HEAP32[i23 >> 2] | 0;
  i24 = i28 + (i34 * 12 | 0) | 0;
  HEAP32[i24 >> 2] = i19;
  i34 = i28 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i29;
  i34 = HEAP32[i26 >> 2] | 0;
  i29 = HEAP32[i23 >> 2] | 0;
  i34 = i29 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f35;
  i34 = HEAP32[i22 >> 2] | 0;
  i28 = i29 + (i34 * 12 | 0) | 0;
  HEAP32[i28 >> 2] = i25;
  i34 = i29 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i33;
  i34 = HEAP32[i22 >> 2] | 0;
  i33 = HEAP32[i23 >> 2] | 0;
  i34 = i33 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f36;
  return;
 }
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_22PxClothCollisionSphereEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i27, i3, i26, i28) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 8 | 0;
 i24 = i29 + 4 | 0;
 i4 = i29;
 HEAP32[i3 >> 2] = 16;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i29;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i28; else {
  HEAP32[gb + 1457196 >> 2] = (HEAP32[gb + 1457196 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = gb + 1576256 | 0;
   i23 = 7;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   if (!i1) {
    i1 = 0;
    i23 = 8;
   } else i23 = 7;
  }
  if ((i23 | 0) == 7) {
   i22 = _strlen(i1) | 0;
   i14 = i1 + i22 | 0;
   if ((i22 | 0) > 0) {
    i15 = i25 + 255 | 0;
    i16 = i25;
    i17 = i25 + 255 | 0;
    i18 = i25;
    i19 = i25 + 255 | 0;
    i20 = i25;
    i21 = i25 + 255 | 0;
    i22 = i25;
    i5 = i1;
    i13 = 0;
    i12 = 0;
    i2 = 0;
    f7 = Math_fround(0.0);
    f8 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f10 = Math_fround(0.0);
    while (1) {
     if (!i5) i11 = 0; else {
      i4 = HEAP8[i5 >> 0] | 0;
      if (!(i4 << 24 >> 24)) i11 = i5; else {
       i3 = i5;
       do {
        if (!(_isspace(i4 & 255) | 0)) break;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i15;
       i4 = HEAP8[i3 >> 0] | 0;
       L23 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L23;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f7 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i16) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L29 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L29;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i17;
       i4 = HEAP8[i3 >> 0] | 0;
       L34 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L34;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f8 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i18) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L40 : do if (!(i4 << 24 >> 24)) i6 = i3; else while (1) {
        if (!(_isspace(i4 & 255) | 0)) {
         i6 = i3;
         break L40;
        }
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
        if (!(i4 << 24 >> 24)) {
         i6 = i3;
         break;
        }
       } while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i19;
       i3 = HEAP8[i6 >> 0] | 0;
       L45 : do if (!(i3 << 24 >> 24)) i3 = i25; else if (!(_isspace(i3 & 255) | 0)) {
        i5 = i6;
        i4 = i25;
        while (1) {
         i3 = i4 + 1 | 0;
         HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
         i5 = i5 + 1 | 0;
         i4 = HEAP8[i5 >> 0] | 0;
         if (!(i4 << 24 >> 24)) break L45;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i3 >>> 0 < i11 >>> 0 & (_isspace(i4 & 255) | 0) == 0)) break; else i4 = i3;
        }
       } else i3 = i25; while (0);
       HEAP8[i3 >> 0] = 0;
       f9 = Math_fround(+_strtod(i25, i24));
       i3 = i6 + ((HEAP32[i24 >> 2] | 0) - i20) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L51 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L51;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i21;
       i4 = HEAP8[i3 >> 0] | 0;
       L56 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L56;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f10 = Math_fround(+_strtod(i25, i24));
       i11 = i3 + ((HEAP32[i24 >> 2] | 0) - i22) | 0;
      }
     }
     i3 = i13 + 16 | 0;
     if (i12 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i4 | 0) | 0;
      if (i13 | 0) _memcpy(i5 | 0, i2 | 0, i13 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else {
      i6 = i2;
      i4 = i12;
     }
     i12 = i6 + i13 | 0;
     HEAPF32[tempDoublePtr >> 2] = f7;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 4) | 0;
     HEAPF32[tempDoublePtr >> 2] = f8;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 8) | 0;
     HEAPF32[tempDoublePtr >> 2] = f9;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i13 = i6 + (i13 | 12) | 0;
     HEAPF32[tempDoublePtr >> 2] = f10;
     HEAP8[i13 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i13 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i13 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i13 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     if (i11 >>> 0 < i14 >>> 0) {
      i5 = i11;
      i13 = i3;
      i12 = i4;
     } else break;
    }
    i4 = i1;
    i3 = i3 >>> 4;
    i1 = i28;
   } else i23 = 8;
  }
  if ((i23 | 0) == 8) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i28;
  }
  HEAP32[i27 >> 2] = i2;
  HEAP32[i26 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, 0);
 STACKTOP = i29;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_21PxClothCollisionPlaneEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i27, i3, i26, i28) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 8 | 0;
 i24 = i29 + 4 | 0;
 i4 = i29;
 HEAP32[i3 >> 2] = 16;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i29;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i28; else {
  HEAP32[gb + 1457192 >> 2] = (HEAP32[gb + 1457192 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = gb + 1576256 | 0;
   i23 = 7;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   if (!i1) {
    i1 = 0;
    i23 = 8;
   } else i23 = 7;
  }
  if ((i23 | 0) == 7) {
   i22 = _strlen(i1) | 0;
   i14 = i1 + i22 | 0;
   if ((i22 | 0) > 0) {
    i15 = i25 + 255 | 0;
    i16 = i25;
    i17 = i25 + 255 | 0;
    i18 = i25;
    i19 = i25 + 255 | 0;
    i20 = i25;
    i21 = i25 + 255 | 0;
    i22 = i25;
    i5 = i1;
    i13 = 0;
    i12 = 0;
    i2 = 0;
    f7 = Math_fround(0.0);
    f8 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f10 = Math_fround(0.0);
    while (1) {
     if (!i5) i11 = 0; else {
      i4 = HEAP8[i5 >> 0] | 0;
      if (!(i4 << 24 >> 24)) i11 = i5; else {
       i3 = i5;
       do {
        if (!(_isspace(i4 & 255) | 0)) break;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i15;
       i4 = HEAP8[i3 >> 0] | 0;
       L23 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L23;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f7 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i16) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L29 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L29;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i17;
       i4 = HEAP8[i3 >> 0] | 0;
       L34 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L34;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f8 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i18) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L40 : do if (!(i4 << 24 >> 24)) i6 = i3; else while (1) {
        if (!(_isspace(i4 & 255) | 0)) {
         i6 = i3;
         break L40;
        }
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
        if (!(i4 << 24 >> 24)) {
         i6 = i3;
         break;
        }
       } while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i19;
       i3 = HEAP8[i6 >> 0] | 0;
       L45 : do if (!(i3 << 24 >> 24)) i3 = i25; else if (!(_isspace(i3 & 255) | 0)) {
        i5 = i6;
        i4 = i25;
        while (1) {
         i3 = i4 + 1 | 0;
         HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
         i5 = i5 + 1 | 0;
         i4 = HEAP8[i5 >> 0] | 0;
         if (!(i4 << 24 >> 24)) break L45;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i3 >>> 0 < i11 >>> 0 & (_isspace(i4 & 255) | 0) == 0)) break; else i4 = i3;
        }
       } else i3 = i25; while (0);
       HEAP8[i3 >> 0] = 0;
       f9 = Math_fround(+_strtod(i25, i24));
       i3 = i6 + ((HEAP32[i24 >> 2] | 0) - i20) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L51 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L51;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i21;
       i4 = HEAP8[i3 >> 0] | 0;
       L56 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L56;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f10 = Math_fround(+_strtod(i25, i24));
       i11 = i3 + ((HEAP32[i24 >> 2] | 0) - i22) | 0;
      }
     }
     i3 = i13 + 16 | 0;
     if (i12 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i4 | 0) | 0;
      if (i13 | 0) _memcpy(i5 | 0, i2 | 0, i13 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else {
      i6 = i2;
      i4 = i12;
     }
     i12 = i6 + i13 | 0;
     HEAPF32[tempDoublePtr >> 2] = f7;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 4) | 0;
     HEAPF32[tempDoublePtr >> 2] = f8;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 8) | 0;
     HEAPF32[tempDoublePtr >> 2] = f9;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i13 = i6 + (i13 | 12) | 0;
     HEAPF32[tempDoublePtr >> 2] = f10;
     HEAP8[i13 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i13 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i13 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i13 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     if (i11 >>> 0 < i14 >>> 0) {
      i5 = i11;
      i13 = i3;
      i12 = i4;
     } else break;
    }
    i4 = i1;
    i3 = i3 >>> 4;
    i1 = i28;
   } else i23 = 8;
  }
  if ((i23 | 0) == 8) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i28;
  }
  HEAP32[i27 >> 2] = i2;
  HEAP32[i26 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, 0);
 STACKTOP = i29;
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation20MoveFilesToCachePathEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 1216 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 64 | 0;
 i12 = i20 + 48 | 0;
 i10 = i20 + 40 | 0;
 i9 = i20 + 24 | 0;
 i7 = i20 + 16 | 0;
 i6 = i20;
 i19 = i20 + 1188 | 0;
 i16 = i20 + 116 | 0;
 i5 = i20 + 1200 | 0;
 i3 = i20 + 1176 | 0;
 i17 = i20 + 92 | 0;
 i14 = i20 + 68 | 0;
 i8 = i20 + 104 | 0;
 i11 = i20 + 80 | 0;
 i4 = i15 + 176 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i15 + 180 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i19 = 1;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i19 >> 2] = 0;
 i18 = i19 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 i1 = HEAP32[gb + 27728 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i1, _strlen(i1) | 0);
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i19 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i19, i16); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i16);
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 12;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __Z17GetCachingManagerv() | 0;
 i2 = i15 + 64 | 0;
 i1 = __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEE(i2, i19) | 0;
 if (!i1) {
  i1 = i15 + 112 | 0;
  i4 = i1 + 11 | 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  HEAP32[i6 >> 2] = i2;
  __Z6FormatPKcz(i5, gb + 368198 | 0, i6);
  i3 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  i2 = i15 + 92 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP32[i2 >> 2] = 3;
   i2 = i15 + 96 | 0;
   if (!i3) {
    if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    __Z6FormatPKcz(i6, gb + 366806 | 0, i7);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i6) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i3 = 0;
 } else {
  i7 = HEAP32[gb + 27728 >> 2] | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i7, _strlen(i7) | 0);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i2, i17);
  __ZN15FileSystemEntryC2EPKc(i16, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i3 = __ZNK15FileSystemEntry4SizeEv(i16) | 0;
  i1 = _i64Add(i3 | 0, getTempRet0() | 0, i1 | 0, 0) | 0;
  getTempRet0() | 0;
  i3 = i15 + 144 | 0;
  __ZN4File4LockENS_8LockModeEb(i3, 8, 0) | 0;
  __ZN4File5CloseEv(i3) | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 444372 | 0, 6);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i17, i2, i14);
  __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i17) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i3 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 1576256 | 0, 0);
  __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i17, i3, i14, 1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i7 = HEAP8[i17 + 11 >> 0] | 0;
  if (!((i7 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i7 & 255) | 0)) {
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   i1 = i15 + 112 | 0;
   i4 = i1 + 11 | 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i3;
   __Z6FormatPKcz(i8, gb + 368262 | 0, i9);
   i3 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   i2 = i15 + 92 | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = 3;
    i2 = i15 + 96 | 0;
    if (!i3) {
     if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i10 >> 2] = i1;
     __Z6FormatPKcz(i9, gb + 366806 | 0, i10);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i9) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 0;
  } else {
   __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i14, i3, i4, 0);
   if (__ZN14CachingManager14MoveTempFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i2, i14) | 0) {
    __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i14);
    __ZN5Cache10AddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, i14, i1);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i14) | 0;
    HEAP8[i15 + 76 >> 0] = 1;
    i1 = 1;
   } else {
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
    i3 = (HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
    i1 = i15 + 112 | 0;
    i5 = i1 + 11 | 0;
    if ((HEAP8[i5 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
    HEAP32[i12 >> 2] = i2;
    HEAP32[i12 + 4 >> 2] = i3;
    HEAP32[i12 + 8 >> 2] = i4;
    __Z6FormatPKcz(i11, gb + 368327 | 0, i12);
    i3 = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
    i2 = i15 + 92 | 0;
    if (!(HEAP32[i2 >> 2] | 0)) {
     HEAP32[i2 >> 2] = 3;
     i2 = i15 + 96 | 0;
     if (!i3) {
      if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
      HEAP32[i13 >> 2] = i1;
      __Z6FormatPKcz(i12, gb + 366806 | 0, i13);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i12) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
     } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    i1 = 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZN13FileEntryDataD2Ev(i16);
  i3 = i1;
 }
 i1 = HEAP32[i19 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i18 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i17 = i2 + -12 | 0;
    HEAP32[i18 >> 2] = i17;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    i2 = HEAP32[i18 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i19 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i19 = i3;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP16[i6 + 152 >> 1] = i3;
 switch (i3 | 0) {
 case 0:
  {
   f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 148 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 32 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 149 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 36 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 150 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 40 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 151 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   STACKTOP = i8;
   return;
  }
 case 4:
 case 1:
  {
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i1 + 8 >> 2] | 0) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i6 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    i1 = i6 + 32 | 0;
    i2 = i2 + 32 | 0;
    i3 = i1 + 40 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    STACKTOP = i8;
    return;
   }
   __ZN8GradientC2Ev(i7);
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   HEAP32[i6 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
   i1 = i6 + 32 | 0;
   i2 = i7 + 32 | 0;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i8;
   return;
  }
 case 2:
  {
   f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 144 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 145 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 20 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 146 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 147 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 148 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 32 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 149 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 36 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 150 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i4 + 40 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i6 + 151 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   STACKTOP = i8;
   return;
  }
 default:
  {
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) {
    i1 = i6 + 72 | 0;
    i5 = 12;
   } else {
    i1 = i6 + 72 | 0;
    if (!(HEAP32[i2 + 8 >> 2] | 0)) i5 = 12; else {
     i2 = HEAP32[i2 + 8 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i6 + 76 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i6 + 80 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i6 + 84 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i6 + 88 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i6 + 92 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i6 + 96 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i6 + 100 >> 2] = HEAP32[i2 + 28 >> 2];
     i1 = i6 + 104 | 0;
     i2 = i2 + 32 | 0;
     i3 = i1 + 40 | 0;
     do {
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      i1 = i1 + 4 | 0;
      i2 = i2 + 4 | 0;
     } while ((i1 | 0) < (i3 | 0));
    }
   }
   if ((i5 | 0) == 12) {
    __ZN8GradientC2Ev(i7);
    HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i6 + 76 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i6 + 80 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i6 + 84 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i6 + 88 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i6 + 92 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i6 + 96 >> 2] = HEAP32[i7 + 24 >> 2];
    HEAP32[i6 + 100 >> 2] = HEAP32[i7 + 28 >> 2];
    i1 = i6 + 104 | 0;
    i2 = i7 + 32 | 0;
    i3 = i1 + 40 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
   }
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   if (i1 | 0) if (HEAP32[i1 + 8 >> 2] | 0) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i6 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    i1 = i6 + 32 | 0;
    i2 = i2 + 32 | 0;
    i3 = i1 + 40 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i1 | 0) < (i3 | 0));
    STACKTOP = i8;
    return;
   }
   __ZN8GradientC2Ev(i7);
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   HEAP32[i6 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
   i1 = i6 + 32 | 0;
   i2 = i7 + 32 | 0;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i27, i3, i26, i28) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 8 | 0;
 i24 = i29 + 4 | 0;
 i4 = i29;
 HEAP32[i3 >> 2] = 16;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i29;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i28; else {
  HEAP32[gb + 1457200 >> 2] = (HEAP32[gb + 1457200 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = gb + 1576256 | 0;
   i23 = 7;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   if (!i1) {
    i1 = 0;
    i23 = 8;
   } else i23 = 7;
  }
  if ((i23 | 0) == 7) {
   i22 = _strlen(i1) | 0;
   i14 = i1 + i22 | 0;
   if ((i22 | 0) > 0) {
    i15 = i25 + 255 | 0;
    i16 = i25;
    i17 = i25 + 255 | 0;
    i18 = i25;
    i19 = i25 + 255 | 0;
    i20 = i25;
    i21 = i25 + 255 | 0;
    i22 = i25;
    i5 = i1;
    i13 = 0;
    i12 = 0;
    i2 = 0;
    f7 = Math_fround(0.0);
    f8 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f10 = Math_fround(0.0);
    while (1) {
     if (!i5) i11 = 0; else {
      i4 = HEAP8[i5 >> 0] | 0;
      if (!(i4 << 24 >> 24)) i11 = i5; else {
       i3 = i5;
       do {
        if (!(_isspace(i4 & 255) | 0)) break;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i15;
       i4 = HEAP8[i3 >> 0] | 0;
       L23 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L23;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f7 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i16) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L29 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L29;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i17;
       i4 = HEAP8[i3 >> 0] | 0;
       L34 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L34;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f8 = Math_fround(+_strtod(i25, i24));
       i3 = i3 + ((HEAP32[i24 >> 2] | 0) - i18) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L40 : do if (!(i4 << 24 >> 24)) i6 = i3; else while (1) {
        if (!(_isspace(i4 & 255) | 0)) {
         i6 = i3;
         break L40;
        }
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
        if (!(i4 << 24 >> 24)) {
         i6 = i3;
         break;
        }
       } while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i19;
       i3 = HEAP8[i6 >> 0] | 0;
       L45 : do if (!(i3 << 24 >> 24)) i3 = i25; else if (!(_isspace(i3 & 255) | 0)) {
        i5 = i6;
        i4 = i25;
        while (1) {
         i3 = i4 + 1 | 0;
         HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
         i5 = i5 + 1 | 0;
         i4 = HEAP8[i5 >> 0] | 0;
         if (!(i4 << 24 >> 24)) break L45;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i3 >>> 0 < i11 >>> 0 & (_isspace(i4 & 255) | 0) == 0)) break; else i4 = i3;
        }
       } else i3 = i25; while (0);
       HEAP8[i3 >> 0] = 0;
       f9 = Math_fround(+_strtod(i25, i24));
       i3 = i6 + ((HEAP32[i24 >> 2] | 0) - i20) | 0;
       i4 = HEAP8[i3 >> 0] | 0;
       L51 : do if (i4 << 24 >> 24) do {
        if (!(_isspace(i4 & 255) | 0)) break L51;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0); while (0);
       _memset(i25 | 0, 0, 256) | 0;
       HEAP32[i24 >> 2] = i21;
       i4 = HEAP8[i3 >> 0] | 0;
       L56 : do if (!(i4 << 24 >> 24)) i4 = i25; else if (!(_isspace(i4 & 255) | 0)) {
        i6 = i3;
        i5 = i25;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
         i6 = i6 + 1 | 0;
         i5 = HEAP8[i6 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L56;
         i11 = HEAP32[i24 >> 2] | 0;
         if (!(i4 >>> 0 < i11 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i25; while (0);
       HEAP8[i4 >> 0] = 0;
       f10 = Math_fround(+_strtod(i25, i24));
       i11 = i3 + ((HEAP32[i24 >> 2] | 0) - i22) | 0;
      }
     }
     i3 = i13 + 16 | 0;
     if (i12 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i28 >> 2] | 0) + 8 >> 2] | 0, i28 | 0, i4 | 0) | 0;
      if (i13 | 0) _memcpy(i5 | 0, i2 | 0, i13 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else {
      i6 = i2;
      i4 = i12;
     }
     i12 = i6 + i13 | 0;
     HEAPF32[tempDoublePtr >> 2] = f7;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 4) | 0;
     HEAPF32[tempDoublePtr >> 2] = f8;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i12 = i6 + (i13 | 8) | 0;
     HEAPF32[tempDoublePtr >> 2] = f9;
     HEAP8[i12 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i12 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i12 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i12 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     i13 = i6 + (i13 | 12) | 0;
     HEAPF32[tempDoublePtr >> 2] = f10;
     HEAP8[i13 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i13 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i13 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i13 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     if (i11 >>> 0 < i14 >>> 0) {
      i5 = i11;
      i13 = i3;
      i12 = i4;
     } else break;
    }
    i4 = i1;
    i3 = i3 >>> 4;
    i1 = i28;
   } else i23 = 8;
  }
  if ((i23 | 0) == 8) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i28;
  }
  HEAP32[i27 >> 2] = i2;
  HEAP32[i26 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, 0);
 STACKTOP = i29;
 return;
}

function runPostSets46() {
 HEAP32[gb + 60744 >> 2] = (HEAP32[gb + 60744 >> 2] | 0) + (gb + 435336 | 0);
 HEAP32[gb + 60748 >> 2] = (HEAP32[gb + 60748 >> 2] | 0) + (gb + 435345 | 0);
 HEAP32[gb + 60752 >> 2] = (HEAP32[gb + 60752 >> 2] | 0) + (gb + 435354 | 0);
 HEAP32[gb + 60756 >> 2] = (HEAP32[gb + 60756 >> 2] | 0) + (gb + 435363 | 0);
 HEAP32[gb + 60760 >> 2] = (HEAP32[gb + 60760 >> 2] | 0) + (gb + 435372 | 0);
 HEAP32[gb + 60764 >> 2] = (HEAP32[gb + 60764 >> 2] | 0) + (gb + 435381 | 0);
 HEAP32[gb + 60768 >> 2] = (HEAP32[gb + 60768 >> 2] | 0) + (gb + 435390 | 0);
 HEAP32[gb + 60772 >> 2] = (HEAP32[gb + 60772 >> 2] | 0) + (gb + 435399 | 0);
 HEAP32[gb + 60776 >> 2] = (HEAP32[gb + 60776 >> 2] | 0) + (gb + 435408 | 0);
 HEAP32[gb + 60780 >> 2] = (HEAP32[gb + 60780 >> 2] | 0) + (gb + 435417 | 0);
 HEAP32[gb + 60784 >> 2] = (HEAP32[gb + 60784 >> 2] | 0) + (gb + 435426 | 0);
 HEAP32[gb + 60788 >> 2] = (HEAP32[gb + 60788 >> 2] | 0) + (gb + 435435 | 0);
 HEAP32[gb + 60792 >> 2] = (HEAP32[gb + 60792 >> 2] | 0) + (gb + 435444 | 0);
 HEAP32[gb + 60796 >> 2] = (HEAP32[gb + 60796 >> 2] | 0) + (gb + 435453 | 0);
 HEAP32[gb + 60800 >> 2] = (HEAP32[gb + 60800 >> 2] | 0) + (gb + 435462 | 0);
 HEAP32[gb + 60804 >> 2] = (HEAP32[gb + 60804 >> 2] | 0) + (gb + 435471 | 0);
 HEAP32[gb + 60808 >> 2] = (HEAP32[gb + 60808 >> 2] | 0) + (gb + 435480 | 0);
 HEAP32[gb + 60812 >> 2] = (HEAP32[gb + 60812 >> 2] | 0) + (gb + 435489 | 0);
 HEAP32[gb + 60816 >> 2] = (HEAP32[gb + 60816 >> 2] | 0) + (gb + 435498 | 0);
 HEAP32[gb + 60820 >> 2] = (HEAP32[gb + 60820 >> 2] | 0) + (gb + 435507 | 0);
 HEAP32[gb + 60824 >> 2] = (HEAP32[gb + 60824 >> 2] | 0) + (gb + 435516 | 0);
 HEAP32[gb + 60828 >> 2] = (HEAP32[gb + 60828 >> 2] | 0) + (gb + 435525 | 0);
 HEAP32[gb + 60832 >> 2] = (HEAP32[gb + 60832 >> 2] | 0) + (gb + 435534 | 0);
 HEAP32[gb + 60836 >> 2] = (HEAP32[gb + 60836 >> 2] | 0) + (gb + 435543 | 0);
 HEAP32[gb + 60840 >> 2] = (HEAP32[gb + 60840 >> 2] | 0) + (gb + 435552 | 0);
 HEAP32[gb + 60844 >> 2] = (HEAP32[gb + 60844 >> 2] | 0) + (gb + 435561 | 0);
 HEAP32[gb + 60848 >> 2] = (HEAP32[gb + 60848 >> 2] | 0) + (gb + 435570 | 0);
 HEAP32[gb + 60852 >> 2] = (HEAP32[gb + 60852 >> 2] | 0) + (gb + 435579 | 0);
 HEAP32[gb + 60856 >> 2] = (HEAP32[gb + 60856 >> 2] | 0) + (gb + 435588 | 0);
 HEAP32[gb + 60860 >> 2] = (HEAP32[gb + 60860 >> 2] | 0) + (gb + 435597 | 0);
 HEAP32[gb + 60864 >> 2] = (HEAP32[gb + 60864 >> 2] | 0) + (gb + 435606 | 0);
 HEAP32[gb + 60868 >> 2] = (HEAP32[gb + 60868 >> 2] | 0) + (gb + 435615 | 0);
 HEAP32[gb + 60872 >> 2] = (HEAP32[gb + 60872 >> 2] | 0) + (gb + 435624 | 0);
 HEAP32[gb + 60876 >> 2] = (HEAP32[gb + 60876 >> 2] | 0) + (gb + 435633 | 0);
 HEAP32[gb + 60880 >> 2] = (HEAP32[gb + 60880 >> 2] | 0) + (gb + 435642 | 0);
 HEAP32[gb + 60884 >> 2] = (HEAP32[gb + 60884 >> 2] | 0) + (gb + 435651 | 0);
 HEAP32[gb + 60888 >> 2] = (HEAP32[gb + 60888 >> 2] | 0) + (gb + 435660 | 0);
 HEAP32[gb + 60892 >> 2] = (HEAP32[gb + 60892 >> 2] | 0) + (gb + 435664 | 0);
 HEAP32[gb + 60896 >> 2] = (HEAP32[gb + 60896 >> 2] | 0) + (gb + 435668 | 0);
 HEAP32[gb + 60900 >> 2] = (HEAP32[gb + 60900 >> 2] | 0) + (gb + 435672 | 0);
 HEAP32[gb + 60904 >> 2] = (HEAP32[gb + 60904 >> 2] | 0) + (gb + 435676 | 0);
 HEAP32[gb + 60908 >> 2] = (HEAP32[gb + 60908 >> 2] | 0) + (gb + 435680 | 0);
 HEAP32[gb + 60912 >> 2] = (HEAP32[gb + 60912 >> 2] | 0) + (gb + 435684 | 0);
 HEAP32[gb + 60916 >> 2] = (HEAP32[gb + 60916 >> 2] | 0) + (gb + 435688 | 0);
 HEAP32[gb + 60920 >> 2] = (HEAP32[gb + 60920 >> 2] | 0) + (gb + 435692 | 0);
 HEAP32[gb + 60924 >> 2] = (HEAP32[gb + 60924 >> 2] | 0) + (gb + 435696 | 0);
 HEAP32[gb + 60928 >> 2] = (HEAP32[gb + 60928 >> 2] | 0) + (gb + 435700 | 0);
 HEAP32[gb + 60932 >> 2] = (HEAP32[gb + 60932 >> 2] | 0) + (gb + 435704 | 0);
 HEAP32[gb + 60936 >> 2] = (HEAP32[gb + 60936 >> 2] | 0) + (gb + 435708 | 0);
 HEAP32[gb + 60940 >> 2] = (HEAP32[gb + 60940 >> 2] | 0) + (gb + 435712 | 0);
 HEAP32[gb + 60944 >> 2] = (HEAP32[gb + 60944 >> 2] | 0) + (gb + 435716 | 0);
 HEAP32[gb + 60948 >> 2] = (HEAP32[gb + 60948 >> 2] | 0) + (gb + 619770 | 0);
 HEAP32[gb + 60952 >> 2] = (HEAP32[gb + 60952 >> 2] | 0) + (gb + 435720 | 0);
 HEAP32[gb + 60956 >> 2] = (HEAP32[gb + 60956 >> 2] | 0) + (gb + 435727 | 0);
 HEAP32[gb + 60960 >> 2] = (HEAP32[gb + 60960 >> 2] | 0) + (gb + 435730 | 0);
 HEAP32[gb + 60964 >> 2] = (HEAP32[gb + 60964 >> 2] | 0) + (gb + 435735 | 0);
 HEAP32[gb + 60968 >> 2] = (HEAP32[gb + 60968 >> 2] | 0) + (gb + 435741 | 0);
 HEAP32[gb + 60972 >> 2] = (HEAP32[gb + 60972 >> 2] | 0) + (gb + 435746 | 0);
 HEAP32[gb + 60976 >> 2] = (HEAP32[gb + 60976 >> 2] | 0) + (gb + 435753 | 0);
 HEAP32[gb + 60980 >> 2] = (HEAP32[gb + 60980 >> 2] | 0) + (gb + 435758 | 0);
 HEAP32[gb + 60984 >> 2] = (HEAP32[gb + 60984 >> 2] | 0) + (gb + 435762 | 0);
 HEAP32[gb + 60988 >> 2] = (HEAP32[gb + 60988 >> 2] | 0) + (gb + 435770 | 0);
 HEAP32[gb + 60992 >> 2] = (HEAP32[gb + 60992 >> 2] | 0) + (gb + 435780 | 0);
 HEAP32[gb + 60996 >> 2] = (HEAP32[gb + 60996 >> 2] | 0) + (gb + 435783 | 0);
 HEAP32[gb + 61e3 >> 2] = (HEAP32[gb + 61e3 >> 2] | 0) + (gb + 435786 | 0);
 HEAP32[gb + 61004 >> 2] = (HEAP32[gb + 61004 >> 2] | 0) + (gb + 435789 | 0);
 HEAP32[gb + 61008 >> 2] = (HEAP32[gb + 61008 >> 2] | 0) + (gb + 435792 | 0);
 HEAP32[gb + 61012 >> 2] = (HEAP32[gb + 61012 >> 2] | 0) + (gb + 435795 | 0);
 HEAP32[gb + 61016 >> 2] = (HEAP32[gb + 61016 >> 2] | 0) + (gb + 435798 | 0);
 HEAP32[gb + 61020 >> 2] = (HEAP32[gb + 61020 >> 2] | 0) + (gb + 435801 | 0);
 HEAP32[gb + 61024 >> 2] = (HEAP32[gb + 61024 >> 2] | 0) + (gb + 435804 | 0);
 HEAP32[gb + 61028 >> 2] = (HEAP32[gb + 61028 >> 2] | 0) + (gb + 435807 | 0);
 HEAP32[gb + 61032 >> 2] = (HEAP32[gb + 61032 >> 2] | 0) + (gb + 435811 | 0);
 HEAP32[gb + 61036 >> 2] = (HEAP32[gb + 61036 >> 2] | 0) + (gb + 435815 | 0);
 HEAP32[gb + 61040 >> 2] = (HEAP32[gb + 61040 >> 2] | 0) + (gb + 435819 | 0);
 HEAP32[gb + 61044 >> 2] = (HEAP32[gb + 61044 >> 2] | 0) + (gb + 435823 | 0);
 HEAP32[gb + 61048 >> 2] = (HEAP32[gb + 61048 >> 2] | 0) + (gb + 435827 | 0);
 HEAP32[gb + 61052 >> 2] = (HEAP32[gb + 61052 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 61056 >> 2] = (HEAP32[gb + 61056 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 61060 >> 2] = (HEAP32[gb + 61060 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 61064 >> 2] = (HEAP32[gb + 61064 >> 2] | 0) + (gb + 435831 | 0);
 HEAP32[gb + 61068 >> 2] = (HEAP32[gb + 61068 >> 2] | 0) + (gb + 435839 | 0);
 HEAP32[gb + 61072 >> 2] = (HEAP32[gb + 61072 >> 2] | 0) + (gb + 435849 | 0);
 HEAP32[gb + 61076 >> 2] = (HEAP32[gb + 61076 >> 2] | 0) + (gb + 435861 | 0);
 HEAP32[gb + 61080 >> 2] = (HEAP32[gb + 61080 >> 2] | 0) + (gb + 435873 | 0);
 HEAP32[gb + 61084 >> 2] = (HEAP32[gb + 61084 >> 2] | 0) + (gb + 435884 | 0);
 HEAP32[gb + 61088 >> 2] = (HEAP32[gb + 61088 >> 2] | 0) + (gb + 435895 | 0);
 HEAP32[gb + 61092 >> 2] = (HEAP32[gb + 61092 >> 2] | 0) + (gb + 435905 | 0);
 HEAP32[gb + 61096 >> 2] = (HEAP32[gb + 61096 >> 2] | 0) + (gb + 435915 | 0);
 HEAP32[gb + 61100 >> 2] = (HEAP32[gb + 61100 >> 2] | 0) + (gb + 435924 | 0);
 HEAP32[gb + 61104 >> 2] = (HEAP32[gb + 61104 >> 2] | 0) + (gb + 435934 | 0);
 HEAP32[gb + 61108 >> 2] = (HEAP32[gb + 61108 >> 2] | 0) + (gb + 435943 | 0);
 HEAP32[gb + 61112 >> 2] = (HEAP32[gb + 61112 >> 2] | 0) + (gb + 435954 | 0);
 HEAP32[gb + 61116 >> 2] = (HEAP32[gb + 61116 >> 2] | 0) + (gb + 435966 | 0);
 HEAP32[gb + 61120 >> 2] = (HEAP32[gb + 61120 >> 2] | 0) + (gb + 435973 | 0);
 HEAP32[gb + 61124 >> 2] = (HEAP32[gb + 61124 >> 2] | 0) + (gb + 435981 | 0);
 HEAP32[gb + 61128 >> 2] = (HEAP32[gb + 61128 >> 2] | 0) + (gb + 435986 | 0);
 HEAP32[gb + 61132 >> 2] = (HEAP32[gb + 61132 >> 2] | 0) + (gb + 435999 | 0);
 HEAP32[gb + 61136 >> 2] = (HEAP32[gb + 61136 >> 2] | 0) + (gb + 436007 | 0);
 HEAP32[gb + 61140 >> 2] = (HEAP32[gb + 61140 >> 2] | 0) + (gb + 436013 | 0);
 runPostSets47();
}

function runPostSets59() {
 HEAP32[gb + 68092 >> 2] = (HEAP32[gb + 68092 >> 2] | 0) + (gb + 473899 | 0);
 HEAP32[gb + 68096 >> 2] = (HEAP32[gb + 68096 >> 2] | 0) + (gb + 473928 | 0);
 HEAP32[gb + 68100 >> 2] = (HEAP32[gb + 68100 >> 2] | 0) + (gb + 473972 | 0);
 HEAP32[gb + 68104 >> 2] = (HEAP32[gb + 68104 >> 2] | 0) + (gb + 473993 | 0);
 HEAP32[gb + 68108 >> 2] = (HEAP32[gb + 68108 >> 2] | 0) + (gb + 474029 | 0);
 HEAP32[gb + 68112 >> 2] = (HEAP32[gb + 68112 >> 2] | 0) + (gb + 474049 | 0);
 HEAP32[gb + 68116 >> 2] = (HEAP32[gb + 68116 >> 2] | 0) + (gb + 474084 | 0);
 HEAP32[gb + 68120 >> 2] = (HEAP32[gb + 68120 >> 2] | 0) + (gb + 474112 | 0);
 HEAP32[gb + 68124 >> 2] = (HEAP32[gb + 68124 >> 2] | 0) + (gb + 474155 | 0);
 HEAP32[gb + 68128 >> 2] = (HEAP32[gb + 68128 >> 2] | 0) + (gb + 474184 | 0);
 HEAP32[gb + 68132 >> 2] = (HEAP32[gb + 68132 >> 2] | 0) + (gb + 474228 | 0);
 HEAP32[gb + 68136 >> 2] = (HEAP32[gb + 68136 >> 2] | 0) + (gb + 474263 | 0);
 HEAP32[gb + 68140 >> 2] = (HEAP32[gb + 68140 >> 2] | 0) + (gb + 474313 | 0);
 HEAP32[gb + 68144 >> 2] = (HEAP32[gb + 68144 >> 2] | 0) + (gb + 474341 | 0);
 HEAP32[gb + 68148 >> 2] = (HEAP32[gb + 68148 >> 2] | 0) + (gb + 474384 | 0);
 HEAP32[gb + 68152 >> 2] = (HEAP32[gb + 68152 >> 2] | 0) + (gb + 474411 | 0);
 HEAP32[gb + 68156 >> 2] = (HEAP32[gb + 68156 >> 2] | 0) + (gb + 474453 | 0);
 HEAP32[gb + 68160 >> 2] = (HEAP32[gb + 68160 >> 2] | 0) + (gb + 474488 | 0);
 HEAP32[gb + 68164 >> 2] = (HEAP32[gb + 68164 >> 2] | 0) + (gb + 474538 | 0);
 HEAP32[gb + 68168 >> 2] = (HEAP32[gb + 68168 >> 2] | 0) + (gb + 474572 | 0);
 HEAP32[gb + 68172 >> 2] = (HEAP32[gb + 68172 >> 2] | 0) + (gb + 474621 | 0);
 HEAP32[gb + 68176 >> 2] = (HEAP32[gb + 68176 >> 2] | 0) + (gb + 474643 | 0);
 HEAP32[gb + 68180 >> 2] = (HEAP32[gb + 68180 >> 2] | 0) + (gb + 474658 | 0);
 HEAP32[gb + 68184 >> 2] = (HEAP32[gb + 68184 >> 2] | 0) + (gb + 474674 | 0);
 HEAP32[gb + 68188 >> 2] = (HEAP32[gb + 68188 >> 2] | 0) + (gb + 474689 | 0);
 HEAP32[gb + 68192 >> 2] = (HEAP32[gb + 68192 >> 2] | 0) + (gb + 472414 | 0);
 HEAP32[gb + 68196 >> 2] = (HEAP32[gb + 68196 >> 2] | 0) + (gb + 474700 | 0);
 HEAP32[gb + 68200 >> 2] = (HEAP32[gb + 68200 >> 2] | 0) + (gb + 472289 | 0);
 HEAP32[gb + 68204 >> 2] = (HEAP32[gb + 68204 >> 2] | 0) + (gb + 474709 | 0);
 HEAP32[gb + 68208 >> 2] = (HEAP32[gb + 68208 >> 2] | 0) + (gb + 472548 | 0);
 HEAP32[gb + 68212 >> 2] = (HEAP32[gb + 68212 >> 2] | 0) + (gb + 474717 | 0);
 HEAP32[gb + 68216 >> 2] = (HEAP32[gb + 68216 >> 2] | 0) + (gb + 472374 | 0);
 HEAP32[gb + 68220 >> 2] = (HEAP32[gb + 68220 >> 2] | 0) + (gb + 474725 | 0);
 HEAP32[gb + 68224 >> 2] = (HEAP32[gb + 68224 >> 2] | 0) + (gb + 472328 | 0);
 HEAP32[gb + 68228 >> 2] = (HEAP32[gb + 68228 >> 2] | 0) + (gb + 474741 | 0);
 HEAP32[gb + 68232 >> 2] = (HEAP32[gb + 68232 >> 2] | 0) + (gb + 472507 | 0);
 HEAP32[gb + 68236 >> 2] = (HEAP32[gb + 68236 >> 2] | 0) + (gb + 474762 | 0);
 HEAP32[gb + 68240 >> 2] = (HEAP32[gb + 68240 >> 2] | 0) + (gb + 472457 | 0);
 HEAP32[gb + 68244 >> 2] = (HEAP32[gb + 68244 >> 2] | 0) + (gb + 474784 | 0);
 HEAP32[gb + 68248 >> 2] = (HEAP32[gb + 68248 >> 2] | 0) + (gb + 473787 | 0);
 HEAP32[gb + 68252 >> 2] = (HEAP32[gb + 68252 >> 2] | 0) + (gb + 474800 | 0);
 HEAP32[gb + 68256 >> 2] = (HEAP32[gb + 68256 >> 2] | 0) + (gb + 474049 | 0);
 HEAP32[gb + 68260 >> 2] = (HEAP32[gb + 68260 >> 2] | 0) + (gb + 474814 | 0);
 HEAP32[gb + 68264 >> 2] = (HEAP32[gb + 68264 >> 2] | 0) + (gb + 473993 | 0);
 HEAP32[gb + 68268 >> 2] = (HEAP32[gb + 68268 >> 2] | 0) + (gb + 474827 | 0);
 HEAP32[gb + 68272 >> 2] = (HEAP32[gb + 68272 >> 2] | 0) + (gb + 473723 | 0);
 HEAP32[gb + 68276 >> 2] = (HEAP32[gb + 68276 >> 2] | 0) + (gb + 474840 | 0);
 HEAP32[gb + 68280 >> 2] = (HEAP32[gb + 68280 >> 2] | 0) + (gb + 474112 | 0);
 HEAP32[gb + 68284 >> 2] = (HEAP32[gb + 68284 >> 2] | 0) + (gb + 474861 | 0);
 HEAP32[gb + 68288 >> 2] = (HEAP32[gb + 68288 >> 2] | 0) + (gb + 473928 | 0);
 HEAP32[gb + 68292 >> 2] = (HEAP32[gb + 68292 >> 2] | 0) + (gb + 474887 | 0);
 HEAP32[gb + 68296 >> 2] = (HEAP32[gb + 68296 >> 2] | 0) + (gb + 473854 | 0);
 HEAP32[gb + 68300 >> 2] = (HEAP32[gb + 68300 >> 2] | 0) + (gb + 474914 | 0);
 HEAP32[gb + 68304 >> 2] = (HEAP32[gb + 68304 >> 2] | 0) + (gb + 472932 | 0);
 HEAP32[gb + 68308 >> 2] = (HEAP32[gb + 68308 >> 2] | 0) + (gb + 474932 | 0);
 HEAP32[gb + 68312 >> 2] = (HEAP32[gb + 68312 >> 2] | 0) + (gb + 472670 | 0);
 HEAP32[gb + 68316 >> 2] = (HEAP32[gb + 68316 >> 2] | 0) + (gb + 474950 | 0);
 HEAP32[gb + 68320 >> 2] = (HEAP32[gb + 68320 >> 2] | 0) + (gb + 473118 | 0);
 HEAP32[gb + 68324 >> 2] = (HEAP32[gb + 68324 >> 2] | 0) + (gb + 474976 | 0);
 HEAP32[gb + 68328 >> 2] = (HEAP32[gb + 68328 >> 2] | 0) + (gb + 472869 | 0);
 HEAP32[gb + 68332 >> 2] = (HEAP32[gb + 68332 >> 2] | 0) + (gb + 475004 | 0);
 HEAP32[gb + 68336 >> 2] = (HEAP32[gb + 68336 >> 2] | 0) + (gb + 472797 | 0);
 HEAP32[gb + 68340 >> 2] = (HEAP32[gb + 68340 >> 2] | 0) + (gb + 475033 | 0);
 HEAP32[gb + 68344 >> 2] = (HEAP32[gb + 68344 >> 2] | 0) + (gb + 475052 | 0);
 HEAP32[gb + 68348 >> 2] = (HEAP32[gb + 68348 >> 2] | 0) + (gb + 475088 | 0);
 HEAP32[gb + 68352 >> 2] = (HEAP32[gb + 68352 >> 2] | 0) + (gb + 475107 | 0);
 HEAP32[gb + 68356 >> 2] = (HEAP32[gb + 68356 >> 2] | 0) + (gb + 475149 | 0);
 HEAP32[gb + 68360 >> 2] = (HEAP32[gb + 68360 >> 2] | 0) + (gb + 475176 | 0);
 HEAP32[gb + 68364 >> 2] = (HEAP32[gb + 68364 >> 2] | 0) + (gb + 475219 | 0);
 HEAP32[gb + 68368 >> 2] = (HEAP32[gb + 68368 >> 2] | 0) + (gb + 475241 | 0);
 HEAP32[gb + 68372 >> 2] = (HEAP32[gb + 68372 >> 2] | 0) + (gb + 475278 | 0);
 HEAP32[gb + 68376 >> 2] = (HEAP32[gb + 68376 >> 2] | 0) + (gb + 475298 | 0);
 HEAP32[gb + 68380 >> 2] = (HEAP32[gb + 68380 >> 2] | 0) + (gb + 475333 | 0);
 HEAP32[gb + 68384 >> 2] = (HEAP32[gb + 68384 >> 2] | 0) + (gb + 475052 | 0);
 HEAP32[gb + 68388 >> 2] = (HEAP32[gb + 68388 >> 2] | 0) + (gb + 475354 | 0);
 HEAP32[gb + 68392 >> 2] = (HEAP32[gb + 68392 >> 2] | 0) + (gb + 475107 | 0);
 HEAP32[gb + 68396 >> 2] = (HEAP32[gb + 68396 >> 2] | 0) + (gb + 475381 | 0);
 HEAP32[gb + 68400 >> 2] = (HEAP32[gb + 68400 >> 2] | 0) + (gb + 475176 | 0);
 HEAP32[gb + 68404 >> 2] = (HEAP32[gb + 68404 >> 2] | 0) + (gb + 475409 | 0);
 HEAP32[gb + 68408 >> 2] = (HEAP32[gb + 68408 >> 2] | 0) + (gb + 475422 | 0);
 HEAP32[gb + 68412 >> 2] = (HEAP32[gb + 68412 >> 2] | 0) + (gb + 475450 | 0);
 HEAP32[gb + 68416 >> 2] = (HEAP32[gb + 68416 >> 2] | 0) + (gb + 473468 | 0);
 HEAP32[gb + 68420 >> 2] = (HEAP32[gb + 68420 >> 2] | 0) + (gb + 475470 | 0);
 HEAP32[gb + 68424 >> 2] = (HEAP32[gb + 68424 >> 2] | 0) + (gb + 473251 | 0);
 HEAP32[gb + 68428 >> 2] = (HEAP32[gb + 68428 >> 2] | 0) + (gb + 475490 | 0);
 HEAP32[gb + 68432 >> 2] = (HEAP32[gb + 68432 >> 2] | 0) + (gb + 473591 | 0);
 HEAP32[gb + 68436 >> 2] = (HEAP32[gb + 68436 >> 2] | 0) + (gb + 475518 | 0);
 HEAP32[gb + 68440 >> 2] = (HEAP32[gb + 68440 >> 2] | 0) + (gb + 473401 | 0);
 HEAP32[gb + 68444 >> 2] = (HEAP32[gb + 68444 >> 2] | 0) + (gb + 475546 | 0);
 HEAP32[gb + 68448 >> 2] = (HEAP32[gb + 68448 >> 2] | 0) + (gb + 473325 | 0);
 HEAP32[gb + 68452 >> 2] = (HEAP32[gb + 68452 >> 2] | 0) + (gb + 475575 | 0);
 HEAP32[gb + 68456 >> 2] = (HEAP32[gb + 68456 >> 2] | 0) + (gb + 472587 | 0);
 HEAP32[gb + 68460 >> 2] = (HEAP32[gb + 68460 >> 2] | 0) + (gb + 475590 | 0);
 HEAP32[gb + 68464 >> 2] = (HEAP32[gb + 68464 >> 2] | 0) + (gb + 475422 | 0);
 HEAP32[gb + 68468 >> 2] = (HEAP32[gb + 68468 >> 2] | 0) + (gb + 475606 | 0);
 HEAP32[gb + 68472 >> 2] = (HEAP32[gb + 68472 >> 2] | 0) + (gb + 472623 | 0);
 HEAP32[gb + 68476 >> 2] = (HEAP32[gb + 68476 >> 2] | 0) + (gb + 475613 | 0);
 HEAP32[gb + 68480 >> 2] = (HEAP32[gb + 68480 >> 2] | 0) + (gb + 931395 | 0);
 HEAP32[gb + 68484 >> 2] = (HEAP32[gb + 68484 >> 2] | 0) + (gb + 475662 | 0);
 HEAP32[gb + 68488 >> 2] = (HEAP32[gb + 68488 >> 2] | 0) + (gb + 931418 | 0);
 runPostSets60();
}

function runPostSets48() {
 HEAP32[gb + 61544 >> 2] = (HEAP32[gb + 61544 >> 2] | 0) + (gb + 437854 | 0);
 HEAP32[gb + 61548 >> 2] = (HEAP32[gb + 61548 >> 2] | 0) + (gb + 437875 | 0);
 HEAP32[gb + 61552 >> 2] = (HEAP32[gb + 61552 >> 2] | 0) + (gb + 437896 | 0);
 HEAP32[gb + 61556 >> 2] = (HEAP32[gb + 61556 >> 2] | 0) + (gb + 437917 | 0);
 HEAP32[gb + 61560 >> 2] = (HEAP32[gb + 61560 >> 2] | 0) + (gb + 437938 | 0);
 HEAP32[gb + 61564 >> 2] = (HEAP32[gb + 61564 >> 2] | 0) + (gb + 437959 | 0);
 HEAP32[gb + 61568 >> 2] = (HEAP32[gb + 61568 >> 2] | 0) + (gb + 437980 | 0);
 HEAP32[gb + 61572 >> 2] = (HEAP32[gb + 61572 >> 2] | 0) + (gb + 438001 | 0);
 HEAP32[gb + 61576 >> 2] = (HEAP32[gb + 61576 >> 2] | 0) + (gb + 438022 | 0);
 HEAP32[gb + 61580 >> 2] = (HEAP32[gb + 61580 >> 2] | 0) + (gb + 438043 | 0);
 HEAP32[gb + 61584 >> 2] = (HEAP32[gb + 61584 >> 2] | 0) + (gb + 438064 | 0);
 HEAP32[gb + 61588 >> 2] = (HEAP32[gb + 61588 >> 2] | 0) + (gb + 438084 | 0);
 HEAP32[gb + 61592 >> 2] = (HEAP32[gb + 61592 >> 2] | 0) + (gb + 438104 | 0);
 HEAP32[gb + 61596 >> 2] = (HEAP32[gb + 61596 >> 2] | 0) + (gb + 438124 | 0);
 HEAP32[gb + 61600 >> 2] = (HEAP32[gb + 61600 >> 2] | 0) + (gb + 438144 | 0);
 HEAP32[gb + 61604 >> 2] = (HEAP32[gb + 61604 >> 2] | 0) + (gb + 438164 | 0);
 HEAP32[gb + 61608 >> 2] = (HEAP32[gb + 61608 >> 2] | 0) + (gb + 438184 | 0);
 HEAP32[gb + 61612 >> 2] = (HEAP32[gb + 61612 >> 2] | 0) + (gb + 438204 | 0);
 HEAP32[gb + 61616 >> 2] = (HEAP32[gb + 61616 >> 2] | 0) + (gb + 438224 | 0);
 HEAP32[gb + 61620 >> 2] = (HEAP32[gb + 61620 >> 2] | 0) + (gb + 438244 | 0);
 HEAP32[gb + 61624 >> 2] = (HEAP32[gb + 61624 >> 2] | 0) + (gb + 438264 | 0);
 HEAP32[gb + 61628 >> 2] = (HEAP32[gb + 61628 >> 2] | 0) + (gb + 438285 | 0);
 HEAP32[gb + 61632 >> 2] = (HEAP32[gb + 61632 >> 2] | 0) + (gb + 438306 | 0);
 HEAP32[gb + 61636 >> 2] = (HEAP32[gb + 61636 >> 2] | 0) + (gb + 438327 | 0);
 HEAP32[gb + 61640 >> 2] = (HEAP32[gb + 61640 >> 2] | 0) + (gb + 438348 | 0);
 HEAP32[gb + 61644 >> 2] = (HEAP32[gb + 61644 >> 2] | 0) + (gb + 438369 | 0);
 HEAP32[gb + 61648 >> 2] = (HEAP32[gb + 61648 >> 2] | 0) + (gb + 438390 | 0);
 HEAP32[gb + 61652 >> 2] = (HEAP32[gb + 61652 >> 2] | 0) + (gb + 438411 | 0);
 HEAP32[gb + 61656 >> 2] = (HEAP32[gb + 61656 >> 2] | 0) + (gb + 438432 | 0);
 HEAP32[gb + 61660 >> 2] = (HEAP32[gb + 61660 >> 2] | 0) + (gb + 438453 | 0);
 HEAP32[gb + 61664 >> 2] = (HEAP32[gb + 61664 >> 2] | 0) + (gb + 438474 | 0);
 HEAP32[gb + 61668 >> 2] = (HEAP32[gb + 61668 >> 2] | 0) + (gb + 438494 | 0);
 HEAP32[gb + 61672 >> 2] = (HEAP32[gb + 61672 >> 2] | 0) + (gb + 438514 | 0);
 HEAP32[gb + 61676 >> 2] = (HEAP32[gb + 61676 >> 2] | 0) + (gb + 438534 | 0);
 HEAP32[gb + 61680 >> 2] = (HEAP32[gb + 61680 >> 2] | 0) + (gb + 438554 | 0);
 HEAP32[gb + 61684 >> 2] = (HEAP32[gb + 61684 >> 2] | 0) + (gb + 438574 | 0);
 HEAP32[gb + 61688 >> 2] = (HEAP32[gb + 61688 >> 2] | 0) + (gb + 438594 | 0);
 HEAP32[gb + 61692 >> 2] = (HEAP32[gb + 61692 >> 2] | 0) + (gb + 438614 | 0);
 HEAP32[gb + 61696 >> 2] = (HEAP32[gb + 61696 >> 2] | 0) + (gb + 438634 | 0);
 HEAP32[gb + 61700 >> 2] = (HEAP32[gb + 61700 >> 2] | 0) + (gb + 438654 | 0);
 HEAP32[gb + 61704 >> 2] = (HEAP32[gb + 61704 >> 2] | 0) + (gb + 438674 | 0);
 HEAP32[gb + 61708 >> 2] = (HEAP32[gb + 61708 >> 2] | 0) + (gb + 438695 | 0);
 HEAP32[gb + 61712 >> 2] = (HEAP32[gb + 61712 >> 2] | 0) + (gb + 438716 | 0);
 HEAP32[gb + 61716 >> 2] = (HEAP32[gb + 61716 >> 2] | 0) + (gb + 438737 | 0);
 HEAP32[gb + 61720 >> 2] = (HEAP32[gb + 61720 >> 2] | 0) + (gb + 438758 | 0);
 HEAP32[gb + 61724 >> 2] = (HEAP32[gb + 61724 >> 2] | 0) + (gb + 438779 | 0);
 HEAP32[gb + 61728 >> 2] = (HEAP32[gb + 61728 >> 2] | 0) + (gb + 438800 | 0);
 HEAP32[gb + 61732 >> 2] = (HEAP32[gb + 61732 >> 2] | 0) + (gb + 438821 | 0);
 HEAP32[gb + 61736 >> 2] = (HEAP32[gb + 61736 >> 2] | 0) + (gb + 438842 | 0);
 HEAP32[gb + 61740 >> 2] = (HEAP32[gb + 61740 >> 2] | 0) + (gb + 438863 | 0);
 HEAP32[gb + 61744 >> 2] = (HEAP32[gb + 61744 >> 2] | 0) + (gb + 438884 | 0);
 HEAP32[gb + 61748 >> 2] = (HEAP32[gb + 61748 >> 2] | 0) + (gb + 438904 | 0);
 HEAP32[gb + 61752 >> 2] = (HEAP32[gb + 61752 >> 2] | 0) + (gb + 438924 | 0);
 HEAP32[gb + 61756 >> 2] = (HEAP32[gb + 61756 >> 2] | 0) + (gb + 438944 | 0);
 HEAP32[gb + 61760 >> 2] = (HEAP32[gb + 61760 >> 2] | 0) + (gb + 438964 | 0);
 HEAP32[gb + 61764 >> 2] = (HEAP32[gb + 61764 >> 2] | 0) + (gb + 438984 | 0);
 HEAP32[gb + 61768 >> 2] = (HEAP32[gb + 61768 >> 2] | 0) + (gb + 439004 | 0);
 HEAP32[gb + 61772 >> 2] = (HEAP32[gb + 61772 >> 2] | 0) + (gb + 439024 | 0);
 HEAP32[gb + 61776 >> 2] = (HEAP32[gb + 61776 >> 2] | 0) + (gb + 439044 | 0);
 HEAP32[gb + 61780 >> 2] = (HEAP32[gb + 61780 >> 2] | 0) + (gb + 439064 | 0);
 HEAP32[gb + 61784 >> 2] = (HEAP32[gb + 61784 >> 2] | 0) + (gb + 439084 | 0);
 HEAP32[gb + 61788 >> 2] = (HEAP32[gb + 61788 >> 2] | 0) + (gb + 439105 | 0);
 HEAP32[gb + 61792 >> 2] = (HEAP32[gb + 61792 >> 2] | 0) + (gb + 439126 | 0);
 HEAP32[gb + 61796 >> 2] = (HEAP32[gb + 61796 >> 2] | 0) + (gb + 439147 | 0);
 HEAP32[gb + 61800 >> 2] = (HEAP32[gb + 61800 >> 2] | 0) + (gb + 439168 | 0);
 HEAP32[gb + 61804 >> 2] = (HEAP32[gb + 61804 >> 2] | 0) + (gb + 439189 | 0);
 HEAP32[gb + 61808 >> 2] = (HEAP32[gb + 61808 >> 2] | 0) + (gb + 439210 | 0);
 HEAP32[gb + 61812 >> 2] = (HEAP32[gb + 61812 >> 2] | 0) + (gb + 439231 | 0);
 HEAP32[gb + 61816 >> 2] = (HEAP32[gb + 61816 >> 2] | 0) + (gb + 439252 | 0);
 HEAP32[gb + 61820 >> 2] = (HEAP32[gb + 61820 >> 2] | 0) + (gb + 439273 | 0);
 HEAP32[gb + 61824 >> 2] = (HEAP32[gb + 61824 >> 2] | 0) + (gb + 439294 | 0);
 HEAP32[gb + 61828 >> 2] = (HEAP32[gb + 61828 >> 2] | 0) + (gb + 439314 | 0);
 HEAP32[gb + 61832 >> 2] = (HEAP32[gb + 61832 >> 2] | 0) + (gb + 439334 | 0);
 HEAP32[gb + 61836 >> 2] = (HEAP32[gb + 61836 >> 2] | 0) + (gb + 439354 | 0);
 HEAP32[gb + 61840 >> 2] = (HEAP32[gb + 61840 >> 2] | 0) + (gb + 439374 | 0);
 HEAP32[gb + 61844 >> 2] = (HEAP32[gb + 61844 >> 2] | 0) + (gb + 439394 | 0);
 HEAP32[gb + 61848 >> 2] = (HEAP32[gb + 61848 >> 2] | 0) + (gb + 439414 | 0);
 HEAP32[gb + 61852 >> 2] = (HEAP32[gb + 61852 >> 2] | 0) + (gb + 439434 | 0);
 HEAP32[gb + 61856 >> 2] = (HEAP32[gb + 61856 >> 2] | 0) + (gb + 439454 | 0);
 HEAP32[gb + 61860 >> 2] = (HEAP32[gb + 61860 >> 2] | 0) + (gb + 439474 | 0);
 HEAP32[gb + 61864 >> 2] = (HEAP32[gb + 61864 >> 2] | 0) + (gb + 439494 | 0);
 HEAP32[gb + 61868 >> 2] = (HEAP32[gb + 61868 >> 2] | 0) + (gb + 439515 | 0);
 HEAP32[gb + 61872 >> 2] = (HEAP32[gb + 61872 >> 2] | 0) + (gb + 439536 | 0);
 HEAP32[gb + 61876 >> 2] = (HEAP32[gb + 61876 >> 2] | 0) + (gb + 439557 | 0);
 HEAP32[gb + 61880 >> 2] = (HEAP32[gb + 61880 >> 2] | 0) + (gb + 439578 | 0);
 HEAP32[gb + 61884 >> 2] = (HEAP32[gb + 61884 >> 2] | 0) + (gb + 439599 | 0);
 HEAP32[gb + 61888 >> 2] = (HEAP32[gb + 61888 >> 2] | 0) + (gb + 439620 | 0);
 HEAP32[gb + 61892 >> 2] = (HEAP32[gb + 61892 >> 2] | 0) + (gb + 439641 | 0);
 HEAP32[gb + 61896 >> 2] = (HEAP32[gb + 61896 >> 2] | 0) + (gb + 439662 | 0);
 HEAP32[gb + 61900 >> 2] = (HEAP32[gb + 61900 >> 2] | 0) + (gb + 439683 | 0);
 HEAP32[gb + 61904 >> 2] = (HEAP32[gb + 61904 >> 2] | 0) + (gb + 439704 | 0);
 HEAP32[gb + 61908 >> 2] = (HEAP32[gb + 61908 >> 2] | 0) + (gb + 439724 | 0);
 HEAP32[gb + 61912 >> 2] = (HEAP32[gb + 61912 >> 2] | 0) + (gb + 439744 | 0);
 HEAP32[gb + 61916 >> 2] = (HEAP32[gb + 61916 >> 2] | 0) + (gb + 439764 | 0);
 HEAP32[gb + 61920 >> 2] = (HEAP32[gb + 61920 >> 2] | 0) + (gb + 439784 | 0);
 HEAP32[gb + 61924 >> 2] = (HEAP32[gb + 61924 >> 2] | 0) + (gb + 439804 | 0);
 HEAP32[gb + 61928 >> 2] = (HEAP32[gb + 61928 >> 2] | 0) + (gb + 439824 | 0);
 HEAP32[gb + 61932 >> 2] = (HEAP32[gb + 61932 >> 2] | 0) + (gb + 439844 | 0);
 HEAP32[gb + 61936 >> 2] = (HEAP32[gb + 61936 >> 2] | 0) + (gb + 439864 | 0);
 HEAP32[gb + 61940 >> 2] = (HEAP32[gb + 61940 >> 2] | 0) + (gb + 439884 | 0);
 runPostSets49();
}

function runPostSets47() {
 HEAP32[gb + 61144 >> 2] = (HEAP32[gb + 61144 >> 2] | 0) + (gb + 436018 | 0);
 HEAP32[gb + 61148 >> 2] = (HEAP32[gb + 61148 >> 2] | 0) + (gb + 436024 | 0);
 HEAP32[gb + 61152 >> 2] = (HEAP32[gb + 61152 >> 2] | 0) + (gb + 436029 | 0);
 HEAP32[gb + 61156 >> 2] = (HEAP32[gb + 61156 >> 2] | 0) + (gb + 436034 | 0);
 HEAP32[gb + 61160 >> 2] = (HEAP32[gb + 61160 >> 2] | 0) + (gb + 436042 | 0);
 HEAP32[gb + 61164 >> 2] = (HEAP32[gb + 61164 >> 2] | 0) + (gb + 436050 | 0);
 HEAP32[gb + 61168 >> 2] = (HEAP32[gb + 61168 >> 2] | 0) + (gb + 436058 | 0);
 HEAP32[gb + 61172 >> 2] = (HEAP32[gb + 61172 >> 2] | 0) + (gb + 436066 | 0);
 HEAP32[gb + 61176 >> 2] = (HEAP32[gb + 61176 >> 2] | 0) + (gb + 436074 | 0);
 HEAP32[gb + 61180 >> 2] = (HEAP32[gb + 61180 >> 2] | 0) + (gb + 436082 | 0);
 HEAP32[gb + 61184 >> 2] = (HEAP32[gb + 61184 >> 2] | 0) + (gb + 434550 | 0);
 HEAP32[gb + 61188 >> 2] = (HEAP32[gb + 61188 >> 2] | 0) + (gb + 434582 | 0);
 HEAP32[gb + 61192 >> 2] = (HEAP32[gb + 61192 >> 2] | 0) + (gb + 436090 | 0);
 HEAP32[gb + 61196 >> 2] = (HEAP32[gb + 61196 >> 2] | 0) + (gb + 436108 | 0);
 HEAP32[gb + 61200 >> 2] = (HEAP32[gb + 61200 >> 2] | 0) + (gb + 436126 | 0);
 HEAP32[gb + 61204 >> 2] = (HEAP32[gb + 61204 >> 2] | 0) + (gb + 436144 | 0);
 HEAP32[gb + 61208 >> 2] = (HEAP32[gb + 61208 >> 2] | 0) + (gb + 436162 | 0);
 HEAP32[gb + 61212 >> 2] = (HEAP32[gb + 61212 >> 2] | 0) + (gb + 436180 | 0);
 HEAP32[gb + 61216 >> 2] = (HEAP32[gb + 61216 >> 2] | 0) + (gb + 436198 | 0);
 HEAP32[gb + 61220 >> 2] = (HEAP32[gb + 61220 >> 2] | 0) + (gb + 436216 | 0);
 HEAP32[gb + 61224 >> 2] = (HEAP32[gb + 61224 >> 2] | 0) + (gb + 436234 | 0);
 HEAP32[gb + 61228 >> 2] = (HEAP32[gb + 61228 >> 2] | 0) + (gb + 436253 | 0);
 HEAP32[gb + 61232 >> 2] = (HEAP32[gb + 61232 >> 2] | 0) + (gb + 436272 | 0);
 HEAP32[gb + 61236 >> 2] = (HEAP32[gb + 61236 >> 2] | 0) + (gb + 436291 | 0);
 HEAP32[gb + 61240 >> 2] = (HEAP32[gb + 61240 >> 2] | 0) + (gb + 436310 | 0);
 HEAP32[gb + 61244 >> 2] = (HEAP32[gb + 61244 >> 2] | 0) + (gb + 436329 | 0);
 HEAP32[gb + 61248 >> 2] = (HEAP32[gb + 61248 >> 2] | 0) + (gb + 436348 | 0);
 HEAP32[gb + 61252 >> 2] = (HEAP32[gb + 61252 >> 2] | 0) + (gb + 436367 | 0);
 HEAP32[gb + 61256 >> 2] = (HEAP32[gb + 61256 >> 2] | 0) + (gb + 436386 | 0);
 HEAP32[gb + 61260 >> 2] = (HEAP32[gb + 61260 >> 2] | 0) + (gb + 436405 | 0);
 HEAP32[gb + 61264 >> 2] = (HEAP32[gb + 61264 >> 2] | 0) + (gb + 436424 | 0);
 HEAP32[gb + 61268 >> 2] = (HEAP32[gb + 61268 >> 2] | 0) + (gb + 436444 | 0);
 HEAP32[gb + 61272 >> 2] = (HEAP32[gb + 61272 >> 2] | 0) + (gb + 436464 | 0);
 HEAP32[gb + 61276 >> 2] = (HEAP32[gb + 61276 >> 2] | 0) + (gb + 436484 | 0);
 HEAP32[gb + 61280 >> 2] = (HEAP32[gb + 61280 >> 2] | 0) + (gb + 436504 | 0);
 HEAP32[gb + 61284 >> 2] = (HEAP32[gb + 61284 >> 2] | 0) + (gb + 436524 | 0);
 HEAP32[gb + 61288 >> 2] = (HEAP32[gb + 61288 >> 2] | 0) + (gb + 436544 | 0);
 HEAP32[gb + 61292 >> 2] = (HEAP32[gb + 61292 >> 2] | 0) + (gb + 436564 | 0);
 HEAP32[gb + 61296 >> 2] = (HEAP32[gb + 61296 >> 2] | 0) + (gb + 436584 | 0);
 HEAP32[gb + 61300 >> 2] = (HEAP32[gb + 61300 >> 2] | 0) + (gb + 436604 | 0);
 HEAP32[gb + 61304 >> 2] = (HEAP32[gb + 61304 >> 2] | 0) + (gb + 436624 | 0);
 HEAP32[gb + 61308 >> 2] = (HEAP32[gb + 61308 >> 2] | 0) + (gb + 436645 | 0);
 HEAP32[gb + 61312 >> 2] = (HEAP32[gb + 61312 >> 2] | 0) + (gb + 436666 | 0);
 HEAP32[gb + 61316 >> 2] = (HEAP32[gb + 61316 >> 2] | 0) + (gb + 436687 | 0);
 HEAP32[gb + 61320 >> 2] = (HEAP32[gb + 61320 >> 2] | 0) + (gb + 436708 | 0);
 HEAP32[gb + 61324 >> 2] = (HEAP32[gb + 61324 >> 2] | 0) + (gb + 436729 | 0);
 HEAP32[gb + 61328 >> 2] = (HEAP32[gb + 61328 >> 2] | 0) + (gb + 436750 | 0);
 HEAP32[gb + 61332 >> 2] = (HEAP32[gb + 61332 >> 2] | 0) + (gb + 436771 | 0);
 HEAP32[gb + 61336 >> 2] = (HEAP32[gb + 61336 >> 2] | 0) + (gb + 436792 | 0);
 HEAP32[gb + 61340 >> 2] = (HEAP32[gb + 61340 >> 2] | 0) + (gb + 436813 | 0);
 HEAP32[gb + 61344 >> 2] = (HEAP32[gb + 61344 >> 2] | 0) + (gb + 436834 | 0);
 HEAP32[gb + 61348 >> 2] = (HEAP32[gb + 61348 >> 2] | 0) + (gb + 436854 | 0);
 HEAP32[gb + 61352 >> 2] = (HEAP32[gb + 61352 >> 2] | 0) + (gb + 436874 | 0);
 HEAP32[gb + 61356 >> 2] = (HEAP32[gb + 61356 >> 2] | 0) + (gb + 436894 | 0);
 HEAP32[gb + 61360 >> 2] = (HEAP32[gb + 61360 >> 2] | 0) + (gb + 436914 | 0);
 HEAP32[gb + 61364 >> 2] = (HEAP32[gb + 61364 >> 2] | 0) + (gb + 436934 | 0);
 HEAP32[gb + 61368 >> 2] = (HEAP32[gb + 61368 >> 2] | 0) + (gb + 436954 | 0);
 HEAP32[gb + 61372 >> 2] = (HEAP32[gb + 61372 >> 2] | 0) + (gb + 436974 | 0);
 HEAP32[gb + 61376 >> 2] = (HEAP32[gb + 61376 >> 2] | 0) + (gb + 436994 | 0);
 HEAP32[gb + 61380 >> 2] = (HEAP32[gb + 61380 >> 2] | 0) + (gb + 437014 | 0);
 HEAP32[gb + 61384 >> 2] = (HEAP32[gb + 61384 >> 2] | 0) + (gb + 437034 | 0);
 HEAP32[gb + 61388 >> 2] = (HEAP32[gb + 61388 >> 2] | 0) + (gb + 437055 | 0);
 HEAP32[gb + 61392 >> 2] = (HEAP32[gb + 61392 >> 2] | 0) + (gb + 437076 | 0);
 HEAP32[gb + 61396 >> 2] = (HEAP32[gb + 61396 >> 2] | 0) + (gb + 437097 | 0);
 HEAP32[gb + 61400 >> 2] = (HEAP32[gb + 61400 >> 2] | 0) + (gb + 437118 | 0);
 HEAP32[gb + 61404 >> 2] = (HEAP32[gb + 61404 >> 2] | 0) + (gb + 437139 | 0);
 HEAP32[gb + 61408 >> 2] = (HEAP32[gb + 61408 >> 2] | 0) + (gb + 437160 | 0);
 HEAP32[gb + 61412 >> 2] = (HEAP32[gb + 61412 >> 2] | 0) + (gb + 437181 | 0);
 HEAP32[gb + 61416 >> 2] = (HEAP32[gb + 61416 >> 2] | 0) + (gb + 437202 | 0);
 HEAP32[gb + 61420 >> 2] = (HEAP32[gb + 61420 >> 2] | 0) + (gb + 437223 | 0);
 HEAP32[gb + 61424 >> 2] = (HEAP32[gb + 61424 >> 2] | 0) + (gb + 437244 | 0);
 HEAP32[gb + 61428 >> 2] = (HEAP32[gb + 61428 >> 2] | 0) + (gb + 437264 | 0);
 HEAP32[gb + 61432 >> 2] = (HEAP32[gb + 61432 >> 2] | 0) + (gb + 437284 | 0);
 HEAP32[gb + 61436 >> 2] = (HEAP32[gb + 61436 >> 2] | 0) + (gb + 437304 | 0);
 HEAP32[gb + 61440 >> 2] = (HEAP32[gb + 61440 >> 2] | 0) + (gb + 437324 | 0);
 HEAP32[gb + 61444 >> 2] = (HEAP32[gb + 61444 >> 2] | 0) + (gb + 437344 | 0);
 HEAP32[gb + 61448 >> 2] = (HEAP32[gb + 61448 >> 2] | 0) + (gb + 437364 | 0);
 HEAP32[gb + 61452 >> 2] = (HEAP32[gb + 61452 >> 2] | 0) + (gb + 437384 | 0);
 HEAP32[gb + 61456 >> 2] = (HEAP32[gb + 61456 >> 2] | 0) + (gb + 437404 | 0);
 HEAP32[gb + 61460 >> 2] = (HEAP32[gb + 61460 >> 2] | 0) + (gb + 437424 | 0);
 HEAP32[gb + 61464 >> 2] = (HEAP32[gb + 61464 >> 2] | 0) + (gb + 437444 | 0);
 HEAP32[gb + 61468 >> 2] = (HEAP32[gb + 61468 >> 2] | 0) + (gb + 437465 | 0);
 HEAP32[gb + 61472 >> 2] = (HEAP32[gb + 61472 >> 2] | 0) + (gb + 437486 | 0);
 HEAP32[gb + 61476 >> 2] = (HEAP32[gb + 61476 >> 2] | 0) + (gb + 437507 | 0);
 HEAP32[gb + 61480 >> 2] = (HEAP32[gb + 61480 >> 2] | 0) + (gb + 437528 | 0);
 HEAP32[gb + 61484 >> 2] = (HEAP32[gb + 61484 >> 2] | 0) + (gb + 437549 | 0);
 HEAP32[gb + 61488 >> 2] = (HEAP32[gb + 61488 >> 2] | 0) + (gb + 437570 | 0);
 HEAP32[gb + 61492 >> 2] = (HEAP32[gb + 61492 >> 2] | 0) + (gb + 437591 | 0);
 HEAP32[gb + 61496 >> 2] = (HEAP32[gb + 61496 >> 2] | 0) + (gb + 437612 | 0);
 HEAP32[gb + 61500 >> 2] = (HEAP32[gb + 61500 >> 2] | 0) + (gb + 437633 | 0);
 HEAP32[gb + 61504 >> 2] = (HEAP32[gb + 61504 >> 2] | 0) + (gb + 437654 | 0);
 HEAP32[gb + 61508 >> 2] = (HEAP32[gb + 61508 >> 2] | 0) + (gb + 437674 | 0);
 HEAP32[gb + 61512 >> 2] = (HEAP32[gb + 61512 >> 2] | 0) + (gb + 437694 | 0);
 HEAP32[gb + 61516 >> 2] = (HEAP32[gb + 61516 >> 2] | 0) + (gb + 437714 | 0);
 HEAP32[gb + 61520 >> 2] = (HEAP32[gb + 61520 >> 2] | 0) + (gb + 437734 | 0);
 HEAP32[gb + 61524 >> 2] = (HEAP32[gb + 61524 >> 2] | 0) + (gb + 437754 | 0);
 HEAP32[gb + 61528 >> 2] = (HEAP32[gb + 61528 >> 2] | 0) + (gb + 437774 | 0);
 HEAP32[gb + 61532 >> 2] = (HEAP32[gb + 61532 >> 2] | 0) + (gb + 437794 | 0);
 HEAP32[gb + 61536 >> 2] = (HEAP32[gb + 61536 >> 2] | 0) + (gb + 437814 | 0);
 HEAP32[gb + 61540 >> 2] = (HEAP32[gb + 61540 >> 2] | 0) + (gb + 437834 | 0);
 runPostSets48();
}

function runPostSets27() {
 HEAP32[gb + 40564 >> 2] = (HEAP32[gb + 40564 >> 2] | 0) + (gb + 392514 | 0);
 HEAP32[gb + 40568 >> 2] = (HEAP32[gb + 40568 >> 2] | 0) + (gb + 392532 | 0);
 HEAP32[gb + 40572 >> 2] = (HEAP32[gb + 40572 >> 2] | 0) + (gb + 392550 | 0);
 HEAP32[gb + 40576 >> 2] = (HEAP32[gb + 40576 >> 2] | 0) + (gb + 392568 | 0);
 HEAP32[gb + 40580 >> 2] = (HEAP32[gb + 40580 >> 2] | 0) + (gb + 392586 | 0);
 HEAP32[gb + 40584 >> 2] = (HEAP32[gb + 40584 >> 2] | 0) + (gb + 392607 | 0);
 HEAP32[gb + 40588 >> 2] = (HEAP32[gb + 40588 >> 2] | 0) + (gb + 392628 | 0);
 HEAP32[gb + 40592 >> 2] = (HEAP32[gb + 40592 >> 2] | 0) + (gb + 392649 | 0);
 HEAP32[gb + 40596 >> 2] = (HEAP32[gb + 40596 >> 2] | 0) + (gb + 392670 | 0);
 HEAP32[gb + 40600 >> 2] = (HEAP32[gb + 40600 >> 2] | 0) + (gb + 392691 | 0);
 HEAP32[gb + 40604 >> 2] = (HEAP32[gb + 40604 >> 2] | 0) + (gb + 392712 | 0);
 HEAP32[gb + 40608 >> 2] = (HEAP32[gb + 40608 >> 2] | 0) + (gb + 392733 | 0);
 HEAP32[gb + 40612 >> 2] = (HEAP32[gb + 40612 >> 2] | 0) + (gb + 392754 | 0);
 HEAP32[gb + 40616 >> 2] = (HEAP32[gb + 40616 >> 2] | 0) + (gb + 392775 | 0);
 HEAP32[gb + 40620 >> 2] = (HEAP32[gb + 40620 >> 2] | 0) + (gb + 392796 | 0);
 HEAP32[gb + 40624 >> 2] = (HEAP32[gb + 40624 >> 2] | 0) + (gb + 392817 | 0);
 HEAP32[gb + 40628 >> 2] = (HEAP32[gb + 40628 >> 2] | 0) + (gb + 392838 | 0);
 HEAP32[gb + 40632 >> 2] = (HEAP32[gb + 40632 >> 2] | 0) + (gb + 392859 | 0);
 HEAP32[gb + 40636 >> 2] = (HEAP32[gb + 40636 >> 2] | 0) + (gb + 392880 | 0);
 HEAP32[gb + 40640 >> 2] = (HEAP32[gb + 40640 >> 2] | 0) + (gb + 392901 | 0);
 HEAP32[gb + 40644 >> 2] = (HEAP32[gb + 40644 >> 2] | 0) + (gb + 392922 | 0);
 HEAP32[gb + 40648 >> 2] = (HEAP32[gb + 40648 >> 2] | 0) + (gb + 392940 | 0);
 HEAP32[gb + 40652 >> 2] = (HEAP32[gb + 40652 >> 2] | 0) + (gb + 392958 | 0);
 HEAP32[gb + 40656 >> 2] = (HEAP32[gb + 40656 >> 2] | 0) + (gb + 392976 | 0);
 HEAP32[gb + 40660 >> 2] = (HEAP32[gb + 40660 >> 2] | 0) + (gb + 392994 | 0);
 HEAP32[gb + 40664 >> 2] = (HEAP32[gb + 40664 >> 2] | 0) + (gb + 393012 | 0);
 HEAP32[gb + 40668 >> 2] = (HEAP32[gb + 40668 >> 2] | 0) + (gb + 393030 | 0);
 HEAP32[gb + 40672 >> 2] = (HEAP32[gb + 40672 >> 2] | 0) + (gb + 393048 | 0);
 HEAP32[gb + 40676 >> 2] = (HEAP32[gb + 40676 >> 2] | 0) + (gb + 393066 | 0);
 HEAP32[gb + 40680 >> 2] = (HEAP32[gb + 40680 >> 2] | 0) + (gb + 393090 | 0);
 HEAP32[gb + 40684 >> 2] = (HEAP32[gb + 40684 >> 2] | 0) + (gb + 393117 | 0);
 HEAP32[gb + 40688 >> 2] = (HEAP32[gb + 40688 >> 2] | 0) + (gb + 393138 | 0);
 HEAP32[gb + 40692 >> 2] = (HEAP32[gb + 40692 >> 2] | 0) + (gb + 393151 | 0);
 HEAP32[gb + 40696 >> 2] = (HEAP32[gb + 40696 >> 2] | 0) + (gb + 393172 | 0);
 HEAP32[gb + 40700 >> 2] = (HEAP32[gb + 40700 >> 2] | 0) + (gb + 393199 | 0);
 HEAP32[gb + 40704 >> 2] = (HEAP32[gb + 40704 >> 2] | 0) + (gb + 393217 | 0);
 HEAP32[gb + 40708 >> 2] = (HEAP32[gb + 40708 >> 2] | 0) + (gb + 393231 | 0);
 HEAP32[gb + 40712 >> 2] = (HEAP32[gb + 40712 >> 2] | 0) + (gb + 393246 | 0);
 HEAP32[gb + 40716 >> 2] = (HEAP32[gb + 40716 >> 2] | 0) + (gb + 393264 | 0);
 HEAP32[gb + 40720 >> 2] = (HEAP32[gb + 40720 >> 2] | 0) + (gb + 393284 | 0);
 HEAP32[gb + 40724 >> 2] = (HEAP32[gb + 40724 >> 2] | 0) + (gb + 393298 | 0);
 HEAP32[gb + 40728 >> 2] = (HEAP32[gb + 40728 >> 2] | 0) + (gb + 393317 | 0);
 HEAP32[gb + 40732 >> 2] = (HEAP32[gb + 40732 >> 2] | 0) + (gb + 393333 | 0);
 HEAP32[gb + 40736 >> 2] = (HEAP32[gb + 40736 >> 2] | 0) + (gb + 393349 | 0);
 HEAP32[gb + 40740 >> 2] = (HEAP32[gb + 40740 >> 2] | 0) + (gb + 393365 | 0);
 HEAP32[gb + 40744 >> 2] = (HEAP32[gb + 40744 >> 2] | 0) + (gb + 393381 | 0);
 HEAP32[gb + 40748 >> 2] = (HEAP32[gb + 40748 >> 2] | 0) + (gb + 393398 | 0);
 HEAP32[gb + 40752 >> 2] = (HEAP32[gb + 40752 >> 2] | 0) + (gb + 393420 | 0);
 HEAP32[gb + 40756 >> 2] = (HEAP32[gb + 40756 >> 2] | 0) + (gb + 393437 | 0);
 HEAP32[gb + 40760 >> 2] = (HEAP32[gb + 40760 >> 2] | 0) + (gb + 393453 | 0);
 HEAP32[gb + 40764 >> 2] = (HEAP32[gb + 40764 >> 2] | 0) + (gb + 393479 | 0);
 HEAP32[gb + 40768 >> 2] = (HEAP32[gb + 40768 >> 2] | 0) + (gb + 393505 | 0);
 HEAP32[gb + 40772 >> 2] = (HEAP32[gb + 40772 >> 2] | 0) + (gb + 393531 | 0);
 HEAP32[gb + 40776 >> 2] = (HEAP32[gb + 40776 >> 2] | 0) + (gb + 393557 | 0);
 HEAP32[gb + 40780 >> 2] = (HEAP32[gb + 40780 >> 2] | 0) + (gb + 393582 | 0);
 HEAP32[gb + 40784 >> 2] = (HEAP32[gb + 40784 >> 2] | 0) + (gb + 393608 | 0);
 HEAP32[gb + 40788 >> 2] = (HEAP32[gb + 40788 >> 2] | 0) + (gb + 393638 | 0);
 HEAP32[gb + 40792 >> 2] = (HEAP32[gb + 40792 >> 2] | 0) + (gb + 393652 | 0);
 HEAP32[gb + 40796 >> 2] = (HEAP32[gb + 40796 >> 2] | 0) + (gb + 393669 | 0);
 HEAP32[gb + 40800 >> 2] = (HEAP32[gb + 40800 >> 2] | 0) + (gb + 393693 | 0);
 HEAP32[gb + 40804 >> 2] = (HEAP32[gb + 40804 >> 2] | 0) + (gb + 393704 | 0);
 HEAP32[gb + 40808 >> 2] = (HEAP32[gb + 40808 >> 2] | 0) + (gb + 393715 | 0);
 HEAP32[gb + 40812 >> 2] = (HEAP32[gb + 40812 >> 2] | 0) + (gb + 393726 | 0);
 HEAP32[gb + 40816 >> 2] = (HEAP32[gb + 40816 >> 2] | 0) + (gb + 393737 | 0);
 HEAP32[gb + 40820 >> 2] = (HEAP32[gb + 40820 >> 2] | 0) + (gb + 393748 | 0);
 HEAP32[gb + 40824 >> 2] = (HEAP32[gb + 40824 >> 2] | 0) + (gb + 393759 | 0);
 HEAP32[gb + 40828 >> 2] = (HEAP32[gb + 40828 >> 2] | 0) + (gb + 393769 | 0);
 HEAP32[gb + 40832 >> 2] = (HEAP32[gb + 40832 >> 2] | 0) + (gb + 393775 | 0);
 HEAP32[gb + 40836 >> 2] = (HEAP32[gb + 40836 >> 2] | 0) + (gb + 393784 | 0);
 HEAP32[gb + 40840 >> 2] = (HEAP32[gb + 40840 >> 2] | 0) + (gb + 393793 | 0);
 HEAP32[gb + 40844 >> 2] = (HEAP32[gb + 40844 >> 2] | 0) + (gb + 393801 | 0);
 HEAP32[gb + 40848 >> 2] = (HEAP32[gb + 40848 >> 2] | 0) + (gb + 393817 | 0);
 HEAP32[gb + 40852 >> 2] = (HEAP32[gb + 40852 >> 2] | 0) + (gb + 393835 | 0);
 HEAP32[gb + 40856 >> 2] = (HEAP32[gb + 40856 >> 2] | 0) + (gb + 393853 | 0);
 HEAP32[gb + 40860 >> 2] = (HEAP32[gb + 40860 >> 2] | 0) + (gb + 393871 | 0);
 HEAP32[gb + 40864 >> 2] = (HEAP32[gb + 40864 >> 2] | 0) + (gb + 393890 | 0);
 HEAP32[gb + 40868 >> 2] = (HEAP32[gb + 40868 >> 2] | 0) + (gb + 393905 | 0);
 HEAP32[gb + 40872 >> 2] = (HEAP32[gb + 40872 >> 2] | 0) + (gb + 393918 | 0);
 HEAP32[gb + 40876 >> 2] = (HEAP32[gb + 40876 >> 2] | 0) + (gb + 393935 | 0);
 HEAP32[gb + 40880 >> 2] = (HEAP32[gb + 40880 >> 2] | 0) + (gb + 393950 | 0);
 HEAP32[gb + 40884 >> 2] = (HEAP32[gb + 40884 >> 2] | 0) + (gb + 393966 | 0);
 HEAP32[gb + 40888 >> 2] = (HEAP32[gb + 40888 >> 2] | 0) + (gb + 393982 | 0);
 HEAP32[gb + 40892 >> 2] = (HEAP32[gb + 40892 >> 2] | 0) + (gb + 394011 | 0);
 HEAP32[gb + 40896 >> 2] = (HEAP32[gb + 40896 >> 2] | 0) + (gb + 394040 | 0);
 HEAP32[gb + 40900 >> 2] = (HEAP32[gb + 40900 >> 2] | 0) + (gb + 394069 | 0);
 HEAP32[gb + 40904 >> 2] = (HEAP32[gb + 40904 >> 2] | 0) + (gb + 394098 | 0);
 HEAP32[gb + 40908 >> 2] = (HEAP32[gb + 40908 >> 2] | 0) + (gb + 394127 | 0);
 HEAP32[gb + 40912 >> 2] = (HEAP32[gb + 40912 >> 2] | 0) + (gb + 394156 | 0);
 HEAP32[gb + 40916 >> 2] = (HEAP32[gb + 40916 >> 2] | 0) + (gb + 394173 | 0);
 HEAP32[gb + 40920 >> 2] = (HEAP32[gb + 40920 >> 2] | 0) + (gb + 394194 | 0);
 HEAP32[gb + 40924 >> 2] = (HEAP32[gb + 40924 >> 2] | 0) + (gb + 394214 | 0);
 HEAP32[gb + 40928 >> 2] = (HEAP32[gb + 40928 >> 2] | 0) + (gb + 394238 | 0);
 HEAP32[gb + 40932 >> 2] = (HEAP32[gb + 40932 >> 2] | 0) + (gb + 394258 | 0);
 HEAP32[gb + 40936 >> 2] = (HEAP32[gb + 40936 >> 2] | 0) + (gb + 394281 | 0);
 HEAP32[gb + 40940 >> 2] = (HEAP32[gb + 40940 >> 2] | 0) + (gb + 394304 | 0);
 HEAP32[gb + 40944 >> 2] = (HEAP32[gb + 40944 >> 2] | 0) + (gb + 394334 | 0);
 HEAP32[gb + 40948 >> 2] = (HEAP32[gb + 40948 >> 2] | 0) + (gb + 394354 | 0);
 HEAP32[gb + 40952 >> 2] = (HEAP32[gb + 40952 >> 2] | 0) + (gb + 394377 | 0);
 HEAP32[gb + 40956 >> 2] = (HEAP32[gb + 40956 >> 2] | 0) + (gb + 394400 | 0);
 HEAP32[gb + 40960 >> 2] = (HEAP32[gb + 40960 >> 2] | 0) + (gb + 422472 | 0);
 runPostSets28();
}

function __ZN5physx6shdfnd4sortINS_2Sc8BodyRankENS0_7GreaterIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i16, i3, i1, i2, i4) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 8 | 0;
 i17 = i18;
 i2 = i4 << 2;
 i13 = i2 >>> 0 > 1024;
 i15 = i17 + 4 | 0;
 HEAP8[i15 >> 0] = i13 & 1;
 if (i13) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i18 + 20 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i17 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i17 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i13 = i4;
  i8 = 0;
  i4 = 0;
  L7 : while (1) {
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i12 = i4;
      break;
     }
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i16 + (i6 * 12 | 0) + 8 >> 2] | 0) >>> 0 > (HEAP32[i16 + (i5 * 12 | 0) + 8 >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i11 = i16 + (i5 * 12 | 0) | 0;
       i12 = i16 + (i7 * 12 | 0) | 0;
       HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
       HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i12 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i12 << 2) >> 2] | 0;
    i8 = i12;
   }
   i11 = (i3 + i12 | 0) / 2 | 0;
   i4 = i16 + (i11 * 12 | 0) | 0;
   i10 = i16 + (i12 * 12 | 0) | 0;
   i11 = i16 + (i11 * 12 | 0) + 8 | 0;
   i5 = i16 + (i12 * 12 | 0) + 8 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i11 >> 2] | 0) >>> 0 > i6 >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i6 = HEAP32[i5 >> 2] | 0;
   }
   i9 = i16 + (i3 * 12 | 0) | 0;
   i7 = i16 + (i3 * 12 | 0) + 8 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   if (i5 >>> 0 > i6 >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i5 = HEAP32[i7 >> 2] | 0;
   }
   if (i5 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   }
   i9 = i3 + -1 | 0;
   i11 = i16 + (i9 * 12 | 0) | 0;
   HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i10 = i16 + (i9 * 12 | 0) + 8 | 0;
   i5 = i12;
   i4 = i9;
   while (1) {
    i7 = HEAP32[i10 >> 2] | 0;
    i6 = i5;
    while (1) {
     i5 = i6 + 1 | 0;
     if ((HEAP32[i16 + (i5 * 12 | 0) + 8 >> 2] | 0) >>> 0 > i7 >>> 0) i6 = i5; else {
      i9 = i6;
      break;
     }
    }
    do i4 = i4 + -1 | 0; while (i7 >>> 0 > (HEAP32[i16 + (i4 * 12 | 0) + 8 >> 2] | 0) >>> 0);
    i6 = i4;
    i4 = i16 + (i5 * 12 | 0) | 0;
    if ((i5 | 0) >= (i6 | 0)) break;
    i9 = i16 + (i6 * 12 | 0) | 0;
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i4 = i6;
   }
   HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   if ((i5 - i12 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i13 + -1 | 0) >>> 0) i4 = i13; else {
     i4 = i13 << 3;
     if (!i4) i5 = 0; else {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
      i5 = _PxGetFoundation() | 0;
      i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
      i5 = mftCall_iiiiii(i10 | 0, i11 | 0, i4 | 0, (i5 ? gb + 703100 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
     i2 = 1;
     i4 = i13 << 1;
     i1 = i5;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i12;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i9;
    i5 = i4;
    i4 = i9 + 2 | 0;
   } else {
    i5 = i9 + 2 | 0;
    if (i8 >>> 0 < (i13 + -1 | 0) >>> 0) i4 = i13; else {
     i4 = i13 << 3;
     if (!i4) i4 = 0; else {
      i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i7 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
      i11 = _PxGetFoundation() | 0;
      i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
      i4 = mftCall_iiiiii(i7 | 0, i10 | 0, i4 | 0, (i11 ? gb + 703100 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i13 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i5;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i12;
    i3 = i9;
   }
   i13 = i5;
   i8 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 STACKTOP = i18;
 return;
}

function __ZZL16ClipDetailMeshesR13dynamic_arrayIP17ClippedDetailMeshLj4EERK11DynamicMeshRK10DetailMeshPK10dtMeshTileRK8Vector3ffEN12ClipCallback7processES9_RK14DetailMeshPolyPKii(i1, i19, i21, i22, i23) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 if ((i23 | 0) <= 0) return;
 i24 = i19 + 20 | 0;
 i25 = i1 + 16 | 0;
 i26 = i1 + 8 | 0;
 i27 = i1 + 20 | 0;
 i20 = i1 + 12 | 0;
 i18 = i1 + 4 | 0;
 i17 = 0;
 do {
  i1 = (HEAP32[i24 >> 2] | 0) + (HEAP32[i22 + (i17 << 2) >> 2] << 2 << 1) | 0;
  i2 = HEAP32[i25 >> 2] | 0;
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = 3;
  i4 = i2 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < 3) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = 3;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 36, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = 3;
   HEAP32[i2 >> 2] = i16;
   break;
  } while (0);
  i10 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
  i11 = (HEAP32[i19 >> 2] | 0) + (((HEAPU16[i1 >> 1] | 0) + (HEAP32[i21 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = (HEAP32[HEAP32[i25 >> 2] >> 2] | 0) + 12 | 0;
  i11 = (HEAP32[i19 >> 2] | 0) + (((HEAPU16[i1 + 2 >> 1] | 0) + (HEAP32[i21 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = (HEAP32[HEAP32[i25 >> 2] >> 2] | 0) + 24 | 0;
  i11 = (HEAP32[i19 >> 2] | 0) + (((HEAPU16[i1 + 4 >> 1] | 0) + (HEAP32[i21 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = HEAP32[i25 >> 2] | 0;
  i11 = HEAP32[i26 >> 2] | 0;
  i5 = HEAP32[i27 >> 2] | 0;
  i12 = HEAP32[i11 + 12 >> 2] | 0;
  L12 : do if (i12 | 0) {
   i6 = i5 + 12 | 0;
   i13 = i10 + 12 | 0;
   i7 = i10 + 16 | 0;
   i8 = i10 + 4 | 0;
   L14 : do if ((i5 | 0) == (i10 | 0)) {
    i1 = 0;
    while (1) {
     if ((__ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i10, i10, (HEAP32[i11 >> 2] | 0) + (i1 << 4) | 0) | 0) == 1) break L14;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i12 >>> 0) break L12;
    }
   } else {
    i4 = 0;
    while (1) {
     switch (__ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i5, i10, (HEAP32[i11 >> 2] | 0) + (i4 << 4) | 0) | 0) {
     case 1:
      break L14;
     case 0:
      {
       i9 = HEAP32[i5 >> 2] | 0;
       i1 = (HEAP32[i6 >> 2] | 0) * 12 | 0;
       i2 = (i1 | 0) / 12 | 0;
       HEAP32[i13 >> 2] = i2;
       i3 = HEAP32[i7 >> 2] | 0;
       do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
        HEAP32[i7 >> 2] = i2;
        i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i10 >> 2] = i1;
        break;
       } else {
        i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
        HEAP32[i7 >> 2] = i2;
        HEAP32[i10 >> 2] = i1;
        break;
       } else i1 = HEAP32[i10 >> 2] | 0; while (0);
       _memcpy(i1 | 0, i9 | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
       break;
      }
     default:
      {}
     }
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i12 >>> 0) break L12;
    }
   } while (0);
   HEAP32[i13 >> 2] = 0;
  } while (0);
  i1 = HEAP32[i25 >> 2] | 0;
  i16 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i16 | 0) >= 2) {
   i14 = __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(HEAP32[i20 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   i1 = __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(HEAP32[i20 >> 2] | 0, (HEAP32[HEAP32[i25 >> 2] >> 2] | 0) + 12 | 0) | 0;
   if ((i16 | 0) != 2) {
    i15 = i14 & 65535;
    i13 = 2;
    do {
     i12 = i1;
     i1 = __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(HEAP32[i20 >> 2] | 0, (HEAP32[HEAP32[i25 >> 2] >> 2] | 0) + (i13 * 12 | 0) | 0) | 0;
     if (!((i1 | 0) == (i14 | 0) | ((i14 | 0) == (i12 | 0) | (i12 | 0) == (i1 | 0)))) {
      i3 = HEAP32[i18 >> 2] | 0;
      i4 = i3 + 24 | 0;
      i5 = i3 + 36 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      i7 = i6 + 1 | 0;
      i8 = i3 + 40 | 0;
      i9 = HEAP32[i8 >> 2] | 0;
      i10 = i9 & 2147483647;
      do if (i7 >>> 0 > i10 >>> 0) {
       i2 = i9 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
        HEAP32[i8 >> 2] = i2;
        HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 1, 2, i3 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i3 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 1 | 0) | 0;
        HEAP32[i8 >> 2] = i2;
        HEAP32[i4 >> 2] = i11;
        break;
       }
      } while (0);
      HEAP32[i5 >> 2] = i7;
      HEAP16[(HEAP32[i4 >> 2] | 0) + (i6 << 1) >> 1] = i15;
      i10 = HEAP32[i18 >> 2] | 0;
      i11 = i10 + 24 | 0;
      i3 = i12 & 65535;
      i4 = i10 + 36 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      i6 = i5 + 1 | 0;
      i7 = i10 + 40 | 0;
      i8 = HEAP32[i7 >> 2] | 0;
      i9 = i8 & 2147483647;
      do if (i6 >>> 0 > i9 >>> 0) {
       i2 = i8 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
        HEAP32[i7 >> 2] = i2;
        HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 << 1, 2, i10 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i10 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] << 1 | 0) | 0;
        HEAP32[i7 >> 2] = i2;
        HEAP32[i11 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i4 >> 2] = i6;
      HEAP16[(HEAP32[i11 >> 2] | 0) + (i5 << 1) >> 1] = i3;
      i3 = HEAP32[i18 >> 2] | 0;
      i4 = i3 + 24 | 0;
      i5 = i1 & 65535;
      i6 = i3 + 36 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      i8 = i7 + 1 | 0;
      i9 = i3 + 40 | 0;
      i10 = HEAP32[i9 >> 2] | 0;
      i11 = i10 & 2147483647;
      do if (i8 >>> 0 > i11 >>> 0) {
       i2 = i10 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i11 >>> 0 < i2 >>> 0) if ((i10 | 0) > -1) {
        HEAP32[i9 >> 2] = i2;
        HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 1, 2, i3 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i3 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
        HEAP32[i9 >> 2] = i2;
        HEAP32[i4 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i6 >> 2] = i8;
      HEAP16[(HEAP32[i4 >> 2] | 0) + (i7 << 1) >> 1] = i5;
     }
     i13 = i13 + 1 | 0;
    } while ((i13 | 0) < (i16 | 0));
   }
  }
  i17 = i17 + 1 | 0;
 } while ((i17 | 0) != (i23 | 0));
 return;
}

function runPostSets19() {
 HEAP32[gb + 36940 >> 2] = (HEAP32[gb + 36940 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36944 >> 2] = (HEAP32[gb + 36944 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36948 >> 2] = (HEAP32[gb + 36948 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36952 >> 2] = (HEAP32[gb + 36952 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36956 >> 2] = (HEAP32[gb + 36956 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36960 >> 2] = (HEAP32[gb + 36960 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36964 >> 2] = (HEAP32[gb + 36964 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36968 >> 2] = (HEAP32[gb + 36968 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36972 >> 2] = (HEAP32[gb + 36972 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36976 >> 2] = (HEAP32[gb + 36976 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36980 >> 2] = (HEAP32[gb + 36980 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36984 >> 2] = (HEAP32[gb + 36984 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36988 >> 2] = (HEAP32[gb + 36988 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36992 >> 2] = (HEAP32[gb + 36992 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36996 >> 2] = (HEAP32[gb + 36996 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37e3 >> 2] = (HEAP32[gb + 37e3 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37004 >> 2] = (HEAP32[gb + 37004 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37008 >> 2] = (HEAP32[gb + 37008 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37012 >> 2] = (HEAP32[gb + 37012 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37016 >> 2] = (HEAP32[gb + 37016 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37020 >> 2] = (HEAP32[gb + 37020 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37024 >> 2] = (HEAP32[gb + 37024 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37028 >> 2] = (HEAP32[gb + 37028 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37032 >> 2] = (HEAP32[gb + 37032 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37036 >> 2] = (HEAP32[gb + 37036 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37040 >> 2] = (HEAP32[gb + 37040 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37044 >> 2] = (HEAP32[gb + 37044 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37048 >> 2] = (HEAP32[gb + 37048 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37052 >> 2] = (HEAP32[gb + 37052 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37056 >> 2] = (HEAP32[gb + 37056 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37060 >> 2] = (HEAP32[gb + 37060 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37064 >> 2] = (HEAP32[gb + 37064 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37068 >> 2] = (HEAP32[gb + 37068 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37072 >> 2] = (HEAP32[gb + 37072 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37076 >> 2] = (HEAP32[gb + 37076 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37080 >> 2] = (HEAP32[gb + 37080 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37084 >> 2] = (HEAP32[gb + 37084 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37088 >> 2] = (HEAP32[gb + 37088 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37092 >> 2] = (HEAP32[gb + 37092 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37096 >> 2] = (HEAP32[gb + 37096 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37100 >> 2] = (HEAP32[gb + 37100 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37104 >> 2] = (HEAP32[gb + 37104 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37108 >> 2] = (HEAP32[gb + 37108 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37112 >> 2] = (HEAP32[gb + 37112 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37116 >> 2] = (HEAP32[gb + 37116 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37120 >> 2] = (HEAP32[gb + 37120 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37124 >> 2] = (HEAP32[gb + 37124 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37128 >> 2] = (HEAP32[gb + 37128 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37132 >> 2] = (HEAP32[gb + 37132 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37136 >> 2] = (HEAP32[gb + 37136 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37140 >> 2] = (HEAP32[gb + 37140 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37144 >> 2] = (HEAP32[gb + 37144 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37148 >> 2] = (HEAP32[gb + 37148 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37152 >> 2] = (HEAP32[gb + 37152 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37156 >> 2] = (HEAP32[gb + 37156 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37160 >> 2] = (HEAP32[gb + 37160 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37164 >> 2] = (HEAP32[gb + 37164 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37168 >> 2] = (HEAP32[gb + 37168 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37172 >> 2] = (HEAP32[gb + 37172 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37176 >> 2] = (HEAP32[gb + 37176 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37180 >> 2] = (HEAP32[gb + 37180 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37184 >> 2] = (HEAP32[gb + 37184 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37188 >> 2] = (HEAP32[gb + 37188 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37192 >> 2] = (HEAP32[gb + 37192 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37196 >> 2] = (HEAP32[gb + 37196 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37200 >> 2] = (HEAP32[gb + 37200 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37204 >> 2] = (HEAP32[gb + 37204 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37208 >> 2] = (HEAP32[gb + 37208 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37212 >> 2] = (HEAP32[gb + 37212 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37216 >> 2] = (HEAP32[gb + 37216 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37220 >> 2] = (HEAP32[gb + 37220 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37224 >> 2] = (HEAP32[gb + 37224 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37228 >> 2] = (HEAP32[gb + 37228 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37232 >> 2] = (HEAP32[gb + 37232 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37236 >> 2] = (HEAP32[gb + 37236 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37240 >> 2] = (HEAP32[gb + 37240 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37244 >> 2] = (HEAP32[gb + 37244 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37248 >> 2] = (HEAP32[gb + 37248 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37252 >> 2] = (HEAP32[gb + 37252 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37256 >> 2] = (HEAP32[gb + 37256 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37260 >> 2] = (HEAP32[gb + 37260 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37264 >> 2] = (HEAP32[gb + 37264 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37268 >> 2] = (HEAP32[gb + 37268 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37272 >> 2] = (HEAP32[gb + 37272 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37276 >> 2] = (HEAP32[gb + 37276 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37280 >> 2] = (HEAP32[gb + 37280 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37284 >> 2] = (HEAP32[gb + 37284 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37288 >> 2] = (HEAP32[gb + 37288 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37292 >> 2] = (HEAP32[gb + 37292 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37296 >> 2] = (HEAP32[gb + 37296 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37300 >> 2] = (HEAP32[gb + 37300 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37304 >> 2] = (HEAP32[gb + 37304 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37308 >> 2] = (HEAP32[gb + 37308 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37312 >> 2] = (HEAP32[gb + 37312 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37316 >> 2] = (HEAP32[gb + 37316 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37320 >> 2] = (HEAP32[gb + 37320 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37324 >> 2] = (HEAP32[gb + 37324 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37328 >> 2] = (HEAP32[gb + 37328 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37332 >> 2] = (HEAP32[gb + 37332 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37336 >> 2] = (HEAP32[gb + 37336 >> 2] | 0) + (gb + 388687 | 0);
 runPostSets20();
}

function runPostSets() {
 HEAP32[gb + 14912 >> 2] = (HEAP32[gb + 14912 >> 2] | 0) + (gb + 356149 | 0);
 HEAP32[gb + 14916 >> 2] = (HEAP32[gb + 14916 >> 2] | 0) + (gb + 356171 | 0);
 HEAP32[gb + 14920 >> 2] = (HEAP32[gb + 14920 >> 2] | 0) + (gb + 356215 | 0);
 HEAP32[gb + 14924 >> 2] = (HEAP32[gb + 14924 >> 2] | 0) + (gb + 356247 | 0);
 HEAP32[gb + 14928 >> 2] = (HEAP32[gb + 14928 >> 2] | 0) + (gb + 356284 | 0);
 HEAP32[gb + 14932 >> 2] = (HEAP32[gb + 14932 >> 2] | 0) + (gb + 356310 | 0);
 HEAP32[gb + 14936 >> 2] = (HEAP32[gb + 14936 >> 2] | 0) + (gb + 356341 | 0);
 HEAP32[gb + 14940 >> 2] = (HEAP32[gb + 14940 >> 2] | 0) + (gb + 356370 | 0);
 HEAP32[gb + 14944 >> 2] = (HEAP32[gb + 14944 >> 2] | 0) + (gb + 356410 | 0);
 HEAP32[gb + 14948 >> 2] = (HEAP32[gb + 14948 >> 2] | 0) + (gb + 356441 | 0);
 HEAP32[gb + 14952 >> 2] = (HEAP32[gb + 14952 >> 2] | 0) + (gb + 356464 | 0);
 HEAP32[gb + 14956 >> 2] = (HEAP32[gb + 14956 >> 2] | 0) + (gb + 356486 | 0);
 HEAP32[gb + 14960 >> 2] = (HEAP32[gb + 14960 >> 2] | 0) + (gb + 356506 | 0);
 HEAP32[gb + 14964 >> 2] = (HEAP32[gb + 14964 >> 2] | 0) + (gb + 356567 | 0);
 HEAP32[gb + 14968 >> 2] = (HEAP32[gb + 14968 >> 2] | 0) + (gb + 356615 | 0);
 HEAP32[gb + 14972 >> 2] = (HEAP32[gb + 14972 >> 2] | 0) + (gb + 356643 | 0);
 HEAP32[gb + 14976 >> 2] = (HEAP32[gb + 14976 >> 2] | 0) + (gb + 356678 | 0);
 HEAP32[gb + 14980 >> 2] = (HEAP32[gb + 14980 >> 2] | 0) + (gb + 356733 | 0);
 HEAP32[gb + 14984 >> 2] = (HEAP32[gb + 14984 >> 2] | 0) + (gb + 356788 | 0);
 HEAP32[gb + 14988 >> 2] = (HEAP32[gb + 14988 >> 2] | 0) + (gb + 356811 | 0);
 HEAP32[gb + 14992 >> 2] = (HEAP32[gb + 14992 >> 2] | 0) + (gb + 356843 | 0);
 HEAP32[gb + 14996 >> 2] = (HEAP32[gb + 14996 >> 2] | 0) + (gb + 356885 | 0);
 HEAP32[gb + 15e3 >> 2] = (HEAP32[gb + 15e3 >> 2] | 0) + (gb + 356962 | 0);
 HEAP32[gb + 15004 >> 2] = (HEAP32[gb + 15004 >> 2] | 0) + (gb + 356989 | 0);
 HEAP32[gb + 15008 >> 2] = (HEAP32[gb + 15008 >> 2] | 0) + (gb + 357032 | 0);
 HEAP32[gb + 15012 >> 2] = (HEAP32[gb + 15012 >> 2] | 0) + (gb + 357060 | 0);
 HEAP32[gb + 15016 >> 2] = (HEAP32[gb + 15016 >> 2] | 0) + (gb + 357097 | 0);
 HEAP32[gb + 15020 >> 2] = (HEAP32[gb + 15020 >> 2] | 0) + (gb + 357135 | 0);
 HEAP32[gb + 15024 >> 2] = (HEAP32[gb + 15024 >> 2] | 0) + (gb + 357172 | 0);
 HEAP32[gb + 15028 >> 2] = (HEAP32[gb + 15028 >> 2] | 0) + (gb + 357191 | 0);
 HEAP32[gb + 15032 >> 2] = (HEAP32[gb + 15032 >> 2] | 0) + (gb + 357212 | 0);
 HEAP32[gb + 15036 >> 2] = (HEAP32[gb + 15036 >> 2] | 0) + (gb + 357231 | 0);
 HEAP32[gb + 15040 >> 2] = (HEAP32[gb + 15040 >> 2] | 0) + (gb + 357250 | 0);
 HEAP32[gb + 15044 >> 2] = (HEAP32[gb + 15044 >> 2] | 0) + (gb + 357287 | 0);
 HEAP32[gb + 15048 >> 2] = (HEAP32[gb + 15048 >> 2] | 0) + (gb + 357308 | 0);
 HEAP32[gb + 15052 >> 2] = (HEAP32[gb + 15052 >> 2] | 0) + (gb + 357328 | 0);
 HEAP32[gb + 15056 >> 2] = (HEAP32[gb + 15056 >> 2] | 0) + (gb + 357361 | 0);
 HEAP32[gb + 15060 >> 2] = (HEAP32[gb + 15060 >> 2] | 0) + (gb + 357383 | 0);
 HEAP32[gb + 15064 >> 2] = (HEAP32[gb + 15064 >> 2] | 0) + (gb + 357430 | 0);
 HEAP32[gb + 15068 >> 2] = (HEAP32[gb + 15068 >> 2] | 0) + (gb + 357470 | 0);
 HEAP32[gb + 15072 >> 2] = (HEAP32[gb + 15072 >> 2] | 0) + (gb + 357503 | 0);
 HEAP32[gb + 15076 >> 2] = (HEAP32[gb + 15076 >> 2] | 0) + (gb + 357536 | 0);
 HEAP32[gb + 15080 >> 2] = (HEAP32[gb + 15080 >> 2] | 0) + (gb + 357583 | 0);
 HEAP32[gb + 15084 >> 2] = (HEAP32[gb + 15084 >> 2] | 0) + (gb + 357600 | 0);
 HEAP32[gb + 15088 >> 2] = (HEAP32[gb + 15088 >> 2] | 0) + (gb + 357628 | 0);
 HEAP32[gb + 15092 >> 2] = (HEAP32[gb + 15092 >> 2] | 0) + (gb + 357690 | 0);
 HEAP32[gb + 15096 >> 2] = (HEAP32[gb + 15096 >> 2] | 0) + (gb + 357729 | 0);
 HEAP32[gb + 15100 >> 2] = (HEAP32[gb + 15100 >> 2] | 0) + (gb + 357768 | 0);
 HEAP32[gb + 15104 >> 2] = (HEAP32[gb + 15104 >> 2] | 0) + (gb + 357788 | 0);
 HEAP32[gb + 15108 >> 2] = (HEAP32[gb + 15108 >> 2] | 0) + (gb + 357834 | 0);
 HEAP32[gb + 15112 >> 2] = (HEAP32[gb + 15112 >> 2] | 0) + (gb + 357862 | 0);
 HEAP32[gb + 15116 >> 2] = (HEAP32[gb + 15116 >> 2] | 0) + (gb + 357899 | 0);
 HEAP32[gb + 15120 >> 2] = (HEAP32[gb + 15120 >> 2] | 0) + (gb + 357933 | 0);
 HEAP32[gb + 15124 >> 2] = (HEAP32[gb + 15124 >> 2] | 0) + (gb + 357975 | 0);
 HEAP32[gb + 15128 >> 2] = (HEAP32[gb + 15128 >> 2] | 0) + (gb + 358018 | 0);
 HEAP32[gb + 15132 >> 2] = (HEAP32[gb + 15132 >> 2] | 0) + (gb + 358048 | 0);
 HEAP32[gb + 15136 >> 2] = (HEAP32[gb + 15136 >> 2] | 0) + (gb + 358094 | 0);
 HEAP32[gb + 15140 >> 2] = (HEAP32[gb + 15140 >> 2] | 0) + (gb + 358134 | 0);
 HEAP32[gb + 15144 >> 2] = (HEAP32[gb + 15144 >> 2] | 0) + (gb + 358173 | 0);
 HEAP32[gb + 15148 >> 2] = (HEAP32[gb + 15148 >> 2] | 0) + (gb + 358218 | 0);
 HEAP32[gb + 15152 >> 2] = (HEAP32[gb + 15152 >> 2] | 0) + (gb + 358266 | 0);
 HEAP32[gb + 15156 >> 2] = (HEAP32[gb + 15156 >> 2] | 0) + (gb + 358308 | 0);
 HEAP32[gb + 15160 >> 2] = (HEAP32[gb + 15160 >> 2] | 0) + (gb + 358353 | 0);
 HEAP32[gb + 15164 >> 2] = (HEAP32[gb + 15164 >> 2] | 0) + (gb + 358397 | 0);
 HEAP32[gb + 15168 >> 2] = (HEAP32[gb + 15168 >> 2] | 0) + (gb + 358432 | 0);
 HEAP32[gb + 15172 >> 2] = (HEAP32[gb + 15172 >> 2] | 0) + (gb + 358462 | 0);
 HEAP32[gb + 15176 >> 2] = (HEAP32[gb + 15176 >> 2] | 0) + (gb + 358492 | 0);
 HEAP32[gb + 15180 >> 2] = (HEAP32[gb + 15180 >> 2] | 0) + (gb + 358546 | 0);
 HEAP32[gb + 15184 >> 2] = (HEAP32[gb + 15184 >> 2] | 0) + (gb + 358588 | 0);
 HEAP32[gb + 15188 >> 2] = (HEAP32[gb + 15188 >> 2] | 0) + (gb + 358619 | 0);
 HEAP32[gb + 15192 >> 2] = (HEAP32[gb + 15192 >> 2] | 0) + (gb + 358654 | 0);
 HEAP32[gb + 15196 >> 2] = (HEAP32[gb + 15196 >> 2] | 0) + (gb + 358693 | 0);
 HEAP32[gb + 15200 >> 2] = (HEAP32[gb + 15200 >> 2] | 0) + (gb + 358714 | 0);
 HEAP32[gb + 15204 >> 2] = (HEAP32[gb + 15204 >> 2] | 0) + (gb + 358734 | 0);
 HEAP32[gb + 15208 >> 2] = (HEAP32[gb + 15208 >> 2] | 0) + (gb + 358988 | 0);
 HEAP32[gb + 15212 >> 2] = (HEAP32[gb + 15212 >> 2] | 0) + (gb + 359004 | 0);
 HEAP32[gb + 15216 >> 2] = (HEAP32[gb + 15216 >> 2] | 0) + (gb + 359066 | 0);
 HEAP32[gb + 15220 >> 2] = (HEAP32[gb + 15220 >> 2] | 0) + (gb + 359132 | 0);
 HEAP32[gb + 15224 >> 2] = (HEAP32[gb + 15224 >> 2] | 0) + (gb + 359174 | 0);
 HEAP32[gb + 15228 >> 2] = (HEAP32[gb + 15228 >> 2] | 0) + (gb + 359218 | 0);
 HEAP32[gb + 15232 >> 2] = (HEAP32[gb + 15232 >> 2] | 0) + (gb + 359257 | 0);
 HEAP32[gb + 15236 >> 2] = (HEAP32[gb + 15236 >> 2] | 0) + (gb + 359285 | 0);
 HEAP32[gb + 15240 >> 2] = (HEAP32[gb + 15240 >> 2] | 0) + (gb + 359328 | 0);
 HEAP32[gb + 15244 >> 2] = (HEAP32[gb + 15244 >> 2] | 0) + (gb + 359355 | 0);
 HEAP32[gb + 15248 >> 2] = (HEAP32[gb + 15248 >> 2] | 0) + (gb + 359375 | 0);
 HEAP32[gb + 15252 >> 2] = (HEAP32[gb + 15252 >> 2] | 0) + (gb + 359398 | 0);
 HEAP32[gb + 15256 >> 2] = (HEAP32[gb + 15256 >> 2] | 0) + (gb + 359411 | 0);
 HEAP32[gb + 15260 >> 2] = (HEAP32[gb + 15260 >> 2] | 0) + (gb + 359451 | 0);
 HEAP32[gb + 15264 >> 2] = (HEAP32[gb + 15264 >> 2] | 0) + (gb + 359504 | 0);
 HEAP32[gb + 15268 >> 2] = (HEAP32[gb + 15268 >> 2] | 0) + (gb + 359564 | 0);
 HEAP32[gb + 15272 >> 2] = (HEAP32[gb + 15272 >> 2] | 0) + (gb + 359610 | 0);
 HEAP32[gb + 15276 >> 2] = (HEAP32[gb + 15276 >> 2] | 0) + (gb + 359643 | 0);
 HEAP32[gb + 15280 >> 2] = (HEAP32[gb + 15280 >> 2] | 0) + (gb + 359682 | 0);
 HEAP32[gb + 15284 >> 2] = (HEAP32[gb + 15284 >> 2] | 0) + (gb + 359707 | 0);
 HEAP32[gb + 15288 >> 2] = (HEAP32[gb + 15288 >> 2] | 0) + (gb + 359747 | 0);
 HEAP32[gb + 15292 >> 2] = (HEAP32[gb + 15292 >> 2] | 0) + (gb + 359782 | 0);
 HEAP32[gb + 15296 >> 2] = (HEAP32[gb + 15296 >> 2] | 0) + (gb + 359806 | 0);
 HEAP32[gb + 15300 >> 2] = (HEAP32[gb + 15300 >> 2] | 0) + (gb + 359842 | 0);
 HEAP32[gb + 15304 >> 2] = (HEAP32[gb + 15304 >> 2] | 0) + (gb + 359879 | 0);
 HEAP32[gb + 15308 >> 2] = (HEAP32[gb + 15308 >> 2] | 0) + (gb + 359885 | 0);
 runPostSets1();
}

function __ZNK5physx40PxVehicleTireLoadFilterDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 12 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj565ENS_22PxRepXPropertyAccessorILj565ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 28 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj566ENS_22PxRepXPropertyAccessorILj566ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 44 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj567ENS_22PxRepXPropertyAccessorILj567ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 60 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj568ENS_22PxRepXPropertyAccessorILj568ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i14, i1, i12, i10, i11, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 600 | 0;
 i4 = i13 + 16 | 0;
 i3 = i13;
 i9 = i13 + 24 | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832239 | 0, i9 | 0) | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i8, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break;
   i6 = mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0) | 0;
   if (!i6) {
    i15 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i3 >> 2] = gb + 833471;
    i12 = i3 + 8 | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i2;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i15, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i3);
    break;
   }
   do if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832272 | 0, i9 | 0) | 0) {
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
     i5 = _strtoul(i1, i8, 10) | 0;
     if (!i5) break;
     if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832282 | 0, i9 | 0) | 0) {
      i1 = HEAP32[i9 >> 2] | 0;
      HEAP32[i8 >> 2] = i1;
      if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i8, 10) | 0;
     } else i1 = 0;
     i7 = __ZN5physx22PxVehicleWheelsSimData8allocateEj(i5) | 0;
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 833671 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i7, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     HEAPF32[i9 + 80 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 84 >> 2] = Math_fround(500.0);
     HEAPF32[i9 + 88 >> 2] = Math_fround(600.0);
     HEAPF32[i9 + 92 >> 2] = Math_fround(.150000006);
     HEAPF32[i9 + 96 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 100 >> 2] = Math_fround(.349999994);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 4 >> 2] = Math_fround(.800000011);
     HEAPF32[i9 + 8 >> 2] = Math_fround(.330000013);
     HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 16 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 20 >> 2] = Math_fround(.800000011);
     HEAP32[i9 + 64 >> 2] = 3;
     HEAPF32[i9 + 104 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 108 >> 2] = Math_fround(.00166666671);
     HEAPF32[i9 + 240 >> 2] = Math_fround(4.0);
     HEAP32[i9 + 244 >> 2] = 7;
     HEAPF32[i9 + 248 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 112 >> 2] = Math_fround(-4.0);
     HEAPF32[i9 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 120 >> 2] = Math_fround(4.0);
     HEAPF32[i9 + 124 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 128 >> 2] = Math_fround(1.5);
     HEAPF32[i9 + 132 >> 2] = Math_fround(1.10000002);
     HEAPF32[i9 + 136 >> 2] = Math_fround(1.0);
     i2 = i9 + 140 | 0;
     i3 = i2 + 100 | 0;
     do {
      HEAP32[i2 >> 2] = 0;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) < (i3 | 0));
     HEAPF32[i9 + 256 >> 2] = Math_fround(10.0);
     HEAP32[i9 + 260 >> 2] = 1;
     HEAP32[i9 + 264 >> 2] = 5;
     i2 = 0;
     do {
      HEAPF32[i9 + 272 + (i2 << 2) >> 2] = Math_fround(.649999976);
      HEAPF32[i9 + 400 + (i2 << 2) >> 2] = Math_fround(.5);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 32);
     HEAPF32[i9 + 276 >> 2] = Math_fround(.150000006);
     HEAPF32[i9 + 400 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 528 >> 2] = Math_fround(.449999988);
     HEAPF32[i9 + 532 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 536 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 540 >> 2] = Math_fround(1.29999995);
     HEAPF32[i9 + 544 >> 2] = Math_fround(1.29999995);
     HEAPF32[i9 + 548 >> 2] = Math_fround(1.29999995);
     HEAP32[i9 + 552 >> 2] = 0;
     HEAPF32[i9 + 560 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 564 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 568 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 572 >> 2] = Math_fround(0.0);
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 834565 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i9, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 833686 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i9, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     i3 = HEAP32[i11 >> 2] | 0;
     i4 = (HEAP16[i6 + 4 >> 1] | 0) == 5 ? i6 : 0;
     i6 = __ZN5physx18PxVehicleDriveTank8allocateEj(i5) | 0;
     __ZN5physx18PxVehicleDriveTank5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj(i6, i3, (HEAP16[i4 + 4 >> 1] | 0) == 5 ? i4 : 0, i7, i9, i5 - i1 | 0);
     HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     __ZN5physx2Sn17readAllPropertiesINS_18PxVehicleDriveTankEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i6, i10, i15) | 0;
     i4 = HEAP32[i6 + 72 >> 2] | 0;
     i5 = i7 + 36 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) {
      i3 = 0;
      do {
       i2 = HEAP32[(HEAP32[i4 + (i3 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
       if (i2) {
        mftCall_viiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i2 | 0, 0, 0);
        i1 = HEAP32[i5 >> 2] | 0;
       }
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     __ZN5physx22PxVehicleWheelsSimData4freeEv(i7);
     HEAP32[i14 >> 2] = gb + 834990;
     HEAP32[i14 + 4 >> 2] = i6;
     i15 = i14 + 8 | 0;
     HEAP32[i15 >> 2] = i6;
     HEAP32[i15 + 4 >> 2] = 0;
     STACKTOP = i13;
     return;
    }
   } while (0);
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 833484 | 0, 88, gb + 833575 | 0, i4);
   HEAP32[i14 >> 2] = gb + 1576256;
   HEAP32[i14 + 4 >> 2] = 0;
   i15 = i14 + 8 | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i14 >> 2] = gb + 1576256;
 HEAP32[i14 + 4 >> 2] = 0;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN11AudioSource8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 4);
 i5 = i1 + 440 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867704 | 0, gb + 863920 | 0, i5, 0);
 i9 = i7 + 8 | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 436 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867600 | 0, gb + 867612 | 0, i9, 0);
 i8 = i7 + 8 | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867628 | 0, i8, i1 + 497 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867642 | 0, i6, i1 + 412 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867651 | 0, i6, i1 + 408 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867699 | 0, i8, i1 + 420 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867726 | 0, i8, i1 + 421 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867731 | 0, i8, i1 + 422 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867742 | 0, i8, i1 + 423 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867764 | 0, i8, i1 + 388 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867773 | 0, i6, i1 + 392 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867786 | 0, i6, i1 + 396 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867798 | 0, i6, i1 + 400 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867810 | 0, i6, i1 + 404 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 416 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867816 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867828 | 0, i6, i1 + 424 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867842 | 0, i6, i1 + 425 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867864 | 0, i6, i1 + 426 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i4 = i1 + 300 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867882 | 0, gb + 1034188 | 0, i4, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867901 | 0, gb + 1034188 | 0, i4, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 212 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867921 | 0, gb + 1034188 | 0, i4, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 124 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867939 | 0, gb + 1034188 | 0, i1, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx43PxVehicleAckermannGeometryDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj553ENS_22PxRepXPropertyAccessorILj553ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj554ENS_22PxRepXPropertyAccessorILj554ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj555ENS_22PxRepXPropertyAccessorILj555ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj556ENS_22PxRepXPropertyAccessorILj556ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx19computeSprungMassesEjPKNS_6PxVec3ERS1_fjPf(i14, i22, i27, f28, i26, i29) {
 i14 = i14 | 0;
 i22 = i22 | 0;
 i27 = i27 | 0;
 f28 = Math_fround(f28);
 i26 = i26 | 0;
 i29 = i29 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 4592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i30 + 2456 | 0;
 i20 = i30 + 2348 | 0;
 i21 = i30 + 2336 | 0;
 i24 = i30 + 2224 | 0;
 i25 = i30;
 i12 = i30 + 2472 | 0;
 i13 = i30 + 2360 | 0;
 i15 = i30 + 2240 | 0;
 i16 = i30 + 12 | 0;
 switch (i14 | 0) {
 case 1:
  {
   HEAPF32[i29 >> 2] = f28;
   STACKTOP = i30;
   return;
  }
 case 2:
  {
   i4 = HEAP32[i22 >> 2] | 0;
   HEAP32[i23 >> 2] = i4;
   i5 = i23 + 4 | 0;
   i6 = HEAP32[i22 + 4 >> 2] | 0;
   HEAP32[i5 >> 2] = i6;
   i7 = i23 + 8 | 0;
   i8 = HEAP32[i22 + 8 >> 2] | 0;
   HEAP32[i7 >> 2] = i8;
   HEAPF32[i23 + (i26 << 2) >> 2] = Math_fround(0.0);
   f19 = Math_fround(HEAPF32[i22 + 12 >> 2]);
   f9 = Math_fround(f19 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f18 = Math_fround(HEAPF32[i22 + 16 >> 2]);
   f11 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f17 = Math_fround(HEAPF32[i22 + 20 >> 2]);
   f10 = Math_fround(f17 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i20 >> 2] = f9;
   i1 = i20 + 4 | 0;
   HEAPF32[i1 >> 2] = f11;
   i3 = i20 + 8 | 0;
   HEAPF32[i3 >> 2] = f10;
   HEAPF32[i20 + (i26 << 2) >> 2] = Math_fround(0.0);
   f10 = Math_fround(HEAPF32[i20 >> 2]);
   f11 = Math_fround(f10 * f10);
   f9 = Math_fround(HEAPF32[i1 >> 2]);
   f11 = Math_fround(f11 + Math_fround(f9 * f9));
   f2 = Math_fround(HEAPF32[i3 >> 2]);
   f11 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f2 * f2))));
   if (f11 > Math_fround(0.0)) {
    f11 = Math_fround(Math_fround(1.0) / f11);
    f10 = Math_fround(f10 * f11);
    HEAPF32[i20 >> 2] = f10;
    f9 = Math_fround(f9 * f11);
    HEAPF32[i1 >> 2] = f9;
    f2 = Math_fround(f2 * f11);
    HEAPF32[i3 >> 2] = f2;
   }
   HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
   i20 = i21 + 4 | 0;
   HEAP32[i20 >> 2] = HEAP32[i27 + 4 >> 2];
   i22 = i21 + 8 | 0;
   HEAP32[i22 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAPF32[i21 + (i26 << 2) >> 2] = Math_fround(0.0);
   f35 = Math_fround(HEAPF32[i21 >> 2]);
   f32 = Math_fround(HEAPF32[i23 >> 2]);
   f35 = Math_fround(f35 - f32);
   f34 = Math_fround(HEAPF32[i20 >> 2]);
   f31 = Math_fround(HEAPF32[i5 >> 2]);
   f34 = Math_fround(f34 - f31);
   f11 = Math_fround(HEAPF32[i22 >> 2]);
   f33 = Math_fround(HEAPF32[i7 >> 2]);
   f11 = Math_fround(Math_fround(Math_fround(f35 * f10) + Math_fround(f34 * f9)) + Math_fround(Math_fround(f11 - f33) * f2));
   f32 = Math_fround(f32 + Math_fround(f10 * f11));
   f31 = Math_fround(f31 + Math_fround(f9 * f11));
   f11 = Math_fround(f33 + Math_fround(f2 * f11));
   HEAP32[i24 >> 2] = i4;
   i21 = i24 + 4 | 0;
   HEAP32[i21 >> 2] = i6;
   i22 = i24 + 8 | 0;
   HEAP32[i22 >> 2] = i8;
   HEAPF32[i24 + (i26 << 2) >> 2] = Math_fround(0.0);
   HEAPF32[i25 >> 2] = f19;
   i23 = i25 + 4 | 0;
   HEAPF32[i23 >> 2] = f18;
   i27 = i25 + 8 | 0;
   HEAPF32[i27 >> 2] = f17;
   HEAPF32[i25 + (i26 << 2) >> 2] = Math_fround(0.0);
   f19 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f32);
   f19 = Math_fround(Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f31) * f9)) + Math_fround(Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f11) * f2));
   f18 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f32);
   f18 = Math_fround(Math_fround(Math_fround(f10 * f18) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f31))) + Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f11)));
   f19 = Math_fround(Math_fround(f18 * f28) / Math_fround(f18 - f19));
   f28 = Math_fround(f28 - f19);
   HEAPF32[i29 >> 2] = f19;
   HEAPF32[i29 + 4 >> 2] = f28;
   STACKTOP = i30;
   return;
  }
 case 3:
  {
   i25 = ((i26 + 1 | 0) >>> 0) % 3 | 0;
   i26 = ((i26 + 2 | 0) >>> 0) % 3 | 0;
   HEAP32[i12 + 2116 >> 2] = 3;
   HEAP32[i13 + 92 >> 2] = 3;
   HEAP32[i12 >> 2] = HEAP32[i22 + (i25 << 2) >> 2];
   i23 = i22 + 12 | 0;
   HEAP32[i12 + 4 >> 2] = HEAP32[i23 + (i25 << 2) >> 2];
   i24 = i22 + 24 | 0;
   HEAP32[i12 + 8 >> 2] = HEAP32[i24 + (i25 << 2) >> 2];
   HEAP32[i12 + 92 >> 2] = HEAP32[i22 + (i26 << 2) >> 2];
   HEAP32[i12 + 96 >> 2] = HEAP32[i23 + (i26 << 2) >> 2];
   HEAP32[i12 + 100 >> 2] = HEAP32[i24 + (i26 << 2) >> 2];
   HEAPF32[i12 + 184 >> 2] = Math_fround(1.0);
   HEAPF32[i12 + 188 >> 2] = Math_fround(1.0);
   HEAPF32[i12 + 192 >> 2] = Math_fround(1.0);
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i27 + (i25 << 2) >> 2]) * f28);
   HEAPF32[i13 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i27 + (i26 << 2) >> 2]) * f28);
   HEAPF32[i13 + 8 >> 2] = f28;
   HEAP32[i15 + 92 >> 2] = 3;
   HEAP32[i16 + 2208 >> 2] = 0;
   __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i16, i12);
   __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i16, i13, i15);
   HEAP32[i29 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i29 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i29 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   STACKTOP = i30;
   return;
  }
 default:
  {
   if (i14 >>> 0 <= 3) {
    STACKTOP = i30;
    return;
   }
   i8 = ((i26 + 1 | 0) >>> 0) % 3 | 0;
   i6 = ((i26 + 2 | 0) >>> 0) % 3 | 0;
   f2 = Math_fround(f28 / Math_fround(i14 >>> 0));
   i7 = i14 + 3 | 0;
   HEAP32[i12 + 2116 >> 2] = i7;
   HEAP32[i13 + 92 >> 2] = i7;
   i1 = 0;
   do {
    i26 = i22 + (i1 * 12 | 0) | 0;
    HEAP32[i12 + (i1 << 2) >> 2] = HEAP32[i26 + (i8 << 2) >> 2];
    HEAP32[i12 + 92 + (i1 << 2) >> 2] = HEAP32[i26 + (i6 << 2) >> 2];
    HEAPF32[i12 + 184 + (i1 << 2) >> 2] = Math_fround(1.0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
   if (i14 >>> 0 < 4294967293) {
    HEAPF32[i12 + (i14 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 92 + (i14 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 184 + (i14 << 2) >> 2] = Math_fround(0.0);
    i26 = i14 + 1 | 0;
    HEAPF32[i12 + (i26 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 92 + (i26 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 184 + (i26 << 2) >> 2] = Math_fround(0.0);
    i26 = i26 + 1 | 0;
    HEAPF32[i12 + (i26 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 92 + (i26 << 2) >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 184 + (i26 << 2) >> 2] = Math_fround(0.0);
   }
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i27 + (i8 << 2) >> 2]) * f28);
   HEAPF32[i13 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i27 + (i6 << 2) >> 2]) * f28);
   HEAPF32[i13 + 8 >> 2] = f28;
   i4 = i14 + 1 | 0;
   i5 = i14 + 2 | 0;
   f2 = Math_fround(f2 * Math_fround(2.0));
   i1 = i14 << 2;
   i3 = 0;
   do {
    i27 = i3 + 3 | 0;
    _memset(i12 + (i27 * 92 | 0) | 0, 0, i1 | 0) | 0;
    HEAPF32[i12 + (i27 * 92 | 0) + (i3 << 2) >> 2] = Math_fround(2.0);
    i26 = i22 + (i3 * 12 | 0) | 0;
    HEAP32[i12 + (i27 * 92 | 0) + (i14 << 2) >> 2] = HEAP32[i26 + (i8 << 2) >> 2];
    HEAP32[i12 + (i27 * 92 | 0) + (i4 << 2) >> 2] = HEAP32[i26 + (i6 << 2) >> 2];
    HEAPF32[i12 + (i27 * 92 | 0) + (i5 << 2) >> 2] = Math_fround(1.0);
    HEAPF32[i13 + (i27 << 2) >> 2] = f2;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i14 | 0));
   HEAP32[i15 + 92 >> 2] = i7;
   HEAP32[i16 + 2208 >> 2] = 0;
   __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i16, i12);
   __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i16, i13, i15);
   _memcpy(i29 | 0, i15 | 0, i14 << 2 | 0) | 0;
   STACKTOP = i30;
   return;
  }
 }
}

function __ZN12_GLOBAL__N_123PrismaticJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i8, i7, i4, i5, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 28 | 0;
 i3 = i6;
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(f15 * f12);
 f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f10));
 f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f21 * f18));
 f22 = Math_fround(Math_fround(f12 * f14) + Math_fround(Math_fround(f15 * f19) + Math_fround(f17 * Math_fround(Math_fround(f21 * f10) - Math_fround(f20 * f18)))));
 f11 = Math_fround(Math_fround(f10 * f14) + Math_fround(Math_fround(f20 * f19) + Math_fround(f17 * Math_fround(Math_fround(f15 * f18) - Math_fround(f21 * f12)))));
 f14 = Math_fround(Math_fround(Math_fround(f21 * f19) + Math_fround(f17 * Math_fround(Math_fround(f20 * f12) - Math_fround(f15 * f10)))) + Math_fround(f18 * f14));
 f22 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f22);
 f11 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f11);
 f14 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f14);
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f20 = Math_fround(f17 * f15);
 f19 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f12 * f19));
 f21 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f10 * f21));
 f13 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f10 * f19) + Math_fround(f17 * f13))) - Math_fround(f12 * f21));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f13) + Math_fround(Math_fround(f18 * f19) + Math_fround(f17 * f21))) - Math_fround(f10 * f15));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f19) - Math_fround(f12 * f15)) - Math_fround(f10 * f13)) - Math_fround(f18 * f21));
 HEAPF32[i1 >> 2] = Math_fround(f20 - Math_fround(f18 * f13));
 i28 = i1 + 4 | 0;
 HEAPF32[i28 >> 2] = f2;
 i27 = i1 + 8 | 0;
 HEAPF32[i27 >> 2] = f9;
 i29 = i1 + 12 | 0;
 HEAPF32[i29 >> 2] = f21;
 i25 = i1 + 16 | 0;
 HEAPF32[i25 >> 2] = f22;
 i23 = i1 + 20 | 0;
 HEAPF32[i23 >> 2] = f11;
 i4 = i1 + 24 | 0;
 HEAPF32[i4 >> 2] = f14;
 f14 = Math_fround(Math_fround(HEAPF32[i7 + 44 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i7 + 48 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(HEAPF32[i7 + 52 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(f14 * f2);
 f18 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f11 * f18));
 f20 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f22 * f20));
 f10 = Math_fround(Math_fround(f2 * f13) + Math_fround(Math_fround(f14 * f9) + Math_fround(f21 * Math_fround(Math_fround(f22 * f18) - Math_fround(f11 * f20)))));
 f15 = Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f11 * f9) + Math_fround(f21 * Math_fround(Math_fround(f14 * f20) - Math_fround(f22 * f2)))));
 f13 = Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f21 * Math_fround(Math_fround(f11 * f2) - Math_fround(f14 * f18)))) + Math_fround(f20 * f13));
 f10 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) + f10);
 f15 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) + f15);
 f13 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) + f13);
 f14 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f11 = Math_fround(f21 * f14);
 f9 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f2 * f9));
 f22 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f18 * f22));
 f12 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(Math_fround(f18 * f9) + Math_fround(f21 * f12))) - Math_fround(f2 * f22));
 f17 = Math_fround(Math_fround(Math_fround(f2 * f12) + Math_fround(Math_fround(f20 * f9) + Math_fround(f21 * f22))) - Math_fround(f18 * f14));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f9) - Math_fround(f2 * f14)) - Math_fround(f18 * f12)) - Math_fround(f20 * f22));
 HEAPF32[i3 >> 2] = Math_fround(f11 - Math_fround(f20 * f12));
 HEAPF32[i3 + 4 >> 2] = f19;
 HEAPF32[i3 + 8 >> 2] = f17;
 HEAPF32[i3 + 12 >> 2] = f22;
 i26 = i3 + 16 | 0;
 HEAPF32[i26 >> 2] = f10;
 i24 = i3 + 20 | 0;
 HEAPF32[i24 >> 2] = f15;
 i5 = i3 + 24 | 0;
 HEAPF32[i5 >> 2] = f13;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i1 | 0, i3 | 0);
 f13 = Math_fround(HEAPF32[i29 >> 2]);
 f15 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(f10 * Math_fround(2.0));
 f17 = Math_fround(HEAPF32[i28 >> 2]);
 f19 = Math_fround(f17 * Math_fround(0.0));
 f22 = Math_fround(f22 + f19);
 f12 = Math_fround(HEAPF32[i27 >> 2]);
 f20 = Math_fround(f12 * Math_fround(0.0));
 f22 = Math_fround(f22 + f20);
 f20 = Math_fround(Math_fround(f10 * f22) + Math_fround(Math_fround(f15 * Math_fround(2.0)) + Math_fround(f13 * Math_fround(f19 - f20))));
 f19 = Math_fround(f15 * Math_fround(0.0));
 f11 = Math_fround(f10 * Math_fround(0.0));
 f18 = Math_fround(Math_fround(f17 * f22) + Math_fround(f19 + Math_fround(f13 * Math_fround(Math_fround(f12 * Math_fround(2.0)) - f11))));
 f22 = Math_fround(Math_fround(f19 + Math_fround(f13 * Math_fround(f11 - Math_fround(f17 * Math_fround(2.0))))) + Math_fround(f12 * f22));
 f11 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(HEAPF32[i25 >> 2]);
 f11 = Math_fround(f11 - f19);
 f14 = Math_fround(HEAPF32[i24 >> 2]);
 f2 = Math_fround(HEAPF32[i23 >> 2]);
 f14 = Math_fround(f14 - f2);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f21 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f11 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - f21) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(Math_fround(f10 * f11) + Math_fround(f17 * f14)) + Math_fround(f12 * f9));
 f2 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f15 * f9) - Math_fround(f13 * Math_fround(Math_fround(f10 * f14) - Math_fround(f17 * f11)))) + Math_fround(f12 * f16)) - f21)) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(Math_fround(f10 * f16) + Math_fround(Math_fround(f15 * f11) - Math_fround(f13 * Math_fround(Math_fround(f17 * f9) - Math_fround(f12 * f14))))) - f19)) + Math_fround(f18 * Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * Math_fround(Math_fround(f12 * f11) - Math_fround(f10 * f9))))) - f2))));
 if (!(HEAP16[i7 + 108 >> 1] & 2)) {
  STACKTOP = i6;
  return;
 }
 f22 = Math_fround(HEAPF32[i7 + 96 >> 2]);
 i29 = i7 + 88 | 0;
 mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0, i3 | 0, +f22, f2 < Math_fround(f22 + Math_fround(HEAPF32[i29 >> 2])) | 0);
 f22 = Math_fround(HEAPF32[i7 + 92 >> 2]);
 mftCall_viiifi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0, i3 | 0, +f22, f2 > Math_fround(f22 - Math_fround(HEAPF32[i29 >> 2])) | 0);
 STACKTOP = i6;
 return;
}

function __ZNK14RenderSettings12SetupAmbientEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0;
 i1 = i19 + 28 | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f4 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 32 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f3 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 36 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i17 = HEAP32[i1 >> 2] | 0;
  i18 = HEAP32[i19 + 32 >> 2] | 0;
  i15 = HEAP32[i19 + 36 >> 2] | 0;
 }
 i14 = i19 + 40 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 i1 = i19 + 44 | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f4 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 48 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f3 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 52 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i12 = HEAP32[i1 >> 2] | 0;
  i13 = HEAP32[i19 + 48 >> 2] | 0;
  i10 = HEAP32[i19 + 52 >> 2] | 0;
 }
 i11 = HEAP32[i19 + 56 >> 2] | 0;
 i1 = i19 + 60 | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f4 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 64 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f3 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i19 + 68 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i8 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i19 + 64 >> 2] | 0;
  i1 = HEAP32[i19 + 68 >> 2] | 0;
 }
 i6 = HEAP32[i19 + 72 >> 2] | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 f3 = Math_fround(HEAPF32[i19 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i19 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i19 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  do if (!(f3 <= Math_fround(.0404499993))) {
   if (f3 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, 2.20000005));
  } else f3 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
  do if (!(f4 <= Math_fround(.0404499993))) {
   if (f4 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
  } else f4 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
  if (f2 <= Math_fround(.0404499993)) {
   f2 = Math_fround(f2 / Math_fround(12.9200001));
   break;
  }
  if (f2 < Math_fround(1.0)) {
   f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
 } while (0);
 f20 = Math_fround(f4 * Math_fround(.5));
 f4 = Math_fround(f2 * Math_fround(.5));
 f5 = Math_fround(f5 * Math_fround(.5));
 HEAPF32[i7 + 532 >> 2] = Math_fround(f3 * Math_fround(.5));
 HEAPF32[i7 + 536 >> 2] = f20;
 HEAPF32[i7 + 540 >> 2] = f4;
 HEAPF32[i7 + 544 >> 2] = f5;
 HEAP32[i7 + 1460 >> 2] = i17;
 HEAP32[i7 + 1464 >> 2] = i18;
 HEAP32[i7 + 1468 >> 2] = i15;
 HEAP32[i7 + 1472 >> 2] = i16;
 HEAP32[i7 + 1476 >> 2] = i12;
 HEAP32[i7 + 1480 >> 2] = i13;
 HEAP32[i7 + 1484 >> 2] = i10;
 HEAP32[i7 + 1488 >> 2] = i11;
 HEAP32[i7 + 1492 >> 2] = i8;
 HEAP32[i7 + 1496 >> 2] = i9;
 HEAP32[i7 + 1500 >> 2] = i1;
 HEAP32[i7 + 1504 >> 2] = i6;
 i18 = i19 + 392 | 0;
 i19 = i7 + 1508 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 return;
}

function __ZN14PhysicsManager18ProcessJointBreaksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 16 | 0;
 i10 = i17;
 i16 = i17 + 28 | 0;
 if ((HEAP16[gb + 1452488 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452488 | 0, i9);
  i13 = gb + 1452488 | 0;
 } else i13 = 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i14;
 HEAP32[i16 >> 2] = 0;
 i5 = i16 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i10);
 i2 = i9;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = i1 + 92 | 0;
 i12 = i1 + 96 | 0;
 i1 = (HEAP32[i12 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 i4 = HEAP32[i14 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i14 >> 2] = i2;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i16 >> 2] = i7;
  break;
 } while (0);
 if (i2 >>> 0 > i3 >>> 0) _memset((HEAP32[i16 >> 2] | 0) + (i3 << 2) | 0, 0, i1 - (i3 << 2) | 0) | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i4 = i3;
  i1 = i3;
  i2 = i3;
 } else {
  i6 = i9 + 4 | 0;
  i7 = i9 + 8 | 0;
  i5 = 0;
  do {
   i4 = i2 + (i5 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i8 = 20; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i18 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 20; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i8 = 22;
     }
    }
    if ((i8 | 0) == 20) i8 = 22;
    if ((i8 | 0) == 22) {
     i8 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
     __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_(i1, i9, i10);
     f19 = Math_fround(HEAPF32[i9 >> 2]);
     f19 = Math_fround(f19 * f19);
     f20 = Math_fround(HEAPF32[i6 >> 2]);
     f20 = Math_fround(f19 + Math_fround(f20 * f20));
     f19 = Math_fround(HEAPF32[i7 >> 2]);
     f19 = Math_fround(Math_sqrt(Math_fround(f20 + Math_fround(f19 * f19))));
     HEAPF32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] = f19;
    }
   } while (0);
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  } while (i5 >>> 0 < i1 - i2 >> 2 >>> 0);
  i4 = i2;
  if ((i1 | 0) != (i2 | 0)) {
   i6 = i9 + 8 | 0;
   i7 = i9 + 4 | 0;
   i5 = 0;
   i1 = i4;
   while (1) {
    i4 = i1 + (i5 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i10 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i8 = 40; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
       i2 = HEAP32[i9 >> 2] | 0;
       i18 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 40; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i8 = 42; else i8 = 43;
      }
     }
     if ((i8 | 0) == 40) i8 = 42;
     if ((i8 | 0) == 42) {
      i8 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (i1 | 0) i8 = 43;
     }
     if ((i8 | 0) == 43) {
      i8 = 0;
      i1 = i1 + 28 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
       i18 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
       i3 = HEAP32[i1 >> 2] | 0;
       i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
       HEAP32[i9 >> 2] = gb + 29272;
       HEAP32[i6 >> 2] = 0;
       HEAP32[i7 >> 2] = i2;
       __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1104996 | 0, i9);
       __Z24SetExecutionRestrictions21ExecutionRestrictions(i18) | 0;
      }
     }
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) {
      HEAP32[i10 >> 2] = i1;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i8 = 52; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
        i2 = HEAP32[i9 >> 2] | 0;
        i18 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 52; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i8 = 54;
       }
      }
      if ((i8 | 0) == 52) i8 = 54;
      if ((i8 | 0) == 54) {
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
       if (!i1) break;
      }
      if (HEAP32[i1 + 28 >> 2] | 0) {
       i18 = __Z24SetExecutionRestrictions21ExecutionRestrictions(0) | 0;
       __Z22DestroyObjectHighLevelP6Objectb(i1, 1);
       __Z24SetExecutionRestrictions21ExecutionRestrictions(i18) | 0;
      }
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = i2;
    if (i5 >>> 0 >= i1 - i2 >> 2 >>> 0) {
     i4 = i3;
     break;
    } else i1 = i3;
   }
  }
 }
 if ((i1 | 0) != (i4 | 0)) HEAP32[i12 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
  HEAP32[i16 >> 2] = 0;
 }
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i17;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i14, i1, i12, i10, i11, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 600 | 0;
 i4 = i13 + 16 | 0;
 i3 = i13;
 i9 = i13 + 24 | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832239 | 0, i9 | 0) | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i8, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break;
   i6 = mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0) | 0;
   if (!i6) {
    i15 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i3 >> 2] = gb + 833471;
    i12 = i3 + 8 | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i2;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i15, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i3);
    break;
   }
   do if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832272 | 0, i9 | 0) | 0) {
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
     i5 = _strtoul(i1, i8, 10) | 0;
     if (!i5) break;
     if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, gb + 832282 | 0, i9 | 0) | 0) {
      i1 = HEAP32[i9 >> 2] | 0;
      HEAP32[i8 >> 2] = i1;
      if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i8, 10) | 0;
     } else i1 = 0;
     i7 = __ZN5physx22PxVehicleWheelsSimData8allocateEj(i5) | 0;
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 833671 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i7, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     HEAPF32[i9 + 80 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 84 >> 2] = Math_fround(500.0);
     HEAPF32[i9 + 88 >> 2] = Math_fround(600.0);
     HEAPF32[i9 + 92 >> 2] = Math_fround(.150000006);
     HEAPF32[i9 + 96 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 100 >> 2] = Math_fround(.349999994);
     HEAPF32[i9 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 4 >> 2] = Math_fround(.800000011);
     HEAPF32[i9 + 8 >> 2] = Math_fround(.330000013);
     HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 16 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 20 >> 2] = Math_fround(.800000011);
     HEAP32[i9 + 64 >> 2] = 3;
     HEAPF32[i9 + 104 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 108 >> 2] = Math_fround(.00166666671);
     HEAPF32[i9 + 240 >> 2] = Math_fround(4.0);
     HEAP32[i9 + 244 >> 2] = 7;
     HEAPF32[i9 + 248 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 112 >> 2] = Math_fround(-4.0);
     HEAPF32[i9 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 120 >> 2] = Math_fround(4.0);
     HEAPF32[i9 + 124 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 128 >> 2] = Math_fround(1.5);
     HEAPF32[i9 + 132 >> 2] = Math_fround(1.10000002);
     HEAPF32[i9 + 136 >> 2] = Math_fround(1.0);
     i2 = i9 + 140 | 0;
     i3 = i2 + 100 | 0;
     do {
      HEAP32[i2 >> 2] = 0;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) < (i3 | 0));
     HEAPF32[i9 + 256 >> 2] = Math_fround(10.0);
     HEAP32[i9 + 260 >> 2] = 1;
     HEAP32[i9 + 264 >> 2] = 5;
     i2 = 0;
     do {
      HEAPF32[i9 + 272 + (i2 << 2) >> 2] = Math_fround(.649999976);
      HEAPF32[i9 + 400 + (i2 << 2) >> 2] = Math_fround(.5);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != 32);
     HEAPF32[i9 + 276 >> 2] = Math_fround(.150000006);
     HEAPF32[i9 + 400 >> 2] = Math_fround(2.0);
     HEAPF32[i9 + 528 >> 2] = Math_fround(.449999988);
     HEAPF32[i9 + 532 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 536 >> 2] = Math_fround(.5);
     HEAPF32[i9 + 540 >> 2] = Math_fround(1.29999995);
     HEAPF32[i9 + 544 >> 2] = Math_fround(1.29999995);
     HEAPF32[i9 + 548 >> 2] = Math_fround(1.29999995);
     HEAP32[i9 + 552 >> 2] = 0;
     HEAPF32[i9 + 560 >> 2] = Math_fround(1.0);
     HEAPF32[i9 + 564 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 568 >> 2] = Math_fround(0.0);
     HEAPF32[i9 + 572 >> 2] = Math_fround(0.0);
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 834565 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i9, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i12 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, gb + 833686 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i9, i10, i15) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0);
     i3 = HEAP32[i11 >> 2] | 0;
     i4 = (HEAP16[i6 + 4 >> 1] | 0) == 5 ? i6 : 0;
     i6 = __ZN5physx16PxVehicleDrive4W8allocateEj(i5) | 0;
     __ZN5physx16PxVehicleDrive4W5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj(i6, i3, (HEAP16[i4 + 4 >> 1] | 0) == 5 ? i4 : 0, i7, i9, i1);
     HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDrive4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i12, i6, i10, i15) | 0;
     i4 = HEAP32[i6 + 72 >> 2] | 0;
     i5 = i7 + 36 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) {
      i3 = 0;
      do {
       i2 = HEAP32[(HEAP32[i4 + (i3 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
       if (i2) {
        mftCall_viiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i2 | 0, 0, 0);
        i1 = HEAP32[i5 >> 2] | 0;
       }
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     __ZN5physx22PxVehicleWheelsSimData4freeEv(i7);
     HEAP32[i14 >> 2] = gb + 835156;
     HEAP32[i14 + 4 >> 2] = i6;
     i15 = i14 + 8 | 0;
     HEAP32[i15 >> 2] = i6;
     HEAP32[i15 + 4 >> 2] = 0;
     STACKTOP = i13;
     return;
    }
   } while (0);
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 833484 | 0, 88, gb + 833575 | 0, i4);
   HEAP32[i14 >> 2] = gb + 1576256;
   HEAP32[i14 + 4 >> 2] = 0;
   i15 = i14 + 8 | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i14 >> 2] = gb + 1576256;
 HEAP32[i14 + 4 >> 2] = 0;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN6Shader8TransferI18StreamedBinaryReadILb1EEEEvRT_(i25, i26) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 24 | 0;
 i5 = i28 + 16 | 0;
 i11 = i28 + 8 | 0;
 i14 = i28 + 116 | 0;
 i15 = i28 + 96 | 0;
 i18 = i28 + 76 | 0;
 i19 = i28 + 56 | 0;
 i22 = i28 + 36 | 0;
 i1 = i28;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i25, i26);
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i11);
 i16 = i27;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = i13;
 HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i20 + 4 >> 2] = i17;
 i20 = gb + 64016 | 0;
 i17 = HEAP32[i20 + 4 >> 2] | 0;
 i16 = i11;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i16 = i15 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i11);
 i20 = i27;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i6 = i17;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i6 + 4 >> 2] = i21;
 i6 = gb + 64016 | 0;
 i21 = HEAP32[i6 + 4 >> 2] | 0;
 i20 = i11;
 HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i20 = i18 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i11);
 i6 = i27;
 i23 = HEAP32[i6 + 4 >> 2] | 0;
 i24 = i21;
 HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i24 + 4 >> 2] = i23;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = i23;
 HEAP32[i19 >> 2] = 0;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i23 = i19 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i11);
 i7 = i27;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i24;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i22 >> 2] = 0;
 i7 = i22 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i22 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i11);
 i3 = i27;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i25 + 96 >> 2] | 0, i26);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i26, i14, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i26, i15, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i26, i18, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i26, i19, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i26, i22, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i26);
 if (HEAP32[i2 >> 2] | 0) {
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i3;
  HEAP32[i27 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i8 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i27) | 0;
  i3 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i3 << 2) >> 2] | 0;
  L3 : do if ((i3 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i2 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i14 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L3;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i5 >> 2] = i4;
   __Z6FormatPKcz(i27, gb + 470364 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i27 + 11 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i4 = i25 + 60 | 0;
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i27 >> 2] = i5;
   HEAP32[i11 >> 2] = i3;
   if ((i3 | 0) != 0 & (i5 | 0 ? (HEAP32[i7 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i25 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i25 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i25 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i25 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i7;
     i1 = i7;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, (HEAP32[i22 >> 2] | 0) + i6 | 0, i11 | 0, i1 | 0, i27 | 0) | 0;
   }
  }
  if (i8 | 0) mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i10);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i24);
  HEAP32[i19 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i21);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i17);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 i3 = i25 + 80 | 0;
 i4 = i26 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i26 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i27, 4);
  i1 = HEAP32[i27 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i27 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i25 + 84 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i26);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i25 + 92 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i27, 1);
  i27 = HEAP8[i27 >> 0] | 0;
  HEAP8[i1 >> 0] = i27;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i26);
  STACKTOP = i28;
  return;
 } else {
  i25 = HEAP8[i2 >> 0] | 0;
  HEAP8[i27 >> 0] = i25;
  HEAP32[i4 >> 2] = i3;
  i27 = i25;
  HEAP8[i1 >> 0] = i27;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i26);
  STACKTOP = i28;
  return;
 }
}

function __ZN13AvatarBuilder14GetAllChildrenER9TransformR8UnityStrRNSt3__26vectorINS_14NamedTransformENS4_9allocatorIS6_EEEERKNS5_IS2_NS7_IS2_EEEE(i13, i14, i15, i16) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 40 | 0;
 i12 = i17;
 i7 = HEAP32[i16 + 4 >> 2] | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i4 = i9;
 i8 = i7;
 if ((i7 | 0) == (i9 | 0)) i10 = 22; else {
  i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i10 = 5;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i12 + 11 >> 0] = i3;
   if (!i3) i1 = i12; else {
    i1 = i12;
    i10 = 7;
   }
  } else i10 = 5;
  if ((i10 | 0) == 5) {
   i9 = i3 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i3;
   i10 = 7;
  }
  if ((i10 | 0) == 7) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i7 = HEAP8[i12 + 11 >> 0] | 0;
  L12 : do if ((i4 | 0) == (i8 | 0)) i1 = 0; else {
   i6 = i7 << 24 >> 24 < 0;
   i5 = i6 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
   i6 = i6 ? HEAP32[i12 >> 2] | 0 : i12;
   while (1) {
    i3 = HEAP8[i4 + 11 >> 0] | 0;
    i1 = i3 << 24 >> 24 < 0;
    if (i1) i2 = HEAP32[i4 + 4 >> 2] | 0; else i2 = i3 & 255;
    if ((i2 | 0) == (i5 | 0)) {
     if (i1) {
      i2 = HEAP32[i4 >> 2] | 0;
      i1 = HEAP32[i4 + 4 >> 2] | 0;
     } else {
      i2 = i4;
      i1 = i3 & 255;
     }
     if (!(_strncmp(i2, i6, i1) | 0)) {
      i1 = 1;
      break L12;
     }
    }
    i4 = i4 + 16 | 0;
    if ((i4 | 0) == (i8 | 0)) {
     i1 = 0;
     break;
    }
   }
  } while (0);
  if (i7 << 24 >> 24 < 0) {
   i9 = HEAP32[i12 >> 2] | 0;
   i8 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
  }
  if (i1) i10 = 22;
 }
 if ((i10 | 0) == 22) {
  i1 = i12;
  i2 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i9 = i12 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i9 = i15 + 4 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i15, i12); else {
   __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i1, i12);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 36;
  }
  i1 = i12 + 16 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = HEAP32[i12 + 28 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
  }
  if ((HEAP8[i12 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i12 >> 2] | 0;
   i7 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
  }
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i6 + -4 >> 2] = i13;
  i1 = i6 + -20 | 0;
  do if ((i1 | 0) != (i14 | 0)) {
   i8 = HEAP8[i14 + 11 >> 0] | 0;
   i4 = i8 << 24 >> 24 < 0;
   i7 = i4 ? HEAP32[i14 >> 2] | 0 : i14;
   i8 = i4 ? HEAP32[i14 + 4 >> 2] | 0 : i8 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i6 + -12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i8 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i6 + -16 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
    break;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
   HEAP8[i1 + i8 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i6 + -16 >> 2] = i8;
    break;
   } else {
    HEAP8[i4 >> 0] = i8;
    break;
   }
  } while (0);
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = i8 + -36 | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i10 = 48;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i12 + 11 >> 0] = i3;
   if (!i3) i1 = i12; else {
    i1 = i12;
    i10 = 50;
   }
  } else i10 = 48;
  if ((i10 | 0) == 48) {
   i7 = i3 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i3;
   i10 = 50;
  }
  if ((i10 | 0) == 50) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i5 = i12 + 11 | 0;
  do if ((i9 | 0) != (i12 | 0)) {
   i7 = HEAP8[i5 >> 0] | 0;
   i3 = i7 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
   i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
   i3 = i9 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i8 + -28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i7 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i8 + -32 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
    break;
   }
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i8 + -32 >> 2] = i7;
    break;
   } else {
    HEAP8[i3 >> 0] = i7;
    break;
   }
  } while (0);
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   i10 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
  }
 }
 i5 = i13 + 92 | 0;
 if ((HEAP32[i5 >> 2] | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i2 = i13 + 80 | 0;
 i3 = i14 + 11 | 0;
 i4 = i14 + 4 | 0;
 i1 = 0;
 do {
  i12 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i13 = HEAP8[i3 >> 0] | 0;
  i13 = i13 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i13 & 255;
  __Z19AppendTransformPathR8UnityStrPKc(i14, mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0) | 0);
  __ZN13AvatarBuilder14GetAllChildrenER9TransformR8UnityStrRNSt3__26vectorINS_14NamedTransformENS4_9allocatorIS6_EEEERKNS5_IS2_NS7_IS2_EEEE(i12, i14, i15, i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i14, i13, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
 STACKTOP = i17;
 return;
}

function __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 56 | 0;
 i15 = i20 + 36 | 0;
 i16 = i20 + 12 | 0;
 i18 = i20;
 i14 = i20 + 24 | 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i19 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i19;
 __ZN19RuntimeSceneManager31CollectDontDestroyOnLoadObjectsERNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(__Z15GetSceneManagerv() | 0, i16);
 i9 = i18 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i18 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i17 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = i17;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) != (i19 | 0)) {
  i8 = i17;
  i2 = i1;
  while (1) {
   i5 = HEAP32[i2 + 16 >> 2] | 0;
   do if (i5 | 0) {
    HEAP32[i15 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i15);
      i3 = HEAP32[i12 >> 2] | 0;
      i7 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 10; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 12;
     }
    }
    if ((i11 | 0) == 10) i11 = 12;
    if ((i11 | 0) == 12) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     if (!i1) break;
    }
    i7 = i1 + 8 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if (!(i5 & 32768)) {
     i6 = HEAP32[i1 + 4 >> 2] | 0;
     i1 = HEAP32[i17 >> 2] | 0;
     do if (!i1) {
      HEAP32[i12 >> 2] = i17;
      i3 = i8;
      i4 = i17;
     } else {
      while (1) {
       i3 = HEAP32[i1 + 16 >> 2] | 0;
       if ((i6 | 0) < (i3 | 0)) {
        i3 = HEAP32[i1 >> 2] | 0;
        if (!i3) {
         i11 = 17;
         break;
        } else i1 = i3;
       } else {
        if ((i3 | 0) >= (i6 | 0)) {
         i11 = 22;
         break;
        }
        i4 = i1 + 4 | 0;
        i3 = HEAP32[i4 >> 2] | 0;
        if (!i3) {
         i11 = 21;
         break;
        } else i1 = i3;
       }
      }
      if ((i11 | 0) == 17) {
       i11 = 0;
       HEAP32[i12 >> 2] = i1;
       i3 = i1;
       i4 = i1;
       break;
      } else if ((i11 | 0) == 21) {
       i11 = 0;
       HEAP32[i12 >> 2] = i1;
       i3 = i1;
       break;
      } else if ((i11 | 0) == 22) {
       i11 = 0;
       HEAP32[i12 >> 2] = i1;
       i3 = i1;
       i4 = i12;
       break;
      }
     } while (0);
     if (!(HEAP32[i4 >> 2] | 0)) {
      i1 = __Znwj(20) | 0;
      HEAP32[i1 + 16 >> 2] = i6;
      HEAP32[i1 >> 2] = 0;
      HEAP32[i1 + 4 >> 2] = 0;
      HEAP32[i1 + 8 >> 2] = i3;
      HEAP32[i4 >> 2] = i1;
      i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
      if (i3) {
       HEAP32[i18 >> 2] = i3;
       i1 = HEAP32[i4 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
      i1 = HEAP32[i7 >> 2] | 0;
     } else i1 = i5;
     HEAP32[i7 >> 2] = i1 | 32768;
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i19 | 0)) break; else i2 = i1;
  }
 }
 i1 = __Z9GetIAudiov() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 __Z15UnloadGameScenev();
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (i17 | 0)) {
  i2 = i1;
  while (1) {
   i5 = i2 + 16 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i15 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 44; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i15);
      i3 = HEAP32[i12 >> 2] | 0;
      i10 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 44; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 46;
     }
    }
    if ((i11 | 0) == 44) i11 = 46;
    if ((i11 | 0) == 46) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i10 = i1 + 8 | 0;
    HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -32769;
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i17 | 0)) break; else i2 = i1;
  }
 }
 __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv(i13 + 180 | 0);
 __ZN18LoadSceneOperation21CompleteAwakeSequenceEv(i13);
 __Z16CleanupAfterLoadv();
 if ((HEAP32[i13 + 460 >> 2] | 0) != 2) {
  i13 = __ZNK10UnityScene13GetBuildIndexEv(HEAP32[i13 + 160 >> 2] | 0) | 0;
  HEAP32[i14 >> 2] = gb + 29192;
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[gb + 1105696 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1105696 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[gb + 1105696 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[gb + 1105696 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[gb + 1105696 + 16 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i15, i12);
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 768 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i15 = __Z14GetTimeManagerv() | 0;
  __ZN11TimeManager21DidFinishLoadingSceneEv(i15);
  i17 = HEAP32[i17 >> 2] | 0;
  __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i18, i17);
  i19 = HEAP32[i19 >> 2] | 0;
  __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i16, i19);
  STACKTOP = i20;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i15 = __Z14GetTimeManagerv() | 0;
 __ZN11TimeManager21DidFinishLoadingSceneEv(i15);
 i17 = HEAP32[i17 >> 2] | 0;
 __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i18, i17);
 i19 = HEAP32[i19 >> 2] | 0;
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i16, i19);
 STACKTOP = i20;
 return;
}

function __ZN14NavMeshManager16LoadDataInternalEPK11NavMeshData(i26, i16) {
 i26 = i26 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i36 + 48 | 0;
 i27 = i36;
 i28 = i36 + 136 | 0;
 i35 = i36 + 72 | 0;
 i14 = i36 + 56 | 0;
 i2 = i26 + 120 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 1;
  i1 = 1;
 }
 HEAP32[i2 >> 2] = i1 + 1;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i35 + 4 >> 2] = 0;
 i11 = i35 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i33 = i35 + 20 | 0;
 HEAP32[i33 >> 2] = 0;
 i34 = i35 + 8 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, gb + 63664 | 0);
 i30 = i27;
 i32 = HEAP32[i30 + 4 >> 2] | 0;
 i31 = i34;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i31 + 4 >> 2] = i32;
 HEAP32[i35 + 24 >> 2] = 0;
 HEAP32[i35 + 36 >> 2] = 0;
 i31 = i35 + 40 | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i35 + 28 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, gb + 63664 | 0);
 i30 = i27;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i25 = i32;
 HEAP32[i25 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i25 + 4 >> 2] = i29;
 HEAP32[i35 + 44 >> 2] = 0;
 i25 = i35 + 56 | 0;
 HEAP32[i25 >> 2] = 0;
 i29 = i35 + 60 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i35 + 48 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, gb + 63664 | 0);
 i2 = i27;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i30;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i35 >> 2] = i16;
 i12 = i16 + 52 | 0;
 i13 = i16 + 56 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) i17 = 21; else {
  i9 = i26 + 108 | 0;
  i10 = i35 + 4 | 0;
  i8 = 0;
  while (1) {
   i1 = i3;
   i4 = HEAP32[i1 + (i8 * 20 | 0) + 12 >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i1 + (i8 * 20 | 0) >> 2] | 0;
    i24 = i27;
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    i1 = __ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy(HEAP32[i9 >> 2] | 0, i1, i4, 0, HEAP32[i28 >> 2] | 0, i27) | 0;
    if ((i1 | 0) < 0) break;
    i5 = i27;
    i5 = HEAP32[(__ZNK9dtNavMesh12getTileByRefEy(HEAP32[i9 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0) | 0) + 8 >> 2] | 0;
    i4 = HEAP32[i5 + 8 >> 2] | 0;
    i5 = HEAP32[i5 + 12 >> 2] | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i2 = HEAP32[i33 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i7 >>> 0 > i3 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i33 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 3, 4, i34, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i34, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i24 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
      HEAP32[i33 >> 2] = i1;
      HEAP32[i10 >> 2] = i24;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i7;
    i2 = (HEAP32[i10 >> 2] | 0) + (i6 << 3) | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = HEAP32[i13 >> 2] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
   }
   i1 = i8 + 1 | 0;
   if (i1 >>> 0 < ((i2 - i3 | 0) / 20 | 0) >>> 0) i8 = i1; else {
    i17 = 20;
    break;
   }
  }
  if ((i17 | 0) == 20) {
   i1 = HEAP32[i28 >> 2] | 0;
   i17 = 21;
   break;
  }
  do if (!(i1 & 3)) if (!(i1 & 4)) {
   HEAP32[i15 >> 2] = i8;
   HEAP32[i15 + 4 >> 2] = i1;
   __Z6FormatPKcz(i14, gb + 846249 | 0, i15);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 842172 | 0, 451, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   break;
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 846209 | 0, 0, gb + 842172 | 0, 447, 1, 0, 0, 0);
   break;
  } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 846143 | 0, 0, gb + 842172 | 0, 443, 1, 0, 0, 0); while (0);
  i2 = 0;
 } while (0);
 if ((i17 | 0) == 21) {
  __ZN15HeightMeshQuery13AddHeightDataEiPKNSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEPK13dynamic_arrayI13HeightmapDataLj4EE(HEAP32[i26 + 116 >> 2] | 0, i1, i16 + 88 | 0, i16 + 68 | 0);
  i24 = i16 + 104 | 0;
  i9 = i16 + 108 | 0;
  i1 = HEAP32[i24 >> 2] | 0;
  if ((HEAP32[i9 >> 2] | 0) != (i1 | 0)) {
   i10 = i27 + 4 | 0;
   i11 = i27 + 8 | 0;
   i12 = i27 + 12 | 0;
   i13 = i27 + 16 | 0;
   i14 = i27 + 20 | 0;
   i15 = i27 + 24 | 0;
   i16 = i27 + 28 | 0;
   i17 = i27 + 32 | 0;
   i18 = i27 + 36 | 0;
   i19 = i27 + 40 | 0;
   i20 = i27 + 42 | 0;
   i21 = i27 + 44 | 0;
   i22 = i26 + 108 | 0;
   i23 = i35 + 44 | 0;
   i8 = 0;
   do {
    i2 = i1;
    i3 = i2 + (i8 << 5) | 0;
    HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i3 + 8 >> 2];
    i3 = i2 + (i8 << 5) + 12 | 0;
    HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i2 + (i8 << 5) + 24 >> 2];
    HEAPF32[i16 >> 2] = Math_fround(-1.0);
    HEAP8[i17 >> 0] = HEAP8[i2 + (i8 << 5) + 31 >> 0] | 0;
    i3 = HEAP8[i2 + (i8 << 5) + 30 >> 0] | 0;
    HEAP32[i18 >> 2] = 1 << (i3 & 255);
    HEAP8[i19 >> 0] = i3;
    HEAP16[i20 >> 1] = HEAP16[i2 + (i8 << 5) + 28 >> 1] | 0;
    HEAP32[i21 >> 2] = 0;
    i2 = __ZN9dtNavMesh20addOffMeshConnectionEPK25dtOffMeshConnectionParams(HEAP32[i22 >> 2] | 0, i27) | 0;
    i3 = getTempRet0() | 0;
    if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
     i4 = HEAP32[i25 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i29 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i1 = i6 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i29 >> 2] = i1;
       HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 3, 8, i30, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i30, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i25 >> 2] << 3 | 0) | 0;
       HEAP32[i29 >> 2] = i1;
       HEAP32[i23 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i25 >> 2] = i5;
     i7 = (HEAP32[i23 >> 2] | 0) + (i4 << 3) | 0;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i7 + 4 >> 2] = i3;
    }
    i8 = i8 + 1 | 0;
    i1 = HEAP32[i24 >> 2] | 0;
   } while (i8 >>> 0 < (HEAP32[i9 >> 2] | 0) - i1 >> 5 >>> 0);
  }
  __ZN14NavMeshManager9LayerDataaSERKS0_(__ZNSt3__23mapIiN14NavMeshManager9LayerDataENS_4lessIiEENS_9allocatorINS_4pairIKiS2_EEEEEixERS7_(i26 + 124 | 0, i28) | 0, i35) | 0;
  i1 = HEAP32[i26 + 104 >> 2] | 0;
  if (i1 | 0) __ZN14NavMeshCarving13SetDirtyLayerEi(i1, HEAP32[i28 >> 2] | 0);
  i2 = HEAP32[i28 >> 2] | 0;
 }
 i1 = i35 + 44 | 0;
 if ((HEAP32[i29 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i30);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i35 + 24 | 0;
 if ((HEAP32[i31 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i32);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i35 + 4 | 0;
 if ((HEAP32[i33 >> 2] | 0) <= -1) {
  STACKTOP = i36;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i34);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i36;
 return i2 | 0;
}

function __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i35, i32, i1, i2) {
 i35 = i35 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37;
 i28 = i37 + 276 | 0;
 i22 = i37 + 224 | 0;
 i29 = i37 + 32 | 0;
 i30 = i37 + 20 | 0;
 i27 = i37 + 16 | 0;
 i23 = i37 + 280 | 0;
 i33 = i35 + 20 | 0;
 i24 = HEAP32[i33 >> 2] | 0;
 i25 = i35 + 32 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i34 = i35 + 4 | 0;
 i4 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i35 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = i1;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i28) | 0;
 i1 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i35 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i33 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i35 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i35 + 36 | 0;
 L12 : do if (HEAP8[i21 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i35, gb + 830924 | 0);
  if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i33 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i21 >> 0] = i1;
  }
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i4 = i35 + 40 | 0;
   i5 = i30 + 4 | 0;
   i6 = i30 + 8 | 0;
   i7 = i35 + 28 | 0;
   i8 = i35 + 8 | 0;
   i9 = i35 + 8 | 0;
   i10 = i28;
   i11 = i22 + 4 | 0;
   i12 = i22 + 8 | 0;
   i13 = i22 + 20 | 0;
   i14 = i22 + 24 | 0;
   i15 = i22 + 28 | 0;
   i16 = i22 + 32 | 0;
   i17 = i22 + 36 | 0;
   i18 = i22 + 40 | 0;
   i19 = i22 + 44 | 0;
   i20 = i22 + 48 | 0;
   while (1) {
    if (!(i1 << 24 >> 24)) i1 = gb + 1576256 | 0; else {
     i1 = HEAP32[i33 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    }
    do if (!(_strcasecmp(i1, gb + 673430 | 0) | 0)) {
     i1 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     HEAP32[i28 >> 2] = i1;
     if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
      i1 = _strtoull(i1, i28, 10) | 0;
      i2 = getTempRet0() | 0;
      if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i31 >> 2] = gb + 690295;
        i38 = i31 + 8 | 0;
        HEAP32[i38 >> 2] = i1;
        HEAP32[i38 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i31);
        HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
        break;
       } else {
        mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i3 | 0);
        break;
       }
      }
     }
    } else {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i27 >> 2] = 0;
     __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i35, i27, i30);
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i1 = HEAP32[i27 >> 2] | 0; else {
      i3 = HEAP32[i8 >> 2] | 0;
      i39 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
      i1 = HEAP32[i27 >> 2] | 0;
      i38 = HEAP32[i30 >> 2] | 0;
      HEAP8[i23 >> 0] = 11;
      i2 = mftCall_iiiiiii(i39 | 0, i3 | 0, i1 | 0, i38 | 0, i2 & 65535 | 0, 1, i23 | 0) | 0;
      if (i2) {
       __ZN5physx20PxShapeGeneratedInfoC2Ev(i29);
       i41 = HEAP32[i35 >> 2] | 0;
       i40 = HEAP32[i34 >> 2] | 0;
       i3 = HEAP32[i33 >> 2] | 0;
       i38 = HEAP32[i7 >> 2] | 0;
       i39 = HEAP32[i25 >> 2] | 0;
       HEAP8[i28 >> 0] = 0;
       HEAP32[i22 >> 2] = i41;
       HEAP32[i11 >> 2] = i40;
       HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i13 >> 2] = i3;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i15 >> 2] = i38;
       HEAP32[i16 >> 2] = i39;
       HEAP8[i17 >> 0] = 1;
       HEAP32[i18 >> 2] = i10;
       HEAP32[i19 >> 2] = 0;
       HEAP32[i20 >> 2] = 0;
       __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j(i29, i22, 0) | 0;
       if (HEAP8[i28 >> 0] | 0) HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
       mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i2 | 0);
       mftCall_viiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i2 | 0, 0, 0);
      }
     }
     i41 = HEAP32[i7 >> 2] | 0;
     i41 = mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 16 >> 2] | 0, i41 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
     i41 = HEAP32[i6 >> 2] | 0;
     if ((i41 | 0) > -1 & (i41 & 2147483647 | 0) != 0) {
      i1 = HEAP32[i30 >> 2] | 0;
      if (i1 | 0) {
       i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
      }
     }
    } while (0);
    if (!(HEAP8[i21 >> 0] | 0)) break L12;
    i41 = HEAP32[i33 >> 2] | 0;
    if (!(mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 24 >> 2] | 0, i41 | 0) | 0)) break L12;
    i1 = HEAP8[i21 >> 0] | 0;
   }
  }
 } while (0);
 i2 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i37;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i36 = 39;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i33 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i35 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i36 | 0) == 39) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i34 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i37;
 return;
}

function __ZN13AvatarBuilder17GenerateAvatarMapERK10GameObjectRNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEES9_RK16HumanDescription10AvatarTypebRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i1, i17, i19, i20, i21, i4, i23) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i29 + 8 | 0;
 i2 = i29;
 i27 = i29 + 56 | 0;
 i28 = i29 + 44 | 0;
 i25 = i29 + 32 | 0;
 i18 = i29 + 16 | 0;
 i16 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if ((i16 | 0) != (__ZN9Transform7GetRootEv(i16) | 0)) {
  i26 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0, i16 | 0) | 0;
  i28 = __ZN9Transform7GetRootEv(i16) | 0;
  i28 = mftCall_ii(HEAP32[(HEAP32[i28 >> 2] | 0) + 36 >> 2] | 0, i28 | 0) | 0;
  HEAP32[i2 >> 2] = i26;
  HEAP32[i2 + 4 >> 2] = i28;
  __Z6FormatPKcz(i27, gb + 912498 | 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i23, i27) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 HEAP32[i28 >> 2] = 0;
 i26 = i28 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE(i16, i28, i27);
 if ((i21 | 0) == 2) {
  i1 = i20 + 52 | 0;
  i3 = i1 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i20 + 56 >> 2] | 0; else i2 = i2 & 255;
  if (!i2) i24 = 13; else if (!(__ZN13AvatarBuilder17GetRootMotionNodeERK8UnityStrRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEE(i1, i28) | 0)) {
   if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   __Z6FormatPKcz(i27, gb + 912554 | 0, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i23, i27) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   i7 = 0;
  } else i24 = 13;
 } else i24 = 13;
 if ((i24 | 0) == 13) {
  HEAP32[i25 >> 2] = 0;
  i22 = i25 + 4 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  if (i4) {
   i1 = HEAP32[i20 + 12 >> 2] | 0;
   i7 = i20 + 16 | 0;
   if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) {
    i8 = i18 + 12 | 0;
    i6 = i18 + 12 | 0;
    i9 = i27 + 4 | 0;
    i10 = i18 + 8 | 0;
    i11 = i18 + 4 | 0;
    i12 = i25 + 8 | 0;
    i13 = i18 + 11 | 0;
    i14 = i27 + 4 | 0;
    i15 = i27 + 4 | 0;
    do {
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
     HEAP32[i18 >> 2] = 0;
     HEAP32[i18 + 4 >> 2] = 0;
     HEAP32[i18 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i8 >> 2] = i2;
     i4 = _strlen(i3) | 0;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
      i2 = HEAP32[i6 >> 2] | 0;
      i24 = 22;
     } else if (i4 >>> 0 < 11) {
      HEAP8[i13 >> 0] = i4;
      if (!i4) i2 = i18; else {
       i2 = i18;
       i24 = 24;
      }
     } else i24 = 22;
     if ((i24 | 0) == 22) {
      i5 = i4 + 16 & -16;
      HEAP32[i27 >> 2] = 66;
      HEAP32[i9 >> 2] = i2;
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i18 >> 2] = i2;
      HEAP32[i10 >> 2] = i5 | -2147483648;
      HEAP32[i11 >> 2] = i4;
      i24 = 24;
     }
     if ((i24 | 0) == 24) {
      i24 = 0;
      _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
     }
     HEAP8[i2 + i4 >> 0] = 0;
     i2 = HEAP32[i22 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i25, i18); else {
      i5 = HEAP8[i13 >> 0] | 0;
      i3 = i5 << 24 >> 24 < 0;
      i4 = i3 ? HEAP32[i18 >> 2] | 0 : i18;
      i5 = i3 ? HEAP32[i11 >> 2] | 0 : i5 & 255;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
      HEAP32[i2 + 12 >> 2] = i3;
      if (i5 >>> 0 > 2147483631) {
       __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
       i3 = HEAP32[i2 + 12 >> 2] | 0;
       i24 = 29;
      } else if (i5 >>> 0 < 11) {
       HEAP8[i2 + 11 >> 0] = i5;
       if (i5) i24 = 31;
      } else i24 = 29;
      if ((i24 | 0) == 29) {
       i30 = i5 + 16 & -16;
       HEAP32[i27 >> 2] = 66;
       HEAP32[i15 >> 2] = i3;
       i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i30, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i2 + 8 >> 2] = i30 | -2147483648;
       HEAP32[i2 + 4 >> 2] = i5;
       i2 = i3;
       i24 = 31;
      }
      if ((i24 | 0) == 31) {
       i24 = 0;
       _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
      }
      HEAP8[i2 + i5 >> 0] = 0;
      HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 16;
     }
     if ((HEAP8[i13 >> 0] | 0) < 0) {
      i30 = HEAP32[i18 >> 2] | 0;
      i5 = HEAP32[i6 >> 2] | 0;
      HEAP32[i27 >> 2] = 66;
      HEAP32[i14 >> 2] = i5;
      __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
     }
     i1 = i1 + 72 | 0;
    } while ((i1 | 0) != (HEAP32[i7 >> 2] | 0));
   }
  }
  __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE(i16, i17, i25);
  if ((i21 | 0) == 3) {
   __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE(i16, i19, i25);
   __ZN13AvatarBuilder22RemoveAllNoneHumanLeafERNSt3__26vectorINS_14NamedTransformENS0_9allocatorIS2_EEEERK16HumanDescription(i19, i20);
   if (__ZN13AvatarBuilder12IsValidHumanERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i20, i19, i16, i23) | 0) i24 = 39; else i7 = 0;
  } else i24 = 39;
  if ((i24 | 0) == 39) i7 = 1;
  i1 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i22 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = i27 + 4 | 0;
    do {
     i3 = i2 + -16 | 0;
     HEAP32[i22 >> 2] = i3;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i30 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i27 >> 2] = 66;
      HEAP32[i4 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
      i2 = HEAP32[i22 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i25 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 }
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i26 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i5 = i27 + 4 | 0;
   i6 = i27 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i26 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i30 = HEAP32[i4 >> 2] | 0;
     i25 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i27 >> 2] = 66;
     HEAP32[i5 >> 2] = i25;
     __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i30 = HEAP32[i3 >> 2] | 0;
     i25 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i27 >> 2] = 66;
     HEAP32[i6 >> 2] = i25;
     __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
    }
    i2 = HEAP32[i26 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i28 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i30 = i7;
 STACKTOP = i29;
 return i30 | 0;
}

function runPostSets147() {
 HEAP32[gb + 137476 >> 2] = (HEAP32[gb + 137476 >> 2] | 0) + (gb + 753930 | 0);
 HEAP32[gb + 137480 >> 2] = (HEAP32[gb + 137480 >> 2] | 0) + (gb + 753943 | 0);
 HEAP32[gb + 137508 >> 2] = (HEAP32[gb + 137508 >> 2] | 0) + (gb + 753101 | 0);
 HEAP32[gb + 137512 >> 2] = (HEAP32[gb + 137512 >> 2] | 0) + (gb + 753921 | 0);
 HEAP32[gb + 137540 >> 2] = (HEAP32[gb + 137540 >> 2] | 0) + (gb + 753432 | 0);
 HEAP32[gb + 137544 >> 2] = (HEAP32[gb + 137544 >> 2] | 0) + (gb + 753896 | 0);
 HEAP32[gb + 137572 >> 2] = (HEAP32[gb + 137572 >> 2] | 0) + (gb + 753722 | 0);
 HEAP32[gb + 137576 >> 2] = (HEAP32[gb + 137576 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137604 >> 2] = (HEAP32[gb + 137604 >> 2] | 0) + (gb + 753806 | 0);
 HEAP32[gb + 137636 >> 2] = (HEAP32[gb + 137636 >> 2] | 0) + (gb + 753722 | 0);
 HEAP32[gb + 137640 >> 2] = (HEAP32[gb + 137640 >> 2] | 0) + (gb + 753886 | 0);
 HEAP32[gb + 137668 >> 2] = (HEAP32[gb + 137668 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 137672 >> 2] = (HEAP32[gb + 137672 >> 2] | 0) + (gb + 753705 | 0);
 HEAP32[gb + 137700 >> 2] = (HEAP32[gb + 137700 >> 2] | 0) + (gb + 753858 | 0);
 HEAP32[gb + 137704 >> 2] = (HEAP32[gb + 137704 >> 2] | 0) + (gb + 753873 | 0);
 HEAP32[gb + 137732 >> 2] = (HEAP32[gb + 137732 >> 2] | 0) + (gb + 752639 | 0);
 HEAP32[gb + 137736 >> 2] = (HEAP32[gb + 137736 >> 2] | 0) + (gb + 753849 | 0);
 HEAP32[gb + 137764 >> 2] = (HEAP32[gb + 137764 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 137768 >> 2] = (HEAP32[gb + 137768 >> 2] | 0) + (gb + 753833 | 0);
 HEAP32[gb + 137796 >> 2] = (HEAP32[gb + 137796 >> 2] | 0) + (gb + 753657 | 0);
 HEAP32[gb + 137800 >> 2] = (HEAP32[gb + 137800 >> 2] | 0) + (gb + 753679 | 0);
 HEAP32[gb + 137828 >> 2] = (HEAP32[gb + 137828 >> 2] | 0) + (gb + 753407 | 0);
 HEAP32[gb + 137832 >> 2] = (HEAP32[gb + 137832 >> 2] | 0) + (gb + 753806 | 0);
 HEAP32[gb + 137860 >> 2] = (HEAP32[gb + 137860 >> 2] | 0) + (gb + 753631 | 0);
 HEAP32[gb + 137892 >> 2] = (HEAP32[gb + 137892 >> 2] | 0) + (gb + 753780 | 0);
 HEAP32[gb + 137896 >> 2] = (HEAP32[gb + 137896 >> 2] | 0) + (gb + 753794 | 0);
 HEAP32[gb + 137924 >> 2] = (HEAP32[gb + 137924 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 137928 >> 2] = (HEAP32[gb + 137928 >> 2] | 0) + (gb + 932499 | 0);
 HEAP32[gb + 137956 >> 2] = (HEAP32[gb + 137956 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 137960 >> 2] = (HEAP32[gb + 137960 >> 2] | 0) + (gb + 753771 | 0);
 HEAP32[gb + 137988 >> 2] = (HEAP32[gb + 137988 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 137992 >> 2] = (HEAP32[gb + 137992 >> 2] | 0) + (gb + 753759 | 0);
 HEAP32[gb + 138020 >> 2] = (HEAP32[gb + 138020 >> 2] | 0) + (gb + 753722 | 0);
 HEAP32[gb + 138024 >> 2] = (HEAP32[gb + 138024 >> 2] | 0) + (gb + 753742 | 0);
 HEAP32[gb + 138052 >> 2] = (HEAP32[gb + 138052 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 138056 >> 2] = (HEAP32[gb + 138056 >> 2] | 0) + (gb + 753705 | 0);
 HEAP32[gb + 138084 >> 2] = (HEAP32[gb + 138084 >> 2] | 0) + (gb + 754632 | 0);
 HEAP32[gb + 138088 >> 2] = (HEAP32[gb + 138088 >> 2] | 0) + (gb + 753689 | 0);
 HEAP32[gb + 138116 >> 2] = (HEAP32[gb + 138116 >> 2] | 0) + (gb + 753657 | 0);
 HEAP32[gb + 138120 >> 2] = (HEAP32[gb + 138120 >> 2] | 0) + (gb + 753679 | 0);
 HEAP32[gb + 138148 >> 2] = (HEAP32[gb + 138148 >> 2] | 0) + (gb + 753383 | 0);
 HEAP32[gb + 138152 >> 2] = (HEAP32[gb + 138152 >> 2] | 0) + (gb + 753631 | 0);
 HEAP32[gb + 138180 >> 2] = (HEAP32[gb + 138180 >> 2] | 0) + (gb + 753611 | 0);
 HEAP32[gb + 138212 >> 2] = (HEAP32[gb + 138212 >> 2] | 0) + (gb + 753487 | 0);
 HEAP32[gb + 138216 >> 2] = (HEAP32[gb + 138216 >> 2] | 0) + (gb + 753611 | 0);
 HEAP32[gb + 138244 >> 2] = (HEAP32[gb + 138244 >> 2] | 0) + (gb + 753583 | 0);
 HEAP32[gb + 138276 >> 2] = (HEAP32[gb + 138276 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 138280 >> 2] = (HEAP32[gb + 138280 >> 2] | 0) + (gb + 753604 | 0);
 HEAP32[gb + 138308 >> 2] = (HEAP32[gb + 138308 >> 2] | 0) + (gb + 753503 | 0);
 HEAP32[gb + 138312 >> 2] = (HEAP32[gb + 138312 >> 2] | 0) + (gb + 753583 | 0);
 HEAP32[gb + 138340 >> 2] = (HEAP32[gb + 138340 >> 2] | 0) + (gb + 753550 | 0);
 HEAP32[gb + 138372 >> 2] = (HEAP32[gb + 138372 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 138376 >> 2] = (HEAP32[gb + 138376 >> 2] | 0) + (gb + 753572 | 0);
 HEAP32[gb + 138404 >> 2] = (HEAP32[gb + 138404 >> 2] | 0) + (gb + 753469 | 0);
 HEAP32[gb + 138408 >> 2] = (HEAP32[gb + 138408 >> 2] | 0) + (gb + 753550 | 0);
 HEAP32[gb + 138436 >> 2] = (HEAP32[gb + 138436 >> 2] | 0) + (gb + 753520 | 0);
 HEAP32[gb + 138468 >> 2] = (HEAP32[gb + 138468 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 138472 >> 2] = (HEAP32[gb + 138472 >> 2] | 0) + (gb + 753538 | 0);
 HEAP32[gb + 138500 >> 2] = (HEAP32[gb + 138500 >> 2] | 0) + (gb + 753455 | 0);
 HEAP32[gb + 138504 >> 2] = (HEAP32[gb + 138504 >> 2] | 0) + (gb + 753520 | 0);
 HEAP32[gb + 138532 >> 2] = (HEAP32[gb + 138532 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138564 >> 2] = (HEAP32[gb + 138564 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138596 >> 2] = (HEAP32[gb + 138596 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138600 >> 2] = (HEAP32[gb + 138600 >> 2] | 0) + (gb + 753503 | 0);
 HEAP32[gb + 138628 >> 2] = (HEAP32[gb + 138628 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138632 >> 2] = (HEAP32[gb + 138632 >> 2] | 0) + (gb + 753487 | 0);
 HEAP32[gb + 138660 >> 2] = (HEAP32[gb + 138660 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138664 >> 2] = (HEAP32[gb + 138664 >> 2] | 0) + (gb + 753469 | 0);
 HEAP32[gb + 138692 >> 2] = (HEAP32[gb + 138692 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138696 >> 2] = (HEAP32[gb + 138696 >> 2] | 0) + (gb + 753455 | 0);
 HEAP32[gb + 138724 >> 2] = (HEAP32[gb + 138724 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138728 >> 2] = (HEAP32[gb + 138728 >> 2] | 0) + (gb + 753432 | 0);
 HEAP32[gb + 138756 >> 2] = (HEAP32[gb + 138756 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138760 >> 2] = (HEAP32[gb + 138760 >> 2] | 0) + (gb + 753407 | 0);
 HEAP32[gb + 138788 >> 2] = (HEAP32[gb + 138788 >> 2] | 0) + (gb + 753365 | 0);
 HEAP32[gb + 138792 >> 2] = (HEAP32[gb + 138792 >> 2] | 0) + (gb + 753383 | 0);
 HEAP32[gb + 138820 >> 2] = (HEAP32[gb + 138820 >> 2] | 0) + (gb + 753657 | 0);
 HEAP32[gb + 138852 >> 2] = (HEAP32[gb + 138852 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 138856 >> 2] = (HEAP32[gb + 138856 >> 2] | 0) + (gb + 753990 | 0);
 HEAP32[gb + 138884 >> 2] = (HEAP32[gb + 138884 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 138888 >> 2] = (HEAP32[gb + 138888 >> 2] | 0) + (gb + 753979 | 0);
 HEAP32[gb + 138916 >> 2] = (HEAP32[gb + 138916 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 138920 >> 2] = (HEAP32[gb + 138920 >> 2] | 0) + (gb + 753975 | 0);
 HEAP32[gb + 138948 >> 2] = (HEAP32[gb + 138948 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 138980 >> 2] = (HEAP32[gb + 138980 >> 2] | 0) + (gb + 754461 | 0);
 HEAP32[gb + 139012 >> 2] = (HEAP32[gb + 139012 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 139016 >> 2] = (HEAP32[gb + 139016 >> 2] | 0) + (gb + 754453 | 0);
 HEAP32[gb + 139044 >> 2] = (HEAP32[gb + 139044 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 139048 >> 2] = (HEAP32[gb + 139048 >> 2] | 0) + (gb + 754446 | 0);
 HEAP32[gb + 139076 >> 2] = (HEAP32[gb + 139076 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 139080 >> 2] = (HEAP32[gb + 139080 >> 2] | 0) + (gb + 754434 | 0);
 HEAP32[gb + 139108 >> 2] = (HEAP32[gb + 139108 >> 2] | 0) + (gb + 1087825 | 0);
 HEAP32[gb + 139112 >> 2] = (HEAP32[gb + 139112 >> 2] | 0) + (gb + 754422 | 0);
 HEAP32[gb + 139140 >> 2] = (HEAP32[gb + 139140 >> 2] | 0) + (gb + 1087820 | 0);
 HEAP32[gb + 139180 >> 2] = fb + 920;
 HEAP32[gb + 139184 >> 2] = fb + 310;
 HEAP32[gb + 139188 >> 2] = fb + 921;
 HEAP32[gb + 139192 >> 2] = fb + 311;
 HEAP32[gb + 139196 >> 2] = fb + 312;
 HEAP32[gb + 139200 >> 2] = fb + 313;
 runPostSets148();
}

function __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf(i1, i74, i75, i76) {
 i1 = i1 | 0;
 i74 = i74 | 0;
 i75 = i75 | 0;
 i76 = i76 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0, f95 = f0, i96 = 0;
 i82 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i80 = i82 + 96 | 0;
 i81 = i82 + 84 | 0;
 i79 = i82 + 64 | 0;
 i78 = i82 + 48 | 0;
 i19 = i82 + 32 | 0;
 i20 = i82 + 16 | 0;
 i30 = i82;
 i77 = i82 + 80 | 0;
 HEAP32[i80 >> 2] = 0;
 HEAP32[i80 + 4 >> 2] = 0;
 i51 = i80 + 8 | 0;
 HEAP32[i51 >> 2] = -1;
 i62 = i80 + 12 | 0;
 HEAP16[i62 >> 1] = 0;
 i72 = i80 + 16 | 0;
 i71 = i80 + 40 | 0;
 HEAP32[i72 >> 2] = 0;
 HEAP32[i72 + 4 >> 2] = 0;
 HEAP32[i72 + 8 >> 2] = 0;
 HEAP32[i72 + 12 >> 2] = 0;
 HEAP32[i72 + 16 >> 2] = 0;
 HEAP32[i72 + 20 >> 2] = 0;
 HEAPF32[i71 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i72 = i80 + 44 | 0;
 HEAPF32[i72 >> 2] = Math_fround(0.0);
 i73 = i80 + 48 | 0;
 HEAPF32[i73 >> 2] = Math_fround(0.0);
 if (!i74) {
  i81 = 1;
  STACKTOP = i82;
  return i81 | 0;
 }
 i21 = i1 + 16 | 0;
 i22 = i1 + 20 | 0;
 i23 = i1 + 24 | 0;
 i24 = i81 + 4 | 0;
 i25 = i81 + 8 | 0;
 i26 = i1 + 64 | 0;
 i27 = i1 + 192 | 0;
 i28 = i1 + 196 | 0;
 i29 = i1 + 200 | 0;
 i31 = i19 + 4 | 0;
 i32 = i19 + 8 | 0;
 i33 = i19 + 12 | 0;
 i34 = i20 + 4 | 0;
 i35 = i20 + 8 | 0;
 i36 = i20 + 12 | 0;
 i37 = i1 + 208 | 0;
 i38 = i1 + 224 | 0;
 i39 = i1 + 181 | 0;
 i40 = i1 + 12 | 0;
 i41 = i1 + 108 | 0;
 i42 = i1 + 68 | 0;
 i43 = i1 + 80 | 0;
 i44 = i1 + 84 | 0;
 i45 = i80 + 16 | 0;
 i46 = i80 + 20 | 0;
 i47 = i1 + 88 | 0;
 i48 = i80 + 24 | 0;
 i49 = i1 + 92 | 0;
 i50 = i1 + 96 | 0;
 i52 = i80 + 28 | 0;
 i53 = i80 + 32 | 0;
 i54 = i1 + 100 | 0;
 i55 = i80 + 36 | 0;
 i56 = i1 + 104 | 0;
 i57 = i1 + 112 | 0;
 i58 = i1 + 132 | 0;
 i59 = i1 + 136 | 0;
 i60 = i1 + 140 | 0;
 i61 = i1 + 144 | 0;
 i63 = i1 + 148 | 0;
 i64 = i1 + 152 | 0;
 i65 = i1 + 156 | 0;
 i66 = i1 + 160 | 0;
 i67 = i1 + 164 | 0;
 i68 = i1 + 168 | 0;
 i69 = i1 + 172 | 0;
 i70 = i1 + 176 | 0;
 i14 = i1 + 180 | 0;
 i18 = 0;
 L4 : while (1) {
  i16 = HEAP32[i75 + (i18 << 2) >> 2] | 0;
  i15 = (i16 >>> 1 & 15) + 1 | 0;
  i16 = i16 >>> 5;
  i17 = 0;
  do {
   i9 = i17 + i16 | 0;
   i1 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
   if (!(HEAP32[i21 >> 2] | 0)) {
    i4 = i1 + (i9 * 12 | 0) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    i4 = HEAP32[i4 + 8 >> 2] | 0;
   } else {
    i4 = i1 + (i9 * 6 | 0) | 0;
    i1 = HEAPU16[i4 >> 1] | 0;
    i2 = HEAPU16[i4 + 2 >> 1] | 0;
    i4 = HEAPU16[i4 + 4 >> 1] | 0;
   }
   i96 = HEAP32[HEAP32[i23 >> 2] >> 2] | 0;
   i10 = i96 + (i1 * 12 | 0) | 0;
   i11 = i96 + (i2 * 12 | 0) | 0;
   i12 = i96 + (i4 * 12 | 0) | 0;
   HEAP32[i81 >> 2] = i1;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i25 >> 2] = i4;
   f86 = Math_fround(HEAPF32[i10 >> 2]);
   i13 = i96 + (i1 * 12 | 0) + 4 | 0;
   f83 = Math_fround(HEAPF32[i13 >> 2]);
   i7 = i96 + (i1 * 12 | 0) + 8 | 0;
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   f88 = Math_fround(HEAPF32[i11 >> 2]);
   i8 = i96 + (i2 * 12 | 0) + 4 | 0;
   f92 = Math_fround(HEAPF32[i8 >> 2]);
   i5 = i96 + (i2 * 12 | 0) + 8 | 0;
   f90 = Math_fround(HEAPF32[i5 >> 2]);
   f87 = Math_fround(HEAPF32[i12 >> 2]);
   i6 = i96 + (i4 * 12 | 0) + 4 | 0;
   f91 = Math_fround(HEAPF32[i6 >> 2]);
   i1 = i96 + (i4 * 12 | 0) + 8 | 0;
   f89 = Math_fround(HEAPF32[i1 >> 2]);
   f95 = f86 < f88 ? f86 : f88;
   f94 = f83 < f92 ? f83 : f92;
   f93 = f3 < f90 ? f3 : f90;
   f88 = f86 > f88 ? f86 : f88;
   f92 = f83 > f92 ? f83 : f92;
   f90 = f3 > f90 ? f3 : f90;
   f3 = Math_fround(HEAPF32[i26 >> 2]);
   i4 = f3 < Math_fround(1.0);
   f83 = Math_fround(f3 * Math_fround(.00100000005));
   f83 = i4 ? Math_fround(.00100000005) : f83;
   f86 = Math_fround(HEAPF32[i27 >> 2]);
   f85 = Math_fround(HEAPF32[i28 >> 2]);
   f84 = Math_fround(HEAPF32[i29 >> 2]);
   f94 = Math_fround((f94 < f91 ? f94 : f91) - f85);
   f93 = Math_fround((f93 < f89 ? f93 : f89) - f84);
   HEAPF32[i19 >> 2] = Math_fround((f95 < f87 ? f95 : f87) - f86);
   HEAPF32[i31 >> 2] = f94;
   HEAPF32[i32 >> 2] = f93;
   HEAPF32[i33 >> 2] = Math_fround(0.0);
   f85 = Math_fround((f92 > f91 ? f92 : f91) + f85);
   f84 = Math_fround((f90 > f89 ? f90 : f89) + f84);
   HEAPF32[i20 >> 2] = Math_fround((f88 > f87 ? f88 : f87) + f86);
   HEAPF32[i34 >> 2] = f85;
   HEAPF32[i35 >> 2] = f84;
   HEAPF32[i36 >> 2] = Math_fround(0.0);
   HEAPF32[i30 >> 2] = Math_fround(f83 + f3);
   if (__ZN5physx2Gu17intersectRayAABB2ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RKNS2_6FloatVERS6_S9_(i19, i20, i37, i38, i30, i79, i78) | 0) {
    i2 = HEAP32[i26 >> 2] | 0;
    HEAP32[i71 >> 2] = i2;
    HEAPF32[i73 >> 2] = Math_fround(0.0);
    HEAPF32[i72 >> 2] = Math_fround(0.0);
    HEAP32[i51 >> 2] = i9;
    HEAP16[i62 >> 1] = 5;
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (!(HEAP8[i39 >> 0] | 0)) {
     HEAP32[i77 >> 2] = HEAP32[i76 >> 2];
     i96 = HEAP32[i40 >> 2] | 0;
     if (!(mftCall_iiiiiiii(HEAP32[HEAP32[i96 >> 2] >> 2] | 0, i96 | 0, i80 | 0, i10 | 0, i11 | 0, i12 | 0, i77 | 0, i81 | 0) | 0)) {
      i1 = 0;
      i2 = 17;
      break L4;
     }
     f3 = Math_fround(HEAPF32[i77 >> 2]);
     if (f3 < Math_fround(HEAPF32[i76 >> 2])) {
      HEAPF32[i76 >> 2] = f3;
      HEAPF32[i26 >> 2] = f3;
     }
    } else if (f3 < Math_fround(HEAPF32[i41 >> 2])) {
     HEAP32[i42 >> 2] = HEAP32[i80 >> 2];
     HEAP32[i42 + 4 >> 2] = HEAP32[i80 + 4 >> 2];
     HEAP32[i42 + 8 >> 2] = HEAP32[i80 + 8 >> 2];
     HEAP16[i43 >> 1] = 5;
     HEAP32[i44 >> 2] = HEAP32[i45 >> 2];
     HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
     HEAP32[i49 >> 2] = HEAP32[i48 >> 2];
     HEAP32[i50 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i54 >> 2] = HEAP32[i53 >> 2];
     HEAP32[i56 >> 2] = HEAP32[i55 >> 2];
     HEAP32[i41 >> 2] = i2;
     HEAP32[i57 >> 2] = HEAP32[i72 >> 2];
     HEAP32[i57 + 4 >> 2] = HEAP32[i72 + 4 >> 2];
     HEAP32[i57 + 8 >> 2] = HEAP32[i72 + 8 >> 2];
     HEAP32[i57 + 12 >> 2] = HEAP32[i72 + 12 >> 2];
     HEAP32[i57 + 16 >> 2] = HEAP32[i72 + 16 >> 2];
     f95 = Math_fround(HEAPF32[i76 >> 2]);
     HEAPF32[i76 >> 2] = f3 < f95 ? f3 : f95;
     HEAP32[i58 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i59 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i60 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i61 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i63 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i64 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i65 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i66 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i67 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i68 >> 2] = HEAP32[i81 >> 2];
     HEAP32[i69 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i70 >> 2] = HEAP32[i25 >> 2];
     HEAP8[i14 >> 0] = 1;
    }
    if (!(HEAP32[(HEAP32[i40 >> 2] | 0) + 4 >> 2] | 0)) {
     i1 = 0;
     i2 = 17;
     break L4;
    }
   }
   i17 = i17 + 1 | 0;
  } while (i17 >>> 0 < i15 >>> 0);
  i18 = i18 + 1 | 0;
  if (i18 >>> 0 >= i74 >>> 0) {
   i1 = 1;
   i2 = 17;
   break;
  }
 }
 if ((i2 | 0) == 17) {
  STACKTOP = i82;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx2Gu15HeightFieldUtil27getSmoothNormalAtShapePointEff(i18, i21, f3, f4) {
 i18 = i18 | 0;
 i21 = i21 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 148 | 0;
 i20 = i22 + 144 | 0;
 i12 = i22 + 132 | 0;
 i14 = i22 + 120 | 0;
 i16 = i22 + 108 | 0;
 i13 = i22 + 96 | 0;
 i15 = i22 + 84 | 0;
 i17 = i22 + 72 | 0;
 i2 = i22 + 60 | 0;
 i8 = i22 + 48 | 0;
 i10 = i22 + 36 | 0;
 i7 = i22 + 24 | 0;
 i9 = i22 + 12 | 0;
 i11 = i22;
 f3 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f3);
 f4 = Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f4);
 i5 = i21 + 12 | 0;
 i6 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(HEAP32[i5 >> 2] | 0, f3, f4, i19, i20) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + (i6 << 2) + 2 >> 0] | 0) < 0) {
  f4 = Math_fround(HEAPF32[i20 >> 2]);
  i11 = f4 > Math_fround(HEAPF32[i19 >> 2]);
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  i1 = (i6 >>> 0) / (i2 >>> 0) | 0;
  i2 = (i6 >>> 0) % (i2 >>> 0) | 0;
  if (i11) {
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i12, i21, i6, i1, i2);
   i15 = i6 + 1 | 0;
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i14, i21, i15, (i15 >>> 0) / (i17 >>> 0) | 0, (i15 >>> 0) % (i17 >>> 0) | 0);
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   i15 = i15 + i17 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i16, i21, i15, (i15 >>> 0) / (i17 >>> 0) | 0, (i15 >>> 0) % (i17 >>> 0) | 0);
   f24 = Math_fround(HEAPF32[i20 >> 2]);
   f23 = Math_fround(HEAPF32[i14 >> 2]);
   f29 = Math_fround(HEAPF32[i12 >> 2]);
   f25 = Math_fround(f23 - f29);
   f3 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f27 = Math_fround(f3 - f28);
   f4 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f26 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f25 = Math_fround(f29 + Math_fround(f24 * f25));
   f27 = Math_fround(f28 + Math_fround(f24 * f27));
   f26 = Math_fround(f26 + Math_fround(f24 * Math_fround(f4 - f26)));
   f24 = Math_fround(HEAPF32[i19 >> 2]);
   f23 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f23);
   f3 = Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) - f3);
   f3 = Math_fround(f27 + Math_fround(f24 * f3));
   f4 = Math_fround(f26 + Math_fround(f24 * Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) - f4)));
   HEAPF32[i18 >> 2] = Math_fround(f25 + Math_fround(f24 * f23));
   HEAPF32[i18 + 4 >> 2] = f3;
   HEAPF32[i18 + 8 >> 2] = f4;
   STACKTOP = i22;
   return;
  } else {
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i13, i21, i6, i1, i2);
   i16 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   i14 = i16 + i6 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i15, i21, i14, (i14 >>> 0) / (i16 >>> 0) | 0, (i14 >>> 0) % (i16 >>> 0) | 0);
   i16 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   i14 = i6 + 1 + i16 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i17, i21, i14, (i14 >>> 0) / (i16 >>> 0) | 0, (i14 >>> 0) % (i16 >>> 0) | 0);
   f26 = Math_fround(HEAPF32[i19 >> 2]);
   f27 = Math_fround(HEAPF32[i15 >> 2]);
   f3 = Math_fround(HEAPF32[i13 >> 2]);
   f25 = Math_fround(f27 - f3);
   f28 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f23 = Math_fround(f28 - f4);
   f29 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f25 = Math_fround(f3 + Math_fround(f26 * f25));
   f23 = Math_fround(f4 + Math_fround(f26 * f23));
   f24 = Math_fround(f24 + Math_fround(f26 * Math_fround(f29 - f24)));
   f26 = Math_fround(HEAPF32[i20 >> 2]);
   f27 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f27);
   f28 = Math_fround(Math_fround(HEAPF32[i17 + 4 >> 2]) - f28);
   f28 = Math_fround(f23 + Math_fround(f26 * f28));
   f29 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_fround(HEAPF32[i17 + 8 >> 2]) - f29)));
   HEAPF32[i18 >> 2] = Math_fround(f25 + Math_fround(f26 * f27));
   HEAPF32[i18 + 4 >> 2] = f28;
   HEAPF32[i18 + 8 >> 2] = f29;
   STACKTOP = i22;
   return;
  }
 } else {
  f29 = Math_fround(HEAPF32[i19 >> 2]);
  i17 = Math_fround(f29 + Math_fround(HEAPF32[i20 >> 2])) < Math_fround(1.0);
  i1 = HEAP32[i1 + 20 >> 2] | 0;
  if (i17) {
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i2, i21, i6, (i6 >>> 0) / (i1 >>> 0) | 0, (i6 >>> 0) % (i1 >>> 0) | 0);
   i16 = i6 + 1 | 0;
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i8, i21, i16, (i16 >>> 0) / (i17 >>> 0) | 0, (i16 >>> 0) % (i17 >>> 0) | 0);
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   i16 = i17 + i6 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i10, i21, i16, (i16 >>> 0) / (i17 >>> 0) | 0, (i16 >>> 0) % (i17 >>> 0) | 0);
   f26 = Math_fround(HEAPF32[i20 >> 2]);
   f25 = Math_fround(HEAPF32[i8 >> 2]);
   f27 = Math_fround(HEAPF32[i2 >> 2]);
   f25 = Math_fround(f25 - f27);
   f23 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f23 = Math_fround(f23 - f28);
   f24 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f29 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f25 = Math_fround(f27 + Math_fround(f26 * f25));
   f23 = Math_fround(f28 + Math_fround(f26 * f23));
   f24 = Math_fround(f29 + Math_fround(f26 * Math_fround(f24 - f29)));
   f26 = Math_fround(HEAPF32[i19 >> 2]);
   f27 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f27);
   f28 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) - f28);
   f28 = Math_fround(f23 + Math_fround(f26 * f28));
   f29 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f29)));
   HEAPF32[i18 >> 2] = Math_fround(f25 + Math_fround(f26 * f27));
   HEAPF32[i18 + 4 >> 2] = f28;
   HEAPF32[i18 + 8 >> 2] = f29;
   STACKTOP = i22;
   return;
  } else {
   i16 = i6 + 1 | 0;
   i17 = i16 + i1 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i7, i21, i17, (i17 >>> 0) / (i1 >>> 0) | 0, (i17 >>> 0) % (i1 >>> 0) | 0);
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   i15 = i17 + i6 | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i9, i21, i15, (i15 >>> 0) / (i17 >>> 0) | 0, (i15 >>> 0) % (i17 >>> 0) | 0);
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
   __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i11, i21, i16, (i16 >>> 0) / (i17 >>> 0) | 0, (i16 >>> 0) % (i17 >>> 0) | 0);
   f26 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i20 >> 2]));
   f25 = Math_fround(HEAPF32[i9 >> 2]);
   f27 = Math_fround(HEAPF32[i7 >> 2]);
   f25 = Math_fround(f25 - f27);
   f23 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   f28 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f23 = Math_fround(f23 - f28);
   f24 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   f29 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f25 = Math_fround(f27 + Math_fround(f26 * f25));
   f23 = Math_fround(f28 + Math_fround(f26 * f23));
   f24 = Math_fround(f29 + Math_fround(f26 * Math_fround(f24 - f29)));
   f26 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i19 >> 2]));
   f27 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f27);
   f28 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) - f28);
   f28 = Math_fround(f23 + Math_fround(f26 * f28));
   f29 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f29)));
   HEAPF32[i18 >> 2] = Math_fround(f25 + Math_fround(f26 * f27));
   HEAPF32[i18 + 4 >> 2] = f28;
   HEAPF32[i18 + 8 >> 2] = f29;
   STACKTOP = i22;
   return;
  }
 }
}

function __ZN5physx57PxVehicleDriveTankSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE(i6, i7, f8, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, i9 = 0, i10 = 0;
 i10 = HEAP8[i7 + 30 >> 0] | 0;
 i9 = i2 + 128 | 0;
 HEAP8[i2 + 193 >> 0] = HEAP8[i7 + 29 >> 0] | 0;
 HEAP8[i2 + 194 >> 0] = i10;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 0));
 f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 if (f1 < f3) {
  f1 = Math_fround(Math_fround(f4 * f8) + f1);
  f1 = f1 < f3 ? f1 : f3;
 } else {
  f1 = Math_fround(f1 - Math_fround(f5 * f8));
  f1 = f1 > f3 ? f1 : f3;
 }
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 0, f1);
 switch (HEAP32[i7 >> 2] | 0) {
 case 1:
  {
   f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 68 >> 2]);
   f4 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 1));
   f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   if (f4 < f5) {
    f1 = Math_fround(Math_fround(f1 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
   } else {
    f1 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f1 > f5 ? f1 : f5;
   }
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 1, f1);
   f1 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 72 >> 2]);
   f4 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 2));
   f5 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   if (f4 < f5) {
    f1 = Math_fround(Math_fround(f1 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
   } else {
    f1 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f1 > f5 ? f1 : f5;
   }
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 2, f1);
   f1 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 76 >> 2]);
   f4 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 3));
   f5 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   do if (f5 == Math_fround(0.0)) {
    if (f4 > Math_fround(0.0)) {
     f1 = Math_fround(f4 - Math_fround(f3 * f8));
     i10 = f1 > Math_fround(0.0);
     f1 = i10 ? f1 : Math_fround(0.0);
     break;
    }
    if (f4 < Math_fround(0.0)) {
     f1 = Math_fround(Math_fround(f3 * f8) + f4);
     i10 = f1 < Math_fround(0.0);
     f1 = i10 ? f1 : Math_fround(0.0);
    } else f1 = Math_fround(0.0);
   } else if (f4 < f5) if (f4 < Math_fround(0.0)) {
    f1 = Math_fround(Math_fround(f3 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
    break;
   } else {
    f1 = Math_fround(Math_fround(f1 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
    break;
   } else if (f4 > Math_fround(0.0)) {
    f1 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f1 > f5 ? f1 : f5;
    break;
   } else {
    f1 = Math_fround(f4 - Math_fround(f1 * f8));
    f1 = f1 > f5 ? f1 : f5;
    break;
   } while (0);
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 3, f1);
   f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 80 >> 2]);
   f4 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 4));
   f1 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   do if (f1 == Math_fround(0.0)) {
    if (f4 > Math_fround(0.0)) {
     f1 = Math_fround(f4 - Math_fround(f3 * f8));
     i10 = f1 > Math_fround(0.0);
     f1 = i10 ? f1 : Math_fround(0.0);
     break;
    }
    if (f4 < Math_fround(0.0)) {
     f1 = Math_fround(Math_fround(f3 * f8) + f4);
     i10 = f1 < Math_fround(0.0);
     f1 = i10 ? f1 : Math_fround(0.0);
    } else f1 = Math_fround(0.0);
   } else if (f4 < f1) if (f4 < Math_fround(0.0)) {
    f8 = Math_fround(Math_fround(f3 * f8) + f4);
    f1 = f8 < f1 ? f8 : f1;
    break;
   } else {
    f8 = Math_fround(Math_fround(f5 * f8) + f4);
    f1 = f8 < f1 ? f8 : f1;
    break;
   } else if (f4 > Math_fround(0.0)) {
    f8 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f8 > f1 ? f8 : f1;
    break;
   } else {
    f8 = Math_fround(f4 - Math_fround(f5 * f8));
    f1 = f8 > f1 ? f8 : f1;
    break;
   } while (0);
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 4, f1);
   return;
  }
 case 0:
  {
   f1 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 80 >> 2]);
   f4 = Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 4)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 2)));
   f5 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) - Math_fround(HEAPF32[i7 + 12 >> 2]));
   do if (f5 == Math_fround(0.0)) {
    if (f4 > Math_fround(0.0)) {
     f1 = Math_fround(f4 - Math_fround(f3 * f8));
     if (f1 > Math_fround(0.0)) {
      i2 = 48;
      break;
     } else {
      f1 = Math_fround(0.0);
      i2 = 50;
      break;
     }
    }
    if (f4 < Math_fround(0.0)) {
     f1 = Math_fround(Math_fround(f3 * f8) + f4);
     if (f1 < Math_fround(0.0)) i2 = 48; else {
      f1 = Math_fround(0.0);
      i2 = 50;
     }
    } else {
     f1 = Math_fround(0.0);
     i2 = 50;
    }
   } else if (f4 < f5) if (f4 < Math_fround(0.0)) {
    f1 = Math_fround(Math_fround(f3 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
    i2 = 48;
    break;
   } else {
    f1 = Math_fround(Math_fround(f1 * f8) + f4);
    f1 = f1 < f5 ? f1 : f5;
    i2 = 48;
    break;
   } else if (f4 > Math_fround(0.0)) {
    f1 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f1 > f5 ? f1 : f5;
    i2 = 48;
    break;
   } else {
    f1 = Math_fround(f4 - Math_fround(f1 * f8));
    f1 = f1 > f5 ? f1 : f5;
    i2 = 48;
    break;
   } while (0);
   if ((i2 | 0) == 48) if (f1 > Math_fround(0.0)) {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 4, f1);
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 2, Math_fround(0.0));
   } else i2 = 50;
   if ((i2 | 0) == 50) {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 4, Math_fround(0.0));
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 2, Math_fround(-f1));
   }
   f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 76 >> 2]);
   f4 = Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 3)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i9, 1)));
   f1 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) - Math_fround(HEAPF32[i7 + 8 >> 2]));
   do if (f1 == Math_fround(0.0)) {
    if (f4 > Math_fround(0.0)) {
     f1 = Math_fround(f4 - Math_fround(f3 * f8));
     if (f1 > Math_fround(0.0)) {
      i2 = 63;
      break;
     } else {
      f1 = Math_fround(0.0);
      break;
     }
    }
    if (f4 < Math_fround(0.0)) {
     f1 = Math_fround(Math_fround(f3 * f8) + f4);
     if (f1 < Math_fround(0.0)) i2 = 63; else f1 = Math_fround(0.0);
    } else f1 = Math_fround(0.0);
   } else if (f4 < f1) if (f4 < Math_fround(0.0)) {
    f8 = Math_fround(Math_fround(f3 * f8) + f4);
    f1 = f8 < f1 ? f8 : f1;
    i2 = 63;
    break;
   } else {
    f8 = Math_fround(Math_fround(f5 * f8) + f4);
    f1 = f8 < f1 ? f8 : f1;
    i2 = 63;
    break;
   } else if (f4 > Math_fround(0.0)) {
    f8 = Math_fround(f4 - Math_fround(f3 * f8));
    f1 = f8 > f1 ? f8 : f1;
    i2 = 63;
    break;
   } else {
    f8 = Math_fround(f4 - Math_fround(f5 * f8));
    f1 = f8 > f1 ? f8 : f1;
    i2 = 63;
    break;
   } while (0);
   if ((i2 | 0) == 63) if (f1 > Math_fround(0.0)) {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 3, f1);
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 1, Math_fround(0.0));
    return;
   }
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 3, Math_fround(0.0));
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i9, 1, Math_fround(-f1));
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i35, i32, i1, i2) {
 i35 = i35 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37;
 i28 = i37 + 276 | 0;
 i22 = i37 + 224 | 0;
 i29 = i37 + 32 | 0;
 i30 = i37 + 20 | 0;
 i27 = i37 + 16 | 0;
 i23 = i37 + 280 | 0;
 i33 = i35 + 20 | 0;
 i24 = HEAP32[i33 >> 2] | 0;
 i25 = i35 + 32 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i34 = i35 + 4 | 0;
 i4 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i35 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = i1;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i28) | 0;
 i1 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i35 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i33 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i35 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i35 + 36 | 0;
 L12 : do if (HEAP8[i21 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i35, gb + 830924 | 0);
  if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i33 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i21 >> 0] = i1;
  }
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i4 = i35 + 40 | 0;
   i5 = i30 + 4 | 0;
   i6 = i30 + 8 | 0;
   i7 = i35 + 28 | 0;
   i8 = i35 + 8 | 0;
   i9 = i35 + 8 | 0;
   i10 = i28;
   i11 = i22 + 4 | 0;
   i12 = i22 + 8 | 0;
   i13 = i22 + 20 | 0;
   i14 = i22 + 24 | 0;
   i15 = i22 + 28 | 0;
   i16 = i22 + 32 | 0;
   i17 = i22 + 36 | 0;
   i18 = i22 + 40 | 0;
   i19 = i22 + 44 | 0;
   i20 = i22 + 48 | 0;
   while (1) {
    if (!(i1 << 24 >> 24)) i1 = gb + 1576256 | 0; else {
     i1 = HEAP32[i33 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    }
    do if (!(_strcasecmp(i1, gb + 673430 | 0) | 0)) {
     i1 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     HEAP32[i28 >> 2] = i1;
     if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
      i1 = _strtoull(i1, i28, 10) | 0;
      i2 = getTempRet0() | 0;
      if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i31 >> 2] = gb + 690295;
        i38 = i31 + 8 | 0;
        HEAP32[i38 >> 2] = i1;
        HEAP32[i38 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i31);
        HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
        break;
       } else {
        mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i3 | 0);
        break;
       }
      }
     }
    } else {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i27 >> 2] = 0;
     __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i35, i27, i30);
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i1 = HEAP32[i27 >> 2] | 0; else {
      i3 = HEAP32[i8 >> 2] | 0;
      i39 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
      i1 = HEAP32[i27 >> 2] | 0;
      i38 = HEAP32[i30 >> 2] | 0;
      HEAP8[i23 >> 0] = 11;
      i2 = mftCall_iiiiiii(i39 | 0, i3 | 0, i1 | 0, i38 | 0, i2 & 65535 | 0, 1, i23 | 0) | 0;
      if (i2) {
       __ZN5physx20PxShapeGeneratedInfoC2Ev(i29);
       i41 = HEAP32[i35 >> 2] | 0;
       i40 = HEAP32[i34 >> 2] | 0;
       i3 = HEAP32[i33 >> 2] | 0;
       i38 = HEAP32[i7 >> 2] | 0;
       i39 = HEAP32[i25 >> 2] | 0;
       HEAP8[i28 >> 0] = 0;
       HEAP32[i22 >> 2] = i41;
       HEAP32[i11 >> 2] = i40;
       HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i13 >> 2] = i3;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i15 >> 2] = i38;
       HEAP32[i16 >> 2] = i39;
       HEAP8[i17 >> 0] = 1;
       HEAP32[i18 >> 2] = i10;
       HEAP32[i19 >> 2] = 0;
       HEAP32[i20 >> 2] = 0;
       __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j(i29, i22, 0) | 0;
       if (HEAP8[i28 >> 0] | 0) HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
       mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i2 | 0);
       mftCall_viiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i2 | 0, 0, 0);
      }
     }
     i41 = HEAP32[i7 >> 2] | 0;
     i41 = mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 16 >> 2] | 0, i41 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
     i41 = HEAP32[i6 >> 2] | 0;
     if ((i41 | 0) > -1 & (i41 & 2147483647 | 0) != 0) {
      i1 = HEAP32[i30 >> 2] | 0;
      if (i1 | 0) {
       i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
      }
     }
    } while (0);
    if (!(HEAP8[i21 >> 0] | 0)) break L12;
    i41 = HEAP32[i33 >> 2] | 0;
    if (!(mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 24 >> 2] | 0, i41 | 0) | 0)) break L12;
    i1 = HEAP8[i21 >> 0] | 0;
   }
  }
 } while (0);
 i2 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i37;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i36 = 39;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i33 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i35 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i36 | 0) == 39) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i34 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i37;
 return;
}

function __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i35, i32, i1, i2) {
 i35 = i35 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37;
 i28 = i37 + 276 | 0;
 i22 = i37 + 224 | 0;
 i29 = i37 + 32 | 0;
 i30 = i37 + 20 | 0;
 i27 = i37 + 16 | 0;
 i23 = i37 + 280 | 0;
 i33 = i35 + 20 | 0;
 i24 = HEAP32[i33 >> 2] | 0;
 i25 = i35 + 32 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i34 = i35 + 4 | 0;
 i4 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i35 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = i1;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i28) | 0;
 i1 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i35 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i21 = HEAP32[i33 >> 2] | 0;
    i21 = (mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i21;
    i1 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i21;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i21 = HEAP32[i35 >> 2] | 0;
   HEAP8[(HEAP32[i21 + 4 >> 2] | 0) + ((HEAP32[i21 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i21 = i35 + 36 | 0;
 L12 : do if (HEAP8[i21 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i35, gb + 830924 | 0);
  if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i33 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i21 >> 0] = i1;
  }
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i20 = HEAP32[i35 >> 2] | 0;
  HEAP8[(HEAP32[i20 + 4 >> 2] | 0) + ((HEAP32[i20 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i4 = i35 + 40 | 0;
   i5 = i30 + 4 | 0;
   i6 = i30 + 8 | 0;
   i7 = i35 + 28 | 0;
   i8 = i35 + 8 | 0;
   i9 = i35 + 8 | 0;
   i10 = i28;
   i11 = i22 + 4 | 0;
   i12 = i22 + 8 | 0;
   i13 = i22 + 20 | 0;
   i14 = i22 + 24 | 0;
   i15 = i22 + 28 | 0;
   i16 = i22 + 32 | 0;
   i17 = i22 + 36 | 0;
   i18 = i22 + 40 | 0;
   i19 = i22 + 44 | 0;
   i20 = i22 + 48 | 0;
   while (1) {
    if (!(i1 << 24 >> 24)) i1 = gb + 1576256 | 0; else {
     i1 = HEAP32[i33 >> 2] | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
    }
    do if (!(_strcasecmp(i1, gb + 673430 | 0) | 0)) {
     i1 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
     HEAP32[i28 >> 2] = i1;
     if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
      i1 = _strtoull(i1, i28, 10) | 0;
      i2 = getTempRet0() | 0;
      if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
       i3 = mftCall_iiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 40 >> 2] | 0, i26 | 0, i1 | 0, i2 | 0) | 0;
       if (!i3) {
        i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
        HEAP32[i31 >> 2] = gb + 690295;
        i38 = i31 + 8 | 0;
        HEAP32[i38 >> 2] = i1;
        HEAP32[i38 + 4 >> 2] = i2;
        __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i31);
        HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
        break;
       } else {
        mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i3 | 0);
        break;
       }
      }
     }
    } else {
     HEAP32[i30 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i27 >> 2] = 0;
     __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i35, i27, i30);
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i1 = HEAP32[i27 >> 2] | 0; else {
      i3 = HEAP32[i8 >> 2] | 0;
      i39 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
      i1 = HEAP32[i27 >> 2] | 0;
      i38 = HEAP32[i30 >> 2] | 0;
      HEAP8[i23 >> 0] = 11;
      i2 = mftCall_iiiiiii(i39 | 0, i3 | 0, i1 | 0, i38 | 0, i2 & 65535 | 0, 1, i23 | 0) | 0;
      if (i2) {
       __ZN5physx20PxShapeGeneratedInfoC2Ev(i29);
       i41 = HEAP32[i35 >> 2] | 0;
       i40 = HEAP32[i34 >> 2] | 0;
       i3 = HEAP32[i33 >> 2] | 0;
       i38 = HEAP32[i7 >> 2] | 0;
       i39 = HEAP32[i25 >> 2] | 0;
       HEAP8[i28 >> 0] = 0;
       HEAP32[i22 >> 2] = i41;
       HEAP32[i11 >> 2] = i40;
       HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i13 >> 2] = i3;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i15 >> 2] = i38;
       HEAP32[i16 >> 2] = i39;
       HEAP8[i17 >> 0] = 1;
       HEAP32[i18 >> 2] = i10;
       HEAP32[i19 >> 2] = 0;
       HEAP32[i20 >> 2] = 0;
       __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j(i29, i22, 0) | 0;
       if (HEAP8[i28 >> 0] | 0) HEAP8[HEAP32[i4 >> 2] >> 0] = 1;
       mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 96 >> 2] | 0, i32 | 0, i2 | 0);
       mftCall_viiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i2 | 0, 0, 0);
      }
     }
     i41 = HEAP32[i7 >> 2] | 0;
     i41 = mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 16 >> 2] | 0, i41 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
     i41 = HEAP32[i6 >> 2] | 0;
     if ((i41 | 0) > -1 & (i41 & 2147483647 | 0) != 0) {
      i1 = HEAP32[i30 >> 2] | 0;
      if (i1 | 0) {
       i41 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       mftCall_vii(HEAP32[(HEAP32[i41 >> 2] | 0) + 12 >> 2] | 0, i41 | 0, i1 | 0);
      }
     }
    } while (0);
    if (!(HEAP8[i21 >> 0] | 0)) break L12;
    i41 = HEAP32[i33 >> 2] | 0;
    if (!(mftCall_ii(HEAP32[(HEAP32[i41 >> 2] | 0) + 24 >> 2] | 0, i41 | 0) | 0)) break L12;
    i1 = HEAP8[i21 >> 0] | 0;
   }
  }
 } while (0);
 i2 = HEAP32[i34 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i37;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i35 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i36 = 39;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i33 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i35 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i35 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i21 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i21 >> 0] = 0;
  } while (i1 >>> 0 > i5 >>> 0);
  if ((i36 | 0) == 39) HEAP8[i21 >> 0] = 1;
  i1 = HEAP32[i34 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i37;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_(i53, i1, i6, i5) {
 i53 = i53 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i54 = 0, i55 = 0;
 i55 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i48 = i55 + 128 | 0;
 i49 = i55;
 i51 = i55 + 64 | 0;
 i52 = i53 + 4 | 0;
 i3 = HEAP32[i52 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i53 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i48 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i48) | 0;
 i1 = HEAP32[i53 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i53 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i50 = HEAP32[i53 + 20 >> 2] | 0;
    i50 = (mftCall_iii(HEAP32[(HEAP32[i50 >> 2] | 0) + 16 >> 2] | 0, i50 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i50;
    i1 = HEAP32[i53 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i50;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i50 = HEAP32[i53 >> 2] | 0;
   HEAP8[(HEAP32[i50 + 4 >> 2] | 0) + ((HEAP32[i50 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i50 = i53 + 36 | 0;
 L12 : do if (HEAP8[i50 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i53, gb + 830924 | 0);
  if (!(HEAP8[i50 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i53 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i50 >> 0] = i1;
  }
  i47 = HEAP32[i53 >> 2] | 0;
  HEAP8[(HEAP32[i47 + 4 >> 2] | 0) + ((HEAP32[i47 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i47 = HEAP32[i53 >> 2] | 0;
  HEAP8[(HEAP32[i47 + 4 >> 2] | 0) + ((HEAP32[i47 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i28 = i51 + 4 | 0;
   i29 = i51 + 8 | 0;
   i30 = i51 + 12 | 0;
   i31 = i51 + 40 | 0;
   i32 = i51 + 16 | 0;
   i33 = i51 + 20 | 0;
   i34 = i51 + 24 | 0;
   i35 = i51 + 28 | 0;
   i36 = i51 + 32 | 0;
   i37 = i51 + 36 | 0;
   i38 = i51 + 44 | 0;
   i39 = i51 + 48 | 0;
   i40 = i51 + 52 | 0;
   i41 = i53 + 8 | 0;
   i42 = i53 + 20 | 0;
   i43 = i53 + 28 | 0;
   i44 = i53 + 32 | 0;
   i45 = i51;
   i46 = i48;
   i47 = i49 + 4 | 0;
   i12 = i49 + 8 | 0;
   i13 = i49 + 20 | 0;
   i14 = i49 + 24 | 0;
   i15 = i49 + 28 | 0;
   i16 = i49 + 32 | 0;
   i17 = i49 + 36 | 0;
   i18 = i49 + 40 | 0;
   i19 = i49 + 44 | 0;
   i20 = i49 + 48 | 0;
   i21 = i5 + 36 | 0;
   i22 = i5 + 52 | 0;
   i23 = i5 + 68 | 0;
   i24 = i5 + 84 | 0;
   i25 = i5 + 100 | 0;
   i26 = i5 + 116 | 0;
   i27 = i5 + 132 | 0;
   i10 = i5 + 136 | 0;
   i11 = i53 + 24 | 0;
   i4 = i6 + 12 | 0;
   i5 = i53 + 40 | 0;
   i6 = 0;
   while (1) {
    HEAPF32[i51 >> 2] = Math_fround(2.0);
    HEAPF32[i28 >> 2] = Math_fround(17.9049301);
    HEAPF32[i29 >> 2] = Math_fround(1.0e3);
    HEAPF32[i30 >> 2] = Math_fround(5.72957754);
    HEAP32[i31 >> 2] = 0;
    HEAPF32[i32 >> 2] = Math_fround(0.0);
    HEAPF32[i33 >> 2] = Math_fround(1.0);
    HEAPF32[i34 >> 2] = Math_fround(.100000001);
    HEAPF32[i35 >> 2] = Math_fround(1.0);
    HEAPF32[i36 >> 2] = Math_fround(1.0);
    HEAPF32[i37 >> 2] = Math_fround(1.0);
    HEAPF32[i38 >> 2] = Math_fround(.00100000005);
    HEAPF32[i39 >> 2] = Math_fround(10.0);
    HEAPF32[i40 >> 2] = Math_fround(1.11111116);
    i8 = HEAP32[i53 >> 2] | 0;
    i7 = HEAP32[i52 >> 2] | 0;
    i1 = HEAP32[i42 >> 2] | 0;
    i2 = HEAP32[i43 >> 2] | 0;
    i3 = HEAP32[i44 >> 2] | 0;
    HEAP8[i48 >> 0] = 0;
    HEAP32[i49 >> 2] = i8;
    HEAP32[i47 >> 2] = i7;
    i7 = i12;
    i8 = i41;
    i9 = i7 + 12 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i8 = i8 + 1 | 0;
    } while ((i7 | 0) < (i9 | 0));
    HEAP32[i13 >> 2] = i1;
    HEAP32[i14 >> 2] = i45;
    HEAP32[i15 >> 2] = i2;
    HEAP32[i16 >> 2] = i3;
    HEAP8[i17 >> 0] = 1;
    HEAP32[i18 >> 2] = i46;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i20 >> 2] = 0;
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj600ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i49, i21, 3);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj601ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i49, i22, 4);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj602ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i49, i23, 5);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj603ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i49, i24, 6);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i49, i25, 7);
    __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj(i49, 8, i26, HEAP32[i27 >> 2] | 0, HEAP32[i10 >> 2] | 0);
    if (HEAP8[i48 >> 0] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 1;
    i1 = HEAP32[i11 >> 2] | 0;
    i7 = i49;
    i8 = i51;
    i9 = i7 + 64 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
    i7 = i48;
    i8 = i49;
    i9 = i7 + 64 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    mftCall_viii(i2 | 0, i1 | 0, i6 | 0, i48 | 0);
    if (!(HEAP8[i50 >> 0] | 0)) break L12;
    i9 = HEAP32[i42 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0) i6 = i6 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i52 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i55;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i53 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i53 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i54 = 22;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i53 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i53 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i50 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i50 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i54 | 0) == 22) HEAP8[i50 >> 0] = 1;
  i1 = HEAP32[i52 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i55;
 return;
}

function __ZN13BuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 24 | 0;
 i8 = i11;
 i9 = i11 + 28 | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i3 = i6 + 28 | 0;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 68 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 108 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 111 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 112 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 113 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 114 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 115 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 116 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 117 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 118 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 109 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 110 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 119 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 120 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
  HEAP32[i4 >> 2] = i2;
 }
 i1 = i6 + 121 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 140 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 124 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN12UnityVersionC2EPKc(i9, i1);
 __ZN12UnityVersionC2EPKc(i8, gb + 443566 | 0);
 if (__ZNK12UnityVersionltERKS_(i9, i8) | 0) {
  __Z6FormatPKcz(i8, gb + 443574 | 0, i10);
  __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE(i8, 0, gb + 443603 | 0, 203, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  _exit(1);
 } else {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags(i7, i6 + 76 | 0, 0);
  __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(HEAP32[i6 + 80 >> 2] | 0, HEAP32[i6 + 84 >> 2] | 0, i8);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags(i7, i6 + 92 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 156 | 0, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN9Animation20BuildAnimationStatesEv(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i28 + 24 | 0;
 i25 = i28;
 i20 = i28 + 8 | 0;
 i21 = i27 + 104 | 0;
 i22 = i27 + 108 | 0;
 if ((HEAP32[i21 >> 2] | 0) != (HEAP32[i22 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 i23 = i27 + 284 | 0;
 i24 = i27 + 288 | 0;
 if ((HEAP32[i23 >> 2] | 0) == (HEAP32[i24 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 if ((HEAP16[gb + 1465188 + 6 >> 1] | 0) > -1) {
  HEAP32[i20 >> 2] = i27;
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465188 | 0, i19);
  i4 = i27 + 104 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i18 = gb + 1465188 | 0; else {
   do {
    i3 = HEAP32[i1 >> 2] | 0;
    if (i3) {
     __ZN14AnimationStateD2Ev(i3);
     __ZdlPv(i3);
     i2 = HEAP32[i22 >> 2] | 0;
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) i18 = gb + 1465188 | 0; else {
    HEAP32[i22 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
    i18 = gb + 1465188 | 0;
   }
  }
 } else i18 = 0;
 __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i21, (HEAP32[i24 >> 2] | 0) - (HEAP32[i23 >> 2] | 0) >> 2);
 d8 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 i1 = HEAP32[i23 >> 2] | 0;
 if ((HEAP32[i24 >> 2] | 0) != (i1 | 0)) {
  i9 = i27 + 112 | 0;
  i10 = i20 + 12 | 0;
  i7 = i20 + 12 | 0;
  i11 = i19 + 4 | 0;
  i12 = i20 + 8 | 0;
  i13 = i20 + 4 | 0;
  i14 = i27 + 36 | 0;
  i15 = i20 + 11 | 0;
  i16 = i19 + 4 | 0;
  i17 = i19 + 11 | 0;
  i6 = 0;
  do {
   i4 = i1 + (i6 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i20 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i26 = 20; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i19, i1, i20);
      i2 = HEAP32[i19 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i26 = 20; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i26 = 22;
     }
    }
    if ((i26 | 0) == 20) i26 = 22;
    if ((i26 | 0) == 22) {
     i26 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0)) {
     i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i5 = mftCall_ii(HEAP32[(HEAP32[i27 >> 2] | 0) + 36 >> 2] | 0, i27 | 0) | 0;
     HEAP32[i25 >> 2] = i4;
     HEAP32[i25 + 4 >> 2] = i5;
     __Z6FormatPKcz(i19, gb + 896682 | 0, i25);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 896407 | 0, 2019, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
     break;
    }
    i2 = __Znwj(160) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAPF32[i2 + 88 >> 2] = Math_fround(0.0);
    HEAPF32[i2 + 92 >> 2] = Math_fround(0.0);
    HEAP32[i2 + 100 >> 2] = 0;
    HEAP32[i2 + 104 >> 2] = 0;
    HEAP32[i2 + 108 >> 2] = i2;
    i3 = i2 + 112 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i2 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i3 = i2 + 128 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i2 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i3 = i2 + 148 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 + 152 >> 2] = 0;
    HEAP32[i2 + 144 >> 2] = i3;
    HEAP32[i2 + 96 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    i3 = i2 + 56 | 0;
    HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -257;
    HEAP32[i19 >> 2] = i2;
    i3 = HEAP32[i22 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i9 >> 2] | 0)) {
     __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i21, i19);
     i2 = HEAP32[i22 >> 2] | 0;
    } else {
     HEAP32[i3 >> 2] = i2;
     i2 = (HEAP32[i22 >> 2] | 0) + 4 | 0;
     HEAP32[i22 >> 2] = i2;
    }
    i4 = HEAP32[i2 + -4 >> 2] | 0;
    i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP32[i20 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = _strlen(i3) | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i20);
     i2 = HEAP32[i7 >> 2] | 0;
     i26 = 31;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i15 >> 0] = i5;
     if (!i5) i2 = i20; else {
      i2 = i20;
      i26 = 33;
     }
    } else i26 = 31;
    if ((i26 | 0) == 31) {
     i29 = i5 + 16 & -16;
     HEAP32[i19 >> 2] = 66;
     HEAP32[i11 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i20 >> 2] = i2;
     HEAP32[i12 >> 2] = i29 | -2147483648;
     HEAP32[i13 >> 2] = i5;
     i26 = 33;
    }
    if ((i26 | 0) == 33) {
     i26 = 0;
     _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
    i29 = HEAP32[i1 + 96 >> 2] | 0;
    __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib(i4, i20, i1, d8, (i29 | 0) == 0 ? HEAP32[i14 >> 2] | 0 : i29, 0);
    if ((HEAP8[i15 >> 0] | 0) < 0) {
     i29 = HEAP32[i20 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     HEAP32[i19 >> 2] = 66;
     HEAP32[i16 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i29, i19);
    }
   } while (0);
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i23 >> 2] | 0;
  } while (i6 >>> 0 < (HEAP32[i24 >> 2] | 0) - i1 >> 2 >>> 0);
 }
 if ((HEAP32[i27 + 44 >> 2] | 0) == 1) {
  i4 = i27 + 72 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = i27 + 68 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i27);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  }
  __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i27, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i27 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN9Animation25CheckRendererVisibleStateEv(i27);
 }
 i29 = i27 + 252 | 0;
 HEAP32[i29 >> 2] = HEAP32[i29 >> 2] | 1;
 mftCall_vi(HEAP32[(HEAP32[i27 >> 2] | 0) + 132 >> 2] | 0, i27 | 0);
 if (!i18) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i28;
 return;
}

function runPostSets9() {
 HEAP32[gb + 29172 >> 2] = fb + 109;
 HEAP32[gb + 29176 >> 2] = fb + 105;
 HEAP32[gb + 29180 >> 2] = fb + 106;
 HEAP32[gb + 29184 >> 2] = fb + 110;
 HEAP32[gb + 29200 >> 2] = (HEAP32[gb + 29200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29204 >> 2] = (HEAP32[gb + 29204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29240 >> 2] = (HEAP32[gb + 29240 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29244 >> 2] = (HEAP32[gb + 29244 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29280 >> 2] = (HEAP32[gb + 29280 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29284 >> 2] = (HEAP32[gb + 29284 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29320 >> 2] = (HEAP32[gb + 29320 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29324 >> 2] = (HEAP32[gb + 29324 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29360 >> 2] = (HEAP32[gb + 29360 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29364 >> 2] = (HEAP32[gb + 29364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29400 >> 2] = (HEAP32[gb + 29400 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29404 >> 2] = (HEAP32[gb + 29404 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29440 >> 2] = (HEAP32[gb + 29440 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29444 >> 2] = (HEAP32[gb + 29444 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29480 >> 2] = (HEAP32[gb + 29480 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29484 >> 2] = (HEAP32[gb + 29484 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29520 >> 2] = (HEAP32[gb + 29520 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29524 >> 2] = (HEAP32[gb + 29524 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29560 >> 2] = (HEAP32[gb + 29560 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29564 >> 2] = (HEAP32[gb + 29564 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29600 >> 2] = (HEAP32[gb + 29600 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29604 >> 2] = (HEAP32[gb + 29604 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29640 >> 2] = (HEAP32[gb + 29640 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29644 >> 2] = (HEAP32[gb + 29644 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29680 >> 2] = (HEAP32[gb + 29680 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29684 >> 2] = (HEAP32[gb + 29684 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29720 >> 2] = (HEAP32[gb + 29720 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29724 >> 2] = (HEAP32[gb + 29724 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29760 >> 2] = (HEAP32[gb + 29760 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29764 >> 2] = (HEAP32[gb + 29764 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29800 >> 2] = (HEAP32[gb + 29800 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29804 >> 2] = (HEAP32[gb + 29804 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29840 >> 2] = (HEAP32[gb + 29840 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29844 >> 2] = (HEAP32[gb + 29844 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29880 >> 2] = (HEAP32[gb + 29880 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29884 >> 2] = (HEAP32[gb + 29884 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29920 >> 2] = (HEAP32[gb + 29920 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29924 >> 2] = (HEAP32[gb + 29924 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29960 >> 2] = (HEAP32[gb + 29960 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29964 >> 2] = (HEAP32[gb + 29964 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 3e4 >> 2] = (HEAP32[gb + 3e4 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30004 >> 2] = (HEAP32[gb + 30004 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30040 >> 2] = (HEAP32[gb + 30040 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30044 >> 2] = (HEAP32[gb + 30044 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30080 >> 2] = (HEAP32[gb + 30080 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30084 >> 2] = (HEAP32[gb + 30084 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30120 >> 2] = (HEAP32[gb + 30120 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30124 >> 2] = (HEAP32[gb + 30124 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30160 >> 2] = (HEAP32[gb + 30160 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30164 >> 2] = (HEAP32[gb + 30164 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30200 >> 2] = (HEAP32[gb + 30200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30204 >> 2] = (HEAP32[gb + 30204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30240 >> 2] = (HEAP32[gb + 30240 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30244 >> 2] = (HEAP32[gb + 30244 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30280 >> 2] = (HEAP32[gb + 30280 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30284 >> 2] = (HEAP32[gb + 30284 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30320 >> 2] = (HEAP32[gb + 30320 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30324 >> 2] = (HEAP32[gb + 30324 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30360 >> 2] = (HEAP32[gb + 30360 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30364 >> 2] = (HEAP32[gb + 30364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30400 >> 2] = (HEAP32[gb + 30400 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30404 >> 2] = (HEAP32[gb + 30404 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30440 >> 2] = (HEAP32[gb + 30440 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30444 >> 2] = (HEAP32[gb + 30444 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30480 >> 2] = (HEAP32[gb + 30480 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30484 >> 2] = (HEAP32[gb + 30484 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30520 >> 2] = (HEAP32[gb + 30520 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30524 >> 2] = (HEAP32[gb + 30524 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30560 >> 2] = (HEAP32[gb + 30560 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30564 >> 2] = (HEAP32[gb + 30564 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30600 >> 2] = (HEAP32[gb + 30600 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30604 >> 2] = (HEAP32[gb + 30604 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30640 >> 2] = (HEAP32[gb + 30640 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30644 >> 2] = (HEAP32[gb + 30644 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30680 >> 2] = (HEAP32[gb + 30680 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30684 >> 2] = (HEAP32[gb + 30684 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30720 >> 2] = (HEAP32[gb + 30720 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30724 >> 2] = (HEAP32[gb + 30724 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30760 >> 2] = (HEAP32[gb + 30760 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30764 >> 2] = (HEAP32[gb + 30764 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30800 >> 2] = (HEAP32[gb + 30800 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30804 >> 2] = (HEAP32[gb + 30804 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30840 >> 2] = (HEAP32[gb + 30840 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30844 >> 2] = (HEAP32[gb + 30844 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30880 >> 2] = (HEAP32[gb + 30880 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30884 >> 2] = (HEAP32[gb + 30884 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30920 >> 2] = (HEAP32[gb + 30920 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30924 >> 2] = (HEAP32[gb + 30924 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 30960 >> 2] = (HEAP32[gb + 30960 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 30964 >> 2] = (HEAP32[gb + 30964 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31e3 >> 2] = (HEAP32[gb + 31e3 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31004 >> 2] = (HEAP32[gb + 31004 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31040 >> 2] = (HEAP32[gb + 31040 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31044 >> 2] = (HEAP32[gb + 31044 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31080 >> 2] = (HEAP32[gb + 31080 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31084 >> 2] = (HEAP32[gb + 31084 >> 2] | 0) + (gb + 1576256 | 0);
 runPostSets10();
}

function __ZN13RenderTexture8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN7Texture8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 80 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932215 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932223 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 406071 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 406086 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 406100 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 116 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 411124 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 117 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 406114 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 118 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 406129 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431875 | 0, gb + 431893 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_(i47, i1, i6, i5) {
 i47 = i47 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i48 = 0, i49 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i49 + 104 | 0;
 i43 = i49;
 i45 = i49 + 56 | 0;
 i46 = i47 + 4 | 0;
 i3 = HEAP32[i46 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i47 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i42 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i42) | 0;
 i1 = HEAP32[i47 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i47 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i44 = HEAP32[i47 + 20 >> 2] | 0;
    i44 = (mftCall_iii(HEAP32[(HEAP32[i44 >> 2] | 0) + 16 >> 2] | 0, i44 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i44;
    i1 = HEAP32[i47 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i44;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i44 = HEAP32[i47 >> 2] | 0;
   HEAP8[(HEAP32[i44 + 4 >> 2] | 0) + ((HEAP32[i44 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i44 = i47 + 36 | 0;
 L12 : do if (HEAP8[i44 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i47, gb + 830924 | 0);
  if (!(HEAP8[i44 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i47 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i44 >> 0] = i1;
  }
  i41 = HEAP32[i47 >> 2] | 0;
  HEAP8[(HEAP32[i41 + 4 >> 2] | 0) + ((HEAP32[i41 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i41 = HEAP32[i47 >> 2] | 0;
  HEAP8[(HEAP32[i41 + 4 >> 2] | 0) + ((HEAP32[i41 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i22 = i45 + 4 | 0;
   i23 = i45 + 8 | 0;
   i24 = i45 + 12 | 0;
   i25 = i45 + 16 | 0;
   i26 = i45 + 20 | 0;
   i27 = i45 + 24 | 0;
   i28 = i47 + 8 | 0;
   i29 = i47 + 20 | 0;
   i30 = i47 + 28 | 0;
   i31 = i47 + 32 | 0;
   i32 = i45;
   i33 = i42;
   i34 = i43 + 4 | 0;
   i35 = i43 + 8 | 0;
   i36 = i43 + 20 | 0;
   i37 = i43 + 24 | 0;
   i38 = i43 + 28 | 0;
   i39 = i43 + 32 | 0;
   i40 = i43 + 36 | 0;
   i41 = i43 + 40 | 0;
   i12 = i43 + 44 | 0;
   i13 = i43 + 48 | 0;
   i14 = i5 + 24 | 0;
   i15 = i5 + 40 | 0;
   i16 = i5 + 56 | 0;
   i17 = i5 + 72 | 0;
   i18 = i5 + 88 | 0;
   i19 = i5 + 104 | 0;
   i20 = i5 + 120 | 0;
   i21 = i5 + 136 | 0;
   i10 = i5 + 152 | 0;
   i11 = i47 + 24 | 0;
   i4 = i6 + 12 | 0;
   i5 = i47 + 40 | 0;
   i6 = 0;
   while (1) {
    HEAPF32[i45 >> 2] = Math_fround(0.0);
    HEAPF32[i22 >> 2] = Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(20.0);
    HEAPF32[i24 >> 2] = Math_fround(0.0);
    HEAPF32[i25 >> 2] = Math_fround(.25);
    HEAPF32[i26 >> 2] = Math_fround(1500.0);
    HEAP32[i27 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    HEAP32[i27 + 12 >> 2] = 0;
    HEAP32[i27 + 16 >> 2] = 0;
    i8 = HEAP32[i47 >> 2] | 0;
    i7 = HEAP32[i46 >> 2] | 0;
    i1 = HEAP32[i29 >> 2] | 0;
    i2 = HEAP32[i30 >> 2] | 0;
    i3 = HEAP32[i31 >> 2] | 0;
    HEAP8[i42 >> 0] = 0;
    HEAP32[i43 >> 2] = i8;
    HEAP32[i34 >> 2] = i7;
    i7 = i35;
    i8 = i28;
    i9 = i7 + 12 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i8 = i8 + 1 | 0;
    } while ((i7 | 0) < (i9 | 0));
    HEAP32[i36 >> 2] = i1;
    HEAP32[i37 >> 2] = i32;
    HEAP32[i38 >> 2] = i2;
    HEAP32[i39 >> 2] = i3;
    HEAP8[i40 >> 0] = 1;
    HEAP32[i41 >> 2] = i33;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = 0;
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj573ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i14, 2);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj574ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i15, 3);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj575ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i16, 4);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj576ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i17, 5);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj577ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i18, 6);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj578ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i19, 7);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj579ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i20, 8);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj580ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i21, 9);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj581ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i43, i10, 10);
    if (HEAP8[i42 >> 0] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 1;
    i1 = HEAP32[i11 >> 2] | 0;
    i7 = i43;
    i8 = i45;
    i9 = i7 + 48 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
    i7 = i42;
    i8 = i43;
    i9 = i7 + 48 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    mftCall_viii(i2 | 0, i1 | 0, i6 | 0, i42 | 0);
    if (!(HEAP8[i44 >> 0] | 0)) break L12;
    i9 = HEAP32[i29 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0) i6 = i6 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i46 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i49;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i47 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i47 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i48 = 22;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i47 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i47 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i44 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i44 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i48 | 0) == 22) HEAP8[i44 >> 0] = 1;
  i1 = HEAP32[i46 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i49;
 return;
}

function __ZNK5physx33PxClothStretchConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj389ENS_22PxRepXPropertyAccessorILj389ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj390ENS_22PxRepXPropertyAccessorILj390ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj391ENS_22PxRepXPropertyAccessorILj391ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj392ENS_22PxRepXPropertyAccessorILj392ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_(i4, i12, i10, i16, i17, i18) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 16 | 0;
 i14 = i21 + 12 | 0;
 i20 = i21;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 if (!(HEAP8[i4 + 4 >> 0] | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAP32[i20 >> 2] = 0;
 i19 = i20 + 4 | 0;
 i1 = gb + 63160 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i19;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i3;
 i9 = i4 + 20 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = i3 << 2;
 do if (!i1) {
  i1 = 0;
  i2 = i3;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i3;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613070 | 0, 83) | 0;
   i11 = gb + 64016 | 0;
   i8 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   i2 = i19;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i2 + 4 >> 2] = i11;
   i2 = HEAP32[i9 >> 2] | 0;
   break;
  }
 } while (0);
 i8 = i1 + 3 & -4;
 i11 = i8;
 if (!i2) i7 = 0; else {
  i7 = i4 + 8 | 0;
  i6 = 0;
  i1 = 0;
  do {
   i5 = (HEAP32[i7 >> 2] | 0) + (i6 * 12 | 0) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   do if (i2) {
    HEAP32[i14 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i15 = 35; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
      i3 = HEAP32[i13 >> 2] | 0;
      i22 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i22 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i22 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 35; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i15 = 37;
     }
    }
    if ((i15 | 0) == 35) i15 = 37;
    if ((i15 | 0) == 37) {
     i15 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i2) break;
    }
    i2 = HEAP32[i2 + 28 >> 2] | 0;
    if (i2) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
     HEAP32[i11 + (i1 << 2) >> 2] = i5;
     i1 = i1 + 1 | 0;
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  i7 = i1;
 }
 i22 = i11 + (i7 << 2) | 0;
 __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i11, i22, i22 - i8 >> 2, fb + 806 | 0);
 L32 : do if ((i7 | 0) > 0) {
  if (!i10) {
   i6 = 0;
   i1 = 0;
   do {
    i5 = HEAP32[i11 + (i6 << 2) >> 2] | 0;
    if ((i6 | 0) > 0) {
     i3 = HEAP32[i11 + (i6 + -1 << 2) >> 2] | 0;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i4 = (HEAP32[i5 + 4 >> 2] | 0) == (i2 | 0);
     L39 : do if (!i4) switch (i2 | 0) {
     case 0:
      {
       HEAP32[i16 >> 2] = i1;
       break L39;
      }
     case 1:
      {
       HEAP32[i17 >> 2] = i1 - (HEAP32[i16 >> 2] | 0);
       break L39;
      }
     default:
      break L39;
     } while (0);
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) != (HEAP32[i3 >> 2] | 0) | i4 ^ 1) i15 = 17;
    } else {
     i2 = HEAP32[i5 >> 2] | 0;
     i15 = 17;
    }
    if ((i15 | 0) == 17) {
     i15 = 0;
     if (!i2) i2 = 0; else {
      HEAP32[i14 >> 2] = i2;
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i2) i15 = 24; else {
       if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[i2 + 32 >> 2] | 0;
        i2 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
        i3 = HEAP32[i13 >> 2] | 0;
        i22 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i2 = (i3 | 0) == -1 ? i22 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i22 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 24; else {
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if (!i2) i15 = 25;
       }
      }
      if ((i15 | 0) == 24) i15 = 25;
      if ((i15 | 0) == 25) {
       i15 = 0;
       i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
      }
     }
     HEAP32[i12 + (i1 << 2) >> 2] = i2;
     i1 = i1 + 1 | 0;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i7 | 0));
  } else {
   i6 = 0;
   i1 = 0;
   do {
    i5 = HEAP32[i11 + (i6 << 2) >> 2] | 0;
    if ((i6 | 0) > 0) {
     i2 = HEAP32[i11 + (i6 + -1 << 2) >> 2] | 0;
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     i4 = (HEAP32[i5 + 4 >> 2] | 0) == (i3 | 0);
     L68 : do if (!i4) switch (i3 | 0) {
     case 0:
      {
       HEAP32[i16 >> 2] = i1;
       break L68;
      }
     case 1:
      {
       HEAP32[i17 >> 2] = i1 - (HEAP32[i16 >> 2] | 0);
       break L68;
      }
     default:
      break L68;
     } while (0);
     if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i2 >> 2] | 0) | i4 ^ 1) i15 = 49;
    } else i15 = 49;
    if ((i15 | 0) == 49) {
     i15 = 0;
     HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[i5 + 8 >> 2];
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i2 = 0; else {
      HEAP32[i14 >> 2] = i2;
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i2) i15 = 55; else {
       if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[i2 + 32 >> 2] | 0;
        i2 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
        i3 = HEAP32[i13 >> 2] | 0;
        i22 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i2 = (i3 | 0) == -1 ? i22 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i22 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 55; else {
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if (!i2) i15 = 57;
       }
      }
      if ((i15 | 0) == 55) i15 = 57;
      if ((i15 | 0) == 57) {
       i15 = 0;
       i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
      }
     }
     HEAP32[i12 + (i1 << 2) >> 2] = i2;
     i1 = i1 + 1 | 0;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i7 | 0));
  }
  if (!i1) i1 = 0; else switch (HEAP32[(HEAP32[i11 + (i1 + -1 << 2) >> 2] | 0) + 4 >> 2] | 0) {
  case 0:
   {
    HEAP32[i16 >> 2] = i1;
    break L32;
   }
  case 1:
   {
    HEAP32[i17 >> 2] = i1 - (HEAP32[i16 >> 2] | 0);
    break L32;
   }
  default:
   {
    HEAP32[i18 >> 2] = i1 - (HEAP32[i17 >> 2] | 0) - (HEAP32[i16 >> 2] | 0);
    break L32;
   }
  }
 } else i1 = 0; while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i19);
 i22 = i1;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZN7VRInput35InsertReferenceTransformIfNecessaryE4PPtrI9TransformE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 128 | 0;
 i7 = i15 + 124 | 0;
 i14 = i15 + 32 | 0;
 i10 = i15 + 16 | 0;
 i11 = i15;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 9;
 }
 if ((i12 | 0) == 7) i12 = 9;
 if ((i12 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i8 = i9 + 4 | 0;
 i4 = i9 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i13 >> 2] | 0;
  i1 = i4;
  L19 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L19; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i4 | 0)) if (!((i1 | 0) == (i4 | 0) ? 1 : (i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0))) {
   STACKTOP = i15;
   return;
  }
 }
 HEAP32[i14 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 24 >> 2] = Math_fround(1.0);
 i5 = i14 + 28 | 0;
 i1 = i5;
 i2 = gb + 1162292 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 23; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 23; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 25;
  }
 }
 if ((i12 | 0) == 23) i12 = 25;
 if ((i12 | 0) == 25) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 __ZNK9Transform16GetLocalPositionEv(i10, i1);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 i4 = i14 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 31; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 31; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 33;
  }
 }
 if ((i12 | 0) == 31) i12 = 33;
 if ((i12 | 0) == 33) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 __ZNK9Transform16GetLocalRotationEv(i10, i1);
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 39; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 39; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 41;
  }
 }
 if ((i12 | 0) == 39) i12 = 41;
 if ((i12 | 0) == 41) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 __ZNK9Transform16GetLocalPositionEv(i10, i1);
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 47; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 47; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 49;
  }
 }
 if ((i12 | 0) == 47) i12 = 49;
 if ((i12 | 0) == 49) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 __ZNK9Transform16GetLocalRotationEv(i11, i1);
 __ZN10Matrix4x4f12SetTRInverseERK8Vector3fRK11Quaternionf(i5, i10, i11);
 i1 = __ZNSt3__23mapI4PPtrI9TransformEN7VRInput18ReferenceTransformENS_4lessIS3_EE13stl_allocatorINS_4pairIKS3_S5_EEL18MemLabelIdentifier87ELi16EEEixERSA_(i8, i13) | 0;
 i2 = i14;
 i3 = i1 + 92 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZNSt3__23mapI4PPtrI9TransformEN7VRInput18ReferenceTransformENS_4lessIS3_EE13stl_allocatorINS_4pairIKS3_S5_EEL18MemLabelIdentifier87ELi16EEEixERSA_(i8, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 244 >> 2] | 0;
  if (i1 | 0) mftCall_viii(i1 | 0, HEAP32[i13 >> 2] | 0, i14 | 0, i4 | 0);
 }
 STACKTOP = i15;
 return;
}

function __ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0;
 i20 = HEAP32[i5 >> 2] | 0;
 i29 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = HEAP32[i20 >> 2] | 0;
 i30 = i20 + 4 | 0;
 i11 = HEAP32[i30 >> 2] | 0;
 i31 = i20 + 8 | 0;
 i12 = HEAP32[i31 >> 2] | 0;
 i7 = HEAP32[i29 >> 2] | 0;
 i21 = i29 + 4 | 0;
 i8 = HEAP32[i21 >> 2] | 0;
 i22 = i29 + 8 | 0;
 i13 = HEAP32[i22 >> 2] | 0;
 i23 = i20 + 16 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 i24 = i20 + 20 | 0;
 i9 = HEAP32[i24 >> 2] | 0;
 i25 = i20 + 24 | 0;
 i6 = HEAP32[i25 >> 2] | 0;
 i26 = i29 + 16 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 i27 = i29 + 20 | 0;
 i2 = HEAP32[i27 >> 2] | 0;
 i28 = i29 + 24 | 0;
 i3 = HEAP32[i28 >> 2] | 0;
 i14 = HEAP32[i5 + 16 >> 2] | 0;
 i17 = HEAP16[i5 + 26 >> 1] | 0;
 i19 = i14 + ((i17 & 65535) << 4) | 0;
 if (!(i17 << 16 >> 16)) {
  i5 = i12;
  i32 = i11;
  i33 = i10;
  i12 = i13;
  i11 = i8;
  i10 = i7;
  i15 = i6;
  i14 = i9;
  i13 = i4;
  i19 = i3;
  i17 = i2;
  i16 = i1;
  HEAP32[i20 >> 2] = i33;
  HEAP32[i30 >> 2] = i32;
  HEAP32[i31 >> 2] = i5;
  HEAP32[i29 >> 2] = i10;
  HEAP32[i21 >> 2] = i11;
  HEAP32[i22 >> 2] = i12;
  HEAP32[i23 >> 2] = i13;
  HEAP32[i24 >> 2] = i14;
  HEAP32[i25 >> 2] = i15;
  HEAP32[i26 >> 2] = i16;
  HEAP32[i27 >> 2] = i17;
  HEAP32[i28 >> 2] = i19;
  return;
 } else {
  i5 = i9;
  i9 = i13;
 }
 do {
  i15 = i14 + 32 | 0;
  i32 = (((HEAPU8[i14 + 1 >> 0] | 0) << 2) + 12 & 2032) + 32 | 0;
  i16 = i14 + i32 | 0;
  i33 = HEAP8[i14 + 2 >> 0] | 0;
  i17 = i33 & 255;
  f18 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  i14 = i14 + (i32 + (i17 * 96 | 0)) | 0;
  if (i33 << 24 >> 24) {
   i13 = 0;
   do {
    i32 = i13;
    i13 = i13 + 1 | 0;
    f50 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) >> 2]);
    f49 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 4 >> 2]);
    f64 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 8 >> 2]);
    i33 = i16 + (i32 * 96 | 0) + 12 | 0;
    f45 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 16 >> 2]);
    f53 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 20 >> 2]);
    f42 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 24 >> 2]);
    f39 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 32 >> 2]);
    f44 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 36 >> 2]);
    f63 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 40 >> 2]);
    f35 = Math_fround(HEAPF32[i33 >> 2]);
    f62 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 28 >> 2]);
    f60 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 44 >> 2]);
    f61 = Math_fround(f18 * Math_fround(HEAPF32[i15 + (HEAP32[i16 + (i32 * 96 | 0) + 80 >> 2] << 2) >> 2]));
    f34 = Math_fround(-f61);
    f59 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f59 * f50);
    f58 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f37 + Math_fround(f58 * f49));
    f57 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f37 = Math_fround(f37 + Math_fround(f57 * f64));
    f47 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f45 = Math_fround(f47 * f45);
    f46 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f53 = Math_fround(f45 + Math_fround(f46 * f53));
    f45 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f42 = Math_fround(f53 + Math_fround(f45 * f42));
    f53 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f53 * f50);
    f52 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f43 + Math_fround(f52 * f49));
    f51 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f43 + Math_fround(f51 * f64));
    f41 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f39 = Math_fround(f41 * f39);
    f40 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f44 = Math_fround(f39 + Math_fround(f40 * f44));
    f39 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f63 = Math_fround(Math_fround(f37 + f42) - Math_fround(f43 + Math_fround(f44 + Math_fround(f39 * f63))));
    f44 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 48 >> 2]);
    f43 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 52 >> 2]);
    f42 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 56 >> 2]);
    f37 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 64 >> 2]);
    f36 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 68 >> 2]);
    f38 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 72 >> 2]);
    f54 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 60 >> 2]);
    f56 = Math_fround(f50 * f54);
    f55 = Math_fround(f49 * f54);
    f54 = Math_fround(f64 * f54);
    f48 = Math_fround(HEAPF32[i16 + (i32 * 96 | 0) + 76 >> 2]);
    f50 = Math_fround(f50 * f48);
    f49 = Math_fround(f49 * f48);
    f48 = Math_fround(f64 * f48);
    f60 = Math_fround(Math_fround(f62 * f63) + Math_fround(f35 - Math_fround(f62 * f60)));
    f60 = f60 > f61 ? f61 : f60;
    f34 = f60 > f34 ? f60 : f34;
    f35 = Math_fround(f34 - f35);
    f56 = Math_fround(f59 + Math_fround(f35 * f56));
    f55 = Math_fround(f58 + Math_fround(f35 * f55));
    f54 = Math_fround(f57 + Math_fround(f35 * f54));
    i10 = (HEAPF32[tempDoublePtr >> 2] = f56, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f55, HEAP32[tempDoublePtr >> 2] | 0);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f54, HEAP32[tempDoublePtr >> 2] | 0);
    f50 = Math_fround(f53 + Math_fround(f35 * f50));
    f49 = Math_fround(f52 + Math_fround(f35 * f49));
    f48 = Math_fround(f51 + Math_fround(f35 * f48));
    i7 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f49, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f48, HEAP32[tempDoublePtr >> 2] | 0);
    f44 = Math_fround(f47 + Math_fround(f44 * f35));
    f43 = Math_fround(f46 + Math_fround(f43 * f35));
    f42 = Math_fround(f45 + Math_fround(f42 * f35));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
    f37 = Math_fround(f41 + Math_fround(f37 * f35));
    f36 = Math_fround(f40 + Math_fround(f36 * f35));
    f35 = Math_fround(f39 + Math_fround(f38 * f35));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i33 >> 2] = f34;
   } while ((i13 | 0) != (i17 | 0));
  }
 } while (i14 >>> 0 < i19 >>> 0);
 HEAP32[i20 >> 2] = i10;
 HEAP32[i30 >> 2] = i11;
 HEAP32[i31 >> 2] = i12;
 HEAP32[i29 >> 2] = i7;
 HEAP32[i21 >> 2] = i8;
 HEAP32[i22 >> 2] = i9;
 HEAP32[i23 >> 2] = i4;
 HEAP32[i24 >> 2] = i5;
 HEAP32[i25 >> 2] = i6;
 HEAP32[i26 >> 2] = i1;
 HEAP32[i27 >> 2] = i2;
 HEAP32[i28 >> 2] = i3;
 return;
}

function __ZN5physx6shdfnd8internal9partitionINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceEKNS4_25SortCUDAProfileOccurencesEEEiPT_iiRT0_(i12, i2, i10, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i8 = (i10 + i2 | 0) / 2 | 0;
 i9 = i12 + (i8 * 24 | 0) | 0;
 i1 = HEAP16[i9 >> 1] | 0;
 i8 = i12 + (i8 * 24 | 0) + 8 | 0;
 i6 = i12 + (i2 * 24 | 0) | 0;
 i3 = HEAP16[i6 >> 1] | 0;
 i7 = i12 + (i2 * 24 | 0) + 8 | 0;
 if ((i1 & 65535) < (i3 & 65535)) i11 = 3; else {
  i5 = i7;
  i15 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i8;
  i16 = HEAP32[i4 + 4 >> 2] | 0;
  if (i1 << 16 >> 16 == i3 << 16 >> 16 & (i16 >>> 0 < i15 >>> 0 | ((i16 | 0) == (i15 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0))) i11 = 3; else i1 = i3;
 }
 if ((i11 | 0) == 3) {
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  i1 = HEAP16[i6 >> 1] | 0;
 }
 i4 = i12 + (i10 * 24 | 0) | 0;
 i3 = HEAP16[i4 >> 1] | 0;
 i5 = i12 + (i10 * 24 | 0) + 8 | 0;
 if ((i3 & 65535) < (i1 & 65535)) i11 = 6; else {
  i16 = i7;
  i7 = HEAP32[i16 + 4 >> 2] | 0;
  i15 = i5;
  i17 = HEAP32[i15 + 4 >> 2] | 0;
  if (i3 << 16 >> 16 == i1 << 16 >> 16 & (i17 >>> 0 < i7 >>> 0 | ((i17 | 0) == (i7 | 0) ? (HEAP32[i15 >> 2] | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0 : 0))) i11 = 6;
 }
 if ((i11 | 0) == 6) {
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  i3 = HEAP16[i4 >> 1] | 0;
 }
 i1 = HEAP16[i9 >> 1] | 0;
 if ((i3 & 65535) < (i1 & 65535)) i11 = 9; else {
  i17 = i8;
  i15 = HEAP32[i17 + 4 >> 2] | 0;
  i16 = i5;
  i8 = HEAP32[i16 + 4 >> 2] | 0;
  if (i3 << 16 >> 16 == i1 << 16 >> 16 & (i8 >>> 0 < i15 >>> 0 | ((i8 | 0) == (i15 | 0) ? (HEAP32[i16 >> 2] | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0 : 0))) i11 = 9;
 }
 if ((i11 | 0) == 9) {
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 }
 i4 = i10 + -1 | 0;
 i10 = i12 + (i4 * 24 | 0) | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 i9 = i12 + (i4 * 24 | 0) + 8 | 0;
 while (1) {
  i6 = HEAP16[i10 >> 1] | 0;
  i8 = i9;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   i1 = i12 + (i2 * 24 | 0) | 0;
   i3 = HEAP16[i1 >> 1] | 0;
   if ((i3 & 65535) < (i6 & 65535)) continue;
   i17 = i12 + (i2 * 24 | 0) + 8 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   if (!(i3 << 16 >> 16 == i6 << 16 >> 16 & (i16 >>> 0 < i8 >>> 0 | ((i16 | 0) == (i8 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < i7 >>> 0 : 0)))) break;
  }
  while (1) {
   i4 = i4 + -1 | 0;
   i3 = i12 + (i4 * 24 | 0) | 0;
   i5 = HEAP16[i3 >> 1] | 0;
   if ((i6 & 65535) < (i5 & 65535)) continue;
   i17 = i12 + (i4 * 24 | 0) + 8 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   if (!(i6 << 16 >> 16 == i5 << 16 >> 16 & (i8 >>> 0 < i16 >>> 0 | ((i8 | 0) == (i16 | 0) ? i7 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0 : 0)))) break;
  }
  if ((i2 | 0) >= (i4 | 0)) break;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 }
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 STACKTOP = i14;
 return i2 | 0;
}

function __ZN19SpriteMeshGenerator9DecomposeEP13dynamic_arrayI8Vector2fLj4EEPS0_ItLj2EEb(i2, i25, i20, i22) {
 i2 = i2 | 0;
 i25 = i25 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i28 + 4 | 0;
 i1 = i28;
 i12 = i2 + 4 | 0;
 if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 i23 = i25 + 16 | 0;
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i25 + 4 | 0);
  HEAP32[i25 >> 2] = 0;
 }
 HEAP32[i25 >> 2] = 0;
 i18 = i25 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 i19 = i20 + 16 | 0;
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i20 + 4 | 0);
  HEAP32[i20 >> 2] = 0;
 }
 HEAP32[i20 >> 2] = 0;
 i21 = i20 + 12 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 if ((HEAP16[gb + 1155228 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155228 | 0, i11);
  i26 = gb + 1155228 | 0;
 } else i26 = 0;
 i27 = __Z11tessNewTessP9TESSalloc(0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i12 >> 2] | 0)) {
  i8 = i11 + 4 | 0;
  i9 = i11 + 8 | 0;
  i10 = i11 + 8 | 0;
  do {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i4 = i1 + 4 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
   i3 = i2 >> 5;
   if (i3 | 0) {
    if (i3 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
    i7 = __Znwj(i2) | 0;
    HEAP32[i8 >> 2] = i7;
    HEAP32[i11 >> 2] = i7;
    HEAP32[i10 >> 2] = i7 + (i3 << 5);
    i2 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) != (i5 | 0)) {
     i6 = (i5 + -32 - i2 | 0) >>> 5;
     i3 = i7;
     i4 = i7;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
      i17 = i3 + 16 | 0;
      i15 = i2 + 16 | 0;
      HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
      i2 = i2 + 32 | 0;
      i4 = i4 + 32 | 0;
      if ((i2 | 0) == (i5 | 0)) break; else i3 = i4;
     }
     HEAP32[i8 >> 2] = i7 + 32 + (i6 << 5);
    }
   }
   __ZL15ProcessVerticesRNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEEEPFbNS_11__wrap_iterIPS2_EES9_S9_E(i11);
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = (HEAP32[i8 >> 2] | 0) - i2 >> 5;
   if (i3) {
    __Z14tessAddContourP14TESStesselatoriPKvii(i27, 2, i2, 32, i3);
    i2 = HEAP32[i11 >> 2] | 0;
   }
   i3 = i2;
   if (i2 | 0) {
    i4 = HEAP32[i8 >> 2] | 0;
    if ((i4 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i4 + (~((i4 + -32 - i3 | 0) >>> 5) << 5);
    __ZdlPv(i2);
   }
   i1 = i1 + 68 | 0;
  } while ((i1 | 0) != (HEAP32[i12 >> 2] | 0));
 }
 __Z13tessTesselateP14TESStesselatoriiiiPKf(i27, 1, 0, 3, 2, 0) | 0;
 i9 = __Z19tessGetElementCountP14TESStesselator(i27) | 0;
 i10 = __Z15tessGetElementsP14TESStesselator(i27) | 0;
 i11 = __Z15tessGetVerticesP14TESStesselator(i27) | 0;
 if ((i9 | 0) > 0) {
  i12 = i20 + 4 | 0;
  i15 = i25 + 4 | 0;
  f16 = Math_fround(HEAPF32[gb + 62456 >> 2]);
  i7 = 0;
  do {
   i17 = i10 + (i7 * 3 << 2) | 0;
   i8 = 0;
   do {
    i2 = HEAP32[i17 + (i8 << 2) >> 2] << 1;
    f13 = Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]);
    f14 = Math_fround(HEAPF32[i11 + ((i2 | 1) << 2) >> 2]);
    i2 = HEAP32[i18 >> 2] | 0;
    L43 : do if (!i2) i24 = 40; else {
     i3 = HEAP32[i25 >> 2] | 0;
     i1 = 0;
     while (1) {
      if (Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i3 + (i1 << 3) >> 2]) - f13))) <= f16) if (Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i3 + (i1 << 3) + 4 >> 2]) - f14))) <= f16) break;
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i2 >>> 0) {
       i24 = 40;
       break L43;
      }
     }
     i2 = i1 & 65535;
     i3 = HEAP32[i21 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i19 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i19 >> 2] = i1;
       HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 1, 2, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 1 | 0) | 0;
       HEAP32[i19 >> 2] = i1;
       HEAP32[i20 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i21 >> 2] = i4;
     HEAP16[(HEAP32[i20 >> 2] | 0) + (i3 << 1) >> 1] = i2;
    } while (0);
    if ((i24 | 0) == 40) {
     i24 = 0;
     i2 = i2 & 65535;
     i3 = HEAP32[i21 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i19 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i19 >> 2] = i1;
       HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 1, 2, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] << 1 | 0) | 0;
       HEAP32[i19 >> 2] = i1;
       HEAP32[i20 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i21 >> 2] = i4;
     HEAP16[(HEAP32[i20 >> 2] | 0) + (i3 << 1) >> 1] = i2;
     i2 = HEAP32[i18 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i23 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i23 >> 2] = i1;
       HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 3, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i18 >> 2] << 3 | 0) | 0;
       HEAP32[i23 >> 2] = i1;
       HEAP32[i25 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i18 >> 2] = i3;
     i6 = HEAP32[i25 >> 2] | 0;
     HEAPF32[i6 + (i2 << 3) >> 2] = f13;
     HEAPF32[i6 + (i2 << 3) + 4 >> 2] = f14;
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != 3);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i9 | 0));
 }
 if (i22) {
  i1 = HEAP32[i18 >> 2] | 0;
  if (i1 | 0) {
   i25 = HEAP32[i25 >> 2] | 0;
   i2 = i25 + (i1 << 3) | 0;
   i1 = i25;
   do {
    HEAPF32[i1 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(.5))));
    i25 = i1 + 4 | 0;
    HEAPF32[i25 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i25 >> 2]) + Math_fround(.5))));
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 __Z14tessDeleteTessP14TESStesselator(i27);
 if (!i26) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i26);
 STACKTOP = i28;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i6 = i12;
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i11 = i8 + 24 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i7 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i7 + 24 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i7 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if ((i1 | 0) == -16777217) {
  HEAP32[i6 >> 2] = 0;
  i4 = i6 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
    i1 = i1 + 60 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i1 = i2;
  if (i2 | 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i3 + (~(((i3 + -60 - i1 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i6 = HEAP32[i6 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i9 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
  }
 } else {
  i3 = i7 + 40 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
  }
  __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i8 + 8 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 + 52 >> 2] | 0;
  i2 = i1 + (i6 * 60 | 0) | 0;
  if (i6 | 0) do {
   __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i8, i7, 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i8, i7 + 80 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 192 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 196 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 188 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 100 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 104 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 116 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 120 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = i7 + 200 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i11 = HEAP32[i9 >> 2] | 0;
  i11 = _llvm_bswap_i32(i11 | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i12;
  return;
 } else {
  i11 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i11;
  HEAP32[i10 >> 2] = i3;
  i11 = _llvm_bswap_i32(i11 | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
}

function __ZN12b2MotorJoint23InitVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i35 = HEAP32[i1 + 48 >> 2] | 0;
 i13 = HEAP32[i35 + 8 >> 2] | 0;
 i10 = i1 + 104 | 0;
 HEAP32[i10 >> 2] = i13;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 i41 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = i1 + 108 | 0;
 HEAP32[i5 >> 2] = i41;
 i16 = i35 + 28 | 0;
 i40 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i38 = i1 + 128 | 0;
 HEAP32[i38 >> 2] = i40;
 HEAP32[i38 + 4 >> 2] = i16;
 i38 = i6 + 28 | 0;
 i39 = HEAP32[i38 >> 2] | 0;
 i38 = HEAP32[i38 + 4 >> 2] | 0;
 i37 = i1 + 136 | 0;
 HEAP32[i37 >> 2] = i39;
 HEAP32[i37 + 4 >> 2] = i38;
 i37 = HEAP32[i35 + 120 >> 2] | 0;
 HEAP32[i1 + 156 >> 2] = i37;
 i36 = HEAP32[i6 + 120 >> 2] | 0;
 HEAP32[i1 + 160 >> 2] = i36;
 i35 = HEAP32[i35 + 128 >> 2] | 0;
 HEAP32[i1 + 164 >> 2] = i35;
 i6 = HEAP32[i6 + 128 >> 2] | 0;
 HEAP32[i1 + 168 >> 2] = i6;
 i12 = HEAP32[i2 + 24 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i12 + (i13 * 12 | 0) >> 2]);
 f29 = Math_fround(HEAPF32[i12 + (i13 * 12 | 0) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i12 + (i13 * 12 | 0) + 8 >> 2]);
 i7 = i2 + 28 | 0;
 i42 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i42 + (i13 * 12 | 0) >> 2] | 0;
 i9 = HEAP32[i42 + (i13 * 12 | 0) + 4 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i42 + (i13 * 12 | 0) + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i12 + (i41 * 12 | 0) >> 2]);
 f28 = Math_fround(HEAPF32[i12 + (i41 * 12 | 0) + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i12 + (i41 * 12 | 0) + 8 >> 2]);
 i12 = HEAP32[i42 + (i41 * 12 | 0) >> 2] | 0;
 i13 = HEAP32[i42 + (i41 * 12 | 0) + 4 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i42 + (i41 * 12 | 0) + 8 >> 2]);
 f25 = Math_fround(+Math_sin(+f21));
 f23 = Math_fround(+Math_cos(+f21));
 f3 = Math_fround(+Math_sin(+f22));
 f19 = Math_fround(+Math_cos(+f22));
 f20 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f15 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f27 = Math_fround(Math_fround(f23 * f20) - Math_fround(f25 * f15));
 f15 = Math_fround(Math_fround(f25 * f20) + Math_fround(f23 * f15));
 i16 = i1 + 112 | 0;
 HEAPF32[i16 >> 2] = f27;
 HEAPF32[i1 + 116 >> 2] = f15;
 f20 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f18 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(Math_fround(f19 * f20) - Math_fround(f3 * f18));
 f18 = Math_fround(Math_fround(f3 * f20) + Math_fround(f19 * f18));
 HEAPF32[i1 + 120 >> 2] = f17;
 HEAPF32[i1 + 124 >> 2] = f18;
 f19 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f34 = Math_fround(f19 + f20);
 f30 = Math_fround(Math_fround(f34 + Math_fround(f15 * Math_fround(f3 * f15))) + Math_fround(f18 * Math_fround(f4 * f18)));
 f32 = Math_fround(f3 * f27);
 f33 = Math_fround(f4 * f17);
 f31 = Math_fround(Math_fround(-Math_fround(f15 * f32)) - Math_fround(f18 * f33));
 f33 = Math_fround(Math_fround(f34 + Math_fround(f27 * f32)) + Math_fround(f17 * f33));
 f32 = Math_fround(Math_fround(f30 * f33) - Math_fround(f31 * f31));
 i6 = f32 != Math_fround(0.0);
 f34 = Math_fround(Math_fround(1.0) / f32);
 f32 = i6 ? f34 : f32;
 f31 = Math_fround(-Math_fround(f31 * f32));
 f30 = Math_fround(f30 * f32);
 HEAPF32[i1 + 172 >> 2] = Math_fround(f33 * f32);
 HEAPF32[i1 + 176 >> 2] = f31;
 HEAPF32[i1 + 180 >> 2] = f31;
 HEAPF32[i1 + 184 >> 2] = f30;
 f30 = Math_fround(f3 + f4);
 i6 = f30 > Math_fround(0.0);
 f31 = Math_fround(Math_fround(1.0) / f30);
 HEAPF32[i1 + 188 >> 2] = i6 ? f31 : f30;
 f27 = Math_fround(Math_fround(Math_fround(f24 + f17) - f26) - f27);
 f29 = Math_fround(Math_fround(Math_fround(f28 + f18) - f29) - f15);
 f28 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f26 = Math_fround(f23 * f28);
 f24 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f23 = Math_fround(f29 - Math_fround(Math_fround(f25 * f28) + Math_fround(f23 * f24)));
 HEAPF32[i1 + 144 >> 2] = Math_fround(f27 - Math_fround(f26 - Math_fround(f25 * f24)));
 HEAPF32[i1 + 148 >> 2] = f23;
 f21 = Math_fround(f22 - f21);
 HEAPF32[i1 + 152 >> 2] = Math_fround(f21 - Math_fround(HEAPF32[i1 + 76 >> 2]));
 i6 = i1 + 80 | 0;
 if (!(HEAP8[i2 + 20 >> 0] | 0)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
  f33 = f11;
  f34 = f14;
  i38 = i12;
  i36 = i8;
  i41 = i13;
  i40 = i9;
  i42 = HEAP32[i10 >> 2] | 0;
  i39 = HEAP32[i7 >> 2] | 0;
  i37 = i39 + (i42 * 12 | 0) | 0;
  HEAP32[i37 >> 2] = i36;
  i42 = i39 + (i42 * 12 | 0) + 4 | 0;
  HEAP32[i42 >> 2] = i40;
  i42 = HEAP32[i10 >> 2] | 0;
  i40 = HEAP32[i7 >> 2] | 0;
  i42 = i40 + (i42 * 12 | 0) + 8 | 0;
  HEAPF32[i42 >> 2] = f33;
  i42 = HEAP32[i5 >> 2] | 0;
  i39 = i40 + (i42 * 12 | 0) | 0;
  HEAP32[i39 >> 2] = i38;
  i42 = i40 + (i42 * 12 | 0) + 4 | 0;
  HEAP32[i42 >> 2] = i41;
  i42 = HEAP32[i5 >> 2] | 0;
  i41 = HEAP32[i7 >> 2] | 0;
  i42 = i41 + (i42 * 12 | 0) + 8 | 0;
  HEAPF32[i42 >> 2] = f34;
  return;
 } else {
  f30 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f34 = Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i6 >> 2] = f34;
  i36 = i1 + 84 | 0;
  f31 = Math_fround(f30 * Math_fround(HEAPF32[i36 >> 2]));
  HEAPF32[i36 >> 2] = f31;
  i36 = i1 + 88 | 0;
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i36 >> 2]));
  HEAPF32[i36 >> 2] = f30;
  f29 = Math_fround(f19 * f34);
  f33 = Math_fround(f19 * f31);
  f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f29);
  i36 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f33);
  i40 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround(f11 - Math_fround(f3 * Math_fround(f30 + Math_fround(Math_fround(f31 * Math_fround(HEAPF32[i16 >> 2])) - Math_fround(f34 * f15)))));
  f29 = Math_fround(f20 * f34);
  f32 = Math_fround(f20 * f31);
  f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
  i38 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
  f34 = Math_fround(f14 + Math_fround(f4 * Math_fround(f30 + Math_fround(Math_fround(f31 * f17) - Math_fround(f34 * f18)))));
  i41 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i42 = HEAP32[i10 >> 2] | 0;
  i39 = HEAP32[i7 >> 2] | 0;
  i37 = i39 + (i42 * 12 | 0) | 0;
  HEAP32[i37 >> 2] = i36;
  i42 = i39 + (i42 * 12 | 0) + 4 | 0;
  HEAP32[i42 >> 2] = i40;
  i42 = HEAP32[i10 >> 2] | 0;
  i40 = HEAP32[i7 >> 2] | 0;
  i42 = i40 + (i42 * 12 | 0) + 8 | 0;
  HEAPF32[i42 >> 2] = f33;
  i42 = HEAP32[i5 >> 2] | 0;
  i39 = i40 + (i42 * 12 | 0) | 0;
  HEAP32[i39 >> 2] = i38;
  i42 = i40 + (i42 * 12 | 0) + 4 | 0;
  HEAP32[i42 >> 2] = i41;
  i42 = HEAP32[i5 >> 2] | 0;
  i41 = HEAP32[i7 >> 2] | 0;
  i42 = i41 + (i42 * 12 | 0) + 8 | 0;
  HEAPF32[i42 >> 2] = f34;
  return;
 }
}

function __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorI13dynamic_arrayI5PlaneLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 8 | 0;
 i16 = i30;
 i29 = i30 + 104 | 0;
 i19 = i30 + 80 | 0;
 i20 = i30 + 60 | 0;
 i21 = i30 + 40 | 0;
 if ((HEAP16[gb + 1459056 + 6 >> 1] | 0) > -1) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i16 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459056 | 0, i27);
  i28 = gb + 1459056 | 0;
 } else i28 = 0;
 i3 = (HEAP32[i13 + 4 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
 i14 = (i3 | 0) / 20 | 0;
 HEAP32[i29 >> 2] = 0;
 i26 = i29 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7reserveEj(i29, 12);
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i1 = i16;
 HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i1 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i1 = i19 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i16);
 i15 = i27;
 i22 = HEAP32[i15 + 4 >> 2] | 0;
 i23 = i18;
 HEAP32[i23 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i23 + 4 >> 2] = i22;
 i23 = gb + 64016 | 0;
 i22 = HEAP32[i23 + 4 >> 2] | 0;
 i15 = i16;
 HEAP32[i15 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i15 + 4 >> 2] = i22;
 HEAP32[i20 >> 2] = 0;
 i15 = i20 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i22 = i20 + 16 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i16);
 i4 = i27;
 i24 = HEAP32[i4 + 4 >> 2] | 0;
 i25 = i23;
 HEAP32[i25 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i25 + 4 >> 2] = i24;
 i25 = gb + 64016 | 0;
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i4 = i16;
 HEAP32[i4 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i4 + 4 >> 2] = i24;
 HEAP32[i21 >> 2] = 0;
 i4 = i21 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i24 = i21 + 16 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i27, i16);
 i10 = i27;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i25;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = HEAP32[i17 >> 2] | 0;
 do if ((i2 & 2147483646) >>> 0 < 6) if ((i2 | 0) > -1) {
  HEAP32[i17 >> 2] = 6;
  HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, 72, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i19 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i17 >> 2] = 6;
  HEAP32[i19 >> 2] = i11;
  break;
 } while (0);
 i1 = HEAP32[i22 >> 2] | 0;
 do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
  HEAP32[i22 >> 2] = 32;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, 384, 4, i23, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i22 >> 2] = 32;
  HEAP32[i20 >> 2] = i11;
  break;
 } while (0);
 i1 = HEAP32[i24 >> 2] | 0;
 do if ((i1 & 2147483616) >>> 0 < 32) if ((i1 | 0) > -1) {
  HEAP32[i24 >> 2] = 32;
  HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, 384, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i24 >> 2] = 32;
  HEAP32[i21 >> 2] = i11;
  break;
 } while (0);
 if (!i3) i4 = 0; else {
  i9 = i12 + 12 | 0;
  i10 = i12 + 40 | 0;
  i11 = i12 + 52 | 0;
  i4 = 0;
  i8 = 0;
  do {
   i6 = (HEAP32[i13 >> 2] | 0) + (i8 * 20 | 0) | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   if (i7) {
    i5 = 0;
    i1 = 0;
    do {
     __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i12, i20, (HEAP32[i12 >> 2] | 0) + (i5 * 26 | 0) | 0);
     __ZNK11DynamicMesh12IntersectionER13dynamic_arrayI8Vector3fLj4EERKS0_I5PlaneLj4EES3_Ph(i12, i20, i6, i21, i27);
     if (HEAP32[i15 >> 2] | 0) {
      HEAP32[i16 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2];
      __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i12, i19, (HEAP32[i12 >> 2] | 0) + (i5 * 26 | 0) | 0);
      __ZNK11DynamicMesh8SubtractERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEERKS4_RS4_SC_PKhRKS2_I5PlaneLj4EE(i12, i29, i19, i20, i21, i27, i6);
      __ZN11DynamicMesh13MergePolygonsERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(0, i29);
      if ((i5 | 0) != (i1 | 0)) {
       i3 = HEAP32[i12 >> 2] | 0;
       i2 = i3 + (i5 * 26 | 0) | 0;
       i3 = i3 + (i1 * 26 | 0) | 0;
       i4 = i2 + 26 | 0;
       do {
        HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
        i2 = i2 + 2 | 0;
        i3 = i3 + 2 | 0;
       } while ((i2 | 0) < (i4 | 0));
       i4 = HEAP32[i10 >> 2] | 0;
       HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
      }
      i1 = i1 + 1 | 0;
      i2 = HEAP32[i29 >> 2] | 0;
      if ((HEAP32[i26 >> 2] | 0) != (i2 | 0)) {
       i3 = 0;
       do {
        __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij(i12, i2 + (i3 * 20 | 0) | 0, i16, 1);
        i3 = i3 + 1 | 0;
        i2 = HEAP32[i29 >> 2] | 0;
       } while (i3 >>> 0 < (((HEAP32[i26 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0);
      }
      i4 = 1;
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i7 | 0));
    if (i1) {
     i7 = HEAP32[i12 >> 2] | 0;
     _memmove(i7 | 0, i7 + (i1 * 26 | 0) | 0, ((HEAP32[i9 >> 2] | 0) - i1 | 0) * 26 | 0) | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - ((i1 * 26 | 0) / 26 | 0);
     i7 = HEAP32[i10 >> 2] | 0;
     _memmove(i7 | 0, i7 + (i1 << 2) | 0, (HEAP32[i11 >> 2] | 0) - i1 << 2 | 0) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) - (i1 << 2 >> 2);
    }
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i14 >>> 0);
 }
 if ((HEAP32[i24 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i25);
  HEAP32[i21 >> 2] = 0;
 }
 if ((HEAP32[i22 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i23);
  HEAP32[i20 >> 2] = 0;
 }
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
  HEAP32[i19 >> 2] = 0;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i26 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i26 >> 2] = i3;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i2 = HEAP32[i26 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i29 >> 2] | 0;
  }
  i29 = HEAP32[i29 + 12 >> 2] | 0;
  HEAP32[i27 >> 2] = 1;
  HEAP32[i27 + 4 >> 2] = i29;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 }
 if (!i28) {
  STACKTOP = i30;
  return i4 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i28);
 STACKTOP = i30;
 return i4 | 0;
}

function _zipCloseFileInZipRaw(i26, i19, i2) {
 i26 = i26 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28;
 if (!i26) {
  i27 = -102;
  STACKTOP = i28;
  return i27 | 0;
 }
 i27 = i26 + 44 | 0;
 if (!(HEAP32[i27 >> 2] | 0)) {
  i27 = -102;
  STACKTOP = i28;
  return i27 | 0;
 }
 i18 = i26 + 48 | 0;
 HEAP32[i26 + 52 >> 2] = 0;
 i17 = i26 + 128 | 0;
 if ((HEAP32[i17 >> 2] | 0) == 8) if (!(HEAP32[i26 + 132 >> 2] | 0)) {
  i6 = i26 + 64 | 0;
  i7 = i26 + 16528 | 0;
  i5 = i26 + 108 | 0;
  i8 = i26 + 8 | 0;
  i9 = i26 + 28 | 0;
  i10 = i26 + 32 | 0;
  i11 = i26 + 136 | 0;
  i12 = i26 + 60 | 0;
  i13 = i26 + 16532 | 0;
  i14 = i26 + 16544 | 0;
  i4 = i26 + 16540 | 0;
  i15 = i26 + 16536 | 0;
  i16 = i26 + 68 | 0;
  do {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i1 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i7 >> 2] | 0) if (!i1) i1 = 0; else {
     i3 = 0;
     do {
      i22 = HEAP32[i4 >> 2] | 0;
      i23 = i22 & 65533;
      i23 = (Math_imul(i23 | 2, i23 ^ 3) | 0) >>> 8;
      i20 = HEAP32[i14 >> 2] | 0;
      i1 = i26 + 136 + i3 | 0;
      i21 = HEAP32[i13 >> 2] | 0;
      i21 = HEAP32[i20 + ((i21 & 255 ^ (HEAPU8[i1 >> 0] | 0)) << 2) >> 2] ^ i21 >>> 8;
      HEAP32[i13 >> 2] = i21;
      i21 = (Math_imul((HEAP32[i15 >> 2] | 0) + (i21 & 255) | 0, 134775813) | 0) + 1 | 0;
      HEAP32[i15 >> 2] = i21;
      HEAP32[i4 >> 2] = HEAP32[i20 + ((i21 >>> 24 ^ i22 & 255) << 2) >> 2] ^ i22 >>> 8;
      HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) ^ i23;
      i3 = i3 + 1 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
     } while (i3 >>> 0 < i1 >>> 0);
    }
    mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, i11 | 0, i1 | 0) | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i6 >> 2] = 16384;
    HEAP32[i12 >> 2] = i11;
   }
   i23 = HEAP32[i16 >> 2] | 0;
   i1 = _unity_z_deflate(i18, 4) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i16 >> 2] | 0) - i23 + (HEAP32[i5 >> 2] | 0);
  } while (!(i1 | 0));
 } else i1 = 0; else i1 = 0;
 i1 = (i1 | 0) == 1 ? 0 : i1;
 i8 = i26 + 108 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 | 0) == 0) {
  if (!(HEAP32[i26 + 16528 >> 2] | 0)) i1 = i3; else {
   i5 = i26 + 16532 | 0;
   i6 = i26 + 16544 | 0;
   i4 = i26 + 16540 | 0;
   i7 = i26 + 16536 | 0;
   i3 = 0;
   do {
    i22 = HEAP32[i4 >> 2] | 0;
    i23 = i22 & 65533;
    i23 = (Math_imul(i23 | 2, i23 ^ 3) | 0) >>> 8;
    i20 = HEAP32[i6 >> 2] | 0;
    i1 = i26 + 136 + i3 | 0;
    i21 = HEAP32[i5 >> 2] | 0;
    i21 = HEAP32[i20 + ((i21 & 255 ^ (HEAPU8[i1 >> 0] | 0)) << 2) >> 2] ^ i21 >>> 8;
    HEAP32[i5 >> 2] = i21;
    i21 = (Math_imul((HEAP32[i7 >> 2] | 0) + (i21 & 255) | 0, 134775813) | 0) + 1 | 0;
    HEAP32[i7 >> 2] = i21;
    HEAP32[i4 >> 2] = HEAP32[i20 + ((i21 >>> 24 ^ i22 & 255) << 2) >> 2] ^ i22 >>> 8;
    HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) ^ i23;
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
  i1 = mftCall_iiiii(HEAP32[i26 + 8 >> 2] | 0, HEAP32[i26 + 28 >> 2] | 0, HEAP32[i26 + 32 >> 2] | 0, i26 + 136 | 0, i1 | 0) | 0;
  i1 = (i1 | 0) != (HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = 0;
  i1 = i1 << 31 >> 31;
 }
 i3 = i26 + 132 | 0;
 if ((HEAP32[i17 >> 2] | 0) == 8) if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = _unity_z_deflateEnd(i18) | 0;
  HEAP32[i26 + 104 >> 2] = 0;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i3 = HEAP32[i26 + 56 >> 2] | 0;
  i2 = HEAP32[i26 + 16524 >> 2] | 0;
 } else i3 = i19;
 i20 = HEAP32[i26 + 68 >> 2] | 0;
 i23 = HEAP32[i26 + 16548 >> 2] | 0;
 i11 = i26 + 116 | 0;
 i17 = HEAP32[i11 >> 2] | 0;
 i12 = i2 & 255;
 HEAP8[i17 + 16 >> 0] = i12;
 i13 = i2 >>> 8 & 255;
 HEAP8[i17 + 17 >> 0] = i13;
 i14 = i2 >>> 16 & 255;
 HEAP8[i17 + 18 >> 0] = i14;
 i15 = i2 >>> 24 & 255;
 HEAP8[i17 + 19 >> 0] = i15;
 i20 = i23 + i20 | 0;
 i23 = HEAP32[i11 >> 2] | 0;
 i17 = i20 & 255;
 HEAP8[i23 + 20 >> 0] = i17;
 i18 = i20 >>> 8 & 255;
 HEAP8[i23 + 21 >> 0] = i18;
 i19 = i20 >>> 16 & 255;
 HEAP8[i23 + 22 >> 0] = i19;
 i20 = i20 >>> 24 & 255;
 HEAP8[i23 + 23 >> 0] = i20;
 if ((HEAP32[i26 + 92 >> 2] | 0) == 1) {
  i23 = HEAP32[i11 >> 2] | 0;
  HEAP8[i23 + 36 >> 0] = 1;
  HEAP8[i23 + 37 >> 0] = 0;
 }
 i10 = HEAP32[i11 >> 2] | 0;
 i21 = i3 & 255;
 HEAP8[i10 + 24 >> 0] = i21;
 i22 = i3 >>> 8 & 255;
 HEAP8[i10 + 25 >> 0] = i22;
 i23 = i3 >>> 16 & 255;
 HEAP8[i10 + 26 >> 0] = i23;
 i16 = i3 >>> 24 & 255;
 HEAP8[i10 + 27 >> 0] = i16;
 L39 : do if (!i1) {
  i3 = i26 + 36 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i26 + 120 >> 2] | 0;
  i10 = i26 + 40 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  do if (!i2) {
   i2 = _malloc(4096) | 0;
   if (!i2) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = -104;
    i24 = 39;
    break L39;
   } else {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 4080;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i3 >> 2] = i2;
    break;
   }
  } while (0);
  do if (i5) {
   i4 = i2;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   while (1) {
    if (!i3) {
     i2 = _malloc(4096) | 0;
     if (!i2) {
      i24 = 34;
      break;
     }
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 4080;
     HEAP32[i4 >> 2] = i2;
     HEAP32[i10 >> 2] = i2;
     i3 = 4080;
    } else i2 = i4;
    i9 = i2 + 4 | 0;
    i8 = i3 >>> 0 < i5 >>> 0 ? i3 : i5;
    i7 = i2 + 8 | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    i6 = i2 + 16 + i4 | 0;
    if (i8) {
     i3 = 0;
     do {
      HEAP8[i6 + i3 >> 0] = HEAP8[i1 + i3 >> 0] | 0;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i8 >>> 0);
     i4 = HEAP32[i7 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
    }
    HEAP32[i7 >> 2] = i4 + i8;
    i3 = i3 - i8 | 0;
    HEAP32[i9 >> 2] = i3;
    i5 = i5 - i8 | 0;
    if (!i5) {
     i24 = 40;
     break;
    } else {
     i1 = i1 + i8 | 0;
     i4 = i2;
    }
   }
   if ((i24 | 0) == 34) {
    HEAP32[i4 >> 2] = 0;
    i1 = -104;
    i24 = 39;
    break L39;
   } else if ((i24 | 0) == 40) {
    i1 = HEAP32[i11 >> 2] | 0;
    break;
   }
  } while (0);
  _free(i1);
  i5 = i26 + 28 | 0;
  i6 = i26 + 32 | 0;
  i7 = mftCall_iii(HEAP32[i26 + 12 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  i8 = i26 + 16 | 0;
  if (!(mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i26 + 112 >> 2] | 0) + 14 | 0, 0) | 0)) {
   i11 = HEAP32[i6 >> 2] | 0;
   HEAP8[i25 >> 0] = i12;
   i4 = i25 + 1 | 0;
   HEAP8[i4 >> 0] = i13;
   i3 = i25 + 2 | 0;
   HEAP8[i3 >> 0] = i14;
   i2 = i25 + 3 | 0;
   HEAP8[i2 >> 0] = i15;
   i1 = i26 + 8 | 0;
   if ((mftCall_iiiii(HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0, i11 | 0, i25 | 0, 4) | 0) == 4) {
    i15 = HEAP32[i6 >> 2] | 0;
    HEAP8[i25 >> 0] = i17;
    HEAP8[i4 >> 0] = i18;
    HEAP8[i3 >> 0] = i19;
    HEAP8[i2 >> 0] = i20;
    if ((mftCall_iiiii(HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0, i15 | 0, i25 | 0, 4) | 0) == 4) {
     i20 = HEAP32[i6 >> 2] | 0;
     HEAP8[i25 >> 0] = i21;
     HEAP8[i4 >> 0] = i22;
     HEAP8[i3 >> 0] = i23;
     HEAP8[i2 >> 0] = i16;
     i1 = ((mftCall_iiiii(HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0, i20 | 0, i25 | 0, 4) | 0) != 4) << 31 >> 31;
    } else i1 = -1;
   } else i1 = -1;
  } else i1 = -1;
  i25 = (mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7 | 0, 0) | 0) == 0;
  i1 = i25 ? i1 : -1;
 } else i24 = 39; while (0);
 if ((i24 | 0) == 39) _free(HEAP32[i11 >> 2] | 0);
 i26 = i26 + 16560 | 0;
 HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
 HEAP32[i27 >> 2] = 0;
 i27 = i1;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERSB_(i42, i1) {
 i42 = i42 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, f44 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i43 + 56 | 0;
 i37 = i43 + 112 | 0;
 i41 = i43;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i41 + 4 >> 2] = 0;
 HEAP32[i41 + 8 >> 2] = 0;
 HEAP32[i41 + 12 >> 2] = 0;
 HEAP32[i41 + 16 >> 2] = 0;
 HEAP32[i41 + 20 >> 2] = 0;
 i40 = i1;
 i39 = HEAP32[i40 >> 2] | 0;
 i40 = HEAP32[i40 + 4 >> 2] | 0;
 i5 = i42 + 4 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i33 = i42 + 12 | 0;
  i1 = i42 + 84 | 0;
  i34 = i42 + 8 | 0;
  i32 = i42 + 20 | 0;
  HEAP8[i34 >> 0] = 1;
  i34 = i33;
  HEAP32[i34 >> 2] = i39;
  i33 = i33 + 4 | 0;
  HEAP32[i33 >> 2] = i40;
  i33 = i41;
  i34 = i32 + 56 | 0;
  do {
   HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
   i32 = i32 + 4 | 0;
   i33 = i33 + 4 | 0;
  } while ((i32 | 0) < (i34 | 0));
  i42 = i1;
  i41 = i42;
  HEAP32[i41 >> 2] = 0;
  i42 = i42 + 4 | 0;
  HEAP32[i42 >> 2] = 0;
  STACKTOP = i43;
  return;
 }
 i2 = i37 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i37 + 8 | 0;
 i36 = i42 + 8 | 0;
 i8 = HEAP16[i36 >> 1] | 0;
 HEAP8[i3 >> 0] = i8;
 i4 = i37 + 9 | 0;
 HEAP8[i4 >> 0] = (i8 & 65535) >>> 8;
 i8 = i37 + 12 | 0;
 i25 = i42 + 12 | 0;
 i32 = i25;
 i38 = HEAP32[i32 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i9 + 4 >> 2] = i38;
 i9 = i37 + 20 | 0;
 i38 = i42 + 20 | 0;
 i32 = i9;
 i33 = i38;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 i10 = i37 + 76 | 0;
 i11 = i42 + 76 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 i12 = i37 + 80 | 0;
 i13 = i42 + 80 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 i14 = i37 + 84 | 0;
 i1 = i42 + 84 | 0;
 i32 = i1;
 i16 = HEAP32[i32 + 4 >> 2] | 0;
 i15 = i14;
 HEAP32[i15 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 i15 = i37 + 92 | 0;
 i16 = i42 + 92 | 0;
 i32 = i16;
 i18 = HEAP32[i32 + 4 >> 2] | 0;
 i17 = i15;
 HEAP32[i17 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i37 + 100 | 0;
 i18 = i42 + 100 | 0;
 i32 = i17;
 i33 = i18;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 i19 = i37 + 156 | 0;
 i20 = i42 + 156 | 0;
 HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
 i21 = i37 + 160 | 0;
 i22 = i42 + 160 | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 i23 = i37 + 164 | 0;
 i24 = i42 + 164 | 0;
 i28 = i24;
 i27 = HEAP32[i28 + 4 >> 2] | 0;
 i26 = i23;
 HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i26 + 4 >> 2] = i27;
 i26 = i37 + 172 | 0;
 HEAP32[i26 >> 2] = 0;
 i27 = i37 + 176 | 0;
 HEAP32[i27 >> 2] = 0;
 i28 = i37 + 180 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i37 + 196 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i29 = i37 + 188 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i37 + 184 | 0;
 HEAP32[i30 >> 2] = 0;
 i31 = i37 + 192 | 0;
 HEAP8[i31 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i37, i42, 0);
 i32 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i32;
 i2 = HEAP8[i36 >> 0] | 0;
 i32 = HEAP16[i3 >> 1] | 0;
 HEAP8[i36 >> 0] = i32;
 HEAP8[i3 >> 0] = i2;
 i2 = i42 + 9 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = (i32 & 65535) >>> 8;
 HEAP8[i4 >> 0] = i3;
 i3 = i25;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i32 = i35;
 i33 = i38;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i7 = i1;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i34 = i8;
 i33 = HEAP32[i34 + 4 >> 2] | 0;
 i32 = i25;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = i33;
 i32 = i38;
 i33 = i9;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 i34 = i14;
 i33 = HEAP32[i34 + 4 >> 2] | 0;
 i32 = i1;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = i33;
 i32 = i8;
 HEAP32[i32 >> 2] = i2;
 HEAP32[i32 + 4 >> 2] = i3;
 i32 = i9;
 i33 = i35;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 HEAP32[i10 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 i3 = i14;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i7;
 i3 = i16;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i32 = i35;
 i33 = i18;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 i4 = HEAP32[i20 >> 2] | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i7 = i24;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i34 = i15;
 i33 = HEAP32[i34 + 4 >> 2] | 0;
 i32 = i16;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = i33;
 i32 = i18;
 i33 = i17;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 i34 = i23;
 i33 = HEAP32[i34 + 4 >> 2] | 0;
 i32 = i24;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i32 + 4 >> 2] = i33;
 i32 = i15;
 HEAP32[i32 >> 2] = i2;
 HEAP32[i32 + 4 >> 2] = i3;
 i32 = i17;
 i33 = i35;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 HEAP32[i19 >> 2] = i4;
 HEAP32[i21 >> 2] = i5;
 i32 = i23;
 HEAP32[i32 >> 2] = i6;
 HEAP32[i32 + 4 >> 2] = i7;
 i32 = i42 + 172 | 0;
 i2 = HEAP32[i32 >> 2] | 0;
 HEAP32[i32 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i26 >> 2] = i2;
 i32 = i42 + 176 | 0;
 i34 = HEAP32[i32 >> 2] | 0;
 i33 = HEAP32[i27 >> 2] | 0;
 HEAP32[i32 >> 2] = i33;
 HEAP32[i27 >> 2] = i34;
 i27 = i42 + 180 | 0;
 i32 = HEAP32[i27 >> 2] | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i28 >> 2] = i32;
 f44 = Math_fround(i33 >>> 0);
 HEAP32[i42 + 188 >> 2] = ~~Math_fround(f44 * Math_fround(.5)) >>> 0;
 HEAP32[i42 + 184 >> 2] = ~~Math_fround(f44 * Math_fround(.200000003)) >>> 0;
 HEAP8[i42 + 192 >> 0] = 0;
 f44 = Math_fround(i34 >>> 0);
 HEAP32[i29 >> 2] = ~~Math_fround(f44 * Math_fround(.5)) >>> 0;
 HEAP32[i30 >> 2] = ~~Math_fround(f44 * Math_fround(.200000003)) >>> 0;
 HEAP8[i31 >> 0] = 0;
 if (i2 | 0) {
  i42 = HEAP32[i37 + 196 >> 2] | 0;
  HEAP32[i35 >> 2] = 65;
  HEAP32[i35 + 4 >> 2] = i42;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i35);
 }
 i33 = i25;
 i34 = i36;
 i32 = i38;
 HEAP8[i34 >> 0] = 1;
 i34 = i33;
 HEAP32[i34 >> 2] = i39;
 i33 = i33 + 4 | 0;
 HEAP32[i33 >> 2] = i40;
 i33 = i41;
 i34 = i32 + 56 | 0;
 do {
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  i32 = i32 + 4 | 0;
  i33 = i33 + 4 | 0;
 } while ((i32 | 0) < (i34 | 0));
 i42 = i1;
 i41 = i42;
 HEAP32[i41 >> 2] = 0;
 i42 = i42 + 4 | 0;
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i43;
 return;
}

function __ZN34ColorBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 614244 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614244 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614283 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614283 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614322 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614322 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614361 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614361 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614400 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614400 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614439 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614439 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 5;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614478 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614478 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 6;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614517 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614517 + 38 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 7;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614556 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614556 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614583 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614583 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx10PxsContext11shiftOriginERKNS_6PxVec3E(i20, i19) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 f1 = Math_fround(HEAPF32[i19 >> 2]);
 i17 = i19 + 4 | 0;
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i19 + 8 | 0;
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 i2 = HEAP32[i20 + 7636 >> 2] | 0;
 if (i2 & 2147483647 | 0) {
  i5 = HEAP32[i20 + 7640 >> 2] | 0;
  i6 = i20 + 7628 | 0;
  i2 = i2 & 2147483647;
  i3 = 0;
  do {
   if (HEAP32[i5 + (i3 << 2) >> 2] | 0) {
    i16 = HEAP32[i6 >> 2] | 0;
    i15 = i16 + (i3 * 28 | 0) + 16 | 0;
    HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f1);
    i15 = i16 + (i3 * 28 | 0) + 20 | 0;
    HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f4);
    i16 = i16 + (i3 * 28 | 0) + 24 | 0;
    HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f7);
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 L9 : do if (HEAP8[i20 + 7605 >> 0] | 0) {
  i15 = i20 + 1332 | 0;
  i16 = i20 + 1336 | 0;
  i8 = HEAP32[i16 >> 2] & 2147483647;
  if (i8 | 0) {
   i6 = HEAP32[i15 >> 2] | 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
    if (i3 | 0) break;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i8 >>> 0) break L9;
   }
   i5 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
   i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i2 << 5;
   i3 = i3 + -1 & i3;
   L16 : do if (!i3) do {
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i8 >>> 0) {
     i3 = 0;
     break L16;
    }
    i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   } while ((i3 | 0) == 0); while (0);
   if ((i5 | 0) != -1) {
    i12 = i20 + 708 | 0;
    i13 = i20 + 720 | 0;
    i14 = i20 + 696 | 0;
    do {
     i11 = i2 << 5;
     while (1) {
      i8 = HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 >>> (HEAP32[i12 >> 2] | 0) << 2) >> 2] | 0) + (((HEAP32[i14 >> 2] | 0) + -1 & i5) << 7) + 68 >> 2] | 0;
      if (i8 | 0) {
       i5 = i8 + 64 | 0;
       i10 = i8 + 16 | 0;
       f7 = Math_fround(HEAPF32[i19 >> 2]);
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       f7 = Math_fround(HEAPF32[i17 >> 2]);
       i10 = i8 + 20 | 0;
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       f7 = Math_fround(HEAPF32[i18 >> 2]);
       i10 = i8 + 24 | 0;
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       i10 = i8 + 44 | 0;
       f7 = Math_fround(HEAPF32[i19 >> 2]);
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       f7 = Math_fround(HEAPF32[i17 >> 2]);
       i10 = i8 + 48 | 0;
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       f7 = Math_fround(HEAPF32[i18 >> 2]);
       i10 = i8 + 52 | 0;
       HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
       i10 = HEAP16[i8 + 56 >> 1] | 0;
       i9 = i10 & 65535;
       i6 = (HEAP8[i8 + 58 >> 0] | 0) == 0;
       if (i10 << 16 >> 16) {
        i10 = i9 + -1 | 0;
        if (!(HEAP8[i8 + 59 >> 0] | 0)) if (i6) {
         i6 = 0;
         while (1) {
          i8 = i5 + 12 | 0;
          f7 = Math_fround(HEAPF32[i19 >> 2]);
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i17 >> 2]);
          i8 = i5 + 16 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i18 >> 2]);
          i8 = i5 + 20 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          i6 = i6 + 1 | 0;
          if ((i6 | 0) == (i9 | 0)) break; else i5 = i5 + 28 | 0;
         }
        } else {
         i6 = 0;
         while (1) {
          i8 = i5 + 12 | 0;
          f7 = Math_fround(HEAPF32[i19 >> 2]);
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i17 >> 2]);
          i8 = i5 + 16 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i18 >> 2]);
          i8 = i5 + 20 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          i6 = i6 + 1 | 0;
          if ((i6 | 0) == (i9 | 0)) break; else i5 = i5 + 36 | 0;
         }
        } else if (i6) {
         i6 = 0;
         while (1) {
          i5 = (i6 | 0) == 0 ? i5 + 12 | 0 : i5;
          f7 = Math_fround(HEAPF32[i19 >> 2]);
          HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i17 >> 2]);
          i8 = i5 + 4 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i18 >> 2]);
          i8 = i5 + 8 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          i6 = i6 + 1 | 0;
          if ((i6 | 0) == (i9 | 0)) break; else i5 = i5 + 16 | 0;
         }
        } else {
         i6 = 0;
         while (1) {
          i5 = (i6 | 0) == 0 ? i5 + 12 | 0 : i5;
          f7 = Math_fround(HEAPF32[i19 >> 2]);
          HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i17 >> 2]);
          i8 = i5 + 4 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          f7 = Math_fround(HEAPF32[i18 >> 2]);
          i8 = i5 + 8 | 0;
          HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
          i6 = i6 + 1 | 0;
          if ((i6 | 0) == (i9 | 0)) break; else i5 = i5 + 24 | 0;
         }
        }
       }
      }
      if (!i3) break L9;
      i5 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
      i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i11;
      i3 = i3 + -1 & i3;
      if (!i3) break;
      if ((i5 | 0) == -1) break L9;
     }
     i6 = HEAP32[i16 >> 2] & 2147483647;
     do {
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i6 >>> 0) {
       i3 = 0;
       break;
      }
      i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     } while ((i3 | 0) == 0);
    } while ((i5 | 0) != -1);
   }
  }
 } while (0);
 i3 = i20 + 6136 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f4 != Math_fround(-8507058669999999534545717.0e13);
 i2 = i20 + 6140 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(i16 | f1 != Math_fround(-8507058669999999534545717.0e13))) if (Math_fround(HEAPF32[i20 + 6144 >> 2]) != Math_fround(-8507058669999999534545717.0e13)) f1 = Math_fround(-8507058669999999534545717.0e13); else if (Math_fround(HEAPF32[i20 + 6148 >> 2]) != Math_fround(8507058669999999534545717.0e13)) f1 = Math_fround(-8507058669999999534545717.0e13); else if (Math_fround(HEAPF32[i20 + 6152 >> 2]) != Math_fround(8507058669999999534545717.0e13)) f1 = Math_fround(-8507058669999999534545717.0e13); else if (Math_fround(HEAPF32[i20 + 6156 >> 2]) != Math_fround(8507058669999999534545717.0e13)) f1 = Math_fround(-8507058669999999534545717.0e13); else return;
 HEAPF32[i3 >> 2] = Math_fround(f4 - Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f1 - Math_fround(HEAPF32[i17 >> 2]));
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 i16 = i20 + 6144 | 0;
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f7);
 f7 = Math_fround(HEAPF32[i19 >> 2]);
 i19 = i20 + 6148 | 0;
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f7);
 f7 = Math_fround(HEAPF32[i17 >> 2]);
 i19 = i20 + 6152 | 0;
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f7);
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 i20 = i20 + 6156 | 0;
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f7);
 return;
}

function __ZN23ForwardShaderRenderLoop14CollectShadowsER17ShadowCachingDataRK15SharedLightDatabbR17ShaderPassContext(i17, i3, i18, i1, i2, i19) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f20 = f0, f21 = f0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16 + 136 | 0;
 i11 = i16 + 88 | 0;
 i12 = i16 + 44 | 0;
 i13 = i16;
 i14 = i17 + 8 | 0;
 if ((HEAP16[gb + 1114836 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114836 | 0, i6);
  i15 = gb + 1114836 | 0;
 } else i15 = 0;
 i7 = HEAP32[gb + 1114836 >> 2] | 0;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 648 >> 2] | 0, i8 | 0, i7 | 0);
 __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i19, 0);
 i7 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[i7 + 4212 >> 2] | 0;
 i9 = (i8 | 0) != 0;
 L4 : do if (i9) {
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 856 >> 2] | 0, i7 | 0, 0);
  switch (i8 | 0) {
  case 2:
   {
    i10 = i19 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -134217729;
    break L4;
   }
  case 1:
   {
    i10 = i19 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -33554433;
    break L4;
   }
  default:
   break L4;
  }
 } while (0);
 i10 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 4 | 0;
 __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataP7TextureRK10Matrix4x4fR17ShaderPassContext(i17, i18, i10, i2, i19);
 i4 = HEAP32[i3 + 344 >> 2] | 0;
 f21 = Math_fround(HEAP32[i10 + 80 >> 2] | 0);
 f20 = Math_fround(HEAP32[i10 + 84 >> 2] | 0);
 HEAPF32[i6 >> 2] = f21;
 HEAPF32[i6 + 4 >> 2] = f20;
 __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext(i2, i4, i3 + 260 | 0, i3 + 280 | 0, i6, i19);
 i4 = HEAP32[i18 + 92 >> 2] | 0;
 do if (!i4) {
  HEAP32[i12 >> 2] = 0;
  i1 = i12;
  i5 = 18;
 } else {
  HEAP32[i11 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i11);
    i2 = HEAP32[i6 >> 2] | 0;
    i22 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 14; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 17; else {
     HEAP32[i12 >> 2] = 0;
     i2 = i12;
    }
   }
  }
  if ((i5 | 0) == 14) i5 = 17;
  if ((i5 | 0) == 17) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   HEAP32[i12 >> 2] = 0;
   if (!i1) {
    i1 = i12;
    i5 = 18;
    break;
   } else i2 = i12;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i12 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i12 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i22 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f20 = Math_fround(i22 | 0);
  f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i12 + 12 >> 2] = i3;
  HEAP32[i12 + 16 >> 2] = i2;
  HEAPF32[i12 + 20 >> 2] = f20;
  HEAPF32[i12 + 24 >> 2] = f21;
  i2 = i12 + 28 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i6, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 } while (0);
 if ((i5 | 0) == 18) HEAP32[i1 >> 2] = 0;
 i1 = __ZNK14RenderSettings20GetDefaultSpotCookieEv(__Z17GetRenderSettingsv() | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 if (!i1) HEAP32[i11 >> 2] = 0; else {
  HEAP32[i11 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i11 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i11 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i22 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f20 = Math_fround(i22 | 0);
  f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i11 + 12 >> 2] = i3;
  HEAP32[i11 + 16 >> 2] = i2;
  HEAPF32[i11 + 20 >> 2] = f20;
  HEAPF32[i11 + 24 >> 2] = f21;
  i2 = i11 + 28 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i6, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 }
 i1 = __ZN10builtintex21GetAttenuationTextureEv() | 0;
 HEAP32[i13 >> 2] = 0;
 if (!i1) HEAP32[i13 >> 2] = 0; else {
  HEAP32[i13 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i13 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i13 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i22 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f20 = Math_fround(i22 | 0);
  f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i13 + 12 >> 2] = i3;
  HEAP32[i13 + 16 >> 2] = i2;
  HEAPF32[i13 + 20 >> 2] = f20;
  HEAPF32[i13 + 24 >> 2] = f21;
  i2 = i13 + 28 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i6, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 }
 __Z26SetupLightShaderPropertiesRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_(i18, Math_fround(1.0), i19, i12, i11, i13);
 L46 : do if (i9) {
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 856 >> 2] | 0, i7 | 0, i8 | 0);
  switch (i8 | 0) {
  case 2:
   {
    i22 = i19 + 4 | 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 134217728;
    break L46;
   }
  case 1:
   {
    i22 = i19 + 4 | 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 33554432;
    break L46;
   }
  default:
   break L46;
  }
 } while (0);
 i1 = __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i18, i10, HEAP32[i18 + 96 >> 2] | 0, HEAP32[i17 + 368 >> 2] | 0, i19) | 0;
 i22 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 652 >> 2] | 0, i22 | 0);
 if (!i15) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i16;
 return i1 | 0;
}

function _FixedJointSolverPrep(i6, i4, i1, i7, i5, i2, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i1 + 72 | 0;
 i10 = i1 + 44 | 0;
 i9 = i1 + 32 | 0;
 i8 = i1;
 i21 = i5 + 56 | 0;
 HEAP32[i7 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 f13 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f24 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(HEAPF32[i2 >> 2]);
 f23 = Math_fround(f13 * f25);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f26 * f14));
 f28 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f15 * f28));
 f27 = Math_fround(Math_fround(f25 * f23) + Math_fround(Math_fround(f13 * f24) + Math_fround(f22 * Math_fround(Math_fround(f15 * f14) - Math_fround(f26 * f28)))));
 f29 = Math_fround(Math_fround(f14 * f23) + Math_fround(Math_fround(f26 * f24) + Math_fround(f22 * Math_fround(Math_fround(f13 * f28) - Math_fround(f15 * f25)))));
 f23 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(f22 * Math_fround(Math_fround(f26 * f25) - Math_fround(f13 * f14)))) + Math_fround(f28 * f23));
 i21 = i2 + 16 | 0;
 f27 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f27);
 i20 = i2 + 20 | 0;
 f29 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f29);
 i19 = i2 + 24 | 0;
 f23 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f23);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f26 = Math_fround(f22 * f13);
 f24 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f25 * f24));
 f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f14 * f15));
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f17 = Math_fround(Math_fround(Math_fround(f28 * f13) + Math_fround(Math_fround(f14 * f24) + Math_fround(f22 * f12))) - Math_fround(f25 * f15));
 f16 = Math_fround(Math_fround(Math_fround(f25 * f12) + Math_fround(Math_fround(f28 * f24) + Math_fround(f22 * f15))) - Math_fround(f14 * f13));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f24) - Math_fround(f25 * f13)) - Math_fround(f14 * f12)) - Math_fround(f28 * f15));
 HEAPF32[i11 >> 2] = Math_fround(f26 - Math_fround(f28 * f12));
 i31 = i11 + 4 | 0;
 HEAPF32[i31 >> 2] = f17;
 i30 = i11 + 8 | 0;
 HEAPF32[i30 >> 2] = f16;
 i32 = i11 + 12 | 0;
 HEAPF32[i32 >> 2] = f15;
 i35 = i11 + 16 | 0;
 HEAPF32[i35 >> 2] = f27;
 i34 = i11 + 20 | 0;
 HEAPF32[i34 >> 2] = f29;
 i33 = i11 + 24 | 0;
 HEAPF32[i33 >> 2] = f23;
 f23 = Math_fround(Math_fround(HEAPF32[i5 + 44 >> 2]) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(HEAPF32[i5 + 48 >> 2]) * Math_fround(2.0));
 f27 = Math_fround(Math_fround(HEAPF32[i5 + 52 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f16 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f23 * f17);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f29 * f28));
 f26 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f27 * f26));
 f14 = Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f23 * f16) + Math_fround(f15 * Math_fround(Math_fround(f27 * f28) - Math_fround(f29 * f26)))));
 f13 = Math_fround(Math_fround(f28 * f12) + Math_fround(Math_fround(f29 * f16) + Math_fround(f15 * Math_fround(Math_fround(f23 * f26) - Math_fround(f27 * f17)))));
 f12 = Math_fround(Math_fround(Math_fround(f27 * f16) + Math_fround(f15 * Math_fround(Math_fround(f29 * f17) - Math_fround(f23 * f28)))) + Math_fround(f26 * f12));
 i18 = i3 + 16 | 0;
 f14 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f14);
 i2 = i3 + 20 | 0;
 f13 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f13);
 i7 = i3 + 24 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f12);
 f23 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f29 = Math_fround(f15 * f23);
 f16 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f29 = Math_fround(f29 + Math_fround(f17 * f16));
 f27 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f29 = Math_fround(f29 + Math_fround(f28 * f27));
 f25 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f24 = Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(Math_fround(f28 * f16) + Math_fround(f15 * f25))) - Math_fround(f17 * f27));
 f22 = Math_fround(Math_fround(Math_fround(f17 * f25) + Math_fround(Math_fround(f26 * f16) + Math_fround(f15 * f27))) - Math_fround(f28 * f23));
 f27 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f23)) - Math_fround(f28 * f25)) - Math_fround(f26 * f27));
 HEAPF32[i10 >> 2] = Math_fround(f29 - Math_fround(f26 * f25));
 HEAPF32[i10 + 4 >> 2] = f24;
 HEAPF32[i10 + 8 >> 2] = f22;
 HEAPF32[i10 + 12 >> 2] = f27;
 HEAPF32[i10 + 16 >> 2] = f14;
 HEAPF32[i10 + 20 >> 2] = f13;
 HEAPF32[i10 + 24 >> 2] = f12;
 f27 = Math_fround(f14 - Math_fround(HEAPF32[i35 >> 2]));
 f22 = Math_fround(f13 - Math_fround(HEAPF32[i34 >> 2]));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f22 = Math_fround(f22 * Math_fround(2.0));
 f24 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i33 >> 2])) * Math_fround(2.0));
 f25 = Math_fround(HEAPF32[i32 >> 2]);
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f29 = Math_fround(HEAPF32[i11 >> 2]);
 f28 = Math_fround(f27 * f29);
 f23 = Math_fround(HEAPF32[i31 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f22 * f23));
 f17 = Math_fround(HEAPF32[i30 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f24 * f17));
 f16 = Math_fround(Math_fround(f23 * f28) + Math_fround(Math_fround(f22 * f26) - Math_fround(f25 * Math_fround(Math_fround(f27 * f17) - Math_fround(f24 * f29)))));
 f15 = Math_fround(Math_fround(Math_fround(f24 * f26) - Math_fround(f25 * Math_fround(Math_fround(f22 * f29) - Math_fround(f27 * f23)))) + Math_fround(f17 * f28));
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f17)))));
 HEAPF32[i9 + 4 >> 2] = f16;
 HEAPF32[i9 + 8 >> 2] = f15;
 f15 = Math_fround(f14 - Math_fround(HEAPF32[i21 >> 2]));
 f16 = Math_fround(f13 - Math_fround(HEAPF32[i20 >> 2]));
 f17 = Math_fround(f12 - Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i4 >> 2] = f15;
 HEAPF32[i4 + 4 >> 2] = f16;
 HEAPF32[i4 + 8 >> 2] = f17;
 f17 = Math_fround(f14 - Math_fround(HEAPF32[i21 >> 2]));
 f16 = Math_fround(f13 - Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(f12 - Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i18 >> 2]));
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i7 >> 2]));
 HEAP32[i8 >> 2] = i6;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 HEAPF32[i8 + 8 >> 2] = f17;
 HEAPF32[i8 + 12 >> 2] = f16;
 HEAPF32[i8 + 16 >> 2] = f15;
 HEAPF32[i8 + 20 >> 2] = f14;
 HEAPF32[i8 + 24 >> 2] = f13;
 HEAPF32[i8 + 28 >> 2] = f12;
 __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj(i8, i11, i10, i9, 7, 7);
 STACKTOP = i1;
 return ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 80 | 0 | 0;
}

function __Z14CopySerializedRK6ObjectRS_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i24 + 8 | 0;
 i2 = i24;
 i15 = i24 + 136 | 0;
 i17 = i24 + 76 | 0;
 i12 = i24 + 16 | 0;
 i21 = gb + 64016 | 0;
 i14 = HEAP32[i21 + 4 >> 2] | 0;
 i13 = i2;
 HEAP32[i13 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i21 = i1;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i23 = i14;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = i22;
 L1 : do if ((HEAP32[i4 + 8 >> 2] ^ HEAP32[i3 + 8 >> 2]) >>> 0 < 2097152) {
  do if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0) | 0) {
   i25 = i17 + 12 | 0;
   HEAP32[i25 >> 2] = 1;
   i16 = i17 + 16 | 0;
   HEAP32[i16 >> 2] = 1;
   i18 = i17 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63720 | 0);
   i19 = i1;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i21 = i18;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   HEAP32[i17 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
   i21 = gb + 63720 | 0;
   i20 = HEAP32[i21 + 4 >> 2] | 0;
   i19 = i2;
   HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i19 + 4 >> 2] = i20;
   i19 = i17 + 20 | 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i17 + 32 >> 2] = 0;
   i20 = i17 + 36 | 0;
   HEAP32[i20 >> 2] = 0;
   i21 = i17 + 24 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
   i22 = i1;
   i23 = HEAP32[i22 + 4 >> 2] | 0;
   i7 = i21;
   HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i7 + 4 >> 2] = i23;
   i7 = gb + 63720 | 0;
   i23 = HEAP32[i7 + 4 >> 2] | 0;
   i22 = i2;
   HEAP32[i22 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i22 + 4 >> 2] = i23;
   HEAP32[i17 + 40 >> 2] = 0;
   HEAP32[i17 + 52 >> 2] = 0;
   i22 = i17 + 56 | 0;
   HEAP32[i22 >> 2] = 0;
   i23 = i17 + 44 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
   i7 = i1;
   i6 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = i23;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = i6;
   i25 = (HEAP32[i25 >> 2] | 0) + -1 | 0;
   i5 = HEAP32[i17 >> 2] | 0;
   HEAP8[i5 + (i25 * 24 | 0) + 2 >> 0] = 0;
   HEAP32[i5 + (i25 * 24 | 0) + 8 >> 2] = 0;
   HEAP32[i5 + (i25 * 24 | 0) + 4 >> 2] = 0;
   HEAP32[i5 + (i25 * 24 | 0) + 16 >> 2] = -1;
   HEAP8[i5 + (i25 * 24 | 0) + 3 >> 0] = 0;
   HEAP16[i5 + (i25 * 24 | 0) >> 1] = 1;
   HEAP32[i5 + (i25 * 24 | 0) + 20 >> 2] = 0;
   HEAP32[i5 + (i25 * 24 | 0) + 12 >> 2] = -1;
   i25 = i12 + 12 | 0;
   HEAP32[i25 >> 2] = 1;
   i5 = i12 + 16 | 0;
   HEAP32[i5 >> 2] = 1;
   i6 = i12 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63720 | 0);
   i7 = i1;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i6;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i12 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
   i9 = gb + 63720 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i2;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i7 = i12 + 20 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i12 + 32 >> 2] = 0;
   i8 = i12 + 36 | 0;
   HEAP32[i8 >> 2] = 0;
   i9 = i12 + 24 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i28 = i9;
   HEAP32[i28 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i28 + 4 >> 2] = i11;
   i28 = gb + 63720 | 0;
   i11 = HEAP32[i28 + 4 >> 2] | 0;
   i10 = i2;
   HEAP32[i10 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   HEAP32[i12 + 40 >> 2] = 0;
   HEAP32[i12 + 52 >> 2] = 0;
   i10 = i12 + 56 | 0;
   HEAP32[i10 >> 2] = 0;
   i11 = i12 + 44 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
   i28 = i1;
   i27 = HEAP32[i28 + 4 >> 2] | 0;
   i26 = i11;
   HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i26 + 4 >> 2] = i27;
   i25 = (HEAP32[i25 >> 2] | 0) + -1 | 0;
   i26 = HEAP32[i12 >> 2] | 0;
   HEAP8[i26 + (i25 * 24 | 0) + 2 >> 0] = 0;
   HEAP32[i26 + (i25 * 24 | 0) + 8 >> 2] = 0;
   HEAP32[i26 + (i25 * 24 | 0) + 4 >> 2] = 0;
   HEAP32[i26 + (i25 * 24 | 0) + 16 >> 2] = -1;
   HEAP8[i26 + (i25 * 24 | 0) + 3 >> 0] = 0;
   HEAP16[i26 + (i25 * 24 | 0) >> 1] = 1;
   HEAP32[i26 + (i25 * 24 | 0) + 20 >> 2] = 0;
   HEAP32[i26 + (i25 * 24 | 0) + 12 >> 2] = -1;
   __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i3, i17, 16384);
   __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i4, i12, 16384);
   HEAP32[i1 >> 2] = i17;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i2 + 4 >> 2] = 0;
   if (__Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_(i1, i2) | 0) {
    i1 = i12 + 40 | 0;
    if ((HEAP32[i10 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i11);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP32[i8 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9);
     HEAP32[i7 >> 2] = 0;
    }
    if ((HEAP32[i5 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i6);
     HEAP32[i12 >> 2] = 0;
    }
    i1 = i17 + 40 | 0;
    if ((HEAP32[i22 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i23);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP32[i20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
     HEAP32[i19 >> 2] = 0;
    }
    if ((HEAP32[i16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i18);
     HEAP32[i17 >> 2] = 0;
    }
    break;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468014 | 0, 0, gb + 467886 | 0, 277, 1, 0, 0, 0);
    i1 = i12 + 40 | 0;
    if ((HEAP32[i10 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i11);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP32[i8 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9);
     HEAP32[i7 >> 2] = 0;
    }
    if ((HEAP32[i5 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i6);
     HEAP32[i12 >> 2] = 0;
    }
    i1 = i17 + 40 | 0;
    if ((HEAP32[i22 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i23);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP32[i20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
     HEAP32[i19 >> 2] = 0;
    }
    if ((HEAP32[i16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i18);
     HEAP32[i17 >> 2] = 0;
    }
    break L1;
   }
  } while (0);
  __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags(i3, i15, 16384);
  __Z20ReadObjectFromVectorILb0EEvR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags(i4, i15, 16384);
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 0);
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468014 | 0, 0, gb + 467886 | 0, 263, 1, 0, 0, 0); while (0);
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function ___dns_doqueries(i12, i1, i26, i27) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i31 + 144 | 0;
 i6 = i31 + 600 | 0;
 i13 = i31 + 536 | 0;
 i28 = i31 + 116 | 0;
 i29 = i31 + 32 | 0;
 i30 = i31 + 256 | 0;
 i4 = i31 + 24 | 0;
 i23 = i31 + 16 | 0;
 i15 = i31 + 8 | 0;
 i14 = i31 + 4 | 0;
 i24 = i31;
 i25 = _time(0) | 0;
 HEAP32[i28 >> 2] = HEAP32[gb + 1469740 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[gb + 1469740 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[gb + 1469740 + 8 >> 2];
 HEAP32[i28 + 12 >> 2] = HEAP32[gb + 1469740 + 12 >> 2];
 HEAP32[i28 + 16 >> 2] = HEAP32[gb + 1469740 + 16 >> 2];
 HEAP32[i28 + 20 >> 2] = HEAP32[gb + 1469740 + 20 >> 2];
 HEAP32[i28 + 24 >> 2] = HEAP32[gb + 1469740 + 24 >> 2];
 i7 = i29;
 i8 = i7 + 84 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 _memset(i30 | 0, 0, 280) | 0;
 _pthread_setcancelstate(1, i15 | 0) | 0;
 L1 : do if (((_strlen(i1) | 0) + -1 | 0) >>> 0 > 253) i1 = -2; else {
  HEAP8[i30 + 5 >> 0] = 1;
  HEAP8[i30 + 2 >> 0] = 1;
  i22 = i30 + 13 | 0;
  _strcpy(i22, i1) | 0;
  if (!(HEAP8[i22 >> 0] | 0)) i1 = 13; else {
   i1 = 13;
   do {
    i2 = i1;
    L6 : while (1) {
     switch (HEAP8[i30 + i2 >> 0] | 0) {
     case 46:
     case 0:
      break L6;
     default:
      {}
     }
     i2 = i2 + 1 | 0;
    }
    i3 = i2 - i1 | 0;
    if ((i3 + -1 | 0) >>> 0 > 62) {
     i1 = -2;
     break L1;
    }
    HEAP8[i30 + (i1 + -1) >> 0] = i3;
    i1 = i2 + 1 | 0;
   } while ((HEAP8[i30 + i1 >> 0] | 0) != 0);
  }
  HEAP8[i30 + (i1 + 3) >> 0] = 1;
  i22 = i1 + 4 | 0;
  _clock_gettime(0, i4 | 0) | 0;
  i20 = HEAP32[i4 + 4 >> 2] | 0;
  i20 = (i20 >>> 16) + i20 | 0;
  i21 = i20 & 65535;
  i11 = ___fopen_rb_ca(gb + 1074009 | 0, i5, i6, 256) | 0;
  do if (!i11) i19 = 22; else {
   i7 = i13 + 10 | 0;
   i8 = i13 + 11 | 0;
   i2 = 2;
   i9 = 0;
   i10 = 16;
   L14 : while (1) {
    i6 = i29 + (i9 * 28 | 0) | 0;
    if (!(_fgets(i13, 64, i11) | 0)) {
     i19 = 21;
     break;
    }
    while (1) {
     if (!(_strncmp(i13, gb + 1074026 | 0, 10) | 0)) if (_isspace(HEAP8[i7 >> 0] | 0) | 0) {
      i5 = i8;
      while (1) {
       i4 = HEAP8[i5 >> 0] | 0;
       if (!(_isspace(i4 << 24 >> 24) | 0)) break; else i5 = i5 + 1 | 0;
      }
      L23 : do if (!(i4 << 24 >> 24)) i3 = i5; else {
       i3 = i5;
       do {
        if (_isspace(i4 << 24 >> 24) | 0) break L23;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0);
      } while (0);
      HEAP8[i3 >> 0] = 0;
      if ((___ipparse(i6, 0, i5) | 0) >= 0) break;
     }
     if (!(_fgets(i13, 64, i11) | 0)) {
      i19 = 21;
      break L14;
     }
    }
    HEAP16[i29 + (i9 * 28 | 0) + 2 >> 1] = _htons(53) | 0;
    i4 = i9 + 1 | 0;
    i19 = (HEAP16[i29 + (i9 * 28 | 0) >> 1] | 0) == 10;
    i3 = i19 ? 28 : i10;
    i2 = i19 ? 10 : i2;
    if ((i4 | 0) < 3) {
     i9 = i4;
     i10 = i3;
    } else {
     i19 = 20;
     break;
    }
   }
   if ((i19 | 0) == 20) {
    ___fclose_ca(i11) | 0;
    i9 = i4;
    i10 = i3;
    break;
   } else if ((i19 | 0) == 21) {
    ___fclose_ca(i11) | 0;
    if (!i9) {
     i19 = 22;
     break;
    } else break;
   }
  } while (0);
  if ((i19 | 0) == 22) {
   HEAP16[i29 >> 1] = 2;
   HEAP16[i29 + 2 >> 1] = _htons(53) | 0;
   HEAP32[i29 + 4 >> 2] = _htonl(2130706433) | 0;
   i2 = 2;
   i9 = 1;
   i10 = 16;
  }
  HEAP16[i28 >> 1] = i2;
  i6 = _socket(i2, 526338, 0) | 0;
  if ((i6 | 0) < 0) {
   if (!((i2 | 0) == 10 & (HEAP32[(___errno_location() | 0) >> 2] | 0) == 97)) {
    i1 = -11;
    break;
   }
   i2 = _socket(2, 526338, 0) | 0;
   if ((i2 | 0) < 0) {
    i1 = -11;
    break;
   } else i6 = i2;
  } else if ((i2 | 0) == 10) {
   HEAP32[i14 >> 2] = 0;
   _setsockopt(i6, 41, 26, i14, 4) | 0;
   if ((i9 | 0) > 0) {
    i2 = 0;
    do {
     i4 = i29 + (i2 * 28 | 0) | 0;
     if ((HEAP16[i4 >> 1] | 0) == 2) {
      i3 = i29 + (i2 * 28 | 0) + 4 | 0;
      HEAP32[i29 + (i2 * 28 | 0) + 20 >> 2] = HEAP32[i3 >> 2];
      i7 = i29 + (i2 * 28 | 0) + 8 | 0;
      i5 = gb + 1074248 | 0;
      i8 = i7 + 12 | 0;
      do {
       HEAP8[i7 >> 0] = HEAP8[i5 >> 0] | 0;
       i7 = i7 + 1 | 0;
       i5 = i5 + 1 | 0;
      } while ((i7 | 0) < (i8 | 0));
      HEAP16[i4 >> 1] = 10;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i29 + (i2 * 28 | 0) + 24 >> 2] = 0;
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i9 | 0));
   }
  }
  _pthread_cleanup_push(fb + 3994 | 0, i6 | 0);
  _pthread_setcancelstate(HEAP32[i15 >> 2] | 0, 0) | 0;
  L47 : do if ((_bind(i6, i28, i10) | 0) < 0) {
   i2 = 0;
   i1 = -11;
  } else {
   HEAP32[i23 >> 2] = i6;
   HEAP16[i23 + 4 >> 1] = 1;
   i17 = (i27 | 0) > 0;
   i18 = i30 + 1 | 0;
   i14 = i30 + (i1 + 1) | 0;
   i15 = (i9 | 0) > 0;
   i13 = (i9 | 0) < 1;
   i16 = (i9 | 0) == 1;
   i1 = -3;
   i11 = 0;
   i2 = 0;
   while (1) {
    do {
     if (((_time(0) | 0) - i25 | 0) >= 5) break L47;
     if (i17) {
      i4 = 0;
      do {
       i5 = i26 + (i4 << 2) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       if (!((i3 | 0) == 0 | i13)) {
        i8 = i4 + i21 | 0;
        i7 = i8 >>> 8 & 255;
        i8 = i8 & 255;
        HEAP8[i30 >> 0] = i7;
        HEAP8[i18 >> 0] = i8;
        HEAP8[i14 >> 0] = i3;
        _sendto(i6, i30, i22, 16384, i29, i10) | 0;
        if (!i16) {
         i3 = 1;
         do {
          i32 = HEAP32[i5 >> 2] | 0;
          HEAP8[i30 >> 0] = i7;
          HEAP8[i18 >> 0] = i8;
          HEAP8[i14 >> 0] = i32;
          _sendto(i6, i30, i22, 16384, i29 + (i3 * 28 | 0) | 0, i10) | 0;
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i9 | 0));
        }
       }
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i27 | 0));
     }
    } while ((_poll(i23, 1, 1e3) | 0) < 1);
    i3 = i11 + i2 | 0;
    L64 : do if ((i3 | 0) < (i27 | 0)) {
     i5 = i11;
     while (1) {
      i7 = i12 + 1 | 0;
      HEAP32[i24 >> 2] = i10;
      if ((_recvfrom(i6, i12, 512, 0, i28, i24) | 0) <= 1) {
       i4 = i12;
       break L64;
      }
      while (1) {
       L69 : do if (i15) {
        i4 = 0;
        do {
         if (!(_memcmp(i29 + (i4 * 28 | 0) | 0, i28, i10) | 0)) break L69;
         i4 = i4 + 1 | 0;
        } while ((i4 | 0) < (i9 | 0));
       } else i4 = 0; while (0);
       if ((i4 | 0) != (i9 | 0)) {
        i4 = (HEAPU8[i12 >> 0] << 8 | HEAPU8[i7 >> 0]) - i20 & 65535;
        if (i4 >>> 0 < i27 >>> 0) {
         i4 = i26 + (i4 << 2) | 0;
         if (HEAP32[i4 >> 2] | 0) break;
        }
       }
       HEAP32[i24 >> 2] = i10;
       if ((_recvfrom(i6, i12, 512, 0, i28, i24) | 0) <= 1) {
        i4 = i12;
        break L64;
       }
      }
      switch (HEAP8[i12 + 3 >> 0] & 15) {
      case 0:
       {
        i2 = i2 + 1 | 0;
        break;
       }
      case 3:
       {
        i1 = -2;
        i19 = 53;
        break;
       }
      default:
       {
        i1 = -4;
        i19 = 53;
       }
      }
      if ((i19 | 0) == 53) {
       i19 = 0;
       i5 = i5 + 1 | 0;
      }
      HEAP32[i4 >> 2] = 0;
      i4 = i12 + 512 | 0;
      i3 = i5 + i2 | 0;
      if ((i3 | 0) < (i27 | 0)) i12 = i4; else break L64;
     }
    } else {
     i5 = i11;
     i4 = i12;
    } while (0);
    if ((i3 | 0) == (i27 | 0)) break; else {
     i11 = i5;
     i12 = i4;
    }
   }
  } while (0);
  _pthread_cleanup_pop(1);
  i1 = (i2 | 0) == 0 ? i1 : i2;
 } while (0);
 STACKTOP = i31;
 return i1 | 0;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i13, i1, i11, i9, i10, i14) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 600 | 0;
 i4 = i12 + 16 | 0;
 i3 = i12;
 i6 = i12 + 24 | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 832239 | 0, i6 | 0) | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i8, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break;
   i5 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i2 | 0) | 0;
   if (!i5) {
    i14 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i3 >> 2] = gb + 833471;
    i11 = i3 + 8 | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 4 >> 2] = i2;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i14, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i3);
    break;
   }
   do if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 832272 | 0, i6 | 0) | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
     i3 = _strtoul(i1, i8, 10) | 0;
     if (!i3) break;
     if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 832282 | 0, i6 | 0) | 0) {
      i1 = HEAP32[i6 >> 2] | 0;
      HEAP32[i8 >> 2] = i1;
      if (i1 | 0) if (HEAP8[i1 >> 0] | 0) _strtoul(i1, i8, 10) | 0;
     }
     i7 = __ZN5physx22PxVehicleWheelsSimData8allocateEj(i3) | 0;
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, gb + 833671 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i11, i7, i9, i14) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0);
     HEAPF32[i6 + 80 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + 84 >> 2] = Math_fround(500.0);
     HEAPF32[i6 + 88 >> 2] = Math_fround(600.0);
     HEAPF32[i6 + 92 >> 2] = Math_fround(.150000006);
     HEAPF32[i6 + 96 >> 2] = Math_fround(2.0);
     HEAPF32[i6 + 100 >> 2] = Math_fround(.349999994);
     HEAPF32[i6 >> 2] = Math_fround(0.0);
     HEAPF32[i6 + 4 >> 2] = Math_fround(.800000011);
     HEAPF32[i6 + 8 >> 2] = Math_fround(.330000013);
     HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + 16 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + 20 >> 2] = Math_fround(.800000011);
     HEAP32[i6 + 64 >> 2] = 3;
     HEAPF32[i6 + 104 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + 108 >> 2] = Math_fround(.00166666671);
     HEAPF32[i6 + 240 >> 2] = Math_fround(4.0);
     HEAP32[i6 + 244 >> 2] = 7;
     HEAPF32[i6 + 248 >> 2] = Math_fround(.5);
     HEAPF32[i6 + 112 >> 2] = Math_fround(-4.0);
     HEAPF32[i6 + 116 >> 2] = Math_fround(0.0);
     HEAPF32[i6 + 120 >> 2] = Math_fround(4.0);
     HEAPF32[i6 + 124 >> 2] = Math_fround(2.0);
     HEAPF32[i6 + 128 >> 2] = Math_fround(1.5);
     HEAPF32[i6 + 132 >> 2] = Math_fround(1.10000002);
     HEAPF32[i6 + 136 >> 2] = Math_fround(1.0);
     i1 = i6 + 140 | 0;
     i2 = i1 + 100 | 0;
     do {
      HEAP32[i1 >> 2] = 0;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) < (i2 | 0));
     HEAPF32[i6 + 256 >> 2] = Math_fround(10.0);
     HEAP32[i6 + 260 >> 2] = 1;
     HEAP32[i6 + 264 >> 2] = 5;
     i1 = 0;
     do {
      HEAPF32[i6 + 272 + (i1 << 2) >> 2] = Math_fround(.649999976);
      HEAPF32[i6 + 400 + (i1 << 2) >> 2] = Math_fround(.5);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 32);
     HEAPF32[i6 + 276 >> 2] = Math_fround(.150000006);
     HEAPF32[i6 + 400 >> 2] = Math_fround(2.0);
     HEAPF32[i6 + 528 >> 2] = Math_fround(.449999988);
     HEAPF32[i6 + 532 >> 2] = Math_fround(.5);
     HEAPF32[i6 + 536 >> 2] = Math_fround(.5);
     HEAPF32[i6 + 540 >> 2] = Math_fround(1.29999995);
     HEAPF32[i6 + 544 >> 2] = Math_fround(1.29999995);
     HEAPF32[i6 + 548 >> 2] = Math_fround(1.29999995);
     HEAP32[i6 + 552 >> 2] = 0;
     HEAPF32[i6 + 560 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + 564 >> 2] = Math_fround(0.0);
     HEAPF32[i6 + 568 >> 2] = Math_fround(0.0);
     HEAPF32[i6 + 572 >> 2] = Math_fround(0.0);
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, gb + 834565 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i11, i6, i9, i14) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0);
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0);
     if (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, gb + 833686 | 0) | 0) {
      HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
      __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i11, i6, i9, i14) | 0;
     }
     mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0);
     i1 = HEAP32[i10 >> 2] | 0;
     i4 = (HEAP16[i5 + 4 >> 1] | 0) == 5 ? i5 : 0;
     i6 = __ZN5physx16PxVehicleNoDrive8allocateEj(i3) | 0;
     __ZN5physx16PxVehicleNoDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE(i6, i1, (HEAP16[i4 + 4 >> 1] | 0) == 5 ? i4 : 0, i7);
     HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleNoDriveEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i8, i11, i6, i9, i14) | 0;
     i4 = HEAP32[i6 + 72 >> 2] | 0;
     i5 = i7 + 36 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) {
      i3 = 0;
      do {
       i2 = HEAP32[(HEAP32[i4 + (i3 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
       if (i2) {
        mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i2 | 0, 0, 0);
        i1 = HEAP32[i5 >> 2] | 0;
       }
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     __ZN5physx22PxVehicleWheelsSimData4freeEv(i7);
     HEAP32[i13 >> 2] = gb + 833702;
     HEAP32[i13 + 4 >> 2] = i6;
     i14 = i13 + 8 | 0;
     HEAP32[i14 >> 2] = i6;
     HEAP32[i14 + 4 >> 2] = 0;
     STACKTOP = i12;
     return;
    }
   } while (0);
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 833484 | 0, 88, gb + 833575 | 0, i4);
   HEAP32[i13 >> 2] = gb + 1576256;
   HEAP32[i13 + 4 >> 2] = 0;
   i14 = i13 + 8 | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   STACKTOP = i12;
   return;
  }
 } while (0);
 HEAP32[i13 >> 2] = gb + 1576256;
 HEAP32[i13 + 4 >> 2] = 0;
 i14 = i13 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj(i24, i22, i23, i15) {
 i24 = i24 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i25 + 48 | 0;
 i11 = i25 + 32 | 0;
 i17 = i25 + 16 | 0;
 i18 = i25;
 i19 = i24 + 372 | 0;
 i3 = i24 + 376 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i20 = i22 + 4 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i14 = i2 - i1 >> 4;
 i16 = i23 - i15 + i13 + i14 | 0;
 if (!(i16 | i13)) {
  STACKTOP = i25;
  return;
 }
 if (!i13) {
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i19, i14);
  i2 = HEAP32[i19 >> 2] | 0;
  i23 = HEAP32[i3 >> 2] | 0;
  i3 = i2 + (i23 << 4) | 0;
  if ((i23 | 0) > 0) while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i2 = i2 + 16 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 16 | 0;
  }
 } else {
  i8 = i16 >>> 0 > i13 >>> 0 ? i16 : i13;
  i4 = HEAP32[i24 + 380 >> 2] & 2147483647;
  i21 = i24 + 384 | 0;
  i9 = i24 + 392 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i7 = i3 & 2147483647;
  if (i8 >>> 0 > (i4 >>> 0 < i7 >>> 0 ? i4 : i7) >>> 0) {
   if (i4 >>> 0 < i16 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i19, i16);
    i3 = HEAP32[i9 >> 2] | 0;
   }
   if ((i3 & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i21, i8);
  }
  i6 = i24 + 388 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  L16 : do if (i3 >>> 0 < i13 >>> 0) {
   i7 = i3;
   while (1) {
    i4 = HEAP32[i19 >> 2] | 0;
    i5 = i4 + (i3 << 4) | 0;
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
     i26 = HEAP32[i21 >> 2] | 0;
     HEAP32[i26 + (i7 << 4) >> 2] = HEAP32[i5 >> 2];
     HEAP32[i26 + (i7 << 4) + 4 >> 2] = HEAP32[i4 + (i3 << 4) + 4 >> 2];
     HEAP32[i26 + (i7 << 4) + 8 >> 2] = HEAP32[i4 + (i3 << 4) + 8 >> 2];
     HEAP32[i26 + (i7 << 4) + 12 >> 2] = HEAP32[i4 + (i3 << 4) + 12 >> 2];
     HEAP32[i6 >> 2] = i7 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i21, i5) | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i13 | 0)) break L16;
    i7 = HEAP32[i6 >> 2] | 0;
   }
  } while (0);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i19, i8, i10);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i21, i8, i11);
  i10 = i16 - i13 | 0;
  if ((i16 | 0) != (i13 | 0)) {
   i8 = HEAP32[i19 >> 2] | 0;
   i6 = i10 + i15 | 0;
   i7 = i6 >>> 0 > i15 >>> 0;
   i5 = i13 >>> 0 > i15 >>> 0;
   if (i7) if (i5) {
    i2 = i13;
    i3 = i16;
    do {
     i3 = i3 + -1 | 0;
     i2 = i2 + -1 | 0;
     HEAP32[i8 + (i3 << 4) >> 2] = HEAP32[i8 + (i2 << 4) >> 2];
     HEAP32[i8 + (i3 << 4) + 4 >> 2] = HEAP32[i8 + (i2 << 4) + 4 >> 2];
     HEAP32[i8 + (i3 << 4) + 8 >> 2] = HEAP32[i8 + (i2 << 4) + 8 >> 2];
     HEAP32[i8 + (i3 << 4) + 12 >> 2] = HEAP32[i8 + (i2 << 4) + 12 >> 2];
    } while (i2 >>> 0 > i15 >>> 0);
    i12 = 23;
   } else i12 = 29; else if (i5) {
    i2 = i15;
    i3 = i6;
    while (1) {
     HEAP32[i8 + (i3 << 4) >> 2] = HEAP32[i8 + (i2 << 4) >> 2];
     HEAP32[i8 + (i3 << 4) + 4 >> 2] = HEAP32[i8 + (i2 << 4) + 4 >> 2];
     HEAP32[i8 + (i3 << 4) + 8 >> 2] = HEAP32[i8 + (i2 << 4) + 8 >> 2];
     HEAP32[i8 + (i3 << 4) + 12 >> 2] = HEAP32[i8 + (i2 << 4) + 12 >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i13 | 0)) {
      i12 = 23;
      break;
     } else i3 = i3 + 1 | 0;
    }
   }
   do if ((i12 | 0) == 23) {
    i4 = HEAP32[i21 >> 2] | 0;
    if (i7) {
     if (i5) {
      i2 = i13;
      i3 = i16;
     } else {
      i12 = 29;
      break;
     }
     do {
      i3 = i3 + -1 | 0;
      i2 = i2 + -1 | 0;
      HEAP32[i4 + (i3 << 4) >> 2] = HEAP32[i4 + (i2 << 4) >> 2];
      HEAP32[i4 + (i3 << 4) + 4 >> 2] = HEAP32[i4 + (i2 << 4) + 4 >> 2];
      HEAP32[i4 + (i3 << 4) + 8 >> 2] = HEAP32[i4 + (i2 << 4) + 8 >> 2];
      HEAP32[i4 + (i3 << 4) + 12 >> 2] = HEAP32[i4 + (i2 << 4) + 12 >> 2];
     } while (i2 >>> 0 > i15 >>> 0);
    } else {
     if (i5) {
      i3 = i15;
      i2 = i6;
     } else break;
     while (1) {
      HEAP32[i4 + (i2 << 4) >> 2] = HEAP32[i4 + (i3 << 4) >> 2];
      HEAP32[i4 + (i2 << 4) + 4 >> 2] = HEAP32[i4 + (i3 << 4) + 4 >> 2];
      HEAP32[i4 + (i2 << 4) + 8 >> 2] = HEAP32[i4 + (i3 << 4) + 8 >> 2];
      HEAP32[i4 + (i2 << 4) + 12 >> 2] = HEAP32[i4 + (i3 << 4) + 12 >> 2];
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i13 | 0)) break; else i2 = i2 + 1 | 0;
     }
    }
    if (i7) i12 = 29;
   } while (0);
   if ((i12 | 0) == 29) {
    i2 = i14 + i23 | 0;
    i3 = i15;
    do {
     i26 = i3 - i23 | 0;
     HEAP32[i8 + (i3 << 4) >> 2] = HEAP32[i1 + (i26 << 4) >> 2];
     HEAP32[i8 + (i3 << 4) + 4 >> 2] = HEAP32[i1 + (i26 << 4) + 4 >> 2];
     HEAP32[i8 + (i3 << 4) + 8 >> 2] = HEAP32[i1 + (i26 << 4) + 8 >> 2];
     HEAP32[i8 + (i3 << 4) + 12 >> 2] = HEAP32[i1 + (i26 << 4) + 12 >> 2];
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i2 | 0));
   }
   i8 = i24 + 360 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i9 = i24 + 364 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L50 : do if (i1 | 0) {
    i7 = ((i10 | 0) > 0 ? 0 : i10) + i15 | 0;
    i5 = i2;
    i3 = i2 + (i1 << 3) | 0;
    while (1) {
     i6 = i2 + 4 | 0;
     i4 = HEAP32[i2 >> 2] | 0;
     i1 = i5;
     while (1) {
      if (i4 >>> 0 < i7 >>> 0) i5 = 0; else {
       i5 = i4 + i10 | 0;
       HEAP32[i2 >> 2] = i5;
       i5 = (i5 | 0) < (i7 | 0);
      }
      i4 = HEAP32[i6 >> 2] | 0;
      if (i4 >>> 0 < i7 >>> 0) i4 = 0; else {
       i4 = i4 + i10 | 0;
       HEAP32[i6 >> 2] = i4;
       i4 = (i4 | 0) < (i7 | 0);
      }
      if (!(i5 | i4)) break;
      i26 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
      HEAP32[i9 >> 2] = i26;
      i26 = i1 + (i26 << 3) | 0;
      i4 = HEAP32[i26 >> 2] | 0;
      i26 = HEAP32[i26 + 4 >> 2] | 0;
      i3 = i2;
      HEAP32[i3 >> 2] = i4;
      HEAP32[i3 + 4 >> 2] = i26;
      i1 = HEAP32[i8 >> 2] | 0;
      i3 = i1 + (HEAP32[i9 >> 2] << 3) | 0;
      if ((i2 | 0) == (i3 | 0)) break L50;
     }
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i5 = i1;
    }
   } while (0);
   __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i19, i16, i17);
   __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i21, i16, i18);
   i2 = HEAP32[i20 >> 2] | 0;
   i1 = HEAP32[i22 >> 2] | 0;
  }
  if ((i2 | 0) != (i1 | 0)) {
   i4 = HEAP32[i21 >> 2] | 0;
   i2 = i2 - i1 >> 4;
   i3 = 0;
   do {
    i26 = i3 + i23 | 0;
    HEAP32[i4 + (i26 << 4) >> 2] = HEAP32[i1 + (i3 << 4) >> 2];
    HEAP32[i4 + (i26 << 4) + 4 >> 2] = HEAP32[i1 + (i3 << 4) + 4 >> 2];
    HEAP32[i4 + (i26 << 4) + 8 >> 2] = HEAP32[i1 + (i3 << 4) + 8 >> 2];
    HEAP32[i4 + (i26 << 4) + 12 >> 2] = HEAP32[i1 + (i3 << 4) + 12 >> 2];
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i2 >>> 0);
  }
 }
 HEAP32[i24 + 540 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZNK6Camera16ScreenPointToRayERK8Vector2f(i25, i17, i11) {
 i25 = i25 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i26 + 184 | 0;
 i15 = i26 + 176 | 0;
 i19 = i26 + 160 | 0;
 i20 = i26 + 144 | 0;
 i21 = i26 + 80 | 0;
 i22 = i26 + 16 | 0;
 i23 = i26;
 __ZL19GetCameraTargetRectRK6Camerab(i18, i17, 1);
 f27 = Math_fround(HEAPF32[i17 + 864 >> 2]);
 f2 = Math_fround(HEAPF32[i17 + 868 >> 2]);
 f1 = Math_fround(HEAPF32[i17 + 872 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 876 >> 2]);
 f29 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f27 = Math_fround(f27 * f29);
 f1 = Math_fround(f1 * f29);
 f2 = Math_fround(f2 * f28);
 f3 = Math_fround(f3 * f28);
 f31 = Math_fround(HEAPF32[i18 >> 2]);
 f30 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f27 = Math_fround(f27 + f31);
 f2 = Math_fround(f2 + f30);
 f1 = Math_fround(f1 + f27);
 f3 = Math_fround(f3 + f2);
 f29 = Math_fround(f29 + f31);
 f28 = Math_fround(f28 + f30);
 f27 = f27 < f31 ? f31 : f27;
 f2 = f2 < f30 ? f30 : f2;
 f1 = Math_fround((f1 > f29 ? f29 : f1) - f27);
 i5 = f1 < Math_fround(0.0);
 f1 = i5 ? Math_fround(0.0) : f1;
 f3 = Math_fround((f3 > f28 ? f28 : f3) - f2);
 i5 = f3 < Math_fround(0.0);
 f3 = i5 ? Math_fround(0.0) : f3;
 f28 = Math_fround(f27 + Math_fround(.5));
 i5 = f28 >= Math_fround(0.0);
 f29 = Math_fround(f28 + Math_fround(-.99999994));
 i5 = ~~(i5 ? f28 : f29);
 HEAP32[i19 >> 2] = i5;
 f29 = Math_fround(f2 + Math_fround(.5));
 i4 = f29 >= Math_fround(0.0);
 f28 = Math_fround(f29 + Math_fround(-.99999994));
 i4 = ~~(i4 ? f29 : f28);
 HEAP32[i19 + 4 >> 2] = i4;
 HEAP32[i19 + 8 >> 2] = (~~Math_fround(Math_fround(f27 + f1) + Math_fround(.5)) >>> 0) - i5;
 HEAP32[i19 + 12 >> 2] = (~~Math_fround(Math_fround(f2 + f3) + Math_fround(.5)) >>> 0) - i4;
 __Z20InvertMatrix4x4_FullPKfPf(__ZNK6Camera20GetWorldToClipMatrixEv(i17) | 0, i21) | 0;
 i4 = i17 + 36 | 0;
 i5 = i17 + 1076 | 0;
 if (HEAP8[i5 >> 0] | 0) if (HEAP8[i17 + 1080 >> 0] | 0) {
  HEAPF32[i18 >> 2] = Math_fround(1.0);
  HEAPF32[i18 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i18 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i4, i18) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i4, i18) | 0;
  HEAP8[i5 >> 0] = 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i4, i22) | 0;
 i9 = i11 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i10 = i17 + 920 | 0;
 i16 = HEAP32[i10 >> 2] | 0;
 HEAP32[i23 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i23 + 4 >> 2] = i4;
 HEAP32[i23 + 8 >> 2] = i16;
 i16 = i17 + 744 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 do if (i4 | 0) {
  HEAP32[i15 >> 2] = i4;
  i4 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i4) i24 = 10; else {
   if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
    i5 = HEAP32[i4 + 28 >> 2] | 0;
    i6 = HEAP32[i4 + 32 >> 2] | 0;
    i4 = i5 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i4, i15);
    i5 = HEAP32[i18 >> 2] | 0;
    i14 = HEAP32[i4 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i5 | 0) == -1 ? i14 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i14 + (i5 << 3) | 0;
    i5 = HEAP32[i6 + 28 >> 2] | 0;
    i6 = HEAP32[i6 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i24 = 10; else if (HEAP32[i4 + 4 >> 2] | 0) break;
  }
  __Z31ReadObjectFromPersistentManageri(HEAP32[i16 >> 2] | 0) | 0;
 } while (0);
 if (!(__Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i23, i22, i21, i19, i20, 0) | 0)) {
  __ZNK9Transform11GetPositionEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i25 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAPF32[i25 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 20 >> 2] = Math_fround(1.0);
  STACKTOP = i26;
  return;
 }
 i12 = HEAP32[i20 >> 2] | 0;
 i7 = i20 + 4 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 i8 = i20 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 do if (!(HEAP8[i17 + 1088 >> 0] | 0)) {
  i4 = HEAP32[i9 >> 2] | 0;
  f31 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(1.0e3));
  HEAP32[i23 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i23 + 4 >> 2] = i4;
  HEAPF32[i23 + 8 >> 2] = f31;
  i4 = HEAP32[i16 >> 2] | 0;
  do if (i4 | 0) {
   HEAP32[i15 >> 2] = i4;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i4) i24 = 23; else {
    if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
     i5 = HEAP32[i4 + 28 >> 2] | 0;
     i6 = HEAP32[i4 + 32 >> 2] | 0;
     i4 = i5 + (i6 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i4, i15);
     i5 = HEAP32[i18 >> 2] | 0;
     i15 = HEAP32[i4 + 28 >> 2] | 0;
     i6 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i5 | 0) == -1 ? i15 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i15 + (i5 << 3) | 0;
     i5 = HEAP32[i6 + 28 >> 2] | 0;
     i6 = HEAP32[i6 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i24 = 23; else if (HEAP32[i4 + 4 >> 2] | 0) break;
   }
   __Z31ReadObjectFromPersistentManageri(HEAP32[i16 >> 2] | 0) | 0;
  } while (0);
  if (__Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i23, i22, i21, i19, i20, 0) | 0) {
   f31 = Math_fround(HEAPF32[i20 >> 2]);
   f31 = Math_fround(f31 - (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f2 = Math_fround(HEAPF32[i7 >> 2]);
   f2 = Math_fround(f2 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f1 = Math_fround(HEAPF32[i8 >> 2]);
   f1 = Math_fround(f1 - (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f2 * f2)) + Math_fround(f1 * f1))));
   f1 = Math_fround(f1 / f3);
   f2 = Math_fround(f2 / f3);
   f3 = Math_fround(f31 / f3);
   break;
  }
  __ZNK9Transform11GetPositionEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i25 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAPF32[i25 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i25 + 20 >> 2] = Math_fround(1.0);
  STACKTOP = i26;
  return;
 } else {
  f31 = Math_fround(HEAPF32[i22 + 32 >> 2]);
  f2 = Math_fround(HEAPF32[i22 + 36 >> 2]);
  f1 = Math_fround(HEAPF32[i22 + 40 >> 2]);
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f2 * f2)) + Math_fround(f1 * f1))));
  f1 = Math_fround(Math_fround(-f1) / f3);
  f2 = Math_fround(Math_fround(-f2) / f3);
  f3 = Math_fround(Math_fround(-f31) / f3);
 } while (0);
 HEAP32[i25 >> 2] = i12;
 HEAP32[i25 + 4 >> 2] = i13;
 HEAP32[i25 + 8 >> 2] = i14;
 HEAPF32[i25 + 12 >> 2] = f3;
 HEAPF32[i25 + 16 >> 2] = f2;
 HEAPF32[i25 + 20 >> 2] = f1;
 STACKTOP = i26;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i15, i1, i13, i14) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i11 = i18 + 16 | 0;
 i12 = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i17;
 HEAP32[i16 >> 2] = i2;
 HEAP32[i16 + 4 >> 2] = i12;
 i16 = i17 + 8 | 0;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i11 >> 2] = i15;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i2 + 1 | 0;
 HEAP32[i17 >> 2] = i2;
 L1 : while (1) {
  i1 = HEAP8[i2 >> 0] | 0;
  L3 : do switch (i1 << 24 >> 24) {
  case 34:
   {
    i3 = 22;
    break L1;
   }
  case 0:
   {
    i3 = 29;
    break L1;
   }
  case 92:
   {
    i4 = i2 + 2 | 0;
    HEAP32[i17 >> 2] = i4;
    i1 = HEAP8[i2 + 1 >> 0] | 0;
    i10 = HEAP8[(i1 & 255) + (gb + 1035087) >> 0] | 0;
    if (!(i10 << 24 >> 24)) {
     if (i1 << 24 >> 24 != 117) {
      i3 = 21;
      break L1;
     }
     i3 = __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_19GenericStringStreamIS2_EEEEjRT_(i15, i17) | 0;
     if ((i3 & -1024 | 0) == 55296) {
      i2 = HEAP32[i17 >> 2] | 0;
      i1 = i2 + 1 | 0;
      HEAP32[i17 >> 2] = i1;
      if ((HEAP8[i2 >> 0] | 0) != 92) {
       i3 = 16;
       break L1;
      }
      i2 = i2 + 2 | 0;
      HEAP32[i17 >> 2] = i2;
      if ((HEAP8[i1 >> 0] | 0) != 117) {
       i1 = i2;
       i3 = 16;
       break L1;
      }
      i1 = __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_19GenericStringStreamIS2_EEEEjRT_(i15, i17) | 0;
      if ((i1 & -1024 | 0) != 56320) {
       i3 = 18;
       break L1;
      }
      i1 = (i1 + -56320 | (i3 << 10) + -56623104) + 65536 | 0;
     } else i1 = i3;
     __ZN9rapidjson4UTF8IcE6EncodeINS_13GenericReaderIS1_S1_13JSONAllocatorE11StackStreamEEEvRT_j(i11, i1);
     break L3;
    }
    i2 = HEAP32[i11 >> 2] | 0;
    i9 = i2 + 12 | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i7 = i2 + 16 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 1 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i2 + 8 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i2 + 4 >> 2] = i3;
      }
      i1 = HEAP32[i2 + 20 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i3 = i8 - i6 | 0;
     i8 = i3 + 1 | 0;
     i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
     i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i6;
     i1 = i6 + i3 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i6 + i8;
    }
    HEAP32[i9 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i10;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
    break;
   }
  default:
   {
    if ((i1 & 255) < 32) {
     i3 = 31;
     break L1;
    }
    HEAP32[i17 >> 2] = i2 + 1;
    i9 = HEAP8[i2 >> 0] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    i10 = i2 + 12 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
    i7 = i2 + 16 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 1 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i2 + 8 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i2 + 4 >> 2] = i3;
      }
      i1 = HEAP32[i2 + 20 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i3 = i8 - i6 | 0;
     i8 = i3 + 1 | 0;
     i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
     i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i6;
     i1 = i6 + i3 | 0;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i7 >> 2] = i6 + i8;
    }
    HEAP32[i10 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i9;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   }
  } while (0);
  i2 = HEAP32[i17 >> 2] | 0;
 }
 if ((i3 | 0) == 16) {
  i14 = i1 + -2 - (HEAP32[i17 + 4 >> 2] | 0) | 0;
  HEAP32[i15 + 24 >> 2] = 9;
  HEAP32[i15 + 28 >> 2] = i14;
 } else if ((i3 | 0) == 18) {
  i14 = (HEAP32[i17 >> 2] | 0) + -2 - (HEAP32[i17 + 4 >> 2] | 0) | 0;
  HEAP32[i15 + 24 >> 2] = 9;
  HEAP32[i15 + 28 >> 2] = i14;
 } else if ((i3 | 0) == 21) {
  i14 = i4 + -1 - (HEAP32[i17 + 4 >> 2] | 0) | 0;
  HEAP32[i15 + 24 >> 2] = 10;
  HEAP32[i15 + 28 >> 2] = i14;
 } else if ((i3 | 0) == 22) {
  HEAP32[i17 >> 2] = i2 + 1;
  i2 = HEAP32[i11 >> 2] | 0;
  i9 = i2 + 12 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = i2 + 16 | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i3 = i11;
  i8 = i1;
  if ((i1 + 1 | 0) >>> 0 >= i11 >>> 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5;
   if (!i5) {
    if (!(HEAP32[i2 >> 2] | 0)) {
     i11 = __Znwj(1) | 0;
     HEAP32[i2 >> 2] = i11;
     HEAP32[i2 + 4 >> 2] = i11;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
   } else {
    i1 = i3 - i6 | 0;
    i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
   }
   i8 = i8 - i6 | 0;
   i11 = i8 + 1 | 0;
   i11 = i1 >>> 0 < i11 >>> 0 ? i11 : i1;
   i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
   HEAP32[i4 >> 2] = i10;
   i1 = i10 + i8 | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i10 + i11;
  }
  HEAP32[i9 >> 2] = i1 + 1;
  HEAP8[i1 >> 0] = 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  i3 = i15 + 24 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i2 = HEAP32[i12 >> 2] | 0;
   i12 = i15 + 12 | 0;
   i1 = (HEAP32[i12 >> 2] | 0) + (0 - i2) | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
   if (i14) {
    if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6StringEPKcjb(i13, i1, i2, 1) | 0) {
     i15 = HEAP32[i16 >> 2] | 0;
     i16 = i17;
     i14 = i16;
     i14 = HEAP32[i14 >> 2] | 0;
     i16 = i16 + 4 | 0;
     i16 = HEAP32[i16 >> 2] | 0;
     i17 = i15;
     i15 = i17;
     HEAP32[i15 >> 2] = i14;
     i17 = i17 + 4 | 0;
     HEAP32[i17 >> 2] = i16;
     STACKTOP = i18;
     return;
    }
   } else if (__ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6StringEPKcjb(i13, i1, i2, 1) | 0) {
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i17;
    i14 = i16;
    i14 = HEAP32[i14 >> 2] | 0;
    i16 = i16 + 4 | 0;
    i16 = HEAP32[i16 >> 2] | 0;
    i17 = i15;
    i15 = i17;
    HEAP32[i15 >> 2] = i14;
    i17 = i17 + 4 | 0;
    HEAP32[i17 >> 2] = i16;
    STACKTOP = i18;
    return;
   }
   i14 = (HEAP32[i17 >> 2] | 0) - (HEAP32[i17 + 4 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = 16;
   HEAP32[i15 + 28 >> 2] = i14;
   i15 = HEAP32[i16 >> 2] | 0;
   i16 = i17;
   i14 = i16;
   i14 = HEAP32[i14 >> 2] | 0;
   i16 = i16 + 4 | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   i17 = i15;
   i15 = i17;
   HEAP32[i15 >> 2] = i14;
   i17 = i17 + 4 | 0;
   HEAP32[i17 >> 2] = i16;
   STACKTOP = i18;
   return;
  }
 } else if ((i3 | 0) == 29) {
  i14 = i2 + -1 - (HEAP32[i17 + 4 >> 2] | 0) | 0;
  HEAP32[i15 + 24 >> 2] = 11;
  HEAP32[i15 + 28 >> 2] = i14;
 } else if ((i3 | 0) == 31) {
  i14 = i2 + -1 - (HEAP32[i17 + 4 >> 2] | 0) | 0;
  HEAP32[i15 + 24 >> 2] = 10;
  HEAP32[i15 + 28 >> 2] = i14;
 }
 i15 = HEAP32[i16 >> 2] | 0;
 i16 = i17;
 i14 = i16;
 i14 = HEAP32[i14 >> 2] | 0;
 i16 = i16 + 4 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = i15;
 i15 = i17;
 HEAP32[i15 >> 2] = i14;
 i17 = i17 + 4 | 0;
 HEAP32[i17 >> 2] = i16;
 STACKTOP = i18;
 return;
}

function __ZN7mecanim9animation13LayerConstant8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904075 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904095 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904124 | 0, gb + 904135 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN7mecanim6bitsetILj66EEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904149 | 0, gb + 905830 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i4 = i2;
    i1 = i1 | 0 ? i1 - i4 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i4;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags(i9, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899001 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 43; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 43; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 43) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904164 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 54; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 54; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 54) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904190 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 65; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 65; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 65) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 36 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904206 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 37 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904215 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration16generateContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj(i42, i1, i2, i21, i45, i48, i19, i47, i27, i44, i46) {
 i42 = i42 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i45 = i45 | 0;
 i48 = i48 | 0;
 i19 = i19 | 0;
 i47 = i47 | 0;
 i27 = i27 | 0;
 i44 = i44 | 0;
 i46 = i46 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i43 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i49 + 16 | 0;
 i43 = i49;
 f35 = Math_fround(HEAPF32[i1 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f53 = Math_fround(HEAPF32[i42 >> 2]);
 i40 = i42 + 4 | 0;
 f7 = Math_fround(HEAPF32[i40 >> 2]);
 i41 = i42 + 8 | 0;
 f52 = Math_fround(HEAPF32[i41 >> 2]);
 f35 = Math_fround(f35 - f53);
 f36 = Math_fround(f36 - f7);
 f37 = Math_fround(f37 - f52);
 f38 = Math_fround(HEAPF32[i2 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f38 = Math_fround(f38 - f53);
 f39 = Math_fround(f39 - f7);
 f28 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f52);
 f16 = Math_fround(HEAPF32[i19 >> 2]);
 f17 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f54 = Math_fround(f16 - f53);
 f51 = Math_fround(f17 - f7);
 f50 = Math_fround(f18 - f52);
 f3 = Math_fround(HEAPF32[i47 >> 2]);
 i1 = i47 + 4 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i47 + 8 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(f3 - f53);
 f23 = Math_fround(f4 - f7);
 f24 = Math_fround(f8 - f52);
 f29 = Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f36 * f36)) + Math_fround(f37 * f37));
 f30 = Math_fround(Math_fround(Math_fround(f35 * f38) + Math_fround(f36 * f39)) + Math_fround(f37 * f28));
 f31 = Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39)) + Math_fround(f28 * f28));
 f32 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f29 * f31) - Math_fround(f30 * f30)));
 f12 = Math_fround(HEAPF32[i21 >> 2]);
 i13 = i21 + 4 | 0;
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i21 + 8 | 0;
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 f54 = Math_fround(f54 * f12);
 f51 = Math_fround(f51 * f6);
 f50 = Math_fround(f50 * f5);
 f15 = Math_fround(Math_fround(Math_fround(-f51) - f54) - f50);
 f9 = Math_fround(HEAPF32[i45 >> 2]);
 i33 = i45 + 4 | 0;
 f10 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i45 + 8 | 0;
 f11 = Math_fround(HEAPF32[i34 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f12 * f9) + Math_fround(f6 * f10)) + Math_fround(f5 * f11));
 i26 = f25 > Math_fround(0.0);
 f15 = Math_fround(f15 / f25);
 f15 = i26 ? f15 : Math_fround(0.0);
 f50 = Math_fround(Math_fround(f54 + f51) + f50);
 f16 = Math_fround(Math_fround(f15 * f9) + f16);
 f17 = Math_fround(Math_fround(f15 * f10) + f17);
 f18 = Math_fround(Math_fround(f15 * f11) + f18);
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 f53 = Math_fround(f16 - f53);
 f7 = Math_fround(f17 - f7);
 f52 = Math_fround(f18 - f52);
 f51 = Math_fround(Math_fround(Math_fround(f35 * f53) + Math_fround(f36 * f7)) + Math_fround(f37 * f52));
 f52 = Math_fround(Math_fround(Math_fround(f38 * f53) + Math_fround(f39 * f7)) + Math_fround(f28 * f52));
 f7 = Math_fround(f32 * Math_fround(Math_fround(f31 * f51) - Math_fround(f30 * f52)));
 f51 = Math_fround(f32 * Math_fround(Math_fround(f29 * f52) - Math_fround(f30 * f51)));
 i19 = f7 >= Math_fround(-1.1920929e-07) & f7 <= Math_fround(1.00000012) & (f51 >= Math_fround(-1.1920929e-07) & f51 <= Math_fround(1.00000012) & Math_fround(f51 + f7) < Math_fround(1.00000012));
 f7 = Math_fround(HEAPF32[i27 >> 2]);
 if (f7 > f50 & i19) {
  i55 = i44 + (HEAP32[i46 >> 2] << 6) | 0;
  HEAP32[i55 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i55 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i55 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i55 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  i20 = HEAP32[i46 >> 2] | 0;
  HEAPF32[i44 + (i20 << 6) + 16 >> 2] = f16;
  HEAPF32[i44 + (i20 << 6) + 20 >> 2] = f17;
  HEAPF32[i44 + (i20 << 6) + 24 >> 2] = f18;
  HEAPF32[i44 + (i20 << 6) + 28 >> 2] = Math_fround(0.0);
  i20 = HEAP32[i46 >> 2] | 0;
  i55 = HEAP32[i33 >> 2] | 0;
  i19 = HEAP32[i34 >> 2] | 0;
  f12 = Math_fround(-f15);
  HEAP32[i44 + (i20 << 6) + 32 >> 2] = HEAP32[i45 >> 2];
  HEAP32[i44 + (i20 << 6) + 36 >> 2] = i55;
  HEAP32[i44 + (i20 << 6) + 40 >> 2] = i19;
  HEAPF32[i44 + (i20 << 6) + 44 >> 2] = f12;
  i20 = HEAP32[i46 >> 2] | 0;
  HEAP32[i46 >> 2] = i20 + 1;
  HEAP32[i44 + (i20 << 6) + 48 >> 2] = i48;
  f12 = Math_fround(HEAPF32[i21 >> 2]);
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  f5 = Math_fround(HEAPF32[i14 >> 2]);
  f9 = Math_fround(HEAPF32[i45 >> 2]);
  f10 = Math_fround(HEAPF32[i33 >> 2]);
  f11 = Math_fround(HEAPF32[i34 >> 2]);
  f3 = Math_fround(HEAPF32[i47 >> 2]);
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  f7 = Math_fround(HEAPF32[i27 >> 2]);
 }
 f50 = Math_fround(f22 * f12);
 f54 = Math_fround(f23 * f6);
 f6 = Math_fround(f24 * f5);
 f52 = Math_fround(Math_fround(f50 + f54) + f6);
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(-f54) - f50) - f6) / f25);
 f6 = i26 ? f6 : Math_fround(0.0);
 f5 = Math_fround(Math_fround(f9 * f6) + f3);
 f4 = Math_fround(Math_fround(f6 * f10) + f4);
 f3 = Math_fround(Math_fround(f6 * f11) + f8);
 HEAP32[i43 >> 2] = HEAP32[i47 >> 2];
 HEAP32[i43 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
 HEAP32[i43 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
 HEAP32[i43 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
 f50 = Math_fround(HEAPF32[i42 >> 2]);
 f54 = Math_fround(HEAPF32[i40 >> 2]);
 f50 = Math_fround(f5 - f50);
 f54 = Math_fround(f4 - f54);
 f51 = Math_fround(f3 - Math_fround(HEAPF32[i41 >> 2]));
 f53 = Math_fround(Math_fround(Math_fround(f35 * f50) + Math_fround(f36 * f54)) + Math_fround(f37 * f51));
 f51 = Math_fround(Math_fround(Math_fround(f38 * f50) + Math_fround(f39 * f54)) + Math_fround(f28 * f51));
 f54 = Math_fround(f32 * Math_fround(Math_fround(f31 * f53) - Math_fround(f30 * f51)));
 f53 = Math_fround(f32 * Math_fround(Math_fround(f29 * f51) - Math_fround(f30 * f53)));
 if (!(f7 > f52 & (f54 >= Math_fround(-1.1920929e-07) & f54 <= Math_fround(1.00000012) & (f53 >= Math_fround(-1.1920929e-07) & f53 <= Math_fround(1.00000012) & Math_fround(f53 + f54) < Math_fround(1.00000012))))) {
  STACKTOP = i49;
  return 0;
 }
 i55 = i44 + (HEAP32[i46 >> 2] << 6) | 0;
 HEAP32[i55 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i55 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
 HEAP32[i55 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
 HEAP32[i55 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
 i55 = HEAP32[i46 >> 2] | 0;
 HEAPF32[i44 + (i55 << 6) + 16 >> 2] = f5;
 HEAPF32[i44 + (i55 << 6) + 20 >> 2] = f4;
 HEAPF32[i44 + (i55 << 6) + 24 >> 2] = f3;
 HEAPF32[i44 + (i55 << 6) + 28 >> 2] = Math_fround(0.0);
 i55 = HEAP32[i46 >> 2] | 0;
 i43 = HEAP32[i33 >> 2] | 0;
 i47 = HEAP32[i34 >> 2] | 0;
 f54 = Math_fround(-f6);
 HEAP32[i44 + (i55 << 6) + 32 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i44 + (i55 << 6) + 36 >> 2] = i43;
 HEAP32[i44 + (i55 << 6) + 40 >> 2] = i47;
 HEAPF32[i44 + (i55 << 6) + 44 >> 2] = f54;
 i55 = HEAP32[i46 >> 2] | 0;
 HEAP32[i46 >> 2] = i55 + 1;
 HEAP32[i44 + (i55 << 6) + 48 >> 2] = i48;
 STACKTOP = i49;
 return 0;
}

function __ZN6Shader8TransferI18StreamedBinaryReadILb0EEEEvRT_(i26, i27) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 24 | 0;
 i5 = i28 + 16 | 0;
 i11 = i28 + 8 | 0;
 i14 = i28 + 116 | 0;
 i15 = i28 + 96 | 0;
 i18 = i28 + 76 | 0;
 i19 = i28 + 56 | 0;
 i22 = i28 + 36 | 0;
 i1 = i28;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i26, i27);
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i16 = i25;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = i13;
 HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i20 + 4 >> 2] = i17;
 i20 = gb + 64016 | 0;
 i17 = HEAP32[i20 + 4 >> 2] | 0;
 i16 = i11;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i16 = i15 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i20 = i25;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i6 = i17;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i6 + 4 >> 2] = i21;
 i6 = gb + 64016 | 0;
 i21 = HEAP32[i6 + 4 >> 2] | 0;
 i20 = i11;
 HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i20 = i18 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i6 = i25;
 i23 = HEAP32[i6 + 4 >> 2] | 0;
 i24 = i21;
 HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i24 + 4 >> 2] = i23;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = i23;
 HEAP32[i19 >> 2] = 0;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i23 = i19 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i7 = i25;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i24;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i22 >> 2] = 0;
 i7 = i22 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i22 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i3 = i25;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i26 + 96 >> 2] | 0, i27);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i27, i14, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i27, i15, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i27, i18, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i27, i19, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i27, i22, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i27);
 if (HEAP32[i2 >> 2] | 0) {
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i3;
  HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i8 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i25) | 0;
  i3 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i3 << 2) >> 2] | 0;
  L3 : do if ((i3 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i2 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i14 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L3;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i5 >> 2] = i4;
   __Z6FormatPKcz(i25, gb + 470364 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i25 + 11 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i4 = i26 + 60 | 0;
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i25 >> 2] = i5;
   HEAP32[i11 >> 2] = i3;
   if ((i3 | 0) != 0 & (i5 | 0 ? (HEAP32[i7 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i26 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i26 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i26 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i26 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i7;
     i1 = i7;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, (HEAP32[i22 >> 2] | 0) + i6 | 0, i11 | 0, i1 | 0, i25 | 0) | 0;
   }
  }
  if (i8 | 0) mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i10);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i24);
  HEAP32[i19 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i21);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i17);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 i3 = i26 + 80 | 0;
 i4 = i27 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i27 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i25, 4);
  i1 = HEAP32[i25 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i25 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i26 + 84 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i27);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i26 + 92 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i27);
  STACKTOP = i28;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i27);
  STACKTOP = i28;
  return;
 }
}

function __ZL21CheckMaterialsNotNullRK13dynamic_arrayI4PPtrI8MaterialELj4EERKS0_I10GameObjectE(i6, i11) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i4 = i14;
 i10 = i14 + 32 | 0;
 i8 = i14 + 28 | 0;
 i12 = i14 + 16 | 0;
 i7 = i6 + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i8);
    i2 = HEAP32[i10 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 10;
   }
  }
  if ((i13 | 0) == 8) i13 = 10;
  if ((i13 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i12, gb + 933916 | 0, i4);
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) {
   i13 = 0;
   i10 = i12 + 11 | 0;
   i10 = HEAP8[i10 >> 0] | 0;
   i10 = i10 << 24 >> 24 < 0;
   i11 = HEAP32[i12 >> 2] | 0;
   i11 = i10 ? i11 : i12;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i11, 0, gb + 933103 | 0, 43, 512, i13, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   STACKTOP = i14;
   return 0;
  }
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i10);
    i2 = HEAP32[i4 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 19;
   }
  }
  if ((i13 | 0) == 17) i13 = 19;
  if ((i13 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
  if (!i1) {
   i13 = 0;
   i10 = i12 + 11 | 0;
   i10 = HEAP8[i10 >> 0] | 0;
   i10 = i10 << 24 >> 24 < 0;
   i11 = HEAP32[i12 >> 2] | 0;
   i11 = i10 ? i11 : i12;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i11, 0, gb + 933103 | 0, 43, 512, i13, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   STACKTOP = i14;
   return 0;
  }
  i13 = HEAP32[i1 + 4 >> 2] | 0;
  i10 = i12 + 11 | 0;
  i10 = HEAP8[i10 >> 0] | 0;
  i10 = i10 << 24 >> 24 < 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i11 = i10 ? i11 : i12;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i11, 0, gb + 933103 | 0, 43, 512, i13, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i14;
  return 0;
 }
 i4 = 0;
 while (1) {
  i5 = (HEAP32[i6 >> 2] | 0) + (i4 << 2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) break;
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 29; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i8);
    i2 = HEAP32[i10 >> 2] | 0;
    i15 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 29; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i13 = 31;
  }
  if ((i13 | 0) == 29) i13 = 31;
  if ((i13 | 0) == 31) {
   i13 = 0;
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
   i1 = 1;
   i13 = 53;
   break;
  }
 }
 if ((i13 | 0) == 53) {
  STACKTOP = i14;
  return i1 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 37; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i8);
   i2 = HEAP32[i10 >> 2] | 0;
   i15 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 37; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 39;
  }
 }
 if ((i13 | 0) == 37) i13 = 39;
 if ((i13 | 0) == 39) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 __Z6FormatPKcz(i12, gb + 933978 | 0, i9);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 46; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i15 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 46; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 48;
   }
  }
  if ((i13 | 0) == 46) i13 = 48;
  if ((i13 | 0) == 48) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 933103 | 0, 51, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i15 = 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i31, i28, i1, f2) {
 i31 = i31 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i32 + 120 | 0;
 i42 = i32 + 32 | 0;
 i29 = i32 + 16 | 0;
 i30 = i32 + 56 | 0;
 i20 = i32;
 HEAP32[i31 >> 2] = -1;
 i25 = i31 + 56 | 0;
 HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
 i26 = i31 + 60 | 0;
 HEAP32[i26 >> 2] = HEAP32[i1 + 4 >> 2];
 i27 = i31 + 64 | 0;
 HEAP32[i27 >> 2] = HEAP32[i1 + 8 >> 2];
 i21 = i31 + 68 | 0;
 HEAP32[i21 >> 2] = HEAP32[i1 + 12 >> 2];
 i22 = i31 + 72 | 0;
 HEAP32[i22 >> 2] = HEAP32[i1 + 16 >> 2];
 i23 = i31 + 76 | 0;
 HEAP32[i23 >> 2] = HEAP32[i1 + 20 >> 2];
 i24 = i31 + 80 | 0;
 HEAP32[i24 >> 2] = HEAP32[i1 + 24 >> 2];
 i18 = i31 + 84 | 0;
 HEAP32[i31 + 144 >> 2] = i28;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i31, i28);
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i31, i42, i25, f2, 0);
 f7 = Math_fround(HEAPF32[i25 >> 2]);
 f34 = Math_fround(HEAPF32[i26 >> 2]);
 f35 = Math_fround(HEAPF32[i27 >> 2]);
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f38 = Math_fround(f7 + f7);
 f8 = Math_fround(f34 + f34);
 f2 = Math_fround(f35 + f35);
 f10 = Math_fround(f34 * f8);
 f6 = Math_fround(f35 * f2);
 f34 = Math_fround(f38 * f34);
 f39 = Math_fround(f38 * f35);
 f9 = Math_fround(f38 * f5);
 f35 = Math_fround(f8 * f35);
 f8 = Math_fround(f8 * f5);
 f5 = Math_fround(f2 * f5);
 f2 = Math_fround(Math_fround(Math_fround(1.0) - f10) - f6);
 f3 = Math_fround(f34 + f5);
 f4 = Math_fround(f39 - f8);
 f5 = Math_fround(f34 - f5);
 f38 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f38));
 f6 = Math_fround(f38 - f6);
 f7 = Math_fround(f35 + f9);
 f8 = Math_fround(f39 + f8);
 f9 = Math_fround(f35 - f9);
 f10 = Math_fround(f38 - f10);
 HEAPF32[i18 >> 2] = f2;
 i1 = i31 + 88 | 0;
 HEAPF32[i1 >> 2] = f3;
 i11 = i31 + 92 | 0;
 HEAPF32[i11 >> 2] = f4;
 i12 = i31 + 96 | 0;
 HEAPF32[i12 >> 2] = f5;
 i13 = i31 + 100 | 0;
 HEAPF32[i13 >> 2] = f6;
 i14 = i31 + 104 | 0;
 HEAPF32[i14 >> 2] = f7;
 i15 = i31 + 108 | 0;
 HEAPF32[i15 >> 2] = f8;
 i16 = i31 + 112 | 0;
 HEAPF32[i16 >> 2] = f9;
 i17 = i31 + 116 | 0;
 HEAPF32[i17 >> 2] = f10;
 f38 = Math_fround(HEAPF32[i42 >> 2]);
 f35 = Math_fround(HEAPF32[i42 + 12 >> 2]);
 f39 = Math_fround(f38 + f35);
 f34 = Math_fround(HEAPF32[i42 + 4 >> 2]);
 f36 = Math_fround(HEAPF32[i42 + 16 >> 2]);
 f41 = Math_fround(f34 + f36);
 f33 = Math_fround(HEAPF32[i42 + 8 >> 2]);
 f37 = Math_fround(HEAPF32[i42 + 20 >> 2]);
 f39 = Math_fround(f39 * Math_fround(.5));
 f41 = Math_fround(f41 * Math_fround(.5));
 f40 = Math_fround(Math_fround(f33 + f37) * Math_fround(.5));
 f38 = Math_fround(Math_fround(Math_fround(f35 - f38) * Math_fround(.5)) * Math_fround(1.00999999));
 f34 = Math_fround(Math_fround(Math_fround(f36 - f34) * Math_fround(.5)) * Math_fround(1.00999999));
 f33 = Math_fround(Math_fround(Math_fround(f37 - f33) * Math_fround(.5)) * Math_fround(1.00999999));
 f37 = Math_fround(f41 - f34);
 f36 = Math_fround(f40 - f33);
 f35 = Math_fround(f39 + f38);
 f34 = Math_fround(f41 + f34);
 f33 = Math_fround(f40 + f33);
 HEAPF32[i31 + 120 >> 2] = Math_fround(f39 - f38);
 HEAPF32[i31 + 124 >> 2] = f37;
 HEAPF32[i31 + 128 >> 2] = f36;
 HEAPF32[i31 + 132 >> 2] = f35;
 HEAPF32[i31 + 136 >> 2] = f34;
 HEAPF32[i31 + 140 >> 2] = f33;
 switch (HEAP32[i28 >> 2] | 0) {
 case 3:
  {
   HEAP32[i31 + 184 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i31 + 188 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i31 + 192 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i31 + 196 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i31 + 200 >> 2] = HEAP32[i31 + 8 >> 2];
   HEAP32[i31 + 204 >> 2] = HEAP32[i31 + 12 >> 2];
   HEAPF32[i31 + 148 >> 2] = f2;
   HEAPF32[i31 + 152 >> 2] = f3;
   HEAPF32[i31 + 156 >> 2] = f4;
   HEAPF32[i31 + 160 >> 2] = f5;
   HEAPF32[i31 + 164 >> 2] = f6;
   HEAPF32[i31 + 168 >> 2] = f7;
   HEAPF32[i31 + 172 >> 2] = f8;
   HEAPF32[i31 + 176 >> 2] = f9;
   HEAPF32[i31 + 180 >> 2] = f10;
   STACKTOP = i32;
   return;
  }
 case 2:
  {
   f33 = Math_fround(HEAPF32[i25 >> 2]);
   f36 = Math_fround(f33 * Math_fround(2.0));
   f39 = Math_fround(HEAPF32[i21 >> 2]);
   f38 = Math_fround(f39 * Math_fround(2.0));
   f39 = Math_fround(Math_fround(f33 * f36) + Math_fround(Math_fround(f39 * f38) + Math_fround(-1.0)));
   f33 = Math_fround(HEAPF32[i27 >> 2]);
   f40 = Math_fround(f33 * f38);
   f41 = Math_fround(HEAPF32[i26 >> 2]);
   f40 = Math_fround(f40 + Math_fround(f36 * f41));
   f41 = Math_fround(Math_fround(f36 * f33) - Math_fround(f38 * f41));
   f38 = Math_fround(HEAPF32[i31 + 8 >> 2]);
   f39 = Math_fround(f38 * f39);
   f40 = Math_fround(f38 * f40);
   f41 = Math_fround(f38 * f41);
   f38 = Math_fround(HEAPF32[i31 + 72 >> 2]);
   f33 = Math_fround(f38 + f39);
   f36 = Math_fround(HEAPF32[i23 >> 2]);
   f34 = Math_fround(f36 + f40);
   f37 = Math_fround(HEAPF32[i24 >> 2]);
   f35 = Math_fround(f41 + f37);
   HEAPF32[i31 + 148 >> 2] = f33;
   HEAPF32[i31 + 152 >> 2] = f34;
   HEAPF32[i31 + 156 >> 2] = f35;
   f40 = Math_fround(f36 - f40);
   f41 = Math_fround(f37 - f41);
   HEAPF32[i31 + 160 >> 2] = Math_fround(f38 - f39);
   HEAPF32[i31 + 164 >> 2] = f40;
   HEAPF32[i31 + 168 >> 2] = f41;
   HEAP32[i31 + 172 >> 2] = HEAP32[i31 + 4 >> 2];
   HEAP32[i29 >> 2] = 3;
   f41 = Math_fround(HEAPF32[i28 + 4 >> 2]);
   HEAPF32[i29 + 4 >> 2] = Math_fround(f41 + Math_fround(HEAPF32[i28 + 8 >> 2]));
   HEAPF32[i29 + 8 >> 2] = f41;
   HEAPF32[i29 + 12 >> 2] = f41;
   __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i31, i29);
   STACKTOP = i32;
   return;
  }
 case 4:
  {
   __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE(i30, i31, HEAP32[i31 + 32 >> 2] | 0, i25);
   HEAP32[i18 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i30 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i30 + 16 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i30 + 20 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i30 + 24 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i30 + 28 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i30 + 32 >> 2];
   i29 = HEAP32[i30 + 48 >> 2] | 0;
   i28 = HEAP32[i30 + 52 >> 2] | 0;
   i18 = HEAP32[i30 + 56 >> 2] | 0;
   HEAP32[i20 >> 2] = 3;
   HEAP32[i20 + 4 >> 2] = i29;
   HEAP32[i20 + 8 >> 2] = i28;
   HEAP32[i20 + 12 >> 2] = i18;
   __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i31, i20);
   __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i19, i30);
   i18 = HEAP32[i19 + 4 >> 2] | 0;
   i20 = HEAP32[i19 + 8 >> 2] | 0;
   i28 = HEAP32[i19 + 12 >> 2] | 0;
   i29 = HEAP32[i30 + 36 >> 2] | 0;
   i31 = HEAP32[i30 + 40 >> 2] | 0;
   i42 = HEAP32[i30 + 44 >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i26 >> 2] = i18;
   HEAP32[i27 >> 2] = i20;
   HEAP32[i21 >> 2] = i28;
   HEAP32[i22 >> 2] = i29;
   HEAP32[i23 >> 2] = i31;
   HEAP32[i24 >> 2] = i42;
   STACKTOP = i32;
   return;
  }
 case 0:
  {
   i42 = HEAP32[i31 + 4 >> 2] | 0;
   i29 = HEAP32[i23 >> 2] | 0;
   i30 = HEAP32[i24 >> 2] | 0;
   HEAP32[i31 + 148 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i31 + 152 >> 2] = i29;
   HEAP32[i31 + 156 >> 2] = i30;
   HEAP32[i31 + 160 >> 2] = i42;
   STACKTOP = i32;
   return;
  }
 default:
  {
   STACKTOP = i32;
   return;
  }
 }
}

function __ZN5physx2Sn9MetaClass5checkERKNS0_8MetaDataE(i19, i23) {
 i19 = i19 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 104 | 0;
 i25 = i27 + 96 | 0;
 i14 = i27 + 80 | 0;
 i12 = i27 + 64 | 0;
 i9 = i27 + 48 | 0;
 i8 = i27 + 32 | 0;
 i20 = i27;
 i15 = i27 + 108 | 0;
 i22 = HEAP32[i23 >> 2] | 0;
 i13 = i19 + 12 | 0;
 HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i22, 1, gb + 671345 | 0, i20);
 if (HEAP32[i19 + 4 >> 2] & 1 | HEAP32[i19 >> 2] | 0) {
  i26 = 1;
  STACKTOP = i27;
  return i26 | 0;
 }
 if (HEAP32[i19 + 8 >> 2] | 0) {
  i26 = 1;
  STACKTOP = i27;
  return i26 | 0;
 }
 i11 = i19 + 16 | 0;
 i16 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i27 + 109 | 0, HEAP32[i11 >> 2] | 0, gb + 670404 | 0, 94) | 0;
 _memset(i16 | 0, 0, HEAP32[i11 >> 2] | 0) | 0;
 i21 = i19 + 36 | 0;
 i17 = i19 + 40 | 0;
 i22 = HEAP32[i17 >> 2] | 0;
 i18 = (i22 | 0) == 0;
 if (!i18) {
  i7 = 0;
  do {
   i1 = HEAP32[i21 >> 2] | 0;
   if (!(HEAP32[i1 + (i7 << 5) + 24 >> 2] & 16)) {
    i2 = HEAP32[i1 + (i7 << 5) + 8 >> 2] | 0;
    i10 = HEAP32[i1 + (i7 << 5) + 12 >> 2] | 0;
    i6 = i10 + i2 | 0;
    if ((i10 | 0) > 0) {
     i4 = 0;
     i1 = -1;
     do {
      i5 = i16 + i2 | 0;
      i3 = (i1 | 0) == -1;
      if (!(HEAP8[i5 >> 0] | 0)) if (i3) i1 = -1; else {
       i10 = HEAP32[i23 >> 2] | 0;
       HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i8 + 4 >> 2] = i4;
       HEAP32[i8 + 8 >> 2] = i1;
       __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 32, gb + 671365 | 0, i8);
       i1 = -1;
      } else {
       i4 = i3 ? 1 : i4 + 1 | 0;
       i1 = i3 ? i7 : i1;
      }
      HEAP8[i5 >> 0] = 1;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i6 | 0));
     i2 = i4;
     if ((i1 | 0) != -1) {
      i10 = HEAP32[i23 >> 2] | 0;
      HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i9 + 4 >> 2] = i2;
      HEAP32[i9 + 8 >> 2] = i1;
      __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 32, gb + 671365 | 0, i9);
     }
    }
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i22 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 do if ((i1 | 0) > 0) {
  i5 = i20 + 4 | 0;
  i6 = i20 + 8 | 0;
  i7 = i20 + 12 | 0;
  i8 = i20 + 16 | 0;
  i9 = i20 + 24 | 0;
  i10 = i19 + 44 | 0;
  i3 = i1;
  i2 = -1;
  i1 = 0;
  i4 = 0;
  do {
   if (!(HEAP8[i16 + i4 >> 0] | 0)) {
    i28 = (i2 | 0) == -1;
    i2 = i28 ? i4 : i2;
    i1 = i28 ? 1 : i1 + 1 | 0;
   } else {
    do if ((i2 | 0) != -1) {
     i28 = HEAP32[i23 >> 2] | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     HEAP32[i12 >> 2] = i1;
     HEAP32[i12 + 4 >> 2] = i2;
     HEAP32[i12 + 8 >> 2] = i3;
     __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i28, 1, gb + 671424 | 0, i12);
     HEAP32[i20 >> 2] = 0;
     HEAP32[i20 + 4 >> 2] = 0;
     HEAP32[i20 + 8 >> 2] = 0;
     HEAP32[i20 + 12 >> 2] = 0;
     HEAP32[i20 + 16 >> 2] = 0;
     HEAP32[i20 + 20 >> 2] = 0;
     HEAP32[i20 + 24 >> 2] = 0;
     HEAP32[i20 + 28 >> 2] = 0;
     HEAP32[i20 >> 2] = gb + 671086;
     HEAP32[i5 >> 2] = gb + 671477;
     HEAP32[i6 >> 2] = i2;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i1;
     HEAP32[i9 >> 2] = 512;
     i2 = HEAP32[i17 >> 2] | 0;
     if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      i28 = (HEAP32[i21 >> 2] | 0) + (i2 << 5) | 0;
      HEAP32[i28 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i28 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i28 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      HEAP32[i28 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
      HEAP32[i28 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
      HEAP32[i28 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
      HEAP32[i28 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
      HEAP32[i28 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i21, i20) | 0;
      break;
     }
    } while (0);
    i2 = -1;
    i3 = HEAP32[i11 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i3 | 0));
  if ((i2 | 0) != -1) {
   i28 = HEAP32[i23 >> 2] | 0;
   i13 = HEAP32[i13 >> 2] | 0;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i14 + 8 >> 2] = i13;
   __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i28, 1, gb + 671424 | 0, i14);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   HEAP32[i20 + 12 >> 2] = 0;
   HEAP32[i20 + 16 >> 2] = 0;
   HEAP32[i20 + 20 >> 2] = 0;
   HEAP32[i20 + 24 >> 2] = 0;
   HEAP32[i20 + 28 >> 2] = 0;
   HEAP32[i20 >> 2] = gb + 671086;
   HEAP32[i20 + 4 >> 2] = gb + 671477;
   HEAP32[i20 + 8 >> 2] = i2;
   HEAP32[i20 + 12 >> 2] = i1;
   HEAP32[i20 + 16 >> 2] = i1;
   HEAP32[i20 + 24 >> 2] = 512;
   i1 = HEAP32[i17 >> 2] | 0;
   if ((HEAP32[i19 + 44 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i28 = (HEAP32[i21 >> 2] | 0) + (i1 << 5) | 0;
    HEAP32[i28 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i28 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i28 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i28 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    HEAP32[i28 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
    HEAP32[i28 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
    HEAP32[i28 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
    HEAP32[i28 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i21, i20) | 0;
    break;
   }
  }
 } while (0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i15, i16);
 if (i18) {
  i28 = 1;
  STACKTOP = i27;
  return i28 | 0;
 }
 i7 = i23 + 4 | 0;
 i9 = 0;
 L48 : while (1) {
  i2 = HEAP32[i21 >> 2] | 0;
  i8 = HEAP32[i2 + (i9 << 5) + 24 >> 2] | 0;
  if (!(i8 & 8)) {
   i1 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i2 + (i9 << 5) >> 2] | 0;
   switch (HEAP32[i7 >> 2] | 0) {
   case 1:
    {
     i3 = HEAP32[i1 + 4 >> 2] | 0;
     i6 = HEAP32[i3 + 24 >> 2] | 0;
     if (!i6) break L48;
     i4 = HEAP32[i3 + 20 >> 2] | 0;
     i5 = 0;
     while (1) {
      i3 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
      i5 = i5 + 1 | 0;
      if (!(_strcmp(HEAP32[i3 + 12 >> 2] | 0, i2) | 0)) break;
      if (i5 >>> 0 >= i6 >>> 0) break L48;
     }
     while (1) {
      i4 = HEAP32[i3 + 8 >> 2] | 0;
      if (!i4) break; else i3 = i4;
     }
     break;
    }
   case 2:
    {
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     i6 = HEAP32[i3 + 24 >> 2] | 0;
     if (!i6) break L48;
     i4 = HEAP32[i3 + 20 >> 2] | 0;
     i5 = 0;
     while (1) {
      i3 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
      i5 = i5 + 1 | 0;
      if (!(_strcmp(HEAP32[i3 + 12 >> 2] | 0, i2) | 0)) break;
      if (i5 >>> 0 >= i6 >>> 0) break L48;
     }
     while (1) {
      i4 = HEAP32[i3 + 8 >> 2] | 0;
      if (!i4) break; else i3 = i4;
     }
     break;
    }
   default:
    break L48;
   }
   if (!i3) break;
   if (i8 & 16 | 0) {
    HEAP32[i24 >> 2] = i2;
    __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i1, 1, gb + 671546 | 0, i24);
   }
  }
  i9 = i9 + 1 | 0;
  if (i9 >>> 0 >= i22 >>> 0) {
   i1 = 1;
   i26 = 49;
   break;
  }
 }
 if ((i26 | 0) == 49) {
  STACKTOP = i27;
  return i1 | 0;
 }
 HEAP32[i25 >> 2] = i2;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i1, 32, gb + 671500 | 0, i25);
 i28 = 0;
 STACKTOP = i27;
 return i28 | 0;
}

function __ZN5physx2Gu9RadixSort4SortEPKjjNS0_9RadixHintE(i17, i15, i16, i7) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0;
 if ((i15 | 0) == 0 | (i16 | 0) < 1) return i17 | 0;
 i13 = i17 + 24 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 i13 = (i7 | 0) == 1;
 i14 = i17 + 16 | 0;
 _memset(HEAP32[i14 >> 2] | 0, 0, 4096) | 0;
 i6 = i15 + (i16 << 2) | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i12 = i17 + 4 | 0;
 i1 = (HEAP32[i12 >> 2] | 0) < 0;
 if (i13) {
  L6 : do if (i1) {
   if ((i6 | 0) != (i15 | 0)) {
    i2 = HEAP32[i15 >> 2] | 0;
    i1 = i15;
    do {
     i11 = i2;
     i2 = HEAP32[i1 >> 2] | 0;
     if (i2 >>> 0 < i11 >>> 0) break L6;
     i11 = i1;
     i1 = i1 + 4 | 0;
     i10 = i5 + ((i2 & 255) << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i10 = i5 + ((HEAPU8[i11 + 1 >> 0] | 0 | 256) << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i10 = i5 + ((HEAPU8[i11 + 2 >> 0] | 0 | 512) << 2) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i11 = i5 + ((HEAPU8[i11 + 3 >> 0] | 0 | 768) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    } while ((i1 | 0) != (i6 | 0));
   }
   i15 = i17 + 28 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   if (!i16) return i17 | 0;
   i1 = HEAP32[i17 + 8 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i16 | 0));
   return i17 | 0;
  } else {
   i1 = HEAP32[i17 + 8 >> 2] | 0;
   L21 : do if ((i6 | 0) != (i15 | 0)) {
    i4 = HEAP32[i15 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
    i2 = i1;
    i3 = i15;
    while (1) {
     i2 = i2 + 4 | 0;
     i1 = i5 + ((HEAPU8[i3 >> 0] | 0) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i5 + ((HEAPU8[i3 + 1 >> 0] | 0 | 256) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i5 + ((HEAPU8[i3 + 2 >> 0] | 0 | 512) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i3 + 4 | 0;
     i11 = i5 + ((HEAPU8[i3 + 3 >> 0] | 0 | 768) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     if ((i1 | 0) == (i6 | 0)) break L21;
     i11 = i4;
     i4 = HEAP32[i15 + (HEAP32[i2 >> 2] << 2) >> 2] | 0;
     if (i4 >>> 0 < i11 >>> 0) break L6; else i3 = i1;
    }
   } while (0);
   i16 = i17 + 28 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
   return i17 | 0;
  } while (0);
  if ((i1 | 0) != (i6 | 0)) do {
   i11 = i5 + ((HEAPU8[i1 >> 0] | 0) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 1 >> 0] | 0 | 256) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 2 >> 0] | 0 | 512) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 3 >> 0] | 0 | 768) << 2) | 0;
   i1 = i1 + 4 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } while ((i1 | 0) != (i6 | 0));
 } else {
  L32 : do if (i1) {
   L34 : do if ((i6 | 0) != (i15 | 0)) {
    i2 = HEAP32[i15 >> 2] | 0;
    i3 = i15;
    i1 = i15;
    while (1) {
     i11 = i5 + ((i2 & 255) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i11 = i5 + ((HEAPU8[i1 + 1 >> 0] | 0 | 256) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i11 = i5 + ((HEAPU8[i1 + 2 >> 0] | 0 | 512) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i11 = i5 + ((HEAPU8[i1 + 3 >> 0] | 0 | 768) << 2) | 0;
     i1 = i3 + 4 | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     if ((i1 | 0) == (i6 | 0)) break L34;
     i11 = i2;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) < (i11 | 0)) break L32; else i3 = i1;
    }
   } while (0);
   i15 = i17 + 28 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   if (!i16) return i17 | 0;
   i1 = HEAP32[i17 + 8 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i1 + (i2 << 2) >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i16 | 0));
   return i17 | 0;
  } else {
   i1 = HEAP32[i17 + 8 >> 2] | 0;
   L47 : do if ((i6 | 0) != (i15 | 0)) {
    i4 = HEAP32[i15 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
    i2 = i1;
    i3 = i15;
    while (1) {
     i2 = i2 + 4 | 0;
     i1 = i5 + ((HEAPU8[i3 >> 0] | 0) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i5 + ((HEAPU8[i3 + 1 >> 0] | 0 | 256) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i5 + ((HEAPU8[i3 + 2 >> 0] | 0 | 512) << 2) | 0;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     i1 = i3 + 4 | 0;
     i11 = i5 + ((HEAPU8[i3 + 3 >> 0] | 0 | 768) << 2) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     if ((i1 | 0) == (i6 | 0)) break L47;
     i11 = i4;
     i4 = HEAP32[i15 + (HEAP32[i2 >> 2] << 2) >> 2] | 0;
     if ((i4 | 0) < (i11 | 0)) break L32; else i3 = i1;
    }
   } while (0);
   i16 = i17 + 28 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
   return i17 | 0;
  } while (0);
  if ((i1 | 0) != (i6 | 0)) do {
   i11 = i5 + ((HEAPU8[i1 >> 0] | 0) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 1 >> 0] | 0 | 256) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 2 >> 0] | 0 | 512) << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i11 = i5 + ((HEAPU8[i1 + 3 >> 0] | 0 | 768) << 2) | 0;
   i1 = i1 + 4 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (!i7) {
  i1 = 0;
  i2 = 128;
  do {
   i1 = (HEAP32[i5 + (i2 + 768 << 2) >> 2] | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 256);
 } else i1 = 0;
 i8 = i17 + 20 | 0;
 i9 = i17 + 12 | 0;
 i10 = i17 + 8 | 0;
 i11 = (i16 | 0) == 0;
 i7 = 0;
 while (1) {
  i4 = i7 << 8;
  if (!((i5 + (i4 << 2) | 0) == 0 ? 1 : (HEAP32[i5 + ((HEAPU8[i15 + i7 >> 0] | 0 | i4) << 2) >> 2] | 0) == (i16 | 0))) {
   i6 = HEAP32[i8 >> 2] | 0;
   if (i13 | (i7 | 0) != 3) {
    i2 = HEAP32[i9 >> 2] | 0;
    HEAP32[i6 >> 2] = i2;
    i3 = 1;
    do {
     i2 = i2 + (HEAP32[i5 + (i3 + -1 + i4 << 2) >> 2] << 2) | 0;
     HEAP32[i6 + (i3 << 2) >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 256);
   } else {
    i2 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
    HEAP32[i6 >> 2] = i2;
    i3 = 1;
    do {
     i2 = i2 + (HEAP32[i5 + (i3 + -1 + i4 << 2) >> 2] << 2) | 0;
     HEAP32[i6 + (i3 << 2) >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 128);
    i2 = HEAP32[i9 >> 2] | 0;
    HEAP32[i6 + 512 >> 2] = i2;
    i3 = 129;
    do {
     i2 = i2 + (HEAP32[i5 + (i3 + -1 + i4 << 2) >> 2] << 2) | 0;
     HEAP32[i6 + (i3 << 2) >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 256);
   }
   i2 = HEAP32[i12 >> 2] | 0;
   if ((i2 | 0) < 0) {
    if (!i11) {
     i2 = 0;
     do {
      i4 = i6 + ((HEAPU8[i15 + ((i2 << 2) + i7) >> 0] | 0) << 2) | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = i5 + 4;
      HEAP32[i5 >> 2] = i2;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i16 | 0));
     i2 = HEAP32[i12 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = i2 & 2147483647;
   } else {
    i2 = HEAP32[i10 >> 2] | 0;
    i3 = i2 + (i16 << 2) | 0;
    if (!i11) do {
     i4 = HEAP32[i2 >> 2] | 0;
     i2 = i2 + 4 | 0;
     i18 = i6 + ((HEAPU8[i15 + ((i4 << 2) + i7) >> 0] | 0) << 2) | 0;
     i5 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = i5 + 4;
     HEAP32[i5 >> 2] = i4;
    } while ((i2 | 0) != (i3 | 0));
   }
   i18 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i18;
  }
  i2 = i7 + 1 | 0;
  if ((i2 | 0) == 4) break;
  i5 = HEAP32[i14 >> 2] | 0;
  i7 = i2;
 }
 return i17 | 0;
}

function _write_scan_header(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = HEAP32[i10 + 332 >> 2] | 0;
 if (!(HEAP8[i10 + 177 >> 0] | 0)) {
  i5 = i10 + 228 | 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i6 = i10 + 300 | 0;
   i2 = i10 + 308 | 0;
   i3 = i10 + 304 | 0;
   i1 = 0;
   do {
    i4 = HEAP32[i10 + 232 + (i1 << 2) >> 2] | 0;
    if (!(HEAP32[i6 >> 2] | 0)) if (!(HEAP32[i2 >> 2] | 0)) _emit_dht(i10, HEAP32[i4 + 20 >> 2] | 0, 0);
    if (HEAP32[i3 >> 2] | 0) _emit_dht(i10, HEAP32[i4 + 24 >> 2] | 0, 1);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
  }
 }
 i4 = i10 + 188 | 0;
 i3 = i7 + 28 | 0;
 i9 = i10 + 24 | 0;
 if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = -1;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = -35;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = 0;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = 4;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = i2 >>> 8;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = i2;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i10 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
  }
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = -1;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i10 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = -38;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i10 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i10 | 0);
 }
 i8 = i10 + 228 | 0;
 i2 = (HEAP32[i8 >> 2] << 1) + 6 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i2 >>> 8;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i10 | 0);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i2;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i10 | 0);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i8 >> 2] & 255;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i7;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i10 | 0);
 }
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i1 = i10 + 300 | 0;
  i6 = i10 + 308 | 0;
  i7 = i10 + 304 | 0;
  i5 = 0;
  do {
   i3 = HEAP32[i10 + 232 + (i5 << 2) >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] & 255;
   i11 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i11 + 1;
   HEAP8[i11 >> 0] = i4;
   i11 = i2 + 4 | 0;
   i4 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
   HEAP32[i11 >> 2] = i4;
   if (!i4) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
    i11 = HEAP32[i10 >> 2] | 0;
    HEAP32[i11 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
   }
   if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i6 >> 2] | 0)) i4 = HEAP32[i3 + 20 >> 2] | 0; else i4 = 0; else i4 = 0;
   if (!(HEAP32[i7 >> 2] | 0)) i2 = 0; else i2 = HEAP32[i3 + 24 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i11 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i11 + 1;
   HEAP8[i11 >> 0] = i2 + (i4 << 4);
   i4 = i3 + 4 | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
   HEAP32[i4 >> 2] = i11;
   if (!i11) if (!((mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
    i11 = HEAP32[i10 >> 2] | 0;
    HEAP32[i11 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i8 >> 2] | 0));
 } else i1 = i10 + 300 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] & 255;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8 + 1;
 HEAP8[i8 >> 0] = i11;
 i8 = i2 + 4 | 0;
 i11 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i11;
 if (!i11) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i10 + 304 >> 2] & 255;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i8 + 1;
 HEAP8[i8 >> 0] = i11;
 i8 = i1 + 4 | 0;
 i11 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i11;
 if (!i11) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i11 = (HEAP32[i10 + 308 >> 2] << 4) + (HEAP32[i10 + 312 >> 2] | 0) & 255;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = i11;
 i9 = i1 + 4 | 0;
 i11 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i11;
 if (i11 | 0) return;
 if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24) return;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 + 20 >> 2] = 24;
 mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
 return;
}

function __ZN11CullResultsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 8 | 0;
 i3 = i5;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 i4 = i1;
 i6 = i4 + 76 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i1 + 76 >> 0] = 0;
 i4 = gb + 64024 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 96 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1 + 116 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 136 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1 + 156 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 176 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1 + 196 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 216 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1 + 236 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 256 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1 + 276 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAP32[i1 + 308 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 296 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = gb + 64024 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 312 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 328 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 316 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP8[i1 + 332 >> 0] = 0;
 i4 = i1 + 336 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i4 = gb + 64024 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 364 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAPF32[i1 + 1004 >> 2] = Math_fround(0.0);
 i4 = i1 + 1136 | 0;
 i6 = i4 + 60 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i1 + 1236 >> 2] = 0;
 HEAP32[i1 + 1240 >> 2] = 0;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAP32[i1 + 1260 >> 2] = 0;
 HEAP32[i1 + 1264 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 1252 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 1268 >> 2] = 0;
 HEAP32[i1 + 1280 >> 2] = 0;
 HEAP32[i1 + 1284 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 1272 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 1288 >> 2] = 0;
 HEAP32[i1 + 1300 >> 2] = 0;
 HEAP32[i1 + 1304 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 1292 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 1308 >> 2] = 0;
 HEAP32[i1 + 1312 >> 2] = 0;
 HEAP32[i1 + 1316 >> 2] = 0;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 1320 >> 2] = 0;
 HEAP32[i1 + 1332 >> 2] = 0;
 HEAP32[i1 + 1336 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 1324 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 1340 >> 2] = 0;
 HEAP32[i1 + 1352 >> 2] = 0;
 HEAP32[i1 + 1356 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i7 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 1344 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 1360 >> 2] = 0;
 HEAP32[i1 + 1364 >> 2] = -1;
 HEAP8[i1 + 1368 >> 0] = 0;
 HEAP32[i1 + 1372 >> 2] = 0;
 i6 = gb + 64024 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i1 + 116 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 136 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 156 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 176 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 196 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 216 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 236 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 256 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 276 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 296 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 STACKTOP = i5;
 return;
}

function __ZN8Material8TransferI14SafeBinaryReadEEvRT_(i14, i21) {
 i14 = i14 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 52 | 0;
 i15 = i23 + 48 | 0;
 i16 = i23 + 40 | 0;
 i22 = i23 + 24 | 0;
 i17 = i23 + 12 | 0;
 i18 = i23;
 __ZN14SafeBinaryRead10SetVersionEi(i21, 6);
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i14, i21);
 i2 = i14 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469700 | 0, gb + 479385 | 0, i20, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i2, i21); else {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i21 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i21);
 }
 i2 = i14 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469709 | 0, HEAP32[gb + 37260 >> 2] | 0, i20, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i21, i2, 1); else {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i21 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i21);
 }
 i4 = i14 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469726 | 0, HEAP32[gb + 37304 >> 2] | 0, i20, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i21 + 16 | 0;
   i13 = HEAP32[i21 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i21 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i21 + 36 >> 2] | 0, 0 - (HEAP32[i21 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i13 >>> 0) i19 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i21 + 24 >> 2] | 0) >>> 0) i19 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i19 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i21 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i21 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i21);
 }
 i4 = i14 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469742 | 0, HEAP32[gb + 37040 >> 2] | 0, i20, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i21 + 16 | 0;
   i13 = HEAP32[i21 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i21 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i21 + 36 >> 2] | 0, 0 - (HEAP32[i21 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i13 >>> 0) i19 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i21 + 24 >> 2] | 0) >>> 0) i19 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i19 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i21 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i21 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i21);
 }
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i22 + 12 >> 2] = 0;
 i13 = i22 + 4 | 0;
 HEAP32[i22 >> 2] = i13;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469762 | 0, HEAP32[gb + 37052 >> 2] | 0, i20, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i21, i22, 0); else {
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i22 | 0, i21 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i21);
 }
 i1 = i14 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 185) | 0;
  __ZN18SharedMaterialDataC2Ev(i2);
  HEAP32[i1 >> 2] = i2;
 }
 i1 = HEAP32[i2 + 176 >> 2] | 0;
 i12 = i2 + 180 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i1 = HEAP32[i22 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) != (i13 | 0)) {
  i10 = i2 + 176 | 0;
  i11 = i16 + 4 | 0;
  while (1) {
   i2 = i3 + 32 | 0;
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   if (i4 << 24 >> 24 < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i3 + 36 >> 2] | 0;
   } else i4 = i4 & 255;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i17 + 4 >> 2] = 0;
   HEAP32[i17 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i2, i4);
   i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17) | 0;
   i2 = i3 + 16 | 0;
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   if (i4 << 24 >> 24 < 0) {
    i5 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i3 + 20 >> 2] | 0;
   } else {
    i5 = i2;
    i2 = i4 & 255;
   };
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i5, i2);
   i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i18) | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[i12 >> 2] | 0;
   i2 = i8 - i3 >> 3;
   if (!i2) i2 = i3; else {
    i6 = i2;
    i2 = i3;
    while (1) {
     i24 = (i6 | 0) / 2 | 0;
     i5 = i3 + (i24 << 3) | 0;
     i4 = (HEAP32[i5 >> 2] | 0) < (i7 | 0);
     i5 = i5 + 8 | 0;
     i2 = i4 ? i5 : i2;
     i6 = i4 ? i6 + -1 - i24 | 0 : i24;
     if (!i6) break; else i3 = i4 ? i5 : i3;
    }
   }
   i3 = i2;
   if ((i2 | 0) == (i8 | 0)) i19 = 57; else if ((i7 | 0) < (HEAP32[i2 >> 2] | 0)) i19 = 57;
   if ((i19 | 0) == 57) {
    i19 = 0;
    HEAP32[i15 >> 2] = i3;
    HEAP32[i16 >> 2] = i7;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    i2 = __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i10, i20, i16) | 0;
   }
   HEAP32[i2 + 4 >> 2] = i9;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i13 | 0)) break; else {
    i1 = i2;
    i3 = i2;
   }
  }
 }
 i2 = i14 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 469844 | 0, gb + 469862 | 0, i20, 1) | 0;
 if (!i1) {
  i24 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i22, i24);
  STACKTOP = i23;
  return;
 }
 if ((i1 | 0) > 0) __ZN18UnityPropertySheet8TransferI14SafeBinaryReadEEvRT_(i2, i21); else {
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i21 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i21);
 i24 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i22, i24);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i16, i3, i1, i2, i4) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 8 | 0;
 i17 = i18;
 i2 = i4 << 2;
 i13 = i2 >>> 0 > 1024;
 i15 = i17 + 4 | 0;
 HEAP8[i15 >> 0] = i13 & 1;
 if (i13) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i18 + 20 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i17 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i17 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i13 = i4;
  i8 = 0;
  i4 = 0;
  L7 : while (1) {
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i12 = i4;
      break;
     }
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i16 + (i6 * 12 | 0) >> 2] | 0) >>> 0 < (HEAP32[i16 + (i5 * 12 | 0) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i11 = i16 + (i5 * 12 | 0) | 0;
       i12 = i16 + (i7 * 12 | 0) | 0;
       HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
       HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
       HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i12 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i12 << 2) >> 2] | 0;
    i8 = i12;
   }
   i4 = i16 + (((i3 + i12 | 0) / 2 | 0) * 12 | 0) | 0;
   i7 = i16 + (i12 * 12 | 0) | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i4 >> 2] | 0) >>> 0 < i5 >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i5 = HEAP32[i7 >> 2] | 0;
   }
   i9 = i16 + (i3 * 12 | 0) | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   if (i6 >>> 0 < i5 >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i5 = HEAP32[i9 >> 2] | 0;
   } else i5 = i6;
   if (i5 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   }
   i6 = i3 + -1 | 0;
   i11 = i16 + (i6 * 12 | 0) | 0;
   HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i4 = i12;
   while (1) {
    i9 = HEAP32[i11 >> 2] | 0;
    i7 = i4;
    while (1) {
     i5 = i7 + 1 | 0;
     i4 = i16 + (i5 * 12 | 0) | 0;
     if ((HEAP32[i4 >> 2] | 0) >>> 0 < i9 >>> 0) i7 = i5; else {
      i10 = i7;
      break;
     }
    }
    while (1) {
     i7 = i6 + -1 | 0;
     i6 = i16 + (i7 * 12 | 0) | 0;
     if (i9 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) i6 = i7; else break;
    }
    if ((i5 | 0) >= (i7 | 0)) break;
    HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    i4 = i5;
    i6 = i7;
   }
   HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   if ((i5 - i12 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i13 + -1 | 0) >>> 0) i4 = i13; else {
     i4 = i13 << 3;
     if (!i4) i5 = 0; else {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
      i5 = _PxGetFoundation() | 0;
      i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
      i5 = mftCall_iiiiii(i9 | 0, i11 | 0, i4 | 0, (i5 ? gb + 681780 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
     i2 = 1;
     i4 = i13 << 1;
     i1 = i5;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i12;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i10;
    i5 = i4;
    i4 = i10 + 2 | 0;
   } else {
    i5 = i10 + 2 | 0;
    if (i8 >>> 0 < (i13 + -1 | 0) >>> 0) i4 = i13; else {
     i4 = i13 << 3;
     if (!i4) i4 = 0; else {
      i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i7 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
      i11 = _PxGetFoundation() | 0;
      i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
      i4 = mftCall_iiiiii(i7 | 0, i9 | 0, i4 | 0, (i11 ? gb + 681780 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i13 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i5;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i12;
    i3 = i10;
   }
   i13 = i5;
   i8 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 STACKTOP = i18;
 return;
}

function __GLOBAL__sub_I_runtime_camera_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = gb + 1098e3 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[gb + 1110400 >> 2] = 0;
 HEAP32[gb + 1110400 + 4 >> 2] = 0;
 HEAP32[gb + 1110400 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110412 | 0, gb + 1017179 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110424 | 0, gb + 381866 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110436 | 0, gb + 374422 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110448 | 0, gb + 374445 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110460 | 0, gb + 442528 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110472 | 0, gb + 374461 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110484 | 0, gb + 374469 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110496 | 0, gb + 374491 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110508 | 0, gb + 374510 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110520 | 0, gb + 374533 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110532 | 0, gb + 374552 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110544 | 0, gb + 374578 | 0, 0, 0);
 HEAP32[gb + 1110556 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110556 | 0, gb + 386617 | 0);
 HEAP32[gb + 1110560 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110560 | 0, gb + 387779 | 0);
 HEAP32[gb + 1110564 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110564 | 0, gb + 386659 | 0);
 HEAP32[gb + 1110568 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110568 | 0, gb + 387806 | 0);
 HEAP32[gb + 1110572 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110572 | 0, gb + 374608 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110576 | 0, gb + 374620 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110588 | 0, gb + 374649 | 0, 0, 0);
 HEAP32[gb + 1110600 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110600 | 0, gb + 1046318 | 0);
 HEAP32[gb + 1110604 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110604 | 0, gb + 374662 | 0);
 HEAP32[gb + 1110608 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110608 | 0, gb + 374669 | 0);
 HEAP32[gb + 1110612 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110612 | 0, gb + 374676 | 0);
 HEAP32[gb + 1110616 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110616 | 0, gb + 374683 | 0);
 HEAP32[gb + 1110620 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110620 | 0, gb + 374691 | 0);
 HEAP32[gb + 1110624 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110624 | 0, gb + 374697 | 0);
 HEAP32[gb + 1110628 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110628 | 0, gb + 374703 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110632 | 0, gb + 374710 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110644 | 0, gb + 374729 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110656 | 0, gb + 374742 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110668 | 0, gb + 374763 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110680 | 0, gb + 374780 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110692 | 0, gb + 374798 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110704 | 0, gb + 374821 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110716 | 0, gb + 374842 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110728 | 0, gb + 374860 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110740 | 0, gb + 374888 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110752 | 0, gb + 374923 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110764 | 0, gb + 374952 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110776 | 0, gb + 374976 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110788 | 0, gb + 374991 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110800 | 0, gb + 375004 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110812 | 0, gb + 375017 | 0, 0, 0);
 HEAP32[gb + 1110296 >> 2] = 0;
 i3 = gb + 63536 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1110296 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1110296 + 12 >> 2] = 16;
 i1 = gb + 1110296 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(0, fb + 3315 | 0, 0, gb + 1110296 | 0);
 HEAP32[gb + 1110824 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110824 | 0, gb + 375035 | 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1110828 | 0, 13);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1110836 | 0, 13);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110844 | 0, gb + 375049 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110856 | 0, gb + 375061 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110868 | 0, gb + 375078 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110880 | 0, gb + 375098 | 0, 0, 0);
 HEAP32[gb + 1110892 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110892 | 0, gb + 1046318 | 0);
 HEAP32[gb + 1110896 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110896 | 0, gb + 375112 | 0);
 HEAP32[gb + 1110900 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110900 | 0, gb + 375135 | 0);
 HEAP32[gb + 1110904 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110904 | 0, gb + 375165 | 0);
 HEAP32[gb + 1110908 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1110908 | 0, gb + 375192 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544213 | 0, 0, fb + 3316 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1110388 | 0, gb + 375226 | 0, 0, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544214 | 0, fb + 3317 | 0, fb + 3318 | 0, -1, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544215 | 0, fb + 3319 | 0, fb + 3320 | 0, -1, 0);
 return;
}

function __ZN18UnityPropertySheet21AddNewSerializedPropsERKS_(i18, i16) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19;
 i1 = HEAP32[i16 + 12 >> 2] | 0;
 i11 = i16 + 16 | 0;
 if ((i1 | 0) != (i11 | 0)) {
  i12 = i18 + 12 | 0;
  i13 = i18 + 16 | 0;
  i14 = i13;
  i9 = i18 + 16 | 0;
  i10 = i18 + 20 | 0;
  i2 = i1;
  while (1) {
   i8 = i2 + 16 | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i7 = (i3 | 0) == 0;
   do if (i7) {
    i1 = HEAP32[i2 + 20 >> 2] | 0;
    i17 = 23;
   } else {
    i6 = HEAP32[i8 >> 2] | 0;
    i1 = i13;
    i5 = i3;
    L8 : while (1) {
     i4 = i5;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i4) break L8;
     }
     i5 = HEAP32[i4 >> 2] | 0;
     if (!i5) {
      i1 = i4;
      break;
     } else i1 = i4;
    }
    if ((i1 | 0) != (i13 | 0)) if ((i6 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) break;
    i1 = HEAP32[i2 + 20 >> 2] | 0;
    if (i7) i17 = 23; else {
     i6 = HEAP32[i8 >> 2] | 0;
     while (1) {
      i4 = HEAP32[i3 + 16 >> 2] | 0;
      if ((i6 | 0) < (i4 | 0)) {
       i4 = HEAP32[i3 >> 2] | 0;
       if (!i4) {
        i17 = 18;
        break;
       } else i3 = i4;
      } else {
       if ((i4 | 0) >= (i6 | 0)) {
        i17 = 24;
        break;
       }
       i5 = i3 + 4 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if (!i4) {
        i17 = 22;
        break;
       } else i3 = i4;
      }
     }
     if ((i17 | 0) == 18) {
      HEAP32[i15 >> 2] = i3;
      i7 = i3;
      i5 = i3;
      i4 = i8;
      i6 = i1;
      i17 = 25;
      break;
     } else if ((i17 | 0) == 22) {
      HEAP32[i15 >> 2] = i3;
      i7 = i3;
      i4 = i8;
      i6 = i1;
      i17 = 25;
      break;
     } else if ((i17 | 0) == 24) {
      HEAP32[i15 >> 2] = i3;
      if (!i3) {
       i7 = i3;
       i5 = i15;
       i4 = i8;
       i6 = i1;
       i17 = 25;
       break;
      } else {
       i17 = 28;
       break;
      }
     }
    }
   } while (0);
   if ((i17 | 0) == 23) {
    HEAP32[i15 >> 2] = i13;
    i7 = i14;
    i5 = i13;
    i4 = i8;
    i6 = i1;
    i17 = 25;
   }
   if ((i17 | 0) == 25) {
    i3 = __Znwj(24) | 0;
    HEAP32[i3 + 16 >> 2] = HEAP32[i4 >> 2];
    HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = i7;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
    if (!i1) i1 = i3; else {
     HEAP32[i12 >> 2] = i1;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    i1 = i6;
    i17 = 28;
   }
   if ((i17 | 0) == 28) {
    i17 = 0;
    HEAP32[i3 + 20 >> 2] = i1;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i11 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i16 + 24 >> 2] | 0;
 i9 = i16 + 28 | 0;
 if ((i1 | 0) != (i9 | 0)) {
  i10 = i18 + 24 | 0;
  i11 = i18 + 28 | 0;
  i12 = i11;
  i13 = i18 + 28 | 0;
  i14 = i18 + 32 | 0;
  i2 = i1;
  while (1) {
   i8 = i2 + 16 | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i6 = (i1 | 0) == 0;
   do if (i6) i17 = 54; else {
    i7 = HEAP32[i8 >> 2] | 0;
    i3 = i11;
    i5 = i1;
    L55 : while (1) {
     i4 = i5;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i7 | 0)) break;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i4) break L55;
     }
     i5 = HEAP32[i4 >> 2] | 0;
     if (!i5) {
      i3 = i4;
      break;
     } else i3 = i4;
    }
    if ((i3 | 0) != (i11 | 0)) if ((i7 | 0) >= (HEAP32[i3 + 16 >> 2] | 0)) break;
    if (i6) i17 = 54; else {
     i5 = HEAP32[i8 >> 2] | 0;
     while (1) {
      i3 = HEAP32[i1 + 16 >> 2] | 0;
      if ((i5 | 0) < (i3 | 0)) {
       i3 = HEAP32[i1 >> 2] | 0;
       if (!i3) {
        i17 = 49;
        break;
       } else i1 = i3;
      } else {
       if ((i3 | 0) >= (i5 | 0)) {
        i17 = 55;
        break;
       }
       i4 = i1 + 4 | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if (!i3) {
        i17 = 53;
        break;
       } else i1 = i3;
      }
     }
     if ((i17 | 0) == 49) {
      HEAP32[i15 >> 2] = i1;
      i5 = i1;
      i4 = i1;
      i3 = i8;
      i17 = 56;
      break;
     } else if ((i17 | 0) == 53) {
      HEAP32[i15 >> 2] = i1;
      i5 = i1;
      i3 = i8;
      i17 = 56;
      break;
     } else if ((i17 | 0) == 55) {
      HEAP32[i15 >> 2] = i1;
      if (!i1) {
       i5 = i1;
       i4 = i15;
       i3 = i8;
       i17 = 56;
       break;
      } else {
       i17 = 59;
       break;
      }
     }
    }
   } while (0);
   if ((i17 | 0) == 54) {
    HEAP32[i15 >> 2] = i11;
    i5 = i12;
    i4 = i11;
    i3 = i8;
    i17 = 56;
   }
   if ((i17 | 0) == 56) {
    i1 = __Znwj(36) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i5;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    if (!i3) i3 = i1; else {
     HEAP32[i10 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 >> 2] | 0, i3);
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
    i17 = 59;
   }
   if ((i17 | 0) == 59) {
    i17 = 0;
    i6 = HEAP32[i2 + 24 >> 2] | 0;
    i7 = HEAP32[i2 + 28 >> 2] | 0;
    i8 = HEAP32[i2 + 32 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = i6;
    HEAP32[i1 + 28 >> 2] = i7;
    HEAP32[i1 + 32 >> 2] = i8;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
  }
 }
 i2 = HEAP32[i16 >> 2] | 0;
 i7 = i16 + 4 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i19;
  return;
 }
 i8 = i18 + 4 | 0;
 while (1) {
  i5 = i2 + 16 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (!i3) i17 = 74; else {
   i6 = HEAP32[i5 >> 2] | 0;
   i1 = i8;
   L102 : while (1) {
    i4 = i3;
    while (1) {
     if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
     if (!i3) break L102; else i4 = i3;
    }
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i1 = i4;
     break;
    } else i1 = i4;
   }
   if ((i1 | 0) == (i8 | 0)) i17 = 74; else if ((i6 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i17 = 74;
  }
  if ((i17 | 0) == 74) {
   i17 = 0;
   i16 = __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i18, i5) | 0;
   i15 = i2 + 20 | 0;
   HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
 }
 STACKTOP = i19;
 return;
}

function __ZN13AnimationClip8GetRangeEv(i19, i16) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 12 | 0;
 i18 = i22 + 8 | 0;
 i15 = i22;
 HEAP32[i17 >> 2] = 2139095040;
 HEAP32[i18 >> 2] = -8388608;
 i20 = i16 + 264 | 0;
 if (Math_fround(HEAPF32[i20 >> 2]) == Math_fround(inf)) {
  i21 = i16 + 268 | 0;
  if (!(Math_fround(HEAPF32[i21 >> 2]) != Math_fround(-inf))) {
   if (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 116 >> 2] | 0, i16 | 0) | 0) {
    f3 = Math_fround(inf);
    i2 = 2139095040;
    f4 = Math_fround(-inf);
    i1 = -8388608;
   } else {
    i1 = HEAP32[i16 + 216 >> 2] | 0;
    if (!i1) {
     f3 = Math_fround(inf);
     i2 = 2139095040;
     f4 = Math_fround(-inf);
     i1 = -8388608;
    } else {
     i2 = HEAP32[i1 + 1064 >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     i1 = HEAP32[i1 + 1068 >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    }
   }
   i5 = HEAP32[i16 + 100 >> 2] | 0;
   i8 = i16 + 104 | 0;
   if ((i5 | 0) != (HEAP32[i8 >> 2] | 0)) {
    i6 = i15 + 4 | 0;
    do {
     __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i15, i5 + 16 | 0);
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = f13 < Math_fround(HEAPF32[i15 >> 2]);
     i2 = HEAP32[(i2 ? i17 : i15) >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     f13 = Math_fround(HEAPF32[i6 >> 2]);
     i1 = f13 < Math_fround(HEAPF32[i18 >> 2]);
     i1 = HEAP32[(i1 ? i18 : i6) >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     i5 = i5 + 204 | 0;
    } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i5 = HEAP32[i16 + 116 >> 2] | 0;
   i8 = i16 + 120 | 0;
   if ((i5 | 0) != (HEAP32[i8 >> 2] | 0)) {
    i6 = i15 + 4 | 0;
    do {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i15, i5 + 16 | 0);
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = f13 < Math_fround(HEAPF32[i15 >> 2]);
     i2 = HEAP32[(i2 ? i17 : i15) >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     f13 = Math_fround(HEAPF32[i6 >> 2]);
     i1 = f13 < Math_fround(HEAPF32[i18 >> 2]);
     i1 = HEAP32[(i1 ? i18 : i6) >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     i5 = i5 + 172 | 0;
    } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i5 = HEAP32[i16 + 132 >> 2] | 0;
   i8 = i16 + 136 | 0;
   if ((i5 | 0) != (HEAP32[i8 >> 2] | 0)) {
    i6 = i15 + 4 | 0;
    do {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i15, i5 + 16 | 0);
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = f13 < Math_fround(HEAPF32[i15 >> 2]);
     i2 = HEAP32[(i2 ? i17 : i15) >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     f13 = Math_fround(HEAPF32[i6 >> 2]);
     i1 = f13 < Math_fround(HEAPF32[i18 >> 2]);
     i1 = HEAP32[(i1 ? i18 : i6) >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     i5 = i5 + 172 | 0;
    } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i5 = HEAP32[i16 + 148 >> 2] | 0;
   i8 = i16 + 152 | 0;
   if ((i5 | 0) != (HEAP32[i8 >> 2] | 0)) {
    i6 = i15 + 4 | 0;
    do {
     __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i15, i5 + 16 | 0);
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = f13 < Math_fround(HEAPF32[i15 >> 2]);
     i2 = HEAP32[(i2 ? i17 : i15) >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     f13 = Math_fround(HEAPF32[i6 >> 2]);
     i1 = f13 < Math_fround(HEAPF32[i18 >> 2]);
     i1 = HEAP32[(i1 ? i18 : i6) >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     i5 = i5 + 172 | 0;
    } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i5 = HEAP32[i16 + 164 >> 2] | 0;
   i8 = i16 + 168 | 0;
   if ((i5 | 0) == (HEAP32[i8 >> 2] | 0)) f13 = f4; else {
    i6 = i15 + 4 | 0;
    do {
     __ZNK17AnimationCurveTplIfE8GetRangeEv(i15, i5 + 40 | 0);
     f13 = Math_fround(HEAPF32[i17 >> 2]);
     i2 = f13 < Math_fround(HEAPF32[i15 >> 2]);
     i2 = HEAP32[(i2 ? i17 : i15) >> 2] | 0;
     HEAP32[i17 >> 2] = i2;
     f13 = Math_fround(HEAPF32[i6 >> 2]);
     i1 = f13 < Math_fround(HEAPF32[i18 >> 2]);
     i1 = HEAP32[(i1 ? i18 : i6) >> 2] | 0;
     HEAP32[i18 >> 2] = i1;
     i5 = i5 + 132 | 0;
    } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
    f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i5 = HEAP32[i16 + 180 >> 2] | 0;
   i8 = HEAP32[i16 + 184 >> 2] | 0;
   if ((i5 | 0) == (i8 | 0)) {
    f7 = f3;
    f10 = f3;
    f9 = f13;
    f4 = f13;
    f3 = f13;
   } else {
    i14 = i16 + 88 | 0;
    f7 = f3;
    f10 = f3;
    f11 = f3;
    f9 = f13;
    f12 = f13;
    f4 = f13;
    f3 = f13;
    do {
     i6 = HEAP32[i5 + 52 >> 2] | 0;
     if (i6) {
      i1 = HEAP32[i5 + 40 >> 2] | 0;
      i2 = f11 < Math_fround(HEAPF32[i1 >> 2]);
      i2 = HEAP32[(i2 ? i17 : i1) >> 2] | 0;
      HEAP32[i17 >> 2] = i2;
      f11 = Math_fround(HEAPF32[i1 + (i6 + -1 << 3) >> 2]);
      f11 = Math_fround(f11 + Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i14 >> 2])));
      HEAPF32[i15 >> 2] = f11;
      i1 = HEAP32[(f11 < f12 ? i18 : i15) >> 2] | 0;
      HEAP32[i18 >> 2] = i1;
      f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f7 = f11;
      f10 = f11;
      f9 = f3;
      f12 = f3;
      f4 = f3;
     }
     i5 = i5 + 60 | 0;
    } while ((i5 | 0) != (i8 | 0));
   }
   i5 = HEAP32[i16 + 196 >> 2] | 0;
   i6 = HEAP32[i16 + 200 >> 2] | 0;
   if ((i5 | 0) != (i6 | 0)) {
    i1 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i6 + -64 >> 2] | 0;
    if ((i1 & 2139095040 | 0) == 2139095040) f3 = f10; else {
     f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f3 = f10 < f3 ? f10 : f3;
    }
    HEAPF32[i17 >> 2] = f3;
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    if ((i5 & 2139095040 | 0) != 2139095040) {
     f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = f4 < f9 ? f9 : f4;
    }
    HEAPF32[i18 >> 2] = f4;
    f7 = f3;
    f3 = f4;
    i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   }
   i16 = f7 == Math_fround(inf);
   if (i16 & f3 == Math_fround(-inf)) {
    HEAP32[i17 >> 2] = 0;
    HEAP32[i18 >> 2] = 1065353216;
    i2 = 0;
    i1 = 1065353216;
   }
   HEAP32[i20 >> 2] = i2;
   HEAP32[i21 >> 2] = i1;
   i18 = i20;
   i20 = HEAP32[i18 + 4 >> 2] | 0;
   i21 = i19;
   HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   STACKTOP = i22;
   return;
  }
 }
 i18 = i20;
 i20 = HEAP32[i18 + 4 >> 2] | 0;
 i21 = i19;
 HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 STACKTOP = i22;
 return;
}

function __ZNK16ParticleAnimator15UpdateParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i5, i25, i28, f29) {
 i5 = i5 | 0;
 i25 = i25 | 0;
 i28 = i28 | 0;
 f29 = Math_fround(f29);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f26 = f0, f27 = f0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i32;
 f31 = Math_fround(Math_fround(HEAPF32[i5 + 68 >> 2]) * f29);
 f26 = Math_fround(Math_fround(HEAPF32[i5 + 72 >> 2]) * f29);
 f27 = Math_fround(Math_fround(HEAPF32[i5 + 76 >> 2]) * f29);
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!(HEAP8[i28 + 36 >> 0] | 0)) {
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i30, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0, i5 + 32 | 0);
  f4 = Math_fround(HEAPF32[i30 >> 2]);
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i5 + 44 >> 2]));
  f3 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 48 >> 2]));
  f2 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i5 + 52 >> 2]));
 } else {
  __ZNK9Transform18TransformDirectionERK8Vector3f(i30, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0, i5 + 44 | 0);
  f4 = Math_fround(HEAPF32[i5 + 32 >> 2]);
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i30 >> 2]));
  f3 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i30 + 4 >> 2]));
  f2 = Math_fround(HEAPF32[i5 + 40 >> 2]);
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i30 + 8 >> 2]));
 }
 f24 = Math_fround(f2 * f29);
 f23 = Math_fround(f3 * f29);
 f3 = Math_fround(f4 * f29);
 f4 = Math_fround(+Math_pow(+Math_fround(HEAPF32[i5 + 80 >> 2]), +f29));
 f18 = Math_fround(Math_fround(HEAPF32[i5 + 56 >> 2]) * f29);
 f19 = Math_fround(Math_fround(HEAPF32[i5 + 60 >> 2]) * f29);
 f20 = Math_fround(Math_fround(HEAPF32[i5 + 64 >> 2]) * f29);
 HEAP32[i30 >> 2] = HEAP32[i5 + 104 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i5 + 100 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i5 + 96 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i5 + 92 >> 2];
 HEAP32[i30 + 16 >> 2] = HEAP32[i5 + 88 >> 2];
 f21 = Math_fround(+Math_pow(+Math_fround(Math_fround(HEAPF32[i5 + 84 >> 2]) + Math_fround(1.0)), +f29));
 f22 = Math_fround(Math_fround(4.0) - Math_fround(HEAPF32[gb + 62452 >> 2]));
 i11 = (HEAP8[i5 + 112 >> 0] | 0) == 0;
 i12 = i25 + 4 | 0;
 i1 = (HEAP32[i12 >> 2] | 0) - (HEAP32[i25 >> 2] | 0) | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i32;
  return;
 }
 i13 = i28 + 4 | 0;
 i14 = i28 + 8 | 0;
 i15 = i28 + 12 | 0;
 i16 = i28 + 16 | 0;
 i17 = i28 + 20 | 0;
 i1 = (i1 >>> 0) / 48 | 0;
 i5 = 0;
 L8 : while (1) {
  while (1) {
   i10 = HEAP32[i25 >> 2] | 0;
   i9 = i10 + (i5 * 48 | 0) + 36 | 0;
   f2 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f29);
   HEAPF32[i9 >> 2] = f2;
   if (!(f2 <= Math_fround(0.0))) break;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i10 + (i5 * 48 | 0) | 0;
   i8 = i6 + -48 | 0;
   i9 = i7 + 44 | 0;
   do {
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    i7 = i7 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i7 | 0) < (i9 | 0));
   HEAP32[i10 + (i5 * 48 | 0) + 44 >> 2] = HEAP32[i6 + -4 >> 2];
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -48;
   i1 = i1 + -1 | 0;
   if ((i5 | 0) >= (i1 | 0)) {
    i1 = 12;
    break L8;
   }
  }
  if (!i11) {
   f2 = Math_fround(f2 * Math_fround(4.0));
   f2 = Math_fround(f2 / Math_fround(HEAPF32[i10 + (i5 * 48 | 0) + 40 >> 2]));
   f2 = f22 < f2 ? f22 : f2;
   i8 = ~~f2 >>> 0;
   i7 = ~~Math_fround(Math_fround(Math_fround(f2 - Math_fround(i8 | 0)) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i9 = HEAP32[i30 + (i8 << 2) >> 2] | 0;
   i6 = i9 & 16711935;
   i8 = HEAP32[i30 + (i8 + 1 << 2) >> 2] | 0;
   i9 = i9 & -16711936;
   HEAP32[i10 + (i5 * 48 | 0) + 44 >> 2] = ((Math_imul(i7, (i8 & 16711935) - i6 | 0) | 0) >>> 8) + i6 & 16711935 | (Math_imul(i7, (i8 >>> 8 & 16711935) - (i9 >>> 8) | 0) | 0) + i9 & -16711936;
  }
  i9 = i10 + (i5 * 48 | 0) + 12 | 0;
  f36 = Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2]));
  i8 = i10 + (i5 * 48 | 0) + 16 | 0;
  f2 = Math_fround(f4 * Math_fround(HEAPF32[i8 >> 2]));
  i7 = i10 + (i5 * 48 | 0) + 20 | 0;
  f36 = Math_fround(f31 + f36);
  f2 = Math_fround(f26 + f2);
  f35 = Math_fround(f27 + Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2])));
  i38 = HEAP32[gb + 1477060 >> 2] | 0;
  i38 = i38 << 11 ^ i38;
  i6 = HEAP32[gb + 1477064 >> 2] | 0;
  i39 = HEAP32[gb + 1477068 >> 2] | 0;
  i41 = HEAP32[gb + 1477072 >> 2] | 0;
  i38 = i38 >>> 8 ^ i38 ^ i41;
  i40 = i38 ^ i41 >>> 19;
  f33 = Math_fround(Math_fround((i40 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f33 = Math_fround(Math_fround(f18 * Math_fround(Math_fround(1.0) - f33)) - Math_fround(f18 * f33));
  i6 = i6 << 11 ^ i6;
  i6 = i6 >>> 8 ^ i6 ^ i40;
  i38 = i6 ^ i38 >>> 19;
  f34 = Math_fround(Math_fround((i38 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f34 = Math_fround(Math_fround(f19 * Math_fround(Math_fround(1.0) - f34)) - Math_fround(f19 * f34));
  i39 = i39 << 11 ^ i39;
  HEAP32[gb + 1477060 >> 2] = i41;
  HEAP32[gb + 1477064 >> 2] = i40;
  HEAP32[gb + 1477068 >> 2] = i38;
  i6 = i39 >>> 8 ^ i39 ^ i38 ^ i6 >>> 19;
  HEAP32[gb + 1477072 >> 2] = i6;
  f37 = Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f33 = Math_fround(f36 + f33);
  f34 = Math_fround(f2 + f34);
  f37 = Math_fround(f35 + Math_fround(Math_fround(f20 * Math_fround(Math_fround(1.0) - f37)) - Math_fround(f20 * f37)));
  f35 = Math_fround(Math_fround(f24 * f33) - Math_fround(f3 * f37));
  f2 = Math_fround(Math_fround(f3 * f34) - Math_fround(f23 * f33));
  f33 = Math_fround(f33 + Math_fround(Math_fround(f23 * f37) - Math_fround(f24 * f34)));
  HEAPF32[i9 >> 2] = f33;
  f35 = Math_fround(f34 + f35);
  HEAPF32[i8 >> 2] = f35;
  f37 = Math_fround(f2 + f37);
  HEAPF32[i7 >> 2] = f37;
  f33 = Math_fround(f33 * f29);
  f35 = Math_fround(f35 * f29);
  f37 = Math_fround(f37 * f29);
  i7 = i10 + (i5 * 48 | 0) | 0;
  f33 = Math_fround(f33 + Math_fround(HEAPF32[i7 >> 2]));
  HEAPF32[i7 >> 2] = f33;
  i8 = i10 + (i5 * 48 | 0) + 4 | 0;
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i8 >> 2] = f35;
  i9 = i10 + (i5 * 48 | 0) + 8 | 0;
  f37 = Math_fround(f37 + Math_fround(HEAPF32[i9 >> 2]));
  HEAPF32[i9 >> 2] = f37;
  i6 = i10 + (i5 * 48 | 0) + 24 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f21 * Math_fround(HEAPF32[i6 >> 2]));
  f2 = Math_fround(HEAPF32[i28 >> 2]);
  f34 = Math_fround(HEAPF32[i13 >> 2]);
  f36 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i28 >> 2] = f33 < f2 ? f33 : f2;
  HEAPF32[i13 >> 2] = f35 < f34 ? f35 : f34;
  HEAPF32[i14 >> 2] = f37 < f36 ? f37 : f36;
  f36 = Math_fround(HEAPF32[i15 >> 2]);
  f37 = Math_fround(HEAPF32[i7 >> 2]);
  f34 = Math_fround(HEAPF32[i16 >> 2]);
  f35 = Math_fround(HEAPF32[i8 >> 2]);
  f2 = Math_fround(HEAPF32[i17 >> 2]);
  f33 = Math_fround(HEAPF32[i9 >> 2]);
  HEAPF32[i15 >> 2] = f36 < f37 ? f37 : f36;
  HEAPF32[i16 >> 2] = f34 < f35 ? f35 : f34;
  HEAPF32[i17 >> 2] = f2 < f33 ? f33 : f2;
  f2 = Math_fround(Math_fround(HEAPF32[i10 + (i5 * 48 | 0) + 32 >> 2]) * f29);
  i10 = i10 + (i5 * 48 | 0) + 28 | 0;
  HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f2);
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (i1 | 0)) {
   i1 = 12;
   break;
  }
 }
 if ((i1 | 0) == 12) {
  STACKTOP = i32;
  return;
 }
}

function ___rem_pio2_large(i18, i29, i22, i19, i26) {
 i18 = i18 | 0;
 i29 = i29 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i26 = i26 | 0;
 var d1 = 0.0, d2 = 0.0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i30 + 480 | 0;
 i20 = i30 + 320 | 0;
 i28 = i30 + 160 | 0;
 i27 = i30;
 i25 = HEAP32[gb + 206728 + (i26 << 2) >> 2] | 0;
 i9 = i19 + -1 | 0;
 i17 = (i22 + -3 | 0) / 24 | 0;
 i17 = (i17 | 0) < 0 ? 0 : i17;
 i21 = Math_imul(i17, -24) | 0;
 i3 = i22 + -24 + i21 | 0;
 if ((i25 + i9 | 0) >= 0) {
  i7 = i25 + i19 | 0;
  i5 = i17 - i9 | 0;
  i6 = 0;
  while (1) {
   if ((i5 | 0) < 0) d1 = 0.0; else d1 = +(HEAP32[gb + 206744 + (i5 << 2) >> 2] | 0);
   HEAPF64[i20 + (i6 << 3) >> 3] = d1;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i7 | 0)) break; else i5 = i5 + 1 | 0;
  }
 }
 i8 = (i19 | 0) > 0;
 i7 = 0;
 while (1) {
  if (i8) {
   i6 = i7 + i9 | 0;
   d1 = 0.0;
   i5 = 0;
   do {
    d1 = d1 + +HEAPF64[i18 + (i5 << 3) >> 3] * +HEAPF64[i20 + (i6 - i5 << 3) >> 3];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i19 | 0));
  } else d1 = 0.0;
  HEAPF64[i27 + (i7 << 3) >> 3] = d1;
  if ((i7 | 0) < (i25 | 0)) i7 = i7 + 1 | 0; else break;
 }
 i12 = (i3 | 0) > 0;
 i13 = 24 - i3 | 0;
 i14 = 23 - i3 | 0;
 i15 = (i19 | 0) > 0;
 i16 = (i3 | 0) == 0;
 i5 = i25;
 L17 : while (1) {
  d1 = +HEAPF64[i27 + (i5 << 3) >> 3];
  i8 = (i5 | 0) > 0;
  if (i8) {
   i6 = i5;
   i7 = 0;
   while (1) {
    d4 = +(~~(d1 * 5.9604644775390625e-08) | 0);
    HEAP32[i24 + (i7 << 2) >> 2] = ~~(d1 - d4 * 16777216.0);
    i11 = i6;
    i6 = i6 + -1 | 0;
    d1 = d4 + +HEAPF64[i27 + (i6 << 3) >> 3];
    if ((i11 | 0) <= 1) break; else i7 = i7 + 1 | 0;
   }
  }
  d1 = +_scalbn(d1, i3);
  d1 = d1 - +Math_floor(+(d1 * .125)) * 8.0;
  i6 = ~~d1;
  d1 = d1 - +(i6 | 0);
  do if (i12) {
   i11 = i24 + (i5 + -1 << 2) | 0;
   i7 = HEAP32[i11 >> 2] | 0;
   i23 = i7 >> i13;
   i7 = i7 - (i23 << i13) | 0;
   HEAP32[i11 >> 2] = i7;
   i7 = i7 >> i14;
   i6 = i23 + i6 | 0;
   i23 = 19;
  } else if (i16) {
   i7 = HEAP32[i24 + (i5 + -1 << 2) >> 2] >> 23;
   i23 = 19;
   break;
  } else if (!(d1 >= .5)) {
   i9 = 0;
   i11 = i6;
   break;
  } else {
   i7 = 2;
   i23 = 20;
   break;
  } while (0);
  if ((i23 | 0) == 19) {
   i23 = 0;
   if ((i7 | 0) > 0) i23 = 20; else {
    i9 = i7;
    i11 = i6;
   }
  }
  if ((i23 | 0) == 20) {
   i23 = 0;
   i11 = i6 + 1 | 0;
   if (i8) {
    i6 = 0;
    i10 = 0;
    do {
     i8 = i24 + (i10 << 2) | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     if (!i6) if (!i9) i6 = 0; else {
      HEAP32[i8 >> 2] = 16777216 - i9;
      i6 = 1;
     } else HEAP32[i8 >> 2] = 16777215 - i9;
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i5 | 0));
   } else i6 = 0;
   L42 : do if (i12) switch (i3 | 0) {
   case 1:
    {
     i10 = i24 + (i5 + -1 << 2) | 0;
     HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & 8388607;
     break L42;
    }
   case 2:
    {
     i10 = i24 + (i5 + -1 << 2) | 0;
     HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & 4194303;
     break L42;
    }
   default:
    break L42;
   } while (0);
   if ((i7 | 0) == 2) {
    d1 = 1.0 - d1;
    if (!i6) i9 = 2; else {
     i9 = 2;
     d1 = d1 - +_scalbn(1.0, i3);
    }
   } else i9 = i7;
  }
  if (!(d1 == 0.0)) {
   i23 = 43;
   break;
  }
  if ((i5 | 0) > (i25 | 0)) {
   i6 = 0;
   i7 = i5;
   do {
    i7 = i7 + -1 | 0;
    i6 = HEAP32[i24 + (i7 << 2) >> 2] | i6;
   } while ((i7 | 0) > (i25 | 0));
   if (!i6) i6 = 1; else {
    i23 = 42;
    break;
   }
  } else i6 = 1;
  while (1) if (!(HEAP32[i24 + (i25 - i6 << 2) >> 2] | 0)) i6 = i6 + 1 | 0; else break;
  i8 = i6 + i5 | 0;
  if ((i6 | 0) <= 0) {
   i5 = i8;
   continue;
  }
  while (1) {
   i7 = i5 + 1 | 0;
   i6 = i5 + i19 | 0;
   HEAPF64[i20 + (i6 << 3) >> 3] = +(HEAP32[gb + 206744 + (i7 + i17 << 2) >> 2] | 0);
   if (i15) {
    d1 = 0.0;
    i5 = 0;
    do {
     d1 = d1 + +HEAPF64[i18 + (i5 << 3) >> 3] * +HEAPF64[i20 + (i6 - i5 << 3) >> 3];
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i19 | 0));
   } else d1 = 0.0;
   HEAPF64[i27 + (i7 << 3) >> 3] = d1;
   if ((i7 | 0) < (i8 | 0)) i5 = i7; else {
    i5 = i8;
    continue L17;
   }
  }
 }
 do if ((i23 | 0) == 42) while (1) {
  i3 = i3 + -24 | 0;
  i5 = i5 + -1 | 0;
  if (!(HEAP32[i24 + (i5 << 2) >> 2] | 0)) i23 = 42; else {
   i8 = i5;
   break;
  }
 } else if ((i23 | 0) == 43) {
  d1 = +_scalbn(d1, 0 - i3 | 0);
  if (!(d1 >= 16777216.0)) {
   HEAP32[i24 + (i5 << 2) >> 2] = ~~d1;
   i8 = i5;
   break;
  } else {
   i3 = ~~(d1 * 5.9604644775390625e-08);
   HEAP32[i24 + (i5 << 2) >> 2] = ~~(d1 - +(i3 | 0) * 16777216.0);
   i8 = i5 + 1 | 0;
   HEAP32[i24 + (i8 << 2) >> 2] = i3;
   i3 = i21 + i22 | 0;
   break;
  }
 } while (0);
 i7 = (i8 | 0) > -1;
 if (i7) {
  d1 = +_scalbn(1.0, i3);
  i3 = i8;
  while (1) {
   HEAPF64[i27 + (i3 << 3) >> 3] = d1 * +(HEAP32[i24 + (i3 << 2) >> 2] | 0);
   if ((i3 | 0) > 0) {
    d1 = d1 * 5.9604644775390625e-08;
    i3 = i3 + -1 | 0;
   } else break;
  }
  if (i7) {
   i5 = i8;
   while (1) {
    i6 = i8 - i5 | 0;
    i3 = 0;
    d1 = 0.0;
    while (1) {
     d1 = d1 + +HEAPF64[gb + 4224 + (i3 << 3) >> 3] * +HEAPF64[i27 + (i3 + i5 << 3) >> 3];
     if ((i3 | 0) >= (i25 | 0) | (i3 | 0) >= (i6 | 0)) break; else i3 = i3 + 1 | 0;
    }
    HEAPF64[i28 + (i6 << 3) >> 3] = d1;
    if ((i5 | 0) > 0) i5 = i5 + -1 | 0; else break;
   }
  }
 }
 L84 : do switch (i26 | 0) {
 case 0:
  {
   if (i7) {
    d1 = 0.0;
    i3 = i8;
    while (1) {
     d1 = d1 + +HEAPF64[i28 + (i3 << 3) >> 3];
     if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
    }
   } else d1 = 0.0;
   HEAPF64[i29 >> 3] = (i9 | 0) == 0 ? d1 : -d1;
   break;
  }
 case 2:
 case 1:
  {
   if (i7) {
    d1 = 0.0;
    i3 = i8;
    while (1) {
     d1 = d1 + +HEAPF64[i28 + (i3 << 3) >> 3];
     if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
    }
   } else d1 = 0.0;
   i5 = (i9 | 0) == 0;
   HEAPF64[i29 >> 3] = i5 ? d1 : -d1;
   d1 = +HEAPF64[i28 >> 3] - d1;
   if ((i8 | 0) >= 1) {
    i3 = 1;
    while (1) {
     d1 = d1 + +HEAPF64[i28 + (i3 << 3) >> 3];
     if ((i3 | 0) == (i8 | 0)) break; else i3 = i3 + 1 | 0;
    }
   }
   HEAPF64[i29 + 8 >> 3] = i5 ? d1 : -d1;
   break;
  }
 case 3:
  {
   if ((i8 | 0) > 0) {
    i3 = i8;
    d1 = +HEAPF64[i28 + (i8 << 3) >> 3];
    do {
     i27 = i3;
     i3 = i3 + -1 | 0;
     i26 = i28 + (i3 << 3) | 0;
     d4 = +HEAPF64[i26 >> 3];
     d2 = d1;
     d1 = d4 + d1;
     HEAPF64[i28 + (i27 << 3) >> 3] = d2 + (d4 - d1);
     HEAPF64[i26 >> 3] = d1;
    } while ((i27 | 0) > 1);
    i5 = (i8 | 0) > 1;
    if (i5) {
     i3 = i8;
     d1 = +HEAPF64[i28 + (i8 << 3) >> 3];
     do {
      i26 = i3;
      i3 = i3 + -1 | 0;
      i27 = i28 + (i3 << 3) | 0;
      d4 = +HEAPF64[i27 >> 3];
      d2 = d1;
      d1 = d4 + d1;
      HEAPF64[i28 + (i26 << 3) >> 3] = d2 + (d4 - d1);
      HEAPF64[i27 >> 3] = d1;
     } while ((i3 | 0) > 1);
     if (i5) {
      i3 = i8;
      d1 = 0.0;
      do {
       d1 = d1 + +HEAPF64[i28 + (i3 << 3) >> 3];
       i3 = i3 + -1 | 0;
      } while ((i3 | 0) > 1);
     } else d1 = 0.0;
    } else d1 = 0.0;
   } else d1 = 0.0;
   d4 = +HEAPF64[i28 >> 3];
   d2 = +HEAPF64[i28 + 8 >> 3];
   if (!i9) {
    HEAPF64[i29 >> 3] = d4;
    HEAPF64[i29 + 8 >> 3] = d2;
    HEAPF64[i29 + 16 >> 3] = d1;
    break L84;
   } else {
    HEAPF64[i29 >> 3] = -d4;
    HEAPF64[i29 + 8 >> 3] = -d2;
    HEAPF64[i29 + 16 >> 3] = -d1;
    break L84;
   }
  }
 default:
  {}
 } while (0);
 STACKTOP = i30;
 return i11 & 7 | 0;
}

function __ZN5physxL18testPolyFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(i36, i37, i38, i7, i4, i9, i45, i44, i43, i46) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i45 = i45 | 0;
 i44 = i44 | 0;
 i43 = i43 | 0;
 i46 = i46 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, f6 = f0, f8 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i47 = 0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, i54 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i47 + 24 | 0;
 i23 = i47 + 12 | 0;
 i11 = i47;
 i5 = HEAP32[i43 >> 2] | 0;
 i39 = i43 + 4 | 0;
 i10 = HEAP32[i39 >> 2] | 0;
 i40 = i43 + 8 | 0;
 i3 = HEAP32[i40 >> 2] | 0;
 i41 = i43 + 12 | 0;
 f2 = Math_fround(HEAPF32[i41 >> 2]);
 i1 = (i36 | 0) == 0;
 L1 : do if (!(HEAP8[i4 + 44 >> 0] | 0)) if (i1) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  i4 = i10;
  i1 = 0;
 } else {
  i4 = HEAP32[i4 + 40 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i4 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f31 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f32 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f33 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f34 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  f35 = Math_fround(HEAPF32[i4 + 40 >> 2]);
  i4 = HEAP32[i7 + 48 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i4 + 96 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 100 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 104 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 112 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 116 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f24 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 136 >> 2]);
  f16 = Math_fround(HEAPF32[i9 >> 2]);
  f15 = Math_fround(3402823469999999843913219.0e14);
  i4 = i10;
  i1 = 0;
  i7 = 0;
  while (1) {
   i23 = HEAPU8[i37 + (i7 * 20 | 0) + 19 >> 0] | 0;
   f53 = Math_fround(HEAPF32[i38 + (i23 * 12 | 0) >> 2]);
   f48 = Math_fround(HEAPF32[i38 + (i23 * 12 | 0) + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i38 + (i23 * 12 | 0) + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i37 + (i7 * 20 | 0) + 12 >> 2]);
   f52 = Math_fround(HEAPF32[i37 + (i7 * 20 | 0) >> 2]);
   f51 = Math_fround(HEAPF32[i37 + (i7 * 20 | 0) + 4 >> 2]);
   f50 = Math_fround(HEAPF32[i37 + (i7 * 20 | 0) + 8 >> 2]);
   f12 = Math_fround(Math_fround(Math_fround(f52 * f27) + Math_fround(f51 * f28)) + Math_fround(f50 * f29));
   f13 = Math_fround(Math_fround(Math_fround(f52 * f30) + Math_fround(f51 * f31)) + Math_fround(f50 * f32));
   f14 = Math_fround(Math_fround(Math_fround(f52 * f33) + Math_fround(f51 * f34)) + Math_fround(f50 * f35));
   f49 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)) + Math_fround(f14 * f14)))));
   f50 = Math_fround(Math_fround(Math_fround(Math_fround(f53 * f52) + Math_fround(f48 * f51)) + Math_fround(f6 * f50)) * f49);
   f8 = Math_fround(f8 * f49);
   f12 = Math_fround(f12 * f49);
   f13 = Math_fround(f13 * f49);
   f14 = Math_fround(f49 * f14);
   f49 = Math_fround(Math_fround(Math_fround(f12 * f17) + Math_fround(f13 * f18)) + Math_fround(f14 * f19));
   f6 = Math_fround(Math_fround(Math_fround(f12 * f20) + Math_fround(f13 * f21)) + Math_fround(f14 * f22));
   f51 = Math_fround(Math_fround(Math_fround(f12 * f24) + Math_fround(f13 * f25)) + Math_fround(f14 * f26));
   i23 = f6 > f51;
   f48 = i23 ? f6 : f51;
   f6 = i23 ? f51 : f6;
   f6 = f49 > f6 ? f6 : f49;
   if (f6 > Math_fround(f16 - f8) ? 1 : f50 > Math_fround(f16 + (f49 > f48 ? f49 : f48))) {
    i1 = 0;
    break;
   }
   f6 = Math_fround(Math_fround(-f8) - f6);
   if (f15 > f6) {
    HEAP32[i42 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i42 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i42 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(0.0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = i7;
   } else f6 = f15;
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 >= i36 >>> 0) break L1; else f15 = f6;
  }
  STACKTOP = i47;
  return i1 | 0;
 } else if (i1) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  i4 = i10;
  i1 = 0;
 } else {
  i4 = HEAP32[i7 + 48 >> 2] | 0;
  f14 = Math_fround(HEAPF32[i4 + 96 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 100 >> 2]);
  f16 = Math_fround(HEAPF32[i4 + 104 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 112 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + 116 >> 2]);
  f19 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f20 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 136 >> 2]);
  f13 = Math_fround(HEAPF32[i9 >> 2]);
  f12 = Math_fround(3402823469999999843913219.0e14);
  i4 = i10;
  i1 = 0;
  i11 = 0;
  while (1) {
   i10 = HEAPU8[i37 + (i11 * 20 | 0) + 19 >> 0] | 0;
   f50 = Math_fround(HEAPF32[i38 + (i10 * 12 | 0) >> 2]);
   f52 = Math_fround(HEAPF32[i38 + (i10 * 12 | 0) + 4 >> 2]);
   f51 = Math_fround(HEAPF32[i38 + (i10 * 12 | 0) + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i37 + (i11 * 20 | 0) + 12 >> 2]);
   i10 = HEAP32[i37 + (i11 * 20 | 0) >> 2] | 0;
   i9 = HEAP32[i37 + (i11 * 20 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i37 + (i11 * 20 | 0) + 8 >> 2] | 0;
   f49 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f50 = Math_fround(f50 * f49);
   f53 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f52 = Math_fround(f50 + Math_fround(f52 * f53));
   f50 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f51 = Math_fround(f52 + Math_fround(f51 * f50));
   f52 = Math_fround(Math_fround(Math_fround(f49 * f14) + Math_fround(f53 * f15)) + Math_fround(f50 * f16));
   f6 = Math_fround(Math_fround(Math_fround(f49 * f17) + Math_fround(f53 * f18)) + Math_fround(f50 * f19));
   f50 = Math_fround(Math_fround(Math_fround(f49 * f20) + Math_fround(f53 * f21)) + Math_fround(f50 * f22));
   i54 = f6 > f50;
   f53 = i54 ? f6 : f50;
   f6 = i54 ? f50 : f6;
   f6 = f52 > f6 ? f6 : f52;
   if (f6 > Math_fround(f13 - f8) ? 1 : f51 > Math_fround(f13 + (f52 > f53 ? f52 : f53))) {
    i1 = 0;
    break;
   }
   f6 = Math_fround(Math_fround(-f8) - f6);
   if (f12 > f6) {
    HEAP32[i42 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i42 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i42 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    f2 = Math_fround(0.0);
    i3 = i7;
    i4 = i9;
    i5 = i10;
    i1 = i11;
   } else f6 = f12;
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i36 >>> 0) break L1; else f12 = f6;
  }
  STACKTOP = i47;
  return i1 | 0;
 } while (0);
 if (Math_fround(HEAPF32[i45 >> 2]) > Math_fround(f6 + Math_fround(1.1920929e-07))) {
  i54 = i45 + 4 | 0;
  HEAP32[i43 >> 2] = i5;
  HEAP32[i39 >> 2] = i4;
  HEAP32[i40 >> 2] = i3;
  HEAPF32[i41 >> 2] = f2;
  HEAPF32[i45 >> 2] = f6;
  HEAP32[i54 >> 2] = HEAP32[i42 >> 2];
  HEAP32[i54 + 4 >> 2] = HEAP32[i42 + 4 >> 2];
  HEAP32[i54 + 8 >> 2] = HEAP32[i42 + 8 >> 2];
  HEAP32[i46 >> 2] = 1;
 }
 HEAP32[i44 >> 2] = i1;
 i54 = 1;
 STACKTOP = i47;
 return i54 | 0;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i7 + 4 | 0;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = i1;
 if (!i1) HEAP32[i6 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i6;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i2 + i4 | 0, i1 << 2);
 }
 i1 = i7 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
  i4 = i3;
 }
 i1 = i7 + 56 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 68 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 76 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 81 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 82 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 83 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 84 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 85 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 86 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN9ShaderLab14SerializedPass8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i7 = i3 + 17 | 0;
 i9 = i3 + 16 | 0;
 i6 = i1 + 860 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470760 | 0, HEAP32[gb + 37052 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i8 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470774 | 0, gb + 470782 | 0, i8, 0);
 __ZN9ShaderLab21SerializedShaderState8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470804 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 724 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 740 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470818 | 0, gb + 470829 | 0, i8, 0);
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470847 | 0, i10, i8, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 752 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470861 | 0, gb + 470829 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470847 | 0, i10, i8, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 764 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470874 | 0, gb + 470829 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470847 | 0, i10, i8, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 776 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470887 | 0, gb + 470829 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470847 | 0, i10, i8, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 788 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470896 | 0, gb + 470829 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470847 | 0, i10, i8, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i8, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i9 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470907 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470930 | 0, i9, i1 + 800 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i8 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, i9, i1 + 816 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470940 | 0, i9, i1 + 832 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470710 | 0, gb + 470717 | 0, i1 + 848 | 0, 0);
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i1 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470740 | 0, HEAP32[gb + 37052 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i4, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i4, HEAP32[i1 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i8, i12, i9, i1) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i12 + 24 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i5 | 0) == (i1 | 0)) {
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  i2 = HEAP32[i8 + 8 >> 2] | 0;
  if ((i1 | 0) < (i2 | 0)) i3 = 1; else if ((i1 | 0) > (i2 | 0)) i3 = 0; else {
   i4 = i12 + 16 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i1 | 0) < (i2 | 0) | ((i1 | 0) == (i2 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0);
  }
 } else i3 = (i5 | 0) < (i1 | 0);
 i4 = i9 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i1 = HEAP32[i9 + 8 >> 2] | 0;
  i2 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i1 | 0) < (i2 | 0)) i1 = 1; else if ((i1 | 0) > (i2 | 0)) i1 = 0; else {
   i5 = i9 + 16 | 0;
   i13 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = i12 + 16 | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = (i13 | 0) < (i2 | 0) | ((i13 | 0) == (i2 | 0) ? (HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0 : 0);
  }
 } else i1 = (i1 | 0) < (i5 | 0);
 if (!i3) {
  if (!i1) {
   i13 = 0;
   STACKTOP = i11;
   return i13 | 0;
  };
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) {
   i1 = HEAP32[i12 + 8 >> 2] | 0;
   i2 = HEAP32[i8 + 8 >> 2] | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    if ((i1 | 0) > (i2 | 0)) {
     i13 = 1;
     STACKTOP = i11;
     return i13 | 0;
    }
    i9 = i12 + 16 | 0;
    i6 = HEAP32[i9 + 4 >> 2] | 0;
    i13 = i8 + 16 | 0;
    i7 = HEAP32[i13 + 4 >> 2] | 0;
    if (!((i6 | 0) < (i7 | 0) | ((i6 | 0) == (i7 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
     i13 = 1;
     STACKTOP = i11;
     return i13 | 0;
    }
   }
  } else if ((i2 | 0) >= (i1 | 0)) {
   i13 = 1;
   STACKTOP = i11;
   return i13 | 0;
  };
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  i13 = 2;
  STACKTOP = i11;
  return i13 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 if (i1) {
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  i13 = 1;
  STACKTOP = i11;
  return i13 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i2 | 0) >= (i1 | 0)) {
   if ((i2 | 0) > (i1 | 0)) {
    i13 = 1;
    STACKTOP = i11;
    return i13 | 0;
   }
   i8 = i9 + 16 | 0;
   i6 = HEAP32[i8 + 4 >> 2] | 0;
   i13 = i12 + 16 | 0;
   i7 = HEAP32[i13 + 4 >> 2] | 0;
   if (!((i6 | 0) < (i7 | 0) | ((i6 | 0) == (i7 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
    i13 = 1;
    STACKTOP = i11;
    return i13 | 0;
   }
  }
 } else if ((i2 | 0) >= (i1 | 0)) {
  i13 = 1;
  STACKTOP = i11;
  return i13 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 i13 = 2;
 STACKTOP = i11;
 return i13 | 0;
}

function __ZN8Remapper14SetupRemappingEiRK26SerializedObjectIdentifier(i13, i14, i15) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16;
 i12 = i13 + 12 | 0;
 i10 = i13 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i3 | 0) {
  i1 = i10;
  i4 = i3;
  L2 : while (1) {
   i2 = i4;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i14 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i14 | 0)) {
   i1 = i10;
   L10 : while (1) {
    i2 = i3;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >= (i14 | 0)) break;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) break L10;
    }
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
   if ((i1 | 0) == (i10 | 0)) i9 = 14; else if ((HEAP32[i1 + 16 >> 2] | 0) > (i14 | 0)) i9 = 14;
   if ((i9 | 0) == 14) i1 = i10;
   __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE14__erase_uniqueIS2_EEjRKT_(i13, i1 + 24 | 0) | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   if (i4 | 0) {
    i3 = i10;
    i2 = i4;
    L22 : while (1) {
     i1 = i2;
     while (1) {
      if ((HEAP32[i1 + 16 >> 2] | 0) >= (i14 | 0)) break;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) break L22;
     }
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i3 = i1;
      break;
     } else i3 = i1;
    }
    if ((i3 | 0) != (i10 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) <= (i14 | 0)) {
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      }
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((HEAP32[i12 >> 2] | 0) == (i3 | 0)) HEAP32[i12 >> 2] = i1;
     i8 = i13 + 20 | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
     __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i4, i3);
     __ZdlPv(i3);
    }
   }
  }
 }
 i5 = i13 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 do if (i3 | 0) {
  i6 = HEAP32[i15 >> 2] | 0;
  i8 = i15 + 8 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i1 = i5;
  i4 = i3;
  L43 : while (1) {
   i2 = i4;
   while (1) {
    i4 = HEAP32[i2 + 16 >> 2] | 0;
    if ((i4 | 0) >= (i6 | 0)) {
     if ((i4 | 0) > (i6 | 0)) break;
     i4 = i2 + 24 | 0;
     i17 = HEAP32[i4 + 4 >> 2] | 0;
     if (!((i17 | 0) < (i8 | 0) | ((i17 | 0) == (i8 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L43;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i6 | 0) >= (i2 | 0)) {
    if ((i6 | 0) > (i2 | 0)) i1 = i5; else {
     i17 = i1 + 24 | 0;
     i4 = HEAP32[i17 + 4 >> 2] | 0;
     if ((i8 | 0) < (i4 | 0) | ((i8 | 0) == (i4 | 0) ? i7 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0 : 0)) break; else i1 = i5;
    }
    L57 : while (1) {
     i2 = i3;
     while (1) {
      i3 = HEAP32[i2 + 16 >> 2] | 0;
      if ((i3 | 0) >= (i6 | 0)) {
       if ((i3 | 0) > (i6 | 0)) break;
       i17 = i2 + 24 | 0;
       i4 = HEAP32[i17 + 4 >> 2] | 0;
       if (!((i4 | 0) < (i8 | 0) | ((i4 | 0) == (i8 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) break;
      }
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) break L57;
     }
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i1 = i2;
      break;
     } else i1 = i2;
    }
    if ((i1 | 0) == (i5 | 0)) i9 = 50; else {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i6 | 0) < (i2 | 0)) i9 = 50; else if ((i6 | 0) <= (i2 | 0)) {
      i17 = i1 + 24 | 0;
      i6 = HEAP32[i17 + 4 >> 2] | 0;
      if ((i8 | 0) < (i6 | 0) | ((i8 | 0) == (i6 | 0) ? i7 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0 : 0)) i9 = 50;
     }
    }
    if ((i9 | 0) == 50) i1 = i5;
    i5 = HEAP32[i10 >> 2] | 0;
    if (i5 | 0) {
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i3 = i10;
     i2 = i5;
     L76 : while (1) {
      i1 = i2;
      while (1) {
       if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) break L76;
      }
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i3 = i1;
       break;
      } else i3 = i1;
     }
     if ((i3 | 0) != (i10 | 0)) if ((i4 | 0) >= (HEAP32[i3 + 16 >> 2] | 0)) {
      i1 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i1) {
       i2 = i3;
       while (1) {
        i1 = HEAP32[i2 + 8 >> 2] | 0;
        if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
       }
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((HEAP32[i12 >> 2] | 0) == (i3 | 0)) HEAP32[i12 >> 2] = i1;
      i17 = i13 + 20 | 0;
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
      __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i5, i3);
      __ZdlPv(i3);
     }
    }
    __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE14__erase_uniqueIS2_EEjRKT_(i13, i15) | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i10;
  i4 = i10;
  i2 = i10;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i14 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i9 = 69;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i14 | 0)) {
     i9 = 75;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i9 = 73;
     break;
    } else i1 = i2;
   }
  }
  if ((i9 | 0) == 69) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i9 | 0) == 73) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i2 = i3;
   break;
  } else if ((i9 | 0) == 75) {
   HEAP32[i11 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i2 = i11;
    break;
   }
   i17 = i1 + 24 | 0;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   i17 = __ZNSt3__23mapI26SerializedObjectIdentifieriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEixERS6_(i13, i15) | 0;
   HEAP32[i17 >> 2] = i14;
   STACKTOP = i16;
   return;
  }
 } while (0);
 i3 = __Znwj(40) | 0;
 HEAP32[i3 + 16 >> 2] = i14;
 HEAP32[i3 + 24 >> 2] = 0;
 i1 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i12 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 + 16 >> 2] | 0, i1);
 i17 = i13 + 20 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 i17 = i3;
 i17 = i17 + 24 | 0;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i17 = __ZNSt3__23mapI26SerializedObjectIdentifieriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEixERS6_(i13, i15) | 0;
 HEAP32[i17 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __ZN16Physics2DManager15ColliderCastAllEPK10Collider2DRK8Vector2ffibP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i39, i2, f8, i40, i41, i49) {
 i1 = i1 | 0;
 i39 = i39 | 0;
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 i40 = i40 | 0;
 i41 = i41 | 0;
 i49 = i49 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0;
 i50 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i50 + 48 | 0;
 i38 = i50;
 i36 = i50 + 536 | 0;
 i37 = i50 + 488 | 0;
 i47 = i50 + 468 | 0;
 i46 = i50 + 448 | 0;
 i35 = i50 + 72 | 0;
 i43 = i50 + 496 | 0;
 if ((HEAP16[gb + 1457740 + 6 >> 1] | 0) > -1) {
  HEAP32[i38 >> 2] = 0;
  HEAP32[i45 >> 2] = HEAP32[i38 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457740 | 0, i45);
  i48 = gb + 1457740 | 0;
 } else i48 = 0;
 if (!(HEAP32[i39 + 72 >> 2] | 0)) i1 = 0; else {
  i1 = HEAP32[(HEAP32[HEAP32[i39 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
  i32 = HEAP32[i1 + 12 >> 2] | 0;
  i33 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i36 >> 2] = i32;
  HEAP32[i36 + 4 >> 2] = i33;
  i44 = f8 == Math_fround(inf);
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  f3 = Math_fround(f7 * f7);
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f3 = Math_fround(f3 + Math_fround(f4 * f4));
  i34 = f3 == Math_fround(0.0);
  f5 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!i34) f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
  f7 = Math_fround(f7 * f3);
  f3 = Math_fround(f4 * f3);
  f4 = i44 ? Math_fround(1.0e5) : f8;
  f8 = Math_fround(Math_fround(f4 * f3) + f6);
  HEAPF32[i37 >> 2] = Math_fround(f5 + Math_fround(f4 * f7));
  HEAPF32[i37 + 4 >> 2] = f8;
  i32 = gb + 64016 | 0;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  i30 = i38;
  HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  HEAP32[i47 >> 2] = 0;
  i30 = i47 + 12 | 0;
  HEAP32[i30 >> 2] = 0;
  i31 = i47 + 16 | 0;
  HEAP32[i31 >> 2] = 0;
  i32 = i47 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i45, i38);
  i27 = i45;
  i33 = HEAP32[i27 + 4 >> 2] | 0;
  i34 = i32;
  HEAP32[i34 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i34 + 4 >> 2] = i33;
  i34 = gb + 64016 | 0;
  i33 = HEAP32[i34 + 4 >> 2] | 0;
  i27 = i38;
  HEAP32[i27 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i27 + 4 >> 2] = i33;
  HEAP32[i46 >> 2] = 0;
  i27 = i46 + 12 | 0;
  HEAP32[i27 >> 2] = 0;
  i33 = i46 + 16 | 0;
  HEAP32[i33 >> 2] = 0;
  i34 = i46 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i45, i38);
  i26 = i45;
  i29 = HEAP32[i26 + 4 >> 2] | 0;
  i28 = i34;
  HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i28 + 4 >> 2] = i29;
  __ZN13dynamic_arrayIP9b2FixtureLj4EEC2ERKS2_(i45, i39 + 60 | 0);
  i28 = i45 + 12 | 0;
  if (HEAP32[i28 >> 2] | 0) {
   i29 = i38 + 4 | 0;
   i25 = i38 + 8 | 0;
   i26 = i38 + 28 | 0;
   i16 = i1 + 56 | 0;
   i17 = i35 + 372 | 0;
   i18 = i35 + 340 | 0;
   i19 = i35 + 356 | 0;
   i20 = i35 + 344 | 0;
   i21 = i35 + 268 | 0;
   i14 = HEAP32[i45 >> 2] | 0;
   do {
    i22 = HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0;
    i23 = mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0) | 0;
    if ((i23 | 0) > 0) {
     i24 = i22 + 4 | 0;
     i15 = 0;
     do {
      HEAP32[i38 >> 2] = gb + 151648 + 8;
      HEAP32[i29 >> 2] = 1;
      HEAP32[i25 >> 2] = HEAP32[gb + 151644 >> 2];
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      HEAP32[i26 + 12 >> 2] = 0;
      HEAP16[i26 + 16 >> 1] = 0;
      if ((HEAP32[i24 >> 2] | 0) == 3) {
       __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei(i22, i38, i15);
       i1 = i38;
      } else i1 = i22;
      __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i35, i36, i37, Math_fround(HEAPF32[i16 >> 2]), i40, Math_fround(-inf), Math_fround(inf), i39, i41, i46);
      HEAP32[i35 >> 2] = gb + 158644 + 8;
      HEAP32[i17 >> 2] = i1;
      __ZN15Cast2DQueryBase8RunQueryEb(i35, 0) | 0;
      i2 = HEAP32[i46 >> 2] | 0;
      i1 = HEAP32[i27 >> 2] | 0;
      if (i1 | 0) {
       i13 = i2;
       i12 = i2;
       while (1) {
        i9 = HEAP32[i30 >> 2] | 0;
        L23 : do if (!i9) {
         i2 = HEAP32[i13 + 32 >> 2] | 0;
         i42 = 28;
        } else {
         i51 = HEAP32[i47 >> 2] | 0;
         i11 = i13 + 32 | 0;
         i2 = HEAP32[i11 >> 2] | 0;
         i10 = i51 + (i9 * 36 | 0) | 0;
         i9 = i51;
         while (1) {
          if ((i2 | 0) == (HEAP32[i9 + 32 >> 2] | 0)) break;
          i9 = i9 + 36 | 0;
          if ((i9 | 0) == (i10 | 0)) {
           i42 = 28;
           break L23;
          }
         }
         f8 = Math_fround(HEAPF32[i13 + 24 >> 2]);
         if (f8 < Math_fround(HEAPF32[i9 + 24 >> 2])) {
          i2 = i13;
          i10 = i9 + 36 | 0;
          do {
           HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
           i9 = i9 + 4 | 0;
           i2 = i2 + 4 | 0;
          } while ((i9 | 0) < (i10 | 0));
         }
         HEAP32[i11 >> 2] = 0;
         i2 = i12;
        } while (0);
        if ((i42 | 0) == 28) {
         i42 = 0;
         if (!i2) i2 = i12; else {
          __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i47, i13);
          i2 = HEAP32[i46 >> 2] | 0;
          i1 = HEAP32[i27 >> 2] | 0;
         }
        }
        i13 = i13 + 36 | 0;
        if ((i13 | 0) == (i2 + (i1 * 36 | 0) | 0)) break; else i12 = i2;
       }
      }
      HEAP32[i35 >> 2] = gb + 156124 + 8;
      if ((HEAP32[i19 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i20);
       HEAP32[i18 >> 2] = 0;
      }
      __ZN16b2BlockAllocatorD2Ev(i21);
      i15 = i15 + 1 | 0;
     } while ((i15 | 0) != (i23 | 0));
    }
    i14 = i14 + 4 | 0;
   } while ((i14 | 0) != ((HEAP32[i45 >> 2] | 0) + (HEAP32[i28 >> 2] << 2) | 0));
  }
  i1 = HEAP32[i47 >> 2] | 0;
  i2 = i1 + ((HEAP32[i30 >> 2] | 0) * 36 | 0) | 0;
  i9 = i43;
  i10 = i9 + 36 | 0;
  do {
   HEAP32[i9 >> 2] = 0;
   i9 = i9 + 4 | 0;
  } while ((i9 | 0) < (i10 | 0));
  __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_(i1, i2, i43);
  i1 = HEAP32[i30 >> 2] | 0;
  if ((i1 | 0) > 0) if (i44) {
   i2 = 0;
   do {
    i51 = HEAP32[i47 >> 2] | 0;
    i44 = i51 + (i2 * 36 | 0) + 28 | 0;
    HEAPF32[i44 >> 2] = Math_fround(Math_fround(HEAPF32[i44 >> 2]) * Math_fround(1.0e5));
    __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i49, i51 + (i2 * 36 | 0) | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  } else {
   i2 = 0;
   do {
    __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i49, (HEAP32[i47 >> 2] | 0) + (i2 * 36 | 0) | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  if ((HEAP32[i45 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i45 >> 2] | 0, i45 + 4 | 0);
   HEAP32[i45 >> 2] = 0;
  }
  if ((HEAP32[i33 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i46 >> 2] | 0, i34);
   HEAP32[i46 >> 2] = 0;
  }
  if ((HEAP32[i31 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i47 >> 2] | 0, i32);
   HEAP32[i47 >> 2] = 0;
  }
 }
 if (!i48) {
  STACKTOP = i50;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i48);
 STACKTOP = i50;
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEbT0_S6_T_(i9, i8, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0;
 switch (i8 - i9 >> 3 | 0) {
 case 2:
  {
   i1 = i8 + -8 | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i9 >> 2]))) {
    i9 = 1;
    return i9 | 0;
   }
   i8 = i9;
   i6 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i4 = i1;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = i5;
   i9 = i1;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i8;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   i6 = i9 + 8 | 0;
   i1 = i8 + -8 | 0;
   f7 = Math_fround(HEAPF32[i6 >> 2]);
   i8 = f7 < Math_fround(HEAPF32[i9 >> 2]);
   i2 = Math_fround(HEAPF32[i1 >> 2]) < f7;
   if (!i8) {
    if (!i2) {
     i9 = 1;
     return i9 | 0;
    }
    i5 = i6;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i10 = i1;
    i2 = HEAP32[i10 + 4 >> 2] | 0;
    i8 = i6;
    HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i8 + 4 >> 2] = i2;
    i8 = i1;
    HEAP32[i8 >> 2] = i4;
    HEAP32[i8 + 4 >> 2] = i5;
    f7 = Math_fround(HEAPF32[i6 >> 2]);
    if (!(f7 < Math_fround(HEAPF32[i9 >> 2]))) {
     i10 = 1;
     return i10 | 0;
    }
    i8 = i9;
    i5 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i2 = i6;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = i9;
    HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 + 4 >> 2] = i4;
    i10 = i6;
    HEAP32[i10 >> 2] = i5;
    HEAP32[i10 + 4 >> 2] = i8;
    i10 = 1;
    return i10 | 0;
   }
   i5 = i9;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (i2) {
    i6 = i1;
    i8 = HEAP32[i6 + 4 >> 2] | 0;
    i10 = i9;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = i8;
    i10 = i1;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i10 + 4 >> 2] = i5;
    i10 = 1;
    return i10 | 0;
   }
   i2 = i6;
   i8 = HEAP32[i2 + 4 >> 2] | 0;
   i10 = i9;
   HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   i10 = i6;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i10 + 4 >> 2] = i5;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
    i10 = 1;
    return i10 | 0;
   }
   i8 = i1;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i6;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   i10 = i1;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i10 + 4 >> 2] = i5;
   i10 = 1;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i9, i9 + 8 | 0, i9 + 16 | 0, i8 + -8 | 0, i2) | 0;
   i10 = 1;
   return i10 | 0;
  }
 case 5:
  {
   i5 = i9 + 8 | 0;
   i6 = i9 + 16 | 0;
   i4 = i9 + 24 | 0;
   i1 = i8 + -8 | 0;
   __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i9, i5, i6, i4, i2) | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i4 >> 2]))) {
    i10 = 1;
    return i10 | 0;
   }
   i8 = i4;
   i2 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i12 = i1;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i4;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i10 = i1;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i10 + 4 >> 2] = i8;
   if (!(Math_fround(HEAPF32[i4 >> 2]) < Math_fround(HEAPF32[i6 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   i11 = i6;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i2 = i4;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i12 = i6;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   i12 = i4;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f3 < Math_fround(HEAPF32[i5 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   i11 = i5;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i5;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   i12 = i6;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   if (!(f3 < Math_fround(HEAPF32[i9 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   i11 = i9;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i9;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   i12 = i5;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = 1;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   return i12 | 0;
  }
 default:
  {
   i2 = i9 + 16 | 0;
   i6 = i9 + 8 | 0;
   f13 = Math_fround(HEAPF32[i6 >> 2]);
   f7 = Math_fround(HEAPF32[i9 >> 2]);
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   i1 = f3 < f13;
   do if (f13 < f7) {
    i5 = i9;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if (i1) {
     i10 = i2;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i9;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     i12 = i2;
     HEAP32[i12 >> 2] = i4;
     HEAP32[i12 + 4 >> 2] = i5;
     f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     break;
    }
    i10 = i6;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i9;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i6;
    HEAP32[i12 >> 2] = i4;
    HEAP32[i12 + 4 >> 2] = i5;
    f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f3 < f7) {
     i10 = i2;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i6;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     i12 = i2;
     HEAP32[i12 >> 2] = i4;
     HEAP32[i12 + 4 >> 2] = i5;
     f3 = f7;
    }
   } else if (i1) {
    i10 = i6;
    i11 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i4 = i2;
    i1 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    i12 = i6;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i4;
    i12 = i2;
    HEAP32[i12 >> 2] = i11;
    HEAP32[i12 + 4 >> 2] = i10;
    i12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f7;
    f3 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (i12) {
     i11 = i9;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     i12 = i9;
     HEAP32[i12 >> 2] = i1;
     HEAP32[i12 + 4 >> 2] = i4;
     i12 = i6;
     HEAP32[i12 >> 2] = i10;
     HEAP32[i12 + 4 >> 2] = i11;
    }
   } while (0);
   i1 = i9 + 24 | 0;
   L13 : do if ((i1 | 0) == (i8 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    while (1) {
     f7 = Math_fround(HEAPF32[i6 >> 2]);
     if (f7 < f3) {
      i5 = HEAP32[i6 + 4 >> 2] | 0;
      i4 = i6;
      while (1) {
       i10 = i2;
       i11 = HEAP32[i10 + 4 >> 2] | 0;
       i12 = i4;
       HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i12 + 4 >> 2] = i11;
       if ((i2 | 0) == (i9 | 0)) {
        i2 = i9;
        break;
       }
       i4 = i2 + -8 | 0;
       if (f7 < Math_fround(HEAPF32[i4 >> 2])) {
        i12 = i2;
        i2 = i4;
        i4 = i12;
       } else break;
      }
      HEAPF32[i2 >> 2] = f7;
      HEAP32[i2 + 4 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 8 | 0) == (i8 | 0);
       break L13;
      }
     }
     i2 = i6 + 8 | 0;
     if ((i2 | 0) == (i8 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     f3 = Math_fround(HEAPF32[i6 >> 2]);
     i12 = i6;
     i6 = i2;
     i2 = i12;
    }
   } while (0);
   i12 = i1 | i2;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i9 = i8 + 16 | 0;
 i10 = i8 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i3;
 }
 i1 = i7 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 12 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 20 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 28 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 32 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 34 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i2;
 }
 i1 = i7 + 38 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 42 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 44 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
  i2 = i4;
 }
 i1 = i7 + 46 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
  i1 = i4;
 }
 i3 = i7 + 48 | 0;
 i4 = i1 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i3, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 50 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 54 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 56 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 58 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 60 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 62 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 i5 = i7 + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i3;
 i1 = i7 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  __ZN8Gradient17ValidateColorKeysEv(i7);
  __ZN8Gradient17ValidateAlphaKeysEv(i7);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  __ZN8Gradient17ValidateColorKeysEv(i7);
  __ZN8Gradient17ValidateAlphaKeysEv(i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN8AnimatorC2E10MemLabelId18ObjectCreationMode(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9;
 i2 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i11 = i5;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN14DirectorPlayerC2E10MemLabelId18ObjectCreationMode(i4, i8, i1);
 HEAP32[i4 >> 2] = gb + 176564 + 8;
 i1 = i4 + 40 | 0;
 HEAP8[i4 + 76 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = -1;
 HEAP32[i4 + 84 >> 2] = -1;
 HEAP8[i4 + 88 >> 0] = 0;
 i1 = i4 + 92 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = gb + 63320 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i4 + 112 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i3 = i8;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 116 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i4 + 124 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP16[i1 + 28 >> 1] = 0;
 i1 = gb + 63320 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i4 + 156 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i3 = i8;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 160 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 i1 = gb + 63320 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i4 + 176 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i3 = i8;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 180 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i4 + 188 | 0;
 i2 = i1;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP16[i1 + 36 >> 1] = 0;
 i11 = gb + 63320 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i4 + 228 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i10 = i8;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i4 + 232 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i4 + 240 >> 2] = 0;
 HEAP32[i4 + 244 >> 2] = 0;
 i11 = gb + 63320 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i4 + 248 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i10 = i8;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = i4 + 252 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i4 + 260 >> 2] = 0;
 HEAP32[i4 + 264 >> 2] = 0;
 HEAP32[i4 + 268 >> 2] = 0;
 i11 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i4 + 272 >> 2] = i11;
 i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i4 + 276 >> 2] = i3;
 i10 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i4 + 280 >> 2] = i10;
 HEAPF32[i4 + 284 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 296 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 300 >> 2] = i11;
 HEAP32[i4 + 304 >> 2] = i3;
 HEAP32[i4 + 308 >> 2] = i10;
 HEAP32[i4 + 312 >> 2] = i11;
 HEAP32[i4 + 316 >> 2] = i3;
 HEAP32[i4 + 320 >> 2] = i10;
 HEAPF32[i4 + 324 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 328 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 332 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 336 >> 2] = i11;
 HEAP32[i4 + 340 >> 2] = i3;
 HEAP32[i4 + 344 >> 2] = i10;
 HEAPF32[i4 + 348 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 360 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 364 >> 2] = Math_fround(-1.0);
 HEAP32[i4 + 368 >> 2] = -1;
 HEAP32[i4 + 372 >> 2] = i11;
 HEAP32[i4 + 376 >> 2] = i3;
 HEAP32[i4 + 380 >> 2] = i10;
 HEAPF32[i4 + 384 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 388 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 392 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 396 >> 2] = Math_fround(1.0);
 i10 = HEAP32[gb + 62512 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 62512 + 8 >> 2] | 0;
 HEAP32[i4 + 400 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i4 + 404 >> 2] = i10;
 HEAP32[i4 + 408 >> 2] = i3;
 i3 = i4 + 412 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP16[i3 + 4 >> 1] = 0;
 HEAP8[i3 + 6 >> 0] = 0;
 HEAPF32[i4 + 420 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 424 >> 0] = 1;
 HEAP8[i4 + 425 >> 0] = 1;
 HEAP8[i4 + 426 >> 0] = 0;
 HEAP32[i4 + 428 >> 2] = 0;
 HEAP32[i4 + 440 >> 2] = 0;
 HEAP32[i4 + 444 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i3 = i8;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i4 + 432 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i4 + 448 >> 2] = 0;
 HEAP32[i4 + 460 >> 2] = 0;
 HEAP32[i4 + 464 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i4 + 452 | 0;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i10;
 HEAP32[i4 + 468 >> 2] = i4;
 HEAP32[i4 + 472 >> 2] = 0;
 HEAP32[i4 + 476 >> 2] = -1;
 HEAP32[i4 + 480 >> 2] = i4;
 HEAP32[i4 + 484 >> 2] = 0;
 HEAP32[i4 + 496 >> 2] = 0;
 HEAP32[i4 + 500 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i3 = i8;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i4 + 488 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14AvatarPlaybackC2E10MemLabelId(i4 + 504 | 0, i8);
 HEAP32[i4 + 548 >> 2] = 0;
 HEAPF32[i4 + 552 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 556 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 560 >> 0] = 1;
 HEAP8[i4 + 561 >> 0] = 1;
 i6 = gb + 64024 | 0;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i4 + 564 >> 2] = 0;
 HEAP32[i4 + 576 >> 2] = 0;
 HEAP32[i4 + 580 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i4 + 568 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i10;
 i6 = gb + 63320 | 0;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i4 + 584 >> 2] = 0;
 HEAP32[i4 + 596 >> 2] = 0;
 HEAP32[i4 + 600 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = i8;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i4 + 588 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i4 + 604 >> 2] = 0;
 HEAP32[i4 + 616 >> 2] = 0;
 HEAP32[i4 + 620 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i4 + 608 | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i4 + 624 >> 2] = 0;
 HEAP32[i4 + 632 >> 2] = 0;
 HEAP32[i4 + 628 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN13BoneInfluence8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426278 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426288 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426298 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426308 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426318 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426331 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426344 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 72; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426357 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 83; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 83; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 83) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _XXH64_update(i15, i1, i3) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = i1 + i3 | 0;
 i14 = i15;
 i14 = _i64Add(HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i3 | 0, 0) | 0;
 i2 = getTempRet0() | 0;
 i16 = i15;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i16 + 4 >> 2] = i2;
 i16 = i15 + 80 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i2 + i3 | 0) >>> 0 < 32) {
  _memcpy(i15 + 48 + i2 | 0, i1 | 0, i3 | 0) | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i3;
  return 0;
 }
 if (i2) {
  i11 = i15 + 48 | 0;
  _memcpy(i11 + i2 | 0, i1 | 0, 32 - i2 | 0) | 0;
  i14 = i15 + 16 | 0;
  i10 = i14;
  i13 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i11;
  i11 = i11 + 4 | 0;
  i11 = ___muldi3(HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
  i10 = _i64Add(i11 | 0, getTempRet0() | 0, i13 | 0, i10 | 0) | 0;
  i13 = getTempRet0() | 0;
  i11 = _bitshift64Shl(i10 | 0, i13 | 0, 31) | 0;
  i12 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i13 | 0, 33) | 0;
  i12 = ___muldi3(i11 | i13 | 0, i12 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i13 = getTempRet0() | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i13;
  i14 = i15 + 24 | 0;
  i13 = i14;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i11 = i15 + 56 | 0;
  i10 = i11;
  i11 = i11 + 4 | 0;
  i11 = ___muldi3(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24 | 0, HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
  i13 = _i64Add(i11 | 0, getTempRet0() | 0, i12 | 0, i13 | 0) | 0;
  i12 = getTempRet0() | 0;
  i11 = _bitshift64Shl(i13 | 0, i12 | 0, 31) | 0;
  i10 = getTempRet0() | 0;
  i12 = _bitshift64Lshr(i13 | 0, i12 | 0, 33) | 0;
  i10 = ___muldi3(i11 | i12 | 0, i10 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i12 = getTempRet0() | 0;
  HEAP32[i14 >> 2] = i10;
  HEAP32[i14 + 4 >> 2] = i12;
  i14 = i15 + 32 | 0;
  i12 = i14;
  i10 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i11 = i15 + 64 | 0;
  i13 = i11;
  i11 = i11 + 4 | 0;
  i11 = ___muldi3(HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24 | 0, HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
  i12 = _i64Add(i11 | 0, getTempRet0() | 0, i10 | 0, i12 | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Shl(i12 | 0, i10 | 0, 31) | 0;
  i13 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i12 | 0, i10 | 0, 33) | 0;
  i13 = ___muldi3(i11 | i10 | 0, i13 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i10 = getTempRet0() | 0;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i14 + 4 >> 2] = i10;
  i14 = i15 + 40 | 0;
  i10 = i14;
  i13 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i11 = i15 + 72 | 0;
  i12 = i11;
  i11 = i11 + 4 | 0;
  i11 = ___muldi3(HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24 | 0, HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
  i10 = _i64Add(i11 | 0, getTempRet0() | 0, i13 | 0, i10 | 0) | 0;
  i13 = getTempRet0() | 0;
  i11 = _bitshift64Shl(i10 | 0, i13 | 0, 31) | 0;
  i12 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i13 | 0, 33) | 0;
  i12 = ___muldi3(i11 | i13 | 0, i12 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i13 = getTempRet0() | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i13;
  i1 = i1 + (32 - (HEAP32[i16 >> 2] | 0)) | 0;
  HEAP32[i16 >> 2] = 0;
 }
 if ((i1 + 32 | 0) >>> 0 <= i17 >>> 0) {
  i10 = i17 + -32 | 0;
  i11 = i15 + 16 | 0;
  i3 = i11;
  i12 = i15 + 24 | 0;
  i5 = i12;
  i13 = i15 + 32 | 0;
  i7 = i13;
  i14 = i15 + 40 | 0;
  i9 = i14;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  do {
   i18 = i1;
   i19 = i18;
   i18 = i18 + 4 | 0;
   i18 = ___muldi3(HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24 | 0, HEAPU8[i18 >> 0] | HEAPU8[i18 + 1 >> 0] << 8 | HEAPU8[i18 + 2 >> 0] << 16 | HEAPU8[i18 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
   i18 = _i64Add(i18 | 0, getTempRet0() | 0, i2 | 0, i3 | 0) | 0;
   i19 = getTempRet0() | 0;
   i20 = _bitshift64Shl(i18 | 0, i19 | 0, 31) | 0;
   i21 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i18 | 0, i19 | 0, 33) | 0;
   i2 = ___muldi3(i20 | i19 | 0, i21 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i3 = getTempRet0() | 0;
   i21 = i1 + 8 | 0;
   i19 = i21;
   i21 = i21 + 4 | 0;
   i21 = ___muldi3(HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24 | 0, HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
   i21 = _i64Add(i21 | 0, getTempRet0() | 0, i4 | 0, i5 | 0) | 0;
   i19 = getTempRet0() | 0;
   i20 = _bitshift64Shl(i21 | 0, i19 | 0, 31) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i21 | 0, i19 | 0, 33) | 0;
   i4 = ___muldi3(i20 | i19 | 0, i18 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i5 = getTempRet0() | 0;
   i18 = i1 + 16 | 0;
   i19 = i18;
   i18 = i18 + 4 | 0;
   i18 = ___muldi3(HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24 | 0, HEAPU8[i18 >> 0] | HEAPU8[i18 + 1 >> 0] << 8 | HEAPU8[i18 + 2 >> 0] << 16 | HEAPU8[i18 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
   i18 = _i64Add(i18 | 0, getTempRet0() | 0, i6 | 0, i7 | 0) | 0;
   i19 = getTempRet0() | 0;
   i20 = _bitshift64Shl(i18 | 0, i19 | 0, 31) | 0;
   i21 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i18 | 0, i19 | 0, 33) | 0;
   i6 = ___muldi3(i20 | i19 | 0, i21 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i7 = getTempRet0() | 0;
   i21 = i1 + 24 | 0;
   i19 = i21;
   i21 = i21 + 4 | 0;
   i21 = ___muldi3(HEAPU8[i19 >> 0] | HEAPU8[i19 + 1 >> 0] << 8 | HEAPU8[i19 + 2 >> 0] << 16 | HEAPU8[i19 + 3 >> 0] << 24 | 0, HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24 | 0, 668265295, -1028477379) | 0;
   i21 = _i64Add(i21 | 0, getTempRet0() | 0, i8 | 0, i9 | 0) | 0;
   i19 = getTempRet0() | 0;
   i20 = _bitshift64Shl(i21 | 0, i19 | 0, 31) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i21 | 0, i19 | 0, 33) | 0;
   i8 = ___muldi3(i20 | i19 | 0, i18 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i9 = getTempRet0() | 0;
   i1 = i1 + 32 | 0;
  } while (i1 >>> 0 <= i10 >>> 0);
  i21 = i11;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i21 + 4 >> 2] = i3;
  i21 = i12;
  HEAP32[i21 >> 2] = i4;
  HEAP32[i21 + 4 >> 2] = i5;
  i21 = i13;
  HEAP32[i21 >> 2] = i6;
  HEAP32[i21 + 4 >> 2] = i7;
  i21 = i14;
  HEAP32[i21 >> 2] = i8;
  HEAP32[i21 + 4 >> 2] = i9;
 }
 if (i1 >>> 0 >= i17 >>> 0) return 0;
 i21 = i17 - i1 | 0;
 _memcpy(i15 + 48 | 0, i1 | 0, i21 | 0) | 0;
 HEAP32[i16 >> 2] = i21;
 return 0;
}

function __Z18ClipAnimationCurveI8Vector3fEbRK17AnimationCurveTplIT_ERS3_ff(i1, i19, f18, f5) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 f18 = Math_fround(f18);
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i23;
 i20 = i23 + 40 | 0;
 HEAP32[i20 >> 2] = 0;
 i17 = i20 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i21 = i20 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i15 = i16;
 i8 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i22;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i8;
 i13 = i1 + 132 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 if (!i8) i1 = 0; else {
  i15 = i1 + 120 | 0;
  i11 = HEAP32[i15 >> 2] | 0;
  if ((HEAP32[i11 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
   i1 = i8 + -1 | 0;
   if ((HEAP32[i11 + (i1 * 40 | 0) >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else {
    f4 = Math_fround(HEAPF32[i11 >> 2]);
    i2 = HEAP32[i11 + (i1 * 40 | 0) >> 2] | 0;
    if (f4 > f18) f12 = f4; else {
     f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f12 = f12 < f18 ? f12 : f18;
    }
    if (f4 > f5) f14 = f4; else {
     f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f14 = f14 < f5 ? f14 : f5;
    }
    i9 = (i8 * 40 | 0) / 40 | 0;
    i7 = i11;
    i2 = i9;
    L11 : while (1) {
     while (1) {
      if (!i2) break L11;
      i3 = (i2 | 0) / 2 | 0;
      i6 = i7 + (i3 * 40 | 0) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f12) break; else i2 = i3;
     }
     i7 = i6 + 40 | 0;
     i2 = i2 + -1 - i3 | 0;
    }
    i8 = i11 + (i8 * 40 | 0) | 0;
    if ((i7 | 0) == (i8 | 0)) i10 = i1; else {
     i6 = (i7 - i11 | 0) / 40 | 0;
     i10 = i6 + -1 | 0;
     i10 = (i10 | 0) < 0 ? 0 : i10;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f12)));
     i7 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i10 * 40 | 0) >> 2]) - f12)));
     i10 = i7 ? i6 : i10;
    }
    i7 = i11;
    i2 = i9;
    L21 : while (1) {
     while (1) {
      if (!i2) break L21;
      i3 = (i2 | 0) / 2 | 0;
      i6 = i7 + (i3 * 40 | 0) | 0;
      if (Math_fround(HEAPF32[i6 >> 2]) < f14) break; else i2 = i3;
     }
     i7 = i6 + 40 | 0;
     i2 = i2 + -1 - i3 | 0;
    }
    if ((i7 | 0) != (i8 | 0)) {
     i9 = (i7 - i11 | 0) / 40 | 0;
     i1 = i9 + -1 | 0;
     i1 = (i1 | 0) < 0 ? 0 : i1;
     f5 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f14)));
     i8 = f5 < Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i11 + (i1 * 40 | 0) >> 2]) - f14)));
     i1 = i8 ? i9 : i1;
    }
    f5 = Math_fround(f12 - f14);
    i9 = f5 < Math_fround(0.0);
    f4 = Math_fround(-f5);
    if (!((i9 ? f4 : f5) <= Math_fround(.00100000005))) {
     i2 = i1 - i10 | 0;
     i2 = ((i2 | 0) < 0 ? 0 : i2) + 3 | 0;
     if (!i2) i9 = i11; else {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2 * 40 | 0, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
      i9 = HEAP32[i15 >> 2] | 0;
     }
     i2 = i9 + (i10 * 40 | 0) | 0;
     f5 = Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2]));
     i11 = f5 < Math_fround(0.0);
     f4 = Math_fround(-f5);
     if (!((i11 ? f4 : f5) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i13 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i9 >> 2]);
       f5 = Math_fround(HEAPF32[i9 + ((i8 + -1 | 0) * 40 | 0) >> 2]);
      }
      if (!(f4 >= f12) & !(f5 <= f12)) {
       i7 = i9;
       i2 = (i8 * 40 | 0) / 40 | 0;
       L42 : while (1) {
        while (1) {
         if (!i2) break L42;
         i3 = (i2 | 0) / 2 | 0;
         i6 = i7 + (i3 * 40 | 0) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f12) break; else i2 = i3;
        }
        i7 = i6 + 40 | 0;
        i2 = i2 + -1 - i3 | 0;
       }
       i11 = ((i7 - i9 | 0) / 40 | 0) + -1 | 0;
       i2 = i8 + -2 | 0;
       i2 = (i11 | 0) < (i2 | 0) ? i11 : i2;
       i2 = (i2 | 0) > 0 ? i2 : 0;
      } else i2 = -1;
      __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f(i16, i9 + (i2 * 40 | 0) | 0, i9 + ((i2 + 1 | 0) * 40 | 0) | 0, f12);
      __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_(i20, i16);
      i2 = HEAP32[i15 >> 2] | 0;
      if (f12 > Math_fround(HEAPF32[i2 + (i10 * 40 | 0) >> 2])) {
       i10 = i10 + 1 | 0;
       i9 = i2;
      } else i9 = i2;
     } else {
      __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_(i20, i2);
      i10 = i10 + 1 | 0;
      i9 = HEAP32[i15 >> 2] | 0;
     }
     i2 = i9 + (i1 * 40 | 0) | 0;
     f12 = Math_fround(f14 - Math_fround(HEAPF32[i2 >> 2]));
     i11 = f12 < Math_fround(0.0);
     f5 = Math_fround(-f12);
     if (!((i11 ? f5 : f12) <= Math_fround(.00100000005))) {
      i8 = HEAP32[i13 >> 2] | 0;
      if (!i8) {
       f4 = Math_fround(inf);
       f5 = Math_fround(-inf);
      } else {
       f4 = Math_fround(HEAPF32[i9 >> 2]);
       f5 = Math_fround(HEAPF32[i9 + ((i8 + -1 | 0) * 40 | 0) >> 2]);
      }
      if (!(f4 >= f14) & !(f5 <= f14)) {
       i7 = i9;
       i2 = (i8 * 40 | 0) / 40 | 0;
       L60 : while (1) {
        while (1) {
         if (!i2) break L60;
         i3 = (i2 | 0) / 2 | 0;
         i6 = i7 + (i3 * 40 | 0) | 0;
         if (Math_fround(HEAPF32[i6 >> 2]) < f14) break; else i2 = i3;
        }
        i7 = i6 + 40 | 0;
        i2 = i2 + -1 - i3 | 0;
       }
       i13 = ((i7 - i9 | 0) / 40 | 0) + -1 | 0;
       i2 = i8 + -2 | 0;
       i2 = (i13 | 0) < (i2 | 0) ? i13 : i2;
       i2 = (i2 | 0) > 0 ? i2 : 0;
      } else i2 = -1;
      __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f(i16, i9 + (i2 * 40 | 0) | 0, i9 + ((i2 + 1 | 0) * 40 | 0) | 0, f14);
      __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_(i20, i16);
      if (f14 > Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + (i1 * 40 | 0) >> 2])) i1 = i1 + 1 | 0;
     } else __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_(i20, i2);
     if ((i1 | 0) > (i10 | 0)) {
      i16 = HEAP32[i15 >> 2] | 0;
      __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_PKS2_S6_(i20, (HEAP32[i20 >> 2] | 0) + 40 | 0, i16 + (i10 * 40 | 0) | 0, i16 + (i1 * 40 | 0) | 0) | 0;
     }
     i1 = HEAP32[i17 >> 2] | 0;
     i3 = HEAP32[i20 >> 2] | 0;
     if (!i1) i1 = 0; else {
      i2 = 0;
      do {
       i17 = i3 + (i2 * 40 | 0) | 0;
       HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f18);
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i1 >>> 0);
     }
     __ZN17AnimationCurveTplI8Vector3fE6AssignEPK11KeyframeTplIS0_ES5_(i19, i3, i3 + (i1 * 40 | 0) | 0);
     HEAPF32[i19 + 4 >> 2] = Math_fround(inf);
     HEAP32[i19 >> 2] = 0;
     HEAPF32[i19 + 64 >> 2] = Math_fround(inf);
     HEAP32[i19 + 60 >> 2] = 0;
     i2 = HEAP32[i19 + 132 >> 2] | 0;
     if (!i2) i1 = 0; else {
      i1 = HEAP32[i19 + 120 >> 2] | 0;
      if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) i1 = 0; else i1 = (HEAP32[i1 + ((i2 + -1 | 0) * 40 | 0) >> 2] & 2139095040 | 0) != 2139095040;
     }
    } else i1 = 0;
   }
  }
 }
 if ((HEAP32[i21 >> 2] | 0) <= -1) {
  STACKTOP = i23;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i22);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i23;
 return i1 | 0;
}

function __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2419;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI19StreamedBinaryWriteILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2419;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i13, i1, i2, i8) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15;
 i14 = i15 + 104 | 0;
 i9 = i15 + 80 | 0;
 i5 = i15 + 52 | 0;
 i6 = i15 + 24 | 0;
 i4 = i15 + 16 | 0;
 i7 = i15 + 8 | 0;
 i11 = i15 + 4 | 0;
 i10 = i1 + 12 | 0;
 i10 = _bitshift64Lshr(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, 30) | 0;
 getTempRet0() | 0;
 i12 = i2 + 12 | 0;
 i12 = _bitshift64Lshr(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, 30) | 0;
 getTempRet0() | 0;
 i12 = (i10 & 3) >>> 0 > (i12 & 3) >>> 0;
 i10 = i12 ? i1 : i2;
 i12 = i12 ? i2 : i1;
 i2 = i10 + 12 | 0;
 i2 = _bitshift64Lshr(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 30) | 0;
 getTempRet0() | 0;
 switch (i2 & 3 | 0) {
 case 1:
  {
   if (!(0 == 0 ? (HEAP32[i12 + 12 >> 2] & -1073741824 | 0) == 0 : 0)) {
    STACKTOP = i15;
    return;
   }
   switch (HEAP8[(HEAP32[i12 + 8 >> 2] | 0) + 50 >> 0] | 0) {
   case 1:
   case 4:
    {
     if (!((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(__ZNK5physx2Sc17ParticleSystemSim7getCoreEv(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i10) | 0) | 0) | 0) & 2)) {
      STACKTOP = i15;
      return;
     }
     break;
    }
   default:
    {}
   }
   if ((HEAP16[i10 + 42 >> 1] | 0) == -1) {
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 701939 | 0, 261, gb + 719257 | 0, i3);
    STACKTOP = i15;
    return;
   }
   i1 = i12 + 28 | 0;
   i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0;
   L14 : do if ((i2 + -5 | 0) >>> 0 < 2) {
    __ZNK5physx2Sc19ParticlePacketShape18computeWorldBoundsERNS_9PxBounds3E(i10, i9);
    switch (i2 | 0) {
    case 5:
     {
      i11 = (HEAP32[i1 >> 2] | 0) + 68 | 0;
      f18 = Math_fround(HEAPF32[i9 >> 2]);
      f24 = Math_fround(HEAPF32[i9 + 12 >> 2]);
      f21 = Math_fround(f18 + f24);
      f17 = Math_fround(HEAPF32[i9 + 4 >> 2]);
      f23 = Math_fround(HEAPF32[i9 + 16 >> 2]);
      f20 = Math_fround(f17 + f23);
      f16 = Math_fround(HEAPF32[i9 + 8 >> 2]);
      f22 = Math_fround(HEAPF32[i9 + 20 >> 2]);
      f21 = Math_fround(f21 * Math_fround(.5));
      f20 = Math_fround(f20 * Math_fround(.5));
      f19 = Math_fround(Math_fround(f16 + f22) * Math_fround(.5));
      f18 = Math_fround(Math_fround(f24 - f18) * Math_fround(.5));
      f17 = Math_fround(Math_fround(f23 - f17) * Math_fround(.5));
      f16 = Math_fround(Math_fround(f22 - f16) * Math_fround(.5));
      HEAP32[i14 >> 2] = 1065353216;
      HEAP32[i14 + 4 >> 2] = 0;
      HEAP32[i14 + 8 >> 2] = 0;
      HEAP32[i14 + 12 >> 2] = 0;
      HEAP32[i14 + 16 >> 2] = 1065353216;
      HEAP32[i14 + 20 >> 2] = 0;
      HEAP32[i14 + 24 >> 2] = 0;
      HEAP32[i14 + 28 >> 2] = 0;
      HEAP32[i14 + 32 >> 2] = 1065353216;
      HEAPF32[i14 + 36 >> 2] = f21;
      HEAPF32[i14 + 40 >> 2] = f20;
      HEAPF32[i14 + 44 >> 2] = f19;
      HEAPF32[i14 + 48 >> 2] = f18;
      HEAPF32[i14 + 52 >> 2] = f17;
      HEAPF32[i14 + 56 >> 2] = f16;
      __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i5, i12);
      if (__ZN5physx2Gu28checkOverlapOBB_triangleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i11, i5, i14) | 0) break L14;
      STACKTOP = i15;
      return;
     }
    case 6:
     {
      i11 = (HEAP32[i1 >> 2] | 0) + 68 | 0;
      f22 = Math_fround(HEAPF32[i9 >> 2]);
      f16 = Math_fround(HEAPF32[i9 + 12 >> 2]);
      f19 = Math_fround(f22 + f16);
      f23 = Math_fround(HEAPF32[i9 + 4 >> 2]);
      f17 = Math_fround(HEAPF32[i9 + 16 >> 2]);
      f20 = Math_fround(f23 + f17);
      f24 = Math_fround(HEAPF32[i9 + 8 >> 2]);
      f18 = Math_fround(HEAPF32[i9 + 20 >> 2]);
      f19 = Math_fround(f19 * Math_fround(.5));
      f20 = Math_fround(f20 * Math_fround(.5));
      f21 = Math_fround(Math_fround(f24 + f18) * Math_fround(.5));
      f22 = Math_fround(Math_fround(f16 - f22) * Math_fround(.5));
      f23 = Math_fround(Math_fround(f17 - f23) * Math_fround(.5));
      f24 = Math_fround(Math_fround(f18 - f24) * Math_fround(.5));
      HEAP32[i14 >> 2] = 1065353216;
      HEAP32[i14 + 4 >> 2] = 0;
      HEAP32[i14 + 8 >> 2] = 0;
      HEAP32[i14 + 12 >> 2] = 0;
      HEAP32[i14 + 16 >> 2] = 1065353216;
      HEAP32[i14 + 20 >> 2] = 0;
      HEAP32[i14 + 24 >> 2] = 0;
      HEAP32[i14 + 28 >> 2] = 0;
      HEAP32[i14 + 32 >> 2] = 1065353216;
      HEAPF32[i14 + 36 >> 2] = f19;
      HEAPF32[i14 + 40 >> 2] = f20;
      HEAPF32[i14 + 44 >> 2] = f21;
      HEAPF32[i14 + 48 >> 2] = f22;
      HEAPF32[i14 + 52 >> 2] = f23;
      HEAPF32[i14 + 56 >> 2] = f24;
      __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i6, i12);
      if (__ZN5physx2Gu31checkOverlapOBB_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i11, i6, i14) | 0) break L14;
      STACKTOP = i15;
      return;
     }
    default:
     {
      STACKTOP = i15;
      return;
     }
    }
   } while (0);
   __ZN5physx2Sc10NPhaseCore35createParticlePacketBodyInteractionERNS0_19ParticlePacketShapeERNS0_8ShapeSimEj(i13, i10, i12, i8) | 0;
   STACKTOP = i15;
   return;
  }
 case 2:
  {
   if (!(0 == 0 ? (HEAP32[i12 + 12 >> 2] & -1073741824 | 0) == 0 : 0)) {
    STACKTOP = i15;
    return;
   }
   i6 = __ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[i10 + 20 >> 2] | 0) | 0;
   if (!((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(__ZNK5physx2Sc8ClothSim7getCoreEv(i6) | 0) | 0) & 4)) {
    STACKTOP = i15;
    return;
   }
   __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE(i4, i13, i10, i12, 0);
   if (HEAP16[i4 >> 1] & 3) {
    STACKTOP = i15;
    return;
   }
   if (!(__ZN5physx2Sc8ClothSim17addCollisionShapeEPKNS0_8ShapeSimE(i6, i12) | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i12;
   i4 = i13 + 2512 | 0;
   i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb(i4, i7, i14) | 0;
   i5 = i12;
   if (!(HEAP8[i14 >> 0] | 0)) {
    HEAP32[i1 >> 2] = i5;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i3 = 0;
   } else i3 = HEAP32[i1 + 8 >> 2] | 0;
   i1 = i13 + 2508 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i13 + 2216 | 0);
    i2 = HEAP32[i1 >> 2] | 0;
   }
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i10 = i13 + 2496 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i13 = i13 + 2500 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   if (!i2) i2 = 0; else {
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 4 >> 2] = i3;
   }
   HEAP32[i11 >> 2] = i12;
   i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb(i4, i11, i14) | 0;
   if (!(HEAP8[i14 >> 0] | 0)) {
    HEAP32[i1 >> 2] = i5;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i1 + 8 | 0;
    HEAP32[i1 >> 2] = 0;
   } else i1 = i1 + 8 | 0;
   HEAP32[i1 >> 2] = i2;
   STACKTOP = i15;
   return;
  }
 case 0:
  {
   __ZN5physx2Sc10NPhaseCore26createRbElementInteractionERNS0_8ShapeSimES3_(i13, i10, i12) | 0;
   STACKTOP = i15;
   return;
  }
 default:
  {
   STACKTOP = i15;
   return;
  }
 }
}

function __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2420;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI24GenerateTypeTreeTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2420;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2698;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb1EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2698;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2418;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2418;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function __ZN14SubstanceInput8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i4 = i9 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i9 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i5;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i7 = i2 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i9 >> 2] | 0 : i9;
 i7 = i7 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 16 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 20 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 32 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 36 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 48 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i9 + 52 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i11 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 __ZN14SubstanceValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 68 | 0, i10);
 i5 = i9 + 88 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i9 + 92 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i9 + 104 | 0, 0);
 i1 = i9 + 116 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 140 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = HEAP32[i9 + 152 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i5 = i9 + 148 | 0;
 i1 = HEAP32[i9 + 144 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i12 = i9 + 128 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i12, 0);
  STACKTOP = i13;
  return;
 }
 i2 = i1;
 while (1) {
  i1 = i2 + 16 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 i12 = i9 + 128 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i12, 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_(i46, i1, i6, i5) {
 i46 = i46 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i47 = 0, i48 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i48 + 104 | 0;
 i42 = i48;
 i44 = i48 + 56 | 0;
 i45 = i46 + 4 | 0;
 i3 = HEAP32[i45 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i46 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i41 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i41) | 0;
 i1 = HEAP32[i46 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i46 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i43 = HEAP32[i46 + 20 >> 2] | 0;
    i43 = (mftCall_iii(HEAP32[(HEAP32[i43 >> 2] | 0) + 16 >> 2] | 0, i43 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i43;
    i1 = HEAP32[i46 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i43;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i43 = HEAP32[i46 >> 2] | 0;
   HEAP8[(HEAP32[i43 + 4 >> 2] | 0) + ((HEAP32[i43 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i43 = i46 + 36 | 0;
 L12 : do if (HEAP8[i43 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i46, gb + 830924 | 0);
  if (!(HEAP8[i43 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i46 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i43 >> 0] = i1;
  }
  i40 = HEAP32[i46 >> 2] | 0;
  HEAP8[(HEAP32[i40 + 4 >> 2] | 0) + ((HEAP32[i40 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i40 = HEAP32[i46 >> 2] | 0;
  HEAP8[(HEAP32[i40 + 4 >> 2] | 0) + ((HEAP32[i40 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i21 = i44 + 4 | 0;
   i22 = i44 + 8 | 0;
   i23 = i44 + 12 | 0;
   i24 = i44 + 16 | 0;
   i25 = i44 + 32 | 0;
   i26 = i44 + 36 | 0;
   i27 = i46 + 8 | 0;
   i28 = i46 + 20 | 0;
   i29 = i46 + 28 | 0;
   i30 = i46 + 32 | 0;
   i31 = i44;
   i32 = i41;
   i33 = i42 + 4 | 0;
   i34 = i42 + 8 | 0;
   i35 = i42 + 20 | 0;
   i36 = i42 + 24 | 0;
   i37 = i42 + 28 | 0;
   i38 = i42 + 32 | 0;
   i39 = i42 + 36 | 0;
   i40 = i42 + 40 | 0;
   i12 = i42 + 44 | 0;
   i13 = i42 + 48 | 0;
   i14 = i5 + 36 | 0;
   i15 = i5 + 52 | 0;
   i16 = i5 + 68 | 0;
   i17 = i5 + 84 | 0;
   i18 = i5 + 100 | 0;
   i19 = i5 + 116 | 0;
   i20 = i5 + 132 | 0;
   i10 = i5 + 148 | 0;
   i11 = i46 + 24 | 0;
   i4 = i6 + 12 | 0;
   i5 = i46 + 40 | 0;
   i6 = 0;
   while (1) {
    HEAPF32[i44 >> 2] = Math_fround(0.0);
    HEAPF32[i21 >> 2] = Math_fround(0.0);
    HEAPF32[i22 >> 2] = Math_fround(.300000012);
    HEAPF32[i23 >> 2] = Math_fround(.100000001);
    HEAP32[i24 >> 2] = 0;
    HEAP32[i24 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 0;
    HEAP32[i24 + 12 >> 2] = 0;
    HEAPF32[i25 >> 2] = Math_fround(1.0);
    HEAPF32[i26 >> 2] = Math_fround(1.0);
    i8 = HEAP32[i46 >> 2] | 0;
    i7 = HEAP32[i45 >> 2] | 0;
    i1 = HEAP32[i28 >> 2] | 0;
    i2 = HEAP32[i29 >> 2] | 0;
    i3 = HEAP32[i30 >> 2] | 0;
    HEAP8[i41 >> 0] = 0;
    HEAP32[i42 >> 2] = i8;
    HEAP32[i33 >> 2] = i7;
    i7 = i34;
    i8 = i27;
    i9 = i7 + 12 | 0;
    do {
     HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
     i7 = i7 + 1 | 0;
     i8 = i8 + 1 | 0;
    } while ((i7 | 0) < (i9 | 0));
    HEAP32[i35 >> 2] = i1;
    HEAP32[i36 >> 2] = i31;
    HEAP32[i37 >> 2] = i2;
    HEAP32[i38 >> 2] = i3;
    HEAP8[i39 >> 0] = 1;
    HEAP32[i40 >> 2] = i32;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = 0;
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj587ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i14, 3);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj588ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i15, 4);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj589ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i16, 5);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj590ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i17, 6);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj591ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i18, 7);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj592ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i19, 8);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj593ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i20, 9);
    __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj594ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i42, i10, 10);
    if (HEAP8[i41 >> 0] | 0) HEAP8[HEAP32[i5 >> 2] >> 0] = 1;
    i1 = HEAP32[i11 >> 2] | 0;
    i7 = i42;
    i8 = i44;
    i9 = i7 + 48 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
    i7 = i41;
    i8 = i42;
    i9 = i7 + 48 | 0;
    do {
     HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
     i7 = i7 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i7 | 0) < (i9 | 0));
    mftCall_viii(i2 | 0, i1 | 0, i6 | 0, i41 | 0);
    if (!(HEAP8[i43 >> 0] | 0)) break L12;
    i9 = HEAP32[i28 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0) i6 = i6 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i45 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i48;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i46 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i46 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i47 = 22;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i46 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i46 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i43 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i43 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i47 | 0) == 22) HEAP8[i43 >> 0] = 1;
  i1 = HEAP32[i45 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i48;
 return;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i8 = i7 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i8 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 81 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 82 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 83 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 85 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 86 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = i2 + 32 | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i5 + 52 | 0;
 if (!(HEAP8[i5 + 50 >> 0] | 0)) {
  i5 = HEAP32[i1 >> 2] | 0;
  f16 = Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) * Math_fround(2.0));
  f14 = Math_fround(Math_fround(HEAPF32[i2 + 52 >> 2]) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) * Math_fround(2.0));
  f19 = Math_fround(HEAPF32[i5 + 28 >> 2]);
  f18 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f6 = Math_fround(f16 * f17);
  f15 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f14 * f15));
  f13 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f9 * f13));
  f8 = Math_fround(Math_fround(f17 * f6) + Math_fround(Math_fround(f16 * f18) + Math_fround(f19 * Math_fround(Math_fround(f9 * f15) - Math_fround(f14 * f13)))));
  f7 = Math_fround(Math_fround(f15 * f6) + Math_fround(Math_fround(f14 * f18) + Math_fround(f19 * Math_fround(Math_fround(f16 * f13) - Math_fround(f9 * f17)))));
  f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f17) - Math_fround(f16 * f15)))) + Math_fround(f13 * f6));
  f8 = Math_fround(Math_fround(HEAPF32[i5 + 32 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i5 + 36 >> 2]) + f7);
  f6 = Math_fround(Math_fround(HEAPF32[i5 + 40 >> 2]) + f6);
  f16 = Math_fround(HEAPF32[i3 >> 2]);
  f14 = Math_fround(f19 * f16);
  f18 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f17 * f18));
  f9 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f15 * f9));
  f12 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f11 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f15 * f18) + Math_fround(f19 * f12))) - Math_fround(f17 * f9));
  f10 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f13 * f18) + Math_fround(f19 * f9))) - Math_fround(f15 * f16));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f15 * f12)) - Math_fround(f13 * f9));
  HEAPF32[i4 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
  HEAPF32[i4 + 4 >> 2] = f11;
  HEAPF32[i4 + 8 >> 2] = f10;
  HEAPF32[i4 + 12 >> 2] = f9;
  HEAPF32[i4 + 16 >> 2] = f8;
  i5 = i4 + 20 | 0;
  HEAPF32[i5 >> 2] = f7;
  i5 = i4 + 24 | 0;
  HEAPF32[i5 >> 2] = f6;
  return;
 } else {
  i5 = HEAP32[i1 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i5 + 64 >> 2]);
  f7 = Math_fround(HEAPF32[i5 + 68 >> 2]);
  f19 = Math_fround(f19 * Math_fround(-2.0));
  f7 = Math_fround(f7 * Math_fround(-2.0));
  f17 = Math_fround(Math_fround(HEAPF32[i5 + 72 >> 2]) * Math_fround(-2.0));
  f15 = Math_fround(HEAPF32[i5 + 60 >> 2]);
  f9 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
  f13 = Math_fround(HEAPF32[i5 + 48 >> 2]);
  f12 = Math_fround(f19 * f13);
  f20 = Math_fround(HEAPF32[i5 + 52 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f7 * f20));
  f14 = Math_fround(HEAPF32[i5 + 56 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f17 * f14));
  f16 = Math_fround(-f13);
  f11 = Math_fround(-f20);
  f6 = Math_fround(-f14);
  f8 = Math_fround(Math_fround(Math_fround(f13 * f12) + Math_fround(Math_fround(f19 * f9) - Math_fround(f15 * Math_fround(Math_fround(f17 * f20) - Math_fround(f7 * f14))))) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(Math_fround(f20 * f12) + Math_fround(Math_fround(f7 * f9) - Math_fround(f15 * Math_fround(Math_fround(f19 * f14) - Math_fround(f17 * f13))))) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f9) - Math_fround(f15 * Math_fround(Math_fround(f7 * f13) - Math_fround(f19 * f20)))) + Math_fround(f14 * f12)) * Math_fround(2.0));
  f14 = Math_fround(HEAPF32[i5 + 28 >> 2]);
  f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
  f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f13 = Math_fround(f19 * f8);
  f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f7 * f10));
  f9 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f13 = Math_fround(Math_fround(f9 * f12) + f13);
  f17 = Math_fround(Math_fround(f19 * f13) + Math_fround(Math_fround(f20 * f8) + Math_fround(f14 * Math_fround(Math_fround(f7 * f12) - Math_fround(f9 * f10)))));
  f18 = Math_fround(Math_fround(f7 * f13) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f9 * f8) - Math_fround(f19 * f12)))));
  f13 = Math_fround(Math_fround(Math_fround(f20 * f12) + Math_fround(f14 * Math_fround(Math_fround(f19 * f10) - Math_fround(f7 * f8)))) + Math_fround(f9 * f13));
  f17 = Math_fround(Math_fround(HEAPF32[i5 + 32 >> 2]) + f17);
  f18 = Math_fround(Math_fround(HEAPF32[i5 + 36 >> 2]) + f18);
  f13 = Math_fround(Math_fround(HEAPF32[i5 + 40 >> 2]) + f13);
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) + Math_fround(f15 * f19)) + Math_fround(f7 * f6)) - Math_fround(f9 * f11));
  f10 = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(Math_fround(f14 * f11) + Math_fround(f15 * f7))) - Math_fround(f19 * f6));
  f12 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(Math_fround(f14 * f6) + Math_fround(f15 * f9))) - Math_fround(f7 * f16));
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f19 * f16)) - Math_fround(f7 * f11)) - Math_fround(f9 * f6));
  f9 = Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) * Math_fround(2.0));
  f11 = Math_fround(Math_fround(HEAPF32[i2 + 52 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) * Math_fround(2.0));
  f16 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
  f19 = Math_fround(Math_fround(Math_fround(f8 * f9) + Math_fround(f10 * f11)) + Math_fround(f12 * f7));
  f17 = Math_fround(f17 + Math_fround(Math_fround(f8 * f19) + Math_fround(Math_fround(f16 * f9) + Math_fround(f6 * Math_fround(Math_fround(f10 * f7) - Math_fround(f12 * f11))))));
  f18 = Math_fround(f18 + Math_fround(Math_fround(f10 * f19) + Math_fround(Math_fround(f16 * f11) + Math_fround(f6 * Math_fround(Math_fround(f12 * f9) - Math_fround(f8 * f7))))));
  f19 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f16 * f7) + Math_fround(f6 * Math_fround(Math_fround(f8 * f11) - Math_fround(f10 * f9)))) + Math_fround(f12 * f19)));
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(f6 * f9);
  f7 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f8 * f7));
  f16 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f10 * f16));
  f13 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f14 = Math_fround(Math_fround(Math_fround(f12 * f9) + Math_fround(Math_fround(f10 * f7) + Math_fround(f6 * f13))) - Math_fround(f8 * f16));
  f15 = Math_fround(Math_fround(Math_fround(f8 * f13) + Math_fround(Math_fround(f12 * f7) + Math_fround(f6 * f16))) - Math_fround(f10 * f9));
  f16 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * f9)) - Math_fround(f10 * f13)) - Math_fround(f12 * f16));
  HEAPF32[i4 >> 2] = Math_fround(f11 - Math_fround(f12 * f13));
  HEAPF32[i4 + 4 >> 2] = f14;
  HEAPF32[i4 + 8 >> 2] = f15;
  HEAPF32[i4 + 12 >> 2] = f16;
  HEAPF32[i4 + 16 >> 2] = f17;
  i5 = i4 + 20 | 0;
  HEAPF32[i5 >> 2] = f18;
  i5 = i4 + 24 | 0;
  HEAPF32[i5 >> 2] = f19;
  return;
 }
}

function __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2421;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI17RemapPPtrTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2421;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function runPostSets134() {
 HEAP32[gb + 115116 >> 2] = fb + 1873;
 HEAP32[gb + 115120 >> 2] = fb + 1348;
 HEAP32[gb + 115132 >> 2] = fb + 1870;
 HEAP32[gb + 115136 >> 2] = fb + 1874;
 HEAP32[gb + 115140 >> 2] = fb + 1349;
 HEAP32[gb + 115152 >> 2] = fb + 1870;
 HEAP32[gb + 115156 >> 2] = fb + 1875;
 HEAP32[gb + 115160 >> 2] = fb + 1350;
 HEAP32[gb + 115172 >> 2] = fb + 1870;
 HEAP32[gb + 115176 >> 2] = fb + 1876;
 HEAP32[gb + 115180 >> 2] = fb + 1351;
 HEAP32[gb + 115184 >> 2] = (HEAP32[gb + 115184 >> 2] | 0) + (gb + 741678 | 0);
 HEAP32[gb + 115200 >> 2] = (HEAP32[gb + 115200 >> 2] | 0) + (gb + 756582 | 0);
 HEAP32[gb + 115208 >> 2] = (HEAP32[gb + 115208 >> 2] | 0) + (gb + 756590 | 0);
 HEAP32[gb + 115224 >> 2] = (HEAP32[gb + 115224 >> 2] | 0) + (gb + 741693 | 0);
 HEAP32[gb + 115232 >> 2] = (HEAP32[gb + 115232 >> 2] | 0) + (gb + 741701 | 0);
 HEAP32[gb + 115240 >> 2] = (HEAP32[gb + 115240 >> 2] | 0) + (gb + 741720 | 0);
 HEAP32[gb + 115248 >> 2] = (HEAP32[gb + 115248 >> 2] | 0) + (gb + 741739 | 0);
 HEAP32[gb + 115256 >> 2] = (HEAP32[gb + 115256 >> 2] | 0) + (gb + 741751 | 0);
 HEAP32[gb + 115264 >> 2] = (HEAP32[gb + 115264 >> 2] | 0) + (gb + 741770 | 0);
 HEAP32[gb + 115272 >> 2] = (HEAP32[gb + 115272 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 115280 >> 2] = (HEAP32[gb + 115280 >> 2] | 0) + (gb + 741781 | 0);
 HEAP32[gb + 115288 >> 2] = (HEAP32[gb + 115288 >> 2] | 0) + (gb + 741806 | 0);
 HEAP32[gb + 115296 >> 2] = (HEAP32[gb + 115296 >> 2] | 0) + (gb + 741835 | 0);
 HEAP32[gb + 115304 >> 2] = (HEAP32[gb + 115304 >> 2] | 0) + (gb + 741851 | 0);
 HEAP32[gb + 115320 >> 2] = (HEAP32[gb + 115320 >> 2] | 0) + (gb + 756582 | 0);
 HEAP32[gb + 115328 >> 2] = (HEAP32[gb + 115328 >> 2] | 0) + (gb + 756590 | 0);
 HEAP32[gb + 115344 >> 2] = (HEAP32[gb + 115344 >> 2] | 0) + (gb + 741693 | 0);
 HEAP32[gb + 115352 >> 2] = (HEAP32[gb + 115352 >> 2] | 0) + (gb + 741701 | 0);
 HEAP32[gb + 115360 >> 2] = (HEAP32[gb + 115360 >> 2] | 0) + (gb + 741720 | 0);
 HEAP32[gb + 115368 >> 2] = (HEAP32[gb + 115368 >> 2] | 0) + (gb + 741739 | 0);
 HEAP32[gb + 115376 >> 2] = (HEAP32[gb + 115376 >> 2] | 0) + (gb + 741751 | 0);
 HEAP32[gb + 115384 >> 2] = (HEAP32[gb + 115384 >> 2] | 0) + (gb + 741770 | 0);
 HEAP32[gb + 115392 >> 2] = (HEAP32[gb + 115392 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 115400 >> 2] = (HEAP32[gb + 115400 >> 2] | 0) + (gb + 741781 | 0);
 HEAP32[gb + 115408 >> 2] = (HEAP32[gb + 115408 >> 2] | 0) + (gb + 741806 | 0);
 HEAP32[gb + 115416 >> 2] = (HEAP32[gb + 115416 >> 2] | 0) + (gb + 741835 | 0);
 HEAP32[gb + 115424 >> 2] = (HEAP32[gb + 115424 >> 2] | 0) + (gb + 741851 | 0);
 HEAP32[gb + 115440 >> 2] = (HEAP32[gb + 115440 >> 2] | 0) + (gb + 741678 | 0);
 HEAP32[gb + 115448 >> 2] = (HEAP32[gb + 115448 >> 2] | 0) + (gb + 742294 | 0);
 HEAP32[gb + 115456 >> 2] = (HEAP32[gb + 115456 >> 2] | 0) + (gb + 742309 | 0);
 HEAP32[gb + 115472 >> 2] = (HEAP32[gb + 115472 >> 2] | 0) + (gb + 741678 | 0);
 HEAP32[gb + 115480 >> 2] = (HEAP32[gb + 115480 >> 2] | 0) + (gb + 742294 | 0);
 HEAP32[gb + 115488 >> 2] = (HEAP32[gb + 115488 >> 2] | 0) + (gb + 742309 | 0);
 HEAP32[gb + 115504 >> 2] = (HEAP32[gb + 115504 >> 2] | 0) + (gb + 741678 | 0);
 HEAP32[gb + 115520 >> 2] = (HEAP32[gb + 115520 >> 2] | 0) + (gb + 741678 | 0);
 HEAP32[gb + 115536 >> 2] = (HEAP32[gb + 115536 >> 2] | 0) + (gb + 742754 | 0);
 HEAP32[gb + 115544 >> 2] = (HEAP32[gb + 115544 >> 2] | 0) + (gb + 742757 | 0);
 HEAP32[gb + 115552 >> 2] = (HEAP32[gb + 115552 >> 2] | 0) + (gb + 742760 | 0);
 HEAP32[gb + 115560 >> 2] = (HEAP32[gb + 115560 >> 2] | 0) + (gb + 742770 | 0);
 HEAP32[gb + 115568 >> 2] = (HEAP32[gb + 115568 >> 2] | 0) + (gb + 742799 | 0);
 HEAP32[gb + 115576 >> 2] = (HEAP32[gb + 115576 >> 2] | 0) + (gb + 742807 | 0);
 HEAP32[gb + 115592 >> 2] = (HEAP32[gb + 115592 >> 2] | 0) + (gb + 742754 | 0);
 HEAP32[gb + 115600 >> 2] = (HEAP32[gb + 115600 >> 2] | 0) + (gb + 742757 | 0);
 HEAP32[gb + 115608 >> 2] = (HEAP32[gb + 115608 >> 2] | 0) + (gb + 742760 | 0);
 HEAP32[gb + 115616 >> 2] = (HEAP32[gb + 115616 >> 2] | 0) + (gb + 742763 | 0);
 HEAP32[gb + 115624 >> 2] = (HEAP32[gb + 115624 >> 2] | 0) + (gb + 742770 | 0);
 HEAP32[gb + 115632 >> 2] = (HEAP32[gb + 115632 >> 2] | 0) + (gb + 742777 | 0);
 HEAP32[gb + 115648 >> 2] = (HEAP32[gb + 115648 >> 2] | 0) + (gb + 742740 | 0);
 HEAP32[gb + 115664 >> 2] = (HEAP32[gb + 115664 >> 2] | 0) + (gb + 742754 | 0);
 HEAP32[gb + 115672 >> 2] = (HEAP32[gb + 115672 >> 2] | 0) + (gb + 742757 | 0);
 HEAP32[gb + 115680 >> 2] = (HEAP32[gb + 115680 >> 2] | 0) + (gb + 742760 | 0);
 HEAP32[gb + 115688 >> 2] = (HEAP32[gb + 115688 >> 2] | 0) + (gb + 742770 | 0);
 HEAP32[gb + 115696 >> 2] = (HEAP32[gb + 115696 >> 2] | 0) + (gb + 742799 | 0);
 HEAP32[gb + 115704 >> 2] = (HEAP32[gb + 115704 >> 2] | 0) + (gb + 742807 | 0);
 HEAP32[gb + 115720 >> 2] = (HEAP32[gb + 115720 >> 2] | 0) + (gb + 742754 | 0);
 HEAP32[gb + 115728 >> 2] = (HEAP32[gb + 115728 >> 2] | 0) + (gb + 742757 | 0);
 HEAP32[gb + 115736 >> 2] = (HEAP32[gb + 115736 >> 2] | 0) + (gb + 742760 | 0);
 HEAP32[gb + 115744 >> 2] = (HEAP32[gb + 115744 >> 2] | 0) + (gb + 742763 | 0);
 HEAP32[gb + 115752 >> 2] = (HEAP32[gb + 115752 >> 2] | 0) + (gb + 742770 | 0);
 HEAP32[gb + 115760 >> 2] = (HEAP32[gb + 115760 >> 2] | 0) + (gb + 742777 | 0);
 HEAP32[gb + 115776 >> 2] = (HEAP32[gb + 115776 >> 2] | 0) + (gb + 742740 | 0);
 HEAP32[gb + 115792 >> 2] = (HEAP32[gb + 115792 >> 2] | 0) + (gb + 759891 | 0);
 HEAP32[gb + 115800 >> 2] = (HEAP32[gb + 115800 >> 2] | 0) + (gb + 742784 | 0);
 HEAP32[gb + 115808 >> 2] = (HEAP32[gb + 115808 >> 2] | 0) + (gb + 742793 | 0);
 HEAP32[gb + 115824 >> 2] = (HEAP32[gb + 115824 >> 2] | 0) + (gb + 761946 | 0);
 HEAP32[gb + 115832 >> 2] = (HEAP32[gb + 115832 >> 2] | 0) + (gb + 742853 | 0);
 HEAP32[gb + 115840 >> 2] = (HEAP32[gb + 115840 >> 2] | 0) + (gb + 742875 | 0);
 HEAP32[gb + 115856 >> 2] = (HEAP32[gb + 115856 >> 2] | 0) + (gb + 761946 | 0);
 HEAP32[gb + 115864 >> 2] = (HEAP32[gb + 115864 >> 2] | 0) + (gb + 742853 | 0);
 HEAP32[gb + 115872 >> 2] = (HEAP32[gb + 115872 >> 2] | 0) + (gb + 742875 | 0);
 HEAP32[gb + 115888 >> 2] = (HEAP32[gb + 115888 >> 2] | 0) + (gb + 742920 | 0);
 HEAP32[gb + 115896 >> 2] = (HEAP32[gb + 115896 >> 2] | 0) + (gb + 742962 | 0);
 HEAP32[gb + 115904 >> 2] = (HEAP32[gb + 115904 >> 2] | 0) + (gb + 743004 | 0);
 HEAP32[gb + 115912 >> 2] = (HEAP32[gb + 115912 >> 2] | 0) + (gb + 743055 | 0);
 HEAP32[gb + 115928 >> 2] = (HEAP32[gb + 115928 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 115936 >> 2] = (HEAP32[gb + 115936 >> 2] | 0) + (gb + 743094 | 0);
 HEAP32[gb + 115944 >> 2] = (HEAP32[gb + 115944 >> 2] | 0) + (gb + 743111 | 0);
 HEAP32[gb + 115952 >> 2] = (HEAP32[gb + 115952 >> 2] | 0) + (gb + 743132 | 0);
 HEAP32[gb + 115968 >> 2] = (HEAP32[gb + 115968 >> 2] | 0) + (gb + 743571 | 0);
 HEAP32[gb + 115976 >> 2] = (HEAP32[gb + 115976 >> 2] | 0) + (gb + 743578 | 0);
 HEAP32[gb + 115984 >> 2] = (HEAP32[gb + 115984 >> 2] | 0) + (gb + 743601 | 0);
 HEAP32[gb + 115992 >> 2] = (HEAP32[gb + 115992 >> 2] | 0) + (gb + 743625 | 0);
 HEAP32[gb + 116e3 >> 2] = (HEAP32[gb + 116e3 >> 2] | 0) + (gb + 743647 | 0);
 HEAP32[gb + 116016 >> 2] = (HEAP32[gb + 116016 >> 2] | 0) + (gb + 743434 | 0);
 HEAP32[gb + 116024 >> 2] = (HEAP32[gb + 116024 >> 2] | 0) + (gb + 743452 | 0);
 HEAP32[gb + 116032 >> 2] = (HEAP32[gb + 116032 >> 2] | 0) + (gb + 743483 | 0);
 HEAP32[gb + 116040 >> 2] = (HEAP32[gb + 116040 >> 2] | 0) + (gb + 743492 | 0);
 HEAP32[gb + 116048 >> 2] = (HEAP32[gb + 116048 >> 2] | 0) + (gb + 743510 | 0);
 HEAP32[gb + 116056 >> 2] = (HEAP32[gb + 116056 >> 2] | 0) + (gb + 743536 | 0);
 runPostSets135();
}

function __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE3AddERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEES4_(i12, i7, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 84 | 0;
 i13 = i16 + 36 | 0;
 i1 = i16 + 80 | 0;
 i14 = i16 + 16 | 0;
 i2 = i16;
 i6 = i16 + 68 | 0;
 i15 = i16 + 56 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE6RemoveES4_(i12, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
 HEAP32[i2 >> 2] = i5;
 i5 = i2 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 i1 = i14 + 4 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i9 = i4 << 24 >> 24 < 0;
 i3 = i9 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i9 ? HEAP32[i2 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 16 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i14 + 16 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 6;
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i17 = i4 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i14 + 12 >> 2] = i17 | -2147483648;
  HEAP32[i14 + 8 >> 2] = i4;
  i1 = i9;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i2 = i12 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  i4 = HEAP32[i14 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i10 = 11;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i10 = 16;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i10 = 15;
     break;
    } else i1 = i2;
   }
  }
  if ((i10 | 0) == 11) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i10 | 0) == 15) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i10 | 0) == 16) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i11;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE(i13, i12, i14);
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i12 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 4 >> 2] | 0, i1);
  i17 = i12 + 8 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 i1 = i14 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i17 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i14 + 16 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i9 = i12 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i15, i7);
 i4 = HEAP32[i8 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i15);
 i3 = i14 + 12 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = HEAP8[i14 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
 i4 = i1 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i10 = 27;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i13 + 11 >> 0] = i4;
  if (!i4) i1 = i13; else {
   i1 = i13;
   i10 = 29;
  }
 } else i10 = 27;
 if ((i10 | 0) == 27) {
  i17 = i4 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i17 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i4;
  i10 = 29;
 }
 if ((i10 | 0) == 29) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i13 + 16 >> 2] = HEAP32[i3 >> 2];
 i1 = i12 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) {
  i2 = i1;
  i3 = i1;
 } else {
  i6 = HEAP8[i13 + 11 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
  i7 = i7 ? HEAP32[i13 >> 2] | 0 : i13;
  i1 = i2;
  while (1) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i6 >>> 0 ? i5 : i6;
   if (!i2) i10 = 34; else {
    i2 = _memcmp(i7, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (!i2) i10 = 34; else if ((i2 | 0) < 0) i10 = 36; else i10 = 38;
   }
   if ((i10 | 0) == 34) if (i6 >>> 0 < i5 >>> 0) i10 = 36; else i10 = 38;
   if ((i10 | 0) == 36) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i10 = 37;
     break;
    } else i1 = i2;
   } else if ((i10 | 0) == 38) {
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i10 = 40;
     break;
    } else i1 = i2;
   }
  }
  if ((i10 | 0) == 37) {
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i10 | 0) == 40) {
   i2 = i1;
   break;
  }
 } while (0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i11, i9, i13);
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i9 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 16 >> 2] | 0, i1);
 i17 = i12 + 20 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 if ((HEAP8[i13 + 11 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i16;
  return;
 }
 i17 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i17, i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN7mecanim5human21HumanGetColliderXformEPKNS0_5HumanERKN4math4trsXEi(i4, i5, i7, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i8 = i4 + 28 | 0;
 i9 = i4 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i9 >> 2] = 1065353216;
 HEAP32[i8 >> 2] = 1065353216;
 i10 = i4 + 32 | 0;
 HEAP32[i10 >> 2] = 1065353216;
 i11 = i4 + 36 | 0;
 HEAP32[i11 >> 2] = 1065353216;
 i1 = HEAP32[i5 + 72 + (i3 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i6 = i5 + 40 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i2 = i6 + 4 | 0;
 i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 i1 = HEAP32[i5 + 264 + (i3 << 2) >> 2] | 0;
 if ((i1 | i2 | 0) <= -1) return;
 i18 = HEAP32[i7 + 4 >> 2] | 0;
 i17 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 i20 = i4 + 4 | 0;
 HEAP32[i20 >> 2] = i18;
 i18 = i4 + 8 | 0;
 HEAP32[i18 >> 2] = i17;
 i17 = i4 + 12 | 0;
 i39 = HEAP32[i7 + 12 >> 2] | 0;
 i42 = HEAP32[i7 + 16 >> 2] | 0;
 i40 = HEAP32[i7 + 20 >> 2] | 0;
 i41 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i17 >> 2] = i39;
 i16 = i4 + 16 | 0;
 HEAP32[i16 >> 2] = i42;
 i3 = i4 + 20 | 0;
 HEAP32[i3 >> 2] = i40;
 HEAP32[i9 >> 2] = i41;
 i37 = HEAP32[i7 + 28 >> 2] | 0;
 i36 = HEAP32[i7 + 32 >> 2] | 0;
 i7 = HEAP32[i7 + 36 >> 2] | 0;
 HEAP32[i8 >> 2] = i37;
 HEAP32[i10 >> 2] = i36;
 HEAP32[i11 >> 2] = i7;
 i38 = i6 + 16 | 0;
 i38 = i38 + (HEAP32[i38 >> 2] | 0) | 0;
 f33 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(HEAPF32[i38 + (i2 * 76 | 0) + 16 >> 2]);
 f26 = Math_fround(f33 * f23);
 f27 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f32 = Math_fround(HEAPF32[i38 + (i2 * 76 | 0) + 28 >> 2]);
 f28 = Math_fround(f27 * f32);
 f24 = (HEAP32[tempDoublePtr >> 2] = i40, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(HEAPF32[i38 + (i2 * 76 | 0) + 20 >> 2]);
 f29 = Math_fround(f24 * f30);
 f34 = (HEAP32[tempDoublePtr >> 2] = i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(HEAPF32[i38 + (i2 * 76 | 0) + 24 >> 2]);
 f26 = Math_fround(Math_fround(Math_fround(f26 - Math_fround(f27 * f12)) - Math_fround(f32 * f24)) - Math_fround(f30 * f34));
 f28 = Math_fround(Math_fround(Math_fround(f28 - Math_fround(f23 * f34)) - Math_fround(f24 * f12)) - Math_fround(f33 * f30));
 f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f33 * f12)) - Math_fround(f23 * f27)) - Math_fround(f32 * f34));
 f32 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f12) - Math_fround(f23 * f24)) - Math_fround(f27 * f30)) - Math_fround(f33 * f32));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i38 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f32 = (HEAP32[tempDoublePtr >> 2] = i38 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f32 * f32);
 f26 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f26 * f26);
 f30 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f29 + f33) + Math_fround(Math_fround(f28 * f28) + Math_fround(f30 * f30))))));
 f32 = Math_fround(f33 * f32);
 f26 = Math_fround(f33 * f26);
 f30 = Math_fround(f33 * f30);
 f28 = Math_fround(f33 * f28);
 HEAPF32[i17 >> 2] = f32;
 HEAPF32[i16 >> 2] = f26;
 HEAPF32[i3 >> 2] = f30;
 HEAPF32[i9 >> 2] = f28;
 i2 = i5 + 68 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 f33 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) >> 2]);
 f29 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 8 >> 2]);
 f24 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f33 = Math_fround(f33 * f24);
 f29 = Math_fround(f29 * f23);
 f27 = Math_fround(f27 * f12);
 f34 = Math_fround(f26 * Math_fround(-2.0));
 f14 = Math_fround(f26 * Math_fround(2.0));
 f31 = Math_fround(f34 * f28);
 f25 = Math_fround(f30 * Math_fround(2.0));
 f13 = Math_fround(f30 * Math_fround(-2.0));
 f35 = Math_fround(f28 * f13);
 f15 = Math_fround(f32 * Math_fround(-2.0));
 f21 = Math_fround(f32 * Math_fround(2.0));
 f19 = Math_fround(f28 * f15);
 f22 = Math_fround(Math_fround(f33 + Math_fround(f33 * Math_fround(Math_fround(f26 * f34) - Math_fround(f30 * f25)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f21 * f30) - f31)) + Math_fround(f29 * Math_fround(f35 - Math_fround(f26 * f15)))));
 f21 = Math_fround(Math_fround(f29 + Math_fround(f33 * Math_fround(Math_fround(f32 * f14) - f35))) + Math_fround(Math_fround(f27 * Math_fround(f19 - Math_fround(f34 * f30))) + Math_fround(f29 * Math_fround(Math_fround(f30 * f13) - Math_fround(f32 * f21)))));
 f19 = Math_fround(Math_fround(f27 + Math_fround(f33 * Math_fround(f31 - Math_fround(f32 * f13)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f32 * f15) - Math_fround(f26 * f14))) + Math_fround(f29 * Math_fround(Math_fround(f26 * f25) - f19))));
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f29 = Math_fround(HEAPF32[i20 >> 2]);
 f22 = Math_fround(f25 + f22);
 f21 = Math_fround(f29 + f21);
 f19 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f19);
 f29 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 12 >> 2]);
 f25 = Math_fround(f26 * f29);
 f14 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 24 >> 2]);
 f15 = Math_fround(f28 * f14);
 f27 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 16 >> 2]);
 f13 = Math_fround(f30 * f27);
 f31 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 20 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f25 - Math_fround(f28 * f31)) - Math_fround(f30 * f14)) - Math_fround(f32 * f27));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f32 * f29)) - Math_fround(f30 * f31)) - Math_fround(f26 * f27));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f26 * f31)) - Math_fround(f28 * f29)) - Math_fround(f32 * f14));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f31) - Math_fround(f30 * f29)) - Math_fround(f28 * f27)) - Math_fround(f26 * f14));
 i7 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f14 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 28 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 32 >> 2]);
 f14 = Math_fround(f24 * f14);
 f13 = Math_fround(f23 * f13);
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i2 + (i1 * 72 | 0) + 36 >> 2]));
 HEAPF32[i4 >> 2] = f22;
 HEAPF32[i20 >> 2] = f21;
 HEAPF32[i18 >> 2] = f19;
 HEAP32[i17 >> 2] = i5 ^ -2147483648;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i3 >> 2] = i7 ^ -2147483648;
 HEAPF32[i9 >> 2] = f15;
 HEAPF32[i8 >> 2] = f14;
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i11 >> 2] = f12;
 return;
}

function _UNITY_TT_Get_MM_Var(i1, i18) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i20 + 44 | 0;
 i19 = i20 + 40 | 0;
 i4 = i20 + 24 | 0;
 i12 = i20;
 i15 = HEAP32[i1 + 104 >> 2] | 0;
 i16 = HEAP32[i1 + 100 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 i17 = i1 + 676 | 0;
 L1 : do if (!(HEAP32[i17 >> 2] | 0)) {
  i2 = i1 + 508 | 0;
  i14 = mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1735811442, i15 | 0, i5 | 0) | 0;
  HEAP32[i19 >> 2] = i14;
  if (i14 | 0) {
   i19 = HEAP32[i19 >> 2] | 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  i14 = mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1719034226, i15 | 0, i5 | 0) | 0;
  HEAP32[i19 >> 2] = i14;
  if (i14 | 0) {
   i19 = HEAP32[i19 >> 2] | 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  i10 = _UNITY_FT_Stream_Pos(i15) | 0;
  i14 = _UNITY_FT_Stream_ReadFields(i15, gb + 227830 | 0, i4) | 0;
  HEAP32[i19 >> 2] = i14;
  if (i14 | 0) {
   i19 = HEAP32[i19 >> 2] | 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  if ((HEAP32[i4 >> 2] | 0) == 65536) if ((HEAP16[i4 + 10 >> 1] | 0) == 20) {
   i13 = i4 + 8 | 0;
   i14 = HEAP16[i13 >> 1] | 0;
   i1 = i14 & 65535;
   if ((i14 & 65535) <= 16382) {
    i2 = HEAPU16[i4 + 14 >> 1] | 0;
    if ((i2 | 0) == ((i1 << 2) + 4 | 0)) {
     i14 = i4 + 12 | 0;
     i3 = HEAP16[i14 >> 1] | 0;
     if ((i3 & 65535) <= 32511) {
      i9 = i4 + 4 | 0;
      i11 = (Math_imul(i3 & 65535, i2) | 0) + (i1 * 20 | 0) + (HEAPU16[i9 >> 1] | 0) | 0;
      if (i11 >>> 0 <= (HEAP32[i5 >> 2] | 0) >>> 0) {
       i1 = _UNITY_ft_mem_alloc(i16, 40, i19) | 0;
       HEAP32[i17 >> 2] = i1;
       if (HEAP32[i19 >> 2] | 0) {
        i19 = HEAP32[i19 >> 2] | 0;
        STACKTOP = i20;
        return i19 | 0;
       }
       i11 = HEAPU16[i14 >> 1] | 0;
       i11 = (i11 << 3) + 20 + (Math_imul((i11 << 2) + 29 | 0, HEAPU16[i13 >> 1] | 0) | 0) | 0;
       HEAP32[i1 + 12 >> 2] = i11;
       i1 = _UNITY_ft_mem_alloc(i16, i11, i19) | 0;
       if (HEAP32[i19 >> 2] | 0) {
        i19 = HEAP32[i19 >> 2] | 0;
        STACKTOP = i20;
        return i19 | 0;
       }
       HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] = i1;
       i5 = HEAP16[i13 >> 1] | 0;
       i6 = i5 & 65535;
       HEAP32[i1 >> 2] = i6;
       HEAP32[i1 + 4 >> 2] = -1;
       i2 = HEAP16[i14 >> 1] | 0;
       i3 = i2 & 65535;
       HEAP32[i1 + 8 >> 2] = i3;
       i7 = i1 + 20 | 0;
       i8 = i1 + 12 | 0;
       HEAP32[i8 >> 2] = i7;
       i4 = i7 + (i6 * 24 | 0) | 0;
       i11 = i1 + 16 | 0;
       HEAP32[i11 >> 2] = i4;
       i1 = i4 + (i3 << 3) | 0;
       if (i2 << 16 >> 16) {
        i2 = 0;
        do {
         HEAP32[i4 + (i2 << 3) >> 2] = i1;
         i1 = i1 + (i6 << 2) | 0;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) < (i3 | 0));
       }
       if (i5 << 16 >> 16) {
        i2 = 0;
        while (1) {
         HEAP32[i7 + (i2 * 24 | 0) >> 2] = i1;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) >= (i6 | 0)) break; else i1 = i1 + 5 | 0;
        }
       }
       i10 = _UNITY_FT_Stream_Seek(i15, (HEAPU16[i9 >> 1] | 0) + i10 | 0) | 0;
       HEAP32[i19 >> 2] = i10;
       if (i10 | 0) {
        i19 = HEAP32[i19 >> 2] | 0;
        STACKTOP = i20;
        return i19 | 0;
       }
       L37 : do if (!(HEAP16[i13 >> 1] | 0)) i2 = 0; else {
        i5 = i12 + 4 | 0;
        i6 = i12 + 8 | 0;
        i7 = i12 + 12 | 0;
        i4 = i12 + 18 | 0;
        i1 = HEAP32[i8 >> 2] | 0;
        i3 = 0;
        while (1) {
         i10 = _UNITY_FT_Stream_ReadFields(i15, gb + 227866 | 0, i12) | 0;
         HEAP32[i19 >> 2] = i10;
         if (i10 | 0) break;
         i10 = HEAP32[i12 >> 2] | 0;
         i2 = i1 + 16 | 0;
         HEAP32[i2 >> 2] = i10;
         HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
         HEAP32[i1 + 8 >> 2] = HEAP32[i6 >> 2];
         HEAP32[i1 + 12 >> 2] = HEAP32[i7 >> 2];
         HEAP32[i1 + 20 >> 2] = HEAPU16[i4 >> 1];
         HEAP8[HEAP32[i1 >> 2] >> 0] = i10 >>> 24;
         HEAP8[(HEAP32[i1 >> 2] | 0) + 1 >> 0] = (HEAP32[i2 >> 2] | 0) >>> 16;
         HEAP8[(HEAP32[i1 >> 2] | 0) + 2 >> 0] = (HEAP32[i2 >> 2] | 0) >>> 8;
         HEAP8[(HEAP32[i1 >> 2] | 0) + 3 >> 0] = HEAP32[i2 >> 2];
         HEAP8[(HEAP32[i1 >> 2] | 0) + 4 >> 0] = 0;
         i3 = i3 + 1 | 0;
         i2 = HEAP16[i13 >> 1] | 0;
         if ((i3 | 0) >= (i2 & 65535 | 0)) break L37; else i1 = i1 + 24 | 0;
        }
        i19 = HEAP32[i19 >> 2] | 0;
        STACKTOP = i20;
        return i19 | 0;
       } while (0);
       if (!(HEAP16[i14 >> 1] | 0)) break;
       i1 = HEAP32[i11 >> 2] | 0;
       i12 = _UNITY_FT_Stream_EnterFrame(i15, ((i2 & 65535) << 2) + 4 | 0) | 0;
       HEAP32[i19 >> 2] = i12;
       if (!i12) i3 = 0; else {
        i19 = HEAP32[i19 >> 2] | 0;
        STACKTOP = i20;
        return i19 | 0;
       }
       while (1) {
        HEAP32[i1 + 4 >> 2] = (_UNITY_FT_Stream_GetUShort(i15) | 0) & 65535;
        _UNITY_FT_Stream_GetUShort(i15) | 0;
        if (HEAP16[i13 >> 1] | 0) {
         i2 = 0;
         do {
          i12 = _UNITY_FT_Stream_GetULong(i15) | 0;
          HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = i12;
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) < (HEAPU16[i13 >> 1] | 0));
        }
        _UNITY_FT_Stream_ExitFrame(i15);
        i3 = i3 + 1 | 0;
        if ((i3 | 0) >= (HEAPU16[i14 >> 1] | 0)) break L1;
        i12 = _UNITY_FT_Stream_EnterFrame(i15, (HEAPU16[i13 >> 1] << 2) + 4 | 0) | 0;
        HEAP32[i19 >> 2] = i12;
        if (i12 | 0) break; else i1 = i1 + 8 | 0;
       }
       i19 = HEAP32[i19 >> 2] | 0;
       STACKTOP = i20;
       return i19 | 0;
      }
     }
    }
   }
  }
  HEAP32[i19 >> 2] = 8;
  i19 = HEAP32[i19 >> 2] | 0;
  STACKTOP = i20;
  return i19 | 0;
 } while (0);
 if (!i18) {
  i19 = HEAP32[i19 >> 2] | 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i7 = _UNITY_ft_mem_alloc(i16, HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i19) | 0;
 if (HEAP32[i19 >> 2] | 0) {
  i19 = HEAP32[i19 >> 2] | 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i2 = HEAP32[i17 >> 2] | 0;
 _memcpy(i7 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 i2 = i7 + 20 | 0;
 HEAP32[i7 + 12 >> 2] = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + (i6 * 24 | 0) | 0;
 HEAP32[i7 + 16 >> 2] = i4;
 i5 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = i4 + (i5 << 3) | 0;
 if (i5) {
  i3 = 0;
  do {
   HEAP32[i4 + (i3 << 3) >> 2] = i1;
   i1 = i1 + (i6 << 2) | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i5 >>> 0);
 }
 if (i6 | 0) {
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   L74 : do if ((i3 | 0) < 2003072104) if ((i3 | 0) < 1936486004) {
    switch (i3 | 0) {
    case 1869640570:
     break;
    default:
     break L74;
    }
    HEAP32[i2 >> 2] = gb + 1007743;
    break;
   } else {
    switch (i3 | 0) {
    case 1936486004:
     break;
    default:
     break L74;
    }
    HEAP32[i2 >> 2] = gb + 1007755;
    break;
   } else if ((i3 | 0) < 2003265652) {
    switch (i3 | 0) {
    case 2003072104:
     break;
    default:
     break L74;
    }
    HEAP32[i2 >> 2] = gb + 1007737;
    break;
   } else {
    switch (i3 | 0) {
    case 2003265652:
     break;
    default:
     break L74;
    }
    HEAP32[i2 >> 2] = gb + 1007730;
    break;
   } while (0);
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= i6 >>> 0) break; else {
    i1 = i1 + 5 | 0;
    i2 = i2 + 24 | 0;
   }
  }
 }
 HEAP32[i18 >> 2] = i7;
 i19 = HEAP32[i19 >> 2] | 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i15, i25, i16, i17, i18) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 32 | 0;
 i22 = i28 + 24 | 0;
 i23 = i28;
 i26 = i28 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i19 = i15 + 8 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 if (!i17) {
  i2 = i21 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i20 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i14 = i23;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i20, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i20;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2422;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i24) | 0;
 if (i1 | 0) if ((HEAP32[i21 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i21 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i27 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i27 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  HEAP32[i27 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i27, i25, i16, 1, 0);
 }
 HEAP32[i26 >> 2] = 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i24, i26);
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i20 >> 2] | 0)) {
  i7 = i27 + 24 | 0;
  i8 = i27 + 25 | 0;
  i9 = i27 + 8 | 0;
  i10 = i27 + 12 | 0;
  i11 = i27 + 4 | 0;
  i12 = i27 + 16 | 0;
  i13 = i27 + 20 | 0;
  i14 = i15 + 16 | 0;
  i2 = i15 + 12 | 0;
  i3 = i27 + 32 | 0;
  i4 = i27 + 28 | 0;
  i5 = i27 + 36 | 0;
  i6 = i27 + 40 | 0;
  do {
   i29 = HEAP32[i1 >> 2] | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i8 >> 0] = 0;
   HEAP32[i27 >> 2] = i29;
   i15 = __Z24scripting_field_get_typeP9FieldInfo(i29) | 0;
   HEAP32[i9 >> 2] = i15;
   HEAP32[i10 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i15) | 0;
   HEAP32[i11 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i29) | 0;
   HEAP32[i13 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i29) | 0;
   HEAP16[i7 >> 1] = HEAP16[i14 >> 1] | 0;
   i29 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i4 >> 2] = 0;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP32[i5 >> 2] = i15;
   HEAP32[i6 >> 2] = i18;
   if (__Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i25, i24, i29, i27, i15) | 0) __Z33EmitSerializationCommandsForFieldI14SafeBinaryReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i27, i25, i16);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i20 >> 2] | 0));
 }
 if (!i17) {
  i1 = i21 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i24, HEAP32[i21 + 224 >> 2] | 0) | 0) {
   i29 = __Z20scripting_object_newP11Il2CppClass(i24) | 0;
   i24 = i23;
   HEAP32[i24 >> 2] = i2;
   HEAP32[i24 + 4 >> 2] = i1;
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i27 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i22, i29, i27);
   if (HEAP32[i22 >> 2] | 0) {
    i2 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i27 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i22 + 4 >> 0] | 0;
    i2 = i25 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i25 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i25 >> 2] = i29;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 2422;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i27;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i20 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = 1;
 HEAP32[i27 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i27);
 STACKTOP = i28;
 return;
}

function __ZN5physx2Sc7BodySimC2ERNS0_5SceneERNS0_8BodyCoreE(i17, i5, i16) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 __ZN5physx2Sc8RigidSimC2ERNS0_5SceneERNS0_9RigidCoreENS0_14IslandNodeInfo4TypeE(i17, i5, i16, 4);
 HEAP32[i17 >> 2] = gb + 90988 + 8;
 i14 = i17 + 60 | 0;
 i15 = i17 + 64 | 0;
 i1 = i16 + 16 | 0;
 i2 = i17 + 96 | 0;
 i3 = i14;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i17 + 100 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i17 + 104 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i17 + 108 >> 2] = HEAP32[i16 + 28 >> 2];
 HEAP32[i17 + 112 >> 2] = HEAP32[i16 + 32 >> 2];
 HEAP32[i17 + 116 >> 2] = HEAP32[i16 + 36 >> 2];
 HEAP32[i17 + 120 >> 2] = HEAP32[i16 + 40 >> 2];
 HEAP32[i17 + 124 >> 2] = 0;
 HEAP32[i17 + 128 >> 2] = i1;
 HEAP32[i17 + 132 >> 2] = 1073741823;
 HEAP32[i17 + 136 >> 2] = 1073741823;
 i13 = i17 + 144 | 0;
 HEAP16[i13 >> 1] = 0;
 i6 = i17 + 146 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP16[i17 + 148 >> 1] = 0;
 i7 = i17 + 152 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i17 + 168 >> 2] = Math_fround(1.0);
 i12 = i17 + 172 | 0;
 i11 = i17 + 188 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i11 >> 2] = -1;
 i5 = HEAP32[i5 + 1204 >> 2] | 0;
 if (HEAP16[i16 + 8 >> 1] & 2) HEAP16[i13 >> 1] = 1;
 i12 = i16 + 156 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) i2 = 0; else if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i16, 0) | 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) i2 = 0; else {
   i3 = i1 + 12 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   if (!(i4 << 24 >> 24)) i2 = 0; else if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 16 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 20 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 24 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 32 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 36 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 40 >> 2]) == Math_fround(0.0)) {
    if (Math_fround(HEAPF32[i1 + 48 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 52 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i1 + 56 >> 2]) == Math_fround(0.0); else i1 = 0; else i1 = 0;
    i2 = i1 ^ 1;
   } else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1; else i2 = 1;
   HEAP8[i6 >> 0] = i4;
   HEAP8[i3 >> 0] = 0;
  }
 } else i2 = 0;
 if (Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i16)) > Math_fround(0.0)) i6 = 1; else if (Math_fround(HEAPF32[i16 + 80 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i16 + 84 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i16 + 88 >> 2]) == Math_fround(0.0)) {
  if (Math_fround(HEAPF32[i16 + 96 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i16 + 100 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i16 + 104 >> 2]) == Math_fround(0.0); else i1 = 0; else i1 = 0;
  i6 = i2 | i1 ^ 1;
 } else i6 = 1; else i6 = 1; else i6 = 1;
 i8 = HEAP8[(HEAP32[i17 + 52 >> 2] | 0) + 44 >> 0] & 1;
 i10 = i17 + 36 | 0;
 i9 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i10 >> 2] | 0) | 0;
 do if ((HEAP8[i17 + 50 >> 0] | 0) == 4) {
  __ZN5physx16PxsIslandManager19addArticulationLinkERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i10 >> 2] | 0) | 0, i11);
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK5physx2Sc15ArticulationSim13getLinkHandleERNS0_7BodySimE(i1, i17) | 0;
   i2 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i10 >> 2] | 0) | 0;
   if (!(i1 & 63)) {
    __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1, i17, i11);
    break;
   } else {
    __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1, i17, i11);
    break;
   }
  }
 } else __ZN5physx16PxsIslandManager7addBodyEPvRNS_20PxsIslandManagerHookIjLj4294967295EEEb(i9, i17, i11, i8 << 24 >> 24 != 0); while (0);
 __ZN5physx2Sc16InteractionScene8addActorERNS0_5ActorEb(i5, i17, i6);
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i9 + 16 >> 2] | 0;
 i2 = i5 + (i1 * 12 | 0) + 8 | 0;
 i4 = HEAP8[i2 >> 0] | 0;
 i3 = (i4 & 8) == 0;
 i4 = i4 & 231;
 if (i6) {
  HEAP8[i2 >> 0] = i4 | 8;
  do if (i3) {
   i7 = (HEAP32[HEAP32[i9 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i1 & 31);
   i1 = HEAP32[i11 >> 2] | 0;
   if (!(HEAP8[i5 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
    i2 = (HEAP32[HEAP32[i9 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i1 = 1 << (i1 & 31);
    if (!(i3 & i1)) {
     HEAP32[i2 >> 2] = i3 | i1;
     break;
    } else {
     HEAP32[i2 >> 2] = i3 & ~i1;
     break;
    }
   }
  } while (0);
  HEAP8[i9 + 477 >> 0] = 1;
 } else {
  HEAP8[i2 >> 0] = i4 | 16;
  do if (!i3) {
   i7 = (HEAP32[HEAP32[i9 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << (i1 & 31));
   i1 = HEAP32[i11 >> 2] | 0;
   if (!(HEAP8[i5 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
    i2 = (HEAP32[HEAP32[i9 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i1 = 1 << (i1 & 31);
    if (!(i3 & i1)) {
     HEAP32[i2 >> 2] = i3 | i1;
     break;
    } else {
     HEAP32[i2 >> 2] = i3 & ~i1;
     break;
    }
   }
  } while (0);
  HEAP8[i9 + 477 >> 0] = 1;
 }
 if (!(i8 << 24 >> 24)) return;
 __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE(i17, 2);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(i1, HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i17) | 0) + 96 >> 2] | 0);
 if (HEAP32[i12 >> 2] | 0) {
  i15 = (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i16, 1) | 0) ^ 1;
  if (!((HEAP32[i12 >> 2] | 0) == 0 | i15)) {
   HEAP16[i13 >> 1] = HEAPU16[i13 >> 1] | 4;
   return;
  }
 }
 __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb(i16, HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i17) | 0) + 1232 >> 2] | 0, 1, 0) | 0;
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i10 >> 2] | 0) | 0;
 i1 = i17 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 i16 = i3 + (i2 * 12 | 0) + 8 | 0;
 i17 = HEAP8[i16 >> 0] | 0;
 HEAP8[i16 >> 0] = i17 & 231 | 16;
 do if (i17 & 8) {
  i17 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & ~(1 << (i2 & 31));
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i3 & i1)) {
    HEAP32[i2 >> 2] = i3 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i3 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i4 + 477 >> 0] = 1;
 return;
}

function __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPNS_17PxContactPairPoseEjRKNS0_8RigidSimEb(i3, i4, i6, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i1 = i6 + 52 | 0;
 if (!(HEAP8[i6 + 50 >> 0] | 0)) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 4 + (i4 * 28 | 0) >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 32 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 36 >> 2];
  HEAP32[i3 + 4 + (i4 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 40 >> 2];
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 4 + (i4 * 28 | 0) | 0;
 if (i5) {
  i6 = i6 + 64 | 0;
  f20 = Math_fround(HEAPF32[i6 + 32 >> 2]);
  f16 = Math_fround(HEAPF32[i6 + 36 >> 2]);
  f14 = Math_fround(HEAPF32[i6 + 40 >> 2]);
  f18 = Math_fround(HEAPF32[i6 + 44 >> 2]);
  f9 = Math_fround(HEAPF32[i6 + 48 >> 2]);
  f8 = Math_fround(HEAPF32[i6 + 52 >> 2]);
  f22 = Math_fround(HEAPF32[i6 + 56 >> 2]);
  f23 = Math_fround(HEAPF32[i1 + 64 >> 2]);
  f25 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  f23 = Math_fround(f23 * Math_fround(-2.0));
  f25 = Math_fround(f25 * Math_fround(-2.0));
  f27 = Math_fround(Math_fround(HEAPF32[i1 + 72 >> 2]) * Math_fround(-2.0));
  f19 = Math_fround(HEAPF32[i1 + 60 >> 2]);
  f26 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f24 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f10 = Math_fround(f23 * f24);
  f7 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f25 * f7));
  f21 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f27 * f21));
  f17 = Math_fround(-f24);
  f13 = Math_fround(-f7);
  f15 = Math_fround(-f21);
  f12 = Math_fround(Math_fround(Math_fround(f24 * f10) + Math_fround(Math_fround(f23 * f26) - Math_fround(f19 * Math_fround(Math_fround(f27 * f7) - Math_fround(f25 * f21))))) * Math_fround(2.0));
  f11 = Math_fround(Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f25 * f26) - Math_fround(f19 * Math_fround(Math_fround(f23 * f21) - Math_fround(f27 * f24))))) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f26) - Math_fround(f19 * Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f7)))) + Math_fround(f21 * f10)) * Math_fround(2.0));
  f21 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
  f7 = Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f20 * f12) + Math_fround(f16 * f11)));
  f9 = Math_fround(f9 + Math_fround(Math_fround(f20 * f7) + Math_fround(Math_fround(f21 * f12) + Math_fround(f18 * Math_fround(Math_fround(f16 * f10) - Math_fround(f14 * f11))))));
  f8 = Math_fround(f8 + Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f21 * f11) + Math_fround(f18 * Math_fround(Math_fround(f14 * f12) - Math_fround(f20 * f10))))));
  f7 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f21 * f10) + Math_fround(f18 * Math_fround(Math_fround(f20 * f11) - Math_fround(f16 * f12)))) + Math_fround(f14 * f7)));
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f18 * f13))) - Math_fround(f20 * f15));
  f11 = Math_fround(Math_fround(Math_fround(f20 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f18 * f15))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f19) - Math_fround(f20 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f15));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f17)) + Math_fround(f16 * f15)) - Math_fround(f14 * f13));
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 4 >> 2] = f12;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 8 >> 2] = f11;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 12 >> 2] = f10;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 16 >> 2] = f9;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 20 >> 2] = f8;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 24 >> 2] = f7;
  return;
 } else {
  f17 = Math_fround(HEAPF32[i1 + 64 >> 2]);
  f18 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  f17 = Math_fround(f17 * Math_fround(-2.0));
  f18 = Math_fround(f18 * Math_fround(-2.0));
  f25 = Math_fround(Math_fround(HEAPF32[i1 + 72 >> 2]) * Math_fround(-2.0));
  f16 = Math_fround(HEAPF32[i1 + 60 >> 2]);
  f20 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
  f27 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f24 = Math_fround(f17 * f27);
  f13 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f18 * f13));
  f14 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f25 * f14));
  f15 = Math_fround(-f27);
  f21 = Math_fround(-f13);
  f19 = Math_fround(-f14);
  f22 = Math_fround(Math_fround(Math_fround(f27 * f24) + Math_fround(Math_fround(f17 * f20) - Math_fround(f16 * Math_fround(Math_fround(f25 * f13) - Math_fround(f18 * f14))))) * Math_fround(2.0));
  f23 = Math_fround(Math_fround(Math_fround(f13 * f24) + Math_fround(Math_fround(f18 * f20) - Math_fround(f16 * Math_fround(Math_fround(f17 * f14) - Math_fround(f25 * f27))))) * Math_fround(2.0));
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f20) - Math_fround(f16 * Math_fround(Math_fround(f18 * f27) - Math_fround(f17 * f13)))) + Math_fround(f14 * f24)) * Math_fround(2.0));
  f14 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  f13 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f27 = Math_fround(f17 * f22);
  f18 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f27 = Math_fround(f27 + Math_fround(f18 * f23));
  f20 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f27 = Math_fround(Math_fround(f20 * f24) + f27);
  f25 = Math_fround(Math_fround(f17 * f27) + Math_fround(Math_fround(f13 * f22) + Math_fround(f14 * Math_fround(Math_fround(f18 * f24) - Math_fround(f20 * f23)))));
  f26 = Math_fround(Math_fround(f18 * f27) + Math_fround(Math_fround(f13 * f23) + Math_fround(f14 * Math_fround(Math_fround(f20 * f22) - Math_fround(f17 * f24)))));
  f27 = Math_fround(Math_fround(Math_fround(f13 * f24) + Math_fround(f14 * Math_fround(Math_fround(f17 * f23) - Math_fround(f18 * f22)))) + Math_fround(f20 * f27));
  f25 = Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) + f25);
  f26 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) + f26);
  f27 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) + f27);
  f22 = Math_fround(Math_fround(Math_fround(f20 * f15) + Math_fround(Math_fround(f14 * f21) + Math_fround(f16 * f18))) - Math_fround(f17 * f19));
  f23 = Math_fround(Math_fround(Math_fround(f17 * f21) + Math_fround(Math_fround(f14 * f19) + Math_fround(f16 * f20))) - Math_fround(f18 * f15));
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f14) - Math_fround(f17 * f15)) - Math_fround(f18 * f21)) - Math_fround(f20 * f19));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(f16 * f17)) + Math_fround(f18 * f19)) - Math_fround(f20 * f21));
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 4 >> 2] = f22;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 8 >> 2] = f23;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 12 >> 2] = f24;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 16 >> 2] = f25;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 20 >> 2] = f26;
  HEAPF32[i3 + 4 + (i4 * 28 | 0) + 24 >> 2] = f27;
  return;
 }
}

function runPostSets26() {
 HEAP32[gb + 39976 >> 2] = fb + 295;
 HEAP32[gb + 39980 >> 2] = fb + 3;
 HEAP32[gb + 39984 >> 2] = fb + 1;
 HEAP32[gb + 39988 >> 2] = fb + 1;
 HEAP32[gb + 39992 >> 2] = fb + 296;
 HEAP32[gb + 39996 >> 2] = fb + 21;
 HEAP32[gb + 4e4 >> 2] = (HEAP32[gb + 4e4 >> 2] | 0) + (gb + 396096 | 0);
 HEAP32[gb + 40004 >> 2] = (HEAP32[gb + 40004 >> 2] | 0) + (gb + 396115 | 0);
 HEAP32[gb + 40008 >> 2] = (HEAP32[gb + 40008 >> 2] | 0) + (gb + 396141 | 0);
 HEAP32[gb + 40012 >> 2] = (HEAP32[gb + 40012 >> 2] | 0) + (gb + 396161 | 0);
 HEAP32[gb + 40016 >> 2] = (HEAP32[gb + 40016 >> 2] | 0) + (gb + 396181 | 0);
 HEAP32[gb + 40020 >> 2] = (HEAP32[gb + 40020 >> 2] | 0) + (gb + 396217 | 0);
 HEAP32[gb + 176 >> 2] = (HEAP32[gb + 176 >> 2] | 0) + (gb + 396068 | 0);
 HEAP32[gb + 184 >> 2] = (HEAP32[gb + 184 >> 2] | 0) + (gb + 396082 | 0);
 HEAP32[gb + 40024 >> 2] = (HEAP32[gb + 40024 >> 2] | 0) + (gb + 395656 | 0);
 HEAP32[gb + 40032 >> 2] = (HEAP32[gb + 40032 >> 2] | 0) + (gb + 395679 | 0);
 HEAP32[gb + 40040 >> 2] = (HEAP32[gb + 40040 >> 2] | 0) + (gb + 395702 | 0);
 HEAP32[gb + 40048 >> 2] = (HEAP32[gb + 40048 >> 2] | 0) + (gb + 395725 | 0);
 HEAP32[gb + 40056 >> 2] = (HEAP32[gb + 40056 >> 2] | 0) + (gb + 395748 | 0);
 HEAP32[gb + 40064 >> 2] = (HEAP32[gb + 40064 >> 2] | 0) + (gb + 395772 | 0);
 HEAP32[gb + 40072 >> 2] = (HEAP32[gb + 40072 >> 2] | 0) + (gb + 395796 | 0);
 HEAP32[gb + 40080 >> 2] = (HEAP32[gb + 40080 >> 2] | 0) + (gb + 395820 | 0);
 HEAP32[gb + 40088 >> 2] = (HEAP32[gb + 40088 >> 2] | 0) + (gb + 395844 | 0);
 HEAP32[gb + 40096 >> 2] = (HEAP32[gb + 40096 >> 2] | 0) + (gb + 395871 | 0);
 HEAP32[gb + 40104 >> 2] = (HEAP32[gb + 40104 >> 2] | 0) + (gb + 395898 | 0);
 HEAP32[gb + 40112 >> 2] = (HEAP32[gb + 40112 >> 2] | 0) + (gb + 395925 | 0);
 HEAP32[gb + 40120 >> 2] = (HEAP32[gb + 40120 >> 2] | 0) + (gb + 395952 | 0);
 HEAP32[gb + 40128 >> 2] = (HEAP32[gb + 40128 >> 2] | 0) + (gb + 395981 | 0);
 HEAP32[gb + 40136 >> 2] = (HEAP32[gb + 40136 >> 2] | 0) + (gb + 396010 | 0);
 HEAP32[gb + 40144 >> 2] = (HEAP32[gb + 40144 >> 2] | 0) + (gb + 396039 | 0);
 HEAP32[gb + 40152 >> 2] = (HEAP32[gb + 40152 >> 2] | 0) + (gb + 395514 | 0);
 HEAP32[gb + 40164 >> 2] = (HEAP32[gb + 40164 >> 2] | 0) + (gb + 395531 | 0);
 HEAP32[gb + 40176 >> 2] = (HEAP32[gb + 40176 >> 2] | 0) + (gb + 395551 | 0);
 HEAP32[gb + 40188 >> 2] = (HEAP32[gb + 40188 >> 2] | 0) + (gb + 395571 | 0);
 HEAP32[gb + 40200 >> 2] = (HEAP32[gb + 40200 >> 2] | 0) + (gb + 395588 | 0);
 HEAP32[gb + 40212 >> 2] = (HEAP32[gb + 40212 >> 2] | 0) + (gb + 395603 | 0);
 HEAP32[gb + 40224 >> 2] = (HEAP32[gb + 40224 >> 2] | 0) + (gb + 395628 | 0);
 HEAP32[gb + 40236 >> 2] = (HEAP32[gb + 40236 >> 2] | 0) + (gb + 395111 | 0);
 HEAP32[gb + 40240 >> 2] = (HEAP32[gb + 40240 >> 2] | 0) + (gb + 395137 | 0);
 HEAP32[gb + 40244 >> 2] = (HEAP32[gb + 40244 >> 2] | 0) + (gb + 395151 | 0);
 HEAP32[gb + 40248 >> 2] = (HEAP32[gb + 40248 >> 2] | 0) + (gb + 395168 | 0);
 HEAP32[gb + 40252 >> 2] = (HEAP32[gb + 40252 >> 2] | 0) + (gb + 395183 | 0);
 HEAP32[gb + 40256 >> 2] = (HEAP32[gb + 40256 >> 2] | 0) + (gb + 395203 | 0);
 HEAP32[gb + 40260 >> 2] = (HEAP32[gb + 40260 >> 2] | 0) + (gb + 395223 | 0);
 HEAP32[gb + 40264 >> 2] = (HEAP32[gb + 40264 >> 2] | 0) + (gb + 395244 | 0);
 HEAP32[gb + 40268 >> 2] = (HEAP32[gb + 40268 >> 2] | 0) + (gb + 395265 | 0);
 HEAP32[gb + 40272 >> 2] = (HEAP32[gb + 40272 >> 2] | 0) + (gb + 395286 | 0);
 HEAP32[gb + 40276 >> 2] = (HEAP32[gb + 40276 >> 2] | 0) + (gb + 395307 | 0);
 HEAP32[gb + 40280 >> 2] = (HEAP32[gb + 40280 >> 2] | 0) + (gb + 395328 | 0);
 HEAP32[gb + 40284 >> 2] = (HEAP32[gb + 40284 >> 2] | 0) + (gb + 395344 | 0);
 HEAP32[gb + 40288 >> 2] = (HEAP32[gb + 40288 >> 2] | 0) + (gb + 395368 | 0);
 HEAP32[gb + 40292 >> 2] = (HEAP32[gb + 40292 >> 2] | 0) + (gb + 395388 | 0);
 HEAP32[gb + 40296 >> 2] = (HEAP32[gb + 40296 >> 2] | 0) + (gb + 395415 | 0);
 HEAP32[gb + 40300 >> 2] = (HEAP32[gb + 40300 >> 2] | 0) + (gb + 395434 | 0);
 HEAP32[gb + 40304 >> 2] = (HEAP32[gb + 40304 >> 2] | 0) + (gb + 395457 | 0);
 HEAP32[gb + 40308 >> 2] = (HEAP32[gb + 40308 >> 2] | 0) + (gb + 395483 | 0);
 HEAP32[gb + 40312 >> 2] = (HEAP32[gb + 40312 >> 2] | 0) + (gb + 394827 | 0);
 HEAP32[gb + 40320 >> 2] = (HEAP32[gb + 40320 >> 2] | 0) + (gb + 394841 | 0);
 HEAP32[gb + 40328 >> 2] = (HEAP32[gb + 40328 >> 2] | 0) + (gb + 394856 | 0);
 HEAP32[gb + 40336 >> 2] = (HEAP32[gb + 40336 >> 2] | 0) + (gb + 394871 | 0);
 HEAP32[gb + 40344 >> 2] = (HEAP32[gb + 40344 >> 2] | 0) + (gb + 394886 | 0);
 HEAP32[gb + 40352 >> 2] = (HEAP32[gb + 40352 >> 2] | 0) + (gb + 394901 | 0);
 HEAP32[gb + 40360 >> 2] = (HEAP32[gb + 40360 >> 2] | 0) + (gb + 394920 | 0);
 HEAP32[gb + 40368 >> 2] = (HEAP32[gb + 40368 >> 2] | 0) + (gb + 394940 | 0);
 HEAP32[gb + 40376 >> 2] = (HEAP32[gb + 40376 >> 2] | 0) + (gb + 394960 | 0);
 HEAP32[gb + 40384 >> 2] = (HEAP32[gb + 40384 >> 2] | 0) + (gb + 394980 | 0);
 HEAP32[gb + 40392 >> 2] = (HEAP32[gb + 40392 >> 2] | 0) + (gb + 395e3 | 0);
 HEAP32[gb + 40400 >> 2] = (HEAP32[gb + 40400 >> 2] | 0) + (gb + 395015 | 0);
 HEAP32[gb + 40408 >> 2] = (HEAP32[gb + 40408 >> 2] | 0) + (gb + 395030 | 0);
 HEAP32[gb + 40416 >> 2] = (HEAP32[gb + 40416 >> 2] | 0) + (gb + 395052 | 0);
 HEAP32[gb + 40424 >> 2] = (HEAP32[gb + 40424 >> 2] | 0) + (gb + 395066 | 0);
 HEAP32[gb + 40432 >> 2] = (HEAP32[gb + 40432 >> 2] | 0) + (gb + 395077 | 0);
 HEAP32[gb + 40440 >> 2] = (HEAP32[gb + 40440 >> 2] | 0) + (gb + 395096 | 0);
 HEAP32[gb + 40448 >> 2] = (HEAP32[gb + 40448 >> 2] | 0) + (gb + 394807 | 0);
 HEAP32[gb + 40460 >> 2] = (HEAP32[gb + 40460 >> 2] | 0) + (gb + 441971 | 0);
 HEAP32[gb + 40464 >> 2] = (HEAP32[gb + 40464 >> 2] | 0) + (gb + 441989 | 0);
 HEAP32[gb + 40468 >> 2] = (HEAP32[gb + 40468 >> 2] | 0) + (gb + 441911 | 0);
 HEAP32[gb + 40472 >> 2] = (HEAP32[gb + 40472 >> 2] | 0) + (gb + 394521 | 0);
 HEAP32[gb + 40476 >> 2] = (HEAP32[gb + 40476 >> 2] | 0) + (gb + 441984 | 0);
 HEAP32[gb + 40480 >> 2] = (HEAP32[gb + 40480 >> 2] | 0) + (gb + 394526 | 0);
 HEAP32[gb + 40484 >> 2] = (HEAP32[gb + 40484 >> 2] | 0) + (gb + 394540 | 0);
 HEAP32[gb + 40488 >> 2] = (HEAP32[gb + 40488 >> 2] | 0) + (gb + 394554 | 0);
 HEAP32[gb + 40492 >> 2] = (HEAP32[gb + 40492 >> 2] | 0) + (gb + 394559 | 0);
 HEAP32[gb + 40496 >> 2] = (HEAP32[gb + 40496 >> 2] | 0) + (gb + 394569 | 0);
 HEAP32[gb + 40500 >> 2] = (HEAP32[gb + 40500 >> 2] | 0) + (gb + 394578 | 0);
 HEAP32[gb + 40504 >> 2] = (HEAP32[gb + 40504 >> 2] | 0) + (gb + 394593 | 0);
 HEAP32[gb + 40508 >> 2] = (HEAP32[gb + 40508 >> 2] | 0) + (gb + 394611 | 0);
 HEAP32[gb + 40512 >> 2] = (HEAP32[gb + 40512 >> 2] | 0) + (gb + 394633 | 0);
 HEAP32[gb + 40516 >> 2] = (HEAP32[gb + 40516 >> 2] | 0) + (gb + 394661 | 0);
 HEAP32[gb + 40520 >> 2] = (HEAP32[gb + 40520 >> 2] | 0) + (gb + 394681 | 0);
 HEAP32[gb + 40524 >> 2] = (HEAP32[gb + 40524 >> 2] | 0) + (gb + 394696 | 0);
 HEAP32[gb + 40528 >> 2] = (HEAP32[gb + 40528 >> 2] | 0) + (gb + 394713 | 0);
 HEAP32[gb + 40532 >> 2] = (HEAP32[gb + 40532 >> 2] | 0) + (gb + 394736 | 0);
 HEAP32[gb + 40536 >> 2] = (HEAP32[gb + 40536 >> 2] | 0) + (gb + 394755 | 0);
 HEAP32[gb + 40540 >> 2] = (HEAP32[gb + 40540 >> 2] | 0) + (gb + 394771 | 0);
 HEAP32[gb + 40544 >> 2] = (HEAP32[gb + 40544 >> 2] | 0) + (gb + 394787 | 0);
 HEAP32[gb + 40548 >> 2] = (HEAP32[gb + 40548 >> 2] | 0) + (gb + 392442 | 0);
 HEAP32[gb + 40552 >> 2] = (HEAP32[gb + 40552 >> 2] | 0) + (gb + 392460 | 0);
 HEAP32[gb + 40556 >> 2] = (HEAP32[gb + 40556 >> 2] | 0) + (gb + 392478 | 0);
 HEAP32[gb + 40560 >> 2] = (HEAP32[gb + 40560 >> 2] | 0) + (gb + 392496 | 0);
 runPostSets27();
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl16checkMarshallingEN5physx8debugger18NonNegativeIntegerES3_(i6, i2, i8, i7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 84 | 0;
 i3 = i9 + 4 | 0;
 i5 = i9 + 8 | 0;
 i1 = i9;
 i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 mftCall_viii(i10 | 0, i4 | 0, i2 | 0, i3 | 0);
 if (!(HEAP8[i4 + 72 >> 0] | 0)) {
  HEAP32[i6 >> 2] = -1;
  HEAP32[i6 + 4 >> 2] = -1;
  HEAP8[i6 + 8 >> 0] = 0;
  HEAP8[i6 + 9 >> 0] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 mftCall_viii(i10 | 0, i5 | 0, i2 | 0, i1 | 0);
 L5 : do if (!(HEAP8[i5 + 72 >> 0] | 0)) {
  HEAP32[i6 >> 2] = -1;
  HEAP32[i6 + 4 >> 2] = -1;
  HEAP8[i6 + 8 >> 0] = 0;
  HEAP8[i6 + 9 >> 0] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
 } else {
  L8 : do if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i4 + 12 >> 2] | 0)) {
   i2 = 0;
   i3 = 0;
   i1 = 0;
  } else {
   i2 = HEAP32[i5 + 20 >> 2] | 0;
   if ((i2 | 0) > -1) {
    i3 = HEAP32[i4 + 20 >> 2] | 0;
    if ((i3 | 0) > -1) {
     i1 = HEAP32[i4 + 24 >> 2] | 0;
     L13 : do switch (HEAP32[i5 + 24 >> 2] | 0) {
     case 65:
      switch (i1 | 0) {
      case 67:
       {
        i2 = fb + 800 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 807 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 806 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 68:
       {
        i2 = fb + 801 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 69:
       {
        i2 = fb + 802 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 70:
       {
        i2 = fb + 803 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 71:
       {
        i2 = fb + 804 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 805 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 66:
      switch (i1 | 0) {
      case 67:
       {
        i2 = fb + 808 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 815 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 814 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 68:
       {
        i2 = fb + 809 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 69:
       {
        i2 = fb + 810 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 70:
       {
        i2 = fb + 811 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 71:
       {
        i2 = fb + 812 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 813 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 67:
      switch (i1 | 0) {
      case 69:
       {
        i2 = fb + 816 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 821 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 820 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 819 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 71:
       {
        i2 = fb + 818 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 70:
       {
        i2 = fb + 817 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 68:
      switch (i1 | 0) {
      case 69:
       {
        i2 = fb + 822 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 827 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 826 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 825 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 71:
       {
        i2 = fb + 824 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 70:
       {
        i2 = fb + 823 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 69:
      switch (i1 | 0) {
      case 71:
       {
        i2 = fb + 828 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 831 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 830 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 829 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 70:
      switch (i1 | 0) {
      case 71:
       {
        i2 = fb + 832 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 835 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 73:
       {
        i2 = fb + 834 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 72:
       {
        i2 = fb + 833 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 71:
      {
       if ((i1 | 0) == 74) {
        i2 = fb + 836 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
       break;
      }
     case 72:
      {
       if ((i1 | 0) == 74) {
        i2 = fb + 837 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
       break;
      }
     case 73:
      switch (i1 | 0) {
      case 69:
       {
        i2 = fb + 838 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 74:
       {
        i2 = fb + 840 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      case 70:
       {
        i2 = fb + 839 | 0;
        i3 = 1;
        i1 = 1;
        break L8;
       }
      default:
       break L13;
      }
     case 74:
      {
       switch (i1 | 0) {
       case 71:
        {
         i2 = fb + 841 | 0;
         i3 = 1;
         i1 = 1;
         break L8;
        }
       case 72:
        break;
       default:
        break L13;
       }
       i2 = fb + 842 | 0;
       i3 = 1;
       i1 = 1;
       break L8;
      }
     default:
      {}
     } while (0);
     i1 = (i2 | 0) == (i3 | 0);
     if (i1) {
      i2 = 0;
      i3 = 0;
      i1 = i1 ^ 1;
      break;
     }
     HEAP32[i6 >> 2] = -1;
     HEAP32[i6 + 4 >> 2] = -1;
     HEAP8[i6 + 8 >> 0] = 0;
     HEAP8[i6 + 9 >> 0] = 0;
     HEAP32[i6 + 12 >> 2] = 0;
     break L5;
    }
   }
   HEAP32[i6 >> 2] = -1;
   HEAP32[i6 + 4 >> 2] = -1;
   HEAP8[i6 + 8 >> 0] = 0;
   HEAP8[i6 + 9 >> 0] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   break L5;
  } while (0);
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i10;
  HEAP8[i6 + 8 >> 0] = i3;
  HEAP8[i6 + 9 >> 0] = i1 & 1;
  HEAP32[i6 + 12 >> 2] = i2;
 } while (0);
 STACKTOP = i9;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEbT0_S7_T_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 switch (i9 - i10 >> 3 | 0) {
 case 2:
  {
   if (!(Math_fround(HEAPF32[i9 + -4 >> 2]) < Math_fround(HEAPF32[i10 + 4 >> 2]))) {
    i10 = 1;
    return i10 | 0;
   }
   i7 = i9 + -8 | 0;
   i9 = i10;
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i3 = i7;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = i5;
   i10 = i7;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i10 + 4 >> 2] = i9;
   i10 = 1;
   return i10 | 0;
  }
 case 3:
  {
   i7 = i10 + 8 | 0;
   i8 = i9 + -8 | 0;
   i1 = i10 + 12 | 0;
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   i2 = i10 + 4 | 0;
   i11 = f6 < Math_fround(HEAPF32[i2 >> 2]);
   i3 = i9 + -4 | 0;
   i5 = Math_fround(HEAPF32[i3 >> 2]) < f6;
   if (!i11) {
    if (!i5) {
     i11 = 1;
     return i11 | 0;
    }
    i9 = i7;
    i5 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i12 = i8;
    i3 = HEAP32[i12 + 4 >> 2] | 0;
    i11 = i7;
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = i3;
    i11 = i8;
    HEAP32[i11 >> 2] = i5;
    HEAP32[i11 + 4 >> 2] = i9;
    f6 = Math_fround(HEAPF32[i1 >> 2]);
    if (!(f6 < Math_fround(HEAPF32[i2 >> 2]))) {
     i12 = 1;
     return i12 | 0;
    }
    i11 = i10;
    i9 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i5 = i7;
    i8 = HEAP32[i5 + 4 >> 2] | 0;
    i12 = i10;
    HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i12 + 4 >> 2] = i8;
    i12 = i7;
    HEAP32[i12 >> 2] = i9;
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = 1;
    return i12 | 0;
   }
   i2 = i10;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (i5) {
    i9 = i8;
    i11 = HEAP32[i9 + 4 >> 2] | 0;
    i12 = i10;
    HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i8;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i2;
    i12 = 1;
    return i12 | 0;
   }
   i9 = i7;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i10;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = i7;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   if (!(Math_fround(HEAPF32[i3 >> 2]) < (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
    i12 = 1;
    return i12 | 0;
   }
   i10 = i8;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i7;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = i8;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i10, i10 + 8 | 0, i10 + 16 | 0, i9 + -8 | 0) | 0;
   i12 = 1;
   return i12 | 0;
  }
 case 5:
  {
   i5 = i10 + 8 | 0;
   i7 = i10 + 16 | 0;
   i3 = i10 + 24 | 0;
   __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i10, i5, i7, i3) | 0;
   i1 = i10 + 28 | 0;
   if (!(Math_fround(HEAPF32[i9 + -4 >> 2]) < Math_fround(HEAPF32[i1 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   i12 = i9 + -8 | 0;
   i11 = i3;
   i9 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i12;
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = i3;
   HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[i12 >> 2] = i9;
   HEAP32[i12 + 4 >> 2] = i11;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i10 + 20 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i7;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i2 = i3;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = i7;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i3;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f4 < Math_fround(HEAPF32[i10 + 12 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i5;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i5;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i7;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   if (!(f4 < Math_fround(HEAPF32[i10 + 4 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i10;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i10;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i5;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   i13 = 1;
   return i13 | 0;
  }
 case 1:
 case 0:
  {
   i13 = 1;
   return i13 | 0;
  }
 default:
  {
   i3 = i10 + 16 | 0;
   i7 = i10 + 8 | 0;
   f14 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i10 + 20 >> 2]);
   i5 = f6 < f14;
   do if (f14 < f4) {
    i2 = i10;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (i5) {
     i11 = i3;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i10;
     HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = i3;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
     break;
    }
    i11 = i7;
    i12 = HEAP32[i11 + 4 >> 2] | 0;
    i13 = i10;
    HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
    i13 = i7;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2;
    if (f6 < (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i11 = i3;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i7;
     HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = i3;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
    }
   } else if (i5) {
    i12 = i7;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i2 = i3;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i13 = i7;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2;
    i13 = i3;
    HEAP32[i13 >> 2] = i11;
    HEAP32[i13 + 4 >> 2] = i12;
    if ((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f4) {
     i12 = i10;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     i13 = i10;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
     i13 = i7;
     HEAP32[i13 >> 2] = i11;
     HEAP32[i13 + 4 >> 2] = i12;
    }
   } while (0);
   i1 = i10 + 24 | 0;
   L13 : do if ((i1 | 0) == (i9 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     if (f4 < Math_fround(HEAPF32[i3 + 4 >> 2])) {
      i7 = HEAP32[i1 >> 2] | 0;
      i5 = i1;
      while (1) {
       i11 = i3;
       i12 = HEAP32[i11 + 4 >> 2] | 0;
       i13 = i5;
       HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i13 + 4 >> 2] = i12;
       if ((i3 | 0) == (i10 | 0)) {
        i3 = i10;
        break;
       }
       if (f4 < Math_fround(HEAPF32[i3 + -4 >> 2])) {
        i5 = i3;
        i3 = i3 + -8 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i7;
      HEAPF32[i3 + 4 >> 2] = f4;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i9 | 0);
       break L13;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i9 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i13 = i1;
      i1 = i3;
      i3 = i13;
     }
    }
   } while (0);
   i13 = i1 | i2;
   return i13 | 0;
  }
 }
 return 0;
}

function __Z23RandomPointInsideSphereR5RandNRKfS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 __Z16RandomUnitVectorR5RandN(i1, i2);
 i28 = HEAP32[i2 >> 2] | 0;
 i20 = i2 + 4 | 0;
 i27 = HEAP32[i20 >> 2] | 0;
 i18 = i2 + 8 | 0;
 i26 = HEAP32[i18 >> 2] | 0;
 i32 = i2 + 12 | 0;
 i25 = HEAP32[i32 >> 2] | 0;
 i28 = i28 << 11 ^ i28;
 i27 = i27 << 11 ^ i27;
 i26 = i26 << 11 ^ i26;
 i25 = i25 << 11 ^ i25;
 i14 = i2 + 16 | 0;
 i12 = i2 + 20 | 0;
 i29 = HEAP32[i12 >> 2] | 0;
 i10 = i2 + 24 | 0;
 i30 = HEAP32[i10 >> 2] | 0;
 i8 = i2 + 28 | 0;
 i31 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i20 >> 2] = i29;
 HEAP32[i18 >> 2] = i30;
 HEAP32[i32 >> 2] = i31;
 i32 = i2 + 32 | 0;
 i31 = i2 + 36 | 0;
 i18 = HEAP32[i31 >> 2] | 0;
 i30 = i2 + 40 | 0;
 i20 = HEAP32[i30 >> 2] | 0;
 i29 = i2 + 44 | 0;
 i22 = HEAP32[i29 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i12 >> 2] = i18;
 HEAP32[i10 >> 2] = i20;
 HEAP32[i8 >> 2] = i22;
 i8 = i2 + 48 | 0;
 i22 = HEAP32[i8 >> 2] | 0;
 i10 = i2 + 52 | 0;
 i20 = HEAP32[i10 >> 2] | 0;
 i12 = i2 + 56 | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i14 = i2 + 60 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i32 >> 2] = i22;
 HEAP32[i31 >> 2] = i20;
 HEAP32[i30 >> 2] = i18;
 HEAP32[i29 >> 2] = i16;
 i22 = i28 >>> 8 ^ i28 ^ i22 ^ i22 >>> 19;
 i20 = i27 >>> 8 ^ i27 ^ i20 ^ i20 >>> 19;
 i18 = i26 >>> 8 ^ i26 ^ i18 ^ i18 >>> 19;
 i16 = i25 >>> 8 ^ i25 ^ i16 ^ i16 >>> 19;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i10 >> 2] = i20;
 HEAP32[i12 >> 2] = i18;
 HEAP32[i14 >> 2] = i16;
 f5 = Math_fround(Math_fround(i22 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(i20 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(i18 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f19 = Math_fround(Math_fround(i16 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(f5 * f21);
 f24 = Math_fround(f6 * f21);
 f23 = Math_fround(f7 * f21);
 f21 = Math_fround(f19 * f21);
 f5 = Math_fround(Math_fround(1.0) - f5);
 f6 = Math_fround(Math_fround(1.0) - f6);
 f7 = Math_fround(Math_fround(1.0) - f7);
 f19 = Math_fround(Math_fround(1.0) - f19);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f17 + Math_fround(f5 * f9));
 f6 = Math_fround(f24 + Math_fround(f6 * f9));
 f7 = Math_fround(f23 + Math_fround(f7 * f9));
 f9 = Math_fround(f21 + Math_fround(f19 * f9));
 i16 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i16 & -2139095041 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18 & -2139095041 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20 & -2139095041 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i22 & -2139095041 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround((i16 >> 23) + -127 | 0) + Math_fround(f9 * Math_fround(1.4379071))) + Math_fround(Math_fround(f9 * f9) * Math_fround(Math_fround(f9 * Math_fround(.194381133)) + Math_fround(-.632288218)))) * Math_fround(.333333343));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround((i18 >> 23) + -127 | 0) + Math_fround(f7 * Math_fround(1.4379071))) + Math_fround(Math_fround(f7 * f7) * Math_fround(Math_fround(f7 * Math_fround(.194381133)) + Math_fround(-.632288218)))) * Math_fround(.333333343));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround((i20 >> 23) + -127 | 0) + Math_fround(f6 * Math_fround(1.4379071))) + Math_fround(Math_fround(f6 * f6) * Math_fround(Math_fround(f6 * Math_fround(.194381133)) + Math_fround(-.632288218)))) * Math_fround(.333333343));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround((i22 >> 23) + -127 | 0) + Math_fround(f5 * Math_fround(1.4379071))) + Math_fround(Math_fround(f5 * f5) * Math_fround(Math_fround(f5 * Math_fround(.194381133)) + Math_fround(-.632288218)))) * Math_fround(.333333343));
 i22 = f9 > Math_fround(-127.0);
 f9 = i22 ? f9 : Math_fround(-127.0);
 i22 = f7 > Math_fround(-127.0);
 f7 = i22 ? f7 : Math_fround(-127.0);
 i22 = f6 > Math_fround(-127.0);
 f6 = i22 ? f6 : Math_fround(-127.0);
 i22 = f5 > Math_fround(-127.0);
 f5 = i22 ? f5 : Math_fround(-127.0);
 f19 = Math_fround(Math_floor(Math_fround(f9)));
 f21 = Math_fround(Math_floor(Math_fround(f7)));
 f23 = Math_fround(Math_floor(Math_fround(f6)));
 f24 = Math_fround(Math_floor(Math_fround(f5)));
 f9 = Math_fround(f9 - f19);
 f7 = Math_fround(f7 - f21);
 f6 = Math_fround(f6 - f23);
 f5 = Math_fround(f5 - f24);
 f9 = Math_fround(Math_fround(Math_fround(f9 * Math_fround(.682270109)) + Math_fround(1.0)) + Math_fround(Math_fround(f9 * f9) * Math_fround(.31772992)));
 f7 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(.682270109)) + Math_fround(1.0)) + Math_fround(Math_fround(f7 * f7) * Math_fround(.31772992)));
 f6 = Math_fround(Math_fround(Math_fround(f6 * Math_fround(.682270109)) + Math_fround(1.0)) + Math_fround(Math_fround(f6 * f6) * Math_fround(.31772992)));
 f5 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(.682270109)) + Math_fround(1.0)) + Math_fround(Math_fround(f5 * f5) * Math_fround(.31772992)));
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = (~~f19 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f9);
 f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = (~~f21 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7);
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = (~~f23 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f6);
 f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = (~~f24 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f5);
 f24 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f9);
 i22 = i1 + 4 | 0;
 f23 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f7);
 i20 = i1 + 8 | 0;
 f21 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f6);
 i18 = i1 + 12 | 0;
 f19 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f5);
 i16 = i1 + 16 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f9);
 i14 = i1 + 20 | 0;
 f15 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f7);
 i12 = i1 + 24 | 0;
 f13 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f6);
 i10 = i1 + 28 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f5);
 i8 = i1 + 32 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f9);
 i2 = i1 + 36 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f7);
 i3 = i1 + 40 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f6);
 i4 = i1 + 44 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f5);
 HEAPF32[i1 >> 2] = f24;
 HEAPF32[i22 >> 2] = f23;
 HEAPF32[i20 >> 2] = f21;
 HEAPF32[i18 >> 2] = f19;
 HEAPF32[i16 >> 2] = f17;
 HEAPF32[i14 >> 2] = f15;
 HEAPF32[i12 >> 2] = f13;
 HEAPF32[i10 >> 2] = f11;
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i3 >> 2] = f6;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function runPostSets150() {
 HEAP32[gb + 140252 >> 2] = fb + 1915;
 HEAP32[gb + 140256 >> 2] = fb + 1369;
 HEAP32[gb + 140268 >> 2] = fb + 1916;
 HEAP32[gb + 140272 >> 2] = fb + 1917;
 HEAP32[gb + 140276 >> 2] = fb + 1370;
 HEAP32[gb + 140288 >> 2] = fb + 111;
 HEAP32[gb + 140292 >> 2] = fb + 968;
 HEAP32[gb + 140296 >> 2] = fb + 374;
 HEAP32[gb + 140300 >> 2] = fb + 1371;
 HEAP32[gb + 140304 >> 2] = fb + 1372;
 HEAP32[gb + 140308 >> 2] = fb + 1918;
 HEAP32[gb + 140312 >> 2] = fb + 1919;
 HEAP32[gb + 140316 >> 2] = (HEAP32[gb + 140316 >> 2] | 0) + (gb + 756598 | 0);
 HEAP32[gb + 140320 >> 2] = (HEAP32[gb + 140320 >> 2] | 0) + (gb + 756624 | 0);
 HEAP32[gb + 140324 >> 2] = (HEAP32[gb + 140324 >> 2] | 0) + (gb + 756630 | 0);
 HEAP32[gb + 140328 >> 2] = (HEAP32[gb + 140328 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140332 >> 2] = (HEAP32[gb + 140332 >> 2] | 0) + (gb + 756654 | 0);
 HEAP32[gb + 140336 >> 2] = (HEAP32[gb + 140336 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 140340 >> 2] = (HEAP32[gb + 140340 >> 2] | 0) + (gb + 756693 | 0);
 HEAP32[gb + 140344 >> 2] = (HEAP32[gb + 140344 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 140348 >> 2] = (HEAP32[gb + 140348 >> 2] | 0) + (gb + 756737 | 0);
 HEAP32[gb + 140352 >> 2] = (HEAP32[gb + 140352 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140356 >> 2] = (HEAP32[gb + 140356 >> 2] | 0) + (gb + 756769 | 0);
 HEAP32[gb + 140360 >> 2] = (HEAP32[gb + 140360 >> 2] | 0) + (gb + 756687 | 0);
 HEAP32[gb + 140364 >> 2] = (HEAP32[gb + 140364 >> 2] | 0) + (gb + 756804 | 0);
 HEAP32[gb + 140368 >> 2] = (HEAP32[gb + 140368 >> 2] | 0) + (gb + 756729 | 0);
 HEAP32[gb + 140372 >> 2] = (HEAP32[gb + 140372 >> 2] | 0) + (gb + 756842 | 0);
 HEAP32[gb + 140376 >> 2] = (HEAP32[gb + 140376 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140380 >> 2] = (HEAP32[gb + 140380 >> 2] | 0) + (gb + 756875 | 0);
 HEAP32[gb + 140384 >> 2] = (HEAP32[gb + 140384 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140388 >> 2] = (HEAP32[gb + 140388 >> 2] | 0) + (gb + 756911 | 0);
 HEAP32[gb + 140392 >> 2] = (HEAP32[gb + 140392 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140396 >> 2] = (HEAP32[gb + 140396 >> 2] | 0) + (gb + 756945 | 0);
 HEAP32[gb + 140400 >> 2] = (HEAP32[gb + 140400 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140404 >> 2] = (HEAP32[gb + 140404 >> 2] | 0) + (gb + 756981 | 0);
 HEAP32[gb + 140408 >> 2] = (HEAP32[gb + 140408 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140412 >> 2] = (HEAP32[gb + 140412 >> 2] | 0) + (gb + 757012 | 0);
 HEAP32[gb + 140416 >> 2] = (HEAP32[gb + 140416 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140420 >> 2] = (HEAP32[gb + 140420 >> 2] | 0) + (gb + 757046 | 0);
 HEAP32[gb + 140424 >> 2] = (HEAP32[gb + 140424 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140428 >> 2] = (HEAP32[gb + 140428 >> 2] | 0) + (gb + 757085 | 0);
 HEAP32[gb + 140432 >> 2] = (HEAP32[gb + 140432 >> 2] | 0) + (gb + 756979 | 0);
 HEAP32[gb + 140436 >> 2] = (HEAP32[gb + 140436 >> 2] | 0) + (gb + 757110 | 0);
 HEAP32[gb + 140440 >> 2] = (HEAP32[gb + 140440 >> 2] | 0) + (gb + 757133 | 0);
 HEAP32[gb + 140444 >> 2] = (HEAP32[gb + 140444 >> 2] | 0) + (gb + 757138 | 0);
 HEAP32[gb + 140448 >> 2] = (HEAP32[gb + 140448 >> 2] | 0) + (gb + 757162 | 0);
 HEAP32[gb + 140452 >> 2] = (HEAP32[gb + 140452 >> 2] | 0) + (gb + 757165 | 0);
 HEAP32[gb + 140456 >> 2] = (HEAP32[gb + 140456 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140460 >> 2] = (HEAP32[gb + 140460 >> 2] | 0) + (gb + 757192 | 0);
 HEAP32[gb + 140464 >> 2] = (HEAP32[gb + 140464 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140468 >> 2] = (HEAP32[gb + 140468 >> 2] | 0) + (gb + 757218 | 0);
 HEAP32[gb + 140472 >> 2] = (HEAP32[gb + 140472 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140476 >> 2] = (HEAP32[gb + 140476 >> 2] | 0) + (gb + 757241 | 0);
 HEAP32[gb + 140480 >> 2] = (HEAP32[gb + 140480 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140484 >> 2] = (HEAP32[gb + 140484 >> 2] | 0) + (gb + 757269 | 0);
 HEAP32[gb + 140488 >> 2] = (HEAP32[gb + 140488 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140492 >> 2] = (HEAP32[gb + 140492 >> 2] | 0) + (gb + 757296 | 0);
 HEAP32[gb + 140496 >> 2] = (HEAP32[gb + 140496 >> 2] | 0) + (gb + 757323 | 0);
 HEAP32[gb + 140500 >> 2] = (HEAP32[gb + 140500 >> 2] | 0) + (gb + 757329 | 0);
 HEAP32[gb + 140504 >> 2] = (HEAP32[gb + 140504 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140508 >> 2] = (HEAP32[gb + 140508 >> 2] | 0) + (gb + 757346 | 0);
 HEAP32[gb + 140512 >> 2] = (HEAP32[gb + 140512 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 140516 >> 2] = (HEAP32[gb + 140516 >> 2] | 0) + (gb + 757386 | 0);
 HEAP32[gb + 140520 >> 2] = (HEAP32[gb + 140520 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 140524 >> 2] = (HEAP32[gb + 140524 >> 2] | 0) + (gb + 757420 | 0);
 HEAP32[gb + 140528 >> 2] = (HEAP32[gb + 140528 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140532 >> 2] = (HEAP32[gb + 140532 >> 2] | 0) + (gb + 757440 | 0);
 HEAP32[gb + 140536 >> 2] = (HEAP32[gb + 140536 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140540 >> 2] = (HEAP32[gb + 140540 >> 2] | 0) + (gb + 757472 | 0);
 HEAP32[gb + 140544 >> 2] = (HEAP32[gb + 140544 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 140548 >> 2] = (HEAP32[gb + 140548 >> 2] | 0) + (gb + 757509 | 0);
 HEAP32[gb + 140552 >> 2] = (HEAP32[gb + 140552 >> 2] | 0) + (gb + 757501 | 0);
 HEAP32[gb + 140556 >> 2] = (HEAP32[gb + 140556 >> 2] | 0) + (gb + 757533 | 0);
 HEAP32[gb + 140560 >> 2] = (HEAP32[gb + 140560 >> 2] | 0) + (gb + 757555 | 0);
 HEAP32[gb + 140564 >> 2] = (HEAP32[gb + 140564 >> 2] | 0) + (gb + 757560 | 0);
 HEAP32[gb + 140568 >> 2] = (HEAP32[gb + 140568 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140572 >> 2] = (HEAP32[gb + 140572 >> 2] | 0) + (gb + 757579 | 0);
 HEAP32[gb + 140576 >> 2] = (HEAP32[gb + 140576 >> 2] | 0) + (gb + 757593 | 0);
 HEAP32[gb + 140580 >> 2] = (HEAP32[gb + 140580 >> 2] | 0) + (gb + 757645 | 0);
 HEAP32[gb + 140584 >> 2] = (HEAP32[gb + 140584 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140588 >> 2] = (HEAP32[gb + 140588 >> 2] | 0) + (gb + 757658 | 0);
 HEAP32[gb + 140592 >> 2] = (HEAP32[gb + 140592 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140596 >> 2] = (HEAP32[gb + 140596 >> 2] | 0) + (gb + 757675 | 0);
 HEAP32[gb + 140600 >> 2] = (HEAP32[gb + 140600 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140604 >> 2] = (HEAP32[gb + 140604 >> 2] | 0) + (gb + 757694 | 0);
 HEAP32[gb + 140608 >> 2] = (HEAP32[gb + 140608 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 140612 >> 2] = (HEAP32[gb + 140612 >> 2] | 0) + (gb + 757734 | 0);
 HEAP32[gb + 140616 >> 2] = (HEAP32[gb + 140616 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140620 >> 2] = (HEAP32[gb + 140620 >> 2] | 0) + (gb + 757763 | 0);
 HEAP32[gb + 140624 >> 2] = (HEAP32[gb + 140624 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140628 >> 2] = (HEAP32[gb + 140628 >> 2] | 0) + (gb + 757789 | 0);
 HEAP32[gb + 140632 >> 2] = (HEAP32[gb + 140632 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140636 >> 2] = (HEAP32[gb + 140636 >> 2] | 0) + (gb + 757822 | 0);
 HEAP32[gb + 140640 >> 2] = (HEAP32[gb + 140640 >> 2] | 0) + (gb + 1075318 | 0);
 HEAP32[gb + 140644 >> 2] = (HEAP32[gb + 140644 >> 2] | 0) + (gb + 757845 | 0);
 HEAP32[gb + 140648 >> 2] = (HEAP32[gb + 140648 >> 2] | 0) + (gb + 757458 | 0);
 HEAP32[gb + 140652 >> 2] = (HEAP32[gb + 140652 >> 2] | 0) + (gb + 757870 | 0);
 HEAP32[gb + 140656 >> 2] = (HEAP32[gb + 140656 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 140660 >> 2] = (HEAP32[gb + 140660 >> 2] | 0) + (gb + 757890 | 0);
 HEAP32[gb + 140664 >> 2] = (HEAP32[gb + 140664 >> 2] | 0) + (gb + 757719 | 0);
 runPostSets151();
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue14ParseEventDataERK8UnityStr(i15, i7) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i14 = i17 + 16 | 0;
 i11 = i17 + 8 | 0;
 i4 = i7 + 11 | 0;
 i8 = HEAP8[i4 >> 0] | 0;
 i9 = i7 + 4 | 0;
 i8 = i8 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i8 & 255;
 if (!i8) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i16 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63800 | 0, 16, gb + 1046596 | 0, 41) | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i10 = i16 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i16 + 40 >> 2] = 0;
 HEAP32[i16 + 44 >> 2] = 1;
 i10 = i16 + 32 | 0;
 HEAP32[i10 >> 2] = 0;
 if (!(__Z10BeginsWithPKcS0_((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, gb + 1086383 | 0) | 0)) {
  do if ((i16 | 0) != (i7 | 0)) {
   i5 = HEAP8[i4 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
   i5 = i3 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
   i3 = i16 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i5 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i16 + 4 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
    break;
   }
   if (i2) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i16 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i3 >> 0] = i5;
    break;
   }
  } while (0);
  HEAP32[i14 >> 2] = i16;
  i1 = i15 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i15, i14); else {
   HEAP32[i2 >> 2] = i16;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
  }
  if (HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] & 1 | 0) {
   i16 = i15 + 16 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  }
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 HEAP32[i11 >> 2] = 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i6 = i1 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i7 >> 2] | 0 : i7;
 i1 = i6 ? HEAP32[i9 >> 2] | 0 : i1 & 255;
 if (!i1) i13 = 31; else {
  i6 = i5 + i1 | 0;
  i2 = i6;
  i3 = i5;
  L39 : do if ((i1 | 0) >= 1) {
   i1 = i5;
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 41) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i6 | 0)) break L39;
   }
   i2 = i1;
  } while (0);
  i1 = i2 - i3 | 0;
  if ((i2 | 0) == (i6 | 0) | (i1 | 0) == -1) i13 = 31; else {
   HEAP32[i12 >> 2] = i11;
   if (!(_sscanf(i5, gb + 1046686 | 0, i12) | 0)) i13 = 31; else {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 < i8 >>> 0) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_(i14, i7, i1, -1, i7 + 12 | 0);
     i5 = i14 + 11 | 0;
     i7 = HEAP8[i5 >> 0] | 0;
     i3 = i7 << 24 >> 24 < 0;
     i6 = i3 ? HEAP32[i14 >> 2] | 0 : i14;
     i7 = i3 ? HEAP32[i14 + 4 >> 2] | 0 : i7 & 255;
     i3 = i16 + 11 | 0;
     i1 = HEAP8[i3 >> 0] | 0;
     i2 = i1 << 24 >> 24 < 0;
     if (i2) i4 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
     do if (i7 >>> 0 > i4 >>> 0) {
      if (i2) i1 = HEAP32[i16 + 4 >> 2] | 0; else i1 = i1 & 255;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
     } else {
      if (i2) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
      if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
      HEAP8[i1 + i7 >> 0] = 0;
      if ((HEAP8[i3 >> 0] | 0) < 0) {
       HEAP32[i16 + 4 >> 2] = i7;
       break;
      } else {
       HEAP8[i3 >> 0] = i7;
       break;
      }
     } while (0);
     if ((HEAP8[i5 >> 0] | 0) < 0) {
      i9 = HEAP32[i14 >> 2] | 0;
      i14 = HEAP32[i14 + 12 >> 2] | 0;
      HEAP32[i12 >> 2] = 66;
      HEAP32[i12 + 4 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i9, i12);
     }
    } else {
     HEAP32[i14 >> 2] = 0;
     HEAP32[i14 + 4 >> 2] = 0;
     HEAP32[i14 + 8 >> 2] = 0;
     HEAP32[i14 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
     i1 = i14 + 11 | 0;
     HEAP8[i1 >> 0] = 0;
     HEAP8[i14 >> 0] = 0;
     i2 = i16 + 11 | 0;
     if ((HEAP8[i2 >> 0] | 0) < 0) i3 = HEAP32[i16 >> 2] | 0; else i3 = i16;
     HEAP8[i3 >> 0] = 0;
     if ((HEAP8[i2 >> 0] | 0) < 0) HEAP32[i16 + 4 >> 2] = 0; else HEAP8[i2 >> 0] = 0;
     if ((HEAP8[i1 >> 0] | 0) < 0) {
      i9 = HEAP32[i14 >> 2] | 0;
      i14 = HEAP32[i14 + 12 >> 2] | 0;
      HEAP32[i12 >> 2] = 66;
      HEAP32[i12 + 4 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i9, i12);
     }
    }
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 >> 2] = i16;
    i1 = i15 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i15, i12); else {
     HEAP32[i2 >> 2] = i16;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
    }
    if (HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] & 1 | 0) {
     i16 = i15 + 16 | 0;
     HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
    }
   }
  }
 }
 if ((i13 | 0) == 31) {
  do if ((i16 | 0) != (i7 | 0)) {
   i5 = HEAP8[i4 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
   i5 = i3 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
   i3 = i16 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i16 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i5 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i16 + 4 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
    break;
   }
   if (i2) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i16 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i3 >> 0] = i5;
    break;
   }
  } while (0);
  HEAP32[i14 >> 2] = i16;
  i1 = i15 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i15, i14); else {
   HEAP32[i2 >> 2] = i16;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
  }
  if (HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] & 1 | 0) {
   i16 = i15 + 16 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  }
 }
 i16 = 1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN11b2WeldJoint24SolvePositionConstraintsERK12b2SolverData(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i35 + 48 | 0;
 i18 = i35 + 40 | 0;
 i6 = i35 + 32 | 0;
 i19 = i35 + 20 | 0;
 i31 = i35 + 8 | 0;
 i20 = i35;
 i34 = i9 + 116 | 0;
 i23 = HEAP32[i34 >> 2] | 0;
 i21 = i1 + 24 | 0;
 i37 = HEAP32[i21 >> 2] | 0;
 i7 = HEAP32[i37 + (i23 * 12 | 0) >> 2] | 0;
 i8 = HEAP32[i37 + (i23 * 12 | 0) + 4 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i37 + (i23 * 12 | 0) + 8 >> 2]);
 i23 = i9 + 120 | 0;
 i36 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i37 + (i36 * 12 | 0) >> 2] | 0;
 i5 = HEAP32[i37 + (i36 * 12 | 0) + 4 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i37 + (i36 * 12 | 0) + 8 >> 2]);
 f32 = Math_fround(+Math_sin(+f22));
 f15 = Math_fround(+Math_cos(+f22));
 f16 = Math_fround(+Math_sin(+f24));
 f2 = Math_fround(+Math_cos(+f24));
 f25 = Math_fround(HEAPF32[i9 + 156 >> 2]);
 f26 = Math_fround(HEAPF32[i9 + 160 >> 2]);
 f27 = Math_fround(HEAPF32[i9 + 164 >> 2]);
 f28 = Math_fround(HEAPF32[i9 + 168 >> 2]);
 f33 = Math_fround(HEAPF32[i9 + 80 >> 2]);
 f33 = Math_fround(f33 - Math_fround(HEAPF32[i9 + 140 >> 2]));
 f30 = Math_fround(HEAPF32[i9 + 84 >> 2]);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i9 + 144 >> 2]));
 f29 = Math_fround(Math_fround(f15 * f33) - Math_fround(f32 * f30));
 f30 = Math_fround(Math_fround(f32 * f33) + Math_fround(f15 * f30));
 f15 = Math_fround(HEAPF32[i9 + 88 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i9 + 148 >> 2]));
 f33 = Math_fround(HEAPF32[i9 + 92 >> 2]);
 f33 = Math_fround(f33 - Math_fround(HEAPF32[i9 + 152 >> 2]));
 f32 = Math_fround(Math_fround(f2 * f15) - Math_fround(f16 * f33));
 f33 = Math_fround(Math_fround(f16 * f15) + Math_fround(f2 * f33));
 f2 = Math_fround(f25 + f26);
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f2 + Math_fround(f27 * Math_fround(f30 * f30))) + Math_fround(f28 * Math_fround(f33 * f33)));
 f15 = Math_fround(Math_fround(-Math_fround(f27 * Math_fround(f30 * f29))) - Math_fround(f28 * Math_fround(f33 * f32)));
 HEAPF32[i17 + 12 >> 2] = f15;
 f16 = Math_fround(Math_fround(-Math_fround(f27 * f30)) - Math_fround(f28 * f33));
 HEAPF32[i17 + 24 >> 2] = f16;
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 16 >> 2] = Math_fround(Math_fround(f2 + Math_fround(f27 * Math_fround(f29 * f29))) + Math_fround(f28 * Math_fround(f32 * f32)));
 f2 = Math_fround(Math_fround(f27 * f29) + Math_fround(f28 * f32));
 HEAPF32[i17 + 28 >> 2] = f2;
 HEAPF32[i17 + 8 >> 2] = f16;
 HEAPF32[i17 + 20 >> 2] = f2;
 f2 = Math_fround(f27 + f28);
 HEAPF32[i17 + 32 >> 2] = f2;
 if (Math_fround(HEAPF32[i9 + 68 >> 2]) > Math_fround(0.0)) {
  f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f10 + f32);
  f12 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f12 + f33);
  f11 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f15 - f11);
  f13 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f15 - f29);
  f16 = Math_fround(Math_fround(f16 - f13) - f30);
  HEAPF32[i18 >> 2] = f15;
  HEAPF32[i18 + 4 >> 2] = f16;
  f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16))));
  __ZNK7b2Mat337Solve22ERK6b2Vec2(i6, i17, i18);
  f15 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  f14 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
  i37 = 1;
  f33 = Math_fround(Math_fround(f32 * f14) - Math_fround(f33 * f15));
  f29 = Math_fround(Math_fround(f29 * f14) - Math_fround(f30 * f15));
  f30 = Math_fround(f10 + Math_fround(f26 * f15));
  f15 = Math_fround(f11 - Math_fround(f25 * f15));
  f32 = Math_fround(f12 + Math_fround(f26 * f14));
  f26 = Math_fround(f13 - Math_fround(f25 * f14));
  f29 = Math_fround(f27 * f29);
  f33 = Math_fround(f28 * f33);
  f29 = Math_fround(f22 - f29);
  f33 = Math_fround(f24 + f33);
  i36 = HEAP32[i34 >> 2] | 0;
  i31 = HEAP32[i21 >> 2] | 0;
  i20 = i31 + (i36 * 12 | 0) | 0;
  HEAPF32[i20 >> 2] = f15;
  i36 = i31 + (i36 * 12 | 0) + 4 | 0;
  HEAPF32[i36 >> 2] = f26;
  i36 = HEAP32[i34 >> 2] | 0;
  i34 = HEAP32[i21 >> 2] | 0;
  i36 = i34 + (i36 * 12 | 0) + 8 | 0;
  HEAPF32[i36 >> 2] = f29;
  i36 = HEAP32[i23 >> 2] | 0;
  i31 = i34 + (i36 * 12 | 0) | 0;
  HEAPF32[i31 >> 2] = f30;
  i36 = i34 + (i36 * 12 | 0) + 4 | 0;
  HEAPF32[i36 >> 2] = f32;
  i36 = HEAP32[i23 >> 2] | 0;
  i34 = HEAP32[i21 >> 2] | 0;
  i36 = i34 + (i36 * 12 | 0) + 8 | 0;
  HEAPF32[i36 >> 2] = f33;
  i36 = f16 <= Math_fround(.00499999989);
  i37 = i36 & i37;
  STACKTOP = i35;
  return i37 | 0;
 }
 f16 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f16 + f32);
 f15 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f15 + f33);
 f14 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f3 - f14);
 f13 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f3 - f29);
 f4 = Math_fround(Math_fround(f4 - f13) - f30);
 HEAPF32[i18 >> 2] = f3;
 HEAPF32[i18 + 4 >> 2] = f4;
 f10 = Math_fround(f24 - f22);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i9 + 96 >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3))));
 i1 = f10 > Math_fround(0.0);
 f12 = Math_fround(-f10);
 HEAPF32[i19 >> 2] = f3;
 HEAPF32[i19 + 4 >> 2] = f4;
 HEAPF32[i19 + 8 >> 2] = f10;
 if (f2 > Math_fround(0.0)) {
  __ZNK7b2Mat337Solve33ERK6b2Vec3(i31, i17, i19);
  f4 = Math_fround(HEAPF32[i31 >> 2]);
  f3 = Math_fround(HEAPF32[i31 + 4 >> 2]);
  f2 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 } else {
  __ZNK7b2Mat337Solve22ERK6b2Vec2(i20, i17, i18);
  f4 = Math_fround(HEAPF32[i20 >> 2]);
  f3 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f2 = Math_fround(0.0);
 }
 f3 = Math_fround(-f3);
 f4 = Math_fround(-f4);
 i37 = (i1 ? f10 : f12) <= Math_fround(.0349065885);
 f12 = f11;
 f33 = Math_fround(f2 + Math_fround(Math_fround(f32 * f3) - Math_fround(f33 * f4)));
 f29 = Math_fround(f2 + Math_fround(Math_fround(f29 * f3) - Math_fround(f30 * f4)));
 f30 = Math_fround(f16 + Math_fround(f26 * f4));
 f16 = Math_fround(f14 - Math_fround(f25 * f4));
 f32 = Math_fround(f15 + Math_fround(f26 * f3));
 f26 = Math_fround(f13 - Math_fround(f25 * f3));
 f29 = Math_fround(f27 * f29);
 f33 = Math_fround(f28 * f33);
 f29 = Math_fround(f22 - f29);
 f33 = Math_fround(f24 + f33);
 i36 = HEAP32[i34 >> 2] | 0;
 i31 = HEAP32[i21 >> 2] | 0;
 i20 = i31 + (i36 * 12 | 0) | 0;
 HEAPF32[i20 >> 2] = f16;
 i36 = i31 + (i36 * 12 | 0) + 4 | 0;
 HEAPF32[i36 >> 2] = f26;
 i36 = HEAP32[i34 >> 2] | 0;
 i34 = HEAP32[i21 >> 2] | 0;
 i36 = i34 + (i36 * 12 | 0) + 8 | 0;
 HEAPF32[i36 >> 2] = f29;
 i36 = HEAP32[i23 >> 2] | 0;
 i31 = i34 + (i36 * 12 | 0) | 0;
 HEAPF32[i31 >> 2] = f30;
 i36 = i34 + (i36 * 12 | 0) + 4 | 0;
 HEAPF32[i36 >> 2] = f32;
 i36 = HEAP32[i23 >> 2] | 0;
 i34 = HEAP32[i21 >> 2] | 0;
 i36 = i34 + (i36 * 12 | 0) + 8 | 0;
 HEAPF32[i36 >> 2] = f33;
 i36 = f12 <= Math_fround(.00499999989);
 i37 = i36 & i37;
 STACKTOP = i35;
 return i37 | 0;
}

function __ZN5physx3Ext31UnregisterExtensionsSerializersERNS_23PxSerializationRegistryE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 259) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 260) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 261) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 258) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 257) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 256) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 8) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 7) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 3) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 1) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 2) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 6) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 5) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 14) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 13) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 4) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 10) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 11) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 12) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 259) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 260) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 261) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 258) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 257) | 0;
 if (i1 | 0) {
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 256) | 0;
 if (!i1) return;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN16CrashReportEventC2ERKS_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 12;
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i2;
  i8 = 12;
 }
 if ((i8 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 32 | 0;
 i3 = i7 + 32 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 36 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 44 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 44 >> 2] | 0;
  i8 = 16;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 18;
 } else i8 = 16;
 if ((i8 | 0) == 16) {
  i11 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i6 + 40 >> 2] = i11 | -2147483648;
  HEAP32[i6 + 36 >> 2] = i4;
  i1 = i10;
  i8 = 18;
 }
 if ((i8 | 0) == 18) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 48 | 0;
 i3 = i7 + 48 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 52 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 60 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 60 >> 2] | 0;
  i8 = 22;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 24;
 } else i8 = 22;
 if ((i8 | 0) == 22) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i6 + 56 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 52 >> 2] = i4;
  i1 = i11;
  i8 = 24;
 }
 if ((i8 | 0) == 24) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 64 | 0;
 i3 = i7 + 64 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 68 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 76 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 76 >> 2] | 0;
  i8 = 28;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 30;
 } else i8 = 28;
 if ((i8 | 0) == 28) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i6 + 72 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 68 >> 2] = i4;
  i1 = i11;
  i8 = 30;
 }
 if ((i8 | 0) == 30) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 80 | 0;
 i3 = i7 + 80 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 84 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 92 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 92 >> 2] | 0;
  i8 = 34;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 36;
 } else i8 = 34;
 if ((i8 | 0) == 34) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i6 + 88 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 84 >> 2] = i4;
  i1 = i11;
  i8 = 36;
 }
 if ((i8 | 0) == 36) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 96 | 0;
 i3 = i7 + 96 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 100 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 108 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 108 >> 2] | 0;
  i8 = 40;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i11 = i1;
   i11 = i11 + i4 | 0;
   HEAP8[i11 >> 0] = 0;
   i11 = i6 + 112 | 0;
   i10 = i7 + 112 | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   HEAP32[i11 >> 2] = i10;
   STACKTOP = i9;
   return;
  }
 } else i8 = 40;
 if ((i8 | 0) == 40) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i6 + 104 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 100 >> 2] = i4;
  i1 = i11;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i11 = i1;
 i11 = i11 + i4 | 0;
 HEAP8[i11 >> 0] = 0;
 i11 = i6 + 112 | 0;
 i10 = i7 + 112 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i9;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE8EvaluateEfPNS1_5CacheE(i9, i10, f11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 16 | 0;
 i13 = i16 + 12 | 0;
 i14 = i16;
 i15 = i10 + 132 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 if ((i4 | 0) == 1) {
  i15 = HEAP32[i10 + 120 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 12 >> 2];
  STACKTOP = i16;
  return;
 }
 i7 = (i1 | 0) == 0 ? i10 : i1;
 i8 = i7 + 4 | 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 if (f2 <= f11) if (Math_fround(HEAPF32[i7 + 8 >> 2]) > f11) {
  f17 = Math_fround(f11 - f2);
  f2 = Math_fround(f17 * Math_fround(HEAPF32[i7 + 12 >> 2]));
  f5 = Math_fround(f17 * Math_fround(HEAPF32[i7 + 16 >> 2]));
  f11 = Math_fround(f17 * Math_fround(HEAPF32[i7 + 20 >> 2]));
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i7 + 24 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 + 28 >> 2]));
  f2 = Math_fround(f17 * f2);
  f5 = Math_fround(f17 * f5);
  f11 = Math_fround(f17 * Math_fround(f11 + Math_fround(HEAPF32[i7 + 32 >> 2])));
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i7 + 36 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 + 40 >> 2]));
  f2 = Math_fround(f17 * f2);
  f5 = Math_fround(f17 * f5);
  f11 = Math_fround(f17 * Math_fround(f11 + Math_fround(HEAPF32[i7 + 44 >> 2])));
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i7 + 48 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 + 52 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i7 + 56 >> 2]));
  HEAPF32[i14 >> 2] = f2;
  HEAPF32[i14 + 4 >> 2] = f5;
  HEAPF32[i14 + 8 >> 2] = f11;
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i9 + 4 >> 2] = f5;
  HEAPF32[i9 + 8 >> 2] = f11;
  STACKTOP = i16;
  return;
 }
 if (i4 | 0) {
  i6 = i10 + 120 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i3 >> 2] & 2139095040 | 0) != 2139095040) {
   i1 = i4 + -1 | 0;
   if ((HEAP32[i3 + (i1 * 40 | 0) >> 2] & 2139095040 | 0) != 2139095040) {
    f5 = Math_fround(HEAPF32[i3 >> 2]);
    f2 = Math_fround(HEAPF32[i3 + (i1 * 40 | 0) >> 2]);
    L14 : do if (!(f2 <= f11)) {
     if (!(f5 > f11)) {
      __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i10, i7, f11, i12, i13);
      __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i10, i7, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, Math_fround(0.0));
      break;
     }
     switch (HEAP32[i10 + 140 >> 2] | 0) {
     case 2:
      {
       HEAPF32[i8 >> 2] = Math_fround(f11 + Math_fround(-1.0e3));
       HEAPF32[i7 + 8 >> 2] = f5;
       i15 = i7 + 12 | 0;
       i12 = i7 + 24 | 0;
       i13 = i7 + 36 | 0;
       HEAPF32[i7 + 36 >> 2] = Math_fround(0.0);
       HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
       HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
       HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       i15 = i7 + 48 | 0;
       i13 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
       HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       break L14;
      }
     case 1:
      {
       f18 = Math_fround(f11 - f5);
       f17 = Math_fround(f2 - f5);
       f17 = Math_fround(f5 + Math_fround(f18 - Math_fround(f17 * Math_fround(Math_floor(Math_fround(f18 / f17))))));
       __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i10, i7, f17, i12, i13);
       __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i10, i7, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, Math_fround(f11 - f17));
       break L14;
      }
     default:
      {
       __ZNK17AnimationCurveTplI8Vector3fE20EvaluateWithoutCacheEfRS0_(i10, f11, i14);
       HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
       STACKTOP = i16;
       return;
      }
     }
    } else switch (HEAP32[i10 + 144 >> 2] | 0) {
    case 2:
     {
      HEAPF32[i8 >> 2] = f2;
      HEAPF32[i7 + 8 >> 2] = Math_fround(inf);
      i13 = i7 + 12 | 0;
      i10 = i7 + 24 | 0;
      i12 = i7 + 36 | 0;
      HEAPF32[i7 + 36 >> 2] = Math_fround(0.0);
      HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
      HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
      HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      i13 = i7 + 48 | 0;
      i15 = (HEAP32[i6 >> 2] | 0) + (((HEAP32[i15 >> 2] | 0) + -1 | 0) * 40 | 0) + 4 | 0;
      HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
      break L14;
     }
    case 1:
     {
      f17 = Math_fround(f11 - f5);
      f18 = Math_fround(f2 - f5);
      f18 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f5 + Math_fround(f17 - Math_fround(f18 * Math_fround(Math_floor(Math_fround(f17 / f18)))))), f5)), f2));
      __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i10, i7, f18, i12, i13);
      __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i10, i7, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, Math_fround(f11 - f18));
      break L14;
     }
    default:
     {
      __ZNK17AnimationCurveTplI8Vector3fE20EvaluateWithoutCacheEfRS0_(i10, f11, i14);
      HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      STACKTOP = i16;
      return;
     }
    } while (0);
    f5 = Math_fround(f11 - Math_fround(HEAPF32[i8 >> 2]));
    f11 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) * f5);
    f17 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 16 >> 2]));
    f18 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 20 >> 2]));
    f11 = Math_fround(f11 + Math_fround(HEAPF32[i7 + 24 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i7 + 28 >> 2]));
    f11 = Math_fround(f5 * f11);
    f17 = Math_fround(f5 * f17);
    f18 = Math_fround(f5 * Math_fround(f18 + Math_fround(HEAPF32[i7 + 32 >> 2])));
    f11 = Math_fround(f11 + Math_fround(HEAPF32[i7 + 36 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i7 + 40 >> 2]));
    f11 = Math_fround(f5 * f11);
    f17 = Math_fround(f5 * f17);
    f18 = Math_fround(f5 * Math_fround(f18 + Math_fround(HEAPF32[i7 + 44 >> 2])));
    f11 = Math_fround(f11 + Math_fround(HEAPF32[i7 + 48 >> 2]));
    f17 = Math_fround(f17 + Math_fround(HEAPF32[i7 + 52 >> 2]));
    f18 = Math_fround(f18 + Math_fround(HEAPF32[i7 + 56 >> 2]));
    HEAPF32[i14 >> 2] = f11;
    HEAPF32[i14 + 4 >> 2] = f17;
    HEAPF32[i14 + 8 >> 2] = f18;
    HEAPF32[i9 >> 2] = f11;
    HEAPF32[i9 + 4 >> 2] = f17;
    HEAPF32[i9 + 8 >> 2] = f18;
    STACKTOP = i16;
    return;
   }
  }
 }
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 STACKTOP = i16;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11CulledLightS2_EEPS2_EEbT0_S6_T_(i10, i9, i1) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 switch (i9 - i10 >> 3 | 0) {
 case 2:
  {
   if (!(Math_fround(HEAPF32[i9 + -4 >> 2]) > Math_fround(HEAPF32[i10 + 4 >> 2]))) {
    i10 = 1;
    return i10 | 0;
   }
   i7 = i9 + -8 | 0;
   i9 = i10;
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i3 = i7;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = i5;
   i10 = i7;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i10 + 4 >> 2] = i9;
   i10 = 1;
   return i10 | 0;
  }
 case 3:
  {
   i7 = i10 + 8 | 0;
   i8 = i9 + -8 | 0;
   i1 = i10 + 12 | 0;
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   i2 = i10 + 4 | 0;
   i11 = f6 > Math_fround(HEAPF32[i2 >> 2]);
   i3 = i9 + -4 | 0;
   i5 = Math_fround(HEAPF32[i3 >> 2]) > f6;
   if (!i11) {
    if (!i5) {
     i11 = 1;
     return i11 | 0;
    }
    i9 = i7;
    i5 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i12 = i8;
    i3 = HEAP32[i12 + 4 >> 2] | 0;
    i11 = i7;
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = i3;
    i11 = i8;
    HEAP32[i11 >> 2] = i5;
    HEAP32[i11 + 4 >> 2] = i9;
    f6 = Math_fround(HEAPF32[i1 >> 2]);
    if (!(f6 > Math_fround(HEAPF32[i2 >> 2]))) {
     i12 = 1;
     return i12 | 0;
    }
    i11 = i10;
    i9 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i5 = i7;
    i8 = HEAP32[i5 + 4 >> 2] | 0;
    i12 = i10;
    HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i12 + 4 >> 2] = i8;
    i12 = i7;
    HEAP32[i12 >> 2] = i9;
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = 1;
    return i12 | 0;
   }
   i2 = i10;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (i5) {
    i9 = i8;
    i11 = HEAP32[i9 + 4 >> 2] | 0;
    i12 = i10;
    HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i12 = i8;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i2;
    i12 = 1;
    return i12 | 0;
   }
   i9 = i7;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i10;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = i7;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   if (!(Math_fround(HEAPF32[i3 >> 2]) > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) {
    i12 = 1;
    return i12 | 0;
   }
   i10 = i8;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i7;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = i8;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i10, i10 + 8 | 0, i10 + 16 | 0, i9 + -8 | 0, i1) | 0;
   i12 = 1;
   return i12 | 0;
  }
 case 5:
  {
   i5 = i10 + 8 | 0;
   i7 = i10 + 16 | 0;
   i3 = i10 + 24 | 0;
   __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i10, i5, i7, i3, i1) | 0;
   i1 = i10 + 28 | 0;
   if (!(Math_fround(HEAPF32[i9 + -4 >> 2]) > Math_fround(HEAPF32[i1 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   i12 = i9 + -8 | 0;
   i11 = i3;
   i9 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i12;
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = i3;
   HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[i12 >> 2] = i9;
   HEAP32[i12 + 4 >> 2] = i11;
   if (!(Math_fround(HEAPF32[i1 >> 2]) > Math_fround(HEAPF32[i10 + 20 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i7;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i2 = i3;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = i7;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i3;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f4 > Math_fround(HEAPF32[i10 + 12 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i5;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i5;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i7;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   if (!(f4 > Math_fround(HEAPF32[i10 + 4 >> 2]))) {
    i13 = 1;
    return i13 | 0;
   }
   i12 = i10;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i10;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   i13 = i5;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i13 + 4 >> 2] = i12;
   i13 = 1;
   return i13 | 0;
  }
 case 1:
 case 0:
  {
   i13 = 1;
   return i13 | 0;
  }
 default:
  {
   i3 = i10 + 16 | 0;
   i7 = i10 + 8 | 0;
   f14 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i10 + 20 >> 2]);
   i5 = f6 > f14;
   do if (f14 > f4) {
    i2 = i10;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (i5) {
     i11 = i3;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i10;
     HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = i3;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
     break;
    }
    i11 = i7;
    i12 = HEAP32[i11 + 4 >> 2] | 0;
    i13 = i10;
    HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
    i13 = i7;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2;
    if (f6 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i11 = i3;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i7;
     HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = i3;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
    }
   } else if (i5) {
    i12 = i7;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i2 = i3;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i13 = i7;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2;
    i13 = i3;
    HEAP32[i13 >> 2] = i11;
    HEAP32[i13 + 4 >> 2] = i12;
    if ((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f4) {
     i12 = i10;
     i11 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     i13 = i10;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i13 + 4 >> 2] = i2;
     i13 = i7;
     HEAP32[i13 >> 2] = i11;
     HEAP32[i13 + 4 >> 2] = i12;
    }
   } while (0);
   i1 = i10 + 24 | 0;
   L13 : do if ((i1 | 0) == (i9 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     if (f4 > Math_fround(HEAPF32[i3 + 4 >> 2])) {
      i7 = HEAP32[i1 >> 2] | 0;
      i5 = i1;
      while (1) {
       i11 = i3;
       i12 = HEAP32[i11 + 4 >> 2] | 0;
       i13 = i5;
       HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i13 + 4 >> 2] = i12;
       if ((i3 | 0) == (i10 | 0)) {
        i3 = i10;
        break;
       }
       if (f4 > Math_fround(HEAPF32[i3 + -4 >> 2])) {
        i5 = i3;
        i3 = i3 + -8 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i7;
      HEAPF32[i3 + 4 >> 2] = f4;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i9 | 0);
       break L13;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i9 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i13 = i1;
      i1 = i3;
      i3 = i13;
     }
    }
   } while (0);
   i13 = i1 | i2;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu20intersectTriangleBoxERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_(i1, i30, i2, i3, i4) {
 i1 = i1 | 0;
 i30 = i30 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0;
 f45 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i30 + 4 | 0;
 f46 = Math_fround(HEAPF32[i31 >> 2]);
 i37 = i30 + 8 | 0;
 f41 = Math_fround(HEAPF32[i37 >> 2]);
 f38 = Math_fround(-f45);
 f39 = Math_fround(-f46);
 f40 = Math_fround(-f41);
 f32 = Math_fround(HEAPF32[i2 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f29 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f32 = Math_fround(f32 - f28);
 f33 = Math_fround(f33 - f29);
 f34 = Math_fround(f34 - f8);
 f35 = Math_fround(HEAPF32[i3 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f35 = Math_fround(f35 - f28);
 f36 = Math_fround(f36 - f29);
 f27 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f8);
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f28 = Math_fround(f10 - f28);
 f29 = Math_fround(f9 - f29);
 f8 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) - f8);
 f9 = Math_fround(f35 - f32);
 f10 = Math_fround(f36 - f33);
 f11 = Math_fround(f27 - f34);
 f12 = Math_fround(f28 - f35);
 f13 = Math_fround(f29 - f36);
 f14 = Math_fround(f8 - f27);
 f15 = Math_fround(f32 - f28);
 f16 = Math_fround(f33 - f29);
 f17 = Math_fround(f34 - f8);
 f18 = Math_fround(-f11);
 f19 = Math_fround(-f14);
 f20 = Math_fround(-f17);
 f21 = Math_fround(-f9);
 f22 = Math_fround(-f12);
 f23 = Math_fround(-f15);
 f24 = Math_fround(-f10);
 f25 = Math_fround(-f13);
 f26 = Math_fround(-f16);
 f48 = Math_fround(f32 * Math_fround(0.0));
 f44 = Math_fround(Math_fround(f34 * f10) + Math_fround(f48 + Math_fround(f33 * f18)));
 f43 = Math_fround(Math_fround(Math_fround(f28 * Math_fround(0.0)) + Math_fround(f29 * f18)) + Math_fround(f10 * f8));
 f45 = Math_fround(f45 * Math_fround(-0.0));
 f42 = Math_fround(Math_fround(f45 + Math_fround((f11 < f18 ? f18 : f11) * f46)) + Math_fround((f10 > f24 ? f10 : f24) * f41));
 f5 = Math_fround(Math_fround(f34 * f13) + Math_fround(f48 + Math_fround(f33 * f19)));
 f47 = Math_fround(f35 * Math_fround(0.0));
 f6 = Math_fround(Math_fround(f27 * f13) + Math_fround(f47 + Math_fround(f36 * f19)));
 f7 = Math_fround(Math_fround((f13 > f25 ? f13 : f25) * f41) + Math_fround(f45 + Math_fround(f46 * (f14 < f19 ? f19 : f14))));
 f48 = Math_fround(Math_fround(f34 * f16) + Math_fround(f48 + Math_fround(f33 * f20)));
 f47 = Math_fround(Math_fround(f27 * f16) + Math_fround(f47 + Math_fround(f36 * f20)));
 f46 = Math_fround(Math_fround((f16 > f26 ? f16 : f26) * f41) + Math_fround(f45 + Math_fround(f46 * (f17 < f20 ? f20 : f17))));
 f45 = Math_fround(-f42);
 f41 = Math_fround(-f7);
 f49 = Math_fround(-f46);
 if (((f48 > f47 ? f48 : f47) < f49 ? 1 : (f48 < f47 ? f48 : f47) > f46) | (((f44 > f43 ? f44 : f43) < f45 ? 1 : (f44 < f43 ? f44 : f43) > f42) | ((f5 > f6 ? f5 : f6) < f41 ? 1 : (f5 < f6 ? f5 : f6) > f7))) {
  i37 = 0;
  return i37 | 0;
 }
 f42 = Math_fround(f33 * Math_fround(0.0));
 f47 = Math_fround(Math_fround(f34 * f21) + Math_fround(f42 + Math_fround(f32 * f11)));
 f48 = Math_fround(Math_fround(Math_fround(f11 * f28) + Math_fround(f29 * Math_fround(0.0))) + Math_fround(f8 * f21));
 f7 = Math_fround(HEAPF32[i30 >> 2]);
 f6 = Math_fround(HEAPF32[i31 >> 2]);
 f5 = Math_fround(HEAPF32[i37 >> 2]);
 f41 = Math_fround(f6 * Math_fround(-0.0));
 f49 = Math_fround(Math_fround(Math_fround((f11 > f18 ? f11 : f18) * f7) + f41) + Math_fround((f9 < f21 ? f21 : f9) * f5));
 f43 = Math_fround(Math_fround(f34 * f22) + Math_fround(f42 + Math_fround(f32 * f14)));
 f46 = Math_fround(f36 * Math_fround(0.0));
 f44 = Math_fround(Math_fround(f27 * f22) + Math_fround(f46 + Math_fround(f35 * f14)));
 f45 = Math_fround(Math_fround(Math_fround((f14 > f19 ? f14 : f19) * f7) + f41) + Math_fround((f12 < f22 ? f22 : f12) * f5));
 f18 = Math_fround(Math_fround(f34 * f23) + Math_fround(f42 + Math_fround(f32 * f17)));
 f19 = Math_fround(Math_fround(f27 * f23) + Math_fround(f46 + Math_fround(f35 * f17)));
 f41 = Math_fround(Math_fround(Math_fround((f17 > f20 ? f17 : f20) * f7) + f41) + Math_fround((f15 < f23 ? f23 : f15) * f5));
 f46 = Math_fround(-f49);
 f42 = Math_fround(-f45);
 f20 = Math_fround(-f41);
 if (((f18 > f19 ? f18 : f19) < f20 ? 1 : (f18 < f19 ? f18 : f19) > f41) | (((f43 > f44 ? f43 : f44) < f42 ? 1 : (f43 < f44 ? f43 : f44) > f45) | ((f47 > f48 ? f47 : f48) < f46 ? 1 : (f47 < f48 ? f47 : f48) > f49))) {
  i37 = 0;
  return i37 | 0;
 }
 f42 = Math_fround(f34 * Math_fround(0.0));
 f47 = Math_fround(f42 + Math_fround(Math_fround(f33 * f9) + Math_fround(f32 * f24)));
 f48 = Math_fround(Math_fround(Math_fround(f28 * f24) + Math_fround(f9 * f29)) + Math_fround(f8 * Math_fround(0.0)));
 f41 = Math_fround(f5 * Math_fround(-0.0));
 f49 = Math_fround(Math_fround(Math_fround((f10 < f24 ? f24 : f10) * f7) + Math_fround((f9 > f21 ? f9 : f21) * f6)) + f41);
 f43 = Math_fround(f42 + Math_fround(Math_fround(f33 * f12) + Math_fround(f32 * f25)));
 f46 = Math_fround(f27 * Math_fround(0.0));
 f44 = Math_fround(f46 + Math_fround(Math_fround(f36 * f12) + Math_fround(f35 * f25)));
 f45 = Math_fround(Math_fround(Math_fround((f13 < f25 ? f25 : f13) * f7) + Math_fround((f12 > f22 ? f12 : f22) * f6)) + f41);
 f24 = Math_fround(f42 + Math_fround(Math_fround(f33 * f15) + Math_fround(f32 * f26)));
 f25 = Math_fround(f46 + Math_fround(Math_fround(f36 * f15) + Math_fround(f35 * f26)));
 f41 = Math_fround(Math_fround(Math_fround((f16 < f26 ? f26 : f16) * f7) + Math_fround((f15 > f23 ? f15 : f23) * f6)) + f41);
 f46 = Math_fround(-f49);
 f42 = Math_fround(-f45);
 f26 = Math_fround(-f41);
 if (((f24 > f25 ? f24 : f25) < f26 ? 1 : (f24 < f25 ? f24 : f25) > f41) | (((f43 > f44 ? f43 : f44) < f42 ? 1 : (f43 < f44 ? f43 : f44) > f45) | ((f47 > f48 ? f47 : f48) < f46 ? 1 : (f47 < f48 ? f47 : f48) > f49))) {
  i37 = 0;
  return i37 | 0;
 }
 f41 = f35 < f28 ? f35 : f28;
 f43 = f36 < f29 ? f36 : f29;
 f45 = f27 < f8 ? f27 : f8;
 f35 = f35 > f28 ? f35 : f28;
 f42 = f36 > f29 ? f36 : f29;
 f44 = f27 > f8 ? f27 : f8;
 f46 = Math_fround(Math_fround(f10 * f14) - Math_fround(f11 * f13));
 f47 = Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f14));
 f48 = Math_fround(Math_fround(f9 * f13) - Math_fround(f10 * f12));
 f49 = Math_fround(Math_fround(f34 * f48) + Math_fround(Math_fround(f32 * f46) + Math_fround(f33 * f47)));
 i30 = f46 > Math_fround(0.0);
 i31 = f47 > Math_fround(0.0);
 i37 = f48 > Math_fround(0.0);
 i37 = (((f32 > f35 ? f32 : f35) < f38 ? 1 : (f32 < f41 ? f32 : f41) > f7) | ((f33 > f42 ? f33 : f42) < f39 ? 1 : (f33 < f43 ? f33 : f43) > f6) | ((f34 > f44 ? f34 : f44) < f40 ? 1 : (f34 < f45 ? f34 : f45) > f5) | Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f46 * (i30 ? f38 : f7)) + Math_fround(f47 * (i31 ? f39 : f6))) + Math_fround(f48 * (i37 ? f40 : f5))) - f49) * Math_fround(Math_fround(Math_fround(Math_fround(f46 * (i30 ? f7 : f38)) + Math_fround(f47 * (i31 ? f6 : f39))) + Math_fround(f48 * (i37 ? f5 : f40))) - f49)) > Math_fround(0.0)) ^ 1;
 return i37 | 0;
}

function __ZN13SpeedTreeWind4GustEdd(i11, d12, d1) {
 i11 = i11 | 0;
 d12 = +d12;
 d1 = +d1;
 var d2 = 0.0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, d16 = 0.0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 4 | 0;
 i14 = i15;
 i10 = i11 + 1424 | 0;
 d2 = +HEAPF64[i10 >> 3];
 if (d2 < d12) i3 = 4; else if (+HEAPF64[i11 + 1448 >> 3] > d12) if (+HEAPF64[i11 + 1416 >> 3] < d12) i3 = 4;
 if ((i3 | 0) == 4) {
  f4 = Math_fround(d1);
  if (!(HEAP8[gb + 1098160 >> 0] | 0)) {
   HEAP32[gb + 1170764 >> 2] = 0;
   HEAP32[gb + 1170764 + 4 >> 2] = 1;
   HEAP32[gb + 1170764 + 8 >> 2] = 1812433254;
   HEAP32[gb + 1170764 + 12 >> 2] = 1900727103;
   i5 = gb + 1098160 | 0;
   HEAP32[i5 >> 2] = 1;
   HEAP32[i5 + 4 >> 2] = 0;
   i5 = 1;
   i7 = 1812433254;
   i9 = 1900727103;
   i3 = 0;
  } else {
   i5 = HEAP32[gb + 1170764 + 4 >> 2] | 0;
   i7 = HEAP32[gb + 1170764 + 8 >> 2] | 0;
   i9 = HEAP32[gb + 1170764 + 12 >> 2] | 0;
   i3 = HEAP32[gb + 1170764 >> 2] | 0;
  }
  i8 = i3 << 11 ^ i3;
  HEAP32[gb + 1170764 >> 2] = i5;
  HEAP32[gb + 1170764 + 4 >> 2] = i7;
  HEAP32[gb + 1170764 + 8 >> 2] = i9;
  i8 = i9 >>> 19 ^ i9 ^ i8 ^ i8 >>> 8;
  HEAP32[gb + 1170764 + 12 >> 2] = i8;
  f6 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  d16 = +Math_fround(Math_fround(f6 * Math_fround(0.0)) + Math_fround(f4 * Math_fround(Math_fround(1.0) - f6)));
  if (d16 < +Math_fround(HEAPF32[i11 + 1304 >> 2]) * d1 * .009999999776482582) {
   HEAPF64[i11 + 1432 >> 3] = d12;
   d2 = +Math_fround(HEAPF32[i11 + 1404 >> 2]);
   HEAPF64[i11 + 1440 >> 3] = d2;
   f4 = Math_fround(HEAPF32[i11 + 1308 >> 2]);
   f6 = Math_fround(HEAPF32[i11 + 1312 >> 2]);
   i5 = i5 << 11 ^ i5;
   HEAP32[gb + 1170764 >> 2] = i7;
   HEAP32[gb + 1170764 + 4 >> 2] = i9;
   HEAP32[gb + 1170764 + 8 >> 2] = i8;
   i5 = i8 >>> 19 ^ i8 ^ i5 ^ i5 >>> 8;
   HEAP32[gb + 1170764 + 12 >> 2] = i5;
   f17 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
   f17 = Math_fround(Math_fround(f4 * f17) + Math_fround(f6 * Math_fround(Math_fround(1.0) - f17)));
   d1 = +f17;
   i3 = i11 + 1408 | 0;
   HEAPF64[i3 >> 3] = d1;
   f6 = Math_fround(HEAPF32[i11 + 1376 >> 2]);
   f4 = Math_fround(Math_fround(1.0) - f6);
   if (f17 > f4) {
    d1 = +f4;
    HEAPF64[i3 >> 3] = d1;
   }
   f17 = Math_fround(HEAPF32[i11 >> 2]);
   f4 = Math_fround(+Math_abs(+(d1 - +f6)));
   f4 = Math_fround(Math_fround(f17 * f4) + Math_fround(Math_fround(f17 * Math_fround(.5)) * Math_fround(Math_fround(1.0) - f4)));
   if (d1 > d2) {
    f18 = Math_fround(HEAPF32[i11 + 1324 >> 2]);
    f6 = Math_fround(f4 * Math_fround(2.0));
    i3 = i7 << 11 ^ i7;
    HEAP32[gb + 1170764 >> 2] = i9;
    HEAP32[gb + 1170764 + 4 >> 2] = i8;
    HEAP32[gb + 1170764 + 8 >> 2] = i5;
    i3 = i5 >>> 19 ^ i5 ^ i3 ^ i3 >>> 8;
    HEAP32[gb + 1170764 + 12 >> 2] = i3;
    f17 = Math_fround(Math_fround((i3 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
    d1 = +Math_fround(f18 * Math_fround(Math_fround(f4 * f17) + Math_fround(f6 * Math_fround(Math_fround(1.0) - f17)))) + d12;
    HEAPF64[i11 + 1416 >> 3] = d1;
   } else {
    f6 = Math_fround(HEAPF32[i11 + 1328 >> 2]);
    f17 = Math_fround(f4 * Math_fround(2.0));
    i3 = i7 << 11 ^ i7;
    HEAP32[gb + 1170764 >> 2] = i9;
    HEAP32[gb + 1170764 + 4 >> 2] = i8;
    HEAP32[gb + 1170764 + 8 >> 2] = i5;
    i3 = i5 >>> 19 ^ i5 ^ i3 ^ i3 >>> 8;
    HEAP32[gb + 1170764 + 12 >> 2] = i3;
    f18 = Math_fround(Math_fround((i3 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
    d1 = +Math_fround(f6 * Math_fround(Math_fround(f4 * f18) + Math_fround(f17 * Math_fround(Math_fround(1.0) - f18)))) + d12;
    HEAPF64[i11 + 1416 >> 3] = d1;
   }
   f6 = Math_fround(HEAPF32[i11 + 1316 >> 2]);
   i7 = i9 << 11 ^ i9;
   i7 = i3 >>> 19 ^ i3 ^ i7 ^ i7 >>> 8;
   f19 = Math_fround(Math_fround((i7 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
   d2 = d1 + +Math_fround(Math_fround(f6 * f19) + Math_fround(Math_fround(HEAPF32[i11 + 1320 >> 2]) * Math_fround(Math_fround(1.0) - f19)));
   HEAPF64[i11 + 1448 >> 3] = d2;
   f19 = Math_fround(HEAPF32[i11 + 1328 >> 2]);
   f6 = Math_fround(f4 * Math_fround(2.0));
   f17 = Math_fround(f4 * Math_fround(3.0));
   i9 = i8 << 11 ^ i8;
   HEAP32[gb + 1170764 >> 2] = i5;
   HEAP32[gb + 1170764 + 4 >> 2] = i3;
   HEAP32[gb + 1170764 + 8 >> 2] = i7;
   i9 = i7 >>> 19 ^ i7 ^ i9 ^ i9 >>> 8;
   HEAP32[gb + 1170764 + 12 >> 2] = i9;
   f18 = Math_fround(Math_fround((i9 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
   d2 = d2 + +Math_fround(f19 * Math_fround(Math_fround(f6 * f18) + Math_fround(f17 * Math_fround(Math_fround(1.0) - f18))));
   HEAPF64[i10 >> 3] = d2;
  }
 }
 d1 = +HEAPF64[i11 + 1416 >> 3];
 if (d1 > d12) {
  f18 = Math_fround(+HEAPF64[i11 + 1440 >> 3]);
  f17 = Math_fround(+HEAPF64[i11 + 1408 >> 3]);
  d16 = +HEAPF64[i11 + 1432 >> 3];
  f19 = Math_fround((d12 - d16) / (d1 - d16));
  f19 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_fround(f19 * Math_fround(6.0)) - Math_fround(Math_fround(Math_fround(1.0) - f19) * Math_fround(6.0)))))) + Math_fround(1.0))) + Math_fround(f19 * Math_fround(0.0)));
  HEAPF32[i11 + 1404 >> 2] = Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * Math_fround(Math_fround(1.0) - f19)));
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  i11 = i11 + 1404 | 0;
  f19 = Math_fround(HEAPF32[i11 >> 2]);
  i10 = f19 < Math_fround(1.0);
  i14 = i10 ? i11 : i14;
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  i10 = f19 > Math_fround(0.0);
  i14 = i10 ? i14 : i13;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i14;
  STACKTOP = i15;
  return;
 }
 d1 = +HEAPF64[i11 + 1448 >> 3];
 if (!(d1 < d12)) {
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  i11 = i11 + 1404 | 0;
  f19 = Math_fround(HEAPF32[i11 >> 2]);
  i10 = f19 < Math_fround(1.0);
  i14 = i10 ? i11 : i14;
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  i10 = f19 > Math_fround(0.0);
  i14 = i10 ? i14 : i13;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i14;
  STACKTOP = i15;
  return;
 }
 if (!(d2 > 0.0 & d2 > d1)) {
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  i11 = i11 + 1404 | 0;
  f19 = Math_fround(HEAPF32[i11 >> 2]);
  i10 = f19 < Math_fround(1.0);
  i14 = i10 ? i11 : i14;
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  i10 = f19 > Math_fround(0.0);
  i14 = i10 ? i14 : i13;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i14;
  STACKTOP = i15;
  return;
 }
 f19 = Math_fround((d12 - d1) / (d2 - d1));
 f19 = Math_fround(Math_fround(f19 * Math_fround(.5)) + Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_fround(f19 * Math_fround(6.0)) - Math_fround(Math_fround(Math_fround(1.0) - f19) * Math_fround(6.0)))))) + Math_fround(1.0))) * Math_fround(.5)));
 HEAPF32[i11 + 1404 >> 2] = Math_fround(Math_fround(f19 * Math_fround(0.0)) + Math_fround(Math_fround(+HEAPF64[i11 + 1408 >> 3]) * Math_fround(Math_fround(1.0) - f19)));
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i11 = i11 + 1404 | 0;
 f19 = Math_fround(HEAPF32[i11 >> 2]);
 i10 = f19 < Math_fround(1.0);
 i14 = i10 ? i11 : i14;
 f19 = Math_fround(HEAPF32[i14 >> 2]);
 i10 = f19 > Math_fround(0.0);
 i14 = i10 ? i14 : i13;
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i14;
 STACKTOP = i15;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 2208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 2144 | 0;
 i13 = i15 + 1072 | 0;
 i11 = i15;
 i14 = i15 + 2192 | 0;
 i12 = i15 + 2176 | 0;
 i8 = i15 + 2160 | 0;
 i2 = i10 + 16 | 0;
 i7 = i2 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i10 + 20 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i4 = i10 + 96 | 0;
  i6 = i4;
  if ((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i6 + 4 >> 2] | 0) == 0) {
   i1 = _time(0) | 0;
   HEAP32[i10 + 104 + 4 >> 2] = i1;
   i3 = HEAP16[gb + 1478660 >> 1] | 0;
   HEAP16[gb + 1478660 >> 1] = i3 + 1 << 16 >> 16;
   HEAP16[i10 + 112 >> 1] = i3;
   i1 = ___muldi3(i1 | 0, 0, 1e5, 0) | 0;
   i1 = _i64Add(i3 & 65535 | 0, 0, i1 | 0, getTempRet0() | 0) | 0;
   i3 = getTempRet0() | 0;
   i6 = i4;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 4 >> 2] = i3;
  }
  i1 = i10 + 52 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i10 + 56 >> 2] | 0;
  } else i3 = i3 & 255;
  i6 = i13;
  HEAP32[i6 >> 2] = 305419896;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = i11;
  HEAP32[i6 >> 2] = 305419896;
  HEAP32[i6 + 4 >> 2] = 0;
  __ZN10SpookyHash7Hash128EPKvjPyS2_(i1, i3, i13, i11);
  i6 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i5 + 8 >> 2] = i6;
  __Z6FormatPKcz(i13, gb + 1046934 | 0, i5);
  i6 = HEAP8[i13 + 11 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
  i6 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i7 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i10 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   if (i3) i1 = HEAP32[i10 + 20 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  } else {
   if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i10 + 20 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 }
 i1 = HEAP8[i10 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
 } else {
  i3 = i10;
  i1 = i1 & 255;
 };
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i3, i1);
 i1 = HEAP8[i7 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i10 + 20 >> 2] | 0;
 } else i1 = i1 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, i1);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i12, i8);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  i9 = 35;
 } else if (i4 >>> 0 < 11) {
  i2 = i14 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i14; else {
   i1 = i14;
   i9 = 37;
  }
 } else i9 = 35;
 if ((i9 | 0) == 35) {
  i2 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i4;
  i2 = i14 + 11 | 0;
  i9 = 37;
 }
 if ((i9 | 0) == 37) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 if (__Z28CreateAsDirectoryIfNotExistsPKc((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14) | 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = i11 + 11 | 0;
  HEAP8[i1 >> 0] = 1;
  HEAP8[i11 >> 0] = 101;
  HEAP8[i11 + 1 >> 0] = 0;
  __ZN12FileAccessorC2Ev(i13);
  if (__ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i14, i11, i13) | 0) {
   i7 = __ZN11UnityEngine15CloudWebService17SessionEventQueue10SaveToFileER12FileAccessor(i10 + 68 | 0, i13) | 0;
   __ZN12FileAccessor5CloseEv(i13) | 0;
  } else i7 = 0;
  __ZN12FileAccessorD2Ev(i13);
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i9 = HEAP32[i11 >> 2] | 0;
   i8 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
  };
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i6 = i12 + 11 | 0;
  HEAP8[i6 >> 0] = 1;
  HEAP8[i12 >> 0] = 115;
  HEAP8[i12 + 1 >> 0] = 0;
  i3 = i10 + 52 | 0;
  __ZN12FileAccessorC2Ev(i11);
  if (__ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i14, i12, i11) | 0) {
   i1 = i13;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = HEAP8[i3 + 11 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) {
    i4 = HEAP32[i10 + 56 >> 2] | 0;
    i5 = 0;
    i1 = HEAP32[i3 >> 2] | 0;
   } else {
    i4 = i1 & 255;
    i5 = 0;
    i1 = i3;
   }
   i1 = __ZN12FileAccessor5WriteEyPKvPy(i11, i4, i5, i1, i13) | 0;
   __ZN12FileAccessor5CloseEv(i11) | 0;
  } else i1 = 0;
  __ZN12FileAccessorD2Ev(i11);
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   i9 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
  };
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i12 = i11 + 11 | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP8[i11 >> 0] = 103;
  HEAP8[i11 + 1 >> 0] = 0;
  __ZN11UnityEngine15CloudWebService16SessionContainer16ArchiveGroupDataERK8UnityStrS4_(i10, i14, i11) | 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   i12 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
  }
  if (i7 | i1) {
   HEAP8[i10 + 89 >> 0] = 0;
   i1 = 1;
  } else i1 = 0;
 } else i1 = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i15;
  return i1 | 0;
 }
 i12 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 66;
 HEAP32[i13 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN5physx14PxRigidBodyExt17linearSweepSingleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEERNS_10PxSweepHitERjRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf(i59, i70, i73, f62, i68, i61, i72, i65, i64, i60, f67) {
 i59 = i59 | 0;
 i70 = i70 | 0;
 i73 = i73 | 0;
 f62 = Math_fround(f62);
 i68 = i68 | 0;
 i61 = i61 | 0;
 i72 = i72 | 0;
 i65 = i65 | 0;
 i64 = i64 | 0;
 i60 = i60 | 0;
 f67 = Math_fround(f67);
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i63 = 0, i66 = 0, i69 = 0, i71 = 0, i74 = 0, f75 = f0, f76 = f0, f77 = f0, f78 = f0, f79 = f0, f80 = f0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, i88 = 0;
 i74 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i74 + 136 | 0;
 i4 = i74 + 68 | 0;
 i71 = i74 + 64 | 0;
 i69 = i74 + 36 | 0;
 i63 = i74 + 16 | 0;
 i15 = i74;
 i26 = i74 + 176 | 0;
 HEAP32[i72 >> 2] = -1;
 i57 = mftCall_ii(HEAP32[(HEAP32[i59 >> 2] | 0) + 104 >> 2] | 0, i59 | 0) | 0;
 if (!i57) {
  i73 = HEAP32[i72 >> 2] | 0;
  i73 = (i73 | 0) != -1;
  STACKTOP = i74;
  return i73 | 0;
 }
 i58 = i4 + 16 | 0;
 i5 = i4 + 20 | 0;
 i6 = i4 + 24 | 0;
 i7 = i3 + 12 | 0;
 i8 = i3 + 4 | 0;
 i9 = i3 + 8 | 0;
 i10 = i3 + 16 | 0;
 i11 = i3 + 20 | 0;
 i12 = i3 + 24 | 0;
 i13 = i4 + 12 | 0;
 i14 = i4 + 8 | 0;
 i16 = i4 + 4 | 0;
 i17 = i69 + 4 | 0;
 i18 = i69 + 8 | 0;
 i19 = i69 + 12 | 0;
 i20 = i69 + 16 | 0;
 i21 = i69 + 20 | 0;
 i22 = i69 + 24 | 0;
 i23 = i63 + 16 | 0;
 i24 = i63 + 18 | 0;
 i25 = i65 + 16 | 0;
 i27 = i65 + 4 | 0;
 i28 = i65 + 8 | 0;
 i29 = i65 + 12 | 0;
 i30 = i4 + 4 | 0;
 i31 = i4 + 8 | 0;
 i32 = i4 + 12 | 0;
 i33 = i4 + 16 | 0;
 i34 = i4 + 20 | 0;
 i35 = i4 + 44 | 0;
 i36 = i4 + 52 | 0;
 i37 = i4 + 56 | 0;
 i38 = i4 + 60 | 0;
 i39 = i4 + 64 | 0;
 i40 = i4 + 4 | 0;
 i41 = i61 + 12 | 0;
 i42 = i61 + 16 | 0;
 i43 = i4 + 20 | 0;
 i44 = i4 + 24 | 0;
 i45 = i61 + 20 | 0;
 i46 = i4 + 28 | 0;
 i47 = i61 + 24 | 0;
 i48 = i61 + 28 | 0;
 i49 = i4 + 32 | 0;
 i50 = i4 + 36 | 0;
 i51 = i61 + 32 | 0;
 i52 = i4 + 40 | 0;
 i53 = i61 + 36 | 0;
 i54 = i61 + 40 | 0;
 i55 = i4 + 48 | 0;
 i56 = i61 + 44 | 0;
 f2 = f62;
 i66 = 0;
 while (1) {
  HEAP32[i71 >> 2] = 0;
  mftCall_iiiii(HEAP32[(HEAP32[i59 >> 2] | 0) + 108 >> 2] | 0, i59 | 0, i71 | 0, 1, i66 | 0) | 0;
  i88 = HEAP32[i71 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i59 >> 2] | 0) + 84 >> 2] | 0, i3 | 0, i59 | 0);
  mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 72 >> 2] | 0, i4 | 0, i88 | 0);
  f84 = Math_fround(Math_fround(HEAPF32[i58 >> 2]) * Math_fround(2.0));
  f82 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
  f77 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(2.0));
  f87 = Math_fround(HEAPF32[i7 >> 2]);
  f86 = Math_fround(Math_fround(f87 * f87) + Math_fround(-.5));
  f85 = Math_fround(HEAPF32[i3 >> 2]);
  f1 = Math_fround(f84 * f85);
  f83 = Math_fround(HEAPF32[i8 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f82 * f83));
  f81 = Math_fround(HEAPF32[i9 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f77 * f81));
  f76 = Math_fround(Math_fround(f85 * f1) + Math_fround(Math_fround(f84 * f86) + Math_fround(f87 * Math_fround(Math_fround(f77 * f83) - Math_fround(f82 * f81)))));
  f75 = Math_fround(Math_fround(f83 * f1) + Math_fround(Math_fround(f82 * f86) + Math_fround(f87 * Math_fround(Math_fround(f84 * f81) - Math_fround(f77 * f85)))));
  f1 = Math_fround(Math_fround(Math_fround(f77 * f86) + Math_fround(f87 * Math_fround(Math_fround(f82 * f85) - Math_fround(f84 * f83)))) + Math_fround(f81 * f1));
  f76 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f76);
  f75 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f75);
  f1 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f1);
  f84 = Math_fround(HEAPF32[i4 >> 2]);
  f82 = Math_fround(f87 * f84);
  f86 = Math_fround(HEAPF32[i13 >> 2]);
  f82 = Math_fround(f82 + Math_fround(f85 * f86));
  f77 = Math_fround(HEAPF32[i14 >> 2]);
  f82 = Math_fround(f82 + Math_fround(f83 * f77));
  f80 = Math_fround(HEAPF32[i16 >> 2]);
  f79 = Math_fround(Math_fround(Math_fround(f81 * f84) + Math_fround(Math_fround(f83 * f86) + Math_fround(f87 * f80))) - Math_fround(f85 * f77));
  f78 = Math_fround(Math_fround(Math_fround(f85 * f80) + Math_fround(Math_fround(f81 * f86) + Math_fround(f87 * f77))) - Math_fround(f83 * f84));
  f77 = Math_fround(Math_fround(Math_fround(Math_fround(f87 * f86) - Math_fround(f85 * f84)) - Math_fround(f83 * f80)) - Math_fround(f81 * f77));
  HEAPF32[i69 >> 2] = Math_fround(f82 - Math_fround(f81 * f80));
  HEAPF32[i17 >> 2] = f79;
  HEAPF32[i18 >> 2] = f78;
  HEAPF32[i19 >> 2] = f77;
  HEAPF32[i20 >> 2] = f76;
  HEAPF32[i21 >> 2] = f75;
  HEAPF32[i22 >> 2] = f1;
  HEAP32[i63 >> 2] = 0;
  HEAP32[i63 + 4 >> 2] = 0;
  HEAP32[i63 + 8 >> 2] = 0;
  HEAP32[i63 + 12 >> 2] = 0;
  HEAP8[i24 >> 0] = 0;
  HEAP16[i23 >> 1] = HEAP16[i25 >> 1] | 0;
  if (!(HEAP32[i27 >> 2] | HEAP32[i65 >> 2] | HEAP32[i28 >> 2] | HEAP32[i29 >> 2])) {
   i88 = HEAP32[i71 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 92 >> 2] | 0, i15 | 0, i88 | 0);
  } else {
   HEAP32[i15 >> 2] = HEAP32[i65 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i65 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i65 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i65 + 12 >> 2];
  };
  HEAP32[i63 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i63 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i63 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i63 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i88 = HEAP32[i71 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i88 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i88 | 0);
  HEAP32[i30 >> 2] = 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i32 >> 2] = -1;
  HEAP16[i33 >> 1] = 0;
  HEAP32[i34 >> 2] = 0;
  HEAP32[i34 + 4 >> 2] = 0;
  HEAP32[i34 + 8 >> 2] = 0;
  HEAP32[i34 + 12 >> 2] = 0;
  HEAP32[i34 + 16 >> 2] = 0;
  HEAP32[i34 + 20 >> 2] = 0;
  HEAPF32[i35 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP8[i36 >> 0] = 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i39 >> 2] = 0;
  HEAP32[i4 >> 2] = gb + 93084 + 8;
  i88 = HEAP32[(HEAP32[i70 >> 2] | 0) + 352 >> 2] | 0;
  HEAP16[i26 >> 1] = HEAP16[i68 >> 1] | 0;
  mftCall_iiiiifiiiiif(i88 | 0, i70 | 0, i3 | 0, i69 | 0, i73 | 0, +f62, i4 | 0, i26 | 0, i63 | 0, i64 | 0, i60 | 0, +f67) | 0;
  if (!(HEAP8[i36 >> 0] | 0)) f1 = f2; else {
   f1 = Math_fround(HEAPF32[i35 >> 2]);
   if (f1 < f2) {
    HEAP32[i61 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i61 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i61 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP16[i41 >> 1] = HEAP16[i33 >> 1] | 0;
    HEAP32[i42 >> 2] = HEAP32[i43 >> 2];
    HEAP32[i45 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i47 >> 2] = HEAP32[i46 >> 2];
    HEAP32[i48 >> 2] = HEAP32[i49 >> 2];
    HEAP32[i51 >> 2] = HEAP32[i50 >> 2];
    HEAP32[i53 >> 2] = HEAP32[i52 >> 2];
    HEAPF32[i54 >> 2] = f1;
    HEAP32[i56 >> 2] = HEAP32[i55 >> 2];
    HEAP32[i72 >> 2] = i66;
   } else f1 = f2;
  }
  i66 = i66 + 1 | 0;
  if ((i66 | 0) == (i57 | 0)) break; else f2 = f1;
 }
 i88 = HEAP32[i72 >> 2] | 0;
 i88 = (i88 | 0) != -1;
 STACKTOP = i74;
 return i88 | 0;
}

function __ZN10GISettings8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i11 + 4 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402298 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402312 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402334 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402348 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402377 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 20 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402403 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 21 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402426 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i7 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i10 >> 0] = 1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402452 | 0, i4, i8, 0) | 0;
 if (!i1) i1 = 0; else {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i8 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i10 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
  i1 = HEAP8[i10 >> 0] ^ 1;
 }
 HEAP32[i5 >> 2] = i1 & 255;
 STACKTOP = i11;
 return;
}

function __ZN9Texture2D13AwakeFromLoadE17AwakeFromLoadMode(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 24 | 0;
 i11 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i14 = i18 + 16 | 0;
 i15 = i18;
 i17 = __Z20push_allocation_rootPvP13BaseAllocatorb(i16, 0, 0) | 0;
 do if (!(i1 & 32)) {
  i1 = HEAP8[i16 + 128 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i16 + 132 >> 2] | 0; else i1 = i1 & 255;
  if (!i1) {
   if (!(HEAP32[i16 + 52 >> 2] | 0)) break;
   if ((HEAP16[gb + 1158380 + 6 >> 1] | 0) > -1) {
    HEAP32[i11 >> 2] = i16;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158380 | 0, i12);
    i1 = gb + 1158380 | 0;
   } else i1 = 0;
   mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 172 >> 2] | 0, i16 | 0);
   if (!i1) break;
   __Z12profiler_endP19ProfilerInformation(i1);
   break;
  }
  i1 = HEAP32[i16 + 56 >> 2] | 0;
  i10 = i16 + 52 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((HEAP32[i2 + 28 >> 2] | 0) == (HEAP32[i16 + 96 >> 2] | 0)) if ((HEAP32[i2 + 32 >> 2] | 0) == (HEAP32[i16 + 100 >> 2] | 0)) {
   i5 = HEAP32[i16 + 48 >> 2] | 0;
   i6 = i16;
   i7 = HEAP32[gb + 1158372 >> 2] | 0;
   i2 = i7 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   do if (!i1) {
    HEAP32[i12 >> 2] = i2;
    i4 = i2;
    i3 = i2;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i9 = 41;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i9 = 46;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i9 = 45;
       break;
      } else i1 = i2;
     }
    }
    if ((i9 | 0) == 41) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i9 | 0) == 45) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i9 | 0) == 46) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i12;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(24) | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i2 + 4 >> 2] = i6;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i7 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
    i8 = i7 + 8 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
  } else i9 = 8; else i9 = 8;
  if ((i9 | 0) == 8) {
   i6 = (i1 | 0) == 6;
   i5 = HEAP32[i16 + 48 >> 2] | 0;
   i8 = i16;
   i7 = HEAP32[gb + 1158372 >> 2] | 0;
   i2 = i7 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   do if (!i1) {
    HEAP32[i12 >> 2] = i2;
    i4 = i2;
    i3 = i2;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i9 = 11;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i9 = 16;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i9 = 15;
       break;
      } else i1 = i2;
     }
    }
    if ((i9 | 0) == 11) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i9 | 0) == 15) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i9 | 0) == 16) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i12;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(24) | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i7 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
    i9 = i7 + 8 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   }
   if (!i6) {
    i5 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 96 >> 2] | 0, i16 | 0) | 0;
    i6 = HEAP32[gb + 1158372 >> 2] | 0;
    i2 = i6 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    do if (!i1) {
     HEAP32[i12 >> 2] = i2;
     i4 = i2;
     i3 = i2;
    } else {
     while (1) {
      i2 = HEAP32[i1 + 16 >> 2] | 0;
      if (i5 >>> 0 < i2 >>> 0) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i9 = 26;
        break;
       } else i1 = i2;
      } else {
       if (i2 >>> 0 >= i5 >>> 0) {
        i9 = 31;
        break;
       }
       i3 = i1 + 4 | 0;
       i2 = HEAP32[i3 >> 2] | 0;
       if (!i2) {
        i9 = 30;
        break;
       } else i1 = i2;
      }
     }
     if ((i9 | 0) == 26) {
      HEAP32[i12 >> 2] = i1;
      i4 = i1;
      i3 = i1;
      break;
     } else if ((i9 | 0) == 30) {
      HEAP32[i12 >> 2] = i1;
      i4 = i1;
      break;
     } else if ((i9 | 0) == 31) {
      HEAP32[i12 >> 2] = i1;
      i4 = i1;
      i3 = i12;
      break;
     }
    } while (0);
    if (!(HEAP32[i3 >> 2] | 0)) {
     i1 = __Znwj(24) | 0;
     i2 = i1 + 16 | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i2 + 4 >> 2] = i8;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = i4;
     HEAP32[i3 >> 2] = i1;
     i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     if (i2) {
      HEAP32[i6 >> 2] = i2;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
     i9 = i6 + 8 | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    }
   }
  }
  i1 = i16 + 144 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411189 | 0, 0, gb + 410682 | 0, 294, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0); else {
   i9 = __Z21GetAsyncUploadManagerv() | 0;
   i6 = i1;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i8 = i13;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = i7;
   HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   if (!(__ZN18AsyncUploadManager12HasCompletedE10AsyncFence(i9, i12) | 0)) {
    i13 = __Z12GetGfxDevicev() | 0;
    i9 = HEAP32[(HEAP32[i13 >> 2] | 0) + 876 >> 2] | 0;
    HEAP32[i14 >> 2] = HEAP32[i16 + 48 >> 2];
    i7 = i1;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i16 = i15;
    HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i16 + 4 >> 2] = i8;
    i16 = __Z18GetQualitySettingsv() | 0;
    i16 = HEAP32[(HEAP32[i16 + 28 >> 2] | 0) + ((HEAP32[i16 + 44 >> 2] | 0) * 108 | 0) + 104 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    mftCall_viiii(i9 | 0, i13 | 0, i11 | 0, i12 | 0, i16 | 0);
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i16 = i1 + 4 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   if (!(HEAP32[i16 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
   }
   HEAP32[i10 >> 2] = 0;
  }
 } while (0);
 if (!i17) {
  STACKTOP = i18;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i18;
 return;
}

function runPostSets213() {
 HEAP32[gb + 179116 >> 2] = fb + 455;
 HEAP32[gb + 179120 >> 2] = fb + 456;
 HEAP32[gb + 179132 >> 2] = fb + 457;
 HEAP32[gb + 179136 >> 2] = fb + 458;
 HEAP32[gb + 179140 >> 2] = (HEAP32[gb + 179140 >> 2] | 0) + (gb + 908429 | 0);
 HEAP32[gb + 179144 >> 2] = (HEAP32[gb + 179144 >> 2] | 0) + (gb + 908438 | 0);
 HEAP32[gb + 179148 >> 2] = (HEAP32[gb + 179148 >> 2] | 0) + (gb + 908451 | 0);
 HEAP32[gb + 179152 >> 2] = (HEAP32[gb + 179152 >> 2] | 0) + (gb + 908458 | 0);
 HEAP32[gb + 179156 >> 2] = (HEAP32[gb + 179156 >> 2] | 0) + (gb + 908464 | 0);
 HEAP32[gb + 179160 >> 2] = (HEAP32[gb + 179160 >> 2] | 0) + (gb + 908470 | 0);
 HEAP32[gb + 179164 >> 2] = (HEAP32[gb + 179164 >> 2] | 0) + (gb + 908477 | 0);
 HEAP32[gb + 179168 >> 2] = (HEAP32[gb + 179168 >> 2] | 0) + (gb + 908482 | 0);
 HEAP32[gb + 179172 >> 2] = (HEAP32[gb + 179172 >> 2] | 0) + (gb + 908489 | 0);
 HEAP32[gb + 179176 >> 2] = (HEAP32[gb + 179176 >> 2] | 0) + (gb + 908494 | 0);
 HEAP32[gb + 179180 >> 2] = (HEAP32[gb + 179180 >> 2] | 0) + (gb + 908507 | 0);
 HEAP32[gb + 179184 >> 2] = (HEAP32[gb + 179184 >> 2] | 0) + (gb + 908521 | 0);
 HEAP32[gb + 179188 >> 2] = (HEAP32[gb + 179188 >> 2] | 0) + (gb + 908534 | 0);
 HEAP32[gb + 179192 >> 2] = (HEAP32[gb + 179192 >> 2] | 0) + (gb + 908548 | 0);
 HEAP32[gb + 179196 >> 2] = (HEAP32[gb + 179196 >> 2] | 0) + (gb + 908557 | 0);
 HEAP32[gb + 179200 >> 2] = (HEAP32[gb + 179200 >> 2] | 0) + (gb + 908567 | 0);
 HEAP32[gb + 179204 >> 2] = (HEAP32[gb + 179204 >> 2] | 0) + (gb + 908573 | 0);
 HEAP32[gb + 179208 >> 2] = (HEAP32[gb + 179208 >> 2] | 0) + (gb + 908579 | 0);
 HEAP32[gb + 179212 >> 2] = (HEAP32[gb + 179212 >> 2] | 0) + (gb + 908584 | 0);
 HEAP32[gb + 179216 >> 2] = (HEAP32[gb + 179216 >> 2] | 0) + (gb + 908589 | 0);
 HEAP32[gb + 179220 >> 2] = (HEAP32[gb + 179220 >> 2] | 0) + (gb + 908602 | 0);
 HEAP32[gb + 179224 >> 2] = (HEAP32[gb + 179224 >> 2] | 0) + (gb + 908616 | 0);
 HEAP32[gb + 179228 >> 2] = (HEAP32[gb + 179228 >> 2] | 0) + (gb + 908629 | 0);
 HEAP32[gb + 179232 >> 2] = (HEAP32[gb + 179232 >> 2] | 0) + (gb + 908643 | 0);
 HEAP32[gb + 179236 >> 2] = (HEAP32[gb + 179236 >> 2] | 0) + (gb + 908656 | 0);
 HEAP32[gb + 179240 >> 2] = (HEAP32[gb + 179240 >> 2] | 0) + (gb + 908670 | 0);
 HEAP32[gb + 179244 >> 2] = (HEAP32[gb + 179244 >> 2] | 0) + (gb + 908679 | 0);
 HEAP32[gb + 179248 >> 2] = (HEAP32[gb + 179248 >> 2] | 0) + (gb + 908689 | 0);
 HEAP32[gb + 179252 >> 2] = (HEAP32[gb + 179252 >> 2] | 0) + (gb + 908698 | 0);
 HEAP32[gb + 179256 >> 2] = (HEAP32[gb + 179256 >> 2] | 0) + (gb + 908708 | 0);
 HEAP32[gb + 179260 >> 2] = (HEAP32[gb + 179260 >> 2] | 0) + (gb + 908716 | 0);
 HEAP32[gb + 179264 >> 2] = (HEAP32[gb + 179264 >> 2] | 0) + (gb + 908725 | 0);
 HEAP32[gb + 179268 >> 2] = (HEAP32[gb + 179268 >> 2] | 0) + (gb + 908729 | 0);
 HEAP32[gb + 179272 >> 2] = (HEAP32[gb + 179272 >> 2] | 0) + (gb + 908741 | 0);
 HEAP32[gb + 179276 >> 2] = (HEAP32[gb + 179276 >> 2] | 0) + (gb + 908748 | 0);
 HEAP32[gb + 179280 >> 2] = (HEAP32[gb + 179280 >> 2] | 0) + (gb + 908760 | 0);
 HEAP32[gb + 179284 >> 2] = (HEAP32[gb + 179284 >> 2] | 0) + (gb + 908772 | 0);
 HEAP32[gb + 179288 >> 2] = (HEAP32[gb + 179288 >> 2] | 0) + (gb + 908789 | 0);
 HEAP32[gb + 179292 >> 2] = (HEAP32[gb + 179292 >> 2] | 0) + (gb + 908806 | 0);
 HEAP32[gb + 179296 >> 2] = (HEAP32[gb + 179296 >> 2] | 0) + (gb + 908829 | 0);
 HEAP32[gb + 179300 >> 2] = (HEAP32[gb + 179300 >> 2] | 0) + (gb + 908846 | 0);
 HEAP32[gb + 179304 >> 2] = (HEAP32[gb + 179304 >> 2] | 0) + (gb + 908863 | 0);
 HEAP32[gb + 179308 >> 2] = (HEAP32[gb + 179308 >> 2] | 0) + (gb + 908886 | 0);
 HEAP32[gb + 179312 >> 2] = (HEAP32[gb + 179312 >> 2] | 0) + (gb + 908903 | 0);
 HEAP32[gb + 179316 >> 2] = (HEAP32[gb + 179316 >> 2] | 0) + (gb + 908924 | 0);
 HEAP32[gb + 179320 >> 2] = (HEAP32[gb + 179320 >> 2] | 0) + (gb + 908945 | 0);
 HEAP32[gb + 179324 >> 2] = (HEAP32[gb + 179324 >> 2] | 0) + (gb + 908962 | 0);
 HEAP32[gb + 179328 >> 2] = (HEAP32[gb + 179328 >> 2] | 0) + (gb + 908983 | 0);
 HEAP32[gb + 179332 >> 2] = (HEAP32[gb + 179332 >> 2] | 0) + (gb + 909004 | 0);
 HEAP32[gb + 179336 >> 2] = (HEAP32[gb + 179336 >> 2] | 0) + (gb + 909021 | 0);
 HEAP32[gb + 179340 >> 2] = (HEAP32[gb + 179340 >> 2] | 0) + (gb + 909037 | 0);
 HEAP32[gb + 179344 >> 2] = (HEAP32[gb + 179344 >> 2] | 0) + (gb + 909055 | 0);
 HEAP32[gb + 179348 >> 2] = (HEAP32[gb + 179348 >> 2] | 0) + (gb + 909072 | 0);
 HEAP32[gb + 179352 >> 2] = (HEAP32[gb + 179352 >> 2] | 0) + (gb + 909082 | 0);
 HEAP32[gb + 179356 >> 2] = (HEAP32[gb + 179356 >> 2] | 0) + (gb + 909097 | 0);
 HEAP32[gb + 179360 >> 2] = (HEAP32[gb + 179360 >> 2] | 0) + (gb + 909123 | 0);
 HEAP32[gb + 179364 >> 2] = (HEAP32[gb + 179364 >> 2] | 0) + (gb + 909145 | 0);
 HEAP32[gb + 179368 >> 2] = (HEAP32[gb + 179368 >> 2] | 0) + (gb + 909173 | 0);
 HEAP32[gb + 179372 >> 2] = (HEAP32[gb + 179372 >> 2] | 0) + (gb + 909196 | 0);
 HEAP32[gb + 179376 >> 2] = (HEAP32[gb + 179376 >> 2] | 0) + (gb + 909224 | 0);
 HEAP32[gb + 179380 >> 2] = (HEAP32[gb + 179380 >> 2] | 0) + (gb + 909242 | 0);
 HEAP32[gb + 179384 >> 2] = (HEAP32[gb + 179384 >> 2] | 0) + (gb + 909265 | 0);
 HEAP32[gb + 179388 >> 2] = (HEAP32[gb + 179388 >> 2] | 0) + (gb + 909283 | 0);
 HEAP32[gb + 179392 >> 2] = (HEAP32[gb + 179392 >> 2] | 0) + (gb + 909310 | 0);
 HEAP32[gb + 179396 >> 2] = (HEAP32[gb + 179396 >> 2] | 0) + (gb + 909333 | 0);
 HEAP32[gb + 179400 >> 2] = (HEAP32[gb + 179400 >> 2] | 0) + (gb + 909362 | 0);
 HEAP32[gb + 179404 >> 2] = (HEAP32[gb + 179404 >> 2] | 0) + (gb + 909386 | 0);
 HEAP32[gb + 179408 >> 2] = (HEAP32[gb + 179408 >> 2] | 0) + (gb + 909415 | 0);
 HEAP32[gb + 179412 >> 2] = (HEAP32[gb + 179412 >> 2] | 0) + (gb + 909434 | 0);
 HEAP32[gb + 179416 >> 2] = (HEAP32[gb + 179416 >> 2] | 0) + (gb + 909458 | 0);
 HEAP32[gb + 179420 >> 2] = (HEAP32[gb + 179420 >> 2] | 0) + (gb + 909477 | 0);
 HEAP32[gb + 179424 >> 2] = (HEAP32[gb + 179424 >> 2] | 0) + (gb + 909499 | 0);
 HEAP32[gb + 179428 >> 2] = (HEAP32[gb + 179428 >> 2] | 0) + (gb + 909524 | 0);
 HEAP32[gb + 179432 >> 2] = (HEAP32[gb + 179432 >> 2] | 0) + (gb + 909541 | 0);
 HEAP32[gb + 179436 >> 2] = (HEAP32[gb + 179436 >> 2] | 0) + (gb + 909561 | 0);
 HEAP32[gb + 179440 >> 2] = (HEAP32[gb + 179440 >> 2] | 0) + (gb + 909583 | 0);
 HEAP32[gb + 179444 >> 2] = (HEAP32[gb + 179444 >> 2] | 0) + (gb + 909604 | 0);
 HEAP32[gb + 179448 >> 2] = (HEAP32[gb + 179448 >> 2] | 0) + (gb + 909630 | 0);
 HEAP32[gb + 179452 >> 2] = (HEAP32[gb + 179452 >> 2] | 0) + (gb + 909648 | 0);
 HEAP32[gb + 179456 >> 2] = (HEAP32[gb + 179456 >> 2] | 0) + (gb + 909665 | 0);
 HEAP32[gb + 179460 >> 2] = (HEAP32[gb + 179460 >> 2] | 0) + (gb + 909688 | 0);
 HEAP32[gb + 179464 >> 2] = (HEAP32[gb + 179464 >> 2] | 0) + (gb + 909714 | 0);
 HEAP32[gb + 179468 >> 2] = (HEAP32[gb + 179468 >> 2] | 0) + (gb + 909732 | 0);
 HEAP32[gb + 179472 >> 2] = (HEAP32[gb + 179472 >> 2] | 0) + (gb + 909753 | 0);
 HEAP32[gb + 179476 >> 2] = (HEAP32[gb + 179476 >> 2] | 0) + (gb + 909776 | 0);
 HEAP32[gb + 179480 >> 2] = (HEAP32[gb + 179480 >> 2] | 0) + (gb + 909798 | 0);
 HEAP32[gb + 179484 >> 2] = (HEAP32[gb + 179484 >> 2] | 0) + (gb + 909825 | 0);
 HEAP32[gb + 179488 >> 2] = (HEAP32[gb + 179488 >> 2] | 0) + (gb + 909844 | 0);
 HEAP32[gb + 184132 >> 2] = fb + 136;
 HEAP32[gb + 184136 >> 2] = fb + 2785;
 HEAP32[gb + 184140 >> 2] = fb + 278;
 HEAP32[gb + 184144 >> 2] = fb + 102;
 HEAP32[gb + 184148 >> 2] = fb + 103;
 HEAP32[gb + 184152 >> 2] = fb + 104;
 HEAP32[gb + 184156 >> 2] = fb + 119;
 HEAP32[gb + 184160 >> 2] = fb + 120;
 runPostSets214();
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj(i38, i1, i5) {
 i38 = i38 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i43;
 i40 = i43 + 56 | 0;
 i41 = i38 + 192 | 0;
 if (HEAP8[i41 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv(i38);
 i42 = i38 + 176 | 0;
 i4 = HEAP32[i42 >> 2] | 0;
 i39 = i38 + 180 | 0;
 i2 = HEAP32[i39 >> 2] | 0;
 if (i4 >>> 0 > i5 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i38 + 188 >> 2] | 0) >>> 0) {
  STACKTOP = i43;
  return;
 }
 i2 = i2 + i1 | 0;
 f3 = Math_fround(i2 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i43;
  return;
 }
 i7 = i38 + 4 | 0;
 f3 = Math_fround((i2 - (HEAP32[i7 >> 2] | 0) | 0) >>> 0);
 i6 = 32;
 while (1) {
  if (i6 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i6 >>> 0) * Math_fround(.5)))) break;
  i6 = i6 << 1;
 }
 i1 = i40 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i40 + 8 | 0;
 i4 = i38 + 8 | 0;
 i8 = HEAP16[i4 >> 1] | 0;
 HEAP8[i2 >> 0] = i8;
 i5 = i40 + 9 | 0;
 HEAP8[i5 >> 0] = (i8 & 65535) >>> 8;
 i8 = i40 + 12 | 0;
 i9 = i38 + 12 | 0;
 i28 = i9;
 i11 = HEAP32[i28 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 i10 = i40 + 20 | 0;
 i11 = i38 + 20 | 0;
 i28 = i10;
 i29 = i11;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i12 = i40 + 76 | 0;
 i13 = i38 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 i14 = i40 + 80 | 0;
 i15 = i38 + 80 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 i16 = i40 + 84 | 0;
 i17 = i38 + 84 | 0;
 i28 = i17;
 i19 = HEAP32[i28 + 4 >> 2] | 0;
 i18 = i16;
 HEAP32[i18 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 i18 = i40 + 92 | 0;
 i19 = i38 + 92 | 0;
 i28 = i19;
 i21 = HEAP32[i28 + 4 >> 2] | 0;
 i20 = i18;
 HEAP32[i20 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 i20 = i40 + 100 | 0;
 i21 = i38 + 100 | 0;
 i28 = i20;
 i29 = i21;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i22 = i40 + 156 | 0;
 i23 = i38 + 156 | 0;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 i24 = i40 + 160 | 0;
 i25 = i38 + 160 | 0;
 HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
 i26 = i40 + 164 | 0;
 i27 = i38 + 164 | 0;
 i33 = i27;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i31 = i26;
 HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i31 + 4 >> 2] = i32;
 i31 = i40 + 172 | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i40 + 176 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i40 + 180 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i40 + 196 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i34 = i40 + 188 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i40 + 184 | 0;
 HEAP32[i35 >> 2] = 0;
 i36 = i40 + 192 | 0;
 HEAP8[i36 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i40, i38, i6);
 i28 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i28;
 i1 = HEAP8[i4 >> 0] | 0;
 i28 = HEAP16[i2 >> 1] | 0;
 HEAP8[i4 >> 0] = i28;
 HEAP8[i2 >> 0] = i1;
 i1 = i38 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i28 & 65535) >>> 8;
 HEAP8[i5 >> 0] = i2;
 i2 = i9;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i37;
 i29 = i11;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i7 = i17;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i30 = i8;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i9;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i11;
 i29 = i10;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 i30 = i16;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i17;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i8;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = i2;
 i28 = i10;
 i29 = i37;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i12 >> 2] = i4;
 HEAP32[i14 >> 2] = i5;
 i2 = i16;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i19;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i37;
 i29 = i21;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i4 = HEAP32[i23 >> 2] | 0;
 i5 = HEAP32[i25 >> 2] | 0;
 i7 = i27;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i30 = i18;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i19;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i21;
 i29 = i20;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
 i30 = i26;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i27;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i18;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = i2;
 i28 = i20;
 i29 = i37;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i22 >> 2] = i4;
 HEAP32[i24 >> 2] = i5;
 i30 = i26;
 HEAP32[i30 >> 2] = i6;
 HEAP32[i30 + 4 >> 2] = i7;
 i30 = i38 + 172 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i31 >> 2] = i1;
 i31 = HEAP32[i42 >> 2] | 0;
 i30 = HEAP32[i32 >> 2] | 0;
 HEAP32[i42 >> 2] = i30;
 HEAP32[i32 >> 2] = i31;
 i42 = HEAP32[i39 >> 2] | 0;
 HEAP32[i39 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i33 >> 2] = i42;
 f3 = Math_fround(i30 >>> 0);
 HEAP32[i38 + 188 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i38 + 184 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i41 >> 0] = 0;
 f3 = Math_fround(i31 >>> 0);
 HEAP32[i34 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i35 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i36 >> 0] = 0;
 if (i1 | 0) {
  i42 = HEAP32[i40 + 196 >> 2] | 0;
  HEAP32[i37 >> 2] = 65;
  HEAP32[i37 + 4 >> 2] = i42;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i37);
 }
 STACKTOP = i43;
 return;
}

function __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i19, i16, i13, f17, i14, f18) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 f17 = Math_fround(f17);
 i14 = i14 | 0;
 f18 = Math_fround(f18);
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, f20 = f0, f21 = f0;
 i15 = i16 + 60 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) return;
 switch (HEAP32[i16 + 56 >> 2] | 0) {
 case 0:
  {
   HEAPF32[i19 >> 2] = Math_fround(1.0);
   i4 = i19 + 4 | 0;
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   f2 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f6 = Math_fround(HEAPF32[i16 + 48 >> 2]);
   f8 = Math_fround(f2 * f6);
   f1 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i16 + 52 >> 2]);
   f8 = Math_fround(Math_fround(f8 - Math_fround(f1 * f7)) + Math_fround(HEAPF32[i13 >> 2]));
   f7 = Math_fround(Math_fround(Math_fround(f6 * f1) + Math_fround(f2 * f7)) + Math_fround(HEAPF32[i13 + 4 >> 2]));
   f2 = Math_fround(HEAPF32[i14 + 12 >> 2]);
   f1 = Math_fround(HEAPF32[i16 >> 2]);
   f6 = Math_fround(f2 * f1);
   f3 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i16 + 4 >> 2]);
   f6 = Math_fround(Math_fround(f6 - Math_fround(f3 * f5)) + Math_fround(HEAPF32[i14 >> 2]));
   f5 = Math_fround(Math_fround(Math_fround(f1 * f3) + Math_fround(f2 * f5)) + Math_fround(HEAPF32[i14 + 4 >> 2]));
   f2 = Math_fround(f8 - f6);
   f3 = Math_fround(f7 - f5);
   if (Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) > Math_fround(1.42108547e-14)) {
    f2 = Math_fround(f6 - f8);
    f1 = Math_fround(f5 - f7);
    HEAPF32[i19 >> 2] = f2;
    HEAPF32[i4 >> 2] = f1;
    f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1))));
    if (!(f3 < Math_fround(1.1920929e-07))) {
     f3 = Math_fround(Math_fround(1.0) / f3);
     f2 = Math_fround(f2 * f3);
     HEAPF32[i19 >> 2] = f2;
     f1 = Math_fround(f1 * f3);
     HEAPF32[i4 >> 2] = f1;
    }
   } else {
    f2 = Math_fround(1.0);
    f1 = Math_fround(0.0);
   }
   f8 = Math_fround(f8 + Math_fround(f2 * f17));
   f17 = Math_fround(f7 + Math_fround(f1 * f17));
   f7 = Math_fround(f6 - Math_fround(f2 * f18));
   f18 = Math_fround(f5 - Math_fround(f1 * f18));
   f6 = Math_fround(Math_fround(f17 + f18) * Math_fround(.5));
   HEAPF32[i19 + 8 >> 2] = Math_fround(Math_fround(f8 + f7) * Math_fround(.5));
   HEAPF32[i19 + 12 >> 2] = f6;
   HEAPF32[i19 + 24 >> 2] = Math_fround(Math_fround(Math_fround(f7 - f8) * f2) + Math_fround(Math_fround(f18 - f17) * f1));
   return;
  }
 case 1:
  {
   i10 = i13 + 12 | 0;
   f8 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = Math_fround(HEAPF32[i16 + 40 >> 2]);
   f2 = Math_fround(f8 * f5);
   i11 = i13 + 8 | 0;
   f6 = Math_fround(HEAPF32[i11 >> 2]);
   f1 = Math_fround(HEAPF32[i16 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f6 * f1));
   f1 = Math_fround(Math_fround(f5 * f6) + Math_fround(f8 * f1));
   HEAPF32[i19 >> 2] = f2;
   i12 = i19 + 4 | 0;
   HEAPF32[i12 >> 2] = f1;
   f8 = Math_fround(HEAPF32[i10 >> 2]);
   f6 = Math_fround(HEAPF32[i16 + 48 >> 2]);
   f5 = Math_fround(f8 * f6);
   f7 = Math_fround(HEAPF32[i11 >> 2]);
   f3 = Math_fround(HEAPF32[i16 + 52 >> 2]);
   f5 = Math_fround(Math_fround(f5 - Math_fround(f7 * f3)) + Math_fround(HEAPF32[i13 >> 2]));
   f3 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f3)) + Math_fround(HEAPF32[i13 + 4 >> 2]));
   if ((HEAP32[i15 >> 2] | 0) <= 0) return;
   i9 = i14 + 12 | 0;
   i10 = i14 + 8 | 0;
   i11 = i14 + 4 | 0;
   i4 = 0;
   while (1) {
    f8 = Math_fround(HEAPF32[i9 >> 2]);
    f21 = Math_fround(HEAPF32[i16 + (i4 * 20 | 0) >> 2]);
    f20 = Math_fround(f8 * f21);
    f7 = Math_fround(HEAPF32[i10 >> 2]);
    f6 = Math_fround(HEAPF32[i16 + (i4 * 20 | 0) + 4 >> 2]);
    f20 = Math_fround(f20 - Math_fround(f7 * f6));
    f20 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f20);
    f6 = Math_fround(Math_fround(f21 * f7) + Math_fround(f8 * f6));
    f6 = Math_fround(f6 + Math_fround(HEAPF32[i11 >> 2]));
    f8 = Math_fround(f17 - Math_fround(Math_fround(f2 * Math_fround(f20 - f5)) + Math_fround(Math_fround(f6 - f3) * f1)));
    f7 = Math_fround(f20 + Math_fround(f2 * f8));
    f8 = Math_fround(f6 + Math_fround(f1 * f8));
    f2 = Math_fround(f20 - Math_fround(f2 * f18));
    f6 = Math_fround(f6 - Math_fround(f1 * f18));
    f1 = Math_fround(Math_fround(f6 + f8) * Math_fround(.5));
    HEAPF32[i19 + 8 + (i4 << 3) >> 2] = Math_fround(Math_fround(f2 + f7) * Math_fround(.5));
    HEAPF32[i19 + 8 + (i4 << 3) + 4 >> 2] = f1;
    f7 = Math_fround(f2 - f7);
    f8 = Math_fround(f6 - f8);
    f7 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f7);
    HEAPF32[i19 + 24 + (i4 << 2) >> 2] = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f8));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (HEAP32[i15 >> 2] | 0)) break;
    f2 = Math_fround(HEAPF32[i19 >> 2]);
    f1 = Math_fround(HEAPF32[i12 >> 2]);
   }
   return;
  }
 case 2:
  {
   i10 = i14 + 12 | 0;
   f21 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = Math_fround(HEAPF32[i16 + 40 >> 2]);
   f2 = Math_fround(f21 * f5);
   i11 = i14 + 8 | 0;
   f8 = Math_fround(HEAPF32[i11 >> 2]);
   f1 = Math_fround(HEAPF32[i16 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f8 * f1));
   f1 = Math_fround(Math_fround(f5 * f8) + Math_fround(f21 * f1));
   HEAPF32[i19 >> 2] = f2;
   i12 = i19 + 4 | 0;
   HEAPF32[i12 >> 2] = f1;
   f21 = Math_fround(HEAPF32[i10 >> 2]);
   f8 = Math_fround(HEAPF32[i16 + 48 >> 2]);
   f5 = Math_fround(f21 * f8);
   f20 = Math_fround(HEAPF32[i11 >> 2]);
   f3 = Math_fround(HEAPF32[i16 + 52 >> 2]);
   f5 = Math_fround(f5 - Math_fround(f20 * f3));
   f5 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f5);
   f3 = Math_fround(Math_fround(f8 * f20) + Math_fround(f21 * f3));
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i14 + 4 >> 2]));
   if ((HEAP32[i15 >> 2] | 0) > 0) {
    i9 = i13 + 12 | 0;
    i10 = i13 + 8 | 0;
    i11 = i13 + 4 | 0;
    i4 = 0;
    do {
     f21 = Math_fround(HEAPF32[i9 >> 2]);
     f6 = Math_fround(HEAPF32[i16 + (i4 * 20 | 0) >> 2]);
     f8 = Math_fround(f21 * f6);
     f20 = Math_fround(HEAPF32[i10 >> 2]);
     f7 = Math_fround(HEAPF32[i16 + (i4 * 20 | 0) + 4 >> 2]);
     f8 = Math_fround(f8 - Math_fround(f20 * f7));
     f8 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f8);
     f7 = Math_fround(Math_fround(f6 * f20) + Math_fround(f21 * f7));
     f7 = Math_fround(f7 + Math_fround(HEAPF32[i11 >> 2]));
     f21 = Math_fround(f18 - Math_fround(Math_fround(f2 * Math_fround(f8 - f5)) + Math_fround(Math_fround(f7 - f3) * f1)));
     f20 = Math_fround(f8 + Math_fround(f2 * f21));
     f21 = Math_fround(f7 + Math_fround(f1 * f21));
     f8 = Math_fround(f8 - Math_fround(f2 * f17));
     f2 = Math_fround(f7 - Math_fround(f1 * f17));
     f1 = Math_fround(Math_fround(f2 + f21) * Math_fround(.5));
     HEAPF32[i19 + 8 + (i4 << 3) >> 2] = Math_fround(Math_fround(f8 + f20) * Math_fround(.5));
     HEAPF32[i19 + 8 + (i4 << 3) + 4 >> 2] = f1;
     f1 = Math_fround(f8 - f20);
     f2 = Math_fround(f2 - f21);
     f1 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f1);
     HEAPF32[i19 + 24 + (i4 << 2) >> 2] = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f2));
     i4 = i4 + 1 | 0;
     f2 = Math_fround(HEAPF32[i19 >> 2]);
     f1 = Math_fround(HEAPF32[i12 >> 2]);
    } while ((i4 | 0) < (HEAP32[i15 >> 2] | 0));
   }
   f21 = Math_fround(-f1);
   HEAPF32[i19 >> 2] = Math_fround(-f2);
   HEAPF32[i12 >> 2] = f21;
   return;
  }
 default:
  return;
 }
}

function runPostSets137() {
 HEAP32[gb + 119664 >> 2] = (HEAP32[gb + 119664 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119668 >> 2] = (HEAP32[gb + 119668 >> 2] | 0) + (gb + 1048298 | 0);
 HEAP32[gb + 119696 >> 2] = (HEAP32[gb + 119696 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119700 >> 2] = (HEAP32[gb + 119700 >> 2] | 0) + (gb + 744985 | 0);
 HEAP32[gb + 119728 >> 2] = (HEAP32[gb + 119728 >> 2] | 0) + (gb + 744241 | 0);
 HEAP32[gb + 119760 >> 2] = (HEAP32[gb + 119760 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119764 >> 2] = (HEAP32[gb + 119764 >> 2] | 0) + (gb + 744978 | 0);
 HEAP32[gb + 119792 >> 2] = (HEAP32[gb + 119792 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119796 >> 2] = (HEAP32[gb + 119796 >> 2] | 0) + (gb + 744971 | 0);
 HEAP32[gb + 119824 >> 2] = (HEAP32[gb + 119824 >> 2] | 0) + (gb + 744614 | 0);
 HEAP32[gb + 119856 >> 2] = (HEAP32[gb + 119856 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119860 >> 2] = (HEAP32[gb + 119860 >> 2] | 0) + (gb + 1034365 | 0);
 HEAP32[gb + 119888 >> 2] = (HEAP32[gb + 119888 >> 2] | 0) + (gb + 744725 | 0);
 HEAP32[gb + 119920 >> 2] = (HEAP32[gb + 119920 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119924 >> 2] = (HEAP32[gb + 119924 >> 2] | 0) + (gb + 1084403 | 0);
 HEAP32[gb + 119952 >> 2] = (HEAP32[gb + 119952 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 119956 >> 2] = (HEAP32[gb + 119956 >> 2] | 0) + (gb + 1084385 | 0);
 HEAP32[gb + 119984 >> 2] = (HEAP32[gb + 119984 >> 2] | 0) + (gb + 744080 | 0);
 HEAP32[gb + 120024 >> 2] = fb + 1877;
 HEAP32[gb + 120028 >> 2] = fb + 1878;
 HEAP32[gb + 120032 >> 2] = fb + 363;
 HEAP32[gb + 120036 >> 2] = fb + 1879;
 HEAP32[gb + 120048 >> 2] = fb + 1870;
 HEAP32[gb + 120052 >> 2] = fb + 1880;
 HEAP32[gb + 120056 >> 2] = fb + 1352;
 HEAP32[gb + 120068 >> 2] = fb + 1870;
 HEAP32[gb + 120072 >> 2] = fb + 1881;
 HEAP32[gb + 120076 >> 2] = fb + 1353;
 HEAP32[gb + 120088 >> 2] = fb + 197;
 HEAP32[gb + 120092 >> 2] = fb + 1882;
 HEAP32[gb + 120096 >> 2] = fb + 1883;
 HEAP32[gb + 120100 >> 2] = (HEAP32[gb + 120100 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 120104 >> 2] = (HEAP32[gb + 120104 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 120132 >> 2] = (HEAP32[gb + 120132 >> 2] | 0) + (gb + 774320 | 0);
 HEAP32[gb + 120136 >> 2] = (HEAP32[gb + 120136 >> 2] | 0) + (gb + 1087452 | 0);
 HEAP32[gb + 120164 >> 2] = (HEAP32[gb + 120164 >> 2] | 0) + (gb + 774339 | 0);
 HEAP32[gb + 120168 >> 2] = (HEAP32[gb + 120168 >> 2] | 0) + (gb + 1087483 | 0);
 HEAP32[gb + 120196 >> 2] = (HEAP32[gb + 120196 >> 2] | 0) + (gb + 774333 | 0);
 HEAP32[gb + 120200 >> 2] = (HEAP32[gb + 120200 >> 2] | 0) + (gb + 1087483 | 0);
 HEAP32[gb + 120228 >> 2] = (HEAP32[gb + 120228 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 120232 >> 2] = (HEAP32[gb + 120232 >> 2] | 0) + (gb + 1087830 | 0);
 HEAP32[gb + 120260 >> 2] = (HEAP32[gb + 120260 >> 2] | 0) + (gb + 774345 | 0);
 HEAP32[gb + 120264 >> 2] = (HEAP32[gb + 120264 >> 2] | 0) + (gb + 1087830 | 0);
 HEAP32[gb + 120292 >> 2] = (HEAP32[gb + 120292 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 120296 >> 2] = (HEAP32[gb + 120296 >> 2] | 0) + (gb + 1087895 | 0);
 HEAP32[gb + 120324 >> 2] = (HEAP32[gb + 120324 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120356 >> 2] = (HEAP32[gb + 120356 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 120360 >> 2] = (HEAP32[gb + 120360 >> 2] | 0) + (gb + 1085989 | 0);
 HEAP32[gb + 120388 >> 2] = (HEAP32[gb + 120388 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 120392 >> 2] = (HEAP32[gb + 120392 >> 2] | 0) + (gb + 1085998 | 0);
 HEAP32[gb + 120420 >> 2] = (HEAP32[gb + 120420 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 120424 >> 2] = (HEAP32[gb + 120424 >> 2] | 0) + (gb + 1084342 | 0);
 HEAP32[gb + 120452 >> 2] = (HEAP32[gb + 120452 >> 2] | 0) + (gb + 774398 | 0);
 HEAP32[gb + 120484 >> 2] = (HEAP32[gb + 120484 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 120488 >> 2] = (HEAP32[gb + 120488 >> 2] | 0) + (gb + 1085899 | 0);
 HEAP32[gb + 120516 >> 2] = (HEAP32[gb + 120516 >> 2] | 0) + (gb + 774405 | 0);
 HEAP32[gb + 120548 >> 2] = (HEAP32[gb + 120548 >> 2] | 0) + (gb + 774412 | 0);
 HEAP32[gb + 120580 >> 2] = (HEAP32[gb + 120580 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120584 >> 2] = (HEAP32[gb + 120584 >> 2] | 0) + (gb + 774422 | 0);
 HEAP32[gb + 120612 >> 2] = (HEAP32[gb + 120612 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120616 >> 2] = (HEAP32[gb + 120616 >> 2] | 0) + (gb + 774430 | 0);
 HEAP32[gb + 120644 >> 2] = (HEAP32[gb + 120644 >> 2] | 0) + (gb + 774438 | 0);
 HEAP32[gb + 120676 >> 2] = (HEAP32[gb + 120676 >> 2] | 0) + (gb + 774405 | 0);
 HEAP32[gb + 120680 >> 2] = (HEAP32[gb + 120680 >> 2] | 0) + (gb + 1084124 | 0);
 HEAP32[gb + 120708 >> 2] = (HEAP32[gb + 120708 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120712 >> 2] = (HEAP32[gb + 120712 >> 2] | 0) + (gb + 1084092 | 0);
 HEAP32[gb + 120740 >> 2] = (HEAP32[gb + 120740 >> 2] | 0) + (gb + 774450 | 0);
 HEAP32[gb + 120772 >> 2] = (HEAP32[gb + 120772 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120776 >> 2] = (HEAP32[gb + 120776 >> 2] | 0) + (gb + 774458 | 0);
 HEAP32[gb + 120804 >> 2] = (HEAP32[gb + 120804 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120808 >> 2] = (HEAP32[gb + 120808 >> 2] | 0) + (gb + 774466 | 0);
 HEAP32[gb + 120836 >> 2] = (HEAP32[gb + 120836 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 120840 >> 2] = (HEAP32[gb + 120840 >> 2] | 0) + (gb + 774474 | 0);
 HEAP32[gb + 120868 >> 2] = (HEAP32[gb + 120868 >> 2] | 0) + (gb + 754490 | 0);
 HEAP32[gb + 120872 >> 2] = (HEAP32[gb + 120872 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 120900 >> 2] = (HEAP32[gb + 120900 >> 2] | 0) + (gb + 754477 | 0);
 HEAP32[gb + 120932 >> 2] = (HEAP32[gb + 120932 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 120936 >> 2] = (HEAP32[gb + 120936 >> 2] | 0) + (gb + 754522 | 0);
 HEAP32[gb + 120964 >> 2] = (HEAP32[gb + 120964 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 120968 >> 2] = (HEAP32[gb + 120968 >> 2] | 0) + (gb + 754511 | 0);
 HEAP32[gb + 120996 >> 2] = (HEAP32[gb + 120996 >> 2] | 0) + (gb + 754490 | 0);
 HEAP32[gb + 121e3 >> 2] = (HEAP32[gb + 121e3 >> 2] | 0) + (gb + 754500 | 0);
 HEAP32[gb + 121028 >> 2] = (HEAP32[gb + 121028 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 121032 >> 2] = (HEAP32[gb + 121032 >> 2] | 0) + (gb + 747203 | 0);
 HEAP32[gb + 121060 >> 2] = (HEAP32[gb + 121060 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 121092 >> 2] = (HEAP32[gb + 121092 >> 2] | 0) + (gb + 754470 | 0);
 HEAP32[gb + 121096 >> 2] = (HEAP32[gb + 121096 >> 2] | 0) + (gb + 754477 | 0);
 HEAP32[gb + 121124 >> 2] = (HEAP32[gb + 121124 >> 2] | 0) + (gb + 754033 | 0);
 HEAP32[gb + 121156 >> 2] = (HEAP32[gb + 121156 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 121160 >> 2] = (HEAP32[gb + 121160 >> 2] | 0) + (gb + 1086007 | 0);
 HEAP32[gb + 121188 >> 2] = (HEAP32[gb + 121188 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121192 >> 2] = (HEAP32[gb + 121192 >> 2] | 0) + (gb + 1086046 | 0);
 HEAP32[gb + 121220 >> 2] = (HEAP32[gb + 121220 >> 2] | 0) + (gb + 754397 | 0);
 HEAP32[gb + 121252 >> 2] = (HEAP32[gb + 121252 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121256 >> 2] = (HEAP32[gb + 121256 >> 2] | 0) + (gb + 754389 | 0);
 HEAP32[gb + 121284 >> 2] = (HEAP32[gb + 121284 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121288 >> 2] = (HEAP32[gb + 121288 >> 2] | 0) + (gb + 754380 | 0);
 HEAP32[gb + 121316 >> 2] = (HEAP32[gb + 121316 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 121320 >> 2] = (HEAP32[gb + 121320 >> 2] | 0) + (gb + 754372 | 0);
 HEAP32[gb + 121348 >> 2] = (HEAP32[gb + 121348 >> 2] | 0) + (gb + 827843 | 0);
 runPostSets138();
}

function __ZN14SubstanceInputC2ERKS_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i13 = i15 + 4 | 0;
 i14 = i15;
 i3 = HEAP8[i11 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
 i3 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i9 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i10 + 16 | 0;
 i3 = i11 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i11 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i10 + 28 >> 2] | 0;
  i5 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i5 = 12;
 } else i5 = 10;
 if ((i5 | 0) == 10) {
  i8 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i10 + 24 >> 2] = i8 | -2147483648;
  HEAP32[i10 + 20 >> 2] = i4;
  i1 = i9;
  i5 = 12;
 }
 if ((i5 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i10 + 32 | 0;
 i3 = i11 + 32 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i11 + 36 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 44 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i10 + 44 >> 2] | 0;
  i5 = 16;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i5 = 18;
 } else i5 = 16;
 if ((i5 | 0) == 16) {
  i8 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i10 + 40 >> 2] = i8 | -2147483648;
  HEAP32[i10 + 36 >> 2] = i4;
  i1 = i9;
  i5 = 18;
 }
 if ((i5 | 0) == 18) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i10 + 48 | 0;
 i3 = i11 + 48 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i11 + 52 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 60 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i10 + 60 >> 2] | 0;
  i5 = 22;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i5 = 24;
 } else i5 = 22;
 if ((i5 | 0) == 22) {
  i8 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i10 + 56 >> 2] = i8 | -2147483648;
  HEAP32[i10 + 52 >> 2] = i4;
  i1 = i9;
  i5 = 24;
 }
 if ((i5 | 0) == 24) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i10 + 64 | 0;
 i2 = i11 + 64 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i10 + 104 | 0;
 i2 = i11 + 104 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i10 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 112 >> 2] = 0;
 i4 = i11 + 108 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 >> 4;
 if (i6 | 0) {
  if (i6 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i9 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i10 + 112 >> 2] = i9 + (i6 << 4);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i10 + 116 | 0;
 i2 = i11 + 116 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i10 + 128 | 0;
 i2 = i11 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i10 + 132 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 136 >> 2] = 0;
 i4 = i11 + 132 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 20 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i9 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i10 + 136 >> 2] = i9 + (i6 * 20 | 0);
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 HEAP32[i10 + 140 >> 2] = HEAP32[i11 + 140 >> 2];
 i7 = i10 + 144 | 0;
 i8 = i10 + 148 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 152 | 0;
 HEAP32[i9 >> 2] = 0;
 i1 = i10 + 148 | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i11 + 144 >> 2] | 0;
 i6 = i11 + 148 | 0;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i1;
 i3 = i2;
 i1 = i2;
 while (1) {
  i3 = i3 + 16 | 0;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  i4 = __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIjPNS_11__tree_nodeIjS8_EEiEESB_RKT_(i7, i12, i13, i3) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i2 = __Znwj(20) | 0;
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 >> 2];
   i3 = HEAP32[i13 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i7 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i2);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  if ((i1 | 0) == (i6 | 0)) break; else i3 = i1;
 }
 STACKTOP = i15;
 return;
}

function __ZN5Unity5Cloth8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i11) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i11);
 i1 = i7 + 40 | 0;
 i9 = i11 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i11 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 45 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i2 = i7 + 48 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 80 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 88 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 92 | 0;
 if ((i3 + 1 | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i7 + 120 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 124 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i7 + 140 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 128 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i4 = i7 + 160 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 148 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN4PPtrI15CapsuleColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i7 + 180 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 168 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i10 << 3) | 0;
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN4PPtrI14SphereColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  __ZN4PPtrI14SphereColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i11);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i12;
 return;
}

function __ZL24CalculateDistanceIndicesR16CullingGroupDataR10BlockRangeR20CullingGroupsJobData(i27, i20) {
 i27 = i27 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, i43 = 0, i44 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i29;
 i28 = i29 + 64 | 0;
 i23 = HEAP32[i27 >> 2] | 0;
 i25 = HEAP32[i27 + 16 >> 2] | 0;
 i26 = HEAP32[i27 + 20 >> 2] | 0;
 i24 = HEAP32[i27 + 24 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i21 = i20 + 4 | 0;
 i1 = (HEAP32[i21 >> 2] | 0) + i2 | 0;
 if (i3 >>> 0 > i1 >>> 0) i13 = i2; else {
  i14 = i27 + 28 | 0;
  i15 = i27 + 36 | 0;
  i16 = i27 + 44 | 0;
  f17 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  while (1) {
   i12 = i23 + (i2 << 4) | 0;
   i9 = HEAP32[i14 >> 2] | 0;
   i10 = HEAP32[i15 >> 2] | 0;
   i13 = (HEAP32[i16 >> 2] | 0) + i2 | 0;
   f41 = Math_fround(HEAPF32[i12 >> 2]);
   f40 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   i11 = i12 + 16 | 0;
   f38 = Math_fround(HEAPF32[i11 >> 2]);
   f37 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f36 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f6 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   i11 = i12 + 32 | 0;
   f35 = Math_fround(HEAPF32[i11 >> 2]);
   f34 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   i12 = i12 + 48 | 0;
   f32 = Math_fround(HEAPF32[i12 >> 2]);
   f31 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f41 = Math_fround(f41 - f17);
   f38 = Math_fround(f38 - f17);
   f35 = Math_fround(f35 - f17);
   f32 = Math_fround(f32 - f17);
   f40 = Math_fround(f40 - f18);
   f37 = Math_fround(f37 - f18);
   f34 = Math_fround(f34 - f18);
   f31 = Math_fround(f31 - f18);
   f39 = Math_fround(f39 - f19);
   f36 = Math_fround(f36 - f19);
   f33 = Math_fround(f33 - f19);
   f30 = Math_fround(f30 - f19);
   f5 = Math_fround(Math_fround(Math_fround(Math_fround(f41 * f41) + Math_fround(f40 * f40)) + Math_fround(f39 * f39)) - Math_fround(f5 * f5));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f37 * f37)) + Math_fround(f36 * f36)) - Math_fround(f6 * f6));
   f7 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f34 * f34)) + Math_fround(f33 * f33)) - Math_fround(f7 * f7));
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f31 * f31)) + Math_fround(f30 * f30)) - Math_fround(f8 * f8));
   if (!i10) {
    i9 = 0;
    i4 = 0;
    i2 = 0;
    i1 = 0;
   } else {
    i1 = 0;
    i2 = 0;
    i4 = 0;
    i11 = 0;
    i12 = 0;
    do {
     i44 = (f5 > Math_fround(HEAPF32[i9 + (i1 << 4) >> 2])) << 31 >> 31;
     i43 = (f6 > Math_fround(HEAPF32[i9 + (i1 << 4) + 4 >> 2])) << 31 >> 31;
     i42 = (f7 > Math_fround(HEAPF32[i9 + (i1 << 4) + 8 >> 2])) << 31 >> 31;
     i2 = i2 - i44 | 0;
     i11 = i11 - i43 | 0;
     i12 = i12 - i42 | 0;
     i4 = i4 - ((f8 > Math_fround(HEAPF32[i9 + (i1 << 4) + 12 >> 2])) << 31 >> 31) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i10 | 0));
    i9 = i2 & 255;
    i4 = i4 & 255;
    i2 = i11 & 255;
    i1 = i12 & 255;
   }
   HEAP8[i13 >> 0] = i9;
   HEAP8[i13 + 1 >> 0] = i2;
   HEAP8[i13 + 2 >> 0] = i1;
   HEAP8[i13 + 3 >> 0] = i4;
   i2 = i3 + 4 | 0;
   i1 = (HEAP32[i21 >> 2] | 0) + (HEAP32[i20 >> 2] | 0) | 0;
   if (i2 >>> 0 > i1 >>> 0) {
    i13 = i3;
    break;
   } else {
    i44 = i3;
    i3 = i2;
    i2 = i44;
   }
  }
 }
 i12 = i1 - i13 | 0;
 if (!i12) {
  STACKTOP = i29;
  return;
 }
 i1 = 0;
 do {
  i44 = i22 + (i1 << 4) | 0;
  i43 = i23 + (i1 + i13 << 4) | 0;
  HEAP32[i44 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i44 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i44 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  HEAP32[i44 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 f30 = Math_fround(HEAPF32[i22 >> 2]);
 f31 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 i44 = i22 + 16 | 0;
 f33 = Math_fround(HEAPF32[i44 >> 2]);
 f34 = Math_fround(HEAPF32[i44 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i44 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i44 + 12 >> 2]);
 i44 = i22 + 32 | 0;
 f36 = Math_fround(HEAPF32[i44 >> 2]);
 f37 = Math_fround(HEAPF32[i44 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i44 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i44 + 12 >> 2]);
 i44 = i22 + 48 | 0;
 f17 = Math_fround(HEAPF32[i44 >> 2]);
 i4 = HEAP32[i27 + 28 >> 2] | 0;
 i11 = HEAP32[i27 + 36 >> 2] | 0;
 f39 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(HEAPF32[i44 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i44 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i44 + 12 >> 2]);
 f30 = Math_fround(f30 - f39);
 f33 = Math_fround(f33 - f39);
 f36 = Math_fround(f36 - f39);
 f39 = Math_fround(f17 - f39);
 f31 = Math_fround(f31 - f40);
 f34 = Math_fround(f34 - f40);
 f37 = Math_fround(f37 - f40);
 f40 = Math_fround(f18 - f40);
 f32 = Math_fround(f32 - f41);
 f35 = Math_fround(f35 - f41);
 f38 = Math_fround(f38 - f41);
 f41 = Math_fround(f19 - f41);
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) + Math_fround(f32 * f32)) - Math_fround(f5 * f5));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34)) + Math_fround(f35 * f35)) - Math_fround(f6 * f6));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f37 * f37)) + Math_fround(f38 * f38)) - Math_fround(f7 * f7));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f39 * f39) + Math_fround(f40 * f40)) + Math_fround(f41 * f41)) - Math_fround(f8 * f8));
 if (!i11) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 0;
  i9 = 0;
  i10 = 0;
  do {
   i42 = (f5 > Math_fround(HEAPF32[i4 + (i1 << 4) >> 2])) << 31 >> 31;
   i43 = (f6 > Math_fround(HEAPF32[i4 + (i1 << 4) + 4 >> 2])) << 31 >> 31;
   i44 = (f7 > Math_fround(HEAPF32[i4 + (i1 << 4) + 8 >> 2])) << 31 >> 31;
   i2 = i2 - i42 | 0;
   i9 = i9 - i43 | 0;
   i10 = i10 - i44 | 0;
   i3 = i3 - ((f8 > Math_fround(HEAPF32[i4 + (i1 << 4) + 12 >> 2])) << 31 >> 31) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  i4 = i2 & 255;
  i3 = i3 & 255;
  i2 = i9 & 255;
  i1 = i10 & 255;
 }
 HEAP8[i28 >> 0] = i4;
 HEAP8[i28 + 1 >> 0] = i2;
 HEAP8[i28 + 2 >> 0] = i1;
 HEAP8[i28 + 3 >> 0] = i3;
 i2 = i27 + 44 | 0;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i13 >> 0] = i4;
 if ((i12 | 0) != 1) {
  i1 = 1;
  do {
   HEAP8[(HEAP32[i2 >> 2] | 0) + (i1 + i13) >> 0] = HEAP8[i28 + i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 }
 STACKTOP = i29;
 return;
}

function __ZN9dtNavMesh24connectOffMeshConnectionEj(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i41;
 i32 = i41 + 48 | 0;
 i38 = HEAP32[i15 + 48 >> 2] | 0;
 i17 = _bitshift64Shl(HEAP32[i38 + (i16 * 104 | 0) + 92 >> 2] | 0, 0, 48) | 0;
 i39 = getTempRet0() | 0;
 i17 = i16 | i17 | 65536;
 f29 = Math_fround(HEAPF32[i15 + 84 >> 2]);
 f18 = Math_fround(HEAPF32[i15 + 88 >> 2]);
 HEAPF32[i32 >> 2] = f29;
 HEAPF32[i32 + 4 >> 2] = f18;
 HEAPF32[i32 + 8 >> 2] = f29;
 i19 = i21 + 4 | 0;
 i20 = i21 + 8 | 0;
 i22 = i21 + 16 | 0;
 i23 = i21 + 20 | 0;
 i24 = i21 + 24 | 0;
 i25 = i21 + 28 | 0;
 i26 = i21 + 32 | 0;
 i27 = i21 + 36 | 0;
 i28 = i21 + 40 | 0;
 f29 = Math_fround(f29 * f29);
 i30 = i15 + 16 | 0;
 i31 = i15 + 20 | 0;
 i33 = i15 + 28 | 0;
 i34 = i15 + 32 | 0;
 i35 = i15 + 36 | 0;
 i36 = i38 + (i16 * 104 | 0) + 72 | 0;
 i37 = i38 + (i16 * 104 | 0) + 88 | 0;
 i14 = 0;
 L1 : while (1) {
  i6 = i38 + (i16 * 104 | 0) + (i14 << 5) + 24 | 0;
  i13 = i6;
  L3 : do if ((HEAP32[i13 >> 2] | 0) == 0 & (HEAP32[i13 + 4 >> 2] | 0) == 0) {
   i1 = i38 + (i16 * 104 | 0) + (i14 << 5) | 0;
   HEAP32[i21 >> 2] = gb + 169376 + 8;
   HEAP32[i19 >> 2] = i15;
   i2 = i20;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAPF32[i22 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
   i2 = i38 + (i16 * 104 | 0) + (i14 << 5) + 4 | 0;
   HEAP32[i24 >> 2] = HEAP32[i2 >> 2];
   i3 = i38 + (i16 * 104 | 0) + (i14 << 5) + 8 | 0;
   HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
   HEAPF32[i26 >> 2] = Math_fround(0.0);
   HEAPF32[i27 >> 2] = Math_fround(0.0);
   HEAPF32[i28 >> 2] = Math_fround(0.0);
   __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback(i15, i1, i32, i21) | 0;
   i7 = HEAP32[i26 >> 2] | 0;
   i8 = HEAP32[i27 >> 2] | 0;
   i9 = HEAP32[i28 >> 2] | 0;
   i12 = i20;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   if (!((i11 | 0) == 0 & (i12 | 0) == 0)) {
    f43 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f43 = Math_fround(f43 - Math_fround(HEAPF32[i1 >> 2]));
    f43 = Math_fround(f43 * f43);
    f42 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f42 = Math_fround(f42 - Math_fround(HEAPF32[i3 >> 2]));
    if (!(Math_fround(f43 + Math_fround(f42 * f42)) > f29)) {
     f43 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f43 = Math_fround(f43 - Math_fround(HEAPF32[i2 >> 2]));
     i13 = f43 < Math_fround(0.0);
     f42 = Math_fround(-f43);
     if ((i13 ? f42 : f43) <= f18) {
      i1 = _bitshift64Lshr(i11 | 0, i12 | 0, 20) | 0;
      getTempRet0() | 0;
      i1 = i1 & 268435455;
      i2 = i11 & 65535;
      if (i1 >>> 0 < (HEAP32[i30 >> 2] | 0) >>> 0) {
       i13 = _bitshift64Lshr(i11 | 0, i12 | 0, 48) | 0;
       getTempRet0() | 0;
       i3 = HEAP32[i31 >> 2] | 0;
       i5 = i3 + (i1 * 56 | 0) | 0;
       if ((HEAP32[i3 + (i1 * 56 | 0) + 4 >> 2] | 0) == (i13 | 0)) {
        i4 = HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] | 0;
        if (i4 | 0) {
         if ((i11 & 983040 | 0) == 65536 & 0 == 0) {
          i13 = 0;
          i10 = 0;
         } else {
          if (i2 >>> 0 >= (HEAP32[i4 + 20 >> 2] | 0) >>> 0) break;
          i13 = (HEAP32[i3 + (i1 * 56 | 0) + 16 >> 2] | 0) + (i2 << 5) | 0;
          i10 = i5;
         }
         HEAP32[i38 + (i16 * 104 | 0) + (i14 << 5) + 12 >> 2] = i7;
         HEAP32[i38 + (i16 * 104 | 0) + (i14 << 5) + 16 >> 2] = i8;
         HEAP32[i38 + (i16 * 104 | 0) + (i14 << 5) + 20 >> 2] = i9;
         i1 = i6;
         HEAP32[i1 >> 2] = i11;
         HEAP32[i1 + 4 >> 2] = i12;
         i1 = HEAP32[i33 >> 2] | 0;
         if ((i1 | 0) == -1) {
          i9 = HEAP32[i34 >> 2] | 0;
          i2 = (i9 | 0) == 0 ? 4 : i9 << 1;
          if (i9 >>> 0 < i2 >>> 0) {
           i4 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i35 >> 2] | 0, i2 << 4 | 0) | 0;
           if (!i4) i1 = HEAP32[i33 >> 2] | 0; else {
            HEAP32[i35 >> 2] = i4;
            i1 = HEAP32[i34 >> 2] | 0;
            i5 = i2 + -1 | 0;
            if (i1 >>> 0 < i5 >>> 0) {
             i3 = i1;
             do {
              i9 = i3;
              i3 = i3 + 1 | 0;
              HEAP32[i4 + (i9 << 4) + 8 >> 2] = i3;
             } while ((i3 | 0) != (i5 | 0));
            }
            HEAP32[i4 + (i5 << 4) + 8 >> 2] = -1;
            HEAP32[i33 >> 2] = i1;
            HEAP32[i34 >> 2] = i2;
           }
           if ((i1 | 0) == -1) i1 = -1; else i40 = 21;
          } else i1 = -1;
         } else i40 = 21;
         if ((i40 | 0) == 21) {
          i40 = 0;
          i7 = HEAP32[i35 >> 2] | 0;
          i8 = i7 + (i1 << 4) + 8 | 0;
          i9 = HEAP32[i8 >> 2] | 0;
          HEAP32[i33 >> 2] = i9;
          i6 = i7 + (i1 << 4) | 0;
          HEAP32[i6 >> 2] = i11;
          HEAP32[i6 + 4 >> 2] = i12;
          HEAP8[i7 + (i1 << 4) + 12 >> 0] = i14;
          HEAP8[i7 + (i1 << 4) + 13 >> 0] = -1;
          HEAP8[i7 + (i1 << 4) + 15 >> 0] = 0;
          HEAP8[i7 + (i1 << 4) + 14 >> 0] = 0;
          HEAP32[i8 >> 2] = HEAP32[i37 >> 2];
          HEAP32[i37 >> 2] = i1;
          i1 = i9;
         }
         switch (i14 | 0) {
         case 0:
          break;
         case 1:
          {
           if (!(HEAP8[i36 >> 0] & 1)) {
            i40 = 2;
            break L1;
           }
           break;
          }
         default:
          break L3;
         }
         if ((i1 | 0) == -1) {
          i12 = HEAP32[i34 >> 2] | 0;
          i2 = (i12 | 0) == 0 ? 4 : i12 << 1;
          if (i12 >>> 0 >= i2 >>> 0) break;
          i4 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i35 >> 2] | 0, i2 << 4 | 0) | 0;
          if (!i4) i1 = HEAP32[i33 >> 2] | 0; else {
           HEAP32[i35 >> 2] = i4;
           i1 = HEAP32[i34 >> 2] | 0;
           i5 = i2 + -1 | 0;
           if (i1 >>> 0 < i5 >>> 0) {
            i3 = i1;
            do {
             i12 = i3;
             i3 = i3 + 1 | 0;
             HEAP32[i4 + (i12 << 4) + 8 >> 2] = i3;
            } while ((i3 | 0) != (i5 | 0));
           }
           HEAP32[i4 + (i5 << 4) + 8 >> 2] = -1;
           HEAP32[i33 >> 2] = i1;
           HEAP32[i34 >> 2] = i2;
          }
          if ((i1 | 0) == -1) break;
         }
         i11 = HEAP32[i35 >> 2] | 0;
         i12 = i11 + (i1 << 4) + 8 | 0;
         HEAP32[i33 >> 2] = HEAP32[i12 >> 2];
         HEAP32[i12 >> 2] = 0;
         i9 = i11 + (i1 << 4) | 0;
         HEAP32[i9 >> 2] = i17;
         HEAP32[i9 + 4 >> 2] = i39;
         HEAP8[i11 + (i1 << 4) + 12 >> 0] = i14;
         HEAP8[i11 + (i1 << 4) + 13 >> 0] = -1;
         HEAP8[i11 + (i1 << 4) + 15 >> 0] = 0;
         HEAP8[i11 + (i1 << 4) + 14 >> 0] = 0;
         i13 = (HEAP32[i10 + 12 >> 2] | 0) + (i13 - (HEAP32[i10 + 16 >> 2] | 0) >> 5 << 2) | 0;
         HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
         HEAP32[i13 >> 2] = i1;
        }
       }
      }
     }
    }
   }
  } while (0);
  i14 = i14 + 1 | 0;
  if ((i14 | 0) == 2) {
   i40 = 2;
   break;
  }
 }
 if ((i40 | 0) == 2) {
  STACKTOP = i41;
  return;
 }
}

function __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 4 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i6, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = 0;
 do {
  HEAP32[i9 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 471386 | 0, i9);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) | 0, gb + 471425 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 8 | 0, gb + 471461 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 16 | 0, gb + 471471 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 24 | 0, gb + 471485 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 32 | 0, gb + 471500 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 40 | 0, gb + 471508 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 64 + (i1 * 56 | 0) + 48 | 0, gb + 471521 | 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i7 = i8 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i6 + 717 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 16 | 0, gb + 471529 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 24 | 0, gb + 471535 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 32 | 0, gb + 471542 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 40 | 0, gb + 471550 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 48 | 0, gb + 471563 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 56 | 0, gb + 471575 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 512 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 520 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 528 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 536 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 544 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 552 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 560 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 568 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 576 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 584 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 592 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 600 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 608 | 0, gb + 471646 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 616 | 0, gb + 471662 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 624 | 0, gb + 471679 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 632 | 0, gb + 471690 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 640 | 0, gb + 471699 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i8, i6 + 648 | 0, gb + 471706 | 0, 0);
 __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb1EEEEvRS1_RT_(i6 + 656 | 0, i8);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i6 + 692 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 696 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 700 | 0, i8);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 712 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 716 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 1);
  i9 = HEAP8[i9 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i6;
  HEAP32[i7 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx21PxcArticulationHelper18setJointTransformsERNS_30PxcArticulationJointTransformsERKNS_11PxTransformES5_RKNS_24PxsArticulationJointCoreE(i14, i3, i1, i2) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0;
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f23 = Math_fround(f7 * f19);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f21 * f6));
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f17 * f9));
 f4 = Math_fround(Math_fround(f19 * f23) + Math_fround(Math_fround(f7 * f20) + Math_fround(f18 * Math_fround(Math_fround(f17 * f6) - Math_fround(f21 * f9)))));
 f22 = Math_fround(Math_fround(f6 * f23) + Math_fround(Math_fround(f21 * f20) + Math_fround(f18 * Math_fround(Math_fround(f7 * f9) - Math_fround(f17 * f19)))));
 f23 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(f18 * Math_fround(Math_fround(f21 * f19) - Math_fround(f7 * f6)))) + Math_fround(f9 * f23));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f4);
 f22 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f22);
 f23 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f23);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f21 = Math_fround(f18 * f7);
 f20 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f19 * f20));
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f6 * f17));
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f24 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f6 * f20) + Math_fround(f18 * f8))) - Math_fround(f19 * f17));
 f15 = Math_fround(Math_fround(Math_fround(f19 * f8) + Math_fround(Math_fround(f9 * f20) + Math_fround(f18 * f17))) - Math_fround(f6 * f7));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f20) - Math_fround(f19 * f7)) - Math_fround(f6 * f8)) - Math_fround(f9 * f17));
 HEAPF32[i14 >> 2] = Math_fround(f21 - Math_fround(f9 * f8));
 i26 = i14 + 4 | 0;
 HEAPF32[i26 >> 2] = f24;
 i25 = i14 + 8 | 0;
 HEAPF32[i25 >> 2] = f15;
 i13 = i14 + 12 | 0;
 HEAPF32[i13 >> 2] = f17;
 i12 = i14 + 16 | 0;
 HEAPF32[i12 >> 2] = f4;
 i11 = i14 + 20 | 0;
 HEAPF32[i11 >> 2] = f22;
 i10 = i14 + 24 | 0;
 HEAPF32[i10 >> 2] = f23;
 f23 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 52 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f15 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f24 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f23 * f24);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f22 * f9));
 f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f4 * f21));
 f6 = Math_fround(Math_fround(f24 * f8) + Math_fround(Math_fround(f23 * f15) + Math_fround(f17 * Math_fround(Math_fround(f4 * f9) - Math_fround(f22 * f21)))));
 f7 = Math_fround(Math_fround(f9 * f8) + Math_fround(Math_fround(f22 * f15) + Math_fround(f17 * Math_fround(Math_fround(f23 * f21) - Math_fround(f4 * f24)))));
 f8 = Math_fround(Math_fround(Math_fround(f4 * f15) + Math_fround(f17 * Math_fround(Math_fround(f22 * f24) - Math_fround(f23 * f9)))) + Math_fround(f21 * f8));
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f6);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f7);
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f8);
 f23 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f22 = Math_fround(f17 * f23);
 f15 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f24 * f15));
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f9 * f4));
 f19 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f22 = Math_fround(f22 - Math_fround(f21 * f19));
 f20 = Math_fround(Math_fround(Math_fround(f21 * f23) + Math_fround(Math_fround(f9 * f15) + Math_fround(f17 * f19))) - Math_fround(f24 * f4));
 f18 = Math_fround(Math_fround(Math_fround(f24 * f19) + Math_fround(Math_fround(f21 * f15) + Math_fround(f17 * f4))) - Math_fround(f9 * f23));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f15) - Math_fround(f24 * f23)) - Math_fround(f9 * f19)) - Math_fround(f21 * f4));
 i1 = i14 + 28 | 0;
 HEAPF32[i1 >> 2] = f22;
 i2 = i14 + 32 | 0;
 HEAPF32[i2 >> 2] = f20;
 i3 = i14 + 36 | 0;
 HEAPF32[i3 >> 2] = f18;
 i5 = i14 + 40 | 0;
 HEAPF32[i5 >> 2] = f4;
 HEAPF32[i14 + 44 >> 2] = f6;
 HEAPF32[i14 + 48 >> 2] = f7;
 HEAPF32[i14 + 52 >> 2] = f8;
 f21 = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f23 = Math_fround(HEAPF32[i13 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i12 >> 2]));
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 >> 2]));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f7 = Math_fround(f7 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f8 - Math_fround(HEAPF32[i10 >> 2])) * Math_fround(2.0));
 f24 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(Math_fround(f6 * f21) + Math_fround(f7 * f19)) + Math_fround(f8 * f9));
 f17 = Math_fround(Math_fround(f15 * f21) + Math_fround(Math_fround(f24 * f6) + Math_fround(f23 * Math_fround(Math_fround(f8 * f19) - Math_fround(f7 * f9)))));
 f16 = Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f24 * f7) + Math_fround(f23 * Math_fround(Math_fround(f6 * f9) - Math_fround(f8 * f21)))));
 f15 = Math_fround(Math_fround(Math_fround(f24 * f8) + Math_fround(f23 * Math_fround(Math_fround(f7 * f21) - Math_fround(f6 * f19)))) + Math_fround(f15 * f9));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f4 * f21)) + Math_fround(f18 * f19)) - Math_fround(f20 * f9));
 f7 = Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(Math_fround(f4 * f19) + Math_fround(f23 * f20))) - Math_fround(f18 * f21));
 f8 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(Math_fround(f4 * f9) + Math_fround(f23 * f18))) - Math_fround(f22 * f19));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f4) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f18 * f9));
 i10 = i14 + 56 | 0;
 HEAPF32[i10 >> 2] = f6;
 i11 = i14 + 60 | 0;
 HEAPF32[i11 >> 2] = f7;
 i12 = i14 + 64 | 0;
 HEAPF32[i12 >> 2] = f8;
 i13 = i14 + 68 | 0;
 HEAPF32[i13 >> 2] = f9;
 HEAPF32[i14 + 72 >> 2] = f17;
 HEAPF32[i14 + 76 >> 2] = f16;
 HEAPF32[i14 + 80 >> 2] = f15;
 if (!(f9 < Math_fround(0.0))) return;
 f23 = Math_fround(-f7);
 f22 = Math_fround(-f8);
 f21 = Math_fround(-f9);
 HEAPF32[i10 >> 2] = Math_fround(-f6);
 HEAPF32[i11 >> 2] = f23;
 HEAPF32[i12 >> 2] = f22;
 HEAPF32[i13 >> 2] = f21;
 f21 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f22 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f23 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f24 = Math_fround(-f4);
 HEAPF32[i1 >> 2] = f21;
 HEAPF32[i2 >> 2] = f22;
 HEAPF32[i3 >> 2] = f23;
 HEAPF32[i5 >> 2] = f24;
 return;
}

function __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i11 + 16 >> 2] | 0;
 i1 = i10;
 if ((i10 | 0) == (HEAP32[i11 + 12 >> 2] | 0)) {
  HEAP8[i11 + 28 >> 0] = 1;
  return;
 }
 i10 = i1 + -8 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 | 0) != 0;
 if (!(HEAP8[i1 + -4 >> 0] | 0)) {
  do if (i3) {
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = i3 + 12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i7 = i3 + 16 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i9 = i8 & 2147483647;
   i1 = i6 >>> 0 > i9 >>> 0;
   if (!(i2 & 1)) {
    do if (i1) {
     i1 = i8 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i7 >> 2] = i1;
      HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = i1;
      HEAP32[i3 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i4 >> 2] = i6;
    HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = 44;
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = i2 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = i2 + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i5 >>> 0 > i8 >>> 0) {
     i1 = i7 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i5;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 10;
    break;
   } else {
    do if (i1) {
     i1 = i8 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i7 >> 2] = i1;
      HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i7 >> 2] = i1;
      HEAP32[i3 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i4 >> 2] = i6;
    HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = 58;
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = i2 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = i2 + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i5 >>> 0 > i8 >>> 0) {
     i1 = i7 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i5;
    HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 32;
    break;
   }
  } else {
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 10;
  } while (0);
  if (!(HEAP32[i10 >> 2] & 1)) __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv(i11);
 } else {
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = i2 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i2 + 16 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  i1 = i6 >>> 0 > i9 >>> 0;
  if (i3) {
   do if (i1) {
    i1 = i8 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i4 >> 2] = i6;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i5 >> 0] = 44;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 10;
  } else {
   do if (i1) {
    i1 = i8 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i2 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i4 >> 2] = i6;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i5 >> 0] = 10;
  }
  __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv(i11);
 }
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 return;
}

function __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB(i37, i36, i39) {
 i37 = i37 | 0;
 i36 = i36 | 0;
 i39 = i39 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, i40 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i40;
 i1 = HEAP32[i36 + 28 >> 2] | 0;
 if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i35 = HEAP32[i1 + 40 >> 2] | 0;
  if ((i35 | 0) > 0) {
   i11 = i1 + 28 | 0;
   i18 = i34 + 16 | 0;
   i19 = i34 + 32 | 0;
   i20 = i34 + 48 | 0;
   i21 = i34 + 4 | 0;
   i22 = i34 + 20 | 0;
   i23 = i34 + 36 | 0;
   i24 = i34 + 52 | 0;
   i25 = i34 + 8 | 0;
   i26 = i34 + 24 | 0;
   i27 = i34 + 40 | 0;
   i28 = i34 + 56 | 0;
   i29 = i39 + 4 | 0;
   i30 = i39 + 8 | 0;
   i31 = i39 + 12 | 0;
   i32 = i39 + 16 | 0;
   i33 = i39 + 20 | 0;
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
    if (i3 | 0) if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) {
     i1 = HEAP32[i3 + 28 >> 2] | 0;
     if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
      i1 = i3 + 32 | 0;
      i2 = i3 + 268 | 0;
      if (((HEAPU16[i2 >> 1] | HEAPU8[i2 + 2 >> 0] << 16) & 196608 | 0) == 131072) {
       i2 = i3 + 272 | 0;
       i41 = HEAP16[i2 >> 1] | 0;
       if ((i41 & 65535) > 255 | (i41 & 255) << 24 >> 24 != 0) {
        mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
        HEAP8[i2 >> 0] = 0;
        HEAP8[i1 + 241 >> 0] = 0;
       }
       i1 = i3 + 36 | 0;
       i2 = i1 + 152 | 0;
       f17 = Math_fround(HEAPF32[i1 + 164 >> 2]);
       f17 = Math_fround(f17 * f17);
       f16 = Math_fround(HEAPF32[i1 + 168 >> 2]);
       f16 = Math_fround(f17 + Math_fround(f16 * f16));
       f17 = Math_fround(HEAPF32[i1 + 172 >> 2]);
       if (Math_fround(f16 + Math_fround(f17 * f17)) > Math_fround(1.1920929e-07)) {
        __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i37, i1, i34);
        if (!(HEAP8[gb + 1544218 >> 0] | 0)) HEAP8[gb + 1544218 >> 0] = 1;
        __ZNK4AABB17CalculateVerticesEP8Vector3f(i2, gb + 1110948 | 0);
        f4 = Math_fround(HEAPF32[i34 >> 2]);
        f6 = Math_fround(HEAPF32[i18 >> 2]);
        f7 = Math_fround(HEAPF32[i19 >> 2]);
        f8 = Math_fround(HEAPF32[i20 >> 2]);
        f9 = Math_fround(HEAPF32[i21 >> 2]);
        f10 = Math_fround(HEAPF32[i22 >> 2]);
        f12 = Math_fround(HEAPF32[i23 >> 2]);
        f13 = Math_fround(HEAPF32[i24 >> 2]);
        f14 = Math_fround(HEAPF32[i25 >> 2]);
        f15 = Math_fround(HEAPF32[i26 >> 2]);
        f16 = Math_fround(HEAPF32[i27 >> 2]);
        f17 = Math_fround(HEAPF32[i28 >> 2]);
        i1 = 0;
        do {
         i2 = gb + 1110948 + (i1 * 12 | 0) | 0;
         f44 = Math_fround(HEAPF32[i2 >> 2]);
         f43 = Math_fround(f4 * f44);
         i3 = gb + 1110948 + (i1 * 12 | 0) + 4 | 0;
         f42 = Math_fround(HEAPF32[i3 >> 2]);
         f43 = Math_fround(f43 + Math_fround(f6 * f42));
         i41 = gb + 1110948 + (i1 * 12 | 0) + 8 | 0;
         f47 = Math_fround(HEAPF32[i41 >> 2]);
         f43 = Math_fround(f8 + Math_fround(f43 + Math_fround(f7 * f47)));
         f45 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f44 * f9) + Math_fround(f42 * f10)) + Math_fround(f47 * f12)));
         f47 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f44 * f14) + Math_fround(f42 * f15)) + Math_fround(f47 * f16)));
         HEAPF32[i2 >> 2] = f43;
         HEAPF32[i3 >> 2] = f45;
         HEAPF32[i41 >> 2] = f47;
         f42 = Math_fround(HEAPF32[i39 >> 2]);
         f44 = Math_fround(HEAPF32[i29 >> 2]);
         f46 = Math_fround(HEAPF32[i30 >> 2]);
         HEAPF32[i39 >> 2] = f43 < f42 ? f43 : f42;
         HEAPF32[i29 >> 2] = f45 < f44 ? f45 : f44;
         HEAPF32[i30 >> 2] = f47 < f46 ? f47 : f46;
         f46 = Math_fround(HEAPF32[i31 >> 2]);
         f47 = Math_fround(HEAPF32[i2 >> 2]);
         f44 = Math_fround(HEAPF32[i32 >> 2]);
         f45 = Math_fround(HEAPF32[i3 >> 2]);
         f42 = Math_fround(HEAPF32[i33 >> 2]);
         f43 = Math_fround(HEAPF32[i41 >> 2]);
         HEAPF32[i31 >> 2] = f46 < f47 ? f47 : f46;
         HEAPF32[i32 >> 2] = f44 < f45 ? f45 : f44;
         HEAPF32[i33 >> 2] = f42 < f43 ? f43 : f42;
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) != 8);
       }
      }
     }
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i35 | 0));
  }
  i3 = HEAP32[i36 + 92 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i2 = i36 + 80 | 0;
   i1 = 0;
   do {
    __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB(i37, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i39);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 f12 = Math_fround(HEAPF32[i39 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f12 == f4) {
  i5 = i39 + 4 | 0;
  f6 = Math_fround(HEAPF32[i5 >> 2]);
  if (f6 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   i1 = i39 + 8 | 0;
   f7 = Math_fround(HEAPF32[i1 >> 2]);
   if (f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
    i2 = i39 + 12 | 0;
    f9 = Math_fround(HEAPF32[i2 >> 2]);
    i3 = i39 + 16 | 0;
    f8 = Math_fround(HEAPF32[i3 >> 2]);
    i41 = i39 + 20 | 0;
    i11 = i41;
    f4 = Math_fround(HEAPF32[i41 >> 2]);
   } else i38 = 25;
  } else i38 = 25;
 } else i38 = 25;
 do if ((i38 | 0) == 25) {
  f47 = Math_fround(-f4);
  f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i2 = i39 + 12 | 0;
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f9 == f47)) {
   STACKTOP = i40;
   return;
  }
  f47 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  i3 = i39 + 16 | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  if (!(f8 == f47)) {
   STACKTOP = i40;
   return;
  }
  i5 = i39 + 20 | 0;
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  if (f10 != f4) {
   STACKTOP = i40;
   return;
  } else {
   i38 = i39 + 4 | 0;
   f6 = Math_fround(HEAPF32[i38 >> 2]);
   i41 = i39 + 8 | 0;
   i1 = i41;
   i11 = i5;
   i5 = i38;
   f7 = Math_fround(HEAPF32[i41 >> 2]);
   f4 = f10;
   break;
  }
 } while (0);
 f47 = Math_fround(HEAPF32[gb + 1111044 >> 2]);
 f47 = Math_fround(f47 - Math_fround(HEAPF32[gb + 1111044 + 12 >> 2]));
 f46 = Math_fround(HEAPF32[gb + 1111044 + 4 >> 2]);
 f46 = Math_fround(f46 - Math_fround(HEAPF32[gb + 1111044 + 16 >> 2]));
 f45 = Math_fround(HEAPF32[gb + 1111044 + 8 >> 2]);
 f45 = Math_fround(f45 - Math_fround(HEAPF32[gb + 1111044 + 20 >> 2]));
 HEAPF32[i39 >> 2] = f47 < f12 ? f47 : f12;
 HEAPF32[i5 >> 2] = f46 < f6 ? f46 : f6;
 HEAPF32[i1 >> 2] = f45 < f7 ? f45 : f7;
 f45 = Math_fround(HEAPF32[gb + 1111044 >> 2]);
 f45 = Math_fround(f45 + Math_fround(HEAPF32[gb + 1111044 + 12 >> 2]));
 f46 = Math_fround(HEAPF32[gb + 1111044 + 4 >> 2]);
 f46 = Math_fround(f46 + Math_fround(HEAPF32[gb + 1111044 + 16 >> 2]));
 f47 = Math_fround(HEAPF32[gb + 1111044 + 8 >> 2]);
 f47 = Math_fround(f47 + Math_fround(HEAPF32[gb + 1111044 + 20 >> 2]));
 HEAPF32[i2 >> 2] = f9 < f45 ? f45 : f9;
 HEAPF32[i3 >> 2] = f8 < f46 ? f46 : f8;
 HEAPF32[i11 >> 2] = f4 < f47 ? f47 : f4;
 STACKTOP = i40;
 return;
}

function __ZN5physx2Gu22computePlane_ConvexMTDERKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformERNS_10PxSweepHitE(i38, i1, i3, i37) {
 i38 = i38 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i37 = i37 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i39 = 0, f40 = f0, f41 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i39;
 i18 = HEAP32[i1 + 32 >> 2] | 0;
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i6, i1 + 4 | 0, i1 + 16 | 0);
 i8 = HEAP8[i18 + 54 >> 0] | 0;
 i4 = HEAP32[i18 + 56 >> 2] | 0;
 i1 = (HEAPU8[i18 + 55 >> 0] | 0) * 20 | 0;
 i18 = i4 + i1 | 0;
 f17 = Math_fround(HEAPF32[i18 >> 2]);
 f30 = Math_fround(f17 * Math_fround(HEAPF32[i6 >> 2]));
 i5 = i6 + 4 | 0;
 f22 = Math_fround(f17 * Math_fround(HEAPF32[i5 >> 2]));
 i7 = i6 + 8 | 0;
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i7 >> 2]));
 f25 = Math_fround(HEAPF32[i4 + (i1 + 4) >> 2]);
 f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f27 = Math_fround(f25 * f19);
 f20 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f26 = Math_fround(f25 * f20);
 f21 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f27 = Math_fround(f30 + f27);
 f26 = Math_fround(f22 + f26);
 f25 = Math_fround(f17 + Math_fround(f25 * f21));
 f17 = Math_fround(HEAPF32[i4 + (i1 + 8) >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f30 = Math_fround(f17 * f22);
 f23 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f31 = Math_fround(f17 * f23);
 f24 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f30 = Math_fround(Math_fround(f27 + f30) * Math_fround(2.0));
 f31 = Math_fround(Math_fround(f26 + f31) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f25 + Math_fround(f17 * f24)) * Math_fround(2.0));
 f25 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(f30 * f27);
 f28 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f31 * f28));
 f29 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f17 * f29));
 f36 = Math_fround(Math_fround(f27 * f16) + Math_fround(Math_fround(f30 * f26) + Math_fround(f25 * Math_fround(Math_fround(f17 * f28) - Math_fround(f31 * f29)))));
 f2 = Math_fround(Math_fround(f28 * f16) + Math_fround(Math_fround(f31 * f26) + Math_fround(f25 * Math_fround(Math_fround(f30 * f29) - Math_fround(f27 * f17)))));
 f16 = Math_fround(Math_fround(Math_fround(f17 * f26) + Math_fround(f25 * Math_fround(Math_fround(f31 * f27) - Math_fround(f30 * f28)))) + Math_fround(f29 * f16));
 f30 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f36 = Math_fround(f30 + f36);
 f31 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f2 = Math_fround(f31 + f2);
 f17 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f16 = Math_fround(f17 + f16);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 f32 = Math_fround(HEAPF32[i38 >> 2]);
 f36 = Math_fround(f32 * f36);
 i33 = i38 + 4 | 0;
 f34 = Math_fround(HEAPF32[i33 >> 2]);
 f2 = Math_fround(f36 + Math_fround(f34 * f2));
 i35 = i38 + 8 | 0;
 f36 = Math_fround(HEAPF32[i35 >> 2]);
 f2 = Math_fround(Math_fround(f16 * f36) + f2);
 f16 = Math_fround(HEAPF32[i38 + 12 >> 2]);
 f2 = Math_fround(f16 + f2);
 if ((i8 & 255) <= 1) {
  i18 = i4;
  i8 = i3;
  i7 = i1;
  f31 = f2;
  i6 = i37 + 28 | 0;
  HEAPF32[i6 >> 2] = f32;
  i6 = i37 + 32 | 0;
  HEAPF32[i6 >> 2] = f34;
  i6 = i37 + 36 | 0;
  HEAPF32[i6 >> 2] = f36;
  i6 = i37 + 40 | 0;
  HEAPF32[i6 >> 2] = f31;
  f32 = Math_fround(HEAPF32[i38 >> 2]);
  f32 = Math_fround(f31 * f32);
  f34 = Math_fround(HEAPF32[i33 >> 2]);
  f34 = Math_fround(f31 * f34);
  f36 = Math_fround(HEAPF32[i35 >> 2]);
  f36 = Math_fround(f31 * f36);
  f31 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f32 = Math_fround(f31 - f32);
  f31 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f31 - f34);
  f31 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = Math_fround(f31 - f36);
  i38 = i37 + 16 | 0;
  HEAPF32[i38 >> 2] = f32;
  i38 = i37 + 20 | 0;
  HEAPF32[i38 >> 2] = f34;
  i38 = i37 + 24 | 0;
  HEAPF32[i38 >> 2] = f36;
  STACKTOP = i39;
  return 1;
 }
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 i6 = i8 & 255;
 f12 = f2;
 i5 = 1;
 while (1) {
  f41 = Math_fround(HEAPF32[i18 + (i5 * 12 | 0) >> 2]);
  f2 = Math_fround(f41 * f15);
  f40 = Math_fround(f41 * f14);
  f41 = Math_fround(f41 * f13);
  f10 = Math_fround(HEAPF32[i18 + (i5 * 12 | 0) + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f10 * f19));
  f40 = Math_fround(f40 + Math_fround(f10 * f20));
  f10 = Math_fround(f41 + Math_fround(f10 * f21));
  f41 = Math_fround(HEAPF32[i18 + (i5 * 12 | 0) + 8 >> 2]);
  f2 = Math_fround(Math_fround(f2 + Math_fround(f41 * f22)) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(f40 + Math_fround(f41 * f23)) * Math_fround(2.0));
  f41 = Math_fround(Math_fround(f10 + Math_fround(f41 * f24)) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(Math_fround(f2 * f27) + Math_fround(f40 * f28)) + Math_fround(f41 * f29));
  f11 = Math_fround(f30 + Math_fround(Math_fround(f27 * f10) + Math_fround(Math_fround(f2 * f26) + Math_fround(f25 * Math_fround(Math_fround(f41 * f28) - Math_fround(f40 * f29))))));
  f9 = Math_fround(f31 + Math_fround(Math_fround(f28 * f10) + Math_fround(Math_fround(f40 * f26) + Math_fround(f25 * Math_fround(Math_fround(f2 * f29) - Math_fround(f27 * f41))))));
  f10 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f41 * f26) + Math_fround(f25 * Math_fround(Math_fround(f40 * f27) - Math_fround(f2 * f28)))) + Math_fround(f29 * f10)));
  f2 = Math_fround(f16 + Math_fround(Math_fround(f10 * f36) + Math_fround(Math_fround(f32 * f11) + Math_fround(f34 * f9))));
  if (f12 > f2) {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  } else f2 = f12;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i6 | 0)) break; else f12 = f2;
 }
 i18 = i37 + 28 | 0;
 HEAPF32[i18 >> 2] = f32;
 i18 = i37 + 32 | 0;
 HEAPF32[i18 >> 2] = f34;
 i18 = i37 + 36 | 0;
 HEAPF32[i18 >> 2] = f36;
 i18 = i37 + 40 | 0;
 HEAPF32[i18 >> 2] = f2;
 f36 = Math_fround(HEAPF32[i38 >> 2]);
 f36 = Math_fround(f2 * f36);
 f40 = Math_fround(HEAPF32[i33 >> 2]);
 f40 = Math_fround(f2 * f40);
 f41 = Math_fround(HEAPF32[i35 >> 2]);
 f41 = Math_fround(f2 * f41);
 f34 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f36 = Math_fround(f34 - f36);
 f34 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f40 = Math_fround(f34 - f40);
 f34 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f41 = Math_fround(f34 - f41);
 i38 = i37 + 16 | 0;
 HEAPF32[i38 >> 2] = f36;
 i38 = i37 + 20 | 0;
 HEAPF32[i38 >> 2] = f40;
 i38 = i37 + 24 | 0;
 HEAPF32[i38 >> 2] = f41;
 STACKTOP = i39;
 return 1;
}

function __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, f68 = f0, f69 = f0, f70 = f0, f71 = f0, f72 = f0, i73 = 0;
 f15 = Math_fround(HEAPF32[i3 + (i4 << 5) >> 2]);
 f13 = Math_fround(HEAPF32[i3 + (i4 << 5) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + (i4 << 5) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + (i4 << 5) + 12 >> 2]);
 i73 = HEAP32[i3 + (i4 << 5) + 16 >> 2] | 0;
 f63 = Math_fround(HEAPF32[i2 + (i73 << 6) >> 2]);
 f72 = Math_fround(HEAPF32[i2 + (i73 << 6) + 4 >> 2]);
 f69 = Math_fround(HEAPF32[i2 + (i73 << 6) + 8 >> 2]);
 f66 = Math_fround(HEAPF32[i2 + (i73 << 6) + 12 >> 2]);
 f47 = Math_fround(HEAPF32[i2 + (i73 << 6) + 16 >> 2]);
 f56 = Math_fround(HEAPF32[i2 + (i73 << 6) + 20 >> 2]);
 f53 = Math_fround(HEAPF32[i2 + (i73 << 6) + 24 >> 2]);
 f50 = Math_fround(HEAPF32[i2 + (i73 << 6) + 28 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + (i73 << 6) + 32 >> 2]);
 f40 = Math_fround(HEAPF32[i2 + (i73 << 6) + 36 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + (i73 << 6) + 40 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + (i73 << 6) + 44 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + (i73 << 6) + 48 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + (i73 << 6) + 52 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + (i73 << 6) + 56 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + (i73 << 6) + 60 >> 2]);
 i73 = HEAP32[i3 + (i4 << 5) + 20 >> 2] | 0;
 f62 = Math_fround(HEAPF32[i2 + (i73 << 6) >> 2]);
 f71 = Math_fround(HEAPF32[i2 + (i73 << 6) + 4 >> 2]);
 f68 = Math_fround(HEAPF32[i2 + (i73 << 6) + 8 >> 2]);
 f65 = Math_fround(HEAPF32[i2 + (i73 << 6) + 12 >> 2]);
 f46 = Math_fround(HEAPF32[i2 + (i73 << 6) + 16 >> 2]);
 f55 = Math_fround(HEAPF32[i2 + (i73 << 6) + 20 >> 2]);
 f52 = Math_fround(HEAPF32[i2 + (i73 << 6) + 24 >> 2]);
 f49 = Math_fround(HEAPF32[i2 + (i73 << 6) + 28 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + (i73 << 6) + 32 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + (i73 << 6) + 36 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + (i73 << 6) + 40 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + (i73 << 6) + 44 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + (i73 << 6) + 48 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + (i73 << 6) + 52 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + (i73 << 6) + 56 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + (i73 << 6) + 60 >> 2]);
 i73 = HEAP32[i3 + (i4 << 5) + 24 >> 2] | 0;
 f61 = Math_fround(HEAPF32[i2 + (i73 << 6) >> 2]);
 f70 = Math_fround(HEAPF32[i2 + (i73 << 6) + 4 >> 2]);
 f67 = Math_fround(HEAPF32[i2 + (i73 << 6) + 8 >> 2]);
 f64 = Math_fround(HEAPF32[i2 + (i73 << 6) + 12 >> 2]);
 f45 = Math_fround(HEAPF32[i2 + (i73 << 6) + 16 >> 2]);
 f54 = Math_fround(HEAPF32[i2 + (i73 << 6) + 20 >> 2]);
 f51 = Math_fround(HEAPF32[i2 + (i73 << 6) + 24 >> 2]);
 f48 = Math_fround(HEAPF32[i2 + (i73 << 6) + 28 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + (i73 << 6) + 32 >> 2]);
 f38 = Math_fround(HEAPF32[i2 + (i73 << 6) + 36 >> 2]);
 f35 = Math_fround(HEAPF32[i2 + (i73 << 6) + 40 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + (i73 << 6) + 44 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + (i73 << 6) + 48 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + (i73 << 6) + 52 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + (i73 << 6) + 56 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + (i73 << 6) + 60 >> 2]);
 i4 = HEAP32[i3 + (i4 << 5) + 28 >> 2] | 0;
 f60 = Math_fround(HEAPF32[i2 + (i4 << 6) >> 2]);
 f59 = Math_fround(HEAPF32[i2 + (i4 << 6) + 4 >> 2]);
 f58 = Math_fround(HEAPF32[i2 + (i4 << 6) + 8 >> 2]);
 f57 = Math_fround(HEAPF32[i2 + (i4 << 6) + 12 >> 2]);
 f44 = Math_fround(HEAPF32[i2 + (i4 << 6) + 16 >> 2]);
 f43 = Math_fround(HEAPF32[i2 + (i4 << 6) + 20 >> 2]);
 f42 = Math_fround(HEAPF32[i2 + (i4 << 6) + 24 >> 2]);
 f41 = Math_fround(HEAPF32[i2 + (i4 << 6) + 28 >> 2]);
 f28 = Math_fround(HEAPF32[i2 + (i4 << 6) + 32 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + (i4 << 6) + 36 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + (i4 << 6) + 40 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + (i4 << 6) + 44 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + (i4 << 6) + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + (i4 << 6) + 52 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + (i4 << 6) + 56 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + (i4 << 6) + 60 >> 2]);
 f59 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f72) + Math_fround(f13 * f71)) + Math_fround(f11 * f70)) + Math_fround(f9 * f59));
 f58 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f69) + Math_fround(f13 * f68)) + Math_fround(f11 * f67)) + Math_fround(f9 * f58));
 f57 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f66) + Math_fround(f13 * f65)) + Math_fround(f11 * f64)) + Math_fround(f9 * f57));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f63) + Math_fround(f13 * f62)) + Math_fround(f11 * f61)) + Math_fround(f9 * f60));
 HEAPF32[i1 + 4 >> 2] = f59;
 HEAPF32[i1 + 8 >> 2] = f58;
 HEAPF32[i1 + 12 >> 2] = f57;
 f43 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f56) + Math_fround(f13 * f55)) + Math_fround(f11 * f54)) + Math_fround(f9 * f43));
 f42 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f53) + Math_fround(f13 * f52)) + Math_fround(f11 * f51)) + Math_fround(f9 * f42));
 f41 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f50) + Math_fround(f13 * f49)) + Math_fround(f11 * f48)) + Math_fround(f9 * f41));
 HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f47) + Math_fround(f13 * f46)) + Math_fround(f11 * f45)) + Math_fround(f9 * f44));
 HEAPF32[i1 + 20 >> 2] = f43;
 HEAPF32[i1 + 24 >> 2] = f42;
 HEAPF32[i1 + 28 >> 2] = f41;
 f27 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f40) + Math_fround(f13 * f39)) + Math_fround(f11 * f38)) + Math_fround(f9 * f27));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f37) + Math_fround(f13 * f36)) + Math_fround(f11 * f35)) + Math_fround(f9 * f26));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f34) + Math_fround(f13 * f33)) + Math_fround(f11 * f32)) + Math_fround(f9 * f25));
 HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f31) + Math_fround(f13 * f30)) + Math_fround(f11 * f29)) + Math_fround(f9 * f28));
 HEAPF32[i1 + 36 >> 2] = f27;
 HEAPF32[i1 + 40 >> 2] = f26;
 HEAPF32[i1 + 44 >> 2] = f25;
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(f13 * f23)) + Math_fround(f11 * f22)) + Math_fround(f9 * f7));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f21) + Math_fround(f13 * f20)) + Math_fround(f11 * f19)) + Math_fround(f9 * f6));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(f13 * f17)) + Math_fround(f11 * f16)) + Math_fround(f9 * f5));
 HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12)) + Math_fround(f11 * f10)) + Math_fround(f9 * f8));
 HEAPF32[i1 + 52 >> 2] = f7;
 HEAPF32[i1 + 56 >> 2] = f6;
 HEAPF32[i1 + 60 >> 2] = f5;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj(i22, i1, i21, i13) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23 + 48 | 0;
 i11 = i23 + 32 | 0;
 i16 = i23 + 16 | 0;
 i17 = i23;
 i18 = i22 + 408 | 0;
 i3 = i22 + 412 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i20 = i19 - i1 >> 4;
 i15 = i21 - i13 + i2 + i20 | 0;
 if (!(i15 | i2)) {
  STACKTOP = i23;
  return;
 }
 if (!i2) {
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i18, i20);
  i2 = HEAP32[i18 >> 2] | 0;
  i21 = HEAP32[i3 >> 2] | 0;
  i3 = i2 + (i21 << 4) | 0;
  if ((i21 | 0) > 0) while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i2 = i2 + 16 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 16 | 0;
  }
 } else {
  i8 = i15 >>> 0 > i2 >>> 0 ? i15 : i2;
  i4 = HEAP32[i22 + 416 >> 2] & 2147483647;
  i14 = i22 + 420 | 0;
  i9 = i22 + 428 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i7 = i3 & 2147483647;
  if (i8 >>> 0 > (i4 >>> 0 < i7 >>> 0 ? i4 : i7) >>> 0) {
   if (i4 >>> 0 < i15 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i18, i15);
    i3 = HEAP32[i9 >> 2] | 0;
   }
   if ((i3 & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i14, i8);
  }
  i6 = i22 + 424 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  L16 : do if (i3 >>> 0 < i2 >>> 0) {
   i7 = i3;
   while (1) {
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = i4 + (i3 << 4) | 0;
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
     i24 = HEAP32[i14 >> 2] | 0;
     HEAP32[i24 + (i7 << 4) >> 2] = HEAP32[i5 >> 2];
     HEAP32[i24 + (i7 << 4) + 4 >> 2] = HEAP32[i4 + (i3 << 4) + 4 >> 2];
     HEAP32[i24 + (i7 << 4) + 8 >> 2] = HEAP32[i4 + (i3 << 4) + 8 >> 2];
     HEAP32[i24 + (i7 << 4) + 12 >> 2] = HEAP32[i4 + (i3 << 4) + 12 >> 2];
     HEAP32[i6 >> 2] = i7 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i14, i5) | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i2 | 0)) break L16;
    i7 = HEAP32[i6 >> 2] | 0;
   }
  } while (0);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i18, i8, i10);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i14, i8, i11);
  i11 = i15 - i2 | 0;
  if ((i15 | 0) != (i2 | 0)) {
   i9 = HEAP32[i18 >> 2] | 0;
   i7 = i11 + i13 | 0;
   i8 = i7 >>> 0 > i13 >>> 0;
   i6 = i2 >>> 0 > i13 >>> 0;
   if (i8) if (i6) {
    i3 = i2;
    i4 = i15;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + -1 | 0;
     HEAP32[i9 + (i4 << 4) >> 2] = HEAP32[i9 + (i3 << 4) >> 2];
     HEAP32[i9 + (i4 << 4) + 4 >> 2] = HEAP32[i9 + (i3 << 4) + 4 >> 2];
     HEAP32[i9 + (i4 << 4) + 8 >> 2] = HEAP32[i9 + (i3 << 4) + 8 >> 2];
     HEAP32[i9 + (i4 << 4) + 12 >> 2] = HEAP32[i9 + (i3 << 4) + 12 >> 2];
    } while (i3 >>> 0 > i13 >>> 0);
    i12 = 23;
   } else i12 = 29; else if (i6) {
    i3 = i13;
    i4 = i7;
    while (1) {
     HEAP32[i9 + (i4 << 4) >> 2] = HEAP32[i9 + (i3 << 4) >> 2];
     HEAP32[i9 + (i4 << 4) + 4 >> 2] = HEAP32[i9 + (i3 << 4) + 4 >> 2];
     HEAP32[i9 + (i4 << 4) + 8 >> 2] = HEAP32[i9 + (i3 << 4) + 8 >> 2];
     HEAP32[i9 + (i4 << 4) + 12 >> 2] = HEAP32[i9 + (i3 << 4) + 12 >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i2 | 0)) {
      i12 = 23;
      break;
     } else i4 = i4 + 1 | 0;
    }
   }
   do if ((i12 | 0) == 23) {
    i5 = HEAP32[i14 >> 2] | 0;
    if (i8) {
     if (i6) i3 = i15; else {
      i12 = 29;
      break;
     }
     do {
      i3 = i3 + -1 | 0;
      i2 = i2 + -1 | 0;
      HEAP32[i5 + (i3 << 4) >> 2] = HEAP32[i5 + (i2 << 4) >> 2];
      HEAP32[i5 + (i3 << 4) + 4 >> 2] = HEAP32[i5 + (i2 << 4) + 4 >> 2];
      HEAP32[i5 + (i3 << 4) + 8 >> 2] = HEAP32[i5 + (i2 << 4) + 8 >> 2];
      HEAP32[i5 + (i3 << 4) + 12 >> 2] = HEAP32[i5 + (i2 << 4) + 12 >> 2];
     } while (i2 >>> 0 > i13 >>> 0);
    } else {
     if (i6) {
      i4 = i13;
      i3 = i7;
     } else break;
     while (1) {
      HEAP32[i5 + (i3 << 4) >> 2] = HEAP32[i5 + (i4 << 4) >> 2];
      HEAP32[i5 + (i3 << 4) + 4 >> 2] = HEAP32[i5 + (i4 << 4) + 4 >> 2];
      HEAP32[i5 + (i3 << 4) + 8 >> 2] = HEAP32[i5 + (i4 << 4) + 8 >> 2];
      HEAP32[i5 + (i3 << 4) + 12 >> 2] = HEAP32[i5 + (i4 << 4) + 12 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i2 | 0)) break; else i3 = i3 + 1 | 0;
     }
    }
    if (i8) i12 = 29;
   } while (0);
   if ((i12 | 0) == 29) {
    i2 = i20 + i21 | 0;
    i3 = i13;
    do {
     i24 = i3 - i21 | 0;
     HEAP32[i9 + (i3 << 4) >> 2] = HEAP32[i1 + (i24 << 4) >> 2];
     HEAP32[i9 + (i3 << 4) + 4 >> 2] = HEAP32[i1 + (i24 << 4) + 4 >> 2];
     HEAP32[i9 + (i3 << 4) + 8 >> 2] = HEAP32[i1 + (i24 << 4) + 8 >> 2];
     HEAP32[i9 + (i3 << 4) + 12 >> 2] = HEAP32[i1 + (i24 << 4) + 12 >> 2];
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i2 | 0));
   }
   i10 = (i11 | 0) < 0;
   i2 = 1 << (i10 ? i11 : 0) + i13;
   i6 = i2 + -1 | 0;
   i7 = HEAP32[i22 + 396 >> 2] | 0;
   i8 = i22 + 400 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   L50 : do if (i3 | 0) {
    i9 = 0 - i11 | 0;
    i5 = 0 - i2 | 0;
    i3 = i7 + (i3 << 2) | 0;
    i4 = i7;
    do {
     i2 = HEAP32[i4 >> 2] | 0;
     L54 : do if (i10) while (1) {
      i2 = i2 >>> i9 & i5 | i2 & i6;
      if (i2 | 0) break L54;
      i2 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
      HEAP32[i8 >> 2] = i2;
      i2 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
      HEAP32[i4 >> 2] = i2;
      i3 = i7 + (HEAP32[i8 >> 2] << 2) | 0;
      if ((i4 | 0) == (i3 | 0)) break L50;
     } else while (1) {
      i2 = (i2 & i5) << i11 | i2 & i6;
      if (i2 | 0) break L54;
      i2 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
      HEAP32[i8 >> 2] = i2;
      i2 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
      HEAP32[i4 >> 2] = i2;
      i3 = i7 + (HEAP32[i8 >> 2] << 2) | 0;
      if ((i4 | 0) == (i3 | 0)) break L50;
     } while (0);
     HEAP32[i4 >> 2] = i2;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i3 | 0));
   } while (0);
   __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i18, i15, i16);
   __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i14, i15, i17);
  }
  if ((i19 | 0) != (i1 | 0)) {
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = 0;
   do {
    i24 = i3 + i21 | 0;
    HEAP32[i2 + (i24 << 4) >> 2] = HEAP32[i1 + (i3 << 4) >> 2];
    HEAP32[i2 + (i24 << 4) + 4 >> 2] = HEAP32[i1 + (i3 << 4) + 4 >> 2];
    HEAP32[i2 + (i24 << 4) + 8 >> 2] = HEAP32[i1 + (i3 << 4) + 8 >> 2];
    HEAP32[i2 + (i24 << 4) + 12 >> 2] = HEAP32[i1 + (i3 << 4) + 12 >> 2];
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i20 >>> 0);
  }
 }
 HEAP32[i22 + 540 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZNK5physx2Sq10AABBPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE(i21, i19, i18) {
 i21 = i21 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 64 | 0;
 i1 = i22 + 260 | 0;
 i8 = i22 + 32 | 0;
 i4 = i22 + 259 | 0;
 i16 = i22 + 258 | 0;
 i9 = i22;
 i5 = i22 + 257 | 0;
 i6 = i22 + 256 | 0;
 i17 = i21 + 4 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 L1 : do if (i7 | 0) {
  i15 = HEAP32[i19 + 144 >> 2] | 0;
  switch (HEAP32[i15 >> 2] | 0) {
  case 3:
   if (Math_fround(Math_abs(Math_fround(HEAPF32[i19 + 68 >> 2]))) < Math_fround(.999998986)) {
    __ZN5physx2Gu12OBBAABBTestsILb1EEC2ERKNS_11PxTransformERKNS_13PxBoxGeometryEf(i20, i19 + 56 | 0, i19, Math_fround(1.00999999));
    if (__ZN15AABBTreeOverlapIN5physx2Gu12OBBAABBTestsILb1EEEEclEPNS0_2Sq13PrunerPayloadERKNS5_8AABBTreeERKS3_RNS5_14PrunerCallbackE(i1, HEAP32[i21 + 7776 >> 2] | 0, HEAP32[i17 >> 2] | 0, i20, i18) | 0) break L1; else i1 = 0;
    STACKTOP = i22;
    return i1 | 0;
   } else {
    f12 = Math_fround(HEAPF32[i19 + 120 >> 2]);
    f11 = Math_fround(HEAPF32[i19 + 132 >> 2]);
    f24 = Math_fround(f12 + f11);
    f13 = Math_fround(HEAPF32[i19 + 124 >> 2]);
    f3 = Math_fround(HEAPF32[i19 + 136 >> 2]);
    f23 = Math_fround(f13 + f3);
    f14 = Math_fround(HEAPF32[i19 + 128 >> 2]);
    f10 = Math_fround(HEAPF32[i19 + 140 >> 2]);
    f23 = Math_fround(f23 * Math_fround(.5));
    f2 = Math_fround(Math_fround(f14 + f10) * Math_fround(.5));
    HEAPF32[i8 >> 2] = Math_fround(f24 * Math_fround(.5));
    HEAPF32[i8 + 4 >> 2] = f23;
    HEAPF32[i8 + 8 >> 2] = f2;
    HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
    f13 = Math_fround(Math_fround(f3 - f13) * Math_fround(.5));
    f14 = Math_fround(Math_fround(f10 - f14) * Math_fround(.5));
    HEAPF32[i8 + 16 >> 2] = Math_fround(Math_fround(f11 - f12) * Math_fround(.5));
    HEAPF32[i8 + 20 >> 2] = f13;
    HEAPF32[i8 + 24 >> 2] = f14;
    HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
    if (__ZN15AABBTreeOverlapIN5physx2Gu12AABBAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i4, HEAP32[i21 + 7776 >> 2] | 0, i7, i8, i18) | 0) break L1; else i1 = 0;
    STACKTOP = i22;
    return i1 | 0;
   }
  case 2:
   {
    f12 = Math_fround(HEAPF32[i19 + 56 >> 2]);
    f13 = Math_fround(f12 * Math_fround(2.0));
    f2 = Math_fround(HEAPF32[i19 + 68 >> 2]);
    f11 = Math_fround(f2 * Math_fround(2.0));
    f2 = Math_fround(Math_fround(f12 * f13) + Math_fround(Math_fround(f2 * f11) + Math_fround(-1.0)));
    f12 = Math_fround(HEAPF32[i19 + 64 >> 2]);
    f3 = Math_fround(f12 * f11);
    f10 = Math_fround(HEAPF32[i19 + 60 >> 2]);
    f3 = Math_fround(f3 + Math_fround(f13 * f10));
    f10 = Math_fround(Math_fround(f13 * f12) - Math_fround(f11 * f10));
    f11 = Math_fround(HEAPF32[i15 + 8 >> 2]);
    f12 = Math_fround(f11 * f2);
    f13 = Math_fround(f11 * f3);
    f14 = Math_fround(f11 * f10);
    f12 = Math_fround(Math_fround(HEAPF32[i19 + 72 >> 2]) - f12);
    f13 = Math_fround(Math_fround(HEAPF32[i19 + 76 >> 2]) - f13);
    f14 = Math_fround(Math_fround(HEAPF32[i19 + 80 >> 2]) - f14);
    f11 = Math_fround(f11 * Math_fround(2.0));
    f24 = Math_fround(Math_fround(HEAPF32[i15 + 4 >> 2]) * Math_fround(1.00999999));
    HEAPF32[i20 >> 2] = f12;
    HEAPF32[i20 + 4 >> 2] = f13;
    HEAPF32[i20 + 8 >> 2] = f14;
    HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i20 + 16 >> 2] = f2;
    HEAPF32[i20 + 20 >> 2] = f3;
    HEAPF32[i20 + 24 >> 2] = f10;
    HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i20 + 32 >> 2] = f3;
    HEAPF32[i20 + 36 >> 2] = f10;
    HEAPF32[i20 + 40 >> 2] = f2;
    HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
    HEAPF32[i20 + 48 >> 2] = f24;
    HEAPF32[i20 + 52 >> 2] = f24;
    HEAPF32[i20 + 56 >> 2] = f24;
    HEAPF32[i20 + 60 >> 2] = Math_fround(0.0);
    f24 = Math_fround(-f2);
    f25 = Math_fround(-f3);
    f23 = Math_fround(-f10);
    f24 = f2 > f24 ? f2 : f24;
    f25 = f3 > f25 ? f3 : f25;
    f23 = f10 > f23 ? f10 : f23;
    HEAPF32[i20 + 64 >> 2] = f24;
    HEAPF32[i20 + 68 >> 2] = f25;
    HEAPF32[i20 + 72 >> 2] = f23;
    HEAPF32[i20 + 76 >> 2] = Math_fround(0.0);
    HEAPF32[i20 + 80 >> 2] = f25;
    HEAPF32[i20 + 84 >> 2] = f23;
    HEAPF32[i20 + 88 >> 2] = f24;
    HEAPF32[i20 + 92 >> 2] = Math_fround(0.0);
    if (!(f11 >= Math_fround(3402823469999999843913219.0e14))) {
     f10 = Math_fround(Math_fround(f10 * f11) + f14);
     f3 = Math_fround(Math_fround(f3 * f11) + f13);
     f2 = Math_fround(Math_fround(f2 * f11) + f12);
    } else {
     i15 = f2 == Math_fround(0.0);
     i9 = f2 >= Math_fround(0.0);
     f2 = i9 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
     f2 = i15 ? f12 : f2;
     i15 = f3 == Math_fround(0.0);
     i9 = f3 >= Math_fround(0.0);
     f3 = i9 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
     f3 = i15 ? f13 : f3;
     if (f10 == Math_fround(0.0)) f10 = f14; else {
      i15 = f10 >= Math_fround(0.0);
      f10 = i15 ? Math_fround(3402823469999999843913219.0e14) : Math_fround(-3402823469999999843913219.0e14);
     }
    }
    HEAPF32[i20 + 96 >> 2] = f12 < f2 ? f12 : f2;
    HEAPF32[i20 + 100 >> 2] = f13 < f3 ? f13 : f3;
    HEAPF32[i20 + 104 >> 2] = f14 < f10 ? f14 : f10;
    HEAPF32[i20 + 108 >> 2] = Math_fround(0.0);
    HEAPF32[i20 + 112 >> 2] = f12 > f2 ? f12 : f2;
    HEAPF32[i20 + 116 >> 2] = f13 > f3 ? f13 : f3;
    HEAPF32[i20 + 120 >> 2] = f14 > f10 ? f14 : f10;
    HEAPF32[i20 + 124 >> 2] = Math_fround(0.0);
    if (__ZN15AABBTreeOverlapIN5physx2Gu15CapsuleAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i16, HEAP32[i21 + 7776 >> 2] | 0, HEAP32[i17 >> 2] | 0, i20, i18) | 0) break L1; else i1 = 0;
    STACKTOP = i22;
    return i1 | 0;
   }
  case 0:
   {
    f25 = Math_fround(HEAPF32[i19 + 160 >> 2]);
    i17 = HEAP32[i19 + 152 >> 2] | 0;
    i20 = HEAP32[i19 + 156 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i19 + 148 >> 2];
    HEAP32[i9 + 4 >> 2] = i17;
    HEAP32[i9 + 8 >> 2] = i20;
    HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i9 + 16 >> 2] = Math_fround(f25 * f25);
    if (__ZN15AABBTreeOverlapIN5physx2Gu14SphereAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i5, HEAP32[i21 + 7776 >> 2] | 0, i7, i9, i18) | 0) break L1; else i1 = 0;
    STACKTOP = i22;
    return i1 | 0;
   }
  case 4:
   {
    __ZN5physx2Gu12OBBAABBTestsILb1EEC2ERKNS_11PxTransformERKNS_13PxBoxGeometryEf(i20, i19 + 56 | 0, i19, Math_fround(1.00999999));
    if (__ZN15AABBTreeOverlapIN5physx2Gu12OBBAABBTestsILb1EEEEclEPNS0_2Sq13PrunerPayloadERKNS5_8AABBTreeERKS3_RNS5_14PrunerCallbackE(i6, HEAP32[i21 + 7776 >> 2] | 0, HEAP32[i17 >> 2] | 0, i20, i18) | 0) break L1; else i1 = 0;
    STACKTOP = i22;
    return i1 | 0;
   }
  default:
   break L1;
  }
 } while (0);
 if (!(HEAP8[i21 + 7808 >> 0] | 0)) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (!(HEAP32[i21 + 92 >> 2] | 0)) if (!(HEAP32[i21 + 136 >> 2] | 0)) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i21 = __ZNK5physx2Sq16BucketPrunerCore7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE(i21 + 144 | 0, i19, i18) | 0;
 STACKTOP = i22;
 return i21 | 0;
}

function __Z16Projector_RenderRK15RenderNodeQueuejR17ShaderPassContext(i30, i1, i31) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i35 + 128 | 0;
 i32 = i35 + 64 | 0;
 i33 = i35;
 i27 = HEAP32[(HEAP32[i30 >> 2] | 0) + (i1 * 360 | 0) + 328 >> 2] | 0;
 i28 = HEAP32[i27 + 276 >> 2] | 0;
 i25 = HEAP32[i27 + 272 >> 2] | 0;
 i26 = __Z12GetGfxDevicev() | 0;
 i1 = i32;
 i2 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 132 >> 2] | 0, i26 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i33;
 i2 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 128 >> 2] | 0, i26 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 if (!i25) {
  i34 = HEAP32[i26 >> 2] | 0;
  i34 = i34 + 112 | 0;
  i34 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(i34 | 0, i26 | 0, i32 | 0);
  i34 = HEAP32[i26 >> 2] | 0;
  i34 = i34 + 108 | 0;
  i34 = HEAP32[i34 >> 2] | 0;
  mftCall_vii(i34 | 0, i26 | 0, i33 | 0);
  STACKTOP = i35;
  return;
 }
 i12 = i27 + 4 | 0;
 i13 = i27 + 68 | 0;
 i14 = i27 + 132 | 0;
 i15 = i27 + 268 | 0;
 i16 = i31 + 4 | 0;
 i17 = i31 + 8 | 0;
 i18 = i31 + 12 | 0;
 i19 = i31 + 16 | 0;
 i20 = i31 + 20 | 0;
 i21 = i31 + 24 | 0;
 i22 = i31 + 28 | 0;
 i23 = i31 + 32 | 0;
 i24 = i27 + 264 | 0;
 i11 = 0;
 do {
  i6 = HEAP32[i28 + (i11 << 2) >> 2] | 0;
  i1 = HEAP32[i30 >> 2] | 0;
  i7 = HEAP32[i1 + (i6 * 360 | 0) + 176 >> 2] | 0;
  i8 = i1 + (i6 * 360 | 0) | 0;
  i10 = __Z12GetGfxDevicev() | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i12, i8, i10 + 2468 | 0);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i13, i8, i10 + 2532 | 0);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i14, i8, i10 + 2596 | 0);
  i10 = __Z12GetGfxDevicev() | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0, i8 | 0, i7 | 0);
  i7 = HEAP32[i1 + (i6 * 360 | 0) + 244 >> 2] | 0;
  i8 = HEAP32[i1 + (i6 * 360 | 0) + 324 >> 2] | 0;
  L6 : do if ((HEAP32[i15 >> 2] | 0) > 0) {
   i9 = i1 + (i6 * 360 | 0) + 332 | 0;
   i10 = i1 + (i6 * 360 | 0) + 182 | 0;
   i4 = i1 + (i6 * 360 | 0) + 180 | 0;
   if ((i7 | 0) > 0) i2 = 0; else {
    i1 = 0;
    while (1) {
     i9 = HEAP32[i27 >> 2] | 0;
     i2 = HEAP32[i9 + 124 >> 2] | 0;
     i3 = HEAP32[i9 + 128 >> 2] | 0;
     i4 = HEAP32[i9 + 132 >> 2] | 0;
     i5 = HEAP32[i9 + 136 >> 2] | 0;
     i6 = HEAP32[i9 + 140 >> 2] | 0;
     i7 = HEAP32[i9 + 144 >> 2] | 0;
     i8 = HEAP32[i9 + 148 >> 2] | 0;
     i10 = HEAP32[i9 + 152 >> 2] | 0;
     HEAP32[i29 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i29 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i29 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     HEAP32[i29 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
     HEAP32[i29 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
     HEAP32[i29 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
     HEAP32[i29 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
     HEAP32[i29 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | i2;
     HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i3;
     HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | i4;
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i5;
     HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i6;
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i7;
     HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i8;
     HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i10;
     i10 = HEAP32[i9 + 8 >> 2] | 0;
     __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[HEAP32[(HEAP32[HEAP32[i10 + 32 >> 2] >> 2] | 0) + (HEAP32[i24 >> 2] << 2) >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0, HEAP32[i9 + 160 >> 2] | 0, i9 + 12 | 0, i31, i10, i1, 0, 0) | 0;
     HEAP32[i16 >> 2] = HEAP32[i29 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
     HEAP32[i16 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
     HEAP32[i16 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
     HEAP32[i16 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
     HEAP32[i16 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
     HEAP32[i16 + 28 >> 2] = HEAP32[i29 + 28 >> 2];
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (HEAP32[i15 >> 2] | 0)) break L6;
    }
   }
   do {
    i3 = HEAP32[i27 >> 2] | 0;
    i41 = HEAP32[i3 + 124 >> 2] | 0;
    i40 = HEAP32[i3 + 128 >> 2] | 0;
    i39 = HEAP32[i3 + 132 >> 2] | 0;
    i38 = HEAP32[i3 + 136 >> 2] | 0;
    i37 = HEAP32[i3 + 140 >> 2] | 0;
    i36 = HEAP32[i3 + 144 >> 2] | 0;
    i1 = HEAP32[i3 + 148 >> 2] | 0;
    i5 = HEAP32[i3 + 152 >> 2] | 0;
    HEAP32[i29 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
    HEAP32[i29 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
    HEAP32[i29 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
    HEAP32[i29 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | i41;
    HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i40;
    HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | i39;
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i38;
    HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i37;
    HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i36;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i1;
    HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | i5;
    i5 = HEAP32[i3 + 8 >> 2] | 0;
    i5 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[HEAP32[(HEAP32[HEAP32[i5 + 32 >> 2] >> 2] | 0) + (HEAP32[i24 >> 2] << 2) >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0, HEAP32[i3 + 160 >> 2] | 0, i3 + 12 | 0, i31, i5, i2, 0, 0) | 0;
    HEAP32[i16 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
    HEAP32[i16 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
    HEAP32[i16 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
    HEAP32[i16 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
    HEAP32[i16 + 28 >> 2] = HEAP32[i29 + 28 >> 2];
    if (i5 | 0) {
     i3 = 0;
     do {
      i1 = HEAP32[i8 + (i3 << 3) >> 2] | 0;
      if (!i1) i34 = 10; else {
       i1 = HEAP32[i1 + 8 >> 2] | 0;
       if (!i1) i34 = 10; else if (!(HEAP8[(HEAP32[i1 + 32 >> 2] | 0) + 60 >> 0] | 0)) i34 = 10;
      }
      if ((i34 | 0) == 10) {
       i34 = 0;
       i40 = HEAP16[i10 >> 1] | 0;
       i41 = i40 & 65535;
       mftCall_viiii(HEAP32[i9 >> 2] | 0, i30 | 0, i6 | 0, i5 | 0, (i40 << 16 >> 16 == 0 | (i41 | 0) > (i3 | 0) ? i3 : i41 + -1 | 0) + (HEAPU16[i4 >> 1] | 0) | 0);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i15 >> 2] | 0));
  } while (0);
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i25 | 0));
 i41 = HEAP32[i26 >> 2] | 0;
 i41 = i41 + 112 | 0;
 i41 = HEAP32[i41 >> 2] | 0;
 mftCall_vii(i41 | 0, i26 | 0, i32 | 0);
 i41 = HEAP32[i26 >> 2] | 0;
 i41 = i41 + 108 | 0;
 i41 = HEAP32[i41 >> 2] | 0;
 mftCall_vii(i41 | 0, i26 | 0, i33 | 0);
 STACKTOP = i35;
 return;
}

function __ZNK9dtNavMesh19queryPolygonsInTileEPK10dtMeshTilePKfS4_P15dtQueryCallback(i3, i27, i1, i2, i28) {
 i3 = i3 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i28 = i28 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i31;
 i30 = i31 + 256 | 0;
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(f34 - f22);
 f33 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f24 = Math_fround(f33 - f23);
 f32 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(f32 - f26);
 f22 = Math_fround(f34 + f22);
 f23 = Math_fround(f33 + f23);
 f26 = Math_fround(f32 + f26);
 i2 = HEAP32[i27 + 36 >> 2] | 0;
 if (!i2) {
  i18 = (i27 - (HEAP32[i3 + 20 >> 2] | 0) | 0) / 56 | 0;
  i16 = _bitshift64Shl(HEAP32[i27 + 4 >> 2] | 0, 0, 48) | 0;
  i17 = getTempRet0() | 0;
  i18 = _bitshift64Shl(i18 | 0, 0, 20) | 0;
  i16 = i18 | i16;
  i17 = getTempRet0() | 0 | i17;
  i18 = i27 + 8 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  if ((HEAP32[i1 + 20 >> 2] | 0) <= 0) {
   STACKTOP = i31;
   return;
  }
  i19 = i27 + 16 | 0;
  i20 = i27 + 20 | 0;
  i15 = 0;
  i2 = 0;
  do {
   i12 = HEAP32[i19 >> 2] | 0;
   i14 = i12 + (i15 << 5) | 0;
   i13 = HEAP32[i20 >> 2] | 0;
   i5 = i13 + ((HEAPU16[i14 >> 1] | 0) * 3 << 2) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i5 + 4 >> 2] | 0;
   i5 = HEAP32[i5 + 8 >> 2] | 0;
   i3 = HEAP8[i12 + (i15 << 5) + 28 >> 0] | 0;
   if ((i3 & 255) > 1) {
    i11 = i3 & 255;
    i10 = 1;
    i8 = i4;
    i7 = i4;
    i6 = i5;
    i4 = i9;
    i3 = i9;
    do {
     i9 = i13 + ((HEAPU16[i12 + (i15 << 5) + (i10 << 1) >> 1] | 0) * 3 << 2) | 0;
     f35 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f32 = Math_fround(HEAPF32[i9 >> 2]);
     i7 = (HEAPF32[tempDoublePtr >> 2] = f35 < f32 ? f35 : f32, HEAP32[tempDoublePtr >> 2] | 0);
     f35 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f33 = Math_fround(HEAPF32[i9 + 4 >> 2]);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f35 < f33 ? f35 : f33, HEAP32[tempDoublePtr >> 2] | 0);
     f35 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f34 = Math_fround(HEAPF32[i9 + 8 >> 2]);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f35 < f34 ? f35 : f34, HEAP32[tempDoublePtr >> 2] | 0);
     f35 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i8 = (HEAPF32[tempDoublePtr >> 2] = f35 > f32 ? f35 : f32, HEAP32[tempDoublePtr >> 2] | 0);
     f32 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i4 = (HEAPF32[tempDoublePtr >> 2] = f32 > f33 ? f32 : f33, HEAP32[tempDoublePtr >> 2] | 0);
     f33 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i6 = (HEAPF32[tempDoublePtr >> 2] = f33 > f34 ? f33 : f34, HEAP32[tempDoublePtr >> 2] | 0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) < (i11 | 0));
   } else {
    i8 = i4;
    i7 = i4;
    i6 = i5;
    i4 = i9;
    i3 = i9;
   }
   f35 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i13 = !(f22 < (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & !(f25 > f35);
   f35 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i13 = !(f23 < (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & !(f24 > f35) & i13;
   i12 = f21 > (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f26 < (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) | i12 | i13 ^ 1)) {
    if ((i2 | 0) > 31) {
     mftCall_viiiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i27 | 0, i29 | 0, i30 | 0, i2 | 0);
     i2 = 0;
     i1 = HEAP32[i18 >> 2] | 0;
    }
    i13 = i29 + (i2 << 3) | 0;
    HEAP32[i13 >> 2] = i16 | i15;
    HEAP32[i13 + 4 >> 2] = i17;
    HEAP32[i30 + (i2 << 2) >> 2] = i14;
    i2 = i2 + 1 | 0;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) < (HEAP32[i1 + 20 >> 2] | 0));
  if ((i2 | 0) <= 0) {
   STACKTOP = i31;
   return;
  }
  mftCall_viiiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i27 | 0, i29 | 0, i30 | 0, i2 | 0);
  STACKTOP = i31;
  return;
 }
 i12 = HEAP32[i27 + 8 >> 2] | 0;
 i20 = HEAP32[i12 + 40 >> 2] | 0;
 i16 = i2 + (i20 + -1 << 4) | 0;
 f33 = Math_fround(HEAPF32[i12 + 68 >> 2]);
 f39 = Math_fround(HEAPF32[i12 + 44 >> 2]);
 f40 = Math_fround(HEAPF32[i12 + 56 >> 2]);
 f37 = Math_fround((f25 < f39 ? f39 : f25 > f40 ? f40 : f25) - f39);
 f32 = Math_fround(HEAPF32[i12 + 48 >> 2]);
 f38 = Math_fround(HEAPF32[i12 + 60 >> 2]);
 f36 = Math_fround((f24 < f32 ? f32 : f24 > f38 ? f38 : f24) - f32);
 f35 = Math_fround(HEAPF32[i12 + 52 >> 2]);
 f34 = Math_fround(HEAPF32[i12 + 64 >> 2]);
 f24 = Math_fround((f21 < f35 ? f35 : f21 > f34 ? f34 : f21) - f35);
 f25 = Math_fround((f22 < f39 ? f39 : f22 > f40 ? f40 : f22) - f39);
 f32 = Math_fround((f23 < f32 ? f32 : f23 > f38 ? f38 : f23) - f32);
 i12 = ~~Math_fround(f33 * f37) & 65534;
 i13 = ~~Math_fround(f33 * f36) & 65534;
 i14 = ~~Math_fround(f33 * f24) & 65534;
 i15 = (~~Math_fround(Math_fround(f33 * f25) + Math_fround(1.0)) & 65535 | 1) & 65535;
 i11 = (~~Math_fround(Math_fround(f33 * f32) + Math_fround(1.0)) & 65535 | 1) & 65535;
 i10 = (~~Math_fround(Math_fround(f33 * Math_fround((f26 < f35 ? f35 : f26 > f34 ? f34 : f26) - f35)) + Math_fround(1.0)) & 65535 | 1) & 65535;
 i19 = (i27 - (HEAP32[i3 + 20 >> 2] | 0) | 0) / 56 | 0;
 i7 = _bitshift64Shl(HEAP32[i27 + 4 >> 2] | 0, 0, 48) | 0;
 i8 = getTempRet0() | 0;
 i19 = _bitshift64Shl(i19 | 0, 0, 20) | 0;
 i7 = i19 | i7;
 i8 = getTempRet0() | 0 | i8;
 if ((i20 | 0) <= 1) {
  STACKTOP = i31;
  return;
 }
 i9 = i27 + 16 | 0;
 i3 = 0;
 while (1) {
  if ((i12 & 65535) > (HEAPU16[i2 + 6 >> 1] | 0)) i1 = 0; else i1 = (i15 & 65535) >= (HEAPU16[i2 >> 1] | 0);
  if ((i13 & 65535) > (HEAPU16[i2 + 8 >> 1] | 0)) i1 = 0; else i1 = i1 & (i11 & 65535) >= (HEAPU16[i2 + 2 >> 1] | 0);
  if ((i14 & 65535) > (HEAPU16[i2 + 10 >> 1] | 0)) {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   i4 = (i1 | 0) > -1;
   i5 = 0;
   i6 = 14;
  } else {
   i5 = i1 & (i10 & 65535) >= (HEAPU16[i2 + 4 >> 1] | 0);
   i6 = i2 + 12 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = (i1 | 0) > -1;
   if (i4 & i5) {
    if ((i3 | 0) > 31) {
     mftCall_viiiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i27 | 0, i29 | 0, i30 | 0, i3 | 0);
     i3 = 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i6 = i29 + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = i7 | i1;
    HEAP32[i6 + 4 >> 2] = i8;
    HEAP32[i30 + (i3 << 2) >> 2] = (HEAP32[i9 >> 2] | 0) + (i1 << 5);
    i1 = i3 + 1 | 0;
    i6 = 15;
   } else i6 = 14;
  }
  if ((i6 | 0) == 14) {
   i6 = 0;
   if (i4 | i5) {
    i1 = i3;
    i6 = 15;
   } else {
    i2 = i2 + (0 - i1 << 4) | 0;
    i1 = i3;
   }
  }
  if ((i6 | 0) == 15) i2 = i2 + 16 | 0;
  if (i2 >>> 0 < i16 >>> 0) i3 = i1; else break;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i31;
  return;
 }
 mftCall_viiiii(HEAP32[HEAP32[i28 >> 2] >> 2] | 0, i28 | 0, i27 | 0, i29 | 0, i30 | 0, i1 | 0);
 STACKTOP = i31;
 return;
}

function __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_(i24, i1, i25, i18, i19, i26, i27) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i25 = i25 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i28 = 0, f29 = f0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i28;
 i23 = i25 - i1 | 0;
 i21 = i19 + 12 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 i17 = i22 + 1 | 0;
 i3 = i19 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i17 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2 << 5, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i21 >> 2] << 5 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i19 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i17;
 i10 = HEAP32[i19 >> 2] | 0;
 i4 = i10 + (i22 << 5) | 0;
 i5 = (HEAP32[i24 >> 2] | 0) + (i1 << 5) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 i5 = i10 + (i22 << 5) + 12 | 0;
 i2 = (HEAP32[i24 >> 2] | 0) + (i1 << 5) + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = i1 + 1 | 0;
 if ((i2 | 0) < (i25 | 0)) {
  i6 = i10 + (i22 << 5) + 4 | 0;
  i7 = i10 + (i22 << 5) + 8 | 0;
  i8 = i10 + (i22 << 5) + 16 | 0;
  i9 = i10 + (i22 << 5) + 20 | 0;
  i3 = i10 + (i22 << 5) + 12 | 0;
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  f13 = Math_fround(HEAPF32[i7 >> 2]);
  f14 = Math_fround(HEAPF32[i5 >> 2]);
  f15 = Math_fround(HEAPF32[i8 >> 2]);
  f16 = Math_fround(HEAPF32[i9 >> 2]);
  do {
   i30 = HEAP32[i24 >> 2] | 0;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) >> 2]);
   f11 = f29 < f11 ? f29 : f11;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) + 4 >> 2]);
   f12 = f29 < f12 ? f29 : f12;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) + 8 >> 2]);
   f13 = f29 < f13 ? f29 : f13;
   HEAPF32[i4 >> 2] = f11;
   HEAPF32[i6 >> 2] = f12;
   HEAPF32[i7 >> 2] = f13;
   i30 = HEAP32[i24 >> 2] | 0;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) + 12 >> 2]);
   f14 = f14 < f29 ? f29 : f14;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) + 16 >> 2]);
   f15 = f15 < f29 ? f29 : f15;
   f29 = Math_fround(HEAPF32[i30 + (i2 << 5) + 20 >> 2]);
   f16 = f16 < f29 ? f29 : f16;
   HEAPF32[i3 >> 2] = f14;
   HEAPF32[i8 >> 2] = f15;
   HEAPF32[i9 >> 2] = f16;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i25 | 0));
 }
 if ((i23 | 0) > (i18 | 0)) {
  f16 = Math_fround(HEAPF32[i5 >> 2]);
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i4 >> 2]));
  f15 = Math_fround(HEAPF32[i10 + (i22 << 5) + 16 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i10 + (i22 << 5) + 4 >> 2]));
  f29 = Math_fround(HEAPF32[i10 + (i22 << 5) + 20 >> 2]);
  f29 = Math_fround(f29 - Math_fround(HEAPF32[i10 + (i22 << 5) + 8 >> 2]));
  HEAPF32[i20 >> 2] = f16;
  HEAPF32[i20 + 4 >> 2] = f15;
  HEAPF32[i20 + 8 >> 2] = f29;
  i2 = f15 > f16 & 1;
  i30 = f29 > Math_fround(HEAPF32[i20 + (i2 << 2) >> 2]);
  i2 = i30 ? 2 : i2;
  do if (!i2) {
   i30 = HEAP32[i24 >> 2] | 0;
   __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_(i30 + (i1 << 5) | 0, i30 + (i25 << 5) | 0, i20);
  } else {
   i4 = HEAP32[i24 >> 2] | 0;
   i3 = i4 + (i1 << 5) | 0;
   i4 = i4 + (i25 << 5) | 0;
   if ((i2 | 0) == 1) {
    __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_(i3, i4, i20);
    break;
   } else {
    __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_(i3, i4, i20);
    break;
   }
  } while (0);
  i30 = ((i23 | 0) / 2 | 0) + i1 | 0;
  __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_(i24, i1, i30, i18, i19, i26, i27);
  __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_(i24, i30, i25, i18, i19, i26, i27);
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i22 << 5) + 24 >> 2] = i17 - (HEAP32[i21 >> 2] | 0);
  STACKTOP = i28;
  return;
 }
 i19 = i26 + 12 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 HEAP32[i10 + (i22 << 5) + 24 >> 2] = (i2 >>> 0) / 3 | 0;
 HEAP32[i10 + (i22 << 5) + 28 >> 2] = i23;
 if ((i25 | 0) <= (i1 | 0)) {
  STACKTOP = i28;
  return;
 }
 i17 = i26 + 16 | 0;
 i18 = i26 + 4 | 0;
 while (1) {
  i10 = (HEAP32[i27 >> 2] | 0) + ((HEAP32[(HEAP32[i24 >> 2] | 0) + (i1 << 5) + 24 >> 2] | 0) * 3 << 2) | 0;
  i4 = i2 + 1 | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i3 = i5 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i6 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i17 >> 2] = i3;
    HEAP32[i26 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i26 >> 2] | 0, i3 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i30 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i30 | 0, HEAP32[i26 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
    HEAP32[i17 >> 2] = i3;
    HEAP32[i26 >> 2] = i30;
    break;
   }
  } while (0);
  HEAP32[i19 >> 2] = i4;
  i5 = HEAP32[i26 >> 2] | 0;
  HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i10 >> 2];
  i6 = i10 + 4 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i8 >>> 0 > i4 >>> 0) {
   i2 = i3 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i17 >> 2] = i2;
    i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i2 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i26 >> 2] = i9;
    i2 = i9;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i26 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
    HEAP32[i17 >> 2] = i2;
    HEAP32[i26 >> 2] = i9;
    i2 = i9;
    break;
   } else {
    i2 = i5;
    i9 = i5;
   }
  } else {
   i2 = i5;
   i9 = i5;
  } while (0);
  HEAP32[i19 >> 2] = i8;
  HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i6 >> 2];
  i6 = i10 + 8 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i4 = HEAP32[i17 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i8 >>> 0 > i5 >>> 0) {
   i3 = i4 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i17 >> 2] = i3;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i3 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i26 >> 2] = i2;
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i2 | 0, HEAP32[i26 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
    HEAP32[i17 >> 2] = i3;
    HEAP32[i26 >> 2] = i2;
    break;
   }
  } while (0);
  HEAP32[i19 >> 2] = i8;
  HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i25 | 0)) break;
  i2 = HEAP32[i19 >> 2] | 0;
 }
 STACKTOP = i28;
 return;
}

function __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i42 + 56 | 0;
 i28 = i42 + 20 | 0;
 i37 = i42;
 i38 = i42 + 40 | 0;
 i39 = i1 + 12 | 0;
 i40 = i1 + 16 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i39, HEAP32[i40 >> 2] | 0);
 i41 = i1 + 20 | 0;
 HEAP32[i41 >> 2] = 0;
 HEAP32[i39 >> 2] = i40;
 HEAP32[i40 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i19 = i1 + 4 | 0;
 if ((i2 | 0) == (i19 | 0)) {
  STACKTOP = i42;
  return;
 }
 i20 = i38 + 12 | 0;
 i15 = i38 + 12 | 0;
 i21 = i18 + 4 | 0;
 i22 = i38 + 8 | 0;
 i23 = i38 + 4 | 0;
 i24 = i38 + 11 | 0;
 i25 = i37 + 12 | 0;
 i17 = i37 + 12 | 0;
 i26 = i18 + 4 | 0;
 i27 = i37 + 8 | 0;
 i29 = i37 + 4 | 0;
 i30 = i37 + 16 | 0;
 i31 = i37 + 11 | 0;
 i32 = i28 + 12 | 0;
 i16 = i28 + 12 | 0;
 i33 = i18 + 4 | 0;
 i34 = i28 + 8 | 0;
 i35 = i28 + 4 | 0;
 i36 = i28 + 16 | 0;
 i10 = i1 + 16 | 0;
 i11 = i28 + 11 | 0;
 i12 = i18 + 4 | 0;
 i13 = i18 + 4 | 0;
 i14 = i18 + 4 | 0;
 while (1) {
  i3 = i2 + 20 | 0;
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i2 + 24 >> 2] | 0 : i4 & 255;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i20 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i38);
   i1 = HEAP32[i15 >> 2] | 0;
   i9 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i24 >> 0] = i4;
   if (!i4) i1 = i38; else {
    i1 = i38;
    i9 = 8;
   }
  } else i9 = 6;
  if ((i9 | 0) == 6) {
   i8 = i4 + 16 & -16;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i21 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i38 >> 2] = i1;
   HEAP32[i22 >> 2] = i8 | -2147483648;
   HEAP32[i23 >> 2] = i4;
   i9 = 8;
  }
  if ((i9 | 0) == 8) {
   i9 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i4 = HEAP32[i2 + 16 >> 2] | 0;
  i5 = HEAP8[i24 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i38 >> 2] | 0 : i38;
  i5 = i1 ? HEAP32[i23 >> 2] | 0 : i5 & 255;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i25 >> 2] = i1;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i37);
   i1 = HEAP32[i17 >> 2] | 0;
   i9 = 12;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i31 >> 0] = i5;
   if (!i5) i1 = i37; else {
    i1 = i37;
    i9 = 14;
   }
  } else i9 = 12;
  if ((i9 | 0) == 12) {
   i8 = i5 + 16 & -16;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i26 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i37 >> 2] = i1;
   HEAP32[i27 >> 2] = i8 | -2147483648;
   HEAP32[i29 >> 2] = i5;
   i9 = 14;
  }
  if ((i9 | 0) == 14) {
   i9 = 0;
   _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i30 >> 2] = i4;
  i4 = HEAP8[i31 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i37 >> 2] | 0 : i37;
  i4 = i1 ? HEAP32[i29 >> 2] | 0 : i4 & 255;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i28 + 4 >> 2] = 0;
  HEAP32[i28 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i32 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i28);
   i1 = HEAP32[i16 >> 2] | 0;
   i9 = 18;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i11 >> 0] = i4;
   if (!i4) i1 = i28; else {
    i1 = i28;
    i9 = 20;
   }
  } else i9 = 18;
  if ((i9 | 0) == 18) {
   i8 = i4 + 16 & -16;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i33 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i28 >> 2] = i1;
   HEAP32[i34 >> 2] = i8 | -2147483648;
   HEAP32[i35 >> 2] = i4;
   i9 = 20;
  }
  if ((i9 | 0) == 20) {
   i9 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i36 >> 2] = HEAP32[i30 >> 2];
  i1 = HEAP32[i40 >> 2] | 0;
  do if (!i1) {
   i3 = i40;
   i4 = i40;
  } else {
   i7 = HEAP8[i11 >> 0] | 0;
   i8 = i7 << 24 >> 24 < 0;
   i7 = i8 ? HEAP32[i35 >> 2] | 0 : i7 & 255;
   i8 = i8 ? HEAP32[i28 >> 2] | 0 : i28;
   while (1) {
    i4 = i1 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i6 & 255;
    i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
    if (!i3) i9 = 25; else {
     i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
     if (!i3) i9 = 25; else if ((i3 | 0) < 0) i9 = 27; else i9 = 29;
    }
    if ((i9 | 0) == 25) if (i7 >>> 0 < i6 >>> 0) i9 = 27; else i9 = 29;
    if ((i9 | 0) == 27) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) {
      i9 = 28;
      break;
     } else i1 = i3;
    } else if ((i9 | 0) == 29) {
     i4 = i1 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i9 = 31;
      break;
     } else i1 = i3;
    }
   }
   if ((i9 | 0) == 28) {
    i9 = 0;
    i3 = i1;
    i4 = i1;
    break;
   } else if ((i9 | 0) == 31) {
    i9 = 0;
    i3 = i1;
    break;
   }
  } while (0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i18, i39, i28);
  i1 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i4 >> 2] = i1;
  i3 = HEAP32[HEAP32[i39 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i39 >> 2] = i3;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i1);
  HEAP32[i41 >> 2] = (HEAP32[i41 >> 2] | 0) + 1;
  if ((HEAP8[i11 >> 0] | 0) < 0) {
   i8 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i16 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i12 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i18);
  }
  if ((HEAP8[i31 >> 0] | 0) < 0) {
   i8 = HEAP32[i37 >> 2] | 0;
   i7 = HEAP32[i17 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i13 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i18);
  }
  if ((HEAP8[i24 >> 0] | 0) < 0) {
   i8 = HEAP32[i38 >> 2] | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i14 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i18);
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i19 | 0)) break; else i2 = i1;
 }
 STACKTOP = i42;
 return;
}

function __Z24CalculateGlobalRSInverse23TransformAccessReadOnly(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i15 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i22 = i1 + 4 | 0;
 i27 = HEAP32[i22 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i15 + (i27 * 40 | 0) + 24 >> 2]);
 f29 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i27 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f29 * Math_fround(-2.0));
 f24 = Math_fround(f29 * Math_fround(2.0));
 f23 = Math_fround(f29 * f8);
 f7 = Math_fround(f6 * Math_fround(-2.0));
 f2 = Math_fround(f6 * Math_fround(2.0));
 f3 = Math_fround(f6 * f7);
 f9 = Math_fround(Math_fround(f23 + f3) + Math_fround(1.0));
 f10 = Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f28 * f2)) + Math_fround(0.0));
 f8 = Math_fround(Math_fround(Math_fround(f28 * f8) + Math_fround(f25 * f2)) + Math_fround(0.0));
 i13 = i12 + 4 | 0;
 i14 = i12 + 8 | 0;
 f5 = Math_fround(f25 * Math_fround(2.0));
 f4 = Math_fround(f25 * Math_fround(-2.0));
 f25 = Math_fround(f25 * f4);
 f7 = Math_fround(Math_fround(Math_fround(f29 * f5) + Math_fround(f28 * f7)) + Math_fround(0.0));
 f3 = Math_fround(Math_fround(f25 + f3) + Math_fround(1.0));
 f2 = Math_fround(Math_fround(Math_fround(f28 * f5) + Math_fround(f29 * f2)) + Math_fround(0.0));
 i16 = i12 + 12 | 0;
 i17 = i12 + 16 | 0;
 i18 = i12 + 20 | 0;
 f5 = Math_fround(Math_fround(Math_fround(f5 * f6) + Math_fround(f28 * f24)) + Math_fround(0.0));
 f24 = Math_fround(Math_fround(Math_fround(f28 * f4) + Math_fround(f6 * f24)) + Math_fround(0.0));
 f23 = Math_fround(Math_fround(f25 + f23) + Math_fround(1.0));
 i19 = i12 + 24 | 0;
 i20 = i12 + 28 | 0;
 i21 = i12 + 32 | 0;
 f25 = Math_fround(HEAPF32[i15 + (i27 * 40 | 0) + 28 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + (i27 * 40 | 0) + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i15 + (i27 * 40 | 0) + 36 >> 2]);
 i27 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(9.99999971e-10);
 i26 = Math_fround(Math_abs(Math_fround(f6))) < Math_fround(9.99999971e-10);
 i11 = Math_fround(Math_abs(Math_fround(f4))) < Math_fround(9.99999971e-10);
 f25 = Math_fround(Math_fround(1.0) / f25);
 f25 = i27 ? Math_fround(1.0) : f25;
 f6 = Math_fround(Math_fround(1.0) / f6);
 f6 = i26 ? Math_fround(1.0) : f6;
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i11 ? Math_fround(1.0) : f4;
 f9 = Math_fround(f25 * f9);
 f10 = Math_fround(f10 * f6);
 f8 = Math_fround(f8 * f4);
 f7 = Math_fround(f25 * f7);
 f3 = Math_fround(f6 * f3);
 f2 = Math_fround(f2 * f4);
 f5 = Math_fround(f25 * f5);
 f6 = Math_fround(f24 * f6);
 f4 = Math_fround(f23 * f4);
 HEAPF32[i12 >> 2] = f9;
 HEAPF32[i13 >> 2] = f10;
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i16 >> 2] = f7;
 HEAPF32[i17 >> 2] = f3;
 HEAPF32[i18 >> 2] = f2;
 HEAPF32[i19 >> 2] = f5;
 HEAPF32[i20 >> 2] = f6;
 HEAPF32[i21 >> 2] = f4;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 i1 = HEAP32[i11 + (HEAP32[i22 >> 2] << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 do {
  f37 = Math_fround(HEAPF32[i15 + (i1 * 40 | 0) + 24 >> 2]);
  f38 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i1 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f24 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i1 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i1 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = Math_fround(f38 * Math_fround(-2.0));
  f31 = Math_fround(f38 * Math_fround(2.0));
  f33 = Math_fround(f38 * f30);
  f36 = Math_fround(f28 * Math_fround(-2.0));
  f35 = Math_fround(f28 * Math_fround(2.0));
  f34 = Math_fround(f28 * f36);
  f29 = Math_fround(Math_fround(f33 + f34) + Math_fround(1.0));
  f32 = Math_fround(Math_fround(Math_fround(f24 * f31) + Math_fround(f37 * f35)) + Math_fround(0.0));
  f30 = Math_fround(Math_fround(Math_fround(f37 * f30) + Math_fround(f24 * f35)) + Math_fround(0.0));
  f23 = Math_fround(f24 * Math_fround(2.0));
  f25 = Math_fround(f24 * Math_fround(-2.0));
  f24 = Math_fround(f24 * f25);
  f36 = Math_fround(Math_fround(Math_fround(f38 * f23) + Math_fround(f37 * f36)) + Math_fround(0.0));
  f34 = Math_fround(Math_fround(f24 + f34) + Math_fround(1.0));
  f35 = Math_fround(Math_fround(Math_fround(f37 * f23) + Math_fround(f38 * f35)) + Math_fround(0.0));
  f23 = Math_fround(Math_fround(Math_fround(f23 * f28) + Math_fround(f37 * f31)) + Math_fround(0.0));
  f31 = Math_fround(Math_fround(Math_fround(f37 * f25) + Math_fround(f28 * f31)) + Math_fround(0.0));
  f33 = Math_fround(Math_fround(f24 + f33) + Math_fround(1.0));
  f24 = Math_fround(HEAPF32[i15 + (i1 * 40 | 0) + 28 >> 2]);
  f28 = Math_fround(HEAPF32[i15 + (i1 * 40 | 0) + 32 >> 2]);
  f25 = Math_fround(HEAPF32[i15 + (i1 * 40 | 0) + 36 >> 2]);
  i22 = Math_fround(Math_abs(Math_fround(f24))) < Math_fround(9.99999971e-10);
  i26 = Math_fround(Math_abs(Math_fround(f28))) < Math_fround(9.99999971e-10);
  i27 = Math_fround(Math_abs(Math_fround(f25))) < Math_fround(9.99999971e-10);
  f24 = Math_fround(Math_fround(1.0) / f24);
  f24 = i22 ? Math_fround(1.0) : f24;
  f28 = Math_fround(Math_fround(1.0) / f28);
  f28 = i26 ? Math_fround(1.0) : f28;
  f25 = Math_fround(Math_fround(1.0) / f25);
  f25 = i27 ? Math_fround(1.0) : f25;
  f29 = Math_fround(f24 * f29);
  f32 = Math_fround(f32 * f28);
  f30 = Math_fround(f30 * f25);
  f36 = Math_fround(f24 * f36);
  f34 = Math_fround(f28 * f34);
  f35 = Math_fround(f35 * f25);
  f23 = Math_fround(f24 * f23);
  f28 = Math_fround(f31 * f28);
  f25 = Math_fround(f33 * f25);
  f33 = f9;
  f9 = Math_fround(Math_fround(f9 * f29) + Math_fround(Math_fround(f30 * f5) + Math_fround(f32 * f7)));
  f31 = f10;
  f10 = Math_fround(Math_fround(f10 * f29) + Math_fround(Math_fround(f30 * f6) + Math_fround(f32 * f3)));
  f24 = f8;
  f8 = Math_fround(Math_fround(f29 * f8) + Math_fround(Math_fround(f30 * f4) + Math_fround(f32 * f2)));
  f32 = f7;
  f7 = Math_fround(Math_fround(f33 * f36) + Math_fround(Math_fround(f5 * f35) + Math_fround(f34 * f7)));
  f30 = f3;
  f3 = Math_fround(Math_fround(f31 * f36) + Math_fround(Math_fround(f35 * f6) + Math_fround(f34 * f3)));
  f29 = f2;
  f2 = Math_fround(Math_fround(f24 * f36) + Math_fround(Math_fround(f35 * f4) + Math_fround(f34 * f2)));
  f5 = Math_fround(Math_fround(f33 * f23) + Math_fround(Math_fround(f5 * f25) + Math_fround(f28 * f32)));
  f6 = Math_fround(Math_fround(f31 * f23) + Math_fround(Math_fround(f25 * f6) + Math_fround(f28 * f30)));
  f4 = Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f25 * f4) + Math_fround(f28 * f29)));
  i1 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i12 >> 2] = f9;
 HEAPF32[i13 >> 2] = f10;
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i19 >> 2] = f5;
 HEAPF32[i20 >> 2] = f6;
 HEAPF32[i21 >> 2] = f4;
 HEAPF32[i16 >> 2] = f7;
 HEAPF32[i17 >> 2] = f3;
 HEAPF32[i18 >> 2] = f2;
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji(i18, i17, i16) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 24 | 0;
 i13 = i20 + 8 | 0;
 i4 = i20;
 i3 = i20 + 32 | 0;
 i19 = i18 + 57 | 0;
 i12 = i17 + 7 + i16 | 0;
 do if (i12 >>> 0 > 32) {
  i1 = i12 >>> 0 > 2097151;
  i15 = i12 >>> (i1 ? 21 : 5);
  i1 = i1 ? 16 : 0;
  i2 = (i15 & 65280 | 0) == 0;
  i15 = i2 ? i15 : i15 >>> 8;
  i1 = i2 ? i1 : i1 | 8;
  i2 = (i15 & 240 | 0) == 0;
  i1 = 1 << (HEAP8[(i2 ? i15 : i15 >>> 4) + (gb + 936717) >> 0] | 0) + (i2 ? i1 : i1 | 4);
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 <= ~i12 >>> 0) {
   i2 = i2 + i12 & 0 - i1;
   break;
  }
  __Z6FormatPKcz(i3, gb + 364269 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 364297 | 0, 96, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 } else i2 = i12; while (0);
 i7 = i18 + 60 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (i5 >>> 0 > i17 >>> 0) {
  i4 = i18 + 36 | 0;
  i3 = i18 + 40 | 0;
  i1 = i18 + 48 | 0;
  i15 = (HEAP32[i4 >> 2] | 0) >>> 0 > i2 >>> 0 ? i3 : i1;
  i6 = HEAP32[i15 + 4 >> 2] | 0;
  if ((i6 | 0) == (i15 | 0)) {
   i1 = i5;
   i15 = 11;
  } else {
   i5 = _tlsf_memalign(HEAP32[i6 + 8 >> 2] | 0, i16, i2) | 0;
   if (!i5) {
    i1 = HEAP32[i7 >> 2] | 0;
    i15 = 11;
   } else i15 = 41;
  }
 } else {
  i1 = i5;
  i15 = 11;
 }
 do if ((i15 | 0) == 11) {
  L17 : do if (i1 >>> 2 >>> 0 > i17 >>> 0) {
   i9 = i18 + 36 | 0;
   i10 = i18 + 40 | 0;
   i11 = i18 + 48 | 0;
   i8 = (HEAP32[i9 >> 2] | 0) >>> 0 > i2 >>> 0 ? i10 : i11;
   i1 = HEAP32[i8 >> 2] | 0;
   L19 : do if ((i1 | 0) != (i8 | 0)) {
    i5 = i1;
    while (1) {
     i6 = i5;
     i1 = _tlsf_memalign(HEAP32[i6 + 8 >> 2] | 0, i16, i2) | 0;
     if (i1 | 0) break;
     i1 = HEAP32[i5 >> 2] | 0;
     if ((i1 | 0) == (i8 | 0)) break L19; else i5 = i1;
    }
    i4 = HEAP32[i8 + 4 >> 2] | 0;
    if ((i6 | 0) == (i4 | 0)) break L17;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = i6 + 4 | 0; else {
     i14 = i6 + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i14 >> 2];
     HEAP32[HEAP32[i14 >> 2] >> 2] = i3;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     i3 = i14;
    }
    i14 = HEAP32[i4 >> 2] | 0;
    HEAP32[i5 >> 2] = i14;
    HEAP32[i3 >> 2] = i4;
    HEAP32[i14 + 4 >> 2] = i6;
    HEAP32[HEAP32[i3 >> 2] >> 2] = i6;
    break L17;
   } while (0);
   i1 = HEAP32[i7 >> 2] | 0;
   i4 = i17 << 1;
   if (i1 >>> 0 > i4 >>> 0) {
    do {
     i5 = __ZN13MemoryManager16LowLevelAllocateEj(i1) | 0;
     i1 = i1 >>> ((i5 | 0) == 0 & 1);
     i3 = (i5 | 0) != 0;
    } while (i1 >>> 0 > i4 >>> 0 & (i3 ^ 1));
    if (i3) {
     i4 = i18 + 20 | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
     i4 = __ZN13MemoryManager16LowLevelAllocateEj(24) | 0;
     i6 = i4 + 4 | 0;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i4 + 4 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = 0;
     HEAP32[i4 + 12 >> 2] = 0;
     HEAP32[i4 + 16 >> 2] = 0;
     HEAP32[i4 + 20 >> 2] = 0;
     HEAP32[i4 + 12 >> 2] = i5;
     HEAP32[i4 + 16 >> 2] = i1;
     HEAP32[i4 + 8 >> 2] = _tlsf_create(i5, i1) | 0;
     HEAP32[i4 + 20 >> 2] = 0;
     i1 = HEAP32[i8 + 4 >> 2] | 0;
     if ((i4 | 0) != (i1 | 0)) {
      i3 = HEAP32[i4 >> 2] | 0;
      if (i3 | 0) {
       HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
       HEAP32[HEAP32[i6 >> 2] >> 2] = i3;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i6 >> 2] = 0;
      }
      i8 = HEAP32[i1 >> 2] | 0;
      HEAP32[i4 >> 2] = i8;
      HEAP32[i6 >> 2] = i1;
      HEAP32[i8 + 4 >> 2] = i4;
      HEAP32[HEAP32[i6 >> 2] >> 2] = i4;
     }
     i1 = _tlsf_memalign(HEAP32[(HEAP32[((HEAP32[i9 >> 2] | 0) >>> 0 > i2 >>> 0 ? i10 : i11) + 4 >> 2] | 0) + 8 >> 2] | 0, i16, i2) | 0;
     if (!i1) i15 = 29;
    } else i15 = 29;
   } else i15 = 29;
  } else i15 = 29; while (0);
  if ((i15 | 0) == 29) {
   i4 = i18 + 20 | 0;
   i5 = i18 + 64 | 0;
   i2 = 0;
   i3 = 0;
   L44 : while (1) {
    i1 = __ZN13MemoryManager16LowLevelAllocateEj(i12) | 0;
    do if (!i1) {
     i1 = i2 + 1 | 0;
     if ((i1 | 0) < 5) {
      HEAP32[i13 >> 2] = i1;
      i2 = i13 + 8 | 0;
      HEAP32[i2 >> 2] = i17;
      HEAP32[i2 + 4 >> 2] = 0;
      _printf_console(gb + 364380 | 0, i13);
      i2 = i1;
      i6 = i3;
      i3 = 10;
      i1 = 0;
      break;
     }
     i11 = i14;
     HEAP32[i11 >> 2] = i17;
     HEAP32[i11 + 4 >> 2] = 0;
     _printf_console(gb + 364479 | 0, i14);
     if (!(HEAP8[i19 >> 0] | 0)) {
      i2 = i1;
      i6 = i3;
      i3 = 1;
      i1 = 0;
     } else {
      i2 = i1;
      i6 = i3;
      i3 = 1;
      i1 = 0;
     }
    } else {
     i6 = __ZN13MemoryManager16LowLevelAllocateEj(20) | 0;
     i11 = i6 + 4 | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i6 + 12 >> 2] = i12;
     HEAP32[i6 + 16 >> 2] = i17;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i17;
     HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i6;
     i3 = 0;
     i1 = HEAP32[i11 >> 2] | 0;
    } while (0);
    switch (i3 & 15) {
    case 10:
    case 0:
     break;
    default:
     {
      i15 = 38;
      break L44;
     }
    }
    if (!i1) i3 = i6; else break;
   }
   if ((i15 | 0) == 38) if (i3 | 0) {
    i19 = 0;
    STACKTOP = i20;
    return i19 | 0;
   }
   if (!i6) i2 = i12; else {
    i2 = -8 - i1 & i16 + -1;
    i3 = i1 + i2 | 0;
    if (!i2) {
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -2;
     i1 = 0;
     i2 = i3;
    } else {
     _memset(i1 | 0, -86, i2 | 0) | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
     HEAP32[i3 + -4 >> 2] = i2;
     i1 = 1;
     i2 = i3;
    }
    HEAP32[i2 >> 2] = i1 | i17 << 1;
    i1 = i3 + 8 | 0;
    HEAP32[i6 + 8 >> 2] = i1;
    i16 = (HEAP32[i6 + 12 >> 2] | 0) - i17 | 0;
    i3 = i18 + 16 | 0;
    i2 = (HEAP32[i3 >> 2] | 0) + i17 | 0;
    HEAP32[i3 >> 2] = i2;
    i3 = i18 + 28 | 0;
    HEAP32[i3 >> 2] = i16 + (HEAP32[i3 >> 2] | 0);
    i3 = i18 + 24 | 0;
    if (i2 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) HEAP32[i3 >> 2] = i2;
    i18 = i18 + 12 | 0;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
    break;
   }
  }
  i5 = i1;
  i4 = i18 + 36 | 0;
  i3 = i18 + 40 | 0;
  i1 = i18 + 48 | 0;
  i15 = 41;
 } while (0);
 if ((i15 | 0) == 41) {
  i1 = (HEAP32[((HEAP32[i4 >> 2] | 0) >>> 0 > i2 >>> 0 ? i3 : i1) + 4 >> 2] | 0) + 20 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = -8 - i5 & i16 + -1;
  i4 = i5 + i1 | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = i17 << 1;
   i3 = i4;
   i1 = 0;
  } else {
   _memset(i5 | 0, -86, i1 | 0) | 0;
   HEAP32[i4 + -4 >> 2] = i1;
   HEAP32[i4 >> 2] = i17 << 1 | 1;
   i3 = i4;
  }
  i2 = (_tlsf_block_size(i4 + (0 - i1) | 0) | 0) + -8 | 0;
  if (!(HEAP32[i3 >> 2] & 1)) i1 = 0; else i1 = HEAP32[i4 + -4 >> 2] | 0;
  i17 = i18 + 16 | 0;
  i1 = i2 - i1 + (HEAP32[i17 >> 2] | 0) | 0;
  HEAP32[i17 >> 2] = i1;
  i2 = i18 + 28 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 23;
  i2 = i18 + 24 | 0;
  if (i1 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) HEAP32[i2 >> 2] = i1;
  i1 = i18 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i4 + 8 | 0;
 }
 if (!(HEAP8[i19 >> 0] | 0)) {
  i19 = i1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i19 = i1;
 STACKTOP = i20;
 return i19 | 0;
}

function _processblock_51(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i43;
 i1 = 0;
 do {
  i39 = i1 << 3;
  i38 = _bitshift64Shl(HEAPU8[i2 + i39 >> 0] | 0 | 0, 0, 56) | 0;
  i40 = getTempRet0() | 0;
  i37 = _bitshift64Shl(HEAPU8[i2 + (i39 | 1) >> 0] | 0 | 0, 0, 48) | 0;
  i40 = getTempRet0() | 0 | i40;
  i36 = _bitshift64Shl(HEAPU8[i2 + (i39 | 2) >> 0] | 0 | 0, 0, 40) | 0;
  i40 = getTempRet0() | 0 | i40;
  i40 = HEAPU8[i2 + (i39 | 3) >> 0] | 0 | i40;
  i35 = _bitshift64Shl(HEAPU8[i2 + (i39 | 4) >> 0] | 0 | 0, 0, 24) | 0;
  i40 = getTempRet0() | 0 | i40;
  i34 = _bitshift64Shl(HEAPU8[i2 + (i39 | 5) >> 0] | 0 | 0, 0, 16) | 0;
  i40 = getTempRet0() | 0 | i40;
  i33 = _bitshift64Shl(HEAPU8[i2 + (i39 | 6) >> 0] | 0 | 0, 0, 8) | 0;
  i40 = getTempRet0() | 0 | i40;
  i41 = i42 + (i1 << 3) | 0;
  HEAP32[i41 >> 2] = i33 | (i34 | (i35 | (i36 | (i37 | i38)))) | (HEAPU8[i2 + (i39 | 7) >> 0] | 0);
  HEAP32[i41 + 4 >> 2] = i40;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 i3 = i42;
 i1 = 16;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 do {
  i32 = i42 + (i1 + -2 << 3) | 0;
  i28 = HEAP32[i32 >> 2] | 0;
  i32 = HEAP32[i32 + 4 >> 2] | 0;
  i34 = _bitshift64Lshr(i28 | 0, i32 | 0, 19) | 0;
  i35 = getTempRet0() | 0;
  i33 = _bitshift64Shl(i28 | 0, i32 | 0, 45) | 0;
  i35 = getTempRet0() | 0 | i35;
  i31 = _bitshift64Lshr(i28 | 0, i32 | 0, 61) | 0;
  i29 = getTempRet0() | 0;
  i30 = _bitshift64Shl(i28 | 0, i32 | 0, 3) | 0;
  i29 = getTempRet0() | 0 | i29;
  i32 = _bitshift64Lshr(i28 | 0, i32 | 0, 6) | 0;
  i35 = i29 ^ (getTempRet0() | 0) ^ i35;
  i29 = i42 + (i1 + -7 << 3) | 0;
  i28 = HEAP32[i29 >> 2] | 0;
  i29 = HEAP32[i29 + 4 >> 2] | 0;
  i40 = i42 + (i1 + -15 << 3) | 0;
  i26 = i2;
  i2 = HEAP32[i40 >> 2] | 0;
  i27 = i3;
  i3 = HEAP32[i40 + 4 >> 2] | 0;
  i40 = _bitshift64Lshr(i2 | 0, i3 | 0, 1) | 0;
  i39 = getTempRet0() | 0;
  i41 = _bitshift64Shl(i2 | 0, i3 | 0, 63) | 0;
  i39 = getTempRet0() | 0 | i39;
  i37 = _bitshift64Lshr(i2 | 0, i3 | 0, 8) | 0;
  i25 = getTempRet0() | 0;
  i36 = _bitshift64Shl(i2 | 0, i3 | 0, 56) | 0;
  i25 = getTempRet0() | 0 | i25;
  i38 = _bitshift64Lshr(i2 | 0, i3 | 0, 7) | 0;
  i39 = i25 ^ (getTempRet0() | 0) ^ i39;
  i29 = _i64Add(i26 | 0, i27 | 0, i28 | 0, i29 | 0) | 0;
  i35 = _i64Add(i29 | 0, getTempRet0() | 0, (i30 | i31) ^ i32 ^ (i33 | i34) | 0, i35 | 0) | 0;
  i39 = _i64Add(i35 | 0, getTempRet0() | 0, (i36 | i37) ^ i38 ^ (i41 | i40) | 0, i39 | 0) | 0;
  i40 = getTempRet0() | 0;
  i41 = i42 + (i1 << 3) | 0;
  HEAP32[i41 >> 2] = i39;
  HEAP32[i41 + 4 >> 2] = i40;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 80);
 i21 = i4 + 8 | 0;
 i23 = i21;
 i22 = HEAP32[i23 >> 2] | 0;
 i23 = HEAP32[i23 + 4 >> 2] | 0;
 i24 = i4 + 16 | 0;
 i26 = i24;
 i25 = HEAP32[i26 >> 2] | 0;
 i26 = HEAP32[i26 + 4 >> 2] | 0;
 i27 = i4 + 24 | 0;
 i29 = i27;
 i28 = HEAP32[i29 >> 2] | 0;
 i29 = HEAP32[i29 + 4 >> 2] | 0;
 i30 = i4 + 32 | 0;
 i32 = i30;
 i31 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 4 >> 2] | 0;
 i33 = i4 + 40 | 0;
 i35 = i33;
 i34 = HEAP32[i35 >> 2] | 0;
 i35 = HEAP32[i35 + 4 >> 2] | 0;
 i36 = i4 + 48 | 0;
 i38 = i36;
 i37 = HEAP32[i38 >> 2] | 0;
 i38 = HEAP32[i38 + 4 >> 2] | 0;
 i39 = i4 + 56 | 0;
 i41 = i39;
 i40 = HEAP32[i41 >> 2] | 0;
 i41 = HEAP32[i41 + 4 >> 2] | 0;
 i6 = i4 + 64 | 0;
 i8 = i6;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = 0;
 i9 = i34;
 i10 = i35;
 i1 = i7;
 i2 = i8;
 i11 = i40;
 i12 = i37;
 i13 = i41;
 i14 = i38;
 i15 = i22;
 i16 = i23;
 i17 = i25;
 i18 = i26;
 i19 = i28;
 i20 = i29;
 i3 = i31;
 i4 = i32;
 while (1) {
  i49 = _bitshift64Lshr(i9 | 0, i10 | 0, 14) | 0;
  i50 = getTempRet0() | 0;
  i47 = _bitshift64Shl(i9 | 0, i10 | 0, 50) | 0;
  i50 = getTempRet0() | 0 | i50;
  i48 = _bitshift64Lshr(i9 | 0, i10 | 0, 18) | 0;
  i44 = getTempRet0() | 0;
  i46 = _bitshift64Shl(i9 | 0, i10 | 0, 46) | 0;
  i44 = i50 ^ (getTempRet0() | 0 | i44);
  i50 = _bitshift64Lshr(i9 | 0, i10 | 0, 41) | 0;
  i45 = getTempRet0() | 0;
  i51 = _bitshift64Shl(i9 | 0, i10 | 0, 23) | 0;
  i45 = _i64Add((i47 | i49) ^ (i46 | i48) ^ (i51 | i50) | 0, i44 ^ (getTempRet0() | 0 | i45) | 0, i1 | 0, i2 | 0) | 0;
  i45 = _i64Add(i45 | 0, getTempRet0() | 0, (i11 ^ i12) & i9 ^ i11 | 0, (i13 ^ i14) & i10 ^ i13 | 0) | 0;
  i44 = getTempRet0() | 0;
  i50 = gb + 3584 + (i5 << 3) | 0;
  i50 = _i64Add(i45 | 0, i44 | 0, HEAP32[i50 >> 2] | 0, HEAP32[i50 + 4 >> 2] | 0) | 0;
  i44 = getTempRet0() | 0;
  i45 = i42 + (i5 << 3) | 0;
  i45 = _i64Add(i50 | 0, i44 | 0, HEAP32[i45 >> 2] | 0, HEAP32[i45 + 4 >> 2] | 0) | 0;
  i44 = getTempRet0() | 0;
  i50 = _bitshift64Lshr(i15 | 0, i16 | 0, 28) | 0;
  i1 = getTempRet0() | 0;
  i51 = _bitshift64Shl(i15 | 0, i16 | 0, 36) | 0;
  i1 = getTempRet0() | 0 | i1;
  i48 = _bitshift64Lshr(i15 | 0, i16 | 0, 34) | 0;
  i46 = getTempRet0() | 0;
  i49 = _bitshift64Shl(i15 | 0, i16 | 0, 30) | 0;
  i46 = i1 ^ (getTempRet0() | 0 | i46);
  i1 = _bitshift64Lshr(i15 | 0, i16 | 0, 39) | 0;
  i47 = getTempRet0() | 0;
  i2 = _bitshift64Shl(i15 | 0, i16 | 0, 25) | 0;
  i47 = _i64Add((i51 | i50) ^ (i49 | i48) ^ (i2 | i1) | 0, i46 ^ (getTempRet0() | 0 | i47) | 0, i19 & (i17 | i15) | i17 & i15 | 0, i20 & (i18 | i16) | i18 & i16 | 0) | 0;
  i46 = getTempRet0() | 0;
  i1 = _i64Add(i45 | 0, i44 | 0, i3 | 0, i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = _i64Add(i47 | 0, i46 | 0, i45 | 0, i44 | 0) | 0;
  i4 = getTempRet0() | 0;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 80) break; else {
   i44 = i16;
   i45 = i15;
   i46 = i10;
   i47 = i14;
   i48 = i9;
   i49 = i12;
   i50 = i13;
   i51 = i11;
   i9 = i1;
   i10 = i2;
   i15 = i3;
   i16 = i4;
   i4 = i20;
   i3 = i19;
   i20 = i18;
   i19 = i17;
   i18 = i44;
   i17 = i45;
   i14 = i46;
   i13 = i47;
   i12 = i48;
   i11 = i49;
   i2 = i50;
   i1 = i51;
  }
 }
 i51 = _i64Add(i22 | 0, i23 | 0, i3 | 0, i4 | 0) | 0;
 i50 = getTempRet0() | 0;
 i49 = i21;
 HEAP32[i49 >> 2] = i51;
 HEAP32[i49 + 4 >> 2] = i50;
 i49 = _i64Add(i25 | 0, i26 | 0, i15 | 0, i16 | 0) | 0;
 i50 = getTempRet0() | 0;
 i51 = i24;
 HEAP32[i51 >> 2] = i49;
 HEAP32[i51 + 4 >> 2] = i50;
 i51 = _i64Add(i28 | 0, i29 | 0, i17 | 0, i18 | 0) | 0;
 i50 = getTempRet0() | 0;
 i49 = i27;
 HEAP32[i49 >> 2] = i51;
 HEAP32[i49 + 4 >> 2] = i50;
 i49 = _i64Add(i31 | 0, i32 | 0, i19 | 0, i20 | 0) | 0;
 i50 = getTempRet0() | 0;
 i51 = i30;
 HEAP32[i51 >> 2] = i49;
 HEAP32[i51 + 4 >> 2] = i50;
 i51 = _i64Add(i34 | 0, i35 | 0, i1 | 0, i2 | 0) | 0;
 i50 = getTempRet0() | 0;
 i49 = i33;
 HEAP32[i49 >> 2] = i51;
 HEAP32[i49 + 4 >> 2] = i50;
 i49 = _i64Add(i37 | 0, i38 | 0, i9 | 0, i10 | 0) | 0;
 i50 = getTempRet0() | 0;
 i51 = i36;
 HEAP32[i51 >> 2] = i49;
 HEAP32[i51 + 4 >> 2] = i50;
 i51 = _i64Add(i40 | 0, i41 | 0, i12 | 0, i14 | 0) | 0;
 i50 = getTempRet0() | 0;
 i49 = i39;
 HEAP32[i49 >> 2] = i51;
 HEAP32[i49 + 4 >> 2] = i50;
 i49 = _i64Add(i7 | 0, i8 | 0, i11 | 0, i13 | 0) | 0;
 i50 = getTempRet0() | 0;
 i51 = i6;
 HEAP32[i51 >> 2] = i49;
 HEAP32[i51 + 4 >> 2] = i50;
 STACKTOP = i43;
 return;
}

function __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i9 = i8 + 16 | 0;
 i10 = i8 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i7, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 34 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 38 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 42 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 46 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
  i3 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 50 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 54 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 58 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 62 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i7 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i7 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN13OpenFileCache10OpenCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16, i11) {
 i16 = i16 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i12 = i17 + 4 | 0;
 i13 = i16 + 240 | 0;
 i9 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
 HEAP32[i13 >> 2] = i9;
 i14 = i11 + 11 | 0;
 i2 = HEAP8[i14 >> 0] | 0;
 i18 = i2 << 24 >> 24 < 0;
 i2 = i2 & 255;
 i8 = i18 ? HEAP32[i11 + 4 >> 2] | 0 : i2;
 i7 = HEAP32[i11 >> 2] | 0;
 i6 = i18 ? i7 : i11;
 i1 = (i8 | 0) == 0;
 i7 = i7 & 255;
 i3 = i16 + 160 | 0;
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i16 + 164 >> 2] | 0 : i5 & 255;
 L1 : do if (i18) {
  if (i1) {
   if (!i5) {
    i1 = 0;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 172 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 176 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 1;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 184 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 188 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 2;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 196 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 200 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 3;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 208 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 212 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 4;
    i10 = 16;
    break;
   } else break;
  }
  if ((i8 | 0) == (i5 | 0)) if (!(_memcmp(i6, i4 ? HEAP32[i3 >> 2] | 0 : i3, i8) | 0)) {
   i1 = 0;
   i10 = 16;
   break;
  }
  i1 = i16 + 172 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i2 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i2 ? HEAP32[i16 + 176 >> 2] | 0 : i18 & 255) | 0)) if (!(_memcmp(i6, i2 ? HEAP32[i1 >> 2] | 0 : i1, i8) | 0)) {
   i1 = 1;
   i10 = 16;
   break;
  }
  i1 = i16 + 184 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i2 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i2 ? HEAP32[i16 + 188 >> 2] | 0 : i18 & 255) | 0)) if (!(_memcmp(i6, i2 ? HEAP32[i1 >> 2] | 0 : i1, i8) | 0)) {
   i1 = 2;
   i10 = 16;
   break;
  }
  i1 = i16 + 196 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i2 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i2 ? HEAP32[i16 + 200 >> 2] | 0 : i18 & 255) | 0)) if (!(_memcmp(i6, i2 ? HEAP32[i1 >> 2] | 0 : i1, i8) | 0)) {
   i1 = 3;
   i10 = 16;
   break;
  }
  i1 = i16 + 208 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i2 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i2 ? HEAP32[i16 + 212 >> 2] | 0 : i18 & 255) | 0)) if (!(_memcmp(i6, i2 ? HEAP32[i1 >> 2] | 0 : i1, i8) | 0)) {
   i1 = 4;
   i10 = 16;
  }
 } else {
  if (i1) {
   if (!i5) {
    i1 = 0;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 172 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 176 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 1;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 184 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 188 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 2;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 196 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 200 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 3;
    i10 = 16;
    break;
   }
   i18 = HEAP8[i16 + 208 + 11 >> 0] | 0;
   if (!((i18 << 24 >> 24 < 0 ? HEAP32[i16 + 212 >> 2] | 0 : i18 & 255) | 0)) {
    i1 = 4;
    i10 = 16;
    break;
   } else break;
  }
  if ((i8 | 0) == (i5 | 0)) {
   i1 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
   if (i7 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i11;
    i4 = i2;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) {
      i1 = 0;
      i10 = 16;
      break L1;
     }
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  }
  i1 = i16 + 172 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i3 ? HEAP32[i16 + 176 >> 2] | 0 : i18 & 255) | 0)) {
   i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   if (i7 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i11;
    i4 = i2;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) {
      i1 = 1;
      i10 = 16;
      break L1;
     }
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  }
  i1 = i16 + 184 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i3 ? HEAP32[i16 + 188 >> 2] | 0 : i18 & 255) | 0)) {
   i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   if (i7 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i11;
    i4 = i2;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) {
      i1 = 2;
      i10 = 16;
      break L1;
     }
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  }
  i1 = i16 + 196 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i3 ? HEAP32[i16 + 200 >> 2] | 0 : i18 & 255) | 0)) {
   i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   if (i7 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i11;
    i4 = i2;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) {
      i1 = 3;
      i10 = 16;
      break L1;
     }
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  }
  i1 = i16 + 208 | 0;
  i18 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i18 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i3 ? HEAP32[i16 + 212 >> 2] | 0 : i18 & 255) | 0)) {
   i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   if (i7 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i11;
    do {
     i2 = i2 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i2) {
      i1 = 4;
      i10 = 16;
      break L1;
     }
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  }
 } while (0);
 if ((i10 | 0) == 16) {
  HEAP32[i16 + 220 + (i1 << 2) >> 2] = i9;
  i18 = i16 + (i1 << 5) | 0;
  STACKTOP = i17;
  return i18 | 0;
 }
 i10 = HEAP32[i16 + 220 >> 2] | 0;
 i9 = HEAP32[i16 + 224 >> 2] | 0;
 i3 = i9 >>> 0 < i10 >>> 0;
 i10 = i3 ? i9 : i10;
 i9 = HEAP32[i16 + 228 >> 2] | 0;
 i1 = i9 >>> 0 < i10 >>> 0;
 i10 = i1 ? i9 : i10;
 i9 = HEAP32[i16 + 232 >> 2] | 0;
 i18 = i9 >>> 0 < i10 >>> 0;
 i3 = (HEAP32[i16 + 236 >> 2] | 0) >>> 0 < (i18 ? i9 : i10) >>> 0 ? 4 : i18 ? 3 : i1 ? 2 : i3 & 1;
 i1 = i16 + (i3 << 5) | 0;
 if (__ZN4File7IsValidEv(i1) | 0) __ZN4File5CloseEv(i1) | 0;
 if (__ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i1, i11, 0, 0) | 0) {
  HEAP32[i16 + 220 + (i3 << 2) >> 2] = HEAP32[i13 >> 2];
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i16 + 160 + (i3 * 12 | 0) | 0, i11) | 0;
  i18 = i1;
  STACKTOP = i17;
  return i18 | 0;
 }
 HEAP32[i15 >> 2] = (HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
 __Z6FormatPKcz(i12, gb + 390982 | 0, i15);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 391014 | 0, 54, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 HEAP32[i16 + 220 + (i3 << 2) >> 2] = 0;
 i1 = i16 + 160 + (i3 * 12 | 0) | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i16 + 160 + (i3 * 12 | 0) + 4 >> 2] = 0;
  i18 = 0;
  STACKTOP = i17;
  return i18 | 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
  i18 = 0;
  STACKTOP = i17;
  return i18 | 0;
 }
 return 0;
}

function __ZN5physx14PxVehicleDrive17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i2 + 416 | 0;
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i16 >> 2] = HEAP32[gb + 160496 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 160496 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 160496 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[gb + 160496 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[gb + 160496 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[gb + 160496 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[gb + 160496 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[gb + 160496 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i16 | 0, 32) | 0;
 HEAP32[i15 >> 2] = HEAP32[gb + 160528 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 160528 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 160528 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 160528 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 160528 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 160528 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 160528 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 160528 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = HEAP32[gb + 160560 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 160560 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 160560 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 160560 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 160560 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 160560 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 160560 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 160560 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 160592 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 160592 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 160592 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 160592 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 160592 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 160592 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 160592 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 160592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 160624 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 160624 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 160624 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 160624 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 160624 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 160624 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 160624 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 160624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 160656 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 160656 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 160656 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 160656 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 160656 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 160656 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 160656 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 160656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 160688 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 160688 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 160688 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 160688 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 160688 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 160688 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 160688 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 160688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 160720 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 160720 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 160720 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 160720 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 160720 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 160720 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 160720 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 160720 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 160752 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 160752 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 160752 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 160752 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 160752 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 160752 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 160752 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 160752 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 160784 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 160784 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 160784 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 160784 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 160784 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 160784 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 160784 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 160784 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 160816 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 160816 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 160816 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 160816 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 160816 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 160816 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 160816 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 160816 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 160848 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 160848 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 160848 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 160848 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 160848 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 160848 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 160848 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 160848 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 828300;
 HEAP32[i4 + 4 >> 2] = gb + 828315;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 224;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 160880 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 160880 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 160880 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 160880 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 160880 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 160880 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 160880 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 160880 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 if (!i2) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  f14 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * Math_fround(2.0));
  f17 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f16 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
  f15 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f14 * f15);
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f12 * f13));
  f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f7 * f11));
  f6 = Math_fround(Math_fround(f15 * f4) + Math_fround(Math_fround(f14 * f16) + Math_fround(f17 * Math_fround(Math_fround(f7 * f13) - Math_fround(f12 * f11)))));
  f5 = Math_fround(Math_fround(f13 * f4) + Math_fround(Math_fround(f12 * f16) + Math_fround(f17 * Math_fround(Math_fround(f14 * f11) - Math_fround(f7 * f15)))));
  f4 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f17 * Math_fround(Math_fround(f12 * f15) - Math_fround(f14 * f13)))) + Math_fround(f11 * f4));
  f6 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f6);
  f5 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f5);
  f4 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f4);
  f14 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(f17 * f14);
  f16 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f15 * f16));
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f12 = Math_fround(f12 + Math_fround(f13 * f7));
  f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f13 * f16) + Math_fround(f17 * f10))) - Math_fround(f15 * f7));
  f8 = Math_fround(Math_fround(Math_fround(f15 * f10) + Math_fround(Math_fround(f11 * f16) + Math_fround(f17 * f7))) - Math_fround(f13 * f14));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)) - Math_fround(f13 * f10)) - Math_fround(f11 * f7));
  HEAPF32[i1 >> 2] = Math_fround(f12 - Math_fround(f11 * f10));
  HEAPF32[i1 + 4 >> 2] = f9;
  HEAPF32[i1 + 8 >> 2] = f8;
  HEAPF32[i1 + 12 >> 2] = f7;
  HEAPF32[i1 + 16 >> 2] = f6;
  HEAPF32[i1 + 20 >> 2] = f5;
  i3 = i1 + 24 | 0;
  HEAPF32[i3 >> 2] = f4;
  return;
 } else {
  i2 = HEAP32[i2 + 64 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  f5 = Math_fround(HEAPF32[i2 + 52 >> 2]);
  f17 = Math_fround(f17 * Math_fround(-2.0));
  f5 = Math_fround(f5 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) * Math_fround(-2.0));
  f13 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f7 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  f10 = Math_fround(f17 * f11);
  f18 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f5 * f18));
  f12 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f15 * f12));
  f14 = Math_fround(-f11);
  f9 = Math_fround(-f18);
  f4 = Math_fround(-f12);
  f6 = Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(Math_fround(f17 * f7) - Math_fround(f13 * Math_fround(Math_fround(f15 * f18) - Math_fround(f5 * f12))))) * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f5 * f7) - Math_fround(f13 * Math_fround(Math_fround(f17 * f12) - Math_fround(f15 * f11))))) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f7) - Math_fround(f13 * Math_fround(Math_fround(f5 * f11) - Math_fround(f17 * f18)))) + Math_fround(f12 * f10)) * Math_fround(2.0));
  f12 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f18 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(f17 * f6);
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f5 * f8));
  f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f11 = Math_fround(Math_fround(f7 * f10) + f11);
  f15 = Math_fround(Math_fround(f17 * f11) + Math_fround(Math_fround(f18 * f6) + Math_fround(f12 * Math_fround(Math_fround(f5 * f10) - Math_fround(f7 * f8)))));
  f16 = Math_fround(Math_fround(f5 * f11) + Math_fround(Math_fround(f18 * f8) + Math_fround(f12 * Math_fround(Math_fround(f7 * f6) - Math_fround(f17 * f10)))));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f10) + Math_fround(f12 * Math_fround(Math_fround(f17 * f8) - Math_fround(f5 * f6)))) + Math_fround(f7 * f11));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f15);
  f16 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f16);
  f11 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f11);
  f6 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f14) + Math_fround(f13 * f17)) + Math_fround(f5 * f4)) - Math_fround(f7 * f9));
  f8 = Math_fround(Math_fround(Math_fround(f7 * f14) + Math_fround(Math_fround(f12 * f9) + Math_fround(f13 * f5))) - Math_fround(f17 * f4));
  f10 = Math_fround(Math_fround(Math_fround(f17 * f9) + Math_fround(Math_fround(f12 * f4) + Math_fround(f13 * f7))) - Math_fround(f5 * f14));
  f4 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f12) - Math_fround(f17 * f14)) - Math_fround(f5 * f9)) - Math_fround(f7 * f4));
  i3 = HEAP32[i3 >> 2] | 0;
  f7 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * Math_fround(2.0));
  f5 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * Math_fround(2.0));
  f14 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
  f17 = Math_fround(Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f9)) + Math_fround(f10 * f5));
  f15 = Math_fround(f15 + Math_fround(Math_fround(f6 * f17) + Math_fround(Math_fround(f14 * f7) + Math_fround(f4 * Math_fround(Math_fround(f8 * f5) - Math_fround(f10 * f9))))));
  f16 = Math_fround(f16 + Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f14 * f9) + Math_fround(f4 * Math_fround(Math_fround(f10 * f7) - Math_fround(f6 * f5))))));
  f17 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f14 * f5) + Math_fround(f4 * Math_fround(Math_fround(f6 * f9) - Math_fround(f8 * f7)))) + Math_fround(f10 * f17)));
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(f4 * f7);
  f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f6 * f5));
  f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f8 * f14));
  f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f10 * f7) + Math_fround(Math_fround(f8 * f5) + Math_fround(f4 * f11))) - Math_fround(f6 * f14));
  f13 = Math_fround(Math_fround(Math_fround(f6 * f11) + Math_fround(Math_fround(f10 * f5) + Math_fround(f4 * f14))) - Math_fround(f8 * f7));
  f14 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f5) - Math_fround(f6 * f7)) - Math_fround(f8 * f11)) - Math_fround(f10 * f14));
  HEAPF32[i1 >> 2] = Math_fround(f9 - Math_fround(f10 * f11));
  HEAPF32[i1 + 4 >> 2] = f12;
  HEAPF32[i1 + 8 >> 2] = f13;
  HEAPF32[i1 + 12 >> 2] = f14;
  HEAPF32[i1 + 16 >> 2] = f15;
  HEAPF32[i1 + 20 >> 2] = f16;
  i3 = i1 + 24 | 0;
  HEAPF32[i3 >> 2] = f17;
  return;
 }
}

function __ZN5physx22PxcPCMContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i6, i2, i3, i5, i1, i30) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f31 = f0, f32 = f0, f33 = f0;
 i27 = i2 + 16 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i27 + 4 >> 2] | 0;
 i27 = HEAP32[i27 + 8 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i3 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i3 = i3 + 16 | 0;
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i5 >> 2]);
 f19 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f12 - f22);
 f13 = Math_fround(f13 - f23);
 f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f24);
 f8 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f11 = Math_fround(Math_fround(Math_fround(f28 * f12) + Math_fround(f29 * f13)) + Math_fround(f25 * f14));
 f9 = Math_fround(Math_fround(Math_fround(f28 * f11) + Math_fround(Math_fround(f8 * f12) - Math_fround(f26 * Math_fround(Math_fround(f29 * f14) - Math_fround(f25 * f13))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f29 * f11) + Math_fround(Math_fround(f8 * f13) - Math_fround(f26 * Math_fround(Math_fround(f25 * f12) - Math_fround(f28 * f14))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f14) - Math_fround(f26 * Math_fround(Math_fround(f28 * f13) - Math_fround(f29 * f12)))) + Math_fround(f25 * f11)) * Math_fround(2.0));
 f12 = Math_fround(-f19);
 f13 = Math_fround(-f20);
 f14 = Math_fround(-f7);
 f31 = Math_fround(f21 + f31);
 f31 = Math_fround(f31 * f31);
 f17 = f9 < f19 ? f9 : f19;
 f16 = f10 < f20 ? f10 : f20;
 f15 = f11 < f7 ? f11 : f7;
 f12 = f17 > f12 ? f17 : f12;
 f13 = f16 > f13 ? f16 : f13;
 f14 = f15 > f14 ? f15 : f14;
 f15 = Math_fround(f9 - f12);
 f16 = Math_fround(f10 - f13);
 f17 = Math_fround(f11 - f14);
 f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)));
 if (!(f31 > f18)) {
  i30 = 0;
  return i30 | 0;
 }
 f31 = Math_fround(-f9);
 f32 = Math_fround(-f10);
 f33 = Math_fround(-f11);
 if (f7 >= (f11 > f33 ? f11 : f33) & (f20 >= (f10 > f32 ? f10 : f32) ? f19 >= (f9 > f31 ? f9 : f31) : 0)) {
  f23 = Math_fround(-f12);
  f33 = Math_fround(-f13);
  f22 = Math_fround(-f14);
  f23 = Math_fround(f19 - (f12 > f23 ? f12 : f23));
  f33 = Math_fround(f20 - (f13 > f33 ? f13 : f33));
  f22 = Math_fround(f7 - (f14 > f22 ? f14 : f22));
  i6 = f22 == f22 & Math_fround(0.0) == Math_fround(0.0) & (f33 >= f22 & f23 >= f22);
  i5 = f22 >= f23 & (f33 >= f23 & (f23 == f23 & Math_fround(0.0) == Math_fround(0.0)));
  i4 = f12 >= Math_fround(0.0);
  f31 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
  i4 = f13 >= Math_fround(0.0);
  f19 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
  i4 = f14 >= Math_fround(0.0);
  f32 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
  f24 = Math_fround(f19 * Math_fround(0.0));
  f18 = Math_fround(f32 * Math_fround(0.0));
  f20 = Math_fround(f31 * Math_fround(0.0));
  f20 = i6 ? f20 : i5 ? f31 : f20;
  f19 = i6 | i5 ? f24 : f19;
  f18 = i6 ? f32 : f18;
  f32 = Math_fround(Math_fround(f25 * f18) + Math_fround(Math_fround(f28 * f20) + Math_fround(f29 * f19)));
  f24 = Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(Math_fround(f8 * f20) + Math_fround(f26 * Math_fround(Math_fround(f29 * f18) - Math_fround(f25 * f19))))) * Math_fround(2.0));
  f31 = Math_fround(Math_fround(Math_fround(f29 * f32) + Math_fround(Math_fround(f8 * f19) + Math_fround(f26 * Math_fround(Math_fround(f25 * f20) - Math_fround(f28 * f18))))) * Math_fround(2.0));
  f32 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f18) + Math_fround(f26 * Math_fround(Math_fround(f28 * f19) - Math_fround(f29 * f20)))) + Math_fround(f25 * f32)) * Math_fround(2.0));
  f33 = Math_fround(Math_fround(-(i6 ? f22 : i5 ? f23 : f33)) - f21);
  i5 = i30 + 4096 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i6 + 1;
  i5 = i30 + (i6 << 6) | 0;
  HEAPF32[i5 >> 2] = f24;
  HEAPF32[i5 + 4 >> 2] = f31;
  HEAPF32[i5 + 8 >> 2] = f32;
  HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
  i5 = i30 + (i6 << 6) + 16 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i2;
  HEAP32[i5 + 8 >> 2] = i27;
  HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i30 + (i6 << 6) + 12 >> 2] = f33;
  HEAP32[i30 + (i6 << 6) + 48 >> 2] = -1;
  HEAP32[i30 + (i6 << 6) + 52 >> 2] = -1;
  i30 = 1;
  return i30 | 0;
 } else {
  f33 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f18))));
  f32 = Math_fround(f15 * f33);
  f31 = Math_fround(f16 * f33);
  f18 = Math_fround(f17 * f33);
  f33 = Math_fround(Math_fround(Math_fround(1.0) / f33) - f21);
  f21 = Math_fround(Math_fround(f25 * f18) + Math_fround(Math_fround(f28 * f32) + Math_fround(f29 * f31)));
  f19 = Math_fround(Math_fround(Math_fround(f28 * f21) + Math_fround(Math_fround(f8 * f32) + Math_fround(f26 * Math_fround(Math_fround(f29 * f18) - Math_fround(f25 * f31))))) * Math_fround(2.0));
  f20 = Math_fround(Math_fround(Math_fround(f29 * f21) + Math_fround(Math_fround(f8 * f31) + Math_fround(f26 * Math_fround(Math_fround(f25 * f32) - Math_fround(f28 * f18))))) * Math_fround(2.0));
  f21 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f18) + Math_fround(f26 * Math_fround(Math_fround(f28 * f31) - Math_fround(f29 * f32)))) + Math_fround(f25 * f21)) * Math_fround(2.0));
  f32 = Math_fround(Math_fround(f25 * f14) + Math_fround(Math_fround(f28 * f12) + Math_fround(f29 * f13)));
  f22 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(Math_fround(f8 * f12) + Math_fround(f26 * Math_fround(Math_fround(f29 * f14) - Math_fround(f25 * f13))))) * Math_fround(2.0)));
  f31 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f29 * f32) + Math_fround(Math_fround(f8 * f13) + Math_fround(f26 * Math_fround(Math_fround(f25 * f12) - Math_fround(f28 * f14))))) * Math_fround(2.0)));
  f32 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f14) + Math_fround(f26 * Math_fround(Math_fround(f28 * f13) - Math_fround(f29 * f12)))) + Math_fround(f25 * f32)) * Math_fround(2.0)));
  i6 = i30 + 4096 | 0;
  i27 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i27 + 1;
  i6 = i30 + (i27 << 6) | 0;
  HEAPF32[i6 >> 2] = f19;
  HEAPF32[i6 + 4 >> 2] = f20;
  HEAPF32[i6 + 8 >> 2] = f21;
  HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
  i6 = i30 + (i27 << 6) + 16 | 0;
  HEAPF32[i6 >> 2] = f22;
  HEAPF32[i6 + 4 >> 2] = f31;
  HEAPF32[i6 + 8 >> 2] = f32;
  HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i30 + (i27 << 6) + 12 >> 2] = f33;
  HEAP32[i30 + (i27 << 6) + 48 >> 2] = -1;
  HEAP32[i30 + (i27 << 6) + 52 >> 2] = -1;
  i30 = 1;
  return i30 | 0;
 }
 return 0;
}

function __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i4, i1, i2, i14, i15, i23) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i23 = i23 | 0;
 var f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
 f24 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f19 * f24);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f11 * f18));
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f26 * f10));
 f6 = Math_fround(Math_fround(f24 * f9) + Math_fround(Math_fround(f19 * f3) + Math_fround(f5 * Math_fround(Math_fround(f26 * f18) - Math_fround(f11 * f10)))));
 f7 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f11 * f3) + Math_fround(f5 * Math_fround(Math_fround(f19 * f10) - Math_fround(f26 * f24)))));
 f9 = Math_fround(Math_fround(Math_fround(f26 * f3) + Math_fround(f5 * Math_fround(Math_fround(f11 * f24) - Math_fround(f19 * f18)))) + Math_fround(f10 * f9));
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f6);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f7);
 f9 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f9);
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f5 * f19);
 f3 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f24 * f3));
 f26 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f18 * f26));
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(Math_fround(f18 * f3) + Math_fround(f5 * f17))) - Math_fround(f24 * f26));
 f25 = Math_fround(Math_fround(Math_fround(f24 * f17) + Math_fround(Math_fround(f10 * f3) + Math_fround(f5 * f26))) - Math_fround(f18 * f19));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f3) - Math_fround(f24 * f19)) - Math_fround(f18 * f17)) - Math_fround(f10 * f26));
 HEAPF32[i14 >> 2] = Math_fround(f11 - Math_fround(f10 * f17));
 i12 = i14 + 4 | 0;
 HEAPF32[i12 >> 2] = f8;
 i13 = i14 + 8 | 0;
 HEAPF32[i13 >> 2] = f25;
 i16 = i14 + 12 | 0;
 HEAPF32[i16 >> 2] = f26;
 i20 = i14 + 16 | 0;
 HEAPF32[i20 >> 2] = f6;
 i21 = i14 + 20 | 0;
 HEAPF32[i21 >> 2] = f7;
 i22 = i14 + 24 | 0;
 HEAPF32[i22 >> 2] = f9;
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i4 + 48 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(HEAPF32[i4 + 52 >> 2]) * Math_fround(2.0));
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f25 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f9 * f8);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f7 * f10));
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f6 * f11));
 f18 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f9 * f25) + Math_fround(f26 * Math_fround(Math_fround(f6 * f10) - Math_fround(f7 * f11)))));
 f19 = Math_fround(Math_fround(f10 * f17) + Math_fround(Math_fround(f7 * f25) + Math_fround(f26 * Math_fround(Math_fround(f9 * f11) - Math_fround(f6 * f8)))));
 f17 = Math_fround(Math_fround(Math_fround(f6 * f25) + Math_fround(f26 * Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10)))) + Math_fround(f11 * f17));
 f18 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f18);
 f19 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f19);
 f17 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f17);
 f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f7 = Math_fround(f26 * f9);
 f25 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f8 * f25));
 f6 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f10 * f6));
 f24 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f11 * f24));
 f3 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f10 * f25) + Math_fround(f26 * f24))) - Math_fround(f8 * f6));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f24) + Math_fround(Math_fround(f11 * f25) + Math_fround(f26 * f6))) - Math_fround(f10 * f9));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f8 * f9)) - Math_fround(f10 * f24)) - Math_fround(f11 * f6));
 HEAPF32[i15 >> 2] = f7;
 i1 = i15 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 i2 = i15 + 8 | 0;
 HEAPF32[i2 >> 2] = f5;
 i4 = i15 + 12 | 0;
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i15 + 16 >> 2] = f18;
 HEAPF32[i15 + 20 >> 2] = f19;
 HEAPF32[i15 + 24 >> 2] = f17;
 f11 = Math_fround(HEAPF32[i14 >> 2]);
 f24 = Math_fround(f11 * f7);
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f10 * f3));
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f9 * f5));
 f8 = Math_fround(HEAPF32[i16 >> 2]);
 if (Math_fround(f24 + Math_fround(f8 * f6)) < Math_fround(0.0)) {
  f7 = Math_fround(-f7);
  f3 = Math_fround(-f3);
  f5 = Math_fround(-f5);
  f6 = Math_fround(-f6);
  HEAPF32[i15 >> 2] = f7;
  HEAPF32[i1 >> 2] = f3;
  HEAPF32[i2 >> 2] = f5;
  HEAPF32[i4 >> 2] = f6;
  f11 = Math_fround(HEAPF32[i14 >> 2]);
  f10 = Math_fround(HEAPF32[i12 >> 2]);
  f9 = Math_fround(HEAPF32[i13 >> 2]);
  f8 = Math_fround(HEAPF32[i16 >> 2]);
 }
 f27 = Math_fround(-f11);
 f10 = Math_fround(-f10);
 f11 = Math_fround(-f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i20 >> 2]));
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f19 = Math_fround(f19 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i22 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f26 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(f19 * f10)) + Math_fround(f17 * f11));
 f24 = Math_fround(Math_fround(f26 * f27) + Math_fround(Math_fround(f9 * f18) + Math_fround(f8 * Math_fround(Math_fround(f17 * f10) - Math_fround(f19 * f11)))));
 f25 = Math_fround(Math_fround(f26 * f10) + Math_fround(Math_fround(f9 * f19) + Math_fround(f8 * Math_fround(Math_fround(f18 * f11) - Math_fround(f17 * f27)))));
 f26 = Math_fround(Math_fround(Math_fround(f9 * f17) + Math_fround(f8 * Math_fround(Math_fround(f19 * f27) - Math_fround(f18 * f10)))) + Math_fround(f26 * f11));
 f17 = Math_fround(Math_fround(Math_fround(f7 * f11) + Math_fround(Math_fround(f6 * f10) + Math_fround(f8 * f3))) - Math_fround(f5 * f27));
 f18 = Math_fround(Math_fround(Math_fround(f3 * f27) + Math_fround(Math_fround(f6 * f11) + Math_fround(f8 * f5))) - Math_fround(f7 * f10));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f6) - Math_fround(f7 * f27)) - Math_fround(f3 * f10)) - Math_fround(f5 * f11));
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f27)) + Math_fround(f5 * f10)) - Math_fround(f3 * f11));
 HEAPF32[i23 + 4 >> 2] = f17;
 HEAPF32[i23 + 8 >> 2] = f18;
 HEAPF32[i23 + 12 >> 2] = f19;
 HEAPF32[i23 + 16 >> 2] = f24;
 HEAPF32[i23 + 20 >> 2] = f25;
 HEAPF32[i23 + 24 >> 2] = f26;
 return;
}

function __ZN5physx25PxcDiscreteNarrowPhasePCMERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE(i15, i17) {
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 32 | 0;
 i12 = i18;
 i10 = i18 + 60 | 0;
 i16 = i18 + 64 | 0;
 i1 = HEAP16[i17 + 22 >> 1] | 0;
 if (!(i1 & 512)) {
  STACKTOP = i18;
  return;
 }
 i1 = i1 & 65535;
 if (!(i1 & 32)) i2 = 0; else i2 = (HEAP8[(HEAP32[i17 + 64 >> 2] | 0) + 29 >> 0] & 1) == 0;
 if (!(i1 & 64)) i1 = 0; else i1 = (HEAP8[(HEAP32[i17 + 68 >> 2] | 0) + 29 >> 0] & 1) == 0;
 i6 = HEAP8[i17 + 96 >> 0] | 0;
 i7 = i6 & 255;
 i8 = HEAP8[i17 + 97 >> 0] | 0;
 i9 = i8 & 255;
 if (!(i2 | i1)) {
  __Z11CopyBuffersRN5physx13PxcNpWorkUnitERNS_18PxcNpThreadContextEb(i17, i15, 0);
  STACKTOP = i18;
  return;
 }
 i13 = i15 + 4496 | 0;
 i4 = HEAP32[i17 + 72 >> 2] | 0;
 i5 = HEAP32[i17 + 76 >> 2] | 0;
 i14 = i17 + 44 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!(i1 & 1)) {
  i3 = HEAP32[i14 >> 2] | 0;
  i20 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
  i19 = getTempRet0() | 0;
  i2 = _i64Add(i3 | 0, 0, 127, 0) | 0;
  i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
  i1 = getTempRet0() | 0;
  i19 = _i64Subtract(1, 0, i20 | 0, i19 | 0) | 0;
  i1 = _i64Add(i19 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
  i2 = getTempRet0() | 0;
  while (1) {
   i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
  }
  i3 = HEAP32[i14 >> 2] | 0;
  i19 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
  i20 = getTempRet0() | 0;
  i2 = _i64Add(i3 | 0, 0, 255, 0) | 0;
  i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
  i1 = getTempRet0() | 0;
  i20 = _i64Subtract(1, 0, i19 | 0, i20 | 0) | 0;
  i1 = _i64Add(i20 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
  i2 = getTempRet0() | 0;
  while (1) {
   i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   } else i3 = i3 + 64 | 0;
  }
 } else {
  __ZN5physx2Gu33MultiplePersistentContactManifold10fromBufferEPh(i13, i1 & -2);
  HEAP32[i14 >> 2] = i13 | 1;
  i3 = 1;
 }
 i20 = HEAP32[i17 + 100 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i15 + 8752 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 + (i20 * 28 | 0) >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 24 >> 2];
 i20 = HEAP32[i17 + 104 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 + (i20 * 28 | 0) >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i2 + (i20 * 28 | 0) + 24 >> 2];
 f21 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 HEAPF32[i10 >> 2] = Math_fround(f21 + Math_fround(HEAPF32[i5 + 28 >> 2]));
 i20 = (i8 & 255) < (i6 & 255);
 i6 = i20 ? i9 : i7;
 i8 = i20 ? i7 : i9;
 i7 = i15 + 104 + (i6 * 28 | 0) + (i8 << 2) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = HEAP32[gb + 105216 + (i6 * 28 | 0) + (i8 << 2) >> 2] | 0;
 i2 = i15 + 4480 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP16[i17 + 98 >> 1] = 0;
 HEAP16[i17 + 20 >> 1] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP16[i17 + 16 >> 1] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 0;
 HEAP32[i17 + 32 >> 2] = 0;
 i9 = i20 ? i5 : i4;
 i19 = i20 ? i4 : i5;
 mftCall_iiiiiiii(i7 | 0, i9 + 36 | 0, i19 + 36 | 0, (i20 ? i12 : i11) | 0, (i20 ? i11 : i12) | 0, i10 | 0, i14 | 0, i15 + 384 | 0) | 0;
 mftCall_iiiii(HEAP32[gb + 104828 + (i6 * 28 | 0) + (i8 << 2) >> 2] | 0, i9 | 0, i19 | 0, i15 | 0, i16 | 0) | 0;
 if (!((HEAP32[i2 >> 2] | 0) == 0 | i20 ^ 1)) {
  i1 = 0;
  do {
   i20 = i15 + 384 + (i1 << 6) | 0;
   f23 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
   i12 = i15 + 384 + (i1 << 6) + 4 | 0;
   f22 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
   i19 = i15 + 384 + (i1 << 6) + 8 | 0;
   f21 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i20 >> 2] = f23;
   HEAPF32[i12 >> 2] = f22;
   HEAPF32[i19 >> 2] = f21;
   i19 = i15 + 384 + (i1 << 6) + 48 | 0;
   i12 = i15 + 384 + (i1 << 6) + 52 | 0;
   i20 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i20;
   i12 = i16 + (i1 << 2) | 0;
   i20 = i16 + (i1 << 2) + 2 | 0;
   i19 = HEAP16[i12 >> 1] | 0;
   HEAP16[i12 >> 1] = HEAP16[i20 >> 1] | 0;
   HEAP16[i20 >> 1] = i19;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if (i3) {
  i8 = i15 + 4548 | 0;
  i9 = ((HEAPU8[i8 >> 0] | 0) << 4) + 48 + ((HEAPU8[i13 + 53 >> 0] | 0) * 48 | 0) | 0;
  i10 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i15 + 356 | 0, i9) | 0;
  i1 = HEAP8[i8 >> 0] | 0;
  HEAP32[i10 + 32 >> 2] = i1 & 255;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
  if (i1 << 24 >> 24) {
   i6 = 0;
   i7 = i10 + 48 | 0;
   while (1) {
    i3 = i7 + 16 | 0;
    i4 = HEAPU8[i13 + 48 + i6 >> 0] | 0;
    i5 = i13 + 64 + (i4 * 400 | 0) + 384 | 0;
    i20 = HEAP32[i5 >> 2] | 0;
    HEAP32[i7 >> 2] = i20;
    if (!i20) i2 = 0; else {
     i2 = 0;
     do {
      i1 = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 4 >> 2] | 0;
      i20 = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 8 >> 2] | 0;
      i19 = i3 + (i2 * 48 | 0) | 0;
      HEAP32[i19 >> 2] = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) >> 2];
      HEAP32[i19 + 4 >> 2] = i1;
      HEAP32[i19 + 8 >> 2] = i20;
      HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
      i19 = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 20 >> 2] | 0;
      i20 = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 24 >> 2] | 0;
      i1 = i3 + (i2 * 48 | 0) + 16 | 0;
      HEAP32[i1 >> 2] = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 16 >> 2];
      HEAP32[i1 + 4 >> 2] = i19;
      HEAP32[i1 + 8 >> 2] = i20;
      HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
      _memmove(i3 + (i2 * 48 | 0) + 32 | 0, i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 32 | 0, 16) | 0;
      HEAP32[i3 + (i2 * 48 | 0) + 12 >> 2] = HEAP32[i13 + 64 + (i4 * 400 | 0) + (i2 << 6) + 48 >> 2];
      i2 = i2 + 1 | 0;
      i1 = HEAP32[i5 >> 2] | 0;
     } while (i2 >>> 0 < i1 >>> 0);
     i2 = i1;
     i1 = HEAP8[i8 >> 0] | 0;
    }
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= (i1 & 255) >>> 0) break; else i7 = i7 + ((i2 * 48 | 0) + 16) | 0;
   }
  }
  HEAP32[i14 >> 2] = i10 | 1;
  HEAP16[i17 + 56 >> 1] = i9;
 }
 __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i17, i15, i16) | 0;
 STACKTOP = i18;
 return;
}

function __ZN16HumanPoseHandler12SetHumanPoseER8Vector3fR11QuaternionfPf(i10, i1, i2, i7) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1824 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 1776 | 0;
 i8 = i24 + 888 | 0;
 i9 = i24;
 i22 = i10 + 16 | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i11 = i4 + 28 | 0;
 i11 = HEAP32[i11 + (HEAP32[i11 >> 2] | 0) >> 2] | 0;
 i25 = HEAP32[i4 >> 2] | 0;
 i6 = i4 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i6 = (i3 | 0) == 0 ? 0 : i3 + i6 | 0;
 i3 = i6 + 40 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i12 = i19 + 28 | 0;
 i13 = i19 + 24 | 0;
 i14 = i19 + 32 | 0;
 i15 = i19 + 36 | 0;
 i23 = i10 + 20 | 0;
 __ZNK9Transform11GetPositionEv(i8, HEAP32[i23 >> 2] | 0);
 i17 = HEAP32[i8 + 4 >> 2] | 0;
 i18 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
 i16 = i19 + 4 | 0;
 HEAP32[i16 >> 2] = i17;
 i17 = i19 + 8 | 0;
 HEAP32[i17 >> 2] = i18;
 i18 = i19 + 12 | 0;
 __ZNK9Transform11GetRotationEv(i8, HEAP32[i23 >> 2] | 0);
 i21 = HEAP32[i8 + 4 >> 2] | 0;
 i26 = HEAP32[i8 + 8 >> 2] | 0;
 i27 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
 i20 = i19 + 16 | 0;
 HEAP32[i20 >> 2] = i21;
 i21 = i19 + 20 | 0;
 HEAP32[i21 >> 2] = i26;
 HEAP32[i13 >> 2] = i27;
 __ZNK9Transform18GetWorldScaleLossyEv(i8, HEAP32[i23 >> 2] | 0);
 i27 = HEAP32[i8 + 4 >> 2] | 0;
 i26 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i14 >> 2] = i27;
 HEAP32[i15 >> 2] = i26;
 __ZN7mecanim5human9HumanPoseC2Ev(i8);
 __ZN7mecanim5human9HumanPoseC2Ev(i9);
 i26 = HEAP32[i1 + 4 >> 2] | 0;
 i27 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i26;
 HEAP32[i8 + 8 >> 2] = i27;
 i27 = HEAP32[i2 + 4 >> 2] | 0;
 i26 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 16 >> 2] = i27;
 HEAP32[i8 + 20 >> 2] = i26;
 HEAP32[i8 + 24 >> 2] = i1;
 _memcpy(i8 + 596 | 0, i7 | 0, 208) | 0;
 i4 = (i25 | 0) == 0 ? 0 : i25 + i4 | 0;
 i5 = (i5 | 0) == 0 ? 0 : i3 + i5 | 0;
 i1 = i8 + 364 | 0;
 i2 = i7 + 208 | 0;
 i3 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 500 | 0;
 i2 = i7 + 288 | 0;
 i3 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i27 = i10 + 36 | 0;
 i25 = i10 + 40 | 0;
 __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_(i6, i8, 0, i19, i9, HEAP32[i27 >> 2] | 0, HEAP32[i25 >> 2] | 0);
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(HEAP32[i27 >> 2] | 0, HEAP32[i25 >> 2] | 0);
 __ZN7mecanim5human10TwistSolveEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_(i6, HEAP32[i25 >> 2] | 0, HEAP32[i10 + 44 >> 2] | 0);
 i9 = (HEAP32[i22 >> 2] | 0) + 4 | 0;
 i27 = HEAP32[i9 >> 2] | 0;
 i2 = i10 + 28 | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i27 | 0) == 0 ? 0 : i9 + i27 | 0, HEAP32[i2 >> 2] | 0);
 i27 = HEAP32[i2 >> 2] | 0;
 i9 = i27 + 4 | 0;
 i9 = i9 + (HEAP32[i9 >> 2] | 0) | 0;
 i6 = i9;
 i1 = HEAP32[i16 >> 2] | 0;
 i26 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i26;
 i26 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 16 >> 2] = i26;
 HEAP32[i6 + 20 >> 2] = i21;
 HEAP32[i6 + 24 >> 2] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i21 = HEAP32[i15 >> 2] | 0;
 HEAP32[i6 + 28 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 32 >> 2] = i1;
 HEAP32[i6 + 36 >> 2] = i21;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i4, i27, i27, i11, 0);
 i21 = HEAP32[i25 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i5, i21, i21, 1, 1);
 i21 = (HEAP32[i25 >> 2] | 0) + 4 | 0;
 i21 = i21 + (HEAP32[i21 >> 2] | 0) | 0;
 i27 = i21;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 i26 = HEAP32[i1 + (i11 * 40 | 0) + 4 >> 2] | 0;
 i20 = HEAP32[i1 + (i11 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i1 + (i11 * 40 | 0) >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 HEAP32[i27 + 8 >> 2] = i20;
 i20 = HEAP32[i1 + (i11 * 40 | 0) + 16 >> 2] | 0;
 i26 = HEAP32[i1 + (i11 * 40 | 0) + 20 >> 2] | 0;
 i21 = HEAP32[i1 + (i11 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i27 + 12 >> 2] = HEAP32[i1 + (i11 * 40 | 0) + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = i20;
 HEAP32[i27 + 20 >> 2] = i26;
 HEAP32[i27 + 24 >> 2] = i21;
 i21 = HEAP32[i1 + (i11 * 40 | 0) + 32 >> 2] | 0;
 i26 = HEAP32[i1 + (i11 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i27 + 28 >> 2] = HEAP32[i1 + (i11 * 40 | 0) + 28 >> 2];
 HEAP32[i27 + 32 >> 2] = i21;
 HEAP32[i27 + 36 >> 2] = i26;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i4, i6, i6, i11, 0);
 i6 = HEAP32[i25 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i5, i6, i6, 1, 1);
 i25 = HEAP32[i25 >> 2] | 0;
 i6 = i25 + 4 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
 i27 = i6;
 i26 = HEAP32[i2 >> 2] | 0;
 i21 = i26 + 4 | 0;
 i21 = i21 + (HEAP32[i21 >> 2] | 0) | 0;
 i1 = HEAP32[i21 + (i11 * 40 | 0) + 4 >> 2] | 0;
 i20 = HEAP32[i21 + (i11 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i21 + (i11 * 40 | 0) >> 2];
 HEAP32[i27 + 4 >> 2] = i1;
 HEAP32[i27 + 8 >> 2] = i20;
 i20 = HEAP32[i21 + (i11 * 40 | 0) + 16 >> 2] | 0;
 i1 = HEAP32[i21 + (i11 * 40 | 0) + 20 >> 2] | 0;
 i6 = HEAP32[i21 + (i11 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i27 + 12 >> 2] = HEAP32[i21 + (i11 * 40 | 0) + 12 >> 2];
 HEAP32[i27 + 16 >> 2] = i20;
 HEAP32[i27 + 20 >> 2] = i1;
 HEAP32[i27 + 24 >> 2] = i6;
 i6 = HEAP32[i21 + (i11 * 40 | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i21 + (i11 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i27 + 28 >> 2] = HEAP32[i21 + (i11 * 40 | 0) + 28 >> 2];
 HEAP32[i27 + 32 >> 2] = i6;
 HEAP32[i27 + 36 >> 2] = i1;
 i27 = HEAP32[i22 >> 2] | 0;
 i1 = i27 + 28 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EEjPKi(i25, i26, HEAP32[i27 + 24 >> 2] | 0, (i6 | 0) == 0 ? 0 : i6 + i1 | 0);
 i1 = HEAP32[i10 + 24 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) <= 1) {
  i27 = HEAP32[i23 >> 2] | 0;
  __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i27);
  STACKTOP = i24;
  return;
 }
 i5 = i1 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
 i3 = i2;
 i1 = 1;
 do {
  i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i4 | 0) {
   __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i4, (HEAP32[i2 >> 2] | 0) + i3 + (i1 * 40 | 0) | 0);
   __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i4, (HEAP32[i2 >> 2] | 0) + i3 + (i1 * 40 | 0) + 12 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i27 = HEAP32[i23 >> 2] | 0;
 __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i27);
 STACKTOP = i24;
 return;
}

function __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj(i22, i10, i11, i1) {
 i22 = i22 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i24 + 16 | 0;
 i8 = i24;
 i13 = i24 + 232 | 0;
 i21 = i24 + 168 | 0;
 i23 = i24 + 96 | 0;
 i12 = i24 + 28 | 0;
 if ((i10 | 0) == 0 | i1 >>> 0 > 11) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 HEAP32[i22 >> 2] = i10;
 i2 = i23;
 i3 = i2 + 68 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = 0;
 do {
  i20 = HEAP8[i11 + i2 >> 0] | 0;
  i3 = i23 + ((i20 & 255) << 2) | 0;
  if (i20 << 24 >> 24) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 i4 = 0;
 i2 = 0;
 i5 = 0;
 i6 = -1;
 i7 = 1;
 while (1) {
  i3 = HEAP32[i23 + (i7 << 2) >> 2] | 0;
  if (!i3) {
   HEAP32[i22 + 28 + (i7 + -1 << 2) >> 2] = 0;
   i20 = i5;
  } else {
   i20 = i7 + -1 | 0;
   HEAP32[i21 + (i20 << 2) >> 2] = i4;
   i4 = i3 + i4 | 0;
   i19 = 16 - i7 | 0;
   HEAP32[i22 + 28 + (i20 << 2) >> 2] = (i4 + -1 << i19 | (1 << i19) + -1) + 1;
   HEAP32[i22 + 96 + (i20 << 2) >> 2] = i2;
   HEAP32[i12 + (i7 << 2) >> 2] = i2;
   i2 = i3 + i2 | 0;
   i20 = i5 >>> 0 > i7 >>> 0 ? i5 : i7;
   i6 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
  }
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == 17) break; else {
   i4 = i4 << 1;
   i5 = i20;
  }
 }
 HEAP32[i22 + 4 >> 2] = i2;
 i5 = i22 + 172 | 0;
 do if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  i3 = i2 + -1 | 0;
  if (!((i2 | 0) != 0 & (i3 & i2 | 0) == 0)) {
   i2 = i3 >>> 16 | i3;
   i2 = i2 >>> 8 | i2;
   i2 = i2 >>> 4 | i2;
   i2 = i2 >>> 2 | i2;
   i2 = (i2 >>> 1 | i2) + 1 | 0;
   i2 = i2 >>> 0 > i10 >>> 0 ? i10 : i2;
  }
  HEAP32[i5 >> 2] = i2;
  i4 = i22 + 176 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if (i2 | 0) {
   i2 = i2 + -8 | 0;
   if (!(i2 & 7)) {
    mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
    break;
   } else {
    HEAP32[i8 >> 2] = gb + 401209;
    HEAP32[i8 + 4 >> 2] = 2513;
    HEAP32[i8 + 8 >> 2] = gb + 401349;
    _sprintf(i13, gb + 401176 | 0, i8) | 0;
    _puts(i13) | 0;
    break;
   }
  } while (0);
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = i2 | 0 ? i2 : 1;
  i3 = __ZN4crnd11crnd_mallocEjPj((i2 << 1) + 8 | 0, 0) | 0;
  if (!i3) {
   HEAP32[i4 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[i3 >> 2] = ~i2;
   HEAP32[i4 >> 2] = i3 + 8;
   i9 = 21;
   break;
  }
 } else i9 = 21; while (0);
 L31 : do if ((i9 | 0) == 21) {
  i19 = i22 + 24 | 0;
  HEAP8[i19 >> 0] = i6;
  HEAP8[i22 + 25 >> 0] = i20;
  i4 = i22 + 176 | 0;
  i2 = 0;
  do {
   i3 = HEAP8[i11 + i2 >> 0] | 0;
   if (i3 << 24 >> 24) {
    i17 = i12 + ((i3 & 255) << 2) | 0;
    i18 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = i18 + 1;
    HEAP16[(HEAP32[i4 >> 2] | 0) + (i18 << 1) >> 1] = i2;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  i17 = (i6 & 255) >>> 0 < i1 >>> 0 ? i1 : 0;
  i18 = i22 + 8 | 0;
  HEAP32[i18 >> 2] = i17;
  i16 = (i17 | 0) != 0;
  if (i16) {
   i4 = 1 << i17;
   i2 = i22 + 164 | 0;
   do if (i4 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
    HEAP32[i2 >> 2] = i4;
    i5 = i22 + 168 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    do if (i2 | 0) {
     i2 = i2 + -8 | 0;
     if (!(i2 & 7)) {
      mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
      break;
     } else {
      HEAP32[i14 >> 2] = gb + 401209;
      HEAP32[i14 + 4 >> 2] = 2513;
      HEAP32[i14 + 8 >> 2] = gb + 401349;
      _sprintf(i13, gb + 401176 | 0, i14) | 0;
      _puts(i13) | 0;
      break;
     }
    } while (0);
    i3 = i4 << 2;
    i2 = __ZN4crnd11crnd_mallocEjPj(i3 + 8 | 0, 0) | 0;
    if (!i2) {
     HEAP32[i5 >> 2] = 0;
     i1 = 0;
     break L31;
    } else {
     i15 = i2 + 8 | 0;
     HEAP32[i2 + 4 >> 2] = i4;
     HEAP32[i2 >> 2] = ~i4;
     HEAP32[i5 >> 2] = i15;
     i2 = i15;
     break;
    }
   } else {
    i2 = i22 + 168 | 0;
    i3 = i4 << 2;
    i5 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
   } while (0);
   _memset(i2 | 0, -1, i3 | 0) | 0;
   i13 = i22 + 176 | 0;
   i12 = 1;
   do {
    if (HEAP32[i23 + (i12 << 2) >> 2] | 0) {
     i14 = i17 - i12 | 0;
     i15 = 1 << i14;
     i2 = i12 + -1 | 0;
     i3 = HEAP32[i21 + (i2 << 2) >> 2] | 0;
     i11 = HEAP32[i22 + 28 + (i2 << 2) >> 2] | 0;
     i11 = (i11 | 0) == 0 ? -1 : (i11 + -1 | 0) >>> (16 - i12 | 0);
     if (i3 >>> 0 <= i11 >>> 0) {
      i7 = (HEAP32[i22 + 96 + (i2 << 2) >> 2] | 0) - i3 | 0;
      i8 = HEAP32[i13 >> 2] | 0;
      i9 = i12 << 16;
      i10 = HEAP32[i5 >> 2] | 0;
      do {
       i4 = i3 << i14;
       i6 = HEAPU16[i8 + (i7 + i3 << 1) >> 1] | 0 | i9;
       i2 = 0;
       do {
        HEAP32[i10 + (i2 + i4 << 2) >> 2] = i6;
        i2 = i2 + 1 | 0;
       } while (i2 >>> 0 < i15 >>> 0);
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 <= i11 >>> 0);
     }
    }
    i12 = i12 + 1 | 0;
   } while (i17 >>> 0 >= i12 >>> 0);
  }
  i2 = i22 + 96 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 >> 2] | 0);
  i2 = i22 + 100 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 4 >> 2] | 0);
  i2 = i22 + 104 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 8 >> 2] | 0);
  i2 = i22 + 108 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 12 >> 2] | 0);
  i2 = i22 + 112 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 16 >> 2] | 0);
  i2 = i22 + 116 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 20 >> 2] | 0);
  i2 = i22 + 120 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 24 >> 2] | 0);
  i2 = i22 + 124 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 28 >> 2] | 0);
  i2 = i22 + 128 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 32 >> 2] | 0);
  i2 = i22 + 132 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 36 >> 2] | 0);
  i2 = i22 + 136 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 40 >> 2] | 0);
  i2 = i22 + 140 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 44 >> 2] | 0);
  i2 = i22 + 144 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 48 >> 2] | 0);
  i2 = i22 + 148 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 52 >> 2] | 0);
  i2 = i22 + 152 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 56 >> 2] | 0);
  i2 = i22 + 156 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[i21 + 60 >> 2] | 0);
  i2 = i22 + 16 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = i22 + 20 | 0;
  HEAP32[i3 >> 2] = HEAPU8[i19 >> 0];
  L66 : do if (i16) {
   do {
    if (!i1) break L66;
    i21 = i1;
    i1 = i1 + -1 | 0;
   } while (!(HEAP32[i23 + (i21 << 2) >> 2] | 0));
   HEAP32[i2 >> 2] = HEAP32[i22 + 28 + (i1 << 2) >> 2];
   i1 = i17 + 1 | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 <= i20 >>> 0) {
    while (1) {
     if (HEAP32[i23 + (i1 << 2) >> 2] | 0) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 > i20 >>> 0) break L66;
    }
    HEAP32[i3 >> 2] = i1;
   }
  } while (0);
  HEAP32[i22 + 92 >> 2] = -1;
  HEAP32[i22 + 160 >> 2] = 1048575;
  HEAP32[i22 + 12 >> 2] = 32 - (HEAP32[i18 >> 2] | 0);
  i1 = 1;
 } while (0);
 i23 = i1;
 STACKTOP = i24;
 return i23 | 0;
}

function __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_I13BoneInfluenceLj16EERS_ItLj2EES7_(i25, i27, i28, i29) {
 i25 = i25 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, f30 = f0, f31 = f0, i32 = 0;
 i26 = i25 + 12 | 0;
 i5 = HEAP32[i26 >> 2] | 0;
 i6 = i5 + -1 | 0;
 i6 = i6 >>> 1 | i6;
 i6 = i6 >>> 2 | i6;
 i6 = i6 >>> 4 | i6;
 i6 = i6 >>> 8 | i6;
 i6 = i6 >>> 16 | i6;
 i1 = i6 + 1 | 0;
 i7 = (i1 | 0) == 0 & 1;
 i1 = i7 + i1 | 0;
 i24 = i1 + i5 | 0;
 i24 = __Znaj(i24 >>> 0 > 1073741823 ? -1 : i24 << 2) | 0;
 i22 = i24 + (i1 << 2) | 0;
 i2 = i29 + 12 | 0;
 HEAP32[i2 >> 2] = i5;
 i3 = i29 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i5 << 1, 2, i29 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i29 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i29 >> 2] = i21;
  break;
 } while (0);
 _memset(i24 | 0, -1, i1 << 2 | 0) | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) i4 = 0; else {
  i20 = i7 + i6 | 0;
  i21 = i27 + 12 | 0;
  i4 = 0;
  i19 = 0;
  i18 = i1;
  while (1) {
   i12 = HEAP32[i25 >> 2] | 0;
   i13 = i12 + (i19 * 12 | 0) | 0;
   i9 = HEAP32[i13 >> 2] | 0;
   i10 = HEAP32[i12 + (i19 * 12 | 0) + 4 >> 2] | 0;
   i11 = HEAP32[i12 + (i19 * 12 | 0) + 8 >> 2] | 0;
   i14 = (i10 * 11 | 0) + i9 + (Math_imul(i11, -17) | 0) & 2147483647;
   i14 = i24 + (((i14 >>> 12 ^ i14 ^ i14 >>> 22) & i20) << 2) | 0;
   i1 = HEAP32[i14 >> 2] | 0;
   f15 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   L11 : do if ((i1 | 0) == -1) i23 = 25; else {
    i2 = HEAP32[i27 >> 2] | 0;
    i3 = i2 + (i19 << 5) | 0;
    i5 = i2 + (i19 << 5) + 16 | 0;
    i6 = i2 + (i19 << 5) + 4 | 0;
    i7 = i2 + (i19 << 5) + 20 | 0;
    i8 = i2 + (i19 << 5) + 8 | 0;
    i9 = i2 + (i19 << 5) + 24 | 0;
    i10 = i2 + (i19 << 5) + 12 | 0;
    i11 = i2 + (i19 << 5) + 28 | 0;
    L13 : do if (!(HEAP32[i21 >> 2] | 0)) while (1) {
     if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) >> 2]) == f15) if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) + 4 >> 2]) == f16) if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) + 8 >> 2]) == f17) break L13;
     i1 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) {
      i23 = 25;
      break L11;
     }
    } else while (1) {
     if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) >> 2]) == f15) if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) + 4 >> 2]) == f16) if (Math_fround(HEAPF32[i12 + (i1 * 12 | 0) + 8 >> 2]) == f17) {
      f30 = Math_fround(HEAPF32[i3 >> 2]);
      f30 = Math_fround(f30 - Math_fround(HEAPF32[i2 + (i1 << 5) >> 2]));
      i32 = f30 < Math_fround(0.0);
      f31 = Math_fround(-f30);
      if ((i32 ? f31 : f30) <= Math_fround(9.99999997e-07)) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i2 + (i1 << 5) + 16 >> 2] | 0)) {
       f31 = Math_fround(HEAPF32[i6 >> 2]);
       f31 = Math_fround(f31 - Math_fround(HEAPF32[i2 + (i1 << 5) + 4 >> 2]));
       i32 = f31 < Math_fround(0.0);
       f30 = Math_fround(-f31);
       if ((i32 ? f30 : f31) <= Math_fround(9.99999997e-07)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 + (i1 << 5) + 20 >> 2] | 0)) {
        f31 = Math_fround(HEAPF32[i8 >> 2]);
        f31 = Math_fround(f31 - Math_fround(HEAPF32[i2 + (i1 << 5) + 8 >> 2]));
        i32 = f31 < Math_fround(0.0);
        f30 = Math_fround(-f31);
        if ((i32 ? f30 : f31) <= Math_fround(9.99999997e-07)) if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i2 + (i1 << 5) + 24 >> 2] | 0)) {
         f31 = Math_fround(HEAPF32[i10 >> 2]);
         f31 = Math_fround(f31 - Math_fround(HEAPF32[i2 + (i1 << 5) + 12 >> 2]));
         i32 = f31 < Math_fround(0.0);
         f30 = Math_fround(-f31);
         if ((i32 ? f30 : f31) <= Math_fround(9.99999997e-07)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + (i1 << 5) + 28 >> 2] | 0)) break L13;
        }
       }
      }
     }
     i1 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) {
      i23 = 25;
      break L11;
     }
    } while (0);
    HEAP16[(HEAP32[i29 >> 2] | 0) + (i19 << 1) >> 1] = i1;
    i1 = i18;
   } while (0);
   if ((i23 | 0) == 25) {
    i23 = 0;
    HEAP16[(HEAP32[i29 >> 2] | 0) + (i19 << 1) >> 1] = i4;
    i32 = i12 + (i4 * 12 | 0) | 0;
    HEAP32[i32 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i32 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i32 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    if (HEAP32[i21 >> 2] | 0) {
     i18 = HEAP32[i27 >> 2] | 0;
     i32 = i18 + (i4 << 5) | 0;
     i18 = i18 + (i19 << 5) | 0;
     HEAP32[i32 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i32 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
     HEAP32[i32 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
     HEAP32[i32 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
     HEAP32[i32 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
     HEAP32[i32 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
     HEAP32[i32 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
     HEAP32[i32 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
    }
    HEAP32[i22 + (i4 << 2) >> 2] = HEAP32[i14 >> 2];
    HEAP32[i14 >> 2] = i4;
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i26 >> 2] | 0;
   }
   i19 = i19 + 1 | 0;
   if (i19 >>> 0 >= i1 >>> 0) break; else i18 = i1;
  }
 }
 __ZdaPv(i24);
 if (i4 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) {
  i32 = 0;
  return i32 | 0;
 }
 HEAP32[i26 >> 2] = i4;
 i1 = i25 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i4 * 12 | 0, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 12 | 0, 4, i25 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i32 | 0, HEAP32[i25 >> 2] | 0, (HEAP32[i26 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i25 >> 2] = i32;
  break;
 } while (0);
 i1 = i27 + 12 | 0;
 do if (HEAP32[i1 >> 2] | 0) {
  HEAP32[i1 >> 2] = i4;
  i2 = i27 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i27 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i27 >> 2] | 0, i4 << 5, 16, i27 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i32 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 5, 16, i27 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i32 | 0, HEAP32[i27 >> 2] | 0, HEAP32[i1 >> 2] << 5 | 0) | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i27 >> 2] = i32;
   break;
  }
 } while (0);
 i4 = HEAP32[i28 + 12 >> 2] | 0;
 if (!i4) {
  i32 = 1;
  return i32 | 0;
 }
 i3 = HEAP32[i28 >> 2] | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i1 = 0;
 do {
  i32 = i3 + (i1 << 1) | 0;
  HEAP16[i32 >> 1] = HEAP16[i2 + ((HEAPU16[i32 >> 1] | 0) << 1) >> 1] | 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i10 = i7 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i7 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + (i6 << 4) | 0;
 if (!i6) i2 = 0; else {
  do {
   __ZN5audio5mixer13GroupConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + (i6 << 4) | 0;
 if (i6 | 0) do {
  __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 16 | 0;
 i5 = i8 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i6 << 5) | 0;
 if (!i6) i2 = 0; else {
  do {
   __ZN5audio5mixer14EffectConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i8 + 20 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i6 << 4) | 0;
 if (i6 | 0) do {
  __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 36 | 0;
 i6 = i8 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i5 * 28 | 0) | 0;
 if (!i5) i2 = 0; else {
  do {
   __ZN5audio5mixer16SnapshotConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 28 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i8 + 40 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i6 << 4) | 0;
 if (i6 | 0) do {
  __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 48 | 0;
 i5 = i8 + 44 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i8 + 56 | 0;
 i5 = i8 + 52 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i8 + 64 | 0;
 i5 = i8 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i8 + 72 | 0;
 i5 = i8 + 68 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) i4 = 0; else {
  do {
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 >> 2] = i3;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i8 + 76 | 0;
 HEAP32[i9 >> 2] = i4;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZN7mecanim9animation17EvaluateHumanPoseERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfRKNS0_12MotionOutputERNS_5human9HumanPoseE(i3, i1, i4, i6, i21) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i21 = i21 | 0;
 var f2 = f0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 888 | 0;
 i5 = i22;
 f13 = Math_fround(HEAPF32[i3 + 1080 >> 2]);
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i1 + 16 >> 2]));
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i20 = i3 + 1725 | 0;
 i19 = (HEAP8[i20 >> 0] | 0) != 0;
 i18 = f2 < Math_fround(0.0);
 f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i1 + 8 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f2))));
 f2 = Math_fround(_modff(Math_fround(f13 + f2), i17));
 f15 = i19 ? f2 : f15;
 f2 = Math_fround(HEAPF32[i17 >> 2]);
 HEAPF32[i17 >> 2] = i19 ? f2 : Math_fround(0.0);
 f2 = Math_fround(f15 + Math_fround(1.0));
 f15 = i18 & i19 ? f2 : f15;
 f2 = Math_fround(Math_fround(1.0) - f15);
 i19 = !(f14 < Math_fround(0.0));
 f2 = i19 ? f15 : f2;
 i1 = (HEAP8[i1 + 12 >> 0] | 0) == 0 ^ (HEAP8[i3 + 1724 >> 0] | 0) == 0;
 __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i3, i4, i21);
 if (HEAP8[i20 >> 0] | 0) if (HEAP8[i3 + 1726 >> 0] | 0) {
  __ZN7mecanim5human9HumanPoseC2Ev(i5);
  __ZN7mecanim5human15HumanPoseWeightERNS0_9HumanPoseERKS1_f(i5, i3, f2);
  __ZN7mecanim5human12HumanPoseAddERNS0_9HumanPoseERKS1_S4_(i21, i21, i5);
 }
 if (i1) __ZN7mecanim5human15HumanPoseMirrorERNS0_9HumanPoseERKS1_(i21, i21);
 i31 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 i23 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i21 >> 2] = i31;
 i16 = i21 + 4 | 0;
 HEAP32[i16 >> 2] = i1;
 i17 = i21 + 8 | 0;
 HEAP32[i17 >> 2] = i23;
 i26 = HEAP32[i6 + 40 >> 2] | 0;
 i27 = HEAP32[i6 + 44 >> 2] | 0;
 i24 = HEAP32[i6 + 48 >> 2] | 0;
 i25 = HEAP32[i6 + 52 >> 2] | 0;
 HEAP32[i21 + 12 >> 2] = i26;
 i18 = i21 + 16 | 0;
 HEAP32[i18 >> 2] = i27;
 i19 = i21 + 20 | 0;
 HEAP32[i19 >> 2] = i24;
 i20 = i21 + 24 | 0;
 HEAP32[i20 >> 2] = i25;
 i30 = HEAP32[i6 + 56 >> 2] | 0;
 i29 = HEAP32[i6 + 60 >> 2] | 0;
 i28 = HEAP32[i6 + 64 >> 2] | 0;
 HEAP32[i21 + 28 >> 2] = i30;
 i4 = i21 + 32 | 0;
 HEAP32[i4 >> 2] = i29;
 i5 = i21 + 36 | 0;
 HEAP32[i5 >> 2] = i28;
 i3 = i21 + 28 | 0;
 i6 = i21 + 12 | 0;
 f15 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 while (1) {
  i35 = i21 + 68 + (i1 << 6) | 0;
  f45 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i21 + 68 + (i1 << 6) + 4 | 0;
  f39 = Math_fround(HEAPF32[i33 >> 2]);
  i32 = i21 + 68 + (i1 << 6) + 8 | 0;
  f45 = Math_fround(f45 * f8);
  f39 = Math_fround(f39 * f9);
  f42 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * f10);
  f46 = Math_fround(f11 * Math_fround(-2.0));
  f40 = Math_fround(f11 * Math_fround(2.0));
  f44 = Math_fround(f46 * f13);
  f38 = Math_fround(f14 * Math_fround(2.0));
  f43 = Math_fround(f14 * Math_fround(-2.0));
  f47 = Math_fround(f13 * f43);
  f37 = Math_fround(f12 * Math_fround(-2.0));
  f34 = Math_fround(f12 * Math_fround(2.0));
  f41 = Math_fround(f13 * f37);
  f36 = Math_fround(f15 + Math_fround(Math_fround(f45 + Math_fround(f45 * Math_fround(Math_fround(f11 * f46) - Math_fround(f14 * f38)))) + Math_fround(Math_fround(f42 * Math_fround(Math_fround(f34 * f14) - f44)) + Math_fround(f39 * Math_fround(f47 - Math_fround(f11 * f37))))));
  f34 = Math_fround(f2 + Math_fround(Math_fround(f39 + Math_fround(f45 * Math_fround(Math_fround(f12 * f40) - f47))) + Math_fround(Math_fround(f42 * Math_fround(f41 - Math_fround(f46 * f14))) + Math_fround(f39 * Math_fround(Math_fround(f14 * f43) - Math_fround(f12 * f34))))));
  f2 = Math_fround(f7 + Math_fround(Math_fround(f42 + Math_fround(f45 * Math_fround(f44 - Math_fround(f12 * f43)))) + Math_fround(Math_fround(f42 * Math_fround(Math_fround(f12 * f37) - Math_fround(f11 * f40))) + Math_fround(f39 * Math_fround(Math_fround(f11 * f38) - f41)))));
  f41 = Math_fround(HEAPF32[i21 + 68 + (i1 << 6) + 12 >> 2]);
  f38 = Math_fround(f11 * f41);
  i28 = i21 + 68 + (i1 << 6) + 24 | 0;
  f39 = Math_fround(HEAPF32[i28 >> 2]);
  f7 = Math_fround(f13 * f39);
  i25 = i21 + 68 + (i1 << 6) + 16 | 0;
  f40 = Math_fround(HEAPF32[i25 >> 2]);
  f37 = Math_fround(f14 * f40);
  i27 = i21 + 68 + (i1 << 6) + 20 | 0;
  f42 = Math_fround(HEAPF32[i27 >> 2]);
  f38 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(f13 * f42)) - Math_fround(f14 * f39)) - Math_fround(f12 * f40));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f12 * f41)) - Math_fround(f14 * f42)) - Math_fround(f11 * f40));
  f37 = Math_fround(Math_fround(Math_fround(f37 - Math_fround(f11 * f42)) - Math_fround(f13 * f41)) - Math_fround(f12 * f39));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f42) - Math_fround(f14 * f41)) - Math_fround(f13 * f40)) - Math_fround(f11 * f39));
  i26 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i29 = i21 + 68 + (i1 << 6) + 28 | 0;
  f12 = Math_fround(HEAPF32[i29 >> 2]);
  i30 = i21 + 68 + (i1 << 6) + 32 | 0;
  f13 = Math_fround(HEAPF32[i30 >> 2]);
  i31 = i21 + 68 + (i1 << 6) + 36 | 0;
  f12 = Math_fround(f8 * f12);
  f13 = Math_fround(f9 * f13);
  f14 = Math_fround(f10 * Math_fround(HEAPF32[i31 >> 2]));
  HEAPF32[i35 >> 2] = f36;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i32 >> 2] = f2;
  HEAP32[i21 + 68 + (i1 << 6) + 12 >> 2] = i23 ^ -2147483648;
  HEAP32[i25 >> 2] = i24;
  HEAP32[i27 >> 2] = i26 ^ -2147483648;
  HEAPF32[i28 >> 2] = f7;
  HEAPF32[i29 >> 2] = f12;
  HEAPF32[i30 >> 2] = f13;
  HEAPF32[i31 >> 2] = f14;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 4) break;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(HEAPF32[i18 >> 2]);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  f13 = Math_fround(HEAPF32[i20 >> 2]);
  f14 = Math_fround(HEAPF32[i19 >> 2]);
  f2 = Math_fround(HEAPF32[i16 >> 2]);
  f7 = Math_fround(HEAPF32[i17 >> 2]);
 }
 STACKTOP = i22;
 return;
}

function __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i37 + 512 | 0;
 i13 = i37 + 504 | 0;
 i21 = i37 + 248 | 0;
 i26 = i37 + 488 | 0;
 i31 = i37 + 496 | 0;
 i32 = i37;
 i33 = i37 + 240 | 0;
 i14 = i16 + 280 | 0;
 i36 = HEAP32[i14 >> 2] | 0;
 i18 = HEAP32[i15 + 136 >> 2] | 0;
 i19 = HEAP32[i15 + 140 >> 2] | 0;
 i20 = HEAP32[i15 + 144 >> 2] | 0;
 HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 132 >> 2];
 i17 = i16 + 16 | 0;
 HEAP32[i17 >> 2] = i18;
 i18 = i16 + 20 | 0;
 HEAP32[i18 >> 2] = i19;
 i19 = i16 + 24 | 0;
 HEAP32[i19 >> 2] = i20;
 i20 = i16 + 28 | 0;
 i23 = HEAP32[i15 + 152 >> 2] | 0;
 i24 = HEAP32[i15 + 156 >> 2] | 0;
 i25 = HEAP32[i15 + 160 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i15 + 148 >> 2];
 i22 = i16 + 32 | 0;
 HEAP32[i22 >> 2] = i23;
 i23 = i16 + 36 | 0;
 HEAP32[i23 >> 2] = i24;
 i24 = i16 + 40 | 0;
 HEAP32[i24 >> 2] = i25;
 i25 = i16 + 44 | 0;
 i28 = HEAP32[i15 + 168 >> 2] | 0;
 i29 = HEAP32[i15 + 172 >> 2] | 0;
 i30 = HEAP32[i15 + 176 >> 2] | 0;
 HEAP32[i25 >> 2] = HEAP32[i15 + 164 >> 2];
 i27 = i16 + 48 | 0;
 HEAP32[i27 >> 2] = i28;
 i28 = i16 + 52 | 0;
 HEAP32[i28 >> 2] = i29;
 i29 = i16 + 56 | 0;
 HEAP32[i29 >> 2] = i30;
 i30 = i16 + 60 | 0;
 HEAP32[i30 >> 2] = HEAPU8[i15 + 244 >> 0];
 i35 = i16 + 96 | 0;
 i1 = i15 + 180 | 0;
 i2 = i16 + 108 | 0;
 i5 = i2;
 i6 = i1;
 i7 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 if (__Z20InvertMatrix4x4_FullPKfPf(i1, i34) | 0) {
  i5 = i2;
  i6 = i1;
  i7 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   i5 = i5 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  i5 = i16 + 172 | 0;
  i6 = i34;
  i7 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   i5 = i5 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  i1 = HEAP32[i16 + 100 >> 2] | 0;
  if ((HEAP32[i35 >> 2] | 0) != (i1 | 0)) __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i35, i36, i1 + -56 | 0);
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017878 | 0, 0, gb + 1017283 | 0, 258, 1, 0, 0, 0);
 i12 = i16 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i1 + 20 >> 2] = i15;
 if ((HEAP32[i36 >> 2] | 0) == 7) {
  f3 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i36 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i15 + 52 >> 2]);
  if (f4 <= f3) if (Math_fround(f4 + Math_fround(HEAPF32[i15 + 60 >> 2])) > f3) {
   f3 = Math_fround(HEAPF32[i15 + 56 >> 2]);
   if (f3 <= f8) if (Math_fround(f3 + Math_fround(HEAPF32[i15 + 64 >> 2])) > f8) HEAP32[i16 + 272 >> 2] = 1;
  }
 }
 i10 = i16 + 72 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i7 = i1 + 12 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i7 >> 2] | 0) == (HEAP32[i15 >> 2] | 0) & i11;
 i9 = __Z29scripting_gchandle_get_targetj(HEAP32[i15 + 128 >> 2] | 0) | 0;
 if (i9 | 0) if ((HEAP32[i36 >> 2] | 0) == 7) {
  i6 = HEAP32[i9 + 8 >> 2] | 0;
  i2 = i15 + 52 | 0;
  i5 = i15 + 72 | 0;
  f3 = Math_fround(HEAPF32[i36 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i36 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f4 <= f3)) i1 = 0; else if (Math_fround(f4 + Math_fround(HEAPF32[i15 + 60 >> 2])) > f3) {
   f3 = Math_fround(HEAPF32[i15 + 56 >> 2]);
   if (!(f3 <= f8)) i1 = 0; else i1 = Math_fround(f3 + Math_fround(HEAPF32[i15 + 64 >> 2])) > f8;
  } else i1 = 0;
  __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb(i6, i16, i2, i5, i1, 0, (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) == (HEAP32[i15 >> 2] | 0), 0);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 __ZN12GUIClipState4PushER10InputEventRK5RectTIfE8Vector2fRKS6_b(i35, i1, i15 + 52 | 0, i13, gb + 1162356 | 0, 0);
 i1 = i16 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i14 = i15 + 4 | 0;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i25 >> 2] = 1065353216;
 HEAP32[i27 >> 2] = 1065353216;
 HEAP32[i28 >> 2] = 1065353216;
 HEAP32[i29 >> 2] = 1065353216;
 HEAP32[i20 >> 2] = 1065353216;
 HEAP32[i22 >> 2] = 1065353216;
 HEAP32[i23 >> 2] = 1065353216;
 HEAP32[i24 >> 2] = 1065353216;
 HEAP32[i16 + 12 >> 2] = 1065353216;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i18 >> 2] = 1065353216;
 HEAP32[i19 >> 2] = 1065353216;
 HEAP32[i30 >> 2] = 1;
 HEAP32[i16 + 64 >> 2] = 0;
 HEAP32[i16 + 68 >> 2] = 1;
 HEAP32[i15 + 48 >> 2] = 0;
 i28 = i15 + 8 | 0;
 HEAP32[i28 >> 2] = -1;
 HEAP32[i28 + 4 >> 2] = -1;
 HEAP32[i28 + 8 >> 2] = -1;
 HEAP32[i28 + 12 >> 2] = -1;
 HEAP8[i15 + 24 >> 0] = 0;
 HEAP32[i14 >> 2] = 1;
 i28 = i16 + 340 | 0;
 HEAP32[i28 >> 2] = (HEAP32[i28 >> 2] | 0) + 1;
 i28 = (__Z24GetIMGUIScriptingClassesv() | 0) + 8 | 0;
 i29 = HEAP32[i28 + 4 >> 2] | 0;
 i30 = i26;
 HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i30 + 4 >> 2] = i29;
 HEAP32[i34 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i34 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i21, i34);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, __Z29scripting_gchandle_get_targetj(HEAP32[i15 + 120 >> 2] | 0) | 0);
 __ZN18ScriptingArguments6AddIntEi(i21, HEAP32[i15 >> 2] | 0);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, __Z29scripting_gchandle_get_targetj(HEAP32[i15 + 124 >> 2] | 0) | 0);
 __ZN18ScriptingArguments6AddIntEi(i21, HEAPU8[i15 + 118 >> 0] | 0);
 __ZN18ScriptingArguments8AddFloatEf(i21, Math_fround(HEAPF32[i15 + 60 >> 2]));
 __ZN18ScriptingArguments8AddFloatEf(i21, Math_fround(HEAPF32[i15 + 64 >> 2]));
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i21, i9);
 HEAP32[i10 >> 2] = (HEAP32[i7 >> 2] | 0) == (HEAP32[i15 >> 2] | 0) & 1;
 HEAP32[i31 >> 2] = 0;
 HEAP8[i21 + 233 >> 0] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i21, i31, 0) | 0;
 if (HEAP32[i31 >> 2] | 0) {
  i28 = (__Z24GetIMGUIScriptingClassesv() | 0) + 32 | 0;
  i29 = HEAP32[i28 + 4 >> 2] | 0;
  i30 = i33;
  HEAP32[i30 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i30 + 4 >> 2] = i29;
  HEAP32[i34 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i34 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i32, i34);
  __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i32, HEAP32[i31 >> 2] | 0);
  HEAP32[i34 >> 2] = 0;
  if (!(__ZN19ScriptingInvocation6InvokeIbEET_PP15Il2CppExceptionb(i32, i34, 0) | 0)) __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(HEAP32[i31 >> 2] | 0, 0, 0);
 }
 __ZN8GUIState8EndOnGUIEv(i16);
 HEAP32[i1 >> 2] = i2;
 i1 = i16 + 100 | 0;
 i34 = HEAP32[i1 >> 2] | 0;
 i2 = i34;
 if (((i34 - (HEAP32[i35 >> 2] | 0) | 0) / 56 | 0) >>> 0 < 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017848 | 0, 0, gb + 1017283 | 0, 130, 1, 0, 0, 0);
  i36 = HEAP32[i12 >> 2] | 0;
  i36 = i36 + 20 | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i37;
  return;
 } else {
  HEAP32[i1 >> 2] = i2 + -56;
  __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i35, i36, i2 + -112 | 0);
  i36 = HEAP32[i12 >> 2] | 0;
  i36 = i36 + 20 | 0;
  HEAP32[i36 >> 2] = 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i37;
  return;
 }
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer27GetDeleteErrorJsonDataBlockERK8UnityStrS4_RS2_(i3, i1, i2, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 136 | 0;
 i10 = i13;
 i11 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = gb + 77468 + 12;
 i12 = i10 + 56 | 0;
 HEAP32[i12 >> 2] = gb + 77468 + 32;
 __ZNSt3__28ios_base4initEPv(i10 + 56 | 0, i11);
 HEAP32[i10 + 128 >> 2] = 0;
 HEAP32[i10 + 132 >> 2] = -1;
 HEAP32[i10 >> 2] = gb + 77508 + 12;
 HEAP32[i10 + 56 >> 2] = gb + 77508 + 32;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i11);
 HEAP32[i11 >> 2] = gb + 77548 + 8;
 i7 = i10 + 36 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = 16;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i11, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046777 | 0, 1) | 0;
 if (__ZN11UnityEngine15CloudWebService16SessionContainer25GetSessionHeaderJsonArrayERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i3, i1, i10) | 0) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1087585 | 0, 1) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046779 | 0, 1) | 0;
 i6 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, i6, _strlen(i6) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046781 | 0, 4) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046786 | 0, 15) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046802 | 0, 23) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046826 | 0, 17) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046844 | 0, 8) | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, i1, _strlen(i1) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046853 | 0, 12) | 0;
 i1 = i3 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, i1, _strlen(i1) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046866 | 0, 12) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046879 | 0, 8) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1086055 | 0, 1) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046888 | 0, 11) | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb(i10, (HEAP8[i3 + 121 >> 0] | 0) != 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046900 | 0, 10) | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb(i10, (HEAP8[i3 + 122 >> 0] | 0) != 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046911 | 0, 3) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046879 | 0, 8) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1085935 | 0, 1) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046888 | 0, 11) | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb(i10, (HEAP8[i3 + 123 >> 0] | 0) != 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046900 | 0, 10) | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb(i10, (HEAP8[i3 + 124 >> 0] | 0) != 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046915 | 0, 4) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i10, gb + 1046920 | 0, 2) | 0;
 __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i9, i11);
 i5 = HEAP8[i9 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i4 = i6 ? HEAP32[i9 >> 2] | 0 : i9;
 i5 = i6 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
 i6 = i8 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 if (i5 >>> 0 > i3 >>> 0) {
  i6 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i5 - i3 | 0, i6, 0, i6, i5, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  HEAP32[i10 >> 2] = gb + 77508 + 12;
  HEAP32[i12 >> 2] = gb + 77508 + 32;
  HEAP32[i11 >> 2] = gb + 77548 + 8;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i11);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i10, gb + 77612 + 4 | 0);
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i12);
  STACKTOP = i13;
  return 1;
 }
 i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
 if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  HEAP32[i8 + 4 >> 2] = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  HEAP32[i10 >> 2] = gb + 77508 + 12;
  HEAP32[i12 >> 2] = gb + 77508 + 32;
  HEAP32[i11 >> 2] = gb + 77548 + 8;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i11);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i10, gb + 77612 + 4 | 0);
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i12);
  STACKTOP = i13;
  return 1;
 } else {
  HEAP8[i6 >> 0] = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  HEAP32[i10 >> 2] = gb + 77508 + 12;
  HEAP32[i12 >> 2] = gb + 77508 + 32;
  HEAP32[i11 >> 2] = gb + 77548 + 8;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i11);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i10, gb + 77612 + 4 | 0);
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i12);
  STACKTOP = i13;
  return 1;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i15, i16, i6) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i24;
 i22 = i15 + 28 | 0;
 i23 = i15 + 32 | 0;
 HEAP32[i23 >> 2] = 32;
 i12 = i15 + 44 | 0;
 HEAP32[i12 >> 2] = 16;
 i13 = i15 + 40 | 0;
 HEAP32[i13 >> 2] = 6;
 i14 = i15 + 48 | 0;
 HEAP8[i14 >> 0] = 0;
 i11 = i15 + 52 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 >> 2] = 6;
 HEAP32[i8 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (i1 | 0) {
  i21 = HEAP32[i11 >> 2] | 0;
  HEAP32[i8 >> 2] = 6;
  HEAP32[i8 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 HEAP32[i22 >> 2] = i2;
 i3 = i2 + (HEAP32[i23 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i15 + 20 | 0;
  i1 = i2;
  do {
   i19 = i4;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i21 = i1;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i20 = i15 + 36 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 i21 = i16 + 4 | 0;
 f5 = Math_fround(((HEAP32[i16 + 36 >> 2] | 0) - (HEAP32[i21 >> 2] | 0) | 0) >>> 0);
 i7 = 32;
 while (1) {
  if (i7 >>> 0 >= i6 >>> 0) {
   f9 = Math_fround(i7 >>> 0);
   f10 = Math_fround(f9 * Math_fround(.5));
   if (!(f5 >= f10)) break;
  }
  i7 = i7 << 1;
 }
 i1 = HEAP32[i23 >> 2] | 0;
 if (i7 >>> 0 > i1 >>> 0) {
  i4 = HEAP32[i11 >> 2] | 0;
  HEAP32[i8 >> 2] = 6;
  HEAP32[i8 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) {
   i19 = HEAP32[i23 >> 2] | 0;
   i3 = i1 + (i19 << 3) | 0;
   if (i19) {
    i2 = i4;
    while (1) {
     i17 = i1;
     i18 = HEAP32[i17 + 4 >> 2] | 0;
     i19 = i2;
     HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 8 | 0;
    }
    i1 = HEAP32[i22 >> 2] | 0;
   }
   i19 = HEAP32[i11 >> 2] | 0;
   HEAP32[i8 >> 2] = 6;
   HEAP32[i8 + 4 >> 2] = i19;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
  }
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i4 + (i7 << 3) | 0;
  if ((i1 | 0) != (i7 | 0)) {
   i3 = i15 + 20 | 0;
   i1 = i4 + (i1 << 3) | 0;
   do {
    i17 = i3;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i1;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i22 >> 2] = i4;
  HEAP32[i23 >> 2] = i7;
  HEAP32[i12 >> 2] = ~~f10 >>> 0;
  HEAP32[i13 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
  HEAP8[i14 >> 0] = 0;
  i11 = i7;
 } else i11 = i1;
 i17 = i16 + 28 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i18 = i16 + 32 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 i19 = i1 + (i14 << 3) | 0;
 L31 : do if (i14) {
  i7 = HEAP32[i16 + 20 >> 2] | 0;
  i2 = (HEAP8[i16 + 8 >> 0] | 0) == 0 | (HEAP32[i21 >> 2] | 0) == 0;
  i8 = HEAP32[i16 + 12 >> 2] | 0;
  i6 = (i8 | 0) != 0;
  if (!i7) {
   if (i2) {
    do {
     if (HEAP32[i1 >> 2] | 0) break L31;
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i19 | 0));
    STACKTOP = i24;
    return;
   }
   if (!i6) {
    do {
     if (HEAP32[i1 >> 2] | 0) break L31;
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i19 | 0));
    STACKTOP = i24;
    return;
   }
   do {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!((i2 | 0) == 0 | (i8 | 0) == (i2 | 0))) if (_strcmp(i8, i2) | 0) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i19 | 0));
   STACKTOP = i24;
   return;
  }
  if (i2) {
   do {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i7 | 0) != (i2 | 0)) {
     if (!i2) break L31;
     if (_strcmp(i7, i2) | 0) break L31;
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i19 | 0));
   STACKTOP = i24;
   return;
  }
  i4 = (i8 | 0) == 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   do if ((i7 | 0) != (i2 | 0)) {
    i3 = (i2 | 0) != 0;
    if (!i3) if (i4) break; else break L31;
    if (!((_strcmp(i7, i2) | 0) == 0 | (i8 | 0) == (i2 | 0))) {
     if (!(i3 & i6)) break L31;
     if (_strcmp(i8, i2) | 0) break L31;
    }
   } while (0);
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i19 | 0));
  STACKTOP = i24;
  return;
 } while (0);
 if ((i1 | 0) == (i19 | 0)) {
  STACKTOP = i24;
  return;
 }
 i13 = i15 + 20 | 0;
 i14 = i16 + 20 | 0;
 i15 = i16 + 8 | 0;
 i12 = i16 + 12 | 0;
 i2 = i11;
 while (1) {
  i11 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  if (!(i3 << 24 >> 24)) i2 = -2128831035; else {
   i4 = i2;
   i2 = -2128831035;
   do {
    i4 = i4 + 1 | 0;
    i2 = Math_imul(i3 & 255 ^ i2, 16777619) | 0;
    i3 = HEAP8[i4 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i2 = i2 & i11;
  i6 = HEAP32[i13 >> 2] | 0;
  i8 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i8 + (i2 << 3) >> 2] | 0;
  L83 : do if ((i6 | 0) != (i3 | 0)) {
   i7 = (i6 | 0) != 0;
   i4 = 0;
   do {
    if (i7 & (i3 | 0) != 0) if (!(_strcmp(i6, i3) | 0)) break L83;
    i4 = i4 + 1 | 0;
    i2 = i4 + i2 & i11;
    i3 = HEAP32[i8 + (i2 << 3) >> 2] | 0;
   } while ((i6 | 0) != (i3 | 0));
  } while (0);
  i7 = i1;
  i11 = HEAP32[i7 + 4 >> 2] | 0;
  i16 = i8 + (i2 << 3) | 0;
  HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i16 + 4 >> 2] = i11;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L91 : do if ((i1 | 0) == (i19 | 0)) i1 = i19; else {
   i7 = HEAP32[i14 >> 2] | 0;
   i2 = (HEAP8[i15 >> 0] | 0) == 0 | (HEAP32[i21 >> 2] | 0) == 0;
   i8 = HEAP32[i12 >> 2] | 0;
   i6 = (i8 | 0) != 0;
   if (!i7) {
    if (i2) while (1) {
     if (HEAP32[i1 >> 2] | 0) break L91;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i19 | 0)) {
      i1 = i19;
      break L91;
     }
    }
    if (!i6) while (1) {
     if (HEAP32[i1 >> 2] | 0) break L91;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i19 | 0)) {
      i1 = i19;
      break L91;
     }
    }
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!((i2 | 0) == 0 | (i8 | 0) == (i2 | 0))) if (_strcmp(i8, i2) | 0) break L91;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i19 | 0)) {
      i1 = i19;
      break L91;
     }
    }
   }
   if (i2) while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i7 | 0) != (i2 | 0)) {
     if (!i2) break L91;
     if (_strcmp(i7, i2) | 0) break L91;
    }
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i19 | 0)) {
     i1 = i19;
     break L91;
    }
   }
   i4 = (i8 | 0) == 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    do if ((i7 | 0) != (i2 | 0)) {
     i3 = (i2 | 0) != 0;
     if (!i3) if (i4) break; else break L91;
     if (!((_strcmp(i7, i2) | 0) == 0 | (i8 | 0) == (i2 | 0))) {
      if (!(i3 & i6)) break L91;
      if (_strcmp(i8, i2) | 0) break L91;
     }
    } while (0);
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i19 | 0)) {
     i1 = i19;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i17 >> 2] | 0) + (HEAP32[i18 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i23 >> 2] | 0;
 }
 STACKTOP = i24;
 return;
}

function __ZN14ParticleSystem8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 5);
 __ZN27ParticleSystemReadOnlyState8TransferI24GenerateTypeTreeTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN19ParticleSystemState8TransferI24GenerateTypeTreeTransferEEvRT_(HEAP32[i1 + 40 >> 2] | 0, i2);
 i3 = i1 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 618937 | 0, gb + 618937 | 0, i4, 0);
 __ZN13InitialModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 618951 | 0, gb + 618951 | 0, i3, 0);
 __ZN11ShapeModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN11ShapeModule16CheckConsistencyEv(i3);
 i3 = i1 + 264 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 618963 | 0, gb + 618963 | 0, i3, 0);
 __ZN14EmissionModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN14EmissionModule16CheckConsistencyEv(i3);
 i3 = HEAP32[i1 + 852 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 618978 | 0, gb + 618978 | 0, i3, 0);
 __ZN10SizeModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = HEAP32[i1 + 856 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 618989 | 0, gb + 618989 | 0, i3, 0);
 __ZN14RotationModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = HEAP32[i1 + 860 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619004 | 0, gb + 619004 | 0, i3, 0);
 __ZN11ColorModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 864 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619016 | 0, gb + 619016 | 0, i4, 0);
 __ZN8UVModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = HEAP32[i1 + 868 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619025 | 0, gb + 619025 | 0, i3, 0);
 __ZN14VelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 872 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619040 | 0, gb + 619040 | 0, i4, 0);
 __ZN21InheritVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = HEAP32[i1 + 876 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619062 | 0, gb + 619062 | 0, i3, 0);
 __ZN11ForceModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = HEAP32[i1 + 880 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619074 | 0, gb + 619074 | 0, i3, 0);
 __ZN20ExternalForcesModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 884 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619095 | 0, gb + 619095 | 0, i4, 0);
 __ZN19ClampVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 888 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619115 | 0, gb + 619115 | 0, i4, 0);
 __ZN11NoiseModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 892 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619127 | 0, gb + 619127 | 0, i4, 0);
 __ZN17SizeBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 896 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619145 | 0, gb + 619145 | 0, i4, 0);
 __ZN21RotationBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 900 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619167 | 0, gb + 619167 | 0, i4, 0);
 __ZN18ColorBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 904 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619186 | 0, gb + 619186 | 0, i4, 0);
 __ZN15CollisionModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 912 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619202 | 0, gb + 619202 | 0, i4, 0);
 __ZN13TriggerModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = HEAP32[i1 + 916 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619216 | 0, gb + 619216 | 0, i3, 0);
 __ZN9SubModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 920 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619226 | 0, gb + 619226 | 0, i4, 0);
 __ZN12LightsModule8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 908 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619239 | 0, gb + 619239 | 0, i3, 0);
 __ZN11TrailModule8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5physx2Gu9RadixSort4SortEPKfj(i19, i17, i18) {
 i19 = i19 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f20 = f0, i21 = 0;
 if ((i17 | 0) == 0 | (i18 | 0) < 1) return i19 | 0;
 i15 = i19 + 24 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 i15 = i19 + 16 | 0;
 _memset(HEAP32[i15 >> 2] | 0, 0, 4096) | 0;
 i5 = i17 + (i18 << 2) | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i16 = i19 + 4 | 0;
 L4 : do if ((HEAP32[i16 >> 2] | 0) < 0) {
  if ((i5 | 0) != (i17 | 0)) {
   f3 = Math_fround(HEAPF32[i17 >> 2]);
   i1 = i17;
   do {
    f20 = f3;
    f3 = Math_fround(HEAPF32[i1 >> 2]);
    if (f3 < f20) break L4;
    i14 = i1;
    i1 = i1 + 4 | 0;
    i13 = i6 + (((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 255) << 2) | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    i13 = i6 + ((HEAPU8[i14 + 1 >> 0] | 0 | 256) << 2) | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    i13 = i6 + ((HEAPU8[i14 + 2 >> 0] | 0 | 512) << 2) | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    i14 = i6 + ((HEAPU8[i14 + 3 >> 0] | 0 | 768) << 2) | 0;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   } while ((i1 | 0) != (i5 | 0));
  }
  i17 = i19 + 28 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
  if (!i18) return i19 | 0;
  i1 = HEAP32[i19 + 8 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 2) >> 2] = i2;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
  return i19 | 0;
 } else {
  i1 = HEAP32[i19 + 8 >> 2] | 0;
  L19 : do if ((i5 | 0) != (i17 | 0)) {
   f3 = Math_fround(HEAPF32[i17 + (HEAP32[i1 >> 2] << 2) >> 2]);
   i2 = i1;
   i4 = i17;
   while (1) {
    i2 = i2 + 4 | 0;
    i1 = i6 + ((HEAPU8[i4 >> 0] | 0) << 2) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = i6 + ((HEAPU8[i4 + 1 >> 0] | 0 | 256) << 2) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = i6 + ((HEAPU8[i4 + 2 >> 0] | 0 | 512) << 2) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = i4 + 4 | 0;
    i14 = i6 + ((HEAPU8[i4 + 3 >> 0] | 0 | 768) << 2) | 0;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
    if ((i1 | 0) == (i5 | 0)) break L19;
    f20 = f3;
    f3 = Math_fround(HEAPF32[i17 + (HEAP32[i2 >> 2] << 2) >> 2]);
    if (f3 < f20) break L4; else i4 = i1;
   }
  } while (0);
  i18 = i19 + 28 | 0;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  return i19 | 0;
 } while (0);
 if ((i1 | 0) == (i5 | 0)) {
  i1 = 0;
  i2 = 128;
 } else {
  do {
   i14 = i6 + ((HEAPU8[i1 >> 0] | 0) << 2) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i14 = i6 + ((HEAPU8[i1 + 1 >> 0] | 0 | 256) << 2) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i14 = i6 + ((HEAPU8[i1 + 2 >> 0] | 0 | 512) << 2) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i14 = i6 + ((HEAPU8[i1 + 3 >> 0] | 0 | 768) << 2) | 0;
   i1 = i1 + 4 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } while ((i1 | 0) != (i5 | 0));
  i1 = 0;
  i2 = 128;
 }
 do {
  i1 = (HEAP32[i6 + (i2 + 768 << 2) >> 2] | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 256);
 i10 = i19 + 20 | 0;
 i11 = i19 + 12 | 0;
 i12 = i19 + 8 | 0;
 i13 = (i18 | 0) == 0;
 i14 = i18 + -1 | 0;
 i4 = i6;
 i9 = 0;
 L33 : while (1) {
  i6 = i9 << 8;
  i5 = HEAP8[i17 + i9 >> 0] | 0;
  i6 = (HEAP32[i4 + ((i5 & 255 | i6) << 2) >> 2] | 0) == (i18 | 0) ? 0 : i4 + (i6 << 2) | 0;
  i2 = (i6 | 0) != 0;
  do if ((i9 | 0) == 3) {
   if (!i2) {
    if (i5 << 24 >> 24 >= 0) {
     i1 = 64;
     break L33;
    }
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 | 0) < 0) {
     if (!i13) {
      i2 = HEAP32[i11 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i2 + (i4 << 2) >> 2] = i14 - i4;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i18 | 0));
      i2 = HEAP32[i16 >> 2] | 0;
     }
     HEAP32[i16 >> 2] = i2 & 2147483647;
    } else if (!i13) {
     i2 = HEAP32[i12 >> 2] | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     i5 = 0;
     do {
      HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i2 + (i14 - i5 << 2) >> 2];
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i18 | 0));
    }
    i8 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i11 >> 2] = i8;
    break;
   }
   i8 = HEAP32[i10 >> 2] | 0;
   i2 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i8 >> 2] = i2;
   i4 = 1;
   do {
    i2 = i2 + (HEAP32[i6 + (i4 + -1 << 2) >> 2] << 2) | 0;
    HEAP32[i8 + (i4 << 2) >> 2] = i2;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 128);
   HEAP32[i8 + 1020 >> 2] = HEAP32[i11 >> 2];
   i2 = 0;
   do {
    i7 = 255 - i2 | 0;
    HEAP32[i8 + (254 - i2 << 2) >> 2] = (HEAP32[i8 + (i7 << 2) >> 2] | 0) + (HEAP32[i6 + (i7 << 2) >> 2] << 2);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 127);
   i2 = 128;
   do {
    i7 = i8 + (i2 << 2) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i6 + (i2 << 2) >> 2] << 2);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 256);
   i2 = HEAP32[i16 >> 2] | 0;
   if ((i2 | 0) < 0) {
    if (!i13) {
     i5 = 0;
     do {
      i7 = HEAP32[i17 + (i5 << 2) >> 2] | 0;
      i2 = i8 + (i7 >>> 24 << 2) | 0;
      i4 = HEAP32[i2 >> 2] | 0;
      if ((i7 | 0) > -1) {
       HEAP32[i2 >> 2] = i4 + 4;
       HEAP32[i4 >> 2] = i5;
      } else {
       i7 = i4 + -4 | 0;
       HEAP32[i2 >> 2] = i7;
       HEAP32[i7 >> 2] = i5;
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i18 | 0));
     i2 = HEAP32[i16 >> 2] | 0;
    }
    HEAP32[i16 >> 2] = i2 & 2147483647;
   } else {
    i2 = HEAP32[i12 >> 2] | 0;
    if (!i13) {
     i7 = 0;
     do {
      i4 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
      i21 = HEAP32[i17 + (i4 << 2) >> 2] | 0;
      i5 = i8 + (i21 >>> 24 << 2) | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i21 | 0) > -1) {
       HEAP32[i5 >> 2] = i6 + 4;
       HEAP32[i6 >> 2] = i4;
      } else {
       i21 = i6 + -4 | 0;
       HEAP32[i5 >> 2] = i21;
       HEAP32[i21 >> 2] = i4;
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i18 | 0));
    }
   }
   i21 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i21;
  } else if (i2) {
   i5 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   i4 = 1;
   do {
    i2 = i2 + (HEAP32[i6 + (i4 + -1 << 2) >> 2] << 2) | 0;
    HEAP32[i5 + (i4 << 2) >> 2] = i2;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 256);
   i2 = HEAP32[i16 >> 2] | 0;
   if ((i2 | 0) < 0) {
    if (!i13) {
     i2 = 0;
     do {
      i8 = i5 + ((HEAPU8[i17 + ((i2 << 2) + i9) >> 0] | 0) << 2) | 0;
      i21 = HEAP32[i8 >> 2] | 0;
      HEAP32[i8 >> 2] = i21 + 4;
      HEAP32[i21 >> 2] = i2;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i18 | 0));
     i2 = HEAP32[i16 >> 2] | 0;
    }
    HEAP32[i16 >> 2] = i2 & 2147483647;
   } else {
    i2 = HEAP32[i12 >> 2] | 0;
    i4 = i2 + (i18 << 2) | 0;
    if (!i13) do {
     i8 = HEAP32[i2 >> 2] | 0;
     i2 = i2 + 4 | 0;
     i7 = i5 + ((HEAPU8[i17 + ((i8 << 2) + i9) >> 0] | 0) << 2) | 0;
     i21 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = i21 + 4;
     HEAP32[i21 >> 2] = i8;
    } while ((i2 | 0) != (i4 | 0));
   }
   i21 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i11 >> 2] = i21;
  } while (0);
  i2 = i9 + 1 | 0;
  if ((i2 | 0) == 4) {
   i1 = 64;
   break;
  }
  i4 = HEAP32[i15 >> 2] | 0;
  i9 = i2;
 }
 if ((i1 | 0) == 64) return i19 | 0;
 return 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZN8Animator19ApplyOnAnimatorMoveEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 16 | 0;
 i6 = i15;
 if ((HEAP16[gb + 1466908 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = i12;
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466908 | 0, i10);
  i11 = gb + 1466908 | 0;
 } else i11 = 0;
 i14 = i12 + 100 | 0;
 HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 2;
 i1 = i12 + 28 | 0;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 switch (HEAP32[i12 + 548 >> 2] | 0) {
 case 1:
  {
   i9 = 29;
   break;
  }
 case 2:
  {
   if (Math_fround(HEAPF32[i12 + 420 >> 2]) < Math_fround(0.0)) i9 = 29; else i9 = 5;
   break;
  }
 default:
  i9 = 5;
 }
 if ((i9 | 0) == 5) {
  if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] & 64)) i1 = 0; else {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i12, gb + 1105436 | 0, i10);
   i1 = 1;
  }
  i7 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
  i2 = ((__ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE(i12, 8) | 0) & 1 | i1 | 0) == 0;
  __Z24SetExecutionRestrictions21ExecutionRestrictions(i7) | 0;
  i7 = i12 + 153 | 0;
  if (HEAP8[i7 >> 0] | 0) {
   i8 = i12 + 168 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (i3 | 0) {
    i6 = i12 + 76 | 0;
    do if (!(HEAP8[i6 >> 0] | 0)) i9 = 15; else {
     i5 = i12 + 132 | 0;
     i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
     if (!i1) i9 = 12; else if (!(HEAP8[(HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 24 >> 2] | 0) + 36 >> 0] | 0)) i9 = 12;
     if ((i9 | 0) == 12) {
      if (!(__ZNK8Animator7IsHumanEv(i12) | 0)) {
       i9 = 15;
       break;
      }
      i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
     }
     HEAP32[i10 >> 2] = HEAP32[i1 + 68 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 72 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 76 >> 2];
     __ZN9Transform16SetLocalPositionERK8Vector3f(i13, i10);
     i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
     f19 = Math_fround(HEAPF32[i1 + 80 >> 2]);
     f21 = Math_fround(f19 * f19);
     f18 = Math_fround(HEAPF32[i1 + 84 >> 2]);
     f4 = Math_fround(f18 * f18);
     f17 = Math_fround(HEAPF32[i1 + 88 >> 2]);
     f16 = Math_fround(f17 * f17);
     f20 = Math_fround(HEAPF32[i1 + 92 >> 2]);
     f16 = Math_fround(Math_fround(f21 + f4) + Math_fround(f16 + Math_fround(f20 * f20)));
     f4 = Math_fround(Math_sqrt(Math_fround(f16)));
     f19 = Math_fround(f19 / f4);
     f18 = Math_fround(f18 / f4);
     f17 = Math_fround(f17 / f4);
     f4 = Math_fround(f20 / f4);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = f16 > Math_fround(1.0e-30);
     i22 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
     HEAP32[i10 >> 2] = i5 ? i1 : 0;
     HEAP32[i10 + 4 >> 2] = i5 ? i2 : 0;
     HEAP32[i10 + 8 >> 2] = i5 ? i3 : 0;
     HEAP32[i10 + 12 >> 2] = i22;
     __ZN9Transform16SetLocalRotationERK11Quaternionf(i13, i10);
    } while (0);
    if ((i9 | 0) == 15) if (i2) if (HEAP8[i12 + 417 >> 0] | 0) __ZN8Animator22ApplyBuiltinRootMotionEv(i12);
    if (HEAP8[i7 >> 0] | 0) {
     i3 = HEAP32[i8 >> 2] | 0;
     if (i3 | 0) {
      i2 = i12 + 417 | 0;
      if (!(HEAP8[i2 >> 0] | 0)) i1 = (HEAP8[i6 >> 0] | 0) != 0; else i1 = 1;
      if (__ZN11UnityEngine9Animation37HasGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantEb(i3, i1) | 0) __ZN11UnityEngine9Animation37SetGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayER9Transformb(HEAP32[i8 >> 2] | 0, HEAP32[HEAP32[i12 + 132 >> 2] >> 2] | 0, i13, (HEAP8[i2 >> 0] | 0) != 0);
      __ZNK9Transform11GetPositionEv(i10, i13);
      if (HEAP8[i7 >> 0] | 0) {
       i22 = HEAP32[i12 + 136 >> 2] | 0;
       i8 = HEAP32[i10 + 4 >> 2] | 0;
       i9 = HEAP32[i10 + 8 >> 2] | 0;
       HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i22 + 4 >> 2] = i8;
       HEAP32[i22 + 8 >> 2] = i9;
      }
      __ZNK9Transform11GetRotationEv(i10, i13);
      if (HEAP8[i7 >> 0] | 0) {
       i22 = HEAP32[i12 + 136 >> 2] | 0;
       i9 = HEAP32[i10 + 4 >> 2] | 0;
       i12 = HEAP32[i10 + 8 >> 2] | 0;
       i13 = HEAP32[i10 + 12 >> 2] | 0;
       HEAP32[i22 + 12 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i22 + 16 >> 2] = i9;
       HEAP32[i22 + 20 >> 2] = i12;
       HEAP32[i22 + 24 >> 2] = i13;
      }
     }
    }
   }
  }
 } else if ((i9 | 0) == 29) {
  i7 = i12 + 417 | 0;
  if (!(HEAP8[i7 >> 0] | 0)) i2 = 0; else {
   if (!(HEAP8[i12 + 153 >> 0] | 0)) {
    HEAPF32[i10 >> 2] = Math_fround(0.0);
    HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
   } else {
    i1 = HEAP32[i12 + 136 >> 2] | 0;
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    i1 = HEAP32[i12 + 136 >> 2] | 0;
    f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
    f16 = Math_fround(f18 * f18);
    f19 = Math_fround(HEAPF32[i1 + 16 >> 2]);
    f4 = Math_fround(f19 * f19);
    f20 = Math_fround(HEAPF32[i1 + 20 >> 2]);
    f21 = Math_fround(f20 * f20);
    f17 = Math_fround(HEAPF32[i1 + 24 >> 2]);
    f21 = Math_fround(Math_fround(f16 + f4) + Math_fround(f21 + Math_fround(f17 * f17)));
    f4 = Math_fround(Math_sqrt(Math_fround(f21)));
    f18 = Math_fround(f18 / f4);
    f19 = Math_fround(f19 / f4);
    f20 = Math_fround(f20 / f4);
    f4 = Math_fround(f17 / f4);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = f21 > Math_fround(1.0e-30);
    i22 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
    HEAP32[i6 >> 2] = i5 ? i1 : 0;
    HEAP32[i6 + 4 >> 2] = i5 ? i2 : 0;
    HEAP32[i6 + 8 >> 2] = i5 ? i3 : 0;
    HEAP32[i6 + 12 >> 2] = i22;
   }
   __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i13, i10, i6);
   i2 = (HEAP8[i7 >> 0] | 0) != 0;
  }
  i1 = i12 + 168 | 0;
  if (__ZN11UnityEngine9Animation37HasGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantEb(HEAP32[i1 >> 2] | 0, i2) | 0) __ZN11UnityEngine9Animation37SetGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayER9Transformb(HEAP32[i1 >> 2] | 0, HEAP32[HEAP32[i12 + 132 >> 2] >> 2] | 0, i13, (HEAP8[i7 >> 0] | 0) != 0);
 }
 HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -3;
 if (!i11) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i15;
 return;
}

function __Z16FindActiveLightsR13dynamic_arrayIPK5LightLj4EES4_RS_I8Vector4fLj4EERS_IiLj4EERK14ShadowCullData(i28, i29, i30, i31, i3) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i33 + 4 | 0;
 i2 = i33;
 if ((HEAP16[gb + 1111124 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111124 | 0, i1);
  i26 = gb + 1111124 | 0;
 } else i26 = 0;
 i27 = HEAP32[gb + 1112264 >> 2] | 0;
 i1 = HEAP32[i27 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i27 | 0)) {
  i13 = i3 + 512 | 0;
  i14 = i30 + 12 | 0;
  i15 = i30 + 16 | 0;
  i16 = i30 + 4 | 0;
  i17 = i29 + 12 | 0;
  i18 = i29 + 16 | 0;
  i19 = i29 + 4 | 0;
  i20 = i31 + 12 | 0;
  i21 = i31 + 16 | 0;
  i22 = i31 + 4 | 0;
  i23 = i28 + 12 | 0;
  i24 = i28 + 16 | 0;
  i25 = i28 + 4 | 0;
  do {
   i11 = i1 + -36 | 0;
   i12 = i1 + 8 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i5 = HEAP32[i6 + 40 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   L8 : do if ((i5 | 0) != 3) {
    if ((HEAP32[i6 + 88 >> 2] | 0) > -1) if ((HEAP32[i6 + 80 >> 2] | 0) != 1) break;
    if (HEAP32[i6 + 36 >> 2] & i3 | 0) if (!(Math_fround(HEAPF32[i6 + 44 >> 2]) < Math_fround(.00100000005))) {
     L15 : do switch (i5 | 0) {
     case 0:
      {
       f4 = Math_fround(HEAPF32[i6 + 48 >> 2]);
       if (f4 < Math_fround(.00100000005)) break L8;
       if (Math_fround(HEAPF32[i6 + 60 >> 2]) < Math_fround(.00100000005)) break L8; else i32 = 22;
       break;
      }
     case 2:
      {
       f4 = Math_fround(HEAPF32[i6 + 48 >> 2]);
       if (f4 < Math_fround(9.99999993e-09)) break L8;
       break;
      }
     case 1:
      {
       i3 = i11;
       i5 = HEAP32[i23 >> 2] | 0;
       i6 = i5 + 1 | 0;
       i7 = HEAP32[i24 >> 2] | 0;
       i8 = i7 & 2147483647;
       do if (i6 >>> 0 > i8 >>> 0) {
        i1 = i7 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i24 >> 2] = i1;
         HEAP32[i28 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i28 >> 2] | 0, i1 << 2, 4, i25, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i12 | 0, HEAP32[i28 >> 2] | 0, HEAP32[i23 >> 2] << 2 | 0) | 0;
         HEAP32[i24 >> 2] = i1;
         HEAP32[i28 >> 2] = i12;
         break;
        }
       } while (0);
       HEAP32[i23 >> 2] = i6;
       HEAP32[(HEAP32[i28 >> 2] | 0) + (i5 << 2) >> 2] = i3;
       break L8;
      }
     default:
      if ((i5 | 2 | 0) == 2) {
       f4 = Math_fround(HEAPF32[i6 + 48 >> 2]);
       if (!i5) {
        i32 = 22;
        break L15;
       } else break L15;
      } else {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 379986 | 0, 0, gb + 379914 | 0, 596, 1, HEAP32[i1 + -32 >> 2] | 0, 0, 0);
       break L8;
      }
     } while (0);
     if ((i32 | 0) == 22) {
      i32 = 0;
      f4 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 72 >> 2]));
     }
     i9 = HEAP32[i6 + 264 >> 2] | 0;
     i10 = HEAP32[i6 + 268 >> 2] | 0;
     i3 = HEAP32[i6 + 272 >> 2] | 0;
     i5 = HEAP32[i14 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i15 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i1 = i7 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i15 >> 2] = i1;
       HEAP32[i30 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i30 >> 2] | 0, i1 << 4, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i30 >> 2] | 0, HEAP32[i14 >> 2] << 4 | 0) | 0;
       HEAP32[i15 >> 2] = i1;
       HEAP32[i30 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i14 >> 2] = i6;
     i6 = HEAP32[i30 >> 2] | 0;
     HEAP32[i6 + (i5 << 4) >> 2] = i9;
     HEAP32[i6 + (i5 << 4) + 4 >> 2] = i10;
     HEAP32[i6 + (i5 << 4) + 8 >> 2] = i3;
     HEAPF32[i6 + (i5 << 4) + 12 >> 2] = f4;
     i3 = i11;
     i5 = HEAP32[i17 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i18 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i1 = i7 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i18 >> 2] = i1;
       HEAP32[i29 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i29 >> 2] | 0, i1 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i29 >> 2] | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
       HEAP32[i18 >> 2] = i1;
       HEAP32[i29 >> 2] = i11;
       break;
      }
     } while (0);
     HEAP32[i17 >> 2] = i6;
     HEAP32[(HEAP32[i29 >> 2] | 0) + (i5 << 2) >> 2] = i3;
     i3 = HEAP32[i20 >> 2] | 0;
     i5 = i3 + 1 | 0;
     i6 = HEAP32[i21 >> 2] | 0;
     i7 = i6 & 2147483647;
     i1 = i5 >>> 0 > i7 >>> 0;
     if (!(HEAP32[(HEAP32[i12 >> 2] | 0) + 96 >> 2] | 0)) {
      do if (i1) {
       i1 = i6 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i21 >> 2] = i1;
        HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i20 >> 2] << 2 | 0) | 0;
        HEAP32[i21 >> 2] = i1;
        HEAP32[i31 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i20 >> 2] = i5;
      HEAP32[(HEAP32[i31 >> 2] | 0) + (i3 << 2) >> 2] = 0;
      break;
     } else {
      do if (i1) {
       i1 = i6 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i21 >> 2] = i1;
        HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i12 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i20 >> 2] << 2 | 0) | 0;
        HEAP32[i21 >> 2] = i1;
        HEAP32[i31 >> 2] = i12;
        break;
       }
      } while (0);
      HEAP32[i20 >> 2] = i5;
      HEAP32[(HEAP32[i31 >> 2] | 0) + (i3 << 2) >> 2] = 1;
      break;
     }
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i27 | 0));
 }
 if (!i26) {
  STACKTOP = i33;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i26);
 STACKTOP = i33;
 return;
}

function __ZN13MonoBehaviour22GetScriptFullClassNameEv(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 64 | 0;
 i11 = i13 + 48 | 0;
 i12 = i13 + 32 | 0;
 i7 = i13 + 16 | 0;
 i8 = i13;
 HEAP32[i11 >> 2] = HEAP32[i5 + 36 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i3 = HEAP32[i10 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) {
  __ZNK10MonoScript22GetScriptFullClassNameEv(i2, i1);
  STACKTOP = i13;
  return;
 }
 i5 = i5 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i1 | 0) {
   i3 = __Z29scripting_class_get_namespaceP11Il2CppClass(i1) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 + 12 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
    i1 = HEAP32[i11 + 12 >> 2] | 0;
    i9 = 16;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i11 + 11 >> 0] = i4;
    if (!i4) i1 = i11; else {
     i1 = i11;
     i9 = 18;
    }
   } else i9 = 16;
   if ((i9 | 0) == 16) {
    i6 = i4 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i10 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 8 >> 2] = i6 | -2147483648;
    HEAP32[i11 + 4 >> 2] = i4;
    i9 = 18;
   }
   if ((i9 | 0) == 18) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   i3 = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 + 12 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
    i1 = HEAP32[i12 + 12 >> 2] | 0;
    i9 = 22;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i12 + 11 >> 0] = i4;
    if (!i4) i1 = i12; else {
     i1 = i12;
     i9 = 24;
    }
   } else i9 = 22;
   if ((i9 | 0) == 22) {
    i6 = i4 + 16 & -16;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i10 + 4 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 8 >> 2] = i6 | -2147483648;
    HEAP32[i12 + 4 >> 2] = i4;
    i9 = 24;
   }
   if ((i9 | 0) == 24) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   i6 = i11 + 11 | 0;
   i5 = HEAP8[i6 >> 0] | 0;
   if (!((i5 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255) | 0)) {
    i1 = i12 + 11 | 0;
    i5 = HEAP8[i1 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
    i5 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i5 & 255;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i2 + 12 >> 2] = i3;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     i9 = 29;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i5;
     if (i5) i9 = 31;
    } else i9 = 29;
    if ((i9 | 0) == 29) {
     i7 = i5 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i10 + 4 >> 2] = i3;
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i8;
     HEAP32[i2 + 8 >> 2] = i7 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i8;
     i9 = 31;
    }
    if ((i9 | 0) == 31) _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
    HEAP8[i2 + i5 >> 0] = 0;
   } else {
    __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i8, i11, gb + 1087625 | 0);
    __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i7, i8, i12);
    i4 = i7 + 11 | 0;
    i5 = HEAP8[i4 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i3 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
    i5 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i2 + 12 >> 2] = i1;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i1 = HEAP32[i2 + 12 >> 2] | 0;
     i9 = 36;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i5;
     if (i5) i9 = 38;
    } else i9 = 36;
    if ((i9 | 0) == 36) {
     i14 = i5 + 16 & -16;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i10 + 4 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i1;
     HEAP32[i2 + 8 >> 2] = i14 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i1;
     i9 = 38;
    }
    if ((i9 | 0) == 38) _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
    HEAP8[i2 + i5 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     i14 = HEAP32[i7 >> 2] | 0;
     i9 = HEAP32[i7 + 12 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i10 + 4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i10);
    }
    if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i8 >> 2] | 0;
     i9 = HEAP32[i8 + 12 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i10 + 4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i10);
    }
    i1 = i12 + 11 | 0;
   }
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    i14 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 12 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i10 + 4 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i10);
   }
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    i14 = HEAP32[i11 >> 2] | 0;
    i12 = HEAP32[i11 + 12 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i10 + 4 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i10);
   }
   STACKTOP = i13;
   return;
  }
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN11NavMeshData8TransferI14SafeBinaryReadEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 4 | 0;
 i3 = i11;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i7, i10);
 i2 = i7 + 52 | 0;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843578 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843593 | 0, gb + 843609 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932905 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i3 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i6 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 14; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 14) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i7 + 36 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843623 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i3 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i6 = 25; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 25; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i7 + 40 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843638 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i3 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i6 = 36; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 36; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i7 + 44 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843653 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i3 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i6 = 47; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 47; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 47) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i7 + 48 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843667 | 0, i5, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i5 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i6 = 58; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 58; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 58) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
  } else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843676 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843689 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 843704 | 0, i8, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i8, i6, i11, i12, i5, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 64 | 0;
 i14 = i15;
 i9 = i8 + 36 | 0;
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + 284 >> 2] | 0;
 L1 : do if (!(HEAP8[i8 + 52 >> 0] | 0)) i10 = 23; else switch (HEAP32[i8 + 56 >> 2] | 0) {
 case 13:
  {
   i4 = HEAP32[i8 + 96 >> 2] | 0;
   if (!i4) {
    i1 = i6;
    i10 = 24;
    break L1;
   }
   HEAP32[i14 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i2 = HEAP32[i13 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 11;
    }
   }
   if ((i10 | 0) == 9) i10 = 11;
   if ((i10 | 0) == 11) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i1 = i6;
     i10 = 24;
     break L1;
    }
   }
   i1 = __ZN8Renderer12GetTransformEv(i1) | 0;
   i10 = 24;
   break L1;
  }
 case 14:
  {
   i4 = HEAP32[i8 + 100 >> 2] | 0;
   if (!i4) {
    i1 = i6;
    i10 = 24;
    break L1;
   }
   HEAP32[i14 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i2 = HEAP32[i13 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 21;
    }
   }
   if ((i10 | 0) == 19) i10 = 21;
   if ((i10 | 0) == 21) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i1 = i6;
     i10 = 24;
     break L1;
    }
   }
   i1 = __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i1) | 0;
   i10 = 24;
   break L1;
  }
 default:
  {
   i10 = 23;
   break L1;
  }
 } while (0);
 L32 : do if ((i10 | 0) == 23) switch (i1 | 0) {
 case 0:
  {
   i1 = i6;
   i10 = 24;
   break L32;
  }
 case 1:
  {
   __ZNK9Transform13GetLocalScaleEv(i13, i6);
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAPF32[i5 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
   __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i13, i6);
   i2 = i11;
   i3 = i13;
   i4 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZN10Matrix4x4f5ScaleERK8Vector3f(i11, i7) | 0;
   i7 = i11;
   break L32;
  }
 default:
  {
   HEAPF32[i7 >> 2] = Math_fround(1.0);
   HEAPF32[i7 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i7 + 8 >> 2] = Math_fround(1.0);
   __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i13, i6);
   i2 = i11;
   i3 = i13;
   i4 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZNK9Transform18GetWorldScaleLossyEv(i13, i6);
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   i7 = i11;
   break L32;
  }
 } while (0);
 if ((i10 | 0) == 24) {
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
  __ZNK9Transform21GetLocalToWorldMatrixEv(i13, i1);
  i2 = i11;
  i3 = i13;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZNK9Transform18GetWorldScaleLossyEv(i13, i1);
  HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i6 = i1;
  i7 = i11;
 }
 i5 = i8 + 40 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + 116 | 0;
 i3 = i7;
 i4 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i1 + 280 >> 2] | 0) != 2) {
  __ZNK9Transform16GetLocalRotationEv(i13, i6);
  __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i13, i12);
  STACKTOP = i15;
  return;
 }
 i4 = i1 + 288 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZNK9Transform16GetLocalRotationEv(i13, i6);
  __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i13, i12);
  STACKTOP = i15;
  return;
 }
 HEAP32[i14 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 34; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
   i2 = HEAP32[i13 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 34; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i10 = 36;
  }
 }
 if ((i10 | 0) == 34) i10 = 36;
 if ((i10 | 0) == 36) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   __ZNK9Transform16GetLocalRotationEv(i13, i6);
   __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i13, i12);
   STACKTOP = i15;
   return;
  }
 }
 __ZNK9Transform21GetLocalToWorldMatrixEv(i13, i1);
 __Z25InvertMatrix4x4_General3DPKfPf(i13, i14) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i14, i11, (HEAP32[i5 >> 2] | 0) + 116 | 0);
 i2 = i7;
 i3 = i13;
 i4 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZNK9Transform16GetLocalRotationEv(i13, i6);
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i13, i12);
 STACKTOP = i15;
 return;
}

function __ZN11Rigidbody2D16TransformChangedEi(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i21 + 32 | 0;
 i11 = i21 + 16 | 0;
 i12 = i21;
 i13 = i21 + 8 | 0;
 i20 = i18 + 92 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if (!i2) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
 i14 = (HEAP8[i6 + 624 >> 0] | 0) != 0;
 i1 = HEAP32[i18 + 68 >> 2] | 0;
 if (!i14) {
  if (!((i1 | 0) != 2 & (HEAP8[i18 + 224 >> 0] | 0) == 0)) {
   STACKTOP = i21;
   return;
  }
  if ((i1 | 0) != 1) if (HEAP16[i2 + 4 >> 1] & 2) {
   STACKTOP = i21;
   return;
  }
 }
 i2 = i18 + 28 | 0;
 if (i19 & 64 | 0) {
  i3 = __Z17GetTransformDepthR9Transform(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0) | 0;
  i3 = i6 + 68 + (((i3 | 0) < 63 ? i3 : 63) << 3) | 0;
  i4 = i18 + 104 | 0;
  if ((i4 | 0) != (i3 | 0)) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = i18 + 108 | 0; else {
    i17 = i18 + 108 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i17 >> 2];
    HEAP32[HEAP32[i17 >> 2] >> 2] = i1;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
    i1 = i17;
   }
   i17 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 >> 2] = i17;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i17 + 4 >> 2] = i4;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  }
  HEAP8[i6 + 625 >> 0] = 1;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0;
 if (!(i19 & 32)) i17 = 0; else i17 = (HEAP32[HEAP32[i20 >> 2] >> 2] | 0) != 0;
 i9 = (i19 & 1 | 0) != 0;
 i15 = (i19 & 2 | 0) != 0;
 if (i9) if (!(HEAP8[i18 + 225 >> 0] | 0)) i1 = 1; else if ((HEAP32[i18 + 56 >> 2] | 0) == 1) {
  __ZNK9Transform11GetPositionEv(i10, i2);
  f5 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i18 + 156 >> 2]));
  i16 = f5 < Math_fround(0.0);
  f22 = Math_fround(-f5);
  if (!((i16 ? f22 : f5) <= Math_fround(.0000999999974))) i1 = 1; else {
   f22 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f22 = Math_fround(f22 - Math_fround(HEAPF32[i18 + 160 >> 2]));
   i1 = f22 < Math_fround(0.0);
   f5 = Math_fround(-f22);
   i1 = !((i1 ? f5 : f22) <= Math_fround(.0000999999974));
  }
 } else i1 = 1; else i1 = 0;
 i16 = (i19 & 3 | 0) != 0;
 if (i16) {
  __ZNK9Transform11GetPositionEv(i10, i2);
  __ZNK9Transform11GetRotationEv(i11, i2);
  i7 = i18 + 156 | 0;
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i8 = i18 + 168 | 0;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i6 = HEAP32[i20 >> 2] | 0;
  i3 = i6 + 12 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i12;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  f5 = Math_fround(HEAPF32[i6 + 56 >> 2]);
  if (i9) {
   i4 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i4;
   HEAP32[i12 + 4 >> 2] = i3;
  } else i4 = i2;
  if (i15) {
   f5 = Math_fround(HEAPF32[i11 + 12 >> 2]);
   i2 = f5 < Math_fround(0.0);
   f23 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f24 = Math_fround(-f23);
   f22 = Math_fround(-f5);
   f5 = Math_fround(Math_fround(+Math_atan2(+(i2 ? f24 : f23), +(i2 ? f22 : f5))) * Math_fround(2.0));
   i2 = 27;
  } else if (i1) i2 = 27; else {
   i1 = 0;
   i2 = 30;
  }
  do if ((i2 | 0) == 27) if (i17) {
   HEAP32[i13 >> 2] = i4;
   HEAP32[i13 + 4 >> 2] = i3;
   __ZN11Rigidbody2D12MovePositionERK8Vector2f(i18, i13);
   __ZN11Rigidbody2D12MoveRotationEf(i18, f5);
   break;
  } else {
   __ZN6b2Body12SetTransformERK6b2Vec2f(i6, i12, f5);
   __ZN11Rigidbody2D19RecalculateContactsEv(i18);
   __ZN11Rigidbody2D17UpdateConstraintsEb(i18, 0);
   i1 = 1;
   i2 = 30;
   break;
  } while (0);
  if ((i2 | 0) == 30) if (!(i17 | i14 ^ 1)) {
   if (i1) {
    HEAP8[i18 + 225 >> 0] = 0;
    i14 = i18 + 128 | 0;
    i13 = i18 + 184 | 0;
    HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    i14 = i18 + 140 | 0;
    i13 = i18 + 196 | 0;
    HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   }
   if (i9) {
    i1 = i18 + 226 | 0;
    if (HEAP8[i1 >> 0] | 0) {
     HEAP8[i1 >> 0] = 0;
     i3 = i18 + 124 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     i7 = HEAP32[i1 + 92 >> 2] | 0;
     if (i7 | 0) {
      i4 = HEAP32[i18 + 212 >> 2] | 0;
      i6 = HEAP32[i18 + 216 >> 2] | 0;
      if (HEAP32[i7 >> 2] | 0) {
       f23 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f23 = Math_fround(f23 * f23);
       f24 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       do if (Math_fround(f23 + Math_fround(f24 * f24)) > Math_fround(0.0)) {
        i1 = i7 + 4 | 0;
        i2 = HEAPU16[i1 >> 1] | 0;
        if (i2 & 2 | 0) break;
        HEAP16[i1 >> 1] = i2 | 2;
        HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
       } while (0);
       HEAP32[i7 + 64 >> 2] = i4;
       HEAP32[i7 + 68 >> 2] = i6;
       i1 = HEAP32[i3 >> 2] | 0;
      }
      HEAP32[i7 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
     }
    }
   }
   if (i15) {
    i1 = i18 + 227 | 0;
    if (HEAP8[i1 >> 0] | 0) {
     HEAP8[i1 >> 0] = 0;
     i3 = HEAP32[i18 + 124 >> 2] | 0;
     i4 = HEAP32[i3 + 92 >> 2] | 0;
     if (i4 | 0) {
      f5 = Math_fround(HEAPF32[i18 + 220 >> 2]);
      if (HEAP32[i4 >> 2] | 0) {
       i2 = i4 + 4 | 0;
       i1 = HEAP16[i2 >> 1] | 0;
       if (!(i1 & 16)) {
        do if (Math_fround(f5 * f5) > Math_fround(0.0)) {
         i1 = i1 & 65535;
         if (i1 & 2 | 0) break;
         HEAP16[i2 >> 1] = i1 | 2;
         HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
        } while (0);
        HEAPF32[i4 + 72 >> 2] = f5;
       }
      }
      HEAP32[i4 + 136 >> 2] = HEAP32[i3 + 40 >> 2];
     }
    }
   }
  }
 }
 if (i17) {
  STACKTOP = i21;
  return;
 }
 if ((i19 & 8 | 0) == 0 & (i16 ^ 1)) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = (__Z14IsWorldPlayingv() | 0) ^ 1;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 64 >> 2] | 0;
  if (i2 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i4 | 0);
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0);
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i21;
 return;
}

function __ZL28removeBrokenEdgesFromIslandsPKjjS0_jS0_RKN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerERNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEEPSD_(i10, i12, i16, i17, i11, i1, i20, i21, i18, i13) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 4096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24;
 i14 = HEAP32[i1 + 4 >> 2] | 0;
 i19 = i20 + 4 | 0;
 i15 = HEAP32[i19 >> 2] | 0;
 if (i12 | 0) {
  i6 = (i13 | 0) == 0;
  i7 = (i11 | 0) == 0;
  i8 = HEAP32[i18 >> 2] | 0;
  i9 = 0;
  do {
   i4 = HEAP32[i10 + (i9 << 2) >> 2] | 0;
   i1 = i15 + (i4 * 12 | 0) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = i15 + (i4 * 12 | 0) + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) != -1) {
    if (!i6) {
     i3 = (HEAP32[i13 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i2 & 31);
    }
    i3 = HEAP32[i14 + (i2 * 12 | 0) + 4 >> 2] | 0;
    if ((i3 | 0) != -1) {
     i25 = i8 + (i3 >>> 5 << 2) | 0;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i3 & 31);
    }
    if (!i7) if (HEAP8[i14 + (i2 * 12 | 0) + 8 >> 0] & 1) HEAP32[i1 >> 2] = HEAP32[i11 + (i2 << 2) >> 2];
   }
   if ((i5 | 0) != -1) {
    if (!i6) {
     i25 = (HEAP32[i13 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i5 & 31);
    }
    i1 = HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i25 = i8 + (i1 >>> 5 << 2) | 0;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
    }
    if (!i7) if (HEAP8[i14 + (i5 * 12 | 0) + 8 >> 0] & 1) HEAP32[i4 >> 2] = HEAP32[i11 + (i5 << 2) >> 2];
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i12 | 0));
 }
 if (!i17) i1 = i18; else if (!i13) {
  i4 = 0;
  do {
   i3 = HEAP32[i16 + (i4 << 2) >> 2] | 0;
   i1 = i15 + (i3 * 12 | 0) + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 & 2 | 0) {
    HEAP32[i1 >> 2] = i2 & -3;
    i1 = HEAP32[i15 + (i3 * 12 | 0) >> 2] | 0;
    i2 = HEAP32[i15 + (i3 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i1 = HEAP32[i14 + (i1 * 12 | 0) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i25 = (HEAP32[i18 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
      HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
     }
    }
    if ((i2 | 0) != -1) {
     i1 = HEAP32[i14 + (i2 * 12 | 0) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i25 = (HEAP32[i18 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
      HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
     }
    }
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i17 | 0));
  i1 = i18;
 } else {
  i4 = 0;
  do {
   i3 = HEAP32[i16 + (i4 << 2) >> 2] | 0;
   i2 = i15 + (i3 * 12 | 0) + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 & 2 | 0) {
    HEAP32[i2 >> 2] = i1 & -3;
    i1 = HEAP32[i15 + (i3 * 12 | 0) >> 2] | 0;
    i2 = HEAP32[i15 + (i3 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i25 = (HEAP32[i13 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
     HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
     i1 = HEAP32[i14 + (i1 * 12 | 0) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i25 = (HEAP32[i18 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
      HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
     }
    }
    if ((i2 | 0) != -1) {
     i1 = (HEAP32[i13 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i2 & 31);
     i1 = HEAP32[i14 + (i2 * 12 | 0) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i25 = (HEAP32[i18 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
      HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i1 & 31);
     }
    }
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i17 | 0));
  i1 = i18;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i18 + 4 >> 2] & 2147483647;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i11 = 0;
   break;
  }
  i1 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
  if (!i1) i1 = i2; else {
   i23 = 42;
   break;
  }
 }
 if ((i23 | 0) == 42) {
  i11 = i1 >>> 1 | i1;
  i11 = i11 >>> 2 | i11;
  i11 = i11 >>> 4 | i11;
  i11 = i11 >>> 8 | i11;
  i11 = (Math_imul(i11 >>> 16 | i11, 130329821) | 0) >>> 27;
  i11 = ((HEAP32[gb + 85120 + (i11 << 2) >> 2] | 0) + (i2 << 5) | 0) >>> 5;
 }
 i15 = HEAP32[i19 >> 2] | 0;
 i14 = HEAP32[i20 + 24 >> 2] | 0;
 i13 = HEAP32[i21 + 4 >> 2] | 0;
 i1 = 0;
 i10 = 0;
 while (1) {
  i2 = HEAP32[i12 + (i10 << 2) >> 2] | 0;
  if (i2) {
   i9 = i10 << 5;
   do {
    i6 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
    i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i9;
    if (i1 >>> 0 < 1024) {
     HEAP32[i22 + (i1 << 2) >> 2] = i6;
     i1 = i1 + 1 | 0;
    } else {
     i8 = 0;
     do {
      i7 = HEAP32[i22 + (i8 << 2) >> 2] | 0;
      i4 = i13 + (i7 << 4) + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      L71 : do if ((i3 | 0) == -1) i23 = 51; else {
       while (1) {
        if (HEAP32[i15 + (i3 * 12 | 0) + 8 >> 2] & 2 | 0) break;
        i25 = i14 + (i3 << 2) | 0;
        i3 = HEAP32[i25 >> 2] | 0;
        HEAP32[i25 >> 2] = -1;
        if ((i3 | 0) == -1) {
         i23 = 51;
         break L71;
        }
       }
       HEAP32[i4 >> 2] = i3;
       i4 = i14 + (i3 << 2) | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       L76 : do if ((i5 | 0) != -1) do {
        while (1) {
         if (HEAP32[i15 + (i5 * 12 | 0) + 8 >> 2] & 2 | 0) {
          i3 = i5;
          break;
         }
         i25 = i14 + (i5 << 2) | 0;
         i5 = HEAP32[i25 >> 2] | 0;
         HEAP32[i25 >> 2] = -1;
         if ((i5 | 0) == -1) break L76;
        }
        HEAP32[i4 >> 2] = i3;
        i4 = i14 + (i3 << 2) | 0;
        i5 = HEAP32[i4 >> 2] | 0;
       } while ((i5 | 0) != -1); while (0);
       HEAP32[i4 >> 2] = -1;
      } while (0);
      if ((i23 | 0) == 51) {
       i23 = 0;
       HEAP32[i4 >> 2] = -1;
       i3 = -1;
      }
      HEAP32[i13 + (i7 << 4) + 12 >> 2] = i3;
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i1 | 0));
     HEAP32[i22 >> 2] = i6;
     i1 = 1;
    }
    i2 = i2 + -1 & i2;
   } while ((i2 | 0) != 0);
  }
  if ((i10 | 0) == (i11 | 0)) {
   i6 = i1;
   break;
  } else i10 = i10 + 1 | 0;
 }
 if (!i6) {
  STACKTOP = i24;
  return;
 } else i5 = 0;
 do {
  i4 = HEAP32[i22 + (i5 << 2) >> 2] | 0;
  i2 = i13 + (i4 << 4) + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  L95 : do if ((i1 | 0) == -1) i23 = 66; else {
   while (1) {
    if (HEAP32[i15 + (i1 * 12 | 0) + 8 >> 2] & 2 | 0) break;
    i25 = i14 + (i1 << 2) | 0;
    i1 = HEAP32[i25 >> 2] | 0;
    HEAP32[i25 >> 2] = -1;
    if ((i1 | 0) == -1) {
     i23 = 66;
     break L95;
    }
   }
   HEAP32[i2 >> 2] = i1;
   i2 = i14 + (i1 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   L100 : do if ((i3 | 0) != -1) do {
    while (1) {
     if (HEAP32[i15 + (i3 * 12 | 0) + 8 >> 2] & 2 | 0) {
      i1 = i3;
      break;
     }
     i25 = i14 + (i3 << 2) | 0;
     i3 = HEAP32[i25 >> 2] | 0;
     HEAP32[i25 >> 2] = -1;
     if ((i3 | 0) == -1) break L100;
    }
    HEAP32[i2 >> 2] = i1;
    i2 = i14 + (i1 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
   } while ((i3 | 0) != -1); while (0);
   HEAP32[i2 >> 2] = -1;
  } while (0);
  if ((i23 | 0) == 66) {
   i23 = 0;
   HEAP32[i2 >> 2] = -1;
   i1 = -1;
  }
  HEAP32[i13 + (i4 << 4) + 12 >> 2] = i1;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i6 | 0));
 STACKTOP = i24;
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i3, i1, i4, i2, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i7 + 28 | 0;
 i25 = i7;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f10 * f10);
 i28 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f20));
 i29 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i29 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f9 * f9));
 i30 = i4 + 12 | 0;
 f15 = Math_fround(HEAPF32[i30 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f15 * f15)))));
 f10 = Math_fround(f10 * f12);
 f20 = Math_fround(f20 * f12);
 f9 = Math_fround(f9 * f12);
 f12 = Math_fround(f15 * f12);
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i33 = i4 + 20 | 0;
 i23 = HEAP32[i33 >> 2] | 0;
 i32 = i4 + 24 | 0;
 i22 = HEAP32[i32 >> 2] | 0;
 HEAPF32[i6 + 20 >> 2] = f10;
 HEAPF32[i6 + 24 >> 2] = f20;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f12;
 HEAP32[i6 + 36 >> 2] = i24;
 HEAP32[i6 + 40 >> 2] = i23;
 HEAP32[i6 + 44 >> 2] = i22;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f12 * f12);
 i22 = i5 + 4 | 0;
 f20 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f20));
 i23 = i5 + 8 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f10));
 i24 = i5 + 12 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f15 * f15)))));
 f12 = Math_fround(f12 * f9);
 f20 = Math_fround(f20 * f9);
 f10 = Math_fround(f10 * f9);
 f9 = Math_fround(f15 * f9);
 i36 = HEAP32[i5 + 16 >> 2] | 0;
 i27 = i5 + 20 | 0;
 i35 = HEAP32[i27 >> 2] | 0;
 i26 = i5 + 24 | 0;
 i34 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i6 + 48 >> 2] = f12;
 HEAPF32[i6 + 52 >> 2] = f20;
 HEAPF32[i6 + 56 >> 2] = f10;
 HEAPF32[i6 + 60 >> 2] = f9;
 HEAP32[i6 + 64 >> 2] = i36;
 HEAP32[i6 + 68 >> 2] = i35;
 HEAP32[i6 + 72 >> 2] = i34;
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i31, i6, i1);
 f9 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i31 + 4 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i31 + 8 >> 2]));
 f12 = Math_fround(HEAPF32[i31 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i31 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i33 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i31 + 20 >> 2]));
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f13 - Math_fround(HEAPF32[i31 + 24 >> 2])) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f8 * f10)) + Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f21 * f15) + Math_fround(f12 * Math_fround(Math_fround(f13 * f10) - Math_fround(f8 * f20)))));
 f17 = Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f21 * f8) + Math_fround(f12 * Math_fround(Math_fround(f15 * f20) - Math_fround(f13 * f9)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f8 * f9) - Math_fround(f15 * f10)))) + Math_fround(f18 * f20));
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f12 * f15);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f9));
 f21 = Math_fround(HEAPF32[i29 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f21 * f10));
 f11 = Math_fround(HEAPF32[i28 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f15 * f20) + Math_fround(Math_fround(f13 * f10) + Math_fround(f12 * f11))) - Math_fround(f21 * f9));
 f19 = Math_fround(Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f13 * f20) + Math_fround(f12 * f21))) - Math_fround(f15 * f10));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f15 * f9)) - Math_fround(f11 * f10)) - Math_fround(f21 * f20));
 HEAPF32[i3 >> 2] = Math_fround(f8 - Math_fround(f11 * f20));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f19;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i3 + 24 >> 2] = f18;
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i25, i6, i2);
 f18 = Math_fround(-Math_fround(HEAPF32[i25 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i25 + 4 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i25 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i25 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i27 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i25 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f16 = Math_fround(f16 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i25 + 24 >> 2])) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f16 * f17)) + Math_fround(f20 * f14));
 f10 = Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f11 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f17) - Math_fround(f16 * f14)))));
 f9 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f11 * f16) + Math_fround(f21 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f18) - Math_fround(f19 * f17)))) + Math_fround(f8 * f14));
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f20 * f18));
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f11 * f17));
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f15))) - Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f11))) - Math_fround(f19 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f15 * f17)) - Math_fround(f11 * f14));
 HEAPF32[i3 + 28 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i3 + 32 >> 2] = f13;
 HEAPF32[i3 + 36 >> 2] = f12;
 HEAPF32[i3 + 40 >> 2] = f11;
 HEAPF32[i3 + 44 >> 2] = f10;
 HEAPF32[i3 + 48 >> 2] = f9;
 HEAPF32[i3 + 52 >> 2] = f8;
 HEAPF32[i3 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 68 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i23, i14, i2, i26, i5, i9, i1, i6, f27, f28, f8) {
 i23 = i23 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i26 = i26 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 f27 = Math_fround(f27);
 f28 = Math_fround(f28);
 f8 = Math_fround(f8);
 var i3 = 0, i4 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i29 = 0, f30 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i29 + 24 | 0;
 i24 = i29 + 12 | 0;
 i25 = i29;
 HEAP32[i11 >> 2] = 0;
 __Z28CalculatePositionAndVelocityR8Vector3fS0_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesj(i24, i25, i2, i26, i5, i6);
 switch (i9 | 0) {
 case 2:
  {
   i1 = (HEAP32[i26 + 420 >> 2] | 0) + i1 | 0;
   i3 = 3;
   break;
  }
 case 1:
  {
   i3 = 3;
   break;
  }
 default:
  {}
 }
 if ((i3 | 0) == 3) i1 = (HEAP32[i26 + 412 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[(HEAP32[i26 + 400 >> 2] | 0) + (i1 * 600 | 0) + 592 >> 2] | 0;
 if (!(i3 & 1)) {
  i18 = -1;
  i20 = -1;
  i21 = -1;
  i22 = -1;
 } else {
  i22 = HEAP32[(HEAP32[i5 + 480 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i18 = i22 & 255;
  i20 = i22 >>> 8 & 255;
  i21 = i22 >>> 16 & 255;
  i22 = i22 >>> 24 & 255;
 }
 if (!(i3 & 2)) {
  i17 = 1065353216;
  i19 = 1065353216;
  i16 = 1065353216;
 } else {
  i2 = HEAP32[(HEAP32[i5 + 420 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  if (!(HEAP8[i5 + 871 >> 0] | 0)) {
   i17 = i2;
   i19 = i2;
   i16 = i2;
  } else {
   i17 = i2;
   i19 = HEAP32[(HEAP32[i5 + 460 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i16 = HEAP32[(HEAP32[i5 + 440 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  }
 }
 if (!(i3 & 4)) {
  i15 = 0;
  i12 = 0;
  i13 = 0;
  i10 = 0;
  i7 = 0;
  i6 = 0;
 } else {
  i2 = HEAP32[i5 + 340 >> 2] | 0;
  if (!(HEAP8[i5 + 870 >> 0] | 0)) {
   i4 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i3 = i4;
   i2 = i4;
  } else {
   i3 = HEAP32[(HEAP32[i5 + 300 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i2 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
   i4 = HEAP32[(HEAP32[i5 + 320 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  }
  if (!(HEAP8[i5 + 868 >> 0] | 0)) {
   i15 = 0;
   i12 = i3;
   i13 = 0;
   i10 = i2;
   i7 = 0;
   i6 = i4;
  } else {
   i15 = HEAP32[(HEAP32[i5 + 240 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i12 = i3;
   i13 = HEAP32[(HEAP32[i5 + 280 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i10 = i2;
   i7 = HEAP32[(HEAP32[i5 + 260 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i6 = i4;
  }
 }
 if (!i9) {
  f30 = Math_fround(f27 - f28);
  i2 = f30 < Math_fround(0.0);
  f30 = i2 ? Math_fround(0.0) : f30;
  i2 = __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff(i23, i14, i25, f30, f27, f28, f8) | 0;
  i5 = (__ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff(i23, i11, i14, f30, f27, f8) | 0) + i2 | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + i2 | 0;
  if (!i5) {
   STACKTOP = i29;
   return;
  }
  i3 = i26 + 460 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) >= (HEAP32[i26 + 464 >> 2] | 0)) {
   STACKTOP = i29;
   return;
  }
  HEAP32[i3 >> 2] = i4 + 1;
  i26 = HEAP32[i26 + 456 >> 2] | 0;
  i3 = HEAP32[i24 >> 2] | 0;
  i9 = HEAP32[i24 + 4 >> 2] | 0;
  i11 = HEAP32[i24 + 8 >> 2] | 0;
  i14 = HEAP32[i25 >> 2] | 0;
  i24 = HEAP32[i25 + 4 >> 2] | 0;
  i25 = HEAP32[i25 + 8 >> 2] | 0;
  _memmove(i26 + (i4 * 112 | 0) | 0, i23 | 0, 24) | 0;
  HEAP32[i26 + (i4 * 112 | 0) + 24 >> 2] = i3;
  HEAP32[i26 + (i4 * 112 | 0) + 28 >> 2] = i9;
  HEAP32[i26 + (i4 * 112 | 0) + 32 >> 2] = i11;
  HEAP32[i26 + (i4 * 112 | 0) + 36 >> 2] = i14;
  HEAP32[i26 + (i4 * 112 | 0) + 40 >> 2] = i24;
  HEAP32[i26 + (i4 * 112 | 0) + 44 >> 2] = i25;
  HEAP32[i26 + (i4 * 112 | 0) + 48 >> 2] = (i20 & 255) << 8 | i18 & 255 | (i21 & 255) << 16 | (i22 & 255) << 24;
  HEAP32[i26 + (i4 * 112 | 0) + 52 >> 2] = i17;
  HEAP32[i26 + (i4 * 112 | 0) + 56 >> 2] = i16;
  HEAP32[i26 + (i4 * 112 | 0) + 60 >> 2] = i19;
  HEAP32[i26 + (i4 * 112 | 0) + 64 >> 2] = i12;
  HEAP32[i26 + (i4 * 112 | 0) + 68 >> 2] = i6;
  HEAP32[i26 + (i4 * 112 | 0) + 72 >> 2] = i10;
  HEAP32[i26 + (i4 * 112 | 0) + 76 >> 2] = i15;
  HEAP32[i26 + (i4 * 112 | 0) + 80 >> 2] = i7;
  HEAP32[i26 + (i4 * 112 | 0) + 84 >> 2] = i13;
  HEAP32[i26 + (i4 * 112 | 0) + 88 >> 2] = i1;
  HEAP32[i26 + (i4 * 112 | 0) + 92 >> 2] = i5;
  HEAP32[i26 + (i4 * 112 | 0) + 96 >> 2] = i2;
  HEAPF32[i26 + (i4 * 112 | 0) + 100 >> 2] = f28;
  HEAPF32[i26 + (i4 * 112 | 0) + 104 >> 2] = f27;
  HEAPF32[i26 + (i4 * 112 | 0) + 108 >> 2] = Math_fround(0.0);
  STACKTOP = i29;
  return;
 }
 if (!(HEAP32[i14 + 576 >> 2] | 0)) {
  STACKTOP = i29;
  return;
 }
 i4 = i23 + 8 | 0;
 i2 = HEAP32[i14 + 544 >> 2] | 0;
 i14 = HEAP32[i14 + 560 >> 2] | 0;
 i3 = i14 + 1 | 0;
 if ((i2 | 0) > (i14 | 0)) {
  if ((i3 | 0) < (i2 | 0)) {
   i9 = HEAP32[i4 >> 2] | 0;
   i9 = i9 << 11 ^ i9;
   i11 = i23 + 12 | 0;
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   i5 = i23 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
   i11 = i23 + 20 | 0;
   i14 = HEAP32[i11 >> 2] | 0;
   HEAP32[i5 >> 2] = i14;
   i14 = i9 >>> 8 ^ i9 ^ i14 ^ i14 >>> 19;
   HEAP32[i11 >> 2] = i14;
   i2 = i2 - ((i14 >>> 0) % ((i2 - i3 | 0) >>> 0) | 0) | 0;
  }
 } else {
  i9 = HEAP32[i4 >> 2] | 0;
  i9 = i9 << 11 ^ i9;
  i11 = i23 + 12 | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  i5 = i23 + 16 | 0;
  HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
  i11 = i23 + 20 | 0;
  i14 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i14;
  i14 = i9 >>> 8 ^ i9 ^ i14 ^ i14 >>> 19;
  HEAP32[i11 >> 2] = i14;
  i2 = ((i14 >>> 0) % ((i3 - i2 | 0) >>> 0) | 0) + i2 | 0;
 }
 if (!i2) {
  STACKTOP = i29;
  return;
 }
 i3 = i26 + 460 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) >= (HEAP32[i26 + 464 >> 2] | 0)) {
  STACKTOP = i29;
  return;
 }
 HEAP32[i3 >> 2] = i4 + 1;
 i26 = HEAP32[i26 + 456 >> 2] | 0;
 i5 = HEAP32[i24 >> 2] | 0;
 i9 = HEAP32[i24 + 4 >> 2] | 0;
 i11 = HEAP32[i24 + 8 >> 2] | 0;
 i14 = HEAP32[i25 >> 2] | 0;
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i25 = HEAP32[i25 + 8 >> 2] | 0;
 _memmove(i26 + (i4 * 112 | 0) | 0, i23 | 0, 24) | 0;
 HEAP32[i26 + (i4 * 112 | 0) + 24 >> 2] = i5;
 HEAP32[i26 + (i4 * 112 | 0) + 28 >> 2] = i9;
 HEAP32[i26 + (i4 * 112 | 0) + 32 >> 2] = i11;
 HEAP32[i26 + (i4 * 112 | 0) + 36 >> 2] = i14;
 HEAP32[i26 + (i4 * 112 | 0) + 40 >> 2] = i24;
 HEAP32[i26 + (i4 * 112 | 0) + 44 >> 2] = i25;
 HEAP32[i26 + (i4 * 112 | 0) + 48 >> 2] = (i20 & 255) << 8 | i18 & 255 | (i21 & 255) << 16 | (i22 & 255) << 24;
 HEAP32[i26 + (i4 * 112 | 0) + 52 >> 2] = i17;
 HEAP32[i26 + (i4 * 112 | 0) + 56 >> 2] = i16;
 HEAP32[i26 + (i4 * 112 | 0) + 60 >> 2] = i19;
 HEAP32[i26 + (i4 * 112 | 0) + 64 >> 2] = i12;
 HEAP32[i26 + (i4 * 112 | 0) + 68 >> 2] = i6;
 HEAP32[i26 + (i4 * 112 | 0) + 72 >> 2] = i10;
 HEAP32[i26 + (i4 * 112 | 0) + 76 >> 2] = i15;
 HEAP32[i26 + (i4 * 112 | 0) + 80 >> 2] = i7;
 HEAP32[i26 + (i4 * 112 | 0) + 84 >> 2] = i13;
 HEAP32[i26 + (i4 * 112 | 0) + 88 >> 2] = i1;
 HEAP32[i26 + (i4 * 112 | 0) + 92 >> 2] = i2;
 HEAP32[i26 + (i4 * 112 | 0) + 96 >> 2] = 0;
 HEAPF32[i26 + (i4 * 112 | 0) + 100 >> 2] = f28;
 HEAPF32[i26 + (i4 * 112 | 0) + 104 >> 2] = f27;
 HEAPF32[i26 + (i4 * 112 | 0) + 108 >> 2] = Math_fround(0.0);
 STACKTOP = i29;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER8UnityStrjPKc(i10, i14, i5, i2) {
 i10 = i10 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i19 + 160 | 0;
 i3 = i19 + 144 | 0;
 i15 = i19 + 216 | 0;
 i17 = i19;
 i18 = i19 + 184 | 0;
 i16 = i19 + 168 | 0;
 __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i17, 0, 0);
 if (!i5) {
  __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i17, i10 + 4 | 0, gb + 1047471 | 0, 0);
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i17 | 0);
 } else {
  HEAP32[i15 >> 2] = 0;
  i11 = i15 + 20 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i15 + 24 | 0;
  i7 = gb + 63648 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i12;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = i15 + 4 | 0;
  HEAP8[i9 >> 0] = 0;
  if (!i2) {
   i1 = i10 + 4 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = i5;
   __Z6FormatPKcz(i18, gb + 1047573 | 0, i4);
   i1 = HEAP8[i18 + 11 >> 0] | 0;
   i5 = i1 << 24 >> 24 < 0;
   i8 = i5 ? HEAP32[i18 >> 2] | 0 : i18;
   i1 = i5 ? HEAP32[i18 + 4 >> 2] | 0 : i1 & 255;
   i5 = HEAP32[i15 >> 2] | 0;
   i6 = (i5 | 0) == 0;
   i2 = i6 ? i9 : i5;
   if (i2 >>> 0 > i8 >>> 0) i13 = 29; else {
    i3 = HEAP32[i11 >> 2] | 0;
    if ((i2 + i3 | 0) >>> 0 > i8 >>> 0) {
     i1 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
     if ((i2 | 0) != (i8 | 0)) _memmove(i2 | 0, i8 | 0, i1 | 0) | 0;
    } else i13 = 29;
   }
   if ((i13 | 0) == 29) {
    i7 = i15 + 4 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    i4 = (i3 | 0) == 0;
    if (i4) if (i6) {
     i3 = 15;
     i13 = 32;
    } else i13 = 35; else {
     i3 = i6 ? 15 : i3;
     i13 = 32;
    }
    if ((i13 | 0) == 32) if (i3 >>> 0 < i1 >>> 0) if (i6 | i4) i13 = 35; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
     i13 = 35;
    }
    if ((i13 | 0) == 35) {
     if (i1 >>> 0 > 15) {
      i2 = i1;
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + 1 | 0, 16, i12, 0, gb + 1047486 | 0, 251) | 0;
     } else {
      i2 = 0;
      i3 = 0;
     }
     HEAP32[i15 >> 2] = i3;
     HEAP32[i7 >> 2] = i2;
     i2 = (i3 | 0) == 0 ? i9 : i3;
    }
    _memcpy(i2 | 0, i8 | 0, i1 | 0) | 0;
    HEAP8[i2 + i1 >> 0] = 0;
   }
   HEAP32[i11 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  } else {
   i1 = i10 + 4 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i3 + 8 >> 2] = i5;
   __Z6FormatPKcz(i18, gb + 1047476 | 0, i3);
   i1 = HEAP8[i18 + 11 >> 0] | 0;
   i5 = i1 << 24 >> 24 < 0;
   i8 = i5 ? HEAP32[i18 >> 2] | 0 : i18;
   i1 = i5 ? HEAP32[i18 + 4 >> 2] | 0 : i1 & 255;
   i5 = HEAP32[i15 >> 2] | 0;
   i6 = (i5 | 0) == 0;
   i2 = i6 ? i9 : i5;
   if (i2 >>> 0 > i8 >>> 0) i13 = 11; else {
    i3 = HEAP32[i11 >> 2] | 0;
    if ((i2 + i3 | 0) >>> 0 > i8 >>> 0) {
     i1 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
     if ((i2 | 0) != (i8 | 0)) _memmove(i2 | 0, i8 | 0, i1 | 0) | 0;
    } else i13 = 11;
   }
   if ((i13 | 0) == 11) {
    i7 = i15 + 4 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    i4 = (i3 | 0) == 0;
    if (i4) if (i6) {
     i3 = 15;
     i13 = 14;
    } else i13 = 17; else {
     i3 = i6 ? 15 : i3;
     i13 = 14;
    }
    if ((i13 | 0) == 14) if (i3 >>> 0 < i1 >>> 0) if (i6 | i4) i13 = 17; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
     i13 = 17;
    }
    if ((i13 | 0) == 17) {
     if (i1 >>> 0 > 15) {
      i2 = i1;
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + 1 | 0, 16, i12, 0, gb + 1047486 | 0, 251) | 0;
     } else {
      i2 = 0;
      i3 = 0;
     }
     HEAP32[i15 >> 2] = i3;
     HEAP32[i7 >> 2] = i2;
     i2 = (i3 | 0) == 0 ? i9 : i3;
    }
    _memcpy(i2 | 0, i8 | 0, i1 | 0) | 0;
    HEAP8[i2 + i1 >> 0] = 0;
   }
   HEAP32[i11 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  }
  HEAP32[i18 >> 2] = i10;
  __ZN9JSONWrite8TransferIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_PKc17TransferMetaFlags(i17, i15, gb + 1047471 | 0, 0);
  __ZN9JSONWrite8TransferIN11UnityEngine15CloudWebService17CloudServiceEvent8MsgValueEEEvRT_PKc17TransferMetaFlags(i17, i18, gb + 1047580 | 0, 0);
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i15 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 i8 = i18 + 24 | 0;
 i3 = gb + 64016 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i18 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i17, i18, 0);
 i2 = HEAP32[i18 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? i1 : i2;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i13 = 47;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i16 + 11 >> 0] = i3;
  if (!i3) i1 = i16; else {
   i1 = i16;
   i13 = 49;
  }
 } else i13 = 47;
 if ((i13 | 0) == 47) {
  i12 = i3 + 16 & -16;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i16 + 4 >> 2] = i3;
  i13 = 49;
 }
 if ((i13 | 0) == 49) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i16 + 11 | 0;
 do if ((i16 | 0) != (i14 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i16 >> 2] | 0 : i16;
  i6 = i7 ? HEAP32[i16 + 4 >> 2] | 0 : i6 & 255;
  i7 = i14 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i14 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i13 = i2 ? HEAP32[i14 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i14, i3, i6 - i3 | 0, i13, 0, i13, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i14 >> 2] | 0 : i14;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i14 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i14 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  __ZN9JSONWriteD2Ev(i17);
  STACKTOP = i19;
  return;
 }
 if (!(HEAP32[i18 + 4 >> 2] | 0)) {
  __ZN9JSONWriteD2Ev(i17);
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 __ZN9JSONWriteD2Ev(i17);
 STACKTOP = i19;
 return;
}

function __ZN20TextRenderingPrivate7GUIText16RenderGUIElementERK5RectTIfER17ShaderPassContext(i9, i10, i18) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 192 | 0;
 i4 = i20 + 184 | 0;
 i13 = i20 + 160 | 0;
 i7 = i20;
 i8 = i20 + 180 | 0;
 i17 = i20 + 96 | 0;
 i14 = i20 + 32 | 0;
 i15 = i20 + 20 | 0;
 i11 = i20 + 8 | 0;
 i5 = i9 + 36 | 0;
 i6 = i5 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i9 + 40 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 if ((HEAP16[gb + 1467920 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = i9;
  HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467920 | 0, i19);
  i16 = gb + 1467920 | 0;
 } else i16 = 0;
 __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv(i4, i9);
 i2 = HEAP32[i4 >> 2] | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 | (i12 | 0) == 0)) {
  if ((HEAP8[i6 >> 0] | 0) < 0) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  i24 = gb + 63672 | 0;
  i25 = HEAP32[i24 + 4 >> 2] | 0;
  i5 = i7;
  HEAP32[i5 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i5 + 4 >> 2] = i25;
  HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN11UTF16StringC2EPKc10MemLabelId(i13, i1, i19);
  i5 = i2 + 48 | 0;
  i25 = HEAP32[i5 >> 2] | 0;
  i24 = HEAP16[i9 + 54 >> 1] | 0;
  i2 = i9 + 52 | 0;
  i23 = HEAP16[i2 >> 1] | 0;
  f22 = Math_fround(HEAPF32[i9 + 60 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 56 >> 2]);
  i21 = (HEAP8[i9 + 65 >> 0] | 0) != 0;
  i6 = i9 + 64 | 0;
  i4 = (HEAP8[i6 >> 0] | 0) != 0;
  HEAP32[i8 >> 2] = HEAP32[i9 + 84 >> 2];
  i1 = HEAP32[i9 + 76 >> 2] | 0;
  i7 = HEAP32[i9 + 80 >> 2] | 0;
  HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
  i7 = __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i13, i25, i24, i23, Math_fround(0.0), f22, f3, i21, i4, i19, Math_fround(1.0), i1, i7) | 0;
  __ZN11UTF16StringD2Ev(i13);
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i25 = HEAP32[i1 + 32 >> 2] | 0;
   if ((HEAP32[i25 + 112 >> 2] | 0) != (HEAP32[i25 + 116 >> 2] | 0)) {
    i4 = __Z12GetGfxDevicev() | 0;
    __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i19, __Z12GetGfxDevicev() | 0);
    f3 = Math_fround(HEAPF32[i7 + 16 >> 2]);
    f26 = Math_fround(-f3);
    f22 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
    HEAPF32[i17 >> 2] = Math_fround(0.0);
    HEAPF32[i17 + 8 >> 2] = f26;
    HEAPF32[i17 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i17 + 12 >> 2] = f22;
    __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i13, i7, i17);
    L19 : do switch (HEAP16[i2 >> 1] | 0) {
    case 2:
     {
      HEAPF32[i13 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i13 >> 2]));
      break;
     }
    case 1:
     {
      f3 = Math_fround(f3 * Math_fround(.5));
      if (!(HEAP8[i6 >> 0] | 0)) {
       HEAPF32[i13 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i13 >> 2]));
       break L19;
      } else {
       f26 = Math_fround(Math_floor(Math_fround(f3 + Math_fround(.5))));
       HEAPF32[i13 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i13 >> 2]));
       break L19;
      }
     }
    default:
     {}
    } while (0);
    if (!(HEAP8[i6 >> 0] | 0)) {
     __ZN10Matrix4x4f8SetOrthoEffffff(i14, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-1.0), Math_fround(100.0)) | 0;
     mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 116 >> 2] | 0, i4 | 0, i14 | 0);
     i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
     __ZNK9Transform11GetPositionEv(i15, i1);
     HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
     __ZNK9Transform18GetWorldScaleLossyEv(i11, i1);
     f26 = Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + 36 >> 2]);
     f22 = Math_fround(f26 * Math_fround(.0500000007));
     f22 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f22);
     HEAPF32[i11 >> 2] = f22;
     f26 = Math_fround(f26 * Math_fround(-.0500000007));
     i1 = i11 + 4 | 0;
     f26 = Math_fround(f26 * Math_fround(HEAPF32[i1 >> 2]));
     HEAPF32[i1 >> 2] = f26;
     HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
     f22 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f22);
     HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f22);
     f26 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) * f26);
     i1 = i15 + 4 | 0;
     HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f26);
     __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i17, i15) | 0;
     __ZN10Matrix4x4f5ScaleERK8Vector3f(i17, i11) | 0;
     i1 = i4;
    } else {
     HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     f26 = Math_fround(HEAPF32[i14 >> 2]);
     i1 = i14 + 4 | 0;
     f22 = Math_fround(HEAPF32[i1 >> 2]);
     HEAPF32[i14 >> 2] = Math_fround(f26 - f26);
     HEAPF32[i1 >> 2] = Math_fround(f22 - f22);
     __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb(i14, i4, 1);
     __ZNK9Transform11GetPositionEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
     f22 = Math_fround(HEAPF32[i15 >> 2]);
     f22 = Math_fround(f22 * Math_fround(HEAPF32[i10 + 8 >> 2]));
     f22 = Math_fround(Math_floor(Math_fround(Math_fround(f22 + Math_fround(HEAPF32[i9 + 68 >> 2])) + Math_fround(.5))));
     f26 = Math_fround(HEAPF32[i15 + 4 >> 2]);
     f26 = Math_fround(f26 * Math_fround(HEAPF32[i10 + 12 >> 2]));
     f26 = Math_fround(Math_floor(Math_fround(Math_fround(f26 + Math_fround(HEAPF32[i9 + 72 >> 2])) + Math_fround(.5))));
     HEAPF32[i11 >> 2] = f22;
     HEAPF32[i11 + 4 >> 2] = f26;
     HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
     __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i17, i11) | 0;
     HEAPF32[i11 >> 2] = Math_fround(1.0);
     HEAPF32[i11 + 4 >> 2] = Math_fround(-1.0);
     HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
     __ZN10Matrix4x4f5ScaleERK8Vector3f(i17, i11) | 0;
     f26 = Math_fround(-Math_fround(HEAPF32[i13 + 4 >> 2]));
     HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
     HEAPF32[i11 + 4 >> 2] = f26;
     HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
     __ZN10Matrix4x4f9TranslateERK8Vector3f(i17, i11) | 0;
     i1 = i4;
    }
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, i17 | 0);
    i2 = __ZNK8Material12GetPassCountEv(i12) | 0;
    if ((i2 | 0) > 0) {
     i1 = 0;
     do {
      i24 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i12, i1, i18, 0, 1) | 0;
      i25 = HEAP32[i7 >> 2] | 0;
      __ZN8DrawUtil15DrawTextMeshRawERK14ChannelAssignsR4MeshR23DefaultMeshVertexFormat(i24, i25, __ZN13TextRendering17TextMeshGenerator15GetVertexFormatEv() | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
    __ZN22DeviceMVPMatricesStateD2Ev(i19);
   }
  }
 }
 if (!i16) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i20;
 return;
}

function __ZN15Cast2DQueryBase8RunQueryEb(i34, i30) {
 i34 = i34 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i38;
 i31 = i38 + 92 | 0;
 if (!(HEAP8[i34 + 369 >> 0] | 0)) __ZN15Cast2DQueryBase15InitializeQueryEv(i34);
 i36 = i34 + 336 | 0;
 i1 = HEAP32[i36 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i32 = i34 + 340 | 0;
 i1 = i34 + 356 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i32 >> 2] | 0, i34 + 344 | 0);
  HEAP32[i32 >> 2] = 0;
 }
 HEAP32[i32 >> 2] = 0;
 i33 = i34 + 352 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK7b2World14QueryProxyAABBEP20b2QueryProxyCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i34, i34 + 120 | 0);
 if (!(HEAP32[i33 >> 2] | 0)) {
  i37 = 0;
  STACKTOP = i38;
  return i37 | 0;
 }
 i11 = i34 + 136 | 0;
 i9 = i34 + 228 | 0;
 i10 = i34 + 232 | 0;
 i12 = i34 + 244 | 0;
 i8 = i34 + 248 | 0;
 i13 = i34 + 236 | 0;
 i7 = i34 + 240 | 0;
 i14 = i34 + 256 | 0;
 i15 = i34 + 252 | 0;
 i16 = i34 + 260 | 0;
 i17 = i34 + 264 | 0;
 i18 = i34 + 164 | 0;
 i19 = i35 + 4 | 0;
 i20 = i34 + 36 | 0;
 i21 = i34 + 104 | 0;
 i22 = i34 + 200 | 0;
 i23 = i34 + 204 | 0;
 i24 = i34 + 208 | 0;
 i25 = i34 + 212 | 0;
 i26 = i34 + 216 | 0;
 i27 = i34 + 220 | 0;
 i28 = i34 + 192 | 0;
 i29 = i34 + 196 | 0;
 i4 = HEAP32[i32 >> 2] | 0;
 do {
  i1 = HEAP32[i4 + 16 >> 2] | 0;
  i6 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = i4 + 52 | 0;
  i43 = i6 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i43 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i43 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i43 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i43 + 12 >> 2];
  i43 = HEAP32[i6 + 28 >> 2] | 0;
  i2 = HEAP32[i6 + 32 >> 2] | 0;
  HEAP32[i9 >> 2] = i43;
  HEAP32[i10 >> 2] = i2;
  f41 = Math_fround(HEAPF32[i4 + 64 >> 2]);
  f40 = (HEAP32[tempDoublePtr >> 2] = i43, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f40 * f41);
  f5 = Math_fround(HEAPF32[i4 + 60 >> 2]);
  f42 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = Math_fround(f39 - Math_fround(f42 * f5));
  f39 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f39);
  f5 = Math_fround(Math_fround(f42 * f41) + Math_fround(f40 * f5));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + 56 >> 2]));
  HEAPF32[i12 >> 2] = f39;
  HEAPF32[i8 >> 2] = f5;
  HEAPF32[i13 >> 2] = f39;
  HEAPF32[i7 >> 2] = f5;
  i6 = HEAP32[i6 + 56 >> 2] | 0;
  HEAP32[i14 >> 2] = i6;
  HEAP32[i15 >> 2] = i6;
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  HEAPF32[i17 >> 2] = Math_fround(1.0);
  if (i30) i6 = 1; else i6 = (HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 93 >> 0] | 0) != 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  __ZN15b2DistanceProxy3SetEPK7b2Shapei(i18, i1, i2);
  __Z14b2TimeOfImpactP11b2TOIOutputPK10b2TOIInput(i35, i11);
  switch (HEAP32[i35 >> 2] | 0) {
  case 3:
   {
    f5 = Math_fround(HEAPF32[i19 >> 2]);
    if (i6 | !(f5 <= Math_fround(1.1920929e-06))) i37 = 18; else if (__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(HEAP32[i20 >> 2] | 0, 0, i1, i2, i21, i3) | 0) {
     i1 = i4 + 92 | 0;
     _memmove(i4 | 0, i1 | 0, (HEAP32[i32 >> 2] | 0) + ((HEAP32[i33 >> 2] | 0) * 92 | 0) - i1 | 0) | 0;
     i1 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
     HEAP32[i33 >> 2] = i1;
    } else i37 = 18;
    break;
   }
  case 2:
   {
    if (i6) {
     f5 = Math_fround(HEAPF32[i19 >> 2]);
     i37 = 18;
    } else i37 = 19;
    break;
   }
  default:
   i37 = 19;
  }
  if ((i37 | 0) == 18) {
   i37 = 0;
   f42 = Math_fround(Math_fround(1.0) - f5);
   f39 = Math_fround(f42 * Math_fround(HEAPF32[i22 >> 2]));
   f40 = Math_fround(f42 * Math_fround(HEAPF32[i23 >> 2]));
   f45 = Math_fround(f5 * Math_fround(HEAPF32[i24 >> 2]));
   f45 = Math_fround(f39 + f45);
   f40 = Math_fround(f40 + Math_fround(f5 * Math_fround(HEAPF32[i25 >> 2])));
   i43 = i4 + 36 | 0;
   HEAPF32[i43 >> 2] = f45;
   i1 = i4 + 40 | 0;
   HEAPF32[i1 >> 2] = f40;
   f42 = Math_fround(f42 * Math_fround(HEAPF32[i26 >> 2]));
   f42 = Math_fround(f42 + Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2])));
   f39 = Math_fround(+Math_sin(+f42));
   HEAPF32[i4 + 44 >> 2] = f39;
   f42 = Math_fround(+Math_cos(+f42));
   HEAPF32[i4 + 48 >> 2] = f42;
   f46 = Math_fround(HEAPF32[i28 >> 2]);
   f44 = Math_fround(f42 * f46);
   f41 = Math_fround(HEAPF32[i29 >> 2]);
   f42 = Math_fround(Math_fround(f39 * f46) + Math_fround(f42 * f41));
   f41 = Math_fround(f45 - Math_fround(f44 - Math_fround(f39 * f41)));
   HEAPF32[i43 >> 2] = f41;
   f42 = Math_fround(f40 - f42);
   HEAPF32[i1 >> 2] = f42;
   f41 = Math_fround(f41 - Math_fround(HEAPF32[i22 >> 2]));
   f42 = Math_fround(f42 - Math_fround(HEAPF32[i23 >> 2]));
   HEAPF32[i4 + 32 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f41 * f41) + Math_fround(f42 * f42))));
   HEAPF32[i4 + 28 >> 2] = f5;
   HEAPF32[i17 >> 2] = f5;
   i4 = i4 + 92 | 0;
   i1 = HEAP32[i33 >> 2] | 0;
  } else if ((i37 | 0) == 19) {
   i37 = 0;
   i1 = i4 + 92 | 0;
   _memmove(i4 | 0, i1 | 0, (HEAP32[i32 >> 2] | 0) + ((HEAP32[i33 >> 2] | 0) * 92 | 0) - i1 | 0) | 0;
   i1 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
   HEAP32[i33 >> 2] = i1;
  }
  i6 = HEAP32[i32 >> 2] | 0;
 } while ((i4 | 0) != (i6 + (i1 * 92 | 0) | 0));
 if (!i1) {
  i43 = 0;
  STACKTOP = i38;
  return i43 | 0;
 }
 i2 = i31;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = i35;
 i1 = i31;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_(i6, i4, i35);
 if (HEAP32[i33 >> 2] | 0) {
  i3 = HEAP32[i32 >> 2] | 0;
  do {
   i4 = HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + 60 >> 2] | 0;
   i2 = HEAP32[i36 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 12 >> 2] | 0;
   L36 : do if (!i2) i37 = 30; else {
    i2 = i1 + (i2 * 36 | 0) | 0;
    while (1) {
     if ((HEAP32[i1 + 32 >> 2] | 0) == (i4 | 0)) break;
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i37 = 30;
      break L36;
     }
    }
    f46 = Math_fround(HEAPF32[i3 + 28 >> 2]);
    if (f46 < Math_fround(HEAPF32[i1 + 28 >> 2])) __ZN15Cast2DQueryBase19ConvertToRaycastHitERNS_14FixtureContactEP12RaycastHit2D(i34, i3, i1) | 0;
   } while (0);
   if ((i37 | 0) == 30) {
    i37 = 0;
    if (__ZN15Cast2DQueryBase19ConvertToRaycastHitERNS_14FixtureContactEP12RaycastHit2D(i34, i3, i35) | 0) __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(HEAP32[i36 >> 2] | 0, i35);
   }
   i3 = i3 + 92 | 0;
  } while ((i3 | 0) != ((HEAP32[i32 >> 2] | 0) + ((HEAP32[i33 >> 2] | 0) * 92 | 0) | 0));
 }
 i43 = HEAP32[(HEAP32[i36 >> 2] | 0) + 12 >> 2] | 0;
 STACKTOP = i38;
 return i43 | 0;
}

function __ZN20SphericalHarmonicsL28TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378523 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378530 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378537 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378544 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378551 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378558 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378565 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378572 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378579 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378586 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378593 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378600 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378607 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378614 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378621 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378628 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378635 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378642 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378649 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378656 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378663 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378670 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378677 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378684 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378691 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378698 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378705 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5Umbra11ShadowUtils17getLightSpaceAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector4ERKS1_(i55, i26, i27, i1) {
 i55 = i55 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i56 + 156 | 0;
 i49 = i56 + 152 | 0;
 i53 = i56 + 148 | 0;
 i46 = i56 + 144 | 0;
 i48 = i56 + 140 | 0;
 i52 = i56 + 136 | 0;
 i21 = i56 + 132 | 0;
 i25 = i56 + 128 | 0;
 i23 = i56 + 124 | 0;
 i2 = i56 + 120 | 0;
 i24 = i56 + 116 | 0;
 i22 = i56 + 112 | 0;
 i45 = i56 + 16 | 0;
 i54 = i56 + 8 | 0;
 i51 = i56 + 4 | 0;
 i50 = i56;
 HEAP32[i47 >> 2] = 2139095039;
 HEAP32[i49 >> 2] = 2139095039;
 HEAP32[i53 >> 2] = 2139095039;
 HEAP32[i46 >> 2] = -8388609;
 HEAP32[i48 >> 2] = -8388609;
 HEAP32[i52 >> 2] = -8388609;
 HEAP32[i21 >> 2] = 2139095039;
 HEAP32[i25 >> 2] = 2139095039;
 HEAP32[i23 >> 2] = 2139095039;
 HEAP32[i2 >> 2] = -8388609;
 HEAP32[i24 >> 2] = -8388609;
 HEAP32[i22 >> 2] = -8388609;
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 i28 = i26 + 4 | 0;
 f9 = Math_fround(HEAPF32[i28 >> 2]);
 i29 = i26 + 8 | 0;
 f10 = Math_fround(HEAPF32[i29 >> 2]);
 i30 = i26 + 12 | 0;
 f11 = Math_fround(HEAPF32[i30 >> 2]);
 i31 = i26 + 16 | 0;
 f12 = Math_fround(HEAPF32[i31 >> 2]);
 i32 = i26 + 20 | 0;
 f13 = Math_fround(HEAPF32[i32 >> 2]);
 i33 = i26 + 24 | 0;
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 i34 = i26 + 28 | 0;
 f15 = Math_fround(HEAPF32[i34 >> 2]);
 i35 = i26 + 32 | 0;
 f16 = Math_fround(HEAPF32[i35 >> 2]);
 i36 = i26 + 36 | 0;
 f17 = Math_fround(HEAPF32[i36 >> 2]);
 i37 = i26 + 40 | 0;
 f18 = Math_fround(HEAPF32[i37 >> 2]);
 i38 = i26 + 44 | 0;
 f19 = Math_fround(HEAPF32[i38 >> 2]);
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i1 = 0;
 f39 = Math_fround(-3402823469999999843913219.0e14);
 f40 = Math_fround(3402823469999999843913219.0e14);
 f41 = Math_fround(-3402823469999999843913219.0e14);
 f42 = Math_fround(3402823469999999843913219.0e14);
 f43 = Math_fround(-3402823469999999843913219.0e14);
 f44 = Math_fround(3402823469999999843913219.0e14);
 do {
  f67 = (i1 & 1 | 0) == 0 ? f4 : f5;
  f66 = (i1 & 2 | 0) == 0 ? f6 : f7;
  f63 = (i1 & 4 | 0) == 0 ? f8 : f3;
  f65 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f67 * f20) + Math_fround(f66 * f9)) + Math_fround(f63 * f10)));
  f64 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f67 * f12) + Math_fround(f66 * f13)) + Math_fround(f63 * f14)));
  f63 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f67 * f16) + Math_fround(f66 * f17)) + Math_fround(f63 * f18)));
  HEAPF32[i45 >> 2] = f65;
  HEAPF32[i54 >> 2] = f64;
  HEAPF32[i51 >> 2] = f63;
  i62 = HEAP32[(f40 <= f65 ? i21 : i45) >> 2] | 0;
  i61 = HEAP32[(f44 <= f64 ? i25 : i54) >> 2] | 0;
  i60 = HEAP32[(f42 <= f63 ? i23 : i51) >> 2] | 0;
  HEAP32[i21 >> 2] = i62;
  HEAP32[i25 >> 2] = i61;
  HEAP32[i23 >> 2] = i60;
  i59 = HEAP32[(f39 >= f65 ? i2 : i45) >> 2] | 0;
  i58 = HEAP32[(f43 >= f64 ? i24 : i54) >> 2] | 0;
  i57 = HEAP32[(f41 >= f63 ? i22 : i51) >> 2] | 0;
  HEAP32[i2 >> 2] = i59;
  HEAP32[i24 >> 2] = i58;
  HEAP32[i22 >> 2] = i57;
  i1 = i1 + 1 | 0;
  f40 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f42 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f39 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f43 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i1 | 0) != 8);
 i1 = i45;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5Umbra11ShadowUtils18getFrustumVerticesEPNS_7Vector3EPKNS_7Vector4E(i45, i27);
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f19 = Math_fround(HEAPF32[i28 >> 2]);
 f18 = Math_fround(HEAPF32[i29 >> 2]);
 f17 = Math_fround(HEAPF32[i30 >> 2]);
 f16 = Math_fround(HEAPF32[i31 >> 2]);
 f15 = Math_fround(HEAPF32[i32 >> 2]);
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 f13 = Math_fround(HEAPF32[i34 >> 2]);
 f12 = Math_fround(HEAPF32[i35 >> 2]);
 f11 = Math_fround(HEAPF32[i36 >> 2]);
 f10 = Math_fround(HEAPF32[i37 >> 2]);
 f9 = Math_fround(HEAPF32[i38 >> 2]);
 i1 = 0;
 f3 = Math_fround(-3402823469999999843913219.0e14);
 f4 = Math_fround(3402823469999999843913219.0e14);
 f5 = Math_fround(-3402823469999999843913219.0e14);
 f6 = Math_fround(3402823469999999843913219.0e14);
 f7 = Math_fround(-3402823469999999843913219.0e14);
 f8 = Math_fround(3402823469999999843913219.0e14);
 do {
  f63 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) >> 2]);
  f64 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) + 4 >> 2]);
  f67 = Math_fround(HEAPF32[i45 + (i1 * 12 | 0) + 8 >> 2]);
  f65 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f63 * f20) + Math_fround(f64 * f19)) + Math_fround(f67 * f18)));
  f66 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f63 * f16) + Math_fround(f64 * f15)) + Math_fround(f67 * f14)));
  f67 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f63 * f12) + Math_fround(f64 * f11)) + Math_fround(f67 * f10)));
  HEAPF32[i54 >> 2] = f65;
  HEAPF32[i51 >> 2] = f66;
  HEAPF32[i50 >> 2] = f67;
  i57 = HEAP32[(f4 <= f65 ? i47 : i54) >> 2] | 0;
  i58 = HEAP32[(f6 <= f66 ? i49 : i51) >> 2] | 0;
  i59 = HEAP32[(f8 <= f67 ? i53 : i50) >> 2] | 0;
  HEAP32[i47 >> 2] = i57;
  HEAP32[i49 >> 2] = i58;
  HEAP32[i53 >> 2] = i59;
  i60 = HEAP32[(f3 >= f65 ? i46 : i54) >> 2] | 0;
  i61 = HEAP32[(f5 >= f66 ? i48 : i51) >> 2] | 0;
  i62 = HEAP32[(f7 >= f67 ? i52 : i50) >> 2] | 0;
  HEAP32[i46 >> 2] = i60;
  HEAP32[i48 >> 2] = i61;
  HEAP32[i52 >> 2] = i62;
  i1 = i1 + 1 | 0;
  f4 = (HEAP32[tempDoublePtr >> 2] = i57, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i58, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i59, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i60, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i61, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i62, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i1 | 0) != 8);
 HEAPF32[i55 >> 2] = f4 >= f40 ? f4 : f40;
 HEAPF32[i55 + 4 >> 2] = f6 >= f44 ? f6 : f44;
 HEAPF32[i55 + 8 >> 2] = f8 >= f42 ? f8 : f42;
 HEAPF32[i55 + 12 >> 2] = f3 <= f39 ? f3 : f39;
 HEAPF32[i55 + 16 >> 2] = f5 <= f43 ? f5 : f43;
 HEAPF32[i55 + 20 >> 2] = f7 <= f41 ? f7 : f41;
 STACKTOP = i56;
 return;
}

function __ZN16GraphicsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = i3 + 20 | 0;
 i6 = i3 + 16 | 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 9);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 373773 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 373784 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 373806 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 373827 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 68 | 0, gb + 373844 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 405015 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 76 | 0, gb + 373859 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i2, i1 + 84 | 0, gb + 373871 | 0, 0);
 i11 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373883 | 0, i11, i1 + 92 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 479385 | 0, i6, 0);
 i12 = i8 + 8 | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i6, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i12, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373907 | 0, i11, i1 + 108 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 374071 | 0, i6, 0);
 i7 = i8 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 124 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373926 | 0, gb + 946436 | 0, i7, 0);
 i6 = i8 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373951 | 0, gb + 373972 | 0, i6, 0);
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374035 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374049 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 136 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373993 | 0, gb + 373972 | 0, i7, 0);
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374035 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374049 | 0, i6, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 144 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374014 | 0, gb + 373972 | 0, i7, 0);
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374035 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374049 | 0, i6, i1 + 148 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx17ConvexHullBuilder27CreateTrianglesFromPolygonsEv(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i30;
 i24 = i30 + 18 | 0;
 i25 = i30 + 17 | 0;
 i26 = i30 + 16 | 0;
 i28 = i30 + 4 | 0;
 i12 = i27 + 20 | 0;
 i13 = HEAP8[(HEAP32[i12 >> 2] | 0) + 39 >> 0] | 0;
 if (!(i13 << 24 >> 24)) {
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i17 = i27 + 4 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 if (!i4) {
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i3 = i13 & 255;
 i1 = 0;
 i5 = 0;
 while (1) {
  i2 = HEAP8[i4 + (i5 * 20 | 0) + 18 >> 0] | 0;
  if ((i2 & 255) < 3) {
   i7 = 5;
   break;
  }
  i1 = i1 + -2 + (i2 & 255) | 0;
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i3 >>> 0) {
   i22 = i1;
   break;
  }
 }
 if ((i7 | 0) == 5) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726825 | 0, 1116, gb + 727097 | 0, i6);
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i1 = i22 >>> 0 > 357913941 ? -1 : i22 * 12 | 0;
 if (!i1) {
  i23 = 0;
  i1 = i13;
 } else {
  i29 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i21 = HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0;
  i23 = _PxGetFoundation() | 0;
  i23 = mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 24 >> 2] | 0, i23 | 0) | 0;
  i23 = mftCall_iiiiii(i21 | 0, i29 | 0, i1 | 0, (i23 ? gb + 726918 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1122) | 0;
  i1 = HEAP8[(HEAP32[i12 >> 2] | 0) + 39 >> 0] | 0;
 }
 i21 = HEAP32[i27 + 8 >> 2] | 0;
 i29 = HEAP32[i27 >> 2] | 0;
 if (!(i1 << 24 >> 24)) i2 = 0; else {
  i17 = HEAP32[i17 >> 2] | 0;
  i12 = i1 & 255;
  i1 = i23;
  i2 = 0;
  i13 = 0;
  do {
   i4 = HEAPU16[i17 + (i13 * 20 | 0) + 16 >> 1] | 0;
   i5 = i21 + i4 | 0;
   i6 = HEAPU8[i17 + (i13 * 20 | 0) + 18 >> 0] | 0;
   i7 = i6 + -2 | 0;
   if (i7) {
    i3 = 0;
    do {
     i32 = HEAPU8[i5 >> 0] | 0;
     HEAP32[i1 >> 2] = i32;
     i31 = i3;
     i3 = i3 + 1 | 0;
     i33 = HEAPU8[i21 + (((i3 >>> 0) % (i6 >>> 0) | 0) + i4) >> 0] | 0;
     HEAP32[i1 + 4 >> 2] = i33;
     i31 = HEAPU8[i21 + ((((i31 + 2 | 0) >>> 0) % (i6 >>> 0) | 0) + i4) >> 0] | 0;
     HEAP32[i1 + 8 >> 2] = i31;
     f14 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) >> 2]);
     f18 = Math_fround(HEAPF32[i29 + (i32 * 12 | 0) >> 2]);
     f14 = Math_fround(f14 - f18);
     f16 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) + 4 >> 2]);
     f15 = Math_fround(HEAPF32[i29 + (i32 * 12 | 0) + 4 >> 2]);
     f16 = Math_fround(f16 - f15);
     f11 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) + 8 >> 2]);
     f20 = Math_fround(HEAPF32[i29 + (i32 * 12 | 0) + 8 >> 2]);
     f11 = Math_fround(f11 - f20);
     f18 = Math_fround(Math_fround(HEAPF32[i29 + (i31 * 12 | 0) >> 2]) - f18);
     f15 = Math_fround(Math_fround(HEAPF32[i29 + (i31 * 12 | 0) + 4 >> 2]) - f15);
     f20 = Math_fround(Math_fround(HEAPF32[i29 + (i31 * 12 | 0) + 8 >> 2]) - f20);
     f19 = Math_fround(Math_fround(f16 * f20) - Math_fround(f11 * f15));
     f20 = Math_fround(Math_fround(f11 * f18) - Math_fround(f14 * f20));
     f18 = Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f18));
     i31 = Math_fround(Math_fround(f18 * f18) + Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20))) != Math_fround(0.0);
     i2 = (i31 & 1) + i2 | 0;
     i1 = i31 ? i1 + 12 | 0 : i1;
    } while ((i3 | 0) != (i7 | 0));
   }
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < i12 >>> 0);
 }
 i3 = i27 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 do if ((i22 | 0) == (i2 | 0)) i1 = i23; else {
  i1 = i2 >>> 0 > 357913941 ? -1 : i2 * 12 | 0;
  if (i1 | 0) {
   i32 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i31 = HEAP32[(HEAP32[i32 >> 2] | 0) + 8 >> 2] | 0;
   i33 = _PxGetFoundation() | 0;
   i33 = mftCall_ii(HEAP32[(HEAP32[i33 >> 2] | 0) + 24 >> 2] | 0, i33 | 0) | 0;
   i1 = mftCall_iiiiii(i31 | 0, i32 | 0, i1 | 0, (i33 ? gb + 726918 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1183) | 0;
   if (i1 | 0) {
    _memcpy(i1 | 0, i23 | 0, i2 * 12 | 0) | 0;
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i23);
    break;
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i23);
  i33 = 0;
  STACKTOP = i30;
  return i33 | 0;
 } while (0);
 HEAP32[i3 >> 2] = i1;
 i21 = i27 + 32 | 0;
 HEAP32[i21 >> 2] = i2;
 __ZNK5physx17ConvexHullBuilder17ComputeGeomCenterERNS_6PxVec3E(i27, i28) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  i33 = 1;
  STACKTOP = i30;
  return i33 | 0;
 }
 i17 = HEAP32[i3 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i28 >> 2]);
 f20 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i13 = 0;
 do {
  i33 = HEAP32[i17 + (i13 * 12 | 0) >> 2] | 0;
  i5 = i17 + (i13 * 12 | 0) + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i17 + (i13 * 12 | 0) + 8 | 0;
  i12 = HEAP32[i7 >> 2] | 0;
  f35 = Math_fround(HEAPF32[i29 + (i6 * 12 | 0) >> 2]);
  f14 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) >> 2]);
  f35 = Math_fround(f35 - f14);
  f11 = Math_fround(HEAPF32[i29 + (i6 * 12 | 0) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) + 4 >> 2]);
  f11 = Math_fround(f11 - f15);
  f36 = Math_fround(HEAPF32[i29 + (i6 * 12 | 0) + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i29 + (i33 * 12 | 0) + 8 >> 2]);
  f36 = Math_fround(f36 - f16);
  f10 = Math_fround(Math_fround(HEAPF32[i29 + (i12 * 12 | 0) >> 2]) - f14);
  f34 = Math_fround(Math_fround(HEAPF32[i29 + (i12 * 12 | 0) + 4 >> 2]) - f15);
  f9 = Math_fround(Math_fround(HEAPF32[i29 + (i12 * 12 | 0) + 8 >> 2]) - f16);
  f8 = Math_fround(Math_fround(f11 * f9) - Math_fround(f36 * f34));
  f9 = Math_fround(Math_fround(f36 * f10) - Math_fround(f35 * f9));
  f10 = Math_fround(Math_fround(f35 * f34) - Math_fround(f11 * f10));
  f11 = Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)));
  if (f11 > Math_fround(0.0)) {
   f36 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f11))));
   f34 = Math_fround(f8 * f36);
   f35 = Math_fround(f9 * f36);
   f36 = Math_fround(f10 * f36);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f36, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i2 = 0;
   i3 = 0;
   i4 = 0;
  }
  f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = Math_fround(f11 * f14);
  f34 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = Math_fround(f35 + Math_fround(f34 * f15));
  f36 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(Math_fround(Math_fround(Math_fround(f11 * f19) + Math_fround(f34 * f20)) + Math_fround(f36 * f18)) - Math_fround(f35 + Math_fround(f36 * f16))) > Math_fround(0.0)) {
   HEAP32[i7 >> 2] = i6;
   HEAP32[i5 >> 2] = i12;
   i1 = HEAP32[i21 >> 2] | 0;
  }
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < i1 >>> 0);
 i1 = 1;
 STACKTOP = i30;
 return i1 | 0;
}

function __ZN7VRInput27ClearAllReferenceTransformsEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 32 | 0;
 i13 = i20 + 16 | 0;
 i19 = i20;
 i6 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i6, HEAP32[i14 >> 2] | 0);
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i14 >> 2] = 0;
 i14 = i17 + 20 | 0;
 i6 = i17 + 24 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i14, HEAP32[i6 >> 2] | 0);
 i15 = i17 + 32 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 i6 = i19 + 12 | 0;
 i5 = i19 + 12 | 0;
 i7 = i18 + 4 | 0;
 i8 = i19 + 8 | 0;
 i9 = i19 + 4 | 0;
 i16 = i17 + 24 | 0;
 i10 = i19 + 11 | 0;
 i11 = i18 + 4 | 0;
 i4 = 0;
 do {
  i2 = HEAP32[gb + 189700 + (i4 << 2) >> 2] | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i19);
   i1 = HEAP32[i5 >> 2] | 0;
   i12 = 18;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i10 >> 0] = i3;
   if (!i3) i1 = i19; else {
    i1 = i19;
    i12 = 20;
   }
  } else i12 = 18;
  if ((i12 | 0) == 18) {
   i21 = i3 + 16 & -16;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i21, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i8 >> 2] = i21 | -2147483648;
   HEAP32[i9 >> 2] = i3;
   i12 = 20;
  }
  if ((i12 | 0) == 20) {
   i12 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i14, i18, i19) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i13, i14, i19);
   i1 = HEAP32[i13 >> 2] | 0;
   HEAP32[i13 >> 2] = 0;
   i2 = HEAP32[i18 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i14 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i2);
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  }
  i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i21 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 36 >> 2] = i3;
  HEAP32[i1 + 40 >> 2] = i21;
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i21 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i11 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i21, i18);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 3);
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 + 12 >> 2] = i1;
 HEAP32[i18 >> 2] = 66;
 HEAP32[i18 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i19 + 8 >> 2] = -2147483632;
 HEAP32[i19 + 4 >> 2] = 12;
 i2 = i1;
 i3 = gb + 1044481 | 0;
 i4 = i2 + 12 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 12 >> 0] = 0;
 i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i14, i18, i19) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i13, i14, i19);
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i2 = HEAP32[i18 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i2);
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 HEAP32[i17 + 36 >> 2] = i1 + 32;
 if ((HEAP8[i19 + 11 >> 0] | 0) < 0) {
  i21 = HEAP32[i19 >> 2] | 0;
  i12 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i18);
 }
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 + 12 >> 2] = i1;
 HEAP32[i18 >> 2] = 66;
 HEAP32[i18 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i19 + 8 >> 2] = -2147483632;
 HEAP32[i19 + 4 >> 2] = 13;
 i2 = i1;
 i3 = gb + 1044494 | 0;
 i4 = i2 + 13 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 13 >> 0] = 0;
 i3 = __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i14, i18, i19) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i13, i14, i19);
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i2 = HEAP32[i18 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i2);
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 HEAP32[i17 + 40 >> 2] = i1 + 32;
 if ((HEAP8[i19 + 11 >> 0] | 0) < 0) {
  i21 = HEAP32[i19 >> 2] | 0;
  i19 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i18);
 }
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i1 + 248 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 mftCall_v(i1 | 0);
 STACKTOP = i20;
 return;
}

function __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i18, i2, i3) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i29 + 208 | 0;
 i26 = i29 + 144 | 0;
 i20 = i29 + 80 | 0;
 i19 = i29 + 64 | 0;
 i27 = i29;
 __ZN12GUIClipState20CalculateMouseValuesER10InputEvent(i18, i2);
 i28 = i18 + 156 | 0;
 i16 = i3 + 32 | 0;
 f12 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
 i17 = i3 + 36 | 0;
 f13 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
 i24 = i3 + 8 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 i25 = i3 + 12 | 0;
 i15 = HEAP32[i25 >> 2] | 0;
 HEAPF32[i18 + 156 >> 2] = f12;
 i21 = i18 + 160 | 0;
 HEAPF32[i21 >> 2] = f13;
 i22 = i18 + 164 | 0;
 HEAP32[i22 >> 2] = i23;
 i23 = i18 + 168 | 0;
 HEAP32[i23 >> 2] = i15;
 if ((HEAP32[i2 >> 2] | 0) != 7) {
  STACKTOP = i29;
  return;
 }
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i24 >> 2]);
 f5 = Math_fround(HEAPF32[i25 >> 2]);
 i2 = f4 < Math_fround(0.0);
 f4 = i2 ? Math_fround(0.0) : f4;
 i2 = f5 < Math_fround(0.0);
 f5 = i2 ? Math_fround(0.0) : f5;
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i3 + 48 >> 2]));
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 + 52 >> 2]));
 __ZN10Matrix4x4f11SetIdentityEv(i20) | 0;
 i2 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i2) {
  i2 = __Z16GetScreenManagerv() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0;
  i3 = __Z16GetScreenManagerv() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
 } else {
  i3 = HEAP32[i2 + 84 >> 2] | 0;
  i2 = HEAP32[i2 + 80 >> 2] | 0;
 }
 f11 = Math_fround(i3 | 0);
 f8 = Math_fround(i2 | 0);
 f7 = Math_fround(f4 / f8);
 f6 = Math_fround(f5 / f11);
 HEAPF32[i19 >> 2] = f7;
 i14 = i19 + 4 | 0;
 HEAPF32[i14 >> 2] = f6;
 HEAPF32[i19 + 8 >> 2] = Math_fround(1.0);
 i15 = i18 + 12 | 0;
 i2 = i18 + 24 | 0;
 f4 = Math_fround(f13 * Math_fround(HEAPF32[i2 >> 2]));
 i3 = i18 + 40 | 0;
 f4 = Math_fround(f4 + Math_fround(f12 * Math_fround(HEAPF32[i3 >> 2])));
 i9 = i18 + 56 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(0.0)));
 i10 = i18 + 72 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f4);
 i30 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 if ((i30 ? f5 : f4) > Math_fround(1.00000001e-07)) {
  f31 = Math_fround(f13 * Math_fround(HEAPF32[i18 + 16 >> 2]));
  f31 = Math_fround(f31 + Math_fround(f12 * Math_fround(HEAPF32[i18 + 32 >> 2])));
  f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i18 + 48 >> 2]) * Math_fround(0.0)));
  f31 = Math_fround(Math_fround(HEAPF32[i18 + 64 >> 2]) + f31);
  f5 = Math_fround(f13 * Math_fround(HEAPF32[i15 >> 2]));
  f5 = Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[i18 + 28 >> 2])));
  f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i18 + 44 >> 2]) * Math_fround(0.0)));
  f13 = Math_fround(Math_fround(1.0) / f4);
  f4 = Math_fround(f13 * f31);
  f5 = Math_fround(f13 * Math_fround(Math_fround(HEAPF32[i18 + 60 >> 2]) + f5));
 } else {
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 }
 f6 = Math_fround(f4 * f6);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f7);
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i26 + 12 >> 2] = Math_fround(1.0);
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i20, i1, i26, i19);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = f11;
 __Z13SetGLViewportRK5RectTIfE(i1);
 f6 = Math_fround(-Math_fround(HEAPF32[i16 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
 f4 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f6);
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f5));
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(0.0)));
 f4 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f4);
 i30 = f4 < Math_fround(0.0);
 f31 = Math_fround(-f4);
 if ((i30 ? f31 : f4) > Math_fround(1.00000001e-07)) {
  f13 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) * f6);
  f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i18 + 32 >> 2]) * f5));
  f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i18 + 48 >> 2]) * Math_fround(0.0)));
  f13 = Math_fround(Math_fround(HEAPF32[i18 + 64 >> 2]) + f13);
  f31 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f6);
  f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i18 + 28 >> 2]) * f5));
  f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i18 + 44 >> 2]) * Math_fround(0.0)));
  f4 = Math_fround(Math_fround(1.0) / f4);
  f5 = Math_fround(f4 * f13);
  f4 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i18 + 60 >> 2]) + f31));
 } else {
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 f4 = Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2]));
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i20, i15, i27);
 i2 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i2 | 0) > -1) i2 = HEAP32[gb + 1468320 + (i2 << 2) >> 2] | 0; else i2 = 0;
 f31 = Math_fround(HEAPF32[(HEAP32[gb + 1468832 + (i2 << 2) >> 2] | 0) + 344 >> 2]);
 f12 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i24 >> 2]) / f31));
 f31 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i25 >> 2]) / f31));
 f12 = Math_fround(f12 - f6);
 f13 = Math_fround(f4 - f31);
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 4 >> 2] = f31;
 HEAPF32[i1 + 12 >> 2] = f13;
 __Z15CalcPixelMatrixRK5RectTIfER10Matrix4x4f(i1, i26);
 i3 = __Z12GetGfxDevicev() | 0;
 __ZN10Matrix4x4fmLERKS_(i26, i27) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i26 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, gb + 1162292 | 0);
 HEAP32[gb + 1468288 >> 2] = HEAP32[i28 >> 2];
 HEAP32[gb + 1468288 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[gb + 1468288 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[gb + 1468288 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 __ZN10Matrix4x4f11SetIdentityEv(i1) | 0;
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 i3 = f13 > Math_fround(0.0);
 f13 = Math_fround(Math_fround(.875) / f13);
 f13 = i3 ? f13 : Math_fround(inf);
 HEAPF32[i1 >> 2] = f13;
 f31 = Math_fround(HEAPF32[i23 >> 2]);
 i3 = f31 > Math_fround(0.0);
 f31 = Math_fround(Math_fround(.875) / f31);
 f31 = i3 ? f31 : Math_fround(inf);
 HEAPF32[i1 + 20 >> 2] = f31;
 HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f13 * Math_fround(HEAPF32[i28 >> 2])));
 HEAPF32[i1 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f31 * Math_fround(HEAPF32[i21 >> 2])));
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 i3 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i29;
 return;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i2 = i6;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i6 >> 2] = i1;
 } else i2 = i6;
 __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + i2 | 0, i10);
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i8 = i1;
  i2 = i2 | 0 ? i2 - i8 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i8;
 }
 i5 = i2 + i1 | 0;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i7 = i10 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (i5 | 0) do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i1, i10);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 i5 = i2 + i1 | 0;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (i5 | 0) do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i1, i10);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 16 | 0;
 i5 = i6 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 396, 4) | 0;
  __ZN7mecanim5human5HumanC2Ev(i2);
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 __ZN7mecanim5human5Human8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i1 | 0, i10);
 i1 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 36 | 0;
 i5 = i6 + 32 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i6 + 44 | 0, i10);
 i1 = i6 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i1 | 0, i10);
 i1 = i6 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 i5 = i2 + i1 | 0;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (i5 | 0) do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i1, i10);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i6 + 96 | 0;
 i5 = i6 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i9 << 2) | 0;
 if (!i9) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_(i1, i2, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i13 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i12 = i1;
    i3 = i13 - i12 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i15 = 51;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i16) | 0;
    } else i3 = __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i1, i8, i14, i16) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    i9 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
    i10 = Math_imul(HEAP32[i9 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i6 << 3) >> 2] | 0) | 0;
    i7 = Math_imul(HEAP32[i9 + (i7 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i7 << 3) >> 2] | 0) | 0;
    if ((i10 | 0) > (i7 | 0)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((Math_imul(HEAP32[i9 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i5 << 3) >> 2] | 0) | 0) > (i7 | 0)) {
      i15 = 34;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if ((i10 | 0) <= (Math_imul(HEAP32[i9 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i5 << 3) >> 2] | 0) | 0)) {
     if ((i3 | 0) == (i14 | 0)) {
      i15 = 51;
      break L1;
     }
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i10 | 0) > (Math_imul(HEAP32[i9 + (i4 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i4 << 3) >> 2] | 0) | 0)) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i14 | 0)) {
       i15 = 51;
       break L1;
      }
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) {
     i15 = 51;
     break L1;
    } else i4 = i14;
    while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
     i9 = Math_imul(HEAP32[i8 + (i9 << 3) + 4 >> 2] | 0, HEAP32[i8 + (i9 << 3) >> 2] | 0) | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if ((i9 | 0) > (Math_imul(HEAP32[i8 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i8 + (i6 << 3) >> 2] | 0) | 0)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while ((i9 | 0) > (Math_imul(HEAP32[i8 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i8 + (i5 << 3) >> 2] | 0) | 0));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 34) {
    i15 = 0;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i4 >> 2] = i6;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i6 = i8;
    while (1) {
     i11 = HEAP32[i6 >> 2] | 0;
     i10 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
     i11 = Math_imul(HEAP32[i10 + (i11 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i11 << 3) >> 2] | 0) | 0;
     while (1) {
      i8 = HEAP32[i5 >> 2] | 0;
      i9 = i5 + 4 | 0;
      if ((Math_imul(HEAP32[i10 + (i8 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i8 << 3) >> 2] | 0) | 0) > (i11 | 0)) i5 = i9; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i7 = HEAP32[i4 >> 2] | 0;
     } while ((Math_imul(HEAP32[i10 + (i7 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i7 << 3) >> 2] | 0) | 0) <= (i11 | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i7;
     HEAP32[i4 >> 2] = i8;
     i6 = (i6 | 0) == (i5 | 0) ? i4 : i6;
     i5 = i9;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i11 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
    i10 = Math_imul(HEAP32[i11 + (i4 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i4 << 3) >> 2] | 0) | 0;
    if ((i10 | 0) > (Math_imul(HEAP32[i11 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i5 << 3) >> 2] | 0) | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR11IndexSorterPiEEbT0_S4_T_(i1, i7, i16) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR11IndexSorterPiEEbT0_S4_T_(i4, i2, i16) | 0) {
     i15 = 50;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i11 = i7;
   if ((i11 - i12 | 0) >= (i13 - i11 | 0)) {
    i15 = 49;
    break;
   }
   __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_(i1, i7, i16);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 49) {
   i15 = 0;
   __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_(i7 + 4 | 0, i2, i16);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 50) {
   i15 = 0;
   if (i3) {
    i15 = 51;
    break;
   } else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i16 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  i15 = Math_imul(HEAP32[i16 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i16 + (i2 << 3) >> 2] | 0) | 0;
  if ((i15 | 0) <= (Math_imul(HEAP32[i16 + (i3 << 3) + 4 >> 2] | 0, HEAP32[i16 + (i3 << 3) >> 2] | 0) | 0)) return;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  return;
 } else if ((i15 | 0) == 7) {
  __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i1, i1 + 4 | 0, i14, i16) | 0;
  return;
 } else if ((i15 | 0) == 8) {
  __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i16) | 0;
  return;
 } else if ((i15 | 0) == 9) {
  __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i16) | 0;
  return;
 } else if ((i15 | 0) == 11) {
  i4 = i1 + 8 | 0;
  __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i1, i1 + 4 | 0, i4, i16) | 0;
  i3 = i1 + 12 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   i7 = HEAP32[i3 >> 2] | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   i15 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i14 = Math_imul(HEAP32[i15 + (i7 << 3) + 4 >> 2] | 0, HEAP32[i15 + (i7 << 3) >> 2] | 0) | 0;
   if ((i14 | 0) > (Math_imul(HEAP32[i15 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i15 + (i6 << 3) >> 2] | 0) | 0)) {
    i5 = i3;
    while (1) {
     HEAP32[i5 >> 2] = i6;
     if ((i4 | 0) == (i1 | 0)) {
      i4 = i1;
      break;
     }
     i5 = i4 + -4 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i15 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
     i14 = Math_imul(HEAP32[i15 + (i7 << 3) + 4 >> 2] | 0, HEAP32[i15 + (i7 << 3) >> 2] | 0) | 0;
     if ((i14 | 0) <= (Math_imul(HEAP32[i15 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i15 + (i6 << 3) >> 2] | 0) | 0)) break; else {
      i15 = i4;
      i4 = i5;
      i5 = i15;
     }
    }
    HEAP32[i4 >> 2] = i7;
   }
   i4 = i3 + 4 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i15 = i3;
    i3 = i4;
    i4 = i15;
   }
  }
  return;
 } else if ((i15 | 0) == 51) return;
}

function __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i1, i2, i3, i53, i4, i5, i54, i55, i56, i57) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i53 = i53 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i54 = i54 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i58 = 0, i59 = 0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, f69 = f0, i70 = 0, f71 = f0, i72 = 0, f73 = f0, i74 = 0, f75 = f0, i76 = 0, f77 = f0, i78 = 0, f79 = f0, i80 = 0, f81 = f0, f82 = f0, f83 = f0, f84 = f0, f85 = f0, f86 = f0, f87 = f0, f88 = f0, f89 = f0, f90 = f0, f91 = f0, f92 = f0, f93 = f0, f94 = f0;
 if (i5 >>> 0 >= i54 >>> 0) return;
 i38 = i53 + 4 | 0;
 i39 = i53 + 8 | 0;
 i40 = i53 + 12 | 0;
 i41 = i53 + 16 | 0;
 i42 = i53 + 20 | 0;
 i43 = i53 + 24 | 0;
 i44 = i53 + 28 | 0;
 i45 = i53 + 32 | 0;
 i46 = i53 + 36 | 0;
 i47 = i53 + 40 | 0;
 i48 = i53 + 44 | 0;
 i49 = i53 + 48 | 0;
 i50 = i53 + 52 | 0;
 i51 = i53 + 56 | 0;
 i52 = i53 + 60 | 0;
 i37 = i1 + 80 | 0;
 i36 = i2 + 80 | 0;
 i22 = i3 + 80 | 0;
 i23 = i56 + 12 | 0;
 i24 = i56 + 24 | 0;
 i25 = i56 + 4 | 0;
 i26 = i56 + 16 | 0;
 i27 = i56 + 28 | 0;
 i28 = i56 + 8 | 0;
 i29 = i56 + 20 | 0;
 i30 = i56 + 32 | 0;
 i31 = i57 + 4 | 0;
 i32 = i57 + 8 | 0;
 i33 = i57 + 12 | 0;
 i34 = HEAP32[i4 + 60 >> 2] | 0;
 i35 = HEAP32[i4 + 80 >> 2] | 0;
 i21 = HEAP32[i4 + 100 >> 2] | 0;
 i9 = HEAP32[i45 >> 2] | 0;
 i10 = HEAP32[i46 >> 2] | 0;
 i11 = HEAP32[i47 >> 2] | 0;
 i12 = HEAP32[i48 >> 2] | 0;
 i13 = HEAP32[i49 >> 2] | 0;
 i14 = HEAP32[i50 >> 2] | 0;
 i15 = HEAP32[i51 >> 2] | 0;
 i16 = HEAP32[i52 >> 2] | 0;
 i1 = HEAP32[i53 >> 2] | 0;
 i2 = HEAP32[i38 >> 2] | 0;
 i3 = HEAP32[i39 >> 2] | 0;
 i4 = HEAP32[i40 >> 2] | 0;
 i17 = HEAP32[i41 >> 2] | 0;
 i18 = HEAP32[i42 >> 2] | 0;
 i19 = HEAP32[i43 >> 2] | 0;
 i20 = HEAP32[i44 >> 2] | 0;
 while (1) {
  i1 = i1 << 11 ^ i1;
  i6 = i2 << 11 ^ i2;
  i2 = i3 << 11 ^ i3;
  i59 = i4 << 11 ^ i4;
  i1 = i1 >>> 8 ^ i1 ^ i13;
  i4 = i17;
  i17 = i1 ^ i13 >>> 19;
  i3 = i6 >>> 8 ^ i6 ^ i14;
  i6 = i18;
  i18 = i3 ^ i14 >>> 19;
  i2 = i2 >>> 8 ^ i2 ^ i15;
  i7 = i19;
  i19 = i2 ^ i15 >>> 19;
  i59 = i59 >>> 8 ^ i59 ^ i16;
  i8 = i20;
  i20 = i59 ^ i16 >>> 19;
  i4 = i4 << 11 ^ i4;
  i6 = i6 << 11 ^ i6;
  i7 = i7 << 11 ^ i7;
  i8 = i8 << 11 ^ i8;
  i4 = i4 >>> 8 ^ i4 ^ i17;
  i58 = i9;
  i9 = i4 ^ i1 >>> 19;
  i6 = i6 >>> 8 ^ i6 ^ i18;
  i1 = i10;
  i10 = i6 ^ i3 >>> 19;
  i7 = i7 >>> 8 ^ i7 ^ i19;
  i3 = i11;
  i11 = i7 ^ i2 >>> 19;
  i8 = i8 >>> 8 ^ i8 ^ i20;
  i2 = i12;
  i12 = i8 ^ i59 >>> 19;
  i58 = i58 << 11 ^ i58;
  i1 = i1 << 11 ^ i1;
  i3 = i3 << 11 ^ i3;
  i2 = i2 << 11 ^ i2;
  i4 = i58 >>> 8 ^ i58 ^ i9 ^ i4 >>> 19;
  i6 = i1 >>> 8 ^ i1 ^ i10 ^ i6 >>> 19;
  i7 = i3 >>> 8 ^ i3 ^ i11 ^ i7 >>> 19;
  i8 = i2 >>> 8 ^ i2 ^ i12 ^ i8 >>> 19;
  i2 = HEAP32[i37 >> 2] | 0;
  i3 = HEAP32[i36 >> 2] | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  if (i55) {
   f63 = Math_fround(HEAPF32[i56 >> 2]);
   f62 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f62 * f63);
   f64 = Math_fround(HEAPF32[i23 >> 2]);
   f61 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f64 = Math_fround(f63 + Math_fround(f61 * f64));
   f63 = Math_fround(HEAPF32[i24 >> 2]);
   f60 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f63 = Math_fround(f64 + Math_fround(f60 * f63));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
   f63 = Math_fround(f62 * Math_fround(HEAPF32[i25 >> 2]));
   f63 = Math_fround(f63 + Math_fround(f61 * Math_fround(HEAPF32[i26 >> 2])));
   f63 = Math_fround(f63 + Math_fround(f60 * Math_fround(HEAPF32[i27 >> 2])));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f63, HEAP32[tempDoublePtr >> 2] | 0);
   f62 = Math_fround(f62 * Math_fround(HEAPF32[i28 >> 2]));
   f61 = Math_fround(f62 + Math_fround(f61 * Math_fround(HEAPF32[i29 >> 2])));
   f60 = Math_fround(f61 + Math_fround(f60 * Math_fround(HEAPF32[i30 >> 2])));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f60, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i80 = i34 + (i5 << 2) | 0;
  f82 = Math_fround(HEAPF32[i80 >> 2]);
  i78 = i80 + 4 | 0;
  f94 = Math_fround(HEAPF32[i78 >> 2]);
  i76 = i80 + 8 | 0;
  f93 = Math_fround(HEAPF32[i76 >> 2]);
  i74 = i80 + 12 | 0;
  f92 = Math_fround(HEAPF32[i74 >> 2]);
  i72 = i35 + (i5 << 2) | 0;
  f91 = Math_fround(HEAPF32[i72 >> 2]);
  i70 = i72 + 4 | 0;
  f90 = Math_fround(HEAPF32[i70 >> 2]);
  i68 = i72 + 8 | 0;
  f89 = Math_fround(HEAPF32[i68 >> 2]);
  i67 = i72 + 12 | 0;
  f88 = Math_fround(HEAPF32[i67 >> 2]);
  i66 = i21 + (i5 << 2) | 0;
  f87 = Math_fround(HEAPF32[i66 >> 2]);
  i65 = i66 + 4 | 0;
  f86 = Math_fround(HEAPF32[i65 >> 2]);
  i58 = i66 + 8 | 0;
  f85 = Math_fround(HEAPF32[i58 >> 2]);
  i59 = i66 + 12 | 0;
  f84 = Math_fround(HEAPF32[i59 >> 2]);
  f75 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(HEAPF32[i57 >> 2]);
  f81 = Math_fround(f75 * f61);
  f62 = Math_fround(HEAPF32[i31 >> 2]);
  f79 = Math_fround(f75 * f62);
  f63 = Math_fround(HEAPF32[i32 >> 2]);
  f77 = Math_fround(f75 * f63);
  f64 = Math_fround(HEAPF32[i33 >> 2]);
  f75 = Math_fround(f75 * f64);
  f60 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f73 = Math_fround(f60 * f61);
  f71 = Math_fround(f60 * f62);
  f69 = Math_fround(f60 * f63);
  f60 = Math_fround(f60 * f64);
  f83 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f79 = Math_fround(f94 + f79);
  f77 = Math_fround(f93 + f77);
  f75 = Math_fround(f92 + f75);
  f73 = Math_fround(f91 + f73);
  f71 = Math_fround(f90 + f71);
  f69 = Math_fround(f89 + f69);
  f60 = Math_fround(f88 + f60);
  f61 = Math_fround(f87 + Math_fround(f83 * f61));
  f62 = Math_fround(f86 + Math_fround(f83 * f62));
  f63 = Math_fround(f85 + Math_fround(f83 * f63));
  f64 = Math_fround(f84 + Math_fround(f83 * f64));
  HEAPF32[i80 >> 2] = Math_fround(f82 + f81);
  HEAPF32[i78 >> 2] = f79;
  HEAPF32[i76 >> 2] = f77;
  HEAPF32[i74 >> 2] = f75;
  HEAPF32[i72 >> 2] = f73;
  HEAPF32[i70 >> 2] = f71;
  HEAPF32[i68 >> 2] = f69;
  HEAPF32[i67 >> 2] = f60;
  HEAPF32[i66 >> 2] = f61;
  HEAPF32[i65 >> 2] = f62;
  HEAPF32[i58 >> 2] = f63;
  HEAPF32[i59 >> 2] = f64;
  i5 = i5 + 4 | 0;
  if (i5 >>> 0 >= i54 >>> 0) break; else {
   i80 = i16;
   i3 = i15;
   i2 = i14;
   i1 = i13;
   i13 = i4;
   i14 = i6;
   i15 = i7;
   i16 = i8;
   i4 = i80;
  }
 }
 HEAP32[i53 >> 2] = i13;
 HEAP32[i38 >> 2] = i14;
 HEAP32[i39 >> 2] = i15;
 HEAP32[i40 >> 2] = i16;
 HEAP32[i41 >> 2] = i17;
 HEAP32[i42 >> 2] = i18;
 HEAP32[i43 >> 2] = i19;
 HEAP32[i44 >> 2] = i20;
 HEAP32[i45 >> 2] = i9;
 HEAP32[i46 >> 2] = i10;
 HEAP32[i47 >> 2] = i11;
 HEAP32[i48 >> 2] = i12;
 HEAP32[i49 >> 2] = i4;
 HEAP32[i50 >> 2] = i6;
 HEAP32[i51 >> 2] = i7;
 HEAP32[i52 >> 2] = i8;
 return;
}

function __ZNSt3__29__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE(i14, i15, i16, i17, i18, i19, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i21;
 i20 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474588 | 0) | 0;
 i12 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474596 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i22 | 0, i12 | 0);
 HEAP32[i19 >> 2] = i17;
 i1 = HEAP8[i14 >> 0] | 0;
 L1 : do switch (i1 << 24 >> 24) {
 case 43:
 case 45:
  {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 44 >> 2] | 0, i20 | 0, i1 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L1;
   } else {
    i4 = HEAP32[i19 >> 2] | 0;
    HEAP32[i19 >> 2] = i4 + 4;
    HEAP32[i4 >> 2] = i1;
    i4 = i14 + 1 | 0;
    i11 = 5;
    break L1;
   }
  }
 default:
  {
   i4 = i14;
   i11 = 5;
  }
 } while (0);
 L6 : do if ((i11 | 0) == 5) {
  i13 = i16;
  L8 : do if ((i13 - i4 | 0) > 1) if ((HEAP8[i4 >> 0] | 0) == 48) {
   i2 = i4 + 1 | 0;
   switch (HEAP8[i2 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i2 = i4;
     i11 = 20;
     break L8;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 44 >> 2] | 0, i20 | 0, 48) | 0;
   i10 = __THREW__;
   __THREW__ = 0;
   if (!(i10 & 1)) {
    i10 = HEAP32[i19 >> 2] | 0;
    HEAP32[i19 >> 2] = i10 + 4;
    HEAP32[i10 >> 2] = i1;
    i4 = i4 + 2 | 0;
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 44 >> 2] | 0, i20 | 0, HEAP8[i2 >> 0] | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (!(i10 & 1)) {
     i2 = HEAP32[i19 >> 2] | 0;
     HEAP32[i19 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i1;
     i2 = i4;
     while (1) {
      if (i2 >>> 0 >= i16 >>> 0) {
       i11 = 25;
       break L8;
      }
      i1 = HEAP8[i2 >> 0] | 0;
      __THREW__ = 0;
      i3 = invoke_i(fb + 314 | 0) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) break;
      __THREW__ = 0;
      i1 = invoke_iii(fb + 1147 | 0, i1 << 24 >> 24 | 0, i3 | 0) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) break;
      if (!i1) {
       i11 = 25;
       break L8;
      }
      i2 = i2 + 1 | 0;
     }
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L6;
    }
   }
  } else {
   i2 = i4;
   i11 = 20;
  } else {
   i2 = i4;
   i11 = 20;
  } while (0);
  L21 : do if ((i11 | 0) == 20) {
   while (1) {
    if (i2 >>> 0 >= i16 >>> 0) {
     i11 = 25;
     break L21;
    }
    i1 = HEAP8[i2 >> 0] | 0;
    __THREW__ = 0;
    i3 = invoke_i(fb + 314 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) break;
    __THREW__ = 0;
    i1 = invoke_iii(fb + 1148 | 0, i1 << 24 >> 24 | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) break;
    if (!i1) {
     i11 = 25;
     break L21;
    }
    i2 = i2 + 1 | 0;
    i11 = 20;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break L6;
  } while (0);
  L29 : do if ((i11 | 0) == 25) {
   i9 = i22 + 11 | 0;
   i8 = HEAP8[i9 >> 0] | 0;
   i10 = i22 + 4 | 0;
   L31 : do if (!((i8 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i8 & 255) | 0)) {
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i20 >> 2] | 0) + 48 >> 2] | 0, i20 | 0, i4 | 0, i2 | 0, HEAP32[i19 >> 2] | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) break L29;
    i1 = (HEAP32[i19 >> 2] | 0) + (i2 - i4 << 2) | 0;
    HEAP32[i19 >> 2] = i1;
    i3 = i20;
   } else {
    L35 : do if ((i4 | 0) != (i2 | 0)) {
     i1 = i2;
     i3 = i4;
     while (1) {
      i1 = i1 + -1 | 0;
      if (i3 >>> 0 >= i1 >>> 0) break L35;
      i8 = HEAP8[i3 >> 0] | 0;
      HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i1 >> 0] = i8;
      i3 = i3 + 1 | 0;
     }
    } while (0);
    __THREW__ = 0;
    i8 = invoke_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) break L29;
    i7 = i4;
    i3 = 0;
    i5 = 0;
    while (1) {
     if (i7 >>> 0 >= i2 >>> 0) break;
     i1 = HEAP8[i9 >> 0] | 0;
     i6 = i1 << 24 >> 24 < 0;
     i23 = HEAP8[(i6 ? HEAP32[i22 >> 2] | 0 : i22) + i3 >> 0] | 0;
     if (i23 << 24 >> 24 > 0 & (i5 | 0) == (i23 << 24 >> 24 | 0)) {
      i5 = HEAP32[i19 >> 2] | 0;
      HEAP32[i19 >> 2] = i5 + 4;
      HEAP32[i5 >> 2] = i8;
      i3 = (i3 >>> 0 < ((i6 ? HEAP32[i10 >> 2] | 0 : i1 & 255) + -1 | 0) >>> 0 & 1) + i3 | 0;
      i5 = 0;
     }
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 44 >> 2] | 0, i20 | 0, HEAP8[i7 >> 0] | 0) | 0;
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i11 = 40;
      break;
     }
     i23 = HEAP32[i19 >> 2] | 0;
     HEAP32[i19 >> 2] = i23 + 4;
     HEAP32[i23 >> 2] = i1;
     i7 = i7 + 1 | 0;
     i5 = i5 + 1 | 0;
    }
    if ((i11 | 0) == 40) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L6;
    }
    i1 = i17 + (i4 - i14 << 2) | 0;
    i4 = HEAP32[i19 >> 2] | 0;
    if ((i1 | 0) == (i4 | 0)) i3 = i20; else {
     i3 = i4;
     while (1) {
      i3 = i3 + -4 | 0;
      if (i1 >>> 0 >= i3 >>> 0) {
       i3 = i20;
       i1 = i4;
       break L31;
      }
      i23 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i3 >> 2] = i23;
      i1 = i1 + 4 | 0;
     }
    }
   } while (0);
   while (1) {
    if (i2 >>> 0 >= i16 >>> 0) break;
    i1 = HEAP8[i2 >> 0] | 0;
    if (i1 << 24 >> 24 == 46) {
     i11 = 45;
     break;
    }
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i20 | 0, i1 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) {
     i11 = 15;
     break;
    }
    i10 = HEAP32[i19 >> 2] | 0;
    i23 = i10 + 4 | 0;
    HEAP32[i19 >> 2] = i23;
    HEAP32[i10 >> 2] = i1;
    i2 = i2 + 1 | 0;
    i1 = i23;
   }
   if ((i11 | 0) == 15) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L6;
   }
   if ((i11 | 0) == 45) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0) | 0;
    i23 = __THREW__;
    __THREW__ = 0;
    if (i23 & 1) break;
    i12 = HEAP32[i19 >> 2] | 0;
    i23 = i12 + 4 | 0;
    HEAP32[i19 >> 2] = i23;
    HEAP32[i12 >> 2] = i1;
    i2 = i2 + 1 | 0;
    i1 = i23;
   }
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i20 >> 2] | 0) + 48 >> 2] | 0, i20 | 0, i2 | 0, i16 | 0, i1 | 0) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (!(i23 & 1)) {
    i23 = (HEAP32[i19 >> 2] | 0) + (i13 - i2 << 2) | 0;
    HEAP32[i19 >> 2] = i23;
    HEAP32[i18 >> 2] = (i15 | 0) == (i16 | 0) ? i23 : i17 + (i15 - i14 << 2) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i21;
    return;
   }
  } while (0);
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
}

function __ZL24stbir__calculate_filtersP11stbir__infoP19stbir__contributorsPf12stbir_filterffii(i24, i20, i1, f21, f19, i14, i22) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 f21 = Math_fround(f21);
 f19 = Math_fround(f19);
 i14 = i14 | 0;
 i22 = i22 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i23 = 0;
 i15 = f21 > Math_fround(1.0);
 i23 = HEAP32[gb + 71848 + (i1 << 3) + 4 >> 2] | 0;
 if (i15) {
  f17 = Math_fround(Math_fround(1.0) / f21);
  f18 = Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f17)) * f21);
  if ((i22 | 0) <= 0) return;
  i9 = gb + 71848 + (i1 << 3) | 0;
  i7 = 0;
  do {
   f8 = Math_fround(Math_fround(i7 | 0) + Math_fround(.5));
   f16 = Math_fround(Math_fround(f8 + f19) / f21);
   i2 = ~~+Math_floor(+(+Math_fround(Math_fround(Math_fround(f8 - f18) + f19) / f21) + .5));
   i6 = ~~+Math_floor(+(+Math_fround(Math_fround(Math_fround(f18 + f8) + f19) / f21) + -.5));
   i10 = i20 + ((Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f17)) * Math_fround(2.0)))), i7) | 0) << 2) | 0;
   Math_fround(+mftCall_ff(i23 | 0, +f17));
   i11 = i24 + (i7 << 3) | 0;
   HEAP32[i11 >> 2] = i2;
   i12 = i24 + (i7 << 3) + 4 | 0;
   HEAP32[i12 >> 2] = i6;
   i1 = i6 - i2 | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) < 0) f3 = Math_fround(0.0); else {
    i1 = 0;
    f3 = Math_fround(0.0);
    while (1) {
     f8 = Math_fround(+mftCall_fff(i5 | 0, +Math_fround(f16 - Math_fround(Math_fround(i1 + i2 | 0) + Math_fround(.5))), +f17));
     HEAPF32[i10 + (i1 << 2) >> 2] = f8;
     if ((i1 | 0) != 0 | f8 != Math_fround(0.0)) {
      i4 = i1;
      f3 = Math_fround(f3 + f8);
     } else {
      i2 = i2 + 1 | 0;
      HEAP32[i11 >> 2] = i2;
      i4 = -1;
     }
     i1 = i6 - i2 | 0;
     if ((i4 | 0) < (i1 | 0)) i1 = i4 + 1 | 0; else break;
    }
   }
   Math_fround(+mftCall_fff(i5 | 0, +Math_fround(Math_fround(Math_fround(i6 + 1 | 0) + Math_fround(.5)) - f16), +f17));
   f3 = Math_fround(Math_fround(1.0) / f3);
   L16 : do if ((i1 | 0) >= 0) {
    i2 = 0;
    while (1) {
     i15 = i10 + (i2 << 2) | 0;
     HEAPF32[i15 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i15 >> 2]));
     if ((i2 | 0) == (i1 | 0)) break; else i2 = i2 + 1 | 0;
    }
    if ((i1 | 0) > -1) do {
     if (Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]) != Math_fround(0.0)) break L16;
     i15 = i1;
     i1 = i1 + -1 | 0;
     HEAP32[i12 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
    } while ((i15 | 0) > 0);
   } while (0);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i22 | 0));
  return;
 }
 i15 = (((~~Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)) / f21))) | 0) / 2 | 0) << 1) + i14 | 0;
 f8 = Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) / f21);
 if ((i15 | 0) > 0) {
  i10 = gb + 71848 + (i1 << 3) | 0;
  i9 = 0;
  do {
   f18 = Math_fround(Math_fround(i9 - ((~~Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)) / f21))) | 0) / 2 | 0) | 0) + Math_fround(.5));
   f3 = Math_fround(Math_fround(f18 * f21) - f19);
   i7 = ~~+Math_floor(+(+Math_fround(Math_fround(Math_fround(f18 - f8) * f21) - f19) + .5));
   i2 = ~~+Math_floor(+(+Math_fround(Math_fround(Math_fround(f8 + f18) * f21) - f19) + -.5));
   i11 = i20 + ((Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i9) | 0) << 2) | 0;
   i1 = i2 - i7 | 0;
   Math_fround(+mftCall_ff(i23 | 0, +f21));
   i12 = i24 + (i9 << 3) | 0;
   HEAP32[i12 >> 2] = i7;
   i13 = i24 + (i9 << 3) + 4 | 0;
   HEAP32[i13 >> 2] = i2;
   if ((i1 | 0) < 0) {
    i4 = i2 + 1 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   } else {
    i4 = i2 + 1 | 0;
    i6 = i4 - i7 | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = 0;
    do {
     HEAPF32[i11 + (i5 << 2) >> 2] = Math_fround(Math_fround(+mftCall_fff(i2 | 0, +Math_fround(Math_fround(Math_fround(i5 + i7 | 0) + Math_fround(.5)) - f3), +f21)) * f21);
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i6 | 0));
   }
   Math_fround(+mftCall_fff(i2 | 0, +Math_fround(Math_fround(Math_fround(i4 | 0) + Math_fround(.5)) - f3), +f21));
   L36 : do if ((i1 | 0) > -1) do {
    if (Math_fround(HEAPF32[i11 + (i1 << 2) >> 2]) != Math_fround(0.0)) break L36;
    i7 = i1;
    i1 = i1 + -1 | 0;
    HEAP32[i13 >> 2] = (HEAP32[i12 >> 2] | 0) + i1;
   } while ((i7 | 0) > 0); while (0);
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i15 | 0));
 }
 i10 = (((~~Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)) / f21))) | 0) / 2 | 0) << 1) + i14 | 0;
 i9 = ~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0))));
 if ((i22 | 0) > 0) {
  i5 = (i10 | 0) > 0;
  i4 = 0;
  do {
   L46 : do if (i5) {
    i2 = 0;
    f3 = Math_fround(0.0);
    do {
     i1 = HEAP32[i24 + (i2 << 3) >> 2] | 0;
     if ((i4 | 0) < (i1 | 0)) break;
     if ((i4 | 0) <= (HEAP32[i24 + (i2 << 3) + 4 >> 2] | 0)) f3 = Math_fround(f3 + Math_fround(HEAPF32[i20 + (i4 - i1 + (Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i2) | 0) << 2) >> 2]));
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i10 | 0));
    f3 = Math_fround(Math_fround(1.0) / f3);
    i1 = 0;
    do {
     i2 = HEAP32[i24 + (i1 << 3) >> 2] | 0;
     if ((i4 | 0) < (i2 | 0)) break L46;
     if ((i4 | 0) <= (HEAP32[i24 + (i1 << 3) + 4 >> 2] | 0)) {
      i15 = i20 + (i4 - i2 + (Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i1) | 0) << 2) | 0;
      HEAPF32[i15 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i15 >> 2]));
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i10 | 0));
   } while (0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i22 | 0));
 }
 if ((i10 | 0) > 0) i7 = 0; else return;
 do {
  i1 = 0;
  while (1) if (Math_fround(HEAPF32[i20 + ((Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i7) | 0) + i1 << 2) >> 2]) == Math_fround(0.0)) i1 = i1 + 1 | 0; else break;
  i15 = i24 + (i7 << 3) | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i24 + (i7 << 3) + 4 >> 2] | 0;
  i5 = i14 + i1 | 0;
  i13 = (i5 | 0) < 0;
  i5 = i13 ? 0 : i5;
  i1 = i13 ? 0 - i14 | 0 : i1;
  HEAP32[i15 >> 2] = i5;
  i5 = i2 - i5 + 1 | 0;
  i5 = (i9 | 0) < (i5 | 0) ? i9 : i5;
  i2 = ~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0))));
  L69 : do if ((i5 | 0) > 0) {
   i4 = 0;
   do {
    i6 = i4 + i1 | 0;
    if ((i6 | 0) >= (i2 | 0)) break L69;
    i15 = HEAP32[i20 + ((Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i7) | 0) + i6 << 2) >> 2] | 0;
    HEAP32[i20 + ((Math_imul(~~Math_fround(Math_ceil(Math_fround(Math_fround(+mftCall_ff(i23 | 0, +f21)) * Math_fround(2.0)))), i7) | 0) + i4 << 2) >> 2] = i15;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i5 | 0));
  } while (0);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i10 | 0));
 i2 = i22 + -1 | 0;
 i1 = 0;
 do {
  i23 = i24 + (i1 << 3) + 4 | 0;
  i22 = HEAP32[i23 >> 2] | 0;
  HEAP32[i23 >> 2] = (i22 | 0) < (i2 | 0) ? i22 : i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __Z13CombineMeshesRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb(i14, i24, i15, i16) {
 i14 = i14 | 0;
 i24 = i24 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i27 + 40 | 0;
 i18 = i27 + 32 | 0;
 i21 = i27 + 24 | 0;
 i20 = i27 + 16 | 0;
 i17 = i27 + 8 | 0;
 i1 = i27;
 i23 = i27 + 56 | 0;
 i25 = i27 + 44 | 0;
 if (!(HEAP8[i24 + 41 >> 0] | 0)) {
  HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
  __Z6FormatPKcz(i23, gb + 428355 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 544, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  STACKTOP = i27;
  return;
 }
 HEAP32[i25 >> 2] = 0;
 i26 = i25 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i12 = i14 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i2 = i1 - i3 | 0;
 i13 = i25 + 8 | 0;
 if (i2 | 0) {
  i11 = __Znwj(i2) | 0;
  i10 = i11;
  HEAP32[i25 >> 2] = i10;
  HEAP32[i26 >> 2] = i10;
  HEAP32[i13 >> 2] = i11 + (((i2 | 0) / 112 | 0) * 112 | 0);
 }
 L8 : do if ((i1 | 0) == (i3 | 0)) i22 = 24; else {
  i7 = i23 + 11 | 0;
  i8 = i23 + 11 | 0;
  i9 = i23 + 11 | 0;
  i10 = i23 + 11 | 0;
  i11 = i23 + 11 | 0;
  i6 = 0;
  i1 = i3;
  L10 : while (1) {
   i4 = HEAP32[i1 + (i6 * 112 | 0) >> 2] | 0;
   L12 : do if (!i4) {
    HEAP32[i17 >> 2] = i6;
    __Z6FormatPKcz(i23, gb + 428490 | 0, i17);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 557, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   } else {
    if ((i4 | 0) == (i24 | 0)) break L10;
    i2 = HEAP32[i1 + (i6 * 112 | 0) + 8 >> 2] | 0;
    if ((i2 | 0) >= 0) {
     i5 = HEAP32[i4 + 32 >> 2] | 0;
     if ((i2 | 0) < (((HEAP32[i5 + 132 >> 2] | 0) - (HEAP32[i5 + 128 >> 2] | 0) | 0) / 52 | 0 | 0)) {
      if (!(HEAP8[i4 + 41 >> 0] | 0)) {
       HEAP32[i21 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
       __Z6FormatPKcz(i23, gb + 428566 | 0, i21);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 572, 512, 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
       break;
      }
      i3 = HEAP32[i5 + 100 >> 2] | 0;
      if (!i3) break;
      i2 = HEAP32[i1 + (i6 * 112 | 0) + 4 >> 2] | 0;
      do if (HEAP32[i5 + 92 >> 2] | 0) {
       if (i2 | 0) if ((HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 100 >> 2] | 0) != (i3 | 0)) break;
       i2 = i1 + (i6 * 112 | 0) | 0;
       i4 = HEAP32[i26 >> 2] | 0;
       if ((i4 | 0) == (HEAP32[i13 >> 2] | 0)) {
        __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i25, i2);
        break L12;
       } else {
        i5 = i4;
        i3 = i5 + 76 | 0;
        do {
         HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
         i5 = i5 + 4 | 0;
         i2 = i2 + 4 | 0;
        } while ((i5 | 0) < (i3 | 0));
        HEAP32[i4 + 76 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 76 >> 2];
        HEAP32[i4 + 80 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 80 >> 2];
        HEAP32[i4 + 84 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 84 >> 2];
        HEAP32[i4 + 88 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 88 >> 2];
        HEAP32[i4 + 92 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 92 >> 2];
        HEAP32[i4 + 96 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 96 >> 2];
        HEAP32[i4 + 100 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 100 >> 2];
        HEAP32[i4 + 104 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 104 >> 2];
        HEAP32[i4 + 108 >> 2] = HEAP32[i1 + (i6 * 112 | 0) + 108 >> 2];
        HEAP32[i26 >> 2] = i4 + 112;
        break L12;
       }
      } while (0);
      HEAP32[i18 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      __Z6FormatPKcz(i23, gb + 428617 | 0, i18);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 581, 512, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
      break;
     }
    }
    i3 = HEAP32[i1 + (i6 * 112 | 0) + 8 >> 2] | 0;
    i5 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    HEAP32[i20 >> 2] = i3;
    HEAP32[i20 + 4 >> 2] = i5;
    __Z6FormatPKcz(i23, gb + 428525 | 0, i20);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 567, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   } while (0);
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i14 >> 2] | 0;
   if (i6 >>> 0 >= (((HEAP32[i12 >> 2] | 0) - i1 | 0) / 112 | 0) >>> 0) {
    i22 = 24;
    break L8;
   }
  }
  HEAP32[i19 >> 2] = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
  __Z6FormatPKcz(i23, gb + 428641 | 0, i19);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 428411 | 0, 562, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 } while (0);
 if ((i22 | 0) == 24) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0) | 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i23, i1, _strlen(i1) | 0);
  __Z36CombineMeshVerticesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEERKNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEER4Meshb(i25, i23, i24, i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  __Z35CombineMeshIndicesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb(i25, i24, i15, 0);
  __ZN4Mesh25RecalculateBoundsInternalEv(i24);
  HEAP32[i23 >> 2] = gb + 30832;
  HEAP32[i23 + 8 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = i24;
  i1 = HEAP32[i24 + 236 >> 2] | 0;
  i3 = i24 + 232 | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i22 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i22 + 8 >> 2] | 0, gb + 1105176 | 0, i23);
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = i24 + 240 | 0;
  i1 = HEAP32[i24 + 244 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i23 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 4 >> 2] | 0, i23 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  __ZN4Mesh18UpdateVertexFormatEv(i24);
 }
 i1 = HEAP32[i25 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i26 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i26 >> 2] = i3 + (~(((i3 + -112 - i2 | 0) >>> 0) / 112 | 0) * 112 | 0);
  __ZdlPv(i1);
 }
 STACKTOP = i27;
 return;
}

function __ZN11b2GearJointC2EPK14b2GearJointDef(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, f33 = f0;
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i11 = i15 + 48 | 0;
 HEAP32[i11 >> 2] = HEAP32[i16 + 8 >> 2];
 i14 = i15 + 52 | 0;
 HEAP32[i14 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i15 + 56 >> 2] = 0;
 HEAP8[i15 + 61 >> 0] = HEAP8[i16 + 16 >> 0] | 0;
 HEAP8[i15 + 60 >> 0] = 0;
 HEAP32[i15 + 64 >> 2] = HEAP32[i16 + 4 >> 2];
 i5 = i15 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i15 >> 2] = gb + 152268 + 8;
 i5 = i15 + 92 | 0;
 i17 = i15 + 100 | 0;
 i6 = i15 + 108 | 0;
 i18 = i15 + 116 | 0;
 i8 = i15 + 124 | 0;
 i19 = i15 + 132 | 0;
 i12 = HEAP32[i16 + 20 >> 2] | 0;
 HEAP32[i15 + 68 >> 2] = i12;
 i20 = i16 + 24 | 0;
 i13 = HEAP32[i20 >> 2] | 0;
 HEAP32[i15 + 72 >> 2] = i13;
 i9 = i12;
 i22 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i15 + 76 >> 2] = i22;
 i21 = HEAP32[i13 + 4 >> 2] | 0;
 HEAP32[i15 + 80 >> 2] = i21;
 i10 = HEAP32[i9 + 48 >> 2] | 0;
 HEAP32[i15 + 84 >> 2] = i10;
 i9 = HEAP32[i9 + 52 >> 2] | 0;
 HEAP32[i11 >> 2] = i9;
 f2 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f1 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 i11 = i12;
 if ((i22 | 0) == 1) {
  f4 = Math_fround(HEAPF32[i9 + 56 >> 2]);
  f7 = Math_fround(HEAPF32[i10 + 56 >> 2]);
  i22 = i12 + 68 | 0;
  i11 = HEAP32[i22 + 4 >> 2] | 0;
  i10 = i6;
  HEAP32[i10 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  i10 = i12 + 76 | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i22 = i5;
  HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i22 + 4 >> 2] = i11;
  i22 = HEAP32[i12 + 116 >> 2] | 0;
  HEAP32[i15 + 140 >> 2] = i22;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 128 >> 2] = Math_fround(0.0);
  f7 = Math_fround(f4 - f7);
  f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 } else {
  f27 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f29 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f28 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f30 = Math_fround(HEAPF32[i9 + 12 >> 2]);
  i31 = i11 + 68 | 0;
  i32 = HEAP32[i31 >> 2] | 0;
  i31 = HEAP32[i31 + 4 >> 2] | 0;
  i10 = i6;
  HEAP32[i10 >> 2] = i32;
  HEAP32[i10 + 4 >> 2] = i31;
  i10 = i11 + 76 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i22 = i5;
  HEAP32[i22 >> 2] = i9;
  HEAP32[i22 + 4 >> 2] = i10;
  HEAP32[i15 + 140 >> 2] = HEAP32[i11 + 100 >> 2];
  i22 = i11 + 84 | 0;
  i12 = HEAP32[i22 >> 2] | 0;
  i22 = HEAP32[i22 + 4 >> 2] | 0;
  i11 = i8;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i11 + 4 >> 2] = i22;
  f24 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(f4 * f26);
  f25 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = Math_fround(Math_fround(f30 - f29) + Math_fround(f23 - Math_fround(f2 * f25)));
  f2 = Math_fround(Math_fround(f28 - f27) + Math_fround(Math_fround(f2 * f26) + Math_fround(f4 * f25)));
  f4 = Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(f1 * f2)) - f24);
  f7 = Math_fround(Math_fround(Math_fround(f3 * f2) - Math_fround(f1 * f23)) - f7);
  f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f4);
  f7 = Math_fround(f4 + Math_fround((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
 }
 i5 = HEAP32[i13 + 48 >> 2] | 0;
 HEAP32[i15 + 88 >> 2] = i5;
 i6 = HEAP32[i13 + 52 >> 2] | 0;
 HEAP32[i14 >> 2] = i6;
 f2 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f1 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 if ((i21 | 0) == 1) {
  f30 = Math_fround(HEAPF32[i6 + 56 >> 2]);
  f29 = Math_fround(HEAPF32[i5 + 56 >> 2]);
  i32 = HEAP32[i20 >> 2] | 0;
  i31 = i32 + 68 | 0;
  i22 = HEAP32[i31 + 4 >> 2] | 0;
  i21 = i18;
  HEAP32[i21 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i21 + 4 >> 2] = i22;
  i21 = i32 + 76 | 0;
  i22 = HEAP32[i21 + 4 >> 2] | 0;
  i31 = i17;
  HEAP32[i31 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i31 + 4 >> 2] = i22;
  i32 = HEAP32[i32 + 116 >> 2] | 0;
  HEAP32[i15 + 144 >> 2] = i32;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 136 >> 2] = Math_fround(0.0);
  f29 = Math_fround(f30 - f29);
  f29 = Math_fround(f29 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i32 = i16 + 28 | 0;
  f30 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i15 + 152 | 0;
  HEAPF32[i32 >> 2] = f30;
  f30 = Math_fround(f29 * f30);
  f30 = Math_fround(f7 + f30);
  i32 = i15 + 148 | 0;
  HEAPF32[i32 >> 2] = f30;
  i32 = i15 + 156 | 0;
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  return;
 } else {
  f25 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f24 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f33 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  i32 = HEAP32[i20 >> 2] | 0;
  i20 = i32 + 68 | 0;
  i14 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i22 = i18;
  HEAP32[i22 >> 2] = i14;
  HEAP32[i22 + 4 >> 2] = i20;
  i22 = i32 + 76 | 0;
  i21 = HEAP32[i22 >> 2] | 0;
  i22 = HEAP32[i22 + 4 >> 2] | 0;
  i31 = i17;
  HEAP32[i31 >> 2] = i21;
  HEAP32[i31 + 4 >> 2] = i22;
  HEAP32[i15 + 144 >> 2] = HEAP32[i32 + 100 >> 2];
  i32 = i32 + 84 | 0;
  i31 = HEAP32[i32 >> 2] | 0;
  i32 = HEAP32[i32 + 4 >> 2] | 0;
  HEAP32[i19 >> 2] = i31;
  HEAP32[i19 + 4 >> 2] = i32;
  f30 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(f4 * f26);
  f27 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(Math_fround(f33 - f23) + Math_fround(f28 - Math_fround(f2 * f27)));
  f27 = Math_fround(Math_fround(f24 - f25) + Math_fround(Math_fround(f2 * f26) + Math_fround(f4 * f27)));
  f30 = Math_fround(Math_fround(Math_fround(f3 * f28) + Math_fround(f1 * f27)) - f30);
  f29 = Math_fround(Math_fround(Math_fround(f3 * f27) - Math_fround(f1 * f28)) - f29);
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f30);
  f29 = Math_fround(f30 + Math_fround((HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f29));
  i32 = i16 + 28 | 0;
  f30 = Math_fround(HEAPF32[i32 >> 2]);
  i32 = i15 + 152 | 0;
  HEAPF32[i32 >> 2] = f30;
  f30 = Math_fround(f29 * f30);
  f30 = Math_fround(f7 + f30);
  i32 = i15 + 148 | 0;
  HEAPF32[i32 >> 2] = f30;
  i32 = i15 + 156 | 0;
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  return;
 }
}

function __Z28CollectMemoryAllocationStatsR11MemoryStats(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = __Z22GetMemoryProfilerStatsv() | 0;
 i3 = i8 + 52 | 0;
 i4 = i8 + 56 | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = __Z22GetMemoryProfilerStatsv() | 0;
 i3 = i8 + 60 | 0;
 i4 = i8 + 64 | 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i2 = i1 + 20 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = __Z22GetMemoryProfilerStatsv() | 0;
 i3 = i8 + 68 | 0;
 i4 = i8 + 72 | 0;
 i7 = HEAP32[i1 + 52 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i2 = i1 + 40 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = __Z22GetMemoryProfilerStatsv() | 0;
 i3 = i8 + 76 | 0;
 i4 = i8 + 80 | 0;
 i7 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i2 = i1 + 60 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i1 = __Z22GetMemoryProfilerStatsv() | 0;
 i3 = i8 + 84 | 0;
 i4 = i8 + 88 | 0;
 i7 = HEAP32[i1 + 92 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i2 = i1 + 80 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i5 = HEAP32[gb + 1104264 >> 2] | 0;
 HEAP32[i8 + 104 >> 2] = (HEAP32[i5 + 36 >> 2] | 0) - (HEAP32[i5 + 4 >> 2] | 0);
 i5 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63576 | 0) | 0;
 i2 = i8 + 20 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0) | 0;
 i5 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63360 | 0) | 0;
 i5 = (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63368 | 0) | 0) + i5 | 0;
 i5 = i5 + (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63376 | 0) | 0) | 0;
 i1 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = i5 + (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63384 | 0) | 0);
 i5 = __ZN13MemoryManager23GetTotalAllocatedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = i5 - (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0);
 i1 = __Z26scripting_gc_get_used_sizev() | 0;
 getTempRet0() | 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 __Z16GetMemoryManagerv() | 0;
 i1 = HEAP32[gb + 1188356 >> 2] | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 HEAP32[i8 >> 2] = (HEAP32[i7 >> 2] | 0) + i1 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i2 >> 2] | 0);
 i2 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63576 | 0) | 0;
 i5 = i8 + 44 | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
 i2 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63360 | 0) | 0;
 i2 = (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63368 | 0) | 0) + i2 | 0;
 i2 = i2 + (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63376 | 0) | 0) | 0;
 i1 = i8 + 40 | 0;
 HEAP32[i1 >> 2] = i2 + (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63384 | 0) | 0);
 i2 = __ZN13MemoryManager22GetTotalReservedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
 i7 = i8 + 28 | 0;
 HEAP32[i7 >> 2] = i2 - (HEAP32[i5 >> 2] | 0) - (HEAP32[i1 >> 2] | 0);
 i1 = __Z26scripting_gc_get_heap_sizev() | 0;
 getTempRet0() | 0;
 i2 = i8 + 32 | 0;
 HEAP32[i2 >> 2] = i1;
 __Z16GetMemoryManagerv() | 0;
 i1 = HEAP32[gb + 1188356 >> 2] | 0;
 HEAP32[i8 + 36 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = (HEAP32[i7 >> 2] | 0) + i1 + (HEAP32[i2 >> 2] | 0) + (HEAP32[i5 >> 2] | 0);
 HEAP32[i8 + 92 >> 2] = HEAP32[(__Z22GetMemoryProfilerStatsv() | 0) + 100 >> 2];
 HEAP32[i8 + 96 >> 2] = HEAP32[(__Z22GetMemoryProfilerStatsv() | 0) + 104 >> 2];
 HEAP32[i8 + 100 >> 2] = HEAP32[(__Z22GetMemoryProfilerStatsv() | 0) + 108 >> 2];
 i5 = i8 + 188 | 0;
 i2 = __Z22GetMemoryProfilerStatsv() | 0;
 i1 = i2 + 120 | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i1 = __ZN10systeminfo22GetUsedVirtualMemoryMBEv() | 0;
  i1 = i1 << 20;
  i2 = i8 + 48 | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = __Z22GetMemoryProfilerStatsv() | 0;
  i2 = i2 + 112 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i8 + 116 | 0;
  HEAP32[i1 >> 2] = i2;
  i1 = __Z22GetMemoryProfilerStatsv() | 0;
  i1 = i1 + 116 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i8 + 120 | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = __Z16GetMemoryManagerv() | 0;
  i2 = i2 + 6896 | 0;
  i1 = i8 + 124 | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i8 + 200 | 0;
 i1 = HEAP32[i2 + 132 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 204 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i8 + 192 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 192 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 i1 = __ZN10systeminfo22GetUsedVirtualMemoryMBEv() | 0;
 i1 = i1 << 20;
 i2 = i8 + 48 | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = __Z22GetMemoryProfilerStatsv() | 0;
 i2 = i2 + 112 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = i8 + 116 | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = __Z22GetMemoryProfilerStatsv() | 0;
 i1 = i1 + 116 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i8 + 120 | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = __Z16GetMemoryManagerv() | 0;
 i2 = i2 + 6896 | 0;
 i1 = i8 + 124 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN13TrailRenderer14UpdateRendererEv(i24) {
 i24 = i24 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25 + 16 | 0;
 i20 = i25;
 __ZN8Renderer14UpdateRendererEv(i24);
 f22 = Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
 i23 = i24 + 356 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i7 = HEAP32[i24 + 344 >> 2] | 0;
  i5 = i24 + 352 | 0;
  i6 = HEAP32[i7 + 8 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i24 + 388 >> 2]);
  i7 = i7 + 20 | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  while (1) {
   if (!(f22 > Math_fround(Math_fround(HEAPF32[i6 + (i8 << 4) + 12 >> 2]) + f2))) break L1;
   i8 = ((i8 + 1 | 0) >>> 0) % ((HEAP32[i7 >> 2] | 0) >>> 0) | 0;
   HEAP32[i5 >> 2] = i8;
   i1 = i1 + -1 | 0;
   HEAP32[i23 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 i21 = i24 + 340 | 0;
 if (HEAP8[i21 >> 0] | 0) {
  i16 = HEAP32[i24 + 84 >> 2] | 0;
  i17 = HEAP32[i24 + 88 >> 2] | 0;
  i18 = HEAP32[i24 + 92 >> 2] | 0;
  i15 = i24 + 344 | 0;
  i5 = HEAP32[i15 >> 2] | 0;
  if (!i1) i9 = 8; else {
   i14 = HEAP32[i24 + 348 >> 2] | 0;
   i13 = HEAP32[i5 + 8 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i13 + (i14 << 4) >> 2]);
   f3 = Math_fround(HEAPF32[i13 + (i14 << 4) + 4 >> 2]);
   f2 = Math_fround(HEAPF32[i13 + (i14 << 4) + 8 >> 2]);
   f28 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f26 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f27 = Math_fround(f2 - (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f27 = Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f27 * f27));
   f26 = Math_fround(HEAPF32[i24 + 392 >> 2]);
   if (f27 > Math_fround(f26 * f26)) i9 = 8;
  }
  if ((i9 | 0) == 8) {
   i6 = HEAP32[i5 + 20 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) {
    HEAP32[i19 >> 2] = 0;
    i14 = i19 + 4 | 0;
    i12 = gb + 63160 | 0;
    i13 = HEAP32[i12 + 4 >> 2] | 0;
    i5 = i14;
    HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i5 + 4 >> 2] = i13;
    i5 = i1 << 4;
    do if (!i5) i5 = 0; else {
     i6 = (i5 | 4) + -1 | 0;
     if (i6 >>> 0 < 2e3) {
      i5 = STACKTOP;
      STACKTOP = STACKTOP + ((1 * i6 | 0) + 15 & -16) | 0;
      if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 421073 | 0, 110) | 0;
      i13 = gb + 64016 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      HEAP32[i19 >> 2] = i5;
      i1 = i14;
      HEAP32[i1 >> 2] = i12;
      HEAP32[i1 + 4 >> 2] = i13;
      i1 = HEAP32[i23 >> 2] | 0;
      break;
     }
    } while (0);
    i13 = i5 + 3 & -4;
    i6 = i13;
    if ((i1 | 0) > 0) {
     i5 = i24 + 352 | 0;
     i1 = 0;
     do {
      i12 = i6 + (i1 << 4) | 0;
      i11 = HEAP32[i15 >> 2] | 0;
      i11 = (HEAP32[i11 + 8 >> 2] | 0) + (((((HEAP32[i5 >> 2] | 0) + i1 | 0) >>> 0) % ((HEAP32[i11 + 20 >> 2] | 0) >>> 0) | 0) << 4) | 0;
      HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i23 >> 2] | 0));
    }
    i5 = HEAP32[i15 >> 2] | 0;
    i6 = i5 + 8 | 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP32[i20 + 8 >> 2] = 0;
    HEAP32[i20 + 12 >> 2] = 0;
    i7 = i5 + 20 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    i9 = i8 + 1 | 0;
    i10 = i5 + 24 | 0;
    i11 = HEAP32[i10 >> 2] | 0;
    i12 = i11 & 2147483647;
    do if (i9 >>> 0 > i12 >>> 0) {
     i1 = i11 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i12 >>> 0 < i1 >>> 0) if ((i11 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 4, 4, i5 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i5 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i6 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i7 >> 2] = i9;
    i6 = (HEAP32[i6 >> 2] | 0) + (i8 << 4) | 0;
    HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
    _memcpy(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, HEAP32[i23 >> 2] << 4 | 0) | 0;
    HEAP32[i24 + 352 >> 2] = 0;
    i6 = i24 + 348 | 0;
    HEAP32[i6 >> 2] = HEAP32[i23 >> 2];
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i14);
    i7 = i6;
    i1 = HEAP32[i23 >> 2] | 0;
    i5 = HEAP32[i15 >> 2] | 0;
    i6 = HEAP32[i6 >> 2] | 0;
   } else {
    i7 = i24 + 348 | 0;
    i6 = (((HEAP32[i7 >> 2] | 0) + 1 | 0) >>> 0) % (i6 >>> 0) | 0;
    HEAP32[i7 >> 2] = i6;
   }
   HEAP32[i23 >> 2] = i1 + 1;
   i20 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i20 + (i6 << 4) >> 2] = i16;
   HEAP32[i20 + (i6 << 4) + 4 >> 2] = i17;
   HEAP32[i20 + (i6 << 4) + 8 >> 2] = i18;
   HEAPF32[i20 + (i6 << 4) + 12 >> 2] = f22;
   i20 = HEAP32[i7 >> 2] | 0;
   i19 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i19 + (i20 << 4) >> 2]);
   f3 = Math_fround(HEAPF32[i19 + (i20 << 4) + 4 >> 2]);
   f2 = Math_fround(HEAPF32[i19 + (i20 << 4) + 8 >> 2]);
  }
  i1 = i24 + 360 | 0;
  f28 = Math_fround(HEAPF32[i1 >> 2]);
  i20 = i24 + 364 | 0;
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i19 = i24 + 368 | 0;
  f26 = Math_fround(HEAPF32[i19 >> 2]);
  HEAPF32[i1 >> 2] = f4 < f28 ? f4 : f28;
  HEAPF32[i20 >> 2] = f3 < f27 ? f3 : f27;
  HEAPF32[i19 >> 2] = f2 < f26 ? f2 : f26;
  i19 = i24 + 372 | 0;
  f26 = Math_fround(HEAPF32[i19 >> 2]);
  i20 = i24 + 376 | 0;
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i1 = i24 + 380 | 0;
  f28 = Math_fround(HEAPF32[i1 >> 2]);
  HEAPF32[i19 >> 2] = f26 < f4 ? f4 : f26;
  HEAPF32[i20 >> 2] = f27 < f3 ? f3 : f27;
  HEAPF32[i1 >> 2] = f28 < f2 ? f2 : f28;
  __ZN8Renderer13BoundsChangedEv(i24);
  i1 = HEAP32[i23 >> 2] | 0;
 }
 if ((i1 | 0) >= 2) {
  HEAP8[i24 + 341 >> 0] = 1;
  __ZN8Renderer18UpdateManagerStateEb(i24, 1);
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!(HEAP8[i24 + 396 >> 0] | 0)) {
  __ZN8Renderer18UpdateManagerStateEb(i24, 1);
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!(HEAP8[i24 + 341 >> 0] | 0)) {
  __ZN8Renderer18UpdateManagerStateEb(i24, 1);
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!(__Z14IsWorldPlayingv() | 0)) {
  __ZN8Renderer18UpdateManagerStateEb(i24, 1);
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 __Z20DestroyObjectDelayedP6Objectf(HEAP32[i24 + 28 >> 2] | 0, Math_fround(-100.0));
 __ZN8Renderer18UpdateManagerStateEb(i24, 1);
 HEAP8[i21 >> 0] = 0;
 STACKTOP = i25;
 return;
}

function __ZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f(i12, i13, i16, i27, i1, i28, f11) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 f11 = Math_fround(f11);
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 296 | 0;
 i23 = i26 + 280 | 0;
 i24 = i26 + 232 | 0;
 i22 = i26 + 100 | 0;
 i10 = i26 + 88 | 0;
 i8 = i26 + 244 | 0;
 i9 = i26 + 172 | 0;
 i25 = i26 + 112 | 0;
 i21 = i26 + 24 | 0;
 i18 = i26 + 12 | 0;
 i17 = i26 + 40 | 0;
 i19 = i26;
 i14 = HEAP32[i13 >> 2] | 0;
 i15 = i14 + 36 | 0;
 i1 = i14 + 40 | 0;
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i20, i1, i14 + 52 | 0);
 f30 = Math_fround(HEAPF32[i12 + 56 >> 2]);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i12 + 28 >> 2]));
 f29 = Math_fround(HEAPF32[i12 + 60 >> 2]);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i12 + 32 >> 2]));
 f7 = Math_fround(HEAPF32[i12 + 64 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i12 + 36 >> 2]));
 HEAPF32[i23 >> 2] = f30;
 HEAPF32[i23 + 4 >> 2] = f29;
 HEAPF32[i23 + 8 >> 2] = f7;
 f2 = Math_fround(HEAPF32[i13 + 56 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i13 + 28 >> 2]));
 f3 = Math_fround(HEAPF32[i13 + 60 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i13 + 32 >> 2]));
 f4 = Math_fround(HEAPF32[i13 + 64 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i13 + 36 >> 2]));
 HEAPF32[i24 >> 2] = f2;
 HEAPF32[i24 + 4 >> 2] = f3;
 HEAPF32[i24 + 8 >> 2] = f4;
 f2 = Math_fround(f30 - f2);
 f3 = Math_fround(f29 - f3);
 f4 = Math_fround(f7 - f4);
 HEAPF32[i22 >> 2] = f2;
 HEAPF32[i22 + 4 >> 2] = f3;
 HEAPF32[i22 + 8 >> 2] = f4;
 HEAPF32[i10 >> 2] = f2;
 i5 = i10 + 4 | 0;
 HEAPF32[i5 >> 2] = f3;
 i6 = i10 + 8 | 0;
 HEAPF32[i6 >> 2] = f4;
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4))));
 if (f7 > Math_fround(0.0)) {
  f30 = Math_fround(Math_fround(1.0) / f7);
  HEAPF32[i10 >> 2] = Math_fround(f2 * f30);
  HEAPF32[i5 >> 2] = Math_fround(f3 * f30);
  HEAPF32[i6 >> 2] = Math_fround(f4 * f30);
 }
 f2 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f35 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f34 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f3 = Math_fround(f2 + f2);
 f30 = Math_fround(f35 + f35);
 f36 = Math_fround(f31 + f31);
 f2 = Math_fround(f2 * f3);
 f29 = Math_fround(f35 * f30);
 f33 = Math_fround(f31 * f36);
 f35 = Math_fround(f3 * f35);
 f4 = Math_fround(f3 * f31);
 f3 = Math_fround(f3 * f34);
 f31 = Math_fround(f30 * f31);
 f30 = Math_fround(f30 * f34);
 f34 = Math_fround(f36 * f34);
 f36 = Math_fround(f35 + f34);
 f32 = Math_fround(f4 - f30);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f29) - f33);
 HEAPF32[i8 + 4 >> 2] = f36;
 HEAPF32[i8 + 8 >> 2] = f32;
 f2 = Math_fround(Math_fround(1.0) - f2);
 f33 = Math_fround(f2 - f33);
 f32 = Math_fround(f31 + f3);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f35 - f34);
 HEAPF32[i8 + 16 >> 2] = f33;
 HEAPF32[i8 + 20 >> 2] = f32;
 f3 = Math_fround(f31 - f3);
 f29 = Math_fround(f2 - f29);
 HEAPF32[i8 + 24 >> 2] = Math_fround(f4 + f30);
 HEAPF32[i8 + 28 >> 2] = f3;
 HEAPF32[i8 + 32 >> 2] = f29;
 i6 = i12 + 68 | 0;
 i5 = i12 + 80 | 0;
 __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i9, i6, i5, i8, i10, f7);
 __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i25, i9, i13 + 40 | 0, i1);
 i10 = i25 + 48 | 0;
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f11);
 i10 = i25 + 52 | 0;
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f11);
 i10 = i25 + 56 | 0;
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f11);
 HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 84 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 88 >> 2];
 f29 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f11);
 f3 = Math_fround(Math_fround(HEAPF32[i12 + 72 >> 2]) + f11);
 f30 = Math_fround(Math_fround(HEAPF32[i12 + 76 >> 2]) + f11);
 HEAPF32[i18 >> 2] = f29;
 HEAPF32[i18 + 4 >> 2] = f3;
 HEAPF32[i18 + 8 >> 2] = f30;
 i10 = (i16 | 0) != 0;
 f30 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f30 = i10 ? f30 : Math_fround(0.0);
 i1 = (i27 | 0) != 0;
 f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f3 = i1 ? f3 : Math_fround(0.0);
 f3 = f30 > f3 ? f30 : f3;
 if (i10) f2 = Math_fround(HEAPF32[(HEAP32[i16 + 60 >> 2] | 0) + 4 >> 2]); else f2 = Math_fround(1.0);
 if (!i1) {
  f36 = Math_fround(1.0);
  i27 = f2 < f36;
  f36 = i27 ? f2 : f36;
  f36 = Math_fround(f3 * f36);
  i27 = i17 + 4 | 0;
  HEAP32[i27 >> 2] = 2;
  HEAP32[i17 >> 2] = gb + 102888 + 8;
  i27 = i17 + 12 | 0;
  HEAPF32[i27 >> 2] = f36;
  i27 = i17 + 16 | 0;
  HEAP32[i27 >> 2] = i15;
  i27 = i17 + 20 | 0;
  HEAP32[i27 >> 2] = i20;
  i27 = i17 + 24 | 0;
  HEAP32[i27 >> 2] = i22;
  i27 = i17 + 28 | 0;
  HEAP32[i27 >> 2] = i23;
  i23 = i17 + 32 | 0;
  HEAP32[i23 >> 2] = i24;
  i24 = i17 + 36 | 0;
  HEAP32[i24 >> 2] = i28;
  i28 = i17 + 40 | 0;
  HEAP32[i28 >> 2] = i21;
  i28 = i17 + 44 | 0;
  HEAP32[i28 >> 2] = i18;
  i28 = i17 + 8 | 0;
  HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i24 = i14 + 76 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i23 = i24 + 16 | 0;
  i23 = HEAP32[i23 >> 2] | 0;
  HEAP32[i19 >> 2] = i23;
  i23 = i24 + 32 | 0;
  i27 = i19 + 4 | 0;
  HEAP32[i27 >> 2] = i23;
  i24 = i24 + 20 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i27 = i19 + 8 | 0;
  HEAP32[i27 >> 2] = i24;
  __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i25, 1, i19, i17, 1);
  f36 = Math_fround(HEAPF32[i28 >> 2]);
  STACKTOP = i26;
  return Math_fround(f36);
 }
 f36 = Math_fround(HEAPF32[(HEAP32[i27 + 60 >> 2] | 0) + 4 >> 2]);
 i27 = f2 < f36;
 f36 = i27 ? f2 : f36;
 f36 = Math_fround(f3 * f36);
 i27 = i17 + 4 | 0;
 HEAP32[i27 >> 2] = 2;
 HEAP32[i17 >> 2] = gb + 102888 + 8;
 i27 = i17 + 12 | 0;
 HEAPF32[i27 >> 2] = f36;
 i27 = i17 + 16 | 0;
 HEAP32[i27 >> 2] = i15;
 i27 = i17 + 20 | 0;
 HEAP32[i27 >> 2] = i20;
 i27 = i17 + 24 | 0;
 HEAP32[i27 >> 2] = i22;
 i27 = i17 + 28 | 0;
 HEAP32[i27 >> 2] = i23;
 i23 = i17 + 32 | 0;
 HEAP32[i23 >> 2] = i24;
 i24 = i17 + 36 | 0;
 HEAP32[i24 >> 2] = i28;
 i28 = i17 + 40 | 0;
 HEAP32[i28 >> 2] = i21;
 i28 = i17 + 44 | 0;
 HEAP32[i28 >> 2] = i18;
 i28 = i17 + 8 | 0;
 HEAPF32[i28 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i24 = i14 + 76 | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 i23 = i24 + 16 | 0;
 i23 = HEAP32[i23 >> 2] | 0;
 HEAP32[i19 >> 2] = i23;
 i23 = i24 + 32 | 0;
 i27 = i19 + 4 | 0;
 HEAP32[i27 >> 2] = i23;
 i24 = i24 + 20 | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 i27 = i19 + 8 | 0;
 HEAP32[i27 >> 2] = i24;
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i25, 1, i19, i17, 1);
 f36 = Math_fround(HEAPF32[i28 >> 2]);
 STACKTOP = i26;
 return Math_fround(f36);
}

function __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress(i30, i4, i31, i34) {
 i30 = i30 | 0;
 i4 = i4 | 0;
 i31 = i31 | 0;
 i34 = i34 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i40 + 24 | 0;
 i35 = i40 + 16 | 0;
 i36 = i40 + 44 | 0;
 i37 = i40;
 i38 = i40 + 40 | 0;
 i39 = i40 + 64 | 0;
 if (!i31) {
  STACKTOP = i40;
  return;
 }
 i33 = gb + 64016 | 0;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i5 = i35;
 HEAP32[i5 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i5 + 4 >> 2] = i32;
 HEAP32[i36 >> 2] = 0;
 i5 = i36 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i32 = i36 + 16 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i36 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i29, i35);
 i3 = i29;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i33;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i31 << 2;
 i2 = i1 >> 2;
 HEAP32[i5 >> 2] = i2;
 i3 = HEAP32[i32 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i32 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i36 >> 2] | 0, i1, 4, i33, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i36 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i33, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i36 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  HEAP32[i32 >> 2] = i2;
  HEAP32[i36 >> 2] = i1;
  break;
 } else i1 = HEAP32[i36 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i4 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 __ZN17PersistentManager22CheckInstanceIDsLoadedEPii(i30, HEAP32[i36 >> 2] | 0, i31);
 i16 = i30 + 192 | 0;
 L11 : do if ((i31 | 0) > 0) {
  i17 = i34 + 8 | 0;
  i18 = i34 + 12 | 0;
  i19 = i30 + 56 | 0;
  i14 = i37 + 4 | 0;
  i15 = i37 + 8 | 0;
  i20 = i30 + 84 | 0;
  i21 = i30 + 176 | 0;
  i22 = i30 + 120 | 0;
  i23 = i30 + 168 | 0;
  i24 = i30 + 172 | 0;
  i25 = i34 + 28 | 0;
  i26 = i34 + 16 | 0;
  i27 = i30 + 116 | 0;
  i28 = i34 + 4 | 0;
  i13 = 0;
  i1 = 0;
  do {
   if (HEAP8[i16 >> 0] | 0) break L11;
   f7 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + Math_fround(1.0));
   HEAPF32[i29 >> 2] = f7;
   f6 = Math_fround(HEAPF32[i17 >> 2]);
   i12 = HEAP32[(f7 < f6 ? i29 : i17) >> 2] | 0;
   HEAP32[i18 >> 2] = i12;
   i2 = HEAP32[i34 >> 2] | 0;
   f7 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i2 | 0) {
    if (f6 == Math_fround(0.0)) f6 = Math_fround(1.0); else f6 = Math_fround(Math_fround(f7 * Math_fround(HEAPF32[i28 >> 2])) / f6);
    HEAPF32[i2 >> 2] = f6;
   }
   i11 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i13 << 2) >> 2] | 0;
   if (i11) {
    if ((HEAP16[gb + 1166004 + 6 >> 1] | 0) > -1) {
     __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1166004 | 0, i11);
     i12 = gb + 1166004 | 0;
    } else i12 = 0;
    i4 = HEAP32[i19 >> 2] | 0;
    i2 = HEAP32[i4 + 36 >> 2] | 0;
    if ((i2 | 0) == -1) i10 = 24; else {
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     if ((i11 | 0) < (i3 | 0)) i10 = 24; else if ((HEAP32[i4 + 32 >> 2] | 0) < (i11 | 0)) i10 = 24; else {
      i8 = (i11 - i3 | 0) / 2 | 0;
      i9 = i8;
      i8 = ((i8 | 0) < 0) << 31 >> 31;
      i10 = 32;
     }
    }
    if ((i10 | 0) == 24) {
     i10 = 0;
     i5 = i4 + 16 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (i2) {
      i3 = i5;
      L33 : while (1) {
       i4 = i2;
       while (1) {
        if ((HEAP32[i4 + 16 >> 2] | 0) >= (i11 | 0)) break;
        i2 = HEAP32[i4 + 4 >> 2] | 0;
        if (!i2) break L33; else i4 = i2;
       }
       i2 = HEAP32[i4 >> 2] | 0;
       if (!i2) {
        i3 = i4;
        break;
       } else i3 = i4;
      }
      if ((i3 | 0) != (i5 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) <= (i11 | 0)) {
       i2 = HEAP32[i3 + 24 >> 2] | 0;
       i1 = HEAP32[i3 + 24 + 4 >> 2] | 0;
       i3 = i3 + 32 | 0;
       if ((i2 | 0) != -1) {
        i9 = HEAP32[i3 >> 2] | 0;
        i8 = HEAP32[i3 + 4 >> 2] | 0;
        i10 = 32;
       }
      }
     }
    }
    L42 : do if ((i10 | 0) == 32) {
     i5 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i30, i2) | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     if (i3) if (__ZNK14SerializedFile11IsAvailableEx(i3, i9, i8) | 0) {
      i4 = HEAP32[i5 + 16 >> 2] | 0;
      L46 : do if (i4 | 0) {
       i3 = HEAP32[i4 >> 2] | 0;
       i10 = HEAP32[i4 + 12 >> 2] | 0;
       i4 = i3 + (i10 << 3) | 0;
       L48 : do if (i10) while (1) {
        i10 = i3;
        if ((HEAP32[i10 >> 2] | 0) == (i9 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i8 | 0) : 0) break L48;
        i3 = i3 + 8 | 0;
        if ((i3 | 0) == (i4 | 0)) break L46;
       } while (0);
       if ((i3 | 0) != (i4 | 0)) break L42;
      } while (0);
      i4 = HEAP32[i5 >> 2] | 0;
      if (i4) {
       HEAP32[i37 >> 2] = i2;
       HEAP32[i14 >> 2] = i1;
       i3 = i15;
       HEAP32[i3 >> 2] = i9;
       HEAP32[i3 + 4 >> 2] = i8;
       HEAP32[i29 >> 2] = HEAP32[i37 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
       HEAP32[i29 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
       HEAP32[i29 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
       i3 = __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib(i30, i4, i29, i11, 1) | 0;
       if (i3) {
        HEAP32[i20 >> 2] = i2;
        i5 = HEAP32[i3 + 8 >> 2] | 0;
        __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object(i4, i9, i8, 1, 1, i38, i39, i5);
        i3 = HEAP32[i38 >> 2] | 0;
        i4 = HEAP8[i39 >> 0] | 0;
        HEAP32[i35 >> 2] = i11;
        if ((HEAP32[i21 >> 2] | 0) == (HEAP32[i22 >> 2] | 0)) i2 = (HEAP32[i23 >> 2] | 0) + ((HEAP32[i24 >> 2] | 0) * 20 | 0) | 0; else {
         __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i29, i27, i35);
         i2 = HEAP32[i29 >> 2] | 0;
         i11 = HEAP32[i23 >> 2] | 0;
         i2 = (i2 | 0) == -1 ? i11 + ((HEAP32[i24 >> 2] | 0) * 20 | 0) | 0 : i11 + (i2 * 20 | 0) | 0;
        }
        i11 = HEAP32[i2 + 12 >> 2] | 0;
        mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0);
        HEAP32[i2 + 8 >> 2] = i3;
        HEAP8[i2 + 16 >> 0] = i4;
        HEAP8[i2 + 17 >> 0] = 1;
        HEAP32[i20 >> 2] = -1;
        if (HEAP32[i25 >> 2] | 0) {
         i2 = 0;
         do {
          i11 = HEAP32[i26 >> 2] | 0;
          mftCall_vii(HEAP32[i11 + (i2 << 3) >> 2] | 0, i5 | 0, HEAP32[i11 + (i2 << 3) + 4 >> 2] | 0);
          i2 = i2 + 1 | 0;
         } while (i2 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
        }
       }
      }
     }
    } while (0);
    if (i12) __Z12profiler_endP19ProfilerInformation(i12);
   }
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) < (i31 | 0));
 } while (0);
 __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i30);
 if ((HEAP32[i32 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i36 >> 2] | 0, i33);
  HEAP32[i36 >> 2] = 0;
 }
 STACKTOP = i40;
 return;
}

function __GLOBAL__sub_I_runtime_camera3_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112316 | 0, gb + 381825 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112328 | 0, gb + 381842 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112340 | 0, gb + 381866 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112352 | 0, gb + 381880 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112364 | 0, gb + 381911 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112376 | 0, gb + 381941 | 0, 0, 0);
 i3 = gb + 1098016 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[gb + 1112388 >> 2] = 0;
 HEAP32[gb + 1112388 + 4 >> 2] = 0;
 HEAP32[gb + 1112388 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112400 | 0, gb + 381989 | 0, 0, 0);
 _memset(gb + 1112412 | 0, 0, 256) | 0;
 HEAP32[gb + 1112276 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112276 | 0, gb + 387690 | 0);
 HEAP32[gb + 1112280 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112280 | 0, gb + 386536 | 0);
 HEAP32[gb + 1112284 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112284 | 0, gb + 386599 | 0);
 HEAP32[gb + 1112312 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112312 | 0, gb + 382012 | 0);
 HEAP32[gb + 1112292 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112292 | 0, gb + 386504 | 0);
 HEAP32[gb + 1112296 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112296 | 0, gb + 386514 | 0);
 HEAP32[gb + 1112300 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112300 | 0, gb + 386524 | 0);
 HEAP32[gb + 1112288 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112288 | 0, gb + 386564 | 0);
 HEAP32[gb + 1112304 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112304 | 0, gb + 382025 | 0);
 HEAP32[gb + 1112308 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112308 | 0, gb + 382044 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112668 | 0, gb + 382070 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112680 | 0, gb + 382117 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112692 | 0, gb + 382162 | 0, 0, 0);
 HEAP32[gb + 1112704 >> 2] = 0;
 i3 = gb + 63536 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1112704 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1112704 + 12 >> 2] = 16;
 i1 = gb + 1112704 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3327 | 0, fb + 3328 | 0, 0, gb + 1112704 | 0);
 HEAP32[gb + 1112784 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112784 | 0, gb + 382025 | 0);
 HEAP32[gb + 1112788 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1112788 | 0, gb + 382044 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112792 | 0, gb + 382176 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112804 | 0, gb + 382207 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112816 | 0, gb + 382243 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112828 | 0, gb + 382267 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112840 | 0, gb + 382301 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112852 | 0, gb + 382338 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112864 | 0, gb + 382381 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112876 | 0, gb + 382412 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112888 | 0, gb + 382449 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112900 | 0, gb + 382485 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112912 | 0, gb + 382517 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112924 | 0, gb + 382557 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112936 | 0, gb + 382589 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112948 | 0, gb + 382626 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112960 | 0, gb + 382668 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112972 | 0, gb + 382706 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112984 | 0, gb + 382749 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1112996 | 0, gb + 382815 | 0, 0, 0);
 HEAP32[gb + 1113008 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1113008 | 0, gb + 386599 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544219 | 0, 0, fb + 3329 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113012 | 0, gb + 382875 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113024 | 0, gb + 382898 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113036 | 0, gb + 382911 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113048 | 0, gb + 382935 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113060 | 0, gb + 382967 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113072 | 0, gb + 382990 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113084 | 0, gb + 383008 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113096 | 0, gb + 383031 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113108 | 0, gb + 383053 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113120 | 0, gb + 383074 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113132 | 0, gb + 383099 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1113144 | 0, gb + 383118 | 0, 0, 0);
 return;
}

function __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEvRT_RKS8_SB_j(i24, i20, i21, i11) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27 + 16 | 0;
 i26 = i27;
 i17 = i20 + 11 | 0;
 i23 = HEAP8[i17 >> 0] | 0;
 i2 = i23 << 24 >> 24 < 0;
 i18 = i20 + 4 | 0;
 switch ((i2 ? HEAP32[i18 >> 2] | 0 : i23 & 255) | 0) {
 case 1:
  {
   i19 = 2;
   break;
  }
 case 0:
  {
   STACKTOP = i27;
   return;
  }
 default:
  {}
 }
 if ((i19 | 0) == 2) {
  i23 = HEAP8[i21 + 11 >> 0] | 0;
  i5 = i23 << 24 >> 24 < 0;
  if (((i5 ? HEAP32[i21 + 4 >> 2] | 0 : i23 & 255) | 0) == 1) {
   i26 = HEAP8[i24 + 11 >> 0] | 0;
   i4 = i26 << 24 >> 24 < 0;
   i1 = i4 ? HEAP32[i24 >> 2] | 0 : i24;
   i26 = i4 ? HEAP32[i24 + 4 >> 2] | 0 : i26 & 255;
   i4 = i1 + i26 | 0;
   i3 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
   i2 = i5 ? HEAP32[i21 >> 2] | 0 : i21;
   if (!i26) {
    STACKTOP = i27;
    return;
   }
   do {
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0)) HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   STACKTOP = i27;
   return;
  }
 }
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i22 = i24 + 11 | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i23 = i24 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE7reserveEj(i26, i2 << 24 >> 24 < 0 ? HEAP32[i23 >> 2] | 0 : i2 & 255);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i26, i24, 0, i11) | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i10 = i3 ? HEAP32[i24 >> 2] | 0 : i24;
 i2 = i3 ? HEAP32[i23 >> 2] | 0 : i2 & 255;
 i3 = HEAP8[i17 >> 0] | 0;
 i16 = i3 << 24 >> 24 < 0;
 i8 = i16 ? HEAP32[i20 >> 2] | 0 : i20;
 i3 = i16 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
 L15 : do if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) i19 = 20; else {
  if (!i3) i1 = i11; else {
   i1 = i10 + i11 | 0;
   i9 = i10 + i2 | 0;
   i6 = i8 + i3 | 0;
   i7 = i9;
   L19 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
    i4 = i9 + (1 - i3) | 0;
    if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
     i5 = HEAP8[i8 >> 0] | 0;
     L22 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i8;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i7;
        break L19;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i6 | 0)) break L22;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i7;
       break L19;
      }
     }
    }
   } while (0);
   if ((i1 | 0) == (i9 | 0)) {
    i19 = 20;
    break;
   } else i1 = i1 - i10 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i26, i24, i11, i1 - i11 | 0) | 0;
  if ((i1 | 0) != -1) {
   i12 = i21 + 11 | 0;
   i13 = i21 + 4 | 0;
   i14 = i26 + 11 | 0;
   i15 = i26 + 8 | 0;
   i16 = i26 + 4 | 0;
   while (1) {
    i6 = HEAP8[i12 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i5 = i2 ? HEAP32[i21 >> 2] | 0 : i21;
    i6 = i2 ? HEAP32[i13 >> 2] | 0 : i6 & 255;
    i2 = HEAP8[i14 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) {
     i4 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
     i2 = HEAP32[i16 >> 2] | 0;
    } else {
     i4 = 10;
     i2 = i2 & 255;
    }
    if ((i4 - i2 | 0) >>> 0 < i6 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i26, i4, i6 - i4 + i2 | 0, i2, i2, 0, i6, i5); else if (i6 | 0) {
     i3 = i3 ? HEAP32[i26 >> 2] | 0 : i26;
     _memcpy(i3 + i2 | 0, i5 | 0, i6 | 0) | 0;
     i2 = i2 + i6 | 0;
     if ((HEAP8[i14 >> 0] | 0) < 0) HEAP32[i16 >> 2] = i2; else HEAP8[i14 >> 0] = i2;
     HEAP8[i3 + i2 >> 0] = 0;
    }
    i3 = HEAP8[i17 >> 0] | 0;
    i8 = i3 << 24 >> 24 < 0;
    i3 = i8 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
    i11 = i3 + i1 | 0;
    i2 = HEAP8[i22 >> 0] | 0;
    i9 = i2 << 24 >> 24 < 0;
    i10 = i9 ? HEAP32[i24 >> 2] | 0 : i24;
    i2 = i9 ? HEAP32[i23 >> 2] | 0 : i2 & 255;
    i8 = i8 ? HEAP32[i20 >> 2] | 0 : i20;
    if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) break;
    if (!i3) i1 = i11; else {
     i1 = i10 + i11 | 0;
     i9 = i10 + i2 | 0;
     i6 = i8 + i3 | 0;
     i7 = i9;
     L53 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
      i4 = i9 + (1 - i3) | 0;
      if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
       i5 = HEAP8[i8 >> 0] | 0;
       L56 : while (1) {
        while (1) {
         if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
          i2 = i8;
          i3 = i1;
          break;
         }
         i1 = i1 + 1 | 0;
         if ((i1 | 0) == (i4 | 0)) {
          i1 = i7;
          break L53;
         }
        }
        do {
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i6 | 0)) break L56;
         i3 = i3 + 1 | 0;
        } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i4 | 0)) {
         i1 = i7;
         break L53;
        }
       }
      }
     } while (0);
     if ((i1 | 0) == (i9 | 0)) break; else i1 = i1 - i10 | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i26, i24, i11, i1 - i11 | 0) | 0;
    if ((i1 | 0) == -1) break L15;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i26, i24, i11, ~i11) | 0;
  }
 } while (0);
 if ((i19 | 0) == 20) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i26, i24, i11, ~i11) | 0;
 i4 = i26 + 11 | 0;
 do if ((i26 | 0) != (i24 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i26 >> 2] | 0 : i26;
  i6 = i1 ? HEAP32[i26 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i22 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i24 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i23 = i2 ? HEAP32[i23 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i24, i3, i6 - i3 | 0, i23, 0, i23, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i22 >> 0] | 0) < 0) {
   HEAP32[i23 >> 2] = i6;
   break;
  } else {
   HEAP8[i22 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i24 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 12 >> 2] | 0;
  HEAP32[i25 >> 2] = 1;
  HEAP32[i25 + 4 >> 2] = i26;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i25);
 }
 STACKTOP = i27;
 return;
}

function __ZN5Umbra9intersectERKNS_4AABBERKNS_4QuadE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, i42 = 0, f43 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i34 + 72 | 0;
 i16 = i34 + 48 | 0;
 i17 = i34 + 24 | 0;
 i19 = i34;
 f2 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f29 = Math_fround(HEAPF32[i10 >> 2]);
 f26 = Math_fround(f2 - f29);
 f3 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f27 = Math_fround(f3 - f13);
 f5 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f28 = Math_fround(f5 - f14);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(f29 - f6);
 f7 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f32 = Math_fround(f13 - f7);
 f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f33 = Math_fround(f14 - f8);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i18 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2 | i18;
 i18 = i18 | (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
 i18 = i18 | (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
 i18 = i18 | (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 16;
 i18 = i18 | (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 32;
 i20 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i23 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i24 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i25 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 if (!i18) {
  i30 = 1;
  STACKTOP = i34;
  return i30 | 0;
 }
 f26 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f37 = Math_fround(f2 - f26);
 f27 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f4 = Math_fround(f3 - f27);
 f28 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f12 = Math_fround(f5 - f28);
 f31 = Math_fround(f26 - f6);
 f32 = Math_fround(f27 - f7);
 f33 = Math_fround(f28 - f8);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
 i30 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
 i36 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
 i11 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 16;
 i30 = i36 | i35 | i1 | i11 | i30 | (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 32;
 if (!i30) {
  i36 = 1;
  STACKTOP = i34;
  return i36 | 0;
 }
 f31 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f41 = Math_fround(f2 - f31);
 f32 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 f40 = Math_fround(f3 - f32);
 f33 = Math_fround(HEAPF32[i10 + 32 >> 2]);
 f39 = Math_fround(f5 - f33);
 f4 = Math_fround(f31 - f6);
 f12 = Math_fround(f32 - f7);
 f37 = Math_fround(f33 - f8);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i35 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
 i11 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
 i38 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
 i36 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 16;
 i11 = i38 | i1 | i35 | i36 | i11 | (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 32;
 if (!i11) {
  i38 = 1;
  STACKTOP = i34;
  return i38 | 0;
 }
 f12 = Math_fround(HEAPF32[i10 + 36 >> 2]);
 f43 = Math_fround(f2 - f12);
 f4 = Math_fround(HEAPF32[i10 + 40 >> 2]);
 f3 = Math_fround(f3 - f4);
 f2 = Math_fround(HEAPF32[i10 + 44 >> 2]);
 f37 = Math_fround(f5 - f2);
 f39 = Math_fround(f12 - f6);
 f40 = Math_fround(f4 - f7);
 f41 = Math_fround(f2 - f8);
 i35 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 i36 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 2;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 4;
 i42 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 8;
 i38 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 16;
 i1 = i42 | i35 | i36 | i38 | i1 | (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0) >> 31 & 32;
 if (!i1) {
  i42 = 1;
  STACKTOP = i34;
  return i42 | 0;
 }
 if (i30 & i18 & i11 & i1 | 0) {
  i42 = 0;
  STACKTOP = i34;
  return i42 | 0;
 }
 HEAPF32[i15 >> 2] = f29;
 HEAPF32[i15 + 4 >> 2] = f13;
 HEAPF32[i15 + 8 >> 2] = f14;
 HEAPF32[i15 + 12 >> 2] = f26;
 HEAPF32[i15 + 16 >> 2] = f27;
 HEAPF32[i15 + 20 >> 2] = f28;
 if (__ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE(i9, i15) | 0) {
  i42 = 1;
  STACKTOP = i34;
  return i42 | 0;
 }
 HEAPF32[i16 >> 2] = f26;
 HEAPF32[i16 + 4 >> 2] = f27;
 HEAPF32[i16 + 8 >> 2] = f28;
 HEAPF32[i16 + 12 >> 2] = f31;
 HEAPF32[i16 + 16 >> 2] = f32;
 HEAPF32[i16 + 20 >> 2] = f33;
 if (__ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE(i9, i16) | 0) {
  i42 = 1;
  STACKTOP = i34;
  return i42 | 0;
 }
 HEAPF32[i17 >> 2] = f31;
 HEAPF32[i17 + 4 >> 2] = f32;
 HEAPF32[i17 + 8 >> 2] = f33;
 HEAPF32[i17 + 12 >> 2] = f12;
 HEAPF32[i17 + 16 >> 2] = f4;
 HEAPF32[i17 + 20 >> 2] = f2;
 if (__ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE(i9, i17) | 0) {
  i42 = 1;
  STACKTOP = i34;
  return i42 | 0;
 }
 HEAPF32[i19 >> 2] = f12;
 HEAPF32[i19 + 4 >> 2] = f4;
 HEAPF32[i19 + 8 >> 2] = f2;
 HEAPF32[i19 + 12 >> 2] = f29;
 HEAPF32[i19 + 16 >> 2] = f13;
 HEAPF32[i19 + 20 >> 2] = f14;
 if (__ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE(i9, i19) | 0) {
  i42 = 1;
  STACKTOP = i34;
  return i42 | 0;
 }
 f26 = Math_fround(f26 - f29);
 f39 = Math_fround(f27 - f13);
 f28 = Math_fround(f28 - f14);
 f43 = Math_fround(f31 - f29);
 f37 = Math_fround(f32 - f13);
 f41 = Math_fround(f33 - f14);
 f40 = Math_fround(Math_fround(f39 * f41) - Math_fround(f28 * f37));
 f41 = Math_fround(Math_fround(f28 * f43) - Math_fround(f26 * f41));
 f43 = Math_fround(Math_fround(f26 * f37) - Math_fround(f39 * f43));
 i36 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
 i38 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
 i36 = (i36 | 0) > -1;
 i38 = (i38 | 0) > -1;
 i42 = ((HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0) | 0) > -1;
 HEAP32[i15 >> 2] = i36 ? i20 : i21;
 HEAP32[i15 + 4 >> 2] = i38 ? i22 : i23;
 HEAP32[i15 + 8 >> 2] = i42 ? i24 : i25;
 HEAP32[i15 + 12 >> 2] = i36 ? i21 : i20;
 HEAP32[i15 + 16 >> 2] = i38 ? i23 : i22;
 HEAP32[i15 + 20 >> 2] = i42 ? i25 : i24;
 i42 = __ZN5Umbra9intersectERKNS_11LineSegmentERKNS_4QuadE(i15, i10) | 0;
 STACKTOP = i34;
 return i42 | 0;
}

function __ZN5physx21PxcArticulationHelper18computeJointDrivesERNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPKNS_19PxsArticulationLinkEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEPKNS4_6Mat33VEf(i2, i18, i20, i1, i22, i21, f19) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 f19 = Math_fround(f19);
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i1 = HEAP16[i2 + 8 >> 1] | 0;
 i17 = i2 + 128 | 0;
 if ((i1 & 65535) <= 1) return;
 i14 = i1 & 65535;
 i16 = 1;
 do {
  i1 = HEAP32[i20 + (i16 << 5) + 28 >> 2] | 0;
  i15 = HEAP32[i20 + (i16 << 5) + 24 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i17 + (i16 << 5) + 24 >> 2]);
  f9 = Math_fround(HEAPF32[i17 + (i16 << 5) + 20 >> 2]);
  f11 = Math_fround(HEAPF32[i17 + (i16 << 5) + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i17 + (i1 << 5) + 24 >> 2]);
  f12 = Math_fround(HEAPF32[i17 + (i1 << 5) + 20 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i17 + (i1 << 5) + 16 >> 2]));
  f12 = Math_fround(f9 - f12);
  f13 = Math_fround(f10 - f13);
  i1 = i15 + 56 | 0;
  if (!(HEAP8[i15 + 121 >> 0] | 0)) {
   f23 = Math_fround(-Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 56 >> 2]));
   f7 = Math_fround(-Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 60 >> 2]));
   f4 = Math_fround(-Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 64 >> 2]));
   f26 = Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 68 >> 2]);
   f25 = Math_fround(HEAPF32[i15 + 68 >> 2]);
   f9 = Math_fround(f25 * f23);
   f24 = Math_fround(HEAPF32[i1 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f26 * f24));
   f10 = Math_fround(HEAPF32[i15 + 60 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f10 * f4));
   f6 = Math_fround(HEAPF32[i15 + 64 >> 2]);
   f9 = Math_fround(f9 - Math_fround(f6 * f7));
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f7) + Math_fround(f26 * f10)) + Math_fround(f6 * f23)) - Math_fround(f24 * f4));
   f5 = Math_fround(Math_fround(Math_fround(f24 * f7) + Math_fround(Math_fround(f25 * f4) + Math_fround(f26 * f6))) - Math_fround(f10 * f23));
   f4 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23)) - Math_fround(f10 * f7)) - Math_fround(f6 * f4));
   f6 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f5 * f5));
   f7 = Math_fround(Math_sqrt(Math_fround(f6)));
   if (+f7 < 1.0e-12) {
    i1 = 0;
    i2 = 0;
    i3 = 0;
   } else {
    if (f4 < Math_fround(0.0)) f10 = Math_fround(+Math_atan2(+Math_fround(-f7), +Math_fround(-f4))); else f10 = Math_fround(+Math_atan2(+f7, +f4));
    if (f6 > Math_fround(0.0)) {
     f4 = Math_fround(Math_fround(1.0) / f7);
     f6 = Math_fround(Math_fround(f5 * f4) * Math_fround(2.0));
     f5 = Math_fround(Math_fround(f8 * f4) * Math_fround(2.0));
     f4 = Math_fround(Math_fround(f9 * f4) * Math_fround(2.0));
    } else {
     f6 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     f4 = Math_fround(0.0);
    }
    f24 = Math_fround(f10 * f4);
    f25 = Math_fround(f10 * f5);
    f26 = Math_fround(f10 * f6);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i15 + 60 >> 2] | 0;
   i3 = HEAP32[i15 + 64 >> 2] | 0;
  }
  f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f4 = Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 12 >> 2]);
  f28 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
  f5 = Math_fround(HEAPF32[i22 + (i16 * 84 | 0) >> 2]);
  f25 = Math_fround(f8 * f5);
  f7 = Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 4 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f6 * f7));
  f24 = Math_fround(HEAPF32[i22 + (i16 * 84 | 0) + 8 >> 2]);
  f25 = Math_fround(f25 + Math_fround(f27 * f24));
  f9 = Math_fround(Math_fround(f5 * f25) + Math_fround(Math_fround(f8 * f28) + Math_fround(f4 * Math_fround(Math_fround(f27 * f7) - Math_fround(f6 * f24)))));
  f10 = Math_fround(Math_fround(f7 * f25) + Math_fround(Math_fround(f6 * f28) + Math_fround(f4 * Math_fround(Math_fround(f8 * f24) - Math_fround(f27 * f5)))));
  f25 = Math_fround(Math_fround(Math_fround(f27 * f28) + Math_fround(f4 * Math_fround(Math_fround(f6 * f5) - Math_fround(f8 * f7)))) + Math_fround(f24 * f25));
  f8 = Math_fround(Math_fround(HEAPF32[i15 + 72 >> 2]) * Math_fround(2.0));
  f6 = Math_fround(Math_fround(HEAPF32[i15 + 76 >> 2]) * Math_fround(2.0));
  f27 = Math_fround(Math_fround(HEAPF32[i15 + 80 >> 2]) * Math_fround(2.0));
  f26 = Math_fround(Math_fround(Math_fround(f5 * f8) + Math_fround(f7 * f6)) + Math_fround(f24 * f27));
  f11 = Math_fround(Math_fround(Math_fround(f5 * f26) + Math_fround(Math_fround(f28 * f8) + Math_fround(f4 * Math_fround(Math_fround(f7 * f27) - Math_fround(f24 * f6))))) - f11);
  f23 = Math_fround(Math_fround(Math_fround(f7 * f26) + Math_fround(Math_fround(f28 * f6) + Math_fround(f4 * Math_fround(Math_fround(f24 * f8) - Math_fround(f5 * f27))))) - f12);
  f26 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f4 * Math_fround(Math_fround(f5 * f6) - Math_fround(f7 * f8)))) + Math_fround(f24 * f26)) - f13);
  f24 = Math_fround(HEAPF32[i15 + 84 >> 2]);
  f13 = Math_fround(f24 * f9);
  f12 = Math_fround(f24 * f10);
  f25 = Math_fround(f24 * f25);
  f24 = Math_fround(HEAPF32[i15 + 88 >> 2]);
  f13 = Math_fround(Math_fround(f13 + Math_fround(f24 * f11)) * f19);
  f23 = Math_fround(Math_fround(f12 + Math_fround(f24 * f23)) * f19);
  f26 = Math_fround(Math_fround(f25 + Math_fround(f24 * f26)) * f19);
  f24 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i15 + 100 >> 2]));
  f13 = Math_fround(f24 * f13);
  f23 = Math_fround(f24 * f23);
  f26 = Math_fround(f24 * f26);
  f24 = Math_fround(Math_fround(HEAPF32[i21 + (i16 * 48 | 0) >> 2]) * f13);
  f24 = Math_fround(f24 + Math_fround(Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 16 >> 2]) * f23));
  f24 = Math_fround(Math_fround(Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 32 >> 2]) * f26) + f24);
  f25 = Math_fround(Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 4 >> 2]) * f13);
  f25 = Math_fround(f25 + Math_fround(Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 20 >> 2]) * f23));
  f25 = Math_fround(Math_fround(f26 * Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 36 >> 2])) + f25);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 8 >> 2]));
  f23 = Math_fround(f13 + Math_fround(f23 * Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 24 >> 2])));
  f26 = Math_fround(f23 + Math_fround(f26 * Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 40 >> 2])));
  HEAPF32[i18 + (i16 << 4) >> 2] = f24;
  HEAPF32[i18 + (i16 << 4) + 4 >> 2] = f25;
  HEAPF32[i18 + (i16 << 4) + 8 >> 2] = f26;
  HEAPF32[i18 + (i16 << 4) + 12 >> 2] = Math_fround(0.0);
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) != (i14 | 0));
 return;
}

function __ZN9Animation9CrossFadeER14AnimationStatefib(i27, i26, f16, i25, i24) {
 i27 = i27 | 0;
 i26 = i26 | 0;
 f16 = Math_fround(f16);
 i25 = i25 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, i34 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30;
 i29 = i30 + 4 | 0;
 i2 = HEAP32[i27 + 104 >> 2] | 0;
 i22 = i27 + 108 | 0;
 if ((i2 | 0) == (HEAP32[i22 >> 2] | 0)) i14 = 0; else {
  i9 = (i25 & 4 | 0) == 0;
  i10 = i26 + 32 | 0;
  i11 = f16 > Math_fround(.00100000005);
  i12 = +f16 > .001;
  i13 = i26 + 56 | 0;
  i14 = i26 + 24 | 0;
  i15 = i26 + 8 | 0;
  i17 = i26 + 76 | 0;
  i18 = i26 + 52 | 0;
  i19 = i26 + 52 | 0;
  i20 = i26 + 76 | 0;
  i21 = i26 + 48 | 0;
  i1 = 0;
  do {
   i6 = HEAP32[i2 >> 2] | 0;
   if (i9) {
    if ((HEAP32[i6 + 32 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) i23 = 8;
   } else i23 = 8;
   do if ((i23 | 0) == 8) {
    i23 = 0;
    if ((i6 | 0) != (i26 | 0)) {
     if (!i11) {
      i5 = i6 + 56 | 0;
      i3 = HEAP16[i5 >> 1] | 0;
      i4 = i3 | 64;
      if ((i3 & 10) == 10) {
       HEAP16[i5 >> 1] = i4;
       i3 = i4;
      }
      HEAP16[i5 >> 1] = i3 & -3;
      __ZN14AnimationState7SetTimeEf(i6, Math_fround(0.0));
      HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -6;
      HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
      break;
     }
     f7 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i6 + 8 >> 2]));
     f8 = Math_fround(f7 / f16);
     f7 = Math_fround(f7 * Math_fround(1.0e5));
     f7 = i12 ? f8 : f7;
     i4 = i6 + 56 | 0;
     i5 = HEAP16[i4 >> 1] | 0;
     if (!(i5 & 1)) i23 = 25; else {
      f8 = Math_fround(HEAPF32[i6 + 52 >> 2]);
      i3 = f8 < Math_fround(0.0);
      f31 = Math_fround(-f8);
      if (!((i3 ? f31 : f8) <= Math_fround(.0000999999974))) i23 = 25; else {
       i3 = i6 + 76 | 0;
       f8 = Math_fround(HEAPF32[i3 >> 2]);
       i34 = f8 < Math_fround(0.0);
       f33 = Math_fround(-f8);
       i32 = f7 < Math_fround(0.0);
       f31 = Math_fround(-f7);
       if ((i34 ? f33 : f8) > (i32 ? f31 : f7)) f7 = f8; else i23 = 25;
      }
     }
     if ((i23 | 0) == 25) {
      i23 = 0;
      i3 = i6 + 76 | 0;
      HEAPF32[i3 >> 2] = f7;
     }
     i34 = f7 < Math_fround(0.0);
     f33 = Math_fround(-f7);
     if ((i34 ? f33 : f7) <= Math_fround(.0000999999974)) HEAPF32[i3 >> 2] = Math_fround(1.0e5);
     HEAPF32[i6 + 52 >> 2] = Math_fround(0.0);
     HEAP16[i4 >> 1] = i5 & -38 | 5;
     break;
    }
    i1 = HEAP16[i13 >> 1] | 0;
    if (!(i1 & 2)) {
     HEAPF64[i14 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
     i1 = HEAP16[i13 >> 1] | 0;
    }
    i3 = i1 | 2;
    HEAP16[i13 >> 1] = i3;
    if (i11) {
     f7 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i15 >> 2]));
     f33 = Math_fround(f7 / f16);
     f7 = Math_fround(f7 * Math_fround(1.0e5));
     f7 = i12 ? f33 : f7;
     if (!(i1 & 1)) i23 = 15; else {
      f33 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + Math_fround(-1.0));
      i34 = f33 < Math_fround(0.0);
      f31 = Math_fround(-f33);
      if (!((i34 ? f31 : f33) <= Math_fround(.0000999999974))) i23 = 15; else {
       f8 = Math_fround(HEAPF32[i20 >> 2]);
       i32 = f8 < Math_fround(0.0);
       f31 = Math_fround(-f8);
       i34 = f7 < Math_fround(0.0);
       f33 = Math_fround(-f7);
       if ((i32 ? f31 : f8) > (i34 ? f33 : f7)) {
        i1 = i20;
        f7 = f8;
       } else i23 = 15;
      }
     }
     if ((i23 | 0) == 15) {
      i23 = 0;
      HEAPF32[i17 >> 2] = f7;
      i1 = i17;
     }
     i34 = f7 < Math_fround(0.0);
     f33 = Math_fround(-f7);
     if ((i34 ? f33 : f7) <= Math_fround(.0000999999974)) HEAPF32[i1 >> 2] = Math_fround(1.0e5);
     HEAPF32[i18 >> 2] = Math_fround(1.0);
     i1 = i3 & -38 | 1;
    } else {
     HEAPF32[i15 >> 2] = Math_fround(1.0);
     i1 = i3 & -38;
    }
    HEAP16[i13 >> 1] = i1;
    HEAPF32[i21 >> 2] = f16;
    i1 = 1;
   } while (0);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i22 >> 2] | 0));
  i14 = i1;
 }
 L45 : do if (i24) {
  i12 = i27 + 316 | 0;
  i13 = i27 + 320 | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  if ((i3 | 0) != (i1 | 0)) {
   i10 = (i25 & 4 | 0) == 0;
   i11 = i26 + 32 | 0;
   i9 = 0;
   i5 = i2;
   i6 = i1;
   i1 = i2;
   while (1) {
    if (i10) {
     i2 = i5;
     i4 = i6;
    } else break;
    while (1) {
     if ((HEAP32[(HEAP32[i1 + (i9 << 4) + 12 >> 2] | 0) + 32 >> 2] | 0) != (HEAP32[i11 >> 2] | 0)) break;
     i3 = HEAP32[i2 + (i9 << 4) + 12 >> 2] | 0;
     i4 = i3 + 56 | 0;
     i1 = HEAP16[i4 >> 1] | 0;
     i2 = i1 | 64;
     if ((i1 & 10) == 10) {
      HEAP16[i4 >> 1] = i2;
      i1 = i2;
     }
     HEAP16[i4 >> 1] = i1 & -3;
     __ZN14AnimationState7SetTimeEf(i3, Math_fround(0.0));
     HEAP16[i4 >> 1] = HEAP16[i4 >> 1] & -6;
     i4 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (i9 << 4) + 12 >> 2] | 0) + 56 | 0;
     HEAP16[i4 >> 1] = HEAP16[i4 >> 1] | 72;
     i4 = (HEAP32[i12 >> 2] | 0) + (i9 << 4) | 0;
     i1 = i4 + 16 | 0;
     i3 = HEAP32[i13 >> 2] | 0;
     i2 = i3 - i1 | 0;
     i5 = i2 >> 4;
     if (!i5) i2 = i3; else {
      _memmove(i4 | 0, i1 | 0, i2 | 0) | 0;
      i3 = HEAP32[i13 >> 2] | 0;
      i2 = i3;
     }
     i1 = i4 + (i5 << 4) | 0;
     if ((i2 | 0) != (i1 | 0)) {
      i3 = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4) | 0;
      HEAP32[i13 >> 2] = i3;
     }
     i4 = HEAP32[i12 >> 2] | 0;
     i2 = i4;
     if (i9 >>> 0 < i3 - i4 >> 4 >>> 0) i1 = i2; else break L45;
    }
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= i3 - i4 >> 4 >>> 0) break L45; else {
     i5 = i2;
     i6 = i4;
     i1 = i4;
    }
   }
   do {
    i3 = HEAP32[i1 + 12 >> 2] | 0;
    i4 = i3 + 56 | 0;
    i1 = HEAP16[i4 >> 1] | 0;
    i2 = i1 | 64;
    if ((i1 & 10) == 10) {
     HEAP16[i4 >> 1] = i2;
     i1 = i2;
    }
    HEAP16[i4 >> 1] = i1 & -3;
    __ZN14AnimationState7SetTimeEf(i3, Math_fround(0.0));
    HEAP16[i4 >> 1] = HEAP16[i4 >> 1] & -6;
    i5 = (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + 56 | 0;
    HEAP16[i5 >> 1] = HEAP16[i5 >> 1] | 72;
    i5 = HEAP32[i12 >> 2] | 0;
    i1 = i5 + 16 | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3 - i1 | 0;
    i6 = i2 >> 4;
    if (!i6) {
     i4 = i3;
     i2 = i3;
    } else {
     _memmove(i5 | 0, i1 | 0, i2 | 0) | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     i4 = i2;
    }
    i1 = i5 + (i6 << 4) | 0;
    if ((i4 | 0) != (i1 | 0)) {
     i2 = i4 + (~((i4 + -16 - i1 | 0) >>> 4) << 4) | 0;
     HEAP32[i13 >> 2] = i2;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
 } while (0);
 if (i14) {
  STACKTOP = i30;
  return;
 }
 i2 = HEAP32[gb + 176232 >> 2] | 0;
 i1 = i26 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i28 >> 2] = i1;
 __Z6FormatPKcz(i29, i2, i28);
 if (!i27) i1 = 0; else i1 = HEAP32[i27 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i29 + 11 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29, 0, gb + 896407 | 0, 519, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
 STACKTOP = i30;
 return;
}

function __ZN19CloudServiceHandler17InitServiceFolderENS_13InitModeFlagsE(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i10 = i15 + 56 | 0;
 i13 = i15 + 40 | 0;
 i11 = i15 + 28 | 0;
 __Z40GetPersistentDataPathApplicationSpecificv(i11);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i13 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i13;
   i8 = i2;
  } else {
   i1 = i13;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i4;
  i2 = i13 + 11 | 0;
  i5 = 6;
 }
 if ((i5 | 0) == 6) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i8 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i1 = HEAP8[i8 >> 0] | 0;
 i6 = i13 + 4 | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i1 & 255) | 0)) {
  __Z40GetTemporaryCachePathApplicationSpecificv(i10);
  i5 = HEAP8[i10 + 11 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
  i5 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i8 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i7 = i2 ? HEAP32[i6 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i13, i3, i5 - i3 | 0, i7, 0, i7, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i13 >> 2] | 0 : i13;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i6 >> 2] = i5;
    break;
   } else {
    HEAP8[i8 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 i3 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 i4 = i12 + 20 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i14 >> 2] = i1 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i13;
 HEAP32[i14 + 4 >> 2] = 47;
 HEAP32[i14 + 8 >> 2] = gb + 1047115;
 HEAP32[i14 + 12 >> 2] = 47;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 47;
 HEAP32[i14 + 24 >> 2] = i4;
 __Z6FormatPKcz(i10, gb + 1047100 | 0, i14);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 i7 = i3 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i12 + 44 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i12 + 40 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i12 + 40 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (i9 & 2 | 0) {
  if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
  __Z29DeleteFileOrDirectoryIfExistsPKcb(i1, 1) | 0;
 }
 i2 = i12 + 52 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i12 + 40 >> 2] | 0;
 } else i1 = i1 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i3, i1);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1047121 | 0, 14);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i14, i10, i11);
 i6 = HEAP8[i14 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i14 >> 2] | 0 : i14;
 i6 = i7 ? HEAP32[i14 + 4 >> 2] | 0 : i6 & 255;
 i7 = i2 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i12 + 60 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i3) i1 = HEAP32[i12 + 56 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i12 + 56 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (i9 & 1 | 0) {
  if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
  __Z29DeleteFileOrDirectoryIfExistsPKcb(i1, 1) | 0;
 }
 i1 = HEAP8[i7 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i12 + 56 >> 2] | 0;
 } else {
  i3 = i2;
  i1 = i1 & 255;
 };
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i3, i1);
 i11 = __Z13IsPathCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 if (!i11) {
  i1 = HEAP8[i7 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i12 + 56 >> 2] | 0;
  } else i1 = i1 & 255;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i2, i1);
  __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 }
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i15;
  return;
 }
 i12 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = 66;
 HEAP32[i14 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i14);
 STACKTOP = i15;
 return;
}

function __ZN9ShaderLab18SerializedProperty8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i7 = i12;
 i8 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034561 | 0, i8, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i10, 1); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471828 | 0, i8, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i2, 1); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471842 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab18SerializedProperty22SerializedPropertyTypeEEvRT_RT0_PKc17TransferMetaFlags(i11, i10 + 44 | 0, gb + 913271 | 0, 0);
 i4 = i10 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471855 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i6 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 52 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471863 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 35; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i6 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471877 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i2 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 46; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i6 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471891 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i6 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471905 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 68; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i6 = 68; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 68) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471919 | 0, gb + 471932 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 471958 | 0, i8, i9, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i2, 1); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i11);
  }
  __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16TextureDimensionEvRT_RT0_PKc17TransferMetaFlags(i11, i10 + 84 | 0, gb + 471972 | 0, 0);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 4 | 0;
 i10 = i13;
 i4 = i5 + 88 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i2 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 7; else {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) i12 = 9;
   }
  }
  if ((i12 | 0) == 7) i12 = 9;
  if ((i12 | 0) == 9) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i5 = i5 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i3 = HEAP32[i9 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i12 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 19;
   }
  }
  if ((i12 | 0) == 17) i12 = 19;
  if ((i12 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 if ((i2 | 0) != 0 & (i1 | 0) == 0) {
  i5 = __ZNK13TextRendering4Font11GetMaterialEv(i2) | 0;
  if (!i5) {
   i1 = 0;
   i3 = 0;
   i8 = 1;
   i12 = 33;
  } else {
   HEAP32[i10 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 28; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i8 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i12 = 28; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 30;
    }
   }
   if ((i12 | 0) == 28) i12 = 30;
   if ((i12 | 0) == 30) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   i12 = 32;
  }
 } else i12 = 32;
 if ((i12 | 0) == 32) {
  i3 = (i2 | 0) == 0;
  i4 = (i1 | 0) == 0;
  if (i3 | i4) {
   i8 = i4;
   i12 = 33;
  }
 }
 if ((i12 | 0) == 33) {
  i4 = HEAP32[gb + 1467944 >> 2] | 0;
  L50 : do if (!i4) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1017543 | 0, 9);
   i4 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i9) | 0;
   HEAP32[gb + 1467944 >> 2] = i4;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i4 = HEAP32[gb + 1467944 >> 2] | 0;
   if (!i4) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 946264 | 0, 0, gb + 946292 | 0, 204, 4, 0, 0, 0);
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    STACKTOP = i13;
    return;
   }
   i7 = __ZNK13TextRendering4Font11GetMaterialEv(i4) | 0;
   do if (i7 | 0) {
    HEAP32[i10 >> 2] = i7;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i4) i12 = 42; else {
     if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
      i5 = HEAP32[i4 + 28 >> 2] | 0;
      i6 = HEAP32[i4 + 32 >> 2] | 0;
      i4 = i5 + (i6 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i4, i10);
      i5 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i4 + 28 >> 2] | 0;
      i6 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i5 | 0) == -1 ? i14 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i14 + (i5 << 3) | 0;
      i5 = HEAP32[i6 + 28 >> 2] | 0;
      i6 = HEAP32[i6 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i12 = 42; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 44;
    }
    if ((i12 | 0) == 42) i12 = 44;
    if ((i12 | 0) == 44) if (!(__Z31ReadObjectFromPersistentManageri(i7) | 0)) break;
    i4 = HEAP32[gb + 1467944 >> 2] | 0;
    break L50;
   } while (0);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 946366 | 0, 0, gb + 946292 | 0, 209, 4, 0, 0, 0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   STACKTOP = i13;
   return;
  } while (0);
  i2 = i3 ? i4 : i2;
  if (i8) {
   i5 = __ZNK13TextRendering4Font11GetMaterialEv(i4) | 0;
   if (!i5) i1 = 0; else {
    HEAP32[i10 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 54; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i12 = 54; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 56;
     }
    }
    if ((i12 | 0) == 54) i12 = 56;
    if ((i12 | 0) == 56) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   }
  }
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __Z17SetupVertexLightsRKNSt3__26vectorIP5LightNS_9allocatorIS2_EEEER17ShaderPassContext(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 i7 = i8 + 16 | 0;
 i10 = __Z12GetGfxDevicev() | 0;
 __ZNK14RenderSettings23GetFFAmbientDeviceColorEv(i9, __Z17GetRenderSettingsv() | 0);
 i10 = i10 + 532 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i10 = HEAP32[gb + 1162364 >> 2] | 0;
 i9 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 i4 = HEAP32[gb + 62548 >> 2] | 0;
 i3 = HEAP32[gb + 62548 + 4 >> 2] | 0;
 i5 = HEAP32[gb + 62548 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = i10;
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 16 >> 2] = i4;
 HEAP32[i7 + 20 >> 2] = i3;
 HEAP32[i7 + 24 >> 2] = i5;
 HEAPF32[i7 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 56 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 60 >> 2] = 1;
 HEAP32[i7 + 64 >> 2] = i10;
 HEAP32[i7 + 68 >> 2] = i9;
 HEAP32[i7 + 72 >> 2] = i2;
 HEAPF32[i7 + 76 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 80 >> 2] = i4;
 HEAP32[i7 + 84 >> 2] = i3;
 HEAP32[i7 + 88 >> 2] = i5;
 HEAPF32[i7 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 116 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 120 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 124 >> 2] = 1;
 HEAP32[i7 + 128 >> 2] = i10;
 HEAP32[i7 + 132 >> 2] = i9;
 HEAP32[i7 + 136 >> 2] = i2;
 HEAPF32[i7 + 140 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 144 >> 2] = i4;
 HEAP32[i7 + 148 >> 2] = i3;
 HEAP32[i7 + 152 >> 2] = i5;
 HEAPF32[i7 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 184 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 188 >> 2] = 1;
 HEAP32[i7 + 192 >> 2] = i10;
 HEAP32[i7 + 196 >> 2] = i9;
 HEAP32[i7 + 200 >> 2] = i2;
 HEAPF32[i7 + 204 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 208 >> 2] = i4;
 HEAP32[i7 + 212 >> 2] = i3;
 HEAP32[i7 + 216 >> 2] = i5;
 HEAPF32[i7 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 228 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 248 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 252 >> 2] = 1;
 HEAP32[i7 + 256 >> 2] = i10;
 HEAP32[i7 + 260 >> 2] = i9;
 HEAP32[i7 + 264 >> 2] = i2;
 HEAPF32[i7 + 268 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 272 >> 2] = i4;
 HEAP32[i7 + 276 >> 2] = i3;
 HEAP32[i7 + 280 >> 2] = i5;
 HEAPF32[i7 + 284 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 296 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 300 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 304 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 308 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 312 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 316 >> 2] = 1;
 HEAP32[i7 + 320 >> 2] = i10;
 HEAP32[i7 + 324 >> 2] = i9;
 HEAP32[i7 + 328 >> 2] = i2;
 HEAPF32[i7 + 332 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 336 >> 2] = i4;
 HEAP32[i7 + 340 >> 2] = i3;
 HEAP32[i7 + 344 >> 2] = i5;
 HEAPF32[i7 + 348 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 360 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 368 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 372 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 376 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 380 >> 2] = 1;
 HEAP32[i7 + 384 >> 2] = i10;
 HEAP32[i7 + 388 >> 2] = i9;
 HEAP32[i7 + 392 >> 2] = i2;
 HEAPF32[i7 + 396 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 400 >> 2] = i4;
 HEAP32[i7 + 404 >> 2] = i3;
 HEAP32[i7 + 408 >> 2] = i5;
 HEAPF32[i7 + 412 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 416 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 420 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 424 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 428 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 432 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 436 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 440 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 444 >> 2] = 1;
 HEAP32[i7 + 448 >> 2] = i10;
 HEAP32[i7 + 452 >> 2] = i9;
 HEAP32[i7 + 456 >> 2] = i2;
 HEAPF32[i7 + 460 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 464 >> 2] = i4;
 HEAP32[i7 + 468 >> 2] = i3;
 HEAP32[i7 + 472 >> 2] = i5;
 HEAPF32[i7 + 476 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 480 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 484 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 488 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 492 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 496 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 500 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 504 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 508 >> 2] = 1;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) - i5 | 0;
 i4 = i3 >> 2;
 if ((i3 | 0) > 0) {
  i3 = 0;
  i1 = 0;
 } else {
  i10 = 0;
  __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(i10, i7, i6);
  STACKTOP = i8;
  return;
 }
 while (1) {
  i2 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
  if (i2) {
   i11 = i7 + (i1 << 6) | 0;
   i10 = HEAP32[i2 + 44 >> 2] | 0;
   i9 = i10 + 124 | 0;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
   i11 = HEAP32[i10 + 160 >> 2] | 0;
   i9 = HEAP32[i10 + 164 >> 2] | 0;
   i2 = HEAP32[i10 + 168 >> 2] | 0;
   HEAP32[i7 + (i1 << 6) + 32 >> 2] = HEAP32[i10 + 156 >> 2];
   HEAP32[i7 + (i1 << 6) + 36 >> 2] = i11;
   HEAP32[i7 + (i1 << 6) + 40 >> 2] = i9;
   HEAP32[i7 + (i1 << 6) + 44 >> 2] = i2;
   i2 = i7 + (i1 << 6) + 48 | 0;
   i10 = i10 + 172 | 0;
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i2 = i1 + 1 | 0;
   if ((i1 | 0) > 6) {
    i1 = i2;
    i2 = 5;
    break;
   } else i1 = i2;
  }
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (i4 | 0)) {
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) {
  __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(i1, i7, i6);
  STACKTOP = i8;
  return;
 }
}

function __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i18, i16, i20, i1) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0;
 i17 = i1 & 1;
 i19 = (i17 | 0) != 0;
 L1 : do if (!(i1 & 2)) {
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i3 = HEAP32[i18 + 16 >> 2] | 0;
  if ((i1 | 0) < (i3 | 0)) {
   i7 = HEAP32[i18 + 32 >> 2] | 0;
   i8 = HEAP32[i16 >> 2] | 0;
   while (1) {
    if ((HEAP32[i7 + (i1 << 2) >> 2] | 0) == (i8 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) break L1;
   }
   if ((i1 | 0) >= 0) {
    i1 = (HEAP32[i18 + 52 >> 2] | 0) + (i1 << 2) | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (i19) {
     i19 = i3 | 1073741824;
     HEAP32[i1 >> 2] = i19;
     i1 = i19;
    } else i1 = i3;
    i8 = (HEAP32[i18 + 72 >> 2] | 0) + (i3 & 1048575) | 0;
    if (!(i1 & 1073741824)) {
     HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
     return;
    }
    f2 = Math_fround(HEAPF32[i20 >> 2]);
    i1 = HEAP32[i20 + 4 >> 2] | 0;
    i3 = HEAP32[i20 + 8 >> 2] | 0;
    i7 = HEAP32[i20 + 12 >> 2] | 0;
    do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
     do if (!(f2 <= Math_fround(.0404499993))) {
      if (f2 < Math_fround(1.0)) {
       f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f2 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f2, 2.20000005));
     } else f4 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
     f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     do if (!(f2 <= Math_fround(.0404499993))) {
      if (f2 < Math_fround(1.0)) {
       f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
       break;
      }
      if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
     } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
     f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f5 <= Math_fround(.0404499993)) {
      f6 = f4;
      f4 = f2;
      f2 = Math_fround(f5 / Math_fround(12.9200001));
      break;
     }
     if (f5 < Math_fround(1.0)) {
      f6 = f4;
      f4 = f2;
      f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f5 == Math_fround(1.0)) {
      f6 = f4;
      f4 = f2;
      f2 = Math_fround(1.0);
     } else {
      f6 = f4;
      f4 = f2;
      f2 = Math_fround(+Math_pow(+f5, 2.20000005));
     }
    } else {
     f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f6 = f2;
     f2 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    } while (0);
    HEAPF32[i8 >> 2] = f6;
    HEAPF32[i8 + 4 >> 2] = f4;
    HEAPF32[i8 + 8 >> 2] = f2;
    HEAP32[i8 + 12 >> 2] = i7;
    return;
   }
  }
 } while (0);
 i13 = i18 + 72 | 0;
 i14 = i18 + 84 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i3 = i18 + 112 | 0;
 i7 = i18 + 124 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i10 = i18 + 128 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i11 & 2147483647;
 do if (i9 >>> 0 > i12 >>> 0) {
  i1 = i11 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i12 >>> 0 < i1 >>> 0) if ((i11 | 0) > -1) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 12 | 0, 4, i18 + 116 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i18 + 116 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i3 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + (i8 * 12 | 0) >> 2] = 1;
 HEAP32[i1 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + (i8 * 12 | 0) + 8 >> 2] = i15 | i17 << 30;
 i1 = i15 + 16 | 0;
 HEAP32[i14 >> 2] = i1;
 i3 = i18 + 88 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 do if ((i7 & 2147483647) >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 4, i18 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i13 >> 2] = i1;
  break;
 } else {
  i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i18 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i18 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = i18;
  i1 = i18;
  break;
 } else i1 = HEAP32[i18 + 72 >> 2] | 0; while (0);
 i8 = i1 + i15 | 0;
 if (!i19) {
  HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  return;
 }
 f2 = Math_fround(HEAPF32[i20 >> 2]);
 i1 = HEAP32[i20 + 4 >> 2] | 0;
 i3 = HEAP32[i20 + 8 >> 2] | 0;
 i7 = HEAP32[i20 + 12 >> 2] | 0;
 do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f4 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f5 <= Math_fround(.0404499993)) {
   f6 = f4;
   f4 = f2;
   f2 = Math_fround(f5 / Math_fround(12.9200001));
   break;
  }
  if (f5 < Math_fround(1.0)) {
   f6 = f4;
   f4 = f2;
   f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f5 == Math_fround(1.0)) {
   f6 = f4;
   f4 = f2;
   f2 = Math_fround(1.0);
  } else {
   f6 = f4;
   f4 = f2;
   f2 = Math_fround(+Math_pow(+f5, 2.20000005));
  }
 } else {
  f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = f2;
  f2 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while (0);
 HEAPF32[i8 >> 2] = f6;
 HEAPF32[i8 + 4 >> 2] = f4;
 HEAPF32[i8 + 8 >> 2] = f2;
 HEAP32[i8 + 12 >> 2] = i7;
 return;
}

function __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_(i9, i10, i7, i6, i4, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_(i9, i10, i7, i6, i1) | 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 i3 = i6 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i11 = i8;
    STACKTOP = i12;
    return i11 | 0;
   }
   i2 = i4 + 16 | 0;
   i13 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = i6 + 16 | 0;
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (!((i13 | 0) < (i1 | 0) | ((i13 | 0) == (i1 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0))) {
    i13 = i8;
    STACKTOP = i12;
    return i13 | 0;
   }
  }
 } else if ((i2 | 0) >= (i1 | 0)) {
  i13 = i8;
  STACKTOP = i12;
  return i13 | 0;
 };
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 i4 = i8 + 1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i13 = i4;
    STACKTOP = i12;
    return i13 | 0;
   }
   i3 = i6 + 16 | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i13 = i7 + 16 | 0;
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   if (!((i1 | 0) < (i2 | 0) | ((i1 | 0) == (i2 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
    i13 = i4;
    STACKTOP = i12;
    return i13 | 0;
   }
  }
 } else if ((i1 | 0) >= (i2 | 0)) {
  i13 = i4;
  STACKTOP = i12;
  return i13 | 0;
 };
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 i3 = i8 + 2 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i10 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = HEAP32[i10 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i13 = i3;
    STACKTOP = i12;
    return i13 | 0;
   }
   i6 = i7 + 16 | 0;
   i2 = HEAP32[i6 + 4 >> 2] | 0;
   i13 = i10 + 16 | 0;
   i5 = HEAP32[i13 + 4 >> 2] | 0;
   if (!((i2 | 0) < (i5 | 0) | ((i2 | 0) == (i5 | 0) ? (HEAP32[i6 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
    i13 = i3;
    STACKTOP = i12;
    return i13 | 0;
   }
  }
 } else if ((i1 | 0) >= (i2 | 0)) {
  i13 = i3;
  STACKTOP = i12;
  return i13 | 0;
 };
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 i3 = i8 + 3 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i9 + 24 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i10 + 8 >> 2] | 0;
  i2 = HEAP32[i9 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i13 = i3;
    STACKTOP = i12;
    return i13 | 0;
   }
   i7 = i10 + 16 | 0;
   i5 = HEAP32[i7 + 4 >> 2] | 0;
   i13 = i9 + 16 | 0;
   i6 = HEAP32[i13 + 4 >> 2] | 0;
   if (!((i5 | 0) < (i6 | 0) | ((i5 | 0) == (i6 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) {
    i13 = i3;
    STACKTOP = i12;
    return i13 | 0;
   }
  }
 } else if ((i1 | 0) >= (i2 | 0)) {
  i13 = i3;
  STACKTOP = i12;
  return i13 | 0;
 };
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 i13 = i8 + 4 | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER9TransformR13dynamic_arrayI20BoundCurveDeprecatedLj4EERNS3_6vectorIPSF_S6_ISM_LSA_25ELi16EEEERi(i13, i14, i15, i16, i17, i18) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 24 | 0;
 i20 = i24 + 8 | 0;
 i21 = i24 + 4 | 0;
 i22 = i24;
 i4 = (HEAP32[i14 + 68 >> 2] | 0) - (HEAP32[i14 + 4 >> 2] | 0) | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 i1 = i16 + 12 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i16 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i4 * 24 | 0, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 24 | 0, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i16 >> 2] = i12;
  break;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  i3 = (HEAP32[i16 >> 2] | 0) + (i5 * 24 | 0) | 0;
  i2 = i4 - i5 | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    i12 = i3 + (i1 * 24 | 0) | 0;
    HEAP32[i12 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = i17 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 HEAP32[i18 >> 2] = 0;
 __ZL27ClearTransformTemporaryFlagR9Transform(i15);
 i9 = i14 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i14 + 64 | 0;
 i1 = i2 + ((HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i20 >> 2] = i14;
 i3 = i20 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 i2 = i20 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i20);
 i1 = HEAP32[i20 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = (HEAP32[i9 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i20 >> 2] = i14;
 i11 = i20 + 4 | 0;
 HEAP32[i11 >> 2] = i8;
 i12 = i20 + 8 | 0;
 HEAP32[i12 >> 2] = i8;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i20);
 if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) {
  __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE(i15, i17);
  STACKTOP = i24;
  return;
 }
 i7 = i19 + 4 | 0;
 i8 = i19 + 8 | 0;
 do {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i3 + 24;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i19);
  i6 = HEAP32[i3 + 20 >> 2] | 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i1 = i15;
   i23 = 15;
  } else {
   i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i15, i1, 0) | 0;
   if (!i1) HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 * 24 | 0) + 4 >> 2] = 0; else i23 = 15;
  }
  L23 : do if ((i23 | 0) == 15) {
   i23 = 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = i3 + 4 | 0;
   L25 : do switch (HEAP32[i4 >> 2] | 0) {
   case 1:
    {
     HEAP32[i20 >> 2] = i2;
     i5 = 1;
     i1 = i2;
     i23 = 23;
     break;
    }
   case 4:
    {
     HEAP32[i20 >> 2] = i1;
     i5 = 4;
     i23 = 23;
     break;
    }
   case 21:
    {
     i1 = __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(i2, 25, HEAP32[i3 + 12 >> 2] | 0) | 0;
     HEAP32[i20 >> 2] = i1;
     if (!i1) {
      HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 * 24 | 0) + 4 >> 2] = 0;
      break L23;
     } else {
      i5 = HEAP32[i4 >> 2] | 0;
      i23 = 23;
      break L25;
     }
    }
   default:
    if (!(__Z21BindGenericFloatCurveRK7CurveIDRP6ObjectP10GameObjectP9TransformRPvRiRN11UnityEngine9Animation10BoundCurveE(i3, i20, 0, i1, i21, i22, (HEAP32[i16 >> 2] | 0) + (i6 * 24 | 0) | 0) | 0)) {
     HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 * 24 | 0) + 4 >> 2] = 0;
     break L23;
    }
   } while (0);
   if ((i23 | 0) == 23) {
    i23 = 0;
    if (!(__ZN15AnimationBinder18CalculateTargetPtrEiP6ObjectPKcPPvPi(i13, i5, i1, HEAP32[i3 + 8 >> 2] | 0, i21, i22) | 0)) {
     HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 * 24 | 0) + 4 >> 2] = 0;
     break;
    }
   }
   if ((HEAP32[i4 >> 2] | 0) == 4) {
    i1 = HEAP32[i20 >> 2] | 0;
    i2 = i1 + 8 | 0;
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 4096;
    i2 = HEAP32[i18 >> 2] | 0;
    do if (!(i2 & 2)) {
     i2 = i3 + 8 | 0;
     if (!(__Z10BeginsWithPKcS0_(HEAP32[i2 >> 2] | 0, gb + 896768 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_(HEAP32[i2 >> 2] | 0, gb + 896784 | 0) | 0)) {
      i2 = HEAP32[i18 >> 2] | 0;
      break;
     }
     i2 = HEAP32[i18 >> 2] | 2;
     HEAP32[i18 >> 2] = i2;
    } while (0);
    if (!(i2 & 1)) {
     i5 = __Z10BeginsWithPKcS0_(HEAP32[i3 + 8 >> 2] | 0, gb + 896797 | 0) | 0;
     i2 = HEAP32[i18 >> 2] | 0;
     if (i5) {
      i2 = i2 | 1;
      HEAP32[i18 >> 2] = i2;
     }
    }
    if (!(i2 & 8)) if (__Z10BeginsWithPKcS0_(HEAP32[i3 + 8 >> 2] | 0, gb + 896813 | 0) | 0) HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 8;
   } else i1 = HEAP32[i20 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   HEAP32[i5 + (i6 * 24 | 0) >> 2] = HEAP32[i21 >> 2];
   HEAP32[i5 + (i6 * 24 | 0) + 4 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i5 + (i6 * 24 | 0) + 12 >> 2] = i1;
   HEAP32[i5 + (i6 * 24 | 0) + 16 >> 2] = HEAP32[i1 + 4 >> 2];
  } while (0);
  i1 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i6 = (HEAP32[i9 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i20 >> 2] = i14;
  HEAP32[i11 >> 2] = i6;
  HEAP32[i12 >> 2] = i6;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i20);
 } while ((i3 | 0) != (HEAP32[i11 >> 2] | 0));
 __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE(i15, i17);
 STACKTOP = i24;
 return;
}

function __ZN5physx2Sq8AABBTree11refitMarkedEjPKNS_9PxBounds3EPj(i12, i1, i23, i24) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 5264 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 80 | 0;
 i26 = i28 + 64 | 0;
 i14 = i28 + 100 | 0;
 i27 = i28 + 96 | 0;
 i22 = i28 + 48 | 0;
 i21 = i28 + 32 | 0;
 i16 = i28 + 16 | 0;
 i15 = i28;
 i8 = i28 + 5224 | 0;
 i6 = i28 + 1128 | 0;
 i7 = i28 + 104 | 0;
 i13 = i12 + 8 | 0;
 i11 = HEAP32[i13 >> 2] | 0;
 if (!i11) {
  STACKTOP = i28;
  return;
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i27 >> 2] = 0;
 i17 = i22 + 4 | 0;
 i18 = i22 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 i19 = i21 + 4 | 0;
 i20 = i21 + 8 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i10 = i12 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 if (i9 >>> 0 < 129) {
  i1 = i9 << 2;
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i5 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  __ZN5physx2Gu9RadixSortC2Ev(i8);
  __ZN5physx2Gu9RadixSort10SetBuffersEPjS2_S2_PS2_(i8, i2, i5, i6, i7) | 0;
  i1 = HEAP32[(__ZN5physx2Gu9RadixSort4SortEPKjjNS0_9RadixHintE(i8, i12 + 24 | 0, i9, 0) | 0) + 8 >> 2] | 0;
  if (i9 | 0) {
   i2 = i9 + -1 | 0;
   i5 = i12 + 4 | 0;
   i6 = 0;
   do {
    i11 = HEAP32[i12 + 24 + (HEAP32[i1 + (i2 - i6 << 2) >> 2] << 2) >> 2] | 0;
    i10 = (HEAP32[i13 >> 2] | 0) + (i11 >>> 5 << 2) | 0;
    HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~(1 << (i11 & 31));
    __ZL9refitNodePN5physx2Sq12AABBTreeNodeEjPKNS_9PxBounds3EPjRS2_S7_RNS_6shdfnd3aos7VecU32VERNS9_5Vec3VESD_SD_SD_SD_(HEAP32[i5 >> 2] | 0, i11, i23, i24, i14, i27, i25, i26, i22, i21, i16, i15);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i9 | 0));
  }
 } else {
  i10 = i12 + 16 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1 + 1 | 0;
  if (i2 | 0) {
   i9 = i12 + 4 | 0;
   while (1) {
    if (HEAP32[i11 + (i1 << 2) >> 2] | 0) {
     i8 = 31;
     i7 = i2 << 5;
     while (1) {
      i7 = i7 + -1 | 0;
      i2 = (HEAP32[i13 >> 2] | 0) + (i7 >>> 5 << 2) | 0;
      i5 = HEAP32[i2 >> 2] | 0;
      i6 = 1 << (i7 & 31);
      if (i5 & i6 | 0) {
       HEAP32[i2 >> 2] = i5 & ~i6;
       __ZL9refitNodePN5physx2Sq12AABBTreeNodeEjPKNS_9PxBounds3EPjRS2_S7_RNS_6shdfnd3aos7VecU32VERNS9_5Vec3VESD_SD_SD_SD_(HEAP32[i9 >> 2] | 0, i7, i23, i24, i14, i27, i25, i26, i22, i21, i16, i15);
      }
      if (!i8) break; else i8 = i8 + -1 | 0;
     }
    }
    if (!i1) break; else {
     i2 = i1;
     i1 = i1 + -1 | 0;
    }
   }
  }
  HEAP32[i10 >> 2] = 0;
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i23 = HEAP32[i26 + 4 >> 2] | 0;
  i24 = HEAP32[i26 + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i1 + 4 >> 2] = i23;
  HEAP32[i1 + 8 >> 2] = i24;
  i24 = i1 + 16 | 0;
  i23 = i24;
  i16 = HEAP32[i23 >> 2] | 0;
  i23 = HEAP32[i23 + 4 >> 2] & 255;
  i15 = _bitshift64Shl((HEAP32[i25 + 4 >> 2] | 0) >>> 8 | 0, 0, 40) | 0;
  i23 = getTempRet0() | 0 | i23;
  HEAP32[i24 >> 2] = i15 | i16;
  HEAP32[i24 + 4 >> 2] = i23;
 }
 if (!(HEAP32[i27 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 f38 = Math_fround(HEAPF32[i22 >> 2]);
 f36 = Math_fround(HEAPF32[i17 >> 2]);
 f4 = Math_fround(HEAPF32[i18 >> 2]);
 f32 = Math_fround(HEAPF32[i21 >> 2]);
 f35 = Math_fround(HEAPF32[i19 >> 2]);
 f37 = Math_fround(HEAPF32[i20 >> 2]);
 i20 = f38 > Math_fround(-9999999940000000065998519.0e8);
 f38 = i20 ? f38 : Math_fround(-9999999940000000065998519.0e8);
 i20 = f36 > Math_fround(-9999999940000000065998519.0e8);
 f36 = i20 ? f36 : Math_fround(-9999999940000000065998519.0e8);
 i20 = f4 > Math_fround(-9999999940000000065998519.0e8);
 f4 = i20 ? f4 : Math_fround(-9999999940000000065998519.0e8);
 i20 = f32 < Math_fround(9999999940000000065998519.0e8);
 f32 = i20 ? f32 : Math_fround(9999999940000000065998519.0e8);
 i20 = f35 < Math_fround(9999999940000000065998519.0e8);
 f35 = i20 ? f35 : Math_fround(9999999940000000065998519.0e8);
 i20 = f37 < Math_fround(9999999940000000065998519.0e8);
 f37 = i20 ? f37 : Math_fround(9999999940000000065998519.0e8);
 f30 = Math_fround(Math_fround(f38 + f32) * Math_fround(.5));
 f29 = Math_fround(Math_fround(f36 + f35) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f4 + f37) * Math_fround(.5));
 f38 = Math_fround(Math_fround(f32 - f38) * Math_fround(.5));
 f36 = Math_fround(Math_fround(f35 - f36) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f37 - f4) * Math_fround(.5));
 f37 = Math_fround(f30 * Math_fround(.0000999999974));
 f35 = Math_fround(f29 * Math_fround(.0000999999974));
 f32 = Math_fround(f3 * Math_fround(.0000999999974));
 f34 = Math_fround(-f37);
 f33 = Math_fround(-f35);
 f31 = Math_fround(-f32);
 f34 = Math_fround(f38 + Math_fround((f37 > f34 ? f37 : f34) + Math_fround(.0000999999974)));
 f33 = Math_fround(f36 + Math_fround((f35 > f33 ? f35 : f33) + Math_fround(.0000999999974)));
 f31 = Math_fround(f4 + Math_fround((f32 > f31 ? f32 : f31) + Math_fround(.0000999999974)));
 f32 = f33 > f31 ? f33 : f31;
 f32 = Math_fround((f34 > f32 ? f34 : f32) * Math_fround(.00392158423));
 f4 = Math_fround(Math_fround(f32 + Math_fround(f32 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
 HEAPF32[i25 >> 2] = f4;
 HEAPF32[i25 + 4 >> 2] = f4;
 HEAPF32[i25 + 8 >> 2] = f4;
 HEAPF32[i25 + 12 >> 2] = Math_fround(0.0);
 f32 = Math_fround(Math_fround(1.0) / f32);
 i20 = ~~Math_fround(Math_fround(f32 * f34) + Math_fround(1.0));
 i22 = ~~Math_fround(Math_fround(f32 * f33) + Math_fround(1.0));
 i24 = ~~Math_fround(Math_fround(f32 * f31) + Math_fround(1.0));
 i21 = f30 == Math_fround(0.0);
 i23 = f29 == Math_fround(0.0);
 i25 = f3 == Math_fround(0.0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i20 | (i21 ? 16777216 : i1 & -256);
 i2 = i22 | (i23 ? 16777216 : i2 & -256);
 i25 = i24 | (i25 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & -256);
 HEAP32[i26 >> 2] = i1;
 HEAP32[i26 + 4 >> 2] = i2;
 HEAP32[i26 + 8 >> 2] = i25;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 i27 = HEAP32[i27 >> 2] | 0;
 HEAP32[i27 >> 2] = i1;
 HEAP32[i27 + 4 >> 2] = i2;
 HEAP32[i27 + 8 >> 2] = i25;
 i27 = i27 + 16 | 0;
 i26 = i27;
 i25 = HEAP32[i26 >> 2] | 0;
 i26 = HEAP32[i26 + 4 >> 2] & 255;
 i24 = _bitshift64Shl((HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 8 | 0, 0, 40) | 0;
 i26 = getTempRet0() | 0 | i26;
 HEAP32[i27 >> 2] = i24 | i25;
 HEAP32[i27 + 4 >> 2] = i26;
 STACKTOP = i28;
 return;
}

function __ZN5Light8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 7);
 i7 = i1 + 44 | 0;
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i10, (HEAP32[i7 >> 2] | 0) + 40 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i9, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374199 | 0, i9, (HEAP32[i7 >> 2] | 0) + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426256 | 0, i9, (HEAP32[i7 >> 2] | 0) + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374211 | 0, i9, (HEAP32[i7 >> 2] | 0) + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374223 | 0, i9, (HEAP32[i7 >> 2] | 0) + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = (HEAP32[i7 >> 2] | 0) + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374236 | 0, gb + 374246 | 0, i9, 0);
 __ZN14ShadowSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = (HEAP32[i7 >> 2] | 0) + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374261 | 0, gb + 944590 | 0, i9, 0);
 i8 = i11 + 8 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374270 | 0, HEAP32[gb + 36972 >> 2] | 0, (HEAP32[i7 >> 2] | 0) + 85 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374303 | 0, i8, (HEAP32[i7 >> 2] | 0) + 88 | 0, 8388609);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i10 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373697 | 0, gb + 373705 | 0, i10, 0);
 i6 = i11 + 8 | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011343 | 0, i8, (HEAP32[i7 >> 2] | 0) + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = (HEAP32[i7 >> 2] | 0) + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381098 | 0, gb + 1048681 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 4194305);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374316 | 0, i8, (HEAP32[i7 >> 2] | 0) + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i7 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374331 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 0);
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i7 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374342 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z23IntersectSphereTriangleRK6SphereRK8Vector3fS4_S4_(i7, i10, i6, i9) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, f3 = f0, d4 = 0.0, d5 = 0.0, f8 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 f20 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f20 = Math_fround(f20 * f20);
 f19 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f19 - f1);
 f17 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f16 = Math_fround(f17 - f2);
 f15 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f18 = Math_fround(f15 - f3);
 if (Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f16 * f16)) + Math_fround(f18 * f18)) <= f20) {
  i10 = 1;
  return i10 | 0;
 }
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(f13 - f1);
 f14 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f16 = Math_fround(f14 - f2);
 f11 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f18 = Math_fround(f11 - f3);
 if (Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f16 * f16)) + Math_fround(f18 * f18)) <= f20) {
  i10 = 1;
  return i10 | 0;
 }
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 f18 = Math_fround(f12 - f1);
 f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f16 = Math_fround(f8 - f2);
 f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f3 = Math_fround(f2 - f3);
 f1 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f16 * f16)) + Math_fround(f3 * f3));
 if (f1 <= f20) {
  i10 = 1;
  return i10 | 0;
 }
 f21 = Math_fround(f19 - f12);
 f17 = Math_fround(f17 - f8);
 f15 = Math_fround(f15 - f2);
 f19 = Math_fround(f13 - f12);
 f8 = Math_fround(f14 - f8);
 f11 = Math_fround(f11 - f2);
 f13 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f17 * f17)) + Math_fround(f15 * f15));
 f12 = Math_fround(Math_fround(Math_fround(f21 * f19) + Math_fround(f17 * f8)) + Math_fround(f15 * f11));
 f14 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f8 * f8)) + Math_fround(f11 * f11));
 f15 = Math_fround(Math_fround(Math_fround(f18 * f21) + Math_fround(f16 * f17)) + Math_fround(f3 * f15));
 f11 = Math_fround(Math_fround(Math_fround(f18 * f19) + Math_fround(f16 * f8)) + Math_fround(f3 * f11));
 f2 = Math_fround(Math_fround(f13 * f14) - Math_fround(f12 * f12));
 i7 = f2 < Math_fround(0.0);
 f3 = Math_fround(-f2);
 f2 = i7 ? f3 : f2;
 f3 = Math_fround(Math_fround(f12 * f11) - Math_fround(f14 * f15));
 f8 = Math_fround(Math_fround(f12 * f15) - Math_fround(f13 * f11));
 i7 = f3 < Math_fround(0.0);
 do if (!(Math_fround(f3 + f8) <= f2)) {
  if (i7) {
   f2 = Math_fround(f12 + f15);
   f3 = Math_fround(f14 + f11);
   if (f3 > f2) {
    d4 = +f3 - +f2;
    d5 = +Math_fround(f14 + Math_fround(f13 - Math_fround(f12 * Math_fround(2.0))));
    if (!(d4 >= d5)) {
     f19 = Math_fround(d4 / d5);
     f21 = Math_fround(Math_fround(1.0) - f19);
     f1 = Math_fround(f1 + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f15 * Math_fround(2.0)) + Math_fround(Math_fround(f13 * f19) + Math_fround(f12 * f21)))) + Math_fround(f21 * Math_fround(Math_fround(f11 * Math_fround(2.0)) + Math_fround(Math_fround(f12 * f19) + Math_fround(f14 * f21))))));
     break;
    } else {
     f1 = Math_fround(f1 + Math_fround(f13 + Math_fround(f15 * Math_fround(2.0))));
     break;
    }
   }
   if (f3 <= Math_fround(0.0)) {
    f1 = Math_fround(f1 + Math_fround(f14 + Math_fround(f11 * Math_fround(2.0))));
    break;
   }
   if (f11 >= Math_fround(0.0)) break;
   f1 = Math_fround(f1 + Math_fround(f11 * Math_fround(Math_fround(-f11) / f14)));
   break;
  }
  if (!(f8 < Math_fround(0.0))) {
   f2 = Math_fround(Math_fround(Math_fround(f14 + f11) - f12) - f15);
   if (f2 <= Math_fround(0.0)) {
    f1 = Math_fround(f1 + Math_fround(f14 + Math_fround(f11 * Math_fround(2.0))));
    break;
   }
   f3 = Math_fround(f14 + Math_fround(f13 - Math_fround(f12 * Math_fround(2.0))));
   if (!(f2 >= f3)) {
    f19 = Math_fround(f2 / f3);
    f21 = Math_fround(Math_fround(1.0) - f19);
    f1 = Math_fround(f1 + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f15 * Math_fround(2.0)) + Math_fround(Math_fround(f13 * f19) + Math_fround(f12 * f21)))) + Math_fround(f21 * Math_fround(Math_fround(f11 * Math_fround(2.0)) + Math_fround(Math_fround(f12 * f19) + Math_fround(f14 * f21))))));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(f13 + Math_fround(f15 * Math_fround(2.0))));
    break;
   }
  }
  f2 = Math_fround(f12 + f11);
  f3 = Math_fround(f13 + f15);
  if (f3 > f2) {
   d4 = +f3 - +f2;
   d5 = +Math_fround(f14 + Math_fround(f13 - Math_fround(f12 * Math_fround(2.0))));
   if (!(d4 >= d5)) {
    f19 = Math_fround(d4 / d5);
    f21 = Math_fround(Math_fround(1.0) - f19);
    f1 = Math_fround(f1 + Math_fround(Math_fround(f21 * Math_fround(Math_fround(f15 * Math_fround(2.0)) + Math_fround(Math_fround(f12 * f19) + Math_fround(f13 * f21)))) + Math_fround(f19 * Math_fround(Math_fround(f11 * Math_fround(2.0)) + Math_fround(Math_fround(f14 * f19) + Math_fround(f12 * f21))))));
    break;
   } else {
    f1 = Math_fround(+f1 + (+f14 + +f11 * 2.0));
    break;
   }
  }
  if (f3 <= Math_fround(0.0)) {
   f1 = Math_fround(f1 + Math_fround(f13 + Math_fround(f15 * Math_fround(2.0))));
   break;
  }
  if (!(f15 >= Math_fround(0.0))) f1 = Math_fround(f1 + Math_fround(f15 * Math_fround(Math_fround(-f15) / f13)));
 } else {
  i6 = f8 < Math_fround(0.0);
  if (!i7) {
   if (!i6) {
    if (f2 == Math_fround(0.0)) {
     f1 = Math_fround(3402823469999999843913219.0e14);
     break;
    }
    f21 = Math_fround(Math_fround(1.0) / f2);
    f19 = Math_fround(f3 * f21);
    f21 = Math_fround(f8 * f21);
    f1 = Math_fround(f1 + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f15 * Math_fround(2.0)) + Math_fround(Math_fround(f13 * f19) + Math_fround(f12 * f21)))) + Math_fround(f21 * Math_fround(Math_fround(f11 * Math_fround(2.0)) + Math_fround(Math_fround(f12 * f19) + Math_fround(f14 * f21))))));
    break;
   }
   if (f15 >= Math_fround(0.0)) break;
   f2 = Math_fround(-f15);
   if (!(f13 <= f2)) {
    f1 = Math_fround(f1 + Math_fround(f15 * Math_fround(f2 / f13)));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(f13 + Math_fround(f15 * Math_fround(2.0))));
    break;
   }
  }
  if (!i6) {
   if (f11 >= Math_fround(0.0)) break;
   f2 = Math_fround(-f11);
   if (!(f14 <= f2)) {
    f1 = Math_fround(f1 + Math_fround(f11 * Math_fround(f2 / f14)));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(f14 + Math_fround(f11 * Math_fround(2.0))));
    break;
   }
  }
  if (f15 < Math_fround(0.0)) {
   f2 = Math_fround(-f15);
   if (!(f13 <= f2)) {
    f1 = Math_fround(f1 + Math_fround(f15 * Math_fround(f2 / f13)));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(f13 + Math_fround(f15 * Math_fround(2.0))));
    break;
   }
  }
  if (!(f11 >= Math_fround(0.0))) {
   f2 = Math_fround(-f11);
   if (!(f14 <= f2)) {
    f1 = Math_fround(f1 + Math_fround(f11 * Math_fround(f2 / f14)));
    break;
   } else {
    f1 = Math_fround(f1 + Math_fround(f14 + Math_fround(f11 * Math_fround(2.0))));
    break;
   }
  }
 } while (0);
 i10 = f1 < Math_fround(0.0);
 f21 = Math_fround(-f1);
 i10 = (i10 ? f21 : f1) <= f20;
 return i10 | 0;
}

function __ZN14DetailDatabase8TransferI14SafeBinaryReadEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i2 = i7 + 4 | 0;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932261 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932271 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15DetailPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 36 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932290 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932303 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932318 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932336 | 0, HEAP32[gb + 36980 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 76 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932352 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 52; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 52; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932374 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 63; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 63; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 63) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932394 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 74; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 74; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 74) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __ZN12TreeDatabase8TransferI14SafeBinaryReadEEvRT_(HEAP32[i7 + 32 >> 2] | 0, i10);
 i2 = i7 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 932413 | 0, i8, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN17Physics2DSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i10 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801749 | 0, HEAP32[gb + 37320 >> 2] | 0, i10, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i10, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944562 | 0, gb + 801759 | 0, i10, 0);
 i9 = i6 + 8 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801783 | 0, i8, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801804 | 0, i8, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801825 | 0, i7, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801845 | 0, i7, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801867 | 0, i7, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801890 | 0, i7, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801912 | 0, i7, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801931 | 0, i7, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801958 | 0, i7, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801975 | 0, i7, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802004 | 0, i7, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802018 | 0, i7, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802041 | 0, i7, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802114 | 0, i7, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802135 | 0, i7, i1 + 93 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802161 | 0, i7, i1 + 94 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802184 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 168 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i3 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(i15, i20, i21) {
 i15 = i15 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22 + 16 | 0;
 i19 = i22;
 if ((i21 | 0) == -1) {
  STACKTOP = i22;
  return;
 }
 i5 = __ZNK15ReflectionProbe10GetTextureEv(i20) | 0;
 do if (!i5) {
  i17 = 0;
  i1 = 0;
  i16 = 1;
 } else {
  HEAP32[i19 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
    i2 = HEAP32[i18 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 10;
   }
  }
  if ((i6 | 0) == 8) i6 = 10;
  if ((i6 | 0) == 10) {
   i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   if (!i1) {
    i17 = 0;
    i1 = 0;
    i16 = 1;
    break;
   }
  }
  i17 = i1;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  i16 = 0;
 } while (0);
 HEAP32[i20 + 156 >> 2] = i21;
 switch (HEAP32[i20 + 36 >> 2] | 0) {
 case 0:
  {
   i5 = HEAP32[i15 + 104 >> 2] | 0;
   i6 = i20 + 28 | 0;
   __ZNK9Transform11GetPositionEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
   f4 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + Math_fround(HEAPF32[i20 + 76 >> 2]));
   f7 = Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) + Math_fround(HEAPF32[i20 + 80 >> 2]));
   f8 = Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) + Math_fround(HEAPF32[i20 + 84 >> 2]));
   f10 = Math_fround(HEAPF32[i20 + 64 >> 2]);
   f10 = Math_fround(f10 * Math_fround(.5));
   f12 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(.5));
   f14 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(.5));
   i2 = f10 < Math_fround(0.0);
   f9 = Math_fround(-f10);
   i3 = f12 < Math_fround(0.0);
   f11 = Math_fround(-f12);
   i19 = f14 < Math_fround(0.0);
   f13 = Math_fround(-f14);
   HEAPF32[i5 + (i21 * 24 | 0) >> 2] = f4;
   HEAPF32[i5 + (i21 * 24 | 0) + 4 >> 2] = f7;
   HEAPF32[i5 + (i21 * 24 | 0) + 8 >> 2] = f8;
   HEAPF32[i5 + (i21 * 24 | 0) + 12 >> 2] = i2 ? f9 : f10;
   HEAPF32[i5 + (i21 * 24 | 0) + 16 >> 2] = i3 ? f11 : f12;
   HEAPF32[i5 + (i21 * 24 | 0) + 20 >> 2] = i19 ? f13 : f14;
   i5 = HEAP32[i15 + 124 >> 2] | 0;
   if (!i1) i1 = __ZN10builtintex21GetBlackCubeTextureIDEv() | 0;
   HEAP32[i5 + (i21 * 40 | 0) >> 2] = i1;
   i3 = i5 + (i21 * 40 | 0) + 4 | 0;
   f4 = Math_fround(HEAPF32[i20 + 132 >> 2]);
   if (i16) __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i18, 0, 0); else {
    i2 = HEAP32[i17 + 56 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i17 + 60 >> 2] | 0; else i1 = 0;
    __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i18, i2, i1, __Z19GetActiveColorSpacev() | 0, f4);
   };
   HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   __ZNK9Transform11GetPositionEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
   f14 = HEAP8[i20 + 141 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
   i17 = HEAP32[i18 + 4 >> 2] | 0;
   i19 = HEAP32[i18 + 8 >> 2] | 0;
   HEAP32[i5 + (i21 * 40 | 0) + 20 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i5 + (i21 * 40 | 0) + 24 >> 2] = i17;
   HEAP32[i5 + (i21 * 40 | 0) + 28 >> 2] = i19;
   HEAPF32[i5 + (i21 * 40 | 0) + 32 >> 2] = f14;
   HEAP32[i5 + (i21 * 40 | 0) + 36 >> 2] = HEAP16[i20 + 60 >> 1];
   STACKTOP = i22;
   return;
  }
 case 1:
  {
   i25 = i20 + 28 | 0;
   __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i25 >> 2] | 0, gb + 28940 | 0) | 0);
   __ZNK9Transform18GetWorldScaleLossyEv(i19, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i25 >> 2] | 0, gb + 28940 | 0) | 0);
   f7 = Math_fround(HEAPF32[i19 >> 2]);
   i25 = f7 < Math_fround(.00999999977);
   f7 = i25 ? Math_fround(.00999999977) : f7;
   f8 = Math_fround(HEAPF32[i19 + 4 >> 2]);
   i25 = f8 < Math_fround(.00999999977);
   f8 = i25 ? Math_fround(.00999999977) : f8;
   i25 = HEAP32[i18 + 52 >> 2] | 0;
   i24 = HEAP32[i18 + 56 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i18 >> 2]);
   f10 = Math_fround(HEAPF32[i18 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i18 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i18 + 16 >> 2]);
   f13 = Math_fround(HEAPF32[i18 + 20 >> 2]);
   f14 = Math_fround(HEAPF32[i18 + 24 >> 2]);
   i3 = HEAP32[i18 + 32 >> 2] | 0;
   i6 = HEAP32[i18 + 36 >> 2] | 0;
   i2 = HEAP32[i18 + 40 >> 2] | 0;
   i5 = i15 + 144 | 0;
   i23 = HEAP32[i5 >> 2] | 0;
   HEAP32[i23 + (i21 * 24 | 0) >> 2] = HEAP32[i18 + 48 >> 2];
   HEAP32[i23 + (i21 * 24 | 0) + 4 >> 2] = i25;
   HEAP32[i23 + (i21 * 24 | 0) + 8 >> 2] = i24;
   i5 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 + (i21 * 24 | 0) + 12 >> 2] = i3;
   HEAP32[i5 + (i21 * 24 | 0) + 16 >> 2] = i6;
   HEAP32[i5 + (i21 * 24 | 0) + 20 >> 2] = i2;
   i5 = i15 + 164 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = __ZN10builtintex17GetBlackTextureIDEv() | 0;
   HEAP32[i2 + (i21 * 44 | 0) + 24 >> 2] = i1;
   i3 = (HEAP32[i5 >> 2] | 0) + (i21 * 44 | 0) + 28 | 0;
   f4 = Math_fround(HEAPF32[i20 + 132 >> 2]);
   if (i16) __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i19, 0, 0); else {
    i2 = HEAP32[i17 + 56 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i17 + 60 >> 2] | 0; else i1 = 0;
    __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i19, i2, i1, __Z19GetActiveColorSpacev() | 0, f4);
   };
   HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   i25 = HEAP32[i5 >> 2] | 0;
   f10 = Math_fround(f10 / f7);
   f11 = Math_fround(f11 / f7);
   HEAPF32[i25 + (i21 * 44 | 0) >> 2] = Math_fround(f9 / f7);
   HEAPF32[i25 + (i21 * 44 | 0) + 4 >> 2] = f10;
   HEAPF32[i25 + (i21 * 44 | 0) + 8 >> 2] = f11;
   i25 = HEAP32[i5 >> 2] | 0;
   f13 = Math_fround(f13 / f8);
   f14 = Math_fround(f14 / f8);
   HEAPF32[i25 + (i21 * 44 | 0) + 12 >> 2] = Math_fround(f12 / f8);
   HEAPF32[i25 + (i21 * 44 | 0) + 16 >> 2] = f13;
   HEAPF32[i25 + (i21 * 44 | 0) + 20 >> 2] = f14;
   STACKTOP = i22;
   return;
  }
 default:
  {
   STACKTOP = i22;
   return;
  }
 }
}

function __ZN16DeveloperConsole5DoGUIEv(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i31;
 __ZN16DeveloperConsole16AppendNewEntriesEv(i24);
 if (HEAP8[i24 >> 0] | 0) {
  i30 = 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i27 = i24 + 4 | 0;
 i23 = i24 + 12 | 0;
 if (!(HEAP32[i23 >> 2] | 0)) {
  i30 = 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = i24 + 120 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN16DeveloperConsole13InitGUIStylesEv(i24);
 i1 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i1 | 0) > -1) i1 = HEAP32[gb + 1468320 + (i1 << 2) >> 2] | 0; else i1 = 0;
 i28 = HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0;
 i26 = i28 + 96 | 0;
 i29 = i28 + 280 | 0;
 __ZN12GUIClipState10BeginOnGUIER10InputEvent(i26, HEAP32[i29 >> 2] | 0);
 i4 = i24 + 28 | 0;
 HEAP32[i28 + 92 >> 2] = i4;
 HEAP32[i28 + 44 >> 2] = 1065353216;
 HEAP32[i28 + 48 >> 2] = 1065353216;
 HEAP32[i28 + 52 >> 2] = 1065353216;
 HEAP32[i28 + 56 >> 2] = 1065353216;
 HEAP32[i28 + 28 >> 2] = 1065353216;
 HEAP32[i28 + 32 >> 2] = 1065353216;
 HEAP32[i28 + 36 >> 2] = 1065353216;
 HEAP32[i28 + 40 >> 2] = 1065353216;
 HEAP32[i28 + 12 >> 2] = 1065353216;
 HEAP32[i28 + 16 >> 2] = 1065353216;
 HEAP32[i28 + 20 >> 2] = 1065353216;
 HEAP32[i28 + 24 >> 2] = 1065353216;
 HEAP32[i28 + 60 >> 2] = 1;
 HEAP32[i28 + 64 >> 2] = 0;
 HEAP32[i28 + 68 >> 2] = 1;
 HEAP32[i24 + 72 >> 2] = 0;
 i19 = i24 + 32 | 0;
 HEAP32[i19 >> 2] = -1;
 HEAP32[i19 + 4 >> 2] = -1;
 HEAP32[i19 + 8 >> 2] = -1;
 HEAP32[i19 + 12 >> 2] = -1;
 HEAP8[i24 + 48 >> 0] = 0;
 HEAP32[i4 >> 2] = 1;
 i4 = i28 + 340 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = __Z16GetScreenManagerv() | 0;
 f16 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 80 >> 2] | 0, i4 | 0) | 0);
 i4 = __Z16GetScreenManagerv() | 0;
 f20 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0) | 0);
 f21 = Math_fround(f16 * Math_fround(.5));
 f22 = Math_fround(f20 * Math_fround(.0250000004));
 f16 = Math_fround(f16 * Math_fround(.0250000004));
 f17 = Math_fround(__ZN16DeveloperConsole7DrawBoxEffR8GUIStateff(i24, f16, f22, i28, f20, f21));
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i19 = i24 + 8 | 0;
 L13 : do if ((i27 | 0) == (HEAP32[i19 >> 2] | 0)) {
  i7 = i24 + 76 | 0;
  i8 = i25 + 12 | 0;
  i9 = i7;
  i6 = i24 + 84 | 0;
  i5 = i25 + 8 | 0;
  i2 = i25 + 4 | 0;
  i3 = i25;
 } else {
  i18 = i24 + 76 | 0;
  i6 = i24 + 84 | 0;
  i7 = i24 + 80 | 0;
  i9 = i4 + 20 | 0;
  i11 = i4 + 24 | 0;
  i12 = i4 + 28 | 0;
  i13 = i4 + 32 | 0;
  f14 = Math_fround(f21 - f16);
  i5 = i25 + 8 | 0;
  i2 = i25 + 4 | 0;
  i8 = i25 + 12 | 0;
  f10 = Math_fround(0.0);
  i3 = i27;
  while (1) {
   i15 = i3;
   i1 = HEAP32[i15 >> 2] | 0;
   __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i18, HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
   HEAP8[i6 >> 0] = 0;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((i1 | 0) > 0) HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[i15 >> 2] | 0;
   switch (HEAP32[i1 + 12 >> 2] | 0) {
   case 4:
   case 1:
   case 0:
    {
     HEAP32[i9 >> 2] = 1065353216;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i12 >> 2] = 0;
     HEAP32[i13 >> 2] = 1065353216;
     break;
    }
   case 2:
    {
     HEAP32[i9 >> 2] = 1065353216;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i12 >> 2] = 0;
     HEAP32[i13 >> 2] = 1065353216;
     break;
    }
   default:
    {
     HEAP32[i9 >> 2] = 1065353216;
     HEAP32[i11 >> 2] = 1065353216;
     HEAP32[i12 >> 2] = 1065353216;
     HEAP32[i13 >> 2] = 1065353216;
    }
   }
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i1 + 16 >> 2]));
   f32 = Math_fround(Math_fround(f20 - f10) - f22);
   HEAPF32[i25 >> 2] = f16;
   HEAPF32[i5 >> 2] = f14;
   HEAPF32[i2 >> 2] = f32;
   HEAPF32[i8 >> 2] = f17;
   if (__ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i28, i25, i18, i4, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i28, 2001146706, 0, i25, 1) | 0) | 0) {
    i15 = (HEAP32[i15 >> 2] | 0) + 8 | 0;
    HEAP32[i15 >> 2] = 0 - (HEAP32[i15 >> 2] | 0);
   }
   i3 = HEAP32[i3 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i19 >> 2] | 0)) {
    i9 = i18;
    i7 = i18;
    i3 = i25;
    break L13;
   }
  }
 } while (0);
 f32 = Math_fround(Math_fround(f20 + Math_fround(-50.0)) - f22);
 HEAPF32[i3 >> 2] = f21;
 HEAPF32[i5 >> 2] = Math_fround(70.0);
 HEAPF32[i2 >> 2] = f32;
 HEAPF32[i8 >> 2] = Math_fround(20.0);
 __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i7, HEAP32[i24 + 152 >> 2] | 0, HEAP32[i24 + 156 >> 2] | 0);
 HEAP8[i6 >> 0] = 0;
 i4 = i24 + 124 | 0;
 i18 = HEAP32[i4 >> 2] | 0;
 if (__ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i28, i25, i9, i18, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i28, 2001146706, 0, i25, 1) | 0) | 0) if (HEAP32[i23 >> 2] | 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  i19 = (HEAP32[i27 >> 2] | 0) + 4 | 0;
  i18 = HEAP32[i1 >> 2] | 0;
  HEAP32[i18 + 4 >> 2] = HEAP32[i19 >> 2];
  HEAP32[HEAP32[i19 >> 2] >> 2] = i18;
  HEAP32[i23 >> 2] = 0;
  if ((i1 | 0) != (i27 | 0)) do {
   i23 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZN11UTF16StringD2Ev(i23 + 20 | 0);
   __ZdlPv(i23);
  } while ((i1 | 0) != (i27 | 0));
 }
 f32 = Math_fround(Math_fround(f20 + Math_fround(-25.0)) - f22);
 HEAPF32[i3 >> 2] = f21;
 HEAPF32[i5 >> 2] = Math_fround(70.0);
 HEAPF32[i2 >> 2] = f32;
 HEAPF32[i8 >> 2] = Math_fround(20.0);
 __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i7, HEAP32[i24 + 172 >> 2] | 0, HEAP32[i24 + 176 >> 2] | 0);
 HEAP8[i6 >> 0] = 0;
 i27 = HEAP32[i4 >> 2] | 0;
 if (__ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i28, i25, i9, i27, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i28, 2001146706, 0, i25, 1) | 0) | 0) HEAP8[i24 >> 0] = 1;
 __ZN8GUIState8EndOnGUIEv(i28);
 i3 = HEAP32[i29 >> 2] | 0;
 i4 = i28 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 - (HEAP32[i26 >> 2] | 0) | 0;
 do if ((i2 | 0) != 56 ? ((HEAP32[i3 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) if (((i2 | 0) / 56 | 0) >>> 0 > 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
  i1 = HEAP32[i4 >> 2] | 0;
  i30 = 29;
  break;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
  break;
 } else i30 = 29; while (0);
 if ((i30 | 0) == 29) {
  HEAP32[i4 >> 2] = i1 + -56;
  i27 = i28 + 236 | 0;
  f22 = Math_fround(HEAPF32[i27 >> 2]);
  f22 = Math_fround(f22 - Math_fround(HEAPF32[i28 + 244 >> 2]));
  f32 = Math_fround(HEAPF32[i28 + 240 >> 2]);
  f32 = Math_fround(f32 - Math_fround(HEAPF32[i28 + 248 >> 2]));
  HEAPF32[i3 + 12 >> 2] = f22;
  HEAPF32[i3 + 16 >> 2] = f32;
  i28 = HEAP32[i27 + 4 >> 2] | 0;
  i30 = i3 + 4 | 0;
  HEAP32[i30 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i30 + 4 >> 2] = i28;
 }
 i30 = (HEAP32[HEAP32[i29 >> 2] >> 2] | 0) == 12;
 STACKTOP = i31;
 return i30 | 0;
}

function _jinit_c_master_control(i19, i17) {
 i19 = i19 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21;
 i20 = mftCall_iiii(HEAP32[HEAP32[i19 + 4 >> 2] >> 2] | 0, i19 | 0, 1, 32) | 0;
 HEAP32[i19 + 316 >> 2] = i20;
 HEAP32[i20 >> 2] = fb + 3255;
 HEAP32[i20 + 4 >> 2] = fb + 3256;
 HEAP32[i20 + 8 >> 2] = fb + 3257;
 HEAP8[i20 + 13 >> 0] = 0;
 i14 = i19 + 32 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i13 = i19 + 28 | 0;
 if (!i1) i15 = 5; else if (!(HEAP32[i13 >> 2] | 0)) i15 = 5; else if ((HEAP32[i19 + 60 >> 2] | 0) < 1) i15 = 5; else if ((HEAP32[i19 + 36 >> 2] | 0) < 1) i15 = 5;
 if ((i15 | 0) == 5) {
  i1 = HEAP32[i19 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 32;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i19 | 0);
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if ((i1 | 0) > 65500) i15 = 8; else if ((HEAP32[i13 >> 2] | 0) > 65500) i15 = 8;
 if ((i15 | 0) == 8) {
  i16 = HEAP32[i19 >> 2] | 0;
  HEAP32[i16 + 20 >> 2] = 41;
  HEAP32[i16 + 24 >> 2] = 65500;
  mftCall_vi(HEAP32[i16 >> 2] | 0, i19 | 0);
 }
 i1 = HEAP32[i19 + 56 >> 2] | 0;
 if ((i1 | 0) != 8) {
  i16 = HEAP32[i19 >> 2] | 0;
  HEAP32[i16 + 20 >> 2] = 15;
  HEAP32[i16 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i16 >> 2] | 0, i19 | 0);
 }
 i16 = i19 + 60 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) > 10) {
  i12 = HEAP32[i19 >> 2] | 0;
  HEAP32[i12 + 20 >> 2] = 26;
  HEAP32[i12 + 24 >> 2] = i1;
  HEAP32[i12 + 28 >> 2] = 10;
  mftCall_vi(HEAP32[i12 >> 2] | 0, i19 | 0);
  i1 = HEAP32[i16 >> 2] | 0;
 }
 i11 = i19 + 216 | 0;
 HEAP32[i11 >> 2] = 1;
 i12 = i19 + 220 | 0;
 HEAP32[i12 >> 2] = 1;
 i10 = i19 + 68 | 0;
 if ((i1 | 0) > 0) {
  i8 = 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i4 = i1;
  i1 = 1;
  i2 = 1;
  while (1) {
   i5 = i9 + 8 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i9 + 12 | 0;
   if ((i6 + -1 | 0) >>> 0 > 3) i15 = 17; else {
    i3 = HEAP32[i7 >> 2] | 0;
    if ((i3 + -1 | 0) >>> 0 > 3) i15 = 17;
   }
   if ((i15 | 0) == 17) {
    i15 = 0;
    i2 = HEAP32[i19 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 18;
    mftCall_vi(HEAP32[i2 >> 2] | 0, i19 | 0);
    i2 = HEAP32[i11 >> 2] | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i16 >> 2] | 0;
   }
   i2 = (i2 | 0) > (i6 | 0) ? i2 : i6;
   HEAP32[i11 >> 2] = i2;
   i1 = (i1 | 0) > (i3 | 0) ? i1 : i3;
   HEAP32[i12 >> 2] = i1;
   i8 = i8 + 1 | 0;
   if ((i8 | 0) >= (i4 | 0)) break; else i9 = i9 + 84 | 0;
  }
  if ((i4 | 0) > 0) {
   i1 = 0;
   i3 = HEAP32[i10 >> 2] | 0;
   while (1) {
    HEAP32[i3 + 4 >> 2] = i1;
    HEAP32[i3 + 36 >> 2] = 8;
    i9 = i3 + 8 | 0;
    HEAP32[i3 + 28 >> 2] = _jdiv_round_up(Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0, i2 << 3) | 0;
    i10 = i3 + 12 | 0;
    i8 = Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
    HEAP32[i3 + 32 >> 2] = _jdiv_round_up(i8, HEAP32[i12 >> 2] << 3) | 0;
    i9 = Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
    HEAP32[i3 + 40 >> 2] = _jdiv_round_up(i9, HEAP32[i11 >> 2] | 0) | 0;
    i10 = Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
    HEAP32[i3 + 44 >> 2] = _jdiv_round_up(i10, HEAP32[i12 >> 2] | 0) | 0;
    HEAP8[i3 + 48 >> 0] = 1;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (HEAP32[i16 >> 2] | 0)) break;
    i3 = i3 + 84 | 0;
    i2 = HEAP32[i11 >> 2] | 0;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
 } else i1 = 1;
 HEAP32[i19 + 224 >> 2] = _jdiv_round_up(HEAP32[i14 >> 2] | 0, i1 << 3) | 0;
 i1 = i19 + 172 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP8[i19 + 212 >> 0] = 0;
  HEAP32[i19 + 168 >> 2] = 1;
 } else {
  i8 = i19 + 168 | 0;
  if ((HEAP32[i8 >> 2] | 0) < 1) {
   i2 = HEAP32[i19 >> 2] | 0;
   HEAP32[i2 + 20 >> 2] = 19;
   HEAP32[i2 + 24 >> 2] = 0;
   mftCall_vi(HEAP32[i2 >> 2] | 0, i19 | 0);
   i2 = HEAP32[i1 >> 2] | 0;
  }
  if (!(HEAP32[i2 + 20 >> 2] | 0)) if ((HEAP32[i2 + 24 >> 2] | 0) == 63) {
   HEAP8[i19 + 212 >> 0] = 0;
   i1 = HEAP32[i16 >> 2] | 0;
   if ((i1 | 0) > 0) _memset(i18 | 0, 0, i1 | 0) | 0;
  } else i15 = 29; else i15 = 29;
  if ((i15 | 0) == 29) {
   i14 = HEAP32[i19 >> 2] | 0;
   HEAP32[i14 + 20 >> 2] = 48;
   mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
  }
  if ((HEAP32[i8 >> 2] | 0) < 1) i1 = i19 + 212 | 0; else {
   i1 = i19 + 212 | 0;
   i7 = 1;
   while (1) {
    i6 = HEAP32[i2 >> 2] | 0;
    if ((i6 + -1 | 0) >>> 0 > 3) {
     i14 = HEAP32[i19 >> 2] | 0;
     HEAP32[i14 + 20 >> 2] = 26;
     HEAP32[i14 + 24 >> 2] = i6;
     HEAP32[i14 + 28 >> 2] = 4;
     mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
    }
    i4 = (i6 | 0) > 0;
    if (i4) {
     i3 = 0;
     do {
      i5 = HEAP32[i2 + 4 + (i3 << 2) >> 2] | 0;
      if ((i5 | 0) < 0) i15 = 40; else if ((i5 | 0) >= (HEAP32[i16 >> 2] | 0)) i15 = 40;
      if ((i15 | 0) == 40) {
       i15 = 0;
       i14 = HEAP32[i19 >> 2] | 0;
       HEAP32[i14 + 20 >> 2] = 19;
       HEAP32[i14 + 24 >> 2] = i7;
       mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
      }
      if ((i3 | 0) > 0) if ((i5 | 0) <= (HEAP32[i2 + 4 + (i3 + -1 << 2) >> 2] | 0)) {
       i14 = HEAP32[i19 >> 2] | 0;
       HEAP32[i14 + 20 >> 2] = 19;
       HEAP32[i14 + 24 >> 2] = i7;
       mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
      }
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i6 | 0));
    }
    if (!(HEAP8[i1 >> 0] | 0)) {
     if ((HEAP32[i2 + 24 >> 2] | 0) != 63 ? 1 : (HEAP32[i2 + 28 >> 2] | HEAP32[i2 + 32 >> 2] | HEAP32[i2 + 20 >> 2] | 0) != 0) {
      i14 = HEAP32[i19 >> 2] | 0;
      HEAP32[i14 + 20 >> 2] = 17;
      HEAP32[i14 + 24 >> 2] = i7;
      mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
     }
     if (i4) {
      i3 = 0;
      do {
       i4 = i18 + (HEAP32[i2 + 4 + (i3 << 2) >> 2] | 0) | 0;
       if (HEAP8[i4 >> 0] | 0) {
        i14 = HEAP32[i19 >> 2] | 0;
        HEAP32[i14 + 20 >> 2] = 19;
        HEAP32[i14 + 24 >> 2] = i7;
        mftCall_vi(HEAP32[i14 >> 2] | 0, i19 | 0);
       }
       HEAP8[i4 >> 0] = 1;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i6 | 0));
     }
    }
    if ((i7 | 0) < (HEAP32[i8 >> 2] | 0)) {
     i7 = i7 + 1 | 0;
     i2 = i2 + 36 | 0;
    } else break;
   }
  }
  if (!(HEAP8[i1 >> 0] | 0)) {
   i1 = HEAP32[i16 >> 2] | 0;
   if ((i1 | 0) > 0) {
    i2 = 0;
    do {
     if (!(HEAP8[i18 + i2 >> 0] | 0)) {
      i1 = HEAP32[i19 >> 2] | 0;
      HEAP32[i1 + 20 >> 2] = 45;
      mftCall_vi(HEAP32[i1 >> 2] | 0, i19 | 0);
      i1 = HEAP32[i16 >> 2] | 0;
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i1 | 0));
   }
  }
  if (HEAP8[i19 + 212 >> 0] | 0) if (!(HEAP8[i19 + 177 >> 0] | 0)) HEAP8[i19 + 178 >> 0] = 1;
 }
 do if (!(i17 << 24 >> 24)) {
  HEAP32[i20 + 16 >> 2] = 0;
  i2 = HEAP8[i19 + 178 >> 0] | 0;
 } else {
  i1 = HEAP8[i19 + 178 >> 0] | 0;
  i2 = i20 + 16 | 0;
  if (!(i1 << 24 >> 24)) {
   HEAP32[i2 >> 2] = 2;
   i2 = 0;
   break;
  } else {
   HEAP32[i2 >> 2] = 1;
   i2 = i1;
   break;
  }
 } while (0);
 HEAP32[i20 + 28 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 i1 = HEAP32[i19 + 168 >> 2] | 0;
 if (!(i2 << 24 >> 24)) {
  HEAP32[i20 + 24 >> 2] = i1;
  STACKTOP = i21;
  return;
 } else {
  HEAP32[i20 + 24 >> 2] = i1 << 1;
  STACKTOP = i21;
  return;
 }
}

function __ZNK5Unity10HingeJoint8GetAngleEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 4 | 0;
 i8 = i20;
 if (!(HEAP32[i19 + 32 >> 2] | 0)) {
  f18 = Math_fround(0.0);
  STACKTOP = i20;
  return Math_fround(f18);
 }
 i13 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i19 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
 i11 = i19 + 92 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i8);
    i2 = HEAP32[i14 >> 2] | 0;
    i21 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 10;
  }
  if ((i12 | 0) == 8) i12 = 10;
  if ((i12 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i8);
    i2 = HEAP32[i14 >> 2] | 0;
    i21 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 18;
   }
  }
  if ((i12 | 0) == 16) i12 = 18;
  if ((i12 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 52 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 84 >> 2] | 0, i14 | 0, i13 | 0);
 f15 = Math_fround(HEAPF32[i14 >> 2]);
 f16 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 if (!i1) {
  f7 = Math_fround(0.0);
  f4 = Math_fround(1.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i14 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f5 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 }
 f22 = Math_fround(-f7);
 f24 = Math_fround(-f5);
 f26 = Math_fround(-f6);
 f23 = Math_fround(Math_fround(Math_fround(f16 * f26) + Math_fround(Math_fround(f18 * f22) + Math_fround(f15 * f4))) - Math_fround(f17 * f24));
 f10 = Math_fround(Math_fround(Math_fround(f17 * f22) + Math_fround(Math_fround(f18 * f24) + Math_fround(f16 * f4))) - Math_fround(f15 * f26));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f18 * f26) + Math_fround(f17 * f4))) - Math_fround(f16 * f22));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f4) - Math_fround(f15 * f22)) - Math_fround(f16 * f24)) - Math_fround(f17 * f26));
 f24 = Math_fround(HEAPF32[i19 + 140 >> 2]);
 f22 = Math_fround(HEAPF32[i19 + 144 >> 2]);
 f9 = Math_fround(HEAPF32[i19 + 148 >> 2]);
 f25 = Math_fround(HEAPF32[i19 + 152 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(f9 * f10) + Math_fround(Math_fround(f24 * f26) + Math_fround(f25 * f23))) - Math_fround(f22 * f7));
 f5 = Math_fround(Math_fround(Math_fround(f24 * f7) + Math_fround(Math_fround(f25 * f10) + Math_fround(f22 * f26))) - Math_fround(f9 * f23));
 f6 = Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(Math_fround(f9 * f26) + Math_fround(f25 * f7))) - Math_fround(f24 * f10));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23)) - Math_fround(f22 * f10)) - Math_fround(f9 * f7));
 f9 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)));
 if (f9 < Math_fround(1.00000002e-16)) {
  f4 = Math_fround(0.0);
  i3 = 1065353216;
  i2 = 0;
  i1 = 0;
 } else {
  f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9))));
  f24 = Math_fround(f4 * f10);
  f25 = Math_fround(f5 * f10);
  f26 = Math_fround(f6 * f10);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  if (Math_fround(Math_abs(Math_fround(f7))) < Math_fround(9.99999993e-09)) f4 = Math_fround(1.57079637); else f4 = Math_fround(Math_fround(Math_fround(+Math_atan2(+Math_fround(f9 * f10), +f7)) * Math_fround(2.0)) * Math_fround(.5));
 }
 f26 = Math_fround(Math_fround(f4 / Math_fround(3.14159274)) * Math_fround(360.0));
 f22 = Math_fround(HEAPF32[i19 + 64 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 68 >> 2]);
 f22 = Math_fround(f22 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(HEAPF32[i19 + 72 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f24 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f16 * f10)) + Math_fround(f17 * f9));
 f23 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f7 * f22) + Math_fround(f18 * Math_fround(Math_fround(f16 * f9) - Math_fround(f17 * f10)))));
 f25 = Math_fround(Math_fround(f16 * f24) + Math_fround(Math_fround(f7 * f10) + Math_fround(f18 * Math_fround(Math_fround(f17 * f22) - Math_fround(f15 * f9)))));
 f24 = Math_fround(Math_fround(Math_fround(f7 * f9) + Math_fround(f18 * Math_fround(Math_fround(f15 * f10) - Math_fround(f16 * f22)))) + Math_fround(f17 * f24));
 f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f23);
 f25 = Math_fround(f23 + Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f25));
 i21 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f24) + f25) < Math_fround(0.0);
 f25 = Math_fround(Math_fround(360.0) - f26);
 f26 = i21 ? f25 : f26;
 i21 = f26 > Math_fround(180.0);
 f25 = Math_fround(f26 + Math_fround(-360.0));
 f26 = i21 ? f25 : f26;
 STACKTOP = i20;
 return Math_fround(f26);
}

function _UNITY_FT_Bitmap_Embolden(i4, i22, i1, i2) {
 i4 = i4 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i23;
 if (!i4) {
  i22 = 33;
  STACKTOP = i23;
  return i22 | 0;
 }
 if (!i22) {
  i22 = 6;
  STACKTOP = i23;
  return i22 | 0;
 }
 i11 = i22 + 12 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  i22 = 6;
  STACKTOP = i23;
  return i22 | 0;
 }
 i3 = i1 + 32 >> 6;
 i2 = i2 + 32 >> 6;
 i1 = i2 | i3;
 if (!i1) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 if ((i1 | 0) < 0) {
  i22 = 6;
  STACKTOP = i23;
  return i22 | 0;
 }
 i21 = i22 + 18 | 0;
 i1 = HEAP8[i21 >> 0] | 0;
 L16 : do switch (i1 << 24 >> 24) {
 case 4:
 case 3:
  {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   HEAP32[i8 + 16 >> 2] = 0;
   HEAP32[i8 + 20 >> 2] = 0;
   i1 = _UNITY_FT_Bitmap_Convert(i4, i22, i8, 1) | 0;
   if (!i1) {
    _UNITY_ft_mem_free(HEAP32[i4 >> 2] | 0, HEAP32[i11 >> 2] | 0);
    HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i22 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i22 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i22 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    i20 = i3;
    i1 = HEAP8[i21 >> 0] | 0;
    break L16;
   }
   i22 = i1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 1:
  {
   i20 = (i3 | 0) > 8 ? 8 : i3;
   i1 = 1;
   break;
  }
 case 5:
  {
   i20 = i3 * 3 | 0;
   i1 = 5;
   break;
  }
 case 6:
  {
   i2 = i2 * 3 | 0;
   i20 = i3;
   i1 = 6;
   break;
  }
 case 7:
  {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  i20 = i3;
 } while (0);
 i7 = HEAP32[i4 >> 2] | 0;
 i19 = i22 + 4 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i10 = HEAP32[i18 >> 2] | 0;
 i10 = (i10 | 0) < 0 ? 0 - i10 | 0 : i10;
 switch (i1 << 24 >> 24) {
 case 1:
  {
   i6 = (i20 + 7 + i5 | 0) >>> 3;
   i3 = 1;
   i9 = 18;
   break;
  }
 case 3:
  {
   i6 = (i20 + 3 + i5 | 0) >>> 2;
   i3 = 2;
   i9 = 18;
   break;
  }
 case 4:
  {
   i6 = (i20 + 1 + i5 | 0) >>> 1;
   i3 = 4;
   i9 = 18;
   break;
  }
 case 6:
 case 5:
 case 2:
  {
   i6 = i5 + i20 | 0;
   i3 = 8;
   i9 = 18;
   break;
  }
 default:
  i1 = 18;
 }
 do if ((i9 | 0) == 18) {
  if ((i2 | 0) != 0 | (i6 | 0) > (i10 | 0)) {
   i4 = _UNITY_ft_mem_qrealloc(i7, i4 + i2 | 0, 0, i6, 0, i8) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) break;
   i3 = ((Math_imul(i3, i5) | 0) + 7 | 0) >>> 3;
   i1 = (HEAP32[i22 >> 2] | 0) != 0;
   if ((HEAP32[i18 >> 2] | 0) > 0) {
    if (i1) {
     i1 = 0;
     do {
      i17 = i4 + (Math_imul(i1 + i2 | 0, i6) | 0) | 0;
      _memcpy(i17 | 0, (HEAP32[i11 >> 2] | 0) + (Math_imul(i1, i10) | 0) | 0, i3 | 0) | 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
    }
   } else if (i1) {
    i1 = 0;
    do {
     i17 = i4 + (Math_imul(i1, i6) | 0) | 0;
     _memcpy(i17 | 0, (HEAP32[i11 >> 2] | 0) + (Math_imul(i1, i10) | 0) | 0, i3 | 0) | 0;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
   }
   _UNITY_ft_mem_free(i7, HEAP32[i11 >> 2] | 0);
   HEAP32[i11 >> 2] = i4;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) < 0 ? 0 - i6 | 0 : i6;
  } else {
   i3 = Math_imul(i3, i5 + i20 | 0) | 0;
   if (i3 >>> 0 < i10 << 3 >>> 0) {
    i17 = HEAP32[i11 >> 2] | 0;
    i1 = i17 + (i3 >>> 3) | 0;
    i5 = i3 & 7;
    i6 = 65280 >>> i5;
    i3 = i17 + i10 | 0;
    if (i4 | 0) if (!i5) while (1) {
     if (i1 >>> 0 < i3 >>> 0) _memset(i1 | 0, 0, i3 - i1 | 0) | 0;
     i4 = i4 + -1 | 0;
     if (!i4) break; else {
      i3 = i3 + i10 | 0;
      i1 = i1 + i10 | 0;
     }
    } else while (1) {
     HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & i6;
     i5 = i1 + 1 | 0;
     if (i5 >>> 0 < i3 >>> 0) _memset(i5 | 0, 0, i3 - i5 | 0) | 0;
     i4 = i4 + -1 | 0;
     if (!i4) break; else {
      i3 = i3 + i10 | 0;
      i1 = i1 + i10 | 0;
     }
    }
   }
  }
  i4 = HEAP32[i18 >> 2] | 0;
  if ((i4 | 0) > 0) {
   i3 = (HEAP32[i11 >> 2] | 0) + (Math_imul(i4, i2) | 0) | 0;
   i17 = i4;
   i1 = HEAP32[i22 >> 2] | 0;
  } else {
   i3 = 0 - i4 | 0;
   i1 = HEAP32[i22 >> 2] | 0;
   i17 = i3;
   i3 = (HEAP32[i11 >> 2] | 0) + (Math_imul(i1 + -1 | 0, i3) | 0) | 0;
  }
  if (!i1) i1 = 0; else {
   i12 = (i17 | 0) > 0;
   i13 = (i20 | 0) < 1;
   i14 = i22 + 16 | 0;
   i15 = (i2 | 0) < 1;
   i16 = i2 + 1 | 0;
   i11 = 0;
   i1 = i4;
   while (1) {
    if (i12) {
     i8 = i17;
     do {
      i9 = i8;
      i8 = i8 + -1 | 0;
      i10 = i3 + i8 | 0;
      L71 : do if (!i13) {
       i1 = HEAP8[i10 >> 0] | 0;
       i7 = i1 & 255;
       i6 = i3 + (i9 + -2) | 0;
       L73 : do if ((i9 | 0) > 1) {
        i5 = 1;
        while (1) {
         if ((HEAP8[i21 >> 0] | 0) == 1) {
          i1 = (HEAPU8[i6 >> 0] << 8 - i5 | (i1 & 255 | i7 >>> i5)) & 255;
          HEAP8[i10 >> 0] = i1;
         } else {
          i4 = i8 - i5 | 0;
          if ((i4 | 0) <= -1) break L71;
          i4 = (HEAPU8[i3 + i4 >> 0] | 0) + (i1 & 255) | 0;
          i1 = HEAPU16[i14 >> 1] | 0;
          if (i4 >>> 0 >= i1 >>> 0) break L73;
          i1 = i4 & 255;
          HEAP8[i10 >> 0] = i1;
          if ((i4 & 255 | 0) == ((HEAPU16[i14 >> 1] | 0) + -1 | 0)) break L71;
         }
         if ((i5 | 0) < (i20 | 0)) i5 = i5 + 1 | 0; else break L71;
        }
       } else {
        i5 = 1;
        while (1) {
         if ((HEAP8[i21 >> 0] | 0) == 1) {
          i1 = (i1 & 255 | i7 >>> i5) & 255;
          HEAP8[i10 >> 0] = i1;
         } else {
          i4 = i8 - i5 | 0;
          if ((i4 | 0) <= -1) break L71;
          i4 = (HEAPU8[i3 + i4 >> 0] | 0) + (i1 & 255) | 0;
          i1 = HEAPU16[i14 >> 1] | 0;
          if (i4 >>> 0 >= i1 >>> 0) break L73;
          i1 = i4 & 255;
          HEAP8[i10 >> 0] = i1;
          if ((i4 & 255 | 0) == ((HEAPU16[i14 >> 1] | 0) + -1 | 0)) break L71;
         }
         if ((i5 | 0) < (i20 | 0)) i5 = i5 + 1 | 0; else break L71;
        }
       } while (0);
       HEAP8[i10 >> 0] = i1 + 255;
      } while (0);
     } while ((i9 | 0) > 1);
     i1 = HEAP32[i18 >> 2] | 0;
    }
    L94 : do if (i15) i4 = i1; else {
     if (i12) i5 = 1; else {
      i4 = 1;
      while (1) {
       i4 = i4 + 1 | 0;
       if ((i4 | 0) == (i16 | 0)) {
        i4 = i1;
        break L94;
       }
      }
     }
     do {
      i4 = i3 + (Math_imul(i1, 0 - i5 | 0) | 0) | 0;
      i1 = 0;
      do {
       i10 = i4 + i1 | 0;
       HEAP8[i10 >> 0] = HEAP8[i10 >> 0] | HEAP8[i3 + i1 >> 0];
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i17 | 0));
      i5 = i5 + 1 | 0;
      i1 = HEAP32[i18 >> 2] | 0;
     } while ((i5 | 0) != (i16 | 0));
     i4 = i1;
    } while (0);
    i11 = i11 + 1 | 0;
    i1 = HEAP32[i22 >> 2] | 0;
    if (i11 >>> 0 >= i1 >>> 0) break; else {
     i3 = i3 + i4 | 0;
     i1 = i4;
    }
   }
  }
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i20;
  HEAP32[i22 >> 2] = i1 + i2;
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 } while (0);
 i22 = i1;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN26PlayerSettingsSplashScreen8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i9 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450096 | 0, HEAP32[gb + 36980 >> 2] | 0, i9, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450126 | 0, i9, i1 + 4 | 0, 0);
 i7 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450150 | 0, i9, i1 + 5 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450172 | 0, i9, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450201 | 0, i6, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i5 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450225 | 0, i6, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i5 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450249 | 0, i6, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450272 | 0, i9, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450310 | 0, i9, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450342 | 0, i9, i5, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450382 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 40 | 0;
 i10 = HEAP32[gb + 37212 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450421 | 0, i10, i9, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450458 | 0, i10, i9, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450494 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 72 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI16SplashScreenLogoEEvRT_17TransferMetaFlags(i2, i4, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 if (Math_fround(HEAPF32[i5 >> 2]) < Math_fround(0.0)) HEAPF32[i5 >> 2] = Math_fround(0.0);
 if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(0.0)) HEAPF32[i6 >> 2] = Math_fround(0.0);
 i9 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450514 | 0, gb + 1034905 | 0, i9, 0);
 i10 = i4 + 8 | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i5, i9, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450548 | 0, gb + 1034905 | 0, i10, 0);
 i6 = i4 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i5, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450581 | 0, gb + 1034905 | 0, i6, 0);
 i10 = i4 + 8 | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i5, i6, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i8;
 return;
}

function __ZN11Rigidbody2D22ApplyRootMotionBuiltinEP14RootMotionData(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 i17 = i15 + 92 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i6 = i15 + 68 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == 2) {
  STACKTOP = i19;
  return;
 }
 i18 = i16 + 32 | 0;
 if (HEAP8[i18 >> 0] | 0) {
  STACKTOP = i19;
  return;
 }
 if ((i2 | 0) == 1) {
  i13 = i1 + 12 | 0;
  i15 = HEAP32[i13 + 4 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i14 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i13 >> 2]));
  f10 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  HEAPF32[i14 + 4 >> 2] = Math_fround(f10 + (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f10 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  i15 = f10 < Math_fround(0.0);
  f8 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f7 = Math_fround(-f8);
  f9 = Math_fround(-f10);
  __ZN6b2Body12SetTransformERK6b2Vec2f(i1, i14, Math_fround(Math_fround(+Math_atan2(+(i15 ? f7 : f8), +(i15 ? f9 : f10))) * Math_fround(2.0)));
 } else {
  __ZNK9Transform11GetRotationEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i15 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f4 = Math_fround(HEAPF32[i14 >> 2]);
  f5 = Math_fround(-f4);
  i11 = i14 + 4 | 0;
  f7 = Math_fround(HEAPF32[i11 >> 2]);
  f8 = Math_fround(-f7);
  i12 = i14 + 8 | 0;
  f9 = Math_fround(HEAPF32[i12 >> 2]);
  i13 = i14 + 12 | 0;
  f10 = Math_fround(HEAPF32[i13 >> 2]);
  i1 = HEAP32[i17 >> 2] | 0;
  do if (!i1) {
   i2 = gb + 1162356 | 0;
   i1 = gb + 1162356 + 4 | 0;
  } else if ((HEAP32[i6 >> 2] | 0) == 2) {
   i2 = gb + 1162356 | 0;
   i1 = gb + 1162356 + 4 | 0;
  } else if (!(HEAP8[i15 + 226 >> 0] | 0)) {
   i2 = i1 + 64 | 0;
   i1 = i1 + 68 | 0;
   break;
  } else {
   i2 = i15 + 212 | 0;
   i1 = i15 + 216 | 0;
   break;
  } while (0);
  f28 = Math_fround(HEAPF32[i1 >> 2]);
  f20 = Math_fround(f4 * Math_fround(-2.0));
  f22 = Math_fround(f7 * Math_fround(-2.0));
  f24 = Math_fround(f9 * Math_fround(-2.0));
  f4 = Math_fround(f20 * f5);
  f21 = Math_fround(f22 * f8);
  f23 = Math_fround(f9 * f24);
  f9 = Math_fround(f22 * f5);
  f27 = Math_fround(f24 * f5);
  f8 = Math_fround(f24 * f8);
  f20 = Math_fround(f20 * f10);
  f22 = Math_fround(f22 * f10);
  f24 = Math_fround(f10 * f24);
  f25 = Math_fround(Math_fround(1.0) - Math_fround(f21 - f23));
  f7 = Math_fround(f9 - f24);
  f26 = Math_fround(f27 + f22);
  f24 = Math_fround(f9 + f24);
  f23 = Math_fround(Math_fround(1.0) - Math_fround(f4 - f23));
  f9 = Math_fround(f8 - f20);
  f5 = Math_fround(Math_fround(f9 * Math_fround(0.0)) + Math_fround(Math_fround(f23 * f28) + Math_fround(f24 * Math_fround(HEAPF32[i2 >> 2]))));
  f22 = Math_fround(f27 - f22);
  f20 = Math_fround(f8 + f20);
  f10 = Math_fround(Math_fround(1.0) - Math_fround(f4 + f21));
  f8 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
  f21 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
  f4 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 4 >> 2]));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2]));
  f7 = Math_fround(Math_fround(f26 * f8) + Math_fround(Math_fround(f25 * f21) + Math_fround(f7 * f4)));
  f9 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * f4)) + Math_fround(f9 * f8));
  f8 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f4)) + Math_fround(f10 * f8));
  i1 = i16 + 28 | 0;
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(Math_fround(f5 * f10) + Math_fround(Math_fround(Math_fround(1.0) - f10) * f9));
  i2 = i15 + 44 | 0;
  if (Math_fround(HEAPF32[i2 >> 2]) > Math_fround(0.0)) {
   i3 = (__Z21GetManagerFromContexti(16) | 0) + 32 | 0;
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f4 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
   f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 4 >> 2]));
   f28 = Math_fround(HEAPF32[i15 + 32 >> 2]);
   f4 = Math_fround(f4 * f28);
   f28 = Math_fround(f5 * f28);
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   f5 = Math_fround(-Math_fround(Math_fround(f5 * Math_fround(0.0)) + Math_fround(Math_fround(1.0) - f5)));
   f4 = Math_fround(f4 * f5);
   f5 = Math_fround(f28 * f5);
   i3 = HEAP32[i17 >> 2] | 0;
   if (!(HEAP32[i6 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == 2) {
    i2 = i3 + 4 | 0;
    i1 = HEAP16[i2 >> 1] | 0;
    if (!(i1 & 2)) {
     i6 = i1 & 65535;
     if (!(i6 & 2)) {
      i1 = (i6 | 2) & 65535;
      HEAP16[i2 >> 1] = i1;
      HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
     }
    }
    if (i1 & 2) {
     i6 = i3 + 76 | 0;
     HEAPF32[i6 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i6 >> 2]));
     i6 = i3 + 80 | 0;
     HEAPF32[i6 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
    }
   }
  } else i3 = HEAP32[i17 >> 2] | 0;
  f21 = Math_fround(HEAPF32[i14 >> 2]);
  f24 = Math_fround(f21 * Math_fround(2.0));
  f23 = Math_fround(HEAPF32[i11 >> 2]);
  f22 = Math_fround(f23 * Math_fround(2.0));
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f27 = Math_fround(f4 * Math_fround(2.0));
  f28 = Math_fround(f21 * f24);
  f5 = Math_fround(f23 * f22);
  f4 = Math_fround(f4 * f27);
  f26 = Math_fround(f21 * f22);
  f21 = Math_fround(f21 * f27);
  f23 = Math_fround(f23 * f27);
  f25 = Math_fround(HEAPF32[i13 >> 2]);
  f27 = Math_fround(f25 * f27);
  f5 = Math_fround(Math_fround(f8 * Math_fround(f21 + Math_fround(f22 * f25))) + Math_fround(Math_fround(f9 * Math_fround(f26 - f27)) + Math_fround(f7 * Math_fround(Math_fround(1.0) - Math_fround(f5 + f4)))));
  f4 = Math_fround(Math_fround(f8 * Math_fround(f23 - Math_fround(f24 * f25))) + Math_fround(Math_fround(f7 * Math_fround(f26 + f27)) + Math_fround(f9 * Math_fround(Math_fround(1.0) - Math_fround(f28 + f4)))));
  if (HEAP32[i3 >> 2] | 0) {
   if (Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) > Math_fround(0.0)) {
    i1 = i3 + 4 | 0;
    i2 = HEAPU16[i1 >> 1] | 0;
    if (!(i2 & 2)) {
     HEAP16[i1 >> 1] = i2 | 2;
     HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
    }
   }
   HEAPF32[i3 + 64 >> 2] = f5;
   HEAPF32[i3 + 68 >> 2] = f4;
  }
  f28 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  i14 = f28 < Math_fround(0.0);
  f26 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f25 = Math_fround(-f26);
  f27 = Math_fround(-f28);
  __ZN11Rigidbody2D12MoveRotationEf(i15, Math_fround(Math_fround(Math_fround(+Math_atan2(+(i14 ? f25 : f26), +(i14 ? f27 : f28))) * Math_fround(2.0)) * Math_fround(57.2957802)));
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i17 = i1 + 64 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i17 + 16 >> 2] = 0;
  HEAP32[i17 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAP8[i18 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZN5physx13PxParticleExt15buildBoundsHashEPjPNS0_14ParticleBoundsERKNS_16PxStrideIteratorIKNS_6PxVec3EEEjPKjjjf(i29, i24, i22, i25, i30, i5, i21, f2) {
 i29 = i29 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 i30 = i30 | 0;
 i5 = i5 | 0;
 i21 = i21 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i32 + 56 | 0;
 i20 = i32 + 52 | 0;
 i28 = i32 + 40 | 0;
 i4 = i32;
 f2 = Math_fround(Math_fround(1.0) / f2);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 0;
 i27 = i31 + 8 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i31, i25, i20);
 HEAP32[i28 >> 2] = 0;
 i20 = i28 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i26 = i28 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 i1 = i4;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i28, i5, i4);
 i19 = HEAP32[i28 >> 2] | 0;
 _memset(i19 | 0, -1, i5 * 40 | 0) | 0;
 i23 = (i25 | 0) != 0;
 if (i23) {
  i17 = i22 + 4 | 0;
  i18 = HEAP32[i31 >> 2] | 0;
  i14 = i5 + -1 | 0;
  i15 = (i25 + -1 | 0) >>> 5;
  i1 = 0;
  i16 = 0;
  while (1) {
   i3 = HEAP32[i30 + (i16 << 2) >> 2] | 0;
   if (i3) {
    i13 = i16 << 5;
    do {
     i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i13;
     i4 = HEAP32[i22 >> 2] | 0;
     i5 = Math_imul(HEAP32[i17 >> 2] | 0, i6) | 0;
     i9 = i4 + i5 | 0;
     i6 = i18 + (i6 << 2) | 0;
     HEAP32[i6 >> 2] = -1;
     do if (i1 >>> 0 < i21 >>> 0) {
      i10 = ~~Math_fround(Math_floor(Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2]))));
      i11 = i4 + (i5 + 4) | 0;
      i12 = ~~Math_fround(Math_floor(Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2]))));
      i7 = i4 + (i5 + 8) | 0;
      i8 = ~~Math_fround(Math_floor(Math_fround(f2 * Math_fround(HEAPF32[i7 >> 2]))));
      i4 = ((i12 << 16 >> 16) * 101 | 0) + (i10 << 16 >> 16) + ((i8 << 16 >> 16) * 7919 | 0) | 0;
      i4 = i4 + ~(i4 << 15) | 0;
      i4 = (i4 >>> 10 ^ i4) * 9 | 0;
      i4 = i4 >>> 6 ^ i4;
      i4 = i4 + ~(i4 << 11) | 0;
      i4 = (i4 >>> 16 ^ i4) & i14;
      L11 : do if ((HEAP32[i19 + (i4 * 40 | 0) + 36 >> 2] | 0) != -1) do {
       if ((HEAP16[i19 + (i4 * 40 | 0) >> 1] | 0) == i10 << 16 >> 16) if ((HEAP16[i19 + (i4 * 40 | 0) + 2 >> 1] | 0) == i12 << 16 >> 16) if ((HEAP16[i19 + (i4 * 40 | 0) + 4 >> 1] | 0) == i8 << 16 >> 16) break L11;
       i4 = i4 + 1 & i14;
      } while ((HEAP32[i19 + (i4 * 40 | 0) + 36 >> 2] | 0) != -1); while (0);
      HEAP32[i6 >> 2] = i4;
      i5 = i19 + (i4 * 40 | 0) + 36 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i6 | 0) == -1) {
       HEAP16[i19 + (i4 * 40 | 0) >> 1] = i10;
       HEAP16[i19 + (i4 * 40 | 0) + 2 >> 1] = i12;
       HEAP16[i19 + (i4 * 40 | 0) + 4 >> 1] = i8;
       i10 = HEAP32[i9 >> 2] | 0;
       i11 = HEAP32[i11 >> 2] | 0;
       i12 = HEAP32[i7 >> 2] | 0;
       HEAP32[i19 + (i4 * 40 | 0) + 8 >> 2] = i10;
       HEAP32[i19 + (i4 * 40 | 0) + 12 >> 2] = i11;
       HEAP32[i19 + (i4 * 40 | 0) + 16 >> 2] = i12;
       HEAP32[i19 + (i4 * 40 | 0) + 20 >> 2] = i10;
       HEAP32[i19 + (i4 * 40 | 0) + 24 >> 2] = i11;
       HEAP32[i19 + (i4 * 40 | 0) + 28 >> 2] = i12;
       HEAP32[i5 >> 2] = 1;
       i1 = i1 + 1 | 0;
       break;
      } else {
       i12 = i19 + (i4 * 40 | 0) + 8 | 0;
       f33 = Math_fround(HEAPF32[i12 >> 2]);
       f34 = Math_fround(HEAPF32[i9 >> 2]);
       i10 = i19 + (i4 * 40 | 0) + 12 | 0;
       f35 = Math_fround(HEAPF32[i10 >> 2]);
       f36 = Math_fround(HEAPF32[i11 >> 2]);
       i8 = i19 + (i4 * 40 | 0) + 16 | 0;
       f37 = Math_fround(HEAPF32[i8 >> 2]);
       f38 = Math_fround(HEAPF32[i7 >> 2]);
       HEAPF32[i12 >> 2] = f33 < f34 ? f33 : f34;
       HEAPF32[i10 >> 2] = f35 < f36 ? f35 : f36;
       HEAPF32[i8 >> 2] = f37 < f38 ? f37 : f38;
       i8 = i19 + (i4 * 40 | 0) + 20 | 0;
       f38 = Math_fround(HEAPF32[i8 >> 2]);
       f37 = Math_fround(HEAPF32[i9 >> 2]);
       i10 = i19 + (i4 * 40 | 0) + 24 | 0;
       f36 = Math_fround(HEAPF32[i10 >> 2]);
       f35 = Math_fround(HEAPF32[i11 >> 2]);
       i12 = i19 + (i4 * 40 | 0) + 28 | 0;
       f34 = Math_fround(HEAPF32[i12 >> 2]);
       f33 = Math_fround(HEAPF32[i7 >> 2]);
       HEAPF32[i8 >> 2] = f38 > f37 ? f38 : f37;
       HEAPF32[i10 >> 2] = f36 > f35 ? f36 : f35;
       HEAPF32[i12 >> 2] = f34 > f33 ? f34 : f33;
       HEAP32[i5 >> 2] = i6 + 1;
       break;
      }
     } while (0);
     i3 = i3 + -1 & i3;
    } while ((i3 | 0) != 0);
   }
   if ((i16 | 0) == (i15 | 0)) break; else i16 = i16 + 1 | 0;
  }
 }
 i6 = HEAP32[i20 >> 2] | 0;
 if (!i6) i10 = 0; else {
  i7 = HEAP32[i28 >> 2] | 0;
  i1 = 0;
  i8 = 0;
  i3 = 0;
  do {
   i4 = i7 + (i8 * 40 | 0) + 36 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != -1) {
    HEAP32[i7 + (i8 * 40 | 0) + 32 >> 2] = i1;
    HEAP32[i24 + (i3 << 5) >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 8 >> 2];
    HEAP32[i24 + (i3 << 5) + 4 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 12 >> 2];
    HEAP32[i24 + (i3 << 5) + 8 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 16 >> 2];
    HEAP32[i24 + (i3 << 5) + 12 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 20 >> 2];
    HEAP32[i24 + (i3 << 5) + 16 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 24 >> 2];
    HEAP32[i24 + (i3 << 5) + 20 >> 2] = HEAP32[i7 + (i8 * 40 | 0) + 28 >> 2];
    HEAP32[i24 + (i3 << 5) + 24 >> 2] = i1;
    HEAP32[i24 + (i3 << 5) + 28 >> 2] = i5;
    HEAP32[i4 >> 2] = 0;
    i1 = i5 + i1 | 0;
    i3 = i3 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i6 >>> 0);
  i10 = i3;
 }
 if (i23) {
  i5 = (i25 + -1 | 0) >>> 5;
  i6 = HEAP32[i31 >> 2] | 0;
  i7 = HEAP32[i28 >> 2] | 0;
  i9 = 0;
  while (1) {
   i1 = HEAP32[i30 + (i9 << 2) >> 2] | 0;
   if (i1 | 0) {
    i8 = i9 << 5;
    do {
     i3 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i8;
     i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
     if ((i4 | 0) != -1) {
      i25 = i7 + (i4 * 40 | 0) + 36 | 0;
      HEAP32[i29 + ((HEAP32[i25 >> 2] | 0) + (HEAP32[i7 + (i4 * 40 | 0) + 32 >> 2] | 0) << 2) >> 2] = i3;
      HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
     }
     i1 = i1 + -1 & i1;
    } while ((i1 | 0) != 0);
   }
   if ((i9 | 0) == (i5 | 0)) break; else i9 = i9 + 1 | 0;
  }
 }
 i30 = HEAP32[i26 >> 2] | 0;
 if ((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i28 >> 2] | 0;
  if (i1 | 0) {
   i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
  }
 }
 i30 = HEAP32[i27 >> 2] | 0;
 if (!((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0)) {
  STACKTOP = i32;
  return i10 | 0;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 if (!i1) {
  STACKTOP = i32;
  return i10 | 0;
 }
 i31 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, i1 | 0);
 STACKTOP = i32;
 return i10 | 0;
}

function __ZN5Unity10HingeJoint6CreateEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 60 | 0;
 i9 = i14 + 56 | 0;
 i7 = i14 + 28 | 0;
 i8 = i14;
 if (!(HEAP8[i12 + 157 >> 0] | 0)) i1 = HEAP8[i12 + 158 >> 0] | 0; else i1 = 0;
 HEAP8[i12 + 159 >> 0] = i1;
 i6 = i12 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 1065353216;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAP32[i7 + 24 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 1065353216;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i13 | 0, i1 | 0, 0);
  HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
  i10 = HEAP32[i6 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i13 | 0, i10 | 0, 1);
  HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 }
 __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv(i12);
 __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_(i12, i7, i8);
 __ZN5Unity5Joint14FinalizeCreateEb(i12, 0);
 i10 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
 i8 = i12 + 92 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i7 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i6 + (i7 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i9);
    i6 = HEAP32[i13 >> 2] | 0;
    i15 = HEAP32[i1 + 28 >> 2] | 0;
    i7 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i6 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i6 << 3) | 0;
    i6 = HEAP32[i7 + 28 >> 2] | 0;
    i7 = HEAP32[i7 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i6 + (i7 << 3) | 0)) i11 = 12; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 14;
  }
  if ((i11 | 0) == 12) i11 = 14;
  if ((i11 | 0) == 14) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 20; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i7 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i6 + (i7 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i9);
    i6 = HEAP32[i13 >> 2] | 0;
    i15 = HEAP32[i1 + 28 >> 2] | 0;
    i7 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i6 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i6 << 3) | 0;
    i6 = HEAP32[i7 + 28 >> 2] | 0;
    i7 = HEAP32[i7 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i6 + (i7 << 3) | 0)) i11 = 20; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 22;
   }
  }
  if ((i11 | 0) == 20) i11 = 22;
  if ((i11 | 0) == 22) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 52 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i13 | 0, i10 | 0);
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 f3 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 if (!i1) {
  f22 = Math_fround(0.0);
  f20 = Math_fround(1.0);
  f19 = Math_fround(0.0);
  f18 = Math_fround(0.0);
  f21 = Math_fround(-f2);
  f16 = Math_fround(-f3);
  f17 = Math_fround(-f4);
  f23 = Math_fround(f20 * f21);
  f2 = Math_fround(f5 * f22);
  f23 = Math_fround(f2 + f23);
  f2 = Math_fround(f19 * f17);
  f23 = Math_fround(f2 + f23);
  f2 = Math_fround(f18 * f16);
  f2 = Math_fround(f23 - f2);
  f23 = Math_fround(f20 * f16);
  f3 = Math_fround(f5 * f19);
  f23 = Math_fround(f3 + f23);
  f3 = Math_fround(f18 * f21);
  f23 = Math_fround(f3 + f23);
  f3 = Math_fround(f22 * f17);
  f3 = Math_fround(f23 - f3);
  f23 = Math_fround(f20 * f17);
  f4 = Math_fround(f5 * f18);
  f23 = Math_fround(f4 + f23);
  f4 = Math_fround(f22 * f16);
  f23 = Math_fround(f4 + f23);
  f4 = Math_fround(f19 * f21);
  f4 = Math_fround(f23 - f4);
  f20 = Math_fround(f5 * f20);
  f5 = Math_fround(f22 * f21);
  f5 = Math_fround(f20 - f5);
  f16 = Math_fround(f19 * f16);
  f16 = Math_fround(f5 - f16);
  f5 = Math_fround(f18 * f17);
  f5 = Math_fround(f16 - f5);
  i15 = i12 + 140 | 0;
  HEAPF32[i15 >> 2] = f2;
  i15 = i12 + 144 | 0;
  HEAPF32[i15 >> 2] = f3;
  i15 = i12 + 148 | 0;
  HEAPF32[i15 >> 2] = f4;
  i15 = i12 + 152 | 0;
  HEAPF32[i15 >> 2] = f5;
  STACKTOP = i14;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i13 | 0, i1 | 0);
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f16 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f17 = Math_fround(-f2);
 f19 = Math_fround(-f3);
 f23 = Math_fround(-f4);
 f4 = Math_fround(f25 * f17);
 f20 = Math_fround(f5 * f24);
 f4 = Math_fround(f20 + f4);
 f20 = Math_fround(f16 * f23);
 f4 = Math_fround(f20 + f4);
 f20 = Math_fround(f18 * f19);
 f20 = Math_fround(f4 - f20);
 f4 = Math_fround(f25 * f19);
 f21 = Math_fround(f5 * f16);
 f4 = Math_fround(f21 + f4);
 f21 = Math_fround(f18 * f17);
 f4 = Math_fround(f21 + f4);
 f21 = Math_fround(f24 * f23);
 f21 = Math_fround(f4 - f21);
 f4 = Math_fround(f25 * f23);
 f22 = Math_fround(f5 * f18);
 f4 = Math_fround(f22 + f4);
 f22 = Math_fround(f24 * f19);
 f4 = Math_fround(f22 + f4);
 f22 = Math_fround(f16 * f17);
 f22 = Math_fround(f4 - f22);
 f5 = Math_fround(f5 * f25);
 f17 = Math_fround(f24 * f17);
 f17 = Math_fround(f5 - f17);
 f19 = Math_fround(f16 * f19);
 f19 = Math_fround(f17 - f19);
 f23 = Math_fround(f18 * f23);
 f23 = Math_fround(f19 - f23);
 i15 = i12 + 140 | 0;
 HEAPF32[i15 >> 2] = f20;
 i15 = i12 + 144 | 0;
 HEAPF32[i15 >> 2] = f21;
 i15 = i12 + 148 | 0;
 HEAPF32[i15 >> 2] = f22;
 i15 = i12 + 152 | 0;
 HEAPF32[i15 >> 2] = f23;
 STACKTOP = i14;
 return;
}

function __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i2 = i10 + 4 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i8, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i1 = 0;
 do {
  HEAP32[i4 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 471386 | 0, i4);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) | 0, gb + 471425 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 8 | 0, gb + 471461 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 16 | 0, gb + 471471 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 24 | 0, gb + 471485 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 32 | 0, gb + 471500 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 40 | 0, gb + 471508 | 0, 0);
  __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 64 + (i1 * 56 | 0) + 48 | 0, gb + 471521 | 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i1 = i8 + 717 | 0;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = i9 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 16 | 0, gb + 471529 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 24 | 0, gb + 471535 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 32 | 0, gb + 471542 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 40 | 0, gb + 471550 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 48 | 0, gb + 471563 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 56 | 0, gb + 471575 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 512 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 520 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 528 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 536 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 544 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 552 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 560 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 568 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 576 | 0, gb + 471784 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 584 | 0, gb + 471789 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 592 | 0, gb + 471794 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 600 | 0, gb + 471800 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 608 | 0, gb + 471646 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 616 | 0, gb + 471662 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 624 | 0, gb + 471679 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 632 | 0, gb + 471690 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 640 | 0, gb + 471699 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i9, i8 + 648 | 0, gb + 471706 | 0, 0);
 __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i8 + 656 | 0, i9);
 i5 = i8 + 692 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = i8 + 696 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 700 | 0, i9);
 i1 = i8 + 712 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i8 + 716 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i19, i24, i22, i25, i23, i21, f17, i2) {
 i19 = i19 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 f17 = Math_fround(f17);
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i26;
 i16 = i26 + 32 | 0;
 i20 = (i21 | 0) == 0;
 if (!i20) {
  i1 = 0;
  do {
   HEAP32[i22 + (i1 << 4) + 8 >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i21 | 0));
 }
 HEAP32[i18 >> 2] = 2139095039;
 HEAP32[i18 + 4 >> 2] = 2139095039;
 HEAP32[i18 + 8 >> 2] = 2139095039;
 i15 = i24 + 7 & -4;
 i10 = i24 >>> 0 > 1 ? i19 + 32 | 0 : i18;
 i11 = i24 >>> 0 > 2 ? i19 + 64 | 0 : i18;
 i12 = i24 >>> 0 > 3 ? i19 + 96 | 0 : i18;
 f29 = Math_fround(HEAPF32[i19 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 f29 = Math_fround(f29 - f28);
 f6 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 - f13);
 f27 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f27 = Math_fround(f27 - f14);
 HEAP32[i16 >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
 HEAP32[i16 + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f6 * f17)));
 HEAP32[i16 + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
 f27 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f28);
 f6 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) - f13);
 f29 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f14);
 HEAP32[i16 + 12 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
 HEAP32[i16 + 16 >> 2] = ~~Math_fround(Math_floor(Math_fround(f6 * f17)));
 HEAP32[i16 + 20 >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
 f29 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f28);
 f6 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) - f13);
 f27 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f14);
 HEAP32[i16 + 24 >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
 HEAP32[i16 + 28 >> 2] = ~~Math_fround(Math_floor(Math_fround(f6 * f17)));
 HEAP32[i16 + 32 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
 f28 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f28);
 f27 = Math_fround(Math_fround(HEAPF32[i12 + 4 >> 2]) - f13);
 f6 = Math_fround(Math_fround(HEAPF32[i12 + 8 >> 2]) - f14);
 HEAP32[i16 + 36 >> 2] = ~~Math_fround(Math_floor(Math_fround(f28 * f17)));
 HEAP32[i16 + 40 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
 HEAP32[i16 + 44 >> 2] = ~~Math_fround(Math_floor(Math_fround(f6 * f17)));
 if (i15 | 0) {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i7 = i21 + -1 | 0;
  i11 = 0;
  do {
   i12 = i11;
   i11 = i11 + 4 | 0;
   i9 = i11 >>> 0 < i24 >>> 0 ? i19 + (i11 << 5) | 0 : i18;
   i4 = i12 + 5 | 0;
   i4 = i4 >>> 0 < i24 >>> 0 ? i19 + (i4 << 5) | 0 : i18;
   i5 = i12 + 6 | 0;
   i5 = i5 >>> 0 < i24 >>> 0 ? i19 + (i5 << 5) | 0 : i18;
   i10 = i12 + 7 | 0;
   i10 = i10 >>> 0 < i24 >>> 0 ? i19 + (i10 << 5) | 0 : i18;
   i8 = i11 & 4;
   f29 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f6);
   f28 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) - f13);
   f27 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) - f14);
   HEAP32[i16 + (i8 * 12 | 0) >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
   HEAP32[i16 + (i8 * 12 | 0) + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f28 * f17)));
   HEAP32[i16 + (i8 * 12 | 0) + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
   i9 = i8 | 1;
   f27 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f6);
   f28 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - f13);
   f29 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) - f14);
   HEAP32[i16 + (i9 * 12 | 0) >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
   HEAP32[i16 + (i9 * 12 | 0) + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f28 * f17)));
   HEAP32[i16 + (i9 * 12 | 0) + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
   i9 = i8 | 2;
   f29 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f28 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f13);
   f27 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f14);
   HEAP32[i16 + (i9 * 12 | 0) >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
   HEAP32[i16 + (i9 * 12 | 0) + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f28 * f17)));
   HEAP32[i16 + (i9 * 12 | 0) + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
   i8 = i8 | 3;
   f27 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f6);
   f28 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) - f13);
   f29 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f14);
   HEAP32[i16 + (i8 * 12 | 0) >> 2] = ~~Math_fround(Math_floor(Math_fround(f27 * f17)));
   HEAP32[i16 + (i8 * 12 | 0) + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f28 * f17)));
   HEAP32[i16 + (i8 * 12 | 0) + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(f29 * f17)));
   i8 = i12 & 4;
   i10 = 0;
   do {
    i9 = i10 + i12 | 0;
    L11 : do if (i9 >>> 0 < i24 >>> 0) {
     i2 = i10 + i8 | 0;
     i1 = HEAP32[i16 + (i2 * 12 | 0) >> 2] | 0;
     i3 = i1 & 65535;
     i30 = HEAP32[i16 + (i2 * 12 | 0) + 4 >> 2] | 0;
     i4 = i30 & 65535;
     i2 = HEAP32[i16 + (i2 * 12 | 0) + 8 >> 2] | 0;
     i5 = i2 & 65535;
     i2 = ((i30 << 16 >> 16) * 101 | 0) + (i1 << 16 >> 16) + ((i2 << 16 >> 16) * 7919 | 0) & i7;
     i1 = HEAP32[i22 + (i2 << 4) + 8 >> 2] | 0;
     L13 : do if ((i1 | 0) != -1) {
      while (1) {
       if (i3 << 16 >> 16 == (HEAP16[i22 + (i2 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i22 + (i2 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i22 + (i2 << 4) + 4 >> 1] | 0)) break;
       i2 = i2 + 1 & i7;
       i1 = HEAP32[i22 + (i2 << 4) + 8 >> 2] | 0;
       if ((i1 | 0) == -1) break L13;
      }
      HEAP16[i23 + (i9 << 1) >> 1] = i2;
      HEAP32[i22 + (i2 << 4) + 8 >> 2] = i1 + 1;
      break L11;
     } while (0);
     HEAP16[i23 + (i9 << 1) >> 1] = i2;
     HEAP16[i22 + (i2 << 4) >> 1] = i3;
     HEAP16[i22 + (i2 << 4) + 2 >> 1] = i4;
     HEAP16[i22 + (i2 << 4) + 4 >> 1] = i5;
     HEAP32[i22 + (i2 << 4) + 8 >> 2] = 1;
    } while (0);
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != 4);
  } while (i11 >>> 0 < i15 >>> 0);
 }
 if (!i20) {
  i3 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i22 + (i3 << 4) + 8 >> 2] | 0;
   if ((i2 | 0) != -1) {
    HEAP32[i22 + (i3 << 4) + 12 >> 2] = i1;
    i1 = i2 + i1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i21 | 0));
  if (!i20) {
   i2 = 0;
   do {
    i1 = i22 + (i2 << 4) + 8 | 0;
    if ((HEAP32[i1 >> 2] | 0) != -1) HEAP32[i1 >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i21 | 0));
  }
 }
 if (!i24) {
  STACKTOP = i26;
  return;
 } else i1 = 0;
 do {
  i21 = HEAPU16[i23 + (i1 << 1) >> 1] | 0;
  i30 = i22 + (i21 << 4) + 8 | 0;
  HEAP32[i25 + ((HEAP32[i30 >> 2] | 0) + (HEAP32[i22 + (i21 << 4) + 12 >> 2] | 0) << 2) >> 2] = i1;
  HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i24 | 0));
 STACKTOP = i26;
 return;
}

function __Z14replace_stringI8UnityStrEvRT_RKS1_S4_j(i24, i20, i21, i11) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27 + 16 | 0;
 i26 = i27;
 i17 = i20 + 11 | 0;
 i23 = HEAP8[i17 >> 0] | 0;
 i2 = i23 << 24 >> 24 < 0;
 i18 = i20 + 4 | 0;
 switch ((i2 ? HEAP32[i18 >> 2] | 0 : i23 & 255) | 0) {
 case 1:
  {
   i19 = 2;
   break;
  }
 case 0:
  {
   STACKTOP = i27;
   return;
  }
 default:
  {}
 }
 if ((i19 | 0) == 2) {
  i23 = HEAP8[i21 + 11 >> 0] | 0;
  i5 = i23 << 24 >> 24 < 0;
  if (((i5 ? HEAP32[i21 + 4 >> 2] | 0 : i23 & 255) | 0) == 1) {
   i26 = HEAP8[i24 + 11 >> 0] | 0;
   i4 = i26 << 24 >> 24 < 0;
   i1 = i4 ? HEAP32[i24 >> 2] | 0 : i24;
   i26 = i4 ? HEAP32[i24 + 4 >> 2] | 0 : i26 & 255;
   i4 = i1 + i26 | 0;
   i3 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
   i2 = i5 ? HEAP32[i21 >> 2] | 0 : i21;
   if (!i26) {
    STACKTOP = i27;
    return;
   }
   do {
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0)) HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   STACKTOP = i27;
   return;
  }
 }
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i22 = i24 + 11 | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i23 = i24 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE7reserveEj(i26, i2 << 24 >> 24 < 0 ? HEAP32[i23 >> 2] | 0 : i2 & 255);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i26, i24, 0, i11) | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i10 = i3 ? HEAP32[i24 >> 2] | 0 : i24;
 i2 = i3 ? HEAP32[i23 >> 2] | 0 : i2 & 255;
 i3 = HEAP8[i17 >> 0] | 0;
 i16 = i3 << 24 >> 24 < 0;
 i8 = i16 ? HEAP32[i20 >> 2] | 0 : i20;
 i3 = i16 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
 L15 : do if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) i19 = 20; else {
  if (!i3) i1 = i11; else {
   i1 = i10 + i11 | 0;
   i9 = i10 + i2 | 0;
   i6 = i8 + i3 | 0;
   i7 = i9;
   L19 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
    i4 = i9 + (1 - i3) | 0;
    if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
     i5 = HEAP8[i8 >> 0] | 0;
     L22 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i8;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i7;
        break L19;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i6 | 0)) break L22;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i7;
       break L19;
      }
     }
    }
   } while (0);
   if ((i1 | 0) == (i9 | 0)) {
    i19 = 20;
    break;
   } else i1 = i1 - i10 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i26, i24, i11, i1 - i11 | 0) | 0;
  if ((i1 | 0) != -1) {
   i12 = i21 + 11 | 0;
   i13 = i21 + 4 | 0;
   i14 = i26 + 11 | 0;
   i15 = i26 + 8 | 0;
   i16 = i26 + 4 | 0;
   while (1) {
    i6 = HEAP8[i12 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i5 = i2 ? HEAP32[i21 >> 2] | 0 : i21;
    i6 = i2 ? HEAP32[i13 >> 2] | 0 : i6 & 255;
    i2 = HEAP8[i14 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) {
     i4 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
     i2 = HEAP32[i16 >> 2] | 0;
    } else {
     i4 = 10;
     i2 = i2 & 255;
    }
    if ((i4 - i2 | 0) >>> 0 < i6 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i26, i4, i6 - i4 + i2 | 0, i2, i2, 0, i6, i5); else if (i6 | 0) {
     i3 = i3 ? HEAP32[i26 >> 2] | 0 : i26;
     _memcpy(i3 + i2 | 0, i5 | 0, i6 | 0) | 0;
     i2 = i2 + i6 | 0;
     if ((HEAP8[i14 >> 0] | 0) < 0) HEAP32[i16 >> 2] = i2; else HEAP8[i14 >> 0] = i2;
     HEAP8[i3 + i2 >> 0] = 0;
    }
    i3 = HEAP8[i17 >> 0] | 0;
    i8 = i3 << 24 >> 24 < 0;
    i3 = i8 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
    i11 = i3 + i1 | 0;
    i2 = HEAP8[i22 >> 0] | 0;
    i9 = i2 << 24 >> 24 < 0;
    i10 = i9 ? HEAP32[i24 >> 2] | 0 : i24;
    i2 = i9 ? HEAP32[i23 >> 2] | 0 : i2 & 255;
    i8 = i8 ? HEAP32[i20 >> 2] | 0 : i20;
    if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) break;
    if (!i3) i1 = i11; else {
     i1 = i10 + i11 | 0;
     i9 = i10 + i2 | 0;
     i6 = i8 + i3 | 0;
     i7 = i9;
     L53 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
      i4 = i9 + (1 - i3) | 0;
      if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
       i5 = HEAP8[i8 >> 0] | 0;
       L56 : while (1) {
        while (1) {
         if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
          i2 = i8;
          i3 = i1;
          break;
         }
         i1 = i1 + 1 | 0;
         if ((i1 | 0) == (i4 | 0)) {
          i1 = i7;
          break L53;
         }
        }
        do {
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i6 | 0)) break L56;
         i3 = i3 + 1 | 0;
        } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i4 | 0)) {
         i1 = i7;
         break L53;
        }
       }
      }
     } while (0);
     if ((i1 | 0) == (i9 | 0)) break; else i1 = i1 - i10 | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i26, i24, i11, i1 - i11 | 0) | 0;
    if ((i1 | 0) == -1) break L15;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i26, i24, i11, ~i11) | 0;
  }
 } while (0);
 if ((i19 | 0) == 20) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i26, i24, i11, ~i11) | 0;
 i4 = i26 + 11 | 0;
 do if ((i26 | 0) != (i24 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i26 >> 2] | 0 : i26;
  i6 = i1 ? HEAP32[i26 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i22 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i24 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i23 = i2 ? HEAP32[i23 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i24, i3, i6 - i3 | 0, i23, 0, i23, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i22 >> 0] | 0) < 0) {
   HEAP32[i23 >> 2] = i6;
   break;
  } else {
   HEAP8[i22 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i24 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 12 >> 2] | 0;
  HEAP32[i25 >> 2] = 66;
  HEAP32[i25 + 4 >> 2] = i26;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i25);
 }
 STACKTOP = i27;
 return;
}

function __ZN5Umbra12QueryContext17findMultipleCellsEPKNS_7Vector3EPNS_4CellEi(i44, i45, i48, i49) {
 i44 = i44 | 0;
 i45 = i45 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i46 = 0, i47 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 3456 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i56 + 1800 | 0;
 i51 = i56 + 152 | 0;
 i52 = i56 + 120 | 0;
 i53 = i56 + 112 | 0;
 i54 = i56 + 72 | 0;
 i55 = i56 + 40 | 0;
 i46 = i56 + 8 | 0;
 i47 = i56;
 i9 = i50 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i50 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i50 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i1 = i50 + 1644 | 0;
 i2 = i50 + 44 | 0;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 12 >> 2] = -1;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i51 + 12 >> 2] = 0;
 HEAP32[i51 + 16 >> 2] = 0;
 i1 = i51 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i51 + 1644 | 0;
 i2 = i51 + 44 | 0;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 12 >> 2] = -1;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i41 = HEAP32[HEAP32[i44 >> 2] >> 2] | 0;
 i7 = HEAP32[i41 + 48 >> 2] | 0;
 i43 = (HEAP32[i41 + 44 >> 2] | 0) >>> 5;
 i7 = (i7 | 0) == 0 ? 0 : i41 + i7 | 0;
 i42 = HEAP32[i41 + 60 >> 2] | 0;
 i1 = HEAP32[i41 + 20 >> 2] | 0;
 i3 = HEAP32[i41 + 24 >> 2] | 0;
 i4 = HEAP32[i41 + 28 >> 2] | 0;
 i5 = HEAP32[i41 + 32 >> 2] | 0;
 i6 = HEAP32[i41 + 36 >> 2] | 0;
 i2 = HEAP32[i41 + 40 >> 2] | 0;
 HEAP32[i50 >> 2] = i45;
 HEAP32[i50 + 4 >> 2] = i49;
 HEAP32[i50 + 8 >> 2] = (1 << i49 & ~(31 - i49 >> 31)) + -1;
 i8 = i50 + 40 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i9 >> 2] = i43;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i50 + 20 >> 2] = i7 + (((i43 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i11 >> 2] = i41;
 HEAP32[i50 + 28 >> 2] = i42;
 HEAP32[i50 + 32 >> 2] = 4;
 HEAP32[i50 + 36 >> 2] = i43;
 if (i43 | 0) {
  i43 = HEAP32[i7 >> 2] & 3;
  HEAP32[i50 + 44 >> 2] = i1;
  HEAP32[i50 + 48 >> 2] = i3;
  HEAP32[i50 + 52 >> 2] = i4;
  HEAP32[i50 + 56 >> 2] = 0;
  HEAP32[i50 + 60 >> 2] = i5;
  HEAP32[i50 + 64 >> 2] = i6;
  HEAP32[i50 + 68 >> 2] = i2;
  HEAP8[i50 + 72 >> 0] = 0;
  HEAP8[i50 + 73 >> 0] = i43;
  HEAP8[i50 + 74 >> 0] = 63;
  HEAP8[i50 + 75 >> 0] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 HEAP8[i50 + 1644 >> 0] = 1;
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 8 >> 2] = Math_fround(0.0);
 i25 = i52 + 12 | 0;
 HEAP32[i25 >> 2] = -1;
 HEAPF32[i52 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i52 + 24 >> 2] = Math_fround(0.0);
 if (!(__ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj(i50, i52, i53) | 0)) {
  STACKTOP = i56;
  return;
 }
 i26 = i54 + 4 | 0;
 i27 = i54 + 8 | 0;
 i28 = i54 + 12 | 0;
 i29 = i54 + 28 | 0;
 i30 = i54 + 32 | 0;
 i31 = i55 + 4 | 0;
 i32 = i55 + 8 | 0;
 i9 = i55 + 12 | 0;
 i16 = i55 + 16 | 0;
 i19 = i55 + 20 | 0;
 i21 = i55 + 24 | 0;
 i14 = i51 + 4 | 0;
 i17 = i51 + 8 | 0;
 i33 = i51 + 12 | 0;
 i34 = i51 + 40 | 0;
 i35 = i51 + 1644 | 0;
 i36 = i46 + 4 | 0;
 i37 = i46 + 8 | 0;
 i38 = i46 + 12 | 0;
 i39 = i46 + 16 | 0;
 i40 = i46 + 20 | 0;
 i41 = i46 + 24 | 0;
 i8 = i51 + 44 | 0;
 i15 = i51 + 48 | 0;
 i18 = i51 + 52 | 0;
 i20 = i51 + 56 | 0;
 i22 = i51 + 60 | 0;
 i23 = i51 + 64 | 0;
 i24 = i51 + 68 | 0;
 i10 = i51 + 72 | 0;
 i11 = i51 + 73 | 0;
 i12 = i51 + 74 | 0;
 i13 = i51 + 75 | 0;
 do {
  i42 = HEAP32[i25 >> 2] | 0;
  HEAP32[i54 >> 2] = -1;
  HEAP32[i26 >> 2] = 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i28 >> 2] = 0;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i30 >> 2] = 0;
  __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i44, i54, i42);
  i43 = HEAP32[i29 >> 2] | 0;
  i57 = (HEAP32[i43 + 24 >> 2] | 0) >>> 5;
  i7 = HEAP32[i43 + 28 >> 2] | 0;
  i7 = (i7 | 0) == 0 ? 0 : i43 + i7 | 0;
  i3 = HEAP32[i43 + 40 >> 2] | 0;
  i1 = HEAP32[i43 + 36 >> 2] | 0;
  HEAP32[i55 >> 2] = i57;
  HEAP32[i31 >> 2] = i7;
  HEAP32[i32 >> 2] = i7 + (((i57 << 1) + 31 | 0) >>> 5 << 2);
  HEAP32[i9 >> 2] = i43;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i19 >> 2] = 4;
  HEAP32[i21 >> 2] = i1;
  i1 = HEAP32[i43 >> 2] | 0;
  i3 = HEAP32[i43 + 4 >> 2] | 0;
  i4 = HEAP32[i43 + 8 >> 2] | 0;
  i5 = HEAP32[i43 + 12 >> 2] | 0;
  i6 = HEAP32[i43 + 16 >> 2] | 0;
  i2 = HEAP32[i43 + 20 >> 2] | 0;
  i58 = HEAP32[i53 >> 2] | 0;
  HEAP32[i51 >> 2] = i45;
  HEAP32[i14 >> 2] = i49;
  HEAP32[i17 >> 2] = i58;
  HEAP32[i34 >> 2] = -1;
  HEAP32[i33 >> 2] = HEAP32[i55 >> 2];
  HEAP32[i33 + 4 >> 2] = HEAP32[i55 + 4 >> 2];
  HEAP32[i33 + 8 >> 2] = HEAP32[i55 + 8 >> 2];
  HEAP32[i33 + 12 >> 2] = HEAP32[i55 + 12 >> 2];
  HEAP32[i33 + 16 >> 2] = HEAP32[i55 + 16 >> 2];
  HEAP32[i33 + 20 >> 2] = HEAP32[i55 + 20 >> 2];
  HEAP32[i33 + 24 >> 2] = HEAP32[i55 + 24 >> 2];
  if (i57 | 0) {
   i58 = HEAP32[i7 >> 2] & 3;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i15 >> 2] = i3;
   HEAP32[i18 >> 2] = i4;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i22 >> 2] = i5;
   HEAP32[i23 >> 2] = i6;
   HEAP32[i24 >> 2] = i2;
   HEAP8[i10 >> 0] = 0;
   HEAP8[i11 >> 0] = i58;
   HEAP8[i12 >> 0] = 63;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i34 >> 2] = 0;
  }
  HEAP8[i35 >> 0] = 1;
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  HEAPF32[i36 >> 2] = Math_fround(0.0);
  HEAPF32[i37 >> 2] = Math_fround(0.0);
  HEAP32[i38 >> 2] = -1;
  HEAPF32[i39 >> 2] = Math_fround(0.0);
  HEAPF32[i40 >> 2] = Math_fround(0.0);
  HEAPF32[i41 >> 2] = Math_fround(0.0);
  if (__ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj(i51, i46, i47) | 0) do {
   i3 = HEAP32[i38 >> 2] | 0;
   i3 = i3 - (__ZNK5Umbra6KDTree4rankEi(i55, i3) | 0) | 0;
   i1 = HEAP32[i47 >> 2] | 0;
   if (i1 | 0) {
    i2 = 0;
    do {
     i57 = _llvm_cttz_i32(i1 | 0) | 0;
     i58 = i57 + i2 | 0;
     HEAP32[i48 + (i58 << 3) >> 2] = i42;
     HEAP32[i48 + (i58 << 3) + 4 >> 2] = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i43, i3, i45 + (i58 * 12 | 0) | 0) | 0;
     i1 = (HEAP32[i47 >> 2] | 0) >>> (i57 + 1 | 0);
     HEAP32[i47 >> 2] = i1;
     i2 = i58 + 1 | 0;
    } while ((i2 | 0) < 32 & (i1 | 0) != 0);
   }
  } while (__ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj(i51, i46, i47) | 0);
 } while (__ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj(i50, i52, i53) | 0);
 STACKTOP = i56;
 return;
}

function __ZN5physx28collideWithStaticHeightFieldEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEfRKNS_11PxTransformE(i50, i48, i1, f51, i52) {
 i50 = i50 | 0;
 i48 = i48 | 0;
 i1 = i1 | 0;
 f51 = Math_fround(f51);
 i52 = i52 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i49 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0, i68 = 0, f69 = f0, f70 = f0, f71 = f0, i72 = 0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i61 + 236 | 0;
 i45 = i61 + 144 | 0;
 i49 = i61 + 120 | 0;
 i53 = i61 + 200 | 0;
 i47 = i61 + 100 | 0;
 i60 = i61 + 164 | 0;
 i44 = i61 + 240 | 0;
 i58 = i61 + 88 | 0;
 i59 = i61 + 76 | 0;
 i56 = i61 + 64 | 0;
 i57 = i61 + 52 | 0;
 i54 = i61 + 48 | 0;
 i55 = i61 + 44 | 0;
 i46 = i61 + 24 | 0;
 i42 = i61 + 12 | 0;
 i43 = i61;
 HEAPF32[i41 >> 2] = f51;
 HEAP32[i45 + 12 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i45 + 16 >> 2] = i1;
 HEAPF32[i45 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i45 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 12 >> 2]));
 HEAPF32[i45 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 16 >> 2]));
 if (!i48) {
  STACKTOP = i61;
  return;
 }
 i5 = i49 + 4 | 0;
 i6 = i49 + 8 | 0;
 i7 = i49 + 12 | 0;
 i8 = i49 + 16 | 0;
 i9 = i49 + 20 | 0;
 i10 = i53 + 4 | 0;
 i11 = i53 + 12 | 0;
 i12 = i53 + 20 | 0;
 i13 = i58 + 4 | 0;
 i14 = i58 + 8 | 0;
 i15 = i59 + 4 | 0;
 i16 = i59 + 8 | 0;
 i17 = i56 + 4 | 0;
 i18 = i56 + 8 | 0;
 i19 = i57 + 4 | 0;
 i20 = i57 + 8 | 0;
 i21 = i46 + 12 | 0;
 i22 = i46 + 8 | 0;
 i23 = i46 + 16 | 0;
 i24 = i46 + 4 | 0;
 i25 = i60 + 4 | 0;
 i26 = i60 + 8 | 0;
 i27 = i60 + 12 | 0;
 i28 = i60 + 16 | 0;
 i29 = i60 + 20 | 0;
 i30 = i60 + 24 | 0;
 i31 = i60 + 28 | 0;
 i32 = i60 + 32 | 0;
 i33 = i42 + 4 | 0;
 i34 = i42 + 8 | 0;
 i35 = i43 + 4 | 0;
 i36 = i43 + 8 | 0;
 i40 = 0;
 do {
  i37 = i50 + (i40 * 176 | 0) | 0;
  i38 = i50 + (i40 * 176 | 0) + 112 | 0;
  i39 = i50 + (i40 * 176 | 0) + 128 | 0;
  f67 = Math_fround(HEAPF32[i38 >> 2]);
  f66 = Math_fround(HEAPF32[i39 >> 2]);
  f65 = Math_fround(HEAPF32[i50 + (i40 * 176 | 0) + 116 >> 2]);
  f64 = Math_fround(HEAPF32[i50 + (i40 * 176 | 0) + 132 >> 2]);
  f63 = Math_fround(HEAPF32[i50 + (i40 * 176 | 0) + 120 >> 2]);
  f62 = Math_fround(HEAPF32[i50 + (i40 * 176 | 0) + 136 >> 2]);
  HEAPF32[i49 >> 2] = Math_fround((f67 < f66 ? f67 : f66) - f51);
  HEAPF32[i5 >> 2] = Math_fround((f65 < f64 ? f65 : f64) - f51);
  HEAPF32[i6 >> 2] = Math_fround((f63 < f62 ? f63 : f62) - f51);
  HEAPF32[i7 >> 2] = Math_fround((f67 > f66 ? f67 : f66) + f51);
  HEAPF32[i8 >> 2] = Math_fround((f65 > f64 ? f65 : f64) + f51);
  HEAPF32[i9 >> 2] = Math_fround((f63 > f62 ? f63 : f62) + f51);
  __ZN5physx22PxcHeightFieldAabbTestC2ERKNS_9PxBounds3ERKNS_2Gu15HeightFieldUtilE(i53, i49, i45);
  __ZNK5physx22PxcHeightFieldAabbTest5beginEv(i47, i53);
  if (!(HEAP8[i10 >> 0] | 0)) i3 = (Math_imul(HEAP32[(HEAP32[(HEAP32[i53 >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0) + (HEAP32[i12 >> 2] | 0) | 0; else i3 = 0;
  HEAP32[i50 + (i40 * 176 | 0) + 144 >> 2] = 0;
  HEAP32[i50 + (i40 * 176 | 0) + 148 >> 2] = 0;
  HEAP32[i50 + (i40 * 176 | 0) + 152 >> 2] = 0;
  i4 = i50 + (i40 * 176 | 0) + 160 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP8[i44 >> 0] = (HEAP32[i50 + (i40 * 176 | 0) + 124 >> 2] | 0) >>> 1 & 1;
  HEAPF32[i58 >> 2] = Math_fround(0.0);
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  HEAPF32[i59 >> 2] = Math_fround(0.0);
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  HEAPF32[i56 >> 2] = Math_fround(0.0);
  HEAPF32[i17 >> 2] = Math_fround(0.0);
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  HEAPF32[i57 >> 2] = Math_fround(0.0);
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  HEAP32[i54 >> 2] = HEAP32[i50 + (i40 * 176 | 0) + 44 >> 2];
  HEAPF32[i55 >> 2] = Math_fround(0.0);
  HEAP32[i46 >> 2] = HEAP32[i47 >> 2];
  HEAP32[i46 + 4 >> 2] = HEAP32[i47 + 4 >> 2];
  HEAP32[i46 + 8 >> 2] = HEAP32[i47 + 8 >> 2];
  HEAP32[i46 + 12 >> 2] = HEAP32[i47 + 12 >> 2];
  HEAP32[i46 + 16 >> 2] = HEAP32[i47 + 16 >> 2];
  i4 = i50 + (i40 * 176 | 0) + 92 | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (!((i2 | 0) == 0 & (i3 | 0) == (i1 | 0))) do {
   i68 = HEAP32[i23 >> 2] | 0;
   i72 = (HEAP8[i68 + 32 >> 0] | 0) != 0;
   __ZNK5physx2Gu11HeightField19getTriangleVerticesEjjjRNS_6PxVec3ES3_S3_(HEAP32[(HEAP32[i68 >> 2] | 0) + 12 >> 2] | 0, (i1 << 1) + i2 | 0, HEAP32[i46 >> 2] | 0, HEAP32[i24 >> 2] | 0, i60, i60 + ((i72 ? 2 : 1) * 12 | 0) | 0, i60 + ((i72 ? 1 : 2) * 12 | 0) | 0);
   f65 = Math_fround(HEAPF32[i60 >> 2]);
   i68 = HEAP32[(HEAP32[i68 >> 2] | 0) + 16 >> 2] | 0;
   f64 = Math_fround(HEAPF32[i68 + 12 >> 2]);
   f65 = Math_fround(f65 * f64);
   f66 = Math_fround(HEAPF32[i25 >> 2]);
   f62 = Math_fround(HEAPF32[i68 + 8 >> 2]);
   f66 = Math_fround(f66 * f62);
   f67 = Math_fround(HEAPF32[i26 >> 2]);
   f63 = Math_fround(HEAPF32[i68 + 16 >> 2]);
   f67 = Math_fround(f67 * f63);
   HEAPF32[i60 >> 2] = f65;
   HEAPF32[i25 >> 2] = f66;
   HEAPF32[i26 >> 2] = f67;
   f71 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f64);
   f70 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f62);
   f69 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) * f63);
   HEAPF32[i27 >> 2] = f71;
   HEAPF32[i28 >> 2] = f70;
   HEAPF32[i29 >> 2] = f69;
   f64 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * f64);
   f62 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * f62);
   f63 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * f63);
   HEAPF32[i30 >> 2] = f64;
   HEAPF32[i31 >> 2] = f62;
   HEAPF32[i32 >> 2] = f63;
   f70 = Math_fround(f70 - f66);
   f69 = Math_fround(f69 - f67);
   HEAPF32[i42 >> 2] = Math_fround(f71 - f65);
   HEAPF32[i33 >> 2] = f70;
   HEAPF32[i34 >> 2] = f69;
   f66 = Math_fround(f62 - f66);
   f67 = Math_fround(f63 - f67);
   HEAPF32[i43 >> 2] = Math_fround(f64 - f65);
   HEAPF32[i35 >> 2] = f66;
   HEAPF32[i36 >> 2] = f67;
   i68 = __ZN5physx23collideWithMeshTriangleERNS_6PxVec3ES1_S1_S1_RfS2_RKS0_S4_S4_S4_S4_bRKfS6_(i58, i59, i56, i57, i54, i55, i38, i39, i60, i42, i43, (HEAP8[i44 >> 0] | 0) != 0, i4, i41) | 0;
   f67 = Math_fround(HEAPF32[i54 >> 2]);
   __Z19updateCollShapeDataRN5physx19PxsParticleCollDataERbjffRKNS_6PxVec3ES5_S5_S5_RKNS_11PxTransformE(i37, i44, i68, f67, Math_fround(HEAPF32[i55 >> 2]), i58, i59, i56, i57, i52);
   __ZN5physx22PxcHeightFieldAabbTest8IteratorppEv(i46) | 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i1 = HEAP32[i21 >> 2] | 0;
  } while (!((i2 | 0) == 0 & (i3 | 0) == (i1 | 0)));
  i40 = i40 + 1 | 0;
 } while ((i40 | 0) != (i48 | 0));
 STACKTOP = i61;
 return;
}

function __ZN8JSONRead18TransferStringDataINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 48 | 0;
 i8 = i13 + 36 | 0;
 i9 = i13 + 24 | 0;
 i10 = i13 + 12 | 0;
 i11 = i13;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 & 1048576 | 0) {
  if (!(i1 & 4194304)) i4 = HEAP32[i4 >> 2] | 0;
  i5 = _strlen(i4) | 0;
  i6 = i12 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
   STACKTOP = i13;
   return;
  }
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i5;
   STACKTOP = i13;
   return;
  } else {
   HEAP8[i6 >> 0] = i5;
   STACKTOP = i13;
   return;
  }
 }
 if (i1 & 256 | 0) {
  i2 = (i1 | 0) == 258;
  i1 = i2 ? gb + 1087447 | 0 : gb + 1087441 | 0;
  i2 = i2 ? 4 : 5;
  i3 = i12 + 11 | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  if (i5) i6 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i2 >>> 0 > i6 >>> 0) {
   i11 = i5 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i6, i2 - i6 | 0, i11, 0, i11, i2, i1);
   STACKTOP = i13;
   return;
  }
  i11 = i5 ? HEAP32[i12 >> 2] | 0 : i12;
  _memmove(i11 | 0, i1 | 0, i2 | 0) | 0;
  HEAP8[i11 + i2 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i2;
   STACKTOP = i13;
   return;
  } else {
   HEAP8[i3 >> 0] = i2;
   STACKTOP = i13;
   return;
  }
 }
 if (i1 & 1024 | 0) {
  __Z11IntToStringi(i7, HEAP32[i4 >> 2] | 0);
  i4 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  i5 = _strlen(i4) | 0;
  i6 = i12 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i12 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i6 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i13;
  return;
 }
 if (i1 & 2048 | 0) {
  __Z19UnsignedIntToStringj(i8, HEAP32[i4 >> 2] | 0);
  i4 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
  i5 = _strlen(i4) | 0;
  i6 = i12 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i12 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i6 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i13;
  return;
 }
 if (i1 & 4096 | 0) {
  __Z13Int64ToStringx(i9, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
  i4 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i5 = _strlen(i4) | 0;
  i6 = i12 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i12 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i6 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i13;
  return;
 }
 if (i1 & 8192 | 0) {
  __Z21UnsignedInt64ToStringy(i10, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
  i4 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  i5 = _strlen(i4) | 0;
  i6 = i12 + 11 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i11 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i11, 0, i11, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i12 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i6 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i13;
  return;
 }
 if (!(i1 & 16384)) {
  i1 = i12 + 11 | 0;
  HEAP8[((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12) >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = 0;
   STACKTOP = i13;
   return;
  } else {
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i13;
   return;
  }
 }
 __Z14DoubleToStringd(i11, +HEAPF64[i4 >> 3]);
 i4 = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
 i5 = _strlen(i4) | 0;
 i6 = i12 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i10 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i10, 0, i10, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __ZN2UIL8PopulateERNS_23RenderableUIInstructionERKNS_13UIInstructionEib(i24, i21, i2, i22) {
 i24 = i24 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27;
 i26 = i27 + 20 | 0;
 i23 = i24 + 246 | 0;
 HEAP8[i23 >> 0] = HEAP8[i21 + 668 >> 0] | 0;
 i3 = i21 + 448 | 0;
 if ((HEAP32[i3 >> 2] | 0) > (i2 | 0)) i1 = HEAP32[i21 + (i2 << 2) >> 2] | 0; else i1 = 0;
 HEAP32[i24 >> 2] = i1;
 if ((HEAP32[i3 >> 2] | 0) > (i2 | 0)) {
  i10 = i21 + 32 + (i2 * 52 | 0) | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i5 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 8 >> 2] | 0;
  i6 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 12 >> 2] | 0;
  i1 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 16 >> 2] | 0;
  i8 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 20 >> 2] | 0;
  i3 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 24 >> 2] | 0;
  i4 = HEAP32[i21 + 32 + (i2 * 52 | 0) + 28 >> 2] | 0;
  i2 = i21 + 32 + (i2 * 52 | 0) + 32 | 0;
  HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i25 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i25 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i25 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  i2 = i8;
  i8 = 0;
  i9 = 0;
 } else {
  i5 = HEAP32[gb + 1155204 >> 2] | 0;
  i6 = HEAP32[gb + 1155204 + 4 >> 2] | 0;
  i1 = HEAP32[gb + 1155204 + 8 >> 2] | 0;
  i2 = HEAP32[gb + 1155204 + 12 >> 2] | 0;
  i3 = HEAP32[gb + 1155204 + 16 >> 2] | 0;
  i4 = HEAP32[gb + 1155204 + 20 >> 2] | 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  HEAP32[i25 + 12 >> 2] = 0;
  HEAP32[i25 + 16 >> 2] = 0;
  i7 = 0;
  i8 = 0;
  i9 = 0;
  i10 = 0;
 }
 i28 = i24 + 32 | 0;
 HEAP32[i28 >> 2] = i7 | i8;
 HEAP32[i28 + 4 >> 2] = i9 | i10;
 HEAP32[i24 + 40 >> 2] = i5;
 HEAP32[i24 + 44 >> 2] = i6;
 HEAP32[i24 + 48 >> 2] = i1;
 HEAP32[i24 + 52 >> 2] = i2;
 HEAP32[i24 + 56 >> 2] = i3;
 HEAP32[i24 + 60 >> 2] = i4;
 i5 = i24 + 64 | 0;
 HEAP32[i5 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i25 + 16 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i21 + 452 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i21 + 456 >> 2];
 i5 = i24 + 12 | 0;
 i1 = i21 + 460 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i5 = i24 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i21 + 476 >> 2];
 HEAP8[i24 + 244 >> 0] = HEAP8[i21 + 666 >> 0] | 0;
 HEAP32[i24 + 84 >> 2] = HEAP32[i21 + 480 >> 2];
 i1 = i24 + 88 | 0;
 i2 = i21 + 484 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i30 = HEAP32[i21 + 596 >> 2] | 0;
 i1 = HEAP32[i21 + 600 >> 2] | 0;
 i6 = HEAP32[i21 + 604 >> 2] | 0;
 i8 = HEAP32[i21 + 608 >> 2] | 0;
 HEAP32[i24 + 152 >> 2] = i30;
 HEAP32[i24 + 156 >> 2] = i1;
 HEAP32[i24 + 160 >> 2] = i6;
 HEAP32[i24 + 164 >> 2] = i8;
 i29 = HEAP32[i21 + 612 >> 2] | 0;
 i2 = HEAP32[i21 + 616 >> 2] | 0;
 i7 = HEAP32[i21 + 620 >> 2] | 0;
 i9 = HEAP32[i21 + 624 >> 2] | 0;
 HEAP32[i24 + 168 >> 2] = i29;
 HEAP32[i24 + 172 >> 2] = i2;
 HEAP32[i24 + 176 >> 2] = i7;
 HEAP32[i24 + 180 >> 2] = i9;
 i3 = i24 + 184 | 0;
 i10 = i21 + 572 | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i3 = HEAP32[i21 + 632 >> 2] | 0;
 i10 = HEAP32[i21 + 636 >> 2] | 0;
 i28 = HEAP32[i21 + 640 >> 2] | 0;
 HEAP32[i24 + 208 >> 2] = HEAP32[i21 + 628 >> 2];
 HEAP32[i24 + 212 >> 2] = i3;
 HEAP32[i24 + 216 >> 2] = i10;
 HEAP32[i24 + 220 >> 2] = i28;
 i10 = HEAP32[i21 + 644 >> 2] | 0;
 HEAP32[i24 + 224 >> 2] = i10;
 HEAP8[i24 + 245 >> 0] = HEAP8[i21 + 667 >> 0] | 0;
 i3 = i24 + 228 | 0;
 i4 = i21 + 648 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP8[i24 + 247 >> 0] = HEAP8[i21 + 669 >> 0] | 0;
 i3 = HEAP8[i21 + 670 >> 0] | 0;
 HEAP8[i24 + 248 >> 0] = i3;
 i4 = i24 + 249 | 0;
 HEAP8[i4 >> 0] = 1;
 f11 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (HEAP8[i23 >> 0] | 0) {
  STACKTOP = i27;
  return;
 }
 if (i22) {
  i2 = (f11 >= f12 | f13 >= f14 | f15 >= f16 | f17 >= f18) & 1 ^ 1;
  HEAP8[i4 >> 0] = i2;
 } else i2 = 1;
 if (!(HEAP32[i5 >> 2] | 0)) i1 = 0; else if (!(HEAP32[i24 + 80 >> 2] | 0)) i1 = 0; else i1 = (HEAP32[i24 + 68 >> 2] | 0) != 0;
 i1 = (i3 ^ 1) & 255 & (i2 & (i1 & 1));
 HEAP8[i4 >> 0] = i1;
 HEAP8[i4 >> 0] = i1 & (f19 > Math_fround(0.0) & f20 > Math_fround(0.0) & 1);
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i25, i1, i26);
   i2 = HEAP32[i25 >> 2] | 0;
   i30 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i30 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i30 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = (HEAP32[i1 + 4 >> 2] | 0) != 0;
 }
 i30 = HEAPU8[i4 >> 0] & (i1 & 1);
 HEAP8[i4 >> 0] = i30;
 if (i30 | 0) {
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 i30 = i1 + 4 | 0;
 HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + -1;
 if (HEAP32[i30 >> 2] | 0) {
  STACKTOP = i27;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 STACKTOP = i27;
 return;
}

function __ZN5IMGUI12BeginWindowsER8GUIStatebb(i12, i8, i6) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 116 | 0;
 i9 = i13;
 i7 = HEAP32[i12 + 8 >> 2] | 0;
 i10 = i12 + 280 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 i1 = i9;
 i2 = i12 + 108 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 24 >> 2] | 0;
 HEAP32[i9 + 64 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i9 + 68 >> 2] = i1;
 HEAP32[i9 + 72 >> 2] = i2;
 HEAP32[i9 + 76 >> 2] = i3;
 i3 = HEAP32[i12 + 48 >> 2] | 0;
 i2 = HEAP32[i12 + 52 >> 2] | 0;
 i1 = HEAP32[i12 + 56 >> 2] | 0;
 HEAP32[i9 + 80 >> 2] = HEAP32[i12 + 44 >> 2];
 HEAP32[i9 + 84 >> 2] = i3;
 HEAP32[i9 + 88 >> 2] = i2;
 HEAP32[i9 + 92 >> 2] = i1;
 i1 = HEAP32[i12 + 32 >> 2] | 0;
 i2 = HEAP32[i12 + 36 >> 2] | 0;
 i3 = HEAP32[i12 + 40 >> 2] | 0;
 HEAP32[i9 + 96 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i9 + 100 >> 2] = i1;
 HEAP32[i9 + 104 >> 2] = i2;
 HEAP32[i9 + 108 >> 2] = i3;
 HEAP8[i9 + 112 >> 0] = (HEAP32[i12 + 60 >> 2] | 0) != 0 & 1;
 if (i8) __ZN12GUIClipState10BeginOnGUIER10InputEvent(i12 + 96 | 0, i11);
 if (HEAP8[i7 + 16 >> 0] | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = i7 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = fb + 1111;
  __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i3, i2, i4);
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2;
  if ((i1 | 0) != (i2 | 0)) {
   i2 = i1 - i2 >> 2;
   i1 = 0;
   do {
    HEAP32[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 68 >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
 }
 L13 : do switch (HEAP32[i11 >> 2] | 0) {
 case 8:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) do {
    HEAP8[(HEAP32[i1 >> 2] | 0) + 116 >> 0] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i2 | 0));
   if (i6) i5 = 54; else {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (!i1) i5 = 54; else {
     HEAP8[i1 + 116 >> 0] = 0;
     i5 = 54;
    }
   }
   break;
  }
 case 15:
 case 10:
 case 9:
  {
   if (!i6) {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (i1 | 0) {
     i5 = 47;
     break L13;
    }
   }
   i1 = __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i7, i12) | 0;
   i5 = 46;
   break;
  }
 case 2:
 case 3:
 case 1:
  {
   if (!i6) {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (i1 | 0) {
     i5 = 47;
     break L13;
    }
   }
   if (!(HEAP32[(HEAP32[i12 + 276 >> 2] | 0) + 4 >> 2] | 0)) {
    i1 = __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i7, i12) | 0;
    i5 = 46;
    break L13;
   }
   i4 = HEAP32[i7 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   if ((i1 | 0) != (i3 | 0)) {
    i2 = i1;
    do {
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = i2 + 4 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
      i5 = 46;
      break L13;
     }
    } while ((i2 | 0) != (i3 | 0));
   }
   i1 = HEAP32[i7 + 24 >> 2] | 0;
   if (!i1) i5 = 54; else if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) i5 = 47; else i5 = 54;
   break;
  }
 case 6:
  {
   if (!i6) {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (i1 | 0) {
     i5 = 47;
     break L13;
    }
   }
   i1 = __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i7, i12) | 0;
   i5 = 46;
   break;
  }
 case 0:
  {
   i2 = i7 + 12 | 0;
   HEAP32[i2 >> 2] = -1;
   if (i6) i5 = 31; else {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (!i1) i5 = 31;
   }
   if ((i5 | 0) == 31) {
    i1 = __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i7, i12) | 0;
    if (!i1) {
     i5 = 54;
     break L13;
    }
   }
   HEAP32[i1 + 68 >> 2] = -1;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i5 = HEAP32[i7 >> 2] | 0;
   i2 = i7 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i4 >> 2] = fb + 1111;
   __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i5, i3, i4);
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = i3;
   if ((i2 | 0) == (i3 | 0)) i5 = 47; else {
    i3 = i2 - i3 >> 2;
    i2 = 0;
    do {
     HEAP32[(HEAP32[i4 + (i2 << 2) >> 2] | 0) + 68 >> 2] = i2;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i3 >>> 0);
    i5 = 46;
   }
   break;
  }
 case 7:
  {
   if (i6) i5 = 37; else if (!(HEAP32[i7 + 24 >> 2] | 0)) i5 = 37; else i1 = 0;
   if ((i5 | 0) == 37) i1 = (__ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i7, i12) | 0) == 0 & 1;
   HEAP8[(HEAP32[i12 + 276 >> 2] | 0) + 8 >> 0] = i1;
   break;
  }
 default:
  {
   if (!i6) {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    if (i1 | 0) {
     i5 = 47;
     break L13;
    }
   }
   i4 = HEAP32[i7 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   if ((i1 | 0) != (i3 | 0)) {
    i2 = i1;
    do {
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = i2 + 4 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
      i5 = 46;
      break L13;
     }
    } while ((i2 | 0) != (i3 | 0));
   }
   i1 = HEAP32[i7 + 24 >> 2] | 0;
   if (!i1) i5 = 54; else if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) i5 = 47; else i5 = 54;
  }
 } while (0);
 if ((i5 | 0) == 46) if (!i1) i5 = 54; else i5 = 47;
 L69 : do if ((i5 | 0) == 47) if (!(HEAP32[i1 + 120 >> 2] | 0)) i5 = 54; else {
  __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i1, i12);
  if (i6) i5 = 54; else if (!(HEAP32[i7 + 24 >> 2] | 0)) i5 = 54; else {
   switch (HEAP32[i11 >> 2] | 0) {
   case 0:
   case 6:
    {
     HEAP32[i11 >> 2] = 11;
     i5 = 54;
     break L69;
    }
   case 1:
   case 3:
   case 2:
    break;
   default:
    {
     i5 = 54;
     break L69;
    }
   }
   if (!(HEAP32[(HEAP32[i12 + 276 >> 2] | 0) + 4 >> 2] | 0)) {
    HEAP32[i11 >> 2] = 11;
    i5 = 54;
   } else i5 = 54;
  }
 } while (0);
 L78 : do if ((i5 | 0) == 54) {
  __ZN5IMGUI25RestoreGUIStatePropertiesER8GUIStateR10InputEventRNS_23GUIStatePropertiesCacheE(i12, i11, i9);
  if (i8) {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i12 + 100 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = i1 - (HEAP32[i12 + 96 >> 2] | 0) | 0;
   do if ((i2 | 0) != 56 ? ((HEAP32[i3 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) if (((i2 | 0) / 56 | 0) >>> 0 > 1) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
    i1 = HEAP32[i4 >> 2] | 0;
    break;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
    break L78;
   } while (0);
   HEAP32[i4 >> 2] = i1 + -56;
   i10 = i12 + 236 | 0;
   f15 = Math_fround(HEAPF32[i10 >> 2]);
   f15 = Math_fround(f15 - Math_fround(HEAPF32[i12 + 244 >> 2]));
   f14 = Math_fround(HEAPF32[i12 + 240 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i12 + 248 >> 2]));
   HEAPF32[i3 + 12 >> 2] = f15;
   HEAPF32[i3 + 16 >> 2] = f14;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i3 + 4 | 0;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
  }
 } while (0);
 STACKTOP = i13;
 return;
}

function __ZN9BoxPruner9addObjectERK5IAABBjb(i18, i16, i14, i13) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19;
 i11 = i19 + 25 | 0;
 i9 = i19 + 26 | 0;
 i10 = i19 + 24 | 0;
 i1 = i18 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i18 + 64 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i18 + 68 >> 2] | 0) == (i2 | 0)) {
   __ZN9BoxPruner13resizeObjectsEv(i18);
   i12 = HEAP32[i1 >> 2] | 0;
   i3 = i12;
  } else {
   i3 = i2;
   i12 = i2;
  }
 } else {
  HEAP32[i1 >> 2] = HEAP32[(HEAP32[i18 + 76 >> 2] | 0) + ((i2 & 65535) << 3) >> 2];
  i3 = i18 + 64 | 0;
  i1 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
  i12 = i2;
 }
 i15 = i12 & 65535;
 HEAP32[i1 >> 2] = i3 + 1;
 if (i13) {
  i7 = i18 + 80 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i8 = i18 + 84 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i4 | 0) == (i3 | 0)) {
   i6 = i4 + 128 | 0;
   i2 = i18 + 96 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = i6 >>> 0 > 178956970 ? -1 : i6 * 24 | 0;
   if (!i1) i1 = 0; else {
    i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
    i10 = _PxGetFoundation() | 0;
    i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0;
    i1 = mftCall_iiiiii(i5 | 0, i9 | 0, i1 | 0, (i10 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1324) | 0;
   }
   if (i4 | 0) _memcpy(i1 | 0, i3 | 0, i4 * 24 | 0) | 0;
   if (i3 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i3);
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[i8 >> 2] | 0;
   i1 = i18 + 104 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i6 << 1, gb + 717183 | 0, 1333) | 0;
   if (i3 | 0) _memcpy(i5 | 0, i4 | 0, i3 << 1 | 0) | 0;
   if (i4 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i4);
   HEAP32[i1 >> 2] = i5;
   HEAP32[i7 >> 2] = i6;
   i3 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = i18 + 96 | 0;
   i1 = i18 + 104 | 0;
  }
  HEAP32[i8 >> 2] = i3 + 1;
  i4 = (HEAP32[i2 >> 2] | 0) + (i3 * 24 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP16[(HEAP32[i1 >> 2] | 0) + (i3 << 1) >> 1] = i15;
  HEAP8[i18 + 168 >> 0] = 1;
  i4 = i18 + 124 | 0;
  i7 = i3 >>> 5;
  i5 = i18 + 128 | 0;
  if (i7 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) i1 = HEAP32[i4 >> 2] | 0; else {
   i6 = i3 + 128 | 0;
   i6 = ((i6 & 31 | 0) != 0 & 1) + (i6 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i6 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   if ((i6 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i6 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
    HEAP32[i4 >> 2] = 0;
   }
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
  }
  i1 = i1 + (i7 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i3 & 31);
  i1 = i3;
 } else {
  i6 = i18 + 88 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i8 = i18 + 92 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i4 | 0) == (i1 | 0)) {
   i7 = i4 + 128 | 0;
   i3 = i18 + 100 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = i7 >>> 0 > 178956970 ? -1 : i7 * 24 | 0;
   if (!i1) i1 = 0; else {
    i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i21 = HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] | 0;
    i5 = _PxGetFoundation() | 0;
    i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
    i1 = mftCall_iiiiii(i21 | 0, i20 | 0, i1 | 0, (i5 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1324) | 0;
   }
   if (i4 | 0) _memcpy(i1 | 0, i2 | 0, i4 * 24 | 0) | 0;
   if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i2);
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i18 + 108 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i7 << 1, gb + 717183 | 0, 1333) | 0;
   if (i1 | 0) _memcpy(i5 | 0, i4 | 0, i1 << 1 | 0) | 0;
   if (i4 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i4);
   HEAP32[i2 >> 2] = i5;
   HEAP32[i6 >> 2] = i7;
   i1 = i18 + 112 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   if (i4 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i4);
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, (i7 << 2) + 4 | 0, gb + 717183 | 0, 1412) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i3 = i18 + 100 | 0;
   i2 = i18 + 108 | 0;
  }
  HEAP32[i8 >> 2] = i1 + 1;
  i21 = (HEAP32[i3 >> 2] | 0) + (i1 * 24 | 0) | 0;
  HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i21 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP16[(HEAP32[i2 >> 2] | 0) + (i1 << 1) >> 1] = i15;
 }
 i21 = i12 & 65535;
 i7 = HEAP32[i18 + 76 >> 2] | 0;
 i8 = i7 + (i21 << 3) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 + (i21 << 3) + 4 >> 2] = i14;
 if (i13) {
  STACKTOP = i19;
  return i15 | 0;
 }
 i2 = HEAP32[i18 + 100 >> 2] | 0;
 i3 = HEAP32[i18 + 108 >> 2] | 0;
 i4 = i18 + 116 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i2 + (i5 * 24 | 0) | 0;
 if ((i1 | 0) == (i5 | 0)) {
  HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 } else {
  HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  i21 = i2 + (i1 * 24 | 0) | 0;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i21 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  i17 = i3 + (i5 << 1) | 0;
  i21 = HEAP16[i17 >> 1] | 0;
  i20 = i3 + (i1 << 1) | 0;
  HEAP16[i17 >> 1] = HEAP16[i20 >> 1] | 0;
  HEAP16[i20 >> 1] = i21;
  HEAP32[i7 + ((i21 & 65535) << 3) >> 2] = i1;
  HEAP32[i8 >> 2] = i5;
 }
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP32[i18 + 120 >> 2] = 0;
 HEAP8[i18 + 169 >> 0] = 1;
 STACKTOP = i19;
 return i15 | 0;
}

function __Z26TransformVerticesInnerLoopILb1ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i7, i34, i35, i2, i5, i36, i1, i37, i6, i38, i3, i4) {
 i7 = i7 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i36 = i36 | 0;
 i1 = i1 | 0;
 i37 = i37 | 0;
 i6 = i6 | 0;
 i38 = i38 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i32 = (i3 | 0) / 4 | 0;
 i33 = (i4 & 8 | 0) == 0;
 if (i33) {
  i29 = 0;
  i30 = 0;
  i31 = 0;
 } else {
  i29 = HEAP32[i34 >> 2] | 0;
  i30 = HEAP32[i34 + 4 >> 2] | 0;
  i31 = HEAP32[i34 + 8 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (!i2) return;
 i9 = i34 + 16 | 0;
 i10 = i34 + 32 | 0;
 i11 = i34 + 48 | 0;
 i12 = i34 + 4 | 0;
 i13 = i34 + 20 | 0;
 i14 = i34 + 36 | 0;
 i15 = i34 + 52 | 0;
 i16 = i34 + 8 | 0;
 i17 = i34 + 24 | 0;
 i18 = i34 + 40 | 0;
 i19 = i34 + 56 | 0;
 i20 = i35 + 12 | 0;
 i21 = i35 + 24 | 0;
 i22 = i35 + 4 | 0;
 i23 = i35 + 16 | 0;
 i24 = i35 + 28 | 0;
 i25 = i35 + 8 | 0;
 i26 = i35 + 20 | 0;
 i27 = i35 + 32 | 0;
 i28 = (i4 & 4 | 0) == 0;
 i8 = (i3 | 0) > 3;
 if (!(i4 & 2)) {
  i2 = i7;
  i7 = i1;
  while (1) {
   f39 = Math_fround(HEAPF32[i34 >> 2]);
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i5 >> 2]));
   f40 = Math_fround(HEAPF32[i9 >> 2]);
   i4 = i5 + 4 | 0;
   f41 = Math_fround(HEAPF32[i4 >> 2]);
   f40 = Math_fround(f39 + Math_fround(f40 * f41));
   f39 = Math_fround(HEAPF32[i10 >> 2]);
   f42 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f39 = Math_fround(f40 + Math_fround(f39 * f42));
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f39);
   f39 = Math_fround(HEAPF32[i12 >> 2]);
   f40 = Math_fround(HEAPF32[i5 >> 2]);
   f39 = Math_fround(f39 * f40);
   f41 = Math_fround(f39 + Math_fround(f41 * Math_fround(HEAPF32[i13 >> 2])));
   f41 = Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i14 >> 2])));
   HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f41);
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i16 >> 2]));
   f41 = Math_fround(HEAPF32[i17 >> 2]);
   f41 = Math_fround(f40 + Math_fround(f41 * Math_fround(HEAPF32[i4 >> 2])));
   f42 = Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i18 >> 2])));
   HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f42);
   i4 = i5 + i36 | 0;
   f42 = Math_fround(HEAPF32[i35 >> 2]);
   f42 = Math_fround(f42 * Math_fround(HEAPF32[i4 >> 2]));
   f41 = Math_fround(HEAPF32[i20 >> 2]);
   i1 = i4 + 4 | 0;
   f40 = Math_fround(HEAPF32[i1 >> 2]);
   f41 = Math_fround(f42 + Math_fround(f41 * f40));
   f42 = Math_fround(HEAPF32[i21 >> 2]);
   f39 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   HEAPF32[i2 + 12 >> 2] = Math_fround(f41 + Math_fround(f42 * f39));
   f42 = Math_fround(HEAPF32[i22 >> 2]);
   f41 = Math_fround(HEAPF32[i4 >> 2]);
   f42 = Math_fround(f42 * f41);
   f40 = Math_fround(f42 + Math_fround(f40 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i2 + 16 >> 2] = Math_fround(f40 + Math_fround(f39 * Math_fround(HEAPF32[i24 >> 2])));
   f41 = Math_fround(f41 * Math_fround(HEAPF32[i25 >> 2]));
   f40 = Math_fround(HEAPF32[i26 >> 2]);
   f40 = Math_fround(f41 + Math_fround(f40 * Math_fround(HEAPF32[i1 >> 2])));
   HEAPF32[i2 + 20 >> 2] = Math_fround(f40 + Math_fround(f39 * Math_fround(HEAPF32[i27 >> 2])));
   i1 = i2 + 24 | 0;
   if (!i28) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    i1 = i2 + 32 | 0;
   }
   if (!i6) i2 = 0; else {
    if (i8) {
     i4 = 0;
     i2 = i6;
     while (1) {
      i3 = i1 + 4 | 0;
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i32 | 0)) {
       i1 = i3;
       break;
      } else {
       i1 = i3;
       i2 = i2 + 4 | 0;
      }
     }
    }
    i2 = i6 + i38 | 0;
   }
   if (!i33) {
    HEAP32[i1 >> 2] = i29;
    HEAP32[i1 + 4 >> 2] = i30;
    HEAP32[i1 + 8 >> 2] = i31;
    HEAP32[i1 + 12 >> 2] = 1065353216;
    i1 = i1 + 16 | 0;
   }
   if (!i7) break; else {
    i5 = i5 + i37 | 0;
    i6 = i2;
    i2 = i1;
    i7 = i7 + -1 | 0;
   }
  }
  return;
 } else {
  i2 = i7;
  i7 = i1;
  while (1) {
   f42 = Math_fround(HEAPF32[i34 >> 2]);
   f42 = Math_fround(f42 * Math_fround(HEAPF32[i5 >> 2]));
   f41 = Math_fround(HEAPF32[i9 >> 2]);
   i4 = i5 + 4 | 0;
   f40 = Math_fround(HEAPF32[i4 >> 2]);
   f41 = Math_fround(f42 + Math_fround(f41 * f40));
   f42 = Math_fround(HEAPF32[i10 >> 2]);
   f39 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f42 = Math_fround(f41 + Math_fround(f42 * f39));
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f42);
   f42 = Math_fround(HEAPF32[i12 >> 2]);
   f41 = Math_fround(HEAPF32[i5 >> 2]);
   f42 = Math_fround(f42 * f41);
   f40 = Math_fround(f42 + Math_fround(f40 * Math_fround(HEAPF32[i13 >> 2])));
   f40 = Math_fround(f40 + Math_fround(f39 * Math_fround(HEAPF32[i14 >> 2])));
   HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f40);
   f41 = Math_fround(f41 * Math_fround(HEAPF32[i16 >> 2]));
   f40 = Math_fround(HEAPF32[i17 >> 2]);
   f40 = Math_fround(f41 + Math_fround(f40 * Math_fround(HEAPF32[i4 >> 2])));
   f39 = Math_fround(f40 + Math_fround(f39 * Math_fround(HEAPF32[i18 >> 2])));
   HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f39);
   i4 = i5 + i36 | 0;
   f39 = Math_fround(HEAPF32[i35 >> 2]);
   f39 = Math_fround(f39 * Math_fround(HEAPF32[i4 >> 2]));
   f40 = Math_fround(HEAPF32[i20 >> 2]);
   i1 = i4 + 4 | 0;
   f41 = Math_fround(HEAPF32[i1 >> 2]);
   f40 = Math_fround(f39 + Math_fround(f40 * f41));
   f39 = Math_fround(HEAPF32[i21 >> 2]);
   f42 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   HEAPF32[i2 + 12 >> 2] = Math_fround(f40 + Math_fround(f39 * f42));
   f39 = Math_fround(HEAPF32[i22 >> 2]);
   f40 = Math_fround(HEAPF32[i4 >> 2]);
   f39 = Math_fround(f39 * f40);
   f41 = Math_fround(f39 + Math_fround(f41 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i2 + 16 >> 2] = Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i24 >> 2])));
   f40 = Math_fround(f40 * Math_fround(HEAPF32[i25 >> 2]));
   f41 = Math_fround(HEAPF32[i26 >> 2]);
   f41 = Math_fround(f40 + Math_fround(f41 * Math_fround(HEAPF32[i1 >> 2])));
   HEAPF32[i2 + 20 >> 2] = Math_fround(f41 + Math_fround(f42 * Math_fround(HEAPF32[i27 >> 2])));
   HEAP32[i2 + 24 >> 2] = -1;
   i1 = i2 + 28 | 0;
   if (!i28) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i2 + 32 >> 2] = 0;
    i1 = i2 + 36 | 0;
   }
   if (!i6) i2 = 0; else {
    if (i8) {
     i4 = 0;
     i2 = i6;
     while (1) {
      i3 = i1 + 4 | 0;
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i32 | 0)) {
       i1 = i3;
       break;
      } else {
       i1 = i3;
       i2 = i2 + 4 | 0;
      }
     }
    }
    i2 = i6 + i38 | 0;
   }
   if (!i33) {
    HEAP32[i1 >> 2] = i29;
    HEAP32[i1 + 4 >> 2] = i30;
    HEAP32[i1 + 8 >> 2] = i31;
    HEAP32[i1 + 12 >> 2] = 1065353216;
    i1 = i1 + 16 | 0;
   }
   if (!i7) break; else {
    i5 = i5 + i37 | 0;
    i6 = i2;
    i2 = i1;
    i7 = i7 + -1 | 0;
   }
  }
  return;
 }
}

function __ZN5physx2Sn18RepXCollectionImpl21instantiateCollectionERNS_23PxRepXInstantiationArgsERNS_12PxCollectionE(i1, i26, i27) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i48 + 16 | 0;
 i47 = i48 + 96 | 0;
 i29 = i48 + 20 | 0;
 i28 = i48;
 i23 = i1 + 24 | 0;
 if (!(HEAP32[i23 >> 2] | 0)) {
  i47 = 1;
  STACKTOP = i48;
  return i47 | 0;
 }
 i24 = i1 + 20 | 0;
 i25 = i1 + 12 | 0;
 i17 = i1 + 8 | 0;
 i18 = i47 + 4 | 0;
 i19 = i47 + 8 | 0;
 i20 = i47 + 12 | 0;
 i21 = i47 + 16 | 0;
 i6 = i47 + 20 | 0;
 i7 = i18;
 i43 = i47 + 24 | 0;
 i8 = i47 + 28 | 0;
 i44 = i47 + 32 | 0;
 i9 = i29 + 4 | 0;
 i31 = i29 + 8 | 0;
 i10 = i29 + 12 | 0;
 i11 = i9;
 i40 = i29 + 16 | 0;
 i32 = i29 + 20 | 0;
 i41 = i29 + 24 | 0;
 i12 = i29 + 28 | 0;
 i37 = i29 + 32 | 0;
 i13 = i29 + 56 | 0;
 i38 = i29 + 60 | 0;
 i14 = i29 + 64 | 0;
 i39 = i29 + 68 | 0;
 i15 = i29 + 72 | 0;
 i16 = i28 + 4 | 0;
 i33 = i29 + 52 | 0;
 i45 = i29 + 12 | 0;
 i46 = i47 + 20 | 0;
 i42 = i29 + 28 | 0;
 i34 = i29 + 44 | 0;
 i36 = i29 + 48 | 0;
 i35 = i29 + 40 | 0;
 i22 = 0;
 while (1) {
  i2 = HEAP32[i24 >> 2] | 0;
  i1 = HEAP32[i2 + (i22 * 24 | 0) >> 2] | 0;
  i5 = i2 + (i22 * 24 | 0) + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = HEAP32[i2 + (i22 * 24 | 0) + 16 >> 2] | 0;
  i3 = HEAP32[i25 >> 2] | 0;
  i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i1 | 0) | 0;
  if (!i3) {
   i2 = 37;
   break;
  }
  i49 = HEAP32[i17 >> 2] | 0;
  i49 = mftCall_ii(HEAP32[(HEAP32[i49 >> 2] | 0) + 16 >> 2] | 0, i49 | 0) | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i47 >> 2] = gb + 146564 + 8;
  HEAP32[i18 >> 2] = i49;
  HEAP32[i19 >> 2] = i1 + 4;
  HEAP32[i20 >> 2] = i2;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i43 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i44 >> 2] = 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i29 >> 2] = gb + 142044 + 8;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i31 >> 2] = i9;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i40 >> 2] = 0;
  HEAP32[i32 >> 2] = 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  HEAP32[i37 + 12 >> 2] = 0;
  HEAP32[i37 + 16 >> 2] = 0;
  HEAP32[i37 + 20 >> 2] = 0;
  HEAPF32[i13 >> 2] = Math_fround(.75);
  HEAP32[i38 >> 2] = -1;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i39 >> 2] = 0;
  __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i12, 64);
  HEAP32[i15 >> 2] = 32;
  mftCall_viiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i28 | 0, i3 | 0, i47 | 0, i29 | 0, i26 | 0, i27 | 0);
  i1 = HEAP32[i16 >> 2] | 0;
  if (!i1) {
   i2 = 21;
   break;
  }
  mftCall_viiii(HEAP32[HEAP32[i27 >> 2] >> 2] | 0, i27 | 0, i1 | 0, i4 | 0, i5 | 0);
  HEAP32[i29 >> 2] = gb + 142044 + 8;
  i1 = HEAP32[i40 >> 2] | 0;
  i49 = HEAP32[i32 >> 2] | 0;
  i2 = i1 + (i49 << 2) | 0;
  if (i49 | 0) do {
   i49 = HEAP32[HEAP32[i31 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i32 >> 2] = 0;
  i1 = HEAP32[i33 >> 2] | 0;
  if (!((i1 | 0) == 0 | (HEAP32[i39 >> 2] | 0) == 0)) {
   _memset(HEAP32[i34 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i2 = HEAP32[i36 >> 2] | 0;
   i4 = i2 + -1 | 0;
   i1 = HEAP32[i35 >> 2] | 0;
   if (i4) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i35 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i36 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i39 >> 2] = 0;
  }
  i1 = HEAP32[i37 >> 2] | 0;
  if (i1 | 0) {
   i49 = HEAP32[HEAP32[i42 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
  }
  i49 = HEAP32[i41 >> 2] | 0;
  if ((i49 | 0) > -1 & (i49 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1 | 0) {
    i49 = HEAP32[HEAP32[i45 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
   }
  }
  HEAP32[i47 >> 2] = gb + 146564 + 8;
  i49 = HEAP32[i44 >> 2] | 0;
  if ((i49 | 0) > -1 & (i49 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i43 >> 2] | 0;
   if (i1 | 0) {
    i49 = HEAP32[HEAP32[i46 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
   }
  }
  i22 = i22 + 1 | 0;
  if (i22 >>> 0 >= (HEAP32[i23 >> 2] | 0) >>> 0) {
   i1 = 1;
   i2 = 38;
   break;
  }
 }
 if ((i2 | 0) == 21) {
  HEAP32[i29 >> 2] = gb + 142044 + 8;
  i1 = HEAP32[i40 >> 2] | 0;
  i49 = HEAP32[i32 >> 2] | 0;
  i2 = i1 + (i49 << 2) | 0;
  if (i49 | 0) do {
   i49 = HEAP32[HEAP32[i31 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  HEAP32[i32 >> 2] = 0;
  i1 = HEAP32[i33 >> 2] | 0;
  if (!((i1 | 0) == 0 | (HEAP32[i39 >> 2] | 0) == 0)) {
   _memset(HEAP32[i34 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i2 = HEAP32[i36 >> 2] | 0;
   i4 = i2 + -1 | 0;
   i1 = HEAP32[i35 >> 2] | 0;
   if (i4) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i35 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i36 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i39 >> 2] = 0;
  }
  i1 = HEAP32[i37 >> 2] | 0;
  if (i1 | 0) {
   i49 = HEAP32[HEAP32[i42 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
  }
  i49 = HEAP32[i41 >> 2] | 0;
  if ((i49 | 0) > -1 & (i49 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1 | 0) {
    i49 = HEAP32[HEAP32[i45 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
   }
  }
  HEAP32[i47 >> 2] = gb + 146564 + 8;
  i49 = HEAP32[i44 >> 2] | 0;
  if ((i49 | 0) > -1 & (i49 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i43 >> 2] | 0;
   if (i1 | 0) {
    i49 = HEAP32[HEAP32[i46 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i49 >> 2] | 0) + 12 >> 2] | 0, i49 | 0, i1 | 0);
   }
  }
  i49 = 0;
  STACKTOP = i48;
  return i49 | 0;
 } else if ((i2 | 0) == 37) {
  i49 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i30 >> 2] = i1;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i49, 32, gb + 766736 | 0, 543, gb + 766948 | 0, i30);
  i49 = 0;
  STACKTOP = i48;
  return i49 | 0;
 } else if ((i2 | 0) == 38) {
  STACKTOP = i48;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx13PxsCCDContext14postCCDAdvanceEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i37 + 32 | 0;
 i30 = i37 + 24 | 0;
 i31 = i37 + 20 | 0;
 i32 = i37 + 16 | 0;
 i29 = i37 + 30 | 0;
 i35 = i37 + 28 | 0;
 i33 = i37;
 i26 = HEAP32[i2 + 244 >> 2] | 0;
 i36 = i2 + 264 | 0;
 i1 = HEAP32[i36 >> 2] | 0;
 if (!i26) {
  i36 = i1;
  i33 = 0;
  i35 = 0;
  i34 = i36 + 1360 | 0;
  i32 = HEAP32[i34 >> 2] | 0;
  i33 = i32 + i33 | 0;
  HEAP32[i34 >> 2] = i33;
  i36 = i36 + 1364 | 0;
  i34 = HEAP32[i36 >> 2] | 0;
  i35 = i34 + i35 | 0;
  HEAP32[i36 >> 2] = i35;
  STACKTOP = i37;
  return;
 }
 i27 = i2 + 240 | 0;
 i28 = i2 + 228 | 0;
 i24 = i2 + 252 | 0;
 i25 = i34 + 2 | 0;
 i19 = i33 + 8 | 0;
 i20 = i33 + 12 | 0;
 i21 = i33 + 4 | 0;
 i22 = i1 + 5864 | 0;
 i23 = i1 + 5872 | 0;
 i16 = i1 + 5868 | 0;
 i2 = 0;
 i1 = 0;
 i17 = 0;
 i18 = 0;
 do {
  i3 = i17;
  i17 = (HEAP32[(HEAP32[i27 >> 2] | 0) + (i18 << 2) >> 2] | 0) + i17 | 0;
  L6 : do if (i3 >>> 0 < i17 >>> 0) {
   i15 = i3;
   do {
    i14 = HEAP32[(HEAP32[i28 >> 2] | 0) + (i15 << 2) >> 2] | 0;
    if (Math_fround(HEAPF32[i14 + 28 >> 2]) > Math_fround(1.0)) break L6;
    L10 : do if (HEAP8[i14 + 68 >> 0] | 0) {
     i13 = i14 + 52 | 0;
     i6 = HEAP32[i13 >> 2] | 0;
     i3 = i6 + 8 | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
     i3 = HEAP16[i6 + 114 >> 1] | 0;
     i12 = (i3 & 2) == 0;
     i5 = HEAP32[i36 >> 2] | 0;
     i8 = i5 + 1344 | 0;
     i11 = HEAP32[i6 + 76 >> 2] | 0;
     i9 = (i11 + 32 | 0) >>> 5;
     i10 = i5 + 1348 | 0;
     if (i9 >>> 0 > (HEAP32[i10 >> 2] & 2147483647) >>> 0) {
      i3 = i5 + 1352 | 0;
      i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i9 << 2, gb + 769739 | 0, 329) | 0;
      i6 = HEAP32[i8 >> 2] | 0;
      if (i6 | 0) {
       _memcpy(i5 | 0, i6 | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
       if ((HEAP32[i10 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i8 >> 2] | 0);
      }
      i3 = HEAP32[i10 >> 2] | 0;
      _memset(i5 + ((i3 & 2147483647) << 2) | 0, 0, i9 - i3 << 2 | 0) | 0;
      HEAP32[i8 >> 2] = i5;
      HEAP32[i10 >> 2] = i9;
      i3 = HEAP32[i13 >> 2] | 0;
      i9 = i3;
      i3 = HEAP16[i3 + 114 >> 1] | 0;
     } else {
      i5 = HEAP32[i8 >> 2] | 0;
      i9 = i6;
     }
     i5 = i5 + (i11 >>> 5 << 2) | 0;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1 << (i11 & 31);
     i5 = i9 + 114 | 0;
     i3 = i3 & 65535;
     if (i12) {
      i6 = (i3 & 65532 | 2) & 65535;
      HEAP16[i5 >> 1] = i6;
      i2 = i2 + 1 | 0;
     } else {
      i6 = (i3 | 8) & 65535;
      HEAP16[i5 >> 1] = i6;
      i1 = i1 + 1 | 0;
     }
     i8 = i9 + 38 | 0;
     i3 = HEAP16[i8 >> 1] | 0;
     i5 = i3 & 65535;
     do if (!(i5 & 1)) {
      if (!(i5 & 256)) break L10;
      if (i5 & 32 | 0) if ((HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 92 >> 2] | 0) != 2139095039) break;
      if (!(i3 & 64)) break L10;
      if ((HEAP32[(HEAP32[i9 + 84 >> 2] | 0) + 92 >> 2] | 0) == 2139095039) break L10;
     } while (0);
     i12 = HEAP32[i24 >> 2] | 0;
     i11 = i12 + 400 | 0;
     HEAP32[i12 + 416 >> 2] = HEAP32[i14 + 36 >> 2];
     HEAP32[i12 + 420 >> 2] = HEAP32[i14 + 40 >> 2];
     HEAP32[i12 + 424 >> 2] = HEAP32[i14 + 44 >> 2];
     f38 = Math_fround(-Math_fround(HEAPF32[i14 + 16 >> 2]));
     f4 = Math_fround(-Math_fround(HEAPF32[i14 + 20 >> 2]));
     f7 = Math_fround(-Math_fround(HEAPF32[i14 + 24 >> 2]));
     HEAPF32[i11 >> 2] = f38;
     HEAPF32[i12 + 404 >> 2] = f4;
     HEAPF32[i12 + 408 >> 2] = f7;
     HEAP32[i12 + 448 >> 2] = HEAP32[i14 + 72 >> 2];
     HEAP32[i12 + 452 >> 2] = -1;
     HEAPF32[i12 + 412 >> 2] = Math_fround(0.0);
     HEAP32[i12 + 460 >> 2] = HEAP32[i14 + 88 >> 2];
     HEAP32[i12 + 456 >> 2] = HEAP32[i14 + 80 >> 2];
     HEAP32[i12 + 444 >> 2] = HEAP32[i14 + 84 >> 2];
     HEAP32[i12 + 432 >> 2] = 0;
     HEAP32[i12 + 436 >> 2] = 0;
     HEAP32[i12 + 440 >> 2] = 0;
     HEAPF32[i12 + 428 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAP16[i34 >> 1] = HEAP16[i14 + 76 >> 1] | 0;
     HEAP16[i25 >> 1] = HEAP16[i14 + 78 >> 1] | 0;
     HEAP16[i35 >> 1] = i6;
     i6 = HEAP32[i9 + 40 >> 2] | 0;
     do if (!(__ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b(i11, 1, i12 + 16 | 0, i29, i31, i32, i30, 4, i35, HEAP32[i9 + 96 >> 2] | 0, (HEAP16[i8 >> 1] & 128) != 0, 1, i34, 8, 0, 0, 0) | 0)) if (!i6) {
      i3 = HEAP32[i13 >> 2] | 0;
      HEAP32[i3 + 40 >> 2] = 0;
      break;
     } else {
      HEAP16[i6 + 6 >> 1] = 1;
      i3 = HEAP32[i13 >> 2] | 0;
      break;
     } else {
      i5 = HEAP32[i31 >> 2] | 0;
      HEAP16[i5 + 4 >> 1] = HEAP32[i32 >> 2];
      HEAP16[i5 + 6 >> 1] = 0;
      i3 = HEAP32[i13 >> 2] | 0;
      HEAP32[i3 + 40 >> 2] = i5;
      HEAP16[i3 + 114 >> 1] = HEAP16[i35 >> 1] | 0;
      if (!i6) HEAP32[i5 >> 2] = 0; else {
       HEAP32[i5 >> 2] = i6;
       HEAP16[i6 + 6 >> 1] = 1;
      }
      HEAP32[HEAP32[i30 >> 2] >> 2] = HEAP32[i14 + 96 >> 2];
     } while (0);
     if (!(HEAP16[i3 + 38 >> 1] & 24)) {
      f4 = Math_fround(HEAPF32[i14 + 96 >> 2]);
      if (f4 != Math_fround(0.0)) {
       HEAPF32[i19 >> 2] = f4;
       i6 = HEAP32[i14 >> 2] | 0;
       if (!i6) f7 = Math_fround(3402823469999999843913219.0e14); else f7 = Math_fround(HEAPF32[(HEAP32[i6 + 64 >> 2] | 0) + 92 >> 2]);
       i3 = HEAP32[i14 + 4 >> 2] | 0;
       i5 = i3;
       if (!i3) f4 = Math_fround(3402823469999999843913219.0e14); else f4 = Math_fround(HEAPF32[(HEAP32[i3 + 64 >> 2] | 0) + 92 >> 2]);
       HEAPF32[i20 >> 2] = f7 < f4 ? f7 : f4;
       HEAP32[i33 >> 2] = i6;
       HEAP32[i21 >> 2] = i5;
       if (i3 >>> 0 < i6 >>> 0) {
        HEAP32[i33 >> 2] = i5;
        HEAP32[i21 >> 2] = i6;
       }
       i3 = HEAP32[i16 >> 2] | 0;
       if ((HEAP32[i23 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
        i14 = (HEAP32[i22 >> 2] | 0) + (i3 << 4) | 0;
        HEAP32[i14 >> 2] = HEAP32[i33 >> 2];
        HEAP32[i14 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
        HEAP32[i14 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
        HEAP32[i14 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
        HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i22, i33) | 0;
        break;
       }
      }
     }
    } while (0);
    i15 = i15 + 1 | 0;
   } while (i15 >>> 0 < i17 >>> 0);
  } while (0);
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i26 | 0));
 i36 = HEAP32[i36 >> 2] | 0;
 i33 = i2;
 i35 = i1;
 i34 = i36 + 1360 | 0;
 i32 = HEAP32[i34 >> 2] | 0;
 i33 = i32 + i33 | 0;
 HEAP32[i34 >> 2] = i33;
 i36 = i36 + 1364 | 0;
 i34 = HEAP32[i36 >> 2] | 0;
 i35 = i34 + i35 | 0;
 HEAP32[i36 >> 2] = i35;
 STACKTOP = i37;
 return;
}

function _UNITY_FT_Load_Glyph(i9, i7, i4) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 if (!i9) {
  i14 = 35;
  return i14 | 0;
 }
 i10 = i9 + 88 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i14 = 35;
  return i14 | 0;
 }
 i14 = HEAP32[i9 + 84 >> 2] | 0;
 if (!i14) {
  i14 = 35;
  return i14 | 0;
 }
 i1 = i14 + 156 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i11 = 7; else if (!(HEAP32[i2 + 4 >> 2] & 1)) i11 = 7; else {
  i13 = i14 + 88 | 0;
  _UNITY_ft_mem_free(HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i13 >> 2] | 0);
  HEAP32[i13 >> 2] = 0;
  i13 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & -2;
 }
 if ((i11 | 0) == 7) HEAP32[i14 + 88 >> 2] = 0;
 i8 = i14 + 24 | 0;
 HEAP8[i14 + 94 >> 0] = 0;
 i1 = i14 + 100 | 0;
 i13 = i14 + 72 | 0;
 i2 = i8;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i2 = i1;
 i3 = i2 + 56 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i5 = HEAP32[i9 + 96 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 160 >> 2] | 0;
 i12 = (i4 & 1024 | 0) == 0 ? i4 : i4 | 2049;
 i12 = (i12 & 1 | 0) == 0 ? i12 : i12 & -15 | 10;
 i4 = (i12 & 2 | 0) == 0;
 L16 : do if ((i12 & 32770 | 0) == 0 & (i6 | 0) != 0) {
  i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if ((i1 & 768 | 0) == 256) {
   i2 = HEAP32[i9 + 8 >> 2] | 0;
   if (!(i2 & 8192)) {
    do if (!(i12 & 2048)) {
     i15 = HEAP32[i9 + 128 >> 2] | 0;
     i3 = (HEAP32[i15 >> 2] | 0) == 0;
     if (!(HEAP32[i15 + 8 >> 2] | 0)) if (i3) {
      i11 = 27;
      break L16;
     } else break; else if (i3) break; else {
      i11 = 27;
      break L16;
     }
    } while (0);
    if (!(i12 & 32)) if (!((i12 & 983040 | 0) == 65536 | (i1 & 1024 | 0) == 0)) if (!(HEAP8[(HEAP32[i9 + 128 >> 2] | 0) + 48 >> 0] | 0)) {
     if (!(i2 & 8)) {
      i11 = 27;
      break;
     }
     if (!(HEAP32[i9 + 696 >> 2] | 0)) {
      i11 = 27;
      break;
     }
     if (HEAP16[i9 + 260 + 26 >> 1] | 0) {
      i11 = 27;
      break;
     }
     if (HEAP32[i9 + 628 >> 2] | 0) {
      i11 = 27;
      break;
     }
     if (HEAP32[i9 + 636 >> 2] | 0) {
      i11 = 27;
      break;
     }
    }
    if ((i12 & 8 | 0) == 0 & (i2 & 2 | 0) != 0) if (!(mftCall_iiiii(HEAP32[(HEAP32[i5 + 12 >> 2] | 0) + 72 >> 2] | 0, i14 | 0, HEAP32[i10 >> 2] | 0, i7 | 0, i12 | 16384 | 0) | 0)) if ((HEAP32[i13 >> 2] | 0) == 1651078259) {
     i1 = 0;
     break;
    }
    i15 = (HEAP32[i9 + 128 >> 2] | 0) + 24 | 0;
    i8 = HEAP32[i15 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i14 | 0, HEAP32[i10 >> 2] | 0, i7 | 0, i12 | 0) | 0;
    HEAP32[i15 >> 2] = i8;
   } else i11 = 27;
  } else i11 = 27;
 } else i11 = 27; while (0);
 if ((i11 | 0) == 27) {
  i1 = mftCall_iiiii(HEAP32[(HEAP32[i5 + 12 >> 2] | 0) + 72 >> 2] | 0, i14 | 0, HEAP32[i10 >> 2] | 0, i7 | 0, i12 | 0) | 0;
  if (i1 | 0) {
   i15 = i1;
   return i15 | 0;
  }
  if ((HEAP32[i13 >> 2] | 0) == 1869968492) {
   i1 = _UNITY_FT_Outline_Check(i14 + 108 | 0) | 0;
   if (i1 | 0) {
    i15 = i1;
    return i15 | 0;
   }
   if (i4) {
    if (!(i12 & 16)) {
     i3 = i14 + 44 | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -64;
     i3 = i14 + 48 | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -64;
     i3 = i14 + 32 | 0;
     i6 = HEAP32[i3 >> 2] | 0;
     i5 = i6 + 63 + (HEAP32[i8 >> 2] | 0) & -64;
     i4 = i14 + 36 | 0;
     i7 = HEAP32[i4 >> 2] | 0;
     i15 = i14 + 28 | 0;
     i11 = i7 - (HEAP32[i15 >> 2] | 0) & -64;
     i6 = i6 & -64;
     HEAP32[i3 >> 2] = i6;
     i7 = i7 + 63 & -64;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i8 >> 2] = i5 - i6;
     HEAP32[i15 >> 2] = i7 - i11;
    } else {
     i3 = i14 + 32 | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -64;
     i3 = i14 + 36 | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 63 & -64;
     i3 = i14 + 44 | 0;
     i6 = HEAP32[i3 >> 2] | 0;
     i5 = i6 + 63 + (HEAP32[i8 >> 2] | 0) & -64;
     i4 = i14 + 48 | 0;
     i11 = HEAP32[i4 >> 2] | 0;
     i15 = i14 + 28 | 0;
     i7 = i11 + 63 + (HEAP32[i15 >> 2] | 0) & -64;
     i6 = i6 & -64;
     HEAP32[i3 >> 2] = i6;
     i11 = i11 & -64;
     HEAP32[i4 >> 2] = i11;
     HEAP32[i8 >> 2] = i5 - i6;
     HEAP32[i15 >> 2] = i7 - i11;
    }
    i1 = i14 + 40 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 32 & -64;
    i1 = i14 + 52 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 32 & -64;
    i1 = 0;
   } else i1 = 0;
  } else i1 = 0;
 }
 if (!(i12 & 16)) {
  i2 = 0;
  i3 = HEAP32[i14 + 40 >> 2] | 0;
 } else {
  i2 = HEAP32[i14 + 52 >> 2] | 0;
  i3 = 0;
 }
 HEAP32[i14 + 64 >> 2] = i3;
 HEAP32[i14 + 68 >> 2] = i2;
 if (!(i12 & 8192)) if (HEAP32[i9 + 8 >> 2] & 1 | 0) {
  i11 = HEAP32[i10 >> 2] | 0;
  i15 = i14 + 56 | 0;
  HEAP32[i15 >> 2] = _UNITY_FT_MulDiv(HEAP32[i15 >> 2] | 0, HEAP32[i11 + 16 >> 2] | 0, 64) | 0;
  i15 = i14 + 60 | 0;
  HEAP32[i15 >> 2] = _UNITY_FT_MulDiv(HEAP32[i15 >> 2] | 0, HEAP32[i11 + 20 >> 2] | 0, 64) | 0;
 }
 if (!(i12 & 2048)) {
  i7 = HEAP32[i9 + 128 >> 2] | 0;
  i6 = i7 + 24 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2) {
   i5 = HEAP32[(HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 96 >> 2] | 0) + 4 >> 2] | 0;
   i3 = HEAP32[i5 + 156 >> 2] | 0;
   if (!i3) {
    i4 = HEAP32[i13 >> 2] | 0;
    i11 = 46;
   } else {
    i4 = HEAP32[i13 >> 2] | 0;
    if ((HEAP32[i3 + 16 >> 2] | 0) == (i4 | 0)) {
     i1 = i3;
     i11 = 51;
    } else i11 = 46;
   }
   L68 : do if ((i11 | 0) == 46) {
    L70 : do if (i5 | 0) {
     i3 = HEAP32[i5 + 148 >> 2] | 0;
     if (i3 | 0) {
      while (1) {
       i5 = HEAP32[i3 + 8 >> 2] | 0;
       if ((HEAP32[i5 + 16 >> 2] | 0) == (i4 | 0)) break;
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) break L70;
      }
      if (i5 | 0) {
       i1 = i5;
       i11 = 51;
       break L68;
      }
     }
    } while (0);
    if ((i4 | 0) == 1869968492) {
     if (i2 & 1) {
      _UNITY_FT_Outline_Transform(i14 + 108 | 0, i7);
      i2 = HEAP32[i6 >> 2] | 0;
     }
     if (i2 & 2) _UNITY_FT_Outline_Translate(i14 + 108 | 0, HEAP32[i7 + 16 >> 2] | 0, HEAP32[i7 + 20 >> 2] | 0);
    }
   } while (0);
   if ((i11 | 0) == 51) i1 = mftCall_iiiii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i14 | 0, i7 | 0, i7 + 16 | 0) | 0;
   _UNITY_FT_Vector_Transform(i14 + 64 | 0, i7);
  }
 }
 if (i1 | 0) {
  i15 = i1;
  return i15 | 0;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 L89 : do if ((i1 | 0) < 1668246896) {
  switch (i1 | 0) {
  case 1651078259:
   {
    i1 = 0;
    break;
   }
  default:
   break L89;
  }
  return i1 | 0;
 } else {
  switch (i1 | 0) {
  case 1668246896:
   {
    i1 = 0;
    break;
   }
  default:
   break L89;
  }
  return i1 | 0;
 } while (0);
 if (!(i12 & 4)) {
  i15 = 0;
  return i15 | 0;
 }
 i1 = i12 >>> 16 & 15;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 if (!i2) {
  i15 = 6;
  return i15 | 0;
 }
 i15 = _UNITY_FT_Render_Glyph_Internal(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, i14, (i12 & 4096 | 0) == 0 | (i1 | 0) != 0 ? i1 : 2) | 0;
 return i15 | 0;
}

function __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj3ENS_22PxRepXPropertyAccessorILj3ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 28 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj4ENS_22PxRepXPropertyAccessorILj4ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj5ENS_22PxRepXPropertyAccessorILj5ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i12 = i10 + 60 | 0;
  i7 = i9 + 4 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj6ES3_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i12, i7);
  i7 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj7ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i12);
  i10 = i10 + 92 | 0;
  i12 = i9 + 6 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj8ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 9 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i12 = i10 + 60 | 0;
 i7 = i9 + 4 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj6ES3_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i12, i7);
 i7 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj7ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i12);
 i10 = i10 + 92 | 0;
 i12 = i9 + 6 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj8ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 9 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 16 | 0;
 i4 = i14;
 i5 = i14 + 8 | 0;
 i3 = i2;
 i11 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i12, i13, i1);
 HEAP32[i12 >> 2] = gb + 58004 + 8;
 i5 = i12 + 44 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -32 | 3;
 i5 = i12 + 48 | 0;
 i1 = i12 + 60 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i12 + 72 >> 2] = 0;
 HEAP32[i12 + 84 >> 2] = 0;
 HEAP32[i12 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i1 = i13;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i12 + 76 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i12 + 92 >> 2] = 0;
 HEAP32[i12 + 104 >> 2] = 0;
 HEAP32[i12 + 108 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i7 = i13;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i12 + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i12 + 112 | 0;
 HEAP32[i12 + 136 >> 2] = 0;
 HEAP32[i12 + 140 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i1 = i13;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i12 + 128 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = i4;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i12 + 144 >> 2] = 0;
 HEAP32[i12 + 156 >> 2] = 0;
 HEAP32[i12 + 160 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i7 = i13;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i12 + 148 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i4;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i12 + 164 >> 2] = 0;
 HEAP32[i12 + 176 >> 2] = 0;
 HEAP32[i12 + 180 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i1 = i13;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i11 = i12 + 168 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i12 + 184 >> 2] = 0;
 HEAP32[i12 + 192 >> 2] = 0;
 HEAP32[i12 + 196 >> 2] = 0;
 HEAP32[i12 + 200 >> 2] = 0;
 __ZN17CollisionMeshDataC2Ev(i12 + 204 | 0);
 HEAP32[i12 + 224 >> 2] = 0;
 i11 = i12 + 228 | 0;
 HEAP32[i11 >> 2] = 0;
 i3 = i12 + 232 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i12 + 236 >> 2] = i3;
 i3 = i12 + 240 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i12 + 244 >> 2] = i3;
 HEAP32[i12 + 248 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 79) | 0;
 i1 = i2;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 58104 + 8;
 __ZN14VertexDataInfoC2Ev(i3 + 8 | 0);
 HEAP32[i3 + 112 >> 2] = 0;
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 120 >> 2] = 0;
 HEAP32[i3 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 128 >> 2] = 0;
 HEAP32[i3 + 132 >> 2] = 0;
 HEAP32[i3 + 136 >> 2] = 0;
 HEAP32[i3 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i3 + 144 >> 2] = 0;
 HEAP32[i3 + 156 >> 2] = 0;
 HEAP32[i3 + 160 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i7 = i13;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i3 + 148 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = i4;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i3 + 164 >> 2] = 0;
 HEAP32[i3 + 176 >> 2] = 0;
 HEAP32[i3 + 180 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i2 = i13;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i3 + 168 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i4;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i3 + 184 >> 2] = 0;
 HEAP32[i3 + 196 >> 2] = 0;
 HEAP32[i3 + 200 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i7 = i13;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i3 + 188 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = i4;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i3 + 204 >> 2] = 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 220 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i4);
 i4 = i13;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i3 + 208 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 + 32 | 0;
 HEAP32[i1 >> 2] = i3;
 i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63232 | 0, 16, gb + 425656 | 0, 80) | 0;
 __ZN23SharedMeshRenderingDataC2Ev(i2);
 HEAP32[i12 + 36 >> 2] = i2;
 HEAP32[i12 + 188 >> 2] = -1;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i2 = i13 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1155204 >> 2];
 i3 = i13 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
 i4 = i13 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
 i5 = i13 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 i6 = i13 + 24 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 i7 = i13 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i8 = i13 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 i9 = i1 + 132 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i10 | 0) == (HEAP32[i1 + 136 >> 2] | 0)) {
  __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1 + 128 | 0, i13);
  i13 = i12 + 40 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i12 + 41 | 0;
  HEAP8[i13 >> 0] = 1;
  i13 = i12 + 42 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i12 + 43 | 0;
  HEAP8[i13 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i14;
  return;
 } else {
  i15 = i13;
  i1 = HEAP32[i15 + 4 >> 2] | 0;
  i13 = i10;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i7 >> 2];
  i13 = i10 + 32 | 0;
  HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 52;
  i13 = i12 + 40 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i12 + 41 | 0;
  HEAP8[i13 >> 0] = 1;
  i13 = i12 + 42 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i12 + 43 | 0;
  HEAP8[i13 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i14;
  return;
 }
}

function __ZNK9ShaderLab22ShaderStencilStateDesc17ToGfxStencilStateEPK19ShaderPropertySheetS3_RK14GfxRasterStateR15GfxStencilState(i5, i9, i10, i6, i14) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 24 | 0;
 i11 = i15 + 16 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
 }
 HEAP8[i14 + 1 >> 0] = ~~f1;
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 + 8 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
 }
 HEAP8[i14 + 2 >> 0] = ~~f1;
 i3 = i5 + 48 | 0;
 i2 = i5 + 80 | 0;
 i4 = i5 + 16 | 0;
 if ((HEAP32[i5 + 28 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i5 + 24 >> 2]) == Math_fround(0.0)) if ((HEAP32[i5 + 36 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i5 + 32 >> 2]) == Math_fround(0.0)) if ((HEAP32[i5 + 44 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i5 + 40 >> 2]) == Math_fround(0.0)) if ((HEAP32[i5 + 20 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(8.0)) {
  i6 = i2;
  i4 = i3;
 } else i7 = 15; else i7 = 15; else i7 = 15; else i7 = 15; else i7 = 15; else i7 = 15; else i7 = 15; else i7 = 15;
 L17 : do if ((i7 | 0) == 15) switch (HEAP32[i6 >> 2] | 0) {
 case 1:
  {
   i6 = i4;
   i4 = i3;
   break L17;
  }
 case 0:
  {
   i6 = i4;
   break L17;
  }
 default:
  {
   i6 = i2;
   break L17;
  }
 } while (0);
 i5 = i4 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == -1) if (Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(0.0)) if ((HEAP32[i4 + 20 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i4 + 16 >> 2]) == Math_fround(0.0)) if ((HEAP32[i4 + 28 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i4 + 24 >> 2]) == Math_fround(0.0)) if ((HEAP32[i4 + 4 >> 2] | 0) == -1) {
  if (!(Math_fround(HEAPF32[i4 >> 2]) == Math_fround(8.0))) i7 = 26;
 } else i7 = 26; else i7 = 26; else i7 = 26; else i7 = 26; else i7 = 26; else i7 = 26; else i7 = 26;
 if ((i7 | 0) == 26) {
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i3 | 0) == -1) f1 = Math_fround(HEAPF32[i4 >> 2]); else {
   HEAP32[i11 >> 2] = -1;
   HEAP32[i11 + 4 >> 2] = 4;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
   f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i7 = ~~f1;
  HEAP8[i14 + 4 >> 0] = (i7 | 0) < 0 ? 0 : ((i7 | 0) > 8 ? 8 : i7) & 255;
  if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 + 8 >> 2]); else {
   HEAP32[i11 >> 2] = -1;
   HEAP32[i11 + 4 >> 2] = 4;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
   f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
  }
  i2 = ~~f1;
  HEAP8[i14 + 5 >> 0] = (i2 | 0) < 0 ? 0 : ((i2 | 0) > 7 ? 7 : i2) & 255;
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 + 16 >> 2]); else {
   HEAP32[i11 >> 2] = -1;
   HEAP32[i11 + 4 >> 2] = 4;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
   f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
  }
  i2 = ~~f1;
  HEAP8[i14 + 6 >> 0] = (i2 | 0) < 0 ? 0 : ((i2 | 0) > 7 ? 7 : i2) & 255;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 + 24 >> 2]); else {
   HEAP32[i11 >> 2] = -1;
   HEAP32[i11 + 4 >> 2] = 4;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
   f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
  }
  i7 = ~~f1;
  HEAP8[i14 + 7 >> 0] = (i7 | 0) < 0 ? 0 : ((i7 | 0) > 7 ? 7 : i7) & 255;
  HEAP8[i14 >> 0] = 1;
 }
 i4 = i6 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == -1) if (Math_fround(HEAPF32[i6 + 8 >> 2]) == Math_fround(0.0)) if ((HEAP32[i6 + 20 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i6 + 16 >> 2]) == Math_fround(0.0)) if ((HEAP32[i6 + 28 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i6 + 24 >> 2]) == Math_fround(0.0)) if ((HEAP32[i6 + 4 >> 2] | 0) == -1) if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(8.0)) {
  STACKTOP = i15;
  return;
 }
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i3 | 0) == -1) f1 = Math_fround(HEAPF32[i6 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i7 = ~~f1;
 HEAP8[i14 + 8 >> 0] = (i7 | 0) < 0 ? 0 : ((i7 | 0) > 8 ? 8 : i7) & 255;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i6 + 8 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
 }
 i2 = ~~f1;
 HEAP8[i14 + 9 >> 0] = (i2 | 0) < 0 ? 0 : ((i2 | 0) > 7 ? 7 : i2) & 255;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i6 + 16 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
 }
 i2 = ~~f1;
 HEAP8[i14 + 10 >> 0] = (i2 | 0) < 0 ? 0 : ((i2 | 0) > 7 ? 7 : i2) & 255;
 i2 = HEAP32[i6 + 28 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i6 + 24 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i9, i10, i8, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i13 >> 2] >> 2]);
 }
 i13 = ~~f1;
 HEAP8[i14 + 11 >> 0] = (i13 | 0) < 0 ? 0 : ((i13 | 0) > 7 ? 7 : i13) & 255;
 HEAP8[i14 >> 0] = 1;
 STACKTOP = i15;
 return;
}

function __Z13SetLocalEuler15TransformAccessRKN4math7_float3ENS0_13RotationOrderE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i11 = i1;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f12 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
 f16 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(.0174532924)) * Math_fround(.5)) * Math_fround(.159154937));
 f18 = Math_fround(+_roundf(+f12));
 f19 = Math_fround(+_roundf(+f16));
 f18 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f12 - f18))));
 f19 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - f19))));
 f21 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f14 - Math_fround(+_roundf(+f14))))));
 f22 = Math_fround(f18 * f18);
 f4 = Math_fround(f19 * f19);
 f20 = Math_fround(f21 * f21);
 f13 = Math_fround(f22 * f22);
 f15 = Math_fround(f4 * f4);
 f17 = Math_fround(f20 * f20);
 f22 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f13 * f13) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f22 * Math_fround(41.3416595))) + Math_fround(f13 * Math_fround(Math_fround(81.6018218) - Math_fround(f22 * Math_fround(76.5686187)))))));
 f4 = Math_fround(f19 * Math_fround(Math_fround(Math_fround(f15 * f15) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f15 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
 f20 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f20 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f20 * Math_fround(76.5686187)))))));
 f12 = Math_fround(f12 + Math_fround(-.25));
 f16 = Math_fround(f16 + Math_fround(-.25));
 f14 = Math_fround(f14 + Math_fround(-.25));
 f17 = Math_fround(+_roundf(+f12));
 f21 = Math_fround(+_roundf(+f16));
 f17 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f12 - f17))));
 f21 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f16 - f21))));
 f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f14 - Math_fround(+_roundf(+f14))))));
 f16 = Math_fround(f17 * f17);
 f12 = Math_fround(f21 * f21);
 f15 = Math_fround(f14 * f14);
 f19 = Math_fround(f16 * f16);
 f13 = Math_fround(f12 * f12);
 f18 = Math_fround(f15 * f15);
 f16 = Math_fround(f17 * Math_fround(Math_fround(Math_fround(f19 * f19) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f16 * Math_fround(41.3416595))) + Math_fround(f19 * Math_fround(Math_fround(81.6018218) - Math_fround(f16 * Math_fround(76.5686187)))))));
 f12 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(f13 * f13) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f12 * Math_fround(41.3416595))) + Math_fround(f13 * Math_fround(Math_fround(81.6018218) - Math_fround(f12 * Math_fround(76.5686187)))))));
 f15 = Math_fround(f14 * Math_fround(Math_fround(Math_fround(f18 * f18) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f15 * Math_fround(41.3416595))) + Math_fround(f18 * Math_fround(Math_fround(81.6018218) - Math_fround(f15 * Math_fround(76.5686187)))))));
 f18 = Math_fround(f20 * f16);
 f16 = Math_fround(f16 * f15);
 f15 = Math_fround(f22 * f15);
 f20 = Math_fround(f22 * f20);
 f22 = Math_fround(f4 * f18);
 f14 = Math_fround(f4 * f16);
 f13 = Math_fround(f4 * f15);
 f4 = Math_fround(f4 * f20);
 i1 = i3 << 1;
 f22 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) >> 2]) * f22);
 f14 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 4 >> 2]) * f14);
 f13 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 8 >> 2]) * f13);
 f4 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 12 >> 2]) * f4);
 i1 = i1 | 1;
 f21 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) >> 2]) * f12);
 f19 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 4 >> 2]) * f12);
 f17 = Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 8 >> 2]) * f12);
 f15 = Math_fround(f22 + Math_fround(f21 * f15));
 f14 = Math_fround(Math_fround(f20 * f19) + f14);
 f13 = Math_fround(Math_fround(f18 * f17) + f13);
 f16 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(HEAPF32[gb + 1159624 + (i1 << 4) + 12 >> 2]) * f12) * f16));
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 f12 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f16 * f16) + Math_fround(f13 * f13)));
 f4 = Math_fround(Math_sqrt(Math_fround(f12)));
 f15 = Math_fround(f15 / f4);
 f14 = Math_fround(f14 / f4);
 f13 = Math_fround(f13 / f4);
 f4 = Math_fround(f16 / f4);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f12 > Math_fround(1.0e-30);
 i2 = i9 ? i2 : 0;
 i3 = i9 ? i3 : 0;
 i5 = i9 ? i5 : 0;
 i7 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i24 = i1 + (i11 * 40 | 0) + 12 | 0;
 f22 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f22 != Math_fround(HEAPF32[i24 >> 2]);
 f22 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i23 = i1 + (i11 * 40 | 0) + 16 | 0;
 i25 = f22 != Math_fround(HEAPF32[i23 >> 2]);
 f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i1 + (i11 * 40 | 0) + 20 | 0;
 i26 = f22 != Math_fround(HEAPF32[i6 >> 2]);
 f22 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i1 + (i11 * 40 | 0) + 24 | 0;
 i9 = f22 != Math_fround(HEAPF32[i8 >> 2]) | (i26 | (i25 | i9));
 HEAP32[i24 >> 2] = i2;
 HEAP32[i23 >> 2] = i3;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 if (!i9) {
  i26 = 0;
  return i26 | 0;
 }
 i5 = HEAP32[i10 + 44 >> 2] | HEAP32[i10 + 40 >> 2];
 i6 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 if (!i6) {
  i26 = 1;
  return i26 | 0;
 }
 i7 = HEAP32[i10 + 60 >> 2] | 0;
 i8 = HEAP32[i10 + 56 >> 2] | 0;
 i9 = i10 + 36 | 0;
 i3 = HEAP32[i10 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i11;
 while (1) {
  i26 = HEAP32[i7 + (i1 << 2) >> 2] & i5;
  i25 = i8 + (i1 << 2) | 0;
  HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i26;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i26;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 return i1 | 0;
}

function _memmem(i2, i3, i14, i15) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 1024 | 0;
 i17 = i18;
 L1 : do if (!i15) i1 = i2; else if (i3 >>> 0 < i15 >>> 0) i1 = 0; else {
  i4 = HEAP8[i14 >> 0] | 0;
  i5 = i4 & 255;
  i1 = _memchr(i2, i5, i3) | 0;
  if (!((i15 | 0) == 1 | (i1 | 0) == 0)) {
   i13 = i2 - i1 + i3 | 0;
   switch (i15 | 0) {
   case 2:
    {
     i4 = HEAPU8[i14 + 1 >> 0] | i5 << 8;
     i2 = i1 + 1 | 0;
     i3 = i13 + -1 | 0;
     if (!i3) {
      i1 = 0;
      break L1;
     }
     i1 = HEAPU8[i1 >> 0] << 8 | HEAPU8[i2 >> 0];
     while (1) {
      i1 = i1 & 65535;
      if ((i1 | 0) == (i4 | 0)) break;
      i2 = i2 + 1 | 0;
      i3 = i3 + -1 | 0;
      if (!i3) {
       i1 = 0;
       break L1;
      } else i1 = HEAPU8[i2 >> 0] | i1 << 8;
     }
     i1 = i2 + -1 | 0;
     break L1;
    }
   case 3:
    {
     i5 = HEAPU8[i14 + 1 >> 0] << 16 | i5 << 24 | HEAPU8[i14 + 2 >> 0] << 8;
     i3 = i1 + 2 | 0;
     i2 = i13 + -2 | 0;
     if (!i2) {
      i1 = 0;
      break L1;
     }
     i4 = i3;
     i1 = HEAPU8[i1 >> 0] << 24 | HEAPU8[i1 + 1 >> 0] << 16 | HEAPU8[i3 >> 0] << 8;
     while (1) {
      if ((i1 | 0) == (i5 | 0)) break;
      i2 = i2 + -1 | 0;
      i3 = i4 + 1 | 0;
      if (!i2) {
       i1 = 0;
       break L1;
      } else {
       i4 = i3;
       i1 = (HEAPU8[i3 >> 0] | i1) << 8;
      }
     }
     i1 = i4 + -2 | 0;
     break L1;
    }
   case 4:
    {
     i6 = HEAPU8[i14 + 1 >> 0] << 16 | i5 << 24 | HEAPU8[i14 + 2 >> 0] << 8 | HEAPU8[i14 + 3 >> 0];
     i4 = i1 + 3 | 0;
     i2 = i13 + -3 | 0;
     if (!i2) {
      i1 = 0;
      break L1;
     }
     i5 = i4;
     i3 = i2;
     i1 = HEAPU8[i1 >> 0] << 24 | HEAPU8[i1 + 1 >> 0] << 16 | HEAPU8[i1 + 2 >> 0] << 8 | HEAPU8[i4 >> 0];
     while (1) {
      if ((i1 | 0) == (i6 | 0)) break;
      i3 = i3 + -1 | 0;
      i2 = i5 + 1 | 0;
      if (!i3) {
       i1 = 0;
       break L1;
      } else {
       i5 = i2;
       i1 = HEAPU8[i2 >> 0] | i1 << 8;
      }
     }
     i1 = i5 + -3 | 0;
     break L1;
    }
   default:
    {
     HEAP32[i16 >> 2] = 0;
     HEAP32[i16 + 4 >> 2] = 0;
     HEAP32[i16 + 8 >> 2] = 0;
     HEAP32[i16 + 12 >> 2] = 0;
     HEAP32[i16 + 16 >> 2] = 0;
     HEAP32[i16 + 20 >> 2] = 0;
     HEAP32[i16 + 24 >> 2] = 0;
     HEAP32[i16 + 28 >> 2] = 0;
     i12 = i16 + (((i4 & 255) >>> 5 & 255) << 2) | 0;
     HEAP32[i12 >> 2] = 1 << (i4 & 31) | HEAP32[i12 >> 2];
     HEAP32[i17 + ((i4 & 255) << 2) >> 2] = 1;
     if ((i15 | 0) != 1) {
      i2 = 1;
      do {
       i12 = HEAP8[i14 + i2 >> 0] | 0;
       i11 = i16 + (((i12 & 255) >>> 5 & 255) << 2) | 0;
       HEAP32[i11 >> 2] = 1 << (i12 & 31) | HEAP32[i11 >> 2];
       i2 = i2 + 1 | 0;
       HEAP32[i17 + ((i12 & 255) << 2) >> 2] = i2;
      } while ((i2 | 0) != (i15 | 0));
     }
     i9 = i1 + i13 | 0;
     L11 : do if (i15 >>> 0 > 1) {
      i3 = 0;
      i8 = -1;
      i4 = 1;
      L12 : while (1) {
       i5 = 1;
       i2 = i3;
       while (1) {
        i3 = i4;
        L16 : while (1) {
         i7 = 1;
         while (1) {
          i4 = HEAP8[i14 + (i7 + i8) >> 0] | 0;
          i6 = HEAP8[i14 + i3 >> 0] | 0;
          if (i4 << 24 >> 24 != i6 << 24 >> 24) break L16;
          if ((i7 | 0) == (i5 | 0)) break;
          i7 = i7 + 1 | 0;
          i3 = i7 + i2 | 0;
          if (i3 >>> 0 >= i15 >>> 0) {
           i10 = i5;
           i2 = i8;
           break L12;
          }
         }
         i2 = i2 + i5 | 0;
         i3 = i2 + 1 | 0;
         if (i3 >>> 0 >= i15 >>> 0) {
          i10 = i5;
          i2 = i8;
          break L12;
         }
        }
        i5 = i3 - i8 | 0;
        if ((i4 & 255) <= (i6 & 255)) break;
        i4 = i3 + 1 | 0;
        if (i4 >>> 0 >= i15 >>> 0) {
         i10 = i5;
         i2 = i8;
         break L12;
        } else i2 = i3;
       }
       i4 = i2 + 2 | 0;
       if (i4 >>> 0 >= i15 >>> 0) {
        i10 = 1;
        break;
       } else {
        i3 = i2 + 1 | 0;
        i8 = i2;
       }
      }
      i5 = 0;
      i11 = -1;
      i6 = 1;
      while (1) {
       i4 = 1;
       i3 = i5;
       while (1) {
        i5 = i6;
        L31 : while (1) {
         i8 = 1;
         while (1) {
          i6 = HEAP8[i14 + (i8 + i11) >> 0] | 0;
          i7 = HEAP8[i14 + i5 >> 0] | 0;
          if (i6 << 24 >> 24 != i7 << 24 >> 24) break L31;
          if ((i8 | 0) == (i4 | 0)) break;
          i8 = i8 + 1 | 0;
          i5 = i8 + i3 | 0;
          if (i5 >>> 0 >= i15 >>> 0) {
           i5 = i10;
           i3 = i11;
           break L11;
          }
         }
         i3 = i3 + i4 | 0;
         i5 = i3 + 1 | 0;
         if (i5 >>> 0 >= i15 >>> 0) {
          i5 = i10;
          i3 = i11;
          break L11;
         }
        }
        i4 = i5 - i11 | 0;
        if ((i6 & 255) >= (i7 & 255)) break;
        i6 = i5 + 1 | 0;
        if (i6 >>> 0 >= i15 >>> 0) {
         i5 = i10;
         i3 = i11;
         break L11;
        } else i3 = i5;
       }
       i6 = i3 + 2 | 0;
       if (i6 >>> 0 >= i15 >>> 0) {
        i5 = i10;
        i4 = 1;
        break;
       } else {
        i5 = i3 + 1 | 0;
        i11 = i3;
       }
      }
     } else {
      i5 = 1;
      i2 = -1;
      i4 = 1;
      i3 = -1;
     } while (0);
     i11 = (i3 + 1 | 0) >>> 0 > (i2 + 1 | 0) >>> 0;
     i4 = i11 ? i4 : i5;
     i11 = i11 ? i3 : i2;
     i12 = i11 + 1 | 0;
     if (!(_memcmp(i14, i14 + i4 | 0, i12) | 0)) i10 = i15 - i4 | 0; else {
      i4 = i15 - i11 + -1 | 0;
      i10 = 0;
      i4 = (i11 >>> 0 > i4 >>> 0 ? i11 : i4) + 1 | 0;
     }
     L46 : do if (i13 >>> 0 < i15 >>> 0) i1 = 0; else {
      i6 = i15 + -1 | 0;
      i7 = (i10 | 0) != 0;
      i8 = i15 - i4 | 0;
      i5 = 0;
      while (1) {
       i2 = HEAP8[i1 + i6 >> 0] | 0;
       L50 : do if (!(1 << (i2 & 31) & HEAP32[i16 + (((i2 & 255) >>> 5 & 255) << 2) >> 2])) {
        i3 = 0;
        i1 = i1 + i15 | 0;
       } else {
        i2 = i15 - (HEAP32[i17 + ((i2 & 255) << 2) >> 2] | 0) | 0;
        if (i2 | 0) {
         i3 = 0;
         i1 = i1 + (i7 & (i5 | 0) != 0 & i2 >>> 0 < i4 >>> 0 ? i8 : i2) | 0;
         break;
        }
        i2 = i12 >>> 0 > i5 >>> 0 ? i12 : i5;
        L56 : do if (i2 >>> 0 < i15 >>> 0) {
         while (1) {
          if ((HEAP8[i14 + i2 >> 0] | 0) != (HEAP8[i1 + i2 >> 0] | 0)) break;
          i2 = i2 + 1 | 0;
          if (i2 >>> 0 >= i15 >>> 0) {
           i2 = i12;
           break L56;
          }
         }
         i3 = 0;
         i1 = i1 + (i2 - i11) | 0;
         break L50;
        } else i2 = i12; while (0);
        do {
         if (i2 >>> 0 <= i5 >>> 0) break L46;
         i2 = i2 + -1 | 0;
        } while ((HEAP8[i14 + i2 >> 0] | 0) == (HEAP8[i1 + i2 >> 0] | 0));
        i3 = i10;
        i1 = i1 + i4 | 0;
       } while (0);
       if ((i9 - i1 | 0) >>> 0 < i15 >>> 0) {
        i1 = 0;
        break;
       } else i5 = i3;
      }
     } while (0);
     break L1;
    }
   }
  }
 } while (0);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZNSt3__29__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i13, i14, i15, i16, i17, i18, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i20;
 i19 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474556 | 0) | 0;
 i12 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474572 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i21 | 0, i12 | 0);
 HEAP32[i18 >> 2] = i16;
 i1 = HEAP8[i13 >> 0] | 0;
 L1 : do switch (i1 << 24 >> 24) {
 case 43:
 case 45:
  {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 28 >> 2] | 0, i19 | 0, i1 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L1;
   } else {
    i4 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i1;
    i4 = i13 + 1 | 0;
    i10 = 5;
    break L1;
   }
  }
 default:
  {
   i4 = i13;
   i10 = 5;
  }
 } while (0);
 L6 : do if ((i10 | 0) == 5) {
  i11 = i15;
  L8 : do if ((i11 - i4 | 0) > 1) if ((HEAP8[i4 >> 0] | 0) == 48) {
   i2 = i4 + 1 | 0;
   switch (HEAP8[i2 >> 0] | 0) {
   case 88:
   case 120:
    break;
   default:
    {
     i1 = i4;
     i10 = 20;
     break L8;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 28 >> 2] | 0, i19 | 0, 48) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (!(i9 & 1)) {
    i9 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = i9 + 1;
    HEAP8[i9 >> 0] = i1;
    i4 = i4 + 2 | 0;
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 28 >> 2] | 0, i19 | 0, HEAP8[i2 >> 0] | 0) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (!(i9 & 1)) {
     i10 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = i10 + 1;
     HEAP8[i10 >> 0] = i1;
     i1 = i4;
     while (1) {
      if (i1 >>> 0 >= i15 >>> 0) {
       i10 = 25;
       break L8;
      }
      i2 = HEAP8[i1 >> 0] | 0;
      __THREW__ = 0;
      i3 = invoke_i(fb + 314 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) break;
      __THREW__ = 0;
      i2 = invoke_iii(fb + 1147 | 0, i2 << 24 >> 24 | 0, i3 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) break;
      if (!i2) {
       i10 = 25;
       break L8;
      }
      i1 = i1 + 1 | 0;
     }
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L6;
    }
   }
  } else {
   i1 = i4;
   i10 = 20;
  } else {
   i1 = i4;
   i10 = 20;
  } while (0);
  L21 : do if ((i10 | 0) == 20) {
   while (1) {
    if (i1 >>> 0 >= i15 >>> 0) {
     i10 = 25;
     break L21;
    }
    i2 = HEAP8[i1 >> 0] | 0;
    __THREW__ = 0;
    i3 = invoke_i(fb + 314 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) break;
    __THREW__ = 0;
    i2 = invoke_iii(fb + 1148 | 0, i2 << 24 >> 24 | 0, i3 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) break;
    if (!i2) {
     i10 = 25;
     break L21;
    }
    i1 = i1 + 1 | 0;
    i10 = 20;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break L6;
  } while (0);
  L29 : do if ((i10 | 0) == 25) {
   i8 = i21 + 11 | 0;
   i7 = HEAP8[i8 >> 0] | 0;
   i9 = i21 + 4 | 0;
   L31 : do if (!((i7 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i7 & 255) | 0)) {
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 32 >> 2] | 0, i19 | 0, i4 | 0, i1 | 0, HEAP32[i18 >> 2] | 0) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) break L29;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + (i1 - i4);
    i3 = i19;
   } else {
    L35 : do if ((i4 | 0) != (i1 | 0)) {
     i2 = i1;
     i3 = i4;
     while (1) {
      i2 = i2 + -1 | 0;
      if (i3 >>> 0 >= i2 >>> 0) break L35;
      i7 = HEAP8[i3 >> 0] | 0;
      HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP8[i2 >> 0] = i7;
      i3 = i3 + 1 | 0;
     }
    } while (0);
    __THREW__ = 0;
    i7 = invoke_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) break L29;
    i6 = i4;
    i2 = 0;
    i3 = 0;
    while (1) {
     if (i6 >>> 0 >= i1 >>> 0) break;
     i5 = HEAP8[((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21) + i2 >> 0] | 0;
     if (i5 << 24 >> 24 > 0 & (i3 | 0) == (i5 << 24 >> 24 | 0)) {
      i3 = HEAP32[i18 >> 2] | 0;
      HEAP32[i18 >> 2] = i3 + 1;
      HEAP8[i3 >> 0] = i7;
      i3 = HEAP8[i8 >> 0] | 0;
      i2 = (i2 >>> 0 < ((i3 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i3 & 255) + -1 | 0) >>> 0 & 1) + i2 | 0;
      i3 = 0;
     }
     __THREW__ = 0;
     i5 = invoke_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 28 >> 2] | 0, i19 | 0, HEAP8[i6 >> 0] | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i10 = 40;
      break;
     }
     i22 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = i22 + 1;
     HEAP8[i22 >> 0] = i5;
     i6 = i6 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
    if ((i10 | 0) == 40) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L6;
    }
    i3 = i16 + (i4 - i13) | 0;
    i2 = HEAP32[i18 >> 2] | 0;
    if ((i3 | 0) == (i2 | 0)) i3 = i19; else while (1) {
     i2 = i2 + -1 | 0;
     if (i3 >>> 0 >= i2 >>> 0) {
      i3 = i19;
      break L31;
     }
     i22 = HEAP8[i3 >> 0] | 0;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i2 >> 0] = i22;
     i3 = i3 + 1 | 0;
    }
   } while (0);
   while (1) {
    if (i1 >>> 0 >= i15 >>> 0) break;
    i2 = HEAP8[i1 >> 0] | 0;
    if (i2 << 24 >> 24 == 46) {
     i10 = 45;
     break;
    }
    __THREW__ = 0;
    i2 = invoke_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i19 | 0, i2 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) {
     i10 = 15;
     break;
    }
    i22 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = i22 + 1;
    HEAP8[i22 >> 0] = i2;
    i1 = i1 + 1 | 0;
   }
   if ((i10 | 0) == 15) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L6;
   }
   if ((i10 | 0) == 45) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0) | 0;
    i22 = __THREW__;
    __THREW__ = 0;
    if (i22 & 1) break;
    i22 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = i22 + 1;
    HEAP8[i22 >> 0] = i2;
    i1 = i1 + 1 | 0;
   }
   __THREW__ = 0;
   invoke_iiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 32 >> 2] | 0, i19 | 0, i1 | 0, i15 | 0, HEAP32[i18 >> 2] | 0) | 0;
   i22 = __THREW__;
   __THREW__ = 0;
   if (!(i22 & 1)) {
    i22 = (HEAP32[i18 >> 2] | 0) + (i11 - i1) | 0;
    HEAP32[i18 >> 2] = i22;
    HEAP32[i17 >> 2] = (i14 | 0) == (i15 | 0) ? i22 : i16 + (i14 - i13) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    STACKTOP = i20;
    return;
   }
  } while (0);
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 ___resumeException(i1 | 0);
}

function __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 i3 = i7 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 28 | 0, i8);
 i3 = i7 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 36 | 0, i8);
 i3 = i7 + 48 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 44 | 0, i8);
 i3 = i7 + 56 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 52 | 0, i8);
 i3 = i7 + 72 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 68 | 0, i8);
 i3 = i7 + 64 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 60 | 0, i8);
 i3 = i7 + 80 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 76 | 0, i8);
 i3 = i7 + 88 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 84 | 0, i8);
 i3 = i7 + 92 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 96 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 108 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 112 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 124 | 0, i8);
 i4 = i7 + 128 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i7 + 132 | 0;
 if ((i2 + 1 | 0) >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i4 = i7 + 136 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i7 + 140 | 0;
 if ((i2 + 1 | 0) >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i4 = i7 + 144 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i7 + 148 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 }
}

function __ZN7mecanim18ValueArrayBlendEndERNS_10ValueArrayERKNS_14ValueArrayMaskERKNS_16ValueArrayWeightEPKS0_(i14, i15, i12, i13) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 if (!i13) i5 = HEAP32[i14 + 8 >> 2] | 0; else {
  i9 = HEAP32[i14 >> 2] | 0;
  if (i9 | 0) {
   i8 = i15 + 4 | 0;
   i10 = i12 + 4 | 0;
   i2 = i10;
   i3 = i14 + 4 | 0;
   i4 = i3;
   i5 = i13 + 4 | 0;
   i7 = i5;
   i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
   i1 = 0;
   do {
    if (HEAP8[i8 + i1 >> 0] | 0) {
     f6 = Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + i2 + (i1 << 2) >> 2]);
     if (f6 < Math_fround(1.0)) {
      f20 = Math_fround(Math_fround(1.0) - f6);
      i11 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
      i18 = i11 + (i1 * 12 | 0) | 0;
      f21 = Math_fround(HEAPF32[i18 >> 2]);
      i16 = i11 + (i1 * 12 | 0) + 4 | 0;
      f23 = Math_fround(HEAPF32[i16 >> 2]);
      i11 = i11 + (i1 * 12 | 0) + 8 | 0;
      f6 = Math_fround(HEAPF32[i11 >> 2]);
      i22 = (HEAP32[i5 >> 2] | 0) + i7 | 0;
      f19 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) >> 2]);
      f17 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 4 >> 2]);
      f17 = Math_fround(f23 + Math_fround(f20 * f17));
      f6 = Math_fround(f6 + Math_fround(f20 * Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 8 >> 2])));
      HEAPF32[i18 >> 2] = Math_fround(f21 + Math_fround(f20 * f19));
      HEAPF32[i16 >> 2] = f17;
      HEAPF32[i11 >> 2] = f6;
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i9 | 0));
  }
  i5 = HEAP32[i14 + 8 >> 2] | 0;
  if (i5 | 0) {
   i10 = i15 + 12 | 0;
   i2 = i12 + 12 | 0;
   i3 = i2;
   i4 = i14 + 12 | 0;
   i7 = i4;
   i8 = i13 + 12 | 0;
   i9 = i8;
   i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
   i1 = 0;
   do {
    if (HEAP8[i10 + i1 >> 0] | 0) {
     f6 = Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2]);
     if (f6 < Math_fround(1.0)) {
      f31 = Math_fround(Math_fround(1.0) - f6);
      i22 = (HEAP32[i4 >> 2] | 0) + i7 | 0;
      i11 = i22 + (i1 << 4) | 0;
      f19 = Math_fround(HEAPF32[i11 >> 2]);
      i16 = i22 + (i1 << 4) + 4 | 0;
      f20 = Math_fround(HEAPF32[i16 >> 2]);
      i18 = i22 + (i1 << 4) + 8 | 0;
      f21 = Math_fround(HEAPF32[i18 >> 2]);
      i22 = i22 + (i1 << 4) + 12 | 0;
      f23 = Math_fround(HEAPF32[i22 >> 2]);
      i28 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
      f30 = Math_fround(HEAPF32[i28 + (i1 << 4) >> 2]);
      f29 = Math_fround(HEAPF32[i28 + (i1 << 4) + 4 >> 2]);
      f6 = Math_fround(HEAPF32[i28 + (i1 << 4) + 8 >> 2]);
      f17 = Math_fround(HEAPF32[i28 + (i1 << 4) + 12 >> 2]);
      f34 = Math_fround(f31 * f30);
      f33 = Math_fround(f31 * f29);
      f32 = Math_fround(f31 * f6);
      f31 = Math_fround(f31 * f17);
      i28 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
      i27 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
      i26 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
      i24 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
      f17 = Math_fround(Math_fround(Math_fround(f19 * f30) + Math_fround(f20 * f29)) + Math_fround(Math_fround(f21 * f6) + Math_fround(f23 * f17)));
      i25 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648;
      f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i25 ^ i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i25 ^ i27, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i25 ^ i26, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      f23 = Math_fround(f23 + (HEAP32[tempDoublePtr >> 2] = i25 ^ i24, Math_fround(HEAPF32[tempDoublePtr >> 2])));
      HEAPF32[i11 >> 2] = f19;
      HEAPF32[i16 >> 2] = f20;
      HEAPF32[i18 >> 2] = f21;
      HEAPF32[i22 >> 2] = f23;
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
  i2 = HEAP32[i14 + 16 >> 2] | 0;
  if (i2 | 0) {
   i11 = i15 + 20 | 0;
   i3 = i12 + 20 | 0;
   i4 = i3;
   i7 = i14 + 20 | 0;
   i8 = i7;
   i9 = i13 + 20 | 0;
   i10 = i9;
   i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
   i1 = 0;
   do {
    if (HEAP8[i11 + i1 >> 0] | 0) {
     f6 = Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + i4 + (i1 << 2) >> 2]);
     if (f6 < Math_fround(1.0)) {
      f31 = Math_fround(Math_fround(1.0) - f6);
      i28 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
      i26 = i28 + (i1 * 12 | 0) | 0;
      f30 = Math_fround(HEAPF32[i26 >> 2]);
      i27 = i28 + (i1 * 12 | 0) + 4 | 0;
      f29 = Math_fround(HEAPF32[i27 >> 2]);
      i28 = i28 + (i1 * 12 | 0) + 8 | 0;
      f34 = Math_fround(HEAPF32[i28 >> 2]);
      i25 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
      f32 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) >> 2]);
      f33 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 4 >> 2]);
      f33 = Math_fround(f29 + Math_fround(f31 * f33));
      f34 = Math_fround(f34 + Math_fround(f31 * Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 8 >> 2])));
      HEAPF32[i26 >> 2] = Math_fround(f30 + Math_fround(f31 * f32));
      HEAPF32[i27 >> 2] = f33;
      HEAPF32[i28 >> 2] = f34;
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i8 = HEAP32[i14 + 24 >> 2] | 0;
  if (i8) {
   i9 = i15 + 28 | 0;
   i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
   i4 = i12 + 36 | 0;
   i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
   i7 = i14 + 28 | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
   i2 = i13 + 28 | 0;
   i3 = i2;
   i1 = 0;
   do {
    if (HEAP8[i9 + i1 >> 0] | 0) {
     f6 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
     if (f6 < Math_fround(1.0)) {
      f34 = Math_fround(Math_fround(1.0) - f6);
      i28 = i7 + (i1 << 2) | 0;
      f33 = Math_fround(HEAPF32[i28 >> 2]);
      HEAPF32[i28 >> 2] = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2])));
     }
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  }
 }
 if (!i5) return;
 i4 = i15 + 12 | 0;
 i2 = i14 + 12 | 0;
 i3 = i2;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i1 = 0;
 do {
  if (HEAP8[i4 + i1 >> 0] | 0) {
   i28 = (HEAP32[i2 >> 2] | 0) + i3 | 0;
   i25 = i28 + (i1 << 4) | 0;
   f30 = Math_fround(HEAPF32[i25 >> 2]);
   i26 = i28 + (i1 << 4) + 4 | 0;
   f32 = Math_fround(HEAPF32[i26 >> 2]);
   i27 = i28 + (i1 << 4) + 8 | 0;
   f33 = Math_fround(HEAPF32[i27 >> 2]);
   i28 = i28 + (i1 << 4) + 12 | 0;
   f34 = Math_fround(HEAPF32[i28 >> 2]);
   f31 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f30 * f30) + Math_fround(f32 * f32)) + Math_fround(Math_fround(f33 * f33) + Math_fround(f34 * f34))))));
   f32 = Math_fround(f32 * f31);
   f33 = Math_fround(f33 * f31);
   f34 = Math_fround(f34 * f31);
   HEAPF32[i25 >> 2] = Math_fround(f30 * f31);
   HEAPF32[i26 >> 2] = f32;
   HEAPF32[i27 >> 2] = f33;
   HEAPF32[i28 >> 2] = f34;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i19, i21, i18, i22, i23, f20) {
 i19 = i19 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 f20 = Math_fround(f20);
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i24;
 i5 = i23 + 4 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f2 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(HEAPF32[i23 >> 2]);
 f2 = Math_fround(f2 * f13);
 i16 = i22 + 4 | 0;
 f2 = Math_fround(f2 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
 i17 = i22 + 8 | 0;
 f1 = Math_fround(HEAPF32[i17 >> 2]);
 i7 = i23 + 8 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(Math_abs(Math_fround(f2 + Math_fround(f1 * f8))));
 HEAPF32[i27 >> 2] = f1;
 i9 = i22 + 12 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f13);
 i10 = i22 + 16 | 0;
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f6));
 i11 = i22 + 20 | 0;
 f2 = Math_fround(Math_abs(Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f8))));
 HEAPF32[i27 + 4 >> 2] = f2;
 i12 = i22 + 24 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f13);
 i14 = i22 + 28 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f6));
 i15 = i22 + 32 | 0;
 f4 = Math_fround(Math_abs(Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f8))));
 HEAPF32[i27 + 8 >> 2] = f4;
 i25 = f2 > f1;
 i26 = f4 > (i25 ? f2 : f1);
 i25 = i26 ? 0 : i25 & 1 ^ 1;
 i26 = i26 ? 1 : 2;
 f1 = Math_fround(HEAPF32[i27 + (i26 << 2) >> 2]);
 i27 = f1 < Math_fround(HEAPF32[i27 + (i25 << 2) >> 2]);
 i25 = i27 ? i26 : i25;
 f1 = Math_fround(HEAPF32[i22 + (i25 * 12 | 0) >> 2]);
 f2 = Math_fround(HEAPF32[i22 + (i25 * 12 | 0) + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i22 + (i25 * 12 | 0) + 8 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f1 * f13) + Math_fround(f2 * f6)) + Math_fround(f4 * f8));
 f1 = Math_fround(f1 - Math_fround(f13 * f3));
 f2 = Math_fround(f2 - Math_fround(f3 * f6));
 f3 = Math_fround(f4 - Math_fround(f3 * f8));
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(f3 * f3))));
 if (f4 > Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(1.0) / f4);
  f3 = Math_fround(f3 * f4);
  f2 = Math_fround(f2 * f4);
  f1 = Math_fround(f1 * f4);
 }
 f33 = Math_fround(Math_fround(f3 * f6) - Math_fround(f2 * f8));
 f31 = Math_fround(Math_fround(f1 * f8) - Math_fround(f3 * f13));
 f29 = Math_fround(Math_fround(f2 * f13) - Math_fround(f1 * f6));
 HEAPF32[i19 >> 2] = f13;
 HEAPF32[i19 + 4 >> 2] = f6;
 HEAPF32[i19 + 8 >> 2] = f8;
 HEAPF32[i19 + 12 >> 2] = f1;
 HEAPF32[i19 + 16 >> 2] = f2;
 HEAPF32[i19 + 20 >> 2] = f3;
 HEAPF32[i19 + 24 >> 2] = f33;
 HEAPF32[i19 + 28 >> 2] = f31;
 HEAPF32[i19 + 32 >> 2] = f29;
 f32 = Math_fround(HEAPF32[i23 >> 2]);
 f28 = Math_fround(f1 * f32);
 f30 = Math_fround(HEAPF32[i5 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f2 * f30));
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 f28 = Math_fround(Math_fround(f28 + Math_fround(f3 * f4)) * f20);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f31 * f30)) + Math_fround(f29 * f4)) * f20);
 i25 = i21 + 4 | 0;
 i26 = i21 + 8 | 0;
 i27 = i19 + 48 | 0;
 f29 = Math_fround(f20 * Math_fround(.5));
 f30 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f13);
 f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f6));
 f30 = Math_fround(Math_abs(Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f8))));
 f30 = Math_fround(f29 + Math_fround(f30 * Math_fround(HEAPF32[i21 >> 2])));
 f29 = Math_fround(f13 * Math_fround(HEAPF32[i9 >> 2]));
 f29 = Math_fround(f29 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
 f29 = Math_fround(Math_abs(Math_fround(f29 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])))));
 f29 = Math_fround(f30 + Math_fround(f29 * Math_fround(HEAPF32[i25 >> 2])));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i12 >> 2]));
 f6 = Math_fround(f13 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 f6 = Math_fround(Math_abs(Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])))));
 HEAPF32[i27 >> 2] = Math_fround(f29 + Math_fround(f6 * Math_fround(HEAPF32[i26 >> 2])));
 f6 = Math_fround(f28 * Math_fround(.5));
 f13 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f1);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f2));
 f13 = Math_fround(Math_abs(Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f3))));
 f13 = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i21 >> 2])));
 f6 = Math_fround(f1 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f2 * Math_fround(HEAPF32[i10 >> 2])));
 f6 = Math_fround(Math_abs(Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i11 >> 2])))));
 f6 = Math_fround(f13 + Math_fround(f6 * Math_fround(HEAPF32[i25 >> 2])));
 f13 = Math_fround(f1 * Math_fround(HEAPF32[i12 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f2 * Math_fround(HEAPF32[i14 >> 2])));
 f13 = Math_fround(Math_abs(Math_fround(f13 + Math_fround(f3 * Math_fround(HEAPF32[i15 >> 2])))));
 HEAPF32[i27 + 4 >> 2] = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i26 >> 2])));
 f13 = Math_fround(f4 * Math_fround(.5));
 f3 = Math_fround(HEAPF32[i22 >> 2]);
 f4 = Math_fround(HEAPF32[i19 + 24 >> 2]);
 f3 = Math_fround(f3 * f4);
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f6 = Math_fround(HEAPF32[i19 + 28 >> 2]);
 f2 = Math_fround(f3 + Math_fround(f2 * f6));
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 f8 = Math_fround(HEAPF32[i19 + 32 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f2 + Math_fround(f3 * f8))));
 f3 = Math_fround(f13 + Math_fround(f3 * Math_fround(HEAPF32[i21 >> 2])));
 f13 = Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
 f13 = Math_fround(Math_abs(Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])))));
 f13 = Math_fround(f3 + Math_fround(f13 * Math_fround(HEAPF32[i25 >> 2])));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i12 >> 2]));
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 f8 = Math_fround(Math_abs(Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])))));
 HEAPF32[i27 + 8 >> 2] = Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i26 >> 2])));
 f8 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * f20);
 f13 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f20);
 f8 = Math_fround(f8 * Math_fround(.5));
 f13 = Math_fround(f13 * Math_fround(.5));
 f20 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f20) * Math_fround(.5));
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i18 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i18 + 4 >> 2]));
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i18 + 8 >> 2]));
 HEAPF32[i19 + 36 >> 2] = f8;
 HEAPF32[i19 + 40 >> 2] = f13;
 HEAPF32[i19 + 44 >> 2] = f20;
 STACKTOP = i24;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj(i26, i1, i9, i24, i25) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, d8 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0, i28 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 144 | 0;
 i22 = i27 + 136 | 0;
 i21 = i27 + 128 | 0;
 i20 = i27;
 i6 = i27 + 152 | 0;
 i18 = i27 + 192 | 0;
 i19 = i27 + 160 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i26 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i26 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i26 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i20 >> 2] = i5;
 HEAP8[i20 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i20;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i20) | 0;
 HEAP32[i6 >> 2] = 605;
 i17 = HEAP32[i26 + 20 >> 2] | 0;
 i17 = (i17 | 0) == 0 ? i6 : i17;
 if (i24 | 0) {
  i12 = i20 + 4 | 0;
  i13 = (i25 | 0) == 0;
  i14 = i26 + 4 | 0;
  i15 = i20 + 4 | 0;
  i16 = i26 + 8 | 0;
  i9 = i9 + 12 | 0;
  i10 = i26 + 12 | 0;
  i11 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i21 >> 2] = i11;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832784 | 0, i21) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i14 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i26 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i20 >> 2] = i18;
   HEAP8[i12 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i4 = i20;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i20) | 0;
   if (!i13) {
    i6 = 0;
    do {
     i1 = i19;
     i2 = i1 + 32 | 0;
     do {
      HEAP8[i1 >> 0] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
     HEAP32[i22 >> 2] = i6;
     __ZN5physx6string9sprintf_sEPcjPKcz(i19, 32, gb + 832792 | 0, i22) | 0;
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if (!i2) {
      i3 = i1;
      i2 = 0;
     } else {
      i3 = i2 + -1 | 0;
      i4 = HEAP32[i1 + 4 >> 2] | 0;
      if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
       i2 = HEAP32[i14 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
       i2 = HEAP32[i26 >> 2] | 0;
       HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
       i2 = HEAP32[i26 >> 2] | 0;
       i3 = i2;
       i2 = HEAP32[i2 + 8 >> 2] | 0;
      } else i3 = i1;
     }
     HEAP32[i20 >> 2] = i19;
     HEAP8[i15 >> 0] = 0;
     i1 = i3 + 8 | 0;
     if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      i28 = i20;
      i4 = HEAP32[i28 + 4 >> 2] | 0;
      i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
      HEAP32[i5 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i20) | 0;
     f7 = Math_fround(+mftCall_fiii(HEAP32[i9 >> 2] | 0, HEAP32[i16 >> 2] | 0, i11 | 0, i6 | 0));
     i4 = HEAP32[i14 >> 2] | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
     d8 = +f7;
     i1 = i20;
     i2 = i1 + 128 | 0;
     do {
      HEAP8[i1 >> 0] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
     HEAPF64[i23 >> 3] = d8;
     __ZN5physx6string9sprintf_sEPcjPKcz(i20, 128, gb + 832323 | 0, i23) | 0;
     if (HEAP8[i20 >> 0] | 0) {
      i28 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_iiii(i28 | 0, i5 | 0, i20 | 0, _strlen(i20) | 0) | 0;
     }
     HEAP8[i20 >> 0] = 0;
     mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i20 | 0, 1) | 0;
     mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i5 + 20 >> 2] | 0);
     HEAP32[i5 + 16 >> 2] = 0;
     HEAP32[i5 + 12 >> 2] = 0;
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if (i2 | 0) {
      if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
       i2 = HEAP32[i14 >> 2] | 0;
       mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
       i2 = HEAP32[i26 >> 2] | 0;
       i1 = i2;
       i2 = HEAP32[i2 + 8 >> 2] | 0;
      }
      HEAP32[i1 + 8 >> 2] = i2 + -1;
     }
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i25 | 0));
   }
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i14 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i24 | 0));
 }
 i2 = HEAP32[i26 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i26 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i26 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i27;
 return;
}

function __ZN7mecanim5human14RetargetToTDoFEPKNS0_5HumanEPNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESB_(i4, i5, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0;
 i9 = i4 + 40 | 0;
 i10 = i9;
 i11 = i8 + 4 | 0;
 i12 = i11;
 i13 = i7 + 4 | 0;
 i14 = i13;
 i6 = i4 + 360 | 0;
 i1 = 0;
 do {
  i2 = HEAP32[i4 + 72 + (HEAP32[gb + 177756 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  i3 = HEAP32[i4 + 72 + (HEAP32[gb + 177784 + (i1 << 2) >> 2] << 2) >> 2] | 0;
  if ((i2 | 0) != -1 & (i3 | 0) != -1) {
   i34 = HEAP32[i9 >> 2] | 0;
   i34 = ((i34 | 0) == 0 ? 0 : i34 + i10 | 0) + 4 | 0;
   i34 = HEAP32[i34 + (HEAP32[i34 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   i20 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   i18 = i20 + (i34 * 40 | 0) | 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 20 >> 2] = 0;
   HEAP32[i20 + (i34 * 40 | 0) + 24 >> 2] = 1065353216;
   HEAP32[i20 + (i34 * 40 | 0) + 28 >> 2] = 1065353216;
   HEAP32[i20 + (i34 * 40 | 0) + 32 >> 2] = 1065353216;
   HEAP32[i20 + (i34 * 40 | 0) + 36 >> 2] = 1065353216;
   i34 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
   i18 = HEAP32[i34 + (i3 * 40 | 0) + 4 >> 2] | 0;
   i35 = HEAP32[i34 + (i3 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i20 + (i3 * 40 | 0) >> 2] = HEAP32[i34 + (i3 * 40 | 0) >> 2];
   HEAP32[i20 + (i3 * 40 | 0) + 4 >> 2] = i18;
   HEAP32[i20 + (i3 * 40 | 0) + 8 >> 2] = i35;
   i35 = HEAP32[i34 + (i3 * 40 | 0) + 16 >> 2] | 0;
   i18 = HEAP32[i34 + (i3 * 40 | 0) + 20 >> 2] | 0;
   i16 = HEAP32[i34 + (i3 * 40 | 0) + 24 >> 2] | 0;
   HEAP32[i20 + (i3 * 40 | 0) + 12 >> 2] = HEAP32[i34 + (i3 * 40 | 0) + 12 >> 2];
   HEAP32[i20 + (i3 * 40 | 0) + 16 >> 2] = i35;
   HEAP32[i20 + (i3 * 40 | 0) + 20 >> 2] = i18;
   HEAP32[i20 + (i3 * 40 | 0) + 24 >> 2] = i16;
   i16 = HEAP32[i34 + (i3 * 40 | 0) + 32 >> 2] | 0;
   i18 = HEAP32[i34 + (i3 * 40 | 0) + 36 >> 2] | 0;
   HEAP32[i20 + (i3 * 40 | 0) + 28 >> 2] = HEAP32[i34 + (i3 * 40 | 0) + 28 >> 2];
   HEAP32[i20 + (i3 * 40 | 0) + 32 >> 2] = i16;
   HEAP32[i20 + (i3 * 40 | 0) + 36 >> 2] = i18;
   i20 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i20 | 0) == 0 ? 0 : i20 + i10 | 0, i7, i8, i2, i3);
   i20 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   f22 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 12 >> 2]);
   f24 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 16 >> 2]);
   f28 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 20 >> 2]);
   f27 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 24 >> 2]);
   f29 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 28 >> 2]);
   f15 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 32 >> 2]);
   f17 = Math_fround(HEAPF32[i20 + (i3 * 40 | 0) + 36 >> 2]);
   i18 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
   i16 = i18 + 16 | 0;
   i18 = i18 + 4 | 0;
   i18 = HEAP32[i18 + (HEAP32[i18 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   i3 = i16 + (HEAP32[i16 >> 2] | 0) | 0;
   f26 = Math_fround(HEAPF32[i3 + (i18 * 76 | 0) + 16 >> 2]);
   f31 = Math_fround(HEAPF32[i3 + (i18 * 76 | 0) + 20 >> 2]);
   f33 = Math_fround(HEAPF32[i3 + (i18 * 76 | 0) + 24 >> 2]);
   f23 = Math_fround(HEAPF32[i3 + (i18 * 76 | 0) + 28 >> 2]);
   f21 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f26) - Math_fround(f27 * f33)) - Math_fround(f28 * f23)) - Math_fround(f22 * f31));
   f25 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f23) - Math_fround(f22 * f26)) - Math_fround(f28 * f33)) - Math_fround(f24 * f31));
   f30 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f31) - Math_fround(f24 * f33)) - Math_fround(f27 * f26)) - Math_fround(f22 * f23));
   f23 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f33) - Math_fround(f28 * f26)) - Math_fround(f27 * f31)) - Math_fround(f24 * f23));
   i18 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
   f23 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(f23 * f23);
   f21 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(f21 * f21);
   f31 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f31 * f31)) + Math_fround(f30 + f24)))));
   f23 = Math_fround(f24 * f23);
   f21 = Math_fround(f24 * f21);
   f31 = Math_fround(f24 * f31);
   f25 = Math_fround(f24 * f25);
   f24 = Math_fround(HEAPF32[i6 >> 2]);
   f30 = Math_fround(HEAPF32[i5 + 804 + (i1 * 12 | 0) >> 2]);
   f27 = Math_fround(HEAPF32[i5 + 804 + (i1 * 12 | 0) + 4 >> 2]);
   f30 = Math_fround(f29 * Math_fround(f24 * f30));
   f27 = Math_fround(f15 * Math_fround(f24 * f27));
   f24 = Math_fround(f17 * Math_fround(f24 * Math_fround(HEAPF32[i5 + 804 + (i1 * 12 | 0) + 8 >> 2])));
   f17 = Math_fround(f21 * Math_fround(-2.0));
   f15 = Math_fround(f21 * Math_fround(2.0));
   f29 = Math_fround(f25 * f17);
   f26 = Math_fround(f31 * Math_fround(2.0));
   f28 = Math_fround(f31 * Math_fround(-2.0));
   f33 = Math_fround(f25 * f28);
   f22 = Math_fround(f23 * Math_fround(-2.0));
   f32 = Math_fround(f23 * Math_fround(2.0));
   f25 = Math_fround(f25 * f22);
   f19 = Math_fround(Math_fround(f30 + Math_fround(f30 * Math_fround(Math_fround(f21 * f17) - Math_fround(f31 * f26)))) + Math_fround(Math_fround(f27 * Math_fround(f33 - Math_fround(f21 * f22))) + Math_fround(f24 * Math_fround(Math_fround(f31 * f32) - f29))));
   f17 = Math_fround(Math_fround(f27 + Math_fround(f30 * Math_fround(Math_fround(f23 * f15) - f33))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f31 * f28) - Math_fround(f23 * f32))) + Math_fround(f24 * Math_fround(f25 - Math_fround(f31 * f17)))));
   f15 = Math_fround(Math_fround(f24 + Math_fround(f30 * Math_fround(f29 - Math_fround(f23 * f28)))) + Math_fround(Math_fround(f27 * Math_fround(Math_fround(f21 * f26) - f25)) + Math_fround(f24 * Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f15)))));
   i18 = i20 + (i2 * 40 | 0) | 0;
   f19 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f19);
   i16 = i20 + (i2 * 40 | 0) + 4 | 0;
   f17 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f17);
   i3 = i20 + (i2 * 40 | 0) + 8 | 0;
   f15 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f15);
   HEAPF32[i18 >> 2] = f19;
   HEAPF32[i16 >> 2] = f17;
   HEAPF32[i3 >> 2] = f15;
   i3 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i3 | 0) == 0 ? 0 : i3 + i10 | 0, i8, i7, i2, i2);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 return;
}

function __ZN5physx2Gu17contactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i36, i4, i37, i38, i3, i1, i35) {
 i36 = i36 | 0;
 i4 = i4 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 var i2 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 3600 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i34 + 3528 | 0;
 i33 = i34 + 3476 | 0;
 i30 = i34 + 3464 | 0;
 i22 = i34 + 3392 | 0;
 i27 = i34;
 i9 = i34 + 3488 | 0;
 i32 = i34 + 3404 | 0;
 i29 = i34 + 16 | 0;
 HEAP32[i31 >> 2] = 1065353216;
 HEAP32[i31 + 4 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = 0;
 HEAP32[i31 + 12 >> 2] = 0;
 HEAP32[i31 + 16 >> 2] = 1065353216;
 HEAP32[i31 + 20 >> 2] = 0;
 HEAP32[i31 + 24 >> 2] = 0;
 HEAP32[i31 + 28 >> 2] = 0;
 HEAP32[i31 + 32 >> 2] = 1065353216;
 HEAP32[i31 + 36 >> 2] = 1065353216;
 HEAP32[i31 + 40 >> 2] = 0;
 HEAP32[i31 + 44 >> 2] = 0;
 HEAP32[i31 + 48 >> 2] = 0;
 HEAP32[i31 + 52 >> 2] = 1065353216;
 HEAP32[i31 + 56 >> 2] = 0;
 HEAP32[i31 + 60 >> 2] = 0;
 HEAP32[i31 + 64 >> 2] = 0;
 HEAP32[i31 + 68 >> 2] = 1065353216;
 i1 = i4 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i4 + 12 >> 2]) == Math_fround(1.0)) i28 = 1; else i2 = 4; else i2 = 4; else i2 = 4;
 if ((i2 | 0) == 4) {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i31, i1, i4 + 16 | 0);
  i28 = 0;
 }
 f40 = Math_fround(HEAPF32[i37 + 16 >> 2]);
 f40 = Math_fround(f40 - Math_fround(HEAPF32[i38 + 16 >> 2]));
 f42 = Math_fround(HEAPF32[i37 + 20 >> 2]);
 f42 = Math_fround(f42 - Math_fround(HEAPF32[i38 + 20 >> 2]));
 f45 = Math_fround(HEAPF32[i37 + 24 >> 2]);
 f40 = Math_fround(f40 * Math_fround(2.0));
 f42 = Math_fround(f42 * Math_fround(2.0));
 f45 = Math_fround(Math_fround(f45 - Math_fround(HEAPF32[i38 + 24 >> 2])) * Math_fround(2.0));
 f43 = Math_fround(HEAPF32[i38 + 12 >> 2]);
 f44 = Math_fround(Math_fround(f43 * f43) + Math_fround(-.5));
 f41 = Math_fround(HEAPF32[i38 >> 2]);
 f6 = Math_fround(f40 * f41);
 f39 = Math_fround(HEAPF32[i38 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f42 * f39));
 f26 = Math_fround(HEAPF32[i38 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f45 * f26));
 f17 = Math_fround(Math_fround(f41 * f6) + Math_fround(Math_fround(f40 * f44) - Math_fround(f43 * Math_fround(Math_fround(f45 * f39) - Math_fround(f42 * f26)))));
 f5 = Math_fround(Math_fround(f39 * f6) + Math_fround(Math_fround(f42 * f44) - Math_fround(f43 * Math_fround(Math_fround(f40 * f26) - Math_fround(f45 * f41)))));
 f6 = Math_fround(Math_fround(Math_fround(f45 * f44) - Math_fround(f43 * Math_fround(Math_fround(f42 * f41) - Math_fround(f40 * f39)))) + Math_fround(f26 * f6));
 HEAPF32[i33 >> 2] = f17;
 HEAPF32[i33 + 4 >> 2] = f5;
 HEAPF32[i33 + 8 >> 2] = f6;
 f26 = Math_fround(HEAPF32[i36 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(HEAPF32[i3 >> 2]));
 i25 = HEAP32[i4 + 40 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i25 + 16 >> 2];
 HEAP32[i30 + 4 >> 2] = i25 + 32;
 HEAP32[i30 + 8 >> 2] = HEAP32[i25 + 20 >> 2];
 HEAPF32[i22 >> 2] = f17;
 i14 = i22 + 4 | 0;
 HEAPF32[i14 >> 2] = f5;
 i18 = i22 + 8 | 0;
 HEAPF32[i18 >> 2] = f6;
 HEAPF32[i27 >> 2] = f26;
 i20 = i27 + 4 | 0;
 HEAPF32[i20 >> 2] = f26;
 i23 = i27 + 8 | 0;
 HEAPF32[i23 >> 2] = f26;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 i1 = i9 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i2 = i9 + 8 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 i3 = i9 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i4 = i9 + 20 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 i7 = i9 + 28 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i8 = i9 + 32 | 0;
 HEAPF32[i8 >> 2] = Math_fround(1.0);
 i24 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 if (i28) {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = 1065353216;
  i19 = 0;
  i15 = 0;
  i16 = 0;
  i13 = 1065353216;
  i12 = 0;
  i11 = 0;
  i10 = 0;
  i9 = 1065353216;
  i8 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = i24;
  i2 = i24;
  i1 = i24;
 } else {
  __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i31, i22, i27, i9);
  i21 = HEAP32[i9 >> 2] | 0;
  i19 = HEAP32[i1 >> 2] | 0;
  i15 = HEAP32[i2 >> 2] | 0;
  i16 = HEAP32[i9 + 12 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  i12 = HEAP32[i4 >> 2] | 0;
  i11 = HEAP32[i9 + 24 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i22 >> 2] | 0;
  i7 = HEAP32[i14 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i3 = HEAP32[i27 >> 2] | 0;
  i2 = HEAP32[i20 >> 2] | 0;
  i1 = HEAP32[i23 >> 2] | 0;
 }
 HEAP32[i32 >> 2] = i21;
 HEAP32[i32 + 4 >> 2] = i19;
 HEAP32[i32 + 8 >> 2] = i15;
 HEAP32[i32 + 12 >> 2] = i16;
 HEAP32[i32 + 16 >> 2] = i13;
 HEAP32[i32 + 20 >> 2] = i12;
 HEAP32[i32 + 24 >> 2] = i11;
 HEAP32[i32 + 28 >> 2] = i10;
 HEAP32[i32 + 32 >> 2] = i9;
 HEAP32[i32 + 36 >> 2] = i8;
 HEAP32[i32 + 40 >> 2] = i7;
 HEAP32[i32 + 44 >> 2] = i4;
 HEAP32[i32 + 48 >> 2] = i3;
 HEAP32[i32 + 52 >> 2] = i2;
 HEAP32[i32 + 56 >> 2] = i1;
 if (i28) {
  HEAP32[i29 + 4 >> 2] = 2;
  HEAP32[i29 >> 2] = gb + 84496 + 8;
  HEAP32[i29 + 8 >> 2] = i36;
  HEAP32[i29 + 12 >> 2] = i37;
  HEAP32[i29 + 16 >> 2] = i38;
  HEAP32[i29 + 20 >> 2] = i35;
  HEAP32[i29 + 24 >> 2] = i33;
  HEAPF32[i29 + 28 >> 2] = Math_fround(f26 * f26);
  HEAP32[i29 + 32 >> 2] = 0;
  HEAP32[i29 + 2596 >> 2] = 0;
  HEAP32[i29 + 3368 >> 2] = i25;
  __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i32, 1, i30, i29, 1);
  HEAP32[i29 >> 2] = gb + 84496 + 8;
  __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i29 + 8 | 0);
  i38 = i35 + 4096 | 0;
  i38 = HEAP32[i38 >> 2] | 0;
  i38 = (i38 | 0) != 0;
  STACKTOP = i34;
  return i38 | 0;
 } else {
  HEAP32[i29 + 4 >> 2] = 2;
  HEAP32[i29 + 8 >> 2] = i36;
  HEAP32[i29 + 12 >> 2] = i37;
  HEAP32[i29 + 16 >> 2] = i38;
  HEAP32[i29 + 20 >> 2] = i35;
  HEAP32[i29 + 24 >> 2] = i33;
  HEAPF32[i29 + 28 >> 2] = Math_fround(f26 * f26);
  HEAP32[i29 + 32 >> 2] = 0;
  HEAP32[i29 + 2596 >> 2] = 0;
  HEAP32[i29 + 3368 >> 2] = i25;
  HEAP32[i29 >> 2] = gb + 84476 + 8;
  HEAP32[i29 + 3372 >> 2] = i31;
  __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i32, 1, i30, i29, 1);
  HEAP32[i29 >> 2] = gb + 84496 + 8;
  __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i29 + 8 | 0);
  i38 = i35 + 4096 | 0;
  i38 = HEAP32[i38 >> 2] | 0;
  i38 = (i38 | 0) != 0;
  STACKTOP = i34;
  return i38 | 0;
 }
 return 0;
}

function __ZN5physx2Gu31SinglePersistentContactManifold14reduceContactsEPNS0_21MeshPersistentContactEj(i20, i19) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i19 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i18 | 0, 0, i19 | 0) | 0;
 i17 = (i19 | 0) == 0;
 if (i17) i1 = -1; else {
  i6 = 2139095039;
  i8 = 0;
  i1 = -1;
  while (1) {
   i2 = HEAP32[i20 + (i8 << 6) + 44 >> 2] | 0;
   f16 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = f16 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i7 ? i8 : i1;
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i19 | 0)) break; else i6 = i7 ? i2 : i6;
  }
 }
 i9 = i21;
 i6 = i20 + (i1 << 6) | 0;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 HEAP8[i18 + i1 >> 0] = 1;
 f3 = Math_fround(HEAPF32[i20 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i20 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i20 + 24 >> 2]);
 f14 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 f3 = Math_fround(f3 - f14);
 f4 = Math_fround(f4 - f15);
 f5 = Math_fround(f5 - f16);
 if (i19 >>> 0 > 1) {
  f12 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f5 * f5));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = 1;
  i1 = 0;
  while (1) {
   f11 = Math_fround(HEAPF32[i20 + (i7 << 6) + 16 >> 2]);
   f12 = Math_fround(HEAPF32[i20 + (i7 << 6) + 20 >> 2]);
   f11 = Math_fround(f11 - f14);
   f12 = Math_fround(f12 - f15);
   f3 = Math_fround(Math_fround(HEAPF32[i20 + (i7 << 6) + 24 >> 2]) - f16);
   f3 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f3 * f3));
   i6 = f3 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i6 ? i7 : i1;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i19 | 0)) break; else i2 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i2;
  }
 } else i1 = 0;
 i13 = i21 + 64 | 0;
 i9 = i13;
 i6 = i20 + (i1 << 6) | 0;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 HEAP8[i18 + i1 >> 0] = 1;
 f23 = Math_fround(HEAPF32[i21 + 80 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + 84 >> 2]);
 f23 = Math_fround(f23 - f14);
 f12 = Math_fround(f12 - f15);
 f24 = Math_fround(Math_fround(HEAPF32[i21 + 88 >> 2]) - f16);
 f4 = Math_fround(HEAPF32[i21 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 36 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + 40 >> 2]);
 f5 = Math_fround(Math_fround(f12 * f11) - Math_fround(f24 * f3));
 f11 = Math_fround(Math_fround(f24 * f4) - Math_fround(f23 * f11));
 f4 = Math_fround(Math_fround(f23 * f3) - Math_fround(f12 * f4));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f5 * f5) + Math_fround(f11 * f11))))));
 f5 = Math_fround(f5 * f12);
 f11 = Math_fround(f11 * f12);
 f12 = Math_fround(f4 * f12);
 if (i17) {
  i7 = -8388609;
  f3 = Math_fround(3402823469999999843913219.0e14);
  i2 = -1;
  i1 = -1;
 } else {
  i7 = -8388609;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i8 = 0;
  i2 = -1;
  i1 = -1;
  while (1) {
   if (!(HEAP8[i18 + i8 >> 0] | 0)) {
    f24 = Math_fround(HEAPF32[i20 + (i8 << 6) + 16 >> 2]);
    f3 = Math_fround(HEAPF32[i20 + (i8 << 6) + 20 >> 2]);
    f3 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(f24 - f14)) + Math_fround(f11 * Math_fround(f3 - f15))) + Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i20 + (i8 << 6) + 24 >> 2]) - f16)));
    i6 = f3 > (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i7 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : i7;
    i2 = i6 ? i8 : i2;
    if (f4 > f3) i1 = i8; else f3 = f4;
   } else f3 = f4;
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i19 | 0)) break; else f4 = f3;
  }
 }
 HEAP8[i18 + i2 >> 0] = 1;
 i10 = i21 + 128 | 0;
 i9 = i10;
 i6 = i20 + (i2 << 6) | 0;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 if (!(Math_fround(f3 * (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]))) > Math_fround(0.0)) | i17) {
  i6 = i1;
  i2 = i21 + 192 | 0;
  i6 = i20 + (i6 << 6) | 0;
  i9 = i2;
  i8 = i9 + 52 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i9 = i9 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i9 | 0) < (i8 | 0));
  i9 = i20;
  i6 = i21;
  i8 = i9 + 52 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i9 = i9 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i9 | 0) < (i8 | 0));
  i9 = i20 + 64 | 0;
  i6 = i13;
  i8 = i9 + 52 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i9 = i9 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i9 | 0) < (i8 | 0));
  i9 = i20 + 128 | 0;
  i6 = i10;
  i8 = i9 + 52 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i9 = i9 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i9 | 0) < (i8 | 0));
  i9 = i20 + 192 | 0;
  i6 = i2;
  i8 = i9 + 52 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i9 = i9 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i9 | 0) < (i8 | 0));
  STACKTOP = i22;
  return 4;
 } else {
  i2 = -8388609;
  i6 = 0;
 }
 do {
  if (!(HEAP8[i18 + i6 >> 0] | 0)) {
   f24 = Math_fround(HEAPF32[i20 + (i6 << 6) + 16 >> 2]);
   f3 = Math_fround(HEAPF32[i20 + (i6 << 6) + 20 >> 2]);
   f3 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(f24 - f14)) + Math_fround(f11 * Math_fround(f3 - f15))) + Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i20 + (i6 << 6) + 24 >> 2]) - f16)));
   if (f3 > (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = i6;
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i19 | 0));
 i2 = i21 + 192 | 0;
 i6 = i20 + (i1 << 6) | 0;
 i9 = i2;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i20;
 i6 = i21;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i20 + 64 | 0;
 i6 = i13;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i20 + 128 | 0;
 i6 = i10;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 i9 = i20 + 192 | 0;
 i6 = i2;
 i8 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  i9 = i9 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i9 | 0) < (i8 | 0));
 STACKTOP = i22;
 return 4;
}

function __ZNK9dtNavMesh23getPolyEdgeDetailPointsEPK10dtMeshTileiiPfPii(i1, i4, i3, i2, i38, i39, i35) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i35 = i35 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i40 = 0, i41 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i37;
 i24 = HEAP32[i4 + 16 >> 2] | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 i25 = HEAP32[i4 + 20 >> 2] | 0;
 i28 = i25 + ((HEAPU16[i24 + (i3 << 5) + (i2 << 1) >> 1] | 0) * 3 << 2) | 0;
 i24 = i25 + ((HEAPU16[i24 + (i3 << 5) + (((i2 + 1 | 0) % (HEAPU8[i24 + (i3 << 5) + 28 >> 0] | 0) | 0) << 1) >> 1] | 0) * 3 << 2) | 0;
 f20 = Math_fround(HEAPF32[i24 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i28 >> 2]));
 i25 = i24 + 8 | 0;
 f11 = Math_fround(HEAPF32[i25 >> 2]);
 i26 = i28 + 8 | 0;
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i26 >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(f11 * f11))));
 i29 = f11 > Math_fround(0.0);
 f11 = Math_fround(Math_fround(1.0) / f11);
 f11 = i29 ? f11 : Math_fround(0.0);
 HEAPF32[i36 >> 2] = Math_fround(0.0);
 i29 = i36 + 4 | 0;
 HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
 i30 = i36 + 8 | 0;
 HEAP32[i30 >> 2] = HEAP32[i28 + 4 >> 2];
 i31 = i36 + 12 | 0;
 HEAP32[i31 >> 2] = HEAP32[i26 >> 2];
 HEAPF32[i36 + 16 >> 2] = Math_fround(1.0);
 i32 = i36 + 20 | 0;
 HEAP32[i32 >> 2] = HEAP32[i24 >> 2];
 i33 = i36 + 24 | 0;
 HEAP32[i33 >> 2] = HEAP32[i24 + 4 >> 2];
 i34 = i36 + 28 | 0;
 HEAP32[i34 >> 2] = HEAP32[i25 >> 2];
 if (!(HEAP8[gb + 1552707 >> 0] | 0)) {
  HEAPF32[gb + 1459452 >> 2] = Math_fround(.0000999999974);
  HEAP8[gb + 1552707 >> 0] = 1;
 }
 i27 = i1 + (i3 * 12 | 0) + 8 | 0;
 i5 = HEAP16[i27 >> 1] | 0;
 if (!(i5 << 16 >> 16)) i2 = 2; else {
  i23 = i1 + (i3 * 12 | 0) | 0;
  i22 = HEAP32[i4 + 28 >> 2] | 0;
  i2 = 2;
  i21 = 0;
  i1 = i5;
  do {
   i4 = i22 + (((HEAP32[i23 >> 2] | 0) + i21 | 0) * 3 << 2) | 0;
   f6 = Math_fround(HEAPF32[i24 >> 2]);
   f9 = Math_fround(HEAPF32[i28 >> 2]);
   f6 = Math_fround(f6 - f9);
   f7 = Math_fround(HEAPF32[i25 >> 2]);
   f10 = Math_fround(HEAPF32[i26 >> 2]);
   f7 = Math_fround(f7 - f10);
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
   i5 = i4 + 8 | 0;
   f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f10);
   f8 = Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7));
   if (f8 == Math_fround(0.0)) f6 = Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)); else {
    f19 = Math_fround(Math_fround(Math_fround(f6 * f9) + Math_fround(f7 * f10)) / f8);
    i3 = f19 < Math_fround(0.0);
    i40 = f19 > Math_fround(1.0);
    f19 = i40 ? Math_fround(1.0) : f19;
    f19 = i3 ? Math_fround(0.0) : f19;
    f20 = Math_fround(Math_fround(f6 * f19) - f9);
    f6 = Math_fround(Math_fround(f7 * f19) - f10);
    f6 = Math_fround(Math_fround(f20 * f20) + Math_fround(f6 * f6));
   }
   if (f6 < Math_fround(HEAPF32[gb + 1459452 >> 2])) {
    f6 = Math_fround(f11 * Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)))));
    if (!((i2 | 0) > 63 | (f6 < Math_fround(.0000999999974) | f6 > Math_fround(.999899983)))) {
     L15 : do if ((i2 | 0) > 0) {
      i3 = 0;
      do {
       if (Math_fround(HEAPF32[i36 + (i3 << 4) >> 2]) >= f6) break L15;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (i2 | 0));
     } else i3 = 0; while (0);
     if ((i2 | 0) > (i3 | 0)) {
      i1 = i2;
      do {
       i40 = i36 + (i1 << 4) | 0;
       i1 = i1 + -1 | 0;
       i41 = i36 + (i1 << 4) | 0;
       HEAP32[i40 >> 2] = HEAP32[i41 >> 2];
       HEAP32[i40 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
       HEAP32[i40 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
       HEAP32[i40 + 12 >> 2] = HEAP32[i41 + 12 >> 2];
      } while ((i1 | 0) > (i3 | 0));
      i1 = HEAP16[i27 >> 1] | 0;
     }
     HEAPF32[i36 + (i3 << 4) >> 2] = f6;
     HEAP32[i36 + (i3 << 4) + 4 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i36 + (i3 << 4) + 8 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i36 + (i3 << 4) + 12 >> 2] = HEAP32[i5 >> 2];
     i2 = i2 + 1 | 0;
    }
   }
   i21 = i21 + 1 | 0;
  } while ((i21 | 0) < (i1 & 65535 | 0));
 }
 if ((i2 | 0) > (i35 | 0)) {
  i21 = i2;
  i5 = i2;
  do {
   i5 = i5 + -1 | 0;
   i21 = i21 + -1 | 0;
   if ((i21 | 0) > 1) {
    f6 = Math_fround(HEAPF32[i29 >> 2]);
    f7 = Math_fround(HEAPF32[i30 >> 2]);
    f8 = Math_fround(HEAPF32[i31 >> 2]);
    f18 = Math_fround(HEAPF32[i32 >> 2]);
    f19 = Math_fround(HEAPF32[i33 >> 2]);
    i4 = 1;
    f14 = Math_fround(3402823469999999843913219.0e14);
    i1 = -1;
    f20 = Math_fround(HEAPF32[i34 >> 2]);
    while (1) {
     i3 = i4;
     i4 = i4 + 1 | 0;
     f15 = Math_fround(HEAPF32[i36 + (i4 << 4) + 4 >> 2]);
     f11 = Math_fround(f15 - f6);
     f16 = Math_fround(HEAPF32[i36 + (i4 << 4) + 8 >> 2]);
     f12 = Math_fround(f16 - f7);
     f17 = Math_fround(HEAPF32[i36 + (i4 << 4) + 12 >> 2]);
     f13 = Math_fround(f17 - f8);
     f10 = Math_fround(f18 - f6);
     f9 = Math_fround(f19 - f7);
     f6 = Math_fround(f20 - f8);
     f7 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
     if (f7 == Math_fround(0.0)) f6 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f6 * f6)); else {
      f8 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f9)) + Math_fround(f13 * f6)) / f7);
      i41 = f8 < Math_fround(0.0);
      i40 = f8 > Math_fround(1.0);
      f8 = i40 ? Math_fround(1.0) : f8;
      f8 = i41 ? Math_fround(0.0) : f8;
      f11 = Math_fround(Math_fround(f11 * f8) - f10);
      f12 = Math_fround(Math_fround(f12 * f8) - f9);
      f6 = Math_fround(Math_fround(f13 * f8) - f6);
      f6 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)));
     }
     i2 = f6 < f14;
     i1 = i2 ? i3 : i1;
     if ((i4 | 0) == (i5 | 0)) break; else {
      f8 = f20;
      f7 = f19;
      f13 = f18;
      f14 = i2 ? f6 : f14;
      f18 = f15;
      f19 = f16;
      f20 = f17;
      f6 = f13;
     }
    }
   } else i1 = -1;
   if ((i1 | 0) < (i21 | 0)) do {
    i41 = i36 + (i1 << 4) | 0;
    i1 = i1 + 1 | 0;
    i40 = i36 + (i1 << 4) | 0;
    HEAP32[i41 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i41 + 4 >> 2] = HEAP32[i40 + 4 >> 2];
    HEAP32[i41 + 8 >> 2] = HEAP32[i40 + 8 >> 2];
    HEAP32[i41 + 12 >> 2] = HEAP32[i40 + 12 >> 2];
   } while ((i1 | 0) != (i5 | 0));
  } while ((i21 | 0) > (i35 | 0));
  i2 = i35;
 }
 if ((i2 | 0) > 0) i1 = 0; else {
  HEAP32[i39 >> 2] = i2;
  STACKTOP = i37;
  return 1073741824;
 }
 do {
  i41 = i38 + (i1 * 3 << 2) | 0;
  HEAP32[i41 >> 2] = HEAP32[i36 + (i1 << 4) + 4 >> 2];
  HEAP32[i41 + 4 >> 2] = HEAP32[i36 + (i1 << 4) + 8 >> 2];
  HEAP32[i41 + 8 >> 2] = HEAP32[i36 + (i1 << 4) + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i39 >> 2] = i2;
 STACKTOP = i37;
 return 1073741824;
}

function __ZN7mecanim9animation26ComputeClipMuscleDeltaPoseERKNS0_18ClipMuscleConstantEffRNS_5human9HumanPoseERN4math4trsXES9_S9_S9_RNS_6memory9AllocatorE(i8, f9, f15, i17, i18, i19, i20, i21, i22) {
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f15 = Math_fround(f15);
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 1808 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23 + 1780 | 0;
 i10 = i23 + 1776 | 0;
 i11 = i23 + 888 | 0;
 i12 = i23;
 __ZN7mecanim5human9HumanPoseC2Ev(i11);
 __ZN7mecanim5human9HumanPoseC2Ev(i12);
 i13 = i8 + 1060 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = i13;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i14 | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] | 0) | 0;
 i16 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 4, 4) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i2 = HEAP32[i13 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i14 | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] | 0) | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 4, 4) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i13 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + i14 | 0;
 i4 = i1 + 8 | 0;
 i3 = i1 + 16 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 + 36 >> 2] | 0) | 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 20, 4) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 + 16 >> 2] = i1 - i2 - (HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i2 * 20 | 0, 4) | 0;
  i3 = i1 + (i2 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i5 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i10 >> 2] = f9;
 i7 = HEAP32[i13 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i7 | 0) == 0 ? 0 : i7 + i14 | 0, i10, i5, i16);
 __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i8, HEAP32[i16 >> 2] | 0, i11);
 HEAPF32[i10 >> 2] = f15;
 i13 = HEAP32[i13 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i13 | 0) == 0 ? 0 : i13 + i14 | 0, i10, i5, i6);
 __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i8, HEAP32[i6 >> 2] | 0, i12);
 __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_(i17, i11, i12);
 i14 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = HEAP32[i11 + 8 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i18 + 4 >> 2] = i14;
 HEAP32[i18 + 8 >> 2] = i13;
 i13 = HEAP32[i11 + 16 >> 2] | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 i17 = HEAP32[i11 + 24 >> 2] | 0;
 HEAP32[i18 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = i13;
 HEAP32[i18 + 20 >> 2] = i14;
 HEAP32[i18 + 24 >> 2] = i17;
 i17 = HEAP32[i11 + 32 >> 2] | 0;
 i14 = HEAP32[i11 + 36 >> 2] | 0;
 HEAP32[i18 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i18 + 32 >> 2] = i17;
 HEAP32[i18 + 36 >> 2] = i14;
 i18 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = HEAP32[i12 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 HEAP32[i19 + 8 >> 2] = i14;
 i14 = HEAP32[i12 + 16 >> 2] | 0;
 i18 = HEAP32[i12 + 20 >> 2] | 0;
 i17 = HEAP32[i12 + 24 >> 2] | 0;
 HEAP32[i19 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = i14;
 HEAP32[i19 + 20 >> 2] = i18;
 HEAP32[i19 + 24 >> 2] = i17;
 i17 = HEAP32[i12 + 32 >> 2] | 0;
 i18 = HEAP32[i12 + 36 >> 2] | 0;
 HEAP32[i19 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i19 + 32 >> 2] = i17;
 HEAP32[i19 + 36 >> 2] = i18;
 i18 = HEAP32[i11 + 72 >> 2] | 0;
 i17 = HEAP32[i11 + 76 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i11 + 68 >> 2];
 HEAP32[i20 + 4 >> 2] = i18;
 HEAP32[i20 + 8 >> 2] = i17;
 i17 = HEAP32[i11 + 84 >> 2] | 0;
 i18 = HEAP32[i11 + 88 >> 2] | 0;
 i19 = HEAP32[i11 + 92 >> 2] | 0;
 HEAP32[i20 + 12 >> 2] = HEAP32[i11 + 80 >> 2];
 HEAP32[i20 + 16 >> 2] = i17;
 HEAP32[i20 + 20 >> 2] = i18;
 HEAP32[i20 + 24 >> 2] = i19;
 i19 = HEAP32[i11 + 100 >> 2] | 0;
 i18 = HEAP32[i11 + 104 >> 2] | 0;
 HEAP32[i20 + 28 >> 2] = HEAP32[i11 + 96 >> 2];
 HEAP32[i20 + 32 >> 2] = i19;
 HEAP32[i20 + 36 >> 2] = i18;
 i20 = HEAP32[i11 + 136 >> 2] | 0;
 i18 = HEAP32[i11 + 140 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i11 + 132 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 HEAP32[i21 + 8 >> 2] = i18;
 i18 = HEAP32[i11 + 148 >> 2] | 0;
 i20 = HEAP32[i11 + 152 >> 2] | 0;
 i19 = HEAP32[i11 + 156 >> 2] | 0;
 HEAP32[i21 + 12 >> 2] = HEAP32[i11 + 144 >> 2];
 HEAP32[i21 + 16 >> 2] = i18;
 HEAP32[i21 + 20 >> 2] = i20;
 HEAP32[i21 + 24 >> 2] = i19;
 i19 = HEAP32[i11 + 164 >> 2] | 0;
 i20 = HEAP32[i11 + 168 >> 2] | 0;
 HEAP32[i21 + 28 >> 2] = HEAP32[i11 + 160 >> 2];
 HEAP32[i21 + 32 >> 2] = i19;
 HEAP32[i21 + 36 >> 2] = i20;
 if (!i16) {
  i21 = HEAP32[i22 >> 2] | 0;
  i21 = i21 + 4 | 0;
  i21 = HEAP32[i21 >> 2] | 0;
  i20 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(i21 | 0, i22 | 0, i20 | 0);
  i20 = HEAP32[i22 >> 2] | 0;
  i20 = i20 + 4 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  mftCall_vii(i20 | 0, i22 | 0, i6 | 0);
  i20 = HEAP32[i22 >> 2] | 0;
  i20 = i20 + 4 | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i21 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(i20 | 0, i22 | 0, i21 | 0);
  i21 = HEAP32[i22 >> 2] | 0;
  i21 = i21 + 4 | 0;
  i21 = HEAP32[i21 >> 2] | 0;
  mftCall_vii(i21 | 0, i22 | 0, i5 | 0);
  STACKTOP = i23;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0, i22 | 0, HEAP32[i16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0, i22 | 0, i16 | 0);
 i21 = HEAP32[i22 >> 2] | 0;
 i21 = i21 + 4 | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i20 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(i21 | 0, i22 | 0, i20 | 0);
 i20 = HEAP32[i22 >> 2] | 0;
 i20 = i20 + 4 | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 mftCall_vii(i20 | 0, i22 | 0, i6 | 0);
 i20 = HEAP32[i22 >> 2] | 0;
 i20 = i20 + 4 | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(i20 | 0, i22 | 0, i21 | 0);
 i21 = HEAP32[i22 >> 2] | 0;
 i21 = i21 + 4 | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 mftCall_vii(i21 | 0, i22 | 0, i5 | 0);
 STACKTOP = i23;
 return;
}

function __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = (i3 | 0) == 0 ? 0 : i3 + i5 | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i4 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = (i4 | 0) == 0 ? 0 : i4 + i1 | 0;
 if (i6 >>> 0 > 1) i2 = 1; else {
  i6 = HEAP32[i3 >> 2] | 0;
  i5 = i3 + 4 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i7 = i3 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i1 + 8 | 0;
  HEAP32[i6 >> 2] = i7;
  i6 = i1 + 12 | 0;
  i7 = i3 + 12 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i5 = i3 + 16 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i4 = i3 + 20 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i2 = i3 + 24 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i7;
  i6 = i1 + 16 | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = i4;
  i6 = i1 + 24 | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i1 + 28 | 0;
  i2 = i3 + 28 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 32 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i5 = i3 + 36 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = i4;
  i6 = i1 + 36 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 do {
  i4 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
  f21 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 24 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) >> 2]);
  f19 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) >> 2]);
  f8 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 4 >> 2]);
  f10 = Math_fround(f25 - f10);
  f8 = Math_fround(f19 - f8);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 8 >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f23 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f19 * Math_fround(-2.0));
  f17 = Math_fround(f19 * Math_fround(2.0));
  f20 = Math_fround(f21 * f14);
  f18 = Math_fround(f23 * Math_fround(2.0));
  f11 = Math_fround(f23 * Math_fround(-2.0));
  f24 = Math_fround(f21 * f11);
  f16 = Math_fround(f25 * Math_fround(-2.0));
  f9 = Math_fround(f25 * Math_fround(2.0));
  f22 = Math_fround(f21 * f16);
  f15 = Math_fround(Math_fround(f10 + Math_fround(Math_fround(Math_fround(f19 * f14) - Math_fround(f23 * f18)) * f10)) + Math_fround(Math_fround(Math_fround(f24 - Math_fround(f19 * f16)) * f8) + Math_fround(Math_fround(Math_fround(f9 * f23) - f20) * f13)));
  f14 = Math_fround(Math_fround(f8 + Math_fround(Math_fround(Math_fround(f25 * f17) - f24) * f10)) + Math_fround(Math_fround(Math_fround(Math_fround(f23 * f11) - Math_fround(f25 * f9)) * f8) + Math_fround(Math_fround(f22 - Math_fround(f23 * f14)) * f13)));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f20 - Math_fround(f25 * f11)) * f10) + f13) + Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - f22) * f8) + Math_fround(Math_fround(Math_fround(f25 * f16) - Math_fround(f19 * f17)) * f13)));
  f17 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 28 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 32 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + (i4 * 40 | 0) + 36 >> 2]);
  i4 = Math_fround(Math_abs(Math_fround(f17))) < Math_fround(9.99999971e-10);
  i12 = Math_fround(Math_abs(Math_fround(f16))) < Math_fround(9.99999971e-10);
  i7 = Math_fround(Math_abs(Math_fround(f8))) < Math_fround(9.99999971e-10);
  f17 = Math_fround(Math_fround(1.0) / f17);
  f17 = i4 ? Math_fround(1.0) : f17;
  f16 = Math_fround(Math_fround(1.0) / f16);
  f16 = i12 ? Math_fround(1.0) : f16;
  f8 = Math_fround(Math_fround(1.0) / f8);
  f8 = i7 ? Math_fround(1.0) : f8;
  f15 = Math_fround(f15 * f17);
  f14 = Math_fround(f14 * f16);
  f13 = Math_fround(f13 * f8);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 12 >> 2]);
  f18 = Math_fround(f19 * f22);
  f10 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 24 >> 2]);
  f11 = Math_fround(f21 * f10);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 16 >> 2]);
  f9 = Math_fround(f23 * f20);
  f24 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 20 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f21 * f24)) - Math_fround(f23 * f10)) - Math_fround(f25 * f20));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f25 * f22)) - Math_fround(f23 * f24)) - Math_fround(f19 * f20));
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f19 * f24)) - Math_fround(f21 * f22)) - Math_fround(f25 * f10));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f20)) - Math_fround(f19 * f10));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f10 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 28 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 32 >> 2]);
  f10 = Math_fround(f17 * f10);
  f9 = Math_fround(f16 * f9);
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 36 >> 2]));
  HEAPF32[i1 + (i2 * 40 | 0) >> 2] = f15;
  HEAPF32[i1 + (i2 * 40 | 0) + 4 >> 2] = f14;
  HEAPF32[i1 + (i2 * 40 | 0) + 8 >> 2] = f13;
  HEAP32[i1 + (i2 * 40 | 0) + 12 >> 2] = i12 ^ -2147483648;
  HEAP32[i1 + (i2 * 40 | 0) + 16 >> 2] = i4;
  HEAP32[i1 + (i2 * 40 | 0) + 20 >> 2] = i7 ^ -2147483648;
  HEAPF32[i1 + (i2 * 40 | 0) + 24 >> 2] = f11;
  HEAPF32[i1 + (i2 * 40 | 0) + 28 >> 2] = f10;
  HEAPF32[i1 + (i2 * 40 | 0) + 32 >> 2] = f9;
  HEAPF32[i1 + (i2 * 40 | 0) + 36 >> 2] = f8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 i12 = HEAP32[i3 >> 2] | 0;
 i7 = i3 + 4 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = i12;
 i12 = i1 + 4 | 0;
 HEAP32[i12 >> 2] = i7;
 i12 = i1 + 8 | 0;
 HEAP32[i12 >> 2] = i4;
 i12 = i1 + 12 | 0;
 i4 = i3 + 12 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i7 = i3 + 16 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = i3 + 20 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = i3 + 24 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i12 >> 2] = i4;
 i12 = i1 + 16 | 0;
 HEAP32[i12 >> 2] = i7;
 i12 = i1 + 20 | 0;
 HEAP32[i12 >> 2] = i6;
 i12 = i1 + 24 | 0;
 HEAP32[i12 >> 2] = i5;
 i12 = i1 + 28 | 0;
 i5 = i3 + 28 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i3 + 32 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i3 + 36 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i12 >> 2] = i5;
 i12 = i1 + 32 | 0;
 HEAP32[i12 >> 2] = i6;
 i12 = i1 + 36 | 0;
 HEAP32[i12 >> 2] = i7;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 L1 : while (1) {
  i10 = i2;
  i11 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i9 = i1;
    i3 = i10 - i9 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 2:
     {
      i12 = 5;
      break L1;
     }
    case 3:
     {
      i12 = 7;
      break L1;
     }
    case 4:
     {
      i12 = 8;
      break L1;
     }
    case 5:
     {
      i12 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i12 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 248) {
     i12 = 11;
     break L1;
    }
    i7 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + (i3 << 3) | 0, i7, i7 + (i3 << 3) | 0, i11) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i1, i7, i11) | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((_strcmp(i6, i5) | 0) < 0) {
     i4 = i11;
     break;
    } else i4 = i11;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if ((_strcmp(HEAP32[i4 >> 2] | 0, i5) | 0) < 0) {
      i12 = 35;
      break L5;
     }
    }
    i3 = i1 + 8 | 0;
    if ((_strcmp(i6, HEAP32[i11 >> 2] | 0) | 0) >= 0) {
     if ((i3 | 0) == (i11 | 0)) {
      i12 = 52;
      break L1;
     }
     while (1) {
      if ((_strcmp(i6, HEAP32[i3 >> 2] | 0) | 0) < 0) break;
      i3 = i3 + 8 | 0;
      if ((i3 | 0) == (i11 | 0)) {
       i12 = 52;
       break L1;
      }
     }
     i8 = i3;
     i7 = HEAP32[i8 >> 2] | 0;
     i8 = HEAP32[i8 + 4 >> 2] | 0;
     i5 = i11;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i9 = i3;
     HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i9 + 4 >> 2] = i6;
     i9 = i11;
     HEAP32[i9 >> 2] = i7;
     HEAP32[i9 + 4 >> 2] = i8;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i11 | 0)) {
     i12 = 52;
     break L1;
    } else i4 = i11;
    while (1) {
     i6 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i5 = i3 + 8 | 0;
      if ((_strcmp(i6, HEAP32[i3 >> 2] | 0) | 0) < 0) break; else i3 = i5;
     }
     do i4 = i4 + -8 | 0; while ((_strcmp(i6, HEAP32[i4 >> 2] | 0) | 0) < 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i9 = i3;
     i8 = HEAP32[i9 >> 2] | 0;
     i9 = HEAP32[i9 + 4 >> 2] | 0;
     i6 = i4;
     i7 = HEAP32[i6 + 4 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i3 + 4 >> 2] = i7;
     i3 = i4;
     HEAP32[i3 >> 2] = i8;
     HEAP32[i3 + 4 >> 2] = i9;
     i3 = i5;
    }
   }
   if ((i12 | 0) == 35) {
    i12 = 0;
    i6 = i1;
    i5 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i14 = i4;
    i13 = HEAP32[i14 + 4 >> 2] | 0;
    i8 = i1;
    HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i8 + 4 >> 2] = i13;
    i8 = i4;
    HEAP32[i8 >> 2] = i5;
    HEAP32[i8 + 4 >> 2] = i6;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i8 = i7;
    while (1) {
     i7 = HEAP32[i8 >> 2] | 0;
     while (1) {
      i6 = i5 + 8 | 0;
      if ((_strcmp(HEAP32[i5 >> 2] | 0, i7) | 0) < 0) i5 = i6; else break;
     }
     do i4 = i4 + -8 | 0; while ((_strcmp(HEAP32[i4 >> 2] | 0, i7) | 0) >= 0);
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i8;
      break L35;
     }
     i13 = i5;
     i7 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i16 = i4;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     i14 = i5;
     HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i14 + 4 >> 2] = i15;
     i14 = i4;
     HEAP32[i14 >> 2] = i7;
     HEAP32[i14 + 4 >> 2] = i13;
     i8 = (i8 | 0) == (i5 | 0) ? i4 : i8;
     i5 = i6;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i7; while (0);
   if ((i5 | 0) != (i4 | 0)) if ((_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) < 0) {
    i15 = i5;
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = HEAP32[i15 + 4 >> 2] | 0;
    i8 = i4;
    i13 = HEAP32[i8 + 4 >> 2] | 0;
    i16 = i5;
    HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i16 + 4 >> 2] = i13;
    i16 = i4;
    HEAP32[i16 >> 2] = i14;
    HEAP32[i16 + 4 >> 2] = i15;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEbT0_S7_T_(i1, i5) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEbT0_S7_T_(i4, i2) | 0) {
     i12 = 51;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i16 = i5;
   if ((i16 - i9 | 0) >= (i10 - i16 | 0)) {
    i12 = 50;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i1, i5);
   i1 = i5 + 8 | 0;
  }
  if ((i12 | 0) == 50) {
   i12 = 0;
   __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_(i5 + 8 | 0, i2);
   i2 = i5;
   continue;
  } else if ((i12 | 0) == 51) {
   i12 = 0;
   if (i3) {
    i12 = 52;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i12 | 0) == 5) {
  if ((_strcmp(HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) >= 0) return;
  i15 = i1;
  i14 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 4 >> 2] | 0;
  i12 = i11;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i16 = i1;
  HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i16 + 4 >> 2] = i13;
  i16 = i11;
  HEAP32[i16 >> 2] = i14;
  HEAP32[i16 + 4 >> 2] = i15;
  return;
 } else if ((i12 | 0) == 7) {
  __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i11) | 0;
  return;
 } else if ((i12 | 0) == 8) {
  __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i11) | 0;
  return;
 } else if ((i12 | 0) == 9) {
  __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i11) | 0;
  return;
 } else if ((i12 | 0) == 11) {
  i4 = i1 + 16 | 0;
  __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i1, i1 + 8 | 0, i4) | 0;
  i3 = i1 + 24 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = i6;
   if ((_strcmp(i6, HEAP32[i4 >> 2] | 0) | 0) < 0) {
    i8 = HEAP32[i3 + 4 >> 2] | 0;
    i5 = i3;
    while (1) {
     i14 = i4;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i5;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     if ((i4 | 0) == (i1 | 0)) {
      i4 = i1;
      break;
     }
     i5 = i4 + -8 | 0;
     if ((_strcmp(i6, HEAP32[i5 >> 2] | 0) | 0) < 0) {
      i16 = i4;
      i4 = i5;
      i5 = i16;
     } else break;
    }
    HEAP32[i4 >> 2] = i7;
    HEAP32[i4 + 4 >> 2] = i8;
   }
   i4 = i3 + 8 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i16 = i3;
    i3 = i4;
    i4 = i16;
   }
  }
  return;
 } else if ((i12 | 0) == 52) return;
}

function __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i6, i10, i12) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i9 = i13;
 i7 = i6 + 36 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i9 >> 2] = i1;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i11 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i1 = HEAP32[i3 + 28 >> 2] | 0;
    i4 = HEAP32[i3 + 32 >> 2] | 0;
    i5 = i1 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i3, i9);
    i5 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i3 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i5 = (i5 | 0) == -1 ? i1 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i1 + (i5 << 3) | 0;
    i3 = i4;
    i1 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i5 | 0) == (i1 + (i4 << 3) | 0)) i11 = 7; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i11 = 9;
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  if (!i3) i11 = 48; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i3, i9);
    i1 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i4 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i4 + (i1 << 3) | 0;
    i4 = HEAP32[i6 + 28 >> 2] | 0;
    i5 = HEAP32[i6 + 32 >> 2] | 0;
    i3 = i6;
   }
   if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i11 = 48; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 50;
   }
  }
  if ((i11 | 0) == 48) i11 = 50;
  if ((i11 | 0) == 50) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  if (!i3) i11 = 56; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i10 = HEAP32[i3 + 28 >> 2] | 0;
    i4 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i10 + (i4 << 3) | 0;
    i3 = i10;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i3, i9);
    i1 = HEAP32[i8 >> 2] | 0;
    i10 = HEAP32[i3 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i10 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i10 + (i1 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 56; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 58;
   }
  }
  if ((i11 | 0) == 56) i11 = 58;
  if ((i11 | 0) == 58) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i1 + 36 >> 2];
  STACKTOP = i13;
  return;
 } while (0);
 if ((HEAP32[i6 + 72 >> 2] | 0) > 0) {
  i1 = HEAP32[(HEAP32[HEAP32[i6 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
  if (!i1) i11 = 14; else {
   i1 = HEAP32[i1 + 148 >> 2] | 0;
   if (!i1) i11 = 14; else i11 = 20;
  }
 } else i11 = 14;
 L45 : do if ((i11 | 0) == 14) {
  i3 = i6 + 28 | 0;
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 67088 | 0) | 0;
  if (!i1) {
   i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
   if (i1 | 0) {
    while (1) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     if (i3 | 0) {
      i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 67088 | 0) | 0;
      if (i3 | 0) break;
     }
     i1 = HEAP32[i1 + 100 >> 2] | 0;
     if (!i1) break L45;
    }
    i1 = i3;
    i11 = 20;
   }
  } else i11 = 20;
 } while (0);
 do if ((i11 | 0) == 20) if (i1 | 0) {
  i5 = __ZN11Rigidbody2D11GetMaterialEv(i1) | 0;
  if (i5 | 0) {
   HEAP32[i9 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 27; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i7 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 27; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 29;
    }
   }
   if ((i11 | 0) == 27) i11 = 29;
   if ((i11 | 0) == 29) {
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) break;
   }
   HEAP32[i10 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i1 + 36 >> 2];
   STACKTOP = i13;
   return;
  }
 } while (0);
 i5 = (__Z20GetPhysics2DSettingsv() | 0) + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) i11 = 41; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 37; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i3 = HEAP32[i8 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 37; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 39;
   }
  }
  if ((i11 | 0) == 37) i11 = 39;
  if ((i11 | 0) == 39) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   if (!i1) {
    i11 = 41;
    break;
   }
  }
  HEAP32[i10 >> 2] = HEAP32[i1 + 32 >> 2];
  f2 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 } while (0);
 if ((i11 | 0) == 41) {
  HEAPF32[i10 >> 2] = Math_fround(.400000006);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i12 >> 2] = f2;
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i6 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i2 = i5;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i5 >> 2] = i1;
 } else {
  i2 = i5;
  i3 = i6 + 4 | 0;
 }
 i2 = i1 + i2 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 16;
 HEAP32[i7 + 4 >> 2] = i2 + 12;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i6 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = i1;
  i2 = i2 | 0 ? i2 - i4 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i4;
 } else i3 = i6 + 4 | 0;
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = i5 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = i6 + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
 } else i4 = i6 + 4 | 0;
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 16;
 HEAP32[i7 + 4 >> 2] = i5 + 12;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = i5 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 396, 4) | 0;
  __ZN7mecanim5human5HumanC2Ev(i2);
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
 }
 __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i1 | 0, i6);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 28;
 HEAP32[i7 + 4 >> 2] = i5 + 24;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 36;
 HEAP32[i7 + 4 >> 2] = i5 + 32;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i5 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i6, i5 + 44 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i5 + 56 | 0, i6);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i6, i5 + 72 | 0, gb + 1085935 | 0, 0);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
 }
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 16;
 HEAP32[i7 + 4 >> 2] = i2 + 12;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i1 = i5 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
  i1 = i2 + i1 | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  i2 = i7 + 4 | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7 + 8 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i6, i7, 0);
  i2 = i5 + 96 | 0;
  i3 = i5 + 92 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = i3;
  i5 = i7 + 8 | 0;
  HEAP32[i5 >> 2] = i4;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i6, i7, 0);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i8;
  return;
 } else {
  i1 = i2 + i1 | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  i2 = i7 + 4 | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7 + 8 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i6, i7, 0);
  i2 = i5 + 96 | 0;
  i3 = i5 + 92 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = i3;
  i5 = i7 + 8 | 0;
  HEAP32[i5 >> 2] = i4;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i6, i7, 0);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i8;
  return;
 }
}

function __Z21CalculateGlobalMatrix23TransformAccessReadOnly(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i19 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i30 = HEAP32[i1 + 4 >> 2] | 0;
 f36 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 28 >> 2]);
 f34 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 36 >> 2]);
 f33 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 12 >> 2]);
 f32 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i19 + (i30 * 40 | 0) + 20 >> 2]);
 f35 = Math_fround(f33 * Math_fround(-2.0));
 f14 = Math_fround(f33 * Math_fround(2.0));
 f16 = Math_fround(f33 * f35);
 f13 = Math_fround(f4 * Math_fround(-2.0));
 f8 = Math_fround(f4 * Math_fround(2.0));
 f7 = Math_fround(f4 * f13);
 f9 = Math_fround(f12 * Math_fround(2.0));
 f31 = Math_fround(f12 * Math_fround(-2.0));
 f5 = Math_fround(f12 * f31);
 f11 = Math_fround(f36 * Math_fround(Math_fround(f16 + f7) + Math_fround(1.0)));
 f10 = Math_fround(f36 * Math_fround(Math_fround(Math_fround(f12 * f14) + Math_fround(f32 * f8)) + Math_fround(0.0)));
 f12 = Math_fround(f36 * Math_fround(Math_fround(Math_fround(f35 * f32) + Math_fround(f12 * f8)) + Math_fround(0.0)));
 f13 = Math_fround(f34 * Math_fround(Math_fround(Math_fround(f33 * f9) + Math_fround(f32 * f13)) + Math_fround(0.0)));
 f7 = Math_fround(f34 * Math_fround(Math_fround(f5 + f7) + Math_fround(1.0)));
 f8 = Math_fround(f34 * Math_fround(Math_fround(Math_fround(f32 * f9) + Math_fround(f33 * f8)) + Math_fround(0.0)));
 f9 = Math_fround(f15 * Math_fround(Math_fround(Math_fround(f14 * f32) + Math_fround(f9 * f4)) + Math_fround(0.0)));
 f4 = Math_fround(f15 * Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(f14 * f4)) + Math_fround(0.0)));
 f5 = Math_fround(f15 * Math_fround(Math_fround(f16 + f5) + Math_fround(1.0)));
 i6 = HEAP32[i19 + (i30 * 40 | 0) >> 2] | 0;
 i2 = HEAP32[i19 + (i30 * 40 | 0) + 4 >> 2] | 0;
 i3 = HEAP32[i19 + (i30 * 40 | 0) + 8 >> 2] | 0;
 HEAPF32[i18 >> 2] = f11;
 i20 = i18 + 4 | 0;
 HEAPF32[i20 >> 2] = f10;
 i21 = i18 + 8 | 0;
 HEAPF32[i21 >> 2] = f12;
 i22 = i18 + 12 | 0;
 HEAPF32[i22 >> 2] = f13;
 i23 = i18 + 16 | 0;
 HEAPF32[i23 >> 2] = f7;
 i24 = i18 + 20 | 0;
 HEAPF32[i24 >> 2] = f8;
 i25 = i18 + 24 | 0;
 HEAPF32[i25 >> 2] = f9;
 i26 = i18 + 28 | 0;
 HEAPF32[i26 >> 2] = f4;
 i27 = i18 + 32 | 0;
 HEAPF32[i27 >> 2] = f5;
 HEAP32[i18 + 36 >> 2] = i6;
 i28 = i18 + 40 | 0;
 HEAP32[i28 >> 2] = i2;
 i29 = i18 + 44 | 0;
 HEAP32[i29 >> 2] = i3;
 i17 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 i1 = HEAP32[i17 + (i30 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 f14 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i2 = i18 + 36 | 0;
 f16 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do {
  f48 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 28 >> 2]);
  f46 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 32 >> 2]);
  f42 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 36 >> 2]);
  f45 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 16 >> 2]);
  f32 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 12 >> 2]);
  f44 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 24 >> 2]);
  f31 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 20 >> 2]);
  f47 = Math_fround(f45 * Math_fround(-2.0));
  f41 = Math_fround(f45 * Math_fround(2.0));
  f33 = Math_fround(f45 * f47);
  f39 = Math_fround(f31 * Math_fround(-2.0));
  f34 = Math_fround(f31 * Math_fround(2.0));
  f37 = Math_fround(f31 * f39);
  f35 = Math_fround(f32 * Math_fround(2.0));
  f43 = Math_fround(f32 * Math_fround(-2.0));
  f36 = Math_fround(f32 * f43);
  f40 = Math_fround(f48 * Math_fround(Math_fround(f33 + f37) + Math_fround(1.0)));
  f38 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f32 * f41) + Math_fround(f44 * f34)) + Math_fround(0.0)));
  f32 = Math_fround(f48 * Math_fround(Math_fround(Math_fround(f47 * f44) + Math_fround(f32 * f34)) + Math_fround(0.0)));
  f39 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f45 * f35) + Math_fround(f44 * f39)) + Math_fround(0.0)));
  f37 = Math_fround(f46 * Math_fround(Math_fround(f36 + f37) + Math_fround(1.0)));
  f34 = Math_fround(f46 * Math_fround(Math_fround(Math_fround(f44 * f35) + Math_fround(f45 * f34)) + Math_fround(0.0)));
  f35 = Math_fround(f42 * Math_fround(Math_fround(Math_fround(f41 * f44) + Math_fround(f35 * f31)) + Math_fround(0.0)));
  f31 = Math_fround(f42 * Math_fround(Math_fround(Math_fround(f44 * f43) + Math_fround(f41 * f31)) + Math_fround(0.0)));
  f36 = Math_fround(f42 * Math_fround(Math_fround(f33 + f36) + Math_fround(1.0)));
  f33 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) >> 2]);
  f42 = Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 4 >> 2]);
  f41 = f16;
  f16 = Math_fround(f33 + Math_fround(Math_fround(f16 * f40) + Math_fround(Math_fround(f15 * f39) + Math_fround(f35 * f14))));
  f33 = f15;
  f15 = Math_fround(f42 + Math_fround(Math_fround(f41 * f38) + Math_fround(Math_fround(f15 * f37) + Math_fround(f31 * f14))));
  f14 = Math_fround(Math_fround(HEAPF32[i19 + (i1 * 40 | 0) + 8 >> 2]) + Math_fround(Math_fround(f41 * f32) + Math_fround(Math_fround(f33 * f34) + Math_fround(f36 * f14))));
  f33 = f11;
  f11 = Math_fround(Math_fround(f40 * f11) + Math_fround(Math_fround(f39 * f10) + Math_fround(f35 * f12)));
  f41 = f10;
  f10 = Math_fround(Math_fround(f38 * f33) + Math_fround(Math_fround(f37 * f10) + Math_fround(f31 * f12)));
  f12 = Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f34 * f41) + Math_fround(f36 * f12)));
  f41 = f13;
  f13 = Math_fround(Math_fround(f40 * f13) + Math_fround(Math_fround(f39 * f7) + Math_fround(f35 * f8)));
  f33 = f7;
  f7 = Math_fround(Math_fround(f38 * f41) + Math_fround(Math_fround(f37 * f7) + Math_fround(f31 * f8)));
  f8 = Math_fround(Math_fround(f32 * f41) + Math_fround(Math_fround(f34 * f33) + Math_fround(f36 * f8)));
  f33 = f9;
  f9 = Math_fround(Math_fround(f40 * f9) + Math_fround(Math_fround(f39 * f4) + Math_fround(f35 * f5)));
  f35 = f4;
  f4 = Math_fround(Math_fround(f38 * f33) + Math_fround(Math_fround(f37 * f4) + Math_fround(f31 * f5)));
  f5 = Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f34 * f35) + Math_fround(f36 * f5)));
  i1 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i2 >> 2] = f16;
 HEAPF32[i28 >> 2] = f15;
 HEAPF32[i29 >> 2] = f14;
 HEAPF32[i18 >> 2] = f11;
 HEAPF32[i20 >> 2] = f10;
 HEAPF32[i21 >> 2] = f12;
 HEAPF32[i22 >> 2] = f13;
 HEAPF32[i23 >> 2] = f7;
 HEAPF32[i24 >> 2] = f8;
 HEAPF32[i25 >> 2] = f9;
 HEAPF32[i26 >> 2] = f4;
 HEAPF32[i27 >> 2] = f5;
 return;
}

function __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 28 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 44 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 52 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 68 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 60 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 76 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 84 | 0, i7);
 i3 = i6 + 92 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 96 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 108 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 112 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 124 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 128 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i6 + 132 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i6 + 140 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 148 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN7Terrain8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i6 = i12;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 HEAP32[i7 >> 2] = 0;
 __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i9);
 __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i8, i7);
 i1 = i8 + 64 | 0;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i9 + 24 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 80 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 52 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 88 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 89 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 90 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i3 = i8 + 92 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 i5 = i8 + 96 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i7, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i2 = i8 + 100 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i9);
 i1 = i8 + 108 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i8 + 112 >> 2] | 0;
  if (i1 | 0) {
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i7 >> 2] = (i6 | 0) == 3 ? i2 : 0;
   __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i1, i7, (i6 | 0) == 0 ? gb + 184364 | 0 : (i6 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0);
  }
 }
 i5 = i8 + 152 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i5, 2);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP16[i5 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i10 >> 2] = i2;
  i4 = i3;
 }
 i1 = i5 + 2 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 2); else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i10 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i8 + 120 | 0, gb + 931957 | 0, 8388609);
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i8 + 136 | 0, gb + 931980 | 0, 8388609);
 i1 = i8 + 188 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i11 = i8 + 156 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i11, gb + 932036 | 0, 8388609);
  i11 = i8 + 172 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i11, gb + 932050 | 0, 8388609);
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i11 = i8 + 156 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i11, gb + 932036 | 0, 8388609);
  i11 = i8 + 172 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i11, gb + 932050 | 0, 8388609);
  STACKTOP = i12;
  return;
 }
}

function _Line_To(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 100 | 0;
 L1 : do switch (HEAP32[i9 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP32[i10 + 72 >> 2] | 0;
   if ((i1 | 0) < (i12 | 0)) {
    i3 = HEAP32[i10 + 4 >> 2] | 0;
    i3 = ((i1 + -1 + i3 & 0 - i3) - i1 | 0) < (HEAP32[i10 + 8 >> 2] | 0);
    i1 = i10 + 92 | 0;
    i2 = i10 + 40 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     i8 = HEAP32[i2 >> 2] | 0;
     HEAP32[i10 + 88 >> 2] = i8;
     HEAP32[i1 >> 2] = i8;
     i1 = i8 + 32 | 0;
     HEAP32[i2 >> 2] = i1;
    } else i1 = HEAP32[i2 >> 2] | 0;
    if (i1 >>> 0 >= (HEAP32[i10 + 36 >> 2] | 0) >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    i2 = HEAP32[i10 + 88 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP16[i2 + 12 >> 1] = HEAPU8[i10 + 176 >> 0] | (i3 ? 8 : 40);
    i1 = i10 + 96 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = 1;
    HEAP8[i10 + 86 >> 0] = 1;
    HEAP8[i10 + 87 >> 0] = 0;
    i3 = 61;
    break L1;
   }
   if ((i1 | 0) > (i12 | 0)) {
    i3 = ((HEAP32[i10 + 4 >> 2] | 0) + -1 & i1 | 0) < (HEAP32[i10 + 8 >> 2] | 0);
    i1 = i10 + 92 | 0;
    i2 = i10 + 40 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     i8 = HEAP32[i2 >> 2] | 0;
     HEAP32[i10 + 88 >> 2] = i8;
     HEAP32[i1 >> 2] = i8;
     i1 = i8 + 32 | 0;
     HEAP32[i2 >> 2] = i1;
    } else i1 = HEAP32[i2 >> 2] | 0;
    if (i1 >>> 0 >= (HEAP32[i10 + 36 >> 2] | 0) >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    i2 = HEAP32[i10 + 88 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    i1 = HEAP8[i10 + 176 >> 0] | 0;
    if (i3) i1 = i1 & 255; else i1 = (i1 & 255 | 16) & 65535;
    HEAP16[i2 + 12 >> 1] = i1;
    i1 = i10 + 96 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = 2;
    HEAP8[i10 + 86 >> 0] = 1;
    HEAP8[i10 + 87 >> 0] = 0;
    i3 = 62;
   } else i3 = 60;
   break;
  }
 case 1:
  {
   i1 = HEAP32[i10 + 72 >> 2] | 0;
   if ((i1 | 0) > (i12 | 0)) {
    i8 = ((HEAP32[i10 + 4 >> 2] | 0) + -1 & i1 | 0) < (HEAP32[i10 + 8 >> 2] | 0);
    i6 = i10 + 40 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i7 = i10 + 88 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i2 = i4 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
    i1 = i4;
    if ((i2 | 0) < 0) {
     HEAP32[i10 + 44 >> 2] = 99;
     i12 = 1;
     return i12 | 0;
    }
    if (!i2) i3 = i5; else {
     HEAP32[i5 + 16 >> 2] = i2 >> 2;
     do if (!i8) {
      i2 = i5 + 12 | 0;
      i3 = HEAPU16[i2 >> 1] | 0;
      if (!(i3 & 8)) {
       HEAP16[i2 >> 1] = i3 | 32;
       break;
      } else {
       HEAP16[i2 >> 1] = i3 | 16;
       break;
      }
     } while (0);
     HEAP32[i7 >> 2] = i4;
     i1 = i1 + 32 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i4;
     HEAP32[i3 + 16 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = i1;
     HEAP32[i5 + 28 >> 2] = i4;
     i5 = i10 + 84 | 0;
     HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
    }
    i4 = HEAP32[i10 + 36 >> 2] | 0;
    if (i1 >>> 0 >= i4 >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    i5 = i10 + 87 | 0;
    HEAP8[i5 >> 0] = 0;
    i2 = i10 + 92 | 0;
    if (!(HEAP32[i2 >> 2] | 0)) {
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i2 >> 2] = i3;
     i1 = i3 + 32 | 0;
     HEAP32[i6 >> 2] = i1;
     i2 = i3;
    } else i2 = i3;
    if (i1 >>> 0 >= i4 >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    i1 = HEAP8[i10 + 176 >> 0] | 0;
    if (i8) i1 = i1 & 255; else i1 = (i1 & 255 | 16) & 65535;
    HEAP16[i2 + 12 >> 1] = i1;
    i1 = i10 + 96 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = 2;
    HEAP8[i10 + 86 >> 0] = 1;
    HEAP8[i5 >> 0] = 0;
    i3 = 62;
   } else i3 = 61;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i10 + 72 >> 2] | 0;
   if ((i1 | 0) < (i12 | 0)) {
    i8 = HEAP32[i10 + 4 >> 2] | 0;
    i8 = ((i1 + -1 + i8 & 0 - i8) - i1 | 0) < (HEAP32[i10 + 8 >> 2] | 0);
    i6 = i10 + 40 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i7 = i10 + 88 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i3 = i2 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
    i1 = i2;
    if ((i3 | 0) < 0) {
     HEAP32[i10 + 44 >> 2] = 99;
     i12 = 1;
     return i12 | 0;
    }
    if (!i3) i2 = i5; else {
     HEAP32[i5 + 16 >> 2] = i3 >> 2;
     do if (!i8) {
      i3 = i5 + 12 | 0;
      i4 = HEAPU16[i3 >> 1] | 0;
      if (!(i4 & 8)) {
       HEAP16[i3 >> 1] = i4 | 32;
       break;
      } else {
       HEAP16[i3 >> 1] = i4 | 16;
       break;
      }
     } while (0);
     HEAP32[i7 >> 2] = i2;
     i1 = i1 + 32 | 0;
     HEAP32[i6 >> 2] = i1;
     i4 = i2;
     HEAP32[i4 + 16 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = i1;
     HEAP32[i5 + 28 >> 2] = i2;
     i2 = i10 + 84 | 0;
     HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
     i2 = i4;
    }
    i4 = HEAP32[i10 + 36 >> 2] | 0;
    if (i1 >>> 0 >= i4 >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    i5 = i10 + 87 | 0;
    HEAP8[i5 >> 0] = 0;
    i3 = i10 + 92 | 0;
    if (!(HEAP32[i3 >> 2] | 0)) {
     i2 = HEAP32[i6 >> 2] | 0;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i3 >> 2] = i2;
     i1 = i2 + 32 | 0;
     HEAP32[i6 >> 2] = i1;
    }
    if (i1 >>> 0 >= i4 >>> 0) {
     HEAP32[i10 + 44 >> 2] = 98;
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP16[i2 + 12 >> 1] = HEAPU8[i10 + 176 >> 0] | (i8 ? 8 : 40);
    i1 = i10 + 96 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = 1;
    HEAP8[i10 + 86 >> 0] = 1;
    HEAP8[i5 >> 0] = 0;
    i3 = 61;
   } else i3 = 62;
   break;
  }
 default:
  i3 = 60;
 } while (0);
 if ((i3 | 0) == 60) {
  i2 = i10 + 72 | 0;
  i1 = i10 + 68 | 0;
 } else if ((i3 | 0) == 61) {
  i1 = i10 + 68 | 0;
  i2 = i10 + 72 | 0;
  if ((_Line_Up(i10, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i11, i12, HEAP32[i10 + 76 >> 2] | 0, HEAP32[i10 + 80 >> 2] | 0) | 0) << 24 >> 24) {
   i12 = 1;
   return i12 | 0;
  }
 } else if ((i3 | 0) == 62) {
  i1 = i10 + 68 | 0;
  i2 = i10 + 72 | 0;
  i3 = i10 + 86 | 0;
  i9 = HEAP8[i3 >> 0] | 0;
  i4 = _Line_Up(i10, HEAP32[i1 >> 2] | 0, 0 - (HEAP32[i2 >> 2] | 0) | 0, i11, 0 - i12 | 0, 0 - (HEAP32[i10 + 80 >> 2] | 0) | 0, 0 - (HEAP32[i10 + 76 >> 2] | 0) | 0) | 0;
  if (i9 << 24 >> 24) if (!(HEAP8[i3 >> 0] | 0)) {
   i10 = (HEAP32[i10 + 88 >> 2] | 0) + 20 | 0;
   HEAP32[i10 >> 2] = 0 - (HEAP32[i10 >> 2] | 0);
  }
  if (i4 << 24 >> 24) {
   i12 = 1;
   return i12 | 0;
  }
 }
 HEAP32[i1 >> 2] = i11;
 HEAP32[i2 >> 2] = i12;
 i12 = 0;
 return i12 | 0;
}

function __ZN28LightProbeProxyVolumeManager17UpdateBoundingBoxER21LightProbeProxyVolume(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 88 | 0;
 i2 = i6;
 i3 = i6 + 24 | 0;
 __ZN21LightProbeProxyVolume27ValidateBoundingBoxSettingsEv(i9);
 i4 = i9 + 36 | 0;
 switch (HEAP32[i4 >> 2] | 0) {
 case 0:
  {
   HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
   f15 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
   f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   i5 = i3 + 12 | 0;
   HEAPF32[i5 >> 2] = f15;
   i7 = i3 + 16 | 0;
   HEAPF32[i7 >> 2] = f18;
   i8 = i3 + 20 | 0;
   HEAPF32[i8 >> 2] = f12;
   i19 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
   __ZNK9Transform21GetWorldToLocalMatrixEv(i1, i19);
   __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB(i1, i19, i3);
   f12 = Math_fround(HEAPF32[i3 >> 2]);
   f18 = Math_fround(HEAPF32[i5 >> 2]);
   f15 = Math_fround(f12 + f18);
   f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i7 >> 2]);
   f14 = Math_fround(f11 + f17);
   f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f16 = Math_fround(HEAPF32[i8 >> 2]);
   f14 = Math_fround(f14 * Math_fround(.5));
   f13 = Math_fround(Math_fround(f10 + f16) * Math_fround(.5));
   f12 = Math_fround(Math_fround(f18 - f12) * Math_fround(.5));
   f11 = Math_fround(Math_fround(f17 - f11) * Math_fround(.5));
   f10 = Math_fround(Math_fround(f16 - f10) * Math_fround(.5));
   HEAPF32[i2 >> 2] = Math_fround(f15 * Math_fround(.5));
   HEAPF32[i2 + 4 >> 2] = f14;
   HEAPF32[i2 + 8 >> 2] = f13;
   HEAPF32[i2 + 12 >> 2] = f12;
   HEAPF32[i2 + 16 >> 2] = f11;
   HEAPF32[i2 + 20 >> 2] = f10;
   break;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
   f13 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
   f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f16 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   i7 = i1 + 12 | 0;
   HEAPF32[i7 >> 2] = f13;
   i8 = i1 + 16 | 0;
   HEAPF32[i8 >> 2] = f10;
   i19 = i1 + 20 | 0;
   HEAPF32[i19 >> 2] = f16;
   __ZN26LightProbeProxyVolumeUtilsL28ComputeGlobalAABBOnHierarchyER9TransformR10MinMaxAABB(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i1);
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f10 = Math_fround(HEAPF32[i7 >> 2]);
   f13 = Math_fround(f16 + f10);
   f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i8 >> 2]);
   f14 = Math_fround(f17 + f11);
   f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i19 >> 2]);
   f14 = Math_fround(f14 * Math_fround(.5));
   f15 = Math_fround(Math_fround(f18 + f12) * Math_fround(.5));
   f16 = Math_fround(Math_fround(f10 - f16) * Math_fround(.5));
   f17 = Math_fround(Math_fround(f11 - f17) * Math_fround(.5));
   f18 = Math_fround(Math_fround(f12 - f18) * Math_fround(.5));
   HEAPF32[i2 >> 2] = Math_fround(f13 * Math_fround(.5));
   HEAPF32[i2 + 4 >> 2] = f14;
   HEAPF32[i2 + 8 >> 2] = f15;
   HEAPF32[i2 + 12 >> 2] = f16;
   HEAPF32[i2 + 16 >> 2] = f17;
   HEAPF32[i2 + 20 >> 2] = f18;
   break;
  }
 case 2:
  {
   f16 = Math_fround(Math_fround(HEAPF32[i9 + 64 >> 2]) * Math_fround(.5));
   f17 = Math_fround(Math_fround(HEAPF32[i9 + 68 >> 2]) * Math_fround(.5));
   f18 = Math_fround(Math_fround(HEAPF32[i9 + 72 >> 2]) * Math_fround(.5));
   HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAPF32[i2 + 12 >> 2] = f16;
   HEAPF32[i2 + 16 >> 2] = f17;
   HEAPF32[i2 + 20 >> 2] = f18;
   break;
  }
 default:
  {}
 }
 i19 = i9 + 92 | 0;
 HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 switch (HEAP32[i4 >> 2] | 0) {
 case 2:
 case 0:
  {
   __ZNK9Transform21GetLocalToWorldMatrixEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   i5 = i3;
   i7 = i1;
   i8 = i5 + 64 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    i5 = i5 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i5 | 0) < (i8 | 0));
   if ((HEAP32[i4 >> 2] | 0) == 2) {
    __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i1, i9 + 76 | 0) | 0;
    __ZN10Matrix4x4fmLERKS_(i3, i1) | 0;
   }
   break;
  }
 default:
  {
   i5 = i3;
   i7 = gb + 1162292 | 0;
   i8 = i5 + 64 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    i5 = i5 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i5 | 0) < (i8 | 0));
  }
 }
 __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i2, i3, i1);
 if (HEAP32[i9 + 44 >> 2] | 0) {
  i19 = i9 + 116 | 0;
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i19 = i9 + 128 | 0;
  i9 = i1 + 12 | 0;
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
 f18 = Math_fround(HEAPF32[i9 + 116 >> 2]);
 if (!(f18 != Math_fround(HEAPF32[i1 >> 2]))) {
  f18 = Math_fround(HEAPF32[i9 + 120 >> 2]);
  if (!(f18 != Math_fround(HEAPF32[i1 + 4 >> 2]))) {
   f18 = Math_fround(HEAPF32[i9 + 124 >> 2]);
   if (!(f18 != Math_fround(HEAPF32[i1 + 8 >> 2]))) {
    f18 = Math_fround(HEAPF32[i9 + 128 >> 2]);
    if (!(f18 != Math_fround(HEAPF32[i1 + 12 >> 2]))) {
     f18 = Math_fround(HEAPF32[i9 + 132 >> 2]);
     if (!(f18 != Math_fround(HEAPF32[i1 + 16 >> 2]))) {
      f18 = Math_fround(HEAPF32[i9 + 136 >> 2]);
      if (!(f18 != Math_fround(HEAPF32[i1 + 20 >> 2]))) {
       i19 = i9 + 116 | 0;
       HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
       HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
       HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
       i19 = i9 + 128 | 0;
       i9 = i1 + 12 | 0;
       HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       STACKTOP = i6;
       return;
      }
     }
    }
   }
  }
 }
 HEAP8[i9 + 154 >> 0] = 1;
 i19 = i9 + 116 | 0;
 HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i19 = i9 + 128 | 0;
 i9 = i1 + 12 | 0;
 HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i6;
 return;
}

function __Z23CullDirectionalCascadesRNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEEEPK17ShadowCascadeInfoiRK10Matrix4x4fRK8Vector3fRK13ShadowJobData16ShadowProjection(i36, i37, i38, i32, i27, i1, i30) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i39 + 152 | 0;
 i33 = i39 + 104 | 0;
 i28 = i39 + 96 | 0;
 i29 = i39;
 i6 = (i38 | 0) == 1;
 if (i6 & (i30 | 0) == 0) {
  STACKTOP = i39;
  return;
 }
 if ((HEAP16[gb + 1112900 + 6 >> 1] | 0) > -1) {
  HEAP32[i33 >> 2] = 0;
  HEAP32[i34 >> 2] = HEAP32[i33 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112900 | 0, i34);
  i35 = gb + 1112900 | 0;
 } else i35 = 0;
 i31 = (i38 | 0) > 0;
 if (i31) {
  i10 = (i30 | 0) == 1;
  i11 = i32 + 4 | 0;
  i12 = i32 + 8 | 0;
  i13 = i32 + 16 | 0;
  i14 = i32 + 20 | 0;
  i15 = i32 + 24 | 0;
  i16 = i28 + 4 | 0;
  i17 = i28 + 5 | 0;
  i18 = i1 + 660 | 0;
  i19 = i1 + 792 | 0;
  i20 = i29 + 76 | 0;
  i21 = i1 + 780 | 0;
  i22 = i29 + 92 | 0;
  i23 = i1 + 784 | 0;
  i24 = i1 + 788 | 0;
  i25 = i1 + 549 | 0;
  i26 = i1 + 64 | 0;
  i2 = i1 + 516 | 0;
  i1 = 0;
  do {
   do if (HEAP8[i37 + (i1 * 364 | 0) >> 0] | 0) {
    if (i10) {
     f9 = Math_fround(HEAPF32[i32 >> 2]);
     f7 = Math_fround(HEAPF32[i11 >> 2]);
     f41 = Math_fround(HEAPF32[i12 >> 2]);
     f40 = Math_fround(HEAPF32[i37 + (i1 * 364 | 0) + 324 >> 2]);
     f9 = Math_fround(f9 * f40);
     f8 = Math_fround(HEAPF32[i37 + (i1 * 364 | 0) + 328 >> 2]);
     f7 = Math_fround(f9 + Math_fround(f7 * f8));
     f9 = Math_fround(HEAPF32[i37 + (i1 * 364 | 0) + 332 >> 2]);
     HEAPF32[i33 + (i1 * 12 | 0) >> 2] = Math_fround(f7 + Math_fround(f41 * f9));
     f41 = Math_fround(HEAPF32[i13 >> 2]);
     f7 = Math_fround(HEAPF32[i14 >> 2]);
     HEAPF32[i33 + (i1 * 12 | 0) + 4 >> 2] = Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(f7 * f8)) + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f9));
     HEAP32[i33 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i37 + (i1 * 364 | 0) + 336 >> 2];
    }
    if (i6) {
     HEAP32[i34 + (i1 * 164 | 0) + 160 >> 2] = 0;
     break;
    } else {
     HEAP32[i28 >> 2] = 16843009;
     HEAP8[i16 >> 0] = (i1 | 0) == 0 & 1;
     HEAP8[i17 >> 0] = (i1 + 1 | 0) == (i38 | 0) & 1;
     i3 = i29;
     i4 = i18;
     i5 = i3 + 96 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
      i3 = i3 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i3 | 0) < (i5 | 0));
     f40 = Math_fround(HEAPF32[i37 + (i1 * 364 | 0) + 348 >> 2]);
     f41 = Math_fround(f40 - Math_fround(HEAPF32[i19 >> 2]));
     HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f41);
     f41 = Math_fround(HEAPF32[i37 + (i1 * 364 | 0) + 352 >> 2]);
     f9 = Math_fround(f41 - Math_fround(HEAPF32[i21 >> 2]));
     HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f9);
     f40 = Math_fround(f40 / Math_fround(HEAPF32[i23 >> 2]));
     f41 = Math_fround(f41 / Math_fround(HEAPF32[i24 >> 2]));
     __Z25CalculateShadowCasterCullbPK5PlaneRK10Matrix4x4fRK8Vector3fff9LightTypeS7_R16ShadowCasterCullPKb((HEAP8[i25 >> 0] | 0) != 0, i29, i26, i2, f40, f41, 1, i27, i34 + (i1 * 164 | 0) | 0, i28);
     break;
    }
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i38 | 0));
  if (i31) {
   i1 = 0;
   i2 = 0;
   do {
    i1 = i1 << 1 | 1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i38 | 0));
   i16 = i1;
  } else i16 = 0;
 } else i16 = 0;
 i2 = HEAP32[i36 >> 2] | 0;
 i29 = (HEAP32[i36 + 4 >> 2] | 0) - i2 | 0;
 i17 = (i29 | 0) / 24 | 0;
 L24 : do if ((i29 | 0) > 0) {
  i13 = i32 + 4 | 0;
  i14 = i32 + 8 | 0;
  i15 = i32 + 16 | 0;
  i11 = i32 + 20 | 0;
  i12 = i32 + 24 | 0;
  i6 = (i38 | 0) > 1;
  if ((i30 | 0) != 1) {
   i1 = 0;
   while (1) {
    i5 = HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] | 0;
    i4 = i2 + (i1 * 24 | 0) + 12 | 0;
    HEAP32[i4 >> 2] = i16;
    if (i6) {
     i2 = 0;
     i3 = 1;
     while (1) {
      if (HEAP8[i37 + (i2 * 364 | 0) >> 0] | 0) if (HEAP32[i4 >> 2] & i3 | 0) if (!(__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i5, i34 + (i2 * 164 | 0) | 0, HEAP32[i34 + (i2 * 164 | 0) + 160 >> 2] | 0) | 0)) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i3;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i38 | 0)) break; else i3 = i3 << 1;
     }
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i17 | 0)) break L24;
    i2 = HEAP32[i36 >> 2] | 0;
   }
  }
  i10 = (i38 | 0) < 1 | i6 ^ 1;
  i1 = 0;
  while (1) {
   i6 = HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] | 0;
   i5 = i2 + (i1 * 24 | 0) + 12 | 0;
   HEAP32[i5 >> 2] = i16;
   f7 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f7 = Math_fround(f7 * f7);
   f9 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   f9 = Math_fround(f7 + Math_fround(f9 * f9));
   f7 = Math_fround(HEAPF32[i6 + 20 >> 2]);
   f7 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f7 * f7))));
   f9 = Math_fround(HEAPF32[i32 >> 2]);
   f42 = Math_fround(HEAPF32[i13 >> 2]);
   f8 = Math_fround(HEAPF32[i14 >> 2]);
   f43 = Math_fround(HEAPF32[i6 >> 2]);
   f9 = Math_fround(f9 * f43);
   f40 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f42 = Math_fround(f9 + Math_fround(f42 * f40));
   f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f8 = Math_fround(f42 + Math_fround(f8 * f9));
   f42 = Math_fround(HEAPF32[i15 >> 2]);
   f41 = Math_fround(HEAPF32[i11 >> 2]);
   f9 = Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f40 * f41)) + Math_fround(f9 * Math_fround(HEAPF32[i12 >> 2])));
   if (i31) {
    i3 = 0;
    i4 = 1;
    i2 = i16;
    while (1) {
     if (HEAP8[i37 + (i3 * 364 | 0) >> 0] | 0) {
      f43 = Math_fround(f8 - Math_fround(HEAPF32[i33 + (i3 * 12 | 0) >> 2]));
      f42 = Math_fround(f9 - Math_fround(HEAPF32[i33 + (i3 * 12 | 0) + 4 >> 2]));
      f42 = Math_fround(Math_fround(f43 * f43) + Math_fround(f42 * f42));
      f43 = Math_fround(f7 + Math_fround(HEAPF32[i33 + (i3 * 12 | 0) + 8 >> 2]));
      if (f42 > Math_fround(f43 * f43)) {
       i2 = i2 & ~i4;
       HEAP32[i5 >> 2] = i2;
      }
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i38 | 0)) break; else i4 = i4 << 1;
    }
    if (!i10) {
     i2 = 0;
     i3 = 1;
     while (1) {
      if (HEAP8[i37 + (i2 * 364 | 0) >> 0] | 0) if (HEAP32[i5 >> 2] & i3 | 0) if (!(__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i6, i34 + (i2 * 164 | 0) | 0, HEAP32[i34 + (i2 * 164 | 0) + 160 >> 2] | 0) | 0)) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~i3;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i38 | 0)) break; else i3 = i3 << 1;
     }
    }
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i17 | 0)) break L24;
   i2 = HEAP32[i36 >> 2] | 0;
  }
 } while (0);
 if (!i35) {
  STACKTOP = i39;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i35);
 STACKTOP = i39;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv(i38) {
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i43;
 i39 = i43 + 56 | 0;
 i41 = i38 + 180 | 0;
 i7 = i38 + 4 | 0;
 i1 = (HEAP32[i41 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i42 = i38 + 184 | 0;
 if (i1 >>> 0 >= (HEAP32[i42 >> 2] | 0) >>> 0) {
  i42 = i38 + 192 | 0;
  HEAP8[i42 >> 0] = 0;
  STACKTOP = i43;
  return;
 }
 i40 = i38 + 176 | 0;
 i2 = HEAP32[i40 >> 2] | 0;
 if (i2 >>> 0 <= 32) {
  i42 = i38 + 192 | 0;
  HEAP8[i42 >> 0] = 0;
  STACKTOP = i43;
  return;
 }
 f3 = Math_fround(i1 >>> 0);
 do {
  i36 = i2;
  i2 = i2 >>> 1;
  if (i36 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i2 >>> 0) * Math_fround(.200000003)));
 i1 = i39 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i39 + 8 | 0;
 i5 = i38 + 8 | 0;
 i8 = HEAP16[i5 >> 1] | 0;
 HEAP8[i4 >> 0] = i8;
 i6 = i39 + 9 | 0;
 HEAP8[i6 >> 0] = (i8 & 65535) >>> 8;
 i8 = i39 + 12 | 0;
 i9 = i38 + 12 | 0;
 i28 = i9;
 i11 = HEAP32[i28 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 i10 = i39 + 20 | 0;
 i11 = i38 + 20 | 0;
 i28 = i10;
 i29 = i11;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i12 = i39 + 76 | 0;
 i13 = i38 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 i14 = i39 + 80 | 0;
 i15 = i38 + 80 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 i16 = i39 + 84 | 0;
 i17 = i38 + 84 | 0;
 i28 = i17;
 i19 = HEAP32[i28 + 4 >> 2] | 0;
 i18 = i16;
 HEAP32[i18 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 i18 = i39 + 92 | 0;
 i19 = i38 + 92 | 0;
 i28 = i19;
 i21 = HEAP32[i28 + 4 >> 2] | 0;
 i20 = i18;
 HEAP32[i20 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 i20 = i39 + 100 | 0;
 i21 = i38 + 100 | 0;
 i28 = i20;
 i29 = i21;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i22 = i39 + 156 | 0;
 i23 = i38 + 156 | 0;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 i24 = i39 + 160 | 0;
 i25 = i38 + 160 | 0;
 HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
 i26 = i39 + 164 | 0;
 i27 = i38 + 164 | 0;
 i33 = i27;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i31 = i26;
 HEAP32[i31 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i31 + 4 >> 2] = i32;
 i31 = i39 + 172 | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i39 + 176 | 0;
 HEAP32[i32 >> 2] = 0;
 i33 = i39 + 180 | 0;
 HEAP32[i33 >> 2] = 0;
 HEAP32[i39 + 196 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i34 = i39 + 188 | 0;
 HEAP32[i34 >> 2] = 0;
 i35 = i39 + 184 | 0;
 HEAP32[i35 >> 2] = 0;
 i36 = i39 + 192 | 0;
 HEAP8[i36 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i39, i38, i2);
 i28 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i28;
 i1 = HEAP8[i5 >> 0] | 0;
 i28 = HEAP16[i4 >> 1] | 0;
 HEAP8[i5 >> 0] = i28;
 HEAP8[i4 >> 0] = i1;
 i1 = i38 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i28 & 65535) >>> 8;
 HEAP8[i6 >> 0] = i2;
 i2 = i9;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i37;
 i29 = i11;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i7 = i17;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i30 = i8;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i9;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i11;
 i29 = i10;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 i30 = i16;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i17;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i8;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = i2;
 i28 = i10;
 i29 = i37;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i12 >> 2] = i4;
 HEAP32[i14 >> 2] = i5;
 i2 = i16;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i19;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i28 = i37;
 i29 = i21;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 i4 = HEAP32[i23 >> 2] | 0;
 i5 = HEAP32[i25 >> 2] | 0;
 i7 = i27;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i30 = i18;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i19;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i21;
 i29 = i20;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
 i30 = i26;
 i29 = HEAP32[i30 + 4 >> 2] | 0;
 i28 = i27;
 HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = i18;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i28 + 4 >> 2] = i2;
 i28 = i20;
 i29 = i37;
 i30 = i28 + 56 | 0;
 do {
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  i28 = i28 + 4 | 0;
  i29 = i29 + 4 | 0;
 } while ((i28 | 0) < (i30 | 0));
 HEAP32[i22 >> 2] = i4;
 HEAP32[i24 >> 2] = i5;
 i30 = i26;
 HEAP32[i30 >> 2] = i6;
 HEAP32[i30 + 4 >> 2] = i7;
 i30 = i38 + 172 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i31 >> 2] = i1;
 i31 = HEAP32[i40 >> 2] | 0;
 i30 = HEAP32[i32 >> 2] | 0;
 HEAP32[i40 >> 2] = i30;
 HEAP32[i32 >> 2] = i31;
 i40 = HEAP32[i41 >> 2] | 0;
 HEAP32[i41 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i33 >> 2] = i40;
 f3 = Math_fround(i30 >>> 0);
 HEAP32[i38 + 188 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i42 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i38 + 192 >> 0] = 0;
 f3 = Math_fround(i31 >>> 0);
 HEAP32[i34 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i35 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i36 >> 0] = 0;
 if (i1 | 0) {
  i42 = HEAP32[i39 + 196 >> 2] | 0;
  HEAP32[i37 >> 2] = 65;
  HEAP32[i37 + 4 >> 2] = i42;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i37);
 }
 i42 = i38 + 192 | 0;
 HEAP8[i42 >> 0] = 0;
 STACKTOP = i43;
 return;
}

function __Z23PatchMuscleClipWithInfoP13AnimationClipRK21AnimationClipSettingsbPN7mecanim9animation18ClipMuscleConstantERNS4_6memory9AllocatorE(i1, i13, i2, i14, i15) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18 + 8 | 0;
 i11 = i18;
 i16 = i18 + 36 | 0;
 i17 = i18 + 16 | 0;
 i5 = i1;
 HEAP32[i14 + 1064 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 1068 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i14 + 1072 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i14 + 1076 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i14 + 1080 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP8[i14 + 1725 >> 0] = HEAP8[i13 + 29 >> 0] | 0;
 i10 = HEAP16[i13 + 30 >> 1] | 0;
 HEAP8[i14 + 1726 >> 0] = i10;
 HEAP8[i14 + 1727 >> 0] = (i10 & 65535) >>> 8;
 i10 = HEAP32[i13 + 32 >> 2] | 0;
 HEAP8[i14 + 1728 >> 0] = i10;
 HEAP8[i14 + 1729 >> 0] = (i10 & 65535) >>> 8;
 HEAP8[i14 + 1731 >> 0] = i10 >>> 16;
 HEAP8[i14 + 1732 >> 0] = i10 >>> 24;
 i10 = HEAP32[i13 + 36 >> 2] | 0;
 HEAP8[i14 + 1733 >> 0] = i10;
 HEAP8[i14 + 1734 >> 0] = (i10 & 65535) >>> 8;
 HEAP8[i14 + 1724 >> 0] = i10 >>> 16;
 __ZN7mecanim9animation25InitClipMuscleDeltaValuesERNS0_18ClipMuscleConstantEb(i14, i2);
 __ZN7mecanim9animation26InitClipMuscleAverageSpeedERNS0_18ClipMuscleConstantEi(i14, 20);
 if (!(HEAP8[i13 + 28 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i11 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i11);
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 8; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 10;
 }
 if ((i12 | 0) == 8) i12 = 10;
 do if ((i12 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
  STACKTOP = i18;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 if (!i1) i12 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i11);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 17; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 19;
  }
 }
 if ((i12 | 0) == 17) i12 = 19;
 if ((i12 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 i8 = __ZN13AnimationClip15GetRuntimeAssetEv(i1) | 0;
 i10 = gb + 63320 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i16 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i11);
 i7 = i6;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i16 + 4 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i17 >> 2] = 0;
 i7 = i17 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i17 + 16 | 0;
 i10 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i11);
 i3 = i6;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i9 >> 2] = 1;
 i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i1 >> 2] = i5;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i4 = 1;
 } else {
  HEAP32[i11 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i11);
    i2 = HEAP32[i6 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 26; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 28;
   }
  }
  if ((i12 | 0) == 26) i12 = 28;
  if ((i12 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i4 + 1 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i17 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i3;
 HEAP32[(HEAP32[i17 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 i1 = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EERN7mecanim6memory9AllocatorE(i17, i16) | 0;
 if (i8 | 0) __Z26InitClipMuscleAdditivePoseRN7mecanim9animation18ClipMuscleConstantES2_PN11UnityEngine9Animation20AnimationSetBindingsEfRNS_6memory9AllocatorE(i14, i8, i1, Math_fround(HEAPF32[i13 + 4 >> 2]), i15);
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(i1, i16);
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i10);
  HEAP32[i17 >> 2] = 0;
 }
 STACKTOP = i18;
 return;
}

function __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i36, i30, i1) {
 i36 = i36 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37 + 16 | 0;
 i32 = i37;
 i33 = i36 + 4 | 0;
 i34 = i36 + 8 | 0;
 i35 = i36 + 12 | 0;
 HEAP32[i36 >> 2] = -1;
 HEAP32[i36 + 4 >> 2] = -1;
 HEAP32[i36 + 8 >> 2] = -1;
 HEAP32[i36 + 12 >> 2] = -1;
 f25 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(65535.0));
 f27 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(65535.0));
 f28 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(65535.0));
 f25 = Math_fround(f25 + Math_fround(.5));
 f27 = Math_fround(f27 + Math_fround(.5));
 f28 = Math_fround(f28 + Math_fround(.5));
 f29 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(65535.0)) + Math_fround(.5));
 i26 = HEAP16[i30 + 64 >> 1] | 0;
 i19 = i26 & 255;
 i1 = (i26 & 65535) >>> 8 & 255;
 if ((i26 & 255) > 1) {
  f10 = Math_fround(HEAPU16[i30 + 32 >> 1] | 0);
  f21 = Math_fround(HEAPU16[i30 + 32 + (i19 + -1 << 1) >> 1] | 0);
  f17 = Math_fround(_fminf(Math_fround(_fmaxf(f25, f10)), f21));
  f18 = Math_fround(_fminf(Math_fround(_fmaxf(f27, f10)), f21));
  f20 = Math_fround(_fminf(Math_fround(_fmaxf(f28, f10)), f21));
  f21 = Math_fround(_fminf(Math_fround(_fmaxf(f29, f10)), f21));
  i2 = 1;
  do {
   f10 = Math_fround(HEAPU16[i30 + 32 + (i2 << 1) >> 1] | 0);
   if (!(f21 > f10 & (f20 > f10 & (f18 > f10 & f17 > f10)))) break;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i19 >>> 0);
  if (i2 >>> 0 < i19 >>> 0) {
   i14 = i31 + 4 | 0;
   i15 = i31 + 8 | 0;
   i16 = i31 + 12 | 0;
   i9 = i32 + 4 | 0;
   i12 = i32 + 8 | 0;
   i13 = i32 + 12 | 0;
   i4 = -1;
   i7 = 0;
   i8 = 0;
   i3 = -1;
   i11 = -1;
   i1 = -1;
   i5 = 0;
   i6 = 0;
   while (1) {
    if ((i5 & i7 & i6 & i8 | 0) <= -1) {
     i2 = i11;
     break;
    }
    f10 = Math_fround(HEAPU16[i30 + 32 + (i2 << 1) >> 1] | 0);
    i26 = i2 + -1 | 0;
    f39 = Math_fround(HEAPU16[i30 + 32 + (i26 << 1) >> 1] | 0);
    f38 = Math_fround(f17 - f39);
    f41 = Math_fround(f18 - f39);
    f40 = Math_fround(f20 - f39);
    f42 = Math_fround(f21 - f39);
    f39 = Math_fround(_fmaxf(Math_fround(f10 - f39), Math_fround(9.99999974e-06)));
    f38 = Math_fround(f38 / f39);
    f41 = Math_fround(f41 / f39);
    f40 = Math_fround(f40 / f39);
    f39 = Math_fround(f42 / f39);
    i24 = f38 < Math_fround(1.0);
    f38 = i24 ? f38 : Math_fround(1.0);
    i24 = f41 < Math_fround(1.0);
    f41 = i24 ? f41 : Math_fround(1.0);
    i24 = f40 < Math_fround(1.0);
    f40 = i24 ? f40 : Math_fround(1.0);
    i24 = f39 < Math_fround(1.0);
    i22 = ~~Math_fround(f41 * Math_fround(255.0));
    i23 = ~~Math_fround(f40 * Math_fround(255.0));
    i24 = ~~Math_fround((i24 ? f39 : Math_fround(1.0)) * Math_fround(255.0));
    HEAP32[i31 >> 2] = ~~Math_fround(f38 * Math_fround(255.0));
    HEAP32[i14 >> 2] = i22;
    HEAP32[i15 >> 2] = i23;
    HEAP32[i16 >> 2] = i24;
    __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i32, i30 + (i26 << 2) | 0, i30 + (i2 << 2) | 0, i31);
    i4 = i4 & i7 | HEAP32[i32 >> 2] & ~i7;
    i3 = i3 & i5 | HEAP32[i9 >> 2] & ~i5;
    i5 = i11 & i6 | HEAP32[i12 >> 2] & ~i6;
    i1 = i1 & i8 | HEAP32[i13 >> 2] & ~i8;
    HEAP32[i36 >> 2] = i4;
    HEAP32[i33 >> 2] = i3;
    HEAP32[i34 >> 2] = i5;
    HEAP32[i35 >> 2] = i1;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i19 >>> 0) {
     i2 = i5;
     break;
    } else {
     i7 = (f17 <= f10) << 31 >> 31;
     i8 = (f21 <= f10) << 31 >> 31;
     i11 = i5;
     i5 = (f18 <= f10) << 31 >> 31;
     i6 = (f20 <= f10) << 31 >> 31;
    }
   }
   i26 = i4;
   i24 = i3;
   i23 = i2;
   i22 = i1;
   i1 = HEAP8[i30 + 65 >> 0] | 0;
  } else {
   i26 = -1;
   i24 = -1;
   i23 = -1;
   i22 = -1;
  }
 } else {
  i26 = -1;
  i24 = -1;
  i23 = -1;
  i22 = -1;
 }
 i19 = i1 & 255;
 if ((i1 & 255) <= 1) {
  STACKTOP = i37;
  return;
 }
 f42 = Math_fround(HEAPU16[i30 + 48 >> 1] | 0);
 f17 = Math_fround(HEAPU16[i30 + 48 + (i19 + -1 << 1) >> 1] | 0);
 f21 = Math_fround(_fminf(Math_fround(_fmaxf(f25, f42)), f17));
 f20 = Math_fround(_fminf(Math_fround(_fmaxf(f27, f42)), f17));
 f18 = Math_fround(_fminf(Math_fround(_fmaxf(f28, f42)), f17));
 f17 = Math_fround(_fminf(Math_fround(_fmaxf(f29, f42)), f17));
 i1 = 1;
 do {
  f42 = Math_fround(HEAPU16[i30 + 48 + (i1 << 1) >> 1] | 0);
  if (!(f17 > f42 & (f18 > f42 & (f20 > f42 & f21 > f42)))) break;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i19 >>> 0);
 L20 : do if (i1 >>> 0 < i19 >>> 0) {
  i14 = i31 + 4 | 0;
  i15 = i31 + 8 | 0;
  i16 = i31 + 12 | 0;
  i11 = i32 + 4 | 0;
  i12 = i32 + 8 | 0;
  i13 = i32 + 12 | 0;
  i8 = i1;
  i4 = -1;
  i7 = 0;
  i3 = -1;
  i9 = 0;
  i2 = -1;
  i1 = -1;
  i5 = 0;
  i6 = 0;
  while (1) {
   if ((i5 & i7 & i6 & i9 | 0) <= -1) break L20;
   f10 = Math_fround(HEAPU16[i30 + 48 + (i8 << 1) >> 1] | 0);
   i43 = i8 + -1 | 0;
   f41 = Math_fround(HEAPU16[i30 + 48 + (i43 << 1) >> 1] | 0);
   f42 = Math_fround(f21 - f41);
   f39 = Math_fround(f20 - f41);
   f40 = Math_fround(f18 - f41);
   f38 = Math_fround(f17 - f41);
   f41 = Math_fround(_fmaxf(Math_fround(f10 - f41), Math_fround(9.99999974e-06)));
   f42 = Math_fround(f42 / f41);
   f39 = Math_fround(f39 / f41);
   f40 = Math_fround(f40 / f41);
   f41 = Math_fround(f38 / f41);
   i44 = f42 < Math_fround(1.0);
   f42 = i44 ? f42 : Math_fround(1.0);
   i44 = f39 < Math_fround(1.0);
   f39 = i44 ? f39 : Math_fround(1.0);
   i44 = f40 < Math_fround(1.0);
   f40 = i44 ? f40 : Math_fround(1.0);
   i44 = f41 < Math_fround(1.0);
   i46 = ~~Math_fround(f39 * Math_fround(255.0));
   i45 = ~~Math_fround(f40 * Math_fround(255.0));
   i44 = ~~Math_fround((i44 ? f41 : Math_fround(1.0)) * Math_fround(255.0));
   HEAP32[i31 >> 2] = ~~Math_fround(f42 * Math_fround(255.0));
   HEAP32[i14 >> 2] = i46;
   HEAP32[i15 >> 2] = i45;
   HEAP32[i16 >> 2] = i44;
   __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i32, i30 + (i43 << 2) | 0, i30 + (i8 << 2) | 0, i31);
   i4 = HEAP32[i32 >> 2] & ~i7 | i7 & i4;
   i1 = HEAP32[i11 >> 2] & ~i5 | i5 & i1;
   i3 = HEAP32[i12 >> 2] & ~i6 | i6 & i3;
   i2 = HEAP32[i13 >> 2] & ~i9 | i9 & i2;
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i19 >>> 0) break; else {
    i7 = (f21 <= f10) << 31 >> 31;
    i9 = (f17 <= f10) << 31 >> 31;
    i5 = (f20 <= f10) << 31 >> 31;
    i6 = (f18 <= f10) << 31 >> 31;
   }
  }
 } else {
  i4 = -1;
  i3 = -1;
  i2 = -1;
  i1 = -1;
 } while (0);
 HEAP32[i36 >> 2] = i26 & 16777215 | i4 & -16777216;
 HEAP32[i33 >> 2] = i24 & 16777215 | i1 & -16777216;
 HEAP32[i34 >> 2] = i23 & 16777215 | i3 & -16777216;
 HEAP32[i35 >> 2] = i22 & 16777215 | i2 & -16777216;
 STACKTOP = i37;
 return;
}

function __ZN11JointLimits8TransferI14SafeBinaryReadEEvRT_(i8, i12) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i6 = i13 + 4 | 0;
 i7 = i13;
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 843849 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i12 + 16 | 0;
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i11 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 6; else {
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i11 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i8, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i8 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 843853 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i11 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i8 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 801720 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i3 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i11 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 28; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (!(HEAP8[i12 + 128 >> 0] | 0)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 736361 | 0, i9, i10, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i12 + 16 | 0;
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i11 = 40; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 40; else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i11 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
    if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
  }
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 736371 | 0, i9, i10, 0) | 0;
  if (!i1) f4 = Math_fround(0.0); else {
   if ((i1 | 0) > 0) {
    i1 = i12 + 16 | 0;
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i11 = 51; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 51; else {
      HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i11 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
    if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   f4 = Math_fround(HEAPF32[i7 >> 2]);
  }
  i3 = Math_fround(HEAPF32[i6 >> 2]) < f4;
  HEAP32[i5 >> 2] = HEAP32[(i3 ? i7 : i6) >> 2];
 }
 i5 = i8 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 736381 | 0, i9, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i11 = 63; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 63; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 63) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i5 = i8 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 744985 | 0, i9, i10, 0) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i12 + 16 | 0;
  i10 = HEAP32[i12 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i10 >>> 0) i11 = 74; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i11 = 74; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i11 | 0) == 74) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i12 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu19BipartiteBoxPruningEPKNS_9PxBounds3EjS3_jRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE(i32, i3, i33, i4, i34, i1) {
 i32 = i32 | 0;
 i3 = i3 | 0;
 i33 = i33 | 0;
 i4 = i4 | 0;
 i34 = i34 | 0;
 i1 = i1 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i35 + 44 | 0;
 i31 = i35 + 8 | 0;
 i28 = i35 + 4 | 0;
 i29 = i35;
 i25 = i35 + 81 | 0;
 i26 = i35 + 80 | 0;
 i27 = i34 + 4 | 0;
 HEAP32[i27 >> 2] = 0;
 if ((i3 | 0) == 0 | (i4 | 0) == 0) {
  i34 = 0;
  STACKTOP = i35;
  return i34 | 0;
 }
 i23 = HEAP32[i1 >> 2] | 0;
 i24 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i35 + 83 | 0, i3 << 2, gb + 657458 | 0, 47) | 0;
 i22 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i35 + 82 | 0, i4 << 2, gb + 657458 | 0, 48) | 0;
 i1 = 0;
 do {
  HEAP32[i24 + (i1 << 2) >> 2] = HEAP32[i32 + (i1 * 24 | 0) + (i23 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = 0;
 do {
  HEAP32[i22 + (i1 << 2) >> 2] = HEAP32[i33 + (i1 * 24 | 0) + (i23 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i30);
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i31);
 i1 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKfj(i30, i24, i3) | 0) + 8 >> 2] | 0;
 i15 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKfj(i31, i22, i4) | 0) + 8 >> 2] | 0;
 i20 = i1 + (i3 << 2) | 0;
 i21 = i15 + (i4 << 2) | 0;
 i19 = (i3 | 0) > 0 & (i4 | 0) > 0;
 L9 : do if (i19) {
  i16 = i34 + 8 | 0;
  i3 = i15;
  i18 = i1;
  do {
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = i18 + 4 | 0;
   HEAP32[i28 >> 2] = i17;
   L13 : do if (i3 >>> 0 < i21 >>> 0) {
    f2 = Math_fround(HEAPF32[i24 + (i17 << 2) >> 2]);
    do {
     if (!(Math_fround(HEAPF32[i22 + (HEAP32[i3 >> 2] << 2) >> 2]) < f2)) break L13;
     i3 = i3 + 4 | 0;
    } while (i3 >>> 0 < i21 >>> 0);
   } while (0);
   i5 = i3 >>> 0 < i21 >>> 0;
   if (!i5) break;
   i6 = i32 + (i17 * 24 | 0) + 12 | 0;
   i7 = i6 + (i23 << 2) | 0;
   i8 = i32 + (i17 * 24 | 0) | 0;
   i9 = i32 + (i17 * 24 | 0) + 16 | 0;
   i10 = i32 + (i17 * 24 | 0) + 4 | 0;
   i11 = i32 + (i17 * 24 | 0) + 20 | 0;
   i12 = i32 + (i17 * 24 | 0) + 8 | 0;
   i14 = i3;
   do {
    i13 = HEAP32[i14 >> 2] | 0;
    i14 = i14 + 4 | 0;
    HEAP32[i29 >> 2] = i13;
    f2 = Math_fround(HEAPF32[i22 + (i13 << 2) >> 2]);
    if (!(f2 <= Math_fround(HEAPF32[i7 >> 2]))) break;
    f2 = Math_fround(HEAPF32[i33 + (i13 * 24 | 0) >> 2]);
    do if (!(f2 > Math_fround(HEAPF32[i6 >> 2]))) {
     f2 = Math_fround(HEAPF32[i8 >> 2]);
     if (!(f2 > Math_fround(HEAPF32[i33 + (i13 * 24 | 0) + 12 >> 2]))) {
      f2 = Math_fround(HEAPF32[i33 + (i13 * 24 | 0) + 4 >> 2]);
      if (!(f2 > Math_fround(HEAPF32[i9 >> 2]))) {
       f2 = Math_fround(HEAPF32[i10 >> 2]);
       if (!(f2 > Math_fround(HEAPF32[i33 + (i13 * 24 | 0) + 16 >> 2]))) {
        f2 = Math_fround(HEAPF32[i33 + (i13 * 24 | 0) + 8 >> 2]);
        if (!(f2 > Math_fround(HEAPF32[i11 >> 2]))) {
         f2 = Math_fround(HEAPF32[i12 >> 2]);
         if (!(f2 > Math_fround(HEAPF32[i33 + (i13 * 24 | 0) + 20 >> 2]))) {
          i4 = HEAP32[i27 >> 2] | 0;
          if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           HEAP32[(HEAP32[i34 >> 2] | 0) + (i4 << 2) >> 2] = i17;
           i4 = (HEAP32[i27 >> 2] | 0) + 1 | 0;
           HEAP32[i27 >> 2] = i4;
          } else {
           __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i34, i28) | 0;
           i4 = HEAP32[i27 >> 2] | 0;
          }
          if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
           HEAP32[(HEAP32[i34 >> 2] | 0) + (i4 << 2) >> 2] = i13;
           HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + 1;
           break;
          } else {
           __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i34, i29) | 0;
           break;
          }
         }
        }
       }
      }
     }
    } while (0);
   } while (i14 >>> 0 < i21 >>> 0);
  } while (i18 >>> 0 < i20 >>> 0 & i5);
  if (i19) {
   i16 = i34 + 8 | 0;
   do {
    i14 = HEAP32[i15 >> 2] | 0;
    i15 = i15 + 4 | 0;
    HEAP32[i28 >> 2] = i14;
    L43 : do if (i1 >>> 0 < i20 >>> 0) {
     f2 = Math_fround(HEAPF32[i22 + (i14 << 2) >> 2]);
     do {
      if (!(Math_fround(HEAPF32[i24 + (HEAP32[i1 >> 2] << 2) >> 2]) <= f2)) break L43;
      i1 = i1 + 4 | 0;
     } while (i1 >>> 0 < i20 >>> 0);
    } while (0);
    i5 = i1 >>> 0 < i20 >>> 0;
    if (!i5) break L9;
    i6 = i33 + (i14 * 24 | 0) + 12 | 0;
    i7 = i6 + (i23 << 2) | 0;
    i8 = i33 + (i14 * 24 | 0) | 0;
    i9 = i33 + (i14 * 24 | 0) + 4 | 0;
    i10 = i33 + (i14 * 24 | 0) + 16 | 0;
    i11 = i33 + (i14 * 24 | 0) + 8 | 0;
    i12 = i33 + (i14 * 24 | 0) + 20 | 0;
    i13 = i1;
    do {
     i3 = HEAP32[i13 >> 2] | 0;
     i13 = i13 + 4 | 0;
     HEAP32[i29 >> 2] = i3;
     f2 = Math_fround(HEAPF32[i24 + (i3 << 2) >> 2]);
     if (!(f2 <= Math_fround(HEAPF32[i7 >> 2]))) break;
     f2 = Math_fround(HEAPF32[i8 >> 2]);
     do if (!(f2 > Math_fround(HEAPF32[i32 + (i3 * 24 | 0) + 12 >> 2]))) {
      f2 = Math_fround(HEAPF32[i32 + (i3 * 24 | 0) >> 2]);
      if (!(f2 > Math_fround(HEAPF32[i6 >> 2]))) {
       f2 = Math_fround(HEAPF32[i9 >> 2]);
       if (!(f2 > Math_fround(HEAPF32[i32 + (i3 * 24 | 0) + 16 >> 2]))) {
        f2 = Math_fround(HEAPF32[i32 + (i3 * 24 | 0) + 4 >> 2]);
        if (!(f2 > Math_fround(HEAPF32[i10 >> 2]))) {
         f2 = Math_fround(HEAPF32[i11 >> 2]);
         if (!(f2 > Math_fround(HEAPF32[i32 + (i3 * 24 | 0) + 20 >> 2]))) {
          f2 = Math_fround(HEAPF32[i32 + (i3 * 24 | 0) + 8 >> 2]);
          if (!(f2 > Math_fround(HEAPF32[i12 >> 2]))) {
           i4 = HEAP32[i27 >> 2] | 0;
           if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
            HEAP32[(HEAP32[i34 >> 2] | 0) + (i4 << 2) >> 2] = i3;
            i3 = (HEAP32[i27 >> 2] | 0) + 1 | 0;
            HEAP32[i27 >> 2] = i3;
           } else {
            __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i34, i29) | 0;
            i3 = HEAP32[i27 >> 2] | 0;
           }
           if ((HEAP32[i16 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
            HEAP32[(HEAP32[i34 >> 2] | 0) + (i3 << 2) >> 2] = i14;
            HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + 1;
            break;
           } else {
            __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i34, i28) | 0;
            break;
           }
          }
         }
        }
       }
      }
     } while (0);
    } while (i13 >>> 0 < i20 >>> 0);
   } while (i15 >>> 0 < i21 >>> 0 & i5);
  }
 } while (0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i22);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, i24);
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i31);
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i30);
 i34 = 1;
 STACKTOP = i35;
 return i34 | 0;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE21writeArticulationLinkEPKNS_18PxArticulationLinkE(i16, i5) {
 i16 = i16 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 992 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 136 | 0;
 i9 = i17 + 128 | 0;
 i10 = i17;
 i11 = i17 + 952 | 0;
 i14 = i17 + 576 | 0;
 i12 = i17 + 544 | 0;
 i13 = i17 + 168 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i16 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i16 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = gb + 687162;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i10;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + -1 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
   i8 = HEAP32[i16 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0);
   i8 = HEAP32[i16 >> 2] | 0;
   HEAP8[(HEAP32[i8 + 4 >> 2] | 0) + ((HEAP32[i8 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
  }
 }
 i2 = HEAP32[i16 + 20 >> 2] | 0;
 i8 = i5;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 L13 : do if (i1 | 0) {
  i7 = _i64Add(i8 | 0, 0, -1, ~i8 | 0) | 0;
  i6 = getTempRet0() | 0;
  i5 = _bitshift64Lshr(i7 | 0, i6 | 0, 22) | 0;
  i7 = i5 ^ i7;
  i6 = (getTempRet0() | 0) ^ i6;
  i5 = _bitshift64Shl(i7 | 0, i6 | 0, 13) | 0;
  i5 = _i64Add(i7 | 0, i6 | 0, ~i5 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i7 = _bitshift64Lshr(i5 | 0, i6 | 0, 8) | 0;
  i6 = ___muldi3(i7 ^ i5 | 0, (getTempRet0() | 0) ^ i6 | 0, 9, 0) | 0;
  i5 = getTempRet0() | 0;
  i7 = _bitshift64Lshr(i6 | 0, i5 | 0, 15) | 0;
  i6 = i7 ^ i6;
  i5 = (getTempRet0() | 0) ^ i5;
  i7 = _bitshift64Shl(i6 | 0, i5 | 0, 27) | 0;
  i7 = _i64Add(i6 | 0, i5 | 0, ~i7 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i5 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i7 | 0, i5 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i5;
  i1 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + ((i1 + -1 & (i6 ^ i7)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i2 + 8 >> 2] | 0;
   i2 = i2 + 12 | 0;
   i3 = i1;
   while (1) {
    i1 = i5 + (i3 << 4) | 0;
    i7 = i1;
    if ((HEAP32[i7 + 4 >> 2] | 0) == 0 ? (HEAP32[i7 >> 2] | 0) == (i8 | 0) : 0) break;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if ((i3 | 0) == -1) break L13;
   }
   if (i1 | 0) {
    i2 = HEAP32[i16 + 4 >> 2] | 0;
    i4 = HEAP32[i16 + 12 >> 2] | 0;
    i1 = HEAP32[i5 + (i3 << 4) + 8 >> 2] | 0;
    i6 = i10;
    i7 = i6 + 128 | 0;
    do {
     HEAP8[i6 >> 0] = 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) < (i7 | 0));
    i7 = i9;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i7 + 4 >> 2] = 0;
    __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 1084511 | 0, i9) | 0;
    if (HEAP8[i10 >> 0] | 0) {
     i7 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
     mftCall_iiii(i7 | 0, i4 | 0, i10 | 0, _strlen(i10) | 0) | 0;
    }
    HEAP8[i9 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i9 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, gb + 673980 | 0, HEAP32[i4 + 20 >> 2] | 0);
    HEAP32[i4 + 16 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
   }
  }
 } while (0);
 i5 = i16 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i16 + 16 | 0;
 i3 = i16 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i6 = i10;
 i7 = i6 + 128 | 0;
 do {
  HEAP8[i6 >> 0] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i9 = i15;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 1084511 | 0, i15) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i9 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  mftCall_iiii(i9 | 0, i4 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i15 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i15 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, gb + 766945 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev(i13);
 i9 = HEAP32[i16 >> 2] | 0;
 i13 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev(i14);
 HEAP32[i15 >> 2] = i9;
 HEAP32[i15 + 4 >> 2] = i13;
 HEAP32[i15 + 8 >> 2] = i8;
 HEAP32[i15 + 12 >> 2] = i1;
 HEAP32[i15 + 16 >> 2] = i2;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i15 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j(i14, i15, 0) | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i13;
 HEAP32[i10 + 8 >> 2] = i8;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i10 + 16 >> 2] = i2;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i14 + 120 | 0, i15);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclERKNS_27PxRigidActorShapeCollectionEj(i10, i14 + 136 | 0, i15 + 1 | 0);
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i11 + 8 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i11 + 16 >> 2] = i2;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j(i14, i11, i15 + 3 | 0) | 0;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i12 + 8 >> 2] = i8;
 HEAP32[i12 + 12 >> 2] = i1;
 HEAP32[i12 + 16 >> 2] = i2;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 0;
 __ZN5physx2Sn17RepXVisitorWriterINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE(i12, i14 + 336 | 0);
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __Z19MurmurHash3_x64_128PKvijPv(i7, i11, i3, i12) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i8 = (i11 | 0) / 16 | 0;
 if ((i11 | 0) > 15) {
  i6 = 0;
  i5 = i3;
  i4 = 0;
  i2 = i3;
  i1 = 0;
  do {
   i10 = i6 << 1;
   i14 = i7 + (i10 << 3) | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i10 = i7 + ((i10 | 1) << 3) | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i16 = ___muldi3(i3 | 0, i14 | 0, 289559509, -2017231983) | 0;
   i15 = getTempRet0() | 0;
   i14 = ___muldi3(i3 | 0, i14 | 0, -2147483648, -2002703894) | 0;
   i3 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i16 | 0, i15 | 0, 33) | 0;
   i3 = ___muldi3(i15 | i14 | 0, getTempRet0() | 0 | i3 | 0, 658871167, 1291169091) | 0;
   i3 = i3 ^ i5;
   i14 = (getTempRet0() | 0) ^ i4;
   i4 = _bitshift64Shl(i3 | 0, i14 | 0, 27) | 0;
   i5 = getTempRet0() | 0;
   i14 = _bitshift64Lshr(i3 | 0, i14 | 0, 37) | 0;
   i5 = _i64Add(i14 | i4 | 0, getTempRet0() | 0 | i5 | 0, i2 | 0, i1 | 0) | 0;
   i5 = ___muldi3(i5 | 0, getTempRet0() | 0, 5, 0) | 0;
   i5 = _i64Add(i5 | 0, getTempRet0() | 0, 1390208809, 0) | 0;
   i4 = getTempRet0() | 0;
   i14 = ___muldi3(i9 | 0, i10 | 0, 658871167, 1291169091) | 0;
   i3 = getTempRet0() | 0;
   i10 = ___muldi3(i9 | 0, i10 | 0, 0, 1317742334) | 0;
   i9 = getTempRet0() | 0;
   i3 = _bitshift64Lshr(i14 | 0, i3 | 0, 31) | 0;
   i9 = ___muldi3(i3 | i10 | 0, getTempRet0() | 0 | i9 | 0, 289559509, -2017231983) | 0;
   i9 = i9 ^ i2;
   i10 = (getTempRet0() | 0) ^ i1;
   i1 = _bitshift64Shl(i9 | 0, i10 | 0, 31) | 0;
   i2 = getTempRet0() | 0;
   i10 = _bitshift64Lshr(i9 | 0, i10 | 0, 33) | 0;
   i2 = _i64Add(i5 | 0, i4 | 0, i10 | i1 | 0, getTempRet0() | 0 | i2 | 0) | 0;
   i2 = ___muldi3(i2 | 0, getTempRet0() | 0, 5, 0) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, 944331445, 0) | 0;
   i1 = getTempRet0() | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i8 | 0));
  i9 = i5;
  i10 = i4;
 } else {
  i2 = i3;
  i1 = 0;
  i9 = i3;
  i10 = 0;
 }
 i6 = i7 + (i8 << 4) | 0;
 switch (i11 & 15) {
 case 15:
  {
   i3 = _bitshift64Shl(HEAPU8[i6 + 14 >> 0] | 0 | 0, 0, 48) | 0;
   i4 = getTempRet0() | 0;
   i13 = 5;
   break;
  }
 case 14:
  {
   i3 = 0;
   i4 = 0;
   i13 = 5;
   break;
  }
 case 13:
  {
   i3 = 0;
   i4 = 0;
   i13 = 6;
   break;
  }
 case 12:
  {
   i3 = 0;
   i4 = 0;
   i13 = 7;
   break;
  }
 case 11:
  {
   i3 = 0;
   i4 = 0;
   i13 = 8;
   break;
  }
 case 10:
  {
   i3 = 0;
   i4 = 0;
   i13 = 9;
   break;
  }
 case 9:
  {
   i5 = 0;
   i3 = 0;
   i13 = 10;
   break;
  }
 case 8:
  {
   i13 = 11;
   break;
  }
 case 7:
  {
   i3 = 0;
   i4 = 0;
   i13 = 12;
   break;
  }
 case 6:
  {
   i5 = 0;
   i3 = 0;
   i13 = 13;
   break;
  }
 case 5:
  {
   i4 = 0;
   i3 = 0;
   i13 = 14;
   break;
  }
 case 4:
  {
   i3 = 0;
   i4 = 0;
   i13 = 15;
   break;
  }
 case 3:
  {
   i3 = 0;
   i4 = 0;
   i13 = 16;
   break;
  }
 case 2:
  {
   i3 = 0;
   i4 = 0;
   i13 = 17;
   break;
  }
 case 1:
  {
   i5 = 0;
   i3 = 0;
   i13 = 18;
   break;
  }
 default:
  {
   i4 = i9;
   i3 = i10;
  }
 }
 if ((i13 | 0) == 5) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 13 >> 0] | 0 | 0, 0, 40) | 0;
  i3 = i16 | i3;
  i4 = getTempRet0() | 0 | i4;
  i13 = 6;
 }
 if ((i13 | 0) == 6) {
  i4 = (HEAPU8[i6 + 12 >> 0] | 0) ^ i4;
  i13 = 7;
 }
 if ((i13 | 0) == 7) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 11 >> 0] | 0 | 0, 0, 24) | 0;
  i3 = i16 ^ i3;
  i4 = (getTempRet0() | 0) ^ i4;
  i13 = 8;
 }
 if ((i13 | 0) == 8) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 10 >> 0] | 0 | 0, 0, 16) | 0;
  i3 = i16 ^ i3;
  i4 = (getTempRet0() | 0) ^ i4;
  i13 = 9;
 }
 if ((i13 | 0) == 9) {
  i5 = _bitshift64Shl(HEAPU8[i6 + 9 >> 0] | 0 | 0, 0, 8) | 0;
  i5 = i5 ^ i3;
  i3 = (getTempRet0() | 0) ^ i4;
  i13 = 10;
 }
 if ((i13 | 0) == 10) {
  i15 = (HEAPU8[i6 + 8 >> 0] | 0) ^ i5;
  i8 = ___muldi3(i15 | 0, i3 | 0, 658871167, 1291169091) | 0;
  i14 = getTempRet0() | 0;
  i15 = ___muldi3(i15 | 0, i3 | 0, 0, 1317742334) | 0;
  i16 = getTempRet0() | 0;
  i14 = _bitshift64Lshr(i8 | 0, i14 | 0, 31) | 0;
  i16 = ___muldi3(i14 | i15 | 0, getTempRet0() | 0 | i16 | 0, 289559509, -2017231983) | 0;
  i2 = i16 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i13 = 11;
 }
 if ((i13 | 0) == 11) {
  i3 = _bitshift64Shl(HEAPU8[i6 + 7 >> 0] | 0 | 0, 0, 56) | 0;
  i4 = getTempRet0() | 0;
  i13 = 12;
 }
 if ((i13 | 0) == 12) {
  i5 = _bitshift64Shl(HEAPU8[i6 + 6 >> 0] | 0 | 0, 0, 48) | 0;
  i5 = i5 | i3;
  i3 = getTempRet0() | 0 | i4;
  i13 = 13;
 }
 if ((i13 | 0) == 13) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 5 >> 0] | 0 | 0, 0, 40) | 0;
  i4 = (getTempRet0() | 0) ^ i3;
  i3 = i16 ^ i5;
  i13 = 14;
 }
 if ((i13 | 0) == 14) {
  i4 = (HEAPU8[i6 + 4 >> 0] | 0) ^ i4;
  i13 = 15;
 }
 if ((i13 | 0) == 15) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 3 >> 0] | 0 | 0, 0, 24) | 0;
  i3 = i16 ^ i3;
  i4 = (getTempRet0() | 0) ^ i4;
  i13 = 16;
 }
 if ((i13 | 0) == 16) {
  i16 = _bitshift64Shl(HEAPU8[i6 + 2 >> 0] | 0 | 0, 0, 16) | 0;
  i3 = i16 ^ i3;
  i4 = (getTempRet0() | 0) ^ i4;
  i13 = 17;
 }
 if ((i13 | 0) == 17) {
  i5 = _bitshift64Shl(HEAPU8[i6 + 1 >> 0] | 0 | 0, 0, 8) | 0;
  i5 = i5 ^ i3;
  i3 = (getTempRet0() | 0) ^ i4;
  i13 = 18;
 }
 if ((i13 | 0) == 18) {
  i4 = (HEAPU8[i6 >> 0] | 0) ^ i5;
  i15 = ___muldi3(i4 | 0, i3 | 0, 289559509, -2017231983) | 0;
  i16 = getTempRet0() | 0;
  i3 = ___muldi3(i4 | 0, i3 | 0, -2147483648, -2002703894) | 0;
  i4 = getTempRet0() | 0;
  i16 = _bitshift64Lshr(i15 | 0, i16 | 0, 33) | 0;
  i4 = ___muldi3(i16 | i3 | 0, getTempRet0() | 0 | i4 | 0, 658871167, 1291169091) | 0;
  i4 = i4 ^ i9;
  i3 = (getTempRet0() | 0) ^ i10;
 }
 i13 = ((i11 | 0) < 0) << 31 >> 31;
 i14 = i2 ^ i11;
 i15 = i1 ^ i13;
 i13 = _i64Add(i4 ^ i11 | 0, i3 ^ i13 | 0, i14 | 0, i15 | 0) | 0;
 i11 = getTempRet0() | 0;
 i15 = _i64Add(i13 | 0, i11 | 0, i14 | 0, i15 | 0) | 0;
 i14 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i13 | 0, i11 | 0, 33) | 0;
 i11 = ___muldi3(i16 ^ i13 | 0, (getTempRet0() | 0) ^ i11 | 0, -313160499, -11423785) | 0;
 i13 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i11 | 0, i13 | 0, 33) | 0;
 i13 = ___muldi3(i16 ^ i11 | 0, (getTempRet0() | 0) ^ i13 | 0, 444984403, -993084930) | 0;
 i11 = getTempRet0() | 0;
 i16 = _bitshift64Lshr(i13 | 0, i11 | 0, 33) | 0;
 i11 = (getTempRet0() | 0) ^ i11;
 i10 = _bitshift64Lshr(i15 | 0, i14 | 0, 33) | 0;
 i14 = ___muldi3(i10 ^ i15 | 0, (getTempRet0() | 0) ^ i14 | 0, -313160499, -11423785) | 0;
 i15 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i14 | 0, i15 | 0, 33) | 0;
 i15 = ___muldi3(i10 ^ i14 | 0, (getTempRet0() | 0) ^ i15 | 0, 444984403, -993084930) | 0;
 i14 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i15 | 0, i14 | 0, 33) | 0;
 i15 = i10 ^ i15;
 i14 = (getTempRet0() | 0) ^ i14;
 i11 = _i64Add(i15 | 0, i14 | 0, i16 ^ i13 | 0, i11 | 0) | 0;
 i13 = getTempRet0() | 0;
 i14 = _i64Add(i11 | 0, i13 | 0, i15 | 0, i14 | 0) | 0;
 i15 = getTempRet0() | 0;
 i16 = i12;
 HEAP32[i16 >> 2] = i11;
 HEAP32[i16 + 4 >> 2] = i13;
 i16 = i12 + 8 | 0;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i16 + 4 >> 2] = i15;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i3 = i5 + 28 | 0;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 44 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 48 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i3 = i5 + 60 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 64 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i3 = i5 + 76 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 80 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i3 = i5 + 92 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i5 + 96 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i3 = i5 + 108 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i5 + 112 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i3 = i5 + 124 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i5 + 128 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i3 = i5 + 140 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i5 + 144 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 STACKTOP = i10;
 return;
}

function __ZN11UmbraModule12SetupPortalsEPKN5Umbra4TomeE(i1, i23) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 8 | 0;
 i21 = i26;
 i24 = i26 + 40 | 0;
 i25 = i26 + 20 | 0;
 i22 = i26 + 16 | 0;
 i3 = __Z29GetOcclusionPortalManagerListv() | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 68 >> 2] = -1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i14 = __ZNK5Umbra4Tome12getGateCountEv(i23) | 0;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i12 = i21;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i12 + 4 >> 2] = i16;
 HEAP32[i24 >> 2] = 0;
 i12 = i24 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i16 = i24 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i21);
 i15 = i20;
 i18 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i17;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 __ZN19RuntimeSceneManager15GetLoadedScenesER13dynamic_arrayIP10UnitySceneLj4EE(__Z15GetSceneManagerv() | 0, i24);
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i15 = i21;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = i18;
 HEAP32[i25 >> 2] = 0;
 i15 = i25 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i18 = i25 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i21);
 i9 = i20;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i19;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 if (!(HEAP32[i12 >> 2] | 0)) i5 = 0; else {
  i9 = 0;
  i1 = 0;
  i11 = 0;
  while (1) {
   i10 = __ZNK10UnityScene19GetLevelGameManagerEi(HEAP32[(HEAP32[i24 >> 2] | 0) + (i11 << 2) >> 2] | 0, 24) | 0;
   do if (!i10) i2 = i9; else if ((((HEAP32[i10 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 35088 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 35088 + 28 >> 2] | 0) >>> 0) {
    i5 = HEAP32[i10 + 28 >> 2] | 0;
    if (!i5) i2 = i9; else {
     HEAP32[i21 >> 2] = i5;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i13 = 14; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
       i3 = HEAP32[i20 >> 2] | 0;
       i8 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i8 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 14; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i13 = 16;
      }
     }
     if ((i13 | 0) == 14) i13 = 16;
     if ((i13 | 0) == 16) {
      i13 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
      if (!i2) {
       i2 = i9;
       break;
      }
     }
     i2 = __ZNK20OcclusionCullingData8GetSceneERK9UnityGUID(i2, i10 + 72 | 0) | 0;
     if (!i2) i2 = i9; else {
      i6 = i10 + 52 | 0;
      i7 = HEAP32[i2 + 8 >> 2] | 0;
      i8 = i6 + 12 | 0;
      i2 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
      i4 = HEAP32[i15 >> 2] | 0;
      HEAP32[i15 >> 2] = i2;
      i3 = HEAP32[i18 >> 2] | 0;
      do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
       HEAP32[i18 >> 2] = i2;
       HEAP32[i25 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i2 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i9 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
       HEAP32[i18 >> 2] = i2;
       HEAP32[i25 >> 2] = i9;
       break;
      } while (0);
      if (i2 >>> 0 > i4 >>> 0) {
       i3 = i2 - i4 | 0;
       if (i3 | 0) _memset((HEAP32[i25 >> 2] | 0) + (i4 << 2) | 0, 0, i3 << 2 | 0) | 0;
      }
      if (HEAP32[i8 >> 2] | 0) {
       i5 = HEAP32[i25 >> 2] | 0;
       i4 = HEAP32[i6 >> 2] | 0;
       i3 = 0;
       do {
        HEAP32[i5 + (i3 + i7 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
      }
      i1 = (HEAP32[i10 + 32 + 12 >> 2] | 0) + i1 | 0;
     }
    }
   } else i2 = i9; while (0);
   i11 = i11 + 1 | 0;
   if ((i11 | 0) == (HEAP32[i12 >> 2] | 0)) {
    i5 = i1;
    break;
   } else i9 = i2;
  }
 }
 if ((i14 | 0) == 0 | (HEAP32[i15 >> 2] | 0) == 0) i1 = 0; else {
  i13 = __ZNK5Umbra4Tome16getGateStateSizeEv(i23) | 0;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, gb + 63600 | 0, 0, gb + 612578 | 0, 271) | 0;
  _memset(i1 | 0, 0, i13 | 0) | 0;
  __ZN5Umbra15GateStateVectorC2EPvjb(i22, i1, i13, 1);
  if ((i14 | 0) > 0) {
   i6 = 0;
   do {
    i2 = (__ZNK5Umbra4Tome13getGateUserIDEi(i23, i6) | 0) - i5 | 0;
    do if (i2 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
     HEAP32[i21 >> 2] = HEAP32[(HEAP32[i25 >> 2] | 0) + (i2 << 2) >> 2];
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (i2 | 0) {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i21);
       i3 = HEAP32[i20 >> 2] | 0;
       i13 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) != (i3 + (i4 << 3) | 0)) {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) break;
       if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31032 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31032 + 28 >> 2] | 0) >>> 0) break;
       HEAP32[i2 + 68 >> 2] = i6;
       __ZN5Umbra15GateStateVector8setStateEib(i22, i6, __ZN15OcclusionPortal22CalculatePortalEnabledEv(i2) | 0);
       break;
      }
     }
    } while (0);
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i14 | 0));
  }
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i19);
  HEAP32[i25 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i26;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i17);
 HEAP32[i24 >> 2] = 0;
 STACKTOP = i26;
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEbT0_S8_T_(i16, i14, i15) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 104 | 0;
 i17 = i19 + 96 | 0;
 i4 = i19 + 48 | 0;
 i5 = i19 + 40 | 0;
 i6 = i19 + 24 | 0;
 i7 = i19 + 16 | 0;
 i8 = i19 + 8 | 0;
 i9 = i19;
 i3 = i19 + 88 | 0;
 i2 = i19 + 80 | 0;
 i10 = i19 + 72 | 0;
 i11 = i19 + 64 | 0;
 i12 = i19 + 56 | 0;
 i13 = i19 + 32 | 0;
 switch (i14 - i16 >> 3 | 0) {
 case 2:
  {
   i15 = HEAP32[i15 >> 2] | 0;
   i1 = i14 + -8 | 0;
   i14 = i1;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i12 = i3;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   i12 = i16;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i14 = i2;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   if (!(mftCall_iii(i15 | 0, i17 | 0, i18 | 0) | 0)) {
    i18 = 1;
    STACKTOP = i19;
    return i18 | 0;
   }
   i17 = i16;
   i15 = HEAP32[i17 >> 2] | 0;
   i17 = HEAP32[i17 + 4 >> 2] | 0;
   i13 = i1;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i18 = i16;
   HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i18 + 4 >> 2] = i14;
   i18 = i1;
   HEAP32[i18 >> 2] = i15;
   HEAP32[i18 + 4 >> 2] = i17;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i16, i16 + 8 | 0, i14 + -8 | 0, i15) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 4:
  {
   i2 = i16 + 8 | 0;
   i3 = i16 + 16 | 0;
   i1 = i14 + -8 | 0;
   __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i16, i2, i3, i15) | 0;
   i14 = HEAP32[i15 >> 2] | 0;
   i13 = i1;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i4;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i11 = i3;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i5;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   if (mftCall_iii(i14 | 0, i17 | 0, i18 | 0) | 0) {
    i13 = i3;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i10 = i1;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i14 = i3;
    HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i14 + 4 >> 2] = i11;
    i14 = i1;
    HEAP32[i14 >> 2] = i12;
    HEAP32[i14 + 4 >> 2] = i13;
    i14 = HEAP32[i15 >> 2] | 0;
    i13 = i3;
    i12 = HEAP32[i13 + 4 >> 2] | 0;
    i11 = i6;
    HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i11 + 4 >> 2] = i12;
    i11 = i2;
    i12 = HEAP32[i11 + 4 >> 2] | 0;
    i13 = i7;
    HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
    HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    if (mftCall_iii(i14 | 0, i17 | 0, i18 | 0) | 0) {
     i11 = i2;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i3;
     i14 = HEAP32[i13 >> 2] | 0;
     i13 = HEAP32[i13 + 4 >> 2] | 0;
     i12 = i2;
     HEAP32[i12 >> 2] = i14;
     HEAP32[i12 + 4 >> 2] = i13;
     i12 = i3;
     HEAP32[i12 >> 2] = i10;
     HEAP32[i12 + 4 >> 2] = i11;
     i15 = HEAP32[i15 >> 2] | 0;
     i12 = i8;
     HEAP32[i12 >> 2] = i14;
     HEAP32[i12 + 4 >> 2] = i13;
     i12 = i16;
     i13 = HEAP32[i12 + 4 >> 2] | 0;
     i14 = i9;
     HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i14 + 4 >> 2] = i13;
     HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     if (mftCall_iii(i15 | 0, i17 | 0, i18 | 0) | 0) {
      i17 = i16;
      i15 = HEAP32[i17 >> 2] | 0;
      i17 = HEAP32[i17 + 4 >> 2] | 0;
      i13 = i2;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i18 = i16;
      HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i18 + 4 >> 2] = i14;
      i18 = i2;
      HEAP32[i18 >> 2] = i15;
      HEAP32[i18 + 4 >> 2] = i17;
     }
    }
   }
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_(i16, i16 + 8 | 0, i16 + 16 | 0, i16 + 24 | 0, i14 + -8 | 0, i15) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 1:
 case 0:
  {
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 default:
  {
   i3 = i16 + 16 | 0;
   __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i16, i16 + 8 | 0, i3, i15) | 0;
   i1 = i16 + 24 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i9 = HEAP32[i15 >> 2] | 0;
     i8 = i1;
     i7 = HEAP32[i8 + 4 >> 2] | 0;
     i6 = i10;
     HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i6 + 4 >> 2] = i7;
     i6 = i3;
     i7 = HEAP32[i6 + 4 >> 2] | 0;
     i8 = i11;
     HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i8 + 4 >> 2] = i7;
     HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     if (mftCall_iii(i9 | 0, i17 | 0, i18 | 0) | 0) {
      i6 = i1;
      i5 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
      i4 = i1;
      while (1) {
       i7 = i3;
       i8 = HEAP32[i7 + 4 >> 2] | 0;
       i9 = i4;
       HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i9 + 4 >> 2] = i8;
       if ((i3 | 0) == (i16 | 0)) break;
       i9 = HEAP32[i15 >> 2] | 0;
       i4 = i12;
       HEAP32[i4 >> 2] = i5;
       HEAP32[i4 + 4 >> 2] = i6;
       i4 = i3 + -8 | 0;
       i20 = i4;
       i7 = HEAP32[i20 + 4 >> 2] | 0;
       i8 = i13;
       HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i8 + 4 >> 2] = i7;
       HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i18 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
       if (mftCall_iii(i9 | 0, i17 | 0, i18 | 0) | 0) {
        i20 = i3;
        i3 = i4;
        i4 = i20;
       } else break;
      }
      i20 = i3;
      HEAP32[i20 >> 2] = i5;
      HEAP32[i20 + 4 >> 2] = i6;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i14 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i20 = i1;
      i1 = i3;
      i3 = i20;
     }
    }
   } while (0);
   i20 = i1 | i2;
   STACKTOP = i19;
   return i20 | 0;
  }
 }
 return 0;
}

function __ZNK13b2DynamicTree7RayCastI21b2WorldRayCastWrapperEEvPT_RK14b2RayCastInput(i1, i31, i34) {
 i1 = i1 | 0;
 i31 = i31 | 0;
 i34 = i34 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, f32 = f0, f33 = f0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i43 + 1064 | 0;
 i36 = i43 + 1056 | 0;
 i42 = i43 + 20 | 0;
 i37 = i43;
 f38 = Math_fround(HEAPF32[i34 >> 2]);
 f39 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 i40 = i34 + 8 | 0;
 f32 = Math_fround(HEAPF32[i40 >> 2]);
 f32 = Math_fround(f32 - f38);
 f33 = Math_fround(Math_fround(HEAPF32[i34 + 12 >> 2]) - f39);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f32 * f32) + Math_fround(f33 * f33))));
 if (f2 < Math_fround(1.1920929e-07)) {
  f28 = f32;
  f2 = f33;
 } else {
  f2 = Math_fround(Math_fround(1.0) / f2);
  f28 = Math_fround(f32 * f2);
  f2 = Math_fround(f33 * f2);
 }
 f29 = Math_fround(-f2);
 i30 = f2 < Math_fround(-0.0);
 f24 = i30 ? f29 : f2;
 i30 = f28 > Math_fround(0.0);
 f25 = Math_fround(-f28);
 f25 = i30 ? f28 : f25;
 f14 = Math_fround(HEAPF32[i34 + 16 >> 2]);
 f11 = Math_fround(f38 + Math_fround(f32 * f14));
 f10 = Math_fround(f39 + Math_fround(f33 * f14));
 i30 = i42 + 4 | 0;
 HEAP32[i42 >> 2] = i30;
 i26 = i42 + 1028 | 0;
 i27 = i42 + 1032 | 0;
 HEAP32[i27 >> 2] = 256;
 HEAP32[i30 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i26 >> 2] = 1;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f39 > f10 ? f39 : f10, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f38 > f11 ? f38 : f11, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f39 < f10 ? f39 : f10, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = i1 + 4 | 0;
 i16 = i37 + 8 | 0;
 i17 = i37 + 16 | 0;
 i18 = i35 + 8 | 0;
 i19 = i37 + 4 | 0;
 i20 = i37 + 8 | 0;
 i21 = i37 + 12 | 0;
 i22 = i36 + 4 | 0;
 i23 = i31 + 4 | 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f38 < f11 ? f38 : f11, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = 1;
 i8 = i30;
 L4 : while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i26 >> 2] = i1;
  i12 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
  do if ((i12 | 0) == -1) f2 = f14; else {
   i13 = HEAP32[i15 >> 2] | 0;
   f46 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = Math_fround(HEAPF32[i13 + (i12 * 36 | 0) + 8 >> 2]);
   f46 = Math_fround(f46 - f2);
   f45 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = Math_fround(HEAPF32[i13 + (i12 * 36 | 0) + 12 >> 2]);
   f45 = Math_fround(f45 - f9);
   f10 = Math_fround(HEAPF32[i13 + (i12 * 36 | 0) >> 2]);
   f44 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f11 = Math_fround(HEAPF32[i13 + (i12 * 36 | 0) + 4 >> 2]);
   if (f46 > Math_fround(0.0) | f45 > Math_fround(0.0) | f44 > Math_fround(0.0) | Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) > Math_fround(0.0)) f2 = f14; else {
    f45 = Math_fround(Math_fround(f2 - f10) * Math_fround(.5));
    f46 = Math_fround(Math_fround(f9 - f11) * Math_fround(.5));
    f11 = Math_fround(Math_fround(Math_fround(f38 - Math_fround(Math_fround(f2 + f10) * Math_fround(.5))) * f29) + Math_fround(f28 * Math_fround(f39 - Math_fround(Math_fround(f9 + f11) * Math_fround(.5)))));
    i7 = f11 > Math_fround(0.0);
    f44 = Math_fround(-f11);
    if (Math_fround((i7 ? f11 : f44) - Math_fround(Math_fround(f24 * f45) + Math_fround(f25 * f46))) > Math_fround(0.0)) f2 = f14; else {
     i7 = i13 + (i12 * 36 | 0) + 24 | 0;
     if ((HEAP32[i7 >> 2] | 0) == -1) {
      i13 = i34;
      i1 = HEAP32[i13 + 4 >> 2] | 0;
      i8 = i37;
      HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 4 >> 2] = i1;
      i8 = i40;
      i1 = HEAP32[i8 + 4 >> 2] | 0;
      i13 = i16;
      HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i13 + 4 >> 2] = i1;
      HEAPF32[i17 >> 2] = f14;
      i13 = HEAP32[(HEAP32[(HEAP32[i31 >> 2] | 0) + 4 >> 2] | 0) + (i12 * 36 | 0) + 16 >> 2] | 0;
      i1 = HEAP32[i13 + 16 >> 2] | 0;
      i12 = HEAP32[i1 + 32 >> 2] | 0;
      if (mftCall_iiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0, i35 | 0, i37 | 0, (HEAP32[i1 + 28 >> 2] | 0) + 12 | 0, HEAP32[i13 + 20 >> 2] | 0) | 0) {
       f2 = Math_fround(HEAPF32[i18 >> 2]);
       f46 = Math_fround(Math_fround(1.0) - f2);
       f44 = Math_fround(f46 * Math_fround(HEAPF32[i37 >> 2]));
       f46 = Math_fround(f46 * Math_fround(HEAPF32[i19 >> 2]));
       f45 = Math_fround(f2 * Math_fround(HEAPF32[i20 >> 2]));
       f46 = Math_fround(f46 + Math_fround(f2 * Math_fround(HEAPF32[i21 >> 2])));
       HEAPF32[i36 >> 2] = Math_fround(f44 + f45);
       HEAPF32[i22 >> 2] = f46;
       i13 = HEAP32[i23 >> 2] | 0;
       f2 = Math_fround(+mftCall_fiiiif(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i1 | 0, i36 | 0, i35 | 0, +f2));
      } else f2 = Math_fround(HEAPF32[i17 >> 2]);
      if (f2 == Math_fround(0.0)) {
       i41 = 24;
       break L4;
      }
      if (f2 > Math_fround(0.0)) {
       f45 = Math_fround(f38 + Math_fround(f32 * f2));
       f46 = Math_fround(f39 + Math_fround(f33 * f2));
       i3 = (HEAPF32[tempDoublePtr >> 2] = f38 < f45 ? f38 : f45, HEAP32[tempDoublePtr >> 2] | 0);
       i5 = (HEAPF32[tempDoublePtr >> 2] = f39 < f46 ? f39 : f46, HEAP32[tempDoublePtr >> 2] | 0);
       i6 = (HEAPF32[tempDoublePtr >> 2] = f38 > f45 ? f38 : f45, HEAP32[tempDoublePtr >> 2] | 0);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f39 > f46 ? f39 : f46, HEAP32[tempDoublePtr >> 2] | 0);
      } else f2 = f14;
      i1 = HEAP32[i26 >> 2] | 0;
      break;
     } else {
      if ((i1 | 0) == (HEAP32[i27 >> 2] | 0)) {
       HEAP32[i27 >> 2] = i1 << 1;
       i1 = __Z7b2Alloci(i1 << 3) | 0;
       HEAP32[i42 >> 2] = i1;
       _memcpy(i1 | 0, i8 | 0, HEAP32[i26 >> 2] << 2 | 0) | 0;
       if ((i8 | 0) != (i30 | 0)) __Z6b2FreePv(i8);
      }
      i8 = HEAP32[i42 >> 2] | 0;
      HEAP32[i8 + (HEAP32[i26 >> 2] << 2) >> 2] = HEAP32[i7 >> 2];
      i7 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
      HEAP32[i26 >> 2] = i7;
      i1 = i13 + (i12 * 36 | 0) + 28 | 0;
      if ((i7 | 0) == (HEAP32[i27 >> 2] | 0)) {
       HEAP32[i27 >> 2] = i7 << 1;
       i13 = __Z7b2Alloci(i7 << 3) | 0;
       HEAP32[i42 >> 2] = i13;
       _memcpy(i13 | 0, i8 | 0, HEAP32[i26 >> 2] << 2 | 0) | 0;
       if ((i8 | 0) != (i30 | 0)) __Z6b2FreePv(i8);
      }
      HEAP32[(HEAP32[i42 >> 2] | 0) + (HEAP32[i26 >> 2] << 2) >> 2] = HEAP32[i1 >> 2];
      i1 = (HEAP32[i26 >> 2] | 0) + 1 | 0;
      HEAP32[i26 >> 2] = i1;
      f2 = f14;
      break;
     }
    }
   }
  } while (0);
  if ((i1 | 0) <= 0) break;
  f14 = f2;
  i8 = HEAP32[i42 >> 2] | 0;
 }
 i1 = HEAP32[i42 >> 2] | 0;
 if ((i1 | 0) == (i30 | 0)) {
  STACKTOP = i43;
  return;
 }
 __Z6b2FreePv(i1);
 HEAP32[i42 >> 2] = 0;
 STACKTOP = i43;
 return;
}

function __ZN12WheelJoint2D6CreateEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 96 | 0;
 i10 = i17 + 88 | 0;
 i14 = i17 + 24 | 0;
 i15 = i17 + 12 | 0;
 i12 = i17;
 i7 = i13 + 28 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i17;
  return;
 }
 i11 = i13 + 36 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i16 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[i1 + 32 >> 2] | 0;
   i6 = i4 + (i5 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i6 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[gb + 1104264 >> 2] | 0;
   i6 = (i6 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i6 << 3) | 0;
   i1 = i5;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   i5 = HEAP32[i5 + 32 >> 2] | 0;
  }
  if ((i6 | 0) == (i4 + (i5 << 3) | 0)) i16 = 9; else if (!(HEAP32[i6 + 4 >> 2] | 0)) i16 = 11;
 }
 if ((i16 | 0) == 9) i16 = 11;
 do if ((i16 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0)) {
  STACKTOP = i17;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 if (!i1) i16 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i4 + (i5 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i4 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i4 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i4 << 3) | 0;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   i5 = HEAP32[i5 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i16 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i16 = 20;
  }
 }
 if ((i16 | 0) == 18) i16 = 20;
 if ((i16 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i14 >> 2] = 7;
 i8 = i14 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP8[i14 + 44 >> 0] = HEAP8[i13 + 116 >> 0] | 0;
 HEAPF32[i14 + 52 >> 2] = Math_fround(Math_fround(HEAPF32[i13 + 108 >> 2]) * Math_fround(.0174532924));
 HEAP32[i14 + 48 >> 2] = HEAP32[i13 + 112 >> 2];
 HEAP32[i14 + 56 >> 2] = HEAP32[i13 + 100 >> 2];
 HEAP32[i14 + 60 >> 2] = HEAP32[i13 + 96 >> 2];
 f2 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i13 + 104 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f3 = Math_fround(+Math_sin(+f2));
 HEAPF32[i14 + 36 >> 2] = Math_fround(+Math_cos(+f2));
 HEAPF32[i14 + 40 >> 2] = f3;
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 do if (!i1) i16 = 33; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i16 = 29; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i6 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i5 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i4 = HEAP32[i9 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i7 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i4 << 3) | 0;
    i5 = HEAP32[i7 + 28 >> 2] | 0;
    i6 = HEAP32[i7 + 32 >> 2] | 0;
    i1 = i7;
   }
   if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i16 = 29; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i16 = 31;
  }
  if ((i16 | 0) == 29) i16 = 31;
  if ((i16 | 0) == 31) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0)) {
    i16 = 33;
    break;
   }
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  if (!i1) i16 = 39; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i4 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i4 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i16 = 39; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i16 = 41;
   }
  }
  if ((i16 | 0) == 39) i16 = 41;
  if ((i16 | 0) == 41) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f3 = Math_fround(HEAPF32[i12 >> 2]);
  f2 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 } while (0);
 if ((i16 | 0) == 33) {
  i11 = HEAP32[gb + 62512 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  i16 = HEAP32[gb + 62512 + 4 >> 2] | 0;
  HEAP32[i12 + 4 >> 2] = i16;
  HEAP32[i12 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  f3 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f19 = Math_fround(HEAPF32[i13 + 76 >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i15 >> 2]));
 f18 = Math_fround(HEAPF32[i13 + 80 >> 2]);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 HEAPF32[i8 >> 2] = f19;
 HEAPF32[i14 + 24 >> 2] = f18;
 f18 = Math_fround(Math_fround(HEAPF32[i13 + 84 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i13 + 88 >> 2]) * f2);
 HEAPF32[i14 + 28 >> 2] = f18;
 HEAPF32[i14 + 32 >> 2] = f3;
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i13, i14);
 STACKTOP = i17;
 return;
}

function __ZN24dtObstacleAvoidanceQuery22sampleVelocityAdaptiveEPKfS1_fffPffPK25dtObstacleAvoidanceParamsP21dtCrowdAgentDebugInfo(i27, i19, i13, f4, f5, f15, i32, f9, i10, i1) {
 i27 = i27 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f15 = Math_fround(f15);
 i32 = i32 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, f7 = f0, i8 = 0, i11 = 0, f12 = f0, i14 = 0, i16 = 0, f17 = f0, i18 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i31 + 32 | 0;
 i23 = i31 + 24 | 0;
 i24 = i31 + 16 | 0;
 i25 = i31 + 8 | 0;
 i26 = i31;
 if (f9 < Math_fround(9.99999974e-06)) {
  HEAP32[i32 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i32 = 0;
  STACKTOP = i31;
  return i32 | 0;
 }
 if (!(HEAP32[i27 + 10456 >> 2] | 0)) if (!(HEAP32[i27 + 10452 >> 2] | 0)) {
  HEAP32[i32 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i32 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i32 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i32 = 0;
  STACKTOP = i31;
  return i32 | 0;
 }
 HEAPF32[i32 >> 2] = Math_fround(0.0);
 i28 = i32 + 4 | 0;
 HEAPF32[i28 >> 2] = Math_fround(0.0);
 i29 = i32 + 8 | 0;
 HEAPF32[i29 >> 2] = Math_fround(0.0);
 if (f15 < Math_fround(9.99999974e-06)) {
  i32 = 0;
  STACKTOP = i31;
  return i32 | 0;
 }
 i16 = i27 + 10420 | 0;
 i2 = i27 + 10460 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   f4 = Math_fround(HEAPF32[i27 + 4992 + (i1 * 52 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i27 + 4992 + (i1 * 52 | 0) + 4 >> 2]);
   f21 = Math_fround(HEAPF32[i27 + 4992 + (i1 * 52 | 0) + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i27 + 4992 + (i1 * 52 | 0) + 12 >> 2]);
   HEAPF32[i27 + 4992 + (i1 * 52 | 0) + 24 >> 2] = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(f21 * Math_fround(.5)));
   HEAPF32[i27 + 4992 + (i1 * 52 | 0) + 28 >> 2] = Math_fround(Math_fround(f5 * Math_fround(.5)) + Math_fround(f7 * Math_fround(.5)));
   i3 = i27 + 4992 + (i1 * 52 | 0) + 32 | 0;
   f4 = Math_fround(f21 - f4);
   HEAPF32[i3 >> 2] = f4;
   f5 = Math_fround(f7 - f5);
   i6 = i27 + 4992 + (i1 * 52 | 0) + 36 | 0;
   HEAPF32[i6 >> 2] = f5;
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))));
   i8 = i27 + 4992 + (i1 * 52 | 0) + 40 | 0;
   HEAPF32[i8 >> 2] = f7;
   if (f7 < Math_fround(9.99999997e-07)) {
    HEAPF32[i8 >> 2] = Math_fround(0.0);
    HEAPF32[i3 >> 2] = Math_fround(0.0);
    HEAPF32[i6 >> 2] = Math_fround(0.0);
   } else {
    f21 = Math_fround(Math_fround(1.0) / f7);
    HEAPF32[i3 >> 2] = Math_fround(f4 * f21);
    HEAPF32[i6 >> 2] = Math_fround(f5 * f21);
    HEAPF32[i8 >> 2] = Math_fround(f7 * Math_fround(.5));
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i14 = i27 + 10400 | 0;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAPF32[i27 + 10440 >> 2] = f9;
 HEAPF32[i27 + 10444 >> 2] = Math_fround(Math_fround(1.0) / f9);
 HEAPF32[i27 + 10448 >> 2] = Math_fround(Math_fround(1.0) / f15);
 i14 = HEAP32[i27 + 10416 >> 2] | 0;
 i10 = i14 & 255;
 i18 = (i14 & 65535) >>> 8;
 i11 = i18 & 65535;
 i10 = (i14 & 255) << 24 >> 24 == 0 ? 1 : i10 >>> 0 > 7 ? 7 : i10;
 i11 = i18 << 16 >> 16 == 0 ? 1 : i11 >>> 0 > 3 ? 3 : i11;
 f12 = Math_fround(Math_fround(6.28318548) / Math_fround(i10 | 0));
 f21 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(+Math_atan2(+f21, +f20));
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 4 >> 2] = Math_fround(0.0);
 i13 = i14 >>> 16;
 i14 = i13 & 255;
 if ((i11 | 0) > 0) {
  f5 = Math_fround(i11 | 0);
  if ((i10 | 0) > 0) {
   i8 = Math_imul(i10, i11) | 0;
   i1 = 1;
   i2 = 0;
   while (1) {
    f7 = Math_fround(Math_fround(i11 - i2 | 0) / f5);
    i3 = 0;
    f4 = Math_fround(f9 + Math_fround(f12 * Math_fround(Math_fround(i2 & 1 | 0) * Math_fround(.5))));
    i6 = i1;
    while (1) {
     i18 = i6 << 1;
     HEAPF32[i22 + (i18 << 2) >> 2] = Math_fround(f7 * Math_fround(+Math_cos(+f4)));
     HEAPF32[i22 + ((i18 | 1) << 2) >> 2] = Math_fround(f7 * Math_fround(+Math_sin(+f4)));
     f4 = Math_fround(f12 + f4);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i10 | 0)) break; else i6 = i6 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i11 | 0)) break; else i1 = i10 + i1 | 0;
   }
   i18 = i8 + 1 | 0;
  } else i18 = 1;
 } else i18 = 1;
 HEAP32[i24 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i23 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i27 + 10428 >> 2];
 HEAPF32[i25 >> 2] = f20;
 HEAPF32[i25 + 4 >> 2] = f21;
 f4 = Math_fround(HEAPF32[i27 + 10400 >> 2]);
 f17 = Math_fround(f4 * f21);
 f12 = Math_fround(Math_fround(f4 * f20) + Math_fround(f21 * Math_fround(.0399999991)));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f17 = Math_fround(f17 - Math_fround(f20 * Math_fround(.0399999991)));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 f17 = Math_fround(f15 + Math_fround(.00100000005));
 f17 = Math_fround(f17 * f17);
 i11 = i13 & 255;
 if (!(i14 << 24 >> 24)) i3 = 0; else {
  i10 = i26 + 4 | 0;
  i8 = 0;
  i3 = 0;
  f15 = Math_fround(Math_fround(Math_fround(1.0) - f4) * f15);
  do {
   f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i6 = 0;
   f7 = Math_fround(3402823469999999843913219.0e14);
   i2 = 0;
   i1 = 0;
   while (1) {
    if (!(i6 | i8)) {
     HEAPF32[i26 >> 2] = f20;
     HEAPF32[i10 >> 2] = f21;
     f5 = f21;
     f4 = f20;
     i30 = 25;
    } else {
     i19 = i6 << 1;
     f4 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i22 + (i19 << 2) >> 2])));
     HEAPF32[i26 >> 2] = f4;
     f5 = Math_fround(f9 + Math_fround(f15 * Math_fround(HEAPF32[i22 + ((i19 | 1) << 2) >> 2])));
     HEAPF32[i10 >> 2] = f5;
     if (Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) > f17) f4 = f7; else i30 = 25;
    }
    if ((i30 | 0) == 25) {
     i30 = 0;
     i14 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
     i19 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     f4 = Math_fround(__ZNK24dtObstacleAvoidanceQuery13processSampleEPKfS1_S1_S1_f(i27, i26, i23, i24, i25, Math_fround(0.0)));
     i16 = f4 < f7;
     f4 = i16 ? f4 : f7;
     i3 = i3 + 1 | 0;
     i2 = i16 ? i14 : i2;
     i1 = i16 ? i19 : i1;
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i18 | 0)) break; else f7 = f4;
   }
   f15 = Math_fround(f15 * Math_fround(.5));
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i11 | 0));
 }
 HEAP32[i32 >> 2] = i2;
 HEAPF32[i28 >> 2] = Math_fround(0.0);
 HEAP32[i29 >> 2] = i1;
 i32 = i3;
 STACKTOP = i31;
 return i32 | 0;
}

function __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0;
 f32 = Math_fround(HEAPF32[i2 >> 2]);
 f46 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f43 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f62 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f55 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f35 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f45 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f42 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f54 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f29 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f61 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f53 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f50 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f47 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f44 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f63 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f59 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f56 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f41 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f60 = Math_fround(f32 * f46);
 f52 = Math_fround(f32 * f43);
 f58 = Math_fround(f62 * f55);
 f40 = Math_fround(f62 * f35);
 f49 = Math_fround(f46 * f43);
 f37 = Math_fround(f55 * f35);
 f5 = Math_fround(f31 * f45);
 f51 = Math_fround(f31 * f42);
 f57 = Math_fround(f23 * f54);
 f39 = Math_fround(f23 * f34);
 f48 = Math_fround(f45 * f42);
 f36 = Math_fround(f54 * f34);
 f27 = Math_fround(f30 * f14);
 f24 = Math_fround(f30 * f13);
 f29 = Math_fround(Math_fround(Math_fround(f29 - f60) - f5) - f27);
 f28 = Math_fround(Math_fround(Math_fround(f28 - f52) - f51) - f24);
 f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f32 * f62)) - Math_fround(f31 * f23)) - Math_fround(f30 * f12));
 f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f46 * f62)) - Math_fround(f45 * f23)) - Math_fround(f14 * f12));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f43 * f62)) - Math_fround(f42 * f23)) - Math_fround(f13 * f12));
 f9 = Math_fround(f12 * f8);
 f6 = Math_fround(f12 * f4);
 f12 = Math_fround(Math_fround(Math_fround(f63 - Math_fround(f62 * f62)) - Math_fround(f23 * f23)) - Math_fround(f12 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f11 - f58) - f57) - f9);
 f10 = Math_fround(Math_fround(Math_fround(f10 - f40) - f39) - f6);
 f23 = Math_fround(f14 * f13);
 f27 = Math_fround(Math_fround(Math_fround(f61 - f60) - f5) - f27);
 f26 = Math_fround(Math_fround(Math_fround(f26 - Math_fround(f46 * f46)) - Math_fround(f45 * f45)) - Math_fround(f14 * f14));
 f25 = Math_fround(Math_fround(Math_fround(f25 - f49) - f48) - f23);
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f32 * f55)) - Math_fround(f31 * f54)) - Math_fround(f30 * f8));
 f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f46 * f55)) - Math_fround(f45 * f54)) - Math_fround(f14 * f8));
 f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f43 * f55)) - Math_fround(f42 * f54)) - Math_fround(f13 * f8));
 f5 = Math_fround(f8 * f4);
 f9 = Math_fround(Math_fround(Math_fround(f59 - f58) - f57) - f9);
 f8 = Math_fround(Math_fround(Math_fround(f56 - Math_fround(f55 * f55)) - Math_fround(f54 * f54)) - Math_fround(f8 * f8));
 f7 = Math_fround(Math_fround(Math_fround(f7 - f37) - f36) - f5);
 f24 = Math_fround(Math_fround(Math_fround(f53 - f52) - f51) - f24);
 f23 = Math_fround(Math_fround(Math_fround(f50 - f49) - f48) - f23);
 f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f43 * f43)) - Math_fround(f42 * f42)) - Math_fround(f13 * f13));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f32 * f35)) - Math_fround(f31 * f34)) - Math_fround(f30 * f4));
 f14 = Math_fround(Math_fround(Math_fround(f47 - Math_fround(f46 * f35)) - Math_fround(f45 * f34)) - Math_fround(f14 * f4));
 f13 = Math_fround(Math_fround(Math_fround(f44 - Math_fround(f43 * f35)) - Math_fround(f42 * f34)) - Math_fround(f13 * f4));
 f6 = Math_fround(Math_fround(Math_fround(f41 - f40) - f39) - f6);
 f5 = Math_fround(Math_fround(Math_fround(f38 - f37) - f36) - f5);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 136 >> 2]) - Math_fround(f35 * f35)) - Math_fround(f34 * f34)) - Math_fround(f4 * f4));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(f33 - Math_fround(f32 * f32)) - Math_fround(f31 * f31)) - Math_fround(f30 * f30));
 HEAPF32[i3 + 4 >> 2] = f29;
 HEAPF32[i3 + 8 >> 2] = f28;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 16 >> 2] = f27;
 HEAPF32[i3 + 20 >> 2] = f26;
 HEAPF32[i3 + 24 >> 2] = f25;
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 32 >> 2] = f24;
 HEAPF32[i3 + 36 >> 2] = f23;
 HEAPF32[i3 + 40 >> 2] = f22;
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 48 >> 2] = f21;
 HEAPF32[i3 + 52 >> 2] = f20;
 HEAPF32[i3 + 56 >> 2] = f19;
 HEAPF32[i3 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 64 >> 2] = f18;
 HEAPF32[i3 + 68 >> 2] = f17;
 HEAPF32[i3 + 72 >> 2] = f16;
 HEAPF32[i3 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 80 >> 2] = f15;
 HEAPF32[i3 + 84 >> 2] = f14;
 HEAPF32[i3 + 88 >> 2] = f13;
 HEAPF32[i3 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 96 >> 2] = f12;
 HEAPF32[i3 + 100 >> 2] = f11;
 HEAPF32[i3 + 104 >> 2] = f10;
 HEAPF32[i3 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 112 >> 2] = f9;
 HEAPF32[i3 + 116 >> 2] = f8;
 HEAPF32[i3 + 120 >> 2] = f7;
 HEAPF32[i3 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 128 >> 2] = f6;
 HEAPF32[i3 + 132 >> 2] = f5;
 HEAPF32[i3 + 136 >> 2] = f4;
 HEAPF32[i3 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __ZL22CheckRedundantVerticesRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderES3_S3_(i19, i22, i18, i24, i2) {
 i19 = i19 | 0;
 i22 = i22 | 0;
 i18 = i18 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 32 | 0;
 i20 = i25 + 16 | 0;
 i21 = i25;
 i1 = HEAP32[i19 >> 2] | 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i17 | 0, 0, i1 | 0) | 0;
 i12 = i2 + 4 | 0;
 __ZN5physx2Gu9ContainerC2Ev(i23);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  __ZN5physx2Gu9ContainerD2Ev(i23);
  STACKTOP = i25;
  return;
 }
 i13 = i22 + 8 | 0;
 i14 = i23 + 8 | 0;
 i10 = i2 + 8 | 0;
 i11 = i23 + 4 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i4 = i2;
 i3 = 0;
 i15 = 0;
 do {
  i1 = i1 + -1 | 0;
  if (!i4) {
   i4 = 0;
   i5 = 0;
  } else {
   i8 = HEAP32[i13 >> 2] | 0;
   i5 = 0;
   i9 = 0;
   while (1) {
    i7 = HEAP32[i8 >> 2] | 0;
    i4 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
    i6 = 0;
    while (1) {
     if (i6 >>> 0 >= i7 >>> 0) {
      i4 = i2;
      break;
     }
     i6 = i6 + 1 | 0;
     if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i8 + (i6 << 2) >> 2] | 0)) {
      i16 = 11;
      break;
     }
    }
    if ((i16 | 0) == 11) {
     i16 = 0;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i23 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i23, 1) | 0;
      i2 = HEAP32[i11 >> 2] | 0;
     }
     HEAP32[i11 >> 2] = i2 + 1;
     i4 = HEAP32[i14 >> 2] | 0;
     HEAP32[i4 + (i2 << 2) >> 2] = i9;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i23 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i23, 1) | 0;
      i2 = HEAP32[i11 >> 2] | 0;
      i4 = HEAP32[i14 >> 2] | 0;
     }
     HEAP32[i11 >> 2] = i2 + 1;
     HEAP32[i4 + (i2 << 2) >> 2] = i7;
     i4 = HEAP32[i19 >> 2] | 0;
     i5 = i5 + 1 | 0;
    }
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= i4 >>> 0) {
     i2 = i4;
     break;
    } else {
     i2 = i4;
     i8 = i8 + (i7 + 1 << 2) | 0;
    }
   }
  }
  i6 = i15;
  i15 = i5 + i15 | 0;
  if (i6 >>> 0 < i15 >>> 0) {
   i5 = HEAP32[i14 >> 2] | 0;
   do {
    i3 = i3 | (HEAP32[i5 + ((i6 << 1 | 1) << 2) >> 2] | 0) == 3;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i15 | 0));
  }
 } while ((i1 | 0) != 0);
 if (!i3) {
  __ZN5physx2Gu9ContainerD2Ev(i23);
  STACKTOP = i25;
  return;
 }
 if (HEAP32[i12 >> 2] | 0) HEAP32[i12 >> 2] = 0;
 if (i15 | 0) {
  i1 = HEAP32[i23 + 8 >> 2] | 0;
  i2 = 0;
  do {
   HEAP8[i17 + (HEAP32[i1 + (i2 << 1 << 2) >> 2] | 0) >> 0] = 1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i15 | 0));
 }
 __ZN5physx2Gu9ContainerC2Ev(i20);
 __ZN5physx2Gu9ContainerC2Ev(i21);
 if (!(HEAP32[i19 >> 2] | 0)) i1 = 0; else {
  i8 = i20 + 4 | 0;
  i9 = i20 + 8 | 0;
  i10 = i21 + 4 | 0;
  i11 = i21 + 8 | 0;
  i14 = HEAP32[i22 + 8 >> 2] | 0;
  i15 = HEAP32[i24 + 8 >> 2] | 0;
  i16 = 0;
  i1 = 0;
  while (1) {
   i12 = HEAP32[i14 >> 2] | 0;
   i13 = HEAP32[i15 >> 2] | 0;
   if (!(HEAP8[i17 + i16 >> 0] | 0)) {
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
     __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i8 >> 2] = i2 + 1;
    i3 = HEAP32[i9 >> 2] | 0;
    HEAP32[i3 + (i2 << 2) >> 2] = i12;
    if (i12 | 0) {
     i5 = 0;
     do {
      i5 = i5 + 1 | 0;
      i4 = HEAP32[i14 + (i5 << 2) >> 2] | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
       __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
       i2 = HEAP32[i8 >> 2] | 0;
       i3 = HEAP32[i9 >> 2] | 0;
      }
      HEAP32[i8 >> 2] = i2 + 1;
      HEAP32[i3 + (i2 << 2) >> 2] = i4;
     } while ((i5 | 0) != (i12 | 0));
    }
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) {
     __ZN5physx2Gu9Container6ResizeEj(i21, 1) | 0;
     i2 = HEAP32[i10 >> 2] | 0;
    }
    HEAP32[i10 >> 2] = i2 + 1;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i3 + (i2 << 2) >> 2] = i13;
    if (i13) {
     i5 = 0;
     do {
      i5 = i5 + 1 | 0;
      i4 = HEAP32[i15 + (i5 << 2) >> 2] | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) {
       __ZN5physx2Gu9Container6ResizeEj(i21, 1) | 0;
       i2 = HEAP32[i10 >> 2] | 0;
       i3 = HEAP32[i11 >> 2] | 0;
      }
      HEAP32[i10 >> 2] = i2 + 1;
      HEAP32[i3 + (i2 << 2) >> 2] = i4;
     } while ((i5 | 0) != (i13 | 0));
    }
   } else if (i13) {
    i7 = 0;
    do {
     i7 = i7 + 1 | 0;
     i6 = HEAP32[i15 + (i7 << 2) >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
      i2 = HEAP32[i8 >> 2] | 0;
     }
     HEAP32[i8 >> 2] = i2 + 1;
     i3 = HEAP32[i9 >> 2] | 0;
     HEAP32[i3 + (i2 << 2) >> 2] = 3;
     i5 = i6 * 3 | 0;
     i4 = HEAP32[i18 + (i5 << 2) >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      i3 = HEAP32[i9 >> 2] | 0;
     }
     HEAP32[i8 >> 2] = i2 + 1;
     HEAP32[i3 + (i2 << 2) >> 2] = i4;
     i4 = HEAP32[i18 + (i5 + 1 << 2) >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      i3 = HEAP32[i9 >> 2] | 0;
     }
     HEAP32[i8 >> 2] = i2 + 1;
     HEAP32[i3 + (i2 << 2) >> 2] = i4;
     i4 = HEAP32[i18 + (i5 + 2 << 2) >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i20, 1) | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      i3 = HEAP32[i9 >> 2] | 0;
     }
     HEAP32[i8 >> 2] = i2 + 1;
     HEAP32[i3 + (i2 << 2) >> 2] = i4;
     i2 = HEAP32[i10 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i21, 1) | 0;
      i2 = HEAP32[i10 >> 2] | 0;
     }
     HEAP32[i10 >> 2] = i2 + 1;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 + (i2 << 2) >> 2] = 1;
     i2 = HEAP32[i10 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) {
      __ZN5physx2Gu9Container6ResizeEj(i21, 1) | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      i3 = HEAP32[i11 >> 2] | 0;
     }
     HEAP32[i10 >> 2] = i2 + 1;
     HEAP32[i3 + (i2 << 2) >> 2] = i6;
    } while ((i7 | 0) != (i13 | 0));
    i1 = i1 + i13 | 0;
   }
   i16 = i16 + 1 | 0;
   if (i16 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) break; else {
    i14 = i14 + (i12 + 1 << 2) | 0;
    i15 = i15 + (i13 + 1 << 2) | 0;
   }
  }
 }
 __ZN5physx2Gu9Container5EmptyEv(i22) | 0;
 __ZN5physx2Gu9Container5EmptyEv(i24) | 0;
 __ZN5physx2Gu9ContaineraSERKS1_(i22, i20);
 __ZN5physx2Gu9ContaineraSERKS1_(i24, i21);
 HEAP32[i19 >> 2] = i1;
 __ZN5physx2Gu9ContainerD2Ev(i21);
 __ZN5physx2Gu9ContainerD2Ev(i20);
 __ZN5physx2Gu9ContainerD2Ev(i23);
 STACKTOP = i25;
 return;
}

function __ZN23ParticleSystemParticles14element_assignEjj(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = HEAP32[i7 + 868 >> 2] | 0;
 i2 = (HEAP8[i7 + 872 >> 0] | 0) == 0;
 i1 = i6 >>> 16 & 255;
 i3 = i6 >>> 24 & 255;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i8 << 2) >> 2] = HEAP32[i5 + (i9 << 2) >> 2];
 i5 = HEAP32[i7 + 60 >> 2] | 0;
 HEAP32[i5 + (i8 << 2) >> 2] = HEAP32[i5 + (i9 << 2) >> 2];
 i5 = HEAP32[i7 + 120 >> 2] | 0;
 HEAP32[i5 + (i8 << 2) >> 2] = HEAP32[i5 + (i9 << 2) >> 2];
 do if (!((i6 & 255) << 24 >> 24)) {
  if (!i2) {
   i6 = HEAP32[i7 + 180 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  }
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i6 = HEAP32[i7 + 80 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i6 = HEAP32[i7 + 140 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  if (!i2) {
   i6 = HEAP32[i7 + 200 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  }
  i6 = HEAP32[i7 + 40 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i6 = HEAP32[i7 + 100 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i6 = HEAP32[i7 + 160 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  if (!i2) {
   i6 = HEAP32[i7 + 220 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  }
 } else {
  i6 = HEAP32[i7 + 240 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  if (i2) {
   i6 = HEAP32[i7 + 20 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 80 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 140 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 260 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 40 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 100 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 160 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i6 = HEAP32[i7 + 280 >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   break;
  } else {
   i3 = HEAP32[i7 + 180 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 80 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 140 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 260 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 200 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 40 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 100 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 160 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 280 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP32[i7 + 220 >> 2] | 0;
   HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
   i3 = HEAP16[i7 + 870 >> 1] | 0;
   i1 = i3 & 255;
   i3 = (i3 & 65535) >>> 8 & 255;
   break;
  }
 } while (0);
 i1 = i1 << 24 >> 24 ? 0 : 2;
 i2 = i1;
 do {
  i6 = HEAP32[i7 + 300 + (i2 * 20 | 0) >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 3);
 if (HEAP8[i7 + 869 >> 0] | 0) do {
  i6 = HEAP32[i7 + 360 + (i1 * 20 | 0) >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 i6 = HEAP32[i7 + 420 >> 2] | 0;
 HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
 if (i3 << 24 >> 24) {
  i6 = HEAP32[i7 + 440 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
  i6 = HEAP32[i7 + 460 >> 2] | 0;
  HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
 }
 i2 = HEAP32[i7 + 480 >> 2] | 0;
 HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
 i2 = HEAP32[i7 + 500 >> 2] | 0;
 HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
 i2 = HEAP32[i7 + 520 >> 2] | 0;
 HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
 i2 = HEAP32[i7 + 540 >> 2] | 0;
 HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
 i2 = HEAP32[i7 + 880 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i6 = HEAP32[i7 + 560 + (i1 * 20 | 0) >> 2] | 0;
   HEAP32[i6 + (i8 << 2) >> 2] = HEAP32[i6 + (i9 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
 }
 do if (HEAP8[i7 + 873 >> 0] | 0) {
  i1 = HEAP32[i7 + 608 >> 2] | 0;
  i2 = 1 << (i8 & 31);
  if (!(HEAP32[i1 + (i9 >>> 5 << 2) >> 2] & 1 << (i9 & 31))) {
   i6 = i1 + (i8 >>> 5 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~i2;
   break;
  } else {
   i6 = i1 + (i8 >>> 5 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i2;
   break;
  }
 } while (0);
 L35 : do if (HEAP8[i7 + 874 >> 0] | 0) {
  i3 = HEAP32[i7 + 760 >> 2] | 0;
  HEAP32[i3 + (i8 << 2) >> 2] = HEAP32[i3 + (i9 << 2) >> 2];
  i3 = i7 + 780 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 + (i8 << 2) >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
  i4 = i7 + 800 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i5 + (i9 << 2) >> 2] | 0;
  HEAP32[i5 + (i8 << 2) >> 2] = i6;
  if (i6 | 0) {
   i5 = i7 + 824 | 0;
   i6 = i7 + 740 | 0;
   i1 = 0;
   while (1) {
    i12 = HEAP32[i5 >> 2] | 0;
    i10 = Math_imul(i12, i8) | 0;
    i13 = HEAP32[i6 >> 2] | 0;
    i10 = i13 + (((((HEAP32[i2 + (i8 << 2) >> 2] | 0) + i1 | 0) >>> 0) % (i12 >>> 0) | 0) + i10 << 4) | 0;
    i11 = Math_imul(i12, i9) | 0;
    i2 = i13 + (((((HEAP32[i2 + (i9 << 2) >> 2] | 0) + i1 | 0) >>> 0) % (i12 >>> 0) | 0) + i11 << 4) | 0;
    HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[(HEAP32[i4 >> 2] | 0) + (i8 << 2) >> 2] | 0) >>> 0) break L35;
    i2 = HEAP32[i3 >> 2] | 0;
   }
  }
 } while (0);
 if (HEAP32[i7 + 844 >> 2] & 2147483647 | 0) {
  i12 = HEAP32[i7 + 828 >> 2] | 0;
  i13 = i12 + (i8 << 4) | 0;
  i12 = i12 + (i9 << 4) | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 }
 if (!(HEAP32[i7 + 864 >> 2] & 2147483647)) return;
 i12 = HEAP32[i7 + 848 >> 2] | 0;
 i13 = i12 + (i8 << 4) | 0;
 i12 = i12 + (i9 << 4) | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 return;
}

function __ZN7dtCrowd8addAgentER13dtCrowdHandlePKfPK18dtCrowdAgentParams(i19, i15, i3, i16) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 140 | 0;
 i12 = i22;
 i4 = i22 + 8 | 0;
 HEAP32[i15 >> 2] = -1;
 i2 = i4 + 128 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 124 >> 2] = Math_fround(1.0);
 i11 = i19 + 12 | 0;
 i5 = i4;
 i1 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 128 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i14 = i16 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 i2 = i19 + 464 | 0;
 __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i2 >> 2] | 0, i3, i19 + 432 | 0, i4, i12, i21) | 0;
 i18 = i12;
 if ((HEAP32[i18 >> 2] | 0) == 0 & (HEAP32[i18 + 4 >> 2] | 0) == 0) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 __ZNK15HeightMeshQuery17SetPositionHeightEPf(HEAP32[i19 + 468 >> 2] | 0, i21) | 0;
 i3 = i19 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == (HEAP32[i19 >> 2] | 0)) {
  i18 = i1 << 1;
  if (__ZN7dtCrowd13ReserveAgentsEi(i19, (i18 | 0) > 1 ? i18 : 1) | 0) {
   i18 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i21 = 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 } else i18 = i1; while (0);
 i13 = i19 + 16 | 0;
 i17 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 if (!i2) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i6 = i17 + (i18 * 608 | 0) + 24 | 0;
 HEAP32[i6 >> 2] = i2;
 i1 = i17 + (i18 * 608 | 0) + 40 | 0;
 HEAP32[i1 >> 2] = 32;
 i10 = __Z7dtAlloci(256) | 0;
 i5 = i17 + (i18 * 608 | 0) + 28 | 0;
 HEAP32[i5 >> 2] = i10;
 if (!i10) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 HEAP32[i17 + (i18 * 608 | 0) + 36 >> 2] = HEAP32[i1 >> 2];
 i7 = i17 + (i18 * 608 | 0) + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i17 + (i18 * 608 | 0) + 44 | 0;
 HEAP8[i8 >> 0] = 1;
 i9 = i17 + (i18 * 608 | 0) + 48 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 + 56 >> 2];
 i10 = i19 + 24 | 0;
 _memcpy((HEAP32[i10 >> 2] | 0) + (i18 * 132 | 0) | 0, HEAP32[i11 >> 2] | 0, 132) | 0;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i18 * 132 | 0) + 128 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i3 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + (i18 * 608 | 0) + 384 >> 2];
 HEAP32[i15 >> 2] = i18;
 i4 = i12;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0;
 if ((i3 | 0) == 0 & (i4 | 0) == 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = 0;
 } else {
  i12 = i1;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i4;
  HEAP32[i17 + (i18 * 608 | 0) >> 2] = HEAP32[i21 >> 2];
  i12 = i21 + 4 | 0;
  HEAP32[i17 + (i18 * 608 | 0) + 4 >> 2] = HEAP32[i12 >> 2];
  i1 = i21 + 8 | 0;
  HEAP32[i17 + (i18 * 608 | 0) + 8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i17 + (i18 * 608 | 0) + 12 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + (i18 * 608 | 0) + 16 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i17 + (i18 * 608 | 0) + 20 >> 2] = HEAP32[i1 >> 2];
  i1 = 1;
 }
 HEAP32[i7 >> 2] = 1;
 HEAP8[i8 >> 0] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAPF32[i17 + (i18 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i17 + (i18 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i17 + (i18 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i17 + (i18 * 608 | 0) + 288 >> 2] = 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) + (i3 * 608 | 0) + 292 | 0;
 HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 i2 = (HEAP32[i10 >> 2] | 0) + (i3 * 132 | 0) + 128 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[i13 >> 2] | 0;
  if ((HEAP32[i1 + (i3 * 608 | 0) + 476 >> 2] | 0) > 0) i20 = 14; else if ((HEAP32[i1 + (i3 * 608 | 0) + 32 >> 2] | 0) > 1) i20 = 14; else if (HEAP8[i1 + (i3 * 608 | 0) + 44 >> 0] & 2) i20 = 14;
  if ((i20 | 0) == 14) HEAP32[i1 + (i3 * 608 | 0) + 48 >> 2] = 0;
  if ((HEAP8[i1 + (i3 * 608 | 0) + 600 >> 0] | 0) == 2) if ((HEAP32[i19 + 32 >> 2] | 0) == (HEAP32[i19 + 452 >> 2] | 0)) if (HEAP32[i19 + 92 >> 2] & 536870912 | 0) HEAP32[i19 + 100 >> 2] = 0;
 }
 HEAP32[i17 + (i18 * 608 | 0) + 384 >> 2] = 0;
 HEAP32[i17 + (i18 * 608 | 0) + 476 >> 2] = 0;
 i3 = HEAP32[i21 >> 2] | 0;
 HEAP32[i17 + (i18 * 608 | 0) + 480 >> 2] = i3;
 i4 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i17 + (i18 * 608 | 0) + 484 >> 2] = i4;
 i1 = HEAP32[i21 + 8 >> 2] | 0;
 HEAP32[i17 + (i18 * 608 | 0) + 488 >> 2] = i1;
 HEAPF32[i17 + (i18 * 608 | 0) + 556 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + (i18 * 608 | 0) + 560 >> 2] = Math_fround(0.0);
 i2 = i17 + (i18 * 608 | 0) + 552 | 0;
 i5 = i17 + (i18 * 608 | 0) + 492 | 0;
 i6 = i5 + 60 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i2 >> 2] = Math_fround(-1.0);
 HEAP8[i17 + (i18 * 608 | 0) + 601 >> 0] = 0;
 i21 = i17 + (i18 * 608 | 0) + 602 | 0;
 HEAP8[i21 >> 0] = HEAP8[i21 >> 0] & -64 | 1;
 i21 = i17 + (i18 * 608 | 0) + 592 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP8[i17 + (i18 * 608 | 0) + 600 >> 0] = 0;
 HEAP32[i17 + (i18 * 608 | 0) + 564 >> 2] = i3;
 HEAP32[i17 + (i18 * 608 | 0) + 568 >> 2] = i4;
 HEAP32[i17 + (i18 * 608 | 0) + 572 >> 2] = i1;
 i21 = 1;
 STACKTOP = i22;
 return i21 | 0;
}

function _XXH64_digest(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i5 = i6 + 48 | 0;
 i7 = HEAP32[i6 + 80 >> 2] | 0;
 i8 = i5 + i7 | 0;
 i1 = i6;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i1 >>> 0 > 0 | (i1 | 0) == 0 & i4 >>> 0 > 31) {
  i15 = i6 + 16 | 0;
  i12 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 4 >> 2] | 0;
  i13 = i6 + 24 | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i11 = i6 + 32 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = i6 + 40 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i18 = _bitshift64Shl(i12 | 0, i15 | 0, 1) | 0;
  i14 = getTempRet0() | 0;
  i16 = _bitshift64Lshr(i12 | 0, i15 | 0, 63) | 0;
  i14 = i14 | (getTempRet0() | 0);
  i20 = _bitshift64Shl(i9 | 0, i13 | 0, 7) | 0;
  i19 = getTempRet0() | 0;
  i17 = _bitshift64Lshr(i9 | 0, i13 | 0, 57) | 0;
  i14 = _i64Add(i20 | i17 | 0, i19 | (getTempRet0() | 0) | 0, i18 | i16 | 0, i14 | 0) | 0;
  i16 = getTempRet0() | 0;
  i18 = _bitshift64Shl(i2 | 0, i11 | 0, 12) | 0;
  i19 = getTempRet0() | 0;
  i17 = _bitshift64Lshr(i2 | 0, i11 | 0, 52) | 0;
  i19 = _i64Add(i14 | 0, i16 | 0, i18 | i17 | 0, i19 | (getTempRet0() | 0) | 0) | 0;
  i17 = getTempRet0() | 0;
  i18 = _bitshift64Shl(i3 | 0, i10 | 0, 18) | 0;
  i16 = getTempRet0() | 0;
  i14 = _bitshift64Lshr(i3 | 0, i10 | 0, 46) | 0;
  i16 = _i64Add(i19 | 0, i17 | 0, i18 | i14 | 0, i16 | (getTempRet0() | 0) | 0) | 0;
  i14 = getTempRet0() | 0;
  i18 = ___muldi3(i12 | 0, i15 | 0, 668265295, -1028477379) | 0;
  i17 = getTempRet0() | 0;
  i15 = ___muldi3(i12 | 0, i15 | 0, -2147483648, -1813351001) | 0;
  i12 = getTempRet0() | 0;
  i17 = _bitshift64Lshr(i18 | 0, i17 | 0, 33) | 0;
  i12 = ___muldi3(i17 | i15 | 0, getTempRet0() | 0 | i12 | 0, -2048144761, -1640531535) | 0;
  i14 = ___muldi3(i16 ^ i12 | 0, i14 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i14 = _i64Add(i14 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
  i12 = getTempRet0() | 0;
  i16 = ___muldi3(i9 | 0, i13 | 0, 668265295, -1028477379) | 0;
  i15 = getTempRet0() | 0;
  i13 = ___muldi3(i9 | 0, i13 | 0, -2147483648, -1813351001) | 0;
  i9 = getTempRet0() | 0;
  i15 = _bitshift64Lshr(i16 | 0, i15 | 0, 33) | 0;
  i9 = ___muldi3(i15 | i13 | 0, getTempRet0() | 0 | i9 | 0, -2048144761, -1640531535) | 0;
  i12 = ___muldi3(i14 ^ i9 | 0, i12 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i12 = _i64Add(i12 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
  i9 = getTempRet0() | 0;
  i14 = ___muldi3(i2 | 0, i11 | 0, 668265295, -1028477379) | 0;
  i13 = getTempRet0() | 0;
  i11 = ___muldi3(i2 | 0, i11 | 0, -2147483648, -1813351001) | 0;
  i2 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i14 | 0, i13 | 0, 33) | 0;
  i2 = ___muldi3(i13 | i11 | 0, getTempRet0() | 0 | i2 | 0, -2048144761, -1640531535) | 0;
  i9 = ___muldi3(i12 ^ i2 | 0, i9 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i9 = _i64Add(i9 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
  i2 = getTempRet0() | 0;
  i12 = ___muldi3(i3 | 0, i10 | 0, 668265295, -1028477379) | 0;
  i11 = getTempRet0() | 0;
  i10 = ___muldi3(i3 | 0, i10 | 0, -2147483648, -1813351001) | 0;
  i3 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i12 | 0, i11 | 0, 33) | 0;
  i3 = ___muldi3(i11 | i10 | 0, getTempRet0() | 0 | i3 | 0, -2048144761, -1640531535) | 0;
  i2 = ___muldi3(i9 ^ i3 | 0, i2 ^ (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
  i3 = getTempRet0() | 0;
 } else {
  i2 = i6 + 8 | 0;
  i2 = _i64Add(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 374761413, 668265263) | 0;
  i3 = getTempRet0() | 0;
 }
 i2 = _i64Add(i2 | 0, i3 | 0, i4 | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 i4 = i6 + 56 | 0;
 if (i4 >>> 0 > i8 >>> 0) i4 = i5; else {
  i3 = i5;
  while (1) {
   i20 = i3;
   i20 = HEAPU8[i20 >> 0] | HEAPU8[i20 + 1 >> 0] << 8 | HEAPU8[i20 + 2 >> 0] << 16 | HEAPU8[i20 + 3 >> 0] << 24;
   i3 = i3 + 4 | 0;
   i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   i18 = ___muldi3(i20 | 0, i3 | 0, 668265295, -1028477379) | 0;
   i19 = getTempRet0() | 0;
   i3 = ___muldi3(i20 | 0, i3 | 0, -2147483648, -1813351001) | 0;
   i20 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i18 | 0, i19 | 0, 33) | 0;
   i20 = ___muldi3(i19 | i3 | 0, getTempRet0() | 0 | i20 | 0, -2048144761, -1640531535) | 0;
   i20 = i20 ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i3 = _bitshift64Shl(i20 | 0, i1 | 0, 27) | 0;
   i2 = getTempRet0() | 0;
   i1 = _bitshift64Lshr(i20 | 0, i1 | 0, 37) | 0;
   i2 = ___muldi3(i3 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
   i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1028477341, -2048144777) | 0;
   i1 = getTempRet0() | 0;
   i3 = i4 + 8 | 0;
   if (i3 >>> 0 > i8 >>> 0) break; else {
    i20 = i4;
    i4 = i3;
    i3 = i20;
   }
  }
 }
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i8 >>> 0) i3 = i4; else {
  i19 = ___muldi3(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24 | 0, 0, -2048144761, -1640531535) | 0;
  i19 = i19 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i20 = _bitshift64Shl(i19 | 0, i1 | 0, 23) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i19 | 0, i1 | 0, 41) | 0;
  i2 = ___muldi3(i20 | i1 | 0, i2 | (getTempRet0() | 0) | 0, 668265295, -1028477379) | 0;
  i2 = _i64Add(i2 | 0, getTempRet0() | 0, -1640531463, 374761393) | 0;
  i1 = getTempRet0() | 0;
 }
 if (i3 >>> 0 >= i8 >>> 0) {
  i20 = i2;
  i19 = i1;
  i18 = _bitshift64Lshr(i20 | 0, i19 | 0, 33) | 0;
  i17 = getTempRet0() | 0;
  i20 = i18 ^ i20;
  i19 = i17 ^ i19;
  i19 = ___muldi3(i20 | 0, i19 | 0, 668265295, -1028477379) | 0;
  i20 = getTempRet0() | 0;
  i17 = _bitshift64Lshr(i19 | 0, i20 | 0, 29) | 0;
  i18 = getTempRet0() | 0;
  i19 = i17 ^ i19;
  i20 = i18 ^ i20;
  i20 = ___muldi3(i19 | 0, i20 | 0, -1640531463, 374761393) | 0;
  i19 = getTempRet0() | 0;
  i20 = i19 ^ i20;
  setTempRet0(i19 | 0);
  return i20 | 0;
 }
 i4 = i6 + (i7 + 48) | 0;
 do {
  i19 = ___muldi3(HEAPU8[i3 >> 0] | 0 | 0, 0, 374761413, 668265263) | 0;
  i19 = i19 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i20 = _bitshift64Shl(i19 | 0, i1 | 0, 11) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i19 | 0, i1 | 0, 53) | 0;
  i2 = ___muldi3(i20 | i1 | 0, i2 | (getTempRet0() | 0) | 0, -2048144761, -1640531535) | 0;
  i1 = getTempRet0() | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 i20 = _bitshift64Lshr(i2 | 0, i1 | 0, 33) | 0;
 i19 = getTempRet0() | 0;
 i20 = i20 ^ i2;
 i19 = i19 ^ i1;
 i19 = ___muldi3(i20 | 0, i19 | 0, 668265295, -1028477379) | 0;
 i20 = getTempRet0() | 0;
 i17 = _bitshift64Lshr(i19 | 0, i20 | 0, 29) | 0;
 i18 = getTempRet0() | 0;
 i19 = i17 ^ i19;
 i20 = i18 ^ i20;
 i20 = ___muldi3(i19 | 0, i20 | 0, -1640531463, 374761393) | 0;
 i19 = getTempRet0() | 0;
 i20 = i19 ^ i20;
 setTempRet0(i19 | 0);
 return i20 | 0;
}

function __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i13, i14, f6, i17, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 f6 = Math_fround(f6);
 i17 = i17 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18 + 32 | 0;
 i10 = i18 + 16 | 0;
 i11 = i18;
 if ((HEAP16[gb + 1452188 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452188 | 0, i8);
  i12 = gb + 1452188 | 0;
 } else i12 = 0;
 i5 = i13 + 36 | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 i16 = HEAP32[i13 + 40 >> 2] | 0;
 i7 = i1 + 3 | 0;
 HEAP32[i16 + 16 >> 2] = i7 - ((i7 | 0) % 4 | 0);
 i7 = i16 + 31 | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i19 = HEAP32[i16 + 104 >> 2] | 0;
  i1 = HEAP32[i16 + 108 >> 2] | 0;
  HEAP32[i16 + 280 >> 2] = HEAP32[i16 + 100 >> 2];
  HEAP32[i16 + 284 >> 2] = i19;
  HEAP32[i16 + 288 >> 2] = i1;
  if (Math_fround(HEAPF32[i16 + 396 >> 2]) == Math_fround(0.0)) if (+HEAPF64[i16 + 32 >> 3] == 0.0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   i19 = HEAP32[(HEAP32[i5 >> 2] | 0) + 272 >> 2] | 0;
   i1 = (Math_imul(i19, 1790253981) | 0) + 1900727103 | 0;
   i19 = i19 << 11 ^ i19;
   f2 = Math_fround(Math_fround(((i1 ^ i19 ^ i19 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i10 + 12 >> 2] = f2;
   HEAPF32[i10 + 8 >> 2] = f2;
   HEAPF32[i10 + 4 >> 2] = f2;
   HEAPF32[i10 >> 2] = f2;
   i1 = HEAP32[i15 + 84 >> 2] | 0;
   L9 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i19 = HEAP32[i15 + 80 >> 2] | 0;
     HEAP32[i11 + 12 >> 2] = i19;
     HEAP32[i11 + 8 >> 2] = i19;
     HEAP32[i11 + 4 >> 2] = i19;
     HEAP32[i11 >> 2] = i19;
     break;
    }
   case 3:
    {
     f9 = Math_fround(HEAPF32[(HEAP32[i15 + 232 >> 2] | 0) + 4 >> 2]);
     f4 = Math_fround(HEAPF32[i15 + 80 >> 2]);
     f9 = Math_fround(f9 * f4);
     f9 = Math_fround(f9 + Math_fround(f2 * Math_fround(Math_fround(f4 * Math_fround(HEAPF32[(HEAP32[i15 + 144 >> 2] | 0) + 4 >> 2])) - f9)));
     HEAPF32[i11 >> 2] = f9;
     HEAPF32[i11 + 4 >> 2] = f9;
     HEAPF32[i11 + 8 >> 2] = f9;
     HEAPF32[i11 + 12 >> 2] = f9;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i11, i15, i8, i10);
     break L9;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i11, i15, i8, i10);
     break L9;
    }
   } while (0);
   HEAP32[i16 + 4 >> 2] = HEAP32[i11 >> 2];
  }
  HEAP8[i7 >> 0] = 0;
 }
 i8 = i16 + 8 | 0;
 do if (f6 > Math_fround(.0000999999974) & (HEAP32[i8 >> 2] | 0) == 1) {
  if ((HEAP32[i15 + 280 >> 2] | 0) != 1) {
   i19 = i16 + 292 | 0;
   HEAP32[i19 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   break;
  }
  i1 = HEAP32[i16 + 100 >> 2] | 0;
  i5 = HEAP32[i16 + 104 >> 2] | 0;
  i7 = HEAP32[i16 + 108 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i16 + 280 >> 2]);
  f4 = Math_fround(HEAPF32[i16 + 284 >> 2]);
  f2 = Math_fround(HEAPF32[i16 + 288 >> 2]);
  if (!(HEAP8[i16 + 328 >> 0] | 0)) {
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f3);
   f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f4);
   f4 = Math_fround(f4 / f6);
   f9 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2) / f6);
   HEAPF32[i16 + 292 >> 2] = Math_fround(f3 / f6);
   HEAPF32[i16 + 296 >> 2] = f4;
   HEAPF32[i16 + 300 >> 2] = f9;
   break;
  } else {
   f21 = Math_fround(Math_fround(HEAPF32[i16 + 332 >> 2]) - f3);
   f20 = Math_fround(Math_fround(HEAPF32[i16 + 336 >> 2]) - f4);
   f2 = Math_fround(Math_fround(HEAPF32[i16 + 340 >> 2]) - f2);
   f3 = Math_fround(HEAPF32[i16 + 344 >> 2]);
   f3 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f4 = Math_fround(HEAPF32[i16 + 348 >> 2]);
   f4 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f9 = Math_fround(HEAPF32[i16 + 352 >> 2]);
   f3 = Math_fround(Math_fround(f21 - f3) / f6);
   f4 = Math_fround(Math_fround(f20 - f4) / f6);
   f9 = Math_fround(Math_fround(f2 - Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])))) / f6);
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i16 + 356 >> 2]));
   f4 = Math_fround(f4 + Math_fround(HEAPF32[i16 + 360 >> 2]));
   f9 = Math_fround(f9 + Math_fround(HEAPF32[i16 + 364 >> 2]));
   HEAPF32[i16 + 292 >> 2] = f3;
   HEAPF32[i16 + 296 >> 2] = f4;
   HEAPF32[i16 + 300 >> 2] = f9;
   break;
  }
 } while (0);
 HEAP32[i14 + 632 >> 2] = 0;
 __ZN14ParticleSystem22AllocateParticleArraysEv(i13);
 i1 = HEAP32[i13 + 904 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN15CollisionModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i15, i16);
 f9 = Math_fround(HEAPF32[i15 + 268 >> 2]);
 i1 = f9 < Math_fround(0.0);
 f9 = Math_fround((i1 ? Math_fround(0.0) : f9) * f6);
 i1 = __Z14GetTimeManagerv() | 0;
 if (!(i17 & 1)) if (Math_fround(HEAPF32[i1 + 204 >> 2]) < f9) f6 = Math_fround(f9 / Math_fround(Math_ceil(Math_fround(f9 / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 204 >> 2]))))); else f6 = f9; else f6 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 if (!(f6 < Math_fround(9.99999974e-06))) {
  if ((HEAP32[i8 >> 2] | 0) == 1) {
   f2 = Math_fround(f9 + Math_fround(HEAPF32[i16 >> 2]));
   HEAPF32[i16 >> 2] = f2;
   if (!(HEAP8[i16 + 13 >> 0] | 0)) if (HEAP8[i13 + 268 >> 0] | 0) if (Math_fround(HEAPF32[i13 + 616 >> 2]) > Math_fround(0.0)) {
    f4 = Math_fround(HEAPF32[i16 + 396 >> 2]);
    f2 = Math_fround(f2 + f4);
    f3 = Math_fround(HEAPF32[i15 + 264 >> 2]);
    if (!(HEAP8[i15 + 277 >> 0] | 0)) f2 = f3 < f2 ? f3 : f2; else f2 = Math_fround(_fmodf(f2, f3));
    i19 = __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff(i16 + 488 | 0, i13 + 272 | 0, i16 + 292 | 0, f4, f2, f9, f3) | 0;
    __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf(i13, i14, Math_fround(0.0), f2, f9, i19, i19, Math_fround(0.0));
   }
   __ZN14ParticleSystem18Update1IncrementalERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesfNS_11UpdateFlagsE(i13, i15, i16, i14, f6, i17);
   if (i17 & 2 | 0) __ZN14ParticleSystem16UpdateProceduralERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles(i13, i15, i16, i14);
  }
  __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i13, i14, i16);
 }
 if (!i12) {
  STACKTOP = i18;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i18;
 return;
}

function __Z24ConvertBufferToPNGBufferPKhjjj13TextureFormatPvPFvS2_PhjE(i7, i8, i9, i10, i11, i12, i13) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = 4;
 i18 = _malloc(40) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i19 + 12 | 0;
 i15 = i19 + 8 | 0;
 i16 = i19;
 __THREW__ = 0;
 i4 = invoke_iiiii(fb + 142 | 0, gb + 402099 | 0, 0, 0, 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
  if (!i2) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i2 = -1;
 i1 = getTempRet0() | 0;
 do if ((i2 | 0) == 1) {
  i6 = 0;
  i5 = 10;
 } else {
  HEAP32[i14 >> 2] = i4;
  if (!i4) {
   i17 = 0;
   _free(i18 | 0);
   STACKTOP = i19;
   return i17 | 0;
  }
  __THREW__ = 0;
  i2 = invoke_ii(fb + 1566 | 0, i4 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
   if (!i3) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i3 = -1;
  i1 = getTempRet0() | 0;
  if ((i3 | 0) == 1) {
   i6 = i15;
   i5 = 10;
  } else {
   HEAP32[i15 >> 2] = i2;
   if (!i2) {
    __THREW__ = 0;
    invoke_vii(fb + 2407 | 0, i14 | 0, i15 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i6 = i15;
     i5 = 10;
     break;
    }
    i1 = 0;
    break;
   }
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 347 | 0, i4 | 0, fb + 2356 | 0, 156) | 0;
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i3) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i3 = -1;
   i1 = getTempRet0() | 0;
   if ((i3 | 0) == 1) {
    i6 = i15;
    i5 = 10;
   } else {
    i18 = _saveSetjmp(i2, 1, i18 | 0, i17 | 0) | 0;
    i17 = getTempRet0() | 0;
    __THREW__ = 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i6 = i15;
     i5 = 10;
    } else {
     i6 = i15;
     i1 = 0;
     i5 = 10;
    }
   }
  }
 } while (0);
 do if ((i5 | 0) == 10) {
  L14 : while (1) {
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vii(fb + 2407 | 0, i14 | 0, i15 | 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) {
     i5 = i6;
     i6 = i5;
     i5 = 10;
     continue;
    } else {
     i5 = 12;
     break;
    }
   }
   HEAP32[i16 + 4 >> 2] = i12;
   HEAP32[i16 >> 2] = i13;
   __THREW__ = 0;
   invoke_viiii(fb + 215 | 0, HEAP32[i14 >> 2] | 0, i16 | 0, fb + 508 | 0, fb + 3376 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i6;
    i6 = i5;
    i5 = 10;
    continue;
   }
   __THREW__ = 0;
   invoke_vii(fb + 2408 | 0, HEAP32[i14 >> 2] | 0, 1);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i6;
    i6 = i5;
    i5 = 10;
    continue;
   }
   __THREW__ = 0;
   invoke_viiiiiiiii(fb + 10 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, i8 | 0, i9 | 0, 8, ((i11 | 0) == 3 ? 2 : 6) | 0, 0, 0, 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i6;
    i6 = i5;
    i5 = 10;
    continue;
   }
   __THREW__ = 0;
   invoke_vii(fb + 2409 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i6;
    i6 = i5;
    i5 = 10;
    continue;
   }
   i1 = HEAP32[i14 >> 2] | 0;
   if (i9) {
    i4 = i9 + -1 | 0;
    i3 = 0;
    while (1) {
     i5 = i7 + (Math_imul(i4 - i3 | 0, i10) | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 2411 | 0, i1 | 0, i5 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
      i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
      if (!i2) _longjmp(i1 | 0, threwValue | 0);
      setTempRet0(threwValue | 0);
     } else i2 = -1;
     i1 = getTempRet0() | 0;
     if ((i2 | 0) == 1) {
      i5 = i6;
      i6 = i5;
      i5 = 10;
      continue L14;
     }
     i3 = i3 + 1 | 0;
     i1 = HEAP32[i14 >> 2] | 0;
     if ((i3 | 0) == (i9 | 0)) break;
    }
   }
   __THREW__ = 0;
   invoke_vii(fb + 2410 | 0, i1 | 0, HEAP32[i15 >> 2] | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i5 = i6;
    i6 = i5;
    i5 = 10;
    continue;
   }
   __THREW__ = 0;
   invoke_vii(fb + 2407 | 0, i14 | 0, i15 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i18 | 0, i17 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) != 1) {
    i5 = 21;
    break;
   } else {
    i5 = i6;
    i6 = i5;
    i5 = 10;
   }
  }
  if ((i5 | 0) == 12) {
   i1 = 0;
   break;
  } else if ((i5 | 0) == 21) {
   i1 = 1;
   break;
  }
 } while (0);
 i17 = i1;
 _free(i18 | 0);
 STACKTOP = i19;
 return i17 | 0;
}

function __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj(i23, f4, f5, i17, i16, i18, i19, i20, i2, i1) {
 i23 = i23 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i17 = i17 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i21 = 0, i22 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 80 | 0;
 i21 = i24;
 i3 = (i1 | 0) == 1 ? 2 : 1;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i22 >> 2] = 2122317823;
 HEAP32[i22 + 4 >> 2] = 2122317823;
 HEAP32[i22 + 8 >> 2] = 2122317823;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i21 >> 2] = -25165825;
 HEAP32[i21 + 4 >> 2] = -25165825;
 HEAP32[i21 + 8 >> 2] = -25165825;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i22 + 16 >> 2] = 2122317823;
 HEAP32[i22 + 20 >> 2] = 2122317823;
 HEAP32[i22 + 24 >> 2] = 2122317823;
 HEAP32[i22 + 28 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = -25165825;
 HEAP32[i21 + 20 >> 2] = -25165825;
 HEAP32[i21 + 24 >> 2] = -25165825;
 HEAP32[i21 + 28 >> 2] = 0;
 HEAP32[i22 + 32 >> 2] = 2122317823;
 HEAP32[i22 + 36 >> 2] = 2122317823;
 HEAP32[i22 + 40 >> 2] = 2122317823;
 HEAP32[i22 + 44 >> 2] = 0;
 HEAP32[i21 + 32 >> 2] = -25165825;
 HEAP32[i21 + 36 >> 2] = -25165825;
 HEAP32[i21 + 40 >> 2] = -25165825;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i22 + 48 >> 2] = 2122317823;
 HEAP32[i22 + 52 >> 2] = 2122317823;
 HEAP32[i22 + 56 >> 2] = 2122317823;
 HEAP32[i22 + 60 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = -25165825;
 HEAP32[i21 + 52 >> 2] = -25165825;
 HEAP32[i21 + 56 >> 2] = -25165825;
 HEAP32[i21 + 60 >> 2] = 0;
 HEAP32[i22 + 64 >> 2] = 2122317823;
 HEAP32[i22 + 68 >> 2] = 2122317823;
 HEAP32[i22 + 72 >> 2] = 2122317823;
 HEAP32[i22 + 76 >> 2] = 0;
 HEAP32[i21 + 64 >> 2] = -25165825;
 HEAP32[i21 + 68 >> 2] = -25165825;
 HEAP32[i21 + 72 >> 2] = -25165825;
 HEAP32[i21 + 76 >> 2] = 0;
 i15 = (i17 | 0) == 0;
 if (!i15) {
  i1 = i2 ? 16 : 0;
  i2 = 0;
  do {
   i6 = i16 + (i2 << 5) | 0;
   f34 = Math_fround(HEAPF32[i6 >> 2]);
   f36 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f40 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f38 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   i14 = i16 + (i2 << 5) + 16 | 0;
   f31 = Math_fround(HEAPF32[i14 >> 2]);
   f29 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i14 + 12 >> 2]);
   f39 = Math_fround(f34 - f31);
   f37 = Math_fround(f36 - f29);
   f35 = Math_fround(f40 - f27);
   f33 = Math_fround(f38 - f25);
   f31 = Math_fround(f34 + f31);
   f29 = Math_fround(f36 + f29);
   f27 = Math_fround(f40 + f27);
   f25 = Math_fround(f38 + f25);
   f38 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
   f40 = Math_fround(HEAPF32[i14 + (i3 << 2) >> 2]);
   i14 = HEAPU8[((Math_fround(f38 - f40) > f5 & 1) << 2 | i1 | (Math_fround(f38 + f40) < f5 & 1) << 3 | f39 > f4 | (f31 < f4 & 1) << 1) + (gb + 710543) >> 0] | 0;
   i6 = i22 + (i14 << 4) | 0;
   f40 = Math_fround(HEAPF32[i6 >> 2]);
   i7 = i6 + 4 | 0;
   f38 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i6 + 8 | 0;
   f36 = Math_fround(HEAPF32[i8 >> 2]);
   i9 = i6 + 12 | 0;
   f34 = Math_fround(HEAPF32[i9 >> 2]);
   i10 = i21 + (i14 << 4) | 0;
   f32 = Math_fround(HEAPF32[i10 >> 2]);
   i11 = i10 + 4 | 0;
   f30 = Math_fround(HEAPF32[i11 >> 2]);
   i12 = i10 + 8 | 0;
   f28 = Math_fround(HEAPF32[i12 >> 2]);
   i13 = i10 + 12 | 0;
   f26 = Math_fround(HEAPF32[i13 >> 2]);
   HEAPF32[i6 >> 2] = f40 < f39 ? f40 : f39;
   HEAPF32[i7 >> 2] = f38 < f37 ? f38 : f37;
   HEAPF32[i8 >> 2] = f36 < f35 ? f36 : f35;
   HEAPF32[i9 >> 2] = f34 < f33 ? f34 : f33;
   HEAPF32[i10 >> 2] = f32 > f31 ? f32 : f31;
   HEAPF32[i11 >> 2] = f30 > f29 ? f30 : f29;
   HEAPF32[i12 >> 2] = f28 > f27 ? f28 : f27;
   HEAPF32[i13 >> 2] = f26 > f25 ? f26 : f25;
   HEAP32[i16 + (i2 << 5) + 12 >> 2] = i14;
   i14 = i23 + (i14 << 2) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i17 | 0));
 }
 i10 = i23 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 i6 = HEAP32[i23 >> 2] | 0;
 i11 = i23 + 24 | 0;
 HEAP32[i11 >> 2] = i6;
 i7 = i23 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i41 = i3 + i6 | 0;
 i12 = i23 + 28 | 0;
 HEAP32[i12 >> 2] = i41;
 i8 = i23 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i41 = i2 + i41 | 0;
 i13 = i23 + 32 | 0;
 HEAP32[i13 >> 2] = i41;
 i9 = i23 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i14 = i23 + 36 | 0;
 HEAP32[i14 >> 2] = i1 + i41;
 if (!i15) {
  i1 = 0;
  do {
   i2 = HEAP32[i16 + (i1 << 5) + 12 >> 2] | 0;
   i6 = i23 + 20 + (i2 << 2) | 0;
   i41 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i41 + 1;
   i6 = i16 + (i1 << 5) | 0;
   i15 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   i42 = i19 + (i41 << 5) | 0;
   HEAP32[i42 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i42 + 4 >> 2] = i15;
   HEAP32[i42 + 8 >> 2] = i3;
   HEAP32[i42 + 12 >> 2] = i2;
   i42 = i16 + (i1 << 5) + 16 | 0;
   i2 = HEAP32[i42 + 4 >> 2] | 0;
   i3 = HEAP32[i42 + 8 >> 2] | 0;
   i15 = HEAP32[i42 + 12 >> 2] | 0;
   i6 = i19 + (i41 << 5) + 16 | 0;
   HEAP32[i6 >> 2] = HEAP32[i42 >> 2];
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i3;
   HEAP32[i6 + 12 >> 2] = i15;
   i6 = i18 + (i1 << 3) | 0;
   i15 = HEAP32[i6 + 4 >> 2] | 0;
   i41 = i20 + (i41 << 3) | 0;
   HEAP32[i41 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i41 + 4 >> 2] = i15;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i17 | 0));
  i6 = HEAP32[i23 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = i6;
 i42 = i3 + i6 | 0;
 HEAP32[i12 >> 2] = i42;
 i42 = i2 + i42 | 0;
 HEAP32[i13 >> 2] = i42;
 HEAP32[i14 >> 2] = i1 + i42;
 i1 = 0;
 do {
  i42 = i22 + (i1 << 4) | 0;
  f34 = Math_fround(HEAPF32[i42 >> 2]);
  f39 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  i42 = i21 + (i1 << 4) | 0;
  f35 = Math_fround(HEAPF32[i42 >> 2]);
  f32 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  f36 = Math_fround(Math_fround(f39 + f32) * Math_fround(.5));
  f37 = Math_fround(Math_fround(f40 + f33) * Math_fround(.5));
  f38 = Math_fround(Math_fround(f35 - f34) * Math_fround(.5));
  f39 = Math_fround(Math_fround(f32 - f39) * Math_fround(.5));
  f40 = Math_fround(Math_fround(f33 - f40) * Math_fround(.5));
  HEAPF32[i23 + 48 + (i1 << 5) >> 2] = Math_fround(Math_fround(f34 + f35) * Math_fround(.5));
  HEAPF32[i23 + 48 + (i1 << 5) + 4 >> 2] = f36;
  HEAPF32[i23 + 48 + (i1 << 5) + 8 >> 2] = f37;
  HEAPF32[i23 + 48 + (i1 << 5) + 16 >> 2] = f38;
  HEAPF32[i23 + 48 + (i1 << 5) + 20 >> 2] = f39;
  HEAPF32[i23 + 48 + (i1 << 5) + 24 >> 2] = f40;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 STACKTOP = i24;
 return;
}

function __ZN5physx19normalizePartitionsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_(i22, i24, i6, i5, i25, i23) {
 i22 = i22 | 0;
 i24 = i24 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 if (!i2) {
  i3 = 1;
  i21 = 0;
  i1 = 0;
 } else {
  i3 = HEAP32[i22 >> 2] | 0;
  i1 = 0;
  i4 = 0;
  do {
   i21 = i4;
   i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   if (i4 >>> 0 <= i21 >>> 0) break;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  if (!i1) {
   i3 = 1;
   i21 = 0;
   i1 = 0;
  } else {
   i3 = 0;
   i21 = (i5 >>> 0) / (i1 >>> 0) | 0;
  }
 }
 i2 = (i25 + 31 | 0) >>> 5;
 if ((HEAP32[i23 + 8 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i23, i2);
 i20 = i23 + 4 | 0;
 HEAP32[i20 >> 2] = i2;
 if (i3) {
  STACKTOP = i28;
  return i1 | 0;
 }
 i18 = i1;
 i19 = i1;
 L15 : while (1) {
  i19 = i19 + -1 | 0;
  i8 = i18;
  i18 = i18 + -1 | 0;
  i17 = (i18 | 0) == 0;
  if (i17) {
   i2 = HEAP32[i22 >> 2] | 0;
   i3 = 0;
  } else {
   i3 = HEAP32[i22 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + (i8 + -2 << 2) >> 2] | 0;
  }
  i5 = HEAP32[i2 + (i18 << 2) >> 2] | 0;
  L21 : do if ((i5 - i3 | 0) >>> 0 < i21 >>> 0) {
   _memset(HEAP32[i23 >> 2] | 0, 0, HEAP32[i20 >> 2] << 2 | 0) | 0;
   if (i5 >>> 0 > i3 >>> 0) {
    i7 = HEAP32[i23 >> 2] | 0;
    do {
     i2 = (HEAP32[i24 + (i3 << 5) >> 2] | 0) - i6 >> 5;
     i4 = (HEAP32[i24 + (i3 << 5) + 4 >> 2] | 0) - i6 >> 5;
     if (i2 >>> 0 < i25 >>> 0) {
      i16 = i7 + (i2 >>> 5 << 2) | 0;
      HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | HEAP32[gb + 106028 + ((i2 & 31) << 2) >> 2];
     }
     if (i4 >>> 0 < i25 >>> 0) {
      i16 = i7 + (i4 >>> 5 << 2) | 0;
      HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | HEAP32[gb + 106028 + ((i4 & 31) << 2) >> 2];
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i5 | 0));
   }
   if (i17) {
    i27 = 57;
    break L15;
   }
   i14 = HEAP32[i22 >> 2] | 0;
   i15 = HEAP32[i23 >> 2] | 0;
   i16 = i14 + (i18 << 2) | 0;
   i11 = i14 + (i8 + -2 << 2) | 0;
   i13 = i18;
   do {
    i2 = i13;
    i13 = i13 + -1 | 0;
    i12 = (i13 | 0) == 0;
    if (i12) i10 = 0; else i10 = HEAP32[i14 + (i2 + -2 << 2) >> 2] | 0;
    i2 = HEAP32[i14 + (i13 << 2) >> 2] | 0;
    L40 : do if (i2 >>> 0 > i10 >>> 0) {
     if (i13 >>> 0 >= i18 >>> 0) while (1) {
      i2 = i2 + -1 | 0;
      i3 = i24 + (i2 << 5) | 0;
      i4 = (HEAP32[i3 >> 2] | 0) - i6 >> 5;
      i5 = (HEAP32[i24 + (i2 << 5) + 4 >> 2] | 0) - i6 >> 5;
      i7 = i4 >>> 0 < i25 >>> 0;
      i8 = i5 >>> 0 < i25 >>> 0;
      if (i7) i9 = (HEAP32[gb + 106028 + ((i4 & 31) << 2) >> 2] & HEAP32[i15 + (i4 >>> 5 << 2) >> 2] | 0) == 0; else i9 = 1;
      if (i8) {
       if (i9 & (HEAP32[gb + 106028 + ((i5 & 31) << 2) >> 2] & HEAP32[i15 + (i5 >>> 5 << 2) >> 2] | 0) == 0) i27 = 52;
      } else if (i9) i27 = 52;
      if ((i27 | 0) == 52) {
       i27 = 0;
       HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i26 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i26 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i26 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i26 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i26 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       if (i7) {
        i9 = i15 + (i4 >>> 5 << 2) | 0;
        HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | HEAP32[gb + 106028 + ((i4 & 31) << 2) >> 2];
       }
       if (i8) {
        i9 = i15 + (i5 >>> 5 << 2) | 0;
        HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | HEAP32[gb + 106028 + ((i5 & 31) << 2) >> 2];
       }
       if (((HEAP32[i16 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) >>> 0 >= i21 >>> 0) break L21;
      }
      if (i2 >>> 0 <= i10 >>> 0) break L40;
     }
     do {
      i2 = i2 + -1 | 0;
      i3 = i24 + (i2 << 5) | 0;
      i4 = (HEAP32[i3 >> 2] | 0) - i6 >> 5;
      i5 = (HEAP32[i24 + (i2 << 5) + 4 >> 2] | 0) - i6 >> 5;
      i7 = i4 >>> 0 < i25 >>> 0;
      i8 = i5 >>> 0 < i25 >>> 0;
      if (i7) i9 = (HEAP32[gb + 106028 + ((i4 & 31) << 2) >> 2] & HEAP32[i15 + (i4 >>> 5 << 2) >> 2] | 0) == 0; else i9 = 1;
      if (i8) {
       if (i9 & (HEAP32[gb + 106028 + ((i5 & 31) << 2) >> 2] & HEAP32[i15 + (i5 >>> 5 << 2) >> 2] | 0) == 0) i27 = 35;
      } else if (i9) i27 = 35;
      if ((i27 | 0) == 35) {
       i27 = 0;
       HEAP32[i26 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i26 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i26 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i26 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i26 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i26 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i26 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i26 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       if (i7) {
        i9 = i15 + (i4 >>> 5 << 2) | 0;
        HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | HEAP32[gb + 106028 + ((i4 & 31) << 2) >> 2];
       }
       if (i8) {
        i4 = i15 + (i5 >>> 5 << 2) | 0;
        HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | HEAP32[gb + 106028 + ((i5 & 31) << 2) >> 2];
        i4 = i13;
        i5 = i2;
       } else {
        i4 = i13;
        i5 = i2;
       }
       while (1) {
        i9 = i14 + (i4 << 2) | 0;
        i3 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
        HEAP32[i9 >> 2] = i3;
        if ((i5 | 0) != (i3 | 0)) {
         i9 = i24 + (i5 << 5) | 0;
         i8 = i24 + (i3 << 5) | 0;
         HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
         HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
         HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
         HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
         HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
         HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
         HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
         HEAP32[i9 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
        }
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (i19 | 0)) break; else i5 = i3;
       }
       if ((i3 | 0) != (i2 | 0)) {
        i9 = i24 + (i3 << 5) | 0;
        HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
        HEAP32[i9 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
        HEAP32[i9 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
        HEAP32[i9 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
        HEAP32[i9 + 16 >> 2] = HEAP32[i26 + 16 >> 2];
        HEAP32[i9 + 20 >> 2] = HEAP32[i26 + 20 >> 2];
        HEAP32[i9 + 24 >> 2] = HEAP32[i26 + 24 >> 2];
        HEAP32[i9 + 28 >> 2] = HEAP32[i26 + 28 >> 2];
       }
       if (((HEAP32[i16 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0) >>> 0 >= i21 >>> 0) break L21;
      }
     } while (i2 >>> 0 > i10 >>> 0);
    } while (0);
   } while (!i12);
  } while (0);
  if (i17) {
   i27 = 57;
   break;
  }
 }
 if ((i27 | 0) == 57) {
  STACKTOP = i28;
  return i1 | 0;
 }
 return 0;
}

function __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i5 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 64 | 0, gb + 381007 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 76 | 0, gb + 381017 | 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i5 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 108 | 0, i6);
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 132 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 136 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 140 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 141 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 142 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 143 >> 0] = i1;
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i9 = HEAP16[i7 >> 1] | 0;
  i9 = _llvm_bswap_i16(i9 | 0) | 0;
  HEAP16[i1 >> 1] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  i9 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP16[i2 >> 1] | 0;
  HEAP16[i7 >> 1] = i9;
  HEAP32[i8 >> 2] = i3;
  i9 = _llvm_bswap_i16(i9 | 0) | 0;
  HEAP16[i1 >> 1] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  i9 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN9rapidjson8internal6u64toaEyPc(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (i6 >>> 0 < 0 | (i6 | 0) == 0 & i7 >>> 0 < 1e8) if (i7 >>> 0 < 1e4) {
  i2 = ((i7 >>> 0) / 100 | 0) << 1;
  i3 = ((i7 >>> 0) % 100 | 0) << 1;
  if (i7 >>> 0 > 999) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i12 = 6;
  } else if (i7 >>> 0 > 99) i12 = 6; else if (i7 >>> 0 > 9) i12 = 8;
  if ((i12 | 0) == 6) {
   HEAP8[i1 >> 0] = HEAP8[(i2 | 1) + (gb + 1035599) >> 0] | 0;
   i1 = i1 + 1 | 0;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i1 >> 0] = HEAP8[(i3 | 1) + (gb + 1035599) >> 0] | 0;
  i12 = i1 + 1 | 0;
  return i12 | 0;
 } else {
  i5 = (i7 >>> 0) % 1e4 | 0;
  i2 = ((i7 >>> 0) / 1e6 | 0) << 1;
  i3 = ((((i7 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
  i4 = ((i5 >>> 0) / 100 | 0) << 1;
  i5 = ((i5 >>> 0) % 100 | 0) << 1;
  if (i6 >>> 0 > 0 | (i6 | 0) == 0 & i7 >>> 0 > 9999999) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i12 = 13;
  } else if (i6 >>> 0 > 0 | (i6 | 0) == 0 & i7 >>> 0 > 999999) i12 = 13; else if (i6 >>> 0 > 0 | (i6 | 0) == 0 & i7 >>> 0 > 99999) i12 = 15;
  if ((i12 | 0) == 13) {
   HEAP8[i1 >> 0] = HEAP8[(i2 | 1) + (gb + 1035599) >> 0] | 0;
   i1 = i1 + 1 | 0;
   i12 = 15;
  }
  if ((i12 | 0) == 15) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i1 >> 0] = HEAP8[(i3 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1035599 + i4 >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[(i4 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1035599 + i5 >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[(i5 | 1) + (gb + 1035599) >> 0] | 0;
  i12 = i1 + 5 | 0;
  return i12 | 0;
 }
 if (!(i6 >>> 0 < 2328306 | (i6 | 0) == 2328306 & i7 >>> 0 < 1874919424)) {
  i5 = ___udivdi3(i7 | 0, i6 | 0, 1874919424, 2328306) | 0;
  getTempRet0() | 0;
  i3 = ___uremdi3(i7 | 0, i6 | 0, 1874919424, 2328306) | 0;
  i4 = getTempRet0() | 0;
  do if (i5 >>> 0 < 10) {
   HEAP8[i1 >> 0] = i5 + 48;
   i1 = i1 + 1 | 0;
  } else {
   if (i5 >>> 0 < 100) {
    i12 = i5 << 1;
    HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i12 >> 0] | 0;
    HEAP8[i1 + 1 >> 0] = HEAP8[(i12 | 1) + (gb + 1035599) >> 0] | 0;
    i1 = i1 + 2 | 0;
    break;
   }
   i2 = (i5 >>> 0) / 100 | 0;
   if (i5 >>> 0 < 1e3) {
    HEAP8[i1 >> 0] = i2 + 48;
    i12 = ((i5 >>> 0) % 100 | 0) << 1;
    HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1035599 + i12 >> 0] | 0;
    HEAP8[i1 + 2 >> 0] = HEAP8[(i12 | 1) + (gb + 1035599) >> 0] | 0;
    i1 = i1 + 3 | 0;
    break;
   } else {
    i11 = i2 << 1;
    i12 = ((i5 >>> 0) % 100 | 0) << 1;
    HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i11 >> 0] | 0;
    HEAP8[i1 + 1 >> 0] = HEAP8[(i11 | 1) + (gb + 1035599) >> 0] | 0;
    HEAP8[i1 + 2 >> 0] = HEAP8[gb + 1035599 + i12 >> 0] | 0;
    HEAP8[i1 + 3 >> 0] = HEAP8[(i12 | 1) + (gb + 1035599) >> 0] | 0;
    i1 = i1 + 4 | 0;
    break;
   }
  } while (0);
  i6 = ___udivdi3(i3 | 0, i4 | 0, 1e8, 0) | 0;
  getTempRet0() | 0;
  i10 = ___uremdi3(i3 | 0, i4 | 0, 1e8, 0) | 0;
  getTempRet0() | 0;
  i8 = (i6 >>> 0) % 1e4 | 0;
  i5 = ((i6 >>> 0) / 1e6 | 0) << 1;
  i6 = ((((i6 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
  i7 = ((i8 >>> 0) / 100 | 0) << 1;
  i8 = ((i8 >>> 0) % 100 | 0) << 1;
  i12 = (i10 >>> 0) % 1e4 | 0;
  i9 = ((i10 >>> 0) / 1e6 | 0) << 1;
  i10 = ((((i10 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
  i11 = ((i12 >>> 0) / 100 | 0) << 1;
  i12 = ((i12 >>> 0) % 100 | 0) << 1;
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i5 >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[(i5 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[gb + 1035599 + i6 >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[(i6 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[gb + 1035599 + i7 >> 0] | 0;
  HEAP8[i1 + 5 >> 0] = HEAP8[(i7 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 6 >> 0] = HEAP8[gb + 1035599 + i8 >> 0] | 0;
  HEAP8[i1 + 7 >> 0] = HEAP8[(i8 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 8 >> 0] = HEAP8[gb + 1035599 + i9 >> 0] | 0;
  HEAP8[i1 + 9 >> 0] = HEAP8[(i9 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 10 >> 0] = HEAP8[gb + 1035599 + i10 >> 0] | 0;
  HEAP8[i1 + 11 >> 0] = HEAP8[(i10 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 12 >> 0] = HEAP8[gb + 1035599 + i11 >> 0] | 0;
  HEAP8[i1 + 13 >> 0] = HEAP8[(i11 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 14 >> 0] = HEAP8[gb + 1035599 + i12 >> 0] | 0;
  HEAP8[i1 + 15 >> 0] = HEAP8[(i12 | 1) + (gb + 1035599) >> 0] | 0;
  i12 = i1 + 16 | 0;
  return i12 | 0;
 }
 i3 = ___udivdi3(i7 | 0, i6 | 0, 1e8, 0) | 0;
 getTempRet0() | 0;
 i8 = ___uremdi3(i7 | 0, i6 | 0, 1e8, 0) | 0;
 getTempRet0() | 0;
 i11 = (i3 >>> 0) % 1e4 | 0;
 i2 = ((i3 >>> 0) / 1e6 | 0) << 1;
 i3 = ((((i3 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
 i4 = ((i11 >>> 0) / 100 | 0) << 1;
 i11 = ((i11 >>> 0) % 100 | 0) << 1;
 i10 = (i8 >>> 0) % 1e4 | 0;
 i5 = ((i8 >>> 0) / 1e6 | 0) << 1;
 i8 = ((((i8 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
 i9 = ((i10 >>> 0) / 100 | 0) << 1;
 i10 = ((i10 >>> 0) % 100 | 0) << 1;
 if (i6 >>> 0 > 232830 | (i6 | 0) == 232830 & i7 >>> 0 > 2764472319) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 21;
 } else if (i6 >>> 0 > 23283 | (i6 | 0) == 23283 & i7 >>> 0 > 276447231) i12 = 21; else if (i6 >>> 0 > 2328 | (i6 | 0) == 2328 & i7 >>> 0 > 1316134911) i12 = 23; else if (i6 >>> 0 > 232 | (i6 | 0) == 232 & i7 >>> 0 > 3567587327) i12 = 25; else if (i6 >>> 0 > 23 | (i6 | 0) == 23 & i7 >>> 0 > 1215752191) i12 = 27; else if (i6 >>> 0 > 2 | (i6 | 0) == 2 & i7 >>> 0 > 1410065407) i12 = 29; else if (i6 >>> 0 > 0 | (i6 | 0) == 0 & i7 >>> 0 > 999999999) i12 = 31;
 if ((i12 | 0) == 21) {
  HEAP8[i1 >> 0] = HEAP8[(i2 | 1) + (gb + 1035599) >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 23;
 }
 if ((i12 | 0) == 23) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 25;
 }
 if ((i12 | 0) == 25) {
  HEAP8[i1 >> 0] = HEAP8[(i3 | 1) + (gb + 1035599) >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 27;
 }
 if ((i12 | 0) == 27) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 29;
 }
 if ((i12 | 0) == 29) {
  HEAP8[i1 >> 0] = HEAP8[(i4 | 1) + (gb + 1035599) >> 0] | 0;
  i1 = i1 + 1 | 0;
  i12 = 31;
 }
 if ((i12 | 0) == 31) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i11 >> 0] | 0;
  i1 = i1 + 1 | 0;
 }
 HEAP8[i1 >> 0] = HEAP8[(i11 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1035599 + i5 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[(i5 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1035599 + i8 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[(i8 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = HEAP8[gb + 1035599 + i9 >> 0] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[(i9 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 7 >> 0] = HEAP8[gb + 1035599 + i10 >> 0] | 0;
 HEAP8[i1 + 8 >> 0] = HEAP8[(i10 | 1) + (gb + 1035599) >> 0] | 0;
 i12 = i1 + 9 | 0;
 return i12 | 0;
}

function __ZN16ReflectionProbes16UpdateSampleDataEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i26;
 i23 = i22 + 24 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 i24 = i22 + 104 | 0;
 i25 = i22 + 120 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i25 >> 2] = i2;
  HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2 * 24 | 0, 4, i22 + 108 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i22 + 108 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i22 + 116 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i25 >> 2] = i2;
  HEAP32[i24 >> 2] = i21;
  break;
 } while (0);
 i19 = i22 + 116 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i22 + 124 | 0;
 i21 = i22 + 140 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i21 >> 2] = i2;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2 * 40 | 0, 4, i22 + 128 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i22 + 128 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i18 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i22 + 136 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i20 >> 2] = i18;
  break;
 } while (0);
 i16 = i22 + 136 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i22 + 144 | 0;
 i18 = i22 + 160 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i18 >> 2] = i2;
  HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2 * 24 | 0, 4, i22 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i22 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i17 >> 2] | 0, (HEAP32[i22 + 156 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i18 >> 2] = i2;
  HEAP32[i17 >> 2] = i15;
  break;
 } while (0);
 i13 = i22 + 156 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i22 + 164 | 0;
 i15 = i22 + 180 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i15 >> 2] = i2;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 * 44 | 0, 4, i22 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i22 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i22 + 176 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i14 >> 2] = i12;
  break;
 } while (0);
 i12 = i22 + 176 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZNK16ReflectionProbes21GenerateDefaultSampleEv(i4, i22);
 i3 = i22 + 192 | 0;
 i1 = i4;
 i2 = i3 + 124 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i7 = i22 + 12 | 0;
 if (!(HEAP32[i23 >> 2] | 0)) {
  STACKTOP = i26;
  return;
 }
 i8 = i22 + 108 | 0;
 i9 = i22 + 128 | 0;
 i10 = i22 + 148 | 0;
 i11 = i22 + 168 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 do {
  switch (HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0) {
  case 0:
   {
    i1 = HEAP32[i19 >> 2] | 0;
    i3 = i1 + 1 | 0;
    i4 = HEAP32[i25 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i25 >> 2] = i2;
      HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2 * 24 | 0, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 24 | 0) | 0;
      HEAP32[i25 >> 2] = i2;
      HEAP32[i24 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i19 >> 2] = i3;
    i3 = (HEAP32[i16 >> 2] | 0) + 1 | 0;
    i4 = HEAP32[i21 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i21 >> 2] = i2;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2 * 40 | 0, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 40 | 0) | 0;
      HEAP32[i21 >> 2] = i2;
      HEAP32[i20 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i3;
    break;
   }
  case 1:
   {
    i1 = HEAP32[i13 >> 2] | 0;
    i3 = i1 + 1 | 0;
    i4 = HEAP32[i18 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i18 >> 2] = i2;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2 * 24 | 0, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i17 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 24 | 0) | 0;
      HEAP32[i18 >> 2] = i2;
      HEAP32[i17 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i13 >> 2] = i3;
    i3 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 * 44 | 0, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 44 | 0) | 0;
      HEAP32[i15 >> 2] = i2;
      HEAP32[i14 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i3;
    break;
   }
  default:
   i1 = 0;
  }
  __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(i22, HEAP32[i6 >> 2] | 0, i1);
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) != ((HEAP32[i7 >> 2] | 0) + (HEAP32[i23 >> 2] << 2) | 0));
 STACKTOP = i26;
 return;
}

function __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i15, i16, i1, i18, i13, i19, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i20;
 i4 = (i18 - i1 | 0) / 12 | 0;
 do if (i4 >>> 0 > 100) {
  i3 = _malloc(i4) | 0;
  if (!i3) {
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  }
  i2 = i3;
  i17 = i3;
  i7 = 6;
 } else {
  i17 = 0;
  i7 = 6;
 } while (0);
 if ((i7 | 0) == 6) {
  i6 = i1;
  i7 = i2;
  i3 = 0;
  while (1) {
   if ((i6 | 0) == (i18 | 0)) break;
   i5 = HEAP8[i6 + 8 + 3 >> 0] | 0;
   if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
   if (!i5) {
    HEAP8[i7 >> 0] = 2;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else HEAP8[i7 >> 0] = 1;
   i6 = i6 + 12 | 0;
   i7 = i7 + 1 | 0;
  }
  i12 = 0;
  i10 = i3;
  L21 : while (1) {
   i3 = HEAP32[i15 >> 2] | 0;
   do if (!i3) i7 = 1; else {
    i5 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i3 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i11 = __THREW__;
     __THREW__ = 0;
     if (i11 & 1) {
      i7 = 43;
      break L21;
     }
    } else i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) == -1) {
     HEAP32[i15 >> 2] = 0;
     i7 = 1;
     break;
    } else {
     i7 = (HEAP32[i15 >> 2] | 0) == 0;
     break;
    }
   } while (0);
   i5 = HEAP32[i16 >> 2] | 0;
   if (!i5) {
    i5 = 0;
    i3 = 1;
   } else {
    i3 = HEAP32[i5 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i3 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
     i11 = __THREW__;
     __THREW__ = 0;
     if (i11 & 1) {
      i7 = 43;
      break;
     }
    } else i3 = HEAP32[i3 >> 2] | 0;
    if ((i3 | 0) == -1) {
     HEAP32[i16 >> 2] = 0;
     i5 = 0;
     i3 = 1;
    } else i3 = 0;
   }
   i6 = HEAP32[i15 >> 2] | 0;
   if (!((i4 | 0) != 0 & (i7 ^ i3))) {
    i7 = 30;
    break;
   }
   i3 = HEAP32[i6 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i3 = invoke_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i7 = 43;
     break;
    }
   } else i3 = HEAP32[i3 >> 2] | 0;
   if (!i14) {
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i7 = 49;
     break;
    }
   }
   i11 = i12 + 1 | 0;
   i8 = i1;
   i7 = 0;
   i9 = i2;
   while (1) {
    if ((i8 | 0) == (i18 | 0)) break;
    do if ((HEAP8[i9 >> 0] | 0) == 1) {
     i6 = i8 + 8 + 3 | 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
     i5 = HEAP32[i5 + (i12 << 2) >> 2] | 0;
     if (!i14) {
      __THREW__ = 0;
      i5 = invoke_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i7 = 59;
       break L21;
      }
     }
     if ((i3 | 0) != (i5 | 0)) {
      HEAP8[i9 >> 0] = 0;
      i5 = i7;
      i6 = i10;
      i4 = i4 + -1 | 0;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i8 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) == (i11 | 0)) {
      HEAP8[i9 >> 0] = 2;
      i5 = 1;
      i6 = i10 + 1 | 0;
      i4 = i4 + -1 | 0;
     } else {
      i5 = 1;
      i6 = i10;
     }
    } else {
     i5 = i7;
     i6 = i10;
    } while (0);
    i8 = i8 + 12 | 0;
    i7 = i5;
    i9 = i9 + 1 | 0;
    i10 = i6;
   }
   if (!i7) {
    i12 = i11;
    continue;
   }
   i3 = HEAP32[i15 >> 2] | 0;
   i5 = i3 + 12 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i7 = 73;
     break;
    }
   } else HEAP32[i5 >> 2] = i6 + 4;
   if ((i10 + i4 | 0) >>> 0 > 1) {
    i6 = i1;
    i7 = i2;
    i3 = i10;
   } else {
    i12 = i11;
    continue;
   }
   while (1) {
    if ((i6 | 0) == (i18 | 0)) {
     i12 = i11;
     i10 = i3;
     continue L21;
    }
    if ((HEAP8[i7 >> 0] | 0) == 2) {
     i5 = HEAP8[i6 + 8 + 3 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) != (i11 | 0)) {
      HEAP8[i7 >> 0] = 0;
      i3 = i3 + -1 | 0;
     }
    }
    i6 = i6 + 12 | 0;
    i7 = i7 + 1 | 0;
   }
  }
  if ((i7 | 0) == 30) {
   do if (!i6) {
    i4 = 1;
    i7 = 37;
   } else {
    i3 = HEAP32[i6 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i3 = invoke_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
     i21 = __THREW__;
     __THREW__ = 0;
     if (i21 & 1) break;
    } else i3 = HEAP32[i3 >> 2] | 0;
    if ((i3 | 0) == -1) {
     HEAP32[i15 >> 2] = 0;
     i4 = 1;
     i7 = 37;
     break;
    } else {
     i4 = (HEAP32[i15 >> 2] | 0) == 0;
     i7 = 37;
     break;
    }
   } while (0);
   L102 : do if ((i7 | 0) == 37) {
    do if (!i5) i7 = 81; else {
     i3 = HEAP32[i5 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i3 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) break L102;
     } else i3 = HEAP32[i3 >> 2] | 0;
     if ((i3 | 0) == -1) {
      HEAP32[i16 >> 2] = 0;
      i7 = 81;
      break;
     } else if (i4) break; else {
      i7 = 83;
      break;
     }
    } while (0);
    if ((i7 | 0) == 81) if (i4) i7 = 83;
    if ((i7 | 0) == 83) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
    while (1) {
     if ((i1 | 0) == (i18 | 0)) {
      i7 = 88;
      break;
     }
     if ((HEAP8[i2 >> 0] | 0) == 2) break;
     i1 = i1 + 12 | 0;
     i2 = i2 + 1 | 0;
    }
    if ((i7 | 0) == 88) {
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 4;
     i1 = i18;
    }
    if (i17 | 0) _free(i17);
    STACKTOP = i20;
    return i1 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i7 | 0) == 43) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i7 | 0) == 49) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i7 | 0) == 59) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i7 | 0) == 73) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  if (i17) _free(i17);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5audio5mixer18AudioMixerConstant8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 12 | 0;
 i11 = i12;
 i7 = i10 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 4;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i11 + 8 >> 2] = i8;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863147 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 8;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863154 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 16;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863165 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 20;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863173 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863185 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i5 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 36;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863205 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 40;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863215 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 48;
 HEAP32[i11 + 4 >> 2] = i6 + 44;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863229 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 56;
 HEAP32[i11 + 4 >> 2] = i6 + 52;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863245 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 64;
 HEAP32[i11 + 4 >> 2] = i6 + 60;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863264 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 68 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 72;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863287 | 0, i8, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i6 + 76;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 863309 | 0, i8, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i10, i11, 0); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i12;
 return;
}

function runPostSets50() {
 HEAP32[gb + 62360 >> 2] = (HEAP32[gb + 62360 >> 2] | 0) + (gb + 442042 | 0);
 HEAP32[gb + 62576 >> 2] = fb + 1;
 HEAP32[gb + 62580 >> 2] = fb + 2;
 HEAP32[gb + 62584 >> 2] = fb + 1;
 HEAP32[gb + 62588 >> 2] = fb + 1;
 HEAP32[gb + 62592 >> 2] = fb + 1;
 HEAP32[gb + 62596 >> 2] = fb + 2;
 HEAP32[gb + 62600 >> 2] = fb + 1;
 HEAP32[gb + 62604 >> 2] = fb + 1;
 HEAP32[gb + 62608 >> 2] = fb + 2;
 HEAP32[gb + 62612 >> 2] = fb + 2;
 HEAP32[gb + 62616 >> 2] = fb + 1;
 HEAP32[gb + 62620 >> 2] = fb + 1;
 HEAP32[gb + 62624 >> 2] = fb + 2;
 HEAP32[gb + 62628 >> 2] = fb + 1;
 HEAP32[gb + 62632 >> 2] = fb + 1;
 HEAP32[gb + 62636 >> 2] = fb + 1;
 HEAP32[gb + 62640 >> 2] = fb + 2;
 HEAP32[gb + 62644 >> 2] = fb + 1;
 HEAP32[gb + 62648 >> 2] = (HEAP32[gb + 62648 >> 2] | 0) + (gb + 442050 | 0);
 HEAP32[gb + 62652 >> 2] = (HEAP32[gb + 62652 >> 2] | 0) + (gb + 442061 | 0);
 HEAP32[gb + 62656 >> 2] = (HEAP32[gb + 62656 >> 2] | 0) + (gb + 442071 | 0);
 HEAP32[gb + 62660 >> 2] = (HEAP32[gb + 62660 >> 2] | 0) + (gb + 442084 | 0);
 HEAP32[gb + 62664 >> 2] = (HEAP32[gb + 62664 >> 2] | 0) + (gb + 442097 | 0);
 HEAP32[gb + 62668 >> 2] = (HEAP32[gb + 62668 >> 2] | 0) + (gb + 1012705 | 0);
 HEAP32[gb + 62672 >> 2] = (HEAP32[gb + 62672 >> 2] | 0) + (gb + 442111 | 0);
 HEAP32[gb + 62676 >> 2] = (HEAP32[gb + 62676 >> 2] | 0) + (gb + 442121 | 0);
 HEAP32[gb + 62680 >> 2] = (HEAP32[gb + 62680 >> 2] | 0) + (gb + 442125 | 0);
 HEAP32[gb + 62684 >> 2] = (HEAP32[gb + 62684 >> 2] | 0) + (gb + 442135 | 0);
 HEAP32[gb + 62688 >> 2] = (HEAP32[gb + 62688 >> 2] | 0) + (gb + 442146 | 0);
 HEAP32[gb + 62692 >> 2] = (HEAP32[gb + 62692 >> 2] | 0) + (gb + 442153 | 0);
 HEAP32[gb + 62696 >> 2] = (HEAP32[gb + 62696 >> 2] | 0) + (gb + 442157 | 0);
 HEAP32[gb + 62700 >> 2] = (HEAP32[gb + 62700 >> 2] | 0) + (gb + 442165 | 0);
 HEAP32[gb + 62704 >> 2] = (HEAP32[gb + 62704 >> 2] | 0) + (gb + 442181 | 0);
 HEAP32[gb + 62708 >> 2] = (HEAP32[gb + 62708 >> 2] | 0) + (gb + 442192 | 0);
 HEAP32[gb + 62712 >> 2] = (HEAP32[gb + 62712 >> 2] | 0) + (gb + 673012 | 0);
 HEAP32[gb + 62716 >> 2] = (HEAP32[gb + 62716 >> 2] | 0) + (gb + 442210 | 0);
 HEAP32[gb + 62720 >> 2] = (HEAP32[gb + 62720 >> 2] | 0) + (gb + 773288 | 0);
 HEAP32[gb + 62724 >> 2] = (HEAP32[gb + 62724 >> 2] | 0) + (gb + 609266 | 0);
 HEAP32[gb + 62728 >> 2] = (HEAP32[gb + 62728 >> 2] | 0) + (gb + 609205 | 0);
 HEAP32[gb + 62732 >> 2] = (HEAP32[gb + 62732 >> 2] | 0) + (gb + 469691 | 0);
 HEAP32[gb + 62736 >> 2] = (HEAP32[gb + 62736 >> 2] | 0) + (gb + 442226 | 0);
 HEAP32[gb + 62740 >> 2] = (HEAP32[gb + 62740 >> 2] | 0) + (gb + 442239 | 0);
 HEAP32[gb + 62744 >> 2] = (HEAP32[gb + 62744 >> 2] | 0) + (gb + 442249 | 0);
 HEAP32[gb + 62748 >> 2] = (HEAP32[gb + 62748 >> 2] | 0) + (gb + 896226 | 0);
 HEAP32[gb + 62752 >> 2] = (HEAP32[gb + 62752 >> 2] | 0) + (gb + 462520 | 0);
 HEAP32[gb + 62756 >> 2] = (HEAP32[gb + 62756 >> 2] | 0) + (gb + 442259 | 0);
 HEAP32[gb + 62760 >> 2] = (HEAP32[gb + 62760 >> 2] | 0) + (gb + 442269 | 0);
 HEAP32[gb + 62764 >> 2] = (HEAP32[gb + 62764 >> 2] | 0) + (gb + 442285 | 0);
 HEAP32[gb + 62768 >> 2] = (HEAP32[gb + 62768 >> 2] | 0) + (gb + 442295 | 0);
 HEAP32[gb + 62772 >> 2] = (HEAP32[gb + 62772 >> 2] | 0) + (gb + 442300 | 0);
 HEAP32[gb + 62776 >> 2] = (HEAP32[gb + 62776 >> 2] | 0) + (gb + 442311 | 0);
 HEAP32[gb + 62780 >> 2] = (HEAP32[gb + 62780 >> 2] | 0) + (gb + 442322 | 0);
 HEAP32[gb + 62784 >> 2] = (HEAP32[gb + 62784 >> 2] | 0) + (gb + 945895 | 0);
 HEAP32[gb + 62788 >> 2] = (HEAP32[gb + 62788 >> 2] | 0) + (gb + 779352 | 0);
 HEAP32[gb + 62792 >> 2] = (HEAP32[gb + 62792 >> 2] | 0) + (gb + 801649 | 0);
 HEAP32[gb + 62796 >> 2] = (HEAP32[gb + 62796 >> 2] | 0) + (gb + 442335 | 0);
 HEAP32[gb + 62800 >> 2] = (HEAP32[gb + 62800 >> 2] | 0) + (gb + 442349 | 0);
 HEAP32[gb + 62804 >> 2] = (HEAP32[gb + 62804 >> 2] | 0) + (gb + 442355 | 0);
 HEAP32[gb + 62808 >> 2] = (HEAP32[gb + 62808 >> 2] | 0) + (gb + 442358 | 0);
 HEAP32[gb + 62812 >> 2] = (HEAP32[gb + 62812 >> 2] | 0) + (gb + 442362 | 0);
 HEAP32[gb + 62816 >> 2] = (HEAP32[gb + 62816 >> 2] | 0) + (gb + 442374 | 0);
 HEAP32[gb + 62820 >> 2] = (HEAP32[gb + 62820 >> 2] | 0) + (gb + 465927 | 0);
 HEAP32[gb + 62824 >> 2] = (HEAP32[gb + 62824 >> 2] | 0) + (gb + 442387 | 0);
 HEAP32[gb + 62828 >> 2] = (HEAP32[gb + 62828 >> 2] | 0) + (gb + 442404 | 0);
 HEAP32[gb + 62832 >> 2] = (HEAP32[gb + 62832 >> 2] | 0) + (gb + 442409 | 0);
 HEAP32[gb + 62836 >> 2] = (HEAP32[gb + 62836 >> 2] | 0) + (gb + 442419 | 0);
 HEAP32[gb + 62840 >> 2] = (HEAP32[gb + 62840 >> 2] | 0) + (gb + 442424 | 0);
 HEAP32[gb + 62844 >> 2] = (HEAP32[gb + 62844 >> 2] | 0) + (gb + 442433 | 0);
 HEAP32[gb + 62848 >> 2] = (HEAP32[gb + 62848 >> 2] | 0) + (gb + 442456 | 0);
 HEAP32[gb + 62852 >> 2] = (HEAP32[gb + 62852 >> 2] | 0) + (gb + 442467 | 0);
 HEAP32[gb + 62856 >> 2] = (HEAP32[gb + 62856 >> 2] | 0) + (gb + 442476 | 0);
 HEAP32[gb + 62860 >> 2] = (HEAP32[gb + 62860 >> 2] | 0) + (gb + 1044255 | 0);
 HEAP32[gb + 62864 >> 2] = (HEAP32[gb + 62864 >> 2] | 0) + (gb + 773730 | 0);
 HEAP32[gb + 62868 >> 2] = (HEAP32[gb + 62868 >> 2] | 0) + (gb + 462529 | 0);
 HEAP32[gb + 62872 >> 2] = (HEAP32[gb + 62872 >> 2] | 0) + (gb + 442485 | 0);
 HEAP32[gb + 62876 >> 2] = (HEAP32[gb + 62876 >> 2] | 0) + (gb + 585142 | 0);
 HEAP32[gb + 62880 >> 2] = (HEAP32[gb + 62880 >> 2] | 0) + (gb + 442492 | 0);
 HEAP32[gb + 62884 >> 2] = (HEAP32[gb + 62884 >> 2] | 0) + (gb + 442507 | 0);
 HEAP32[gb + 62888 >> 2] = (HEAP32[gb + 62888 >> 2] | 0) + (gb + 442528 | 0);
 HEAP32[gb + 62892 >> 2] = (HEAP32[gb + 62892 >> 2] | 0) + (gb + 442536 | 0);
 HEAP32[gb + 62896 >> 2] = (HEAP32[gb + 62896 >> 2] | 0) + (gb + 937588 | 0);
 HEAP32[gb + 62900 >> 2] = (HEAP32[gb + 62900 >> 2] | 0) + (gb + 442545 | 0);
 HEAP32[gb + 62904 >> 2] = (HEAP32[gb + 62904 >> 2] | 0) + (gb + 442560 | 0);
 HEAP32[gb + 62908 >> 2] = (HEAP32[gb + 62908 >> 2] | 0) + (gb + 442567 | 0);
 HEAP32[gb + 62912 >> 2] = (HEAP32[gb + 62912 >> 2] | 0) + (gb + 774375 | 0);
 HEAP32[gb + 62916 >> 2] = (HEAP32[gb + 62916 >> 2] | 0) + (gb + 442571 | 0);
 HEAP32[gb + 62920 >> 2] = (HEAP32[gb + 62920 >> 2] | 0) + (gb + 442584 | 0);
 HEAP32[gb + 62924 >> 2] = (HEAP32[gb + 62924 >> 2] | 0) + (gb + 442597 | 0);
 HEAP32[gb + 62928 >> 2] = (HEAP32[gb + 62928 >> 2] | 0) + (gb + 442609 | 0);
 HEAP32[gb + 62932 >> 2] = (HEAP32[gb + 62932 >> 2] | 0) + (gb + 442617 | 0);
 HEAP32[gb + 62936 >> 2] = (HEAP32[gb + 62936 >> 2] | 0) + (gb + 442622 | 0);
 HEAP32[gb + 62940 >> 2] = (HEAP32[gb + 62940 >> 2] | 0) + (gb + 462517 | 0);
 HEAP32[gb + 62944 >> 2] = (HEAP32[gb + 62944 >> 2] | 0) + (gb + 442632 | 0);
 HEAP32[gb + 62948 >> 2] = (HEAP32[gb + 62948 >> 2] | 0) + (gb + 442649 | 0);
 HEAP32[gb + 62952 >> 2] = (HEAP32[gb + 62952 >> 2] | 0) + (gb + 442658 | 0);
 HEAP32[gb + 62956 >> 2] = (HEAP32[gb + 62956 >> 2] | 0) + (gb + 442672 | 0);
 HEAP32[gb + 62960 >> 2] = (HEAP32[gb + 62960 >> 2] | 0) + (gb + 442682 | 0);
 HEAP32[gb + 62964 >> 2] = (HEAP32[gb + 62964 >> 2] | 0) + (gb + 442690 | 0);
 HEAP32[gb + 62968 >> 2] = (HEAP32[gb + 62968 >> 2] | 0) + (gb + 442693 | 0);
 runPostSets51();
}

function __ZN14SpriteRenderer15SetupPropertiesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i10 = i12;
 i5 = i8 + 340 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 9;
 }
 if ((i11 | 0) == 7) i11 = 9;
 if ((i11 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i12;
  return;
 }
 i4 = __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i8) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 18;
   }
  }
  if ((i11 | 0) == 16) i11 = 18;
  if ((i11 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 i1 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0;
 __ZN14SpriteRenderer15SetupPropertiesER19ShaderPropertySheetRK16SpriteRenderData(i4, i1);
 __ZN19ShaderPropertySheet11ComputeHashEv(i4);
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i6 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 26; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 28;
   }
  }
  if ((i11 | 0) == 26) i11 = 28;
  if ((i11 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i6 = (i1 | 0) != 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0) | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i7 = 0;
 do {
  i5 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, i7 | 0) | 0;
  do if (i5 | 0) {
   HEAP32[i10 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 38; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i13 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
     i3 = HEAP32[i13 + 28 >> 2] | 0;
     i4 = HEAP32[i13 + 32 >> 2] | 0;
     i1 = i13;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 38; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i11 = 40;
   }
   if ((i11 | 0) == 38) i11 = 40;
   if ((i11 | 0) == 40) {
    i11 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = i5;
   if (!i1) i11 = 47; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 47; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 49;
    }
   }
   if ((i11 | 0) == 47) i11 = 49;
   if ((i11 | 0) == 49) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   }
   if (i6) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 478520 | 0, 19);
    __ZN8Material13EnableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i9);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    break;
   } else {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 478520 | 0, 19);
    __ZN8Material14DisableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i9);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    break;
   }
  } while (0);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0) | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx22PxcContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i2, i10, i9, i7, i22, i1, i35) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, f37 = f0, f38 = f0;
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f26 = Math_fround(-f13);
 i2 = i9 + 4 | 0;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(-f18);
 i1 = i9 + 8 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(-f19);
 i36 = i9 + 12 | 0;
 f20 = Math_fround(HEAPF32[i36 >> 2]);
 f31 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 i32 = i9 + 16 | 0;
 f14 = Math_fround(HEAPF32[i32 >> 2]);
 f31 = Math_fround(f31 - f14);
 f4 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 i33 = i9 + 20 | 0;
 f15 = Math_fround(HEAPF32[i33 >> 2]);
 f4 = Math_fround(f4 - f15);
 f27 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 i34 = i9 + 24 | 0;
 f16 = Math_fround(HEAPF32[i34 >> 2]);
 f31 = Math_fround(f31 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f27 - f16) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f31 * f26) + Math_fround(f4 * f11)) + Math_fround(f27 * f3));
 f21 = Math_fround(Math_fround(f8 * f26) + Math_fround(Math_fround(f17 * f31) + Math_fround(f20 * Math_fround(Math_fround(f27 * f11) - Math_fround(f4 * f3)))));
 f6 = Math_fround(Math_fround(f8 * f11) + Math_fround(Math_fround(f17 * f4) + Math_fround(f20 * Math_fround(Math_fround(f31 * f3) - Math_fround(f27 * f26)))));
 f8 = Math_fround(Math_fround(Math_fround(f17 * f27) + Math_fround(f20 * Math_fround(Math_fround(f4 * f26) - Math_fround(f31 * f11)))) + Math_fround(f8 * f3));
 f31 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(f20 * f31);
 f27 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f27 * f26));
 f25 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f25 * f11));
 f24 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f24 * f3));
 f5 = Math_fround(Math_fround(Math_fround(f31 * f3) + Math_fround(Math_fround(f27 * f11) + Math_fround(f20 * f24))) - Math_fround(f25 * f26));
 f23 = Math_fround(Math_fround(Math_fround(f24 * f26) + Math_fround(Math_fround(f27 * f3) + Math_fround(f20 * f25))) - Math_fround(f31 * f11));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f27) - Math_fround(f31 * f26)) - Math_fround(f24 * f11)) - Math_fround(f25 * f3));
 f25 = Math_fround(f4 * Math_fround(2.0));
 f11 = Math_fround(f3 * Math_fround(2.0));
 f3 = Math_fround(Math_fround(f4 * f25) + Math_fround(Math_fround(f3 * f11) + Math_fround(-1.0)));
 f4 = Math_fround(Math_fround(f23 * f11) + Math_fround(f25 * f5));
 f5 = Math_fround(Math_fround(f25 * f23) - Math_fround(f11 * f5));
 f11 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f3 = Math_fround(f11 * f3);
 f4 = Math_fround(f11 * f4);
 f5 = Math_fround(f11 * f5);
 f11 = Math_fround(f21 + f3);
 f3 = Math_fround(f21 - f3);
 f21 = Math_fround(f6 - f4);
 f23 = Math_fround(f8 - f5);
 f25 = Math_fround(HEAPF32[i9 >> 2]);
 f24 = Math_fround(f25 * Math_fround(2.0));
 f26 = Math_fround(HEAPF32[i36 >> 2]);
 f31 = Math_fround(f26 * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f25 * f24) + Math_fround(Math_fround(f26 * f31) + Math_fround(-1.0)));
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f30 = Math_fround(f28 * f31);
 f29 = Math_fround(HEAPF32[i2 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f24 * f29));
 f31 = Math_fround(Math_fround(f24 * f28) - Math_fround(f31 * f29));
 f24 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f11 = Math_fround(f11 - f24);
 f24 = Math_fround(f3 - f24);
 f3 = Math_fround(HEAPF32[i22 >> 2]);
 if (!(f11 <= f3)) i1 = 0; else {
  f12 = Math_fround(f11 * Math_fround(2.0));
  f6 = Math_fround(Math_fround(f6 + f4) * Math_fround(2.0));
  f4 = Math_fround(Math_fround(f8 + f5) * Math_fround(2.0));
  f5 = Math_fround(Math_fround(f19 * f4) + Math_fround(Math_fround(f18 * f6) + Math_fround(f13 * f12)));
  i1 = i35 + 4096 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 > 63) i1 = 1; else {
   f8 = Math_fround(-f31);
   f37 = Math_fround(-f30);
   f38 = Math_fround(-f27);
   f3 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f17 * f4) + Math_fround(f20 * Math_fround(Math_fround(f13 * f6) - Math_fround(f18 * f12)))) + Math_fround(f19 * f5)));
   f16 = Math_fround(f15 + Math_fround(Math_fround(f18 * f5) + Math_fround(Math_fround(f17 * f6) + Math_fround(f20 * Math_fround(Math_fround(f19 * f12) - Math_fround(f13 * f4))))));
   f20 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(f20 * Math_fround(Math_fround(f18 * f4) - Math_fround(f19 * f6)))) + Math_fround(f13 * f5)));
   HEAP32[i1 >> 2] = i2 + 1;
   HEAPF32[i35 + (i2 << 6) >> 2] = f38;
   HEAPF32[i35 + (i2 << 6) + 4 >> 2] = f37;
   HEAPF32[i35 + (i2 << 6) + 8 >> 2] = f8;
   HEAPF32[i35 + (i2 << 6) + 16 >> 2] = f20;
   HEAPF32[i35 + (i2 << 6) + 20 >> 2] = f16;
   HEAPF32[i35 + (i2 << 6) + 24 >> 2] = f3;
   HEAPF32[i35 + (i2 << 6) + 12 >> 2] = f11;
   HEAP32[i35 + (i2 << 6) + 48 >> 2] = -1;
   HEAP32[i35 + (i2 << 6) + 52 >> 2] = -1;
   f3 = Math_fround(HEAPF32[i22 >> 2]);
   i1 = 1;
  }
 }
 if (!(f24 <= f3)) {
  i36 = i1;
  return i36 | 0;
 }
 f8 = Math_fround(f24 * Math_fround(2.0));
 f6 = Math_fround(f21 * Math_fround(2.0));
 f3 = Math_fround(f23 * Math_fround(2.0));
 f4 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f25) + Math_fround(f6 * f29)) + Math_fround(f3 * f28));
 i1 = i35 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i36 = 1;
  return i36 | 0;
 }
 f23 = Math_fround(-f31);
 f30 = Math_fround(-f30);
 f27 = Math_fround(-f27);
 f38 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f4) + Math_fround(f26 * Math_fround(Math_fround(f6 * f25) - Math_fround(f8 * f29)))) + Math_fround(f28 * f5)) + Math_fround(HEAPF32[i34 >> 2]));
 f37 = Math_fround(Math_fround(Math_fround(f29 * f5) + Math_fround(Math_fround(f6 * f4) + Math_fround(f26 * Math_fround(Math_fround(f8 * f28) - Math_fround(f3 * f25))))) + Math_fround(HEAPF32[i33 >> 2]));
 f31 = Math_fround(Math_fround(Math_fround(f25 * f5) + Math_fround(Math_fround(f8 * f4) + Math_fround(f26 * Math_fround(Math_fround(f3 * f29) - Math_fround(f6 * f28))))) + Math_fround(HEAPF32[i32 >> 2]));
 HEAP32[i1 >> 2] = i2 + 1;
 HEAPF32[i35 + (i2 << 6) >> 2] = f27;
 HEAPF32[i35 + (i2 << 6) + 4 >> 2] = f30;
 HEAPF32[i35 + (i2 << 6) + 8 >> 2] = f23;
 HEAPF32[i35 + (i2 << 6) + 16 >> 2] = f31;
 HEAPF32[i35 + (i2 << 6) + 20 >> 2] = f37;
 HEAPF32[i35 + (i2 << 6) + 24 >> 2] = f38;
 HEAPF32[i35 + (i2 << 6) + 12 >> 2] = f24;
 HEAP32[i35 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i35 + (i2 << 6) + 52 >> 2] = -1;
 i36 = 1;
 return i36 | 0;
}

function __ZN18UnityPropertySheet20AddNewShaderlabPropsERK19ShaderPropertySheet(i27, i25) {
 i27 = i27 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i29 + 16 | 0;
 i24 = i29;
 i2 = HEAP32[i25 + 8 >> 2] | 0;
 i28 = i25 + 12 | 0;
 i15 = HEAP32[i28 >> 2] | 0;
 if ((i2 | 0) == (i15 | 0)) i1 = 0; else {
  i16 = i25 + 52 | 0;
  i8 = i25 + 72 | 0;
  i9 = i27 + 12 | 0;
  i10 = i25 + 32 | 0;
  i11 = i27 + 16 | 0;
  i12 = i11;
  i13 = i27 + 16 | 0;
  i14 = i27 + 20 | 0;
  i1 = 0;
  i6 = i2;
  do {
   i22 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   f7 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + (i22 & 1048575) >> 2]);
   do if (i22 & 1073741824) if ((__Z19GetActiveColorSpacev() | 0) == 1) if (!(f7 <= Math_fround(0.0))) {
    if (f7 <= Math_fround(.00313080009)) {
     f7 = Math_fround(f7 * Math_fround(12.9200001));
     break;
    }
    if (f7 < Math_fround(1.0)) {
     f7 = Math_fround(Math_fround(Math_fround(+Math_pow(+f7, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, .454545468));
   } else f7 = Math_fround(0.0); while (0);
   i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   f7 = Math_fround(f7);
   i2 = HEAP32[i11 >> 2] | 0;
   do if (!i2) {
    HEAP32[i23 >> 2] = i11;
    i3 = i12;
    i4 = i11;
   } else {
    while (1) {
     i3 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i5 | 0) < (i3 | 0)) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i26 = 18;
       break;
      } else i2 = i3;
     } else {
      if ((i3 | 0) >= (i5 | 0)) {
       i26 = 23;
       break;
      }
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i26 = 22;
       break;
      } else i2 = i3;
     }
    }
    if ((i26 | 0) == 18) {
     i26 = 0;
     HEAP32[i23 >> 2] = i2;
     i3 = i2;
     i4 = i2;
     break;
    } else if ((i26 | 0) == 22) {
     i26 = 0;
     HEAP32[i23 >> 2] = i2;
     i3 = i2;
     break;
    } else if ((i26 | 0) == 23) {
     i26 = 0;
     HEAP32[i23 >> 2] = i2;
     i3 = i2;
     i4 = i23;
     break;
    }
   } while (0);
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i22 = i2 + 16 | 0;
    HEAP32[i22 >> 2] = i5;
    HEAPF32[i22 + 4 >> 2] = f7;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i9 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 >> 2] | 0, i2);
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
    i2 = 1;
   } else i2 = 0;
   i1 = i1 | i2;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i15 | 0));
  i2 = HEAP32[i28 >> 2] | 0;
 }
 i12 = HEAP32[i25 + 16 >> 2] | 0;
 if ((i2 | 0) != (i12 | 0)) {
  i13 = i25 + 52 | 0;
  i14 = i27 + 24 | 0;
  i15 = i25 + 32 | 0;
  i16 = i24 + 4 | 0;
  i17 = i24 + 8 | 0;
  i18 = i24 + 12 | 0;
  i19 = i27 + 28 | 0;
  i20 = i19;
  i21 = i27 + 28 | 0;
  i22 = i27 + 32 | 0;
  do {
   if ((HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0) >= 0) {
    __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi(i24, i25, i2);
    i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i8 = HEAP32[i24 >> 2] | 0;
    i9 = HEAP32[i16 >> 2] | 0;
    i10 = HEAP32[i17 >> 2] | 0;
    i11 = HEAP32[i18 >> 2] | 0;
    i3 = HEAP32[i19 >> 2] | 0;
    do if (!i3) {
     HEAP32[i23 >> 2] = i19;
     i4 = i20;
     i5 = i19;
    } else {
     while (1) {
      i4 = HEAP32[i3 + 16 >> 2] | 0;
      if ((i6 | 0) < (i4 | 0)) {
       i4 = HEAP32[i3 >> 2] | 0;
       if (!i4) {
        i26 = 36;
        break;
       } else i3 = i4;
      } else {
       if ((i4 | 0) >= (i6 | 0)) {
        i26 = 41;
        break;
       }
       i5 = i3 + 4 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if (!i4) {
        i26 = 40;
        break;
       } else i3 = i4;
      }
     }
     if ((i26 | 0) == 36) {
      i26 = 0;
      HEAP32[i23 >> 2] = i3;
      i4 = i3;
      i5 = i3;
      break;
     } else if ((i26 | 0) == 40) {
      i26 = 0;
      HEAP32[i23 >> 2] = i3;
      i4 = i3;
      break;
     } else if ((i26 | 0) == 41) {
      i26 = 0;
      HEAP32[i23 >> 2] = i3;
      i4 = i3;
      i5 = i23;
      break;
     }
    } while (0);
    if (!(HEAP32[i5 >> 2] | 0)) {
     i3 = __Znwj(36) | 0;
     HEAP32[i3 + 16 >> 2] = i6;
     HEAP32[i3 + 20 >> 2] = i8;
     HEAP32[i3 + 24 >> 2] = i9;
     HEAP32[i3 + 28 >> 2] = i10;
     HEAP32[i3 + 32 >> 2] = i11;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i3 + 4 >> 2] = 0;
     HEAP32[i3 + 8 >> 2] = i4;
     HEAP32[i5 >> 2] = i3;
     i4 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
     if (i4) {
      HEAP32[i14 >> 2] = i4;
      i3 = HEAP32[i5 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i3);
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
     i3 = 1;
    } else i3 = 0;
    i1 = i1 | i3;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
 }
 i2 = HEAP32[i25 + 20 >> 2] | 0;
 i10 = HEAP32[i25 + 24 >> 2] | 0;
 if ((i2 | 0) == (i10 | 0)) {
  i28 = i1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i11 = i25 + 32 | 0;
 i12 = i27 + 4 | 0;
 i13 = i25 + 52 | 0;
 i9 = i25 + 72 | 0;
 do {
  i8 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  if (!i4) i26 = 58; else {
   i6 = HEAP32[i8 >> 2] | 0;
   i3 = i12;
   L74 : while (1) {
    i5 = i4;
    while (1) {
     if ((HEAP32[i5 + 16 >> 2] | 0) >= (i6 | 0)) break;
     i4 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i4) break L74; else i5 = i4;
    }
    i4 = HEAP32[i5 >> 2] | 0;
    if (!i4) {
     i3 = i5;
     break;
    } else i3 = i5;
   }
   if ((i3 | 0) == (i12 | 0)) i26 = 58; else if ((i6 | 0) < (HEAP32[i3 + 16 >> 2] | 0)) i26 = 58;
  }
  if ((i26 | 0) == 58) {
   i26 = 0;
   i1 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i3 + (HEAP32[i1 + (i2 << 2) >> 2] & 1048575) + 20 >> 2] | 0;
   if ((i4 | 0) > -1) {
    i5 = i3 + (HEAP32[i1 + ((HEAP32[i28 >> 2] | 0) + i4 << 2) >> 2] & 1048575) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i5 + 12 >> 2] | 0;
    i4 = HEAP32[i5 + 4 >> 2] | 0;
    i5 = HEAP32[i5 + 8 >> 2] | 0;
   } else {
    i1 = 1065353216;
    i3 = 0;
    i4 = 1065353216;
    i5 = 0;
   }
   i25 = __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i27, i8) | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i25 + 4 >> 2] = i4;
   HEAP32[i25 + 8 >> 2] = i5;
   HEAP32[i25 + 12 >> 2] = i3;
   HEAP32[i25 + 16 >> 2] = 0;
   i1 = 1;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 STACKTOP = i29;
 return i1 | 0;
}

function __ZNSt3__25dequeIPN9ShaderLab21SerializedShaderStateENS_9allocatorIS3_EEE19__add_back_capacityEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17;
 i1 = i16 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 1023) {
  HEAP32[i1 >> 2] = i2 + -1024;
  i10 = i16 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = i16 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i1 = i15;
  i5 = i7;
  do if ((i7 | 0) == (i15 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i9 >>> 0 > i2 >>> 0) {
    i1 = i9;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i9 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i9; else {
     _memmove(i4 | 0, i9 | 0, i1 | 0) | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i10 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i15 = __Znwj(i6 << 2) | 0;
   i4 = i15;
   i1 = i15 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i15 + (i6 << 2) | 0;
   if ((i9 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i9;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i11 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
 i15 = i16 + 8 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i9 = i8 - i10 | 0;
 i11 = i9 >> 2;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i1 = i4 - i6 | 0;
 i5 = i8;
 i12 = i10;
 i7 = i4;
 i2 = i6;
 if (i11 >>> 0 >= i1 >> 2 >>> 0) {
  i10 = i1 >> 1;
  i10 = (i10 | 0) == 0 ? 1 : i10;
  i2 = __Znwj(i10 << 2) | 0;
  i3 = i2;
  i4 = i2 + (i11 << 2) | 0;
  i1 = i2 + (i10 << 2) | 0;
  i6 = __Znwj(4096) | 0;
  do if ((i11 | 0) == (i10 | 0)) if ((i9 | 0) > 0) {
   i7 = i3;
   i3 = i4 + (((i11 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i12;
   break;
  } else {
   i1 = i9 >> 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   i5 = __Znwj(i1 << 2) | 0;
   __ZdlPv(i2);
   i7 = i5;
   i3 = i5 + (i1 >>> 2 << 2) | 0;
   i1 = i5 + (i1 << 2) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i7 = i3;
   i3 = i4;
   i2 = i12;
  } while (0);
  i4 = i3;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  if ((i5 | 0) == (i2 | 0)) i5 = i7; else while (1) {
   i5 = i5 + -4 | 0;
   i2 = i4;
   do if ((i2 | 0) == (i7 | 0)) {
    i9 = i3;
    if (i9 >>> 0 < i1 >>> 0) {
     i6 = i9 + ((((i1 - i3 >> 2) + 1 | 0) / 2 | 0) << 2) | 0;
     i2 = i3 - i4 | 0;
     i12 = i2 >> 2;
     i3 = i6 + (0 - i12 << 2) | 0;
     if (!i12) i2 = i6; else {
      _memmove(i3 | 0, i4 | 0, i2 | 0) | 0;
      i2 = i3;
     }
     i4 = i2;
     i3 = i6;
     break;
    }
    i1 = i1 - i7 >> 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    i12 = __Znwj(i1 << 2) | 0;
    i7 = i12;
    i10 = i12 + ((i1 + 3 | 0) >>> 2 << 2) | 0;
    i8 = i10;
    i1 = i12 + (i1 << 2) | 0;
    if ((i2 | 0) == (i9 | 0)) i3 = i8; else {
     i6 = i10;
     i3 = i8;
     do {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      i6 = i3 + 4 | 0;
      i3 = i6;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i9 | 0));
    }
    if (!i4) {
     i4 = i8;
     i2 = i10;
    } else {
     __ZdlPv(i4);
     i4 = i8;
     i2 = i10;
    }
   } while (0);
   HEAP32[i2 + -4 >> 2] = HEAP32[i5 >> 2];
   i2 = i4 + -4 | 0;
   if ((i5 | 0) == (HEAP32[i14 >> 2] | 0)) {
    i5 = i7;
    i4 = i2;
    break;
   } else i4 = i2;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i1;
  if (!i2) {
   STACKTOP = i17;
   return;
  }
  __ZdlPv(i2);
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) == (i8 | 0)) {
  HEAP32[i3 >> 2] = __Znwj(4096) | 0;
  __ZNSt3__214__split_bufferIPPN9ShaderLab21SerializedShaderStateENS_9allocatorIS4_EEE10push_frontERKS4_(i16, i3);
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 4 | 0;
  HEAP32[i14 >> 2] = i8;
  i7 = HEAP32[i15 >> 2] | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = i12;
  i5 = i7;
  do if ((i7 | 0) == (i12 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i8 >>> 0 > i2 >>> 0) {
    i1 = i8;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i8 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i8; else {
     _memmove(i4 | 0, i8 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i12 = __Znwj(i6 << 2) | 0;
   i4 = i12;
   i1 = i12 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i12 + (i6 << 2) | 0;
   if ((i8 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i8;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 } else {
  i9 = __Znwj(4096) | 0;
  i1 = i8;
  do if ((i5 | 0) == (i7 | 0)) {
   if (i12 >>> 0 > i2 >>> 0) {
    i3 = ((i10 - i6 >> 2) + 1 | 0) / -2 | 0;
    i4 = i12 + (i3 << 2) | 0;
    i1 = i8 - i10 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i12; else {
     _memmove(i4 | 0, i10 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i4 = i4 - i6 >> 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i11 = __Znwj(i4 << 2) | 0;
   i6 = i11;
   i1 = i11 + (i4 >>> 2 << 2) | 0;
   i7 = i1;
   i4 = i11 + (i4 << 2) | 0;
   if ((i12 | 0) == (i5 | 0)) i1 = i7; else {
    i3 = i1;
    i1 = i7;
    i2 = i12;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i5 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i6;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i4;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
}

function __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0, f66 = f0, f67 = f0;
 i26 = HEAP32[i2 >> 2] | 0;
 i27 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = HEAP32[i2 + 16 >> 2] | 0;
 i11 = HEAP32[i26 >> 2] | 0;
 i24 = i26 + 4 | 0;
 i12 = HEAP32[i24 >> 2] | 0;
 i25 = i26 + 8 | 0;
 i10 = HEAP32[i25 >> 2] | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i16 = i27 + 4 | 0;
 i8 = HEAP32[i16 >> 2] | 0;
 i17 = i27 + 8 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 i18 = i26 + 16 | 0;
 i5 = HEAP32[i18 >> 2] | 0;
 i19 = i26 + 20 | 0;
 i7 = HEAP32[i19 >> 2] | 0;
 i20 = i26 + 24 | 0;
 i4 = HEAP32[i20 >> 2] | 0;
 i21 = i27 + 16 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 i22 = i27 + 20 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i23 = i27 + 24 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i15 = i13 + 1 | 0;
 if (!(HEAP8[i15 >> 0] | 0)) {
  i28 = i10;
  i29 = i12;
  i30 = i11;
  i12 = i9;
  i11 = i8;
  i10 = i6;
  i9 = i4;
  i8 = i7;
  i7 = i5;
  i15 = i3;
  i14 = i2;
  i13 = i1;
  HEAP32[i26 >> 2] = i30;
  HEAP32[i24 >> 2] = i29;
  HEAP32[i25 >> 2] = i28;
  HEAP32[i18 >> 2] = i7;
  HEAP32[i19 >> 2] = i8;
  HEAP32[i20 >> 2] = i9;
  HEAP32[i27 >> 2] = i10;
  HEAP32[i16 >> 2] = i11;
  HEAP32[i17 >> 2] = i12;
  HEAP32[i21 >> 2] = i13;
  HEAP32[i22 >> 2] = i14;
  HEAP32[i23 >> 2] = i15;
  return;
 }
 i13 = i13 + 48 | 0;
 i14 = 0;
 while (1) {
  f52 = Math_fround(HEAPF32[i13 >> 2]);
  f51 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f58 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f46 = Math_fround(HEAPF32[i13 + 16 >> 2]);
  f45 = Math_fround(HEAPF32[i13 + 20 >> 2]);
  f57 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  f41 = Math_fround(HEAPF32[i13 + 32 >> 2]);
  f49 = Math_fround(HEAPF32[i13 + 36 >> 2]);
  f65 = Math_fround(HEAPF32[i13 + 40 >> 2]);
  f35 = Math_fround(HEAPF32[i13 + 48 >> 2]);
  f63 = Math_fround(HEAPF32[i13 + 52 >> 2]);
  f62 = Math_fround(HEAPF32[i13 + 56 >> 2]);
  f40 = Math_fround(HEAPF32[i13 + 64 >> 2]);
  f39 = Math_fround(HEAPF32[i13 + 68 >> 2]);
  f38 = Math_fround(HEAPF32[i13 + 72 >> 2]);
  f33 = Math_fround(HEAPF32[i13 + 80 >> 2]);
  f32 = Math_fround(HEAPF32[i13 + 84 >> 2]);
  f34 = Math_fround(HEAPF32[i13 + 88 >> 2]);
  f50 = Math_fround(HEAPF32[i13 + 76 >> 2]);
  f44 = Math_fround(HEAPF32[i13 + 92 >> 2]);
  f67 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f61 = Math_fround(HEAPF32[i13 + 44 >> 2]);
  f59 = Math_fround(HEAPF32[i13 + 60 >> 2]);
  i30 = i13 + 104 | 0;
  f31 = Math_fround(HEAPF32[i30 >> 2]);
  f56 = Math_fround(HEAPF32[i13 + 100 >> 2]);
  f60 = Math_fround(HEAPF32[i13 + 96 >> 2]);
  f55 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(f55 * f52);
  f54 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(f66 + Math_fround(f54 * f51));
  f53 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f66 = Math_fround(f66 + Math_fround(f53 * f58));
  f43 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f41 = Math_fround(f43 * f41);
  f42 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f49 = Math_fround(f41 + Math_fround(f42 * f49));
  f41 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f65 = Math_fround(f49 + Math_fround(f41 * f65));
  f49 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f49 * f46);
  f48 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f64 + Math_fround(f48 * f45));
  f47 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f64 = Math_fround(f64 + Math_fround(f47 * f57));
  f37 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f35 = Math_fround(f37 * f35);
  f36 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f63 = Math_fround(f35 + Math_fround(f36 * f63));
  f35 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f59 = Math_fround(Math_fround(f67 + Math_fround(Math_fround(Math_fround(f66 + f65) - Math_fround(f64 + Math_fround(f63 + Math_fround(f35 * f62)))) * f61)) + Math_fround(f59 * f31));
  f59 = f60 > f59 ? f60 : f59;
  f56 = f56 > f59 ? f59 : f56;
  f31 = Math_fround(f56 - f31);
  f52 = Math_fround(f52 * f50);
  f51 = Math_fround(f51 * f50);
  f50 = Math_fround(f58 * f50);
  f46 = Math_fround(f46 * f44);
  f45 = Math_fround(f45 * f44);
  f44 = Math_fround(f57 * f44);
  HEAPF32[i30 >> 2] = f56;
  f52 = Math_fround(f55 + Math_fround(f52 * f31));
  f51 = Math_fround(f54 + Math_fround(f51 * f31));
  f50 = Math_fround(f53 + Math_fround(f50 * f31));
  i11 = (HEAPF32[tempDoublePtr >> 2] = f52, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f51, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f50, HEAP32[tempDoublePtr >> 2] | 0);
  f46 = Math_fround(f49 + Math_fround(f46 * f31));
  f45 = Math_fround(f48 + Math_fround(f45 * f31));
  f44 = Math_fround(f47 + Math_fround(f44 * f31));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f46, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f45, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f44, HEAP32[tempDoublePtr >> 2] | 0);
  f40 = Math_fround(f43 + Math_fround(f40 * f31));
  f39 = Math_fround(f42 + Math_fround(f39 * f31));
  f38 = Math_fround(f41 + Math_fround(f38 * f31));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f39, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround(f37 + Math_fround(f33 * f31));
  f32 = Math_fround(f36 + Math_fround(f32 * f31));
  f31 = Math_fround(f35 + Math_fround(f34 * f31));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = i14 + 1 | 0;
  if (i14 >>> 0 >= (HEAPU8[i15 >> 0] | 0) >>> 0) break; else i13 = i13 + 112 | 0;
 }
 HEAP32[i26 >> 2] = i11;
 HEAP32[i24 >> 2] = i12;
 HEAP32[i25 >> 2] = i10;
 HEAP32[i18 >> 2] = i5;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i20 >> 2] = i4;
 HEAP32[i27 >> 2] = i6;
 HEAP32[i16 >> 2] = i8;
 HEAP32[i17 >> 2] = i9;
 HEAP32[i21 >> 2] = i1;
 HEAP32[i22 >> 2] = i2;
 HEAP32[i23 >> 2] = i3;
 return;
}

function __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i1, i5, i11) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, i13 = 0, d14 = 0.0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L1 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L1;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i9 | 0, 0, 256) | 0;
 i6 = i9 + 255 | 0;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L6 : do if (!(i2 << 24 >> 24)) i2 = i9; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i9;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L6;
   i7 = HEAP32[i8 >> 2] | 0;
   if (!(i2 >>> 0 < i7 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i9; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i7 = i9;
 i1 = i1 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAPF32[i5 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L12 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L12;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L17 : do if (!(i2 << 24 >> 24)) i2 = i9; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i9;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L17;
   i13 = HEAP32[i8 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i9; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i1 = i1 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAPF32[i5 + 4 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L23 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L23;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L28 : do if (!(i2 << 24 >> 24)) i2 = i9; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i9;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L28;
   i13 = HEAP32[i8 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i9; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i1 = i1 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAPF32[i5 + 8 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L34 : do if (!(i2 << 24 >> 24)) i4 = i1; else while (1) {
  if (!(_isspace(i2 & 255) | 0)) {
   i4 = i1;
   break L34;
  }
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i4 = i1;
   break;
  }
 } while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i1 = HEAP8[i4 >> 0] | 0;
 L39 : do if (!(i1 << 24 >> 24)) i1 = i9; else if (!(_isspace(i1 & 255) | 0)) {
  i3 = i4;
  i2 = i9;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L39;
   i13 = HEAP32[i8 >> 2] | 0;
   if (!(i1 >>> 0 < i13 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i9; while (0);
 HEAP8[i1 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i1 = i4 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAPF32[i5 + 12 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L45 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L45;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L50 : do if (!(i2 << 24 >> 24)) i2 = i9; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i9;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L50;
   i13 = HEAP32[i8 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i9; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i1 = i1 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 i5 = i5 + 16 | 0;
 HEAPF32[i5 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L56 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L56;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L61 : do if (!(i2 << 24 >> 24)) i2 = i9; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i9;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L61;
   i13 = HEAP32[i8 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i9; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i9, i8));
 i1 = i1 + ((HEAP32[i8 >> 2] | 0) - i7) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAPF32[i5 + 4 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L67 : do if (!(i2 << 24 >> 24)) i4 = i1; else while (1) {
  if (!(_isspace(i2 & 255) | 0)) {
   i4 = i1;
   break L67;
  }
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i4 = i1;
   break;
  }
 } while (0);
 _memset(i9 | 0, 0, 256) | 0;
 HEAP32[i8 >> 2] = i6;
 i1 = HEAP8[i4 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i13 = i9;
  HEAP8[i13 >> 0] = 0;
  d14 = +_strtod(i9, i8);
  f12 = Math_fround(d14);
  i13 = HEAP32[i8 >> 2] | 0;
  i13 = i13 - i7 | 0;
  i13 = i4 + i13 | 0;
  HEAP32[i11 >> 2] = i13;
  i13 = i5 + 8 | 0;
  HEAPF32[i13 >> 2] = f12;
  STACKTOP = i10;
  return;
 }
 if (!(_isspace(i1 & 255) | 0)) {
  i3 = i4;
  i2 = i9;
 } else {
  i13 = i9;
  HEAP8[i13 >> 0] = 0;
  d14 = +_strtod(i9, i8);
  f12 = Math_fround(d14);
  i13 = HEAP32[i8 >> 2] | 0;
  i13 = i13 - i7 | 0;
  i13 = i4 + i13 | 0;
  HEAP32[i11 >> 2] = i13;
  i13 = i5 + 8 | 0;
  HEAPF32[i13 >> 2] = f12;
  STACKTOP = i10;
  return;
 }
 while (1) {
  i1 = i2 + 1 | 0;
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i2 = 50;
   break;
  }
  i13 = HEAP32[i8 >> 2] | 0;
  if (!(i1 >>> 0 < i13 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) {
   i2 = 50;
   break;
  } else i2 = i1;
 }
 if ((i2 | 0) == 50) {
  HEAP8[i1 >> 0] = 0;
  d14 = +_strtod(i9, i8);
  f12 = Math_fround(d14);
  i13 = HEAP32[i8 >> 2] | 0;
  i13 = i13 - i7 | 0;
  i13 = i4 + i13 | 0;
  HEAP32[i11 >> 2] = i13;
  i13 = i5 + 8 | 0;
  HEAPF32[i13 >> 2] = f12;
  STACKTOP = i10;
  return;
 }
}

function __ZN9Coroutine35HandleIEnumerableCurrentReturnValueEP12Il2CppObject(i15, i4) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 40 | 0;
 i10 = i16 + 36 | 0;
 i7 = i16 + 32 | 0;
 i8 = i16 + 28 | 0;
 i5 = i16 + 12 | 0;
 i6 = i16;
 i13 = i16 + 24 | 0;
 i11 = i16 + 20 | 0;
 i12 = i16 + 16 | 0;
 i9 = i16 + 8 | 0;
 i1 = __Z26scripting_object_get_classP12Il2CppObject(i4) | 0;
 i2 = __Z14GetMonoManagerv() | 0;
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 472 >> 2] | 0) | 0) {
  i13 = i15 + 44 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  f3 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  if (f3 != f3 | Math_fround(0.0) != Math_fround(0.0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 456879 | 0, 0, gb + 456812 | 0, 326, 1, 0, 0, 0);
  i1 = HEAP32[i15 + 40 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
  __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, f3, i15, Math_fround(0.0), fb + 1577 | 0, 10);
  STACKTOP = i16;
  return;
 }
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 468 >> 2] | 0) | 0) {
  i1 = i15 + 44 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i15 + 40 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
  __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(0.0), i15, Math_fround(0.0), fb + 1577 | 0, 1);
  STACKTOP = i16;
  return;
 }
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 464 >> 2] | 0) | 0) {
  i1 = i15 + 44 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i15 + 40 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
  __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(-1.0), i15, Math_fround(0.0), fb + 1577 | 0, 32);
  STACKTOP = i16;
  return;
 }
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[i2 + 52 >> 2] | 0) | 0) {
  i2 = i15 + 44 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i15 + 40 | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  i9 = gb + 1164176 | 0;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i6;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  do if (__ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i12, i4, i14, i5) | 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i1 + 56 >> 2] = i15;
    HEAP32[i15 + 60 >> 2] = i1;
    break;
   }
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(0.0), i15, Math_fround(0.0), fb + 1577 | 0, 10);
  } while (0);
  STACKTOP = i16;
  return;
 }
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 132 >> 2] | 0) | 0) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  if (HEAP8[i1 + 52 >> 0] | 0) {
   __ZN9Coroutine3RunEPb(i15, 0) | 0;
   STACKTOP = i16;
   return;
  }
  i2 = i1 + 56 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i14 = i15 + 44 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = i15;
   HEAP32[i15 + 60 >> 2] = i1;
   STACKTOP = i16;
   return;
  }
  i1 = HEAP32[i15 + 40 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 456969 | 0, 0, gb + 456812 | 0, 392, 4, i1, 0, 0);
  STACKTOP = i16;
  return;
 }
 if (HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 476 >> 2] | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 476 >> 2] | 0) | 0) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  if (!i1) {
   STACKTOP = i16;
   return;
  }
  i14 = i15 + 44 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  __ZN3WWW12CallWhenDoneEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E(i1, fb + 592 | 0, HEAP32[i15 + 40 >> 2] | 0, i15, fb + 1577 | 0);
  STACKTOP = i16;
  return;
 }
 if (!((i4 | 0) == 0 | (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 36 >> 2] | 0) | 0) ^ 1)) {
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  if (i4 | 0) {
   i13 = i15 + 44 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0) | 0) {
    i1 = HEAP32[i15 + 40 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
    __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(0.0), i15, Math_fround(0.0), fb + 1577 | 0, 10);
    STACKTOP = i16;
    return;
   }
   if (!(HEAP32[i4 + 8 >> 2] | 0)) {
    __ZN14AsyncOperation20SetCoroutineCallbackEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E(i4, fb + 592 | 0, HEAP32[i15 + 40 >> 2] | 0, i15, fb + 1577 | 0);
    i1 = i15 + 64 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
    HEAP32[i1 >> 2] = i4;
    i15 = i4 + 4 | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
    STACKTOP = i16;
    return;
   } else {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 457087 | 0, 0, gb + 456812 | 0, 432, 1, 0, 0, 0);
    i1 = HEAP32[i15 + 40 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
    __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(0.0), i15, Math_fround(0.0), fb + 1577 | 0, 10);
    STACKTOP = i16;
    return;
   }
  }
 }
 i1 = i15 + 44 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i15 + 40 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i14, Math_fround(0.0), i15, Math_fround(0.0), fb + 1577 | 0, 10);
 STACKTOP = i16;
 return;
}

function __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_13ToiPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i20, i3, i1, i2, i4) {
 i20 = i20 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23;
 i2 = i4 << 2;
 i18 = i2 >>> 0 > 1024;
 i19 = i21 + 4 | 0;
 HEAP8[i19 >> 0] = i18 & 1;
 if (i18) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i23 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i21 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i21 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i18 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i12 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i11 = i4;
      i4 = i4 + 1 | 0;
      i10 = i4;
      i5 = i11;
      while (1) {
       i6 = HEAP32[i20 + (i10 << 2) >> 2] | 0;
       f7 = Math_fround(HEAPF32[i6 + 28 >> 2]);
       i8 = HEAP32[i20 + (i5 << 2) >> 2] | 0;
       f9 = Math_fround(HEAPF32[i8 + 28 >> 2]);
       if (f7 < f9) i6 = 1; else if (f7 == f9) if (!(HEAP32[i6 + 4 >> 2] | 0)) i6 = 0; else i6 = (HEAP32[i8 + 4 >> 2] | 0) == 0; else i6 = 0;
       i5 = i6 ? i10 : i5;
       if ((i10 | 0) < (i3 | 0)) i10 = i10 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i11 | 0)) {
       i15 = i20 + (i5 << 2) | 0;
       i17 = i20 + (i11 << 2) | 0;
       i16 = HEAP32[i15 >> 2] | 0;
       HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i17 >> 2] = i16;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i12) break L7;
    i17 = i12 + -2 | 0;
    i3 = HEAP32[i1 + (i12 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i17 << 2) >> 2] | 0;
    i12 = i17;
   }
   i16 = i20 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i14 = i20 + (i4 << 2) | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i6 + 28 >> 2]);
   i8 = HEAP32[i14 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i8 + 28 >> 2]);
   i10 = i8;
   i5 = i6;
   if (f7 < f9) i22 = 22; else if (f7 == f9) if (!(HEAP32[i6 + 4 >> 2] | 0)) {
    i11 = i8;
    i13 = i10;
   } else if (!(HEAP32[i8 + 4 >> 2] | 0)) i22 = 22; else {
    i11 = i8;
    i13 = i10;
   } else {
    i11 = i8;
    i13 = i10;
   }
   if ((i22 | 0) == 22) {
    i22 = 0;
    HEAP32[i14 >> 2] = i5;
    HEAP32[i16 >> 2] = i10;
    i13 = HEAP32[i14 >> 2] | 0;
    i5 = i10;
    i6 = i8;
    f9 = Math_fround(HEAPF32[i13 + 28 >> 2]);
    i11 = i13;
   }
   i15 = i20 + (i3 << 2) | 0;
   i10 = HEAP32[i15 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   i8 = i10;
   if (f7 < f9) i22 = 27; else if (f7 == f9) if (!(HEAP32[i10 + 4 >> 2] | 0)) f9 = f7; else if (!(HEAP32[i11 + 4 >> 2] | 0)) i22 = 27; else f9 = f7; else f9 = f7;
   if ((i22 | 0) == 27) {
    i22 = 0;
    HEAP32[i14 >> 2] = i8;
    HEAP32[i15 >> 2] = i13;
    i10 = i13;
    f9 = Math_fround(HEAPF32[i10 + 28 >> 2]);
    i5 = HEAP32[i16 >> 2] | 0;
    i6 = i5;
    i8 = i13;
   }
   f7 = Math_fround(HEAPF32[i6 + 28 >> 2]);
   if (f9 < f7) i22 = 32; else if (f9 == f7) if (HEAP32[i10 + 4 >> 2] | 0) if (!(HEAP32[i6 + 4 >> 2] | 0)) i22 = 32;
   if ((i22 | 0) == 32) {
    i22 = 0;
    HEAP32[i16 >> 2] = i8;
    HEAP32[i15 >> 2] = i5;
    i5 = HEAP32[i16 >> 2] | 0;
   }
   i10 = i3 + -1 | 0;
   i17 = i20 + (i10 << 2) | 0;
   HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i5;
   i6 = i4;
   while (1) {
    f9 = Math_fround(HEAPF32[i5 + 28 >> 2]);
    i15 = i5 + 4 | 0;
    i13 = i6;
    while (1) {
     i11 = i13 + 1 | 0;
     i6 = i20 + (i11 << 2) | 0;
     i8 = HEAP32[i6 >> 2] | 0;
     f7 = Math_fround(HEAPF32[i8 + 28 >> 2]);
     if (f7 < f9) {
      i13 = i11;
      continue;
     }
     if (!(f7 == f9)) {
      i14 = i11;
      i16 = i13;
      break;
     }
     if (!(HEAP32[i8 + 4 >> 2] | 0)) {
      i14 = i11;
      i16 = i13;
      break;
     }
     if (!(HEAP32[i15 >> 2] | 0)) i13 = i11; else {
      i14 = i11;
      i16 = i13;
      break;
     }
    }
    while (1) {
     i13 = i10 + -1 | 0;
     i11 = i20 + (i13 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     f7 = Math_fround(HEAPF32[i10 + 28 >> 2]);
     if (f9 < f7) {
      i10 = i13;
      continue;
     }
     if (!(f9 == f7)) break;
     if (!(HEAP32[i15 >> 2] | 0)) break;
     if (!(HEAP32[i10 + 4 >> 2] | 0)) i10 = i13; else break;
    }
    if ((i14 | 0) >= (i13 | 0)) {
     i10 = i14;
     i11 = i16;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i8;
    i5 = HEAP32[i17 >> 2] | 0;
    i6 = i14;
    i10 = i13;
   }
   HEAP32[i6 >> 2] = i5;
   HEAP32[i17 >> 2] = i8;
   if ((i10 - i4 | 0) < (i3 - i10 | 0)) {
    if (i12 >>> 0 < (i18 + -1 | 0) >>> 0) i5 = i18; else {
     i5 = i18 << 3;
     if (!i5) i5 = 0; else {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
      i17 = _PxGetFoundation() | 0;
      i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
      i5 = mftCall_iiiiii(i15 | 0, i16 | 0, i5 | 0, (i17 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i12 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i18 << 1;
    }
    HEAP32[i1 + (i12 << 2) >> 2] = i4;
    HEAP32[i1 + (i12 + 1 << 2) >> 2] = i11;
    i4 = i11 + 2 | 0;
   } else {
    i6 = i11 + 2 | 0;
    if (i12 >>> 0 < (i18 + -1 | 0) >>> 0) i5 = i18; else {
     i5 = i18 << 3;
     if (!i5) i5 = 0; else {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
      i17 = _PxGetFoundation() | 0;
      i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
      i5 = mftCall_iiiiii(i15 | 0, i16 | 0, i5 | 0, (i17 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i12 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i18 << 1;
    }
    HEAP32[i1 + (i12 << 2) >> 2] = i6;
    HEAP32[i1 + (i12 + 1 << 2) >> 2] = i3;
    i3 = i11;
   }
   i18 = i5;
   i5 = i12 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i19 >> 0] | 0)) {
  STACKTOP = i23;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i21, HEAP32[i21 >> 2] | 0);
 STACKTOP = i23;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i10 + 48 | 0;
 i5 = i10 + 24 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 if (f3 != f7) i2 = f3 < f7; else i2 = (HEAP32[i10 + 28 >> 2] | 0) < (HEAP32[i10 + 4 >> 2] | 0);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 if (f6 != f3) i1 = f6 < f3; else i1 = (HEAP32[i10 + 52 >> 2] | 0) < (HEAP32[i10 + 28 >> 2] | 0);
 do if (i2) {
  if (i1) {
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  if (f6 != f3) {
   if (!(f6 < f3)) break;
  } else if ((HEAP32[i10 + 52 >> 2] | 0) >= (HEAP32[i10 + 28 >> 2] | 0)) break;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 } else if (i1) {
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  if (f3 != f7) {
   if (!(f3 < f7)) break;
  } else if ((HEAP32[i10 + 28 >> 2] | 0) >= (HEAP32[i10 + 4 >> 2] | 0)) break;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 } while (0);
 i1 = i10 + 72 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i9;
  return;
 }
 while (1) {
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(HEAPF32[i4 >> 2]);
  if (f6 != f3) {
   if (f6 < f3) {
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    i12 = 26;
   }
  } else {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i2 | 0) < (HEAP32[i4 + 4 >> 2] | 0)) {
    i5 = i2;
    i12 = 26;
   }
  }
  if ((i12 | 0) == 26) {
   i12 = 0;
   i2 = i1 + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   L36 : do if ((i4 | 0) == (i10 | 0)) i2 = i10; else while (1) {
    i2 = i4;
    i4 = i4 + -24 | 0;
    f3 = Math_fround(HEAPF32[i4 >> 2]);
    if (f6 != f3) {
     if (!(f6 < f3)) break L36;
    } else if ((i5 | 0) >= (HEAP32[i2 + -20 >> 2] | 0)) break L36;
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    if ((i4 | 0) == (i10 | 0)) {
     i2 = i10;
     break;
    }
   } while (0);
   HEAPF32[i2 >> 2] = f6;
   HEAP32[i2 + 4 >> 2] = i5;
   i5 = i2 + 8 | 0;
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  }
  i2 = i1 + 24 | 0;
  if ((i2 | 0) == (i11 | 0)) break; else {
   i4 = i1;
   i1 = i2;
  }
 }
 STACKTOP = i9;
 return;
}

function __ZN19SkinnedMeshRenderer8BakeMeshER4Mesh(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 120 | 0;
 i16 = i19 + 96 | 0;
 i1 = i19 + 80 | 0;
 i2 = i19 + 184 | 0;
 i17 = i19 + 16 | 0;
 i18 = i19;
 i6 = i13 + 356 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 if ((i12 | 0) == 0 | (i12 | 0) == (i14 | 0)) {
  STACKTOP = i19;
  return;
 }
 i11 = i13 + 380 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i3 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i13, 1, 0) | 0;
 if (i3 | 0) {
  __ZN4Mesh14SetBoneWeightsEPK13BoneInfluencei(i14, 0, 0) | 0;
  i10 = (HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0) + 8 | 0;
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i1, i10);
  __ZNK14VertexDataInfo17GetChannelsLayoutEv(i2, i10);
  i4 = i14 + 32 | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i8 = i3 + 60 | 0;
  i9 = i13 + 496 | 0;
  i20 = HEAP32[i9 >> 2] | 0;
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i7 + 8 | 0, HEAP32[i8 >> 2] | 0, i20, ~i20, i1, i2);
  HEAP32[i3 + 36 >> 2] = HEAP32[i7 + 92 >> 2];
  __Z17DeformSkinnedMeshR12SkinMeshInfo(i3);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] & ~HEAP32[i1 >> 2], i10, (HEAP32[i4 >> 2] | 0) + 8 | 0);
  i1 = i3 + 84 | 0;
  if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
  i1 = HEAP32[i3 + 100 >> 2] | 0;
  if (i1 | 0) {
   i20 = i1 + 4 | 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
   if (!(HEAP32[i20 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i2 + 112 | 0, HEAP32[i3 + 112 >> 2] | 0, HEAP32[i3 + 116 >> 2] | 0);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) {
    __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2 + 128 | 0, HEAP32[i3 + 128 >> 2] | 0, HEAP32[i3 + 132 >> 2] | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   }
  }
  i20 = i14 + 44 | 0;
  HEAP8[i20 >> 0] = HEAP8[i20 >> 0] & -17 | HEAP8[i1 + 44 >> 0] & 16;
  __ZN4Mesh16SetChannelsDirtyEjb(i14, 1, 1);
  HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
    i2 = HEAP32[i15 >> 2] | 0;
    i20 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 19;
   }
  }
  if ((i5 | 0) == 16) i5 = 19;
  if ((i5 | 0) == 19) i1 = __ZN8Renderer12GetTransformEv(i13) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i17, i1);
  HEAP32[i16 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f22 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f21 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i8 = i16 + 12 | 0;
  HEAPF32[i8 >> 2] = f23;
  i9 = i16 + 16 | 0;
  HEAPF32[i9 >> 2] = f22;
  i10 = i16 + 20 | 0;
  HEAPF32[i10 >> 2] = f21;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i7 = 0; else i7 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 156 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  i6 = i18 + 4 | 0;
  i5 = gb + 63160 | 0;
  i20 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i6;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i20;
  i1 = i7 << 6;
  do if (!i1) i1 = 0; else {
   i2 = (i1 | 4) + -1 | 0;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 429036 | 0, 1413) | 0;
    i5 = gb + 64016 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    HEAP32[i18 >> 2] = i1;
    i20 = i6;
    HEAP32[i20 >> 2] = i4;
    HEAP32[i20 + 4 >> 2] = i5;
    break;
   }
  } while (0);
  i2 = i1 + 3 & -4;
  if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i13, i2, i7) | 0) {
   if (i7 | 0) {
    i1 = 0;
    do {
     i3 = i2 + (i1 << 6) | 0;
     __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i17, i3, i15);
     i4 = i15;
     i5 = i3 + 64 | 0;
     do {
      HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
      i3 = i3 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i3 | 0) < (i5 | 0));
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i7 | 0));
   }
   if (__ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB(i13, i2, i7, i16) | 0) {
    f21 = Math_fround(HEAPF32[i16 >> 2]);
    f29 = Math_fround(HEAPF32[i8 >> 2]);
    f26 = Math_fround(f21 + f29);
    f22 = Math_fround(HEAPF32[i16 + 4 >> 2]);
    f28 = Math_fround(HEAPF32[i9 >> 2]);
    f25 = Math_fround(f22 + f28);
    f23 = Math_fround(HEAPF32[i16 + 8 >> 2]);
    f27 = Math_fround(HEAPF32[i10 >> 2]);
    f25 = Math_fround(f25 * Math_fround(.5));
    f24 = Math_fround(Math_fround(f23 + f27) * Math_fround(.5));
    f21 = Math_fround(Math_fround(f29 - f21) * Math_fround(.5));
    f22 = Math_fround(Math_fround(f28 - f22) * Math_fround(.5));
    f23 = Math_fround(Math_fround(f27 - f23) * Math_fround(.5));
    HEAPF32[i14 + 48 >> 2] = Math_fround(f26 * Math_fround(.5));
    HEAPF32[i14 + 52 >> 2] = f25;
    HEAPF32[i14 + 56 >> 2] = f24;
    HEAPF32[i14 + 60 >> 2] = f21;
    HEAPF32[i14 + 64 >> 2] = f22;
    HEAPF32[i14 + 68 >> 2] = f23;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i6);
 }
 HEAP32[i11 >> 2] = i12;
 STACKTOP = i19;
 return;
}

function __Z14ClipAnimationsIfN13AnimationClip10FloatCurveE13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRS9_(i1, f34, f35, f2, i3, i36) {
 i1 = i1 | 0;
 f34 = Math_fround(f34);
 f35 = Math_fround(f35);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i36 = i36 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i39;
 i38 = i39 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i33 = i1 + 4 | 0;
 if ((i4 | 0) == (HEAP32[i33 >> 2] | 0)) {
  STACKTOP = i39;
  return;
 }
 i15 = i38 + 12 | 0;
 i16 = i38 + 16 | 0;
 i17 = i38 + 28 | 0;
 i18 = i38 + 36 | 0;
 i19 = i38 + 44 | 0;
 i20 = i38 + 40 | 0;
 i21 = i38 + 48 | 0;
 i22 = i38 + 72 | 0;
 i23 = i38 + 68 | 0;
 i24 = i38 + 76 | 0;
 i25 = i38 + 108 | 0;
 i26 = i38 + 112 | 0;
 i27 = i38 + 100 | 0;
 i28 = i38 + 120 | 0;
 i29 = i38 + 116 | 0;
 i30 = i38 + 124 | 0;
 i31 = i38 + 128 | 0;
 i32 = i38 + 40 | 0;
 f2 = Math_fround(Math_fround(f35 - f34) + Math_fround(Math_fround(1.0) / f2));
 i5 = i36 + 4 | 0;
 i6 = i36 + 8 | 0;
 i7 = i38 + 96 | 0;
 i8 = i38 + 16 | 0;
 i9 = i8 + 11 | 0;
 i10 = i38 + 28 | 0;
 i11 = i37 + 4 | 0;
 i12 = i38 + 11 | 0;
 i13 = i38 + 12 | 0;
 i14 = i37 + 4 | 0;
 if (i3) {
  i1 = i4;
  do {
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i15 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i17 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   HEAPF32[i19 >> 2] = Math_fround(inf);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   HEAP32[i21 + 16 >> 2] = 0;
   HEAPF32[i22 >> 2] = Math_fround(inf);
   HEAP32[i23 >> 2] = 0;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i24 + 16 >> 2] = 0;
   HEAP32[i24 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
   i40 = i37;
   i3 = HEAP32[i40 + 4 >> 2] | 0;
   i4 = i27;
   HEAP32[i4 >> 2] = HEAP32[i40 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i28 >> 2] = 2;
   HEAP32[i29 >> 2] = 2;
   HEAP32[i30 >> 2] = 4;
   HEAP32[i31 >> 2] = 0;
   do if (__Z18ClipAnimationCurveIfEbRK17AnimationCurveTplIT_ERS2_ff(i1 + 40 | 0, i32, f34, f35) | 0) {
    __ZNK13AnimationClip10FloatCurve16CopyWithoutCurveERS0_(i1, i38);
    __ZN17AnimationCurveTplIfE15SetPostInfinityEi(i32, 1);
    __ZN17AnimationCurveTplIfE14SetPreInfinityEi(i32, 1);
    HEAP32[i30 >> 2] = HEAP32[i1 + 124 >> 2];
    __Z15AddLoopingFrameIfEvR17AnimationCurveTplIT_Ef(i32, f2);
    i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
     __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i36, i38);
     break;
    } else {
     __ZN13AnimationClip10FloatCurveC2ERKS0_(i3, i38);
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 132;
     break;
    }
   } while (0);
   if ((HEAP32[i26 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i27);
    HEAP32[i7 >> 2] = 0;
   }
   if ((HEAP8[i9 >> 0] | 0) < 0) {
    i40 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i11 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i37);
   }
   if ((HEAP8[i12 >> 0] | 0) < 0) {
    i40 = HEAP32[i38 >> 2] | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i14 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i37);
   }
   i1 = i1 + 132 | 0;
  } while ((i1 | 0) != (HEAP32[i33 >> 2] | 0));
  STACKTOP = i39;
  return;
 } else {
  i1 = i4;
  do {
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i15 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i38 >> 2] = 0;
   HEAP32[i38 + 4 >> 2] = 0;
   HEAP32[i38 + 8 >> 2] = 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i17 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   HEAPF32[i19 >> 2] = Math_fround(inf);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   HEAP32[i21 + 8 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   HEAP32[i21 + 16 >> 2] = 0;
   HEAPF32[i22 >> 2] = Math_fround(inf);
   HEAP32[i23 >> 2] = 0;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i24 + 12 >> 2] = 0;
   HEAP32[i24 + 16 >> 2] = 0;
   HEAP32[i24 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i37, gb + 63664 | 0);
   i3 = i37;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i40 = i27;
   HEAP32[i40 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i40 + 4 >> 2] = i4;
   HEAP32[i28 >> 2] = 2;
   HEAP32[i29 >> 2] = 2;
   HEAP32[i30 >> 2] = 4;
   HEAP32[i31 >> 2] = 0;
   do if (__Z18ClipAnimationCurveIfEbRK17AnimationCurveTplIT_ERS2_ff(i1 + 40 | 0, i32, f34, f35) | 0) {
    __ZNK13AnimationClip10FloatCurve16CopyWithoutCurveERS0_(i1, i38);
    __ZN17AnimationCurveTplIfE15SetPostInfinityEi(i32, 1);
    __ZN17AnimationCurveTplIfE14SetPreInfinityEi(i32, 1);
    HEAP32[i30 >> 2] = HEAP32[i1 + 124 >> 2];
    i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
     __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i36, i38);
     break;
    } else {
     __ZN13AnimationClip10FloatCurveC2ERKS0_(i3, i38);
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 132;
     break;
    }
   } while (0);
   if ((HEAP32[i26 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i27);
    HEAP32[i7 >> 2] = 0;
   }
   if ((HEAP8[i9 >> 0] | 0) < 0) {
    i40 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i11 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i37);
   }
   if ((HEAP8[i12 >> 0] | 0) < 0) {
    i40 = HEAP32[i38 >> 2] | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i14 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i37);
   }
   i1 = i1 + 132 | 0;
  } while ((i1 | 0) != (HEAP32[i33 >> 2] | 0));
  STACKTOP = i39;
  return;
 }
}

function __ZNSt3__25dequeIN9BlobWrite11TypeContextENS_9allocatorIS2_EEE19__add_back_capacityEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17;
 i1 = i16 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 255) {
  HEAP32[i1 >> 2] = i2 + -256;
  i10 = i16 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = i16 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i1 = i15;
  i5 = i7;
  do if ((i7 | 0) == (i15 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i9 >>> 0 > i2 >>> 0) {
    i1 = i9;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i9 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i9; else {
     _memmove(i4 | 0, i9 | 0, i1 | 0) | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i10 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i15 = __Znwj(i6 << 2) | 0;
   i4 = i15;
   i1 = i15 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i15 + (i6 << 2) | 0;
   if ((i9 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i9;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i11 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
 i15 = i16 + 8 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i9 = i8 - i10 | 0;
 i11 = i9 >> 2;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i1 = i4 - i6 | 0;
 i5 = i8;
 i12 = i10;
 i7 = i4;
 i2 = i6;
 if (i11 >>> 0 >= i1 >> 2 >>> 0) {
  i10 = i1 >> 1;
  i10 = (i10 | 0) == 0 ? 1 : i10;
  i2 = __Znwj(i10 << 2) | 0;
  i3 = i2;
  i4 = i2 + (i11 << 2) | 0;
  i1 = i2 + (i10 << 2) | 0;
  i6 = __Znwj(4096) | 0;
  do if ((i11 | 0) == (i10 | 0)) if ((i9 | 0) > 0) {
   i7 = i3;
   i3 = i4 + (((i11 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i12;
   break;
  } else {
   i1 = i9 >> 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   i5 = __Znwj(i1 << 2) | 0;
   __ZdlPv(i2);
   i7 = i5;
   i3 = i5 + (i1 >>> 2 << 2) | 0;
   i1 = i5 + (i1 << 2) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i7 = i3;
   i3 = i4;
   i2 = i12;
  } while (0);
  i4 = i3;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  if ((i5 | 0) == (i2 | 0)) i5 = i7; else while (1) {
   i5 = i5 + -4 | 0;
   i2 = i4;
   do if ((i2 | 0) == (i7 | 0)) {
    i9 = i3;
    if (i9 >>> 0 < i1 >>> 0) {
     i6 = i9 + ((((i1 - i3 >> 2) + 1 | 0) / 2 | 0) << 2) | 0;
     i2 = i3 - i4 | 0;
     i12 = i2 >> 2;
     i3 = i6 + (0 - i12 << 2) | 0;
     if (!i12) i2 = i6; else {
      _memmove(i3 | 0, i4 | 0, i2 | 0) | 0;
      i2 = i3;
     }
     i4 = i2;
     i3 = i6;
     break;
    }
    i1 = i1 - i7 >> 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    i12 = __Znwj(i1 << 2) | 0;
    i7 = i12;
    i10 = i12 + ((i1 + 3 | 0) >>> 2 << 2) | 0;
    i8 = i10;
    i1 = i12 + (i1 << 2) | 0;
    if ((i2 | 0) == (i9 | 0)) i3 = i8; else {
     i6 = i10;
     i3 = i8;
     do {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      i6 = i3 + 4 | 0;
      i3 = i6;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i9 | 0));
    }
    if (!i4) {
     i4 = i8;
     i2 = i10;
    } else {
     __ZdlPv(i4);
     i4 = i8;
     i2 = i10;
    }
   } while (0);
   HEAP32[i2 + -4 >> 2] = HEAP32[i5 >> 2];
   i2 = i4 + -4 | 0;
   if ((i5 | 0) == (HEAP32[i14 >> 2] | 0)) {
    i5 = i7;
    i4 = i2;
    break;
   } else i4 = i2;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i1;
  if (!i2) {
   STACKTOP = i17;
   return;
  }
  __ZdlPv(i2);
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) == (i8 | 0)) {
  HEAP32[i3 >> 2] = __Znwj(4096) | 0;
  __ZNSt3__214__split_bufferIPN9BlobWrite11TypeContextENS_9allocatorIS3_EEE10push_frontERKS3_(i16, i3);
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 4 | 0;
  HEAP32[i14 >> 2] = i8;
  i7 = HEAP32[i15 >> 2] | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = i12;
  i5 = i7;
  do if ((i7 | 0) == (i12 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i8 >>> 0 > i2 >>> 0) {
    i1 = i8;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i8 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i8; else {
     _memmove(i4 | 0, i8 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i12 = __Znwj(i6 << 2) | 0;
   i4 = i12;
   i1 = i12 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i12 + (i6 << 2) | 0;
   if ((i8 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i8;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 } else {
  i9 = __Znwj(4096) | 0;
  i1 = i8;
  do if ((i5 | 0) == (i7 | 0)) {
   if (i12 >>> 0 > i2 >>> 0) {
    i3 = ((i10 - i6 >> 2) + 1 | 0) / -2 | 0;
    i4 = i12 + (i3 << 2) | 0;
    i1 = i8 - i10 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i12; else {
     _memmove(i4 | 0, i10 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i4 = i4 - i6 >> 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i11 = __Znwj(i4 << 2) | 0;
   i6 = i11;
   i1 = i11 + (i4 >>> 2 << 2) | 0;
   i7 = i1;
   i4 = i11 + (i4 << 2) | 0;
   if ((i12 | 0) == (i5 | 0)) i1 = i7; else {
    i3 = i1;
    i1 = i7;
    i2 = i12;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i5 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i6;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i4;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
}

function __ZNK5physx15PxsArticulation11checkLimitsEv(i21) {
 i21 = i21 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, d36 = 0.0, d37 = 0.0, d38 = 0.0, d39 = 0.0, d40 = 0.0, d41 = 0.0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24;
 i20 = i24 + 96 | 0;
 i18 = i24 + 80 | 0;
 i17 = i24 + 68 | 0;
 i19 = i24 + 64 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((HEAPU16[i1 + 36 >> 1] | 0) <= 1) {
  _putchar(10) | 0;
  STACKTOP = i24;
  return;
 }
 i11 = i18 + 4 | 0;
 i12 = i18 + 8 | 0;
 i13 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 i15 = i20 + 4 | 0;
 i16 = i20 + 8 | 0;
 i10 = i20 + 12 | 0;
 i9 = 1;
 do {
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i8 + (i9 << 5) + 28 >> 2] | 0;
  i7 = HEAP32[i1 + 12 >> 2] | 0;
  i8 = HEAP32[i8 + (i9 << 5) + 24 >> 2] | 0;
  f34 = Math_fround(HEAPF32[i7 + (i3 * 28 | 0) + 12 >> 2]);
  f32 = Math_fround(HEAPF32[i7 + (i3 * 28 | 0) >> 2]);
  f4 = Math_fround(HEAPF32[i7 + (i3 * 28 | 0) + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i7 + (i3 * 28 | 0) + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  f28 = Math_fround(f34 * f6);
  f29 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f32 * f29));
  f31 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f28 = Math_fround(f28 + Math_fround(f4 * f31));
  f33 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f28 = Math_fround(f28 - Math_fround(f35 * f33));
  f26 = Math_fround(Math_fround(Math_fround(f35 * f6) + Math_fround(Math_fround(f4 * f29) + Math_fround(f34 * f33))) - Math_fround(f32 * f31));
  f2 = Math_fround(Math_fround(Math_fround(f32 * f33) + Math_fround(Math_fround(f35 * f29) + Math_fround(f34 * f31))) - Math_fround(f4 * f6));
  f31 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f29) - Math_fround(f32 * f6)) - Math_fround(f4 * f33)) - Math_fround(f35 * f31));
  f35 = Math_fround(HEAPF32[i7 + (i9 * 28 | 0) + 12 >> 2]);
  f33 = Math_fround(HEAPF32[i7 + (i9 * 28 | 0) >> 2]);
  f4 = Math_fround(HEAPF32[i7 + (i9 * 28 | 0) + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i7 + (i9 * 28 | 0) + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i8 + 28 >> 2]);
  f29 = Math_fround(f35 * f32);
  f34 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f33 * f34));
  f30 = Math_fround(HEAPF32[i8 + 36 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f4 * f30));
  f5 = Math_fround(HEAPF32[i8 + 32 >> 2]);
  f29 = Math_fround(f29 - Math_fround(f6 * f5));
  f27 = Math_fround(Math_fround(Math_fround(f6 * f32) + Math_fround(Math_fround(f4 * f34) + Math_fround(f35 * f5))) - Math_fround(f33 * f30));
  f25 = Math_fround(Math_fround(Math_fround(f33 * f5) + Math_fround(Math_fround(f6 * f34) + Math_fround(f35 * f30))) - Math_fround(f4 * f32));
  f30 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f34) - Math_fround(f33 * f32)) - Math_fround(f4 * f5)) - Math_fround(f6 * f30));
  f28 = Math_fround(-f28);
  f26 = Math_fround(-f26);
  f2 = Math_fround(-f2);
  f6 = Math_fround(Math_fround(Math_fround(f25 * f26) + Math_fround(Math_fround(f31 * f29) + Math_fround(f30 * f28))) - Math_fround(f27 * f2));
  f5 = Math_fround(Math_fround(Math_fround(f29 * f2) + Math_fround(Math_fround(f30 * f26) + Math_fround(f31 * f27))) - Math_fround(f25 * f28));
  f4 = Math_fround(Math_fround(Math_fround(f27 * f28) + Math_fround(Math_fround(f30 * f2) + Math_fround(f31 * f25))) - Math_fround(f29 * f26));
  f2 = Math_fround(Math_fround(Math_fround(Math_fround(f31 * f30) - Math_fround(f29 * f28)) - Math_fround(f27 * f26)) - Math_fround(f25 * f2));
  if (f2 < Math_fround(0.0)) {
   f2 = Math_fround(-f2);
   f4 = Math_fround(-f4);
   f5 = Math_fround(-f5);
   f6 = Math_fround(-f6);
  }
  i8 = HEAP32[(HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0) + (i9 << 5) + 24 >> 2] | 0;
  if (!(HEAP8[i8 + 144 >> 0] | 0)) {
   if (HEAP8[i8 + 120 >> 0] | 0) i23 = 7;
  } else i23 = 7;
  if ((i23 | 0) == 7) {
   i23 = 0;
   if (f6 != Math_fround(0.0)) {
    f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f6 * f6) + Math_fround(0.0))))));
    f33 = Math_fround(f6 * f35);
    f34 = Math_fround(f35 * Math_fround(0.0));
    f35 = Math_fround(f2 * f35);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i1 = 0;
    i3 = 0;
    i7 = 1065353216;
   }
   f35 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f28 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f31 = Math_fround(f2 * f35);
   f30 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(f5 * f28);
   f32 = Math_fround(f4 * f28);
   f34 = Math_fround(f2 * f28);
   f28 = Math_fround(f6 * f28);
   f33 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f30) + f34) + Math_fround(f4 * f35)) - f28);
   f34 = Math_fround(Math_fround(f28 + Math_fround(Math_fround(f4 * f30) + f34)) - Math_fround(f5 * f35));
   f35 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f30) - Math_fround(f6 * f35)) - f29) - f32);
   HEAPF32[i20 >> 2] = Math_fround(Math_fround(f29 + Math_fround(Math_fround(f6 * f30) + f31)) - f32);
   HEAPF32[i15 >> 2] = f33;
   HEAPF32[i16 >> 2] = f34;
   HEAPF32[i10 >> 2] = f35;
   if (HEAP8[i8 + 120 >> 0] | 0) {
    i3 = i8 + 108 | 0;
    f33 = Math_fround(HEAPF32[i3 >> 2]);
    i1 = i8 + 112 | 0;
    f34 = Math_fround(HEAPF32[i1 >> 2]);
    f2 = Math_fround((f33 < f34 ? f33 : f34) * Math_fround(.25));
    f34 = Math_fround(+Math_tan(+Math_fround(f34 * Math_fround(.25))));
    f35 = Math_fround(+Math_tan(+Math_fround(f2 * Math_fround(.25))));
    HEAPF32[i18 >> 2] = Math_fround(+Math_tan(+Math_fround(f33 * Math_fround(.25))));
    HEAPF32[i11 >> 2] = f34;
    HEAPF32[i12 >> 2] = f35;
    if (__ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf(i18, i20, i17, i19) | 0) {
     d41 = +Math_fround(HEAPF32[i3 >> 2]);
     d40 = +Math_fround(HEAPF32[i1 >> 2]);
     d39 = +Math_fround(HEAPF32[i17 >> 2]);
     d38 = +Math_fround(HEAPF32[i13 >> 2]);
     d37 = +Math_fround(HEAPF32[i14 >> 2]);
     d36 = +Math_fround(HEAPF32[i19 >> 2]);
     HEAP32[i22 >> 2] = i9;
     HEAPF64[i22 + 8 >> 3] = d41;
     HEAPF64[i22 + 16 >> 3] = d40;
     HEAPF64[i22 + 24 >> 3] = +f2;
     HEAPF64[i22 + 32 >> 3] = d39;
     HEAPF64[i22 + 40 >> 3] = d38;
     HEAPF64[i22 + 48 >> 3] = d37;
     HEAPF64[i22 + 56 >> 3] = d36;
     _printf(gb + 773348 | 0, i22) | 0;
    }
   }
  }
  i9 = i9 + 1 | 0;
  i1 = HEAP32[i21 >> 2] | 0;
 } while (i9 >>> 0 < (HEAPU16[i1 + 36 >> 1] | 0) >>> 0);
 _putchar(10) | 0;
 STACKTOP = i24;
 return;
}

function __ZN9ShaderLab11ShaderState29FindPropsAffectingStateBlocksERK19ShaderPropertySheetR13dynamic_arrayIiLj4EE(i2, i3, i14) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = i2 + 56 | 0;
 i4 = i2 + 68 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 i6 = HEAP8[i2 + 536 >> 0] | 0 ? 8 : 1;
 i1 = 0;
 do {
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 8 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 16 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 24 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 48 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 32 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i13 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 80 + (i1 * 56 | 0) + 40 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i13;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i6 | 0));
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 528 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 540 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 548 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 556 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 564 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 572 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 580 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 588 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 596 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 604 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 612 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 620 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 628 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 636 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 644 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 652 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 660 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 668 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 676 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = (__ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i3, i15, i2 + 684 | 0) | 0) & 1;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | i10;
 i10 = HEAP32[i4 >> 2] | 0;
 if (!i10) return;
 i11 = i14 + 12 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i9 = 0;
 i1 = i2;
 do {
  i8 = HEAP32[i11 >> 2] | 0;
  i5 = i1 + (i8 << 2) | 0;
  L9 : do if (!i8) {
   i3 = i1;
   i4 = 10;
  } else {
   i4 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) {
     i4 = 10;
     break L9;
    }
    i3 = i3 + 4 | 0;
    if ((i3 | 0) == (i5 | 0)) {
     i4 = 11;
     break;
    }
   }
  } while (0);
  if ((i4 | 0) == 10) {
   i4 = 0;
   if ((i3 | 0) == (i5 | 0)) i4 = 11;
  }
  if ((i4 | 0) == 11) {
   i6 = (HEAP32[i15 >> 2] | 0) + (i9 << 2) | 0;
   i7 = i8 + 1 | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i7 >>> 0 > i5 >>> 0) {
    i3 = i4 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i12 >> 2] = i3;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i14 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i3;
     HEAP32[i14 >> 2] = i1;
     break;
    }
   } while (0);
   HEAP32[i11 >> 2] = i7;
   HEAP32[i1 + (i8 << 2) >> 2] = HEAP32[i6 >> 2];
   i2 = i1;
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i10 | 0));
 return;
}

function __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_(i14, i28, i25, i29, i30, i26, i27) {
 i14 = i14 | 0;
 i28 = i28 | 0;
 i25 = i25 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f31 = f0, f32 = f0, f33 = f0;
 i13 = HEAP32[i28 >> 2] | 0;
 L1 : do if ((i13 | 0) == (i25 | 0)) {
  i6 = HEAP32[i26 >> 2] | 0;
  i5 = HEAP32[i26 + 4 >> 2] | 0;
  i4 = HEAP32[i27 >> 2] | 0;
  i3 = HEAP32[i27 + 4 >> 2] | 0;
 } else {
  i24 = i14 + 4 | 0;
  i12 = HEAP32[i24 >> 2] | 0;
  i6 = HEAP32[i26 >> 2] | 0;
  i18 = i26 + 4 | 0;
  i5 = HEAP32[i18 >> 2] | 0;
  i19 = i26 + 8 | 0;
  i10 = HEAP32[i19 >> 2] | 0;
  i20 = i26 + 12 | 0;
  i11 = HEAP32[i20 >> 2] | 0;
  i4 = HEAP32[i27 >> 2] | 0;
  i21 = i27 + 4 | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i22 = i27 + 8 | 0;
  i17 = HEAP32[i22 >> 2] | 0;
  i23 = i27 + 12 | 0;
  i9 = HEAP32[i23 >> 2] | 0;
  f32 = (HEAP32[tempDoublePtr >> 2] = (i10 | 0) < 0 ? 0 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = (HEAP32[tempDoublePtr >> 2] = (i17 | 0) > 0 ? 0 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f33 = (HEAP32[tempDoublePtr >> 2] = (i11 | 0) < 0 ? 0 : i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i9 = !(f33 > (HEAP32[tempDoublePtr >> 2] = (i9 | 0) > 0 ? 0 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  if (!(f32 > f31)) i16 = i13; else {
   i1 = i13;
   while (1) {
    i1 = HEAP32[i12 + ((i1 + -1 | 0) * 28 | 0) + 24 >> 2] | 0;
    if ((i1 | 0) == (i25 | 0)) break L1;
   }
  }
  while (1) {
   i17 = i16 + -1 | 0;
   if ((HEAP32[i12 + (i17 * 28 | 0) >> 2] | 0) == (i29 | 0)) if ((HEAP32[i12 + (i17 * 28 | 0) + 4 >> 2] | 0) == (i30 | 0)) {
    i1 = HEAP32[i12 + (i17 * 28 | 0) + 8 >> 2] | 0;
    i2 = HEAP32[i12 + (i17 * 28 | 0) + 12 >> 2] | 0;
    i7 = HEAP32[i12 + (i17 * 28 | 0) + 16 >> 2] | 0;
    i8 = HEAP32[i12 + (i17 * 28 | 0) + 20 >> 2] | 0;
    f31 = (HEAP32[tempDoublePtr >> 2] = (i6 | 0) >= (i1 | 0) ? i6 : i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f32 = (HEAP32[tempDoublePtr >> 2] = (i4 | 0) <= (i7 | 0) ? i4 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f33 = (HEAP32[tempDoublePtr >> 2] = (i5 | 0) >= (i2 | 0) ? i5 : i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (!(f31 > f32) & !(f33 > (HEAP32[tempDoublePtr >> 2] = (i3 | 0) <= (i8 | 0) ? i3 : i8, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & i9) break;
   }
   i1 = HEAP32[i12 + (i17 * 28 | 0) + 24 >> 2] | 0;
   if ((i1 | 0) == (i25 | 0)) break L1; else i16 = i1;
  }
  HEAP32[i26 >> 2] = (i6 | 0) <= (i1 | 0) ? i6 : i1;
  HEAP32[i18 >> 2] = (i5 | 0) <= (i2 | 0) ? i5 : i2;
  HEAP32[i19 >> 2] = (i10 | 0) > 0 ? 0 : i10;
  HEAP32[i20 >> 2] = (i11 | 0) > 0 ? 0 : i11;
  i14 = HEAP32[i27 >> 2] | 0;
  i14 = (i14 | 0) >= (i7 | 0) ? i14 : i7;
  i15 = HEAP32[i21 >> 2] | 0;
  i15 = (i15 | 0) >= (i8 | 0) ? i15 : i8;
  i12 = HEAP32[i22 >> 2] | 0;
  i1 = HEAP32[i23 >> 2] | 0;
  HEAP32[i27 >> 2] = i14;
  HEAP32[i21 >> 2] = i15;
  HEAP32[i22 >> 2] = (i12 | 0) < 0 ? 0 : i12;
  HEAP32[i23 >> 2] = (i1 | 0) < 0 ? 0 : i1;
  i1 = HEAP32[i24 >> 2] | 0;
  i12 = HEAP32[i18 >> 2] | 0;
  i13 = i1 + (i17 * 28 | 0) + 8 | 0;
  HEAP32[i13 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  i1 = i1 + (i17 * 28 | 0) + 16 | 0;
  HEAP32[i1 >> 2] = i14;
  HEAP32[i1 + 4 >> 2] = i15;
  i1 = HEAP32[i28 >> 2] | 0;
  if ((i1 | 0) == (i25 | 0)) return;
  L16 : while (1) {
   i8 = HEAP32[i24 >> 2] | 0;
   i10 = HEAP32[i26 >> 2] | 0;
   i11 = HEAP32[i18 >> 2] | 0;
   i12 = HEAP32[i19 >> 2] | 0;
   i13 = HEAP32[i20 >> 2] | 0;
   i14 = HEAP32[i27 >> 2] | 0;
   i15 = HEAP32[i21 >> 2] | 0;
   i9 = HEAP32[i22 >> 2] | 0;
   i7 = HEAP32[i23 >> 2] | 0;
   f31 = (HEAP32[tempDoublePtr >> 2] = (i12 | 0) < 0 ? 0 : i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = (HEAP32[tempDoublePtr >> 2] = (i9 | 0) > 0 ? 0 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = (HEAP32[tempDoublePtr >> 2] = (i13 | 0) < 0 ? 0 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i9 = !(f31 > f32);
   i7 = !(f33 > (HEAP32[tempDoublePtr >> 2] = (i7 | 0) > 0 ? 0 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i2 = i28;
   while (1) {
    if ((i16 | 0) == (i1 | 0)) i1 = i17; else {
     i1 = i1 + -1 | 0;
     if ((HEAP32[i8 + (i1 * 28 | 0) >> 2] | 0) == (i29 | 0)) if ((HEAP32[i8 + (i1 * 28 | 0) + 4 >> 2] | 0) == (i30 | 0)) {
      i3 = HEAP32[i8 + (i1 * 28 | 0) + 8 >> 2] | 0;
      i4 = HEAP32[i8 + (i1 * 28 | 0) + 12 >> 2] | 0;
      i5 = HEAP32[i8 + (i1 * 28 | 0) + 16 >> 2] | 0;
      i6 = HEAP32[i8 + (i1 * 28 | 0) + 20 >> 2] | 0;
      f31 = (HEAP32[tempDoublePtr >> 2] = (i10 | 0) >= (i3 | 0) ? i10 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f32 = (HEAP32[tempDoublePtr >> 2] = (i14 | 0) <= (i5 | 0) ? i14 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f33 = (HEAP32[tempDoublePtr >> 2] = (i11 | 0) >= (i4 | 0) ? i11 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if (!(f31 > f32) & !(f33 > (HEAP32[tempDoublePtr >> 2] = (i15 | 0) <= (i6 | 0) ? i15 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & i9 & i7) break;
     }
    }
    i2 = i8 + (i1 * 28 | 0) + 24 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == (i25 | 0)) {
     i1 = 20;
     break L16;
    }
   }
   HEAP32[i26 >> 2] = (i10 | 0) <= (i3 | 0) ? i10 : i3;
   HEAP32[i18 >> 2] = (i11 | 0) <= (i4 | 0) ? i11 : i4;
   HEAP32[i19 >> 2] = (i12 | 0) > 0 ? 0 : i12;
   HEAP32[i20 >> 2] = (i13 | 0) > 0 ? 0 : i13;
   i13 = HEAP32[i27 >> 2] | 0;
   i13 = (i13 | 0) >= (i5 | 0) ? i13 : i5;
   i14 = HEAP32[i21 >> 2] | 0;
   i14 = (i14 | 0) >= (i6 | 0) ? i14 : i6;
   i11 = HEAP32[i22 >> 2] | 0;
   i15 = HEAP32[i23 >> 2] | 0;
   HEAP32[i27 >> 2] = i13;
   HEAP32[i21 >> 2] = i14;
   HEAP32[i22 >> 2] = (i11 | 0) < 0 ? 0 : i11;
   HEAP32[i23 >> 2] = (i15 | 0) < 0 ? 0 : i15;
   i15 = HEAP32[i24 >> 2] | 0;
   i11 = HEAP32[i18 >> 2] | 0;
   i12 = i15 + (i17 * 28 | 0) + 8 | 0;
   HEAP32[i12 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i15 = i15 + (i17 * 28 | 0) + 16 | 0;
   HEAP32[i15 >> 2] = i13;
   HEAP32[i15 + 4 >> 2] = i14;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i24 >> 2] | 0) + (i1 * 28 | 0) + 24 >> 2];
   i1 = HEAP32[i28 >> 2] | 0;
   if ((i1 | 0) == (i25 | 0)) {
    i1 = 20;
    break;
   }
  }
  if ((i1 | 0) == 20) return;
 } while (0);
 i1 = i14 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (__ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb(i14, i2 + 1 | 0, 1, 0, 0) | 0) {
  i27 = HEAP32[i14 + 4 >> 2] | 0;
  i26 = i27 + (i2 * 28 | 0) | 0;
  HEAP32[i26 >> 2] = i29;
  HEAP32[i26 + 4 >> 2] = i30;
  i30 = i27 + (i2 * 28 | 0) + 8 | 0;
  HEAP32[i30 >> 2] = i6;
  HEAP32[i30 + 4 >> 2] = i5;
  i30 = i27 + (i2 * 28 | 0) + 16 | 0;
  HEAP32[i30 >> 2] = i4;
  HEAP32[i30 + 4 >> 2] = i3;
  HEAP32[i27 + (i2 * 28 | 0) + 24 >> 2] = i13;
 }
 HEAP32[i28 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __ZN23ParticleSystemParticlesD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 848 | 0;
 if ((HEAP32[i3 + 864 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 852 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 828 | 0;
 if ((HEAP32[i3 + 844 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 832 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 740 | 0;
 i1 = i3 + 800 | 0;
 if ((HEAP32[i3 + 816 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 804 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 780 | 0;
 if ((HEAP32[i3 + 796 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 784 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 760 | 0;
 if ((HEAP32[i3 + 776 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 764 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 756 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 744 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 640 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 728 >> 2] | 0, i3 + 720 | 0);
 i1 = i3 + 700 | 0;
 if ((HEAP32[i3 + 716 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 704 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 680 | 0;
 if ((HEAP32[i3 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 660 | 0;
 if ((HEAP32[i3 + 676 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 664 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 656 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 644 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 620 | 0;
 if ((HEAP32[i3 + 636 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 624 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 608 >> 2] | 0, i3 + 600 | 0);
 i1 = i3 + 580 | 0;
 if ((HEAP32[i3 + 596 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 584 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 560 | 0;
 if ((HEAP32[i3 + 576 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 564 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 540 | 0;
 if ((HEAP32[i3 + 556 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 544 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 520 | 0;
 if ((HEAP32[i3 + 536 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 524 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 500 | 0;
 if ((HEAP32[i3 + 516 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 504 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 480 | 0;
 if ((HEAP32[i3 + 496 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 484 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 420 | 0;
 i1 = i3 + 460 | 0;
 if ((HEAP32[i3 + 476 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 464 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 440 | 0;
 if ((HEAP32[i3 + 456 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 444 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 436 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 424 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 360 | 0;
 i1 = i3 + 400 | 0;
 if ((HEAP32[i3 + 416 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 404 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 380 | 0;
 if ((HEAP32[i3 + 396 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 384 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 376 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 364 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 300 | 0;
 i1 = i3 + 340 | 0;
 if ((HEAP32[i3 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 344 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 320 | 0;
 if ((HEAP32[i3 + 336 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 324 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 316 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 304 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 240 | 0;
 i1 = i3 + 280 | 0;
 if ((HEAP32[i3 + 296 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 284 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 260 | 0;
 if ((HEAP32[i3 + 276 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 264 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 244 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 180 | 0;
 i1 = i3 + 220 | 0;
 if ((HEAP32[i3 + 236 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 224 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 200 | 0;
 if ((HEAP32[i3 + 216 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 204 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 184 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 120 | 0;
 i1 = i3 + 160 | 0;
 if ((HEAP32[i3 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 140 | 0;
 if ((HEAP32[i3 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i3 + 60 | 0;
 i1 = i3 + 100 | 0;
 if ((HEAP32[i3 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 80 | 0;
 if ((HEAP32[i3 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 if ((HEAP32[i3 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 20 | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17;
 i1 = i16 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 340) {
  HEAP32[i1 >> 2] = i2 + -341;
  i10 = i16 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = i16 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i1 = i15;
  i5 = i7;
  do if ((i7 | 0) == (i15 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i9 >>> 0 > i2 >>> 0) {
    i1 = i9;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i9 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i9; else {
     _memmove(i4 | 0, i9 | 0, i1 | 0) | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i10 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i15 = __Znwj(i6 << 2) | 0;
   i4 = i15;
   i1 = i15 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i15 + (i6 << 2) | 0;
   if ((i9 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i9;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i11 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
 i15 = i16 + 8 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i9 = i8 - i10 | 0;
 i11 = i9 >> 2;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i1 = i4 - i6 | 0;
 i5 = i8;
 i12 = i10;
 i7 = i4;
 i2 = i6;
 if (i11 >>> 0 >= i1 >> 2 >>> 0) {
  i10 = i1 >> 1;
  i10 = (i10 | 0) == 0 ? 1 : i10;
  i2 = __Znwj(i10 << 2) | 0;
  i3 = i2;
  i4 = i2 + (i11 << 2) | 0;
  i1 = i2 + (i10 << 2) | 0;
  i6 = __Znwj(4092) | 0;
  do if ((i11 | 0) == (i10 | 0)) if ((i9 | 0) > 0) {
   i7 = i3;
   i3 = i4 + (((i11 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i12;
   break;
  } else {
   i1 = i9 >> 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   i5 = __Znwj(i1 << 2) | 0;
   __ZdlPv(i2);
   i7 = i5;
   i3 = i5 + (i1 >>> 2 << 2) | 0;
   i1 = i5 + (i1 << 2) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i7 = i3;
   i3 = i4;
   i2 = i12;
  } while (0);
  i4 = i3;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  if ((i5 | 0) == (i2 | 0)) i5 = i7; else while (1) {
   i5 = i5 + -4 | 0;
   i2 = i4;
   do if ((i2 | 0) == (i7 | 0)) {
    i9 = i3;
    if (i9 >>> 0 < i1 >>> 0) {
     i6 = i9 + ((((i1 - i3 >> 2) + 1 | 0) / 2 | 0) << 2) | 0;
     i2 = i3 - i4 | 0;
     i12 = i2 >> 2;
     i3 = i6 + (0 - i12 << 2) | 0;
     if (!i12) i2 = i6; else {
      _memmove(i3 | 0, i4 | 0, i2 | 0) | 0;
      i2 = i3;
     }
     i4 = i2;
     i3 = i6;
     break;
    }
    i1 = i1 - i7 >> 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    i12 = __Znwj(i1 << 2) | 0;
    i7 = i12;
    i10 = i12 + ((i1 + 3 | 0) >>> 2 << 2) | 0;
    i8 = i10;
    i1 = i12 + (i1 << 2) | 0;
    if ((i2 | 0) == (i9 | 0)) i3 = i8; else {
     i6 = i10;
     i3 = i8;
     do {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      i6 = i3 + 4 | 0;
      i3 = i6;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i9 | 0));
    }
    if (!i4) {
     i4 = i8;
     i2 = i10;
    } else {
     __ZdlPv(i4);
     i4 = i8;
     i2 = i10;
    }
   } while (0);
   HEAP32[i2 + -4 >> 2] = HEAP32[i5 >> 2];
   i2 = i4 + -4 | 0;
   if ((i5 | 0) == (HEAP32[i14 >> 2] | 0)) {
    i5 = i7;
    i4 = i2;
    break;
   } else i4 = i2;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i1;
  if (!i2) {
   STACKTOP = i17;
   return;
  }
  __ZdlPv(i2);
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) == (i8 | 0)) {
  HEAP32[i3 >> 2] = __Znwj(4092) | 0;
  __ZNSt3__214__split_bufferIP18ReflectionProbeJobNS_9allocatorIS2_EEE10push_frontERKS2_(i16, i3);
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 4 | 0;
  HEAP32[i14 >> 2] = i8;
  i7 = HEAP32[i15 >> 2] | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = i12;
  i5 = i7;
  do if ((i7 | 0) == (i12 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i8 >>> 0 > i2 >>> 0) {
    i1 = i8;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i8 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i8; else {
     _memmove(i4 | 0, i8 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i12 = __Znwj(i6 << 2) | 0;
   i4 = i12;
   i1 = i12 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i12 + (i6 << 2) | 0;
   if ((i8 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i8;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 } else {
  i9 = __Znwj(4092) | 0;
  i1 = i8;
  do if ((i5 | 0) == (i7 | 0)) {
   if (i12 >>> 0 > i2 >>> 0) {
    i3 = ((i10 - i6 >> 2) + 1 | 0) / -2 | 0;
    i4 = i12 + (i3 << 2) | 0;
    i1 = i8 - i10 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i12; else {
     _memmove(i4 | 0, i10 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i4 = i4 - i6 >> 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i11 = __Znwj(i4 << 2) | 0;
   i6 = i11;
   i1 = i11 + (i4 >>> 2 << 2) | 0;
   i7 = i1;
   i4 = i11 + (i4 << 2) | 0;
   if ((i12 | 0) == (i5 | 0)) i1 = i7; else {
    i3 = i1;
    i1 = i7;
    i2 = i12;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i5 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i6;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i4;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
}

function _inflate_fast(i25, i1) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i20 = HEAP32[i25 + 28 >> 2] | 0;
 i5 = (HEAP32[i25 >> 2] | 0) + -1 | 0;
 i31 = i25 + 4 | 0;
 i32 = i5 + ((HEAP32[i31 >> 2] | 0) + -5) | 0;
 i26 = i25 + 12 | 0;
 i3 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
 i27 = i25 + 16 | 0;
 i12 = HEAP32[i27 >> 2] | 0;
 i28 = i3 + (i12 + -257) | 0;
 i17 = HEAP32[i20 + 40 >> 2] | 0;
 i18 = HEAP32[i20 + 44 >> 2] | 0;
 i19 = HEAP32[i20 + 48 >> 2] | 0;
 i29 = i20 + 56 | 0;
 i30 = i20 + 60 | 0;
 i21 = HEAP32[i20 + 76 >> 2] | 0;
 i22 = HEAP32[i20 + 80 >> 2] | 0;
 i23 = (1 << HEAP32[i20 + 84 >> 2]) + -1 | 0;
 i24 = (1 << HEAP32[i20 + 88 >> 2]) + -1 | 0;
 i12 = i3 + (i12 - i1) | 0;
 i13 = (HEAP32[i20 + 52 >> 2] | 0) + -1 | 0;
 i14 = (i19 | 0) == 0;
 i15 = i19 + i17 | 0;
 i16 = i12 - i19 | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 L1 : while (1) {
  if (i1 >>> 0 < 15) {
   i11 = i5 + 2 | 0;
   i4 = i11;
   i2 = ((HEAPU8[i5 + 1 >> 0] | 0) << i1) + i2 + ((HEAPU8[i11 >> 0] | 0) << i1 + 8) | 0;
   i1 = i1 + 16 | 0;
  } else i4 = i5;
  i11 = i2 & i23;
  i5 = HEAP8[i21 + (i11 << 2) >> 0] | 0;
  i6 = HEAP16[i21 + (i11 << 2) + 2 >> 1] | 0;
  i11 = HEAPU8[i21 + (i11 << 2) + 1 >> 0] | 0;
  i2 = i2 >>> i11;
  i1 = i1 - i11 | 0;
  do if (!(i5 << 24 >> 24)) {
   i5 = i6 & 255;
   i33 = 7;
  } else {
   i7 = i5 & 255;
   while (1) {
    if (i7 & 16 | 0) break;
    if (i7 & 64 | 0) {
     i33 = 54;
     break L1;
    }
    i11 = (i2 & (1 << i7) + -1) + (i6 & 65535) | 0;
    i5 = HEAP8[i21 + (i11 << 2) >> 0] | 0;
    i6 = HEAP16[i21 + (i11 << 2) + 2 >> 1] | 0;
    i11 = HEAPU8[i21 + (i11 << 2) + 1 >> 0] | 0;
    i2 = i2 >>> i11;
    i1 = i1 - i11 | 0;
    if (!(i5 << 24 >> 24)) {
     i33 = 6;
     break;
    } else i7 = i5 & 255;
   }
   if ((i33 | 0) == 6) {
    i5 = i6 & 255;
    i33 = 7;
    break;
   }
   i5 = i6 & 65535;
   i7 = i7 & 15;
   if (i7) {
    i6 = i4 + 1 | 0;
    if (i1 >>> 0 < i7 >>> 0) {
     i4 = i6;
     i2 = ((HEAPU8[i6 >> 0] | 0) << i1) + i2 | 0;
     i1 = i1 + 8 | 0;
    }
    i5 = (i2 & (1 << i7) + -1) + i5 | 0;
    i2 = i2 >>> i7;
    i1 = i1 - i7 | 0;
   }
   if (i1 >>> 0 < 15) {
    i11 = i4 + 2 | 0;
    i10 = i11;
    i2 = ((HEAPU8[i4 + 1 >> 0] | 0) << i1) + i2 + ((HEAPU8[i11 >> 0] | 0) << i1 + 8) | 0;
    i1 = i1 + 16 | 0;
   } else i10 = i4;
   i6 = i2 & i24;
   i4 = HEAP16[i22 + (i6 << 2) + 2 >> 1] | 0;
   i11 = HEAPU8[i22 + (i6 << 2) + 1 >> 0] | 0;
   i2 = i2 >>> i11;
   i1 = i1 - i11 | 0;
   i6 = HEAPU8[i22 + (i6 << 2) >> 0] | 0;
   if (!(i6 & 16)) do {
    if (i6 & 64 | 0) {
     i33 = 51;
     break L1;
    }
    i6 = (i2 & (1 << i6) + -1) + (i4 & 65535) | 0;
    i4 = HEAP16[i22 + (i6 << 2) + 2 >> 1] | 0;
    i11 = HEAPU8[i22 + (i6 << 2) + 1 >> 0] | 0;
    i2 = i2 >>> i11;
    i1 = i1 - i11 | 0;
    i6 = HEAPU8[i22 + (i6 << 2) >> 0] | 0;
   } while ((i6 & 16 | 0) == 0);
   i8 = i4 & 65535;
   i9 = i6 & 15;
   if (i1 >>> 0 < i9 >>> 0) {
    i4 = i10 + 1 | 0;
    i2 = ((HEAPU8[i4 >> 0] | 0) << i1) + i2 | 0;
    i7 = i1 + 8 | 0;
    i6 = i10 + 2 | 0;
    if (i7 >>> 0 < i9 >>> 0) {
     i4 = i6;
     i2 = ((HEAPU8[i6 >> 0] | 0) << i7) + i2 | 0;
     i1 = i1 + 16 | 0;
    } else i1 = i7;
   } else i4 = i10;
   i11 = (i2 & (1 << i9) + -1) + i8 | 0;
   i2 = i2 >>> i9;
   i1 = i1 - i9 | 0;
   i8 = i3;
   i6 = i8 - i12 | 0;
   if (i11 >>> 0 <= i6 >>> 0) {
    i8 = i3 + (0 - i11) | 0;
    i7 = i3;
    while (1) {
     HEAP8[i7 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
     HEAP8[i7 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
     i6 = i8 + 3 | 0;
     i3 = i7 + 3 | 0;
     HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
     i5 = i5 + -3 | 0;
     if (i5 >>> 0 <= 2) break; else {
      i8 = i6;
      i7 = i3;
     }
    }
    if (!i5) break;
    i3 = i7 + 4 | 0;
    HEAP8[i3 >> 0] = HEAP8[i8 + 4 >> 0] | 0;
    if ((i5 | 0) == 1) break;
    i3 = i7 + 5 | 0;
    HEAP8[i3 >> 0] = HEAP8[i8 + 5 >> 0] | 0;
    break;
   }
   i7 = i11 - i6 | 0;
   if (i7 >>> 0 > i18 >>> 0) {
    i33 = 21;
    break L1;
   }
   do if (i14) {
    i6 = i13 + (i17 - i7) | 0;
    if (i5 >>> 0 > i7 >>> 0) {
     i5 = i5 - i7 | 0;
     i9 = i11 - i8 | 0;
     i8 = i3;
     do {
      i6 = i6 + 1 | 0;
      i8 = i8 + 1 | 0;
      HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
      i7 = i7 + -1 | 0;
     } while ((i7 | 0) != 0);
     i3 = i3 + i12 + i9 | 0;
     i6 = i3 + (0 - i11) | 0;
    }
   } else {
    if (i19 >>> 0 >= i7 >>> 0) {
     i6 = i13 + (i19 - i7) | 0;
     if (i5 >>> 0 <= i7 >>> 0) break;
     i5 = i5 - i7 | 0;
     i9 = i11 - i8 | 0;
     i8 = i3;
     do {
      i6 = i6 + 1 | 0;
      i8 = i8 + 1 | 0;
      HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
      i7 = i7 + -1 | 0;
     } while ((i7 | 0) != 0);
     i3 = i3 + i12 + i9 | 0;
     i6 = i3 + (0 - i11) | 0;
     break;
    }
    i6 = i13 + (i15 - i7) | 0;
    i7 = i7 - i19 | 0;
    if (i5 >>> 0 > i7 >>> 0) {
     i5 = i5 - i7 | 0;
     i10 = i11 - i8 | 0;
     i8 = i3;
     do {
      i6 = i6 + 1 | 0;
      i8 = i8 + 1 | 0;
      HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
      i7 = i7 + -1 | 0;
     } while ((i7 | 0) != 0);
     i9 = i3 + i16 + i10 | 0;
     if (i5 >>> 0 > i19 >>> 0) {
      i8 = i3 + i12 | 0;
      i6 = i13;
      i7 = i19;
      i3 = i9;
      do {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
       HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
       i7 = i7 + -1 | 0;
      } while ((i7 | 0) != 0);
      i3 = i8 + i10 | 0;
      i5 = i5 - i19 | 0;
      i6 = i3 + (0 - i11) | 0;
     } else {
      i6 = i13;
      i3 = i9;
     }
    }
   } while (0);
   if (i5 >>> 0 > 2) do {
    HEAP8[i3 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    HEAP8[i3 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    i6 = i6 + 3 | 0;
    i3 = i3 + 3 | 0;
    HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
    i5 = i5 + -3 | 0;
   } while (i5 >>> 0 > 2);
   if (i5) {
    i7 = i3 + 1 | 0;
    HEAP8[i7 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
    if ((i5 | 0) == 1) i3 = i7; else {
     i3 = i3 + 2 | 0;
     HEAP8[i3 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
    }
   }
  } while (0);
  if ((i33 | 0) == 7) {
   i33 = 0;
   i3 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = i5;
  }
  if (i3 >>> 0 < i28 >>> 0 & i4 >>> 0 < i32 >>> 0) i5 = i4; else break;
 }
 do if ((i33 | 0) == 21) {
  HEAP32[i25 + 24 >> 2] = gb + 362948;
  HEAP32[i20 >> 2] = 27;
 } else if ((i33 | 0) == 51) {
  HEAP32[i25 + 24 >> 2] = gb + 362926;
  HEAP32[i20 >> 2] = 27;
  i4 = i10;
 } else if ((i33 | 0) == 54) if (!(i7 & 32)) {
  HEAP32[i25 + 24 >> 2] = gb + 362898;
  HEAP32[i20 >> 2] = 27;
  break;
 } else {
  HEAP32[i20 >> 2] = 11;
  break;
 } while (0);
 i33 = i1 >>> 3;
 i24 = i4 + (0 - i33) | 0;
 i33 = i1 - (i33 << 3) | 0;
 HEAP32[i25 >> 2] = i24 + 1;
 HEAP32[i26 >> 2] = i3 + 1;
 HEAP32[i31 >> 2] = i32 + 5 - i24;
 HEAP32[i27 >> 2] = i28 + 257 - i3;
 HEAP32[i29 >> 2] = (1 << i33) + -1 & i2;
 HEAP32[i30 >> 2] = i33;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN15ResourceManager10Dependency6SorterEPS2_EEbT0_S6_T_(i19, i20, i1) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 24 | 0;
 i21 = i23;
 switch ((i20 - i19 | 0) / 20 | 0 | 0) {
 case 2:
  {
   i8 = i20 + -20 | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i8 >> 2] | 0) >= (i1 | 0)) {
    i22 = 1;
    STACKTOP = i23;
    return i22 | 0;
   }
   HEAP32[i21 >> 2] = i1;
   i4 = i21 + 4 | 0;
   i7 = i19 + 4 | 0;
   i1 = HEAP32[i19 + 16 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   i9 = i21 + 8 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i21 + 12 >> 2] = 0;
   i10 = i21 + 16 | 0;
   HEAP32[i10 >> 2] = i1;
   i6 = i19 + 8 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i5 = i2 >> 2;
   if (i5 | 0) {
    if ((i2 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    HEAP32[i22 >> 2] = 51;
    HEAP32[i22 + 4 >> 2] = i1;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i9 >> 2] = i3;
    HEAP32[i4 >> 2] = i3;
    HEAP32[i21 + 12 >> 2] = i3 + (i5 << 2);
    i2 = HEAP32[i7 >> 2] | 0;
    i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (i1 >> 2 << 2);
    }
   }
   HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
   if ((i8 | 0) != (i19 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i20 + -16 >> 2] | 0, HEAP32[i20 + -12 >> 2] | 0);
   HEAP32[i8 >> 2] = HEAP32[i21 >> 2];
   if ((i21 | 0) == (i8 | 0)) i1 = i21 + 4 | 0; else {
    i1 = i21 + 4 | 0;
    __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i20 + -16 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0);
   }
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    i21 = HEAP32[i10 >> 2] | 0;
    HEAP32[i22 >> 2] = 51;
    HEAP32[i22 + 4 >> 2] = i21;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
   }
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i19, i19 + 20 | 0, i20 + -20 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_(i19, i19 + 20 | 0, i19 + 40 | 0, i20 + -20 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_(i19, i19 + 20 | 0, i19 + 40 | 0, i19 + 60 | 0, i20 + -20 | 0, i1) | 0;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 1:
 case 0:
  {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  {
   i2 = i19 + 40 | 0;
   __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i19, i19 + 20 | 0, i2, i1) | 0;
   i1 = i19 + 60 | 0;
   L3 : do if ((i1 | 0) == (i20 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i10 = i21 + 4 | 0;
    i11 = i21 + 8 | 0;
    i12 = i21 + 12 | 0;
    i13 = i21 + 16 | 0;
    i14 = i22 + 4 | 0;
    i15 = i21 + 12 | 0;
    i16 = i21 + 4 | 0;
    i17 = i22 + 4 | 0;
    i9 = i1;
    i1 = 0;
    i8 = i2;
    while (1) {
     i2 = HEAP32[i9 >> 2] | 0;
     if ((i2 | 0) < (HEAP32[i8 >> 2] | 0)) {
      HEAP32[i21 >> 2] = i2;
      i5 = i9 + 4 | 0;
      i2 = HEAP32[i9 + 16 >> 2] | 0;
      HEAP32[i10 >> 2] = 0;
      HEAP32[i11 >> 2] = 0;
      HEAP32[i12 >> 2] = 0;
      HEAP32[i13 >> 2] = i2;
      i7 = i9 + 8 | 0;
      i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
      i6 = i3 >> 2;
      if (i6 | 0) {
       if ((i3 | 0) < 0) {
        __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
        i2 = HEAP32[i13 >> 2] | 0;
       }
       HEAP32[i22 >> 2] = 51;
       HEAP32[i14 >> 2] = i2;
       i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i11 >> 2] = i4;
       HEAP32[i10 >> 2] = i4;
       HEAP32[i15 >> 2] = i4 + (i6 << 2);
       i3 = HEAP32[i5 >> 2] | 0;
       i2 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
       if ((i2 | 0) > 0) {
        _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
        HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i2 >> 2 << 2);
       }
      }
      i5 = i8;
      i2 = i9;
      i4 = HEAP32[i8 >> 2] | 0;
      while (1) {
       HEAP32[i2 >> 2] = i4;
       if ((i2 | 0) != (i5 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i2 + 4 | 0, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i5 + 8 >> 2] | 0);
       if ((i5 | 0) == (i19 | 0)) {
        i18 = 33;
        break;
       }
       i3 = i5 + -20 | 0;
       i2 = HEAP32[i21 >> 2] | 0;
       i4 = HEAP32[i3 >> 2] | 0;
       if ((i2 | 0) >= (i4 | 0)) {
        i3 = i5;
        break;
       } else {
        i2 = i5;
        i5 = i3;
       }
      }
      if ((i18 | 0) == 33) {
       i18 = 0;
       i3 = i19;
       i2 = HEAP32[i21 >> 2] | 0;
      }
      HEAP32[i5 >> 2] = i2;
      if ((i3 | 0) != (i21 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i3 + 4 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i11 >> 2] | 0);
      i2 = i1 + 1 | 0;
      i3 = (i2 | 0) == 8;
      i1 = (i9 + 20 | 0) == (i20 | 0);
      i4 = HEAP32[i16 >> 2] | 0;
      i5 = i4;
      if (i4 | 0) {
       i6 = HEAP32[i11 >> 2] | 0;
       if ((i6 | 0) != (i4 | 0)) HEAP32[i11 >> 2] = i6 + (~((i6 + -4 - i5 | 0) >>> 2) << 2);
       i8 = HEAP32[i13 >> 2] | 0;
       HEAP32[i22 >> 2] = 51;
       HEAP32[i17 >> 2] = i8;
       __Z19free_alloc_internalPvRK10MemLabelId(i4, i22);
      }
      if (i3) {
       i2 = 0;
       break L3;
      } else i1 = i2;
     }
     i2 = i9 + 20 | 0;
     if ((i2 | 0) == (i20 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i8 = i9;
      i9 = i2;
     }
    }
   } while (0);
   i22 = i1 | i2;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 return 0;
}

function __ZN18AsyncUploadManager23HandleAsyncReadCommandsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i31 + 20 | 0;
 i30 = i31 + 8 | 0;
 i12 = i31 + 16 | 0;
 i21 = i31;
 i22 = i11 + 20 | 0;
 i23 = i29 + 4 | 0;
 i24 = i29 + 8 | 0;
 i25 = i29 + 12 | 0;
 i26 = i29 + 16 | 0;
 i27 = i29 + 20 | 0;
 i28 = i29 + 24 | 0;
 i13 = i11 + 1340 | 0;
 i14 = i11 + 1344 | 0;
 i15 = i11 + 36 | 0;
 i16 = i11 + 1324 | 0;
 i17 = i11 + 4 | 0;
 i18 = i11 + 1352 | 0;
 i10 = 0;
 i20 = HEAP32[i22 >> 2] | 0;
 L1 : while (1) {
  i19 = i11 + 44 + (i20 * 40 | 0) + 24 | 0;
  switch (HEAP32[i19 >> 2] | 0) {
  case 1:
  case 3:
   {
    i9 = 49;
    break L1;
   }
  case 0:
   {
    i8 = HEAP32[i11 + 44 + (i20 * 40 | 0) + 32 >> 2] | 0;
    i3 = i8 + 60 | 0;
    if ((HEAP32[i3 >> 2] | 1 | 0) == 29) i9 = 5; else if (HEAP32[i8 + 64 >> 2] & 536870912 | 0) i9 = 5;
    if ((i9 | 0) == 5) {
     i9 = 0;
     i1 = i8 + 180 | 0;
     do if (!(HEAP8[i1 >> 0] | 0)) {
      i7 = i8 + 64 | 0;
      if (!(HEAP32[i7 >> 2] & 536870912)) {
       HEAP8[i1 >> 0] = 2;
       if ((__Z22GetJobQueueThreadCountv() | 0) > 0) {
        __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i8 + 148 | 0, fb + 3360 | 0, i8, 0);
        break;
       }
       i2 = i8 + 24 | 0;
       HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
       i6 = HEAP32[i7 >> 2] | 0;
       i1 = HEAP32[i8 + 68 >> 2] | 0;
       i4 = HEAP32[i8 + 36 >> 2] | 0;
       i5 = HEAP32[i8 + 40 >> 2] | 0;
       i34 = gb + 64024 | 0;
       i33 = HEAP32[i34 + 4 >> 2] | 0;
       i32 = i21;
       HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i32 + 4 >> 2] = i33;
       HEAP32[i29 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i29 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
       i6 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i1, i12, i3, i6 & 255, i4, i5, (i6 & 245760 | 0) == 32768 ? 1 : 6, i29) | 0;
       HEAP32[i8 + 72 >> 2] = i6;
       if (!i6) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397888 | 0, 0, gb + 397649 | 0, 330, 1, 0, 0, 0); else {
        i1 = HEAP32[i12 >> 2] | 0;
        HEAP32[i2 >> 2] = i1;
        if ((HEAP32[i7 >> 2] & 245760 | 0) == 65536) HEAP32[i8 + 28 >> 2] = (i1 >>> 0) / 6 | 0;
       }
       break;
      }
      HEAP8[i1 >> 0] = 1;
      if ((__Z22GetJobQueueThreadCountv() | 0) > 0) {
       __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i8 + 148 | 0, fb + 3359 | 0, i8, 0);
       break;
      }
      i1 = HEAP32[i7 >> 2] | 0;
      HEAP32[i29 >> 2] = HEAP32[i8 + 68 >> 2];
      HEAP32[i23 >> 2] = HEAP32[i8 + 24 >> 2];
      HEAP32[i24 >> 2] = HEAP32[i8 + 36 >> 2];
      HEAP32[i25 >> 2] = HEAP32[i8 + 40 >> 2];
      i6 = i8 + 32 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      HEAP32[i26 >> 2] = i2;
      HEAP32[i27 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i28 >> 2] = i1 & 255;
      if ((i2 | 0) > 0) {
       i5 = i8 + 76 | 0;
       i4 = i8 + 104 | 0;
       if ((i1 & 3932160 | 0) == 1572864) {
        i3 = 0;
        do {
         if (i1 & 255) {
          i1 = 0;
          do {
           __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i29, i5, i3, i1, 1, 0);
           i1 = i1 + 1 | 0;
           i2 = HEAP32[i7 >> 2] | 0;
          } while ((i1 | 0) < (i2 & 255 | 0));
          i1 = i2;
          i2 = HEAP32[i6 >> 2] | 0;
         }
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) < (i2 | 0));
       } else {
        i3 = 0;
        do {
         if (i1 & 255) {
          i2 = 0;
          do {
           __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i29, i4, i3, i2, 0, 1);
           __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i29, i5, i3, i2, 1, 0);
           i2 = i2 + 1 | 0;
           i1 = HEAP32[i7 >> 2] | 0;
          } while ((i2 | 0) < (i1 & 255 | 0));
          i2 = HEAP32[i6 >> 2] | 0;
         }
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) < (i2 | 0));
       }
      }
     } while (0);
     if (!(__Z11IsFenceDoneRK8JobFence(i8 + 148 | 0) | 0)) {
      i9 = 49;
      break L1;
     }
    }
    i2 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) i1 = __ZnwjRK10MemLabelIdiPKci(16, i14, 16, gb + 397729 | 0, 33) | 0; else HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 + 4 >> 2] = i8;
    i33 = HEAP32[i15 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    i34 = HEAP32[i33 >> 2] | 0;
    HEAP32[i33 >> 2] = i1;
    HEAP32[i34 >> 2] = i1;
    HEAP32[i19 >> 2] = 3;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 28 >> 2] = 0;
    HEAP8[i11 + 44 + (i20 * 40 | 0) + 36 >> 0] = 0;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 12 >> 2] = 0;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 16 >> 2] = 0;
    break;
   }
  case 2:
   {
    i8 = HEAP32[i11 + 44 + (i20 * 40 | 0) + 32 >> 2] | 0;
    i4 = HEAP32[i8 + 144 >> 2] | 0;
    i1 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i1 + 24 >> 2] | 0;
    i7 = i1 + 20 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i6 = i1 + 28 | 0;
    i1 = HEAP32[i1 + 32 >> 2] | 0;
    if ((HEAP32[i6 >> 2] | 0) == 1) {
     i2 = i1 >>> 0 < i5 >>> 0 ? 0 : i1 - i5 | 0;
     i34 = (i3 | 0) != 0 & (i2 | 0) == 0;
     i1 = i34 ? i3 : i2;
     if (i34) {
      i1 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
      i9 = 37;
     } else {
      i1 = i2;
      i9 = 36;
     }
    } else {
     i1 = i3 >>> 0 > i5 >>> 0 ? i3 - i5 | 0 : 0;
     i9 = 36;
    }
    if ((i9 | 0) == 36) {
     i9 = 0;
     i1 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
     if (!i5) i9 = 37;
    }
    if ((i9 | 0) == 37) {
     i9 = 0;
     if (HEAP32[i7 >> 2] | 0) {
      HEAP32[i7 >> 2] = 0;
      HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
     }
    }
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
    i1 = i8 + 148 | 0;
    if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
    i1 = i8 + 168 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    i2 = i8 + 156 | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
    HEAP32[i30 >> 2] = i1;
    HEAP32[i30 + 4 >> 2] = i2;
    _printf_console(gb + 397912 | 0, i30);
    HEAP32[i19 >> 2] = 3;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 28 >> 2] = 0;
    HEAP8[i11 + 44 + (i20 * 40 | 0) + 36 >> 0] = 0;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 12 >> 2] = 0;
    HEAP32[i11 + 44 + (i20 * 40 | 0) + 16 >> 2] = 0;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
    i34 = i8 + 140 | 0;
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
    i34 = HEAP32[i18 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i34 >> 2];
    HEAP32[i34 >> 2] = i8;
    break;
   }
  default:
   {}
  }
  i20 = ((HEAP32[i22 >> 2] | 0) + 1 | 0) % 32 | 0;
  HEAP32[i22 >> 2] = i20;
  i10 = i10 + 1 | 0;
  if ((i10 | 0) >= 32) {
   i9 = 49;
   break;
  }
 }
 if ((i9 | 0) == 49) {
  STACKTOP = i31;
  return;
 }
}

function __ZN17PersistentManager23PostLoadStreamNameSpaceER15StreamNameSpacei(i26, i1, i30) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i33 + 48 | 0;
 i28 = i33 + 8 | 0;
 i29 = i33;
 i25 = i33 + 12 | 0;
 i31 = i1 + 8 | 0;
 i20 = __ZNK14SerializedFile12GetHighestIDEv(HEAP32[i1 >> 2] | 0) | 0;
 i24 = getTempRet0() | 0;
 i23 = i31;
 i21 = HEAP32[i23 >> 2] | 0;
 i23 = HEAP32[i23 + 4 >> 2] | 0;
 i22 = (i23 | 0) < (i24 | 0) | (i23 | 0) == (i24 | 0) & i21 >>> 0 < i20 >>> 0;
 HEAP32[i31 >> 2] = i22 ? i20 : i21;
 HEAP32[i31 + 4 >> 2] = i22 ? i24 : i23;
 i31 = __Z20push_allocation_rootPvP13BaseAllocatorb(i26, 0, 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i23 = i1 + 96 | 0;
 if (!(HEAP32[i23 >> 2] | 0)) i1 = i26 + 24 | 0; else {
  i24 = i1 + 92 | 0;
  i12 = i1 + 108 | 0;
  i13 = i25 + 12 | 0;
  i11 = i25 + 12 | 0;
  i14 = i27 + 4 | 0;
  i15 = i25 + 8 | 0;
  i16 = i25 + 4 | 0;
  i17 = i25 + 16 | 0;
  i18 = i25 + 11 | 0;
  i19 = i27 + 4 | 0;
  i1 = i26 + 24 | 0;
  i20 = i29 + 4 | 0;
  i21 = i26 + 40 | 0;
  i22 = i29 + 4 | 0;
  i10 = 0;
  do {
   i6 = HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0;
   i4 = HEAP32[i24 >> 2] | 0;
   i7 = (i10 >>> 0) % (i4 >>> 0) | 0;
   i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (((i10 >>> 0) / (i4 >>> 0) | 0) << 2) >> 2] | 0;
   i3 = i4 + (i7 * 36 | 0) | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i5 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
   i5 = i2 ? HEAP32[i4 + (i7 * 36 | 0) + 4 >> 2] | 0 : i5 & 255;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i25 + 4 >> 2] = 0;
   HEAP32[i25 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i25);
    i2 = HEAP32[i11 >> 2] | 0;
    i32 = 20;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i18 >> 0] = i5;
    if (!i5) i2 = i25; else {
     i2 = i25;
     i32 = 22;
    }
   } else i32 = 20;
   if ((i32 | 0) == 20) {
    i9 = i5 + 16 & -16;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i14 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i25 >> 2] = i2;
    HEAP32[i15 >> 2] = i9 | -2147483648;
    HEAP32[i16 >> 2] = i5;
    i32 = 22;
   }
   if ((i32 | 0) == 22) {
    i32 = 0;
    _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   i9 = i4 + (i7 * 36 | 0) + 16 | 0;
   HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   i9 = mftCall_iiii(i6 | 0, i26 | 0, i25 | 0, 1) | 0;
   if ((HEAP8[i18 >> 0] | 0) < 0) {
    i8 = HEAP32[i25 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i19 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i27);
   }
   i10 = i10 + 1 | 0;
   i8 = HEAP32[i1 >> 2] | 0;
   i7 = i8 + (i30 * 20 | 0) + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i8 = HEAP32[i8 + (i30 * 20 | 0) + 8 >> 2] | 0;
   i2 = i8 - i3 >> 3;
   if (!i2) i2 = i3; else {
    i6 = i2;
    i2 = i3;
    while (1) {
     i34 = (i6 | 0) / 2 | 0;
     i5 = i3 + (i34 << 3) | 0;
     i4 = (HEAP32[i5 >> 2] | 0) < (i9 | 0);
     i5 = i5 + 8 | 0;
     i2 = i4 ? i5 : i2;
     i6 = i4 ? i6 + -1 - i34 | 0 : i34;
     if (!i6) break; else i3 = i4 ? i5 : i3;
    }
   }
   i3 = i2;
   if ((i2 | 0) == (i8 | 0)) i32 = 29; else if ((i9 | 0) < (HEAP32[i2 >> 2] | 0)) i32 = 29;
   if ((i32 | 0) == 29) {
    i32 = 0;
    HEAP32[i28 >> 2] = i3;
    HEAP32[i29 >> 2] = i9;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
    i2 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i7, i27, i29) | 0;
   }
   HEAP32[i2 + 4 >> 2] = i10;
   i8 = HEAP32[i21 >> 2] | 0;
   i7 = i8 + (i30 * 20 | 0) + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i8 = HEAP32[i8 + (i30 * 20 | 0) + 8 >> 2] | 0;
   i2 = i8 - i3 >> 3;
   if (!i2) i2 = i3; else {
    i6 = i2;
    i2 = i3;
    while (1) {
     i34 = (i6 | 0) / 2 | 0;
     i5 = i3 + (i34 << 3) | 0;
     i4 = (HEAP32[i5 >> 2] | 0) < (i10 | 0);
     i5 = i5 + 8 | 0;
     i2 = i4 ? i5 : i2;
     i6 = i4 ? i6 + -1 - i34 | 0 : i34;
     if (!i6) break; else i3 = i4 ? i5 : i3;
    }
   }
   i3 = i2;
   if ((i2 | 0) == (i8 | 0)) i32 = 34; else if ((i10 | 0) < (HEAP32[i2 >> 2] | 0)) i32 = 34;
   if ((i32 | 0) == 34) {
    i32 = 0;
    HEAP32[i28 >> 2] = i3;
    HEAP32[i29 >> 2] = i10;
    HEAP32[i22 >> 2] = 0;
    HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
    i2 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i7, i27, i29) | 0;
   }
   HEAP32[i2 + 4 >> 2] = i9;
  } while ((i10 | 0) != (HEAP32[i23 >> 2] | 0));
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i6 = i7 + (i30 * 20 | 0) + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i7 + (i30 * 20 | 0) + 8 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i34 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i34 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i30 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i34 | 0 : i34;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i32 = 8; else if ((HEAP32[i1 >> 2] | 0) > (i30 | 0)) i32 = 8;
 if ((i32 | 0) == 8) {
  HEAP32[i28 >> 2] = i2;
  HEAP32[i29 >> 2] = i30;
  HEAP32[i29 + 4 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
  i1 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i6, i27, i29) | 0;
 }
 HEAP32[i1 + 4 >> 2] = 0;
 i7 = HEAP32[i26 + 40 >> 2] | 0;
 i6 = i7 + (i30 * 20 | 0) + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i7 + (i30 * 20 | 0) + 8 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i34 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i34 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < 0;
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i34 | 0 : i34;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i32 = 13; else if ((HEAP32[i1 >> 2] | 0) > 0) i32 = 13;
 if ((i32 | 0) == 13) {
  HEAP32[i28 >> 2] = i2;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i29 + 4 >> 2] = 0;
  HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
  i1 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i6, i27, i29) | 0;
 }
 HEAP32[i1 + 4 >> 2] = i30;
 if (!i31) {
  STACKTOP = i33;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i33;
 return;
}

function runPostSets194() {
 HEAP32[gb + 166368 >> 2] = fb + 1789;
 HEAP32[gb + 166380 >> 2] = fb + 1870;
 HEAP32[gb + 166384 >> 2] = fb + 2512;
 HEAP32[gb + 166388 >> 2] = fb + 1790;
 HEAP32[gb + 166400 >> 2] = fb + 1870;
 HEAP32[gb + 166404 >> 2] = fb + 2513;
 HEAP32[gb + 166408 >> 2] = fb + 1791;
 HEAP32[gb + 166420 >> 2] = fb + 1870;
 HEAP32[gb + 166424 >> 2] = fb + 2514;
 HEAP32[gb + 166428 >> 2] = fb + 1792;
 HEAP32[gb + 166432 >> 2] = (HEAP32[gb + 166432 >> 2] | 0) + (gb + 834579 | 0);
 HEAP32[gb + 166440 >> 2] = (HEAP32[gb + 166440 >> 2] | 0) + (gb + 834588 | 0);
 HEAP32[gb + 166448 >> 2] = (HEAP32[gb + 166448 >> 2] | 0) + (gb + 834597 | 0);
 HEAP32[gb + 166456 >> 2] = (HEAP32[gb + 166456 >> 2] | 0) + (gb + 834604 | 0);
 HEAP32[gb + 166464 >> 2] = (HEAP32[gb + 166464 >> 2] | 0) + (gb + 834612 | 0);
 HEAP32[gb + 166472 >> 2] = (HEAP32[gb + 166472 >> 2] | 0) + (gb + 834619 | 0);
 HEAP32[gb + 166480 >> 2] = (HEAP32[gb + 166480 >> 2] | 0) + (gb + 834627 | 0);
 HEAP32[gb + 166488 >> 2] = (HEAP32[gb + 166488 >> 2] | 0) + (gb + 834634 | 0);
 HEAP32[gb + 166496 >> 2] = (HEAP32[gb + 166496 >> 2] | 0) + (gb + 834641 | 0);
 HEAP32[gb + 166504 >> 2] = (HEAP32[gb + 166504 >> 2] | 0) + (gb + 834650 | 0);
 HEAP32[gb + 166512 >> 2] = (HEAP32[gb + 166512 >> 2] | 0) + (gb + 834658 | 0);
 HEAP32[gb + 166520 >> 2] = (HEAP32[gb + 166520 >> 2] | 0) + (gb + 834665 | 0);
 HEAP32[gb + 166528 >> 2] = (HEAP32[gb + 166528 >> 2] | 0) + (gb + 834672 | 0);
 HEAP32[gb + 166536 >> 2] = (HEAP32[gb + 166536 >> 2] | 0) + (gb + 834682 | 0);
 HEAP32[gb + 166544 >> 2] = (HEAP32[gb + 166544 >> 2] | 0) + (gb + 834691 | 0);
 HEAP32[gb + 166552 >> 2] = (HEAP32[gb + 166552 >> 2] | 0) + (gb + 834703 | 0);
 HEAP32[gb + 166560 >> 2] = (HEAP32[gb + 166560 >> 2] | 0) + (gb + 834715 | 0);
 HEAP32[gb + 166568 >> 2] = (HEAP32[gb + 166568 >> 2] | 0) + (gb + 834726 | 0);
 HEAP32[gb + 166576 >> 2] = (HEAP32[gb + 166576 >> 2] | 0) + (gb + 834737 | 0);
 HEAP32[gb + 166584 >> 2] = (HEAP32[gb + 166584 >> 2] | 0) + (gb + 834750 | 0);
 HEAP32[gb + 166592 >> 2] = (HEAP32[gb + 166592 >> 2] | 0) + (gb + 834762 | 0);
 HEAP32[gb + 166600 >> 2] = (HEAP32[gb + 166600 >> 2] | 0) + (gb + 834774 | 0);
 HEAP32[gb + 166608 >> 2] = (HEAP32[gb + 166608 >> 2] | 0) + (gb + 834785 | 0);
 HEAP32[gb + 166616 >> 2] = (HEAP32[gb + 166616 >> 2] | 0) + (gb + 834798 | 0);
 HEAP32[gb + 166624 >> 2] = (HEAP32[gb + 166624 >> 2] | 0) + (gb + 834812 | 0);
 HEAP32[gb + 166632 >> 2] = (HEAP32[gb + 166632 >> 2] | 0) + (gb + 834825 | 0);
 HEAP32[gb + 166640 >> 2] = (HEAP32[gb + 166640 >> 2] | 0) + (gb + 834839 | 0);
 HEAP32[gb + 166648 >> 2] = (HEAP32[gb + 166648 >> 2] | 0) + (gb + 834852 | 0);
 HEAP32[gb + 166656 >> 2] = (HEAP32[gb + 166656 >> 2] | 0) + (gb + 834865 | 0);
 HEAP32[gb + 166664 >> 2] = (HEAP32[gb + 166664 >> 2] | 0) + (gb + 834880 | 0);
 HEAP32[gb + 166672 >> 2] = (HEAP32[gb + 166672 >> 2] | 0) + (gb + 834894 | 0);
 HEAP32[gb + 166680 >> 2] = (HEAP32[gb + 166680 >> 2] | 0) + (gb + 834907 | 0);
 HEAP32[gb + 166696 >> 2] = (HEAP32[gb + 166696 >> 2] | 0) + (gb + 834579 | 0);
 HEAP32[gb + 166704 >> 2] = (HEAP32[gb + 166704 >> 2] | 0) + (gb + 834588 | 0);
 HEAP32[gb + 166712 >> 2] = (HEAP32[gb + 166712 >> 2] | 0) + (gb + 834597 | 0);
 HEAP32[gb + 166720 >> 2] = (HEAP32[gb + 166720 >> 2] | 0) + (gb + 834604 | 0);
 HEAP32[gb + 166728 >> 2] = (HEAP32[gb + 166728 >> 2] | 0) + (gb + 834612 | 0);
 HEAP32[gb + 166736 >> 2] = (HEAP32[gb + 166736 >> 2] | 0) + (gb + 834619 | 0);
 HEAP32[gb + 166744 >> 2] = (HEAP32[gb + 166744 >> 2] | 0) + (gb + 834627 | 0);
 HEAP32[gb + 166752 >> 2] = (HEAP32[gb + 166752 >> 2] | 0) + (gb + 834634 | 0);
 HEAP32[gb + 166760 >> 2] = (HEAP32[gb + 166760 >> 2] | 0) + (gb + 834641 | 0);
 HEAP32[gb + 166768 >> 2] = (HEAP32[gb + 166768 >> 2] | 0) + (gb + 834650 | 0);
 HEAP32[gb + 166776 >> 2] = (HEAP32[gb + 166776 >> 2] | 0) + (gb + 834658 | 0);
 HEAP32[gb + 166784 >> 2] = (HEAP32[gb + 166784 >> 2] | 0) + (gb + 834665 | 0);
 HEAP32[gb + 166792 >> 2] = (HEAP32[gb + 166792 >> 2] | 0) + (gb + 834672 | 0);
 HEAP32[gb + 166800 >> 2] = (HEAP32[gb + 166800 >> 2] | 0) + (gb + 834682 | 0);
 HEAP32[gb + 166808 >> 2] = (HEAP32[gb + 166808 >> 2] | 0) + (gb + 834691 | 0);
 HEAP32[gb + 166816 >> 2] = (HEAP32[gb + 166816 >> 2] | 0) + (gb + 834703 | 0);
 HEAP32[gb + 166824 >> 2] = (HEAP32[gb + 166824 >> 2] | 0) + (gb + 834715 | 0);
 HEAP32[gb + 166832 >> 2] = (HEAP32[gb + 166832 >> 2] | 0) + (gb + 834726 | 0);
 HEAP32[gb + 166840 >> 2] = (HEAP32[gb + 166840 >> 2] | 0) + (gb + 834737 | 0);
 HEAP32[gb + 166848 >> 2] = (HEAP32[gb + 166848 >> 2] | 0) + (gb + 834750 | 0);
 HEAP32[gb + 166856 >> 2] = (HEAP32[gb + 166856 >> 2] | 0) + (gb + 834762 | 0);
 HEAP32[gb + 166864 >> 2] = (HEAP32[gb + 166864 >> 2] | 0) + (gb + 834774 | 0);
 HEAP32[gb + 166872 >> 2] = (HEAP32[gb + 166872 >> 2] | 0) + (gb + 834785 | 0);
 HEAP32[gb + 166880 >> 2] = (HEAP32[gb + 166880 >> 2] | 0) + (gb + 834798 | 0);
 HEAP32[gb + 166888 >> 2] = (HEAP32[gb + 166888 >> 2] | 0) + (gb + 834812 | 0);
 HEAP32[gb + 166896 >> 2] = (HEAP32[gb + 166896 >> 2] | 0) + (gb + 834825 | 0);
 HEAP32[gb + 166904 >> 2] = (HEAP32[gb + 166904 >> 2] | 0) + (gb + 834839 | 0);
 HEAP32[gb + 166912 >> 2] = (HEAP32[gb + 166912 >> 2] | 0) + (gb + 834852 | 0);
 HEAP32[gb + 166920 >> 2] = (HEAP32[gb + 166920 >> 2] | 0) + (gb + 834865 | 0);
 HEAP32[gb + 166928 >> 2] = (HEAP32[gb + 166928 >> 2] | 0) + (gb + 834880 | 0);
 HEAP32[gb + 166936 >> 2] = (HEAP32[gb + 166936 >> 2] | 0) + (gb + 834894 | 0);
 HEAP32[gb + 166944 >> 2] = (HEAP32[gb + 166944 >> 2] | 0) + (gb + 834907 | 0);
 HEAP32[gb + 166960 >> 2] = (HEAP32[gb + 166960 >> 2] | 0) + (gb + 834918 | 0);
 HEAP32[gb + 166968 >> 2] = (HEAP32[gb + 166968 >> 2] | 0) + (gb + 834928 | 0);
 HEAP32[gb + 166984 >> 2] = (HEAP32[gb + 166984 >> 2] | 0) + (gb + 834971 | 0);
 HEAP32[gb + 166992 >> 2] = (HEAP32[gb + 166992 >> 2] | 0) + (gb + 834981 | 0);
 HEAP32[gb + 167008 >> 2] = (HEAP32[gb + 167008 >> 2] | 0) + (gb + 835009 | 0);
 HEAP32[gb + 167016 >> 2] = (HEAP32[gb + 167016 >> 2] | 0) + (gb + 835027 | 0);
 HEAP32[gb + 167024 >> 2] = (HEAP32[gb + 167024 >> 2] | 0) + (gb + 835049 | 0);
 HEAP32[gb + 167032 >> 2] = (HEAP32[gb + 167032 >> 2] | 0) + (gb + 835070 | 0);
 HEAP32[gb + 167040 >> 2] = (HEAP32[gb + 167040 >> 2] | 0) + (gb + 835090 | 0);
 HEAP32[gb + 167048 >> 2] = (HEAP32[gb + 167048 >> 2] | 0) + (gb + 835114 | 0);
 HEAP32[gb + 167056 >> 2] = (HEAP32[gb + 167056 >> 2] | 0) + (gb + 835137 | 0);
 HEAP32[gb + 167080 >> 2] = fb + 1139;
 HEAP32[gb + 167084 >> 2] = fb + 1793;
 HEAP32[gb + 167088 >> 2] = fb + 124;
 HEAP32[gb + 167092 >> 2] = fb + 38;
 HEAP32[gb + 167096 >> 2] = fb + 261;
 HEAP32[gb + 167100 >> 2] = fb + 1794;
 HEAP32[gb + 167104 >> 2] = fb + 2515;
 HEAP32[gb + 167108 >> 2] = fb + 2516;
 HEAP32[gb + 167112 >> 2] = fb + 2517;
 HEAP32[gb + 167116 >> 2] = fb + 2518;
 HEAP32[gb + 167128 >> 2] = fb + 2519;
 HEAP32[gb + 167132 >> 2] = fb + 2520;
 HEAP32[gb + 167136 >> 2] = fb + 1140;
 HEAP32[gb + 167140 >> 2] = fb + 1141;
 HEAP32[gb + 167144 >> 2] = fb + 1142;
 runPostSets195();
}

function __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i1, i7, i11, i12, i13, i19) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 136 | 0;
 i18 = i22 + 64 | 0;
 i3 = i22 + 40 | 0;
 i6 = i22 + 16 | 0;
 i23 = i22 + 56 | 0;
 i20 = i22 + 124 | 0;
 i2 = i22 + 32 | 0;
 i9 = i22 + 8 | 0;
 i8 = i22;
 i14 = i22 + 112 | 0;
 i15 = i22 + 100 | 0;
 i16 = i22 + 88 | 0;
 i17 = i22 + 76 | 0;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 if ((__Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i21) | 0) != (i12 | 0)) {
  i18 = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  i23 = i2;
  HEAP32[i23 >> 2] = i4;
  HEAP32[i23 + 4 >> 2] = i5;
  HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i23 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i21) | 0;
  HEAP32[i6 >> 2] = i18;
  HEAP32[i6 + 4 >> 2] = i23;
  __Z6FormatPKcz(i20, gb + 456396 | 0, i6);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 456420 | 0, 29);
  i23 = (HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
  HEAP32[i3 >> 2] = (HEAP8[i20 + 11 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20;
  HEAP32[i3 + 4 >> 2] = i12;
  HEAP32[i3 + 8 >> 2] = i23;
  __Z6FormatPKcz(i6, gb + 456450 | 0, i3);
  if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 455851 | 0, 90, 2052, i1, HEAP32[i19 + 4 >> 2] | 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  i23 = 0;
  STACKTOP = i22;
  return i23 | 0;
 }
 if (!i12) {
  i23 = 1;
  STACKTOP = i22;
  return i23 | 0;
 } else i1 = 0;
 while (1) {
  i2 = i9;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i21 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  i2 = __Z25scripting_class_from_typePK10Il2CppType(__Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi(i21, i1) | 0) | 0;
  if ((i2 | 0) != (HEAP32[(__Z19GetScriptingManagerv() | 0) + 56 >> 2] | 0)) if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(HEAP32[i11 + (i1 << 2) >> 2] | 0, i2) | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i12 >>> 0) {
   i1 = 1;
   i10 = 14;
   break;
  }
 }
 if ((i10 | 0) == 14) {
  STACKTOP = i22;
  return i1 | 0;
 }
 i1 = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i2 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i21) | 0;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i18 + 4 >> 2] = i2;
 __Z6FormatPKcz(i20, gb + 456501 | 0, i18);
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, gb + 456420 | 0, 29);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i2 = i12 + -1 | 0;
 i1 = 0;
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i18, __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i11 + (i1 << 2) >> 2] | 0) | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i18, i1 >>> 0 < i2 >>> 0 ? gb + 456569 | 0 : gb + 1087625 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i12 = HEAP8[i20 + 11 >> 0] | 0;
 i23 = i12 << 24 >> 24 < 0;
 i12 = i23 ? HEAP32[i20 + 4 >> 2] | 0 : i12 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i17, i23 ? HEAP32[i20 >> 2] | 0 : i20, i12, i12 + 44 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i17, gb + 456524 | 0, 44) | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i12 = HEAP8[i17 + 11 >> 0] | 0;
 i23 = i12 << 24 >> 24 < 0;
 i12 = i23 ? HEAP32[i17 + 4 >> 2] | 0 : i12 & 255;
 i10 = i18 + 11 | 0;
 i11 = HEAP8[i10 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i18 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i23 ? HEAP32[i17 >> 2] | 0 : i17, i12, i11 + i12 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, i11) | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i11 = HEAP8[i16 + 11 >> 0] | 0;
 i10 = i11 << 24 >> 24 < 0;
 i11 = i10 ? HEAP32[i16 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i15, i10 ? HEAP32[i16 >> 2] | 0 : i16, i11, i11 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, gb + 1074320 | 0, 1) | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i11 = HEAP8[i15 + 11 >> 0] | 0;
 i10 = i11 << 24 >> 24 < 0;
 i11 = i10 ? HEAP32[i15 + 4 >> 2] | 0 : i11 & 255;
 i12 = i21 + 11 | 0;
 i23 = HEAP8[i12 >> 0] | 0;
 i23 = i23 << 24 >> 24 < 0 ? HEAP32[i21 + 4 >> 2] | 0 : i23 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i14, i10 ? HEAP32[i15 >> 2] | 0 : i15, i11, i23 + i11 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i14, (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, i23) | 0;
 if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 455851 | 0, 119, 2052, i1, HEAP32[i19 + 4 >> 2] | 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 i23 = 0;
 STACKTOP = i22;
 return i23 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl14GetOSFontNamesERNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 44 | 0;
 i22 = i26 + 16 | 0;
 i23 = i26;
 i24 = i26 + 32 | 0;
 i1 = HEAP32[gb + 1467884 >> 2] | 0;
 if (!i1) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63392 | 0, 16, gb + 945383 | 0, 95) | 0;
  i2 = i4 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[gb + 1467884 >> 2] = i4;
  HEAP32[i21 >> 2] = 0;
  i4 = i21 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i21);
  i2 = HEAP32[i4 >> 2] | 0;
  i19 = HEAP32[i21 >> 2] | 0;
  i1 = i19;
  if ((i2 | 0) != (i19 | 0)) {
   i3 = 0;
   do {
    __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + (i3 * 12 | 0) | 0);
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i19 = HEAP32[i21 >> 2] | 0;
    i1 = i19;
   } while (i3 >>> 0 < ((i2 - i19 | 0) / 12 | 0) >>> 0);
  }
  if (i1 | 0) {
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i19 = i2 + -12 | 0;
     HEAP32[i4 >> 2] = i19;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
     i2 = HEAP32[i4 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i21 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[gb + 1467884 >> 2] | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i1 + 4 | 0)) {
  STACKTOP = i26;
  return;
 }
 i7 = i23 + 11 | 0;
 i8 = i23 + 4 | 0;
 i9 = i22 + 12 | 0;
 i6 = i22 + 12 | 0;
 i10 = i21 + 4 | 0;
 i11 = i22 + 8 | 0;
 i12 = i22 + 4 | 0;
 i13 = i20 + 4 | 0;
 i14 = i20 + 8 | 0;
 i15 = i22 + 11 | 0;
 i16 = i21 + 4 | 0;
 i17 = i21 + 4 | 0;
 i18 = i24 + 11 | 0;
 i19 = i24 + 4 | 0;
 while (1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i24, i2 + 16 | 0);
  switch (HEAP32[i2 + 28 >> 2] | 0) {
  case 0:
   {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i23, i24);
    break;
   }
  case 2:
   {
    HEAP32[i23 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 0;
    HEAP32[i23 + 8 >> 2] = 0;
    i5 = HEAP8[i18 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i23, i4 ? HEAP32[i24 >> 2] | 0 : i24, i5, i5 + 7 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i23, gb + 945475 | 0, 7) | 0;
    break;
   }
  case 1:
   {
    HEAP32[i23 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 0;
    HEAP32[i23 + 8 >> 2] = 0;
    i5 = HEAP8[i18 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i23, i4 ? HEAP32[i24 >> 2] | 0 : i24, i5, i5 + 5 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i23, gb + 945469 | 0, 5) | 0;
    break;
   }
  case 3:
   {
    HEAP32[i23 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 0;
    HEAP32[i23 + 8 >> 2] = 0;
    i5 = HEAP8[i18 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i19 >> 2] | 0 : i5 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i23, i4 ? HEAP32[i24 >> 2] | 0 : i24, i5, i5 + 12 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i23, gb + 1008042 | 0, 12) | 0;
    break;
   }
  default:
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i23, i24);
  }
  i4 = HEAP8[i7 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i23 >> 2] | 0 : i23;
  i4 = i1 ? HEAP32[i8 >> 2] | 0 : i4 & 255;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
   i1 = HEAP32[i6 >> 2] | 0;
   i25 = 22;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i15 >> 0] = i4;
   if (!i4) i1 = i22; else {
    i1 = i22;
    i25 = 24;
   }
  } else i25 = 22;
  if ((i25 | 0) == 22) {
   i5 = i4 + 16 & -16;
   HEAP32[i21 >> 2] = 66;
   HEAP32[i10 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i11 >> 2] = i5 | -2147483648;
   HEAP32[i12 >> 2] = i4;
   i25 = 24;
  }
  if ((i25 | 0) == 24) {
   i25 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i14 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i20, i22); else {
   i5 = HEAP8[i15 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i22 >> 2] | 0 : i22;
   i5 = i3 ? HEAP32[i12 >> 2] | 0 : i5 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i3 = HEAP32[i1 + 12 >> 2] | 0;
    i25 = 29;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (i5) i25 = 31;
   } else i25 = 29;
   if ((i25 | 0) == 29) {
    i27 = i5 + 16 & -16;
    HEAP32[i21 >> 2] = 66;
    HEAP32[i17 >> 2] = i3;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i27, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 8 >> 2] = i27 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i5;
    i1 = i3;
    i25 = 31;
   }
   if ((i25 | 0) == 31) {
    i25 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 16;
  }
  if ((HEAP8[i15 >> 0] | 0) < 0) {
   i27 = HEAP32[i22 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i21 >> 2] = 66;
   HEAP32[i16 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i27, i21);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == ((HEAP32[gb + 1467884 >> 2] | 0) + 4 | 0)) break; else i2 = i1;
 }
 STACKTOP = i26;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj(i21, i24, i15, i16, i17, i2, i1, i18, i22) {
 i21 = i21 | 0;
 i24 = i24 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0, i23 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25 + 64 | 0;
 i13 = i25 + 40 | 0;
 i5 = i25 + 12 | 0;
 i6 = i25;
 i14 = i25 + 24 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 if (!i23) {
  HEAP32[i21 + 464 >> 2] = 1;
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i7 = i17 << 1;
 i7 = (HEAP32[(HEAP32[i16 + 4 >> 2] | 0) + (i7 >> 5 << 2) >> 2] | 0) >>> (i7 & 30) & 3;
 if ((i7 | 0) == 3) {
  i2 = (HEAP32[(HEAP32[i21 + 132 >> 2] | 0) + (i15 << 2) >> 2] | 0) + i17 | 0;
  i3 = i24 + 8 | 0;
  i20 = HEAP32[i23 + 8 >> 2] | 0;
  HEAP32[i20 + (HEAP32[i3 >> 2] << 3) >> 2] = i2 << 2 | 2;
  i19 = i23 + 36 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i17 = HEAP32[i19 >> 2] | 0;
  HEAP32[i19 >> 2] = (i3 | 0) >= (i17 | 0) ? i3 : i17;
  HEAP32[i20 + (i3 << 3) + 4 >> 2] = i2;
  i21 = HEAP32[i21 + 68 >> 2] | 0;
  HEAP32[i21 + (i2 << 5) + 12 >> 2] = i1;
  HEAP32[i21 + (i2 << 5) + 16 >> 2] = i18;
  HEAP32[i21 + (i2 << 5) + 20 >> 2] = i22 & i18;
  i2 = i24 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
  if ((i3 | 0) != ((HEAP32[i1 + 8 >> 2] | 0) + 1 | 0)) {
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
  i4 = __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(i23, i3) | 0;
  i3 = HEAP32[i24 >> 2] | 0;
  i1 = (HEAP32[i3 + 8 >> 2] | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] << 3) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  switch (i2 & 3) {
  case 1:
   {
    HEAP32[i1 >> 2] = i2 & 15 | i4 << 4;
    i24 = 1;
    STACKTOP = i25;
    return i24 | 0;
   }
  case 0:
   {
    i24 = (HEAP32[i3 + 24 >> 2] | 0) + (i2 >>> 2 << 3) | 0;
    HEAP32[i24 >> 2] = HEAP32[i24 >> 2] & 3 | i4 << 2;
    i24 = 1;
    STACKTOP = i25;
    return i24 | 0;
   }
  default:
   {
    i24 = 1;
    STACKTOP = i25;
    return i24 | 0;
   }
  }
 }
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i19 >> 2] = i8;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i19 + 4 >> 2] = i9;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i19 + 8 >> 2] = i10;
 i11 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i19 + 12 >> 2] = i11;
 i12 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i19 + 16 >> 2] = i12;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i19 + 20 >> 2] = i2;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i13 + 4 >> 2] = i9;
 HEAP32[i13 + 8 >> 2] = i10;
 HEAP32[i13 + 12 >> 2] = i11;
 HEAP32[i13 + 16 >> 2] = i12;
 HEAP32[i13 + 20 >> 2] = i2;
 i4 = i7 << 1;
 i3 = ~(1 << (i4 | 1)) & i18;
 i4 = ~(1 << i4) & i18;
 if ((HEAP32[i16 + 24 >> 2] | 0) > (i17 | 0)) {
  f26 = Math_fround(HEAPF32[(HEAP32[i16 + 12 >> 2] | 0) + (HEAP32[i16 + 16 >> 2] | 0) + (i17 << 2) >> 2]);
  HEAPF32[i19 + 12 + (i7 << 2) >> 2] = f26;
  HEAPF32[i13 + (i7 << 2) >> 2] = f26;
  if (__ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor7kdSplitEif(i24, i7, f26) | 0) i20 = 13; else {
   HEAP32[i21 + 464 >> 2] = 1;
   i1 = 0;
  }
 } else {
  f26 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28) * Math_fround(.5));
  f27 = Math_fround(Math_fround(f30 + f27) * Math_fround(.5));
  f26 = Math_fround(Math_fround(f29 + f26) * Math_fround(.5));
  HEAPF32[i5 >> 2] = f28;
  HEAPF32[i5 + 4 >> 2] = f27;
  HEAPF32[i5 + 8 >> 2] = f26;
  HEAP32[i19 + 12 + (i7 << 2) >> 2] = HEAP32[i5 + (i7 << 2) >> 2];
  HEAPF32[i6 >> 2] = f28;
  HEAPF32[i6 + 4 >> 2] = f27;
  HEAPF32[i6 + 8 >> 2] = f26;
  HEAP32[i13 + (i7 << 2) >> 2] = HEAP32[i6 + (i7 << 2) >> 2];
  i12 = i24 + 8 | 0;
  HEAP32[(HEAP32[i23 + 8 >> 2] | 0) + (HEAP32[i12 >> 2] << 3) >> 2] = i7 << 2 | 1;
  i20 = i23 + 36 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i23 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = (i12 | 0) >= (i23 | 0) ? i12 : i23;
  i20 = 13;
 }
 if ((i20 | 0) == 13) {
  i23 = HEAP32[(HEAP32[i21 + 56 >> 2] | 0) + (i15 << 2) >> 2] | 0;
  if (!(HEAP32[i23 + (HEAP32[i23 + 160 >> 2] | 0) + (i17 << 2) >> 2] | 0)) HEAP32[(HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0) + (HEAP32[i24 + 8 >> 2] << 3) + 4 >> 2] = -1; else {
   i23 = (HEAP32[(HEAP32[i21 + 132 >> 2] | 0) + (i15 << 2) >> 2] | 0) + i17 | 0;
   HEAP32[(HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0) + (HEAP32[i24 + 8 >> 2] << 3) + 4 >> 2] = i23;
   i20 = HEAP32[i21 + 68 >> 2] | 0;
   HEAP32[i20 + (i23 << 5) + 12 >> 2] = i1;
   HEAP32[i20 + (i23 << 5) + 16 >> 2] = i18;
   HEAP32[i20 + (i23 << 5) + 20 >> 2] = i22 & i18;
   i1 = i23;
  }
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor13constructLeftERS3_(i24, i14);
  L30 : do if (__ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj(i21, i14, i15, i16, ((__ZNK5Umbra6KDTree4rankEi(i16, i17) | 0) << 1) + -1 | 0, i19, i1, i3, i22) | 0) {
   __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor14constructRightERS3_(i24, i14);
   if (__ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj(i21, i14, i15, i16, (__ZNK5Umbra6KDTree4rankEi(i16, i17) | 0) << 1, i13, i1, i4, i22) | 0) {
    i4 = i24 + 4 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 1; else {
     i2 = HEAP32[i24 + 8 >> 2] | 0;
     if ((i2 | 0) == ((HEAP32[i1 + 8 >> 2] | 0) + 1 | 0)) {
      i5 = __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(HEAP32[i24 >> 2] | 0, i2) | 0;
      i3 = HEAP32[i24 >> 2] | 0;
      i1 = (HEAP32[i3 + 8 >> 2] | 0) + (HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] << 3) | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      switch (i2 & 3) {
      case 1:
       {
        HEAP32[i1 >> 2] = i2 & 15 | i5 << 4;
        i1 = 1;
        break L30;
       }
      case 0:
       {
        i1 = (HEAP32[i3 + 24 >> 2] | 0) + (i2 >>> 2 << 3) | 0;
        HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 3 | i5 << 2;
        i1 = 1;
        break L30;
       }
      default:
       {
        i1 = 1;
        break L30;
       }
      }
     } else i1 = 1;
    }
   } else i1 = 0;
  } else i1 = 0; while (0);
 }
 i24 = i1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 16 | 0;
 i6 = i3 + 12 | 0;
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905792 | 0, gb + 905830 | 0, i1, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905809 | 0, gb + 905830 | 0, i1 + 4 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905840 | 0, gb + 905830 | 0, i1 + 8 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i2 + 4 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 16;
 HEAP32[i8 + 4 >> 2] = i1 + 12;
 HEAP32[i8 + 8 >> 2] = i11;
 i11 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905854 | 0, i11, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905876 | 0, gb + 905830 | 0, i1 + 20 | 0, 0);
 __ZN7mecanim5human5HumanC2Ev(i7);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905884 | 0, i7, 0);
 __ZN7mecanim5human5Human8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 28;
 HEAP32[i8 + 4 >> 2] = i1 + 24;
 HEAP32[i8 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905890 | 0, i11, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 36;
 HEAP32[i8 + 4 >> 2] = i1 + 32;
 HEAP32[i8 + 8 >> 2] = i12;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905916 | 0, i11, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905949 | 0, i10, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905971 | 0, gb + 905989 | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i10, gb + 1085944 | 0, 0);
 i10 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i10, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905995 | 0, gb + 905830 | 0, i1 + 84 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906016 | 0, gb + 905830 | 0, i1 + 88 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 96;
 HEAP32[i8 + 4 >> 2] = i1 + 92;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906041 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE19__add_back_capacityEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17;
 i1 = i16 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 77) {
  HEAP32[i1 >> 2] = i2 + -78;
  i10 = i16 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = i16 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i1 = i15;
  i5 = i7;
  do if ((i7 | 0) == (i15 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i9 >>> 0 > i2 >>> 0) {
    i1 = i9;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i9 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i9; else {
     _memmove(i4 | 0, i9 | 0, i1 | 0) | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i10 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i15 = __Znwj(i6 << 2) | 0;
   i4 = i15;
   i1 = i15 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i15 + (i6 << 2) | 0;
   if ((i9 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i9;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i11 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
 i15 = i16 + 8 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i9 = i8 - i10 | 0;
 i11 = i9 >> 2;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i1 = i4 - i6 | 0;
 i5 = i8;
 i12 = i10;
 i7 = i4;
 i2 = i6;
 if (i11 >>> 0 >= i1 >> 2 >>> 0) {
  i10 = i1 >> 1;
  i10 = (i10 | 0) == 0 ? 1 : i10;
  i2 = __Znwj(i10 << 2) | 0;
  i3 = i2;
  i4 = i2 + (i11 << 2) | 0;
  i1 = i2 + (i10 << 2) | 0;
  i6 = __Znwj(4056) | 0;
  do if ((i11 | 0) == (i10 | 0)) if ((i9 | 0) > 0) {
   i7 = i3;
   i3 = i4 + (((i11 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i12;
   break;
  } else {
   i1 = i9 >> 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   i5 = __Znwj(i1 << 2) | 0;
   __ZdlPv(i2);
   i7 = i5;
   i3 = i5 + (i1 >>> 2 << 2) | 0;
   i1 = i5 + (i1 << 2) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i7 = i3;
   i3 = i4;
   i2 = i12;
  } while (0);
  i4 = i3;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  if ((i5 | 0) == (i2 | 0)) i5 = i7; else while (1) {
   i5 = i5 + -4 | 0;
   i2 = i4;
   do if ((i2 | 0) == (i7 | 0)) {
    i9 = i3;
    if (i9 >>> 0 < i1 >>> 0) {
     i6 = i9 + ((((i1 - i3 >> 2) + 1 | 0) / 2 | 0) << 2) | 0;
     i2 = i3 - i4 | 0;
     i12 = i2 >> 2;
     i3 = i6 + (0 - i12 << 2) | 0;
     if (!i12) i2 = i6; else {
      _memmove(i3 | 0, i4 | 0, i2 | 0) | 0;
      i2 = i3;
     }
     i4 = i2;
     i3 = i6;
     break;
    }
    i1 = i1 - i7 >> 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    i12 = __Znwj(i1 << 2) | 0;
    i7 = i12;
    i10 = i12 + ((i1 + 3 | 0) >>> 2 << 2) | 0;
    i8 = i10;
    i1 = i12 + (i1 << 2) | 0;
    if ((i2 | 0) == (i9 | 0)) i3 = i8; else {
     i6 = i10;
     i3 = i8;
     do {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      i6 = i3 + 4 | 0;
      i3 = i6;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i9 | 0));
    }
    if (!i4) {
     i4 = i8;
     i2 = i10;
    } else {
     __ZdlPv(i4);
     i4 = i8;
     i2 = i10;
    }
   } while (0);
   HEAP32[i2 + -4 >> 2] = HEAP32[i5 >> 2];
   i2 = i4 + -4 | 0;
   if ((i5 | 0) == (HEAP32[i14 >> 2] | 0)) {
    i5 = i7;
    i4 = i2;
    break;
   } else i4 = i2;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i1;
  if (!i2) {
   STACKTOP = i17;
   return;
  }
  __ZdlPv(i2);
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) == (i8 | 0)) {
  HEAP32[i3 >> 2] = __Znwj(4056) | 0;
  __ZNSt3__214__split_bufferIP10InputEventNS_9allocatorIS2_EEE10push_frontERKS2_(i16, i3);
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 4 | 0;
  HEAP32[i14 >> 2] = i8;
  i7 = HEAP32[i15 >> 2] | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = i12;
  i5 = i7;
  do if ((i7 | 0) == (i12 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i8 >>> 0 > i2 >>> 0) {
    i1 = i8;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i8 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i8; else {
     _memmove(i4 | 0, i8 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i12 = __Znwj(i6 << 2) | 0;
   i4 = i12;
   i1 = i12 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i12 + (i6 << 2) | 0;
   if ((i8 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i8;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 } else {
  i9 = __Znwj(4056) | 0;
  i1 = i8;
  do if ((i5 | 0) == (i7 | 0)) {
   if (i12 >>> 0 > i2 >>> 0) {
    i3 = ((i10 - i6 >> 2) + 1 | 0) / -2 | 0;
    i4 = i12 + (i3 << 2) | 0;
    i1 = i8 - i10 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i12; else {
     _memmove(i4 | 0, i10 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i4 = i4 - i6 >> 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i11 = __Znwj(i4 << 2) | 0;
   i6 = i11;
   i1 = i11 + (i4 >>> 2 << 2) | 0;
   i7 = i1;
   i4 = i11 + (i4 << 2) | 0;
   if ((i12 | 0) == (i5 | 0)) i1 = i7; else {
    i3 = i1;
    i1 = i7;
    i2 = i12;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i5 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i6;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i4;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
}

function __ZN13AnimationClipD2Ev(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 HEAP32[i12 >> 2] = gb + 176240 + 8;
 HEAP32[i12 + 216 >> 2] = 0;
 HEAP32[i12 + 220 >> 2] = 0;
 i11 = i12 + 64 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) do {
  i10 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i11 >> 2] = 0;
 i10 = i12 + 68 | 0;
 HEAP32[i10 >> 2] = 0;
 i9 = i12 + 72 | 0;
 HEAP32[i9 >> 2] = 0;
 i1 = i12 + 224 | 0;
 i4 = i12 + 240 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 228 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i12 + 236 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i12 + 244 | 0;
 i1 = i12 + 260 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  i2 = i12 + 248 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2);
  HEAP32[i3 >> 2] = 0;
 } else i2 = i12 + 248 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i12 + 256 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i12 + 224 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 HEAP32[i3 >> 2] = 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 228 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i4 = i12 + 196 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i12 + 200 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i8 + 4 | 0;
   i7 = i8 + 4 | 0;
   do {
    HEAP32[i5 >> 2] = i2 + -64;
    i3 = i2 + -44 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i14 = HEAP32[i2 + -32 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
    }
    i3 = i2 + -60 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i2 + -48 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i7 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i14 = HEAP32[i12 + 208 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i12 + 180 | 0);
 __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i12 + 164 | 0);
 i5 = i12 + 148 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i12 + 152 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i8 + 4 | 0;
   do {
    i3 = i2 + -172 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -160 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i7 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i14 = HEAP32[i12 + 160 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 i5 = i12 + 132 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i12 + 136 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i8 + 4 | 0;
   do {
    i3 = i2 + -172 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -160 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i7 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i14 = HEAP32[i12 + 144 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 i5 = i12 + 116 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i12 + 120 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i8 + 4 | 0;
   do {
    i3 = i2 + -172 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -160 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i7 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i14 = HEAP32[i12 + 128 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 i5 = i12 + 100 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i12 + 104 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i8 + 4 | 0;
   do {
    i3 = i2 + -204 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -192 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i7 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i14 = HEAP32[i12 + 112 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 HEAP32[i12 + 84 >> 2] = 0;
 HEAP32[i12 + 80 >> 2] = 0;
 HEAP32[i12 + 56 >> 2] = gb + 176376 + 8;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) do {
  i14 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i12 >> 2] = gb + 176392 + 8;
 i1 = i12 + 36 | 0;
 if ((HEAP32[i12 + 52 >> 2] | 0) <= -1) {
  HEAP32[i12 >> 2] = gb + 32336 + 8;
  i14 = i12 + 28 | 0;
  __ZN14ConstantStringD2Ev(i14);
  HEAP32[i12 >> 2] = gb + 26392 + 8;
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i12 + 40 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i12 >> 2] = gb + 32336 + 8;
 i14 = i12 + 28 | 0;
 __ZN14ConstantStringD2Ev(i14);
 HEAP32[i12 >> 2] = gb + 26392 + 8;
 STACKTOP = i13;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i17, i10, i1) {
 i17 = i17 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i7 = i16 + 8 | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) {
  i12 = i17 + 8 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i10 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i10 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i14 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i8 = HEAP32[gb + 36996 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i12 = i17 + 84 | 0;
  HEAP32[HEAP32[i12 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i11) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i3 = HEAP32[i19 + 4 >> 2] | 0;
     i10 = i2 + 24 | 0;
     HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i10 + 4 >> 2] = i3;
     i10 = HEAP32[i12 >> 2] | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i10 = HEAP32[i5 >> 2] | 0;
     i2 = i10 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i10 >>> 0) i18 = 17; else if ((i2 + 8 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i18 = 17; else {
      HEAP8[tempDoublePtr >> 0] = HEAP8[i2 >> 0];
      HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i2 + 1 >> 0];
      HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i2 + 2 >> 0];
      HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i2 + 3 >> 0];
      HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i2 + 4 >> 0];
      HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i2 + 5 >> 0];
      HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i2 + 6 >> 0];
      HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i2 + 7 >> 0];
      HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
      HEAP8[i1 >> 0] = HEAP8[tempDoublePtr >> 0];
      HEAP8[i1 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
      HEAP8[i1 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
      HEAP8[i1 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
      HEAP8[i1 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
      HEAP8[i1 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
      HEAP8[i1 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
      HEAP8[i1 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 8;
     }
     if ((i18 | 0) == 17) {
      i18 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 8);
     }
     if (HEAP32[i17 >> 2] & 512 | 0) {
      i10 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
      i19 = i1 + 4 | 0;
      HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i10;
     }
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i14 | 0)) break L20;
     i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i18 = 30; else if ((i2 + 8 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) i18 = 30; else {
       HEAP8[tempDoublePtr >> 0] = HEAP8[i2 >> 0];
       HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i2 + 1 >> 0];
       HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i2 + 2 >> 0];
       HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i2 + 3 >> 0];
       HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i2 + 4 >> 0];
       HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i2 + 5 >> 0];
       HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i2 + 6 >> 0];
       HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i2 + 7 >> 0];
       HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
       HEAP8[i1 >> 0] = HEAP8[tempDoublePtr >> 0];
       HEAP8[i1 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
       HEAP8[i1 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
       HEAP8[i1 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
       HEAP8[i1 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
       HEAP8[i1 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
       HEAP8[i1 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
       HEAP8[i1 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 8;
      }
      if ((i18 | 0) == 30) {
       i18 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 8);
      }
      if (HEAP32[i17 >> 2] & 512 | 0) {
       i12 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
       i19 = i1 + 4 | 0;
       HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
       HEAP32[i19 >> 2] = i12;
      }
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function _IsMacResource(i17, i16, i1, i4, i20) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22 + 16 | 0;
 i2 = i22 + 12 | 0;
 i3 = i22 + 8 | 0;
 i21 = i22 + 4 | 0;
 i5 = i22;
 i19 = HEAP32[i17 >> 2] | 0;
 i1 = _UNITY_FT_Raccess_Get_HeaderInfo(i17, i16, i1, i2, i3) | 0;
 if (i1 | 0) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (_UNITY_FT_Raccess_Get_DataOffsets(i17, i16, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, 1347375956, 1, i21, i5) | 0) {
  i1 = _UNITY_FT_Raccess_Get_DataOffsets(i17, i16, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, 1936092788, 0, i21, i5) | 0;
  if (i1 | 0) {
   i21 = i1;
   STACKTOP = i22;
   return i21 | 0;
  }
  i15 = HEAP32[i5 >> 2] | 0;
  i1 = (i4 | 0) % (i15 | 0) | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 0 : i1;
  L9 : do if ((i1 | 0) < (i15 | 0)) {
   i2 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i15 = _UNITY_FT_Stream_Seek(i16, i2) | 0;
   HEAP32[i18 >> 2] = i15;
   do if (!i15) {
    i4 = _UNITY_FT_Stream_ReadULong(i16, i18) | 0;
    if (!(HEAP32[i18 >> 2] | 0)) {
     if ((i4 | 0) == -1) {
      i1 = 1;
      break L9;
     }
     if (i4 >>> 0 > 16777215) {
      i1 = 9;
      break L9;
     }
     i15 = _open_face_PS_from_sfnt_stream(i17, i16, i1, 0, 0, i20) | 0;
     HEAP32[i18 >> 2] = i15;
     if (i15 | 0) if (!(_UNITY_FT_Stream_Seek(i16, i2 + 4 | 0) | 0)) {
      i2 = _UNITY_ft_mem_alloc(i3, i4, i18) | 0;
      i1 = HEAP32[i18 >> 2] | 0;
      if (i1 | 0) break L9;
      i16 = _UNITY_FT_Stream_Read(i16, i2, i4) | 0;
      HEAP32[i18 >> 2] = i16;
      if (i16 | 0) {
       _UNITY_ft_mem_free(i3, i2);
       break;
      }
      if ((i4 | 0) > 4) {
       i1 = (_memcmp(i2, gb + 945616 | 0, 4) | 0) != 0;
       i1 = i1 ? gb + 1007021 | 0 : gb + 1006900 | 0;
      } else i1 = gb + 1007021 | 0;
      HEAP32[i18 >> 2] = _open_face_from_buffer(i17, i2, i4, 0, i1, i20) | 0;
     }
    }
   } while (0);
   i1 = HEAP32[i18 >> 2] | 0;
  } else i1 = 1; while (0);
  _UNITY_ft_mem_free(i19, HEAP32[i21 >> 2] | 0);
  HEAP32[i21 >> 2] = 0;
  if (i1 | 0) {
   i21 = i1;
   STACKTOP = i22;
   return i21 | 0;
  }
  HEAP32[HEAP32[i20 >> 2] >> 2] = HEAP32[i5 >> 2];
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i14 = HEAP32[i21 >> 2] | 0;
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[i18 >> 2] = 1;
 i15 = HEAP32[i17 >> 2] | 0;
 L32 : do switch (i4 | 0) {
 case 0:
 case -1:
  {
   i4 = (i13 | 0) > 0;
   if (i4) {
    i10 = 0;
    i3 = 0;
    do {
     i1 = _UNITY_FT_Stream_Seek(i16, HEAP32[i14 + (i3 << 2) >> 2] | 0) | 0;
     HEAP32[i18 >> 2] = i1;
     if (i1 | 0) break L32;
     i2 = _UNITY_FT_Stream_ReadULong(i16, i18) | 0;
     i1 = HEAP32[i18 >> 2] | 0;
     if (i1 | 0) break L32;
     if (i2 >>> 0 > 16777215) {
      i6 = 9;
      break;
     }
     i1 = i10 + 6 | 0;
     if ((16777215 - i2 | 0) >>> 0 < i1 >>> 0) {
      i6 = 9;
      break;
     }
     i10 = i1 + i2 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i13 | 0));
    if ((i6 | 0) == 9) {
     HEAP32[i18 >> 2] = 9;
     i1 = 9;
     break L32;
    }
    i11 = i10 + 2 | 0;
    if (i11 >>> 0 >= 6) {
     i12 = _UNITY_ft_mem_alloc(i15, i11, i18) | 0;
     i1 = HEAP32[i18 >> 2] | 0;
     if (i1 | 0) break L32;
     HEAP8[i12 >> 0] = -128;
     HEAP8[i12 + 1 >> 0] = 1;
     i9 = i12 + 2 | 0;
     HEAP8[i9 >> 0] = 0;
     HEAP8[i9 + 1 >> 0] = 0;
     HEAP8[i9 + 2 >> 0] = 0;
     HEAP8[i9 + 3 >> 0] = 0;
     L46 : do if (i4) {
      i4 = 2;
      i1 = 6;
      i3 = 0;
      i8 = 1;
      i9 = 0;
      while (1) {
       i7 = _UNITY_FT_Stream_Seek(i16, HEAP32[i14 + (i9 << 2) >> 2] | 0) | 0;
       HEAP32[i18 >> 2] = i7;
       if (i7 | 0) {
        i6 = 35;
        break L46;
       }
       i5 = _UNITY_FT_Stream_ReadULong(i16, i18) | 0;
       if (HEAP32[i18 >> 2] | 0) {
        i6 = 35;
        break L46;
       }
       if ((i5 | 0) < 0) break;
       i2 = _UNITY_FT_Stream_ReadUShort(i16, i18) | 0;
       if (HEAP32[i18 >> 2] | 0) {
        i6 = 35;
        break L46;
       }
       HEAP32[i18 >> 2] = 10;
       i6 = (i2 & 65535) >>> 8;
       if (!i6) i2 = i8; else {
        i7 = i5 >>> 0 > 2 ? i5 + -2 | 0 : 0;
        if ((i6 | 0) == (i8 | 0)) {
         i3 = i7 + i3 | 0;
         i2 = i8;
        } else {
         i2 = i4 + 3 | 0;
         if (i2 >>> 0 > i11 >>> 0) {
          i6 = 34;
          break L46;
         }
         HEAP8[i12 + i4 >> 0] = i3;
         HEAP8[i12 + (i4 + 1) >> 0] = i3 >>> 8;
         HEAP8[i12 + (i4 + 2) >> 0] = i3 >>> 16;
         HEAP8[i12 + i2 >> 0] = i3 >>> 24;
         if ((i6 | 0) == 5) {
          i6 = 31;
          break L46;
         }
         i2 = i1 + 6 | 0;
         if (i2 >>> 0 > i11 >>> 0) {
          i6 = 34;
          break L46;
         }
         HEAP8[i12 + i1 >> 0] = -128;
         i4 = i1 + 2 | 0;
         HEAP8[i12 + (i1 + 1) >> 0] = i6;
         HEAP8[i12 + i4 >> 0] = 0;
         HEAP8[i12 + (i1 + 3) >> 0] = 0;
         HEAP8[i12 + (i1 + 4) >> 0] = 0;
         HEAP8[i12 + (i1 + 5) >> 0] = 0;
         i1 = i2;
         i3 = i7;
         i2 = i6;
        }
        if (i1 >>> 0 > i10 >>> 0) {
         i6 = 34;
         break L46;
        }
        i5 = i1 + i7 | 0;
        if (i5 >>> 0 > i10 >>> 0) {
         i6 = 34;
         break L46;
        }
        i8 = _UNITY_FT_Stream_Read(i16, i12 + i1 | 0, i7) | 0;
        HEAP32[i18 >> 2] = i8;
        if (!i8) i1 = i5; else {
         i6 = 35;
         break L46;
        }
       }
       i9 = i9 + 1 | 0;
       if ((i9 | 0) >= (i13 | 0)) {
        i6 = 31;
        break L46;
       } else i8 = i2;
      }
      HEAP32[i18 >> 2] = 9;
      i6 = 35;
     } else {
      i4 = 2;
      i1 = 6;
      i3 = 0;
      i6 = 31;
     } while (0);
     if ((i6 | 0) == 31) {
      HEAP32[i18 >> 2] = 10;
      i2 = i1 + 2 | 0;
      if (i2 >>> 0 > i11 >>> 0) i6 = 35; else {
       HEAP8[i12 + i1 >> 0] = -128;
       HEAP8[i12 + (i1 + 1) >> 0] = 3;
       i1 = i4 + 3 | 0;
       if (i1 >>> 0 > i11 >>> 0) i6 = 34; else {
        HEAP8[i12 + i4 >> 0] = i3;
        HEAP8[i12 + (i4 + 1) >> 0] = i3 >>> 8;
        HEAP8[i12 + (i4 + 2) >> 0] = i3 >>> 16;
        HEAP8[i12 + i1 >> 0] = i3 >>> 24;
        i1 = _open_face_from_buffer(i17, i12, i2, 0, gb + 945610 | 0, i20) | 0;
        break L32;
       }
      }
     }
     if ((i6 | 0) == 34) if (HEAP32[i18 >> 2] | 0) i6 = 35;
     if ((i6 | 0) == 35) HEAP32[i18 >> 2] = 1;
     _UNITY_ft_mem_free(i15, i12);
     i1 = HEAP32[i18 >> 2] | 0;
     break L32;
    }
   }
   HEAP32[i18 >> 2] = 10;
   i1 = 10;
   break;
  }
 default:
  i1 = 1;
 } while (0);
 _UNITY_ft_mem_free(i19, HEAP32[i21 >> 2] | 0);
 HEAP32[i21 >> 2] = 0;
 if (i1 | 0) {
  i21 = i1;
  STACKTOP = i22;
  return i21 | 0;
 }
 HEAP32[HEAP32[i20 >> 2] >> 2] = 1;
 i21 = 0;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN8b2Island8SolveTOIERK10b2TimeStepii(i20, i13, i7, i10) {
 i20 = i20 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 96 | 0;
 i6 = i25 + 52 | 0;
 i24 = i25;
 i19 = i20 + 28 | 0;
 if ((HEAP32[i19 >> 2] | 0) > 0) {
  i2 = i20 + 8 | 0;
  i4 = i20 + 20 | 0;
  i3 = i20 + 24 | 0;
  i1 = 0;
  do {
   i22 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i5 = i22 + 44 | 0;
   i21 = HEAP32[i5 + 4 >> 2] | 0;
   i18 = (HEAP32[i4 >> 2] | 0) + (i1 * 12 | 0) | 0;
   HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i18 + 4 >> 2] = i21;
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i22 + 56 >> 2];
   i18 = i22 + 64 | 0;
   i21 = HEAP32[i18 + 4 >> 2] | 0;
   i5 = (HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) | 0;
   HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i5 + 4 >> 2] = i21;
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i22 + 72 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i19 >> 2] | 0));
  i1 = i5;
 } else {
  i1 = i20 + 24 | 0;
  i3 = i1;
  i4 = i20 + 20 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i21 = i20 + 12 | 0;
 HEAP32[i6 + 24 >> 2] = HEAP32[i21 >> 2];
 i22 = i20 + 36 | 0;
 HEAP32[i6 + 28 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i6 + 32 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 36 >> 2] = i1;
 __ZN15b2ContactSolverC2EP18b2ContactSolverDef(i24, i6);
 i2 = i13 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i1 = i1 + 1 | 0;
   i18 = (__ZN15b2ContactSolver27SolveTOIPositionConstraintsEii(i24, i7, i10) | 0) ^ 1;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0) & i18);
 }
 i18 = i20 + 8 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + (i7 * 12 | 0) | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = (HEAP32[(HEAP32[i18 >> 2] | 0) + (i7 << 2) >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 HEAP32[(HEAP32[i2 + (i7 << 2) >> 2] | 0) + 52 >> 2] = HEAP32[i6 + (i7 * 12 | 0) + 8 >> 2];
 i6 = i6 + (i10 * 12 | 0) | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (HEAP32[i2 + (i10 << 2) >> 2] | 0) + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + (i10 << 2) >> 2] | 0) + 52 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i10 * 12 | 0) + 8 >> 2];
 __ZN15b2ContactSolver29InitializeVelocityConstraintsEv(i24);
 i2 = i13 + 12 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __ZN15b2ContactSolver24SolveVelocityConstraintsEv(i24);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 if ((HEAP32[i19 >> 2] | 0) > 0) {
  i5 = 0;
  do {
   i13 = HEAP32[i4 >> 2] | 0;
   i7 = i13 + (i5 * 12 | 0) | 0;
   f15 = Math_fround(HEAPF32[i7 >> 2]);
   i6 = i13 + (i5 * 12 | 0) + 4 | 0;
   f16 = Math_fround(HEAPF32[i6 >> 2]);
   f17 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 8 >> 2]);
   i13 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i13 + (i5 * 12 | 0) >> 2] | 0;
   i1 = HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 8 >> 2]);
   f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f14 * f9);
   f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = Math_fround(f14 * f11);
   f12 = Math_fround(Math_fround(f26 * f26) + Math_fround(f12 * f12));
   if (f12 > Math_fround(HEAPF32[gb + 151892 >> 2])) {
    f26 = Math_fround(Math_fround(HEAPF32[gb + 151888 >> 2]) / Math_fround(Math_sqrt(Math_fround(f12))));
    f12 = Math_fround(f9 * f26);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f26 = Math_fround(f11 * f26);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f9 = Math_fround(f14 * f8);
   f26 = Math_fround(f9 * f9);
   if (f26 > Math_fround(HEAPF32[gb + 151900 >> 2])) {
    f12 = Math_fround(HEAPF32[gb + 151896 >> 2]);
    i13 = f9 > Math_fround(0.0);
    f26 = Math_fround(-f9);
    f8 = Math_fround(f8 * Math_fround(f12 / (i13 ? f9 : f26)));
   }
   f12 = Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f12 = Math_fround(f15 + f12);
   f9 = Math_fround(f16 + Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
   f26 = Math_fround(f17 + Math_fround(f14 * f8));
   HEAPF32[i7 >> 2] = f12;
   HEAPF32[i6 >> 2] = f9;
   HEAPF32[(HEAP32[i4 >> 2] | 0) + (i5 * 12 | 0) + 8 >> 2] = f26;
   i13 = HEAP32[i3 >> 2] | 0;
   HEAP32[i13 + (i5 * 12 | 0) >> 2] = i2;
   HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2] = i1;
   HEAPF32[(HEAP32[i3 >> 2] | 0) + (i5 * 12 | 0) + 8 >> 2] = f8;
   i13 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   HEAPF32[i13 + 44 >> 2] = f12;
   HEAPF32[i13 + 48 >> 2] = f9;
   HEAPF32[i13 + 56 >> 2] = f26;
   HEAP32[i13 + 64 >> 2] = i2;
   HEAP32[i13 + 68 >> 2] = i1;
   HEAPF32[i13 + 72 >> 2] = f8;
   f16 = Math_fround(+Math_sin(+f26));
   HEAPF32[i13 + 20 >> 2] = f16;
   f26 = Math_fround(+Math_cos(+f26));
   HEAPF32[i13 + 24 >> 2] = f26;
   f11 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f15 = Math_fround(f26 * f11);
   f17 = Math_fround(HEAPF32[i13 + 32 >> 2]);
   f26 = Math_fround(f9 - Math_fround(Math_fround(f16 * f11) + Math_fround(f26 * f17)));
   HEAPF32[i13 + 12 >> 2] = Math_fround(f12 - Math_fround(f15 - Math_fround(f16 * f17)));
   HEAPF32[i13 + 16 >> 2] = f26;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i19 >> 2] | 0));
 }
 i7 = HEAP32[i24 + 40 >> 2] | 0;
 i3 = i20 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZN15b2ContactSolverD2Ev(i24);
  STACKTOP = i25;
  return;
 }
 if ((HEAP32[i22 >> 2] | 0) <= 0) {
  __ZN15b2ContactSolverD2Ev(i24);
  STACKTOP = i25;
  return;
 }
 i4 = i23 + 16 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i6 = HEAP32[i7 + (i1 * 156 | 0) + 148 >> 2] | 0;
  HEAP32[i4 >> 2] = i6;
  if ((i6 | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i23 + (i2 << 2) >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 16 >> 2];
    HEAP32[i23 + 8 + (i2 << 2) >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 20 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i6 | 0));
  }
  i20 = HEAP32[i3 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i20 >> 2] | 0) + 20 >> 2] | 0, i20 | 0, i5 | 0, i23 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i22 >> 2] | 0));
 __ZN15b2ContactSolverD2Ev(i24);
 STACKTOP = i25;
 return;
}

function __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17;
 i1 = i16 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 340) {
  HEAP32[i1 >> 2] = i2 + -341;
  i10 = i16 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = i16 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i1 = i15;
  i5 = i7;
  do if ((i7 | 0) == (i15 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i9 >>> 0 > i2 >>> 0) {
    i1 = i9;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i9 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i9; else {
     _memmove(i4 | 0, i9 | 0, i1 | 0) | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i11 >> 2] = i16;
    HEAP32[i10 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i15 = __Znwj(i6 << 2) | 0;
   i4 = i15;
   i1 = i15 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i15 + (i6 << 2) | 0;
   if ((i9 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i9;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i11 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
 i15 = i16 + 8 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i9 = i8 - i10 | 0;
 i11 = i9 >> 2;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i1 = i4 - i6 | 0;
 i5 = i8;
 i12 = i10;
 i7 = i4;
 i2 = i6;
 if (i11 >>> 0 >= i1 >> 2 >>> 0) {
  i10 = i1 >> 1;
  i10 = (i10 | 0) == 0 ? 1 : i10;
  i2 = __Znwj(i10 << 2) | 0;
  i3 = i2;
  i4 = i2 + (i11 << 2) | 0;
  i1 = i2 + (i10 << 2) | 0;
  i6 = __Znwj(4092) | 0;
  do if ((i11 | 0) == (i10 | 0)) if ((i9 | 0) > 0) {
   i7 = i3;
   i3 = i4 + (((i11 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i12;
   break;
  } else {
   i1 = i9 >> 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   i5 = __Znwj(i1 << 2) | 0;
   __ZdlPv(i2);
   i7 = i5;
   i3 = i5 + (i1 >>> 2 << 2) | 0;
   i1 = i5 + (i1 << 2) | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i7 = i3;
   i3 = i4;
   i2 = i12;
  } while (0);
  i4 = i3;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  if ((i5 | 0) == (i2 | 0)) i5 = i7; else while (1) {
   i5 = i5 + -4 | 0;
   i2 = i4;
   do if ((i2 | 0) == (i7 | 0)) {
    i9 = i3;
    if (i9 >>> 0 < i1 >>> 0) {
     i6 = i9 + ((((i1 - i3 >> 2) + 1 | 0) / 2 | 0) << 2) | 0;
     i2 = i3 - i4 | 0;
     i12 = i2 >> 2;
     i3 = i6 + (0 - i12 << 2) | 0;
     if (!i12) i2 = i6; else {
      _memmove(i3 | 0, i4 | 0, i2 | 0) | 0;
      i2 = i3;
     }
     i4 = i2;
     i3 = i6;
     break;
    }
    i1 = i1 - i7 >> 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    i12 = __Znwj(i1 << 2) | 0;
    i7 = i12;
    i10 = i12 + ((i1 + 3 | 0) >>> 2 << 2) | 0;
    i8 = i10;
    i1 = i12 + (i1 << 2) | 0;
    if ((i2 | 0) == (i9 | 0)) i3 = i8; else {
     i6 = i10;
     i3 = i8;
     do {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      i6 = i3 + 4 | 0;
      i3 = i6;
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i9 | 0));
    }
    if (!i4) {
     i4 = i8;
     i2 = i10;
    } else {
     __ZdlPv(i4);
     i4 = i8;
     i2 = i10;
    }
   } while (0);
   HEAP32[i2 + -4 >> 2] = HEAP32[i5 >> 2];
   i2 = i4 + -4 | 0;
   if ((i5 | 0) == (HEAP32[i14 >> 2] | 0)) {
    i5 = i7;
    i4 = i2;
    break;
   } else i4 = i2;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i1;
  if (!i2) {
   STACKTOP = i17;
   return;
  }
  __ZdlPv(i2);
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) == (i8 | 0)) {
  HEAP32[i3 >> 2] = __Znwj(4092) | 0;
  __ZNSt3__214__split_bufferIP4NodeNS_9allocatorIS2_EEE10push_frontERKS2_(i16, i3);
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 4 | 0;
  HEAP32[i14 >> 2] = i8;
  i7 = HEAP32[i15 >> 2] | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = i12;
  i5 = i7;
  do if ((i7 | 0) == (i12 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   if (i8 >>> 0 > i2 >>> 0) {
    i1 = i8;
    i3 = ((i1 - i3 >> 2) + 1 | 0) / -2 | 0;
    i4 = i8 + (i3 << 2) | 0;
    i1 = i5 - i1 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i8; else {
     _memmove(i4 | 0, i8 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i6 = i1 - i3 >> 1;
   i6 = (i6 | 0) == 0 ? 1 : i6;
   i12 = __Znwj(i6 << 2) | 0;
   i4 = i12;
   i1 = i12 + (i6 >>> 2 << 2) | 0;
   i5 = i1;
   i6 = i12 + (i6 << 2) | 0;
   if ((i8 | 0) == (i7 | 0)) i1 = i5; else {
    i3 = i1;
    i1 = i5;
    i2 = i8;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i4;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i6;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } else i1 = i7; while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 } else {
  i9 = __Znwj(4092) | 0;
  i1 = i8;
  do if ((i5 | 0) == (i7 | 0)) {
   if (i12 >>> 0 > i2 >>> 0) {
    i3 = ((i10 - i6 >> 2) + 1 | 0) / -2 | 0;
    i4 = i12 + (i3 << 2) | 0;
    i1 = i8 - i10 | 0;
    i2 = i1 >> 2;
    if (!i2) i1 = i12; else {
     _memmove(i4 | 0, i10 | 0, i1 | 0) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i16 = i4 + (i2 << 2) | 0;
    HEAP32[i15 >> 2] = i16;
    HEAP32[i14 >> 2] = i1 + (i3 << 2);
    i1 = i16;
    break;
   }
   i4 = i4 - i6 >> 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i11 = __Znwj(i4 << 2) | 0;
   i6 = i11;
   i1 = i11 + (i4 >>> 2 << 2) | 0;
   i7 = i1;
   i4 = i11 + (i4 << 2) | 0;
   if ((i12 | 0) == (i5 | 0)) i1 = i7; else {
    i3 = i1;
    i1 = i7;
    i2 = i12;
    do {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     i3 = i1 + 4 | 0;
     i1 = i3;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i5 | 0));
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = i6;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i13 >> 2] = i4;
   if (i2) {
    __ZdlPv(i2);
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
  STACKTOP = i17;
  return;
 }
}

function __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10);
 i1 = i9 + 40 | 0;
 i6 = i10 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i10 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 44 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i9 + 45 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i1 = i9 + 48 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 80 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
  i4 = i3;
 }
 i1 = i9 + 88 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i9 + 92 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i9 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i1 = i9 + 120 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i9 + 124 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i4 = i9 + 128 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  i1 = i5;
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = i10 + 8 | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i9 + 132 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy(i4, i1, i7, 1);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  i8 = i9 + 148 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i10, i8, 0);
  i9 = i9 + 168 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i10, i9, 0);
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, HEAP32[i4 >> 2] | 0, i1 << 3);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i8 = i9 + 148 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i10, i8, 0);
 i9 = i9 + 168 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i10, i9, 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx16PxsFluidDynamics21updatePacketLocalHashENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i34, i35, i28, i32, i1, i31, i29, i33) {
 i34 = i34 | 0;
 i35 = i35 | 0;
 i28 = i28 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i31 = i31 | 0;
 i29 = i29 | 0;
 i33 = i33 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i36;
 i24 = HEAP32[i33 >> 2] | 0;
 i25 = HEAP32[i33 + 4 >> 2] | 0;
 i26 = HEAP32[i33 + 16 >> 2] | 0;
 i27 = HEAP32[i33 + 20 >> 2] | 0;
 f40 = Math_fround(HEAP16[i1 >> 1] | 0);
 f38 = Math_fround(HEAP16[i1 + 2 >> 1] | 0);
 f37 = Math_fround(HEAP16[i1 + 4 >> 1] | 0);
 f39 = Math_fround(HEAPF32[i34 + 20 >> 2]);
 f38 = Math_fround(f38 * f39);
 f37 = Math_fround(f37 * f39);
 HEAPF32[i30 >> 2] = Math_fround(f40 * f39);
 HEAPF32[i30 + 4 >> 2] = f38;
 HEAPF32[i30 + 8 >> 2] = f37;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i12 = i33 + 40 | 0;
  i13 = i34 + 12 | 0;
  i14 = i28 + (i1 * 12 | 0) | 0;
  i9 = i32 + (i1 << 5) | 0;
  do {
   i1 = i2 >>> 0 < 512 ? i2 : 512;
   i3 = i1 + 1 | 0;
   i3 = i3 >>> 1 | i3;
   i3 = i3 >>> 2 | i3;
   i3 = i3 >>> 4 | i3;
   i3 = i3 >>> 8 | i3;
   i3 = (i3 >>> 16 | i3) + 1 | 0;
   __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i9, i1, i26, i24, HEAP32[i12 >> 2] | 0, i3, Math_fround(HEAPF32[i13 >> 2]), i30);
   __ZN5physx20updateCellsSubpacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleEPKNS_15PxsParticleCellEPKjjRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersE(i35, i14, i9, i26, i24, i3, i34, i33);
   i4 = i2;
   i2 = i2 - i1 | 0;
   i10 = i9;
   i9 = i9 + (i1 << 5) | 0;
   i6 = i14;
   i14 = i14 + (i1 * 12 | 0) | 0;
   i4 = (i4 | 0) == (i1 | 0);
   if (i4) break L1; else {
    i7 = i14;
    i8 = i2;
    i11 = i9;
   }
   while (1) {
    i5 = i8 >>> 0 < 512 ? i8 : 512;
    i23 = i5 + 1 | 0;
    i23 = i23 >>> 1 | i23;
    i23 = i23 >>> 2 | i23;
    i23 = i23 >>> 4 | i23;
    i23 = i23 >>> 8 | i23;
    i23 = (i23 >>> 16 | i23) + 1 | 0;
    __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i11, i5, i27, i25, HEAP32[i12 >> 2] | 0, i23, Math_fround(HEAPF32[i13 >> 2]), i30);
    __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb(i35, i6, i7, i10, i11, i26, i27, i24, i25, i3, i23, 1, i34, i33, i1 >>> 0 < i5 >>> 0);
    if ((i8 | 0) == (i5 | 0)) break; else {
     i7 = i7 + (i5 * 12 | 0) | 0;
     i8 = i8 - i5 | 0;
     i11 = i11 + (i5 << 5) | 0;
    }
   }
  } while (!i4);
 } while (0);
 if (!(HEAP32[i29 + 784 >> 2] | 0)) {
  STACKTOP = i36;
  return;
 }
 i8 = i33 + 36 | 0;
 i9 = i33 + 8 | 0;
 i10 = (i35 | 0) == 0;
 i11 = i33 + 28 | 0;
 i12 = i33 + 32 | 0;
 i13 = i33 + 40 | 0;
 i14 = i34 + 12 | 0;
 i23 = 0;
 do {
  i15 = HEAP32[i31 + (i23 << 2) >> 2] | 0;
  if (i15 | 0) {
   i16 = i15 >>> 0 < 201;
   i17 = HEAP32[gb + 107804 + (i23 * 80 | 0) >> 2] | 0;
   i22 = HEAP32[i31 + 108 + (i23 << 2) >> 2] | 0;
   i18 = (i17 | 0) == 0;
   i20 = i28 + (i22 * 12 | 0) | 0;
   i21 = i15;
   i22 = i32 + (i22 << 5) | 0;
   while (1) {
    i19 = i21 >>> 0 < 512 ? i21 : 512;
    i4 = i19 + 1 | 0;
    i4 = i4 >>> 1 | i4;
    i4 = i4 >>> 2 | i4;
    i4 = i4 >>> 4 | i4;
    i4 = i4 >>> 8 | i4;
    i4 = (i4 >>> 16 | i4) + 1 | 0;
    if (!i18) {
     i5 = 0;
     i1 = 0;
     do {
      i3 = HEAP32[gb + 107804 + (i23 * 80 | 0) + 4 + (i5 << 2) >> 2] | 0;
      i2 = HEAP32[i29 + (i3 << 2) >> 2] | 0;
      if (!(i16 & i2 >>> 0 < 201)) {
       if (!i1) __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i22, i19, i26, i24, HEAP32[i13 >> 2] | 0, i4, Math_fround(HEAPF32[i14 >> 2]), i30);
       if (!i2) i1 = 1; else {
        i3 = i32 + (HEAP32[i29 + 392 + (i3 << 2) >> 2] << 5) | 0;
        while (1) {
         i1 = i2 >>> 0 < 512 ? i2 : 512;
         i7 = i1 + 1 | 0;
         i7 = i7 >>> 1 | i7;
         i7 = i7 >>> 2 | i7;
         i7 = i7 >>> 4 | i7;
         i7 = i7 >>> 8 | i7;
         i7 = (i7 >>> 16 | i7) + 1 | 0;
         __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i3, i1, i27, i25, HEAP32[i13 >> 2] | 0, i7, Math_fround(HEAPF32[i14 >> 2]), i30);
         __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb(i35, i20, 0, i22, i3, i26, i27, i24, i25, i4, i7, 0, i34, i33, i19 >>> 0 > i1 >>> 0);
         if ((i2 | 0) == (i1 | 0)) {
          i1 = 1;
          break;
         } else {
          i2 = i2 - i1 | 0;
          i3 = i3 + (i1 << 5) | 0;
         }
        }
       }
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i17 | 0));
     if (!i18) {
      i7 = 0;
      i1 = 0;
      do {
       i2 = HEAP32[gb + 107804 + (i23 * 80 | 0) + 4 + (i7 << 2) >> 2] | 0;
       i6 = HEAP32[i29 + (i2 << 2) >> 2] | 0;
       if (i16 & (i6 + -1 | 0) >>> 0 < 200) {
        if ((i6 + i1 | 0) >>> 0 > 512) {
         __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i20, 0, i22, i32, HEAP32[i8 >> 2] | 0, i15, HEAP32[i9 >> 2] | 0, i1, 0, i10, i34, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0);
         i1 = 0;
        }
        if (i6) {
         i5 = HEAP32[i9 >> 2] | 0;
         i2 = HEAP32[i29 + 392 + (i2 << 2) >> 2] | 0;
         i3 = 0;
         i4 = i1;
         while (1) {
          HEAP32[i5 + (i4 << 2) >> 2] = i2;
          i3 = i3 + 1 | 0;
          if ((i3 | 0) == (i6 | 0)) break; else {
           i2 = i2 + 1 | 0;
           i4 = i4 + 1 | 0;
          }
         }
         i1 = i1 + i6 | 0;
        }
       }
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i17 | 0));
      if (i1 | 0) __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i20, 0, i22, i32, HEAP32[i8 >> 2] | 0, i15, HEAP32[i9 >> 2] | 0, i1, 0, i10, i34, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0);
     }
    }
    if ((i21 | 0) == (i19 | 0)) break; else {
     i20 = i20 + (i19 * 12 | 0) | 0;
     i21 = i21 - i19 | 0;
     i22 = i22 + (i19 << 5) | 0;
    }
   }
  }
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) != 26);
 STACKTOP = i36;
 return;
}

function __ZN15DistanceJoint2D6CreateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 20;
   }
  }
  if ((i7 | 0) == 18) i7 = 20;
  if ((i7 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i10;
   return;
  }
 } while (0);
 if (!(HEAP8[i8 + 100 >> 0] | 0)) {
  i2 = i9 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP8[i2 + 12 >> 0] = 0;
  HEAP32[i9 >> 2] = 3;
  i2 = i9 + 20 | 0;
  i1 = i9 + 36 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  i2 = i9 + 40 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  i3 = i9 + 44 | 0;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i4 = i9 + 20 | 0;
  i5 = i9 + 28 | 0;
  __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i8, i4, i5);
  if (HEAP8[i8 + 101 >> 0] | 0) if (!(HEAP8[i8 + 52 >> 0] | 0)) {
   i7 = __ZNK7Joint2D10FetchBodyAEv(i8) | 0;
   f15 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f12 = Math_fround(f15 * f14);
   f17 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f11 = Math_fround(HEAPF32[i9 + 24 >> 2]);
   f12 = Math_fround(f12 - Math_fround(f17 * f11));
   f12 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) + f12);
   f11 = Math_fround(Math_fround(f14 * f17) + Math_fround(f15 * f11));
   f11 = Math_fround(f11 + Math_fround(HEAPF32[i7 + 16 >> 2]));
   i7 = __ZNK7Joint2D10FetchBodyBEv(i8) | 0;
   f15 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f17 = Math_fround(HEAPF32[i5 >> 2]);
   f14 = Math_fround(f15 * f17);
   f16 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f13 = Math_fround(HEAPF32[i9 + 32 >> 2]);
   f14 = Math_fround(f14 - Math_fround(f16 * f13));
   f14 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) + f14);
   f13 = Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f13));
   f12 = Math_fround(f14 - f12);
   f11 = Math_fround(Math_fround(f13 + Math_fround(HEAPF32[i7 + 16 >> 2])) - f11);
   f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11))));
   i7 = f11 < Math_fround(.00499999989);
   i6 = f11 > Math_fround(1.0e6);
   f11 = i6 ? Math_fround(1.0e6) : f11;
   HEAPF32[i8 + 96 >> 2] = i7 ? Math_fround(.00499999989) : f11;
  }
  HEAP32[i1 >> 2] = HEAP32[i8 + 96 >> 2];
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i8, i9);
  STACKTOP = i10;
  return;
 } else {
  i1 = i9 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP8[i1 + 12 >> 0] = 0;
  HEAP32[i9 >> 2] = 10;
  HEAPF32[i9 + 20 >> 2] = Math_fround(-1.0);
  i1 = i9 + 24 | 0;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 28 >> 2] = Math_fround(1.0);
  i2 = i9 + 32 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  i3 = i9 + 36 | 0;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i4 = i9 + 20 | 0;
  i5 = i9 + 28 | 0;
  __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i8, i4, i5);
  if (HEAP8[i8 + 101 >> 0] | 0) if (!(HEAP8[i8 + 52 >> 0] | 0)) {
   i7 = __ZNK7Joint2D10FetchBodyAEv(i8) | 0;
   f13 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f16 = Math_fround(f13 * f14);
   f11 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f17 = Math_fround(HEAPF32[i1 >> 2]);
   f16 = Math_fround(f16 - Math_fround(f11 * f17));
   f16 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) + f16);
   f17 = Math_fround(Math_fround(f14 * f11) + Math_fround(f13 * f17));
   f17 = Math_fround(f17 + Math_fround(HEAPF32[i7 + 16 >> 2]));
   i7 = __ZNK7Joint2D10FetchBodyBEv(i8) | 0;
   f13 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   f11 = Math_fround(HEAPF32[i5 >> 2]);
   f14 = Math_fround(f13 * f11);
   f12 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   f15 = Math_fround(HEAPF32[i2 >> 2]);
   f14 = Math_fround(f14 - Math_fround(f12 * f15));
   f14 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) + f14);
   f15 = Math_fround(Math_fround(f11 * f12) + Math_fround(f13 * f15));
   f16 = Math_fround(f14 - f16);
   f17 = Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i7 + 16 >> 2])) - f17);
   f17 = Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17))));
   i7 = f17 < Math_fround(.00499999989);
   i6 = f17 > Math_fround(1.0e6);
   f17 = i6 ? Math_fround(1.0e6) : f17;
   HEAPF32[i8 + 96 >> 2] = i7 ? Math_fround(.00499999989) : f17;
  }
  HEAP32[i3 >> 2] = HEAP32[i8 + 96 >> 2];
  __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i8, i9);
  STACKTOP = i10;
  return;
 }
}

function __ZN13WheelCollider26AddWheelToRecreatedVehicleEP9Rigidbody(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18;
 i5 = i12 + 56 | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 64 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 i17 = (i15 | 0) != 0;
 if (i17) {
  i2 = HEAP32[i15 + 48 >> 2] | 0;
  i1 = i2 + 1 | 0;
  if ((i2 | 0) == 20) {
   if (!i14) i1 = 0; else i1 = HEAP32[i14 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 827007 | 0, 0, gb + 826839 | 0, 401, 1, i1, 0, 0);
   STACKTOP = i18;
   return;
  } else i13 = i2;
 } else {
  i1 = 1;
  i13 = 0;
 }
 i8 = HEAP32[i12 + 52 >> 2] | 0;
 i9 = __ZN5physx16PxVehicleNoDrive8allocateEj(i1) | 0;
 i4 = __Znaj(i1 >>> 0 > 29020049 ? -1 : i1 * 148 | 0) | 0;
 if (i1 | 0) {
  i2 = i4 + (i1 * 148 | 0) | 0;
  i3 = i4;
  do {
   _memset(i3 | 0, 0, 140) | 0;
   HEAP8[i3 + 28 >> 0] = 1;
   HEAP32[i3 + 44 >> 2] = -1;
   HEAP32[i3 + 120 >> 2] = 0;
   HEAP32[i3 + 124 >> 2] = 0;
   HEAP32[i3 + 128 >> 2] = 0;
   HEAP32[i3 + 132 >> 2] = 1065353216;
   HEAP32[i3 + 136 >> 2] = 0;
   HEAP32[i3 + 140 >> 2] = 0;
   HEAP32[i3 + 144 >> 2] = 0;
   i3 = i3 + 148 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 i7 = (i13 | 0) == 0;
 i3 = i12 + 60 | 0;
 if (!i7) {
  i2 = 0;
  do {
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 + (i2 * 148 | 0) >> 2] = HEAP32[i6 + (i2 * 148 | 0) >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 4 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 4 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 8 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 8 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 12 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 12 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 16 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 16 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 20 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 20 >> 2];
   i19 = i4 + (i2 * 148 | 0) + 24 | 0;
   i20 = i6 + (i2 * 148 | 0) + 24 | 0;
   HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i19 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
   HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 48 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 48 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 52 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 52 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 56 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 56 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 60 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 60 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 64 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 64 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 68 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 68 >> 2];
   i19 = i4 + (i2 * 148 | 0) + 72 | 0;
   i20 = i6 + (i2 * 148 | 0) + 72 | 0;
   HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 84 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 84 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 88 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 88 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 92 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 92 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 96 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 96 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 100 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 100 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 104 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 104 >> 2];
   i19 = i4 + (i2 * 148 | 0) + 108 | 0;
   i20 = i6 + (i2 * 148 | 0) + 108 | 0;
   HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 120 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 120 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 124 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 124 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 128 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 128 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 132 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 132 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 136 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 136 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 140 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 140 >> 2];
   HEAP32[i4 + (i2 * 148 | 0) + 144 >> 2] = HEAP32[i6 + (i2 * 148 | 0) + 144 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i3 >> 2] = i4;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i11 >> 2] = __Z10AddVehiclePN5physx16PxVehicleNoDriveEjPNS_18PxWheelQueryResultE(i9, i1, i4) | 0;
 HEAP32[i14 + 148 >> 2] = i13;
 i6 = i9 + 8 | 0;
 __ZN5physx22PxVehicleWheelsSimData25setMinLongSlipDenominatorEf(i6, Math_fround(4.0));
 if (i17) __ZN5physx22PxVehicleWheelsSimData21setTireLoadFilterDataERKNS_27PxVehicleTireLoadFilterDataE(i6, i15 + 8 | 0);
 if (i7) i3 = i9 + 72 | 0; else {
  i2 = i15 + 8 | 0;
  i3 = i9 + 72 | 0;
  i4 = i15 + 72 | 0;
  i5 = i10 + 8 | 0;
  i1 = 0;
  do {
   __ZN5physx22PxVehicleWheelsSimData4copyERKS0_jj(i6, i2, i1, i1);
   __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv(i3, i1, __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj(i4, i1) | 0);
   i20 = __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i2, i1) | 0;
   HEAP32[i10 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i5 >> 2] = (HEAP32[i11 >> 2] << 16) + 65536 | HEAP32[i5 >> 2] & 65535;
   __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i6, i1, i10);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 __ZN13WheelCollider25AddWheelToExistingVehicleEP9RigidbodyPN5physx16PxVehicleNoDriveEi(i14, i12, i9, i13);
 __ZN5physx16PxVehicleNoDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE(i9, __Z14GetDynamicsSDKv() | 0, i8, i6);
 __ZN5physx16PxVehicleNoDrive14setToRestStateEv(i9);
 if (!i7) {
  i2 = i15 + 72 | 0;
  i1 = 0;
  do {
   __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf(i3, i1, Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj(i2, i1)));
   __ZN5physx22PxVehicleWheelsDynData21setWheelRotationAngleEjf(i3, i1, Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj(i2, i1)));
   __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv(i3, i1, __ZNK5physx22PxVehicleWheelsDynData22getTireForceShaderDataEj(i2, i1) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv(i3, i13, i14 + 104 | 0);
 __ZN5physx22PxVehicleWheelsDynData26setTireForceShaderFunctionEPFvPKvffffffffffffRfS3_S3_S3_E(i3, fb + 1 | 0);
 if (!i17) {
  STACKTOP = i18;
  return;
 }
 __Z13RemoveVehiclePN5physx16PxVehicleNoDriveEj(i15, i16);
 __ZN5physx16PxVehicleNoDrive4freeEv(i15);
 STACKTOP = i18;
 return;
}

function __GLOBAL__sub_I_runtime_terrain_lump_cpp_3661() {
 var i1 = 0;
 i1 = gb + 1099728 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1467672 >> 2] = 0;
 HEAP32[gb + 1467672 + 4 >> 2] = 0;
 HEAP32[gb + 1467672 + 8 >> 2] = 0;
 HEAP32[gb + 1467400 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467400 | 0, gb + 1046318 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467644 | 0, gb + 935701 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467684 | 0, gb + 935732 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467696 | 0, gb + 935759 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467708 | 0, gb + 935776 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467720 | 0, gb + 935797 | 0, 0, 0);
 HEAP32[gb + 1467656 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467656 | 0, gb + 935821 | 0);
 HEAP32[gb + 1467616 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467616 | 0, gb + 1046318 | 0);
 HEAP32[gb + 1467620 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467620 | 0, gb + 935829 | 0);
 HEAP32[gb + 1467624 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467624 | 0, gb + 935845 | 0);
 HEAP32[gb + 1467628 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467628 | 0, gb + 935861 | 0);
 HEAP32[gb + 1467632 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467632 | 0, gb + 935878 | 0);
 HEAP32[gb + 1467636 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467636 | 0, gb + 935890 | 0);
 HEAP32[gb + 1467640 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467640 | 0, gb + 935903 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467172 | 0, gb + 935913 | 0, 0, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1573583 | 0, fb + 3822 | 0, fb + 3823 | 0, -1, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467320 | 0, gb + 935933 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467260 | 0, gb + 935957 | 0, 11, 0);
 HEAP32[gb + 1467336 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467336 | 0, gb + 935981 | 0);
 HEAP32[gb + 1467312 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467312 | 0, gb + 935990 | 0);
 HEAP32[gb + 1467316 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467316 | 0, gb + 936001 | 0);
 HEAP32[gb + 1467732 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467732 | 0, gb + 936012 | 0);
 HEAP32[gb + 1467308 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467308 | 0, gb + 936024 | 0);
 HEAP32[gb + 1467304 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467304 | 0, gb + 936037 | 0);
 HEAP32[gb + 1467340 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467340 | 0, gb + 936050 | 0);
 HEAP32[gb + 1467340 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467340 + 4 | 0, gb + 936058 | 0);
 HEAP32[gb + 1467340 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467340 + 8 | 0, gb + 936066 | 0);
 HEAP32[gb + 1467340 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467340 + 12 | 0, gb + 936074 | 0);
 HEAP32[gb + 1467356 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467356 | 0, gb + 936082 | 0);
 HEAP32[gb + 1467356 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467356 + 4 | 0, gb + 936091 | 0);
 HEAP32[gb + 1467356 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467356 + 8 | 0, gb + 936100 | 0);
 HEAP32[gb + 1467356 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467356 + 12 | 0, gb + 936109 | 0);
 HEAP32[gb + 1467372 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467372 | 0, gb + 936118 | 0);
 HEAP32[gb + 1467372 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467372 + 4 | 0, gb + 936129 | 0);
 HEAP32[gb + 1467372 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467372 + 8 | 0, gb + 936140 | 0);
 HEAP32[gb + 1467372 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467372 + 12 | 0, gb + 936151 | 0);
 HEAP32[gb + 1467288 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467288 | 0, gb + 936162 | 0);
 HEAP32[gb + 1467288 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467288 + 4 | 0, gb + 936173 | 0);
 HEAP32[gb + 1467288 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467288 + 8 | 0, gb + 936184 | 0);
 HEAP32[gb + 1467288 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467288 + 12 | 0, gb + 936195 | 0);
 HEAP32[gb + 1467272 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467272 | 0, gb + 936206 | 0);
 HEAP32[gb + 1467272 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467272 + 4 | 0, gb + 936219 | 0);
 HEAP32[gb + 1467272 + 8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467272 + 8 | 0, gb + 936232 | 0);
 HEAP32[gb + 1467272 + 12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467272 + 12 | 0, gb + 936245 | 0);
 HEAP32[gb + 1467248 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467248 | 0, gb + 1046318 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467388 | 0, gb + 936258 | 0, 10, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1573584 | 0, fb + 3824 | 0, fb + 3825 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467404 | 0, gb + 936284 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467416 | 0, gb + 936303 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467428 | 0, gb + 936333 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467440 | 0, gb + 936363 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467452 | 0, gb + 936393 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467464 | 0, gb + 936416 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467660 | 0, gb + 936437 | 0, 0, 0);
 HEAP32[gb + 1467736 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467736 | 0, gb + 936464 | 0);
 HEAP32[gb + 1467740 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467740 | 0, gb + 936470 | 0);
 HEAP32[gb + 1467744 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467744 | 0, gb + 936483 | 0);
 return;
}

function __Z29SpriteRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i18, i19, i22) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i43 + 552 | 0;
 i27 = i43 + 536 | 0;
 i37 = i43 + 4 | 0;
 i38 = i43;
 i39 = i43 + 528 | 0;
 i40 = __Z12GetGfxDevicev() | 0;
 i41 = __ZN9GfxDevice13GetDynamicVBOEv(i40) | 0;
 mftCall_vii(HEAP32[(HEAP32[i40 >> 2] | 0) + 108 >> 2] | 0, i40 | 0, gb + 1162292 | 0);
 i24 = HEAP32[i22 >> 2] | 0;
 i24 = i24 >>> 6 & 2 | i24 >>> 1 & 1;
 i20 = HEAP32[gb + 1161636 + (i24 << 3) >> 2] | 0;
 i21 = __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj(i20, gb + 1546313 | 0, 0) | 0;
 i24 = gb + 1161636 + (i24 << 3) + 4 | 0;
 i23 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(HEAP32[i24 >> 2] | 0, HEAP32[i22 >> 2] | 0, 0) | 0;
 i24 = HEAP32[(HEAP32[i24 >> 2] | 0) + 4 >> 2] | 0;
 i25 = i19 + 4 | 0;
 if (!(HEAP32[i25 >> 2] | 0)) {
  STACKTOP = i43;
  return;
 }
 i26 = i40 + 4448 | 0;
 i28 = i27 + 4 | 0;
 i29 = i27 + 8 | 0;
 i30 = i27 + 12 | 0;
 i31 = i17 + 4 | 0;
 i32 = i17 + 8 | 0;
 i33 = i17 + 12 | 0;
 i34 = i17 + 16 | 0;
 i35 = i17 + 4 | 0;
 i36 = i17 + 8 | 0;
 i1 = 0;
 do {
  __ZN14BatchAllocatorC2Ev(i37);
  HEAP32[i38 >> 2] = 0;
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i37, i38, -1, 24, 1, 4);
  HEAP32[i38 >> 2] = 0;
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i37, 0, 0, 20, 128, 4);
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i37, (HEAP32[i38 >> 2] | 0) + 4 | 0, 0, 5640, 128, 4);
  __ZN14BatchAllocator6CommitERK10MemLabelId(i37, gb + 64024 | 0);
  i4 = HEAP32[i38 >> 2] | 0;
  __ZN17UniqueIDGenerator8CreateIDEv(i17, i26);
  HEAP32[i4 + 8 >> 2] = HEAP32[i17 >> 2];
  i4 = HEAP32[i25 >> 2] | 0;
  if (i1 >>> 0 < i4 >>> 0) {
   i2 = 0;
   i5 = 0;
   i16 = 0;
   i6 = 0;
   i10 = 0;
   i3 = 0;
   i8 = 0;
   while (1) {
    i12 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 3) >> 2] | 0;
    i7 = HEAP32[i18 >> 2] | 0;
    i11 = i7 + (i12 * 360 | 0) | 0;
    i12 = HEAP32[i7 + (i12 * 360 | 0) + 328 >> 2] | 0;
    i7 = HEAP32[i12 >> 2] | 0;
    if (!i7) i7 = i16; else {
     i13 = HEAP32[i7 + 40 >> 2] | 0;
     i14 = HEAP32[i7 + 20 >> 2] | 0;
     i4 = (i5 | 0) != 0;
     i15 = i13 + i6 | 0;
     if (i4 & i15 >>> 0 > 31999) {
      i7 = i16;
      i4 = i10;
      break;
     }
     if (!i4) {
      i5 = HEAP32[(HEAP32[i38 >> 2] | 0) + 4 >> 2] | 0;
      HEAP32[i5 + (i2 * 5640 | 0) + 5632 >> 2] = i16;
      HEAP32[i5 + (i2 * 5640 | 0) + 5636 >> 2] = 0;
      i5 = i5 + (i2 * 5640 | 0) | 0;
      i10 = 0;
      i3 = 0;
      i8 = i8 + 1 | 0;
     }
     i9 = i5 + 5636 | 0;
     HEAP32[i5 + (HEAP32[i9 >> 2] << 2) >> 2] = i7;
     i7 = HEAP32[i9 >> 2] | 0;
     i44 = HEAP32[i12 + 12 >> 2] | 0;
     i6 = HEAP32[i12 + 16 >> 2] | 0;
     i4 = HEAP32[i12 + 20 >> 2] | 0;
     HEAP32[i5 + 256 + (i7 << 4) >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i5 + 256 + (i7 << 4) + 4 >> 2] = i44;
     HEAP32[i5 + 256 + (i7 << 4) + 8 >> 2] = i6;
     HEAP32[i5 + 256 + (i7 << 4) + 12 >> 2] = i4;
     HEAP32[i5 + 1280 + (HEAP32[i9 >> 2] << 2) >> 2] = i20;
     i7 = i5 + 1536 + (HEAP32[i9 >> 2] << 6) | 0;
     i4 = i11;
     i6 = i7 + 64 | 0;
     do {
      HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
      i7 = i7 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i7 | 0) < (i6 | 0));
     i4 = HEAP16[i12 + 4 >> 1] | 0;
     i6 = (i4 & 65535) >>> 8;
     if (((i4 | i6) & 255) << 24 >> 24) {
      i44 = i5 + 1536 + (HEAP32[i9 >> 2] << 6) | 0;
      f46 = (i4 & 255) << 24 >> 24 ? Math_fround(-1.0) : Math_fround(1.0);
      f45 = i6 << 16 >> 16 ? Math_fround(-1.0) : Math_fround(1.0);
      HEAPF32[i17 >> 2] = f46;
      HEAPF32[i35 >> 2] = f45;
      HEAPF32[i36 >> 2] = Math_fround(1.0);
      __ZN10Matrix4x4f5ScaleERK8Vector3f(i44, i17) | 0;
     }
     i44 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
     HEAP32[i9 >> 2] = i44;
     i4 = i10 + i14 | 0;
     i3 = i3 + i13 | 0;
     if ((i44 | 0) == 64) {
      i5 = HEAP32[HEAP32[i38 >> 2] >> 2] | 0;
      HEAP32[i5 + (i2 * 20 | 0) + 8 >> 2] = i4;
      HEAP32[i5 + (i2 * 20 | 0) + 12 >> 2] = i3;
      HEAP32[i5 + (i2 * 20 | 0) + 16 >> 2] = i21;
      i2 = i2 + 1 | 0;
      i5 = 0;
     }
     i7 = i14 + i16 | 0;
     i6 = i15;
     i10 = i4;
     i4 = HEAP32[i25 >> 2] | 0;
    }
    i1 = i1 + 1 | 0;
    if (i8 >>> 0 < 128 & i1 >>> 0 < i4 >>> 0) i16 = i7; else {
     i4 = i10;
     break;
    }
   }
   if (i5) if (HEAP32[i5 + 5636 >> 2] | 0) {
    i44 = HEAP32[HEAP32[i38 >> 2] >> 2] | 0;
    HEAP32[i44 + (i2 * 20 | 0) + 8 >> 2] = i4;
    HEAP32[i44 + (i2 * 20 | 0) + 12 >> 2] = i3;
    HEAP32[i44 + (i2 * 20 | 0) + 16 >> 2] = i21;
    i2 = i2 + 1 | 0;
   }
   if (!i2) i42 = 24; else {
    if ((HEAP16[gb + 1161668 + 6 >> 1] | 0) > -1) {
     HEAP32[i27 >> 2] = 0;
     HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161668 | 0, i17);
     i3 = gb + 1161668 | 0;
    } else i3 = 0;
    HEAP32[i27 >> 2] = 0;
    HEAP32[i28 >> 2] = 0;
    HEAP32[i29 >> 2] = -1;
    HEAP32[i30 >> 2] = 0;
    i16 = HEAP32[i38 >> 2] | 0;
    i44 = HEAP32[i16 + 8 >> 2] | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i40 >> 2] | 0) + 252 >> 2] | 0, i40 | 0, fb + 2417 | 0, fb + 3392 | 0, i16 | 0, i2 | 0, 0, i27 | 0);
    HEAP32[i38 >> 2] = 0;
    i2 = HEAP32[(HEAP32[i40 >> 2] | 0) + 256 >> 2] | 0;
    HEAP32[i39 >> 2] = i44;
    HEAP32[i17 >> 2] = HEAP32[i39 >> 2];
    mftCall_vii(i2 | 0, i40 | 0, i17 | 0);
    i2 = HEAP32[(HEAP32[i18 >> 2] | 0) + ((HEAP32[HEAP32[i19 >> 2] >> 2] | 0) * 360 | 0) + 188 >> 2] | 0;
    if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i40 >> 2] | 0) + 188 >> 2] | 0, i40 | 0, i2 | 0);
    HEAP32[i17 >> 2] = i21;
    HEAP32[i31 >> 2] = 0;
    HEAP32[i32 >> 2] = i7;
    HEAP32[i33 >> 2] = 0;
    HEAP32[i34 >> 2] = i6;
    mftCall_viiiiiii(HEAP32[(HEAP32[i41 >> 2] | 0) + 16 >> 2] | 0, i41 | 0, i27 | 0, i22 | 0, i24 | 0, i23 | 0, i17 | 0, 1);
    __Z15gpu_time_samplev();
    if (i3) __Z12profiler_endP19ProfilerInformation(i3);
   }
  } else i42 = 24;
  if ((i42 | 0) == 24) {
   i42 = 0;
   i3 = HEAP32[i38 >> 2] | 0;
   if ((HEAP16[gb + 1161680 + 6 >> 1] | 0) > -1) {
    HEAP32[i27 >> 2] = 0;
    HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161680 | 0, i17);
    i2 = gb + 1161680 | 0;
   } else i2 = 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
   if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
   HEAP32[i38 >> 2] = 0;
  }
 } while (i1 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
 STACKTOP = i43;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE6assignINS_11__wrap_iterIPS7_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISF_E9referenceEEE5valueEvE4typeESF_SF_(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i1 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i8 = i6 - i1 | 0;
 i9 = i8 >> 4;
 i10 = i11 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i1;
 i2 = i4;
 i13 = i6;
 if (i9 >>> 0 > i3 - i4 >> 4 >>> 0) {
  if (!i4) i2 = i3; else {
   i7 = i11 + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) i2 = i4; else {
    i6 = i15 + 4 | 0;
    i4 = i3;
    while (1) {
     i3 = i4 + -16 | 0;
     HEAP32[i7 >> 2] = i3;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i3 = HEAP32[i3 >> 2] | 0;
      i12 = HEAP32[i4 + -4 >> 2] | 0;
      HEAP32[i15 >> 2] = 1;
      HEAP32[i6 >> 2] = i12;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i15);
      i3 = HEAP32[i7 >> 2] | 0;
     }
     if ((i3 | 0) == (i2 | 0)) break; else i4 = i3;
    }
    i2 = HEAP32[i11 >> 2] | 0;
   }
   i12 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i15 >> 2] = 1;
   HEAP32[i15 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
  }
  if ((i8 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  } else i3 = 0;
  i12 = i2 - i3 | 0;
  i3 = i12 >> 3;
  i3 = i12 >> 4 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 1;
  HEAP32[i15 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  i8 = i11 + 4 | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i10 >> 2] = i2 + (i3 << 4);
  if ((i5 | 0) == (i13 | 0)) {
   STACKTOP = i16;
   return;
  }
  i7 = i15 + 4 | 0;
  while (1) {
   i3 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i4 = i2 + 12 | 0;
   HEAP32[i4 >> 2] = i3;
   if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i3 = HEAP32[i4 >> 2] | 0;
     i14 = 57;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i5;
     if (i5) i14 = 59;
    } else i14 = 57;
    if ((i14 | 0) == 57) {
     i11 = i5 + 16 & -16;
     HEAP32[i15 >> 2] = 1;
     HEAP32[i7 >> 2] = i3;
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i12;
     HEAP32[i2 + 8 >> 2] = i11 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i12;
     i14 = 59;
    }
    if ((i14 | 0) == 59) {
     i14 = 0;
     _memcpy(i2 | 0, i6 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
   } else {
    HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    i1 = i5;
   }
   i3 = i1 + 16 | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + 16 | 0;
   HEAP32[i8 >> 2] = i2;
   if ((i3 | 0) == (i13 | 0)) break; else {
    i1 = i3;
    i5 = i3;
   }
  }
  STACKTOP = i16;
  return;
 }
 i13 = i11 + 4 | 0;
 i1 = (HEAP32[i13 >> 2] | 0) - i4 >> 4;
 i11 = i9 >>> 0 > i1 >>> 0;
 i1 = i5 + (i1 << 4) | 0;
 i4 = i11 ? i1 : i6;
 if ((i5 | 0) == (i4 | 0)) i5 = i2; else {
  do {
   do if ((i2 | 0) != (i5 | 0)) {
    i10 = HEAP8[i5 + 11 >> 0] | 0;
    i7 = i10 << 24 >> 24 < 0;
    i9 = i7 ? HEAP32[i5 >> 2] | 0 : i5;
    i10 = i7 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255;
    i7 = i2 + 11 | 0;
    i3 = HEAP8[i7 >> 0] | 0;
    i6 = i3 << 24 >> 24 < 0;
    if (i6) i8 = (HEAP32[i2 + 8 >> 2] & 2147483647) + -1 | 0; else i8 = 10;
    if (i10 >>> 0 > i8 >>> 0) {
     if (i6) i3 = HEAP32[i2 + 4 >> 2] | 0; else i3 = i3 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i8, i10 - i8 | 0, i3, 0, i3, i10, i9);
     break;
    }
    if (i6) i3 = HEAP32[i2 >> 2] | 0; else i3 = i2;
    if (i10 | 0) _memmove(i3 | 0, i9 | 0, i10 | 0) | 0;
    HEAP8[i3 + i10 >> 0] = 0;
    if ((HEAP8[i7 >> 0] | 0) < 0) {
     HEAP32[i2 + 4 >> 2] = i10;
     break;
    } else {
     HEAP8[i7 >> 0] = i10;
     break;
    }
   } while (0);
   i5 = i5 + 16 | 0;
   i2 = i2 + 16 | 0;
  } while ((i5 | 0) != (i4 | 0));
  i5 = i2;
 }
 if (!i11) {
  i1 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i16;
   return;
  }
  i3 = i15 + 4 | 0;
  i2 = i1;
  while (1) {
   i1 = i2 + -16 | 0;
   HEAP32[i13 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i14 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i15 >> 2] = 1;
    HEAP32[i3 >> 2] = i14;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
    i1 = HEAP32[i13 >> 2] | 0;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
  STACKTOP = i16;
  return;
 }
 i7 = HEAP32[i12 >> 2] | 0;
 if ((i4 | 0) == (i7 | 0)) {
  STACKTOP = i16;
  return;
 }
 i8 = i15 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 while (1) {
  i3 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i5 = i2 + 12 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i6 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i3 = HEAP32[i5 >> 2] | 0;
    i14 = 28;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i4;
    if (i4) i14 = 30;
   } else i14 = 28;
   if ((i14 | 0) == 28) {
    i11 = i4 + 16 & -16;
    HEAP32[i15 >> 2] = 1;
    HEAP32[i8 >> 2] = i3;
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i12;
    HEAP32[i2 + 8 >> 2] = i11 | -2147483648;
    HEAP32[i2 + 4 >> 2] = i4;
    i2 = i12;
    i14 = 30;
   }
   if ((i14 | 0) == 30) {
    i14 = 0;
    _memcpy(i2 | 0, i6 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i1 = i4;
  }
  i3 = i1 + 16 | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + 16 | 0;
  HEAP32[i13 >> 2] = i2;
  if ((i3 | 0) == (i7 | 0)) break; else {
   i1 = i3;
   i4 = i3;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i12, i13, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, f17 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 252 | 0;
 i8 = i16 + 8 | 0;
 i1 = i16;
 i3 = i16 + 248 | 0;
 if ((HEAP16[gb + 1110460 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = i12;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110460 | 0, i7);
  i11 = gb + 1110460 | 0;
 } else i11 = 0;
 i15 = i12 + 1118 | 0;
 do if (!(HEAP8[i15 >> 0] | 0)) {
  f4 = Math_fround(HEAPF32[i12 + 872 >> 2]);
  if (!(f4 <= Math_fround(9.99999974e-06))) {
   f5 = Math_fround(HEAPF32[i12 + 876 >> 2]);
   if (!(f5 <= Math_fround(9.99999974e-06))) {
    f17 = Math_fround(HEAPF32[i12 + 864 >> 2]);
    if (!(f17 >= Math_fround(1.0)) & !(Math_fround(f4 + f17) <= Math_fround(0.0))) {
     f17 = Math_fround(HEAPF32[i12 + 868 >> 2]);
     if (!(f17 >= Math_fround(1.0)) & !(Math_fround(f5 + f17) <= Math_fround(0.0))) {
      f17 = Math_fround(HEAPF32[i12 + 924 >> 2]);
      f4 = Math_fround(HEAPF32[i12 + 920 >> 2]);
      if (!(f17 <= f4)) {
       if (!(HEAP8[i12 + 1088 >> 0] | 0)) {
        if (f4 <= Math_fround(0.0)) break;
        f17 = Math_fround(HEAPF32[i12 + 292 >> 2]);
        i9 = f17 < Math_fround(0.0);
        f5 = Math_fround(-f17);
        if ((i9 ? f5 : f17) < Math_fround(9.99999997e-07)) break;
       } else {
        f17 = Math_fround(HEAPF32[i12 + 916 >> 2]);
        i9 = f17 < Math_fround(0.0);
        f5 = Math_fround(-f17);
        if ((i9 ? f5 : f17) < Math_fround(9.99999997e-07)) break;
       }
       HEAP32[i7 >> 2] = 0;
       HEAP32[i7 + 4 >> 2] = 0;
       HEAP32[i7 + 8 >> 2] = 0;
       __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i12, gb + 1105356 | 0, i7);
       if (__Z17GetMonoManagerPtrv() | 0) {
        i2 = (__Z23GetCoreScriptingClassesv() | 0) + 104 | 0;
        i6 = HEAP32[i2 + 4 >> 2] | 0;
        i9 = i1;
        HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i9 + 4 >> 2] = i6;
        HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i8, i7);
        __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i8, __ZN9Scripting19ScriptingWrapperForEP6Object(i12) | 0);
        HEAP32[i7 >> 2] = 0;
        __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i8, i7, 0) | 0;
       }
       i1 = HEAP32[i12 + 28 >> 2] | 0;
       if (!i1) i10 = 19; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
        if (!(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 112 >> 2] | 0, i12 | 0) | 0)) i10 = 19;
       } else i10 = 19;
       if ((i10 | 0) == 19) if (!(HEAP32[i13 + 12 >> 2] & 1)) break;
       HEAP8[i15 >> 0] = 1;
       __ZN6Camera24PrepareCullingParametersERK23CameraCullingParameters13RenderingPathR11CullResults(i13, __ZNK6Camera22CalculateRenderingPathEv(i12) | 0, i14);
       i1 = __Z18GetITerrainManagerv() | 0;
       if (i1 | 0) if (HEAP32[i14 + 576 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, HEAP32[i13 >> 2] | 0, i14 + 384 | 0);
       if (!(HEAP8[i14 + 76 >> 0] | 0)) i9 = i14 + 384 | 0; else {
        i9 = i14 + 384 | 0;
        __Z24CullStaticSceneWithUmbraR8JobFenceRK22SceneCullingParametersR13CullingOutput(i14, i9, i14 + 16 | 0);
       }
       i2 = HEAP32[gb + 1114352 >> 2] | 0;
       i1 = HEAP32[i13 >> 2] | 0;
       if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
       HEAP32[i3 >> 2] = i1;
       HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
       __ZN19CullingGroupManager17CullAndSendEventsERK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK8JobFence(i2, i9, i7, i14 + 16 | 0, i14);
       __ZN8Renderer26UpdateAllRenderersInternalEb(0);
       __ZN13RendererScene22RecalculateDirtyBoundsEv(__Z16GetRendererScenev() | 0);
       __ZN6Camera38PrepareCullingParametersRendererArraysERK23CameraCullingParametersR11CullResults(i13, i14);
       i1 = i13 + 4 | 0;
       do if (!(HEAP32[i1 >> 2] | 0)) {
        i6 = i12 + 828 | 0;
        i1 = HEAP32[i6 >> 2] | 0;
        if (i1 | 0) {
         HEAP32[i8 >> 2] = i1;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
         do if (!i1) i10 = 36; else {
          if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
           i2 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[i1 + 32 >> 2] | 0;
           i1 = i2 + (i3 << 3) | 0;
          } else {
           __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
           i2 = HEAP32[i7 >> 2] | 0;
           i8 = HEAP32[i1 + 28 >> 2] | 0;
           i3 = HEAP32[gb + 1104264 >> 2] | 0;
           i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
           i2 = HEAP32[i3 + 28 >> 2] | 0;
           i3 = HEAP32[i3 + 32 >> 2] | 0;
          }
          if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
           i10 = 36;
           break;
          }
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i10 = 38;
         } while (0);
         if ((i10 | 0) == 36) i10 = 38;
         if ((i10 | 0) == 38) {
          i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
          if (!i1) break;
         }
         i2 = i12 + 832 | 0;
         HEAP32[i14 + 1360 >> 2] = i1;
         i10 = HEAP8[i2 + 11 >> 0] | 0;
         if (!((i10 << 24 >> 24 < 0 ? HEAP32[i12 + 836 >> 2] | 0 : i10 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
         HEAP32[i14 + 1364 >> 2] = i1;
        }
       } else {
        i7 = i1;
        i8 = HEAP32[i7 + 4 >> 2] | 0;
        i10 = i14 + 1360 | 0;
        HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i10 + 4 >> 2] = i8;
       } while (0);
       if (HEAP8[i14 + 1201 >> 0] | 0) {
        i10 = __ZnwjRK10MemLabelIdiPKci(956, gb + 64024 | 0, 16, gb + 375437 | 0, 1202) | 0;
        HEAP32[i10 + 944 >> 2] = 0;
        HEAP32[i10 + 948 >> 2] = -1;
        __Z19SetupShadowCullDataR6CameraRK17ShaderReplaceDataPK22SceneCullingParametersR14ShadowCullData(HEAP32[i13 >> 2] | 0, i14 + 1360 | 0, i9, i10);
        HEAP32[i14 + 1308 >> 2] = i10;
       }
       __Z9CullSceneR22SceneCullingParametersPK6CameraR11CullResults(i9, i12, i14);
       HEAP8[i14 + 1368 >> 0] = 1;
       HEAP8[i15 >> 0] = 0;
      }
     }
    }
   }
  }
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 375821 | 0, 0, gb + 375437 | 0, 1136, 1, HEAP32[i12 + 4 >> 2] | 0, 0, 0); while (0);
 if (!i11) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i16;
 return;
}

function __Z11CopyTextureP7TextureS0_(i14, i11) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 68 | 0;
 i12 = i18 + 64 | 0;
 i17 = i18 + 48 | 0;
 i4 = i18 + 40 | 0;
 i2 = i18 + 32 | 0;
 i3 = i18 + 8 | 0;
 i1 = i18;
 i15 = i18 + 60 | 0;
 i16 = i18 + 56 | 0;
 if (!i14) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 398064 | 0, 0, gb + 398117 | 0, 15, 1, 0, 0, 0);
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!i11) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 398190 | 0, 0, gb + 398117 | 0, 20, 1, 0, 0, 0);
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 148 >> 2] | 0, i14 | 0) | 0;
 if ((i10 | 0) != (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 148 >> 2] | 0, i11 | 0) | 0)) {
  i16 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 148 >> 2] | 0, i14 | 0) | 0;
  i17 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 148 >> 2] | 0, i11 | 0) | 0;
  HEAP32[i1 >> 2] = i16;
  HEAP32[i1 + 4 >> 2] = i17;
  __Z6FormatPKcz(i13, gb + 398248 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 398117 | 0, 239, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 100 >> 2] | 0, i14 | 0) | 0;
 if ((i10 | 0) == (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0) | 0)) {
  i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 104 >> 2] | 0, i14 | 0) | 0;
  if ((i10 | 0) == (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0)) {
   i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 144 >> 2] | 0, i14 | 0) | 0;
   if ((i10 | 0) == (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 144 >> 2] | 0, i11 | 0) | 0)) {
    i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 116 >> 2] | 0, i14 | 0) | 0;
    if ((i10 | 0) != (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0) | 0)) {
     i16 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 116 >> 2] | 0, i14 | 0) | 0;
     i17 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0) | 0;
     HEAP32[i2 >> 2] = i16;
     HEAP32[i2 + 4 >> 2] = i17;
     __Z6FormatPKcz(i13, gb + 398410 | 0, i2);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 398117 | 0, 252, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
     i17 = 0;
     STACKTOP = i18;
     return i17 | 0;
    }
    i9 = HEAP32[i14 + 48 >> 2] | 0;
    i10 = HEAP32[i11 + 48 >> 2] | 0;
    if ((i9 | 0) == (i10 | 0)) {
     __Z6FormatPKcz(i13, gb + 398482 | 0, i4);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 398117 | 0, 261, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
     i17 = 0;
     STACKTOP = i18;
     return i17 | 0;
    }
    i8 = i14 + 8 | 0;
    i5 = HEAP32[gb + 32032 + 24 >> 2] | 0;
    i6 = HEAP32[gb + 32032 + 28 >> 2] | 0;
    i1 = (((HEAP32[i8 >> 2] | 0) >>> 21) - i5 | 0) >>> 0 < i6 >>> 0 ? i14 : 0;
    i7 = i11 + 8 | 0;
    if ((i1 | 0) == 0 ? 1 : (((HEAP32[i7 >> 2] | 0) >>> 21) - i5 | 0) >>> 0 >= i6 >>> 0) {
     i4 = 0;
     i3 = 0;
     i2 = 0;
     i1 = 0;
    } else {
     __ZN9Texture2D18UnshareTextureDataEv(i1);
     i2 = i1 + 52 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) i4 = 0; else i4 = HEAP32[i1 + 8 >> 2] | 0;
     __ZN9Texture2D18UnshareTextureDataEv(i11);
     i6 = HEAP32[i11 + 52 >> 2] | 0;
     i5 = (i6 | 0) == 0;
     if (i5) i3 = 0; else i3 = HEAP32[i6 + 8 >> 2] | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) i2 = 0; else i2 = HEAP32[i1 + 40 >> 2] | 0;
     if (i5) i1 = 0; else i1 = HEAP32[i6 + 40 >> 2] | 0;
    }
    i5 = HEAP32[gb + 32072 + 24 >> 2] | 0;
    i6 = HEAP32[gb + 32072 + 28 >> 2] | 0;
    i7 = (HEAP32[i7 >> 2] | 0) >>> 21;
    if ((((HEAP32[i8 >> 2] | 0) >>> 21) - i5 | 0) >>> 0 < i6 >>> 0) if (!((i14 | 0) == 0 | (i7 - i5 | 0) >>> 0 >= i6 >>> 0)) {
     i4 = HEAP32[i14 + 96 >> 2] | 0;
     i3 = HEAP32[i11 + 96 >> 2] | 0;
     i2 = HEAP32[i14 + 100 >> 2] | 0;
     i1 = HEAP32[i11 + 100 >> 2] | 0;
    }
    i5 = HEAP32[gb + 32112 + 24 >> 2] | 0;
    i6 = HEAP32[gb + 32112 + 28 >> 2] | 0;
    if ((((HEAP32[i8 >> 2] | 0) >>> 21) - i5 | 0) >>> 0 < i6 >>> 0) if (!((i14 | 0) == 0 | (i7 - i5 | 0) >>> 0 >= i6 >>> 0)) {
     i4 = HEAP32[i14 + 96 >> 2] | 0;
     i3 = HEAP32[i11 + 96 >> 2] | 0;
     i2 = HEAP32[i14 + 100 >> 2] | 0;
     i1 = HEAP32[i11 + 100 >> 2] | 0;
    }
    do if ((i3 | 0) != 0 & (i4 | 0) != 0) {
     if ((i2 | 0) == (i1 | 0)) {
      _memcpy(i3 | 0, i4 | 0, i1 | 0) | 0;
      break;
     }
     HEAP32[i17 >> 2] = i2;
     HEAP32[i17 + 4 >> 2] = i1;
     __Z6FormatPKcz(i13, gb + 398575 | 0, i17);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 398117 | 0, 123, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
     i17 = 0;
     STACKTOP = i18;
     return i17 | 0;
    } while (0);
    i17 = __Z12GetGfxDevicev() | 0;
    i14 = HEAP32[(HEAP32[i17 >> 2] | 0) + 468 >> 2] | 0;
    HEAP32[i15 >> 2] = i9;
    HEAP32[i16 >> 2] = i10;
    HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
    mftCall_viii(i14 | 0, i17 | 0, i12 | 0, i13 | 0);
    i17 = 1;
    STACKTOP = i18;
    return i17 | 0;
   }
  }
 }
 i9 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 100 >> 2] | 0, i14 | 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 104 >> 2] | 0, i14 | 0) | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 144 >> 2] | 0, i14 | 0) | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0) | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0;
 i17 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 144 >> 2] | 0, i11 | 0) | 0;
 HEAP32[i3 >> 2] = i9;
 HEAP32[i3 + 4 >> 2] = i10;
 HEAP32[i3 + 8 >> 2] = i12;
 HEAP32[i3 + 12 >> 2] = i15;
 HEAP32[i3 + 16 >> 2] = i16;
 HEAP32[i3 + 20 >> 2] = i17;
 __Z6FormatPKcz(i13, gb + 398323 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 398117 | 0, 246, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i17 = 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN15b2FrictionJoint23InitVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i26 = HEAP32[i1 + 48 >> 2] | 0;
 i15 = HEAP32[i26 + 8 >> 2] | 0;
 i13 = i1 + 104 | 0;
 HEAP32[i13 >> 2] = i15;
 i8 = HEAP32[i1 + 52 >> 2] | 0;
 i33 = HEAP32[i8 + 8 >> 2] | 0;
 i7 = i1 + 108 | 0;
 HEAP32[i7 >> 2] = i33;
 i31 = i26 + 28 | 0;
 i32 = HEAP32[i31 >> 2] | 0;
 i31 = HEAP32[i31 + 4 >> 2] | 0;
 i29 = i1 + 128 | 0;
 HEAP32[i29 >> 2] = i32;
 HEAP32[i29 + 4 >> 2] = i31;
 i29 = i8 + 28 | 0;
 i30 = HEAP32[i29 >> 2] | 0;
 i29 = HEAP32[i29 + 4 >> 2] | 0;
 i28 = i1 + 136 | 0;
 HEAP32[i28 >> 2] = i30;
 HEAP32[i28 + 4 >> 2] = i29;
 i28 = HEAP32[i26 + 120 >> 2] | 0;
 HEAP32[i1 + 144 >> 2] = i28;
 i27 = HEAP32[i8 + 120 >> 2] | 0;
 HEAP32[i1 + 148 >> 2] = i27;
 i26 = HEAP32[i26 + 128 >> 2] | 0;
 HEAP32[i1 + 152 >> 2] = i26;
 i8 = HEAP32[i8 + 128 >> 2] | 0;
 HEAP32[i1 + 156 >> 2] = i8;
 i14 = HEAP32[i2 + 24 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i14 + (i15 * 12 | 0) + 8 >> 2]);
 i9 = i2 + 28 | 0;
 i34 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[i34 + (i15 * 12 | 0) >> 2] | 0;
 i11 = HEAP32[i34 + (i15 * 12 | 0) + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i34 + (i15 * 12 | 0) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i14 + (i33 * 12 | 0) + 8 >> 2]);
 i14 = HEAP32[i34 + (i33 * 12 | 0) >> 2] | 0;
 i15 = HEAP32[i34 + (i33 * 12 | 0) + 4 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i34 + (i33 * 12 | 0) + 8 >> 2]);
 f19 = Math_fround(+Math_sin(+f4));
 f4 = Math_fround(+Math_cos(+f4));
 f5 = Math_fround(+Math_sin(+f3));
 f3 = Math_fround(+Math_cos(+f3));
 f20 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f18 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f18 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(Math_fround(f4 * f20) - Math_fround(f19 * f18));
 f18 = Math_fround(Math_fround(f19 * f20) + Math_fround(f4 * f18));
 HEAPF32[i1 + 112 >> 2] = f17;
 HEAPF32[i1 + 116 >> 2] = f18;
 f4 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f4 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(Math_fround(f3 * f4) - Math_fround(f5 * f20));
 f20 = Math_fround(Math_fround(f5 * f4) + Math_fround(f3 * f20));
 HEAPF32[i1 + 120 >> 2] = f19;
 HEAPF32[i1 + 124 >> 2] = f20;
 f3 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f3 + f4);
 f21 = Math_fround(Math_fround(f25 + Math_fround(f18 * Math_fround(f5 * f18))) + Math_fround(f20 * Math_fround(f6 * f20)));
 f23 = Math_fround(f5 * f17);
 f24 = Math_fround(f6 * f19);
 f22 = Math_fround(Math_fround(-Math_fround(f18 * f23)) - Math_fround(f20 * f24));
 f24 = Math_fround(Math_fround(f25 + Math_fround(f17 * f23)) + Math_fround(f19 * f24));
 f23 = Math_fround(Math_fround(f21 * f24) - Math_fround(f22 * f22));
 i8 = f23 != Math_fround(0.0);
 f25 = Math_fround(Math_fround(1.0) / f23);
 f23 = i8 ? f25 : f23;
 f22 = Math_fround(-Math_fround(f22 * f23));
 f21 = Math_fround(f21 * f23);
 HEAPF32[i1 + 160 >> 2] = Math_fround(f24 * f23);
 HEAPF32[i1 + 164 >> 2] = f22;
 HEAPF32[i1 + 168 >> 2] = f22;
 HEAPF32[i1 + 172 >> 2] = f21;
 f21 = Math_fround(f5 + f6);
 i8 = f21 > Math_fround(0.0);
 f22 = Math_fround(Math_fround(1.0) / f21);
 HEAPF32[i1 + 176 >> 2] = i8 ? f22 : f21;
 i8 = i1 + 84 | 0;
 if (!(HEAP8[i2 + 20 >> 0] | 0)) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
  f24 = f12;
  f25 = f16;
  i30 = i14;
  i28 = i10;
  i33 = i15;
  i32 = i11;
  i34 = HEAP32[i13 >> 2] | 0;
  i31 = HEAP32[i9 >> 2] | 0;
  i29 = i31 + (i34 * 12 | 0) | 0;
  HEAP32[i29 >> 2] = i28;
  i34 = i31 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i32;
  i34 = HEAP32[i13 >> 2] | 0;
  i32 = HEAP32[i9 >> 2] | 0;
  i34 = i32 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f24;
  i34 = HEAP32[i7 >> 2] | 0;
  i31 = i32 + (i34 * 12 | 0) | 0;
  HEAP32[i31 >> 2] = i30;
  i34 = i32 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i33;
  i34 = HEAP32[i7 >> 2] | 0;
  i33 = HEAP32[i9 >> 2] | 0;
  i34 = i33 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f25;
  return;
 } else {
  f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f25 = Math_fround(f21 * Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i8 >> 2] = f25;
  i28 = i1 + 88 | 0;
  f22 = Math_fround(f21 * Math_fround(HEAPF32[i28 >> 2]));
  HEAPF32[i28 >> 2] = f22;
  i28 = i1 + 92 | 0;
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i28 >> 2]));
  HEAPF32[i28 >> 2] = f21;
  f23 = Math_fround(f3 * f25);
  f24 = Math_fround(f3 * f22);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
  i28 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f24);
  i32 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  f24 = Math_fround(f12 - Math_fround(f5 * Math_fround(f21 + Math_fround(Math_fround(f22 * f17) - Math_fround(f25 * f18)))));
  f18 = Math_fround(f4 * f25);
  f23 = Math_fround(f4 * f22);
  f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f18);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f23);
  f25 = Math_fround(f16 + Math_fround(f6 * Math_fround(f21 + Math_fround(Math_fround(f22 * f19) - Math_fround(f25 * f20)))));
  i33 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i34 = HEAP32[i13 >> 2] | 0;
  i31 = HEAP32[i9 >> 2] | 0;
  i29 = i31 + (i34 * 12 | 0) | 0;
  HEAP32[i29 >> 2] = i28;
  i34 = i31 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i32;
  i34 = HEAP32[i13 >> 2] | 0;
  i32 = HEAP32[i9 >> 2] | 0;
  i34 = i32 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f24;
  i34 = HEAP32[i7 >> 2] | 0;
  i31 = i32 + (i34 * 12 | 0) | 0;
  HEAP32[i31 >> 2] = i30;
  i34 = i32 + (i34 * 12 | 0) + 4 | 0;
  HEAP32[i34 >> 2] = i33;
  i34 = HEAP32[i7 >> 2] | 0;
  i33 = HEAP32[i9 >> 2] | 0;
  i34 = i33 + (i34 * 12 | 0) + 8 | 0;
  HEAPF32[i34 >> 2] = f25;
  return;
 }
}

function __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i3);
 i1 = i5 + 204 | 0;
 i6 = i3 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i3 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 205 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i3);
 i1 = i5 + 116 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 120 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 124 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 128 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 132 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 136 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 144 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 148 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 152 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 156 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 160 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 164 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 180 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 184 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 188 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 140 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 168 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 172 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 176 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 200 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 196 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 193 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 192 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 206 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  return;
 }
}

function __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 switch (i2 | 0) {
 case 1:
  {
   i6 = i3 + (HEAP32[i4 >> 2] << 6) | 0;
   return i6 | 0;
  }
 case 2:
  {
   f8 = Math_fround(HEAPF32[i5 >> 2]);
   f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   i6 = HEAP32[i5 + 12 >> 2] | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 4 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 4 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 8 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 8 >> 2])));
   HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 16 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 16 >> 2])));
   HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 20 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 20 >> 2])));
   HEAPF32[i1 + 24 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 24 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 24 >> 2])));
   HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 32 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 32 >> 2])));
   HEAPF32[i1 + 36 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 36 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 36 >> 2])));
   HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 40 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 40 >> 2])));
   HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 48 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 48 >> 2])));
   HEAPF32[i1 + 52 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 52 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 52 >> 2])));
   HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i3 + (i4 << 6) + 56 >> 2])) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i6 << 6) + 56 >> 2])));
   i6 = i1;
   return i6 | 0;
  }
 case 4:
  {
   f10 = Math_fround(HEAPF32[i6 >> 2]);
   f9 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   i4 = HEAP32[i6 + 20 >> 2] | 0;
   i5 = HEAP32[i6 + 24 >> 2] | 0;
   i6 = HEAP32[i6 + 28 >> 2] | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 4 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 4 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 4 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 4 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 8 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 8 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 8 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 8 >> 2])));
   HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 16 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 16 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 16 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 16 >> 2])));
   HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 20 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 20 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 20 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 20 >> 2])));
   HEAPF32[i1 + 24 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 24 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 24 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 24 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 24 >> 2])));
   HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 32 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 32 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 32 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 32 >> 2])));
   HEAPF32[i1 + 36 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 36 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 36 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 36 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 36 >> 2])));
   HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 40 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 40 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 40 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 40 >> 2])));
   HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 48 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 48 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 48 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 48 >> 2])));
   HEAPF32[i1 + 52 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 52 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 52 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 52 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 52 >> 2])));
   HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 6) + 56 >> 2])) + Math_fround(f9 * Math_fround(HEAPF32[i3 + (i4 << 6) + 56 >> 2]))) + Math_fround(f7 * Math_fround(HEAPF32[i3 + (i5 << 6) + 56 >> 2]))) + Math_fround(f8 * Math_fround(HEAPF32[i3 + (i6 << 6) + 56 >> 2])));
   i6 = i1;
   return i6 | 0;
  }
 default:
  {
   i6 = 0;
   return i6 | 0;
  }
 }
 return 0;
}

function __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode1EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f22, i23, i29, i1, i30) {
 f22 = Math_fround(f22);
 i23 = i23 | 0;
 i29 = i29 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i35 + 32 | 0;
 i32 = i35 + 16 | 0;
 i33 = i35;
 i34 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i34) {
  STACKTOP = i35;
  return;
 }
 i24 = i1 + 500 | 0;
 i25 = i33 + 4 | 0;
 i26 = i33 + 8 | 0;
 i27 = i33 + 12 | 0;
 i28 = i29 + 84 | 0;
 i2 = i1 + 520 | 0;
 i3 = i23 + 32 | 0;
 i4 = i23 + 4 | 0;
 i5 = i23 + 8 | 0;
 i6 = i23 + 12 | 0;
 i7 = i23 + 16 | 0;
 i8 = i23 + 20 | 0;
 i9 = i23 + 24 | 0;
 i10 = i23 + 28 | 0;
 i11 = i31 + 4 | 0;
 i12 = i31 + 8 | 0;
 i13 = i31 + 12 | 0;
 i14 = i29 + 80 | 0;
 i15 = i29 + 232 | 0;
 i16 = i29 + 144 | 0;
 i1 = 0;
 do {
  i36 = (HEAP32[i24 >> 2] | 0) + (i1 << 2) | 0;
  i42 = HEAP32[i36 >> 2] | 0;
  i40 = HEAP32[i36 + 4 >> 2] | 0;
  i38 = HEAP32[i36 + 8 >> 2] | 0;
  i36 = HEAP32[i36 + 12 >> 2] | 0;
  HEAP32[i32 >> 2] = 0;
  HEAP32[i32 + 4 >> 2] = 0;
  HEAP32[i32 + 8 >> 2] = 0;
  HEAP32[i32 + 12 >> 2] = 0;
  i42 = i42 + 1454627760 | 0;
  i40 = i40 + 1454627760 | 0;
  i38 = i38 + 1454627760 | 0;
  i36 = i36 + 1454627760 | 0;
  i41 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
  i39 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i38, 1790253981) | 0) + 1900727103 | 0;
  i21 = (Math_imul(i36, 1790253981) | 0) + 1900727103 | 0;
  i42 = i42 << 11 ^ i42;
  i40 = i40 << 11 ^ i40;
  i38 = i38 << 11 ^ i38;
  i36 = i36 << 11 ^ i36;
  f17 = Math_fround(Math_fround((i41 ^ i42 ^ i42 >>> 8) & 8388607 ^ i41 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f18 = Math_fround(Math_fround((i39 ^ i40 ^ i40 >>> 8) & 8388607 ^ i39 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f19 = Math_fround(Math_fround((i37 ^ i38 ^ i38 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f20 = Math_fround(Math_fround((i21 ^ i36 ^ i36 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i33 >> 2] = f17;
  HEAPF32[i25 >> 2] = f18;
  HEAPF32[i26 >> 2] = f19;
  HEAPF32[i27 >> 2] = f20;
  i21 = HEAP32[i28 >> 2] | 0;
  L6 : do switch ((i21 & 65535) << 16 >> 16) {
  case 0:
   {
    i42 = HEAP32[i14 >> 2] | 0;
    HEAP32[i13 >> 2] = i42;
    HEAP32[i12 >> 2] = i42;
    HEAP32[i11 >> 2] = i42;
    HEAP32[i31 >> 2] = i42;
    break;
   }
  case 3:
   {
    f44 = Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 4 >> 2]);
    f43 = Math_fround(HEAPF32[i14 >> 2]);
    f44 = Math_fround(f44 * f43);
    f43 = Math_fround(Math_fround(f43 * Math_fround(HEAPF32[(HEAP32[i16 >> 2] | 0) + 4 >> 2])) - f44);
    f18 = Math_fround(f44 + Math_fround(f43 * f18));
    f19 = Math_fround(f44 + Math_fround(f43 * f19));
    f20 = Math_fround(f44 + Math_fround(f20 * f43));
    HEAPF32[i31 >> 2] = Math_fround(f44 + Math_fround(f17 * f43));
    HEAPF32[i11 >> 2] = f18;
    HEAPF32[i12 >> 2] = f19;
    HEAPF32[i13 >> 2] = f20;
    break;
   }
  default:
   if (!(i21 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i31, i29, i32, i33);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i31, i29, i32, i33);
    break L6;
   }
  } while (0);
  i42 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f51 = Math_fround(HEAPF32[i42 >> 2]);
  f49 = Math_fround(HEAPF32[i42 + 4 >> 2]);
  f47 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  f51 = Math_fround(f51 * Math_fround(.00999999977));
  f49 = Math_fround(f49 * Math_fround(.00999999977));
  f47 = Math_fround(f47 * Math_fround(.00999999977));
  f45 = Math_fround(Math_fround(HEAPF32[i42 + 12 >> 2]) * Math_fround(.00999999977));
  f17 = Math_fround(HEAPF32[i3 >> 2]);
  f56 = Math_fround(HEAPF32[i23 >> 2]);
  f19 = Math_fround(f51 * f56);
  f20 = Math_fround(f49 * f56);
  f43 = Math_fround(f47 * f56);
  f56 = Math_fround(f45 * f56);
  f44 = Math_fround(HEAPF32[i4 >> 2]);
  f19 = Math_fround(f51 * Math_fround(f19 + f44));
  f20 = Math_fround(f49 * Math_fround(f20 + f44));
  f43 = Math_fround(f47 * Math_fround(f43 + f44));
  f44 = Math_fround(f45 * Math_fround(f56 + f44));
  f56 = Math_fround(HEAPF32[i5 >> 2]);
  f19 = Math_fround(f51 * Math_fround(f56 + f19));
  f20 = Math_fround(f49 * Math_fround(f56 + f20));
  f43 = Math_fround(f47 * Math_fround(f56 + f43));
  f44 = Math_fround(f45 * Math_fround(f56 + f44));
  f56 = Math_fround(HEAPF32[i6 >> 2]);
  f19 = Math_fround(f56 + f19);
  f20 = Math_fround(f56 + f20);
  f43 = Math_fround(f56 + f43);
  f44 = Math_fround(f56 + f44);
  f56 = Math_fround(f51 - f17);
  f55 = Math_fround(f49 - f17);
  f54 = Math_fround(f47 - f17);
  f53 = Math_fround(f45 - f17);
  f52 = Math_fround(HEAPF32[i7 >> 2]);
  f50 = Math_fround(f56 * f52);
  f48 = Math_fround(f55 * f52);
  f46 = Math_fround(f54 * f52);
  f52 = Math_fround(f53 * f52);
  f18 = Math_fround(HEAPF32[i8 >> 2]);
  f50 = Math_fround(f56 * Math_fround(f50 + f18));
  f48 = Math_fround(f55 * Math_fround(f48 + f18));
  f46 = Math_fround(f54 * Math_fround(f46 + f18));
  f18 = Math_fround(f53 * Math_fround(f52 + f18));
  f52 = Math_fround(HEAPF32[i9 >> 2]);
  f50 = Math_fround(f56 * Math_fround(f52 + f50));
  f48 = Math_fround(f55 * Math_fround(f52 + f48));
  f46 = Math_fround(f54 * Math_fround(f52 + f46));
  f18 = Math_fround(f53 * Math_fround(f52 + f18));
  f52 = Math_fround(HEAPF32[i10 >> 2]);
  f50 = Math_fround(f52 + f50);
  f48 = Math_fround(f52 + f48);
  f46 = Math_fround(f52 + f46);
  f18 = Math_fround(f52 + f18);
  f19 = Math_fround((f51 > f17 ? f50 : f19) * f22);
  f20 = Math_fround((f49 > f17 ? f48 : f20) * f22);
  f43 = Math_fround((f47 > f17 ? f46 : f43) * f22);
  f44 = Math_fround((f45 > f17 ? f18 : f44) * f22);
  i42 = i30 + (i1 << 2) | 0;
  f19 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) + f19);
  f20 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f20);
  f43 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f43);
  f44 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f44);
  f20 = Math_fround(f20 - Math_fround(Math_floor(Math_fround(f20))));
  f43 = Math_fround(f43 - Math_fround(Math_floor(Math_fround(f43))));
  f44 = Math_fround(f44 - Math_fround(Math_floor(Math_fround(f44))));
  HEAPF32[i42 >> 2] = Math_fround(f19 - Math_fround(Math_floor(Math_fround(f19))));
  HEAPF32[i42 + 4 >> 2] = f20;
  HEAPF32[i42 + 8 >> 2] = f43;
  HEAPF32[i42 + 12 >> 2] = f44;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i34 >>> 0);
 STACKTOP = i35;
 return;
}

function __ZN7Terrain11GetRendererEPK6Camerab(i16, i11, i3) {
 i16 = i16 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i22 + 40 | 0;
 i14 = i22 + 28 | 0;
 i18 = i22;
 i12 = i22 + 32 | 0;
 i19 = i22 + 24 | 0;
 i20 = i22 + 12 | 0;
 i6 = i16 + 28 | 0;
 if (!(1 << HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] & HEAP32[i11 + 880 >> 2])) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i17 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
 i7 = i16 + 228 | 0;
 i10 = i16 + 240 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i5 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = i5 + (i1 * 20 | 0) | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i11 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) break L4;
  }
  HEAP32[i5 + (i1 * 20 | 0) + 16 >> 2] = i17;
  i21 = i2;
  STACKTOP = i22;
  return i21 | 0;
 } while (0);
 if (!i3) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i13 = i16 + 48 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 HEAP32[i14 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i21 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i14);
   i2 = HEAP32[i15 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 14; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i21 = 16;
 }
 if ((i21 | 0) == 14) i21 = 16;
 if ((i21 | 0) == 16) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[i6 >> 2] | 0, 0, 0) | 0;
 __ZNK9Transform11GetPositionEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
 HEAP32[i10 >> 2] = i1;
 i2 = i16 + 244 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 * 20 | 0, 4, i16 + 232 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i8;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i16 + 232 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i8;
  break;
 } else i8 = HEAP32[i7 >> 2] | 0; while (0);
 i6 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 i7 = i8 + (i6 * 20 | 0) | 0;
 HEAP32[i7 >> 2] = i11;
 i5 = __ZnwjRK10MemLabelIdiPKci(240, gb + 63616 | 0, 16, gb + 930687 | 0, 437) | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
 __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f(i5, 0, i15, i18);
 i4 = i8 + (i6 * 20 | 0) + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 i5 = __ZnwjRK10MemLabelIdiPKci(440, gb + 63616 | 0, 16, gb + 930687 | 0, 438) | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i21 = 27; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i14);
   i2 = HEAP32[i15 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 27; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i21 = 29;
  }
 }
 if ((i21 | 0) == 27) i21 = 29;
 if ((i21 | 0) == 29) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
 __ZN12TreeRendererC2ER12TreeDatabaseRK8Vector3f(i5, i1 + 84 | 0, i18);
 i21 = i8 + (i6 * 20 | 0) + 8 | 0;
 HEAP32[i21 >> 2] = i5;
 i14 = __ZnwjRK10MemLabelIdiPKci(120, gb + 63616 | 0, 16, gb + 930687 | 0, 439) | 0;
 HEAP32[i19 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 __ZN14DetailRendererC2E4PPtrI11TerrainDataE8Vector3f(i14, i15, i20);
 i20 = i8 + (i6 * 20 | 0) + 12 | 0;
 HEAP32[i20 >> 2] = i14;
 i14 = HEAP32[i4 >> 2] | 0;
 HEAP32[i14 + 112 >> 2] = HEAP32[i16 + 116 >> 2];
 i13 = i16 + 152 | 0;
 HEAP32[i14 + 108 >> 2] = HEAP32[i13 >> 2];
 HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] = HEAP32[i13 >> 2];
 i13 = HEAP32[i16 + 120 >> 2] | 0;
 i14 = HEAP32[i16 + 124 >> 2] | 0;
 i15 = HEAP32[i16 + 128 >> 2] | 0;
 i18 = HEAP32[i16 + 132 >> 2] | 0;
 i19 = HEAP32[i4 >> 2] | 0;
 HEAP32[i19 + 76 >> 2] = i13;
 HEAP32[i19 + 80 >> 2] = i14;
 HEAP32[i19 + 84 >> 2] = i15;
 HEAP32[i19 + 88 >> 2] = i18;
 i19 = HEAP32[i20 >> 2] | 0;
 HEAP32[i19 + 32 >> 2] = i13;
 HEAP32[i19 + 36 >> 2] = i14;
 HEAP32[i19 + 40 >> 2] = i15;
 HEAP32[i19 + 44 >> 2] = i18;
 f27 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f28 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f23 = Math_fround(HEAPF32[i16 + 140 >> 2]);
 f24 = Math_fround(HEAPF32[i16 + 136 >> 2]);
 f26 = Math_fround(f24 * Math_fround(HEAPF32[i16 + 156 >> 2]));
 f25 = Math_fround(f23 * Math_fround(HEAPF32[i16 + 160 >> 2]));
 f24 = Math_fround(f28 + Math_fround(f24 * Math_fround(HEAPF32[i16 + 164 >> 2])));
 f23 = Math_fround(f27 + Math_fround(f23 * Math_fround(HEAPF32[i16 + 168 >> 2])));
 i19 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i19 + 92 >> 2] = f26;
 HEAPF32[i19 + 96 >> 2] = f25;
 HEAPF32[i19 + 100 >> 2] = f24;
 HEAPF32[i19 + 104 >> 2] = f23;
 i20 = HEAP32[i20 >> 2] | 0;
 HEAPF32[i20 + 48 >> 2] = f26;
 HEAPF32[i20 + 52 >> 2] = f25;
 HEAPF32[i20 + 56 >> 2] = f24;
 HEAPF32[i20 + 60 >> 2] = f23;
 HEAP32[(HEAP32[i21 >> 2] | 0) + 360 >> 2] = HEAP32[i16 + 196 >> 2];
 HEAP32[i8 + (i6 * 20 | 0) + 16 >> 2] = i17;
 if (!i9) {
  i21 = i7;
  STACKTOP = i22;
  return i21 | 0;
 }
 __Z19pop_allocation_rootv();
 i21 = i7;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5physx2Gu11HeightField34parseTrianglesForCollisionVerticesEt(i30, i29) {
 i30 = i30 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i33 + 24 | 0;
 i32 = i33;
 i25 = i30 + 20 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i27 = i30 + 16 | 0;
 i28 = HEAP32[i27 >> 2] | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = 0;
 HEAP32[i32 + 16 >> 2] = 0;
 i5 = (i26 + 32 | 0) >>> 5;
 i1 = i32 + 4 | 0;
 if (!i5) {
  i1 = 0;
  i2 = 0;
 } else {
  HEAP32[i1 >> 2] = i5;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32 + 8 | 0, i5 << 2, gb + 769739 | 0, 352) | 0;
  HEAP32[i32 >> 2] = i2;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
 i4 = i32 + 12 | 0;
 i3 = i32 + 16 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i5 >>> 0 > (i2 & 2147483647) >>> 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) > -1 & (i1 | 0) != 0) {
   i24 = i32 + 20 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i1);
   i1 = i24;
  } else i1 = i32 + 20 | 0;
  HEAP32[i3 >> 2] = i5;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i5 << 2, gb + 769739 | 0, 352) | 0;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 } else i1 = HEAP32[i4 >> 2] | 0;
 _memset(i1 | 0, 0, i2 << 2 | 0) | 0;
 i24 = (i26 | 0) == 0;
 if (!i24) {
  i3 = i30 + 36 | 0;
  i4 = i29 & 65535;
  i5 = i30 + 48 | 0;
  i8 = i30 + 40 | 0;
  i9 = i30 + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i10 = 0;
  do {
   if (((HEAPU8[i1 + (i10 << 2) + 3 >> 0] & 127 | 0) == (i4 | 0) ? 1 : (HEAPU8[i1 + (i10 << 2) + 2 >> 0] & 127 | 0) == (i4 | 0)) | 0) {
    i23 = HEAP32[i32 >> 2] | 0;
    i22 = i23 + (i10 >>> 5 << 2) | 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | 1 << (i10 & 31);
    i22 = i10 + 1 | 0;
    i23 = i23 + (i22 >>> 5 << 2) | 0;
    HEAP32[i23 >> 2] = HEAP32[i23 >> 2] | 1 << (i22 & 31);
   }
   L19 : do if (!(HEAP16[i5 >> 1] & 1)) {
    do if (__ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb(i30, i10, 0, i10, i29, i11) | 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     i31 = 24;
    } else {
     i1 = HEAP32[i3 >> 2] | 0;
     if (!(HEAP8[i11 >> 0] | 0)) {
      i31 = 25;
      break L19;
     }
     i2 = HEAP16[i1 + (i10 << 2) >> 1] << 1;
     if (!i10) i31 = 24; else if (((HEAP32[i25 >> 2] | 0) + -1 | 0) >>> 0 > i10 >>> 0) {
      i2 = i2 - (HEAP16[i1 + (i10 + 1 << 2) >> 1] | 0) - (HEAP16[i1 + (i10 + -1 << 2) >> 1] | 0) | 0;
      if ((i2 | 0) > -1) {
       i31 = 25;
       break L19;
      }
      f7 = Math_fround(i2 | 0);
      i23 = !(Math_fround(HEAPF32[i8 >> 2]) <= Math_fround(0.0));
      f6 = Math_fround(HEAPF32[i9 >> 2]);
      if (i23) {
       i2 = i1 + (i10 << 2) + 3 | 0;
       if (f7 < Math_fround(-f6)) break; else {
        i31 = 28;
        break L19;
       }
      } else {
       i2 = i1 + (i10 << 2) + 3 | 0;
       if (f7 > f6) break; else {
        i31 = 28;
        break L19;
       }
      }
     } else i31 = 24;
    } while (0);
    if ((i31 | 0) == 24) {
     i31 = 0;
     i2 = i1 + (i10 << 2) + 3 | 0;
    }
    HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 128;
   } else i31 = 25; while (0);
   if ((i31 | 0) == 25) {
    i2 = i1 + (i10 << 2) + 3 | 0;
    i31 = 28;
   }
   if ((i31 | 0) == 28) {
    i31 = 0;
    HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] & 127;
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i26 | 0));
 }
 if (i28 >>> 0 > 1) {
  i14 = i30 + 36 | 0;
  i15 = i29 & 65535;
  i16 = i26 + -1 | 0;
  i17 = i28 + -1 | 0;
  i18 = i30 + 40 | 0;
  i19 = i30 + 44 | 0;
  i20 = 0;
  i22 = 1;
  i23 = 1;
  while (1) {
   i10 = Math_imul(i22, i26) | 0;
   if (!i24) {
    i11 = (i22 | 0) == (i17 | 0);
    i12 = i32 + (i20 * 12 | 0) | 0;
    i13 = i32 + (i23 * 12 | 0) | 0;
    i1 = HEAP32[i14 >> 2] | 0;
    i21 = 0;
    do {
     i4 = i21 + i10 | 0;
     i8 = i1 + (i4 << 2) + 3 | 0;
     i9 = HEAPU8[i8 >> 0] | 0;
     if (((i9 & 127 | 0) == (i15 | 0) ? 1 : (HEAPU8[i1 + (i4 << 2) + 2 >> 0] & 127 | 0) == (i15 | 0)) | 0) {
      i35 = 1 << (i21 & 31);
      i34 = i21 >>> 5;
      i2 = HEAP32[i12 >> 2] | 0;
      i5 = i2 + (i34 << 2) | 0;
      HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i35;
      i5 = i21 + 1 | 0;
      i3 = 1 << (i5 & 31);
      i5 = i5 >>> 5;
      i2 = i2 + (i5 << 2) | 0;
      HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i3;
      i2 = HEAP32[i13 >> 2] | 0;
      i34 = i2 + (i34 << 2) | 0;
      HEAP32[i34 >> 2] = HEAP32[i34 >> 2] | i35;
      i5 = i2 + (i5 << 2) | 0;
      HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i3;
     }
     L51 : do if (i11 | ((i21 | 0) == 0 | (i21 | 0) == (i16 | 0))) i31 = 37; else if (!(HEAP32[(HEAP32[i12 >> 2] | 0) + (i21 >>> 5 << 2) >> 2] & 1 << (i21 & 31))) {
      i2 = HEAP16[i1 + (i4 << 2) >> 1] << 1;
      if (((HEAP32[i27 >> 2] | 0) + -1 | 0) >>> 0 > i22 >>> 0) {
       i5 = HEAP32[i25 >> 2] | 0;
       i5 = i2 - (HEAP16[i1 + (i5 + i4 << 2) >> 1] | 0) - (HEAP16[i1 + (i4 - i5 << 2) >> 1] | 0) | 0;
       i3 = 1;
      } else {
       i5 = 0;
       i3 = 0;
      }
      if (((HEAP32[i25 >> 2] | 0) + -1 | 0) >>> 0 > i21 >>> 0) {
       i2 = i2 - (HEAP16[i1 + (i4 + 1 << 2) >> 1] | 0) - (HEAP16[i1 + (i4 + -1 << 2) >> 1] | 0) | 0;
       i31 = 45;
      } else if (i3) {
       i2 = 0;
       i31 = 45;
      }
      do if ((i31 | 0) == 45) {
       i31 = 0;
       if ((i2 ^ i5 | 0) > -1) break L51;
       f6 = Math_fround(i2 + i5 | 0);
       i35 = !(Math_fround(HEAPF32[i18 >> 2]) <= Math_fround(0.0));
       f7 = Math_fround(HEAPF32[i19 >> 2]);
       if (i35) if (f6 < Math_fround(-f7)) break; else break L51; else if (f6 > f7) break; else break L51;
      } while (0);
      HEAP8[i8 >> 0] = i9 | 128;
     } else i31 = 37; while (0);
     do if ((i31 | 0) == 37) {
      i31 = 0;
      i35 = __ZNK5physx2Gu11HeightField22isCollisionVertexPrecaEjjjt(i30, i4, i22, i21, i29) | 0;
      i1 = HEAP32[i14 >> 2] | 0;
      i2 = i1 + (i4 << 2) + 3 | 0;
      i3 = HEAPU8[i2 >> 0] | 0;
      if (i35) {
       HEAP8[i2 >> 0] = i3 | 128;
       break;
      } else {
       HEAP8[i2 >> 0] = i3 & 127;
       break;
      }
     } while (0);
     i21 = i21 + 1 | 0;
    } while ((i21 | 0) != (i26 | 0));
   }
   _memset(HEAP32[i32 + (i20 * 12 | 0) >> 2] | 0, 0, HEAP32[i32 + (i20 * 12 | 0) + 4 >> 2] << 2 | 0) | 0;
   i22 = i22 + 1 | 0;
   if ((i22 | 0) == (i28 | 0)) break; else {
    i20 = i20 ^ 1;
    i23 = i23 ^ 1;
   }
  }
 }
 i1 = HEAP32[i32 + 12 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i32 + 16 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32 + 20 | 0, i1);
 i1 = HEAP32[i32 >> 2] | 0;
 if (!i1) {
  STACKTOP = i33;
  return;
 }
 if ((HEAP32[i32 + 4 >> 2] | 0) <= -1) {
  STACKTOP = i33;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i32 + 8 | 0, i1);
 STACKTOP = i33;
 return;
}

function __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i2, i3, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, i49 = 0, f50 = f0, i51 = 0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0;
 if (i3 >>> 0 >= i14 >>> 0) return;
 i12 = i1 + 80 | 0;
 i13 = HEAP32[i2 + 120 >> 2] | 0;
 i8 = HEAP32[i2 + 140 >> 2] | 0;
 i9 = HEAP32[i2 + 160 >> 2] | 0;
 i10 = HEAP32[i2 + 60 >> 2] | 0;
 i11 = i2 + 80 | 0;
 i4 = i2 + 100 | 0;
 i5 = i15 + 4 | 0;
 i6 = i15 + 8 | 0;
 i7 = i15 + 12 | 0;
 i1 = i3;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 do {
  f53 = Math_fround(HEAPF32[i12 >> 2]);
  i30 = i13 + (i1 << 2) | 0;
  f31 = Math_fround(HEAPF32[i30 >> 2]);
  f29 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i30 + 12 >> 2]);
  i30 = i8 + (i1 << 2) | 0;
  f24 = Math_fround(HEAPF32[i30 >> 2]);
  f23 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i30 + 12 >> 2]);
  i30 = i9 + (i1 << 2) | 0;
  f20 = Math_fround(HEAPF32[i30 >> 2]);
  f19 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  f17 = Math_fround(HEAPF32[i30 + 12 >> 2]);
  i30 = i10 + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i30 + 4 | 0;
  f45 = Math_fround(HEAPF32[i28 >> 2]);
  i26 = i30 + 8 | 0;
  f44 = Math_fround(HEAPF32[i26 >> 2]);
  i16 = i30 + 12 | 0;
  f43 = Math_fround(HEAPF32[i16 >> 2]);
  i51 = i2 + (i1 << 2) | 0;
  f42 = Math_fround(HEAPF32[i51 >> 2]);
  f41 = Math_fround(HEAPF32[i51 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i51 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i51 + 12 >> 2]);
  i51 = i3 + (i1 << 2) | 0;
  f52 = Math_fround(HEAPF32[i51 >> 2]);
  f55 = Math_fround(HEAPF32[i51 + 4 >> 2]);
  f57 = Math_fround(HEAPF32[i51 + 8 >> 2]);
  f32 = Math_fround(f31 + f32);
  f45 = Math_fround(f29 + f45);
  f44 = Math_fround(f27 + f44);
  f43 = Math_fround(f25 + f43);
  f42 = Math_fround(f24 + f42);
  f41 = Math_fround(f23 + f41);
  f40 = Math_fround(f22 + f40);
  f39 = Math_fround(f21 + f39);
  f52 = Math_fround(f20 + f52);
  f55 = Math_fround(f19 + f55);
  f57 = Math_fround(f18 + f57);
  f59 = Math_fround(f17 + Math_fround(HEAPF32[i51 + 12 >> 2]));
  f54 = Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f42 * f42)) + Math_fround(f52 * f52));
  f56 = Math_fround(Math_fround(Math_fround(f45 * f45) + Math_fround(f41 * f41)) + Math_fround(f55 * f55));
  f58 = Math_fround(Math_fround(Math_fround(f44 * f44) + Math_fround(f40 * f40)) + Math_fround(f57 * f57));
  f60 = Math_fround(Math_fround(Math_fround(f43 * f43) + Math_fround(f39 * f39)) + Math_fround(f59 * f59));
  f38 = Math_fround(Math_sqrt(Math_fround(f54)));
  f50 = Math_fround(Math_fround(1.0) / f38);
  f37 = Math_fround(Math_sqrt(Math_fround(f56)));
  f48 = Math_fround(Math_fround(1.0) / f37);
  f36 = Math_fround(Math_sqrt(Math_fround(f58)));
  f46 = Math_fround(Math_fround(1.0) / f36);
  f33 = Math_fround(Math_sqrt(Math_fround(f60)));
  f34 = Math_fround(Math_fround(1.0) / f33);
  f32 = Math_fround(f32 * f50);
  f45 = Math_fround(f45 * f48);
  f44 = Math_fround(f44 * f46);
  f43 = Math_fround(f43 * f34);
  f42 = Math_fround(f42 * f50);
  f41 = Math_fround(f41 * f48);
  f40 = Math_fround(f40 * f46);
  f39 = Math_fround(f39 * f34);
  f50 = Math_fround(f52 * f50);
  f48 = Math_fround(f55 * f48);
  f46 = Math_fround(f57 * f46);
  f34 = Math_fround(f59 * f34);
  i51 = f54 > Math_fround(9.99999974e-06);
  i49 = f56 > Math_fround(9.99999974e-06);
  i47 = f58 > Math_fround(9.99999974e-06);
  i35 = f60 > Math_fround(9.99999974e-06);
  f60 = Math_fround((f38 > Math_fround(0.0) & 1) - (f38 < Math_fround(0.0) & 1) | 0);
  f58 = Math_fround((f37 > Math_fround(0.0) & 1) - (f37 < Math_fround(0.0) & 1) | 0);
  f56 = Math_fround((f36 > Math_fround(0.0) & 1) - (f36 < Math_fround(0.0) & 1) | 0);
  f54 = Math_fround((f33 > Math_fround(0.0) & 1) - (f33 < Math_fround(0.0) & 1) | 0);
  f38 = Math_fround(Math_abs(Math_fround(f38)));
  f37 = Math_fround(Math_abs(Math_fround(f37)));
  f36 = Math_fround(Math_abs(Math_fround(f36)));
  f33 = Math_fround(Math_abs(Math_fround(f33)));
  f59 = Math_fround(f53 - f38);
  f57 = Math_fround(f53 - f37);
  f55 = Math_fround(f53 - f36);
  f52 = Math_fround(f53 - f33);
  f59 = Math_fround(f59 * Math_fround(HEAPF32[i15 >> 2]));
  f57 = Math_fround(f57 * Math_fround(HEAPF32[i5 >> 2]));
  f55 = Math_fround(f55 * Math_fround(HEAPF32[i6 >> 2]));
  f59 = Math_fround(f38 + f59);
  f57 = Math_fround(f37 + f57);
  f55 = Math_fround(f36 + f55);
  f52 = Math_fround(f33 + Math_fround(f52 * Math_fround(HEAPF32[i7 >> 2])));
  f38 = Math_fround(f60 * (f38 > f53 ? f59 : f38));
  f37 = Math_fround(f58 * (f37 > f53 ? f57 : f37));
  f36 = Math_fround(f56 * (f36 > f53 ? f55 : f36));
  f33 = Math_fround(f54 * (f33 > f53 ? f52 : f33));
  f32 = Math_fround((i51 ? f32 : Math_fround(0.0)) * f38);
  f45 = Math_fround((i49 ? f45 : Math_fround(0.0)) * f37);
  f44 = Math_fround((i47 ? f44 : Math_fround(0.0)) * f36);
  f43 = Math_fround((i35 ? f43 : Math_fround(0.0)) * f33);
  f42 = Math_fround((i51 ? f42 : Math_fround(0.0)) * f38);
  f41 = Math_fround((i49 ? f41 : Math_fround(0.0)) * f37);
  f40 = Math_fround((i47 ? f40 : Math_fround(0.0)) * f36);
  f39 = Math_fround((i35 ? f39 : Math_fround(0.0)) * f33);
  f38 = Math_fround((i51 ? f50 : Math_fround(0.0)) * f38);
  f37 = Math_fround((i49 ? f48 : Math_fround(0.0)) * f37);
  f36 = Math_fround((i47 ? f46 : Math_fround(0.0)) * f36);
  f29 = Math_fround(f45 - f29);
  f27 = Math_fround(f44 - f27);
  f25 = Math_fround(f43 - f25);
  f24 = Math_fround(f42 - f24);
  f23 = Math_fround(f41 - f23);
  f22 = Math_fround(f40 - f22);
  f21 = Math_fround(f39 - f21);
  f20 = Math_fround(f38 - f20);
  f19 = Math_fround(f37 - f19);
  f18 = Math_fround(f36 - f18);
  f17 = Math_fround(Math_fround((i35 ? f34 : Math_fround(0.0)) * f33) - f17);
  HEAPF32[i30 >> 2] = Math_fround(f32 - f31);
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i26 >> 2] = f27;
  HEAPF32[i16 >> 2] = f25;
  i2 = HEAP32[i11 >> 2] | 0;
  i16 = i2 + (i1 << 2) | 0;
  HEAPF32[i16 >> 2] = f24;
  HEAPF32[i16 + 4 >> 2] = f23;
  HEAPF32[i16 + 8 >> 2] = f22;
  HEAPF32[i16 + 12 >> 2] = f21;
  i3 = HEAP32[i4 >> 2] | 0;
  i16 = i3 + (i1 << 2) | 0;
  HEAPF32[i16 >> 2] = f20;
  HEAPF32[i16 + 4 >> 2] = f19;
  HEAPF32[i16 + 8 >> 2] = f18;
  HEAPF32[i16 + 12 >> 2] = f17;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i14 >>> 0);
 return;
}

function __ZN15ReflectionProbe8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 44 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 48 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 56 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 64 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 68 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 72 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 80 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 88 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 92 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 108 | 0, i6);
 i1 = i5 + 100 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 140 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 141 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 142 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 143 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 60 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i7 >> 2] = i2;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZN14dense_hash_mapIy9PlaneDataN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorENSt3__28equal_toIyEE13stl_allocatorINS3_4pairIKyS0_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERS8_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 128 | 0;
 i8 = i9;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i6 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i8 = i6 + 16 | 0;
  i7 = i6 + 8 | 0;
  HEAP8[i7 >> 0] = 1;
  i7 = i8;
  HEAP32[i7 >> 2] = i4;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i5;
  STACKTOP = i9;
  return;
 }
 i49 = i8 + 4 | 0;
 HEAP32[i49 >> 2] = 0;
 i46 = i8 + 8 | 0;
 i2 = i6 + 8 | 0;
 i47 = HEAP16[i2 >> 1] | 0;
 HEAP8[i46 >> 0] = i47;
 i48 = i8 + 9 | 0;
 HEAP8[i48 >> 0] = (i47 & 65535) >>> 8;
 i47 = i8 + 16 | 0;
 i3 = i6 + 16 | 0;
 i42 = i3;
 i56 = HEAP32[i42 + 4 >> 2] | 0;
 i45 = i47;
 HEAP32[i45 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i45 + 4 >> 2] = i56;
 i45 = i8 + 24 | 0;
 i56 = i6 + 24 | 0;
 HEAP32[i45 >> 2] = HEAP32[i56 >> 2];
 i42 = i8 + 28 | 0;
 i55 = i6 + 28 | 0;
 HEAP32[i42 >> 2] = HEAP32[i55 >> 2];
 i15 = i8 + 32 | 0;
 i54 = i6 + 32 | 0;
 HEAP32[i15 >> 2] = HEAP32[i54 >> 2];
 i20 = i8 + 36 | 0;
 i53 = i6 + 36 | 0;
 HEAP32[i20 >> 2] = HEAP32[i53 >> 2];
 i24 = i8 + 40 | 0;
 i51 = i6 + 40 | 0;
 HEAP32[i24 >> 2] = HEAP32[i51 >> 2];
 i28 = i8 + 44 | 0;
 i52 = i6 + 44 | 0;
 HEAP32[i28 >> 2] = HEAP32[i52 >> 2];
 i32 = i8 + 48 | 0;
 i50 = i6 + 48 | 0;
 i27 = i50;
 i41 = HEAP32[i27 + 4 >> 2] | 0;
 i31 = i32;
 HEAP32[i31 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i31 + 4 >> 2] = i41;
 i31 = i8 + 56 | 0;
 i41 = i6 + 56 | 0;
 i27 = i41;
 i40 = HEAP32[i27 + 4 >> 2] | 0;
 i29 = i31;
 HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i29 + 4 >> 2] = i40;
 i29 = i8 + 64 | 0;
 i40 = i6 + 64 | 0;
 HEAP32[i29 >> 2] = HEAP32[i40 >> 2];
 i27 = i8 + 68 | 0;
 i39 = i6 + 68 | 0;
 HEAP32[i27 >> 2] = HEAP32[i39 >> 2];
 i25 = i8 + 72 | 0;
 i38 = i6 + 72 | 0;
 HEAP32[i25 >> 2] = HEAP32[i38 >> 2];
 i23 = i8 + 76 | 0;
 i37 = i6 + 76 | 0;
 HEAP32[i23 >> 2] = HEAP32[i37 >> 2];
 i21 = i8 + 80 | 0;
 i35 = i6 + 80 | 0;
 HEAP32[i21 >> 2] = HEAP32[i35 >> 2];
 i19 = i8 + 84 | 0;
 i36 = i6 + 84 | 0;
 HEAP32[i19 >> 2] = HEAP32[i36 >> 2];
 i14 = i8 + 88 | 0;
 i34 = i6 + 88 | 0;
 i16 = i34;
 i18 = HEAP32[i16 + 4 >> 2] | 0;
 i17 = i14;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i8 + 96 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i8 + 100 | 0;
 HEAP32[i18 >> 2] = 0;
 i16 = i8 + 104 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i8 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 112 | 0;
 HEAP32[i13 >> 2] = 0;
 i11 = i8 + 108 | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i8 + 116 | 0;
 HEAP8[i10 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i8, i6, 0);
 i44 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i49 >> 2];
 HEAP32[i49 >> 2] = i44;
 i49 = HEAP8[i2 >> 0] | 0;
 i44 = HEAP16[i46 >> 1] | 0;
 HEAP8[i2 >> 0] = i44;
 HEAP8[i46 >> 0] = i49;
 i46 = i6 + 9 | 0;
 i49 = HEAP8[i46 >> 0] | 0;
 HEAP8[i46 >> 0] = (i44 & 65535) >>> 8;
 HEAP8[i48 >> 0] = i49;
 i48 = i3;
 i49 = HEAP32[i48 >> 2] | 0;
 i48 = HEAP32[i48 + 4 >> 2] | 0;
 i46 = HEAP32[i56 >> 2] | 0;
 i44 = HEAP32[i55 >> 2] | 0;
 i43 = HEAP32[i54 >> 2] | 0;
 i1 = HEAP32[i53 >> 2] | 0;
 i22 = HEAP32[i51 >> 2] | 0;
 i26 = HEAP32[i52 >> 2] | 0;
 i33 = i50;
 i30 = HEAP32[i33 >> 2] | 0;
 i33 = HEAP32[i33 + 4 >> 2] | 0;
 i59 = i47;
 i58 = HEAP32[i59 + 4 >> 2] | 0;
 i57 = i3;
 HEAP32[i57 >> 2] = HEAP32[i59 >> 2];
 HEAP32[i57 + 4 >> 2] = i58;
 HEAP32[i56 >> 2] = HEAP32[i45 >> 2];
 HEAP32[i55 >> 2] = HEAP32[i42 >> 2];
 HEAP32[i54 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i53 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i51 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i52 >> 2] = HEAP32[i28 >> 2];
 i52 = i32;
 i51 = HEAP32[i52 + 4 >> 2] | 0;
 HEAP32[i50 >> 2] = HEAP32[i52 >> 2];
 HEAP32[i50 + 4 >> 2] = i51;
 HEAP32[i47 >> 2] = i49;
 HEAP32[i47 + 4 >> 2] = i48;
 HEAP32[i45 >> 2] = i46;
 HEAP32[i42 >> 2] = i44;
 HEAP32[i15 >> 2] = i43;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i24 >> 2] = i22;
 HEAP32[i28 >> 2] = i26;
 HEAP32[i32 >> 2] = i30;
 HEAP32[i32 + 4 >> 2] = i33;
 i32 = i41;
 i33 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 4 >> 2] | 0;
 i30 = HEAP32[i40 >> 2] | 0;
 i28 = HEAP32[i39 >> 2] | 0;
 i26 = HEAP32[i38 >> 2] | 0;
 i24 = HEAP32[i37 >> 2] | 0;
 i22 = HEAP32[i35 >> 2] | 0;
 i20 = HEAP32[i36 >> 2] | 0;
 i1 = i34;
 i15 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i43 = i31;
 i42 = HEAP32[i43 + 4 >> 2] | 0;
 HEAP32[i41 >> 2] = HEAP32[i43 >> 2];
 HEAP32[i41 + 4 >> 2] = i42;
 HEAP32[i40 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i39 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i38 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i37 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i35 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i36 >> 2] = HEAP32[i19 >> 2];
 i36 = i14;
 i35 = HEAP32[i36 + 4 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i34 + 4 >> 2] = i35;
 HEAP32[i31 >> 2] = i33;
 HEAP32[i31 + 4 >> 2] = i32;
 HEAP32[i29 >> 2] = i30;
 HEAP32[i27 >> 2] = i28;
 HEAP32[i25 >> 2] = i26;
 HEAP32[i23 >> 2] = i24;
 HEAP32[i21 >> 2] = i22;
 HEAP32[i19 >> 2] = i20;
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i1;
 i14 = i6 + 96 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i1;
 i17 = i6 + 100 | 0;
 i14 = HEAP32[i17 >> 2] | 0;
 i15 = HEAP32[i18 >> 2] | 0;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i18 >> 2] = i14;
 i18 = i6 + 104 | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i17;
 f12 = Math_fround(i15 >>> 0);
 HEAP32[i6 + 112 >> 2] = ~~Math_fround(f12 * Math_fround(.5)) >>> 0;
 HEAP32[i6 + 108 >> 2] = ~~Math_fround(f12 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 + 116 >> 0] = 0;
 f12 = Math_fround(i14 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f12 * Math_fround(.5)) >>> 0;
 HEAP32[i11 >> 2] = ~~Math_fround(f12 * Math_fround(.200000003)) >>> 0;
 HEAP8[i10 >> 0] = 0;
 if (i1 | 0) {
  i59 = HEAP32[i8 + 120 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i59;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 i59 = i3;
 i58 = i2;
 HEAP8[i58 >> 0] = 1;
 i58 = i59;
 HEAP32[i58 >> 2] = i4;
 i59 = i59 + 4 | 0;
 HEAP32[i59 >> 2] = i5;
 STACKTOP = i9;
 return;
}

function __Z26TransformVerticesInnerLoopILb0ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i6, i27, i2, i3, i7, i1, i28, i29, i8, i30, i5, i4) {
 i6 = i6 | 0;
 i27 = i27 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i8 = i8 | 0;
 i30 = i30 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i26 = (i5 | 0) / 4 | 0;
 i1 = (i4 & 1 | 0) == 0;
 if (i1) {
  i10 = 0;
  i11 = 0;
  i9 = 0;
 } else {
  i10 = HEAP32[i2 + 24 >> 2] | 0;
  i11 = HEAP32[i2 + 28 >> 2] | 0;
  i9 = HEAP32[i2 + 32 >> 2] | 0;
 }
 i2 = i3 + -1 | 0;
 if (!i3) return;
 i14 = i27 + 16 | 0;
 i15 = i27 + 32 | 0;
 i16 = i27 + 48 | 0;
 i17 = i27 + 4 | 0;
 i18 = i27 + 20 | 0;
 i19 = i27 + 36 | 0;
 i20 = i27 + 52 | 0;
 i21 = i27 + 8 | 0;
 i22 = i27 + 24 | 0;
 i23 = i27 + 40 | 0;
 i24 = i27 + 56 | 0;
 i25 = (i4 & 2 | 0) == 0;
 i13 = (i4 & 4 | 0) == 0;
 i12 = (i5 | 0) > 3;
 if (i1) {
  i3 = i6;
  i5 = i8;
  i6 = i2;
  while (1) {
   f34 = Math_fround(HEAPF32[i27 >> 2]);
   f34 = Math_fround(f34 * Math_fround(HEAPF32[i7 >> 2]));
   f33 = Math_fround(HEAPF32[i14 >> 2]);
   i1 = i7 + 4 | 0;
   f32 = Math_fround(HEAPF32[i1 >> 2]);
   f33 = Math_fround(f34 + Math_fround(f33 * f32));
   f34 = Math_fround(HEAPF32[i15 >> 2]);
   f31 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f34 = Math_fround(f33 + Math_fround(f34 * f31));
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f34);
   f34 = Math_fround(HEAPF32[i17 >> 2]);
   f33 = Math_fround(HEAPF32[i7 >> 2]);
   f34 = Math_fround(f34 * f33);
   f32 = Math_fround(f34 + Math_fround(f32 * Math_fround(HEAPF32[i18 >> 2])));
   f32 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i19 >> 2])));
   HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f32);
   f33 = Math_fround(f33 * Math_fround(HEAPF32[i21 >> 2]));
   f32 = Math_fround(HEAPF32[i22 >> 2]);
   f32 = Math_fround(f33 + Math_fround(f32 * Math_fround(HEAPF32[i1 >> 2])));
   f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f31);
   i1 = i3 + 12 | 0;
   if (!i25) {
    HEAP32[i1 >> 2] = -1;
    i1 = i3 + 16 | 0;
   }
   if (!i13) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i1 + 8 | 0;
   }
   if (!i5) i2 = 0; else {
    if (i12) {
     i4 = 0;
     i2 = i1;
     i3 = i5;
     while (1) {
      i1 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i26 | 0)) break; else {
       i2 = i1;
       i3 = i3 + 4 | 0;
      }
     }
    }
    i2 = i5 + i30 | 0;
   }
   i11 = i7 + i28 | 0;
   f31 = Math_fround(HEAPF32[i27 >> 2]);
   f31 = Math_fround(f31 * Math_fround(HEAPF32[i11 >> 2]));
   f32 = Math_fround(HEAPF32[i14 >> 2]);
   i10 = i11 + 4 | 0;
   f33 = Math_fround(HEAPF32[i10 >> 2]);
   f32 = Math_fround(f31 + Math_fround(f32 * f33));
   f31 = Math_fround(HEAPF32[i15 >> 2]);
   f34 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   HEAPF32[i1 >> 2] = Math_fround(f32 + Math_fround(f31 * f34));
   f31 = Math_fround(HEAPF32[i17 >> 2]);
   f32 = Math_fround(HEAPF32[i11 >> 2]);
   f31 = Math_fround(f31 * f32);
   f33 = Math_fround(f31 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i19 >> 2])));
   f32 = Math_fround(f32 * Math_fround(HEAPF32[i21 >> 2]));
   f33 = Math_fround(HEAPF32[i22 >> 2]);
   f33 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i10 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2])));
   HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   if (!i6) break; else {
    i3 = i1 + 16 | 0;
    i7 = i7 + i29 | 0;
    i5 = i2;
    i6 = i6 + -1 | 0;
   }
  }
  return;
 } else {
  i3 = i6;
  i5 = i8;
  i6 = i2;
  while (1) {
   f31 = Math_fround(HEAPF32[i27 >> 2]);
   f31 = Math_fround(f31 * Math_fround(HEAPF32[i7 >> 2]));
   f32 = Math_fround(HEAPF32[i14 >> 2]);
   i1 = i7 + 4 | 0;
   f33 = Math_fround(HEAPF32[i1 >> 2]);
   f32 = Math_fround(f31 + Math_fround(f32 * f33));
   f31 = Math_fround(HEAPF32[i15 >> 2]);
   f34 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f31 = Math_fround(f32 + Math_fround(f31 * f34));
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f31);
   f31 = Math_fround(HEAPF32[i17 >> 2]);
   f32 = Math_fround(HEAPF32[i7 >> 2]);
   f31 = Math_fround(f31 * f32);
   f33 = Math_fround(f31 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2])));
   f33 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i19 >> 2])));
   HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f33);
   f32 = Math_fround(f32 * Math_fround(HEAPF32[i21 >> 2]));
   f33 = Math_fround(HEAPF32[i22 >> 2]);
   f33 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i1 >> 2])));
   f34 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f34);
   HEAP32[i3 + 12 >> 2] = i10;
   HEAP32[i3 + 16 >> 2] = i11;
   HEAP32[i3 + 20 >> 2] = i9;
   i1 = i3 + 24 | 0;
   if (!i25) {
    HEAP32[i1 >> 2] = -1;
    i1 = i3 + 28 | 0;
   }
   if (!i13) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i1 + 8 | 0;
   }
   if (!i5) i2 = 0; else {
    if (i12) {
     i4 = 0;
     i2 = i1;
     i3 = i5;
     while (1) {
      i1 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i26 | 0)) break; else {
       i2 = i1;
       i3 = i3 + 4 | 0;
      }
     }
    }
    i2 = i5 + i30 | 0;
   }
   i8 = i7 + i28 | 0;
   f31 = Math_fround(HEAPF32[i27 >> 2]);
   f31 = Math_fround(f31 * Math_fround(HEAPF32[i8 >> 2]));
   f32 = Math_fround(HEAPF32[i14 >> 2]);
   i5 = i8 + 4 | 0;
   f33 = Math_fround(HEAPF32[i5 >> 2]);
   f32 = Math_fround(f31 + Math_fround(f32 * f33));
   f31 = Math_fround(HEAPF32[i15 >> 2]);
   f34 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   HEAPF32[i1 >> 2] = Math_fround(f32 + Math_fround(f31 * f34));
   f31 = Math_fround(HEAPF32[i17 >> 2]);
   f32 = Math_fround(HEAPF32[i8 >> 2]);
   f31 = Math_fround(f31 * f32);
   f33 = Math_fround(f31 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i19 >> 2])));
   f32 = Math_fround(f32 * Math_fround(HEAPF32[i21 >> 2]));
   f33 = Math_fround(HEAPF32[i22 >> 2]);
   f33 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i5 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2])));
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   if (!i6) break; else {
    i3 = i1 + 16 | 0;
    i7 = i7 + i29 | 0;
    i5 = i2;
    i6 = i6 + -1 | 0;
   }
  }
  return;
 }
}

function __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i17, i16) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 8 | 0;
 i13 = i19 + 4 | 0;
 i14 = i19;
 i18 = i17 + 48 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i19;
  return;
 }
 if (HEAP8[i17 + 34 >> 0] | 0) {
  i11 = HEAP32[i17 + 28 >> 2] | 0;
  do if (i2 | 0) {
   HEAP32[i13 >> 2] = i2;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i4 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i15 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i15 = 11;
   }
   if ((i15 | 0) == 9) i15 = 11;
   if ((i15 | 0) == 11) {
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i18 >> 2] | 0) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
   if (!i1) i15 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i15 = 20;
    }
   }
   if ((i15 | 0) == 18) i15 = 20;
   if ((i15 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i18 >> 2] | 0) | 0;
   if (!i11) i8 = 0; else i8 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = HEAP32[i1 + 352 >> 2] | 0;
   i10 = i1 + 356 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i1 = i9 - i3 >> 2;
   i2 = i9;
   if (!i1) i5 = i3; else {
    i4 = i3;
    i5 = i3;
    while (1) {
     i20 = (i1 | 0) / 2 | 0;
     i7 = i5 + (i20 << 2) | 0;
     i6 = (HEAP32[i7 >> 2] | 0) < (i8 | 0);
     i7 = i7 + 4 | 0;
     i3 = i6 ? i7 : i4;
     i1 = i6 ? i1 + -1 - i20 | 0 : i20;
     if (!i1) {
      i5 = i3;
      break;
     } else {
      i4 = i3;
      i5 = i6 ? i7 : i5;
     }
    }
   }
   if ((i5 | 0) != (i2 | 0)) if ((i8 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    i3 = i5 + 4 | 0;
    i1 = i9 - i3 | 0;
    i4 = i1 >> 2;
    if (i4) {
     _memmove(i5 | 0, i3 | 0, i1 | 0) | 0;
     i2 = HEAP32[i10 >> 2] | 0;
    }
    i1 = i5 + (i4 << 2) | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   }
  } while (0);
  i1 = HEAP32[i16 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i13 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 37; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i20 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
     i3 = HEAP32[i20 + 28 >> 2] | 0;
     i4 = HEAP32[i20 + 32 >> 2] | 0;
     i1 = i20;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 37; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i15 = 39;
   }
   if ((i15 | 0) == 37) i15 = 39;
   if ((i15 | 0) == 39) {
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i16 >> 2] | 0) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
   if (!i1) i15 = 46; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i20 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 46; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i15 = 48;
    }
   }
   if ((i15 | 0) == 46) i15 = 48;
   if ((i15 | 0) == 48) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i16 >> 2] | 0) | 0;
   i8 = i1 + 352 | 0;
   if (!i11) i7 = 0; else i7 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i7;
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i1 + 356 >> 2] | 0;
   i1 = i6 - i2 >> 2;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i20 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i20 << 2) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
     i4 = i4 + 4 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i20 | 0 : i20;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   i2 = i1;
   if ((i1 | 0) == (i6 | 0)) i15 = 55; else if ((i7 | 0) < (HEAP32[i1 >> 2] | 0)) i15 = 55;
   if ((i15 | 0) == 55) {
    HEAP32[i13 >> 2] = i2;
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i8, i12, i14) | 0;
   }
  } while (0);
  i2 = HEAP32[i17 + 112 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   HEAP32[i2 >> 2] = i3;
   __ZN14SplatMaterials15UpdateMaterialsEv(i2);
   i1 = HEAP32[i16 >> 2] | 0;
  }
 }
 HEAP32[i18 >> 2] = i1;
 __ZN7Terrain5FlushEv(i17);
 STACKTOP = i19;
 return;
}

function __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0;
 f47 = Math_fround(HEAPF32[i1 >> 2]);
 f50 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f48 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f49 = Math_fround(-f47);
 f5 = Math_fround(-f50);
 f6 = Math_fround(-f48);
 f46 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f45 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f44 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f43 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f42 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f41 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f40 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 f39 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 f38 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i29 = HEAP32[i3 + 12 >> 2] | 0;
 f28 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 i25 = HEAP32[i3 + 28 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 f37 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f35 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f34 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f33 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f21 = Math_fround(Math_fround(f28 * f6) + Math_fround(f24 * f50));
 f20 = Math_fround(Math_fround(f27 * f6) + Math_fround(f23 * f50));
 f19 = Math_fround(Math_fround(f26 * f6) + Math_fround(f22 * f50));
 f18 = Math_fround(Math_fround(f24 * f49) + Math_fround(f32 * f48));
 f17 = Math_fround(Math_fround(f23 * f49) + Math_fround(f31 * f48));
 f16 = Math_fround(Math_fround(f22 * f49) + Math_fround(f30 * f48));
 f15 = Math_fround(Math_fround(f32 * f5) + Math_fround(f28 * f47));
 f14 = Math_fround(Math_fround(f31 * f5) + Math_fround(f27 * f47));
 f13 = Math_fround(Math_fround(f30 * f5) + Math_fround(f26 * f47));
 f12 = Math_fround(Math_fround(Math_fround(f46 * Math_fround(0.0)) + Math_fround(Math_fround(f45 * f6) + Math_fround(f44 * f50))) + Math_fround(Math_fround(Math_fround(f50 * f19) + Math_fround(Math_fround(f20 * f6) + Math_fround(f21 * Math_fround(0.0)))) * Math_fround(.5)));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * Math_fround(0.0)) + Math_fround(f41 * f49)) + Math_fround(f43 * f48)) + Math_fround(Math_fround(Math_fround(f16 * f49) + Math_fround(Math_fround(f17 * Math_fround(0.0)) + Math_fround(f48 * f18))) * Math_fround(.5)));
 f4 = Math_fround(Math_fround(Math_fround(f40 * f5) + Math_fround(Math_fround(f38 * Math_fround(0.0)) + Math_fround(f39 * f47))) + Math_fround(Math_fround(Math_fround(f13 * Math_fround(0.0)) + Math_fround(Math_fround(f47 * f14) + Math_fround(f15 * f5))) * Math_fround(.5)));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f45 * Math_fround(0.0)) + Math_fround(f44 * f49)) + Math_fround(f46 * f48)) + Math_fround(Math_fround(Math_fround(f19 * f49) + Math_fround(Math_fround(f20 * Math_fround(0.0)) + Math_fround(f48 * f21))) * Math_fround(.5))) + Math_fround(Math_fround(Math_fround(f43 * Math_fround(0.0)) + Math_fround(Math_fround(f42 * f6) + Math_fround(f41 * f50))) + Math_fround(Math_fround(Math_fround(f50 * f16) + Math_fround(Math_fround(f17 * f6) + Math_fround(f18 * Math_fround(0.0)))) * Math_fround(.5))));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * Math_fround(0.0)) + Math_fround(Math_fround(f39 * f6) + Math_fround(f38 * f50))) + Math_fround(Math_fround(Math_fround(f50 * f13) + Math_fround(Math_fround(f14 * f6) + Math_fround(f15 * Math_fround(0.0)))) * Math_fround(.5))) + Math_fround(Math_fround(Math_fround(f46 * f5) + Math_fround(Math_fround(f44 * Math_fround(0.0)) + Math_fround(f45 * f47))) + Math_fround(Math_fround(Math_fround(f19 * Math_fround(0.0)) + Math_fround(Math_fround(f47 * f20) + Math_fround(f21 * f5))) * Math_fround(.5))));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f39 * Math_fround(0.0)) + Math_fround(f38 * f49)) + Math_fround(f40 * f48)) + Math_fround(Math_fround(Math_fround(f13 * f49) + Math_fround(Math_fround(f14 * Math_fround(0.0)) + Math_fround(f15 * f48))) * Math_fround(.5))) + Math_fround(Math_fround(Math_fround(f43 * f5) + Math_fround(Math_fround(f41 * Math_fround(0.0)) + Math_fround(f42 * f47))) + Math_fround(Math_fround(Math_fround(f16 * Math_fround(0.0)) + Math_fround(Math_fround(f47 * f17) + Math_fround(f18 * f5))) * Math_fround(.5))));
 f21 = Math_fround(f46 + f21);
 f20 = Math_fround(f45 + f20);
 f19 = Math_fround(f44 + f19);
 f18 = Math_fround(f43 + f18);
 f17 = Math_fround(f42 + f17);
 f16 = Math_fround(f41 + f16);
 f15 = Math_fround(f40 + f15);
 f14 = Math_fround(f39 + f14);
 f13 = Math_fround(f38 + f13);
 f12 = Math_fround(f37 + Math_fround(f12 + f12));
 f11 = Math_fround(f11 + f9);
 f10 = Math_fround(f10 + f6);
 f9 = Math_fround(f36 + f9);
 f8 = Math_fround(f35 + Math_fround(f8 + f8));
 f7 = Math_fround(f7 + f5);
 f6 = Math_fround(f34 + f6);
 f5 = Math_fround(f33 + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 136 >> 2]) + Math_fround(f4 + f4));
 HEAPF32[i2 >> 2] = f32;
 HEAPF32[i2 + 4 >> 2] = f31;
 HEAPF32[i2 + 8 >> 2] = f30;
 HEAP32[i2 + 12 >> 2] = i29;
 HEAPF32[i2 + 16 >> 2] = f28;
 HEAPF32[i2 + 20 >> 2] = f27;
 HEAPF32[i2 + 24 >> 2] = f26;
 HEAP32[i2 + 28 >> 2] = i25;
 HEAPF32[i2 + 32 >> 2] = f24;
 HEAPF32[i2 + 36 >> 2] = f23;
 HEAPF32[i2 + 40 >> 2] = f22;
 HEAP32[i2 + 44 >> 2] = i1;
 HEAPF32[i2 + 48 >> 2] = f21;
 HEAPF32[i2 + 52 >> 2] = f20;
 HEAPF32[i2 + 56 >> 2] = f19;
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 64 >> 2] = f18;
 HEAPF32[i2 + 68 >> 2] = f17;
 HEAPF32[i2 + 72 >> 2] = f16;
 HEAPF32[i2 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 80 >> 2] = f15;
 HEAPF32[i2 + 84 >> 2] = f14;
 HEAPF32[i2 + 88 >> 2] = f13;
 HEAPF32[i2 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 96 >> 2] = f12;
 HEAPF32[i2 + 100 >> 2] = f11;
 HEAPF32[i2 + 104 >> 2] = f10;
 HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 112 >> 2] = f9;
 HEAPF32[i2 + 116 >> 2] = f8;
 HEAPF32[i2 + 120 >> 2] = f7;
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 128 >> 2] = f6;
 HEAPF32[i2 + 132 >> 2] = f5;
 HEAPF32[i2 + 136 >> 2] = f4;
 HEAPF32[i2 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __Z17RandomUnitVector2R5RandN(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i29 = HEAP32[i2 >> 2] | 0;
 i20 = i2 + 4 | 0;
 i28 = HEAP32[i20 >> 2] | 0;
 i19 = i2 + 8 | 0;
 i27 = HEAP32[i19 >> 2] | 0;
 i33 = i2 + 12 | 0;
 i26 = HEAP32[i33 >> 2] | 0;
 i29 = i29 << 11 ^ i29;
 i28 = i28 << 11 ^ i28;
 i27 = i27 << 11 ^ i27;
 i26 = i26 << 11 ^ i26;
 i22 = i2 + 16 | 0;
 i23 = i2 + 20 | 0;
 i30 = HEAP32[i23 >> 2] | 0;
 i24 = i2 + 24 | 0;
 i31 = HEAP32[i24 >> 2] | 0;
 i25 = i2 + 28 | 0;
 i32 = HEAP32[i25 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i20 >> 2] = i30;
 HEAP32[i19 >> 2] = i31;
 HEAP32[i33 >> 2] = i32;
 i33 = i2 + 32 | 0;
 i32 = i2 + 36 | 0;
 i19 = HEAP32[i32 >> 2] | 0;
 i31 = i2 + 40 | 0;
 i20 = HEAP32[i31 >> 2] | 0;
 i30 = i2 + 44 | 0;
 i21 = HEAP32[i30 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i23 >> 2] = i19;
 HEAP32[i24 >> 2] = i20;
 HEAP32[i25 >> 2] = i21;
 i25 = i2 + 48 | 0;
 i21 = HEAP32[i25 >> 2] | 0;
 i24 = i2 + 52 | 0;
 i20 = HEAP32[i24 >> 2] | 0;
 i23 = i2 + 56 | 0;
 i19 = HEAP32[i23 >> 2] | 0;
 i22 = i2 + 60 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 HEAP32[i33 >> 2] = i21;
 HEAP32[i32 >> 2] = i20;
 HEAP32[i31 >> 2] = i19;
 HEAP32[i30 >> 2] = i2;
 i21 = i29 >>> 8 ^ i29 ^ i21 ^ i21 >>> 19;
 i20 = i28 >>> 8 ^ i28 ^ i20 ^ i20 >>> 19;
 i19 = i27 >>> 8 ^ i27 ^ i19 ^ i19 >>> 19;
 i2 = i26 >>> 8 ^ i26 ^ i2 ^ i2 >>> 19;
 HEAP32[i25 >> 2] = i21;
 HEAP32[i24 >> 2] = i20;
 HEAP32[i23 >> 2] = i19;
 HEAP32[i22 >> 2] = i2;
 f4 = Math_fround(Math_fround(i21 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(i20 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(i19 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(Math_fround(f4 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f4) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f5 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f6 = Math_fround(Math_fround(Math_fround(f6 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f6) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f12 = Math_fround(Math_fround(Math_fround(f12 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f12) * Math_fround(6.28318548))) * Math_fround(.159154937));
 f11 = Math_fround(+_roundf(+f4));
 f15 = Math_fround(+_roundf(+f5));
 f3 = Math_fround(+_roundf(+f6));
 f11 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f4 - f11))));
 f15 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f5 - f15))));
 f3 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f6 - f3))));
 f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f12 - Math_fround(+_roundf(+f12))))));
 f10 = Math_fround(f11 * f11);
 f9 = Math_fround(f15 * f15);
 f8 = Math_fround(f3 * f3);
 f7 = Math_fround(f16 * f16);
 f13 = Math_fround(f10 * f10);
 f17 = Math_fround(f9 * f9);
 f14 = Math_fround(f8 * f8);
 f18 = Math_fround(f7 * f7);
 f10 = Math_fround(f11 * Math_fround(Math_fround(Math_fround(f13 * f13) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f10 * Math_fround(41.3416595))) + Math_fround(f13 * Math_fround(Math_fround(81.6018218) - Math_fround(f10 * Math_fround(76.5686187)))))));
 f9 = Math_fround(f15 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f9 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f9 * Math_fround(76.5686187)))))));
 f8 = Math_fround(f3 * Math_fround(Math_fround(Math_fround(f14 * f14) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f8 * Math_fround(41.3416595))) + Math_fround(f14 * Math_fround(Math_fround(81.6018218) - Math_fround(f8 * Math_fround(76.5686187)))))));
 f7 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f18 * f18) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f7 * Math_fround(41.3416595))) + Math_fround(f18 * Math_fround(Math_fround(81.6018218) - Math_fround(f7 * Math_fround(76.5686187)))))));
 f4 = Math_fround(f4 + Math_fround(-.25));
 f5 = Math_fround(f5 + Math_fround(-.25));
 f6 = Math_fround(f6 + Math_fround(-.25));
 f12 = Math_fround(f12 + Math_fround(-.25));
 f18 = Math_fround(+_roundf(+f4));
 f16 = Math_fround(+_roundf(+f5));
 f14 = Math_fround(+_roundf(+f6));
 f18 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f4 - f18))));
 f16 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f5 - f16))));
 f14 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f6 - f14))));
 f12 = Math_fround(Math_fround(.25) - Math_fround(Math_abs(Math_fround(f12 - Math_fround(+_roundf(+f12))))));
 f6 = Math_fround(f18 * f18);
 f5 = Math_fround(f16 * f16);
 f4 = Math_fround(f14 * f14);
 f3 = Math_fround(f12 * f12);
 f17 = Math_fround(f6 * f6);
 f15 = Math_fround(f5 * f5);
 f13 = Math_fround(f4 * f4);
 f11 = Math_fround(f3 * f3);
 f6 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f17 * f17) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f6 * Math_fround(41.3416595))) + Math_fround(f17 * Math_fround(Math_fround(81.6018218) - Math_fround(f6 * Math_fround(76.5686187)))))));
 f5 = Math_fround(f16 * Math_fround(Math_fround(Math_fround(f15 * f15) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f5 * Math_fround(41.3416595))) + Math_fround(f15 * Math_fround(Math_fround(81.6018218) - Math_fround(f5 * Math_fround(76.5686187)))))));
 f4 = Math_fround(f14 * Math_fround(Math_fround(Math_fround(f13 * f13) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f4 * Math_fround(41.3416595))) + Math_fround(f13 * Math_fround(Math_fround(81.6018218) - Math_fround(f4 * Math_fround(76.5686187)))))));
 f3 = Math_fround(f12 * Math_fround(Math_fround(Math_fround(f11 * f11) * Math_fround(39.657032)) + Math_fround(Math_fround(Math_fround(6.283185) - Math_fround(f3 * Math_fround(41.3416595))) + Math_fround(f11 * Math_fround(Math_fround(81.6018218) - Math_fround(f3 * Math_fround(76.5686187)))))));
 HEAPF32[i1 >> 2] = f10;
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 HEAPF32[i1 + 28 >> 2] = f3;
 return;
}

function __ZN12AudioManager21FixMasterGroupRoutingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 128 | 0;
 i17 = i19 + 112 | 0;
 i16 = i19 + 96 | 0;
 i15 = i19 + 80 | 0;
 i8 = i19 + 64 | 0;
 i7 = i19 + 48 | 0;
 i6 = i19 + 32 | 0;
 i5 = i19 + 16 | 0;
 i3 = i19;
 i9 = i19 + 164 | 0;
 i4 = i19 + 160 | 0;
 i10 = i19 + 156 | 0;
 i11 = i19 + 152 | 0;
 i12 = i19 + 176 | 0;
 i13 = i19 + 148 | 0;
 i14 = i19 + 144 | 0;
 i2 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i2) {
  STACKTOP = i19;
  return;
 }
 __ZN4FMOD6System6updateEv(i2) | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(HEAP32[i1 + 92 >> 2] | 0, i4) | 0;
 if (i1 | 0) {
  i2 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i3 >> 2] = gb + 856220;
  HEAP32[i3 + 4 >> 2] = 635;
  HEAP32[i3 + 8 >> 2] = gb + 857050;
  HEAP32[i3 + 12 >> 2] = i2;
  __Z6FormatPKcz(i9, gb + 883334 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i10 >> 2] = 0;
  i1 = __ZN4FMOD3DSP9getOutputEiPPS0_PPNS_13DSPConnectionE(i1, 0, i10, 0) | 0;
  if (i1 | 0) {
   i3 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
   HEAP32[i5 >> 2] = gb + 856220;
   HEAP32[i5 + 4 >> 2] = 640;
   HEAP32[i5 + 8 >> 2] = gb + 857100;
   HEAP32[i5 + 12 >> 2] = i3;
   __Z6FormatPKcz(i9, gb + 883334 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  }
  if (HEAP32[i10 >> 2] | 0) {
   HEAP32[i11 >> 2] = 0;
   i1 = __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(HEAP32[i4 >> 2] | 0, 0, i11, 0) | 0;
   if (i1 | 0) {
    i5 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
    HEAP32[i6 >> 2] = gb + 856220;
    HEAP32[i6 + 4 >> 2] = 645;
    HEAP32[i6 + 8 >> 2] = gb + 857148;
    HEAP32[i6 + 12 >> 2] = i5;
    __Z6FormatPKcz(i9, gb + 883334 | 0, i6);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   }
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) {
    i1 = __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(i1, 0, i11, 0) | 0;
    if (i1 | 0) {
     i6 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
     HEAP32[i7 >> 2] = gb + 856220;
     HEAP32[i7 + 4 >> 2] = 648;
     HEAP32[i7 + 8 >> 2] = gb + 857189;
     HEAP32[i7 + 12 >> 2] = i6;
     __Z6FormatPKcz(i9, gb + 883334 | 0, i7);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    }
    if (HEAP32[i11 >> 2] | 0) {
     HEAP32[i13 >> 2] = 0;
     i1 = __ZN4FMOD3DSP12getNumInputsEPi(HEAP32[i10 >> 2] | 0, i13) | 0;
     if (i1 | 0) {
      i7 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
      HEAP32[i8 >> 2] = gb + 856220;
      HEAP32[i8 + 4 >> 2] = 654;
      HEAP32[i8 + 8 >> 2] = gb + 857230;
      HEAP32[i8 + 12 >> 2] = i7;
      __Z6FormatPKcz(i9, gb + 883334 | 0, i8);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     }
     if ((HEAP32[i13 >> 2] | 0) > 0) {
      i3 = i9 + 11 | 0;
      i4 = i9 + 11 | 0;
      i5 = i9 + 11 | 0;
      i6 = i9 + 11 | 0;
      i2 = 0;
      do {
       HEAP32[i14 >> 2] = 0;
       i1 = __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(HEAP32[i10 >> 2] | 0, i2, i14, 0) | 0;
       if (i1 | 0) {
        i8 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
        HEAP32[i15 >> 2] = gb + 856220;
        HEAP32[i15 + 4 >> 2] = 658;
        HEAP32[i15 + 8 >> 2] = gb + 857272;
        HEAP32[i15 + 12 >> 2] = i8;
        __Z6FormatPKcz(i9, gb + 883334 | 0, i15);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
       }
       i1 = HEAP32[i14 >> 2] | 0;
       do if (i1 | 0) {
        i1 = __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_(i1, i12, 0, 0, 0, 0) | 0;
        if (i1 | 0) {
         i8 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
         HEAP32[i16 >> 2] = gb + 856220;
         HEAP32[i16 + 4 >> 2] = 661;
         HEAP32[i16 + 8 >> 2] = gb + 857325;
         HEAP32[i16 + 12 >> 2] = i8;
         __Z6FormatPKcz(i9, gb + 883334 | 0, i16);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
        }
        if (_memcmp(i12, gb + 857383 | 0, 11) | 0) break;
        i1 = __ZN4FMOD3DSP13disconnectAllEbb(HEAP32[i14 >> 2] | 0, 0, 1) | 0;
        if (i1 | 0) {
         i8 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
         HEAP32[i17 >> 2] = gb + 856220;
         HEAP32[i17 + 4 >> 2] = 664;
         HEAP32[i17 + 8 >> 2] = gb + 857394;
         HEAP32[i17 + 12 >> 2] = i8;
         __Z6FormatPKcz(i9, gb + 883334 | 0, i17);
         __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
        }
        i1 = __ZN4FMOD3DSP8addInputEPS0_PPNS_13DSPConnectionE(HEAP32[i11 >> 2] | 0, HEAP32[i14 >> 2] | 0, 0) | 0;
        if (!i1) break;
        i8 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
        HEAP32[i18 >> 2] = gb + 856220;
        HEAP32[i18 + 4 >> 2] = 665;
        HEAP32[i18 + 8 >> 2] = gb + 857438;
        HEAP32[i18 + 12 >> 2] = i8;
        __Z6FormatPKcz(i9, gb + 883334 | 0, i18);
        __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
       } while (0);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (HEAP32[i13 >> 2] | 0));
     }
    }
   }
  }
 }
 STACKTOP = i19;
 return;
}

function __ZN7mecanim12statemachine13StateConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 32 | 0;
 i6 = i3 + 24 | 0;
 i8 = i3 + 12 | 0;
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i10 = i2 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 4;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i9;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902998 | 0, i9, i5, 0);
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i8, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(.899999976);
 HEAP8[i7 + 36 >> 0] = 0;
 HEAP8[i7 + 37 >> 0] = 0;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP8[i7 + 44 >> 0] = 1;
 HEAP8[i7 + 45 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903185 | 0, i7, 0);
 __ZN7mecanim12statemachine18TransitionConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 12;
 HEAP32[i8 + 4 >> 2] = i1 + 8;
 HEAP32[i8 + 8 >> 2] = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903370 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 20;
 HEAP32[i8 + 4 >> 2] = i1 + 16;
 HEAP32[i8 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903400 | 0, i9, i8, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i6, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903425 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903024 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903434 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903442 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903457 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903473 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903494 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898587 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903502 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903513 | 0, i6, i1 + 61 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903534 | 0, i6, i1 + 62 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898680 | 0, i6, i1 + 63 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy(i18, i17, i10, i11, i12, i13, i14) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i22 + 48 | 0;
 i9 = i22 + 40 | 0;
 i21 = i22 + 100 | 0;
 i19 = i22;
 i8 = i22 + 72 | 0;
 i6 = i22 + 56 | 0;
 i7 = i22 + 88 | 0;
 i3 = i18 + 1080 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
 i4 = i6 + 12 | 0;
 HEAP32[i4 >> 2] = -1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i6);
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i4 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i3, i19, i8) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = HEAP32[i18 + 1088 >> 2] | 0;
  HEAP32[i21 >> 2] = 54;
  HEAP32[i21 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5 + 16 | 0, i8);
  HEAP32[i5 + 28 >> 2] = HEAP32[i2 >> 2];
  i1 = HEAP32[i19 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = i1;
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
  if (!i1) i1 = i5; else {
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 + 1084 >> 2] | 0, i1);
  i1 = i18 + 1092 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = 0;
 } else {
  i5 = i1;
  i1 = 1;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (i1) {
  HEAP32[i9 >> 2] = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
  __Z6FormatPKcz(i21, gb + 490745 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 490375 | 0, 263, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i9 = i18 + 1208 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i16 = i18 + 1212 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 L11 : do if ((i1 | 0) != (i4 | 0)) {
  i6 = _i64Add(i13 | 0, i14 | 0, i11 | 0, i12 | 0) | 0;
  i7 = getTempRet0() | 0;
  while (1) {
   i3 = i1;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i6 >>> 0) {
    i8 = i1 + 8 | 0;
    i8 = _i64Add(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i2 | 0, i3 | 0) | 0;
    i3 = getTempRet0() | 0;
    if (i3 >>> 0 > i12 >>> 0 | (i3 | 0) == (i12 | 0) & i8 >>> 0 > i11 >>> 0) break;
   }
   i1 = i1 + 40 | 0;
   if ((i1 | 0) == (i4 | 0)) break L11;
  }
  i1 = i1 + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
  HEAP32[i15 + 4 >> 2] = i1;
  __Z6FormatPKcz(i21, gb + 490785 | 0, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 490375 | 0, 272, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 } while (0);
 i8 = i19 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = i19 + 32 | 0;
 HEAP32[i3 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = i19;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = i19 + 8 | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i14;
 HEAP32[i19 + 16 >> 2] = i10;
 i1 = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
 i2 = _strlen(i1) | 0;
 i7 = i8 + 11 | 0;
 do if (i2 >>> 0 > 10) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, 10, i2 + -10 | 0, 0, 0, 0, i2, i1); else {
  if (i2 | 0) _memmove(i8 | 0, i1 | 0, i2 | 0) | 0;
  HEAP8[i8 + i2 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i19 + 24 >> 2] = i2;
   break;
  } else {
   HEAP8[i7 >> 0] = i2;
   break;
  }
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i5 + 28 >> 2] = (i1 - (HEAP32[i9 >> 2] | 0) | 0) / 40 | 0;
 i6 = i1;
 if ((i6 | 0) == (HEAP32[i18 + 1216 >> 2] | 0)) __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i19); else {
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
  i1 = i6 + 20 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = i6 + 32 | 0;
  HEAP32[i3 >> 2] = i2;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i19 + 24 >> 2] | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i3 >> 2] | 0;
    i20 = 29;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (i5) i20 = 31;
   } else i20 = 29;
   if ((i20 | 0) == 29) {
    i17 = i5 + 16 & -16;
    HEAP32[i21 >> 2] = 54;
    HEAP32[i21 + 4 >> 2] = i2;
    i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i18;
    HEAP32[i6 + 28 >> 2] = i17 | -2147483648;
    HEAP32[i6 + 24 >> 2] = i5;
    i1 = i18;
    i20 = 31;
   }
   if ((i20 | 0) == 31) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  }
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 40;
 }
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i20 = HEAP32[i8 >> 2] | 0;
  i19 = HEAP32[i19 + 32 >> 2] | 0;
  HEAP32[i21 >> 2] = 54;
  HEAP32[i21 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
 }
 i21 = 1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_(i13, i14, i8, i7, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i9 = i14 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i13 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 < i1 >>> 0) i3 = 1; else if ((i2 | 0) == (i1 | 0)) i3 = (HEAP32[i14 + 24 >> 2] | 0) >>> 0 < (HEAP32[i13 + 24 >> 2] | 0) >>> 0; else i3 = 0;
 i6 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) i1 = 1; else if ((i1 | 0) == (i2 | 0)) i1 = (HEAP32[i8 + 24 >> 2] | 0) >>> 0 < (HEAP32[i14 + 24 >> 2] | 0) >>> 0; else i1 = 0;
 do if (i3) {
  i2 = i11;
  i3 = i13;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  if (i1) {
   i2 = i13;
   i3 = i8;
   i4 = i2 + 36 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i13 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
   i2 = i8;
   i3 = i11;
   i4 = i2 + 36 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i8 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
   i5 = 1;
   break;
  }
  i2 = i13;
  i3 = i14;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i13 + 36 >> 0] = HEAP8[i14 + 36 >> 0] | 0;
  i2 = i14;
  i3 = i11;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   if ((i1 | 0) != (i2 | 0)) {
    i5 = 1;
    break;
   }
   if ((HEAP32[i8 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
    i5 = 1;
    break;
   }
  }
  i2 = i11;
  i3 = i14;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i14;
  i3 = i8;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
  i2 = i8;
  i3 = i11;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i8 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
  i5 = 2;
 } else if (i1) {
  i2 = i11;
  i3 = i14;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i14;
  i3 = i8;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
  i2 = i8;
  i3 = i11;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i8 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   if ((i1 | 0) != (i2 | 0)) {
    i5 = 1;
    break;
   }
   if ((HEAP32[i14 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
    i5 = 1;
    break;
   }
  }
  i2 = i11;
  i3 = i13;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i13;
  i3 = i14;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i13 + 36 >> 0] = HEAP8[i14 + 36 >> 0] | 0;
  i2 = i14;
  i3 = i11;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
  i5 = 2;
 } else i5 = 0; while (0);
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  if ((i1 | 0) != (i2 | 0)) {
   i14 = i5;
   STACKTOP = i12;
   return i14 | 0;
  }
  if ((HEAP32[i7 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   i14 = i5;
   STACKTOP = i12;
   return i14 | 0;
  }
 }
 i2 = i11;
 i3 = i8;
 i4 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i8;
 i3 = i7;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i8 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
 i2 = i7;
 i3 = i11;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i7 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i3 = i5 + 1 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  if ((i1 | 0) != (i2 | 0)) {
   i14 = i3;
   STACKTOP = i12;
   return i14 | 0;
  }
  if ((HEAP32[i8 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) {
   i14 = i3;
   STACKTOP = i12;
   return i14 | 0;
  }
 }
 i2 = i11;
 i3 = i14;
 i4 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i14;
 i3 = i8;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i14 + 36 >> 0] = HEAP8[i8 + 36 >> 0] | 0;
 i2 = i8;
 i3 = i11;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i8 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i3 = i5 + 2 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 >= i1 >>> 0) {
  if ((i2 | 0) != (i1 | 0)) {
   i14 = i3;
   STACKTOP = i12;
   return i14 | 0;
  }
  if ((HEAP32[i14 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i13 + 24 >> 2] | 0) >>> 0) {
   i14 = i3;
   STACKTOP = i12;
   return i14 | 0;
  }
 }
 i2 = i11;
 i3 = i13;
 i4 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i13;
 i3 = i14;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i13 + 36 >> 0] = HEAP8[i14 + 36 >> 0] | 0;
 i2 = i14;
 i3 = i11;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i14 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i14 = i5 + 3 | 0;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj(i26, i25, i13, i14, i17, i20, i27) {
 i26 = i26 | 0;
 i25 = i25 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i20 = i20 | 0;
 i27 = i27 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i28 = 0, f29 = f0, i30 = 0, f31 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i28 + 144 | 0;
 i10 = i28 + 128 | 0;
 i11 = i28 + 112 | 0;
 i8 = i28 + 172 | 0;
 i22 = i28 + 160 | 0;
 i21 = i28 + 96 | 0;
 i23 = i28 + 80 | 0;
 i24 = i28 + 64 | 0;
 i15 = i28 + 48 | 0;
 i16 = i28 + 32 | 0;
 i18 = i28 + 16 | 0;
 i19 = i28;
 HEAP32[i27 >> 2] = 3;
 HEAP32[i9 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
 i12 = i25 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i30 = i25 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f2 = Math_fround(f2 - f5);
 f4 = Math_fround(f4 - f3);
 f1 = Math_fround(f1 - f7);
 f29 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f5 = Math_fround(f29 - f5);
 f3 = Math_fround(f6 - f3);
 f7 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f7);
 f6 = Math_fround(Math_fround(f4 * f7) - Math_fround(f1 * f3));
 f7 = Math_fround(Math_fround(f1 * f5) - Math_fround(f2 * f7));
 f5 = Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f5));
 if (!(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))) <= Math_fround(1.1920929e-07))) {
  HEAP32[i22 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i21, i9, i10, i11, i22, i8);
  i8 = HEAP32[i8 >> 2] | 0;
  if ((i8 | 0) != 3) {
   i9 = HEAP32[i22 >> 2] | 0;
   i30 = i25 + (i9 << 4) | 0;
   HEAP32[i23 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
   i30 = HEAP32[i22 + 4 >> 2] | 0;
   i10 = i25 + (i30 << 4) | 0;
   HEAP32[i24 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i24 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = i13 + (i9 << 4) | 0;
   HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = i13 + (i30 << 4) | 0;
   HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = i14 + (i9 << 4) | 0;
   HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = i14 + (i30 << 4) | 0;
   HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i19 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i10 = HEAP32[i17 + (i9 << 2) >> 2] | 0;
   i11 = HEAP32[i17 + (i30 << 2) >> 2] | 0;
   i22 = HEAP32[i20 + (i9 << 2) >> 2] | 0;
   i30 = HEAP32[i20 + (i30 << 2) >> 2] | 0;
   HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   i25 = i13 + 16 | 0;
   HEAP32[i25 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   i25 = i14 + 16 | 0;
   HEAP32[i25 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
   HEAP32[i17 >> 2] = i10;
   HEAP32[i17 + 4 >> 2] = i11;
   HEAP32[i20 >> 2] = i22;
   HEAP32[i20 + 4 >> 2] = i30;
   HEAP32[i27 >> 2] = i8;
  };
  HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
  STACKTOP = i28;
  return;
 }
 HEAP32[i27 >> 2] = 2;
 f1 = Math_fround(HEAPF32[i25 >> 2]);
 f2 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i25 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i25 + 20 >> 2]);
 f4 = Math_fround(f4 - f1);
 f5 = Math_fround(f5 - f2);
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) - f3);
 f7 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6));
 if (!(f7 <= Math_fround(1.1920929e-07))) {
  f31 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f2 * f5)) - Math_fround(f1 * f4)) - Math_fround(f3 * f6)) / f7);
  i30 = f31 > Math_fround(1.0);
  f31 = i30 ? Math_fround(1.0) : f31;
  i30 = f31 > Math_fround(0.0);
  f31 = i30 ? f31 : Math_fround(0.0);
  f7 = Math_fround(f2 + Math_fround(f5 * f31));
  f29 = Math_fround(f3 + Math_fround(f6 * f31));
  HEAPF32[i26 >> 2] = Math_fround(f1 + Math_fround(f4 * f31));
  HEAPF32[i26 + 4 >> 2] = f7;
  HEAPF32[i26 + 8 >> 2] = f29;
  HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
  STACKTOP = i28;
  return;
 } else {
  HEAP32[i27 >> 2] = 1;
  HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
  STACKTOP = i28;
  return;
 }
}

function __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i3);
 i1 = i5 + 204 | 0;
 i6 = i3 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i3 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 205 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 i1 = i5 + 116 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 120 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 124 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 128 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 132 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 136 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 144 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 148 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 152 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 156 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 160 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 164 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 180 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 184 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
  i4 = i3;
 }
 i1 = i5 + 188 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 140 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 168 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 172 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 176 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 200 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i5 + 196 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 193 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 192 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 206 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 }
}

function __ZN5physx11PxMeshQuery22findOverlapHeightFieldERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_PjjjRb(i2, i1, i17, i18, i22, i20, i23, i21) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i19 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 24 | 0;
 i19 = i24;
 i16 = i24 + 48 | 0;
 f25 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i18 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i18 + 8 >> 2]));
 f28 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f27 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f26 = Math_fround(f26 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f27 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f14 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f8 * f4)) + Math_fround(f27 * f11));
 f12 = Math_fround(Math_fround(f14 * f25) + Math_fround(Math_fround(f5 * f26) + Math_fround(f28 * Math_fround(Math_fround(f27 * f4) - Math_fround(f8 * f11)))));
 f13 = Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f5 * f8) + Math_fround(f28 * Math_fround(Math_fround(f26 * f11) - Math_fround(f27 * f25)))));
 f14 = Math_fround(Math_fround(Math_fround(f5 * f27) + Math_fround(f28 * Math_fround(Math_fround(f8 * f25) - Math_fround(f26 * f4)))) + Math_fround(f14 * f11));
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f28 * f26);
 f27 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f27 * f25));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f5 * f4));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f3 * f11));
 f9 = Math_fround(Math_fround(Math_fround(f26 * f11) + Math_fround(Math_fround(f27 * f4) + Math_fround(f28 * f3))) - Math_fround(f5 * f25));
 f10 = Math_fround(Math_fround(Math_fround(f3 * f25) + Math_fround(Math_fround(f27 * f11) + Math_fround(f28 * f5))) - Math_fround(f26 * f4));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f3 * f4)) - Math_fround(f5 * f11));
 switch (HEAP32[i2 >> 2] | 0) {
 case 2:
  {
   f27 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f28 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f27 = Math_fround(f27 + f28);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = i1;
   break;
  }
 case 0:
  {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i6 = i1;
   i7 = i1;
   break;
  }
 case 3:
  {
   i6 = HEAP32[i2 + 4 >> 2] | 0;
   i7 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   break;
  }
 default:
  {
   HEAP8[i21 >> 0] = 0;
   i6 = 0;
   i7 = 0;
   i1 = 0;
  }
 }
 if (f10 == Math_fround(0.0) & (f8 == Math_fround(0.0) & f9 == Math_fround(0.0))) {
  f3 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i2 = 1;
 } else {
  f26 = Math_fround(f8 + f8);
  f3 = Math_fround(f9 + f9);
  f30 = Math_fround(f10 + f10);
  f28 = Math_fround(f9 * f3);
  f25 = Math_fround(f10 * f30);
  f5 = Math_fround(f26 * f9);
  f33 = Math_fround(f26 * f10);
  f4 = Math_fround(f26 * f11);
  f32 = Math_fround(f10 * f3);
  f3 = Math_fround(f11 * f3);
  f30 = Math_fround(f11 * f30);
  f31 = Math_fround(Math_fround(Math_fround(1.0) - f28) - f25);
  f29 = Math_fround(f5 + f30);
  f27 = Math_fround(f33 - f3);
  f30 = Math_fround(f5 - f30);
  f26 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f26));
  f25 = Math_fround(f26 - f25);
  f5 = Math_fround(f4 + f32);
  f3 = Math_fround(f33 + f3);
  f4 = Math_fround(f32 - f4);
  f28 = Math_fround(f26 - f28);
  f26 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f31 * f26);
  f29 = Math_fround(f29 * f26);
  f26 = Math_fround(f27 * f26);
  f27 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = Math_fround(f30 * f27);
  f25 = Math_fround(f25 * f27);
  f27 = Math_fround(f5 * f27);
  f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f31))) + Math_fround(Math_abs(Math_fround(f30)))) + Math_fround(Math_abs(Math_fround(f3 * f5))));
  f4 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f29))) + Math_fround(Math_abs(Math_fround(f25)))) + Math_fround(Math_abs(Math_fround(f4 * f5))));
  f5 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f26))) + Math_fround(Math_abs(Math_fround(f27)))) + Math_fround(Math_abs(Math_fround(f28 * f5))));
  i2 = 0;
 }
 f33 = Math_fround(f14 + f5);
 f32 = Math_fround(f13 + f4);
 f31 = Math_fround(f12 + f3);
 f30 = Math_fround(f14 - f5);
 f29 = Math_fround(f13 - f4);
 HEAPF32[i15 >> 2] = Math_fround(f12 - f3);
 HEAPF32[i15 + 4 >> 2] = f29;
 HEAPF32[i15 + 8 >> 2] = f30;
 HEAPF32[i15 + 12 >> 2] = f31;
 HEAPF32[i15 + 16 >> 2] = f32;
 HEAPF32[i15 + 20 >> 2] = f33;
 HEAP32[i19 + 12 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i19 + 16 >> 2] = i17;
 HEAPF32[i19 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i17 + 8 >> 2]));
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i17 + 12 >> 2]));
 HEAPF32[i19 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i17 + 16 >> 2]));
 HEAP32[i16 >> 2] = gb + 85776 + 8;
 HEAP32[i16 + 4 >> 2] = i19;
 HEAPF32[i16 + 8 >> 2] = f12;
 HEAPF32[i16 + 12 >> 2] = f13;
 HEAPF32[i16 + 16 >> 2] = f14;
 HEAP32[i16 + 20 >> 2] = i6;
 HEAP32[i16 + 24 >> 2] = i7;
 HEAP32[i16 + 28 >> 2] = i1;
 HEAPF32[i16 + 32 >> 2] = f8;
 HEAPF32[i16 + 36 >> 2] = f9;
 HEAPF32[i16 + 40 >> 2] = f10;
 HEAPF32[i16 + 44 >> 2] = f11;
 HEAP32[i16 + 48 >> 2] = i22;
 HEAP32[i16 + 52 >> 2] = i20;
 HEAP32[i16 + 56 >> 2] = i23;
 i23 = i16 + 60 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i16 + 64 >> 2] = 0;
 HEAP8[i16 + 68 >> 0] = i2;
 i22 = i16 + 69 | 0;
 HEAP8[i22 >> 0] = 0;
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i19, i18, i15, 0, i16) | 0;
 HEAP8[i21 >> 0] = HEAP8[i22 >> 0] | 0;
 STACKTOP = i24;
 return HEAP32[i23 >> 2] | 0;
}

function __Z30CalculateAABBFromPositionArrayRK10Matrix4x4fPK8Vector3fj(i26, i1, i27, i28) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i29 = 0, f30 = f0;
 if (!((i27 | 0) != 0 & (i28 | 0) != 0)) {
  i28 = i26 + 12 | 0;
  HEAP32[i26 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i28 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  return;
 }
 if (!(HEAP8[gb + 1544236 >> 0] | 0)) {
  HEAP32[gb + 1155264 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[gb + 1155264 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[gb + 1155264 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  HEAPF32[gb + 1155264 + 12 >> 2] = Math_fround(1.0);
  HEAP8[gb + 1544236 >> 0] = 1;
 }
 if (!(HEAP8[gb + 1544237 >> 0] | 0)) {
  f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f24 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f25 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  HEAPF32[gb + 1155280 >> 2] = f23;
  HEAPF32[gb + 1155280 + 4 >> 2] = f24;
  HEAPF32[gb + 1155280 + 8 >> 2] = f25;
  HEAPF32[gb + 1155280 + 12 >> 2] = Math_fround(1.0);
  HEAP8[gb + 1544237 >> 0] = 1;
 }
 if (__ZNK10Matrix4x4f10IsIdentityEf(i1, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0) {
  i6 = 0;
  i8 = HEAP32[gb + 1155280 >> 2] | 0;
  i9 = HEAP32[gb + 1155264 >> 2] | 0;
  i1 = HEAP32[gb + 1155280 + 8 >> 2] | 0;
  i10 = HEAP32[gb + 1155264 + 8 >> 2] | 0;
  i11 = HEAP32[gb + 1155280 + 4 >> 2] | 0;
  i12 = HEAP32[gb + 1155264 + 4 >> 2] | 0;
  while (1) {
   i29 = i27 + (i6 * 12 | 0) | 0;
   f2 = Math_fround(HEAPF32[i29 >> 2]);
   f4 = Math_fround(HEAPF32[i29 + 4 >> 2]);
   f3 = Math_fround(HEAPF32[i29 + 8 >> 2]);
   f5 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = f5 < f2 ? f5 : f2;
   f13 = f13 < f4 ? f13 : f4;
   f7 = f7 < f3 ? f7 : f3;
   i9 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f23 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f24 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = f23 > f2 ? f23 : f2;
   f4 = f24 > f4 ? f24 : f4;
   f3 = f25 > f3 ? f25 : f3;
   i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i28 | 0)) break; else i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f25 = Math_fround(Math_fround(f4 + f13) * Math_fround(.5));
  f24 = Math_fround(Math_fround(f3 + f7) * Math_fround(.5));
  HEAPF32[i26 >> 2] = Math_fround(Math_fround(f2 + f5) * Math_fround(.5));
  HEAPF32[i26 + 4 >> 2] = f25;
  HEAPF32[i26 + 8 >> 2] = f24;
  f24 = Math_fround(Math_fround(f4 - f13) * Math_fround(.5));
  f25 = Math_fround(Math_fround(f3 - f7) * Math_fround(.5));
  HEAPF32[i26 + 12 >> 2] = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
  HEAPF32[i26 + 16 >> 2] = f24;
  HEAPF32[i26 + 20 >> 2] = f25;
  return;
 } else {
  f15 = Math_fround(HEAPF32[i1 >> 2]);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f19 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f20 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + 32 >> 2]);
  f22 = Math_fround(HEAPF32[i1 + 36 >> 2]);
  f23 = Math_fround(HEAPF32[i1 + 40 >> 2]);
  f24 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f25 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  i6 = 0;
  i8 = HEAP32[gb + 1155280 >> 2] | 0;
  i9 = HEAP32[gb + 1155264 >> 2] | 0;
  i1 = HEAP32[gb + 1155280 + 8 >> 2] | 0;
  i10 = HEAP32[gb + 1155264 + 8 >> 2] | 0;
  i11 = HEAP32[gb + 1155280 + 4 >> 2] | 0;
  i12 = HEAP32[gb + 1155264 + 4 >> 2] | 0;
  while (1) {
   f14 = Math_fround(HEAPF32[i27 + (i6 * 12 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i27 + (i6 * 12 | 0) + 4 >> 2]);
   f2 = Math_fround(HEAPF32[i27 + (i6 * 12 | 0) + 8 >> 2]);
   f3 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f18 * f4)) + Math_fround(f24 + Math_fround(f21 * f2)));
   f13 = Math_fround(Math_fround(Math_fround(f16 * f14) + Math_fround(f19 * f4)) + Math_fround(f25 + Math_fround(f22 * f2)));
   f2 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f20 * f4)) + Math_fround(f7 + Math_fround(f23 * f2)));
   f4 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = f4 < f3 ? f4 : f3;
   f14 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = f14 < f13 ? f14 : f13;
   f5 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = f5 < f2 ? f5 : f2;
   i9 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = f30 > f3 ? f30 : f3;
   f30 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = f30 > f13 ? f30 : f13;
   f30 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = f30 > f2 ? f30 : f2;
   i8 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i28 | 0)) break; else i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f30 = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
  f25 = Math_fround(Math_fround(f2 + f5) * Math_fround(.5));
  HEAPF32[i26 >> 2] = Math_fround(Math_fround(f3 + f4) * Math_fround(.5));
  HEAPF32[i26 + 4 >> 2] = f30;
  HEAPF32[i26 + 8 >> 2] = f25;
  f25 = Math_fround(Math_fround(f13 - f14) * Math_fround(.5));
  f30 = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
  HEAPF32[i26 + 12 >> 2] = Math_fround(Math_fround(f3 - f4) * Math_fround(.5));
  HEAPF32[i26 + 16 >> 2] = f25;
  HEAPF32[i26 + 20 >> 2] = f30;
  return;
 }
}

function __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i4 = i6 + 64 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 68 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN5physx5cloth21IterationStateFactoryC2INS0_7SwClothEEERT_f(i27, i26, f11) {
 i27 = i27 | 0;
 i26 = i26 | 0;
 f11 = Math_fround(f11);
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i15 = i27 + 20 | 0;
 i16 = i27 + 36 | 0;
 i22 = i27 + 48 | 0;
 i23 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i26 + 140 >> 2]) * f11) + Math_fround(.5));
 i23 = (i23 | 0) > 1 ? i23 : 1;
 HEAP32[i27 >> 2] = i23;
 f1 = Math_fround(Math_fround(1.0) / Math_fround(i23 | 0));
 HEAPF32[i27 + 4 >> 2] = f1;
 f1 = Math_fround(f1 * f11);
 i23 = i27 + 8 | 0;
 HEAPF32[i23 >> 2] = f1;
 i24 = i26 + 228 | 0;
 f13 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = f13 != Math_fround(0.0);
 f13 = Math_fround(f1 / f13);
 HEAPF32[i27 + 12 >> 2] = i25 ? f13 : Math_fround(1.0);
 i25 = i26 + 232 | 0;
 i4 = HEAP32[i26 + 236 >> 2] | 0;
 if (i4) {
  i5 = HEAP32[i25 >> 2] | 0;
  i2 = i5 + (i4 << 3) | 0;
  i3 = i5;
  f1 = Math_fround(0.0);
  do {
   f13 = Math_fround((HEAP32[i3 >> 2] | 0) >>> 0);
   f1 = Math_fround(f1 + Math_fround(f13 * Math_fround(HEAPF32[i3 + 4 >> 2])));
   i3 = i3 + 8 | 0;
  } while ((i3 | 0) != (i2 | 0));
  f10 = f1;
  i9 = HEAP32[i26 + 244 >> 2] | 0;
  i14 = i9 >>> 3;
  i2 = i5 + (i4 + -1 << 3) | 0;
  if (!i14) f1 = Math_fround(0.0); else {
   i3 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i8 = 0;
   i4 = i5;
   f1 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   while (1) {
    if ((i8 | 0) == (i6 | 0)) {
     i4 = i4 + 8 | 0;
     i5 = (HEAP32[i4 >> 2] | 0) + i8 | 0;
    } else i5 = i6;
    if ((i8 | 0) == (i3 | 0)) {
     i2 = i2 + -8 | 0;
     i3 = (HEAP32[i2 >> 2] | 0) + i8 | 0;
    }
    f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    f7 = Math_fround(f7 + Math_fround(f13 + Math_fround(HEAPF32[i2 + 4 >> 2])));
    f1 = Math_fround(f1 + f7);
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i14 | 0)) break; else i6 = i5;
   }
  }
  i21 = i14 + 1 | 0;
  f1 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(i21 >>> 0)) - f1) / Math_fround((Math_imul(i9 - i14 | 0, i21) | 0) >>> 0));
 }
 HEAPF32[i27 + 16 >> 2] = f1;
 i21 = i26 + 176 | 0;
 HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
 i18 = i26 + 180 | 0;
 HEAP32[i27 + 24 >> 2] = HEAP32[i18 >> 2];
 i19 = i26 + 184 | 0;
 HEAP32[i27 + 28 >> 2] = HEAP32[i19 >> 2];
 i20 = i26 + 188 | 0;
 HEAP32[i27 + 32 >> 2] = HEAP32[i20 >> 2];
 i9 = i26 + 204 | 0;
 HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
 i8 = i26 + 208 | 0;
 HEAP32[i27 + 40 >> 2] = HEAP32[i8 >> 2];
 i6 = i26 + 212 | 0;
 HEAP32[i27 + 44 >> 2] = HEAP32[i6 >> 2];
 i17 = i26 + 216 | 0;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 i15 = i26 + 220 | 0;
 HEAP32[i27 + 52 >> 2] = HEAP32[i15 >> 2];
 i16 = i26 + 224 | 0;
 HEAP32[i27 + 56 >> 2] = HEAP32[i16 >> 2];
 f13 = Math_fround(Math_fround(1.0) / f11);
 i14 = i26 + 148 | 0;
 f11 = Math_fround(HEAPF32[i26 + 164 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i26 + 192 >> 2]));
 i2 = i26 + 168 | 0;
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i26 + 196 | 0;
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i3 >> 2]));
 i4 = i26 + 172 | 0;
 f30 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i26 + 200 | 0;
 f28 = Math_fround(f13 * f28);
 f30 = Math_fround(f13 * Math_fround(f30 - Math_fround(HEAPF32[i5 >> 2])));
 HEAPF32[i9 >> 2] = Math_fround(f13 * f11);
 HEAPF32[i8 >> 2] = f28;
 HEAPF32[i6 >> 2] = f30;
 f30 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f28 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
 f33 = Math_fround(HEAPF32[i20 >> 2]);
 i6 = i26 + 160 | 0;
 f32 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = Math_fround(f32 * f30);
 f31 = Math_fround(HEAPF32[i14 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f33 * f31));
 i8 = i26 + 152 | 0;
 f29 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f29 * f11));
 i9 = i26 + 156 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 f1 = Math_fround(f1 - Math_fround(f12 * f28));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f28) + Math_fround(f33 * f29)) + Math_fround(f12 * f30)) - Math_fround(f31 * f11));
 f10 = Math_fround(Math_fround(Math_fround(f31 * f28) + Math_fround(Math_fround(f32 * f11) + Math_fround(f33 * f12))) - Math_fround(f29 * f30));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)) - Math_fround(f29 * f28)) - Math_fround(f12 * f11));
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f7 * f7)) + Math_fround(f10 * f10))));
 if (!(f12 > Math_fround(1.1920929e-07))) {
  f31 = Math_fround(1.0);
  f33 = Math_fround(-f31);
  i22 = f11 >= Math_fround(0.0);
  f33 = i22 ? f31 : f33;
  f31 = Math_fround(f1 * f33);
  f32 = Math_fround(f7 * f33);
  f33 = Math_fround(f10 * f33);
  f31 = Math_fround(f13 * f31);
  f32 = Math_fround(f13 * f32);
  f33 = Math_fround(f13 * f33);
  HEAPF32[i17 >> 2] = f31;
  HEAPF32[i15 >> 2] = f32;
  HEAPF32[i16 >> 2] = f33;
  i23 = HEAP32[i23 >> 2] | 0;
  HEAP32[i24 >> 2] = i23;
  i27 = HEAP32[i27 >> 2] | 0;
  f33 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  __ZN5physx5cloth13MovingAverage4pushEjf(i25, i27, f33);
  i27 = HEAP32[i14 >> 2] | 0;
  HEAP32[i21 >> 2] = i27;
  i27 = HEAP32[i8 >> 2] | 0;
  HEAP32[i18 >> 2] = i27;
  i27 = HEAP32[i9 >> 2] | 0;
  HEAP32[i19 >> 2] = i27;
  i27 = HEAP32[i6 >> 2] | 0;
  HEAP32[i20 >> 2] = i27;
  i27 = i26 + 192 | 0;
  i26 = i26 + 164 | 0;
  i26 = HEAP32[i26 >> 2] | 0;
  HEAP32[i27 >> 2] = i26;
  i27 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i27;
  i27 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i27;
  return;
 }
 i22 = f12 < Math_fround(-1.0);
 f31 = i22 ? Math_fround(-1.0) : f12;
 i22 = f31 > Math_fround(1.0);
 f31 = Math_fround(Math_fround(+Math_asin(+(i22 ? Math_fround(1.0) : f31))) / f12);
 f33 = Math_fround(-f31);
 i22 = f11 >= Math_fround(0.0);
 f33 = i22 ? f31 : f33;
 f31 = Math_fround(f1 * f33);
 f32 = Math_fround(f7 * f33);
 f33 = Math_fround(f10 * f33);
 f31 = Math_fround(f13 * f31);
 f32 = Math_fround(f13 * f32);
 f33 = Math_fround(f13 * f33);
 HEAPF32[i17 >> 2] = f31;
 HEAPF32[i15 >> 2] = f32;
 HEAPF32[i16 >> 2] = f33;
 i23 = HEAP32[i23 >> 2] | 0;
 HEAP32[i24 >> 2] = i23;
 i27 = HEAP32[i27 >> 2] | 0;
 f33 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 __ZN5physx5cloth13MovingAverage4pushEjf(i25, i27, f33);
 i27 = HEAP32[i14 >> 2] | 0;
 HEAP32[i21 >> 2] = i27;
 i27 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 >> 2] = i27;
 i27 = HEAP32[i9 >> 2] | 0;
 HEAP32[i19 >> 2] = i27;
 i27 = HEAP32[i6 >> 2] | 0;
 HEAP32[i20 >> 2] = i27;
 i27 = i26 + 192 | 0;
 i26 = i26 + 164 | 0;
 i26 = HEAP32[i26 >> 2] | 0;
 HEAP32[i27 >> 2] = i26;
 i27 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i27;
 i27 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i27;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i11, i18, i19, i13, i20, i14, i1, i15) {
 i11 = i11 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i22 + 12 | 0;
 i9 = i22 + 8 | 0;
 i16 = i22 + 4 | 0;
 i17 = i22;
 i2 = __ZNKSt3__28ios_base6getlocEv(i13) | 0;
 HEAP32[i10 >> 2] = i2;
 __THREW__ = 0;
 i12 = invoke_iii(fb + 1145 | 0, i10 | 0, gb + 1474588 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i22 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  ___resumeException(i22 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
 HEAP32[i20 >> 2] = 0;
 i2 = 0;
 L4 : while (1) {
  i8 = (i1 | 0) != (i15 | 0);
  i3 = i2;
  while (1) {
   i2 = HEAP32[i18 >> 2] | 0;
   if (!(i8 & (i3 | 0) == 0)) break L4;
   i4 = i2;
   if (!i2) {
    i2 = 0;
    i6 = 1;
    i7 = i4;
   } else {
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i3 = HEAP32[i3 >> 2] | 0;
    if ((i3 | 0) == -1) {
     HEAP32[i18 >> 2] = 0;
     i2 = 0;
     i6 = 1;
     i7 = 0;
    } else {
     i6 = 0;
     i7 = i4;
    }
   }
   i5 = HEAP32[i19 >> 2] | 0;
   i3 = i5;
   do if (!i5) i21 = 17; else {
    i4 = HEAP32[i5 + 12 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) i4 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0; else i4 = HEAP32[i4 >> 2] | 0;
    if ((i4 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i21 = 17;
     break;
    } else if (i6) break; else {
     i21 = 19;
     break L4;
    }
   } while (0);
   if ((i21 | 0) == 17) {
    i21 = 0;
    if (i6) {
     i21 = 19;
     break L4;
    } else i5 = 0;
   }
   if ((mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0, 0) | 0) << 24 >> 24 == 37) {
    i21 = 22;
    break;
   }
   if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, 8192, HEAP32[i1 >> 2] | 0) | 0) {
    i21 = 30;
    break;
   }
   i4 = i2 + 12 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i5 = i2 + 16 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i3 = HEAP32[i3 >> 2] | 0;
   i7 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0, i3 | 0) | 0;
   if ((i7 | 0) == (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0) | 0)) {
    i21 = 58;
    break;
   }
   HEAP32[i20 >> 2] = 4;
   i3 = 4;
  }
  L36 : do if ((i21 | 0) == 22) {
   i21 = 0;
   i6 = i1 + 4 | 0;
   if ((i6 | 0) == (i15 | 0)) {
    i21 = 23;
    break L4;
   }
   i4 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i12 | 0, HEAP32[i6 >> 2] | 0, 0) | 0;
   switch (i4 << 24 >> 24) {
   case 48:
   case 69:
    {
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i15 | 0)) {
      i21 = 28;
      break L4;
     }
     i5 = i4;
     i2 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0, 0) | 0;
     i1 = i6;
     break;
    }
   default:
    {
     i5 = 0;
     i2 = i4;
    }
   }
   i8 = HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0;
   HEAP32[i16 >> 2] = i7;
   HEAP32[i17 >> 2] = i3;
   HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i18 >> 2] = mftCall_iiiiiiiii(i8 | 0, i11 | 0, i9 | 0, i10 | 0, i13 | 0, i20 | 0, i14 | 0, i2 | 0, i5 | 0) | 0;
   i1 = i1 + 8 | 0;
  } else if ((i21 | 0) == 30) {
   while (1) {
    i21 = 0;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i15 | 0)) {
     i1 = i15;
     break;
    }
    if (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, 8192, HEAP32[i1 >> 2] | 0) | 0) i21 = 30; else break;
   }
   i3 = i5;
   i6 = i5;
   while (1) {
    if (!i2) {
     i5 = 1;
     i2 = 0;
    } else {
     i4 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i4 = HEAP32[i4 >> 2] | 0;
     if ((i4 | 0) == -1) {
      HEAP32[i18 >> 2] = 0;
      i5 = 1;
      i2 = 0;
     } else i5 = 0;
    }
    do if (!i6) i21 = 45; else {
     i4 = HEAP32[i6 + 12 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) i4 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0; else i4 = HEAP32[i4 >> 2] | 0;
     if ((i4 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i3 = 0;
      i21 = 45;
      break;
     } else if (i5 ^ (i3 | 0) == 0) {
      i7 = i3;
      i6 = i3;
      break;
     } else break L36;
    } while (0);
    if ((i21 | 0) == 45) {
     i21 = 0;
     if (i5) break L36; else {
      i7 = i3;
      i6 = 0;
     }
    }
    i4 = i2 + 12 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i5 = i2 + 16 | 0;
    if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i3 = HEAP32[i3 >> 2] | 0;
    if (!(mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, 8192, i3 | 0) | 0)) break L36;
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) {
     mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
     i3 = i7;
     continue;
    } else {
     HEAP32[i4 >> 2] = i3 + 4;
     i3 = i7;
     continue;
    }
   }
  } else if ((i21 | 0) == 58) {
   i21 = 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0; else HEAP32[i4 >> 2] = i3 + 4;
   i1 = i1 + 4 | 0;
  } while (0);
  i2 = HEAP32[i20 >> 2] | 0;
 }
 if ((i21 | 0) == 19) HEAP32[i20 >> 2] = 4; else if ((i21 | 0) == 23) HEAP32[i20 >> 2] = 4; else if ((i21 | 0) == 28) HEAP32[i20 >> 2] = 4;
 if (!i2) {
  i2 = 0;
  i4 = 1;
 } else {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i18 >> 2] = 0;
   i2 = 0;
   i4 = 1;
  } else i4 = 0;
 }
 i1 = HEAP32[i19 >> 2] | 0;
 do if (!i1) i21 = 76; else {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i19 >> 2] = 0;
   i21 = 76;
   break;
  } else if (i4) break; else {
   i21 = 78;
   break;
  }
 } while (0);
 if ((i21 | 0) == 76) if (i4) i21 = 78;
 if ((i21 | 0) == 78) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 2;
 STACKTOP = i22;
 return i2 | 0;
}

function __ZN5Umbra8QueryExt20queryConnectedRegionEjRNS_9IndexListEiRKNS_7Vector3EfPfPNS_9FloatListES8_PS1_(i1, i17, i5, i11, i20, f21, i18, i6, i7, i8) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i20 = i20 | 0;
 f21 = Math_fround(f21);
 i18 = i18 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26;
 i14 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i25 >> 2] = i14;
 i2 = HEAP32[i14 + 76 >> 2] | 0;
 HEAP32[i25 + 4 >> 2] = i2;
 i24 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i24 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i24 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i25 + 8 >> 2] = i1;
 i15 = i25 + 12 | 0;
 HEAP32[i15 >> 2] = i1 + i4;
 i23 = i25 + 16 | 0;
 HEAP32[i23 >> 2] = i1;
 HEAP32[i25 + 20 >> 2] = i4;
 HEAP32[i25 + 24 >> 2] = 0;
 i24 = i25 + 28 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i25 + 32 >> 2] = i17;
 HEAP32[i25 + 36 >> 2] = 0;
 HEAP32[i25 + 40 >> 2] = -1;
 i12 = i14 + 84 | 0;
 i22 = HEAP32[i12 >> 2] | 0;
 HEAP32[i25 + 44 >> 2] = i22;
 i16 = i25 + 48 | 0;
 HEAP32[i16 >> 2] = i22;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i25 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i23 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i25 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i9 = HEAP32[i14 >> 2] | 0;
 i10 = i9;
 if (!i9) {
  i24 = 6;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i24 | 0;
 }
 i22 = i5 + 3 & -4;
 i13 = (i6 | 0) == 0 ? 0 : i6 + 3 & -4;
 i7 = (i7 | 0) == 0 ? 0 : i7 + 3 & -4;
 i6 = (i8 | 0) == 0 ? 0 : i8 + 3 & -4;
 do if ((i11 | 0) == -1) i11 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i25, i20) | 0; else {
  if ((i11 | 0) >= 0) if ((HEAP32[i9 + 124 >> 2] | 0) > (i11 | 0)) {
   i5 = HEAP32[i14 + 4 >> 2] | 0;
   if (i5 | 0) {
    i2 = HEAP32[i5 + 44 >> 2] | 0;
    do if (!i2) i2 = 0; else {
     i1 = HEAP32[i14 + 108 >> 2] | 0;
     if ((i1 | 0) <= (i11 | 0)) if ((i11 - i1 | 0) < (HEAP32[(HEAP32[i14 + 100 >> 2] | 0) + 124 >> 2] | 0)) {
      i2 = HEAP32[i14 + 92 >> 2] | 0;
      break;
     }
     i3 = HEAP32[i9 + 180 >> 2] | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i4 + 1;
     i3 = (i3 | 0) == 0 ? 0 : i9 + i3 | 0;
     i1 = i2 + -1 | 0;
     if ((i1 | 0) > 0) {
      i2 = 0;
      do {
       i8 = (i1 + 1 + i2 | 0) / 2 | 0;
       i27 = (HEAP32[i3 + (i8 << 2) >> 2] | 0) > (i11 | 0);
       i2 = i27 ? i2 : i8;
       i1 = i27 ? i8 + -1 | 0 : i1;
      } while ((i1 | 0) > (i2 | 0));
     } else i2 = 0;
     HEAP32[i12 >> 2] = i4;
    } while (0);
    if ((i2 | 0) != -1 & (i5 | 0) != 0) {
     i1 = (HEAP32[i5 + 32 >> 2] | 0) + ((HEAP32[i5 + 40 >> 2] | 0) + (i2 << 5)) | 0;
     if (i1 | 0) {
      i8 = HEAP32[i1 >> 2] | 0;
      i27 = HEAP32[i9 + (HEAP32[i9 + 180 >> 2] | 0) + (i2 << 2) >> 2] | 0;
      i12 = i9 + (HEAP32[i9 + 184 >> 2] | 0) | 0;
      i9 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
      i12 = (HEAP32[i12 + (i2 + 1 << 2) >> 2] | 0) - i9 | 0;
      HEAP32[i14 + 92 >> 2] = i2;
      HEAP32[i14 + 96 >> 2] = i1;
      HEAP32[i14 + 100 >> 2] = i8;
      HEAP32[i14 + 104 >> 2] = i10;
      HEAP32[i14 + 108 >> 2] = i27;
      HEAP32[i14 + 112 >> 2] = i9;
      HEAP32[i14 + 116 >> 2] = i12;
      i11 = i11 - i27 | 0;
      break;
     }
    }
   }
  }
  HEAP32[i14 + 92 >> 2] = 0;
  HEAP32[i14 + 96 >> 2] = 0;
  HEAP32[i14 + 100 >> 2] = i10;
  HEAP32[i14 + 104 >> 2] = i10;
  HEAP32[i14 + 108 >> 2] = 0;
  HEAP32[i14 + 112 >> 2] = 0;
  HEAP32[i14 + 116 >> 2] = 0;
 } while (0);
 if ((i11 | 0) == -1) {
  i27 = 5;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i27 | 0;
 }
 i12 = i22 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i27 = (i17 & 1 | 0) != 0 & f21 >= Math_fround(0.0);
 i4 = i25 + 4 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 if (i27) {
  i1 = i3 + 24208 | 0;
  if (i1 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) i1 = 0; else {
   HEAP32[i23 >> 2] = i1;
   i1 = i3;
  }
  __ZN5Umbra12RegionFinderC2EPNS_12QueryContextEiRKNS_7Vector3Efb(i1, i25, i11, i20, f21, (i17 & 2 | 0) != 0);
  if (!i1) {
   i27 = 2;
   __ZN5Umbra12QueryContextD2Ev(i25);
   STACKTOP = i26;
   return i27 | 0;
  }
  if (!(HEAP32[i24 >> 2] | 0)) __ZN5Umbra12RegionFinder7executeEPNS_8UserListIiEEPNS1_IfEES5_S3_(i1, i22, i13, i7, i6);
  i2 = HEAP32[i1 + 24192 >> 2] | 0;
  if (i2 | 0) HEAP32[(HEAP32[i1 + 144 >> 2] | 0) + 16 >> 2] = i2 + -16;
  i2 = HEAP32[i1 + 152 >> 2] | 0;
  if (i2 | 0) HEAP32[(HEAP32[i1 + 148 >> 2] | 0) + 12 >> 2] = i2 + -16;
  i2 = HEAP32[i1 + 120 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 124 >> 2];
  i2 = HEAP32[i1 + 84 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 88 >> 2];
  i2 = HEAP32[i1 + 48 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 52 >> 2];
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if (i2) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 } else {
  i2 = i3 + 80128 | 0;
  i8 = HEAP32[i15 >> 2] | 0;
  if (i2 >>> 0 > i8 >>> 0) {
   i1 = 0;
   i2 = i3;
  } else {
   HEAP32[i23 >> 2] = i2;
   i1 = i3;
  }
  HEAP32[i1 >> 2] = i25;
  HEAP32[i1 + 4 >> 2] = i17;
  HEAP32[i1 + 8 >> 2] = i4;
  i7 = i25 + 44 | 0;
  i9 = i1 + 20 | 0;
  HEAP32[i9 >> 2] = i7;
  i5 = HEAP32[i16 >> 2] | 0;
  i10 = i1 + 24 | 0;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i1 + 28 >> 2] = 20;
  HEAP32[i1 + 44 >> 2] = i4;
  i6 = i1 + 56 | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i16 >> 2] = i5 + 2;
  i7 = i1 + 60 | 0;
  HEAP32[i7 >> 2] = i5 + 1;
  HEAP32[i1 + 64 >> 2] = 8;
  i5 = i1 + 92 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  i5 = i1 + 80112 | 0;
  HEAP32[i5 >> 2] = 0;
  i3 = (HEAP32[(HEAP32[HEAP32[i25 >> 2] >> 2] | 0) + 124 >> 2] | 0) + 31 >> 5;
  i4 = i2 + ((i3 << 2) + 31 & -16) | 0;
  if (i4 >>> 0 > i8 >>> 0) i19 = 46; else {
   HEAP32[i23 >> 2] = i4;
   if (!i2) i19 = 46; else {
    HEAP32[i2 >> 2] = i3;
    i2 = i2 + 16 | 0;
    HEAP32[i5 >> 2] = i2;
    if (!(HEAP32[i24 >> 2] | 0)) {
     __ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf(i1, i22, 0, i11, i20, f21, i18) | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    if (i2 | 0) HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] = i2 + -16;
   }
  }
  if ((i19 | 0) == 46) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i24 >> 2] = 2;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2) HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
 }
 HEAP32[i23 >> 2] = i1;
 i27 = (HEAP32[i12 >> 2] | 0) > (HEAP32[i22 + 4 >> 2] | 0) ? 2 : HEAP32[i24 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i25);
 STACKTOP = i26;
 return i27 | 0;
}

function __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 44 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 48 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 56 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 64 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 68 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 72 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 80 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 88 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 92 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 104 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 108 | 0, i6);
 i1 = i5 + 100 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 140 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 141 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 142 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 143 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 60 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i7 >> 2] = i2;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 128 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 124 | 0;
  __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZN10TagManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 32436 + 8;
 i2 = gb + 63648 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 48 >> 0] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 i3 = i1 + 100 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 80 >> 0] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 i3 = i1 + 132 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 112 >> 0] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 i3 = i1 + 164 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 144 >> 0] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 i3 = i1 + 196 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 176 >> 0] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 i3 = i1 + 228 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 208 >> 0] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 i3 = i1 + 260 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 240 >> 0] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 i3 = i1 + 292 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 272 >> 0] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = 0;
 i3 = i1 + 324 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 304 >> 0] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 i3 = i1 + 356 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 336 >> 0] = 0;
 HEAP32[i1 + 364 >> 2] = 0;
 HEAP32[i1 + 384 >> 2] = 0;
 i3 = i1 + 388 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 368 >> 0] = 0;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP32[i1 + 416 >> 2] = 0;
 i3 = i1 + 420 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 400 >> 0] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP32[i1 + 448 >> 2] = 0;
 i3 = i1 + 452 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 432 >> 0] = 0;
 HEAP32[i1 + 460 >> 2] = 0;
 HEAP32[i1 + 480 >> 2] = 0;
 i3 = i1 + 484 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 464 >> 0] = 0;
 HEAP32[i1 + 492 >> 2] = 0;
 HEAP32[i1 + 512 >> 2] = 0;
 i3 = i1 + 516 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 496 >> 0] = 0;
 HEAP32[i1 + 524 >> 2] = 0;
 HEAP32[i1 + 544 >> 2] = 0;
 i3 = i1 + 548 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 528 >> 0] = 0;
 HEAP32[i1 + 556 >> 2] = 0;
 HEAP32[i1 + 576 >> 2] = 0;
 i3 = i1 + 580 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 560 >> 0] = 0;
 HEAP32[i1 + 588 >> 2] = 0;
 HEAP32[i1 + 608 >> 2] = 0;
 i3 = i1 + 612 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 592 >> 0] = 0;
 HEAP32[i1 + 620 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = 0;
 i3 = i1 + 644 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 624 >> 0] = 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 i3 = i1 + 676 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 656 >> 0] = 0;
 HEAP32[i1 + 684 >> 2] = 0;
 HEAP32[i1 + 704 >> 2] = 0;
 i3 = i1 + 708 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 688 >> 0] = 0;
 HEAP32[i1 + 716 >> 2] = 0;
 HEAP32[i1 + 736 >> 2] = 0;
 i3 = i1 + 740 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 720 >> 0] = 0;
 HEAP32[i1 + 748 >> 2] = 0;
 HEAP32[i1 + 768 >> 2] = 0;
 i3 = i1 + 772 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 752 >> 0] = 0;
 HEAP32[i1 + 780 >> 2] = 0;
 HEAP32[i1 + 800 >> 2] = 0;
 i3 = i1 + 804 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 784 >> 0] = 0;
 HEAP32[i1 + 812 >> 2] = 0;
 HEAP32[i1 + 832 >> 2] = 0;
 i3 = i1 + 836 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 816 >> 0] = 0;
 HEAP32[i1 + 844 >> 2] = 0;
 HEAP32[i1 + 864 >> 2] = 0;
 i3 = i1 + 868 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 848 >> 0] = 0;
 HEAP32[i1 + 876 >> 2] = 0;
 HEAP32[i1 + 896 >> 2] = 0;
 i3 = i1 + 900 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 880 >> 0] = 0;
 HEAP32[i1 + 908 >> 2] = 0;
 HEAP32[i1 + 928 >> 2] = 0;
 i3 = i1 + 932 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 912 >> 0] = 0;
 HEAP32[i1 + 940 >> 2] = 0;
 HEAP32[i1 + 960 >> 2] = 0;
 i3 = i1 + 964 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 944 >> 0] = 0;
 HEAP32[i1 + 972 >> 2] = 0;
 HEAP32[i1 + 992 >> 2] = 0;
 i3 = i1 + 996 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 976 >> 0] = 0;
 HEAP32[i1 + 1004 >> 2] = 0;
 HEAP32[i1 + 1024 >> 2] = 0;
 i3 = i1 + 1028 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 1008 >> 0] = 0;
 HEAP32[i1 + 1036 >> 2] = 0;
 HEAP32[i1 + 1056 >> 2] = 0;
 i3 = i1 + 1060 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 1040 >> 0] = 0;
 HEAP32[i1 + 1068 >> 2] = 0;
 HEAP32[i1 + 1072 >> 2] = 0;
 HEAP32[i1 + 1076 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63528 | 0, 16, gb + 373187 | 0, gb + 1576256 | 0, gb + 370982 | 0, 32) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[i1 + 36 >> 2] = i3;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63528 | 0, 16, gb + 370982 | 0, 34) | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = i2;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63528 | 0, 16, gb + 370982 | 0, 35) | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 + 32 >> 2] = i2;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63528 | 0, 16, gb + 370982 | 0, 36) | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = i2;
 __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i1);
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_124HfTrianglesEntityReport27onEventEjPj(i51, i1, i5) {
 i51 = i51 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i53 + 76 | 0;
 i6 = i53 + 48 | 0;
 i46 = i53 + 36 | 0;
 i47 = i53 + 24 | 0;
 i48 = i53 + 12 | 0;
 i49 = i53;
 if (HEAP8[i51 + 68 >> 0] | 0) {
  if (!i1) {
   i52 = 1;
   STACKTOP = i53;
   return i52 | 0;
  }
  i6 = i51 + 60 | 0;
  i7 = i51 + 52 | 0;
  i8 = i51 + 64 | 0;
  i9 = i51 + 56 | 0;
  i10 = i51 + 48 | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break;
   i4 = HEAP32[i8 >> 2] | 0;
   if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) HEAP32[i8 >> 2] = i4 + 1; else {
    HEAP32[i6 >> 2] = i3 + 1;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   }
   if (!i1) {
    i50 = 1;
    i52 = 19;
    break;
   } else i5 = i5 + 4 | 0;
  }
  if ((i52 | 0) == 19) {
   STACKTOP = i53;
   return i50 | 0;
  }
  HEAP8[i51 + 69 >> 0] = 1;
  i52 = 0;
  STACKTOP = i53;
  return i52 | 0;
 }
 f11 = Math_fround(HEAPF32[i51 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i51 + 36 >> 2]);
 f13 = Math_fround(HEAPF32[i51 + 40 >> 2]);
 f14 = Math_fround(HEAPF32[i51 + 44 >> 2]);
 f15 = Math_fround(HEAPF32[i51 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i51 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i51 + 16 >> 2]);
 if (!i1) {
  i52 = 1;
  STACKTOP = i53;
  return i52 | 0;
 }
 i7 = i51 + 4 | 0;
 i8 = i6 + 4 | 0;
 i9 = i6 + 8 | 0;
 i10 = i6 + 12 | 0;
 i18 = i6 + 16 | 0;
 i19 = i6 + 20 | 0;
 i20 = i6 + 24 | 0;
 i21 = i45 + 4 | 0;
 i22 = i45 + 8 | 0;
 f23 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 i24 = i46 + 4 | 0;
 i25 = i46 + 8 | 0;
 i26 = i45 + 12 | 0;
 i27 = i45 + 16 | 0;
 i28 = i45 + 20 | 0;
 i29 = i47 + 4 | 0;
 i30 = i47 + 8 | 0;
 i31 = i45 + 24 | 0;
 i32 = i45 + 28 | 0;
 i33 = i45 + 32 | 0;
 i34 = i48 + 4 | 0;
 i35 = i48 + 8 | 0;
 i36 = i49 + 4 | 0;
 i37 = i49 + 8 | 0;
 i38 = i51 + 20 | 0;
 i39 = i51 + 60 | 0;
 i40 = i51 + 52 | 0;
 i41 = i51 + 64 | 0;
 i42 = i51 + 56 | 0;
 i43 = i51 + 48 | 0;
 i44 = 0;
 L21 : while (1) {
  i4 = HEAP32[i7 >> 2] | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i2 = i5 + (i44 << 2) | 0;
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i4, i6, i45, 0, 0, HEAP32[i2 >> 2] | 0, 0, 0) | 0;
  f56 = Math_fround(Math_fround(HEAPF32[i45 >> 2]) - f15);
  f59 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f16);
  f56 = Math_fround(f56 * Math_fround(2.0));
  f59 = Math_fround(f59 * Math_fround(2.0));
  f54 = Math_fround(Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f17) * Math_fround(2.0));
  f58 = Math_fround(Math_fround(Math_fround(f11 * f56) + Math_fround(f12 * f59)) + Math_fround(f13 * f54));
  f57 = Math_fround(Math_fround(f12 * f58) + Math_fround(Math_fround(f23 * f59) - Math_fround(f14 * Math_fround(Math_fround(f13 * f56) - Math_fround(f11 * f54)))));
  f55 = Math_fround(Math_fround(Math_fround(f23 * f54) - Math_fround(f14 * Math_fround(Math_fround(f11 * f59) - Math_fround(f12 * f56)))) + Math_fround(f13 * f58));
  HEAPF32[i46 >> 2] = Math_fround(Math_fround(f11 * f58) + Math_fround(Math_fround(f23 * f56) - Math_fround(f14 * Math_fround(Math_fround(f12 * f54) - Math_fround(f13 * f59)))));
  HEAPF32[i24 >> 2] = f57;
  HEAPF32[i25 >> 2] = f55;
  f55 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f15);
  f57 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f16);
  f55 = Math_fround(f55 * Math_fround(2.0));
  f57 = Math_fround(f57 * Math_fround(2.0));
  f59 = Math_fround(Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f17) * Math_fround(2.0));
  f54 = Math_fround(Math_fround(Math_fround(f11 * f55) + Math_fround(f12 * f57)) + Math_fround(f13 * f59));
  f56 = Math_fround(Math_fround(f12 * f54) + Math_fround(Math_fround(f23 * f57) - Math_fround(f14 * Math_fround(Math_fround(f13 * f55) - Math_fround(f11 * f59)))));
  f58 = Math_fround(Math_fround(Math_fround(f23 * f59) - Math_fround(f14 * Math_fround(Math_fround(f11 * f57) - Math_fround(f12 * f55)))) + Math_fround(f13 * f54));
  HEAPF32[i47 >> 2] = Math_fround(Math_fround(f11 * f54) + Math_fround(Math_fround(f23 * f55) - Math_fround(f14 * Math_fround(Math_fround(f12 * f59) - Math_fround(f13 * f57)))));
  HEAPF32[i29 >> 2] = f56;
  HEAPF32[i30 >> 2] = f58;
  f58 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f15);
  f56 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f16);
  f58 = Math_fround(f58 * Math_fround(2.0));
  f56 = Math_fround(f56 * Math_fround(2.0));
  f57 = Math_fround(Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f17) * Math_fround(2.0));
  f59 = Math_fround(Math_fround(Math_fround(f11 * f58) + Math_fround(f12 * f56)) + Math_fround(f13 * f57));
  f55 = Math_fround(Math_fround(f12 * f59) + Math_fround(Math_fround(f23 * f56) - Math_fround(f14 * Math_fround(Math_fround(f13 * f58) - Math_fround(f11 * f57)))));
  f54 = Math_fround(Math_fround(Math_fround(f23 * f57) - Math_fround(f14 * Math_fround(Math_fround(f11 * f56) - Math_fround(f12 * f58)))) + Math_fround(f13 * f59));
  HEAPF32[i48 >> 2] = Math_fround(Math_fround(f11 * f59) + Math_fround(Math_fround(f23 * f58) - Math_fround(f14 * Math_fround(Math_fround(f12 * f57) - Math_fround(f13 * f56)))));
  HEAPF32[i34 >> 2] = f55;
  HEAPF32[i35 >> 2] = f54;
  HEAPF32[i49 >> 2] = Math_fround(0.0);
  HEAPF32[i36 >> 2] = Math_fround(0.0);
  HEAPF32[i37 >> 2] = Math_fround(0.0);
  do if (__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i49, i38, i46, i47, i48) | 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i39 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i40 >> 2] | 0) >>> 0) break L21;
   i4 = HEAP32[i41 >> 2] | 0;
   if (i4 >>> 0 < (HEAP32[i42 >> 2] | 0) >>> 0) {
    HEAP32[i41 >> 2] = i4 + 1;
    break;
   } else {
    HEAP32[i39 >> 2] = i3 + 1;
    HEAP32[(HEAP32[i43 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    break;
   }
  } while (0);
  i44 = i44 + 1 | 0;
  if (i44 >>> 0 >= i1 >>> 0) {
   i50 = 1;
   i52 = 19;
   break;
  }
 }
 if ((i52 | 0) == 19) {
  STACKTOP = i53;
  return i50 | 0;
 }
 HEAP8[i51 + 69 >> 0] = 1;
 i52 = 0;
 STACKTOP = i53;
 return i52 | 0;
}

function __ZN20SpeedTreeWindManager6UpdateEf(i23, f27) {
 i23 = i23 | 0;
 f27 = Math_fround(f27);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f24 = f0, f25 = f0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30;
 i14 = i23 + 48 | 0;
 f25 = Math_fround(HEAPF32[i14 >> 2]);
 i29 = i23 + 52 | 0;
 f5 = Math_fround(HEAPF32[i29 >> 2]);
 if (f25 != f5) {
  i13 = HEAP32[gb + 1170608 >> 2] | 0;
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  i6 = i1;
  if ((i6 | 0) == (i13 | 0)) {
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i9 = i28 + 4 | 0;
   i10 = i28 + 8 | 0;
   i11 = i28 + 12 | 0;
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   do {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (!(HEAP32[i1 + 36 >> 2] | 0)) if (__ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, gb + 1155204 | 0, i28) | 0) {
     f25 = Math_fround(HEAPF32[i28 >> 2]);
     f4 = Math_fround(HEAPF32[i9 >> 2]);
     f2 = Math_fround(HEAPF32[i10 >> 2]);
     f3 = Math_fround(HEAPF32[i11 >> 2]);
     f5 = Math_fround(f5 + Math_fround(f25 * f3));
     f8 = Math_fround(f8 + Math_fround(f4 * f3));
     f7 = Math_fround(f7 + Math_fround(f2 * f3));
     f3 = f5;
     f2 = f8;
     f4 = f7;
    }
    i1 = HEAP32[i6 + 4 >> 2] | 0;
    i6 = i1;
   } while ((i6 | 0) != (i13 | 0));
   i1 = HEAP32[i29 >> 2] | 0;
  }
  HEAPF32[i23 + 36 >> 2] = f3;
  HEAPF32[i23 + 40 >> 2] = f2;
  HEAPF32[i23 + 44 >> 2] = f4;
  HEAP32[i14 >> 2] = i1;
  i19 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i19 = HEAP32[i23 + 36 >> 2] | 0;
  i20 = HEAP32[i23 + 40 >> 2] | 0;
  i21 = HEAP32[i23 + 44 >> 2] | 0;
 }
 i11 = i23 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  d12 = +f27;
  f3 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)));
  i13 = i28 + 4 | 0;
  i14 = i28 + 8 | 0;
  i15 = i28 + 12 | 0;
  i16 = i28 + 4 | 0;
  i17 = i28 + 8 | 0;
  i18 = i28 + 12 | 0;
  i10 = 0;
  i6 = HEAP32[i23 >> 2] | 0;
  do {
   i9 = HEAP32[i6 + (i10 << 3) >> 2] | 0;
   if (!(HEAP8[i6 + (i10 << 3) + 4 >> 0] | 0)) HEAPF64[i9 + 1392 >> 3] = d12; else {
    f2 = Math_fround(Math_sqrt(Math_fround(f7)));
    i26 = f2 < Math_fround(0.0);
    f25 = Math_fround(-f2);
    if (!((i26 ? f25 : f2) <= Math_fround(9.99999997e-07))) {
     f24 = Math_fround(f4 / f2);
     f25 = Math_fround(f5 / f2);
     HEAPF32[i28 >> 2] = Math_fround(f3 / f2);
     HEAPF32[i13 >> 2] = f24;
     HEAPF32[i14 >> 2] = f25;
     HEAPF32[i15 >> 2] = f2;
     __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i9, i28);
    } else {
     i6 = HEAP32[i9 + 1488 >> 2] | 0;
     i26 = HEAP32[i9 + 1492 >> 2] | 0;
     HEAP32[i28 >> 2] = HEAP32[i9 + 1484 >> 2];
     HEAP32[i16 >> 2] = i6;
     HEAP32[i17 >> 2] = i26;
     HEAPF32[i18 >> 2] = Math_fround(0.0);
     __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i9, i28);
    }
    __ZN13SpeedTreeWind7AdvanceEbd(HEAP32[(HEAP32[i23 >> 2] | 0) + (i10 << 3) >> 2] | 0, 1, d12);
    i6 = HEAP32[i23 >> 2] | 0;
    HEAP8[i6 + (i10 << 3) + 4 >> 0] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < i1 >>> 0);
 }
 i6 = HEAP32[i23 + 20 >> 2] | 0;
 i26 = i23 + 24 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i6 | 0) == (i1 | 0)) {
  HEAPF32[i29 >> 2] = f27;
  STACKTOP = i30;
  return;
 }
 d12 = +f27;
 f25 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i14 = i28 + 4 | 0;
 i15 = i28 + 8 | 0;
 i16 = i28 + 12 | 0;
 i17 = i28 + 4 | 0;
 i18 = i28 + 8 | 0;
 i19 = i28 + 12 | 0;
 i20 = i28 + 4 | 0;
 i21 = i28 + 8 | 0;
 i23 = i28 + 12 | 0;
 do {
  i11 = HEAP32[i6 >> 2] | 0;
  i13 = i11 + 1896 | 0;
  if (!(HEAP8[i13 >> 0] | 0)) HEAPF64[i11 + 1416 >> 3] = d12; else {
   i10 = HEAP32[gb + 1170608 >> 2] | 0;
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   i9 = i1;
   if ((i9 | 0) == (i10 | 0)) {
    f2 = Math_fround(0.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
   } else {
    f2 = Math_fround(0.0);
    f3 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    f8 = Math_fround(0.0);
    f7 = Math_fround(0.0);
    do {
     i1 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i1 + 36 >> 2] | 0) == 1) if (__ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, i11, i28) | 0) {
      f31 = Math_fround(HEAPF32[i28 >> 2]);
      f4 = Math_fround(HEAPF32[i20 >> 2]);
      f3 = Math_fround(HEAPF32[i21 >> 2]);
      f2 = Math_fround(HEAPF32[i23 >> 2]);
      f5 = Math_fround(f5 + Math_fround(f31 * f2));
      f8 = Math_fround(f8 + Math_fround(f4 * f2));
      f7 = Math_fround(f7 + Math_fround(f3 * f2));
      f2 = f5;
      f3 = f8;
      f4 = f7;
     }
     i1 = HEAP32[i9 + 4 >> 2] | 0;
     i9 = i1;
    } while ((i9 | 0) != (i10 | 0));
   }
   i1 = i11 + 24 | 0;
   f7 = Math_fround(f25 + f2);
   f5 = Math_fround(f24 + f3);
   f2 = Math_fround(f22 + f4);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5)) + Math_fround(f2 * f2))));
   i10 = f3 < Math_fround(0.0);
   f31 = Math_fround(-f3);
   if (!((i10 ? f31 : f3) <= Math_fround(9.99999997e-07))) {
    f8 = Math_fround(f5 / f3);
    f31 = Math_fround(f2 / f3);
    HEAPF32[i28 >> 2] = Math_fround(f7 / f3);
    HEAPF32[i14 >> 2] = f8;
    HEAPF32[i15 >> 2] = f31;
    HEAPF32[i16 >> 2] = f3;
    __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i1, i28);
   } else {
    i9 = HEAP32[i11 + 1512 >> 2] | 0;
    i10 = HEAP32[i11 + 1516 >> 2] | 0;
    HEAP32[i28 >> 2] = HEAP32[i11 + 1508 >> 2];
    HEAP32[i17 >> 2] = i9;
    HEAP32[i18 >> 2] = i10;
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i1, i28);
   }
   __ZN13SpeedTreeWind7AdvanceEbd(i1, 1, d12);
   HEAP8[i13 >> 0] = 0;
   i1 = HEAP32[i26 >> 2] | 0;
  }
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) != (i1 | 0));
 HEAPF32[i29 >> 2] = f27;
 STACKTOP = i30;
 return;
}

function __Z24Resources_CUSTOM_LoadAllP12Il2CppStringP12Il2CppObject(i1, i24) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i30 + 48 | 0;
 i26 = i30 + 44 | 0;
 i2 = i30 + 40 | 0;
 i3 = i30 + 32 | 0;
 i29 = i30 + 16 | 0;
 i28 = i30 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if (__ZNK11ICallString6IsNullEv(i2) | 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 560488 | 0, i30);
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i24);
 i23 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i24) | 0;
 __ZN15ResourceManager6GetAllEv(i3, __Z18GetResourceManagerv() | 0);
 __ZNK11ICallString6ToUTF8Ev(i25, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i29, i25);
 i20 = i29 + 11 | 0;
 i22 = HEAP8[i20 >> 0] | 0;
 i2 = i22 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i29 >> 2] | 0 : i29;
 i21 = i29 + 4 | 0;
 i22 = i2 ? HEAP32[i21 >> 2] | 0 : i22 & 255;
 i2 = i1 + i22 | 0;
 if (i22 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 HEAP32[i28 >> 2] = 0;
 i22 = i28 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i9 = i3 + 4 | 0;
 if ((i2 | 0) != (HEAP32[i9 >> 2] | 0)) {
  i10 = i28 + 8 | 0;
  i11 = i25 + 4 | 0;
  i12 = i25 + 8 | 0;
  i13 = i25 + 12 | 0;
  i14 = i25 + 13 | 0;
  i15 = i25 + 14 | 0;
  i16 = i25 + 16 | 0;
  i17 = i25 + 20 | 0;
  i18 = i25 + 21 | 0;
  i19 = i25 + 22 | 0;
  i8 = i2;
  while (1) {
   i2 = i8 + 16 | 0;
   i6 = HEAP8[i20 >> 0] | 0;
   i4 = i6 << 24 >> 24 < 0;
   i6 = i4 ? HEAP32[i21 >> 2] | 0 : i6 & 255;
   i7 = HEAP8[i2 + 11 >> 0] | 0;
   i3 = i7 << 24 >> 24 < 0;
   i7 = i3 ? HEAP32[i8 + 20 >> 2] | 0 : i7 & 255;
   L15 : do if (i7 >>> 0 >= i6 >>> 0) {
    if (i6 | 0) {
     i5 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
     i3 = i4 ? HEAP32[i29 >> 2] | 0 : i29;
     i2 = 0;
     do {
      i33 = HEAP8[i5 + i2 >> 0] | 0;
      i32 = i33 << 24 >> 24;
      i31 = HEAP8[i3 + i2 >> 0] | 0;
      i4 = i31 << 24 >> 24;
      i2 = i2 + 1 | 0;
      if ((((i33 + -65 & 255) < 26 ? i32 + 32 | 0 : i32) & 255) << 24 >> 24 != (((i31 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255) << 24 >> 24) break L15;
     } while (i2 >>> 0 < i6 >>> 0);
     if ((i7 | 0) != (i6 | 0)) if ((HEAP8[i5 + i6 >> 0] | 0) != 47) if ((HEAP8[i3 + (i6 + -1) >> 0] | 0) != 47) break;
    }
    i5 = i8 + 32 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i26 >> 2] = i2;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i27 = 28; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i25, i2, i26);
       i3 = HEAP32[i25 >> 2] | 0;
       i33 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i33 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i33 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i27 = 28; else {
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i2) i27 = 30;
      }
     }
     if ((i27 | 0) == 28) i27 = 30;
     if ((i27 | 0) == 30) {
      i27 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
      if (!i2) break;
     }
     i3 = __Z18GetResourceManagerv() | 0;
     __ZN15ResourceManager19PreloadDependenciesEi(i3, HEAP32[i2 + 4 >> 2] | 0);
     i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
     if (i3 | 0) {
      if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i3) | 0, i23) | 0) {
       i2 = HEAP32[i22 >> 2] | 0;
       if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) {
        __ZNSt3__26vectorI4PPtrI6ObjectENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i28, i5);
        break;
       } else {
        HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i22 >> 2] = i2 + 4;
        break;
       }
      }
      if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) {
       HEAP32[i25 >> 2] = i2;
       HEAP32[i11 >> 2] = i24;
       HEAP32[i12 >> 2] = 0;
       HEAP8[i13 >> 0] = 0;
       HEAP8[i14 >> 0] = 1;
       HEAP8[i15 >> 0] = 1;
       HEAP32[i16 >> 2] = 0;
       HEAP8[i17 >> 0] = 1;
       HEAP8[i18 >> 0] = 0;
       HEAP8[i19 >> 0] = 0;
       i2 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i25) | 0;
       if (i2 | 0) {
        i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
        if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
        HEAP32[i26 >> 2] = i2;
        i3 = HEAP32[i22 >> 2] | 0;
        if ((i3 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorI4PPtrI6ObjectENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i28, i26); else {
         HEAP32[i3 >> 2] = i2;
         HEAP32[i22 >> 2] = i3 + 4;
        }
       }
      }
     }
    }
   } while (0);
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) break; else {
    i1 = i2;
    i8 = i2;
   }
  }
 }
 i3 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(0) | 0;
 i1 = __Z19GetScriptingManagerv() | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i1 + 168 >> 2] | 0) + (HEAP32[i3 + 24 >> 2] << 2) >> 2] | 0, 4, (HEAP32[i22 >> 2] | 0) - (HEAP32[i28 >> 2] | 0) >> 2) | 0;
 __Z34FillScriptingArrayFromUnityObjectsINSt3__26vectorI4PPtrI6ObjectENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i3, i28, 0) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (!i1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
  STACKTOP = i30;
  return i3 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i22 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
 STACKTOP = i30;
 return i3 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i17, i31, i5) {
 i17 = i17 | 0;
 i31 = i31 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i36 + 12 | 0;
 i33 = i36;
 i34 = i17 + 92 | 0;
 i35 = i17 + 96 | 0;
 HEAP32[i35 >> 2] = 32;
 i11 = i17 + 108 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 104 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 112 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 116 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i32 >> 2] = 65;
 HEAP32[i32 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1280, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i34 >> 2] | 0;
 if (i1 | 0) {
  i30 = HEAP32[i10 >> 2] | 0;
  HEAP32[i32 >> 2] = 65;
  HEAP32[i32 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i32);
 }
 HEAP32[i34 >> 2] = i2;
 i1 = i2 + ((HEAP32[i35 >> 2] | 0) * 40 | 0) | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i17 + 52 | 0;
  do {
   i14 = i2;
   i15 = i4;
   i16 = i14 + 40 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    i14 = i14 + 4 | 0;
    i15 = i15 + 4 | 0;
   } while ((i14 | 0) < (i16 | 0));
   i2 = i2 + 40 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i30 = i17 + 100 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 f3 = Math_fround(((HEAP32[i31 + 100 >> 2] | 0) - (HEAP32[i31 + 4 >> 2] | 0) | 0) >>> 0);
 i7 = 32;
 while (1) {
  if (i7 >>> 0 >= i5 >>> 0) {
   f8 = Math_fround(i7 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f3 >= f9)) break;
  }
  i7 = i7 << 1;
 }
 if (i7 >>> 0 > (HEAP32[i35 >> 2] | 0) >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i32 >> 2] = 65;
  HEAP32[i32 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 40 | 0, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i34 >> 2] | 0;
  i2 = HEAP32[i35 >> 2] | 0;
  i29 = i2 >>> 0 > i7 >>> 0 ? i7 : i2;
  i4 = i1 + (i29 * 40 | 0) | 0;
  if (i29) {
   i2 = i6;
   while (1) {
    i14 = i2;
    i15 = i1;
    i16 = i14 + 40 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     i14 = i14 + 4 | 0;
     i15 = i15 + 4 | 0;
    } while ((i14 | 0) < (i16 | 0));
    i1 = i1 + 40 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 40 | 0;
   }
   i2 = HEAP32[i35 >> 2] | 0;
  }
  i4 = i6 + (i7 * 40 | 0) | 0;
  if ((i2 | 0) != (i7 | 0)) {
   i5 = i17 + 52 | 0;
   i1 = i6 + (i2 * 40 | 0) | 0;
   do {
    i14 = i1;
    i15 = i5;
    i16 = i14 + 40 | 0;
    do {
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     i14 = i14 + 4 | 0;
     i15 = i15 + 4 | 0;
    } while ((i14 | 0) < (i16 | 0));
    i1 = i1 + 40 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  i29 = HEAP32[i34 >> 2] | 0;
  i28 = HEAP32[i10 >> 2] | 0;
  HEAP32[i32 >> 2] = 65;
  HEAP32[i32 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i29, i32);
  HEAP32[i34 >> 2] = i6;
  HEAP32[i35 >> 2] = i7;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 }
 i18 = i31 + 92 | 0;
 i21 = HEAP32[i18 >> 2] | 0;
 i19 = i31 + 96 | 0;
 i1 = i21 + ((HEAP32[i19 >> 2] | 0) * 40 | 0) | 0;
 HEAP32[i32 >> 2] = i31;
 i20 = i32 + 4 | 0;
 HEAP32[i20 >> 2] = i21;
 HEAP32[i32 + 8 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i32);
 i1 = (HEAP32[i18 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 40 | 0) | 0;
 HEAP32[i33 >> 2] = i31;
 i21 = i33 + 4 | 0;
 HEAP32[i21 >> 2] = i1;
 i22 = i33 + 8 | 0;
 HEAP32[i22 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i33);
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i21 >> 2] | 0)) {
  STACKTOP = i36;
  return;
 }
 i23 = i17 + 52 | 0;
 i24 = i17 + 56 | 0;
 i25 = i17 + 60 | 0;
 i26 = i17 + 64 | 0;
 i27 = i17 + 68 | 0;
 i28 = i17 + 72 | 0;
 i29 = i17 + 76 | 0;
 i17 = i17 + 80 | 0;
 do {
  i5 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
  i6 = HEAP32[i34 >> 2] | 0;
  i7 = HEAP32[i23 >> 2] | 0;
  i10 = HEAP32[i24 >> 2] | 0;
  i11 = HEAP32[i25 >> 2] | 0;
  i12 = HEAP32[i26 >> 2] | 0;
  i13 = HEAP32[i27 >> 2] | 0;
  i14 = HEAP32[i28 >> 2] | 0;
  i15 = HEAP32[i29 >> 2] | 0;
  i16 = HEAP32[i17 >> 2] | 0;
  i4 = 0;
  i2 = HEAP32[i1 + 32 >> 2] | 0;
  while (1) {
   i2 = i2 & i5;
   if ((i7 | 0) == (HEAP32[i6 + (i2 * 40 | 0) >> 2] | 0)) if ((i10 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 4 >> 2] | 0)) if ((i11 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 8 >> 2] | 0)) if ((i12 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 12 >> 2] | 0)) if ((i13 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 16 >> 2] | 0)) if ((i14 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 20 >> 2] | 0)) if ((i15 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 24 >> 2] | 0)) if ((i16 | 0) == (HEAP32[i6 + (i2 * 40 | 0) + 28 >> 2] | 0)) break;
   i37 = i4 + 1 | 0;
   i4 = i37;
   i2 = i37 + i2 | 0;
  }
  i14 = i6 + (i2 * 40 | 0) | 0;
  i15 = i1;
  i16 = i14 + 40 | 0;
  do {
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   i14 = i14 + 4 | 0;
   i15 = i15 + 4 | 0;
  } while ((i14 | 0) < (i16 | 0));
  HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 1;
  HEAP32[i20 >> 2] = i1 + 40;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i32);
  i37 = (HEAP32[i18 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i33 >> 2] = i31;
  HEAP32[i21 >> 2] = i37;
  HEAP32[i22 >> 2] = i37;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i33);
  i1 = HEAP32[i20 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i21 >> 2] | 0));
 STACKTOP = i36;
 return;
}

function __ZN14AreaEffector2D21ContactUpdateCallbackEf(i4, f26) {
 i4 = i4 | 0;
 f26 = Math_fround(f26);
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30;
 i28 = i30 + 16 | 0;
 f2 = Math_fround(HEAPF32[i4 + 96 >> 2]);
 f3 = Math_fround(HEAPF32[i4 + 100 >> 2]);
 i21 = i4 + 76 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 i22 = i22 << 11 ^ i22;
 i23 = i4 + 80 | 0;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 i21 = i4 + 84 | 0;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 i23 = i4 + 88 | 0;
 i24 = HEAP32[i23 >> 2] | 0;
 HEAP32[i21 >> 2] = i24;
 i24 = i22 >>> 8 ^ i22 ^ i24 ^ i24 >>> 19;
 HEAP32[i23 >> 2] = i24;
 f3 = Math_fround(f2 + Math_fround(f3 * Math_fround(Math_fround((i24 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
 f2 = Math_fround(Math_fround(HEAPF32[i4 + 92 >> 2]) * Math_fround(.0174532924));
 if (!(HEAP8[i4 + 116 >> 0] | 0)) {
  __ZNK9Transform11GetRotationEv(i27, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f1 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i24 = f1 < Math_fround(0.0);
  f20 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f9 = Math_fround(-f20);
  f25 = Math_fround(-f1);
  f1 = Math_fround(Math_fround(+Math_atan2(+(i24 ? f9 : f20), +(i24 ? f25 : f1))) * Math_fround(2.0));
 } else f1 = Math_fround(0.0);
 f20 = Math_fround(f2 + f1);
 f25 = Math_fround(f3 * Math_fround(+Math_cos(+f20)));
 f20 = Math_fround(f3 * Math_fround(+Math_sin(+f20)));
 i21 = (HEAP32[i4 + 112 >> 2] | 0) == 0;
 i22 = i4 + 36 | 0;
 i5 = HEAP32[i22 >> 2] | 0;
 i23 = i4 + 48 | 0;
 __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i5, i5 + ((HEAP32[i23 >> 2] | 0) * 40 | 0) | 0, i27);
 i5 = HEAP32[i22 >> 2] | 0;
 i24 = i4 + 104 | 0;
 i12 = i4 + 108 | 0;
 i13 = i27 + 8 | 0;
 i14 = i27 + 4 | 0;
 i15 = i27 + 12 | 0;
 i16 = i28 + 4 | 0;
 i17 = i28 + 8 | 0;
 i18 = i28 + 12 | 0;
 i4 = i5;
 i6 = HEAP32[i23 >> 2] | 0;
 while (1) {
  i19 = HEAP32[i4 + 16 >> 2] | 0;
  i7 = i5 + (i6 * 40 | 0) | 0;
  i8 = 0;
  while (1) {
   i10 = i4 + (i8 * 40 | 0) | 0;
   i5 = i8 + 1 | 0;
   i6 = i4 + (i5 * 40 | 0) | 0;
   if ((i6 | 0) == (i7 | 0)) {
    i11 = i7;
    break;
   }
   if ((HEAP32[i10 + 56 >> 2] | 0) == (i19 | 0)) i8 = i5; else {
    i11 = i6;
    break;
   }
  }
  if ((HEAP32[i19 >> 2] | 0) == 2) {
   if (i21) {
    i5 = HEAP32[i19 + 44 >> 2] | 0;
    i8 = HEAP32[i19 + 48 >> 2] | 0;
    i29 = 15;
   } else {
    i7 = HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 32 >> 2] | 0;
    mftCall_viiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i27 | 0, i19 + 12 | 0, HEAP32[i4 + 28 >> 2] | 0, 1);
    if ((i8 | 0) < 1) {
     f9 = Math_fround(HEAPF32[i27 >> 2]);
     f3 = Math_fround(HEAPF32[i13 >> 2]);
     f2 = Math_fround(HEAPF32[i14 >> 2]);
     f1 = Math_fround(HEAPF32[i15 >> 2]);
    } else {
     i5 = i4 + 40 | 0;
     while (1) {
      i8 = HEAP32[(HEAP32[i4 + 64 >> 2] | 0) + 32 >> 2] | 0;
      mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0, i28 | 0, (HEAP32[i4 + 56 >> 2] | 0) + 12 | 0, HEAP32[i4 + 68 >> 2] | 0, 1);
      f31 = Math_fround(HEAPF32[i27 >> 2]);
      f9 = Math_fround(HEAPF32[i28 >> 2]);
      f9 = f31 < f9 ? f31 : f9;
      f31 = Math_fround(HEAPF32[i14 >> 2]);
      f2 = Math_fround(HEAPF32[i16 >> 2]);
      f2 = f31 < f2 ? f31 : f2;
      HEAPF32[i27 >> 2] = f9;
      HEAPF32[i14 >> 2] = f2;
      f31 = Math_fround(HEAPF32[i13 >> 2]);
      f3 = Math_fround(HEAPF32[i17 >> 2]);
      f3 = f31 > f3 ? f31 : f3;
      f31 = Math_fround(HEAPF32[i15 >> 2]);
      f1 = Math_fround(HEAPF32[i18 >> 2]);
      f1 = f31 > f1 ? f31 : f1;
      HEAPF32[i13 >> 2] = f3;
      HEAPF32[i15 >> 2] = f1;
      i4 = i5 + 40 | 0;
      if (i4 >>> 0 > i10 >>> 0) break; else {
       i8 = i5;
       i5 = i4;
       i4 = i8;
      }
     }
    }
    f31 = Math_fround(Math_fround(f9 + f3) * Math_fround(.5));
    f1 = Math_fround(Math_fround(f2 + f1) * Math_fround(.5));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = HEAP32[i19 >> 2] | 0;
    if ((i4 | 0) == 2) {
     i8 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
     i29 = 15;
    }
   }
   if ((i29 | 0) == 15) {
    i29 = 0;
    i6 = i19 + 4 | 0;
    i4 = HEAP16[i6 >> 1] | 0;
    if (!(i4 & 2)) {
     i7 = i4 & 65535;
     if (!(i7 & 2)) {
      i4 = (i7 | 2) & 65535;
      HEAP16[i6 >> 1] = i4;
      HEAPF32[i19 + 144 >> 2] = Math_fround(0.0);
     }
    }
    if (!(i4 & 2)) i4 = 2; else {
     i4 = i19 + 76 | 0;
     HEAPF32[i4 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i4 >> 2]));
     i4 = i19 + 80 | 0;
     HEAPF32[i4 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i4 >> 2]));
     f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f9 = Math_fround(f9 - Math_fround(HEAPF32[i19 + 44 >> 2]));
     f31 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f31 = Math_fround(Math_fround(f20 * f9) - Math_fround(f25 * Math_fround(f31 - Math_fround(HEAPF32[i19 + 48 >> 2]))));
     i4 = i19 + 84 | 0;
     HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f31);
     i4 = 2;
    }
   }
   f1 = Math_fround(HEAPF32[i24 >> 2]);
   if (f1 > Math_fround(0.0)) {
    i8 = i19 + 64 | 0;
    f31 = Math_fround(HEAPF32[i8 >> 2]);
    i7 = i19 + 68 | 0;
    f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f1 * f26) + Math_fround(1.0)));
    f1 = Math_fround(f2 * f31);
    f2 = Math_fround(f2 * Math_fround(HEAPF32[i7 >> 2]));
    if (i4 | 0) {
     if (Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) > Math_fround(0.0)) {
      i5 = i19 + 4 | 0;
      i6 = HEAPU16[i5 >> 1] | 0;
      if (!(i6 & 2)) {
       HEAP16[i5 >> 1] = i6 | 2;
       HEAPF32[i19 + 144 >> 2] = Math_fround(0.0);
      }
     }
     HEAPF32[i8 >> 2] = f1;
     HEAPF32[i7 >> 2] = f2;
    }
   }
   f1 = Math_fround(HEAPF32[i12 >> 2]);
   if (f1 > Math_fround(0.0)) {
    i6 = i19 + 72 | 0;
    f1 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f1 * f26) + Math_fround(1.0))) * Math_fround(HEAPF32[i6 >> 2]));
    if (i4 | 0) {
     i5 = i19 + 4 | 0;
     i4 = HEAP16[i5 >> 1] | 0;
     if (!(i4 & 16)) {
      if (Math_fround(f1 * f1) > Math_fround(0.0)) {
       i4 = i4 & 65535;
       if (!(i4 & 2)) {
        HEAP16[i5 >> 1] = i4 | 2;
        HEAPF32[i19 + 144 >> 2] = Math_fround(0.0);
       }
      }
      HEAPF32[i6 >> 2] = f1;
     }
    }
   }
  }
  i5 = HEAP32[i22 >> 2] | 0;
  i6 = HEAP32[i23 >> 2] | 0;
  if ((i11 | 0) == (i5 + (i6 * 40 | 0) | 0)) break; else i4 = i11;
 }
 STACKTOP = i30;
 return;
}

function __Z23InitializeStdConvertersv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 i2 = HEAP32[gb + 36996 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i2, fb + 698 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i9, fb + 699 | 0);
 i2 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i9, fb + 700 | 0);
 i9 = HEAP32[gb + 37296 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i9, fb + 701 | 0);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i8, fb + 702 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i2, fb + 703 | 0);
 i1 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i1, fb + 704 | 0);
 i3 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i3, fb + 705 | 0);
 i4 = HEAP32[gb + 37240 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i4, fb + 706 | 0);
 i7 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i7, fb + 707 | 0);
 i6 = HEAP32[gb + 37252 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i6, fb + 708 | 0);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i9, i5, fb + 709 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i9, fb + 710 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i8, fb + 711 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i2, fb + 712 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i1, fb + 713 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i3, fb + 714 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i4, fb + 715 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i7, fb + 716 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i6, fb + 717 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, i5, fb + 718 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i9, fb + 719 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i8, fb + 720 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i2, fb + 721 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i1, fb + 722 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i3, fb + 723 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i4, fb + 724 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i7, fb + 725 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i6, fb + 726 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i5, fb + 727 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i9, fb + 728 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i8, fb + 729 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i2, fb + 730 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i1, fb + 731 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i3, fb + 732 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i4, fb + 733 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i7, fb + 734 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i6, fb + 735 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, i5, fb + 736 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i9, fb + 737 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i8, fb + 738 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i2, fb + 739 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i1, fb + 740 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i3, fb + 741 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i4, fb + 742 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i7, fb + 743 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i6, fb + 744 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, i5, fb + 745 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i9, fb + 746 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i8, fb + 747 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i2, fb + 748 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i1, fb + 749 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i3, fb + 750 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i4, fb + 751 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i7, fb + 752 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i6, fb + 753 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i7, i5, fb + 754 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i9, fb + 755 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i8, fb + 756 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i2, fb + 757 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i1, fb + 758 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i3, fb + 759 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i4, fb + 760 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i7, fb + 761 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i6, fb + 762 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i6, i5, fb + 763 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i9, fb + 764 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i8, fb + 765 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i2, fb + 766 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i1, fb + 767 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i3, fb + 768 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i4, fb + 769 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i7, fb + 770 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i6, fb + 771 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i5, i5, fb + 772 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i4, gb + 589182 | 0, fb + 773 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i3, gb + 589182 | 0, fb + 774 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i2, gb + 589182 | 0, fb + 775 | 0);
 __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, gb + 589182 | 0, fb + 776 | 0);
 return;
}

function __ZN18AnimatorController13GetBehavioursEP11Il2CppClass(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i18 + 16 | 0;
 i17 = i18;
 i12 = i18 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 i13 = i10 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i10 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 63664 | 0);
 i7 = i17;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i15;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i11, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 444 >> 2] | 0) | 0)) {
  i15 = __Z24scripting_class_get_nameP11Il2CppClass(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 444 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i15;
  HEAP32[i2 + 4 >> 2] = i16;
  __Z6FormatPKcz(i17, gb + 911317 | 0, i2);
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 911349 | 0, 1100, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return;
 }
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0) | 0;
 i8 = i7 + 12 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i6 = HEAP32[i7 >> 2] | 0;
 do {
  i9 = HEAP32[i6 >> 2] | 0;
  do if (i9 | 0) {
   HEAP32[i12 >> 2] = i9;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i16 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i12);
     i4 = HEAP32[i17 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i16 = 13; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i16 = 15;
   }
   if ((i16 | 0) == 13) i16 = 15;
   if ((i16 | 0) == 15) {
    i16 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i9) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i12 >> 2] = i9;
   if (!i1) i16 = 22; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i12);
     i2 = HEAP32[i17 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 22; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i16 = 24;
    }
   }
   if ((i16 | 0) == 22) i16 = 24;
   if ((i16 | 0) == 24) {
    i16 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
   }
   if ((__ZNK13MonoBehaviour8GetClassEv(i1) | 0) == (i11 | 0)) {
    i2 = HEAP32[i13 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i13 >> 2] = i3;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i9;
    break;
   }
   HEAP32[i12 >> 2] = i9;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i16 = 37; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i12);
     i2 = HEAP32[i17 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 37; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i16 = 39;
    }
   }
   if ((i16 | 0) == 37) i16 = 39;
   if ((i16 | 0) == 39) {
    i16 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
   }
   if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__ZNK13MonoBehaviour8GetClassEv(i1) | 0, i11) | 0) {
    i2 = HEAP32[i13 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i13 >> 2] = i3;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i9;
   }
  } while (0);
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) != ((HEAP32[i7 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
 STACKTOP = i18;
 return;
}

function __ZN5Unity12PhysicsQuery11CapsuleCastERK8Vector3fS3_fS3_fR10RaycastHiti23QueryTriggerInteraction(i1, i2, i3, f10, i18, f19, i24, i20, i21) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f10 = Math_fround(f10);
 i18 = i18 | 0;
 f19 = Math_fround(f19);
 i24 = i24 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i22 = 0, i23 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 80 | 0;
 i9 = i25 + 60 | 0;
 i5 = i25 + 148 | 0;
 i6 = i25 + 48 | 0;
 i7 = i25 + 20 | 0;
 i8 = i25;
 if ((HEAP16[gb + 1452668 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452668 | 0, i22);
  i23 = gb + 1452668 | 0;
 } else i23 = 0;
 HEAP32[i6 >> 2] = 2;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i6 + 4 >> 2] = f10;
 f26 = Math_fround(f15 - f14);
 f28 = Math_fround(f16 - f12);
 f13 = Math_fround(f17 - f11);
 f27 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f28 * f28)) + Math_fround(f13 * f13))));
 HEAPF32[i6 + 8 >> 2] = Math_fround(f27 * Math_fround(.5));
 f15 = Math_fround(Math_fround(f14 + f15) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f12 + f16) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f11 + f17) * Math_fround(.5));
 f11 = Math_fround(f28 * Math_fround(0.0));
 f10 = Math_fround(f13 * Math_fround(0.0));
 f12 = Math_fround(f10 - f11);
 f14 = Math_fround(f26 * Math_fround(0.0));
 f13 = Math_fround(f14 - f13);
 f14 = Math_fround(f28 - f14);
 f10 = Math_fround(f27 + Math_fround(Math_fround(f26 + f11) + f10));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 if (f10 < Math_fround(.0000999999974)) {
  i2 = -2147483648;
  i4 = 1065353216;
  i3 = 0;
  i1 = 0;
 } else {
  i4 = i3;
  i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f10 * f10);
 f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 + Math_fround(f11 * f11));
 f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 + Math_fround(f12 * f12));
 f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_sqrt(Math_fround(f14 + Math_fround(f13 * f13))));
 if (f14 != Math_fround(0.0)) {
  f28 = Math_fround(Math_fround(1.0) / f14);
  f27 = Math_fround(f10 * f28);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  f27 = Math_fround(f11 * f28);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  f27 = Math_fround(f12 * f28);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  f28 = Math_fround(f13 * f28);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i7 + 12 >> 2] = i3;
 HEAPF32[i7 + 16 >> 2] = f15;
 HEAPF32[i7 + 20 >> 2] = f16;
 HEAPF32[i7 + 24 >> 2] = f17;
 HEAP32[i8 >> 2] = gb + 114012 + 8;
 HEAP32[i8 + 4 >> 2] = 2;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = i20;
 switch (i21 | 0) {
 case 0:
  {
   HEAP8[i8 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i8 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i8 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i29 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i3 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i22 + 4 >> 2] = 0;
 i1 = i22 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i22 + 12 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP16[i22 + 16 >> 1] = 0;
 i21 = i22 + 20 | 0;
 i20 = i22 + 44 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 HEAP32[i21 + 20 >> 2] = 0;
 HEAPF32[i20 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i21 = i22 + 52 | 0;
 HEAP8[i21 >> 0] = 0;
 HEAP32[i22 + 56 >> 2] = 0;
 HEAP32[i22 + 60 >> 2] = 0;
 HEAP32[i22 + 64 >> 2] = 0;
 HEAP32[i22 >> 2] = gb + 93084 + 8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP16[i9 + 16 >> 1] = 15;
 HEAP8[i9 + 18 >> 0] = 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 352 >> 2] | 0;
 HEAP16[i5 >> 1] = i29 ? 143 : 15;
 mftCall_iiiiifiiiiif(i4 | 0, i3 | 0, i6 | 0, i7 | 0, i18 | 0, +f19, i22 | 0, i5 | 0, i9 | 0, i8 | 0, 0, 0.0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i22 + 20 >> 2] | 0;
 i4 = HEAP32[i22 + 24 >> 2] | 0;
 i5 = HEAP32[i22 + 28 >> 2] | 0;
 i6 = HEAP32[i22 + 32 >> 2] | 0;
 i7 = HEAP32[i22 + 36 >> 2] | 0;
 i8 = HEAP32[i22 + 40 >> 2] | 0;
 i9 = HEAP32[i20 >> 2] | 0;
 if (!(HEAP8[i21 >> 0] | 0)) i1 = 0; else {
  HEAP32[i24 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i24 >> 2] = i3;
  HEAP32[i24 + 4 >> 2] = i4;
  HEAP32[i24 + 8 >> 2] = i5;
  HEAP32[i24 + 12 >> 2] = i6;
  HEAP32[i24 + 16 >> 2] = i7;
  HEAP32[i24 + 20 >> 2] = i8;
  HEAP32[i22 >> 2] = 5;
  HEAPF32[i22 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i22 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i22 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i22 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i22 + 28 >> 2] = Math_fround(1.0);
  i29 = i22 + 32 | 0;
  HEAP32[i29 >> 2] = 0;
  HEAP32[i29 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i22 | 0) | 0) {
   i1 = HEAP32[i22 + 36 >> 2] | 0;
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) + (i2 << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i24 + 24 >> 2] = i1;
  HEAP32[i24 + 28 >> 2] = i9;
  HEAPF32[i24 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i24 + 36 >> 2] = Math_fround(0.0);
  if (!((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0))) i1 = 1; else {
   HEAP32[i24 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   i1 = 1;
  }
 }
 if (!i23) {
  STACKTOP = i25;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i23);
 STACKTOP = i25;
 return i1 | 0;
}

function __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb(i13, i5) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 28 | 0;
 i11 = i18 + 16 | 0;
 i10 = i18 + 8 | 0;
 i7 = i18 + 24 | 0;
 i16 = i18;
 i3 = i13 + 140 | 0;
 i15 = (HEAP8[i3 >> 0] | 0) == 0;
 i1 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i15) i14 = mftCall_ii(HEAP32[i2 + 704 >> 2] | 0, i1 | 0) | 0; else i14 = mftCall_ii(HEAP32[i2 + 708 >> 2] | 0, i1 | 0) | 0;
 i15 = (HEAP32[i13 + 36 >> 2] | 0) == 0 ? 4 : 2;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i12 = (HEAP8[i3 >> 0] | 0) == 0; else i12 = 0;
 i1 = HEAP32[i13 + 52 >> 2] | 0;
 i8 = i13 + 172 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 do if (i2) {
  HEAP32[i7 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i9 = 12; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i6 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i2, i7);
    i6 = HEAP32[i17 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i6 = (i6 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i6 << 3) | 0;
    i2 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i6 | 0) == (i3 + (i4 << 3) | 0)) i9 = 12; else if (!(HEAP32[i6 + 4 >> 2] | 0)) i9 = 14; else i1 = i2;
  }
  if ((i9 | 0) == 12) i9 = 14;
  if ((i9 | 0) == 14) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  if (!i1) i9 = 21; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i1, i7);
    i2 = HEAP32[i17 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 21; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 23;
   }
  }
  if ((i9 | 0) == 21) i9 = 23;
  if ((i9 | 0) == 23) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 80 >> 2] | 0;
  if (i5) {
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i9 = 30; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i2, i7);
     i3 = HEAP32[i17 >> 2] | 0;
     i7 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 30; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i9 = 32;
    }
   }
   if ((i9 | 0) == 30) i9 = 32;
   if ((i9 | 0) == 32) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
   i5 = (HEAP8[i2 + 116 >> 0] | 0) != 0;
  } else i5 = 0;
 } while (0);
 do if ((i1 | 0) < 16) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i10 >> 2] = 16;
  HEAP32[i10 + 4 >> 2] = i3;
  __Z6FormatPKcz(i17, gb + 383339 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 380852 | 0, 613, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i3 = 16;
  i4 = i13;
  i2 = i13;
 } else if ((i1 | 0) > 2048) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i11 >> 2] = 2048;
  HEAP32[i11 + 4 >> 2] = i3;
  __Z6FormatPKcz(i17, gb + 383461 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 380852 | 0, 619, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i3 = 2048;
  i4 = i13;
  i2 = i13;
  break;
 } else {
  i3 = i1;
  i4 = i13;
  i2 = i13;
  break;
 } while (0);
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 380852 | 0, 622) | 0;
 i10 = gb + 63520 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i13 = i16;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode(i1, i17, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
 i17 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 mftCall_vii(i17 | 0, i1 | 0, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0);
 __ZN13RenderTexture8SetWidthEi(i1, i3);
 __ZN13RenderTexture9SetHeightEi(i1, i3);
 __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i1, i14);
 __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat(i1, 0);
 __ZN13RenderTexture12SetDimensionE16TextureDimension(i1, i15);
 __ZN13RenderTexture16SetSRGBReadWriteEb(i1, i12);
 __ZN13RenderTexture9SetMipMapEb(i1, i5);
 __ZN13RenderTexture19SetAutoGenerateMipsEb(i1, 0);
 if (!i5) {
  __ZN7Texture13SetAnisoLevelEi(i1, 0);
  __ZN13RenderTexture6CreateEv(i1) | 0;
  i17 = HEAP32[i1 >> 2] | 0;
  i17 = i17 + 12 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  mftCall_vii(i17 | 0, i1 | 0, 4);
  STACKTOP = i18;
  return i1 | 0;
 }
 __ZN7Texture13SetFilterModeEi(i1, 2);
 __ZN7Texture13SetAnisoLevelEi(i1, 0);
 __ZN13RenderTexture6CreateEv(i1) | 0;
 i17 = HEAP32[i1 >> 2] | 0;
 i17 = i17 + 12 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 mftCall_vii(i17 | 0, i1 | 0, 4);
 STACKTOP = i18;
 return i1 | 0;
}

function __Z34PxVehicleWheels4SuspensionRaycastsPN5physx12PxBatchQueryERKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataEPKNS_17PxQueryFilterDataEPKbjPNS_14PxRigidDynamicE(i25, i30, i2, i26, i24, i27, i1) {
 i25 = i25 | 0;
 i30 = i30 | 0;
 i2 = i2 | 0;
 i26 = i26 | 0;
 i24 = i24 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i28 = 0, i29 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i31 + 52 | 0;
 i11 = i31 + 24 | 0;
 i29 = i31 + 12 | 0;
 i28 = i31;
 i23 = i31 + 80 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i12 >> 2] = 0;
 i15 = i12 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i14 = i12 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 i13 = i12 + 12 | 0;
 HEAP32[i13 >> 2] = 1065353216;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i11 | 0, i1 | 0);
 f3 = Math_fround(Math_fround(HEAPF32[i12 + 16 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i12 + 20 >> 2]) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(HEAPF32[i12 + 24 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f33 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i11 >> 2]);
 f18 = Math_fround(f3 * f32);
 f4 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f19 * f4));
 f9 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f22 * f9));
 f16 = Math_fround(Math_fround(f32 * f18) + Math_fround(Math_fround(f3 * f33) + Math_fround(f34 * Math_fround(Math_fround(f22 * f4) - Math_fround(f19 * f9)))));
 f17 = Math_fround(Math_fround(f4 * f18) + Math_fround(Math_fround(f19 * f33) + Math_fround(f34 * Math_fround(Math_fround(f3 * f9) - Math_fround(f22 * f32)))));
 f18 = Math_fround(Math_fround(Math_fround(f22 * f33) + Math_fround(f34 * Math_fround(Math_fround(f19 * f32) - Math_fround(f3 * f4)))) + Math_fround(f9 * f18));
 f16 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) + f16);
 f17 = Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) + f17);
 f18 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) + f18);
 f3 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f34 * f3);
 f33 = Math_fround(HEAPF32[i13 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f32 * f33));
 f22 = Math_fround(HEAPF32[i14 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f22));
 f5 = Math_fround(HEAPF32[i15 >> 2]);
 f19 = Math_fround(f19 - Math_fround(f9 * f5));
 f20 = Math_fround(Math_fround(Math_fround(f9 * f3) + Math_fround(Math_fround(f4 * f33) + Math_fround(f34 * f5))) - Math_fround(f32 * f22));
 f21 = Math_fround(Math_fround(Math_fround(f32 * f5) + Math_fround(Math_fround(f9 * f33) + Math_fround(f34 * f22))) - Math_fround(f4 * f3));
 f22 = Math_fround(Math_fround(Math_fround(Math_fround(f34 * f33) - Math_fround(f32 * f3)) - Math_fround(f4 * f5)) - Math_fround(f9 * f22));
 if (!i27) {
  STACKTOP = i31;
  return;
 }
 f9 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 i10 = i28 + 4 | 0;
 i11 = i28 + 8 | 0;
 i12 = i29 + 4 | 0;
 i13 = i29 + 8 | 0;
 i14 = i2 + 96 | 0;
 i15 = i2 + 144 | 0;
 i1 = i2 + 192 | 0;
 i8 = 0;
 do {
  f5 = Math_fround(HEAPF32[i30 + (i8 * 48 | 0) + 12 >> 2]);
  f3 = Math_fround(HEAPF32[i30 + (i8 * 48 | 0) + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i30 + 192 + (i8 * 48 | 0) >> 2]);
  if (!(HEAP8[i24 + i8 >> 0] | 0)) {
   f4 = Math_fround(Math_fround(HEAPF32[gb + 1458436 >> 2]) * Math_fround(9.99999974e-06));
   i2 = 0;
   i6 = 0;
   i7 = 0;
   f3 = f4;
   f5 = f4;
  } else {
   i2 = HEAP32[i30 + 784 + (i8 * 12 | 0) >> 2] | 0;
   i6 = HEAP32[i30 + 784 + (i8 * 12 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i30 + 784 + (i8 * 12 | 0) + 8 >> 2] | 0;
  }
  f42 = Math_fround(Math_fround(HEAPF32[i30 + 640 + (i8 * 12 | 0) >> 2]) * Math_fround(2.0));
  f40 = Math_fround(Math_fround(HEAPF32[i30 + 640 + (i8 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
  f41 = Math_fround(Math_fround(HEAPF32[i30 + 640 + (i8 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
  f33 = Math_fround(Math_fround(Math_fround(f19 * f42) + Math_fround(f20 * f40)) + Math_fround(f21 * f41));
  f35 = Math_fround(Math_fround(f19 * f33) + Math_fround(Math_fround(f9 * f42) + Math_fround(f22 * Math_fround(Math_fround(f20 * f41) - Math_fround(f21 * f40)))));
  f32 = Math_fround(Math_fround(f20 * f33) + Math_fround(Math_fround(f9 * f40) + Math_fround(f22 * Math_fround(Math_fround(f21 * f42) - Math_fround(f19 * f41)))));
  f33 = Math_fround(Math_fround(Math_fround(f9 * f41) + Math_fround(f22 * Math_fround(Math_fround(f19 * f40) - Math_fround(f20 * f42)))) + Math_fround(f21 * f33));
  HEAPF32[i28 >> 2] = f35;
  HEAPF32[i10 >> 2] = f32;
  HEAPF32[i11 >> 2] = f33;
  f42 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f40 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f41 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
  f37 = Math_fround(Math_fround(f21 * f41) + Math_fround(Math_fround(f20 * f40) + Math_fround(f19 * f42)));
  f39 = Math_fround(f17 + Math_fround(Math_fround(f20 * f37) + Math_fround(Math_fround(f9 * f40) + Math_fround(f22 * Math_fround(Math_fround(f21 * f42) - Math_fround(f19 * f41))))));
  f38 = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f9 * f41) + Math_fround(f22 * Math_fround(Math_fround(f19 * f40) - Math_fround(f20 * f42)))) + Math_fround(f21 * f37)));
  f34 = Math_fround(f3 + f4);
  f36 = Math_fround(f34 * f32);
  f3 = Math_fround(f34 * f33);
  f37 = Math_fround(Math_fround(f16 + Math_fround(Math_fround(Math_fround(f9 * f42) + Math_fround(f22 * Math_fround(Math_fround(f20 * f41) - Math_fround(f21 * f40)))) + Math_fround(f19 * f37))) - Math_fround(f34 * f35));
  HEAPF32[i29 >> 2] = f37;
  f36 = Math_fround(f39 - f36);
  HEAPF32[i12 >> 2] = f36;
  f3 = Math_fround(f38 - f3);
  HEAPF32[i13 >> 2] = f3;
  f34 = Math_fround(f4 + Math_fround(f4 + Math_fround(f34 + f5)));
  HEAPF32[i14 + (i8 * 12 | 0) >> 2] = f37;
  HEAPF32[i14 + (i8 * 12 | 0) + 4 >> 2] = f36;
  HEAPF32[i14 + (i8 * 12 | 0) + 8 >> 2] = f3;
  HEAPF32[i15 + (i8 * 12 | 0) >> 2] = f35;
  HEAPF32[i15 + (i8 * 12 | 0) + 4 >> 2] = f32;
  HEAPF32[i15 + (i8 * 12 | 0) + 8 >> 2] = f33;
  HEAPF32[i1 + (i8 << 2) >> 2] = f34;
  i7 = HEAP32[(HEAP32[i25 >> 2] | 0) + 44 >> 2] | 0;
  HEAP16[i23 >> 1] = 15;
  mftCall_viiifiiiii(i7 | 0, i25 | 0, i29 | 0, i28 | 0, +f34, 0, i23 | 0, i26 + (i8 * 20 | 0) | 0, 0, 0);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i27 | 0));
 STACKTOP = i31;
 return;
}

function __ZN5physx2Gu10ConvexMesh4loadERNS_13PxInputStreamE(i17, i16) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 64 | 0;
 i9 = i18 + 71 | 0;
 i2 = i18 + 48 | 0;
 i1 = i18 + 40 | 0;
 i15 = i18 + 68 | 0;
 i13 = i18 + 8 | 0;
 if (!(__ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE(67, 86, 88, 77, i1, i15, i16) | 0)) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) >>> 0 < 13) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 724158 | 0, 219, gb + 724243 | 0, i18);
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16) | 0;
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(67, 76, 72, 76, i14, i9, i16) | 0)) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(67, 86, 72, 76, i14, i9, i16) | 0)) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i2, 4, (HEAP8[i9 >> 0] | 0) != 0, i16) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i12 = i17 + 54 | 0;
 HEAP8[i12 >> 0] = i3;
 i19 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i17 + 52 | 0;
 HEAP16[i7 >> 1] = i19;
 i11 = HEAP32[i2 + 8 >> 2] | 0;
 i8 = i17 + 55 | 0;
 HEAP8[i8 >> 0] = i11;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i11 = i2 + ((i3 & 255) * 15 | 0) + (i19 << 1 & 131070) + ((i11 & 255) * 20 | 0) | 0;
 i19 = i11 & 3;
 i3 = i17 + 56 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i18 + 70 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i17 + 80 >> 2] = i2;
 i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18 + 69 | 0, ((i19 | 0) == 0 ? 0 : 4 - i19 | 0) + i11 | 0, gb + 724158 | 0, 158) | 0;
 HEAP32[i3 >> 2] = i11;
 i19 = (HEAPU8[i8 >> 0] | 0) * 20 | 0;
 i1 = HEAPU8[i12 >> 0] | 0;
 i10 = (i1 * 12 | 0) + i19 | 0;
 i4 = i11 + i10 | 0;
 i10 = i10 + (HEAPU16[i7 >> 1] << 1) | 0;
 i5 = i11 + i10 | 0;
 i1 = i1 * 3 | 0;
 i6 = i11 + (i10 + i1) | 0;
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i11 + i19 | 0, i1, (HEAP8[i9 >> 0] | 0) != 0, i16) | 0;
 if ((HEAP32[i14 >> 2] | 0) >>> 0 < 7) __ZN5physx8readWordEbRNS_13PxInputStreamE((HEAP8[i9 >> 0] | 0) != 0, i16) | 0;
 mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i3 >> 2] | 0, (HEAPU8[i8 >> 0] | 0) * 20 | 0) | 0;
 if (!((HEAP8[i9 >> 0] | 0) == 0 | (HEAP8[i8 >> 0] | 0) == 0)) {
  i1 = 0;
  do {
   i20 = HEAP32[i3 >> 2] | 0;
   i9 = i20 + (i1 * 20 | 0) | 0;
   i19 = HEAP8[i9 >> 0] | 0;
   i21 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i21 >> 0] | 0;
   HEAP8[i21 >> 0] = i19;
   i21 = i9 + 1 | 0;
   i19 = HEAP8[i21 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i21 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i19;
   i9 = i20 + (i1 * 20 | 0) + 4 | 0;
   i19 = HEAP8[i9 >> 0] | 0;
   i21 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i21 >> 0] | 0;
   HEAP8[i21 >> 0] = i19;
   i21 = i9 + 1 | 0;
   i19 = HEAP8[i21 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i21 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i19;
   i9 = i20 + (i1 * 20 | 0) + 8 | 0;
   i19 = HEAP8[i9 >> 0] | 0;
   i21 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i21 >> 0] | 0;
   HEAP8[i21 >> 0] = i19;
   i21 = i9 + 1 | 0;
   i19 = HEAP8[i21 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i21 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i19;
   i9 = i20 + (i1 * 20 | 0) + 12 | 0;
   i19 = HEAP8[i9 >> 0] | 0;
   i21 = i9 + 3 | 0;
   HEAP8[i9 >> 0] = HEAP8[i21 >> 0] | 0;
   HEAP8[i21 >> 0] = i19;
   i21 = i9 + 1 | 0;
   i19 = HEAP8[i21 >> 0] | 0;
   i9 = i9 + 2 | 0;
   HEAP8[i21 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = i19;
   i20 = i20 + (i1 * 20 | 0) + 16 | 0;
   i9 = HEAP8[i20 >> 0] | 0;
   i19 = i20 + 1 | 0;
   HEAP8[i20 >> 0] = HEAP8[i19 >> 0] | 0;
   HEAP8[i19 >> 0] = i9;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAPU8[i8 >> 0] | 0) >>> 0);
 }
 mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i6 | 0, i2 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i4 | 0, HEAPU16[i7 >> 1] << 1 | 0) | 0;
 if ((HEAP32[i14 >> 2] | 0) >>> 0 < 6) {
  if (HEAP8[i12 >> 0] | 0) {
   i1 = i10 | 1;
   i2 = i10 + 2 | 0;
   i3 = 0;
   do {
    i21 = i3 * 3 | 0;
    HEAP8[i11 + (i21 + i10) >> 0] = -1;
    HEAP8[i11 + (i21 + i1) >> 0] = -1;
    HEAP8[i11 + (i2 + i21) >> 0] = -1;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAPU8[i12 >> 0] | 0) >>> 0);
  }
 } else mftCall_iiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i5 | 0, (HEAPU8[i12 >> 0] | 0) * 3 | 0) | 0;
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i13, 8, (HEAP8[i15 >> 0] | 0) != 0, i16) | 0;
 i11 = HEAP32[i13 + 8 >> 2] | 0;
 i12 = HEAP32[i13 + 12 >> 2] | 0;
 i19 = HEAP32[i13 + 16 >> 2] | 0;
 i20 = HEAP32[i13 + 20 >> 2] | 0;
 i21 = HEAP32[i13 + 24 >> 2] | 0;
 HEAP32[i17 + 16 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i17 + 20 >> 2] = i11;
 HEAP32[i17 + 24 >> 2] = i12;
 HEAP32[i17 + 28 >> 2] = i19;
 HEAP32[i17 + 32 >> 2] = i20;
 HEAP32[i17 + 36 >> 2] = i21;
 f22 = Math_fround(HEAPF32[i13 + 28 >> 2]);
 HEAPF32[i17 + 88 >> 2] = f22;
 if (f22 != Math_fround(-1.0)) {
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i17 + 92 | 0, 9, (HEAP8[i15 >> 0] | 0) != 0, i16) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i17 + 40 | 0, 3, (HEAP8[i15 >> 0] | 0) != 0, i16) | 0;
 }
 if (Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16)) != Math_fround(-1.0)) {
  i2 = i17 + 84 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __ZN5physx13BigConvexDataD2Ev(i1);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i1);
  }
  HEAP32[i2 >> 2] = 0;
  i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i20 = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i20 | 0, i21 | 0, 28, (i1 ? gb + 729661 | 0 : gb + 837976 | 0) | 0, gb + 724158 | 0, 252) | 0;
  __ZN5physx13BigConvexDataC2Ev(i1);
  HEAP32[i2 >> 2] = i1;
  if (i1 | 0) {
   __ZN5physx13BigConvexData4LoadERNS_13PxInputStreamE(i1, i16) | 0;
   HEAP32[i17 + 60 >> 2] = HEAP32[i2 >> 2];
  }
 }
 HEAPF32[i17 + 64 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16));
 HEAPF32[i17 + 68 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16));
 HEAPF32[i17 + 72 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16));
 HEAPF32[i17 + 76 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i15 >> 0] | 0) != 0, i16));
 i21 = 1;
 STACKTOP = i18;
 return i21 | 0;
}

function __ZL32GeomOverlapCallback_ConvexConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i1, i3, i2, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, i41 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i6 + 560 | 0;
 i22 = i6 + 544 | 0;
 i26 = i6 + 320 | 0;
 i18 = i6 + 96 | 0;
 i24 = i6 + 80 | 0;
 i8 = i6 + 576 | 0;
 i10 = i6 + 336 | 0;
 i9 = i6 + 112 | 0;
 i7 = i6 + 64 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 i23 = HEAP32[i1 + 32 >> 2] | 0;
 i19 = HEAP32[i2 + 32 >> 2] | 0;
 i20 = HEAP32[i1 + 8 >> 2] | 0;
 i40 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i1 + 4 >> 2];
 i21 = i22 + 4 | 0;
 HEAP32[i21 >> 2] = i20;
 i20 = i22 + 8 | 0;
 HEAP32[i20 >> 2] = i40;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 i40 = HEAP32[i1 + 20 >> 2] | 0;
 i17 = HEAP32[i1 + 24 >> 2] | 0;
 i41 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i26 + 4 >> 2] = i40;
 HEAP32[i26 + 8 >> 2] = i17;
 HEAP32[i26 + 12 >> 2] = i41;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i41 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i2 + 4 >> 2];
 i17 = i18 + 4 | 0;
 HEAP32[i17 >> 2] = i1;
 i1 = i18 + 8 | 0;
 HEAP32[i1 >> 2] = i41;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 i41 = HEAP32[i2 + 20 >> 2] | 0;
 i40 = HEAP32[i2 + 24 >> 2] | 0;
 i39 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i24 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i24 + 4 >> 2] = i41;
 HEAP32[i24 + 8 >> 2] = i40;
 HEAP32[i24 + 12 >> 2] = i39;
 f37 = Math_fround(HEAPF32[i3 >> 2]);
 f38 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f36 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i2 = i3 + 16 | 0;
 f35 = Math_fround(HEAPF32[i2 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f34 = Math_fround(HEAPF32[i4 >> 2]);
 f29 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i2 = i4 + 16 | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f34 = Math_fround(-f34);
 f29 = Math_fround(-f29);
 f12 = Math_fround(-f12);
 f15 = Math_fround(f35 - f15);
 f30 = Math_fround(f33 - f30);
 f32 = Math_fround(f32 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f33 = Math_fround(Math_fround(f11 * f11) + Math_fround(-.5));
 f35 = Math_fround(Math_fround(Math_fround(f15 * f34) + Math_fround(f30 * f29)) + Math_fround(f32 * f12));
 f13 = Math_fround(Math_fround(Math_fround(f35 * f29) + Math_fround(Math_fround(f33 * f30) + Math_fround(f11 * Math_fround(Math_fround(f15 * f12) - Math_fround(f32 * f34))))) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f11 * Math_fround(Math_fround(f30 * f34) - Math_fround(f15 * f29)))) + Math_fround(f35 * f12)) * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f36 * f11) - Math_fround(Math_fround(Math_fround(f37 * f34) + Math_fround(f38 * f29)) + Math_fround(f31 * f12)));
 f28 = Math_fround(Math_fround(Math_fround(f31 * f29) - Math_fround(f38 * f12)) + Math_fround(Math_fround(f36 * f34) + Math_fround(f37 * f11)));
 f16 = Math_fround(Math_fround(Math_fround(f37 * f12) - Math_fround(f31 * f34)) + Math_fround(Math_fround(f36 * f29) + Math_fround(f38 * f11)));
 f31 = Math_fround(Math_fround(Math_fround(f38 * f34) - Math_fround(f37 * f29)) + Math_fround(Math_fround(f36 * f12) + Math_fround(f31 * f11)));
 HEAPF32[i8 + 48 >> 2] = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(Math_fround(f33 * f15) + Math_fround(f11 * Math_fround(Math_fround(f32 * f29) - Math_fround(f30 * f12))))) * Math_fround(2.0));
 HEAPF32[i8 + 52 >> 2] = f13;
 HEAPF32[i8 + 56 >> 2] = f14;
 HEAPF32[i8 + 60 >> 2] = Math_fround(0.0);
 f14 = Math_fround(f28 + f28);
 f13 = Math_fround(f16 + f16);
 f12 = Math_fround(f31 + f31);
 f30 = Math_fround(f16 * f13);
 f29 = Math_fround(f31 * f12);
 f16 = Math_fround(f16 * f14);
 f32 = Math_fround(f31 * f14);
 f11 = Math_fround(f27 * f14);
 f31 = Math_fround(f31 * f13);
 f13 = Math_fround(f27 * f13);
 f12 = Math_fround(f27 * f12);
 f14 = Math_fround(Math_fround(1.0) - Math_fround(f28 * f14));
 f28 = Math_fround(f16 + f12);
 f27 = Math_fround(f32 - f13);
 f12 = Math_fround(f16 - f12);
 f16 = Math_fround(f14 - f29);
 f15 = Math_fround(f31 + f11);
 f13 = Math_fround(f32 + f13);
 f11 = Math_fround(f31 - f11);
 f14 = Math_fround(f14 - f30);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f30) - f29);
 HEAPF32[i8 + 4 >> 2] = f28;
 HEAPF32[i8 + 8 >> 2] = f27;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = f12;
 HEAPF32[i8 + 20 >> 2] = f16;
 HEAPF32[i8 + 24 >> 2] = f15;
 HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 32 >> 2] = f13;
 HEAPF32[i8 + 36 >> 2] = f11;
 HEAPF32[i8 + 40 >> 2] = f14;
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i10, i23 + 16 | 0, i25, i22, i26);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i9, i19 + 16 | 0, i25, i18, i24);
 f14 = Math_fround(HEAPF32[i23 + 68 >> 2]);
 f11 = Math_fround(HEAPF32[i23 + 72 >> 2]);
 f13 = Math_fround(HEAPF32[i23 + 76 >> 2]);
 f15 = Math_fround(HEAPF32[i22 >> 2]);
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f15 = Math_fround(f14 * f15);
 f16 = Math_fround(f11 * f16);
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 f16 = f15 <= f16 ? f15 : f16;
 f13 = Math_fround((f16 <= f13 ? f16 : f13) * Math_fround(.00999999977));
 f16 = Math_fround(HEAPF32[i19 + 68 >> 2]);
 f15 = Math_fround(HEAPF32[i19 + 72 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 76 >> 2]);
 f14 = Math_fround(HEAPF32[i18 >> 2]);
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f14 = Math_fround(f16 * f14);
 f12 = Math_fround(f15 * f12);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i1 >> 2]));
 f12 = f14 <= f12 ? f14 : f12;
 f11 = Math_fround(f13 + Math_fround((f12 <= f11 ? f12 : f11) * Math_fround(.00999999977)));
 HEAPF32[i7 >> 2] = Math_fround(f11 * f11);
 i2 = (__ZN5physx2Gu22GJKRelativeTesselationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i10, i9, i8, i7, i6 + 48 | 0, i6 + 32 | 0, i6 + 16 | 0, i6) | 0) == 1;
 if (!i5) {
  STACKTOP = i6;
  return i2 | 0;
 }
 i1 = i5 + 12 | 0;
 if (i2) {
  HEAP16[i1 >> 1] = 2;
  STACKTOP = i6;
  return i2 | 0;
 } else {
  HEAP16[i1 >> 1] = 0;
  STACKTOP = i6;
  return i2 | 0;
 }
 return 0;
}

function _DistanceJointSolverPrep(i25, i8, i4, i3, i24, i5, i6) {
 i25 = i25 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i24 = i24 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, f2 = f0, f7 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0;
 i19 = i24 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 f1 = Math_fround(Math_fround(HEAPF32[i24 + 16 >> 2]) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(HEAPF32[i24 + 20 >> 2]) * Math_fround(2.0));
 f31 = Math_fround(Math_fround(HEAPF32[i24 + 24 >> 2]) * Math_fround(2.0));
 f32 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f30 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(f1 * f27);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f29 * f7));
 f2 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f31 * f2));
 f20 = Math_fround(Math_fround(f27 * f18) + Math_fround(Math_fround(f1 * f30) + Math_fround(f32 * Math_fround(Math_fround(f31 * f7) - Math_fround(f29 * f2)))));
 f22 = Math_fround(Math_fround(f7 * f18) + Math_fround(Math_fround(f29 * f30) + Math_fround(f32 * Math_fround(Math_fround(f1 * f2) - Math_fround(f31 * f27)))));
 f18 = Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f32 * Math_fround(Math_fround(f29 * f27) - Math_fround(f1 * f7)))) + Math_fround(f2 * f18));
 i19 = i5 + 16 | 0;
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 f20 = Math_fround(f2 + f20);
 i21 = i5 + 20 | 0;
 f7 = Math_fround(HEAPF32[i21 >> 2]);
 f22 = Math_fround(f7 + f22);
 i17 = i5 + 24 | 0;
 f1 = Math_fround(HEAPF32[i17 >> 2]);
 f18 = Math_fround(f1 + f18);
 f27 = Math_fround(Math_fround(HEAPF32[i24 + 44 >> 2]) * Math_fround(2.0));
 f29 = Math_fround(Math_fround(HEAPF32[i24 + 48 >> 2]) * Math_fround(2.0));
 f32 = Math_fround(Math_fround(HEAPF32[i24 + 52 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f31 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f28 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(f27 * f28);
 f26 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f29 * f26));
 f16 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f32 * f16));
 f13 = Math_fround(Math_fround(f28 * f11) + Math_fround(Math_fround(f27 * f31) + Math_fround(f30 * Math_fround(Math_fround(f32 * f26) - Math_fround(f29 * f16)))));
 f15 = Math_fround(Math_fround(f26 * f11) + Math_fround(Math_fround(f29 * f31) + Math_fround(f30 * Math_fround(Math_fround(f27 * f16) - Math_fround(f32 * f28)))));
 f11 = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(f30 * Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * f26)))) + Math_fround(f16 * f11));
 i12 = i6 + 16 | 0;
 f13 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f13);
 i14 = i6 + 20 | 0;
 f15 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f15);
 i10 = i6 + 24 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f11);
 f7 = Math_fround(f15 - f7);
 f1 = Math_fround(f11 - f1);
 HEAPF32[i8 >> 2] = Math_fround(f13 - f2);
 HEAPF32[i8 + 4 >> 2] = f7;
 HEAPF32[i8 + 8 >> 2] = f1;
 f1 = Math_fround(f20 - f13);
 f7 = Math_fround(f22 - f15);
 f2 = Math_fround(f18 - f11);
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f1 * f1) + Math_fround(f7 * f7)))));
 if (f16 > Math_fround(0.0)) {
  f32 = Math_fround(Math_fround(1.0) / f16);
  f2 = Math_fround(f2 * f32);
  f7 = Math_fround(f7 * f32);
  f1 = Math_fround(f1 * f32);
 }
 i6 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = HEAP16[i24 + 92 >> 1] | 0;
 i9 = i5 & 65535;
 i8 = (i9 & 2 | 0) != 0;
 i9 = (i9 & 4 | 0) != 0;
 if (i8) {
  if (f16 <= Math_fround(HEAPF32[i24 + 76 >> 2])) i23 = 5;
 } else i23 = 5;
 if ((i23 | 0) == 5) {
  if (!i9) {
   i25 = 0;
   return i25 | 0;
  }
  if (f16 >= Math_fround(HEAPF32[i24 + 72 >> 2])) {
   i25 = 0;
   return i25 | 0;
  }
 }
 i33 = f16 < Math_fround(1.1920929e-07);
 i23 = i33 ? 0 : i3;
 i4 = i33 ? 0 : i4;
 i6 = i33 ? 1065353216 : i6;
 i3 = i25 + 76 | 0;
 HEAP16[i3 >> 1] = 16;
 HEAP32[i25 >> 2] = i6;
 HEAP32[i25 + 4 >> 2] = i4;
 HEAP32[i25 + 8 >> 2] = i23;
 f31 = Math_fround(f20 - Math_fround(HEAPF32[i19 >> 2]));
 f26 = Math_fround(f22 - Math_fround(HEAPF32[i21 >> 2]));
 f27 = Math_fround(f18 - Math_fround(HEAPF32[i17 >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f26 * f28);
 f30 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f29 - Math_fround(f27 * f30));
 f32 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(Math_fround(f27 * f32) - Math_fround(f31 * f28));
 f26 = Math_fround(Math_fround(f31 * f30) - Math_fround(f26 * f32));
 HEAPF32[i25 + 16 >> 2] = f29;
 HEAPF32[i25 + 20 >> 2] = f27;
 HEAPF32[i25 + 24 >> 2] = f26;
 HEAP32[i25 + 32 >> 2] = i6;
 HEAP32[i25 + 36 >> 2] = i4;
 HEAP32[i25 + 40 >> 2] = i23;
 f26 = Math_fround(f13 - Math_fround(HEAPF32[i12 >> 2]));
 f27 = Math_fround(f15 - Math_fround(HEAPF32[i14 >> 2]));
 f29 = Math_fround(f11 - Math_fround(HEAPF32[i10 >> 2]));
 f31 = Math_fround(Math_fround(f29 * f32) - Math_fround(f26 * f28));
 f32 = Math_fround(Math_fround(f26 * f30) - Math_fround(f27 * f32));
 HEAPF32[i25 + 48 >> 2] = Math_fround(Math_fround(f27 * f28) - Math_fround(f29 * f30));
 HEAPF32[i25 + 52 >> 2] = f31;
 HEAPF32[i25 + 56 >> 2] = f32;
 if (i5 & 8) {
  HEAP16[i3 >> 1] = 17;
  HEAP32[i25 + 64 >> 2] = HEAP32[i24 + 84 >> 2];
  HEAP32[i25 + 68 >> 2] = HEAP32[i24 + 88 >> 2];
 }
 f1 = Math_fround(HEAPF32[i24 + 72 >> 2]);
 f2 = Math_fround(HEAPF32[i24 + 76 >> 2]);
 if (!(f1 != f2 | i9 ^ 1 | i8 ^ 1)) {
  f2 = Math_fround(f16 - f2);
  f1 = Math_fround(HEAPF32[i24 + 80 >> 2]);
  if (f2 > f1) f1 = Math_fround(f2 - f1); else if (f2 < Math_fround(-f1)) f1 = Math_fround(f2 + f1); else f1 = Math_fround(0.0);
  HEAPF32[i25 + 12 >> 2] = f1;
  i33 = 1;
  return i33 | 0;
 }
 if (i8 & f16 > f2) {
  f32 = Math_fround(f16 - f2);
  HEAPF32[i25 + 12 >> 2] = Math_fround(f32 - Math_fround(HEAPF32[i24 + 80 >> 2]));
  HEAPF32[i25 + 60 >> 2] = Math_fround(0.0);
  i33 = 1;
  return i33 | 0;
 }
 if (!(i9 & f16 < f1)) {
  i33 = 1;
  return i33 | 0;
 }
 f32 = Math_fround(f16 - f1);
 HEAPF32[i25 + 12 >> 2] = Math_fround(f32 + Math_fround(HEAPF32[i24 + 80 >> 2]));
 HEAPF32[i25 + 44 >> 2] = Math_fround(0.0);
 i33 = 1;
 return i33 | 0;
}

function _UNITY_FT_Stroker_ParseOutline(i13, i14, i17) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i36 + 32 | 0;
 i31 = i36 + 24 | 0;
 i32 = i36 + 16 | 0;
 i33 = i36 + 8 | 0;
 i34 = i36;
 if (!i14) {
  i35 = 20;
  STACKTOP = i36;
  return i35 | 0;
 }
 if (!i13) {
  i35 = 6;
  STACKTOP = i36;
  return i35 | 0;
 }
 HEAP32[i13 + 64 >> 2] = 0;
 HEAP32[i13 + 84 >> 2] = -1;
 HEAP8[i13 + 92 >> 0] = 0;
 HEAP32[i13 + 96 >> 2] = 0;
 HEAP32[i13 + 116 >> 2] = -1;
 HEAP8[i13 + 124 >> 0] = 0;
 if ((HEAP16[i14 >> 1] | 0) <= 0) {
  i35 = 0;
  STACKTOP = i36;
  return i35 | 0;
 }
 i15 = i14 + 12 | 0;
 i16 = i14 + 4 | 0;
 i18 = i14 + 8 | 0;
 i19 = i13 + 20 | 0;
 i20 = i13 + 8 | 0;
 i21 = i13 + 21 | 0;
 i22 = i13 + 48 | 0;
 i23 = i17 << 24 >> 24 == 0;
 i24 = i13 + 44 | 0;
 i25 = i13 + 40 | 0;
 i26 = i13 + 28 | 0;
 i27 = i32 + 4 | 0;
 i29 = i28 + 4 | 0;
 i30 = i33 + 4 | 0;
 i12 = i31 + 4 | 0;
 i9 = 0;
 i11 = 0;
 L10 : while (1) {
  i10 = HEAP16[(HEAP32[i15 >> 2] | 0) + (i11 << 1) >> 1] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  i1 = i2 + (i10 << 3) | 0;
  L12 : do if (i10 >>> 0 > i9 >>> 0) {
   i4 = i2 + (i9 << 3) | 0;
   i8 = i4;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i6 = i31;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i6 + 4 >> 2] = i8;
   i6 = HEAP32[i2 + (i10 << 3) >> 2] | 0;
   i2 = HEAP32[i2 + (i10 << 3) + 4 >> 2] | 0;
   i5 = i28;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i5 + 4 >> 2] = i8;
   i5 = HEAP32[i18 >> 2] | 0;
   i3 = i5 + i9 | 0;
   switch (HEAP8[i3 >> 0] & 3) {
   case 2:
    {
     i1 = 20;
     i35 = 39;
     break L10;
    }
   case 0:
    {
     if ((HEAP8[i5 + i10 >> 0] & 3) == 1) {
      HEAP32[i31 >> 2] = i6;
      HEAP32[i12 >> 2] = i2;
      i1 = i1 + -8 | 0;
     } else {
      HEAP32[i31 >> 2] = (i7 + i6 | 0) / 2 | 0;
      HEAP32[i12 >> 2] = (i8 + i2 | 0) / 2 | 0;
     }
     i3 = i3 + -1 | 0;
     i4 = i4 + -8 | 0;
     i6 = i1;
     break;
    }
   default:
    i6 = i1;
   }
   HEAP8[i19 >> 0] = 1;
   i5 = i31;
   i2 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = i20;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP8[i21 >> 0] = i17;
   i1 = (HEAP32[i22 >> 2] | 0) != 0;
   if (!(i1 | i23)) i1 = (HEAP32[i24 >> 2] | 0) == 0;
   HEAP8[i25 >> 0] = i1 & 1;
   i8 = i26;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i5;
   HEAP32[i13 >> 2] = 0;
   if (i4 >>> 0 < i6 >>> 0) {
    i1 = 0;
    L25 : while (1) {
     i2 = i4 + 8 | 0;
     i5 = i3 + 1 | 0;
     L27 : do switch (HEAP8[i5 >> 0] & 3) {
     case 1:
      {
       HEAP32[i32 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i27 >> 2] = HEAP32[i4 + 12 >> 2];
       i1 = _UNITY_FT_Stroker_LineTo(i13, i32) | 0;
       if (!i1) {
        i1 = 0;
        i3 = i5;
       } else {
        i35 = 39;
        break L10;
       }
       break;
      }
     case 0:
      {
       HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i29 >> 2] = HEAP32[i4 + 12 >> 2];
       i3 = i5;
       while (1) {
        if (i2 >>> 0 >= i6 >>> 0) {
         i35 = 25;
         break L25;
        }
        i5 = i2 + 8 | 0;
        i3 = i3 + 1 | 0;
        i8 = HEAP8[i3 >> 0] | 0;
        i4 = i5;
        i2 = HEAP32[i4 >> 2] | 0;
        i4 = HEAP32[i4 + 4 >> 2] | 0;
        i7 = i32;
        HEAP32[i7 >> 2] = i2;
        HEAP32[i7 + 4 >> 2] = i4;
        switch (i8 & 3) {
        case 1:
         {
          i1 = _UNITY_FT_Stroker_ConicTo(i13, i28, i32) | 0;
          i2 = (i1 | 0) == 0 ? 7 : 6;
          break;
         }
        case 0:
         {
          HEAP32[i33 >> 2] = (i2 + (HEAP32[i28 >> 2] | 0) | 0) / 2 | 0;
          HEAP32[i30 >> 2] = (i4 + (HEAP32[i29 >> 2] | 0) | 0) / 2 | 0;
          i1 = _UNITY_FT_Stroker_ConicTo(i13, i28, i33) | 0;
          if (!i1) {
           i8 = i32;
           i1 = HEAP32[i8 + 4 >> 2] | 0;
           i2 = i28;
           HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
           HEAP32[i2 + 4 >> 2] = i1;
           i2 = 10;
           i1 = 0;
          } else i2 = 6;
          break;
         }
        default:
         i2 = 5;
        }
        switch (i2 & 15) {
        case 7:
         {
          i2 = i5;
          break L27;
         }
        case 10:
         {
          i2 = i5;
          break;
         }
        default:
         {
          i35 = 36;
          break L25;
         }
        }
       }
      }
     default:
      {
       i1 = i4 + 16 | 0;
       if (i1 >>> 0 > i6 >>> 0) {
        i35 = 30;
        break L10;
       }
       if ((HEAP8[i3 + 2 >> 0] & 3) != 2) {
        i35 = 30;
        break L10;
       }
       i4 = i4 + 24 | 0;
       i8 = i2;
       i7 = HEAP32[i8 + 4 >> 2] | 0;
       i5 = i32;
       HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i5 + 4 >> 2] = i7;
       i5 = i1;
       i7 = HEAP32[i5 + 4 >> 2] | 0;
       i8 = i33;
       HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i8 + 4 >> 2] = i7;
       if (i4 >>> 0 > i6 >>> 0) {
        i35 = 29;
        break L25;
       }
       i7 = i4;
       i8 = HEAP32[i7 + 4 >> 2] | 0;
       i1 = i34;
       HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i1 + 4 >> 2] = i8;
       i1 = _UNITY_FT_Stroker_CubicTo(i13, i32, i33, i34) | 0;
       if (!i1) {
        i1 = 0;
        i3 = i3 + 3 | 0;
        i2 = i4;
       } else {
        i2 = 6;
        i35 = 36;
        break L25;
       }
      }
     } while (0);
     if (i2 >>> 0 < i6 >>> 0) i4 = i2; else break;
    }
    if ((i35 | 0) == 25) {
     i35 = 0;
     i1 = _UNITY_FT_Stroker_ConicTo(i13, i28, i31) | 0;
    } else if ((i35 | 0) == 29) {
     i35 = 0;
     i1 = _UNITY_FT_Stroker_CubicTo(i13, i32, i33, i31) | 0;
    } else if ((i35 | 0) == 36) {
     i35 = 0;
     switch (i2 | 0) {
     case 5:
      {
       i1 = 20;
       i35 = 39;
       break L10;
      }
     case 4:
     case 0:
      {
       i1 = i9;
       break L12;
      }
     default:
      {
       i35 = 38;
       break L10;
      }
     }
    }
    if (i1 | 0) {
     i35 = 38;
     break L10;
    }
   }
   if (!(HEAP8[i19 >> 0] | 0)) {
    i1 = _UNITY_FT_Stroker_EndSubPath(i13) | 0;
    if (i1 | 0) {
     i35 = 38;
     break L10;
    }
   }
   i1 = i10 + 1 | 0;
  } else i1 = i10 + 1 | 0; while (0);
  i11 = i11 + 1 | 0;
  if ((i11 | 0) >= (HEAP16[i14 >> 1] | 0)) {
   i1 = 0;
   i35 = 38;
   break;
  } else i9 = i1;
 }
 if ((i35 | 0) == 30) {
  i35 = 20;
  STACKTOP = i36;
  return i35 | 0;
 } else if ((i35 | 0) == 38) {
  i35 = i1;
  STACKTOP = i36;
  return i35 | 0;
 } else if ((i35 | 0) == 39) {
  STACKTOP = i36;
  return i1 | 0;
 }
 return 0;
}

function __ZN16GraphicsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i11);
 i1 = i9 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i12 = i11 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i11 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 28 | 0, i11);
 i1 = i9 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 36 | 0, i11);
 i1 = i9 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 44 | 0, i11);
 i1 = i9 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 52 | 0, i11);
 i1 = i9 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 68 | 0, i11);
 i1 = i9 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 60 | 0, i11);
 i1 = i9 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 76 | 0, i11);
 i1 = i9 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 84 | 0, i11);
 i3 = i9 + 92 | 0;
 i7 = i9 + 96 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i9 + 108 | 0;
 i3 = i9 + 112 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI23ShaderVariantCollectionE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 124 | 0, i11);
 i5 = i9 + 128 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 i1 = i9 + 132 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i5 = i9 + 136 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 i1 = i9 + 140 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i5 = i9 + 144 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 i1 = i9 + 148 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i13;
  return;
 }
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 208 | 0;
 i13 = i21 + 200 | 0;
 i14 = i21 + 196 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 337 | 0;
 i11 = i21 + 336 | 0;
 __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i2;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i7 = i25 + 4 | 0;
  i8 = i25 + 8 | 0;
  i4 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i4) {
    i9 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) {
      i27 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i9 = 0;
     i5 = 1;
    } else {
     i9 = i4;
     i5 = 0;
    }
   }
   i4 = HEAP32[i23 >> 2] | 0;
   do if (!i4) i27 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i27 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 20;
     break;
    } else if (i5) break; else {
     i27 = 39;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 20) {
    i27 = 0;
    if (i5) {
     i4 = 0;
     i27 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i10 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i2 + i5;
   }
   i5 = i9 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i9 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i1, i15, i11, i2, i16, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    } else {
     i4 = i9;
     continue;
    }
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    i4 = i9;
    continue;
   }
  }
  if ((i27 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 39) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i1 = HEAP32[i19 >> 2] | 0;
    if ((i1 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   f3 = Math_fround(+invoke_fiii(fb + 26 | 0, i2 | 0, HEAP32[i16 >> 2] | 0, i24 | 0));
   i28 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i28 & 1)) {
    HEAPF32[i20 >> 2] = f3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i9) i2 = 1; else {
     i1 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i27 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i23 >> 2] = 0;
      i27 = 55;
      break;
     } else if (i2) break; else {
      i27 = 57;
      break;
     }
    } while (0);
    if ((i27 | 0) == 55) if (i2) i27 = 57;
    if ((i27 | 0) == 57) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i27, i1, i28, i2) {
 i3 = i3 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i25 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i25) return;
 i19 = HEAP32[i3 + 60 >> 2] | 0;
 i20 = HEAP32[i3 + 80 >> 2] | 0;
 i21 = HEAP32[i3 + 100 >> 2] | 0;
 i22 = HEAP32[i3 + 120 >> 2] | 0;
 i23 = HEAP32[i3 + 140 >> 2] | 0;
 i17 = HEAP32[i3 + 160 >> 2] | 0;
 i18 = i28 + 192 | 0;
 i16 = 0;
 do {
  i15 = i19 + (i16 << 2) | 0;
  f46 = Math_fround(HEAPF32[i15 >> 2]);
  f45 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i20 + (i16 << 2) | 0;
  f42 = Math_fround(HEAPF32[i15 >> 2]);
  f41 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i21 + (i16 << 2) | 0;
  f38 = Math_fround(HEAPF32[i15 >> 2]);
  f37 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i22 + (i16 << 2) | 0;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  f33 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f29 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i23 + (i16 << 2) | 0;
  f34 = Math_fround(HEAPF32[i15 >> 2]);
  f32 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i17 + (i16 << 2) | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  f13 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f35 = Math_fround(f46 + f35);
  f33 = Math_fround(f45 + f33);
  f31 = Math_fround(f44 + f31);
  f29 = Math_fround(f43 + f29);
  f34 = Math_fround(f42 + f34);
  f32 = Math_fround(f41 + f32);
  f30 = Math_fround(f40 + f30);
  f10 = Math_fround(f39 + f10);
  f11 = Math_fround(f38 + f11);
  f13 = Math_fround(f37 + f13);
  f12 = Math_fround(f36 + f12);
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i15 + 12 >> 2]));
  f11 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f34 * f34)) + Math_fround(f11 * f11))))));
  f13 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f32 * f32)) + Math_fround(f13 * f13))))));
  f12 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f30 * f30)) + Math_fround(f12 * f12))))));
  f14 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f10 * f10)) + Math_fround(f14 * f14))))));
  i15 = f11 < Math_fround(0.0);
  f11 = i15 ? Math_fround(0.0) : f11;
  i15 = f13 < Math_fround(0.0);
  f13 = i15 ? Math_fround(0.0) : f13;
  i15 = f12 < Math_fround(0.0);
  f12 = i15 ? Math_fround(0.0) : f12;
  i15 = f14 < Math_fround(0.0);
  f14 = i15 ? Math_fround(0.0) : f14;
  i15 = f11 > Math_fround(1.0);
  f11 = i15 ? Math_fround(1.0) : f11;
  i15 = f13 > Math_fround(1.0);
  f13 = i15 ? Math_fround(1.0) : f13;
  i15 = f12 > Math_fround(1.0);
  f12 = i15 ? Math_fround(1.0) : f12;
  i15 = f14 > Math_fround(1.0);
  f14 = i15 ? Math_fround(1.0) : f14;
  i15 = HEAP32[i18 >> 2] | 0;
  L6 : do if (!i15) i1 = 0; else {
   i1 = 0;
   do {
    f46 = Math_fround(HEAPF32[i28 + 64 + (i1 << 2) >> 2]);
    if (!(f14 > f46 & (f12 > f46 & (f11 > f46 & f13 > f46)))) break L6;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i15 >>> 0);
  } while (0);
  L11 : do if (i1 >>> 0 < i15 >>> 0) {
   i7 = i1;
   i8 = 0;
   i4 = -1;
   i9 = 0;
   i3 = -1;
   i5 = 0;
   i2 = -1;
   i6 = 0;
   i1 = -1;
   while (1) {
    if ((i6 & i9 & i5 & i8 | 0) <= -1) break L11;
    f10 = Math_fround(HEAPF32[i28 + 64 + (i7 << 2) >> 2]);
    i47 = HEAP32[i28 + (i7 << 2) >> 2] | 0;
    i4 = i47 & ~i8 | i8 & i4;
    i3 = i47 & ~i5 | i5 & i3;
    i2 = i47 & ~i6 | i6 & i2;
    i1 = i47 & ~i9 | i9 & i1;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i15 >>> 0) break; else {
     i8 = (f11 < f10) << 31 >> 31;
     i9 = (f14 < f10) << 31 >> 31;
     i5 = (f13 < f10) << 31 >> 31;
     i6 = (f12 < f10) << 31 >> 31;
    }
   }
  } else {
   i4 = -1;
   i3 = -1;
   i2 = -1;
   i1 = -1;
  } while (0);
  i54 = i27 + (i16 << 2) | 0;
  i56 = HEAP32[i54 >> 2] | 0;
  i49 = i54 + 4 | 0;
  i51 = HEAP32[i49 >> 2] | 0;
  i6 = i54 + 8 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i47 = i54 + 12 | 0;
  i9 = HEAP32[i47 >> 2] | 0;
  i57 = (Math_imul(i56 & 255, i4 & 255) | 0) + 128 | 0;
  i58 = (Math_imul(i56 >>> 8 & 255, i4 >>> 8 & 255) | 0) + 128 | 0;
  i55 = (Math_imul(i56 >>> 16 & 255, i4 >>> 16 & 255) | 0) + 128 | 0;
  i56 = (Math_imul(i56 >>> 24, i4 >>> 24) | 0) + 128 | 0;
  i52 = (Math_imul(i51 & 255, i3 & 255) | 0) + 128 | 0;
  i53 = (Math_imul(i51 >>> 8 & 255, i3 >>> 8 & 255) | 0) + 128 | 0;
  i50 = (Math_imul(i51 >>> 16 & 255, i3 >>> 16 & 255) | 0) + 128 | 0;
  i51 = (Math_imul(i51 >>> 24, i3 >>> 24) | 0) + 128 | 0;
  i3 = (Math_imul(i8 & 255, i2 & 255) | 0) + 128 | 0;
  i48 = (Math_imul(i8 >>> 8 & 255, i2 >>> 8 & 255) | 0) + 128 | 0;
  i5 = (Math_imul(i8 >>> 16 & 255, i2 >>> 16 & 255) | 0) + 128 | 0;
  i4 = (Math_imul(i8 >>> 24, i2 >>> 24) | 0) + 128 | 0;
  i8 = (Math_imul(i9 & 255, i1 & 255) | 0) + 128 | 0;
  i7 = (Math_imul(i9 >>> 8 & 255, i1 >>> 8 & 255) | 0) + 128 | 0;
  i15 = (Math_imul(i9 >>> 16 & 255, i1 >>> 16 & 255) | 0) + 128 | 0;
  i9 = (Math_imul(i9 >>> 24, i1 >>> 24) | 0) + 128 | 0;
  HEAP32[i54 >> 2] = (i58 >>> 8) + i58 & 261888 | ((i57 >>> 8) + i57 | 0) >>> 8 | ((i56 >>> 8) + i56 | 0) >>> 8 << 24 | ((i55 >>> 8) + i55 | 0) >>> 8 << 16;
  HEAP32[i49 >> 2] = (i53 >>> 8) + i53 & 261888 | ((i52 >>> 8) + i52 | 0) >>> 8 | ((i51 >>> 8) + i51 | 0) >>> 8 << 24 | ((i50 >>> 8) + i50 | 0) >>> 8 << 16;
  HEAP32[i6 >> 2] = (i48 >>> 8) + i48 & 261888 | ((i3 >>> 8) + i3 | 0) >>> 8 | ((i4 >>> 8) + i4 | 0) >>> 8 << 24 | ((i5 >>> 8) + i5 | 0) >>> 8 << 16;
  HEAP32[i47 >> 2] = (i7 >>> 8) + i7 & 261888 | ((i8 >>> 8) + i8 | 0) >>> 8 | ((i9 >>> 8) + i9 | 0) >>> 8 << 24 | ((i15 >>> 8) + i15 | 0) >>> 8 << 16;
  i16 = i16 + 4 | 0;
 } while (i16 >>> 0 < i25 >>> 0);
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i27, i1, i28, i2) {
 i3 = i3 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0;
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i25 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i25) return;
 i19 = HEAP32[i3 + 60 >> 2] | 0;
 i20 = HEAP32[i3 + 80 >> 2] | 0;
 i21 = HEAP32[i3 + 100 >> 2] | 0;
 i22 = HEAP32[i3 + 120 >> 2] | 0;
 i23 = HEAP32[i3 + 140 >> 2] | 0;
 i17 = HEAP32[i3 + 160 >> 2] | 0;
 i18 = i28 + 192 | 0;
 i16 = 0;
 do {
  i15 = i19 + (i16 << 2) | 0;
  f46 = Math_fround(HEAPF32[i15 >> 2]);
  f45 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i20 + (i16 << 2) | 0;
  f42 = Math_fround(HEAPF32[i15 >> 2]);
  f41 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i21 + (i16 << 2) | 0;
  f38 = Math_fround(HEAPF32[i15 >> 2]);
  f37 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i22 + (i16 << 2) | 0;
  f35 = Math_fround(HEAPF32[i15 >> 2]);
  f33 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f29 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i23 + (i16 << 2) | 0;
  f34 = Math_fround(HEAPF32[i15 >> 2]);
  f32 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i15 + 12 >> 2]);
  i15 = i17 + (i16 << 2) | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  f13 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f35 = Math_fround(f46 + f35);
  f33 = Math_fround(f45 + f33);
  f31 = Math_fround(f44 + f31);
  f29 = Math_fround(f43 + f29);
  f34 = Math_fround(f42 + f34);
  f32 = Math_fround(f41 + f32);
  f30 = Math_fround(f40 + f30);
  f10 = Math_fround(f39 + f10);
  f11 = Math_fround(f38 + f11);
  f13 = Math_fround(f37 + f13);
  f12 = Math_fround(f36 + f12);
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i15 + 12 >> 2]));
  f11 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f34 * f34)) + Math_fround(f11 * f11))))));
  f13 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f32 * f32)) + Math_fround(f13 * f13))))));
  f12 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f30 * f30)) + Math_fround(f12 * f12))))));
  f14 = Math_fround(f24 + Math_fround(f26 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f10 * f10)) + Math_fround(f14 * f14))))));
  i15 = f11 < Math_fround(0.0);
  f11 = i15 ? Math_fround(0.0) : f11;
  i15 = f13 < Math_fround(0.0);
  f13 = i15 ? Math_fround(0.0) : f13;
  i15 = f12 < Math_fround(0.0);
  f12 = i15 ? Math_fround(0.0) : f12;
  i15 = f14 < Math_fround(0.0);
  f14 = i15 ? Math_fround(0.0) : f14;
  i15 = f11 > Math_fround(1.0);
  f11 = i15 ? Math_fround(1.0) : f11;
  i15 = f13 > Math_fround(1.0);
  f13 = i15 ? Math_fround(1.0) : f13;
  i15 = f12 > Math_fround(1.0);
  f12 = i15 ? Math_fround(1.0) : f12;
  i15 = f14 > Math_fround(1.0);
  f14 = i15 ? Math_fround(1.0) : f14;
  i15 = HEAP32[i18 >> 2] | 0;
  L6 : do if (!i15) i1 = 0; else {
   i1 = 0;
   do {
    f46 = Math_fround(HEAPF32[i28 + 64 + (i1 << 2) >> 2]);
    if (!(f14 > f46 & (f12 > f46 & (f11 > f46 & f13 > f46)))) break L6;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i15 >>> 0);
  } while (0);
  L11 : do if (i1 >>> 0 < i15 >>> 0) {
   i7 = i1;
   i8 = 0;
   i4 = -1;
   i9 = 0;
   i3 = -1;
   i5 = 0;
   i2 = -1;
   i6 = 0;
   i1 = -1;
   while (1) {
    if ((i6 & i9 & i5 & i8 | 0) <= -1) break L11;
    f10 = Math_fround(HEAPF32[i28 + 64 + (i7 << 2) >> 2]);
    i47 = HEAP32[i28 + (i7 << 2) >> 2] | 0;
    i4 = i47 & ~i8 | i8 & i4;
    i3 = i47 & ~i5 | i5 & i3;
    i2 = i47 & ~i6 | i6 & i2;
    i1 = i47 & ~i9 | i9 & i1;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i15 >>> 0) break; else {
     i8 = (f11 < f10) << 31 >> 31;
     i9 = (f14 < f10) << 31 >> 31;
     i5 = (f13 < f10) << 31 >> 31;
     i6 = (f12 < f10) << 31 >> 31;
    }
   }
  } else {
   i4 = -1;
   i3 = -1;
   i2 = -1;
   i1 = -1;
  } while (0);
  i54 = i27 + (i16 << 2) | 0;
  i56 = HEAP32[i54 >> 2] | 0;
  i49 = i54 + 4 | 0;
  i51 = HEAP32[i49 >> 2] | 0;
  i6 = i54 + 8 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i47 = i54 + 12 | 0;
  i9 = HEAP32[i47 >> 2] | 0;
  i57 = (Math_imul(i56 & 255, i4 & 255) | 0) + 128 | 0;
  i58 = (Math_imul(i56 >>> 8 & 255, i4 >>> 8 & 255) | 0) + 128 | 0;
  i55 = (Math_imul(i56 >>> 16 & 255, i4 >>> 16 & 255) | 0) + 128 | 0;
  i56 = (Math_imul(i56 >>> 24, i4 >>> 24) | 0) + 128 | 0;
  i52 = (Math_imul(i51 & 255, i3 & 255) | 0) + 128 | 0;
  i53 = (Math_imul(i51 >>> 8 & 255, i3 >>> 8 & 255) | 0) + 128 | 0;
  i50 = (Math_imul(i51 >>> 16 & 255, i3 >>> 16 & 255) | 0) + 128 | 0;
  i51 = (Math_imul(i51 >>> 24, i3 >>> 24) | 0) + 128 | 0;
  i3 = (Math_imul(i8 & 255, i2 & 255) | 0) + 128 | 0;
  i48 = (Math_imul(i8 >>> 8 & 255, i2 >>> 8 & 255) | 0) + 128 | 0;
  i5 = (Math_imul(i8 >>> 16 & 255, i2 >>> 16 & 255) | 0) + 128 | 0;
  i4 = (Math_imul(i8 >>> 24, i2 >>> 24) | 0) + 128 | 0;
  i8 = (Math_imul(i9 & 255, i1 & 255) | 0) + 128 | 0;
  i7 = (Math_imul(i9 >>> 8 & 255, i1 >>> 8 & 255) | 0) + 128 | 0;
  i15 = (Math_imul(i9 >>> 16 & 255, i1 >>> 16 & 255) | 0) + 128 | 0;
  i9 = (Math_imul(i9 >>> 24, i1 >>> 24) | 0) + 128 | 0;
  HEAP32[i54 >> 2] = (i58 >>> 8) + i58 & 261888 | ((i57 >>> 8) + i57 | 0) >>> 8 | ((i56 >>> 8) + i56 | 0) >>> 8 << 24 | ((i55 >>> 8) + i55 | 0) >>> 8 << 16;
  HEAP32[i49 >> 2] = (i53 >>> 8) + i53 & 261888 | ((i52 >>> 8) + i52 | 0) >>> 8 | ((i51 >>> 8) + i51 | 0) >>> 8 << 24 | ((i50 >>> 8) + i50 | 0) >>> 8 << 16;
  HEAP32[i6 >> 2] = (i48 >>> 8) + i48 & 261888 | ((i3 >>> 8) + i3 | 0) >>> 8 | ((i4 >>> 8) + i4 | 0) >>> 8 << 24 | ((i5 >>> 8) + i5 | 0) >>> 8 << 16;
  HEAP32[i47 >> 2] = (i7 >>> 8) + i7 & 261888 | ((i8 >>> 8) + i8 | 0) >>> 8 | ((i9 >>> 8) + i9 | 0) >>> 8 << 24 | ((i15 >>> 8) + i15 | 0) >>> 8 << 16;
  i16 = i16 + 4 | 0;
 } while (i16 >>> 0 < i25 >>> 0);
 return;
}

function __ZN5physx11HullLibrary7extrudeEPNS_3TriEi(i22, i21, i23) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25;
 i15 = HEAP32[i21 >> 2] | 0;
 i16 = HEAP32[i21 + 4 >> 2] | 0;
 i7 = HEAP32[i21 + 8 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0;
 i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i10 = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0;
 i19 = _PxGetFoundation() | 0;
 i19 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 24 >> 2] | 0, i19 | 0) | 0;
 i19 = mftCall_iiiiii(i10 | 0, i17 | 0, 36, (i19 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1424) | 0;
 __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i19, i23, i16, i7, HEAP32[i22 >> 2] | 0);
 i17 = i19 + 12 | 0;
 i10 = i21 + 12 | 0;
 i11 = i12 + 1 | 0;
 i18 = i12 + 2 | 0;
 HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i19 + 16 >> 2] = i11;
 HEAP32[i19 + 20 >> 2] = i18;
 i6 = HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i10 >> 2] << 2) >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = (i1 | 0) == (i16 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 do if (i4 & (i5 | 0) == (i7 | 0)) {
  i1 = 2;
  i24 = 2;
 } else {
  i1 = (i1 | 0) == (i7 | 0);
  i2 = (i5 | 0) == (i16 | 0);
  if (i1 & i2) i1 = 2; else {
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   if (i2 & (i3 | 0) == (i7 | 0)) {
    i1 = 0;
    i24 = 2;
    break;
   }
   if ((i5 | 0) == (i7 | 0) & (i3 | 0) == (i16 | 0)) i1 = 0; else {
    if (!((i3 | 0) != (i16 | 0) | i1 ^ 1)) {
     i1 = 1;
     i24 = 2;
     break;
    }
    if ((i3 | 0) != (i7 | 0) | i4 ^ 1) {
     i1 = gb + 110160 | 0;
     break;
    } else i1 = 1;
   }
  }
  i1 = i6 + 12 + (i1 << 2) | 0;
 } while (0);
 if ((i24 | 0) == 2) i1 = i6 + 12 + (i1 << 2) | 0;
 HEAP32[i1 >> 2] = i12;
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
 i14 = _PxGetFoundation() | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
 i14 = mftCall_iiiiii(i6 | 0, i13 | 0, 36, (i14 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1431) | 0;
 __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i14, i23, i7, i15, HEAP32[i22 >> 2] | 0);
 i13 = i14 + 12 | 0;
 i6 = i10 + 4 | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i14 + 16 >> 2] = i18;
 HEAP32[i14 + 20 >> 2] = i12;
 i6 = HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i6 >> 2] << 2) >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = (i1 | 0) == (i7 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 do if (i4 & (i5 | 0) == (i15 | 0)) {
  i1 = 2;
  i24 = 10;
 } else {
  i1 = (i1 | 0) == (i15 | 0);
  i2 = (i5 | 0) == (i7 | 0);
  if (i1 & i2) i1 = 2; else {
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   if (i2 & (i3 | 0) == (i15 | 0)) {
    i1 = 0;
    i24 = 10;
    break;
   }
   if ((i5 | 0) == (i15 | 0) & (i3 | 0) == (i7 | 0)) i1 = 0; else {
    if (!((i3 | 0) != (i7 | 0) | i1 ^ 1)) {
     i1 = 1;
     i24 = 10;
     break;
    }
    if ((i3 | 0) != (i15 | 0) | i4 ^ 1) {
     i1 = gb + 110160 | 0;
     break;
    } else i1 = 1;
   }
  }
  i1 = i6 + 12 + (i1 << 2) | 0;
 } while (0);
 if ((i24 | 0) == 10) i1 = i6 + 12 + (i1 << 2) | 0;
 HEAP32[i1 >> 2] = i11;
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i9 = _PxGetFoundation() | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0;
 i9 = mftCall_iiiiii(i6 | 0, i8 | 0, 36, (i9 ? gb + 730518 | 0 : gb + 837976 | 0) | 0, gb + 730220 | 0, 1438) | 0;
 __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i9, i23, i15, i16, HEAP32[i22 >> 2] | 0);
 i8 = i9 + 12 | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 16 >> 2] = i12;
 HEAP32[i9 + 20 >> 2] = i11;
 i7 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
 i6 = HEAP32[i7 + (HEAP32[i6 >> 2] << 2) >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = (i1 | 0) == (i15 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 do if (i4 & (i5 | 0) == (i16 | 0)) {
  i1 = 2;
  i24 = 18;
 } else {
  i1 = (i1 | 0) == (i16 | 0);
  i2 = (i5 | 0) == (i15 | 0);
  if (i1 & i2) i1 = 2; else {
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   if (i2 & (i3 | 0) == (i16 | 0)) {
    i1 = 0;
    i24 = 18;
    break;
   }
   if ((i5 | 0) == (i16 | 0) & (i3 | 0) == (i15 | 0)) i1 = 0; else {
    if (!((i3 | 0) != (i15 | 0) | i1 ^ 1)) {
     i1 = 1;
     i24 = 18;
     break;
    }
    if ((i3 | 0) != (i16 | 0) | i4 ^ 1) {
     i1 = gb + 110160 | 0;
     break;
    } else i1 = 1;
   }
  }
  i1 = i6 + 12 + (i1 << 2) | 0;
 } while (0);
 if ((i24 | 0) == 18) i1 = i6 + 12 + (i1 << 2) | 0;
 HEAP32[i1 >> 2] = i18;
 i1 = HEAP32[i7 + (HEAP32[i17 >> 2] << 2) >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i23 | 0)) i24 = 28; else if ((HEAP32[i1 + 4 >> 2] | 0) == (i23 | 0)) i24 = 28; else if ((HEAP32[i1 + 8 >> 2] | 0) == (i23 | 0)) i24 = 28;
 if ((i24 | 0) == 28) {
  __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_(i22, i19, i1);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i19 + 24 >> 2] << 2) >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i19);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] = 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i1);
 }
 i1 = HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i13 >> 2] << 2) >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i23 | 0)) i24 = 33; else if ((HEAP32[i1 + 4 >> 2] | 0) == (i23 | 0)) i24 = 33; else if ((HEAP32[i1 + 8 >> 2] | 0) == (i23 | 0)) i24 = 33;
 if ((i24 | 0) == 33) {
  __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_(i22, i14, i1);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i14 + 24 >> 2] << 2) >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i14);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] = 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i1);
 }
 i1 = HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i8 >> 2] << 2) >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i23 | 0)) i24 = 38; else if ((HEAP32[i1 + 4 >> 2] | 0) == (i23 | 0)) i24 = 38; else if ((HEAP32[i1 + 8 >> 2] | 0) == (i23 | 0)) i24 = 38;
 if ((i24 | 0) == 38) {
  __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_(i22, i9, i1);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i9 + 24 >> 2] << 2) >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i9);
  HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] = 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i1);
 }
 HEAP32[(HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (HEAP32[i21 + 24 >> 2] << 2) >> 2] = 0;
 if (!i21) {
  STACKTOP = i25;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i21);
 STACKTOP = i25;
 return;
}

function __ZN22ProceduralMaterialData12CopyFromDataERKS_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i14 = i16 + 4 | 0;
 i15 = i16;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 i4 = i12 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  i11 = i2 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  if (!(HEAP32[i11 >> 2] | 0)) {
   if (!(HEAP8[i2 + 16 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63736 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
  }
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 >> 2] = i1;
 HEAP32[i12 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 i9 = (i12 | 0) == (i8 | 0);
 do if (!i9) {
  __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i12 + 32 | 0, HEAP32[i8 + 32 >> 2] | 0, HEAP32[i8 + 36 >> 2] | 0);
  __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 44 | 0, HEAP32[i8 + 44 >> 2] | 0, HEAP32[i8 + 48 >> 2] | 0);
  __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12 + 60 | 0, HEAP32[i8 + 60 >> 2] | 0, HEAP32[i8 + 64 >> 2] | 0);
  i1 = i12 + 12 | 0;
  i6 = i8 + 12 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i8 + 16 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 20 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 16 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i12 + 16 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i12 + 112 >> 2] = HEAP32[i8 + 112 >> 2];
 i1 = i8 + 96 | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = i12 + 96 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 i10 = i8 + 104 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i12 + 104 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 i2 = i12 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i11 = i3 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  if (!(HEAP32[i11 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
  }
 }
 HEAP32[i2 >> 2] = i1;
 i4 = i8 + 76 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i11 = i8 + 80 | 0;
 if ((i2 | 0) != (i11 | 0)) while (1) {
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  if (i1 | 0) {
   i10 = i1 + 4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i1;
 }
 i10 = i12 + 76 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i12 + 80 | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 + 20 >> 2] | 0;
   if (i1 | 0) {
    i8 = i1 + 4 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
    if (!(HEAP32[i8 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
    }
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 if (i9) {
  STACKTOP = i16;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i10, HEAP32[i3 >> 2] | 0);
 i9 = i12 + 88 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i16;
  return;
 }
 i6 = i3;
 i7 = i12 + 84 | 0;
 i8 = i13 + 4 | 0;
 i5 = i12 + 80 | 0;
 i3 = i1;
 i2 = i1;
 while (1) {
  i3 = i3 + 16 | 0;
  HEAP32[i15 >> 2] = i6;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  i4 = __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i10, i13, i14, i3) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i13 >> 2] = 77;
   HEAP32[i8 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   i17 = i3;
   i12 = HEAP32[i17 + 4 >> 2] | 0;
   i3 = i1 + 16 | 0;
   HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i3 + 4 >> 2] = i12;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i10 >> 2] = i3;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 >> 2] | 0, i1);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i11 | 0)) break; else {
   i3 = i1;
   i2 = i1;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZL22PxcGenerateVFContacts2RN5physx2Gu13ContactBufferERKNS_11PxTransformERKNS0_13PolygonalDataERKNS_11PxMeshScaleEjPKNS_6PxVec3EfRSD_f(i36, i1, i4, i2, i37, i39, f40, i38, f3) {
 i36 = i36 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i37 = i37 | 0;
 i39 = i39 | 0;
 f40 = Math_fround(f40);
 i38 = i38 | 0;
 f3 = Math_fround(f3);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i41 = 0, i42 = 0, f43 = f0, f44 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i42 + 56 | 0;
 i31 = i42 + 28 | 0;
 i30 = i42;
 f22 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 >> 2]));
 f35 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 4 >> 2]));
 f34 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i31 >> 2] = f22;
 HEAPF32[i31 + 4 >> 2] = f35;
 HEAPF32[i31 + 8 >> 2] = f34;
 HEAP32[i31 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 f34 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f34 = Math_fround(f34 * Math_fround(-2.0));
 f35 = Math_fround(f35 * Math_fround(-2.0));
 f22 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
 f32 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f16 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i1 >> 2]);
 f24 = Math_fround(f34 * f27);
 f33 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f35 * f33));
 f25 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f22 * f25));
 f29 = Math_fround(Math_fround(f27 * f24) + Math_fround(Math_fround(f34 * f16) - Math_fround(f32 * Math_fround(Math_fround(f22 * f33) - Math_fround(f35 * f25)))));
 f18 = Math_fround(Math_fround(f33 * f24) + Math_fround(Math_fround(f35 * f16) - Math_fround(f32 * Math_fround(Math_fround(f34 * f25) - Math_fround(f22 * f27)))));
 f24 = Math_fround(Math_fround(Math_fround(f22 * f16) - Math_fround(f32 * Math_fround(Math_fround(f35 * f27) - Math_fround(f34 * f33)))) + Math_fround(f25 * f24));
 f33 = Math_fround(-f33);
 f25 = Math_fround(-f25);
 HEAPF32[i30 >> 2] = Math_fround(-f27);
 HEAPF32[i30 + 4 >> 2] = f33;
 HEAPF32[i30 + 8 >> 2] = f25;
 HEAPF32[i30 + 12 >> 2] = f32;
 HEAPF32[i30 + 16 >> 2] = f29;
 HEAPF32[i30 + 20 >> 2] = f18;
 HEAPF32[i30 + 24 >> 2] = f24;
 __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE(i5, i31, i30);
 f24 = Math_fround(-Math_fround(HEAPF32[i38 >> 2]));
 i30 = i38 + 4 | 0;
 f18 = Math_fround(-Math_fround(HEAPF32[i30 >> 2]));
 i31 = i38 + 8 | 0;
 f29 = Math_fround(-Math_fround(HEAPF32[i31 >> 2]));
 f32 = Math_fround(HEAPF32[i5 >> 2]);
 f25 = Math_fround(f32 * f24);
 f33 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f27 = Math_fround(f33 * f24);
 f34 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f24 = Math_fround(f34 * f24);
 f35 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f16 = Math_fround(f35 * f18);
 f22 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(f22 * f18);
 f23 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(f25 + f16);
 f17 = Math_fround(f27 + f17);
 f18 = Math_fround(f24 + Math_fround(f23 * f18));
 f24 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f27 = Math_fround(f24 * f29);
 f25 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f28 = Math_fround(f25 * f29);
 f26 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f27 = Math_fround(f16 + f27);
 f28 = Math_fround(f17 + f28);
 f29 = Math_fround(f18 + Math_fround(f26 * f29));
 if (!i37) {
  STACKTOP = i42;
  return;
 }
 f18 = Math_fround(f40 + f3);
 i21 = HEAP32[i4 + 16 >> 2] | 0;
 i20 = HEAP32[i4 + 24 >> 2] | 0;
 f18 = Math_fround(f18 + Math_fround(-9.99999974e-06));
 i19 = i36 + 4096 | 0;
 f16 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 44 >> 2]);
 i4 = 0;
 do {
  f13 = Math_fround(HEAPF32[i39 + (i4 * 12 | 0) >> 2]);
  f9 = Math_fround(f13 * f32);
  f10 = Math_fround(f13 * f33);
  f11 = Math_fround(f13 * f34);
  f14 = Math_fround(HEAPF32[i39 + (i4 * 12 | 0) + 4 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f14 * f35));
  f10 = Math_fround(f10 + Math_fround(f14 * f22));
  f11 = Math_fround(f11 + Math_fround(f14 * f23));
  f15 = Math_fround(HEAPF32[i39 + (i4 * 12 | 0) + 8 >> 2]);
  f9 = Math_fround(Math_fround(f9 + Math_fround(f15 * f24)) + f16);
  f10 = Math_fround(Math_fround(f10 + Math_fround(f15 * f25)) + f17);
  f11 = Math_fround(Math_fround(f11 + Math_fround(f15 * f26)) + f12);
  f3 = Math_fround(3402823469999999843913219.0e14);
  f6 = Math_fround(-3402823469999999843913219.0e14);
  i2 = i21;
  i1 = i20;
  L6 : while (1) {
   L8 : while (1) {
    while (1) {
     if (!i2) {
      i41 = 12;
      break L6;
     }
     i2 = i2 + -1 | 0;
     f44 = Math_fround(HEAPF32[i1 >> 2]);
     f8 = Math_fround(f9 * f44);
     f43 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f8 = Math_fround(f8 + Math_fround(f10 * f43));
     f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f8 = Math_fround(f8 + Math_fround(f11 * f7));
     f8 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f8);
     i1 = i1 + 20 | 0;
     f7 = Math_fround(Math_fround(Math_fround(f27 * f44) + Math_fround(f28 * f43)) + Math_fround(f29 * f7));
     if (f7 > Math_fround(1.00000001e-07)) break L8;
     if (f7 < Math_fround(-1.00000001e-07)) break;
     if (f8 > Math_fround(0.0)) break L6;
    }
    f44 = Math_fround(Math_fround(-f8) / f7);
    f6 = f6 > f44 ? f6 : f44;
   }
   f44 = Math_fround(Math_fround(-f8) / f7);
   f3 = f3 < f44 ? f3 : f44;
  }
  if ((i41 | 0) == 12) {
   i41 = 0;
   if (f6 < f18 & (f6 < f3 & f6 != Math_fround(-3402823469999999843913219.0e14))) {
    i1 = HEAP32[i19 >> 2] | 0;
    if (i1 >>> 0 <= 63) {
     f44 = Math_fround(f6 - f40);
     f11 = Math_fround(HEAPF32[i31 >> 2]);
     f43 = Math_fround(f15 - Math_fround(f6 * f11));
     f10 = Math_fround(HEAPF32[i30 >> 2]);
     f15 = Math_fround(f14 - Math_fround(f6 * f10));
     f9 = Math_fround(HEAPF32[i38 >> 2]);
     f14 = Math_fround(f13 - Math_fround(f6 * f9));
     HEAP32[i19 >> 2] = i1 + 1;
     HEAPF32[i36 + (i1 << 6) >> 2] = f9;
     HEAPF32[i36 + (i1 << 6) + 4 >> 2] = f10;
     HEAPF32[i36 + (i1 << 6) + 8 >> 2] = f11;
     HEAPF32[i36 + (i1 << 6) + 16 >> 2] = f14;
     HEAPF32[i36 + (i1 << 6) + 20 >> 2] = f15;
     HEAPF32[i36 + (i1 << 6) + 24 >> 2] = f43;
     HEAPF32[i36 + (i1 << 6) + 12 >> 2] = f44;
     HEAP32[i36 + (i1 << 6) + 48 >> 2] = -1;
     HEAP32[i36 + (i1 << 6) + 52 >> 2] = -1;
    }
   }
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i37 | 0));
 STACKTOP = i42;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 56 | 0;
 i5 = i3 + 8 | 0;
 i12 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i10 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470975 | 0, i10, i1 + 28 | 0, 0);
 i8 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853571 | 0, gb + 470987 | 0, i11, 0);
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853571 | 0, i7, i11, 0);
 HEAP32[i12 >> 2] = -1;
 i11 = i12 + 4 | 0;
 HEAP32[i11 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 471352 | 0, i12, 0);
 HEAP8[i6 >> 0] = HEAP32[i12 >> 2];
 i9 = HEAP32[gb + 37252 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 670513 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i12 >> 2] = HEAP8[i6 >> 0];
 HEAP8[i6 >> 0] = HEAP32[i11 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 670520 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i11 >> 2] = HEAP8[i6 >> 0];
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471006 | 0, i10, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471018 | 0, i7, i1 + 56 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37288 >> 2] | 0, i5, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i6 >> 0] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471035 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP8[i6 >> 0];
 i7 = i1 + 4 | 0;
 HEAP8[i6 >> 0] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471056 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP8[i6 >> 0];
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 108 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471073 | 0, i4, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 120 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471088 | 0, i4, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 132 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471103 | 0, i4, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 156 | 0, gb + 471119 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471134 | 0, i4, i1 + 168 | 0, 0);
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = -1;
 i7 = i5 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 471230 | 0, i5, 0);
 __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 180 | 0, gb + 471152 | 0, 0);
 i1 = i1 + 144 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471177 | 0, i4, i1, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i35, i36, i1) {
 i35 = i35 | 0;
 i36 = i36 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i40 + 72 | 0;
 i28 = i40 + 68 | 0;
 i32 = i40 + 64 | 0;
 i38 = i40 + 32 | 0;
 i33 = i40;
 i34 = i36 + 12 | 0;
 HEAP32[i32 >> 2] = HEAP32[i34 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i35, gb + 1041885 | 0, gb + 1041885 | 0, i32) | 0)) {
  STACKTOP = i40;
  return;
 };
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 HEAP32[i38 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i38 + 4 >> 2] = 0;
 HEAP32[i38 + 8 >> 2] = 0;
 i7 = i38 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i38 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i31 = i36 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i36, HEAP32[i31 >> 2] | 0);
 HEAP32[i34 >> 2] = 0;
 HEAP32[i36 >> 2] = i31;
 HEAP32[i31 >> 2] = 0;
 if ((HEAP32[i32 >> 2] | 0) > 0) {
  i8 = HEAP32[gb + 37152 >> 2] | 0;
  i9 = i38 + 11 | 0;
  i10 = i38 + 4 | 0;
  i11 = i33 + 12 | 0;
  i5 = i33 + 12 | 0;
  i12 = i37 + 4 | 0;
  i13 = i33 + 8 | 0;
  i14 = i33 + 4 | 0;
  i15 = i33 + 16 | 0;
  i16 = i7 + 11 | 0;
  i17 = i38 + 20 | 0;
  i18 = i33 + 28 | 0;
  i6 = i33 + 28 | 0;
  i19 = i37 + 4 | 0;
  i20 = i33 + 24 | 0;
  i21 = i33 + 20 | 0;
  i22 = i36 + 8 | 0;
  i23 = i37 + 4 | 0;
  i24 = i36 + 4 | 0;
  i25 = i33 + 16 | 0;
  i26 = i25 + 11 | 0;
  i27 = i37 + 4 | 0;
  i29 = i33 + 11 | 0;
  i30 = i37 + 4 | 0;
  i31 = i15 + 11 | 0;
  i4 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i35, gb + 1041891 | 0, i8, i37, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_(i38, i35); else {
     i1 = HEAP32[i37 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i38 | 0, i35 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i35);
   }
   i3 = HEAP8[i9 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i38 >> 2] | 0 : i38;
   i3 = i1 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
   HEAP32[i33 >> 2] = 0;
   HEAP32[i33 + 4 >> 2] = 0;
   HEAP32[i33 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i33);
    i1 = HEAP32[i5 >> 2] | 0;
    i39 = 18;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i29 >> 0] = i3;
    if (!i3) i1 = i33; else {
     i1 = i33;
     i39 = 20;
    }
   } else i39 = 18;
   if ((i39 | 0) == 18) {
    i41 = i3 + 16 & -16;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i37, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i33 >> 2] = i1;
    HEAP32[i13 >> 2] = i41 | -2147483648;
    HEAP32[i14 >> 2] = i3;
    i39 = 20;
   }
   if ((i39 | 0) == 20) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = HEAP8[i16 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
   i3 = i1 ? HEAP32[i17 >> 2] | 0 : i3 & 255;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
    i1 = HEAP32[i6 >> 2] | 0;
    i39 = 24;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i31 >> 0] = i3;
    if (!i3) i1 = i15; else {
     i1 = i15;
     i39 = 26;
    }
   } else i39 = 24;
   if ((i39 | 0) == 24) {
    i41 = i3 + 16 & -16;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i19 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i41, 16, i37, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i15 >> 2] = i1;
    HEAP32[i20 >> 2] = i41 | -2147483648;
    HEAP32[i21 >> 2] = i3;
    i39 = 26;
   }
   if ((i39 | 0) == 26) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i2 = __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i36, i28, i33) | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    i1 = HEAP32[i22 >> 2] | 0;
    HEAP32[i37 >> 2] = 1;
    HEAP32[i23 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i37, 0, gb + 1049224 | 0, 75) | 0;
    __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_(i1 + 16 | 0, i33);
    i3 = HEAP32[i28 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i3;
    HEAP32[i2 >> 2] = i1;
    i3 = HEAP32[HEAP32[i36 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i36 >> 2] = i3;
     i1 = HEAP32[i2 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i24 >> 2] | 0, i1);
    HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + 1;
   }
   if ((HEAP8[i26 >> 0] | 0) < 0) {
    i41 = HEAP32[i25 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i27 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i41, i37);
   }
   if ((HEAP8[i29 >> 0] | 0) < 0) {
    i41 = HEAP32[i33 >> 2] | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    HEAP32[i37 >> 2] = 66;
    HEAP32[i30 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i41, i37);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i32 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i35);
 i1 = i38 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i41 = HEAP32[i1 >> 2] | 0;
  i39 = HEAP32[i38 + 28 >> 2] | 0;
  HEAP32[i37 >> 2] = 66;
  HEAP32[i37 + 4 >> 2] = i39;
  __Z19free_alloc_internalPvRK10MemLabelId(i41, i37);
 }
 if ((HEAP8[i38 + 11 >> 0] | 0) < 0) {
  i41 = HEAP32[i38 >> 2] | 0;
  i39 = HEAP32[i38 + 12 >> 2] | 0;
  HEAP32[i37 >> 2] = 66;
  HEAP32[i37 + 4 >> 2] = i39;
  __Z19free_alloc_internalPvRK10MemLabelId(i41, i37);
 }
 STACKTOP = i40;
 return;
}

function __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i8, i9);
 i2 = i8 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i9);
 __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i9, i8 + 44 | 0, gb + 906091 | 0, 0);
 i1 = i8 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 60, 4) | 0;
  __ZN7mecanim4hand4HandC2Ev(i2);
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 }
 i6 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i6 >> 2] = i4;
 }
 if (i3 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i1 | 0, i3 << 2);
 i1 = i8 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 60, 4) | 0;
  __ZN7mecanim4hand4HandC2Ev(i2);
  i4 = i1;
  i2 = i2 | 0 ? i2 - i4 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i4;
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i6 >> 2] = i4;
 }
 if (i3 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i1 | 0, i3 << 2);
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i8 + 60;
 HEAP32[i5 + 4 >> 2] = i8 + 56;
 HEAP32[i5 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i9, i5, 0);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i8 + 68;
 HEAP32[i5 + 4 >> 2] = i8 + 64;
 HEAP32[i5 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i9, i5, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i8 + 72 | 0, i1 << 2);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i8 + 168 | 0, i1 << 2);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i8 + 264 | 0, i1 << 2);
 i1 = i8 + 360 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 364 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 376 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 380 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 384 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 388 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 392 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i8 + 393 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i8 + 394 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 }
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i2, i7, i1, i8) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i2 + (i1 >> 1 << 3) | 0;
 if ((i1 | 0) < 65) {
  if (mftCall_iii(i8 | 0, i9 | 0, i2 | 0) | 0) {
   i5 = i9;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = i2;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i6 = i9;
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i6 + 4 >> 2] = i3;
   i6 = i2;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i5;
  }
  if (mftCall_iii(i8 | 0, i7 | 0, i9 | 0) | 0) {
   i5 = i7;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = i9;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i6 = i7;
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i6 + 4 >> 2] = i3;
   i6 = i9;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i5;
  }
  if (!(mftCall_iii(i8 | 0, i9 | 0, i2 | 0) | 0)) {
   i8 = i9;
   i6 = i8;
   i6 = HEAP32[i6 >> 2] | 0;
   i8 = i8 + 4 | 0;
   i8 = HEAP32[i8 >> 2] | 0;
   i5 = i7;
   i3 = i5;
   i3 = HEAP32[i3 >> 2] | 0;
   i5 = i5 + 4 | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = i9;
   HEAP32[i4 >> 2] = i3;
   i9 = i9 + 4 | 0;
   HEAP32[i9 >> 2] = i5;
   i9 = i7;
   i7 = i9;
   HEAP32[i7 >> 2] = i6;
   i9 = i9 + 4 | 0;
   HEAP32[i9 >> 2] = i8;
   return;
  }
  i6 = i9;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i2;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i9;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i3;
  i8 = i2;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i8 + 4 >> 2] = i6;
  i8 = i9;
  i6 = i8;
  i6 = HEAP32[i6 >> 2] | 0;
  i8 = i8 + 4 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i5 = i7;
  i3 = i5;
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = i5 + 4 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i4 = i9;
  HEAP32[i4 >> 2] = i3;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = i7;
  i7 = i9;
  HEAP32[i7 >> 2] = i6;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i4 = i1 >> 3;
 i5 = i4 << 1;
 i6 = i2 + (i4 << 3) | 0;
 i1 = i2 + (i5 << 3) | 0;
 if (mftCall_iii(i8 | 0, i6 | 0, i2 | 0) | 0) {
  i10 = i6;
  i11 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i13 = i2;
  i12 = HEAP32[i13 + 4 >> 2] | 0;
  i3 = i6;
  HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i3 + 4 >> 2] = i12;
  i3 = i2;
  HEAP32[i3 >> 2] = i11;
  HEAP32[i3 + 4 >> 2] = i10;
 }
 if (mftCall_iii(i8 | 0, i1 | 0, i6 | 0) | 0) {
  i12 = i1;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = i6;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i6;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i6 | 0, i2 | 0) | 0) {
  i12 = i6;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = i2;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  i13 = i6;
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i2;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i3 = 0 - i4 | 0;
 i2 = i9 + (i3 << 3) | 0;
 i1 = i9 + (i4 << 3) | 0;
 if (mftCall_iii(i8 | 0, i9 | 0, i2 | 0) | 0) {
  i12 = i9;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = i2;
  i10 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = i9;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i2;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i1 | 0, i9 | 0) | 0) {
  i12 = i1;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = i9;
  i10 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i9;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i9 | 0, i2 | 0) | 0) {
  i12 = i9;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = i2;
  i10 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = i9;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i2;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i2 = i7 + (0 - i5 << 3) | 0;
 i1 = i7 + (i3 << 3) | 0;
 if (mftCall_iii(i8 | 0, i1 | 0, i2 | 0) | 0) {
  i12 = i1;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i2;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i2;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i7 | 0, i1 | 0) | 0) {
  i12 = i7;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i1;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = i7;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i1;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i1 | 0, i2 | 0) | 0) {
  i12 = i1;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i2;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i2;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i9 | 0, i6 | 0) | 0) {
  i12 = i9;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i6;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = i9;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i6;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (mftCall_iii(i8 | 0, i1 | 0, i9 | 0) | 0) {
  i12 = i1;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i9;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 4 >> 2] = i10;
  i13 = i9;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
 }
 if (!(mftCall_iii(i8 | 0, i9 | 0, i6 | 0) | 0)) {
  i12 = i9;
  i10 = i12;
  i10 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i7;
  i8 = i11;
  i8 = HEAP32[i8 >> 2] | 0;
  i11 = i11 + 4 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i13 = i9;
  i9 = i13;
  HEAP32[i9 >> 2] = i8;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i7;
  i11 = i13;
  HEAP32[i11 >> 2] = i10;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 }
 i10 = i9;
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i13 = i6;
 i8 = HEAP32[i13 + 4 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = i8;
 i12 = i6;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i10;
 i12 = i9;
 i10 = i12;
 i10 = HEAP32[i10 >> 2] | 0;
 i12 = i12 + 4 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i7;
 i8 = i11;
 i8 = HEAP32[i8 >> 2] | 0;
 i11 = i11 + 4 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i13 = i9;
 i9 = i13;
 HEAP32[i9 >> 2] = i8;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i7;
 i11 = i13;
 HEAP32[i11 >> 2] = i10;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 return;
}

function __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKNS_6PxVec3ES6_fRj(i35, i43, i46, i47, f42, i45) {
 i35 = i35 | 0;
 i43 = i43 | 0;
 i46 = i46 | 0;
 i47 = i47 | 0;
 f42 = Math_fround(f42);
 i45 = i45 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i44 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, i52 = 0, i53 = 0, i54 = 0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i48 + 88 | 0;
 i5 = i48 + 72 | 0;
 i6 = i48 + 40 | 0;
 i12 = i48 + 154 | 0;
 i38 = i48 + 28 | 0;
 i39 = i48;
 i40 = i48 + 152 | 0;
 HEAP32[i44 >> 2] = 0;
 HEAP32[i44 + 4 >> 2] = 0;
 HEAP32[i44 + 8 >> 2] = -1;
 i41 = i44 + 12 | 0;
 HEAP16[i41 >> 1] = 0;
 i37 = i44 + 16 | 0;
 i36 = i44 + 40 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAP32[i37 + 16 >> 2] = 0;
 HEAP32[i37 + 20 >> 2] = 0;
 HEAPF32[i36 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i37 = i44 + 44 | 0;
 HEAPF32[i37 >> 2] = Math_fround(0.0);
 HEAPF32[i44 + 48 >> 2] = Math_fround(0.0);
 i7 = HEAP32[i35 + 8 >> 2] | 0;
 if (!i7) {
  f2 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
 } else {
  i8 = i35 + 4 | 0;
  i9 = i5 + 4 | 0;
  i10 = i5 + 8 | 0;
  i11 = i5 + 12 | 0;
  i13 = i6 + 4 | 0;
  i14 = i6 + 8 | 0;
  i15 = i6 + 12 | 0;
  i16 = i6 + 16 | 0;
  i17 = i6 + 20 | 0;
  i18 = i6 + 24 | 0;
  i19 = i43 + 12 | 0;
  i20 = i43 + 16 | 0;
  i21 = i44 + 16 | 0;
  i22 = i44 + 20 | 0;
  i23 = i43 + 20 | 0;
  i24 = i44 + 24 | 0;
  i25 = i43 + 24 | 0;
  i26 = i43 + 28 | 0;
  i27 = i44 + 28 | 0;
  i28 = i44 + 32 | 0;
  i29 = i43 + 32 | 0;
  i30 = i44 + 36 | 0;
  i31 = i43 + 36 | 0;
  i32 = i43 + 40 | 0;
  i33 = i43 + 44 | 0;
  i34 = 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
  i3 = 0;
  while (1) {
   i52 = HEAP32[i8 >> 2] | 0;
   i49 = HEAP32[(__ZN5physx2Gu19GetRaycastFuncTableEv() | 0) + 12 >> 2] | 0;
   i54 = HEAP32[i52 + (i34 * 72 | 0) + 56 >> 2] | 0;
   i53 = HEAP32[i52 + (i34 * 72 | 0) + 60 >> 2] | 0;
   i1 = HEAP32[i52 + (i34 * 72 | 0) + 64 >> 2] | 0;
   HEAP32[i5 >> 2] = 3;
   HEAP32[i9 >> 2] = i54;
   HEAP32[i10 >> 2] = i53;
   HEAP32[i11 >> 2] = i1;
   i1 = i52 + (i34 * 72 | 0) + 8 | 0;
   f51 = Math_fround(+HEAPF64[i52 + (i34 * 72 | 0) + 16 >> 3]);
   f50 = Math_fround(+HEAPF64[i52 + (i34 * 72 | 0) + 24 >> 3]);
   f2 = Math_fround(+HEAPF64[i52 + (i34 * 72 | 0) + 32 >> 3]);
   HEAP32[i6 >> 2] = HEAP32[i52 + (i34 * 72 | 0) + 40 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i52 + (i34 * 72 | 0) + 44 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i52 + (i34 * 72 | 0) + 48 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i52 + (i34 * 72 | 0) + 52 >> 2];
   HEAPF32[i16 >> 2] = f51;
   HEAPF32[i17 >> 2] = f50;
   HEAPF32[i18 >> 2] = f2;
   HEAP16[i12 >> 1] = 4;
   if (!(mftCall_iiiiifiiiiii(i49 | 0, i5 | 0, i6 | 0, i46 | 0, i47 | 0, +f42, i12 | 0, 1, i44 | 0, 0, 0, 0) | 0)) {
    f2 = f4;
    i1 = i3;
   } else {
    f2 = Math_fround(HEAPF32[i36 >> 2]);
    if (f2 < f4) {
     HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
     HEAP32[i43 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
     HEAP32[i43 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
     HEAP16[i19 >> 1] = HEAP16[i41 >> 1] | 0;
     HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i25 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
     HEAPF32[i32 >> 2] = f2;
     HEAP32[i33 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i33 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
     HEAP32[i33 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
     HEAP32[i33 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
     HEAP32[i33 + 16 >> 2] = HEAP32[i37 + 16 >> 2];
     HEAP32[i45 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i34 * 72 | 0) >> 2];
    } else {
     f2 = f4;
     i1 = i3;
    }
   }
   i34 = i34 + 1 | 0;
   if ((i34 | 0) == (i7 | 0)) break; else {
    f4 = f2;
    i3 = i1;
   }
  }
 }
 i30 = HEAP32[i35 + 20 >> 2] | 0;
 if (!i30) {
  i54 = i1;
  STACKTOP = i48;
  return i54 | 0;
 }
 i16 = i35 + 16 | 0;
 i17 = i38 + 4 | 0;
 i18 = i38 + 8 | 0;
 i19 = i39 + 4 | 0;
 i20 = i39 + 8 | 0;
 i21 = i39 + 12 | 0;
 i22 = i39 + 16 | 0;
 i23 = i39 + 20 | 0;
 i24 = i39 + 24 | 0;
 i25 = i43 + 12 | 0;
 i26 = i43 + 16 | 0;
 i27 = i44 + 16 | 0;
 i28 = i44 + 20 | 0;
 i5 = i43 + 20 | 0;
 i6 = i44 + 24 | 0;
 i7 = i43 + 24 | 0;
 i8 = i43 + 28 | 0;
 i9 = i44 + 28 | 0;
 i10 = i44 + 32 | 0;
 i11 = i43 + 32 | 0;
 i12 = i44 + 36 | 0;
 i13 = i43 + 36 | 0;
 i14 = i43 + 40 | 0;
 i15 = i43 + 44 | 0;
 i29 = 0;
 f4 = f2;
 i3 = i1;
 while (1) {
  i53 = HEAP32[i16 >> 2] | 0;
  i54 = HEAP32[(__ZN5physx2Gu19GetRaycastFuncTableEv() | 0) + 8 >> 2] | 0;
  i52 = HEAP32[i53 + (i29 << 6) + 60 >> 2] | 0;
  i1 = HEAP32[i53 + (i29 << 6) + 56 >> 2] | 0;
  HEAP32[i38 >> 2] = 2;
  HEAP32[i17 >> 2] = i52;
  HEAP32[i18 >> 2] = i1;
  i1 = i53 + (i29 << 6) + 8 | 0;
  f2 = Math_fround(+HEAPF64[i53 + (i29 << 6) + 16 >> 3]);
  f50 = Math_fround(+HEAPF64[i53 + (i29 << 6) + 24 >> 3]);
  f51 = Math_fround(+HEAPF64[i53 + (i29 << 6) + 32 >> 3]);
  HEAP32[i39 >> 2] = HEAP32[i53 + (i29 << 6) + 40 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i53 + (i29 << 6) + 44 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i53 + (i29 << 6) + 48 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i53 + (i29 << 6) + 52 >> 2];
  HEAPF32[i22 >> 2] = f2;
  HEAPF32[i23 >> 2] = f50;
  HEAPF32[i24 >> 2] = f51;
  HEAP16[i40 >> 1] = 4;
  if (!(mftCall_iiiiifiiiiii(i54 | 0, i38 | 0, i39 | 0, i46 | 0, i47 | 0, +f42, i40 | 0, 1, i44 | 0, 0, 0, 0) | 0)) {
   f2 = f4;
   i1 = i3;
  } else {
   f2 = Math_fround(HEAPF32[i36 >> 2]);
   if (f2 < f4) {
    HEAP32[i43 >> 2] = HEAP32[i44 >> 2];
    HEAP32[i43 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
    HEAP32[i43 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
    HEAP16[i25 >> 1] = HEAP16[i41 >> 1] | 0;
    HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
    HEAPF32[i14 >> 2] = f2;
    HEAP32[i15 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
    HEAP32[i15 + 16 >> 2] = HEAP32[i37 + 16 >> 2];
    HEAP32[i45 >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + (i29 << 6) >> 2];
   } else {
    f2 = f4;
    i1 = i3;
   }
  }
  i29 = i29 + 1 | 0;
  if ((i29 | 0) == (i30 | 0)) break; else {
   f4 = f2;
   i3 = i1;
  }
 }
 STACKTOP = i48;
 return i1 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 208 | 0;
 i13 = i21 + 200 | 0;
 i14 = i21 + 196 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 337 | 0;
 i11 = i21 + 336 | 0;
 __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i2;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i7 = i25 + 4 | 0;
  i8 = i25 + 8 | 0;
  i4 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i4) {
    i9 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) {
      i27 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i9 = 0;
     i5 = 1;
    } else {
     i9 = i4;
     i5 = 0;
    }
   }
   i4 = HEAP32[i23 >> 2] | 0;
   do if (!i4) i27 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i27 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 20;
     break;
    } else if (i5) break; else {
     i27 = 39;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 20) {
    i27 = 0;
    if (i5) {
     i4 = 0;
     i27 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i10 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i2 + i5;
   }
   i5 = i9 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i9 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i1, i15, i11, i2, i16, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    } else {
     i4 = i9;
     continue;
    }
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    i4 = i9;
    continue;
   }
  }
  if ((i27 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 39) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i1 = HEAP32[i19 >> 2] | 0;
    if ((i1 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   d3 = +invoke_diii(fb + 3 | 0, i2 | 0, HEAP32[i16 >> 2] | 0, i24 | 0);
   i28 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i28 & 1)) {
    HEAPF64[i20 >> 3] = d3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i9) i2 = 1; else {
     i1 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i27 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i23 >> 2] = 0;
      i27 = 55;
      break;
     } else if (i2) break; else {
      i27 = 57;
      break;
     }
    } while (0);
    if ((i27 | 0) == 55) if (i2) i27 = 57;
    if ((i27 | 0) == 57) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 208 | 0;
 i13 = i21 + 200 | 0;
 i14 = i21 + 196 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 337 | 0;
 i11 = i21 + 336 | 0;
 __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i2;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i7 = i25 + 4 | 0;
  i8 = i25 + 8 | 0;
  i4 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i4) {
    i9 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i9 = __THREW__;
     __THREW__ = 0;
     if (i9 & 1) {
      i27 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i9 = 0;
     i5 = 1;
    } else {
     i9 = i4;
     i5 = 0;
    }
   }
   i4 = HEAP32[i23 >> 2] | 0;
   do if (!i4) i27 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i27 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 20;
     break;
    } else if (i5) break; else {
     i27 = 39;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 20) {
    i27 = 0;
    if (i5) {
     i4 = 0;
     i27 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i10 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i27 = 31;
     break;
    }
    i2 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i2 + i5;
   }
   i5 = i9 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i9 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i1, i15, i11, i2, i16, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 29;
     break;
    } else {
     i4 = i9;
     continue;
    }
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    i4 = i9;
    continue;
   }
  }
  if ((i27 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 39) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i1 = HEAP32[i19 >> 2] | 0;
    if ((i1 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   d3 = +invoke_diii(fb + 4 | 0, i2 | 0, HEAP32[i16 >> 2] | 0, i24 | 0);
   i28 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i28 & 1)) {
    HEAPF64[i20 >> 3] = d3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i9) i2 = 1; else {
     i1 = HEAP32[i9 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i27 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i23 >> 2] = 0;
      i27 = 55;
      break;
     } else if (i2) break; else {
      i27 = 57;
      break;
     }
    } while (0);
    if ((i27 | 0) == 55) if (i2) i27 = 57;
    if ((i27 | 0) == 57) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5physx16PxsIslandManager43computeChangeToNumEdgeReferencesToKinematicEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 8 | 0;
 i8 = i20;
 i17 = HEAP32[i15 + 16 >> 2] | 0;
 i18 = HEAP32[i15 + 284 >> 2] | 0;
 i9 = HEAP32[i15 + 268 >> 2] | 0;
 i4 = HEAP32[i15 + 360 >> 2] | 0;
 i5 = HEAP32[i15 + 356 >> 2] | 0;
 if (!i4) i2 = 0; else {
  i6 = 0;
  i2 = 0;
  do {
   i1 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
   if (!(HEAP32[i18 + (i1 * 12 | 0) + 8 >> 2] & 8)) {
    i3 = HEAP32[i18 + (i1 * 12 | 0) >> 2] | 0;
    i1 = HEAP32[i18 + (i1 * 12 | 0) + 4 >> 2] | 0;
    if ((i3 | 0) != -1) i2 = (HEAP8[i17 + (i3 * 12 | 0) + 8 >> 0] & 1) + i2 | 0;
    if ((i1 | 0) != -1) i2 = (HEAP8[i17 + (i1 * 12 | 0) + 8 >> 0] & 1) + i2 | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i4 | 0));
 }
 i16 = HEAP32[i15 + 628 >> 2] | 0;
 if (!i16) {
  i18 = i2;
  i19 = 0;
  i19 = i18 - i19 | 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i10 = i19 + 4 | 0;
 i4 = (HEAP32[i15 + 384 >> 2] | 0) >>> 5;
 _memset(i16 | 0, 0, (i4 << 2) + 15 & 1073741808 | 0) | 0;
 HEAP32[i19 >> 2] = i16;
 HEAP32[i10 >> 2] = i4 | -2147483648;
 i4 = HEAP32[i15 + 352 >> 2] | 0;
 i5 = HEAP32[i15 + 348 >> 2] | 0;
 if (i4 | 0) {
  i6 = 0;
  do {
   i3 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
   i1 = HEAP32[i18 + (i3 * 12 | 0) >> 2] | 0;
   i3 = HEAP32[i18 + (i3 * 12 | 0) + 4 >> 2] | 0;
   if ((i1 | 0) != -1) if (HEAP8[i17 + (i1 * 12 | 0) + 8 >> 0] & 1) if (!(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) {
    i1 = HEAP32[i17 + (i1 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i14 = i16 + (i1 >>> 5 << 2) | 0;
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i1 & 31);
    }
   }
   if ((i3 | 0) != -1) if (HEAP8[i17 + (i3 * 12 | 0) + 8 >> 0] & 1) if (!(HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
    i1 = HEAP32[i17 + (i3 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i14 = i16 + (i1 >>> 5 << 2) | 0;
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i1 & 31);
    }
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i15 + 344 >> 2] | 0;
 i5 = HEAP32[i15 + 340 >> 2] | 0;
 if (!i4) i1 = i9; else {
  i6 = i8 + 4 | 0;
  i7 = 0;
  do {
   i1 = HEAP32[i5 + (i7 << 2) >> 2] | 0;
   if ((HEAP32[i18 + (i1 * 12 | 0) + 8 >> 2] & 6 | 0) == 2) {
    i3 = HEAP32[i18 + (i1 * 12 | 0) >> 2] | 0;
    HEAP32[i8 >> 2] = i3;
    i1 = HEAP32[i18 + (i1 * 12 | 0) + 4 >> 2] | 0;
    HEAP32[i6 >> 2] = i1;
    if ((i3 | 0) != -1) if (HEAP8[i17 + (i3 * 12 | 0) + 8 >> 0] & 1) if (!(HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
     i14 = HEAP32[i17 + (i3 * 12 | 0) + 4 >> 2] | 0;
     i1 = i16 + (i14 >>> 5 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i14 & 31);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) != -1) if (HEAP8[i17 + (i1 * 12 | 0) + 8 >> 0] & 1) if (!(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) {
     i13 = HEAP32[i17 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i14 = i16 + (i13 >>> 5 << 2) | 0;
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i13 & 31);
    }
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i4 | 0));
  i1 = i9;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i9 + 4 >> 2] & 2147483647;
 while (1) {
  i4 = i1 + -1 | 0;
  if (!i1) {
   i5 = 0;
   i14 = i3;
   break;
  }
  i1 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
  if (!i1) i1 = i4; else {
   i11 = 29;
   break;
  }
 }
 if ((i11 | 0) == 29) {
  i5 = i1 >>> 1 | i1;
  i5 = i5 >>> 2 | i5;
  i5 = i5 >>> 4 | i5;
  i5 = i5 >>> 8 | i5;
  i5 = (Math_imul(i5 >>> 16 | i5, 130329821) | 0) >>> 27;
  i5 = ((HEAP32[gb + 85120 + (i5 << 2) >> 2] | 0) + (i4 << 5) | 0) >>> 5;
  i14 = i3;
 }
 i4 = 0;
 while (1) {
  i1 = HEAP32[i14 + (i4 << 2) >> 2] | 0;
  if (i1 | 0) {
   i3 = i4 << 5;
   do {
    i12 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i12 = HEAP32[i17 + ((HEAP32[gb + 90668 + (i12 << 2) >> 2] | i3) * 12 | 0) + 4 >> 2] | 0;
    i13 = i16 + (i12 >>> 5 << 2) | 0;
    HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1 << (i12 & 31);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  if ((i4 | 0) == (i5 | 0)) break; else i4 = i4 + 1 | 0;
 }
 i13 = HEAP32[i10 >> 2] | 0;
 i3 = i13 & 2147483647;
 while (1) {
  i1 = i3 + -1 | 0;
  if (!i3) {
   i12 = 0;
   break;
  }
  i3 = HEAP32[i16 + (i1 << 2) >> 2] | 0;
  if (!i3) i3 = i1; else {
   i11 = 38;
   break;
  }
 }
 if ((i11 | 0) == 38) {
  i12 = i3 >>> 1 | i3;
  i12 = i12 >>> 2 | i12;
  i12 = i12 >>> 4 | i12;
  i12 = i12 >>> 8 | i12;
  i12 = (Math_imul(i12 >>> 16 | i12, 130329821) | 0) >>> 27;
  i12 = ((HEAP32[gb + 85120 + (i12 << 2) >> 2] | 0) + (i1 << 5) | 0) >>> 5;
 }
 i11 = HEAP32[i15 + 376 >> 2] | 0;
 i10 = HEAP32[i15 + 304 >> 2] | 0;
 i1 = 0;
 i9 = 0;
 while (1) {
  i3 = HEAP32[i16 + (i9 << 2) >> 2] | 0;
  if (i3) {
   i8 = i9 << 5;
   do {
    i4 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
    i4 = HEAP32[i11 + ((HEAP32[gb + 90668 + (i4 << 2) >> 2] | i8) << 4) + 4 >> 2] | 0;
    if ((i4 | 0) != -1) do {
     i5 = HEAP32[i18 + (i4 * 12 | 0) >> 2] | 0;
     i7 = HEAP32[i18 + (i4 * 12 | 0) + 4 >> 2] | 0;
     i6 = (i5 | 0) == -1;
     do if ((HEAP32[i18 + (i4 * 12 | 0) + 8 >> 2] & 10 | 0) == 2) {
      do if (!i6) if (HEAP32[i14 + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31)) if (!(HEAP8[i17 + (i5 * 12 | 0) + 8 >> 0] & 1)) {
       i1 = i1 + 1 | 0;
       break;
      } else {
       i2 = i2 + 1 | 0;
       break;
      } while (0);
      if ((i7 | 0) != -1) if (HEAP32[i14 + (i7 >>> 5 << 2) >> 2] & 1 << (i7 & 31)) if (!(HEAP8[i17 + (i7 * 12 | 0) + 8 >> 0] & 1)) {
       i1 = i1 + 1 | 0;
       break;
      } else {
       i2 = i2 + 1 | 0;
       break;
      }
     } else {
      if (!i6) {
       i6 = (HEAP8[i17 + (i5 * 12 | 0) + 8 >> 0] & 1) == 0;
       i15 = HEAP32[i14 + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31);
       i1 = (((i15 | 0) == 0 & (i6 ^ 1) | i6 & (i15 | 0) != 0) & 1) + i1 | 0;
      }
      if ((i7 | 0) != -1) {
       i6 = (HEAP8[i17 + (i7 * 12 | 0) + 8 >> 0] & 1) == 0;
       i15 = HEAP32[i14 + (i7 >>> 5 << 2) >> 2] & 1 << (i7 & 31);
       i1 = (((i15 | 0) == 0 & (i6 ^ 1) | i6 & (i15 | 0) != 0) & 1) + i1 | 0;
      }
     } while (0);
     i4 = HEAP32[i10 + (i4 << 2) >> 2] | 0;
    } while ((i4 | 0) != -1);
    i3 = i3 + -1 & i3;
   } while ((i3 | 0) != 0);
  }
  if ((i9 | 0) == (i12 | 0)) break; else i9 = i9 + 1 | 0;
 }
 if (!((i16 | 0) != 0 & (i13 | 0) > -1)) {
  i18 = i2;
  i19 = i1;
  i19 = i18 - i19 | 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i19 + 8 | 0, i16);
 i18 = i2;
 i19 = i1;
 i19 = i18 - i19 | 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_(i14, i15, i13, i6, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 24 | 0;
 i16 = i19;
 i17 = __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i14, i15, i13, i1) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i10 = i13 + 4 | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i16 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i8 = i16 + 16 | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i13 + 8 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i2 >> 2 << 2);
  }
 }
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 if ((i13 | 0) != (i6 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0);
 HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
 if ((i16 | 0) == (i6 | 0)) i1 = i6 + 4 | 0; else {
  i1 = i16 + 4 | 0;
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i6 + 4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i12 = HEAP32[i8 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17 + 1 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i12 = i15 + 4 | 0;
 i1 = HEAP32[i15 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i16 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i7 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i11 = i15 + 8 | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i2 >> 2 << 2);
  }
 }
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 if ((i15 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, HEAP32[i13 + 4 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
 i1 = i16 + 4 | 0;
 if ((i16 | 0) != (i13 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i13 = HEAP32[i7 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i15 >> 2] | 0) >= (i1 | 0)) {
  i18 = i17 + 2 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i4 = i16 + 4 | 0;
 i7 = i14 + 4 | 0;
 i1 = HEAP32[i14 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i16 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 i9 = i16 + 16 | 0;
 HEAP32[i9 >> 2] = i1;
 i6 = i14 + 8 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i5 = i2 >> 2;
 if (i5 | 0) {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i3 + (i5 << 2);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
  }
 }
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 if ((i14 | 0) != (i15 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, HEAP32[i15 + 4 >> 2] | 0, HEAP32[i11 >> 2] | 0);
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 i1 = i16 + 4 | 0;
 if ((i16 | 0) != (i15 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i16 = HEAP32[i9 >> 2] | 0;
  HEAP32[i18 >> 2] = 51;
  HEAP32[i18 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 }
 i18 = i17 + 3 | 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i29, i28, i30, i31, i32, i33) {
 i29 = i29 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f34 = f0, f35 = f0;
 HEAP32[i33 >> 2] = 3;
 f1 = Math_fround(HEAPF32[i30 >> 2]);
 i13 = i30 + 4 | 0;
 f5 = Math_fround(HEAPF32[i13 >> 2]);
 i22 = i30 + 8 | 0;
 f9 = Math_fround(HEAPF32[i22 >> 2]);
 f10 = Math_fround(HEAPF32[i28 >> 2]);
 i23 = i28 + 4 | 0;
 f11 = Math_fround(HEAPF32[i23 >> 2]);
 i27 = i28 + 8 | 0;
 f12 = Math_fround(HEAPF32[i27 >> 2]);
 f14 = Math_fround(f1 - f10);
 f15 = Math_fround(f5 - f11);
 f16 = Math_fround(f9 - f12);
 f2 = Math_fround(HEAPF32[i31 >> 2]);
 i17 = i31 + 4 | 0;
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i31 + 8 | 0;
 f4 = Math_fround(HEAPF32[i18 >> 2]);
 f19 = Math_fround(f2 - f10);
 f20 = Math_fround(f3 - f11);
 f21 = Math_fround(f4 - f12);
 f6 = Math_fround(Math_fround(f15 * f21) - Math_fround(f16 * f20));
 f7 = Math_fround(Math_fround(f16 * f19) - Math_fround(f14 * f21));
 f8 = Math_fround(Math_fround(f14 * f20) - Math_fround(f15 * f19));
 f24 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f3) - Math_fround(f5 * f2)) * f8) + Math_fround(Math_fround(Math_fround(Math_fround(f5 * f4) - Math_fround(f9 * f3)) * f6) + Math_fround(Math_fround(Math_fround(f9 * f2) - Math_fround(f1 * f4)) * f7)));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f2) - Math_fround(f10 * f3)) * f8) + Math_fround(Math_fround(Math_fround(Math_fround(f12 * f3) - Math_fround(f11 * f4)) * f6) + Math_fround(Math_fround(Math_fround(f10 * f4) - Math_fround(f12 * f2)) * f7)));
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f10) - Math_fround(f1 * f11)) * f8) + Math_fround(Math_fround(Math_fround(Math_fround(f9 * f11) - Math_fround(f5 * f12)) * f6) + Math_fround(Math_fround(Math_fround(f1 * f12) - Math_fround(f9 * f10)) * f7)));
 if (f24 >= Math_fround(0.0) & (f25 >= Math_fround(0.0) & f26 >= Math_fround(0.0))) {
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f10) + Math_fround(f7 * f11)) + Math_fround(f8 * f12)) / Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))));
  f25 = Math_fround(f7 * f24);
  f26 = Math_fround(f8 * f24);
  HEAPF32[i29 >> 2] = Math_fround(f6 * f24);
  HEAPF32[i29 + 4 >> 2] = f25;
  HEAPF32[i29 + 8 >> 2] = f26;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 f35 = Math_fround(-f10);
 f34 = Math_fround(-f11);
 f10 = Math_fround(-f12);
 f11 = Math_fround(-f1);
 f12 = Math_fround(-f5);
 f5 = Math_fround(-f9);
 f8 = Math_fround(-f2);
 f7 = Math_fround(-f3);
 f6 = Math_fround(-f4);
 f1 = Math_fround(Math_fround(Math_fround(f14 * f35) + Math_fround(f15 * f34)) + Math_fround(f16 * f10));
 f2 = Math_fround(Math_fround(Math_fround(f19 * f35) + Math_fround(f20 * f34)) + Math_fround(f21 * f10));
 f3 = Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f15 * f12)) + Math_fround(f16 * f5));
 f4 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f20 * f12)) + Math_fround(f21 * f5));
 f5 = Math_fround(Math_fround(Math_fround(f14 * f8) + Math_fround(f15 * f7)) + Math_fround(f16 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f19 * f8) + Math_fround(f20 * f7)) + Math_fround(f21 * f6));
 f7 = Math_fround(f4 - f3);
 f8 = Math_fround(f5 - f6);
 HEAP32[i33 >> 2] = 2;
 if (f26 <= Math_fround(0.0) & (f1 >= Math_fround(0.0) & f3 <= Math_fround(0.0))) {
  f26 = Math_fround(f1 - f3);
  i33 = Math_fround(Math_abs(Math_fround(f26))) > Math_fround(1.1920929e-07);
  f26 = Math_fround(Math_fround(1.0) / f26);
  f26 = Math_fround(f1 * (i33 ? f26 : Math_fround(0.0)));
  f25 = Math_fround(HEAPF32[i28 >> 2]);
  f34 = Math_fround(HEAPF32[i23 >> 2]);
  f34 = Math_fround(f34 + Math_fround(f15 * f26));
  f35 = Math_fround(Math_fround(f16 * f26) + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i29 >> 2] = Math_fround(f25 + Math_fround(f14 * f26));
  HEAPF32[i29 + 4 >> 2] = f34;
  HEAPF32[i29 + 8 >> 2] = f35;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 if (f24 <= Math_fround(0.0) & (f4 >= f3 & f5 >= f6)) {
  f24 = Math_fround(HEAPF32[i31 >> 2]);
  f20 = Math_fround(HEAPF32[i17 >> 2]);
  f21 = Math_fround(HEAPF32[i18 >> 2]);
  f26 = Math_fround(HEAPF32[i30 >> 2]);
  f34 = Math_fround(HEAPF32[i13 >> 2]);
  f35 = Math_fround(HEAPF32[i22 >> 2]);
  f24 = Math_fround(f24 - f26);
  f20 = Math_fround(f20 - f34);
  f21 = Math_fround(f21 - f35);
  f25 = Math_fround(f7 + f8);
  i33 = Math_fround(Math_abs(Math_fround(f25))) > Math_fround(1.1920929e-07);
  f25 = Math_fround(Math_fround(1.0) / f25);
  f25 = Math_fround(f7 * (i33 ? f25 : Math_fround(0.0)));
  i33 = i32 + 4 | 0;
  HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i33 >> 2] = HEAP32[i32 + 8 >> 2];
  f34 = Math_fround(Math_fround(f20 * f25) + f34);
  f35 = Math_fround(Math_fround(f21 * f25) + f35);
  HEAPF32[i29 >> 2] = Math_fround(Math_fround(f24 * f25) + f26);
  HEAPF32[i29 + 4 >> 2] = f34;
  HEAPF32[i29 + 8 >> 2] = f35;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 if (f25 <= Math_fround(0.0) & (f2 >= Math_fround(0.0) & f6 <= Math_fround(0.0))) {
  f26 = Math_fround(f2 - f6);
  i33 = Math_fround(Math_abs(Math_fround(f26))) > Math_fround(1.1920929e-07);
  f26 = Math_fround(Math_fround(1.0) / f26);
  f26 = Math_fround(f2 * (i33 ? f26 : Math_fround(0.0)));
  HEAP32[i32 + 4 >> 2] = HEAP32[i32 + 8 >> 2];
  f25 = Math_fround(HEAPF32[i28 >> 2]);
  f34 = Math_fround(HEAPF32[i23 >> 2]);
  f34 = Math_fround(Math_fround(f20 * f26) + f34);
  f35 = Math_fround(Math_fround(f21 * f26) + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i29 >> 2] = Math_fround(f25 + Math_fround(f19 * f26));
  HEAPF32[i29 + 4 >> 2] = f34;
  HEAPF32[i29 + 8 >> 2] = f35;
  HEAPF32[i29 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 HEAP32[i33 >> 2] = 1;
 if (f1 <= Math_fround(0.0) & f2 <= Math_fround(0.0)) {
  HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
  return;
 }
 if (f3 >= Math_fround(0.0) & f3 >= f4) {
  HEAP32[i32 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
  return;
 } else {
  HEAP32[i32 >> 2] = HEAP32[i32 + 8 >> 2];
  HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  HEAP32[i29 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
  return;
 }
}

function __Z43TransformVerticesStridedSeparatePointersREFRPhRK10Matrix4x4fj14StrideIteratorI8Vector3fES6_S4_I11ColorRGBA32ES4_I8Vector2fESA_S4_I8Vector4fE(i14, i15, i1, i27, i35, i36, i37, i38, i39) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f40 = f0, i41 = 0, i42 = 0, i43 = 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 i13 = i15 + 4 | 0;
 f17 = Math_fround(HEAPF32[i13 >> 2]);
 i6 = i15 + 8 | 0;
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i15 + 16 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i15 + 20 | 0;
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i15 + 24 | 0;
 f21 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i15 + 32 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i15 + 36 | 0;
 f23 = Math_fround(HEAPF32[i11 >> 2]);
 i12 = i15 + 40 | 0;
 f40 = Math_fround(HEAPF32[i12 >> 2]);
 f24 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
 i34 = f24 > Math_fround(9.99999997e-07);
 f24 = Math_fround(Math_fround(1.0) / f24);
 f24 = i34 ? f24 : Math_fround(1.0);
 f16 = Math_fround(f2 * f24);
 f17 = Math_fround(f17 * f24);
 f18 = Math_fround(f18 * f24);
 f19 = Math_fround(f4 * f24);
 f20 = Math_fround(f20 * f24);
 f21 = Math_fround(f21 * f24);
 f22 = Math_fround(f3 * f24);
 f23 = Math_fround(f23 * f24);
 f24 = Math_fround(f40 * f24);
 if (!i1) return;
 i25 = i15 + 48 | 0;
 i26 = i15 + 52 | 0;
 i28 = i15 + 56 | 0;
 i29 = i27 + 4 | 0;
 i30 = i39 + 4 | 0;
 i31 = i38 + 4 | 0;
 i32 = i37 + 4 | 0;
 i33 = i36 + 4 | 0;
 i34 = i35 + 4 | 0;
 while (1) {
  i5 = i1 + -1 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i42 = HEAP32[i27 >> 2] | 0;
  f40 = Math_fround(f2 * Math_fround(HEAPF32[i42 >> 2]));
  i41 = i42 + 4 | 0;
  f2 = Math_fround(HEAPF32[i41 >> 2]);
  f4 = Math_fround(f40 + Math_fround(f4 * f2));
  f40 = Math_fround(HEAPF32[i42 + 8 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f3 * f40));
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f4);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f3 = Math_fround(HEAPF32[i42 >> 2]);
  f4 = Math_fround(f4 * f3);
  f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i8 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f40 * Math_fround(HEAPF32[i11 >> 2])));
  HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i26 >> 2]) + f4);
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]));
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i41 >> 2])));
  f40 = Math_fround(f4 + Math_fround(f40 * Math_fround(HEAPF32[i12 >> 2])));
  HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f40);
  HEAP32[i14 >> 2] = i1 + 12;
  HEAP32[i27 >> 2] = (HEAP32[i27 >> 2] | 0) + (HEAP32[i29 >> 2] | 0);
  i1 = HEAP32[i35 >> 2] | 0;
  if (i1 | 0) {
   i42 = HEAP32[i14 >> 2] | 0;
   f40 = Math_fround(f16 * Math_fround(HEAPF32[i1 >> 2]));
   i41 = i1 + 4 | 0;
   f3 = Math_fround(HEAPF32[i41 >> 2]);
   f40 = Math_fround(f40 + Math_fround(f19 * f3));
   f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   HEAPF32[i42 >> 2] = Math_fround(f40 + Math_fround(f22 * f4));
   f40 = Math_fround(HEAPF32[i1 >> 2]);
   HEAPF32[i42 + 4 >> 2] = Math_fround(Math_fround(f23 * f4) + Math_fround(Math_fround(f20 * f3) + Math_fround(f17 * f40)));
   f40 = Math_fround(f18 * f40);
   HEAPF32[i42 + 8 >> 2] = Math_fround(Math_fround(f24 * f4) + Math_fround(f40 + Math_fround(f21 * Math_fround(HEAPF32[i41 >> 2]))));
   HEAP32[i14 >> 2] = i42 + 12;
   HEAP32[i35 >> 2] = (HEAP32[i35 >> 2] | 0) + (HEAP32[i34 >> 2] | 0);
  }
  i1 = HEAP32[i36 >> 2] | 0;
  if (i1 | 0) {
   i42 = HEAP32[i14 >> 2] | 0;
   i41 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   HEAP8[i42 >> 0] = i41;
   HEAP8[i42 + 1 >> 0] = i41 >> 8;
   HEAP8[i42 + 2 >> 0] = i41 >> 16;
   HEAP8[i42 + 3 >> 0] = i41 >> 24;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 4;
   HEAP32[i36 >> 2] = (HEAP32[i36 >> 2] | 0) + (HEAP32[i33 >> 2] | 0);
  }
  i1 = HEAP32[i37 >> 2] | 0;
  if (i1 | 0) {
   i41 = i1;
   i43 = i41;
   i43 = HEAPU8[i43 >> 0] | HEAPU8[i43 + 1 >> 0] << 8 | HEAPU8[i43 + 2 >> 0] << 16 | HEAPU8[i43 + 3 >> 0] << 24;
   i41 = i41 + 4 | 0;
   i41 = HEAPU8[i41 >> 0] | HEAPU8[i41 + 1 >> 0] << 8 | HEAPU8[i41 + 2 >> 0] << 16 | HEAPU8[i41 + 3 >> 0] << 24;
   i42 = HEAP32[i14 >> 2] | 0;
   i1 = i42;
   HEAP8[i1 >> 0] = i43;
   HEAP8[i1 + 1 >> 0] = i43 >> 8;
   HEAP8[i1 + 2 >> 0] = i43 >> 16;
   HEAP8[i1 + 3 >> 0] = i43 >> 24;
   i42 = i42 + 4 | 0;
   HEAP8[i42 >> 0] = i41;
   HEAP8[i42 + 1 >> 0] = i41 >> 8;
   HEAP8[i42 + 2 >> 0] = i41 >> 16;
   HEAP8[i42 + 3 >> 0] = i41 >> 24;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 8;
   HEAP32[i37 >> 2] = (HEAP32[i37 >> 2] | 0) + (HEAP32[i32 >> 2] | 0);
  }
  i1 = HEAP32[i38 >> 2] | 0;
  if (i1 | 0) {
   i42 = i1;
   i1 = i42;
   i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   i42 = i42 + 4 | 0;
   i42 = HEAPU8[i42 >> 0] | HEAPU8[i42 + 1 >> 0] << 8 | HEAPU8[i42 + 2 >> 0] << 16 | HEAPU8[i42 + 3 >> 0] << 24;
   i43 = HEAP32[i14 >> 2] | 0;
   i41 = i43;
   HEAP8[i41 >> 0] = i1;
   HEAP8[i41 + 1 >> 0] = i1 >> 8;
   HEAP8[i41 + 2 >> 0] = i1 >> 16;
   HEAP8[i41 + 3 >> 0] = i1 >> 24;
   i43 = i43 + 4 | 0;
   HEAP8[i43 >> 0] = i42;
   HEAP8[i43 + 1 >> 0] = i42 >> 8;
   HEAP8[i43 + 2 >> 0] = i42 >> 16;
   HEAP8[i43 + 3 >> 0] = i42 >> 24;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 8;
   HEAP32[i38 >> 2] = (HEAP32[i38 >> 2] | 0) + (HEAP32[i31 >> 2] | 0);
  }
  i1 = HEAP32[i39 >> 2] | 0;
  if (i1 | 0) {
   i43 = HEAP32[i14 >> 2] | 0;
   f40 = Math_fround(f16 * Math_fround(HEAPF32[i1 >> 2]));
   i42 = i1 + 4 | 0;
   f3 = Math_fround(HEAPF32[i42 >> 2]);
   f40 = Math_fround(f40 + Math_fround(f19 * f3));
   f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   HEAPF32[i43 >> 2] = Math_fround(f40 + Math_fround(f22 * f4));
   f40 = Math_fround(HEAPF32[i1 >> 2]);
   HEAPF32[i43 + 4 >> 2] = Math_fround(Math_fround(f23 * f4) + Math_fround(Math_fround(f20 * f3) + Math_fround(f17 * f40)));
   f40 = Math_fround(f18 * f40);
   HEAPF32[i43 + 8 >> 2] = Math_fround(Math_fround(f24 * f4) + Math_fround(f40 + Math_fround(f21 * Math_fround(HEAPF32[i42 >> 2]))));
   HEAP32[i43 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 >> 2] = i43 + 16;
   HEAP32[i39 >> 2] = (HEAP32[i39 >> 2] | 0) + (HEAP32[i30 >> 2] | 0);
  }
  if (!i5) break;
  f2 = Math_fround(HEAPF32[i15 >> 2]);
  f4 = Math_fround(HEAPF32[i7 >> 2]);
  i1 = i5;
  f3 = Math_fround(HEAPF32[i10 >> 2]);
 }
 return;
}

function __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i15, i16, i1, i18, i13, i19, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i20;
 i4 = (i18 - i1 | 0) / 12 | 0;
 do if (i4 >>> 0 > 100) {
  i3 = _malloc(i4) | 0;
  if (!i3) {
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  }
  i2 = i3;
  i17 = i3;
  i6 = 6;
 } else {
  i17 = 0;
  i6 = 6;
 } while (0);
 if ((i6 | 0) == 6) {
  i6 = i1;
  i7 = i2;
  i3 = 0;
  while (1) {
   if ((i6 | 0) == (i18 | 0)) break;
   i5 = HEAP8[i6 + 11 >> 0] | 0;
   if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
   if (!i5) {
    HEAP8[i7 >> 0] = 2;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else HEAP8[i7 >> 0] = 1;
   i6 = i6 + 12 | 0;
   i7 = i7 + 1 | 0;
  }
  i12 = 0;
  i10 = i3;
  L21 : while (1) {
   i3 = HEAP32[i15 >> 2] | 0;
   do if (!i3) i3 = 0; else if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i3 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i6 = 39;
     break L21;
    }
    if ((i3 | 0) == -1) {
     HEAP32[i15 >> 2] = 0;
     i3 = 0;
     break;
    } else {
     i3 = HEAP32[i15 >> 2] | 0;
     break;
    }
   } while (0);
   i6 = (i3 | 0) == 0;
   i3 = HEAP32[i16 >> 2] | 0;
   if (!i3) i5 = 0; else if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i6 = 39;
     break;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i16 >> 2] = 0;
     i5 = 0;
    } else i5 = i3;
   } else i5 = i3;
   i7 = (i5 | 0) == 0;
   i3 = HEAP32[i15 >> 2] | 0;
   if (!((i4 | 0) != 0 & (i6 ^ i7))) {
    i6 = 28;
    break;
   }
   i5 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i3 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i6 = 39;
     break;
    }
   } else i3 = HEAPU8[i5 >> 0] | 0;
   i3 = i3 & 255;
   if (!i14) {
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i3 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i6 = 45;
     break;
    }
   }
   i11 = i12 + 1 | 0;
   i8 = i1;
   i7 = 0;
   i9 = i2;
   while (1) {
    if ((i8 | 0) == (i18 | 0)) break;
    do if ((HEAP8[i9 >> 0] | 0) == 1) {
     i6 = i8 + 11 | 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
     i5 = HEAP8[i5 + i12 >> 0] | 0;
     if (!i14) {
      __THREW__ = 0;
      i5 = invoke_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i6 = 55;
       break L21;
      }
     }
     if (i3 << 24 >> 24 != i5 << 24 >> 24) {
      HEAP8[i9 >> 0] = 0;
      i5 = i7;
      i6 = i10;
      i4 = i4 + -1 | 0;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i8 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) == (i11 | 0)) {
      HEAP8[i9 >> 0] = 2;
      i5 = 1;
      i6 = i10 + 1 | 0;
      i4 = i4 + -1 | 0;
     } else {
      i5 = 1;
      i6 = i10;
     }
    } else {
     i5 = i7;
     i6 = i10;
    } while (0);
    i8 = i8 + 12 | 0;
    i7 = i5;
    i9 = i9 + 1 | 0;
    i10 = i6;
   }
   if (!i7) {
    i12 = i11;
    continue;
   }
   i3 = HEAP32[i15 >> 2] | 0;
   i5 = i3 + 12 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (i21 & 1) {
     i6 = 69;
     break;
    }
   } else HEAP32[i5 >> 2] = i6 + 1;
   if ((i10 + i4 | 0) >>> 0 > 1) {
    i6 = i1;
    i7 = i2;
    i3 = i10;
   } else {
    i12 = i11;
    continue;
   }
   while (1) {
    if ((i6 | 0) == (i18 | 0)) {
     i12 = i11;
     i10 = i3;
     continue L21;
    }
    if ((HEAP8[i7 >> 0] | 0) == 2) {
     i5 = HEAP8[i6 + 11 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) != (i11 | 0)) {
      HEAP8[i7 >> 0] = 0;
      i3 = i3 + -1 | 0;
     }
    }
    i6 = i6 + 12 | 0;
    i7 = i7 + 1 | 0;
   }
  }
  if ((i6 | 0) == 28) {
   do if (!i3) {
    i3 = 0;
    i6 = 34;
   } else if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i3 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i21 = __THREW__;
    __THREW__ = 0;
    if (!(i21 & 1)) if ((i3 | 0) == -1) {
     HEAP32[i15 >> 2] = 0;
     i3 = 0;
     i6 = 34;
     break;
    } else {
     i3 = HEAP32[i15 >> 2] | 0;
     i6 = 34;
     break;
    }
   } else i6 = 34; while (0);
   L96 : do if ((i6 | 0) == 34) {
    i4 = (i3 | 0) == 0;
    do if (i7) i6 = 78; else {
     if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i3 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) break L96;
      if ((i3 | 0) == -1) {
       HEAP32[i16 >> 2] = 0;
       i6 = 78;
       break;
      }
     }
     if (!i4) i6 = 79;
    } while (0);
    if ((i6 | 0) == 78) if (i4) i6 = 79;
    if ((i6 | 0) == 79) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
    while (1) {
     if ((i1 | 0) == (i18 | 0)) {
      i6 = 84;
      break;
     }
     if ((HEAP8[i2 >> 0] | 0) == 2) break;
     i1 = i1 + 12 | 0;
     i2 = i2 + 1 | 0;
    }
    if ((i6 | 0) == 84) {
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 4;
     i1 = i18;
    }
    if (i17 | 0) _free(i17);
    STACKTOP = i20;
    return i1 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i6 | 0) == 39) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i6 | 0) == 45) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i6 | 0) == 55) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i6 | 0) == 69) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  if (i17) _free(i17);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __Z20AddActiveLocalLightsR11CullResultsPPK5LightPK8Vector4fRK9IndexListPfRS8_R12ActiveLightsP5RectTIfEP13TargetEyeMask(i11, i21, i24, i12, i25, i26, i32, i18, i19) {
 i11 = i11 | 0;
 i21 = i21 | 0;
 i24 = i24 | 0;
 i12 = i12 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i32 = i32 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i22 = 0, i23 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, f34 = f0, f35 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i33;
 i30 = i33 + 40 | 0;
 i22 = i33 + 8 | 0;
 if ((HEAP16[gb + 1111160 + 6 >> 1] | 0) > -1) {
  HEAP32[i30 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i30 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111160 | 0, i20);
  i31 = gb + 1111160 | 0;
 } else i31 = 0;
 i23 = HEAP32[i11 + 1308 >> 2] | 0;
 i1 = i23 + 528 | 0;
 HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f34 = Math_fround(f34 * Math_fround(HEAPF32[i23 + 516 >> 2]));
 f35 = Math_fround(HEAPF32[i23 + 532 >> 2]);
 f35 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i23 + 520 >> 2])));
 f34 = Math_fround(HEAPF32[i23 + 536 >> 2]);
 HEAPF32[i22 + 12 >> 2] = Math_fround(-Math_fround(f35 + Math_fround(f34 * Math_fround(HEAPF32[i23 + 524 >> 2]))));
 HEAP32[i22 + 16 >> 2] = HEAP32[i23 + 796 >> 2];
 f34 = Math_fround(HEAPF32[i23 + 780 >> 2]);
 HEAP8[i22 + 20 >> 0] = f34 > Math_fround(HEAPF32[i23 + 792 >> 2]) & 1;
 HEAP32[i22 + 24 >> 2] = HEAP32[i23 + 512 >> 2];
 i1 = HEAP32[i26 + 4 >> 2] | 0;
 i13 = (HEAP8[(HEAP32[i23 + 952 >> 2] | 0) + 818 >> 0] | 0) != 0;
 i14 = i13 ? 2 : 1;
 i15 = i20;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 i15 = i12 + 4 | 0;
 i27 = i32 + 12 | 0;
 i28 = i32 + 16 | 0;
 i29 = i32 + 4 | 0;
 i10 = 0;
 do {
  i16 = HEAP32[gb + 35296 + (i10 << 2) >> 2] | 0;
  i17 = i20 + (i10 << 2) | 0;
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i9 = 0;
   do {
    i7 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i9 << 2) >> 2] | 0;
    i8 = (HEAP32[i21 + (i7 << 2) >> 2] | 0) + 44 | 0;
    do if ((HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0) == (i16 | 0)) {
     if (!(HEAP32[i19 + (i7 << 2) >> 2] | 0)) {
      HEAPF32[i25 + (i1 << 2) >> 2] = Math_fround(1.0);
      HEAP32[(HEAP32[i26 >> 2] | 0) + (i1 << 2) >> 2] = i7;
      i1 = i1 + 1 | 0;
      break;
     }
     i3 = HEAP32[i27 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i28 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i28 >> 2] = i2;
       HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i2 * 180 | 0, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 180 | 0, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i32 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 180 | 0) | 0;
       HEAP32[i28 >> 2] = i2;
       HEAP32[i32 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i27 >> 2] = i4;
     i6 = (HEAP32[i32 >> 2] | 0) + (i3 * 180 | 0) | 0;
     i8 = HEAP32[i8 >> 2] | 0;
     i5 = i8 + 4 | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     HEAP32[i6 >> 2] = i8;
     __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight(i22, i23, i24 + (i7 << 4) | 0, i18 + ((Math_imul(i7, i14) | 0) << 4) | 0, i13, 1, Math_fround(1.0), i6);
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
    } while (0);
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) < (HEAP32[i15 >> 2] | 0));
  }
  i3 = __ZN15GlobalCallbacks3GetEv() | 0;
  i4 = i3 + 37824 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i2 = 0;
   do {
    i5 = i3 + 37056 + (i2 * 12 | 0) | 0;
    if (!(HEAP8[i3 + 37056 + (i2 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiiii(HEAP32[i5 >> 2] | 0, i22 | 0, i11 | 0, i32 | 0, i17 | 0, i16 | 0); else mftCall_viiiiii(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 37056 + (i2 * 12 | 0) + 4 >> 2] | 0, i22 | 0, i11 | 0, i32 | 0, i17 | 0, i16 | 0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 2);
 HEAP32[i32 + 28 >> 2] = HEAP32[i20 >> 2];
 i13 = i20 + 4 | 0;
 HEAP32[i32 + 32 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = 0;
 HEAP32[i30 + 20 >> 2] = 0;
 HEAP32[i30 + 24 >> 2] = 0;
 HEAP32[i30 + 28 >> 2] = 0;
 if ((i1 | 0) > 0) {
  i3 = 0;
  do {
   i5 = i20 + (i3 << 2) | 0;
   HEAP32[i5 >> 2] = 0;
   i6 = HEAP32[gb + 35296 + (i3 << 2) >> 2] | 0;
   i2 = 0;
   do {
    i7 = HEAP32[(HEAP32[i26 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i8 = (HEAP32[i21 + (i7 << 2) >> 2] | 0) + 44 | 0;
    if ((HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0) == (i6 | 0)) {
     i9 = HEAP32[i27 >> 2] | 0;
     i10 = i9 + 1 | 0;
     i11 = HEAP32[i28 >> 2] | 0;
     i12 = i11 & 2147483647;
     do if (i10 >>> 0 > i12 >>> 0) {
      i4 = i11 << 1;
      i4 = (i4 | 0) == 0 ? 1 : i4;
      if (i12 >>> 0 < i4 >>> 0) if ((i11 | 0) > -1) {
       HEAP32[i28 >> 2] = i4;
       HEAP32[i32 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i32 >> 2] | 0, i4 * 180 | 0, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 180 | 0, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i19 | 0, HEAP32[i32 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 180 | 0) | 0;
       HEAP32[i28 >> 2] = i4;
       HEAP32[i32 >> 2] = i19;
       break;
      }
     } while (0);
     HEAP32[i27 >> 2] = i10;
     i19 = (HEAP32[i32 >> 2] | 0) + (i9 * 180 | 0) | 0;
     i18 = HEAP32[i8 >> 2] | 0;
     i17 = i18 + 4 | 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     HEAP32[i19 >> 2] = i18;
     __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight(i22, i23, i24 + (i7 << 4) | 0, i30, 0, 0, Math_fround(HEAPF32[i25 + (i2 << 2) >> 2]), i19);
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != 2);
  i2 = HEAP32[i20 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i2 = i20;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
 }
 HEAP32[i32 + 36 >> 2] = i2;
 HEAP32[i32 + 40 >> 2] = i1;
 if (!i31) {
  STACKTOP = i33;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i31);
 STACKTOP = i33;
 return;
}

function __ZN11CullResultsD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1110632 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110632 | 0, i1);
  i6 = gb + 1110632 | 0;
 } else i6 = 0;
 if (HEAP32[i7 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i7);
 i1 = i7 + 1312 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i5 = i7 + 372 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = i7 + 360 | 0;
  i3 = 0;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 * 960 | 0) + 72 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    __Z21CompleteFenceInternalR8JobFence(i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = i7 + 1372 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i7 + 16 | 0;
 i1 = i7 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0, 0, gb + 64024 | 0);
 }
 i3 = i7 + 360 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i3 >> 2] | 0;
   i9 = i4 + (i1 * 960 | 0) + 4 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
   HEAP32[i9 >> 2] = 0;
   i9 = i4 + (i1 * 960 | 0) + 16 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
   HEAP32[i9 >> 2] = 0;
   i9 = i4 + (i1 * 960 | 0) + 28 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
   HEAP32[i9 >> 2] = 0;
   i9 = i4 + (i1 * 960 | 0) + 40 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
   HEAP32[i9 >> 2] = 0;
   i4 = i4 + (i1 * 960 | 0) + 52 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 64024 | 0);
   HEAP32[i4 >> 2] = 0;
   if (HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 960 | 0) + 944 >> 2] | 0) {
    i9 = __Z9GetIUmbrav() | 0;
    mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 960 | 0) + 944 >> 2] | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i2 >> 2] = 0;
 i9 = i7 + 28 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i9 >> 2] = 0;
 i9 = i7 + 40 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i9 >> 2] = 0;
 i9 = i7 + 52 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i9 >> 2] = 0;
 i9 = i7 + 64 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i9 >> 2] = 0;
 i9 = i7 + 1308 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i9 >> 2] = 0;
 if (i6 | 0) __Z12profiler_endP19ProfilerInformation(i6);
 i1 = i7 + 1340 | 0;
 if ((HEAP32[i7 + 1356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 1344 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 1320 | 0;
 if ((HEAP32[i7 + 1336 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 1324 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 1288 | 0;
 if ((HEAP32[i7 + 1304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 1292 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 1268 | 0;
 if ((HEAP32[i7 + 1284 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 1272 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 1248 | 0;
 if ((HEAP32[i7 + 1264 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 1252 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i7 + 376 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i7 + 364 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i7 + 312 | 0;
 i4 = i7 + 324 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 180 | 0) >> 2] | 0;
   i9 = i2 + 4 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   if (!(HEAP32[i9 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i7 + 328 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i7 + 316 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i7 + 292 | 0;
 if ((HEAP32[i7 + 308 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 296 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 272 | 0;
 if ((HEAP32[i7 + 288 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 276 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 252 | 0;
 if ((HEAP32[i7 + 268 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 256 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 232 | 0;
 if ((HEAP32[i7 + 248 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 236 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 212 | 0;
 if ((HEAP32[i7 + 228 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 216 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 192 | 0;
 if ((HEAP32[i7 + 208 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 196 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 172 | 0;
 if ((HEAP32[i7 + 188 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 176 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 152 | 0;
 if ((HEAP32[i7 + 168 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 156 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 132 | 0;
 if ((HEAP32[i7 + 148 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 136 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 112 | 0;
 if ((HEAP32[i7 + 128 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 116 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 92 | 0;
 if ((HEAP32[i7 + 108 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 96 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function runPostSets244() {
 HEAP32[gb + 13228 >> 2] = (HEAP32[gb + 13228 >> 2] | 0) + (gb + 1085663 | 0);
 HEAP32[gb + 13232 >> 2] = (HEAP32[gb + 13232 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 216448 >> 2] = (HEAP32[gb + 216448 >> 2] | 0) + (gb + 13240 | 0);
 HEAP32[gb + 216452 >> 2] = fb + 3224;
 HEAP32[gb + 216456 >> 2] = fb + 3232;
 HEAP32[gb + 216460 >> 2] = fb + 1413;
 HEAP32[gb + 13240 >> 2] = (HEAP32[gb + 13240 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13244 >> 2] = (HEAP32[gb + 13244 >> 2] | 0) + (gb + 1085682 | 0);
 HEAP32[gb + 13248 >> 2] = (HEAP32[gb + 13248 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 216468 >> 2] = (HEAP32[gb + 216468 >> 2] | 0) + (gb + 13256 | 0);
 HEAP32[gb + 216472 >> 2] = fb + 3017;
 HEAP32[gb + 216476 >> 2] = fb + 3233;
 HEAP32[gb + 216480 >> 2] = fb + 1552;
 HEAP32[gb + 13256 >> 2] = (HEAP32[gb + 13256 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13260 >> 2] = (HEAP32[gb + 13260 >> 2] | 0) + (gb + 1085716 | 0);
 HEAP32[gb + 13264 >> 2] = (HEAP32[gb + 13264 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216488 >> 2] = (HEAP32[gb + 216488 >> 2] | 0) + (gb + 13272 | 0);
 HEAP32[gb + 216492 >> 2] = fb + 3234;
 HEAP32[gb + 216496 >> 2] = fb + 3235;
 HEAP32[gb + 216500 >> 2] = fb + 1553;
 HEAP32[gb + 13272 >> 2] = (HEAP32[gb + 13272 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13276 >> 2] = (HEAP32[gb + 13276 >> 2] | 0) + (gb + 1085744 | 0);
 HEAP32[gb + 13280 >> 2] = (HEAP32[gb + 13280 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216508 >> 2] = (HEAP32[gb + 216508 >> 2] | 0) + (gb + 13024 | 0);
 HEAP32[gb + 216512 >> 2] = fb + 3236;
 HEAP32[gb + 216516 >> 2] = fb + 3237;
 HEAP32[gb + 13288 >> 2] = (HEAP32[gb + 13288 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13292 >> 2] = (HEAP32[gb + 13292 >> 2] | 0) + (gb + 1085795 | 0);
 HEAP32[gb + 13296 >> 2] = (HEAP32[gb + 13296 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 13304 >> 2] = (HEAP32[gb + 13304 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13308 >> 2] = (HEAP32[gb + 13308 >> 2] | 0) + (gb + 1085759 | 0);
 HEAP32[gb + 13312 >> 2] = (HEAP32[gb + 13312 >> 2] | 0) + (gb + 13288 | 0);
 HEAP32[gb + 216524 >> 2] = (HEAP32[gb + 216524 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 216528 >> 2] = fb + 3210;
 HEAP32[gb + 216532 >> 2] = fb + 3238;
 HEAP32[gb + 216536 >> 2] = fb + 3212;
 HEAP32[gb + 216540 >> 2] = fb + 3213;
 HEAP32[gb + 216544 >> 2] = fb + 1;
 HEAP32[gb + 216552 >> 2] = (HEAP32[gb + 216552 >> 2] | 0) + (gb + 13320 | 0);
 HEAP32[gb + 216556 >> 2] = fb + 3210;
 HEAP32[gb + 216560 >> 2] = fb + 3239;
 HEAP32[gb + 216564 >> 2] = fb + 3212;
 HEAP32[gb + 216568 >> 2] = fb + 3213;
 HEAP32[gb + 216572 >> 2] = fb + 325;
 HEAP32[gb + 13320 >> 2] = (HEAP32[gb + 13320 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13324 >> 2] = (HEAP32[gb + 13324 >> 2] | 0) + (gb + 1085829 | 0);
 HEAP32[gb + 13328 >> 2] = (HEAP32[gb + 13328 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 13336 >> 2] = (HEAP32[gb + 13336 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13340 >> 2] = (HEAP32[gb + 13340 >> 2] | 0) + (gb + 1085869 | 0);
 HEAP32[gb + 13344 >> 2] = (HEAP32[gb + 13344 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13348 >> 2] = (HEAP32[gb + 13348 >> 2] | 0) + (gb + 1085871 | 0);
 HEAP32[gb + 13356 >> 2] = (HEAP32[gb + 13356 >> 2] | 0) + (gb + 13336 | 0);
 HEAP32[gb + 216580 >> 2] = (HEAP32[gb + 216580 >> 2] | 0) + (gb + 13304 | 0);
 HEAP32[gb + 216584 >> 2] = fb + 3210;
 HEAP32[gb + 216588 >> 2] = fb + 3240;
 HEAP32[gb + 216592 >> 2] = fb + 3212;
 HEAP32[gb + 216596 >> 2] = fb + 3213;
 HEAP32[gb + 216600 >> 2] = fb + 326;
 HEAP32[gb + 13360 >> 2] = (HEAP32[gb + 13360 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13364 >> 2] = (HEAP32[gb + 13364 >> 2] | 0) + (gb + 1085874 | 0);
 HEAP32[gb + 13368 >> 2] = (HEAP32[gb + 13368 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13372 >> 2] = (HEAP32[gb + 13372 >> 2] | 0) + (gb + 1085877 | 0);
 HEAP32[gb + 13380 >> 2] = (HEAP32[gb + 13380 >> 2] | 0) + (gb + 13336 | 0);
 HEAP32[gb + 13384 >> 2] = (HEAP32[gb + 13384 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13388 >> 2] = (HEAP32[gb + 13388 >> 2] | 0) + (gb + 1085881 | 0);
 HEAP32[gb + 13396 >> 2] = (HEAP32[gb + 13396 >> 2] | 0) + (gb + 13360 | 0);
 HEAP32[gb + 13400 >> 2] = (HEAP32[gb + 13400 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13404 >> 2] = (HEAP32[gb + 13404 >> 2] | 0) + (gb + 1085885 | 0);
 HEAP32[gb + 13412 >> 2] = (HEAP32[gb + 13412 >> 2] | 0) + (gb + 13360 | 0);
 HEAP32[gb + 13416 >> 2] = (HEAP32[gb + 13416 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13420 >> 2] = (HEAP32[gb + 13420 >> 2] | 0) + (gb + 1085890 | 0);
 HEAP32[gb + 13424 >> 2] = (HEAP32[gb + 13424 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13428 >> 2] = (HEAP32[gb + 13428 >> 2] | 0) + (gb + 1085892 | 0);
 HEAP32[gb + 13436 >> 2] = (HEAP32[gb + 13436 >> 2] | 0) + (gb + 13416 | 0);
 HEAP32[gb + 13440 >> 2] = (HEAP32[gb + 13440 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13444 >> 2] = (HEAP32[gb + 13444 >> 2] | 0) + (gb + 1085895 | 0);
 HEAP32[gb + 13452 >> 2] = (HEAP32[gb + 13452 >> 2] | 0) + (gb + 13416 | 0);
 HEAP32[gb + 13456 >> 2] = (HEAP32[gb + 13456 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13460 >> 2] = (HEAP32[gb + 13460 >> 2] | 0) + (gb + 1085899 | 0);
 HEAP32[gb + 13464 >> 2] = (HEAP32[gb + 13464 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13468 >> 2] = (HEAP32[gb + 13468 >> 2] | 0) + (gb + 1085901 | 0);
 HEAP32[gb + 13476 >> 2] = (HEAP32[gb + 13476 >> 2] | 0) + (gb + 13456 | 0);
 HEAP32[gb + 13480 >> 2] = (HEAP32[gb + 13480 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13484 >> 2] = (HEAP32[gb + 13484 >> 2] | 0) + (gb + 1085904 | 0);
 HEAP32[gb + 13492 >> 2] = (HEAP32[gb + 13492 >> 2] | 0) + (gb + 13456 | 0);
 HEAP32[gb + 13496 >> 2] = (HEAP32[gb + 13496 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13500 >> 2] = (HEAP32[gb + 13500 >> 2] | 0) + (gb + 1085908 | 0);
 HEAP32[gb + 13504 >> 2] = (HEAP32[gb + 13504 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13508 >> 2] = (HEAP32[gb + 13508 >> 2] | 0) + (gb + 1085910 | 0);
 HEAP32[gb + 13516 >> 2] = (HEAP32[gb + 13516 >> 2] | 0) + (gb + 13496 | 0);
 HEAP32[gb + 13520 >> 2] = (HEAP32[gb + 13520 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13524 >> 2] = (HEAP32[gb + 13524 >> 2] | 0) + (gb + 1085913 | 0);
 HEAP32[gb + 13532 >> 2] = (HEAP32[gb + 13532 >> 2] | 0) + (gb + 13496 | 0);
 HEAP32[gb + 13536 >> 2] = (HEAP32[gb + 13536 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 13540 >> 2] = (HEAP32[gb + 13540 >> 2] | 0) + (gb + 1085917 | 0);
 HEAP32[gb + 13544 >> 2] = (HEAP32[gb + 13544 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13548 >> 2] = (HEAP32[gb + 13548 >> 2] | 0) + (gb + 1085919 | 0);
 HEAP32[gb + 13556 >> 2] = (HEAP32[gb + 13556 >> 2] | 0) + (gb + 13536 | 0);
 HEAP32[gb + 13560 >> 2] = (HEAP32[gb + 13560 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 13564 >> 2] = (HEAP32[gb + 13564 >> 2] | 0) + (gb + 1085922 | 0);
 runPostSets245();
}

function __Z48UnityAnalyticsHandler_CUSTOM_InternalTransactionP12Il2CppObjectP12Il2CppStringdS2_S2_S2_h(i1, i2, d10, i3, i4, i5, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d10 = +d10;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 152 | 0;
 i6 = i22 + 148 | 0;
 i7 = i22 + 144 | 0;
 i8 = i22 + 140 | 0;
 i9 = i22 + 136 | 0;
 i13 = i22 + 120 | 0;
 i14 = i22 + 104 | 0;
 i15 = i22 + 88 | 0;
 i16 = i22 + 72 | 0;
 i17 = i22 + 56 | 0;
 i18 = i22 + 40 | 0;
 i19 = i22 + 24 | 0;
 i20 = i22 + 12 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i6, i2);
 __ZN11ICallStringC2EP12Il2CppString(i7, i3);
 __ZN11ICallStringC2EP12Il2CppString(i8, i4);
 __ZN11ICallStringC2EP12Il2CppString(i9, i5);
 if (__ZNK11ICallString6IsNullEv(i6) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038856 | 0, i22);
 if (__ZNK11ICallString6IsNullEv(i7) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038874 | 0, i22 + 8 | 0);
 if (!i1) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i14, i6);
 i3 = HEAP8[i14 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
 i3 = i1 ? HEAP32[i14 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i12 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i13 + 11 >> 0] = i3;
  if (!i3) i1 = i13; else {
   i1 = i13;
   i12 = 12;
  }
 } else i12 = 10;
 if ((i12 | 0) == 10) {
  i6 = i3 + 16 & -16;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i3;
  i12 = 12;
 }
 if ((i12 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNK11ICallString6ToUTF8Ev(i16, i7);
 i3 = HEAP8[i16 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
 i3 = i1 ? HEAP32[i16 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i12 = 16;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i15 + 11 >> 0] = i3;
  if (!i3) i1 = i15; else {
   i1 = i15;
   i12 = 18;
  }
 } else i12 = 16;
 if ((i12 | 0) == 16) {
  i7 = i3 + 16 & -16;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i3;
  i12 = 18;
 }
 if ((i12 | 0) == 18) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNK11ICallString6ToUTF8Ev(i18, i8);
 i3 = HEAP8[i18 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i18 >> 2] | 0 : i18;
 i3 = i1 ? HEAP32[i18 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i17 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i17);
  i1 = HEAP32[i17 + 12 >> 2] | 0;
  i12 = 22;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i17 + 11 >> 0] = i3;
  if (!i3) i1 = i17; else {
   i1 = i17;
   i12 = 24;
  }
 } else i12 = 22;
 if ((i12 | 0) == 22) {
  i8 = i3 + 16 & -16;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i17 + 4 >> 2] = i3;
  i12 = 24;
 }
 if ((i12 | 0) == 24) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNK11ICallString6ToUTF8Ev(i20, i9);
 i4 = HEAP8[i20 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i20 >> 2] | 0 : i20;
 i4 = i1 ? HEAP32[i20 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i19);
  i1 = HEAP32[i19 + 12 >> 2] | 0;
  i12 = 28;
 } else if (i4 >>> 0 < 11) {
  i2 = i19 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i19; else {
   i1 = i19;
   i12 = 30;
  }
 } else i12 = 28;
 if ((i12 | 0) == 28) {
  i2 = i4 + 16 & -16;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i19 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i19 + 4 >> 2] = i4;
  i2 = i19 + 11 | 0;
  i12 = 30;
 }
 if ((i12 | 0) == 30) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_S2_S2_b(i5, i13, d10, i15, i17, i19, i11 << 24 >> 24 != 0) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i12 = HEAP32[i19 >> 2] | 0;
  i19 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i21);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 if ((HEAP8[i17 + 11 >> 0] | 0) < 0) {
  i20 = HEAP32[i17 >> 2] | 0;
  i19 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 if ((HEAP8[i15 + 11 >> 0] | 0) < 0) {
  i20 = HEAP32[i15 >> 2] | 0;
  i19 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 if ((HEAP8[i13 + 11 >> 0] | 0) < 0) {
  i20 = HEAP32[i13 >> 2] | 0;
  i19 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 66;
  HEAP32[i21 + 4 >> 2] = i19;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 i21 = i1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 switch (i2 | 0) {
 case 1:
  {
   i6 = __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_10StartEventEEEbRT_(i5, i6) | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 2:
  {
   i6 = __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_9StopEventEEEbRT_(i5, i6) | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 3:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = i4 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 660679 | 0, i6, HEAPU8[i1 >> 0] & 3);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i10 = HEAP32[i5 >> 2] | 0;
    i11 = i10 + 16 | 0;
    i8 = i11;
    i9 = i6;
    i1 = (HEAP8[i1 >> 0] & 3) == 3;
    i9 = _i64Add((i1 ? 0 : HEAP32[i8 >> 2] | 0) | 0, (i1 ? 0 : HEAP32[i8 + 4 >> 2] | 0) | 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0) | 0;
    i8 = getTempRet0() | 0;
    i1 = i11;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = i6;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = HEAP32[i5 + 12 >> 2] | 0;
    i11 = HEAP32[i10 + 8 >> 2] | 0;
    i12 = i10;
    i13 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i5 = HEAP8[i10 + 13 >> 0] | 0;
    i10 = HEAP8[i10 + 12 >> 0] | 0;
    i2 = i1 + 8192 | 0;
    i6 = i1 + (HEAP32[i2 >> 2] << 5) | 0;
    HEAP32[i6 >> 2] = HEAPU16[i4 + 2 >> 1] << 16 | 65281;
    i4 = i6 + 8 | 0;
    HEAP32[i4 >> 2] = i13;
    HEAP32[i4 + 4 >> 2] = i12;
    HEAP32[i6 + 16 >> 2] = i11;
    HEAP8[i6 + 20 >> 0] = i10;
    HEAP8[i6 + 21 >> 0] = i5;
    i6 = i6 + 24 | 0;
    HEAP32[i6 >> 2] = i9;
    HEAP32[i6 + 4 >> 2] = i8;
    i6 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
    HEAP32[i2 >> 2] = i6;
    if ((i6 | 0) == 256) {
     i13 = HEAP32[i1 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i1 | 0, 256);
     HEAP32[i2 >> 2] = 0;
    }
   }
   i13 = i3;
   STACKTOP = i7;
   return i13 | 0;
  }
 case 4:
  {
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = i3 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 660679 | 0, i6, HEAPU8[i1 >> 0] & 3);
   i4 = (HEAP8[i4 + 8 >> 0] | 0) == 0;
   if (i4) {
    i9 = HEAP32[i5 >> 2] | 0;
    i8 = i9 + 16 | 0;
    i12 = i8;
    i11 = i6;
    i1 = (HEAP8[i1 >> 0] & 3) == 3;
    i11 = _i64Add((i1 ? 0 : HEAP32[i12 >> 2] | 0) | 0, (i1 ? 0 : HEAP32[i12 + 4 >> 2] | 0) | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
    i12 = getTempRet0() | 0;
    i1 = i8;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = i6;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = HEAP32[i5 + 12 >> 2] | 0;
    i8 = HEAP32[i9 + 8 >> 2] | 0;
    i5 = i9;
    i14 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i10 = HEAP8[i9 + 13 >> 0] | 0;
    i9 = HEAP8[i9 + 12 >> 0] | 0;
    i2 = i1 + 8192 | 0;
    i13 = i1 + (HEAP32[i2 >> 2] << 5) | 0;
    HEAP32[i13 >> 2] = HEAPU16[i3 + 2 >> 1] << 16 | 65282;
    i6 = i13 + 8 | 0;
    HEAP32[i6 >> 2] = i14;
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i13 + 16 >> 2] = i8;
    HEAP8[i13 + 20 >> 0] = i9;
    HEAP8[i13 + 21 >> 0] = i10;
    i13 = i13 + 24 | 0;
    HEAP32[i13 >> 2] = i11;
    HEAP32[i13 + 4 >> 2] = i12;
    i13 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
    HEAP32[i2 >> 2] = i13;
    if ((i13 | 0) == 256) {
     i14 = HEAP32[i1 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 | 0, 256);
     HEAP32[i2 >> 2] = 0;
    }
   }
   i14 = i4;
   STACKTOP = i7;
   return i14 | 0;
  }
 case 5:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = HEAP32[i5 + 8 >> 2] | 0;
   __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i6, i3, i1);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i8 = i6;
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i12 = HEAP16[i1 + 2 >> 1] | 0;
    i13 = HEAP32[i6 + 16 >> 2] | 0;
    i11 = i6 + 8 | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = _bitshift64Shl(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, 48) | 0;
    i8 = _bitshift64Ashr(i8 | 0, getTempRet0() | 0, 48) | 0;
    i9 = getTempRet0() | 0;
    i1 = i2 + 8192 | 0;
    i14 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
    HEAP8[i14 >> 0] = 5;
    HEAP8[i14 + 1 >> 0] = -1;
    HEAP16[i14 + 2 >> 1] = i12;
    i12 = i14 + 8 | 0;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i9;
    i12 = i14 + 16 | 0;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i14 + 24 >> 2] = i13;
    i14 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
    HEAP32[i1 >> 2] = i14;
    if ((i14 | 0) == 256) {
     i14 = HEAP32[i2 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i2 | 0, 256);
     HEAP32[i1 >> 2] = 0;
    }
   }
   i14 = i3;
   STACKTOP = i7;
   return i14 | 0;
  }
 case 6:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i6, i3, HEAP32[i5 + 8 >> 2] | 0);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i8 = i6;
    i5 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i10 = HEAP32[i6 + 8 >> 2] | 0;
    i12 = HEAP32[i6 + 16 >> 2] | 0;
    i13 = HEAP32[i6 + 20 >> 2] | 0;
    i11 = HEAP32[i6 + 12 >> 2] | 0;
    i1 = i2 + 8192 | 0;
    i14 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
    HEAP8[i14 >> 0] = 6;
    HEAP8[i14 + 1 >> 0] = -1;
    HEAP16[i14 + 2 >> 1] = 0;
    i9 = i14 + 8 | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP32[i14 + 16 >> 2] = i10;
    HEAP32[i14 + 20 >> 2] = i11;
    HEAP32[i14 + 24 >> 2] = i12;
    HEAP32[i14 + 28 >> 2] = i13;
    i14 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
    HEAP32[i1 >> 2] = i14;
    if ((i14 | 0) == 256) {
     i14 = HEAP32[i2 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i2 | 0, 256);
     HEAP32[i1 >> 2] = 0;
    }
   }
   i14 = i3;
   STACKTOP = i7;
   return i14 | 0;
  }
 default:
  {
   i14 = 0;
   STACKTOP = i7;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 switch (i2 | 0) {
 case 1:
  {
   i6 = __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_10StartEventEEEbRT_(i5, i6) | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 2:
  {
   i6 = __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_9StopEventEEEbRT_(i5, i6) | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 3:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = i4 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 660679 | 0, i6, HEAPU8[i1 >> 0] & 3);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i10 = HEAP32[i5 >> 2] | 0;
    i11 = i10 + 16 | 0;
    i8 = i11;
    i9 = i6;
    i1 = (HEAP8[i1 >> 0] & 3) == 3;
    i9 = _i64Add((i1 ? 0 : HEAP32[i8 >> 2] | 0) | 0, (i1 ? 0 : HEAP32[i8 + 4 >> 2] | 0) | 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0) | 0;
    i8 = getTempRet0() | 0;
    i1 = i11;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = i6;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = HEAP32[i5 + 12 >> 2] | 0;
    i11 = HEAP32[i10 + 8 >> 2] | 0;
    i12 = i10;
    i13 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i5 = HEAP8[i10 + 13 >> 0] | 0;
    i10 = HEAP8[i10 + 12 >> 0] | 0;
    i2 = i1 + 8192 | 0;
    i6 = i1 + (HEAP32[i2 >> 2] << 5) | 0;
    HEAP32[i6 >> 2] = HEAPU16[i4 + 2 >> 1] << 16 | 65281;
    i4 = i6 + 8 | 0;
    HEAP32[i4 >> 2] = i13;
    HEAP32[i4 + 4 >> 2] = i12;
    HEAP32[i6 + 16 >> 2] = i11;
    HEAP8[i6 + 20 >> 0] = i10;
    HEAP8[i6 + 21 >> 0] = i5;
    i6 = i6 + 24 | 0;
    HEAP32[i6 >> 2] = i9;
    HEAP32[i6 + 4 >> 2] = i8;
    i6 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
    HEAP32[i2 >> 2] = i6;
    if ((i6 | 0) == 256) {
     i13 = HEAP32[i1 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i1 | 0, 256);
     HEAP32[i2 >> 2] = 0;
    }
   }
   i13 = i3;
   STACKTOP = i7;
   return i13 | 0;
  }
 case 4:
  {
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = i3 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 660679 | 0, i6, HEAPU8[i1 >> 0] & 3);
   i4 = (HEAP8[i4 + 8 >> 0] | 0) == 0;
   if (i4) {
    i9 = HEAP32[i5 >> 2] | 0;
    i8 = i9 + 16 | 0;
    i12 = i8;
    i11 = i6;
    i1 = (HEAP8[i1 >> 0] & 3) == 3;
    i11 = _i64Add((i1 ? 0 : HEAP32[i12 >> 2] | 0) | 0, (i1 ? 0 : HEAP32[i12 + 4 >> 2] | 0) | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
    i12 = getTempRet0() | 0;
    i1 = i8;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = i6;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = HEAP32[i5 + 12 >> 2] | 0;
    i8 = HEAP32[i9 + 8 >> 2] | 0;
    i5 = i9;
    i14 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i10 = HEAP8[i9 + 13 >> 0] | 0;
    i9 = HEAP8[i9 + 12 >> 0] | 0;
    i2 = i1 + 8192 | 0;
    i13 = i1 + (HEAP32[i2 >> 2] << 5) | 0;
    HEAP32[i13 >> 2] = HEAPU16[i3 + 2 >> 1] << 16 | 65282;
    i6 = i13 + 8 | 0;
    HEAP32[i6 >> 2] = i14;
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i13 + 16 >> 2] = i8;
    HEAP8[i13 + 20 >> 0] = i9;
    HEAP8[i13 + 21 >> 0] = i10;
    i13 = i13 + 24 | 0;
    HEAP32[i13 >> 2] = i11;
    HEAP32[i13 + 4 >> 2] = i12;
    i13 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
    HEAP32[i2 >> 2] = i13;
    if ((i13 | 0) == 256) {
     i14 = HEAP32[i1 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 | 0, 256);
     HEAP32[i2 >> 2] = 0;
    }
   }
   i14 = i4;
   STACKTOP = i7;
   return i14 | 0;
  }
 case 5:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = HEAP32[i5 + 8 >> 2] | 0;
   __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i6, i3, i1);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i8 = i6;
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i12 = HEAP16[i1 + 2 >> 1] | 0;
    i13 = HEAP32[i6 + 16 >> 2] | 0;
    i11 = i6 + 8 | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = _bitshift64Shl(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, 48) | 0;
    i8 = _bitshift64Ashr(i8 | 0, getTempRet0() | 0, 48) | 0;
    i9 = getTempRet0() | 0;
    i1 = i2 + 8192 | 0;
    i14 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
    HEAP8[i14 >> 0] = 5;
    HEAP8[i14 + 1 >> 0] = -1;
    HEAP16[i14 + 2 >> 1] = i12;
    i12 = i14 + 8 | 0;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i9;
    i12 = i14 + 16 | 0;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i14 + 24 >> 2] = i13;
    i14 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
    HEAP32[i1 >> 2] = i14;
    if ((i14 | 0) == 256) {
     i14 = HEAP32[i2 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i2 | 0, 256);
     HEAP32[i1 >> 2] = 0;
    }
   }
   i14 = i3;
   STACKTOP = i7;
   return i14 | 0;
  }
 case 6:
  {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i6, i3, HEAP32[i5 + 8 >> 2] | 0);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i8 = i6;
    i5 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i10 = HEAP32[i6 + 8 >> 2] | 0;
    i12 = HEAP32[i6 + 16 >> 2] | 0;
    i13 = HEAP32[i6 + 20 >> 2] | 0;
    i11 = HEAP32[i6 + 12 >> 2] | 0;
    i1 = i2 + 8192 | 0;
    i14 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
    HEAP8[i14 >> 0] = 6;
    HEAP8[i14 + 1 >> 0] = -1;
    HEAP16[i14 + 2 >> 1] = 0;
    i9 = i14 + 8 | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP32[i14 + 16 >> 2] = i10;
    HEAP32[i14 + 20 >> 2] = i11;
    HEAP32[i14 + 24 >> 2] = i12;
    HEAP32[i14 + 28 >> 2] = i13;
    i14 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
    HEAP32[i1 >> 2] = i14;
    if ((i14 | 0) == 256) {
     i14 = HEAP32[i2 + 8196 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i2 | 0, 256);
     HEAP32[i1 >> 2] = 0;
    }
   }
   i14 = i3;
   STACKTOP = i7;
   return i14 | 0;
  }
 default:
  {
   i14 = 0;
   STACKTOP = i7;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i21, i2, i4, i5, i22) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 16 | 0;
 i24 = i25;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i21 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i21);
  i1 = HEAP32[i21 + 12 >> 2] | 0;
  i20 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i21 + 11 >> 0] = i3;
  if (!i3) i1 = i21; else {
   i1 = i21;
   i20 = 6;
  }
 } else i20 = 4;
 if ((i20 | 0) == 4) {
  i19 = i3 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 8 >> 2] = i19 | -2147483648;
  HEAP32[i21 + 4 >> 2] = i3;
  i20 = 6;
 }
 if ((i20 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i21 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i21 + 28 >> 2] = i2;
 i3 = _strlen(i4) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i21 + 28 >> 2] | 0;
  i20 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (i3) i20 = 12;
 } else i20 = 10;
 if ((i20 | 0) == 10) {
  i18 = i3 + 16 & -16;
  HEAP32[i23 >> 2] = 66;
  HEAP32[i23 + 4 >> 2] = i2;
  i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i19;
  HEAP32[i21 + 24 >> 2] = i18 | -2147483648;
  HEAP32[i21 + 20 >> 2] = i3;
  i1 = i19;
  i20 = 12;
 }
 if ((i20 | 0) == 12) _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i18 = i21 + 32 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i21 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i21 + 40 >> 2] = 0;
 HEAP32[i21 + 44 >> 2] = i5;
 i8 = i21 + 48 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i21 + 68 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i21 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i21 + 84 >> 2] = 1;
 i9 = i22 + 4 | 0;
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj(i18, ((HEAP32[i9 >> 2] | 0) - (HEAP32[i22 >> 2] | 0) | 0) / 12 | 0);
 i1 = HEAP32[i22 >> 2] | 0;
 if ((HEAP32[i9 >> 2] | 0) == (i1 | 0)) {
  i24 = i21 + 52 | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  STACKTOP = i25;
  return;
 }
 i10 = i24 + 12 | 0;
 i7 = i24 + 12 | 0;
 i11 = i23 + 4 | 0;
 i12 = i24 + 8 | 0;
 i13 = i24 + 4 | 0;
 i14 = i21 + 40 | 0;
 i15 = i24 + 11 | 0;
 i16 = i23 + 4 | 0;
 i17 = i23 + 4 | 0;
 i6 = 0;
 do {
  i4 = i1 + (i6 * 12 | 0) | 0;
  i5 = i4 + 11 | 0;
  i2 = 0;
  while (1) {
   if (!(__Z7StrICmpPKcS0_((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, HEAP32[gb + 67628 + (i2 << 2) >> 2] | 0) | 0)) {
    i20 = 21;
    break;
   }
   i3 = HEAP32[gb + 67652 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) if (!(__Z7StrICmpPKcS0_((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0)) {
    i20 = 21;
    break;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= 6) {
    i20 = 22;
    break;
   }
  }
  if ((i20 | 0) == 21) HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << i2; else if ((i20 | 0) == 22) {
   i20 = 0;
   i2 = HEAP8[i5 >> 0] | 0;
   i5 = i2 << 24 >> 24 < 0;
   i3 = i5 ? HEAP32[i4 >> 2] | 0 : i4;
   i2 = i5 ? HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2] | 0 : i2 & 255;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = i1;
   if (i2 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
    i1 = HEAP32[i7 >> 2] | 0;
    i20 = 25;
   } else if (i2 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i2;
    if (!i2) i1 = i24; else {
     i1 = i24;
     i20 = 27;
    }
   } else i20 = 25;
   if ((i20 | 0) == 25) {
    i5 = i2 + 16 & -16;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i11 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i24 >> 2] = i1;
    HEAP32[i12 >> 2] = i5 | -2147483648;
    HEAP32[i13 >> 2] = i2;
    i20 = 27;
   }
   if ((i20 | 0) == 27) {
    i20 = 0;
    _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
   }
   HEAP8[i1 + i2 >> 0] = 0;
   i1 = HEAP32[i19 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i14 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i18, i24); else {
    i4 = HEAP8[i15 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
    i4 = i2 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i20 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i20 = 34;
    } else i20 = 32;
    if ((i20 | 0) == 32) {
     i26 = i4 + 16 & -16;
     HEAP32[i23 >> 2] = 66;
     HEAP32[i17 >> 2] = i2;
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i26, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i5;
     HEAP32[i1 + 8 >> 2] = i26 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i5;
     i20 = 34;
    }
    if ((i20 | 0) == 34) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 16;
   }
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i26 = HEAP32[i24 >> 2] | 0;
    i20 = HEAP32[i7 >> 2] | 0;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i16 >> 2] = i20;
    __Z19free_alloc_internalPvRK10MemLabelId(i26, i23);
   }
  }
  i6 = i6 + 1 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
 } while (i6 >>> 0 < (((HEAP32[i9 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0);
 i26 = i21 + 52 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i5 = i2 + 4 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + i5 + (i1 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i2 = i2 + 16 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 f9 = Math_fround(HEAPF32[i2 + (i1 * 76 | 0) + 16 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + (i1 * 76 | 0) + 20 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + (i1 * 76 | 0) + 24 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + (i1 * 76 | 0) + 28 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f9 * f7);
 f20 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f14 = Math_fround(f17 * f20);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f11 = Math_fround(f19 * f10);
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f21 * f20)) - Math_fround(f17 * f10)) - Math_fround(f19 * f15));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f9 * f15)) - Math_fround(f21 * f10)) - Math_fround(f19 * f7));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f21 * f7)) - Math_fround(f9 * f20)) - Math_fround(f17 * f15));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f15) - Math_fround(f9 * f10)) - Math_fround(f19 * f20)) - Math_fround(f17 * f7));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f7 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f7 * f7);
 f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f8 * f8);
 f10 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f10 * f10)) + Math_fround(f11 + f20)))));
 f7 = Math_fround(f20 * f7);
 f8 = Math_fround(f20 * f8);
 f10 = Math_fround(f20 * f10);
 f14 = Math_fround(f20 * f14);
 f20 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(-.5)) + Math_fround(f7 * f7));
 f11 = Math_fround(Math_fround(f14 * f10) + Math_fround(f7 * f8));
 f8 = Math_fround(Math_fround(f10 * f7) - Math_fround(f14 * f8));
 f20 = Math_fround(f20 + f20);
 f11 = Math_fround(f11 + f11);
 f8 = Math_fround(f8 + f8);
 i2 = i4 + 4 | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f9 * f14);
 i5 = i4 + 12 | 0;
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f17 * f10);
 i3 = i4 + 8 | 0;
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f19 * f18);
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f21 * f10)) - Math_fround(f17 * f18)) - Math_fround(f19 * f16));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f9 * f16)) - Math_fround(f21 * f18)) - Math_fround(f19 * f14));
 f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f21 * f14)) - Math_fround(f9 * f10)) - Math_fround(f17 * f16));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f16) - Math_fround(f9 * f18)) - Math_fround(f19 * f10)) - Math_fround(f17 * f14));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f17 = (HEAP32[tempDoublePtr >> 2] = i12 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f17 * f17);
 f7 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(f7 * f7);
 f9 = (HEAP32[tempDoublePtr >> 2] = i1 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f9 * f9)) + Math_fround(f6 + f19)))));
 f17 = Math_fround(f19 * f17);
 f7 = Math_fround(f19 * f7);
 f9 = Math_fround(f19 * f9);
 f15 = Math_fround(f19 * f15);
 f19 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(-.5)) + Math_fround(f17 * f17));
 f6 = Math_fround(Math_fround(f15 * f9) + Math_fround(f17 * f7));
 f7 = Math_fround(Math_fround(f9 * f17) - Math_fround(f15 * f7));
 f19 = Math_fround(f19 + f19);
 f6 = Math_fround(f6 + f6);
 f7 = Math_fround(f7 + f7);
 f15 = Math_fround(Math_fround(f11 * f19) - Math_fround(f20 * f6));
 f17 = Math_fround(Math_fround(f8 * f6) - Math_fround(f11 * f7));
 f9 = Math_fround(Math_fround(f20 * f7) - Math_fround(f8 * f19));
 f7 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f8 * f8) + Math_fround(0.0))) * Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f7 * f7) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f11 * f6)) + Math_fround(Math_fround(f8 * f7) + Math_fround(0.0))));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f9) - Math_fround(f18 * f7)) - Math_fround(f10 * f15)) - Math_fround(f14 * f17));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f7) - Math_fround(f16 * f17)) - Math_fround(f18 * f15)) - Math_fround(f14 * f9));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f18 * f9)) - Math_fround(f16 * f7)) - Math_fround(f10 * f17));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f7)) - Math_fround(f10 * f9));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f9 = (HEAP32[tempDoublePtr >> 2] = i13 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f9 * f9);
 f8 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f8 * f8);
 f7 = (HEAP32[tempDoublePtr >> 2] = i1 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f11 + f10) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))))));
 f8 = Math_fround(f10 * f8);
 f7 = Math_fround(f10 * f7);
 f6 = Math_fround(f10 * f6);
 HEAPF32[i4 >> 2] = Math_fround(f10 * f9);
 HEAPF32[i2 >> 2] = f8;
 HEAPF32[i3 >> 2] = f7;
 HEAPF32[i5 >> 2] = f6;
 return;
}

function __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 28 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i3;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i3 = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i5 = i4;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 92 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 93 >> 0] = i1;
 i1 = i6 + 94 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 168 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i7, i10, 0);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 168 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i7, i10, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN14RenderSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i7 + 312 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 320 | 0, i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 316 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 344 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 336 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i7 + 340 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 28 | 0, i8);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 44 | 0, i8);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 60 | 0, i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 184 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i7 + 188 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 360 | 0, i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 300 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i7 + 304 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i7 + 308 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 352 | 0, i8);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 348 | 0, i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 372 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i7 + 376 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i7 + 364 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  i10 = i7 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 392 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  STACKTOP = i11;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i10 >> 2] = i2;
  i10 = i6;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  i10 = i7 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  i10 = i7 + 392 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleERKNS0_9TriangleVEjRKNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVEhPNS0_21MeshPersistentContactERj(i1, i20, i10, i11, i5, i12, i14) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 128 | 0;
 i16 = i21 + 112 | 0;
 i17 = i21 + 96 | 0;
 i13 = i21 + 80 | 0;
 i19 = i21 + 64 | 0;
 i3 = i21 + 48 | 0;
 i4 = i21 + 32 | 0;
 i22 = i21 + 16 | 0;
 i18 = i21;
 i7 = i1 + 96 | 0;
 HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = i1 + 112 | 0;
 HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = i1 + 128 | 0;
 HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 f25 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f25 = Math_fround(f25 - f6);
 f23 = Math_fround(f23 - f24);
 f26 = Math_fround(f26 - f9);
 f27 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f6 = Math_fround(f27 - f6);
 f24 = Math_fround(f2 - f24);
 f9 = Math_fround(Math_fround(HEAPF32[i1 + 136 >> 2]) - f9);
 f2 = Math_fround(Math_fround(f23 * f9) - Math_fround(f26 * f24));
 f9 = Math_fround(Math_fround(f26 * f6) - Math_fround(f25 * f9));
 f6 = Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f6));
 f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f2 * f2) + Math_fround(f9 * f9))))));
 f9 = Math_fround(f23 * f9);
 f6 = Math_fround(f6 * f23);
 HEAPF32[i13 >> 2] = Math_fround(f23 * f2);
 HEAPF32[i13 + 4 >> 2] = f9;
 HEAPF32[i13 + 8 >> 2] = f6;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(f6 * f6);
 i7 = i10 + 96 | 0;
 i8 = i10 + 112 | 0;
 __ZN5physx2Gu33pcmDistanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_S7_(i22, i7, i8, i15, i16, i17, i19, i3, i4);
 f9 = Math_fround(HEAPF32[i22 >> 2]);
 if (!(f6 > f9)) {
  STACKTOP = i21;
  return 1;
 }
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 do if (f6 == Math_fround(0.0)) {
  f2 = Math_fround(HEAPF32[i4 >> 2]);
  if (f2 == Math_fround(0.0)) if (!(i5 & 40)) {
   i1 = 13;
   break;
  } else {
   i1 = 14;
   break;
  }
  i1 = i5 & 255;
  if (f2 == Math_fround(1.0)) if (!(i1 & 48)) {
   i1 = 13;
   break;
  } else {
   f2 = Math_fround(1.0);
   i1 = 14;
   break;
  } else if (!(i1 & 32)) {
   i1 = 13;
   break;
  } else {
   i1 = 14;
   break;
  }
 } else {
  i22 = f6 == Math_fround(1.0);
  f2 = Math_fround(HEAPF32[i4 >> 2]);
  i1 = f2 == Math_fround(0.0);
  if (i22) if ((i5 & 24) == 0 & i1) {
   i1 = 13;
   break;
  } else {
   i1 = 14;
   break;
  }
  if (i1) if (!(i5 & 8)) {
   i1 = 13;
   break;
  } else {
   i1 = 14;
   break;
  } else if ((i5 & 16) == 0 | !(Math_fround(f6 + f2) >= Math_fround(.999899983))) {
   i1 = 13;
   break;
  } else {
   i1 = 14;
   break;
  }
 } while (0);
 do if ((i1 | 0) == 13) {
  HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 } else if ((i1 | 0) == 14) if (f9 == Math_fround(0.0)) {
  HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  break;
 } else {
  f24 = Math_fround(HEAPF32[i10 + 112 >> 2]);
  f29 = Math_fround(HEAPF32[i10 + 116 >> 2]);
  f32 = Math_fround(HEAPF32[i10 + 120 >> 2]);
  f33 = Math_fround(HEAPF32[i10 + 96 >> 2]);
  f30 = Math_fround(HEAPF32[i10 + 100 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 104 >> 2]);
  f24 = Math_fround(f24 - f33);
  f29 = Math_fround(f29 - f30);
  f32 = Math_fround(f32 - f9);
  f23 = Math_fround(HEAPF32[i19 >> 2]);
  f33 = Math_fround(Math_fround(f24 * f23) + f33);
  f30 = Math_fround(Math_fround(f29 * f23) + f30);
  f9 = Math_fround(Math_fround(f32 * f23) + f9);
  f23 = Math_fround(Math_fround(1.0) - Math_fround(f6 + f2));
  f32 = Math_fround(HEAPF32[i15 >> 2]);
  f29 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f31 = Math_fround(HEAPF32[i16 >> 2]);
  f28 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i17 >> 2]);
  f26 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f25 = Math_fround(f33 - Math_fround(Math_fround(f32 * f23) + Math_fround(Math_fround(f31 * f6) + Math_fround(f25 * f2))));
  f26 = Math_fround(f30 - Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f28 * f6) + Math_fround(f26 * f2))));
  f27 = Math_fround(f9 - Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f27 * f6) + Math_fround(Math_fround(HEAPF32[i17 + 8 >> 2]) * f2))));
  f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26))))));
  f26 = Math_fround(f24 * f26);
  f27 = Math_fround(f24 * f27);
  HEAPF32[i18 >> 2] = Math_fround(f24 * f25);
  HEAPF32[i18 + 4 >> 2] = f26;
  HEAPF32[i18 + 8 >> 2] = f27;
  HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
  break;
 } while (0);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration16generateContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj(i15, i16, i17, i13, i18, i20, i7, i8, i11, i12, i14) | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i7, i8, i11, i18, i20, i15, i16, i12, i14);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i7, i8, i11, i18, i20, i16, i17, i12, i14);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i7, i8, i11, i18, i20, i15, i17, i12, i14);
 STACKTOP = i21;
 return 1;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i17, i16, i11) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 336 | 0;
 i4 = i18 + 304 | 0;
 i5 = i18 + 280 | 0;
 i6 = i18 + 216 | 0;
 i7 = i18 + 192 | 0;
 i9 = i18 + 128 | 0;
 i10 = i18 + 96 | 0;
 i14 = i18 + 32 | 0;
 i15 = i18;
 __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE(i17 + 20 | 0, i16, i11, i17);
 i8 = HEAP32[i17 + 52 >> 2] | 0;
 if (!(HEAP16[((i8 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i8 >>> 24 & 15) << 2) >> 2] | 0) + (i17 + 48) + 8 | 0 : HEAP32[i17 + 56 >> 2] | 0) >> 1] & 1)) {
  STACKTOP = i18;
  return;
 }
 i8 = i11 + 3388 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!(i2 & 64)) i13 = 5; else if (!(HEAP8[i11 + 3028 >> 0] | 0)) i13 = 5; else f12 = Math_fround(HEAPF32[i11 + 2880 >> 2]);
 if ((i13 | 0) == 5) {
  f12 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 0));
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if (!(i2 & 64)) i13 = 9; else if (!(HEAP8[i11 + 3039 >> 0] | 0)) i13 = 9; else f1 = Math_fround(HEAPF32[i11 + 2924 >> 2]);
 if ((i13 | 0) == 9) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 11));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i17 | 0);
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i3, i4);
  i4 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i3) | 0;
  HEAPF32[i5 >> 2] = f1;
  HEAPF32[i5 + 4 >> 2] = f1;
  HEAPF32[i5 + 8 >> 2] = f1;
  HEAP32[i5 + 12 >> 2] = -65536;
  HEAP32[i5 + 16 >> 2] = -16711936;
  HEAP32[i5 + 20 >> 2] = -16776961;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i4, i5) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 15; else if (!(HEAP8[i11 + 3030 >> 0] | 0)) i13 = 15; else f1 = Math_fround(HEAPF32[i11 + 2888 >> 2]);
 if ((i13 | 0) == 15) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 2));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i6, i17 + 224 | 0);
  i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i6) | 0;
  HEAPF32[i7 >> 2] = f1;
  HEAPF32[i7 + 4 >> 2] = f1;
  HEAPF32[i7 + 8 >> 2] = f1;
  HEAP32[i7 + 12 >> 2] = -65536;
  HEAP32[i7 + 16 >> 2] = -16711936;
  HEAP32[i7 + 20 >> 2] = -16776961;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i6, i7) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 21; else if (!(HEAP8[i11 + 3032 >> 0] | 0)) i13 = 21; else f1 = Math_fround(HEAPF32[i11 + 2896 >> 2]);
 if ((i13 | 0) == 21) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 4));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  i5 = __ZN5physx2Cm12RenderOutputlsEj(i16, 16777215) | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  i6 = i9 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 20 >> 2] = Math_fround(1.0);
  i6 = i9 + 24 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 40 >> 2] = Math_fround(1.0);
  i6 = i9 + 44 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 60 >> 2] = Math_fround(1.0);
  i9 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i5, i9) | 0;
  f21 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 252 >> 2]));
  f20 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 256 >> 2]));
  f19 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 260 >> 2]));
  f1 = Math_fround(f1 * Math_fround(.200000003));
  i5 = HEAP32[i17 + 240 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  i6 = HEAP32[i17 + 244 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i6;
  i7 = HEAP32[i17 + 248 >> 2] | 0;
  HEAP32[i10 + 8 >> 2] = i7;
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i10 + 12 >> 2] = f21;
  HEAPF32[i10 + 16 >> 2] = f20;
  HEAPF32[i10 + 20 >> 2] = f19;
  HEAPF32[i10 + 24 >> 2] = f1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i9, i10) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 27; else if (!(HEAP8[i11 + 3033 >> 0] | 0)) i13 = 27; else f1 = Math_fround(HEAPF32[i11 + 2900 >> 2]);
 if ((i13 | 0) == 27) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 5));
 f1 = Math_fround(f12 * f1);
 if (!(f1 != Math_fround(0.0))) {
  STACKTOP = i18;
  return;
 }
 i16 = __ZN5physx2Cm12RenderOutputlsEj(i16, 0) | 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i13 = i14 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = Math_fround(1.0);
 i13 = i14 + 24 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(1.0);
 i13 = i14 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 60 >> 2] = Math_fround(1.0);
 i16 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i14) | 0;
 f12 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 264 >> 2]));
 f19 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 268 >> 2]));
 f20 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 272 >> 2]));
 f21 = Math_fround(f1 * Math_fround(.200000003));
 i13 = HEAP32[i17 + 240 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 i14 = HEAP32[i17 + 244 >> 2] | 0;
 HEAP32[i15 + 4 >> 2] = i14;
 i17 = HEAP32[i17 + 248 >> 2] | 0;
 HEAP32[i15 + 8 >> 2] = i17;
 f12 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i15 + 12 >> 2] = f12;
 HEAPF32[i15 + 16 >> 2] = f19;
 HEAPF32[i15 + 20 >> 2] = f20;
 HEAPF32[i15 + 24 >> 2] = f21;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i16, i15) | 0;
 STACKTOP = i18;
 return;
}

function __Z26RegisterAllClassesGranularv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __Z20RegisterBuiltinTypesv();
 __Z13RegisterClassI11AssetBundleEvv();
 __Z13RegisterClassI19AssetBundleManifestEvv();
 __Z13RegisterClassI9BehaviourEvv();
 __Z13RegisterClassI14BillboardAssetEvv();
 __Z13RegisterClassI17BillboardRendererEvv();
 __Z13RegisterClassI13BuildSettingsEvv();
 __Z13RegisterClassI6CameraEvv();
 __Z13RegisterClassI13ComputeShaderEvv();
 __Z13RegisterClassI7CubemapEvv();
 __Z13RegisterClassI12CubemapArrayEvv();
 __Z13RegisterClassI9CGProgramEvv();
 __Z13RegisterClassI18DelayedCallManagerEvv();
 __Z13RegisterClassI14DirectorPlayerEvv();
 HEAP32[i2 >> 2] = gb + 28304;
 HEAP32[i2 + 4 >> 2] = fb + 521;
 HEAP32[i2 + 8 >> 2] = gb + 369788;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 18;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 26492;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI5FlareEvv();
 __Z13RegisterClassI10FlareLayerEvv();
 HEAP32[i2 >> 2] = gb + 26492;
 HEAP32[i2 + 4 >> 2] = fb + 522;
 HEAP32[i2 + 8 >> 2] = gb + 368689;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 1;
 HEAP32[i2 + 20 >> 2] = 80;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28900;
 HEAP32[i2 + 44 >> 2] = fb + 6;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 7;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 28304;
 HEAP32[i2 + 4 >> 2] = fb + 523;
 HEAP32[i2 + 8 >> 2] = gb + 369804;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 9;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28608;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 28608;
 HEAP32[i2 + 4 >> 2] = fb + 524;
 HEAP32[i2 + 8 >> 2] = gb + 368671;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 6;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28760;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI16GraphicsSettingsEvv();
 __Z13RegisterClassI10GUIElementEvv();
 __Z13RegisterClassI8GUILayerEvv();
 __Z13RegisterClassI10GUITextureEvv();
 __Z13RegisterClassI4HaloEvv();
 __Z13RegisterClassI9HaloLayerEvv();
 __Z13RegisterClassI12InputManagerEvv();
 __Z13RegisterClassI9LensFlareEvv();
 HEAP32[i2 >> 2] = gb + 28608;
 HEAP32[i2 + 4 >> 2] = fb + 525;
 HEAP32[i2 + 8 >> 2] = gb + 368654;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 3;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28456;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI5LightEvv();
 __Z13RegisterClassI15LightProbeGroupEvv();
 __Z13RegisterClassI21LightProbeProxyVolumeEvv();
 __Z13RegisterClassI11LightProbesEvv();
 __Z13RegisterClassI16LightmapSettingsEvv();
 __Z13RegisterClassI12LineRendererEvv();
 __Z13RegisterClassI8LODGroupEvv();
 __Z13RegisterClassI8MaterialEvv();
 __Z13RegisterClassI4MeshEvv();
 __Z13RegisterClassI10MeshFilterEvv();
 __Z13RegisterClassI12MeshRendererEvv();
 __Z13RegisterClassI11NamedObjectEvv();
 __Z13RegisterClassI13OcclusionAreaEvv();
 __Z13RegisterClassI20OcclusionCullingDataEvv();
 __Z13RegisterClassI15OcclusionPortalEvv();
 __Z13RegisterClassI14PlayerSettingsEvv();
 __Z13RegisterClassI11PreloadDataEvv();
 __Z13RegisterClassI18ProceduralMaterialEvv();
 __Z13RegisterClassI17ProceduralTextureEvv();
 __Z13RegisterClassI9ProjectorEvv();
 __Z13RegisterClassI15ReflectionProbeEvv();
 __Z13RegisterClassI8RendererEvv();
 __Z13RegisterClassI14RenderSettingsEvv();
 __Z13RegisterClassI13RenderTextureEvv();
 __Z13RegisterClassI15ResourceManagerEvv();
 __Z13RegisterClassI30RuntimeInitializeOnLoadManagerEvv();
 __Z13RegisterClassI12ScriptMapperEvv();
 __Z13RegisterClassI6ShaderEvv();
 __Z13RegisterClassI23ShaderVariantCollectionEvv();
 __Z13RegisterClassI19SkinnedMeshRendererEvv();
 __Z13RegisterClassI6SkyboxEvv();
 __Z13RegisterClassI13SparseTextureEvv();
 __Z13RegisterClassI18SpeedTreeWindAssetEvv();
 __Z13RegisterClassI14SpriteRendererEvv();
 __Z13RegisterClassI6SpriteEvv();
 __Z13RegisterClassI16SubstanceArchiveEvv();
 __Z13RegisterClassI10TagManagerEvv();
 __Z13RegisterClassI11TimeManagerEvv();
 __Z13RegisterClassI9TextAssetEvv();
 __Z13RegisterClassI7TextureEvv();
 __Z13RegisterClassI9Texture2DEvv();
 __Z13RegisterClassI14Texture2DArrayEvv();
 __Z13RegisterClassI9Texture3DEvv();
 __Z13RegisterClassI13TrailRendererEvv();
 __Z13RegisterClassI9TransformEvv();
 __Z13RegisterClassI15QualitySettingsEvv();
 __Z13RegisterClassI8WindZoneEvv();
 HEAP32[i2 >> 2] = gb + 26492;
 HEAP32[i2 + 4 >> 2] = fb + 526;
 HEAP32[i2 + 8 >> 2] = gb + 589668;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 2;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29020;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassIN2UI13RectTransformEEvv();
 __Z13RegisterClassI13MonoBehaviourEvv();
 __Z13RegisterClassI11MonoManagerEvv();
 __Z13RegisterClassI10MonoScriptEvv();
 __Z43InvokeRegisterStaticallyLinkedModuleClassesv();
 STACKTOP = i1;
 return;
}

function __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 16 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 81 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 82 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 83 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 76 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function _UNITY_FT_Bitmap_Convert(i1, i10, i9, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 HEAP32[i13 >> 2] = 0;
 if (!i1) {
  i13 = 33;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!((i10 | 0) != 0 & (i9 | 0) != 0)) {
  i13 = 6;
  STACKTOP = i14;
  return i13 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i8 = i10 + 18 | 0;
 if (((HEAPU8[i8 >> 0] | 0) + -1 | 0) >>> 0 < 7) {
  i7 = i9 + 8 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = Math_imul((i1 | 0) < 0 ? 0 - i1 | 0 : i1, HEAP32[i9 >> 2] | 0) | 0;
  HEAP8[i9 + 18 >> 0] = 2;
  i4 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  i3 = i10 + 4 | 0;
  HEAP32[i9 + 4 >> 2] = HEAP32[i3 >> 2];
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i12 = (i3 | 0) % (i2 | 0) | 0;
   i2 = (i12 | 0) == 0 ? 0 : i2 - i12 | 0;
  } else i2 = 0;
  i3 = i3 + i2 | 0;
  if ((i3 | 0) > 0) if (i4 >>> 0 > (4294967295 / (i3 >>> 0) | 0) >>> 0) {
   i13 = 6;
   STACKTOP = i14;
   return i13 | 0;
  }
  i2 = Math_imul(i4, i3) | 0;
  do if (i2 >>> 0 > i5 >>> 0) {
   i1 = i9 + 12 | 0;
   HEAP32[i1 >> 2] = _UNITY_ft_mem_qrealloc(i6, 1, i5, i2, HEAP32[i1 >> 2] | 0, i13) | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i7 >> 2] | 0;
    break;
   } else {
    i13 = i1;
    STACKTOP = i14;
    return i13 | 0;
   }
  } while (0);
  HEAP32[i7 >> 2] = (i1 | 0) < 0 ? 0 - i3 | 0 : i3;
 } else HEAP32[i13 >> 2] = 6;
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 i3 = HEAP32[i9 + 12 >> 2] | 0;
 i12 = i10 + 8 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) < 0) i1 = i1 + (Math_imul((HEAP32[i10 >> 2] | 0) + -1 | 0, 0 - i5 | 0) | 0) | 0;
 i11 = i9 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) < 0) i3 = i3 + (Math_imul((HEAP32[i9 >> 2] | 0) + -1 | 0, 0 - i2 | 0) | 0) | 0;
 switch (HEAP8[i8 >> 0] | 0) {
 case 1:
  {
   HEAP16[i9 + 16 >> 1] = 2;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i9 = i10 + 4 | 0;
    while (1) {
     i5 = HEAP32[i9 >> 2] | 0;
     i8 = i5 >>> 3;
     if (!i8) {
      i4 = i3;
      i6 = i1;
     } else {
      i4 = i3 + (i8 << 3) | 0;
      i5 = i8;
      i6 = i3;
      i7 = i1;
      while (1) {
       i15 = HEAP8[i7 >> 0] | 0;
       i10 = i15 & 255;
       HEAP8[i6 >> 0] = (i15 & 255) >>> 7;
       HEAP8[i6 + 1 >> 0] = i10 >>> 6 & 1;
       HEAP8[i6 + 2 >> 0] = i10 >>> 5 & 1;
       HEAP8[i6 + 3 >> 0] = i10 >>> 4 & 1;
       HEAP8[i6 + 4 >> 0] = i10 >>> 3 & 1;
       HEAP8[i6 + 5 >> 0] = i10 >>> 2 & 1;
       HEAP8[i6 + 6 >> 0] = i10 >>> 1 & 1;
       HEAP8[i6 + 7 >> 0] = i10 & 1;
       i5 = i5 + -1 | 0;
       if (!i5) break; else {
        i6 = i6 + 8 | 0;
        i7 = i7 + 1 | 0;
       }
      }
      i6 = i1 + i8 | 0;
      i5 = HEAP32[i9 >> 2] | 0;
     }
     i5 = i5 & 7;
     if (i5 | 0) {
      i6 = HEAPU8[i6 >> 0] | 0;
      while (1) {
       HEAP8[i4 >> 0] = i6 >>> 7 & 1;
       i5 = i5 + -1 | 0;
       if (!i5) break; else {
        i6 = i6 << 1;
        i4 = i4 + 1 | 0;
       }
      }
     }
     i2 = i2 + -1 | 0;
     if (!i2) break; else {
      i1 = i1 + (HEAP32[i12 >> 2] | 0) | 0;
      i3 = i3 + (HEAP32[i11 >> 2] | 0) | 0;
     }
    }
   }
   break;
  }
 case 6:
 case 5:
 case 2:
  {
   i4 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP16[i9 + 16 >> 1] = 256;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) while (1) {
    _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
    i2 = i2 + -1 | 0;
    if (!i2) break; else {
     i3 = i3 + (HEAP32[i11 >> 2] | 0) | 0;
     i1 = i1 + (HEAP32[i12 >> 2] | 0) | 0;
    }
   }
   break;
  }
 case 3:
  {
   HEAP16[i9 + 16 >> 1] = 4;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i9 = i10 + 4 | 0;
    while (1) {
     i5 = HEAP32[i9 >> 2] | 0;
     i8 = i5 >>> 2;
     if (!i8) {
      i4 = i3;
      i6 = i1;
     } else {
      i7 = i8 << 2;
      i4 = i8;
      i5 = i3;
      i6 = i1;
      while (1) {
       i10 = HEAP8[i6 >> 0] | 0;
       i15 = i10 & 255;
       HEAP8[i5 >> 0] = (i10 & 255) >>> 6;
       HEAP8[i5 + 1 >> 0] = i15 >>> 4 & 3;
       HEAP8[i5 + 2 >> 0] = i15 >>> 2 & 3;
       HEAP8[i5 + 3 >> 0] = i15 & 3;
       i4 = i4 + -1 | 0;
       if (!i4) break; else {
        i5 = i5 + 4 | 0;
        i6 = i6 + 1 | 0;
       }
      }
      i4 = i3 + i7 | 0;
      i6 = i1 + i8 | 0;
      i5 = HEAP32[i9 >> 2] | 0;
     }
     i5 = i5 & 3;
     if (i5 | 0) {
      i6 = HEAPU8[i6 >> 0] | 0;
      while (1) {
       HEAP8[i4 >> 0] = i6 >>> 6 & 3;
       i5 = i5 + -1 | 0;
       if (!i5) break; else {
        i6 = i6 << 2;
        i4 = i4 + 1 | 0;
       }
      }
     }
     i2 = i2 + -1 | 0;
     if (!i2) break; else {
      i3 = i3 + (HEAP32[i11 >> 2] | 0) | 0;
      i1 = i1 + (HEAP32[i12 >> 2] | 0) | 0;
     }
    }
   }
   break;
  }
 case 4:
  {
   HEAP16[i9 + 16 >> 1] = 16;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i9 = i10 + 4 | 0;
    while (1) {
     i4 = HEAP32[i9 >> 2] | 0;
     i8 = i4 >>> 1;
     if (!i8) {
      i6 = i3;
      i5 = i1;
     } else {
      i7 = i8 << 1;
      i4 = i8;
      i5 = i3;
      i6 = i1;
      while (1) {
       i15 = HEAP8[i6 >> 0] | 0;
       HEAP8[i5 >> 0] = (i15 & 255) >>> 4;
       HEAP8[i5 + 1 >> 0] = i15 & 15;
       i4 = i4 + -1 | 0;
       if (!i4) break; else {
        i5 = i5 + 2 | 0;
        i6 = i6 + 1 | 0;
       }
      }
      i6 = i3 + i7 | 0;
      i5 = i1 + i8 | 0;
      i4 = HEAP32[i9 >> 2] | 0;
     }
     if (i4 & 1 | 0) HEAP8[i6 >> 0] = (HEAPU8[i5 >> 0] | 0) >>> 4;
     i2 = i2 + -1 | 0;
     if (!i2) break; else {
      i3 = i3 + (HEAP32[i11 >> 2] | 0) | 0;
      i1 = i1 + (HEAP32[i12 >> 2] | 0) | 0;
     }
    }
   }
   break;
  }
 case 7:
  {
   HEAP16[i9 + 16 >> 1] = 256;
   i4 = HEAP32[i10 >> 2] | 0;
   if (i4 | 0) {
    i9 = i10 + 4 | 0;
    while (1) {
     i6 = HEAP32[i9 >> 2] | 0;
     if (i6) {
      i7 = i3;
      i8 = i1;
      i5 = i6;
      while (1) {
       i15 = HEAP8[i8 + 3 >> 0] | 0;
       i2 = i15 & 255;
       if (!(i15 << 24 >> 24)) i2 = 0; else {
        i10 = HEAPU8[i8 >> 0] | 0;
        i10 = Math_imul(i10 * 4732 | 0, i10) | 0;
        i15 = HEAPU8[i8 + 1 >> 0] | 0;
        i10 = (Math_imul(i15 * 46871 | 0, i15) | 0) + i10 | 0;
        i15 = HEAPU8[i8 + 2 >> 0] | 0;
        i2 = i2 - (((i10 + (Math_imul(i15 * 13933 | 0, i15) | 0) | 0) >>> 16 >>> 0) / (i2 >>> 0) | 0) & 255;
       }
       HEAP8[i7 >> 0] = i2;
       i5 = i5 + -1 | 0;
       if (!i5) break; else {
        i7 = i7 + 1 | 0;
        i8 = i8 + 4 | 0;
       }
      }
      i5 = HEAP32[i12 >> 2] | 0;
      i2 = HEAP32[i11 >> 2] | 0;
     }
     i4 = i4 + -1 | 0;
     if (!i4) break; else {
      i3 = i3 + i2 | 0;
      i1 = i1 + i5 | 0;
     }
    }
   }
   break;
  }
 default:
  {}
 }
 i15 = HEAP32[i13 >> 2] | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i17, i16, i11) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 336 | 0;
 i4 = i18 + 304 | 0;
 i5 = i18 + 280 | 0;
 i6 = i18 + 216 | 0;
 i7 = i18 + 192 | 0;
 i9 = i18 + 128 | 0;
 i10 = i18 + 96 | 0;
 i14 = i18 + 32 | 0;
 i15 = i18;
 __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE(i17 + 20 | 0, i16, i11, i17);
 i8 = HEAP32[i17 + 52 >> 2] | 0;
 if (!(HEAP16[((i8 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i8 >>> 24 & 15) << 2) >> 2] | 0) + (i17 + 48) + 8 | 0 : HEAP32[i17 + 56 >> 2] | 0) >> 1] & 1)) {
  STACKTOP = i18;
  return;
 }
 i8 = i11 + 3388 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!(i2 & 64)) i13 = 5; else if (!(HEAP8[i11 + 3028 >> 0] | 0)) i13 = 5; else f12 = Math_fround(HEAPF32[i11 + 2880 >> 2]);
 if ((i13 | 0) == 5) {
  f12 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 0));
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if (!(i2 & 64)) i13 = 9; else if (!(HEAP8[i11 + 3039 >> 0] | 0)) i13 = 9; else f1 = Math_fround(HEAPF32[i11 + 2924 >> 2]);
 if ((i13 | 0) == 9) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 11));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i17 | 0);
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i3, i4);
  i4 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i3) | 0;
  HEAPF32[i5 >> 2] = f1;
  HEAPF32[i5 + 4 >> 2] = f1;
  HEAPF32[i5 + 8 >> 2] = f1;
  HEAP32[i5 + 12 >> 2] = -65536;
  HEAP32[i5 + 16 >> 2] = -16711936;
  HEAP32[i5 + 20 >> 2] = -16776961;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i4, i5) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 15; else if (!(HEAP8[i11 + 3030 >> 0] | 0)) i13 = 15; else f1 = Math_fround(HEAPF32[i11 + 2888 >> 2]);
 if ((i13 | 0) == 15) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 2));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i6, i17 + 224 | 0);
  i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i6) | 0;
  HEAPF32[i7 >> 2] = f1;
  HEAPF32[i7 + 4 >> 2] = f1;
  HEAPF32[i7 + 8 >> 2] = f1;
  HEAP32[i7 + 12 >> 2] = -65536;
  HEAP32[i7 + 16 >> 2] = -16711936;
  HEAP32[i7 + 20 >> 2] = -16776961;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i6, i7) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 21; else if (!(HEAP8[i11 + 3032 >> 0] | 0)) i13 = 21; else f1 = Math_fround(HEAPF32[i11 + 2896 >> 2]);
 if ((i13 | 0) == 21) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 4));
 f1 = Math_fround(f12 * f1);
 if (f1 != Math_fround(0.0)) {
  i5 = __ZN5physx2Cm12RenderOutputlsEj(i16, 16777215) | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  i6 = i9 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 20 >> 2] = Math_fround(1.0);
  i6 = i9 + 24 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 40 >> 2] = Math_fround(1.0);
  i6 = i9 + 44 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i9 + 60 >> 2] = Math_fround(1.0);
  i9 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i5, i9) | 0;
  f21 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 252 >> 2]));
  f20 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 256 >> 2]));
  f19 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 260 >> 2]));
  f1 = Math_fround(f1 * Math_fround(.200000003));
  i5 = HEAP32[i17 + 240 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  i6 = HEAP32[i17 + 244 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i6;
  i7 = HEAP32[i17 + 248 >> 2] | 0;
  HEAP32[i10 + 8 >> 2] = i7;
  f21 = Math_fround(f21 + (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAPF32[i10 + 12 >> 2] = f21;
  HEAPF32[i10 + 16 >> 2] = f20;
  HEAPF32[i10 + 20 >> 2] = f19;
  HEAPF32[i10 + 24 >> 2] = f1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i9, i10) | 0;
 }
 if (!(HEAP32[i8 >> 2] & 64)) i13 = 27; else if (!(HEAP8[i11 + 3033 >> 0] | 0)) i13 = 27; else f1 = Math_fround(HEAPF32[i11 + 2900 >> 2]);
 if ((i13 | 0) == 27) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i11 + 32 | 0, 5));
 f1 = Math_fround(f12 * f1);
 if (!(f1 != Math_fround(0.0))) {
  STACKTOP = i18;
  return;
 }
 i16 = __ZN5physx2Cm12RenderOutputlsEj(i16, 0) | 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i13 = i14 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = Math_fround(1.0);
 i13 = i14 + 24 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(1.0);
 i13 = i14 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAPF32[i14 + 60 >> 2] = Math_fround(1.0);
 i16 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i16, i14) | 0;
 f12 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 264 >> 2]));
 f19 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 268 >> 2]));
 f20 = Math_fround(f1 * Math_fround(HEAPF32[i17 + 272 >> 2]));
 f21 = Math_fround(f1 * Math_fround(.200000003));
 i13 = HEAP32[i17 + 240 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 i14 = HEAP32[i17 + 244 >> 2] | 0;
 HEAP32[i15 + 4 >> 2] = i14;
 i17 = HEAP32[i17 + 248 >> 2] | 0;
 HEAP32[i15 + 8 >> 2] = i17;
 f12 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(f19 + (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(f20 + (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i15 + 12 >> 2] = f12;
 HEAPF32[i15 + 16 >> 2] = f19;
 HEAPF32[i15 + 20 >> 2] = f20;
 HEAPF32[i15 + 24 >> 2] = f21;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i16, i15) | 0;
 STACKTOP = i18;
 return;
}

function __Z16ApplyRadialForceR23ParticleSystemParticlesjjRK8Vector3ffRKN4math7_float4E(i3, i13, i16, i1, f2, i17) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i17 = i17 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f14 = f0, f15 = f0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, i37 = 0, f38 = f0, i39 = 0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(Math_fround(1.0) / f2);
 if (i13 >>> 0 >= i16 >>> 0) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[i3 + 40 >> 2] | 0;
 i7 = i17 + 4 | 0;
 i8 = i17 + 8 | 0;
 i9 = i17 + 12 | 0;
 i10 = HEAP32[i3 + 60 >> 2] | 0;
 i11 = HEAP32[i3 + 80 >> 2] | 0;
 i3 = HEAP32[i3 + 100 >> 2] | 0;
 i1 = i13;
 do {
  i33 = i4 + (i1 << 2) | 0;
  f40 = Math_fround(HEAPF32[i33 >> 2]);
  f38 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f40 = Math_fround(f15 - f40);
  f38 = Math_fround(f15 - f38);
  f36 = Math_fround(f15 - f36);
  f34 = Math_fround(f15 - Math_fround(HEAPF32[i33 + 12 >> 2]));
  i33 = i5 + (i1 << 2) | 0;
  f48 = Math_fround(HEAPF32[i33 >> 2]);
  f47 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f48 = Math_fround(f14 - f48);
  f47 = Math_fround(f14 - f47);
  f46 = Math_fround(f14 - f46);
  f45 = Math_fround(f14 - Math_fround(HEAPF32[i33 + 12 >> 2]));
  i33 = i6 + (i1 << 2) | 0;
  f52 = Math_fround(HEAPF32[i33 >> 2]);
  f20 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f52 = Math_fround(f12 - f52);
  f20 = Math_fround(f12 - f20);
  f22 = Math_fround(f12 - f22);
  f24 = Math_fround(f12 - Math_fround(HEAPF32[i33 + 12 >> 2]));
  f26 = Math_fround(Math_fround(Math_fround(f40 * f40) + Math_fround(f48 * f48)) + Math_fround(f52 * f52));
  f28 = Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f47 * f47)) + Math_fround(f20 * f20));
  f30 = Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f46 * f46)) + Math_fround(f22 * f22));
  f32 = Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f45 * f45)) + Math_fround(f24 * f24));
  f44 = Math_fround(Math_sqrt(Math_fround(f26)));
  f49 = Math_fround(Math_fround(1.0) / f44);
  f43 = Math_fround(Math_sqrt(Math_fround(f28)));
  f50 = Math_fround(Math_fround(1.0) / f43);
  f42 = Math_fround(Math_sqrt(Math_fround(f30)));
  f51 = Math_fround(Math_fround(1.0) / f42);
  f18 = Math_fround(Math_sqrt(Math_fround(f32)));
  f41 = Math_fround(Math_fround(1.0) / f18);
  f40 = Math_fround(f40 * f49);
  f38 = Math_fround(f38 * f50);
  f36 = Math_fround(f36 * f51);
  f34 = Math_fround(f34 * f41);
  f48 = Math_fround(f48 * f49);
  f47 = Math_fround(f47 * f50);
  f46 = Math_fround(f46 * f51);
  f45 = Math_fround(f45 * f41);
  f49 = Math_fround(f52 * f49);
  f50 = Math_fround(f20 * f50);
  f51 = Math_fround(f22 * f51);
  f41 = Math_fround(f24 * f41);
  i33 = f26 > Math_fround(9.99999974e-06);
  i35 = f28 > Math_fround(9.99999974e-06);
  i37 = f30 > Math_fround(9.99999974e-06);
  i39 = f32 > Math_fround(9.99999974e-06);
  f44 = Math_fround(f2 * f44);
  f43 = Math_fround(f2 * f43);
  f42 = Math_fround(f2 * f42);
  f18 = Math_fround(f2 * f18);
  i31 = f44 < Math_fround(0.0);
  f44 = i31 ? Math_fround(0.0) : f44;
  i31 = f43 < Math_fround(0.0);
  f43 = i31 ? Math_fround(0.0) : f43;
  i31 = f42 < Math_fround(0.0);
  f42 = i31 ? Math_fround(0.0) : f42;
  i31 = f18 < Math_fround(0.0);
  f18 = i31 ? Math_fround(0.0) : f18;
  i31 = f44 > Math_fround(1.0);
  f44 = i31 ? Math_fround(1.0) : f44;
  i31 = f43 > Math_fround(1.0);
  f43 = i31 ? Math_fround(1.0) : f43;
  i31 = f42 > Math_fround(1.0);
  f42 = i31 ? Math_fround(1.0) : f42;
  i31 = f18 > Math_fround(1.0);
  f18 = i31 ? Math_fround(1.0) : f18;
  f44 = Math_fround(Math_fround(1.0) - Math_fround(f44 * f44));
  f43 = Math_fround(Math_fround(1.0) - Math_fround(f43 * f43));
  f42 = Math_fround(Math_fround(1.0) - Math_fround(f42 * f42));
  f18 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f18));
  f44 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f44);
  f43 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f43);
  f42 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f42);
  f18 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f18);
  f40 = Math_fround((i33 ? f40 : Math_fround(0.0)) * f44);
  f38 = Math_fround((i35 ? f38 : Math_fround(0.0)) * f43);
  f36 = Math_fround((i37 ? f36 : Math_fround(0.0)) * f42);
  f34 = Math_fround((i39 ? f34 : Math_fround(0.0)) * f18);
  f48 = Math_fround((i33 ? f48 : Math_fround(0.0)) * f44);
  f47 = Math_fround((i35 ? f47 : Math_fround(0.0)) * f43);
  f46 = Math_fround((i37 ? f46 : Math_fround(0.0)) * f42);
  f45 = Math_fround((i39 ? f45 : Math_fround(0.0)) * f18);
  f44 = Math_fround((i33 ? f49 : Math_fround(0.0)) * f44);
  f43 = Math_fround((i35 ? f50 : Math_fround(0.0)) * f43);
  f42 = Math_fround((i37 ? f51 : Math_fround(0.0)) * f42);
  f18 = Math_fround((i39 ? f41 : Math_fround(0.0)) * f18);
  i39 = i10 + (i1 << 2) | 0;
  f41 = Math_fround(HEAPF32[i39 >> 2]);
  i37 = i39 + 4 | 0;
  f51 = Math_fround(HEAPF32[i37 >> 2]);
  i35 = i39 + 8 | 0;
  f50 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i39 + 12 | 0;
  f49 = Math_fround(HEAPF32[i33 >> 2]);
  i31 = i11 + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i31 >> 2]);
  i29 = i31 + 4 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  i27 = i31 + 8 | 0;
  f28 = Math_fround(HEAPF32[i27 >> 2]);
  i25 = i31 + 12 | 0;
  f26 = Math_fround(HEAPF32[i25 >> 2]);
  i23 = i3 + (i1 << 2) | 0;
  f24 = Math_fround(HEAPF32[i23 >> 2]);
  i21 = i23 + 4 | 0;
  f22 = Math_fround(HEAPF32[i21 >> 2]);
  i19 = i23 + 8 | 0;
  f20 = Math_fround(HEAPF32[i19 >> 2]);
  i13 = i23 + 12 | 0;
  f38 = Math_fround(f51 + f38);
  f36 = Math_fround(f50 + f36);
  f34 = Math_fround(f49 + f34);
  f32 = Math_fround(f48 + f32);
  f30 = Math_fround(f47 + f30);
  f28 = Math_fround(f46 + f28);
  f26 = Math_fround(f45 + f26);
  f24 = Math_fround(f44 + f24);
  f22 = Math_fround(f43 + f22);
  f20 = Math_fround(f42 + f20);
  f18 = Math_fround(f18 + Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i39 >> 2] = Math_fround(f41 + f40);
  HEAPF32[i37 >> 2] = f38;
  HEAPF32[i35 >> 2] = f36;
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i29 >> 2] = f30;
  HEAPF32[i27 >> 2] = f28;
  HEAPF32[i25 >> 2] = f26;
  HEAPF32[i23 >> 2] = f24;
  HEAPF32[i21 >> 2] = f22;
  HEAPF32[i19 >> 2] = f20;
  HEAPF32[i13 >> 2] = f18;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i37, i38, i1) {
 i37 = i37 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i40 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i36 + 72 | 0;
 i33 = i36 + 64 | 0;
 i34 = i36 + 32 | 0;
 i35 = i36;
 i1 = i37 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i37 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i32, 4);
  i1 = HEAP32[i32 >> 2] | 0;
 } else {
  i31 = HEAP32[i2 >> 2] | 0;
  HEAP32[i32 >> 2] = i31;
  HEAP32[i1 >> 2] = i3;
  i1 = i31;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 i8 = i34 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i34 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i31 = i38 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i38, HEAP32[i31 >> 2] | 0);
 i9 = i38 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i38 >> 2] = i31;
 HEAP32[i31 >> 2] = 0;
 if ((i7 | 0) > 0) {
  i10 = i34 + 11 | 0;
  i11 = i34 + 4 | 0;
  i12 = i35 + 12 | 0;
  i5 = i35 + 12 | 0;
  i13 = i32 + 4 | 0;
  i14 = i35 + 8 | 0;
  i15 = i35 + 4 | 0;
  i16 = i35 + 16 | 0;
  i17 = i8 + 11 | 0;
  i18 = i34 + 20 | 0;
  i19 = i35 + 28 | 0;
  i6 = i35 + 28 | 0;
  i20 = i32 + 4 | 0;
  i21 = i35 + 24 | 0;
  i22 = i35 + 20 | 0;
  i23 = i38 + 8 | 0;
  i24 = i32 + 4 | 0;
  i25 = i38 + 4 | 0;
  i26 = i35 + 16 | 0;
  i27 = i26 + 11 | 0;
  i28 = i32 + 4 | 0;
  i29 = i35 + 11 | 0;
  i30 = i32 + 4 | 0;
  i31 = i16 + 11 | 0;
  i4 = 0;
  do {
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i37, i34, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i37);
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i37, i8, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i37);
   i3 = HEAP8[i10 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i34 >> 2] | 0 : i34;
   i3 = i1 ? HEAP32[i11 >> 2] | 0 : i3 & 255;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   HEAP32[i35 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i35);
    i1 = HEAP32[i5 >> 2] | 0;
    i39 = 14;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i29 >> 0] = i3;
    if (!i3) i1 = i35; else {
     i1 = i35;
     i39 = 16;
    }
   } else i39 = 14;
   if ((i39 | 0) == 14) {
    i40 = i3 + 16 & -16;
    HEAP32[i32 >> 2] = 66;
    HEAP32[i13 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i40, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i35 >> 2] = i1;
    HEAP32[i14 >> 2] = i40 | -2147483648;
    HEAP32[i15 >> 2] = i3;
    i39 = 16;
   }
   if ((i39 | 0) == 16) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = HEAP8[i17 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
   i3 = i1 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i19 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
    i1 = HEAP32[i6 >> 2] | 0;
    i39 = 20;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i31 >> 0] = i3;
    if (!i3) i1 = i16; else {
     i1 = i16;
     i39 = 22;
    }
   } else i39 = 20;
   if ((i39 | 0) == 20) {
    i40 = i3 + 16 & -16;
    HEAP32[i32 >> 2] = 66;
    HEAP32[i20 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i40, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i21 >> 2] = i40 | -2147483648;
    HEAP32[i22 >> 2] = i3;
    i39 = 22;
   }
   if ((i39 | 0) == 22) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i38, i33, i35) | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i32 >> 2] = 1;
    HEAP32[i24 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i32, 0, gb + 1049224 | 0, 75) | 0;
    __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_(i1 + 16 | 0, i35);
    i2 = HEAP32[i33 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i38 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i38 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i25 >> 2] | 0, i1);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   }
   if ((HEAP8[i27 >> 0] | 0) < 0) {
    i40 = HEAP32[i26 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i32 >> 2] = 66;
    HEAP32[i28 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i32);
   }
   if ((HEAP8[i29 >> 0] | 0) < 0) {
    i40 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    HEAP32[i32 >> 2] = 66;
    HEAP32[i30 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i32);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i7 | 0));
  if ((HEAP8[i34 + 16 + 11 >> 0] | 0) < 0) {
   i40 = HEAP32[i34 + 16 >> 2] | 0;
   i39 = HEAP32[i34 + 28 >> 2] | 0;
   HEAP32[i32 >> 2] = 66;
   HEAP32[i32 + 4 >> 2] = i39;
   __Z19free_alloc_internalPvRK10MemLabelId(i40, i32);
  }
 }
 if ((HEAP8[i34 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i36;
  return;
 }
 i40 = HEAP32[i34 >> 2] | 0;
 i39 = HEAP32[i34 + 12 >> 2] | 0;
 HEAP32[i32 >> 2] = 66;
 HEAP32[i32 + 4 >> 2] = i39;
 __Z19free_alloc_internalPvRK10MemLabelId(i40, i32);
 STACKTOP = i36;
 return;
}

function __Z50CanvasRenderer_CUSTOM_SplitUIVertexStreamsInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_(i1, i5, i7, i8, i9, i6, i13) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i15;
 i14 = i15 + 8 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i1 + 8 >> 2] | 0, 0, 60) | 0;
 HEAP32[i14 >> 2] = 0;
 i10 = i14 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i3 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i12);
 i1 = (i2 + (i4 * 60 | 0) - i2 | 0) / 60 | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i11 >> 2] = i1 | -2147483648;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
 i2 = i5 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 12, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i19 = HEAP32[i1 >> 2] | 0;
   i18 = HEAP32[i1 + 4 >> 2] | 0;
   i17 = HEAP32[i1 + 8 >> 2] | 0;
   i16 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 12) | 0;
   HEAP32[i16 >> 2] = i19;
   HEAP32[i16 + 4 >> 2] = i18;
   HEAP32[i16 + 8 >> 2] = i17;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i5 + 12 >> 2] = HEAP32[i10 >> 2];
 i1 = i5 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
 i2 = i6 + 8 | 0;
 i19 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i19 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 12, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i16 = HEAP32[i1 + 12 >> 2] | 0;
   i17 = HEAP32[i1 + 16 >> 2] | 0;
   i18 = HEAP32[i1 + 20 >> 2] | 0;
   i19 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 12) | 0;
   HEAP32[i19 >> 2] = i16;
   HEAP32[i19 + 4 >> 2] = i17;
   HEAP32[i19 + 8 >> 2] = i18;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i6 + 12 >> 2] = HEAP32[i10 >> 2];
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0;
 i2 = i7 + 8 | 0;
 i19 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i19 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i19 = HEAP32[i1 + 24 >> 2] | 0;
   HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 4) | 0) >> 2] = i19;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 >> 2];
 i1 = i7 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i19 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i19 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i18 = i1 + 28 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   i19 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i19 >> 2] = i17;
   HEAP32[i19 + 4 >> 2] = i18;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 >> 2];
 i1 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i2 = i9 + 8 | 0;
 i19 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i19 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i18 = i1 + 36 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   i19 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i19 >> 2] = i17;
   HEAP32[i19 + 4 >> 2] = i18;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 >> 2];
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 460 >> 2] | 0;
 i2 = i13 + 8 | 0;
 i19 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i19 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 16, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i9 = HEAP32[i1 + 44 >> 2] | 0;
   i16 = HEAP32[i1 + 48 >> 2] | 0;
   i17 = HEAP32[i1 + 52 >> 2] | 0;
   i18 = HEAP32[i1 + 56 >> 2] | 0;
   i19 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 16) | 0;
   HEAP32[i19 >> 2] = i9;
   HEAP32[i19 + 4 >> 2] = i16;
   HEAP32[i19 + 8 >> 2] = i17;
   HEAP32[i19 + 12 >> 2] = i18;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i13 + 12 >> 2] = HEAP32[i10 >> 2];
 i19 = i13 + 16 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i12);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj(i28, i27, i7, i6, i5) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, f30 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 8 | 0;
 i26 = i29;
 i24 = i27 + 12 | 0;
 i19 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i24 >> 2] | 0, i7, i6, i5, i25) | 0;
 L1 : do if (!i19) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  i20 = i26 + 4 | 0;
  i21 = i27 + 4 | 0;
  i22 = i27 + 8 | 0;
  f1 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i23 = 0;
  while (1) {
   switch (__ZN5physx22getEdgeTriangleIndicesERKNS_2Gu11HeightFieldERKNS_8EdgeDataEPj(HEAP32[i24 >> 2] | 0, i25 + (i23 << 4) | 0, i26) | 0) {
   case 2:
    {
     i17 = HEAP32[i24 >> 2] | 0;
     i7 = HEAP32[i20 >> 2] | 0;
     i15 = (i7 & 1 | 0) == 0;
     i7 = i7 >>> 1;
     i16 = HEAP32[i17 + 36 >> 2] | 0;
     i5 = i16 + (i7 << 2) + 2 | 0;
     if ((HEAP8[(i15 ? i5 : i16 + (i7 << 2) + 3 | 0) >> 0] & 127) == 127) i18 = 23; else {
      i14 = (HEAP8[i5 >> 0] | 0) < 0;
      i5 = HEAP32[i17 + 20 >> 2] | 0;
      do if (i14) if (i15) {
       i11 = i5 + i7 | 0;
       i13 = i7;
       i6 = i7 + 1 + i5 | 0;
       break;
      } else {
       i13 = i7 + 1 | 0;
       i11 = i13;
       i13 = i5 + i13 | 0;
       i6 = i7;
       break;
      } else {
       i6 = i7 + 1 | 0;
       if (i15) {
        i11 = i7;
        i13 = i6;
        i6 = i5 + i7 | 0;
        break;
       } else {
        i11 = i5 + i6 | 0;
        i13 = i5 + i7 | 0;
        break;
       }
      } while (0);
      i11 = HEAP16[i16 + (i11 << 2) >> 1] | 0;
      i7 = HEAP16[i16 + (i13 << 2) >> 1] | 0;
      i5 = HEAP16[i16 + (i6 << 2) >> 1] | 0;
      i18 = Math_fround(HEAPF32[i17 + 40 >> 2]) >= Math_fround(0.0);
      f9 = i18 ? Math_fround(-1.0) : Math_fround(1.0);
      do if (i14) if (i15) {
       f8 = Math_fround(Math_fround(i7 - i11 | 0) * f9);
       f2 = Math_fround(f9 * Math_fround(i11 - i5 | 0));
       break;
      } else {
       f8 = Math_fround(Math_fround(i11 - i7 | 0) * f9);
       f2 = Math_fround(f9 * Math_fround(i5 - i11 | 0));
       break;
      } else if (i15) {
       f8 = Math_fround(f9 * Math_fround(i11 - i5 | 0));
       f2 = Math_fround(Math_fround(i11 - i7 | 0) * f9);
       break;
      } else {
       f8 = Math_fround(f9 * Math_fround(i5 - i11 | 0));
       f2 = Math_fround(Math_fround(i7 - i11 | 0) * f9);
       break;
      } while (0);
      f10 = Math_fround(f8 * Math_fround(HEAPF32[i27 >> 2]));
      f9 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
      f2 = Math_fround(f2 * Math_fround(HEAPF32[i22 >> 2]));
      f8 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f2 * f2));
      if (f8 > Math_fround(0.0)) {
       f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
       f12 = Math_fround(f2 * f30);
       f8 = Math_fround(f9 * f30);
       f2 = Math_fround(f10 * f30);
      } else {
       f12 = Math_fround(0.0);
       f8 = Math_fround(0.0);
       f2 = Math_fround(0.0);
      }
      f1 = Math_fround(f1 + f2);
      f3 = Math_fround(f3 + f8);
      f4 = Math_fround(f4 + f12);
      i18 = 23;
     }
     break;
    }
   case 1:
    {
     i17 = HEAP32[i24 >> 2] | 0;
     i16 = HEAP32[i17 + 36 >> 2] | 0;
     i18 = 23;
     break;
    }
   default:
    {}
   }
   if ((i18 | 0) == 23) {
    i18 = 0;
    i7 = HEAP32[i26 >> 2] | 0;
    i15 = (i7 & 1 | 0) == 0;
    i7 = i7 >>> 1;
    i5 = i16 + (i7 << 2) + 2 | 0;
    if ((HEAP8[(i15 ? i5 : i16 + (i7 << 2) + 3 | 0) >> 0] & 127) != 127) {
     i14 = (HEAP8[i5 >> 0] | 0) < 0;
     i5 = HEAP32[i17 + 20 >> 2] | 0;
     do if (i14) if (i15) {
      i11 = i5 + i7 | 0;
      i13 = i7;
      i6 = i7 + 1 + i5 | 0;
      break;
     } else {
      i13 = i7 + 1 | 0;
      i11 = i13;
      i13 = i5 + i13 | 0;
      i6 = i7;
      break;
     } else {
      i6 = i7 + 1 | 0;
      if (i15) {
       i11 = i7;
       i13 = i6;
       i6 = i5 + i7 | 0;
       break;
      } else {
       i11 = i5 + i6 | 0;
       i13 = i5 + i7 | 0;
       break;
      }
     } while (0);
     i11 = HEAP16[i16 + (i11 << 2) >> 1] | 0;
     i7 = HEAP16[i16 + (i13 << 2) >> 1] | 0;
     i5 = HEAP16[i16 + (i6 << 2) >> 1] | 0;
     i17 = Math_fround(HEAPF32[i17 + 40 >> 2]) >= Math_fround(0.0);
     f9 = i17 ? Math_fround(-1.0) : Math_fround(1.0);
     do if (i14) if (i15) {
      f8 = Math_fround(Math_fround(i7 - i11 | 0) * f9);
      f2 = Math_fround(f9 * Math_fround(i11 - i5 | 0));
      break;
     } else {
      f8 = Math_fround(Math_fround(i11 - i7 | 0) * f9);
      f2 = Math_fround(f9 * Math_fround(i5 - i11 | 0));
      break;
     } else if (i15) {
      f8 = Math_fround(f9 * Math_fround(i11 - i5 | 0));
      f2 = Math_fround(Math_fround(i11 - i7 | 0) * f9);
      break;
     } else {
      f8 = Math_fround(f9 * Math_fround(i5 - i11 | 0));
      f2 = Math_fround(Math_fround(i7 - i11 | 0) * f9);
      break;
     } while (0);
     f10 = Math_fround(f8 * Math_fround(HEAPF32[i27 >> 2]));
     f9 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
     f2 = Math_fround(f2 * Math_fround(HEAPF32[i22 >> 2]));
     f8 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f2 * f2));
     if (f8 > Math_fround(0.0)) {
      f30 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
      f2 = Math_fround(f2 * f30);
      f8 = Math_fround(f9 * f30);
      f9 = Math_fround(f10 * f30);
     } else {
      f2 = Math_fround(0.0);
      f8 = Math_fround(0.0);
      f9 = Math_fround(0.0);
     }
     f4 = Math_fround(f4 + f2);
     f3 = Math_fround(f3 + f8);
     f1 = Math_fround(f1 + f9);
    }
   }
   i23 = i23 + 1 | 0;
   if ((i23 | 0) == (i19 | 0)) break L1;
  }
 } while (0);
 f2 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1)));
 if (!(f2 > Math_fround(0.0))) {
  f30 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  HEAPF32[i28 >> 2] = f10;
  i27 = i28 + 4 | 0;
  HEAPF32[i27 >> 2] = f12;
  i28 = i28 + 8 | 0;
  HEAPF32[i28 >> 2] = f30;
  STACKTOP = i29;
  return;
 }
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
 f30 = Math_fround(f4 * f10);
 f12 = Math_fround(f3 * f10);
 f10 = Math_fround(f1 * f10);
 HEAPF32[i28 >> 2] = f10;
 i27 = i28 + 4 | 0;
 HEAPF32[i27 >> 2] = f12;
 i28 = i28 + 8 | 0;
 HEAPF32[i28 >> 2] = f30;
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu18intersectBoxConvexERKNS_13PxBoxGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i2, i3, i5, i6, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i1 + 560 | 0;
 i23 = i1 + 544 | 0;
 i19 = i1 + 464 | 0;
 i24 = i1 + 240 | 0;
 i8 = i1 + 480 | 0;
 i9 = i1 + 256 | 0;
 i10 = i1 + 80 | 0;
 i7 = i1 + 64 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 i33 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
 i18 = i19 + 4 | 0;
 HEAP32[i18 >> 2] = i15;
 i15 = i19 + 8 | 0;
 HEAP32[i15 >> 2] = i33;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 i33 = i6 + 12 | 0;
 i6 = HEAP32[i33 + 4 >> 2] | 0;
 i20 = HEAP32[i33 + 8 >> 2] | 0;
 i21 = HEAP32[i33 + 12 >> 2] | 0;
 HEAP32[i24 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i24 + 4 >> 2] = i6;
 HEAP32[i24 + 8 >> 2] = i20;
 HEAP32[i24 + 12 >> 2] = i21;
 i21 = HEAP32[i2 + 4 >> 2] | 0;
 i20 = HEAP32[i2 + 8 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 f17 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
 f27 = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
 f25 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f32 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i4 + 16 >> 2]));
 f26 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i4 + 20 >> 2]));
 f31 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f11 = Math_fround(f11 * Math_fround(2.0));
 f26 = Math_fround(f26 * Math_fround(2.0));
 f31 = Math_fround(Math_fround(f31 - Math_fround(HEAPF32[i4 + 24 >> 2])) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f11 * f17) + Math_fround(f26 * f27)) + Math_fround(f31 * f25));
 f12 = Math_fround(Math_fround(f16 * f17) + Math_fround(Math_fround(f28 * f11) + Math_fround(f32 * Math_fround(Math_fround(f31 * f27) - Math_fround(f26 * f25)))));
 f13 = Math_fround(Math_fround(f16 * f27) + Math_fround(Math_fround(f28 * f26) + Math_fround(f32 * Math_fround(Math_fround(f11 * f25) - Math_fround(f31 * f17)))));
 f16 = Math_fround(Math_fround(Math_fround(f28 * f31) + Math_fround(f32 * Math_fround(Math_fround(f26 * f17) - Math_fround(f11 * f27)))) + Math_fround(f16 * f25));
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f26 = Math_fround(f32 * f11);
 f31 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f31 * f17));
 f28 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f28 * f27));
 f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f26 = Math_fround(f26 - Math_fround(f30 * f25));
 f14 = Math_fround(Math_fround(Math_fround(f11 * f25) + Math_fround(Math_fround(f31 * f27) + Math_fround(f32 * f30))) - Math_fround(f28 * f17));
 f29 = Math_fround(Math_fround(Math_fround(f30 * f17) + Math_fround(Math_fround(f31 * f25) + Math_fround(f32 * f28))) - Math_fround(f11 * f27));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f31) - Math_fround(f11 * f17)) - Math_fround(f30 * f27)) - Math_fround(f28 * f25));
 HEAPF32[i8 + 48 >> 2] = f12;
 HEAPF32[i8 + 52 >> 2] = f13;
 HEAPF32[i8 + 56 >> 2] = f16;
 HEAPF32[i8 + 60 >> 2] = Math_fround(0.0);
 f16 = Math_fround(f26 + f26);
 f13 = Math_fround(f14 + f14);
 f12 = Math_fround(f29 + f29);
 f28 = Math_fround(f14 * f13);
 f27 = Math_fround(f29 * f12);
 f14 = Math_fround(f16 * f14);
 f30 = Math_fround(f16 * f29);
 f17 = Math_fround(f16 * f25);
 f29 = Math_fround(f29 * f13);
 f13 = Math_fround(f25 * f13);
 f12 = Math_fround(f25 * f12);
 f16 = Math_fround(Math_fround(1.0) - Math_fround(f26 * f16));
 f26 = Math_fround(f14 + f12);
 f25 = Math_fround(f30 - f13);
 f12 = Math_fround(f14 - f12);
 f14 = Math_fround(f16 - f27);
 f11 = Math_fround(f17 + f29);
 f13 = Math_fround(f30 + f13);
 f17 = Math_fround(f29 - f17);
 f16 = Math_fround(f16 - f28);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f28) - f27);
 HEAPF32[i8 + 4 >> 2] = f26;
 HEAPF32[i8 + 8 >> 2] = f25;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = f12;
 HEAPF32[i8 + 20 >> 2] = f14;
 HEAPF32[i8 + 24 >> 2] = f11;
 HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 32 >> 2] = f13;
 HEAPF32[i8 + 36 >> 2] = f17;
 HEAPF32[i8 + 40 >> 2] = f16;
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i9, i5 + 16 | 0, i23, i19, i24);
 i4 = i10 + 64 | 0;
 HEAP32[i10 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAP32[i10 + 80 >> 2] = 3;
 HEAPF32[i10 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i10 + 144 >> 2] = i21;
 HEAP32[i10 + 148 >> 2] = i20;
 HEAP32[i10 + 152 >> 2] = i6;
 HEAPF32[i10 + 156 >> 2] = Math_fround(0.0);
 f16 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = f16 <= f17 ? f16 : f17;
 f13 = f17 <= f13 ? f17 : f13;
 HEAPF32[i10 + 16 >> 2] = Math_fround(f13 * Math_fround(.150000006));
 HEAPF32[i10 + 32 >> 2] = Math_fround(f13 * Math_fround(.0500000007));
 f17 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 72 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 76 >> 2]);
 f14 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(HEAPF32[i18 >> 2]);
 f14 = Math_fround(f17 * f14);
 f12 = Math_fround(f16 * f12);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2]));
 f12 = f14 <= f12 ? f14 : f12;
 f11 = Math_fround(Math_fround(f13 * Math_fround(.00999999977)) + Math_fround((f12 <= f11 ? f12 : f11) * Math_fround(.00999999977)));
 HEAPF32[i7 >> 2] = Math_fround(f11 * f11);
 i6 = (__ZN5physx2Gu22GJKRelativeTesselationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i10, i9, i8, i7, i1 + 48 | 0, i1 + 32 | 0, i1 + 16 | 0, i1) | 0) == 1;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass(i15, i4) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i12 = i16;
 i14 = i15 + 404 | 0;
 i10 = i15 + 408 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i2 | 0) {
  i1 = i10;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) if (i4 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   i15 = HEAP16[i1 + 20 >> 1] | 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 if (!i4) i1 = 0; else {
  i1 = i4;
  do {
   i9 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
   i11 = (i9 | 0) == 0;
   i1 = i11 ? i1 : i9;
  } while ((i1 | 0) != 0 & (i11 ^ 1));
 }
 i11 = __ZN9Scripting29GetFirstNonGenericParentClassEP11Il2CppClassS1_(i4, i1) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i3 | 0) {
  i2 = i10;
  L18 : while (1) {
   i4 = i3;
   while (1) {
    if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i11 >>> 0) break;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i3) break L18; else i4 = i3;
   }
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) {
    i2 = i4;
    break;
   } else i2 = i4;
  }
  if ((i2 | 0) != (i10 | 0)) if (i11 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   i15 = HEAP16[i2 + 20 >> 1] | 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 i3 = i15 + 420 | 0;
 i9 = i15 + 432 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i4 = i8 + 1 | 0;
 i5 = i15 + 436 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i2 = i6 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 * 40 | 0, 4, i15 + 424 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i15 + 424 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i3 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i4;
 i2 = HEAP32[i3 >> 2] | 0;
 i7 = i2 + (i8 * 40 | 0) | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i13, gb + 582763 | 0, i11, i1);
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP8[i7 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
 i3 = i2 + (i8 * 40 | 0) + 8 | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i13, gb + 582776 | 0, i11, i1);
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP8[i3 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
 i4 = i2 + (i8 * 40 | 0) + 16 | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i13, gb + 582789 | 0, i11, i1);
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
 i5 = i2 + (i8 * 40 | 0) + 24 | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i13, gb + 582799 | 0, i11, i1);
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
 i2 = i2 + (i8 * 40 | 0) + 32 | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i13, gb + 582814 | 0, i11, i1);
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
 if (!(HEAP32[i7 >> 2] | 0)) if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i4 >> 2] | 0)) if (!(HEAP32[i5 >> 2] | 0)) if (!(HEAP32[i2 >> 2] | 0)) {
  i5 = i11;
  i1 = HEAP32[i10 >> 2] | 0;
  do if (!i1) {
   HEAP32[i12 >> 2] = i10;
   i2 = i10;
   i3 = i10;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i11 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 32;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i11 >>> 0) {
      i4 = 37;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 36;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 32) {
    HEAP32[i12 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 36) {
    HEAP32[i12 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 37) {
    HEAP32[i12 >> 2] = i1;
    i2 = i1;
    i3 = i12;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = HEAP32[i15 + 412 >> 2] | 0;
   HEAP32[i13 >> 2] = 83;
   HEAP32[i13 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   HEAP16[i1 + 20 >> 1] = -1;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i14 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 + 408 >> 2] | 0, i1);
   i15 = i15 + 416 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  }
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  i15 = -1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i6 = HEAP32[i9 >> 2] & 65535;
 i5 = i11;
 i1 = HEAP32[i10 >> 2] | 0;
 do if (!i1) {
  HEAP32[i12 >> 2] = i10;
  i2 = i10;
  i3 = i10;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i11 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i4 = 47;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i11 >>> 0) {
     i4 = 52;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i4 = 51;
     break;
    } else i1 = i2;
   }
  }
  if ((i4 | 0) == 47) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i4 | 0) == 51) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i4 | 0) == 52) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   i3 = i12;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i15 + 412 >> 2] | 0;
  HEAP32[i13 >> 2] = 83;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = i5;
  HEAP16[i1 + 20 >> 1] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i14 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 + 408 >> 2] | 0, i1);
  i15 = i15 + 416 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 i15 = i6;
 STACKTOP = i16;
 return i15 | 0;
}

function __Z13RotateTowardsRK8Vector3fS1_ff(i22, i2, i5, f7, f21) {
 i22 = i22 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 f7 = Math_fround(f7);
 f21 = Math_fround(f21);
 var f1 = f0, f3 = f0, f4 = f0, f6 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i23 + 36 | 0;
 i16 = i23;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(f18 * f18);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f17 * f17));
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(Math_sqrt(Math_fround(f20 + Math_fround(f15 * f15))));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f19 = Math_fround(f10 * f10);
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f11 * f11));
 f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f19 = Math_fround(Math_sqrt(Math_fround(f19 + Math_fround(f9 * f9))));
 if (!(f20 > Math_fround(9.99999974e-06) & f19 > Math_fround(9.99999974e-06))) {
  f3 = Math_fround(f10 - f18);
  f4 = Math_fround(f11 - f17);
  f6 = Math_fround(f9 - f15);
  f1 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f6 * f6));
  if (!(f1 > Math_fround(f21 * f21))) {
   HEAPF32[i22 >> 2] = f10;
   HEAPF32[i22 + 4 >> 2] = f11;
   HEAPF32[i22 + 8 >> 2] = f9;
   STACKTOP = i23;
   return;
  }
  f1 = Math_fround(Math_sqrt(Math_fround(f1)));
  if (f1 > Math_fround(9.99999974e-06)) {
   f19 = Math_fround(f17 + Math_fround(Math_fround(f4 / f1) * f21));
   f20 = Math_fround(f15 + Math_fround(Math_fround(f6 / f1) * f21));
   HEAPF32[i22 >> 2] = Math_fround(f18 + Math_fround(Math_fround(f3 / f1) * f21));
   HEAPF32[i22 + 4 >> 2] = f19;
   HEAPF32[i22 + 8 >> 2] = f20;
   STACKTOP = i23;
   return;
  } else {
   HEAPF32[i22 >> 2] = f18;
   HEAPF32[i22 + 4 >> 2] = f17;
   HEAPF32[i22 + 8 >> 2] = f15;
   STACKTOP = i23;
   return;
  }
 }
 f12 = Math_fround(f18 / f20);
 f13 = Math_fround(f17 / f20);
 f14 = Math_fround(f15 / f20);
 f1 = Math_fround(f10 / f19);
 f3 = Math_fround(f11 / f19);
 f4 = Math_fround(f9 / f19);
 f6 = Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f12 * f1) + Math_fround(f13 * f3)));
 if (f6 > Math_fround(.999989986)) {
  f3 = Math_fround(f10 - f18);
  f4 = Math_fround(f11 - f17);
  f6 = Math_fround(f9 - f15);
  f1 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f6 * f6));
  if (!(f1 > Math_fround(f21 * f21))) {
   HEAPF32[i22 >> 2] = f10;
   HEAPF32[i22 + 4 >> 2] = f11;
   HEAPF32[i22 + 8 >> 2] = f9;
   STACKTOP = i23;
   return;
  }
  f1 = Math_fround(Math_sqrt(Math_fround(f1)));
  if (f1 > Math_fround(9.99999974e-06)) {
   f19 = Math_fround(f17 + Math_fround(Math_fround(f4 / f1) * f21));
   f20 = Math_fround(f15 + Math_fround(Math_fround(f6 / f1) * f21));
   HEAPF32[i22 >> 2] = Math_fround(f18 + Math_fround(Math_fround(f3 / f1) * f21));
   HEAPF32[i22 + 4 >> 2] = f19;
   HEAPF32[i22 + 8 >> 2] = f20;
   STACKTOP = i23;
   return;
  } else {
   HEAPF32[i22 >> 2] = f18;
   HEAPF32[i22 + 4 >> 2] = f17;
   HEAPF32[i22 + 8 >> 2] = f15;
   STACKTOP = i23;
   return;
  }
 }
 if (!(f6 < Math_fround(-.999989986))) {
  f6 = Math_fround(+Math_acos(+f6));
  f17 = Math_fround(Math_fround(f13 * f4) - Math_fround(f14 * f3));
  f18 = Math_fround(Math_fround(f14 * f1) - Math_fround(f12 * f4));
  f3 = Math_fround(Math_fround(f12 * f3) - Math_fround(f13 * f1));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)))));
  HEAPF32[i8 >> 2] = Math_fround(f17 / f4);
  HEAPF32[i8 + 4 >> 2] = Math_fround(f18 / f4);
  HEAPF32[i8 + 8 >> 2] = Math_fround(f3 / f4);
  __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff(i16, i8, f6 < f7 ? f6 : f7) | 0;
  f4 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 12 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 24 >> 2])));
  HEAPF32[i22 >> 2] = f4;
  f6 = Math_fround(f12 * Math_fround(HEAPF32[i16 + 4 >> 2]));
  f6 = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 16 >> 2])));
  f6 = Math_fround(f6 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 28 >> 2])));
  i5 = i22 + 4 | 0;
  HEAPF32[i5 >> 2] = f6;
  f3 = Math_fround(f12 * Math_fround(HEAPF32[i16 + 8 >> 2]));
  f3 = Math_fround(f3 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 20 >> 2])));
  f3 = Math_fround(f3 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 32 >> 2])));
  i2 = i22 + 8 | 0;
  HEAPF32[i2 >> 2] = f3;
  f1 = Math_fround(f19 - f20);
  if (f1 > Math_fround(0.0)) f1 = Math_fround(f20 + (f1 > f21 ? f21 : f1)); else {
   f1 = Math_fround(-f1);
   f1 = Math_fround(f20 - (f21 < f1 ? f21 : f1));
  }
  HEAPF32[i22 >> 2] = Math_fround(f1 * f4);
  HEAPF32[i5 >> 2] = Math_fround(f1 * f6);
  HEAPF32[i2 >> 2] = Math_fround(f1 * f3);
  STACKTOP = i23;
  return;
 }
 i5 = f14 < Math_fround(0.0);
 f18 = Math_fround(-f14);
 if ((i5 ? f18 : f14) > Math_fround(.707106769)) {
  f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)))));
  f1 = Math_fround(f13 * f3);
  f3 = Math_fround(-Math_fround(f14 * f3));
  f4 = Math_fround(0.0);
 } else {
  f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(f13 * f13)))));
  f1 = Math_fround(0.0);
  f3 = Math_fround(f12 * f4);
  f4 = Math_fround(-Math_fround(f13 * f4));
 }
 HEAPF32[i8 >> 2] = f4;
 HEAPF32[i8 + 4 >> 2] = f3;
 HEAPF32[i8 + 8 >> 2] = f1;
 __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff(i16, i8, f7) | 0;
 f4 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 12 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 HEAPF32[i22 >> 2] = f4;
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 28 >> 2])));
 i5 = i22 + 4 | 0;
 HEAPF32[i5 >> 2] = f6;
 f3 = Math_fround(f12 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f3 = Math_fround(f3 + Math_fround(f13 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f3 = Math_fround(f3 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 i2 = i22 + 8 | 0;
 HEAPF32[i2 >> 2] = f3;
 f1 = Math_fround(f19 - f20);
 if (f1 > Math_fround(0.0)) f1 = Math_fround(f20 + (f1 > f21 ? f21 : f1)); else {
  f1 = Math_fround(-f1);
  f1 = Math_fround(f20 - (f21 < f1 ? f21 : f1));
 }
 HEAPF32[i22 >> 2] = Math_fround(f1 * f4);
 HEAPF32[i5 >> 2] = Math_fround(f1 * f6);
 HEAPF32[i2 >> 2] = Math_fround(f1 * f3);
 STACKTOP = i23;
 return;
}

function __ZN11AudioSource16UpdateParametersE12SoundChannel(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 48 | 0;
 i12 = i13 + 36 | 0;
 i9 = i13 + 24 | 0;
 i4 = i13 + 12 | 0;
 i6 = i13 + 8 | 0;
 i7 = i13 + 4 | 0;
 i10 = i13;
 HEAP8[i3 >> 0] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 if ((__ZN20SoundChannelInstance9isPlayingEPb(i1, i3) | 0) == 36) {
  STACKTOP = i13;
  return;
 }
 i3 = i11 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 67048 | 0) | 0;
 if (!i1) {
  f15 = Math_fround(HEAPF32[i12 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i11 + 504 >> 2]));
  f2 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i11 + 508 >> 2]));
  f5 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i11 + 512 >> 2]));
  f14 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
  f2 = Math_fround(f2 * f14);
  f5 = Math_fround(f5 * f14);
  HEAPF32[i9 >> 2] = Math_fround(f15 * f14);
  HEAPF32[i9 + 4 >> 2] = f2;
  HEAPF32[i9 + 8 >> 2] = f5;
 } else {
  i16 = __Z11GetIPhysicsv() | 0;
  mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i16 | 0, i1 | 0);
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance15set3DAttributesEPK11FMOD_VECTORS2_(i1, i12, i9) | 0;
 i1 = __ZNK12AudioManager16GetAudioListenerEv(__Z15GetAudioManagerv() | 0) | 0;
 if (!i1) f5 = Math_fround(0.0); else {
  f14 = Math_fround(HEAPF32[i12 >> 2]);
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i1 + 36 >> 2]));
  f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i1 + 40 >> 2]));
  f5 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 44 >> 2]));
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f5 * f5))));
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 171428 | 0) | 0;
 if (i3 | 0) {
  i1 = __ZNK18AudioLowPassFilter26GetCustomLowpassLevelCurveEv(i3) | 0;
  f2 = Math_fround(HEAPF32[i11 + 400 >> 2]);
  if (f2 > Math_fround(0.0) ? (HEAP32[i1 + 68 >> 2] | 0) != 1 : 0) f2 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i1, Math_fround(f5 / f2), 0)); else f2 = Math_fround(HEAPF32[(HEAP32[i1 + 56 >> 2] | 0) + 4 >> 2]);
  i16 = f2 < Math_fround(0.0);
  i4 = f2 > Math_fround(1.0);
  f15 = Math_fround(Math_fround((i4 ? Math_fround(1.0) : f2) * Math_fround(21990.0)) + Math_fround(10.0));
  __ZN18AudioLowPassFilter26SetCutoffFrequencyInternalEf(i3, i16 ? Math_fround(10.0) : f15);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN11AudioSource21Update3DPanParametersE12SoundChannelf(i11, i6, f5);
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN11AudioSource19UpdateReverbZoneMixE12SoundChannelf(i11, i7, f5);
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i7 >> 2] = 0;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 }
 HEAP32[i10 >> 2] = i1;
 __ZN11AudioSource13UpdateDopplerE12SoundChannelfR8Vector3fS2_(i11, i10, f5, i12, i9);
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 if (i1 | 0) {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i10 >> 2] = 0;
 }
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  __ZN11AudioSource17UpdateSpatializerE12SoundChannelf(i11, 0, Math_fround(0.0));
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 } else {
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  __ZN11AudioSource17UpdateSpatializerE12SoundChannelf(i11, 0, Math_fround(0.0));
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
  i16 = i1 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
 }
 i16 = i11 + 504 | 0;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 __ZN11AudioSource9SetVolumeEf(i11, Math_fround(HEAPF32[i11 + 412 >> 2]));
 STACKTOP = i13;
 return;
}

function __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i16, i20, i21, i1) {
 i16 = i16 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 i14 = i23 + 12 | 0;
 i15 = i20 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 i7 = i16 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i19 = f24 > Math_fround(HEAPF32[i14 + 8 >> 2]);
 i9 = i21 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = f24 > Math_fround(HEAPF32[i14 + 8 >> 2]);
 if (!i19) {
  if (!i1) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i20 >> 2] | 0;
  i9 = i20 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i10 = i20 + 8 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i11 = i20 + 12 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i12 = i20 + 16 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i13 = i20 + 20 | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  i8 = i20 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i17 = i20;
  i18 = i21;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i3;
  HEAP32[i21 + 12 >> 2] = i4;
  HEAP32[i21 + 16 >> 2] = i5;
  HEAP32[i21 + 20 >> 2] = i6;
  i21 = i21 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f24 > Math_fround(HEAPF32[i14 + 8 >> 2]))) {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = HEAP32[i16 + 8 >> 2] | 0;
  i4 = HEAP32[i16 + 12 >> 2] | 0;
  i5 = HEAP32[i16 + 16 >> 2] | 0;
  i6 = HEAP32[i16 + 20 >> 2] | 0;
  i17 = i16 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i16;
  i18 = i20;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i20 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i22 = 2;
  STACKTOP = i23;
  return i22 | 0;
 }
 if (i1) {
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = HEAP32[i16 + 8 >> 2] | 0;
  i4 = HEAP32[i16 + 12 >> 2] | 0;
  i5 = HEAP32[i16 + 16 >> 2] | 0;
  i6 = HEAP32[i16 + 20 >> 2] | 0;
  i17 = i16 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i16;
  i18 = i21;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i3;
  HEAP32[i21 + 12 >> 2] = i4;
  HEAP32[i21 + 16 >> 2] = i5;
  HEAP32[i21 + 20 >> 2] = i6;
  i21 = i21 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i16 + 4 >> 2] | 0;
 i3 = HEAP32[i16 + 8 >> 2] | 0;
 i4 = HEAP32[i16 + 12 >> 2] | 0;
 i5 = HEAP32[i16 + 16 >> 2] | 0;
 i8 = HEAP32[i16 + 20 >> 2] | 0;
 i17 = i16 + 24 | 0;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i17 = i16;
 i18 = i20;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i20 >> 2] = i1;
 i1 = i20 + 4 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i20 + 8 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i20 + 12 | 0;
 HEAP32[i3 >> 2] = i4;
 i6 = i20 + 16 | 0;
 HEAP32[i6 >> 2] = i5;
 i7 = i20 + 20 | 0;
 HEAP32[i7 >> 2] = i8;
 i8 = i20 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f24 > Math_fround(HEAPF32[i14 + 8 >> 2]))) {
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 i9 = HEAP32[i20 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i17 = i20;
 i18 = i21;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i21 >> 2] = i9;
 HEAP32[i21 + 4 >> 2] = i5;
 HEAP32[i21 + 8 >> 2] = i4;
 HEAP32[i21 + 12 >> 2] = i3;
 HEAP32[i21 + 16 >> 2] = i2;
 HEAP32[i21 + 20 >> 2] = i1;
 i21 = i21 + 24 | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 i22 = 2;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN5physx2Gu29ConvexVsMeshContactGenerationC2ERNS0_9ContainerERKNS_11PxTransformES6_RKNS0_13PolygonalDataERKNS_2Cm8Matrix34ESD_RKNSA_23FastVertex2ShapeScalingEfbfS6_S6_RNS0_13ContactBufferE(i27, i10, i5, i6, i26, i1, i14, i9, f8, i11, f4, i12, i13, i7) {
 i27 = i27 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i9 = i9 | 0;
 f8 = Math_fround(f8);
 i11 = i11 | 0;
 f4 = Math_fround(f4);
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 HEAP32[i27 >> 2] = i10;
 HEAP32[i27 + 1284 >> 2] = 0;
 i2 = i27 + 1156 | 0;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 255;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i27 + 2056 >> 2] = 0;
 i2 = i27 + 1928 | 0;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 255;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f35 = Math_fround(HEAPF32[i5 >> 2]);
 f30 = Math_fround(f35 + f35);
 f29 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f34 = Math_fround(f29 + f29);
 f37 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f36 = Math_fround(f37 + f37);
 f31 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f32 = Math_fround(f30 * f31);
 f38 = Math_fround(f34 * f31);
 f31 = Math_fround(f31 * f36);
 f30 = Math_fround(f35 * f30);
 f33 = Math_fround(f35 * f34);
 f35 = Math_fround(f35 * f36);
 f34 = Math_fround(f29 * f34);
 f29 = Math_fround(f29 * f36);
 f36 = Math_fround(f37 * f36);
 i15 = i27 + 2060 | 0;
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f34) - f36);
 i16 = i27 + 2064 | 0;
 HEAPF32[i16 >> 2] = Math_fround(f33 + f31);
 i17 = i27 + 2068 | 0;
 HEAPF32[i17 >> 2] = Math_fround(f35 - f38);
 i18 = i27 + 2072 | 0;
 HEAPF32[i18 >> 2] = Math_fround(f33 - f31);
 f30 = Math_fround(Math_fround(1.0) - f30);
 i19 = i27 + 2076 | 0;
 HEAPF32[i19 >> 2] = Math_fround(f30 - f36);
 i20 = i27 + 2080 | 0;
 HEAPF32[i20 >> 2] = Math_fround(f29 + f32);
 i21 = i27 + 2084 | 0;
 HEAPF32[i21 >> 2] = Math_fround(f35 + f38);
 i22 = i27 + 2088 | 0;
 HEAPF32[i22 >> 2] = Math_fround(f29 - f32);
 i23 = i27 + 2092 | 0;
 HEAPF32[i23 >> 2] = Math_fround(f30 - f34);
 i24 = i27 + 2096 | 0;
 HEAPF32[i24 >> 2] = Math_fround(0.0);
 i25 = i27 + 2100 | 0;
 HEAPF32[i25 >> 2] = Math_fround(0.0);
 i3 = i27 + 2104 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 2096 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i25 >> 2] = HEAP32[i5 + 20 >> 2];
 i28 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = i28;
 f34 = Math_fround(HEAPF32[i6 >> 2]);
 f30 = Math_fround(f34 + f34);
 f32 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f29 = Math_fround(f32 + f32);
 f38 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f35 = Math_fround(f38 + f38);
 f36 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f31 = Math_fround(f30 * f36);
 f33 = Math_fround(f29 * f36);
 f36 = Math_fround(f36 * f35);
 f30 = Math_fround(f34 * f30);
 f37 = Math_fround(f34 * f29);
 f34 = Math_fround(f34 * f35);
 f29 = Math_fround(f32 * f29);
 f32 = Math_fround(f32 * f35);
 f35 = Math_fround(f38 * f35);
 HEAPF32[i27 + 2108 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f29) - f35);
 HEAPF32[i27 + 2112 >> 2] = Math_fround(f37 + f36);
 HEAPF32[i27 + 2116 >> 2] = Math_fround(f34 - f33);
 HEAPF32[i27 + 2120 >> 2] = Math_fround(f37 - f36);
 f30 = Math_fround(Math_fround(1.0) - f30);
 HEAPF32[i27 + 2124 >> 2] = Math_fround(f30 - f35);
 HEAPF32[i27 + 2128 >> 2] = Math_fround(f32 + f31);
 HEAPF32[i27 + 2132 >> 2] = Math_fround(f34 + f33);
 HEAPF32[i27 + 2136 >> 2] = Math_fround(f32 - f31);
 HEAPF32[i27 + 2140 >> 2] = Math_fround(f30 - f29);
 HEAPF32[i27 + 2144 >> 2] = Math_fround(0.0);
 i5 = i27 + 2148 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i3 = i27 + 2152 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAP32[i27 + 2144 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 + 24 >> 2];
 i3 = i27 + 2180 | 0;
 HEAP32[i3 >> 2] = i26;
 i5 = i27 + 2184 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i27 + 2188 >> 2] = i14;
 HEAP32[i27 + 2192 >> 2] = i9;
 HEAPF32[i27 + 2196 >> 2] = f8;
 HEAP8[i27 + 2201 >> 0] = i11 & 1;
 HEAPF32[i27 + 2204 >> 2] = f4;
 HEAP32[i27 + 2208 >> 2] = i12;
 HEAP32[i27 + 2212 >> 2] = i13;
 HEAP32[i27 + 2216 >> 2] = i7;
 i2 = i10 + 4 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!(HEAP32[i2 >> 2] | 0)) i2 = i26; else {
  HEAP32[i2 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP8[i27 + 2220 >> 0] = 0;
 f38 = Math_fround(HEAPF32[i2 >> 2]);
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i15 >> 2]));
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i16 >> 2]));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i17 >> 2]));
 i26 = i2 + 4 | 0;
 f35 = Math_fround(HEAPF32[i26 >> 2]);
 f34 = Math_fround(f35 * Math_fround(HEAPF32[i18 >> 2]));
 f33 = Math_fround(f35 * Math_fround(HEAPF32[i19 >> 2]));
 f34 = Math_fround(f37 + f34);
 f33 = Math_fround(f36 + f33);
 f35 = Math_fround(f38 + Math_fround(f35 * Math_fround(HEAPF32[i20 >> 2])));
 i28 = i2 + 8 | 0;
 f38 = Math_fround(HEAPF32[i28 >> 2]);
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i21 >> 2]));
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i22 >> 2]));
 f36 = Math_fround(f34 + f36);
 f37 = Math_fround(f33 + f37);
 f38 = Math_fround(f35 + Math_fround(f38 * Math_fround(HEAPF32[i23 >> 2])));
 f36 = Math_fround(f36 + Math_fround(HEAPF32[i24 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i25 >> 2]));
 f38 = Math_fround(f38 + f4);
 HEAPF32[i27 + 2156 >> 2] = f36;
 HEAPF32[i27 + 2160 >> 2] = f37;
 HEAPF32[i27 + 2164 >> 2] = f38;
 f38 = Math_fround(HEAPF32[i2 >> 2]);
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i1 >> 2]));
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f35 = Math_fround(HEAPF32[i26 >> 2]);
 f33 = Math_fround(f35 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f34 = Math_fround(f35 * Math_fround(HEAPF32[i1 + 16 >> 2]));
 f33 = Math_fround(f37 + f33);
 f34 = Math_fround(f36 + f34);
 f35 = Math_fround(f38 + Math_fround(f35 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f38 = Math_fround(HEAPF32[i28 >> 2]);
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 24 >> 2]));
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i1 + 28 >> 2]));
 f36 = Math_fround(f33 + f36);
 f37 = Math_fround(f34 + f37);
 f38 = Math_fround(f35 + Math_fround(f38 * Math_fround(HEAPF32[i1 + 32 >> 2])));
 f36 = Math_fround(f36 + Math_fround(HEAPF32[i1 + 36 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i1 + 40 >> 2]));
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i1 + 44 >> 2]));
 HEAPF32[i27 + 2168 >> 2] = f36;
 HEAPF32[i27 + 2172 >> 2] = f37;
 HEAPF32[i27 + 2176 >> 2] = f38;
 return;
}

function __ZN18ProceduralMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 16 | 0;
 i12 = i17;
 __ZN8Material8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13, i14);
 i1 = i13 + 112 | 0;
 i15 = i14 + 16 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i16 = i14 + 24 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i1, 4);
  i4 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = i13 + 116 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i1, 4);
  i3 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = i13 + 120 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i14);
 i3 = i13 + 124 | 0;
 i7 = i13 + 128 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 HEAP32[i11 >> 2] = i4;
 i5 = HEAP32[i15 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i15 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i11, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI17ProceduralTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i14);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i13 + 172 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i15 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i4, 4);
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -131073;
 i1 = i13 + 256 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 i5 = i2 + 4 | 0;
 if (i5 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i15 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i11, 4);
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 __ZN4PPtrI16SubstanceArchiveE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i13 + 108 | 0, i14);
 i3 = i13 + 176 | 0;
 i7 = i13 + 180 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 156 | 0;
 HEAP32[i11 >> 2] = i4;
 i5 = HEAP32[i15 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i15 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i11, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SubstanceInput8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i14);
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i13 + 156 | 0;
 i8 = i7 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i9 = i13 + 160 | 0;
 i2 = i1 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i1 & 255;
 HEAP32[i11 >> 2] = i2;
 i3 = HEAP32[i15 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i15 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i11, 4);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 i6 = i1 << 24 >> 24 < 0;
 i2 = i6 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i6 ? HEAP32[i9 >> 2] | 0 : i1 & 255;
 i3 = i2 + i6 | 0;
 if (i6 | 0) {
  i1 = i2;
  do {
   i2 = HEAP32[i15 >> 2] | 0;
   if ((i2 + 1 | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i1, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i14);
 i6 = HEAP8[i8 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i6 & 255) | 0)) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i12 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i10 = 38;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i12 + 11 >> 0] = i3;
   if (!i3) i1 = i12; else {
    i1 = i12;
    i10 = 40;
   }
  } else i10 = 38;
  if ((i10 | 0) == 38) {
   i6 = i3 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i6 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i3;
   i10 = 40;
  }
  if ((i10 | 0) == 40) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i12 + 11 | 0;
  do if ((i7 | 0) != (i12 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
   i6 = i1 ? HEAP32[i12 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i8 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i13 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i9 >> 2] = i6;
    break;
   } else {
    HEAP8[i8 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i10 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
  }
 }
 i1 = i13 + 264 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 >> 2] = i3;
  i16 = i13 + 240 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i16, i14);
  STACKTOP = i17;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i15, i1, 4);
  i16 = i13 + 240 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i16, i14);
  STACKTOP = i17;
  return;
 }
}

function __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i16, i20, i21, i1) {
 i16 = i16 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 i14 = i23 + 12 | 0;
 i15 = i20 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 i7 = i16 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i19 = f24 < Math_fround(HEAPF32[i14 + 8 >> 2]);
 i9 = i21 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = f24 < Math_fround(HEAPF32[i14 + 8 >> 2]);
 if (!i19) {
  if (!i1) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i20 >> 2] | 0;
  i9 = i20 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i10 = i20 + 8 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i11 = i20 + 12 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i12 = i20 + 16 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i13 = i20 + 20 | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  i8 = i20 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i17 = i20;
  i18 = i21;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i3;
  HEAP32[i21 + 12 >> 2] = i4;
  HEAP32[i21 + 16 >> 2] = i5;
  HEAP32[i21 + 20 >> 2] = i6;
  i21 = i21 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f24 < Math_fround(HEAPF32[i14 + 8 >> 2]))) {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = HEAP32[i16 + 8 >> 2] | 0;
  i4 = HEAP32[i16 + 12 >> 2] | 0;
  i5 = HEAP32[i16 + 16 >> 2] | 0;
  i6 = HEAP32[i16 + 20 >> 2] | 0;
  i17 = i16 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i16;
  i18 = i20;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i20 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i22 = 2;
  STACKTOP = i23;
  return i22 | 0;
 }
 if (i1) {
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = HEAP32[i16 + 8 >> 2] | 0;
  i4 = HEAP32[i16 + 12 >> 2] | 0;
  i5 = HEAP32[i16 + 16 >> 2] | 0;
  i6 = HEAP32[i16 + 20 >> 2] | 0;
  i17 = i16 + 24 | 0;
  HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i16;
  i18 = i21;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i3;
  HEAP32[i21 + 12 >> 2] = i4;
  HEAP32[i21 + 16 >> 2] = i5;
  HEAP32[i21 + 20 >> 2] = i6;
  i21 = i21 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i16 + 4 >> 2] | 0;
 i3 = HEAP32[i16 + 8 >> 2] | 0;
 i4 = HEAP32[i16 + 12 >> 2] | 0;
 i5 = HEAP32[i16 + 16 >> 2] | 0;
 i8 = HEAP32[i16 + 20 >> 2] | 0;
 i17 = i16 + 24 | 0;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i17 = i16;
 i18 = i20;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i20 >> 2] = i1;
 i1 = i20 + 4 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i20 + 8 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i20 + 12 | 0;
 HEAP32[i3 >> 2] = i4;
 i6 = i20 + 16 | 0;
 HEAP32[i6 >> 2] = i5;
 i7 = i20 + 20 | 0;
 HEAP32[i7 >> 2] = i8;
 i8 = i20 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f24 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f24 < Math_fround(HEAPF32[i14 + 8 >> 2]))) {
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 i9 = HEAP32[i20 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i17 = i20;
 i18 = i21;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i21 >> 2] = i9;
 HEAP32[i21 + 4 >> 2] = i5;
 HEAP32[i21 + 8 >> 2] = i4;
 HEAP32[i21 + 12 >> 2] = i3;
 HEAP32[i21 + 16 >> 2] = i2;
 HEAP32[i21 + 20 >> 2] = i1;
 i21 = i21 + 24 | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 i22 = 2;
 STACKTOP = i23;
 return i22 | 0;
}

function __Z47ParticleSystemRenderer_RenderMultipleBillboardsRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i22, i23, i27) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, d36 = 0.0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i35 + 8 | 0;
 i2 = i35;
 i31 = i35 + 24 | 0;
 d36 = +_emscripten_get_now() * 1.0e6;
 i32 = ~~d36 >>> 0;
 i33 = +Math_abs(d36) >= 1.0 ? (d36 > 0.0 ? ~~+Math_min(+Math_floor(d36 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d36 - +(~~d36 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i34 = __Z12GetGfxDevicev() | 0;
 i26 = __ZN9GfxDevice13GetDynamicVBOEv(i34) | 0;
 i29 = gb + 64016 | 0;
 i28 = HEAP32[i29 + 4 >> 2] | 0;
 i25 = i2;
 HEAP32[i25 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i25 + 4 >> 2] = i28;
 HEAP32[i31 >> 2] = 0;
 i25 = i31 + 12 | 0;
 HEAP32[i25 >> 2] = 0;
 i28 = i31 + 16 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i31 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i30, i2);
 i2 = i30;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i24 = i29;
 HEAP32[i24 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i24 + 4 >> 2] = i1;
 i24 = i23 + 4 | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i2 = i1 << 1;
 if (i2 | 0) {
  HEAP32[i28 >> 2] = i2;
  HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 40 | 0, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
 }
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = -1;
 HEAP32[i30 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 104 >> 2] | 0, i34 | 0, gb + 1162292 | 0, 0);
 if (!(HEAP32[i24 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = 0;
  i3 = 0;
  i1 = 0;
  do {
   i21 = __Z34ParticleSystemRenderer_RenderTrailRK15RenderNodeQueueRK17BatchInstanceDataR21DynamicVBOChunkHandleR13dynamic_arrayIN10DynamicVBO10DrawParamsELj4EER9GfxDevice(i22, (HEAP32[i23 >> 2] | 0) + (i3 << 3) | 0, i30, i31, i34) | 0;
   i2 = ((i21 | 0) != 0 & 1) + i2 | 0;
   i1 = i21 + i1 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i24 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i25 >> 2] | 0) {
  i19 = HEAP32[(HEAP32[i26 >> 2] | 0) + 16 >> 2] | 0;
  i21 = HEAP32[gb + 1452272 + 4 >> 2] | 0;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i21 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i21, HEAP32[i27 >> 2] | 0, 0) | 0;
  mftCall_viiiiiii(i19 | 0, i26 | 0, i30 | 0, i27 | 0, i20 | 0, i21 | 0, HEAP32[i31 >> 2] | 0, HEAP32[i25 >> 2] | 0);
 }
 HEAP32[i25 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i34 >> 2] | 0) + 104 >> 2] | 0, i34 | 0, gb + 1162292 | 0, 0);
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 i21 = i30 + 8 | 0;
 HEAP32[i21 >> 2] = -1;
 HEAP32[i30 + 12 >> 2] = 0;
 i3 = HEAP32[i24 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  i5 = 0;
  i4 = 0;
  i3 = i1;
 } else {
  i6 = 0;
  i5 = 0;
  i20 = 0;
  i4 = 0;
  i9 = i3;
  while (1) {
   i3 = HEAP32[i23 >> 2] | 0;
   if ((HEAP32[i3 + (i20 << 3) + 4 >> 2] | 0) == 1) i3 = i9; else {
    i7 = HEAP32[i3 + (i20 << 3) >> 2] | 0;
    i8 = HEAP32[i22 >> 2] | 0;
    i10 = HEAP32[i8 + (i7 * 360 | 0) + 328 >> 2] | 0;
    if ((HEAP32[i10 + 508 >> 2] | 0) == 5) i3 = i9; else {
     i3 = i10 + 64 | 0;
     i19 = i10 + 88 | 0;
     if (!(HEAP32[i19 >> 2] | 0)) i3 = i9; else {
      if ((HEAP32[i21 >> 2] | 0) == -1) {
       HEAP32[i30 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i30 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i30 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i30 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       i4 = HEAP32[i10 + 472 >> 2] | 0;
       i5 = HEAP32[i4 + 4 >> 2] | 0;
       i4 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i4, HEAP32[i27 >> 2] | 0, 0) | 0;
      }
      i3 = HEAP32[i8 + (i7 * 360 | 0) + 188 >> 2] | 0;
      if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 188 >> 2] | 0, i34 | 0, i3 | 0);
      i3 = HEAP32[i19 >> 2] | 0;
      i18 = (i3 + 16383 | 0) >>> 14;
      i17 = HEAP32[i10 + 476 >> 2] | 0;
      if (i18) {
       i16 = 0;
       i15 = HEAP32[i10 + 80 >> 2] | 0;
       while (1) {
        i7 = i3 >>> 0 > 16384 ? 16384 : i3;
        i9 = i7 << 2;
        i10 = i7 * 6 | 0;
        i11 = HEAP32[i25 >> 2] | 0;
        i12 = i11 + 1 | 0;
        i13 = HEAP32[i28 >> 2] | 0;
        i14 = i13 & 2147483647;
        do if (i12 >>> 0 > i14 >>> 0) {
         i8 = i13 << 1;
         i8 = (i8 | 0) == 0 ? 1 : i8;
         if (i14 >>> 0 < i8 >>> 0) if ((i13 | 0) > -1) {
          HEAP32[i28 >> 2] = i8;
          HEAP32[i31 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i31 >> 2] | 0, i8 * 20 | 0, 4, i29, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 20 | 0, 4, i29, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i14 | 0, HEAP32[i31 >> 2] | 0, (HEAP32[i25 >> 2] | 0) * 20 | 0) | 0;
          HEAP32[i28 >> 2] = i8;
          HEAP32[i31 >> 2] = i14;
          break;
         }
        } while (0);
        HEAP32[i25 >> 2] = i12;
        i14 = HEAP32[i31 >> 2] | 0;
        HEAP32[i14 + (i11 * 20 | 0) >> 2] = i17;
        HEAP32[i14 + (i11 * 20 | 0) + 4 >> 2] = i15;
        HEAP32[i14 + (i11 * 20 | 0) + 8 >> 2] = i9;
        HEAP32[i14 + (i11 * 20 | 0) + 12 >> 2] = 0;
        HEAP32[i14 + (i11 * 20 | 0) + 16 >> 2] = i10;
        i15 = (Math_imul(i9, i17) | 0) + i15 | 0;
        i16 = i16 + 1 | 0;
        if ((i16 | 0) == (i18 | 0)) break; else i3 = i3 - i7 | 0;
       }
       i3 = HEAP32[i19 >> 2] | 0;
      }
      i6 = (i3 * 6 | 0) + i6 | 0;
      i1 = (i3 << 2) + i1 | 0;
      i2 = i18 + i2 | 0;
      i3 = HEAP32[i24 >> 2] | 0;
     }
    }
   }
   i20 = i20 + 1 | 0;
   if (i20 >>> 0 >= i3 >>> 0) {
    i3 = i1;
    break;
   } else i9 = i3;
  }
 }
 i1 = HEAP32[i25 >> 2] | 0;
 if (i1 | 0) {
  mftCall_viiiiiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 16 >> 2] | 0, i26 | 0, i30 | 0, i27 | 0, i5 | 0, i4 | 0, HEAP32[i31 >> 2] | 0, i1 | 0);
  __Z15gpu_time_samplev();
 }
 if ((i2 | 0) > 0) {
  i30 = HEAP32[(HEAP32[i34 >> 2] | 0) + 268 >> 2] | 0;
  d36 = +_emscripten_get_now() * 1.0e6;
  i33 = _i64Subtract(~~d36 >>> 0 | 0, (+Math_abs(d36) >= 1.0 ? (d36 > 0.0 ? ~~+Math_min(+Math_floor(d36 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d36 - +(~~d36 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i32 | 0, i33 | 0) | 0;
  mftCall_viiiiiii(i30 | 0, i34 | 0, 1, (i6 | 0) / 3 | 0 | 0, i3 | 0, i2 | 0, i33 | 0, getTempRet0() | 0);
 }
 if ((HEAP32[i28 >> 2] | 0) <= -1) {
  STACKTOP = i35;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i31 >> 2] | 0, i29);
 HEAP32[i31 >> 2] = 0;
 STACKTOP = i35;
 return;
}

function _deflate_fast(i35, i32) {
 i35 = i35 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i36 = 0;
 i22 = i35 + 116 | 0;
 i25 = (i32 | 0) == 0;
 i26 = i35 + 72 | 0;
 i27 = i35 + 88 | 0;
 i34 = i35 + 108 | 0;
 i30 = i35 + 56 | 0;
 i28 = i35 + 84 | 0;
 i29 = i35 + 68 | 0;
 i13 = i35 + 52 | 0;
 i14 = i35 + 64 | 0;
 i15 = i35 + 96 | 0;
 i16 = i35 + 112 | 0;
 i17 = i35 + 5792 | 0;
 i18 = i35 + 5796 | 0;
 i19 = i35 + 5784 | 0;
 i20 = i35 + 5788 | 0;
 i21 = i35 + 128 | 0;
 i33 = i35 + 92 | 0;
 i23 = i35 + 44 | 0;
 i24 = i35 + 136 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i22 >> 2] | 0) >>> 0 < 262) {
   _fill_window(i35);
   i2 = HEAP32[i22 >> 2] | 0;
   if (i25 & i2 >>> 0 < 262) {
    i1 = 0;
    i31 = 36;
    break;
   }
   if (!i2) {
    i31 = 28;
    break;
   }
   if (i2 >>> 0 > 2) i31 = 6;
  } else i31 = 6;
  if ((i31 | 0) == 6) {
   i31 = 0;
   i11 = HEAP32[i34 >> 2] | 0;
   i12 = ((HEAPU8[(HEAP32[i30 >> 2] | 0) + (i11 + 2) >> 0] | 0) ^ HEAP32[i26 >> 2] << HEAP32[i27 >> 2]) & HEAP32[i28 >> 2];
   HEAP32[i26 >> 2] = i12;
   i12 = (HEAP32[i29 >> 2] | 0) + (i12 << 1) | 0;
   i1 = HEAP16[i12 >> 1] | 0;
   HEAP16[(HEAP32[i14 >> 2] | 0) + ((HEAP32[i13 >> 2] & i11) << 1) >> 1] = i1;
   HEAP16[i12 >> 1] = i11;
   i1 = i1 & 65535;
  }
  do if (!i1) i31 = 13; else {
   i2 = (HEAP32[i34 >> 2] | 0) - i1 | 0;
   if (i2 >>> 0 > ((HEAP32[i23 >> 2] | 0) + -262 | 0) >>> 0) i31 = 13; else {
    i3 = HEAP32[i24 >> 2] | 0;
    if ((i3 & -2 | 0) != 2) {
     i2 = _longest_match(i35, i1) | 0;
     HEAP32[i15 >> 2] = i2;
     break;
    }
    if ((i2 | 0) == 1 & (i3 | 0) == 3) {
     i2 = _longest_match_fast(i35, i1) | 0;
     HEAP32[i15 >> 2] = i2;
    } else i31 = 13;
   }
  } while (0);
  if ((i31 | 0) == 13) {
   i31 = 0;
   i2 = HEAP32[i15 >> 2] | 0;
  }
  do if (i2 >>> 0 > 2) {
   i2 = i2 + 253 | 0;
   i12 = (HEAP32[i34 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0;
   i11 = HEAP32[i17 >> 2] | 0;
   HEAP16[(HEAP32[i18 >> 2] | 0) + (i11 << 1) >> 1] = i12;
   HEAP32[i17 >> 2] = i11 + 1;
   HEAP8[(HEAP32[i19 >> 2] | 0) + i11 >> 0] = i2;
   i2 = i35 + 148 + ((HEAPU8[(i2 & 255) + (gb + 361974) >> 0] | 0 | 256) + 1 << 2) | 0;
   HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
   i12 = i12 + 65535 & 65535;
   i12 = i35 + 2440 + ((HEAPU8[(i12 >>> 0 < 256 ? i12 : (i12 >>> 7) + 256 | 0) + (gb + 361462) >> 0] | 0) << 2) | 0;
   HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
   i12 = (HEAP32[i17 >> 2] | 0) == ((HEAP32[i20 >> 2] | 0) + -1 | 0) & 1;
   i2 = HEAP32[i15 >> 2] | 0;
   i11 = (HEAP32[i22 >> 2] | 0) - i2 | 0;
   HEAP32[i22 >> 2] = i11;
   if (!(i11 >>> 0 > 2 ? i2 >>> 0 <= (HEAP32[i21 >> 2] | 0) >>> 0 : 0)) {
    i4 = (HEAP32[i34 >> 2] | 0) + i2 | 0;
    HEAP32[i34 >> 2] = i4;
    HEAP32[i15 >> 2] = 0;
    i11 = HEAP32[i30 >> 2] | 0;
    i2 = HEAPU8[i11 + i4 >> 0] | 0;
    HEAP32[i26 >> 2] = i2;
    HEAP32[i26 >> 2] = ((HEAPU8[i11 + (i4 + 1) >> 0] | 0) ^ i2 << HEAP32[i27 >> 2]) & HEAP32[i28 >> 2];
    i2 = i12;
    break;
   }
   i10 = i2 + -1 | 0;
   HEAP32[i15 >> 2] = i10;
   i1 = HEAP32[i27 >> 2] | 0;
   i2 = HEAP32[i30 >> 2] | 0;
   i3 = HEAP32[i28 >> 2] | 0;
   i4 = HEAP32[i29 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i8 = HEAP32[i34 >> 2] | 0;
   i9 = HEAP32[i26 >> 2] | 0;
   while (1) {
    i7 = i8 + 1 | 0;
    HEAP32[i34 >> 2] = i7;
    i9 = ((HEAPU8[i2 + (i8 + 3) >> 0] | 0) ^ i9 << i1) & i3;
    HEAP32[i26 >> 2] = i9;
    i36 = i4 + (i9 << 1) | 0;
    i11 = HEAP16[i36 >> 1] | 0;
    HEAP16[i6 + ((i5 & i7) << 1) >> 1] = i11;
    HEAP16[i36 >> 1] = i7;
    i10 = i10 + -1 | 0;
    HEAP32[i15 >> 2] = i10;
    if (!i10) break; else i8 = i7;
   }
   i4 = i8 + 2 | 0;
   HEAP32[i34 >> 2] = i4;
   i2 = i12;
   i1 = i11 & 65535;
  } else {
   i2 = HEAP8[(HEAP32[i30 >> 2] | 0) + (HEAP32[i34 >> 2] | 0) >> 0] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   HEAP16[(HEAP32[i18 >> 2] | 0) + (i4 << 1) >> 1] = 0;
   HEAP32[i17 >> 2] = i4 + 1;
   HEAP8[(HEAP32[i19 >> 2] | 0) + i4 >> 0] = i2;
   i2 = i35 + 148 + ((i2 & 255) << 2) | 0;
   HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
   i2 = (HEAP32[i17 >> 2] | 0) == ((HEAP32[i20 >> 2] | 0) + -1 | 0) & 1;
   HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
   i4 = (HEAP32[i34 >> 2] | 0) + 1 | 0;
   HEAP32[i34 >> 2] = i4;
  } while (0);
  if (!i2) continue;
  i2 = HEAP32[i33 >> 2] | 0;
  if ((i2 | 0) > -1) i3 = (HEAP32[i30 >> 2] | 0) + i2 | 0; else i3 = 0;
  _unity_z_tr_flush_block(i35, i3, i4 - i2 | 0, 0);
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  i5 = HEAP32[i35 >> 2] | 0;
  i2 = i5 + 28 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i3 + 20 >> 2] | 0;
  i6 = i5 + 16 | 0;
  i36 = HEAP32[i6 >> 2] | 0;
  i4 = i4 >>> 0 > i36 >>> 0 ? i36 : i4;
  if (i4 | 0) {
   i12 = i5 + 12 | 0;
   _memcpy(HEAP32[i12 >> 2] | 0, HEAP32[i3 + 16 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i4;
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = i2 + 16 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
   i12 = i5 + 20 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i4;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i4;
   i12 = i2 + 20 | 0;
   i36 = (HEAP32[i12 >> 2] | 0) - i4 | 0;
   HEAP32[i12 >> 2] = i36;
   if (!i36) HEAP32[i3 >> 2] = HEAP32[i2 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i31 = 36;
   break;
  }
 }
 if ((i31 | 0) == 28) {
  i2 = HEAP32[i33 >> 2] | 0;
  if ((i2 | 0) > -1) i1 = (HEAP32[i30 >> 2] | 0) + i2 | 0; else i1 = 0;
  i6 = (i32 | 0) == 4;
  _unity_z_tr_flush_block(i35, i1, (HEAP32[i34 >> 2] | 0) - i2 | 0, i6 & 1);
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  i4 = HEAP32[i35 >> 2] | 0;
  i1 = i4 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i5 = i4 + 16 | 0;
  i36 = HEAP32[i5 >> 2] | 0;
  i3 = i3 >>> 0 > i36 >>> 0 ? i36 : i3;
  if (i3 | 0) {
   i34 = i4 + 12 | 0;
   _memcpy(HEAP32[i34 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i3 | 0) | 0;
   HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i3;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
   i34 = i4 + 20 | 0;
   HEAP32[i34 >> 2] = (HEAP32[i34 >> 2] | 0) + i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i3;
   i34 = i1 + 20 | 0;
   i36 = (HEAP32[i34 >> 2] | 0) - i3 | 0;
   HEAP32[i34 >> 2] = i36;
   if (!i36) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i35 >> 2] | 0) + 16 >> 2] | 0)) {
   i36 = i6 ? 2 : 0;
   return i36 | 0;
  } else {
   i36 = i6 ? 3 : 1;
   return i36 | 0;
  }
 } else if ((i31 | 0) == 36) return i1 | 0;
 return 0;
}

function __ZN33AssetBundleLoadFromAsyncOperation21InitializeAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 32 | 0;
 i11 = i12 + 24 | 0;
 i7 = i12 + 16 | 0;
 i9 = i12;
 i2 = __Z20GetPersistentManagerv() | 0;
 if ((__ZN17PersistentManager24GetTypeFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i2, i1, 1, 0) | 0) == (gb + 27368 | 0)) {
  i3 = 1;
  i4 = 0;
  i6 = 3;
 } else if ((__ZN17PersistentManager24GetTypeFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i2, i1, 2, 0) | 0) == (gb + 27368 | 0)) {
  i3 = 2;
  i4 = 0;
  i6 = 3;
 } else i6 = 13;
 do if ((i6 | 0) == 3) {
  i4 = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i2, i1, i3, i4) | 0;
  if (!i4) i6 = 13; else {
   HEAP32[i9 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i9);
     i2 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 11;
    }
   }
   if ((i6 | 0) == 9) i6 = 11;
   if ((i6 | 0) == 11) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i6 = 13;
     break;
    }
   }
   if ((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27368 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27368 + 28 >> 2] | 0) >>> 0) i6 = 13; else i5 = i1;
  }
 } while (0);
 if ((i6 | 0) == 13) {
  i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(188, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 365786 | 0, 315) | 0;
  i3 = gb + 63520 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = i9;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i5, i10, 0);
  HEAP32[i5 >> 2] = gb + 27268 + 8;
  HEAP32[i5 + 32 >> 2] = 1;
  i2 = i5 + 36 | 0;
  HEAP32[i5 + 60 >> 2] = 0;
  HEAP32[i5 + 64 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i2 = i10;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i5 + 52 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i5 + 72 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 + 76 >> 2] = 0;
  HEAP32[i5 + 68 >> 2] = i3;
  i3 = i5 + 84 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 + 88 >> 2] = 0;
  HEAP32[i5 + 80 >> 2] = i3;
  __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev(i5 + 92 | 0);
  i3 = i5 + 148 | 0;
  i4 = i5 + 168 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP8[i3 + 16 >> 0] = 0;
  __ZN14ConstantString12create_emptyEv(i4);
  i4 = i5 + 172 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP8[i4 + 12 >> 0] = 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0, 61);
  __Z19pop_allocation_rootv();
  i5 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i5) | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, 4);
  HEAP32[i5 + 32 >> 2] = 0;
 }
 i1 = i8 + 80 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 148 >> 2] = i4;
 __ZNK6Object14GetMemoryLabelEv(i10, i5);
 i2 = __Z18get_root_referencePvRK10MemLabelId(i5, i10) | 0;
 __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i4, gb + 63552 | 0, i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 64 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5 + 152 | 0, i1) | 0;
 HEAP8[i5 + 164 >> 0] = HEAP8[i8 + 76 >> 0] | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i8 + 68 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 do if (!(HEAP8[i8 + 124 >> 0] | 0)) {
  __ZN18AssetBundleManager19RegisterAssetBundleEP11AssetBundle(HEAP32[gb + 1104056 >> 2] | 0, i5);
  if (!i5) i1 = 0; else i6 = 29;
 } else {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i1 = i8 + 112 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  if (HEAP32[i5 + 32 >> 2] | 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   __ZN18AssetBundleManager19RegisterAssetBundleEP11AssetBundle(HEAP32[gb + 1104056 >> 2] | 0, i5);
   i6 = 29;
   break;
  }
  i4 = i1 + 11 | 0;
  HEAP32[i7 >> 2] = (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i10, gb + 366169 | 0, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i3 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i2 = i8 + 92 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP32[i2 >> 2] = 6;
   i2 = i8 + 96 | 0;
   if (!i3) {
    if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i11 >> 2] = i1;
    __Z6FormatPKcz(i10, gb + 366067 | 0, i11);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i10) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
  }
  __Z17UnloadAssetBundleR11AssetBundleb(i5, 1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 } while (0);
 if ((i6 | 0) == 29) i1 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i8 + 84 >> 2] = i1;
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideParticlesEv(i72) {
 i72 = i72 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i73 = 0, f74 = f0, f75 = f0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 944 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i68 = i73 + 928 | 0;
 i36 = i73 + 856 | 0;
 i65 = i73 + 776 | 0;
 i35 = i73 + 656 | 0;
 i62 = i73 + 864 | 0;
 i69 = i73 + 792 | 0;
 i13 = i73 + 592 | 0;
 i24 = i73 + 584 | 0;
 i34 = i73 + 568 | 0;
 i37 = i73 + 560 | 0;
 i40 = i73 + 544 | 0;
 i51 = i73 + 536 | 0;
 i59 = i73 + 520 | 0;
 i60 = i73 + 512 | 0;
 i61 = i73 + 664 | 0;
 i71 = i73 + 496 | 0;
 i67 = i73 + 480 | 0;
 i3 = i73 + 464 | 0;
 i66 = i73 + 448 | 0;
 i4 = i73 + 432 | 0;
 i5 = i73 + 424 | 0;
 i6 = i73 + 408 | 0;
 i7 = i73 + 400 | 0;
 i8 = i73 + 384 | 0;
 i9 = i73 + 376 | 0;
 i10 = i73 + 360 | 0;
 i11 = i73 + 352 | 0;
 i64 = i73 + 608 | 0;
 i12 = i73 + 336 | 0;
 i14 = i73 + 320 | 0;
 i15 = i73 + 304 | 0;
 i63 = i73 + 288 | 0;
 i16 = i73 + 272 | 0;
 i17 = i73 + 256 | 0;
 i18 = i73 + 240 | 0;
 i19 = i73 + 224 | 0;
 i20 = i73 + 208 | 0;
 i21 = i73 + 192 | 0;
 i70 = i73 + 176 | 0;
 i22 = i73 + 160 | 0;
 i23 = i73 + 144 | 0;
 i25 = i73 + 128 | 0;
 i26 = i73 + 112 | 0;
 i27 = i73 + 96 | 0;
 i28 = i73 + 80 | 0;
 i29 = i73 + 64 | 0;
 i30 = i73 + 48 | 0;
 i31 = i73 + 32 | 0;
 i32 = i73 + 16 | 0;
 i33 = i73;
 i2 = i72 + 432 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + 220 | 0;
 f75 = Math_fround(HEAPF32[i1 >> 2]);
 HEAP32[i36 >> 2] = __Z6simd4fRKf(i1) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i68, i36);
 i36 = (HEAP32[i2 >> 2] | 0) + 216 | 0;
 f74 = Math_fround(HEAPF32[i36 >> 2]);
 HEAP32[i35 >> 2] = __Z6simd4fRKf(i36) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i65, i35);
 i35 = f75 > Math_fround(0.0);
 i36 = f74 > Math_fround(0.0);
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i58 = HEAP32[i2 >> 2] << 2;
 i38 = i1 + (i58 << 2) | 0;
 if ((i58 | 0) <= 0) {
  STACKTOP = i73;
  return;
 }
 i39 = i62 + 16 | 0;
 i41 = i62 + 32 | 0;
 i42 = i62 + 48 | 0;
 i43 = i61 + 96 | 0;
 i44 = i69 + 16 | 0;
 i45 = i69 + 32 | 0;
 i46 = i69 + 48 | 0;
 i47 = i61 + 16 | 0;
 i48 = i61 + 32 | 0;
 i49 = i61 + 48 | 0;
 i50 = i61 + 64 | 0;
 i52 = i61 + 80 | 0;
 i53 = i64 + 16 | 0;
 i54 = i64 + 32 | 0;
 i55 = i61 + 16 | 0;
 i56 = i61 + 32 | 0;
 i57 = i61 + 16 | 0;
 i58 = i61 + 32 | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 while (1) {
  __Z11loadAlignedPKfj(i24, i1, 0);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i13, i24);
  __ZN8Scalar4faSERKS_(i62, i13) | 0;
  __Z11loadAlignedPKfj(i37, i1, 16);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i34, i37);
  __ZN8Scalar4faSERKS_(i39, i34) | 0;
  __Z11loadAlignedPKfj(i51, i1, 32);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i40, i51);
  __ZN8Scalar4faSERKS_(i41, i40) | 0;
  __Z11loadAlignedPKfj(i60, i1, 48);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i59, i60);
  __ZN8Scalar4faSERKS_(i42, i59) | 0;
  __Z9transposeR8Scalar4fS0_S0_S0_(i62, i39, i41, i42);
  __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i61);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_RNS3_18ImpulseAccumulatorE(i71, i72, i62, i61);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_RNS3_18ImpulseAccumulatorE(i72, i71, i62, i61);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i3, gb + 1097856 | 0);
  if (__Z10anyGreaterRK8Scalar4fS1_RS_(i43, i3, i67) | 0) {
   __Z5recipRK8Scalar4f(i66, i43);
   if (i36) {
    __Z11loadAlignedPKfj(i5, i2, 0);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i4, i5);
    __ZN8Scalar4faSERKS_(i69, i4) | 0;
    __Z11loadAlignedPKfj(i7, i2, 16);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i6, i7);
    __ZN8Scalar4faSERKS_(i44, i6) | 0;
    __Z11loadAlignedPKfj(i9, i2, 32);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i8, i9);
    __ZN8Scalar4faSERKS_(i45, i8) | 0;
    __Z11loadAlignedPKfj(i11, i2, 48);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i10, i11);
    __ZN8Scalar4faSERKS_(i46, i10) | 0;
    __Z9transposeR8Scalar4fS0_S0_S0_(i69, i44, i45, i46);
    __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_(i61, i47, i48, i49, i50, i52, i62, i69, i66, i65, i67, i64);
    __ZmiRK8Scalar4fS1_(i12, i69, i64);
    __ZN8Scalar4faSERKS_(i69, i12) | 0;
    __ZmiRK8Scalar4fS1_(i14, i44, i53);
    __ZN8Scalar4faSERKS_(i44, i14) | 0;
    __ZmiRK8Scalar4fS1_(i15, i45, i54);
    __ZN8Scalar4faSERKS_(i45, i15) | 0;
    __Z9transposeR8Scalar4fS0_S0_S0_(i69, i44, i45, i46);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 0, i69);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 16, i44);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 32, i45);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 48, i46);
   }
   if (i35) {
    __ZmlRK8Scalar4fS1_(i16, i66, i66);
    __ZmlRK8Scalar4fS1_(i19, i61, i61);
    __ZmlRK8Scalar4fS1_(i20, i55, i55);
    __ZplRK8Scalar4fS1_(i18, i19, i20);
    __ZmlRK8Scalar4fS1_(i21, i56, i56);
    __ZplRK8Scalar4fS1_(i17, i18, i21);
    __ZmlRK8Scalar4fS1_(i63, i16, i17);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i23, gb + 1097760 | 0);
    __ZmlRK8Scalar4fS1_(i25, i68, i63);
    __ZplRK8Scalar4fS1_(i22, i23, i25);
    __Z5recipRK8Scalar4f(i70, i22);
    __ZmlRK8Scalar4fS1_(i27, i42, i70);
    __Z6selectRK8Scalar4fS1_S1_(i26, i67, i27, i42);
    __ZN8Scalar4faSERKS_(i42, i26) | 0;
   }
   __ZmlRK8Scalar4fS1_(i29, i61, i66);
   __ZplRK8Scalar4fS1_(i28, i62, i29);
   __ZN8Scalar4faSERKS_(i62, i28) | 0;
   __ZmlRK8Scalar4fS1_(i31, i57, i66);
   __ZplRK8Scalar4fS1_(i30, i39, i31);
   __ZN8Scalar4faSERKS_(i39, i30) | 0;
   __ZmlRK8Scalar4fS1_(i33, i58, i66);
   __ZplRK8Scalar4fS1_(i32, i41, i33);
   __ZN8Scalar4faSERKS_(i41, i32) | 0;
   __Z9transposeR8Scalar4fS0_S0_S0_(i62, i39, i41, i42);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 0, i62);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 16, i39);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 32, i41);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 48, i42);
  }
  i1 = i1 + 64 | 0;
  if (i1 >>> 0 >= i38 >>> 0) break; else i2 = i2 + 64 | 0;
 }
 STACKTOP = i73;
 return;
}

function __ZN5Unity14CharacterJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 96 | 0, gb + 734686 | 0, 0);
 i4 = i1 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734753 | 0, gb + 734772 | 0, i4, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i6, i4, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i6, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734698 | 0, gb + 734793 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i6, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i6, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734736 | 0, gb + 734793 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i6, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 140 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734836 | 0, gb + 734772 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i6, i1 + 144 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 148 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734808 | 0, gb + 734793 | 0, i6, 0);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 152 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 160 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734822 | 0, gb + 734793 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744104 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 168 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734855 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 172 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734874 | 0, i5, i1 + 176 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734895 | 0, i5, i1 + 180 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZL21GetMeshLocationDetailR4Mesh(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 80 | 0;
 i12 = i17 + 64 | 0;
 i13 = i17 + 48 | 0;
 i14 = i17 + 32 | 0;
 i15 = i17 + 16 | 0;
 i16 = i17;
 i4 = i9 + 248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i12 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 } while (0);
 __Z32GetSceneHierarchyPathDescriptivePK6Object(i10, i1);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i13 + 11 | 0;
 HEAP8[i6 >> 0] = 2;
 HEAP16[i13 >> 1] = 8236;
 HEAP8[i13 + 2 >> 0] = 0;
 __Z27GetMeshAssetPathDescriptivePK4Mesh(i14, i9);
 __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i12, i10, i13, i14);
 i5 = i12 + 11 | 0;
 do if ((i12 | 0) != (i10 | 0)) {
  i8 = HEAP8[i5 >> 0] | 0;
  i3 = i8 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i3 = i10 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i8 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i8 - i4 | 0, i1, 0, i1, i8, i7);
   break;
  }
  if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 4 >> 2] = i8;
   break;
  } else {
   HEAP8[i3 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 if ((HEAP8[i14 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i8 = HEAP32[i13 >> 2] | 0;
  i7 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 };
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i13 + 11 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP8[i13 >> 0] = 32;
 HEAP8[i13 + 1 >> 0] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 + 12 >> 2] = i1;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = -2147483632;
 HEAP32[i16 + 4 >> 2] = 11;
 i2 = i1;
 i3 = gb + 781672 | 0;
 i4 = i2 + 11 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 11 >> 0] = 0;
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i15, i16, mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0);
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i14, i15, gb + 1046779 | 0);
 __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i12, i10, i13, i14);
 i5 = i12 + 11 | 0;
 do if ((i12 | 0) != (i10 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i3 = i10 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i10 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 }
 if ((HEAP8[i14 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i11);
 }
 if ((HEAP8[i15 + 11 >> 0] | 0) < 0) {
  i14 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
 }
 if ((HEAP8[i16 + 11 >> 0] | 0) < 0) {
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i11);
 }
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i17;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 i15 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i11);
 STACKTOP = i17;
 return;
}

function __ZN11DynamicMesh13MergePolygonsERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i1, i22) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i21;
 i15 = i21 + 28 | 0;
 i17 = i21 + 8 | 0;
 i18 = i15 + 12 | 0;
 HEAP32[i18 >> 2] = 6;
 i19 = i15 + 16 | 0;
 HEAP32[i19 >> 2] = 6;
 i20 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 64016 | 0);
 i14 = i2;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i20;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
 i12 = i17 + 12 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 16 | 0;
 HEAP32[i13 >> 2] = 6;
 i14 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 64016 | 0);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i16 = i14;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i17 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
 i16 = i22 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i11 = 0;
  do {
   i4 = i2;
   i3 = i4 + (i11 * 20 | 0) | 0;
   if ((i3 | 0) != (i15 | 0)) {
    i5 = HEAP32[i3 >> 2] | 0;
    i1 = (HEAP32[i4 + (i11 * 20 | 0) + 12 >> 2] | 0) * 12 | 0;
    i2 = (i1 | 0) / 12 | 0;
    HEAP32[i18 >> 2] = i2;
    i3 = HEAP32[i19 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i19 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i15 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i19 >> 2] = i2;
     HEAP32[i15 >> 2] = i1;
     break;
    } else i1 = HEAP32[i15 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i5 | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i22 >> 2] | 0;
   }
   i1 = ((i1 - i2 | 0) / 20 | 0) + -1 | 0;
   i3 = i2;
   if (i1 >>> 0 > i11 >>> 0) {
    i2 = i3;
    do {
     do if (__ZNK11DynamicMesh13MergePolygonsER13dynamic_arrayI8Vector3fLj4EERKS2_S5_(0, i17, i15, i2 + (i1 * 20 | 0) | 0) | 0) {
      i5 = HEAP32[i17 >> 2] | 0;
      i2 = (HEAP32[i12 >> 2] | 0) * 12 | 0;
      i3 = (i2 | 0) / 12 | 0;
      HEAP32[i18 >> 2] = i3;
      i4 = HEAP32[i19 >> 2] | 0;
      do if ((i4 & 2147483647) >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i19 >> 2] = i3;
       i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i15 >> 2] = i2;
       break;
      } else {
       i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i2 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i19 >> 2] = i3;
       HEAP32[i15 >> 2] = i2;
       break;
      } else i2 = HEAP32[i15 >> 2] | 0; while (0);
      _memcpy(i2 | 0, i5 | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
      i3 = (HEAP32[i22 >> 2] | 0) + (i1 * 20 | 0) | 0;
      i2 = i3 + 20 | 0;
      i10 = HEAP32[i16 >> 2] | 0;
      if ((i2 | 0) == (i10 | 0)) i4 = i3; else {
       do {
        i8 = HEAP32[i2 >> 2] | 0;
        i9 = i3 + 12 | 0;
        i4 = (HEAP32[i2 + 12 >> 2] | 0) * 12 | 0;
        i5 = (i4 | 0) / 12 | 0;
        HEAP32[i9 >> 2] = i5;
        i6 = i3 + 16 | 0;
        i7 = HEAP32[i6 >> 2] | 0;
        do if ((i7 & 2147483647) >>> 0 < i5 >>> 0) if ((i7 | 0) > -1) {
         HEAP32[i6 >> 2] = i5;
         i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i4, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
         HEAP32[i3 >> 2] = i4;
         break;
        } else {
         i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i4 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
         HEAP32[i6 >> 2] = i5;
         HEAP32[i3 >> 2] = i4;
         break;
        } else i4 = HEAP32[i3 >> 2] | 0; while (0);
        _memcpy(i4 | 0, i8 | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
        i2 = i2 + 20 | 0;
        i3 = i3 + 20 | 0;
       } while ((i2 | 0) != (i10 | 0));
       i2 = HEAP32[i16 >> 2] | 0;
       if ((i2 | 0) == (i3 | 0)) break; else i4 = i3;
      }
      i3 = i2;
      while (1) {
       i2 = i3 + -20 | 0;
       HEAP32[i16 >> 2] = i2;
       if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
        __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -16 | 0);
        HEAP32[i2 >> 2] = 0;
        i2 = HEAP32[i16 >> 2] | 0;
       }
       if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
      }
     } while (0);
     i1 = i1 + -1 | 0;
     i2 = HEAP32[i22 >> 2] | 0;
    } while (i1 >>> 0 > i11 >>> 0);
    i3 = i2;
   }
   i6 = i3 + (i11 * 20 | 0) | 0;
   if ((i15 | 0) != (i6 | 0)) {
    i7 = HEAP32[i15 >> 2] | 0;
    i8 = i3 + (i11 * 20 | 0) + 12 | 0;
    i1 = (HEAP32[i18 >> 2] | 0) * 12 | 0;
    i2 = (i1 | 0) / 12 | 0;
    HEAP32[i8 >> 2] = i2;
    i4 = i3 + (i11 * 20 | 0) + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i4 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i3 + (i11 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i6 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i3 + (i11 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     HEAP32[i6 >> 2] = i1;
     break;
    } else i1 = HEAP32[i6 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i7 | 0, (HEAP32[i8 >> 2] | 0) * 12 | 0) | 0;
    i2 = HEAP32[i22 >> 2] | 0;
   }
   i11 = i11 + 1 | 0;
   i1 = HEAP32[i16 >> 2] | 0;
  } while (i11 >>> 0 < ((i1 - i2 | 0) / 20 | 0) >>> 0);
 }
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i14);
  HEAP32[i17 >> 2] = 0;
 }
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i21;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i20);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZN17PolygonCollider2D20ValidatePolygonShapeEPK6b2Vec2i(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 96 | 0;
 i14 = i17 + 64 | 0;
 i16 = i17;
 if ((i10 + -3 | 0) >>> 0 > 5) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((i10 | 0) > 0) {
  _memcpy(i13 | 0, i9 | 0, i10 << 3 | 0) | 0;
  i1 = 0;
  i8 = 0;
  while (1) {
   i4 = HEAP32[i9 + (i8 << 3) >> 2] | 0;
   i7 = HEAP32[i9 + (i8 << 3) + 4 >> 2] | 0;
   L8 : do if ((i1 | 0) > 0) {
    f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i2 = 0;
    while (1) {
     f6 = Math_fround(f3 - Math_fround(HEAPF32[i13 + (i2 << 3) >> 2]));
     f11 = Math_fround(f5 - Math_fround(HEAPF32[i13 + (i2 << 3) + 4 >> 2]));
     i2 = i2 + 1 | 0;
     if (Math_fround(Math_fround(f6 * f6) + Math_fround(f11 * f11)) < Math_fround(6.24999984e-06)) {
      i12 = i1;
      break L8;
     }
     if ((i2 | 0) >= (i1 | 0)) {
      i15 = 9;
      break;
     }
    }
   } else i15 = 9; while (0);
   if ((i15 | 0) == 9) {
    i15 = 0;
    HEAP32[i13 + (i1 << 3) >> 2] = i4;
    HEAP32[i13 + (i1 << 3) + 4 >> 2] = i7;
    i12 = i1 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i10 | 0)) break; else i1 = i12;
  }
  if ((i12 | 0) < 3) i1 = 0; else {
   i2 = 1;
   f3 = Math_fround(HEAPF32[i13 >> 2]);
   i1 = 0;
   do {
    f5 = Math_fround(HEAPF32[i13 + (i2 << 3) >> 2]);
    if (f5 > f3) i15 = 24; else if (f5 == f3) {
     f11 = Math_fround(HEAPF32[i13 + (i2 << 3) + 4 >> 2]);
     if (f11 < Math_fround(HEAPF32[i13 + (i1 << 3) + 4 >> 2])) i15 = 24;
    }
    if ((i15 | 0) == 24) {
     i15 = 0;
     f3 = f5;
     i1 = i2;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
   L27 : do if ((i12 | 0) > 1) {
    i9 = i1;
    i10 = 0;
    while (1) {
     HEAP32[i14 + (i10 << 2) >> 2] = i9;
     i7 = i13 + (i9 << 3) | 0;
     i8 = i13 + (i9 << 3) + 4 | 0;
     i4 = 1;
     i2 = 0;
     do {
      if ((i2 | 0) == (i9 | 0)) i2 = i4; else {
       f3 = Math_fround(HEAPF32[i13 + (i2 << 3) >> 2]);
       f6 = Math_fround(HEAPF32[i7 >> 2]);
       f3 = Math_fround(f3 - f6);
       f5 = Math_fround(HEAPF32[i13 + (i2 << 3) + 4 >> 2]);
       f11 = Math_fround(HEAPF32[i8 >> 2]);
       f5 = Math_fround(f5 - f11);
       f6 = Math_fround(Math_fround(HEAPF32[i13 + (i4 << 3) >> 2]) - f6);
       f11 = Math_fround(Math_fround(HEAPF32[i13 + (i4 << 3) + 4 >> 2]) - f11);
       f18 = Math_fround(Math_fround(f3 * f11) - Math_fround(f5 * f6));
       i19 = f18 < Math_fround(0.0);
       i2 = i19 ? i4 : i2;
       if (f18 == Math_fround(0.0)) if (Math_fround(Math_fround(f6 * f6) + Math_fround(f11 * f11)) > Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5))) i2 = i4;
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i12 | 0));
     i7 = i10 + 1 | 0;
     switch (((i2 | 0) == (i1 | 0) ? 14 : (i10 | 0) > 6 & 1) & 15) {
     case 14:
      {
       i15 = 27;
       break L27;
      }
     case 0:
      {
       i9 = i2;
       i10 = i7;
       break;
      }
     default:
      {
       i1 = 0;
       break L27;
      }
     }
    }
   } else {
    i4 = (i1 | 0) == 0;
    i2 = 0;
    while (1) {
     HEAP32[i14 + (i2 << 2) >> 2] = i1;
     i7 = i2 + 1 | 0;
     switch ((i4 ? 14 : (i2 | 0) > 6 & 1) & 15) {
     case 14:
      {
       i10 = i2;
       i15 = 27;
       break L27;
      }
     case 0:
      {
       i1 = 0;
       i2 = i7;
       break;
      }
     default:
      {
       i1 = 0;
       break L27;
      }
     }
    }
   } while (0);
   if ((i15 | 0) == 27) if ((i7 | 0) < 3) i1 = 0; else {
    i8 = (i10 | 0) < 0;
    if (i8) i1 = 0; else {
     i1 = 0;
     while (1) {
      i9 = i13 + (HEAP32[i14 + (i1 << 2) >> 2] << 3) | 0;
      i12 = HEAP32[i9 + 4 >> 2] | 0;
      i19 = i16 + (i1 << 3) | 0;
      HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i19 + 4 >> 2] = i12;
      if ((i1 | 0) == (i10 | 0)) {
       i1 = 0;
       break;
      } else i1 = i1 + 1 | 0;
     }
    }
    while (1) {
     if ((i1 | 0) > (i10 | 0)) {
      i15 = 32;
      break;
     }
     i19 = i1;
     i1 = i1 + 1 | 0;
     i14 = (i19 | 0) < (i10 | 0) ? i1 : 0;
     f11 = Math_fround(HEAPF32[i16 + (i14 << 3) >> 2]);
     f11 = Math_fround(f11 - Math_fround(HEAPF32[i16 + (i19 << 3) >> 2]));
     f18 = Math_fround(HEAPF32[i16 + (i14 << 3) + 4 >> 2]);
     f18 = Math_fround(f18 - Math_fround(HEAPF32[i16 + (i19 << 3) + 4 >> 2]));
     if (Math_fround(Math_fround(f11 * f11) + Math_fround(f18 * f18)) <= Math_fround(1.42108547e-14)) {
      i1 = 0;
      break;
     }
    }
    if ((i15 | 0) == 32) {
     if (i8) i1 = 0; else {
      i2 = 0;
      i4 = HEAP32[gb + 1457504 >> 2] | 0;
      i1 = HEAP32[gb + 1457504 + 4 >> 2] | 0;
      while (1) {
       f3 = Math_fround(HEAPF32[i16 + (i2 << 3) >> 2]);
       f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f3);
       i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
       f6 = Math_fround(HEAPF32[i16 + (i2 << 3) + 4 >> 2]);
       f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
       if ((i2 | 0) == (i10 | 0)) break; else {
        i2 = i2 + 1 | 0;
        i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
       }
      }
      f18 = Math_fround(Math_fround(1.0) / Math_fround(i7 | 0));
      f5 = Math_fround(f18 * f3);
      f3 = Math_fround(f18 * f6);
      if (i8) i1 = 0; else {
       i2 = 0;
       i1 = 0;
       do {
        f6 = Math_fround(HEAPF32[i16 + (i2 << 3) >> 2]);
        f11 = Math_fround(HEAPF32[i16 + (i2 << 3) + 4 >> 2]);
        i19 = i2;
        i2 = i2 + 1 | 0;
        i15 = (i19 | 0) < (i10 | 0) ? i16 + (i2 << 3) | 0 : i16;
        f18 = Math_fround(HEAPF32[i15 >> 2]);
        f18 = Math_fround(Math_fround(Math_fround(Math_fround(f6 - f5) * Math_fround(Math_fround(HEAPF32[i15 + 4 >> 2]) - f3)) - Math_fround(Math_fround(f11 - f3) * Math_fround(f18 - f5))) * Math_fround(.5));
        f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f18);
        i1 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
       } while ((i19 | 0) != (i10 | 0));
      }
     }
     i1 = (i1 & 2139095040 | 0) != 2139095040 & (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(1.1920929e-07);
    }
   }
  }
 } else i1 = 0;
 i19 = i1;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE5eraseENS_16__deque_iteratorIS1_PKS1_RS6_PKS7_iLi0EEE(i27, i3, i1) {
 i27 = i27 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28 + 48 | 0;
 i22 = i28 + 16 | 0;
 i21 = i28 + 8 | 0;
 i12 = i28 + 24 | 0;
 i13 = i28 + 40 | 0;
 i14 = i28 + 32 | 0;
 i15 = i28;
 i25 = i3 + 4 | 0;
 i8 = HEAP32[i25 >> 2] | 0;
 i24 = i3 + 16 | 0;
 i7 = HEAP32[i24 >> 2] | 0;
 i17 = i8 + (((i7 >>> 0) / 78 | 0) << 2) | 0;
 i26 = i3 + 8 | 0;
 i9 = (HEAP32[i26 >> 2] | 0) == (i8 | 0);
 if (i9) i20 = 0; else i20 = (HEAP32[i17 >> 2] | 0) + (((i7 >>> 0) % 78 | 0) * 52 | 0) | 0;
 i18 = i20;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) == (i20 | 0)) {
  i5 = 0;
  i4 = i17;
  i10 = i17;
  i6 = i18;
  i11 = i3 + 20 | 0;
  i2 = 1;
  i19 = 10;
 } else {
  i5 = HEAP32[i1 >> 2] | 0;
  i5 = ((i5 - i17 >> 2) * 78 | 0) + ((i2 - (HEAP32[i5 >> 2] | 0) | 0) / 52 | 0) + ((i18 - (HEAP32[i17 >> 2] | 0) | 0) / -52 | 0) | 0;
  do if (!i5) {
   i5 = 0;
   i4 = i17;
   i6 = i18;
   i16 = 1;
  } else {
   i1 = ((i18 - (HEAP32[i17 >> 2] | 0) | 0) / 52 | 0) + i5 | 0;
   if ((i1 | 0) > 0) {
    i6 = i17 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
    i4 = i6;
    i6 = (HEAP32[i6 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
    i16 = 0;
    break;
   } else {
    i6 = 77 - i1 | 0;
    i16 = i17 + (((i6 | 0) / -78 | 0) << 2) | 0;
    i4 = i16;
    i6 = (HEAP32[i16 >> 2] | 0) + ((77 - ((i6 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
    i16 = 0;
    break;
   }
  } while (0);
  i10 = i4;
  i11 = i3 + 20 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  if (i5 >>> 0 > (i3 + -1 | 0) >>> 1 >>> 0) {
   i20 = i6 - (HEAP32[i4 >> 2] | 0) | 0;
   i1 = (i20 | 0) / 52 | 0;
   i2 = i1 + 1 | 0;
   if ((i20 | 0) > -52) {
    i20 = i4 + (((i2 >>> 0) / 78 | 0) << 2) | 0;
    i1 = (HEAP32[i20 >> 2] | 0) + (((i2 >>> 0) % 78 | 0) * 52 | 0) | 0;
    i2 = i20;
   } else {
    i1 = 76 - i1 | 0;
    i2 = i4 + (((i1 | 0) / -78 | 0) << 2) | 0;
    i1 = (HEAP32[i2 >> 2] | 0) + ((77 - ((i1 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
   }
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 4 >> 2] = i1;
   i1 = i7 + i3 | 0;
   i2 = i8 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
   if (i9) i1 = 0; else i1 = (HEAP32[i2 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i14 + 4 >> 2] = i1;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i15 + 4 >> 2] = i6;
   HEAP32[i21 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __ZNSt3__24moveI10InputEventPS1_RS1_PS2_iLi0ES1_S2_S3_S4_iLi0EEENS_16__deque_iteratorIT5_T6_T7_T8_T9_XT10_EEENS5_IT_T0_T1_T2_T3_XT4_EEESH_SB_(i12, i21, i22, i23);
   __ZN10InputEventD2Ev(HEAP32[i12 + 4 >> 2] | 0);
   i23 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
   HEAP32[i11 >> 2] = i23;
   i2 = HEAP32[i26 >> 2] | 0;
   i22 = i2 - (HEAP32[i25 >> 2] | 0) >> 2;
   i1 = HEAP32[i24 >> 2] | 0;
   if ((((i22 | 0) == 0 ? 0 : (i22 * 78 | 0) + -1 | 0) - (i23 + i1) | 0) >>> 0 > 155) {
    __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + -4;
    i1 = HEAP32[i24 >> 2] | 0;
   }
   i3 = i1;
   i2 = i16;
  } else {
   i2 = i16;
   i19 = 10;
  }
 }
 if ((i19 | 0) == 10) {
  i3 = HEAP32[i4 >> 2] | 0;
  i19 = i6 - i3 | 0;
  i9 = (i19 | 0) / 52 | 0;
  i1 = i9 + 1 | 0;
  if ((i19 | 0) > -52) {
   i19 = i4 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
   i7 = (HEAP32[i19 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
   i1 = i19;
  } else {
   i7 = 76 - i9 | 0;
   i1 = i4 + (((i7 | 0) / -78 | 0) << 2) | 0;
   i7 = (HEAP32[i1 >> 2] | 0) + ((77 - ((i7 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
  }
  i8 = i1;
  L30 : do if ((i6 | 0) != (i20 | 0)) {
   i1 = i9 + ((i10 - i17 >> 2) * 78 | 0) + ((i18 - (HEAP32[i17 >> 2] | 0) | 0) / -52 | 0) | 0;
   if ((i1 | 0) > 0) while (1) {
    if ((i6 | 0) == (i3 | 0)) {
     i4 = i4 + -4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i6 = i3 + 4056 | 0;
    }
    i9 = i6 + -52 | 0;
    i19 = (i6 - i3 | 0) / 52 | 0;
    i18 = (i19 | 0) > (i1 | 0);
    i19 = i18 ? i1 : i19;
    i17 = i21;
    HEAP32[i17 >> 2] = i8;
    HEAP32[i17 + 4 >> 2] = i7;
    HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    __ZNSt3__213move_backwardIP10InputEventS1_S2_RS1_PS2_iLi0EEENS_16__deque_iteratorIT0_T1_T2_T3_T4_XT5_EEET_SC_SB_PNS_9enable_ifIXsr27__is_random_access_iteratorISC_EE5valueEvE4typeE(i22, i18 ? i6 + ((0 - i1 | 0) * 52 | 0) | 0 : i3, i6, i23, 0);
    i7 = i22;
    i8 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    i6 = i1 - i19 | 0;
    i1 = i19 + -1 | 0;
    do if (!i1) i3 = i9; else {
     i1 = ((i9 - (HEAP32[i4 >> 2] | 0) | 0) / 52 | 0) - i1 | 0;
     if ((i1 | 0) > 0) {
      i3 = i4 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
      i4 = i3;
      i3 = (HEAP32[i3 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
      break;
     } else {
      i3 = 77 - i1 | 0;
      i19 = i4 + (((i3 | 0) / -78 | 0) << 2) | 0;
      i4 = i19;
      i3 = (HEAP32[i19 >> 2] | 0) + ((77 - ((i3 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
      break;
     }
    } while (0);
    if ((i6 | 0) <= 0) break L30;
    i1 = i6;
    i6 = i3;
    i3 = HEAP32[i4 >> 2] | 0;
   }
  } while (0);
  __ZN10InputEventD2Ev(i20);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  i1 = (HEAP32[i24 >> 2] | 0) + 1 | 0;
  HEAP32[i24 >> 2] = i1;
  if (i1 >>> 0 > 155) {
   __ZdlPv(HEAP32[HEAP32[i25 >> 2] >> 2] | 0);
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 4;
   i3 = (HEAP32[i24 >> 2] | 0) + -78 | 0;
   HEAP32[i24 >> 2] = i3;
  } else i3 = i1;
 }
 i25 = HEAP32[i25 >> 2] | 0;
 i4 = i25 + (((i3 >>> 0) / 78 | 0) << 2) | 0;
 if ((HEAP32[i26 >> 2] | 0) == (i25 | 0)) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = 0;
  i3 = (HEAP32[i4 >> 2] | 0) + (((i3 >>> 0) % 78 | 0) * 52 | 0) | 0;
 }
 i26 = i27;
 HEAP32[i26 >> 2] = i1 | i4;
 HEAP32[i26 + 4 >> 2] = i3;
 if (i2) {
  STACKTOP = i28;
  return;
 }
 i2 = i27 + 4 | 0;
 i1 = ((i3 - (HEAP32[i4 >> 2] | 0) | 0) / 52 | 0) + i5 | 0;
 if ((i1 | 0) > 0) {
  i26 = i4 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
  HEAP32[i27 >> 2] = i26;
  HEAP32[i2 >> 2] = (HEAP32[i26 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0);
  STACKTOP = i28;
  return;
 } else {
  i26 = 77 - i1 | 0;
  i25 = i4 + (((i26 | 0) / -78 | 0) << 2) | 0;
  HEAP32[i27 >> 2] = i25;
  HEAP32[i2 >> 2] = (HEAP32[i25 >> 2] | 0) + ((77 - ((i26 | 0) % 78 | 0) | 0) * 52 | 0);
  STACKTOP = i28;
  return;
 }
}

function __ZN13WheelCollider8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i2 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034411 | 0, HEAP32[gb + 37324 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 72 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843745 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827182 | 0, gb + 827201 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI11JointSpringE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827213 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827234 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   i3 = i1 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i1 >>> 0) i6 = 40; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i6 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827258 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 51; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 51; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827265 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 62; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 62; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 62) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __ZN14SafeBinaryRead8TransferI18WheelFrictionCurveEEvRT_PKc17TransferMetaFlags(i9, i7 + 104 | 0, gb + 827284 | 0, 0);
 __ZN14SafeBinaryRead8TransferI18WheelFrictionCurveEEvRT_PKc17TransferMetaFlags(i9, i7 + 124 | 0, gb + 827302 | 0, 0);
 i3 = i7 + 41 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1047713 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN18BuoyancyEffector2D8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i5, i9);
 i4 = i5 + 92 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800986 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 864119 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802772 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802447 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801001 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801013 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801029 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 72; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK8GUIStyle14DrawBackgroundER8GUIStateRK5RectTIfEPK13GUIStyleState(i15, i7, i8, i13) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 24 | 0;
 i17 = i19 + 16 | 0;
 i18 = i19;
 f9 = Math_fround(HEAPF32[i7 + 252 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 256 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + 260 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 264 >> 2]);
 HEAPF32[gb + 1468288 >> 2] = f9;
 HEAPF32[gb + 1468288 + 4 >> 2] = f11;
 HEAPF32[gb + 1468288 + 8 >> 2] = f10;
 HEAPF32[gb + 1468288 + 12 >> 2] = f12;
 __ZN10Matrix4x4f11SetIdentityEv(i16) | 0;
 i1 = f10 > Math_fround(0.0);
 f10 = Math_fround(Math_fround(.875) / f10);
 f10 = i1 ? f10 : Math_fround(inf);
 HEAPF32[i16 >> 2] = f10;
 i1 = f12 > Math_fround(0.0);
 f12 = Math_fround(Math_fround(.875) / f12);
 f12 = i1 ? f12 : Math_fround(inf);
 HEAPF32[i16 + 20 >> 2] = f12;
 HEAPF32[i16 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f9 * f10));
 HEAPF32[i16 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(f11 * f12));
 HEAPF32[i16 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i16 + 56 >> 2] = Math_fround(1.0);
 i1 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i2 = i16;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i17 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i14 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i17);
   i2 = HEAP32[i16 >> 2] | 0;
   i20 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i14 = 9;
 }
 if ((i14 | 0) == 7) i14 = 9;
 if ((i14 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
  STACKTOP = i19;
  return;
 }
 f10 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i7 + 28 >> 2]));
 f11 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i7 + 32 >> 2]));
 f12 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i7 + 36 >> 2]));
 f9 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i7 + 40 >> 2]));
 f4 = Math_fround(f9 * Math_fround(.5));
 f9 = (HEAP32[i7 + 60 >> 2] | 0) == 0 ? f4 : f9;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f21 = Math_fround(f4 - Math_fround(HEAP32[i15 + 224 >> 2] | 0));
 f6 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f5 = Math_fround(f6 - Math_fround(HEAP32[i15 + 232 >> 2] | 0));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i8 + 8 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAP32[i15 + 228 >> 2] | 0));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i8 + 12 >> 2]));
 f4 = Math_fround(f4 - f21);
 f6 = Math_fround(Math_fround(f6 + Math_fround(HEAP32[i15 + 236 >> 2] | 0)) - f5);
 HEAPF32[i18 >> 2] = f21;
 HEAPF32[i18 + 8 >> 2] = f4;
 HEAPF32[i18 + 4 >> 2] = f5;
 HEAPF32[i18 + 12 >> 2] = f6;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i3 = 0; else {
  HEAP32[i17 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i17);
    i2 = HEAP32[i16 >> 2] | 0;
    i20 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 18;
   }
  }
  if ((i14 | 0) == 16) i14 = 18;
  if ((i14 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
  i3 = i1;
 }
 f4 = Math_fround(HEAP32[i15 + 176 >> 2] | 0);
 f5 = Math_fround(HEAP32[i15 + 180 >> 2] | 0);
 f6 = Math_fround(HEAP32[i15 + 184 >> 2] | 0);
 i2 = ~~Math_fround(HEAP32[i15 + 188 >> 2] | 0);
 i1 = f10 < Math_fround(0.0);
 f21 = i1 ? Math_fround(0.0) : f10;
 i1 = f21 > Math_fround(1.0);
 HEAP8[i17 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = f11 < Math_fround(0.0);
 f21 = i1 ? Math_fround(0.0) : f11;
 i1 = f21 > Math_fround(1.0);
 HEAP8[i17 + 1 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = f12 < Math_fround(0.0);
 f21 = i1 ? Math_fround(0.0) : f12;
 i1 = f21 > Math_fround(1.0);
 HEAP8[i17 + 2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = f9 < Math_fround(0.0);
 f21 = i1 ? Math_fround(0.0) : f9;
 i1 = f21 > Math_fround(1.0);
 HEAP8[i17 + 3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f21) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = HEAP32[gb + 1468864 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, gb + 1017441 | 0, 30);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i16) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1468864 >> 2] = i1;
  __Z24InitializeGUIClipTexturev();
  i1 = HEAP32[gb + 1468864 >> 2] | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Textureiiii11ColorRGBA32P8Materiali(i18, i3, ~~f4, ~~f5, ~~f6, i2, i16, i1, -1);
 STACKTOP = i19;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN17AudioChorusFilter8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i5, i9);
 i4 = i5 + 44 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853419 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853428 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853438 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853448 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853458 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853466 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853473 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 72; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN11b2WeldJoint24SolveVelocityConstraintsERK12b2SolverData(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i17 = i16 + 116 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i12 = i1 + 28 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 + (i18 * 12 | 0) >> 2] | 0;
 i1 = i13 + (i18 * 12 | 0) + 4 | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i13 + (i18 * 12 | 0) + 8 >> 2]);
 i3 = i16 + 120 | 0;
 i19 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i13 + (i19 * 12 | 0) >> 2] | 0;
 i5 = HEAP32[i13 + (i19 * 12 | 0) + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i13 + (i19 * 12 | 0) + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i16 + 156 >> 2]);
 f8 = Math_fround(HEAPF32[i16 + 160 >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 164 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 168 >> 2]);
 i19 = Math_fround(HEAPF32[i16 + 68 >> 2]) > Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i16 + 204 >> 2]);
 if (i19) {
  f26 = Math_fround(f6 - f2);
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i16 + 76 >> 2]));
  f28 = Math_fround(HEAPF32[i16 + 100 >> 2]);
  i19 = i16 + 112 | 0;
  f25 = Math_fround(HEAPF32[i19 >> 2]);
  f28 = Math_fround(f11 * Math_fround(f26 + Math_fround(f28 * f25)));
  f26 = Math_fround(-f28);
  HEAPF32[i19 >> 2] = Math_fround(f25 - f28);
  f28 = Math_fround(f2 - Math_fround(f9 * f26));
  f26 = Math_fround(f6 + Math_fround(f10 * f26));
  f11 = Math_fround(HEAPF32[i16 + 136 >> 2]);
  f2 = Math_fround(f11 * f26);
  f25 = Math_fround(HEAPF32[i16 + 132 >> 2]);
  f29 = Math_fround(f25 * f26);
  f24 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(f24 - f2);
  f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f22 + f29);
  f23 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(f2 - f23);
  f21 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 - f21);
  f6 = Math_fround(HEAPF32[i16 + 128 >> 2]);
  f30 = Math_fround(f6 * f28);
  f27 = Math_fround(HEAPF32[i16 + 124 >> 2]);
  f2 = Math_fround(f30 + f2);
  f29 = Math_fround(f29 - Math_fround(f27 * f28));
  f30 = Math_fround(Math_fround(HEAPF32[i16 + 172 >> 2]) * f2);
  f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i16 + 184 >> 2]) * f29));
  f2 = Math_fround(Math_fround(HEAPF32[i16 + 176 >> 2]) * f2);
  f29 = Math_fround(f2 + Math_fround(f29 * Math_fround(HEAPF32[i16 + 188 >> 2])));
  f2 = Math_fround(-f30);
  f20 = Math_fround(-f29);
  i19 = i16 + 104 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f30);
  i19 = i16 + 108 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f29);
  f6 = Math_fround(f28 - Math_fround(f9 * Math_fround(Math_fround(f27 * f20) - Math_fround(f6 * f2))));
  f11 = Math_fround(f26 + Math_fround(f10 * Math_fround(Math_fround(f25 * f20) - Math_fround(f11 * f2))));
  f9 = Math_fround(f24 + Math_fround(f8 * f2));
  f2 = Math_fround(f23 - Math_fround(f7 * f2));
  f10 = Math_fround(f22 + Math_fround(f8 * f20));
  f8 = Math_fround(f21 - Math_fround(f7 * f20));
  i19 = i13 + (i18 * 12 | 0) | 0;
  HEAPF32[i19 >> 2] = f2;
  HEAPF32[i1 >> 2] = f8;
  i19 = HEAP32[i17 >> 2] | 0;
  i18 = HEAP32[i12 >> 2] | 0;
  i19 = i18 + (i19 * 12 | 0) + 8 | 0;
  HEAPF32[i19 >> 2] = f6;
  i19 = HEAP32[i3 >> 2] | 0;
  i17 = i18 + (i19 * 12 | 0) | 0;
  HEAPF32[i17 >> 2] = f9;
  i19 = i18 + (i19 * 12 | 0) + 4 | 0;
  HEAPF32[i19 >> 2] = f10;
  i19 = HEAP32[i3 >> 2] | 0;
  i18 = HEAP32[i12 >> 2] | 0;
  i19 = i18 + (i19 * 12 | 0) + 8 | 0;
  HEAPF32[i19 >> 2] = f11;
  return;
 } else {
  f22 = Math_fround(HEAPF32[i16 + 136 >> 2]);
  f30 = Math_fround(f6 * f22);
  f21 = Math_fround(HEAPF32[i16 + 132 >> 2]);
  f25 = Math_fround(f6 * f21);
  f28 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = Math_fround(f28 - f30);
  f29 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f29 + f25);
  f23 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f30 = Math_fround(f30 - f23);
  f24 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f25 = Math_fround(f25 - f24);
  f27 = Math_fround(HEAPF32[i16 + 128 >> 2]);
  f32 = Math_fround(f2 * f27);
  f20 = Math_fround(HEAPF32[i16 + 124 >> 2]);
  f32 = Math_fround(f30 + f32);
  f25 = Math_fround(f25 - Math_fround(f2 * f20));
  f30 = Math_fround(f6 - f2);
  f34 = Math_fround(f32 * Math_fround(HEAPF32[i16 + 172 >> 2]));
  f33 = Math_fround(f32 * Math_fround(HEAPF32[i16 + 176 >> 2]));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i16 + 180 >> 2]));
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i16 + 184 >> 2]));
  f31 = Math_fround(f25 * Math_fround(HEAPF32[i16 + 188 >> 2]));
  f26 = Math_fround(f34 + f26);
  f31 = Math_fround(f33 + f31);
  f25 = Math_fround(f32 + Math_fround(f25 * Math_fround(HEAPF32[i16 + 192 >> 2])));
  f32 = Math_fround(f30 * Math_fround(HEAPF32[i16 + 196 >> 2]));
  f32 = Math_fround(f26 + f32);
  f31 = Math_fround(f31 + Math_fround(f30 * Math_fround(HEAPF32[i16 + 200 >> 2])));
  f30 = Math_fround(f25 + Math_fround(f30 * f11));
  f25 = Math_fround(-f32);
  f26 = Math_fround(-f31);
  i19 = i16 + 104 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f32);
  i19 = i16 + 108 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f31);
  i19 = i16 + 112 | 0;
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f30);
  f27 = Math_fround(f2 - Math_fround(f9 * Math_fround(Math_fround(Math_fround(f20 * f26) - Math_fround(f27 * f25)) - f30)));
  f30 = Math_fround(f6 + Math_fround(f10 * Math_fround(Math_fround(Math_fround(f21 * f26) - Math_fround(f22 * f25)) - f30)));
  f28 = Math_fround(f28 + Math_fround(f8 * f25));
  f25 = Math_fround(f23 - Math_fround(f7 * f25));
  f29 = Math_fround(f29 + Math_fround(f8 * f26));
  f26 = Math_fround(f24 - Math_fround(f7 * f26));
  i19 = i13 + (i18 * 12 | 0) | 0;
  HEAPF32[i19 >> 2] = f25;
  HEAPF32[i1 >> 2] = f26;
  i19 = HEAP32[i17 >> 2] | 0;
  i18 = HEAP32[i12 >> 2] | 0;
  i19 = i18 + (i19 * 12 | 0) + 8 | 0;
  HEAPF32[i19 >> 2] = f27;
  i19 = HEAP32[i3 >> 2] | 0;
  i17 = i18 + (i19 * 12 | 0) | 0;
  HEAPF32[i17 >> 2] = f28;
  i19 = i18 + (i19 * 12 | 0) + 4 | 0;
  HEAPF32[i19 >> 2] = f29;
  i19 = HEAP32[i3 >> 2] | 0;
  i18 = HEAP32[i12 >> 2] | 0;
  i19 = i18 + (i19 * 12 | 0) + 8 | 0;
  HEAPF32[i19 >> 2] = f30;
  return;
 }
}

function __ZN10VertexData8TransferI14SafeBinaryReadEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i14 = i15 + 16 | 0;
 i10 = i15 + 40 | 0;
 i8 = i12 + 88 | 0;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 430604 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i11 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i11 = 6; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 i5 = i12 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 430622 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i13 + 16 | 0;
   i7 = HEAP32[i13 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 + 36 >> 2] | 0, 0 - (HEAP32[i13 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i11 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i13 + 24 >> 2] | 0) >>> 0) i11 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i11 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i13 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i3 = i9;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 853571 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i13, i14, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i13 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
 }
 switch (HEAP32[i2 >> 2] | 0) {
 case 8:
  {
   _memmove(i12 | 0, HEAP32[i14 >> 2] | 0, 32) | 0;
   break;
  }
 case 6:
  {
   i4 = HEAP32[i14 >> 2] | 0;
   _memmove(i12 | 0, i4 | 0, 20) | 0;
   i3 = i12 + 20 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i12 + 28 >> 2] = HEAP32[i4 + 20 >> 2];
   if ((HEAP8[i12 + 10 >> 0] | 0) == 2) HEAP8[i12 + 11 >> 0] = 4;
   break;
  }
 case 0:
  {
   i4 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i4 << 2 & 128 | i4 & 31;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
   HEAP32[i12 + 24 >> 2] = 0;
   HEAP32[i12 + 28 >> 2] = 0;
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430681 | 0, 0, gb + 430527 | 0, 118, 1, 0, 0, 0);
   HEAP32[i8 >> 2] = 0;
  }
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 if (!(HEAP8[i12 + 3 >> 0] | 0)) i1 = 0; else {
  i1 = i9 + (HEAPU8[i12 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
  i1 = 1;
 }
 if (HEAP8[i12 + 7 >> 0] | 0) {
  i4 = i9 + (HEAPU8[i12 + 4 >> 0] << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
  i1 = i1 | 2;
 }
 if (HEAP8[i12 + 11 >> 0] | 0) {
  i4 = i9 + (HEAPU8[i12 + 8 >> 0] << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
  i1 = i1 | 4;
 }
 if (HEAP8[i12 + 15 >> 0] | 0) {
  i4 = i9 + (HEAPU8[i12 + 12 >> 0] << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 8;
  i1 = i1 | 8;
 }
 if (HEAP8[i12 + 19 >> 0] | 0) {
  i4 = i9 + (HEAPU8[i12 + 16 >> 0] << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 16;
  i1 = i1 | 16;
 }
 if (HEAP8[i12 + 23 >> 0] | 0) {
  i4 = i9 + (HEAPU8[i12 + 20 >> 0] << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 32;
  i1 = i1 | 32;
 }
 if (!(HEAP8[i12 + 27 >> 0] | 0)) i2 = i1; else {
  i2 = i9 + (HEAPU8[i12 + 24 >> 0] << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 64;
  i2 = i1 | 64;
 }
 if (!(HEAP8[i12 + 31 >> 0] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i2) {
   i10 = HEAP32[i8 >> 2] | 0;
   __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i12, i1, i10, ~i10, gb + 59212 | 0, gb + 1546313 | 0);
  } else i11 = 38;
 } else {
  i1 = i9 + (HEAPU8[i12 + 28 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 128;
  i2 = i2 | 128;
  i1 = HEAP32[i5 >> 2] | 0;
  i11 = 38;
 }
 if ((i11 | 0) == 38) {
  HEAP16[i10 >> 1] = HEAP16[i12 + 2 >> 1] | 0;
  HEAP16[i10 + 2 >> 1] = HEAP16[i12 + 6 >> 1] | 0;
  HEAP16[i10 + 4 >> 1] = HEAP16[i12 + 10 >> 1] | 0;
  HEAP16[i10 + 6 >> 1] = HEAP16[i12 + 14 >> 1] | 0;
  HEAP16[i10 + 8 >> 1] = HEAP16[i12 + 18 >> 1] | 0;
  HEAP16[i10 + 10 >> 1] = HEAP16[i12 + 22 >> 1] | 0;
  HEAP16[i10 + 12 >> 1] = HEAP16[i12 + 26 >> 1] | 0;
  HEAP16[i10 + 14 >> 1] = HEAP16[i12 + 30 >> 1] | 0;
  __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i12, i1, i2, ~i2, i9, i10);
 }
 i4 = i12 + 96 | 0;
 __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i13, i4, gb + 430648 | 0, 1);
 i3 = i12 + 84 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[i13 + 128 >> 0] | 0)) i2 = i1; else {
  if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  i1 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
  if (i2 | 0) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 if (!i2) i1 = 0; else i1 = HEAP32[i4 >> 2] | 0;
 __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i13, i1, i2, 0);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i7);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i37, i38, i1) {
 i37 = i37 | 0;
 i38 = i38 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i39 = 0, i40 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i36 + 72 | 0;
 i32 = i36 + 68 | 0;
 i33 = i36 + 64 | 0;
 i34 = i36 + 32 | 0;
 i35 = i36;
 i2 = i37 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > (HEAP32[i37 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i33, 4); else {
  HEAP32[i33 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i1;
 };
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 i7 = i34 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i34 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i30 = i38 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i38, HEAP32[i30 >> 2] | 0);
 i8 = i38 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i38 >> 2] = i30;
 HEAP32[i30 >> 2] = 0;
 if ((HEAP32[i33 >> 2] | 0) > 0) {
  i9 = i34 + 11 | 0;
  i10 = i34 + 4 | 0;
  i11 = i35 + 12 | 0;
  i5 = i35 + 12 | 0;
  i12 = i31 + 4 | 0;
  i13 = i35 + 8 | 0;
  i14 = i35 + 4 | 0;
  i15 = i35 + 16 | 0;
  i16 = i7 + 11 | 0;
  i17 = i34 + 20 | 0;
  i18 = i35 + 28 | 0;
  i6 = i35 + 28 | 0;
  i19 = i31 + 4 | 0;
  i20 = i35 + 24 | 0;
  i21 = i35 + 20 | 0;
  i22 = i38 + 8 | 0;
  i23 = i31 + 4 | 0;
  i24 = i38 + 4 | 0;
  i25 = i35 + 16 | 0;
  i26 = i25 + 11 | 0;
  i27 = i31 + 4 | 0;
  i28 = i35 + 11 | 0;
  i29 = i31 + 4 | 0;
  i30 = i15 + 11 | 0;
  i4 = 0;
  do {
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i37, i34, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i37);
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i37, i7, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i37);
   i3 = HEAP8[i9 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i34 >> 2] | 0 : i34;
   i3 = i1 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i35 + 4 >> 2] = 0;
   HEAP32[i35 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i35);
    i1 = HEAP32[i5 >> 2] | 0;
    i39 = 14;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i28 >> 0] = i3;
    if (!i3) i1 = i35; else {
     i1 = i35;
     i39 = 16;
    }
   } else i39 = 14;
   if ((i39 | 0) == 14) {
    i40 = i3 + 16 & -16;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i40, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i35 >> 2] = i1;
    HEAP32[i13 >> 2] = i40 | -2147483648;
    HEAP32[i14 >> 2] = i3;
    i39 = 16;
   }
   if ((i39 | 0) == 16) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = HEAP8[i16 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
   i3 = i1 ? HEAP32[i17 >> 2] | 0 : i3 & 255;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i18 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
    i1 = HEAP32[i6 >> 2] | 0;
    i39 = 20;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i30 >> 0] = i3;
    if (!i3) i1 = i15; else {
     i1 = i15;
     i39 = 22;
    }
   } else i39 = 20;
   if ((i39 | 0) == 20) {
    i40 = i3 + 16 & -16;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i19 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i40, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i15 >> 2] = i1;
    HEAP32[i20 >> 2] = i40 | -2147483648;
    HEAP32[i21 >> 2] = i3;
    i39 = 22;
   }
   if ((i39 | 0) == 22) {
    i39 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i38, i32, i35) | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = HEAP32[i22 >> 2] | 0;
    HEAP32[i31 >> 2] = 1;
    HEAP32[i23 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
    __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_(i1 + 16 | 0, i35);
    i2 = HEAP32[i32 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i38 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i38 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i24 >> 2] | 0, i1);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
   if ((HEAP8[i26 >> 0] | 0) < 0) {
    i40 = HEAP32[i25 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i27 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
   }
   if ((HEAP8[i28 >> 0] | 0) < 0) {
    i40 = HEAP32[i35 >> 2] | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i29 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i33 >> 2] | 0));
  if ((HEAP8[i34 + 16 + 11 >> 0] | 0) < 0) {
   i40 = HEAP32[i34 + 16 >> 2] | 0;
   i39 = HEAP32[i34 + 28 >> 2] | 0;
   HEAP32[i31 >> 2] = 66;
   HEAP32[i31 + 4 >> 2] = i39;
   __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
  }
 }
 if ((HEAP8[i34 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i36;
  return;
 }
 i40 = HEAP32[i34 >> 2] | 0;
 i39 = HEAP32[i34 + 12 >> 2] | 0;
 HEAP32[i31 >> 2] = 66;
 HEAP32[i31 + 4 >> 2] = i39;
 __Z19free_alloc_internalPvRK10MemLabelId(i40, i31);
 STACKTOP = i36;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEbT0_SC_T_(i18, i19, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 switch ((i19 - i18 | 0) / 24 | 0 | 0) {
 case 2:
  {
   i9 = i19 + -24 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
   i7 = i2;
   i8 = i1;
   do if (i1 >>> 0 < i2 >>> 0) {
    i4 = i19 + -16 | 0;
    i1 = i4;
    i3 = i18 + 8 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   } else {
    if (i2 >>> 0 < i1 >>> 0) {
     i19 = 1;
     return i19 | 0;
    }
    i4 = i19 + -16 | 0;
    i1 = i4;
    i2 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = i18 + 8 | 0;
    i6 = i3;
    i5 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0) & (i1 | 0) == (i6 | 0)) {
     i16 = i19 + -8 | 0;
     i14 = HEAP32[i16 + 4 >> 2] | 0;
     i17 = i18 + 16 | 0;
     i15 = HEAP32[i17 + 4 >> 2] | 0;
     if (i14 >>> 0 < i15 >>> 0 | ((i14 | 0) == (i15 | 0) ? (HEAP32[i16 >> 2] | 0) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0 : 0)) break; else i1 = 1;
     return i1 | 0;
    } else {
     if (i1 >>> 0 < i6 >>> 0 | (i1 | 0) == (i6 | 0) & i2 >>> 0 < i5 >>> 0) break; else i1 = 1;
     return i1 | 0;
    }
   } while (0);
   HEAP32[i18 >> 2] = i8;
   HEAP32[i9 >> 2] = i7;
   i15 = i3;
   i14 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 4 >> 2] | 0;
   i16 = i18 + 16 | 0;
   i18 = i16;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   i12 = i3;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i12 + 4 >> 2] = i1;
   i19 = i19 + -8 | 0;
   i12 = i19;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i16 + 4 >> 2] = i13;
   i16 = i4;
   HEAP32[i16 >> 2] = i14;
   HEAP32[i16 + 4 >> 2] = i15;
   HEAP32[i19 >> 2] = i17;
   HEAP32[i19 + 4 >> 2] = i18;
   i19 = 1;
   return i19 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i18, i18 + 24 | 0, i19 + -24 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_(i18, i18 + 24 | 0, i18 + 48 | 0, i19 + -24 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_(i18, i18 + 24 | 0, i18 + 48 | 0, i18 + 72 | 0, i19 + -24 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 1:
 case 0:
  {
   i19 = 1;
   return i19 | 0;
  }
 default:
  {
   i3 = i18 + 48 | 0;
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i18, i18 + 24 | 0, i3, i1) | 0;
   i1 = i18 + 72 | 0;
   L3 : do if ((i1 | 0) == (i19 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i15 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     i16 = i15;
     i10 = i4;
     do if (i15 >>> 0 < i4 >>> 0) {
      i5 = i1 + 8 | 0;
      i9 = i5;
      i4 = i3 + 8 | 0;
      i7 = i4;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      i17 = 19;
     } else if (i4 >>> 0 >= i15 >>> 0) {
      i5 = i1 + 8 | 0;
      i9 = i5;
      i8 = HEAP32[i9 >> 2] | 0;
      i9 = HEAP32[i9 + 4 >> 2] | 0;
      i4 = i3 + 8 | 0;
      i7 = i4;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      if ((i8 | 0) == (i6 | 0) & (i9 | 0) == (i7 | 0)) {
       i13 = i1 + 16 | 0;
       i11 = HEAP32[i13 + 4 >> 2] | 0;
       i14 = i3 + 16 | 0;
       i12 = HEAP32[i14 + 4 >> 2] | 0;
       if (i11 >>> 0 < i12 >>> 0 | ((i11 | 0) == (i12 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0 : 0)) {
        i6 = i8;
        i7 = i9;
        i17 = 19;
        break;
       } else break;
      } else if (i9 >>> 0 < i7 >>> 0 | (i9 | 0) == (i7 | 0) & i8 >>> 0 < i6 >>> 0) {
       i17 = 19;
       break;
      } else break;
     } while (0);
     if ((i17 | 0) == 19) {
      i17 = 0;
      i12 = i1 + 16 | 0;
      i14 = i12;
      i13 = HEAP32[i14 >> 2] | 0;
      i14 = HEAP32[i14 + 4 >> 2] | 0;
      HEAP32[i1 >> 2] = i10;
      HEAP32[i5 >> 2] = i6;
      HEAP32[i5 + 4 >> 2] = i7;
      i5 = i3 + 16 | 0;
      i10 = i5;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
      L15 : do if ((i3 | 0) != (i18 | 0)) {
       i12 = i3;
       i10 = i4;
       while (1) {
        i3 = i12 + -24 | 0;
        i4 = HEAP32[i3 >> 2] | 0;
        i11 = i4;
        do if (i15 >>> 0 < i4 >>> 0) {
         i4 = i12 + -16 | 0;
         i5 = i4;
         i6 = HEAP32[i5 >> 2] | 0;
         i5 = HEAP32[i5 + 4 >> 2] | 0;
        } else {
         if (i4 >>> 0 < i15 >>> 0) {
          i4 = i10;
          i3 = i12;
          break L15;
         }
         i4 = i12 + -16 | 0;
         i7 = i4;
         i6 = HEAP32[i7 >> 2] | 0;
         i7 = HEAP32[i7 + 4 >> 2] | 0;
         if ((i8 | 0) == (i6 | 0) & (i9 | 0) == (i7 | 0)) {
          i7 = i12 + -8 | 0;
          i6 = HEAP32[i7 + 4 >> 2] | 0;
          if (i14 >>> 0 < i6 >>> 0 | ((i14 | 0) == (i6 | 0) ? i13 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0 : 0)) {
           i6 = i8;
           i5 = i9;
           break;
          } else {
           i4 = i10;
           i3 = i12;
           break L15;
          }
         } else if (i9 >>> 0 < i7 >>> 0 | (i9 | 0) == (i7 | 0) & i8 >>> 0 < i6 >>> 0) {
          i5 = i7;
          break;
         } else {
          i4 = i10;
          i3 = i12;
          break L15;
         }
        } while (0);
        HEAP32[i12 >> 2] = i11;
        i10 = i12 + 8 | 0;
        HEAP32[i10 >> 2] = i6;
        HEAP32[i10 + 4 >> 2] = i5;
        i5 = i12 + -8 | 0;
        i10 = i5;
        i11 = HEAP32[i10 + 4 >> 2] | 0;
        i12 = i12 + 16 | 0;
        HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
        HEAP32[i12 + 4 >> 2] = i11;
        if ((i3 | 0) == (i18 | 0)) break; else {
         i12 = i3;
         i10 = i4;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = i16;
      i16 = i4;
      HEAP32[i16 >> 2] = i8;
      HEAP32[i16 + 4 >> 2] = i9;
      i16 = i5;
      HEAP32[i16 >> 2] = i13;
      HEAP32[i16 + 4 >> 2] = i14;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 24 | 0) == (i19 | 0);
       break L3;
      }
     }
     i3 = i1 + 24 | 0;
     if ((i3 | 0) == (i19 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i16 = i1;
      i1 = i3;
      i3 = i16;
     }
    }
   } while (0);
   i19 = i1 | i2;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN5physx18NpArticulationLink17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i15 >> 2] = HEAP32[gb + 124228 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 124228 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 124228 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 124228 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 124228 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 124228 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 124228 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 124228 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = gb + 754732;
 HEAP32[i14 + 4 >> 2] = gb + 827530;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 336;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 1;
 HEAP32[i14 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = gb + 754732;
 HEAP32[i13 + 4 >> 2] = gb + 747076;
 HEAP32[i13 + 8 >> 2] = 12;
 HEAP32[i13 + 12 >> 2] = 336;
 HEAP32[i13 + 16 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 1;
 HEAP32[i13 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 124260 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 124260 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 124260 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 124260 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 124260 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 124260 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 124260 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 124260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 124292 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 124292 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 124292 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 124292 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 124292 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 124292 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 124292 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 124292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 124324 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 124324 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 124324 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 124324 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 124324 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 124324 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 124324 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 124324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 124356 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 124356 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 124356 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 124356 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 124356 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 124356 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 124356 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 124356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124388 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124388 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124388 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124388 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124388 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124388 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124388 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 124420 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 124420 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 124420 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 124420 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 124420 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 124420 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 124420 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 124420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124452 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124452 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124452 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124452 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124452 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124452 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124452 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124452 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 124484 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 124484 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 124484 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 124484 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 124484 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 124484 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 124484 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 124484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc5Scene29fireBrokenConstraintCallbacksEv(i25) {
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i34 + 488 | 0;
 i27 = i34 + 424 | 0;
 i24 = i34 + 16 | 0;
 i22 = i34;
 i31 = i34 + 24 | 0;
 i13 = HEAP32[i25 + 196 >> 2] | 0;
 i32 = i33 + 512 | 0;
 i29 = i33 + 516 | 0;
 i26 = i33 + 520 | 0;
 HEAP32[i26 >> 2] = 0;
 i30 = i33 + 524 | 0;
 HEAP8[i32 >> 0] = 1;
 HEAP32[i29 >> 2] = i33;
 HEAP32[i30 >> 2] = 32;
 if (i13 >>> 0 > 32) {
  __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE8recreateEj(i33, i13);
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  i19 = i27;
  i28 = 4;
 } else {
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  if (!i13) i1 = 0; else {
   i19 = i27;
   i28 = 4;
  }
 }
 if ((i28 | 0) == 4) {
  i20 = i25 + 192 | 0;
  i21 = i25 + 1208 | 0;
  i14 = i25 + 1152 | 0;
  i15 = i22 + 4 | 0;
  i16 = i22 + 8 | 0;
  i17 = i22 + 12 | 0;
  i18 = i22 + 14 | 0;
  i1 = 0;
  i23 = 0;
  do {
   i12 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i23 << 2) >> 2] | 0;
   i3 = i12 + 68 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i11 = __ZN5physx2Sc13ConstraintSim8getRigidEj(i2, 0) | 0;
    if ((i11 | 0) == (HEAP32[i21 >> 2] | 0)) i4 = 0; else i4 = HEAP32[(__ZN5physx2Sc13ConstraintSim8getRigidEj(HEAP32[i3 >> 2] | 0, 0) | 0) + 52 >> 2] | 0;
    i11 = __ZN5physx2Sc13ConstraintSim8getRigidEj(HEAP32[i3 >> 2] | 0, 1) | 0;
    if ((i11 | 0) == (HEAP32[i21 >> 2] | 0)) i5 = 0; else i5 = HEAP32[(__ZN5physx2Sc13ConstraintSim8getRigidEj(HEAP32[i3 >> 2] | 0, 1) | 0) + 52 >> 2] | 0;
    i2 = (i4 | 0) != 0;
    if (i2) i10 = HEAP8[i4 + 13 >> 0] | 0; else i10 = 0;
    i3 = (i5 | 0) != 0;
    if (i3) i11 = HEAP8[i5 + 13 >> 0] | 0; else i11 = 0;
    if (i2) i8 = HEAP8[i4 + 11 >> 0] & 4; else i8 = 0;
    if (i3) i3 = HEAP8[i5 + 11 >> 0] & 4; else i3 = 0;
    i7 = i10 & 255;
    i4 = HEAP32[i14 >> 2] | 0;
    i6 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
    i2 = HEAP8[i6 + 12 >> 0] & 4;
    i9 = i11 & 255;
    i4 = HEAP32[i4 + (i9 << 2) >> 2] | 0;
    i5 = HEAP8[i4 + 12 >> 0] & 4;
    if (!(HEAP32[i6 + 16 >> 2] | 0)) i6 = 0; else if (i10 << 24 >> 24 == i11 << 24 >> 24) i6 = 1; else i6 = i3 << 24 >> 24 != 0 & i2 << 24 >> 24 != 0;
    i3 = i5 << 24 >> 24 != 0 & (i8 << 24 >> 24 != 0 & (HEAP32[i4 + 16 >> 2] | 0 ? i10 << 24 >> 24 != i11 << 24 >> 24 : 0));
    if (i6 | i3) {
     HEAP32[i24 >> 2] = -1;
     i8 = HEAP32[i12 + 28 >> 2] | 0;
     i8 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0, i24 | 0) | 0;
     i12 = __ZN5physx2Sc14ConstraintCore15getPxConstraintEv(i12) | 0;
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP32[i22 >> 2] = i12;
     HEAP32[i15 >> 2] = i8;
     HEAP32[i16 >> 2] = i2;
     HEAP16[i17 >> 1] = i6 ? i10 & 255 : -1;
     HEAP16[i18 >> 1] = i3 ? i11 & 255 : -1;
     i2 = HEAP32[i26 >> 2] | 0;
     if ((HEAP32[i30 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      i12 = (HEAP32[i29 >> 2] | 0) + (i2 << 4) | 0;
      HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
      HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE15growAndPushBackERKS3_(i33, i22) | 0;
     if (i6) {
      i12 = i27 + (i7 >>> 3 << 2) | 0;
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1 << (i7 & 7);
      i12 = i7 + 1 & 65535;
      i1 = (i12 & 65535) < (i1 & 65535) ? i1 : i12;
     }
     if (i3) {
      i12 = i27 + (i9 >>> 3 << 2) | 0;
      HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1 << (i9 & 7);
      i12 = i9 + 1 & 65535;
      i1 = (i12 & 65535) < (i1 & 65535) ? i1 : i12;
     }
    }
   }
   i23 = i23 + 1 | 0;
  } while ((i23 | 0) != (i13 | 0));
 }
 i10 = i31 + 384 | 0;
 i9 = i31 + 388 | 0;
 i7 = i31 + 392 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i31 + 396 | 0;
 HEAP8[i10 >> 0] = 1;
 HEAP32[i9 >> 2] = i31;
 HEAP32[i8 >> 2] = 32;
 if (!(i1 << 16 >> 16)) i1 = 32; else {
  i6 = i25 + 1152 | 0;
  i4 = i1 & 65535;
  i5 = 0;
  do {
   if (HEAP32[i27 + (i5 >>> 3 << 2) >> 2] & 1 << (i5 & 7) | 0) {
    HEAP32[i7 >> 2] = 0;
    i1 = HEAP32[i26 >> 2] | 0;
    if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
     __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE8recreateEj(i31, i1);
     i1 = HEAP32[i26 >> 2] | 0;
    }
    if (i1 | 0) {
     i3 = 0;
     do {
      i1 = HEAP32[i29 >> 2] | 0;
      if ((HEAPU16[i1 + (i3 << 4) + 12 >> 1] | 0 | 0) == (i5 | 0)) i28 = 38; else if ((HEAPU16[i1 + (i3 << 4) + 14 >> 1] | 0 | 0) == (i5 | 0)) i28 = 38;
      do if ((i28 | 0) == 38) {
       i28 = 0;
       i1 = i1 + (i3 << 4) | 0;
       i2 = HEAP32[i7 >> 2] | 0;
       if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
        i25 = (HEAP32[i9 >> 2] | 0) + (i2 * 12 | 0) | 0;
        HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
        HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
        HEAP32[i25 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
        HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_(i31, i1) | 0;
        break;
       }
      } while (0);
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0);
    }
    i25 = HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0) + 16 >> 2] | 0;
    mftCall_viii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] | 0);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 do if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i31 | 0) == (i1 | 0)) {
   HEAP8[i10 >> 0] = 0;
   break;
  } else {
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i31, i1);
   break;
  }
 } while (0);
 i31 = HEAP32[i30 >> 2] | 0;
 if (!((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0)) {
  STACKTOP = i34;
  return;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if ((i33 | 0) == (i1 | 0)) {
  HEAP8[i32 >> 0] = 0;
  STACKTOP = i34;
  return;
 } else {
  __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i33, i1);
  STACKTOP = i34;
  return;
 }
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) {
     i6 = i4;
     break;
    } else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i6 = 0;
   }
   i4 = HEAP8[i9 >> 0] | 0;
   i4 = i4 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i4 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i4 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i4 << 1 | 0, 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i4;
   }
   i4 = i3 + 12 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i4 = i6;
    i24 = 39;
    break;
   }
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i4 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 201 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i2 = getTempRet0() | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    i25 = i17;
    HEAP32[i25 >> 2] = i1;
    HEAP32[i25 + 4 >> 2] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) {
     i6 = i4;
     break;
    } else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i6 = 0;
   }
   i4 = HEAP8[i9 >> 0] | 0;
   i4 = i4 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i4 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i4 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i4 << 1 | 0, 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i4;
   }
   i4 = i3 + 12 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i4 = i6;
    i24 = 39;
    break;
   }
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i4 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 205 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i2 = getTempRet0() | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    i25 = i17;
    HEAP32[i25 >> 2] = i1;
    HEAP32[i25 + 4 >> 2] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNK10InputEvent5DebugEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 112 | 0;
 i15 = i18 + 104 | 0;
 i14 = i18 + 88 | 0;
 i13 = i18 + 80 | 0;
 i12 = i18 + 72 | 0;
 i6 = i18 + 64 | 0;
 i8 = i18 + 48 | 0;
 i7 = i18 + 16 | 0;
 i11 = i18;
 i16 = i18 + 128 | 0;
 i5 = i18 + 116 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < 7) {
  i3 = i4 & 255;
  i1 = (112 >>> (i3 & 127) & 1) != 0;
  i3 = (15 >>> (i3 & 127) & 1) != 0;
  i2 = i5;
  i9 = 4;
 } else if (i4 >>> 0 > 15) {
  i1 = 0;
  i3 = 0;
  i4 = gb + 604454 | 0;
  i2 = i5;
 } else {
  i1 = 0;
  i3 = 0;
  i2 = i5;
  i9 = 4;
 }
 if ((i9 | 0) == 4) i4 = HEAP32[gb + 64800 + (i4 << 2) >> 2] | 0;
 i9 = HEAP32[i10 + 40 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = i9;
 __Z6FormatPKcz(i5, gb + 452039 | 0, i11);
 i9 = HEAP8[i5 + 11 >> 0] | 0;
 i4 = i9 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i4 ? HEAP32[i5 >> 2] | 0 : i2, i4 ? HEAP32[i5 + 4 >> 2] | 0 : i9 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (i3) {
  d22 = +Math_fround(HEAPF32[i10 + 4 >> 2]);
  d21 = +Math_fround(HEAPF32[i10 + 8 >> 2]);
  d20 = +Math_fround(HEAPF32[i10 + 12 >> 2]);
  d19 = +Math_fround(HEAPF32[i10 + 16 >> 2]);
  HEAPF64[i7 >> 3] = d22;
  HEAPF64[i7 + 8 >> 3] = d21;
  HEAPF64[i7 + 16 >> 3] = d20;
  HEAPF64[i7 + 24 >> 3] = d19;
  __Z6FormatPKcz(i11, gb + 452065 | 0, i7);
  i15 = HEAP8[i11 + 11 >> 0] | 0;
  i14 = i15 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i14 ? HEAP32[i11 >> 2] | 0 : i11, i14 ? HEAP32[i11 + 4 >> 2] | 0 : i15 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  HEAP32[i8 >> 2] = HEAP32[i10 + 20 >> 2];
  __Z6FormatPKcz(i7, gb + 452101 | 0, i8);
  i15 = HEAP8[i7 + 11 >> 0] | 0;
  i14 = i15 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i14 ? HEAP32[i7 >> 2] | 0 : i7, i14 ? HEAP32[i7 + 4 >> 2] | 0 : i15 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  HEAP32[i6 >> 2] = HEAP32[i10 + 32 >> 2];
  __Z6FormatPKcz(i8, gb + 452114 | 0, i6);
  i15 = HEAP8[i8 + 11 >> 0] | 0;
  i14 = i15 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i14 ? HEAP32[i8 >> 2] | 0 : i8, i14 ? HEAP32[i8 + 4 >> 2] | 0 : i15 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 } else if (i1) {
  i1 = HEAP16[i10 + 36 >> 1] | 0;
  if ((i1 + -32 & 65535) < 96) {
   HEAP32[i12 >> 2] = i1 & 65535;
   __Z6FormatPKcz(i11, gb + 452132 | 0, i12);
   i13 = HEAP8[i11 + 11 >> 0] | 0;
   i12 = i13 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i12 ? HEAP32[i11 >> 2] | 0 : i11, i12 ? HEAP32[i11 + 4 >> 2] | 0 : i13 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  } else {
   HEAP32[i13 >> 2] = i1 & 65535;
   __Z6FormatPKcz(i11, gb + 452151 | 0, i13);
   i13 = HEAP8[i11 + 11 >> 0] | 0;
   i12 = i13 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i12 ? HEAP32[i11 >> 2] | 0 : i11, i12 ? HEAP32[i11 + 4 >> 2] | 0 : i13 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
  HEAP32[i14 >> 2] = HEAPU16[i10 + 38 >> 1];
  __Z6FormatPKcz(i11, gb + 452173 | 0, i14);
  i13 = HEAP8[i11 + 11 >> 0] | 0;
  i12 = i13 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i12 ? HEAP32[i11 >> 2] | 0 : i11, i12 ? HEAP32[i11 + 4 >> 2] | 0 : i13 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  HEAP32[i15 >> 2] = HEAP8[i10 + 48 >> 0] | 0 ? gb + 1087447 | 0 : gb + 1087441 | 0;
  __Z6FormatPKcz(i14, gb + 452190 | 0, i15);
  i15 = HEAP8[i14 + 11 >> 0] | 0;
  i13 = i15 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i13 ? HEAP32[i14 >> 2] | 0 : i14, i13 ? HEAP32[i14 + 4 >> 2] | 0 : i15 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452207 | 0) | 0;
 i2 = i10 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452215 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452222 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 4) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452228 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452233 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 16) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452238 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 32) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452243 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 & 64) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452253 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 1074320 | 0) | 0;
  i14 = i16 + 11 | 0;
  i14 = HEAP8[i14 >> 0] | 0;
  i14 = i14 << 24 >> 24 < 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i15 = i14 ? i15 : i16;
  HEAP32[i17 >> 2] = i15;
  _printf_console(gb + 1074693 | 0, i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  STACKTOP = i18;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 452259 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 1074320 | 0) | 0;
 i14 = i16 + 11 | 0;
 i14 = HEAP8[i14 >> 0] | 0;
 i14 = i14 << 24 >> 24 < 0;
 i15 = HEAP32[i16 >> 2] | 0;
 i15 = i14 ? i15 : i16;
 HEAP32[i17 >> 2] = i15;
 _printf_console(gb + 1074693 | 0, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 STACKTOP = i18;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE26collideContinuousParticlesEv(i71) {
 i71 = i71 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i72 = 0, i73 = 0;
 i73 = STACKTOP;
 STACKTOP = STACKTOP + 944 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i62 = i73 + 880 | 0;
 i69 = i73 + 816 | 0;
 i68 = i73 + 800 | 0;
 i58 = i73 + 632 | 0;
 i65 = i73 + 616 | 0;
 i1 = i73 + 608 | 0;
 i13 = i73 + 592 | 0;
 i24 = i73 + 584 | 0;
 i34 = i73 + 568 | 0;
 i37 = i73 + 560 | 0;
 i40 = i73 + 544 | 0;
 i51 = i73 + 536 | 0;
 i59 = i73 + 520 | 0;
 i60 = i73 + 512 | 0;
 i3 = i73 + 496 | 0;
 i4 = i73 + 488 | 0;
 i5 = i73 + 472 | 0;
 i6 = i73 + 464 | 0;
 i7 = i73 + 448 | 0;
 i8 = i73 + 440 | 0;
 i9 = i73 + 424 | 0;
 i10 = i73 + 416 | 0;
 i61 = i73 + 688 | 0;
 i70 = i73 + 400 | 0;
 i67 = i73 + 384 | 0;
 i11 = i73 + 368 | 0;
 i66 = i73 + 352 | 0;
 i64 = i73 + 640 | 0;
 i12 = i73 + 336 | 0;
 i14 = i73 + 320 | 0;
 i15 = i73 + 304 | 0;
 i63 = i73 + 288 | 0;
 i16 = i73 + 272 | 0;
 i17 = i73 + 256 | 0;
 i18 = i73 + 240 | 0;
 i19 = i73 + 224 | 0;
 i20 = i73 + 208 | 0;
 i21 = i73 + 192 | 0;
 i72 = i73 + 176 | 0;
 i22 = i73 + 160 | 0;
 i23 = i73 + 144 | 0;
 i25 = i73 + 128 | 0;
 i26 = i73 + 112 | 0;
 i27 = i73 + 96 | 0;
 i28 = i73 + 80 | 0;
 i29 = i73 + 64 | 0;
 i30 = i73 + 48 | 0;
 i31 = i73 + 32 | 0;
 i32 = i73 + 16 | 0;
 i33 = i73;
 i2 = i71 + 432 | 0;
 i36 = (HEAP32[i2 >> 2] | 0) + 220 | 0;
 i35 = Math_fround(HEAPF32[i36 >> 2]) > Math_fround(0.0);
 HEAP32[i58 >> 2] = __Z6simd4fRKf(i36) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i68, i58);
 i58 = (HEAP32[i2 >> 2] | 0) + 216 | 0;
 i36 = Math_fround(HEAPF32[i58 >> 2]) > Math_fround(0.0);
 HEAP32[i1 >> 2] = __Z6simd4fRKf(i58) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i65, i1);
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i58 = HEAP32[i2 >> 2] << 2;
 i38 = i1 + (i58 << 2) | 0;
 if ((i58 | 0) <= 0) {
  STACKTOP = i73;
  return;
 }
 i39 = i69 + 16 | 0;
 i41 = i69 + 32 | 0;
 i42 = i69 + 48 | 0;
 i43 = i62 + 16 | 0;
 i44 = i62 + 32 | 0;
 i45 = i62 + 48 | 0;
 i46 = i61 + 96 | 0;
 i47 = i61 + 16 | 0;
 i48 = i61 + 32 | 0;
 i49 = i61 + 48 | 0;
 i50 = i61 + 64 | 0;
 i52 = i61 + 80 | 0;
 i53 = i64 + 16 | 0;
 i54 = i64 + 32 | 0;
 i55 = i61 + 16 | 0;
 i56 = i61 + 32 | 0;
 i57 = i61 + 16 | 0;
 i58 = i61 + 32 | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 while (1) {
  __Z11loadAlignedPKfj(i24, i2, 0);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i13, i24);
  __ZN8Scalar4faSERKS_(i69, i13) | 0;
  __Z11loadAlignedPKfj(i37, i2, 16);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i34, i37);
  __ZN8Scalar4faSERKS_(i39, i34) | 0;
  __Z11loadAlignedPKfj(i51, i2, 32);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i40, i51);
  __ZN8Scalar4faSERKS_(i41, i40) | 0;
  __Z11loadAlignedPKfj(i60, i2, 48);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i59, i60);
  __ZN8Scalar4faSERKS_(i42, i59) | 0;
  __Z9transposeR8Scalar4fS0_S0_S0_(i69, i39, i41, i42);
  __Z11loadAlignedPKfj(i4, i1, 0);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i3, i4);
  __ZN8Scalar4faSERKS_(i62, i3) | 0;
  __Z11loadAlignedPKfj(i6, i1, 16);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i5, i6);
  __ZN8Scalar4faSERKS_(i43, i5) | 0;
  __Z11loadAlignedPKfj(i8, i1, 32);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i7, i8);
  __ZN8Scalar4faSERKS_(i44, i7) | 0;
  __Z11loadAlignedPKfj(i10, i1, 48);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i9, i10);
  __ZN8Scalar4faSERKS_(i45, i9) | 0;
  __Z9transposeR8Scalar4fS0_S0_S0_(i62, i43, i44, i45);
  __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i61);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_PS2_RNS3_18ImpulseAccumulatorE(i70, i71, i69, i62, i61);
  __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_PS2_RNS3_18ImpulseAccumulatorE(i71, i70, i69, i62, i61);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i11, gb + 1097856 | 0);
  if (__Z10anyGreaterRK8Scalar4fS1_RS_(i46, i11, i67) | 0) {
   __Z5recipRK8Scalar4f(i66, i46);
   if (i36) {
    __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_(i61, i47, i48, i49, i50, i52, i62, i69, i66, i65, i67, i64);
    __ZmiRK8Scalar4fS1_(i12, i69, i64);
    __ZN8Scalar4faSERKS_(i69, i12) | 0;
    __ZmiRK8Scalar4fS1_(i14, i39, i53);
    __ZN8Scalar4faSERKS_(i39, i14) | 0;
    __ZmiRK8Scalar4fS1_(i15, i41, i54);
    __ZN8Scalar4faSERKS_(i41, i15) | 0;
    __Z9transposeR8Scalar4fS0_S0_S0_(i69, i39, i41, i42);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 0, i69);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 16, i39);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 32, i41);
    __Z12storeAlignedPfjRK8Scalar4f(i2, 48, i42);
   }
   if (i35) {
    __ZmlRK8Scalar4fS1_(i16, i66, i66);
    __ZmlRK8Scalar4fS1_(i19, i61, i61);
    __ZmlRK8Scalar4fS1_(i20, i55, i55);
    __ZplRK8Scalar4fS1_(i18, i19, i20);
    __ZmlRK8Scalar4fS1_(i21, i56, i56);
    __ZplRK8Scalar4fS1_(i17, i18, i21);
    __ZmlRK8Scalar4fS1_(i63, i16, i17);
    __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i23, gb + 1097760 | 0);
    __ZmlRK8Scalar4fS1_(i25, i68, i63);
    __ZplRK8Scalar4fS1_(i22, i23, i25);
    __Z5recipRK8Scalar4f(i72, i22);
    __ZmlRK8Scalar4fS1_(i27, i45, i72);
    __Z6selectRK8Scalar4fS1_S1_(i26, i67, i27, i45);
    __ZN8Scalar4faSERKS_(i45, i26) | 0;
   }
   __ZmlRK8Scalar4fS1_(i29, i61, i66);
   __ZplRK8Scalar4fS1_(i28, i62, i29);
   __ZN8Scalar4faSERKS_(i62, i28) | 0;
   __ZmlRK8Scalar4fS1_(i31, i57, i66);
   __ZplRK8Scalar4fS1_(i30, i43, i31);
   __ZN8Scalar4faSERKS_(i43, i30) | 0;
   __ZmlRK8Scalar4fS1_(i33, i58, i66);
   __ZplRK8Scalar4fS1_(i32, i44, i33);
   __ZN8Scalar4faSERKS_(i44, i32) | 0;
   __Z9transposeR8Scalar4fS0_S0_S0_(i62, i43, i44, i45);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 0, i62);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 16, i43);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 32, i44);
   __Z12storeAlignedPfjRK8Scalar4f(i1, 48, i45);
  }
  i1 = i1 + 64 | 0;
  if (i1 >>> 0 >= i38 >>> 0) break; else i2 = i2 + 64 | 0;
 }
 STACKTOP = i73;
 return;
}

function __ZN17PolygonCollider2D19ExtractConvexShapesER13dynamic_arrayIP7b2ShapeLj4EERK10Matrix4x4f(i17, i19, i9) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 i18 = __Z11tessNewTessP9TESSalloc(0) | 0;
 i10 = i17 + 160 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i16 = (HEAP32[i17 + 164 >> 2] | 0) - i3 | 0;
 i6 = (i16 | 0) / 20 | 0;
 if ((i16 | 0) > 0) {
  i7 = i20 + 4 | 0;
  i8 = i17 + 40 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   i5 = i3 + (i2 * 20 | 0) | 0;
   i3 = HEAP32[i3 + (i2 * 20 | 0) + 12 >> 2] | 0;
   if (i3 >>> 0 >= 3) {
    HEAP32[i20 >> 2] = 0;
    i14 = gb + 63160 | 0;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i7;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i3 = i3 << 3;
    do if (!i3) i3 = 0; else {
     i4 = (i3 | 4) + -1 | 0;
     if (i4 >>> 0 < 2e3) {
      i3 = STACKTOP;
      STACKTOP = STACKTOP + ((1 * i4 | 0) + 15 & -16) | 0;
      if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
      break;
     } else {
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, gb + 64016 | 0, 0, gb + 802461 | 0, 400) | 0;
      i15 = gb + 64016 | 0;
      i14 = HEAP32[i15 >> 2] | 0;
      i15 = HEAP32[i15 + 4 >> 2] | 0;
      HEAP32[i20 >> 2] = i3;
      i16 = i7;
      HEAP32[i16 >> 2] = i14;
      HEAP32[i16 + 4 >> 2] = i15;
      break;
     }
    } while (0);
    i4 = i3 + 3 & -4;
    i3 = __ZN17PolygonCollider2D15TransformPointsERK13dynamic_arrayI8Vector2fLj4EERK10Matrix4x4fRKS1_P6b2Vec2(i5, i9, i8, i4) | 0;
    if ((i3 | 0) >= 3) {
     __Z14tessAddContourP14TESStesselatoriPKvii(i18, 2, i4, 8, i3);
     i1 = i1 + 1 | 0;
    }
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i7);
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i6 | 0)) break;
   i3 = HEAP32[i10 >> 2] | 0;
  }
  if (i1 | 0) {
   __Z13tessTesselateP14TESStesselatoriiiiPKf(i18, 0, 0, 8, 2, 0) | 0;
   i13 = __Z19tessGetElementCountP14TESStesselator(i18) | 0;
   if (!i13) {
    __Z14tessDeleteTessP14TESStesselator(i18);
    i21 = 0;
    STACKTOP = i22;
    return i21 | 0;
   }
   i14 = i19 + 12 | 0;
   HEAP32[i14 >> 2] = i13;
   i15 = i19 + 16 | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   do if ((i1 & 2147483647) >>> 0 < i13 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i15 >> 2] = i13;
    HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i13 << 2, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 << 2, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i16 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
    HEAP32[i15 >> 2] = i13;
    HEAP32[i19 >> 2] = i16;
    break;
   } while (0);
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 * 152 | 0, 4, gb + 64016 | 0, 0, gb + 802461 | 0, 434) | 0;
   i11 = __Z15tessGetElementsP14TESStesselator(i18) | 0;
   i12 = __Z15tessGetVerticesP14TESStesselator(i18) | 0;
   HEAP32[i20 >> 2] = 0;
   i16 = i20 + 4 | 0;
   i9 = gb + 63160 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = i16;
   HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i2 + 4 >> 2] = i10;
   i2 = STACKTOP;
   STACKTOP = STACKTOP + 80 | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i10 = i2 + 3 & -4;
   if ((i13 | 0) > 0) {
    i9 = i17 + 56 | 0;
    i8 = 0;
    i4 = 0;
    do {
     i7 = i11 + (i8 << 3 << 2) | 0;
     i6 = 0;
     i2 = 0;
     do {
      i3 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
      if ((i3 | 0) == -1) break;
      i5 = i3 << 1;
      i3 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
      i5 = HEAP32[i12 + ((i5 | 1) << 2) >> 2] | 0;
      if ((i2 | 0) > 0) {
       i17 = i2 + -1 | 0;
       f24 = Math_fround(HEAPF32[i10 + (i17 << 3) >> 2]);
       f24 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       f23 = Math_fround(HEAPF32[i10 + (i17 << 3) + 4 >> 2]);
       f23 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
       if (!(Math_fround(Math_fround(f24 * f24) + Math_fround(f23 * f23)) <= Math_fround(6.24999984e-06))) i21 = 30;
      } else i21 = 30;
      if ((i21 | 0) == 30) {
       i21 = 0;
       HEAP32[i10 + (i2 << 3) >> 2] = i3;
       HEAP32[i10 + (i2 << 3) + 4 >> 2] = i5;
       i2 = i2 + 1 | 0;
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < 8);
     do if ((i2 | 0) < 3) HEAP32[i9 >> 2] = 2; else if (__ZN17PolygonCollider2D20ValidatePolygonShapeEPK6b2Vec2i(i10, i2) | 0) {
      i17 = i1 + (i4 * 152 | 0) | 0;
      HEAP32[i17 >> 2] = gb + 151728 + 8;
      HEAP32[i1 + (i4 * 152 | 0) + 4 >> 2] = 2;
      HEAP32[i1 + (i4 * 152 | 0) + 8 >> 2] = HEAP32[gb + 151644 >> 2];
      HEAP32[i1 + (i4 * 152 | 0) + 148 >> 2] = 0;
      HEAPF32[i1 + (i4 * 152 | 0) + 12 >> 2] = Math_fround(0.0);
      HEAPF32[i1 + (i4 * 152 | 0) + 16 >> 2] = Math_fround(0.0);
      __ZN14b2PolygonShape3SetEPK6b2Vec2i(i17, i10, i2);
      HEAP32[(HEAP32[i19 >> 2] | 0) + (i4 << 2) >> 2] = i17;
      i4 = i4 + 1 | 0;
      break;
     } else {
      HEAP32[i9 >> 2] = 2;
      break;
     } while (0);
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i13 | 0));
    __Z14tessDeleteTessP14TESStesselator(i18);
    if (!i4) i21 = 37; else {
     i2 = HEAP32[i14 >> 2] | 0;
     HEAP32[i14 >> 2] = i4;
     i3 = HEAP32[i15 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i15 >> 2] = i4;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i4 << 2, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i19 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i18 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i4;
      HEAP32[i19 >> 2] = i18;
      break;
     } while (0);
     if (i4 >>> 0 > i2 >>> 0) _memset((HEAP32[i19 >> 2] | 0) + (i2 << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
    }
   } else {
    __Z14tessDeleteTessP14TESStesselator(i18);
    i21 = 37;
   }
   if ((i21 | 0) == 37) if (!i1) i1 = 0; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
    i1 = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i16);
   i21 = i1;
   STACKTOP = i22;
   return i21 | 0;
  }
 }
 __Z14tessDeleteTessP14TESStesselator(i18);
 i21 = 0;
 STACKTOP = i22;
 return i21 | 0;
}

function _tt_cmap14_variant_chars(i10, i11, i4) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i9 = HEAP32[i10 + 16 >> 2] | 0;
 i5 = i9 + 10 | 0;
 i1 = 0;
 i3 = (HEAPU8[i9 + 7 >> 0] | 0) << 16 | (HEAPU8[i9 + 6 >> 0] | 0) << 24 | (HEAPU8[i9 + 8 >> 0] | 0) << 8 | (HEAPU8[i9 + 9 >> 0] | 0);
 L1 : while (1) while (1) {
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i8 = 60;
   break L1;
  }
  i6 = (i1 + i3 | 0) >>> 1;
  i7 = i5 + (i6 * 11 | 0) + 3 | 0;
  i2 = i7 + -3 | 0;
  i2 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
  if (i2 >>> 0 > i4 >>> 0) {
   i3 = i6;
   continue L1;
  }
  if (i2 >>> 0 < i4 >>> 0) i1 = i6 + 1 | 0; else break L1;
 }
 if ((i8 | 0) == 60) {
  STACKTOP = i15;
  return i1 | 0;
 }
 i2 = (HEAPU8[i7 + 1 >> 0] | 0) << 16 | (HEAPU8[i7 >> 0] | 0) << 24 | (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
 i3 = (HEAPU8[i7 + 5 >> 0] | 0) << 16 | (HEAPU8[i7 + 4 >> 0] | 0) << 24 | (HEAPU8[i7 + 6 >> 0] | 0) << 8 | (HEAPU8[i7 + 7 >> 0] | 0);
 i1 = (i3 | 0) == 0;
 if (!(i3 | i2)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!i2) {
  i5 = i9 + i3 | 0;
  i1 = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
  i3 = i1 + 1 | 0;
  i4 = i10 + 28 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  do if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i10 + 36 >> 2] = i11;
   i14 = i10 + 32 | 0;
   i2 = _UNITY_ft_mem_realloc(i11, 4, i2, i3, HEAP32[i14 >> 2] | 0, i12) | 0;
   HEAP32[i14 >> 2] = i2;
   if (!(HEAP32[i12 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i3;
    i4 = i2;
    break;
   }
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  } else i4 = HEAP32[i10 + 32 >> 2] | 0; while (0);
  if (!i1) i1 = 0; else {
   i3 = 0;
   i2 = i5 + 4 | 0;
   while (1) {
    HEAP32[i4 + (i3 << 2) >> 2] = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 5 | 0;
   }
  }
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i14 = i4;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (i1) {
  i14 = _tt_cmap14_get_def_chars(i10, i9 + i2 | 0, i11) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i5 = i9 + i2 | 0;
 i1 = i9 + i3 + 4 | 0;
 i13 = i1 + -4 | 0;
 i13 = (HEAPU8[i13 + 1 >> 0] | 0) << 16 | (HEAPU8[i13 >> 0] | 0) << 24 | (HEAPU8[i13 + 2 >> 0] | 0) << 8 | (HEAPU8[i13 + 3 >> 0] | 0);
 i14 = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
 if (!i14) i2 = 0; else {
  i3 = i14;
  i4 = i5 + 7 | 0;
  i2 = 0;
  while (1) {
   i2 = i2 + 1 + (HEAPU8[i4 >> 0] | 0) | 0;
   i3 = i3 + -1 | 0;
   if (!i3) break; else i4 = i4 + 4 | 0;
  }
 }
 i6 = i5 + 4 | 0;
 if (!i13) {
  i14 = _tt_cmap14_get_def_chars(i10, i5, i11) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i5 = i13 + 1 | 0;
 if (!i2) {
  i4 = i10 + 28 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  do if (i2 >>> 0 < i5 >>> 0) {
   HEAP32[i10 + 36 >> 2] = i11;
   i14 = i10 + 32 | 0;
   i3 = _UNITY_ft_mem_realloc(i11, 4, i2, i5, HEAP32[i14 >> 2] | 0, i12) | 0;
   HEAP32[i14 >> 2] = i3;
   if (!(HEAP32[i12 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i5;
    break;
   }
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  } else i3 = HEAP32[i10 + 32 >> 2] | 0; while (0);
  i2 = 0;
  while (1) {
   HEAP32[i3 + (i2 << 2) >> 2] = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i13 | 0)) break; else i1 = i1 + 5 | 0;
  }
  HEAP32[i3 + (i13 << 2) >> 2] = 0;
  i14 = i3;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i5 + i2 | 0;
 i4 = i10 + 28 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 do if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i10 + 36 >> 2] = i11;
  i10 = i10 + 32 | 0;
  i2 = _UNITY_ft_mem_realloc(i11, 4, i2, i3, HEAP32[i10 >> 2] | 0, i12) | 0;
  HEAP32[i10 >> 2] = i2;
  if (!(HEAP32[i12 >> 2] | 0)) {
   HEAP32[i4 >> 2] = i3;
   i10 = i2;
   break;
  }
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 } else i10 = HEAP32[i10 + 32 >> 2] | 0; while (0);
 i4 = i6 + 3 | 0;
 i5 = i4 + -3 | 0;
 i2 = i1 + 3 | 0;
 i9 = i2 + -3 | 0;
 i8 = 1;
 i6 = 1;
 i7 = i4 + 1 | 0;
 i9 = (HEAPU8[i9 + 1 >> 0] | 0) << 8 | (HEAPU8[i9 >> 0] | 0) << 16 | (HEAPU8[i9 + 2 >> 0] | 0);
 i4 = HEAPU8[i4 >> 0] | 0;
 i5 = (HEAPU8[i5 + 1 >> 0] | 0) << 8 | (HEAPU8[i5 >> 0] | 0) << 16 | (HEAPU8[i5 + 2 >> 0] | 0);
 i2 = i2 + 2 | 0;
 i1 = 0;
 L66 : while (1) {
  if (i9 >>> 0 > (i4 + i5 | 0) >>> 0) while (1) {
   i3 = 0;
   do {
    i12 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i10 + (i12 << 2) >> 2] = i3 + i5;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 <= i4 >>> 0);
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 > i14 >>> 0) break L66;
   i5 = (HEAPU8[i7 + 1 >> 0] | 0) << 8 | (HEAPU8[i7 >> 0] | 0) << 16 | (HEAPU8[i7 + 2 >> 0] | 0);
   i3 = i7 + 4 | 0;
   i4 = HEAPU8[i7 + 3 >> 0] | 0;
   if (i9 >>> 0 > (i4 + i5 | 0) >>> 0) i7 = i3; else {
    i7 = i3;
    break;
   }
  }
  if (i9 >>> 0 < i5 >>> 0) {
   HEAP32[i10 + (i1 << 2) >> 2] = i9;
   i1 = i1 + 1 | 0;
  }
  i3 = i8 + 1 | 0;
  if (i3 >>> 0 > i13 >>> 0) {
   i8 = i3;
   break;
  }
  i8 = i3;
  i9 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
  i2 = i2 + 5 | 0;
 }
 if (i8 >>> 0 > i13 >>> 0) {
  if (i6 >>> 0 <= i14 >>> 0) {
   i2 = 0;
   do {
    i13 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i10 + (i13 << 2) >> 2] = i2 + i5;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 <= i4 >>> 0);
   if (i6 >>> 0 < i14 >>> 0) while (1) {
    i3 = (HEAPU8[i7 + 1 >> 0] | 0) << 8 | (HEAPU8[i7 >> 0] | 0) << 16 | (HEAPU8[i7 + 2 >> 0] | 0);
    i4 = HEAPU8[i7 + 3 >> 0] | 0;
    i5 = i1 + 1 | 0;
    i2 = 0;
    while (1) {
     HEAP32[i10 + (i1 << 2) >> 2] = i2 + i3;
     if ((i2 | 0) == (i4 | 0)) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
    i1 = i5 + i4 | 0;
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i14 | 0)) break; else i7 = i7 + 4 | 0;
   }
  }
 } else {
  HEAP32[i10 + (i1 << 2) >> 2] = i9;
  i4 = i1 + 1 | 0;
  if (i8 >>> 0 < i13 >>> 0) {
   i5 = i1 + i13 + 1 | 0;
   i3 = i8;
   i1 = i4;
   while (1) {
    HEAP32[i10 + (i1 << 2) >> 2] = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i13 | 0)) break; else {
     i2 = i2 + 5 | 0;
     i1 = i1 + 1 | 0;
    }
   }
   i1 = i5 - i8 | 0;
  } else i1 = i4;
 }
 HEAP32[i10 + (i1 << 2) >> 2] = 0;
 i14 = i10;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getRelativeTransformEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i3 + 60 | 0;
 i26 = i3 + 56 | 0;
 i27 = i3 + 28 | 0;
 i25 = i3;
 i29 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 28 >> 2] | 0, i29 | 0, i28 | 0, i26 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i27, i2, HEAP32[i28 >> 2] | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f23 = Math_fround(HEAPF32[i27 >> 2]);
 f7 = Math_fround(f24 * f23);
 f13 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f12 * f13));
 f21 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f21));
 f9 = Math_fround(Math_fround(f23 * f7) + Math_fround(Math_fround(f24 * f22) + Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f12 * f21)))));
 f8 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f12 * f22) + Math_fround(f18 * Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f23)))));
 f7 = Math_fround(Math_fround(Math_fround(f15 * f22) + Math_fround(f18 * Math_fround(Math_fround(f12 * f23) - Math_fround(f24 * f13)))) + Math_fround(f21 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i27 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i27 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i27 + 24 >> 2]) + f7);
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f18 * f24);
 f22 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f23 * f22));
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f13 * f22) + Math_fround(f18 * f14))) - Math_fround(f23 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f21 * f22) + Math_fround(f18 * f15))) - Math_fround(f13 * f24));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f22) - Math_fround(f23 * f24)) - Math_fround(f13 * f14)) - Math_fround(f21 * f15));
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i25, i2, HEAP32[i26 >> 2] | 0);
 f21 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f18 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f20));
 f5 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f5));
 f6 = Math_fround(Math_fround(f22 * f18) + Math_fround(Math_fround(f21 * f23) + Math_fround(f24 * Math_fround(Math_fround(f13 * f20) - Math_fround(f14 * f5)))));
 f4 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f14 * f23) + Math_fround(f24 * Math_fround(Math_fround(f21 * f5) - Math_fround(f13 * f22)))));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f23) + Math_fround(f24 * Math_fround(Math_fround(f14 * f22) - Math_fround(f21 * f20)))) + Math_fround(f5 * f18));
 f6 = Math_fround(Math_fround(HEAPF32[i25 + 16 >> 2]) + f6);
 f4 = Math_fround(Math_fround(HEAPF32[i25 + 20 >> 2]) + f4);
 f18 = Math_fround(Math_fround(HEAPF32[i25 + 24 >> 2]) + f18);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f14 = Math_fround(f24 * f21);
 f23 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f22 * f23));
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f13));
 f19 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f5 * f19));
 f11 = Math_fround(Math_fround(Math_fround(f5 * f21) + Math_fround(Math_fround(f20 * f23) + Math_fround(f24 * f19))) - Math_fround(f22 * f13));
 f17 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f5 * f23) + Math_fround(f24 * f13))) - Math_fround(f20 * f21));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f5 * f13));
 f12 = Math_fround(-f12);
 f16 = Math_fround(-f16);
 f10 = Math_fround(-f10);
 f9 = Math_fround(Math_fround(f6 - f9) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f4 - f8) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f18 - f7) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f9 * f12) + Math_fround(f8 * f16)));
 f6 = Math_fround(Math_fround(f4 * f12) + Math_fround(Math_fround(f18 * f9) + Math_fround(f15 * Math_fround(Math_fround(f7 * f16) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f18 * f8) + Math_fround(f15 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f12)))));
 f4 = Math_fround(Math_fround(Math_fround(f18 * f7) + Math_fround(f15 * Math_fround(Math_fround(f8 * f12) - Math_fround(f9 * f16)))) + Math_fround(f4 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f11))) - Math_fround(f17 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f13 * f10) + Math_fround(f15 * f17))) - Math_fround(f14 * f16));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * f12)) - Math_fround(f11 * f16)) - Math_fround(f17 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12))) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN16ParticleRenderer19UpdateTransformInfoEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 16 | 0;
 i20 = i22;
 i21 = __ZN8Renderer12GetTransformEv(i18) | 0;
 i1 = HEAP16[i18 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  HEAP32[i18 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i21) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i21, i18 + 36 | 0);
  i1 = HEAP8[i18 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i22;
  return;
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i18 + 28 >> 2] | 0, gb + 190576 | 0) | 0;
 if (i1 | 0) {
  i10 = HEAP32[i1 + 56 >> 2] | 0;
  i17 = (HEAP32[i1 + 60 >> 2] | 0) - i10 | 0;
  i16 = (i17 | 0) / 48 | 0;
  if (i17 | 0) {
   i17 = i1 + 72 | 0;
   i11 = HEAP32[i17 >> 2] | 0;
   i12 = HEAP32[i17 + 4 >> 2] | 0;
   i13 = HEAP32[i17 + 8 >> 2] | 0;
   i9 = HEAP32[i17 + 12 >> 2] | 0;
   i8 = HEAP32[i17 + 16 >> 2] | 0;
   i1 = HEAP32[i17 + 20 >> 2] | 0;
   if ((HEAP32[i18 + 340 >> 2] | 0) == 3) {
    f6 = Math_fround(HEAPF32[i18 + 348 >> 2]);
    f7 = Math_fround(HEAPF32[i18 + 344 >> 2]);
    f15 = Math_fround(HEAPF32[gb + 62452 >> 2]);
    i14 = 0;
    while (1) {
     f3 = Math_fround(HEAPF32[i10 + 12 >> 2]);
     f2 = Math_fround(f3 * f3);
     f4 = Math_fround(HEAPF32[i10 + 16 >> 2]);
     f2 = Math_fround(f2 + Math_fround(f4 * f4));
     f5 = Math_fround(HEAPF32[i10 + 20 >> 2]);
     f2 = Math_fround(f2 + Math_fround(f5 * f5));
     if (f2 > f15) {
      if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
      f23 = Math_fround(f7 * f2);
      f23 = Math_fround(f6 + Math_fround(f23 * Math_fround(HEAPF32[i10 + 24 >> 2])));
      f24 = Math_fround(f3 * f23);
      f2 = Math_fround(f4 * f23);
      f4 = Math_fround(f5 * f23);
      f24 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f24);
      f2 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) - f2);
      f4 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f4);
      f5 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f3 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f23 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i11 = (HEAPF32[tempDoublePtr >> 2] = f24 < f5 ? f24 : f5, HEAP32[tempDoublePtr >> 2] | 0);
      i12 = (HEAPF32[tempDoublePtr >> 2] = f2 < f3 ? f2 : f3, HEAP32[tempDoublePtr >> 2] | 0);
      i13 = (HEAPF32[tempDoublePtr >> 2] = f4 < f23 ? f4 : f23, HEAP32[tempDoublePtr >> 2] | 0);
      f23 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f3 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i9 = (HEAPF32[tempDoublePtr >> 2] = f23 < f24 ? f24 : f23, HEAP32[tempDoublePtr >> 2] | 0);
      i8 = (HEAPF32[tempDoublePtr >> 2] = f3 < f2 ? f2 : f3, HEAP32[tempDoublePtr >> 2] | 0);
      i1 = (HEAPF32[tempDoublePtr >> 2] = f5 < f4 ? f4 : f5, HEAP32[tempDoublePtr >> 2] | 0);
     }
     i14 = i14 + 1 | 0;
     if (i14 >>> 0 >= i16 >>> 0) {
      i10 = i13;
      break;
     } else i10 = i10 + 48 | 0;
    }
   } else i10 = i13;
   f2 = Math_fround(Math_fround(HEAPF32[i17 + 28 >> 2]) * Math_fround(.707106769));
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
   f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f2);
   f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f2);
   f2 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f2);
   if (!(HEAP8[i17 + 36 >> 0] | 0)) {
    f26 = Math_fround(Math_fround(f6 + f3) * Math_fround(.5));
    f25 = Math_fround(Math_fround(f5 + f2) * Math_fround(.5));
    f15 = Math_fround(Math_fround(f4 - f7) * Math_fround(.5));
    f23 = Math_fround(Math_fround(f3 - f6) * Math_fround(.5));
    f24 = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
    HEAPF32[i18 + 188 >> 2] = Math_fround(Math_fround(f7 + f4) * Math_fround(.5));
    HEAPF32[i18 + 192 >> 2] = f26;
    HEAPF32[i18 + 196 >> 2] = f25;
    HEAPF32[i18 + 200 >> 2] = f15;
    HEAPF32[i18 + 204 >> 2] = f23;
    HEAPF32[i18 + 208 >> 2] = f24;
    __ZNK9Transform11GetPositionEv(i19, i21);
    __ZNK9Transform11GetRotationEv(i20, i21);
    __Z13TransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i18 + 188 | 0, i19, i20, i18 + 164 | 0);
    STACKTOP = i22;
    return;
   } else {
    f15 = Math_fround(Math_fround(f6 + f3) * Math_fround(.5));
    f23 = Math_fround(Math_fround(f5 + f2) * Math_fround(.5));
    f24 = Math_fround(Math_fround(f4 - f7) * Math_fround(.5));
    f25 = Math_fround(Math_fround(f3 - f6) * Math_fround(.5));
    f26 = Math_fround(Math_fround(f2 - f5) * Math_fround(.5));
    HEAPF32[i18 + 164 >> 2] = Math_fround(Math_fround(f7 + f4) * Math_fround(.5));
    HEAPF32[i18 + 168 >> 2] = f15;
    HEAPF32[i18 + 172 >> 2] = f23;
    HEAPF32[i18 + 176 >> 2] = f24;
    HEAPF32[i18 + 180 >> 2] = f25;
    HEAPF32[i18 + 184 >> 2] = f26;
    __ZNK9Transform11GetPositionEv(i19, i21);
    __ZNK9Transform11GetRotationEv(i20, i21);
    __Z20InverseTransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i18 + 164 | 0, i19, i20, i18 + 188 | 0);
    STACKTOP = i22;
    return;
   }
  }
 }
 i21 = i18 + 188 | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i21 = i18 + 200 | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i21 = i18 + 164 | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i21 = i18 + 176 | 0;
 HEAP32[i21 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 STACKTOP = i22;
 return;
}

function __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_(i7, i8, i17, i18, i19, i20) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 120 | 0;
 i21 = i23 + 112 | 0;
 i25 = i23 + 48 | 0;
 i24 = i23 + 40 | 0;
 i5 = i23 + 24 | 0;
 i6 = i23 + 16 | 0;
 i2 = i23 + 8 | 0;
 i3 = i23;
 i9 = i23 + 104 | 0;
 i10 = i23 + 96 | 0;
 i11 = i23 + 88 | 0;
 i12 = i23 + 80 | 0;
 i13 = i23 + 72 | 0;
 i14 = i23 + 64 | 0;
 i15 = i23 + 56 | 0;
 i16 = i23 + 32 | 0;
 i1 = __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i7, i8, i17, i20) | 0;
 i4 = HEAP32[i20 >> 2] | 0;
 i26 = i18;
 i27 = HEAP32[i26 + 4 >> 2] | 0;
 i28 = i25;
 HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i28 + 4 >> 2] = i27;
 i28 = i17;
 i27 = HEAP32[i28 + 4 >> 2] | 0;
 i26 = i24;
 HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i26 + 4 >> 2] = i27;
 HEAP32[i21 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 if (mftCall_iii(i4 | 0, i21 | 0, i22 | 0) | 0) {
  i28 = i17;
  i27 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i25 = i18;
  i26 = HEAP32[i25 + 4 >> 2] | 0;
  i4 = i17;
  HEAP32[i4 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i4 + 4 >> 2] = i26;
  i4 = i18;
  HEAP32[i4 >> 2] = i27;
  HEAP32[i4 + 4 >> 2] = i28;
  i4 = i1 + 1 | 0;
  i28 = HEAP32[i20 >> 2] | 0;
  i27 = i17;
  i26 = HEAP32[i27 + 4 >> 2] | 0;
  i25 = i5;
  HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i25 + 4 >> 2] = i26;
  i25 = i8;
  i26 = HEAP32[i25 + 4 >> 2] | 0;
  i27 = i6;
  HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i27 + 4 >> 2] = i26;
  HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  if (mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0) {
   i27 = i8;
   i26 = HEAP32[i27 >> 2] | 0;
   i27 = HEAP32[i27 + 4 >> 2] | 0;
   i24 = i17;
   i25 = HEAP32[i24 + 4 >> 2] | 0;
   i28 = i8;
   HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i28 + 4 >> 2] = i25;
   i28 = i17;
   HEAP32[i28 >> 2] = i26;
   HEAP32[i28 + 4 >> 2] = i27;
   i28 = HEAP32[i20 >> 2] | 0;
   i27 = i8;
   i26 = HEAP32[i27 + 4 >> 2] | 0;
   i25 = i2;
   HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i25 + 4 >> 2] = i26;
   i25 = i7;
   i26 = HEAP32[i25 + 4 >> 2] | 0;
   i27 = i3;
   HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i27 + 4 >> 2] = i26;
   HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i22 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   if (mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0) {
    i27 = i7;
    i26 = HEAP32[i27 >> 2] | 0;
    i27 = HEAP32[i27 + 4 >> 2] | 0;
    i24 = i8;
    i25 = HEAP32[i24 + 4 >> 2] | 0;
    i28 = i7;
    HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i28 + 4 >> 2] = i25;
    i28 = i8;
    HEAP32[i28 >> 2] = i26;
    HEAP32[i28 + 4 >> 2] = i27;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 i28 = HEAP32[i20 >> 2] | 0;
 i27 = i19;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i25 = i9;
 HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 i25 = i18;
 i26 = HEAP32[i25 + 4 >> 2] | 0;
 i27 = i10;
 HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 HEAP32[i21 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 if (!(mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0)) {
  i28 = i1;
  STACKTOP = i23;
  return i28 | 0;
 }
 i27 = i18;
 i26 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 4 >> 2] | 0;
 i24 = i19;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i28 = i18;
 HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i28 + 4 >> 2] = i25;
 i28 = i19;
 HEAP32[i28 >> 2] = i26;
 HEAP32[i28 + 4 >> 2] = i27;
 i28 = HEAP32[i20 >> 2] | 0;
 i27 = i18;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i25 = i11;
 HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 i25 = i17;
 i26 = HEAP32[i25 + 4 >> 2] | 0;
 i27 = i12;
 HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 if (!(mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0)) {
  i28 = i1 + 1 | 0;
  STACKTOP = i23;
  return i28 | 0;
 }
 i27 = i17;
 i26 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 4 >> 2] | 0;
 i24 = i18;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i28 = i17;
 HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i28 + 4 >> 2] = i25;
 i28 = i18;
 HEAP32[i28 >> 2] = i26;
 HEAP32[i28 + 4 >> 2] = i27;
 i28 = HEAP32[i20 >> 2] | 0;
 i27 = i17;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i25 = i13;
 HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 i25 = i8;
 i26 = HEAP32[i25 + 4 >> 2] | 0;
 i27 = i14;
 HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 HEAP32[i21 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 if (!(mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0)) {
  i28 = i1 + 2 | 0;
  STACKTOP = i23;
  return i28 | 0;
 }
 i27 = i8;
 i26 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 4 >> 2] | 0;
 i24 = i17;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i28 = i8;
 HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i28 + 4 >> 2] = i25;
 i28 = i17;
 HEAP32[i28 >> 2] = i26;
 HEAP32[i28 + 4 >> 2] = i27;
 i28 = HEAP32[i20 >> 2] | 0;
 i27 = i8;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i25 = i15;
 HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i25 + 4 >> 2] = i26;
 i25 = i7;
 i26 = HEAP32[i25 + 4 >> 2] | 0;
 i27 = i16;
 HEAP32[i27 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i27 + 4 >> 2] = i26;
 HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 if (!(mftCall_iii(i28 | 0, i21 | 0, i22 | 0) | 0)) {
  i28 = i1 + 3 | 0;
  STACKTOP = i23;
  return i28 | 0;
 }
 i27 = i7;
 i26 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 4 >> 2] | 0;
 i24 = i8;
 i25 = HEAP32[i24 + 4 >> 2] | 0;
 i28 = i7;
 HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i28 + 4 >> 2] = i25;
 i28 = i8;
 HEAP32[i28 >> 2] = i26;
 HEAP32[i28 + 4 >> 2] = i27;
 i28 = i1 + 4 | 0;
 STACKTOP = i23;
 return i28 | 0;
}

function __Z37GetBarycentricCoordinatesForOuterCellPPK8Vector3fRK13dynamic_arrayIS_Lj4EERS0_RK11TetrahedronR8Vector4fRf(i1, i15, i20, i22, i23, i14) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i14 = i14 | 0;
 var f2 = f0, i3 = 0, d4 = 0.0, f5 = f0, f6 = f0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 12 | 0;
 i25 = i27;
 i26 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i1 + 4 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i16 >> 2]);
 f30 = Math_fround(HEAPF32[i26 >> 2]);
 f31 = Math_fround(f31 - f30);
 i17 = i16 + 4 | 0;
 f33 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i26 + 4 | 0;
 f28 = Math_fround(HEAPF32[i18 >> 2]);
 f33 = Math_fround(f33 - f28);
 i19 = i16 + 8 | 0;
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 i21 = i26 + 8 | 0;
 f6 = Math_fround(HEAPF32[i21 >> 2]);
 f2 = Math_fround(f2 - f6);
 i11 = HEAP32[i1 + 8 >> 2] | 0;
 f32 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f30);
 i12 = i11 + 4 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f28);
 i13 = i11 + 8 | 0;
 f34 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f6);
 f29 = Math_fround(Math_fround(f2 * f5) - Math_fround(f33 * f34));
 f2 = Math_fround(Math_fround(f31 * f34) - Math_fround(f2 * f32));
 f5 = Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f5));
 f30 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f30);
 i1 = i20 + 4 | 0;
 f28 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f28);
 i3 = i20 + 8 | 0;
 f6 = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f28 * f2)) + Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f6)));
 HEAPF32[i14 >> 2] = f6;
 if (f6 < Math_fround(0.0)) {
  HEAPF32[i23 >> 2] = Math_fround(0.0);
  HEAPF32[i23 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i23 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i23 + 12 >> 2] = Math_fround(-1.0);
  STACKTOP = i27;
  return;
 }
 f5 = Math_fround(HEAPF32[i22 + 32 >> 2]);
 f33 = Math_fround(HEAPF32[i20 >> 2]);
 f5 = Math_fround(f5 * f33);
 f6 = Math_fround(HEAPF32[i22 + 44 >> 2]);
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f34));
 f5 = Math_fround(HEAPF32[i22 + 56 >> 2]);
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * f2));
 f5 = Math_fround(Math_fround(HEAPF32[i22 + 68 >> 2]) + f5);
 f6 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f34 * Math_fround(HEAPF32[i22 + 48 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f2 * Math_fround(HEAPF32[i22 + 60 >> 2])));
 f6 = Math_fround(Math_fround(HEAPF32[i22 + 72 >> 2]) + f6);
 f33 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 40 >> 2]));
 f34 = Math_fround(f33 + Math_fround(f34 * Math_fround(HEAPF32[i22 + 52 >> 2])));
 f2 = Math_fround(f34 + Math_fround(f2 * Math_fround(HEAPF32[i22 + 64 >> 2])));
 f2 = Math_fround(Math_fround(HEAPF32[i22 + 76 >> 2]) + f2);
 do if ((HEAP32[i22 + 12 >> 2] | 0) == -1) {
  d7 = +f6;
  d10 = +f5 * .3333333333333333;
  d9 = d10 * d10;
  d4 = d10 * d9 - d10 * d7 * .5 + +f2 * .5;
  d9 = d7 * .3333333333333333 - d9;
  d7 = d9 * (d9 * d9);
  d8 = d7 + d4 * d4;
  if (!(d8 > 0.0)) {
   d7 = +Math_sqrt(+-d7);
   d4 = +Math_acos(+(-d4 / d7));
   d7 = +Math_pow(+d7, .3333333333333333);
   d9 = d7 - d9 / d7;
   d7 = +Math_cos(+(d4 * .3333333333333333)) * d9 - d10;
   d8 = d9 * +Math_cos(+((d4 + 6.2831854820251465) * .3333333333333333)) - d10;
   d9 = d9 * +Math_cos(+((d4 + 12.566370964050293) * .3333333333333333)) - d10;
   d10 = d7 < d8 ? d8 : d7;
   d10 = d10 < d9 ? d9 : d10;
   d10 = !(d7 >= 0.0) ? d10 : d7 < d10 ? d7 : d10;
   d10 = !(d8 >= 0.0) ? d10 : d8 < d10 ? d8 : d10;
   f2 = Math_fround(!(d9 >= 0.0) ? d10 : d9 < d10 ? d9 : d10);
   HEAPF32[i14 >> 2] = f2;
   break;
  }
  d4 = +Math_sqrt(+d8) - d4;
  if (d4 > 0.0) d4 = +Math_pow(+d4, .3333333333333333); else d4 = -+Math_pow(+-d4, .3333333333333333);
  f2 = Math_fround(d4 + (-d10 - d9 / d4));
  HEAPF32[i14 >> 2] = f2;
 } else {
  i3 = f5 < Math_fround(0.0);
  f34 = Math_fround(-f5);
  if ((i3 ? f34 : f5) < Math_fround(9.99999974e-06)) {
   i3 = f6 < Math_fround(0.0);
   f34 = Math_fround(-f6);
   if ((i3 ? f34 : f6) > Math_fround(9.99999974e-06)) f2 = Math_fround(Math_fround(-f2) / f6); else f2 = Math_fround(0.0);
  } else {
   f2 = Math_fround(Math_fround(f6 * f6) - Math_fround(Math_fround(f5 * Math_fround(4.0)) * f2));
   if (f2 < Math_fround(0.0)) f2 = Math_fround(0.0); else f2 = Math_fround(Math_fround(Math_fround(.5) / f5) * Math_fround(Math_fround(Math_sqrt(Math_fround(f2))) - f6));
  }
  HEAPF32[i14 >> 2] = f2;
 } while (0);
 i14 = HEAP32[i22 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 f32 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i14 * 12 | 0) >> 2]));
 f33 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i14 * 12 | 0) + 4 >> 2]));
 f34 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i14 * 12 | 0) + 8 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i26 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i18 >> 2]));
 f34 = Math_fround(f34 + Math_fround(HEAPF32[i21 >> 2]));
 HEAPF32[i24 >> 2] = f32;
 HEAPF32[i24 + 4 >> 2] = f33;
 HEAPF32[i24 + 8 >> 2] = f34;
 i26 = HEAP32[i22 + 4 >> 2] | 0;
 f34 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) >> 2]));
 f33 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) + 4 >> 2]));
 f32 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) + 8 >> 2]));
 f34 = Math_fround(f34 + Math_fround(HEAPF32[i16 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i17 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i24 + 12 >> 2] = f34;
 HEAPF32[i24 + 16 >> 2] = f33;
 HEAPF32[i24 + 20 >> 2] = f32;
 i26 = HEAP32[i22 + 8 >> 2] | 0;
 f32 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) >> 2]));
 f33 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) + 4 >> 2]));
 f34 = Math_fround(f2 * Math_fround(HEAPF32[i15 + (i26 * 12 | 0) + 8 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i11 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i12 >> 2]));
 f34 = Math_fround(f34 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i24 + 24 >> 2] = f32;
 HEAPF32[i24 + 28 >> 2] = f33;
 HEAPF32[i24 + 32 >> 2] = f34;
 __ZN15LightProbeUtils32BarycentricCoordinates3DTriangleEPK8Vector3fRS1_(i25, i24, i20);
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i26 = HEAP32[i25 + 8 >> 2] | 0;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i23 + 8 >> 2] = i26;
 HEAPF32[i23 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i27;
 return;
}

function __ZN14ShadowSettings8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 913271 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380976 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 374360 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 374379 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 374390 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 374397 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 374410 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 72; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 72; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 72) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN11AudioSource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 440 | 0, i7);
 __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 436 | 0, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i10 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 497 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 412 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 408 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 420 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 421 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 422 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 423 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 388 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 392 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 396 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 400 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i3;
 }
 HEAP32[i6 + 404 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i3 = i2;
  i2 = i4;
 }
 HEAP32[i6 + 416 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i3 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 424 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 425 >> 0] = i1;
 i1 = i6 + 426 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx14PxsAABBManager20selfCollideAggregateERKNS_19AggregateSortedDataERKNS_9AggregateEPNS_17SelfCollideBitmapE(i22, i1, i2, i26) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i26 = i26 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 1025 | 0;
 i24 = i27 + 1024 | 0;
 i25 = i27;
 _memset(i25 | 0, 0, 1024) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i21 = i1 + 4 | 0;
 i19 = HEAP32[i21 >> 2] | 0;
 i20 = HEAP32[i22 + 300 >> 2] | 0;
 i18 = HEAP8[i2 + 1026 >> 0] | 0;
 i13 = i3 + ((i18 & 255) << 2) | 0;
 L1 : do if (!(i18 << 24 >> 24)) i1 = 0; else {
  i14 = i22 + 308 | 0;
  i15 = i22 + 304 | 0;
  i16 = i22 + 49836 | 0;
  i17 = i22 + 49840 | 0;
  i18 = i22 + 49832 | 0;
  i1 = i3;
  i12 = i3;
  while (1) {
   i10 = HEAP32[i12 >> 2] | 0;
   i12 = i12 + 4 | 0;
   i11 = i19 + (i10 << 2) | 0;
   i2 = i1;
   while (1) {
    if (i2 >>> 0 >= i13 >>> 0) {
     i1 = i2;
     break;
    }
    i1 = i2 + 4 | 0;
    if ((HEAP32[i20 + ((HEAP32[i19 + (HEAP32[i2 >> 2] << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0 < (HEAP32[i20 + ((HEAP32[i11 >> 2] | 0) * 24 | 0) >> 2] | 0) >>> 0) i2 = i1; else break;
   }
   i8 = i1 >>> 0 < i13 >>> 0;
   if (i8) i9 = i1; else {
    i1 = 0;
    break L1;
   }
   do {
    i2 = HEAP32[i9 >> 2] | 0;
    i9 = i9 + 4 | 0;
    i4 = HEAP32[i19 + (i2 << 2) >> 2] | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    if ((HEAP32[i20 + (i4 * 24 | 0) >> 2] | 0) >>> 0 > (HEAP32[i20 + (i3 * 24 | 0) + 12 >> 2] | 0) >>> 0) break;
    if ((i10 | 0) != (i2 | 0)) {
     i7 = HEAP32[i14 >> 2] | 0;
     if ((HEAP32[i7 + (i3 << 2) >> 2] | 0) != (HEAP32[i7 + (i4 << 2) >> 2] | 0)) if ((HEAP32[i20 + (i3 * 24 | 0) + 20 >> 2] | 0) >>> 0 >= (HEAP32[i20 + (i4 * 24 | 0) + 8 >> 2] | 0) >>> 0) if ((HEAP32[i20 + (i4 * 24 | 0) + 20 >> 2] | 0) >>> 0 >= (HEAP32[i20 + (i3 * 24 | 0) + 8 >> 2] | 0) >>> 0) if ((HEAP32[i20 + (i3 * 24 | 0) + 16 >> 2] | 0) >>> 0 >= (HEAP32[i20 + (i4 * 24 | 0) + 4 >> 2] | 0) >>> 0) if ((HEAP32[i20 + (i4 * 24 | 0) + 16 >> 2] | 0) >>> 0 >= (HEAP32[i20 + (i3 * 24 | 0) + 4 >> 2] | 0) >>> 0) {
      i6 = i10 >>> 0 < i2 >>> 0;
      i7 = i6 ? i2 : i10;
      i6 = ((Math_imul(i7 + -1 | 0, i7) | 0) >>> 1) + (i6 ? i10 : i2) | 0;
      i7 = 1 << (i6 & 31);
      i6 = i6 >>> 5;
      i5 = i25 + (i6 << 2) | 0;
      HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i7;
      if (!(HEAP32[i26 + (i6 << 2) >> 2] & i7)) {
       i6 = HEAP32[i15 >> 2] | 0;
       i7 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
       i6 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
       i3 = HEAP32[i16 >> 2] | 0;
       if ((i3 | 0) == (HEAP32[i17 >> 2] | 0)) {
        i4 = (i3 | 0) == 0 ? 32 : i3 << 1;
        i5 = HEAP32[i18 >> 2] | 0;
        i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, i4 << 3, gb + 717789 | 0, 59) | 0;
        if (i5 | 0) _memcpy(i2 | 0, i5 | 0, i3 << 3 | 0) | 0;
        _memset(i2 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i5);
        HEAP32[i18 >> 2] = i2;
        HEAP32[i17 >> 2] = i4;
        i3 = HEAP32[i16 >> 2] | 0;
       } else i2 = HEAP32[i18 >> 2] | 0;
       HEAP32[i16 >> 2] = i3 + 1;
       HEAP32[i2 + (i3 << 3) >> 2] = i7;
       HEAP32[i2 + (i3 << 3) + 4 >> 2] = i6;
      }
     }
    }
   } while (i9 >>> 0 < i13 >>> 0);
   if (!(i8 & i12 >>> 0 < i13 >>> 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 while (1) {
  i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
  if (i2 | 0) {
   i3 = 26;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= 256) {
   i3 = 25;
   break;
  }
 }
 L32 : do if ((i3 | 0) == 25) {
  i5 = -1;
  i6 = HEAP32[i21 >> 2] | 0;
  i9 = 1;
  i2 = 0;
  i8 = 0;
  i7 = 0;
 } else if ((i3 | 0) == 26) {
  i6 = HEAP32[i21 >> 2] | 0;
  i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i1 << 5;
  i4 = 1;
  while (1) {
   i3 = i4 + 1 | 0;
   if ((Math_imul(i3, i4) | 0) >>> 1 >>> 0 > i5 >>> 0) break; else i4 = i3;
  }
  i3 = i5 - ((Math_imul(i4 + -1 | 0, i4) | 0) >>> 1) | 0;
  i2 = i2 + -1 & i2;
  if (!i2) while (1) {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= 256) {
    i9 = i4;
    i2 = 0;
    i8 = i3;
    i7 = i4;
    break L32;
   }
   i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
   if (i2) {
    i9 = i4;
    i8 = i3;
    i7 = i4;
    break;
   }
  } else {
   i9 = i4;
   i8 = i3;
   i7 = i4;
  }
 } while (0);
 i17 = i22 + 308 | 0;
 i18 = i22 + 304 | 0;
 i19 = i22 + 49848 | 0;
 i20 = i22 + 49852 | 0;
 i16 = i22 + 49844 | 0;
 i4 = i9;
 i3 = i8;
 L42 : while (1) {
  i15 = i1 << 5;
  while (1) {
   i14 = ((Math_imul(i7 + -1 | 0, i7) | 0) >>> 1) + i3 | 0;
   i13 = i25 + (i14 >>> 5 << 2) | 0;
   i14 = 1 << (i14 & 31);
   i12 = i6 + (i3 << 2) | 0;
   i11 = i6 + (i7 << 2) | 0;
   while (1) {
    if ((i5 | 0) == -1) break L42;
    if (!(HEAP32[i13 >> 2] & i14)) {
     i3 = HEAP32[i12 >> 2] | 0;
     i7 = HEAP32[i11 >> 2] | 0;
     i5 = HEAP32[i17 >> 2] | 0;
     if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) != 1073741823) if ((HEAP32[i5 + (i7 << 2) >> 2] | 0) != 1073741823) {
      i9 = HEAP32[i18 >> 2] | 0;
      i10 = HEAP32[i9 + (i3 << 2) >> 2] | 0;
      i9 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
      i5 = HEAP32[i19 >> 2] | 0;
      if ((i5 | 0) == (HEAP32[i20 >> 2] | 0)) {
       i7 = (i5 | 0) == 0 ? 32 : i5 << 1;
       i8 = HEAP32[i16 >> 2] | 0;
       i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, i7 << 3, gb + 717789 | 0, 59) | 0;
       if (i8 | 0) _memcpy(i3 | 0, i8 | 0, i5 << 3 | 0) | 0;
       _memset(i3 + (i5 << 3) | 0, 0, i7 - i5 << 3 | 0) | 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i8);
       HEAP32[i16 >> 2] = i3;
       HEAP32[i20 >> 2] = i7;
       i5 = HEAP32[i19 >> 2] | 0;
      } else i3 = HEAP32[i16 >> 2] | 0;
      HEAP32[i19 >> 2] = i5 + 1;
      HEAP32[i3 + (i5 << 3) >> 2] = i10;
      HEAP32[i3 + (i5 << 3) + 4 >> 2] = i9;
     }
    }
    if (!i2) {
     i2 = 0;
     i5 = -1;
    } else break;
   }
   i5 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i5 = HEAP32[gb + 90668 + (i5 << 2) >> 2] | i15;
   while (1) {
    i3 = i4 + 1 | 0;
    if ((Math_imul(i3, i4) | 0) >>> 1 >>> 0 > i5 >>> 0) {
     i7 = i4;
     break;
    } else i4 = i3;
   }
   i3 = i5 - ((Math_imul(i7 + -1 | 0, i7) | 0) >>> 1) | 0;
   i2 = i2 + -1 & i2;
   if (!i2) break; else i4 = i7;
  }
  while (1) {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= 256) {
    i4 = i7;
    i2 = 0;
    continue L42;
   }
   i2 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
   if (i2) {
    i4 = i7;
    continue L42;
   }
  }
 }
 _memcpy(i26 | 0, i25 | 0, 1024) | 0;
 STACKTOP = i27;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 16 | 0;
 i5 = i11;
 i1 = i7 + 28 | 0;
 i9 = i8 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i8 + 24 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 20 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  i1 = i4;
 }
 if ((i1 | 0) == -2) {
  HEAP32[i5 >> 2] = 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
   i1 = HEAP32[i6 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, i1);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
    i1 = i1 + 60 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i2;
  if (i2 | 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i3 + (~(((i3 + -60 - i1 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i5 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = 1;
   HEAP32[i6 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
  }
 } else {
  i3 = i7 + 40 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
   i1 = HEAP32[i6 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, i1, i8 + 8 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i7 + 52 >> 2] | 0;
  i2 = i1 + (i5 * 60 | 0) | 0;
  if (i5 | 0) do {
   __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i8, i7, 0);
 i1 = i7 + 36 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i8, i7 + 80 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 192 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 196 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i4 = i7 + 188 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i1;
 }
 i4 = i7 + 100 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i7 + 104 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 116 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 120 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 200 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
  STACKTOP = i11;
  return;
 }
}

function _BF_crypt(i11, i16, i1, i4) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 4272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 8 | 0;
 i15 = i19;
 L1 : do if ((HEAP8[i16 >> 0] | 0) == 36) if ((HEAP8[i16 + 1 >> 0] | 0) == 50) {
  i12 = i16 + 2 | 0;
  i2 = (HEAP8[i12 >> 0] | 0) + -97 | 0;
  if (i2 >>> 0 > 25) i1 = 0; else if (!(25165825 >>> i2 & 1)) i1 = 0; else if ((HEAP8[i16 + 3 >> 0] | 0) == 36) {
   i2 = (HEAP8[i16 + 4 >> 0] | 0) + -48 | 0;
   if (i2 >>> 0 > 1) i1 = 0; else {
    i3 = (HEAP8[i16 + 5 >> 0] | 0) + -48 | 0;
    if (i3 >>> 0 > 9) i1 = 0; else if ((HEAP8[i16 + 6 >> 0] | 0) == 36) {
     i7 = 1 << i3 + (i2 * 10 | 0);
     if (i7 >>> 0 < i4 >>> 0) i1 = 0; else {
      i17 = i14 + 4240 | 0;
      i10 = i14 + 4256 | 0;
      i8 = i17;
      i9 = i16 + 7 | 0;
      while (1) {
       i2 = (HEAPU8[i9 >> 0] | 0) + -32 | 0;
       if (i2 >>> 0 > 95) {
        i1 = 0;
        break L1;
       }
       i3 = HEAP8[gb + 1059780 + i2 >> 0] | 0;
       if ((i3 & 255) > 63) {
        i1 = 0;
        break L1;
       }
       i2 = (HEAPU8[i9 + 1 >> 0] | 0) + -32 | 0;
       if (i2 >>> 0 > 95) {
        i1 = 0;
        break L1;
       }
       i13 = HEAP8[gb + 1059780 + i2 >> 0] | 0;
       i4 = i13 & 255;
       if ((i13 & 255) > 63) {
        i1 = 0;
        break L1;
       }
       i5 = i8 + 1 | 0;
       HEAP8[i8 >> 0] = i4 >>> 4 & 3 | (i3 & 255) << 2;
       if (i5 >>> 0 >= i10 >>> 0) {
        i2 = i17;
        i3 = 4;
        break;
       }
       i2 = (HEAPU8[i9 + 2 >> 0] | 0) + -32 | 0;
       if (i2 >>> 0 > 95) {
        i1 = 0;
        break L1;
       }
       i13 = HEAP8[gb + 1059780 + i2 >> 0] | 0;
       i3 = i13 & 255;
       if ((i13 & 255) > 63) {
        i1 = 0;
        break L1;
       }
       i6 = i8 + 2 | 0;
       HEAP8[i5 >> 0] = i3 >>> 2 & 15 | i4 << 4;
       if (i6 >>> 0 >= i10 >>> 0) {
        i2 = i17;
        i3 = 4;
        break;
       }
       i2 = (HEAPU8[i9 + 3 >> 0] | 0) + -32 | 0;
       if (i2 >>> 0 > 95) {
        i1 = 0;
        break L1;
       }
       i2 = HEAP8[gb + 1059780 + i2 >> 0] | 0;
       if ((i2 & 255) > 63) {
        i1 = 0;
        break L1;
       }
       i8 = i8 + 3 | 0;
       HEAP8[i6 >> 0] = i2 & 255 | i3 << 6;
       if (i8 >>> 0 >= i10 >>> 0) {
        i2 = i17;
        i3 = 4;
        break;
       } else i9 = i9 + 4 | 0;
      }
      while (1) {
       HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
       i3 = i3 + -1 | 0;
       if (!i3) break; else i2 = i2 + 4 | 0;
      }
      i13 = i14 + 4168 | 0;
      _BF_set_key(i11, i13, i14, HEAP8[(HEAP8[i12 >> 0] | 0) + -97 + (gb + 1059876) >> 0] | 0);
      _memcpy(i14 + 72 | 0, gb + 199012 + 72 | 0, 4096) | 0;
      i10 = i14 + 4244 | 0;
      i11 = i14 + 4248 | 0;
      i12 = i14 + 4252 | 0;
      i2 = i14;
      i3 = _BF_encrypt(i14, HEAP32[i17 >> 2] | 0, HEAP32[i10 >> 2] | 0, i14, i14) | 0;
      i4 = i14 + 8 | 0;
      do {
       i8 = _BF_encrypt(i14, HEAP32[i11 >> 2] ^ i3, HEAP32[i12 >> 2] ^ HEAP32[i2 + 4 >> 2], i4, i4) | 0;
       i9 = i2;
       i2 = i2 + 16 | 0;
       i3 = _BF_encrypt(i14, HEAP32[i17 >> 2] ^ i8, HEAP32[i10 >> 2] ^ HEAP32[i9 + 12 >> 2], i2, i2) | 0;
       i4 = i9 + 24 | 0;
      } while (i4 >>> 0 < i13 >>> 0);
      i8 = i14 + 64 | 0;
      i9 = i14 + 68 | 0;
      do {
       i2 = 0;
       do {
        i5 = i14 + (i2 << 2) | 0;
        HEAP32[i5 >> 2] = HEAP32[i5 >> 2] ^ HEAP32[i14 + 4168 + (i2 << 2) >> 2];
        i5 = i2 | 1;
        i6 = i14 + (i5 << 2) | 0;
        HEAP32[i6 >> 2] = HEAP32[i6 >> 2] ^ HEAP32[i14 + 4168 + (i5 << 2) >> 2];
        i2 = i2 + 2 | 0;
       } while ((i2 | 0) < 18);
       _BF_encrypt(i14, 0, 0, i14, i13) | 0;
       i3 = HEAP32[i17 >> 2] | 0;
       i4 = HEAP32[i10 >> 2] | 0;
       i5 = HEAP32[i11 >> 2] | 0;
       i6 = HEAP32[i12 >> 2] | 0;
       i2 = 0;
       do {
        i20 = i14 + (i2 << 2) | 0;
        HEAP32[i20 >> 2] = HEAP32[i20 >> 2] ^ i3;
        i20 = i14 + ((i2 | 1) << 2) | 0;
        HEAP32[i20 >> 2] = HEAP32[i20 >> 2] ^ i4;
        i20 = i14 + ((i2 | 2) << 2) | 0;
        HEAP32[i20 >> 2] = HEAP32[i20 >> 2] ^ i5;
        i20 = i14 + ((i2 | 3) << 2) | 0;
        HEAP32[i20 >> 2] = HEAP32[i20 >> 2] ^ i6;
        i2 = i2 + 4 | 0;
       } while ((i2 | 0) < 16);
       HEAP32[i8 >> 2] = HEAP32[i8 >> 2] ^ i3;
       HEAP32[i9 >> 2] = HEAP32[i9 >> 2] ^ i4;
       _BF_encrypt(i14, 0, 0, i14, i13) | 0;
       i7 = i7 + -1 | 0;
      } while ((i7 | 0) != 0);
      i3 = i15 + 4 | 0;
      i2 = 0;
      do {
       i6 = HEAP32[gb + 203180 + (i2 << 2) >> 2] | 0;
       i4 = i2 | 1;
       i5 = HEAP32[gb + 203180 + (i4 << 2) >> 2] | 0;
       HEAP32[i3 >> 2] = i5;
       i5 = _BF_encrypt(i14, i6, i5, i15, i15) | 0;
       i6 = 63;
       do {
        i5 = _BF_encrypt(i14, i5, HEAP32[i3 >> 2] | 0, i15, i15) | 0;
        i6 = i6 + -1 | 0;
       } while ((i6 | 0) != 0);
       HEAP32[i14 + 4240 + (i2 << 2) >> 2] = i5;
       HEAP32[i14 + 4240 + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
       i2 = i2 + 2 | 0;
      } while ((i2 | 0) < 6);
      i2 = i1;
      i3 = i16;
      i4 = i2 + 28 | 0;
      do {
       HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
       i2 = i2 + 1 | 0;
       i3 = i3 + 1 | 0;
      } while ((i2 | 0) < (i4 | 0));
      HEAP8[i1 + 28 >> 0] = HEAP8[(HEAPU8[(HEAP8[i16 + 28 >> 0] | 0) + -32 + (gb + 1059780) >> 0] & 48) + (gb + 1059902) >> 0] | 0;
      i2 = i17;
      i3 = 6;
      while (1) {
       HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
       i3 = i3 + -1 | 0;
       if (!i3) break; else i2 = i2 + 4 | 0;
      }
      i6 = i1 + 59 | 0;
      i2 = i1 + 29 | 0;
      i3 = 0;
      while (1) {
       i20 = HEAPU8[i17 + i3 >> 0] | 0;
       HEAP8[i2 >> 0] = HEAP8[(i20 >>> 2) + (gb + 1059902) >> 0] | 0;
       i4 = i3 + 2 | 0;
       i5 = HEAPU8[i17 + (i3 + 1) >> 0] | 0;
       HEAP8[i2 + 1 >> 0] = HEAP8[(i5 >>> 4 | i20 << 4 & 48) + (gb + 1059902) >> 0] | 0;
       i5 = i5 << 2 & 60;
       if ((i4 | 0) > 22) {
        i18 = 39;
        break;
       }
       i3 = i3 + 3 | 0;
       i20 = HEAPU8[i17 + i4 >> 0] | 0;
       HEAP8[i2 + 2 >> 0] = HEAP8[(i20 >>> 6 | i5) + (gb + 1059902) >> 0] | 0;
       HEAP8[i2 + 3 >> 0] = HEAP8[(i20 & 63) + (gb + 1059902) >> 0] | 0;
       if ((i3 | 0) >= 23) break; else i2 = i2 + 4 | 0;
      }
      if ((i18 | 0) == 39) HEAP8[i6 >> 0] = HEAP8[gb + 1059902 + i5 >> 0] | 0;
      HEAP8[i1 + 60 >> 0] = 0;
     }
    } else i1 = 0;
   }
  } else i1 = 0;
 } else i1 = 0; else i1 = 0; while (0);
 STACKTOP = i19;
 return i1 | 0;
}

function __Z28AddBlendShapeFrameFromScriptR4Mesh11ICallStringfP11Il2CppArrayS3_S3_(i11, i18, f20, i13, i15, i17) {
 i11 = i11 | 0;
 i18 = i18 | 0;
 f20 = Math_fround(f20);
 i13 = i13 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i16 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i26 + 16 | 0;
 i5 = i26 + 8 | 0;
 i22 = i26 + 64 | 0;
 i4 = i26 + 48 | 0;
 i23 = i26 + 32 | 0;
 i24 = i26 + 20 | 0;
 i19 = HEAP32[(HEAP32[i11 + 32 >> 2] | 0) + 100 >> 2] | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i13) | 0;
 i14 = (i15 | 0) != 0;
 if (i14) i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i15) | 0; else i2 = i19;
 i16 = (i17 | 0) != 0;
 if (i16) i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i17) | 0; else i3 = i19;
 if (!((i1 | 0) == (i19 | 0) & (i2 | 0) == (i19 | 0) & (i3 | 0) == (i19 | 0))) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404269 | 0, i26);
 i12 = i11 + 72 | 0;
 i21 = i11 + 112 | 0;
 i9 = i11 + 116 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 i10 = i1 - i2 | 0;
 i8 = i10 >> 4;
 do if ((i10 | 0) > 0) {
  __ZNK11ICallString6ToUTF8Ev(i4, i18);
  i3 = __Z15GetChannelIndexRK14BlendShapeDataPKc(i12, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = i8 + -1 | 0;
  if ((i3 | 0) > -1 & (i3 | 0) < (i1 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404332 | 0, i5);
  i6 = HEAP32[i21 >> 2] | 0;
  if ((i3 | 0) != -1) {
   i2 = HEAP32[i6 + (i3 << 4) + 8 >> 2] | 0;
   i4 = HEAP32[i6 + (i3 << 4) + 12 >> 2] | 0;
   i5 = i4 + i2 | 0;
   if (!(Math_fround(HEAPF32[(HEAP32[i11 + 124 >> 2] | 0) + (i5 + -1 << 2) >> 2]) >= f20)) {
    i8 = i3;
    i10 = i2;
    i9 = i4 + 1 | 0;
    break;
   }
   __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404364 | 0, i7);
  }
  i4 = (HEAP32[i6 + (i1 << 4) + 12 >> 2] | 0) + (HEAP32[i6 + (i1 << 4) + 8 >> 2] | 0) | 0;
  i2 = i8 + 1 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = i1 - i6 >> 4;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj(i21, i2 - i3 | 0);
   i10 = i4;
   i9 = 1;
   i5 = i4;
   break;
  }
  if (i2 >>> 0 < i3 >>> 0) {
   i2 = i6 + (i2 << 4) | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i10 = i4;
    i9 = 1;
    i5 = i4;
   } else {
    do {
     i10 = i1 + -16 | 0;
     HEAP32[i9 >> 2] = i10;
     __ZN14ConstantStringD2Ev(i10);
     i1 = HEAP32[i9 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
    i10 = i4;
    i9 = 1;
    i5 = i4;
   }
  } else {
   i10 = i4;
   i9 = 1;
   i5 = i4;
  }
 } else {
  if (!i8) {
   __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj(i21, 1);
   i8 = 0;
   i10 = 0;
   i9 = 1;
   i5 = 0;
   break;
  }
  i2 = i2 + 16 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i8 = 0;
   i10 = 0;
   i9 = 1;
   i5 = 0;
  } else {
   do {
    i10 = i1 + -16 | 0;
    HEAP32[i9 >> 2] = i10;
    __ZN14ConstantStringD2Ev(i10);
    i1 = HEAP32[i9 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i8 = 0;
   i10 = 0;
   i9 = 1;
   i5 = 0;
  }
 } while (0);
 i7 = i11 + 92 | 0;
 i6 = i5 + 1 | 0;
 i1 = i11 + 104 | 0;
 HEAP32[i1 >> 2] = i6;
 i2 = i11 + 108 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i6 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i6 * 12 | 0, 4, i11 + 96 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 12 | 0, 4, i11 + 96 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i7 >> 2] = i4;
  break;
 } while (0);
 i4 = i11 + 124 | 0;
 i1 = i11 + 136 | 0;
 HEAP32[i1 >> 2] = i6;
 i2 = i11 + 140 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i6 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i6 << 2, 4, i11 + 128 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i11 + 128 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i4 >> 2] = i11;
  break;
 } while (0);
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i13, 0, 12) | 0;
 if (i14) i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i15, 0, 12) | 0; else i2 = 0;
 if (i16) i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i17, 0, 12) | 0; else i1 = 0;
 __Z21SetBlendShapeVerticesPK8Vector3fS1_S1_R13dynamic_arrayI16BlendShapeVertexLj4EER10BlendShapei(i3, i2, i1, i12, (HEAP32[i7 >> 2] | 0) + (i5 * 12 | 0) | 0, i19);
 HEAPF32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = f20;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i24, i18);
 i4 = HEAP8[i24 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
 i4 = i1 ? HEAP32[i24 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i23 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
  i1 = HEAP32[i23 + 12 >> 2] | 0;
  i25 = 37;
 } else if (i4 >>> 0 < 11) {
  i1 = i23 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i23; else {
   i2 = i23;
   i25 = 39;
  }
 } else i25 = 37;
 if ((i25 | 0) == 37) {
  i19 = i4 + 16 & -16;
  HEAP32[i22 >> 2] = 66;
  HEAP32[i22 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i23 >> 2] = i2;
  HEAP32[i23 + 8 >> 2] = i19 | -2147483648;
  HEAP32[i23 + 4 >> 2] = i4;
  i1 = i23 + 11 | 0;
  i25 = 39;
 }
 if ((i25 | 0) == 39) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __Z17InitializeChannelRK8UnityStriiR17BlendShapeChannel(i23, i10, i9, (HEAP32[i21 >> 2] | 0) + (i8 << 4) | 0);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  STACKTOP = i26;
  return;
 }
 i25 = HEAP32[i23 >> 2] | 0;
 i23 = HEAP32[i23 + 12 >> 2] | 0;
 HEAP32[i22 >> 2] = 66;
 HEAP32[i22 + 4 >> 2] = i23;
 __Z19free_alloc_internalPvRK10MemLabelId(i25, i22);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 STACKTOP = i26;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i32, i33, i1) {
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i35 + 40 | 0;
 i28 = i35 + 24 | 0;
 i29 = i35 + 20 | 0;
 i30 = i35 + 16 | 0;
 i34 = i35;
 i31 = i33 + 8 | 0;
 HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i32, gb + 1041885 | 0, gb + 1041885 | 0, i30) | 0)) {
  STACKTOP = i35;
  return;
 };
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = 0;
 i13 = i33 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i33, HEAP32[i13 >> 2] | 0);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i33 >> 2] = i13;
 HEAP32[i13 >> 2] = 0;
 if ((HEAP32[i30 >> 2] | 0) > 0) {
  i14 = HEAP32[gb + 37152 >> 2] | 0;
  i15 = i28 + 4 | 0;
  i16 = i34 + 4 | 0;
  i17 = i28 + 8 | 0;
  i18 = i28 + 12 | 0;
  i19 = i34 + 8 | 0;
  i20 = i13;
  i21 = i33 + 4 | 0;
  i22 = i28 + 4 | 0;
  i23 = i28 + 12 | 0;
  i24 = HEAP32[gb + 37008 >> 2] | 0;
  i25 = HEAP32[gb + 37224 >> 2] | 0;
  i26 = HEAP32[gb + 37228 >> 2] | 0;
  i12 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i32, gb + 1041891 | 0, i14, i29, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i32, i24, gb + 479385 | 0, i27, 1) | 0;
     if (i1 | 0) {
      if ((i1 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i34, i32); else {
       i1 = HEAP32[i27 >> 2] | 0;
       if (i1 | 0) mftCall_iii(i1 | 0, i34 | 0, i32 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i32);
     }
     i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i32, i25, gb + 479398 | 0, i28, 1) | 0;
     if (i1 | 0) {
      if ((i1 | 0) > 0) {
       i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i32, gb + 479409 | 0, i26, i27, 1) | 0;
       if (i1 | 0) {
        if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS3_EENS4_9allocatorIS3_EEEEEvRT_17TransferMetaFlags(i32, i16, 0); else {
         i1 = HEAP32[i27 >> 2] | 0;
         if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i32 | 0) | 0;
        }
        __ZN14SafeBinaryRead11EndTransferEv(i32);
       }
      } else {
       i1 = HEAP32[i28 >> 2] | 0;
       if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i32 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i32);
     }
    } else {
     i1 = HEAP32[i29 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i34 | 0, i32 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i32);
   }
   HEAP32[i28 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i15 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i16 >> 2] | 0;
   i3 = i2 - i1 | 0;
   i4 = (i3 | 0) / 36 | 0;
   if (!i3) {
    i11 = 0;
    i3 = 0;
    i1 = 0;
   } else {
    if (i4 >>> 0 > 119304647) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i15);
     i5 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i19 >> 2] | 0;
    } else i5 = i1;
    i1 = __Znwj(i3) | 0;
    HEAP32[i17 >> 2] = i1;
    HEAP32[i15 >> 2] = i1;
    HEAP32[i23 >> 2] = i1 + (i4 * 36 | 0);
    i2 = i2 - i5 | 0;
    i3 = i1;
    if ((i2 | 0) > 0) {
     _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
     i11 = i1 + (((i2 >>> 0) / 36 | 0) * 36 | 0) | 0;
     HEAP32[i17 >> 2] = i11;
    } else i11 = i3;
   }
   i2 = HEAP32[i13 >> 2] | 0;
   do if (!i2) {
    HEAP32[i27 >> 2] = i13;
    i10 = i20;
    i5 = i13;
   } else {
    i6 = HEAP32[i28 >> 2] | 0;
    while (1) {
     i4 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i6 | 0) < (i4 | 0)) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i4 = 42;
       break;
      } else i2 = i4;
     } else {
      if ((i4 | 0) >= (i6 | 0)) {
       i4 = 47;
       break;
      }
      i5 = i2 + 4 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) {
       i4 = 46;
       break;
      } else i2 = i4;
     }
    }
    if ((i4 | 0) == 42) {
     HEAP32[i27 >> 2] = i2;
     i10 = i2;
     i5 = i2;
     break;
    } else if ((i4 | 0) == 46) {
     HEAP32[i27 >> 2] = i2;
     i10 = i2;
     break;
    } else if ((i4 | 0) == 47) {
     HEAP32[i27 >> 2] = i2;
     i10 = i2;
     i5 = i27;
     break;
    }
   } while (0);
   if (!(HEAP32[i5 >> 2] | 0)) {
    i1 = __Znwj(32) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i28 >> 2];
    i8 = i1 + 20 | 0;
    HEAP32[i8 >> 2] = 0;
    i9 = i1 + 24 | 0;
    HEAP32[i9 >> 2] = 0;
    i6 = i1 + 28 | 0;
    HEAP32[i6 >> 2] = 0;
    i4 = i11 - i3 | 0;
    i7 = (i4 | 0) / 36 | 0;
    if (i4 | 0) {
     if (i7 >>> 0 > 119304647) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
      i3 = HEAP32[i15 >> 2] | 0;
      i2 = HEAP32[i17 >> 2] | 0;
     } else i2 = i11;
     i4 = __Znwj(i4) | 0;
     HEAP32[i9 >> 2] = i4;
     HEAP32[i8 >> 2] = i4;
     HEAP32[i6 >> 2] = i4 + (i7 * 36 | 0);
     i2 = i2 - i3 | 0;
     if ((i2 | 0) > 0) {
      _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
      HEAP32[i9 >> 2] = i4 + (((i2 >>> 0) / 36 | 0) * 36 | 0);
     }
    }
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i10;
    HEAP32[i5 >> 2] = i1;
    i2 = HEAP32[HEAP32[i33 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i33 >> 2] = i2;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i1);
    HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
    i1 = HEAP32[i22 >> 2] | 0;
   }
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i17 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i3 + (~(((i3 + -36 - i2 | 0) >>> 0) / 36 | 0) * 36 | 0);
    __ZdlPv(i1);
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) < (HEAP32[i30 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i32);
 i3 = HEAP32[i34 + 4 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i1 = i34 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -36 - i4 | 0) >>> 0) / 36 | 0) * 36 | 0);
  __ZdlPv(i3);
 }
 STACKTOP = i35;
 return;
}

function __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 16 | 0;
 i10 = i16;
 __ZN8Material8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12);
 i14 = i12 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i15 = i12 + 24 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i3;
 }
 HEAP32[i11 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i11 + 116 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 1);
  i1 = HEAP8[i13 >> 0] | 0;
 } else {
  i9 = HEAP8[i4 >> 0] | 0;
  HEAP8[i13 >> 0] = i9;
  HEAP32[i14 >> 2] = i1;
  i1 = i9;
 }
 HEAP8[i11 + 120 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
 i3 = i11 + 124 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 128 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 i4 = i11 + 256 | 0;
 HEAP32[i4 >> 2] = i1 >>> 24 & 1;
 HEAP32[i11 + 172 >> 2] = _llvm_bswap_i32(i1 & -16777729 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i9;
  HEAP32[i14 >> 2] = i1;
  i1 = i9;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11 + 108 | 0, i12);
 i3 = i11 + 176 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i11 + 180 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i11 + 156 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i7, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
 i8 = i7 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i9 = i11 + 160 | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i6 & 255) | 0)) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i10 + 12 >> 2] | 0;
   i5 = 30;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i10 + 11 >> 0] = i3;
   if (!i3) i1 = i10; else {
    i1 = i10;
    i5 = 32;
   }
  } else i5 = 30;
  if ((i5 | 0) == 30) {
   i6 = i3 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 8 >> 2] = i6 | -2147483648;
   HEAP32[i10 + 4 >> 2] = i3;
   i5 = 32;
  }
  if ((i5 | 0) == 32) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i10 + 11 | 0;
  do if ((i7 | 0) != (i10 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
   i6 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i8 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i11 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i9 >> 2] = i6;
    break;
   } else {
    HEAP8[i8 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
  }
 }
 i1 = i11 + 264 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i15 = HEAP32[i13 >> 2] | 0;
  i15 = _llvm_bswap_i32(i15 | 0) | 0;
  HEAP32[i1 >> 2] = i15;
  i15 = i11 + 240 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i15, i12);
  STACKTOP = i16;
  return;
 } else {
  i15 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i15;
  HEAP32[i14 >> 2] = i3;
  i15 = _llvm_bswap_i32(i15 | 0) | 0;
  HEAP32[i1 >> 2] = i15;
  i15 = i11 + 240 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i15, i12);
  STACKTOP = i16;
  return;
 }
}

function __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i22, i1, i3) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f21 = Math_fround(f9 * f9);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f20 = Math_fround(f9 * f14);
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f15 = Math_fround(f9 * f16);
 f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(f9 * f19);
 f17 = Math_fround(f14 * f14);
 f12 = Math_fround(f14 * f16);
 f14 = Math_fround(f14 * f19);
 f18 = Math_fround(f16 * f16);
 f16 = Math_fround(f16 * f19);
 f19 = Math_fround(f19 * f19);
 i11 = HEAP32[gb + 62576 + (i3 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[gb + 62576 + (i3 * 12 | 0) + 4 >> 2] | 0;
 i13 = HEAP32[gb + 62576 + (i3 * 12 | 0) + 8 >> 2] | 0;
 L1 : do switch (i3 | 0) {
 case 5:
  {
   f4 = Math_fround(f15 + f14);
   f5 = Math_fround(f16 - f20);
   f10 = Math_fround(f5 * Math_fround(2.0));
   f2 = Math_fround(f19 + Math_fround(Math_fround(f21 - f18) - f17));
   f8 = Math_fround(f4 * Math_fround(2.0));
   i3 = f4 < Math_fround(0.0);
   f7 = Math_fround(-f4);
   if ((i3 ? f7 : f4) < Math_fround(.499998987)) {
    f5 = Math_fround(Math_fround(f9 - f12) * Math_fround(2.0));
    i3 = i13;
    f6 = Math_fround(f19 + Math_fround(Math_fround(f18 - f17) - f21));
    f7 = Math_fround(1.0);
    f9 = f8;
    f4 = f10;
    break L1;
   } else {
    f7 = Math_fround(f15 - f14);
    f9 = Math_fround(f20 + f16);
    f6 = Math_fround(Math_fround(f5 * f9) - Math_fround(f4 * f7));
    f5 = Math_fround(Math_fround(f4 * f9) + Math_fround(f5 * f7));
    i3 = fb + 9 | 0;
    f7 = Math_fround(1.0);
    f9 = f8;
    f4 = f10;
    break L1;
   }
  }
 case 1:
  {
   f4 = Math_fround(f20 + f16);
   f5 = Math_fround(f9 - f12);
   f6 = Math_fround(f5 * Math_fround(2.0));
   f7 = Math_fround(f19 + Math_fround(Math_fround(f17 - f18) - f21));
   f2 = Math_fround(f4 * Math_fround(2.0));
   i3 = f4 < Math_fround(0.0);
   f10 = Math_fround(-f4);
   if ((i3 ? f10 : f4) < Math_fround(.499998987)) {
    f5 = f6;
    i3 = i13;
    f6 = f7;
    f7 = Math_fround(Math_fround(f14 - f15) * Math_fround(2.0));
    f9 = Math_fround(f19 + Math_fround(Math_fround(f21 - f18) - f17));
    f4 = Math_fround(1.0);
    break L1;
   } else {
    f20 = Math_fround(f20 - f16);
    f9 = Math_fround(f12 + f9);
    f21 = Math_fround(Math_fround(f4 * f9) + Math_fround(f5 * f20));
    f9 = Math_fround(Math_fround(f5 * f9) - Math_fround(f4 * f20));
    i11 = fb + 9 | 0;
    f5 = f6;
    i3 = i13;
    f6 = f7;
    f7 = f21;
    f4 = Math_fround(1.0);
    break L1;
   }
  }
 case 2:
  {
   f4 = Math_fround(f20 - f16);
   f6 = Math_fround(f15 + f14);
   f7 = Math_fround(f6 * Math_fround(2.0));
   f8 = Math_fround(f19 + Math_fround(Math_fround(f21 - f18) - f17));
   f2 = Math_fround(f4 * Math_fround(2.0));
   i3 = f4 < Math_fround(0.0);
   f10 = Math_fround(-f4);
   if ((i3 ? f10 : f4) < Math_fround(.499998987)) {
    f5 = Math_fround(Math_fround(f12 + f9) * Math_fround(2.0));
    i3 = i13;
    f6 = Math_fround(Math_fround(Math_fround(f17 - f21) - f18) + f19);
    f9 = f8;
    f4 = Math_fround(-1.0);
    break L1;
   } else {
    f9 = Math_fround(f20 + f16);
    f21 = Math_fround(f14 - f15);
    f5 = Math_fround(Math_fround(f4 * f21) + Math_fround(f6 * f9));
    i3 = i13;
    f6 = Math_fround(Math_fround(f6 * f21) - Math_fround(f4 * f9));
    f9 = f8;
    f4 = Math_fround(-1.0);
    i1 = fb + 9 | 0;
    break L1;
   }
  }
 case 4:
  {
   f10 = Math_fround(f12 - f9);
   f4 = Math_fround(f20 + f16);
   f8 = Math_fround(f4 * Math_fround(2.0));
   f2 = Math_fround(f19 + Math_fround(Math_fround(f17 - f18) - f21));
   f6 = Math_fround(f10 * Math_fround(2.0));
   i3 = f10 < Math_fround(0.0);
   f7 = Math_fround(-f10);
   if ((i3 ? f7 : f10) < Math_fround(.499998987)) {
    f5 = Math_fround(-1.0);
    i3 = i13;
    f7 = Math_fround(Math_fround(f15 + f14) * Math_fround(2.0));
    f9 = Math_fround(f19 + Math_fround(Math_fround(f18 - f21) - f17));
    f4 = f8;
    break L1;
   } else {
    f21 = Math_fround(f9 - f12);
    f5 = Math_fround(f20 - f16);
    f9 = Math_fround(f12 + f9);
    f7 = Math_fround(Math_fround(f4 * f9) + Math_fround(f21 * f5));
    f9 = Math_fround(Math_fround(f21 * f9) - Math_fround(f4 * f5));
    f5 = Math_fround(-1.0);
    i3 = fb + 9 | 0;
    f4 = f8;
    break L1;
   }
  }
 case 3:
  {
   f8 = Math_fround(f12 + f9);
   f10 = Math_fround(f14 - f15);
   f2 = Math_fround(f10 * Math_fround(2.0));
   f4 = Math_fround(f19 + Math_fround(Math_fround(f18 - f17) - f21));
   f6 = Math_fround(f8 * Math_fround(2.0));
   i3 = f8 < Math_fround(0.0);
   f7 = Math_fround(-f8);
   if ((i3 ? f7 : f8) < Math_fround(.499998987)) {
    f5 = Math_fround(1.0);
    i3 = i13;
    f7 = f2;
    f9 = f4;
    f4 = Math_fround(Math_fround(f16 - f20) * Math_fround(2.0));
    f2 = Math_fround(f19 + Math_fround(Math_fround(f17 - f18) - f21));
    break L1;
   } else {
    f21 = Math_fround(f12 - f9);
    f20 = Math_fround(f15 + f14);
    f5 = Math_fround(1.0);
    i3 = i13;
    f7 = f2;
    f9 = f4;
    f4 = Math_fround(Math_fround(f8 * f20) + Math_fround(f10 * f21));
    f2 = Math_fround(Math_fround(f10 * f20) - Math_fround(f8 * f21));
    i1 = fb + 9 | 0;
    break L1;
   }
  }
 case 0:
  {
   f2 = Math_fround(f15 - f14);
   f4 = Math_fround(f12 + f9);
   f5 = Math_fround(f4 * Math_fround(2.0));
   f6 = Math_fround(f19 + Math_fround(Math_fround(f18 - f17) - f21));
   f8 = Math_fround(f2 * Math_fround(2.0));
   i3 = f2 < Math_fround(0.0);
   f10 = Math_fround(-f2);
   if ((i3 ? f10 : f2) < Math_fround(.499998987)) {
    i3 = i13;
    f7 = Math_fround(-1.0);
    f9 = f8;
    f4 = Math_fround(Math_fround(f20 + f16) * Math_fround(2.0));
    f2 = Math_fround(f19 + Math_fround(Math_fround(f21 - f18) - f17));
    break L1;
   } else {
    f7 = Math_fround(f15 + f14);
    f9 = Math_fround(f9 - f12);
    f21 = Math_fround(Math_fround(f2 * f9) + Math_fround(f4 * f7));
    f2 = Math_fround(Math_fround(f4 * f9) - Math_fround(f2 * f7));
    i11 = fb + 9 | 0;
    i3 = i13;
    f7 = Math_fround(-1.0);
    f9 = f8;
    f4 = f21;
    break L1;
   }
  }
 default:
  {
   f5 = Math_fround(0.0);
   i3 = i13;
   f6 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
 } while (0);
 f19 = Math_fround(+mftCall_fff(i11 | 0, +f5, +f6));
 f20 = Math_fround(+mftCall_fff(i1 | 0, +f7, +f9));
 f21 = Math_fround(+mftCall_fff(i3 | 0, +f4, +f2));
 HEAPF32[i22 >> 2] = f19;
 HEAPF32[i22 + 4 >> 2] = f20;
 HEAPF32[i22 + 8 >> 2] = f21;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE(i22, i1, i27) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i28 + 80 | 0;
 i26 = i28 + 56 | 0;
 i2 = i28 + 8 | 0;
 i18 = i28 + 96 | 0;
 i15 = i28;
 i20 = i28 + 44 | 0;
 i23 = i28 + 32 | 0;
 i25 = i28 + 16 | 0;
 i17 = i22 + 492 | 0;
 HEAP32[i17 >> 2] = 0;
 i24 = HEAP32[i22 + 28 >> 2] | 0;
 i4 = i1;
 i19 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i16 = i2;
 HEAP32[i16 >> 2] = i19;
 HEAP32[i16 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN5physx5cloth16TripletSchedulerC2ENS0_5RangeIA4_KjEE(i26, i3);
 __ZN5physx5cloth16TripletScheduler4simdEjj(i26, i24 & 65535, 4);
 HEAP16[i18 >> 1] = i24;
 HEAP16[i18 + 2 >> 1] = i24 + 1;
 HEAP16[i18 + 4 >> 1] = i24 + 2;
 HEAP16[i18 + 6 >> 1] = 0;
 i24 = i26 + 12 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i2 = HEAP32[i26 + 16 >> 2] | 0;
 i16 = i3 + (i2 << 2) | 0;
 i4 = HEAP32[i26 >> 2] | 0;
 i21 = i22 + 468 | 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE6resizeEjRKS4_(i21, 0, i28 + 88 | 0);
 i1 = ((HEAP32[i1 + 4 >> 2] | 0) - i19 >> 4) + ((i2 << 2 >> 2) * 3 | 0) | 0;
 i19 = i22 + 476 | 0;
 if ((HEAP32[i19 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE8recreateEj(i21, i1);
 if (!i2) {
  i12 = i22 + 472 | 0;
  i1 = i21;
 } else {
  i12 = i22 + 472 | 0;
  i11 = i15 + 2 | 0;
  i13 = i15 + 4 | 0;
  i14 = i15 + 6 | 0;
  i1 = i4;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = i1 + (i2 << 4) | 0;
   if (i2) {
    i2 = ((i2 << 4) + -16 | 0) >>> 4;
    i9 = i1;
    do {
     HEAP16[i15 >> 1] = HEAP32[i9 >> 2];
     HEAP16[i11 >> 1] = HEAP32[i9 + 4 >> 2];
     HEAP16[i13 >> 1] = HEAP32[i9 + 8 >> 2];
     HEAP16[i14 >> 1] = HEAP32[i9 + 12 >> 2];
     i4 = HEAP32[i12 >> 2] | 0;
     if ((HEAP32[i19 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i29 = i15;
      i31 = HEAP32[i29 >> 2] | 0;
      i29 = HEAP32[i29 + 4 >> 2] | 0;
      i4 = (HEAP32[i21 >> 2] | 0) + (i4 << 3) | 0;
      i30 = i4;
      HEAP16[i30 >> 1] = i31;
      HEAP16[i30 + 2 >> 1] = i31 >>> 16;
      i4 = i4 + 4 | 0;
      HEAP16[i4 >> 1] = i29;
      HEAP16[i4 + 2 >> 1] = i29 >>> 16;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE15growAndPushBackERKS4_(i21, i15) | 0;
     i9 = i9 + 16 | 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
    } while ((i9 | 0) != (i10 | 0));
    i1 = i1 + (i2 + 1 << 4) | 0;
   }
   __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE6resizeEjRKS4_(i21, (HEAP32[i12 >> 2] | 0) + 3 & -4, i18);
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i16 | 0));
  i1 = i21;
 }
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i11 = i20 + 4 | 0;
 i1 = (i1 | 0) < 0 ? 0 : i1 << 3 >> 3;
 HEAP32[i11 >> 2] = i1;
 i10 = i20 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 if (!i1) {
  HEAP32[i20 >> 2] = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i20, i1 << 3, gb + 838004 | 0, 543) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i20 >> 2] = i1;
  i4 = i1 + (i2 << 3) | 0;
  i3 = i1;
  if ((i2 | 0) > 0) {
   i2 = i1;
   i1 = i9;
   while (1) {
    i30 = i1;
    i18 = i30;
    i18 = HEAPU16[i18 >> 1] | HEAPU16[i18 + 2 >> 1] << 16;
    i30 = i30 + 4 | 0;
    i30 = HEAPU16[i30 >> 1] | HEAPU16[i30 + 2 >> 1] << 16;
    i31 = i2;
    i29 = i31;
    HEAP16[i29 >> 1] = i18;
    HEAP16[i29 + 2 >> 1] = i18 >>> 16;
    i31 = i31 + 4 | 0;
    HEAP16[i31 >> 1] = i30;
    HEAP16[i31 + 2 >> 1] = i30 >>> 16;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 8 | 0;
   }
   i3 = HEAP32[i20 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  }
 }
 i1 = HEAP32[i21 >> 2] | 0;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i21 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i2;
 i30 = HEAP32[i10 >> 2] | 0;
 i31 = HEAP32[i19 >> 2] | 0;
 HEAP32[i10 >> 2] = i31;
 HEAP32[i19 >> 2] = i30;
 if ((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i1);
 i14 = i22 + 480 | 0;
 i31 = HEAP32[i14 >> 2] | 0;
 HEAP32[i23 >> 2] = i31;
 HEAP32[i14 >> 2] = 0;
 i15 = i22 + 484 | 0;
 HEAP32[i23 + 4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = 0;
 i13 = i22 + 488 | 0;
 i30 = HEAP32[i13 >> 2] | 0;
 HEAP32[i23 + 8 >> 2] = i30;
 HEAP32[i13 >> 2] = 0;
 i1 = i31;
 if ((i30 & 2147483647 | 0) == 0 | (i30 | 0) < 0 | (i31 | 0) == 0) i2 = 0; else {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i23, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
  i2 = HEAP32[i13 >> 2] & 2147483647;
 }
 i11 = HEAP32[i27 + 4 >> 2] | 0;
 i12 = HEAP32[i27 >> 2] | 0;
 i3 = i12;
 i1 = (i11 - i3 | 0) / 12 | 0;
 if (i2 >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i14, i1);
 if (i12 >>> 0 < i11 >>> 0) {
  i4 = i25 + 4 | 0;
  i9 = i25 + 8 | 0;
  i10 = i25 + 12 | 0;
  i1 = i12 + 12 | 0;
  i1 = ((((i11 >>> 0 > i1 >>> 0 ? i11 : i1) + ~i3 | 0) >>> 0) / 12 | 0) + 1 | 0;
  i2 = i12;
  do {
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)));
   HEAPF32[i25 >> 2] = f5;
   HEAPF32[i4 >> 2] = f6;
   HEAPF32[i9 >> 2] = f7;
   HEAPF32[i10 >> 2] = f8;
   i3 = HEAP32[i15 >> 2] | 0;
   if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i31 = HEAP32[i14 >> 2] | 0;
    HEAPF32[i31 + (i3 << 4) >> 2] = f5;
    HEAPF32[i31 + (i3 << 4) + 4 >> 2] = f6;
    HEAPF32[i31 + (i3 << 4) + 8 >> 2] = f7;
    HEAPF32[i31 + (i3 << 4) + 12 >> 2] = f8;
    HEAP32[i15 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i14, i25) | 0;
   i2 = i2 + 12 | 0;
  } while (i2 >>> 0 < i11 >>> 0);
  HEAP32[i27 >> 2] = i12 + (i1 * 12 | 0);
 }
 i31 = HEAP32[i26 + 20 >> 2] | 0;
 if ((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, HEAP32[i24 >> 2] | 0);
 i31 = HEAP32[i26 + 8 >> 2] | 0;
 if (!((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0)) {
  STACKTOP = i28;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, HEAP32[i26 >> 2] | 0);
 STACKTOP = i28;
 return;
}

function __ZN3MBP9addObjectERK5IAABBjb(i27, i23, i33, i26) {
 i27 = i27 | 0;
 i23 = i23 | 0;
 i33 = i33 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34 + 1029 | 0;
 i32 = i34 + 1028 | 0;
 i25 = i34;
 i1 = i27 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i27 + 36 | 0;
 if ((i2 | 0) == -1) {
  i2 = i27 + 40 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 + 3 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
   __ZN5physx2Gu9Container6ResizeEj(i4, 3) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } else i1 = i3;
  i29 = (HEAP32[i27 + 44 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i2 >> 2] = i1 + 3;
  i31 = (i3 >>> 0) / 3 | 0;
  i24 = 0;
 } else {
  i29 = HEAP32[i27 + 44 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i29 + (i2 * 12 | 0) + 8 >> 2];
  i31 = i2;
  i24 = ((HEAPU16[i29 + (i2 * 12 | 0) + 6 >> 1] | 0) >>> 1 & 1 ^ 1) & 65535;
  i29 = i29 + (i2 * 12 | 0) | 0;
 }
 i28 = i24 << 1 | i26 & 1 | i31 << 2;
 i15 = HEAP32[i27 + 8 >> 2] | 0;
 i16 = HEAP32[i27 + 28 >> 2] | 0;
 L8 : do if (!i15) {
  i1 = 0;
  i2 = 1;
 } else {
  i17 = i23 + 12 | 0;
  i18 = i23 + 4 | 0;
  i19 = i23 + 16 | 0;
  i20 = i23 + 8 | 0;
  i21 = i23 + 20 | 0;
  i22 = 0;
  i5 = 0;
  i6 = 1;
  do {
   i1 = HEAP32[i16 + (i22 * 40 | 0) + 16 >> 2] | 0;
   i2 = HEAP32[i23 >> 2] | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    i3 = HEAP32[i17 >> 2] | 0;
    i4 = HEAP32[i16 + (i22 * 40 | 0) + 4 >> 2] | 0;
    if (i3 >>> 0 >= i4 >>> 0) {
     i7 = HEAP32[i16 + (i22 * 40 | 0) + 20 >> 2] | 0;
     i8 = HEAP32[i18 >> 2] | 0;
     if (i7 >>> 0 >= i8 >>> 0) {
      i9 = HEAP32[i19 >> 2] | 0;
      i10 = HEAP32[i16 + (i22 * 40 | 0) + 8 >> 2] | 0;
      if (i9 >>> 0 >= i10 >>> 0) {
       i11 = HEAP32[i16 + (i22 * 40 | 0) + 24 >> 2] | 0;
       i12 = HEAP32[i20 >> 2] | 0;
       if (i11 >>> 0 >= i12 >>> 0) {
        i13 = HEAP32[i21 >> 2] | 0;
        i14 = HEAP32[i16 + (i22 * 40 | 0) + 12 >> 2] | 0;
        if (i13 >>> 0 >= i14 >>> 0) {
         HEAP16[i25 + (i5 << 2) >> 1] = __ZN9BoxPruner9addObjectERK5IAABBjb(HEAP32[i16 + (i22 * 40 | 0) + 28 >> 2] | 0, i23, i28, i26) | 0;
         HEAP16[i25 + (i5 << 2) + 2 >> 1] = i22;
         i5 = i5 + 1 | 0;
         i6 = i6 & (i11 >>> 0 >= i13 >>> 0 & ((i4 >>> 0 > i2 >>> 0 | i10 >>> 0 > i8 >>> 0 | i14 >>> 0 > i12 >>> 0 | i1 >>> 0 < i3 >>> 0 | i7 >>> 0 < i9 >>> 0) ^ 1));
        }
       }
      }
     }
    }
   }
   i22 = i22 + 1 | 0;
  } while ((i22 | 0) != (i15 | 0));
  switch (i5 | 0) {
  case 0:
   {
    i1 = 0;
    i2 = i6;
    break L8;
   }
  case 1:
   {
    i1 = i29 + 8 | 0;
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP16[i1 >> 1] = i2;
    HEAP16[i1 + 2 >> 1] = i2 >>> 16;
    i1 = 1;
    i2 = i6;
    break L8;
   }
  default:
   {}
  }
  i4 = i27 + 96 + (i5 << 4) | 0;
  i1 = i27 + 4208 + (i5 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == -1) {
   i2 = i27 + 96 + (i5 << 4) + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i29 + 8 >> 2] = i1;
   i3 = i5 & 1073741823;
   if ((i1 + i3 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
    __ZN5physx2Gu9Container6ResizeEj(i4, i3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   }
   i23 = (HEAP32[i27 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i2 >> 2] = i1 + i3;
   i1 = i23;
  } else {
   HEAP32[i29 + 8 >> 2] = i2;
   i23 = (HEAP32[i27 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i2 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
   i1 = i23;
  }
  _memcpy(i1 | 0, i25 | 0, i5 << 2 | 0) | 0;
  i1 = i5;
  i2 = i6;
 } while (0);
 HEAP16[i29 + 4 >> 1] = i1;
 i8 = (i24 | 0) == 0 ? 0 : 2;
 i6 = (i1 | 0) != 0;
 i4 = i27 + 5252 | 0;
 i7 = i31 >>> 5;
 i5 = i27 + 5256 | 0;
 i1 = i7 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0;
 if (i2 & i6) {
  if (i1) i1 = HEAP32[i4 >> 2] | 0; else {
   i3 = i31 + 128 | 0;
   i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i3 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   if ((i3 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i3 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i2);
    HEAP32[i4 >> 2] = 0;
   }
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  i25 = i1 + (i7 << 2) | 0;
  HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | 1 << (i31 & 31);
 } else {
  if (i1) i1 = HEAP32[i4 >> 2] | 0; else {
   i3 = i31 + 128 | 0;
   i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i3 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   if ((i3 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i3 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i2);
    HEAP32[i4 >> 2] = 0;
   }
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  i25 = i1 + (i7 << 2) | 0;
  HEAP32[i25 >> 2] = HEAP32[i25 >> 2] & ~(1 << (i31 & 31));
 }
 if (!i6) {
  HEAP32[i29 + 8 >> 2] = i28;
  i2 = i27 + 5236 | 0;
  i3 = i27 + 5240 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
   __ZN5physx2Gu9Container6ResizeEj(i2, 1) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP32[(HEAP32[i27 + 5244 >> 2] | 0) + (i1 << 2) >> 2] = i33;
 }
 if (i26) {
  i32 = i29 + 6 | 0;
  HEAP16[i32 >> 1] = i8;
  HEAP32[i29 >> 2] = i33;
  STACKTOP = i34;
  return i28 | 0;
 }
 i5 = i27 + 80 | 0;
 i3 = i27 + 84 | 0;
 if (i7 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) i1 = HEAP32[i5 >> 2] | 0; else {
  i4 = i31 + 128 | 0;
  i4 = ((i4 & 31 | 0) != 0 & 1) + (i4 >>> 5) | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i4 << 2, gb + 717183 | 0, 412) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) i2 = 0; else {
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  if ((i4 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i2);
   HEAP32[i5 >> 2] = 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i4;
 }
 i32 = i1 + (i7 << 2) | 0;
 HEAP32[i32 >> 2] = HEAP32[i32 >> 2] | 1 << (i31 & 31);
 i32 = i29 + 6 | 0;
 HEAP16[i32 >> 1] = i8;
 HEAP32[i29 >> 2] = i33;
 STACKTOP = i34;
 return i28 | 0;
}

function __ZN7mecanim9animation20MotionOutputBlendEndEPNS0_12MotionOutputEbbRKNS_6bitsetILj66EEERf(i7, i2, i3, i4, i5) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0;
 if (i2) i6 = 4; else if (i3) if (HEAP32[i4 >> 2] & 1 | 0) i6 = 4;
 if ((i6 | 0) == 4) {
  f1 = Math_fround(HEAPF32[i5 >> 2]);
  if (f1 > Math_fround(0.0)) {
   i8 = i7 + 284 | 0;
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) / f1);
  }
 }
 f1 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i5 >> 2]))))));
 do if (i2) i6 = 9; else if (i3) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (!(i2 & 1)) break; else {
   i6 = 9;
   break;
  }
 } else return; while (0);
 do if ((i6 | 0) == 9) {
  i8 = i7 + 40 | 0;
  f14 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
  i6 = i7 + 44 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i2 = i7 + 48 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
  i12 = i7 + 52 | 0;
  f9 = Math_fround(f1 + Math_fround(HEAPF32[i12 >> 2]));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9))))));
  f10 = Math_fround(f10 * f13);
  f11 = Math_fround(f11 * f13);
  f9 = Math_fround(f9 * f13);
  HEAPF32[i8 >> 2] = Math_fround(f14 * f13);
  HEAPF32[i6 >> 2] = f10;
  HEAPF32[i2 >> 2] = f11;
  HEAPF32[i12 >> 2] = f9;
  i12 = i7 + 80 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(0.0));
  i2 = i7 + 84 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
  i6 = i7 + 88 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i8 = i7 + 92 | 0;
  f13 = Math_fround(f1 + Math_fround(HEAPF32[i8 >> 2]));
  f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f10 * f10) + Math_fround(f13 * f13))))));
  f11 = Math_fround(f11 * f14);
  f10 = Math_fround(f10 * f14);
  f13 = Math_fround(f13 * f14);
  HEAPF32[i12 >> 2] = Math_fround(f9 * f14);
  HEAPF32[i2 >> 2] = f11;
  HEAPF32[i6 >> 2] = f10;
  HEAPF32[i8 >> 2] = f13;
  i8 = i7 + 120 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
  i6 = i7 + 124 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i2 = i7 + 128 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
  i12 = i7 + 132 | 0;
  f14 = Math_fround(f1 + Math_fround(HEAPF32[i12 >> 2]));
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f11 * f11) + Math_fround(f14 * f14))))));
  f10 = Math_fround(f10 * f9);
  f11 = Math_fround(f11 * f9);
  f14 = Math_fround(f14 * f9);
  HEAPF32[i8 >> 2] = Math_fround(f13 * f9);
  HEAPF32[i6 >> 2] = f10;
  HEAPF32[i2 >> 2] = f11;
  HEAPF32[i12 >> 2] = f14;
  i12 = i7 + 160 | 0;
  f14 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(0.0));
  i2 = i7 + 164 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
  i6 = i7 + 168 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i8 = i7 + 172 | 0;
  f9 = Math_fround(f1 + Math_fround(HEAPF32[i8 >> 2]));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9))))));
  f11 = Math_fround(f11 * f13);
  f10 = Math_fround(f10 * f13);
  f9 = Math_fround(f9 * f13);
  HEAPF32[i12 >> 2] = Math_fround(f14 * f13);
  HEAPF32[i2 >> 2] = f11;
  HEAPF32[i6 >> 2] = f10;
  HEAPF32[i8 >> 2] = f9;
  if (i3) {
   i2 = HEAP32[i4 >> 2] | 0;
   break;
  } else return;
 } while (0);
 if (i2 & 1 | 0) {
  i3 = i7 + 304 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(0.0));
  i6 = i7 + 308 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i8 = i7 + 312 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
  i12 = i7 + 316 | 0;
  f14 = Math_fround(f1 + Math_fround(HEAPF32[i12 >> 2]));
  f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14))))));
  f11 = Math_fround(f11 * f10);
  f13 = Math_fround(f13 * f10);
  f14 = Math_fround(f14 * f10);
  HEAPF32[i3 >> 2] = Math_fround(f9 * f10);
  HEAPF32[i6 >> 2] = f11;
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i12 >> 2] = f14;
 }
 if (__ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE(i4) | 0) {
  i3 = i7 + 200 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(0.0));
  i6 = i7 + 204 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i8 = i7 + 208 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
  i12 = i7 + 212 | 0;
  f14 = Math_fround(f1 + Math_fround(HEAPF32[i12 >> 2]));
  f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14))))));
  f11 = Math_fround(f11 * f10);
  f13 = Math_fround(f13 * f10);
  f14 = Math_fround(f14 * f10);
  HEAPF32[i3 >> 2] = Math_fround(f9 * f10);
  HEAPF32[i6 >> 2] = f11;
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i12 >> 2] = f14;
 }
 if (__ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE(i4) | 0) {
  i4 = i7 + 240 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
  i6 = i7 + 244 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
  i8 = i7 + 248 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
  i12 = i7 + 252 | 0;
  f14 = Math_fround(f1 + Math_fround(HEAPF32[i12 >> 2]));
  f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14))))));
  f11 = Math_fround(f11 * f10);
  f13 = Math_fround(f13 * f10);
  f14 = Math_fround(f14 * f10);
  HEAPF32[i4 >> 2] = Math_fround(f9 * f10);
  HEAPF32[i6 >> 2] = f11;
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i12 >> 2] = f14;
 }
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 if (!(f1 > Math_fround(0.0))) return;
 i12 = i7 + 288 | 0;
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) / f1);
 return;
}

function __ZN5Unity14CharacterJoint6CreateEv(i10) {
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 28 | 0;
 i7 = i12;
 i9 = i10 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) i8 = 6; else {
  if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) __ZN5Unity5Joint7CleanupEv(i10);
  i2 = HEAP32[i9 >> 2] | 0;
  if (!i2) i8 = 6; else i5 = i9;
 }
 if ((i8 | 0) == 6) {
  i6 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
  i5 = i10 + 92 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (!i2) i2 = 0; else {
   HEAP32[i7 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i8 = 12; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i7);
     i3 = HEAP32[i11 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 12; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 14;
   }
   if ((i8 | 0) == 12) i8 = 14;
   if ((i8 | 0) == 14) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
    i2 = 0;
    break;
   }
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i8 = 20; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i7);
     i3 = HEAP32[i11 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 20; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i8 = 22;
    }
   }
   if ((i8 | 0) == 20) i8 = 22;
   if ((i8 | 0) == 22) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   i2 = HEAP32[i2 + 52 >> 2] | 0;
  } while (0);
  i5 = __Z14GetDynamicsSDKv() | 0;
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i11 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 24 >> 2] = Math_fround(0.0);
  i5 = __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i5, i6, i11, i2, i7) | 0;
  HEAP32[i9 >> 2] = i5;
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 64 >> 2] | 0;
  mftCall_viii(i2 | 0, i5 | 0, 32, __ZNK14PhysicsManager23GetPvdConnectionEnabledEv(__Z17GetPhysicsManagerv() | 0) | 0);
  i5 = i9;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 0, 0);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0, 1, 0);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0, 2, 0);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0, 3, 1);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0, 4, 1);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0, 5, 1);
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i4 >> 2] | 0) + 188 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i10 + 176 >> 2]));
 i4 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i4 >> 2] | 0) + 196 >> 2] | 0, i4 | 0, +Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i10 + 180 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
 i4 = HEAP32[i9 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 64 >> 2] | 0, i4 | 0, 6, (HEAP8[i10 + 172 >> 0] | 0) != 0 | 0);
 __ZN5Unity14CharacterJoint16SetLowTwistLimitERK14SoftJointLimit(i10, i10 + 116 | 0);
 __ZN5Unity14CharacterJoint17SetHighTwistLimitERK14SoftJointLimit(i10, i10 + 128 | 0);
 __ZN5Unity14CharacterJoint14SetSwing1LimitERK14SoftJointLimit(i10, i10 + 148 | 0);
 __ZN5Unity14CharacterJoint14SetSwing2LimitERK14SoftJointLimit(i10, i10 + 160 | 0);
 __ZN5Unity14CharacterJoint19SetTwistLimitSpringERK20SoftJointLimitSpring(i10, i10 + 108 | 0);
 i4 = i10 + 140 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i13 = f1 < Math_fround(0.0);
 i8 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i8 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i13 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i10 + 144 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i13 = f1 < Math_fround(0.0);
 i8 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i8 ? Math_fround(340282326000000008404918.0e15) : f1;
 i13 = i13 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i13;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  __ZN5Unity5Joint14FinalizeCreateEb(i10, 0);
  STACKTOP = i12;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) {
  __ZN5Unity5Joint14FinalizeCreateEb(i10, 0);
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 160 >> 2] | 0, i11 | 0, i13 | 0);
 HEAP32[i11 + 8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i3 >> 2];
 i13 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 156 >> 2] | 0, i13 | 0, i11 | 0);
 __ZN5Unity5Joint14FinalizeCreateEb(i10, 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_48PCMCapsuleVsHeightfieldContactGenerationCallbackEE7onEventEjPj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i53 + 108 | 0;
 i52 = i53 + 60 | 0;
 i50 = i53 + 72 | 0;
 i47 = i53 + 12 | 0;
 i48 = i53 + 24 | 0;
 i51 = i53;
 i40 = i49 + 848 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = (i3 + 15 | 0) >>> 4;
 if (!i41) {
  STACKTOP = i53;
  return 1;
 }
 i42 = i1 + 16 | 0;
 i43 = i49 + 832 | 0;
 i44 = i49 + 768 | 0;
 i45 = i49 + 576 | 0;
 i46 = i1 + 4 | 0;
 i38 = i1 + 8 | 0;
 i18 = i50 + 12 | 0;
 i19 = i50 + 16 | 0;
 i20 = i50 + 4 | 0;
 i21 = i50 + 20 | 0;
 i22 = i50 + 8 | 0;
 i23 = i50 + 24 | 0;
 i24 = i50 + 28 | 0;
 i25 = i50 + 32 | 0;
 i26 = i48 + 12 | 0;
 i27 = i48 + 16 | 0;
 i28 = i48 + 4 | 0;
 i29 = i48 + 20 | 0;
 i30 = i48 + 8 | 0;
 i31 = i48 + 24 | 0;
 i32 = i48 + 28 | 0;
 i33 = i48 + 32 | 0;
 i34 = i50 + 12 | 0;
 i35 = i50 + 24 | 0;
 i36 = i52 + 4 | 0;
 i37 = i52 + 8 | 0;
 i39 = 0;
 do {
  HEAP32[i40 >> 2] = 0;
  i17 = i3 >>> 0 < 16 ? i3 : 16;
  if (i17) {
   i7 = (i3 ^ -16) >>> 0 > 4294967279;
   i6 = i17;
   i16 = i2;
   do {
    i6 = i6 + -1 | 0;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i16 + 4 | 0;
    __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i50, i52, i47, i15, 0, 0) | 0;
    f13 = Math_fround(HEAPF32[i18 >> 2]);
    f11 = Math_fround(HEAPF32[i50 >> 2]);
    f13 = Math_fround(f13 - f11);
    f9 = Math_fround(HEAPF32[i19 >> 2]);
    f14 = Math_fround(HEAPF32[i20 >> 2]);
    f9 = Math_fround(f9 - f14);
    f12 = Math_fround(HEAPF32[i21 >> 2]);
    f10 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(f12 - f10);
    f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
    f14 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
    f10 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f10);
    f8 = Math_fround(Math_fround(f9 * f10) - Math_fround(f12 * f14));
    f10 = Math_fround(Math_fround(f12 * f11) - Math_fround(f13 * f10));
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f9 * f11));
    f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10)))));
    if (f9 > Math_fround(0.0)) {
     f14 = Math_fround(Math_fround(1.0) / f9);
     f8 = Math_fround(f8 * f14);
     f10 = Math_fround(f10 * f14);
     f11 = Math_fround(f11 * f14);
    }
    i5 = 0;
    i1 = 0;
    do {
     i4 = HEAP32[i47 + (i5 << 2) >> 2] | 0;
     if ((i4 | 0) == -1) i1 = (1 << i5 + 3 | i1 & 255) & 255; else {
      __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i48, i51, 0, i4, 0, 0) | 0;
      f58 = Math_fround(HEAPF32[i26 >> 2]);
      f55 = Math_fround(HEAPF32[i48 >> 2]);
      f58 = Math_fround(f58 - f55);
      f56 = Math_fround(HEAPF32[i27 >> 2]);
      f54 = Math_fround(HEAPF32[i28 >> 2]);
      f56 = Math_fround(f56 - f54);
      f59 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(HEAPF32[i30 >> 2]);
      f59 = Math_fround(f59 - f12);
      f9 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f55);
      f57 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f54);
      f14 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f12);
      f13 = Math_fround(Math_fround(f56 * f14) - Math_fround(f59 * f57));
      f14 = Math_fround(Math_fround(f59 * f9) - Math_fround(f58 * f14));
      f9 = Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f9));
      i4 = HEAPU8[gb + 768833 + i5 >> 0] | 0;
      f55 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) >> 2]) - f55);
      f54 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 4 >> 2]) - f54);
      if (Math_fround(Math_fround(Math_fround(f13 * f55) + Math_fround(f14 * f54)) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 8 >> 2]) - f12))) < Math_fround(0.0)) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)))));
       if (f12 > Math_fround(0.0)) {
        f59 = Math_fround(Math_fround(1.0) / f12);
        f13 = Math_fround(f13 * f59);
        f12 = Math_fround(f14 * f59);
        f9 = Math_fround(f9 * f59);
       } else f12 = f14;
       if (Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f10 * f12) + Math_fround(f8 * f13))) < Math_fround(.996999979)) i1 = (1 << i5 + 3 | i1 & 255) & 255;
      }
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 3);
    i5 = HEAP32[i40 >> 2] | 0;
    HEAP32[i40 >> 2] = i5 + 1;
    i61 = i5 * 3 | 0;
    HEAP32[i49 + (i61 * 12 | 0) >> 2] = HEAP32[i50 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 4 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    i60 = i61 + 1 | 0;
    HEAP32[i49 + (i60 * 12 | 0) >> 2] = HEAP32[i34 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
    i4 = i61 + 2 | 0;
    HEAP32[i49 + (i4 * 12 | 0) >> 2] = HEAP32[i35 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i49 + 576 + (i61 << 2) >> 2] = HEAP32[i52 >> 2];
    HEAP32[i49 + 576 + (i60 << 2) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i49 + 576 + (i4 << 2) >> 2] = HEAP32[i37 >> 2];
    HEAP32[i49 + 768 + (i5 << 2) >> 2] = i15;
    HEAP8[i49 + 832 + i5 >> 0] = i1;
   } while ((i6 | 0) != 0);
   i2 = i2 + ((i7 ? i3 : 16) << 2) | 0;
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1) {
    i4 = i43;
    i5 = i44;
    i6 = i45;
    i7 = i49;
    while (1) {
     i1 = i1 + -1 | 0;
     __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i42, i7, HEAP32[i5 >> 2] | 0, HEAP8[i4 >> 0] | 0, i6) | 0;
     if (!i1) break; else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 4 | 0;
      i6 = i6 + 12 | 0;
      i7 = i7 + 36 | 0;
     }
    }
   }
  }
  i3 = i3 - i17 | 0;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) != (i41 | 0));
 STACKTOP = i53;
 return 1;
}

function __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMSphereVsHeightfieldContactGenerationCallbackEE7onEventEjPj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i53 + 108 | 0;
 i52 = i53 + 60 | 0;
 i50 = i53 + 72 | 0;
 i47 = i53 + 12 | 0;
 i48 = i53 + 24 | 0;
 i51 = i53;
 i40 = i49 + 848 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = (i3 + 15 | 0) >>> 4;
 if (!i41) {
  STACKTOP = i53;
  return 1;
 }
 i42 = i1 + 16 | 0;
 i43 = i49 + 832 | 0;
 i44 = i49 + 768 | 0;
 i45 = i49 + 576 | 0;
 i46 = i1 + 4 | 0;
 i38 = i1 + 8 | 0;
 i18 = i50 + 12 | 0;
 i19 = i50 + 16 | 0;
 i20 = i50 + 4 | 0;
 i21 = i50 + 20 | 0;
 i22 = i50 + 8 | 0;
 i23 = i50 + 24 | 0;
 i24 = i50 + 28 | 0;
 i25 = i50 + 32 | 0;
 i26 = i48 + 12 | 0;
 i27 = i48 + 16 | 0;
 i28 = i48 + 4 | 0;
 i29 = i48 + 20 | 0;
 i30 = i48 + 8 | 0;
 i31 = i48 + 24 | 0;
 i32 = i48 + 28 | 0;
 i33 = i48 + 32 | 0;
 i34 = i50 + 12 | 0;
 i35 = i50 + 24 | 0;
 i36 = i52 + 4 | 0;
 i37 = i52 + 8 | 0;
 i39 = 0;
 do {
  HEAP32[i40 >> 2] = 0;
  i17 = i3 >>> 0 < 16 ? i3 : 16;
  if (i17) {
   i7 = (i3 ^ -16) >>> 0 > 4294967279;
   i6 = i17;
   i16 = i2;
   do {
    i6 = i6 + -1 | 0;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i16 + 4 | 0;
    __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i50, i52, i47, i15, 0, 0) | 0;
    f13 = Math_fround(HEAPF32[i18 >> 2]);
    f11 = Math_fround(HEAPF32[i50 >> 2]);
    f13 = Math_fround(f13 - f11);
    f9 = Math_fround(HEAPF32[i19 >> 2]);
    f14 = Math_fround(HEAPF32[i20 >> 2]);
    f9 = Math_fround(f9 - f14);
    f12 = Math_fround(HEAPF32[i21 >> 2]);
    f10 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(f12 - f10);
    f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
    f14 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
    f10 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f10);
    f8 = Math_fround(Math_fround(f9 * f10) - Math_fround(f12 * f14));
    f10 = Math_fround(Math_fround(f12 * f11) - Math_fround(f13 * f10));
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f9 * f11));
    f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10)))));
    if (f9 > Math_fround(0.0)) {
     f14 = Math_fround(Math_fround(1.0) / f9);
     f8 = Math_fround(f8 * f14);
     f10 = Math_fround(f10 * f14);
     f11 = Math_fround(f11 * f14);
    }
    i5 = 0;
    i1 = 0;
    do {
     i4 = HEAP32[i47 + (i5 << 2) >> 2] | 0;
     if ((i4 | 0) == -1) i1 = (1 << i5 + 3 | i1 & 255) & 255; else {
      __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i48, i51, 0, i4, 0, 0) | 0;
      f58 = Math_fround(HEAPF32[i26 >> 2]);
      f55 = Math_fround(HEAPF32[i48 >> 2]);
      f58 = Math_fround(f58 - f55);
      f56 = Math_fround(HEAPF32[i27 >> 2]);
      f54 = Math_fround(HEAPF32[i28 >> 2]);
      f56 = Math_fround(f56 - f54);
      f59 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(HEAPF32[i30 >> 2]);
      f59 = Math_fround(f59 - f12);
      f9 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f55);
      f57 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f54);
      f14 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f12);
      f13 = Math_fround(Math_fround(f56 * f14) - Math_fround(f59 * f57));
      f14 = Math_fround(Math_fround(f59 * f9) - Math_fround(f58 * f14));
      f9 = Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f9));
      i4 = HEAPU8[gb + 768833 + i5 >> 0] | 0;
      f55 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) >> 2]) - f55);
      f54 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 4 >> 2]) - f54);
      if (Math_fround(Math_fround(Math_fround(f13 * f55) + Math_fround(f14 * f54)) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 8 >> 2]) - f12))) < Math_fround(0.0)) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)))));
       if (f12 > Math_fround(0.0)) {
        f59 = Math_fround(Math_fround(1.0) / f12);
        f13 = Math_fround(f13 * f59);
        f12 = Math_fround(f14 * f59);
        f9 = Math_fround(f9 * f59);
       } else f12 = f14;
       if (Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f10 * f12) + Math_fround(f8 * f13))) < Math_fround(.996999979)) i1 = (1 << i5 + 3 | i1 & 255) & 255;
      }
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 3);
    i5 = HEAP32[i40 >> 2] | 0;
    HEAP32[i40 >> 2] = i5 + 1;
    i61 = i5 * 3 | 0;
    HEAP32[i49 + (i61 * 12 | 0) >> 2] = HEAP32[i50 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 4 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    i60 = i61 + 1 | 0;
    HEAP32[i49 + (i60 * 12 | 0) >> 2] = HEAP32[i34 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
    i4 = i61 + 2 | 0;
    HEAP32[i49 + (i4 * 12 | 0) >> 2] = HEAP32[i35 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i49 + 576 + (i61 << 2) >> 2] = HEAP32[i52 >> 2];
    HEAP32[i49 + 576 + (i60 << 2) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i49 + 576 + (i4 << 2) >> 2] = HEAP32[i37 >> 2];
    HEAP32[i49 + 768 + (i5 << 2) >> 2] = i15;
    HEAP8[i49 + 832 + i5 >> 0] = i1;
   } while ((i6 | 0) != 0);
   i2 = i2 + ((i7 ? i3 : 16) << 2) | 0;
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1) {
    i4 = i43;
    i5 = i44;
    i6 = i45;
    i7 = i49;
    while (1) {
     i1 = i1 + -1 | 0;
     __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i42, i7, HEAP32[i5 >> 2] | 0, HEAP8[i4 >> 0] | 0, i6) | 0;
     if (!i1) break; else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 4 | 0;
      i6 = i6 + 12 | 0;
      i7 = i7 + 36 | 0;
     }
    }
   }
  }
  i3 = i3 - i17 | 0;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) != (i41 | 0));
 STACKTOP = i53;
 return 1;
}

function __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMConvexVsHeightfieldContactGenerationCallbackEE7onEventEjPj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, i60 = 0, i61 = 0;
 i53 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i53 + 108 | 0;
 i52 = i53 + 60 | 0;
 i50 = i53 + 72 | 0;
 i47 = i53 + 12 | 0;
 i48 = i53 + 24 | 0;
 i51 = i53;
 i40 = i49 + 848 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = (i3 + 15 | 0) >>> 4;
 if (!i41) {
  STACKTOP = i53;
  return 1;
 }
 i42 = i1 + 16 | 0;
 i43 = i49 + 832 | 0;
 i44 = i49 + 768 | 0;
 i45 = i49 + 576 | 0;
 i46 = i1 + 4 | 0;
 i38 = i1 + 8 | 0;
 i18 = i50 + 12 | 0;
 i19 = i50 + 16 | 0;
 i20 = i50 + 4 | 0;
 i21 = i50 + 20 | 0;
 i22 = i50 + 8 | 0;
 i23 = i50 + 24 | 0;
 i24 = i50 + 28 | 0;
 i25 = i50 + 32 | 0;
 i26 = i48 + 12 | 0;
 i27 = i48 + 16 | 0;
 i28 = i48 + 4 | 0;
 i29 = i48 + 20 | 0;
 i30 = i48 + 8 | 0;
 i31 = i48 + 24 | 0;
 i32 = i48 + 28 | 0;
 i33 = i48 + 32 | 0;
 i34 = i50 + 12 | 0;
 i35 = i50 + 24 | 0;
 i36 = i52 + 4 | 0;
 i37 = i52 + 8 | 0;
 i39 = 0;
 do {
  HEAP32[i40 >> 2] = 0;
  i17 = i3 >>> 0 < 16 ? i3 : 16;
  if (i17) {
   i7 = (i3 ^ -16) >>> 0 > 4294967279;
   i6 = i17;
   i16 = i2;
   do {
    i6 = i6 + -1 | 0;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i16 + 4 | 0;
    __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i50, i52, i47, i15, 0, 0) | 0;
    f13 = Math_fround(HEAPF32[i18 >> 2]);
    f11 = Math_fround(HEAPF32[i50 >> 2]);
    f13 = Math_fround(f13 - f11);
    f9 = Math_fround(HEAPF32[i19 >> 2]);
    f14 = Math_fround(HEAPF32[i20 >> 2]);
    f9 = Math_fround(f9 - f14);
    f12 = Math_fround(HEAPF32[i21 >> 2]);
    f10 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(f12 - f10);
    f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
    f14 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
    f10 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f10);
    f8 = Math_fround(Math_fround(f9 * f10) - Math_fround(f12 * f14));
    f10 = Math_fround(Math_fround(f12 * f11) - Math_fround(f13 * f10));
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f9 * f11));
    f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10)))));
    if (f9 > Math_fround(0.0)) {
     f14 = Math_fround(Math_fround(1.0) / f9);
     f8 = Math_fround(f8 * f14);
     f10 = Math_fround(f10 * f14);
     f11 = Math_fround(f11 * f14);
    }
    i5 = 0;
    i1 = 0;
    do {
     i4 = HEAP32[i47 + (i5 << 2) >> 2] | 0;
     if ((i4 | 0) == -1) i1 = (1 << i5 + 3 | i1 & 255) & 255; else {
      __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i48, i51, 0, i4, 0, 0) | 0;
      f58 = Math_fround(HEAPF32[i26 >> 2]);
      f55 = Math_fround(HEAPF32[i48 >> 2]);
      f58 = Math_fround(f58 - f55);
      f56 = Math_fround(HEAPF32[i27 >> 2]);
      f54 = Math_fround(HEAPF32[i28 >> 2]);
      f56 = Math_fround(f56 - f54);
      f59 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(HEAPF32[i30 >> 2]);
      f59 = Math_fround(f59 - f12);
      f9 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f55);
      f57 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f54);
      f14 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f12);
      f13 = Math_fround(Math_fround(f56 * f14) - Math_fround(f59 * f57));
      f14 = Math_fround(Math_fround(f59 * f9) - Math_fround(f58 * f14));
      f9 = Math_fround(Math_fround(f58 * f57) - Math_fround(f56 * f9));
      i4 = HEAPU8[gb + 768833 + i5 >> 0] | 0;
      f55 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) >> 2]) - f55);
      f54 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 4 >> 2]) - f54);
      if (Math_fround(Math_fround(Math_fround(f13 * f55) + Math_fround(f14 * f54)) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 8 >> 2]) - f12))) < Math_fround(0.0)) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)))));
       if (f12 > Math_fround(0.0)) {
        f59 = Math_fround(Math_fround(1.0) / f12);
        f13 = Math_fround(f13 * f59);
        f12 = Math_fround(f14 * f59);
        f9 = Math_fround(f9 * f59);
       } else f12 = f14;
       if (Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f10 * f12) + Math_fround(f8 * f13))) < Math_fround(.996999979)) i1 = (1 << i5 + 3 | i1 & 255) & 255;
      }
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 3);
    i5 = HEAP32[i40 >> 2] | 0;
    HEAP32[i40 >> 2] = i5 + 1;
    i61 = i5 * 3 | 0;
    HEAP32[i49 + (i61 * 12 | 0) >> 2] = HEAP32[i50 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 4 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i49 + (i61 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    i60 = i61 + 1 | 0;
    HEAP32[i49 + (i60 * 12 | 0) >> 2] = HEAP32[i34 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
    i4 = i61 + 2 | 0;
    HEAP32[i49 + (i4 * 12 | 0) >> 2] = HEAP32[i35 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i49 + 576 + (i61 << 2) >> 2] = HEAP32[i52 >> 2];
    HEAP32[i49 + 576 + (i60 << 2) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i49 + 576 + (i4 << 2) >> 2] = HEAP32[i37 >> 2];
    HEAP32[i49 + 768 + (i5 << 2) >> 2] = i15;
    HEAP8[i49 + 832 + i5 >> 0] = i1;
   } while ((i6 | 0) != 0);
   i2 = i2 + ((i7 ? i3 : 16) << 2) | 0;
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1) {
    i4 = i43;
    i5 = i44;
    i6 = i45;
    i7 = i49;
    while (1) {
     i1 = i1 + -1 | 0;
     __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i42, i7, HEAP32[i5 >> 2] | 0, HEAP8[i4 >> 0] | 0, i6) | 0;
     if (!i1) break; else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 4 | 0;
      i6 = i6 + 12 | 0;
      i7 = i7 + 36 | 0;
     }
    }
   }
  }
  i3 = i3 - i17 | 0;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) != (i41 | 0));
 STACKTOP = i53;
 return 1;
}

function __ZN5Umbra15StartCellFinder23findStartCellsForObjectENS_12PortalCuller4TileERKNS_10MappedTileE(i25, i26, i1) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33;
 i29 = HEAP32[i25 >> 2] | 0;
 i32 = i1 + 28 | 0;
 i2 = HEAP32[i32 >> 2] | 0;
 i28 = HEAP32[i2 + 56 >> 2] | 0;
 i30 = HEAP32[i2 + 52 >> 2] & 65535;
 HEAP32[i29 + 2856 >> 2] = i30;
 HEAP32[i29 + 2828 >> 2] = (i28 | 0) == 0 ? 0 : i2 + i28 | 0;
 if (!i30) {
  i32 = 0;
  STACKTOP = i33;
  return i32 | 0;
 }
 i27 = i25 + 4 | 0;
 i22 = i31 + 4 | 0;
 i24 = i31 + 8 | 0;
 i20 = i31 + 12 | 0;
 i21 = i31 + 16 | 0;
 i23 = i31 + 20 | 0;
 i28 = i1 + 8 | 0;
 i29 = i1 + 4 | 0;
 i30 = i25 + 8 | 0;
 i19 = i1 + 12 | 0;
 i1 = 0;
 i18 = 0;
 do {
  i16 = HEAP32[i25 >> 2] | 0;
  i16 = (HEAP32[i16 + 2828 >> 2] | 0) + (Math_imul(HEAP32[i16 + 2844 >> 2] | 0, i18) | 0) | 0;
  i3 = HEAP32[i16 + 8 >> 2] | 0;
  i17 = HEAP32[i16 + 12 >> 2] | 0;
  i14 = HEAP32[i16 + 24 >> 2] | 0;
  i15 = HEAP32[i16 + 28 >> 2] | 0;
  i16 = HEAP32[i16 + 32 >> 2] | 0;
  f44 = Math_fround(HEAPF32[i2 >> 2]);
  f42 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f45 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f43 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f41 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  f39 = Math_fround(i14 >>> 16 | 0);
  f38 = Math_fround(i14 & 65535 | 0);
  f37 = Math_fround(i15 >>> 16 | 0);
  f36 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
  f39 = Math_fround(f39 * f36);
  f35 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
  f38 = Math_fround(f38 * f35);
  f34 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
  f37 = Math_fround(f37 * f34);
  f36 = Math_fround(Math_fround(i15 & 65535 | 0) * f36);
  f35 = Math_fround(Math_fround(i16 >>> 16 | 0) * f35);
  f34 = Math_fround(Math_fround(i16 & 65535 | 0) * f34);
  f39 = Math_fround(Math_fround(f45 * f39) + Math_fround(f44 * Math_fround(Math_fround(1.0) - f39)));
  f36 = Math_fround(Math_fround(f45 * f36) + Math_fround(f44 * Math_fround(Math_fround(1.0) - f36)));
  f38 = Math_fround(Math_fround(f43 * f38) + Math_fround(f42 * Math_fround(Math_fround(1.0) - f38)));
  f35 = Math_fround(Math_fround(f43 * f35) + Math_fround(f42 * Math_fround(Math_fround(1.0) - f35)));
  f37 = Math_fround(Math_fround(f41 * f37) + Math_fround(f40 * Math_fround(Math_fround(1.0) - f37)));
  f34 = Math_fround(Math_fround(f41 * f34) + Math_fround(f40 * Math_fround(Math_fround(1.0) - f34)));
  i16 = HEAP32[i27 >> 2] | 0;
  HEAPF32[i31 >> 2] = f39;
  HEAPF32[i22 >> 2] = f38;
  HEAPF32[i24 >> 2] = f37;
  HEAPF32[i20 >> 2] = f36;
  HEAPF32[i21 >> 2] = f35;
  HEAPF32[i23 >> 2] = f34;
  L6 : do if (__ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE(i16, i31) | 0) {
   i4 = HEAP32[i25 >> 2] | 0;
   i5 = HEAP32[i28 >> 2] | 0;
   i7 = HEAP32[i5 + 84 >> 2] | 0;
   i6 = i7 & 31;
   i7 = i7 >>> 5 & 31;
   i8 = i7 + i6 | 0;
   i2 = Math_imul(i8, i3) | 0;
   i3 = ((Math_imul(i8, HEAP32[i5 + 92 >> 2] | 0) | 0) + 31 >> 5 << 5) - i2 | 0;
   if (i3 | 0) {
    HEAP32[i4 + 2900 >> 2] = i5 + (HEAP32[i5 + 88 >> 2] | 0);
    HEAP32[i4 + 2904 >> 2] = i3;
    HEAP32[i4 + 2908 >> 2] = i2;
   }
   HEAP8[i4 + 2932 >> 0] = i8 >>> 0 > 31 & 1;
   HEAP32[i4 + 2912 >> 2] = i6;
   HEAP32[i4 + 2916 >> 2] = i7;
   HEAP32[i4 + 2920 >> 2] = i17;
   HEAP32[i4 + 2928 >> 2] = 0;
   if ((i17 | 0) > 0) {
    i16 = 0;
    while (1) {
     i14 = HEAP32[i25 >> 2] | 0;
     i2 = i14 + 2900 | 0;
     i15 = i14 + 2928 | 0;
     i3 = HEAP32[i15 >> 2] | 0;
     do if (!i3) {
      i7 = HEAP32[i14 + 2912 >> 2] | 0;
      if (!(HEAP8[i14 + 2932 >> 0] | 0)) {
       i4 = (HEAP32[i14 + 2916 >> 2] | 0) + i7 | 0;
       i11 = HEAP32[i2 >> 2] | 0;
       i2 = i14 + 2908 | 0;
       i13 = HEAP32[i2 >> 2] | 0;
       i12 = i13 >> 5;
       i3 = i13 & 31;
       i3 = (HEAP32[i11 + (i12 + 1 << 2) >> 2] << 32 - i3 & -1 << (i3 ^ 31) | (HEAP32[i11 + (i12 << 2) >> 2] | 0) >>> i3) & (1 << i4) + -1;
       HEAP32[i2 >> 2] = i13 + i4;
       i2 = i14 + 2904 | 0;
       HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i4;
       i2 = i3 & (1 << i7) + -1;
       i4 = i14 + 2924 | 0;
       HEAP32[i4 >> 2] = i2;
       i3 = i3 >>> i7;
       HEAP32[i15 >> 2] = i3;
       break;
      }
      i12 = HEAP32[i2 >> 2] | 0;
      i13 = i14 + 2908 | 0;
      i6 = HEAP32[i13 >> 2] | 0;
      i5 = i6 >> 5;
      i2 = i6 & 31;
      i3 = (HEAP32[i12 + (i5 << 2) >> 2] | 0) >>> i2;
      i4 = 32 - i2 | 0;
      i5 = HEAP32[i12 + (i5 + 1 << 2) >> 2] << i4;
      if ((i7 | 0) < 32) i2 = (i5 & -1 << (i2 ^ 31) | i3) & (1 << i7) + -1; else i2 = -1 << i4 & 0 - i2 >> 31 & i5 | i3;
      i10 = i6 + i7 | 0;
      HEAP32[i13 >> 2] = i10;
      i11 = i14 + 2904 | 0;
      i8 = (HEAP32[i11 >> 2] | 0) - i7 | 0;
      HEAP32[i11 >> 2] = i8;
      i4 = i14 + 2924 | 0;
      HEAP32[i4 >> 2] = i2;
      i9 = HEAP32[i14 + 2916 >> 2] | 0;
      i3 = i10 >> 5;
      i5 = i10 & 31;
      i6 = (HEAP32[i12 + (i3 << 2) >> 2] | 0) >>> i5;
      i7 = 32 - i5 | 0;
      i3 = HEAP32[i12 + (i3 + 1 << 2) >> 2] << i7;
      if ((i9 | 0) < 32) i3 = (i3 & -1 << (i5 ^ 31) | i6) & (1 << i9) + -1; else i3 = -1 << i7 & 0 - i5 >> 31 & i3 | i6;
      HEAP32[i13 >> 2] = i9 + i10;
      HEAP32[i11 >> 2] = i8 - i9;
      HEAP32[i15 >> 2] = i3;
     } else {
      i2 = i14 + 2924 | 0;
      i4 = i2;
      i2 = HEAP32[i2 >> 2] | 0;
     } while (0);
     i14 = i14 + 2920 | 0;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
     HEAP32[i15 >> 2] = i3 + -1;
     HEAP32[i4 >> 2] = i2 + 1;
     i3 = HEAP32[i29 >> 2] | 0;
     if (i3) i2 = HEAP32[(HEAP32[i19 >> 2] | 0) + (HEAP32[i3 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     i16 = i16 + 1 | 0;
     if ((i2 | 0) == (HEAP32[i30 >> 2] | 0)) break;
     if ((i16 | 0) >= (i17 | 0)) break L6;
    }
    __ZN5Umbra12PortalCuller12addStartCellERKNS0_4TileEi(HEAP32[i25 >> 2] | 0, i26, i18);
    i1 = HEAP32[HEAP32[i25 >> 2] >> 2] | 0;
    if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0)) i1 = 1; else if (!(HEAP32[i1 + 32 >> 2] & 16)) i1 = 1; else {
     __ZN5Umbra12QueryContext13visualizeCellEPKNS_7ImpTileEi(i1, HEAP32[i32 >> 2] | 0, i18);
     i1 = 1;
    }
   }
  } while (0);
  i18 = i18 + 1 | 0;
  i2 = HEAP32[i32 >> 2] | 0;
 } while ((i18 | 0) < (HEAP32[i2 + 52 >> 2] & 65535 | 0));
 STACKTOP = i33;
 return i1 | 0;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i8, i17, i9, i10, i11) {
 i8 = i8 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 32 | 0;
 i14 = i20 + 24 | 0;
 i15 = i20;
 i18 = i20 + 8 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i8 + 8 >> 2] | 0;
 if (!i10) {
  i2 = i13 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i16, HEAP32[i13 + 224 >> 2] | 0) | 0) {
   i12 = __Z20scripting_object_newP11Il2CppClass(i16) | 0;
   i7 = i15;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i14, i12, i19);
   if (HEAP32[i14 >> 2] | 0) {
    i2 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i19 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i14 + 4 >> 0] | 0;
    i2 = i17 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i17 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 4371;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i16) | 0;
 if (i1 | 0) if ((HEAP32[i13 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i13 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i13 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i19 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i19, i17, i9, 1, 0);
 }
 HEAP32[i18 >> 2] = 0;
 i12 = i18 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i16, i18);
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i12 >> 2] | 0)) {
  i2 = i19 + 24 | 0;
  i3 = i19 + 25 | 0;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   HEAP8[i2 >> 0] = 0;
   HEAP8[i3 >> 0] = 0;
   if (__Z41InitializeTransferFieldFromScriptingFieldR18TransferField_InfoPKS_P9FieldInfoP11Il2CppClassRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsRK20CoreScriptingClasses(i19, i11, i7, i16, i8, i17, i9, i13) | 0) __Z33EmitSerializationCommandsForFieldI9JSONWriteEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i19, i17, i9);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i12 >> 2] | 0));
 }
 if (!i10) {
  i2 = i13 + 228 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i16, HEAP32[i13 + 224 >> 2] | 0) | 0) {
   i16 = __Z20scripting_object_newP11Il2CppClass(i16) | 0;
   i13 = i15;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i14, i16, i19);
   if (HEAP32[i14 >> 2] | 0) {
    i2 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i19 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i14 + 4 >> 0] | 0;
    i2 = i17 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i17 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 4371;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i18 = HEAP32[i18 + 12 >> 2] | 0;
 HEAP32[i19 >> 2] = 1;
 HEAP32[i19 + 4 >> 2] = i18;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
 STACKTOP = i20;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE(i36, i2) {
 i36 = i36 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i40 + 24 | 0;
 i11 = i40 + 23 | 0;
 i12 = i40 + 22 | 0;
 i13 = i40 + 21 | 0;
 i14 = i40 + 20 | 0;
 i15 = i40 + 19 | 0;
 i16 = i40 + 18 | 0;
 i17 = i40 + 17 | 0;
 i18 = i40 + 16 | 0;
 i19 = i40 + 15 | 0;
 i20 = i40 + 14 | 0;
 i21 = i40 + 13 | 0;
 i22 = i40 + 12 | 0;
 i23 = i40 + 11 | 0;
 i24 = i40 + 10 | 0;
 i25 = i40 + 9 | 0;
 i26 = i40 + 8 | 0;
 i27 = i40 + 7 | 0;
 i28 = i40 + 6 | 0;
 i29 = i40 + 5 | 0;
 i30 = i40 + 4 | 0;
 i31 = i40 + 3 | 0;
 i32 = i40 + 2 | 0;
 i33 = i40 + 1 | 0;
 i34 = i40;
 HEAP32[i36 + 76 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i37 = i36 + 80 | 0;
 HEAP32[i37 >> 2] = i1;
 i38 = i36 + 92 | 0;
 HEAP32[i38 >> 2] = HEAP32[i2 + 8 >> 2];
 i39 = i36 + 96 | 0;
 HEAP32[i39 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i36 + 84 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i36 + 88 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i36 + 100 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i36 + 104 >> 2] = HEAP32[i2 + 28 >> 2];
 i9 = HEAP32[i2 + 32 >> 2] | 0;
 i35 = i36 + 108 | 0;
 i2 = HEAP32[i35 >> 2] | 0;
 if (i9 >>> 0 > i2 >>> 0) {
  i5 = (i9 << 3) + 15 & -16;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i40 + 27 | 0, i5, gb + 716671 | 0, 932) | 0;
  i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i40 + 26 | 0, i5, gb + 716671 | 0, 933) | 0;
  i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i40 + 25 | 0, i5, gb + 716671 | 0, 934) | 0;
  i6 = i36 + 112 | 0;
  i1 = i2 << 3;
  _memcpy(i3 | 0, HEAP32[i6 >> 2] | 0, i1 | 0) | 0;
  i7 = i36 + 116 | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, i1 | 0) | 0;
  i8 = i36 + 120 | 0;
  _memcpy(i5 | 0, HEAP32[i8 >> 2] | 0, i1 | 0) | 0;
  i1 = i2;
  do {
   HEAP32[i3 + (i1 << 3) >> 2] = 1073741823;
   HEAP32[i3 + (i1 << 3) + 4 >> 2] = 1073741823;
   HEAP32[i4 + (i1 << 3) >> 2] = 1073741823;
   HEAP32[i4 + (i1 << 3) + 4 >> 2] = 1073741823;
   HEAP32[i5 + (i1 << 3) >> 2] = 1073741823;
   HEAP32[i5 + (i1 << 3) + 4 >> 2] = 1073741823;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i6 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i7 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i8 >> 2] | 0);
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i35 >> 2] = i9;
  i1 = i36 + 148 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, i9 + 15 & -16, gb + 716671 | 0, 960) | 0;
  i1 = HEAP32[i37 >> 2] | 0;
 }
 i14 = i36 + 168 | 0;
 i10 = i1 + (HEAP32[i14 >> 2] | 0) << 1;
 i11 = i10 + 2 | 0;
 i12 = i36 + 176 | 0;
 if (i11 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  i13 = (i11 << 2) + 15 & -16;
  i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i15, i13, gb + 716671 | 0, 969) | 0;
  i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, i13, gb + 716671 | 0, 970) | 0;
  i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13, gb + 716671 | 0, 971) | 0;
  i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, i13, gb + 716671 | 0, 972) | 0;
  i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, i13, gb + 716671 | 0, 973) | 0;
  i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i20, i13, gb + 716671 | 0, 974) | 0;
  i1 = i36 + 160 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, HEAP32[i1 >> 2] | 0);
  i21 = i36 + 164 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, HEAP32[i21 >> 2] | 0);
  HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i23, i13, gb + 716671 | 0, 980) | 0;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i24, i13, gb + 716671 | 0, 981) | 0;
  HEAP32[i21 >> 2] = i2;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i10 | 0) != -2) {
   i3 = 1;
   do {
    i24 = i3 + -1 | 0;
    HEAP32[i1 + (i24 << 2) >> 2] = i3;
    HEAP32[i2 + (i3 << 2) >> 2] = i24;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i11 >>> 0);
  }
  i19 = i10 | 1;
  HEAP32[i1 + (i19 << 2) >> 2] = i19;
  HEAP32[i2 >> 2] = 0;
  i19 = i36 + 124 | 0;
  _memcpy(i9 | 0, HEAP32[i19 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  i20 = i36 + 128 | 0;
  _memcpy(i8 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  i21 = i36 + 132 | 0;
  _memcpy(i7 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  i22 = i36 + 136 | 0;
  _memcpy(i6 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  i23 = i36 + 140 | 0;
  _memcpy(i5 | 0, HEAP32[i23 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  i24 = i36 + 144 | 0;
  _memcpy(i4 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i14 >> 2] << 3) + 8 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, HEAP32[i19 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i26, HEAP32[i20 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i27, HEAP32[i21 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i28, HEAP32[i22 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i29, HEAP32[i23 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, HEAP32[i24 >> 2] | 0);
  HEAP32[i19 >> 2] = i9;
  HEAP32[i20 >> 2] = i8;
  HEAP32[i21 >> 2] = i7;
  HEAP32[i22 >> 2] = i6;
  HEAP32[i23 >> 2] = i5;
  HEAP32[i24 >> 2] = i4;
  HEAP32[i12 >> 2] = i11;
  i30 = i36 + 152 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i31, HEAP32[i30 >> 2] | 0);
  i31 = i36 + 156 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, HEAP32[i31 >> 2] | 0);
  HEAP32[i30 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i33, i13, gb + 716671 | 0, 1016) | 0;
  HEAP32[i31 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i34, i11 << 3, gb + 716671 | 0, 1017) | 0;
 }
 i2 = i36 + 148 | 0;
 _memset(HEAP32[i2 >> 2] | 0, 0, HEAP32[i35 >> 2] | 0) | 0;
 if (!(HEAP32[i39 >> 2] | 0)) {
  i39 = HEAP32[i37 >> 2] | 0;
  i38 = HEAP32[i14 >> 2] | 0;
  i39 = i38 + i39 | 0;
  HEAP32[i14 >> 2] = i39;
  STACKTOP = i40;
  return 1;
 } else i1 = 0;
 do {
  HEAP8[(HEAP32[i2 >> 2] | 0) + (HEAP32[(HEAP32[i38 >> 2] | 0) + (i1 << 2) >> 2] | 0) >> 0] = 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i39 >> 2] | 0) >>> 0);
 i39 = HEAP32[i37 >> 2] | 0;
 i38 = HEAP32[i14 >> 2] | 0;
 i39 = i38 + i39 | 0;
 HEAP32[i14 >> 2] = i39;
 STACKTOP = i40;
 return 1;
}

function __ZN11ShapeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 36 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 44 | 0, i6);
 __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 48 | 0, i6);
 __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 52 | 0, i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 }
 HEAP32[i8 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 60 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 64 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 213 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 214 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 212 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i8 + 204 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i8 + 208 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i8, i17, i9, i10, i11) {
 i8 = i8 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 32 | 0;
 i14 = i20 + 24 | 0;
 i15 = i20;
 i18 = i20 + 8 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i8 + 8 >> 2] | 0;
 if (!i10) {
  i2 = i13 + 236 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i16, HEAP32[i13 + 224 >> 2] | 0) | 0) {
   i12 = __Z20scripting_object_newP11Il2CppClass(i16) | 0;
   i7 = i15;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i14, i12, i19);
   if (HEAP32[i14 >> 2] | 0) {
    i2 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i19 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i14 + 4 >> 0] | 0;
    i2 = i17 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i17 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 4315;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 1;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 0;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = __Z26scripting_class_get_parentP11Il2CppClass(i16) | 0;
 if (i1 | 0) if ((HEAP32[i13 + 264 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i13 + 356 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i13 + 268 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i19 >> 2] = i1;
  __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i19, i17, i9, 1, 0);
 }
 HEAP32[i18 >> 2] = 0;
 i12 = i18 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i16, i18);
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i12 >> 2] | 0)) {
  i2 = i19 + 24 | 0;
  i3 = i19 + 25 | 0;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   HEAP8[i2 >> 0] = 0;
   HEAP8[i3 >> 0] = 0;
   if (__Z41InitializeTransferFieldFromScriptingFieldR18TransferField_InfoPKS_P9FieldInfoP11Il2CppClassRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsRK20CoreScriptingClasses(i19, i11, i7, i16, i8, i17, i9, i13) | 0) __Z33EmitSerializationCommandsForFieldI8JSONReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i19, i17, i9);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i12 >> 2] | 0));
 }
 if (!i10) {
  i2 = i13 + 228 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i16, HEAP32[i13 + 224 >> 2] | 0) | 0) {
   i16 = __Z20scripting_object_newP11Il2CppClass(i16) | 0;
   i13 = i15;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 4 >> 2] = i2;
   HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i14, i16, i19);
   if (HEAP32[i14 >> 2] | 0) {
    i2 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = 0;
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = i19 + 48 | 0;
    HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
    HEAP8[i2 + 4 >> 0] = HEAP8[i14 + 4 >> 0] | 0;
    i2 = i17 + 12 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = i7 + 1 | 0;
    i4 = i17 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i3 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i16 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i17 >> 2] = i16;
      break;
     }
    } while (0);
    HEAP32[i2 >> 2] = i3;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i1 + (i7 << 6) >> 2] = fb + 4315;
    i2 = i1 + (i7 << 6) + 4 | 0;
    i3 = i19;
    i4 = i2 + 56 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    HEAP8[i1 + (i7 << 6) + 60 >> 0] = 0;
    HEAP8[i1 + (i7 << 6) + 61 >> 0] = 1;
    HEAP16[i1 + (i7 << 6) + 62 >> 1] = 0;
   }
  }
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i18 = HEAP32[i18 + 12 >> 2] | 0;
 HEAP32[i19 >> 2] = 1;
 HEAP32[i19 + 4 >> 2] = i18;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
 STACKTOP = i20;
 return;
}

function __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i17, i2, i1) {
 i17 = i17 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f12 = Math_fround(f5 + f5);
 f13 = Math_fround(f6 + f6);
 f4 = Math_fround(f33 + f33);
 f9 = Math_fround(f6 * f13);
 f29 = Math_fround(f33 * f4);
 f6 = Math_fround(f12 * f6);
 f8 = Math_fround(f12 * f33);
 f11 = Math_fround(f12 * f30);
 f33 = Math_fround(f13 * f33);
 f13 = Math_fround(f13 * f30);
 f30 = Math_fround(f4 * f30);
 f4 = Math_fround(Math_fround(Math_fround(1.0) - f9) - f29);
 f3 = Math_fround(f6 + f30);
 f16 = Math_fround(f8 - f13);
 f30 = Math_fround(f6 - f30);
 f12 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f12));
 f29 = Math_fround(f12 - f29);
 f5 = Math_fround(f33 + f11);
 f13 = Math_fround(f8 + f13);
 f11 = Math_fround(f33 - f11);
 f9 = Math_fround(f12 - f9);
 HEAPF32[i17 >> 2] = f4;
 i24 = i17 + 4 | 0;
 HEAPF32[i24 >> 2] = f30;
 i23 = i17 + 8 | 0;
 HEAPF32[i23 >> 2] = f13;
 i22 = i17 + 12 | 0;
 HEAPF32[i22 >> 2] = f3;
 i21 = i17 + 16 | 0;
 HEAPF32[i21 >> 2] = f29;
 i20 = i17 + 20 | 0;
 HEAPF32[i20 >> 2] = f11;
 i19 = i17 + 24 | 0;
 HEAPF32[i19 >> 2] = f16;
 i18 = i17 + 28 | 0;
 HEAPF32[i18 >> 2] = f5;
 i1 = i17 + 32 | 0;
 HEAPF32[i1 >> 2] = f9;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f33 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f3 * Math_fround(0.0));
 f7 = Math_fround(f29 * Math_fround(0.0));
 f14 = Math_fround(f11 * Math_fround(0.0));
 f27 = Math_fround(f16 * Math_fround(0.0));
 f25 = Math_fround(f5 * Math_fround(0.0));
 f10 = Math_fround(f9 * Math_fround(0.0));
 f28 = Math_fround(Math_fround(Math_fround(f12 * f4) + f6) + f27);
 f26 = Math_fround(Math_fround(Math_fround(f12 * f30) + f7) + f25);
 f12 = Math_fround(Math_fround(Math_fround(f12 * f13) + f14) + f10);
 f32 = Math_fround(f4 * Math_fround(0.0));
 f31 = Math_fround(f30 * Math_fround(0.0));
 f15 = Math_fround(f13 * Math_fround(0.0));
 f27 = Math_fround(Math_fround(f32 + Math_fround(f33 * f3)) + f27);
 f25 = Math_fround(Math_fround(f31 + Math_fround(f33 * f29)) + f25);
 f10 = Math_fround(Math_fround(f15 + Math_fround(f33 * f11)) + f10);
 f6 = Math_fround(Math_fround(f32 + f6) + Math_fround(f8 * f16));
 f7 = Math_fround(Math_fround(f31 + f7) + Math_fround(f8 * f5));
 f8 = Math_fround(Math_fround(f15 + f14) + Math_fround(f8 * f9));
 f14 = Math_fround(Math_fround(Math_fround(f4 * f28) + Math_fround(f3 * f27)) + Math_fround(f16 * f6));
 f15 = Math_fround(Math_fround(Math_fround(f4 * f26) + Math_fround(f3 * f25)) + Math_fround(f16 * f7));
 f16 = Math_fround(Math_fround(Math_fround(f4 * f12) + Math_fround(f3 * f10)) + Math_fround(f16 * f8));
 f3 = Math_fround(Math_fround(Math_fround(f30 * f28) + Math_fround(f29 * f27)) + Math_fround(f5 * f6));
 f4 = Math_fround(Math_fround(Math_fround(f30 * f26) + Math_fround(f29 * f25)) + Math_fround(f5 * f7));
 f5 = Math_fround(Math_fround(Math_fround(f30 * f12) + Math_fround(f29 * f10)) + Math_fround(f5 * f8));
 f6 = Math_fround(Math_fround(Math_fround(f13 * f28) + Math_fround(f11 * f27)) + Math_fround(f9 * f6));
 f7 = Math_fround(Math_fround(Math_fround(f13 * f26) + Math_fround(f11 * f25)) + Math_fround(f9 * f7));
 f8 = Math_fround(Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * f10)) + Math_fround(f9 * f8));
 HEAPF32[i17 >> 2] = f14;
 HEAPF32[i24 >> 2] = f15;
 HEAPF32[i23 >> 2] = f16;
 HEAPF32[i22 >> 2] = f3;
 HEAPF32[i21 >> 2] = f4;
 HEAPF32[i20 >> 2] = f5;
 HEAPF32[i19 >> 2] = f6;
 HEAPF32[i18 >> 2] = f7;
 HEAPF32[i1 >> 2] = f8;
 i1 = i17 + 36 | 0;
 f9 = Math_fround(Math_fround(f4 * f8) - Math_fround(f5 * f7));
 f10 = Math_fround(f5 * f6);
 f11 = Math_fround(f8 * f3);
 f12 = Math_fround(Math_fround(f7 * f3) - Math_fround(f4 * f6));
 f13 = Math_fround(Math_fround(Math_fround(f9 * f14) + Math_fround(f15 * Math_fround(f10 - f11))) + Math_fround(f12 * f16));
 if (!(f13 != Math_fround(0.0))) {
  i23 = 1065353216;
  i22 = 0;
  i21 = 0;
  i24 = 1065353216;
  i34 = 0;
  i2 = 0;
  i18 = 0;
  i19 = 1065353216;
  i20 = 0;
  HEAP32[i1 >> 2] = i24;
  i24 = i17 + 40 | 0;
  HEAP32[i24 >> 2] = i34;
  i24 = i17 + 44 | 0;
  HEAP32[i24 >> 2] = i2;
  i24 = i17 + 48 | 0;
  HEAP32[i24 >> 2] = i18;
  i24 = i17 + 52 | 0;
  HEAP32[i24 >> 2] = i19;
  i24 = i17 + 56 | 0;
  HEAP32[i24 >> 2] = i20;
  i24 = i17 + 60 | 0;
  HEAP32[i24 >> 2] = i21;
  i24 = i17 + 64 | 0;
  HEAP32[i24 >> 2] = i22;
  i24 = i17 + 68 | 0;
  HEAP32[i24 >> 2] = i23;
  return;
 }
 f33 = Math_fround(Math_fround(1.0) / f13);
 f25 = Math_fround(f9 * f33);
 f26 = Math_fround(-Math_fround(Math_fround(Math_fround(f8 * f15) - Math_fround(f7 * f16)) * f33));
 f27 = Math_fround(Math_fround(Math_fround(f5 * f15) - Math_fround(f4 * f16)) * f33);
 f28 = Math_fround(-Math_fround(Math_fround(f11 - f10) * f33));
 f29 = Math_fround(Math_fround(Math_fround(f8 * f14) - Math_fround(f6 * f16)) * f33);
 f30 = Math_fround(-Math_fround(Math_fround(Math_fround(f5 * f14) - Math_fround(f3 * f16)) * f33));
 f31 = Math_fround(f12 * f33);
 f32 = Math_fround(-Math_fround(Math_fround(Math_fround(f7 * f14) - Math_fround(f6 * f15)) * f33));
 f33 = Math_fround(Math_fround(Math_fround(f4 * f14) - Math_fround(f3 * f15)) * f33);
 i34 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i20 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
 i23 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
 i24 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i1 >> 2] = i34;
 i34 = i17 + 40 | 0;
 HEAP32[i34 >> 2] = i2;
 i34 = i17 + 44 | 0;
 HEAP32[i34 >> 2] = i18;
 i34 = i17 + 48 | 0;
 HEAP32[i34 >> 2] = i19;
 i34 = i17 + 52 | 0;
 HEAP32[i34 >> 2] = i20;
 i34 = i17 + 56 | 0;
 HEAP32[i34 >> 2] = i21;
 i34 = i17 + 60 | 0;
 HEAP32[i34 >> 2] = i22;
 i34 = i17 + 64 | 0;
 HEAP32[i34 >> 2] = i23;
 i34 = i17 + 68 | 0;
 HEAP32[i34 >> 2] = i24;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i16, i11, i1) {
 i16 = i16 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17;
 i15 = i17 + 28 | 0;
 i13 = i17 + 12 | 0;
 i5 = i17 + 24 | 0;
 HEAP32[i5 >> 2] = 435;
 i9 = HEAP32[i16 + 20 >> 2] | 0;
 i9 = (i9 | 0) == 0 ? i5 : i9;
 i5 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i16 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i16 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i14;
  i10 = HEAP32[i8 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 i5 = HEAP32[i11 + 8 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i16 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i16 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i14;
  i10 = HEAP32[i8 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 i7 = i16 + 8 | 0;
 i8 = i11 + 20 | 0;
 mftCall_viii(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14 | 0, i15 | 0);
 i3 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i12 = i16 + 4 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i10 = i16 + 12 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i4;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i6, i13) | 0;
 HEAP8[i14 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i14 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i14;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i12 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i16 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i14;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i12 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i16 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i16 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i14;
   } else {
    i3 = i5;
    i4 = i14;
   }
  }
 }
 HEAP32[i14 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i14;
  i9 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 mftCall_viii(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14 | 0, i15 | 0);
 i4 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = HEAP32[i15 + 8 >> 2] | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i4;
 HEAP32[i13 + 8 >> 2] = i5;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i3, i13) | 0;
 HEAP8[i14 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i14 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i1 | 0, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i17;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i16 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5Light10SetupFlareEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i3 = i11;
 i4 = i10 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  i9 = i10 + 28 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0) | 0) {
   i8 = i10 + 44 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i2 + 40 >> 2] | 0) == 1) {
    i7 = 1;
    i4 = i2 + 248 | 0;
    i3 = i2 + 252 | 0;
    i2 = i2 + 256 | 0;
   } else {
    i7 = 0;
    i4 = i2 + 264 | 0;
    i3 = i2 + 268 | 0;
    i2 = i2 + 272 | 0;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
   i3 = i10 + 60 | 0;
   if ((HEAP32[i3 >> 2] | 0) == -1) {
    i2 = HEAP32[gb + 1110296 >> 2] | 0;
    do if (!i2) {
     i2 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
     if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
      i2 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i2, gb + 1041912 | 0, 65) | 0;
      i10 = i2 + 4 | 0;
      HEAP32[i10 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 >> 2] = i10;
      i10 = i2 + 12 | 0;
      HEAP32[i10 >> 2] = 0;
      HEAP32[i10 + 4 >> 2] = 0;
      HEAP32[i10 + 8 >> 2] = 0;
      HEAP32[i10 + 12 >> 2] = 0;
      HEAP32[gb + 1110296 >> 2] = i2;
      break;
     } else {
      i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i2, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
      i10 = i2 + 4 | 0;
      HEAP32[i10 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 >> 2] = i10;
      i10 = i2 + 12 | 0;
      HEAP32[i10 >> 2] = 0;
      HEAP32[i10 + 4 >> 2] = 0;
      HEAP32[i10 + 8 >> 2] = 0;
      HEAP32[i10 + 12 >> 2] = 0;
      __Z19pop_allocation_rootv();
      HEAP32[gb + 1110296 >> 2] = i2;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = __ZN12FlareManager8AddFlareEv(i2) | 0;
   }
   i2 = HEAP32[gb + 1110296 >> 2] | 0;
   do if (!i2) {
    i2 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
    if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
     i2 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i2, gb + 1041912 | 0, 65) | 0;
     i10 = i2 + 4 | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = 0;
     HEAP32[i2 >> 2] = i10;
     i10 = i2 + 12 | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     HEAP32[i10 + 8 >> 2] = 0;
     HEAP32[i10 + 12 >> 2] = 0;
     HEAP32[gb + 1110296 >> 2] = i2;
     break;
    } else {
     i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i2, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
     i10 = i2 + 4 | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = 0;
     HEAP32[i2 >> 2] = i10;
     i10 = i2 + 12 | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     HEAP32[i10 + 8 >> 2] = 0;
     HEAP32[i10 + 12 >> 2] = 0;
     __Z19pop_allocation_rootv();
     HEAP32[gb + 1110296 >> 2] = i2;
     break;
    }
   } while (0);
   i10 = HEAP32[i3 >> 2] | 0;
   i16 = HEAP32[(__Z17GetRenderSettingsv() | 0) + 304 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f15 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 20 >> 2]));
   f14 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 24 >> 2]));
   f13 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 28 >> 2]));
   f12 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 32 >> 2]));
   i3 = HEAP32[(__Z17GetRenderSettingsv() | 0) + 308 >> 2] | 0;
   i8 = 1 << HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2];
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i9 + (i10 * 52 | 0) + 16 >> 2] = i4;
   HEAP32[i9 + (i10 * 52 | 0) + 20 >> 2] = i5;
   HEAP32[i9 + (i10 * 52 | 0) + 24 >> 2] = i6;
   HEAP32[i9 + (i10 * 52 | 0) + 28 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP8[i9 + (i10 * 52 | 0) + 48 >> 0] = i7;
   HEAP32[i9 + (i10 * 52 | 0) + 40 >> 2] = i16;
   HEAPF32[i9 + (i10 * 52 | 0) >> 2] = f15;
   HEAPF32[i9 + (i10 * 52 | 0) + 4 >> 2] = f14;
   HEAPF32[i9 + (i10 * 52 | 0) + 8 >> 2] = f13;
   HEAPF32[i9 + (i10 * 52 | 0) + 12 >> 2] = f12;
   HEAP32[i9 + (i10 * 52 | 0) + 44 >> 2] = i3;
   HEAP32[i9 + (i10 * 52 | 0) + 32 >> 2] = i8;
   HEAP32[i9 + (i10 * 52 | 0) + 36 >> 2] = 6;
   STACKTOP = i11;
   return;
  }
 } while (0);
 i2 = i10 + 60 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i16 = i1 + 4 | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i16;
   i16 = i1 + 12 | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i16 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i16 = i1 + 4 | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i16;
   i16 = i1 + 12 | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   HEAP32[i16 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 52 | 0) + 49 >> 0] = 0;
 HEAP32[i2 >> 2] = -1;
 STACKTOP = i11;
 return;
}

function __ZN5Flare12FlareElement8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373635 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 407233 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842535 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 28 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373648 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 29 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373664 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 30 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373673 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 31 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373680 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZN10GCProfiler13RegisterEventENS_7GCEventEi(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 switch (i3 | 0) {
 case 1:
  {
   d7 = +_emscripten_get_now() * 1.0e6;
   i6 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i5 = i2;
   HEAP32[i5 >> 2] = ~~d7 >>> 0;
   HEAP32[i5 + 4 >> 2] = i6;
   break;
  }
 case 5:
  {
   i5 = i2;
   i8 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   d7 = +_emscripten_get_now() * 1.0e6;
   i5 = __Z17TimeToNanosecondsy(_i64Subtract(~~d7 >>> 0 | 0, (+Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i5 | 0) | 0, getTempRet0() | 0) | 0;
   i8 = getTempRet0() | 0;
   i6 = i2 + 8 | 0;
   i9 = i6;
   i8 = _i64Add(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, i5 | 0, i8 | 0) | 0;
   i5 = getTempRet0() | 0;
   HEAP32[i6 >> 2] = i8;
   HEAP32[i6 + 4 >> 2] = i5;
   i6 = i2 + 16 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   break;
  }
 default:
  {}
 }
 if (!(HEAP8[i2 + 20 >> 0] | 0)) {
  STACKTOP = i4;
  return;
 }
 do switch (i3 | 0) {
 case 0:
  {
   d7 = +_emscripten_get_now() * 1.0e6;
   i8 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i2 + 24 | 0;
   HEAP32[i9 >> 2] = ~~d7 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 5:
  {
   i6 = i2 + 24 | 0;
   i8 = i6;
   i9 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i8 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i9 | 0, i8 | 0) | 0;
   i9 = getTempRet0() | 0;
   HEAP32[i6 >> 2] = i8;
   HEAP32[i6 + 4 >> 2] = i9;
   i6 = i2 + 48 | 0;
   d13 = +Math_fround((+((HEAP32[i6 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i6 + 4 >> 2] | 0) >>> 0)) * 1.0e-09);
   i6 = i2 + 32 | 0;
   d12 = +Math_fround((+((HEAP32[i6 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i6 + 4 >> 2] | 0) >>> 0)) * 1.0e-09);
   i6 = i2 + 40 | 0;
   d11 = +Math_fround((+((HEAP32[i6 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i6 + 4 >> 2] | 0) >>> 0)) * 1.0e-09);
   i6 = i2 + 56 | 0;
   d10 = +Math_fround((+((HEAP32[i6 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i6 + 4 >> 2] | 0) >>> 0)) * 1.0e-09);
   d7 = +Math_fround((+(i8 >>> 0) + 4294967296.0 * +(i9 >>> 0)) * 1.0e-09);
   HEAPF64[i1 >> 3] = d13;
   HEAPF64[i1 + 8 >> 3] = d12;
   HEAPF64[i1 + 16 >> 3] = d11;
   HEAPF64[i1 + 24 >> 3] = d10;
   HEAPF64[i1 + 32 >> 3] = d7;
   _printf_console(gb + 461526 | 0, i1);
   i1 = i2 + 24 | 0;
   i2 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   STACKTOP = i4;
   return;
  }
 case 1:
  {
   d13 = +_emscripten_get_now() * 1.0e6;
   i8 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i2 + 32 | 0;
   HEAP32[i9 >> 2] = ~~d13 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 2:
  {
   i9 = i2 + 32 | 0;
   i6 = i9;
   i8 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i6 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i6 | 0) | 0;
   i8 = getTempRet0() | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 3:
  {
   d13 = +_emscripten_get_now() * 1.0e6;
   i8 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i2 + 40 | 0;
   HEAP32[i9 >> 2] = ~~d13 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 4:
  {
   i9 = i2 + 40 | 0;
   i6 = i9;
   i8 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i6 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i6 | 0) | 0;
   i8 = getTempRet0() | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 6:
  {
   d13 = +_emscripten_get_now() * 1.0e6;
   i8 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i2 + 48 | 0;
   HEAP32[i9 >> 2] = ~~d13 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 7:
  {
   i9 = i2 + 48 | 0;
   i6 = i9;
   i8 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i6 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i6 | 0) | 0;
   i8 = getTempRet0() | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 8:
  {
   d13 = +_emscripten_get_now() * 1.0e6;
   i8 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i2 + 56 | 0;
   HEAP32[i9 >> 2] = ~~d13 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 case 9:
  {
   i9 = i2 + 56 | 0;
   i6 = i9;
   i8 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i6 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i6 | 0) | 0;
   i8 = getTempRet0() | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i8;
   STACKTOP = i4;
   return;
  }
 default:
  {
   STACKTOP = i4;
   return;
  }
 } while (0);
}

function __Z15SHFilterCubeMapP13CImageSurfaceS0_biR17PrecomputeContext(i15, i25, i23, i24, i30) {
 i15 = i15 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i30 = i30 | 0;
 var i1 = 0, d2 = 0.0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0, i21 = 0, i22 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, d38 = 0.0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 1008 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i36 + 800 | 0;
 i32 = i36 + 600 | 0;
 i33 = i36 + 400 | 0;
 i34 = i36 + 200 | 0;
 i35 = i36;
 i16 = HEAP32[i15 >> 2] | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i21 = HEAP32[i15 + 8 >> 2] | 0;
 i27 = HEAP32[i25 + 8 >> 2] | 0;
 __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei(i16, i30, i24);
 i28 = HEAP32[i30 + 8 >> 2] | 0;
 _memset(i31 | 0, 0, 200) | 0;
 _memset(i32 | 0, 0, 200) | 0;
 _memset(i33 | 0, 0, 200) | 0;
 _memset(i34 | 0, 0, 200) | 0;
 _memset(i35 | 0, 0, 200) | 0;
 i22 = (i16 | 0) > 0;
 i29 = (i28 | 0) > 3;
 d2 = 0.0;
 i14 = 0;
 do {
  if (i22) {
   i12 = i30 + (i14 << 4) + 12 | 0;
   i13 = i15 + (i14 << 4) + 12 | 0;
   i11 = 0;
   do {
    i10 = Math_imul(i11, i16) | 0;
    i9 = Math_imul(i10, i28) | 0;
    i9 = (HEAP32[i12 >> 2] | 0) + (i9 << 2) | 0;
    i10 = Math_imul(i10, i21) | 0;
    i10 = (HEAP32[i13 >> 2] | 0) + (i10 << 2) | 0;
    if (i23) {
     i6 = 0;
     do {
      i1 = i9 + ((Math_imul(i6, i28) | 0) << 2) | 0;
      d17 = +Math_fround(HEAPF32[i1 + 12 >> 2]);
      __Z11EvalSHBasisPKfPd(i1, i35);
      i1 = Math_imul(i6, i21) | 0;
      d18 = +Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
      d19 = +Math_fround(HEAPF32[i10 + (i1 + 1 << 2) >> 2]);
      d20 = +Math_fround(HEAPF32[i10 + (i1 + 2 << 2) >> 2]);
      if (i29) f3 = Math_fround(HEAPF32[i10 + (i1 + 3 << 2) >> 2]); else f3 = Math_fround(1.0);
      d8 = +f3;
      i1 = 0;
      do {
       d38 = +HEAPF64[i35 + (i1 << 3) >> 3];
       i37 = i31 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d17 * (d18 * d38);
       i37 = i32 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d17 * (d19 * d38);
       i37 = i33 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d17 * (d20 * d38);
       i37 = i34 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d17 * (d8 * d38);
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 25);
      d2 = d2 + d17;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i16 | 0));
    } else {
     i6 = 0;
     do {
      __Z11EvalSHBasisPKfPd(i9 + ((Math_imul(i6, i28) | 0) << 2) | 0, i35);
      i1 = Math_imul(i6, i21) | 0;
      d17 = +Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
      d18 = +Math_fround(HEAPF32[i10 + (i1 + 1 << 2) >> 2]);
      d19 = +Math_fround(HEAPF32[i10 + (i1 + 2 << 2) >> 2]);
      if (i29) f3 = Math_fround(HEAPF32[i10 + (i1 + 3 << 2) >> 2]); else f3 = Math_fround(1.0);
      d8 = +f3;
      i1 = 0;
      do {
       d38 = +HEAPF64[i35 + (i1 << 3) >> 3];
       i37 = i31 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d17 * d38;
       i37 = i32 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d18 * d38;
       i37 = i33 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d19 * d38;
       i37 = i34 + (i1 << 3) | 0;
       HEAPF64[i37 >> 3] = +HEAPF64[i37 >> 3] + d8 * d38;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 25);
      d2 = d2 + 1.0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i16 | 0));
    }
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i16 | 0));
  }
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != 6);
 d2 = 12.566370614359172 / d2;
 i1 = 0;
 do {
  i37 = i31 + (i1 << 3) | 0;
  HEAPF64[i37 >> 3] = d2 * +HEAPF64[i37 >> 3];
  i37 = i32 + (i1 << 3) | 0;
  HEAPF64[i37 >> 3] = d2 * +HEAPF64[i37 >> 3];
  i37 = i33 + (i1 << 3) | 0;
  HEAPF64[i37 >> 3] = d2 * +HEAPF64[i37 >> 3];
  i37 = i34 + (i1 << 3) | 0;
  HEAPF64[i37 >> 3] = d2 * +HEAPF64[i37 >> 3];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 25);
 __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei(HEAP32[i25 >> 2] | 0, i30, i24);
 i11 = (i26 | 0) > 0;
 i12 = (i27 | 0) > 3;
 i10 = 0;
 do {
  if (i11) {
   i13 = i30 + (i10 << 4) + 12 | 0;
   i14 = i25 + (i10 << 4) + 12 | 0;
   i9 = 0;
   do {
    i16 = Math_imul(i9, i26) | 0;
    i15 = Math_imul(i16, i28) | 0;
    i15 = (HEAP32[i13 >> 2] | 0) + (i15 << 2) | 0;
    i16 = Math_imul(i16, i27) | 0;
    i16 = (HEAP32[i14 >> 2] | 0) + (i16 << 2) | 0;
    if (i29) {
     i6 = 0;
     do {
      __Z11EvalSHBasisPKfPd(i15 + ((Math_imul(i6, i28) | 0) << 2) | 0, i35);
      f3 = Math_fround(0.0);
      f4 = Math_fround(0.0);
      f5 = Math_fround(0.0);
      f7 = Math_fround(0.0);
      i1 = 0;
      do {
       d38 = +HEAPF64[i35 + (i1 << 3) >> 3];
       d20 = +HEAPF64[gb + 192 + (i1 << 3) >> 3];
       f7 = Math_fround(f7 + Math_fround(+HEAPF64[i31 + (i1 << 3) >> 3] * d38 * d20));
       f5 = Math_fround(f5 + Math_fround(d20 * (d38 * +HEAPF64[i32 + (i1 << 3) >> 3])));
       f4 = Math_fround(f4 + Math_fround(d20 * (d38 * +HEAPF64[i33 + (i1 << 3) >> 3])));
       f3 = Math_fround(f3 + Math_fround(d20 * (d38 * +HEAPF64[i34 + (i1 << 3) >> 3])));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 25);
      i1 = Math_imul(i6, i27) | 0;
      HEAPF32[i16 + (i1 << 2) >> 2] = f7;
      HEAPF32[i16 + (i1 + 1 << 2) >> 2] = f5;
      HEAPF32[i16 + (i1 + 2 << 2) >> 2] = f4;
      if (i12) HEAPF32[i16 + (i1 + 3 << 2) >> 2] = f3;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i26 | 0));
    } else {
     i6 = 0;
     do {
      __Z11EvalSHBasisPKfPd(i15 + ((Math_imul(i6, i28) | 0) << 2) | 0, i35);
      f3 = Math_fround(0.0);
      f4 = Math_fround(0.0);
      f5 = Math_fround(0.0);
      i1 = 0;
      do {
       d38 = +HEAPF64[i35 + (i1 << 3) >> 3];
       d20 = +HEAPF64[gb + 192 + (i1 << 3) >> 3];
       f5 = Math_fround(f5 + Math_fround(+HEAPF64[i31 + (i1 << 3) >> 3] * d38 * d20));
       f4 = Math_fround(f4 + Math_fround(d20 * (d38 * +HEAPF64[i32 + (i1 << 3) >> 3])));
       f3 = Math_fround(f3 + Math_fround(d20 * (d38 * +HEAPF64[i33 + (i1 << 3) >> 3])));
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != 25);
      i1 = Math_imul(i6, i27) | 0;
      HEAPF32[i16 + (i1 << 2) >> 2] = f5;
      HEAPF32[i16 + (i1 + 1 << 2) >> 2] = f4;
      HEAPF32[i16 + (i1 + 2 << 2) >> 2] = f3;
      if (i12) HEAPF32[i16 + (i1 + 3 << 2) >> 2] = Math_fround(1.0);
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i26 | 0));
    }
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i26 | 0));
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 6);
 STACKTOP = i36;
 return;
}

function __Z8BuildCapjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfRKNS2_7_float4ERK11ColorRGBA32SA_b(i3, i32, i33, i2, i34, i35, i36, i37, i1) {
 i3 = i3 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i2 = i2 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 if (Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + (i3 << 4) + 8 >> 2]) > Math_fround(0.0)) i1 = i1 ^ 1;
 i30 = HEAP32[i2 + 8 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i30 + (i3 << 3) >> 2]);
 f14 = Math_fround(HEAPF32[i30 + (i3 << 3) + 4 >> 2]);
 f15 = Math_fround(Math_fround(1.0) / Math_fround(i4 + 1 | 0));
 f16 = Math_fround(-f15);
 f16 = Math_fround((i1 ? f16 : f15) * Math_fround(3.14159274));
 if ((i4 | 0) < -1) return;
 i17 = i35 + 4 | 0;
 i18 = i35 + 8 | 0;
 i19 = i33 + 16 | 0;
 i20 = i33 + 20 | 0;
 i21 = i33 + 24 | 0;
 i22 = i33 + 4 | 0;
 i23 = i33 + 8 | 0;
 i24 = i33 + 48 | 0;
 i25 = i33 + 52 | 0;
 i26 = i33 + 56 | 0;
 i27 = i33 + 32 | 0;
 i28 = i33 + 36 | 0;
 i29 = i33 + 40 | 0;
 i13 = HEAP32[i32 >> 2] | 0;
 i30 = (i4 << 1) + 4 | 0;
 i3 = i4 + 1 | 0;
 f12 = Math_fround(0.0);
 i2 = 0;
 i4 = i13;
 while (1) {
  f6 = Math_fround(+Math_cos(+f12));
  f9 = Math_fround(+Math_sin(+f12));
  f8 = Math_fround(Math_fround(f31 * f6) - Math_fround(f14 * f9));
  f9 = Math_fround(Math_fround(f14 * f6) + Math_fround(f31 * f9));
  f6 = Math_fround(HEAPF32[i34 >> 2]);
  f8 = Math_fround(f6 * f8);
  f9 = Math_fround(f6 * f9);
  f6 = Math_fround(HEAPF32[i35 >> 2]);
  f7 = Math_fround(HEAPF32[i17 >> 2]);
  f8 = Math_fround(f6 + f8);
  f9 = Math_fround(f7 + f9);
  f12 = Math_fround(f16 + f12);
  f5 = Math_fround(f15 * Math_fround(i2 | 0));
  f10 = Math_fround(HEAPF32[i18 >> 2]);
  f11 = Math_fround(HEAPF32[i19 >> 2]);
  if (i1) {
   f42 = Math_fround(f7 * f11);
   f39 = Math_fround(f7 * Math_fround(HEAPF32[i20 >> 2]));
   f41 = Math_fround(f7 * Math_fround(HEAPF32[i21 >> 2]));
   f7 = Math_fround(f6 * Math_fround(HEAPF32[i33 >> 2]));
   f43 = Math_fround(f6 * Math_fround(HEAPF32[i22 >> 2]));
   f7 = Math_fround(f42 + f7);
   f43 = Math_fround(f39 + f43);
   f41 = Math_fround(f41 + Math_fround(f6 * Math_fround(HEAPF32[i23 >> 2])));
   f39 = Math_fround(HEAPF32[i24 >> 2]);
   f42 = Math_fround(HEAPF32[i25 >> 2]);
   f11 = Math_fround(HEAPF32[i26 >> 2]);
   f40 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
   f6 = Math_fround(f10 * Math_fround(HEAPF32[i28 >> 2]));
   f6 = Math_fround(f43 + Math_fround(f42 + f6));
   f11 = Math_fround(f41 + Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i29 >> 2]))));
   HEAPF32[i4 >> 2] = Math_fround(f7 + Math_fround(f39 + f40));
   HEAPF32[i4 + 4 >> 2] = f6;
   HEAPF32[i4 + 8 >> 2] = f11;
   HEAP32[i4 + 12 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i37 >> 2];
   HEAPF32[i4 + 20 >> 2] = Math_fround(.5);
   f11 = Math_fround(HEAPF32[i18 >> 2]);
   i38 = i4 + 24 | 0;
   f6 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
   f40 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
   f39 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
   f7 = Math_fround(f8 * Math_fround(HEAPF32[i33 >> 2]));
   f41 = Math_fround(f8 * Math_fround(HEAPF32[i22 >> 2]));
   f7 = Math_fround(f6 + f7);
   f41 = Math_fround(f40 + f41);
   f39 = Math_fround(f39 + Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2])));
   f8 = Math_fround(HEAPF32[i24 >> 2]);
   f40 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(HEAPF32[i26 >> 2]);
   f9 = Math_fround(f11 * Math_fround(HEAPF32[i27 >> 2]));
   f10 = Math_fround(f11 * Math_fround(HEAPF32[i28 >> 2]));
   f10 = Math_fround(f41 + Math_fround(f40 + f10));
   f11 = Math_fround(f39 + Math_fround(f6 + Math_fround(f11 * Math_fround(HEAPF32[i29 >> 2]))));
   HEAPF32[i38 >> 2] = Math_fround(f7 + Math_fround(f8 + f9));
   HEAPF32[i38 + 4 >> 2] = f10;
   HEAPF32[i38 + 8 >> 2] = f11;
   HEAP32[i4 + 36 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i4 + 40 >> 2] = HEAP32[i37 >> 2];
  } else {
   f43 = Math_fround(f9 * f11);
   f40 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
   f42 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
   f9 = Math_fround(f8 * Math_fround(HEAPF32[i33 >> 2]));
   f7 = Math_fround(f8 * Math_fround(HEAPF32[i22 >> 2]));
   f9 = Math_fround(f43 + f9);
   f7 = Math_fround(f40 + f7);
   f42 = Math_fround(f42 + Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2])));
   f40 = Math_fround(HEAPF32[i24 >> 2]);
   f43 = Math_fround(HEAPF32[i25 >> 2]);
   f11 = Math_fround(HEAPF32[i26 >> 2]);
   f39 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
   f41 = Math_fround(f10 * Math_fround(HEAPF32[i28 >> 2]));
   f41 = Math_fround(f7 + Math_fround(f43 + f41));
   f11 = Math_fround(f42 + Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i29 >> 2]))));
   HEAPF32[i4 >> 2] = Math_fround(f9 + Math_fround(f40 + f39));
   HEAPF32[i4 + 4 >> 2] = f41;
   HEAPF32[i4 + 8 >> 2] = f11;
   HEAP32[i4 + 12 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i37 >> 2];
   HEAPF32[i4 + 20 >> 2] = f5;
   f5 = Math_fround(HEAPF32[i18 >> 2]);
   f11 = Math_fround(HEAPF32[i35 >> 2]);
   f41 = Math_fround(HEAPF32[i17 >> 2]);
   i38 = i4 + 24 | 0;
   f39 = Math_fround(f41 * Math_fround(HEAPF32[i19 >> 2]));
   f10 = Math_fround(f41 * Math_fround(HEAPF32[i20 >> 2]));
   f41 = Math_fround(f41 * Math_fround(HEAPF32[i21 >> 2]));
   f40 = Math_fround(f11 * Math_fround(HEAPF32[i33 >> 2]));
   f9 = Math_fround(f11 * Math_fround(HEAPF32[i22 >> 2]));
   f40 = Math_fround(f39 + f40);
   f9 = Math_fround(f10 + f9);
   f11 = Math_fround(f41 + Math_fround(f11 * Math_fround(HEAPF32[i23 >> 2])));
   f41 = Math_fround(HEAPF32[i24 >> 2]);
   f10 = Math_fround(HEAPF32[i25 >> 2]);
   f39 = Math_fround(HEAPF32[i26 >> 2]);
   f42 = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
   f43 = Math_fround(f5 * Math_fround(HEAPF32[i28 >> 2]));
   f43 = Math_fround(f9 + Math_fround(f10 + f43));
   f5 = Math_fround(f11 + Math_fround(f39 + Math_fround(f5 * Math_fround(HEAPF32[i29 >> 2]))));
   HEAPF32[i38 >> 2] = Math_fround(f40 + Math_fround(f41 + f42));
   HEAPF32[i38 + 4 >> 2] = f43;
   HEAPF32[i38 + 8 >> 2] = f5;
   HEAP32[i4 + 36 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i4 + 40 >> 2] = HEAP32[i37 >> 2];
   f5 = Math_fround(.5);
  }
  HEAPF32[i4 + 44 >> 2] = f5;
  if ((i2 | 0) == (i3 | 0)) break; else {
   i2 = i2 + 1 | 0;
   i4 = i4 + 48 | 0;
  }
 }
 HEAP32[i32 >> 2] = i13 + (i30 * 24 | 0);
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN6Camera8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i9 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381067 | 0, i9, i1 + 844 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 848 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381080 | 0, HEAP32[gb + 36980 >> 2] | 0, i8, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 864 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373323 | 0, HEAP32[gb + 37212 >> 2] | 0, i8, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373348 | 0, i8, i1 + 920 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373364 | 0, i8, i1 + 924 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373379 | 0, i8, i1 + 292 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373393 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 1088 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373406 | 0, i8, i1 + 916 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853473 | 0, i8, i1 + 888 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 880 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381098 | 0, gb + 1048681 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, i9, i8, 4194305);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373424 | 0, i8, i1 + 928 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 744 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373440 | 0, gb + 373456 | 0, i9, 0);
 i6 = i7 + 8 | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011529 | 0, i8, i1 + 820 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 824 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373476 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 381150 | 0, i6, i1 + 1091 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373488 | 0, i6, i1 + 1089 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373507 | 0, i7, i1 + 1100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373527 | 0, i7, i1 + 1096 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373546 | 0, i6, i1 + 1112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i18, i2, i19, i1) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i17 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i17) return;
 i11 = HEAP32[i2 + 60 >> 2] | 0;
 i12 = HEAP32[i2 + 80 >> 2] | 0;
 i13 = HEAP32[i2 + 100 >> 2] | 0;
 i14 = HEAP32[i2 + 120 >> 2] | 0;
 i15 = HEAP32[i2 + 140 >> 2] | 0;
 i2 = HEAP32[i2 + 160 >> 2] | 0;
 i3 = i18 + 32 | 0;
 i4 = i18 + 4 | 0;
 i5 = i18 + 8 | 0;
 i6 = i18 + 12 | 0;
 i7 = i18 + 16 | 0;
 i8 = i18 + 20 | 0;
 i9 = i18 + 24 | 0;
 i10 = i18 + 28 | 0;
 i1 = 0;
 do {
  i27 = i11 + (i1 << 2) | 0;
  f48 = Math_fround(HEAPF32[i27 >> 2]);
  f34 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f37 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f39 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = i12 + (i1 << 2) | 0;
  f41 = Math_fround(HEAPF32[i27 >> 2]);
  f43 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f45 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = i13 + (i1 << 2) | 0;
  f46 = Math_fround(HEAPF32[i27 >> 2]);
  f22 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f24 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = i14 + (i1 << 2) | 0;
  f26 = Math_fround(HEAPF32[i27 >> 2]);
  f47 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f33 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = i15 + (i1 << 2) | 0;
  f28 = Math_fround(HEAPF32[i27 >> 2]);
  f35 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f29 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = i2 + (i1 << 2) | 0;
  f42 = Math_fround(HEAPF32[i27 >> 2]);
  f40 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f38 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f26 = Math_fround(f48 + f26);
  f47 = Math_fround(f34 + f47);
  f31 = Math_fround(f37 + f31);
  f33 = Math_fround(f39 + f33);
  f28 = Math_fround(f41 + f28);
  f35 = Math_fround(f43 + f35);
  f32 = Math_fround(f44 + f32);
  f29 = Math_fround(f45 + f29);
  f42 = Math_fround(f46 + f42);
  f40 = Math_fround(f22 + f40);
  f38 = Math_fround(f24 + f38);
  f36 = Math_fround(f36 + Math_fround(HEAPF32[i27 + 12 >> 2]));
  f42 = Math_fround(f16 + Math_fround(f20 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f28 * f28)) + Math_fround(f42 * f42))))));
  f40 = Math_fround(f16 + Math_fround(f20 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f47 * f47) + Math_fround(f35 * f35)) + Math_fround(f40 * f40))))));
  f38 = Math_fround(f16 + Math_fround(f20 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f32 * f32)) + Math_fround(f38 * f38))))));
  f36 = Math_fround(f16 + Math_fround(f20 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f29 * f29)) + Math_fround(f36 * f36))))));
  i27 = f42 < Math_fround(0.0);
  f42 = i27 ? Math_fround(0.0) : f42;
  i27 = f40 < Math_fround(0.0);
  f40 = i27 ? Math_fround(0.0) : f40;
  i27 = f38 < Math_fround(0.0);
  f38 = i27 ? Math_fround(0.0) : f38;
  i27 = f36 < Math_fround(0.0);
  f36 = i27 ? Math_fround(0.0) : f36;
  i27 = f42 > Math_fround(1.0);
  f42 = i27 ? Math_fround(1.0) : f42;
  i27 = f40 > Math_fround(1.0);
  f40 = i27 ? Math_fround(1.0) : f40;
  i27 = f38 > Math_fround(1.0);
  f38 = i27 ? Math_fround(1.0) : f38;
  i27 = f36 > Math_fround(1.0);
  f36 = i27 ? Math_fround(1.0) : f36;
  i27 = i19 + (i1 << 2) | 0;
  f29 = Math_fround(HEAPF32[i27 >> 2]);
  i25 = i27 + 4 | 0;
  f33 = Math_fround(HEAPF32[i25 >> 2]);
  i23 = i27 + 8 | 0;
  f32 = Math_fround(HEAPF32[i23 >> 2]);
  i21 = i27 + 12 | 0;
  f31 = Math_fround(HEAPF32[i21 >> 2]);
  f35 = Math_fround(HEAPF32[i3 >> 2]);
  f47 = Math_fround(HEAPF32[i18 >> 2]);
  f28 = Math_fround(f42 * f47);
  f26 = Math_fround(f40 * f47);
  f24 = Math_fround(f38 * f47);
  f47 = Math_fround(f47 * f36);
  f22 = Math_fround(HEAPF32[i4 >> 2]);
  f28 = Math_fround(f42 * Math_fround(f28 + f22));
  f26 = Math_fround(f40 * Math_fround(f26 + f22));
  f24 = Math_fround(f38 * Math_fround(f24 + f22));
  f22 = Math_fround(f36 * Math_fround(f47 + f22));
  f47 = Math_fround(HEAPF32[i5 >> 2]);
  f28 = Math_fround(f42 * Math_fround(f47 + f28));
  f26 = Math_fround(f40 * Math_fround(f47 + f26));
  f24 = Math_fround(f38 * Math_fround(f47 + f24));
  f22 = Math_fround(f36 * Math_fround(f47 + f22));
  f47 = Math_fround(HEAPF32[i6 >> 2]);
  f28 = Math_fround(f47 + f28);
  f26 = Math_fround(f47 + f26);
  f24 = Math_fround(f47 + f24);
  f22 = Math_fround(f47 + f22);
  f47 = Math_fround(f42 - f35);
  f46 = Math_fround(f40 - f35);
  f45 = Math_fround(f38 - f35);
  f44 = Math_fround(f36 - f35);
  f43 = Math_fround(HEAPF32[i7 >> 2]);
  f41 = Math_fround(f47 * f43);
  f39 = Math_fround(f46 * f43);
  f37 = Math_fround(f45 * f43);
  f43 = Math_fround(f44 * f43);
  f34 = Math_fround(HEAPF32[i8 >> 2]);
  f41 = Math_fround(f47 * Math_fround(f41 + f34));
  f39 = Math_fround(f46 * Math_fround(f39 + f34));
  f37 = Math_fround(f45 * Math_fround(f37 + f34));
  f34 = Math_fround(f44 * Math_fround(f43 + f34));
  f43 = Math_fround(HEAPF32[i9 >> 2]);
  f41 = Math_fround(f47 * Math_fround(f43 + f41));
  f39 = Math_fround(f46 * Math_fround(f43 + f39));
  f37 = Math_fround(f45 * Math_fround(f43 + f37));
  f34 = Math_fround(f44 * Math_fround(f43 + f34));
  f43 = Math_fround(HEAPF32[i10 >> 2]);
  f41 = Math_fround(f43 + f41);
  f39 = Math_fround(f43 + f39);
  f37 = Math_fround(f43 + f37);
  f34 = Math_fround(f43 + f34);
  f28 = f42 > f35 ? f41 : f28;
  f26 = f40 > f35 ? f39 : f26;
  f24 = f38 > f35 ? f37 : f24;
  f22 = f36 > f35 ? f34 : f22;
  i30 = f28 < Math_fround(0.0);
  f28 = i30 ? Math_fround(0.0) : f28;
  i30 = f26 < Math_fround(0.0);
  f26 = i30 ? Math_fround(0.0) : f26;
  i30 = f24 < Math_fround(0.0);
  f24 = i30 ? Math_fround(0.0) : f24;
  i30 = f22 < Math_fround(0.0);
  f26 = Math_fround(f33 * f26);
  f24 = Math_fround(f32 * f24);
  f22 = Math_fround(f31 * (i30 ? Math_fround(0.0) : f22));
  HEAPF32[i27 >> 2] = Math_fround(f29 * f28);
  HEAPF32[i25 >> 2] = f26;
  HEAPF32[i23 >> 2] = f24;
  HEAPF32[i21 >> 2] = f22;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i17 >>> 0);
 return;
}

function __ZN5physx2Sc5Scene5flushEb(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1) {
  __ZN5physx2Sc5Scene26fireQueuedContactCallbacksEb(i11, 1);
  __ZN5physx2Sc5Scene20fireTriggerCallbacksEv(i11);
  i1 = i11 + 1104 | 0;
 } else {
  i1 = i11 + 1104 | 0;
  __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb(HEAP32[i1 >> 2] | 0, 1);
 }
 __ZN5physx2Sc5Scene18postReportsCleanupEv(i11);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = -1;
 i2 = i1 + 52 | 0;
 i3 = i1 + 56 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
  i9 = i1 + 44 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 24 | 0, HEAP32[i9 >> 2] | 0);
  HEAP32[i9 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, HEAP32[i3 >> 2] | 0, gb + 705933 | 0, 150) | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 }
 __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i11 + 84 | 0, HEAP32[i11 + 88 >> 2] | 0);
 i4 = i11 + 100 | 0;
 HEAP8[i10 + 20 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i4, 0, i10);
 __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i4, HEAP32[i11 + 104 >> 2] | 0);
 i4 = HEAP32[i11 + 112 >> 2] | 0;
 HEAP32[i10 >> 2] = -1;
 HEAP32[i10 + 4 >> 2] = -1;
 HEAP16[i10 + 8 >> 1] = 65535;
 HEAP8[i10 + 10 >> 0] = 0;
 HEAP8[i10 + 11 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i4, 0, i10);
 __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i4, HEAP32[i4 + 4 >> 2] | 0);
 i4 = i11 + 196 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = i11 + 192 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i9, 0, i10);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i9, HEAP32[i4 >> 2] | 0);
 i4 = i11 + 1128 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = i11 + 1124 | 0;
  i2 = 0;
  do {
   i9 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0) + 144 | 0;
   HEAP16[i9 >> 1] = (HEAPU16[i9 >> 1] | 0) & 65423;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i11 + 1140 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i11 + 1136 | 0;
  i3 = 0;
  do {
   i9 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) + 144 | 0;
   HEAP16[i9 >> 1] = (HEAPU16[i9 >> 1] | 0) & 65359;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i11 + 1148 >> 0] = 1;
 HEAP8[i11 + 1149 >> 0] = 1;
 i2 = i11 + 1124 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i2, 0, i10);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i2, HEAP32[i4 >> 2] | 0);
 i2 = i11 + 1136 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i2, 0, i10);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i2, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i11 + 1152 | 0, HEAP32[i11 + 1156 >> 2] | 0);
 i1 = HEAP32[i11 + 1196 >> 2] | 0;
 i2 = i1 + 32 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i1 + 28 | 0;
  i4 = i1 + 4 | 0;
  i5 = i1 + 12 | 0;
  i6 = i1 + 8 | 0;
  i9 = 0;
  do {
   i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAP32[i10 >> 2] = i7;
   do if (((HEAP32[i1 >> 2] | 0) + -1 | 0) == (i7 | 0)) HEAP32[i1 >> 2] = i7; else {
    i8 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i8 >>> 0) {
     HEAP32[(HEAP32[i4 >> 2] | 0) + (i8 << 2) >> 2] = i7;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i10) | 0;
     break;
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 28 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i1, 0, i10);
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i11 + 1200 >> 2] | 0;
 i2 = i1 + 32 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i1 + 28 | 0;
  i4 = i1 + 4 | 0;
  i5 = i1 + 12 | 0;
  i6 = i1 + 8 | 0;
  i9 = 0;
  do {
   i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAP32[i10 >> 2] = i7;
   do if (((HEAP32[i1 >> 2] | 0) + -1 | 0) == (i7 | 0)) HEAP32[i1 >> 2] = i7; else {
    i8 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i8 >>> 0) {
     HEAP32[(HEAP32[i4 >> 2] | 0) + (i8 << 2) >> 2] = i7;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i10) | 0;
     break;
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 HEAP32[i2 >> 2] = 0;
 i9 = i1 + 28 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i9, 0, i10);
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i9, HEAP32[i2 >> 2] | 0);
 __ZN5physx2Sc5Scene21processLostTouchPairsEv(i11);
 i9 = i11 + 1240 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i9, 0, i10);
 __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i9, HEAP32[i11 + 1244 >> 2] | 0);
 i9 = i11 + 1204 | 0;
 __ZN5physx2Sc16InteractionScene14retrieveMemoryEv(HEAP32[i9 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i11 + 132 | 0, HEAP32[i11 + 136 >> 2] | 0);
 i8 = i11 + 144 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i8, 0, i10);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i8, HEAP32[i11 + 148 >> 2] | 0);
 __ZN5physx17PxcNpMemBlockPool19releaseUnusedBlocksEv((HEAP32[(HEAP32[i9 >> 2] | 0) + 1e3 >> 2] | 0) + 44 | 0);
 STACKTOP = i12;
 return;
}

function _UNITY_png_ascii_from_fp(i18, i1, i3, d6, i2) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 d6 = +d6;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 8 | 0;
 i19 = i20 + 12 | 0;
 i16 = i20;
 i15 = (i2 | 0) == 0 ? 15 : i2;
 i15 = i15 >>> 0 > 16 ? 16 : i15;
 if ((i15 + 5 | 0) >>> 0 > i3 >>> 0) _UNITY_png_error(i18, gb + 351925 | 0);
 if (d6 < 0.0) {
  HEAP8[i1 >> 0] = 45;
  i1 = i1 + 1 | 0;
  i9 = i3 + -1 | 0;
  d11 = -d6;
 } else {
  i9 = i3;
  d11 = d6;
 }
 i3 = d11 >= 2.2250738585072014e-308;
 if (!(i3 & d11 <= 1797693134862315708145274.0e284)) {
  i2 = i1 + 1 | 0;
  if (i3) {
   HEAP8[i1 >> 0] = 105;
   HEAP8[i2 >> 0] = 110;
   HEAP8[i1 + 2 >> 0] = 102;
   HEAP8[i1 + 3 >> 0] = 0;
   STACKTOP = i20;
   return;
  } else {
   HEAP8[i1 >> 0] = 48;
   HEAP8[i2 >> 0] = 0;
   STACKTOP = i20;
   return;
  }
 }
 +_frexp(d11, i17);
 i2 = (HEAP32[i17 >> 2] | 0) * 77 >> 8;
 HEAP32[i17 >> 2] = i2;
 if ((i2 | 0) < 0) if ((i2 | 0) < -307) {
  d6 = 0.0;
  i5 = 12;
 } else {
  i4 = 1;
  i3 = 0 - i2 | 0;
  i5 = 8;
 } else {
  i4 = 0;
  i3 = i2;
  i5 = 8;
 }
 if ((i5 | 0) == 8) {
  if ((i3 | 0) > 0) {
   d6 = 10.0;
   d7 = 1.0;
   while (1) {
    d7 = (i3 & 1 | 0) == 0 ? d7 : d7 * d6;
    i3 = i3 >> 1;
    if ((i3 | 0) <= 0) break; else d6 = d6 * d6;
   }
   d6 = (i4 | 0) == 0 ? d7 : 1.0 / d7;
  } else d6 = 1.0;
  if (d6 < 2.2250738585072014e-308 | d6 < d11) i5 = 12;
 }
 L25 : do if ((i5 | 0) == 12) L26 : while (1) {
  i5 = i2 + 1 | 0;
  do if ((i2 | 0) < -1) if ((i5 | 0) < -307) {
   HEAP32[i17 >> 2] = i5;
   d6 = 0.0;
   i2 = i5;
   i5 = 12;
   continue L26;
  } else {
   i4 = 1;
   i3 = ~i2;
   break;
  } else {
   i4 = 0;
   i3 = i5;
  } while (0);
  if ((i3 | 0) > 0) {
   d7 = 10.0;
   d8 = 1.0;
   while (1) {
    d8 = (i3 & 1 | 0) == 0 ? d8 : d8 * d7;
    i3 = i3 >> 1;
    if ((i3 | 0) <= 0) break; else d7 = d7 * d7;
   }
   d7 = (i4 | 0) == 0 ? d8 : 1.0 / d8;
   if (!(d7 <= 1797693134862315708145274.0e284)) break L25; else d6 = d7;
  } else d6 = 1.0;
  HEAP32[i17 >> 2] = i5;
  if (d6 < 2.2250738585072014e-308 | d6 < d11) {
   i2 = i5;
   i5 = 12;
  } else {
   i2 = i5;
   break;
  }
 } while (0);
 d6 = d11 / d6;
 if (d6 >= 1.0) {
  do {
   d6 = d6 / 10.0;
   i2 = i2 + 1 | 0;
  } while (d6 >= 1.0);
  HEAP32[i17 >> 2] = i2;
 }
 if (i2 >>> 0 > 4294967293) {
  HEAP32[i17 >> 2] = 0;
  i2 = 0 - i2 | 0;
 } else i2 = 0;
 i3 = 0;
 i14 = i2;
 i13 = i2;
 i2 = i9;
 while (1) {
  d6 = d6 * 10.0;
  i12 = i13 + 1 | 0;
  do if ((i12 - i14 + i3 | 0) < (i15 | 0)) {
   d6 = +_modf(d6, i16);
   d7 = +HEAPF64[i16 >> 3];
   i5 = 44;
  } else {
   d7 = +Math_floor(+(d6 + .5));
   HEAPF64[i16 >> 3] = d7;
   if (d7 > 9.0) {
    if ((i13 | 0) > 0) {
     HEAPF64[i16 >> 3] = 1.0;
     i14 = (((i3 | 0) == 0) << 31 >> 31) + i14 | 0;
     i10 = i3;
     i13 = i13 + -1 | 0;
     d6 = 0.0;
     i5 = 46;
     break;
    }
    if ((i3 | 0) > 0) {
     i10 = i3;
     i3 = HEAP32[i17 >> 2] | 0;
     while (1) {
      i9 = i1 + -1 | 0;
      i4 = HEAP8[i9 >> 0] | 0;
      i5 = i4 << 24 >> 24;
      if ((i3 | 0) == -1) {
       i1 = i1 + -2 | 0;
       if (i4 << 24 >> 24 == 46) {
        i3 = HEAP8[i1 >> 0] | 0;
        HEAP32[i17 >> 2] = 1;
        i2 = i2 + 1 | 0;
        i4 = 1;
       } else {
        i3 = i5;
        i1 = i9;
        i4 = -1;
       }
      } else {
       i4 = i3 + 1 | 0;
       HEAP32[i17 >> 2] = i4;
       i3 = i5;
       i1 = i9;
      }
      i9 = i10;
      i10 = i10 + -1 | 0;
      i3 = i3 + -47 | 0;
      d7 = +(i3 | 0);
      HEAPF64[i16 >> 3] = d7;
      i3 = (i3 | 0) > 9;
      if (!(i3 & (i9 | 0) > 1)) break; else i3 = i4;
     }
     if (i3) {
      i4 = i10;
      i3 = i2;
     } else {
      i3 = i10;
      d6 = 0.0;
      i5 = 44;
      break;
     }
    } else {
     i4 = i3;
     i3 = i2;
    }
    i2 = HEAP32[i17 >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i1 + -1 | 0;
     if ((HEAP8[i1 >> 0] | 0) == 46) {
      HEAP32[i17 >> 2] = 1;
      i2 = i3 + 1 | 0;
     } else i2 = i3;
    } else {
     HEAP32[i17 >> 2] = i2 + 1;
     i2 = i3;
    }
    HEAPF64[i16 >> 3] = 1.0;
    i10 = i4;
    d6 = 0.0;
    i5 = 46;
   } else {
    d6 = 0.0;
    i5 = 44;
   }
  } while (0);
  if ((i5 | 0) == 44) {
   i5 = 0;
   if (d7 == 0.0) {
    i9 = i2;
    i4 = ((i3 | 0) == 0 & 1) + i14 | 0;
    i2 = i12;
   } else {
    i10 = i3;
    i5 = 46;
   }
  }
  if ((i5 | 0) == 46) {
   i3 = HEAP32[i17 >> 2] | 0;
   i4 = (i3 | 0) != -1;
   if ((i13 | 0) > 0) {
    i9 = i13;
    while (1) {
     if (i4) {
      if (!i3) {
       HEAP8[i1 >> 0] = 46;
       i1 = i1 + 1 | 0;
       i2 = i2 + -1 | 0;
       i3 = HEAP32[i17 >> 2] | 0;
      }
      HEAP32[i17 >> 2] = i3 + -1;
      i3 = i1;
     } else i3 = i1;
     i1 = i3 + 1 | 0;
     HEAP8[i3 >> 0] = 48;
     i5 = i9 + -1 | 0;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = (i3 | 0) != -1;
     if ((i9 | 0) > 1) i9 = i5; else break;
    }
   } else i5 = i13;
   if (i4) {
    if (!i3) {
     HEAP8[i1 >> 0] = 46;
     i1 = i1 + 1 | 0;
     i2 = i2 + -1 | 0;
     i3 = HEAP32[i17 >> 2] | 0;
    }
    HEAP32[i17 >> 2] = i3 + -1;
   }
   HEAP8[i1 >> 0] = ~~+HEAPF64[i16 >> 3] + 48;
   i1 = i1 + 1 | 0;
   i9 = i2;
   i4 = 0;
   i3 = i10 + 1 - i14 + i13 | 0;
   i2 = i5;
  }
  if (d6 > 2.2250738585072014e-308 ? (i2 - i4 + i3 | 0) < (i15 | 0) : 0) {
   i14 = i4;
   i13 = i2;
   i2 = i9;
  } else break;
 }
 i2 = HEAP32[i17 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < 4) {
  HEAP32[i17 >> 2] = i2 + -1;
  if ((i2 | 0) > 0) while (1) {
   i2 = i1 + 1 | 0;
   HEAP8[i1 >> 0] = 48;
   i19 = HEAP32[i17 >> 2] | 0;
   HEAP32[i17 >> 2] = i19 + -1;
   if ((i19 | 0) > 0) i1 = i2; else {
    i1 = i2;
    break;
   }
  }
  HEAP8[i1 >> 0] = 0;
 } else {
  i4 = i9 - i3 | 0;
  i2 = i1 + 1 | 0;
  HEAP8[i1 >> 0] = 69;
  i3 = HEAP32[i17 >> 2] | 0;
  if ((i3 | 0) < 0) {
   HEAP8[i2 >> 0] = 45;
   i3 = 0 - (HEAP32[i17 >> 2] | 0) | 0;
   i1 = i1 + 2 | 0;
   i5 = i4 + -2 | 0;
  } else {
   i1 = i2;
   i5 = i4 + -1 | 0;
  }
  if (!i3) i2 = 0; else {
   i4 = 0;
   while (1) {
    i2 = i4 + 1 | 0;
    HEAP8[i19 + i4 >> 0] = (i3 >>> 0) % 10 | 0 | 48;
    if (i3 >>> 0 < 10) break; else {
     i3 = (i3 >>> 0) / 10 | 0;
     i4 = i2;
    }
   }
  }
  if ((i5 | 0) <= (i2 | 0)) _UNITY_png_error(i18, gb + 351925 | 0);
  if ((i2 | 0) > 0) while (1) {
   i18 = i2;
   i2 = i2 + -1 | 0;
   i3 = i1 + 1 | 0;
   HEAP8[i1 >> 0] = HEAP8[i19 + i2 >> 0] | 0;
   if ((i18 | 0) <= 1) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  HEAP8[i1 >> 0] = 0;
 }
 STACKTOP = i20;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZN19CharacterController6CreateEPK9Rigidbody(i21, i1) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, d23 = 0.0, d24 = 0.0, d25 = 0.0, i26 = 0, f27 = f0, f28 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 144 | 0;
 i18 = i22 + 128 | 0;
 i5 = i22 + 120 | 0;
 i16 = i22;
 i10 = i16 + 104 | 0;
 HEAP32[i10 >> 2] = 1;
 i11 = i16 + 44 | 0;
 i6 = i16 + 56 | 0;
 i15 = i16 + 60 | 0;
 i7 = i16 + 64 | 0;
 i8 = i16 + 68 | 0;
 i9 = i16 + 72 | 0;
 i12 = i16 + 76 | 0;
 i1 = i16 + 8 | 0;
 i4 = i16 + 96 | 0;
 HEAP8[i12 + 16 >> 0] = 0;
 HEAP32[i16 >> 2] = gb + 111528 + 8;
 i14 = i16 + 112 | 0;
 i13 = i16 + 108 | 0;
 i17 = i16 + 116 | 0;
 HEAP32[i16 + 32 >> 2] = 0;
 HEAP32[i16 + 36 >> 2] = 1065353216;
 HEAP32[i16 + 40 >> 2] = 0;
 HEAP32[i7 >> 2] = 1092616192;
 HEAP32[i8 >> 2] = 1061997773;
 HEAP32[i9 >> 2] = 1069547520;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i16 + 48 >> 2] = 0;
 HEAP32[i16 + 52 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 f2 = Math_fround(+Math_cos(+Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i21 + 80 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274))));
 i19 = f2 < Math_fround(0.0);
 HEAPF32[i11 >> 2] = i19 ? Math_fround(0.0) : f2;
 HEAP32[i6 >> 2] = HEAP32[i21 + 76 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i21 + 84 >> 2];
 HEAP32[i16 + 100 >> 2] = i21;
 HEAPF32[i20 >> 2] = Math_fround(9.99999974e-06);
 i19 = i21 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i18, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i19 >> 2] | 0, gb + 28940 | 0) | 0);
 f2 = Math_fround(HEAPF32[i21 + 88 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i18 + 4 >> 2]));
 i26 = f2 < Math_fround(0.0);
 f3 = Math_fround(-f2);
 f2 = i26 ? f3 : f2;
 i26 = f2 < Math_fround(9.99999974e-06);
 f2 = i26 ? Math_fround(9.99999974e-06) : f2;
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 i26 = f3 < Math_fround(0.0);
 f27 = Math_fround(-f3);
 f3 = i26 ? f27 : f3;
 f27 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 i26 = f27 < Math_fround(0.0);
 f28 = Math_fround(-f27);
 f27 = i26 ? f28 : f27;
 f3 = Math_fround(Math_fround(HEAPF32[i21 + 92 >> 2]) * (f3 < f27 ? f27 : f3));
 f2 = Math_fround(f2 - Math_fround(f3 * Math_fround(2.0)));
 HEAPF32[i5 >> 2] = f2;
 i26 = f2 < Math_fround(9.99999974e-06);
 i5 = HEAP32[(i26 ? i20 : i5) >> 2] | 0;
 i26 = f3 < Math_fround(9.99999974e-06);
 HEAPF32[i13 >> 2] = i26 ? Math_fround(9.99999974e-06) : f3;
 HEAP32[i14 >> 2] = i5;
 __ZNK9Transform14TransformPointERK8Vector3f(i20, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i19 >> 2] | 0, gb + 28940 | 0) | 0, i21 + 96 | 0);
 d25 = +Math_fround(HEAPF32[i20 >> 2]);
 d24 = +Math_fround(HEAPF32[i20 + 4 >> 2]);
 d23 = +Math_fround(HEAPF32[i20 + 8 >> 2]);
 HEAPF64[i1 >> 3] = d25;
 HEAPF64[i16 + 16 >> 3] = d24;
 HEAPF64[i16 + 24 >> 3] = d23;
 i1 = __ZN14PhysicsManager20GetDefaultPxMaterialEv(__Z17GetPhysicsManagerv() | 0) | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i17 >> 2] = 1;
 HEAP32[i12 >> 2] = gb + 1452868;
 HEAP8[i16 + 92 >> 0] = 1;
 i17 = i21 + 60 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 if (i5) {
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
  HEAP32[i17 >> 2] = 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i4 = i21 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 i26 = (HEAP32[i10 >> 2] | 0) >>> 0 > 1 ? 1 : Math_fround(HEAPF32[i8 >> 2]) < Math_fround(0.0);
 i26 = i26 | Math_fround(HEAPF32[i9 >> 2]) < Math_fround(1.0);
 i26 = i26 | Math_fround(HEAPF32[i7 >> 2]) < Math_fround(0.0);
 i26 = i26 | Math_fround(HEAPF32[i11 >> 2]) < Math_fround(0.0);
 i26 = i26 | Math_fround(HEAPF32[i15 >> 2]) < Math_fround(0.0);
 if (!(i26 | Math_fround(HEAPF32[i6 >> 2]) <= Math_fround(0.0) | (i1 | 0) == 0)) {
  i1 = HEAP32[i16 + 80 >> 2] | 0;
  if ((i1 | 0) != 0 & (HEAP32[i12 >> 2] | 0) == 0) {
   HEAP32[i12 >> 2] = i1;
   i26 = _PxGetFoundation() | 0;
   i26 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 4 >> 2] | 0, i26 | 0) | 0;
   mftCall_viiiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, 2, gb + 733824 | 0, gb + 733919 | 0, 640);
  }
  f3 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f3 <= Math_fround(0.0))) {
   f2 = Math_fround(HEAPF32[i14 >> 2]);
   if (!(f2 <= Math_fround(0.0))) if (!(Math_fround(HEAPF32[i15 >> 2]) > Math_fround(Math_fround(f3 * Math_fround(2.0)) + f2))) {
    i1 = HEAP32[gb + 1457412 >> 2] | 0;
    i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i16 | 0) | 0;
    HEAP32[i17 >> 2] = i1;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
    mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i4 | 0, 1, 0) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 8 >> 2] = i21;
    if (i1) {
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i20 | 0, i1 | 0);
     i26 = HEAP32[i4 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 92 >> 2] | 0, i18 | 0, i26 | 0);
     i26 = HEAP32[(HEAP32[i19 >> 2] | 0) + 48 >> 2] | HEAP32[i20 >> 2] & -256;
     HEAP32[i20 >> 2] = i26;
     i1 = i21;
     HEAP32[i20 + 4 >> 2] = i1;
     HEAP32[i20 + 12 >> 2] = 0;
     HEAP32[i18 >> 2] = i26;
     HEAP32[i18 + 4 >> 2] = i1;
     HEAP32[i18 + 12 >> 2] = 0;
     i1 = HEAP32[i4 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i20 | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i18 | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1) {
      i19 = (HEAP8[i21 + 108 >> 0] | 0) == 0;
      mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i20 | 0, i1 | 0);
      i1 = i20 + 8 | 0;
      i26 = HEAP32[i1 >> 2] | 0;
      HEAP32[i1 >> 2] = i19 ? i26 | 16 : i26 & -17;
      i1 = HEAP32[i4 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i20 | 0);
      i1 = HEAP32[i4 >> 2] | 0;
     }
    }
    HEAP32[i21 + 68 >> 2] = i1;
    STACKTOP = i22;
    return;
   }
  }
 }
 if (!(__ZNK19CharacterController31ArePropertiesValidExplainErrorsEv(i21) | 0)) {
  STACKTOP = i22;
  return;
 }
 if (!i21) i1 = 0; else i1 = HEAP32[i21 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734024 | 0, 0, gb + 734039 | 0, 390, 1, i1, 0, 0);
 STACKTOP = i22;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i11, i18, i19, i13, i20, i14, i2, i15) {
 i11 = i11 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i22 + 12 | 0;
 i9 = i22 + 8 | 0;
 i16 = i22 + 4 | 0;
 i17 = i22;
 i1 = __ZNKSt3__28ios_base6getlocEv(i13) | 0;
 HEAP32[i10 >> 2] = i1;
 __THREW__ = 0;
 i12 = invoke_iii(fb + 1145 | 0, i10 | 0, gb + 1474556 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i22 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i22 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
 HEAP32[i20 >> 2] = 0;
 i8 = i12 + 8 | 0;
 i1 = 0;
 L4 : while (1) {
  i7 = (i2 | 0) != (i15 | 0);
  i3 = i1;
  while (1) {
   i1 = HEAP32[i18 >> 2] | 0;
   if (!(i7 & (i3 | 0) == 0)) break L4;
   i3 = i1;
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
    HEAP32[i18 >> 2] = 0;
    i1 = 0;
    i3 = 0;
   }
   i6 = (i1 | 0) == 0;
   i5 = HEAP32[i19 >> 2] | 0;
   i4 = i5;
   do if (!i5) i21 = 14; else {
    if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i4 = 0;
     i21 = 14;
     break;
    }
    if (!i6) {
     i21 = 15;
     break L4;
    }
   } while (0);
   if ((i21 | 0) == 14) {
    i21 = 0;
    if (i6) {
     i21 = 15;
     break L4;
    } else i5 = 0;
   }
   if ((mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, HEAP8[i2 >> 0] | 0, 0) | 0) << 24 >> 24 == 37) {
    i21 = 18;
    break;
   }
   i3 = HEAP8[i2 >> 0] | 0;
   if (i3 << 24 >> 24 > -1) {
    i4 = HEAP32[i8 >> 2] | 0;
    if (HEAP16[i4 + (i3 << 24 >> 24 << 1) >> 1] & 8192) {
     i21 = 27;
     break;
    }
   }
   i4 = i1 + 12 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i5 = i1 + 16 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i3 = HEAPU8[i3 >> 0] | 0;
   i6 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i3 & 255 | 0) | 0;
   if (i6 << 24 >> 24 == (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP8[i2 >> 0] | 0) | 0) << 24 >> 24) {
    i21 = 54;
    break;
   }
   HEAP32[i20 >> 2] = 4;
   i3 = 4;
  }
  L32 : do if ((i21 | 0) == 18) {
   i21 = 0;
   i7 = i2 + 1 | 0;
   if ((i7 | 0) == (i15 | 0)) {
    i21 = 19;
    break L4;
   }
   i5 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, HEAP8[i7 >> 0] | 0, 0) | 0;
   switch (i5 << 24 >> 24) {
   case 48:
   case 69:
    {
     i2 = i2 + 2 | 0;
     if ((i2 | 0) == (i15 | 0)) {
      i21 = 24;
      break L4;
     }
     i6 = i5;
     i1 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, HEAP8[i2 >> 0] | 0, 0) | 0;
     i2 = i7;
     break;
    }
   default:
    {
     i6 = 0;
     i1 = i5;
    }
   }
   i7 = HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0;
   HEAP32[i16 >> 2] = i3;
   HEAP32[i17 >> 2] = i4;
   HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i18 >> 2] = mftCall_iiiiiiiii(i7 | 0, i11 | 0, i9 | 0, i10 | 0, i13 | 0, i20 | 0, i14 | 0, i1 | 0, i6 | 0) | 0;
   i1 = i2 + 2 | 0;
  } else if ((i21 | 0) == 27) {
   while (1) {
    i21 = 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i15 | 0)) {
     i2 = i15;
     break;
    }
    i3 = HEAP8[i2 >> 0] | 0;
    if (i3 << 24 >> 24 <= -1) break;
    if (!(HEAP16[i4 + (i3 << 24 >> 24 << 1) >> 1] & 8192)) break; else i21 = 27;
   }
   i3 = i5;
   while (1) {
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
     HEAP32[i18 >> 2] = 0;
     i1 = 0;
    }
    i4 = (i1 | 0) == 0;
    do if (!i5) i21 = 40; else {
     if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i4) {
      i7 = i3;
      break;
     } else {
      i1 = i2;
      break L32;
     }
     if ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i3 = 0;
      i21 = 40;
      break;
     } else if (i4 ^ (i3 | 0) == 0) {
      i7 = i3;
      i5 = i3;
      break;
     } else {
      i1 = i2;
      break L32;
     }
    } while (0);
    if ((i21 | 0) == 40) {
     i21 = 0;
     if (i4) {
      i1 = i2;
      break L32;
     } else {
      i7 = i3;
      i5 = 0;
     }
    }
    i4 = i1 + 12 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i6 = i1 + 16 | 0;
    if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i3 = HEAPU8[i3 >> 0] | 0;
    if ((i3 & 255) << 24 >> 24 <= -1) {
     i1 = i2;
     break L32;
    }
    if (!(HEAP16[(HEAP32[i8 >> 2] | 0) + (i3 << 24 >> 24 << 1) >> 1] & 8192)) {
     i1 = i2;
     break L32;
    }
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) {
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i3 = i7;
     continue;
    } else {
     HEAP32[i4 >> 2] = i3 + 1;
     i3 = i7;
     continue;
    }
   }
  } else if ((i21 | 0) == 54) {
   i21 = 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0; else HEAP32[i4 >> 2] = i3 + 1;
   i1 = i2 + 1 | 0;
  } while (0);
  i2 = i1;
  i1 = HEAP32[i20 >> 2] | 0;
 }
 if ((i21 | 0) == 15) HEAP32[i20 >> 2] = 4; else if ((i21 | 0) == 19) HEAP32[i20 >> 2] = 4; else if ((i21 | 0) == 24) HEAP32[i20 >> 2] = 4;
 if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
  HEAP32[i18 >> 2] = 0;
  i1 = 0;
 }
 i2 = (i1 | 0) == 0;
 i3 = HEAP32[i19 >> 2] | 0;
 do if (!i3) i21 = 69; else {
  if ((HEAP32[i3 + 12 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0) == -1) {
   HEAP32[i19 >> 2] = 0;
   i21 = 69;
   break;
  }
  if (!i2) i21 = 70;
 } while (0);
 if ((i21 | 0) == 69) if (i2) i21 = 70;
 if ((i21 | 0) == 70) HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 2;
 STACKTOP = i22;
 return i1 | 0;
}

function __ZL22PrepareMeshRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i15 = HEAP32[i17 + 32 >> 2] | 0;
 i16 = HEAP32[i17 + 36 >> 2] | 0;
 i22 = HEAP32[i17 + 48 >> 2] | 0;
 i25 = i17 + 76 | 0;
 i19 = HEAP32[i25 >> 2] | 0;
 i26 = HEAP32[i19 + 16 >> 2] | 0;
 i19 = HEAP32[i19 + 1504 >> 2] | 0;
 i27 = i17 + 16 | 0;
 i28 = i17 + 4 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i18 = (i19 & 2 | 0) == 0;
 i19 = (i19 & 4 | 0) != 0;
 i20 = i17 + 12 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 if (i2 >>> 0 >= i16 >>> 0) {
  i27 = i1;
  HEAP32[i28 >> 2] = i27;
  return;
 }
 f21 = Math_fround(HEAPF32[gb + 1161204 >> 2]);
 i23 = i17 + 20 | 0;
 i24 = i17 + 24 | 0;
 while (1) {
  i10 = HEAP32[i15 + (i2 << 2) >> 2] | 0;
  i14 = HEAP32[i22 + (i10 * 24 | 0) >> 2] | 0;
  i14 = (i14 | 0) == 0 ? 0 : i14 + -32 | 0;
  i11 = i14 + 32 | 0;
  i2 = i14 + 268 | 0;
  i2 = HEAPU16[i2 >> 1] | HEAPU8[i2 + 2 >> 0] << 16;
  if ((i2 & 63 | 0) != 1) {
   i2 = 53;
   break;
  }
  do if (!(i19 & (i2 & 192 | 0) == 0)) {
   i12 = HEAP32[i14 + 340 >> 2] | 0;
   if (i12) {
    i13 = i12 + 36 | 0;
    i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
    do if (i2 | 0) {
     if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
      i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0;
      if (!i2) break;
      if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
       i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0;
       if (!i2) break;
       if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
        i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0;
        if (!i2) break;
        if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) break;
       }
      }
     }
     i9 = i12 + 44 | 0;
     HEAP8[i9 >> 0] = HEAP8[i9 >> 0] | 1;
    } while (0);
    i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
    if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0) {
     i9 = i12 + 44 | 0;
     HEAP8[i9 >> 0] = HEAP8[i9 >> 0] | 2;
    }
    if (HEAP8[i12 + 44 >> 0] & 3) {
     __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i17);
     break;
    }
    i8 = HEAP32[i14 + 344 >> 2] | 0;
    i9 = (i8 | 0) == 0;
    if (!i9) {
     i3 = i8 + 36 | 0;
     i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0;
     do if (i2 | 0) {
      if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
       i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
       if (!i2) break;
       if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
        i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0;
        if (!i2) break;
        if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
         i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0;
         if (!i2) break;
         if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) break;
        }
       }
      }
      i7 = i8 + 44 | 0;
      HEAP8[i7 >> 0] = HEAP8[i7 >> 0] | 1;
     } while (0);
     i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
     if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0) {
      i7 = i8 + 44 | 0;
      HEAP8[i7 >> 0] = HEAP8[i7 >> 0] | 2;
     }
     if (HEAP8[i8 + 44 >> 0] & 3) {
      __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i17);
      break;
     }
    }
    i7 = HEAP16[i14 + 272 >> 1] | 0;
    if ((i7 & 65535) > 255 | (i7 & 255) << 24 >> 24 != 0) {
     __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i17);
     break;
    }
    i7 = HEAP32[i17 >> 2] | 0;
    i5 = i7 + (i1 * 360 | 0) | 0;
    i6 = i14 + 36 | 0;
    i3 = HEAP16[i22 + (i10 * 24 | 0) + 14 >> 1] | 0;
    i2 = i3 & 65535;
    if (!(i3 << 16 >> 16)) f4 = f21; else {
     i3 = HEAP32[i22 + (i10 * 24 | 0) + 16 >> 2] | 0;
     if (!i3) f4 = f21; else {
      i10 = HEAPU16[i22 + (i10 * 24 | 0) + 12 >> 1] | 0;
      f4 = Math_fround(__ZN15LODGroupManager16CalculateLODFadeEjhf(i3, HEAP8[(HEAP32[i26 + (i10 * 12 | 0) >> 2] | 0) + i2 >> 0] | 0, Math_fround(HEAPF32[(HEAP32[i26 + (i10 * 12 | 0) + 4 >> 2] | 0) + (i2 << 2) >> 2])));
     }
    }
    __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode(i11, i6, f4, i5);
    if (!i18) __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode(i11, i6, (HEAP32[i25 >> 2] | 0) + 1572 | 0, i5);
    if (!(__ZN12BaseRenderer25FlattenSharedMaterialDataILb1EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i11, i27, i5) | 0)) {
     __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i17);
     break;
    }
    HEAP32[i7 + (i1 * 360 | 0) + 248 >> 2] = HEAP32[i12 + 228 >> 2];
    i2 = HEAP32[i23 >> 2] | 0;
    if ((i2 + 28 | 0) >>> 0 > (HEAP32[i24 >> 2] | 0) >>> 0) {
     __ZN22PerThreadPageAllocator14AcquireNewPageEj(i27, 32768);
     i2 = HEAP32[i23 >> 2] | 0;
    }
    i5 = (HEAP32[i27 >> 2] | 0) + i2 | 0;
    HEAP32[i23 >> 2] = i2 + 28;
    HEAP32[i7 + (i1 * 360 | 0) + 328 >> 2] = i5;
    i3 = HEAP32[i14 + 4 >> 2] | 0;
    i12 = HEAP32[i12 + 32 >> 2] | 0;
    i11 = i12 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    HEAP32[i5 >> 2] = i12;
    i13 = HEAP32[i13 >> 2] | 0;
    i12 = i13 + 4 | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
    HEAP32[i5 + 8 >> 2] = i13;
    if (i9) {
     HEAP32[i5 + 4 >> 2] = 0;
     i2 = 0;
    } else {
     i2 = HEAP32[i8 + 32 >> 2] | 0;
     i13 = i2 + 4 | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     HEAP32[i5 + 4 >> 2] = i2;
     i2 = HEAP32[i8 + 36 >> 2] | 0;
     i13 = i2 + 4 | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    }
    HEAP32[i5 + 12 >> 2] = i2;
    HEAP32[i5 + 16 >> 2] = i3;
    HEAP32[i5 + 20 >> 2] = 0;
    HEAP32[i5 + 24 >> 2] = 0;
    i2 = HEAPU8[i14 + 348 >> 0] ^ 1;
    i3 = i7 + (i1 * 360 | 0) + 348 | 0;
    HEAP32[i3 >> 2] = i2;
    if (!(HEAP16[i7 + (i1 * 360 | 0) + 182 >> 1] | 0)) HEAP32[i3 >> 2] = i2 | 2;
    HEAP32[i7 + (i1 * 360 | 0) + 340 >> 2] = fb + 492;
    HEAP32[i7 + (i1 * 360 | 0) + 332 >> 2] = fb + 211;
    HEAP32[i7 + (i1 * 360 | 0) + 344 >> 2] = fb + 2371;
    i1 = i1 + 1 | 0;
   }
  } while (0);
  i2 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
  HEAP32[i20 >> 2] = i2;
  if (i2 >>> 0 >= i16 >>> 0) {
   i2 = 53;
   break;
  }
 }
 if ((i2 | 0) == 53) {
  HEAP32[i28 >> 2] = i1;
  return;
 }
}

function __ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf(i16, i29, i28, i32) {
 i16 = i16 | 0;
 i29 = i29 | 0;
 i28 = i28 | 0;
 i32 = i32 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33;
 i30 = i29 + 4 | 0;
 i23 = i16 + 60 | 0;
 i24 = i16 + 56 | 0;
 i25 = i16 + 40 | 0;
 i26 = i31 + 16 | 0;
 i27 = i29 + 8 | 0;
 i17 = i16 + 44 | 0;
 i18 = i31 + 8 | 0;
 i19 = i31 + 12 | 0;
 i20 = i16 + 12 | 0;
 i21 = i16 + 16 | 0;
 i22 = i16 + 28 | 0;
 L1 : while (1) {
  i1 = HEAP32[i29 >> 2] | 0;
  i3 = HEAP32[i30 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) {
   i1 = i3 + (~((i3 + -32 - i1 | 0) >>> 5) << 5) | 0;
   HEAP32[i30 >> 2] = i1;
  }
  i4 = HEAP32[i23 >> 2] | 0;
  if ((i4 | 0) <= 0) {
   i1 = 0;
   i3 = 38;
   break;
  }
  i5 = HEAP32[i24 >> 2] | 0;
  i3 = 0;
  while (1) {
   if (1 << (i3 & 31) & HEAP32[i5 + (i3 >>> 5 << 2) >> 2] | 0) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i4 | 0)) {
    i1 = 0;
    i3 = 38;
    break L1;
   }
  }
  if ((i3 | 0) < 0) {
   i1 = 0;
   i3 = 38;
   break;
  }
  i7 = HEAP32[i25 >> 2] | 0;
  i5 = (i3 | 0) % (i7 | 0) | 0;
  i3 = (i3 | 0) / (i7 | 0) | 0;
  f14 = Math_fround(i5 | 0);
  f15 = Math_fround(i3 | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  if ((i5 | 0) < 0) i3 = 45; else {
   i4 = HEAP32[i20 >> 2] | 0;
   if ((i3 | 0) < 0 | (i4 | 0) <= (i5 | 0)) i3 = 45; else if ((HEAP32[i21 >> 2] | 0) > (i3 | 0)) {
    i3 = (Math_imul(i4, i3) | 0) + i5 | 0;
    i3 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31) | 0 ? 43 : 45;
   } else i3 = 45;
  }
  HEAP32[i28 >> 2] = i3;
  f10 = Math_fround(f14 + Math_fround(-1.0));
  f13 = f14;
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = i7;
  i12 = i7;
  L17 : while (1) {
   i11 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   HEAP32[i26 >> 2] = 0;
   HEAP32[i26 + 4 >> 2] = 0;
   HEAP32[i26 + 8 >> 2] = 0;
   HEAP32[i26 + 12 >> 2] = 0;
   i9 = i31;
   HEAP32[i9 >> 2] = i11;
   HEAP32[i9 + 4 >> 2] = i12;
   if ((i1 | 0) == (HEAP32[i27 >> 2] | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i29, i31); else {
    HEAPF32[i1 >> 2] = f13;
    HEAP32[i1 + 4 >> 2] = i12;
    HEAP32[i1 + 8 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i19 >> 2];
    i9 = i1 + 16 | 0;
    HEAP32[i9 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
    HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + 32;
   }
   f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = Math_fround(f2 - f13);
   f6 = Math_fround(f6 - f10);
   if (f2 > Math_fround(0.0)) i1 = 7; else i1 = (((f2 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
   i5 = f6 > Math_fround(0.0);
   i9 = (f6 < Math_fround(0.0)) << 31 >> 31;
   i9 = i1 - (i5 ? 1 : i9) | 0;
   i5 = HEAP32[gb + 38036 + (i9 << 2) >> 2] | 0;
   if ((i9 | 0) == 4) break;
   i7 = ~~f13;
   i8 = ~~f10;
   i1 = 0;
   while (1) {
    i9 = (i1 + i5 | 0) % 8 | 0;
    i3 = (HEAP32[gb + 38072 + (i9 << 3) >> 2] | 0) + i7 | 0;
    i9 = (HEAP32[gb + 38072 + (i9 << 3) + 4 >> 2] | 0) + i8 | 0;
    if ((i3 | 0) >= 0) {
     i4 = HEAP32[i25 >> 2] | 0;
     if (!((i9 | 0) < 0 | (i4 | 0) <= (i3 | 0))) if ((HEAP32[i17 >> 2] | 0) > (i9 | 0)) {
      i4 = (Math_imul(i4, i9) | 0) + i3 | 0;
      if (HEAP32[(HEAP32[i24 >> 2] | 0) + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31) | 0) break;
     }
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= 8) break L17;
   }
   f2 = Math_fround(i3 | 0);
   f6 = Math_fround(i9 | 0);
   f13 = Math_fround(Math_fround(Math_fround(f13 * f6) - Math_fround(f10 * f2)) * Math_fround(.5));
   HEAPF32[i32 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i32 >> 2]));
   if (f2 == f14 & f6 == f15) break;
   i3 = i12;
   f13 = f2;
   i4 = i11;
   i12 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = HEAP32[i30 >> 2] | 0;
  }
  __ZN19SpriteMeshGenerator7invmaskERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEE(i16, i29) | 0;
  f2 = Math_fround(HEAPF32[i32 >> 2]);
  if (!(Math_fround(Math_abs(Math_fround(f2))) < Math_fround(4.0))) {
   i3 = 30;
   break;
  }
  HEAPF32[i32 >> 2] = Math_fround(0.0);
 }
 if ((i3 | 0) == 30) {
  i1 = HEAP32[i28 >> 2] | 0;
  if (f2 < Math_fround(0.0) & (i1 | 0) == 43) i3 = 32; else if (f2 > Math_fround(0.0) & (i1 | 0) == 45) i3 = 32;
  if ((i3 | 0) == 32) {
   i3 = HEAP32[i29 >> 2] | 0;
   i1 = HEAP32[i30 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) {
    i1 = i1 + -32 | 0;
    if (i3 >>> 0 < i1 >>> 0) {
     do {
      i27 = HEAP32[i3 >> 2] | 0;
      i28 = HEAP32[i3 + 4 >> 2] | 0;
      i29 = HEAP32[i3 + 8 >> 2] | 0;
      i30 = HEAP32[i3 + 12 >> 2] | 0;
      i26 = i3 + 16 | 0;
      HEAP32[i31 >> 2] = HEAP32[i26 >> 2];
      HEAP32[i31 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
      HEAP32[i31 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
      HEAP32[i31 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
      HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
      HEAP32[i1 >> 2] = i27;
      HEAP32[i1 + 4 >> 2] = i28;
      HEAP32[i1 + 8 >> 2] = i29;
      HEAP32[i1 + 12 >> 2] = i30;
      i30 = i1 + 16 | 0;
      HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i30 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
      HEAP32[i30 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
      HEAP32[i30 + 12 >> 2] = HEAP32[i31 + 12 >> 2];
      i3 = i3 + 32 | 0;
      i1 = i1 + -32 | 0;
     } while (i3 >>> 0 < i1 >>> 0);
     f2 = Math_fround(HEAPF32[i32 >> 2]);
    }
   }
  }
  HEAPF32[i32 >> 2] = Math_fround(Math_abs(Math_fround(f2)));
  i32 = 1;
  STACKTOP = i33;
  return i32 | 0;
 } else if ((i3 | 0) == 38) {
  STACKTOP = i33;
  return i1 | 0;
 }
 return 0;
}

function __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i22, i21, i1, i4, i2, i19) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i20 = 0, i23 = 0, f24 = f0;
 i20 = i22 + 60 | 0;
 HEAP32[i20 >> 2] = 0;
 i23 = i4 + 12 | 0;
 f10 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i23 >> 2]);
 f18 = Math_fround(f10 * f16);
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f18 = Math_fround(f18 - Math_fround(f15 * f11));
 f18 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f18);
 f11 = Math_fround(Math_fround(f16 * f15) + Math_fround(f10 * f11));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i2 + 4 >> 2]));
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i1 >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f15 = Math_fround(f18 * f10);
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f11 * f16));
 f16 = Math_fround(Math_fround(f10 * f11) - Math_fround(f18 * f16));
 f18 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 i4 = HEAP32[i21 + 148 >> 2] | 0;
 do if ((i4 | 0) > 0) {
  f5 = Math_fround(-3402823469999999843913219.0e14);
  i1 = 0;
  i2 = 0;
  while (1) {
   f11 = Math_fround(f15 - Math_fround(HEAPF32[i21 + 20 + (i1 << 3) >> 2]));
   f3 = Math_fround(f16 - Math_fround(HEAPF32[i21 + 20 + (i1 << 3) + 4 >> 2]));
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i21 + 84 + (i1 << 3) >> 2]));
   f3 = Math_fround(f11 + Math_fround(f3 * Math_fround(HEAPF32[i21 + 84 + (i1 << 3) + 4 >> 2])));
   if (f3 > f18) {
    i1 = 23;
    break;
   }
   i17 = f3 > f5;
   f5 = i17 ? f3 : f5;
   i2 = i17 ? i1 : i2;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) {
    i1 = 4;
    break;
   }
  }
  if ((i1 | 0) == 4) {
   i17 = i2;
   i2 = f5 < Math_fround(1.1920929e-07);
   break;
  } else if ((i1 | 0) == 23) return;
 } else {
  i17 = 0;
  i2 = 1;
 } while (0);
 i14 = i17 + 1 | 0;
 i14 = (i14 | 0) < (i4 | 0) ? i14 : 0;
 i4 = HEAP32[i21 + 20 + (i17 << 3) >> 2] | 0;
 i12 = HEAP32[i21 + 20 + (i17 << 3) + 4 >> 2] | 0;
 i13 = HEAP32[i21 + 20 + (i14 << 3) >> 2] | 0;
 i14 = HEAP32[i21 + 20 + (i14 << 3) + 4 >> 2] | 0;
 if (i2) {
  HEAP32[i20 >> 2] = 1;
  HEAP32[i22 + 56 >> 2] = 1;
  i19 = i21 + 84 + (i17 << 3) | 0;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i20 = i22 + 40 | 0;
  HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i20 + 4 >> 2] = i21;
  f16 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f16 + (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f18 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = Math_fround(Math_fround(f18 + (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
  HEAPF32[i22 + 48 >> 2] = Math_fround(f16 * Math_fround(.5));
  HEAPF32[i22 + 52 >> 2] = f18;
  i20 = i23;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i23 = i22;
  HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 4 >> 2] = i21;
  HEAP32[i22 + 16 >> 2] = 0;
  return;
 }
 f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f15 - f3);
 f6 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f16 - f6);
 f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f5 - f3);
 f7 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f15 - f5);
 f11 = Math_fround(f16 - f7);
 if (Math_fround(Math_fround(f8 * f24) + Math_fround(f9 * Math_fround(f7 - f6))) <= Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9));
  if (f3 > Math_fround(f18 * f18)) return;
  HEAP32[i20 >> 2] = 1;
  HEAP32[i22 + 56 >> 2] = 1;
  i2 = i22 + 40 | 0;
  if (i19) {
   i19 = i21 + 84 + (i17 << 3) | 0;
   i20 = HEAP32[i19 + 4 >> 2] | 0;
   i21 = i2;
   HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i21 + 4 >> 2] = i20;
  } else {
   HEAPF32[i2 >> 2] = f8;
   i1 = i22 + 44 | 0;
   HEAPF32[i1 >> 2] = f9;
   f3 = Math_fround(Math_sqrt(Math_fround(f3)));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f24 = Math_fround(Math_fround(1.0) / f3);
    HEAPF32[i2 >> 2] = Math_fround(f8 * f24);
    HEAPF32[i1 >> 2] = Math_fround(f9 * f24);
   }
  }
  HEAP32[i22 + 48 >> 2] = i4;
  HEAP32[i22 + 52 >> 2] = i12;
  i20 = i23;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i23 = i22;
  HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 4 >> 2] = i21;
  HEAP32[i22 + 16 >> 2] = 0;
  return;
 }
 if (!(Math_fround(Math_fround(f10 * Math_fround(f3 - f5)) + Math_fround(f11 * Math_fround(f6 - f7))) <= Math_fround(0.0))) {
  f5 = Math_fround(Math_fround(f3 + f5) * Math_fround(.5));
  f3 = Math_fround(Math_fround(f6 + f7) * Math_fround(.5));
  f15 = Math_fround(f15 - f5);
  f24 = Math_fround(f16 - f3);
  i1 = i21 + 84 + (i17 << 3) | 0;
  f16 = Math_fround(f15 * Math_fround(HEAPF32[i1 >> 2]));
  if (Math_fround(f16 + Math_fround(f24 * Math_fround(HEAPF32[i21 + 84 + (i17 << 3) + 4 >> 2]))) > f18) return;
  HEAP32[i20 >> 2] = 1;
  HEAP32[i22 + 56 >> 2] = 1;
  i19 = i1;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i20 = i22 + 40 | 0;
  HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i20 + 4 >> 2] = i21;
  HEAPF32[i22 + 48 >> 2] = f5;
  HEAPF32[i22 + 52 >> 2] = f3;
  i20 = i23;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i23 = i22;
  HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 4 >> 2] = i21;
  HEAP32[i22 + 16 >> 2] = 0;
  return;
 }
 f3 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
 if (f3 > Math_fround(f18 * f18)) return;
 HEAP32[i20 >> 2] = 1;
 HEAP32[i22 + 56 >> 2] = 1;
 i2 = i22 + 40 | 0;
 if (i19) {
  i19 = i21 + 84 + (i17 << 3) | 0;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i2;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
 } else {
  HEAPF32[i2 >> 2] = f10;
  i1 = i22 + 44 | 0;
  HEAPF32[i1 >> 2] = f11;
  f3 = Math_fround(Math_sqrt(Math_fround(f3)));
  if (!(f3 < Math_fround(1.1920929e-07))) {
   f24 = Math_fround(Math_fround(1.0) / f3);
   HEAPF32[i2 >> 2] = Math_fround(f10 * f24);
   HEAPF32[i1 >> 2] = Math_fround(f11 * f24);
  }
 }
 HEAP32[i22 + 48 >> 2] = i13;
 HEAP32[i22 + 52 >> 2] = i14;
 i20 = i23;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i23 = i22;
 HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i23 + 4 >> 2] = i21;
 HEAP32[i22 + 16 >> 2] = 0;
 return;
}

function __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE(i23, i21) {
 i23 = i23 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 24 | 0;
 i18 = i24 + 16 | 0;
 i3 = i24 + 8 | 0;
 i2 = i24 + 76 | 0;
 i1 = i24 + 64 | 0;
 i22 = i24 + 56 | 0;
 i5 = i24 + 88 | 0;
 i17 = i24 + 44 | 0;
 i16 = i24 + 32 | 0;
 i20 = i24 + 28 | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 108 >> 2] | 0, i21 | 0) | 0;
 i6 = HEAP32[HEAP32[i21 + 88 >> 2] >> 2] | 0;
 if (Math_fround(+mftCall_fi(HEAP32[(HEAP32[i6 >> 2] | 0) + 132 >> 2] | 0, i6 | 0)) == Math_fround(0.0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 867, gb + 678735 | 0, i24);
  mftCall_vif(HEAP32[(HEAP32[i6 >> 2] | 0) + 128 >> 2] | 0, i6 | 0, 1.0);
 }
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i6 | 0);
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) i4 = 6; else if (Math_fround(HEAPF32[i2 + 4 >> 2]) == Math_fround(0.0)) i4 = 6; else if (Math_fround(HEAPF32[i2 + 8 >> 2]) == Math_fround(0.0)) i4 = 6;
 if ((i4 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 874, gb + 678833 | 0, i3);
  i15 = HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] | 0;
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
  mftCall_vii(i15 | 0, i6 | 0, i1 | 0);
 }
 if (Math_fround(HEAPF32[i6 + 252 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i6 + 256 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i6 + 260 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i6 + 264 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i6 + 268 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i6 + 272 >> 2]) != Math_fround(0.0); else i1 = 1; else i1 = 1; else i1 = 1; else i1 = 1; else i1 = 1;
 i14 = i23 + 16 | 0;
 __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i14, i6 + 48 | 0, 0);
 __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i6 + 20 | 0, i6);
 __ZN5physx3Scb5Scene15addArticulationERNS0_12ArticulationE(i14, i21 + 12 | 0);
 i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 228 >> 2] | 0, i6 | 0) | 0;
 if (i2 | 0) __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE(i14, i2 + 8 | 0);
 if (HEAP32[i6 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i6 + 12 | 0);
 i3 = i7 << 2;
 i13 = i3 >>> 0 > 1024;
 i15 = i22 + 4 | 0;
 HEAP8[i15 >> 0] = i13 & 1;
 if (i13) {
  i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i5, i3, gb + 678666 | 0, 890) | 0;
  HEAP32[i22 >> 2] = i2;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i22 >> 2] = i2;
 }
 HEAP32[i2 >> 2] = i6;
 i8 = i7 + -1 | 0;
 if (i8) {
  i9 = i16 + 4 | 0;
  i10 = i16 + 8 | 0;
  i11 = i17 + 4 | 0;
  i12 = i17 + 8 | 0;
  i13 = 0;
  i2 = 1;
  do {
   i5 = HEAP32[(HEAP32[i22 >> 2] | 0) + (i13 << 2) >> 2] | 0;
   if (!(HEAP32[i5 + 324 >> 2] | 0)) i6 = 0; else i6 = HEAP32[i5 + 320 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 232 >> 2] | 0, i5 | 0) | 0) {
    i7 = 0;
    do {
     i4 = HEAP32[i6 + (i7 << 2) >> 2] | 0;
     if (Math_fround(+mftCall_fi(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0)) == Math_fround(0.0)) {
      __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 909, gb + 678735 | 0, i18);
      mftCall_vif(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0, 1.0);
     }
     mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i17 | 0, i4 | 0);
     i3 = Math_fround(HEAPF32[i17 >> 2]) == Math_fround(0.0);
     i3 = i3 | Math_fround(HEAPF32[i11 >> 2]) == Math_fround(0.0);
     if (i3 | Math_fround(HEAPF32[i12 >> 2]) == Math_fround(0.0)) {
      __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 916, gb + 678833 | 0, i19);
      i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0;
      HEAPF32[i16 >> 2] = Math_fround(1.0);
      HEAPF32[i9 >> 2] = Math_fround(1.0);
      HEAPF32[i10 >> 2] = Math_fround(1.0);
      mftCall_vii(i3 | 0, i4 | 0, i16 | 0);
     }
     if (i1) i1 = 1; else {
      do if (Math_fround(HEAPF32[i4 + 252 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i4 + 256 >> 2]) == Math_fround(0.0)) {
       if (!(Math_fround(HEAPF32[i4 + 260 >> 2]) == Math_fround(0.0))) {
        i1 = 0;
        break;
       }
       if (!(Math_fround(HEAPF32[i4 + 264 >> 2]) == Math_fround(0.0))) {
        i1 = 0;
        break;
       }
       if (!(Math_fround(HEAPF32[i4 + 268 >> 2]) == Math_fround(0.0))) {
        i1 = 0;
        break;
       }
       i1 = Math_fround(HEAPF32[i4 + 272 >> 2]) == Math_fround(0.0);
      } else i1 = 0; else i1 = 0; while (0);
      i1 = i1 ^ 1;
     }
     __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i14, i4 + 48 | 0, 0);
     __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i4 + 20 | 0, i4);
     i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 228 >> 2] | 0, i4 | 0) | 0;
     if (i3 | 0) __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE(i14, i3 + 8 | 0);
     if (HEAP32[i4 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i4 + 12 | 0);
     HEAP32[(HEAP32[i22 >> 2] | 0) + (i2 << 2) >> 2] = i4;
     i2 = i2 + 1 | 0;
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 232 >> 2] | 0, i5 | 0) | 0) >>> 0);
   }
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i8 | 0));
 }
 if (!(Math_fround(HEAPF32[i21 + 60 >> 2]) != Math_fround(0.0) | i1 ^ 1)) __ZN5physx14NpArticulation14wakeUpInternalEbb(i21, 1, 0);
 i1 = i23 + 3564 | 0;
 HEAP32[i20 >> 2] = i21;
 i2 = i23 + 3568 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i23 + 3572 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i21;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i20) | 0;
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i24;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i22, HEAP32[i22 >> 2] | 0);
 STACKTOP = i24;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN15AnimationBinder19RemoveUnboundCurvesER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER13dynamic_arrayI20BoundCurveDeprecatedLj4EE(i8, i14) {
 i8 = i8 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i9 = i19 + 44 | 0;
 i18 = i19 + 24 | 0;
 i10 = i19 + 12 | 0;
 i3 = i8 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i8 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i15 = i14 + 12 | 0;
 if ((i1 - i2 | 0) == (HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 if ((i1 | 0) == (i2 | 0)) {
  i1 = i14 + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i14 + 4 | 0);
   HEAP32[i14 >> 2] = 0;
  }
  HEAP32[i14 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i19;
  return;
 }
 HEAP32[i18 >> 2] = 0;
 i11 = i18 + 12 | 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i12 = i13;
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = i17;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = HEAP32[i16 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i16 >> 2] = i1;
  HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 * 24 | 0, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i18 >> 2] = i12;
  break;
 } while (0);
 HEAP32[i13 >> 2] = 0;
 i12 = i13 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i7 = 0; else {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i13, i1);
  if (!(HEAP32[i15 >> 2] | 0)) i7 = 0; else {
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i18 >> 2] | 0;
   i1 = 0;
   i3 = 0;
   do {
    HEAP32[i4 + (i3 << 2) >> 2] = i1;
    i2 = HEAP32[i14 >> 2] | 0;
    if (HEAP32[i2 + (i3 * 24 | 0) + 4 >> 2] | 0) {
     i6 = i2 + (i3 * 24 | 0) | 0;
     i7 = i5 + (i1 * 24 | 0) | 0;
     HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     i1 = i1 + 1 | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
   i7 = i1;
  }
 }
 i2 = i8 + 60 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i8 + 64 | 0;
 i6 = i4 + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i10 + 8 >> 2] = i6;
 __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i10);
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 i6 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i10 >> 2] = i8;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i6;
 i5 = i10 + 8 | 0;
 HEAP32[i5 >> 2] = i6;
 __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i10);
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
  i20 = i1 + 20 | 0;
  HEAP32[i20 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + (HEAP32[i20 >> 2] << 2) >> 2];
  HEAP32[i6 >> 2] = i1 + 24;
  __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i9);
  i20 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i10 >> 2] = i8;
  HEAP32[i4 >> 2] = i20;
  HEAP32[i5 >> 2] = i20;
  __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i10);
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i17, HEAP32[i14 + 8 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  i1 = i14;
  i4 = i14 + 4 | 0;
  i2 = 0;
 } else {
  i4 = i14 + 4 | 0;
  __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i4, HEAP32[i18 + 8 >> 2] | 0);
  i1 = i14;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i20 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = i2;
 HEAP32[i1 >> 2] = i20;
 i3 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i3;
 i3 = i14 + 16 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i2 = i17;
 i11 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i4;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i17;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i4;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i15 >> 2] = i7;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i20;
 do if ((i1 & 2147483647) >>> 0 < i7 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i7 * 24 | 0, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i20 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i14 >> 2] = i20;
  break;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i12 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
  HEAP32[i18 >> 2] = 0;
 }
 STACKTOP = i19;
 return;
}

function __ZNK9SubModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i49, i50, i51, i52, i53, i54) {
 i1 = i1 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, f59 = f0, f60 = f0, f61 = f0;
 i48 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i45 = i48 + 56 | 0;
 i46 = i48 + 40 | 0;
 i47 = i48 + 24 | 0;
 i16 = i48;
 if ((i52 | 0) == (i53 | 0)) {
  STACKTOP = i48;
  return;
 }
 i17 = i50 + 412 | 0;
 if (!(HEAP32[i17 >> 2] | 0)) {
  STACKTOP = i48;
  return;
 }
 i18 = i50 + 408 | 0;
 i19 = i52 + 1 | 0;
 i20 = i52 + 2 | 0;
 i21 = i52 + 3 | 0;
 i22 = i52 >>> 0 < i53 >>> 0;
 i23 = i51 + 520 | 0;
 i24 = i51 + 540 | 0;
 i25 = i45 + 4 | 0;
 i26 = i45 + 8 | 0;
 i27 = i45 + 12 | 0;
 i28 = i46 + 4 | 0;
 i29 = i46 + 8 | 0;
 i30 = i46 + 12 | 0;
 i31 = i47 + 4 | 0;
 i32 = i47 + 8 | 0;
 i33 = i47 + 12 | 0;
 i34 = i50 + 496 | 0;
 i35 = i16 + 4 | 0;
 i36 = i16 + 8 | 0;
 i37 = i16 + 12 | 0;
 i38 = i16 + 16 | 0;
 i39 = i16 + 20 | 0;
 i15 = 0;
 do {
  i1 = HEAP32[i18 >> 2] | 0;
  i40 = i1 + (i15 * 600 | 0) | 0;
  f41 = Math_fround(HEAPF32[i1 + (i15 * 600 | 0) + 584 >> 2]);
  f42 = Math_fround(HEAPF32[i1 + (i15 * 600 | 0) + 588 >> 2]);
  i43 = i15 >>> 0 < 2;
  if (i22) {
   i44 = i1 + (i15 * 600 | 0) + 80 | 0;
   i13 = i1 + (i15 * 600 | 0) + 344 | 0;
   i14 = i51 + 560 + (i15 * 20 | 0) | 0;
   i9 = i52;
   i10 = i20;
   i11 = i21;
   i12 = i19;
   while (1) {
    i57 = (HEAP32[i23 >> 2] | 0) + (i9 << 2) | 0;
    f61 = Math_fround(HEAPF32[i57 >> 2]);
    f60 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f59 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f61 = Math_fround(f61 * Math_fround(.00999999977));
    f60 = Math_fround(f60 * Math_fround(.00999999977));
    f59 = Math_fround(f59 * Math_fround(.00999999977));
    f6 = Math_fround(Math_fround(HEAPF32[i57 + 12 >> 2]) * Math_fround(.00999999977));
    i57 = (HEAP32[i24 >> 2] | 0) + (i9 << 2) | 0;
    f3 = Math_fround(HEAPF32[i57 >> 2]);
    f4 = Math_fround(HEAPF32[i57 + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i57 + 8 >> 2]);
    f3 = Math_fround(Math_fround(f61 / f3) - f41);
    f4 = Math_fround(Math_fround(f60 / f4) - f41);
    f5 = Math_fround(Math_fround(f59 / f5) - f41);
    f6 = Math_fround(Math_fround(f6 / Math_fround(HEAPF32[i57 + 12 >> 2])) - f41);
    HEAPF32[i45 >> 2] = f3;
    HEAPF32[i25 >> 2] = f4;
    HEAPF32[i26 >> 2] = f5;
    HEAPF32[i27 >> 2] = f6;
    i57 = !(f3 >= f42) & f3 >= Math_fround(0.0);
    i1 = i57 << 31 >> 31;
    i58 = !(f4 >= f42) & f4 >= Math_fround(0.0);
    i2 = i58 << 31 >> 31;
    i56 = !(f5 >= f42) & f5 >= Math_fround(0.0);
    i7 = i56 << 31 >> 31;
    i55 = !(f6 >= f42) & f6 >= Math_fround(0.0);
    i8 = i55 << 31 >> 31;
    HEAP32[i46 >> 2] = i1;
    HEAP32[i28 >> 2] = i2;
    HEAP32[i29 >> 2] = i7;
    HEAP32[i30 >> 2] = i8;
    if (i58 | i57 | i56 | i55) {
     f61 = Math_fround(HEAPF32[i44 >> 2]);
     f61 = Math_fround(f61 + Math_fround(HEAPF32[i13 >> 2]));
     f3 = Math_fround(f3 * f61);
     f59 = Math_fround(f61 * f4);
     f60 = Math_fround(f61 * f5);
     f61 = Math_fround(f61 * f6);
     f59 = Math_fround(f59 - Math_fround(Math_floor(Math_fround(f59))));
     f60 = Math_fround(f60 - Math_fround(Math_floor(Math_fround(f60))));
     f61 = Math_fround(f61 - Math_fround(Math_floor(Math_fround(f61))));
     HEAPF32[i47 >> 2] = Math_fround(f3 - Math_fround(Math_floor(Math_fround(f3))));
     HEAPF32[i31 >> 2] = f59;
     HEAPF32[i32 >> 2] = f60;
     HEAPF32[i33 >> 2] = f61;
     i1 = (i9 | 0) < (i53 | 0) ? i1 : 0;
     HEAP32[i46 >> 2] = i1;
     HEAP32[i28 >> 2] = (i12 | 0) < (i53 | 0) ? i2 : 0;
     HEAP32[i29 >> 2] = (i10 | 0) < (i53 | 0) ? i7 : 0;
     HEAP32[i30 >> 2] = (i11 | 0) < (i53 | 0) ? i8 : 0;
     L15 : do if (i43) {
      i2 = 0;
      while (1) {
       if (i1 | 0) {
        i58 = HEAP32[i34 >> 2] | 0;
        HEAPF32[i16 >> 2] = Math_fround(0.0);
        HEAPF32[i35 >> 2] = Math_fround(0.0);
        HEAP32[i36 >> 2] = i58;
        i58 = (Math_imul(i58, 1812433253) | 0) + 1 | 0;
        HEAP32[i37 >> 2] = i58;
        i58 = (Math_imul(i58, 1812433253) | 0) + 1 | 0;
        HEAP32[i38 >> 2] = i58;
        HEAP32[i39 >> 2] = (Math_imul(i58, 1812433253) | 0) + 1;
        i58 = i2 + i9 | 0;
        HEAP32[i35 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + (i58 << 2) >> 2];
        f61 = Math_fround(HEAPF32[i45 + (i2 << 2) >> 2]);
        __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i16, i40, i49, i50, i51, 0, i15, i58, f61, Math_fround(HEAPF32[i54 + (i2 << 2) >> 2]), f42);
        HEAP32[(HEAP32[i14 >> 2] | 0) + (i58 << 2) >> 2] = HEAP32[i35 >> 2];
       }
       i1 = i2 + 1 | 0;
       if ((i1 | 0) == 4) break L15;
       i2 = i1;
       i1 = HEAP32[i46 + (i1 << 2) >> 2] | 0;
      }
     } else {
      i2 = 0;
      while (1) {
       if (i1 | 0) {
        i58 = HEAP32[i34 >> 2] | 0;
        HEAPF32[i16 >> 2] = Math_fround(0.0);
        HEAP32[i36 >> 2] = i58;
        i58 = (Math_imul(i58, 1812433253) | 0) + 1 | 0;
        HEAP32[i37 >> 2] = i58;
        i58 = (Math_imul(i58, 1812433253) | 0) + 1 | 0;
        HEAP32[i38 >> 2] = i58;
        HEAP32[i39 >> 2] = (Math_imul(i58, 1812433253) | 0) + 1;
        HEAP32[i35 >> 2] = HEAP32[i47 + (i2 << 2) >> 2];
        f61 = Math_fround(HEAPF32[i45 + (i2 << 2) >> 2]);
        __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i16, i40, i49, i50, i51, 0, i15, i2 + i9 | 0, f61, Math_fround(HEAPF32[i54 + (i2 << 2) >> 2]), f42);
       }
       i1 = i2 + 1 | 0;
       if ((i1 | 0) == 4) break L15;
       i2 = i1;
       i1 = HEAP32[i46 + (i1 << 2) >> 2] | 0;
      }
     } while (0);
    }
    i9 = i9 + 4 | 0;
    if (i9 >>> 0 >= i53 >>> 0) break; else {
     i10 = i10 + 4 | 0;
     i11 = i11 + 4 | 0;
     i12 = i12 + 4 | 0;
    }
   }
  }
  i15 = i15 + 1 | 0;
 } while (i15 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
 STACKTOP = i48;
 return;
}

function __ZN5physx2Gu27generatedContactsEEContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE(i7, i6, i1, i5, i48, i50, i51, i4, i49) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i48 = i48 | 0;
 i50 = i50 | 0;
 i51 = i51 | 0;
 i4 = i4 | 0;
 i49 = i49 | 0;
 var i2 = 0, i3 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i52 = 0, i53 = 0;
 i52 = STACKTOP;
 i3 = (HEAP32[i6 + 32 >> 2] | 0) + (HEAPU16[i1 + 16 >> 1] | 0) | 0;
 i47 = i1 + 18 | 0;
 i2 = HEAPU8[i47 >> 0] | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * ((i2 << 4) + 16 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i1 + 15 & -16;
 mftCall_viiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i3 | 0, i2 | 0, HEAP32[i6 + 28 >> 2] | 0, i46 | 0);
 f38 = Math_fround(HEAPF32[i7 + 128 >> 2]);
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP8[i47 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  STACKTOP = i52;
  return;
 }
 i39 = i49 + 4 | 0;
 i40 = i49 + 8 | 0;
 i41 = i7 + 96 | 0;
 i42 = i7 + 100 | 0;
 i43 = i7 + 104 | 0;
 i44 = i7 + 112 | 0;
 i45 = i7 + 116 | 0;
 i4 = i7 + 120 | 0;
 i5 = i48 + 48 | 0;
 i6 = i48 + 52 | 0;
 i7 = i48 + 56 | 0;
 i30 = i48 + 4 | 0;
 i31 = i48 + 8 | 0;
 i32 = i48 + 16 | 0;
 i33 = i48 + 20 | 0;
 i34 = i48 + 24 | 0;
 i35 = i48 + 32 | 0;
 i36 = i48 + 36 | 0;
 i37 = i48 + 40 | 0;
 i1 = i2;
 i2 = (i2 & 255) + -1 | 0;
 i3 = 0;
 while (1) {
  f24 = Math_fround(HEAPF32[i46 + (i2 << 4) >> 2]);
  f25 = Math_fround(HEAPF32[i46 + (i2 << 4) + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i46 + (i2 << 4) + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i46 + (i3 << 4) >> 2]);
  f22 = Math_fround(HEAPF32[i46 + (i3 << 4) + 4 >> 2]);
  f23 = Math_fround(HEAPF32[i46 + (i3 << 4) + 8 >> 2]);
  f24 = Math_fround(f24 - f21);
  f25 = Math_fround(f25 - f22);
  f26 = Math_fround(f26 - f23);
  f27 = Math_fround(HEAPF32[i49 >> 2]);
  f28 = Math_fround(HEAPF32[i39 >> 2]);
  f29 = Math_fround(HEAPF32[i40 >> 2]);
  f11 = Math_fround(Math_fround(f25 * f29) - Math_fround(f26 * f28));
  f12 = Math_fround(Math_fround(f26 * f27) - Math_fround(f24 * f29));
  f13 = Math_fround(Math_fround(f24 * f28) - Math_fround(f25 * f27));
  f14 = Math_fround(Math_fround(f23 * f13) + Math_fround(Math_fround(f21 * f11) + Math_fround(f22 * f12)));
  f15 = Math_fround(HEAPF32[i41 >> 2]);
  f18 = Math_fround(HEAPF32[i42 >> 2]);
  f20 = Math_fround(HEAPF32[i43 >> 2]);
  f16 = Math_fround(Math_fround(Math_fround(f15 * f11) + Math_fround(f12 * f18)) + Math_fround(f13 * f20));
  f8 = Math_fround(HEAPF32[i44 >> 2]);
  f9 = Math_fround(HEAPF32[i45 >> 2]);
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  if (!(Math_fround(Math_fround(f16 - f14) * Math_fround(Math_fround(Math_fround(Math_fround(f11 * f8) + Math_fround(f12 * f9)) + Math_fround(f13 * f10)) - f14)) > Math_fround(0.0))) {
   f19 = Math_fround(f8 - f15);
   f17 = Math_fround(f9 - f18);
   f9 = Math_fround(f10 - f20);
   f8 = Math_fround(Math_fround(Math_fround(f11 * f19) + Math_fround(f12 * f17)) + Math_fround(f13 * f9));
   if (!(f8 == Math_fround(0.0))) {
    f14 = Math_fround(Math_fround(f14 - f16) / f8);
    f16 = Math_fround(f15 + Math_fround(f19 * f14));
    f15 = Math_fround(f18 + Math_fround(f17 * f14));
    f14 = Math_fround(f20 + Math_fround(f9 * f14));
    f20 = Math_fround(Math_fround(f28 * f9) - Math_fround(f29 * f17));
    f12 = Math_fround(Math_fround(f29 * f19) - Math_fround(f27 * f9));
    f19 = Math_fround(Math_fround(f27 * f17) - Math_fround(f28 * f19));
    f8 = Math_fround(f16 - f21);
    f9 = Math_fround(f15 - f22);
    f11 = Math_fround(f14 - f23);
    f12 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(Math_fround(f20 * f8) + Math_fround(f12 * f9))) / Math_fround(Math_fround(f26 * f19) + Math_fround(Math_fround(f24 * f20) + Math_fround(f25 * f12))));
    if (!(f12 > Math_fround(1.005) | f12 < Math_fround(-.00499999989))) {
     f13 = Math_fround(f8 - Math_fround(f24 * f12));
     f10 = Math_fround(f9 - Math_fround(f25 * f12));
     f9 = Math_fround(f11 - Math_fround(f26 * f12));
     f8 = Math_fround(Math_fround(f29 * f9) + Math_fround(Math_fround(f27 * f13) + Math_fround(f28 * f10)));
     if (f38 >= f8) {
      f27 = Math_fround(f16 - f13);
      f28 = Math_fround(f15 - f10);
      f29 = Math_fround(f14 - f9);
      i1 = HEAP32[i51 >> 2] | 0;
      f22 = Math_fround(HEAPF32[i5 >> 2]);
      f23 = Math_fround(HEAPF32[i6 >> 2]);
      f22 = Math_fround(f16 - f22);
      f23 = Math_fround(f15 - f23);
      f26 = Math_fround(f14 - Math_fround(HEAPF32[i7 >> 2]));
      f24 = Math_fround(f22 * Math_fround(HEAPF32[i48 >> 2]));
      f24 = Math_fround(f24 + Math_fround(f23 * Math_fround(HEAPF32[i30 >> 2])));
      f24 = Math_fround(f24 + Math_fround(f26 * Math_fround(HEAPF32[i31 >> 2])));
      f25 = Math_fround(f22 * Math_fround(HEAPF32[i32 >> 2]));
      f25 = Math_fround(f25 + Math_fround(f23 * Math_fround(HEAPF32[i33 >> 2])));
      f25 = Math_fround(f25 + Math_fround(f26 * Math_fround(HEAPF32[i34 >> 2])));
      f22 = Math_fround(f22 * Math_fround(HEAPF32[i35 >> 2]));
      f23 = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i36 >> 2])));
      f26 = Math_fround(f23 + Math_fround(f26 * Math_fround(HEAPF32[i37 >> 2])));
      HEAPF32[i50 + (i1 * 48 | 0) >> 2] = f24;
      HEAPF32[i50 + (i1 * 48 | 0) + 4 >> 2] = f25;
      HEAPF32[i50 + (i1 * 48 | 0) + 8 >> 2] = f26;
      HEAPF32[i50 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
      i1 = HEAP32[i51 >> 2] | 0;
      HEAPF32[i50 + (i1 * 48 | 0) + 16 >> 2] = f27;
      HEAPF32[i50 + (i1 * 48 | 0) + 20 >> 2] = f28;
      HEAPF32[i50 + (i1 * 48 | 0) + 24 >> 2] = f29;
      HEAPF32[i50 + (i1 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
      i1 = HEAP32[i51 >> 2] | 0;
      HEAP32[i51 >> 2] = i1 + 1;
      i53 = HEAP32[i39 >> 2] | 0;
      i2 = HEAP32[i40 >> 2] | 0;
      HEAP32[i50 + (i1 * 48 | 0) + 32 >> 2] = HEAP32[i49 >> 2];
      HEAP32[i50 + (i1 * 48 | 0) + 36 >> 2] = i53;
      HEAP32[i50 + (i1 * 48 | 0) + 40 >> 2] = i2;
      HEAPF32[i50 + (i1 * 48 | 0) + 44 >> 2] = f8;
      i1 = HEAP8[i47 >> 0] | 0;
     }
    }
   }
  }
  i2 = i3 + 1 | 0;
  if (i2 >>> 0 < (i1 & 255) >>> 0) {
   i53 = i3;
   i3 = i2;
   i2 = i53;
  } else break;
 }
 STACKTOP = i52;
 return;
}

function __ZN7Terrain8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 HEAP32[i6 >> 2] = HEAP32[i7 + 48 >> 2];
 __ZN4PPtrI11TerrainDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i8);
 i1 = i7 + 64 | 0;
 i9 = i8 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i8 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 89 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 90 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i5 = i7 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i5 = i7 + 96 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 HEAP32[i6 >> 2] = HEAP32[i7 + 108 >> 2];
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i8);
 i5 = i7 + 152 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP16[i1 >> 1] = HEAP16[i5 >> 1] | 0;
  HEAP32[i9 >> 2] = i2;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i5 + 2 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i7 + 120 | 0, gb + 931957 | 0, 8388609);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i7 + 136 | 0, gb + 931980 | 0, 8388609);
 i1 = i7 + 188 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = i7 + 156 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i10, gb + 932036 | 0, 8388609);
  i10 = i7 + 172 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i10, gb + 932050 | 0, 8388609);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = i7 + 156 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i10, gb + 932036 | 0, 8388609);
  i10 = i7 + 172 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i8, i10, gb + 932050 | 0, 8388609);
  STACKTOP = i11;
  return;
 }
}

function __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe(i1, i20, i10, i21, i22, d5) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 d5 = +d5;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 1008 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i24 + 8 | 0;
 i2 = i24;
 i1 = i24 + 896 | 0;
 i7 = i24 + 888 | 0;
 i3 = i24 + 488 | 0;
 i28 = i24 + 480 | 0;
 i14 = i24 + 892 | 0;
 i15 = i24 + 476 | 0;
 i16 = i24 + 472 | 0;
 i25 = i24 + 460 | 0;
 i26 = i24 + 448 | 0;
 i27 = i24 + 436 | 0;
 i12 = i24 + 432 | 0;
 i6 = i24 + 32 | 0;
 i17 = i24 + 24 | 0;
 i18 = i24 + 20 | 0;
 i19 = i24 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAPF64[i13 >> 3] = d5;
 i1 = _snprintf(i1, 100, gb + 1080070 | 0, i13) | 0;
 do if (i1 >>> 0 > 99) {
  __THREW__ = 0;
  i1 = invoke_i(fb + 314 | 0) | 0;
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i2 = 0;
   i1 = 0;
   i23 = 8;
  } else {
   __THREW__ = 0;
   HEAPF64[i2 >> 3] = d5;
   i4 = invoke_iiiii(fb + 207 | 0, i7 | 0, i1 | 0, gb + 1080070 | 0, i2 | 0) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i2 = 0;
    i1 = 0;
    i23 = 8;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i2 = 0;
      i1 = 0;
      i23 = 8;
      break;
     }
     i1 = HEAP32[i7 >> 2] | 0;
    }
    i3 = _malloc(i4 << 2) | 0;
    i2 = i3;
    if (!i3) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) i23 = 8; else {
      i3 = 0;
      i9 = i4;
      i11 = i2;
      i23 = 11;
     }
    } else {
     i9 = i4;
     i11 = i2;
     i23 = 11;
    }
   }
  }
 } else {
  i9 = i1;
  i11 = 0;
  i1 = 0;
  i23 = 11;
 } while (0);
 if ((i23 | 0) == 11) {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2804 | 0, i21 | 0) | 0;
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i2 = i11;
   i23 = 8;
  } else {
   HEAP32[i28 >> 2] = i2;
   __THREW__ = 0;
   i8 = invoke_iii(fb + 1145 | 0, i28 | 0, gb + 1474588 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   do if (i4 & 1) {
    i3 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    i4 = HEAP32[i7 >> 2] | 0;
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 48 >> 2] | 0, i8 | 0, i4 | 0, i4 + i9 | 0, i3 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    if (!i9) i7 = 0; else i7 = (HEAP8[HEAP32[i7 >> 2] >> 0] | 0) == 45;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i25 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i26 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i26 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i27 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i27 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_viiiiiiiiii(fb + 14 | 0, i10 | 0, i7 | 0, i28 | 0, i14 | 0, i15 | 0, i16 | 0, i25 | 0, i26 | 0, i27 | 0, i12 | 0);
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i4 = HEAP32[i12 >> 2] | 0;
     if ((i9 | 0) > (i4 | 0)) {
      i10 = HEAP8[i27 + 8 + 3 >> 0] | 0;
      i2 = HEAP8[i26 + 8 + 3 >> 0] | 0;
      i2 = (i10 << 24 >> 24 < 0 ? HEAP32[i27 + 4 >> 2] | 0 : i10 & 255) + (i9 - i4 << 1 | 1) + (i2 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i2 & 255) | 0;
     } else {
      i10 = HEAP8[i27 + 8 + 3 >> 0] | 0;
      i2 = HEAP8[i26 + 8 + 3 >> 0] | 0;
      i2 = (i10 << 24 >> 24 < 0 ? HEAP32[i27 + 4 >> 2] | 0 : i10 & 255) + 2 + (i2 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i2 & 255) | 0;
     }
     i2 = i2 + i4 | 0;
     do if (i2 >>> 0 > 100) {
      i6 = _malloc(i2 << 2) | 0;
      i2 = i6;
      if (!i6) {
       __THREW__ = 0;
       invoke_v(fb + 459 | 0);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i3 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        break;
       } else {
        i6 = 0;
        i4 = HEAP32[i12 >> 2] | 0;
        i23 = 37;
        break;
       }
      } else i23 = 37;
     } else {
      i2 = 0;
      i23 = 37;
     } while (0);
     if ((i23 | 0) == 37) {
      __THREW__ = 0;
      invoke_viiiiiiiiiiiiiii(fb + 4 | 0, i6 | 0, i17 | 0, i18 | 0, HEAP32[i21 + 4 >> 2] | 0, i3 | 0, i3 + (i9 << 2) | 0, i8 | 0, i7 | 0, i14 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] | 0, i25 | 0, i26 | 0, i27 | 0, i4 | 0);
      i16 = __THREW__;
      __THREW__ = 0;
      if (!(i16 & 1)) {
       HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
       i20 = HEAP32[i17 >> 2] | 0;
       i3 = HEAP32[i18 >> 2] | 0;
       __THREW__ = 0;
       HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
       i3 = invoke_iiiiiii(fb + 147 | 0, i13 | 0, i6 | 0, i20 | 0, i3 | 0, i21 | 0, i22 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (!(i22 & 1)) {
        if (i2 | 0) _free(i2);
        __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i27);
        __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i26);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
        __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i28 >> 2] | 0) | 0;
        if (i11 | 0) _free(i11);
        if (i1 | 0) _free(i1);
        STACKTOP = i24;
        return i3 | 0;
       }
      }
      i3 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     if (i2 | 0) _free(i2);
    }
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i27);
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i26);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    i2 = HEAP32[i28 >> 2] | 0;
   } while (0);
   __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
   i2 = i11;
  }
 }
 if ((i23 | 0) == 8) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 if (i2 | 0) _free(i2);
 if (i1 | 0) _free(i1);
 ___resumeException(i3 | 0);
 return 0;
}

function __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i9);
 i5 = i10 + 16 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj284ENS_22PxRepXPropertyAccessorILj284ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 32 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj285ENS_22PxRepXPropertyAccessorILj285ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 48 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj286ENS_22PxRepXPropertyAccessorILj286ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 64 | 0;
  i12 = i9 + 4 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj287ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 5 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 64 | 0;
 i12 = i9 + 4 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj287ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 5 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE25getRelativeLinearVelocityEv(i17, i20) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 76 | 0;
 i4 = i21 + 64 | 0;
 i1 = i21 + 60 | 0;
 i2 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 i22 = HEAP32[i20 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i1 | 0, i2 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i18, i20, HEAP32[i1 >> 2] | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i19, i20, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f10 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i4 | 0, i1 | 0);
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 }
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 36 >> 2]) * Math_fround(2.0));
 f35 = Math_fround(Math_fround(HEAPF32[i20 + 40 >> 2]) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i20 + 44 >> 2]) * Math_fround(2.0));
 i3 = i18 + 12 | 0;
 f32 = Math_fround(HEAPF32[i3 >> 2]);
 f27 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
 f34 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f36 * f34);
 i4 = i18 + 4 | 0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f35 * f33));
 i22 = i18 + 8 | 0;
 f31 = Math_fround(HEAPF32[i22 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f30 * f31));
 f25 = Math_fround(Math_fround(f34 * f28) + Math_fround(Math_fround(f36 * f27) + Math_fround(f32 * Math_fround(Math_fround(f30 * f33) - Math_fround(f35 * f31)))));
 f26 = Math_fround(Math_fround(f33 * f28) + Math_fround(Math_fround(f35 * f27) + Math_fround(f32 * Math_fround(Math_fround(f36 * f31) - Math_fround(f30 * f34)))));
 f28 = Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * Math_fround(Math_fround(f35 * f34) - Math_fround(f36 * f33)))) + Math_fround(f31 * f28));
 f31 = Math_fround(Math_fround(HEAPF32[i20 + 64 >> 2]) * Math_fround(2.0));
 f33 = Math_fround(Math_fround(HEAPF32[i20 + 68 >> 2]) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(HEAPF32[i20 + 72 >> 2]) * Math_fround(2.0));
 f34 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f35 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f27 = Math_fround(f31 * f32);
 f30 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f33 * f30));
 f29 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f36 * f29));
 f23 = Math_fround(Math_fround(f32 * f27) + Math_fround(Math_fround(f31 * f35) + Math_fround(f34 * Math_fround(Math_fround(f36 * f30) - Math_fround(f33 * f29)))));
 f24 = Math_fround(Math_fround(f30 * f27) + Math_fround(Math_fround(f33 * f35) + Math_fround(f34 * Math_fround(Math_fround(f31 * f29) - Math_fround(f36 * f32)))));
 f27 = Math_fround(Math_fround(Math_fround(f36 * f35) + Math_fround(f34 * Math_fround(Math_fround(f33 * f32) - Math_fround(f31 * f30)))) + Math_fround(f29 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f28) - Math_fround(f15 * f26)) + Math_fround(Math_fround(f7 - Math_fround(Math_fround(f10 * f27) - Math_fround(f5 * f24))) - f11));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f25) - Math_fround(f16 * f28)) + Math_fround(Math_fround(f8 - Math_fround(Math_fround(f5 * f23) - Math_fround(f6 * f27))) - f12));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f26) - Math_fround(f14 * f25)) + Math_fround(Math_fround(f9 - Math_fround(Math_fround(f6 * f24) - Math_fround(f10 * f23))) - f13));
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i18 + 16 >> 2]));
 f14 = Math_fround(f8 - Math_fround(HEAPF32[i18 + 20 >> 2]));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i18 + 24 >> 2])) * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f6 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(f6 * f9);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f14));
 f13 = Math_fround(HEAPF32[i22 >> 2]);
 f7 = Math_fround(Math_fround(f13 * f12) + f7);
 f15 = Math_fround(Math_fround(f11 * f7) + Math_fround(Math_fround(f8 * f14) - Math_fround(f10 * Math_fround(Math_fround(f13 * f9) - Math_fround(f6 * f12)))));
 f16 = Math_fround(Math_fround(Math_fround(f8 * f12) - Math_fround(f10 * Math_fround(Math_fround(f6 * f14) - Math_fround(f11 * f9)))) + Math_fround(f13 * f7));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) - Math_fround(f10 * Math_fround(Math_fround(f11 * f12) - Math_fround(f13 * f14)))));
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f16;
 STACKTOP = i21;
 return;
}

function __ZN5physx22PxVehicleWheelsSimDataaSERKS0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i5 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  i9 = i5 + 48 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i8 = i6 + 48 | 0;
  HEAP32[i8 >> 2] = i9;
  i8 = i5 + 52 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i6 + 52 | 0;
  HEAP32[i9 >> 2] = i8;
  i9 = i5 + 56 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i8 = i6 + 56 | 0;
  HEAP32[i8 >> 2] = i9;
  i8 = i5 + 60 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i6 + 60 | 0;
  HEAP32[i9 >> 2] = i8;
  i9 = i6 + 44 | 0;
  i8 = i5 + 44 | 0;
  i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
  HEAP8[i9 >> 0] = i8;
  HEAP8[i9 + 1 >> 0] = i8 >> 8;
  HEAP8[i9 + 2 >> 0] = i8 >> 16;
  HEAP8[i9 + 3 >> 0] = i8 >> 24;
  return i6 | 0;
 }
 i2 = i6 + 32 | 0;
 i3 = i5 + 32 | 0;
 i4 = 0;
 do {
  i7 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  _memcpy(i7 + (i4 * 944 | 0) | 0, i8 + (i4 * 944 | 0) | 0, 640) | 0;
  HEAP32[i7 + (i4 * 944 | 0) + 640 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 640 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 644 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 644 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 648 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 648 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 652 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 652 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 656 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 656 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 660 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 660 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 664 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 664 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 668 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 668 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 672 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 672 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 676 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 676 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 680 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 680 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 684 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 684 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 688 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 688 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 692 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 692 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 696 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 696 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 700 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 700 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 704 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 704 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 708 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 708 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 712 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 712 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 716 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 716 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 720 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 720 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 724 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 724 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 728 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 728 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 732 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 732 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 736 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 736 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 740 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 740 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 744 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 744 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 748 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 748 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 752 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 752 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 756 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 756 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 760 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 760 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 764 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 764 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 768 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 768 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 772 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 772 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 776 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 776 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 780 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 780 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 784 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 784 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 788 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 788 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 792 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 792 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 796 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 796 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 800 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 800 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 804 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 804 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 808 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 808 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 812 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 812 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 816 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 816 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 820 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 820 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 824 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 824 >> 2];
  HEAP32[i7 + (i4 * 944 | 0) + 828 >> 2] = HEAP32[i8 + (i4 * 944 | 0) + 828 >> 2];
  i7 = i7 + (i4 * 944 | 0) + 832 | 0;
  i8 = i8 + (i4 * 944 | 0) + 832 | 0;
  i9 = i7 + 112 | 0;
  do {
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   i7 = i7 + 4 | 0;
   i8 = i8 + 4 | 0;
  } while ((i7 | 0) < (i9 | 0));
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 i9 = i5 + 48 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i8 = i6 + 48 | 0;
 HEAP32[i8 >> 2] = i9;
 i8 = i5 + 52 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i6 + 52 | 0;
 HEAP32[i9 >> 2] = i8;
 i9 = i5 + 56 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i8 = i6 + 56 | 0;
 HEAP32[i8 >> 2] = i9;
 i8 = i5 + 60 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i6 + 60 | 0;
 HEAP32[i9 >> 2] = i8;
 i9 = i6 + 44 | 0;
 i8 = i5 + 44 | 0;
 i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
 HEAP8[i9 >> 0] = i8;
 HEAP8[i9 + 1 >> 0] = i8 >> 8;
 HEAP8[i9 + 2 >> 0] = i8 >> 16;
 HEAP8[i9 + 3 >> 0] = i8 >> 24;
 return i6 | 0;
}

function __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 switch ((i1 & 255) << 24 >> 24) {
 case 0:
  {
   __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 0);
   i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteNullEv(i6) | 0;
   return i8 | 0;
  }
 case 1:
  {
   __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 1);
   i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb(i6, 0) | 0;
   return i8 | 0;
  }
 case 2:
  {
   __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 2);
   i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb(i6, 1) | 0;
   return i8 | 0;
  }
 case 3:
  {
   if (!(__ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv(i6) | 0)) {
    i8 = 0;
    return i8 | 0;
   }
   i4 = i5 + 4 | 0;
   L12 : do if (HEAP32[i4 >> 2] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    while (1) {
     if (!(HEAP32[i1 + 16 >> 2] & 4194304)) {
      i2 = HEAP32[i1 >> 2] | 0;
      i3 = HEAP32[i1 + 4 >> 2] | 0;
     } else {
      i2 = i1;
      i3 = 11 - (HEAP8[i1 + 11 >> 0] | 0) | 0;
     }
     __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 5);
     if (!(__ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj(i6, i2, i3) | 0)) {
      i1 = 0;
      i2 = 44;
      break;
     }
     if (!(__ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1 + 24 | 0, i6) | 0)) {
      i1 = 0;
      i2 = 44;
      break;
     }
     i1 = i1 + 48 | 0;
     if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 48 | 0) | 0)) break L12;
    }
    if ((i2 | 0) == 44) return i1 | 0;
   } while (0);
   i2 = i6 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -8;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 125;
   i8 = 1;
   return i8 | 0;
  }
 case 4:
  {
   if (!(__ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv(i6) | 0)) {
    i8 = 0;
    return i8 | 0;
   }
   i2 = i5 + 4 | 0;
   L38 : do if (HEAP32[i2 >> 2] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    while (1) {
     if (!(__ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1, i6) | 0)) {
      i1 = 0;
      break;
     }
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) | 0)) break L38;
    }
    return i1 | 0;
   } while (0);
   i2 = i6 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -8;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 93;
   i8 = 1;
   return i8 | 0;
  }
 case 5:
  {
   if (!(i1 & 4194304)) {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i5 + 4 >> 2] | 0;
   } else {
    i2 = i5;
    i1 = 11 - (HEAP8[i5 + 11 >> 0] | 0) | 0;
   }
   __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 5);
   i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj(i6, i2, i1) | 0;
   return i8 | 0;
  }
 case 6:
  {
   if (i1 & 1024 | 0) {
    i8 = HEAP32[i5 >> 2] | 0;
    __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 6);
    i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE8WriteIntEi(i6, i8) | 0;
    return i8 | 0;
   }
   if (i1 & 2048 | 0) {
    i8 = HEAP32[i5 >> 2] | 0;
    __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 6);
    i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteUintEj(i6, i8) | 0;
    return i8 | 0;
   }
   if (i1 & 4096 | 0) {
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 6);
    i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10WriteInt64Ex(i6, i7, i8) | 0;
    return i8 | 0;
   }
   if (!(i1 & 8192)) {
    d9 = +HEAPF64[i5 >> 3];
    __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 6);
    i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteDoubleEd(i6, d9) | 0;
    return i8 | 0;
   } else {
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i6, 6);
    i8 = __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteUint64Ey(i6, i7, i8) | 0;
    return i8 | 0;
   }
  }
 default:
  {
   i8 = 0;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZN14ParticleSystem4PlayEb(i13, i4) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, d27 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 32 | 0;
 i8 = i14 + 16 | 0;
 i9 = i14;
 i10 = i13 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i14;
  return;
 }
 i11 = i13 + 40 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if (HEAP8[i5 + 24 >> 0] | 0) {
  i1 = i5 + 8 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   STACKTOP = i14;
   return;
  }
  HEAP32[i1 >> 2] = 1;
  HEAP8[i5 + 12 >> 0] = 1;
  __ZN14ParticleSystem12AddToManagerEv(i13);
  STACKTOP = i14;
  return;
 }
 if (!(HEAP8[i5 + 12 >> 0] | 0)) i1 = i5; else {
  i7 = i13 + 36 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i2 = i6 + 276 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if ((i2 & 255) << 24 >> 24) {
   i16 = HEAP32[gb + 1451700 >> 2] | 0;
   i18 = i16 + 24 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i17 = i17 << 11 ^ i17;
   i15 = i16 + 28 | 0;
   HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
   i18 = i16 + 32 | 0;
   HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
   i16 = i16 + 36 | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   HEAP32[i18 >> 2] = i15;
   i15 = i17 >>> 8 ^ i17 ^ i15 ^ i15 >>> 19;
   HEAP32[i16 >> 2] = i15;
   HEAP32[i6 + 272 >> 2] = i15;
  }
  HEAP32[i5 + 8 >> 2] = 1;
  if (!(i2 & 16711680)) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   i18 = HEAP32[i6 + 272 >> 2] | 0;
   i1 = (Math_imul(i18, 1790253981) | 0) + 1900727103 | 0;
   i18 = i18 << 11 ^ i18;
   f3 = Math_fround(Math_fround(((i1 ^ i18 ^ i18 >>> 8) & 8388607 ^ i1 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
   HEAPF32[i8 + 12 >> 2] = f3;
   HEAPF32[i8 + 8 >> 2] = f3;
   HEAPF32[i8 + 4 >> 2] = f3;
   HEAPF32[i8 >> 2] = f3;
   i1 = HEAP32[i6 + 84 >> 2] | 0;
   L21 : do switch ((i1 & 65535) << 16 >> 16) {
   case 0:
    {
     i18 = HEAP32[i6 + 80 >> 2] | 0;
     HEAP32[i9 + 12 >> 2] = i18;
     HEAP32[i9 + 8 >> 2] = i18;
     HEAP32[i9 + 4 >> 2] = i18;
     HEAP32[i9 >> 2] = i18;
     break;
    }
   case 3:
    {
     f19 = Math_fround(HEAPF32[(HEAP32[i6 + 232 >> 2] | 0) + 4 >> 2]);
     f20 = Math_fround(HEAPF32[i6 + 80 >> 2]);
     f19 = Math_fround(f19 * f20);
     f3 = Math_fround(f19 + Math_fround(f3 * Math_fround(Math_fround(f20 * Math_fround(HEAPF32[(HEAP32[i6 + 144 >> 2] | 0) + 4 >> 2])) - f19)));
     HEAPF32[i9 >> 2] = f3;
     HEAPF32[i9 + 4 >> 2] = f3;
     HEAPF32[i9 + 8 >> 2] = f3;
     HEAPF32[i9 + 12 >> 2] = f3;
     break;
    }
   default:
    if (!(i1 & 16711680)) {
     __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i9, i6, i12, i8);
     break L21;
    } else {
     __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i9, i6, i12, i8);
     break L21;
    }
   } while (0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
  } else if ((i1 & 65535) < 256 | i4 ^ 1) i1 = i5; else {
   __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i13, Math_fround(0.0), 3);
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAPF32[i1 + 396 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 48 >> 2] = 0;
  HEAP8[i1 + 26 >> 0] = 0;
  HEAP8[i1 + 28 >> 0] = 0;
  HEAP8[i1 + 29 >> 0] = 0;
  i15 = __ZN14ParticleSystem27DetermineSupportsProceduralERKS_(i13) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP8[i1 + 25 >> 0] = i15 & 1;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  i15 = HEAP32[(HEAP32[i7 >> 2] | 0) + 272 >> 2] | 0;
  i16 = (Math_imul(i15, 1812433253) | 0) + 1 | 0;
  i17 = (Math_imul(i16, 1812433253) | 0) + 1 | 0;
  i18 = (Math_imul(i17, 1812433253) | 0) + 1 | 0;
  HEAPF32[i1 + 488 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 492 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 496 >> 2] = i15;
  HEAP32[i1 + 500 >> 2] = i16;
  HEAP32[i1 + 504 >> 2] = i17;
  HEAP32[i1 + 508 >> 2] = i18;
  __ZN14ParticleSystem10ResetSeedsEv(i13);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP8[i1 + 13 >> 0] = 0;
 HEAP8[i1 + 31 >> 0] = 1;
 if (HEAP8[i1 + 30 >> 0] | 0) if (HEAP8[i1 + 25 >> 0] | 0) if (!(HEAP8[i1 + 26 >> 0] | 0)) {
  i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 80260 | 0) | 0;
  if (i2 | 0) {
   i18 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i13, i18, i1 + 52 | 0, i1 + 244 | 0, i1 + 304 | 0, i1 + 316 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   __Z25InvertMatrix4x4_General3DPKfPf(i1 + 52 | 0, i1 + 180 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i1 + 368 >> 2]);
   f21 = Math_fround(HEAPF32[i1 + 380 >> 2]);
   f26 = Math_fround(f3 + f21);
   f19 = Math_fround(HEAPF32[i1 + 372 >> 2]);
   f23 = Math_fround(HEAPF32[i1 + 384 >> 2]);
   f25 = Math_fround(f19 + f23);
   f20 = Math_fround(HEAPF32[i1 + 376 >> 2]);
   f22 = Math_fround(HEAPF32[i1 + 388 >> 2]);
   f25 = Math_fround(f25 * Math_fround(.5));
   f24 = Math_fround(Math_fround(f20 + f22) * Math_fround(.5));
   HEAPF32[i12 >> 2] = Math_fround(f26 * Math_fround(.5));
   HEAPF32[i12 + 4 >> 2] = f25;
   HEAPF32[i12 + 8 >> 2] = f24;
   f19 = Math_fround(Math_fround(f23 - f19) * Math_fround(.5));
   f20 = Math_fround(Math_fround(f22 - f20) * Math_fround(.5));
   HEAPF32[i12 + 12 >> 2] = Math_fround(Math_fround(f21 - f3) * Math_fround(.5));
   HEAPF32[i12 + 16 >> 2] = f19;
   HEAPF32[i12 + 20 >> 2] = f20;
   if ((HEAP32[(HEAP32[i13 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1) __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i12, i1 + 52 | 0, i12);
   i18 = i2 + 568 | 0;
   HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i18 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   __ZN8Renderer18UpdateManagerStateEb(i2, 1);
  }
  if (!(__Z14IsWorldPlayingv() | 0)) {
   STACKTOP = i14;
   return;
  }
  HEAP8[(HEAP32[i11 >> 2] | 0) + 30 >> 0] = 1;
  d27 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  HEAPF64[(HEAP32[i11 >> 2] | 0) + 32 >> 3] = d27;
  __ZN14ParticleSystem17RemoveFromManagerEv(i13);
  STACKTOP = i14;
  return;
 }
 __ZN14ParticleSystem12AddToManagerEv(i13);
 STACKTOP = i14;
 return;
}

function __Z28GetHaloVertexPositionsStereoP8Vector3fRKS_S2_f(i2, i3, i1, f5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 144 | 0;
 i7 = i9 + 108 | 0;
 i8 = i9;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 >> 2]));
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i4 = i3 + 4 | 0;
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i4 >> 2]));
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = i3 + 8 | 0;
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i6 + 4 >> 2] = f11;
 HEAPF32[i6 + 8 >> 2] = f10;
 if (!(__Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i6, gb + 62536 | 0, i7) | 0)) __Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i6, gb + 62524 | 0, i7) | 0;
 f47 = Math_fround(HEAPF32[i7 >> 2]);
 f46 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f47 = Math_fround(f47 * f5);
 f46 = Math_fround(f46 * f5);
 f45 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * f5);
 f41 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f40 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f41 = Math_fround(f41 * f5);
 f40 = Math_fround(f40 * f5);
 f39 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * f5);
 f38 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f37 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f5 = Math_fround(f5 * Math_fround(.333000004));
 f38 = Math_fround(f5 * f38);
 f37 = Math_fround(f5 * f37);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 32 >> 2]));
 f44 = Math_fround(HEAPF32[i3 >> 2]);
 f38 = Math_fround(f44 - f38);
 f43 = Math_fround(HEAPF32[i4 >> 2]);
 f37 = Math_fround(f43 - f37);
 f42 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f42 - f5);
 HEAPF32[i8 >> 2] = f38;
 i7 = i8 + 4 | 0;
 HEAPF32[i7 >> 2] = f37;
 i19 = i8 + 8 | 0;
 HEAPF32[i19 >> 2] = f5;
 f10 = Math_fround(f44 - f47);
 f11 = Math_fround(f43 - f46);
 f12 = Math_fround(f42 - f45);
 i1 = i8 + 12 | 0;
 HEAPF32[i1 >> 2] = f10;
 i3 = i8 + 16 | 0;
 HEAPF32[i3 >> 2] = f11;
 i4 = i8 + 20 | 0;
 HEAPF32[i4 >> 2] = f12;
 f49 = Math_fround(f11 - f40);
 f48 = Math_fround(f12 - f39);
 i36 = i8 + 24 | 0;
 HEAPF32[i36 >> 2] = Math_fround(f10 - f41);
 i35 = i8 + 28 | 0;
 HEAPF32[i35 >> 2] = f49;
 i34 = i8 + 32 | 0;
 HEAPF32[i34 >> 2] = f48;
 f48 = Math_fround(f43 - f40);
 f49 = Math_fround(f42 - f39);
 i33 = i8 + 36 | 0;
 HEAPF32[i33 >> 2] = Math_fround(f44 - f41);
 i32 = i8 + 40 | 0;
 HEAPF32[i32 >> 2] = f48;
 i31 = i8 + 44 | 0;
 HEAPF32[i31 >> 2] = f49;
 f47 = Math_fround(f47 + f44);
 f46 = Math_fround(f46 + f43);
 f45 = Math_fround(f45 + f42);
 f49 = Math_fround(f46 - f40);
 f48 = Math_fround(f45 - f39);
 i30 = i8 + 48 | 0;
 HEAPF32[i30 >> 2] = Math_fround(f47 - f41);
 i29 = i8 + 52 | 0;
 HEAPF32[i29 >> 2] = f49;
 i28 = i8 + 56 | 0;
 HEAPF32[i28 >> 2] = f48;
 i27 = i8 + 60 | 0;
 HEAPF32[i27 >> 2] = f47;
 i26 = i8 + 64 | 0;
 HEAPF32[i26 >> 2] = f46;
 i25 = i8 + 68 | 0;
 HEAPF32[i25 >> 2] = f45;
 f46 = Math_fround(f40 + f46);
 f45 = Math_fround(f39 + f45);
 i21 = i8 + 72 | 0;
 HEAPF32[i21 >> 2] = Math_fround(f41 + f47);
 i20 = i8 + 76 | 0;
 HEAPF32[i20 >> 2] = f46;
 i6 = i8 + 80 | 0;
 HEAPF32[i6 >> 2] = f45;
 f43 = Math_fround(f40 + f43);
 f42 = Math_fround(f39 + f42);
 i18 = i8 + 84 | 0;
 HEAPF32[i18 >> 2] = Math_fround(f41 + f44);
 i17 = i8 + 88 | 0;
 HEAPF32[i17 >> 2] = f43;
 i16 = i8 + 92 | 0;
 HEAPF32[i16 >> 2] = f42;
 f40 = Math_fround(f40 + f11);
 f39 = Math_fround(f39 + f12);
 i15 = i8 + 96 | 0;
 HEAPF32[i15 >> 2] = Math_fround(f41 + f10);
 i14 = i8 + 100 | 0;
 HEAPF32[i14 >> 2] = f40;
 i13 = i8 + 104 | 0;
 HEAPF32[i13 >> 2] = f39;
 HEAPF32[i2 >> 2] = f38;
 HEAPF32[i2 + 4 >> 2] = f37;
 HEAPF32[i2 + 8 >> 2] = f5;
 HEAPF32[i2 + 12 >> 2] = f38;
 HEAPF32[i2 + 16 >> 2] = f37;
 HEAPF32[i2 + 20 >> 2] = f5;
 HEAPF32[i2 + 24 >> 2] = f10;
 HEAPF32[i2 + 28 >> 2] = f11;
 HEAPF32[i2 + 32 >> 2] = f12;
 i24 = HEAP32[i8 >> 2] | 0;
 i23 = HEAP32[i7 >> 2] | 0;
 i22 = HEAP32[i19 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = i24;
 HEAP32[i2 + 40 >> 2] = i23;
 HEAP32[i2 + 44 >> 2] = i22;
 i35 = HEAP32[i35 >> 2] | 0;
 i34 = HEAP32[i34 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i36 >> 2];
 HEAP32[i2 + 52 >> 2] = i35;
 HEAP32[i2 + 56 >> 2] = i34;
 HEAP32[i2 + 60 >> 2] = i24;
 HEAP32[i2 + 64 >> 2] = i23;
 HEAP32[i2 + 68 >> 2] = i22;
 i32 = HEAP32[i32 >> 2] | 0;
 i31 = HEAP32[i31 >> 2] | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i2 + 76 >> 2] = i32;
 HEAP32[i2 + 80 >> 2] = i31;
 HEAP32[i2 + 84 >> 2] = i24;
 HEAP32[i2 + 88 >> 2] = i23;
 HEAP32[i2 + 92 >> 2] = i22;
 i29 = HEAP32[i29 >> 2] | 0;
 i28 = HEAP32[i28 >> 2] | 0;
 HEAP32[i2 + 96 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i2 + 100 >> 2] = i29;
 HEAP32[i2 + 104 >> 2] = i28;
 HEAP32[i2 + 108 >> 2] = i24;
 HEAP32[i2 + 112 >> 2] = i23;
 HEAP32[i2 + 116 >> 2] = i22;
 i26 = HEAP32[i26 >> 2] | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 HEAP32[i2 + 120 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i2 + 124 >> 2] = i26;
 HEAP32[i2 + 128 >> 2] = i25;
 HEAP32[i2 + 132 >> 2] = i24;
 HEAP32[i2 + 136 >> 2] = i23;
 HEAP32[i2 + 140 >> 2] = i22;
 i20 = HEAP32[i20 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i2 + 144 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i2 + 148 >> 2] = i20;
 HEAP32[i2 + 152 >> 2] = i6;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 HEAP32[i2 + 156 >> 2] = i6;
 HEAP32[i2 + 160 >> 2] = i7;
 HEAP32[i2 + 164 >> 2] = i8;
 i17 = HEAP32[i17 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 HEAP32[i2 + 168 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i2 + 172 >> 2] = i17;
 HEAP32[i2 + 176 >> 2] = i16;
 HEAP32[i2 + 180 >> 2] = i6;
 HEAP32[i2 + 184 >> 2] = i7;
 HEAP32[i2 + 188 >> 2] = i8;
 i14 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i2 + 192 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 196 >> 2] = i14;
 HEAP32[i2 + 200 >> 2] = i13;
 HEAP32[i2 + 204 >> 2] = i6;
 HEAP32[i2 + 208 >> 2] = i7;
 HEAP32[i2 + 212 >> 2] = i8;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + 216 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 220 >> 2] = i3;
 HEAP32[i2 + 224 >> 2] = i4;
 HEAP32[i2 + 228 >> 2] = i6;
 HEAP32[i2 + 232 >> 2] = i7;
 HEAP32[i2 + 236 >> 2] = i8;
 HEAP32[i2 + 240 >> 2] = i6;
 HEAP32[i2 + 244 >> 2] = i7;
 HEAP32[i2 + 248 >> 2] = i8;
 STACKTOP = i9;
 return;
}

function __ZN17ArchiveFileSystem14UnmountArchiveEPKc(i13, i2) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 28 | 0;
 i5 = i14 + 16 | 0;
 i4 = i14;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  i12 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i4 + 11 >> 0] = i3;
  if (!i3) i1 = i4; else {
   i1 = i4;
   i12 = 6;
  }
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i11 = i3 + 16 & -16;
  HEAP32[i6 >> 2] = 54;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i4 + 4 >> 2] = i3;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i10 = i13 + 40 | 0;
 i11 = i13 + 44 | 0;
 if ((HEAP32[i13 + 100 >> 2] | 0) == (HEAP32[i11 >> 2] | 0)) {
  i9 = (HEAP32[i13 + 92 >> 2] | 0) + ((HEAP32[i13 + 96 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i5 >> 2] = i10;
  HEAP32[i5 + 4 >> 2] = i9;
  HEAP32[i5 + 8 >> 2] = i9;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i5);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E13find_positionERS9_(i6, i10, i4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i13 + 92 >> 2] | 0;
  i3 = HEAP32[i13 + 96 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i9 = i2 + (i3 * 20 | 0) | 0;
   HEAP32[i5 >> 2] = i10;
   HEAP32[i5 + 4 >> 2] = i9;
   HEAP32[i5 + 8 >> 2] = i9;
   __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i5);
  } else {
   HEAP32[i5 >> 2] = i10;
   HEAP32[i5 + 4 >> 2] = i2 + (i1 * 20 | 0);
   HEAP32[i5 + 8 >> 2] = i2 + (i3 * 20 | 0);
  }
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i4 >> 2] | 0;
  i8 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 54;
  HEAP32[i6 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
 }
 i3 = i13 + 92 | 0;
 i4 = i13 + 96 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i6 >> 2] = i10;
 i9 = i6 + 4 | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i6);
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader(i13, HEAP32[i1 + 16 >> 2] | 0);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + 16 >> 2] = 0;
 i7 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i6 >> 2] = i10;
 i8 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i7;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i6);
 if ((i9 | 0) == (HEAP32[i8 >> 2] | 0)) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 L30 : do if (!(HEAP8[i13 + 48 >> 0] | 0)) i12 = 28; else if (!(HEAP32[i11 >> 2] | 0)) i12 = 28; else {
  i3 = i13 + 52 | 0;
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i7 = i2 << 24 >> 24 < 0;
  i2 = i2 & 255;
  i8 = i7 ? HEAP32[i13 + 56 >> 2] | 0 : i2;
  i6 = HEAP8[i9 + 11 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  if ((i8 | 0) == ((i1 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0)) {
   i5 = HEAP32[i3 >> 2] | 0;
   i6 = i7 ? i5 : i3;
   i1 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
   i4 = (i8 | 0) == 0;
   L34 : do if (i7) {
    if (!i4) {
     i8 = (_memcmp(i6, i1, i8) | 0) == 0;
     __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i10, i9, i13 + 52 | 0);
     if (i8) i1 = 1; else break L30;
     STACKTOP = i14;
     return i1 | 0;
    }
   } else if (!i4) {
    if ((i5 & 255) << 24 >> 24 != (HEAP8[i1 >> 0] | 0)) {
     i12 = 28;
     break L30;
    }
    while (1) {
     i2 = i2 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i2) break L34;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i12 = 28;
      break L30;
     }
    }
   } while (0);
   __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i10, i9, i13 + 52 | 0);
   i13 = 1;
   STACKTOP = i14;
   return i13 | 0;
  } else i12 = 28;
 } while (0);
 if ((i12 | 0) == 28) __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i10, i9, i13 + 52 | 0);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 HEAP8[i13 + 112 >> 0] = 1;
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function runPostSets49() {
 HEAP32[gb + 61944 >> 2] = (HEAP32[gb + 61944 >> 2] | 0) + (gb + 439904 | 0);
 HEAP32[gb + 61948 >> 2] = (HEAP32[gb + 61948 >> 2] | 0) + (gb + 439925 | 0);
 HEAP32[gb + 61952 >> 2] = (HEAP32[gb + 61952 >> 2] | 0) + (gb + 439946 | 0);
 HEAP32[gb + 61956 >> 2] = (HEAP32[gb + 61956 >> 2] | 0) + (gb + 439967 | 0);
 HEAP32[gb + 61960 >> 2] = (HEAP32[gb + 61960 >> 2] | 0) + (gb + 439988 | 0);
 HEAP32[gb + 61964 >> 2] = (HEAP32[gb + 61964 >> 2] | 0) + (gb + 440009 | 0);
 HEAP32[gb + 61968 >> 2] = (HEAP32[gb + 61968 >> 2] | 0) + (gb + 440030 | 0);
 HEAP32[gb + 61972 >> 2] = (HEAP32[gb + 61972 >> 2] | 0) + (gb + 440051 | 0);
 HEAP32[gb + 61976 >> 2] = (HEAP32[gb + 61976 >> 2] | 0) + (gb + 440072 | 0);
 HEAP32[gb + 61980 >> 2] = (HEAP32[gb + 61980 >> 2] | 0) + (gb + 440093 | 0);
 HEAP32[gb + 61984 >> 2] = (HEAP32[gb + 61984 >> 2] | 0) + (gb + 440114 | 0);
 HEAP32[gb + 61988 >> 2] = (HEAP32[gb + 61988 >> 2] | 0) + (gb + 440135 | 0);
 HEAP32[gb + 61992 >> 2] = (HEAP32[gb + 61992 >> 2] | 0) + (gb + 440156 | 0);
 HEAP32[gb + 61996 >> 2] = (HEAP32[gb + 61996 >> 2] | 0) + (gb + 440177 | 0);
 HEAP32[gb + 62e3 >> 2] = (HEAP32[gb + 62e3 >> 2] | 0) + (gb + 440198 | 0);
 HEAP32[gb + 62004 >> 2] = (HEAP32[gb + 62004 >> 2] | 0) + (gb + 440219 | 0);
 HEAP32[gb + 62008 >> 2] = (HEAP32[gb + 62008 >> 2] | 0) + (gb + 440240 | 0);
 HEAP32[gb + 62012 >> 2] = (HEAP32[gb + 62012 >> 2] | 0) + (gb + 440261 | 0);
 HEAP32[gb + 62016 >> 2] = (HEAP32[gb + 62016 >> 2] | 0) + (gb + 440282 | 0);
 HEAP32[gb + 62020 >> 2] = (HEAP32[gb + 62020 >> 2] | 0) + (gb + 440303 | 0);
 HEAP32[gb + 62024 >> 2] = (HEAP32[gb + 62024 >> 2] | 0) + (gb + 440324 | 0);
 HEAP32[gb + 62028 >> 2] = (HEAP32[gb + 62028 >> 2] | 0) + (gb + 440346 | 0);
 HEAP32[gb + 62032 >> 2] = (HEAP32[gb + 62032 >> 2] | 0) + (gb + 440368 | 0);
 HEAP32[gb + 62036 >> 2] = (HEAP32[gb + 62036 >> 2] | 0) + (gb + 440390 | 0);
 HEAP32[gb + 62040 >> 2] = (HEAP32[gb + 62040 >> 2] | 0) + (gb + 440412 | 0);
 HEAP32[gb + 62044 >> 2] = (HEAP32[gb + 62044 >> 2] | 0) + (gb + 440434 | 0);
 HEAP32[gb + 62048 >> 2] = (HEAP32[gb + 62048 >> 2] | 0) + (gb + 440456 | 0);
 HEAP32[gb + 62052 >> 2] = (HEAP32[gb + 62052 >> 2] | 0) + (gb + 440478 | 0);
 HEAP32[gb + 62056 >> 2] = (HEAP32[gb + 62056 >> 2] | 0) + (gb + 440500 | 0);
 HEAP32[gb + 62060 >> 2] = (HEAP32[gb + 62060 >> 2] | 0) + (gb + 440522 | 0);
 HEAP32[gb + 62064 >> 2] = (HEAP32[gb + 62064 >> 2] | 0) + (gb + 440544 | 0);
 HEAP32[gb + 62068 >> 2] = (HEAP32[gb + 62068 >> 2] | 0) + (gb + 440565 | 0);
 HEAP32[gb + 62072 >> 2] = (HEAP32[gb + 62072 >> 2] | 0) + (gb + 440586 | 0);
 HEAP32[gb + 62076 >> 2] = (HEAP32[gb + 62076 >> 2] | 0) + (gb + 440607 | 0);
 HEAP32[gb + 62080 >> 2] = (HEAP32[gb + 62080 >> 2] | 0) + (gb + 440628 | 0);
 HEAP32[gb + 62084 >> 2] = (HEAP32[gb + 62084 >> 2] | 0) + (gb + 440649 | 0);
 HEAP32[gb + 62088 >> 2] = (HEAP32[gb + 62088 >> 2] | 0) + (gb + 440670 | 0);
 HEAP32[gb + 62092 >> 2] = (HEAP32[gb + 62092 >> 2] | 0) + (gb + 440691 | 0);
 HEAP32[gb + 62096 >> 2] = (HEAP32[gb + 62096 >> 2] | 0) + (gb + 440712 | 0);
 HEAP32[gb + 62100 >> 2] = (HEAP32[gb + 62100 >> 2] | 0) + (gb + 440733 | 0);
 HEAP32[gb + 62104 >> 2] = (HEAP32[gb + 62104 >> 2] | 0) + (gb + 440754 | 0);
 HEAP32[gb + 62108 >> 2] = (HEAP32[gb + 62108 >> 2] | 0) + (gb + 440776 | 0);
 HEAP32[gb + 62112 >> 2] = (HEAP32[gb + 62112 >> 2] | 0) + (gb + 440798 | 0);
 HEAP32[gb + 62116 >> 2] = (HEAP32[gb + 62116 >> 2] | 0) + (gb + 440820 | 0);
 HEAP32[gb + 62120 >> 2] = (HEAP32[gb + 62120 >> 2] | 0) + (gb + 440842 | 0);
 HEAP32[gb + 62124 >> 2] = (HEAP32[gb + 62124 >> 2] | 0) + (gb + 440864 | 0);
 HEAP32[gb + 62128 >> 2] = (HEAP32[gb + 62128 >> 2] | 0) + (gb + 440886 | 0);
 HEAP32[gb + 62132 >> 2] = (HEAP32[gb + 62132 >> 2] | 0) + (gb + 440908 | 0);
 HEAP32[gb + 62136 >> 2] = (HEAP32[gb + 62136 >> 2] | 0) + (gb + 440930 | 0);
 HEAP32[gb + 62140 >> 2] = (HEAP32[gb + 62140 >> 2] | 0) + (gb + 440952 | 0);
 HEAP32[gb + 62152 >> 2] = fb + 652;
 HEAP32[gb + 62156 >> 2] = fb + 653;
 HEAP32[gb + 62160 >> 2] = fb + 80;
 HEAP32[gb + 62164 >> 2] = fb + 515;
 HEAP32[gb + 62168 >> 2] = fb + 16;
 HEAP32[gb + 62172 >> 2] = fb + 654;
 HEAP32[gb + 62176 >> 2] = fb + 655;
 HEAP32[gb + 62180 >> 2] = fb + 19;
 HEAP32[gb + 62184 >> 2] = fb + 287;
 HEAP32[gb + 62188 >> 2] = fb + 99;
 HEAP32[gb + 62192 >> 2] = fb + 40;
 HEAP32[gb + 62196 >> 2] = fb + 62;
 HEAP32[gb + 62200 >> 2] = fb + 28;
 HEAP32[gb + 62204 >> 2] = fb + 63;
 HEAP32[gb + 62208 >> 2] = fb + 29;
 HEAP32[gb + 62212 >> 2] = fb + 34;
 HEAP32[gb + 62216 >> 2] = fb + 516;
 HEAP32[gb + 62220 >> 2] = fb + 517;
 HEAP32[gb + 62224 >> 2] = fb + 518;
 HEAP32[gb + 62228 >> 2] = fb + 519;
 HEAP32[gb + 62232 >> 2] = fb + 520;
 HEAP32[gb + 62236 >> 2] = fb + 521;
 HEAP32[gb + 62240 >> 2] = fb + 36;
 HEAP32[gb + 62244 >> 2] = fb + 96;
 HEAP32[gb + 62248 >> 2] = fb + 81;
 HEAP32[gb + 62252 >> 2] = fb + 82;
 HEAP32[gb + 62256 >> 2] = fb + 656;
 HEAP32[gb + 62268 >> 2] = fb + 657;
 HEAP32[gb + 62272 >> 2] = fb + 658;
 HEAP32[gb + 62276 >> 2] = (HEAP32[gb + 62276 >> 2] | 0) + (gb + 441911 | 0);
 HEAP32[gb + 62280 >> 2] = (HEAP32[gb + 62280 >> 2] | 0) + (gb + 441915 | 0);
 HEAP32[gb + 62284 >> 2] = (HEAP32[gb + 62284 >> 2] | 0) + (gb + 441920 | 0);
 HEAP32[gb + 62288 >> 2] = (HEAP32[gb + 62288 >> 2] | 0) + (gb + 441925 | 0);
 HEAP32[gb + 62292 >> 2] = (HEAP32[gb + 62292 >> 2] | 0) + (gb + 441934 | 0);
 HEAP32[gb + 62296 >> 2] = (HEAP32[gb + 62296 >> 2] | 0) + (gb + 441944 | 0);
 HEAP32[gb + 62300 >> 2] = (HEAP32[gb + 62300 >> 2] | 0) + (gb + 441951 | 0);
 HEAP32[gb + 62304 >> 2] = (HEAP32[gb + 62304 >> 2] | 0) + (gb + 441958 | 0);
 HEAP32[gb + 62308 >> 2] = (HEAP32[gb + 62308 >> 2] | 0) + (gb + 441963 | 0);
 HEAP32[gb + 62312 >> 2] = (HEAP32[gb + 62312 >> 2] | 0) + (gb + 441971 | 0);
 HEAP32[gb + 62316 >> 2] = (HEAP32[gb + 62316 >> 2] | 0) + (gb + 441977 | 0);
 HEAP32[gb + 62320 >> 2] = (HEAP32[gb + 62320 >> 2] | 0) + (gb + 441984 | 0);
 HEAP32[gb + 62324 >> 2] = (HEAP32[gb + 62324 >> 2] | 0) + (gb + 441989 | 0);
 HEAP32[gb + 62328 >> 2] = (HEAP32[gb + 62328 >> 2] | 0) + (gb + 441995 | 0);
 HEAP32[gb + 62332 >> 2] = (HEAP32[gb + 62332 >> 2] | 0) + (gb + 442002 | 0);
 HEAP32[gb + 62336 >> 2] = (HEAP32[gb + 62336 >> 2] | 0) + (gb + 442008 | 0);
 HEAP32[gb + 62340 >> 2] = (HEAP32[gb + 62340 >> 2] | 0) + (gb + 442015 | 0);
 HEAP32[gb + 62344 >> 2] = (HEAP32[gb + 62344 >> 2] | 0) + (gb + 442021 | 0);
 HEAP32[gb + 62348 >> 2] = (HEAP32[gb + 62348 >> 2] | 0) + (gb + 442027 | 0);
 HEAP32[gb + 62352 >> 2] = (HEAP32[gb + 62352 >> 2] | 0) + (gb + 442032 | 0);
 HEAP32[gb + 62356 >> 2] = (HEAP32[gb + 62356 >> 2] | 0) + (gb + 442037 | 0);
 runPostSets50();
}

function __ZN5physx14PxVehicleGraph16setupEngineGraphEffffRKNS_6PxVec3ES3_S3_(i8, f6, f7, f4, f5, i1, i2, i3) {
 i8 = i8 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 448 | 0;
 i11 = i9 + 384 | 0;
 i17 = i9 + 320 | 0;
 i20 = i9 + 256 | 0;
 i21 = i9 + 192 | 0;
 i22 = i9 + 128 | 0;
 i23 = i9 + 64 | 0;
 i24 = i9;
 i25 = i9 + 520 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i1 + 4 >> 2] | 0;
 i26 = HEAP32[i1 + 8 >> 2] | 0;
 f6 = Math_fround(f6 * Math_fround(.5));
 HEAPF32[i8 + 15808 >> 2] = Math_fround(f4 - f6);
 HEAPF32[i8 + 15812 >> 2] = Math_fround(f6 + f4);
 f7 = Math_fround(f7 * Math_fround(.5));
 HEAPF32[i8 + 15816 >> 2] = Math_fround(f5 - f7);
 HEAPF32[i8 + 15820 >> 2] = Math_fround(f7 + f5);
 HEAP32[i8 + 15792 >> 2] = i13;
 HEAP32[i8 + 15796 >> 2] = i15;
 HEAP32[i8 + 15800 >> 2] = i26;
 HEAP32[i8 + 15804 >> 2] = 1056964608;
 HEAP32[i8 + 15828 >> 2] = 9;
 i26 = HEAP32[i2 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = i2 + 8 | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i27 = HEAP32[i3 >> 2] | 0;
 i12 = i3 + 4 | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i14 = i3 + 8 | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i25, 64, gb + 835359 | 0, i24) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 1145569280;
 HEAP32[i8 + 96 >> 2] = 1137180672;
 HEAP32[i8 + 144 >> 2] = i27;
 HEAP32[i8 + 148 >> 2] = i18;
 HEAP32[i8 + 152 >> 2] = i19;
 HEAP32[i8 + 288 >> 2] = i26;
 HEAP32[i8 + 292 >> 2] = i15;
 HEAP32[i8 + 296 >> 2] = i16;
 _strncpy(i8 + 432 | 0, i25, 256) | 0;
 HEAP8[i8 + 687 >> 0] = 0;
 i25 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i26 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i24, 64, gb + 835370 | 0, i23) | 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1148846080;
 HEAP32[i8 + 100 >> 2] = 0;
 HEAP32[i8 + 156 >> 2] = i26;
 HEAP32[i8 + 160 >> 2] = i19;
 HEAP32[i8 + 164 >> 2] = i18;
 HEAP32[i8 + 300 >> 2] = i25;
 HEAP32[i8 + 304 >> 2] = i16;
 HEAP32[i8 + 308 >> 2] = i15;
 _strncpy(i8 + 688 | 0, i24, 256) | 0;
 HEAP8[i8 + 943 >> 0] = 0;
 i24 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i25 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i23, 64, gb + 835388 | 0, i22) | 0;
 HEAP32[i8 + 8 >> 2] = -1018691584;
 HEAP32[i8 + 56 >> 2] = 1128792064;
 HEAP32[i8 + 104 >> 2] = 0;
 HEAP32[i8 + 168 >> 2] = i25;
 HEAP32[i8 + 172 >> 2] = i18;
 HEAP32[i8 + 176 >> 2] = i19;
 HEAP32[i8 + 312 >> 2] = i24;
 HEAP32[i8 + 316 >> 2] = i15;
 HEAP32[i8 + 320 >> 2] = i16;
 _strncpy(i8 + 944 | 0, i23, 256) | 0;
 HEAP8[i8 + 1199 >> 0] = 0;
 i23 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i24 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i22, 64, gb + 835399 | 0, i21) | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 1066192077;
 HEAP32[i8 + 108 >> 2] = 0;
 HEAP32[i8 + 180 >> 2] = i24;
 HEAP32[i8 + 184 >> 2] = i19;
 HEAP32[i8 + 188 >> 2] = i18;
 HEAP32[i8 + 324 >> 2] = i23;
 HEAP32[i8 + 328 >> 2] = i16;
 HEAP32[i8 + 332 >> 2] = i15;
 _strncpy(i8 + 1200 | 0, i22, 256) | 0;
 HEAP8[i8 + 1455 >> 0] = 0;
 i22 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i23 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i21, 64, gb + 835405 | 0, i20) | 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 1066192077;
 HEAP32[i8 + 112 >> 2] = 0;
 HEAP32[i8 + 192 >> 2] = i23;
 HEAP32[i8 + 196 >> 2] = i18;
 HEAP32[i8 + 200 >> 2] = i19;
 HEAP32[i8 + 336 >> 2] = i22;
 HEAP32[i8 + 340 >> 2] = i15;
 HEAP32[i8 + 344 >> 2] = i16;
 _strncpy(i8 + 1456 | 0, i21, 256) | 0;
 HEAP8[i8 + 1711 >> 0] = 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i22 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i20, 64, gb + 835427 | 0, i17) | 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1066192077;
 HEAP32[i8 + 116 >> 2] = 0;
 HEAP32[i8 + 204 >> 2] = i22;
 HEAP32[i8 + 208 >> 2] = i19;
 HEAP32[i8 + 212 >> 2] = i18;
 HEAP32[i8 + 348 >> 2] = i21;
 HEAP32[i8 + 352 >> 2] = i16;
 HEAP32[i8 + 356 >> 2] = i15;
 _strncpy(i8 + 1712 | 0, i20, 256) | 0;
 HEAP8[i8 + 1967 >> 0] = 0;
 i20 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 i21 = HEAP32[i3 >> 2] | 0;
 i18 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i17, 64, gb + 835454 | 0, i11) | 0;
 HEAP32[i8 + 24 >> 2] = -1081291571;
 HEAP32[i8 + 72 >> 2] = 1066192077;
 HEAP32[i8 + 120 >> 2] = 0;
 HEAP32[i8 + 216 >> 2] = i21;
 HEAP32[i8 + 220 >> 2] = i18;
 HEAP32[i8 + 224 >> 2] = i19;
 HEAP32[i8 + 360 >> 2] = i20;
 HEAP32[i8 + 364 >> 2] = i15;
 HEAP32[i8 + 368 >> 2] = i16;
 _strncpy(i8 + 1968 | 0, i17, 256) | 0;
 HEAP8[i8 + 2223 >> 0] = 0;
 i17 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i20 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i12 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i11, 64, gb + 835481 | 0, i10) | 0;
 HEAP32[i8 + 28 >> 2] = -1081291571;
 HEAP32[i8 + 76 >> 2] = 1066192077;
 HEAP32[i8 + 124 >> 2] = 0;
 HEAP32[i8 + 228 >> 2] = i20;
 HEAP32[i8 + 232 >> 2] = i19;
 HEAP32[i8 + 236 >> 2] = i18;
 HEAP32[i8 + 372 >> 2] = i17;
 HEAP32[i8 + 376 >> 2] = i16;
 HEAP32[i8 + 380 >> 2] = i15;
 _strncpy(i8 + 2224 | 0, i11, 256) | 0;
 HEAP8[i8 + 2479 >> 0] = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 64, gb + 835510 | 0, i9 + 512 | 0) | 0;
 HEAP32[i8 + 32 >> 2] = -1065353216;
 HEAP32[i8 + 80 >> 2] = 1101004800;
 HEAP32[i8 + 128 >> 2] = 0;
 HEAP32[i8 + 240 >> 2] = i13;
 HEAP32[i8 + 244 >> 2] = i12;
 HEAP32[i8 + 248 >> 2] = i3;
 HEAP32[i8 + 384 >> 2] = i11;
 HEAP32[i8 + 388 >> 2] = i1;
 HEAP32[i8 + 392 >> 2] = i2;
 _strncpy(i8 + 2480 | 0, i10, 256) | 0;
 HEAP8[i8 + 2735 >> 0] = 0;
 STACKTOP = i9;
 return;
}

function __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 if (!i21) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = i21 + 1304 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i19 = HEAP32[gb + 1112412 + 8 >> 2] | 0;
 HEAP32[i20 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 24 >> 2] | 0;
 HEAP32[i20 + 4 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 40 >> 2] | 0;
 HEAP32[i20 + 8 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 56 >> 2] | 0;
 HEAP32[i20 + 12 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 72 >> 2] | 0;
 HEAP32[i20 + 16 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 88 >> 2] | 0;
 HEAP32[i20 + 20 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 104 >> 2] | 0;
 HEAP32[i20 + 24 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 120 >> 2] | 0;
 HEAP32[i20 + 28 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 136 >> 2] | 0;
 HEAP32[i20 + 32 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 152 >> 2] | 0;
 HEAP32[i20 + 36 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 168 >> 2] | 0;
 HEAP32[i20 + 40 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 184 >> 2] | 0;
 HEAP32[i20 + 44 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 200 >> 2] | 0;
 HEAP32[i20 + 48 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 216 >> 2] | 0;
 HEAP32[i20 + 52 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 232 >> 2] | 0;
 HEAP32[i20 + 56 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[gb + 1112412 + 248 >> 2] | 0;
 HEAP32[i20 + 60 >> 2] = (i19 | 0) == 0 ? fb + 3332 | 0 : i19;
 i19 = HEAP32[i21 + 20 >> 2] | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 i2 = HEAP32[i1 + 32804 >> 2] | 0;
 if ((i19 | 0) > 0) {
  i17 = i21 + 8 | 0;
  i18 = i21 + 12 | 0;
  i16 = 0;
  i1 = i2;
  do {
   i13 = i21 + 24 + (i16 * 80 | 0) | 0;
   i14 = i21 + 24 + (i16 * 80 | 0) + 4 | 0;
   HEAP32[i14 >> 2] = i1;
   i15 = HEAP32[i21 + 24 + (i16 * 80 | 0) + 68 >> 2] | 0;
   if ((i15 | 0) > 0) {
    i4 = i21 + 24 + (i16 * 80 | 0) + 56 | 0;
    i5 = i21 + 24 + (i16 * 80 | 0) + 8 | 0;
    i6 = i21 + 24 + (i16 * 80 | 0) + 44 | 0;
    i7 = i21 + 24 + (i16 * 80 | 0) + 32 | 0;
    i8 = i21 + 24 + (i16 * 80 | 0) + 36 | 0;
    i9 = i21 + 24 + (i16 * 80 | 0) + 40 | 0;
    i10 = i21 + 24 + (i16 * 80 | 0) + 12 | 0;
    i11 = i21 + 24 + (i16 * 80 | 0) + 32 | 0;
    i12 = i21 + 24 + (i16 * 80 | 0) + 48 | 0;
    i3 = 0;
    do {
     i23 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP32[i23 + (i3 << 3) + 4 >> 2] | 0;
     i23 = i23 + (i3 << 3) | 0;
     i24 = HEAP32[i23 >> 2] | 0;
     HEAP32[i5 >> 2] = i24;
     i24 = (HEAP32[i17 >> 2] | 0) + (i24 * 12 | 0) | 0;
     HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     i23 = HEAP32[i23 >> 2] | 0;
     i24 = HEAP32[i18 >> 2] | 0;
     i2 = HEAP32[i24 + (i23 * 12 | 0) >> 2] | 0;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i9 >> 2] = HEAP32[i24 + (i23 * 12 | 0) + 8 >> 2];
     HEAP32[i8 >> 2] = i1 + 1;
     HEAP32[i10 >> 2] = i1;
     if ((i1 | 0) != -1) {
      i1 = (HEAP32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i2 + (i1 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
      mftCall_vi(HEAP32[i20 + (((HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 63) << 2) >> 2] | 0, i13 | 0);
      i1 = HEAP32[i10 >> 2] | 0;
      if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) do {
       i24 = (HEAP32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
       mftCall_vi(HEAP32[i20 + (((HEAPU16[i24 >> 1] | 0 | (HEAPU8[i24 + 2 >> 0] | 0) << 16) & 63) << 2) >> 2] | 0, i13 | 0);
       i1 = HEAP32[i10 >> 2] | 0;
      } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i15 | 0));
    i1 = HEAP32[i14 >> 2] | 0;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i19 | 0));
  i6 = HEAP32[i21 >> 2] | 0;
  i5 = i1;
 } else {
  i6 = i1;
  i5 = i2;
 }
 i8 = i6 + 32804 | 0;
 HEAP32[i8 >> 2] = i5;
 if (!(HEAP32[i21 + 1504 >> 2] & 1)) i1 = i5; else {
  i1 = HEAP32[gb + 1112268 >> 2] | 0;
  if (!(HEAP32[i1 + 64 >> 2] | 0)) i1 = i5; else {
   i2 = HEAP32[i1 + 56 >> 2] | 0;
   i4 = i1 + 60 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i3 = i5;
    i4 = i6;
    i1 = i5;
    i2 = i5;
   } else {
    i7 = i21 + 40 | 0;
    i3 = i5;
    while (1) {
     i3 = ((__ZN9Projector17PrepareRenderNodeEjjPS_R15RenderNodeQueueR22PerThreadPageAllocator(HEAP32[i2 + 16 >> 2] | 0, i3, HEAP32[i2 + 20 >> 2] | 0, i6, i7) | 0) & 1) + i3 | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i21 >> 2] | 0;
    i4 = i1;
    i1 = HEAP32[i1 + 32804 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i6 + 32808 >> 2] = i3 - i2;
   i6 = i4;
  }
 }
 i5 = HEAP32[i21 + 4 >> 2] | 0;
 i1 = (HEAP32[i6 + 32808 >> 2] | 0) + i1 | 0;
 i2 = i6 + 12 | 0;
 do if (!i1) HEAP32[i2 >> 2] = 0; else {
  HEAP32[i2 >> 2] = i1;
  i3 = i6 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 * 360 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 360 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i24 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 360 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i24;
   break;
  }
 } while (0);
 __ZN29RenderNodeQueuePrepareContextD2Ev(i21);
 __Z19free_alloc_internalPvRK10MemLabelId(i21, gb + 64024 | 0);
 i24 = (i1 | 0) != (i5 | 0);
 STACKTOP = i22;
 return i24 | 0;
}

function __ZN14ImageReference9BlitImageERKS_NS_10ColorSpaceENS_8BlitModeE(i12, i13, i14, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 20 | 0;
 i10 = i16;
 if (!(HEAP32[i12 + 16 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 if (!(HEAP32[i13 + 16 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 switch (i1 | 0) {
 case 2:
 case 1:
 case 0:
  {
   __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i13, i12, i1);
   STACKTOP = i16;
   return;
  }
 case 3:
  {
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   if (__Z21HasAlphaTextureFormat13TextureFormat(i1) | 0) if (__Z21HasAlphaTextureFormat13TextureFormat(i2) | 0) i3 = 8; else if ((i1 | 0) == 1) i11 = 1; else if ((i1 | 0) == 3) i11 = 3; else if ((i1 | 0) == 8) i11 = 8; else if ((i1 | 0) == 4) i11 = 4; else if ((i1 | 0) == 14) i11 = 14; else if ((i1 | 0) == 5) i11 = 5; else if ((i1 | 0) == 23) i11 = 23; else if ((i1 | 0) == 6) i11 = 6; else if ((i1 | 0) == 20) i11 = 20; else i3 = 11; else i3 = 8;
   if ((i3 | 0) == 8) if ((i1 | 0) == 1 | (i2 | 0) == 1) i11 = 1; else if ((i1 | 0) == 3 | (i2 | 0) == 3) i11 = 3; else if ((i1 | 0) == 8 | (i2 | 0) == 8) i11 = 8; else if ((i1 | 0) == 4 | (i2 | 0) == 4) i11 = 4; else if ((i1 | 0) == 14 | (i2 | 0) == 14) i11 = 14; else if ((i1 | 0) == 5 | (i2 | 0) == 5) i11 = 5; else if ((i1 | 0) == 23 | (i2 | 0) == 23) i11 = 23; else if ((i1 | 0) == 6 | (i2 | 0) == 6) i11 = 6; else if ((i1 | 0) == 20 | (i2 | 0) == 20) i11 = 20; else i3 = 11;
   if ((i3 | 0) == 11) if ((i1 | 0) == 2 | (i2 | 0) == 2) i11 = 5; else if ((i1 | 0) == 13 | (i2 | 0) == 13) i11 = 4; else i11 = (i1 | 0) == 7 | (i2 | 0) == 7 ? 3 : 0;
   i3 = (i11 | 0) != (HEAP32[i13 >> 2] | 0);
   i4 = (i11 | 0) != (HEAP32[i12 >> 2] | 0);
   i8 = i12 + 4 | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i13 + 4 >> 2] | 0;
   if ((i5 | 0) == (i9 | 0)) if ((HEAP32[i12 + 8 >> 2] | 0) == (HEAP32[i13 + 8 >> 2] | 0)) {
    __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i13, i12, 0);
    STACKTOP = i16;
    return;
   }
   i1 = i4 ^ 1;
   i2 = i3 ^ 1;
   if (!(i2 | i1)) {
    i1 = HEAP32[i13 + 8 >> 2] | 0;
    i2 = i15 + 4 | 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = i1;
    HEAP32[i2 >> 2] = i9;
    HEAP32[i15 >> 2] = i11;
    i2 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i11) | 0, i9) | 0;
    HEAP32[i15 + 12 >> 2] = i2;
    i6 = i11 >>> 0 < 9;
    if (i6) i3 = 1; else i3 = (i11 | 0) == 23 | (i11 + -13 | 0) >>> 0 < 9;
    i7 = (i11 | 0) != 0;
    if (i7 & ((i9 | 0) > 0 & (i1 | 0) > 0) & i3) {
     i9 = __Z19GetMaxBytesPerPixel13TextureFormat(i11) | 0;
     i5 = Math_imul(i2, i1) | 0;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + i5 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
     _memset(i1 + i5 | 0, 0, i9 | 0) | 0;
    } else i1 = 0;
    i5 = i15 + 16 | 0;
    HEAP32[i5 >> 2] = i1;
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i12 + 8 >> 2] | 0;
    i4 = i10 + 4 | 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP32[i10 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i10 >> 2] = i11;
    i4 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i11) | 0, i2) | 0;
    HEAP32[i10 + 12 >> 2] = i4;
    if (i6) i1 = 1; else i1 = (i11 | 0) == 23 | (i11 + -13 | 0) >>> 0 < 9;
    if (i7 & ((i2 | 0) > 0 & (i3 | 0) > 0) & i1) {
     i11 = __Z19GetMaxBytesPerPixel13TextureFormat(i11) | 0;
     i9 = Math_imul(i4, i3) | 0;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 + i9 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
     _memset(i1 + i9 | 0, 0, i11 | 0) | 0;
    } else i1 = 0;
    i11 = i10 + 16 | 0;
    HEAP32[i11 >> 2] = i1;
    __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i13, i15, 0);
    __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE(i15, i10, i14);
    __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i10, i12, 0);
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, gb + 63184 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, gb + 63184 | 0);
    STACKTOP = i16;
    return;
   }
   if (!(i3 | i1)) {
    i1 = HEAP32[i12 + 8 >> 2] | 0;
    i2 = i15 + 4 | 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = i1;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i15 >> 2] = i11;
    i2 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i11) | 0, i5) | 0;
    HEAP32[i15 + 12 >> 2] = i2;
    if (i11 >>> 0 < 9) i3 = 1; else i3 = (i11 | 0) == 23 | (i11 + -13 | 0) >>> 0 < 9;
    if ((i11 | 0) != 0 & ((i5 | 0) > 0 & (i1 | 0) > 0) & i3) {
     i11 = __Z19GetMaxBytesPerPixel13TextureFormat(i11) | 0;
     i10 = Math_imul(i2, i1) | 0;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 + i10 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
     _memset(i1 + i10 | 0, 0, i11 | 0) | 0;
    } else i1 = 0;
    i11 = i15 + 16 | 0;
    HEAP32[i11 >> 2] = i1;
    __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE(i13, i15, i14);
    __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i15, i12, 0);
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, gb + 63184 | 0);
    STACKTOP = i16;
    return;
   }
   if (i4 | i2) {
    __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE(i13, i12, i14);
    STACKTOP = i16;
    return;
   }
   i1 = HEAP32[i13 + 8 >> 2] | 0;
   i2 = i15 + 4 | 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i15 >> 2] = i11;
   i2 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i11) | 0, i9) | 0;
   HEAP32[i15 + 12 >> 2] = i2;
   if (i11 >>> 0 < 9) i3 = 1; else i3 = (i11 | 0) == 23 | (i11 + -13 | 0) >>> 0 < 9;
   if ((i11 | 0) != 0 & ((i9 | 0) > 0 & (i1 | 0) > 0) & i3) {
    i11 = __Z19GetMaxBytesPerPixel13TextureFormat(i11) | 0;
    i10 = Math_imul(i2, i1) | 0;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 + i10 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
    _memset(i1 + i10 | 0, 0, i11 | 0) | 0;
   } else i1 = 0;
   i11 = i15 + 16 | 0;
   HEAP32[i11 >> 2] = i1;
   __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i13, i15, 0);
   __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE(i15, i12, i14);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, gb + 63184 | 0);
   STACKTOP = i16;
   return;
  }
 default:
  {
   STACKTOP = i16;
   return;
  }
 }
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) break; else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i5;
   }
   i5 = i3 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i24 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 204 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    HEAP16[i17 >> 1] = i1;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) break; else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i5;
   }
   i5 = i3 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i24 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 202 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i1;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) break; else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i5;
   }
   i5 = i3 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i24 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 203 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i1;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN22UnityProfilerPerThread34CreateProfilerInformationForMethodEP12Il2CppObject21ScriptingMethodIl2CppPKcP11Il2CppClassS2_N19ProfilerInformation5FlagsE(i19, i1, i14, i13, i6, i4, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 296 | 0;
 i9 = i18 + 24 | 0;
 i15 = i18 + 40 | 0;
 i8 = i18 + 16 | 0;
 i5 = i18 + 304 | 0;
 i1 = i18 + 8 | 0;
 i3 = i18;
 i7 = i19 + 160 | 0;
 i17 = __ZN22ForwardLinearAllocator8allocateEjj(i7, 8, 4) | 0;
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(i17, 0, 1, i2 | 1);
 i11 = i14;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i11;
 HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i8 = __Z24scripting_class_get_nameP11Il2CppClass(__Z26scripting_method_get_class21ScriptingMethodIl2Cpp(i16) | 0) | 0;
 if (i6 | 0) {
  _memset(i5 | 0, 0, 256) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i3 = i13;
   i1 = i8;
  } else {
   i13 = i4;
   i8 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   i14 = i1;
   HEAP32[i14 >> 2] = i8;
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i1 = __Z24scripting_class_get_nameP11Il2CppClass(__Z26scripting_method_get_class21ScriptingMethodIl2Cpp(i16) | 0) | 0;
   i14 = i3;
   HEAP32[i14 >> 2] = i8;
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   i3 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i16) | 0;
  }
  if ((HEAP8[i1 >> 0] | 0) == 60) {
   i2 = _strchr(i1, 62) | 0;
   if (!i2) i12 = 31; else {
    i13 = i1 + 1 | 0;
    i14 = i2 - i13 | 0;
    _strncpy(i5, i13, (i14 | 0) > 256 ? 256 : i14) | 0;
   }
  } else i12 = 31;
  if ((i12 | 0) == 31) _strncpy(i5, i1, 256) | 0;
  HEAP32[i9 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i6) | 0;
  HEAP32[i9 + 4 >> 2] = i5;
  HEAP32[i9 + 8 >> 2] = i3;
  _snprintf(i15, 256, gb + 462377 | 0, i9) | 0;
  i5 = (_strlen(i15) | 0) + 1 | 0;
  i6 = __ZN22ForwardLinearAllocator8allocateEjj(i7, i5, 4) | 0;
  _memcpy(i6 | 0, i15 | 0, i5 | 0) | 0;
  HEAP32[i17 >> 2] = i6;
  i6 = i19 + 188 | 0;
  i5 = i17;
  i2 = i19 + 192 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  do if (!i1) {
   HEAP32[i9 >> 2] = i2;
   i4 = i2;
   i3 = i2;
  } else {
   i4 = i10;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i12 = 36;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i12 = 41;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i12 = 40;
      break;
     } else i1 = i2;
    }
   }
   if ((i12 | 0) == 36) {
    HEAP32[i9 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i12 | 0) == 40) {
    HEAP32[i9 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i12 | 0) == 41) {
    HEAP32[i9 >> 2] = i1;
    i4 = i1;
    i3 = i9;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = HEAP32[i19 + 196 >> 2] | 0;
   HEAP32[i16 >> 2] = 57;
   HEAP32[i16 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 + 16 >> 2] = i10;
   HEAP32[i1 + 20 >> 2] = i11;
   HEAP32[i1 + 24 >> 2] = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i6 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 + 192 >> 2] | 0, i1);
   i19 = i19 + 200 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  }
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!(HEAP8[i8 >> 0] | 0)) i1 = 4; else {
  i2 = 0;
  i1 = 4;
  do {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((HEAP8[i8 + i2 >> 0] | 0) != 0);
 }
 if (HEAP8[i13 >> 0] | 0) {
  i2 = 0;
  do {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((HEAP8[i13 + i2 >> 0] | 0) != 0);
 }
 i2 = __ZN22ForwardLinearAllocator8allocateEjj(i7, i1, 4) | 0;
 HEAP32[i17 >> 2] = i2;
 i1 = HEAP8[i8 >> 0] | 0;
 if (i1 << 24 >> 24) {
  i3 = 0;
  do {
   HEAP8[i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i8 + i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 HEAP8[i2 >> 0] = 46;
 i1 = i2 + 1 | 0;
 i3 = HEAP8[i13 >> 0] | 0;
 if (i3 << 24 >> 24) {
  i4 = 0;
  i2 = i1;
  while (1) {
   HEAP8[i2 >> 0] = i3;
   i4 = i4 + 1 | 0;
   i1 = i2 + 1 | 0;
   i3 = HEAP8[i13 + i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break; else i2 = i1;
  }
 }
 HEAP8[i1 >> 0] = 40;
 HEAP8[i2 + 2 >> 0] = 41;
 HEAP8[i2 + 3 >> 0] = 0;
 i8 = i19 + 188 | 0;
 i6 = i14;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i17;
 i2 = i19 + 192 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i15 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  i4 = i5;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i12 = 13;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i12 = 18;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i12 = 17;
     break;
    } else i1 = i2;
   }
  }
  if ((i12 | 0) == 13) {
   HEAP32[i15 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i12 | 0) == 17) {
   HEAP32[i15 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i12 | 0) == 18) {
   HEAP32[i15 >> 2] = i1;
   i4 = i1;
   i3 = i15;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i19 + 196 >> 2] | 0;
  HEAP32[i16 >> 2] = 57;
  HEAP32[i16 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = i5;
  HEAP32[i1 + 20 >> 2] = i6;
  HEAP32[i1 + 24 >> 2] = i7;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i8 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 + 192 >> 2] | 0, i1);
  i19 = i19 + 200 | 0;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 }
 STACKTOP = i18;
 return i17 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 200 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i3) {
    i3 = 0;
    i5 = 1;
   } else {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i3 = 0;
     i5 = 1;
    } else i5 = 0;
   }
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 20; else {
    i1 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i24 = 29;
      break L11;
     }
    } else i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 20;
     break;
    } else if (i5) break; else {
     i24 = 39;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 20) {
    i24 = 0;
    if (i5) {
     i4 = 0;
     i24 = 39;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i2 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 31;
     break;
    }
    i2 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i2 + i5;
   }
   i5 = i3 + 12 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i3 + 16 | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    }
   } else i1 = HEAP32[i1 >> 2] | 0;
   if (__ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i1, i14, i2, i12, i13, HEAP32[i11 >> 2] | 0, i22, i15, i16, i10) | 0) {
    i24 = 39;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 29;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i1 + 4;
    continue;
   }
  }
  if ((i24 | 0) == 29) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 39) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i1 = HEAP32[i16 >> 2] | 0;
    if ((i1 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i1 + 4;
     HEAP32[i1 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i1 = invoke_iiiii(fb + 206 | 0, i2 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L56 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i1;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i3) i2 = 1; else {
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i2 = 1;
     } else i2 = 0;
    }
    do if (!i4) i24 = 55; else {
     i1 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L56;
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i20 >> 2] = 0;
      i24 = 55;
      break;
     } else if (i2) break; else {
      i24 = 57;
      break;
     }
    } while (0);
    if ((i24 | 0) == 55) if (i2) i24 = 57;
    if ((i24 | 0) == 57) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN26AnimatorOverrideController21SetAnimatorControllerE4PPtrI25RuntimeAnimatorControllerE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i9 = i13 + 24 | 0;
 i10 = i13 + 20 | 0;
 i5 = i13 + 8 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i7 = (i8 | 0) == 0;
 do if (!i7) {
  HEAP32[i10 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 9;
  }
  if ((i12 | 0) == 7) i12 = 9;
  if ((i12 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(i8) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = i8;
  if (!i1) i12 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 18;
   }
  }
  if ((i12 | 0) == 16) i12 = 18;
  if ((i12 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178624 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 178624 + 28 >> 2] | 0) >>> 0) {
   HEAP32[i10 >> 2] = i8;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 25; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 25; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 27;
    }
   }
   if ((i12 | 0) == 25) i12 = 27;
   if ((i12 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
   i10 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   i12 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
   HEAP32[i6 >> 2] = i10;
   HEAP32[i6 + 4 >> 2] = i12;
   __Z6FormatPKcz(i5, gb + 912168 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 912223 | 0, 219, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i13;
   return;
  }
 } while (0);
 i5 = i11 + 80 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i8 | 0)) {
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 120 | 0;
 __ZN12UserListNode5ClearEv(i6);
 HEAP32[i5 >> 2] = i8;
 do if (!i7) {
  HEAP32[i10 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 36; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i8 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i8 + 28 >> 2] | 0;
    i4 = HEAP32[i8 + 32 >> 2] | 0;
    i1 = i8;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 36; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i12 = 38;
  }
  if ((i12 | 0) == 36) i12 = 38;
  if ((i12 | 0) == 38) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  if (!i1) i12 = 45; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 45; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 47;
   }
  }
  if ((i12 | 0) == 45) i12 = 47;
  if ((i12 | 0) == 47) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  __ZN8UserList7AddUserER12UserListNode(i1 + 32 | 0, i6);
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i11, gb + 1105796 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i41, i4, i5, i1, i2, i3, i12, i44, i42, i43) {
 i41 = i41 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i44 = i44 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f45 = f0;
 f33 = Math_fround(HEAPF32[i4 >> 2]);
 f32 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f30 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f36 = Math_fround(HEAPF32[i5 >> 2]);
 f35 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f40 = Math_fround(HEAPF32[i1 >> 2]);
 f39 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f11 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 while (1) {
  f6 = Math_fround(Math_fround(f33 + f36) * Math_fround(.5));
  f7 = Math_fround(Math_fround(f32 + f35) * Math_fround(.5));
  f8 = Math_fround(Math_fround(f31 + f34) * Math_fround(.5));
  f9 = Math_fround(Math_fround(f40 + f18) * Math_fround(.5));
  f21 = Math_fround(Math_fround(f39 + f19) * Math_fround(.5));
  f22 = Math_fround(Math_fround(f38 + f20) * Math_fround(.5));
  f23 = Math_fround(Math_fround(f14 + f10) * Math_fround(.5));
  f24 = Math_fround(Math_fround(f15 + f11) * Math_fround(.5));
  f25 = Math_fround(Math_fround(f16 + f13) * Math_fround(.5));
  f26 = Math_fround(f6 - f33);
  f27 = Math_fround(f7 - f32);
  f28 = Math_fround(f8 - f31);
  f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(Math_fround(f27 * f27) + Math_fround(f26 * f26)));
  if (f29 < Math_fround(1.0e4)) {
   f25 = f34;
   f7 = f35;
   f6 = f36;
   f24 = f37;
   f23 = f38;
   f22 = f39;
   f21 = f40;
   break;
  }
  i12 = f29 == Math_fround(0.0);
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f32 * f27)) - Math_fround(f33 * f26)) - Math_fround(f31 * f28)) / f29);
  i5 = f29 > Math_fround(1.0);
  f29 = i5 ? Math_fround(1.0) : f29;
  i5 = f29 > Math_fround(0.0);
  f29 = i5 ? f29 : Math_fround(0.0);
  f29 = i12 ? Math_fround(0.0) : f29;
  f45 = Math_fround(f33 + Math_fround(f26 * f29));
  f26 = Math_fround(f32 + Math_fround(f27 * f29));
  f27 = Math_fround(f31 + Math_fround(f28 * f29));
  f28 = i12 ? f33 : f45;
  f26 = i12 ? f32 : f26;
  f27 = i12 ? f31 : f27;
  f26 = Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)));
  f28 = Math_fround(f6 - f36);
  f27 = Math_fround(f7 - f35);
  f45 = Math_fround(f8 - f34);
  f29 = Math_fround(Math_fround(f45 * f45) + Math_fround(Math_fround(f27 * f27) + Math_fround(f28 * f28)));
  i12 = f29 == Math_fround(0.0);
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f35 * f27)) - Math_fround(f36 * f28)) - Math_fround(f34 * f45)) / f29);
  i5 = f29 > Math_fround(1.0);
  f29 = i5 ? Math_fround(1.0) : f29;
  i5 = f29 > Math_fround(0.0);
  f29 = i5 ? f29 : Math_fround(0.0);
  f29 = i12 ? Math_fround(0.0) : f29;
  f28 = Math_fround(f36 + Math_fround(f28 * f29));
  f27 = Math_fround(f35 + Math_fround(f27 * f29));
  f29 = Math_fround(f34 + Math_fround(f45 * f29));
  f28 = i12 ? f36 : f28;
  f27 = i12 ? f35 : f27;
  f29 = i12 ? f34 : f29;
  i12 = f26 > Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)));
  f27 = i12 ? Math_fround(0.0) : f30;
  f28 = i12 ? Math_fround(0.0) : f37;
  f29 = i12 ? Math_fround(0.0) : f17;
  f30 = f27;
  f37 = f28;
  f17 = f29;
  f33 = i12 ? f6 : f33;
  f36 = i12 ? f36 : f6;
  f32 = i12 ? f7 : f32;
  f35 = i12 ? f35 : f7;
  f31 = i12 ? f8 : f31;
  f34 = i12 ? f34 : f8;
  f40 = i12 ? f9 : f40;
  f18 = i12 ? f18 : f9;
  f39 = i12 ? f21 : f39;
  f19 = i12 ? f19 : f21;
  f38 = i12 ? f22 : f38;
  f20 = i12 ? f20 : f22;
  f14 = i12 ? f23 : f14;
  f10 = i12 ? f10 : f23;
  f15 = i12 ? f24 : f15;
  f11 = i12 ? f11 : f24;
  f16 = i12 ? f25 : f16;
  f13 = i12 ? f13 : f25;
 }
 f9 = Math_fround(f6 - f33);
 f8 = Math_fround(f7 - f32);
 f6 = Math_fround(f25 - f31);
 f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)));
 if (f7 == Math_fround(0.0)) {
  HEAP32[i44 >> 2] = 1;
  HEAPF32[i42 >> 2] = f21;
  HEAPF32[i42 + 4 >> 2] = f22;
  HEAPF32[i42 + 8 >> 2] = f23;
  HEAPF32[i42 + 12 >> 2] = f24;
  HEAPF32[i43 >> 2] = f14;
  HEAPF32[i43 + 4 >> 2] = f15;
  HEAPF32[i43 + 8 >> 2] = f16;
  HEAPF32[i43 + 12 >> 2] = f17;
  HEAPF32[i41 >> 2] = f33;
  HEAPF32[i41 + 8 >> 2] = f31;
  f45 = f30;
  f40 = f32;
  i44 = i41 + 4 | 0;
  HEAPF32[i44 >> 2] = f40;
  i44 = i41 + 12 | 0;
  HEAPF32[i44 >> 2] = f45;
  return;
 } else {
  f38 = Math_fround(f18 - f21);
  f36 = Math_fround(f19 - f22);
  f37 = Math_fround(f20 - f23);
  f39 = Math_fround(f10 - f14);
  f40 = Math_fround(f11 - f15);
  f35 = Math_fround(f13 - f16);
  f45 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f32 * f8)) - Math_fround(f33 * f9)) - Math_fround(f31 * f6)) / f7);
  i44 = f45 > Math_fround(1.0);
  f45 = i44 ? Math_fround(1.0) : f45;
  i44 = f45 > Math_fround(0.0);
  f45 = i44 ? f45 : Math_fround(0.0);
  f38 = Math_fround(f21 + Math_fround(f38 * f45));
  f36 = Math_fround(f22 + Math_fround(f36 * f45));
  f37 = Math_fround(f23 + Math_fround(f37 * f45));
  f39 = Math_fround(f14 + Math_fround(f39 * f45));
  f40 = Math_fround(f15 + Math_fround(f40 * f45));
  f45 = Math_fround(f16 + Math_fround(f35 * f45));
  HEAPF32[i42 >> 2] = f38;
  HEAPF32[i42 + 4 >> 2] = f36;
  HEAPF32[i42 + 8 >> 2] = f37;
  HEAPF32[i42 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i43 >> 2] = f39;
  HEAPF32[i43 + 4 >> 2] = f40;
  HEAPF32[i43 + 8 >> 2] = f45;
  HEAPF32[i43 + 12 >> 2] = Math_fround(0.0);
  f40 = Math_fround(f36 - f40);
  f45 = Math_fround(f37 - f45);
  HEAPF32[i41 >> 2] = Math_fround(f38 - f39);
  HEAPF32[i41 + 8 >> 2] = f45;
  f45 = Math_fround(0.0);
  i44 = i41 + 4 | 0;
  HEAPF32[i44 >> 2] = f40;
  i44 = i41 + 12 | 0;
  HEAPF32[i44 >> 2] = f45;
  return;
 }
}

function __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce(i1, i20, i10, i21, i22, d5) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i10 = i10 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 d5 = +d5;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i24 + 8 | 0;
 i2 = i24;
 i1 = i24 + 284 | 0;
 i7 = i24 + 72 | 0;
 i3 = i24 + 184 | 0;
 i28 = i24 + 68 | 0;
 i14 = i24 + 180 | 0;
 i15 = i24 + 177 | 0;
 i16 = i24 + 176 | 0;
 i25 = i24 + 56 | 0;
 i26 = i24 + 44 | 0;
 i27 = i24 + 32 | 0;
 i12 = i24 + 28 | 0;
 i6 = i24 + 76 | 0;
 i17 = i24 + 24 | 0;
 i18 = i24 + 20 | 0;
 i19 = i24 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAPF64[i13 >> 3] = d5;
 i1 = _snprintf(i1, 100, gb + 1080070 | 0, i13) | 0;
 do if (i1 >>> 0 > 99) {
  __THREW__ = 0;
  i1 = invoke_i(fb + 314 | 0) | 0;
  i23 = __THREW__;
  __THREW__ = 0;
  if (i23 & 1) {
   i2 = 0;
   i1 = 0;
   i23 = 8;
  } else {
   __THREW__ = 0;
   HEAPF64[i2 >> 3] = d5;
   i4 = invoke_iiiii(fb + 207 | 0, i7 | 0, i1 | 0, gb + 1080070 | 0, i2 | 0) | 0;
   i23 = __THREW__;
   __THREW__ = 0;
   if (i23 & 1) {
    i2 = 0;
    i1 = 0;
    i23 = 8;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) {
      i2 = 0;
      i1 = 0;
      i23 = 8;
      break;
     }
     i1 = HEAP32[i7 >> 2] | 0;
    }
    i3 = _malloc(i4) | 0;
    i2 = i3;
    if (!i3) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i23 = __THREW__;
     __THREW__ = 0;
     if (i23 & 1) i23 = 8; else {
      i3 = 0;
      i9 = i4;
      i11 = i2;
      i23 = 11;
     }
    } else {
     i9 = i4;
     i11 = i2;
     i23 = 11;
    }
   }
  }
 } else {
  i9 = i1;
  i11 = 0;
  i1 = 0;
  i23 = 11;
 } while (0);
 if ((i23 | 0) == 11) {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2804 | 0, i21 | 0) | 0;
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i2 = i11;
   i23 = 8;
  } else {
   HEAP32[i28 >> 2] = i2;
   __THREW__ = 0;
   i8 = invoke_iii(fb + 1145 | 0, i28 | 0, gb + 1474556 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   do if (i4 & 1) {
    i3 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    i4 = HEAP32[i7 >> 2] | 0;
    __THREW__ = 0;
    invoke_iiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, i4 | 0, i4 + i9 | 0, i3 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    if (!i9) i7 = 0; else i7 = (HEAP8[HEAP32[i7 >> 2] >> 0] | 0) == 45;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i25 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i26 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i26 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i27 >> 2] = 0;
    HEAP32[i27 + 4 >> 2] = 0;
    HEAP32[i27 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i27 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_viiiiiiiiii(fb + 13 | 0, i10 | 0, i7 | 0, i28 | 0, i14 | 0, i15 | 0, i16 | 0, i25 | 0, i26 | 0, i27 | 0, i12 | 0);
    i10 = __THREW__;
    __THREW__ = 0;
    if (i10 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     i4 = HEAP32[i12 >> 2] | 0;
     if ((i9 | 0) > (i4 | 0)) {
      i10 = HEAP8[i27 + 11 >> 0] | 0;
      i2 = HEAP8[i26 + 11 >> 0] | 0;
      i2 = (i10 << 24 >> 24 < 0 ? HEAP32[i27 + 4 >> 2] | 0 : i10 & 255) + (i9 - i4 << 1 | 1) + (i2 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i2 & 255) | 0;
     } else {
      i10 = HEAP8[i27 + 11 >> 0] | 0;
      i2 = HEAP8[i26 + 11 >> 0] | 0;
      i2 = (i10 << 24 >> 24 < 0 ? HEAP32[i27 + 4 >> 2] | 0 : i10 & 255) + 2 + (i2 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i2 & 255) | 0;
     }
     i2 = i2 + i4 | 0;
     do if (i2 >>> 0 > 100) {
      i6 = _malloc(i2) | 0;
      i2 = i6;
      if (!i6) {
       __THREW__ = 0;
       invoke_v(fb + 459 | 0);
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i3 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
        break;
       } else {
        i6 = 0;
        i4 = HEAP32[i12 >> 2] | 0;
        i23 = 37;
        break;
       }
      } else i23 = 37;
     } else {
      i2 = 0;
      i23 = 37;
     } while (0);
     if ((i23 | 0) == 37) {
      __THREW__ = 0;
      invoke_viiiiiiiiiiiiiii(fb + 3 | 0, i6 | 0, i17 | 0, i18 | 0, HEAP32[i21 + 4 >> 2] | 0, i3 | 0, i3 + i9 | 0, i8 | 0, i7 | 0, i14 | 0, HEAP8[i15 >> 0] | 0, HEAP8[i16 >> 0] | 0, i25 | 0, i26 | 0, i27 | 0, i4 | 0);
      i16 = __THREW__;
      __THREW__ = 0;
      if (!(i16 & 1)) {
       HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
       i20 = HEAP32[i17 >> 2] | 0;
       i3 = HEAP32[i18 >> 2] | 0;
       __THREW__ = 0;
       HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
       i3 = invoke_iiiiiii(fb + 146 | 0, i13 | 0, i6 | 0, i20 | 0, i3 | 0, i21 | 0, i22 | 0) | 0;
       i22 = __THREW__;
       __THREW__ = 0;
       if (!(i22 & 1)) {
        if (i2 | 0) _free(i2);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
        __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i28 >> 2] | 0) | 0;
        if (i11 | 0) _free(i11);
        if (i1 | 0) _free(i1);
        STACKTOP = i24;
        return i3 | 0;
       }
      }
      i3 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     }
     if (i2 | 0) _free(i2);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    i2 = HEAP32[i28 >> 2] | 0;
   } while (0);
   __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
   i2 = i11;
  }
 }
 if ((i23 | 0) == 8) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 if (i2 | 0) _free(i2);
 if (i1 | 0) _free(i1);
 ___resumeException(i3 | 0);
 return 0;
}

function __ZN8GUIStyle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 16 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 20 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 36 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 40 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 56 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 60 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 76 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 80 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 96 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 100 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 116 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 120 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 136 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 140 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 156 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 160 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 176 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 192 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 208 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 224 | 0, i6);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 240 | 0, i6);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 284 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 288 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 244 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 248 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 249 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 + 252 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 256 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 + 260 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i5 + 264 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 276 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 280 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 292 >> 0] = i1;
 i1 = i5 + 293 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i20, i2, i21, i1) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26 + 32 | 0;
 i23 = i26 + 16 | 0;
 i24 = i26;
 f25 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i9 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i9) {
  STACKTOP = i26;
  return;
 }
 i10 = i2 + 60 | 0;
 i11 = i2 + 80 | 0;
 i12 = i2 + 100 | 0;
 i13 = i2 + 120 | 0;
 i14 = i2 + 140 | 0;
 i15 = i2 + 160 | 0;
 i16 = i22 + 4 | 0;
 i17 = i22 + 8 | 0;
 i18 = i22 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i23 + 4 | 0;
 i4 = i23 + 8 | 0;
 i5 = i23 + 12 | 0;
 i6 = i24 + 4 | 0;
 i7 = i24 + 8 | 0;
 i8 = i24 + 12 | 0;
 i1 = 0;
 do {
  i27 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i27 >> 2]);
  f56 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f54 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i27 >> 2]);
  f52 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f49 = Math_fround(HEAPF32[i27 >> 2]);
  f48 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f47 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f46 = Math_fround(HEAPF32[i27 >> 2]);
  f44 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f45 = Math_fround(HEAPF32[i27 >> 2]);
  f43 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f37 = Math_fround(HEAPF32[i27 >> 2]);
  f35 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f46 = Math_fround(f57 + f46);
  f44 = Math_fround(f56 + f44);
  f28 = Math_fround(f55 + f28);
  f32 = Math_fround(f54 + f32);
  f45 = Math_fround(f53 + f45);
  f43 = Math_fround(f52 + f43);
  f30 = Math_fround(f51 + f30);
  f34 = Math_fround(f50 + f34);
  f37 = Math_fround(f49 + f37);
  f35 = Math_fround(f48 + f35);
  f39 = Math_fround(f47 + f39);
  f38 = Math_fround(f38 + Math_fround(HEAPF32[i27 + 12 >> 2]));
  f37 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f45 * f45)) + Math_fround(f37 * f37))))));
  f35 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f44 * f44) + Math_fround(f43 * f43)) + Math_fround(f35 * f35))))));
  f39 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f30 * f30)) + Math_fround(f39 * f39))))));
  f38 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f34 * f34)) + Math_fround(f38 * f38))))));
  i27 = f37 < Math_fround(0.0);
  f37 = i27 ? Math_fround(0.0) : f37;
  i27 = f35 < Math_fround(0.0);
  f35 = i27 ? Math_fround(0.0) : f35;
  i27 = f39 < Math_fround(0.0);
  f39 = i27 ? Math_fround(0.0) : f39;
  i27 = f38 < Math_fround(0.0);
  f38 = i27 ? Math_fround(0.0) : f38;
  i27 = f37 > Math_fround(1.0);
  f37 = i27 ? Math_fround(1.0) : f37;
  i27 = f35 > Math_fround(1.0);
  f35 = i27 ? Math_fround(1.0) : f35;
  i27 = f39 > Math_fround(1.0);
  f39 = i27 ? Math_fround(1.0) : f39;
  i27 = f38 > Math_fround(1.0);
  f38 = i27 ? Math_fround(1.0) : f38;
  HEAPF32[i22 >> 2] = f37;
  HEAPF32[i16 >> 2] = f35;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f38;
  i27 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i31 = (HEAP32[i27 >> 2] | 0) + -209354897 | 0;
  i42 = (HEAP32[i27 + 4 >> 2] | 0) + -209354897 | 0;
  i40 = (HEAP32[i27 + 8 >> 2] | 0) + -209354897 | 0;
  i27 = (HEAP32[i27 + 12 >> 2] | 0) + -209354897 | 0;
  i33 = (Math_imul(i31, 1790253981) | 0) + 1900727103 | 0;
  i41 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
  i36 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i29 = (Math_imul(i27, 1790253981) | 0) + 1900727103 | 0;
  i31 = i31 << 11 ^ i31;
  i42 = i42 << 11 ^ i42;
  i40 = i40 << 11 ^ i40;
  i27 = i27 << 11 ^ i27;
  f38 = Math_fround(Math_fround((i41 ^ i42 ^ i42 >>> 8) & 8388607 ^ i41 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f39 = Math_fround(Math_fround((i36 ^ i40 ^ i40 >>> 8) & 8388607 ^ i36 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i29 ^ i27 ^ i27 >>> 8) & 8388607 ^ i29 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i23 >> 2] = Math_fround(Math_fround((i33 ^ i31 ^ i31 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f38;
  HEAPF32[i4 >> 2] = f39;
  HEAPF32[i5 >> 2] = f35;
  i33 = i21 + (i1 << 2) | 0;
  f35 = Math_fround(HEAPF32[i33 >> 2]);
  i31 = i33 + 4 | 0;
  f39 = Math_fround(HEAPF32[i31 >> 2]);
  i29 = i33 + 8 | 0;
  f38 = Math_fround(HEAPF32[i29 >> 2]);
  i27 = i33 + 12 | 0;
  f37 = Math_fround(HEAPF32[i27 >> 2]);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i24, i20, i22, i23);
  f34 = Math_fround(HEAPF32[i24 >> 2]);
  i36 = f34 < Math_fround(0.0);
  f34 = i36 ? Math_fround(0.0) : f34;
  f32 = Math_fround(HEAPF32[i6 >> 2]);
  i36 = f32 < Math_fround(0.0);
  f32 = i36 ? Math_fround(0.0) : f32;
  f30 = Math_fround(HEAPF32[i7 >> 2]);
  i36 = f30 < Math_fround(0.0);
  f30 = i36 ? Math_fround(0.0) : f30;
  f28 = Math_fround(HEAPF32[i8 >> 2]);
  i36 = f28 < Math_fround(0.0);
  f32 = Math_fround(f39 * f32);
  f30 = Math_fround(f38 * f30);
  f28 = Math_fround(f37 * (i36 ? Math_fround(0.0) : f28));
  HEAPF32[i33 >> 2] = Math_fround(f35 * f34);
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i29 >> 2] = f30;
  HEAPF32[i27 >> 2] = f28;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i9 >>> 0);
 STACKTOP = i26;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 i5 = i10 + 44 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 60 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 76 | 0;
  i12 = i9 + 5 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 76 | 0;
 i12 = i9 + 5 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN44ConvexVsHeightfieldContactGenerationCallback7onEventEjPj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, i59 = 0, i60 = 0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i52 + 96 | 0;
 i51 = i52 + 48 | 0;
 i50 = i52 + 60 | 0;
 i47 = i52;
 i48 = i52 + 12 | 0;
 i40 = i49 + 848 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = (i3 + 15 | 0) >>> 4;
 if (!i41) {
  STACKTOP = i52;
  return 1;
 }
 i42 = i1 + 4 | 0;
 i43 = i49 + 832 | 0;
 i44 = i49 + 768 | 0;
 i45 = i49 + 576 | 0;
 i46 = i1 + 2228 | 0;
 i38 = i1 + 2216 | 0;
 i18 = i50 + 12 | 0;
 i19 = i50 + 16 | 0;
 i20 = i50 + 4 | 0;
 i21 = i50 + 20 | 0;
 i22 = i50 + 8 | 0;
 i23 = i50 + 24 | 0;
 i24 = i50 + 28 | 0;
 i25 = i50 + 32 | 0;
 i26 = i48 + 12 | 0;
 i27 = i48 + 16 | 0;
 i28 = i48 + 4 | 0;
 i29 = i48 + 20 | 0;
 i30 = i48 + 8 | 0;
 i31 = i48 + 24 | 0;
 i32 = i48 + 28 | 0;
 i33 = i48 + 32 | 0;
 i34 = i50 + 12 | 0;
 i35 = i50 + 24 | 0;
 i36 = i51 + 4 | 0;
 i37 = i51 + 8 | 0;
 i39 = 0;
 do {
  HEAP32[i40 >> 2] = 0;
  i17 = i3 >>> 0 < 16 ? i3 : 16;
  if (i17) {
   i7 = (i3 ^ -16) >>> 0 > 4294967279;
   i6 = i17;
   i16 = i2;
   do {
    i6 = i6 + -1 | 0;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i16 + 4 | 0;
    __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i50, i51, i47, i15, 0, 0) | 0;
    f13 = Math_fround(HEAPF32[i18 >> 2]);
    f11 = Math_fround(HEAPF32[i50 >> 2]);
    f13 = Math_fround(f13 - f11);
    f9 = Math_fround(HEAPF32[i19 >> 2]);
    f14 = Math_fround(HEAPF32[i20 >> 2]);
    f9 = Math_fround(f9 - f14);
    f12 = Math_fround(HEAPF32[i21 >> 2]);
    f10 = Math_fround(HEAPF32[i22 >> 2]);
    f12 = Math_fround(f12 - f10);
    f11 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f11);
    f14 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f14);
    f10 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f10);
    f8 = Math_fround(Math_fround(f9 * f10) - Math_fround(f12 * f14));
    f10 = Math_fround(Math_fround(f12 * f11) - Math_fround(f13 * f10));
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f9 * f11));
    f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10)))));
    if (f9 > Math_fround(0.0)) {
     f14 = Math_fround(Math_fround(1.0) / f9);
     f8 = Math_fround(f8 * f14);
     f10 = Math_fround(f10 * f14);
     f11 = Math_fround(f11 * f14);
    }
    i5 = 0;
    i1 = 0;
    do {
     i4 = HEAP32[i47 + (i5 << 2) >> 2] | 0;
     if ((i4 | 0) == -1) i1 = (1 << i5 + 3 | i1 & 255) & 255; else {
      __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i46 >> 2] | 0, HEAP32[i38 >> 2] | 0, i48, 0, 0, i4, 0, 0) | 0;
      f57 = Math_fround(HEAPF32[i26 >> 2]);
      f54 = Math_fround(HEAPF32[i48 >> 2]);
      f57 = Math_fround(f57 - f54);
      f55 = Math_fround(HEAPF32[i27 >> 2]);
      f53 = Math_fround(HEAPF32[i28 >> 2]);
      f55 = Math_fround(f55 - f53);
      f58 = Math_fround(HEAPF32[i29 >> 2]);
      f12 = Math_fround(HEAPF32[i30 >> 2]);
      f58 = Math_fround(f58 - f12);
      f9 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) - f54);
      f56 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) - f53);
      f14 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) - f12);
      f13 = Math_fround(Math_fround(f55 * f14) - Math_fround(f58 * f56));
      f14 = Math_fround(Math_fround(f58 * f9) - Math_fround(f57 * f14));
      f9 = Math_fround(Math_fround(f57 * f56) - Math_fround(f55 * f9));
      i4 = HEAPU8[gb + 768833 + i5 >> 0] | 0;
      f54 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) >> 2]) - f54);
      f53 = Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 4 >> 2]) - f53);
      if (Math_fround(Math_fround(Math_fround(f13 * f54) + Math_fround(f14 * f53)) + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i50 + (i4 * 12 | 0) + 8 >> 2]) - f12))) < Math_fround(0.0)) {
       f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)))));
       if (f12 > Math_fround(0.0)) {
        f58 = Math_fround(Math_fround(1.0) / f12);
        f13 = Math_fround(f13 * f58);
        f12 = Math_fround(f14 * f58);
        f9 = Math_fround(f9 * f58);
       } else f12 = f14;
       if (Math_fround(Math_fround(f11 * f9) + Math_fround(Math_fround(f10 * f12) + Math_fround(f8 * f13))) < Math_fround(.999000012)) i1 = (1 << i5 + 3 | i1 & 255) & 255;
      }
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 3);
    i5 = HEAP32[i40 >> 2] | 0;
    HEAP32[i40 >> 2] = i5 + 1;
    i60 = i5 * 3 | 0;
    HEAP32[i49 + (i60 * 12 | 0) >> 2] = HEAP32[i50 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 4 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i49 + (i60 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    i59 = i60 + 1 | 0;
    HEAP32[i49 + (i59 * 12 | 0) >> 2] = HEAP32[i34 >> 2];
    HEAP32[i49 + (i59 * 12 | 0) + 4 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i49 + (i59 * 12 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
    i4 = i60 + 2 | 0;
    HEAP32[i49 + (i4 * 12 | 0) >> 2] = HEAP32[i35 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i49 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i49 + 576 + (i60 << 2) >> 2] = HEAP32[i51 >> 2];
    HEAP32[i49 + 576 + (i59 << 2) >> 2] = HEAP32[i36 >> 2];
    HEAP32[i49 + 576 + (i4 << 2) >> 2] = HEAP32[i37 >> 2];
    HEAP32[i49 + 768 + (i5 << 2) >> 2] = i15;
    HEAP8[i49 + 832 + i5 >> 0] = i1;
   } while ((i6 | 0) != 0);
   i2 = i2 + ((i7 ? i3 : 16) << 2) | 0;
   i1 = HEAP32[i40 >> 2] | 0;
   if (i1) {
    i4 = i43;
    i5 = i44;
    i6 = i45;
    i7 = i49;
    while (1) {
     i1 = i1 + -1 | 0;
     __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj(i42, i7, HEAP32[i5 >> 2] | 0, HEAP8[i4 >> 0] | 0, i6) | 0;
     if (!i1) break; else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 4 | 0;
      i6 = i6 + 12 | 0;
      i7 = i7 + 36 | 0;
     }
    }
   }
  }
  i3 = i3 - i17 | 0;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) != (i41 | 0));
 STACKTOP = i52;
 return 1;
}

function __ZN5physx23PxVehicleWheels4DynData17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i14 >> 2] = HEAP32[gb + 163248 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 163248 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 163248 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 163248 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 163248 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 163248 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 163248 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 163248 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 163280 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 163280 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 163280 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 163280 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 163280 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 163280 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 163280 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 163280 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 163312 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 163312 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 163312 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 163312 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 163312 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 163312 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 163312 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 163312 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 163344 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 163344 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 163344 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 163344 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 163344 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 163344 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 163344 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 163344 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 163376 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 163376 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 163376 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 163376 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 163376 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 163376 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 163376 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 163376 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 163408 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 163408 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 163408 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 163408 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 163408 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 163408 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 163408 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 163408 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 163440 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 163440 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 163440 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 163440 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 163440 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 163440 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 163440 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 163440 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 163472 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 163472 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 163472 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 163472 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 163472 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 163472 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 163472 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 163472 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 163504 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 163504 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 163504 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 163504 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 163504 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 163504 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 163504 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 163504 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 163536 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 163536 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 163536 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 163536 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 163536 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 163536 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 163536 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 163536 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 163568 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 163568 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 163568 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 163568 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 163568 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 163568 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 163568 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 163568 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 163600 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 163600 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 163600 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 163600 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 163600 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 163600 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 163600 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 163600 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN9ShaderLab21SerializedShaderStateC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 20 >> 2] = -1;
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 28 >> 2] = -1;
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 36 >> 2] = -1;
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 44 >> 2] = -1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 52 >> 2] = -1;
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 60 >> 2] = -1;
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 68 >> 2] = -1;
 HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 76 >> 2] = -1;
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 84 >> 2] = -1;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 92 >> 2] = -1;
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 100 >> 2] = -1;
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 108 >> 2] = -1;
 HEAPF32[i1 + 112 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 116 >> 2] = -1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 124 >> 2] = -1;
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 132 >> 2] = -1;
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 140 >> 2] = -1;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 148 >> 2] = -1;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 156 >> 2] = -1;
 HEAPF32[i1 + 160 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 164 >> 2] = -1;
 HEAPF32[i1 + 168 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 172 >> 2] = -1;
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 180 >> 2] = -1;
 HEAPF32[i1 + 184 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 188 >> 2] = -1;
 HEAPF32[i1 + 192 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 196 >> 2] = -1;
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 204 >> 2] = -1;
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 212 >> 2] = -1;
 HEAPF32[i1 + 216 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 220 >> 2] = -1;
 HEAPF32[i1 + 224 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 228 >> 2] = -1;
 HEAPF32[i1 + 232 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 236 >> 2] = -1;
 HEAPF32[i1 + 240 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 244 >> 2] = -1;
 HEAPF32[i1 + 248 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 252 >> 2] = -1;
 HEAPF32[i1 + 256 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 260 >> 2] = -1;
 HEAPF32[i1 + 264 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 268 >> 2] = -1;
 HEAPF32[i1 + 272 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 276 >> 2] = -1;
 HEAPF32[i1 + 280 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 284 >> 2] = -1;
 HEAPF32[i1 + 288 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 292 >> 2] = -1;
 HEAPF32[i1 + 296 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 300 >> 2] = -1;
 HEAPF32[i1 + 304 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 308 >> 2] = -1;
 HEAPF32[i1 + 312 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 316 >> 2] = -1;
 HEAPF32[i1 + 320 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 324 >> 2] = -1;
 HEAPF32[i1 + 328 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 332 >> 2] = -1;
 HEAPF32[i1 + 336 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 340 >> 2] = -1;
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 348 >> 2] = -1;
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 356 >> 2] = -1;
 HEAPF32[i1 + 360 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 364 >> 2] = -1;
 HEAPF32[i1 + 368 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 372 >> 2] = -1;
 HEAPF32[i1 + 376 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 380 >> 2] = -1;
 HEAPF32[i1 + 384 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 388 >> 2] = -1;
 HEAPF32[i1 + 392 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 396 >> 2] = -1;
 HEAPF32[i1 + 400 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 404 >> 2] = -1;
 HEAPF32[i1 + 408 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 412 >> 2] = -1;
 HEAPF32[i1 + 416 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 420 >> 2] = -1;
 HEAPF32[i1 + 424 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 428 >> 2] = -1;
 HEAPF32[i1 + 432 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 436 >> 2] = -1;
 HEAPF32[i1 + 440 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 444 >> 2] = -1;
 HEAPF32[i1 + 448 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 452 >> 2] = -1;
 HEAPF32[i1 + 456 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 460 >> 2] = -1;
 HEAPF32[i1 + 464 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 468 >> 2] = -1;
 HEAPF32[i1 + 472 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 476 >> 2] = -1;
 HEAPF32[i1 + 480 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 484 >> 2] = -1;
 HEAPF32[i1 + 488 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 492 >> 2] = -1;
 HEAPF32[i1 + 496 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 500 >> 2] = -1;
 HEAPF32[i1 + 504 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 508 >> 2] = -1;
 HEAPF32[i1 + 512 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 516 >> 2] = -1;
 HEAPF32[i1 + 520 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 524 >> 2] = -1;
 HEAPF32[i1 + 528 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 532 >> 2] = -1;
 HEAPF32[i1 + 536 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 540 >> 2] = -1;
 HEAPF32[i1 + 544 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 548 >> 2] = -1;
 HEAPF32[i1 + 552 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 556 >> 2] = -1;
 HEAPF32[i1 + 560 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 564 >> 2] = -1;
 HEAPF32[i1 + 568 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 572 >> 2] = -1;
 HEAPF32[i1 + 576 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 580 >> 2] = -1;
 HEAPF32[i1 + 584 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 588 >> 2] = -1;
 HEAPF32[i1 + 592 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 596 >> 2] = -1;
 HEAPF32[i1 + 600 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 604 >> 2] = -1;
 HEAPF32[i1 + 608 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 612 >> 2] = -1;
 HEAPF32[i1 + 616 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 620 >> 2] = -1;
 HEAPF32[i1 + 624 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 628 >> 2] = -1;
 HEAPF32[i1 + 632 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 636 >> 2] = -1;
 HEAPF32[i1 + 640 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 644 >> 2] = -1;
 HEAPF32[i1 + 648 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 652 >> 2] = -1;
 HEAPF32[i1 + 656 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 660 >> 2] = -1;
 HEAPF32[i1 + 664 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 668 >> 2] = -1;
 HEAPF32[i1 + 672 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 676 >> 2] = -1;
 HEAPF32[i1 + 680 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 684 >> 2] = -1;
 HEAP32[i1 + 688 >> 2] = -1;
 HEAP32[i1 + 704 >> 2] = 0;
 HEAP32[i1 + 708 >> 2] = 0;
 HEAP32[i1 + 700 >> 2] = i1 + 704;
 HEAP8[i1 + 716 >> 0] = 0;
 HEAP8[i1 + 717 >> 0] = 0;
 return;
}

function __ZN9Heightmap23RecalculateMinMaxHeightEiii(i15, i16, i17, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, f20 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 4 | 0;
 i12 = i18;
 do if (!i14) {
  i11 = HEAP32[i15 + 76 >> 2] | 0;
  i1 = Math_imul(i11, i16 << 4) | 0;
  i7 = i1 + (i11 * 17 | 0) | 0;
  i8 = i17 << 4;
  if ((i11 | 0) > 0) {
   i9 = HEAP32[i15 + 4 >> 2] | 0;
   i10 = i8 + 16 | 0;
   i2 = 32767;
   i5 = -32768;
   do {
    i6 = i8;
    while (1) {
     i19 = HEAP16[i9 + (i6 + i1 << 1) >> 1] | 0;
     i2 = i19 << 16 >> 16 < i2 << 16 >> 16 ? i19 : i2;
     i5 = i5 << 16 >> 16 < i19 << 16 >> 16 ? i19 : i5;
     if ((i6 | 0) >= (i10 | 0)) break; else i6 = i6 + 1 | 0;
    }
    i1 = i11 + i1 | 0;
   } while ((i1 | 0) < (i7 | 0));
   f4 = Math_fround(i2 << 16 >> 16);
   f3 = Math_fround(i5 << 16 >> 16);
  } else {
   f4 = Math_fround(32767.0);
   f3 = Math_fround(-32768.0);
  }
  f20 = Math_fround(f4 / Math_fround(32766.0));
  HEAPF32[i13 >> 2] = f20;
  f4 = Math_fround(f3 / Math_fround(32766.0));
  HEAPF32[i12 >> 2] = f4;
  i7 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = HEAP32[i15 + 80 >> 2] | 0;
 } else {
  HEAP32[i13 >> 2] = 2139095040;
  HEAP32[i12 >> 2] = -8388608;
  i8 = i16 << 1;
  i9 = i17 << 1;
  i10 = i14 + -1 | 0;
  i1 = HEAP32[i15 + 80 >> 2] | 0;
  i7 = 1 << i1;
  i11 = HEAP32[i15 + 44 >> 2] | 0;
  if ((i14 | 0) > 1) {
   i2 = i7;
   i5 = 0;
   i6 = 0;
  } else {
   i7 = i8 + (i9 << i1) | 0;
   i6 = i7 << 1;
   i19 = i11 + (i6 << 2) | 0;
   i5 = Math_fround(HEAPF32[i19 >> 2]) < Math_fround(inf);
   i19 = HEAP32[(i5 ? i19 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i19;
   i6 = i11 + ((i6 | 1) << 2) | 0;
   i5 = Math_fround(HEAPF32[i6 >> 2]) > Math_fround(-inf);
   i6 = HEAP32[(i5 ? i6 : i12) >> 2] | 0;
   HEAP32[i12 >> 2] = i6;
   i7 = (i7 << 1) + 2 | 0;
   i5 = i11 + (i7 << 2) | 0;
   f20 = Math_fround(HEAPF32[i5 >> 2]);
   i19 = f20 < (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i5 = HEAP32[(i19 ? i5 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i5;
   i7 = i11 + ((i7 | 1) << 2) | 0;
   f20 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i6 = f20 < Math_fround(HEAPF32[i7 >> 2]);
   i7 = HEAP32[(i6 ? i7 : i12) >> 2] | 0;
   HEAP32[i12 >> 2] = i7;
   i6 = i8 + ((i9 | 1) << i1) | 0;
   i19 = i6 << 1;
   i10 = i11 + (i19 << 2) | 0;
   f20 = Math_fround(HEAPF32[i10 >> 2]);
   i9 = f20 < (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i10 = HEAP32[(i9 ? i10 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i10;
   i19 = i11 + ((i19 | 1) << 2) | 0;
   f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = f20 < Math_fround(HEAPF32[i19 >> 2]);
   i19 = HEAP32[(i7 ? i19 : i12) >> 2] | 0;
   HEAP32[i12 >> 2] = i19;
   i6 = (i6 << 1) + 2 | 0;
   i7 = i11 + (i6 << 2) | 0;
   f20 = Math_fround(HEAPF32[i7 >> 2]);
   i10 = f20 < (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = HEAP32[(i10 ? i7 : i13) >> 2] | 0;
   HEAP32[i13 >> 2] = i7;
   i6 = i11 + ((i6 | 1) << 2) | 0;
   f20 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i19 = f20 < Math_fround(HEAPF32[i6 >> 2]);
   i6 = HEAP32[(i19 ? i6 : i12) >> 2] | 0;
   HEAP32[i12 >> 2] = i6;
   break;
  }
  do {
   i5 = (Math_imul(i2, i2) | 0) + i5 | 0;
   i2 = i2 >> 1;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i10 | 0));
  i2 = i5 + i8 + (Math_imul(i2, i9) | 0) | 0;
  i6 = i2 << 1;
  i19 = i11 + (i6 << 2) | 0;
  i5 = Math_fround(HEAPF32[i19 >> 2]) < Math_fround(inf);
  i19 = HEAP32[(i5 ? i19 : i13) >> 2] | 0;
  HEAP32[i13 >> 2] = i19;
  i6 = i11 + ((i6 | 1) << 2) | 0;
  i5 = Math_fround(HEAPF32[i6 >> 2]) > Math_fround(-inf);
  i6 = HEAP32[(i5 ? i6 : i12) >> 2] | 0;
  HEAP32[i12 >> 2] = i6;
  i2 = (i2 << 1) + 2 | 0;
  i5 = i11 + (i2 << 2) | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  i19 = f3 < (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i5 = HEAP32[(i19 ? i5 : i13) >> 2] | 0;
  HEAP32[i13 >> 2] = i5;
  i2 = i11 + ((i2 | 1) << 2) | 0;
  f3 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = f3 < Math_fround(HEAPF32[i2 >> 2]);
  i2 = HEAP32[(i6 ? i2 : i12) >> 2] | 0;
  HEAP32[i12 >> 2] = i2;
  f3 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i2 = i7;
  i5 = 0;
  i6 = 0;
  do {
   i5 = (Math_imul(i2, i2) | 0) + i5 | 0;
   i2 = i2 >> 1;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i10 | 0));
  i6 = i5 + i8 + (Math_imul(i2, i9 | 1) | 0) | 0;
  i19 = i6 << 1;
  i10 = i11 + (i19 << 2) | 0;
  i7 = Math_fround(HEAPF32[i10 >> 2]) < f3;
  i10 = HEAP32[(i7 ? i10 : i13) >> 2] | 0;
  HEAP32[i13 >> 2] = i10;
  i19 = i11 + ((i19 | 1) << 2) | 0;
  i7 = f4 < Math_fround(HEAPF32[i19 >> 2]);
  i19 = HEAP32[(i7 ? i19 : i12) >> 2] | 0;
  HEAP32[i12 >> 2] = i19;
  i6 = (i6 << 1) + 2 | 0;
  i7 = i11 + (i6 << 2) | 0;
  f20 = Math_fround(HEAPF32[i7 >> 2]);
  i10 = f20 < (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i7 = HEAP32[(i10 ? i7 : i13) >> 2] | 0;
  HEAP32[i13 >> 2] = i7;
  i6 = i11 + ((i6 | 1) << 2) | 0;
  f20 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i19 = f20 < Math_fround(HEAPF32[i6 >> 2]);
  i6 = HEAP32[(i19 ? i6 : i12) >> 2] | 0;
  HEAP32[i12 >> 2] = i6;
 } while (0);
 i1 = 1 << i1;
 if ((i14 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  i5 = 0;
 } else {
  i19 = i1;
  i14 = 0;
  i19 = Math_imul(i19, i17) | 0;
  i17 = i14 + i16 | 0;
  i19 = i17 + i19 | 0;
  i19 = i19 << 1;
  i17 = i15 + 44 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  i16 = i17 + (i19 << 2) | 0;
  HEAP32[i16 >> 2] = i7;
  i19 = i19 | 1;
  i19 = i17 + (i19 << 2) | 0;
  HEAP32[i19 >> 2] = i6;
  STACKTOP = i18;
  return;
 }
 do {
  i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
  i2 = i2 >> 1;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i14 | 0));
 i19 = Math_imul(i2, i17) | 0;
 i17 = i1 + i16 | 0;
 i19 = i17 + i19 | 0;
 i19 = i19 << 1;
 i17 = i15 + 44 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 i16 = i17 + (i19 << 2) | 0;
 HEAP32[i16 >> 2] = i7;
 i19 = i19 | 1;
 i19 = i17 + (i19 << 2) | 0;
 HEAP32[i19 >> 2] = i6;
 STACKTOP = i18;
 return;
}

function __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb(i10, i27, i26, f11, f9, i17, i28, i24, f18, f16, i1) {
 i10 = i10 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 f11 = Math_fround(f11);
 f9 = Math_fround(f9);
 i17 = i17 | 0;
 i28 = i28 | 0;
 i24 = i24 | 0;
 f18 = Math_fround(f18);
 f16 = Math_fround(f16);
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, f29 = f0, f30 = f0, f31 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i25 + 32 | 0;
 i15 = i25;
 i8 = HEAP16[i10 + 8 >> 1] | 0;
 f6 = Math_fround(HEAPF32[i27 >> 2]);
 i22 = i27 + 4 | 0;
 f7 = Math_fround(HEAPF32[i22 >> 2]);
 i23 = i27 + 8 | 0;
 f2 = Math_fround(HEAPF32[i23 >> 2]);
 i19 = i27 + 16 | 0;
 f3 = Math_fround(HEAPF32[i19 >> 2]);
 i20 = i27 + 20 | 0;
 f4 = Math_fround(HEAPF32[i20 >> 2]);
 i21 = i27 + 24 | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 if (i8 << 16 >> 16 == -1) {
  f29 = Math_fround(f6 * f11);
  f30 = Math_fround(f7 * f11);
  f2 = Math_fround(f2 * f11);
  f6 = Math_fround(f3 * f9);
  f7 = Math_fround(f4 * f9);
  f11 = Math_fround(f5 * f9);
  i14 = HEAP32[i10 + 4 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i14 + 48 >> 2]);
  f9 = Math_fround(f30 * f5);
  f3 = Math_fround(f2 * f5);
  HEAPF32[i26 >> 2] = Math_fround(f29 * f5);
  HEAPF32[i26 + 4 >> 2] = f9;
  HEAPF32[i26 + 8 >> 2] = f3;
  f3 = Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2]));
  f9 = Math_fround(f6 * Math_fround(HEAPF32[i14 + 4 >> 2]));
  f5 = Math_fround(f6 * Math_fround(HEAPF32[i14 + 8 >> 2]));
  f6 = Math_fround(f7 * Math_fround(HEAPF32[i14 + 12 >> 2]));
  f4 = Math_fround(f7 * Math_fround(HEAPF32[i14 + 16 >> 2]));
  f6 = Math_fround(f3 + f6);
  f4 = Math_fround(f9 + f4);
  f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i14 + 20 >> 2])));
  f7 = Math_fround(f11 * Math_fround(HEAPF32[i14 + 24 >> 2]));
  f9 = Math_fround(f11 * Math_fround(HEAPF32[i14 + 28 >> 2]));
  f9 = Math_fround(f4 + f9);
  f11 = Math_fround(f5 + Math_fround(f11 * Math_fround(HEAPF32[i14 + 32 >> 2])));
  HEAPF32[i26 + 16 >> 2] = Math_fround(f6 + f7);
  HEAPF32[i26 + 20 >> 2] = f9;
  HEAPF32[i26 + 24 >> 2] = f11;
 } else {
  i14 = HEAP32[i10 >> 2] | 0;
  f31 = Math_fround(f7 * f11);
  f2 = Math_fround(f2 * f11);
  f7 = Math_fround(f3 * f9);
  f29 = Math_fround(f4 * f9);
  f30 = Math_fround(f5 * f9);
  HEAPF32[i1 >> 2] = Math_fround(f6 * f11);
  HEAPF32[i1 + 4 >> 2] = f31;
  HEAPF32[i1 + 8 >> 2] = f2;
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 16 >> 2] = f7;
  HEAPF32[i1 + 20 >> 2] = f29;
  HEAPF32[i1 + 24 >> 2] = f30;
  HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
  __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(i14, i8 & 65535, i1, i26);
 }
 i1 = HEAP16[i17 + 8 >> 1] | 0;
 f2 = Math_fround(HEAPF32[i28 >> 2]);
 i8 = i28 + 4 | 0;
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = i28 + 8 | 0;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 i12 = i28 + 16 | 0;
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i28 + 20 | 0;
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i28 + 24 | 0;
 f7 = Math_fround(HEAPF32[i14 >> 2]);
 if (i1 << 16 >> 16 == -1) {
  f11 = Math_fround(f2 * f18);
  f30 = Math_fround(f3 * f18);
  f18 = Math_fround(f4 * f18);
  f29 = Math_fround(f5 * f16);
  f31 = Math_fround(f6 * f16);
  f2 = Math_fround(f7 * f16);
  i17 = HEAP32[i17 + 4 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i17 + 48 >> 2]);
  f3 = Math_fround(f11 * f5);
  f4 = Math_fround(f30 * f5);
  f5 = Math_fround(f18 * f5);
  HEAPF32[i24 >> 2] = f3;
  HEAPF32[i24 + 4 >> 2] = f4;
  HEAPF32[i24 + 8 >> 2] = f5;
  f18 = Math_fround(f29 * Math_fround(HEAPF32[i17 >> 2]));
  f7 = Math_fround(f29 * Math_fround(HEAPF32[i17 + 4 >> 2]));
  f6 = Math_fround(f29 * Math_fround(HEAPF32[i17 + 8 >> 2]));
  f29 = Math_fround(f31 * Math_fround(HEAPF32[i17 + 12 >> 2]));
  f30 = Math_fround(f31 * Math_fround(HEAPF32[i17 + 16 >> 2]));
  f29 = Math_fround(f18 + f29);
  f30 = Math_fround(f7 + f30);
  f31 = Math_fround(f6 + Math_fround(f31 * Math_fround(HEAPF32[i17 + 20 >> 2])));
  f6 = Math_fround(f2 * Math_fround(HEAPF32[i17 + 24 >> 2]));
  f7 = Math_fround(f2 * Math_fround(HEAPF32[i17 + 28 >> 2]));
  f6 = Math_fround(f29 + f6);
  f7 = Math_fround(f30 + f7);
  f2 = Math_fround(f31 + Math_fround(f2 * Math_fround(HEAPF32[i17 + 32 >> 2])));
  HEAPF32[i24 + 16 >> 2] = f6;
  HEAPF32[i24 + 20 >> 2] = f7;
  HEAPF32[i24 + 24 >> 2] = f2;
 } else {
  i17 = HEAP32[i17 >> 2] | 0;
  f30 = Math_fround(f3 * f18);
  f31 = Math_fround(f4 * f18);
  f5 = Math_fround(f5 * f16);
  f4 = Math_fround(f6 * f16);
  f3 = Math_fround(f7 * f16);
  HEAPF32[i15 >> 2] = Math_fround(f2 * f18);
  HEAPF32[i15 + 4 >> 2] = f30;
  HEAPF32[i15 + 8 >> 2] = f31;
  HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 16 >> 2] = f5;
  HEAPF32[i15 + 20 >> 2] = f4;
  HEAPF32[i15 + 24 >> 2] = f3;
  HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
  __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(i17, i1 & 65535, i15, i24);
  f3 = Math_fround(HEAPF32[i24 >> 2]);
  f4 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i24 + 16 >> 2]);
  f7 = Math_fround(HEAPF32[i24 + 20 >> 2]);
  f2 = Math_fround(HEAPF32[i24 + 24 >> 2]);
 }
 f31 = Math_fround(HEAPF32[i27 >> 2]);
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i26 >> 2]));
 f29 = Math_fround(HEAPF32[i22 >> 2]);
 f29 = Math_fround(f31 + Math_fround(f29 * Math_fround(HEAPF32[i26 + 4 >> 2])));
 f31 = Math_fround(HEAPF32[i23 >> 2]);
 f31 = Math_fround(f29 + Math_fround(f31 * Math_fround(HEAPF32[i26 + 8 >> 2])));
 f29 = Math_fround(HEAPF32[i19 >> 2]);
 f29 = Math_fround(f29 * Math_fround(HEAPF32[i26 + 16 >> 2]));
 f30 = Math_fround(HEAPF32[i20 >> 2]);
 f30 = Math_fround(f29 + Math_fround(f30 * Math_fround(HEAPF32[i26 + 20 >> 2])));
 f29 = Math_fround(HEAPF32[i21 >> 2]);
 f29 = Math_fround(f31 + Math_fround(f30 + Math_fround(f29 * Math_fround(HEAPF32[i26 + 24 >> 2]))));
 f30 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) * f3);
 f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f4));
 f30 = Math_fround(f30 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f5));
 f31 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f6);
 f31 = Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f7));
 f31 = Math_fround(f29 + Math_fround(f30 + Math_fround(f31 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f2))));
 STACKTOP = i25;
 return Math_fround(f31);
}

function __ZN5physx2Sc16ArticulationCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i14 >> 2] = HEAP32[gb + 129572 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 129572 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 129572 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[gb + 129572 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[gb + 129572 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[gb + 129572 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[gb + 129572 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[gb + 129572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 129604 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 129604 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 129604 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 129604 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 129604 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 129604 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 129604 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 129604 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 129636 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 129636 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 129636 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 129636 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 129636 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 129636 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 129636 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 129636 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 129668 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 129668 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 129668 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 129668 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 129668 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 129668 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 129668 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 129668 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 129700 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 129700 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 129700 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 129700 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 129700 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 129700 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 129700 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 129700 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 129732 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 129732 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 129732 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 129732 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 129732 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 129732 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 129732 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 129732 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 129764 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 129764 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 129764 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 129764 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 129764 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 129764 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 129764 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 129764 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 129796 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 129796 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 129796 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 129796 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 129796 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 129796 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 129796 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 129796 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 129828 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 129828 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 129828 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 129828 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 129828 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 129828 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 129828 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 129828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 129860 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 129860 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 129860 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 129860 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 129860 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 129860 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 129860 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 129860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 129892 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 129892 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 129892 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 129892 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 129892 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 129892 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 129892 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 129892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 129924 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 129924 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 129924 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 129924 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 129924 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 129924 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 129924 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 129924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z23dtNavMeshDataSwapEndianPhi(i2, i13) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 if ((HEAP32[i2 >> 2] | 0) != 1145979222) {
  i15 = 0;
  return i15 | 0;
 }
 if ((HEAP32[i2 + 4 >> 2] | 0) != 16) {
  i15 = 0;
  return i15 | 0;
 }
 i4 = i2 + 24 | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 i5 = i2 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i2 + 28 | 0;
 i9 = i2 + 32 | 0;
 i11 = i2 + 36 | 0;
 i14 = i2 + 40 | 0;
 i3 = i2 + 72 | 0;
 i6 = i3 + (i16 * 12 | 0) | 0;
 i8 = i6 + (i1 << 5) | 0;
 i10 = i8 + ((HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 i12 = i10 + ((HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
 i15 = i12 + (HEAP32[i11 >> 2] << 3) | 0;
 i2 = i15 + (HEAP32[i14 >> 2] << 4) - i2 | 0;
 if ((i16 | 0) > 0) {
  i1 = 0;
  do {
   i16 = i3 + (i1 << 2) | 0;
   i18 = i16 + 3 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i18 = i16 + 1 | 0;
   i16 = i16 + 2 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < ((HEAP32[i4 >> 2] | 0) * 3 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 | 0) > 0) {
  i1 = 0;
  do {
   i18 = i6 + (i1 << 5) | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i6 + (i1 << 5) + 12 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i6 + (i1 << 5) + 2 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i6 + (i1 << 5) + 14 | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i6 + (i1 << 5) + 4 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i6 + (i1 << 5) + 16 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i6 + (i1 << 5) + 6 | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i6 + (i1 << 5) + 18 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i6 + (i1 << 5) + 8 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i6 + (i1 << 5) + 20 | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i6 + (i1 << 5) + 10 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i6 + (i1 << 5) + 22 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i6 + (i1 << 5) + 24 | 0;
   i16 = i18 + 3 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i18 + 1 | 0;
   i18 = i18 + 2 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
 }
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i17 = i8 + (i1 * 12 | 0) | 0;
   i16 = i17 + 3 | 0;
   i18 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i18;
   i16 = i17 + 1 | 0;
   i17 = i17 + 2 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i8 + (i1 * 12 | 0) + 4 | 0;
   i18 = i17 + 3 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i17 + 1 | 0;
   i17 = i17 + 2 | 0;
   i16 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i16;
   i17 = i8 + (i1 * 12 | 0) + 8 | 0;
   i16 = i17 + 1 | 0;
   i18 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i18;
   i16 = i8 + (i1 * 12 | 0) + 10 | 0;
   i18 = i16 + 1 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 }
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i18 = i10 + (i1 << 2) | 0;
   i16 = i18 + 3 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i18 + 1 | 0;
   i18 = i18 + 2 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < ((HEAP32[i9 >> 2] | 0) * 3 | 0));
 }
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i16 = i12 + (i1 << 1) | 0;
   i18 = i16 + 1 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] << 2 | 0));
 }
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i18 = i15 + (i1 << 4) | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i15 + (i1 << 4) + 6 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i15 + (i1 << 4) + 2 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i15 + (i1 << 4) + 8 | 0;
   i16 = i18 + 1 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i15 + (i1 << 4) + 4 | 0;
   i17 = i16 + 1 | 0;
   i18 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = i18;
   i17 = i15 + (i1 << 4) + 10 | 0;
   i18 = i17 + 1 | 0;
   i16 = HEAP8[i17 >> 0] | 0;
   HEAP8[i17 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i16;
   i18 = i15 + (i1 << 4) + 12 | 0;
   i16 = i18 + 3 | 0;
   i17 = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = i17;
   i16 = i18 + 1 | 0;
   i18 = i18 + 2 | 0;
   i17 = HEAP8[i16 >> 0] | 0;
   HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
   HEAP8[i18 >> 0] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 i18 = (i2 | 0) == (i13 | 0);
 return i18 | 0;
}

function __ZN5physx6shdfnd4sortI10SortedDataNS0_4LessIS2_EENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j(i16, i3, i1, i2, i4) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i2 = i4 << 2;
 i14 = i2 >>> 0 > 1024;
 i15 = i17 + 4 | 0;
 HEAP8[i15 >> 0] = i14 & 1;
 if (i14) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i18 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i17 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i17 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i14 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i16 + (i6 << 3) >> 2] | 0) >>> 0 < (HEAP32[i16 + (i5 << 3) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i10 = i16 + (i5 << 3) | 0;
       i13 = i16 + (i7 << 3) | 0;
       i12 = i10;
       i11 = HEAP32[i12 >> 2] | 0;
       i12 = HEAP32[i12 + 4 >> 2] | 0;
       i7 = i13;
       i9 = HEAP32[i7 + 4 >> 2] | 0;
       HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i10 + 4 >> 2] = i9;
       HEAP32[i13 >> 2] = i11;
       HEAP32[i13 + 4 >> 2] = i12;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i13 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i13 << 2) >> 2] | 0;
    i8 = i13;
   }
   i11 = i16 + (((i3 + i4 | 0) / 2 | 0) << 3) | 0;
   i9 = i16 + (i4 << 3) | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   if (i5 >>> 0 < i6 >>> 0) {
    i13 = i9;
    i5 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i10 = i11;
    i12 = HEAP32[i10 + 4 >> 2] | 0;
    i6 = i9;
    HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i6 + 4 >> 2] = i12;
    i6 = i11;
    HEAP32[i6 >> 2] = i5;
    HEAP32[i6 + 4 >> 2] = i13;
    i6 = HEAP32[i9 >> 2] | 0;
   }
   i10 = i16 + (i3 << 3) | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   if (i7 >>> 0 < i6 >>> 0) {
    i13 = i9;
    i6 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    i7 = i10;
    i12 = HEAP32[i7 + 4 >> 2] | 0;
    i5 = i9;
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i5 + 4 >> 2] = i12;
    i5 = i10;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i5 + 4 >> 2] = i13;
    i5 = HEAP32[i11 >> 2] | 0;
   } else i6 = i7;
   if (i6 >>> 0 < i5 >>> 0) {
    i12 = i11;
    i9 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i6 = i10;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i13 = i11;
    HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i13 + 4 >> 2] = i7;
    i13 = i10;
    HEAP32[i13 >> 2] = i9;
    HEAP32[i13 + 4 >> 2] = i12;
   }
   i6 = i3 + -1 | 0;
   i13 = i16 + (i6 << 3) | 0;
   i12 = i11;
   i10 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i7 = i13;
   i9 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = i11;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = i9;
   i5 = i13;
   HEAP32[i5 >> 2] = i10;
   HEAP32[i5 + 4 >> 2] = i12;
   i5 = i4;
   while (1) {
    i9 = i5;
    while (1) {
     i5 = i9 + 1 | 0;
     i7 = i16 + (i5 << 3) | 0;
     if ((HEAP32[i7 >> 2] | 0) >>> 0 < i10 >>> 0) i9 = i5; else {
      i12 = i9;
      break;
     }
    }
    do {
     i6 = i6 + -1 | 0;
     i9 = i16 + (i6 << 3) | 0;
    } while (i10 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
    i11 = i7;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    if ((i5 | 0) >= (i6 | 0)) {
     i9 = i10;
     i6 = i11;
     break;
    }
    i20 = i9;
    i19 = HEAP32[i20 + 4 >> 2] | 0;
    i12 = i7;
    HEAP32[i12 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i12 + 4 >> 2] = i19;
    i12 = i9;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i11;
    i10 = HEAP32[i13 >> 2] | 0;
   }
   i11 = i13;
   i19 = HEAP32[i11 + 4 >> 2] | 0;
   i20 = i7;
   HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i20 = i13;
   HEAP32[i20 >> 2] = i9;
   HEAP32[i20 + 4 >> 2] = i6;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i14 + -1 | 0) >>> 0) i5 = i14; else {
     i5 = i14 << 3;
     if (!i5) i5 = 0; else {
      i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
      i20 = _PxGetFoundation() | 0;
      i20 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 24 >> 2] | 0, i20 | 0) | 0;
      i5 = mftCall_iiiiii(i13 | 0, i19 | 0, i5 | 0, (i20 ? gb + 717882 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i14 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i12;
    i4 = i12 + 2 | 0;
   } else {
    i6 = i12 + 2 | 0;
    if (i8 >>> 0 < (i14 + -1 | 0) >>> 0) i5 = i14; else {
     i5 = i14 << 3;
     if (!i5) i5 = 0; else {
      i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i13 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
      i20 = _PxGetFoundation() | 0;
      i20 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 24 >> 2] | 0, i20 | 0) | 0;
      i5 = mftCall_iiiiii(i13 | 0, i19 | 0, i5 | 0, (i20 ? gb + 717882 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i14 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i12;
   }
   i14 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 STACKTOP = i18;
 return;
}

function __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb(i13, i10, i14, i11) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 8 | 0;
 i16 = i17;
 i9 = i14 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = (i1 | 0) == 0;
 if (!i8) {
  i2 = i9;
  i4 = i1;
  L2 : while (1) {
   i3 = i4;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i10 | 0)) break;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) break L2;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) != (i9 | 0)) if ((HEAP32[i2 + 16 >> 2] | 0) <= (i10 | 0)) {
   STACKTOP = i17;
   return;
  }
 }
 i3 = HEAP32[i13 + 28 >> 2] | 0;
 i7 = HEAP32[i13 + 32 >> 2] | 0;
 i2 = i7 - i3 | 0;
 if (!i2) i4 = i3; else {
  i6 = (i2 | 0) / 20 | 0;
  i2 = i3;
  while (1) {
   i18 = (i6 | 0) / 2 | 0;
   i5 = i3 + (i18 * 20 | 0) | 0;
   i4 = (HEAP32[i5 >> 2] | 0) < (i10 | 0);
   i5 = i5 + 20 | 0;
   i2 = i4 ? i5 : i2;
   i6 = i4 ? i6 + -1 - i18 | 0 : i18;
   if (!i6) {
    i4 = i2;
    break;
   } else i3 = i4 ? i5 : i3;
  }
 }
 if ((i4 | 0) == (i7 | 0)) {
  STACKTOP = i17;
  return;
 }
 if ((HEAP32[i4 >> 2] | 0) != (i10 | 0)) {
  STACKTOP = i17;
  return;
 }
 do if (i8) {
  HEAP32[i15 >> 2] = i9;
  i2 = i9;
  i3 = i9;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i10 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i12 = 16;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i10 | 0)) {
     i12 = 21;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i12 = 20;
     break;
    } else i1 = i2;
   }
  }
  if ((i12 | 0) == 16) {
   HEAP32[i15 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i12 | 0) == 20) {
   HEAP32[i15 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i12 | 0) == 21) {
   HEAP32[i15 >> 2] = i1;
   i2 = i1;
   i3 = i15;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = i10;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i14 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 + 4 >> 2] | 0, i1);
  i18 = i14 + 8 | 0;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
 }
 i7 = i4 + 4 | 0;
 i6 = i4 + 8 | 0;
 i18 = HEAP32[i7 >> 2] | 0;
 i1 = i18;
 if ((HEAP32[i6 >> 2] | 0) == (i18 | 0)) {
  STACKTOP = i17;
  return;
 }
 if (i11) i5 = 0; else {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   HEAP32[i16 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 53; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
     i2 = HEAP32[i15 >> 2] | 0;
     i18 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 53; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 55;
   }
   if ((i12 | 0) == 53) i12 = 55;
   if ((i12 | 0) == 55) {
    i12 = 0;
    __Z31ReadObjectFromPersistentManageri(i4) | 0;
   }
   __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb(i13, i4, i14, 0);
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i5 >>> 0 < (HEAP32[i6 >> 2] | 0) - i1 >> 2 >>> 0);
  STACKTOP = i17;
  return;
 }
 do {
  i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
  HEAP32[i16 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 36; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
    i2 = HEAP32[i15 >> 2] | 0;
    i18 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 36; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 37; else i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
   }
  }
  if ((i12 | 0) == 36) i12 = 37;
  if ((i12 | 0) == 37) {
   i12 = 0;
   i1 = __ZN17PersistentManager17GetSerializedTypeEi(__Z20GetPersistentManagerv() | 0, i4) | 0;
  }
  do if ((i1 | 0) == (gb + 27480 | 0)) {
   HEAP32[i16 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 45; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
     i2 = HEAP32[i15 >> 2] | 0;
     i18 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 45; else if (HEAP32[i1 + 4 >> 2] | 0) break;
   }
   if ((i12 | 0) == 45) i12 = 0;
   __Z31ReadObjectFromPersistentManageri(i4) | 0;
  } while (0);
  __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb(i13, i4, i14, 1);
  i5 = i5 + 1 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } while (i5 >>> 0 < (HEAP32[i6 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_fS2_S6_S7_fb(i2, i23, i19, f21, i3, i4, i20, f22, i1) {
 i2 = i2 | 0;
 i23 = i23 | 0;
 i19 = i19 | 0;
 f21 = Math_fround(f21);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 f22 = Math_fround(f22);
 i1 = i1 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i1 = HEAP16[i2 + 8 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i18 = HEAP32[i2 + 4 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i18 + 48 >> 2]);
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i23 + 4 >> 2]));
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i23 + 8 >> 2]));
  HEAPF32[i19 >> 2] = f8;
  HEAPF32[i19 + 4 >> 2] = f9;
  HEAPF32[i19 + 8 >> 2] = f10;
  f10 = Math_fround(HEAPF32[i23 + 16 >> 2]);
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i18 >> 2]));
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i18 + 4 >> 2]));
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i18 + 8 >> 2]));
  f6 = Math_fround(HEAPF32[i23 + 20 >> 2]);
  f7 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 12 >> 2]));
  f5 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 16 >> 2]));
  f7 = Math_fround(f9 + f7);
  f5 = Math_fround(f8 + f5);
  f6 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i18 + 20 >> 2])));
  f10 = Math_fround(HEAPF32[i23 + 24 >> 2]);
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i18 + 24 >> 2]));
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i18 + 28 >> 2]));
  f9 = Math_fround(f5 + f9);
  f10 = Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i18 + 32 >> 2])));
  HEAPF32[i19 + 16 >> 2] = Math_fround(f7 + f8);
  HEAPF32[i19 + 20 >> 2] = f9;
  HEAPF32[i19 + 24 >> 2] = f10;
 } else __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(HEAP32[i2 >> 2] | 0, i1 & 65535, i23, i19);
 i1 = HEAP16[i3 + 8 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i14 = HEAP32[i3 + 4 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i14 + 48 >> 2]);
  f5 = Math_fround(f7 * Math_fround(HEAPF32[i4 >> 2]));
  i2 = i4 + 4 | 0;
  f6 = Math_fround(f7 * Math_fround(HEAPF32[i2 >> 2]));
  i11 = i4 + 8 | 0;
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i11 >> 2]));
  HEAPF32[i20 >> 2] = f5;
  i3 = i20 + 4 | 0;
  HEAPF32[i3 >> 2] = f6;
  i12 = i20 + 8 | 0;
  HEAPF32[i12 >> 2] = f7;
  i13 = i4 + 16 | 0;
  f10 = Math_fround(HEAPF32[i13 >> 2]);
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i14 >> 2]));
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i14 + 4 >> 2]));
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i14 + 8 >> 2]));
  i15 = i4 + 20 | 0;
  f24 = Math_fround(HEAPF32[i15 >> 2]);
  f26 = Math_fround(f24 * Math_fround(HEAPF32[i14 + 12 >> 2]));
  f25 = Math_fround(f24 * Math_fround(HEAPF32[i14 + 16 >> 2]));
  f26 = Math_fround(f9 + f26);
  f25 = Math_fround(f8 + f25);
  f24 = Math_fround(f10 + Math_fround(f24 * Math_fround(HEAPF32[i14 + 20 >> 2])));
  i17 = i4 + 24 | 0;
  f10 = Math_fround(HEAPF32[i17 >> 2]);
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i14 + 24 >> 2]));
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i14 + 28 >> 2]));
  f8 = Math_fround(f26 + f8);
  f9 = Math_fround(f25 + f9);
  f10 = Math_fround(f24 + Math_fround(f10 * Math_fround(HEAPF32[i14 + 32 >> 2])));
  i14 = i20 + 16 | 0;
  HEAPF32[i14 >> 2] = f8;
  i16 = i20 + 20 | 0;
  HEAPF32[i16 >> 2] = f9;
  i18 = i20 + 24 | 0;
  HEAPF32[i18 >> 2] = f10;
  i1 = i20;
 } else {
  __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(HEAP32[i3 >> 2] | 0, i1 & 65535, i4, i20);
  f5 = Math_fround(HEAPF32[i20 >> 2]);
  i3 = i20 + 4 | 0;
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  i12 = i20 + 8 | 0;
  f7 = Math_fround(HEAPF32[i12 >> 2]);
  i14 = i20 + 16 | 0;
  f8 = Math_fround(HEAPF32[i14 >> 2]);
  i16 = i20 + 20 | 0;
  f9 = Math_fround(HEAPF32[i16 >> 2]);
  i27 = i20 + 24 | 0;
  i1 = i20;
  i2 = i4 + 4 | 0;
  i11 = i4 + 8 | 0;
  i13 = i4 + 16 | 0;
  i15 = i4 + 20 | 0;
  i17 = i4 + 24 | 0;
  i18 = i27;
  f10 = Math_fround(HEAPF32[i27 >> 2]);
 }
 f37 = Math_fround(HEAPF32[i23 >> 2]);
 f32 = Math_fround(HEAPF32[i19 >> 2]);
 f37 = Math_fround(f37 * f32);
 f36 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 i31 = i19 + 4 | 0;
 f25 = Math_fround(HEAPF32[i31 >> 2]);
 f36 = Math_fround(f37 + Math_fround(f36 * f25));
 f37 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 i30 = i19 + 8 | 0;
 f24 = Math_fround(HEAPF32[i30 >> 2]);
 f37 = Math_fround(f36 + Math_fround(f37 * f24));
 f36 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 i29 = i19 + 16 | 0;
 f35 = Math_fround(HEAPF32[i29 >> 2]);
 f36 = Math_fround(f36 * f35);
 f26 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 i28 = i19 + 20 | 0;
 f34 = Math_fround(HEAPF32[i28 >> 2]);
 f26 = Math_fround(f36 + Math_fround(f26 * f34));
 f36 = Math_fround(HEAPF32[i23 + 24 >> 2]);
 i27 = i19 + 24 | 0;
 f33 = Math_fround(HEAPF32[i27 >> 2]);
 f36 = Math_fround(Math_fround(f37 + Math_fround(f26 + Math_fround(f36 * f33))) * f21);
 f26 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f5);
 f26 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f6));
 f7 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f7));
 f26 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f8);
 f26 = Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f9));
 f26 = Math_fround(f36 + Math_fround(Math_fround(f7 + Math_fround(f26 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f10))) * f22));
 f25 = Math_fround(f25 * f21);
 f24 = Math_fround(f24 * f21);
 f10 = Math_fround(f35 * f21);
 f9 = Math_fround(f34 * f21);
 f8 = Math_fround(f33 * f21);
 HEAPF32[i19 >> 2] = Math_fround(f32 * f21);
 HEAPF32[i31 >> 2] = f25;
 HEAPF32[i30 >> 2] = f24;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i29 >> 2] = f10;
 HEAPF32[i28 >> 2] = f9;
 HEAPF32[i27 >> 2] = f8;
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f22);
 f9 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f22);
 f10 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f22);
 f21 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f22);
 f24 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f22);
 f25 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f22);
 HEAPF32[i1 >> 2] = f8;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i12 >> 2] = f10;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i14 >> 2] = f21;
 HEAPF32[i16 >> 2] = f24;
 HEAPF32[i18 >> 2] = f25;
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 return Math_fround(f26);
}

function __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj(i24, i23, i13, i14, i25) {
 i24 = i24 | 0;
 i23 = i23 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i25 = i25 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i26 = 0, f27 = f0, i28 = 0, f29 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i26 + 144 | 0;
 i10 = i26 + 128 | 0;
 i11 = i26 + 112 | 0;
 i8 = i26 + 172 | 0;
 i20 = i26 + 160 | 0;
 i19 = i26 + 96 | 0;
 i21 = i26 + 80 | 0;
 i22 = i26 + 64 | 0;
 i15 = i26 + 48 | 0;
 i16 = i26 + 32 | 0;
 i17 = i26 + 16 | 0;
 i18 = i26;
 HEAP32[i25 >> 2] = 3;
 HEAP32[i9 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 i12 = i23 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i28 = i23 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f2 = Math_fround(f2 - f5);
 f4 = Math_fround(f4 - f3);
 f1 = Math_fround(f1 - f7);
 f27 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f5 = Math_fround(f27 - f5);
 f3 = Math_fround(f6 - f3);
 f7 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f7);
 f6 = Math_fround(Math_fround(f4 * f7) - Math_fround(f1 * f3));
 f7 = Math_fround(Math_fround(f1 * f5) - Math_fround(f2 * f7));
 f5 = Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f5));
 if (!(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))) <= Math_fround(1.1920929e-07))) {
  HEAP32[i20 >> 2] = HEAP32[gb + 101572 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
  __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i19, i9, i10, i11, i20, i8);
  i8 = HEAP32[i8 >> 2] | 0;
  if ((i8 | 0) != 3) {
   i11 = HEAP32[i20 >> 2] | 0;
   i28 = i23 + (i11 << 4) | 0;
   HEAP32[i21 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i21 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   i28 = HEAP32[i20 + 4 >> 2] | 0;
   i20 = i23 + (i28 << 4) | 0;
   HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i20 = i13 + (i11 << 4) | 0;
   HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i20 = i13 + (i28 << 4) | 0;
   HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i20 = i14 + (i11 << 4) | 0;
   HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   i28 = i14 + (i28 << 4) | 0;
   HEAP32[i18 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i28 + 12 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   i28 = i13 + 16 | 0;
   HEAP32[i28 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i28 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i28 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i28 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   i28 = i14 + 16 | 0;
   HEAP32[i28 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i28 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i28 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i28 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   HEAP32[i25 >> 2] = i8;
  };
  HEAP32[i24 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  STACKTOP = i26;
  return;
 }
 HEAP32[i25 >> 2] = 2;
 f1 = Math_fround(HEAPF32[i23 >> 2]);
 f2 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f4 = Math_fround(f4 - f1);
 f5 = Math_fround(f5 - f2);
 f6 = Math_fround(Math_fround(HEAPF32[i23 + 24 >> 2]) - f3);
 f7 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6));
 if (!(f7 <= Math_fround(1.1920929e-07))) {
  f29 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f2 * f5)) - Math_fround(f1 * f4)) - Math_fround(f3 * f6)) / f7);
  i28 = f29 > Math_fround(1.0);
  f29 = i28 ? Math_fround(1.0) : f29;
  i28 = f29 > Math_fround(0.0);
  f29 = i28 ? f29 : Math_fround(0.0);
  f7 = Math_fround(f2 + Math_fround(f5 * f29));
  f27 = Math_fround(f3 + Math_fround(f6 * f29));
  HEAPF32[i24 >> 2] = Math_fround(f1 + Math_fround(f4 * f29));
  HEAPF32[i24 + 4 >> 2] = f7;
  HEAPF32[i24 + 8 >> 2] = f27;
  HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
  STACKTOP = i26;
  return;
 } else {
  HEAP32[i25 >> 2] = 1;
  HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  STACKTOP = i26;
  return;
 }
}

function __ZN18AssetBundleManagerC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 i6 = i3 + 24 | 0;
 HEAP8[i6 >> 0] = 0;
 i4 = i3 + 25 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP8[i3 + 32 >> 0] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP8[i3 + 40 >> 0] = 0;
 i1 = i3 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i3 + 48 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 16;
 HEAP32[i3 + 56 >> 2] = 6;
 HEAP8[i3 + 64 >> 0] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP8[i3 + 76 >> 0] = 0;
 HEAP8[i3 + 77 >> 0] = 0;
 i2 = i3 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i3 + 96 | 0;
 i7 = i3 + 100 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 + 112 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 120 >> 2] = 0;
 i7 = i3 + 68 | 0;
 HEAP32[i3 + 124 >> 2] = 32;
 HEAP32[i3 + 128 >> 2] = 0;
 HEAP32[i3 + 136 >> 2] = 16;
 HEAP32[i3 + 132 >> 2] = 6;
 HEAP8[i3 + 140 >> 0] = 0;
 HEAP32[i3 + 148 >> 2] = 0;
 HEAP8[i3 + 152 >> 0] = 0;
 HEAP8[i3 + 153 >> 0] = 0;
 i2 = i3 + 156 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i3 + 168 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i3 + 172 | 0;
 i10 = i3 + 176 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 + 188 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = 0;
 HEAP32[i3 + 196 >> 2] = 0;
 i10 = i3 + 144 | 0;
 HEAP32[i3 + 200 >> 2] = 32;
 HEAP32[i3 + 204 >> 2] = 0;
 HEAP32[i3 + 212 >> 2] = 16;
 HEAP32[i3 + 208 >> 2] = 6;
 HEAP8[i3 + 216 >> 0] = 0;
 HEAP8[i4 >> 0] = 1;
 i4 = i3 + 36 | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = __Znwj(i5 << 3) | 0;
 HEAP32[i1 >> 2] = i2;
 i5 = i2 + (i5 << 3) | 0;
 if ((i2 | 0) != (i5 | 0)) {
  i1 = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = i2 + 8 | 0;
  if ((i1 | 0) != (i5 | 0)) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = i2 + 16 | 0;
   if ((i1 | 0) != (i5 | 0)) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i2 + 24 | 0;
    if ((i1 | 0) != (i5 | 0)) do {
     i13 = i4;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i2 = i1;
     HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i2 + 4 >> 2] = i12;
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i5 | 0));
   }
  }
 }
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E14squash_deletedEv(i3 + 16 | 0);
 HEAP8[i6 >> 0] = 1;
 i13 = i3 + 28 | 0;
 HEAP32[i13 >> 2] = -1;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i9 + 11 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP8[i9 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE13set_empty_keyERSG_(i7, i9);
 if ((HEAP8[i13 >> 0] | 0) < 0) {
  i13 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i8);
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i9 + 11 | 0;
 HEAP8[i1 >> 0] = 10;
 i2 = i9;
 i3 = gb + 367647 | 0;
 i4 = i2 + 10 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i9 + 10 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE15set_deleted_keyERSG_(i7, i9);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i13 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i8);
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i9 + 11 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP8[i9 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE13set_empty_keyERSG_(i10, i9);
 if ((HEAP8[i13 >> 0] | 0) < 0) {
  i13 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i8);
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i9 + 11 | 0;
 HEAP8[i1 >> 0] = 10;
 i2 = i9;
 i3 = gb + 367647 | 0;
 i4 = i2 + 10 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i9 + 10 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE15set_deleted_keyERSG_(i10, i9);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return;
 }
 i13 = HEAP32[i9 >> 2] | 0;
 i12 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 54;
 HEAP32[i8 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i8);
 STACKTOP = i11;
 return;
}

function __ZN5physx14collideWithBoxEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i54, i53, i1, f56) {
 i54 = i54 | 0;
 i53 = i53 | 0;
 i1 = i1 | 0;
 f56 = Math_fround(f56);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0, i51 = 0, i52 = 0, i55 = 0, i57 = 0, i58 = 0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i55 = i57 + 320 | 0;
 i52 = i57;
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(-f11);
 f8 = Math_fround(-f12);
 f49 = Math_fround(f6 - f56);
 f50 = Math_fround(f8 - f56);
 f9 = Math_fround(f7 + f56);
 f7 = Math_fround(-f7);
 f10 = Math_fround(f7 - f56);
 f11 = Math_fround(f11 + f56);
 f12 = Math_fround(f12 + f56);
 HEAP32[i55 >> 2] = 1065353216;
 HEAP32[i55 + 4 >> 2] = 0;
 HEAP32[i55 + 8 >> 2] = 0;
 HEAPF32[i55 + 12 >> 2] = f6;
 HEAP32[i55 + 16 >> 2] = -1082130432;
 HEAP32[i55 + 20 >> 2] = 0;
 HEAP32[i55 + 24 >> 2] = 0;
 HEAPF32[i55 + 28 >> 2] = f6;
 HEAP32[i55 + 32 >> 2] = 0;
 HEAP32[i55 + 36 >> 2] = 1065353216;
 HEAP32[i55 + 40 >> 2] = 0;
 HEAPF32[i55 + 44 >> 2] = f7;
 HEAP32[i55 + 48 >> 2] = 0;
 HEAP32[i55 + 52 >> 2] = -1082130432;
 HEAP32[i55 + 56 >> 2] = 0;
 HEAPF32[i55 + 60 >> 2] = f7;
 HEAP32[i55 + 64 >> 2] = 0;
 HEAP32[i55 + 68 >> 2] = 0;
 HEAP32[i55 + 72 >> 2] = 1065353216;
 HEAPF32[i55 + 76 >> 2] = f8;
 HEAP32[i55 + 80 >> 2] = 0;
 HEAP32[i55 + 84 >> 2] = 0;
 HEAP32[i55 + 88 >> 2] = -1082130432;
 HEAPF32[i55 + 92 >> 2] = f8;
 if (!i53) {
  STACKTOP = i57;
  return;
 }
 i13 = i53 + -1 | 0;
 i14 = i52 + 160 | 0;
 i15 = i52 + 4 | 0;
 i16 = i52 + 164 | 0;
 i17 = i52 + 8 | 0;
 i18 = i52 + 168 | 0;
 i19 = i52 + 12 | 0;
 i20 = i52 + 172 | 0;
 i21 = i52 + 188 | 0;
 i22 = i52 + 240 | 0;
 i23 = i52 + 244 | 0;
 i24 = i52 + 248 | 0;
 i25 = i52 + 304 | 0;
 i26 = i52 + 308 | 0;
 i27 = i52 + 312 | 0;
 i28 = i52 + 184 | 0;
 i29 = i52 + 224 | 0;
 i30 = i52 + 228 | 0;
 i31 = i52 + 232 | 0;
 i32 = i52 + 288 | 0;
 i33 = i52 + 292 | 0;
 i34 = i52 + 296 | 0;
 i35 = i52 + 180 | 0;
 i36 = i52 + 208 | 0;
 i37 = i52 + 212 | 0;
 i38 = i52 + 216 | 0;
 i39 = i52 + 272 | 0;
 i40 = i52 + 276 | 0;
 i41 = i52 + 280 | 0;
 i42 = i52 + 176 | 0;
 i43 = i52 + 192 | 0;
 i44 = i52 + 196 | 0;
 i45 = i52 + 200 | 0;
 i46 = i52 + 256 | 0;
 i47 = i52 + 260 | 0;
 i48 = i52 + 264 | 0;
 i51 = 0;
 i1 = 0;
 do {
  f3 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 112 >> 2]);
  f4 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 128 >> 2]);
  f5 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 116 >> 2]);
  f6 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 132 >> 2]);
  f7 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 120 >> 2]);
  f8 = Math_fround(HEAPF32[i54 + (i51 * 176 | 0) + 136 >> 2]);
  if (!((f7 < f8 ? f7 : f8) > f12) & (((f5 < f6 ? f5 : f6) > f9 | ((f49 > (f3 > f4 ? f3 : f4) ? 1 : (f3 < f4 ? f3 : f4) > f11) | f10 > (f5 > f6 ? f5 : f6)) | f50 > (f7 > f8 ? f7 : f8)) ^ 1)) {
   HEAPF32[i52 + 16 + (i1 << 4) >> 2] = f3;
   HEAPF32[i52 + 16 + (i1 << 4) + 4 >> 2] = f5;
   HEAPF32[i52 + 16 + (i1 << 4) + 8 >> 2] = f7;
   HEAPF32[i52 + 16 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i52 + 80 + (i1 << 4) >> 2] = f4;
   HEAPF32[i52 + 80 + (i1 << 4) + 4 >> 2] = f6;
   HEAPF32[i52 + 80 + (i1 << 4) + 8 >> 2] = f8;
   HEAPF32[i52 + 80 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i52 + 160 + (i1 << 2) >> 2] = HEAP32[i54 + (i51 * 176 | 0) + 124 >> 2];
   HEAP32[i52 + 144 + (i1 << 2) >> 2] = HEAP32[i54 + (i51 * 176 | 0) + 92 >> 2];
   HEAP32[i52 + 176 + (i1 << 2) >> 2] = HEAP32[i54 + (i51 * 176 | 0) + 44 >> 2];
   HEAP32[i52 + (i1 << 2) >> 2] = i54 + (i51 * 176 | 0);
   i1 = i1 + 1 | 0;
  }
  switch (i1 | 0) {
  case 4:
   {
    __ZN5physx27collideWithConvexPlanesSIMDERNS_21PxsParticleCollDataV4EPKNS_7PxPlaneEjf(i52, i55, 6, f56);
    i1 = HEAP32[i52 >> 2] | 0;
    i2 = HEAP32[i14 >> 2] | 0;
    if (i2 | 0) {
     i58 = i1 + 124 | 0;
     HEAP32[i58 >> 2] = HEAP32[i58 >> 2] | i2;
     HEAP32[i1 + 44 >> 2] = HEAP32[i42 >> 2];
     HEAP32[i1 + 144 >> 2] = HEAP32[i43 >> 2];
     HEAP32[i1 + 148 >> 2] = HEAP32[i44 >> 2];
     HEAP32[i1 + 152 >> 2] = HEAP32[i45 >> 2];
     HEAP32[i1 + 160 >> 2] = HEAP32[i46 >> 2];
     HEAP32[i1 + 164 >> 2] = HEAP32[i47 >> 2];
     HEAP32[i1 + 168 >> 2] = HEAP32[i48 >> 2];
    }
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    if (i2 | 0) {
     i58 = i1 + 124 | 0;
     HEAP32[i58 >> 2] = HEAP32[i58 >> 2] | i2;
     HEAP32[i1 + 44 >> 2] = HEAP32[i35 >> 2];
     HEAP32[i1 + 144 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i1 + 148 >> 2] = HEAP32[i37 >> 2];
     HEAP32[i1 + 152 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i1 + 160 >> 2] = HEAP32[i39 >> 2];
     HEAP32[i1 + 164 >> 2] = HEAP32[i40 >> 2];
     HEAP32[i1 + 168 >> 2] = HEAP32[i41 >> 2];
    }
    i1 = HEAP32[i17 >> 2] | 0;
    i2 = HEAP32[i18 >> 2] | 0;
    if (i2 | 0) {
     i58 = i1 + 124 | 0;
     HEAP32[i58 >> 2] = HEAP32[i58 >> 2] | i2;
     HEAP32[i1 + 44 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i1 + 144 >> 2] = HEAP32[i29 >> 2];
     HEAP32[i1 + 148 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i1 + 152 >> 2] = HEAP32[i31 >> 2];
     HEAP32[i1 + 160 >> 2] = HEAP32[i32 >> 2];
     HEAP32[i1 + 164 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i1 + 168 >> 2] = HEAP32[i34 >> 2];
    }
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = HEAP32[i20 >> 2] | 0;
    if (!i2) i1 = 0; else {
     i58 = i1 + 124 | 0;
     HEAP32[i58 >> 2] = HEAP32[i58 >> 2] | i2;
     HEAP32[i1 + 44 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i1 + 144 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i1 + 148 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 152 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i1 + 160 >> 2] = HEAP32[i25 >> 2];
     HEAP32[i1 + 164 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i1 + 168 >> 2] = HEAP32[i27 >> 2];
     i1 = 0;
    }
    break;
   }
  case 0:
   {
    i1 = 0;
    break;
   }
  default:
   if ((i51 | 0) == (i13 | 0)) {
    i2 = 0;
    do {
     __ZN5physx23collideWithConvexPlanesERNS_19PxsParticleCollDataEPKNS_7PxPlaneEjf(HEAP32[i52 + (i2 << 2) >> 2] | 0, i55, 6, f56);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
  }
  i51 = i51 + 1 | 0;
 } while ((i51 | 0) != (i53 | 0));
 STACKTOP = i57;
 return;
}

function __ZN8GUIStyle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i8 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 16 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 20 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 36 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 40 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 56 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 60 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 76 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 80 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 96 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 100 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 116 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 120 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 136 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 140 | 0, i9);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 156 | 0, i9);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 160 | 0, i9);
 __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 176 | 0, i9);
 __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 192 | 0, i9);
 __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 208 | 0, i9);
 __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 224 | 0, i9);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 240 | 0, i9);
 i1 = i8 + 284 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 244 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 248 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i8 + 249 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i8 + 252 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 256 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 260 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 264 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 276 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 280 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 292 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i8 + 293 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj678ES2_NS_23PxVehicleDriveSimData4WES6_EEKNS_36PxVehicleDriveSimData4WGeneratedInfoEEEvPjRKT_RT0_(i17, i1, i22, i16) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 2400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 1816 | 0;
 i21 = i23 + 1240 | 0;
 i15 = i23 + 16 | 0;
 i13 = i23 + 1184 | 0;
 i14 = i23;
 i18 = i23 + 32 | 0;
 i19 = i23 + 608 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i17 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i17 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i17 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i17 + 36 >> 0] | 0)) {
  STACKTOP = i23;
  return;
 }
 i8 = i17 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i17 + 8 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i17 + 4 >> 2] | 0;
 i3 = HEAP32[i17 + 20 >> 2] | 0;
 i6 = HEAP32[i17 + 28 >> 2] | 0;
 i4 = HEAP32[i17 + 32 >> 2] | 0;
 i10 = i14;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i21 >> 0] = 0;
 i7 = i18;
 i5 = i21;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i20 >> 2] = i1;
 HEAP32[i20 + 4 >> 2] = i2;
 i12 = i20 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i3;
 HEAP32[i20 + 24 >> 2] = i7;
 HEAP32[i20 + 28 >> 2] = i6;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i16, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i16 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i16 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i16 + 48 | 0, 3);
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i14 = i13 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj669ES3_RKNS_27PxVehicleDifferential4WDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i16 + 64 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj670ES3_RKNS_30PxVehicleAckermannGeometryDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i16 + 80 | 0, 1);
 if (HEAP8[i21 >> 0] | 0) HEAP8[HEAP32[i17 + 40 >> 2] >> 0] = 1;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i18 + 64 >> 2] | 0;
 i6 = i5 << 3;
 _memcpy(i19 | 0, i18 | 0, i6 | 0) | 0;
 HEAP32[i19 + 64 >> 2] = i5;
 i3 = i19 + 80 | 0;
 i7 = i18 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 i3 = i18 + 112 | 0;
 _memcpy(i19 + 112 | 0, i3 | 0, 416) | 0;
 i2 = i18 + 528 | 0;
 i10 = i19 + 528 | 0;
 i11 = i2;
 i12 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 _memcpy(i21 | 0, i19 | 0, i6 | 0) | 0;
 HEAP32[i21 + 64 >> 2] = i5;
 i10 = i21 + 80 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 _memcpy(i21 + 112 | 0, i3 | 0, 416) | 0;
 i10 = i21 + 528 | 0;
 i11 = i2;
 i12 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i1 = HEAP32[i22 + 20 >> 2] | 0;
 _memcpy(i20 | 0, i21 | 0, i6 | 0) | 0;
 HEAP32[i20 + 64 >> 2] = i5;
 i10 = i20 + 80 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 _memcpy(i20 + 112 | 0, i3 | 0, 416) | 0;
 i10 = i20 + 528 | 0;
 i11 = i2;
 i12 = i10 + 48 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 mftCall_vii(i1 | 0, i4 | 0, i20 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx15PxVehicleUpdate40updateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE(f8, i4, i10, i9, i5, i12) {
 f8 = Math_fround(f8);
 i4 = i4 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f6 = f0, f7 = f0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 1408 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 1360 | 0;
 i15 = i16 + 480 | 0;
 i13 = i16 + 240 | 0;
 i14 = i16;
 i1 = i11;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[gb + 1458536 >> 2] = i11;
 _memset(i15 | 0, 0, 880) | 0;
 i1 = HEAP32[i9 + 44 >> 2] << 2;
 if (!i1) {
  i1 = 0;
  i3 = 3;
 } else {
  i2 = 0;
  do {
   HEAP32[gb + 1458456 + (i2 << 2) >> 2] = i15 + (i2 * 44 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  if (i1 >>> 0 < 20) i3 = 3;
 }
 if ((i3 | 0) == 3) _memset(gb + 1458456 + (i1 << 2) | 0, 0, 80 - (i1 << 2) | 0) | 0;
 _memset(i13 | 0, 0, 240) | 0;
 HEAP32[gb + 1458452 >> 2] = i13;
 _memset(i14 | 0, 0, 240) | 0;
 HEAP32[gb + 1458448 >> 2] = i14;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(f6 * f6);
 f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f7 = Math_fround(f6 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(Math_sqrt(Math_fround(f7 + Math_fround(f6 * f6))));
 f7 = Math_fround(Math_fround(1.0) / f6);
 switch (HEAPU8[i9 + 113 >> 0] | 0 | 0) {
 case 0:
  {
   __ZN5physx15PxVehicleUpdate13updateDrive4WEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDrive4WEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f8, i4, f6, f7, i10, i9, i5, 0);
   i1 = i9 + 48 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i2 = i12 + 4 | 0;
    i3 = i12 + 12 | 0;
    i4 = i12 + 8 | 0;
    i5 = 0;
    do {
     __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf((HEAP32[i2 >> 2] | 0) + (i5 * 15840 | 0) | 0, i15 + (i5 * 44 | 0) | 0);
     i10 = HEAP32[i3 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i13 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 8 >> 2];
     i10 = HEAP32[i4 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i14 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 8 >> 2];
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
   }
   __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf(HEAP32[i12 >> 2] | 0, i11);
   STACKTOP = i16;
   return;
  }
 case 1:
  {
   __ZN5physx15PxVehicleUpdate13updateDriveNWEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDriveNWEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f8, i4, f6, f7, i10, i9, i5, 0);
   i1 = i9 + 48 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i2 = i12 + 4 | 0;
    i3 = i12 + 12 | 0;
    i4 = i12 + 8 | 0;
    i5 = 0;
    do {
     __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf((HEAP32[i2 >> 2] | 0) + (i5 * 15840 | 0) | 0, i15 + (i5 * 44 | 0) | 0);
     i10 = HEAP32[i3 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i13 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 8 >> 2];
     i10 = HEAP32[i4 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i14 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 8 >> 2];
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
   }
   __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf(HEAP32[i12 >> 2] | 0, i11);
   STACKTOP = i16;
   return;
  }
 case 2:
  {
   __ZN5physx15PxVehicleUpdate10updateTankEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_18PxVehicleDriveTankEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f8, i4, f6, f7, i10, i9, i5, 0);
   i1 = i9 + 48 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i2 = i12 + 4 | 0;
    i3 = i12 + 12 | 0;
    i4 = i12 + 8 | 0;
    i5 = 0;
    do {
     __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf((HEAP32[i2 >> 2] | 0) + (i5 * 15840 | 0) | 0, i15 + (i5 * 44 | 0) | 0);
     i10 = HEAP32[i3 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i13 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i13 + (i5 * 12 | 0) + 8 >> 2];
     i10 = HEAP32[i4 >> 2] | 0;
     HEAP32[i10 + (i5 * 12 | 0) >> 2] = HEAP32[i14 + (i5 * 12 | 0) >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i14 + (i5 * 12 | 0) + 8 >> 2];
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
   }
   __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf(HEAP32[i12 >> 2] | 0, i11);
   STACKTOP = i16;
   return;
  }
 case 3:
  {
   __ZN5physx15PxVehicleUpdate13updateNoDriveEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleNoDriveEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f8, i4, f6, f7, i10, i9, i5, 0);
   i3 = i9 + 48 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    STACKTOP = i16;
    return;
   }
   i4 = i12 + 4 | 0;
   i5 = i12 + 12 | 0;
   i1 = i12 + 8 | 0;
   i2 = 0;
   do {
    __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf((HEAP32[i4 >> 2] | 0) + (i2 * 15840 | 0) | 0, i15 + (i2 * 44 | 0) | 0);
    i12 = HEAP32[i5 >> 2] | 0;
    HEAP32[i12 + (i2 * 12 | 0) >> 2] = HEAP32[i13 + (i2 * 12 | 0) >> 2];
    HEAP32[i12 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i13 + (i2 * 12 | 0) + 4 >> 2];
    HEAP32[i12 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i13 + (i2 * 12 | 0) + 8 >> 2];
    i12 = HEAP32[i1 >> 2] | 0;
    HEAP32[i12 + (i2 * 12 | 0) >> 2] = HEAP32[i14 + (i2 * 12 | 0) >> 2];
    HEAP32[i12 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i14 + (i2 * 12 | 0) + 4 >> 2];
    HEAP32[i12 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i14 + (i2 * 12 | 0) + 8 >> 2];
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   STACKTOP = i16;
   return;
  }
 default:
  {
   STACKTOP = i16;
   return;
  }
 }
}

function _UNITY_png_do_expand(i22, i18, i3) {
 i22 = i22 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = HEAP32[i22 >> 2] | 0;
 i20 = i22 + 8 | 0;
 i2 = HEAP16[i20 >> 1] | 0;
 i1 = i2 & 255;
 i2 = (i2 & 65535) >>> 8 & 255;
 if (i1 << 24 >> 24) {
  if (!((i3 | 0) != 0 & i1 << 24 >> 24 == 2)) return;
  i17 = i22 + 9 | 0;
  switch (i2 << 24 >> 24) {
  case 8:
   {
    if (i21 | 0) {
     i9 = HEAP16[i3 + 2 >> 1] & 255;
     i10 = HEAP16[i3 + 4 >> 1] & 255;
     i8 = HEAP16[i3 + 6 >> 1] & 255;
     i6 = 0;
     i7 = i18 + (i21 << 2) | 0;
     i3 = i18 + (HEAP32[i22 + 4 >> 2] | 0) | 0;
     do {
      i2 = i3 + -1 | 0;
      i1 = i7 + -1 | 0;
      i4 = i3 + -2 | 0;
      i3 = i3 + -3 | 0;
      if ((HEAP8[i3 >> 0] | 0) == i9 << 24 >> 24) if ((HEAP8[i4 >> 0] | 0) == i10 << 24 >> 24) if ((HEAP8[i2 >> 0] | 0) == i8 << 24 >> 24) i5 = 0; else i19 = 39; else i19 = 39; else i19 = 39;
      if ((i19 | 0) == 39) {
       i19 = 0;
       i5 = -1;
      }
      HEAP8[i1 >> 0] = i5;
      HEAP8[i7 + -2 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP8[i7 + -3 >> 0] = HEAP8[i4 >> 0] | 0;
      i7 = i7 + -4 | 0;
      HEAP8[i7 >> 0] = HEAP8[i3 >> 0] | 0;
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i21 | 0));
    }
    break;
   }
  case 16:
   {
    i1 = HEAP16[i3 + 2 >> 1] | 0;
    i15 = (i1 & 65535) >>> 8 & 65535;
    i2 = HEAP16[i3 + 4 >> 1] | 0;
    i16 = (i2 & 65535) >>> 8 & 65535;
    i3 = HEAP16[i3 + 6 >> 1] | 0;
    i14 = (i3 & 65535) >>> 8 & 65535;
    if (i21 | 0) {
     i13 = i1 & 255;
     i12 = i2 & 255;
     i11 = i3 & 255;
     i9 = 0;
     i10 = i18 + (HEAP32[i22 + 4 >> 2] | 0) | 0;
     i7 = i18 + (i21 << 3) | 0;
     do {
      i6 = i10 + -1 | 0;
      i2 = i7 + -1 | 0;
      i5 = i10;
      i10 = i10 + -6 | 0;
      i8 = i5 + -5 | 0;
      if ((HEAPU8[i10 >> 0] | 0) == (i15 | 0)) if ((HEAP8[i8 >> 0] | 0) == i13 << 24 >> 24) {
       i1 = i5 + -4 | 0;
       if ((HEAPU8[i1 >> 0] | 0) == (i16 | 0)) {
        i4 = i5 + -3 | 0;
        if ((HEAP8[i4 >> 0] | 0) == i12 << 24 >> 24) {
         i3 = i5 + -2 | 0;
         if ((HEAPU8[i3 >> 0] | 0) == (i14 | 0)) if ((HEAP8[i6 >> 0] | 0) == i11 << 24 >> 24) {
          HEAP8[i2 >> 0] = 0;
          HEAP8[i7 + -2 >> 0] = 0;
          i2 = i4;
         } else i19 = 50; else i19 = 50;
        } else i19 = 50;
       } else i19 = 50;
      } else i19 = 50; else i19 = 50;
      if ((i19 | 0) == 50) {
       i19 = 0;
       HEAP8[i2 >> 0] = -1;
       HEAP8[i7 + -2 >> 0] = -1;
       i3 = i5 + -2 | 0;
       i2 = i5 + -3 | 0;
       i1 = i5 + -4 | 0;
      }
      HEAP8[i7 + -3 >> 0] = HEAP8[i6 >> 0] | 0;
      HEAP8[i7 + -4 >> 0] = HEAP8[i3 >> 0] | 0;
      HEAP8[i7 + -5 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP8[i7 + -6 >> 0] = HEAP8[i1 >> 0] | 0;
      HEAP8[i7 + -7 >> 0] = HEAP8[i8 >> 0] | 0;
      i7 = i7 + -8 | 0;
      HEAP8[i7 >> 0] = HEAP8[i10 >> 0] | 0;
      i9 = i9 + 1 | 0;
     } while ((i9 | 0) != (i21 | 0));
    }
    break;
   }
  default:
   {}
  }
  HEAP8[i20 >> 0] = 6;
  HEAP8[i22 + 10 >> 0] = 4;
  i1 = HEAPU8[i17 >> 0] << 2;
  HEAP8[i22 + 11 >> 0] = i1;
  i1 = i1 & 252;
  if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i21) | 0; else i1 = ((Math_imul(i1, i21) | 0) + 7 | 0) >>> 3;
  HEAP32[i22 + 4 >> 2] = i1;
  return;
 }
 i7 = (i3 | 0) != 0;
 if (i7) i1 = HEAPU16[i3 + 8 >> 1] | 0; else i1 = 0;
 i8 = i22 + 9 | 0;
 if ((i2 & 255) < 8) {
  switch (i2 << 24 >> 24) {
  case 1:
   {
    i1 = 0 - (i1 & 1) & 255;
    if (i21) {
     i2 = i18 + ((i21 + -1 | 0) >>> 3) | 0;
     i3 = i18 + i21 | 0;
     i4 = 0;
     i5 = i21 + 7 & 7 ^ 7;
     while (1) {
      i3 = i3 + -1 | 0;
      HEAP8[i3 >> 0] = ((HEAPU8[i2 >> 0] & 1 << i5 | 0) != 0) << 31 >> 31;
      i6 = (i5 | 0) == 7;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i21 | 0)) break; else {
       i2 = i6 ? i2 + -1 | 0 : i2;
       i5 = i6 ? 0 : i5 + 1 | 0;
      }
     }
    }
    break;
   }
  case 2:
   {
    i1 = (i1 & 3) * 85 | 0;
    if (i21) {
     i2 = i18 + i21 | 0;
     i3 = 0;
     i4 = i18 + ((i21 + -1 | 0) >>> 2) | 0;
     i5 = (i21 << 1) + 6 & 6 ^ 6;
     while (1) {
      i2 = i2 + -1 | 0;
      i6 = (HEAPU8[i4 >> 0] | 0) >>> i5 & 3;
      HEAP8[i2 >> 0] = i6 << 2 | i6 | i6 << 4 | i6 << 6;
      i6 = (i5 | 0) == 6;
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i21 | 0)) break; else {
       i4 = i6 ? i4 + -1 | 0 : i4;
       i5 = i6 ? 0 : i5 + 2 | 0;
      }
     }
    }
    break;
   }
  case 4:
   {
    i1 = (i1 & 15) * 17 | 0;
    if (i21) {
     i3 = i18 + i21 | 0;
     i4 = 0;
     i5 = i18 + ((i21 + -1 | 0) >>> 1) | 0;
     i2 = i21 << 2 & 4;
     while (1) {
      i3 = i3 + -1 | 0;
      i17 = (HEAPU8[i5 >> 0] | 0) >>> i2 & 15;
      HEAP8[i3 >> 0] = i17 << 4 | i17;
      i2 = (i2 | 0) == 4;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i21 | 0)) break; else {
       i5 = i2 ? i5 + -1 | 0 : i5;
       i2 = i2 ? 0 : 4;
      }
     }
    }
    break;
   }
  default:
   {}
  }
  HEAP8[i8 >> 0] = 8;
  HEAP8[i22 + 11 >> 0] = 8;
  HEAP32[i22 + 4 >> 2] = i21;
  i2 = 8;
 }
 if (!i7) return;
 switch (i2 << 24 >> 24) {
 case 8:
  {
   if (i21 | 0) {
    i4 = i1 & 255;
    i2 = 0;
    i3 = i18 + (i21 << 1) | 0;
    i1 = i18 + i21 | 0;
    do {
     i1 = i1 + -1 | 0;
     i19 = i3;
     i3 = i3 + -2 | 0;
     HEAP8[i19 + -1 >> 0] = ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24) << 31 >> 31;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i21 | 0));
   }
   break;
  }
 case 16:
  {
   i2 = HEAP32[i22 + 4 >> 2] | 0;
   if (i21 | 0) {
    i7 = i1 >>> 8 & 255;
    i6 = i1 & 255;
    i4 = 0;
    i5 = i18 + (i2 << 1) | 0;
    i3 = i18 + i2 | 0;
    do {
     i2 = i3 + -1 | 0;
     i1 = i5 + -1 | 0;
     i3 = i3 + -2 | 0;
     if ((HEAP8[i3 >> 0] | 0) == i7 << 24 >> 24) if ((HEAP8[i2 >> 0] | 0) == i6 << 24 >> 24) {
      HEAP8[i1 >> 0] = 0;
      HEAP8[i5 + -2 >> 0] = 0;
     } else i19 = 26; else i19 = 26;
     if ((i19 | 0) == 26) {
      i19 = 0;
      HEAP8[i1 >> 0] = -1;
      HEAP8[i5 + -2 >> 0] = -1;
     }
     HEAP8[i5 + -3 >> 0] = HEAP8[i2 >> 0] | 0;
     i5 = i5 + -4 | 0;
     HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i21 | 0));
   }
   break;
  }
 default:
  {}
 }
 HEAP8[i20 >> 0] = 4;
 HEAP8[i22 + 10 >> 0] = 2;
 i1 = HEAPU8[i8 >> 0] << 1;
 HEAP8[i22 + 11 >> 0] = i1;
 i1 = i1 & 254;
 if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i21) | 0; else i1 = ((Math_imul(i1, i21) | 0) + 7 | 0) >>> 3;
 HEAP32[i22 + 4 >> 2] = i1;
 return;
}

function __ZNK5physx20PxsSolverCoreGeneral13solveV_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj(i6, f3, i9, i28, i13, i7, i1, i12, i16, i15, i24, i8, i2, i4, i23, i5, i14, i26, i27, i25) {
 i6 = i6 | 0;
 f3 = Math_fround(f3);
 i9 = i9 | 0;
 i28 = i28 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i24 = i24 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i25 = i25 | 0;
 var i10 = 0, i11 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i29 = 0, i30 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 4 | 0;
 i21 = i22;
 HEAP32[i20 + 16 >> 2] = i7;
 HEAP32[i20 + 4 >> 2] = i26;
 HEAP32[i20 + 12 >> 2] = i27 + 4;
 i19 = i20 + 8 | 0;
 HEAP32[i19 >> 2] = 0;
 i17 = i20 + 1 | 0;
 HEAP8[i17 >> 0] = 0;
 i18 = HEAP32[i23 + 4 >> 2] | 0;
 if (!i8) {
  if (i12 | 0) {
   i1 = 0;
   do {
    HEAP32[i14 + (i1 << 5) >> 2] = HEAP32[i13 + (i1 << 5) >> 2];
    HEAP32[i14 + (i1 << 5) + 4 >> 2] = HEAP32[i13 + (i1 << 5) + 4 >> 2];
    HEAP32[i14 + (i1 << 5) + 8 >> 2] = HEAP32[i13 + (i1 << 5) + 8 >> 2];
    HEAP32[i14 + (i1 << 5) + 16 >> 2] = HEAP32[i13 + (i1 << 5) + 16 >> 2];
    HEAP32[i14 + (i1 << 5) + 20 >> 2] = HEAP32[i13 + (i1 << 5) + 20 >> 2];
    HEAP32[i14 + (i1 << 5) + 24 >> 2] = HEAP32[i13 + (i1 << 5) + 24 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
  if (!i15) {
   STACKTOP = i22;
   return;
  } else i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i16 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i15 | 0));
  STACKTOP = i22;
  return;
 }
 if ((i9 | 0) > 0) {
  i11 = (i18 | 0) > 0;
  while (1) {
   HEAP8[i20 >> 0] = (i9 | 0) < 4 & 1;
   i8 = (i9 | 0) == 1 ? gb + 103580 | 0 : gb + 103620 | 0;
   i7 = HEAP32[i23 >> 2] | 0;
   if (i11) {
    i10 = 0;
    do {
     i6 = HEAP16[i7 + (i10 << 3) + 4 >> 1] | 0;
     i5 = HEAP32[i7 + (i10 << 3) >> 2] | 0;
     i4 = HEAP32[i24 + (i5 << 5) + 16 >> 2] | 0;
     i2 = i4;
     i30 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
     i29 = getTempRet0() | 0;
     i2 = _i64Add(i2 | 0, 0, 383, 0) | 0;
     i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
     i1 = getTempRet0() | 0;
     i29 = _i64Subtract(1, 0, i30 | 0, i29 | 0) | 0;
     i1 = _i64Add(i29 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
     i2 = getTempRet0() | 0;
     while (1) {
      i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
      i2 = getTempRet0() | 0;
      if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i4 = i4 + 64 | 0;
     }
     i4 = i6 & 65535;
     i2 = i24 + (i5 << 5) | 0;
     if (i6 << 16 >> 16) {
      i1 = 0;
      do i1 = i1 + 1 | 0; while ((i1 | 0) != (i4 | 0));
     }
     mftCall_viii(HEAP32[i8 + ((HEAPU16[i7 + (i10 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i2 | 0, i4 | 0, i20 | 0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i18 | 0));
   }
   if ((i9 | 0) > 1) i9 = i9 + -1 | 0; else break;
  }
 }
 if (i12 | 0) {
  i1 = 0;
  do {
   HEAP32[i14 + (i1 << 5) >> 2] = HEAP32[i13 + (i1 << 5) >> 2];
   HEAP32[i14 + (i1 << 5) + 4 >> 2] = HEAP32[i13 + (i1 << 5) + 4 >> 2];
   HEAP32[i14 + (i1 << 5) + 8 >> 2] = HEAP32[i13 + (i1 << 5) + 8 >> 2];
   HEAP32[i14 + (i1 << 5) + 16 >> 2] = HEAP32[i13 + (i1 << 5) + 16 >> 2];
   HEAP32[i14 + (i1 << 5) + 20 >> 2] = HEAP32[i13 + (i1 << 5) + 20 >> 2];
   HEAP32[i14 + (i1 << 5) + 24 >> 2] = HEAP32[i13 + (i1 << 5) + 24 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 }
 if (i15 | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i16 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i15 | 0));
 }
 if ((i28 | 0) > 1) {
  i8 = (i18 | 0) > 0;
  i1 = i28 + -1 | 0;
  i11 = 0;
  do {
   i9 = HEAP32[i23 >> 2] | 0;
   if (i8) {
    i10 = 0;
    do {
     i7 = HEAP16[i9 + (i10 << 3) + 4 >> 1] | 0;
     i6 = HEAP32[i9 + (i10 << 3) >> 2] | 0;
     i5 = HEAP32[i24 + (i6 << 5) + 16 >> 2] | 0;
     i4 = i5;
     i29 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
     i30 = getTempRet0() | 0;
     i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
     i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
     i2 = getTempRet0() | 0;
     i30 = _i64Subtract(1, 0, i29 | 0, i30 | 0) | 0;
     i2 = _i64Add(i30 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
     i4 = getTempRet0() | 0;
     while (1) {
      i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
      i4 = getTempRet0() | 0;
      if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
     }
     i5 = i7 & 65535;
     i4 = i24 + (i6 << 5) | 0;
     if (i7 << 16 >> 16) {
      i2 = 0;
      do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
     }
     mftCall_viii(HEAP32[gb + 103620 + ((HEAPU16[i9 + (i10 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i20 | 0);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i18 | 0));
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i1 | 0));
 } else i1 = 0;
 HEAP32[i21 >> 2] = HEAP32[i25 >> 2];
 HEAP8[i17 >> 0] = 1;
 if ((i1 | 0) < (i28 | 0)) {
  i10 = (i18 | 0) > 0;
  do {
   i8 = HEAP32[i23 >> 2] | 0;
   if (i10) {
    i9 = 0;
    do {
     i7 = HEAP16[i8 + (i9 << 3) + 4 >> 1] | 0;
     i6 = HEAP32[i8 + (i9 << 3) >> 2] | 0;
     i5 = HEAP32[i24 + (i6 << 5) + 16 >> 2] | 0;
     i4 = i5;
     i29 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
     i30 = getTempRet0() | 0;
     i4 = _i64Add(i4 | 0, 0, 383, 0) | 0;
     i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
     i2 = getTempRet0() | 0;
     i30 = _i64Subtract(1, 0, i29 | 0, i30 | 0) | 0;
     i2 = _i64Add(i30 | 0, getTempRet0() | 0, i4 | 0, i2 | 0) | 0;
     i4 = getTempRet0() | 0;
     while (1) {
      i2 = _i64Add(i2 | 0, i4 | 0, -1, -1) | 0;
      i4 = getTempRet0() | 0;
      if ((i2 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
     }
     i5 = i7 & 65535;
     i4 = i24 + (i6 << 5) | 0;
     if (i7 << 16 >> 16) {
      i2 = 0;
      do i2 = i2 + 1 | 0; while ((i2 | 0) != (i5 | 0));
     }
     mftCall_viiiiii(HEAP32[gb + 103660 + ((HEAPU16[i8 + (i9 << 3) + 6 >> 1] | 0) << 2) >> 2] | 0, i4 | 0, i5 | 0, i20 | 0, i26 | 0, i27 | 0, i21 | 0);
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i18 | 0));
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i28 | 0));
 }
 HEAP32[i25 >> 2] = HEAP32[i19 >> 2];
 STACKTOP = i22;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i20, i2, i21, i1) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26 + 32 | 0;
 i23 = i26 + 16 | 0;
 i24 = i26;
 f25 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i9 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i9) {
  STACKTOP = i26;
  return;
 }
 i10 = i2 + 60 | 0;
 i11 = i2 + 80 | 0;
 i12 = i2 + 100 | 0;
 i13 = i2 + 120 | 0;
 i14 = i2 + 140 | 0;
 i15 = i2 + 160 | 0;
 i16 = i22 + 4 | 0;
 i17 = i22 + 8 | 0;
 i18 = i22 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i23 + 4 | 0;
 i4 = i23 + 8 | 0;
 i5 = i23 + 12 | 0;
 i6 = i24 + 4 | 0;
 i7 = i24 + 8 | 0;
 i8 = i24 + 12 | 0;
 i1 = 0;
 do {
  i27 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i27 >> 2]);
  f56 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f54 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i27 >> 2]);
  f52 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f51 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f49 = Math_fround(HEAPF32[i27 >> 2]);
  f48 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f47 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f38 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f46 = Math_fround(HEAPF32[i27 >> 2]);
  f44 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f32 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f45 = Math_fround(HEAPF32[i27 >> 2]);
  f43 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i27 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  f37 = Math_fround(HEAPF32[i27 >> 2]);
  f35 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f46 = Math_fround(f57 + f46);
  f44 = Math_fround(f56 + f44);
  f28 = Math_fround(f55 + f28);
  f32 = Math_fround(f54 + f32);
  f45 = Math_fround(f53 + f45);
  f43 = Math_fround(f52 + f43);
  f30 = Math_fround(f51 + f30);
  f34 = Math_fround(f50 + f34);
  f37 = Math_fround(f49 + f37);
  f35 = Math_fround(f48 + f35);
  f39 = Math_fround(f47 + f39);
  f38 = Math_fround(f38 + Math_fround(HEAPF32[i27 + 12 >> 2]));
  f37 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f46 * f46) + Math_fround(f45 * f45)) + Math_fround(f37 * f37))))));
  f35 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f44 * f44) + Math_fround(f43 * f43)) + Math_fround(f35 * f35))))));
  f39 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f30 * f30)) + Math_fround(f39 * f39))))));
  f38 = Math_fround(f19 + Math_fround(f25 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f34 * f34)) + Math_fround(f38 * f38))))));
  i27 = f37 < Math_fround(0.0);
  f37 = i27 ? Math_fround(0.0) : f37;
  i27 = f35 < Math_fround(0.0);
  f35 = i27 ? Math_fround(0.0) : f35;
  i27 = f39 < Math_fround(0.0);
  f39 = i27 ? Math_fround(0.0) : f39;
  i27 = f38 < Math_fround(0.0);
  f38 = i27 ? Math_fround(0.0) : f38;
  i27 = f37 > Math_fround(1.0);
  f37 = i27 ? Math_fround(1.0) : f37;
  i27 = f35 > Math_fround(1.0);
  f35 = i27 ? Math_fround(1.0) : f35;
  i27 = f39 > Math_fround(1.0);
  f39 = i27 ? Math_fround(1.0) : f39;
  i27 = f38 > Math_fround(1.0);
  f38 = i27 ? Math_fround(1.0) : f38;
  HEAPF32[i22 >> 2] = f37;
  HEAPF32[i16 >> 2] = f35;
  HEAPF32[i17 >> 2] = f39;
  HEAPF32[i18 >> 2] = f38;
  i27 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i31 = (HEAP32[i27 >> 2] | 0) + -209354897 | 0;
  i42 = (HEAP32[i27 + 4 >> 2] | 0) + -209354897 | 0;
  i40 = (HEAP32[i27 + 8 >> 2] | 0) + -209354897 | 0;
  i27 = (HEAP32[i27 + 12 >> 2] | 0) + -209354897 | 0;
  i33 = (Math_imul(i31, 1790253981) | 0) + 1900727103 | 0;
  i41 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
  i36 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i29 = (Math_imul(i27, 1790253981) | 0) + 1900727103 | 0;
  i31 = i31 << 11 ^ i31;
  i42 = i42 << 11 ^ i42;
  i40 = i40 << 11 ^ i40;
  i27 = i27 << 11 ^ i27;
  f38 = Math_fround(Math_fround((i41 ^ i42 ^ i42 >>> 8) & 8388607 ^ i41 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f39 = Math_fround(Math_fround((i36 ^ i40 ^ i40 >>> 8) & 8388607 ^ i36 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i29 ^ i27 ^ i27 >>> 8) & 8388607 ^ i29 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i23 >> 2] = Math_fround(Math_fround((i33 ^ i31 ^ i31 >>> 8) & 8388607 ^ i33 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f38;
  HEAPF32[i4 >> 2] = f39;
  HEAPF32[i5 >> 2] = f35;
  i33 = i21 + (i1 << 2) | 0;
  f35 = Math_fround(HEAPF32[i33 >> 2]);
  i31 = i33 + 4 | 0;
  f39 = Math_fround(HEAPF32[i31 >> 2]);
  i29 = i33 + 8 | 0;
  f38 = Math_fround(HEAPF32[i29 >> 2]);
  i27 = i33 + 12 | 0;
  f37 = Math_fround(HEAPF32[i27 >> 2]);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i24, i20, i22, i23);
  f34 = Math_fround(HEAPF32[i24 >> 2]);
  i36 = f34 < Math_fround(0.0);
  f34 = i36 ? Math_fround(0.0) : f34;
  f32 = Math_fround(HEAPF32[i6 >> 2]);
  i36 = f32 < Math_fround(0.0);
  f32 = i36 ? Math_fround(0.0) : f32;
  f30 = Math_fround(HEAPF32[i7 >> 2]);
  i36 = f30 < Math_fround(0.0);
  f30 = i36 ? Math_fround(0.0) : f30;
  f28 = Math_fround(HEAPF32[i8 >> 2]);
  i36 = f28 < Math_fround(0.0);
  f32 = Math_fround(f39 * f32);
  f30 = Math_fround(f38 * f30);
  f28 = Math_fround(f37 * (i36 ? Math_fround(0.0) : f28));
  HEAPF32[i33 >> 2] = Math_fround(f35 * f34);
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i29 >> 2] = f30;
  HEAPF32[i27 >> 2] = f28;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i9 >>> 0);
 STACKTOP = i26;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i4, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 48 | 0;
 i10 = i12 + 24 | 0;
 i11 = i12 + 12 | 0;
 i6 = i12;
 L1 : do if ((i1 | 0) != (i4 | 0)) {
  i2 = (HEAP8[i1 >> 0] | 0) + -48 | 0;
  if (i2 >>> 0 < 10) {
   i3 = i1 + 1 | 0;
   if ((i3 | 0) != (i4 | 0)) {
    i7 = i2;
    while (1) {
     i2 = (HEAP8[i3 >> 0] | 0) + -48 | 0;
     if (i2 >>> 0 >= 10) break;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i4 | 0)) break L1;
     i7 = i2 + (i7 * 10 | 0) | 0;
    }
    if ((i4 - i3 | 0) >>> 0 >= i7 >>> 0) {
     HEAP32[i11 >> 2] = 0;
     HEAP32[i11 + 4 >> 2] = 0;
     HEAP32[i11 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i11, i3, i7);
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     i5 = HEAP8[i11 + 11 >> 0] | 0;
     i4 = i5 << 24 >> 24 < 0;
     i5 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255;
     __THREW__ = 0;
     invoke_viii(fb + 1064 | 0, i9 | 0, (i4 ? HEAP32[i11 >> 2] | 0 : i11) | 0, (i5 >>> 0 < 10 ? i5 : 10) | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     L10 : do if (i5 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i5 = HEAP8[i9 + 11 >> 0] | 0;
      i1 = i5 << 24 >> 24 < 0;
      if (((i1 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255) | 0) == 10) i1 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1 ? HEAP32[i9 >> 2] | 0 : i9, gb + 1087397 | 0, 10) | 0) == 0; else i1 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
      if (i1) {
       i1 = _malloc(32) | 0;
       HEAP32[i9 >> 2] = i1;
       HEAP32[i9 + 8 >> 2] = -2147483616;
       HEAP32[i9 + 4 >> 2] = 21;
       i2 = i1;
       i4 = gb + 1087408 | 0;
       i5 = i2 + 21 | 0;
       do {
        HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
        i2 = i2 + 1 | 0;
        i4 = i4 + 1 | 0;
       } while ((i2 | 0) < (i5 | 0));
       HEAP8[i1 + 21 >> 0] = 0;
       i2 = i9 + 12 | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       i1 = 0;
       while (1) {
        if ((i1 | 0) == 3) break;
        HEAP32[i2 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       }
       i1 = i8 + 4 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       i6 = HEAP32[i8 + 8 >> 2] | 0;
       i5 = i6;
       do if (i2 >>> 0 < i6 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i9);
        HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
       } else {
        i4 = HEAP32[i8 >> 2] | 0;
        i1 = (i2 - i4 | 0) / 24 | 0;
        i2 = i1 + 1 | 0;
        if (i2 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i8 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i9);
         break L10;
        } else {
         i5 = (i5 - i4 | 0) / 24 | 0;
         i6 = i5 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i10, i5 >>> 0 < 89478485 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 178956970, i1, i8 + 12 | 0);
         i6 = i10 + 8 | 0;
         i5 = HEAP32[i6 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i5, i9);
         HEAP32[i6 >> 2] = i5 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i10);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i9);
      } else {
       HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
       i1 = 0;
       while (1) {
        if ((i1 | 0) == 3) break;
        HEAP32[i11 + (i1 << 2) >> 2] = 0;
        i1 = i1 + 1 | 0;
       }
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i10, i6);
       i1 = i8 + 4 | 0;
       i2 = HEAP32[i1 >> 2] | 0;
       i4 = HEAP32[i8 + 8 >> 2] | 0;
       i5 = i4;
       do if (i2 >>> 0 < i4 >>> 0) {
        __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i10);
        HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
       } else {
        i4 = HEAP32[i8 >> 2] | 0;
        i1 = (i2 - i4 | 0) / 24 | 0;
        i2 = i1 + 1 | 0;
        if (i2 >>> 0 > 178956970) {
         __THREW__ = 0;
         invoke_vi(fb + 4014 | 0, i8 | 0);
         __THREW__ = 0;
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i10);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
         break L10;
        } else {
         i4 = (i5 - i4 | 0) / 24 | 0;
         i5 = i4 << 1;
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i4 >>> 0 < 89478485 ? (i5 >>> 0 < i2 >>> 0 ? i2 : i5) : 178956970, i1, i8 + 12 | 0);
         i5 = i9 + 8 | 0;
         i4 = HEAP32[i5 >> 2] | 0;
         __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i4, i10);
         HEAP32[i5 >> 2] = i4 + 24;
         __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9);
         __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
         break;
        }
       } while (0);
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i10);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
      i1 = i3 + i7 | 0;
      break L1;
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i11);
     ___resumeException(i1 | 0);
    }
   }
  }
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function _send_tree(i12, i13, i21) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i11 = HEAP16[i13 + 2 >> 1] | 0;
 i4 = i11 << 16 >> 16 == 0;
 i24 = i12 + 2754 | 0;
 i25 = i12 + 5820 | 0;
 i26 = i12 + 2752 | 0;
 i14 = i12 + 5816 | 0;
 i15 = i12 + 20 | 0;
 i16 = i12 + 8 | 0;
 i17 = i12 + 2758 | 0;
 i18 = i12 + 2756 | 0;
 i19 = i12 + 2750 | 0;
 i20 = i12 + 2748 | 0;
 i1 = 0;
 i2 = -1;
 i11 = i11 & 65535;
 i3 = i4 ? 138 : 7;
 i4 = i4 ? 3 : 4;
 L1 : while (1) {
  i9 = i1;
  i6 = 0;
  while (1) {
   if ((i9 | 0) > (i21 | 0)) break L1;
   i9 = i9 + 1 | 0;
   i10 = HEAP16[i13 + (i9 << 2) + 2 >> 1] | 0;
   i22 = i10 & 65535;
   i1 = i6 + 1 | 0;
   i23 = (i11 | 0) == (i22 | 0);
   if (!((i1 | 0) < (i3 | 0) & i23)) break; else i6 = i1;
  }
  do if ((i1 | 0) < (i4 | 0)) {
   i7 = i12 + 2684 + (i11 << 2) + 2 | 0;
   i8 = i12 + 2684 + (i11 << 2) | 0;
   i6 = i1;
   i1 = HEAP32[i25 >> 2] | 0;
   i2 = HEAP16[i14 >> 1] | 0;
   do {
    i5 = HEAPU16[i7 >> 1] | 0;
    i4 = HEAPU16[i8 >> 1] | 0;
    i3 = i2 & 65535 | i4 << i1;
    i2 = i3 & 65535;
    HEAP16[i14 >> 1] = i2;
    if ((i1 | 0) > (16 - i5 | 0)) {
     i2 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i2 >> 0] = i3;
     i2 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i1 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i2;
     i1 = HEAP32[i25 >> 2] | 0;
     i2 = i4 >>> (16 - i1 | 0) & 65535;
     HEAP16[i14 >> 1] = i2;
     i1 = i5 + -16 + i1 | 0;
    } else i1 = i1 + i5 | 0;
    HEAP32[i25 >> 2] = i1;
    i6 = i6 + -1 | 0;
   } while ((i6 | 0) != 0);
  } else {
   if (i11 | 0) {
    if ((i11 | 0) == (i2 | 0)) {
     i5 = i1;
     i4 = HEAP32[i25 >> 2] | 0;
     i1 = HEAP16[i14 >> 1] | 0;
    } else {
     i4 = HEAPU16[i12 + 2684 + (i11 << 2) + 2 >> 1] | 0;
     i5 = HEAP32[i25 >> 2] | 0;
     i1 = HEAPU16[i12 + 2684 + (i11 << 2) >> 1] | 0;
     i2 = HEAPU16[i14 >> 1] | 0 | i1 << i5;
     i3 = i2 & 65535;
     HEAP16[i14 >> 1] = i3;
     if ((i5 | 0) > (16 - i4 | 0)) {
      i3 = HEAP32[i15 >> 2] | 0;
      HEAP32[i15 >> 2] = i3 + 1;
      HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i2;
      i3 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
      i8 = HEAP32[i15 >> 2] | 0;
      HEAP32[i15 >> 2] = i8 + 1;
      HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i3;
      i8 = HEAP32[i25 >> 2] | 0;
      i3 = i1 >>> (16 - i8 | 0) & 65535;
      HEAP16[i14 >> 1] = i3;
      i1 = i4 + -16 + i8 | 0;
     } else i1 = i5 + i4 | 0;
     HEAP32[i25 >> 2] = i1;
     i5 = i6;
     i4 = i1;
     i1 = i3;
    }
    i3 = HEAPU16[i19 >> 1] | 0;
    i2 = HEAPU16[i20 >> 1] | 0;
    i1 = i1 & 65535 | i2 << i4;
    HEAP16[i14 >> 1] = i1;
    if ((i4 | 0) > (16 - i3 | 0)) {
     i8 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i1;
     i1 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i8 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i1;
     i8 = HEAP32[i25 >> 2] | 0;
     i1 = i2 >>> (16 - i8 | 0);
     HEAP16[i14 >> 1] = i1;
     i3 = i3 + -16 + i8 | 0;
    } else i3 = i4 + i3 | 0;
    HEAP32[i25 >> 2] = i3;
    i2 = i5 + -3 | 0;
    i1 = i1 & 65535 | i2 << i3;
    HEAP16[i14 >> 1] = i1;
    if ((i3 | 0) > 14) {
     i8 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i1;
     i8 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i1 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i8;
     i1 = HEAP32[i25 >> 2] | 0;
     HEAP16[i14 >> 1] = (i2 & 65535) >>> (16 - i1 | 0);
     i1 = i1 + -14 | 0;
    } else i1 = i3 + 2 | 0;
    HEAP32[i25 >> 2] = i1;
    break;
   }
   if ((i1 | 0) < 11) {
    i2 = HEAPU16[i24 >> 1] | 0;
    i3 = HEAP32[i25 >> 2] | 0;
    i4 = HEAPU16[i26 >> 1] | 0;
    i1 = HEAPU16[i14 >> 1] | 0 | i4 << i3;
    HEAP16[i14 >> 1] = i1;
    if ((i3 | 0) > (16 - i2 | 0)) {
     i3 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i3 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i1;
     i1 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i3 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i3 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i1;
     i3 = HEAP32[i25 >> 2] | 0;
     i1 = i4 >>> (16 - i3 | 0);
     HEAP16[i14 >> 1] = i1;
     i3 = i2 + -16 + i3 | 0;
    } else i3 = i3 + i2 | 0;
    HEAP32[i25 >> 2] = i3;
    i2 = i6 + -2 | 0;
    i1 = i1 & 65535 | i2 << i3;
    HEAP16[i14 >> 1] = i1;
    if ((i3 | 0) > 13) {
     i8 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i1;
     i8 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i1 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i8;
     i1 = HEAP32[i25 >> 2] | 0;
     HEAP16[i14 >> 1] = (i2 & 65535) >>> (16 - i1 | 0);
     i1 = i1 + -13 | 0;
    } else i1 = i3 + 3 | 0;
    HEAP32[i25 >> 2] = i1;
    break;
   } else {
    i2 = HEAPU16[i17 >> 1] | 0;
    i3 = HEAP32[i25 >> 2] | 0;
    i4 = HEAPU16[i18 >> 1] | 0;
    i1 = HEAPU16[i14 >> 1] | 0 | i4 << i3;
    HEAP16[i14 >> 1] = i1;
    if ((i3 | 0) > (16 - i2 | 0)) {
     i3 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i3 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i1;
     i1 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i3 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i3 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i1;
     i3 = HEAP32[i25 >> 2] | 0;
     i1 = i4 >>> (16 - i3 | 0);
     HEAP16[i14 >> 1] = i1;
     i3 = i2 + -16 + i3 | 0;
    } else i3 = i3 + i2 | 0;
    HEAP32[i25 >> 2] = i3;
    i2 = i6 + -10 | 0;
    i1 = i1 & 65535 | i2 << i3;
    HEAP16[i14 >> 1] = i1;
    if ((i3 | 0) > 9) {
     i8 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i8 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i8 >> 0] = i1;
     i8 = (HEAPU16[i14 >> 1] | 0) >>> 8 & 255;
     i1 = HEAP32[i15 >> 2] | 0;
     HEAP32[i15 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i16 >> 2] | 0) + i1 >> 0] = i8;
     i1 = HEAP32[i25 >> 2] | 0;
     HEAP16[i14 >> 1] = (i2 & 65535) >>> (16 - i1 | 0);
     i1 = i1 + -9 | 0;
    } else i1 = i3 + 7 | 0;
    HEAP32[i25 >> 2] = i1;
    break;
   }
  } while (0);
  i4 = i10 << 16 >> 16 == 0;
  i2 = i11;
  i1 = i9;
  i11 = i22;
  i3 = i4 ? 138 : i23 ? 6 : 7;
  i4 = i4 | i23 ? 3 : 4;
 }
 return;
}

function __ZN28LightsModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = HEAP32[gb + 1111240 + 716 >> 2] ^ 16777215;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 105) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 103) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 104) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 116) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 115) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 77) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 100) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 117) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 108) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 101) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 46) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 114) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 97) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 116) << 2) >> 2] ^ i6 >>> 8;
 i6 = HEAP32[gb + 1111240 + ((i6 & 255 ^ 105) << 2) >> 2] ^ i6 >>> 8;
 HEAP32[i5 >> 2] = ~(HEAP32[gb + 1111240 + ((i6 & 255 ^ 111) << 2) >> 2] ^ i6 >>> 8);
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i4 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 616972 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616972 + 31 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 1;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617004 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617004 + 29 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 2;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617034 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617034 + 29 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 3;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617064 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617064 + 34 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100001;
 HEAP32[i5 + 12 >> 2] = 4;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617099 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617099 + 30 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 5;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
 }
 i1 = gb + 617130 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617130 + 34 | 0));
 HEAP32[i5 >> 2] = ~i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 6;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 __ZN5physx7profile12MemoryBufferINS0_21WrapperNamedAllocatorEE5writeIyEEvRKT_(HEAP32[i18 >> 2] | 0, i17);
 i9 = i17 + 8 | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 i10 = i7 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i7 + 8 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i16 = i4;
 i5 = i1 - i16 | 0;
 i2 = i5 + 4 | 0;
 i6 = i7 + 16 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i16 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i7 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i5 | 0) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) {
    i16 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
  HEAP32[i8 >> 2] = i2;
  i1 = i2 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = HEAP8[i9 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i9 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i9 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i9 + 3 >> 0] | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 i14 = HEAP32[i17 + 12 >> 2] | 0;
 i16 = i17 + 16 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 i9 = i15 & 255;
 i10 = i15 >>> 8 & 255;
 i11 = i15 >>> 16 & 255;
 i12 = i15 >>> 24 & 255;
 i5 = HEAP32[i18 >> 2] | 0;
 i13 = i5 + 12 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3;
 i7 = i1 - i4 | 0;
 i2 = i7 + 4 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i9;
 HEAP8[i1 + 1 >> 0] = i10;
 HEAP8[i1 + 2 >> 0] = i11;
 HEAP8[i1 + 3 >> 0] = i12;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
 if (i15 | 0) {
  i5 = HEAP32[i18 >> 2] | 0;
  if (i14 | 0) {
   i9 = i5 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i13 = i3;
   i7 = i1 - i13 | 0;
   i2 = i7 + i15 | 0;
   i8 = i5 + 16 | 0;
   if (((HEAP32[i8 >> 2] | 0) - i13 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) {
      i13 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
     }
    }
    HEAP32[i6 >> 2] = i2;
    i1 = i2 + i7 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i8 >> 2] = i2 + i4;
   }
   _memcpy(i1 | 0, i14 | 0, i15 | 0) | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i15;
  }
 }
 i5 = HEAP32[i18 >> 2] | 0;
 i9 = i5 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i15 = i3;
 i7 = i1 - i15 | 0;
 i2 = i7 + 4 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i15 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i15 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = HEAP8[i16 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i16 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i16 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i16 + 3 >> 0] | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 4;
 i10 = i17 + 20 | 0;
 i5 = HEAP32[i18 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i18 = i3;
 i8 = i1 - i18 | 0;
 i2 = i8 + 4 | 0;
 i9 = i5 + 16 | 0;
 if (((HEAP32[i9 >> 2] | 0) - i18 | 0) >>> 0 > i2 >>> 0) {
  i18 = i1;
  i17 = HEAP8[i10 >> 0] | 0;
  HEAP8[i18 >> 0] = i17;
  i17 = i10 + 1 | 0;
  i17 = HEAP8[i17 >> 0] | 0;
  i16 = i18 + 1 | 0;
  HEAP8[i16 >> 0] = i17;
  i16 = i10 + 2 | 0;
  i16 = HEAP8[i16 >> 0] | 0;
  i17 = i18 + 2 | 0;
  HEAP8[i17 >> 0] = i16;
  i17 = i10 + 3 | 0;
  i17 = HEAP8[i17 >> 0] | 0;
  i18 = i18 + 3 | 0;
  HEAP8[i18 >> 0] = i17;
  i18 = HEAP32[i6 >> 2] | 0;
  i18 = i18 + 4 | 0;
  HEAP32[i6 >> 2] = i18;
  return;
 }
 i4 = i2 << 1;
 if (!i4) {
  i2 = 0;
  i1 = i3;
 } else {
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (i1 | 0) {
  _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i18 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 HEAP32[i7 >> 2] = i2;
 i18 = i2 + i8 | 0;
 HEAP32[i6 >> 2] = i18;
 HEAP32[i9 >> 2] = i2 + i4;
 i17 = HEAP8[i10 >> 0] | 0;
 HEAP8[i18 >> 0] = i17;
 i17 = i10 + 1 | 0;
 i17 = HEAP8[i17 >> 0] | 0;
 i16 = i18 + 1 | 0;
 HEAP8[i16 >> 0] = i17;
 i16 = i10 + 2 | 0;
 i16 = HEAP8[i16 >> 0] | 0;
 i17 = i18 + 2 | 0;
 HEAP8[i17 >> 0] = i16;
 i17 = i10 + 3 | 0;
 i17 = HEAP8[i17 >> 0] | 0;
 i18 = i18 + 3 | 0;
 HEAP8[i18 >> 0] = i17;
 i18 = HEAP32[i6 >> 2] | 0;
 i18 = i18 + 4 | 0;
 HEAP32[i6 >> 2] = i18;
 return;
}

function __ZN21AnimationClipPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE(i22, f23, i24) {
 i22 = i22 | 0;
 f23 = Math_fround(f23);
 i24 = i24 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0, i26 = 0, f27 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 12 | 0;
 i16 = i26 + 8 | 0;
 i15 = i26 + 4 | 0;
 i21 = i26;
 i3 = HEAP32[i22 + 120 >> 2] | 0;
 i18 = (i3 & 2 | 0) == 0;
 i17 = i3 & 1;
 if (HEAP32[i22 + 116 >> 2] | 0) {
  i12 = i22 + 164 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (i2 | 0) {
   i19 = i22 + 84 | 0;
   if (HEAP32[i19 >> 2] | 0) if ((HEAP32[i2 + 200 >> 2] | 0) != (HEAP32[i2 + 196 >> 2] | 0)) if (f23 > Math_fround(0.0) | (i3 & 3 | 0) != 0) {
    i3 = i24 + 12 | 0;
    i13 = HEAP32[i3 >> 2] | 0;
    i4 = i13 + 1 | 0;
    i5 = i24 + 16 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i8 = i6 & 2147483647;
    do if (i4 >>> 0 > i8 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i8 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2 * 60 | 0, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 60 | 0, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i8 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 60 | 0) | 0;
      HEAP32[i5 >> 2] = i2;
      HEAP32[i24 >> 2] = i8;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i4;
    i5 = HEAP32[i24 >> 2] | 0;
    HEAP32[i5 + (i13 * 60 | 0) >> 2] = HEAP32[i12 >> 2];
    i2 = i5 + (i13 * 60 | 0) + 12 | 0;
    i3 = i22 + 128 | 0;
    i4 = i2 + 36 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i2 = HEAP32[i12 >> 2] | 0;
    f14 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0));
    i2 = HEAP32[i12 >> 2] | 0;
    if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
    HEAP32[i5 + (i13 * 60 | 0) + 48 >> 2] = i2;
    HEAPF32[i5 + (i13 * 60 | 0) + 52 >> 2] = f23;
    f27 = Math_fround(HEAPF32[i22 + 100 >> 2]);
    i6 = i5 + (i13 * 60 | 0) + 8 | 0;
    i12 = i22 + 96 | 0;
    f7 = Math_fround(HEAPF32[i12 >> 2]);
    i8 = i5 + (i13 * 60 | 0) + 4 | 0;
    i4 = f14 != Math_fround(0.0);
    f1 = i4 ? f14 : Math_fround(1.0);
    f27 = Math_fround(f27 / f1);
    HEAPF32[i6 >> 2] = f27;
    HEAPF32[i8 >> 2] = Math_fround(f7 / f1);
    i4 = i22 + 104 | 0;
    f1 = Math_fround(HEAPF32[i4 >> 2]);
    i2 = i5 + (i13 * 60 | 0) + 56 | 0;
    HEAPF32[i2 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i5 + (i13 * 60 | 0) + 36 >> 2]));
    i13 = HEAP32[i19 >> 2] | 0;
    f11 = Math_fround(HEAPF32[i13 + 1080 >> 2]);
    f11 = Math_fround(f11 + Math_fround(HEAPF32[i22 + 108 >> 2]));
    HEAPF32[i16 >> 2] = Math_fround(0.0);
    HEAPF32[i15 >> 2] = Math_fround(0.0);
    f10 = Math_fround(HEAPF32[i13 + 1064 >> 2]);
    f9 = Math_fround(HEAPF32[i13 + 1068 >> 2]);
    HEAPF32[i6 >> 2] = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f27, f10, f9, f11, (HEAP8[i13 + 1725 >> 0] | 0) != 0, f1, i20, i16, f7 < Math_fround(0.0)));
    f7 = Math_fround(HEAPF32[i8 >> 2]);
    i13 = HEAP32[i19 >> 2] | 0;
    f1 = Math_fround(HEAPF32[i13 + 1064 >> 2]);
    f9 = Math_fround(HEAPF32[i13 + 1068 >> 2]);
    f10 = Math_fround(HEAPF32[i4 >> 2]);
    f10 = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f7, f1, f9, f11, (HEAP8[i13 + 1725 >> 0] | 0) != 0, f10, i20, i15, Math_fround(HEAPF32[i12 >> 2]) < Math_fround(0.0)));
    HEAPF32[i8 >> 2] = f10;
    f9 = Math_fround(HEAPF32[i15 >> 2]);
    f1 = Math_fround(HEAPF32[i16 >> 2]);
    f7 = Math_fround(HEAPF32[i2 >> 2]);
    i16 = f9 > f1 & f7 > Math_fround(0.0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    if (i16) HEAPF32[i8 >> 2] = Math_fround(f10 + Math_fround(f14 * Math_fround(f9 - f1))); else if (f9 < f1 & f7 < Math_fround(0.0)) HEAPF32[i8 >> 2] = Math_fround(f10 - Math_fround(f14 * Math_fround(f1 - f9)));
    i3 = (HEAP32[tempDoublePtr >> 2] = i2 & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
    i2 = (i17 | 0) == 0;
    do if (i2 | i3 ^ 1) {
     if (!(i2 | i3)) {
      HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(9.99999997e-07));
      break;
     }
     if (!i18) {
      i2 = HEAP32[i19 >> 2] | 0;
      if (HEAP8[i2 + 1725 >> 0] | 0) {
       i19 = HEAP32[i22 + 124 >> 2] | 0;
       HEAPF32[i21 >> 2] = Math_fround(0.0);
       f10 = Math_fround(HEAPF32[i19 + 64 >> 2]);
       f1 = Math_fround(HEAPF32[i2 + 1064 >> 2]);
       f27 = Math_fround(HEAPF32[i2 + 1068 >> 2]);
       f10 = Math_fround(__ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f10, f1, f27, f11, 1, Math_fround(HEAPF32[i4 >> 2]), i20, i21, f10 < Math_fround(0.0)));
       i20 = f10 == Math_fround(0.0) ? Math_fround(HEAPF32[i21 >> 2]) != Math_fround(0.0) : 0;
       f11 = i20 ? Math_fround(1.0) : Math_fround(0.0);
       HEAPF32[i21 >> 2] = f11;
       f27 = Math_fround(HEAPF32[i19 + 72 >> 2]);
       f1 = Math_fround(f14 * f27);
       f1 = Math_fround(Math_fround(f10 + Math_fround(f14 * f11)) + (HEAP8[i19 + 84 >> 0] | 0 ? f27 : f1));
       if (f1 <= Math_fround(HEAPF32[i8 >> 2])) {
        HEAPF32[i8 >> 2] = f1;
        if (Math_fround(HEAPF32[i6 >> 2]) > f1) HEAPF32[i6 >> 2] = f1;
       }
      }
     }
    } else HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(-9.99999997e-07)); while (0);
   }
  }
 }
 i5 = i22 + 8 | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i26;
  return;
 }
 i3 = 0;
 do {
  i4 = i3;
  i2 = i22;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i4 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i25 = 34;
    break;
   } else i4 = 0;
  }
  if ((i25 | 0) == 34) {
   i25 = 0;
   mftCall_vifi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, +Math_fround(Math_fround(HEAPF32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0) + (i3 << 3) >> 2]) * f23), i24 | 0);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 STACKTOP = i26;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i20, i1, i21, i2) {
 i3 = i3 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 16 | 0;
 i17 = i19;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i9) {
  STACKTOP = i19;
  return;
 }
 i10 = i3 + 60 | 0;
 i11 = i3 + 80 | 0;
 i12 = i3 + 100 | 0;
 i13 = i3 + 120 | 0;
 i14 = i3 + 140 | 0;
 i2 = i3 + 160 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16 + 8 | 0;
 i5 = i16 + 12 | 0;
 i6 = i17 + 4 | 0;
 i7 = i17 + 8 | 0;
 i8 = i17 + 12 | 0;
 i1 = 0;
 do {
  i39 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  f65 = Math_fround(HEAPF32[i39 >> 2]);
  f64 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f63 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f61 = Math_fround(HEAPF32[i39 >> 2]);
  f60 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f58 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i39 >> 2]);
  f56 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f54 = Math_fround(HEAPF32[i39 >> 2]);
  f52 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f50 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f48 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i39 >> 2]);
  f51 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f47 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f46 = Math_fround(HEAPF32[i39 >> 2]);
  f45 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f54 = Math_fround(f65 + f54);
  f52 = Math_fround(f64 + f52);
  f50 = Math_fround(f63 + f50);
  f48 = Math_fround(f62 + f48);
  f53 = Math_fround(f61 + f53);
  f51 = Math_fround(f60 + f51);
  f49 = Math_fround(f59 + f49);
  f47 = Math_fround(f58 + f47);
  f46 = Math_fround(f57 + f46);
  f45 = Math_fround(f56 + f45);
  f44 = Math_fround(f55 + f44);
  f43 = Math_fround(f43 + Math_fround(HEAPF32[i39 + 12 >> 2]));
  f46 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f53 * f53)) + Math_fround(f46 * f46))))));
  f45 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51)) + Math_fround(f45 * f45))))));
  f44 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f50 * f50) + Math_fround(f49 * f49)) + Math_fround(f44 * f44))))));
  f43 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f48 * f48) + Math_fround(f47 * f47)) + Math_fround(f43 * f43))))));
  i39 = f46 < Math_fround(0.0);
  f46 = i39 ? Math_fround(0.0) : f46;
  i39 = f45 < Math_fround(0.0);
  f45 = i39 ? Math_fround(0.0) : f45;
  i39 = f44 < Math_fround(0.0);
  f44 = i39 ? Math_fround(0.0) : f44;
  i39 = f43 < Math_fround(0.0);
  f43 = i39 ? Math_fround(0.0) : f43;
  i39 = f46 > Math_fround(1.0);
  f46 = i39 ? Math_fround(1.0) : f46;
  i39 = f45 > Math_fround(1.0);
  f45 = i39 ? Math_fround(1.0) : f45;
  i39 = f44 > Math_fround(1.0);
  f44 = i39 ? Math_fround(1.0) : f44;
  i39 = f43 > Math_fround(1.0);
  f43 = i39 ? Math_fround(1.0) : f43;
  HEAPF32[i16 >> 2] = f46;
  HEAPF32[i3 >> 2] = f45;
  HEAPF32[i4 >> 2] = f44;
  HEAPF32[i5 >> 2] = f43;
  __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i17, i21, i16);
  i39 = HEAP32[i17 >> 2] | 0;
  i34 = HEAP32[i6 >> 2] | 0;
  i29 = HEAP32[i7 >> 2] | 0;
  i24 = HEAP32[i8 >> 2] | 0;
  i37 = i20 + (i1 << 2) | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i37 + 4 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i37 + 8 | 0;
  i25 = HEAP32[i27 >> 2] | 0;
  i22 = i37 + 12 | 0;
  i42 = HEAP32[i22 >> 2] | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i25 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i25 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i25 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i25 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  i25 = (Math_imul(i42 & 255, i24 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i42 >>> 8 & 255, i24 >>> 8 & 255) | 0) + 128 | 0;
  i23 = (Math_imul(i42 >>> 16 & 255, i24 >>> 16 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i42 >>> 24, i24 >>> 24) | 0) + 128 | 0;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  HEAP32[i22 >> 2] = (i26 >>> 8) + i26 & 261888 | ((i25 >>> 8) + i25 | 0) >>> 8 | ((i24 >>> 8) + i24 | 0) >>> 8 << 24 | ((i23 >>> 8) + i23 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i9 >>> 0);
 STACKTOP = i19;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i3, i20, i1, i21, i2) {
 i3 = i3 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0, f65 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 16 | 0;
 i17 = i19;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i9) {
  STACKTOP = i19;
  return;
 }
 i10 = i3 + 60 | 0;
 i11 = i3 + 80 | 0;
 i12 = i3 + 100 | 0;
 i13 = i3 + 120 | 0;
 i14 = i3 + 140 | 0;
 i2 = i3 + 160 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16 + 8 | 0;
 i5 = i16 + 12 | 0;
 i6 = i17 + 4 | 0;
 i7 = i17 + 8 | 0;
 i8 = i17 + 12 | 0;
 i1 = 0;
 do {
  i39 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  f65 = Math_fround(HEAPF32[i39 >> 2]);
  f64 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f63 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f62 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f61 = Math_fround(HEAPF32[i39 >> 2]);
  f60 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f59 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f58 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
  f57 = Math_fround(HEAPF32[i39 >> 2]);
  f56 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f55 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i13 >> 2] | 0) + (i1 << 2) | 0;
  f54 = Math_fround(HEAPF32[i39 >> 2]);
  f52 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f50 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f48 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f53 = Math_fround(HEAPF32[i39 >> 2]);
  f51 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f47 = Math_fround(HEAPF32[i39 + 12 >> 2]);
  i39 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f46 = Math_fround(HEAPF32[i39 >> 2]);
  f45 = Math_fround(HEAPF32[i39 + 4 >> 2]);
  f44 = Math_fround(HEAPF32[i39 + 8 >> 2]);
  f54 = Math_fround(f65 + f54);
  f52 = Math_fround(f64 + f52);
  f50 = Math_fround(f63 + f50);
  f48 = Math_fround(f62 + f48);
  f53 = Math_fround(f61 + f53);
  f51 = Math_fround(f60 + f51);
  f49 = Math_fround(f59 + f49);
  f47 = Math_fround(f58 + f47);
  f46 = Math_fround(f57 + f46);
  f45 = Math_fround(f56 + f45);
  f44 = Math_fround(f55 + f44);
  f43 = Math_fround(f43 + Math_fround(HEAPF32[i39 + 12 >> 2]));
  f46 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f54 * f54) + Math_fround(f53 * f53)) + Math_fround(f46 * f46))))));
  f45 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f52 * f52) + Math_fround(f51 * f51)) + Math_fround(f45 * f45))))));
  f44 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f50 * f50) + Math_fround(f49 * f49)) + Math_fround(f44 * f44))))));
  f43 = Math_fround(f15 + Math_fround(f18 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f48 * f48) + Math_fround(f47 * f47)) + Math_fround(f43 * f43))))));
  i39 = f46 < Math_fround(0.0);
  f46 = i39 ? Math_fround(0.0) : f46;
  i39 = f45 < Math_fround(0.0);
  f45 = i39 ? Math_fround(0.0) : f45;
  i39 = f44 < Math_fround(0.0);
  f44 = i39 ? Math_fround(0.0) : f44;
  i39 = f43 < Math_fround(0.0);
  f43 = i39 ? Math_fround(0.0) : f43;
  i39 = f46 > Math_fround(1.0);
  f46 = i39 ? Math_fround(1.0) : f46;
  i39 = f45 > Math_fround(1.0);
  f45 = i39 ? Math_fround(1.0) : f45;
  i39 = f44 > Math_fround(1.0);
  f44 = i39 ? Math_fround(1.0) : f44;
  i39 = f43 > Math_fround(1.0);
  f43 = i39 ? Math_fround(1.0) : f43;
  HEAPF32[i16 >> 2] = f46;
  HEAPF32[i3 >> 2] = f45;
  HEAPF32[i4 >> 2] = f44;
  HEAPF32[i5 >> 2] = f43;
  __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i17, i21, i16);
  i39 = HEAP32[i17 >> 2] | 0;
  i34 = HEAP32[i6 >> 2] | 0;
  i29 = HEAP32[i7 >> 2] | 0;
  i24 = HEAP32[i8 >> 2] | 0;
  i37 = i20 + (i1 << 2) | 0;
  i35 = HEAP32[i37 >> 2] | 0;
  i32 = i37 + 4 | 0;
  i30 = HEAP32[i32 >> 2] | 0;
  i27 = i37 + 8 | 0;
  i25 = HEAP32[i27 >> 2] | 0;
  i22 = i37 + 12 | 0;
  i42 = HEAP32[i22 >> 2] | 0;
  i40 = (Math_imul(i35 & 255, i39 & 255) | 0) + 128 | 0;
  i41 = (Math_imul(i35 >>> 8 & 255, i39 >>> 8 & 255) | 0) + 128 | 0;
  i38 = (Math_imul(i35 >>> 16 & 255, i39 >>> 16 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i35 >>> 24, i39 >>> 24) | 0) + 128 | 0;
  i35 = (Math_imul(i30 & 255, i34 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i30 >>> 8 & 255, i34 >>> 8 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i30 >>> 16 & 255, i34 >>> 16 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i30 >>> 24, i34 >>> 24) | 0) + 128 | 0;
  i30 = (Math_imul(i25 & 255, i29 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i25 >>> 8 & 255, i29 >>> 8 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i25 >>> 16 & 255, i29 >>> 16 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i25 >>> 24, i29 >>> 24) | 0) + 128 | 0;
  i25 = (Math_imul(i42 & 255, i24 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i42 >>> 8 & 255, i24 >>> 8 & 255) | 0) + 128 | 0;
  i23 = (Math_imul(i42 >>> 16 & 255, i24 >>> 16 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i42 >>> 24, i24 >>> 24) | 0) + 128 | 0;
  HEAP32[i37 >> 2] = (i41 >>> 8) + i41 & 261888 | ((i40 >>> 8) + i40 | 0) >>> 8 | ((i39 >>> 8) + i39 | 0) >>> 8 << 24 | ((i38 >>> 8) + i38 | 0) >>> 8 << 16;
  HEAP32[i32 >> 2] = (i36 >>> 8) + i36 & 261888 | ((i35 >>> 8) + i35 | 0) >>> 8 | ((i34 >>> 8) + i34 | 0) >>> 8 << 24 | ((i33 >>> 8) + i33 | 0) >>> 8 << 16;
  HEAP32[i27 >> 2] = (i31 >>> 8) + i31 & 261888 | ((i30 >>> 8) + i30 | 0) >>> 8 | ((i29 >>> 8) + i29 | 0) >>> 8 << 24 | ((i28 >>> 8) + i28 | 0) >>> 8 << 16;
  HEAP32[i22 >> 2] = (i26 >>> 8) + i26 & 261888 | ((i25 >>> 8) + i25 | 0) >>> 8 | ((i24 >>> 8) + i24 | 0) >>> 8 << 24 | ((i23 >>> 8) + i23 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i9 >>> 0);
 STACKTOP = i19;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEbT0_S6_T_(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 switch ((i12 - i13 | 0) / 20 | 0 | 0) {
 case 2:
  {
   i7 = i12 + -20 | 0;
   i1 = HEAP32[i12 + -4 >> 2] | 0;
   i2 = i1 & 255;
   i3 = HEAP32[i13 + 16 >> 2] | 0;
   i4 = i3 & 255;
   i5 = (i1 & 65535) >>> 8 & 255;
   i6 = (i3 & 65535) >>> 8 & 255;
   do if (i2 << 24 >> 24 == i4 << 24 >> 24) if (i5 << 24 >> 24 == i6 << 24 >> 24) {
    if ((i1 & 65536 | 0) == 0 & (i3 & 65536 | 0) != 0) break; else i1 = 1;
    STACKTOP = i15;
    return i1 | 0;
   } else {
    if ((i5 & 255) < (i6 & 255)) break; else i1 = 1;
    STACKTOP = i15;
    return i1 | 0;
   } else if ((i2 & 255) >= (i4 & 255)) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   } while (0);
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP16[i13 + 16 >> 1] = HEAP16[i7 + 16 >> 1] | 0;
   HEAP8[i13 + 18 >> 0] = HEAP8[i7 + 18 >> 0] | 0;
   HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP16[i7 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
   HEAP8[i7 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i13, i13 + 20 | 0, i12 + -20 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_(i13, i13 + 20 | 0, i13 + 40 | 0, i12 + -20 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_(i13, i13 + 20 | 0, i13 + 40 | 0, i13 + 60 | 0, i12 + -20 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i3 = i13 + 40 | 0;
   __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i13, i13 + 20 | 0, i3, i1) | 0;
   i1 = i13 + 60 | 0;
   L3 : do if ((i1 | 0) == (i12 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i10 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = i10 & 255;
     i4 = HEAP32[i3 + 16 >> 2] | 0;
     i5 = i4 & 255;
     i9 = (i10 & 65535) >>> 8 & 255;
     i6 = (i4 & 65535) >>> 8 & 255;
     do if (i8 << 24 >> 24 == i5 << 24 >> 24) if (i9 << 24 >> 24 == i6 << 24 >> 24) if ((i10 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) {
      i11 = 17;
      break;
     } else break; else if ((i9 & 255) < (i6 & 255)) {
      i11 = 17;
      break;
     } else break; else if ((i8 & 255) < (i5 & 255)) i11 = 17; while (0);
     if ((i11 | 0) == 17) {
      i11 = 0;
      HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP16[i1 + 16 >> 1] = HEAP16[i3 + 16 >> 1] | 0;
      HEAP8[i1 + 18 >> 0] = HEAP8[i3 + 18 >> 0] | 0;
      L14 : do if ((i3 | 0) == (i13 | 0)) i4 = i13; else {
       if (i10 & 65536) while (1) {
        i6 = i3 + -20 | 0;
        i4 = HEAP32[i3 + -4 >> 2] | 0;
        i5 = i4 & 255;
        if (i8 << 24 >> 24 == i5 << 24 >> 24) {
         if ((i9 & 255) >= ((i4 & 65535) >>> 8 & 255)) {
          i4 = i3;
          break L14;
         }
        } else if ((i8 & 255) >= (i5 & 255)) {
         i4 = i3;
         break L14;
        };
        HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
        HEAP16[i3 + 16 >> 1] = HEAP16[i6 + 16 >> 1] | 0;
        HEAP8[i3 + 18 >> 0] = HEAP8[i6 + 18 >> 0] | 0;
        if ((i6 | 0) == (i13 | 0)) {
         i4 = i13;
         i3 = i6;
         break L14;
        } else i3 = i6;
       }
       while (1) {
        i7 = i3 + -20 | 0;
        i4 = HEAP32[i3 + -4 >> 2] | 0;
        i5 = i4 & 255;
        i6 = (i4 & 65535) >>> 8 & 255;
        do if (i8 << 24 >> 24 == i5 << 24 >> 24) if (i9 << 24 >> 24 == i6 << 24 >> 24) if (!(i4 & 65536)) {
         i4 = i3;
         break L14;
        } else break; else if ((i9 & 255) < (i6 & 255)) break; else {
         i4 = i3;
         break L14;
        } else if ((i8 & 255) >= (i5 & 255)) {
         i4 = i3;
         break L14;
        } while (0);
        HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
        HEAP16[i3 + 16 >> 1] = HEAP16[i7 + 16 >> 1] | 0;
        HEAP8[i3 + 18 >> 0] = HEAP8[i7 + 18 >> 0] | 0;
        if ((i7 | 0) == (i13 | 0)) {
         i4 = i13;
         i3 = i7;
         break;
        } else i3 = i7;
       }
      } while (0);
      HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i9 = i4 + 16 | 0;
      HEAP16[i9 >> 1] = i10;
      HEAP8[i9 + 2 >> 0] = i10 >>> 16;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 20 | 0) == (i12 | 0);
       break L3;
      }
     }
     i3 = i1 + 20 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i14 = i1 | i2;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 return 0;
}

function __Z22SetupForwardBaseLightsRK18ForwardLightsBlockR17ShaderPassContextRK10TextureRefS6_(i15, i18, i16, i17) {
 i15 = i15 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19 + 112 | 0;
 i10 = i19 + 96 | 0;
 i11 = i19 + 80 | 0;
 i12 = i19 + 64 | 0;
 i13 = i19;
 i14 = __Z12GetGfxDevicev() | 0;
 i5 = i14 + 4 | 0;
 i3 = i15 + 132 + (HEAP32[i15 + 112 >> 2] << 2) | 0;
 i8 = HEAP32[i15 + 116 >> 2] | 0;
 if ((i8 | 0) > 0) {
  f20 = Math_fround(HEAPF32[i15 + 120 >> 2]);
  f6 = Math_fround(Math_fround(1.0) - f20);
  i4 = i8 + -1 | 0;
  f7 = Math_fround(HEAPF32[i15 + 124 >> 2]);
  i2 = f20 == Math_fround(1.0);
  i1 = 0;
  do {
   i27 = HEAP32[HEAP32[i3 + (i1 << 2) >> 2] >> 2] | 0;
   i26 = HEAP32[i27 + 268 >> 2] | 0;
   i25 = HEAP32[i27 + 272 >> 2] | 0;
   f20 = (i1 | 0) == (i4 | 0) ? f7 : Math_fround(1.0);
   f20 = (i1 | 0) != 0 | i2 ? f20 : f6;
   f23 = Math_fround(f20 * Math_fround(HEAPF32[i27 + 156 >> 2]));
   f22 = Math_fround(f20 * Math_fround(HEAPF32[i27 + 160 >> 2]));
   f21 = Math_fround(f20 * Math_fround(HEAPF32[i27 + 164 >> 2]));
   f20 = Math_fround(f20 * Math_fround(HEAPF32[i27 + 168 >> 2]));
   f24 = Math_fround(HEAPF32[((HEAP32[i27 + 40 >> 2] | 0) == 3 ? i27 + 204 | 0 : i27 + 48 | 0) >> 2]);
   f24 = Math_fround(Math_fround(25.0) / Math_fround(f24 * f24));
   HEAP32[i9 + (i1 << 2) >> 2] = HEAP32[i27 + 264 >> 2];
   HEAP32[i10 + (i1 << 2) >> 2] = i26;
   HEAP32[i11 + (i1 << 2) >> 2] = i25;
   HEAPF32[i12 + (i1 << 2) >> 2] = f24;
   HEAPF32[i13 + (i1 << 4) >> 2] = f23;
   HEAPF32[i13 + (i1 << 4) + 4 >> 2] = f22;
   HEAPF32[i13 + (i1 << 4) + 8 >> 2] = f21;
   HEAPF32[i13 + (i1 << 4) + 12 >> 2] = f20;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i8 | 0));
  if ((i8 | 0) < 4) i2 = 4; else i2 = 8;
 } else i2 = 4;
 if ((i2 | 0) == 4) {
  i27 = i8 << 2;
  i1 = 16 - i27 | 0;
  _memset(i9 + i27 | 0, 0, i1 | 0) | 0;
  _memset(i10 + i27 | 0, 0, i1 | 0) | 0;
  _memset(i11 + i27 | 0, 0, i1 | 0) | 0;
  _memset(i13 + (i8 << 4) | 0, 0, 64 - (i8 << 4) | 0) | 0;
  i1 = i8;
  do {
   HEAPF32[i12 + (i1 << 2) >> 2] = Math_fround(1.0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4);
  if (!i8) {
   i27 = i18 + 4 | 0;
   HEAP32[i27 >> 2] = HEAP32[i27 >> 2] & -524289;
  } else i2 = 8;
 }
 if ((i2 | 0) == 8) {
  i26 = i14 + 1204 | 0;
  HEAP32[i26 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i26 = i14 + 1220 | 0;
  HEAP32[i26 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  i26 = i14 + 1236 | 0;
  HEAP32[i26 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i26 = i14 + 1252 | 0;
  HEAP32[i26 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  i26 = i13 + 16 | 0;
  i27 = i14 + 20 | 0;
  HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  i27 = i13 + 32 | 0;
  i26 = i14 + 36 | 0;
  HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  HEAP32[i26 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
  i26 = i13 + 48 | 0;
  i27 = i14 + 52 | 0;
  HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  HEAP32[i27 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
  i27 = i18 + 4 | 0;
  HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 524288;
 }
 i4 = i15 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i27 = i14 + 548 | 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  HEAP32[i27 + 16 >> 2] = 0;
  HEAP32[i27 + 20 >> 2] = 0;
  HEAP32[i27 + 24 >> 2] = 0;
  HEAP32[i27 + 28 >> 2] = 0;
  STACKTOP = i19;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i5 + 248 >> 2]);
 f23 = Math_fround(HEAPF32[i5 + 252 >> 2]);
 f23 = Math_fround(-f23);
 f24 = Math_fround(-Math_fround(HEAPF32[i5 + 256 >> 2]));
 HEAPF32[i14 + 548 >> 2] = Math_fround(-f22);
 HEAPF32[i14 + 552 >> 2] = f23;
 HEAPF32[i14 + 556 >> 2] = f24;
 HEAPF32[i14 + 560 >> 2] = Math_fround(0.0);
 __Z20CalculateLightMatrixRK15SharedLightDataP10Matrix4x4f(i5, i14 + 2724 | 0);
 i1 = i18 + 4 | 0;
 i2 = HEAP32[i1 >> 2] & -32;
 HEAP32[i1 >> 2] = i2;
 i3 = i5 + 40 | 0;
 L19 : do switch (HEAP32[i3 >> 2] | 0) {
 case 0:
  {
   HEAP32[i1 >> 2] = i2 | 1;
   break;
  }
 case 2:
  if (!(HEAP8[i5 + 84 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2 | 8;
   break L19;
  } else {
   HEAP32[i1 >> 2] = i2 | 16;
   break L19;
  }
 case 1:
  if (!(HEAP8[i5 + 84 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2 | 2;
   break L19;
  } else {
   HEAP32[i1 >> 2] = i2 | 4;
   break L19;
  }
 default:
  {}
 } while (0);
 f24 = Math_fround(HEAPF32[i15 + 128 >> 2]);
 i1 = (HEAP32[i4 >> 2] | 0) + 84 | 0;
 i27 = __Z12GetGfxDevicev() | 0;
 f21 = Math_fround(f24 * Math_fround(HEAPF32[i5 + 156 >> 2]));
 f22 = Math_fround(f24 * Math_fround(HEAPF32[i5 + 160 >> 2]));
 f23 = Math_fround(f24 * Math_fround(HEAPF32[i5 + 164 >> 2]));
 f24 = Math_fround(f24 * Math_fround(HEAPF32[i5 + 168 >> 2]));
 HEAPF32[i27 + 564 >> 2] = f21;
 HEAPF32[i27 + 568 >> 2] = f22;
 HEAPF32[i27 + 572 >> 2] = f23;
 HEAPF32[i27 + 576 >> 2] = f24;
 switch (HEAP32[i3 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP8[i5 + 84 >> 0] | 0 ? i1 : i16;
   break;
  }
 case 2:
  {
   i1 = HEAP8[i5 + 84 >> 0] | 0 ? i1 : i17;
   break;
  }
 case 1:
  {
   if (!(HEAP8[i5 + 84 >> 0] | 0)) {
    STACKTOP = i19;
    return;
   }
   break;
  }
 default:
  {
   STACKTOP = i19;
   return;
  }
 }
 __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef(i18 + 36 | 0, gb + 1111220 | 0, i1);
 STACKTOP = i19;
 return;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 200 | 0;
 i13 = i21 + 199 | 0;
 i14 = i21 + 198 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 197 | 0;
 i11 = i21 + 196 | 0;
 __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i8 = i25 + 4 | 0;
  i9 = i25 + 8 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i5 = HEAP32[i23 >> 2] | 0;
   do if (!i5) i27 = 19; else {
    if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i2) break; else {
     i27 = 38;
     break L11;
    }
    __THREW__ = 0;
    i6 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break L11;
    }
    if ((i6 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 19;
     break;
    } else if (i2) break; else {
     i27 = 38;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 19) {
    i27 = 0;
    if (i2) {
     i5 = 0;
     i27 = 38;
     break;
    } else i5 = 0;
   }
   i6 = HEAP8[i10 >> 0] | 0;
   i6 = i6 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i6 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i4 + i6 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i6 << 1 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i2 = (HEAP32[i9 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i2 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i4 + i6;
   }
   i6 = i1 + 12 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i15, i11, i4, i16, HEAP8[i13 >> 0] | 0, HEAP8[i14 >> 0] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 38;
    break;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i6 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i27 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 38) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i2 = HEAP32[i19 >> 2] | 0;
    if ((i2 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   f3 = Math_fround(+invoke_fiii(fb + 26 | 0, i4 | 0, HEAP32[i16 >> 2] | 0, i24 | 0));
   i28 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i28 & 1)) {
    HEAPF32[i20 >> 2] = f3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i5) i27 = 53; else {
     if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i23 >> 2] = 0;
       i27 = 53;
       break;
      }
     }
     if (!i2) i27 = 54;
    } while (0);
    if ((i27 | 0) == 53) if (i2) i27 = 54;
    if ((i27 | 0) == 54) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 112 | 0;
 i8 = i1 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i1 = i6 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 92 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 100 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 104 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 32 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 36 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 44 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 48 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
  i2 = i4;
 }
 i1 = i6 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i2;
 }
 i1 = i6 + 68 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 72 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i3 = i6 + 80 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i2 = i1;
 }
 i1 = f5 < Math_fround(0.0);
 i11 = f5 > Math_fround(1.0);
 f5 = i11 ? Math_fround(1.0) : f5;
 HEAPF32[i3 >> 2] = i1 ? Math_fround(0.0) : f5;
 i1 = i6 + 113 | 0;
 if ((i2 + 1 | 0) >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i3;
 }
 i2 = i6 + 108 | 0;
 HEAP8[i7 >> 0] = (HEAP32[i2 >> 2] | 0) != 0 & 1;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i11 = HEAP8[i3 >> 0] | 0;
  HEAP8[i7 >> 0] = i11;
  HEAP32[i8 >> 2] = i1;
  i1 = i11;
 }
 if (!(i1 << 24 >> 24)) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i2 >> 2] = 1;
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_114D6JointProjectEPKvRN5physx11PxTransformES4_b(i23, i19, i20, i24) {
 i23 = i23 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 132 | 0;
 i22 = i26 + 104 | 0;
 i5 = i26 + 76 | 0;
 i25 = i26 + 48 | 0;
 i18 = i26 + 160 | 0;
 i1 = i26 + 32 | 0;
 i2 = i26 + 16 | 0;
 i3 = i26;
 __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i23, i19, i20, i21, i22, i5);
 i4 = HEAP32[i23 + 324 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f16 = i4 & 1 | 0 ? f15 : Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f12 = i4 & 2 | 0 ? f11 : Math_fround(0.0);
 f13 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f14 = i4 & 4 | 0 ? f13 : Math_fround(0.0);
 HEAP8[i18 >> 0] = 0;
 f7 = Math_fround(HEAPF32[i23 + 376 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f12 * f12)) + Math_fround(f14 * f14));
 i17 = f6 > Math_fround(f7 * f7);
 if (i17) {
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
  f8 = Math_fround(f7 * Math_fround(f16 * f6));
  f10 = Math_fround(f7 * Math_fround(f12 * f6));
  f6 = Math_fround(f7 * Math_fround(f14 * f6));
 } else {
  f8 = f16;
  f10 = f12;
  f6 = f14;
 }
 f11 = Math_fround(f10 + Math_fround(f11 - f12));
 f12 = Math_fround(f6 + Math_fround(f13 - f14));
 HEAPF32[i25 + 16 >> 2] = Math_fround(f8 + Math_fround(f15 - f16));
 HEAPF32[i25 + 20 >> 2] = f11;
 HEAPF32[i25 + 24 >> 2] = f12;
 f12 = Math_fround(Math_fround(HEAPF32[i23 + 380 >> 2]) * Math_fround(.5));
 f13 = Math_fround(+Math_cos(+f12));
 f12 = Math_fround(+Math_sin(+f12));
 switch (i4 >>> 3 | 0) {
 case 0:
  {
   HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   break;
  }
 case 1:
  {
   HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   break;
  }
 case 2:
  {
   HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   break;
  }
 case 3:
  {
   __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb(i1, i5, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), f12, f13, i18);
   HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  }
 case 4:
  {
   HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   break;
  }
 case 5:
  {
   __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb(i2, i5, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), f12, f13, i18);
   HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   break;
  }
 case 6:
  {
   __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb(i3, i5, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), f12, f13, i18);
   HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i25 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i25 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i25 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   break;
  }
 case 7:
  {
   HEAP8[i18 >> 0] = 0;
   do if (f12 > Math_fround(.999899983)) {
    i4 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    i2 = HEAP32[i5 + 8 >> 2] | 0;
    i1 = HEAP32[i5 + 12 >> 2] | 0;
   } else {
    f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    if (!(f11 >= Math_fround(0.0))) {
     f14 = Math_fround(HEAPF32[i5 >> 2]);
     f7 = Math_fround(-f14);
     f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
     f8 = Math_fround(-f15);
     f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
     f10 = Math_fround(-f16);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     i9 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    } else {
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i5 + 4 >> 2] | 0;
     i2 = HEAP32[i5 + 8 >> 2] | 0;
     i1 = i4;
     i5 = i3;
     i9 = i2;
    }
    f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = Math_fround(f10 * f10);
    f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = Math_fround(Math_fround(f8 * f8) + f7);
    f6 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = Math_fround(Math_fround(f6 * f6) + f7);
    i9 = f7 > Math_fround(f12 * f12);
    HEAP8[i18 >> 0] = i9 & 1;
    if (i9) {
     f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
     f14 = Math_fround(Math_fround(f12 * f10) * f16);
     f15 = Math_fround(Math_fround(f12 * f8) * f16);
     f16 = Math_fround(Math_fround(f12 * f6) * f16);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
     i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
     break;
    } else {
     i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
     break;
    }
   } while (0);
   HEAP32[i25 >> 2] = i4;
   HEAP32[i25 + 4 >> 2] = i3;
   HEAP32[i25 + 8 >> 2] = i2;
   HEAP32[i25 + 12 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 if ((HEAP8[i18 >> 0] | 0) == 0 & (i17 ^ 1)) {
  STACKTOP = i26;
  return;
 }
 __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i19, i20, i21, i22, i25, i23, i24);
 STACKTOP = i26;
 return;
}

function __ZN12LightsModule8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i5, i8);
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619503 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619509 | 0, gb + 619515 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI5LightE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 12 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619527 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 945665 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 21 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 620185 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 22 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619546 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619556 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 288 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619567 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i5 + 552 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619582 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i10 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i10 >>> 0) i7 = 71; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 71; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 71) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 200 | 0;
 i13 = i21 + 199 | 0;
 i14 = i21 + 198 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 197 | 0;
 i11 = i21 + 196 | 0;
 __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i8 = i25 + 4 | 0;
  i9 = i25 + 8 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i5 = HEAP32[i23 >> 2] | 0;
   do if (!i5) i27 = 19; else {
    if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i2) break; else {
     i27 = 38;
     break L11;
    }
    __THREW__ = 0;
    i6 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break L11;
    }
    if ((i6 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 19;
     break;
    } else if (i2) break; else {
     i27 = 38;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 19) {
    i27 = 0;
    if (i2) {
     i5 = 0;
     i27 = 38;
     break;
    } else i5 = 0;
   }
   i6 = HEAP8[i10 >> 0] | 0;
   i6 = i6 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i6 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i4 + i6 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i6 << 1 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i2 = (HEAP32[i9 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i2 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i4 + i6;
   }
   i6 = i1 + 12 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i15, i11, i4, i16, HEAP8[i13 >> 0] | 0, HEAP8[i14 >> 0] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 38;
    break;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i6 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i27 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 38) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i2 = HEAP32[i19 >> 2] | 0;
    if ((i2 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   d3 = +invoke_diii(fb + 3 | 0, i4 | 0, HEAP32[i16 >> 2] | 0, i24 | 0);
   i28 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i28 & 1)) {
    HEAPF64[i20 >> 3] = d3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i5) i27 = 53; else {
     if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i23 >> 2] = 0;
       i27 = 53;
       break;
      }
     }
     if (!i2) i27 = 54;
    } while (0);
    if ((i27 | 0) == 53) if (i2) i27 = 54;
    if ((i27 | 0) == 54) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i22, i23, i2, i24, i20) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 200 | 0;
 i13 = i21 + 199 | 0;
 i14 = i21 + 198 | 0;
 i26 = i21 + 184 | 0;
 i25 = i21 + 172 | 0;
 i16 = i21 + 168 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21 + 4 | 0;
 i17 = i21;
 i15 = i21 + 197 | 0;
 i11 = i21 + 196 | 0;
 __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i26, i2, i12, i13, i14);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i25 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i25 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) i1 = (HEAP32[i25 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i25 | 0, i1 | 0, 0);
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i17 >> 2] = 0;
  HEAP8[i15 >> 0] = 1;
  HEAP8[i11 >> 0] = 69;
  i8 = i25 + 4 | 0;
  i9 = i25 + 8 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i22 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i5 = HEAP32[i23 >> 2] | 0;
   do if (!i5) i27 = 19; else {
    if ((HEAP32[i5 + 12 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) if (i2) break; else {
     i27 = 38;
     break L11;
    }
    __THREW__ = 0;
    i6 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 28;
     break L11;
    }
    if ((i6 | 0) == -1) {
     HEAP32[i23 >> 2] = 0;
     i27 = 19;
     break;
    } else if (i2) break; else {
     i27 = 38;
     break L11;
    }
   } while (0);
   if ((i27 | 0) == 19) {
    i27 = 0;
    if (i2) {
     i5 = 0;
     i27 = 38;
     break;
    } else i5 = 0;
   }
   i6 = HEAP8[i10 >> 0] | 0;
   i6 = i6 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i6 & 255;
   if ((HEAP32[i16 >> 2] | 0) == (i4 + i6 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i6 << 1 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    if ((HEAP8[i10 >> 0] | 0) < 0) i2 = (HEAP32[i9 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i25 | 0, i2 | 0, 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i27 = 30;
     break;
    }
    i4 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25;
    HEAP32[i16 >> 2] = i4 + i6;
   }
   i6 = i1 + 12 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i2 & 255, i15, i11, i4, i16, HEAP8[i13 >> 0] | 0, HEAP8[i14 >> 0] | 0, i26, i18, i19, i17, i12) | 0) {
    i27 = 38;
    break;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i28 = __THREW__;
    __THREW__ = 0;
    if (i28 & 1) {
     i27 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i6 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i27 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i27 | 0) == 38) {
   i28 = HEAP8[i26 + 11 >> 0] | 0;
   if (!((HEAP8[i15 >> 0] | 0) == 0 ? 1 : ((i28 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i28 & 255) | 0) == 0)) {
    i2 = HEAP32[i19 >> 2] | 0;
    if ((i2 - i18 | 0) < 160) {
     i28 = HEAP32[i17 >> 2] | 0;
     HEAP32[i19 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i28;
    }
   }
   __THREW__ = 0;
   d3 = +invoke_diii(fb + 4 | 0, i4 | 0, HEAP32[i16 >> 2] | 0, i24 | 0);
   i28 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i28 & 1)) {
    HEAPF64[i20 >> 3] = d3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i26, i18, HEAP32[i19 >> 2] | 0, i24);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i28 = __THREW__;
     __THREW__ = 0;
     if (i28 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i22 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i5) i27 = 53; else {
     if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i5 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
      i28 = __THREW__;
      __THREW__ = 0;
      if (i28 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i23 >> 2] = 0;
       i27 = 53;
       break;
      }
     }
     if (!i2) i27 = 54;
    } while (0);
    if ((i27 | 0) == 53) if (i2) i27 = 54;
    if ((i27 | 0) == 54) HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 2;
    i28 = HEAP32[i22 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
    STACKTOP = i21;
    return i28 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5physx3Ext10FixedJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i2 + 384 | 0;
 i14 = i2 + 352 | 0;
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i15 >> 2] = HEAP32[gb + 118576 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 118576 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 118576 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[gb + 118576 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[gb + 118576 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 118576 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[gb + 118576 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[gb + 118576 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i15 | 0, 32) | 0;
 HEAP32[i14 >> 2] = gb + 744748;
 HEAP32[i14 + 4 >> 2] = gb + 743927;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 80;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 1;
 HEAP32[i14 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i14 | 0, 32) | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 118608 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 118608 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 118608 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 118608 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 118608 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 118608 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 118608 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 118608 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 118640 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 118640 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 118640 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 118640 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 118640 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 118640 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 118640 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 118640 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 118672 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 118672 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 118672 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 118672 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 118672 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 118672 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 118672 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 118672 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 744763;
 HEAP32[i10 + 4 >> 2] = gb + 743901;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 84;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 744763;
 HEAP32[i9 + 4 >> 2] = gb + 829211;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 84;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 116592 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 116592 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 116592 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 116592 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 116592 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 116592 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 116592 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 116592 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 116624 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 116624 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 116624 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 116624 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 116624 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 116624 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 116624 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 116624 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 116656 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 116656 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 116656 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 116656 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 116656 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 116656 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 116656 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 116656 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 116688 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116688 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116688 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116688 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116688 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116688 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116688 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116688 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 118704 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 118704 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 118704 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 118704 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 118704 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 118704 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 118704 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 118704 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function runPostSets241() {
 HEAP32[gb + 215052 >> 2] = (HEAP32[gb + 215052 >> 2] | 0) + (gb + 1084278 | 0);
 HEAP32[gb + 215060 >> 2] = (HEAP32[gb + 215060 >> 2] | 0) + (gb + 1085944 | 0);
 HEAP32[gb + 215068 >> 2] = (HEAP32[gb + 215068 >> 2] | 0) + (gb + 1084284 | 0);
 HEAP32[gb + 215076 >> 2] = (HEAP32[gb + 215076 >> 2] | 0) + (gb + 1084288 | 0);
 HEAP32[gb + 215084 >> 2] = (HEAP32[gb + 215084 >> 2] | 0) + (gb + 1084294 | 0);
 HEAP32[gb + 215092 >> 2] = (HEAP32[gb + 215092 >> 2] | 0) + (gb + 1084300 | 0);
 HEAP32[gb + 215100 >> 2] = (HEAP32[gb + 215100 >> 2] | 0) + (gb + 1087504 | 0);
 HEAP32[gb + 215108 >> 2] = (HEAP32[gb + 215108 >> 2] | 0) + (gb + 1084304 | 0);
 HEAP32[gb + 215116 >> 2] = (HEAP32[gb + 215116 >> 2] | 0) + (gb + 1085869 | 0);
 HEAP32[gb + 215124 >> 2] = (HEAP32[gb + 215124 >> 2] | 0) + (gb + 1084315 | 0);
 HEAP32[gb + 215132 >> 2] = (HEAP32[gb + 215132 >> 2] | 0) + (gb + 1084329 | 0);
 HEAP32[gb + 215140 >> 2] = (HEAP32[gb + 215140 >> 2] | 0) + (gb + 1085899 | 0);
 HEAP32[gb + 215148 >> 2] = (HEAP32[gb + 215148 >> 2] | 0) + (gb + 1085989 | 0);
 HEAP32[gb + 215156 >> 2] = (HEAP32[gb + 215156 >> 2] | 0) + (gb + 1085998 | 0);
 HEAP32[gb + 215164 >> 2] = (HEAP32[gb + 215164 >> 2] | 0) + (gb + 1084342 | 0);
 HEAP32[gb + 215172 >> 2] = (HEAP32[gb + 215172 >> 2] | 0) + (gb + 1084344 | 0);
 HEAP32[gb + 215180 >> 2] = (HEAP32[gb + 215180 >> 2] | 0) + (gb + 1084349 | 0);
 HEAP32[gb + 215188 >> 2] = (HEAP32[gb + 215188 >> 2] | 0) + (gb + 1084355 | 0);
 HEAP32[gb + 215196 >> 2] = (HEAP32[gb + 215196 >> 2] | 0) + (gb + 1084361 | 0);
 HEAP32[gb + 215204 >> 2] = (HEAP32[gb + 215204 >> 2] | 0) + (gb + 1084367 | 0);
 HEAP32[gb + 215212 >> 2] = (HEAP32[gb + 215212 >> 2] | 0) + (gb + 1086046 | 0);
 HEAP32[gb + 215220 >> 2] = (HEAP32[gb + 215220 >> 2] | 0) + (gb + 1084373 | 0);
 HEAP32[gb + 215228 >> 2] = (HEAP32[gb + 215228 >> 2] | 0) + (gb + 1084379 | 0);
 HEAP32[gb + 215236 >> 2] = (HEAP32[gb + 215236 >> 2] | 0) + (gb + 1084385 | 0);
 HEAP32[gb + 215244 >> 2] = (HEAP32[gb + 215244 >> 2] | 0) + (gb + 1084391 | 0);
 HEAP32[gb + 215252 >> 2] = (HEAP32[gb + 215252 >> 2] | 0) + (gb + 1084397 | 0);
 HEAP32[gb + 215260 >> 2] = (HEAP32[gb + 215260 >> 2] | 0) + (gb + 1085935 | 0);
 HEAP32[gb + 215268 >> 2] = (HEAP32[gb + 215268 >> 2] | 0) + (gb + 1084278 | 0);
 HEAP32[gb + 215276 >> 2] = (HEAP32[gb + 215276 >> 2] | 0) + (gb + 1084403 | 0);
 HEAP32[gb + 215284 >> 2] = (HEAP32[gb + 215284 >> 2] | 0) + (gb + 1085899 | 0);
 HEAP32[gb + 215292 >> 2] = (HEAP32[gb + 215292 >> 2] | 0) + (gb + 1084409 | 0);
 HEAP32[gb + 215436 >> 2] = (HEAP32[gb + 215436 >> 2] | 0) + (gb + 12848 | 0);
 HEAP32[gb + 215440 >> 2] = fb + 3188;
 HEAP32[gb + 215444 >> 2] = fb + 3189;
 HEAP32[gb + 215448 >> 2] = fb + 706;
 HEAP32[gb + 215452 >> 2] = fb + 96;
 HEAP32[gb + 215456 >> 2] = fb + 147;
 HEAP32[gb + 215460 >> 2] = fb + 182;
 HEAP32[gb + 215464 >> 2] = fb + 400;
 HEAP32[gb + 215468 >> 2] = fb + 401;
 HEAP32[gb + 215472 >> 2] = fb + 97;
 HEAP32[gb + 215476 >> 2] = fb + 1544;
 HEAP32[gb + 215480 >> 2] = fb + 403;
 HEAP32[gb + 215484 >> 2] = fb + 496;
 HEAP32[gb + 215488 >> 2] = fb + 98;
 HEAP32[gb + 215492 >> 2] = fb + 497;
 HEAP32[gb + 12848 >> 2] = (HEAP32[gb + 12848 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12852 >> 2] = (HEAP32[gb + 12852 >> 2] | 0) + (gb + 1084523 | 0);
 HEAP32[gb + 12856 >> 2] = (HEAP32[gb + 12856 >> 2] | 0) + (gb + 10760 | 0);
 HEAP32[gb + 215504 >> 2] = (HEAP32[gb + 215504 >> 2] | 0) + (gb + 12864 | 0);
 HEAP32[gb + 215508 >> 2] = fb + 3190;
 HEAP32[gb + 215512 >> 2] = fb + 3191;
 HEAP32[gb + 215524 >> 2] = (HEAP32[gb + 215524 >> 2] | 0) + (gb + 12864 | 0);
 HEAP32[gb + 215528 >> 2] = fb + 3192;
 HEAP32[gb + 215532 >> 2] = fb + 3193;
 HEAP32[gb + 12864 >> 2] = (HEAP32[gb + 12864 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12868 >> 2] = (HEAP32[gb + 12868 >> 2] | 0) + (gb + 1084546 | 0);
 HEAP32[gb + 12872 >> 2] = (HEAP32[gb + 12872 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 215536 >> 2] = (HEAP32[gb + 215536 >> 2] | 0) + (gb + 215496 | 0);
 HEAP32[gb + 215540 >> 2] = (HEAP32[gb + 215540 >> 2] | 0) + (gb + 215552 | 0);
 HEAP32[gb + 215544 >> 2] = (HEAP32[gb + 215544 >> 2] | 0) + (gb + 215552 | 0);
 HEAP32[gb + 215548 >> 2] = (HEAP32[gb + 215548 >> 2] | 0) + (gb + 215496 | 0);
 HEAP32[gb + 215560 >> 2] = (HEAP32[gb + 215560 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 215564 >> 2] = fb + 3041;
 HEAP32[gb + 215568 >> 2] = fb + 3042;
 HEAP32[gb + 215580 >> 2] = (HEAP32[gb + 215580 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 215584 >> 2] = fb + 3043;
 HEAP32[gb + 215588 >> 2] = fb + 3044;
 HEAP32[gb + 215600 >> 2] = (HEAP32[gb + 215600 >> 2] | 0) + (gb + 12880 | 0);
 HEAP32[gb + 215604 >> 2] = fb + 3194;
 HEAP32[gb + 215608 >> 2] = fb + 3195;
 HEAP32[gb + 215620 >> 2] = (HEAP32[gb + 215620 >> 2] | 0) + (gb + 12880 | 0);
 HEAP32[gb + 215624 >> 2] = fb + 3196;
 HEAP32[gb + 215628 >> 2] = fb + 3197;
 HEAP32[gb + 12880 >> 2] = (HEAP32[gb + 12880 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12884 >> 2] = (HEAP32[gb + 12884 >> 2] | 0) + (gb + 1084567 | 0);
 HEAP32[gb + 12888 >> 2] = (HEAP32[gb + 12888 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 215632 >> 2] = (HEAP32[gb + 215632 >> 2] | 0) + (gb + 215592 | 0);
 HEAP32[gb + 215636 >> 2] = (HEAP32[gb + 215636 >> 2] | 0) + (gb + 215648 | 0);
 HEAP32[gb + 215640 >> 2] = (HEAP32[gb + 215640 >> 2] | 0) + (gb + 215648 | 0);
 HEAP32[gb + 215644 >> 2] = (HEAP32[gb + 215644 >> 2] | 0) + (gb + 215592 | 0);
 HEAP32[gb + 215656 >> 2] = (HEAP32[gb + 215656 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 215660 >> 2] = fb + 879;
 HEAP32[gb + 215664 >> 2] = fb + 880;
 HEAP32[gb + 215676 >> 2] = (HEAP32[gb + 215676 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 215680 >> 2] = fb + 881;
 HEAP32[gb + 215684 >> 2] = fb + 882;
 HEAP32[gb + 215696 >> 2] = (HEAP32[gb + 215696 >> 2] | 0) + (gb + 12896 | 0);
 HEAP32[gb + 215700 >> 2] = fb + 3198;
 HEAP32[gb + 215704 >> 2] = fb + 3199;
 HEAP32[gb + 215716 >> 2] = (HEAP32[gb + 215716 >> 2] | 0) + (gb + 12896 | 0);
 HEAP32[gb + 215720 >> 2] = fb + 3200;
 HEAP32[gb + 215724 >> 2] = fb + 3201;
 HEAP32[gb + 215736 >> 2] = (HEAP32[gb + 215736 >> 2] | 0) + (gb + 12896 | 0);
 HEAP32[gb + 215740 >> 2] = fb + 3202;
 HEAP32[gb + 215744 >> 2] = fb + 3203;
 HEAP32[gb + 12896 >> 2] = (HEAP32[gb + 12896 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12900 >> 2] = (HEAP32[gb + 12900 >> 2] | 0) + (gb + 1084588 | 0);
 HEAP32[gb + 12904 >> 2] = (HEAP32[gb + 12904 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 215748 >> 2] = (HEAP32[gb + 215748 >> 2] | 0) + (gb + 215688 | 0);
 runPostSets242();
}

function __ZNSt3__227__insertion_sort_incompleteIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEbT0_S6_T_(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 switch (i15 - i14 >> 5 | 0) {
 case 2:
  {
   i3 = i15 + -32 | 0;
   i1 = HEAP32[i15 + -8 >> 2] | 0;
   i2 = HEAP32[i14 + 24 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = HEAP32[i15 + -24 >> 2] | 0;
    i2 = HEAP32[i14 + 8 >> 2] | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     if ((i1 | 0) > (i2 | 0)) {
      i15 = 1;
      STACKTOP = i16;
      return i15 | 0;
     }
     i13 = i15 + -16 | 0;
     i11 = HEAP32[i13 + 4 >> 2] | 0;
     i15 = i14 + 16 | 0;
     i12 = HEAP32[i15 + 4 >> 2] | 0;
     if (!((i11 | 0) < (i12 | 0) | ((i11 | 0) == (i12 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0 : 0))) {
      i15 = 1;
      STACKTOP = i16;
      return i15 | 0;
     }
    }
   } else if ((i1 | 0) >= (i2 | 0)) {
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   };
   HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i14 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i14, i14 + 32 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i14 + 96 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 1:
 case 0:
  {
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 default:
  {
   i2 = i14 + 64 | 0;
   __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i14, i14 + 32 | 0, i2, i1) | 0;
   i1 = i14 + 96 | 0;
   L3 : do if ((i1 | 0) == (i15 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i12 = i1;
    i1 = 0;
    while (1) {
     i11 = HEAP32[i12 + 24 >> 2] | 0;
     i3 = HEAP32[i2 + 24 >> 2] | 0;
     if ((i11 | 0) == (i3 | 0)) {
      i3 = HEAP32[i12 + 8 >> 2] | 0;
      i4 = HEAP32[i2 + 8 >> 2] | 0;
      if ((i3 | 0) < (i4 | 0)) i13 = 18; else if ((i3 | 0) <= (i4 | 0)) {
       i9 = i12 + 16 | 0;
       i7 = HEAP32[i9 + 4 >> 2] | 0;
       i10 = i2 + 16 | 0;
       i8 = HEAP32[i10 + 4 >> 2] | 0;
       if ((i7 | 0) < (i8 | 0) | ((i7 | 0) == (i8 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0)) i13 = 18;
      }
     } else if ((i11 | 0) < (i3 | 0)) {
      i3 = HEAP32[i12 + 8 >> 2] | 0;
      i13 = 18;
     }
     if ((i13 | 0) == 18) {
      i13 = 0;
      i8 = i12;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i6 = HEAP32[i12 + 12 >> 2] | 0;
      i10 = i12 + 16 | 0;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
      HEAP32[i12 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
      HEAP32[i12 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
      HEAP32[i12 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
      L14 : do if ((i2 | 0) == (i14 | 0)) i4 = i14; else {
       i5 = i2;
       while (1) {
        i2 = i5 + -32 | 0;
        i4 = HEAP32[i5 + -8 >> 2] | 0;
        if ((i11 | 0) == (i4 | 0)) {
         i4 = HEAP32[i5 + -24 >> 2] | 0;
         if ((i3 | 0) >= (i4 | 0)) {
          if ((i3 | 0) > (i4 | 0)) {
           i4 = i5;
           i2 = i5;
           break L14;
          }
          i4 = i5 + -16 | 0;
          i17 = HEAP32[i4 + 4 >> 2] | 0;
          if (!((i10 | 0) < (i17 | 0) | ((i10 | 0) == (i17 | 0) ? i9 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0 : 0))) {
           i4 = i5;
           i2 = i5;
           break L14;
          }
         }
        } else if ((i11 | 0) >= (i4 | 0)) {
         i4 = i5;
         i2 = i5;
         break L14;
        };
        HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
        HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
        HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
        HEAP32[i5 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
        if ((i2 | 0) == (i14 | 0)) {
         i4 = i14;
         break;
        } else i5 = i2;
       }
      } while (0);
      i17 = i4;
      HEAP32[i17 >> 2] = i7;
      HEAP32[i17 + 4 >> 2] = i8;
      HEAP32[i4 + 8 >> 2] = i3;
      HEAP32[i2 + 12 >> 2] = i6;
      i17 = i4 + 16 | 0;
      HEAP32[i17 >> 2] = i9;
      HEAP32[i17 + 4 >> 2] = i10;
      HEAP32[i4 + 24 >> 2] = i11;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i12 + 32 | 0) == (i15 | 0);
       break L3;
      }
     }
     i2 = i12 + 32 | 0;
     if ((i2 | 0) == (i15 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i17 = i12;
      i12 = i2;
      i2 = i17;
     }
    }
   } while (0);
   i17 = i1 | i2;
   STACKTOP = i16;
   return i17 | 0;
  }
 }
 return 0;
}

function __Z24ScheduleCullingAllGroupsR8JobFenceRK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK13dynamic_arrayIP12CullingGroupLj4EERKS_(i20, i1, i3, i2, i23, i25) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i28 + 16 | 0;
 i27 = i28;
 if ((HEAP16[gb + 1114356 + 6 >> 1] | 0) > -1) {
  HEAP32[i27 >> 2] = 0;
  HEAP32[i18 >> 2] = HEAP32[i27 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114356 | 0, i18);
  i19 = gb + 1114356 | 0;
 } else i19 = 0;
 i26 = i23 + 12 | 0;
 do if (HEAP32[i26 >> 2] | 0) {
  i21 = __ZnwjRK10MemLabelIdiPKci(248, gb + 64024 | 0, 16, gb + 385488 | 0, 224) | 0;
  i16 = gb + 64024 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i22 = i27;
  HEAP32[i22 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i22 + 4 >> 2] = i15;
  i22 = i21 + 16 | 0;
  HEAP32[i22 >> 2] = 0;
  i15 = i21 + 28 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i21 + 32 | 0;
  HEAP32[i16 >> 2] = 0;
  i17 = i21 + 20 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i27);
  i24 = i18;
  i11 = HEAP32[i24 + 4 >> 2] | 0;
  i12 = i17;
  HEAP32[i12 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  i12 = gb + 64024 | 0;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i24 = i27;
  HEAP32[i24 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i24 + 4 >> 2] = i11;
  i24 = i21 + 36 | 0;
  HEAP32[i24 >> 2] = 0;
  i11 = i21 + 48 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i21 + 52 | 0;
  HEAP32[i12 >> 2] = 0;
  i13 = i21 + 40 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i27);
  i9 = i18;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i14 = i13;
  HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i14 + 4 >> 2] = i10;
  HEAP32[i21 >> 2] = i1;
  i14 = i2 + 60 | 0;
  HEAP32[i21 + 8 >> 2] = i14;
  if (HEAP8[i14 >> 0] | 0) {
   i14 = __Z9GetIUmbrav() | 0;
   HEAP32[i21 + 4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0, HEAP32[i2 + 64 >> 2] | 0) | 0;
  }
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i26 >> 2] | 0) * 48 | 0, 16, gb + 64024 | 0, 0, gb + 385488 | 0, 230) | 0;
  i14 = i21 + 12 | 0;
  HEAP32[i14 >> 2] = i2;
  if (HEAP32[i26 >> 2] | 0) {
   i8 = HEAP32[i3 >> 2] | 0;
   i9 = i18 + 4 | 0;
   i10 = i18 + 8 | 0;
   i7 = 0;
   i1 = 0;
   while (1) {
    i6 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    HEAP32[i2 + (i1 * 48 | 0) >> 2] = HEAP32[i6 + 16 >> 2];
    i5 = i6 + 96 | 0;
    i3 = (HEAP32[i5 >> 2] | 0) == 0 ? 1 : 3;
    i4 = i2 + (i1 * 48 | 0) + 32 | 0;
    HEAP32[i4 >> 2] = i3;
    if ((HEAP32[i6 + 12 >> 2] | 0) != (i8 | 0)) {
     i3 = i3 & 2;
     HEAP32[i4 >> 2] = i3;
    }
    if (!(i3 & 2)) {
     i3 = 0;
     i4 = 0;
    } else {
     __ZNK12CullingGroup34GetEffectiveDistanceReferencePointEv(i18, i6);
     i3 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 + (i1 * 48 | 0) + 16 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i2 + (i1 * 48 | 0) + 20 >> 2] = i3;
     HEAP32[i2 + (i1 * 48 | 0) + 24 >> 2] = i4;
     i4 = HEAP32[i5 >> 2] | 0;
     HEAP32[i2 + (i1 * 48 | 0) + 28 >> 2] = HEAP32[i6 + 84 >> 2];
     i3 = HEAP8[i6 + 104 >> 0] ^ 1;
    }
    HEAP32[i2 + (i1 * 48 | 0) + 36 >> 2] = i4;
    HEAP8[i2 + (i1 * 48 | 0) + 40 >> 0] = i3;
    HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] = HEAP32[i6 + 28 >> 2];
    i2 = (HEAP32[i6 + 24 >> 2] | 0) + i7 | 0;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) break;
    i7 = i2;
    i2 = HEAP32[i14 >> 2] | 0;
   }
   if (i2 | 0) {
    i4 = __Z37CalculateJobCountWithMinIndicesPerJobii(i2, 256) | 0;
    i2 = ~~Math_fround(Math_ceil(Math_fround(Math_fround(i2 >>> 0) / Math_fround(i4 | 0)))) >>> 0;
    i3 = (HEAP32[i26 >> 2] | 0) + i4 | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
     HEAP32[i12 >> 2] = i3;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i3 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i13 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i12 >> 2] = i3;
     HEAP32[i24 >> 2] = i13;
     break;
    } while (0);
    i1 = HEAP32[i16 >> 2] | 0;
    do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
     HEAP32[i16 >> 2] = i3;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i3 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i17 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
     HEAP32[i16 >> 2] = i3;
     HEAP32[i22 >> 2] = i17;
     break;
    } while (0);
    HEAP32[i18 >> 2] = -1;
    HEAP32[i18 + 4 >> 2] = -1;
    HEAP32[i18 + 8 >> 2] = 0;
    HEAP32[i18 + 12 >> 2] = i21 + 56;
    HEAP32[i18 + 16 >> 2] = i2;
    if (HEAP32[i26 >> 2] | 0) {
     i1 = 0;
     do {
      i17 = (HEAP32[i14 >> 2] | 0) + (i1 * 48 | 0) + 4 | 0;
      __Z18AddGroupToWorkloadR26BlockRangeBalancedWorkloadjR13dynamic_arrayI10BlockRangeLj4EERS1_IjLj4EE(i27, i18, HEAP32[(HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] | 0, i24, i22);
      HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
      HEAP32[i17 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
      HEAP32[i17 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0);
    }
    __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i20, fb + 2389 | 0, i21, i4, i25, fb + 3342 | 0, 1);
    break;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, gb + 64024 | 0);
  if ((HEAP32[i12 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i13);
   HEAP32[i24 >> 2] = 0;
  }
  if ((HEAP32[i16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i17);
   HEAP32[i22 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i21, gb + 64024 | 0);
 } while (0);
 if (!i19) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i28;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i21, i25, i11) {
 i21 = i21 | 0;
 i25 = i25 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i31;
 i13 = i31 + 8 | 0;
 i28 = i21 + 172 | 0;
 i29 = i21 + 176 | 0;
 HEAP32[i29 >> 2] = 32;
 i14 = i21 + 188 | 0;
 HEAP32[i14 >> 2] = 16;
 i15 = i21 + 184 | 0;
 HEAP32[i15 >> 2] = 6;
 i16 = i21 + 192 | 0;
 HEAP8[i16 >> 0] = 0;
 i2 = i21 + 196 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 65;
 HEAP32[i12 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2560, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) {
  i27 = HEAP32[i2 >> 2] | 0;
  HEAP32[i12 >> 2] = 65;
  HEAP32[i12 + 4 >> 2] = i27;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 HEAP32[i28 >> 2] = i4;
 i1 = i4 + ((HEAP32[i29 >> 2] | 0) * 80 | 0) | 0;
 if ((i4 | 0) != (i1 | 0)) {
  i2 = i21 + 92 | 0;
  i7 = i21 + 100 | 0;
  i8 = i21 + 156 | 0;
  i9 = i21 + 160 | 0;
  i10 = i21 + 164 | 0;
  do {
   i19 = i2;
   i18 = HEAP32[i19 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = i18;
   i17 = i4 + 8 | 0;
   i18 = i7;
   i19 = i17 + 56 | 0;
   do {
    HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
    i17 = i17 + 4 | 0;
    i18 = i18 + 4 | 0;
   } while ((i17 | 0) < (i19 | 0));
   HEAP32[i4 + 64 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 68 >> 2] = HEAP32[i9 >> 2];
   i24 = i10;
   i26 = HEAP32[i24 + 4 >> 2] | 0;
   i27 = i4 + 72 | 0;
   HEAP32[i27 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i27 + 4 >> 2] = i26;
   i4 = i4 + 80 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i26 = i21 + 180 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 i27 = i25 + 4 | 0;
 f3 = Math_fround(((HEAP32[i25 + 180 >> 2] | 0) - (HEAP32[i27 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i11 >>> 0) {
   f5 = Math_fround(i2 >>> 0);
   f6 = Math_fround(f5 * Math_fround(.5));
   if (!(f3 >= f6)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i21, i2, i12);
  HEAP32[i29 >> 2] = i2;
  HEAP32[i14 >> 2] = ~~f6 >>> 0;
  HEAP32[i15 >> 2] = ~~Math_fround(f5 * Math_fround(.200000003)) >>> 0;
  HEAP8[i16 >> 0] = 0;
 } else i2 = i1;
 i22 = i25 + 172 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i23 = i25 + 176 | 0;
 i20 = HEAP32[i23 >> 2] | 0;
 i24 = i1 + (i20 * 80 | 0) | 0;
 L18 : do if (i20) {
  i9 = HEAP32[i25 + 92 >> 2] | 0;
  i10 = HEAP32[i25 + 96 >> 2] | 0;
  i7 = HEAP32[i25 + 12 >> 2] | 0;
  i8 = HEAP32[i25 + 16 >> 2] | 0;
  if (!((HEAP8[i25 + 8 >> 0] | 0) != 0 & (HEAP32[i27 >> 2] | 0) != 0)) {
   do {
    if ((i9 | 0) != (HEAP32[i1 >> 2] | 0)) break L18;
    if ((i10 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L18;
    i1 = i1 + 80 | 0;
   } while ((i1 | 0) != (i24 | 0));
   STACKTOP = i31;
   return;
  }
  do {
   i4 = HEAP32[i1 >> 2] | 0;
   if ((i9 | 0) == (i4 | 0)) {
    if ((i10 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i30 = 16;
   } else i30 = 16;
   if ((i30 | 0) == 16) {
    i30 = 0;
    if ((i7 | 0) != (i4 | 0)) break L18;
    if ((i8 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L18;
   }
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i24 | 0));
  STACKTOP = i31;
  return;
 } while (0);
 if ((i1 | 0) == (i24 | 0)) {
  STACKTOP = i31;
  return;
 }
 i20 = i21 + 92 | 0;
 i12 = i21 + 96 | 0;
 i13 = i25 + 92 | 0;
 i14 = i25 + 96 | 0;
 i15 = i25 + 12 | 0;
 i16 = i25 + 16 | 0;
 i11 = i25 + 8 | 0;
 while (1) {
  i7 = i2 + -1 | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i10 = HEAP32[i28 >> 2] | 0;
  i8 = HEAP32[i20 >> 2] | 0;
  i9 = HEAP32[i12 >> 2] | 0;
  i4 = 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  while (1) {
   i2 = i2 & i7;
   if ((i8 | 0) == (HEAP32[i10 + (i2 * 80 | 0) >> 2] | 0)) if ((i9 | 0) == (HEAP32[i10 + (i2 * 80 | 0) + 4 >> 2] | 0)) break;
   i25 = i4 + 1 | 0;
   i4 = i25;
   i2 = i25 + i2 | 0;
  }
  i19 = i1;
  i18 = HEAP32[i19 + 4 >> 2] | 0;
  i17 = i10 + (i2 * 80 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  i17 = i10 + (i2 * 80 | 0) + 8 | 0;
  i18 = i1 + 8 | 0;
  i19 = i17 + 56 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i10 + (i2 * 80 | 0) + 64 >> 2] = HEAP32[i1 + 64 >> 2];
  HEAP32[i10 + (i2 * 80 | 0) + 68 >> 2] = HEAP32[i1 + 68 >> 2];
  i19 = i1 + 72 | 0;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i25 = i10 + (i2 * 80 | 0) + 72 | 0;
  HEAP32[i25 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i25 + 4 >> 2] = i21;
  HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
  i1 = i1 + 80 | 0;
  L47 : do if ((i1 | 0) == (i24 | 0)) i1 = i24; else {
   i8 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[i15 >> 2] | 0;
   i7 = HEAP32[i16 >> 2] | 0;
   if (!((HEAP8[i11 >> 0] | 0) != 0 & (HEAP32[i27 >> 2] | 0) != 0)) while (1) {
    if ((i8 | 0) != (HEAP32[i1 >> 2] | 0)) break L47;
    if ((i9 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L47;
    i1 = i1 + 80 | 0;
    if ((i1 | 0) == (i24 | 0)) {
     i1 = i24;
     break L47;
    }
   }
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     if ((i9 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i30 = 35;
    } else i30 = 35;
    if ((i30 | 0) == 35) {
     i30 = 0;
     if ((i4 | 0) != (i2 | 0)) break L47;
     if ((i7 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L47;
    }
    i1 = i1 + 80 | 0;
    if ((i1 | 0) == (i24 | 0)) {
     i1 = i24;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i22 >> 2] | 0) + ((HEAP32[i23 >> 2] | 0) * 80 | 0) | 0)) break;
  i2 = HEAP32[i29 >> 2] | 0;
 }
 STACKTOP = i31;
 return;
}

function __ZN20TextRenderingPrivate7GUIText8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946475 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 36 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i10, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37240 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946522 | 0, i9, i1 + 54 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034753 | 0, i9, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946411 | 0, HEAP32[gb + 37320 >> 2] | 0, i9, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i8, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i8, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946508 | 0, i8, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946531 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 88 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034701 | 0, gb + 1034708 | 0, i8, 0);
 i9 = i10 + 8 | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946425 | 0, gb + 946436 | 0, i9, 0);
 i7 = i10 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034730 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034741 | 0, i6, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 84 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946451 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034776 | 0, i6, i1 + 65 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN19CharacterController8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i8, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i4 = i8 + 88 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932223 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843745 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i7 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i8 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734421 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i7 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 28; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734434 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734447 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 734459 | 0, i6, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i7 = 61; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 61; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 61) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034411 | 0, HEAP32[gb + 37324 >> 2] | 0, i10, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAPF32[i10 >> 2] = Math_fround(45.0);
 i9 = Math_fround(HEAPF32[i5 >> 2]) < Math_fround(45.0);
 HEAP32[i5 >> 2] = HEAP32[(i9 ? i5 : i10) >> 2];
 STACKTOP = i11;
 return;
}

function __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns(i1, i2, i22) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 16 | 0;
 i21 = i24;
 i20 = i24 + 176 | 0;
 i7 = i24 + 144 | 0;
 i23 = i24 + 32 | 0;
 if (Math_fround(HEAPF32[i2 + 4 >> 2]) <= Math_fround(0.0)) {
  STACKTOP = i24;
  return;
 }
 if (Math_fround(HEAPF32[i2 + 8 >> 2]) <= Math_fround(0.0)) {
  STACKTOP = i24;
  return;
 }
 i16 = HEAP32[i2 >> 2] | 0;
 i3 = i16 + 60 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i4 = i16 + 80 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i17 = __Z12GetGfxDevicev() | 0;
 HEAP32[i20 >> 2] = 0;
 i6 = i20 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = -1;
 HEAP32[i20 + 12 >> 2] = 0;
 i18 = __ZN9GfxDevice13GetDynamicVBOEv(i17) | 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, HEAP32[gb + 1159904 >> 2] | 0, i11 | 0, i12 | 0, 0, i20 | 0) | 0) {
  HEAP32[i7 >> 2] = i16;
  i8 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  i13 = i7 + 20 | 0;
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 16 >> 2] = Math_fround(1.0);
  i14 = i7 + 24 | 0;
  HEAP32[i14 >> 2] = HEAP32[i2 + 12 >> 2];
  i15 = i7 + 28 | 0;
  HEAP32[i15 >> 2] = HEAP32[i2 + 16 >> 2];
  i1 = HEAP32[i20 >> 2] | 0;
  i10 = HEAP32[i16 + 48 >> 2] | 0;
  i9 = HEAP32[i3 >> 2] | 0;
  i5 = (HEAP32[i4 >> 2] | 0) >>> 1;
  if (i5 | 0) {
   i3 = 0;
   i4 = HEAP32[i16 + 68 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i5 | 0)) break; else {
     i4 = i4 + 4 | 0;
     i2 = i2 + 4 | 0;
    }
   }
  }
  if (i9 | 0) {
   i5 = i7 + 8 | 0;
   i6 = i7 + 12 | 0;
   i4 = i7 + 16 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = 0;
   while (1) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + (i2 << 3) >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i10 + (i2 << 3) + 4 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i1 + 32 >> 2] = HEAP32[i15 >> 2];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i9 | 0)) break; else i1 = i1 + 36 | 0;
   }
  }
  mftCall_viiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i20 | 0, i11 | 0, i12 | 0);
  HEAP32[i23 + 4 >> 2] = 1;
  HEAP32[i23 >> 2] = gb + 33952 + 8;
  i3 = gb + 64016 | 0;
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i21;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i23 + 32 >> 2] = 0;
  HEAP32[i23 + 44 >> 2] = 0;
  i5 = i23 + 48 | 0;
  HEAP32[i5 >> 2] = 0;
  i6 = i23 + 36 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i21);
  i3 = i19;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i6;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = gb + 64016 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i21;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i23 + 52 >> 2] = 0;
  HEAP32[i23 + 64 >> 2] = 0;
  i3 = i23 + 68 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i23 + 56 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i21);
  i1 = i19;
  i15 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i4;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = i15;
  i2 = gb + 64016 | 0;
  i15 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = i21;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  i1 = i23 + 72 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i23 + 84 >> 2] = 0;
  i15 = i23 + 88 | 0;
  HEAP32[i15 >> 2] = 0;
  i2 = i23 + 76 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i21);
  i14 = i19;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i2;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = i13;
  HEAP32[i23 + 92 >> 2] = 0;
  HEAP32[i23 + 96 >> 2] = 0;
  i12 = gb + 64016 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i23 + 100 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP8[i23 + 108 >> 0] = 1;
  i14 = i23 + 8 | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 + 16 >> 2] = 0;
  HEAP32[i14 + 20 >> 2] = 0;
  i14 = i16 + 40 | 0;
  i13 = HEAP32[i14 >> 2] | 0;
  __ZN19ShaderPropertySheet20ReservePropertyCountEj(i23, i13 + 2 | 0);
  f26 = Math_fround(i13 >>> 0);
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(6.28318548) / f26));
  HEAPF32[i19 >> 2] = f26;
  HEAPF32[i19 + 4 >> 2] = f25;
  HEAPF32[i19 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i23, gb + 1159908 | 0, i19, 0);
  i13 = HEAP32[i16 + 20 >> 2] | 0;
  i19 = HEAP32[i16 + 24 >> 2] | 0;
  HEAP32[i21 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i21 + 4 >> 2] = i13;
  HEAP32[i21 + 8 >> 2] = i19;
  HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i23, gb + 1159912 | 0, i21, 0);
  __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i23, gb + 1159916 | 0, 1, HEAP32[i16 + 28 >> 2] | 0, 16, HEAP32[i14 >> 2] | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 184 >> 2] | 0, i17 | 0, i23 | 0);
  i17 = HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0;
  i21 = HEAP32[gb + 1159920 >> 2] | 0;
  i19 = HEAP32[i21 + 4 >> 2] | 0;
  mftCall_viiiiiii(i17 | 0, i18 | 0, i20 | 0, i22 | 0, i19 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i21, HEAP32[i22 >> 2] | 0, 0) | 0, 0, 0);
  __Z15gpu_time_samplev();
  HEAP32[i23 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i23 + 52 | 0;
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i23 + 32 | 0;
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6);
   HEAP32[i1 >> 2] = 0;
  }
 }
 STACKTOP = i24;
 return;
}

function __ZN5physx36normalizePartitionsWithArticulationsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_Pjj(i17, i25, i23, i5, i31, i22, i24, i30) {
 i17 = i17 | 0;
 i25 = i25 | 0;
 i23 = i23 | 0;
 i5 = i5 | 0;
 i31 = i31 | 0;
 i22 = i22 | 0;
 i24 = i24 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i34 + 44 | 0;
 i28 = i34 + 40 | 0;
 i18 = i34 + 51 | 0;
 i20 = i34 + 50 | 0;
 i27 = i34 + 36 | 0;
 i29 = i34 + 32 | 0;
 i19 = i34 + 49 | 0;
 i21 = i34 + 48 | 0;
 i32 = i34;
 i2 = HEAP32[i17 + 4 >> 2] | 0;
 if (!i2) {
  i3 = 1;
  i16 = 0;
  i1 = 0;
 } else {
  i3 = HEAP32[i17 >> 2] | 0;
  i1 = 0;
  i4 = 0;
  do {
   i16 = i4;
   i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   if (i4 >>> 0 <= i16 >>> 0) break;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  if (!i1) {
   i3 = 1;
   i16 = 0;
   i1 = 0;
  } else {
   i3 = 0;
   i16 = (i5 >>> 0) / (i1 >>> 0) | 0;
  }
 }
 i2 = (i31 + 31 + i30 | 0) >>> 5;
 if ((HEAP32[i22 + 8 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i22, i2);
 i15 = i22 + 4 | 0;
 HEAP32[i15 >> 2] = i2;
 if (i3) {
  STACKTOP = i34;
  return i1 | 0;
 }
 i13 = i1;
 i14 = i1;
 L15 : while (1) {
  i14 = i14 + -1 | 0;
  i5 = i13;
  i13 = i13 + -1 | 0;
  i12 = (i13 | 0) == 0;
  if (i12) {
   i2 = HEAP32[i17 >> 2] | 0;
   i4 = 0;
  } else {
   i4 = HEAP32[i17 >> 2] | 0;
   i2 = i4;
   i4 = HEAP32[i4 + (i5 + -2 << 2) >> 2] | 0;
  }
  i3 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
  L21 : do if ((i3 - i4 | 0) >>> 0 < i16 >>> 0) {
   _memset(HEAP32[i22 >> 2] | 0, 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
   if (i3 >>> 0 > i4 >>> 0) {
    i2 = i4;
    do {
     __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i25 + (i2 << 5) | 0, i23, i31, i24, i30, i26, i28, i18, i20) | 0;
     if (HEAP8[i18 >> 0] | 0) {
      i10 = HEAP32[i26 >> 2] | 0;
      i11 = (HEAP32[i22 >> 2] | 0) + (i10 >>> 5 << 2) | 0;
      HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | HEAP32[gb + 106028 + ((i10 & 31) << 2) >> 2];
     }
     if (HEAP8[i20 >> 0] | 0) {
      i10 = HEAP32[i28 >> 2] | 0;
      i11 = (HEAP32[i22 >> 2] | 0) + (i10 >>> 5 << 2) | 0;
      HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | HEAP32[gb + 106028 + ((i10 & 31) << 2) >> 2];
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   if (i12) {
    i33 = 48;
    break L15;
   }
   i9 = i5 + -2 | 0;
   i11 = i13;
   do {
    i2 = i11;
    i11 = i11 + -1 | 0;
    i10 = (i11 | 0) == 0;
    if (i10) {
     i3 = HEAP32[i17 >> 2] | 0;
     i8 = 0;
    } else {
     i8 = HEAP32[i17 >> 2] | 0;
     i3 = i8;
     i8 = HEAP32[i8 + (i2 + -2 << 2) >> 2] | 0;
    }
    i2 = HEAP32[i3 + (i11 << 2) >> 2] | 0;
    if (i2 >>> 0 > i8 >>> 0) {
     i7 = i11 >>> 0 < i13 >>> 0;
     do {
      i2 = i2 + -1 | 0;
      i3 = i25 + (i2 << 5) | 0;
      __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i3, i23, i31, i24, i30, i27, i29, i19, i21) | 0;
      i4 = (HEAP8[i19 >> 0] | 0) == 0;
      if (i4) i6 = 1; else {
       i6 = HEAP32[i27 >> 2] | 0;
       i6 = (HEAP32[gb + 106028 + ((i6 & 31) << 2) >> 2] & HEAP32[(HEAP32[i22 >> 2] | 0) + (i6 >>> 5 << 2) >> 2] | 0) == 0;
      }
      i5 = (HEAP8[i21 >> 0] | 0) == 0;
      if (i5) {
       if (i6) i33 = 36;
      } else {
       i35 = HEAP32[i29 >> 2] | 0;
       if (i6 & (HEAP32[gb + 106028 + ((i35 & 31) << 2) >> 2] & HEAP32[(HEAP32[i22 >> 2] | 0) + (i35 >>> 5 << 2) >> 2] | 0) == 0) i33 = 36;
      }
      if ((i33 | 0) == 36) {
       i33 = 0;
       HEAP32[i32 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i32 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i32 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i32 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i32 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i32 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i32 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i32 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       if (!i4) {
        i6 = HEAP32[i27 >> 2] | 0;
        i35 = (HEAP32[i22 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
        HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | HEAP32[gb + 106028 + ((i6 & 31) << 2) >> 2];
       }
       if (!i5) {
        i6 = HEAP32[i29 >> 2] | 0;
        i35 = (HEAP32[i22 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
        HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | HEAP32[gb + 106028 + ((i6 & 31) << 2) >> 2];
       }
       do if (i7) {
        i4 = HEAP32[i17 >> 2] | 0;
        i5 = i11;
        i6 = i2;
        while (1) {
         i35 = i4 + (i5 << 2) | 0;
         i3 = (HEAP32[i35 >> 2] | 0) + -1 | 0;
         HEAP32[i35 >> 2] = i3;
         if ((i6 | 0) != (i3 | 0)) {
          i35 = i25 + (i6 << 5) | 0;
          i6 = i25 + (i3 << 5) | 0;
          HEAP32[i35 >> 2] = HEAP32[i6 >> 2];
          HEAP32[i35 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
          HEAP32[i35 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
          HEAP32[i35 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
          HEAP32[i35 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
          HEAP32[i35 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
          HEAP32[i35 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
          HEAP32[i35 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
         }
         i5 = i5 + 1 | 0;
         if ((i5 | 0) == (i14 | 0)) break; else i6 = i3;
        }
        if ((i3 | 0) == (i2 | 0)) break;
        i35 = i25 + (i3 << 5) | 0;
        HEAP32[i35 >> 2] = HEAP32[i32 >> 2];
        HEAP32[i35 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
        HEAP32[i35 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
        HEAP32[i35 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
        HEAP32[i35 + 16 >> 2] = HEAP32[i32 + 16 >> 2];
        HEAP32[i35 + 20 >> 2] = HEAP32[i32 + 20 >> 2];
        HEAP32[i35 + 24 >> 2] = HEAP32[i32 + 24 >> 2];
        HEAP32[i35 + 28 >> 2] = HEAP32[i32 + 28 >> 2];
       } while (0);
       i35 = HEAP32[i17 >> 2] | 0;
       if (((HEAP32[i35 + (i13 << 2) >> 2] | 0) - (HEAP32[i35 + (i9 << 2) >> 2] | 0) | 0) >>> 0 >= i16 >>> 0) break L21;
      }
     } while (i2 >>> 0 > i8 >>> 0);
    }
   } while (!i10);
  } while (0);
  if (i12) {
   i33 = 48;
   break;
  }
 }
 if ((i33 | 0) == 48) {
  STACKTOP = i34;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i12 = i11 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i15 = i11 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if (((i1 - i3 | 0) / 296 | 0) >>> 0 >= i4 >>> 0) {
  do {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i1 = i3 + 16 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 32 >> 2] = Math_fround(1.0);
   i1 = i3 + 36 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 52 >> 2] = Math_fround(1.0);
   i1 = i3 + 56 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 72 >> 2] = Math_fround(1.0);
   i1 = i3 + 76 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 92 >> 2] = Math_fround(1.0);
   i1 = i3 + 96 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 112 >> 2] = Math_fround(1.0);
   i1 = i3 + 116 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 132 >> 2] = Math_fround(1.0);
   i1 = i3 + 136 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 152 >> 2] = Math_fround(1.0);
   i1 = i3 + 156 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAPF32[i3 + 172 >> 2] = Math_fround(1.0);
   i1 = i3 + 176 | 0;
   i2 = i3 + 249 | 0;
   i8 = i1;
   i9 = i8 + 72 | 0;
   do {
    HEAP32[i8 >> 2] = 0;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) < (i9 | 0));
   HEAP8[i1 + 72 >> 0] = 0;
   HEAP8[i2 >> 0] = 1;
   i1 = i3 + 292 | 0;
   i8 = i3 + 252 | 0;
   i9 = i8 + 40 | 0;
   do {
    HEAP32[i8 >> 2] = 0;
    i8 = i8 + 4 | 0;
   } while ((i8 | 0) < (i9 | 0));
   HEAP8[i1 >> 0] = 1;
   HEAP8[i3 + 293 >> 0] = 0;
   i3 = (HEAP32[i15 >> 2] | 0) + 296 | 0;
   HEAP32[i15 >> 2] = i3;
   i4 = i4 + -1 | 0;
  } while ((i4 | 0) != 0);
  STACKTOP = i16;
  return;
 }
 i14 = i11 + 12 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = ((i3 - i2 | 0) / 296 | 0) + i4 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
 }
 i10 = (i1 - i2 | 0) / 296 | 0;
 i1 = i10 << 1;
 i1 = i10 >>> 0 < 1073741823 ? (i1 >>> 0 < i5 >>> 0 ? i5 : i1) : 2147483647;
 if (!i1) i5 = 0; else {
  i5 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = 1;
  HEAP32[i13 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 296 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i5 + (((i3 - i2 | 0) / 296 | 0) * 296 | 0) | 0;
 i2 = i3;
 i7 = i5 + (i1 * 296 | 0) | 0;
 i10 = i2;
 i6 = i3;
 do {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i1 = i6 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 32 >> 2] = Math_fround(1.0);
  i1 = i6 + 36 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 52 >> 2] = Math_fround(1.0);
  i1 = i6 + 56 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
  i1 = i6 + 76 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 92 >> 2] = Math_fround(1.0);
  i1 = i6 + 96 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 112 >> 2] = Math_fround(1.0);
  i1 = i6 + 116 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 132 >> 2] = Math_fround(1.0);
  i1 = i6 + 136 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 152 >> 2] = Math_fround(1.0);
  i1 = i6 + 156 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i6 + 172 >> 2] = Math_fround(1.0);
  i1 = i6 + 176 | 0;
  i5 = i6 + 249 | 0;
  i8 = i1;
  i9 = i8 + 72 | 0;
  do {
   HEAP32[i8 >> 2] = 0;
   i8 = i8 + 4 | 0;
  } while ((i8 | 0) < (i9 | 0));
  HEAP8[i1 + 72 >> 0] = 0;
  HEAP8[i5 >> 0] = 1;
  i1 = i6 + 292 | 0;
  i8 = i6 + 252 | 0;
  i9 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = 0;
   i8 = i8 + 4 | 0;
  } while ((i8 | 0) < (i9 | 0));
  HEAP8[i1 >> 0] = 1;
  HEAP8[i6 + 293 >> 0] = 0;
  i6 = i10 + 296 | 0;
  i10 = i6;
  i4 = i4 + -1 | 0;
 } while ((i4 | 0) != 0);
 i4 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i5 = i4;
  i1 = i4;
 } else {
  do {
   i1 = i1 + -296 | 0;
   __ZN8GUIStyleC2ERKS_(i3 + -296 | 0, i1);
   i3 = i2 + -296 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i4 | 0));
  i5 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i12 >> 2] = i7;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i13 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -296 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i4 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i13);
   }
  } while ((i1 | 0) != (i3 | 0));
 }
 if (!i5) {
  STACKTOP = i16;
  return;
 }
 i15 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i13);
 STACKTOP = i16;
 return;
}

function __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi(i29, i30, i32, i33, i1, i2, i34, i25) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i34 = i34 | 0;
 i25 = i25 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i37 + 44 | 0;
 i27 = i37 + 40 | 0;
 i26 = i37 + 36 | 0;
 i35 = i37 + 32 | 0;
 i36 = i37 + 28 | 0;
 i31 = i37 + 24 | 0;
 i19 = i37 + 20 | 0;
 i20 = i37 + 16 | 0;
 i21 = i37 + 12 | 0;
 i22 = i37 + 8 | 0;
 i23 = i37 + 4 | 0;
 i24 = i37;
 if (!i2) {
  STACKTOP = i37;
  return;
 }
 i3 = i1;
 L4 : while (1) {
  if (!((i2 | 0) > (i25 | 0) & (i3 | 0) > (i25 | 0))) {
   i1 = 6;
   break;
  }
  if (!i3) {
   i1 = 37;
   break;
  }
  i7 = HEAP32[i30 >> 2] | 0;
  i13 = HEAP32[i7 >> 2] | 0;
  i17 = i7;
  i4 = HEAP32[i29 >> 2] | 0;
  while (1) {
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i13 | 0) < (i5 | 0)) break;
   i1 = i4 + 8 | 0;
   HEAP32[i29 >> 2] = i1;
   i3 = i3 + -1 | 0;
   if (!i3) {
    i1 = 37;
    break L4;
   } else i4 = i1;
  }
  i18 = i4;
  if ((i3 | 0) < (i2 | 0)) {
   i12 = (i2 | 0) / 2 | 0;
   i5 = i7 + (i12 << 3) | 0;
   i1 = i5;
   i6 = i17 - i18 >> 3;
   if (i6) {
    i11 = HEAP32[i5 >> 2] | 0;
    i5 = i4;
    i8 = i4;
    while (1) {
     i16 = (i6 | 0) / 2 | 0;
     i10 = i8 + (i16 << 3) | 0;
     i9 = (i11 | 0) < (HEAP32[i10 >> 2] | 0);
     i10 = i10 + 8 | 0;
     i4 = i9 ? i5 : i10;
     i6 = i9 ? i16 : i6 + -1 - i16 | 0;
     if (!i6) break; else {
      i5 = i4;
      i8 = i9 ? i8 : i10;
     }
    }
   }
   i16 = i4;
   i10 = i16 - i18 >> 3;
  } else {
   if ((i3 | 0) == 1) {
    i1 = 15;
    break;
   }
   i10 = (i3 | 0) / 2 | 0;
   i1 = i4 + (i10 << 3) | 0;
   i11 = i1;
   i4 = (HEAP32[i32 >> 2] | 0) - i17 >> 3;
   if (!i4) i1 = i7; else {
    i9 = HEAP32[i1 >> 2] | 0;
    i1 = i7;
    i5 = i7;
    while (1) {
     i16 = (i4 | 0) / 2 | 0;
     i8 = i5 + (i16 << 3) | 0;
     i6 = (HEAP32[i8 >> 2] | 0) < (i9 | 0);
     i8 = i8 + 8 | 0;
     i1 = i6 ? i8 : i1;
     i4 = i6 ? i4 + -1 - i16 | 0 : i16;
     if (!i4) break; else i5 = i6 ? i8 : i5;
    }
   }
   i12 = i1 - i17 >> 3;
   i16 = i11;
  }
  i3 = i3 - i10 | 0;
  i2 = i2 - i12 | 0;
  i4 = i16;
  i15 = i1;
  L27 : do if ((i4 | 0) == (i7 | 0)) i4 = i15; else if ((i7 | 0) != (i15 | 0)) {
   i14 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i13;
   HEAP32[i7 >> 2] = i14;
   i14 = i4 + 4 | 0;
   i5 = i7 + 4 | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i6;
   i4 = i4 + 8 | 0;
   i5 = i7 + 8 | 0;
   i6 = (i4 | 0) == (i7 | 0);
   if ((i5 | 0) == (i15 | 0)) if (i6) {
    i4 = i7;
    break;
   } else {
    i6 = i17;
    i5 = i17;
   } else {
    i13 = i15 + -16 | 0;
    i9 = i5;
    i11 = i6;
    i5 = i17;
    i14 = i7;
    i6 = i17;
    i8 = i4;
    do {
     i40 = i9;
     i5 = i11 ? i40 : i5;
     i14 = i11 ? i9 : i14;
     i6 = i11 ? i40 : i6;
     i7 = i11 ? i9 : i7;
     i40 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = i40;
     i40 = i8 + 4 | 0;
     i38 = i9 + 4 | 0;
     i39 = HEAP32[i40 >> 2] | 0;
     HEAP32[i40 >> 2] = HEAP32[i38 >> 2];
     HEAP32[i38 >> 2] = i39;
     i8 = i8 + 8 | 0;
     i9 = i9 + 8 | 0;
     i11 = (i8 | 0) == (i7 | 0);
    } while ((i9 | 0) != (i15 | 0));
    i4 = i4 + (((i13 - i17 | 0) >>> 3) + 1 << 3) | 0;
    if (i11) break; else i7 = i14;
   }
   i8 = i7;
   i7 = i4;
   L37 : while (1) {
    i13 = i5;
    i11 = i8;
    while (1) {
     while (1) {
      i8 = i6;
      i40 = HEAP32[i7 >> 2] | 0;
      HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i8 >> 2] = i40;
      i40 = i7 + 4 | 0;
      i6 = i8 + 4 | 0;
      i9 = HEAP32[i40 >> 2] | 0;
      HEAP32[i40 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i6 >> 2] = i9;
      i7 = i7 + 8 | 0;
      i8 = i8 + 8 | 0;
      i6 = i8;
      i9 = (i7 | 0) == (i11 | 0);
      if ((i8 | 0) == (i15 | 0)) break;
      if (i9) {
       i5 = i6;
       i7 = i11;
       continue L37;
      }
     }
     if (i9) break L27; else {
      i11 = i13;
      i6 = i5;
     }
    }
   }
  } while (0);
  HEAP32[i30 >> 2] = i4;
  if ((i10 + i12 | 0) < (i3 + i2 | 0)) {
   HEAP32[i19 >> 2] = i18;
   HEAP32[i20 >> 2] = i16;
   HEAP32[i21 >> 2] = i4;
   HEAP32[i26 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i21 >> 2];
   __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi(i26, i27, i28, i33, i10, i12, i34, i25);
   HEAP32[i29 >> 2] = i4;
  } else {
   HEAP32[i22 >> 2] = i4;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i24 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i28 >> 2] = HEAP32[i24 >> 2];
   __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi(i26, i27, i28, i33, i3, i2, i34, i25);
   HEAP32[i32 >> 2] = i4;
   i2 = i12;
   i3 = i10;
   i1 = i16;
  }
  HEAP32[i30 >> 2] = i1;
  if (!i2) {
   i1 = 37;
   break;
  }
 }
 if ((i1 | 0) == 6) {
  HEAP32[i35 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i36 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i26 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i36 >> 2];
  HEAP32[i28 >> 2] = HEAP32[i31 >> 2];
  __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeE(i26, i27, i28, i33, i3, i2, i34);
  STACKTOP = i37;
  return;
 } else if ((i1 | 0) == 15) {
  HEAP32[i4 >> 2] = i13;
  HEAP32[i7 >> 2] = i5;
  i38 = i4 + 4 | 0;
  i40 = i7 + 4 | 0;
  i39 = HEAP32[i38 >> 2] | 0;
  HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
  HEAP32[i40 >> 2] = i39;
  STACKTOP = i37;
  return;
 } else if ((i1 | 0) == 37) {
  STACKTOP = i37;
  return;
 }
}

function __ZN7mecanim9animation17EvaluateBlendTreeERKNS0_17BlendTreeConstantERKNS0_14BlendTreeInputERNS0_15BlendTreeOutputERNS0_18BlendTreeWorkspaceERKNS0_12AnimationSetE(i19, i20, i21, i22, i4) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f23 = f0, i24 = 0, f25 = f0;
 i2 = HEAP32[i21 + 4 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i21 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i3 + (i1 * 24 | 0) + 4 >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i18 = i21 + 8 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[HEAP32[i22 >> 2] >> 2] = Math_fround(1.0);
 if (HEAP32[i19 >> 2] | 0) {
  i14 = i19 + 4 | 0;
  i15 = i14;
  i16 = i20 + 4 | 0;
  i17 = i22 + 4 | 0;
  i13 = i4 + 8 | 0;
  f5 = Math_fround(0.0);
  i1 = 0;
  i12 = 0;
  i11 = 0;
  while (1) {
   i3 = (HEAP32[i14 >> 2] | 0) + i15 + (i12 << 2) | 0;
   i10 = HEAP32[i3 >> 2] | 0;
   i10 = (i10 | 0) == 0 ? 0 : i3 + i10 | 0;
   i3 = i10 + 32 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i9 = i10 + 12 | 0;
    if (!(HEAP32[i9 >> 2] | 0)) i2 = i11; else {
     i2 = HEAP32[i10 >> 2] | 0;
     do if (!i2) {
      i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(HEAP32[i20 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0) | 0;
      if ((i2 | 0) != -1) {
       i8 = (HEAP32[i20 >> 2] | 0) + 4 | 0;
       i7 = (HEAP32[i16 >> 2] | 0) + 28 | 0;
       f6 = Math_fround(HEAPF32[(HEAP32[i7 >> 2] | 0) + i7 + (HEAP32[i8 + (HEAP32[i8 >> 2] | 0) + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2]);
       __ZN7mecanim9animation10GetWeightsERKNS0_21BlendTreeNodeConstantERNS0_18BlendTreeWorkspaceEPfff(i10, i22, HEAP32[i17 >> 2] | 0, f6, Math_fround(0.0));
      }
     } else {
      if (i2 >>> 0 < 4) {
       i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(HEAP32[i20 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0) | 0;
       i3 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(HEAP32[i20 >> 2] | 0, HEAP32[i10 + 8 >> 2] | 0) | 0;
       if (!((i2 | 0) != -1 & (i3 | 0) != -1)) break;
       i8 = (HEAP32[i20 >> 2] | 0) + 4 | 0;
       i8 = i8 + (HEAP32[i8 >> 2] | 0) | 0;
       i7 = (HEAP32[i16 >> 2] | 0) + 28 | 0;
       i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
       f23 = Math_fround(HEAPF32[i7 + (HEAP32[i8 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2]);
       f6 = Math_fround(HEAPF32[i7 + (HEAP32[i8 + (i3 * 12 | 0) + 8 >> 2] << 2) >> 2]);
       __ZN7mecanim9animation10GetWeightsERKNS0_21BlendTreeNodeConstantERNS0_18BlendTreeWorkspaceEPfff(i10, i22, HEAP32[i17 >> 2] | 0, f23, f6);
       break;
      }
      if ((i2 | 0) == 4) {
       i7 = i10 + 28 | 0;
       i8 = i7;
       i2 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
       if (HEAP32[i2 >> 2] | 0) {
        i4 = 0;
        f6 = Math_fround(0.0);
        do {
         i2 = i2 + 4 | 0;
         i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + i2 + (i4 << 2) >> 2] | 0;
         if ((i2 | 0) == -1) i2 = 0; else {
          i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(HEAP32[i20 >> 2] | 0, i2) | 0;
          if ((i2 | 0) == -1) i2 = 0; else {
           i3 = (HEAP32[i20 >> 2] | 0) + 4 | 0;
           i24 = (HEAP32[i16 >> 2] | 0) + 28 | 0;
           i2 = HEAP32[(HEAP32[i24 >> 2] | 0) + i24 + (HEAP32[i3 + (HEAP32[i3 >> 2] | 0) + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0;
          }
         }
         f23 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
         i3 = f23 < Math_fround(0.0);
         f25 = i3 ? Math_fround(0.0) : f23;
         HEAPF32[(HEAP32[i17 >> 2] | 0) + (i4 << 2) >> 2] = f25;
         f6 = Math_fround(f6 + f23);
         i4 = i4 + 1 | 0;
         i3 = HEAP32[i7 >> 2] | 0;
         i2 = i3 + i8 | 0;
        } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
        if (f6 > Math_fround(1.0) & (HEAP8[i2 + 8 >> 0] | 0) != 0) {
         i3 = HEAP32[i3 + i8 >> 2] | 0;
         if (i3 | 0) {
          i4 = HEAP32[i17 >> 2] | 0;
          i2 = 0;
          do {
           i24 = i4 + (i2 << 2) | 0;
           HEAPF32[i24 >> 2] = Math_fround(Math_fround(HEAPF32[i24 >> 2]) / f6);
           i2 = i2 + 1 | 0;
          } while (i2 >>> 0 < i3 >>> 0);
         }
        }
       }
      }
     } while (0);
     i4 = HEAP32[i9 >> 2] | 0;
     if (!i4) i2 = i11; else {
      i7 = HEAP32[i17 >> 2] | 0;
      i8 = HEAP32[i22 >> 2] | 0;
      i9 = i8 + (i12 << 2) | 0;
      i3 = i10 + 16 | 0;
      i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
      i2 = 0;
      do {
       f25 = Math_fround(HEAPF32[i7 + (i2 << 2) >> 2]);
       f25 = Math_fround(f25 * Math_fround(HEAPF32[i9 >> 2]));
       HEAPF32[i8 + (HEAP32[i3 + (i2 << 2) >> 2] << 2) >> 2] = f25;
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i4 >>> 0);
      i2 = i11;
     }
    }
   } else {
    if (Math_fround(HEAPF32[(HEAP32[i22 >> 2] | 0) + (i12 << 2) >> 2]) > Math_fround(0.0)) {
     i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 * 40 | 0) >> 2] | 0;
     if (!i2) f6 = Math_fround(0.0); else {
      i2 = __ZN13AnimationClip15GetRuntimeAssetEv(i2) | 0;
      if (!i2) f6 = Math_fround(0.0); else {
       f6 = Math_fround(HEAPF32[i2 + 1068 >> 2]);
       f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 1064 >> 2]));
      }
     }
     f23 = Math_fround(HEAPF32[i10 + 36 >> 2]);
     f25 = Math_fround(f6 * f23);
     i9 = HEAP32[i21 >> 2] | 0;
     HEAP32[i9 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i3 >> 2];
     i24 = (HEAP32[i22 >> 2] | 0) + (i12 << 2) | 0;
     HEAP32[i9 + (i1 * 24 | 0) >> 2] = HEAP32[i24 >> 2];
     i8 = f23 != Math_fround(0.0);
     f23 = Math_fround(Math_fround(1.0) / f23);
     HEAPF32[i9 + (i1 * 24 | 0) + 8 >> 2] = i8 ? f23 : Math_fround(1.0);
     HEAP32[i9 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i10 + 40 >> 2];
     HEAP8[i9 + (i1 * 24 | 0) + 12 >> 0] = HEAP8[i10 + 44 >> 0] | 0;
     HEAP32[i9 + (i1 * 24 | 0) + 20 >> 2] = i11;
     f25 = Math_fround(Math_abs(Math_fround(f25)));
     f25 = Math_fround(f25 * Math_fround(HEAPF32[i24 >> 2]));
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f25);
     f5 = Math_fround(f5 + Math_fround(HEAPF32[i24 >> 2]));
     i1 = i1 + 1 | 0;
    }
    i2 = i11 + 1 | 0;
   }
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= (HEAP32[i19 >> 2] | 0) >>> 0) break; else i11 = i2;
  }
  if (!(f5 == Math_fround(0.0))) {
   if (!(f5 < Math_fround(1.0))) return;
   HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) / f5);
   return;
  }
 }
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 return;
}

function __ZN5physx49solveDrive4WInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 4544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i33 + 2408 | 0;
 i24 = i33 + 2312 | 0;
 i29 = i33 + 2216 | 0;
 i25 = i33;
 i26 = i33 + 4528 | 0;
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 i21 = HEAP32[i3 + 20 >> 2] | 0;
 i22 = HEAP32[i3 + 24 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i5 = HEAP32[i3 + 36 >> 2] | 0;
 i6 = HEAP32[i3 + 40 >> 2] | 0;
 i16 = HEAP32[i3 + 44 >> 2] | 0;
 i27 = HEAP32[i3 + 48 >> 2] | 0;
 i18 = HEAP32[i3 + 52 >> 2] | 0;
 i19 = HEAP32[i3 + 64 >> 2] | 0;
 i32 = HEAP32[i3 + 68 >> 2] | 0;
 i31 = HEAP32[i4 + 4 >> 2] | 0;
 i30 = HEAP32[i4 >> 2] | 0;
 f1 = Math_fround(f17 * f20);
 f2 = Math_fround(f20 * f1);
 HEAP32[i23 + 2116 >> 2] = 5;
 HEAP32[i24 + 92 >> 2] = 5;
 HEAP32[i29 + 92 >> 2] = 5;
 i31 = i31 + 76 | 0;
 f12 = Math_fround(HEAPF32[i31 >> 2]);
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i29 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i29 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 HEAP32[i29 + 12 >> 2] = HEAP32[i30 + 12 >> 2];
 f11 = f7;
 i3 = 0;
 while (1) {
  f34 = Math_fround(f13 * Math_fround(HEAPF32[i19 + 192 + (i3 * 48 | 0) + 40 >> 2]));
  f35 = Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]);
  f36 = Math_fround(f35 * Math_fround(f2 * f34));
  HEAPF32[i23 + (i3 * 92 | 0) >> 2] = Math_fround(f7 * f36);
  HEAPF32[i23 + (i3 * 92 | 0) + 4 >> 2] = Math_fround(f36 * f8);
  HEAPF32[i23 + (i3 * 92 | 0) + 8 >> 2] = Math_fround(f36 * f9);
  HEAPF32[i23 + (i3 * 92 | 0) + 12 >> 2] = Math_fround(f36 * f10);
  f11 = Math_fround(Math_fround(f36 * f11) + Math_fround(1.0));
  HEAPF32[i23 + (i3 * 92 | 0) + (i3 << 2) >> 2] = Math_fround(f11 + Math_fround(f34 * Math_fround(HEAPF32[i19 + 192 + (i3 * 48 | 0) + 16 >> 2])));
  HEAPF32[i23 + (i3 * 92 | 0) + 16 >> 2] = Math_fround(-Math_fround(f35 * Math_fround(f1 * f34)));
  f35 = Math_fround(HEAPF32[i30 + (i3 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i16 + (i3 << 2) >> 2]);
  HEAPF32[i24 + (i3 << 2) >> 2] = Math_fround(f35 + Math_fround(f34 * Math_fround(f11 + Math_fround(HEAPF32[i18 + (i3 << 2) >> 2]))));
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 4) break;
  f11 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
 }
 f36 = Math_fround(f13 * Math_fround(HEAPF32[i32 + 104 >> 2]));
 f35 = Math_fround(-Math_fround(f20 * Math_fround(f17 * f36)));
 HEAPF32[i23 + 368 >> 2] = Math_fround(f7 * f35);
 HEAPF32[i23 + 372 >> 2] = Math_fround(f8 * f35);
 HEAPF32[i23 + 376 >> 2] = Math_fround(f9 * f35);
 HEAPF32[i23 + 380 >> 2] = Math_fround(f10 * f35);
 HEAPF32[i23 + 384 >> 2] = Math_fround(Math_fround(Math_fround(f17 + f15) * f36) + Math_fround(1.0));
 HEAPF32[i24 + 16 >> 2] = Math_fround(f12 + Math_fround(f14 * f36));
 i16 = i29 + 16 | 0;
 HEAPF32[i16 >> 2] = f12;
 if ((i21 | 0) == 1) {
  HEAP32[i25 + 2208 >> 2] = 0;
  __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i25, i23);
  __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i25, i24, i29);
 } else __ZNK5physx24MatrixNGaussSeidelSolver5solveEjfRKNS_8MatrixNNERKNS_7VectorNERS4_(i26, i22, Math_fround(1.00000001e-10), i23, i24, i29);
 if (!(HEAP8[i27 >> 0] | 0)) {
  i3 = i29;
  f1 = Math_fround(HEAPF32[i29 >> 2]);
  i28 = 10;
 } else {
  f36 = Math_fround(HEAPF32[i30 >> 2]);
  f1 = Math_fround(HEAPF32[i29 >> 2]);
  if (!(Math_fround(f36 * f1) <= Math_fround(0.0))) {
   i3 = i29;
   i28 = 10;
  } else {
   i3 = i29;
   f1 = Math_fround(0.0);
  }
 }
 HEAPF32[i3 >> 2] = f1;
 if (!(HEAP8[i27 + 1 >> 0] | 0)) {
  i28 = i29 + 4 | 0;
  i3 = i28;
  f2 = Math_fround(HEAPF32[i28 >> 2]);
  i28 = 14;
 } else {
  f36 = Math_fround(HEAPF32[i30 + 4 >> 2]);
  i3 = i29 + 4 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  if (!(Math_fround(f36 * f2) <= Math_fround(0.0))) i28 = 14; else {
   i6 = i3;
   f2 = Math_fround(0.0);
  }
 }
 if ((i28 | 0) == 14) i6 = i3;
 HEAPF32[i6 >> 2] = f2;
 if (!(HEAP8[i27 + 2 >> 0] | 0)) {
  i28 = i29 + 8 | 0;
  i3 = i28;
  f2 = Math_fround(HEAPF32[i28 >> 2]);
  i28 = 18;
 } else {
  f36 = Math_fround(HEAPF32[i30 + 8 >> 2]);
  i3 = i29 + 8 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  if (!(Math_fround(f36 * f2) <= Math_fround(0.0))) i28 = 18; else {
   i5 = i3;
   f2 = Math_fround(0.0);
  }
 }
 if ((i28 | 0) == 18) i5 = i3;
 HEAPF32[i5 >> 2] = f2;
 if (!(HEAP8[i27 + 3 >> 0] | 0)) {
  i29 = i29 + 12 | 0;
  i3 = i29;
  f2 = Math_fround(HEAPF32[i29 >> 2]);
 } else {
  i4 = i30 + 12 | 0;
  f36 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i29 + 12 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  if (Math_fround(f36 * f2) <= Math_fround(0.0)) {
   i28 = i3;
   i29 = i4;
   f36 = Math_fround(0.0);
   HEAPF32[i28 >> 2] = f36;
   f36 = Math_fround(HEAPF32[i16 >> 2]);
   i32 = i32 + 88 | 0;
   f35 = Math_fround(HEAPF32[i32 >> 2]);
   i32 = f36 < Math_fround(0.0);
   f36 = i32 ? Math_fround(0.0) : f36;
   i32 = f36 > f35;
   f36 = i32 ? f35 : f36;
   HEAPF32[i16 >> 2] = f36;
   HEAPF32[i30 >> 2] = f1;
   i32 = HEAP32[i6 >> 2] | 0;
   i27 = i30 + 4 | 0;
   HEAP32[i27 >> 2] = i32;
   i27 = HEAP32[i5 >> 2] | 0;
   i32 = i30 + 8 | 0;
   HEAP32[i32 >> 2] = i27;
   i32 = HEAP32[i28 >> 2] | 0;
   HEAP32[i29 >> 2] = i32;
   i32 = HEAP32[i16 >> 2] | 0;
   HEAP32[i31 >> 2] = i32;
   STACKTOP = i33;
   return;
  }
 }
 i28 = i3;
 i29 = i30 + 12 | 0;
 f36 = f2;
 HEAPF32[i28 >> 2] = f36;
 f36 = Math_fround(HEAPF32[i16 >> 2]);
 i32 = i32 + 88 | 0;
 f35 = Math_fround(HEAPF32[i32 >> 2]);
 i32 = f36 < Math_fround(0.0);
 f36 = i32 ? Math_fround(0.0) : f36;
 i32 = f36 > f35;
 f36 = i32 ? f35 : f36;
 HEAPF32[i16 >> 2] = f36;
 HEAPF32[i30 >> 2] = f1;
 i32 = HEAP32[i6 >> 2] | 0;
 i27 = i30 + 4 | 0;
 HEAP32[i27 >> 2] = i32;
 i27 = HEAP32[i5 >> 2] | 0;
 i32 = i30 + 8 | 0;
 HEAP32[i32 >> 2] = i27;
 i32 = HEAP32[i28 >> 2] | 0;
 HEAP32[i29 >> 2] = i32;
 i32 = HEAP32[i16 >> 2] | 0;
 HEAP32[i31 >> 2] = i32;
 STACKTOP = i33;
 return;
}

function __ZN8Material8TransferI18StreamedBinaryReadILb1EEEEvRT_(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i23 + 52 | 0;
 i17 = i23 + 48 | 0;
 i18 = i23 + 40 | 0;
 i19 = i23 + 24 | 0;
 i20 = i23 + 12 | 0;
 i21 = i23;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i15, i16);
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i15 + 32 | 0, i16);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i16, i15 + 80 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i16);
 i5 = i16 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i16 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i14, 4);
  i1 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 }
 HEAP32[i15 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i14, 4);
  i1 = HEAP32[i14 >> 2] | 0;
 } else {
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i5 >> 2] = i1;
  i1 = i13;
 }
 HEAP32[i15 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 + 12 >> 2] = 0;
 i13 = i19 + 4 | 0;
 HEAP32[i19 >> 2] = i13;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i16, i19, 0);
 i1 = i15 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 185) | 0;
  __ZN18SharedMaterialDataC2Ev(i2);
  HEAP32[i1 >> 2] = i2;
 }
 i1 = HEAP32[i2 + 176 >> 2] | 0;
 i12 = i2 + 180 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i13 | 0)) {
  i22 = i15 + 44 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = i15 + 56 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = i15 + 68 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i19, i22);
  STACKTOP = i23;
  return;
 }
 i10 = i2 + 176 | 0;
 i11 = i18 + 4 | 0;
 while (1) {
  i2 = i3 + 32 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  if (i4 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i3 + 36 >> 2] | 0;
  } else i4 = i4 & 255;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, i2, i4);
  i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i20) | 0;
  i2 = i3 + 16 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  if (i4 << 24 >> 24 < 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i3 + 20 >> 2] | 0;
  } else {
   i5 = i2;
   i2 = i4 & 255;
  };
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, i5, i2);
  i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i21) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i2 = i8 - i3 >> 3;
  if (!i2) i2 = i3; else {
   i6 = i2;
   i2 = i3;
   while (1) {
    i24 = (i6 | 0) / 2 | 0;
    i5 = i3 + (i24 << 3) | 0;
    i4 = (HEAP32[i5 >> 2] | 0) < (i7 | 0);
    i5 = i5 + 8 | 0;
    i2 = i4 ? i5 : i2;
    i6 = i4 ? i6 + -1 - i24 | 0 : i24;
    if (!i6) break; else i3 = i4 ? i5 : i3;
   }
  }
  i3 = i2;
  if ((i2 | 0) == (i8 | 0)) i22 = 23; else if ((i7 | 0) < (HEAP32[i2 >> 2] | 0)) i22 = 23;
  if ((i22 | 0) == 23) {
   i22 = 0;
   HEAP32[i17 >> 2] = i3;
   HEAP32[i18 >> 2] = i7;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
   i2 = __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i10, i14, i18) | 0;
  }
  HEAP32[i2 + 4 >> 2] = i9;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i13 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 i24 = i15 + 44 | 0;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = i15 + 56 | 0;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = i15 + 68 | 0;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i19, i24);
 STACKTOP = i23;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j(i14, i25, i6) {
 i14 = i14 | 0;
 i25 = i25 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i30 + 12 | 0;
 i27 = i30;
 i28 = i14 + 60 | 0;
 i29 = i14 + 64 | 0;
 HEAP32[i29 >> 2] = 32;
 i11 = i14 + 76 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i14 + 72 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i14 + 80 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i14 + 84 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i26 >> 2] = 1;
 HEAP32[i26 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(768, 16, i26, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 >> 2] | 0;
  HEAP32[i26 >> 2] = 1;
  HEAP32[i26 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i26);
 }
 HEAP32[i28 >> 2] = i2;
 i3 = i2 + ((HEAP32[i29 >> 2] | 0) * 24 | 0) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i14 + 36 | 0;
  i1 = i2;
  do {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i24 = i14 + 68 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 f5 = Math_fround(((HEAP32[i25 + 68 >> 2] | 0) - (HEAP32[i25 + 4 >> 2] | 0) | 0) >>> 0);
 i7 = 32;
 while (1) {
  if (i7 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i7 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i7 = i7 << 1;
 }
 if (i7 >>> 0 > (HEAP32[i29 >> 2] | 0) >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i26 >> 2] = 1;
  HEAP32[i26 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 16, i26, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i28 >> 2] | 0;
  i2 = HEAP32[i29 >> 2] | 0;
  i23 = i2 >>> 0 > i7 >>> 0 ? i7 : i2;
  i3 = i1 + (i23 * 24 | 0) | 0;
  if (i23) {
   i2 = i6;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    i1 = i1 + 24 | 0;
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 24 | 0;
   }
   i2 = HEAP32[i29 >> 2] | 0;
  }
  i3 = i6 + (i7 * 24 | 0) | 0;
  if ((i2 | 0) != (i7 | 0)) {
   i4 = i14 + 36 | 0;
   i1 = i6 + (i2 * 24 | 0) | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    i1 = i1 + 24 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  i23 = HEAP32[i28 >> 2] | 0;
  i22 = HEAP32[i10 >> 2] | 0;
  HEAP32[i26 >> 2] = 1;
  HEAP32[i26 + 4 >> 2] = i22;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i26);
  HEAP32[i28 >> 2] = i6;
  HEAP32[i29 >> 2] = i7;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 }
 i15 = i25 + 60 | 0;
 i18 = HEAP32[i15 >> 2] | 0;
 i16 = i25 + 64 | 0;
 i1 = i18 + ((HEAP32[i16 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i26 >> 2] = i25;
 i17 = i26 + 4 | 0;
 HEAP32[i17 >> 2] = i18;
 HEAP32[i26 + 8 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i26);
 i1 = (HEAP32[i15 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i27 >> 2] = i25;
 i18 = i27 + 4 | 0;
 HEAP32[i18 >> 2] = i1;
 i19 = i27 + 8 | 0;
 HEAP32[i19 >> 2] = i1;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i27);
 i1 = HEAP32[i17 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 i20 = i14 + 52 | 0;
 i21 = i14 + 40 | 0;
 i22 = i14 + 36 | 0;
 i23 = i14 + 44 | 0;
 i14 = i14 + 48 | 0;
 do {
  i4 = (HEAP32[i29 >> 2] | 0) + -1 | 0;
  i6 = HEAP32[i28 >> 2] | 0;
  i7 = HEAP32[i20 >> 2] | 0;
  i10 = HEAP32[i21 >> 2] | 0;
  i11 = HEAP32[i22 >> 2] | 0;
  i12 = HEAP32[i23 >> 2] | 0;
  i13 = HEAP32[i14 >> 2] | 0;
  i3 = 0;
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  while (1) {
   i2 = i2 & i4;
   if ((i7 | 0) == (HEAP32[i6 + (i2 * 24 | 0) + 16 >> 2] | 0)) if ((i10 | 0) == (HEAP32[i6 + (i2 * 24 | 0) + 4 >> 2] | 0)) if (!(_strcmp(i11, HEAP32[i6 + (i2 * 24 | 0) >> 2] | 0) | 0)) if (!(_strcmp(i12, HEAP32[i6 + (i2 * 24 | 0) + 8 >> 2] | 0) | 0)) if ((i13 | 0) == (HEAP32[i6 + (i2 * 24 | 0) + 12 >> 2] | 0)) break;
   i31 = i3 + 1 | 0;
   i3 = i31;
   i2 = i31 + i2 | 0;
  }
  i31 = i6 + (i2 * 24 | 0) | 0;
  HEAP32[i31 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i31 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i31 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
  HEAP32[i17 >> 2] = i1 + 24;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i26);
  i31 = (HEAP32[i15 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i27 >> 2] = i25;
  HEAP32[i18 >> 2] = i31;
  HEAP32[i19 >> 2] = i31;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i27);
  i1 = HEAP32[i17 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i18 >> 2] | 0));
 STACKTOP = i30;
 return;
}

function __ZL25computeMassAndDiagInertiaRN5physx3Ext21InertiaTensorComputerERNS_6PxVec3ERNS_6PxQuatERfS4_bRKNS_11PxRigidBodyEPKc(i5, i12, i15, i14, i4, i6, i10, i13) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i3 = i18 + 172 | 0;
 i1 = i18 + 160 | 0;
 i7 = i18 + 148 | 0;
 i2 = i18 + 112 | 0;
 i11 = i18 + 88 | 0;
 i16 = i18 + 56 | 0;
 i8 = i18 + 32 | 0;
 i9 = i18 + 4 | 0;
 if (i6) {
  f21 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
  f20 = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
  f19 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
  HEAPF32[i1 >> 2] = f21;
  HEAPF32[i1 + 4 >> 2] = f20;
  HEAPF32[i1 + 8 >> 2] = f19;
  __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i5, i1);
 } else {
  i1 = i5 + 40 | 0;
  i23 = HEAP32[i1 >> 2] | 0;
  i6 = i5 + 44 | 0;
  i22 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + 36 >> 2];
  HEAP32[i4 + 4 >> 2] = i23;
  HEAP32[i4 + 8 >> 2] = i22;
  f19 = Math_fround(-Math_fround(HEAPF32[i5 + 36 >> 2]));
  f20 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  f21 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i3 >> 2] = f19;
  HEAPF32[i3 + 4 >> 2] = f20;
  HEAPF32[i3 + 8 >> 2] = f21;
  __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i5, i3);
 }
 HEAP32[i14 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i5 + 32 >> 2];
 __ZN5physx13PxDiagonalizeERKNS_7PxMat33ERNS_6PxQuatE(i7, i2, i15);
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 i22 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i12 + 4 | 0;
 HEAP32[i2 >> 2] = i22;
 i23 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = i12 + 8 | 0;
 HEAP32[i1 >> 2] = i23;
 i7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 i22 = i7 & (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 if (i22 & (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) {
  STACKTOP = i18;
  return;
 }
 i23 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i17 >> 2] = i13;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i23, 2, gb + 659217 | 0, 69, gb + 659453 | 0, i17);
 mftCall_viif(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i11 | 0, i10 | 0, 1.00999999);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i10 | 0);
 f28 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f29 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f28 = Math_fround(f28 * Math_fround(-2.0));
 f29 = Math_fround(f29 * Math_fround(-2.0));
 f31 = Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) * Math_fround(-2.0));
 f24 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f30 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i16 >> 2]);
 f26 = Math_fround(f28 * f27);
 f19 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f29 * f19));
 f21 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f31 * f21));
 f20 = Math_fround(Math_fround(f27 * f26) + Math_fround(Math_fround(f28 * f30) - Math_fround(f24 * Math_fround(Math_fround(f31 * f19) - Math_fround(f29 * f21)))));
 f25 = Math_fround(Math_fround(f19 * f26) + Math_fround(Math_fround(f29 * f30) - Math_fround(f24 * Math_fround(Math_fround(f28 * f21) - Math_fround(f31 * f27)))));
 f26 = Math_fround(Math_fround(Math_fround(f31 * f30) - Math_fround(f24 * Math_fround(Math_fround(f29 * f27) - Math_fround(f28 * f19)))) + Math_fround(f21 * f26));
 f19 = Math_fround(-f19);
 f21 = Math_fround(-f21);
 HEAPF32[i9 >> 2] = Math_fround(-f27);
 HEAPF32[i9 + 4 >> 2] = f19;
 HEAPF32[i9 + 8 >> 2] = f21;
 HEAPF32[i9 + 12 >> 2] = f24;
 HEAPF32[i9 + 16 >> 2] = f20;
 HEAPF32[i9 + 20 >> 2] = f25;
 HEAPF32[i9 + 24 >> 2] = f26;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i8, i9, i11);
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i13;
 i17 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i17;
 i23 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 + 8 >> 2] = i23;
 i10 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i11 + 12 >> 2] = i10;
 i16 = HEAP32[i8 + 16 >> 2] | 0;
 HEAP32[i11 + 16 >> 2] = i16;
 i22 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i11 + 20 >> 2] = i22;
 f26 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f26 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f25 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f25 - (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f26 * Math_fround(.5));
 f25 = Math_fround(f25 * Math_fround(.5));
 f20 = Math_fround(Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
 i23 = f26 != Math_fround(0.0);
 f24 = i23 ? f26 : Math_fround(1.0);
 i23 = f25 != Math_fround(0.0);
 f21 = Math_fround(f25 * f24);
 f24 = i23 ? f21 : f24;
 i23 = f20 != Math_fround(0.0);
 f21 = Math_fround(f20 * f24);
 f24 = Math_fround((i23 ? f21 : f24) * Math_fround(8.0));
 f21 = Math_fround(f24 * Math_fround(.333333343));
 f26 = Math_fround(f26 * f26);
 f25 = Math_fround(f25 * f25);
 f20 = Math_fround(f20 * f20);
 f19 = Math_fround(Math_fround(f25 + f20) * f21);
 f20 = Math_fround(Math_fround(f26 + f20) * f21);
 f21 = Math_fround(Math_fround(f26 + f25) * f21);
 f24 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) / f24);
 f20 = Math_fround(f24 * f20);
 f21 = Math_fround(f24 * f21);
 HEAPF32[i12 >> 2] = Math_fround(f24 * f19);
 HEAPF32[i2 >> 2] = f20;
 HEAPF32[i1 >> 2] = f21;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 1065353216;
 STACKTOP = i18;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue11ResetValuesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i9 = i10;
 HEAP8[i8 >> 0] = 1;
 i5 = i8 + 4 | 0;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 8 >> 2] = -2147483600;
 HEAP32[i9 + 4 >> 2] = 43;
 i1 = i6;
 i2 = gb + 1042433 | 0;
 i3 = i1 + 43 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 43 >> 0] = 0;
 i4 = i9 + 11 | 0;
 i2 = i5 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 < 0) {
  i1 = (HEAP32[i8 + 12 >> 2] & 2147483647) + -1 | 0;
  if (i1 >>> 0 < 43) {
   i2 = HEAP32[i8 + 8 >> 2] | 0;
   i3 = 8;
   break;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  _memmove(i5 | 0, i6 | 0, 43) | 0;
  HEAP8[i5 + 43 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i8 + 8 >> 2] = 43;
   i3 = 9;
   break;
  } else {
   HEAP8[i2 >> 0] = 43;
   i3 = 9;
   break;
  }
 } else {
  i1 = 10;
  i2 = i3 & 255;
  i3 = 8;
 } while (0);
 if ((i3 | 0) == 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i1, 43 - i1 | 0, i2, 0, i2, 43, i6);
  if ((HEAP8[i4 >> 0] | 0) < 0) i3 = 9;
 }
 if ((i3 | 0) == 9) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i5 = i8 + 20 | 0;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 8 >> 2] = -2147483600;
 HEAP32[i9 + 4 >> 2] = 39;
 i1 = i6;
 i2 = gb + 1042477 | 0;
 i3 = i1 + 39 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 39 >> 0] = 0;
 i4 = i9 + 11 | 0;
 i2 = i5 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 < 0) {
  i1 = (HEAP32[i8 + 28 >> 2] & 2147483647) + -1 | 0;
  if (i1 >>> 0 < 39) {
   i2 = HEAP32[i8 + 24 >> 2] | 0;
   i3 = 17;
   break;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  _memmove(i5 | 0, i6 | 0, 39) | 0;
  HEAP8[i5 + 39 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i8 + 24 >> 2] = 39;
   i3 = 18;
   break;
  } else {
   HEAP8[i2 >> 0] = 39;
   i3 = 18;
   break;
  }
 } else {
  i1 = 10;
  i2 = i3 & 255;
  i3 = 17;
 } while (0);
 if ((i3 | 0) == 17) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i1, 39 - i1 | 0, i2, 0, i2, 39, i6);
  if ((HEAP8[i4 >> 0] | 0) < 0) i3 = 18;
 }
 if ((i3 | 0) == 18) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i5 = i8 + 36 | 0;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 8 >> 2] = -2147483600;
 HEAP32[i9 + 4 >> 2] = 36;
 i1 = i6;
 i2 = gb + 1042517 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 36 >> 0] = 0;
 i4 = i9 + 11 | 0;
 i2 = i5 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 < 0) {
  i1 = (HEAP32[i8 + 44 >> 2] & 2147483647) + -1 | 0;
  if (i1 >>> 0 < 36) {
   i2 = HEAP32[i8 + 40 >> 2] | 0;
   i3 = 26;
   break;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  _memmove(i5 | 0, i6 | 0, 36) | 0;
  HEAP8[i5 + 36 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i8 + 40 >> 2] = 36;
   i3 = 27;
   break;
  } else {
   HEAP8[i2 >> 0] = 36;
   i3 = 27;
   break;
  }
 } else {
  i1 = 10;
  i2 = i3 & 255;
  i3 = 26;
 } while (0);
 if ((i3 | 0) == 26) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i1, 36 - i1 | 0, i2, 0, i2, 36, i6);
  if ((HEAP8[i4 >> 0] | 0) < 0) i3 = 27;
 }
 if ((i3 | 0) == 27) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 HEAP32[i8 + 52 >> 2] = -1;
 HEAP32[i8 + 56 >> 2] = 3600;
 HEAP32[i8 + 60 >> 2] = 1800;
 i1 = i8 + 64 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i8 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i6;
 if ((i3 | 0) == (i6 | 0)) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_(i1, i7, gb + 189452 | 0, gb + 189452 + 24 | 0) | 0;
  i9 = i8 + 80 | 0;
  HEAP32[i9 >> 2] = 300;
  i9 = i8 + 84 | 0;
  HEAP32[i9 >> 2] = 30;
  i9 = i8 + 88 | 0;
  HEAP32[i9 >> 2] = 1;
  i9 = i8 + 92 | 0;
  HEAP32[i9 >> 2] = 300;
  i9 = i8 + 96 | 0;
  HEAP32[i9 >> 2] = 2592e3;
  i9 = i8 + 100 | 0;
  HEAP32[i9 >> 2] = 20;
  i9 = i8 + 104 | 0;
  HEAP32[i9 >> 2] = 60;
  STACKTOP = i10;
  return;
 }
 HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i4 | 0) >>> 2) << 2);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_(i1, i7, gb + 189452 | 0, gb + 189452 + 24 | 0) | 0;
 i9 = i8 + 80 | 0;
 HEAP32[i9 >> 2] = 300;
 i9 = i8 + 84 | 0;
 HEAP32[i9 >> 2] = 30;
 i9 = i8 + 88 | 0;
 HEAP32[i9 >> 2] = 1;
 i9 = i8 + 92 | 0;
 HEAP32[i9 >> 2] = 300;
 i9 = i8 + 96 | 0;
 HEAP32[i9 >> 2] = 2592e3;
 i9 = i8 + 100 | 0;
 HEAP32[i9 >> 2] = 20;
 i9 = i8 + 104 | 0;
 HEAP32[i9 >> 2] = 60;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj690ES2_NS_23PxVehicleDriveSimDataNWES6_EEKNS_36PxVehicleDriveSimDataNWGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 2272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 1720 | 0;
 i14 = i20 + 1176 | 0;
 i19 = i20 + 16 | 0;
 i15 = i20 + 1120 | 0;
 i16 = i20;
 i18 = i20 + 32 | 0;
 i17 = i20 + 576 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i16;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i14 >> 0] = 0;
 i7 = i18;
 i5 = i14;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 HEAP32[i15 >> 2] = i1;
 HEAP32[i15 + 4 >> 2] = i2;
 i16 = i15 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i3;
 HEAP32[i15 + 24 >> 2] = i7;
 HEAP32[i15 + 28 >> 2] = i6;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj686ES3_RKNS_27PxVehicleDifferentialNWDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i21 + 64 | 0, 0);
 if (HEAP8[i14 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 i15 = HEAP32[i18 + 64 >> 2] | 0;
 i12 = i15 << 3;
 _memcpy(i17 | 0, i18 | 0, i12 | 0) | 0;
 HEAP32[i17 + 64 >> 2] = i15;
 i21 = i17 + 80 | 0;
 i16 = i18 + 80 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 i21 = i18 + 112 | 0;
 _memcpy(i17 + 112 | 0, i21 | 0, 416) | 0;
 i11 = i17 + 528 | 0;
 i19 = i18 + 528 | 0;
 HEAP32[i11 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 _memcpy(i14 | 0, i17 | 0, i12 | 0) | 0;
 HEAP32[i14 + 64 >> 2] = i15;
 i18 = i14 + 80 | 0;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 _memcpy(i14 + 112 | 0, i21 | 0, 416) | 0;
 i18 = i14 + 528 | 0;
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 i22 = HEAP32[i22 + 20 >> 2] | 0;
 _memcpy(i13 | 0, i14 | 0, i12 | 0) | 0;
 HEAP32[i13 + 64 >> 2] = i15;
 i18 = i13 + 80 | 0;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 _memcpy(i13 + 112 | 0, i21 | 0, 416) | 0;
 i21 = i13 + 528 | 0;
 HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 mftCall_vii(i22 | 0, i23 | 0, i13 | 0);
 STACKTOP = i20;
 return;
}

function __ZN16ParticleRenderer8TransferI14SafeBinaryReadEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i7, i10);
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i4 = i7 + 368 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048449 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 340 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048471 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 344 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048490 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 348 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048504 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048520 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i9 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i7 + 356 | 0;
 if (__ZN14SafeBinaryRead16IsCurrentVersionEv(i10) | 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048538 | 0, gb + 1048551 | 0, i8, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsIN16ParticleRenderer11UVAnimationEE8TransferI14SafeBinaryReadEEvRS1_RT_(i4, i10); else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  STACKTOP = i11;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048563 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i8 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 69; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 69; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 69) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 STACKTOP = i11;
 return;
}

function __Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i8, i9, i7, i17, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 64 | 0;
 i19 = i24 + 56 | 0;
 i18 = i24 + 40 | 0;
 i23 = i24 + 24 | 0;
 i16 = i24 + 16 | 0;
 i15 = i24;
 i21 = i24 + 112 | 0;
 i13 = i24 + 100 | 0;
 i14 = i24 + 88 | 0;
 i22 = i24 + 76 | 0;
 HEAP32[i17 + 28 >> 2] = 0;
 i10 = i17 + 16 | 0;
 if (HEAP32[i10 >> 2] & 176 | 0) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i5 = i17 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i17 + 12 | 0;
 L4 : do switch (HEAP32[i6 >> 2] | 0) {
 case 21:
  {
   if (__ZN9Scripting36IsSystemCollectionsGenericDictionaryEP11Il2CppClass(i1) | 0) {
    i23 = 0;
    STACKTOP = i24;
    return i23 | 0;
   } else i12 = 8;
   break;
  }
 case 18:
  {
   i2 = i11 + 268 | 0;
   i3 = i11 + 356 | 0;
   i4 = i11 + 264 | 0;
   if (!i1) i12 = 8; else {
    while (1) {
     i12 = (i1 | 0) == (HEAP32[(__Z19GetScriptingManagerv() | 0) + 56 >> 2] | 0);
     if (i12 | (i1 | 0) == (HEAP32[i2 >> 2] | 0) | (i1 | 0) == (HEAP32[i3 >> 2] | 0) | (i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
      i12 = 8;
      break L4;
     }
     if (__ZN9Scripting36IsSystemCollectionsGenericDictionaryEP11Il2CppClass(i1) | 0) {
      i1 = 0;
      break;
     }
     i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
     if (!i1) {
      i12 = 8;
      break L4;
     }
    }
    STACKTOP = i24;
    return i1 | 0;
   }
   break;
  }
 default:
  {}
 } while (0);
 if ((i12 | 0) == 8) if ((HEAP32[i6 >> 2] | 0) == 18) {
  i4 = __Z41scripting_type_get_class_or_element_classPK10Il2CppType(HEAP32[i17 + 8 >> 2] | 0) | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i4, HEAP32[(__Z19GetScriptingManagerv() | 0) + 92 >> 2] | 0) | 0) {
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  }
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (__Z26scripting_field_get_parentP9FieldInfo(HEAP32[i17 >> 2] | 0) | 0)) if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(HEAP32[i5 >> 2] | 0, HEAP32[i11 + 268 >> 2] | 0) | 0)) {
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  }
 }
 do if ((i7 | 0) > 7) {
  if ((HEAP32[i6 >> 2] | 0) != 18) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i1) | 0)) break;
  }
  i8 = i8 + 20 | 0;
  if (HEAP8[i8 >> 0] | 0) {
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  };
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i3 = i13 + 11 | 0;
  i4 = i14 + 11 | 0;
  i5 = i14 + 4 | 0;
  i1 = 8;
  i2 = i17;
  while (1) {
   i7 = __Z26scripting_field_get_parentP9FieldInfo(HEAP32[i2 >> 2] | 0) | 0;
   i6 = __Z29scripting_class_get_namespaceP11Il2CppClass(i7) | 0;
   i7 = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
   if (!i6) i12 = 21; else if (!(HEAP8[i6 >> 0] | 0)) i12 = 21; else {
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    HEAP32[i15 >> 2] = i6;
    HEAP32[i15 + 4 >> 2] = i7;
    HEAP32[i15 + 8 >> 2] = i11;
    __Z6FormatPKcz(i13, gb + 458204 | 0, i15);
   }
   if ((i12 | 0) == 21) {
    i12 = 0;
    i11 = HEAP32[i2 + 20 >> 2] | 0;
    HEAP32[i16 >> 2] = i7;
    HEAP32[i16 + 4 >> 2] = i11;
    __Z6FormatPKcz(i13, gb + 458214 | 0, i16);
   }
   i11 = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 4 >> 2] = i11;
   __Z6FormatPKcz(i14, gb + 458220 | 0, i23);
   i11 = HEAP8[i4 >> 0] | 0;
   i10 = i11 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i21, i10 ? HEAP32[i14 >> 2] | 0 : i14, i10 ? HEAP32[i5 >> 2] | 0 : i11 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i2 = HEAP32[i2 + 40 >> 2] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   if (!i2) break; else i1 = i1 + -1 | 0;
  }
  i1 = (__Z19GetScriptingManagerv() | 0) + 28 | 0;
  i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass(i1, __Z26scripting_field_get_parentP9FieldInfo(HEAP32[i17 >> 2] | 0) | 0) | 0;
  i3 = __Z26scripting_field_get_parentP9FieldInfo(HEAP32[i17 >> 2] | 0) | 0;
  i2 = __Z29scripting_class_get_namespaceP11Il2CppClass(i3) | 0;
  i3 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
  if (!i2) i12 = 26; else if (!(HEAP8[i2 >> 0] | 0)) i12 = 26; else {
   i19 = HEAP32[i17 + 20 >> 2] | 0;
   HEAP32[i18 >> 2] = i2;
   HEAP32[i18 + 4 >> 2] = i3;
   HEAP32[i18 + 8 >> 2] = i19;
   __Z6FormatPKcz(i22, gb + 458204 | 0, i18);
  }
  if ((i12 | 0) == 26) {
   i18 = HEAP32[i17 + 20 >> 2] | 0;
   HEAP32[i19 >> 2] = i3;
   HEAP32[i19 + 4 >> 2] = i18;
   __Z6FormatPKcz(i22, gb + 458214 | 0, i19);
  }
  i18 = (HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
  i19 = (HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21;
  HEAP32[i20 >> 2] = 7;
  HEAP32[i20 + 4 >> 2] = i18;
  HEAP32[i20 + 8 >> 2] = i19;
  __Z6FormatPKcz(i23, gb + 458228 | 0, i20);
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 458388 | 0, 84, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  HEAP8[i8 >> 0] = 1;
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 } while (0);
 if (_strchr(HEAP32[i17 + 20 >> 2] | 0, 46) | 0) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (__ZN9Scripting18IsFieldFlagsPublicEi(HEAP32[i10 >> 2] | 0) | 0) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (__Z29scripting_class_has_attributeP11Il2CppClassS0_(i9, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 384 >> 2] | 0) | 0) {
  i23 = 1;
  STACKTOP = i24;
  return i23 | 0;
 } else {
  i23 = __Z29scripting_field_has_attributeP11Il2CppClassP9FieldInfoS0_(i9, HEAP32[i17 >> 2] | 0, HEAP32[i11 + 380 >> 2] | 0) | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 return 0;
}

function __ZN5physx2Gu22intersectCapsuleConvexERKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i3, i5, i7, i8, i6, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, i32 = 0, i33 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i4 + 464 | 0;
 i29 = i4 + 448 | 0;
 i12 = i4 + 480 | 0;
 i28 = i4 + 80 | 0;
 i27 = i4 + 64 | 0;
 i9 = i4 + 240 | 0;
 i10 = i4 + 96 | 0;
 i1 = i4;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i32 = HEAP32[i8 + 4 >> 2] | 0;
 i33 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i28 + 4 >> 2] = i32;
 HEAP32[i28 + 8 >> 2] = i33;
 HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
 i33 = i8 + 12 | 0;
 i32 = HEAP32[i33 + 4 >> 2] | 0;
 i3 = HEAP32[i33 + 8 >> 2] | 0;
 i8 = HEAP32[i33 + 12 >> 2] | 0;
 HEAP32[i27 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i27 + 4 >> 2] = i32;
 HEAP32[i27 + 8 >> 2] = i3;
 HEAP32[i27 + 12 >> 2] = i8;
 f22 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f26 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
 f24 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f23 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i6 + 16 >> 2]));
 f15 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i6 + 20 >> 2]));
 f31 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f23 = Math_fround(f23 * Math_fround(2.0));
 f15 = Math_fround(f15 * Math_fround(2.0));
 f31 = Math_fround(Math_fround(f31 - Math_fround(HEAPF32[i6 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f15 * f26)) + Math_fround(f31 * f24));
 f16 = Math_fround(Math_fround(f17 * f22) + Math_fround(Math_fround(f20 * f23) + Math_fround(f14 * Math_fround(Math_fround(f31 * f26) - Math_fround(f15 * f24)))));
 f18 = Math_fround(Math_fround(f17 * f26) + Math_fround(Math_fround(f20 * f15) + Math_fround(f14 * Math_fround(Math_fround(f23 * f24) - Math_fround(f31 * f22)))));
 f17 = Math_fround(Math_fround(Math_fround(f20 * f31) + Math_fround(f14 * Math_fround(Math_fround(f15 * f22) - Math_fround(f23 * f26)))) + Math_fround(f17 * f24));
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f14 * f23);
 f31 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f31 * f22));
 f20 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f20 * f26));
 f25 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(f15 - Math_fround(f25 * f24));
 f13 = Math_fround(Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f31 * f26) + Math_fround(f14 * f25))) - Math_fround(f20 * f22));
 f30 = Math_fround(Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f31 * f24) + Math_fround(f14 * f20))) - Math_fround(f23 * f26));
 f24 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f31) - Math_fround(f23 * f22)) - Math_fround(f25 * f26)) - Math_fround(f20 * f24));
 f20 = Math_fround(f15 + f15);
 f26 = Math_fround(f13 + f13);
 f25 = Math_fround(f30 + f30);
 f22 = Math_fround(f13 * f26);
 f23 = Math_fround(f30 * f25);
 f13 = Math_fround(f20 * f13);
 f31 = Math_fround(f20 * f30);
 f14 = Math_fround(f20 * f24);
 f30 = Math_fround(f30 * f26);
 f26 = Math_fround(f24 * f26);
 f25 = Math_fround(f24 * f25);
 f20 = Math_fround(Math_fround(1.0) - Math_fround(f15 * f20));
 f15 = Math_fround(Math_fround(Math_fround(1.0) - f22) - f23);
 f24 = Math_fround(f13 + f25);
 f19 = Math_fround(f31 - f26);
 f25 = Math_fround(f13 - f25);
 f23 = Math_fround(f20 - f23);
 f13 = Math_fround(f14 + f30);
 f26 = Math_fround(f31 + f26);
 f14 = Math_fround(f30 - f14);
 f22 = Math_fround(f20 - f22);
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i9, i7 + 16 | 0, i29, i28, i27);
 f20 = Math_fround(f21 * Math_fround(0.0));
 f15 = Math_fround(Math_fround(f20 * f26) + Math_fround(Math_fround(f20 * f25) + Math_fround(f21 * f15)));
 f14 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(f20 * f23)) + Math_fround(f20 * f14));
 f13 = Math_fround(Math_fround(f20 * f22) + Math_fround(Math_fround(f21 * f19) + Math_fround(f20 * f13)));
 i8 = i10 + 64 | 0;
 HEAPF32[i10 >> 2] = f16;
 HEAPF32[i10 + 4 >> 2] = f18;
 HEAPF32[i10 + 8 >> 2] = f17;
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 80 >> 2] = 4;
 HEAPF32[i10 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 128 >> 2] = f2;
 i7 = i10 + 132 | 0;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 f20 = Math_fround(f18 + f14);
 f19 = Math_fround(f17 + f13);
 HEAPF32[i10 + 96 >> 2] = Math_fround(f16 + f15);
 HEAPF32[i10 + 100 >> 2] = f20;
 HEAPF32[i10 + 104 >> 2] = f19;
 HEAPF32[i10 + 108 >> 2] = Math_fround(0.0);
 f14 = Math_fround(f18 - f14);
 f13 = Math_fround(f17 - f13);
 HEAPF32[i10 + 112 >> 2] = Math_fround(f16 - f15);
 HEAPF32[i10 + 116 >> 2] = f14;
 HEAPF32[i10 + 120 >> 2] = f13;
 HEAPF32[i10 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 16 >> 2] = f2;
 i7 = i10 + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAPF32[i10 + 32 >> 2] = f2;
 i7 = i10 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i11 >> 2] = -1;
 HEAP32[i11 + 4 >> 2] = -1;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP32[i11 + 12 >> 2] = -1;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 if ((__ZN5physx2Gu8GJKLocalERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i10, i9, i4 + 48 | 0, i4 + 32 | 0, i4 + 16 | 0, i1) | 0) == 1) {
  i33 = 1;
  STACKTOP = i4;
  return i33 | 0;
 }
 f31 = Math_fround(f2 * f2);
 i33 = f31 >= Math_fround(HEAPF32[i1 >> 2]);
 STACKTOP = i4;
 return i33 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9copy_fromERKSL_j(i28, i29, i2) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31 + 12 | 0;
 i6 = i31 + 24 | 0;
 i30 = i31;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E5clearEv(i28);
 f1 = Math_fround(((HEAP32[i29 + 60 >> 2] | 0) - (HEAP32[i29 + 4 >> 2] | 0) | 0) >>> 0);
 i3 = 32;
 while (1) {
  if (i3 >>> 0 >= i2 >>> 0) {
   f4 = Math_fround(i3 >>> 0);
   f5 = Math_fround(f4 * Math_fround(.5));
   if (!(f1 >= f5)) break;
  }
  i3 = i3 << 1;
 }
 i26 = i28 + 56 | 0;
 if (i3 >>> 0 > (HEAP32[i26 >> 2] | 0) >>> 0) {
  HEAP8[i27 >> 0] = HEAP8[i6 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i28, i3, i27);
  HEAP32[i26 >> 2] = i3;
  HEAP32[i28 + 68 >> 2] = ~~f5 >>> 0;
  HEAP32[i28 + 64 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
  HEAP8[i28 + 72 >> 0] = 0;
 }
 i16 = i29 + 52 | 0;
 i19 = HEAP32[i16 >> 2] | 0;
 i17 = i29 + 56 | 0;
 i2 = i19 + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i27 >> 2] = i29;
 i18 = i27 + 4 | 0;
 HEAP32[i18 >> 2] = i19;
 HEAP32[i27 + 8 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i27);
 i2 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i30 >> 2] = i29;
 i19 = i30 + 4 | 0;
 HEAP32[i19 >> 2] = i2;
 i20 = i30 + 8 | 0;
 HEAP32[i20 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i30);
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i19 >> 2] | 0)) {
  STACKTOP = i31;
  return;
 }
 i21 = i28 + 32 | 0;
 i22 = i28 + 52 | 0;
 i23 = i21 + 11 | 0;
 i24 = i28 + 36 | 0;
 i25 = i28 + 60 | 0;
 do {
  i15 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
  i3 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  i7 = HEAP8[i3 >> 0] | 0;
  if (!(i7 << 24 >> 24)) i6 = 5381; else {
   i6 = 5381;
   do {
    i3 = i3 + 1 | 0;
    i6 = i6 * 33 ^ i7 << 24 >> 24;
    i7 = HEAP8[i3 >> 0] | 0;
   } while (i7 << 24 >> 24 != 0);
  }
  i14 = HEAP32[i22 >> 2] | 0;
  i11 = HEAP8[i23 >> 0] | 0;
  i8 = i11 << 24 >> 24 < 0;
  i11 = i11 & 255;
  i13 = i8 ? HEAP32[i24 >> 2] | 0 : i11;
  i12 = HEAP32[i21 >> 2] | 0;
  i9 = i8 ? i12 : i21;
  i10 = (i13 | 0) == 0;
  i12 = i12 & 255;
  L19 : do if (i8) {
   i8 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 20 | 0) | 0;
    i12 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i12 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i12 & 255) | 0)) {
     if (i10) break L19;
     if (!(_memcmp(i9, i7 ? HEAP32[i6 >> 2] | 0 : i6, i13) | 0)) break L19;
    }
    i6 = i8 + 1 | 0;
    i8 = i6;
    i6 = i6 + i3 | 0;
   }
  } else {
   if (i10) {
    i3 = i6 & i15;
    i13 = HEAP8[i14 + (i3 * 20 | 0) + 11 >> 0] | 0;
    if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break; else i6 = 0;
    while (1) {
     i6 = i6 + 1 | 0;
     i3 = i6 + i3 & i15;
     i13 = HEAP8[i14 + (i3 * 20 | 0) + 11 >> 0] | 0;
     if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break L19;
    }
   } else i9 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 20 | 0) | 0;
    i10 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i10 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
     i6 = i7 ? HEAP32[i6 >> 2] | 0 : i6;
     if (i12 << 24 >> 24 == (HEAP8[i6 >> 0] | 0)) {
      i7 = i21;
      i8 = i11;
      do {
       i8 = i8 + -1 | 0;
       i7 = i7 + 1 | 0;
       if (!i8) break L19;
       i6 = i6 + 1 | 0;
      } while ((HEAP8[i7 >> 0] | 0) == (HEAP8[i6 >> 0] | 0));
     }
    }
    i6 = i9 + 1 | 0;
    i9 = i6;
    i6 = i6 + i3 | 0;
   }
  } while (0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i28, i14 + (i3 * 20 | 0) | 0, i2);
  HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 20;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i27);
  i15 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i30 >> 2] = i29;
  HEAP32[i19 >> 2] = i15;
  HEAP32[i20 >> 2] = i15;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i30);
  i2 = HEAP32[i18 >> 2] | 0;
 } while ((i2 | 0) != (HEAP32[i19 >> 2] | 0));
 STACKTOP = i31;
 return;
}

function __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8, i7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 16 | 0, i7 + 1 | 0);
 i2 = i8 + 32 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 48 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 64 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj66ENS_22PxRepXPropertyAccessorILj66ES4_NS_28PxArticulationJointDriveType4EnumESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj67ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 80 | 0, i7 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj68ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 96 | 0, i7 + 6 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj69ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 112 | 0, i7 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj70ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 128 | 0, i7 + 8 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i6, i8 + 144 | 0, i7 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj72ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 168 | 0, i7 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj73ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 184 | 0, i7 + 11 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj74ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 200 | 0, i7 + 12 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj75ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 216 | 0, i7 + 13 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i6, i8 + 232 | 0, i7 + 14 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj77ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 256 | 0, i7 + 15 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj78ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 272 | 0, i7 + 16 | 0);
 STACKTOP = i9;
 return i7 + 18 | 0;
}

function __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj(i15, i18, i17, i19) {
 i15 = i15 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i29 + 124 | 0;
 i12 = i29 + 128 | 0;
 i16 = i29 + 44 | 0;
 i28 = i29 + 48 | 0;
 i20 = i29;
 HEAP32[i16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0) | 0;
 i21 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i28 >> 2] = gb + 142044 + 8;
 i23 = i28 + 4 | 0;
 HEAP32[i23 >> 2] = i21;
 i21 = i28 + 8 | 0;
 HEAP32[i21 >> 2] = i23;
 HEAP32[i28 + 12 >> 2] = i23;
 i26 = i28 + 16 | 0;
 HEAP32[i26 >> 2] = 0;
 i22 = i28 + 20 | 0;
 HEAP32[i22 >> 2] = 0;
 i27 = i28 + 24 | 0;
 HEAP32[i27 >> 2] = 0;
 i13 = i28 + 28 | 0;
 HEAP32[i13 >> 2] = i23;
 i23 = i28 + 32 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAPF32[i28 + 56 >> 2] = Math_fround(.75);
 i24 = i28 + 60 | 0;
 HEAP32[i24 >> 2] = -1;
 HEAP32[i28 + 64 >> 2] = 0;
 i25 = i28 + 68 | 0;
 HEAP32[i25 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i13, 64);
 HEAP32[i28 + 72 >> 2] = 32;
 HEAP32[i20 >> 2] = i16;
 i16 = i20 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAPF32[i20 + 28 >> 2] = Math_fround(.75);
 HEAP32[i20 + 32 >> 2] = -1;
 HEAP32[i20 + 36 >> 2] = 0;
 HEAP32[i20 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj(i20, 64);
 if (i19 | 0) {
  i7 = i20 + 24 | 0;
  i8 = i20 + 16 | 0;
  i9 = i20 + 8 | 0;
  i10 = i20 + 12 | 0;
  i11 = i28 + 8 | 0;
  i13 = 0;
  do {
   i4 = i17 + (i13 << 3) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = i1;
   L5 : while (1) {
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
    switch (i3 << 24 >> 24) {
    case 46:
    case 0:
     break L5;
    default:
     {}
    }
   }
   L7 : while (1) {
    switch (i3 << 24 >> 24) {
    case 46:
     {
      i14 = 7;
      break L7;
     }
    case 0:
     break L7;
    default:
     {}
    }
    i5 = i2 + 1 | 0;
    i3 = HEAP8[i5 >> 0] | 0;
    i2 = i5;
   }
   L10 : do if ((i14 | 0) == 7) {
    i14 = 0;
    i3 = i2 - i1 | 0;
    i2 = i3 + 1 | 0;
    if (!i2) i5 = 0; else {
     i5 = __ZN5physx19CVariableMemoryPool8allocateEj(i11, i2) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    _memcpy(i5 | 0, i1 | 0, i3 | 0) | 0;
    HEAP8[i5 + i3 >> 0] = 0;
    i4 = HEAP32[i7 >> 2] | 0;
    L15 : do if (i4 | 0) {
     i1 = HEAP8[i5 >> 0] | 0;
     if (!(i1 << 24 >> 24)) i1 = 5381; else {
      i2 = 5381;
      i3 = i5;
      do {
       i2 = i2 * 33 ^ i1 << 24 >> 24;
       i3 = i3 + 1 | 0;
       i1 = HEAP8[i3 >> 0] | 0;
      } while (i1 << 24 >> 24 != 0);
      i1 = i2;
     }
     i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
     if ((i1 | 0) != -1) {
      i3 = HEAP32[i9 >> 2] | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i2 = i1;
      while (1) {
       i1 = i3 + (i2 << 3) | 0;
       if (!(_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0)) break;
       i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
       if ((i2 | 0) == -1) break L15;
      }
      if (i1 | 0) {
       if (!i5) break L10;
       __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj(i11, i5 + -8 | 0, HEAP32[i5 + -4 >> 2] | 0);
       break L10;
      }
     }
    } while (0);
    HEAP32[i6 >> 2] = i5;
    i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb(i20, i6, i12) | 0;
    if (!(HEAP8[i12 >> 0] | 0)) {
     HEAP32[i1 >> 2] = i5;
     HEAP32[i1 + 4 >> 2] = i13;
    }
   } while (0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i19 | 0));
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 32 >> 2] | 0, i15 | 0) | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN5physx2Sn29setMissingPropertiesToDefaultEPNS0_7XmlNodeERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEjRNS_7profile14ProfileHashMapIPKcjNS_6shdfnd4HashISB_EEEE(HEAP32[i1 + 16 >> 2] | 0, i18, i17, i19, i20);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i16 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
 }
 HEAP32[i28 >> 2] = gb + 142044 + 8;
 i1 = HEAP32[i26 >> 2] | 0;
 i20 = HEAP32[i22 >> 2] | 0;
 i2 = i1 + (i20 << 2) | 0;
 if (i20 | 0) do {
  i20 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i22 >> 2] = 0;
 i1 = HEAP32[i28 + 52 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i25 >> 2] | 0) == 0)) {
  _memset(HEAP32[i28 + 44 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i28 + 48 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i28 + 40 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i25 >> 2] = 0;
 }
 i1 = HEAP32[i23 >> 2] | 0;
 if (i1 | 0) {
  i25 = HEAP32[HEAP32[i28 + 28 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 }
 i27 = HEAP32[i27 >> 2] | 0;
 if (!((i27 | 0) > -1 & (i27 & 2147483647 | 0) != 0)) {
  STACKTOP = i29;
  return;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 if (!i1) {
  STACKTOP = i29;
  return;
 }
 i28 = HEAP32[HEAP32[i28 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
 STACKTOP = i29;
 return;
}

function __Z10WritePixelPhRK10ColorRGBAf13TextureFormat(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 do switch (i6 | 0) {
 case 1e3:
 case 5:
 case 14:
 case 4:
 case 8:
 case 3:
  {
   f14 = Math_fround(HEAPF32[i2 >> 2]);
   i13 = f14 < Math_fround(0.0);
   i12 = f14 > Math_fround(1.0);
   i12 = ~~Math_fround(Math_fround((i12 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   i11 = f14 < Math_fround(0.0);
   i10 = f14 > Math_fround(1.0);
   i10 = ~~Math_fround(Math_fround((i10 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i9 = f14 < Math_fround(0.0);
   i3 = f14 > Math_fround(1.0);
   i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   f14 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   i4 = f14 < Math_fround(0.0);
   i5 = f14 > Math_fround(1.0);
   i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   HEAP8[i1 >> 0] = i13 ? 0 : i12;
   HEAP8[i1 + 1 >> 0] = i11 ? 0 : i10;
   HEAP8[i1 + 2 >> 0] = i9 ? 0 : i3;
   HEAP8[i1 + 3 >> 0] = i4 ? 0 : i5;
   __Z10WritePixelPhRK11ColorRGBA3213TextureFormat(i7, i1, i6);
   STACKTOP = i8;
   return;
  }
 case 2:
 case 13:
  {
   f14 = Math_fround(HEAPF32[i2 >> 2]);
   i13 = f14 < Math_fround(0.0);
   i3 = f14 > Math_fround(1.0);
   i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f14) * Math_fround(15.0)) + Math_fround(.5)) >>> 0;
   i3 = i13 ? 0 : i3;
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   i13 = f14 < Math_fround(0.0);
   i4 = f14 > Math_fround(1.0);
   i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f14) * Math_fround(15.0)) + Math_fround(.5)) >>> 0;
   i4 = i13 ? 0 : i4;
   f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i13 = f14 < Math_fround(0.0);
   i5 = f14 > Math_fround(1.0);
   i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f14) * Math_fround(15.0)) + Math_fround(.5)) >>> 0;
   i5 = i13 ? 0 : i5;
   f14 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   i13 = f14 < Math_fround(0.0);
   i1 = f14 > Math_fround(1.0);
   i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f14) * Math_fround(15.0)) + Math_fround(.5)) >>> 0;
   i1 = i13 ? 0 : i1;
   if ((i6 | 0) == 13) i1 = i4 << 8 & 16776960 | i3 << 12 & 268431360 | i5 << 4 & 1048560 | i1 & 65535; else i1 = i4 << 4 | i3 << 8 | i5 | i1 << 12;
   HEAP16[i7 >> 1] = i1;
   STACKTOP = i8;
   return;
  }
 case 7:
  {
   f14 = Math_fround(HEAPF32[i2 >> 2]);
   i10 = f14 < Math_fround(0.0);
   i11 = f14 > Math_fround(1.0);
   i11 = ~~Math_fround(Math_fround((i11 ? Math_fround(1.0) : f14) * Math_fround(31.0)) + Math_fround(.5)) >>> 0;
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   i6 = f14 < Math_fround(0.0);
   i9 = f14 > Math_fround(1.0);
   i9 = ~~Math_fround(Math_fround((i9 ? Math_fround(1.0) : f14) * Math_fround(63.0)) + Math_fround(.5)) >>> 0;
   f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i12 = f14 < Math_fround(0.0);
   i13 = f14 > Math_fround(1.0);
   i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f14) * Math_fround(31.0)) + Math_fround(.5)) >>> 0;
   HEAP16[i7 >> 1] = (i6 ? 0 : i9 << 5) | (i10 ? 0 : i11 << 11) | (i12 ? 0 : i13);
   STACKTOP = i8;
   return;
  }
 case 1:
  {
   f14 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   i12 = f14 < Math_fround(0.0);
   i13 = f14 > Math_fround(1.0);
   i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   HEAP8[i7 >> 0] = i12 ? 0 : i13;
   STACKTOP = i8;
   return;
  }
 case 15:
  {
   i12 = HEAP32[i2 >> 2] | 0;
   i13 = i12 >>> 23 & 255;
   HEAP16[i7 >> 1] = HEAPU16[gb + 1477124 + (i13 << 1) >> 1] | 0 | i12 >>> 16 & 32768 | (i12 & 8388607) >>> (HEAPU8[gb + 1546331 + i13 >> 0] | 0);
   STACKTOP = i8;
   return;
  }
 case 16:
  {
   i13 = HEAP32[i2 >> 2] | 0;
   i12 = i13 >>> 23 & 255;
   HEAP16[i7 >> 1] = HEAPU16[gb + 1477124 + (i12 << 1) >> 1] | 0 | i13 >>> 16 & 32768 | (i13 & 8388607) >>> (HEAPU8[gb + 1546331 + i12 >> 0] | 0);
   i12 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = i12 >>> 23 & 255;
   HEAP16[i7 + 2 >> 1] = HEAPU16[gb + 1477124 + (i13 << 1) >> 1] | 0 | i12 >>> 16 & 32768 | (i12 & 8388607) >>> (HEAPU8[gb + 1546331 + i13 >> 0] | 0);
   STACKTOP = i8;
   return;
  }
 case 17:
  {
   i13 = HEAP32[i2 >> 2] | 0;
   i12 = i13 >>> 23 & 255;
   HEAP16[i7 >> 1] = HEAPU16[gb + 1477124 + (i12 << 1) >> 1] | 0 | i13 >>> 16 & 32768 | (i13 & 8388607) >>> (HEAPU8[gb + 1546331 + i12 >> 0] | 0);
   i12 = HEAP32[i2 + 4 >> 2] | 0;
   i13 = i12 >>> 23 & 255;
   HEAP16[i7 + 2 >> 1] = HEAPU16[gb + 1477124 + (i13 << 1) >> 1] | 0 | i12 >>> 16 & 32768 | (i12 & 8388607) >>> (HEAPU8[gb + 1546331 + i13 >> 0] | 0);
   i13 = HEAP32[i2 + 8 >> 2] | 0;
   i12 = i13 >>> 23 & 255;
   HEAP16[i7 + 4 >> 1] = HEAPU16[gb + 1477124 + (i12 << 1) >> 1] | 0 | i13 >>> 16 & 32768 | (i13 & 8388607) >>> (HEAPU8[gb + 1546331 + i12 >> 0] | 0);
   i12 = HEAP32[i2 + 12 >> 2] | 0;
   i13 = i12 >>> 23 & 255;
   HEAP16[i7 + 6 >> 1] = HEAPU16[gb + 1477124 + (i13 << 1) >> 1] | 0 | i12 >>> 16 & 32768 | (i12 & 8388607) >>> (HEAPU8[gb + 1546331 + i13 >> 0] | 0);
   STACKTOP = i8;
   return;
  }
 case 18:
  {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   STACKTOP = i8;
   return;
  }
 case 19:
  {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   STACKTOP = i8;
   return;
  }
 case 23:
  {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   STACKTOP = i8;
   return;
  }
 case 20:
  {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   STACKTOP = i8;
   return;
  }
 case 6:
  {
   HEAP32[i7 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 8 >> 2];
   STACKTOP = i8;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 404494 | 0, 1406, 1, 0, 0, 0);
   STACKTOP = i8;
   return;
  }
 } while (0);
}

function __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj(i33, i32, i2, i1, i6, i34) {
 i33 = i33 | 0;
 i32 = i32 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i34 = i34 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i35 = 0, i36 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i35;
 i36 = HEAP32[i33 + 16 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i36 >> 2]);
 f27 = Math_fround(HEAPF32[i36 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i36 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f29 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(f18 - f29);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f25 = Math_fround(f17 - f30);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(f5 - f23);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f21 = Math_fround(f3 - f29);
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f22 = Math_fround(f4 - f30);
 f15 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f19 = Math_fround(f15 - f23);
 f14 = Math_fround(f26 - f29);
 f16 = Math_fround(f27 - f30);
 f8 = Math_fround(f28 - f23);
 f7 = Math_fround(Math_fround(Math_fround(f24 * f14) + Math_fround(f25 * f16)) + Math_fround(f20 * f8));
 f8 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f16 * f22)) + Math_fround(f8 * f19));
 do if (f7 <= Math_fround(0.0) & f8 <= Math_fround(0.0)) {
  f5 = f23;
  f4 = f30;
  f3 = f29;
  i6 = 0;
 } else {
  f14 = Math_fround(f26 - f18);
  f16 = Math_fround(f27 - f17);
  f10 = Math_fround(f28 - f5);
  f9 = Math_fround(Math_fround(Math_fround(f14 * f24) + Math_fround(f16 * f25)) + Math_fround(f10 * f20));
  f10 = Math_fround(Math_fround(Math_fround(f14 * f21) + Math_fround(f16 * f22)) + Math_fround(f10 * f19));
  if (!(f9 >= Math_fround(0.0)) | !(f10 <= f9)) {
   f16 = Math_fround(Math_fround(f7 * f10) - Math_fround(f9 * f8));
   if (f9 <= Math_fround(0.0) & (f7 >= Math_fround(0.0) & f16 <= Math_fround(0.0))) {
    f3 = Math_fround(f7 / Math_fround(f7 - f9));
    f5 = Math_fround(f23 + Math_fround(f20 * f3));
    f4 = Math_fround(f30 + Math_fround(f25 * f3));
    f3 = Math_fround(f29 + Math_fround(f24 * f3));
    i6 = 3;
    break;
   }
   f11 = Math_fround(f26 - f3);
   f14 = Math_fround(f27 - f4);
   f13 = Math_fround(f28 - f15);
   f12 = Math_fround(Math_fround(Math_fround(f24 * f11) + Math_fround(f25 * f14)) + Math_fround(f20 * f13));
   f13 = Math_fround(Math_fround(Math_fround(f21 * f11) + Math_fround(f22 * f14)) + Math_fround(f19 * f13));
   if (!(f13 >= Math_fround(0.0)) | !(f12 <= f13)) {
    f14 = Math_fround(Math_fround(f12 * f8) - Math_fround(f7 * f13));
    if (f13 <= Math_fround(0.0) & (f8 >= Math_fround(0.0) & f14 <= Math_fround(0.0))) {
     f3 = Math_fround(f8 / Math_fround(f8 - f13));
     f5 = Math_fround(f23 + Math_fround(f19 * f3));
     f4 = Math_fround(f30 + Math_fround(f22 * f3));
     f3 = Math_fround(f29 + Math_fround(f21 * f3));
     i6 = 5;
     break;
    }
    f11 = Math_fround(Math_fround(f9 * f13) - Math_fround(f12 * f10));
    if (f11 <= Math_fround(0.0)) {
     f8 = Math_fround(f10 - f9);
     if (f8 >= Math_fround(0.0)) {
      f7 = Math_fround(f12 - f13);
      if (f7 >= Math_fround(0.0)) {
       f16 = Math_fround(f8 / Math_fround(f8 + f7));
       f5 = Math_fround(f5 + Math_fround(Math_fround(f15 - f5) * f16));
       f4 = Math_fround(f17 + Math_fround(Math_fround(f4 - f17) * f16));
       f3 = Math_fround(f18 + Math_fround(Math_fround(f3 - f18) * f16));
       i6 = 4;
       break;
      }
     }
    }
    f18 = Math_fround(Math_fround(1.0) / Math_fround(f16 + Math_fround(f11 + f14)));
    f3 = Math_fround(f14 * f18);
    f18 = Math_fround(f16 * f18);
    f5 = Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f20 * f3) + f23));
    f4 = Math_fround(Math_fround(f22 * f18) + Math_fround(f30 + Math_fround(f25 * f3)));
    f3 = Math_fround(Math_fround(f21 * f18) + Math_fround(f29 + Math_fround(f24 * f3)));
    i6 = 6;
   } else {
    f5 = f15;
    i6 = 2;
   }
  } else {
   f4 = f17;
   f3 = f18;
   i6 = 1;
  }
 } while (0);
 f7 = Math_fround(f3 - f26);
 f8 = Math_fround(f4 - f27);
 f9 = Math_fround(f5 - f28);
 f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
 if (f10 >= Math_fround(HEAPF32[i33 + 20 >> 2])) {
  STACKTOP = i35;
  return;
 }
 f5 = Math_fround(Math_fround(f25 * f19) - Math_fround(f20 * f22));
 f4 = Math_fround(Math_fround(f20 * f21) - Math_fround(f24 * f19));
 f3 = Math_fround(Math_fround(f24 * f22) - Math_fround(f25 * f21));
 if (Math_fround(Math_fround(f28 * f3) + Math_fround(Math_fround(f26 * f5) + Math_fround(f27 * f4))) < Math_fround(Math_fround(f23 * f3) + Math_fround(Math_fround(f29 * f5) + Math_fround(f30 * f4)))) {
  STACKTOP = i35;
  return;
 }
 i36 = f10 > Math_fround(.0000999999974);
 f5 = i36 ? f7 : f5;
 f4 = i36 ? f8 : f4;
 f3 = i36 ? f9 : f3;
 HEAPF32[i31 >> 2] = f5;
 HEAPF32[i31 + 4 >> 2] = f4;
 HEAPF32[i31 + 8 >> 2] = f3;
 if ((i6 | 0) == 6) {
  __ZN12_GLOBAL__N_127SphereMeshContactGeneration10addContactERKN5physx6PxVec3Efj(i33, i31, f10, i32);
  i1 = i33 + 2588 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 >= 64) {
   STACKTOP = i35;
   return;
  }
  i31 = HEAP32[i34 >> 2] | 0;
  i32 = HEAP32[i34 + 4 >> 2] | 0;
  i36 = HEAP32[i34 + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = i2 + 1;
  HEAP32[i33 + 2592 + (i2 * 12 | 0) >> 2] = i31;
  HEAP32[i33 + 2592 + (i2 * 12 | 0) + 4 >> 2] = i32;
  HEAP32[i33 + 2592 + (i2 * 12 | 0) + 8 >> 2] = i36;
  STACKTOP = i35;
  return;
 } else {
  i1 = i33 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 >= 64) {
   STACKTOP = i35;
   return;
  }
  HEAP32[i1 >> 2] = i2 + 1;
  HEAPF32[i33 + 2076 + (i2 << 3) >> 2] = f10;
  HEAP32[i33 + 2076 + (i2 << 3) + 4 >> 2] = i2;
  HEAPF32[i33 + 28 + (i2 << 5) >> 2] = f5;
  HEAPF32[i33 + 28 + (i2 << 5) + 4 >> 2] = f4;
  HEAPF32[i33 + 28 + (i2 << 5) + 8 >> 2] = f3;
  HEAP32[i33 + 28 + (i2 << 5) + 20 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i33 + 28 + (i2 << 5) + 24 >> 2] = HEAP32[i34 + 4 >> 2];
  HEAP32[i33 + 28 + (i2 << 5) + 28 >> 2] = HEAP32[i34 + 8 >> 2];
  HEAP32[i33 + 28 + (i2 << 5) + 12 >> 2] = i6;
  HEAP32[i33 + 28 + (i2 << 5) + 16 >> 2] = i32;
  STACKTOP = i35;
  return;
 }
}

function __ZN24b2ChainAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i4, i10, i12, i13) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 24 | 0;
 i15 = i19;
 i9 = HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i11 = (HEAP32[i7 + 176 >> 2] | 0) == 0;
 HEAP32[i14 >> 2] = gb + 151728 + 8;
 HEAP32[i14 + 4 >> 2] = 2;
 i8 = i14 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 151644 >> 2];
 HEAP32[i14 + 148 >> 2] = 0;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i8 >> 2] = HEAP32[i9 + 8 >> 2];
 i8 = HEAP32[i4 + 56 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i14, i9 + (i8 << 3) | 0, i9 + (i8 + 1 << 3) | 0);
 i8 = i7 + 12 | 0;
 i9 = i7 + 20 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i9 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i9 + 4 >> 2]));
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3))));
 if (f2 < Math_fround(1.1920929e-07)) {
  f18 = f1;
  f17 = f3;
 } else {
  f17 = Math_fround(Math_fround(1.0) / f2);
  f18 = Math_fround(f1 * f17);
  f17 = Math_fround(f3 * f17);
 }
 do if (i11) i6 = i10 + 60 | 0; else {
  __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i10, i14, i12, i7 + 28 | 0, i13);
  i6 = i10 + 60 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = HEAP32[i10 + 40 >> 2] | 0;
   i4 = HEAP32[i10 + 44 >> 2] | 0;
   if ((HEAP32[i10 + 56 >> 2] | 0) == 1) {
    f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
    f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f21 * f20);
    f3 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f1 - Math_fround(f2 * f3));
    f3 = Math_fround(Math_fround(f2 * f20) + Math_fround(f21 * f3));
    f21 = Math_fround(HEAPF32[i13 + 12 >> 2]);
    f20 = Math_fround(f21 * f1);
    f2 = Math_fround(HEAPF32[i13 + 8 >> 2]);
    f20 = Math_fround(f20 + Math_fround(f2 * f3));
    f2 = Math_fround(Math_fround(f21 * f3) - Math_fround(f1 * f2));
    f1 = Math_fround(-f20);
    f3 = Math_fround(-f2);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(f2 * f2))));
    if (f2 < Math_fround(1.1920929e-07)) i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0); else {
     f21 = Math_fround(Math_fround(1.0) / f2);
     f20 = Math_fround(f21 * f1);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
     f21 = Math_fround(f21 * f3);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
    }
   }
   f21 = Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f21 = Math_fround(Math_fround(f18 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f21);
   if (!(f21 >= Math_fround(.99999988) | f21 <= Math_fround(-.99999988))) {
    HEAP32[i6 >> 2] = 0;
    break;
   }
   HEAP32[i10 + 68 >> 2] = HEAP32[gb + 151644 >> 2];
   STACKTOP = i19;
   return;
  }
 } while (0);
 HEAP32[i15 >> 2] = gb + 151824 + 8;
 i4 = i15 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i4 = i15 + 12 | 0;
 i5 = i8;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i10, i14, i12, i15, i13, 0);
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  if (!i11) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i10 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i10 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(f18 * f2) + Math_fround(f17 * f1)) >= Math_fround(0.0))) {
    HEAP32[i6 >> 2] = 0;
    i16 = 18;
   }
  }
 } else i16 = 18;
 if ((i16 | 0) == 18) if (!i11) {
  i11 = HEAP32[i9 + 4 >> 2] | 0;
  i16 = i4;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = i11;
  __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i10, i14, i12, i15, i13, 0);
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i10 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i10 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(-Math_fround(f17 * f1)) - Math_fround(f18 * f2)) >= Math_fround(0.0))) HEAP32[i6 >> 2] = 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i13, i15, i20, i4, i1, i3, i2, i5) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 216 | 0;
 i12 = i21;
 i17 = i21 + 8 | 0;
 i10 = i3 + 16 | 0;
 i7 = HEAP16[i10 >> 1] | 0;
 if (!i1) i8 = 0; else {
  i8 = __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i1 + 4 >> 2] | 0) | 0;
  i8 = __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(i8, HEAP32[i1 >> 2] | 0) | 0;
 }
 i9 = i13 + 3392 | 0;
 __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv(i9);
 i14 = i20 + 52 | 0;
 HEAP8[i14 >> 0] = 0;
 i19 = i20 + 64 | 0;
 HEAP32[i19 >> 2] = 0;
 f6 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 i22 = f6 < Math_fround(1.0e8);
 f6 = i22 ? f6 : Math_fround(1.0e8);
 i22 = HEAP16[i4 >> 1] | 0;
 HEAP32[i16 >> 2] = gb + 93064 + 8;
 HEAP32[i16 + 4 >> 2] = i13;
 HEAP32[i16 + 8 >> 2] = i15;
 HEAP32[i16 + 12 >> 2] = i20;
 HEAP16[i16 + 16 >> 1] = i22;
 HEAP32[i16 + 20 >> 2] = i3;
 HEAP32[i16 + 24 >> 2] = i2;
 i11 = i16 + 28 | 0;
 HEAPF32[i11 >> 2] = f6;
 HEAP32[i16 + 32 >> 2] = i5;
 HEAP8[i16 + 36 >> 0] = 1;
 i4 = i16 + 68 | 0;
 HEAP8[i4 >> 0] = 0;
 i5 = i16 + 72 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = i16 + 41 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = (i7 & 65535) >>> 4 & 1;
 HEAP8[i16 + 39 >> 0] = i1;
 HEAP8[i16 + 40 >> 0] = i22 & 64 ? 1 : i1;
 i1 = HEAP16[i10 >> 1] | 0;
 i7 = (i1 & 65535) >>> 5 & 1;
 HEAP8[i16 + 38 >> 0] = i7;
 HEAP8[i16 + 37 >> 0] = i7;
 do if (!i8) i18 = 8; else if (!(HEAP32[i20 + 60 >> 2] | 0)) {
  i22 = __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE(i9, __ZN5physx2Sq8populateEPKNS0_10ActorShapeE(i8) | 0) | 0;
  HEAP8[i2 >> 0] = 1;
  __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i17, HEAP32[i15 + 12 >> 2] | 0, HEAP32[i15 + 16 >> 2] | 0, Math_fround(HEAPF32[i15 + 20 >> 2]));
  HEAP32[i16 + 44 >> 2] = HEAP32[i17 + 120 >> 2];
  HEAP32[i16 + 48 >> 2] = HEAP32[i17 + 124 >> 2];
  HEAP32[i16 + 52 >> 2] = HEAP32[i17 + 128 >> 2];
  HEAP32[i16 + 56 >> 2] = HEAP32[i17 + 132 >> 2];
  HEAP32[i16 + 60 >> 2] = HEAP32[i17 + 136 >> 2];
  HEAP32[i16 + 64 >> 2] = HEAP32[i17 + 140 >> 2];
  HEAP8[i4 >> 0] = 1;
  HEAP32[i5 >> 2] = i17;
  i22 = __ZN18MultiQueryCallbackIN5physx10PxSweepHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i16, i12, i22, 1) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP8[i2 >> 0] = 0;
  if (i22) {
   i1 = HEAP16[i10 >> 1] | 0;
   i18 = 8;
   break;
  } else {
   i3 = HEAP8[i14 >> 0] | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = i3 << 24 >> 24 != 0 | (i1 | 0) != 0;
   break;
  }
 } else i18 = 8; while (0);
 do if ((i18 | 0) == 8) {
  i3 = HEAP32[i13 + 3404 >> 2] | 0;
  i2 = HEAP32[i13 + 3408 >> 2] | 0;
  i22 = i1 & 65535;
  i1 = i22 & 2;
  __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i17, HEAP32[i15 + 12 >> 2] | 0, HEAP32[i15 + 16 >> 2] | 0, Math_fround(HEAPF32[i15 + 20 >> 2]));
  HEAP32[i16 + 44 >> 2] = HEAP32[i17 + 120 >> 2];
  HEAP32[i16 + 48 >> 2] = HEAP32[i17 + 124 >> 2];
  HEAP32[i16 + 52 >> 2] = HEAP32[i17 + 128 >> 2];
  HEAP32[i16 + 56 >> 2] = HEAP32[i17 + 132 >> 2];
  HEAP32[i16 + 60 >> 2] = HEAP32[i17 + 136 >> 2];
  HEAP32[i16 + 64 >> 2] = HEAP32[i17 + 140 >> 2];
  HEAP8[i4 >> 0] = 1;
  HEAP32[i5 >> 2] = i17;
  if (i22 & 1 | 0) if (!(mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i17 | 0, HEAP32[i15 + 4 >> 2] | 0, i11 | 0, i16 | 0) | 0)) {
   i3 = HEAP8[i14 >> 0] | 0;
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = i3 << 24 >> 24 != 0 | (i1 | 0) != 0;
   break;
  }
  if (!i1) i4 = 0; else i4 = (mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i17 | 0, HEAP32[i15 + 4 >> 2] | 0, i11 | 0, i16 | 0) | 0) ^ 1;
  i3 = HEAP8[i14 >> 0] | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  i2 = i3 << 24 >> 24 != 0 | (i1 | 0) != 0;
  if (i4) {
   i22 = i2;
   i19 = HEAP32[i20 >> 2] | 0;
   i19 = i19 + 4 | 0;
   i19 = HEAP32[i19 >> 2] | 0;
   mftCall_vi(i19 | 0, i20 | 0);
   STACKTOP = i21;
   return i22 | 0;
  }
 } while (0);
 if (i3 << 24 >> 24) {
  if (!i1) {
   i22 = i2;
   i19 = HEAP32[i20 >> 2] | 0;
   i19 = i19 + 4 | 0;
   i19 = HEAP32[i19 >> 2] | 0;
   mftCall_vi(i19 | 0, i20 | 0);
   STACKTOP = i21;
   return i22 | 0;
  }
  i5 = HEAP32[i20 + 56 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i20 + 4 + 40 >> 2]);
  i7 = 0;
  i3 = i1;
  do {
   i4 = i5 + (i7 * 48 | 0) + 40 | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) > f6) {
    i3 = i3 + -1 | 0;
    i11 = HEAP16[i5 + (i3 * 48 | 0) + 12 >> 1] | 0;
    i12 = HEAP32[i5 + (i3 * 48 | 0) + 16 >> 2] | 0;
    i13 = HEAP32[i5 + (i3 * 48 | 0) + 20 >> 2] | 0;
    i14 = HEAP32[i5 + (i3 * 48 | 0) + 24 >> 2] | 0;
    i15 = HEAP32[i5 + (i3 * 48 | 0) + 28 >> 2] | 0;
    i16 = HEAP32[i5 + (i3 * 48 | 0) + 32 >> 2] | 0;
    i17 = HEAP32[i5 + (i3 * 48 | 0) + 36 >> 2] | 0;
    i18 = HEAP32[i5 + (i3 * 48 | 0) + 40 >> 2] | 0;
    i22 = HEAP32[i5 + (i3 * 48 | 0) + 44 >> 2] | 0;
    _memmove(i5 + (i7 * 48 | 0) | 0, i5 + (i3 * 48 | 0) | 0, 12) | 0;
    HEAP16[i5 + (i7 * 48 | 0) + 12 >> 1] = i11;
    HEAP32[i5 + (i7 * 48 | 0) + 16 >> 2] = i12;
    HEAP32[i5 + (i7 * 48 | 0) + 20 >> 2] = i13;
    HEAP32[i5 + (i7 * 48 | 0) + 24 >> 2] = i14;
    HEAP32[i5 + (i7 * 48 | 0) + 28 >> 2] = i15;
    HEAP32[i5 + (i7 * 48 | 0) + 32 >> 2] = i16;
    HEAP32[i5 + (i7 * 48 | 0) + 36 >> 2] = i17;
    HEAP32[i4 >> 2] = i18;
    HEAP32[i5 + (i7 * 48 | 0) + 44 >> 2] = i22;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
  i1 = i3;
  HEAP32[i19 >> 2] = i1;
 }
 if (!i1) {
  i22 = i2;
  i19 = HEAP32[i20 >> 2] | 0;
  i19 = i19 + 4 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i20 | 0);
  STACKTOP = i21;
  return i22 | 0;
 }
 if (!(mftCall_iiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, HEAP32[i20 + 56 >> 2] | 0, i1 | 0) | 0)) {
  i22 = i2;
  i19 = HEAP32[i20 >> 2] | 0;
  i19 = i19 + 4 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i20 | 0);
  STACKTOP = i21;
  return i22 | 0;
 }
 HEAP32[i19 >> 2] = 0;
 i22 = i2;
 i19 = HEAP32[i20 >> 2] | 0;
 i19 = i19 + 4 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 mftCall_vi(i19 | 0, i20 | 0);
 STACKTOP = i21;
 return i22 | 0;
}

function __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb(i12, i22, i20) {
 i12 = i12 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 12 | 0;
 i17 = i24;
 do if (i20) {
  i18 = i22 + 4 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
  if ((HEAP32[i18 >> 2] | 0) == (i1 | 0)) {
   i23 = 0;
   STACKTOP = i24;
   return i23 | 0;
  }
  i19 = i23 + 11 | 0;
  i13 = i23 + 4 | 0;
  i14 = i12 + 11 | 0;
  i15 = i12 + 4 | 0;
  i16 = i17 + 11 | 0;
  i11 = 0;
  L6 : while (1) {
   i4 = i1 + (i11 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i17 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i21 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i17);
      i2 = HEAP32[i23 >> 2] | 0;
      i10 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 10; else {
      i5 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i5) i21 = 12;
     }
    }
    if ((i21 | 0) == 10) i21 = 12;
    if ((i21 | 0) == 12) {
     i21 = 0;
     i5 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i5) break;
    }
    if (HEAP8[i5 + 93 >> 0] | 0) {
     __ZN6Shader20CreateFromParsedFormEv(i5);
     i1 = i5 + 32 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      HEAP32[i5 + 40 >> 2] = 0;
      i1 = 0;
     } else {
      __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i2, i5);
      i1 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i1 >> 2] | 0, i5 + 40 | 0) | 0;
     }
     HEAP32[i5 + 36 >> 2] = i1;
    }
    i6 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i5 | 0) | 0;
    i3 = HEAP8[i6 + 11 >> 0] | 0;
    i9 = i3 << 24 >> 24 < 0;
    i4 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
    i3 = i9 ? HEAP32[i6 + 4 >> 2] | 0 : i3 & 255;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i23 + 4 >> 2] = 0;
    HEAP32[i23 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i23, i4, i3);
    i3 = HEAP8[i19 >> 0] | 0;
    i4 = i3 << 24 >> 24 < 0;
    i3 = i3 & 255;
    i6 = i4 ? HEAP32[i13 >> 2] | 0 : i3;
    i9 = HEAP8[i14 >> 0] | 0;
    i10 = i9 << 24 >> 24 < 0;
    do if ((i6 | 0) == ((i10 ? HEAP32[i15 >> 2] | 0 : i9 & 255) | 0)) {
     i7 = HEAP32[i23 >> 2] | 0;
     i8 = i4 ? i7 : i23;
     i1 = HEAP32[i12 >> 2] | 0;
     i2 = i10 ? i1 : i12;
     i9 = (i6 | 0) == 0;
     if (i4) {
      if (i9) {
       i21 = 33;
       break L6;
      }
      if (!(_memcmp(i8, i2, i6) | 0)) {
       i21 = 33;
       break L6;
      } else break;
     }
     if (i9) {
      i21 = 33;
      break L6;
     }
     if ((i7 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
      i4 = i23;
      do {
       i3 = i3 + -1 | 0;
       i4 = i4 + 1 | 0;
       if (!i3) {
        i21 = 33;
        break L6;
       }
       i2 = i2 + 1 | 0;
      } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     }
    } else i1 = HEAP32[i12 >> 2] | 0; while (0);
    i2 = i10 ? i1 : i12;
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i2, _strlen(i2) | 0);
    i2 = (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
    i1 = 0;
    while (1) {
     i3 = i1 << 1;
     i1 = i1 + 1 | 0;
     if (!(_strcmp(HEAP32[gb + 67868 + (i3 << 2) >> 2] | 0, i2) | 0)) {
      i21 = 30;
      break;
     }
     if ((i1 | 0) >= 78) {
      i1 = 0;
      break;
     }
    }
    if ((i21 | 0) == 30) {
     i21 = 0;
     i1 = HEAP32[gb + 67868 + ((i3 | 1) << 2) >> 2] | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    if (i1 | 0) if (!(_strcmp((HEAP8[i19 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, i1) | 0)) {
     i21 = 33;
     break L6;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   } while (0);
   i11 = i11 + 1 | 0;
   i1 = HEAP32[i22 >> 2] | 0;
   if (i11 >>> 0 >= (HEAP32[i18 >> 2] | 0) - i1 >> 2 >>> 0) {
    i1 = 0;
    i21 = 52;
    break;
   }
  }
  if ((i21 | 0) == 33) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   break;
  } else if ((i21 | 0) == 52) {
   STACKTOP = i24;
   return i1 | 0;
  }
 } else i5 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z21GetManagerFromContexti(4) | 0, i12) | 0; while (0);
 if (!i5) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (HEAP8[i5 + 93 >> 0] | 0) {
  __ZN6Shader20CreateFromParsedFormEv(i5);
  i1 = i5 + 32 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   HEAP32[i5 + 40 >> 2] = 0;
   i1 = 0;
  } else {
   __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i2, i5);
   i1 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i1 >> 2] | 0, i5 + 40 | 0) | 0;
  }
  HEAP32[i5 + 36 >> 2] = i1;
 }
 if (i20) {
  i23 = i5;
  STACKTOP = i24;
  return i23 | 0;
 }
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i23 >> 2] = i2;
 i1 = HEAP32[i22 >> 2] | 0;
 i3 = i22 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L69 : do if ((i1 | 0) == (i4 | 0)) i21 = 47; else while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
   i21 = 47;
   break L69;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i21 = 48;
   break;
  }
 } while (0);
 if ((i21 | 0) == 47) if ((i1 | 0) == (i4 | 0)) i21 = 48;
 do if ((i21 | 0) == 48) if ((i4 | 0) == (HEAP32[i22 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i22, i23);
  break;
 } else {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i4 + 4;
  break;
 } while (0);
 i23 = i5;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN4Node6InsertERfS0_ffbb(i1, i16, i17, f3, f4, i18, i19) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i2 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f20 = f0;
 L1 : while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i15 = i1;
   i14 = i1;
  } else {
   i5 = i1;
   while (1) {
    i1 = __ZN4Node6InsertERfS0_ffbb(i2, i16, i17, f3, f4, i18, i19) | 0;
    if (i1 | 0) {
     i2 = 36;
     break L1;
    }
    i1 = HEAP32[i5 + 4 >> 2] | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i15 = i1;
     i14 = i1;
     break;
    } else i5 = i1;
   }
  }
  i13 = i14 + 24 | 0;
  if (HEAP8[i13 >> 0] | 0) {
   i1 = 0;
   i2 = 36;
   break;
  }
  if (i19) {
   i1 = HEAP32[i14 + 28 >> 2] | 0;
   if ((i1 & 3 | 0) == 3) {
    f6 = Math_fround(HEAPF32[i16 >> 2]);
    f7 = Math_fround(HEAPF32[i14 + 16 >> 2]);
    if (f6 > f7) f8 = Math_fround(f7 / f6); else f8 = Math_fround(1.0);
   } else f8 = Math_fround(1.0);
   if ((i1 & 12 | 0) == 12) {
    f6 = Math_fround(HEAPF32[i17 >> 2]);
    f7 = Math_fround(HEAPF32[i14 + 20 >> 2]);
    if (f6 > f7) f6 = Math_fround(f7 / f6); else f6 = Math_fround(1.0);
   } else f6 = Math_fround(1.0);
   f7 = Math_fround(HEAPF32[i16 >> 2]);
   if (f6 < f8) {
    HEAPF32[i16 >> 2] = Math_fround(f6 * f7);
    f6 = Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2]));
   } else {
    HEAPF32[i16 >> 2] = Math_fround(f8 * f7);
    f6 = Math_fround(f8 * Math_fround(HEAPF32[i17 >> 2]));
   }
   HEAPF32[i17 >> 2] = f6;
  } else f6 = Math_fround(HEAPF32[i17 >> 2]);
  f10 = Math_fround(HEAPF32[i16 >> 2]);
  i5 = i14 + 8 | 0;
  i11 = i14 + 16 | 0;
  f7 = Math_fround(HEAPF32[i11 >> 2]);
  i1 = f10 > Math_fround(Math_fround(f7 - f3) + Math_fround(.5));
  i12 = i14 + 20 | 0;
  f9 = Math_fround(HEAPF32[i12 >> 2]);
  i2 = f6 > Math_fround(Math_fround(f9 - f4) + Math_fround(.5));
  if (i1 | i2) {
   if (i1) {
    i1 = f10 <= f7 ? (HEAP32[i14 + 28 >> 2] & 2 | 0) == 0 : 1;
    f8 = Math_fround(f7 - f10);
    f3 = i1 ? f3 : f8;
   } else i1 = 0;
   if (i2) {
    if (f6 <= f9 ? (HEAP32[i14 + 28 >> 2] & 8 | 0) == 0 : 1) {
     i1 = 0;
     i2 = 36;
     break;
    }
    f4 = Math_fround(f9 - f6);
   }
   if (i1) {
    i1 = 0;
    i2 = 36;
    break;
   }
  }
  f8 = Math_fround(f7 - f10);
  f7 = Math_fround(f9 - f6);
  f20 = Math_fround(f3 * Math_fround(2.0));
  i2 = f20 < Math_fround(9.99999974e-06);
  f20 = i2 ? Math_fround(9.99999974e-06) : f20;
  f9 = Math_fround(f4 * Math_fround(2.0));
  i2 = f9 < Math_fround(9.99999974e-06);
  if (!(!(f8 <= f20) | !(f7 <= (i2 ? Math_fround(9.99999974e-06) : f9)))) {
   i2 = 26;
   break;
  }
  if (f8 < Math_fround(4.0) & i18 & f7 < Math_fround(4.0)) {
   i2 = 28;
   break;
  }
  i13 = __Znwj(32) | 0;
  HEAP32[i13 + 28 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i13 + 20 >> 2] = 0;
  HEAP8[i13 + 24 >> 0] = 0;
  HEAP32[i14 >> 2] = i13;
  i13 = __Znwj(32) | 0;
  HEAP32[i13 + 28 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i13 + 20 >> 2] = 0;
  HEAP8[i13 + 24 >> 0] = 0;
  i1 = i14 + 4 | 0;
  HEAP32[i1 >> 2] = i13;
  if (f8 > f7) {
   f6 = Math_fround(f3 + f10);
   if (i18) f6 = Math_fround(~~f6 + 3 & -4 | 0);
   i13 = HEAP32[i15 >> 2] | 0;
   f20 = Math_fround(HEAPF32[i5 >> 2]);
   i2 = i14 + 12 | 0;
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   f8 = Math_fround(f6 + f20);
   f8 = Math_fround(f8 - f20);
   f10 = Math_fround(Math_fround(f9 + Math_fround(HEAPF32[i12 >> 2])) - f9);
   HEAPF32[i13 + 8 >> 2] = f20;
   HEAPF32[i13 + 12 >> 2] = f9;
   HEAPF32[i13 + 16 >> 2] = f8;
   HEAPF32[i13 + 20 >> 2] = f10;
   i13 = HEAP32[i1 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(f6 + f10);
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i11 >> 2]));
   f10 = Math_fround(f10 - f8);
   f20 = Math_fround(Math_fround(f9 + Math_fround(HEAPF32[i12 >> 2])) - f9);
   HEAPF32[i13 + 8 >> 2] = f8;
   HEAPF32[i13 + 12 >> 2] = f9;
   HEAPF32[i13 + 16 >> 2] = f10;
   HEAPF32[i13 + 20 >> 2] = f20;
   i15 = HEAP32[i15 >> 2] | 0;
   i13 = i15 + 28 | 0;
   i14 = i14 + 28 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 4;
   i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 4;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 8;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 8;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 1;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 2;
   i1 = i15;
   continue;
  } else {
   f6 = Math_fround(f4 + f6);
   if (i18) f6 = Math_fround(~~f6 + 3 & -4 | 0);
   i13 = HEAP32[i15 >> 2] | 0;
   f10 = Math_fround(HEAPF32[i5 >> 2]);
   i2 = i14 + 12 | 0;
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   f20 = Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i11 >> 2])) - f10);
   f8 = Math_fround(Math_fround(f6 + f9) - f9);
   HEAPF32[i13 + 8 >> 2] = f10;
   HEAPF32[i13 + 12 >> 2] = f9;
   HEAPF32[i13 + 16 >> 2] = f20;
   HEAPF32[i13 + 20 >> 2] = f8;
   i13 = HEAP32[i1 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i5 >> 2]);
   f20 = Math_fround(HEAPF32[i2 >> 2]);
   f9 = Math_fround(f6 + f20);
   f10 = Math_fround(f8 + Math_fround(HEAPF32[i11 >> 2]));
   f10 = Math_fround(f10 - f8);
   f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i12 >> 2])) - f9);
   HEAPF32[i13 + 8 >> 2] = f8;
   HEAPF32[i13 + 12 >> 2] = f9;
   HEAPF32[i13 + 16 >> 2] = f10;
   HEAPF32[i13 + 20 >> 2] = f20;
   i15 = HEAP32[i15 >> 2] | 0;
   i13 = i15 + 28 | 0;
   i14 = i14 + 28 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 1;
   i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 1;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 2;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 2;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | HEAP32[i14 >> 2] & 4;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | HEAP32[i14 >> 2] & 8;
   i1 = i15;
   continue;
  }
 }
 if ((i2 | 0) == 26) {
  HEAP8[i13 >> 0] = 1;
  i19 = i14;
  return i19 | 0;
 } else if ((i2 | 0) == 28) {
  HEAP8[i13 >> 0] = 1;
  i19 = i14;
  return i19 | 0;
 } else if ((i2 | 0) == 36) return i1 | 0;
 return 0;
}

function __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i(i19, i20, i25, i30) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i25 = i25 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, i39 = 0, f40 = f0, f41 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i36 + 72 | 0;
 i32 = i36 + 64 | 0;
 i33 = i36;
 i34 = i36 + 32 | 0;
 if (!i20) {
  STACKTOP = i36;
  return;
 }
 if ((HEAP32[i20 >> 2] | 0) != (HEAP32[i25 >> 2] | 0)) {
  STACKTOP = i36;
  return;
 }
 i21 = i20 + 8 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((HEAP32[i1 + 20 >> 2] | 0) <= 0) {
  STACKTOP = i36;
  return;
 }
 i22 = i20 + 16 | 0;
 i23 = (i30 | 0) == -1;
 i24 = i20 + 20 | 0;
 i26 = i19 + 28 | 0;
 i27 = i19 + 32 | 0;
 i28 = i19 + 36 | 0;
 i29 = i20 + 12 | 0;
 i18 = 0;
 do {
  i16 = HEAP32[i22 >> 2] | 0;
  i15 = HEAP8[i16 + (i18 << 5) + 28 >> 0] | 0;
  i17 = i15 & 255;
  if (i15 << 24 >> 24) {
   i11 = 0;
   do {
    i1 = HEAP16[i16 + (i18 << 5) + 12 + (i11 << 1) >> 1] | 0;
    i2 = i1 & 65535;
    if (i2 & 32768 | 0) if (i23 | (i2 & 255 | 0) == (i30 | 0)) {
     i14 = HEAP32[i24 >> 2] | 0;
     i12 = i14 + ((HEAPU16[i16 + (i18 << 5) + (i11 << 1) >> 1] | 0) * 3 << 2) | 0;
     i13 = i11 + 1 | 0;
     i13 = i14 + ((HEAPU16[i16 + (i18 << 5) + (((i13 | 0) == (i17 | 0) ? 0 : i13) << 1) >> 1] | 0) * 3 << 2) | 0;
     HEAP32[i32 >> 2] = 0;
     __ZNK9dtNavMesh23getPolyEdgeDetailPointsEPK10dtMeshTileiiPfPii(0, i20, i18, i11, i31, i32, 16) | 0;
     i14 = __ZNK9dtNavMesh19findConnectingPolysEPKfiPK10dtMeshTileiPyPfi(i19, i31, HEAP32[i32 >> 2] | 0, i25, i2 + 4 & 7, i33, i34, 4) | 0;
     if ((i14 | 0) > 0) {
      i15 = i11 & 255;
      i10 = i1 & 255;
      i9 = (i2 | 4) & 255;
      i7 = i12 + 8 | 0;
      i8 = i13 + 8 | 0;
      i6 = 0;
      do {
       i1 = HEAP32[i26 >> 2] | 0;
       if ((i1 | 0) == -1) {
        i5 = HEAP32[i27 >> 2] | 0;
        i2 = (i5 | 0) == 0 ? 4 : i5 << 1;
        if (i5 >>> 0 < i2 >>> 0) {
         i4 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i28 >> 2] | 0, i2 << 4 | 0) | 0;
         if (!i4) i1 = HEAP32[i26 >> 2] | 0; else {
          HEAP32[i28 >> 2] = i4;
          i1 = HEAP32[i27 >> 2] | 0;
          i5 = i2 + -1 | 0;
          if (i1 >>> 0 < i5 >>> 0) {
           i3 = i1;
           do {
            i37 = i3;
            i3 = i3 + 1 | 0;
            HEAP32[i4 + (i37 << 4) + 8 >> 2] = i3;
           } while ((i3 | 0) != (i5 | 0));
          }
          HEAP32[i4 + (i5 << 4) + 8 >> 2] = -1;
          HEAP32[i26 >> 2] = i1;
          HEAP32[i27 >> 2] = i2;
         }
         if ((i1 | 0) != -1) i35 = 21;
        }
       } else i35 = 21;
       L33 : do if ((i35 | 0) == 21) {
        i35 = 0;
        i2 = HEAP32[i28 >> 2] | 0;
        i5 = i2 + (i1 << 4) + 8 | 0;
        HEAP32[i26 >> 2] = HEAP32[i5 >> 2];
        HEAP32[i5 >> 2] = 0;
        i3 = i33 + (i6 << 3) | 0;
        i4 = HEAP32[i3 + 4 >> 2] | 0;
        i37 = i2 + (i1 << 4) | 0;
        HEAP32[i37 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i37 + 4 >> 2] = i4;
        HEAP8[i2 + (i1 << 4) + 12 >> 0] = i15;
        HEAP8[i2 + (i1 << 4) + 13 >> 0] = i10;
        i37 = (HEAP32[i29 >> 2] | 0) + (i18 << 2) | 0;
        HEAP32[i5 >> 2] = HEAP32[i37 >> 2];
        HEAP32[i37 >> 2] = i1;
        switch (i9 << 24 >> 24) {
        case 4:
         {
          i5 = i6 << 1;
          f40 = Math_fround(HEAPF32[i34 + (i5 << 2) >> 2]);
          f41 = Math_fround(HEAPF32[i7 >> 2]);
          f40 = Math_fround(f40 - f41);
          f38 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f41);
          f40 = Math_fround(f40 / f38);
          i37 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
          f38 = Math_fround(Math_fround(Math_fround(HEAPF32[i34 + ((i5 | 1) << 2) >> 2]) - f41) / f38);
          i5 = (HEAPF32[tempDoublePtr >> 2] = f38, HEAP32[tempDoublePtr >> 2] | 0);
          i4 = f40 > f38;
          f38 = (HEAP32[tempDoublePtr >> 2] = i4 ? i5 : i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          i39 = f38 < Math_fround(0.0);
          i3 = f38 > Math_fround(1.0);
          i3 = ~~Math_fround((i3 ? Math_fround(1.0) : f38) * Math_fround(255.0)) & 255;
          HEAP8[i2 + (i1 << 4) + 14 >> 0] = i39 ? 0 : i3;
          f38 = (HEAP32[tempDoublePtr >> 2] = i4 ? i37 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          i5 = f38 < Math_fround(0.0);
          i37 = f38 > Math_fround(1.0);
          i37 = ~~Math_fround((i37 ? Math_fround(1.0) : f38) * Math_fround(255.0)) & 255;
          HEAP8[i2 + (i1 << 4) + 15 >> 0] = i5 ? 0 : i37;
          break L33;
         }
        case 6:
         {
          i37 = i6 << 1;
          f40 = Math_fround(HEAPF32[i34 + (i37 << 2) >> 2]);
          f38 = Math_fround(HEAPF32[i12 >> 2]);
          f40 = Math_fround(f40 - f38);
          f41 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f38);
          f40 = Math_fround(f40 / f41);
          i39 = (HEAPF32[tempDoublePtr >> 2] = f40, HEAP32[tempDoublePtr >> 2] | 0);
          f41 = Math_fround(Math_fround(Math_fround(HEAPF32[i34 + ((i37 | 1) << 2) >> 2]) - f38) / f41);
          i37 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
          i5 = f40 > f41;
          f41 = (HEAP32[tempDoublePtr >> 2] = i5 ? i37 : i39, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          i3 = f41 < Math_fround(0.0);
          i4 = f41 > Math_fround(1.0);
          i4 = ~~Math_fround((i4 ? Math_fround(1.0) : f41) * Math_fround(255.0)) & 255;
          HEAP8[i2 + (i1 << 4) + 14 >> 0] = i3 ? 0 : i4;
          f41 = (HEAP32[tempDoublePtr >> 2] = i5 ? i39 : i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
          i37 = f41 < Math_fround(0.0);
          i39 = f41 > Math_fround(1.0);
          i39 = ~~Math_fround((i39 ? Math_fround(1.0) : f41) * Math_fround(255.0)) & 255;
          HEAP8[i2 + (i1 << 4) + 15 >> 0] = i37 ? 0 : i39;
          break L33;
         }
        default:
         break L33;
        }
       } while (0);
       i6 = i6 + 1 | 0;
      } while ((i6 | 0) != (i14 | 0));
     }
    }
    i11 = i11 + 1 | 0;
   } while ((i11 | 0) != (i17 | 0));
   i1 = HEAP32[i21 >> 2] | 0;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) < (HEAP32[i1 + 20 >> 2] | 0));
 STACKTOP = i36;
 return;
}

function __ZN5physx18PxcArticulationRef12applyImpulseERKNS_9PxcFsDataEPNS_2Cm13SpatialVectorEjRKS5_(i37, i39, i7, i4) {
 i37 = i37 | 0;
 i39 = i39 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i40 = 0, f41 = f0, f42 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 2976 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i38 = i40 + 160 | 0;
 i36 = i40 + 2208 | 0;
 i27 = i40 + 128 | 0;
 i26 = i40 + 96 | 0;
 i29 = i40 + 64 | 0;
 i30 = i40 + 32 | 0;
 i34 = i40;
 i28 = i37 + 26 | 0;
 i1 = HEAP16[i28 >> 1] | 0;
 i35 = i37 + ((i1 & 65535) + 144) | 0;
 i31 = i37 + 8 | 0;
 i25 = HEAP16[i31 >> 1] | 0;
 i2 = i25 & 65535;
 i32 = i37 + ((i2 * 432 | 0) + (HEAPU16[i37 + 24 >> 1] | 0)) | 0;
 i33 = i37 + (HEAPU16[i37 + 10 >> 1] | 0) | 0;
 if (i25 << 16 >> 16) {
  i3 = 0;
  do {
   HEAP32[i36 + (i3 * 12 | 0) >> 2] = 0;
   HEAP32[i36 + (i3 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i36 + (i3 * 12 | 0) + 8 >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 f13 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i4 + 16 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[i4 + 20 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i4 + 24 >> 2]));
 HEAPF32[i27 >> 2] = f13;
 i20 = i27 + 4 | 0;
 HEAPF32[i20 >> 2] = f12;
 i21 = i27 + 8 | 0;
 HEAPF32[i21 >> 2] = f11;
 i22 = i27 + 12 | 0;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 16 >> 2] = f10;
 i23 = i27 + 20 | 0;
 HEAPF32[i23 >> 2] = f9;
 i24 = i27 + 24 | 0;
 HEAPF32[i24 >> 2] = f8;
 i25 = i27 + 28 | 0;
 HEAPF32[i25 >> 2] = Math_fround(0.0);
 if (i7) {
  i14 = i26 + 4 | 0;
  i15 = i26 + 8 | 0;
  i16 = i27 + 16 | 0;
  i17 = i26 + 16 | 0;
  i18 = i26 + 20 | 0;
  i19 = i26 + 24 | 0;
  while (1) {
   __ZN5physx18PxcArticulationRef16propagateImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE(i26, i35 + (i7 * 160 | 0) | 0, i33 + (i7 << 5) | 0, i36 + (i7 * 12 | 0) | 0, i27, i32 + (i7 * 96 | 0) | 0);
   i6 = HEAP32[i26 >> 2] | 0;
   HEAP32[i27 >> 2] = i6;
   i5 = HEAP32[i14 >> 2] | 0;
   HEAP32[i20 >> 2] = i5;
   i4 = HEAP32[i15 >> 2] | 0;
   HEAP32[i21 >> 2] = i4;
   HEAPF32[i22 >> 2] = Math_fround(0.0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP32[i16 >> 2] = i3;
   i2 = HEAP32[i18 >> 2] | 0;
   HEAP32[i23 >> 2] = i2;
   i1 = HEAP32[i19 >> 2] | 0;
   HEAP32[i24 >> 2] = i1;
   HEAPF32[i25 >> 2] = Math_fround(0.0);
   i7 = HEAP8[i37 + 64 + i7 >> 0] | 0;
   if (!(i7 << 24 >> 24)) break; else i7 = i7 & 255;
  }
  f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = HEAP16[i28 >> 1] | 0;
 }
 f42 = Math_fround(-f12);
 f41 = Math_fround(-f11);
 f10 = Math_fround(-f10);
 f11 = Math_fround(-f9);
 f12 = Math_fround(-f8);
 HEAPF32[i30 >> 2] = Math_fround(-f13);
 HEAPF32[i30 + 4 >> 2] = f42;
 HEAPF32[i30 + 8 >> 2] = f41;
 HEAPF32[i30 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 16 >> 2] = f10;
 HEAPF32[i30 + 20 >> 2] = f11;
 HEAPF32[i30 + 24 >> 2] = f12;
 HEAPF32[i30 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx24PxcArticulationFnsScalar8multiplyERKNS_12PxcFsInertiaERKNS_2Cm13SpatialVectorE(i29, i37 + (i1 & 65535) | 0, i30);
 HEAP32[i38 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i38 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
 HEAP32[i38 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
 HEAPF32[i38 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i38 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
 HEAP32[i38 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
 HEAP32[i38 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
 HEAPF32[i38 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP16[i31 >> 1] | 0;
 if ((i1 & 65535) > 1) {
  i2 = i34 + 4 | 0;
  i3 = i34 + 8 | 0;
  i4 = i34 + 16 | 0;
  i5 = i34 + 20 | 0;
  i6 = i34 + 24 | 0;
  i7 = 1;
  do {
   __ZN5physx18PxcArticulationRef17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE(i34, i35 + (i7 * 160 | 0) | 0, i33 + (i7 << 5) | 0, i36 + (i7 * 12 | 0) | 0, i38 + ((HEAPU8[i37 + 64 + i7 >> 0] | 0) << 5) | 0, i32 + (i7 * 96 | 0) | 0);
   HEAP32[i38 + (i7 << 5) >> 2] = HEAP32[i34 >> 2];
   HEAP32[i38 + (i7 << 5) + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i38 + (i7 << 5) + 8 >> 2] = HEAP32[i3 >> 2];
   HEAPF32[i38 + (i7 << 5) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i38 + (i7 << 5) + 16 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i38 + (i7 << 5) + 20 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i38 + (i7 << 5) + 24 >> 2] = HEAP32[i6 >> 2];
   HEAPF32[i38 + (i7 << 5) + 28 >> 2] = Math_fround(0.0);
   i7 = i7 + 1 | 0;
   i1 = HEAP16[i31 >> 1] | 0;
  } while (i7 >>> 0 < (i1 & 65535) >>> 0);
 }
 if (!(i1 << 16 >> 16)) {
  STACKTOP = i40;
  return;
 }
 i1 = i1 & 65535;
 i2 = 0;
 do {
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) >> 2]);
  i37 = i39 + (i2 << 5) | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) + 4 >> 2]);
  i37 = i39 + (i2 << 5) + 4 | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) + 8 >> 2]);
  i37 = i39 + (i2 << 5) + 8 | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) + 16 >> 2]);
  i37 = i39 + (i2 << 5) + 16 | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) + 20 >> 2]);
  i37 = i39 + (i2 << 5) + 20 | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  f42 = Math_fround(HEAPF32[i38 + (i2 << 5) + 24 >> 2]);
  i37 = i39 + (i2 << 5) + 24 | 0;
  HEAPF32[i37 >> 2] = Math_fround(f42 + Math_fround(HEAPF32[i37 >> 2]));
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 STACKTOP = i40;
 return;
}

function __Z17SetupVertexLightsiPKPK11ActiveLightR17ShaderPassContext(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[gb + 1162364 >> 2] | 0;
 i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 i4 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 i5 = HEAP32[gb + 62548 >> 2] | 0;
 i6 = HEAP32[gb + 62548 + 4 >> 2] | 0;
 i7 = HEAP32[gb + 62548 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i10 + 8 >> 2] = i4;
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 16 >> 2] = i5;
 HEAP32[i10 + 20 >> 2] = i6;
 HEAP32[i10 + 24 >> 2] = i7;
 HEAPF32[i10 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 56 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 60 >> 2] = 1;
 HEAP32[i10 + 64 >> 2] = i2;
 HEAP32[i10 + 68 >> 2] = i3;
 HEAP32[i10 + 72 >> 2] = i4;
 HEAPF32[i10 + 76 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 80 >> 2] = i5;
 HEAP32[i10 + 84 >> 2] = i6;
 HEAP32[i10 + 88 >> 2] = i7;
 HEAPF32[i10 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 116 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 120 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 124 >> 2] = 1;
 HEAP32[i10 + 128 >> 2] = i2;
 HEAP32[i10 + 132 >> 2] = i3;
 HEAP32[i10 + 136 >> 2] = i4;
 HEAPF32[i10 + 140 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 144 >> 2] = i5;
 HEAP32[i10 + 148 >> 2] = i6;
 HEAP32[i10 + 152 >> 2] = i7;
 HEAPF32[i10 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 184 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 188 >> 2] = 1;
 HEAP32[i10 + 192 >> 2] = i2;
 HEAP32[i10 + 196 >> 2] = i3;
 HEAP32[i10 + 200 >> 2] = i4;
 HEAPF32[i10 + 204 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 208 >> 2] = i5;
 HEAP32[i10 + 212 >> 2] = i6;
 HEAP32[i10 + 216 >> 2] = i7;
 HEAPF32[i10 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 228 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 248 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 252 >> 2] = 1;
 HEAP32[i10 + 256 >> 2] = i2;
 HEAP32[i10 + 260 >> 2] = i3;
 HEAP32[i10 + 264 >> 2] = i4;
 HEAPF32[i10 + 268 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 272 >> 2] = i5;
 HEAP32[i10 + 276 >> 2] = i6;
 HEAP32[i10 + 280 >> 2] = i7;
 HEAPF32[i10 + 284 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 288 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 296 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 300 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 304 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 308 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 312 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 316 >> 2] = 1;
 HEAP32[i10 + 320 >> 2] = i2;
 HEAP32[i10 + 324 >> 2] = i3;
 HEAP32[i10 + 328 >> 2] = i4;
 HEAPF32[i10 + 332 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 336 >> 2] = i5;
 HEAP32[i10 + 340 >> 2] = i6;
 HEAP32[i10 + 344 >> 2] = i7;
 HEAPF32[i10 + 348 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 360 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 368 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 372 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 376 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 380 >> 2] = 1;
 HEAP32[i10 + 384 >> 2] = i2;
 HEAP32[i10 + 388 >> 2] = i3;
 HEAP32[i10 + 392 >> 2] = i4;
 HEAPF32[i10 + 396 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 400 >> 2] = i5;
 HEAP32[i10 + 404 >> 2] = i6;
 HEAP32[i10 + 408 >> 2] = i7;
 HEAPF32[i10 + 412 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 416 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 420 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 424 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 428 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 432 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 436 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 440 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 444 >> 2] = 1;
 HEAP32[i10 + 448 >> 2] = i2;
 HEAP32[i10 + 452 >> 2] = i3;
 HEAP32[i10 + 456 >> 2] = i4;
 HEAPF32[i10 + 460 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 464 >> 2] = i5;
 HEAP32[i10 + 468 >> 2] = i6;
 HEAP32[i10 + 472 >> 2] = i7;
 HEAPF32[i10 + 476 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 480 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 484 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 488 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 492 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 496 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 500 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 504 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 508 >> 2] = 1;
 i7 = (i1 | 0) > 8 ? 8 : i1;
 if ((i1 | 0) > 0) i1 = 0; else {
  __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(i7, i10, i9);
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i10 + (i1 << 6) | 0;
  i5 = i3 + 124 | 0;
  i6 = i4 + 64 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
  } while ((i4 | 0) < (i6 | 0));
  f12 = Math_fround(HEAPF32[i2 + 176 >> 2]);
  f14 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 156 >> 2]));
  f13 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 160 >> 2]));
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 164 >> 2]));
  HEAPF32[i10 + (i1 << 6) + 32 >> 2] = f14;
  HEAPF32[i10 + (i1 << 6) + 36 >> 2] = f13;
  HEAPF32[i10 + (i1 << 6) + 40 >> 2] = f12;
  HEAP32[i10 + (i1 << 6) + 44 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i7 | 0));
 __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(i7, i10, i9);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i2, i12) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i7 = i12 - i2 | 0;
 i9 = (i7 | 0) / 72 | 0;
 i11 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i3 = i6;
 if (i9 >>> 0 <= ((i1 - i6 | 0) / 72 | 0) >>> 0) {
  i7 = i10 + 4 | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i1 = (i11 - i6 | 0) / 72 | 0;
  i5 = i9 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 72 | 0) | 0;
  i4 = i5 ? i1 : i12;
  i6 = i11;
  if ((i4 | 0) == (i2 | 0)) i2 = i3; else {
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i11 = i2 + 40 | 0;
    i10 = HEAP32[i11 + 4 >> 2] | 0;
    i9 = i3 + 40 | 0;
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = i10;
    i9 = i2 + 48 | 0;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i11 = i3 + 48 | 0;
    HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i11 + 4 >> 2] = i10;
    i11 = HEAP16[i2 + 28 >> 1] | 0;
    HEAP8[i3 + 28 >> 0] = i11;
    HEAP8[i3 + 29 >> 0] = (i11 & 65535) >>> 8;
    HEAP32[i3 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
    HEAP32[i3 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
    HEAP8[i3 + 60 >> 0] = HEAP8[i2 + 60 >> 0] | 0;
    HEAP32[i3 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
    i2 = i2 + 72 | 0;
    i3 = i3 + 72 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i2 = i3;
  }
  if (!i5) {
   if ((i6 | 0) == (i2 | 0)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i7 >> 2] = i6 + (~(((i6 + -72 - i2 | 0) >>> 0) / 72 | 0) * 72 | 0);
   STACKTOP = i13;
   return;
  }
  if ((i4 | 0) == (i12 | 0)) {
   STACKTOP = i13;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   i8 = i2 + 24 | 0;
   HEAP32[i8 >> 2] = 0;
   i6 = i2 + 28 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP8[i6 >> 0] = 1;
   i9 = i2 + 29 | 0;
   HEAP8[i9 >> 0] = 0;
   i10 = i2 + 32 | 0;
   HEAP32[i10 >> 2] = 0;
   i4 = i2 + 40 | 0;
   i11 = i2 + 64 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP8[i4 + 20 >> 0] = 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i8 = i1 + 40 | 0;
   i5 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = i1 + 48 | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i8 = i2 + 48 | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = i5;
   i8 = HEAP16[i1 + 28 >> 1] | 0;
   HEAP8[i6 >> 0] = i8;
   HEAP8[i9 >> 0] = (i8 & 65535) >>> 8;
   HEAP32[i10 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
   HEAP8[i2 + 60 >> 0] = HEAP8[i1 + 60 >> 0] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 + 64 >> 2];
   i1 = i1 + 72 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 72 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 }
 i5 = i6;
 if (i6) {
  i1 = i10 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i4 + (~(((i4 + -72 - i6 | 0) >>> 0) / 72 | 0) * 72 | 0);
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 77;
  HEAP32[i8 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i7 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i7 = (i1 - i3 | 0) / 72 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 77;
 HEAP32[i8 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 72 | 0, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 * 72 | 0);
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i8 = i1 + 24 | 0;
  HEAP32[i8 >> 2] = 0;
  i7 = i1 + 28 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i7 >> 0] = 1;
  i9 = i1 + 29 | 0;
  HEAP8[i9 >> 0] = 0;
  i10 = i1 + 32 | 0;
  HEAP32[i10 >> 2] = 0;
  i5 = i1 + 40 | 0;
  i11 = i1 + 64 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP8[i5 + 20 >> 0] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i8 = i2 + 40 | 0;
  i6 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  i5 = i2 + 48 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i1 + 48 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  i8 = HEAP16[i2 + 28 >> 1] | 0;
  HEAP8[i7 >> 0] = i8;
  HEAP8[i9 >> 0] = (i8 & 65535) >>> 8;
  HEAP32[i10 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
  HEAP8[i1 + 60 >> 0] = HEAP8[i2 + 60 >> 0] | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 + 64 >> 2];
  i2 = i2 + 72 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 72 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 STACKTOP = i13;
 return;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 201 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i3 = getTempRet0() | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    i25 = i17;
    HEAP32[i25 >> 2] = i2;
    HEAP32[i25 + 4 >> 2] = i3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 205 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i3 = getTempRet0() | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    i25 = i17;
    HEAP32[i25 >> 2] = i2;
    HEAP32[i25 + 4 >> 2] = i3;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN11TypeManagerC2ERN4RTTI16RuntimeTypeArrayE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i3 = i13;
 HEAP32[i11 >> 2] = 0;
 i4 = gb + 63520 | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i3);
 i2 = i10;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 i4 = gb + 63520 | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 36 >> 2] = 0;
 HEAP32[i11 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i3);
 i3 = i10;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i12 = i11 + 28 | 0;
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i12 + 4 >> 2] = i2;
 i12 = i11 + 44 | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i11 + 48 >> 2] = 0;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 68 >> 2] = 0;
 HEAP8[i11 + 72 >> 0] = 0;
 i2 = i11 + 73 | 0;
 HEAP8[i2 >> 0] = 0;
 i3 = i11 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i3 = i11 + 96 | 0;
 HEAP32[i3 >> 2] = 32;
 HEAP32[i11 + 100 >> 2] = 0;
 HEAP32[i11 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f15 = Math_fround((HEAP32[i3 >> 2] | 0) >>> 0);
 HEAP32[i11 + 108 >> 2] = ~~Math_fround(f15 * Math_fround(.5)) >>> 0;
 HEAP32[i11 + 104 >> 2] = ~~Math_fround(f15 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 + 112 >> 0] = 0;
 HEAP32[i11 + 124 >> 2] = 0;
 HEAP8[i11 + 128 >> 0] = 0;
 i4 = i11 + 129 | 0;
 HEAP8[i4 >> 0] = 0;
 i5 = i11 + 132 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i5 = i11 + 152 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i11 + 156 >> 2] = 0;
 HEAP32[i11 + 172 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f15 = Math_fround((HEAP32[i5 >> 2] | 0) >>> 0);
 HEAP32[i11 + 164 >> 2] = ~~Math_fround(f15 * Math_fround(.5)) >>> 0;
 HEAP32[i11 + 160 >> 2] = ~~Math_fround(f15 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 + 168 >> 0] = 0;
 HEAP32[i11 + 180 >> 2] = 0;
 HEAP8[i11 + 184 >> 0] = 0;
 i6 = i11 + 185 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i11 + 188 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i7 = i11 + 208 | 0;
 HEAP32[i7 >> 2] = 32;
 HEAP32[i11 + 212 >> 2] = 0;
 HEAP32[i11 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f15 = Math_fround((HEAP32[i7 >> 2] | 0) >>> 0);
 HEAP32[i11 + 220 >> 2] = ~~Math_fround(f15 * Math_fround(.5)) >>> 0;
 HEAP32[i11 + 216 >> 2] = ~~Math_fround(f15 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 + 224 >> 0] = 0;
 HEAP32[i11 + 240 >> 2] = 0;
 HEAP8[i11 + 244 >> 0] = 0;
 i8 = i11 + 245 | 0;
 HEAP8[i8 >> 0] = 0;
 i9 = i11 + 248 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 i9 = i11 + 268 | 0;
 HEAP32[i9 >> 2] = 32;
 HEAP32[i11 + 272 >> 2] = 0;
 HEAP32[i11 + 288 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f15 = Math_fround((HEAP32[i9 >> 2] | 0) >>> 0);
 HEAP32[i11 + 280 >> 2] = ~~Math_fround(f15 * Math_fround(.5)) >>> 0;
 HEAP32[i11 + 276 >> 2] = ~~Math_fround(f15 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 + 284 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i2 = i11 + 84 | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] << 3;
 i14 = HEAP32[i11 + 116 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i14;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 + 92 >> 2] = i1;
 i3 = i1 + (HEAP32[i3 >> 2] << 3) | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i17 = i2;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i14 = i1;
  HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i14 + 4 >> 2] = i16;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP8[i4 >> 0] = 1;
 i3 = i11 + 140 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i5 >> 2] << 3;
 i2 = HEAP32[i11 + 172 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 + 148 >> 2] = i1;
 i2 = i1 + (HEAP32[i5 >> 2] << 3) | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i14 = i3;
  i16 = HEAP32[i14 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP8[i6 >> 0] = 1;
 i3 = i11 + 196 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] << 3;
 i2 = HEAP32[i11 + 228 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 + 204 >> 2] = i1;
 i2 = i1 + (HEAP32[i7 >> 2] << 3) | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i14 = i3;
  i16 = HEAP32[i14 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP8[i8 >> 0] = 1;
 i3 = i11 + 256 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i9 >> 2] << 3;
 i2 = HEAP32[i11 + 288 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 + 264 >> 2] = i1;
 i2 = i1 + (HEAP32[i9 >> 2] << 3) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i17 = HEAP32[i12 >> 2] | 0;
  HEAP32[i17 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 do {
  i14 = i3;
  i16 = HEAP32[i14 + 4 >> 2] | 0;
  i17 = i1;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i17 = HEAP32[i12 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function runPostSets246() {
 HEAP32[gb + 14068 >> 2] = (HEAP32[gb + 14068 >> 2] | 0) + (gb + 1086039 | 0);
 HEAP32[gb + 14076 >> 2] = (HEAP32[gb + 14076 >> 2] | 0) + (gb + 14056 | 0);
 HEAP32[gb + 14080 >> 2] = (HEAP32[gb + 14080 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14084 >> 2] = (HEAP32[gb + 14084 >> 2] | 0) + (gb + 1086042 | 0);
 HEAP32[gb + 14092 >> 2] = (HEAP32[gb + 14092 >> 2] | 0) + (gb + 14056 | 0);
 HEAP32[gb + 14096 >> 2] = (HEAP32[gb + 14096 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14100 >> 2] = (HEAP32[gb + 14100 >> 2] | 0) + (gb + 1086046 | 0);
 HEAP32[gb + 14104 >> 2] = (HEAP32[gb + 14104 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14108 >> 2] = (HEAP32[gb + 14108 >> 2] | 0) + (gb + 1086048 | 0);
 HEAP32[gb + 14116 >> 2] = (HEAP32[gb + 14116 >> 2] | 0) + (gb + 14096 | 0);
 HEAP32[gb + 14120 >> 2] = (HEAP32[gb + 14120 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14124 >> 2] = (HEAP32[gb + 14124 >> 2] | 0) + (gb + 1086051 | 0);
 HEAP32[gb + 14132 >> 2] = (HEAP32[gb + 14132 >> 2] | 0) + (gb + 14096 | 0);
 HEAP32[gb + 14136 >> 2] = (HEAP32[gb + 14136 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14140 >> 2] = (HEAP32[gb + 14140 >> 2] | 0) + (gb + 1086055 | 0);
 HEAP32[gb + 14144 >> 2] = (HEAP32[gb + 14144 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14148 >> 2] = (HEAP32[gb + 14148 >> 2] | 0) + (gb + 1086057 | 0);
 HEAP32[gb + 14156 >> 2] = (HEAP32[gb + 14156 >> 2] | 0) + (gb + 14136 | 0);
 HEAP32[gb + 14160 >> 2] = (HEAP32[gb + 14160 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14164 >> 2] = (HEAP32[gb + 14164 >> 2] | 0) + (gb + 1086060 | 0);
 HEAP32[gb + 14172 >> 2] = (HEAP32[gb + 14172 >> 2] | 0) + (gb + 14136 | 0);
 HEAP32[gb + 14176 >> 2] = (HEAP32[gb + 14176 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14180 >> 2] = (HEAP32[gb + 14180 >> 2] | 0) + (gb + 1086064 | 0);
 HEAP32[gb + 14184 >> 2] = (HEAP32[gb + 14184 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14188 >> 2] = (HEAP32[gb + 14188 >> 2] | 0) + (gb + 1086066 | 0);
 HEAP32[gb + 14196 >> 2] = (HEAP32[gb + 14196 >> 2] | 0) + (gb + 14176 | 0);
 HEAP32[gb + 14200 >> 2] = (HEAP32[gb + 14200 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14204 >> 2] = (HEAP32[gb + 14204 >> 2] | 0) + (gb + 1086069 | 0);
 HEAP32[gb + 14212 >> 2] = (HEAP32[gb + 14212 >> 2] | 0) + (gb + 14176 | 0);
 HEAP32[gb + 14216 >> 2] = (HEAP32[gb + 14216 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14220 >> 2] = (HEAP32[gb + 14220 >> 2] | 0) + (gb + 1086073 | 0);
 HEAP32[gb + 14224 >> 2] = (HEAP32[gb + 14224 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14228 >> 2] = (HEAP32[gb + 14228 >> 2] | 0) + (gb + 1086076 | 0);
 HEAP32[gb + 14236 >> 2] = (HEAP32[gb + 14236 >> 2] | 0) + (gb + 14216 | 0);
 HEAP32[gb + 14240 >> 2] = (HEAP32[gb + 14240 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14244 >> 2] = (HEAP32[gb + 14244 >> 2] | 0) + (gb + 1086080 | 0);
 HEAP32[gb + 14252 >> 2] = (HEAP32[gb + 14252 >> 2] | 0) + (gb + 14216 | 0);
 HEAP32[gb + 14256 >> 2] = (HEAP32[gb + 14256 >> 2] | 0) + (gb + 216548 | 0);
 HEAP32[gb + 14260 >> 2] = (HEAP32[gb + 14260 >> 2] | 0) + (gb + 1086085 | 0);
 HEAP32[gb + 14264 >> 2] = (HEAP32[gb + 14264 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14268 >> 2] = (HEAP32[gb + 14268 >> 2] | 0) + (gb + 1086088 | 0);
 HEAP32[gb + 14276 >> 2] = (HEAP32[gb + 14276 >> 2] | 0) + (gb + 14256 | 0);
 HEAP32[gb + 14280 >> 2] = (HEAP32[gb + 14280 >> 2] | 0) + (gb + 216576 | 0);
 HEAP32[gb + 14284 >> 2] = (HEAP32[gb + 14284 >> 2] | 0) + (gb + 1086092 | 0);
 HEAP32[gb + 14292 >> 2] = (HEAP32[gb + 14292 >> 2] | 0) + (gb + 14256 | 0);
 HEAP32[gb + 216608 >> 2] = (HEAP32[gb + 216608 >> 2] | 0) + (gb + 14296 | 0);
 HEAP32[gb + 216612 >> 2] = fb + 3210;
 HEAP32[gb + 216616 >> 2] = fb + 3241;
 HEAP32[gb + 216620 >> 2] = fb + 3212;
 HEAP32[gb + 216624 >> 2] = fb + 3213;
 HEAP32[gb + 216628 >> 2] = fb + 327;
 HEAP32[gb + 14296 >> 2] = (HEAP32[gb + 14296 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 14300 >> 2] = (HEAP32[gb + 14300 >> 2] | 0) + (gb + 1086097 | 0);
 HEAP32[gb + 14304 >> 2] = (HEAP32[gb + 14304 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 216636 >> 2] = (HEAP32[gb + 216636 >> 2] | 0) + (gb + 14312 | 0);
 HEAP32[gb + 216640 >> 2] = fb + 3210;
 HEAP32[gb + 216644 >> 2] = fb + 3242;
 HEAP32[gb + 216648 >> 2] = fb + 3212;
 HEAP32[gb + 216652 >> 2] = fb + 3213;
 HEAP32[gb + 216656 >> 2] = fb + 328;
 HEAP32[gb + 14312 >> 2] = (HEAP32[gb + 14312 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 14316 >> 2] = (HEAP32[gb + 14316 >> 2] | 0) + (gb + 1086131 | 0);
 HEAP32[gb + 14320 >> 2] = (HEAP32[gb + 14320 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 216664 >> 2] = (HEAP32[gb + 216664 >> 2] | 0) + (gb + 14328 | 0);
 HEAP32[gb + 216668 >> 2] = fb + 3210;
 HEAP32[gb + 216672 >> 2] = fb + 3243;
 HEAP32[gb + 216676 >> 2] = fb + 3212;
 HEAP32[gb + 216680 >> 2] = fb + 3213;
 HEAP32[gb + 216684 >> 2] = fb + 329;
 HEAP32[gb + 14328 >> 2] = (HEAP32[gb + 14328 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 14332 >> 2] = (HEAP32[gb + 14332 >> 2] | 0) + (gb + 1086168 | 0);
 HEAP32[gb + 14336 >> 2] = (HEAP32[gb + 14336 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 216692 >> 2] = (HEAP32[gb + 216692 >> 2] | 0) + (gb + 14344 | 0);
 HEAP32[gb + 216696 >> 2] = fb + 3210;
 HEAP32[gb + 216700 >> 2] = fb + 3244;
 HEAP32[gb + 216704 >> 2] = fb + 3212;
 HEAP32[gb + 216708 >> 2] = fb + 3213;
 HEAP32[gb + 216712 >> 2] = fb + 324;
 HEAP32[gb + 216716 >> 2] = fb + 150;
 HEAP32[gb + 216720 >> 2] = fb + 96;
 HEAP32[gb + 216724 >> 2] = fb + 185;
 HEAP32[gb + 14344 >> 2] = (HEAP32[gb + 14344 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 14348 >> 2] = (HEAP32[gb + 14348 >> 2] | 0) + (gb + 1086201 | 0);
 HEAP32[gb + 14352 >> 2] = (HEAP32[gb + 14352 >> 2] | 0) + (gb + 12992 | 0);
 HEAP32[gb + 216732 >> 2] = (HEAP32[gb + 216732 >> 2] | 0) + (gb + 13288 | 0);
 HEAP32[gb + 216736 >> 2] = fb + 3210;
 HEAP32[gb + 216740 >> 2] = fb + 3245;
 HEAP32[gb + 216744 >> 2] = fb + 3212;
 HEAP32[gb + 216748 >> 2] = fb + 3213;
 HEAP32[gb + 216752 >> 2] = fb + 330;
 HEAP32[gb + 216760 >> 2] = (HEAP32[gb + 216760 >> 2] | 0) + (gb + 14360 | 0);
 HEAP32[gb + 216764 >> 2] = fb + 3210;
 HEAP32[gb + 216768 >> 2] = fb + 3246;
 HEAP32[gb + 216772 >> 2] = fb + 3212;
 HEAP32[gb + 216776 >> 2] = fb + 3213;
 HEAP32[gb + 216780 >> 2] = fb + 330;
 HEAP32[gb + 14360 >> 2] = (HEAP32[gb + 14360 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 14364 >> 2] = (HEAP32[gb + 14364 >> 2] | 0) + (gb + 1086239 | 0);
 HEAP32[gb + 14368 >> 2] = (HEAP32[gb + 14368 >> 2] | 0) + (gb + 13288 | 0);
}

function _UNITY_FT_Outline_Decompose(i12, i13, i20) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37 + 16 | 0;
 i32 = i37 + 8 | 0;
 i33 = i37;
 i34 = i37 + 32 | 0;
 i35 = i37 + 24 | 0;
 if (!i12) {
  i36 = 20;
  STACKTOP = i37;
  return i36 | 0;
 }
 if (!i13) {
  i36 = 6;
  STACKTOP = i37;
  return i36 | 0;
 }
 i14 = HEAP32[i13 + 16 >> 2] | 0;
 i15 = HEAP32[i13 + 20 >> 2] | 0;
 if ((HEAP16[i12 >> 1] | 0) <= 0) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i16 = i12 + 12 | 0;
 i17 = i12 + 4 | 0;
 i18 = i32 + 4 | 0;
 i19 = i12 + 8 | 0;
 i21 = i13 + 4 | 0;
 i22 = i33 + 4 | 0;
 i23 = i34 + 4 | 0;
 i24 = i35 + 4 | 0;
 i25 = i13 + 12 | 0;
 i26 = i33 + 4 | 0;
 i27 = i31 + 4 | 0;
 i28 = i33 + 4 | 0;
 i29 = i13 + 8 | 0;
 i30 = i34 + 4 | 0;
 i3 = 0;
 i11 = 0;
 L10 : while (1) {
  i9 = HEAP16[(HEAP32[i16 >> 2] | 0) + (i11 << 1) >> 1] | 0;
  i10 = i9 << 16 >> 16;
  if (i9 << 16 >> 16 < 0) {
   i1 = 20;
   i36 = 35;
   break;
  }
  i7 = HEAP32[i17 >> 2] | 0;
  i1 = i7 + (i10 << 3) | 0;
  i2 = i7 + (i3 << 3) | 0;
  i6 = i2;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i32 >> 2] = (HEAP32[i6 >> 2] << i14) - i15;
  i5 = (i5 << i14) - i15 | 0;
  HEAP32[i18 >> 2] = i5;
  i6 = (HEAP32[i7 + (i10 << 3) >> 2] << i14) - i15 | 0;
  i7 = (HEAP32[i7 + (i10 << 3) + 4 >> 2] << i14) - i15 | 0;
  i4 = i32;
  i8 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = i31;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i9 + 4 >> 2] = i4;
  i9 = HEAP32[i19 >> 2] | 0;
  i4 = i9 + i3 | 0;
  switch (HEAP8[i4 >> 0] & 3) {
  case 2:
   {
    i1 = 20;
    i36 = 35;
    break L10;
   }
  case 0:
   {
    if ((HEAP8[i9 + i10 >> 0] & 3) == 1) {
     HEAP32[i32 >> 2] = i6;
     HEAP32[i18 >> 2] = i7;
     i1 = i1 + -8 | 0;
    } else {
     HEAP32[i32 >> 2] = (i8 + i6 | 0) / 2 | 0;
     HEAP32[i18 >> 2] = (i5 + i7 | 0) / 2 | 0;
    }
    i4 = i4 + -1 | 0;
    i2 = i2 + -8 | 0;
    i8 = i1;
    break;
   }
  default:
   i8 = i1;
  }
  i1 = mftCall_iii(HEAP32[i13 >> 2] | 0, i32 | 0, i20 | 0) | 0;
  if (i1 | 0) {
   i36 = 34;
   break;
  }
  L21 : do if (i2 >>> 0 < i8 >>> 0) {
   i1 = 0;
   i5 = i4;
   L22 : while (1) {
    i4 = i2 + 8 | 0;
    i6 = i5 + 1 | 0;
    L24 : do switch (HEAP8[i6 >> 0] & 3) {
    case 1:
     {
      HEAP32[i33 >> 2] = (HEAP32[i4 >> 2] << i14) - i15;
      HEAP32[i26 >> 2] = (HEAP32[i2 + 12 >> 2] << i14) - i15;
      i1 = mftCall_iii(HEAP32[i21 >> 2] | 0, i33 | 0, i20 | 0) | 0;
      if (!i1) {
       i1 = 0;
       i5 = i6;
       i2 = i4;
      } else {
       i36 = 35;
       break L10;
      }
      break;
     }
    case 0:
     {
      HEAP32[i31 >> 2] = (HEAP32[i4 >> 2] << i14) - i15;
      HEAP32[i27 >> 2] = (HEAP32[i2 + 12 >> 2] << i14) - i15;
      i2 = i6;
      while (1) {
       if (i4 >>> 0 >= i8 >>> 0) {
        i36 = 23;
        break L22;
       }
       i7 = i4 + 8 | 0;
       i6 = i2 + 1 | 0;
       i9 = HEAP8[i6 >> 0] | 0;
       i5 = (HEAP32[i7 >> 2] << i14) - i15 | 0;
       HEAP32[i33 >> 2] = i5;
       i2 = (HEAP32[i4 + 12 >> 2] << i14) - i15 | 0;
       HEAP32[i28 >> 2] = i2;
       switch (i9 & 3) {
       case 1:
        {
         i1 = mftCall_iiii(HEAP32[i29 >> 2] | 0, i31 | 0, i33 | 0, i20 | 0) | 0;
         i2 = (i1 | 0) == 0 ? 11 : 10;
         break;
        }
       case 0:
        {
         HEAP32[i34 >> 2] = (i5 + (HEAP32[i31 >> 2] | 0) | 0) / 2 | 0;
         HEAP32[i30 >> 2] = (i2 + (HEAP32[i27 >> 2] | 0) | 0) / 2 | 0;
         i1 = mftCall_iiii(HEAP32[i29 >> 2] | 0, i31 | 0, i34 | 0, i20 | 0) | 0;
         if (!i1) {
          i9 = i33;
          i1 = HEAP32[i9 + 4 >> 2] | 0;
          i2 = i31;
          HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
          HEAP32[i2 + 4 >> 2] = i1;
          i2 = 16;
          i1 = 0;
         } else i2 = 10;
         break;
        }
       default:
        i2 = 7;
       }
       switch (i2 & 31) {
       case 11:
        {
         i5 = i6;
         i2 = i7;
         break L24;
        }
       case 16:
        {
         i2 = i6;
         i4 = i7;
         break;
        }
       default:
        break L21;
       }
      }
     }
    default:
     {
      if ((i2 + 16 | 0) >>> 0 > i8 >>> 0) {
       i36 = 28;
       break L10;
      }
      if ((HEAP8[i5 + 2 >> 0] & 3) != 2) {
       i36 = 28;
       break L10;
      }
      i4 = i2 + 24 | 0;
      HEAP32[i33 >> 2] = (HEAP32[i2 + 8 >> 2] << i14) - i15;
      HEAP32[i22 >> 2] = (HEAP32[i2 + 12 >> 2] << i14) - i15;
      HEAP32[i34 >> 2] = (HEAP32[i2 + 16 >> 2] << i14) - i15;
      HEAP32[i23 >> 2] = (HEAP32[i2 + 20 >> 2] << i14) - i15;
      if (i4 >>> 0 > i8 >>> 0) {
       i36 = 27;
       break L22;
      }
      HEAP32[i35 >> 2] = (HEAP32[i4 >> 2] << i14) - i15;
      HEAP32[i24 >> 2] = (HEAP32[i2 + 28 >> 2] << i14) - i15;
      i1 = mftCall_iiiii(HEAP32[i25 >> 2] | 0, i33 | 0, i34 | 0, i35 | 0, i20 | 0) | 0;
      if (!i1) {
       i1 = 0;
       i5 = i5 + 3 | 0;
       i2 = i4;
      } else {
       i2 = 10;
       break L21;
      }
     }
    } while (0);
    if (i2 >>> 0 >= i8 >>> 0) {
     i36 = 30;
     break L21;
    }
   }
   if ((i36 | 0) == 23) {
    i1 = mftCall_iiii(HEAP32[i29 >> 2] | 0, i31 | 0, i32 | 0, i20 | 0) | 0;
    i36 = 31;
    break;
   } else if ((i36 | 0) == 27) {
    i1 = mftCall_iiiii(HEAP32[i25 >> 2] | 0, i33 | 0, i34 | 0, i32 | 0, i20 | 0) | 0;
    i36 = 31;
    break;
   }
  } else i36 = 30; while (0);
  if ((i36 | 0) == 30) {
   i1 = mftCall_iii(HEAP32[i21 >> 2] | 0, i32 | 0, i20 | 0) | 0;
   i36 = 31;
  }
  if ((i36 | 0) == 31) {
   i36 = 0;
   i2 = (i1 | 0) == 0;
   i3 = i2 ? i10 + 1 | 0 : i3;
   i2 = i2 ? 0 : 10;
  }
  switch (i2 | 0) {
  case 7:
   {
    i1 = 20;
    i36 = 35;
    break L10;
   }
  case 0:
   break;
  default:
   {
    i36 = 34;
    break L10;
   }
  }
  i11 = i11 + 1 | 0;
  if ((i11 | 0) >= (HEAP16[i12 >> 1] | 0)) {
   i1 = 0;
   i36 = 34;
   break;
  }
 }
 if ((i36 | 0) == 28) {
  i36 = 20;
  STACKTOP = i37;
  return i36 | 0;
 } else if ((i36 | 0) == 34) {
  i36 = i1;
  STACKTOP = i37;
  return i36 | 0;
 } else if ((i36 | 0) == 35) {
  STACKTOP = i37;
  return i1 | 0;
 }
 return 0;
}

function __ZN16MeshVertexFormat23CreateVertexDeclarationEjPKS_(i12, i13, i7) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 32 | 0;
 i14 = i16;
 i15 = i16 + 64 | 0;
 i8 = (i7 | 0) != 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 i4 = HEAP32[i12 + 4 >> 2] | 0;
 if (!i4) i1 = 0; else {
  i1 = 0;
  i2 = 0;
  i3 = 1;
  do {
   if (HEAP8[i12 + 8 + (i2 << 2) + 3 >> 0] | 0) {
    i10 = HEAP8[i12 + 8 + (i2 << 2) >> 0] | 0;
    i1 = (i1 & 255) < (i10 & 255) ? i10 : i1;
   }
   i2 = i2 + 1 | 0;
   i3 = i3 << 1;
  } while ((i2 | 0) < 8 & i3 >>> 0 <= i4 >>> 0);
 }
 i6 = i1 & 255;
 i1 = i6 + 1 | 0;
 if (i8) {
  i10 = i7 + 8 | 0;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  if (!(HEAP8[i11 + 3 >> 0] | 0)) i2 = 0; else {
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[i11 >> 0] = i2 + i1;
   i2 = i2 >>> 24 & 255;
  }
  if (HEAP8[i11 + 7 >> 0] | 0) {
   i10 = i11 + 4 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 11 >> 0] | 0) {
   i10 = i11 + 8 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 15 >> 0] | 0) {
   i10 = i11 + 12 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 19 >> 0] | 0) {
   i10 = i11 + 16 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 23 >> 0] | 0) {
   i10 = i11 + 20 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 27 >> 0] | 0) {
   i10 = i11 + 24 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  if (HEAP8[i11 + 31 >> 0] | 0) {
   i10 = i11 + 28 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) + i1;
  }
  i5 = HEAP32[i7 + 4 >> 2] | 0;
  if (!i5) i1 = 0; else {
   i1 = 0;
   i3 = 0;
   i4 = 1;
   do {
    if (HEAP8[i7 + 8 + (i3 << 2) + 3 >> 0] | 0) {
     i10 = HEAP8[i7 + 8 + (i3 << 2) >> 0] | 0;
     i1 = (i1 & 255) < (i10 & 255) ? i10 : i1;
    }
    i3 = i3 + 1 | 0;
    i4 = i4 << 1;
   } while ((i3 | 0) < 8 & i4 >>> 0 <= i5 >>> 0);
  }
  i1 = i6 + 2 + (i1 & 255) | 0;
 } else i2 = 0;
 i1 = i1 & 255;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP16[i15 >> 1] = 0;
 L42 : do if (i13 | 0) {
  if (i8) {
   i10 = 0;
   i6 = 0;
   i7 = 0;
   i9 = 1;
  } else {
   i7 = 0;
   i8 = 0;
   i9 = 0;
   i10 = 1;
   while (1) {
    i4 = (i10 & 120 | 0) != 0;
    i2 = HEAP32[i12 + 8 + (i7 << 2) >> 2] | 0;
    i3 = i2 >>> 24;
    i11 = i3 & 255;
    i5 = i11 << 24 >> 24 == 0;
    i6 = i5 | i4 ^ 1;
    i8 = i6 ? i8 : i2;
    i9 = i6 ? i9 : i11;
    do if (i10 & i13) {
     i6 = i14 + (i7 << 2) | 0;
     if (!i5) {
      HEAP32[i6 >> 2] = i3 << 24 | i2 & 16777215;
      break;
     }
     if (i4 & i9 << 24 >> 24 != 0) {
      HEAP32[i6 >> 2] = (i9 & 255) << 24 | i8 & 16777215;
      break;
     }
     if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2] & i10) {
      switch (i7 | 0) {
      case 7:
      case 1:
       {
        i2 = 1;
        break;
       }
      default:
       i2 = 0;
      }
      i2 = i15 + i2 | 0;
      i3 = HEAP8[i2 >> 0] | 0;
      if (!(i3 << 24 >> 24)) {
       HEAP8[i2 >> 0] = i1;
       i2 = i1 + 1 << 24 >> 24;
      } else {
       i2 = i1;
       i1 = i3;
      }
      HEAP8[i6 >> 0] = i1;
      switch (i7 | 0) {
      case 1:
      case 2:
       {
        i1 = 0;
        break;
       }
      case 7:
       {
        i1 = 4;
        break;
       }
      default:
       i1 = 4;
      }
      HEAP8[i14 + (i7 << 2) + 1 >> 0] = i1;
      HEAP8[i14 + (i7 << 2) + 2 >> 0] = 2;
      HEAP8[i14 + (i7 << 2) + 3 >> 0] = 4;
      i1 = i2;
     }
    } while (0);
    i7 = i7 + 1 | 0;
    i10 = i10 << 1;
    if (!(i10 >>> 0 <= i13 >>> 0 & (i7 | 0) < 8)) break L42;
   }
  }
  while (1) {
   i5 = (i9 & 120 | 0) != 0;
   i2 = HEAP32[(i2 << 24 >> 24 == 0 ? i12 + 8 + (i10 << 2) | 0 : i11 + (i10 << 2) | 0) >> 2] | 0;
   i3 = i2 >>> 24;
   i8 = i3 & 255;
   i4 = i8 << 24 >> 24 == 0;
   i17 = i4 | i5 ^ 1;
   i6 = i17 ? i6 : i2;
   i7 = i17 ? i7 : i8;
   do if (i9 & i13) {
    i8 = i14 + (i10 << 2) | 0;
    if (!i4) {
     HEAP32[i8 >> 2] = i3 << 24 | i2 & 16777215;
     break;
    }
    if (i5 & i7 << 24 >> 24 != 0) {
     HEAP32[i8 >> 2] = (i7 & 255) << 24 | i6 & 16777215;
     break;
    }
    if (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2] & i9) {
     switch (i10 | 0) {
     case 7:
     case 1:
      {
       i2 = 1;
       break;
      }
     default:
      i2 = 0;
     }
     i2 = i15 + i2 | 0;
     i3 = HEAP8[i2 >> 0] | 0;
     if (!(i3 << 24 >> 24)) {
      HEAP8[i2 >> 0] = i1;
      i2 = i1 + 1 << 24 >> 24;
     } else {
      i2 = i1;
      i1 = i3;
     }
     HEAP8[i8 >> 0] = i1;
     switch (i10 | 0) {
     case 1:
     case 2:
      {
       i1 = 0;
       break;
      }
     case 7:
      {
       i1 = 4;
       break;
      }
     default:
      i1 = 4;
     }
     HEAP8[i14 + (i10 << 2) + 1 >> 0] = i1;
     HEAP8[i14 + (i10 << 2) + 2 >> 0] = 2;
     HEAP8[i14 + (i10 << 2) + 3 >> 0] = 4;
     i1 = i2;
    }
   } while (0);
   i3 = i10 + 1 | 0;
   i2 = i9 << 1;
   if (!(i2 >>> 0 <= i13 >>> 0 & (i3 | 0) < 8)) break L42;
   i10 = i3;
   i9 = i2;
   i2 = HEAP8[i11 + (i3 << 2) + 3 >> 0] | 0;
  }
 } while (0);
 if (!(HEAP8[i12 + 56 >> 0] | 0)) {
  i17 = __Z12GetGfxDevicev() | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i15 = i15 + 240 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i17 = mftCall_iii(i15 | 0, i17 | 0, i14 | 0) | 0;
  STACKTOP = i16;
  return i17 | 0;
 } else {
  i17 = __Z16GetRealGfxDevicev() | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i15 = i15 + 240 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i17 = mftCall_iii(i15 | 0, i17 | 0, i14 | 0) | 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 return 0;
}

function __ZNSt3__219__partial_sort_copyIRNS_6__lessI16dtCrowdNeighbourS2_EEPS2_S5_EET1_T0_S7_S6_S6_T_(i2, i20, i21, i4, i1) {
 i2 = i2 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f22 = f0, i23 = 0;
 if ((i21 | 0) == (i4 | 0)) return i21 | 0;
 if ((i2 | 0) == (i20 | 0)) i1 = i21; else {
  i1 = i21;
  do {
   i17 = i2;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i1;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i2 = i2 + 8 | 0;
   i1 = i1 + 8 | 0;
  } while (!((i1 | 0) == (i4 | 0) | (i2 | 0) == (i20 | 0)));
 }
 i18 = i1 - i21 | 0;
 i9 = i18 >> 3;
 i19 = (i18 | 0) > 8;
 if (i19) {
  i11 = (i9 + -2 | 0) / 2 | 0;
  if ((i18 | 0) >= 16) {
   i10 = i11;
   while (1) {
    i7 = i21 + (i10 << 3) | 0;
    i4 = i10 << 3;
    if ((i11 | 0) >= (i4 >> 3 | 0)) {
     i6 = i4 >> 2;
     i5 = i6 | 1;
     i4 = i21 + (i5 << 3) | 0;
     i6 = i6 + 2 | 0;
     if ((i6 | 0) < (i9 | 0)) {
      i16 = i4 + 8 | 0;
      f3 = Math_fround(HEAPF32[i21 + (i5 << 3) + 4 >> 2]);
      i17 = f3 < Math_fround(HEAPF32[i16 + 4 >> 2]);
      i4 = i17 ? i16 : i4;
      i5 = i17 ? i6 : i5;
     }
     f22 = Math_fround(HEAPF32[i4 + 4 >> 2]);
     f3 = Math_fround(HEAPF32[i21 + (i10 << 3) + 4 >> 2]);
     if (!(f22 < f3)) {
      i8 = HEAP32[i7 >> 2] | 0;
      i6 = i7;
      while (1) {
       i15 = i4;
       i16 = HEAP32[i15 + 4 >> 2] | 0;
       i17 = i6;
       HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i17 + 4 >> 2] = i16;
       if ((i11 | 0) < (i5 | 0)) break;
       i5 = i5 << 1 | 1;
       i6 = i21 + (i5 << 3) | 0;
       i7 = i5 + 1 | 0;
       if ((i7 | 0) < (i9 | 0)) {
        i16 = i6 + 8 | 0;
        f22 = Math_fround(HEAPF32[i21 + (i5 << 3) + 4 >> 2]);
        i17 = f22 < Math_fround(HEAPF32[i16 + 4 >> 2]);
        i6 = i17 ? i16 : i6;
        i5 = i17 ? i7 : i5;
       }
       if (Math_fround(HEAPF32[i6 + 4 >> 2]) < f3) break; else {
        i17 = i4;
        i4 = i6;
        i6 = i17;
       }
      }
      HEAP32[i4 >> 2] = i8;
      HEAPF32[i4 + 4 >> 2] = f3;
     }
    }
    if ((i10 | 0) > 0) i10 = i10 + -1 | 0; else break;
   }
  }
 }
 L27 : do if ((i2 | 0) != (i20 | 0)) {
  i17 = i21 + 4 | 0;
  i4 = i9 + -2 | 0;
  i11 = (i4 | 0) / 2 | 0;
  i12 = i21 + 8 | 0;
  i13 = (i18 | 0) > 16;
  i14 = i21 + 16 | 0;
  i15 = i21 + 12 | 0;
  i16 = i21 + 20 | 0;
  if ((i18 | 0) < 16) {
   f3 = Math_fround(HEAPF32[i17 >> 2]);
   while (1) {
    if (Math_fround(HEAPF32[i2 + 4 >> 2]) < f3) {
     i16 = i2;
     i18 = HEAP32[i16 + 4 >> 2] | 0;
     i17 = i21;
     HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i17 + 4 >> 2] = i18;
     f3 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    }
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i20 | 0)) break L27;
   }
  }
  if ((i4 | 0) < -1) {
   f3 = Math_fround(HEAPF32[i17 >> 2]);
   while (1) {
    if (Math_fround(HEAPF32[i2 + 4 >> 2]) < f3) {
     i16 = i2;
     i18 = HEAP32[i16 + 4 >> 2] | 0;
     i17 = i21;
     HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i17 + 4 >> 2] = i18;
     f3 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    }
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i20 | 0)) break L27;
   }
  }
  do {
   f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   if (f22 < Math_fround(HEAPF32[i17 >> 2])) {
    i10 = i2;
    i8 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    i18 = i21;
    HEAP32[i18 >> 2] = i8;
    HEAP32[i18 + 4 >> 2] = i10;
    f3 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (i13) {
     f22 = Math_fround(HEAPF32[i15 >> 2]);
     i5 = f22 < Math_fround(HEAPF32[i16 >> 2]);
     i4 = i5 ? i14 : i12;
     i5 = i5 ? 2 : 1;
    } else {
     i4 = i12;
     i5 = 1;
    }
    if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) < f3)) {
     i6 = i21;
     while (1) {
      i23 = i4;
      i7 = HEAP32[i23 + 4 >> 2] | 0;
      i18 = i6;
      HEAP32[i18 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i18 + 4 >> 2] = i7;
      if ((i11 | 0) < (i5 | 0)) break;
      i5 = i5 << 1 | 1;
      i6 = i21 + (i5 << 3) | 0;
      i7 = i5 + 1 | 0;
      if ((i7 | 0) < (i9 | 0)) {
       i18 = i6 + 8 | 0;
       f22 = Math_fround(HEAPF32[i21 + (i5 << 3) + 4 >> 2]);
       i23 = f22 < Math_fround(HEAPF32[i18 + 4 >> 2]);
       i6 = i23 ? i18 : i6;
       i5 = i23 ? i7 : i5;
      }
      if (Math_fround(HEAPF32[i6 + 4 >> 2]) < f3) break; else {
       i23 = i4;
       i4 = i6;
       i6 = i23;
      }
     }
     HEAP32[i4 >> 2] = i8;
     HEAP32[i4 + 4 >> 2] = i10;
    }
   }
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i20 | 0));
 } while (0);
 if (!i19) {
  i23 = i1;
  return i23 | 0;
 }
 i11 = i21 + 8 | 0;
 i12 = i21 + 16 | 0;
 i13 = i21 + 12 | 0;
 i14 = i21 + 20 | 0;
 i15 = i21 + 4 | 0;
 i10 = i1;
 do {
  i10 = i10 + -8 | 0;
  i23 = i21;
  i20 = HEAP32[i23 >> 2] | 0;
  i23 = HEAP32[i23 + 4 >> 2] | 0;
  i18 = i10;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i2 = i21;
  HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i2 + 4 >> 2] = i19;
  i2 = i10;
  HEAP32[i2 >> 2] = i20;
  HEAP32[i2 + 4 >> 2] = i23;
  i2 = i9;
  i9 = i9 + -1 | 0;
  if ((i2 | 0) != 2) {
   i23 = i2 + -3 | 0;
   i7 = (i23 | 0) / 2 | 0;
   if ((i23 | 0) >= -1) {
    if ((i9 | 0) > 2) {
     f22 = Math_fround(HEAPF32[i13 >> 2]);
     i4 = f22 < Math_fround(HEAPF32[i14 >> 2]);
     i2 = i4 ? i12 : i11;
     i4 = i4 ? 2 : 1;
    } else {
     i2 = i11;
     i4 = 1;
    }
    f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    f3 = Math_fround(HEAPF32[i15 >> 2]);
    if (!(f22 < f3)) {
     i8 = HEAP32[i21 >> 2] | 0;
     i5 = i21;
     while (1) {
      i19 = i2;
      i20 = HEAP32[i19 + 4 >> 2] | 0;
      i23 = i5;
      HEAP32[i23 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i23 + 4 >> 2] = i20;
      if ((i7 | 0) < (i4 | 0)) break;
      i4 = i4 << 1 | 1;
      i5 = i21 + (i4 << 3) | 0;
      i6 = i4 + 1 | 0;
      if ((i6 | 0) < (i9 | 0)) {
       i20 = i5 + 8 | 0;
       f22 = Math_fround(HEAPF32[i21 + (i4 << 3) + 4 >> 2]);
       i23 = f22 < Math_fround(HEAPF32[i20 + 4 >> 2]);
       i5 = i23 ? i20 : i5;
       i4 = i23 ? i6 : i4;
      }
      if (Math_fround(HEAPF32[i5 + 4 >> 2]) < f3) break; else {
       i23 = i2;
       i2 = i5;
       i5 = i23;
      }
     }
     HEAP32[i2 >> 2] = i8;
     HEAPF32[i2 + 4 >> 2] = f3;
    }
   }
  }
 } while ((i9 | 0) > 1);
 return i1 | 0;
}

function __ZN12GUIClipState4PushER10InputEventRK5RectTIfE8Vector2fRKS6_b(i14, i15, i3, i4, i1, i2) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 i17 = i14 + 4 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 if ((HEAP32[i14 >> 2] | 0) == (i18 | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017807 | 0, 0, gb + 1017283 | 0, 38, 1, 0, 0, 0);
  STACKTOP = i19;
  return;
 }
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i18 + -56 >> 2]);
 f6 = Math_fround(f9 + f8);
 f11 = Math_fround(HEAPF32[i18 + -24 >> 2]);
 f6 = Math_fround(f6 + f11);
 f9 = Math_fround(f11 + Math_fround(f8 + Math_fround(f9 + Math_fround(HEAPF32[i3 + 8 >> 2]))));
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i18 + -52 >> 2]);
 f7 = Math_fround(f11 + f10);
 f13 = Math_fround(HEAPF32[i18 + -20 >> 2]);
 f7 = Math_fround(f7 + f13);
 f11 = Math_fround(f13 + Math_fround(f10 + Math_fround(f11 + Math_fround(HEAPF32[i3 + 12 >> 2]))));
 if (f6 < f8) {
  f13 = Math_fround(f6 - f8);
  HEAPF32[i4 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i4 >> 2]));
  f13 = f8;
 } else f13 = f6;
 if (f7 < f10) {
  f12 = Math_fround(f7 - f10);
  i5 = i4 + 4 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i5 >> 2]));
  f12 = f10;
 } else f12 = f7;
 f6 = Math_fround(f8 + Math_fround(HEAPF32[i18 + -48 >> 2]));
 f6 = f9 > f6 ? f6 : f9;
 f7 = Math_fround(f10 + Math_fround(HEAPF32[i18 + -44 >> 2]));
 f7 = f11 > f7 ? f7 : f11;
 f6 = Math_fround((f6 <= f13 ? f13 : f6) - f13);
 f7 = Math_fround((f7 <= f12 ? f12 : f7) - f12);
 if (i2) {
  f10 = Math_fround(Math_fround(HEAPF32[i14 + 12 >> 2]) + Math_fround(9.99999997e-07));
  f10 = Math_fround(Math_fround(1.0) / f10);
  f21 = Math_fround(f13 + Math_fround(Math_fround(f6 * Math_fround(Math_fround(1.0) - f10)) * Math_fround(.5)));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(HEAPF32[i14 + 32 >> 2]) + Math_fround(9.99999997e-07)));
  f20 = Math_fround(f12 + Math_fround(Math_fround(f7 * Math_fround(Math_fround(1.0) - f13)) * Math_fround(.5)));
  f8 = Math_fround(f6 * f10);
  f9 = Math_fround(f7 * f13);
  f12 = Math_fround(Math_fround(HEAPF32[i14 + 60 >> 2]) * f10);
  HEAPF32[i4 >> 2] = f12;
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i14 + 64 >> 2]));
  HEAPF32[i4 + 4 >> 2] = f13;
  f10 = Math_fround(f21 + f12);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i1 >> 2]));
  f11 = Math_fround(f20 + f13);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i1 + 4 >> 2]));
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i18 + -16 >> 2]));
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i18 + -12 >> 2]));
  i1 = i16 + 16 | 0;
  i5 = i16 + 32 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAPF32[i16 >> 2] = f21;
  HEAPF32[i16 + 4 >> 2] = f20;
  HEAPF32[i16 + 8 >> 2] = f8;
  HEAPF32[i16 + 12 >> 2] = f9;
  i1 = i4;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i16 + 48 | 0;
  HEAPF32[i3 >> 2] = f10;
  i4 = i16 + 52 | 0;
  HEAPF32[i4 >> 2] = f11;
  i1 = i16 + 40 | 0;
  HEAPF32[i1 >> 2] = f12;
  i2 = i16 + 44 | 0;
  HEAPF32[i2 >> 2] = f13;
  if ((i18 | 0) == (HEAP32[i14 + 8 >> 2] | 0)) __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i14, i16); else {
   HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
   HEAP32[i18 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
   HEAP32[i18 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
   HEAP32[i18 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
   HEAP32[i18 + 32 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i18 + 36 >> 2] = HEAP32[i16 + 36 >> 2];
   HEAP32[i18 + 40 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i18 + 44 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i18 + 48 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i18 + 52 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 56;
  }
 } else {
  f10 = Math_fround(HEAPF32[i18 + -8 >> 2]);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i1 >> 2]));
  f11 = Math_fround(HEAPF32[i18 + -4 >> 2]);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i1 + 4 >> 2]));
  f20 = Math_fround(HEAPF32[i18 + -16 >> 2]);
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i4 >> 2]));
  f21 = Math_fround(HEAPF32[i18 + -12 >> 2]);
  f21 = Math_fround(f21 + Math_fround(HEAPF32[i4 + 4 >> 2]));
  i1 = i16 + 16 | 0;
  i5 = i16 + 32 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAPF32[i16 >> 2] = f13;
  HEAPF32[i16 + 4 >> 2] = f12;
  HEAPF32[i16 + 8 >> 2] = f6;
  HEAPF32[i16 + 12 >> 2] = f7;
  i1 = i4;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i16 + 48 | 0;
  HEAPF32[i3 >> 2] = f10;
  i4 = i16 + 52 | 0;
  HEAPF32[i4 >> 2] = f11;
  i1 = i16 + 40 | 0;
  HEAPF32[i1 >> 2] = f20;
  i2 = i16 + 44 | 0;
  HEAPF32[i2 >> 2] = f21;
  if ((i18 | 0) == (HEAP32[i14 + 8 >> 2] | 0)) __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i14, i16); else {
   HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
   HEAP32[i18 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
   HEAP32[i18 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
   HEAP32[i18 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
   HEAP32[i18 + 32 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i18 + 36 >> 2] = HEAP32[i16 + 36 >> 2];
   HEAP32[i18 + 40 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i18 + 44 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i18 + 48 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i18 + 52 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 56;
  }
 }
 __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i14, i15, (HEAP32[i17 >> 2] | 0) + -56 | 0);
 STACKTOP = i19;
 return;
}

function __Z25CalculateShadowCasterCullbPK5PlaneRK10Matrix4x4fRK8Vector3fff9LightTypeS7_R16ShadowCasterCullPKb(i15, i16, i20, i21, f22, f23, i24, i25, i26, i27) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 f22 = Math_fround(f22);
 f23 = Math_fround(f23);
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i17 = 0, i18 = 0, i19 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i28 + 6 | 0;
 i18 = i28;
 i19 = i26 + 160 | 0;
 HEAP32[i19 >> 2] = 0;
 i10 = i25 + 4 | 0;
 i11 = i25 + 8 | 0;
 L1 : do if ((i24 | 0) == 1) {
  i7 = 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i16 + (i7 << 4) >> 2] | 0;
   i3 = HEAP32[i16 + (i7 << 4) + 4 >> 2] | 0;
   i4 = HEAP32[i16 + (i7 << 4) + 8 >> 2] | 0;
   i5 = HEAP32[i16 + (i7 << 4) + 12 >> 2] | 0;
   f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f14 * Math_fround(HEAPF32[i25 >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   f14 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i13 = Math_fround(f6 + Math_fround(f14 * Math_fround(HEAPF32[i11 >> 2]))) < Math_fround(0.0);
   HEAP8[i17 + i7 >> 0] = i13 & 1;
   HEAP8[i18 + i7 >> 0] = 1;
   if (i13) if (!(HEAP8[i27 + i7 >> 0] | 0)) {
    HEAP32[i19 >> 2] = i1 + 1;
    HEAP32[i26 + (i1 << 4) >> 2] = i2;
    HEAP32[i26 + (i1 << 4) + 4 >> 2] = i3;
    HEAP32[i26 + (i1 << 4) + 8 >> 2] = i4;
    HEAP32[i26 + (i1 << 4) + 12 >> 2] = i5;
    i1 = HEAP32[i19 >> 2] | 0;
    if ((i1 | 0) == 10) break;
   }
   i7 = i7 + 1 | 0;
   if ((i7 | 0) >= 6) {
    i1 = 0;
    break L1;
   }
  }
  STACKTOP = i28;
  return;
 } else {
  i9 = 0;
  i1 = 0;
  while (1) {
   i4 = HEAP32[i16 + (i9 << 4) >> 2] | 0;
   i5 = HEAP32[i16 + (i9 << 4) + 4 >> 2] | 0;
   i7 = HEAP32[i16 + (i9 << 4) + 8 >> 2] | 0;
   i8 = HEAP32[i16 + (i9 << 4) + 12 >> 2] | 0;
   f14 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f14 * Math_fround(HEAPF32[i25 >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   f14 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f6 + Math_fround(f14 * Math_fround(HEAPF32[i11 >> 2])));
   f6 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = Math_fround(f6 + f14);
   i2 = i17 + i9 | 0;
   HEAP8[i2 >> 0] = 0;
   i3 = i18 + i9 | 0;
   HEAP8[i3 >> 0] = 1;
   if (f14 > Math_fround(-.00999999977)) {
    HEAP8[i2 >> 0] = 1;
    if (f14 < Math_fround(.00999999977)) HEAP8[i3 >> 0] = 0;
    if (!(HEAP8[i27 + i9 >> 0] | 0)) {
     i13 = f14 < Math_fround(0.0);
     f6 = Math_fround(f6 - f14);
     i13 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i8;
     HEAP32[i19 >> 2] = i1 + 1;
     HEAP32[i26 + (i1 << 4) >> 2] = i4;
     HEAP32[i26 + (i1 << 4) + 4 >> 2] = i5;
     HEAP32[i26 + (i1 << 4) + 8 >> 2] = i7;
     HEAP32[i26 + (i1 << 4) + 12 >> 2] = i13;
     i1 = HEAP32[i19 >> 2] | 0;
     if ((i1 | 0) == 10) break;
    }
   }
   i9 = i9 + 1 | 0;
   if ((i9 | 0) >= 6) {
    i1 = 0;
    break L1;
   }
  }
  STACKTOP = i28;
  return;
 } while (0);
 do {
  i2 = HEAP32[gb + 35780 + (i1 << 2) >> 2] | 0;
  i1 = i1 + 1 | 0;
  if (!(HEAP8[i27 + i2 >> 0] | 0)) {
   i3 = HEAP32[gb + 35780 + (((i1 | 0) == 4 ? 0 : i1) << 2) >> 2] | 0;
   if ((HEAP8[i17 + i2 >> 0] | 0) != (HEAP8[i17 + i3 >> 0] | 0)) if (HEAP8[i18 + i2 >> 0] | 0) if (HEAP8[i18 + i3 >> 0] | 0) if (__ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i15, i16, i20, i21, f22, f23, i2, i3, 5, i24, i25, i26 + (HEAP32[i19 >> 2] << 4) | 0) | 0) {
    i13 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
    HEAP32[i19 >> 2] = i13;
    if ((i13 | 0) == 10) {
     i12 = 27;
     break;
    }
   }
  }
 } while ((i1 | 0) < 4);
 if ((i12 | 0) == 27) {
  STACKTOP = i28;
  return;
 }
 i2 = HEAP8[i17 >> 0] | 0;
 i3 = HEAP8[i17 + 2 >> 0] | 0;
 i4 = HEAP8[i17 + 1 >> 0] | 0;
 i5 = HEAP8[i17 + 3 >> 0] | 0;
 i7 = (HEAP8[i18 + 3 >> 0] | 0) == 0;
 i8 = (HEAP8[i18 + 1 >> 0] | 0) == 0;
 i9 = (HEAP8[i18 + 2 >> 0] | 0) == 0;
 i10 = (HEAP8[i18 >> 0] | 0) == 0;
 i1 = 0;
 while (1) {
  i11 = HEAP32[gb + 35796 + (i1 << 2) >> 2] | 0;
  if (!(HEAP8[i27 + i11 >> 0] | 0)) {
   i12 = HEAP8[i17 + i11 >> 0] | 0;
   i13 = i18 + i11 | 0;
   if (i12 << 24 >> 24 != i2 << 24 >> 24) if (!((HEAP8[i13 >> 0] | 0) == 0 | i10)) if (__ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i15, i16, i20, i21, f22, f23, i11, 0, 2, i24, i25, i26 + (HEAP32[i19 >> 2] << 4) | 0) | 0) {
    i29 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
    HEAP32[i19 >> 2] = i29;
    if ((i29 | 0) == 10) {
     i12 = 27;
     break;
    }
   }
   if (i12 << 24 >> 24 != i3 << 24 >> 24) if (!((HEAP8[i13 >> 0] | 0) == 0 | i9)) if (__ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i15, i16, i20, i21, f22, f23, i11, 2, 1, i24, i25, i26 + (HEAP32[i19 >> 2] << 4) | 0) | 0) {
    i29 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
    HEAP32[i19 >> 2] = i29;
    if ((i29 | 0) == 10) {
     i12 = 27;
     break;
    }
   }
   if (i12 << 24 >> 24 != i4 << 24 >> 24) if (!((HEAP8[i13 >> 0] | 0) == 0 | i8)) if (__ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i15, i16, i20, i21, f22, f23, i11, 1, 3, i24, i25, i26 + (HEAP32[i19 >> 2] << 4) | 0) | 0) {
    i29 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
    HEAP32[i19 >> 2] = i29;
    if ((i29 | 0) == 10) {
     i12 = 27;
     break;
    }
   }
   if (i12 << 24 >> 24 != i5 << 24 >> 24) if (!((HEAP8[i13 >> 0] | 0) == 0 | i7)) if (__ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_(i15, i16, i20, i21, f22, f23, i11, 3, 0, i24, i25, i26 + (HEAP32[i19 >> 2] << 4) | 0) | 0) {
    i29 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
    HEAP32[i19 >> 2] = i29;
    if ((i29 | 0) == 10) {
     i12 = 27;
     break;
    }
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 2) {
   i12 = 27;
   break;
  }
 }
 if ((i12 | 0) == 27) {
  STACKTOP = i28;
  return;
 }
}

function __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i15 = i17 + 4 | 0;
 if (!(HEAP8[i16 + 228 >> 0] | 0)) i14 = i16; else {
  __ZN20TextRenderingPrivate15GetFormatStringER11UTF16StringR13dynamic_arrayINS_16TextFormatChangeELj4EE(i16 + 196 | 0, i16);
  i14 = i16;
 }
 i11 = i16 + 284 | 0;
 HEAP32[i11 >> 2] = 1;
 i12 = i16 + 12 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) i1 = i16 + 188 | 0; else {
  i8 = i15 + 11 | 0;
  i1 = i16 + 188 | 0;
  i9 = i16 + 192 | 0;
  i10 = i16 + 244 | 0;
  i7 = HEAP32[i16 >> 2] | 0;
  i2 = 1;
  do {
   i4 = HEAP32[i7 + 40 >> 2] | 0;
   if (i4 & 8 | 0) {
    i5 = i7 + 16 | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if (!i3) {
     f6 = Math_fround(HEAP32[i1 >> 2] | 0);
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2]));
    } else {
     f6 = Math_fround(i3 | 0);
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2]));
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2]));
    }
    HEAP32[i5 >> 2] = ~~f6;
   }
   if (i4 & 48) {
    i3 = i7 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 >>> 0 > 7) {
     HEAP32[i13 >> 2] = 8;
     __Z6FormatPKcz(i15, gb + 945247 | 0, i13);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 945167 | 0, 194, 512, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
     HEAP32[i3 >> 2] = 0;
     i4 = 0;
     i2 = HEAP32[i11 >> 2] | 0;
    }
    if ((i4 | 0) >= (i2 | 0)) {
     i2 = i4 + 1 | 0;
     HEAP32[i11 >> 2] = i2;
    }
   }
   i7 = i7 + 44 | 0;
  } while ((i7 | 0) != ((HEAP32[i16 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 44 | 0) | 0));
 }
 i12 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 HEAP16[i15 >> 1] = 32;
 i13 = i16 + 184 | 0;
 i8 = i16 + 248 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = i16 + 232 | 0;
 __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE(HEAP32[i13 >> 2] | 0, i15, 1, HEAP32[i1 >> 2] | 0, f6, HEAP32[i7 >> 2] | 0, 0) | 0;
 i15 = i16 + 200 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE(HEAP32[i13 >> 2] | 0, HEAP32[i16 + 196 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i1 >> 2] | 0, f6, HEAP32[i7 >> 2] | 0, i14) | 0;
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i12) | 0;
 f6 = Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(HEAP32[i13 >> 2] | 0, 32, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0, Math_fround(HEAPF32[i8 >> 2]), 0));
 i8 = f6 == Math_fround(0.0);
 f6 = i8 ? Math_fround(4.0) : f6;
 i8 = i16 + 236 | 0;
 HEAP32[i8 >> 2] = ~~Math_fround(Math_fround(HEAP32[i8 >> 2] | 0) * f6);
 HEAPF32[i16 + 296 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 288 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i16 + 320 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 324 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 328 >> 2] = Math_fround(0.0);
 i8 = i16 + 180 | 0;
 i7 = ((HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0) + -4 | 0) / 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i1 = (i7 | 0) < (i1 | 0) ? i7 : i1;
 i7 = i16 + 280 | 0;
 HEAP32[i7 >> 2] = i1;
 if (((i1 << 2) + 4 | 0) > 65535) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 945291 | 0, 0, gb + 945167 | 0, 226, 1, 0, 0, 0);
  HEAP32[i7 >> 2] = 16382;
  i1 = 16382;
 }
 i5 = i16 + 356 | 0;
 i1 = i1 + 1 | 0;
 i2 = i16 + 368 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i16 + 372 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 3, 4, i16 + 360 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i16 + 360 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i15;
  break;
 } while (0);
 i1 = i16 + 376 | 0;
 i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
 i3 = i16 + 388 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i16 + 392 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2 << 2, 4, i16 + 380 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i16 + 380 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i15;
  break;
 } while (0);
 i5 = i16 + 396 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
 i2 = i16 + 408 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i16 + 412 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i1 >>> 0) {
  i14 = HEAP32[i8 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = i16 + 436 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = i16 + 440 | 0;
  HEAP32[i15 >> 2] = i14;
  i16 = i16 + 352 | 0;
  HEAP8[i16 >> 0] = 1;
  STACKTOP = i17;
  return 1;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 2, 4, i16 + 400 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i14 = HEAP32[i8 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = i16 + 436 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = i16 + 440 | 0;
  HEAP32[i15 >> 2] = i14;
  i16 = i16 + 352 | 0;
  HEAP8[i16 >> 0] = 1;
  STACKTOP = i17;
  return 1;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16 + 400 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i14;
  i14 = HEAP32[i8 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = i16 + 436 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = i16 + 440 | 0;
  HEAP32[i15 >> 2] = i14;
  i16 = i16 + 352 | 0;
  HEAP8[i16 >> 0] = 1;
  STACKTOP = i17;
  return 1;
 }
 return 0;
}

function __ZN5physx27InternalTriangleMeshBuilder9cleanMeshEb(i23, i12) {
 i23 = i23 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 8 | 0;
 i3 = i30;
 i27 = i30 + 12 | 0;
 i6 = i30 + 35 | 0;
 i17 = i30 + 34 | 0;
 i19 = i30 + 33 | 0;
 i22 = i30 + 32 | 0;
 i20 = HEAP32[i23 >> 2] | 0;
 i25 = i23 + 8 | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] & 1)) f2 = Math_fround(0.0); else {
  f2 = Math_fround(HEAPF32[i1 + 36 >> 2]);
  if (f2 == Math_fround(0.0)) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 730919 | 0, 147, gb + 731837 | 0, i3);
   f2 = Math_fround(0.0);
  }
 }
 i21 = i20 + 8 | 0;
 i26 = i20 + 4 | 0;
 i24 = i20 + 12 | 0;
 __ZN5physx11MeshCleanerC2EjPKNS_6PxVec3EjPKjf(i27, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] | 0, HEAP32[i26 >> 2] | 0, HEAP32[i24 >> 2] | 0, f2);
 i18 = i27 + 4 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  i29 = 0;
  __ZN5physx11MeshCleanerD2Ev(i27);
  STACKTOP = i30;
  return i29 | 0;
 }
 if (i12) {
  if ((HEAP32[i27 >> 2] | 0) != (HEAP32[i20 >> 2] | 0)) {
   i29 = 0;
   __ZN5physx11MeshCleanerD2Ev(i27);
   STACKTOP = i30;
   return i29 | 0;
  }
  if ((i1 | 0) != (HEAP32[i26 >> 2] | 0)) {
   i29 = 0;
   __ZN5physx11MeshCleanerD2Ev(i27);
   STACKTOP = i30;
   return i29 | 0;
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[(HEAP32[i23 >> 2] | 0) + 164 >> 2] | 0);
 i1 = HEAP32[i23 >> 2] | 0;
 HEAP32[i1 + 164 >> 2] = 0;
 i14 = i27 + 16 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i16 = HEAP32[i18 >> 2] | 0;
  if (HEAP32[i1 + 160 >> 2] | 0) {
   i1 = i16 >>> 0 > 2147483647 ? -1 : i16 << 1;
   if (!i1) i13 = 0; else {
    i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i6 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
    i13 = _PxGetFoundation() | 0;
    i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0;
    i13 = mftCall_iiiiii(i6 | 0, i12 | 0, i1 | 0, (i13 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 180) | 0;
   }
   if (!i16) i1 = HEAP32[i23 >> 2] | 0; else {
    i3 = HEAP32[i14 >> 2] | 0;
    i1 = HEAP32[i23 >> 2] | 0;
    i6 = HEAP32[i1 + 160 >> 2] | 0;
    i12 = 0;
    do {
     HEAP16[i13 + (i12 << 1) >> 1] = HEAP16[i6 + (HEAP32[i3 + (i12 << 2) >> 2] << 1) >> 1] | 0;
     i12 = i12 + 1 | 0;
    } while ((i12 | 0) != (i16 | 0));
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i1 + 160 >> 2] | 0);
   i1 = HEAP32[i23 >> 2] | 0;
   HEAP32[i1 + 160 >> 2] = i13;
  }
  if (!(HEAP8[(HEAP32[i25 >> 2] | 0) + 12 >> 0] | 0)) {
   i3 = i16 >>> 0 > 1073741823 ? -1 : i16 << 2;
   if (!i3) i3 = 0; else {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i13 = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0;
    i1 = _PxGetFoundation() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
    i3 = mftCall_iiiiii(i13 | 0, i17 | 0, i3 | 0, (i1 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 190) | 0;
    i1 = HEAP32[i23 >> 2] | 0;
   }
   HEAP32[i1 + 164 >> 2] = i3;
   _memcpy(i3 | 0, HEAP32[i14 >> 2] | 0, i16 << 2 | 0) | 0;
  }
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i27 >> 2] | 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, HEAP32[i21 >> 2] | 0);
  HEAP32[i21 >> 2] = 0;
  __ZN5physx20InternalTriangleMesh16allocateVerticesEj(HEAP32[i23 >> 2] | 0, HEAP32[i27 >> 2] | 0) | 0;
  i1 = HEAP32[i20 >> 2] | 0;
 }
 _memcpy(HEAP32[i21 >> 2] | 0, HEAP32[i27 + 8 >> 2] | 0, i1 * 12 | 0) | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i18 >> 2] | 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, HEAP32[i24 >> 2] | 0);
  HEAP32[i24 >> 2] = 0;
  __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb(HEAP32[i23 >> 2] | 0, HEAP32[i18 >> 2] | 0, 1) | 0;
  i1 = HEAP32[i26 >> 2] | 0;
 }
 f15 = Math_fround(HEAPF32[(HEAP32[i25 >> 2] | 0) + 16 >> 2]);
 f15 = Math_fround(f15 * Math_fround(f15 * Math_fround(25.0e4)));
 i14 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  i29 = 1;
  __ZN5physx11MeshCleanerD2Ev(i27);
  STACKTOP = i30;
  return i29 | 0;
 }
 i13 = HEAP32[i27 + 12 >> 2] | 0;
 i6 = HEAP32[i24 >> 2] | 0;
 i1 = 0;
 i12 = 0;
 do {
  i3 = i12 * 3 | 0;
  i24 = HEAP32[i13 + (i3 << 2) >> 2] | 0;
  i25 = HEAP32[i13 + (i3 + 1 << 2) >> 2] | 0;
  i3 = HEAP32[i13 + (i3 + 2 << 2) >> 2] | 0;
  HEAP32[i6 + (i12 * 12 | 0) >> 2] = i24;
  HEAP32[i6 + (i12 * 12 | 0) + 4 >> 2] = i25;
  HEAP32[i6 + (i12 * 12 | 0) + 8 >> 2] = i3;
  f7 = Math_fround(HEAPF32[i14 + (i24 * 12 | 0) >> 2]);
  f2 = Math_fround(HEAPF32[i14 + (i25 * 12 | 0) >> 2]);
  f31 = Math_fround(f7 - f2);
  f8 = Math_fround(HEAPF32[i14 + (i24 * 12 | 0) + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i14 + (i25 * 12 | 0) + 4 >> 2]);
  f5 = Math_fround(f8 - f4);
  f9 = Math_fround(HEAPF32[i14 + (i24 * 12 | 0) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i14 + (i25 * 12 | 0) + 8 >> 2]);
  f11 = Math_fround(f9 - f10);
  if (!(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f5 * f5)) + Math_fround(f11 * f11)) >= f15)) {
   f11 = Math_fround(HEAPF32[i14 + (i3 * 12 | 0) >> 2]);
   f32 = Math_fround(f2 - f11);
   f5 = Math_fround(HEAPF32[i14 + (i3 * 12 | 0) + 4 >> 2]);
   f4 = Math_fround(f4 - f5);
   f2 = Math_fround(HEAPF32[i14 + (i3 * 12 | 0) + 8 >> 2]);
   f31 = Math_fround(f10 - f2);
   if (!(Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f4 * f4)) + Math_fround(f31 * f31)) >= f15)) {
    f11 = Math_fround(f11 - f7);
    f31 = Math_fround(f5 - f8);
    f32 = Math_fround(f2 - f9);
    if (Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f31 * f31)) + Math_fround(f32 * f32)) >= f15) i29 = 30;
   } else i29 = 30;
  } else i29 = 30;
  if ((i29 | 0) == 30) {
   i29 = 0;
   i1 = 1;
  }
  i12 = i12 + 1 | 0;
 } while (i12 >>> 0 < (HEAP32[i26 >> 2] | 0) >>> 0);
 if (!i1) {
  i29 = 1;
  __ZN5physx11MeshCleanerD2Ev(i27);
  STACKTOP = i30;
  return i29 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 730919 | 0, 236, gb + 731894 | 0, i28);
 i29 = 1;
 __ZN5physx11MeshCleanerD2Ev(i27);
 STACKTOP = i30;
 return i29 | 0;
}

function __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i26, i25, i24) {
 i26 = i26 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i22 = i26 + 2324 | 0;
 if (!(HEAP32[i22 >> 2] | 0)) return;
 i23 = i26 + 2328 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i7 = 1;
  do {
   i3 = i26 + 2048 + (i7 + -1 << 2) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   f8 = Math_fround(HEAPF32[i4 + 32 >> 2]);
   i2 = i26 + 2048 + (i7 << 2) | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i5 = i6 + 32 | 0;
   if (f8 > Math_fround(HEAPF32[i5 >> 2])) {
    HEAP32[i3 >> 2] = i6;
    HEAP32[i2 >> 2] = i4;
    i1 = i7 + -2 | 0;
    L9 : do if ((i1 | 0) > -1) while (1) {
     f8 = Math_fround(HEAPF32[i5 >> 2]);
     i2 = i26 + 2048 + (i1 << 2) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (f8 >= Math_fround(HEAPF32[i3 + 32 >> 2])) break L9;
     HEAP32[i26 + 2048 + (i1 + 1 << 2) >> 2] = i3;
     HEAP32[i2 >> 2] = i6;
     if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
    } while (0);
    i1 = HEAP32[i23 >> 2] | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 i19 = i26 + 2216 | 0;
 i20 = i26 + 2048 | 0;
 i18 = i26 + 2320 | 0;
 i21 = i26 + 2224 | 0;
 i13 = (i1 | 0) == 0;
 if (i13) {
  i2 = HEAP32[i18 >> 2] | 0;
  i3 = 0;
  i1 = i26 + 2240 | 0;
 } else {
  i12 = 0;
  do {
   i9 = HEAP32[i26 + 2048 + (i12 << 2) >> 2] | 0;
   i10 = i9 + 24 | 0;
   HEAP32[i10 >> 2] = i9;
   HEAP32[i9 + 20 >> 2] = i9;
   i11 = (HEAP32[i9 + 52 >> 2] | 0) - (HEAP32[i9 + 48 >> 2] | 0) | 0;
   HEAP32[i9 + 56 >> 2] = i11;
   HEAP32[i9 + 16 >> 2] = 0;
   i5 = i9 + 4 | 0;
   i6 = i9 + 8 | 0;
   f8 = Math_fround(HEAPF32[i21 >> 2]);
   i7 = i12;
   while (1) {
    if (!i7) break;
    i7 = i7 + -1 | 0;
    i4 = HEAP32[i26 + 2048 + (i7 << 2) >> 2] | 0;
    f31 = Math_fround(HEAPF32[i9 >> 2]);
    f29 = Math_fround(HEAPF32[i5 >> 2]);
    f27 = Math_fround(HEAPF32[i6 >> 2]);
    i3 = i4 + 24 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    f30 = Math_fround(HEAPF32[i2 >> 2]);
    f28 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    if (Math_fround(Math_fround(Math_fround(f31 * f30) + Math_fround(f29 * f28)) + Math_fround(f27 * Math_fround(HEAPF32[i2 + 8 >> 2]))) >= f8) {
     i14 = 15;
     break;
    }
   }
   if ((i14 | 0) == 15) {
    i14 = 0;
    HEAP32[i4 + 16 >> 2] = i9;
    HEAP32[i2 + 20 >> 2] = i9;
    HEAP32[i10 >> 2] = i2;
    i17 = (HEAP32[i3 >> 2] | 0) + 56 | 0;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i11;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i1 | 0));
  i2 = HEAP32[i18 >> 2] | 0;
  i17 = i26 + 2240 | 0;
  if (i13) {
   i3 = 0;
   i1 = i17;
  } else {
   i16 = 0;
   do {
    i4 = HEAP32[i26 + 2048 + (i16 << 2) >> 2] | 0;
    if (i4 | 0 ? (HEAP32[i4 + 24 >> 2] | 0) == (i4 | 0) : 0) {
     i3 = HEAP32[i4 + 16 >> 2] | 0;
     if (i3 | 0) while (1) {
      i6 = HEAP32[i4 + 48 >> 2] | 0;
      i13 = i4 + 52 | 0;
      i5 = HEAP32[i13 >> 2] | 0;
      if (i6 >>> 0 < i5 >>> 0) {
       i14 = i3 + 48 | 0;
       i15 = i3 + 52 | 0;
       i4 = HEAP32[i15 >> 2] | 0;
       do {
        i7 = HEAP32[i14 >> 2] | 0;
        if (i7 >>> 0 < i4 >>> 0) {
         i10 = i2 + (i6 << 6) + 16 | 0;
         i11 = i2 + (i6 << 6) + 20 | 0;
         i12 = i2 + (i6 << 6) + 24 | 0;
         i5 = i7;
         do {
          f27 = Math_fround(HEAPF32[i2 + (i5 << 6) + 16 >> 2]);
          f28 = Math_fround(HEAPF32[i2 + (i5 << 6) + 20 >> 2]);
          f31 = Math_fround(HEAPF32[i2 + (i5 << 6) + 24 >> 2]);
          f29 = Math_fround(HEAPF32[i10 >> 2]);
          f30 = Math_fround(HEAPF32[i11 >> 2]);
          f29 = Math_fround(f27 - f29);
          f30 = Math_fround(f28 - f30);
          f31 = Math_fround(f31 - Math_fround(HEAPF32[i12 >> 2]));
          f31 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f31 * f31));
          if (Math_fround(HEAPF32[i17 >> 2]) > f31) {
           i9 = i2 + (i5 << 6) | 0;
           i4 = i2 + (i4 + -1 << 6) | 0;
           i7 = i9 + 52 | 0;
           do {
            HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
            i9 = i9 + 4 | 0;
            i4 = i4 + 4 | 0;
           } while ((i9 | 0) < (i7 | 0));
           i4 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
           HEAP32[i15 >> 2] = i4;
           i5 = i5 + -1 | 0;
          }
          i5 = i5 + 1 | 0;
         } while (i5 >>> 0 < i4 >>> 0);
         i5 = HEAP32[i13 >> 2] | 0;
        }
        i6 = i6 + 1 | 0;
       } while (i6 >>> 0 < i5 >>> 0);
      }
      i4 = HEAP32[i3 + 16 >> 2] | 0;
      if (!i4) break; else {
       i15 = i3;
       i3 = i4;
       i4 = i15;
      }
     }
    }
    i16 = i16 + 1 | 0;
   } while ((i16 | 0) != (i1 | 0));
   i2 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i23 >> 2] | 0;
   i1 = i17;
  }
 }
 __ZN5physx2Gu33MultiplePersistentContactManifold24addManifoldContactPointsEPNS0_21MeshPersistentContactEjPPNS0_15PCMContactPatchEjRKNS_6shdfnd3aos6FloatVESB_h(HEAP32[i19 >> 2] | 0, i2, HEAP32[i22 >> 2] | 0, i20, i3, i1, i21, i25);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i23 >> 2] = 0;
 if (!i24) return;
 HEAP32[i20 >> 2] = i26;
 HEAP32[i26 + 2052 >> 2] = i26 + 64;
 HEAP32[i26 + 2056 >> 2] = i26 + 128;
 HEAP32[i26 + 2060 >> 2] = i26 + 192;
 HEAP32[i26 + 2064 >> 2] = i26 + 256;
 HEAP32[i26 + 2068 >> 2] = i26 + 320;
 HEAP32[i26 + 2072 >> 2] = i26 + 384;
 HEAP32[i26 + 2076 >> 2] = i26 + 448;
 HEAP32[i26 + 2080 >> 2] = i26 + 512;
 HEAP32[i26 + 2084 >> 2] = i26 + 576;
 HEAP32[i26 + 2088 >> 2] = i26 + 640;
 HEAP32[i26 + 2092 >> 2] = i26 + 704;
 HEAP32[i26 + 2096 >> 2] = i26 + 768;
 HEAP32[i26 + 2100 >> 2] = i26 + 832;
 HEAP32[i26 + 2104 >> 2] = i26 + 896;
 HEAP32[i26 + 2108 >> 2] = i26 + 960;
 HEAP32[i26 + 2112 >> 2] = i26 + 1024;
 HEAP32[i26 + 2116 >> 2] = i26 + 1088;
 HEAP32[i26 + 2120 >> 2] = i26 + 1152;
 HEAP32[i26 + 2124 >> 2] = i26 + 1216;
 HEAP32[i26 + 2128 >> 2] = i26 + 1280;
 HEAP32[i26 + 2132 >> 2] = i26 + 1344;
 HEAP32[i26 + 2136 >> 2] = i26 + 1408;
 HEAP32[i26 + 2140 >> 2] = i26 + 1472;
 HEAP32[i26 + 2144 >> 2] = i26 + 1536;
 HEAP32[i26 + 2148 >> 2] = i26 + 1600;
 HEAP32[i26 + 2152 >> 2] = i26 + 1664;
 HEAP32[i26 + 2156 >> 2] = i26 + 1728;
 HEAP32[i26 + 2160 >> 2] = i26 + 1792;
 HEAP32[i26 + 2164 >> 2] = i26 + 1856;
 HEAP32[i26 + 2168 >> 2] = i26 + 1920;
 HEAP32[i26 + 2172 >> 2] = i26 + 1984;
 return;
}

function __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i5 + 156 | 0;
 i9 = i5 + 120 | 0;
 i8 = i5 + 60 | 0;
 i7 = i5 + 72 | 0;
 i6 = i5;
 f25 = Math_fround(HEAPF32[i2 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f32 = Math_fround(f25 + f25);
 f24 = Math_fround(f39 + f39);
 f22 = Math_fround(f17 + f17);
 f29 = Math_fround(f39 * f24);
 f12 = Math_fround(f17 * f22);
 f39 = Math_fround(f32 * f39);
 f37 = Math_fround(f32 * f17);
 f31 = Math_fround(f32 * f20);
 f17 = Math_fround(f24 * f17);
 f24 = Math_fround(f24 * f20);
 f20 = Math_fround(f22 * f20);
 f22 = Math_fround(Math_fround(Math_fround(1.0) - f29) - f12);
 f30 = Math_fround(f39 + f20);
 f27 = Math_fround(f37 - f24);
 f20 = Math_fround(f39 - f20);
 f32 = Math_fround(Math_fround(1.0) - Math_fround(f25 * f32));
 f12 = Math_fround(f32 - f12);
 f25 = Math_fround(f17 + f31);
 f24 = Math_fround(f37 + f24);
 f31 = Math_fround(f17 - f31);
 f29 = Math_fround(f32 - f29);
 f32 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f39 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f15 = Math_fround(f32 + f32);
 f33 = Math_fround(f17 + f17);
 f14 = Math_fround(f37 + f37);
 f18 = Math_fround(f17 * f33);
 f38 = Math_fround(f37 * f14);
 f17 = Math_fround(f15 * f17);
 f35 = Math_fround(f15 * f37);
 f16 = Math_fround(f15 * f39);
 f37 = Math_fround(f33 * f37);
 f33 = Math_fround(f33 * f39);
 f39 = Math_fround(f14 * f39);
 f14 = Math_fround(Math_fround(Math_fround(1.0) - f18) - f38);
 f13 = Math_fround(f17 + f39);
 f23 = Math_fround(f35 - f33);
 f39 = Math_fround(f17 - f39);
 f15 = Math_fround(Math_fround(1.0) - Math_fround(f32 * f15));
 f38 = Math_fround(f15 - f38);
 f32 = Math_fround(f37 + f16);
 f33 = Math_fround(f35 + f33);
 f16 = Math_fround(f37 - f16);
 f18 = Math_fround(f15 - f18);
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f37 = Math_fround(f15 * f14);
 f35 = Math_fround(f15 * f39);
 f15 = Math_fround(f15 * f33);
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f36 = Math_fround(f13 * f17);
 f34 = Math_fround(f38 * f17);
 f17 = Math_fround(f16 * f17);
 f28 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(f23 * f28);
 f11 = Math_fround(f32 * f28);
 f28 = Math_fround(f18 * f28);
 f21 = Math_fround(Math_fround(Math_fround(f14 * f37) + Math_fround(f13 * f36)) + Math_fround(f23 * f26));
 f19 = Math_fround(Math_fround(Math_fround(f14 * f35) + Math_fround(f13 * f34)) + Math_fround(f23 * f11));
 f23 = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(f13 * f17)) + Math_fround(f23 * f28));
 f13 = Math_fround(Math_fround(Math_fround(f39 * f37) + Math_fround(f38 * f36)) + Math_fround(f32 * f26));
 f14 = Math_fround(Math_fround(Math_fround(f39 * f35) + Math_fround(f38 * f34)) + Math_fround(f32 * f11));
 f32 = Math_fround(Math_fround(Math_fround(f39 * f15) + Math_fround(f38 * f17)) + Math_fround(f32 * f28));
 f26 = Math_fround(Math_fround(Math_fround(f33 * f37) + Math_fround(f16 * f36)) + Math_fround(f18 * f26));
 f11 = Math_fround(Math_fround(Math_fround(f33 * f35) + Math_fround(f16 * f34)) + Math_fround(f18 * f11));
 f28 = Math_fround(Math_fround(Math_fround(f33 * f15) + Math_fround(f16 * f17)) + Math_fround(f18 * f28));
 f18 = Math_fround(Math_fround(f31 * f23) + Math_fround(Math_fround(f30 * f21) + Math_fround(f12 * f19)));
 f17 = Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f27 * f21) + Math_fround(f25 * f19)));
 f16 = Math_fround(Math_fround(f24 * f32) + Math_fround(Math_fround(f22 * f13) + Math_fround(f20 * f14)));
 f15 = Math_fround(Math_fround(f31 * f32) + Math_fround(Math_fround(f30 * f13) + Math_fround(f12 * f14)));
 f14 = Math_fround(Math_fround(f29 * f32) + Math_fround(Math_fround(f27 * f13) + Math_fround(f25 * f14)));
 f13 = Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f22 * f26) + Math_fround(f20 * f11)));
 f12 = Math_fround(Math_fround(f31 * f28) + Math_fround(Math_fround(f30 * f26) + Math_fround(f12 * f11)));
 f11 = Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f11)));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(f24 * f23) + Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f19)));
 HEAPF32[i10 + 4 >> 2] = f18;
 HEAPF32[i10 + 8 >> 2] = f17;
 HEAPF32[i10 + 12 >> 2] = f16;
 HEAPF32[i10 + 16 >> 2] = f15;
 HEAPF32[i10 + 20 >> 2] = f14;
 HEAPF32[i10 + 24 >> 2] = f13;
 HEAPF32[i10 + 28 >> 2] = f12;
 HEAPF32[i10 + 32 >> 2] = f11;
 __ZN5physx10getInverseERNS_7PxMat33ERNS_6PxVec3ERKS0_RKS2_(i9, i8, i10, i2 + 16 | 0);
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i7 + 32 >> 2] = HEAP32[i9 + 32 >> 2];
 HEAP32[i7 + 36 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physx9transformERKNS_2Cm8Matrix34ERKNS_2Gu3BoxE(i6, i7, i4);
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i6 + 56 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN11OffMeshLink8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 3);
 i3 = __ZN14SafeBinaryRead12IsOldVersionEi(i8, 2) | 0;
 i4 = i6 + 88 | 0;
 i1 = HEAP32[gb + 37304 >> 2] | 0;
 if (i3) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842675 | 0, i1, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i2 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i2 >>> 0) i5 = 7; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i5 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842690 | 0, i1, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i5 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 19; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i5 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 }
 i2 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898897 | 0, gb + 842702 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843739 | 0, gb + 842702 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842718 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i8 + 16 | 0;
   i1 = HEAP32[i8 + 20 >> 2] | 0;
   i3 = i1 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i1 >>> 0) i5 = 43; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 43; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i5 | 0) == 43) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 98 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842733 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 99 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842749 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 842761 | 0, i4, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z17MergeLightmapDataiR18AwakeFromLoadQueue(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i17;
 i14 = i17 + 16 | 0;
 i15 = i17 + 12 | 0;
 i6 = i13 + 12 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i5 = 0;
 L4 : while (1) {
  i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 * 12 | 0) + 4 >> 2] | 0;
  do if (i4 | 0) {
   HEAP32[i15 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i16 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
     i2 = HEAP32[i14 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i16 = 12;
    }
   }
   if ((i16 | 0) == 10) i16 = 12;
   if ((i16 | 0) == 12) {
    i16 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30672 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30672 + 28 >> 2] | 0) >>> 0)) break L4;
  } while (0);
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
   i16 = 48;
   break;
  }
 }
 if ((i16 | 0) == 48) {
  STACKTOP = i17;
  return;
 }
 i10 = i1 + 36 | 0;
 i11 = i1 + 100 | 0;
 if (!(HEAP32[i10 + 12 >> 2] | 0)) {
  if (HEAP32[i11 + 32 >> 2] | 0) i16 = 16;
 } else i16 = 16;
 if ((i16 | 0) == 16) {
  i2 = HEAP32[(HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 28 >> 2] | 0) + 12 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 12 >> 2] | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i9 = HEAP32[gb + 43440 + (i2 << 2) >> 2] | 0;
   i8 = HEAP32[gb + 43440 + (i3 << 2) >> 2] | 0;
   HEAP32[i7 >> 2] = i9;
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i7 + 8 >> 2] = i9;
   __Z6FormatPKcz(i14, gb + 402976 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 403085 | 0, 463, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i8 = HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 100 + 92 >> 2] | 0;
  i9 = HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 36 + 12 >> 2] | 0;
  if (i9 | i8 | 0) {
   i6 = i13 + 232 | 0;
   if (HEAP32[i6 >> 2] | 0) {
    i7 = i13 + 220 | 0;
    i5 = 0;
    do {
     i2 = HEAP32[i7 >> 2] | 0;
     do if (((HEAP32[(HEAP32[i2 + (i5 * 12 | 0) + 8 >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) {
      HEAP32[i15 >> 2] = HEAP32[i2 + (i5 * 12 | 0) + 4 >> 2];
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
      if (i2 | 0) {
       if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[i2 + 32 >> 2] | 0;
        i2 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i2, i15);
        i3 = HEAP32[i14 >> 2] | 0;
        i18 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i2 = (i3 | 0) == -1 ? i18 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i18 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i2 | 0) != (i3 + (i4 << 3) | 0)) {
        i2 = HEAP32[i2 + 4 >> 2] | 0;
        if (!i2) break;
        i18 = i2 + 32 + 228 | 0;
        i4 = HEAP32[i18 >> 2] | 0;
        i3 = i4 >>> 16;
        HEAP32[i18 >> 2] = ((i3 & 65535) < 65534 ? i8 : 0) + i3 << 16 | ((i4 & 65535) < 65534 ? i9 : 0) + i4 & 65535;
        break;
       }
      }
     } while (0);
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
   }
   i2 = __Z18GetITerrainManagerv() | 0;
   if (i2 | 0) mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i13 | 0, i9 | 0, i8 | 0);
  }
  __ZN16LightmapSettings15AppendLightmapsEiRK13dynamic_arrayI12LightmapDataLj4EE(__Z21GetManagerFromContexti(26) | 0, i12, i10);
  if (HEAP32[i11 + 32 >> 2] | 0) {
   if (!(HEAP32[i11 + 72 >> 2] | 0)) __ZN21EnlightenSceneMapping14SetSceneHandleEi(i11, i12);
   __ZN21EnlightenSceneMapping6AppendEiRKS_((__Z21GetManagerFromContexti(26) | 0) + 100 | 0, i12, i11);
  }
 }
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i16 = 43; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
   i2 = HEAP32[i14 >> 2] | 0;
   i18 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 43; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i16 = 45;
  }
 }
 if ((i16 | 0) == 43) i16 = 45;
 if ((i16 | 0) == 45) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i17;
   return;
  }
 }
 if (!(__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i1 + 32 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i18 = __Z21GetManagerFromContexti(26) | 0;
 HEAP32[i18 + 32 >> 2] = HEAP32[i1 + 4 >> 2];
 STACKTOP = i17;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager13connectAddRefEPN5physx8debugger18PvdNetworkInStreamERNS2_19PvdNetworkOutStreamENS1_7PxFlagsINS2_17PvdConnectionType4EnumEjEEb(i10, i4, i5, i6, i3) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i2 = i13 + 4 | 0;
 i12 = i10 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i12 >> 2] | 0);
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 i11 = i10 + 20 | 0;
 i9 = HEAP32[i10 + 12 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 i1 = __ZN5physx8debugger4comm31PvdCommStreamInternalConnection6createERNS_19PxAllocatorCallbackES4_RNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamENS_7PxFlagsINS0_17PvdConnectionType4EnumEjEERNS1_21PvdConnectionListenerERNS_6shdfnd6MutexTINS0_19ForwardingAllocatorEEEb(i9, i1, i5, i4, i2, i10 + 4 | 0, i10 + 192 | 0, i3) | 0;
 i2 = i1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) == 0 | (i3 | 0) == (i1 | 0)) HEAP32[i11 >> 2] = i2; else {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
  HEAP32[i11 >> 2] = i2;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i8 = HEAP32[i11 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (!i9) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0);
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 76 >> 2] | 0, i8 | 0);
 if (HEAP32[i6 >> 2] & 4 | 0) {
  i1 = i10 + 204 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
  i2 = HEAP32[i10 + 172 >> 2] | 0;
  if (!i2) {
   i5 = i10 + 176 | 0;
   HEAP32[i5 >> 2] = fb + 188;
   HEAP32[i5 + 4 >> 2] = 0;
   i5 = i10 + 184 | 0;
   HEAP32[i5 >> 2] = fb + 3678;
   HEAP32[i5 + 4 >> 2] = 0;
  } else mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, (i9 ? 0 : i8 + 8 | 0) | 0);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 }
 i1 = HEAP32[i10 + 208 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 >> 2] & 2 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i8 + 4 | 0);
 if ((__ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE((__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 116 | 0, i8 + 12 | 0) | 0) < 0) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 776869 | 0, 231, gb + 777117 | 0, i7);
 i7 = i10 + 68 | 0;
 L25 : do if (!(HEAP32[i10 + 72 >> 2] | 0)) {
  i2 = 0;
  i1 = -1;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i10 + 76 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i2 = i3;
     i1 = -1;
     break L25;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i10 + 60 | 0;
 i5 = i10 + 64 | 0;
 i4 = i10 + 76 | 0;
 L32 : while (1) {
  do {
   if ((i1 | 0) == -1) break L32;
   i3 = HEAP32[i6 >> 2] | 0;
   if (HEAP8[i3 + (i1 << 4) + 10 >> 0] | 0) {
    mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 60 >> 2] | 0, i8 | 0, HEAP32[i3 + (i1 << 4) >> 2] | 0, i3 + (i1 << 4) + 6 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
   }
   if (HEAP8[i3 + (i1 << 4) + 5 >> 0] | 0) {
    mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0, i8 | 0, HEAP32[i3 + (i1 << 4) >> 2] | 0, (HEAP8[i3 + (i1 << 4) + 4 >> 0] | 0) != 0 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
   }
   if (HEAP8[i3 + (i1 << 4) + 12 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 72 >> 2] | 0, i8 | 0, HEAP32[i3 + (i1 << 4) >> 2] | 0, (HEAP8[i3 + (i1 << 4) + 11 >> 0] | 0) != 0 | 0);
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i2 = i3;
    i1 = -1;
    continue L32;
   }
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L32;
  }
 }
 i7 = i10 + 120 | 0;
 L51 : do if (!(HEAP32[i10 + 124 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i10 + 128 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L51;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i10 + 112 | 0;
 i6 = i10 + 116 | 0;
 i4 = i10 + 128 | 0;
 L58 : while (1) {
  do {
   if ((i1 | 0) == -1) break L58;
   i3 = HEAP32[i5 >> 2] | 0;
   mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 64 >> 2] | 0, i8 | 0, HEAP32[i3 + (i1 * 48 | 0) + 8 >> 2] | 0, i3 + (i1 * 48 | 0) + 12 | 0, i3 + (i1 * 48 | 0) + 24 | 0, i3 + (i1 * 48 | 0) + 36 | 0);
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L58;
   }
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L58;
  }
 }
 i4 = i10 + 164 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i10 + 160 | 0;
  i3 = 0;
  do {
   i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i1 = i10 + 160 | 0;
   i2 = 0;
   do {
    i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i8 | 0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 if (i9) {
  i12 = HEAP32[i12 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i13;
  return i1 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0);
 i12 = HEAP32[i12 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
 STACKTOP = i13;
 return i1 | 0;
}

function __Z10EncodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i20, i8) {
 i20 = i20 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23 + 8 | 0;
 i17 = i23;
 i21 = i23 + 24 | 0;
 i22 = i23 + 12 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i15 = i8 + 11 | 0;
 i2 = HEAP8[i15 >> 0] | 0;
 i16 = i8 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if (!((i2 << 24 >> 24 < 0 ? i3 : i2 & 255) | 0)) {
  STACKTOP = i23;
  return;
 }
 i9 = i21 + 11 | 0;
 i10 = i21 + 4 | 0;
 i11 = i21 + 11 | 0;
 i12 = i21 + 4 | 0;
 i13 = i21 + 11 | 0;
 i14 = i21 + 4 | 0;
 i1 = 0;
 L4 : while (1) {
  i7 = i2 << 24 >> 24 < 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i5 = i7 ? i6 : i8;
  i3 = i7 ? i3 : i2 & 255;
  if (i3 >>> 0 <= i1 >>> 0) {
   i19 = 8;
   break;
  }
  i4 = i5 + i3 | 0;
  i3 = i5 + i1 | 0;
  while (1) {
   if (!(_memchr(gb + 488830 | 0, HEAPU8[i3 >> 0] | 0, 63) | 0)) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) {
    i19 = 8;
    break L4;
   }
  }
  i7 = i3 - i5 | 0;
  if ((i7 | 0) == -1) {
   i19 = 8;
   break;
  }
  if (i7 >>> 0 > i1 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i22, i8, i1, i7 - i1 | 0, i8);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i21, i22);
   i2 = HEAP8[i9 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   i4 = HEAP32[i21 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i3 ? i1 : i2 & 255) | 0) {
    i3 = i3 ? i4 : i21;
    do {
     i6 = HEAP8[i3 >> 0] | 0;
     i2 = i6 << 24 >> 24;
     HEAP8[i3 >> 0] = (i6 + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
     i3 = i3 + 1 | 0;
     i2 = HEAP8[i9 >> 0] | 0;
     i6 = i2 << 24 >> 24 < 0;
     i4 = HEAP32[i21 >> 2] | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    } while ((i3 | 0) != ((i6 ? i4 : i21) + (i6 ? i1 : i2 & 255) | 0));
   }
   i6 = i2 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i6 ? i4 : i21, i6 ? i1 : i2 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
   i2 = HEAP8[i15 >> 0] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i6;
  i3 = i2 << 24 >> 24 < 0;
  i5 = i3 ? i1 : i8;
  i1 = HEAP8[i5 + i7 >> 0] | 0;
  switch (i1 << 24 >> 24) {
  case 63:
   {
    i19 = 42;
    break L4;
   }
  case 37:
   {
    i4 = i7 + 2 | 0;
    if (i4 >>> 0 < (i3 ? HEAP32[i16 >> 2] | 0 : i2 & 255) >>> 0) {
     i1 = HEAP8[i5 + (i7 + 1) >> 0] | 0;
     i2 = i1 << 24 >> 24;
     do if ((i1 + -48 & 255) < 10) i1 = i2 + 208 | 0; else if ((i1 + -97 & 255) < 6) {
      i1 = i2 + 169 | 0;
      break;
     } else {
      i1 = (i1 + -65 & 255) < 6 ? i2 + 201 | 0 : 0;
      break;
     } while (0);
     i3 = i1 << 4;
     i1 = HEAP8[i5 + i4 >> 0] | 0;
     i2 = i1 << 24 >> 24;
     do if ((i1 + -48 & 255) < 10) i1 = i2 + 208 | 0; else if ((i1 + -97 & 255) < 6) {
      i1 = i2 + 169 | 0;
      break;
     } else {
      i1 = (i1 + -65 & 255) < 6 ? i2 + 201 | 0 : 0;
      break;
     } while (0);
     i1 = i1 | i3;
     i2 = i1 << 24 >> 24;
     i2 = ((i1 & 255) + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
     i1 = i2 & 255;
     i2 = i2 & 255;
     do if ((i1 + -97 & 255) < 26) i19 = 31; else if (i1 << 24 >> 24 == 32 | (i1 + -48 & 255) < 10) i19 = 31; else if (i1 << 24 >> 24 == 47) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i20, 45);
      break;
     } else {
      HEAP32[i17 >> 2] = i2;
      __Z6FormatPKcz(i21, gb + 488894 | 0, i17);
      i6 = HEAP8[i11 >> 0] | 0;
      i5 = i6 << 24 >> 24 < 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i5 ? HEAP32[i21 >> 2] | 0 : i21, i5 ? HEAP32[i12 >> 2] | 0 : i6 & 255) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
      break;
     } while (0);
     if ((i19 | 0) == 31) {
      i19 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i20, i1);
     }
     i1 = i7 + 3 | 0;
    } else i19 = 40;
    break;
   }
  case 47:
   {
    i2 = i3 ? HEAP32[i16 >> 2] | 0 : i2 & 255;
    i1 = i7;
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break;
    } while ((HEAP8[i5 + i1 >> 0] | 0) == 47);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i20, 45);
    break;
   }
  default:
   i19 = 40;
  }
  if ((i19 | 0) == 40) {
   i19 = 0;
   HEAP32[i18 >> 2] = i1 << 24 >> 24;
   __Z6FormatPKcz(i21, gb + 488894 | 0, i18);
   i1 = HEAP8[i13 >> 0] | 0;
   i6 = i1 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i6 ? HEAP32[i21 >> 2] | 0 : i21, i6 ? HEAP32[i14 >> 2] | 0 : i1 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   i1 = i7 + 1 | 0;
  }
  i2 = HEAP8[i15 >> 0] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  if (i1 >>> 0 >= (i2 << 24 >> 24 < 0 ? i3 : i2 & 255) >>> 0) {
   i19 = 42;
   break;
  }
 }
 if ((i19 | 0) == 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i22, i8, i1, -1, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i21, i22);
  i5 = i21 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i2 = HEAP32[i21 >> 2] | 0;
  i6 = i21 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i4 ? i1 : i3 & 255) | 0) {
   i4 = i4 ? i2 : i21;
   do {
    i19 = HEAP8[i4 >> 0] | 0;
    i3 = i19 << 24 >> 24;
    HEAP8[i4 >> 0] = (i19 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
    i4 = i4 + 1 | 0;
    i3 = HEAP8[i5 >> 0] | 0;
    i19 = i3 << 24 >> 24 < 0;
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   } while ((i4 | 0) != ((i19 ? i2 : i21) + (i19 ? i1 : i3 & 255) | 0));
  }
  i19 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i19 ? i2 : i21, i19 ? i1 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
  STACKTOP = i23;
  return;
 } else if ((i19 | 0) == 42) {
  STACKTOP = i23;
  return;
 }
}

function __ZNSt3__26locale5__impC2ERKS1_S3_i(i4, i2, i5, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i4 >> 2] = gb + 212688 + 8;
 i11 = i4 + 8 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i11 | 0, 28);
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i10 = i4 + 144 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i10 | 0, gb + 1086428 | 0, 1);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   if ((i4 | 0) == (i2 | 0)) i7 = 5; else {
    __THREW__ = 0;
    invoke_viii(fb + 1050 | 0, i11 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else i7 = 5;
   }
   if ((i7 | 0) == 5) {
    i8 = i4 + 12 | 0;
    i3 = 0;
    while (1) {
     i2 = HEAP32[i11 >> 2] | 0;
     if (i3 >>> 0 >= (HEAP32[i8 >> 2] | 0) - i2 >> 2 >>> 0) break;
     i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i2);
     i3 = i3 + 1 | 0;
    }
    if (!(i6 & 8)) i7 = 19; else {
     __THREW__ = 0;
     invoke_vii(fb + 4589 | 0, i4 | 0, i5 | 0);
     i3 = __THREW__;
     __THREW__ = 0;
     if (!(i3 & 1)) {
      __THREW__ = 0;
      invoke_vii(fb + 4590 | 0, i4 | 0, i5 | 0);
      i3 = __THREW__;
      __THREW__ = 0;
      if (!(i3 & 1)) i7 = 19;
     }
    }
    do if ((i7 | 0) == 19) {
     if (i6 & 1 | 0) {
      __THREW__ = 0;
      invoke_vii(fb + 4591 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4592 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4593 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4594 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4595 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4596 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
     }
     if (i6 & 16 | 0) {
      __THREW__ = 0;
      invoke_vii(fb + 4597 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4598 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4599 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4600 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4601 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4602 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4603 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4604 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
     }
     if (i6 & 2 | 0) {
      __THREW__ = 0;
      invoke_vii(fb + 4605 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4606 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4607 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4608 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4609 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4610 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
     }
     if (i6 & 4 | 0) {
      __THREW__ = 0;
      invoke_vii(fb + 4611 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4612 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4613 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4614 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
     }
     if (i6 & 32 | 0) {
      __THREW__ = 0;
      invoke_vii(fb + 4615 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
      __THREW__ = 0;
      invoke_vii(fb + 4616 | 0, i4 | 0, i5 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) break;
     }
     return;
    } while (0);
    i3 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___cxa_begin_catch(i3 | 0) | 0;
    i3 = 0;
    while (1) {
     i2 = HEAP32[i11 >> 2] | 0;
     if (i3 >>> 0 >= (HEAP32[i8 >> 2] | 0) - i2 >> 2 >>> 0) break;
     i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
     i3 = i3 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_v(fb + 460 | 0);
    __THREW__ = 0;
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __THREW__ = 0;
    invoke_v(fb + 458 | 0);
    i9 = __THREW__;
    __THREW__ = 0;
    if (i9 & 1) {
     i9 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i9);
    } else i1 = i2;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  }
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i11);
 }
 ___resumeException(i1 | 0);
}

function __Z23sweepCCTBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i4, i2, i3, i28, f19, i27, i24, f1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i28 = i28 | 0;
 f19 = Math_fround(f19);
 i27 = i27 | 0;
 i24 = i24 | 0;
 f1 = Math_fround(f1);
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i26 + 152 | 0;
 i25 = i26 + 92 | 0;
 i7 = i26 + 80 | 0;
 i30 = i26 + 68 | 0;
 i22 = i26 + 40 | 0;
 i31 = i26 + 12 | 0;
 i29 = i26 + 168 | 0;
 i23 = i26;
 f33 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f35 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f34 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f37 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 i20 = i2 + 16 | 0;
 f37 = Math_fround(f37 - Math_fround(HEAPF32[i20 >> 2]));
 f36 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 i21 = i2 + 20 | 0;
 f36 = Math_fround(f36 - Math_fround(HEAPF32[i21 >> 2]));
 f38 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 i8 = i2 + 24 | 0;
 f38 = Math_fround(f38 - Math_fround(HEAPF32[i8 >> 2]));
 HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
 i9 = i25 + 4 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 + 4 >> 2];
 i10 = i25 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i11 = i25 + 16 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 + 16 >> 2];
 i12 = i25 + 20 | 0;
 HEAP32[i12 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i25 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 i13 = i25 + 28 | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 + 28 >> 2];
 i14 = i25 + 32 | 0;
 HEAP32[i14 >> 2] = HEAP32[i3 + 32 >> 2];
 i15 = i25 + 36 | 0;
 HEAPF32[i15 >> 2] = f37;
 i16 = i25 + 40 | 0;
 HEAPF32[i16 >> 2] = f36;
 i17 = i25 + 44 | 0;
 HEAPF32[i17 >> 2] = f38;
 i18 = i25 + 48 | 0;
 HEAP32[i18 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i25 + 52 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i25 + 56 >> 2] = HEAP32[i3 + 56 >> 2];
 f38 = Math_fround(-Math_fround(HEAPF32[i28 >> 2]));
 i5 = i28 + 4 | 0;
 f36 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
 i6 = i28 + 8 | 0;
 f37 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i30 >> 2] = f38;
 HEAPF32[i30 + 4 >> 2] = f36;
 HEAPF32[i30 + 8 >> 2] = f37;
 f37 = Math_fround(f33 * Math_fround(2.0));
 f36 = Math_fround(f34 * Math_fround(2.0));
 f34 = Math_fround(Math_fround(f33 * f37) + Math_fround(Math_fround(f34 * f36) + Math_fround(-1.0)));
 f33 = Math_fround(Math_fround(f37 * f1) + Math_fround(f35 * f36));
 f36 = Math_fround(Math_fround(f37 * f35) - Math_fround(f1 * f36));
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f34 = Math_fround(f34 * f1);
 f33 = Math_fround(f33 * f1);
 f1 = Math_fround(f36 * f1);
 f36 = Math_fround(f33 + Math_fround(0.0));
 f35 = Math_fround(f1 + Math_fround(0.0));
 HEAPF32[i22 >> 2] = Math_fround(f34 + Math_fround(0.0));
 HEAPF32[i22 + 4 >> 2] = f36;
 HEAPF32[i22 + 8 >> 2] = f35;
 f33 = Math_fround(Math_fround(0.0) - f33);
 f1 = Math_fround(Math_fround(0.0) - f1);
 HEAPF32[i22 + 12 >> 2] = Math_fround(Math_fround(0.0) - f34);
 HEAPF32[i22 + 16 >> 2] = f33;
 HEAPF32[i22 + 20 >> 2] = f1;
 HEAP32[i22 + 24 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i32, i25);
 HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
 HEAP32[i31 + 12 >> 2] = HEAP32[i32 + 12 >> 2];
 HEAP32[i31 + 16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i31 + 20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i31 + 24 >> 2] = HEAP32[i17 >> 2];
 i4 = i27 + 16 | 0;
 i3 = i27 + 40 | 0;
 HEAP16[i29 >> 1] = HEAP16[i24 >> 1] | 0;
 if (!(__ZN5physx2Gu15sweepCapsuleBoxERKNS0_7CapsuleERKNS_11PxTransformERKNS_6PxVec3ES9_fRS7_RfSA_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i22, i31, i18, i30, f19, i4, i3, i7, i29) | 0)) {
  i32 = 0;
  STACKTOP = i26;
  return i32 | 0;
 }
 f36 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
 f37 = Math_fround(-Math_fround(HEAPF32[i7 + 4 >> 2]));
 f38 = Math_fround(-Math_fround(HEAPF32[i7 + 8 >> 2]));
 HEAPF32[i27 + 28 >> 2] = f36;
 HEAPF32[i27 + 32 >> 2] = f37;
 HEAPF32[i27 + 36 >> 2] = f38;
 i2 = i27 + 12 | 0;
 HEAP16[i2 >> 1] = 6;
 if (!(HEAP16[i24 >> 1] & 1)) {
  i32 = 1;
  STACKTOP = i26;
  return i32 | 0;
 }
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f1 != Math_fround(0.0))) {
  i32 = 1;
  STACKTOP = i26;
  return i32 | 0;
 }
 f36 = Math_fround(f1 * Math_fround(HEAPF32[i28 >> 2]));
 f37 = Math_fround(f1 * Math_fround(HEAPF32[i5 >> 2]));
 f38 = Math_fround(f1 * Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i15 >> 2] = Math_fround(f36 + Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i16 >> 2] = Math_fround(f37 + Math_fround(HEAPF32[i16 >> 2]));
 HEAPF32[i17 >> 2] = Math_fround(f38 + Math_fround(HEAPF32[i17 >> 2]));
 Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i22, i22 + 12 | 0, i15, i18, i25, 0, i23));
 f38 = Math_fround(HEAPF32[i23 >> 2]);
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i25 >> 2]));
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i9 >> 2]));
 f38 = Math_fround(f38 * Math_fround(HEAPF32[i10 >> 2]));
 f35 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f33 = Math_fround(f35 * Math_fround(HEAPF32[i25 + 12 >> 2]));
 f34 = Math_fround(f35 * Math_fround(HEAPF32[i11 >> 2]));
 f33 = Math_fround(f37 + f33);
 f34 = Math_fround(f36 + f34);
 f35 = Math_fround(f38 + Math_fround(f35 * Math_fround(HEAPF32[i12 >> 2])));
 f38 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f36 = Math_fround(f38 * Math_fround(HEAPF32[i25 + 24 >> 2]));
 f37 = Math_fround(f38 * Math_fround(HEAPF32[i13 >> 2]));
 f36 = Math_fround(f33 + f36);
 f37 = Math_fround(f34 + f37);
 f38 = Math_fround(f35 + Math_fround(f38 * Math_fround(HEAPF32[i14 >> 2])));
 f36 = Math_fround(f36 + Math_fround(HEAPF32[i25 + 36 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i16 >> 2]));
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i17 >> 2]));
 f36 = Math_fround(f36 + Math_fround(HEAPF32[i20 >> 2]));
 f37 = Math_fround(f37 + Math_fround(HEAPF32[i21 >> 2]));
 f38 = Math_fround(f38 + Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i4 >> 2] = f36;
 HEAPF32[i27 + 20 >> 2] = f37;
 HEAPF32[i27 + 24 >> 2] = f38;
 HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 1;
 i32 = 1;
 STACKTOP = i26;
 return i32 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i10, i14, i13, i1) {
 i10 = i10 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i8 = i5;
 i12 = i11;
 do if (i5 >>> 0 < i11 >>> 0) i6 = 1; else if (i11 >>> 0 < i5 >>> 0) i6 = 0; else {
  i2 = i14 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i10 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
   i9 = i14 + 16 | 0;
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i6 = i10 + 16 | 0;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i6 = i4 >>> 0 < i7 >>> 0 | ((i4 | 0) == (i7 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0 : 0);
   break;
  } else {
   i6 = i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 i7 = i1;
 do if (i1 >>> 0 < i5 >>> 0) i1 = 1; else if (i5 >>> 0 < i1 >>> 0) i1 = 0; else {
  i2 = i13 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i14 + 8 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0)) {
   i9 = i13 + 16 | 0;
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = i14 + 16 | 0;
   i5 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i4 >>> 0 < i5 >>> 0 | ((i4 | 0) == (i5 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0 : 0);
   break;
  } else {
   i1 = i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0;
   break;
  }
 } while (0);
 if (!i6) {
  if (!i1) {
   i14 = 0;
   return i14 | 0;
  }
  HEAP32[i14 >> 2] = i7;
  HEAP32[i13 >> 2] = i8;
  i8 = i14 + 8 | 0;
  i12 = i8;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i9 = i14 + 16 | 0;
  i2 = i9;
  i6 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i13 + 8 | 0;
  i5 = i7;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i8;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i13 + 16 | 0;
  i4 = i1;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i13 = i9;
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = i5;
  HEAP32[i7 >> 2] = i11;
  HEAP32[i7 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i6 = i2;
  i7 = i1;
  do if (i1 >>> 0 < i2 >>> 0) {
   i1 = i8;
   i3 = i10 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } else {
   if (i2 >>> 0 < i1 >>> 0) {
    i14 = 1;
    return i14 | 0;
   }
   i1 = i8;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = i10 + 8 | 0;
   i5 = i3;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0) & (i1 | 0) == (i5 | 0)) {
    i12 = i9;
    i5 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i10 + 16 | 0;
    i11 = HEAP32[i13 + 4 >> 2] | 0;
    if (i5 >>> 0 < i11 >>> 0 | ((i5 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) break; else i1 = 1;
    return i1 | 0;
   } else {
    if (i1 >>> 0 < i5 >>> 0 | (i1 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) break; else i1 = 1;
    return i1 | 0;
   }
  } while (0);
  HEAP32[i10 >> 2] = i7;
  HEAP32[i14 >> 2] = i6;
  i11 = i3;
  i7 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i14 = i10 + 16 | 0;
  i13 = i14;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i1;
  i6 = i9;
  i10 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i14 + 4 >> 2] = i10;
  i14 = i8;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i14 + 4 >> 2] = i11;
  i14 = i9;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i13;
  i14 = 2;
  return i14 | 0;
 }
 if (i1) {
  HEAP32[i10 >> 2] = i7;
  HEAP32[i13 >> 2] = i12;
  i14 = i10 + 8 | 0;
  i9 = i14;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = i10 + 16 | 0;
  i12 = i5;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i10 = i13 + 8 | 0;
  i7 = i10;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i14 + 4 >> 2] = i6;
  i14 = i13 + 16 | 0;
  i6 = i14;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i13 = i5;
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 + 4 >> 2] = i7;
  i13 = i10;
  HEAP32[i13 >> 2] = i8;
  HEAP32[i13 + 4 >> 2] = i9;
  HEAP32[i14 >> 2] = i11;
  HEAP32[i14 + 4 >> 2] = i12;
  i14 = 1;
  return i14 | 0;
 }
 HEAP32[i10 >> 2] = i8;
 HEAP32[i14 >> 2] = i12;
 i9 = i10 + 8 | 0;
 i1 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i10 + 16 | 0;
 i6 = i3;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i14 + 8 | 0;
 i10 = i8;
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i14 + 16 | 0;
 i7 = i9;
 i10 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i10;
 i3 = i8;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = i9;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i6;
 i3 = HEAP32[i13 >> 2] | 0;
 i10 = i3;
 do if (i3 >>> 0 < i11 >>> 0) {
  i3 = i13 + 8 | 0;
  i1 = i3;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i11 >>> 0 < i3 >>> 0) {
   i14 = 1;
   return i14 | 0;
  }
  i3 = i13 + 8 | 0;
  i7 = i3;
  i4 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  if ((i4 | 0) == (i2 | 0) & (i7 | 0) == (i1 | 0)) {
   i11 = i13 + 16 | 0;
   i7 = HEAP32[i11 + 4 >> 2] | 0;
   if (i7 >>> 0 < i6 >>> 0 | ((i7 | 0) == (i6 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) break; else i1 = 1;
   return i1 | 0;
  } else {
   if (i7 >>> 0 < i1 >>> 0 | (i7 | 0) == (i1 | 0) & i4 >>> 0 < i2 >>> 0) {
    i2 = i4;
    i1 = i7;
    break;
   } else i1 = 1;
   return i1 | 0;
  }
 } while (0);
 HEAP32[i14 >> 2] = i10;
 HEAP32[i13 >> 2] = i12;
 i10 = i8;
 i7 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i9;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i8;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i1;
 i14 = i13 + 16 | 0;
 i6 = i14;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i13 = i9;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = i8;
 i13 = i3;
 HEAP32[i13 >> 2] = i7;
 HEAP32[i13 + 4 >> 2] = i10;
 HEAP32[i14 >> 2] = i11;
 HEAP32[i14 + 4 >> 2] = i12;
 i14 = 2;
 return i14 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j(i7, i28, i2) {
 i7 = i7 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 12 | 0;
 i6 = i30 + 24 | 0;
 i29 = i30;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E5clearEv(i7);
 f1 = Math_fround(((HEAP32[i28 + 68 >> 2] | 0) - (HEAP32[i28 + 4 >> 2] | 0) | 0) >>> 0);
 i3 = 32;
 while (1) {
  if (i3 >>> 0 >= i2 >>> 0) {
   f4 = Math_fround(i3 >>> 0);
   f5 = Math_fround(f4 * Math_fround(.5));
   if (!(f1 >= f5)) break;
  }
  i3 = i3 << 1;
 }
 i26 = i7 + 64 | 0;
 if (i3 >>> 0 > (HEAP32[i26 >> 2] | 0) >>> 0) {
  HEAP8[i27 >> 0] = HEAP8[i6 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i7, i3, i27);
  HEAP32[i26 >> 2] = i3;
  HEAP32[i7 + 76 >> 2] = ~~f5 >>> 0;
  HEAP32[i7 + 72 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
  HEAP8[i7 + 80 >> 0] = 0;
 }
 i17 = i28 + 60 | 0;
 i20 = HEAP32[i17 >> 2] | 0;
 i18 = i28 + 64 | 0;
 i2 = i20 + ((HEAP32[i18 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i27 >> 2] = i28;
 i19 = i27 + 4 | 0;
 HEAP32[i19 >> 2] = i20;
 HEAP32[i27 + 8 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv(i27);
 i2 = (HEAP32[i17 >> 2] | 0) + ((HEAP32[i18 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i29 >> 2] = i28;
 i20 = i29 + 4 | 0;
 HEAP32[i20 >> 2] = i2;
 i21 = i29 + 8 | 0;
 HEAP32[i21 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv(i29);
 i2 = HEAP32[i19 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i20 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 i22 = i7 + 36 | 0;
 i23 = i7 + 60 | 0;
 i24 = i22 + 11 | 0;
 i25 = i7 + 40 | 0;
 i16 = i7 + 68 | 0;
 do {
  i15 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
  i3 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  i7 = HEAP8[i3 >> 0] | 0;
  if (!(i7 << 24 >> 24)) i6 = 5381; else {
   i6 = 5381;
   do {
    i3 = i3 + 1 | 0;
    i6 = i6 * 33 ^ i7 << 24 >> 24;
    i7 = HEAP8[i3 >> 0] | 0;
   } while (i7 << 24 >> 24 != 0);
  }
  i14 = HEAP32[i23 >> 2] | 0;
  i11 = HEAP8[i24 >> 0] | 0;
  i8 = i11 << 24 >> 24 < 0;
  i11 = i11 & 255;
  i13 = i8 ? HEAP32[i25 >> 2] | 0 : i11;
  i12 = HEAP32[i22 >> 2] | 0;
  i9 = i8 ? i12 : i22;
  i10 = (i13 | 0) == 0;
  i12 = i12 & 255;
  L19 : do if (i8) {
   i8 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 24 | 0) | 0;
    i12 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i12 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 24 | 0) + 4 >> 2] | 0 : i12 & 255) | 0)) {
     if (i10) break L19;
     if (!(_memcmp(i9, i7 ? HEAP32[i6 >> 2] | 0 : i6, i13) | 0)) break L19;
    }
    i6 = i8 + 1 | 0;
    i8 = i6;
    i6 = i6 + i3 | 0;
   }
  } else {
   if (i10) {
    i3 = i6 & i15;
    i13 = HEAP8[i14 + (i3 * 24 | 0) + 11 >> 0] | 0;
    if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 24 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break; else i6 = 0;
    while (1) {
     i6 = i6 + 1 | 0;
     i3 = i6 + i3 & i15;
     i13 = HEAP8[i14 + (i3 * 24 | 0) + 11 >> 0] | 0;
     if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 24 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break L19;
    }
   } else i9 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 24 | 0) | 0;
    i10 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i10 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 24 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
     i6 = i7 ? HEAP32[i6 >> 2] | 0 : i6;
     if (i12 << 24 >> 24 == (HEAP8[i6 >> 0] | 0)) {
      i7 = i22;
      i8 = i11;
      do {
       i8 = i8 + -1 | 0;
       i7 = i7 + 1 | 0;
       if (!i8) break L19;
       i6 = i6 + 1 | 0;
      } while ((HEAP8[i7 >> 0] | 0) == (HEAP8[i6 >> 0] | 0));
     }
    }
    i6 = i9 + 1 | 0;
    i9 = i6;
    i6 = i6 + i3 | 0;
   }
  } while (0);
  i15 = i14 + (i3 * 24 | 0) + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  i14 = i14 + (i3 * 24 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i15, i2 + 12 | 0);
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 24;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv(i27);
  i15 = (HEAP32[i17 >> 2] | 0) + ((HEAP32[i18 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i29 >> 2] = i28;
  HEAP32[i20 >> 2] = i15;
  HEAP32[i21 >> 2] = i15;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv(i29);
  i2 = HEAP32[i19 >> 2] | 0;
 } while ((i2 | 0) != (HEAP32[i20 >> 2] | 0));
 STACKTOP = i30;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9copy_fromERKSM_j(i28, i29, i2) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31 + 12 | 0;
 i6 = i31 + 24 | 0;
 i30 = i31;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E5clearEv(i28);
 f1 = Math_fround(((HEAP32[i29 + 60 >> 2] | 0) - (HEAP32[i29 + 4 >> 2] | 0) | 0) >>> 0);
 i3 = 32;
 while (1) {
  if (i3 >>> 0 >= i2 >>> 0) {
   f4 = Math_fround(i3 >>> 0);
   f5 = Math_fround(f4 * Math_fround(.5));
   if (!(f1 >= f5)) break;
  }
  i3 = i3 << 1;
 }
 i26 = i28 + 56 | 0;
 if (i3 >>> 0 > (HEAP32[i26 >> 2] | 0) >>> 0) {
  HEAP8[i27 >> 0] = HEAP8[i6 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i28, i3, i27);
  HEAP32[i26 >> 2] = i3;
  HEAP32[i28 + 68 >> 2] = ~~f5 >>> 0;
  HEAP32[i28 + 64 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
  HEAP8[i28 + 72 >> 0] = 0;
 }
 i16 = i29 + 52 | 0;
 i19 = HEAP32[i16 >> 2] | 0;
 i17 = i29 + 56 | 0;
 i2 = i19 + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i27 >> 2] = i29;
 i18 = i27 + 4 | 0;
 HEAP32[i18 >> 2] = i19;
 HEAP32[i27 + 8 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i27);
 i2 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i30 >> 2] = i29;
 i19 = i30 + 4 | 0;
 HEAP32[i19 >> 2] = i2;
 i20 = i30 + 8 | 0;
 HEAP32[i20 >> 2] = i2;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i30);
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i19 >> 2] | 0)) {
  STACKTOP = i31;
  return;
 }
 i21 = i28 + 32 | 0;
 i22 = i28 + 52 | 0;
 i23 = i21 + 11 | 0;
 i24 = i28 + 36 | 0;
 i25 = i28 + 60 | 0;
 do {
  i15 = (HEAP32[i26 >> 2] | 0) + -1 | 0;
  i3 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  i7 = HEAP8[i3 >> 0] | 0;
  if (!(i7 << 24 >> 24)) i6 = 5381; else {
   i6 = 5381;
   do {
    i3 = i3 + 1 | 0;
    i6 = i6 * 33 ^ i7 << 24 >> 24;
    i7 = HEAP8[i3 >> 0] | 0;
   } while (i7 << 24 >> 24 != 0);
  }
  i14 = HEAP32[i22 >> 2] | 0;
  i11 = HEAP8[i23 >> 0] | 0;
  i8 = i11 << 24 >> 24 < 0;
  i11 = i11 & 255;
  i13 = i8 ? HEAP32[i24 >> 2] | 0 : i11;
  i12 = HEAP32[i21 >> 2] | 0;
  i9 = i8 ? i12 : i21;
  i10 = (i13 | 0) == 0;
  i12 = i12 & 255;
  L19 : do if (i8) {
   i8 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 20 | 0) | 0;
    i12 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i12 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i12 & 255) | 0)) {
     if (i10) break L19;
     if (!(_memcmp(i9, i7 ? HEAP32[i6 >> 2] | 0 : i6, i13) | 0)) break L19;
    }
    i6 = i8 + 1 | 0;
    i8 = i6;
    i6 = i6 + i3 | 0;
   }
  } else {
   if (i10) {
    i3 = i6 & i15;
    i13 = HEAP8[i14 + (i3 * 20 | 0) + 11 >> 0] | 0;
    if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break; else i6 = 0;
    while (1) {
     i6 = i6 + 1 | 0;
     i3 = i6 + i3 & i15;
     i13 = HEAP8[i14 + (i3 * 20 | 0) + 11 >> 0] | 0;
     if (!((i13 << 24 >> 24 < 0 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i13 & 255) | 0)) break L19;
    }
   } else i9 = 0;
   while (1) {
    i3 = i6 & i15;
    i6 = i14 + (i3 * 20 | 0) | 0;
    i10 = HEAP8[i6 + 11 >> 0] | 0;
    i7 = i10 << 24 >> 24 < 0;
    if ((i13 | 0) == ((i7 ? HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
     i6 = i7 ? HEAP32[i6 >> 2] | 0 : i6;
     if (i12 << 24 >> 24 == (HEAP8[i6 >> 0] | 0)) {
      i7 = i21;
      i8 = i11;
      do {
       i8 = i8 + -1 | 0;
       i7 = i7 + 1 | 0;
       if (!i8) break L19;
       i6 = i6 + 1 | 0;
      } while ((HEAP8[i7 >> 0] | 0) == (HEAP8[i6 >> 0] | 0));
     }
    }
    i6 = i9 + 1 | 0;
    i9 = i6;
    i6 = i6 + i3 | 0;
   }
  } while (0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i28, i14 + (i3 * 20 | 0) | 0, i2);
  HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 20;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i27);
  i15 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i30 >> 2] = i29;
  HEAP32[i19 >> 2] = i15;
  HEAP32[i20 >> 2] = i15;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i30);
  i2 = HEAP32[i18 >> 2] | 0;
 } while ((i2 | 0) != (HEAP32[i19 >> 2] | 0));
 STACKTOP = i31;
 return;
}

function __ZN5physx2Gu23computeBoxTriImpactDataERNS_6PxVec3ES2_RKS1_S4_S4_S4_RKNS_10PxTriangleE(i11, i14, i8, i12, i13, i1, i16) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i15 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i18 + 368 | 0;
 i17 = i18 + 224 | 0;
 i9 = i18 + 64 | 0;
 i10 = i18 + 32 | 0;
 i15 = i18 + 16 | 0;
 i3 = i18 + 392 | 0;
 i4 = i18 + 384 | 0;
 f21 = Math_fround(HEAPF32[i8 >> 2]);
 f24 = Math_fround(-f21);
 i6 = i8 + 4 | 0;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(-f20);
 i7 = i8 + 8 | 0;
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 f22 = Math_fround(-f19);
 HEAPF32[i3 >> 2] = f24;
 HEAPF32[i3 + 4 >> 2] = f23;
 HEAPF32[i3 + 8 >> 2] = f22;
 HEAPF32[i3 + 12 >> 2] = f21;
 HEAPF32[i3 + 16 >> 2] = f20;
 HEAPF32[i3 + 20 >> 2] = f19;
 HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (__ZN5physx2Gu16sweepBoxTriangleERKNS_10PxTriangleERKNS_9PxBounds3ERKNS_6PxVec3ES9_RS7_SA_Rf(i16, i3, i13, i1, i11, i14, i4) | 0) {
  STACKTOP = i18;
  return;
 }
 f24 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(.100000001));
 i1 = i12 + 4 | 0;
 f23 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.100000001));
 i2 = i12 + 8 | 0;
 f22 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.100000001));
 f24 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f24);
 i3 = i13 + 4 | 0;
 f23 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f23);
 i4 = i13 + 8 | 0;
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f22);
 f28 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f24);
 f27 = Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) - f23);
 f26 = Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) - f22);
 f19 = Math_fround(Math_fround(HEAPF32[i16 + 12 >> 2]) - f24);
 f20 = Math_fround(Math_fround(HEAPF32[i16 + 16 >> 2]) - f23);
 f21 = Math_fround(Math_fround(HEAPF32[i16 + 20 >> 2]) - f22);
 f24 = Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) - f24);
 f23 = Math_fround(Math_fround(HEAPF32[i16 + 28 >> 2]) - f23);
 f22 = Math_fround(Math_fround(HEAPF32[i16 + 32 >> 2]) - f22);
 i25 = i17 + 64 | 0;
 HEAP32[i17 + 80 >> 2] = 7;
 HEAPF32[i17 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i25 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i25 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 f30 = Math_fround(Math_fround(Math_fround(f27 + f20) + f23) * Math_fround(.333332986));
 f29 = Math_fround(Math_fround(Math_fround(f26 + f21) + f22) * Math_fround(.333332986));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(Math_fround(f28 + f19) + f24) * Math_fround(.333332986));
 HEAPF32[i17 + 4 >> 2] = f30;
 HEAPF32[i17 + 8 >> 2] = f29;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 96 >> 2] = f28;
 HEAPF32[i17 + 100 >> 2] = f27;
 HEAPF32[i17 + 104 >> 2] = f26;
 HEAPF32[i17 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 112 >> 2] = f19;
 HEAPF32[i17 + 116 >> 2] = f20;
 HEAPF32[i17 + 120 >> 2] = f21;
 HEAPF32[i17 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 128 >> 2] = f24;
 HEAPF32[i17 + 132 >> 2] = f23;
 HEAPF32[i17 + 136 >> 2] = f22;
 HEAPF32[i17 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i25 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 i7 = i9 + 64 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 80 >> 2] = 3;
 HEAPF32[i9 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i9 + 144 >> 2] = i25;
 HEAP32[i9 + 148 >> 2] = i8;
 HEAP32[i9 + 152 >> 2] = i16;
 HEAPF32[i9 + 156 >> 2] = Math_fround(0.0);
 f22 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = f22 <= f23 ? f22 : f23;
 f24 = f23 <= f24 ? f23 : f24;
 HEAPF32[i9 + 16 >> 2] = Math_fround(f24 * Math_fround(.150000006));
 HEAPF32[i9 + 32 >> 2] = Math_fround(f24 * Math_fround(.0500000007));
 HEAP32[i9 + 96 >> 2] = 1065353216;
 i16 = i9 + 100 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i9 + 116 >> 2] = 1065353216;
 i16 = i9 + 120 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i9 + 136 >> 2] = 1065353216;
 HEAPF32[i9 + 140 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i17, i9, i18 + 48 | 0, i10, i15, i18) | 0)) {
  f24 = Math_fround(HEAPF32[i10 >> 2]);
  f26 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f28 = Math_fround(HEAPF32[i15 >> 2]);
  f29 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i13 >> 2]));
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i3 >> 2]));
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i11 >> 2] = f24;
  HEAPF32[i11 + 4 >> 2] = f26;
  HEAPF32[i11 + 8 >> 2] = f27;
  f29 = Math_fround(-f29);
  f30 = Math_fround(-f30);
  HEAPF32[i14 >> 2] = Math_fround(-f28);
  HEAPF32[i14 + 4 >> 2] = f29;
  HEAPF32[i14 + 8 >> 2] = f30;
  STACKTOP = i18;
  return;
 } else {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  f28 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
  f29 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  f30 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i14 >> 2] = f28;
  HEAPF32[i14 + 4 >> 2] = f29;
  HEAPF32[i14 + 8 >> 2] = f30;
  STACKTOP = i18;
  return;
 }
}

function __ZN6Shader8TransferI17RemapPPtrTransferEEvRT_(i27, i28) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i29 + 24 | 0;
 i5 = i29 + 16 | 0;
 i11 = i29 + 8 | 0;
 i14 = i29 + 116 | 0;
 i15 = i29 + 96 | 0;
 i18 = i29 + 76 | 0;
 i19 = i29 + 56 | 0;
 i22 = i29 + 36 | 0;
 i1 = i29;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i27, i28);
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i16 = i25;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = i13;
 HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i20 + 4 >> 2] = i17;
 i20 = gb + 64016 | 0;
 i17 = HEAP32[i20 + 4 >> 2] | 0;
 i16 = i11;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i16 = i15 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i20 = i25;
 i21 = HEAP32[i20 + 4 >> 2] | 0;
 i6 = i17;
 HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i6 + 4 >> 2] = i21;
 i6 = gb + 64016 | 0;
 i21 = HEAP32[i6 + 4 >> 2] | 0;
 i20 = i11;
 HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i20 + 4 >> 2] = i21;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i20 = i18 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i6 = i25;
 i23 = HEAP32[i6 + 4 >> 2] | 0;
 i24 = i21;
 HEAP32[i24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i24 + 4 >> 2] = i23;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = i23;
 HEAP32[i19 >> 2] = 0;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i23 = i19 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i7 = i25;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i24;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i22 >> 2] = 0;
 i7 = i22 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i22 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i25, i11);
 i3 = i25;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 if (!(HEAP32[i2 >> 2] | 0)) i26 = 20; else {
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i3;
  HEAP32[i25 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i25 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i8 = __Z18CreateDecompressor15CompressionType10MemLabelId(3, i25) | 0;
  i3 = HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4388 >> 2] | 0;
  i4 = HEAP32[gb + 67780 + (i3 << 2) >> 2] | 0;
  L3 : do if ((i3 | 0) == 4) i1 = 0; else {
   i2 = HEAP32[i2 >> 2] | 0;
   if (i2 | 0) {
    i3 = HEAP32[i14 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L3;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   HEAP32[i5 >> 2] = i4;
   __Z6FormatPKcz(i25, gb + 470364 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i25 + 11 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25, 0, gb + 470432 | 0, 540, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   i1 = 0;
  } while (0);
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i4 = i27 + 60 | 0;
   i5 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i25 >> 2] = i5;
   HEAP32[i11 >> 2] = i3;
   if ((i3 | 0) != 0 & (i5 | 0 ? (HEAP32[i7 >> 2] | 0) >>> 0 > i6 >>> 0 : 0)) {
    i1 = i27 + 72 | 0;
    HEAP32[i1 >> 2] = i5;
    i2 = i27 + 76 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i2 >> 2] = i5;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5, 4, i27 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i1;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i27 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
     HEAP32[i2 >> 2] = i5;
     HEAP32[i4 >> 2] = i7;
     i1 = i7;
     break;
    } else i1 = HEAP32[i4 >> 2] | 0; while (0);
    mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, (HEAP32[i22 >> 2] | 0) + i6 | 0, i11 | 0, i1 | 0, i25 | 0) | 0;
   }
  }
  if (i8 | 0) mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
  if ((HEAP32[i9 >> 2] | 0) > -1) i26 = 20;
 }
 if ((i26 | 0) == 20) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i10);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i24);
  HEAP32[i19 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i21);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i17);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 i1 = HEAP32[i27 + 80 >> 2] | 0;
 i4 = HEAP32[i27 + 84 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i29;
  return;
 }
 i5 = i28 + 16 | 0;
 i6 = i28 + 36 | 0;
 i3 = i28 + 40 | 0;
 do {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i29;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i16, i1, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 8 | 0;
 i13 = i18;
 i12 = i16 + 24 | 0;
 i10 = i3 + 12 | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, HEAP32[i12 >> 2] | 0);
 i15 = i16 + 4 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i1;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i14) | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i16 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i16 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i16 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i16 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i16, gb + 830924 | 0);
  i4 = i16 + 20 | 0;
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i6 = HEAP32[i16 >> 2] | 0;
  HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i6 = HEAP32[i16 >> 2] | 0;
  HEAP8[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP32[i6 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  i6 = i16 + 40 | 0;
  i8 = i14 + 255 | 0;
  i9 = i14 + 255 | 0;
  f7 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  i1 = i1 << 24 >> 24 != 0;
  while (1) {
   while (1) {
    if (!i1) break L12;
    i1 = HEAP32[i4 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i17 = 25; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i17 = 25; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i14 | 0, 0, 256) | 0;
      HEAP32[i13 >> 2] = i8;
      i2 = HEAP8[i1 >> 0] | 0;
      L29 : do if (!(i2 << 24 >> 24)) i1 = i14; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i14;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L29;
        i19 = HEAP32[i13 >> 2] | 0;
        if (!(i1 >>> 0 < i19 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i14; while (0);
      HEAP8[i1 >> 0] = 0;
      f7 = Math_fround(+_strtod(i14, i13));
     }
    }
    if ((i17 | 0) == 25) {
     i17 = 0;
     HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
    }
    if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else break;
   }
   i19 = HEAP32[i4 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 24 >> 2] | 0, i19 | 0) | 0) {
    i1 = HEAP32[i4 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i17 = 38; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i17 = 38; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i14 | 0, 0, 256) | 0;
      HEAP32[i13 >> 2] = i9;
      i2 = HEAP8[i1 >> 0] | 0;
      L48 : do if (!(i2 << 24 >> 24)) i1 = i14; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i14;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L48;
        i19 = HEAP32[i13 >> 2] | 0;
        if (!(i1 >>> 0 < i19 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i14; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i14, i13));
     }
    }
    if ((i17 | 0) == 38) {
     i17 = 0;
     HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
    }
    mftCall_viff(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i12 >> 2] | 0, +f7, +f5);
   }
   if (!(HEAP8[i11 >> 0] | 0)) {
    i1 = 0;
    continue;
   }
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  }
 } while (0);
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i8 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i8 >>> 0) {
  i6 = i16 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i17 = 46;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i8 >>> 0);
  if ((i17 | 0) == 46) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN18PlatformEffector2D8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i6, i10);
 i4 = i6 + 88 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802226 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 76 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802245 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 77 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802257 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802277 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i9 = 35; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 78 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802290 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 79 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802308 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 802324 | 0, i7, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i8 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i8 >>> 0) i9 = 64; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 64; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i9 | 0) == 64) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i17, i16, i15, i1, i13) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18 + 16 | 0;
 i9 = i18;
 HEAP32[i17 + 44 >> 2] = i15;
 i12 = i17 + 72 | 0;
 HEAP32[i17 + 84 >> 2] = i15;
 HEAP32[i17 + 48 >> 2] = i1;
 HEAP32[i17 + 64 >> 2] = HEAP32[gb + 158880 >> 2];
 HEAP32[i17 + 60 >> 2] = HEAP32[gb + 158876 >> 2];
 HEAP32[i17 + 56 >> 2] = HEAP32[gb + 158872 >> 2];
 HEAP32[i17 + 88 >> 2] = i1;
 HEAP8[i17 + 112 >> 0] = i15;
 i10 = i17 + 40 | 0;
 HEAP32[i10 >> 2] = i16;
 i4 = i16 + (i15 * 944 | 0) | 0;
 HEAP32[i12 >> 2] = i4;
 i2 = i15 * 1168 | 0;
 i3 = i16 + i2 | 0;
 i14 = i17 + 76 | 0;
 HEAP32[i14 >> 2] = i3;
 i2 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = i16 + i2;
 i3 = i15 << 4;
 i2 = i2 + i3 | 0;
 i7 = i17 + 80 | 0;
 HEAP32[i7 >> 2] = i16 + i2;
 i11 = (i15 | 0) == 0;
 if (!i11) {
  i5 = 0;
  i2 = i16 + (i2 + i3) | 0;
  while (1) {
   HEAP32[i4 + (i5 * 224 | 0) + 208 >> 2] = i2;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i15 | 0)) break; else i2 = i2 + 384 | 0;
  }
 }
 if (i13) {
  if (i11) i2 = 0; else {
   __ZN5physx23PxVehicleWheels4SimDataC2Ev(i16);
   if ((i15 | 0) != 1) {
    i2 = 1;
    do {
     __ZN5physx23PxVehicleWheels4SimDataC2Ev((HEAP32[i10 >> 2] | 0) + (i2 * 944 | 0) | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i15 | 0));
   }
   if (i11) i2 = 0; else {
    i4 = 0;
    do {
     i2 = HEAP32[i12 >> 2] | 0;
     i3 = i2 + (i4 * 224 | 0) + 212 | 0;
     HEAPF32[i2 + (i4 * 224 | 0) >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 32 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 48 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 64 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i2 + (i4 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 36 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 52 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 68 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i2 + (i4 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 40 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 56 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 72 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
     HEAPF32[i2 + (i4 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 44 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 60 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 76 >> 2] = Math_fround(0.0);
     HEAPF32[i2 + (i4 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
     i5 = i2 + (i4 * 224 | 0) + 96 | 0;
     i6 = i5 + 112 | 0;
     do {
      HEAP8[i5 >> 0] = 0;
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i6 | 0));
     HEAP32[i3 >> 2] = 0;
     HEAP8[i2 + (i4 * 224 | 0) + 216 >> 0] = 0;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i15 | 0));
    i2 = i15 << 2;
    if (!i2) i2 = 0; else {
     i3 = i15 << 2;
     i4 = 0;
     do {
      HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + (i4 << 2) >> 2] = 0;
      HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = 0;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i3 | 0));
    }
   }
  }
  if (i1 | 0) {
   i3 = 0;
   do {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    HEAP32[i8 + 8 >> 2] = 0;
    HEAP32[i8 + 12 >> 2] = 0;
    i6 = i3 >>> 2;
    i7 = i3 & 3;
    __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i10 >> 2] | 0) + (i6 * 944 | 0) | 0, i7, i8);
    __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i10 >> 2] | 0) + (i6 * 944 | 0) | 0, i7, i3);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i1 | 0));
  }
  if (i2 >>> 0 > i1 >>> 0) {
   i2 = i15 << 2;
   do {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    i7 = i1 >>> 2;
    i8 = i1 & 3;
    __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i10 >> 2] | 0) + (i7 * 944 | 0) | 0, i8, i9);
    __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i10 >> 2] | 0) + (i7 * 944 | 0) | 0, i8, -1);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAPF32[i17 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 12 >> 2] = Math_fround(.230800003);
  HEAPF32[i17 + 16 >> 2] = Math_fround(3.0);
  HEAPF32[i17 + 20 >> 2] = Math_fround(3.0);
  HEAPF32[i17 + 24 >> 2] = Math_fround(.333333343);
 }
 if (i11) {
  i14 = HEAP32[i14 >> 2] | 0;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = fb + 2;
  i14 = i15 << 5;
  i17 = i15 * 1552 | 0;
  i15 = i14 | 16;
  i17 = i15 + i17 | 0;
  i17 = i16 + i17 | 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if (i13) {
  i1 = 0;
  do {
   i13 = HEAP32[i2 + (i1 * 224 | 0) + 208 >> 2] | 0;
   HEAP32[i13 >> 2] = gb + 159132 + 8;
   HEAP32[i13 + 368 >> 2] = 0;
   HEAP32[i13 + 372 >> 2] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
  i14 = HEAP32[i14 >> 2] | 0;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = fb + 2;
  i14 = i15 << 5;
  i17 = i15 * 1552 | 0;
  i15 = i14 | 16;
  i17 = i15 + i17 | 0;
  i17 = i16 + i17 | 0;
  STACKTOP = i18;
  return i17 | 0;
 } else {
  i1 = 0;
  do {
   i13 = HEAP32[i2 + (i1 * 224 | 0) + 208 >> 2] | 0;
   i12 = HEAP32[i13 + 368 >> 2] | 0;
   HEAP32[i13 >> 2] = gb + 159132 + 8;
   HEAP32[i13 + 368 >> 2] = i12;
   HEAP32[i13 + 372 >> 2] = i17;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
  i14 = HEAP32[i14 >> 2] | 0;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = fb + 2;
  i14 = i15 << 5;
  i17 = i15 * 1552 | 0;
  i15 = i14 | 16;
  i17 = i15 + i17 | 0;
  i17 = i16 + i17 | 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 return 0;
}

function __ZN9Projector8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i8, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i4 = i8 + 36 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380721 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380737 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380752 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380766 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380780 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 380795 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 59; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946425 | 0, gb + 946436 | 0, i7, 1) | 0;
 if (!i1) {
  i8 = i8 + 60 | 0;
  __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i9, i8, gb + 380814 | 0, 0);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 i8 = i8 + 60 | 0;
 __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i9, i8, gb + 380814 | 0, 0);
 STACKTOP = i10;
 return;
}

function __Z18ConvertUTF8toUTF16PPKhS0_PPtS2_15ConversionFlags(i10, i9, i11, i1, i3) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 L1 : do if (i2 >>> 0 < i9 >>> 0) {
  if (i3) while (1) {
   i3 = HEAP8[i2 >> 0] | 0;
   i5 = HEAP8[(i3 & 255) + (gb + 584316) >> 0] | 0;
   i6 = i5 << 24 >> 24 & 65535;
   if ((i2 + i6 | 0) >>> 0 >= i9 >>> 0) {
    i3 = 1;
    break L1;
   }
   i4 = i2 + (i6 + 1) | 0;
   i5 = i5 << 24 >> 24;
   switch (i5 << 16 >> 16) {
   case 3:
    {
     i4 = i4 + -1 | 0;
     i8 = HEAP8[i4 >> 0] | 0;
     if (i8 << 24 >> 24 > -1 | (i8 & 255) > 191) {
      i3 = 3;
      break L1;
     } else i8 = 28;
     break;
    }
   case 2:
    {
     i8 = 28;
     break;
    }
   case 1:
    {
     i8 = 29;
     break;
    }
   case 0:
    {
     i4 = i3;
     break;
    }
   default:
    {
     i3 = 3;
     break L1;
    }
   }
   if ((i8 | 0) == 28) {
    i4 = i4 + -1 | 0;
    i8 = HEAP8[i4 >> 0] | 0;
    if (i8 << 24 >> 24 > -1 | (i8 & 255) > 191) {
     i3 = 3;
     break L1;
    } else i8 = 29;
   }
   L11 : do if ((i8 | 0) == 29) {
    i8 = 0;
    i4 = HEAP8[i4 + -1 >> 0] | 0;
    if ((i4 & 255) > 191) {
     i3 = 3;
     break L1;
    }
    switch (i3 << 24 >> 24) {
    case -32:
     if ((i4 & 255) < 160) {
      i3 = 3;
      break L1;
     } else {
      i4 = -32;
      break L11;
     }
    case -19:
     if ((i4 & 255) > 159) {
      i3 = 3;
      break L1;
     } else {
      i4 = -19;
      break L11;
     }
    case -16:
     if ((i4 & 255) < 144) {
      i3 = 3;
      break L1;
     } else {
      i4 = -16;
      break L11;
     }
    case -12:
     if ((i4 & 255) > 143) {
      i3 = 3;
      break L1;
     } else {
      i4 = -12;
      break L11;
     }
    default:
     if (i4 << 24 >> 24 > -1) {
      i3 = 3;
      break L1;
     } else {
      i4 = i3;
      break L11;
     }
    }
   } while (0);
   if (!((i4 & 255) < 245 & ((i4 & 255) > 193 | i4 << 24 >> 24 > -1))) {
    i3 = 3;
    break L1;
   }
   switch (i5 << 16 >> 16) {
   case 1:
    {
     i4 = 0;
     i8 = 40;
     break;
    }
   case 0:
    {
     i4 = 0;
     i8 = 41;
     break;
    }
   case 3:
    {
     i8 = i2 + 1 | 0;
     i4 = (i3 & 255) << 6;
     i2 = i8;
     i3 = HEAP8[i8 >> 0] | 0;
     i8 = 39;
     break;
    }
   case 2:
    {
     i4 = 0;
     i8 = 39;
     break;
    }
   default:
    i3 = 0;
   }
   if ((i8 | 0) == 39) {
    i7 = i2 + 1 | 0;
    i4 = (i3 & 255) + i4 << 6;
    i2 = i7;
    i3 = HEAP8[i7 >> 0] | 0;
    i8 = 40;
   }
   if ((i8 | 0) == 40) {
    i7 = i2 + 1 | 0;
    i4 = (i3 & 255) + i4 << 6;
    i2 = i7;
    i3 = HEAP8[i7 >> 0] | 0;
    i8 = 41;
   }
   if ((i8 | 0) == 41) {
    i8 = 0;
    i3 = (i3 & 255) + i4 | 0;
    i2 = i2 + 1 | 0;
   }
   i3 = i3 - (HEAP32[gb + 73500 + (i6 << 2) >> 2] | 0) | 0;
   do if (i3 >>> 0 < 65536) if ((i3 & -2048 | 0) == 55296) {
    HEAP16[i1 >> 1] = -3;
    break;
   } else {
    HEAP16[i1 >> 1] = i3;
    break;
   } else HEAP16[i1 >> 1] = -3; while (0);
   i1 = i1 + 2 | 0;
   if (i2 >>> 0 >= i9 >>> 0) {
    i3 = 0;
    break L1;
   }
  }
  while (1) {
   i5 = HEAP8[i2 >> 0] | 0;
   i4 = HEAP8[(i5 & 255) + (gb + 584316) >> 0] | 0;
   i7 = i4 << 24 >> 24;
   i6 = i7 & 65535;
   if ((i2 + i6 | 0) >>> 0 >= i9 >>> 0) {
    i3 = 1;
    break L1;
   }
   i3 = i2 + (i6 + 1) | 0;
   i4 = i4 << 24 >> 24;
   switch (i4 << 16 >> 16) {
   case 3:
    {
     i3 = i3 + -1 | 0;
     i8 = HEAP8[i3 >> 0] | 0;
     if (i8 << 24 >> 24 > -1 | (i8 & 255) > 191) {
      i3 = 3;
      break L1;
     } else i8 = 6;
     break;
    }
   case 2:
    {
     i8 = 6;
     break;
    }
   case 1:
    {
     i8 = 7;
     break;
    }
   case 0:
    {
     i3 = i5;
     break;
    }
   default:
    {
     i3 = 3;
     break L1;
    }
   }
   if ((i8 | 0) == 6) {
    i3 = i3 + -1 | 0;
    i8 = HEAP8[i3 >> 0] | 0;
    if (i8 << 24 >> 24 > -1 | (i8 & 255) > 191) {
     i3 = 3;
     break L1;
    } else i8 = 7;
   }
   L45 : do if ((i8 | 0) == 7) {
    i8 = 0;
    i3 = HEAP8[i3 + -1 >> 0] | 0;
    if ((i3 & 255) > 191) {
     i3 = 3;
     break L1;
    }
    switch (i5 << 24 >> 24) {
    case -32:
     if ((i3 & 255) < 160) {
      i3 = 3;
      break L1;
     } else {
      i3 = -32;
      break L45;
     }
    case -19:
     if ((i3 & 255) > 159) {
      i3 = 3;
      break L1;
     } else {
      i3 = -19;
      break L45;
     }
    case -16:
     if ((i3 & 255) < 144) {
      i3 = 3;
      break L1;
     } else {
      i3 = -16;
      break L45;
     }
    case -12:
     if ((i3 & 255) > 143) {
      i3 = 3;
      break L1;
     } else {
      i3 = -12;
      break L45;
     }
    default:
     if (i3 << 24 >> 24 > -1) {
      i3 = 3;
      break L1;
     } else {
      i3 = i5;
      break L45;
     }
    }
   } while (0);
   if (!((i3 & 255) < 245 & ((i3 & 255) > 193 | i3 << 24 >> 24 > -1))) {
    i3 = 3;
    break L1;
   }
   switch (i4 << 16 >> 16) {
   case 1:
    {
     i4 = 0;
     i3 = i5;
     i8 = 18;
     break;
    }
   case 0:
    {
     i4 = 0;
     i3 = i5;
     i8 = 19;
     break;
    }
   case 3:
    {
     i3 = i2 + 1 | 0;
     i4 = (i5 & 255) << 6;
     i2 = i3;
     i3 = HEAP8[i3 >> 0] | 0;
     i8 = 17;
     break;
    }
   case 2:
    {
     i4 = 0;
     i3 = i5;
     i8 = 17;
     break;
    }
   default:
    i3 = 0;
   }
   if ((i8 | 0) == 17) {
    i5 = i2 + 1 | 0;
    i4 = (i3 & 255) + i4 << 6;
    i2 = i5;
    i3 = HEAP8[i5 >> 0] | 0;
    i8 = 18;
   }
   if ((i8 | 0) == 18) {
    i5 = i2 + 1 | 0;
    i4 = (i3 & 255) + i4 << 6;
    i2 = i5;
    i3 = HEAP8[i5 >> 0] | 0;
    i8 = 19;
   }
   if ((i8 | 0) == 19) {
    i8 = 0;
    i3 = (i3 & 255) + i4 | 0;
    i2 = i2 + 1 | 0;
   }
   i3 = i3 - (HEAP32[gb + 73500 + (i6 << 2) >> 2] | 0) | 0;
   if (i3 >>> 0 < 65536) {
    if ((i3 & -2048 | 0) == 55296) {
     i8 = 44;
     break;
    }
    i3 = i3 & 65535;
   } else if (i3 >>> 0 > 1114111) {
    i8 = 48;
    break;
   } else i3 = -3;
   HEAP16[i1 >> 1] = i3;
   i1 = i1 + 2 | 0;
   if (i2 >>> 0 >= i9 >>> 0) {
    i3 = 0;
    break L1;
   }
  }
  if ((i8 | 0) == 44) {
   i3 = 3;
   i2 = i2 + ((i7 | -65536) ^ 65535) | 0;
   break;
  } else if ((i8 | 0) == 48) {
   i3 = 3;
   i2 = i2 + ((i7 | -65536) ^ 65535) | 0;
   break;
  }
 } else i3 = 0; while (0);
 HEAP32[i10 >> 2] = i2;
 HEAP32[i11 >> 2] = i1;
 return i3 | 0;
}

function __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i21, i1, i24, i4, f25, f26, f27, i28, i29, i30, f22, i2, i3) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 i4 = i4 | 0;
 f25 = Math_fround(f25);
 f26 = Math_fround(f26);
 f27 = Math_fround(f27);
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 f22 = Math_fround(f22);
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33 + 8 | 0;
 i23 = i33;
 i32 = i33 + 20 | 0;
 if (!i1) {
  i1 = HEAP32[gb + 1467752 >> 2] | 0;
  if (!i1) {
   HEAP32[i31 >> 2] = 0;
   HEAP32[i31 + 4 >> 2] = 0;
   HEAP32[i31 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i31, gb + 1017543 | 0, 9);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i31) | 0;
   HEAP32[gb + 1467752 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i31);
   i1 = HEAP32[gb + 1467752 >> 2] | 0;
  }
  i19 = HEAP32[i1 + 48 >> 2] | 0;
 } else i19 = i1;
 i17 = (HEAP32[i19 + 32 >> 2] | 0) == -2;
 i18 = i17 ? i2 : 0;
 i20 = i17 ? i3 : 0;
 i17 = (i3 | i2 | 0) != 0 & (i17 ^ 1);
 i18 = (i18 | 0) > 500 ? 500 : i18;
 if (i24 >>> 0 < 9 & ((i24 | 0) > -1 & (i4 | 0) == 3)) i16 = HEAP32[gb + 185360 + (i24 << 2) >> 2] | 0; else i16 = i4;
 i4 = HEAP32[gb + 1467756 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 L10 : do if ((i1 | 0) != (i4 | 0)) {
  i5 = HEAP32[(HEAP32[i19 + 76 >> 2] | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i21 + 4 >> 2] | 0;
  i7 = HEAP32[i21 >> 2] | 0;
  i8 = (i7 | 0) == 0;
  i9 = i28 & 1;
  i10 = i29 & 1;
  i14 = HEAP32[i30 >> 2] | 0;
  i11 = i14 & 255;
  i12 = i14 >>> 24 & 255;
  i13 = i14 >>> 16 & 255;
  i14 = (i14 & 65535) >>> 8 & 255;
  i15 = i6 << 1;
  L12 : do if ((i24 | 0) == 9) {
   i3 = i1;
   while (1) {
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((HEAP32[i1 + 4 >> 2] | 0) == (i5 | 0)) if (Math_fround(HEAPF32[i1 + 32 >> 2]) == f25) if (Math_fround(HEAPF32[i1 + 44 >> 2]) == f26) if (Math_fround(HEAPF32[i1 + 40 >> 2]) == f27) {
     i2 = i1 + 68 | 0;
     if ((HEAP32[i1 + 72 >> 2] | 0) == (i6 | 0)) {
      if (!i8) if (_memcmp(HEAP32[i2 >> 2] | 0, i7, i15) | 0) break;
      if ((HEAP32[i1 + 52 >> 2] | 0) == (i18 | 0)) if (Math_fround(HEAPF32[i1 + 56 >> 2]) == f22) if ((HEAP32[i1 + 60 >> 2] | 0) == (i20 | 0)) if ((HEAPU8[i1 + 49 >> 0] | 0 | 0) == (i9 | 0)) if ((HEAPU8[i1 + 28 >> 0] | 0 | 0) == (i10 | 0)) {
       i2 = HEAP32[i1 + 64 >> 2] | 0;
       if ((i2 & 255) << 24 >> 24 == i11 << 24 >> 24) if ((i2 >>> 24 & 255) << 24 >> 24 == i12 << 24 >> 24 & ((i2 >>> 16 & 255) << 24 >> 24 == i13 << 24 >> 24 ? ((i2 & 65535) >>> 8 & 255) << 24 >> 24 == i14 << 24 >> 24 : 0)) break L12;
      }
     }
    } while (0);
    i3 = i3 + 4 | 0;
    if ((i3 | 0) == (i4 | 0)) break L10;
   }
  } else {
   i3 = i1;
   while (1) {
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((HEAP32[i1 + 4 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i1 + 24 >> 2] | 0) == (i24 | 0)) if ((HEAP32[i1 + 36 >> 2] | 0) == (i16 | 0)) if (Math_fround(HEAPF32[i1 + 32 >> 2]) == f25) if (Math_fround(HEAPF32[i1 + 44 >> 2]) == f26) if (Math_fround(HEAPF32[i1 + 40 >> 2]) == f27) {
     i2 = i1 + 68 | 0;
     if ((HEAP32[i1 + 72 >> 2] | 0) == (i6 | 0)) {
      if (!i8) if (_memcmp(HEAP32[i2 >> 2] | 0, i7, i15) | 0) break;
      if ((HEAP32[i1 + 52 >> 2] | 0) == (i18 | 0)) if (Math_fround(HEAPF32[i1 + 56 >> 2]) == f22) if ((HEAP32[i1 + 60 >> 2] | 0) == (i20 | 0)) if ((HEAPU8[i1 + 49 >> 0] | 0 | 0) == (i9 | 0)) {
       if ((HEAPU8[i1 + 28 >> 0] | 0 | 0) != (i10 | 0)) break;
       i2 = HEAP32[i1 + 64 >> 2] | 0;
       if ((i2 & 255) << 24 >> 24 != i11 << 24 >> 24) break;
       if ((i2 >>> 24 & 255) << 24 >> 24 == i12 << 24 >> 24 & ((i2 >>> 16 & 255) << 24 >> 24 == i13 << 24 >> 24 ? ((i2 & 65535) >>> 8 & 255) << 24 >> 24 == i14 << 24 >> 24 : 0)) break L12;
      }
     }
    } while (0);
    i3 = i3 + 4 | 0;
    if ((i3 | 0) == (i4 | 0)) break L10;
   }
  } while (0);
  HEAP32[i1 + 108 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2];
  i32 = i1;
  STACKTOP = i33;
  return i32 | 0;
 } while (0);
 if (i17) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 945015 | 0, 0, gb + 945083 | 0, 101, 512, 0, 0, 0);
 i4 = __Znwj(112) | 0;
 i3 = HEAP32[i19 + 76 >> 2] | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i17 = gb + 63672 | 0;
 i19 = HEAP32[i17 + 4 >> 2] | 0;
 i30 = i23;
 HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i30 + 4 >> 2] = i19;
 HEAP32[i31 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i4 + 68 | 0, i21, i31);
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i31, gb + 63664 | 0);
 i23 = i31;
 i30 = HEAP32[i23 + 4 >> 2] | 0;
 i31 = i4 + 92 | 0;
 HEAP32[i31 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i31 + 4 >> 2] = i30;
 HEAP32[i2 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 52 >> 2] = i18;
 HEAP32[i4 + 60 >> 2] = i20;
 HEAPF32[i4 + 56 >> 2] = f22;
 HEAP32[i4 + 24 >> 2] = (i24 | 0) == 9 ? 0 : i24;
 HEAP32[i4 + 36 >> 2] = i16;
 HEAPF32[i4 + 32 >> 2] = f25;
 HEAPF32[i4 + 44 >> 2] = f26;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAPF32[i4 + 40 >> 2] = f27;
 HEAP32[i4 >> 2] = 0;
 HEAP8[i4 + 49 >> 0] = i28 & 1;
 HEAP8[i4 + 28 >> 0] = i29 & 1;
 HEAP32[i4 + 64 >> 2] = i1;
 HEAP32[i32 >> 2] = i4;
 __ZN20TextRenderingPrivate17TextMeshGenerator8GenerateEv(i4);
 HEAP32[i4 + 108 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2];
 i1 = HEAP32[gb + 1467756 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1, i32); else {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
 }
 i32 = HEAP32[i32 >> 2] | 0;
 STACKTOP = i33;
 return i32 | 0;
}

function __ZN15FileSystemEntry13MoveByCopyingERS_23FileSystemCopyMoveFlags(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 32 | 0;
 i6 = i12 + 16 | 0;
 i5 = i12 + 8 | 0;
 i2 = i12;
 i11 = i12 + 1112 | 0;
 i10 = i12 + 52 | 0;
 i7 = i12 + 40 | 0;
 if (!(__ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags(i8, i9, i1) | 0)) {
  i1 = HEAP32[i9 + 1040 >> 2] | 0;
  if (i1 | 0) if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i9 | 0, 1) | 0) {
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
  HEAP32[i2 >> 2] = i8;
  HEAP32[i2 + 4 >> 2] = i9;
  __Z6FormatPKcz(i11, gb + 491966 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 491603 | 0, 633, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = i8 + 1040 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1 | 0) {
  if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i8 | 0) | 0)) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) break;
   if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i8 | 0, 0) | 0) i1 = 1; else break;
   STACKTOP = i12;
   return i1 | 0;
  };
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i8, _strlen(i8) | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 492048 | 0, 3);
  __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i10, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
  i3 = i10 + 1040 | 0;
  HEAP8[i10 >> 0] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  __ZN15FileSystemEntry3SetEPKc(i10, i1);
  i1 = HEAP32[i2 >> 2] | 0;
  L16 : do if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i8 + 1044 >> 2] | 0) == (HEAP32[i10 + 1044 >> 2] | 0)) {
   if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, i8 | 0, i10 | 0) | 0)) {
    switch (HEAP32[i8 + 1056 >> 2] | 0) {
    case 10:
    case 15:
     {
      i4 = 17;
      break L16;
     }
    default:
     {}
    }
    i1 = HEAP32[i9 + 1040 >> 2] | 0;
    if (i1 | 0) if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i9 | 0, 1) | 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     i11 = 0;
     STACKTOP = i12;
     return i11 | 0;
    }
    HEAP32[i5 >> 2] = i8;
    HEAP32[i5 + 4 >> 2] = i9;
    __Z6FormatPKcz(i7, gb + 491966 | 0, i5);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 491603 | 0, 652, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    i11 = 0;
    STACKTOP = i12;
    return i11 | 0;
   }
  } else i4 = 9; else i4 = 9; while (0);
  if ((i4 | 0) == 9) {
   HEAP32[i8 + 1056 >> 2] = 10;
   i4 = 17;
  }
  if ((i4 | 0) == 17) if ((i10 | 0) != (i8 | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
   _strncpy(i10, i8, 1040) | 0;
   HEAP8[i10 + 1039 >> 0] = 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i10 + 1044 >> 2] = HEAP32[i8 + 1044 >> 2];
   HEAP32[i10 + 1048 >> 2] = 0;
   HEAP32[i10 + 1052 >> 2] = 0;
   HEAP32[i10 + 1056 >> 2] = 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i10 | 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i10 | 0, 1) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i11 = 1;
   STACKTOP = i12;
   return i11 | 0;
  }
  HEAP32[i8 + 1056 >> 2] = HEAP32[i10 + 1056 >> 2];
  if (__ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags(i9, i8, 4) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  } else {
   HEAP32[i6 >> 2] = i8;
   HEAP32[i6 + 4 >> 2] = i9;
   HEAP32[i6 + 8 >> 2] = i9;
   __Z6FormatPKcz(i7, gb + 491789 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 491603 | 0, 673, 17, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 } while (0);
 i1 = HEAP32[i9 + 1040 >> 2] | 0;
 if (i1 | 0) if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i9 | 0, 0) | 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i3 >> 2] = i8;
 HEAP32[i3 + 4 >> 2] = i9;
 __Z6FormatPKcz(i11, gb + 491966 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 491603 | 0, 686, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j(i24, i4, i1, i2, i3) {
 i24 = i24 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 24 | 0;
 i25 = i28;
 i1 = i3 << 2;
 i22 = i1 >>> 0 > 1024;
 i23 = i26 + 4 | 0;
 HEAP8[i23 >> 0] = i22 & 1;
 if (i22) {
  i5 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i28 + 32 | 0, i1, gb + 838140 | 0, 51) | 0;
  HEAP32[i26 >> 2] = i5;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i26 >> 2] = i2;
  i5 = i2;
 }
 i21 = i25 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i25 + 8 | 0;
 HEAP32[i22 >> 2] = i3;
 i19 = i25 + 12 | 0;
 HEAP32[i19 >> 2] = i5;
 i20 = i25 + 16 | 0;
 HEAP8[i20 >> 0] = 0;
 i1 = i4 + -1 | 0;
 if ((i1 | 0) > 0) {
  i18 = 0;
  i7 = i1;
  i1 = 0;
  i3 = i5;
  i2 = i5;
  i4 = i5;
  L7 : while (1) {
   L9 : do if ((i7 | 0) > (i18 | 0)) {
    i17 = i24 + (i18 << 2) | 0;
    i16 = i3;
    i6 = i3;
    while (1) {
     if ((i7 - i18 | 0) >>> 0 < 5) {
      i8 = i4;
      i27 = 9;
      break;
     }
     i13 = i24 + (((i7 + i18 | 0) / 2 | 0) << 2) | 0;
     i5 = HEAP32[i13 >> 2] | 0;
     i8 = HEAP32[i17 >> 2] | 0;
     i9 = i8;
     i3 = i5;
     if (i5 >>> 0 < i8 >>> 0) {
      HEAP32[i17 >> 2] = i3;
      HEAP32[i13 >> 2] = i9;
      i15 = HEAP32[i17 >> 2] | 0;
      i3 = i9;
      i5 = i8;
      i8 = i15;
      i9 = i15;
     }
     i12 = i24 + (i7 << 2) | 0;
     i10 = HEAP32[i12 >> 2] | 0;
     i11 = i10;
     if (i10 >>> 0 < i8 >>> 0) {
      HEAP32[i17 >> 2] = i11;
      HEAP32[i12 >> 2] = i9;
      i3 = HEAP32[i13 >> 2] | 0;
      i10 = i9;
      i5 = i3;
      i8 = i9;
     } else i8 = i11;
     if (i10 >>> 0 < i5 >>> 0) {
      HEAP32[i13 >> 2] = i8;
      HEAP32[i12 >> 2] = i3;
      i3 = HEAP32[i13 >> 2] | 0;
     }
     i9 = i7 + -1 | 0;
     i15 = i24 + (i9 << 2) | 0;
     HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i15 >> 2] = i3;
     i14 = i3;
     i12 = i3;
     i3 = i18;
     while (1) {
      i10 = i3;
      while (1) {
       i3 = i10 + 1 | 0;
       i5 = i24 + (i3 << 2) | 0;
       i8 = HEAP32[i5 >> 2] | 0;
       if (i8 >>> 0 < i12 >>> 0) i10 = i3; else {
        i13 = i10;
        break;
       }
      }
      do {
       i9 = i9 + -1 | 0;
       i11 = i24 + (i9 << 2) | 0;
       i10 = HEAP32[i11 >> 2] | 0;
      } while (i12 >>> 0 < i10 >>> 0);
      if ((i3 | 0) >= (i9 | 0)) {
       i9 = i14;
       break;
      }
      HEAP32[i5 >> 2] = i10;
      HEAP32[i11 >> 2] = i8;
      i12 = HEAP32[i15 >> 2] | 0;
      i14 = i12;
     }
     HEAP32[i5 >> 2] = i9;
     HEAP32[i15 >> 2] = i8;
     if ((i3 - i18 | 0) < (i7 - i3 | 0)) {
      i9 = i13;
      break;
     }
     i10 = i13 + 2 | 0;
     i5 = HEAP32[i21 >> 2] | 0;
     i3 = HEAP32[i22 >> 2] | 0;
     if (i5 >>> 0 < (i3 + -1 | 0) >>> 0) {
      i9 = i16;
      i8 = i16;
     } else {
      HEAP32[i22 >> 2] = i3 << 1;
      i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, (i3 << 3) + 67 | 0, gb + 838381 | 0, 137) | 0;
      if (!i1) i3 = 0; else {
       i3 = i1 + 67 & -64;
       HEAP32[i3 + -4 >> 2] = i3 - i1;
      }
      _memcpy(i3 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
      if (HEAP8[i20 >> 0] | 0) {
       i1 = HEAP32[i19 >> 2] | 0;
       if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
      }
      HEAP8[i20 >> 0] = 1;
      HEAP32[i19 >> 2] = i3;
      i1 = 1;
      i6 = i3;
      i9 = i3;
      i5 = HEAP32[i21 >> 2] | 0;
      i8 = i3;
      i2 = i3;
      i4 = i3;
     }
     HEAP32[i21 >> 2] = i5 + 1;
     HEAP32[i8 + (i5 << 2) >> 2] = i10;
     i16 = HEAP32[i21 >> 2] | 0;
     HEAP32[i21 >> 2] = i16 + 1;
     HEAP32[i8 + (i16 << 2) >> 2] = i7;
     if ((i13 | 0) > (i18 | 0)) {
      i16 = i9;
      i7 = i13;
     } else break L9;
    }
    if ((i27 | 0) == 9) {
     i27 = 0;
     i5 = i18;
     while (1) {
      i6 = i5;
      i5 = i5 + 1 | 0;
      i4 = i5;
      i3 = i6;
      while (1) {
       i3 = (HEAP32[i24 + (i4 << 2) >> 2] | 0) >>> 0 < (HEAP32[i24 + (i3 << 2) >> 2] | 0) >>> 0 ? i4 : i3;
       if ((i4 | 0) < (i7 | 0)) i4 = i4 + 1 | 0; else break;
      }
      if ((i3 | 0) != (i6 | 0)) {
       i16 = i24 + (i3 << 2) | 0;
       i18 = i24 + (i6 << 2) | 0;
       i17 = HEAP32[i16 >> 2] | 0;
       HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
       HEAP32[i18 >> 2] = i17;
      }
      if ((i5 | 0) == (i7 | 0)) {
       i4 = i8;
       break L9;
      }
     }
    }
    i5 = HEAP32[i21 >> 2] | 0;
    i3 = HEAP32[i22 >> 2] | 0;
    if (i5 >>> 0 < (i3 + -1 | 0) >>> 0) i8 = i6; else {
     HEAP32[i22 >> 2] = i3 << 1;
     i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i25, (i3 << 3) + 67 | 0, gb + 838381 | 0, 137) | 0;
     if (!i1) i3 = 0; else {
      i3 = i1 + 67 & -64;
      HEAP32[i3 + -4 >> 2] = i3 - i1;
     }
     _memcpy(i3 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i21 >> 2] << 2 | 0) | 0;
     if (HEAP8[i20 >> 0] | 0) {
      i1 = HEAP32[i19 >> 2] | 0;
      if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
     }
     HEAP8[i20 >> 0] = 1;
     HEAP32[i19 >> 2] = i3;
     i1 = 1;
     i8 = i3;
     i5 = HEAP32[i21 >> 2] | 0;
     i6 = i3;
     i2 = i3;
     i4 = i3;
    }
    HEAP32[i21 >> 2] = i5 + 1;
    HEAP32[i6 + (i5 << 2) >> 2] = i18;
    i3 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = i3 + 1;
    HEAP32[i6 + (i3 << 2) >> 2] = i9;
    i18 = i9 + 2 | 0;
    i3 = i8;
    continue L7;
   } while (0);
   i3 = HEAP32[i21 >> 2] | 0;
   if (!i3) break;
   i7 = i3 + -1 | 0;
   HEAP32[i21 >> 2] = i7;
   i7 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
   i18 = i3 + -2 | 0;
   HEAP32[i21 >> 2] = i18;
   i18 = HEAP32[i4 + (i18 << 2) >> 2] | 0;
   i3 = i4;
  }
  if (!(i1 << 24 >> 24 == 0 | (i2 | 0) == 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 if (!(HEAP8[i23 >> 0] | 0)) {
  STACKTOP = i28;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i26, HEAP32[i26 >> 2] | 0);
 STACKTOP = i28;
 return;
}

function _psh_blues_set_zones(i2, i3, i4, i9, i8, i16, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = (i1 | 0) == 0;
 i15 = i14 ? i2 + 516 | 0 : i2 + 1548 | 0;
 i14 = i14 ? i2 : i2 + 1032 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 if (i3 >>> 0 > 1) {
  i2 = 0;
  i1 = 0;
  i5 = 0;
  while (1) {
   if (i2) {
    i11 = HEAP16[i4 >> 1] | 0;
    i10 = 1;
    i6 = i5;
    i12 = (HEAP16[i4 + 2 >> 1] | 0) - i11 | 0;
    i2 = i14;
   } else {
    i11 = HEAP16[i4 + 2 >> 1] | 0;
    i10 = 0;
    i6 = i1;
    i12 = (HEAP16[i4 >> 1] | 0) - i11 | 0;
    i2 = i15;
   }
   i2 = i2 + 4 | 0;
   L8 : do if (!i6) i13 = 15; else {
    while (1) {
     i7 = HEAP32[i2 >> 2] | 0;
     if ((i11 | 0) < (i7 | 0)) {
      i13 = 14;
      break;
     }
     if ((i11 | 0) == (i7 | 0)) break;
     i6 = i6 + -1 | 0;
     i2 = i2 + 32 | 0;
     if (!i6) {
      i13 = 15;
      break L8;
     }
    }
    if ((i13 | 0) == 14) while (1) {
     i13 = i2 + (i6 << 5) | 0;
     i6 = i6 + -1 | 0;
     i7 = i2 + (i6 << 5) | 0;
     HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i13 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i13 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
     HEAP32[i13 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
     HEAP32[i13 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
     if (!i6) {
      i13 = 15;
      break L8;
     } else i13 = 14;
    }
    i2 = i2 + 4 | 0;
    i6 = HEAP32[i2 >> 2] | 0;
    if ((i12 | 0) < 0) {
     if ((i12 | 0) >= (i6 | 0)) break;
     HEAP32[i2 >> 2] = i12;
     break;
    } else {
     if ((i12 | 0) <= (i6 | 0)) break;
     HEAP32[i2 >> 2] = i12;
     break;
    }
   } while (0);
   do if ((i13 | 0) == 15) {
    i13 = 0;
    HEAP32[i2 >> 2] = i11;
    HEAP32[i2 + 4 >> 2] = i12;
    if (!(i10 << 24 >> 24)) {
     i1 = i1 + 1 | 0;
     break;
    } else {
     i5 = i5 + 1 | 0;
     break;
    }
   } while (0);
   i3 = i3 + -2 | 0;
   if (i3 >>> 0 <= 1) break; else {
    i4 = i4 + 4 | 0;
    i2 = 1;
   }
  }
 } else {
  i1 = 0;
  i5 = 0;
 }
 HEAP32[i14 >> 2] = i5;
 HEAP32[i15 >> 2] = i1;
 if (i9 >>> 0 > 1) {
  i10 = i15 + 4 | 0;
  while (1) {
   i6 = HEAP16[i8 + 2 >> 1] | 0;
   i7 = (HEAP16[i8 >> 1] | 0) - i6 | 0;
   L33 : do if (!i1) {
    i2 = i10;
    i13 = 31;
   } else {
    i2 = i10;
    i3 = i1;
    while (1) {
     i4 = HEAP32[i2 >> 2] | 0;
     if ((i6 | 0) < (i4 | 0)) {
      i13 = 30;
      break;
     }
     if ((i6 | 0) == (i4 | 0)) break;
     i3 = i3 + -1 | 0;
     i2 = i2 + 32 | 0;
     if (!i3) {
      i13 = 31;
      break L33;
     }
    }
    if ((i13 | 0) == 30) while (1) {
     i13 = i2 + (i3 << 5) | 0;
     i3 = i3 + -1 | 0;
     i12 = i2 + (i3 << 5) | 0;
     HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     HEAP32[i13 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
     HEAP32[i13 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
     HEAP32[i13 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
     if (!i3) {
      i13 = 31;
      break L33;
     } else i13 = 30;
    }
    i2 = i2 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i7 | 0) < 0) {
     if ((i7 | 0) >= (i3 | 0)) break;
     HEAP32[i2 >> 2] = i7;
     break;
    } else {
     if ((i7 | 0) <= (i3 | 0)) break;
     HEAP32[i2 >> 2] = i7;
     break;
    }
   } while (0);
   if ((i13 | 0) == 31) {
    i13 = 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 4 >> 2] = i7;
    i1 = i1 + 1 | 0;
   }
   i9 = i9 + -2 | 0;
   if (i9 >>> 0 <= 1) {
    i10 = i1;
    break;
   } else i8 = i8 + 4 | 0;
  }
 } else i10 = i1;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i15 >> 2] = i10;
 i8 = (i5 | 0) == 0;
 L51 : do if (!i8) {
  i6 = i5;
  i7 = i14 + 4 | 0;
  while (1) {
   switch (i6 | 0) {
   case 0:
    break L51;
   case 1:
    {
     i2 = HEAP32[i7 >> 2] | 0;
     i1 = HEAP32[i7 + 4 >> 2] | 0;
     break;
    }
   default:
    {
     i2 = HEAP32[i7 >> 2] | 0;
     i1 = (HEAP32[i7 + 32 >> 2] | 0) - i2 | 0;
     i3 = i7 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) > (i1 | 0)) HEAP32[i3 >> 2] = i1; else i1 = i4;
    }
   }
   HEAP32[i7 + 12 >> 2] = i2;
   HEAP32[i7 + 8 >> 2] = i1 + i2;
   i6 = i6 + -1 | 0;
   i7 = i7 + 32 | 0;
  }
 } while (0);
 i9 = (i10 | 0) == 0;
 L61 : do if (!i9) {
  i6 = i15 + 4 | 0;
  i7 = i10;
  while (1) {
   switch (i7 | 0) {
   case 0:
    break L61;
   case 1:
    {
     i2 = HEAP32[i6 >> 2] | 0;
     i1 = HEAP32[i6 + 4 >> 2] | 0;
     break;
    }
   default:
    {
     i2 = HEAP32[i6 >> 2] | 0;
     i1 = i2 - (HEAP32[i6 + 32 >> 2] | 0) | 0;
     i3 = i6 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) < (i1 | 0)) HEAP32[i3 >> 2] = i1; else i1 = i4;
    }
   }
   HEAP32[i6 + 8 >> 2] = i2;
   HEAP32[i6 + 12 >> 2] = i1 + i2;
   i6 = i6 + 32 | 0;
   i7 = i7 + -1 | 0;
  }
 } while (0);
 i1 = i14 + 4 | 0;
 if (!i8) {
  i3 = i14 + 16 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i16;
  i3 = i5 + -1 | 0;
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  if (i3) {
   i7 = i14 + -28 + (i5 << 3 << 2) | 0;
   while (1) {
    i4 = i1 + 44 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = (i5 - i2 | 0) / 2 | 0;
    if ((i6 | 0) < (i16 | 0)) {
     i14 = i6 + i2 | 0;
     HEAP32[i4 >> 2] = i14;
     HEAP32[i1 + 8 >> 2] = i14;
    } else {
     HEAP32[i1 + 8 >> 2] = i2 + i16;
     HEAP32[i4 >> 2] = i5 - i16;
    }
    i3 = i3 + -1 | 0;
    i2 = HEAP32[i1 + 40 >> 2] | 0;
    if (!i3) break; else i1 = i1 + 32 | 0;
   }
   i1 = i7;
  }
  HEAP32[i1 + 8 >> 2] = i2 + i16;
 }
 i1 = i15 + 4 | 0;
 if (i9) return;
 i3 = i15 + 16 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i16;
 i3 = i10 + -1 | 0;
 i2 = HEAP32[i15 + 12 >> 2] | 0;
 if (i3) {
  i4 = i15 + -28 + (i10 << 3 << 2) | 0;
  while (1) {
   i13 = i1 + 44 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i15 = (i12 - i2 | 0) / 2 | 0;
   i14 = (i15 | 0) < (i16 | 0);
   i15 = i15 + i2 | 0;
   HEAP32[i13 >> 2] = i14 ? i15 : i12 - i16 | 0;
   HEAP32[i1 + 8 >> 2] = i14 ? i15 : i2 + i16 | 0;
   i3 = i3 + -1 | 0;
   i2 = HEAP32[i1 + 40 >> 2] | 0;
   if (!i3) break; else i1 = i1 + 32 | 0;
  }
  i1 = i4;
 }
 HEAP32[i1 + 8 >> 2] = i2 + i16;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_(i16, i17, i14, i10, i9, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_(i16, i17, i14, i10, i1) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i2;
 i8 = i1;
 do if (i1 >>> 0 < i2 >>> 0) {
  i2 = i9 + 8 | 0;
  i1 = i2;
  i13 = i10 + 8 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i2 >>> 0 < i1 >>> 0) {
   i17 = i15;
   return i17 | 0;
  }
  i2 = i9 + 8 | 0;
  i1 = i2;
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i10 + 8 | 0;
  i4 = i5;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i6 | 0) == (i3 | 0) & (i1 | 0) == (i4 | 0)) {
   i12 = i9 + 16 | 0;
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i10 + 16 | 0;
   i11 = HEAP32[i13 + 4 >> 2] | 0;
   if (i4 >>> 0 < i11 >>> 0 | ((i4 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
    i13 = i5;
    i3 = i6;
    break;
   } else i1 = i15;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i4 >>> 0 | (i1 | 0) == (i4 | 0) & i6 >>> 0 < i3 >>> 0) {
    i13 = i5;
    i3 = i6;
    break;
   } else i1 = i15;
   return i1 | 0;
  }
 } while (0);
 HEAP32[i10 >> 2] = i8;
 HEAP32[i9 >> 2] = i7;
 i12 = i13;
 i6 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i11 = i10 + 16 | 0;
 i7 = i11;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = i9 + 16 | 0;
 i5 = i1;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i15 + 1 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i7 = i3;
 i8 = i2;
 do if (i2 >>> 0 < i3 >>> 0) {
  i1 = i13;
  i12 = i14 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i3 >>> 0 < i2 >>> 0) {
   i17 = i1;
   return i17 | 0;
  }
  i6 = i13;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i14 + 8 | 0;
  i5 = i3;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i6 | 0) == (i5 | 0)) {
   i9 = i11;
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i14 + 16 | 0;
   i5 = HEAP32[i12 + 4 >> 2] | 0;
   if (i4 >>> 0 < i5 >>> 0 | ((i4 | 0) == (i5 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 : 0)) {
    i12 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i12 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 HEAP32[i14 >> 2] = i8;
 HEAP32[i10 >> 2] = i7;
 i8 = i12;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i14 + 16 | 0;
 i3 = i10;
 i7 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i11;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i13;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i11;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i15 + 2 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i7 = i3;
 i8 = i2;
 do if (i2 >>> 0 < i3 >>> 0) {
  i1 = i12;
  i11 = i17 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i3 >>> 0 < i2 >>> 0) {
   i17 = i1;
   return i17 | 0;
  }
  i6 = i12;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i17 + 8 | 0;
  i5 = i3;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i6 | 0) == (i5 | 0)) {
   i11 = i10;
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i17 + 16 | 0;
   i9 = HEAP32[i13 + 4 >> 2] | 0;
   if (i5 >>> 0 < i9 >>> 0 | ((i5 | 0) == (i9 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
    i11 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i11 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 HEAP32[i17 >> 2] = i8;
 HEAP32[i14 >> 2] = i7;
 i8 = i11;
 i14 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i17 + 16 | 0;
 i3 = i9;
 i7 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i1;
 i13 = i10;
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i10;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i15 + 3 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i7 = i3;
 i8 = i2;
 do if (i2 >>> 0 < i3 >>> 0) {
  i1 = i11;
  i3 = i16 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i3 >>> 0 < i2 >>> 0) {
   i17 = i1;
   return i17 | 0;
  }
  i6 = i11;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i16 + 8 | 0;
  i5 = i3;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i6 | 0) == (i5 | 0)) {
   i13 = i9;
   i10 = HEAP32[i13 + 4 >> 2] | 0;
   i14 = i16 + 16 | 0;
   i12 = HEAP32[i14 + 4 >> 2] | 0;
   if (i10 >>> 0 < i12 >>> 0 | ((i10 | 0) == (i12 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0 : 0)) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 HEAP32[i16 >> 2] = i8;
 HEAP32[i17 >> 2] = i7;
 i13 = i3;
 i12 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i17 = i16 + 16 | 0;
 i16 = i17;
 i14 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i9;
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i17 + 4 >> 2] = i10;
 i17 = i11;
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 4 >> 2] = i13;
 i17 = i9;
 HEAP32[i17 >> 2] = i14;
 HEAP32[i17 + 4 >> 2] = i16;
 i17 = i15 + 4 | 0;
 return i17 | 0;
}

function __ZN23ArchiveStorageConverter18DecompressAndStoreEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 8 | 0;
 i14 = i19;
 if (!(HEAP8[i5 + 56 >> 0] | 0)) {
  i1 = __ZN23ArchiveStorageConverter24ReadHeaderFromMemoryFileEv(i5) | 0;
  if (i1 | 0) {
   i18 = i1;
   STACKTOP = i19;
   return i18 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) if (!(mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, HEAP32[i5 + 28 >> 2] | 0) | 0)) {
   i18 = -1;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 i1 = i5 + 57 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  if (i2 | 0) if (HEAP8[i2 + 184 >> 0] | 0) {
   HEAP8[i1 >> 0] = 1;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0) | 0)) {
    i18 = -1;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
 }
 i12 = i5 + 60 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i10 = i5 + 68 | 0;
  i11 = i5 + 80 | 0;
  HEAP32[i11 >> 2] = 65536;
  i1 = i5 + 84 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  do if ((i2 & 2147418112) >>> 0 < 65536) if ((i2 | 0) > -1) {
   HEAP32[i1 >> 2] = 65536;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, 65536, 1, i5 + 72 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(65536, 1, i5 + 72 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i15 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
   HEAP32[i1 >> 2] = 65536;
   HEAP32[i10 >> 2] = i15;
   break;
  } while (0);
  i6 = i5 + 40 | 0;
  i1 = i6;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = i5 + 48 | 0;
  i4 = i7;
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(i4 >>> 0 > i1 >>> 0 | (i4 | 0) == (i1 | 0) & i2 >>> 0 > i3 >>> 0)) {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
  i8 = i5 + 24 | 0;
  i9 = i5 + 16 | 0;
  i5 = i5 + 4 | 0;
  while (1) {
   i20 = HEAP32[i11 >> 2] | 0;
   i2 = _i64Subtract(i2 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
   i15 = getTempRet0() | 0;
   i4 = i15 >>> 0 < 0 | (i15 | 0) == 0 & i2 >>> 0 < i20 >>> 0;
   i21 = HEAP32[i8 >> 2] | 0;
   if (!(mftCall_iiiiiiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, i3 | 0, i1 | 0, (i4 ? i2 : i20) | 0, (i4 ? i15 : 0) | 0, HEAP32[i10 >> 2] | 0, i14 | 0) | 0)) {
    i13 = -1;
    break;
   }
   i2 = i14;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i13 = 1;
    break;
   }
   i20 = __ZN12FileAccessor5WriteEyPKvPy(HEAP32[i12 >> 2] | 0, i1, i2, HEAP32[i10 >> 2] | 0, i17) | 0;
   i21 = i17;
   if (!(i20 & ((HEAP32[i21 >> 2] | 0) == (i1 | 0) ? (HEAP32[i21 + 4 >> 2] | 0) == (i2 | 0) : 0))) {
    i13 = -1;
    break;
   }
   i3 = i14;
   i1 = i6;
   i3 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
   i1 = getTempRet0() | 0;
   i4 = i6;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = i1;
   i4 = i9;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = i1;
   __ZN24RingBufferMemoryFileData16ConsumeReadBytesEy(HEAP32[i5 >> 2] | 0, i3, i1);
   i1 = i6;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = i7;
   i2 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (!(i4 >>> 0 > i1 >>> 0 | (i4 | 0) == (i1 | 0) & i2 >>> 0 > i3 >>> 0)) {
    i16 = 0;
    i18 = 34;
    break;
   }
  }
  if ((i18 | 0) == 34) {
   STACKTOP = i19;
   return i16 | 0;
  }
  i21 = i13;
  STACKTOP = i19;
  return i21 | 0;
 }
 i11 = i5 + 64 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  i21 = -1;
  STACKTOP = i19;
  return i21 | 0;
 }
 i12 = i5 + 68 | 0;
 i1 = HEAP32[i5 + 88 >> 2] | 0;
 i13 = i5 + 80 | 0;
 HEAP32[i13 >> 2] = i1;
 i2 = i5 + 84 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1, 1, i5 + 72 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i5 + 72 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = i21;
  break;
 } while (0);
 i6 = i5 + 40 | 0;
 i1 = i6;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i5 + 48 | 0;
 i4 = i7;
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(i4 >>> 0 > i1 >>> 0 | (i4 | 0) == (i1 | 0) & i2 >>> 0 > i3 >>> 0)) {
  i21 = 0;
  STACKTOP = i19;
  return i21 | 0;
 }
 i8 = i5 + 28 | 0;
 i9 = i5 + 24 | 0;
 i10 = i5 + 16 | 0;
 i5 = i5 + 4 | 0;
 while (1) {
  i14 = HEAP32[i13 >> 2] | 0;
  i4 = _i64Subtract(i2 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
  i21 = getTempRet0() | 0;
  i20 = i21 >>> 0 < 0 | (i21 | 0) == 0 & i4 >>> 0 < i14 >>> 0;
  if (!(__ZN20ArchiveStorageReader4ReadEyyPvPy(HEAP32[i8 >> 2] | 0, i3, i1, i20 ? i4 : i14, i20 ? i21 : 0, HEAP32[i12 >> 2] | 0, i17) | 0)) {
   i15 = -1;
   break;
  }
  i2 = i17;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if ((i1 | 0) == 0 & (i2 | 0) == 0) {
   i15 = 1;
   break;
  }
  if (!(__ZN21ArchiveStorageCreator10AppendDataEPKvj(HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0, i1) | 0)) {
   i15 = -1;
   break;
  }
  i4 = i6;
  i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  i1 = getTempRet0() | 0;
  i3 = i6;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = HEAP32[i9 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  i1 = getTempRet0() | 0;
  i4 = i10;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = i1;
  __ZN24RingBufferMemoryFileData16ConsumeReadBytesEy(HEAP32[i5 >> 2] | 0, i3, i1);
  i1 = i6;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i7;
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(i4 >>> 0 > i1 >>> 0 | (i4 | 0) == (i1 | 0) & i2 >>> 0 > i3 >>> 0)) {
   i16 = 0;
   i18 = 34;
   break;
  }
 }
 if ((i18 | 0) == 34) {
  STACKTOP = i19;
  return i16 | 0;
 }
 i21 = i15;
 STACKTOP = i19;
 return i21 | 0;
}

function __ZN8VRModuleC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 68 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 1 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[gb + 189476 >> 2];
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP32[gb + 1469188 >> 2] = i1;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i3 + 9260 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = i1 + 1;
 HEAP32[i3 + 8492 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 8492 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 8492 + (i1 * 12 | 0) >> 2] = fb + 414;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 20840 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 20072 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) >> 2] = fb + 415;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 21612 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 20844 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 20844 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 20844 + (i1 * 12 | 0) >> 2] = fb + 416;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 25472 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 24 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 24704 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 24704 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 24704 + (i1 * 12 | 0) >> 2] = fb + 417;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 24700 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 32 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) >> 2] = fb + 418;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 20068 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 40 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 19300 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 19300 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 19300 + (i1 * 12 | 0) >> 2] = fb + 419;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 17752 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 48 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 16984 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 16984 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 16984 + (i1 * 12 | 0) >> 2] = fb + 420;
 HEAP32[gb + 1115296 + 16 >> 2] = fb + 421;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 4628 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 56 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 3860 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) >> 2] = fb + 1004;
 i1 = HEAP32[gb + 1155296 + 768 >> 2] | 0;
 if (i1 >>> 0 <= 63) {
  i4 = i1;
  i3 = i4 + 1 | 0;
  HEAP32[gb + 1155296 + 768 >> 2] = i3;
  i3 = gb + 1155296 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = gb + 1155296 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = gb + 1155296 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 422;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 64 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[gb + 1155296 + 768 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[gb + 1155296 + 768 >> 2] = i3;
 i3 = gb + 1155296 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = gb + 1155296 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = gb + 1155296 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 422;
 STACKTOP = i5;
 return;
}

function __ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i3, i2, i30, i29, i36, i37) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i30 = i30 | 0;
 i29 = i29 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 var i1 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i38 + 64 | 0;
 i32 = i38 + 48 | 0;
 i31 = i38 + 32 | 0;
 i1 = i38 + 16 | 0;
 i33 = i38;
 i34 = i38 + 80 | 0;
 HEAPF32[i35 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu16testPolyDataAxisERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i3, i2, i30, i29, i35, i1) | 0)) {
  i37 = 0;
  STACKTOP = i38;
  return i37 | 0;
 }
 i26 = i3 + 112 | 0;
 f5 = Math_fround(HEAPF32[i26 >> 2]);
 i27 = i3 + 116 | 0;
 f6 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i3 + 120 | 0;
 f22 = Math_fround(HEAPF32[i28 >> 2]);
 i17 = i3 + 96 | 0;
 f20 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i3 + 100 | 0;
 f21 = Math_fround(HEAPF32[i18 >> 2]);
 i19 = i3 + 104 | 0;
 f20 = Math_fround(f5 - f20);
 f21 = Math_fround(f6 - f21);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i19 >> 2]));
 i23 = i2 + 16 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 L4 : do if (i4) {
  i24 = i2 + 24 | 0;
  i25 = i2 + 32 | 0;
  i12 = i2 + 28 | 0;
  i13 = i30 + 40 | 0;
  i14 = i33 + 4 | 0;
  i15 = i33 + 8 | 0;
  i16 = i33 + 12 | 0;
  i10 = i3 + 128 | 0;
  i11 = i35 + 4 | 0;
  i2 = i4;
  i9 = 0;
  L7 : while (1) {
   i8 = HEAP32[i24 >> 2] | 0;
   i4 = HEAP32[i25 >> 2] | 0;
   i7 = HEAPU16[i8 + (i9 * 20 | 0) + 16 >> 1] | 0;
   i8 = i8 + (i9 * 20 | 0) + 18 | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (i3 << 24 >> 24) {
    i2 = (i3 & 255) + -1 | 0;
    i3 = 0;
    while (1) {
     i44 = HEAPU8[i4 + (i3 + i7) >> 0] | 0;
     i43 = HEAP32[i12 >> 2] | 0;
     f5 = Math_fround(HEAPF32[i43 + (i44 * 12 | 0) >> 2]);
     f6 = Math_fround(HEAPF32[i43 + (i44 * 12 | 0) + 4 >> 2]);
     f41 = Math_fround(HEAPF32[i43 + (i44 * 12 | 0) + 8 >> 2]);
     i2 = HEAPU8[i4 + (i2 + i7) >> 0] | 0;
     f42 = Math_fround(HEAPF32[i43 + (i2 * 12 | 0) >> 2]);
     f40 = Math_fround(HEAPF32[i43 + (i2 * 12 | 0) + 4 >> 2]);
     f5 = Math_fround(f42 - f5);
     f6 = Math_fround(f40 - f6);
     f41 = Math_fround(Math_fround(HEAPF32[i43 + (i2 * 12 | 0) + 8 >> 2]) - f41);
     i2 = HEAP32[i13 >> 2] | 0;
     f40 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
     f40 = Math_fround(f40 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 4 >> 2])));
     f40 = Math_fround(f40 + Math_fround(f41 * Math_fround(HEAPF32[i2 + 8 >> 2])));
     f42 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 16 >> 2]));
     f42 = Math_fround(f42 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 20 >> 2])));
     f42 = Math_fround(f42 + Math_fround(f41 * Math_fround(HEAPF32[i2 + 24 >> 2])));
     f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 32 >> 2]));
     f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 36 >> 2])));
     f41 = Math_fround(f6 + Math_fround(f41 * Math_fround(HEAPF32[i2 + 40 >> 2])));
     f6 = Math_fround(Math_fround(f21 * f41) - Math_fround(f22 * f42));
     f41 = Math_fround(Math_fround(f22 * f40) - Math_fround(f20 * f41));
     f40 = Math_fround(Math_fround(f20 * f42) - Math_fround(f21 * f40));
     f42 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f40 * f40) + Math_fround(Math_fround(f6 * f6) + Math_fround(f41 * f41))))));
     f41 = Math_fround(f42 * f41);
     f40 = Math_fround(f40 * f42);
     HEAPF32[i33 >> 2] = Math_fround(f42 * f6);
     HEAPF32[i14 >> 2] = f41;
     HEAPF32[i15 >> 2] = f40;
     HEAPF32[i16 >> 2] = Math_fround(0.0);
     mftCall_viiii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i33 | 0, i32 | 0, i31 | 0);
     f40 = Math_fround(HEAPF32[i17 >> 2]);
     f41 = Math_fround(HEAPF32[i18 >> 2]);
     f6 = Math_fround(HEAPF32[i19 >> 2]);
     f42 = Math_fround(HEAPF32[i33 >> 2]);
     f5 = Math_fround(HEAPF32[i14 >> 2]);
     f39 = Math_fround(HEAPF32[i15 >> 2]);
     f6 = Math_fround(Math_fround(Math_fround(f40 * f42) + Math_fround(f41 * f5)) + Math_fround(f6 * f39));
     f41 = Math_fround(HEAPF32[i26 >> 2]);
     f40 = Math_fround(HEAPF32[i27 >> 2]);
     f39 = Math_fround(Math_fround(Math_fround(f42 * f41) + Math_fround(f5 * f40)) + Math_fround(f39 * Math_fround(HEAPF32[i28 >> 2])));
     i2 = f6 > f39;
     f40 = Math_fround(HEAPF32[i10 >> 2]);
     f5 = Math_fround((i2 ? f39 : f6) - f40);
     f39 = Math_fround(f40 + (i2 ? f6 : f39));
     f6 = Math_fround(HEAPF32[i31 >> 2]);
     f40 = Math_fround(HEAPF32[i29 >> 2]);
     i2 = f5 > Math_fround(f6 + f40);
     if (i2 | Math_fround(HEAPF32[i32 >> 2]) > Math_fround(f40 + f39)) {
      i1 = 0;
      break L7;
     }
     f5 = Math_fround(f6 - f5);
     if (Math_fround(HEAPF32[i35 >> 2]) > f5) {
      HEAPF32[i35 >> 2] = f5;
      HEAP32[i11 >> 2] = HEAP32[i34 >> 2];
      HEAP32[i11 + 4 >> 2] = HEAP32[i34 + 4 >> 2];
      HEAP32[i11 + 8 >> 2] = HEAP32[i34 + 8 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i33 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
     }
     i2 = i3 + 1 | 0;
     if (i2 >>> 0 < (HEAPU8[i8 >> 0] | 0) >>> 0) {
      i44 = i3;
      i3 = i2;
      i2 = i44;
     } else break;
    }
    i2 = HEAP32[i23 >> 2] | 0;
   }
   i9 = i9 + 1 | 0;
   if (i9 >>> 0 >= i2 >>> 0) break L4;
  }
  STACKTOP = i38;
  return i1 | 0;
 } while (0);
 HEAP32[i37 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i37 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i36 >> 2] = HEAP32[i35 >> 2];
 HEAP32[i36 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
 HEAP32[i36 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
 HEAP32[i36 + 12 >> 2] = HEAP32[i35 + 12 >> 2];
 i44 = 1;
 STACKTOP = i38;
 return i44 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 204 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    HEAP16[i17 >> 1] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 202 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 203 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5physx2Sn12RepXUpgrader34upgrade10CollectionTo3_1CollectionERNS0_14RepXCollectionE(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i20 + 24 | 0;
 i17 = i20 + 76 | 0;
 i6 = i20 + 64 | 0;
 i13 = i20 + 60 | 0;
 i14 = i20 + 56 | 0;
 i15 = i20 + 52 | 0;
 i16 = i20 + 48 | 0;
 i7 = i20;
 i11 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 56 >> 2] | 0, i18 | 0) | 0;
 __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj(i18, i11, gb + 140316 | 0, 216);
 i12 = mftCall_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 52 >> 2] | 0, i18 | 0, gb + 756441 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 32 >> 2] | 0, i18 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
 if ((i1 | 0) == (i8 | 0)) {
  i19 = HEAP32[i11 >> 2] | 0;
  i19 = i19 + 68 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i11 | 0);
  i19 = HEAP32[i18 >> 2] | 0;
  i19 = i19 + 8 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i18 | 0);
  STACKTOP = i20;
  return i12 | 0;
 }
 i9 = i7 + 4 | 0;
 i10 = i7 + 16 | 0;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i4 = mftCall_iii(HEAP32[(HEAP32[i18 >> 2] | 0) + 40 >> 2] | 0, i18 | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i4 | 0);
  if (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, gb + 756447 | 0) | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756447 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756464 | 0);
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
  }
  if (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, gb + 756487 | 0) | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756487 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756508 | 0);
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
  }
  if (!(_strstr(i3, gb + 780838 | 0) | 0)) {
   if (_strstr(i3, gb + 756523 | 0) | 0) i19 = 9;
  } else i19 = 9;
  if ((i19 | 0) == 9) {
   i19 = 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 756529 | 0, i13 | 0) | 0) mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756529 | 0) | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 756536 | 0, i14 | 0) | 0) mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756536 | 0) | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 756543 | 0, i15 | 0) | 0) mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756543 | 0) | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, gb + 756554 | 0, i16 | 0) | 0) mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] | 0, i11 | 0, gb + 756554 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756565 | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   if (i2 | 0) if (HEAP8[i2 >> 0] | 0) {
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 771563 | 0);
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
    mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   }
   i2 = HEAP32[i14 >> 2] | 0;
   if (i2 | 0) if (HEAP8[i2 >> 0] | 0) {
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 771570 | 0);
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
    mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   }
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756572 | 0);
   i2 = HEAP32[i15 >> 2] | 0;
   if (i2 | 0) if (HEAP8[i2 >> 0] | 0) {
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756582 | 0);
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
    mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   }
   i2 = HEAP32[i16 >> 2] | 0;
   if (i2 | 0) if (HEAP8[i2 >> 0] | 0) {
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0, gb + 756590 | 0);
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] | 0, i11 | 0, i2 | 0);
    mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
   }
   mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0) | 0;
  }
  i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i9 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i10 >> 2] = i4;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  mftCall_vii(i2 | 0, i12 | 0, i5 | 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i8 | 0));
 i19 = HEAP32[i11 >> 2] | 0;
 i19 = i19 + 68 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 mftCall_vi(i19 | 0, i11 | 0);
 i19 = HEAP32[i18 >> 2] | 0;
 i19 = i19 + 8 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 mftCall_vi(i19 | 0, i18 | 0);
 STACKTOP = i20;
 return i12 | 0;
}

function __ZN14PlayerSettings5ResetEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i9 = i10;
 HEAP32[i7 + 328 >> 2] = 0;
 HEAP32[i7 + 332 >> 2] = 0;
 HEAP8[i7 + 336 >> 0] = 1;
 HEAP8[i7 + 337 >> 0] = 0;
 HEAP32[i8 >> 2] = 1;
 __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i7 + 340 | 0, 6, i8, 1);
 HEAP32[i7 + 152 >> 2] = 1;
 HEAP32[i7 + 156 >> 2] = 1;
 i1 = HEAP32[gb + 1162568 + 4 >> 2] | 0;
 i6 = HEAP32[gb + 1162568 + 8 >> 2] | 0;
 i5 = HEAP32[gb + 1162568 + 12 >> 2] | 0;
 HEAP32[i7 + 244 >> 2] = HEAP32[gb + 1162568 >> 2];
 HEAP32[i7 + 248 >> 2] = i1;
 HEAP32[i7 + 252 >> 2] = i6;
 HEAP32[i7 + 256 >> 2] = i5;
 HEAPF32[i7 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 184 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 188 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 180 >> 2] = Math_fround(1.0);
 HEAP8[i7 + 148 >> 0] = 1;
 HEAP8[i7 + 149 >> 0] = 1;
 HEAP32[i7 + 160 >> 2] = 0;
 HEAPF32[i7 + 164 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 168 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 236 >> 2] = 0;
 HEAP32[i7 + 240 >> 2] = 0;
 HEAP32[i7 + 260 >> 2] = 0;
 HEAP32[i7 + 264 >> 2] = 0;
 i5 = i7 + 556 | 0;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 8 >> 2] = -2147483616;
 HEAP32[i9 + 4 >> 2] = 23;
 i1 = i6;
 i2 = gb + 450645 | 0;
 i3 = i1 + 23 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 23 >> 0] = 0;
 i4 = i9 + 11 | 0;
 i2 = i5 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 < 0) {
  i1 = (HEAP32[i7 + 564 >> 2] & 2147483647) + -1 | 0;
  if (i1 >>> 0 < 23) {
   i2 = HEAP32[i7 + 560 >> 2] | 0;
   i3 = 8;
   break;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  _memmove(i5 | 0, i6 | 0, 23) | 0;
  HEAP8[i5 + 23 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i7 + 560 >> 2] = 23;
   i3 = 9;
   break;
  } else {
   HEAP8[i2 >> 0] = 23;
   i3 = 9;
   break;
  }
 } else {
  i1 = 10;
  i2 = i3 & 255;
  i3 = 8;
 } while (0);
 if ((i3 | 0) == 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i1, 23 - i1 | 0, i2, 0, i2, 23, i6);
  if ((HEAP8[i4 >> 0] | 0) < 0) i3 = 9;
 }
 if ((i3 | 0) == 9) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 572 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i9 + 11 | 0;
 HEAP8[i4 >> 0] = 3;
 HEAP8[i9 >> 0] = HEAP8[gb + 766693 >> 0] | 0;
 HEAP8[i9 + 1 >> 0] = HEAP8[gb + 766693 + 1 >> 0] | 0;
 HEAP8[i9 + 2 >> 0] = HEAP8[gb + 766693 + 2 >> 0] | 0;
 HEAP8[i9 + 3 >> 0] = 0;
 L15 : do if ((i1 | 0) != (i9 | 0)) {
  i5 = i1 + 11 | 0;
  do if ((HEAP8[i5 >> 0] | 0) < 0) {
   i2 = HEAP32[i7 + 580 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 3) {
    i6 = HEAP32[i7 + 576 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 4 - i2 | 0, i6, 0, i6, 3, i9);
    break L15;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } while (0);
  _memmove(i1 | 0, i9 | 0, 3) | 0;
  HEAP8[i1 + 3 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i7 + 576 >> 2] = 3;
   break;
  } else {
   HEAP8[i5 >> 0] = 3;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i6 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 HEAP8[i7 + 386 >> 0] = 1;
 HEAP8[i7 + 387 >> 0] = 1;
 HEAP32[i7 + 316 >> 2] = 1;
 HEAP32[i7 + 300 >> 2] = 1024;
 HEAP32[i7 + 304 >> 2] = 768;
 HEAP32[i7 + 308 >> 2] = 960;
 HEAP32[i7 + 312 >> 2] = 600;
 HEAP8[i7 + 280 >> 0] = 0;
 HEAP32[i7 + 284 >> 2] = 4;
 i9 = i7 + 377 | 0;
 HEAP8[i9 >> 0] = 1;
 HEAP8[i9 + 1 >> 0] = 1;
 HEAP8[i9 + 2 >> 0] = 1;
 HEAP8[i9 + 3 >> 0] = 1;
 HEAP8[i9 + 4 >> 0] = 1;
 HEAP8[i9 + 5 >> 0] = 1;
 HEAP8[i7 + 383 >> 0] = 0;
 HEAP8[i7 + 384 >> 0] = 0;
 HEAP8[i7 + 385 >> 0] = 0;
 HEAP32[i7 + 364 >> 2] = -1;
 HEAP32[i7 + 360 >> 2] = -1;
 HEAP32[i7 + 368 >> 2] = -1;
 HEAP32[i7 + 372 >> 2] = 0;
 HEAP8[i7 + 376 >> 0] = 1;
 HEAP8[i7 + 388 >> 0] = 0;
 HEAP8[i7 + 389 >> 0] = 0;
 HEAP32[i7 + 288 >> 2] = 2;
 HEAP8[i7 + 292 >> 0] = 0;
 HEAP32[i7 + 296 >> 2] = 60;
 HEAP8[i7 + 390 >> 0] = 0;
 HEAP8[i7 + 391 >> 0] = 0;
 HEAP8[i7 + 392 >> 0] = 1;
 HEAP8[i7 + 393 >> 0] = 1;
 HEAP8[i7 + 394 >> 0] = 0;
 HEAP8[i7 + 412 >> 0] = 0;
 HEAP8[i7 + 413 >> 0] = 0;
 HEAP8[i7 + 395 >> 0] = 0;
 HEAP32[i7 + 400 >> 2] = 2;
 HEAP32[i7 + 404 >> 2] = 1;
 HEAP32[i7 + 408 >> 2] = 1;
 HEAP8[i7 + 396 >> 0] = 0;
 HEAP8[i7 + 397 >> 0] = 1;
 i9 = i7 + 414 | 0;
 HEAP32[i7 + 432 >> 2] = 0;
 HEAP32[i7 + 436 >> 2] = 0;
 HEAP16[i9 >> 1] = 0;
 HEAP16[i9 + 2 >> 1] = 0;
 HEAP16[i9 + 4 >> 1] = 0;
 HEAP16[i9 + 6 >> 1] = 0;
 HEAP16[i9 + 8 >> 1] = 0;
 HEAP16[i9 + 10 >> 1] = 0;
 HEAP16[i9 + 12 >> 1] = 0;
 HEAP32[i7 + 440 >> 2] = 1;
 HEAP8[i7 + 428 >> 0] = 0;
 HEAP8[i7 + 429 >> 0] = 1;
 HEAP8[i7 + 430 >> 0] = 0;
 HEAP32[i7 + 444 >> 2] = 0;
 HEAP32[i7 + 624 >> 2] = 0;
 HEAP8[i7 + 628 >> 0] = 1;
 HEAP8[i7 + 629 >> 0] = 0;
 HEAP32[i7 + 448 >> 2] = 0;
 HEAP8[i7 + 452 >> 0] = 1;
 HEAP32[i7 + 504 >> 2] = 0;
 HEAP32[i7 + 508 >> 2] = 1;
 i9 = i7 + 512 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP8[i9 + 4 >> 0] = 0;
 HEAP8[i7 + 517 >> 0] = 1;
 HEAP32[i7 + 520 >> 2] = 0;
 HEAP8[i7 + 60 >> 0] = 0;
 HEAP8[i7 + 630 >> 0] = 0;
 HEAP32[i7 + 268 >> 2] = 0;
 HEAPF32[i7 + 272 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 276 >> 2] = Math_fround(0.0);
 STACKTOP = i10;
 return;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i19, i20, i2, i21, i17) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 198 | 0;
 i11 = i18 + 196 | 0;
 i22 = i18 + 184 | 0;
 i23 = i18 + 172 | 0;
 i12 = i18 + 168 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 4 | 0;
 i13 = i18;
 i14 = __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i2) | 0;
 __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i22, i2, i10, i11);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i23 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = i23 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = (HEAP32[i23 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i23 | 0, i1 | 0, 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  i7 = i23 + 4 | 0;
  i8 = i23 + 8 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  L11 : while (1) {
   if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break;
    }
    if ((i2 | 0) == -1) {
     HEAP32[i19 >> 2] = 0;
     i1 = 0;
    }
   }
   i2 = (i1 | 0) == 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do if (!i4) i24 = 19; else {
    if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i4 + 16 >> 2] | 0)) if (i2) break; else {
     i24 = 38;
     break L11;
    }
    __THREW__ = 0;
    i5 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 28;
     break L11;
    }
    if ((i5 | 0) == -1) {
     HEAP32[i20 >> 2] = 0;
     i24 = 19;
     break;
    } else if (i2) break; else {
     i24 = 38;
     break L11;
    }
   } while (0);
   if ((i24 | 0) == 19) {
    i24 = 0;
    if (i2) {
     i4 = 0;
     i24 = 38;
     break;
    } else i4 = 0;
   }
   i5 = HEAP8[i9 >> 0] | 0;
   i5 = i5 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
   if ((HEAP32[i12 >> 2] | 0) == (i3 + i5 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i5 << 1 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) < 0) i2 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
    __THREW__ = 0;
    invoke_viii(fb + 1039 | 0, i23 | 0, i2 | 0, 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i24 = 30;
     break;
    }
    i3 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23;
    HEAP32[i12 >> 2] = i3 + i5;
   }
   i5 = i1 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    }
   } else i2 = HEAPU8[i2 >> 0] | 0;
   if (__ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i2 & 255, i14, i3, i12, i13, HEAP8[i11 >> 0] | 0, i22, i15, i16, i10) | 0) {
    i24 = 38;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i25 = __THREW__;
    __THREW__ = 0;
    if (i25 & 1) {
     i24 = 28;
     break;
    } else continue;
   } else {
    HEAP32[i5 >> 2] = i2 + 1;
    continue;
   }
  }
  if ((i24 | 0) == 28) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i24 | 0) == 38) {
   i25 = HEAP8[i22 + 11 >> 0] | 0;
   if ((i25 << 24 >> 24 < 0 ? HEAP32[i22 + 4 >> 2] | 0 : i25 & 255) | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    if ((i2 - i15 | 0) < 160) {
     i25 = HEAP32[i13 >> 2] | 0;
     HEAP32[i16 >> 2] = i2 + 4;
     HEAP32[i2 >> 2] = i25;
    }
   }
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 206 | 0, i3 | 0, HEAP32[i12 >> 2] | 0, i21 | 0, i14 | 0) | 0;
   i25 = __THREW__;
   __THREW__ = 0;
   L54 : do if (!(i25 & 1)) {
    HEAP32[i17 >> 2] = i2;
    __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i22, i15, HEAP32[i16 >> 2] | 0, i21);
    if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i25 = __THREW__;
     __THREW__ = 0;
     if (i25 & 1) break;
     if ((i2 | 0) == -1) {
      HEAP32[i19 >> 2] = 0;
      i1 = 0;
     }
    }
    i2 = (i1 | 0) == 0;
    do if (!i4) i24 = 53; else {
     if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
      i25 = __THREW__;
      __THREW__ = 0;
      if (i25 & 1) break L54;
      if ((i1 | 0) == -1) {
       HEAP32[i20 >> 2] = 0;
       i24 = 53;
       break;
      }
     }
     if (!i2) i24 = 54;
    } while (0);
    if ((i24 | 0) == 53) if (i2) i24 = 54;
    if ((i24 | 0) == 54) HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 2;
    i25 = HEAP32[i19 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    STACKTOP = i18;
    return i25 | 0;
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN22NavMeshProjectSettings8TransferI14SafeBinaryReadEEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 32 | 0;
 i14 = i16 + 16 | 0;
 i12 = i16;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i11, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 HEAP32[i14 >> 2] = 0;
 i15 = i14 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i6 = i14 + 8 | 0;
 i7 = i13 + 4 | 0;
 i1 = 0;
 i5 = 0;
 i3 = 0;
 while (1) {
  i2 = i11 + 28 + (i1 * 20 | 0) | 0;
  if ((i5 | 0) == (i3 | 0)) __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i2); else {
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   i9 = i4 << 24 >> 24 < 0;
   i3 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = i9 ? HEAP32[i11 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i10 = 13;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i5 + 11 >> 0] = i4;
    if (!i4) i2 = i5; else {
     i2 = i5;
     i10 = 15;
    }
   } else i10 = 13;
   if ((i10 | 0) == 13) {
    i9 = i4 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i7 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i9 | -2147483648;
    HEAP32[i5 + 4 >> 2] = i4;
    i10 = 15;
   }
   if ((i10 | 0) == 15) {
    i10 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 28 + (i1 * 20 | 0) + 16 >> 2];
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 20;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i5 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 844235 | 0, HEAP32[gb + 37316 >> 2] | 0, i13, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i8, i14, 0); else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if (HEAP8[i8 + 128 >> 0] | 0) {
  i8 = 0;
  do {
   i5 = i11 + 28 + (i8 * 20 | 0) | 0;
   i9 = HEAP32[i14 >> 2] | 0;
   i1 = i9 + (i8 * 20 | 0) | 0;
   do if ((i5 | 0) != (i1 | 0)) {
    i7 = HEAP8[i1 + 11 >> 0] | 0;
    i3 = i7 << 24 >> 24 < 0;
    i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
    i7 = i3 ? HEAP32[i9 + (i8 * 20 | 0) + 4 >> 2] | 0 : i7 & 255;
    i3 = i5 + 11 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i4 = (HEAP32[i11 + 28 + (i8 * 20 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
    if (i7 >>> 0 > i4 >>> 0) {
     if (i2) i1 = HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
     break;
    }
    if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i3 >> 0] | 0) < 0) {
     HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i3 >> 0] = i7;
     break;
    }
   } while (0);
   HEAP32[i11 + 28 + (i8 * 20 | 0) + 16 >> 2] = HEAP32[i9 + (i8 * 20 | 0) + 16 >> 2];
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != 32);
 }
 i1 = i11 + 28 | 0;
 i6 = i1 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i11 + 32 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = i2 & 255;
  i4 = i1;
 }
 i5 = i3 >>> 0 > 7;
 i2 = i5 ? 7 : i3;
 if (!i2) i10 = 42; else if (!(_memcmp(i4, gb + 1012705 | 0, i2) | 0)) i10 = 42;
 if ((i10 | 0) == 42) if (i3 >>> 0 > 6 & (i5 ^ 1)) {
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i12 + 11 | 0;
  HEAP8[i4 >> 0] = 8;
  i10 = i12;
  HEAP32[i10 >> 2] = 1802264919;
  HEAP32[i10 + 4 >> 2] = 1701601889;
  HEAP8[i12 + 8 >> 0] = 0;
  L62 : do if ((i1 | 0) != (i12 | 0)) {
   do if ((HEAP8[i6 >> 0] | 0) < 0) {
    i2 = HEAP32[i11 + 36 >> 2] & 2147483647;
    i3 = i2 + -1 | 0;
    if (i3 >>> 0 < 8) {
     i11 = HEAP32[i11 + 32 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i11, 0, i11, 8, i12);
     break L62;
    } else {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } while (0);
   i9 = i12;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i10 = i1;
   i8 = i10;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = i9;
   HEAP8[i10 + 1 >> 0] = i9 >> 8;
   HEAP8[i10 + 2 >> 0] = i9 >> 16;
   HEAP8[i10 + 3 >> 0] = i9 >> 24;
   HEAP8[i1 + 8 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i11 + 32 >> 2] = 8;
    break;
   } else {
    HEAP8[i6 >> 0] = 8;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i13);
  }
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i13 + 4 | 0;
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i15 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
    i2 = HEAP32[i15 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i16;
 return;
}

function _decode_mcu_AC_refine(i13, i5) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27 + 256 | 0;
 i24 = i27;
 i26 = HEAP32[i13 + 408 >> 2] | 0;
 i18 = HEAP32[i13 + 368 >> 2] | 0;
 i17 = HEAP32[i13 + 376 >> 2] | 0;
 i16 = 1 << i17;
 i17 = -1 << i17;
 i2 = i13 + 252 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i26 + 40 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i22 = i26 + 16 | 0;
   i23 = HEAP32[i13 + 404 >> 2] | 0;
   i21 = i23 + 20 | 0;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + ((HEAP32[i22 >> 2] | 0) / 8 | 0);
   HEAP32[i22 >> 2] = 0;
   if (!((mftCall_ii(HEAP32[i23 + 8 >> 2] | 0, i13 | 0) | 0) << 24 >> 24)) {
    i26 = 0;
    STACKTOP = i27;
    return i26 | 0;
   }
   i4 = i13 + 292 | 0;
   if ((HEAP32[i4 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i26 + 24 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
   }
   HEAP32[i26 + 20 >> 2] = 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   if (!(HEAP32[i13 + 380 >> 2] | 0)) HEAP8[i26 + 8 >> 0] = 0;
  }
 }
 do if (!(HEAP8[i26 + 8 >> 0] | 0)) {
  HEAP32[i25 + 16 >> 2] = i13;
  i19 = i13 + 24 | 0;
  i21 = HEAP32[i19 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[i21 >> 2];
  i20 = i25 + 4 | 0;
  HEAP32[i20 >> 2] = HEAP32[i21 + 4 >> 2];
  i21 = i26 + 12 | 0;
  i4 = HEAP32[i21 >> 2] | 0;
  i22 = i26 + 16 | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i23 = i26 + 20 | 0;
  i3 = HEAP32[i23 >> 2] | 0;
  i14 = HEAP32[i5 >> 2] | 0;
  i10 = HEAP32[i26 + 60 >> 2] | 0;
  i5 = HEAP32[i13 + 364 >> 2] | 0;
  L15 : do if (!i3) if ((i5 | 0) > (i18 | 0)) {
   i3 = 0;
   i1 = i4;
   i15 = 60;
  } else {
   i12 = i25 + 8 | 0;
   i11 = i25 + 12 | 0;
   i1 = 0;
   L18 : while (1) {
    if ((i2 | 0) < 8) {
     if (!((_jpeg_fill_bit_buffer(i25, i4, i2, 0) | 0) << 24 >> 24)) break L15;
     i4 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((i2 | 0) < 8) {
      i6 = 1;
      i15 = 18;
     } else i15 = 16;
    } else i15 = 16;
    if ((i15 | 0) == 16) {
     i15 = 0;
     i3 = HEAP32[i10 + 148 + ((i4 >> i2 + -8 & 255) << 2) >> 2] | 0;
     i6 = i3 >> 8;
     if ((i6 | 0) < 9) {
      i3 = i3 & 255;
      i2 = i2 - i6 | 0;
     } else i15 = 18;
    }
    if ((i15 | 0) == 18) {
     i15 = 0;
     i2 = _jpeg_huff_decode(i25, i4, i2, i10, i6) | 0;
     if ((i2 | 0) < 0) break L15;
     i3 = i2;
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i12 >> 2] | 0;
    }
    i6 = i3 >> 4;
    switch (i3 & 15) {
    case 0:
     {
      if ((i6 | 0) == 15) {
       i3 = 15;
       i9 = 0;
      } else break L18;
      break;
     }
    case 1:
     {
      i15 = 22;
      break;
     }
    default:
     {
      i15 = HEAP32[i13 >> 2] | 0;
      HEAP32[i15 + 20 >> 2] = 118;
      mftCall_vii(HEAP32[i15 + 4 >> 2] | 0, i13 | 0, -1);
      i15 = 22;
     }
    }
    if ((i15 | 0) == 22) {
     i15 = 0;
     if ((i2 | 0) < 1) {
      if (!((_jpeg_fill_bit_buffer(i25, i4, i2, 1) | 0) << 24 >> 24)) break L15;
      i2 = HEAP32[i11 >> 2] | 0;
      i4 = HEAP32[i12 >> 2] | 0;
     }
     i2 = i2 + -1 | 0;
     i3 = i6;
     i9 = (1 << i2 & i4 | 0) == 0 ? i17 : i16;
    }
    L40 : while (1) {
     i8 = i14 + (HEAP32[gb + 15416 + (i5 << 2) >> 2] << 1) | 0;
     do if (!(HEAP16[i8 >> 1] | 0)) if ((i3 | 0) < 1) break L40; else i3 = i3 + -1 | 0; else {
      if ((i2 | 0) < 1) {
       if (!((_jpeg_fill_bit_buffer(i25, i4, i2, 1) | 0) << 24 >> 24)) break L15;
       i2 = HEAP32[i11 >> 2] | 0;
       i4 = HEAP32[i12 >> 2] | 0;
      }
      i2 = i2 + -1 | 0;
      if (1 << i2 & i4) {
       i6 = HEAP16[i8 >> 1] | 0;
       i7 = i6 << 16 >> 16;
       if (!(i7 & i16)) if (i6 << 16 >> 16 > -1) {
        HEAP16[i8 >> 1] = i7 + i16;
        break;
       } else {
        HEAP16[i8 >> 1] = i7 + i17;
        break;
       }
      }
     } while (0);
     i6 = i5 + 1 | 0;
     if ((i5 | 0) < (i18 | 0)) i5 = i6; else {
      i5 = i6;
      break;
     }
    }
    if (i9) {
     i8 = HEAP32[gb + 15416 + (i5 << 2) >> 2] | 0;
     HEAP16[i14 + (i8 << 1) >> 1] = i9;
     HEAP32[i24 + (i1 << 2) >> 2] = i8;
     i1 = i1 + 1 | 0;
    }
    if ((i5 | 0) < (i18 | 0)) i5 = i5 + 1 | 0; else {
     i3 = 0;
     i1 = i4;
     i15 = 60;
     break L15;
    }
   }
   i3 = 1 << i6;
   if (!i6) i15 = 47; else {
    if ((i2 | 0) < (i6 | 0)) {
     if (!((_jpeg_fill_bit_buffer(i25, i4, i2, i6) | 0) << 24 >> 24)) break;
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i12 >> 2] | 0;
    }
    i2 = i2 - i6 | 0;
    i3 = (i4 >> i2 & i3 + -1) + i3 | 0;
    if (!i3) {
     i3 = 0;
     i1 = i4;
     i15 = 60;
    } else i15 = 47;
   }
  } else {
   i1 = 0;
   i15 = 47;
  } while (0);
  L65 : do if ((i15 | 0) == 47) {
   if ((i5 | 0) > (i18 | 0)) i1 = i4; else {
    i9 = i25 + 8 | 0;
    i10 = i25 + 12 | 0;
    while (1) {
     i8 = i14 + (HEAP32[gb + 15416 + (i5 << 2) >> 2] << 1) | 0;
     do if (HEAP16[i8 >> 1] | 0) {
      if ((i2 | 0) < 1) {
       if (!((_jpeg_fill_bit_buffer(i25, i4, i2, 1) | 0) << 24 >> 24)) break L65;
       i2 = HEAP32[i10 >> 2] | 0;
       i4 = HEAP32[i9 >> 2] | 0;
      }
      i2 = i2 + -1 | 0;
      if (1 << i2 & i4) {
       i6 = HEAP16[i8 >> 1] | 0;
       i7 = i6 << 16 >> 16;
       if (!(i7 & i16)) if (i6 << 16 >> 16 > -1) {
        HEAP16[i8 >> 1] = i7 + i16;
        break;
       } else {
        HEAP16[i8 >> 1] = i7 + i17;
        break;
       }
      }
     } while (0);
     if ((i5 | 0) < (i18 | 0)) i5 = i5 + 1 | 0; else {
      i1 = i4;
      break;
     }
    }
   }
   i3 = i3 + -1 | 0;
   i15 = 60;
  } while (0);
  if ((i15 | 0) == 60) {
   i24 = HEAP32[i19 >> 2] | 0;
   HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i21 >> 2] = i1;
   HEAP32[i22 >> 2] = i2;
   HEAP32[i23 >> 2] = i3;
   break;
  }
  if ((i1 | 0) <= 0) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  do {
   i26 = i1;
   i1 = i1 + -1 | 0;
   HEAP16[i14 + (HEAP32[i24 + (i1 << 2) >> 2] << 1) >> 1] = 0;
  } while ((i26 | 0) > 1);
  i1 = 0;
  STACKTOP = i27;
  return i1 | 0;
 } while (0);
 i26 = i26 + 40 | 0;
 HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + -1;
 i26 = 1;
 STACKTOP = i27;
 return i26 | 0;
}

function __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i3, i1, i2, i5, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i7 = i1 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = (i6 | 0) == 0 ? 0 : i6 + i7 | 0;
 i6 = i2 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = (i4 | 0) == 0 ? 0 : i4 + i6 | 0;
 i4 = i3 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i1 = i5;
 while (1) {
  i2 = HEAP32[i4 + (i1 << 3) >> 2] | 0;
  i3 = i6 + (i1 * 40 | 0) | 0;
  if ((i2 | 0) == -1) break;
  f24 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 24 >> 2]);
  f28 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) >> 2]);
  f22 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 4 >> 2]);
  f12 = Math_fround(f28 - f12);
  f10 = Math_fround(f22 - f10);
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 8 >> 2]));
  f22 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i7 + (i2 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i7 + (i2 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i7 + (i2 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = Math_fround(f22 * Math_fround(-2.0));
  f20 = Math_fround(f22 * Math_fround(2.0));
  f23 = Math_fround(f24 * f17);
  f21 = Math_fround(f26 * Math_fround(2.0));
  f13 = Math_fround(f26 * Math_fround(-2.0));
  f27 = Math_fround(f24 * f13);
  f19 = Math_fround(f28 * Math_fround(-2.0));
  f11 = Math_fround(f28 * Math_fround(2.0));
  f25 = Math_fround(f24 * f19);
  f18 = Math_fround(Math_fround(f12 + Math_fround(Math_fround(Math_fround(f22 * f17) - Math_fround(f26 * f21)) * f12)) + Math_fround(Math_fround(Math_fround(f27 - Math_fround(f22 * f19)) * f10) + Math_fround(Math_fround(Math_fround(f11 * f26) - f23) * f16)));
  f17 = Math_fround(Math_fround(f10 + Math_fround(Math_fround(Math_fround(f28 * f20) - f27) * f12)) + Math_fround(Math_fround(Math_fround(Math_fround(f26 * f13) - Math_fround(f28 * f11)) * f10) + Math_fround(Math_fround(f25 - Math_fround(f26 * f17)) * f16)));
  f16 = Math_fround(Math_fround(Math_fround(Math_fround(f23 - Math_fround(f28 * f13)) * f12) + f16) + Math_fround(Math_fround(Math_fround(Math_fround(f22 * f21) - f25) * f10) + Math_fround(Math_fround(Math_fround(f28 * f19) - Math_fround(f22 * f20)) * f16)));
  f20 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 28 >> 2]);
  f19 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 36 >> 2]);
  i14 = Math_fround(Math_abs(Math_fround(f20))) < Math_fround(9.99999971e-10);
  i15 = Math_fround(Math_abs(Math_fround(f19))) < Math_fround(9.99999971e-10);
  i5 = Math_fround(Math_abs(Math_fround(f10))) < Math_fround(9.99999971e-10);
  f20 = Math_fround(Math_fround(1.0) / f20);
  f20 = i14 ? Math_fround(1.0) : f20;
  f19 = Math_fround(Math_fround(1.0) / f19);
  f19 = i15 ? Math_fround(1.0) : f19;
  f10 = Math_fround(Math_fround(1.0) / f10);
  f10 = i5 ? Math_fround(1.0) : f10;
  f18 = Math_fround(f18 * f20);
  f17 = Math_fround(f17 * f19);
  f16 = Math_fround(f16 * f10);
  f25 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 12 >> 2]);
  f21 = Math_fround(f22 * f25);
  f12 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 24 >> 2]);
  f13 = Math_fround(f24 * f12);
  f23 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 16 >> 2]);
  f11 = Math_fround(f26 * f23);
  f27 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 20 >> 2]);
  f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f24 * f27)) - Math_fround(f26 * f12)) - Math_fround(f28 * f23));
  f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f28 * f25)) - Math_fround(f26 * f27)) - Math_fround(f22 * f23));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f22 * f27)) - Math_fround(f24 * f25)) - Math_fround(f28 * f12));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f23)) - Math_fround(f22 * f12));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f12 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 28 >> 2]);
  f11 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 32 >> 2]);
  f12 = Math_fround(f20 * f12);
  f11 = Math_fround(f19 * f11);
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 36 >> 2]));
  HEAPF32[i3 >> 2] = f18;
  HEAPF32[i6 + (i1 * 40 | 0) + 4 >> 2] = f17;
  HEAPF32[i6 + (i1 * 40 | 0) + 8 >> 2] = f16;
  HEAP32[i6 + (i1 * 40 | 0) + 12 >> 2] = i15 ^ -2147483648;
  HEAP32[i6 + (i1 * 40 | 0) + 16 >> 2] = i14;
  HEAP32[i6 + (i1 * 40 | 0) + 20 >> 2] = i5 ^ -2147483648;
  HEAPF32[i6 + (i1 * 40 | 0) + 24 >> 2] = f13;
  HEAPF32[i6 + (i1 * 40 | 0) + 28 >> 2] = f12;
  HEAPF32[i6 + (i1 * 40 | 0) + 32 >> 2] = f11;
  HEAPF32[i6 + (i1 * 40 | 0) + 36 >> 2] = f10;
  if ((i1 | 0) == (i8 | 0)) {
   i9 = 5;
   break;
  } else i1 = i2;
 }
 if ((i9 | 0) == 5) return;
 i15 = HEAP32[i7 + (i1 * 40 | 0) + 4 >> 2] | 0;
 i9 = HEAP32[i7 + (i1 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 + (i1 * 40 | 0) >> 2];
 HEAP32[i6 + (i1 * 40 | 0) + 4 >> 2] = i15;
 HEAP32[i6 + (i1 * 40 | 0) + 8 >> 2] = i9;
 i9 = HEAP32[i7 + (i1 * 40 | 0) + 16 >> 2] | 0;
 i15 = HEAP32[i7 + (i1 * 40 | 0) + 20 >> 2] | 0;
 i14 = HEAP32[i7 + (i1 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i6 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i7 + (i1 * 40 | 0) + 12 >> 2];
 HEAP32[i6 + (i1 * 40 | 0) + 16 >> 2] = i9;
 HEAP32[i6 + (i1 * 40 | 0) + 20 >> 2] = i15;
 HEAP32[i6 + (i1 * 40 | 0) + 24 >> 2] = i14;
 i14 = HEAP32[i7 + (i1 * 40 | 0) + 32 >> 2] | 0;
 i15 = HEAP32[i7 + (i1 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i6 + (i1 * 40 | 0) + 28 >> 2] = HEAP32[i7 + (i1 * 40 | 0) + 28 >> 2];
 HEAP32[i6 + (i1 * 40 | 0) + 32 >> 2] = i14;
 HEAP32[i6 + (i1 * 40 | 0) + 36 >> 2] = i15;
 return;
}

function __ZN26AnimatorControllerPlayable11UpdateGraphEf(i50, f11) {
 i50 = i50 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, i52 = 0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i52;
 i17 = i50 + 74 | 0;
 HEAP8[i17 >> 0] = 0;
 i25 = i50 + 73 | 0;
 HEAP8[i25 >> 0] = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i50 >> 2] | 0) + 180 >> 2] | 0, i50 | 0) | 0)) {
  STACKTOP = i52;
  return;
 }
 i47 = i50 + 84 | 0;
 i51 = HEAP32[i47 >> 2] | 0;
 i51 = mftCall_iii(HEAP32[(HEAP32[i51 >> 2] | 0) + 92 >> 2] | 0, i51 | 0, 1) | 0;
 if (!i51) {
  STACKTOP = i52;
  return;
 }
 i12 = HEAP32[i50 + 96 >> 2] | 0;
 i13 = HEAP32[i50 + 104 >> 2] | 0;
 i49 = HEAP32[i50 + 100 >> 2] | 0;
 i48 = i13 + 8 | 0;
 i15 = i49 + 16 | 0;
 i16 = i15;
 _memset(HEAP32[i48 >> 2] | 0, 0, HEAP32[(HEAP32[i15 >> 2] | 0) + i16 + 40 >> 2] | 0) | 0;
 i18 = i51 + 8 | 0;
 L7 : do if (HEAP32[i18 >> 2] | 0) {
  i19 = i50 + 60 | 0;
  i20 = i14 + 4 | 0;
  i21 = i14 + 8 | 0;
  i22 = i14 + 12 | 0;
  i23 = i14 + 16 | 0;
  i24 = i14 + 28 | 0;
  i26 = i14 + 32 | 0;
  i27 = i14 + 36 | 0;
  i28 = i14 + 40 | 0;
  i29 = i13 + 16 | 0;
  i30 = i14 + 20 | 0;
  i31 = i49 + 20 | 0;
  i32 = i50 + 132 | 0;
  i33 = i51 + 16 | 0;
  i34 = i33;
  i35 = i50 + 144 | 0;
  i36 = i13 + 4 | 0;
  i37 = i51 + 12 | 0;
  i38 = i37;
  i39 = i49 + 4 | 0;
  i40 = i39;
  i41 = i51 + 4 | 0;
  i42 = i41;
  i43 = i12 + 12 | 0;
  i44 = i14 + 24 | 0;
  i45 = i49 + 12 | 0;
  i46 = i45;
  i9 = 0;
  while (1) {
   HEAP32[i20 >> 2] = 0;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i28 >> 2] = i19;
   HEAP32[i22 >> 2] = HEAP32[i12 >> 2];
   i7 = HEAP32[i29 >> 2] | 0;
   HEAP32[i30 >> 2] = i7;
   i6 = HEAP32[i51 >> 2] | 0;
   if (!i6) i1 = 0; else {
    i8 = (HEAP32[i41 >> 2] | 0) + i42 | 0;
    i1 = 0;
    i5 = 0;
    do {
     i2 = i8 + (i5 << 2) | 0;
     i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     L15 : do if ((i9 | 0) == (HEAP32[i2 >> 2] | 0)) {
      i3 = (i4 | 0) == 0;
      do if (i3) {
       HEAP32[i44 >> 2] = (HEAP32[i43 >> 2] | 0) + (i5 * 24 | 0);
       i1 = i5;
       f10 = Math_fround(1.0);
      } else if (i3 | (HEAP8[i2 + 37 >> 0] | 0) != 0) {
       f10 = Math_fround(HEAPF32[(HEAP32[i45 >> 2] | 0) + i46 + (i5 << 2) >> 2]);
       break;
      } else {
       HEAPF32[i7 + (i4 << 2) >> 2] = Math_fround(0.0);
       break L15;
      } while (0);
      HEAPF32[i7 + (i4 << 2) >> 2] = f10;
     } while (0);
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < i6 >>> 0);
   }
   HEAPF32[i14 >> 2] = f11;
   HEAP32[i24 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i26 >> 2] = i32;
   i7 = HEAP32[i47 >> 2] | 0;
   HEAP32[i20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0) | 0;
   i7 = HEAP32[i47 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 96 >> 2] | 0, i7 | 0) | 0) + 36 >> 2];
   HEAP32[i27 >> 2] = i1;
   i7 = HEAP32[i15 >> 2] | 0;
   HEAP32[i23 >> 2] = (i7 | 0) == 0 ? 0 : i7 + i16 | 0;
   i7 = HEAP32[i33 >> 2] | 0;
   i1 = (HEAP32[i13 >> 2] | 0) + (i9 << 2) | 0;
   HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = (i7 | 0) == 0 ? 0 : i7 + i34 | 0;
   HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] = i48;
   i7 = (HEAP32[i36 >> 2] | 0) + (i9 << 2) | 0;
   HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] = (HEAP32[i35 >> 2] | 0) + (i9 << 3);
   i5 = (HEAP32[i37 >> 2] | 0) + i38 + (i9 << 2) | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i8 = (HEAP32[i39 >> 2] | 0) + i40 + (i9 << 2) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   __ZN7mecanim12statemachine20EvaluateStateMachineERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_21StateMachineWorkspaceE((i6 | 0) == 0 ? 0 : i5 + i6 | 0, i14, HEAP32[i7 >> 2] | 0, (i2 | 0) == 0 ? 0 : i8 + i2 | 0, HEAP32[i1 >> 2] | 0);
   i1 = (HEAP32[i39 >> 2] | 0) + i40 + (i9 << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i2 = HEAP32[(HEAP32[i36 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   if (!(HEAP8[i1 + 80 >> 0] | 0)) i3 = (HEAP8[i2 + 16 >> 0] | 0) != 0; else i3 = 1;
   HEAP8[i25 >> 0] = HEAPU8[i25 >> 0] | i3 & 1;
   HEAP8[i17 >> 0] = HEAP8[i17 >> 0] | HEAP8[i2 + 18 >> 0];
   HEAP8[i1 + 86 >> 0] = 0;
   i9 = i9 + 1 | 0;
   if (__ZN7mecanim12statemachine10IsDisabledEPKNS0_17StateMachineInputE(i14) | 0) break;
   if (i9 >>> 0 >= (HEAP32[i18 >> 2] | 0) >>> 0) break L7;
  }
  STACKTOP = i52;
  return;
 } while (0);
 i1 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 if (i5 | 0) {
  i4 = HEAP32[i48 >> 2] | 0;
  i2 = i1 + 44 | 0;
  i3 = i2;
  i1 = 0;
  do {
   if (HEAP8[i4 + i1 >> 0] | 0) HEAP8[(HEAP32[i2 >> 2] | 0) + i3 + i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 }
 if (!(HEAP32[i51 >> 2] | 0)) {
  STACKTOP = i52;
  return;
 }
 i6 = i51 + 4 | 0;
 i7 = i6;
 i8 = i49 + 4 | 0;
 i9 = i8;
 i4 = i49 + 12 | 0;
 i5 = i4;
 i2 = i50 + 8 | 0;
 i1 = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do {
  i50 = i3 + i7 + (i1 << 2) | 0;
  i50 = i50 + (HEAP32[i50 >> 2] | 0) | 0;
  i48 = (HEAP32[i8 >> 2] | 0) + i9 + (HEAP32[i50 >> 2] << 2) | 0;
  i48 = i48 + (HEAP32[i48 >> 2] | 0) + 4 | 0;
  f10 = Math_fround(HEAPF32[i48 + (HEAP32[i48 >> 2] | 0) + (HEAP32[i50 + 4 >> 2] << 2) >> 2]);
  f11 = Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + i5 + (i1 << 2) >> 2]);
  i50 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
  i50 = mftCall_iii(HEAP32[(HEAP32[i50 >> 2] | 0) + 136 >> 2] | 0, i50 | 0, i1 | 0) | 0;
  f11 = Math_fround(f10 * f11);
  __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0, i1, (i1 | 0) == 0 ? Math_fround(1.0) : f11);
  i3 = HEAP32[i6 >> 2] | 0;
  i48 = i3 + i7 + (i1 << 2) | 0;
  i49 = HEAP32[i48 >> 2] | 0;
  HEAP8[i50 + 1 >> 0] = (HEAP32[((i49 | 0) == 0 ? 0 : i48 + i49 | 0) + 28 >> 2] | 0) == 1 & 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i51 >> 2] | 0) >>> 0);
 STACKTOP = i52;
 return;
}

function __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi(i28, i29, i31, i32, i1, i2, i33, i24) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i33 = i33 | 0;
 i24 = i24 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i36 + 44 | 0;
 i26 = i36 + 40 | 0;
 i25 = i36 + 36 | 0;
 i34 = i36 + 32 | 0;
 i35 = i36 + 28 | 0;
 i30 = i36 + 24 | 0;
 i18 = i36 + 20 | 0;
 i19 = i36 + 16 | 0;
 i20 = i36 + 12 | 0;
 i21 = i36 + 8 | 0;
 i22 = i36 + 4 | 0;
 i23 = i36;
 if (!i2) {
  STACKTOP = i36;
  return;
 }
 i3 = i1;
 L4 : while (1) {
  if (!((i2 | 0) > (i24 | 0) & (i3 | 0) > (i24 | 0))) {
   i1 = 6;
   break;
  }
  if (!i3) {
   i1 = 34;
   break;
  }
  i16 = HEAP32[i29 >> 2] | 0;
  i6 = HEAP32[i16 >> 2] | 0;
  i17 = i16;
  i13 = i6;
  i4 = HEAP32[i28 >> 2] | 0;
  while (1) {
   i5 = HEAP32[i4 >> 2] | 0;
   if (i6 >>> 0 < i5 >>> 0) break;
   i1 = i4 + 8 | 0;
   HEAP32[i28 >> 2] = i1;
   i3 = i3 + -1 | 0;
   if (!i3) {
    i1 = 34;
    break L4;
   } else i4 = i1;
  }
  i11 = i4;
  if ((i3 | 0) < (i2 | 0)) {
   i12 = (i2 | 0) / 2 | 0;
   i5 = i16 + (i12 << 3) | 0;
   i1 = i5;
   i6 = i17 - i11 >> 3;
   if (i6) {
    i10 = HEAP32[i5 >> 2] | 0;
    i5 = i4;
    i7 = i4;
    while (1) {
     i15 = (i6 | 0) / 2 | 0;
     i9 = i7 + (i15 << 3) | 0;
     i8 = i10 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0;
     i9 = i9 + 8 | 0;
     i4 = i8 ? i5 : i9;
     i6 = i8 ? i15 : i6 + -1 - i15 | 0;
     if (!i6) break; else {
      i5 = i4;
      i7 = i8 ? i7 : i9;
     }
    }
   }
   i14 = i4;
   i15 = i14 - i11 >> 3;
  } else {
   if ((i3 | 0) == 1) {
    i1 = 15;
    break;
   }
   i9 = (i3 | 0) / 2 | 0;
   i1 = i4 + (i9 << 3) | 0;
   i10 = i1;
   i4 = (HEAP32[i31 >> 2] | 0) - i17 >> 3;
   if (!i4) i1 = i16; else {
    i8 = HEAP32[i1 >> 2] | 0;
    i1 = i16;
    i5 = i16;
    while (1) {
     i15 = (i4 | 0) / 2 | 0;
     i7 = i5 + (i15 << 3) | 0;
     i6 = (HEAP32[i7 >> 2] | 0) >>> 0 < i8 >>> 0;
     i7 = i7 + 8 | 0;
     i1 = i6 ? i7 : i1;
     i4 = i6 ? i4 + -1 - i15 | 0 : i15;
     if (!i4) break; else i5 = i6 ? i7 : i5;
    }
   }
   i15 = i9;
   i12 = i1 - i17 >> 3;
   i14 = i10;
  }
  i3 = i3 - i15 | 0;
  i2 = i2 - i12 | 0;
  i4 = i14;
  i11 = i1;
  L27 : do if ((i4 | 0) == (i16 | 0)) i4 = i11; else if ((i16 | 0) != (i11 | 0)) {
   i8 = i14;
   i7 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i13;
   HEAP32[i16 >> 2] = i7;
   i7 = i4 + 4 | 0;
   i8 = i16 + 4 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i5;
   i4 = i4 + 8 | 0;
   i8 = i4;
   i5 = i16 + 8 | 0;
   i7 = (i4 | 0) == (i16 | 0);
   if ((i5 | 0) == (i11 | 0)) {
    i5 = i16;
    i6 = i17;
   } else {
    i9 = i5;
    i6 = i17;
    i5 = i7;
    while (1) {
     i6 = i5 ? i9 : i6;
     i7 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i9 >> 2] = i7;
     i7 = i4 + 4 | 0;
     i4 = i9 + 4 | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i5;
     i4 = i8 + 8 | 0;
     i8 = i4;
     i9 = i9 + 8 | 0;
     i5 = i6;
     i7 = (i4 | 0) == (i5 | 0);
     if ((i9 | 0) == (i11 | 0)) break; else i5 = i7;
    }
   }
   if (!i7) {
    i7 = i4;
    while (1) {
     i10 = i6;
     while (1) {
      i9 = i5;
      i17 = HEAP32[i7 >> 2] | 0;
      i16 = i5;
      HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i16 >> 2] = i17;
      i16 = i7 + 4 | 0;
      i5 = i9 + 4 | 0;
      i17 = HEAP32[i16 >> 2] | 0;
      HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i5 >> 2] = i17;
      i7 = i8 + 8 | 0;
      i8 = i7;
      i5 = i9 + 8 | 0;
      i9 = (i7 | 0) == (i10 | 0);
      if ((i5 | 0) != (i11 | 0)) break;
      if (i9) break L27; else i5 = i6;
     }
     i17 = i5;
     i5 = i17;
     i6 = i9 ? i17 : i6;
    }
   }
  } while (0);
  HEAP32[i29 >> 2] = i4;
  if ((i15 + i12 | 0) < (i3 + i2 | 0)) {
   HEAP32[i18 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i19 >> 2] = i14;
   HEAP32[i20 >> 2] = i4;
   HEAP32[i25 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i20 >> 2];
   __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi(i25, i26, i27, i32, i15, i12, i33, i24);
   HEAP32[i28 >> 2] = i4;
  } else {
   HEAP32[i21 >> 2] = i4;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i23 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i25 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
   __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi(i25, i26, i27, i32, i3, i2, i33, i24);
   HEAP32[i31 >> 2] = i4;
   i2 = i12;
   i3 = i15;
   i1 = i14;
  }
  HEAP32[i29 >> 2] = i1;
  if (!i2) {
   i1 = 34;
   break;
  }
 }
 if ((i1 | 0) == 6) {
  HEAP32[i34 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i35 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i25 >> 2] = HEAP32[i34 >> 2];
  HEAP32[i26 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
  __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeE(i25, i26, i27, i32, i3, i2, i33);
  STACKTOP = i36;
  return;
 } else if ((i1 | 0) == 15) {
  HEAP32[i4 >> 2] = i13;
  HEAP32[i16 >> 2] = i5;
  i33 = i4 + 4 | 0;
  i35 = i16 + 4 | 0;
  i34 = HEAP32[i33 >> 2] | 0;
  HEAP32[i33 >> 2] = HEAP32[i35 >> 2];
  HEAP32[i35 >> 2] = i34;
  STACKTOP = i36;
  return;
 } else if ((i1 | 0) == 34) {
  STACKTOP = i36;
  return;
 }
}

function __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 328 >> 0] = i1;
 i3 = i6 + 268 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16777023 | (i1 & 255) << 6 & 192;
 HEAP16[i3 >> 1] = i1;
 HEAP8[i3 + 2 >> 0] = i1 >>> 16;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16776959 | (i1 & 255) << 8 & 256;
 HEAP16[i3 >> 1] = i1;
 HEAP8[i3 + 2 >> 0] = i1 >>> 16;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16774143 | (i1 & 255) << 10 & 3072;
 HEAP16[i3 >> 1] = i1;
 HEAP8[i3 + 2 >> 0] = i1 >>> 16;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16580607 | (i1 & 255) << 16 & 196608;
 HEAP16[i3 >> 1] = i1;
 HEAP8[i3 + 2 >> 0] = i1 >>> 16;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16728063 | (i1 & 255) << 14 & 49152;
 HEAP16[i3 >> 1] = i4;
 HEAP8[i3 + 2 >> 0] = i4 >>> 16;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i4 = i6 + 260 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i4 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
 } else {
  i3 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i3;
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
 }
 HEAP16[i4 + 2 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 228 | 0, i7);
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 244 | 0, i7);
 i3 = i6 + 288 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i11 = i7 + 8 | 0;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i4 = i6 + 292 | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
 }
 HEAP32[i8 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i3, i1, i8, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i6 + 300 >> 2] | 0;
 i2 = i1 + (i11 << 2) | 0;
 if (i11 | 0) do {
  __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 216 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
 } else {
  i11 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i11;
  HEAP32[i9 >> 2] = i1;
  i1 = i11;
 }
 HEAP16[i6 + 218 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 308 | 0, i7);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 280 | 0, i7);
 __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 276 | 0, i7);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 332 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 336 | 0;
 i2 = i4 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i11 = HEAP16[i8 >> 1] | 0;
  i11 = _llvm_bswap_i16(i11 | 0) | 0;
  HEAP16[i1 >> 1] = i11;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i11 = HEAP16[i4 >> 1] | 0;
  HEAP16[i8 >> 1] = i11;
  HEAP32[i9 >> 2] = i2;
  i11 = _llvm_bswap_i16(i11 | 0) | 0;
  HEAP16[i1 >> 1] = i11;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN7mecanim12statemachine13StateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i7 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i9 = i8 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) {
  i5 = i8 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
    HEAP8[i2 + 36 >> 0] = 0;
    HEAP8[i2 + 37 >> 0] = 0;
    HEAP32[i2 + 40 >> 2] = 0;
    HEAP8[i2 + 44 >> 0] = 1;
    HEAP8[i2 + 45 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine18TransitionConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i8);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i7 + 12 | 0;
 i5 = i7 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i7 + 20 | 0;
 i5 = i7 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i7 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 61 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 62 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 63 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN2UI15SortForBatchingEPKNS_23RenderableUIInstructionEjPS0_i(i15, i16, i19, i12) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i21 + 8 | 0;
 i1 = i21;
 i20 = i21 + 28 | 0;
 if ((HEAP16[gb + 1467988 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467988 | 0, i11);
  i14 = gb + 1467988 | 0;
 } else i14 = 0;
 i8 = gb + 64016 | 0;
 i18 = HEAP32[i8 + 4 >> 2] | 0;
 i17 = i1;
 HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i20 >> 2] = 0;
 i17 = i20 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i1);
 i8 = i11;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i18;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i20 + 12 >> 2] = i16;
 if (!i16) __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(0, 0 + (i16 << 5) | 0, i11); else {
  HEAP32[i17 >> 2] = i16;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i16 << 5, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i20 >> 2] = i7;
  HEAP32[i11 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i8 = i11 + 12 | 0;
  i9 = i11 + 4 | 0;
  i10 = i11 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i11 >> 2] = i9;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i2 = 0;
  i1 = 0;
  do {
   i3 = i15 + (i2 * 252 | 0) | 0;
   i4 = HEAP8[i15 + (i2 * 252 | 0) + 247 >> 0] | 0;
   if (!(i4 << 24 >> 24)) i13 = 8; else if (!(HEAP8[i15 + (i2 * 252 | 0) + 246 >> 0] | 0)) {
    i6 = __ZN2UI13DepthSortGrid17AddAndGetDepthForERKNS_23RenderableUIInstructionEPS2_i(i11, i3, i15, i12) | 0;
    HEAP32[i7 + (i2 << 5) >> 2] = HEAP32[i15 + (i2 * 252 | 0) + 84 >> 2];
    HEAP32[i7 + (i2 << 5) + 4 >> 2] = i6;
    HEAP32[i7 + (i2 << 5) + 8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i7 + (i2 << 5) + 12 >> 2] = HEAP32[i15 + (i2 * 252 | 0) + 4 >> 2];
    i5 = i7 + (i2 << 5) + 16 | 0;
    i4 = i15 + (i2 * 252 | 0) + 12 | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i1 = (i6 | 0) < (i1 | 0) ? i1 : i6;
   } else i13 = 8;
   L12 : do if ((i13 | 0) == 8) {
    i13 = 0;
    if (i2 >>> 0 < i16 >>> 0) {
     i5 = 0;
     i6 = i2;
     i3 = i4;
     while (1) {
      if (i3 << 24 >> 24) if (!(HEAP8[i15 + (i6 * 252 | 0) + 246 >> 0] | 0)) break;
      HEAP32[i7 + (i6 << 5) >> 2] = HEAP32[i15 + (i6 * 252 | 0) + 84 >> 2];
      i1 = i1 + 1 | 0;
      HEAP32[i7 + (i6 << 5) + 4 >> 2] = i1;
      i3 = i6 + 1 | 0;
      if (i3 >>> 0 >= i16 >>> 0) break L12;
      i5 = i5 + 1 | 0;
      i6 = i3;
      i3 = HEAP8[i15 + (i3 * 252 | 0) + 247 >> 0] | 0;
     }
     i1 = i1 + 1 | 0;
     __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i11, HEAP32[i9 >> 2] | 0);
     HEAP32[i8 >> 2] = 0;
     HEAP32[i11 >> 2] = i9;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i10 >> 2] = i1;
     i2 = i2 + -1 + i5 | 0;
    }
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i16 >>> 0);
  __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i11, HEAP32[i9 >> 2] | 0);
  i2 = HEAP32[i20 >> 2] | 0;
  __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i2, i2 + (i16 << 5) | 0, i11);
  i2 = HEAP32[i20 >> 2] | 0;
  i1 = 0;
  do {
   i12 = HEAP32[i2 + (i1 << 5) >> 2] | 0;
   _memcpy(i19 + (i1 * 252 | 0) | 0, i15 + (i12 * 252 | 0) | 0, 152) | 0;
   i10 = HEAP32[i15 + (i12 * 252 | 0) + 156 >> 2] | 0;
   i11 = HEAP32[i15 + (i12 * 252 | 0) + 160 >> 2] | 0;
   i13 = HEAP32[i15 + (i12 * 252 | 0) + 164 >> 2] | 0;
   HEAP32[i19 + (i1 * 252 | 0) + 152 >> 2] = HEAP32[i15 + (i12 * 252 | 0) + 152 >> 2];
   HEAP32[i19 + (i1 * 252 | 0) + 156 >> 2] = i10;
   HEAP32[i19 + (i1 * 252 | 0) + 160 >> 2] = i11;
   HEAP32[i19 + (i1 * 252 | 0) + 164 >> 2] = i13;
   i13 = HEAP32[i15 + (i12 * 252 | 0) + 172 >> 2] | 0;
   i11 = HEAP32[i15 + (i12 * 252 | 0) + 176 >> 2] | 0;
   i10 = HEAP32[i15 + (i12 * 252 | 0) + 180 >> 2] | 0;
   HEAP32[i19 + (i1 * 252 | 0) + 168 >> 2] = HEAP32[i15 + (i12 * 252 | 0) + 168 >> 2];
   HEAP32[i19 + (i1 * 252 | 0) + 172 >> 2] = i13;
   HEAP32[i19 + (i1 * 252 | 0) + 176 >> 2] = i11;
   HEAP32[i19 + (i1 * 252 | 0) + 180 >> 2] = i10;
   i10 = i19 + (i1 * 252 | 0) + 184 | 0;
   i11 = i15 + (i12 * 252 | 0) + 184 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   i10 = HEAP32[i15 + (i12 * 252 | 0) + 212 >> 2] | 0;
   i11 = HEAP32[i15 + (i12 * 252 | 0) + 216 >> 2] | 0;
   i13 = HEAP32[i15 + (i12 * 252 | 0) + 220 >> 2] | 0;
   HEAP32[i19 + (i1 * 252 | 0) + 208 >> 2] = HEAP32[i15 + (i12 * 252 | 0) + 208 >> 2];
   HEAP32[i19 + (i1 * 252 | 0) + 212 >> 2] = i10;
   HEAP32[i19 + (i1 * 252 | 0) + 216 >> 2] = i11;
   HEAP32[i19 + (i1 * 252 | 0) + 220 >> 2] = i13;
   i13 = i19 + (i1 * 252 | 0) + 224 | 0;
   i12 = i15 + (i12 * 252 | 0) + 224 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP16[i13 + 24 >> 1] = HEAP16[i12 + 24 >> 1] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
 }
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i18);
  HEAP32[i20 >> 2] = 0;
 }
 if (!i14) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i12, i15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i9 = i4 - i2 | 0;
 i10 = (i9 | 0) / 20 | 0;
 i14 = i11 + 8 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = i5;
 if (i10 >>> 0 > ((i3 - i5 | 0) / 20 | 0) >>> 0) {
  if (!i5) i1 = i3; else {
   i8 = i11 + 4 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) i1 = i5; else {
    i7 = i16 + 4 | 0;
    i6 = i2;
    while (1) {
     i2 = i6 + -20 | 0;
     HEAP32[i8 >> 2] = i2;
     i4 = HEAP32[i6 + -16 >> 2] | 0;
     i5 = i4;
     if (i4) {
      i2 = i6 + -12 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
      i2 = HEAP32[i6 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 51;
      HEAP32[i7 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i4, i16);
      i2 = HEAP32[i8 >> 2] | 0;
     }
     if ((i2 | 0) == (i1 | 0)) break; else i6 = i2;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i13 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
   HEAP32[i14 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = 0;
  }
  if ((i9 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  } else i2 = 0;
  i13 = (i1 - i2 | 0) / 20 | 0;
  i1 = i13 << 1;
  i1 = i13 >>> 0 < 1073741823 ? (i1 >>> 0 < i10 >>> 0 ? i10 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i13 = i11 + 4 | 0;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i14 >> 2] = i2 + (i1 * 20 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i15 >> 2] | 0;
  if ((i1 | 0) == (i11 | 0)) {
   STACKTOP = i17;
   return;
  }
  i12 = i16 + 4 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i6 = i2 + 4 | 0;
   i7 = i1 + 4 | 0;
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   i10 = i2 + 8 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i4 = i2 + 16 | 0;
   HEAP32[i4 >> 2] = i3;
   i9 = i1 + 8 | 0;
   i5 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = i5 >> 2;
   if (i8 | 0) {
    if ((i5 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
     i3 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i16 >> 2] = 51;
    HEAP32[i12 >> 2] = i3;
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i6 >> 2] = i4;
    HEAP32[i2 + 12 >> 2] = i4 + (i8 << 2);
    i3 = HEAP32[i7 >> 2] | 0;
    i2 = (HEAP32[i9 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i2 >> 2 << 2);
    }
   }
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i13 >> 2] | 0) + 20 | 0;
   HEAP32[i13 >> 2] = i2;
  } while ((i1 | 0) != (i11 | 0));
  STACKTOP = i17;
  return;
 } else {
  i13 = i11 + 4 | 0;
  i14 = ((HEAP32[i13 >> 2] | 0) - i5 | 0) / 20 | 0;
  i3 = i10 >>> 0 > i14 >>> 0;
  i4 = i3 ? i2 + (i14 * 20 | 0) | 0 : i4;
  if ((i2 | 0) == (i4 | 0)) i7 = i1; else {
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    if ((i1 | 0) != (i2 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i1 + 4 | 0, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
    i2 = i2 + 20 | 0;
    i1 = i1 + 20 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i7 = i1;
  }
  if (!i3) {
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 | 0) == (i7 | 0)) {
    STACKTOP = i17;
    return;
   }
   i6 = i16 + 4 | 0;
   do {
    i2 = i1 + -20 | 0;
    HEAP32[i13 >> 2] = i2;
    i4 = HEAP32[i1 + -16 >> 2] | 0;
    i5 = i4;
    if (!i4) i1 = i2; else {
     i2 = i1 + -12 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
     i1 = HEAP32[i1 + -4 >> 2] | 0;
     HEAP32[i16 >> 2] = 51;
     HEAP32[i6 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i16);
     i1 = HEAP32[i13 >> 2] | 0;
    }
   } while ((i1 | 0) != (i7 | 0));
   STACKTOP = i17;
   return;
  }
  i11 = HEAP32[i15 >> 2] | 0;
  if ((i4 | 0) == (i11 | 0)) {
   STACKTOP = i17;
   return;
  }
  i12 = i16 + 4 | 0;
  i5 = HEAP32[i13 >> 2] | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   i6 = i5 + 4 | 0;
   i7 = i4 + 4 | 0;
   i1 = HEAP32[i4 + 16 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   i10 = i5 + 8 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i2 = i5 + 16 | 0;
   HEAP32[i2 >> 2] = i1;
   i9 = i4 + 8 | 0;
   i3 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = i3 >> 2;
   if (i8 | 0) {
    if ((i3 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
     i1 = HEAP32[i2 >> 2] | 0;
    }
    HEAP32[i16 >> 2] = 51;
    HEAP32[i12 >> 2] = i1;
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i10 >> 2] = i3;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i5 + 12 >> 2] = i3 + (i8 << 2);
    i2 = HEAP32[i7 >> 2] | 0;
    i1 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i1 >> 2 << 2);
    }
   }
   i4 = i4 + 20 | 0;
   i5 = (HEAP32[i13 >> 2] | 0) + 20 | 0;
   HEAP32[i13 >> 2] = i5;
  } while ((i4 | 0) != (i11 | 0));
  STACKTOP = i17;
  return;
 }
}

function __ZN5physx2Sc5Scene11shiftOriginERKNS_6PxVec3E(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i10 = HEAP32[(HEAP32[i14 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 __ZN5physx10PxsContext11shiftOriginERKNS_6PxVec3E(i10, i13);
 __ZN5physx14PxsAABBManager11shiftOriginERKNS_6PxVec3E(HEAP32[i10 + 8 >> 2] | 0, i13);
 i10 = HEAP32[i14 + 1152 >> 2] | 0;
 i11 = HEAP32[i14 + 1156 >> 2] | 0;
 if (i11 | 0) {
  i6 = i13 + 4 | 0;
  i7 = i13 + 8 | 0;
  i12 = 0;
  do {
   i9 = HEAP32[i10 + (i12 << 2) >> 2] | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = (i9 >>> 0) / 6 | 0;
   if (i9 >>> 0 > 5) {
    i2 = i9 >>> 0 > 11;
    i3 = 0;
    i4 = 0;
    i5 = i8 + 256 | 0;
    while (1) {
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i17 = i8 + (i4 * 36 | 0) + 24 | 0;
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i17 = i8 + (i4 * 36 | 0) + 28 | 0;
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i17 = i8 + (i4 * 36 | 0) + 32 | 0;
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f18);
     i17 = i4 + 1 | 0;
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 24 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 28 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 32 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     i17 = i17 + 1 | 0;
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 24 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 28 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 32 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     i17 = i17 + 1 | 0;
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 24 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 28 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 32 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     i17 = i17 + 1 | 0;
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 24 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 28 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 32 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     i17 = i17 + 1 | 0;
     f18 = Math_fround(HEAPF32[i13 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 24 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     i19 = i8 + (i17 * 36 | 0) + 28 | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
     f18 = Math_fround(HEAPF32[i7 >> 2]);
     i17 = i8 + (i17 * 36 | 0) + 32 | 0;
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f18);
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 >= i1 >>> 0) break; else {
      i4 = i4 + 6 | 0;
      i5 = i5 + 256 | 0;
     }
    }
    i1 = i2 ? i1 * 6 | 0 : 6;
   } else i1 = 0;
   if (i1 >>> 0 < i9 >>> 0) do {
    f18 = Math_fround(HEAPF32[i13 >> 2]);
    i19 = i8 + (i1 * 36 | 0) + 24 | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
    f18 = Math_fround(HEAPF32[i6 >> 2]);
    i19 = i8 + (i1 * 36 | 0) + 28 | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
    f18 = Math_fround(HEAPF32[i7 >> 2]);
    i19 = i8 + (i1 * 36 | 0) + 32 | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f18);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i9 | 0));
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i11 | 0));
 }
 i1 = i14 + 88 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i14 + 84 | 0;
  i3 = 0;
  do {
   i19 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 16 >> 2] | 0, i19 | 0, i13 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = i14 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i14 + 156 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sc9ClothCore13onOriginShiftERKNS_6PxVec3E(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i13);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i14 + 136 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i2 = i14 + 132 | 0;
 i3 = 0;
 do {
  i17 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  __ZN5physx2Sc17ParticleSystemSim7releaseEb(__ZNK5physx2Sc18ParticleSystemCore6getSimEv(i17) | 0, 0);
  __ZN5physx2Sc18ParticleSystemCore13onOriginShiftERKNS_6PxVec3E(i17, i13);
  i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
  i19 = _PxGetFoundation() | 0;
  i19 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 24 >> 2] | 0, i19 | 0) | 0;
  i19 = mftCall_iiiiii(i11 | 0, i12 | 0, 400, (i19 ? gb + 683622 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 4005) | 0;
  __ZN5physx2Sc17ParticleSystemSimC2ERNS0_5SceneERNS0_18ParticleSystemCoreE(i19, i14, i17);
  if (!i19) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 680241 | 0, 4008, gb + 703317 | 0, i15);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLab10GrabPasses3AddEPNS_4PassEPK6Camera(i15, i1, i10) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 16 | 0;
 i11 = i17;
 i6 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i16 = i1 + 768 | 0;
 i5 = (HEAP32[i16 >> 2] | 0) != -1;
 i16 = i5 ? i16 : gb + 1166408 | 0;
 i14 = i15 + 8 | 0;
 i9 = i15 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i16 >> 2] | 0;
  i1 = i9;
  L3 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L3; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i9 | 0)) if (!((i1 | 0) == (i9 | 0) ? 1 : (i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0))) {
   i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
   if (!i1) {
    __ZNK6Camera13GetCameraRectEb(i13, i10, 1);
    __Z14RectfToRectIntRK5RectTIfE(i11, i13);
   } else {
    i15 = HEAP32[i1 + 80 >> 2] | 0;
    i16 = HEAP32[i1 + 84 >> 2] | 0;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = i15;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 12 >> 2] = i16;
   }
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 i1 = i5 ^ 1;
 HEAP8[i6 >> 0] = 0;
 i2 = __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb(i10, i16, i1, 0, i6) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 + 88 | 0;
  i4 = i2 + 132 | 0;
  i5 = i2 + 128 | 0;
  if (!(HEAP32[((HEAP32[i3 >> 2] | 0) > 1 ? i4 : i5) >> 2] | 0)) i1 = 0; else {
   i12 = __ZnwjRK10MemLabelIdiPKci(136, i15, 16, gb + 480294 | 0, 166) | 0;
   i19 = i15;
   i20 = HEAP32[i19 >> 2] | 0;
   i19 = HEAP32[i19 + 4 >> 2] | 0;
   HEAP32[i12 + 4 >> 2] = 1;
   HEAP32[i12 >> 2] = gb + 33952 + 8;
   i22 = i11;
   HEAP32[i22 >> 2] = i20;
   HEAP32[i22 + 4 >> 2] = i19;
   HEAP32[i12 + 32 >> 2] = 0;
   HEAP32[i12 + 44 >> 2] = 0;
   HEAP32[i12 + 48 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i11);
   i22 = i13;
   i21 = HEAP32[i22 + 4 >> 2] | 0;
   i18 = i12 + 36 | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i18 + 4 >> 2] = i21;
   i18 = i11;
   HEAP32[i18 >> 2] = i20;
   HEAP32[i18 + 4 >> 2] = i19;
   HEAP32[i12 + 52 >> 2] = 0;
   HEAP32[i12 + 64 >> 2] = 0;
   HEAP32[i12 + 68 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i11);
   i18 = i13;
   i21 = HEAP32[i18 + 4 >> 2] | 0;
   i22 = i12 + 56 | 0;
   HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i22 + 4 >> 2] = i21;
   i22 = i11;
   HEAP32[i22 >> 2] = i20;
   HEAP32[i22 + 4 >> 2] = i19;
   HEAP32[i12 + 72 >> 2] = 0;
   HEAP32[i12 + 84 >> 2] = 0;
   HEAP32[i12 + 88 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i11);
   i22 = i13;
   i21 = HEAP32[i22 + 4 >> 2] | 0;
   i18 = i12 + 76 | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i18 + 4 >> 2] = i21;
   HEAP32[i12 + 92 >> 2] = 0;
   HEAP32[i12 + 96 >> 2] = 0;
   i18 = i12 + 100 | 0;
   HEAP32[i18 >> 2] = i20;
   HEAP32[i18 + 4 >> 2] = i19;
   HEAP8[i12 + 108 >> 0] = 1;
   i18 = i12 + 8 | 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 + 20 >> 2] = 0;
   i18 = i12 + 112 | 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP32[i18 + 16 >> 2] = 0;
   HEAP32[i18 >> 2] = HEAP32[((HEAP32[i3 >> 2] | 0) > 1 ? i4 : i5) >> 2];
   i5 = i12 + 116 | 0;
   __ZNK6Camera18GetRenderRectangleEv(i11, i10);
   __Z14RectfToRectIntRK5RectTIfE(i13, i11);
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   __ZNK13RenderTexture12FitGivenRectERiS0_S0_S0_(i2, i5, i12 + 120 | 0, i12 + 124 | 0, i12 + 128 | 0);
   HEAP32[i7 >> 2] = HEAP32[gb + 62472 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
   HEAP32[i8 >> 2] = HEAP32[gb + 1162356 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
   __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i12, i16, i2, i7, i8);
   i11 = i12 + 132 | 0;
   HEAP8[i11 >> 0] = HEAP8[i11 >> 0] & -4 | i1 & 1 | HEAP8[i6 >> 0] << 1 & 255;
   i1 = HEAP32[i9 >> 2] | 0;
   do if (!i1) {
    HEAP32[i13 >> 2] = i9;
    i5 = i9;
    i3 = i9;
    i2 = HEAP32[i16 >> 2] | 0;
    i4 = 26;
   } else {
    i6 = HEAP32[i16 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i6 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 19;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i6 | 0)) {
       i4 = 25;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 23;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 19) {
     HEAP32[i13 >> 2] = i1;
     i5 = i1;
     i3 = i1;
     i2 = i6;
     i4 = 26;
     break;
    } else if ((i4 | 0) == 23) {
     HEAP32[i13 >> 2] = i1;
     i5 = i1;
     i2 = i6;
     i4 = 26;
     break;
    } else if ((i4 | 0) == 25) {
     HEAP32[i13 >> 2] = i1;
     if (!i1) {
      i5 = i1;
      i3 = i13;
      i2 = i6;
      i4 = 26;
      break;
     } else break;
    }
   } while (0);
   if ((i4 | 0) == 26) {
    i1 = __Znwj(24) | 0;
    HEAP32[i1 + 16 >> 2] = i2;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i5;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i14 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 + 12 >> 2] | 0, i2);
    i22 = i15 + 16 | 0;
    HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   }
   HEAP32[i1 + 20 >> 2] = i12;
   __ZN19ShaderPropertySheet38CopyTextureWithAuxiliaryPropertiesFromERKN9ShaderLab16FastPropertyNameERKS_((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, i16, i12);
   i1 = 1;
  }
 }
 i22 = i1;
 STACKTOP = i17;
 return i22 | 0;
}

function __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  i3 = i11;
 } else {
  i3 = HEAP32[i11 + 4 >> 2] | 0;
  if (!i3) i3 = i11; else while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 0;
    break;
   } else i3 = i2;
  }
 }
 i8 = i3 + 4 | 0;
 i9 = HEAP32[((i2 | 0) == 0 ? i8 : i3) >> 2] | 0;
 i10 = (i9 | 0) == 0;
 i6 = i3 + 8 | 0;
 if (!i10) HEAP32[i9 + 8 >> 2] = HEAP32[i6 >> 2];
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) {
  HEAP32[i2 >> 2] = i9;
  if ((i3 | 0) == (i1 | 0)) {
   i1 = i9;
   i4 = 0;
  } else i4 = HEAP32[i2 + 4 >> 2] | 0;
 } else HEAP32[i2 + 4 >> 2] = i9;
 i5 = i3 + 12 | 0;
 i7 = (HEAP8[i5 >> 0] | 0) == 0;
 if ((i3 | 0) != (i11 | 0)) {
  i12 = i11 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  if ((HEAP32[HEAP32[i12 >> 2] >> 2] | 0) == (i11 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i2 + 8 >> 2] = i3;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  if (i2 | 0) HEAP32[i2 + 8 >> 2] = i3;
  HEAP8[i5 >> 0] = HEAP8[i11 + 12 >> 0] | 0;
  i1 = (i1 | 0) == (i11 | 0) ? i3 : i1;
 }
 if (i7 | (i1 | 0) == 0) return;
 if (i10) i7 = i4; else {
  HEAP8[i9 + 12 >> 0] = 1;
  return;
 }
 while (1) {
  i6 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i7 + 12 | 0;
  i3 = (HEAP8[i2 >> 0] | 0) != 0;
  if ((HEAP32[i6 >> 2] | 0) == (i7 | 0)) {
   if (i3) i5 = i7; else {
    HEAP8[i2 >> 0] = 1;
    HEAP8[i6 + 12 >> 0] = 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = i4 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i6 >> 2] = i2;
    if (i2 | 0) HEAP32[i2 + 8 >> 2] = i6;
    i2 = i6 + 8 | 0;
    HEAP32[i4 + 8 >> 2] = HEAP32[i2 >> 2];
    i3 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) HEAP32[i3 >> 2] = i4; else HEAP32[i3 + 4 >> 2] = i4;
    HEAP32[i5 >> 2] = i6;
    HEAP32[i2 >> 2] = i4;
    i12 = HEAP32[i7 + 4 >> 2] | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i1 = (i1 | 0) == (i12 | 0) ? i7 : i1;
   }
   i4 = HEAP32[i5 >> 2] | 0;
   i3 = (i4 | 0) == 0;
   if (!i3) if (!(HEAP8[i4 + 12 >> 0] | 0)) {
    i6 = 66;
    break;
   }
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   if (i2 | 0) if (!(HEAP8[i2 + 12 >> 0] | 0)) {
    i6 = 65;
    break;
   }
   HEAP8[i5 + 12 >> 0] = 0;
   i2 = HEAP32[i5 + 8 >> 2] | 0;
   i3 = i2 + 12 | 0;
   if ((i2 | 0) == (i1 | 0) | (HEAP8[i3 >> 0] | 0) == 0) {
    i6 = 62;
    break;
   }
   i12 = HEAP32[i2 + 8 >> 2] | 0;
   i2 = (HEAP32[i12 >> 2] | 0) == (i2 | 0) ? i12 + 4 | 0 : i12;
  } else {
   if (i3) i5 = i7; else {
    HEAP8[i2 >> 0] = 1;
    HEAP8[i6 + 12 >> 0] = 0;
    i12 = i6 + 4 | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i12 >> 2] = i2;
    if (i2 | 0) HEAP32[i2 + 8 >> 2] = i6;
    i2 = i6 + 8 | 0;
    HEAP32[i4 + 8 >> 2] = HEAP32[i2 >> 2];
    i3 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) HEAP32[i3 >> 2] = i4; else HEAP32[i3 + 4 >> 2] = i4;
    HEAP32[i4 >> 2] = i6;
    HEAP32[i2 >> 2] = i4;
    i12 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i12 + 4 >> 2] | 0;
    i1 = (i1 | 0) == (i12 | 0) ? i7 : i1;
   }
   i4 = HEAP32[i5 >> 2] | 0;
   if (i4 | 0) if (!(HEAP8[i4 + 12 >> 0] | 0)) {
    i6 = 36;
    break;
   }
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   if (i2 | 0) if (!(HEAP8[i2 + 12 >> 0] | 0)) {
    i1 = i2;
    i6 = 37;
    break;
   }
   HEAP8[i5 + 12 >> 0] = 0;
   i2 = HEAP32[i5 + 8 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i6 = 34;
    break;
   }
   if (!(HEAP8[i2 + 12 >> 0] | 0)) {
    i1 = i2;
    i6 = 34;
    break;
   }
   i12 = HEAP32[i2 + 8 >> 2] | 0;
   i2 = (HEAP32[i12 >> 2] | 0) == (i2 | 0) ? i12 + 4 | 0 : i12;
  }
  i7 = HEAP32[i2 >> 2] | 0;
 }
 if ((i6 | 0) == 34) {
  HEAP8[i1 + 12 >> 0] = 1;
  return;
 } else if ((i6 | 0) == 36) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i1) i6 = 38; else i6 = 37;
 } else if ((i6 | 0) == 62) {
  HEAP8[i3 >> 0] = 1;
  return;
 } else if ((i6 | 0) == 65) if (i3) i6 = 67; else i6 = 66;
 if ((i6 | 0) == 37) if (!(HEAP8[i1 + 12 >> 0] | 0)) {
  i2 = i5;
  i6 = 44;
 } else i6 = 38; else if ((i6 | 0) == 66) if (!(HEAP8[i4 + 12 >> 0] | 0)) {
  i3 = i5;
  i1 = i4;
  i6 = 73;
 } else i6 = 67;
 if ((i6 | 0) == 38) {
  HEAP8[i4 + 12 >> 0] = 1;
  HEAP8[i5 + 12 >> 0] = 0;
  i3 = i4 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i5;
  i1 = i5 + 8 | 0;
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) HEAP32[i2 >> 2] = i4; else HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i4;
  i2 = i4;
  i1 = i5;
  i6 = 44;
 } else if ((i6 | 0) == 67) {
  i12 = i5 + 4 | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  HEAP8[i3 + 12 >> 0] = 1;
  HEAP8[i5 + 12 >> 0] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i5;
  i1 = i5 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
  i6 = 73;
 }
 if ((i6 | 0) == 44) {
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i12 = i4 + 12 | 0;
  HEAP8[i2 + 12 >> 0] = HEAP8[i12 >> 0] | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP8[i1 + 12 >> 0] = 1;
  i12 = i4 + 4 | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i4;
  i1 = i4 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  return;
 } else if ((i6 | 0) == 73) {
  i5 = HEAP32[i3 + 8 >> 2] | 0;
  i4 = i5 + 12 | 0;
  HEAP8[i3 + 12 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP8[i4 >> 0] = 1;
  HEAP8[i1 + 12 >> 0] = 1;
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i5;
  i1 = i5 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function __ZN16Physics2DManager21GetRayIntersectionAllERK8Vector3fS2_fiPK10Collider2DP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i4, i3, f12, i8, i11, i27) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 f12 = Math_fround(f12);
 i8 = i8 | 0;
 i11 = i11 | 0;
 i27 = i27 | 0;
 var f2 = f0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i30 + 16 | 0;
 i26 = i30 + 8 | 0;
 i24 = i30 + 80 | 0;
 i28 = i30 + 56 | 0;
 i25 = i30 + 104 | 0;
 i22 = i30;
 if ((HEAP16[gb + 1457836 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457836 | 0, i21);
  i29 = gb + 1457836 | 0;
 } else i29 = 0;
 i1 = i27 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i27 + 4 | 0);
  HEAP32[i27 >> 2] = 0;
 }
 HEAP32[i27 >> 2] = 0;
 i23 = i27 + 12 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f6 * f6));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f7 * f7));
 if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
 f13 = Math_fround(f5 * f2);
 f5 = Math_fround(f6 * f2);
 f7 = Math_fround(f7 * f2);
 i18 = i24 + 12 | 0;
 HEAPF32[i18 >> 2] = f13;
 i19 = i24 + 16 | 0;
 HEAPF32[i19 >> 2] = f5;
 HEAPF32[i24 + 20 >> 2] = f7;
 i17 = f12 == Math_fround(inf);
 f20 = Math_fround(Math_fround(1.0) / f12);
 f20 = i17 ? Math_fround(1.0) : f20;
 f2 = i17 ? Math_fround(1.0e5) : f12;
 f7 = Math_fround(f2 * f7);
 i17 = i24 + 4 | 0;
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i24 + 8 >> 2]));
 i10 = i4 + 8 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f7);
 i16 = f12 < Math_fround(0.0);
 f6 = Math_fround(-f12);
 if (!((i16 ? f6 : f12) <= Math_fround(9.99999997e-07))) {
  f6 = Math_fround(f2 * f5);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i17 >> 2]));
  f5 = Math_fround(f2 * f13);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i24 >> 2]));
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i16 = gb + 64016 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i26;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i28 >> 2] = 0;
  i14 = i28 + 12 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i28 + 16 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i28 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i26);
  i31 = i21;
  i4 = HEAP32[i31 + 4 >> 2] | 0;
  i9 = i16;
  HEAP32[i9 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i9 + 4 >> 2] = i4;
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  if ((HEAP16[gb + 1457620 + 6 >> 1] | 0) > -1) {
   HEAP32[i26 >> 2] = 0;
   HEAP32[i21 >> 2] = HEAP32[i26 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457620 | 0, i21);
   i9 = gb + 1457620 | 0;
  } else i9 = 0;
  HEAP32[i21 >> 2] = gb + 156148 + 8;
  HEAP32[i21 + 4 >> 2] = i8;
  i4 = i21 + 8 | 0;
  i8 = i21 + 12 | 0;
  HEAP32[i21 + 16 >> 2] = i11;
  HEAP32[i21 + 20 >> 2] = i3;
  HEAP32[i21 + 24 >> 2] = i1;
  HEAPF32[i21 + 28 >> 2] = f5;
  HEAPF32[i21 + 32 >> 2] = f6;
  HEAP32[i21 + 36 >> 2] = i28;
  i31 = f2 == Math_fround(-inf);
  f2 = i31 ? Math_fround(-3402823469999999843913219.0e14) : f2;
  HEAPF32[i4 >> 2] = f2;
  i31 = f7 == Math_fround(inf);
  f5 = i31 ? Math_fround(3402823469999999843913219.0e14) : f7;
  HEAPF32[i8 >> 2] = f5;
  if (!(f2 < f5)) {
   HEAPF32[i4 >> 2] = f5;
   HEAPF32[i8 >> 2] = f2;
  }
  i1 = __ZN14Raycast2DQuery8RunQueryEb(i21, 1) | 0;
  if (i9 | 0) __Z12profiler_endP19ProfilerInformation(i9);
  if (!i1) i1 = 0; else {
   i1 = Math_fround(HEAPF32[i10 >> 2]) < f7;
   i3 = HEAP32[i28 >> 2] | 0;
   i4 = i3 + ((HEAP32[i14 >> 2] | 0) * 36 | 0) | 0;
   if (i1) __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i3, i4, i21); else __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i3, i4, i21);
   f2 = i1 ? Math_fround(1.0) : Math_fround(-1.0);
   if (HEAP32[i14 >> 2] | 0) {
    i8 = i25 + 8 | 0;
    i3 = i21 + 4 | 0;
    i4 = i21 + 8 | 0;
    i9 = i21 + 12 | 0;
    i10 = i22 + 4 | 0;
    i1 = HEAP32[i28 >> 2] | 0;
    do {
     i11 = HEAP32[i1 + 32 >> 2] | 0;
     __ZNK9Transform11GetPositionEv(i25, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f13 = Math_fround(HEAPF32[i8 >> 2]);
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     HEAPF32[i3 >> 2] = Math_fround(0.0);
     HEAPF32[i4 >> 2] = f2;
     HEAPF32[i9 >> 2] = Math_fround(-Math_fround(Math_fround(f2 * f13) + Math_fround(0.0)));
     if (__Z17IntersectRayPlaneRK3RayRK5PlanePf(i24, i21, i26) | 0) {
      f13 = Math_fround(HEAPF32[i26 >> 2]);
      f12 = Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2]));
      f13 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
      f12 = Math_fround(f12 + Math_fround(HEAPF32[i24 >> 2]));
      f13 = Math_fround(f13 + Math_fround(HEAPF32[i17 >> 2]));
      HEAPF32[i22 >> 2] = f12;
      HEAPF32[i10 >> 2] = f13;
      if (__ZNK10Collider2D12OverlapPointERK8Vector2f(i11, i22) | 0) {
       i32 = i22;
       i11 = HEAP32[i32 + 4 >> 2] | 0;
       i31 = i1 + 8 | 0;
       HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
       HEAP32[i31 + 4 >> 2] = i11;
       f13 = Math_fround(f20 * Math_fround(HEAPF32[i26 >> 2]));
       HEAPF32[i1 + 28 >> 2] = f13;
       HEAPF32[i1 + 24 >> 2] = f13;
       __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i27, i1);
      }
     }
     i1 = i1 + 36 | 0;
    } while ((i1 | 0) != ((HEAP32[i28 >> 2] | 0) + ((HEAP32[i14 >> 2] | 0) * 36 | 0) | 0));
   }
   i1 = HEAP32[i23 >> 2] | 0;
  }
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i28 >> 2] | 0, i16);
   HEAP32[i28 >> 2] = 0;
  }
 } else i1 = 0;
 if (!i29) {
  STACKTOP = i30;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i29);
 STACKTOP = i30;
 return i1 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i23, i1, i5) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i28;
 i21 = i28 + 144 | 0;
 i25 = i28 + 16 | 0;
 i26 = i23 + 120 | 0;
 if (HEAP8[i26 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i23);
 i27 = i23 + 104 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i24 = i23 + 108 | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 if (i4 >>> 0 > i5 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i23 + 116 >> 2] | 0) >>> 0) {
  STACKTOP = i28;
  return;
 }
 i2 = i2 + i1 | 0;
 f3 = Math_fround(i2 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i28;
  return;
 }
 i7 = i23 + 4 | 0;
 f3 = Math_fround((i2 - (HEAP32[i7 >> 2] | 0) | 0) >>> 0);
 i6 = 32;
 while (1) {
  if (i6 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i6 >>> 0) * Math_fround(.5)))) break;
  i6 = i6 << 1;
 }
 i1 = i25 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i25 + 8 | 0;
 i4 = i23 + 8 | 0;
 i8 = HEAP16[i4 >> 1] | 0;
 HEAP8[i2 >> 0] = i8;
 i5 = i25 + 9 | 0;
 HEAP8[i5 >> 0] = (i8 & 65535) >>> 8;
 i8 = i25 + 12 | 0;
 i9 = i23 + 12 | 0;
 i12 = i8;
 i13 = i9;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 i10 = i25 + 56 | 0;
 i11 = i23 + 56 | 0;
 i12 = i10;
 i13 = i11;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 i15 = i25 + 100 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i25 + 104 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i25 + 108 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i25 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i18 = i25 + 116 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i25 + 112 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i25 + 120 | 0;
 HEAP8[i20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i25, i23, i6);
 i12 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i12;
 i1 = HEAP8[i4 >> 0] | 0;
 i12 = HEAP16[i2 >> 1] | 0;
 HEAP8[i4 >> 0] = i12;
 HEAP8[i2 >> 0] = i1;
 i2 = i23 + 9 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = (i12 & 65535) >>> 8;
 HEAP8[i5 >> 0] = i1;
 HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i1 = HEAP32[i23 + 28 >> 2] | 0;
 i2 = HEAP32[i23 + 32 >> 2] | 0;
 i4 = HEAP32[i23 + 36 >> 2] | 0;
 i12 = i23 + 40 | 0;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i12 = i9;
 i13 = i8;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i25 + 28 >> 2] = i1;
 HEAP32[i25 + 32 >> 2] = i2;
 HEAP32[i25 + 36 >> 2] = i4;
 i1 = i25 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i1 = HEAP32[i23 + 72 >> 2] | 0;
 i2 = HEAP32[i23 + 76 >> 2] | 0;
 i4 = HEAP32[i23 + 80 >> 2] | 0;
 i12 = i23 + 84 | 0;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i12 = i11;
 i13 = i10;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 HEAP32[i10 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i25 + 72 >> 2] = i1;
 HEAP32[i25 + 76 >> 2] = i2;
 HEAP32[i25 + 80 >> 2] = i4;
 i1 = i25 + 84 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 i21 = i23 + 100 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i1;
 i21 = HEAP32[i27 >> 2] | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i27 >> 2] = i15;
 HEAP32[i16 >> 2] = i21;
 i27 = HEAP32[i24 >> 2] | 0;
 HEAP32[i24 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i27;
 f3 = Math_fround(i15 >>> 0);
 HEAP32[i23 + 116 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i23 + 112 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i26 >> 0] = 0;
 f3 = Math_fround(i21 >>> 0);
 HEAP32[i18 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i19 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i20 >> 0] = 0;
 if (i1 | 0) {
  i27 = HEAP32[i25 + 124 >> 2] | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 4 >> 2] = i27;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
 }
 STACKTOP = i28;
 return;
}

function __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(i1, i2, i29) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i29 = i29 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, f34 = f0, f35 = f0;
 i30 = __Z12GetGfxDevicev() | 0;
 f31 = Math_fround(i1 | 0);
 if ((i1 | 0) > 0) {
  i24 = i30 + 1828 | 0;
  i25 = i30 + 1844 | 0;
  i26 = i30 + 1860 | 0;
  i27 = i30 + 1832 | 0;
  i16 = i30 + 1848 | 0;
  i17 = i30 + 1864 | 0;
  i18 = i30 + 1836 | 0;
  i19 = i30 + 1852 | 0;
  i20 = i30 + 1868 | 0;
  i21 = i30 + 1876 | 0;
  i22 = i30 + 1880 | 0;
  i23 = i30 + 1884 | 0;
  i13 = i2;
  i2 = 0;
  i3 = 0;
  i14 = 0;
  while (1) {
   i4 = i14 + 8 | 0;
   i10 = i14 + 16 | 0;
   i11 = i30 + 4 + (i10 << 4) | 0;
   i15 = i14 + 24 | 0;
   i12 = i30 + 4 + (i15 << 4) | 0;
   i33 = i13 + 32 | 0;
   i32 = i30 + 4 + (i14 << 4) | 0;
   HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
   HEAP32[i32 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
   HEAP32[i32 + 8 >> 2] = HEAP32[i33 + 8 >> 2];
   HEAP32[i32 + 12 >> 2] = HEAP32[i33 + 12 >> 2];
   f9 = Math_fround(HEAPF32[i24 >> 2]);
   f5 = Math_fround(HEAPF32[i13 >> 2]);
   f9 = Math_fround(f9 * f5);
   f8 = Math_fround(HEAPF32[i25 >> 2]);
   f6 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f8 = Math_fround(f9 + Math_fround(f8 * f6));
   f9 = Math_fround(HEAPF32[i26 >> 2]);
   f7 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f9 = Math_fround(f8 + Math_fround(f9 * f7));
   if ((HEAP32[i13 + 60 >> 2] | 0) == 1) {
    f34 = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
    f34 = Math_fround(f34 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
    f34 = Math_fround(f34 + Math_fround(f7 * Math_fround(HEAPF32[i17 >> 2])));
    f8 = Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2]));
    f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2])));
    f8 = Math_fround(0.0);
    f6 = Math_fround(-Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i20 >> 2]))));
    f7 = Math_fround(-f34);
    f5 = Math_fround(-f9);
   } else {
    f34 = Math_fround(f9 + Math_fround(HEAPF32[i21 >> 2]));
    f9 = Math_fround(f5 * Math_fround(HEAPF32[i27 >> 2]));
    f9 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
    f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i17 >> 2])));
    f9 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f9);
    f8 = Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2]));
    f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2])));
    f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i20 >> 2])));
    i3 = 1;
    f8 = Math_fround(1.0);
    f6 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f6);
    f7 = f9;
    f5 = f34;
   }
   HEAPF32[i30 + 4 + (i4 << 4) >> 2] = f5;
   HEAPF32[i30 + 4 + (i4 << 4) + 4 >> 2] = f7;
   HEAPF32[i30 + 4 + (i4 << 4) + 8 >> 2] = f6;
   HEAPF32[i30 + 4 + (i4 << 4) + 12 >> 2] = f8;
   f6 = Math_fround(HEAPF32[i13 + 48 >> 2]);
   f6 = Math_fround(f6 * f6);
   f5 = Math_fround(HEAPF32[i13 + 56 >> 2]);
   if (f5 > Math_fround(0.0)) {
    f8 = Math_fround(HEAPF32[i24 >> 2]);
    f35 = Math_fround(HEAPF32[i13 + 16 >> 2]);
    f8 = Math_fround(f8 * f35);
    f9 = Math_fround(HEAPF32[i25 >> 2]);
    f7 = Math_fround(HEAPF32[i13 + 20 >> 2]);
    f9 = Math_fround(f8 + Math_fround(f9 * f7));
    f8 = Math_fround(HEAPF32[i26 >> 2]);
    f34 = Math_fround(HEAPF32[i13 + 24 >> 2]);
    f8 = Math_fround(f9 + Math_fround(f8 * f34));
    f9 = Math_fround(f35 * Math_fround(HEAPF32[i27 >> 2]));
    f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i16 >> 2])));
    f9 = Math_fround(f9 + Math_fround(f34 * Math_fround(HEAPF32[i17 >> 2])));
    f35 = Math_fround(f35 * Math_fround(HEAPF32[i18 >> 2]));
    f7 = Math_fround(f35 + Math_fround(f7 * Math_fround(HEAPF32[i19 >> 2])));
    f9 = Math_fround(-f9);
    f34 = Math_fround(-Math_fround(f7 + Math_fround(f34 * Math_fround(HEAPF32[i20 >> 2]))));
    HEAPF32[i11 >> 2] = Math_fround(-f8);
    HEAPF32[i30 + 4 + (i10 << 4) + 4 >> 2] = f9;
    HEAPF32[i30 + 4 + (i10 << 4) + 8 >> 2] = f34;
    HEAPF32[i30 + 4 + (i10 << 4) + 12 >> 2] = Math_fround(0.0);
    f34 = Math_fround(Math_fround(Math_fround(f5 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
    f9 = Math_fround(+Math_cos(+Math_fround(f34 * Math_fround(.5))));
    f34 = Math_fround(Math_fround(+Math_cos(+Math_fround(f34 * Math_fround(.25)))) - f9);
    i2 = f34 != Math_fround(0.0);
    f34 = Math_fround(Math_fround(1.0) / f34);
    f34 = i2 ? f34 : Math_fround(1.0);
    i2 = HEAP32[i13 + 52 >> 2] | 0;
    HEAPF32[i12 >> 2] = f9;
    HEAPF32[i30 + 4 + (i15 << 4) + 4 >> 2] = f34;
    HEAP32[i30 + 4 + (i15 << 4) + 8 >> 2] = i2;
    i2 = 1;
   } else {
    HEAPF32[i11 >> 2] = Math_fround(0.0);
    HEAPF32[i30 + 4 + (i10 << 4) + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i30 + 4 + (i10 << 4) + 8 >> 2] = Math_fround(1.0);
    HEAPF32[i30 + 4 + (i10 << 4) + 12 >> 2] = Math_fround(0.0);
    i33 = HEAP32[i13 + 52 >> 2] | 0;
    HEAPF32[i12 >> 2] = Math_fround(-1.0);
    HEAPF32[i30 + 4 + (i15 << 4) + 4 >> 2] = Math_fround(1.0);
    HEAP32[i30 + 4 + (i15 << 4) + 8 >> 2] = i33;
   }
   HEAPF32[i30 + 4 + (i15 << 4) + 12 >> 2] = f6;
   i14 = i14 + 1 | 0;
   if ((i14 | 0) == (i1 | 0)) break; else i13 = i13 + 64 | 0;
  }
  if ((i1 | 0) < 8) i28 = 4; else i4 = i2;
 } else {
  i2 = 0;
  i3 = 0;
  i28 = 4;
 }
 if ((i28 | 0) == 4) {
  do {
   i33 = i1 + 8 | 0;
   HEAPF32[i30 + 4 + (i33 << 4) >> 2] = Math_fround(0.0);
   HEAPF32[i30 + 4 + (i33 << 4) + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i30 + 4 + (i33 << 4) + 8 >> 2] = Math_fround(1.0);
   HEAPF32[i30 + 4 + (i33 << 4) + 12 >> 2] = Math_fround(0.0);
   i33 = i30 + 4 + (i1 << 4) | 0;
   i1 = i1 + 1 | 0;
   HEAP32[i33 >> 2] = 0;
   HEAP32[i33 + 4 >> 2] = 0;
   HEAP32[i33 + 8 >> 2] = 0;
   HEAP32[i33 + 12 >> 2] = 0;
  } while ((i1 | 0) != 8);
  i4 = i2;
 }
 HEAPF32[i30 + 516 >> 2] = f31;
 HEAPF32[i30 + 520 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 524 >> 2] = Math_fround(1.0);
 HEAPF32[i30 + 528 >> 2] = Math_fround(0.0);
 i1 = i29 + 4 | 0;
 i2 = HEAP32[i1 >> 2] & -32;
 HEAP32[i1 >> 2] = i2;
 if (i4) {
  HEAP32[i1 >> 2] = i2 | 1;
  return;
 }
 if (!i3) return;
 HEAP32[i1 >> 2] = i2 | 8;
 return;
}

function __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode2EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f27, i28, i35, i1, i36) {
 f27 = Math_fround(f27);
 i28 = i28 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i41 + 48 | 0;
 i38 = i41 + 32 | 0;
 i39 = i41 + 16 | 0;
 i40 = i41;
 i29 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i29) {
  STACKTOP = i41;
  return;
 }
 i30 = i1 + 500 | 0;
 i31 = i39 + 4 | 0;
 i32 = i39 + 8 | 0;
 i33 = i39 + 12 | 0;
 i34 = i35 + 84 | 0;
 i2 = i1 + 520 | 0;
 i3 = i39 + 4 | 0;
 i4 = i39 + 8 | 0;
 i5 = i39 + 12 | 0;
 i6 = i40 + 4 | 0;
 i7 = i40 + 8 | 0;
 i8 = i40 + 12 | 0;
 i9 = i38 + 4 | 0;
 i10 = i38 + 8 | 0;
 i11 = i38 + 12 | 0;
 i12 = i37 + 4 | 0;
 i13 = i37 + 8 | 0;
 i14 = i37 + 12 | 0;
 i15 = i35 + 80 | 0;
 i16 = i35 + 232 | 0;
 i17 = i35 + 144 | 0;
 i1 = 0;
 do {
  i21 = (HEAP32[i30 >> 2] | 0) + (i1 << 2) | 0;
  i18 = HEAP32[i21 >> 2] | 0;
  i19 = HEAP32[i21 + 4 >> 2] | 0;
  i20 = HEAP32[i21 + 8 >> 2] | 0;
  i21 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  HEAP32[i38 + 12 >> 2] = 0;
  i48 = i18 + 1454627760 | 0;
  i46 = i19 + 1454627760 | 0;
  i44 = i20 + 1454627760 | 0;
  i42 = i21 + 1454627760 | 0;
  i47 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i45 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
  i26 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
  i48 = i48 << 11 ^ i48;
  i46 = i46 << 11 ^ i46;
  i44 = i44 << 11 ^ i44;
  i42 = i42 << 11 ^ i42;
  f22 = Math_fround(Math_fround((i47 ^ i48 ^ i48 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f23 = Math_fround(Math_fround((i45 ^ i46 ^ i46 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f24 = Math_fround(Math_fround((i43 ^ i44 ^ i44 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f25 = Math_fround(Math_fround((i26 ^ i42 ^ i42 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i39 >> 2] = f22;
  HEAPF32[i31 >> 2] = f23;
  HEAPF32[i32 >> 2] = f24;
  HEAPF32[i33 >> 2] = f25;
  i26 = HEAP32[i34 >> 2] | 0;
  L6 : do switch ((i26 & 65535) << 16 >> 16) {
  case 0:
   {
    i48 = HEAP32[i15 >> 2] | 0;
    HEAP32[i14 >> 2] = i48;
    HEAP32[i13 >> 2] = i48;
    HEAP32[i12 >> 2] = i48;
    HEAP32[i37 >> 2] = i48;
    break;
   }
  case 3:
   {
    f50 = Math_fround(HEAPF32[(HEAP32[i16 >> 2] | 0) + 4 >> 2]);
    f49 = Math_fround(HEAPF32[i15 >> 2]);
    f50 = Math_fround(f50 * f49);
    f49 = Math_fround(Math_fround(f49 * Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + 4 >> 2])) - f50);
    f23 = Math_fround(f50 + Math_fround(f49 * f23));
    f24 = Math_fround(f50 + Math_fround(f49 * f24));
    f25 = Math_fround(f50 + Math_fround(f25 * f49));
    HEAPF32[i37 >> 2] = Math_fround(f50 + Math_fround(f22 * f49));
    HEAPF32[i12 >> 2] = f23;
    HEAPF32[i13 >> 2] = f24;
    HEAPF32[i14 >> 2] = f25;
    break;
   }
  default:
   if (!(i26 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i37, i35, i38, i39);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i37, i35, i38, i39);
    break L6;
   }
  } while (0);
  i47 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f50 = Math_fround(HEAPF32[i47 >> 2]);
  f24 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f24 = Math_fround(f24 * Math_fround(.00999999977));
  f25 = Math_fround(f25 * Math_fround(.00999999977));
  f49 = Math_fround(Math_fround(HEAPF32[i47 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i39 >> 2] = Math_fround(f50 * Math_fround(.00999999977));
  HEAPF32[i3 >> 2] = f24;
  HEAPF32[i4 >> 2] = f25;
  HEAPF32[i5 >> 2] = f49;
  i47 = i18 + 326370691 | 0;
  i26 = i19 + 326370691 | 0;
  i43 = i20 + 326370691 | 0;
  i45 = i21 + 326370691 | 0;
  i48 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i26, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
  i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i47 = i47 << 11 ^ i47;
  i26 = i26 << 11 ^ i26;
  i43 = i43 << 11 ^ i43;
  i45 = i45 << 11 ^ i45;
  f49 = Math_fround(Math_fround((i42 ^ i26 ^ i26 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f25 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f24 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i40 >> 2] = Math_fround(Math_fround((i48 ^ i47 ^ i47 >>> 8) & 8388607 ^ i48 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i6 >> 2] = f49;
  HEAPF32[i7 >> 2] = f25;
  HEAPF32[i8 >> 2] = f24;
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i38, i28, i39, i40);
  f24 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * f27);
  f25 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f27);
  f49 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f27);
  f50 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f27);
  i48 = i36 + (i1 << 2) | 0;
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i37 >> 2]));
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i12 >> 2]));
  f49 = Math_fround(f49 + Math_fround(HEAPF32[i13 >> 2]));
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i14 >> 2]));
  f25 = Math_fround(f25 - Math_fround(Math_floor(Math_fround(f25))));
  f49 = Math_fround(f49 - Math_fround(Math_floor(Math_fround(f49))));
  f50 = Math_fround(f50 - Math_fround(Math_floor(Math_fround(f50))));
  HEAPF32[i48 >> 2] = Math_fround(f24 - Math_fround(Math_floor(Math_fround(f24))));
  HEAPF32[i48 + 4 >> 2] = f25;
  HEAPF32[i48 + 8 >> 2] = f49;
  HEAPF32[i48 + 12 >> 2] = f50;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i29 >>> 0);
 STACKTOP = i41;
 return;
}

function __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i14, i8, f12, i7, i13, i10, i11) {
 i14 = i14 | 0;
 i8 = i8 | 0;
 f12 = Math_fround(f12);
 i7 = i7 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 264 | 0;
 i15 = i16;
 i3 = i16 + 252 | 0;
 i4 = i16 + 240 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i1 = i6 + 16 | 0;
 i5 = i6 + 8 | 0;
 i6 = i6 + 12 | 0;
 if (f12 == Math_fround(0.0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i17 >> 2] = gb + 85388 + 32;
  HEAP32[i15 + 8 >> 2] = i13;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i11;
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  i31 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i31;
  i5 = i14 + 4 | 0;
  i30 = HEAP32[i5 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i30;
  i6 = i14 + 8 | 0;
  i29 = HEAP32[i6 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i29;
  i28 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i28;
  i27 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i27;
  i26 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i26;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f12;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i7 = i15 + 84 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i10 + 4 >> 2] | 0) == 1 & 1;
  i10 = i15 + 180 | 0;
  HEAP8[i10 >> 0] = 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 4 >> 2] | 0;
  i11 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i15 + 192 >> 2] = i7;
  HEAP32[i15 + 196 >> 2] = i8;
  HEAP32[i15 + 200 >> 2] = i11;
  HEAPF32[i15 + 204 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 208 >> 2] = i31;
  HEAP32[i15 + 212 >> 2] = i30;
  HEAP32[i15 + 216 >> 2] = i29;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i28;
  HEAP32[i15 + 228 >> 2] = i27;
  HEAP32[i15 + 232 >> 2] = i26;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  f25 = Math_fround(f19 - f20);
  f18 = Math_fround(HEAPF32[i5 >> 2]);
  f24 = Math_fround(f18 - f22);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  f23 = Math_fround(f12 - f21);
  HEAPF32[i3 >> 2] = f25;
  HEAPF32[i3 + 4 >> 2] = f24;
  HEAPF32[i3 + 8 >> 2] = f23;
  f18 = Math_fround(f22 + f18);
  f12 = Math_fround(f21 + f12);
  HEAPF32[i4 >> 2] = Math_fround(f20 + f19);
  HEAPF32[i4 + 4 >> 2] = f18;
  HEAPF32[i4 + 8 >> 2] = f12;
  __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i13, i3, i4, 4, i9, i15 + 4 | 0);
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i17 >> 2] = gb + 85388 + 32;
  if (HEAP8[i10 >> 0] | 0) {
   i31 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  i30 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 85436 + 8;
  HEAP32[i30 >> 2] = gb + 85436 + 32;
  HEAP32[i15 + 8 >> 2] = i13;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i11;
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i17;
  i26 = HEAP32[i14 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i26;
  i27 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i27;
  i28 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i28;
  i29 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i29;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f12;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i31 = i15 + 84 | 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = 0;
  HEAP32[i31 + 16 >> 2] = 0;
  HEAP32[i31 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i10 + 4 >> 2] | 0) == 1 & 1;
  i31 = i15 + 180 | 0;
  HEAP8[i31 >> 0] = 0;
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i15 + 192 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i15 + 196 >> 2] = i7;
  HEAP32[i15 + 200 >> 2] = i10;
  HEAPF32[i15 + 204 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 208 >> 2] = i6;
  HEAP32[i15 + 212 >> 2] = i17;
  HEAP32[i15 + 216 >> 2] = i26;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i27;
  HEAP32[i15 + 228 >> 2] = i28;
  HEAP32[i15 + 232 >> 2] = i29;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  __ZNK5physx2Gu5RTree11traverseRayILi1EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(HEAP32[i13 + 4 >> 2] | 0, i14, i8, 4, i9, i15, i11, f12);
  HEAP32[i15 >> 2] = gb + 85436 + 8;
  HEAP32[i30 >> 2] = gb + 85436 + 32;
  if (HEAP8[i31 >> 0] | 0) {
   i31 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx2Gu15MeshRayCollider7collideILi1ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i14, i8, f12, i7, i13, i10, i11) {
 i14 = i14 | 0;
 i8 = i8 | 0;
 f12 = Math_fround(f12);
 i7 = i7 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 264 | 0;
 i15 = i16;
 i3 = i16 + 252 | 0;
 i4 = i16 + 240 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i1 = i6 + 16 | 0;
 i5 = i6 + 8 | 0;
 i6 = i6 + 12 | 0;
 if (f12 == Math_fround(0.0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i17 >> 2] = gb + 85388 + 32;
  HEAP32[i15 + 8 >> 2] = i13;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i11;
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  i31 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i31;
  i5 = i14 + 4 | 0;
  i30 = HEAP32[i5 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i30;
  i6 = i14 + 8 | 0;
  i29 = HEAP32[i6 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i29;
  i28 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i28;
  i27 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i27;
  i26 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i26;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f12;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i7 = i15 + 84 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i10 + 4 >> 2] | 0) == 1 & 1;
  i10 = i15 + 180 | 0;
  HEAP8[i10 >> 0] = 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 4 >> 2] | 0;
  i11 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i15 + 192 >> 2] = i7;
  HEAP32[i15 + 196 >> 2] = i8;
  HEAP32[i15 + 200 >> 2] = i11;
  HEAPF32[i15 + 204 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 208 >> 2] = i31;
  HEAP32[i15 + 212 >> 2] = i30;
  HEAP32[i15 + 216 >> 2] = i29;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i28;
  HEAP32[i15 + 228 >> 2] = i27;
  HEAP32[i15 + 232 >> 2] = i26;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  f20 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  f25 = Math_fround(f19 - f20);
  f18 = Math_fround(HEAPF32[i5 >> 2]);
  f24 = Math_fround(f18 - f22);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  f23 = Math_fround(f12 - f21);
  HEAPF32[i3 >> 2] = f25;
  HEAPF32[i3 + 4 >> 2] = f24;
  HEAPF32[i3 + 8 >> 2] = f23;
  f18 = Math_fround(f22 + f18);
  f12 = Math_fround(f21 + f12);
  HEAPF32[i4 >> 2] = Math_fround(f20 + f19);
  HEAPF32[i4 + 4 >> 2] = f18;
  HEAPF32[i4 + 8 >> 2] = f12;
  __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i13, i3, i4, 4, i9, i15 + 4 | 0);
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i17 >> 2] = gb + 85388 + 32;
  if (HEAP8[i10 >> 0] | 0) {
   i31 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  i30 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i30 >> 2] = gb + 85388 + 32;
  HEAP32[i15 + 8 >> 2] = i13;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i11;
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i17;
  i26 = HEAP32[i14 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i26;
  i27 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i27;
  i28 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i28;
  i29 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i29;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f12;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i31 = i15 + 84 | 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = 0;
  HEAP32[i31 + 16 >> 2] = 0;
  HEAP32[i31 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i10 + 4 >> 2] | 0) == 1 & 1;
  i31 = i15 + 180 | 0;
  HEAP8[i31 >> 0] = 0;
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i15 + 192 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i15 + 196 >> 2] = i7;
  HEAP32[i15 + 200 >> 2] = i10;
  HEAPF32[i15 + 204 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 208 >> 2] = i6;
  HEAP32[i15 + 212 >> 2] = i17;
  HEAP32[i15 + 216 >> 2] = i26;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i27;
  HEAP32[i15 + 228 >> 2] = i28;
  HEAP32[i15 + 232 >> 2] = i29;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  __ZNK5physx2Gu5RTree11traverseRayILi1EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(HEAP32[i13 + 4 >> 2] | 0, i14, i8, 4, i9, i15, i11, f12);
  HEAP32[i15 >> 2] = gb + 85388 + 8;
  HEAP32[i30 >> 2] = gb + 85388 + 32;
  if (HEAP8[i31 >> 0] | 0) {
   i31 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i31 >> 2] >> 2] | 0, i31 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx2Gu18contactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i12, i4, i13, i7, i1, i15) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 1032 | 0;
 i3 = i14 + 104 | 0;
 i11 = i14 + 12 | 0;
 i6 = i14 + 128 | 0;
 i10 = i14 + 40 | 0;
 i8 = i14;
 i1 = i12 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i12 + 8 >> 2]) == Math_fround(1.0)) i5 = Math_fround(HEAPF32[i12 + 12 >> 2]) == Math_fround(1.0); else i5 = 0; else i5 = 0;
 HEAP32[i9 >> 2] = 1065353216;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 1065353216;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 1065353216;
 HEAP32[i9 + 36 >> 2] = 1065353216;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 1065353216;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 68 >> 2] = 1065353216;
 if (!i5) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i9, i1, i12 + 16 | 0);
 f31 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(f31 * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f27 = Math_fround(f18 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f31 * f25) + Math_fround(Math_fround(f18 * f27) + Math_fround(-1.0)));
 f31 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f19 = Math_fround(f31 * f27);
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f25 * f17));
 f17 = Math_fround(Math_fround(f25 * f31) - Math_fround(f27 * f17));
 f27 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f27 * f18);
 f19 = Math_fround(f27 * f19);
 f17 = Math_fround(f27 * f17);
 f27 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f31 = Math_fround(f27 + f18);
 f25 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f32 = Math_fround(f25 + f19);
 f16 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f33 = Math_fround(f17 + f16);
 f18 = Math_fround(f27 - f18);
 f19 = Math_fround(f25 - f19);
 f17 = Math_fround(f16 - f17);
 i1 = i2 + 4 | 0;
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i7 >> 2]));
 f25 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f31 = Math_fround(f31 - f25);
 f27 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 f32 = Math_fround(f32 - f27);
 f30 = Math_fround(HEAPF32[i13 + 24 >> 2]);
 f31 = Math_fround(f31 * Math_fround(2.0));
 f32 = Math_fround(f32 * Math_fround(2.0));
 f33 = Math_fround(Math_fround(f33 - f30) * Math_fround(2.0));
 f28 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f29 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f26 = Math_fround(HEAPF32[i13 >> 2]);
 f20 = Math_fround(f31 * f26);
 f24 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f32 * f24));
 f23 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f33 * f23));
 f22 = Math_fround(Math_fround(f26 * f20) + Math_fround(Math_fround(f31 * f29) - Math_fround(f28 * Math_fround(Math_fround(f33 * f24) - Math_fround(f32 * f23)))));
 f21 = Math_fround(Math_fround(f24 * f20) + Math_fround(Math_fround(f32 * f29) - Math_fround(f28 * Math_fround(Math_fround(f31 * f23) - Math_fround(f33 * f26)))));
 f20 = Math_fround(Math_fround(Math_fround(f33 * f29) - Math_fround(f28 * Math_fround(Math_fround(f32 * f26) - Math_fround(f31 * f24)))) + Math_fround(f23 * f20));
 f25 = Math_fround(Math_fround(f18 - f25) * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f19 - f27) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(f17 - f30) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(f25 * f26) + Math_fround(f27 * f24)) + Math_fround(f30 * f23));
 f19 = Math_fround(Math_fround(f26 * f17) + Math_fround(Math_fround(f25 * f29) - Math_fround(f28 * Math_fround(Math_fround(f30 * f24) - Math_fround(f27 * f23)))));
 f18 = Math_fround(Math_fround(f24 * f17) + Math_fround(Math_fround(f27 * f29) - Math_fround(f28 * Math_fround(Math_fround(f25 * f23) - Math_fround(f30 * f26)))));
 f17 = Math_fround(Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24)))) + Math_fround(f23 * f17));
 HEAPF32[i3 >> 2] = f22;
 HEAPF32[i3 + 4 >> 2] = f21;
 HEAPF32[i3 + 8 >> 2] = f20;
 HEAPF32[i3 + 12 >> 2] = f19;
 HEAPF32[i3 + 16 >> 2] = f18;
 HEAPF32[i3 + 20 >> 2] = f17;
 HEAPF32[i11 >> 2] = f22;
 HEAPF32[i11 + 4 >> 2] = f21;
 HEAPF32[i11 + 8 >> 2] = f20;
 HEAPF32[i11 + 12 >> 2] = f19;
 HEAPF32[i11 + 16 >> 2] = f18;
 HEAPF32[i11 + 20 >> 2] = f17;
 HEAPF32[i11 + 24 >> 2] = f16;
 i2 = HEAP32[i12 + 40 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 2;
 HEAP32[i6 >> 2] = gb + 84436 + 8;
 HEAP32[i6 + 8 >> 2] = i15;
 HEAP32[i6 + 12 >> 2] = i13;
 HEAP32[i6 + 16 >> 2] = i3;
 HEAPF32[i6 + 20 >> 2] = f16;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i1;
 HEAP32[i6 + 32 >> 2] = i12;
 HEAP32[i6 + 36 >> 2] = i9;
 HEAP8[i6 + 40 >> 0] = i5 & 1;
 i1 = i6 + 892 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 896 >> 2] = i2;
 __ZN5physx2Gu3Box6createERKNS0_7CapsuleE(i10, i11);
 if (!i5) __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i9, i10 + 36 | 0, i10 + 48 | 0, i10);
 HEAP32[i8 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i8 + 4 >> 2] = i2 + 32;
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i10, 1, i8, i6, 1);
 if (!(HEAP32[i1 >> 2] | 0)) {
  i15 = i15 + 4096 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i15 = (i15 | 0) != 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE(i6 + 8 | 0, i6 + 44 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i15 = i15 + 4096 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i15 = (i15 | 0) != 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i13, i1, i15, i16) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 8 | 0;
 i14 = i18;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 0:
  {
   f2 = Math_fround(HEAPF32[i15 + 12 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f5 = Math_fround(f2 * f19);
   f3 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f5 = Math_fround(Math_fround(f5 - Math_fround(f3 * f6)) + Math_fround(HEAPF32[i15 >> 2]));
   f6 = Math_fround(Math_fround(Math_fround(f19 * f3) + Math_fround(f2 * f6)) + Math_fround(HEAPF32[i15 + 4 >> 2]));
   HEAPF32[i17 >> 2] = f5;
   HEAPF32[i17 + 4 >> 2] = f6;
   f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f5 = Math_fround(f3 + Math_fround(f2 * Math_fround(0.0)));
   HEAPF32[i14 >> 2] = Math_fround(f2 - Math_fround(f3 * Math_fround(0.0)));
   HEAPF32[i14 + 4 >> 2] = f5;
   i15 = HEAP32[i13 + 102988 >> 2] | 0;
   mftCall_viifii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, i15 | 0, i17 | 0, +f6, i14 | 0, i16 | 0);
   STACKTOP = i18;
   return;
  }
 case 1:
  {
   f20 = Math_fround(HEAPF32[i15 + 12 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f3 = Math_fround(f20 * f19);
   f5 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f21 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f3 = Math_fround(f3 - Math_fround(f5 * f21));
   f2 = Math_fround(HEAPF32[i15 >> 2]);
   f3 = Math_fround(f2 + f3);
   f21 = Math_fround(Math_fround(f19 * f5) + Math_fround(f20 * f21));
   f19 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f21 = Math_fround(f21 + f19);
   HEAPF32[i17 >> 2] = f3;
   HEAPF32[i17 + 4 >> 2] = f21;
   i15 = i1 + 20 | 0;
   f21 = Math_fround(HEAPF32[i15 >> 2]);
   f3 = Math_fround(f20 * f21);
   f6 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f19 = Math_fround(Math_fround(Math_fround(f21 * f5) + Math_fround(f20 * f6)) + f19);
   HEAPF32[i14 >> 2] = Math_fround(f2 + Math_fround(f3 - Math_fround(f5 * f6)));
   HEAPF32[i14 + 4 >> 2] = f19;
   i15 = HEAP32[i13 + 102988 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 32 >> 2] | 0, i15 | 0, i17 | 0, i14 | 0, i16 | 0);
   STACKTOP = i18;
   return;
  }
 case 3:
  {
   i12 = HEAP32[i1 + 16 >> 2] | 0;
   i8 = HEAP32[i1 + 12 >> 2] | 0;
   i9 = i15 + 12 | 0;
   f5 = Math_fround(HEAPF32[i9 >> 2]);
   f2 = Math_fround(HEAPF32[i8 >> 2]);
   f20 = Math_fround(f5 * f2);
   i10 = i15 + 8 | 0;
   f6 = Math_fround(HEAPF32[i10 >> 2]);
   f21 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f20 = Math_fround(f20 - Math_fround(f6 * f21));
   f3 = Math_fround(HEAPF32[i15 >> 2]);
   f20 = Math_fround(f3 + f20);
   f21 = Math_fround(Math_fround(f2 * f6) + Math_fround(f5 * f21));
   i11 = i15 + 4 | 0;
   f2 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(f21 + f2);
   HEAPF32[i17 >> 2] = f20;
   HEAPF32[i17 + 4 >> 2] = f21;
   L7 : do if ((i12 | 0) > 1) {
    i7 = i14 + 4 | 0;
    i4 = i13 + 102988 | 0;
    i1 = 1;
    while (1) {
     f21 = Math_fround(HEAPF32[i8 + (i1 << 3) >> 2]);
     f19 = Math_fround(f5 * f21);
     f20 = Math_fround(HEAPF32[i8 + (i1 << 3) + 4 >> 2]);
     f21 = Math_fround(Math_fround(Math_fround(f21 * f6) + Math_fround(f5 * f20)) + f2);
     HEAPF32[i14 >> 2] = Math_fround(f3 + Math_fround(f19 - Math_fround(f6 * f20)));
     HEAPF32[i7 >> 2] = f21;
     i23 = HEAP32[i4 >> 2] | 0;
     mftCall_viiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 32 >> 2] | 0, i23 | 0, i17 | 0, i14 | 0, i16 | 0);
     i23 = HEAP32[i4 >> 2] | 0;
     mftCall_viifi(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0, i23 | 0, i17 | 0, .0500000007, i16 | 0);
     i23 = i14;
     i22 = HEAP32[i23 + 4 >> 2] | 0;
     i13 = i17;
     HEAP32[i13 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i13 + 4 >> 2] = i22;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i12 | 0)) break L7;
     f5 = Math_fround(HEAPF32[i9 >> 2]);
     f6 = Math_fround(HEAPF32[i10 >> 2]);
     f3 = Math_fround(HEAPF32[i15 >> 2]);
     f2 = Math_fround(HEAPF32[i11 >> 2]);
    }
   } while (0);
   STACKTOP = i18;
   return;
  }
 case 2:
  {
   i7 = HEAP32[i1 + 148 >> 2] | 0;
   if ((i7 | 0) > 0) {
    i4 = i1 + 20 | 0;
    f5 = Math_fround(HEAPF32[i15 + 12 >> 2]);
    f6 = Math_fround(HEAPF32[i15 + 8 >> 2]);
    f3 = Math_fround(HEAPF32[i15 >> 2]);
    f2 = Math_fround(HEAPF32[i15 + 4 >> 2]);
    i1 = 0;
    do {
     f21 = Math_fround(HEAPF32[i4 + (i1 << 3) >> 2]);
     f19 = Math_fround(f5 * f21);
     f20 = Math_fround(HEAPF32[i4 + (i1 << 3) + 4 >> 2]);
     f21 = Math_fround(Math_fround(Math_fround(f21 * f6) + Math_fround(f5 * f20)) + f2);
     HEAPF32[i17 + (i1 << 3) >> 2] = Math_fround(f3 + Math_fround(f19 - Math_fround(f6 * f20)));
     HEAPF32[i17 + (i1 << 3) + 4 >> 2] = f21;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i7 | 0));
   }
   i23 = HEAP32[i13 + 102988 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i17 | 0, i7 | 0, i16 | 0);
   STACKTOP = i18;
   return;
  }
 case 4:
  {
   f3 = Math_fround(HEAPF32[i15 + 12 >> 2]);
   f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f6 = Math_fround(f3 * f21);
   f19 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f6 = Math_fround(f6 - Math_fround(f19 * f2));
   f5 = Math_fround(HEAPF32[i15 >> 2]);
   f6 = Math_fround(f5 + f6);
   f2 = Math_fround(Math_fround(f21 * f19) + Math_fround(f3 * f2));
   f21 = Math_fround(HEAPF32[i15 + 4 >> 2]);
   f2 = Math_fround(f2 + f21);
   HEAPF32[i17 >> 2] = f6;
   HEAPF32[i17 + 4 >> 2] = f2;
   i23 = i1 + 20 | 0;
   f2 = Math_fround(HEAPF32[i23 >> 2]);
   f6 = Math_fround(f3 * f2);
   f20 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   f21 = Math_fround(Math_fround(Math_fround(f2 * f19) + Math_fround(f3 * f20)) + f21);
   HEAPF32[i14 >> 2] = Math_fround(f5 + Math_fround(f6 - Math_fround(f19 * f20)));
   HEAPF32[i14 + 4 >> 2] = f21;
   f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i23 = HEAP32[i13 + 102988 >> 2] | 0;
   mftCall_viiifi(HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] | 0, i23 | 0, i17 | 0, i14 | 0, +f21, i16 | 0);
   STACKTOP = i18;
   return;
  }
 default:
  {
   STACKTOP = i18;
   return;
  }
 }
}

function __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE9propagateERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialERKNS_6shdfnd3aos6Mat33VENSA_6FloatVE(i3, i1, i2, i5, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i6 + 144 | 0;
 i7 = i6 + 48 | 0;
 i38 = i6;
 __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_(i38, i1, i2, i37);
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f27 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i4 >> 2]);
 f36 = Math_fround(HEAPF32[i38 >> 2]);
 i4 = i38 + 4 | 0;
 f35 = Math_fround(HEAPF32[i4 >> 2]);
 i39 = i38 + 8 | 0;
 f36 = Math_fround(Math_fround(f14 * f26) + f36);
 f35 = Math_fround(Math_fround(f27 * f26) + f35);
 f17 = Math_fround(Math_fround(f17 * f26) + Math_fround(HEAPF32[i39 >> 2]));
 HEAPF32[i38 >> 2] = f36;
 HEAPF32[i4 >> 2] = f35;
 HEAPF32[i39 >> 2] = f17;
 HEAPF32[i38 + 12 >> 2] = Math_fround(0.0);
 f27 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 i39 = i38 + 16 | 0;
 f16 = Math_fround(HEAPF32[i39 >> 2]);
 i4 = i38 + 20 | 0;
 f34 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i38 + 24 | 0;
 f34 = Math_fround(Math_fround(f14 * f26) + f34);
 f15 = Math_fround(Math_fround(f15 * f26) + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i39 >> 2] = Math_fround(Math_fround(f27 * f26) + f16);
 HEAPF32[i4 >> 2] = f34;
 HEAPF32[i2 >> 2] = f15;
 HEAPF32[i38 + 28 >> 2] = Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f27 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 i2 = i38 + 32 | 0;
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i38 + 36 | 0;
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i38 + 40 | 0;
 f18 = Math_fround(Math_fround(f27 * f26) + f18);
 f14 = Math_fround(Math_fround(f14 * f26) + Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f16 * f26) + f28);
 HEAPF32[i4 >> 2] = f18;
 HEAPF32[i5 >> 2] = f14;
 HEAPF32[i38 + 44 >> 2] = Math_fround(0.0);
 f36 = Math_fround(Math_fround(1.0) / f36);
 i5 = f36 < Math_fround(0.0);
 f36 = Math_fround(Math_sqrt(Math_fround(i5 ? Math_fround(0.0) : f36)));
 f35 = Math_fround(f35 * f36);
 f17 = Math_fround(f17 * f36);
 f34 = Math_fround(Math_fround(1.0) / Math_fround(f34 - Math_fround(f35 * f35)));
 i5 = f34 < Math_fround(0.0);
 f34 = Math_fround(Math_sqrt(Math_fround(i5 ? Math_fround(0.0) : f34)));
 f15 = Math_fround(f34 * Math_fround(f15 - Math_fround(f35 * f17)));
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f14 - Math_fround(f15 * f15)) - Math_fround(f17 * f17)));
 i5 = f14 < Math_fround(0.0);
 f14 = Math_fround(Math_sqrt(Math_fround(i5 ? Math_fround(0.0) : f14)));
 f35 = Math_fround(Math_fround(f36 * f35) * f34);
 f17 = Math_fround(f14 * Math_fround(Math_fround(f35 * f15) - Math_fround(f36 * f17)));
 f35 = Math_fround(-f35);
 f15 = Math_fround(-Math_fround(f15 * Math_fround(f34 * f14)));
 f18 = Math_fround(HEAPF32[i37 >> 2]);
 f28 = Math_fround(HEAPF32[i37 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i37 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i37 + 32 >> 2]);
 f27 = Math_fround(HEAPF32[i37 + 36 >> 2]);
 f25 = Math_fround(HEAPF32[i37 + 40 >> 2]);
 f13 = Math_fround(HEAPF32[i37 + 64 >> 2]);
 f12 = Math_fround(HEAPF32[i37 + 68 >> 2]);
 f11 = Math_fround(HEAPF32[i37 + 72 >> 2]);
 f24 = Math_fround(HEAPF32[i37 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i37 + 20 >> 2]);
 f20 = Math_fround(HEAPF32[i37 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i37 + 48 >> 2]);
 f21 = Math_fround(HEAPF32[i37 + 52 >> 2]);
 f19 = Math_fround(HEAPF32[i37 + 56 >> 2]);
 f10 = Math_fround(HEAPF32[i37 + 80 >> 2]);
 f9 = Math_fround(HEAPF32[i37 + 84 >> 2]);
 f8 = Math_fround(HEAPF32[i37 + 88 >> 2]);
 f29 = Math_fround(f36 * f28);
 f30 = Math_fround(f36 * f26);
 f31 = Math_fround(f36 * f24);
 f32 = Math_fround(f36 * f22);
 f33 = Math_fround(f36 * f20);
 HEAPF32[i7 >> 2] = Math_fround(f36 * f18);
 HEAPF32[i7 + 4 >> 2] = f29;
 HEAPF32[i7 + 8 >> 2] = f30;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 16 >> 2] = f31;
 HEAPF32[i7 + 20 >> 2] = f32;
 HEAPF32[i7 + 24 >> 2] = f33;
 HEAPF32[i7 + 28 >> 2] = Math_fround(0.0);
 f33 = Math_fround(Math_fround(f28 * f35) + Math_fround(f34 * f27));
 f32 = Math_fround(Math_fround(f26 * f35) + Math_fround(f34 * f25));
 f31 = Math_fround(Math_fround(f24 * f35) + Math_fround(f34 * f23));
 f30 = Math_fround(Math_fround(f22 * f35) + Math_fround(f34 * f21));
 f29 = Math_fround(Math_fround(f20 * f35) + Math_fround(f34 * f19));
 HEAPF32[i7 + 32 >> 2] = Math_fround(Math_fround(f18 * f35) + Math_fround(f34 * f16));
 HEAPF32[i7 + 36 >> 2] = f33;
 HEAPF32[i7 + 40 >> 2] = f32;
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 48 >> 2] = f31;
 HEAPF32[i7 + 52 >> 2] = f30;
 HEAPF32[i7 + 56 >> 2] = f29;
 HEAPF32[i7 + 60 >> 2] = Math_fround(0.0);
 f12 = Math_fround(Math_fround(f28 * f17) + Math_fround(Math_fround(f27 * f15) + Math_fround(f14 * f12)));
 f11 = Math_fround(Math_fround(f26 * f17) + Math_fround(Math_fround(f25 * f15) + Math_fround(f14 * f11)));
 f10 = Math_fround(Math_fround(f17 * f24) + Math_fround(Math_fround(f23 * f15) + Math_fround(f14 * f10)));
 f9 = Math_fround(Math_fround(f17 * f22) + Math_fround(Math_fround(f21 * f15) + Math_fround(f14 * f9)));
 f8 = Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f19 * f15) + Math_fround(f14 * f8)));
 HEAPF32[i7 + 64 >> 2] = Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)));
 HEAPF32[i7 + 68 >> 2] = f12;
 HEAPF32[i7 + 72 >> 2] = f11;
 HEAPF32[i7 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 80 >> 2] = f10;
 HEAPF32[i7 + 84 >> 2] = f9;
 HEAPF32[i7 + 88 >> 2] = f8;
 HEAPF32[i7 + 92 >> 2] = Math_fround(0.0);
 __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialE(i3, i1, i7);
 STACKTOP = i6;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEbT0_SD_T_(i10, i9, i1) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 switch (i9 - i10 >> 3 | 0) {
 case 2:
  {
   i1 = i9 + -8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i10 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i8 = i10 + 4 | 0;
   i10 = i9 + -4 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i9;
   i10 = 1;
   return i10 | 0;
  }
 case 3:
  {
   i6 = i10 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = i9 + -8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = (i2 | 0) < (i1 | 0);
   if ((i1 | 0) >= (i4 | 0)) {
    if (!i3) {
     i10 = 1;
     return i10 | 0;
    }
    HEAP32[i6 >> 2] = i2;
    HEAP32[i5 >> 2] = i1;
    i3 = i10 + 12 | 0;
    i1 = i9 + -4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i10 = 1;
     return i10 | 0;
    }
    HEAP32[i10 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
    i9 = i10 + 4 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i3 >> 2] = i10;
    i10 = 1;
    return i10 | 0;
   }
   if (i3) {
    HEAP32[i10 >> 2] = i2;
    HEAP32[i5 >> 2] = i4;
    i8 = i10 + 4 | 0;
    i10 = i9 + -4 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i10 >> 2] = i9;
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = i4;
   i8 = i10 + 4 | 0;
   i1 = i10 + 12 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i2;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) >= (i4 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i10 = i9 + -4 | 0;
   i9 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i9;
   i10 = 1;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i10, i10 + 8 | 0, i10 + 16 | 0, i9 + -8 | 0, i1) | 0;
   i10 = 1;
   return i10 | 0;
  }
 case 5:
  {
   i7 = i10 + 8 | 0;
   i6 = i10 + 16 | 0;
   i4 = i10 + 24 | 0;
   __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i10, i7, i6, i4, i1) | 0;
   i1 = i9 + -8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i2 = i10 + 28 | 0;
   i5 = i9 + -4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i1;
   i5 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i5 | 0) >= (i1 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i6 >> 2] = i5;
   HEAP32[i4 >> 2] = i1;
   i3 = i10 + 20 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i2 >> 2] = i1;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i5 | 0) >= (i1 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i7 >> 2] = i5;
   HEAP32[i6 >> 2] = i1;
   i2 = i10 + 12 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i5 | 0) >= (i1 | 0)) {
    i10 = 1;
    return i10 | 0;
   }
   HEAP32[i10 >> 2] = i5;
   HEAP32[i7 >> 2] = i1;
   i9 = i10 + 4 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i2 >> 2] = i10;
   i10 = 1;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   return i10 | 0;
  }
 default:
  {
   i3 = i10 + 16 | 0;
   i5 = i10 + 8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i10 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   i1 = (i7 | 0) < (i2 | 0);
   do if ((i2 | 0) < (i6 | 0)) {
    if (i1) {
     HEAP32[i10 >> 2] = i7;
     HEAP32[i3 >> 2] = i6;
     i7 = i10 + 4 | 0;
     i2 = i10 + 20 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i8;
     i2 = i6;
     break;
    }
    HEAP32[i10 >> 2] = i2;
    HEAP32[i5 >> 2] = i6;
    i8 = i10 + 4 | 0;
    i1 = i10 + 12 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i2;
    if ((i7 | 0) < (i6 | 0)) {
     HEAP32[i5 >> 2] = i7;
     HEAP32[i3 >> 2] = i6;
     i8 = i10 + 20 | 0;
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i8 >> 2] = i2;
     i2 = i6;
    } else i2 = i7;
   } else if (i1) {
    HEAP32[i5 >> 2] = i7;
    HEAP32[i3 >> 2] = i2;
    i1 = i10 + 12 | 0;
    i8 = i10 + 20 | 0;
    i11 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    HEAP32[i1 >> 2] = i4;
    HEAP32[i8 >> 2] = i11;
    if ((i7 | 0) < (i6 | 0)) {
     HEAP32[i10 >> 2] = i7;
     HEAP32[i5 >> 2] = i6;
     i8 = i10 + 4 | 0;
     i11 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = i4;
     HEAP32[i1 >> 2] = i11;
    }
   } else i2 = i7; while (0);
   i1 = i10 + 24 | 0;
   L13 : do if ((i1 | 0) == (i9 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i8 = i1;
    i1 = 0;
    while (1) {
     if ((HEAP32[i8 >> 2] | 0) < (i2 | 0)) {
      i7 = i8;
      i6 = HEAP32[i7 >> 2] | 0;
      i7 = HEAP32[i7 + 4 >> 2] | 0;
      i4 = i8;
      while (1) {
       HEAP32[i4 >> 2] = i2;
       i5 = i3 + 4 | 0;
       HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
       if ((i3 | 0) == (i10 | 0)) break;
       i4 = i3 + -8 | 0;
       i2 = HEAP32[i4 >> 2] | 0;
       if ((i6 | 0) >= (i2 | 0)) break; else {
        i11 = i3;
        i3 = i4;
        i4 = i11;
       }
      }
      HEAP32[i3 >> 2] = i6;
      HEAP32[i5 >> 2] = i7;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i8 + 8 | 0) == (i9 | 0);
       break L13;
      }
     }
     i2 = i8 + 8 | 0;
     if ((i2 | 0) == (i9 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i11 = HEAP32[i8 >> 2] | 0;
     i3 = i8;
     i8 = i2;
     i2 = i11;
    }
   } while (0);
   i11 = i1 | i2;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_(i4, i5, i6, i7, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i8 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i6 >> 2] | 0) < (i8 | 0);
 do if ((i8 | 0) < (HEAP32[i4 >> 2] | 0)) {
  if (i1) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = 1;
   break;
  };
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  if ((HEAP32[i6 >> 2] | 0) < (HEAP32[i5 >> 2] | 0)) {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  if ((HEAP32[i5 >> 2] | 0) < (HEAP32[i4 >> 2] | 0)) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if ((HEAP32[i7 >> 2] | 0) >= (HEAP32[i6 >> 2] | 0)) {
  i8 = i1;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 if ((HEAP32[i6 >> 2] | 0) >= (HEAP32[i5 >> 2] | 0)) {
  i8 = i1 + 1 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 if ((HEAP32[i5 >> 2] | 0) >= (HEAP32[i4 >> 2] | 0)) {
  i8 = i1 + 2 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 i8 = i1 + 3 | 0;
 STACKTOP = i3;
 return i8 | 0;
}

function __ZN8Material8TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i23 + 52 | 0;
 i17 = i23 + 48 | 0;
 i18 = i23 + 40 | 0;
 i19 = i23 + 24 | 0;
 i20 = i23 + 12 | 0;
 i21 = i23;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i16);
 __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i15 + 32 | 0, i16);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i16, i15 + 80 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i16);
 i4 = i15 + 96 | 0;
 i6 = i16 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i16 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i4, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
 }
 i1 = i15 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 + 12 >> 2] = 0;
 i13 = i19 + 4 | 0;
 HEAP32[i19 >> 2] = i13;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i16, i19, 0);
 i1 = i15 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 185) | 0;
  __ZN18SharedMaterialDataC2Ev(i2);
  HEAP32[i1 >> 2] = i2;
 }
 i1 = HEAP32[i2 + 176 >> 2] | 0;
 i12 = i2 + 180 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i13 | 0)) {
  i22 = i15 + 44 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = i15 + 56 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = i15 + 68 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i16, i22, 0);
  i22 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i19, i22);
  STACKTOP = i23;
  return;
 }
 i10 = i2 + 176 | 0;
 i11 = i18 + 4 | 0;
 while (1) {
  i2 = i3 + 32 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  if (i4 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i3 + 36 >> 2] | 0;
  } else i4 = i4 & 255;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, i2, i4);
  i9 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i20) | 0;
  i2 = i3 + 16 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  if (i4 << 24 >> 24 < 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i3 + 20 >> 2] | 0;
  } else {
   i5 = i2;
   i2 = i4 & 255;
  };
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i21, i5, i2);
  i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i21) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i2 = i8 - i3 >> 3;
  if (!i2) i2 = i3; else {
   i6 = i2;
   i2 = i3;
   while (1) {
    i24 = (i6 | 0) / 2 | 0;
    i5 = i3 + (i24 << 3) | 0;
    i4 = (HEAP32[i5 >> 2] | 0) < (i7 | 0);
    i5 = i5 + 8 | 0;
    i2 = i4 ? i5 : i2;
    i6 = i4 ? i6 + -1 - i24 | 0 : i24;
    if (!i6) break; else i3 = i4 ? i5 : i3;
   }
  }
  i3 = i2;
  if ((i2 | 0) == (i8 | 0)) i22 = 23; else if ((i7 | 0) < (HEAP32[i2 >> 2] | 0)) i22 = 23;
  if ((i22 | 0) == 23) {
   i22 = 0;
   HEAP32[i17 >> 2] = i3;
   HEAP32[i18 >> 2] = i7;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
   i2 = __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i10, i14, i18) | 0;
  }
  HEAP32[i2 + 4 >> 2] = i9;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i13 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 i24 = i15 + 44 | 0;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = i15 + 56 | 0;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = i15 + 68 | 0;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i16, i24, 0);
 i24 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i19, i24);
 STACKTOP = i23;
 return;
}

function __ZNSt3__218__insertion_sort_3IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 16 | 0;
 i11 = i13;
 i3 = i14 + 80 | 0;
 i7 = i14 + 40 | 0;
 i4 = i14 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i14 + 16 >> 2] | 0;
 if (i1 >>> 0 < i6 >>> 0) i2 = 1; else if ((i1 | 0) == (i6 | 0)) i2 = (HEAP32[i14 + 64 >> 2] | 0) >>> 0 < (HEAP32[i14 + 24 >> 2] | 0) >>> 0; else i2 = 0;
 i5 = HEAP32[i14 + 96 >> 2] | 0;
 if (i5 >>> 0 < i1 >>> 0) i1 = 1; else if ((i5 | 0) == (i1 | 0)) i1 = (HEAP32[i14 + 104 >> 2] | 0) >>> 0 < (HEAP32[i14 + 64 >> 2] | 0) >>> 0; else i1 = 0;
 do if (i2) {
  i8 = i12;
  i9 = i14;
  i10 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  if (i1) {
   i8 = i14;
   i9 = i3;
   i10 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i10 | 0));
   HEAP8[i14 + 36 >> 0] = HEAP8[i3 + 36 >> 0] | 0;
   i8 = i3;
   i9 = i12;
   i10 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i10 | 0));
   HEAP8[i3 + 36 >> 0] = HEAP8[i12 + 36 >> 0] | 0;
   break;
  }
  i8 = i14;
  i9 = i7;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
  i8 = i7;
  i9 = i12;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i12 + 36 >> 0] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5 >>> 0 >= i1 >>> 0) {
   if ((i5 | 0) != (i1 | 0)) break;
   if ((HEAP32[i14 + 104 >> 2] | 0) >>> 0 >= (HEAP32[i14 + 64 >> 2] | 0) >>> 0) break;
  }
  i8 = i12;
  i9 = i7;
  i10 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  i8 = i7;
  i9 = i3;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i3 + 36 >> 0] | 0;
  i8 = i3;
  i9 = i12;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i3 + 36 >> 0] = HEAP8[i12 + 36 >> 0] | 0;
 } else if (i1) {
  i8 = i12;
  i9 = i7;
  i10 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  i8 = i7;
  i9 = i3;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i3 + 36 >> 0] | 0;
  i8 = i3;
  i9 = i12;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i3 + 36 >> 0] = HEAP8[i12 + 36 >> 0] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 >>> 0 >= i6 >>> 0) {
   if ((i1 | 0) != (i6 | 0)) break;
   if ((HEAP32[i14 + 64 >> 2] | 0) >>> 0 >= (HEAP32[i14 + 24 >> 2] | 0) >>> 0) break;
  }
  i8 = i12;
  i9 = i14;
  i10 = i8 + 40 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  i8 = i14;
  i9 = i7;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i14 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
  i8 = i7;
  i9 = i12;
  i10 = i8 + 36 | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i8 = i8 + 4 | 0;
   i9 = i9 + 4 | 0;
  } while ((i8 | 0) < (i10 | 0));
  HEAP8[i7 + 36 >> 0] = HEAP8[i12 + 36 >> 0] | 0;
 } while (0);
 i1 = i14 + 120 | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i13;
  return;
 }
 while (1) {
  i7 = HEAP32[i1 + 16 >> 2] | 0;
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  if (i7 >>> 0 < i2 >>> 0) {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   i16 = 25;
  } else if ((i7 | 0) == (i2 | 0)) {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 24 >> 2] | 0) >>> 0) i16 = 25;
  }
  if ((i16 | 0) == 25) {
   i16 = 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i6 = HEAP32[i1 + 20 >> 2] | 0;
   i8 = i1 + 28 | 0;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i8 = i1;
   i9 = i3;
   i10 = i8 + 36 | 0;
   do {
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    i8 = i8 + 4 | 0;
    i9 = i9 + 4 | 0;
   } while ((i8 | 0) < (i10 | 0));
   HEAP8[i1 + 36 >> 0] = HEAP8[i3 + 36 >> 0] | 0;
   L35 : do if ((i3 | 0) == (i14 | 0)) i4 = i14; else while (1) {
    i5 = i3 + -40 | 0;
    i4 = HEAP32[i3 + -24 >> 2] | 0;
    if (i7 >>> 0 >= i4 >>> 0) {
     if ((i7 | 0) != (i4 | 0)) {
      i4 = i3;
      break L35;
     }
     if (i2 >>> 0 >= (HEAP32[i3 + -16 >> 2] | 0) >>> 0) {
      i4 = i3;
      break L35;
     }
    }
    i8 = i3;
    i9 = i5;
    i10 = i8 + 36 | 0;
    do {
     HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
     i8 = i8 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i8 | 0) < (i10 | 0));
    HEAP8[i3 + 36 >> 0] = HEAP8[i5 + 36 >> 0] | 0;
    if ((i5 | 0) == (i14 | 0)) {
     i4 = i14;
     i3 = i5;
     break;
    } else i3 = i5;
   } while (0);
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = i7;
   HEAP32[i4 + 20 >> 2] = i6;
   HEAP32[i4 + 24 >> 2] = i2;
   i10 = i4 + 28 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP8[i10 + 8 >> 0] = HEAP8[i11 + 8 >> 0] | 0;
  }
  i2 = i1 + 40 | 0;
  if ((i2 | 0) == (i15 | 0)) break; else {
   i3 = i1;
   i1 = i2;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i31 = HEAP32[i4 + 192 >> 2] | 0;
 i28 = HEAP32[i31 + 40 >> 2] | 0;
 i31 = ((HEAPU8[i31 + 38 >> 0] | 0) * 12 | 0) + ((HEAPU8[i31 + 39 >> 0] | 0) * 20 | 0) + ((HEAPU16[i31 + 36 >> 1] | 0) << 1) | 0;
 i30 = HEAP32[i4 + 200 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i30 + (i2 * 12 | 0) + 8 >> 2]);
 f13 = Math_fround(f21 * Math_fround(HEAPF32[i4 + 96 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f23 * Math_fround(HEAPF32[i4 + 112 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 128 >> 2])));
 f12 = Math_fround(f21 * Math_fround(HEAPF32[i4 + 100 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f23 * Math_fround(HEAPF32[i4 + 116 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 132 >> 2])));
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i4 + 104 >> 2]));
 f23 = Math_fround(f21 + Math_fround(f23 * Math_fround(HEAPF32[i4 + 120 >> 2])));
 f11 = Math_fround(f23 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 136 >> 2])));
 i2 = i2 * 3 | 0;
 i30 = HEAPU8[i28 + (i31 + i2) >> 0] | 0;
 i29 = HEAPU8[i28 + (i2 + 1 + i31) >> 0] | 0;
 i2 = HEAPU8[i28 + (i2 + 2 + i31) >> 0] | 0;
 f23 = Math_fround(HEAPF32[i28 + (i30 * 20 | 0) >> 2]);
 f21 = Math_fround(HEAPF32[i28 + (i30 * 20 | 0) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i28 + (i30 * 20 | 0) + 8 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 144 >> 2]);
 f18 = Math_fround(f23 * f27);
 f26 = Math_fround(HEAPF32[i4 + 148 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f21 * f26));
 f25 = Math_fround(HEAPF32[i4 + 152 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f14 * f25));
 f8 = Math_fround(HEAPF32[i4 + 160 >> 2]);
 f16 = Math_fround(f23 * f8);
 f9 = Math_fround(HEAPF32[i4 + 164 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f21 * f9));
 f24 = Math_fround(HEAPF32[i4 + 168 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f14 * f24));
 f10 = Math_fround(HEAPF32[i4 + 176 >> 2]);
 f23 = Math_fround(f23 * f10);
 f22 = Math_fround(HEAPF32[i4 + 180 >> 2]);
 f21 = Math_fround(f23 + Math_fround(f21 * f22));
 f23 = Math_fround(HEAPF32[i4 + 184 >> 2]);
 f14 = Math_fround(f21 + Math_fround(f14 * f23));
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f16 * f16)) + Math_fround(f14 * f14)))));
 f18 = Math_fround(f18 * f21);
 f16 = Math_fround(f16 * f21);
 f21 = Math_fround(f14 * f21);
 f14 = Math_fround(HEAPF32[i28 + (i29 * 20 | 0) >> 2]);
 f19 = Math_fround(HEAPF32[i28 + (i29 * 20 | 0) + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i28 + (i29 * 20 | 0) + 8 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f27 * f14) + Math_fround(f26 * f19)) + Math_fround(f25 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f14) + Math_fround(f9 * f19)) + Math_fround(f24 * f20));
 f20 = Math_fround(Math_fround(Math_fround(f10 * f14) + Math_fround(f22 * f19)) + Math_fround(f23 * f20));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f15 * f15) + Math_fround(f17 * f17))))));
 f15 = Math_fround(f15 * f19);
 f17 = Math_fround(f17 * f19);
 f19 = Math_fround(f20 * f19);
 f20 = Math_fround(HEAPF32[i28 + (i2 * 20 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i28 + (i2 * 20 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i28 + (i2 * 20 | 0) + 8 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f27 * f20) + Math_fround(f26 * f14)) + Math_fround(f25 * f7));
 f24 = Math_fround(Math_fround(Math_fround(f8 * f20) + Math_fround(f9 * f14)) + Math_fround(f24 * f7));
 f7 = Math_fround(Math_fround(Math_fround(f10 * f20) + Math_fround(f22 * f14)) + Math_fround(f23 * f7));
 f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24))))));
 f25 = Math_fround(f25 * f23);
 f24 = Math_fround(f24 * f23);
 f23 = Math_fround(f7 * f23);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f7 - Math_fround(Math_fround(f11 * f21) + Math_fround(Math_fround(f13 * f18) + Math_fround(f12 * f16))));
 f22 = Math_fround(f7 - Math_fround(Math_fround(f11 * f19) + Math_fround(Math_fround(f13 * f15) + Math_fround(f12 * f17))));
 f20 = Math_fround(f7 - Math_fround(Math_fround(f11 * f23) + Math_fround(Math_fround(f13 * f25) + Math_fround(f12 * f24))));
 f10 = Math_fround(Math_fround(f17 * f23) - Math_fround(f19 * f24));
 f9 = Math_fround(Math_fround(f19 * f25) - Math_fround(f15 * f23));
 f8 = Math_fround(Math_fround(f15 * f24) - Math_fround(f17 * f25));
 f15 = Math_fround(Math_fround(f25 * f22) - Math_fround(f15 * f20));
 f17 = Math_fround(Math_fround(f24 * f22) - Math_fround(f17 * f20));
 f20 = Math_fround(Math_fround(f23 * f22) - Math_fround(f19 * f20));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f21 * f8) + Math_fround(Math_fround(f18 * f10) + Math_fround(f16 * f9))));
 f10 = Math_fround(f19 * Math_fround(Math_fround(Math_fround(f16 * f20) - Math_fround(f21 * f17)) - Math_fround(f14 * f10)));
 f9 = Math_fround(f19 * Math_fround(Math_fround(Math_fround(f21 * f15) - Math_fround(f18 * f20)) - Math_fround(f14 * f9)));
 f8 = Math_fround(f19 * Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f8)));
 HEAPF32[i1 >> 2] = f10;
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 f10 = Math_fround(f13 - f10);
 f9 = Math_fround(f12 - f9);
 f8 = Math_fround(f11 - f8);
 HEAPF32[i4 + 48 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f8 * f8)))) - f7);
 i4 = i4 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN9rapidjson8internal8DigitGenERKNS0_5DiyFpES3_yPcPiS5_(i1, i5, i17, i18, i26, i27, i24) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i25 = 0 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
 i28 = _bitshift64Shl(1, 0, i25 | 0) | 0;
 i29 = getTempRet0() | 0;
 i8 = i5;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i19 = i1;
 i19 = _i64Subtract(i7 | 0, i8 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i19 + 4 >> 2] | 0) | 0;
 i20 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i7 | 0, i8 | 0, i25 | 0) | 0;
 getTempRet0() | 0;
 i21 = _i64Add(i28 | 0, i29 | 0, -1, -1) | 0;
 i22 = getTempRet0() | 0;
 i7 = i21 & i7;
 i8 = i22 & i8;
 if (i1 >>> 0 < 10) i5 = 1; else if (i1 >>> 0 < 100) i5 = 2; else if (i1 >>> 0 < 1e3) i5 = 3; else if (i1 >>> 0 < 1e4) i5 = 4; else if (i1 >>> 0 < 1e5) i5 = 5; else if (i1 >>> 0 < 1e6) i5 = 6; else if (i1 >>> 0 < 1e7) i5 = 7; else if (i1 >>> 0 < 1e8) i5 = 8; else i5 = i1 >>> 0 < 1e9 ? 9 : 10;
 HEAP32[i27 >> 2] = 0;
 while (1) {
  if ((i5 | 0) <= 0) {
   i23 = i5;
   i4 = i7;
   i2 = i8;
   i30 = i17;
   i31 = i18;
   break;
  }
  switch (i5 | 0) {
  case 10:
   {
    i9 = (i1 >>> 0) / 1e9 | 0;
    i11 = (i1 >>> 0) % 1e9 | 0;
    i16 = 22;
    break;
   }
  case 9:
   {
    i9 = (i1 >>> 0) / 1e8 | 0;
    i11 = (i1 >>> 0) % 1e8 | 0;
    i16 = 22;
    break;
   }
  case 8:
   {
    i9 = (i1 >>> 0) / 1e7 | 0;
    i11 = (i1 >>> 0) % 1e7 | 0;
    i16 = 22;
    break;
   }
  case 7:
   {
    i9 = (i1 >>> 0) / 1e6 | 0;
    i11 = (i1 >>> 0) % 1e6 | 0;
    i16 = 22;
    break;
   }
  case 6:
   {
    i9 = (i1 >>> 0) / 1e5 | 0;
    i11 = (i1 >>> 0) % 1e5 | 0;
    i16 = 22;
    break;
   }
  case 5:
   {
    i9 = (i1 >>> 0) / 1e4 | 0;
    i11 = (i1 >>> 0) % 1e4 | 0;
    i16 = 22;
    break;
   }
  case 4:
   {
    i9 = (i1 >>> 0) / 1e3 | 0;
    i11 = (i1 >>> 0) % 1e3 | 0;
    i16 = 22;
    break;
   }
  case 3:
   {
    i9 = (i1 >>> 0) / 100 | 0;
    i11 = (i1 >>> 0) % 100 | 0;
    i16 = 22;
    break;
   }
  case 2:
   {
    i9 = (i1 >>> 0) / 10 | 0;
    i11 = (i1 >>> 0) % 10 | 0;
    i16 = 22;
    break;
   }
  case 1:
   {
    i9 = i1;
    i11 = 0;
    i16 = 22;
    break;
   }
  default:
   {
    i14 = i1;
    i16 = 24;
   }
  }
  if ((i16 | 0) == 22) if (!i9) {
   i14 = i11;
   i16 = 24;
  } else {
   i10 = i9;
   i13 = i11;
   i15 = HEAP32[i27 >> 2] | 0;
   i16 = 25;
  }
  if ((i16 | 0) == 24) {
   i16 = 0;
   i1 = HEAP32[i27 >> 2] | 0;
   if (!i1) i12 = i14; else {
    i10 = 0;
    i13 = i14;
    i15 = i1;
    i16 = 25;
   }
  }
  if ((i16 | 0) == 25) {
   i16 = 0;
   HEAP32[i27 >> 2] = i15 + 1;
   HEAP8[i26 + i15 >> 0] = i10 + 48;
   i12 = i13;
  }
  i5 = i5 + -1 | 0;
  i3 = _bitshift64Shl(i12 | 0, 0, i25 | 0) | 0;
  i3 = _i64Add(i3 | 0, getTempRet0() | 0, i7 | 0, i8 | 0) | 0;
  i6 = getTempRet0() | 0;
  if (!(i6 >>> 0 > i18 >>> 0 | (i6 | 0) == (i18 | 0) & i3 >>> 0 > i17 >>> 0)) {
   i16 = 27;
   break;
  } else i1 = i12;
 }
 if ((i16 | 0) == 27) {
  HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + i5;
  i7 = _bitshift64Shl(HEAP32[gb + 188204 + (i5 << 2) >> 2] | 0, 0, i25 | 0) | 0;
  i8 = getTempRet0() | 0;
  i16 = _i64Subtract(i17 | 0, i18 | 0, i3 | 0, i6 | 0) | 0;
  i15 = getTempRet0() | 0;
  if (i6 >>> 0 > i20 >>> 0 | (i6 | 0) == (i20 | 0) & i3 >>> 0 >= i19 >>> 0 | (i15 >>> 0 < i8 >>> 0 | (i15 | 0) == (i8 | 0) & i16 >>> 0 < i7 >>> 0)) return;
  i9 = i26 + ((HEAP32[i27 >> 2] | 0) + -1) | 0;
  while (1) {
   i5 = i3;
   i3 = _i64Add(i3 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
   i1 = i6;
   i6 = getTempRet0() | 0;
   if (!(i6 >>> 0 < i20 >>> 0 | (i6 | 0) == (i20 | 0) & i3 >>> 0 < i19 >>> 0)) {
    i15 = _i64Subtract(i19 | 0, i20 | 0, i5 | 0, i1 | 0) | 0;
    i13 = getTempRet0() | 0;
    i16 = _i64Subtract(i3 | 0, i6 | 0, i19 | 0, i20 | 0) | 0;
    i14 = getTempRet0() | 0;
    if (!(i13 >>> 0 > i14 >>> 0 | (i13 | 0) == (i14 | 0) & i15 >>> 0 > i16 >>> 0)) {
     i16 = 40;
     break;
    }
   }
   HEAP8[i9 >> 0] = (HEAP8[i9 >> 0] | 0) + -1 << 24 >> 24;
   i16 = _i64Subtract(i17 | 0, i18 | 0, i3 | 0, i6 | 0) | 0;
   i15 = getTempRet0() | 0;
   if (i6 >>> 0 > i20 >>> 0 | (i6 | 0) == (i20 | 0) & i3 >>> 0 >= i19 >>> 0 | (i15 >>> 0 < i8 >>> 0 | (i15 | 0) == (i8 | 0) & i16 >>> 0 < i7 >>> 0)) {
    i16 = 40;
    break;
   }
  }
  if ((i16 | 0) == 40) return;
 }
 while (1) {
  i1 = ___muldi3(i4 | 0, i2 | 0, 10, 0) | 0;
  i5 = getTempRet0() | 0;
  i30 = ___muldi3(i30 | 0, i31 | 0, 10, 0) | 0;
  i31 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i5 | 0, i25 | 0) | 0;
  getTempRet0() | 0;
  i3 = HEAP32[i27 >> 2] | 0;
  if (!((i2 & 255) << 24 >> 24 == 0 & (i3 | 0) == 0)) {
   HEAP32[i27 >> 2] = i3 + 1;
   HEAP8[i26 + i3 >> 0] = i2 + 48;
  }
  i4 = i1 & i21;
  i2 = i5 & i22;
  i1 = i23 + -1 | 0;
  if (i31 >>> 0 > i2 >>> 0 | (i31 | 0) == (i2 | 0) & i30 >>> 0 > i4 >>> 0) break; else i23 = i1;
 }
 HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + i1;
 i6 = ___muldi3(HEAP32[gb + 188204 + (1 - i23 << 2) >> 2] | 0, 0, i19 | 0, i20 | 0) | 0;
 i7 = getTempRet0() | 0;
 i25 = _i64Subtract(i30 | 0, i31 | 0, i4 | 0, i2 | 0) | 0;
 i24 = getTempRet0() | 0;
 if (i24 >>> 0 < i29 >>> 0 | (i24 | 0) == (i29 | 0) & i25 >>> 0 < i28 >>> 0 | (i2 >>> 0 > i7 >>> 0 | (i2 | 0) == (i7 | 0) & i4 >>> 0 >= i6 >>> 0)) return;
 i5 = i26 + ((HEAP32[i27 >> 2] | 0) + -1) | 0;
 while (1) {
  i1 = i4;
  i4 = _i64Add(i4 | 0, i2 | 0, i28 | 0, i29 | 0) | 0;
  i3 = i2;
  i2 = getTempRet0() | 0;
  if (!(i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0)) {
   i26 = _i64Subtract(i6 | 0, i7 | 0, i1 | 0, i3 | 0) | 0;
   i24 = getTempRet0() | 0;
   i27 = _i64Subtract(i4 | 0, i2 | 0, i6 | 0, i7 | 0) | 0;
   i25 = getTempRet0() | 0;
   if (!(i24 >>> 0 > i25 >>> 0 | (i24 | 0) == (i25 | 0) & i26 >>> 0 > i27 >>> 0)) {
    i16 = 40;
    break;
   }
  }
  HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) + -1 << 24 >> 24;
  i27 = _i64Subtract(i30 | 0, i31 | 0, i4 | 0, i2 | 0) | 0;
  i26 = getTempRet0() | 0;
  if (i2 >>> 0 > i7 >>> 0 | (i2 | 0) == (i7 | 0) & i4 >>> 0 >= i6 >>> 0 | (i26 >>> 0 < i29 >>> 0 | (i26 | 0) == (i29 | 0) & i27 >>> 0 < i28 >>> 0)) {
   i16 = 40;
   break;
  }
 }
 if ((i16 | 0) == 40) return;
}

function __ZN5physx16PxsIslandManager12resizeArraysEv(i38) {
 i38 = i38 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i39 + 3 | 0;
 i9 = i39 + 2 | 0;
 i5 = i39 + 1 | 0;
 i8 = i39;
 i2 = __ZN5physx16PxsIslandManager43computeChangeToNumEdgeReferencesToKinematicEv(i38) | 0;
 i18 = i38 + 468 | 0;
 i2 = (HEAP32[i18 >> 2] | 0) + i2 | 0;
 HEAP32[i18 >> 2] = i2;
 i2 = i2 + (HEAP32[i38 + 452 >> 2] | 0) | 0;
 i18 = i38 + 472 | 0;
 HEAP32[i18 >> 2] = i2;
 i1 = HEAP32[i38 + 32 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i37 = i38 + 24 | 0;
  __ZN5physx11NodeManager6resizeEj(i38 + 12 | 0, 31 - i1 + i2 + (HEAP32[i37 >> 2] | 0) & -32);
  i1 = i37;
  i2 = HEAP32[i18 >> 2] | 0;
 } else i1 = i38 + 24 | 0;
 i23 = HEAP32[i1 >> 2] | 0;
 i24 = i23 >>> 5;
 i21 = HEAP32[i38 + 456 >> 2] | 0;
 i25 = HEAP32[i38 + 460 >> 2] | 0;
 i26 = i25 + i21 | 0;
 i27 = i26 + (HEAP32[i38 + 464 >> 2] | 0) | 0;
 i16 = i38 + 444 | 0;
 i28 = HEAP32[i16 >> 2] | 0;
 i19 = i38 + 448 | 0;
 i29 = HEAP32[i19 >> 2] | 0;
 i30 = i29 + i28 | 0;
 i31 = i30 + i2 | 0;
 i32 = (i23 << 2) + 15 & -16;
 i10 = (i30 << 2) + 15 & -16;
 i11 = (i27 << 3) + 15 & -16;
 i17 = (i28 << 2) + 15 & -16;
 i12 = (i2 << 2) + 15 & -16;
 i20 = (i29 << 2) + 15 & -16;
 i22 = i21 << 4;
 i33 = i25 << 4;
 i34 = (i31 << 4) + 31 | 0;
 i35 = i24 << 2;
 i36 = i35 + 15 & 1073741808;
 i13 = i32 + i22 + i33 + i11 + i17 + i10 + i12 + (i34 & -16) + (i20 << 1) | 0;
 i14 = i32 << 1;
 i15 = i32 * 3 | 0;
 i37 = i13 + i15 | 0;
 i1 = i37 + (i36 * 3 | 0) + i15 | 0;
 i6 = i38 + 624 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do if (i1 >>> 0 > i3 >>> 0) {
  i1 = i1 + 16384 | 0;
  HEAP32[i6 >> 2] = i1;
  i4 = i38 + 628 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i3);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i1, gb + 719876 | 0, 1010) | 0;
  HEAP32[i4 >> 2] = i7;
 } else {
  if (!(i1 >>> 0 < i3 >>> 1 >>> 0 & i1 >>> 0 > 16383)) {
   i7 = HEAP32[i38 + 628 >> 2] | 0;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  i4 = i38 + 628 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i3);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, i1, gb + 719876 | 0, 1017) | 0;
  HEAP32[i4 >> 2] = i7;
 } while (0);
 HEAP32[i38 + 632 >> 2] = i7;
 HEAP32[i38 + 636 >> 2] = i7 + i32;
 HEAP32[i38 + 640 >> 2] = i7 + i14;
 i1 = i7 + i15 | 0;
 HEAP32[i38 + 480 >> 2] = i1;
 HEAP32[i38 + 484 >> 2] = i13;
 HEAP32[i38 + 488 >> 2] = i1;
 i1 = i10 + i15 | 0;
 HEAP32[i38 + 500 >> 2] = i30;
 HEAP32[i38 + 492 >> 2] = 0;
 HEAP32[i38 + 496 >> 2] = 0;
 HEAP32[i38 + 504 >> 2] = i7 + i1;
 i1 = i1 + i11 | 0;
 HEAP32[i38 + 512 >> 2] = i27;
 HEAP32[i38 + 508 >> 2] = 0;
 HEAP32[i38 + 516 >> 2] = i7 + i1;
 i1 = i1 + i32 | 0;
 HEAP32[i38 + 520 >> 2] = i23;
 HEAP32[i38 + 524 >> 2] = i7 + i1;
 i1 = i1 + i12 | 0;
 HEAP32[i38 + 532 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i38 + 528 >> 2] = 0;
 i6 = i38 + 536 | 0;
 HEAP32[i6 >> 2] = i7 + i1;
 i1 = i1 + i17 | 0;
 HEAP32[i38 + 544 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i38 + 540 >> 2] = 0;
 i4 = i38 + 548 | 0;
 HEAP32[i4 >> 2] = i7 + i1;
 i1 = i1 + i20 | 0;
 i5 = i38 + 552 | 0;
 HEAP32[i5 >> 2] = i7 + i1;
 i1 = i1 + i20 | 0;
 HEAP32[i38 + 560 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i38 + 556 >> 2] = 0;
 i3 = i38 + 564 | 0;
 HEAP32[i3 >> 2] = i7 + i1;
 i22 = i1 + i22 | 0;
 HEAP32[i38 + 572 >> 2] = i21;
 HEAP32[i38 + 568 >> 2] = 0;
 i1 = i38 + 576 | 0;
 HEAP32[i1 >> 2] = i7 + i22;
 HEAP32[i38 + 584 >> 2] = i25;
 HEAP32[i38 + 580 >> 2] = 0;
 HEAP32[i38 + 588 >> 2] = i7 + (i22 + i33);
 HEAP32[i38 + 596 >> 2] = i34 >>> 4;
 HEAP32[i38 + 592 >> 2] = 0;
 HEAP32[i38 + 600 >> 2] = 0;
 i33 = i7 + i37 | 0;
 i34 = (((i23 << 2) + 15 | 0) >>> 4 << 6) + ((((i24 << 2) + 15 | 0) >>> 4) * 48 | 0) + (((i29 << 2) + 15 | 0) >>> 4 << 5) + ((((((i26 << 4) + ((i31 << 4) + 31) & -16) + ((i27 << 3) + 15) & -16) + ((i28 << 2) + 15) & -16) + ((i2 << 2) + 15) & -16) + ((i30 << 2) + 15) & -16) | 0;
 i31 = i38 + 644 | 0;
 HEAP32[i31 >> 2] = i33;
 i37 = i37 + i36 | 0;
 i30 = i38 + 656 | 0;
 HEAP32[i30 >> 2] = i24;
 _memset(i33 | 0, 0, i35 | 0) | 0;
 i33 = HEAP32[i38 + 704 >> 2] | 0;
 i30 = HEAP32[i30 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i33 + 4 >> 2] = i30 | -2147483648;
 i33 = i7 + i37 | 0;
 i30 = i38 + 648 | 0;
 HEAP32[i30 >> 2] = i33;
 i31 = i38 + 660 | 0;
 HEAP32[i31 >> 2] = i24;
 _memset(i33 | 0, 0, i35 | 0) | 0;
 i33 = HEAP32[i38 + 708 >> 2] | 0;
 i31 = HEAP32[i31 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i33 + 4 >> 2] = i31 | -2147483648;
 i37 = i7 + (i37 + i36) | 0;
 i33 = i38 + 652 | 0;
 HEAP32[i33 >> 2] = i37;
 i36 = i38 + 664 | 0;
 HEAP32[i36 >> 2] = i24;
 _memset(i37 | 0, 0, i35 | 0) | 0;
 i37 = HEAP32[i38 + 712 >> 2] | 0;
 i36 = HEAP32[i36 >> 2] | 0;
 HEAP32[i37 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i37 + 4 >> 2] = i36 | -2147483648;
 HEAP32[i38 + 716 >> 2] = i7 + i34;
 i37 = i34 + i32 | 0;
 HEAP32[i38 + 720 >> 2] = i7 + i37;
 HEAP32[i38 + 724 >> 2] = i7 + (i37 + i32);
 if (i23 >>> 0 <= (HEAP32[i38 + 384 >> 2] | 0) >>> 0) {
  i37 = HEAP32[i6 >> 2] | 0;
  i36 = i38 + 604 | 0;
  HEAP32[i36 >> 2] = i37;
  i36 = HEAP32[i4 >> 2] | 0;
  i37 = i38 + 608 | 0;
  HEAP32[i37 >> 2] = i36;
  i37 = HEAP32[i5 >> 2] | 0;
  i36 = i38 + 612 | 0;
  HEAP32[i36 >> 2] = i37;
  i36 = HEAP32[i3 >> 2] | 0;
  i37 = i38 + 616 | 0;
  HEAP32[i37 >> 2] = i36;
  i37 = HEAP32[i1 >> 2] | 0;
  i38 = i38 + 620 | 0;
  HEAP32[i38 >> 2] = i37;
  STACKTOP = i39;
  return;
 }
 __ZN5physx13IslandManager6resizeEj(i38 + 372 | 0, i23);
 i37 = HEAP32[i6 >> 2] | 0;
 i36 = i38 + 604 | 0;
 HEAP32[i36 >> 2] = i37;
 i36 = HEAP32[i4 >> 2] | 0;
 i37 = i38 + 608 | 0;
 HEAP32[i37 >> 2] = i36;
 i37 = HEAP32[i5 >> 2] | 0;
 i36 = i38 + 612 | 0;
 HEAP32[i36 >> 2] = i37;
 i36 = HEAP32[i3 >> 2] | 0;
 i37 = i38 + 616 | 0;
 HEAP32[i37 >> 2] = i36;
 i37 = HEAP32[i1 >> 2] | 0;
 i38 = i38 + 620 | 0;
 HEAP32[i38 >> 2] = i37;
 STACKTOP = i39;
 return;
}

function __ZN16ParticleAnimator8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 112 | 0;
 i8 = i1 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i1 = i6 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 68 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i5 = i6 + 80 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i1;
  i3 = i1;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = f11 < Math_fround(0.0);
 i4 = f11 > Math_fround(1.0);
 f11 = i4 ? Math_fround(1.0) : f11;
 HEAPF32[i5 >> 2] = i1 ? Math_fround(0.0) : f11;
 i1 = i6 + 113 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = (HEAP32[i6 + 108 >> 2] | 0) != 0 & 1;
 HEAP8[i7 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 1);
  STACKTOP = i10;
  return;
 }
}

function __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode3EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f27, i28, i35, i1, i36) {
 f27 = Math_fround(f27);
 i28 = i28 | 0;
 i35 = i35 | 0;
 i1 = i1 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, f49 = f0, f50 = f0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i41 + 48 | 0;
 i38 = i41 + 32 | 0;
 i39 = i41 + 16 | 0;
 i40 = i41;
 i29 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i29) {
  STACKTOP = i41;
  return;
 }
 i30 = i1 + 500 | 0;
 i31 = i39 + 4 | 0;
 i32 = i39 + 8 | 0;
 i33 = i39 + 12 | 0;
 i34 = i35 + 84 | 0;
 i2 = i1 + 520 | 0;
 i3 = i39 + 4 | 0;
 i4 = i39 + 8 | 0;
 i5 = i39 + 12 | 0;
 i6 = i40 + 4 | 0;
 i7 = i40 + 8 | 0;
 i8 = i40 + 12 | 0;
 i9 = i38 + 4 | 0;
 i10 = i38 + 8 | 0;
 i11 = i38 + 12 | 0;
 i12 = i37 + 4 | 0;
 i13 = i37 + 8 | 0;
 i14 = i37 + 12 | 0;
 i15 = i35 + 80 | 0;
 i16 = i35 + 232 | 0;
 i17 = i35 + 144 | 0;
 i1 = 0;
 do {
  i21 = (HEAP32[i30 >> 2] | 0) + (i1 << 2) | 0;
  i18 = HEAP32[i21 >> 2] | 0;
  i19 = HEAP32[i21 + 4 >> 2] | 0;
  i20 = HEAP32[i21 + 8 >> 2] | 0;
  i21 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i38 >> 2] = 0;
  HEAP32[i38 + 4 >> 2] = 0;
  HEAP32[i38 + 8 >> 2] = 0;
  HEAP32[i38 + 12 >> 2] = 0;
  i48 = i18 + 1454627760 | 0;
  i46 = i19 + 1454627760 | 0;
  i44 = i20 + 1454627760 | 0;
  i42 = i21 + 1454627760 | 0;
  i47 = (Math_imul(i48, 1790253981) | 0) + 1900727103 | 0;
  i45 = (Math_imul(i46, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
  i26 = (Math_imul(i42, 1790253981) | 0) + 1900727103 | 0;
  i48 = i48 << 11 ^ i48;
  i46 = i46 << 11 ^ i46;
  i44 = i44 << 11 ^ i44;
  i42 = i42 << 11 ^ i42;
  f22 = Math_fround(Math_fround((i47 ^ i48 ^ i48 >>> 8) & 8388607 ^ i47 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f23 = Math_fround(Math_fround((i45 ^ i46 ^ i46 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f24 = Math_fround(Math_fround((i43 ^ i44 ^ i44 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f25 = Math_fround(Math_fround((i26 ^ i42 ^ i42 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i39 >> 2] = f22;
  HEAPF32[i31 >> 2] = f23;
  HEAPF32[i32 >> 2] = f24;
  HEAPF32[i33 >> 2] = f25;
  i26 = HEAP32[i34 >> 2] | 0;
  L6 : do switch ((i26 & 65535) << 16 >> 16) {
  case 0:
   {
    i48 = HEAP32[i15 >> 2] | 0;
    HEAP32[i14 >> 2] = i48;
    HEAP32[i13 >> 2] = i48;
    HEAP32[i12 >> 2] = i48;
    HEAP32[i37 >> 2] = i48;
    break;
   }
  case 3:
   {
    f50 = Math_fround(HEAPF32[(HEAP32[i16 >> 2] | 0) + 4 >> 2]);
    f49 = Math_fround(HEAPF32[i15 >> 2]);
    f50 = Math_fround(f50 * f49);
    f49 = Math_fround(Math_fround(f49 * Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + 4 >> 2])) - f50);
    f23 = Math_fround(f50 + Math_fround(f49 * f23));
    f24 = Math_fround(f50 + Math_fround(f49 * f24));
    f25 = Math_fround(f50 + Math_fround(f25 * f49));
    HEAPF32[i37 >> 2] = Math_fround(f50 + Math_fround(f22 * f49));
    HEAPF32[i12 >> 2] = f23;
    HEAPF32[i13 >> 2] = f24;
    HEAPF32[i14 >> 2] = f25;
    break;
   }
  default:
   if (!(i26 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i37, i35, i38, i39);
    break L6;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i37, i35, i38, i39);
    break L6;
   }
  } while (0);
  i47 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f50 = Math_fround(HEAPF32[i47 >> 2]);
  f24 = Math_fround(HEAPF32[i47 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i47 + 8 >> 2]);
  f24 = Math_fround(f24 * Math_fround(.00999999977));
  f25 = Math_fround(f25 * Math_fround(.00999999977));
  f49 = Math_fround(Math_fround(HEAPF32[i47 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i39 >> 2] = Math_fround(f50 * Math_fround(.00999999977));
  HEAPF32[i3 >> 2] = f24;
  HEAPF32[i4 >> 2] = f25;
  HEAPF32[i5 >> 2] = f49;
  i47 = i18 + 326370691 | 0;
  i26 = i19 + 326370691 | 0;
  i43 = i20 + 326370691 | 0;
  i45 = i21 + 326370691 | 0;
  i48 = (Math_imul(i47, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i26, 1790253981) | 0) + 1900727103 | 0;
  i44 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
  i46 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i47 = i47 << 11 ^ i47;
  i26 = i26 << 11 ^ i26;
  i43 = i43 << 11 ^ i43;
  i45 = i45 << 11 ^ i45;
  f49 = Math_fround(Math_fround((i42 ^ i26 ^ i26 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f25 = Math_fround(Math_fround((i44 ^ i43 ^ i43 >>> 8) & 8388607 ^ i44 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f24 = Math_fround(Math_fround((i46 ^ i45 ^ i45 >>> 8) & 8388607 ^ i46 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i40 >> 2] = Math_fround(Math_fround((i48 ^ i47 ^ i47 >>> 8) & 8388607 ^ i48 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i6 >> 2] = f49;
  HEAPF32[i7 >> 2] = f25;
  HEAPF32[i8 >> 2] = f24;
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i38, i28, i39, i40);
  f24 = Math_fround(Math_fround(HEAPF32[i38 >> 2]) * f27);
  f25 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f27);
  f49 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f27);
  f50 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f27);
  i48 = i36 + (i1 << 2) | 0;
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i37 >> 2]));
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i12 >> 2]));
  f49 = Math_fround(f49 + Math_fround(HEAPF32[i13 >> 2]));
  f50 = Math_fround(f50 + Math_fround(HEAPF32[i14 >> 2]));
  f25 = Math_fround(f25 - Math_fround(Math_floor(Math_fround(f25))));
  f49 = Math_fround(f49 - Math_fround(Math_floor(Math_fround(f49))));
  f50 = Math_fround(f50 - Math_fround(Math_floor(Math_fround(f50))));
  HEAPF32[i48 >> 2] = Math_fround(f24 - Math_fround(Math_floor(Math_fround(f24))));
  HEAPF32[i48 + 4 >> 2] = f25;
  HEAPF32[i48 + 8 >> 2] = f49;
  HEAPF32[i48 + 12 >> 2] = f50;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i29 >>> 0);
 STACKTOP = i41;
 return;
}

function __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_(i8, i9, i7, i3, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f4 = f0, f5 = f0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i8, i9, i7, i10) | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = i7 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f14 = Math_fround(f4 - f5);
  f14 = Math_fround(f14 * f14);
  if (f14 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break; else i1 = i12;
   STACKTOP = i13;
   return i1 | 0;
  } else {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[HEAP32[i10 + 24 >> 2] >> 2] | 0;
   f17 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) >> 2]);
   f16 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 8 >> 2]);
   i2 = HEAP32[i7 >> 2] | 0;
   f20 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) >> 2]);
   f19 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i1 + (i2 * 24 | 0) + 8 >> 2]);
   f4 = Math_fround(HEAPF32[i10 >> 2]);
   f17 = Math_fround(f17 - f4);
   f5 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f16 = Math_fround(f16 - f5);
   f14 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f15 = Math_fround(f15 - f14);
   f4 = Math_fround(f20 - f4);
   f5 = Math_fround(f19 - f5);
   f14 = Math_fround(f18 - f14);
   if (Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f15 * f15)) < Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f14 * f14))) break; else i1 = i12;
   STACKTOP = i13;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i1 | 0)) {
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i1 = i12 + 1 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i6 = i9 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) {
  f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f20 = Math_fround(f4 - f5);
  f20 = Math_fround(f20 * f20);
  if (f20 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break;
   STACKTOP = i13;
   return i1 | 0;
  } else {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[HEAP32[i10 + 24 >> 2] >> 2] | 0;
   f15 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) >> 2]);
   f16 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 8 >> 2]);
   i3 = HEAP32[i9 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i2 + (i3 * 24 | 0) + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i10 >> 2]);
   f15 = Math_fround(f15 - f18);
   f19 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f17 = Math_fround(f17 - f20);
   f18 = Math_fround(f4 - f18);
   f19 = Math_fround(f5 - f19);
   f20 = Math_fround(f14 - f20);
   if (Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f17 * f17)) < Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)) + Math_fround(f20 * f20))) break;
   STACKTOP = i13;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i1 = i12 + 2 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 do if ((i2 | 0) == (i3 | 0)) {
  f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f20 = Math_fround(f4 - f5);
  f20 = Math_fround(f20 * f20);
  if (f20 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   if (f4 > f5) break;
   STACKTOP = i13;
   return i1 | 0;
  } else {
   i7 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[HEAP32[i10 + 24 >> 2] >> 2] | 0;
   f15 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) >> 2]);
   f16 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 8 >> 2]);
   i7 = HEAP32[i8 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) >> 2]);
   f5 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i6 + (i7 * 24 | 0) + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i10 >> 2]);
   f15 = Math_fround(f15 - f18);
   f19 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f16 = Math_fround(f16 - f19);
   f20 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f17 = Math_fround(f17 - f20);
   f18 = Math_fround(f4 - f18);
   f19 = Math_fround(f5 - f19);
   f20 = Math_fround(f14 - f20);
   if (Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f17 * f17)) < Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)) + Math_fround(f20 * f20))) break;
   STACKTOP = i13;
   return i1 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i12 = i12 + 3 | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i1, i12, i2, i3, i5) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f26 = Math_fround(f26 - f13);
 f29 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f29 = Math_fround(f29 - f16);
 f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f24 = Math_fround(f24 - f17);
 f11 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f13);
 f14 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f16);
 f15 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f17);
 f13 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f13);
 f16 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f16);
 f17 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f17);
 f20 = Math_fround(f11 - f26);
 f21 = Math_fround(f14 - f29);
 f18 = Math_fround(f15 - f24);
 f22 = Math_fround(f13 - f11);
 f23 = Math_fround(f16 - f14);
 f19 = Math_fround(f17 - f15);
 f8 = Math_fround(f26 - f13);
 f9 = Math_fround(f29 - f16);
 f10 = Math_fround(f24 - f17);
 f4 = Math_fround(Math_abs(Math_fround(f20)));
 f6 = Math_fround(Math_abs(Math_fround(f21)));
 f7 = Math_fround(Math_abs(Math_fround(f18)));
 f31 = Math_fround(Math_fround(f29 * f18) - Math_fround(f24 * f21));
 f30 = Math_fround(Math_fround(f18 * f16) - Math_fround(f21 * f17));
 f27 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f25 = Math_fround(f7 * f27);
 f28 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f6 * f28));
 if ((f31 < f30 ? f31 : f30) > f25 ? 1 : (f31 > f30 ? f31 : f30) < Math_fround(-f25)) {
  i12 = 0;
  return i12 | 0;
 }
 f30 = Math_fround(-f18);
 f32 = Math_fround(Math_fround(f24 * f20) + Math_fround(f26 * f30));
 f30 = Math_fround(Math_fround(f13 * f30) + Math_fround(f20 * f17));
 f25 = Math_fround(HEAPF32[i12 >> 2]);
 f31 = Math_fround(Math_fround(f4 * f28) + Math_fround(f7 * f25));
 if ((f32 < f30 ? f32 : f30) > f31 ? 1 : (f32 > f30 ? f32 : f30) < Math_fround(-f31)) {
  i12 = 0;
  return i12 | 0;
 }
 f30 = Math_fround(Math_fround(f11 * f21) - Math_fround(f20 * f14));
 f31 = Math_fround(Math_fround(f21 * f13) - Math_fround(f20 * f16));
 f32 = Math_fround(Math_fround(f4 * f27) + Math_fround(f6 * f25));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f7 = Math_fround(Math_abs(Math_fround(f22)));
 f6 = Math_fround(Math_abs(Math_fround(f23)));
 f4 = Math_fround(Math_abs(Math_fround(f19)));
 f30 = Math_fround(Math_fround(f29 * f19) - Math_fround(f24 * f23));
 f31 = Math_fround(Math_fround(f16 * f19) - Math_fround(f23 * f17));
 f32 = Math_fround(Math_fround(f28 * f6) + Math_fround(f27 * f4));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f31 = Math_fround(-f19);
 f30 = Math_fround(Math_fround(f24 * f22) + Math_fround(f26 * f31));
 f31 = Math_fround(Math_fround(f22 * f17) + Math_fround(f13 * f31));
 f32 = Math_fround(Math_fround(f28 * f7) + Math_fround(f25 * f4));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f30 = Math_fround(Math_fround(f26 * f23) - Math_fround(f29 * f22));
 f31 = Math_fround(Math_fround(f11 * f23) - Math_fround(f14 * f22));
 f32 = Math_fround(Math_fround(f27 * f7) + Math_fround(f25 * f6));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f7 = Math_fround(Math_abs(Math_fround(f8)));
 f6 = Math_fround(Math_abs(Math_fround(f9)));
 f4 = Math_fround(Math_abs(Math_fround(f10)));
 f30 = Math_fround(Math_fround(f29 * f10) - Math_fround(f24 * f9));
 f31 = Math_fround(Math_fround(f14 * f10) - Math_fround(f15 * f9));
 f32 = Math_fround(Math_fround(f28 * f6) + Math_fround(f27 * f4));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f31 = Math_fround(-f10);
 f30 = Math_fround(Math_fround(f24 * f8) + Math_fround(f26 * f31));
 f31 = Math_fround(Math_fround(f15 * f8) + Math_fround(f11 * f31));
 f32 = Math_fround(Math_fround(f28 * f7) + Math_fround(f25 * f4));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f30 = Math_fround(Math_fround(f11 * f9) - Math_fround(f14 * f8));
 f31 = Math_fround(Math_fround(f13 * f9) - Math_fround(f8 * f16));
 f32 = Math_fround(Math_fround(f27 * f7) + Math_fround(f25 * f6));
 if ((f30 < f31 ? f30 : f31) > f32 ? 1 : (f30 > f31 ? f30 : f31) < Math_fround(-f32)) {
  i12 = 0;
  return i12 | 0;
 }
 f31 = f26 < f11 ? f26 : f11;
 f32 = f26 > f11 ? f26 : f11;
 f11 = Math_fround(-f25);
 if ((f31 < f13 ? f31 : f13) > f25 ? 1 : (f32 > f13 ? f32 : f13) < f11) {
  i12 = 0;
  return i12 | 0;
 }
 f31 = f29 < f14 ? f29 : f14;
 f32 = f29 > f14 ? f29 : f14;
 f10 = Math_fround(-f27);
 if ((f31 < f16 ? f31 : f16) > f27 ? 1 : (f32 > f16 ? f32 : f16) < f10) {
  i12 = 0;
  return i12 | 0;
 }
 f31 = f24 < f15 ? f24 : f15;
 f32 = f24 > f15 ? f24 : f15;
 f9 = Math_fround(-f28);
 if ((f31 < f17 ? f31 : f17) > f28 ? 1 : (f32 > f17 ? f32 : f17) < f9) {
  i12 = 0;
  return i12 | 0;
 }
 f8 = Math_fround(Math_fround(f21 * f19) - Math_fround(f18 * f23));
 f7 = Math_fround(Math_fround(f18 * f22) - Math_fround(f20 * f19));
 f6 = Math_fround(Math_fround(f20 * f23) - Math_fround(f21 * f22));
 f4 = Math_fround(Math_fround(f24 * f6) + Math_fround(Math_fround(f26 * f8) + Math_fround(f29 * f7)));
 i1 = f8 > Math_fround(0.0);
 i2 = f7 > Math_fround(0.0);
 i3 = f6 > Math_fround(0.0);
 if (Math_fround(Math_fround(Math_fround(f6 * (i3 ? f9 : f28)) + Math_fround(Math_fround(f7 * (i2 ? f10 : f27)) + Math_fround(f8 * (i1 ? f11 : f25)))) - f4) > Math_fround(0.0)) i1 = 1; else i1 = !(Math_fround(Math_fround(Math_fround(f6 * (i3 ? f28 : f9)) + Math_fround(Math_fround(f7 * (i2 ? f27 : f10)) + Math_fround(f8 * (i1 ? f25 : f11)))) - f4) >= Math_fround(0.0));
 i12 = i1 & 1 ^ 1;
 return i12 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i8 = i17;
 i3 = i17 + 20 | 0;
 i4 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i1 >> 4;
 i5 = i1;
 if (i2 >>> 0 < i9 >>> 0) {
  i5 = i14 + 8 | 0;
  if (((HEAP32[i5 >> 2] | 0) - i1 >> 4 | 0) == (i9 | 0)) {
   __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE8__appendEj(i14, i9 - i2 | 0);
   STACKTOP = i17;
   return;
  }
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i6 = i8 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i7 = i8 + 12 | 0;
  HEAP32[i7 >> 2] = i2;
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE7reserveEj(i8, i9);
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, i13, i16);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i2 - i4 >> 4;
  i1 = i2;
  if (i3 >>> 0 < i9 >>> 0) {
   __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE8__appendEj(i8, i9 - i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  } else if (i3 >>> 0 > i9 >>> 0) {
   i4 = i4 + (i9 << 4) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i16 + 4 | 0;
    while (1) {
     i2 = i1 + -16 | 0;
     HEAP32[i6 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i13 = HEAP32[i1 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i16);
      i2 = HEAP32[i6 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i14 >> 2] = i4;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i6 >> 2] = i14;
  HEAP32[i15 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i14;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i16 + 4 | 0;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i6 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 if (i2 >>> 0 <= i9 >>> 0) {
  STACKTOP = i17;
  return;
 }
 i8 = i5 + (i9 << 4) | 0;
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 i11 = i13 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i12 = i13 + 12 | 0;
 HEAP32[i12 >> 2] = i1;
 i2 = i9 << 4;
 i3 = i2 >> 4;
 if (!i3) {
  i4 = i13 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i1 = HEAP32[i12 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = i1;
  i2 = i1 + (i3 << 4) | 0;
  i7 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i1;
  if (!i9) {
   i4 = i7;
   i5 = i3;
  } else {
   i6 = i16 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i10 = 34;
    } else i10 = 32;
    if ((i10 | 0) == 32) {
     i18 = i4 + 16 & -16;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i9;
     HEAP32[i1 + 8 >> 2] = i18 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i9;
     i10 = 34;
    }
    if ((i10 | 0) == 34) {
     i10 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i5 = i5 + 16 | 0;
    i1 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
    HEAP32[i11 >> 2] = i1;
   } while ((i5 | 0) != (i8 | 0));
   i4 = i7;
   i5 = HEAP32[i13 >> 2] | 0;
   i3 = i1;
   i2 = HEAP32[i7 >> 2] | 0;
  }
 }
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i5;
 i18 = HEAP32[i15 >> 2] | 0;
 HEAP32[i11 >> 2] = i18;
 HEAP32[i15 >> 2] = i3;
 i15 = i14 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i2;
 i4 = i1;
 i2 = i18;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i16 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i11 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i18 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i3 >> 2] = i18;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
     i1 = HEAP32[i11 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i18 = HEAP32[i12 >> 2] | 0;
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i8 = i17;
 i3 = i17 + 20 | 0;
 i4 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i1 >> 4;
 i5 = i1;
 if (i2 >>> 0 < i9 >>> 0) {
  i5 = i14 + 8 | 0;
  if (((HEAP32[i5 >> 2] | 0) - i1 >> 4 | 0) == (i9 | 0)) {
   __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE8__appendEj(i14, i9 - i2 | 0);
   STACKTOP = i17;
   return;
  }
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i6 = i8 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i7 = i8 + 12 | 0;
  HEAP32[i7 >> 2] = i2;
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE7reserveEj(i8, i9);
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, i13, i16);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i2 - i4 >> 4;
  i1 = i2;
  if (i3 >>> 0 < i9 >>> 0) {
   __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE8__appendEj(i8, i9 - i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  } else if (i3 >>> 0 > i9 >>> 0) {
   i4 = i4 + (i9 << 4) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i16 + 4 | 0;
    while (1) {
     i2 = i1 + -16 | 0;
     HEAP32[i6 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i13 = HEAP32[i1 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i16);
      i2 = HEAP32[i6 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i14 >> 2] = i4;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i6 >> 2] = i14;
  HEAP32[i15 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i14;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i16 + 4 | 0;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i6 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 if (i2 >>> 0 <= i9 >>> 0) {
  STACKTOP = i17;
  return;
 }
 i8 = i5 + (i9 << 4) | 0;
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 i11 = i13 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i12 = i13 + 12 | 0;
 HEAP32[i12 >> 2] = i1;
 i2 = i9 << 4;
 i3 = i2 >> 4;
 if (!i3) {
  i4 = i13 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i1 = HEAP32[i12 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = i1;
  i2 = i1 + (i3 << 4) | 0;
  i7 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i1;
  if (!i9) {
   i4 = i7;
   i5 = i3;
  } else {
   i6 = i16 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i10 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i10 = 34;
    } else i10 = 32;
    if ((i10 | 0) == 32) {
     i18 = i4 + 16 & -16;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i9;
     HEAP32[i1 + 8 >> 2] = i18 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i9;
     i10 = 34;
    }
    if ((i10 | 0) == 34) {
     i10 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i5 = i5 + 16 | 0;
    i1 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
    HEAP32[i11 >> 2] = i1;
   } while ((i5 | 0) != (i8 | 0));
   i4 = i7;
   i5 = HEAP32[i13 >> 2] | 0;
   i3 = i1;
   i2 = HEAP32[i7 >> 2] | 0;
  }
 }
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i5;
 i18 = HEAP32[i15 >> 2] | 0;
 HEAP32[i11 >> 2] = i18;
 HEAP32[i15 >> 2] = i3;
 i15 = i14 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i2;
 i4 = i1;
 i2 = i18;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i16 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i11 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i18 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i3 >> 2] = i18;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
     i1 = HEAP32[i11 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i18 = HEAP32[i12 >> 2] | 0;
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i(i3, i12, i17, i18) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i20 + 72 | 0;
 i15 = i20 + 56 | 0;
 i5 = i20 + 48 | 0;
 i19 = i20 + 24 | 0;
 i14 = i20;
 i6 = i20 + 156 | 0;
 i16 = i20 + 104 | 0;
 i13 = i20 + 84 | 0;
 i8 = i3 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L1 : do if (!i2) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  i1 = 0;
 } else {
  i4 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  if (i4) if (!i1) i1 = 0; else {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAP32[i6 + 16 >> 2] = 0;
   if (__ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i2, i6, 0, i12) | 0) {
    i1 = HEAP32[i6 + 4 >> 2] | 0;
    i2 = HEAP32[i6 + 8 >> 2] | 0;
    if ((Math_imul(i2, i1) | 0) > (i18 | 0)) {
     HEAP32[i7 >> 2] = i18;
     HEAP32[i7 + 4 >> 2] = i1;
     HEAP32[i7 + 8 >> 2] = i2;
     __Z6FormatPKcz(i19, gb + 412444 | 0, i7);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 410682 | 0, 1346, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
     i1 = 0;
     break;
    } else {
     __ZN14ImageReferenceC2Eiii13TextureFormatPv(i19, i1, i2, i1 << 2, 4, i17);
     __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i19, i6, 0);
     i1 = 1;
     break;
    }
   }
   i3 = HEAP32[i8 >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i3 + 36 >> 2] | 0;
   do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
    i2 = i1 + -30 | 0;
    if (i2 >>> 0 < 15) if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break; else {
     i1 = 0;
     break L1;
    } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break; else {
     i1 = 0;
     break L1;
    }
   } while (0);
   i10 = gb + 64016 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i16 + 4 >> 2] = 1;
   HEAP32[i16 >> 2] = gb + 41960 + 8;
   i9 = i14;
   HEAP32[i9 >> 2] = i11;
   HEAP32[i9 + 4 >> 2] = i10;
   i9 = i16 + 8 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i16 + 20 >> 2] = 0;
   i10 = i16 + 24 | 0;
   HEAP32[i10 >> 2] = 0;
   i11 = i16 + 12 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i14);
   i5 = i19;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i11;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i16 + 28 >> 2] = 0;
   HEAP32[i16 + 32 >> 2] = 0;
   HEAP32[i16 + 40 >> 2] = 0;
   HEAP32[i16 + 44 >> 2] = 0;
   HEAP32[i16 + 48 >> 2] = 0;
   if ((HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 1 | 0) == 29) {
    __ZN17SharedTextureData32GetCrunchDecompressedTextureDataIS_EEbRKT_(i16, i3) | 0;
    i1 = i16;
   } else i1 = i3;
   i2 = i1 + 28 | 0;
   i4 = i1 + 32 | 0;
   i7 = i1 + 36 | 0;
   i5 = __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0, i12) | 0;
   i5 = (HEAP32[i1 + 8 >> 2] | 0) + i5 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i1 = i6 | 1;
   L24 : do if ((i1 | 0) == 31) i3 = 16; else {
    switch (i6 | 0) {
    case 32:
    case 33:
    case 60:
    case 61:
     {
      i3 = 8;
      break L24;
     }
    default:
     {}
    }
    switch (i6 | 0) {
    case 34:
    case 35:
    case 36:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
    case 47:
     {
      i3 = 4;
      break L24;
     }
    default:
     {}
    }
    if ((i6 + -48 | 0) >>> 0 < 12) i3 = 1; else {
     switch (i6 | 0) {
     case 10:
     case 11:
     case 12:
     case 26:
     case 27:
      {
       i3 = 4;
       break L24;
      }
     default:
      {}
     }
     i3 = (i1 | 0) == 25 ? 4 : 1;
    }
   } while (0);
   i2 = HEAP32[i2 >> 2] >> i12;
   i2 = (i2 | 0) < (i3 | 0) ? i3 : i2;
   i1 = HEAP32[i4 >> 2] >> i12;
   i1 = (i1 | 0) < (i3 | 0) ? i3 : i1;
   do if ((Math_imul(i1, i2) | 0) > (i18 | 0)) {
    HEAP32[i15 >> 2] = i18;
    HEAP32[i15 + 4 >> 2] = i2;
    HEAP32[i15 + 8 >> 2] = i1;
    __Z6FormatPKcz(i19, gb + 412444 | 0, i15);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 410682 | 0, 1312, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
    i1 = 0;
   } else {
    if (!((i2 | 0) % (i3 | 0) | 0)) if (!((i1 | 0) % (i3 | 0) | 0)) {
     __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i6, 4, i2, i1, i5, i2, 0, i17) | 0;
     i1 = 1;
     break;
    }
    i18 = i3 + -1 | 0;
    i15 = i18 + i2 | 0;
    i15 = i15 - ((i15 | 0) % (i3 | 0) | 0) | 0;
    i18 = i18 + i1 | 0;
    __ZN5ImageC2Eii13TextureFormat(i19, i15, i18 - ((i18 | 0) % (i3 | 0) | 0) | 0, 4);
    i18 = i19 + 16 | 0;
    __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(HEAP32[i7 >> 2] | 0, 4, i2, i1, i5, i15, 0, HEAP32[i18 >> 2] | 0) | 0;
    __ZNK14ImageReference9ClipImageEiiii(i14, i19, 0, 0, i2, i1);
    __ZN14ImageReferenceC2Eiii13TextureFormatPv(i13, i2, i1, i2 << 2, 4, i17);
    __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i13, i14, 0);
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, gb + 63184 | 0);
    i1 = 1;
   } while (0);
   HEAP32[i16 >> 2] = gb + 41960 + 8;
   if ((HEAP32[i10 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i11);
    HEAP32[i9 >> 2] = 0;
   }
   break;
  }
  HEAP32[i5 >> 2] = i4;
  HEAP32[i5 + 4 >> 2] = i1;
  __Z6FormatPKcz(i19, gb + 412384 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 410682 | 0, 1284, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 } while (0);
 i19 = i1;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN6Camera22SetTargetBuffersScriptEiPK21ScriptingRenderBufferPS0_(i13, i14, i7, i9) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 72 | 0;
 i10 = i18 + 68 | 0;
 i15 = i18 + 32 | 0;
 i16 = i18;
 i17 = i18 + 64 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 0;
 if ((i14 | 0) > 0) {
  i6 = 0;
  do {
   i1 = HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0;
   i5 = HEAP32[i7 + (i6 << 3) >> 2] | 0;
   if (!i1) {
    i1 = __Z12GetGfxDevicev() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
   }
   HEAP32[i15 + (i6 << 2) >> 2] = i1;
   do if (!i5) i1 = 0; else {
    HEAP32[i10 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 12; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i10);
      i4 = HEAP32[i12 >> 2] | 0;
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
      i1 = i3;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i11 = 12; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i11 = 14;
    }
    if ((i11 | 0) == 12) i11 = 14;
    if ((i11 | 0) == 14) {
     i11 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i10 >> 2] = i5;
    if (!i1) i11 = 21; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i10);
      i2 = HEAP32[i12 >> 2] | 0;
      i8 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 21; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 23;
     }
    }
    if ((i11 | 0) == 21) i11 = 23;
    if ((i11 | 0) == 23) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
   } while (0);
   HEAP32[i16 + (i6 << 2) >> 2] = i1;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i14 | 0));
 }
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 if (!i1) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, i1 | 0) | 0;
 }
 i8 = i1;
 i6 = (HEAP32[i16 >> 2] | 0) == 0;
 i5 = HEAP32[i9 >> 2] | 0;
 if (!i5) i2 = 1; else {
  HEAP32[i10 >> 2] = i5;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i11 = 33; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i2, i10);
    i3 = HEAP32[i12 >> 2] | 0;
    i10 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 33; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i11 = 35;
   }
  }
  if ((i11 | 0) == 33) i11 = 35;
  if ((i11 | 0) == 35) i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
  i2 = (i2 | 0) == 0;
 }
 i7 = (i14 | 0) > 1;
 L55 : do if (i7) {
  i3 = 1;
  while (1) {
   if (i6 ^ (HEAP32[i16 + (i3 << 2) >> 2] | 0) == 0) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i14 | 0)) break L55;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376844 | 0, 0, gb + 375437 | 0, 2986, 1, 0, 0, 0);
  STACKTOP = i18;
  return;
 } while (0);
 if (i6 ^ i2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376915 | 0, 0, gb + 375437 | 0, 2989, 1, 0, 0, 0);
  STACKTOP = i18;
  return;
 }
 i5 = HEAP32[i15 >> 2] | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 L66 : do if (i7) {
  i1 = 1;
  while (1) {
   i2 = HEAP32[i15 + (i1 << 2) >> 2] | 0;
   if ((i4 | 0) != (HEAP32[i2 + 4 >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i5 | 0) != (HEAP32[i2 + 8 >> 2] | 0)) break;
   if ((i1 | 0) >= (i14 | 0)) break L66;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376996 | 0, 0, gb + 375437 | 0, 3004, 1, 0, 0, 0);
  STACKTOP = i18;
  return;
 } while (0);
 if ((i4 | 0) == (i6 | 0) & (i5 | 0) == (i3 | 0)) {
  HEAP32[i17 >> 2] = i8;
  HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
  __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i13, 0, i14, i15, i12, i16);
  STACKTOP = i18;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376996 | 0, 0, gb + 375437 | 0, 3008, 1, 0, 0, 0);
  STACKTOP = i18;
  return;
 }
}

function _UNITY_FT_Stroker_EndSubPath(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 if (!i13) {
  i13 = 6;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(HEAP8[i13 + 21 >> 0] | 0)) {
  i1 = i13 + 28 | 0;
  if ((HEAP32[i13 + 8 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
   if ((HEAP32[i13 + 12 >> 2] | 0) != (HEAP32[i13 + 32 >> 2] | 0)) i2 = 25;
  } else i2 = 25;
  if ((i2 | 0) == 25) {
   i1 = _UNITY_FT_Stroker_LineTo(i13, i1) | 0;
   if (i1 | 0) {
    i13 = i1;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
  i1 = HEAP32[i13 + 24 >> 2] | 0;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = _UNITY_FT_Angle_Diff(HEAP32[i13 >> 2] | 0, i1) | 0;
  if (i1 | 0) {
   i1 = i1 >>> 31;
   i2 = i13 + 36 | 0;
   i3 = _ft_stroker_inside(i13, i1, HEAP32[i2 >> 2] | 0) | 0;
   if (i3 | 0) {
    i13 = i3;
    STACKTOP = i14;
    return i13 | 0;
   }
   i1 = _ft_stroker_outside(i13, i1 ^ 1, HEAP32[i2 >> 2] | 0) | 0;
   if (i1 | 0) {
    i13 = i1;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
  i1 = i13 + 84 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i13 + 64 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 > (i2 + 1 | 0) >>> 0) {
   i10 = i4 + -1 | 0;
   HEAP32[i3 >> 2] = i10;
   i12 = HEAP32[i13 + 72 >> 2] | 0;
   i10 = i12 + (i10 << 3) | 0;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i12 + (i2 << 3) | 0;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i12 = i13 + 76 | 0;
   i11 = (HEAP32[i12 >> 2] | 0) + i2 | 0;
   HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 4;
   i12 = (HEAP32[i12 >> 2] | 0) + (i4 + -2) | 0;
   HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 8;
  } else HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = -1;
  HEAP8[i13 + 80 >> 0] = 0;
  i5 = i13 + 116 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i1 = i13 + 96 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  if (i7 >>> 0 > (i6 + 1 | 0) >>> 0) {
   i3 = i7 + -1 | 0;
   HEAP32[i1 >> 2] = i3;
   i2 = i13 + 104 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i11 = i1 + (i3 << 3) | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i1 = i1 + (i6 << 3) | 0;
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 4 >> 2] = i12;
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = i2 + (i3 << 3) + -8 | 0;
   i2 = i2 + (i6 << 3) + 8 | 0;
   if (i2 >>> 0 < i1 >>> 0) do {
    i11 = i2;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = i1;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i12 = i2;
    HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i12 + 4 >> 2] = i9;
    i12 = i1;
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i11;
    i1 = i1 + -8 | 0;
    i2 = i2 + 8 | 0;
   } while (i2 >>> 0 < i1 >>> 0);
   i4 = i13 + 108 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = i1 + i3 + -1 | 0;
   i2 = i1 + i6 + 1 | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    i1 = i3;
    do {
     i12 = HEAP8[i2 >> 0] | 0;
     HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = i12;
     i1 = i1 + -1 | 0;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i1 >>> 0);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i12 = i1 + i6 | 0;
   HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 4;
   i12 = (HEAP32[i4 >> 2] | 0) + (i7 + -2) | 0;
   HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 8;
  } else HEAP32[i1 >> 2] = i6;
  HEAP32[i5 >> 2] = -1;
  HEAP8[i13 + 112 >> 0] = 0;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = _ft_stroker_cap(i13, HEAP32[i13 >> 2] | 0) | 0;
 if (i1 | 0) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i12 = i13 + 96 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i9 = i13 + 116 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i3 - i2 | 0;
 if ((i10 | 0) > 0) {
  i7 = i13 + 68 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i11 = i13 + 64 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = i1 + i10 | 0;
  HEAP32[i8 >> 2] = 0;
  do if (i4 >>> 0 > i6 >>> 0) {
   i2 = HEAP32[i13 + 88 >> 2] | 0;
   i5 = i6;
   do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i4 >>> 0);
   i3 = i13 + 72 | 0;
   HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i6, i5, HEAP32[i3 >> 2] | 0, i8) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) {
    i1 = i13 + 76 | 0;
    i4 = _UNITY_ft_mem_realloc(i2, 1, i6, i5, HEAP32[i1 >> 2] | 0, i8) | 0;
    HEAP32[i1 >> 2] = i4;
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) {
     HEAP32[i7 >> 2] = i5;
     i7 = i3;
     i5 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i11 >> 2] | 0;
     break;
    }
   }
   i13 = i1;
   STACKTOP = i14;
   return i13 | 0;
  } else {
   i7 = i13 + 72 | 0;
   i5 = i3;
   i4 = HEAP32[i13 + 76 >> 2] | 0;
  } while (0);
  i6 = i13 + 104 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i3 = i8 + (i5 << 3) + -8 | 0;
  if (i3 >>> 0 >= (i8 + (i2 << 3) | 0) >>> 0) {
   i5 = (HEAP32[i13 + 108 >> 2] | 0) + i5 | 0;
   i4 = i4 + i1 | 0;
   i1 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   while (1) {
    i5 = i5 + -1 | 0;
    i7 = i3;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i2 = i1;
    HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP8[i4 >> 0] = HEAPU8[i5 >> 0] & 243;
    i3 = i3 + -8 | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if (i3 >>> 0 < ((HEAP32[i6 >> 2] | 0) + (i2 << 3) | 0) >>> 0) break; else {
     i4 = i4 + 1 | 0;
     i1 = i1 + 8 | 0;
    }
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i12 >> 2] = i2;
  HEAP32[i11 >> 2] = i1 + i10;
  HEAP8[i13 + 80 >> 0] = 0;
  HEAP8[i13 + 112 >> 0] = 0;
 }
 i11 = i13 + 28 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = _ft_stroker_cap(i13, (HEAP32[i13 + 24 >> 2] | 0) + 11796480 | 0) | 0;
 if (i1 | 0) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = i13 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i13 + 64 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 > (i2 + 1 | 0) >>> 0) {
  i10 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i10;
  i12 = HEAP32[i13 + 72 >> 2] | 0;
  i10 = i12 + (i10 << 3) | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i12 + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  i12 = i13 + 76 | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + i2 | 0;
  HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 4;
  i12 = (HEAP32[i12 >> 2] | 0) + (i4 + -2) | 0;
  HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 8;
 } else HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = -1;
 HEAP8[i13 + 80 >> 0] = 0;
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN9Rigidbody22ApplyRootMotionBuiltinEP14RootMotionData(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 12 | 0;
 i1 = i19;
 i17 = i14 + 52 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if (!i2) {
  STACKTOP = i19;
  return;
 }
 i18 = i15 + 32 | 0;
 if (HEAP8[i18 >> 0] | 0) {
  STACKTOP = i19;
  return;
 }
 if (!(HEAP8[i14 + 84 >> 0] | 0)) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i2 | 0);
  f9 = Math_fround(HEAPF32[i16 >> 2]);
  f10 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  f4 = Math_fround(-f9);
  f21 = Math_fround(-f10);
  i1 = HEAP32[i17 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i16 | 0, i1 | 0);
  f27 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f20 = Math_fround(f9 * Math_fround(-2.0));
  f22 = Math_fround(f10 * Math_fround(-2.0));
  f24 = Math_fround(f11 * Math_fround(-2.0));
  f7 = Math_fround(f20 * f4);
  f6 = Math_fround(f22 * f21);
  f23 = Math_fround(f11 * f24);
  f8 = Math_fround(f22 * f4);
  f4 = Math_fround(f24 * f4);
  f21 = Math_fround(f24 * f21);
  f20 = Math_fround(f20 * f12);
  f22 = Math_fround(f22 * f12);
  f24 = Math_fround(f12 * f24);
  f25 = Math_fround(Math_fround(1.0) - Math_fround(f6 - f23));
  f13 = Math_fround(f8 - f24);
  f26 = Math_fround(f4 + f22);
  f24 = Math_fround(f8 + f24);
  f23 = Math_fround(Math_fround(1.0) - Math_fround(f7 - f23));
  f8 = Math_fround(f21 - f20);
  f5 = Math_fround(Math_fround(Math_fround(f24 * f27) + Math_fround(f23 * f5)) + Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2])));
  f22 = Math_fround(f4 - f22);
  f20 = Math_fround(f21 + f20);
  f6 = Math_fround(Math_fround(1.0) - Math_fround(f7 + f6));
  f7 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
  f21 = Math_fround(f7 * Math_fround(HEAPF32[i15 >> 2]));
  f4 = Math_fround(f7 * Math_fround(HEAPF32[i15 + 4 >> 2]));
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i15 + 8 >> 2]));
  f13 = Math_fround(Math_fround(f26 * f7) + Math_fround(Math_fround(f25 * f21) + Math_fround(f13 * f4)));
  f8 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * f4)) + Math_fround(f8 * f7));
  f7 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f4)) + Math_fround(f6 * f7));
  i1 = i15 + 28 | 0;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(Math_fround(f5 * f6) + Math_fround(Math_fround(Math_fround(1.0) - f6) * f8));
  i3 = HEAP32[i17 >> 2] | 0;
  if (!((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0) | 0) & 2)) {
   i3 = __Z21GetManagerFromContexti(9) | 0;
   f4 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(-Math_fround(Math_fround(f6 * Math_fround(0.0)) + Math_fround(Math_fround(1.0) - f6)));
   f4 = Math_fround(f4 * f6);
   f5 = Math_fround(f5 * f6);
   f6 = Math_fround(f27 * f6);
   if (HEAP8[i14 + 80 >> 0] | 0) {
    i1 = f4 < Math_fround(0.0);
    f25 = Math_fround(-f4);
    i2 = f5 < Math_fround(0.0);
    f26 = Math_fround(-f5);
    i3 = f6 < Math_fround(0.0);
    f27 = Math_fround(-f6);
    i1 = (i1 ? f25 : f4) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
    i2 = i1 & (i2 ? f26 : f5) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
    if (!(i2 & (i3 ? f27 : f6) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]))) {
     i3 = HEAP32[i17 >> 2] | 0;
     if (!((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 200 >> 2] | 0, i3 | 0) | 0) & 1)) {
      i3 = HEAP32[i17 >> 2] | 0;
      i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 168 >> 2] | 0;
      HEAPF32[i16 >> 2] = f4;
      HEAPF32[i16 + 4 >> 2] = f5;
      HEAPF32[i16 + 8 >> 2] = f6;
      mftCall_viiii(i2 | 0, i3 | 0, i16 | 0, 0, 1);
     }
    }
   }
  }
  f27 = Math_fround(f9 * Math_fround(2.0));
  f21 = Math_fround(f10 * Math_fround(2.0));
  f25 = Math_fround(f11 * Math_fround(2.0));
  f6 = Math_fround(f9 * f27);
  f22 = Math_fround(f10 * f21);
  f23 = Math_fround(f11 * f25);
  f24 = Math_fround(f9 * f21);
  f20 = Math_fround(f9 * f25);
  f11 = Math_fround(f10 * f25);
  f27 = Math_fround(f27 * f12);
  f21 = Math_fround(f21 * f12);
  f25 = Math_fround(f12 * f25);
  f26 = Math_fround(Math_fround(Math_fround(f11 - f27) * f7) + Math_fround(Math_fround(Math_fround(f24 + f25) * f13) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f6 + f23)) * f8)));
  f27 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f6 + f22)) * f7) + Math_fround(Math_fround(Math_fround(f20 - f21) * f13) + Math_fround(Math_fround(f11 + f27) * f8)));
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(Math_fround(f20 + f21) * f7) + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f22 + f23)) * f13) + Math_fround(Math_fround(f24 - f25) * f8)));
  i1 = i16 + 4 | 0;
  HEAPF32[i1 >> 2] = f26;
  i2 = i16 + 8 | 0;
  HEAPF32[i2 >> 2] = f27;
  i3 = HEAP32[i14 + 88 >> 2] | 0;
  if (i3 & 2 | 0) HEAPF32[i16 >> 2] = Math_fround(0.0);
  if (i3 & 4 | 0) HEAPF32[i1 >> 2] = Math_fround(0.0);
  if (i3 & 8 | 0) HEAPF32[i2 >> 2] = Math_fround(0.0);
  i17 = HEAP32[i17 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i17 >> 2] | 0) + 156 >> 2] | 0, i17 | 0, i16 | 0, 1);
  __ZN9Rigidbody12MoveRotationERK11Quaternionf(i14, i15 + 12 | 0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i2 | 0);
  f25 = Math_fround(HEAPF32[i16 + 16 >> 2]);
  f26 = Math_fround(HEAPF32[i16 + 20 >> 2]);
  f27 = Math_fround(HEAPF32[i16 + 24 >> 2]);
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i15 >> 2]));
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i15 + 4 >> 2]));
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i15 + 8 >> 2]));
  HEAPF32[i1 >> 2] = f25;
  HEAPF32[i1 + 4 >> 2] = f26;
  HEAPF32[i1 + 8 >> 2] = f27;
  __ZN9Rigidbody11SetPositionERK8Vector3f(i14, i1);
  __ZN9Rigidbody11SetRotationERK11Quaternionf(i14, i15 + 12 | 0);
 }
 HEAP8[i18 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f(i36, i1, i6, f37) {
 i36 = i36 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 f37 = Math_fround(f37);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i35 = i36 + 4 | 0;
 i4 = i36 + 20 | 0;
 i5 = i36 + 36 | 0;
 i2 = i36;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f33 = Math_fround(HEAPF32[i6 >> 2]);
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f33 = Math_fround(f33 - f34);
 f34 = Math_fround(Math_fround(f37 - f34) / f33);
 if (f34 < Math_fround(-9.99999974e-06)) {
  i2 = i36;
  i3 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAPF32[i36 >> 2] = f37;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  return;
 }
 if (f34 > Math_fround(1.00001001)) {
  i2 = i36;
  i1 = i6;
  i3 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAPF32[i36 >> 2] = f37;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  return;
 }
 f17 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f18 = Math_fround(f33 * f17);
 f19 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f20 = Math_fround(f33 * f19);
 f21 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f22 = Math_fround(f33 * f21);
 f23 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f24 = Math_fround(f33 * f23);
 f25 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f26 = Math_fround(f33 * f25);
 f27 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f28 = Math_fround(f33 * f27);
 f29 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f30 = Math_fround(f33 * f29);
 f31 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f32 = Math_fround(f33 * f31);
 i3 = i1 + 4 | 0;
 i5 = i1 + 8 | 0;
 i14 = i1 + 12 | 0;
 i16 = i1 + 16 | 0;
 i4 = i6 + 4 | 0;
 i13 = i6 + 8 | 0;
 i15 = i6 + 12 | 0;
 i2 = i6 + 16 | 0;
 f11 = Math_fround(f34 * f34);
 f10 = Math_fround(f11 * Math_fround(6.0));
 f38 = Math_fround(f34 * Math_fround(6.0));
 f7 = Math_fround(f10 - f38);
 f12 = Math_fround(f11 * Math_fround(3.0));
 f8 = Math_fround(Math_fround(f12 - Math_fround(f34 * Math_fround(4.0))) + Math_fround(1.0));
 f9 = Math_fround(f12 - Math_fround(f34 * Math_fround(2.0)));
 f10 = Math_fround(f38 - f10);
 if (f33 > Math_fround(1.74532929e-07)) {
  f39 = Math_fround(Math_fround(f9 * f32) + Math_fround(Math_fround(f8 * f24) + Math_fround(f7 * Math_fround(HEAPF32[i16 >> 2]))));
  f39 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2])) + f39);
  f40 = Math_fround(Math_fround(f9 * f30) + Math_fround(Math_fround(f8 * f22) + Math_fround(f7 * Math_fround(HEAPF32[i14 >> 2]))));
  f40 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i15 >> 2])) + f40);
  f38 = Math_fround(Math_fround(f9 * f28) + Math_fround(Math_fround(f8 * f20) + Math_fround(f7 * Math_fround(HEAPF32[i5 >> 2]))));
  f38 = Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2])) + f38);
  f8 = Math_fround(Math_fround(f9 * f26) + Math_fround(Math_fround(f8 * f18) + Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]))));
  f8 = Math_fround(Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])) + f8) / f33);
  f9 = Math_fround(f40 / f33);
  f10 = Math_fround(f39 / f33);
  f7 = Math_fround(f38 / f33);
 } else {
  f8 = Math_fround(5729578.0);
  f9 = Math_fround(5729578.0);
  f10 = Math_fround(5729578.0);
  f7 = Math_fround(5729578.0);
 }
 i43 = f17 == Math_fround(inf);
 i43 = i43 | f25 == Math_fround(inf);
 f40 = i43 ? Math_fround(inf) : f8;
 i42 = f19 == Math_fround(inf);
 i41 = i42 | f27 == Math_fround(inf);
 f19 = i41 ? Math_fround(inf) : f7;
 i41 = f21 == Math_fround(inf);
 i6 = i41 | f29 == Math_fround(inf);
 f17 = i6 ? Math_fround(inf) : f9;
 i6 = f23 == Math_fround(inf);
 i44 = i6 | f31 == Math_fround(inf);
 f33 = i44 ? Math_fround(inf) : f10;
 HEAPF32[i36 + 20 >> 2] = f40;
 HEAPF32[i36 + 24 >> 2] = f19;
 HEAPF32[i36 + 28 >> 2] = f17;
 HEAPF32[i36 + 32 >> 2] = f33;
 HEAPF32[i36 + 36 >> 2] = f40;
 HEAPF32[i36 + 40 >> 2] = f19;
 HEAPF32[i36 + 44 >> 2] = f17;
 HEAPF32[i36 + 48 >> 2] = f33;
 HEAPF32[i36 >> 2] = f37;
 f33 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f19 = Math_fround(HEAPF32[i14 >> 2]);
 f40 = Math_fround(HEAPF32[i16 >> 2]);
 f37 = Math_fround(HEAPF32[i4 >> 2]);
 f38 = Math_fround(HEAPF32[i13 >> 2]);
 f39 = Math_fround(HEAPF32[i15 >> 2]);
 f21 = Math_fround(f34 * f11);
 f10 = Math_fround(f21 * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f10 - f12) + Math_fround(1.0));
 f23 = Math_fround(f34 + Math_fround(f21 - Math_fround(f11 * Math_fround(2.0))));
 f21 = Math_fround(f21 - f11);
 f34 = Math_fround(f12 - f10);
 f38 = Math_fround(Math_fround(Math_fround(f21 * f28) + Math_fround(Math_fround(f23 * f20) + Math_fround(f25 * f17))) + Math_fround(f34 * f38));
 f39 = Math_fround(Math_fround(Math_fround(f21 * f30) + Math_fround(Math_fround(f23 * f22) + Math_fround(f25 * f19))) + Math_fround(f34 * f39));
 f40 = Math_fround(Math_fround(Math_fround(f21 * f32) + Math_fround(Math_fround(f23 * f24) + Math_fround(f25 * f40))) + Math_fround(f34 * Math_fround(HEAPF32[i2 >> 2])));
 HEAPF32[i36 + 4 >> 2] = Math_fround(Math_fround(Math_fround(f21 * f26) + Math_fround(Math_fround(f23 * f18) + Math_fround(f25 * f33))) + Math_fround(f34 * f37));
 HEAPF32[i36 + 8 >> 2] = f38;
 HEAPF32[i36 + 12 >> 2] = f39;
 HEAPF32[i36 + 16 >> 2] = f40;
 i36 = i43 | i42 | (f27 == Math_fround(inf) | i41);
 i36 = i36 | (f29 == Math_fround(inf) | i6);
 if (!(i36 | f31 == Math_fround(inf))) return;
 i44 = i1 + 4 | 0;
 HEAP32[i35 >> 2] = HEAP32[i44 >> 2];
 HEAP32[i35 + 4 >> 2] = HEAP32[i44 + 4 >> 2];
 HEAP32[i35 + 8 >> 2] = HEAP32[i44 + 8 >> 2];
 HEAP32[i35 + 12 >> 2] = HEAP32[i44 + 12 >> 2];
 return;
}

function __ZN5physx14PxsAABBManager11preAllocateEjjj(i12, i1, i2, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 1 | 0;
 i14 = i15;
 i8 = i1 + 31 & -32;
 i9 = i2 + 31 & -32;
 i10 = i9 + i8 | 0;
 if (!(i10 | i11)) {
  STACKTOP = i15;
  return;
 }
 if ((HEAP32[i12 + 36 >> 2] | 0) >>> 0 < i10 >>> 0) {
  __ZN5physx5Elems4growEj(i12 + 8 | 0, i10);
  i5 = i12 + 44 | 0;
  i6 = i12 + 48 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i8 >>> 0 > i2 >>> 0) {
   i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i8 << 3, gb + 717789 | 0, 1491) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    _memcpy(i7 | 0, i1 | 0, i2 << 3 | 0) | 0;
    _memset(i7 + (i2 << 3) | 0, 0, i8 - i2 << 3 | 0) | 0;
   }
   i3 = i12 + 52 | 0;
   i4 = i8 + -1 | 0;
   HEAP32[i7 + (i4 << 3) >> 2] = HEAP32[i3 >> 2];
   if (i2 >>> 0 < i4 >>> 0) {
    i1 = i2;
    do {
     i2 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i7 + (i2 << 3) >> 2] = i1;
    } while ((i1 | 0) != (i4 | 0));
   }
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, HEAP32[i5 >> 2] | 0);
   HEAP32[i5 >> 2] = i7;
   HEAP32[i6 >> 2] = i8;
  }
  i5 = i12 + 56 | 0;
  i6 = i12 + 60 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i9 >>> 0 > i2 >>> 0) {
   i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i9 << 4, gb + 717789 | 0, 1491) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    _memcpy(i7 | 0, i1 | 0, i2 << 4 | 0) | 0;
    _memset(i7 + (i2 << 4) | 0, 0, i9 - i2 << 4 | 0) | 0;
   }
   i3 = i12 + 64 | 0;
   i4 = i9 + -1 | 0;
   HEAP32[i7 + (i4 << 4) >> 2] = HEAP32[i3 >> 2];
   if (i2 >>> 0 < i4 >>> 0) {
    i1 = i2;
    do {
     i8 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i7 + (i8 << 4) >> 2] = i1;
    } while ((i1 | 0) != (i4 | 0));
   }
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, HEAP32[i5 >> 2] | 0);
   HEAP32[i5 >> 2] = i7;
   HEAP32[i6 >> 2] = i9;
  }
  i9 = i12 + 68 | 0;
  i5 = i12 + 92 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
  HEAP32[i5 >> 2] = i1;
  i5 = i12 + 88 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 > i6 >>> 0) {
   i1 = i1 + 31 & -32;
   i2 = i12 + 80 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i1 << 2, gb + 717789 | 0, 59) | 0;
   if (i3 | 0) _memcpy(i4 | 0, i3 | 0, i6 << 2 | 0) | 0;
   _memset(i4 + (i6 << 2) | 0, 0, i1 - i6 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i3);
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
  }
  i8 = i12 + 96 | 0;
  i5 = i12 + 120 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
  HEAP32[i5 >> 2] = i1;
  i5 = i12 + 116 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 > i6 >>> 0) {
   i1 = i1 + 31 & -32;
   i2 = i12 + 108 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i1 << 2, gb + 717789 | 0, 59) | 0;
   if (i3 | 0) _memcpy(i4 | 0, i3 | 0, i6 << 2 | 0) | 0;
   _memset(i4 + (i6 << 2) | 0, 0, i1 - i6 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i3);
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
  }
  i7 = i12 + 124 | 0;
  i5 = i12 + 148 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
  HEAP32[i5 >> 2] = i1;
  i5 = i12 + 144 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 > i6 >>> 0) {
   i1 = i1 + 31 & -32;
   i2 = i12 + 136 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i1 << 2, gb + 717789 | 0, 59) | 0;
   if (i3 | 0) _memcpy(i4 | 0, i3 | 0, i6 << 2 | 0) | 0;
   _memset(i4 + (i6 << 2) | 0, 0, i1 - i6 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i3);
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
  }
  i6 = (i10 >>> 5) + 3 & 268435452;
  i1 = i12 + 72 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2 & 2147483647;
  if (i6 >>> 0 > i3 >>> 0) {
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i6 << 2, gb + 717789 | 0, 59) | 0;
   if (i4 | 0) _memcpy(i5 | 0, i4 | 0, i2 << 2 | 0) | 0;
   _memset(i5 + (i3 << 2) | 0, 0, i6 - i2 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i4);
   HEAP32[i9 >> 2] = i5;
   HEAP32[i1 >> 2] = i6 | -2147483648;
  }
  i1 = i12 + 100 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2 & 2147483647;
  if (i6 >>> 0 > i3 >>> 0) {
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i6 << 2, gb + 717789 | 0, 59) | 0;
   if (i4 | 0) _memcpy(i5 | 0, i4 | 0, i2 << 2 | 0) | 0;
   _memset(i5 + (i3 << 2) | 0, 0, i6 - i2 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i4);
   HEAP32[i8 >> 2] = i5;
   HEAP32[i1 >> 2] = i6 | -2147483648;
  }
  i1 = i12 + 128 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2 & 2147483647;
  if (i6 >>> 0 > i3 >>> 0) {
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i6 << 2, gb + 717789 | 0, 59) | 0;
   if (i4 | 0) _memcpy(i5 | 0, i4 | 0, i2 << 2 | 0) | 0;
   _memset(i5 + (i3 << 2) | 0, 0, i6 - i2 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i4);
   HEAP32[i7 >> 2] = i5;
   HEAP32[i1 >> 2] = i6 | -2147483648;
  }
 }
 if ((HEAP32[i12 + 324 >> 2] | 0) >>> 0 < i10 >>> 0) {
  HEAP32[i12 + 328 >> 2] = 1073741823;
  __ZN5physx5Elems4growEj(i12 + 296 | 0, i10);
 }
 if ((HEAP32[i12 + 164 >> 2] | 0) >>> 0 < i10 >>> 0) __ZN5physx13SingleManager6resizeEj(i12 + 152 | 0, i10);
 if ((HEAP32[i12 + 196 >> 2] | 0) >>> 0 >= i11 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i11 + 3 & -4;
 __ZN5physx16AggregateManager6resizeEj(i12 + 176 | 0, i7);
 i6 = i12 + 356 | 0;
 i7 = ((i7 + 31 | 0) >>> 5) + 3 & 268435452;
 i2 = i12 + 360 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i7 >>> 0 <= i4 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 << 2, gb + 717789 | 0, 59) | 0;
 if (i5 | 0) _memcpy(i1 | 0, i5 | 0, i3 << 2 | 0) | 0;
 _memset(i1 + (i4 << 2) | 0, 0, i7 - i3 << 2 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, i5);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i7 | -2147483648;
 STACKTOP = i15;
 return;
}

function __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_(i67, i68, i49, i11, i60) {
 i67 = i67 | 0;
 i68 = i68 | 0;
 i49 = i49 | 0;
 i11 = i11 | 0;
 i60 = i60 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0;
 i69 = __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i67, i68, i49, i60) | 0;
 if (!(mftCall_iii(HEAP32[i60 >> 2] | 0, i11 | 0, i49 | 0) | 0)) {
  i72 = i69;
  return i72 | 0;
 }
 i23 = HEAP32[i49 >> 2] | 0;
 i66 = i49 + 4 | 0;
 i1 = HEAP32[i66 >> 2] | 0;
 i44 = i49 + 8 | 0;
 i2 = HEAP32[i44 >> 2] | 0;
 i45 = i49 + 12 | 0;
 i3 = HEAP32[i45 >> 2] | 0;
 i46 = i49 + 16 | 0;
 i4 = HEAP32[i46 >> 2] | 0;
 i47 = i49 + 20 | 0;
 i5 = HEAP32[i47 >> 2] | 0;
 i48 = i49 + 24 | 0;
 i6 = HEAP32[i48 >> 2] | 0;
 i50 = i49 + 28 | 0;
 i7 = HEAP32[i50 >> 2] | 0;
 i51 = i49 + 32 | 0;
 i8 = HEAP32[i51 >> 2] | 0;
 i52 = i49 + 36 | 0;
 i9 = HEAP32[i52 >> 2] | 0;
 i53 = i49 + 40 | 0;
 i10 = HEAP32[i53 >> 2] | 0;
 i54 = i49 + 44 | 0;
 i12 = HEAP32[i54 >> 2] | 0;
 i55 = i49 + 48 | 0;
 i13 = HEAP32[i55 >> 2] | 0;
 i56 = i49 + 52 | 0;
 i14 = HEAP32[i56 >> 2] | 0;
 i57 = i49 + 56 | 0;
 i15 = HEAP32[i57 >> 2] | 0;
 i58 = i49 + 60 | 0;
 i16 = HEAP32[i58 >> 2] | 0;
 i59 = i49 + 64 | 0;
 i17 = HEAP32[i59 >> 2] | 0;
 i61 = i49 + 68 | 0;
 i18 = HEAP32[i61 >> 2] | 0;
 i62 = i49 + 72 | 0;
 i19 = HEAP32[i62 >> 2] | 0;
 i63 = i49 + 76 | 0;
 i20 = HEAP32[i63 >> 2] | 0;
 i64 = i49 + 80 | 0;
 i21 = HEAP32[i64 >> 2] | 0;
 i65 = i49 + 84 | 0;
 i22 = HEAP32[i65 >> 2] | 0;
 i70 = i49;
 i71 = i11;
 i72 = i70 + 88 | 0;
 do {
  HEAP32[i70 >> 2] = HEAP32[i71 >> 2];
  i70 = i70 + 4 | 0;
  i71 = i71 + 4 | 0;
 } while ((i70 | 0) < (i72 | 0));
 HEAP32[i11 >> 2] = i23;
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = i2;
 HEAP32[i11 + 12 >> 2] = i3;
 HEAP32[i11 + 16 >> 2] = i4;
 HEAP32[i11 + 20 >> 2] = i5;
 HEAP32[i11 + 24 >> 2] = i6;
 HEAP32[i11 + 28 >> 2] = i7;
 HEAP32[i11 + 32 >> 2] = i8;
 HEAP32[i11 + 36 >> 2] = i9;
 HEAP32[i11 + 40 >> 2] = i10;
 HEAP32[i11 + 44 >> 2] = i12;
 HEAP32[i11 + 48 >> 2] = i13;
 HEAP32[i11 + 52 >> 2] = i14;
 HEAP32[i11 + 56 >> 2] = i15;
 HEAP32[i11 + 60 >> 2] = i16;
 HEAP32[i11 + 64 >> 2] = i17;
 HEAP32[i11 + 68 >> 2] = i18;
 HEAP32[i11 + 72 >> 2] = i19;
 HEAP32[i11 + 76 >> 2] = i20;
 HEAP32[i11 + 80 >> 2] = i21;
 HEAP32[i11 + 84 >> 2] = i22;
 if (!(mftCall_iii(HEAP32[i60 >> 2] | 0, i49 | 0, i68 | 0) | 0)) {
  i72 = i69 + 1 | 0;
  return i72 | 0;
 }
 i1 = HEAP32[i68 >> 2] | 0;
 i23 = i68 + 4 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 i24 = i68 + 8 | 0;
 i3 = HEAP32[i24 >> 2] | 0;
 i25 = i68 + 12 | 0;
 i4 = HEAP32[i25 >> 2] | 0;
 i26 = i68 + 16 | 0;
 i5 = HEAP32[i26 >> 2] | 0;
 i27 = i68 + 20 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i28 = i68 + 24 | 0;
 i7 = HEAP32[i28 >> 2] | 0;
 i29 = i68 + 28 | 0;
 i8 = HEAP32[i29 >> 2] | 0;
 i30 = i68 + 32 | 0;
 i9 = HEAP32[i30 >> 2] | 0;
 i31 = i68 + 36 | 0;
 i10 = HEAP32[i31 >> 2] | 0;
 i32 = i68 + 40 | 0;
 i11 = HEAP32[i32 >> 2] | 0;
 i33 = i68 + 44 | 0;
 i12 = HEAP32[i33 >> 2] | 0;
 i34 = i68 + 48 | 0;
 i13 = HEAP32[i34 >> 2] | 0;
 i35 = i68 + 52 | 0;
 i14 = HEAP32[i35 >> 2] | 0;
 i36 = i68 + 56 | 0;
 i15 = HEAP32[i36 >> 2] | 0;
 i37 = i68 + 60 | 0;
 i16 = HEAP32[i37 >> 2] | 0;
 i38 = i68 + 64 | 0;
 i17 = HEAP32[i38 >> 2] | 0;
 i39 = i68 + 68 | 0;
 i18 = HEAP32[i39 >> 2] | 0;
 i40 = i68 + 72 | 0;
 i19 = HEAP32[i40 >> 2] | 0;
 i41 = i68 + 76 | 0;
 i20 = HEAP32[i41 >> 2] | 0;
 i42 = i68 + 80 | 0;
 i21 = HEAP32[i42 >> 2] | 0;
 i43 = i68 + 84 | 0;
 i22 = HEAP32[i43 >> 2] | 0;
 i70 = i68;
 i71 = i49;
 i72 = i70 + 88 | 0;
 do {
  HEAP32[i70 >> 2] = HEAP32[i71 >> 2];
  i70 = i70 + 4 | 0;
  i71 = i71 + 4 | 0;
 } while ((i70 | 0) < (i72 | 0));
 HEAP32[i49 >> 2] = i1;
 HEAP32[i66 >> 2] = i2;
 HEAP32[i44 >> 2] = i3;
 HEAP32[i45 >> 2] = i4;
 HEAP32[i46 >> 2] = i5;
 HEAP32[i47 >> 2] = i6;
 HEAP32[i48 >> 2] = i7;
 HEAP32[i50 >> 2] = i8;
 HEAP32[i51 >> 2] = i9;
 HEAP32[i52 >> 2] = i10;
 HEAP32[i53 >> 2] = i11;
 HEAP32[i54 >> 2] = i12;
 HEAP32[i55 >> 2] = i13;
 HEAP32[i56 >> 2] = i14;
 HEAP32[i57 >> 2] = i15;
 HEAP32[i58 >> 2] = i16;
 HEAP32[i59 >> 2] = i17;
 HEAP32[i61 >> 2] = i18;
 HEAP32[i62 >> 2] = i19;
 HEAP32[i63 >> 2] = i20;
 HEAP32[i64 >> 2] = i21;
 HEAP32[i65 >> 2] = i22;
 if (!(mftCall_iii(HEAP32[i60 >> 2] | 0, i68 | 0, i67 | 0) | 0)) {
  i72 = i69 + 2 | 0;
  return i72 | 0;
 }
 i1 = HEAP32[i67 >> 2] | 0;
 i2 = HEAP32[i67 + 4 >> 2] | 0;
 i3 = HEAP32[i67 + 8 >> 2] | 0;
 i4 = HEAP32[i67 + 12 >> 2] | 0;
 i5 = HEAP32[i67 + 16 >> 2] | 0;
 i6 = HEAP32[i67 + 20 >> 2] | 0;
 i7 = HEAP32[i67 + 24 >> 2] | 0;
 i8 = HEAP32[i67 + 28 >> 2] | 0;
 i9 = HEAP32[i67 + 32 >> 2] | 0;
 i10 = HEAP32[i67 + 36 >> 2] | 0;
 i11 = HEAP32[i67 + 40 >> 2] | 0;
 i12 = HEAP32[i67 + 44 >> 2] | 0;
 i13 = HEAP32[i67 + 48 >> 2] | 0;
 i14 = HEAP32[i67 + 52 >> 2] | 0;
 i15 = HEAP32[i67 + 56 >> 2] | 0;
 i16 = HEAP32[i67 + 60 >> 2] | 0;
 i17 = HEAP32[i67 + 64 >> 2] | 0;
 i18 = HEAP32[i67 + 68 >> 2] | 0;
 i19 = HEAP32[i67 + 72 >> 2] | 0;
 i20 = HEAP32[i67 + 76 >> 2] | 0;
 i21 = HEAP32[i67 + 80 >> 2] | 0;
 i22 = HEAP32[i67 + 84 >> 2] | 0;
 i70 = i67;
 i71 = i68;
 i72 = i70 + 88 | 0;
 do {
  HEAP32[i70 >> 2] = HEAP32[i71 >> 2];
  i70 = i70 + 4 | 0;
  i71 = i71 + 4 | 0;
 } while ((i70 | 0) < (i72 | 0));
 HEAP32[i68 >> 2] = i1;
 HEAP32[i23 >> 2] = i2;
 HEAP32[i24 >> 2] = i3;
 HEAP32[i25 >> 2] = i4;
 HEAP32[i26 >> 2] = i5;
 HEAP32[i27 >> 2] = i6;
 HEAP32[i28 >> 2] = i7;
 HEAP32[i29 >> 2] = i8;
 HEAP32[i30 >> 2] = i9;
 HEAP32[i31 >> 2] = i10;
 HEAP32[i32 >> 2] = i11;
 HEAP32[i33 >> 2] = i12;
 HEAP32[i34 >> 2] = i13;
 HEAP32[i35 >> 2] = i14;
 HEAP32[i36 >> 2] = i15;
 HEAP32[i37 >> 2] = i16;
 HEAP32[i38 >> 2] = i17;
 HEAP32[i39 >> 2] = i18;
 HEAP32[i40 >> 2] = i19;
 HEAP32[i41 >> 2] = i20;
 HEAP32[i42 >> 2] = i21;
 HEAP32[i43 >> 2] = i22;
 i72 = i69 + 3 | 0;
 return i72 | 0;
}

function __ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i21, i22, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 16 | 0;
 i4 = i25 + 8 | 0;
 i5 = i25 + 4 | 0;
 i9 = i25;
 i24 = HEAP32[i22 + 12 >> 2] | 0;
 i11 = HEAP32[i22 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i11 + 4 >> 2])));
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i11 + 8 >> 2])));
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f2 = Math_fround(f6 + f2);
 HEAPF32[i23 >> 2] = f2;
 HEAPF32[i5 >> 2] = f2;
 HEAPF32[i4 >> 2] = f2;
 if (i24 >>> 0 > 1) {
  i1 = 1;
  f3 = f2;
  do {
   f26 = Math_fround(f10 * Math_fround(HEAPF32[i11 + (i1 * 12 | 0) >> 2]));
   f26 = Math_fround(f26 + Math_fround(f7 * Math_fround(HEAPF32[i11 + (i1 * 12 | 0) + 4 >> 2])));
   f26 = Math_fround(f6 + Math_fround(f26 + Math_fround(f8 * Math_fround(HEAPF32[i11 + (i1 * 12 | 0) + 8 >> 2]))));
   HEAPF32[i9 >> 2] = f26;
   HEAPF32[i23 + (i1 << 2) >> 2] = f26;
   i19 = HEAP32[(f26 < f3 ? i9 : i4) >> 2] | 0;
   HEAP32[i4 >> 2] = i19;
   i20 = HEAP32[(f2 < f26 ? i9 : i5) >> 2] | 0;
   HEAP32[i5 >> 2] = i20;
   i1 = i1 + 1 | 0;
   f3 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i1 | 0) != (i24 | 0));
 } else f3 = f2;
 if (f2 <= Math_fround(0.0)) {
  i24 = -1;
  STACKTOP = i25;
  return i24 | 0;
 }
 if (f3 > Math_fround(0.0)) {
  i24 = 1;
  STACKTOP = i25;
  return i24 | 0;
 }
 i18 = i21 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i21 + 16 | 0;
 i1 = i24 + -1 | 0;
 if (!i24) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i20 = i21 + 4 | 0;
 f2 = Math_fround(HEAPF32[i23 + (i1 << 2) >> 2]);
 i17 = 0;
 i5 = i11 + (i1 * 12 | 0) | 0;
 i4 = i11 + (i1 * 12 | 0) + 4 | 0;
 i1 = i11 + (i1 * 12 | 0) + 8 | 0;
 i16 = i11;
 while (1) {
  i15 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i4 >> 2] | 0;
  i13 = HEAP32[i5 >> 2] | 0;
  i5 = i16 + (i17 * 12 | 0) | 0;
  f3 = Math_fround(HEAPF32[i23 + (i17 << 2) >> 2]);
  if (f2 > Math_fround(0.0) & f3 < Math_fround(0.0)) {
   f2 = Math_fround(Math_fround(-f3) / Math_fround(f2 - f3));
   i4 = HEAP32[i18 >> 2] | 0;
   i9 = i4 + 1 | 0;
   i11 = HEAP32[i19 >> 2] | 0;
   i12 = i11 & 2147483647;
   do if (i9 >>> 0 > i12 >>> 0) {
    i1 = i11 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i12 >>> 0 < i1 >>> 0) if ((i11 | 0) > -1) {
     HEAP32[i19 >> 2] = i1;
     HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i12 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i21 >> 2] = i12;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i9;
   i12 = HEAP32[i21 >> 2] | 0;
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f2);
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f2);
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f2);
   f26 = Math_fround(Math_fround(1.0) - f2);
   f8 = Math_fround(f26 * Math_fround(HEAPF32[i5 >> 2]));
   f10 = Math_fround(f26 * Math_fround(HEAPF32[i16 + (i17 * 12 | 0) + 4 >> 2]));
   f10 = Math_fround(f27 + f10);
   f26 = Math_fround(f6 + Math_fround(f26 * Math_fround(HEAPF32[i16 + (i17 * 12 | 0) + 8 >> 2])));
   HEAPF32[i12 + (i4 * 12 | 0) >> 2] = Math_fround(f7 + f8);
   HEAPF32[i12 + (i4 * 12 | 0) + 4 >> 2] = f10;
   HEAPF32[i12 + (i4 * 12 | 0) + 8 >> 2] = f26;
  } else if (f2 < Math_fround(0.0) & f3 > Math_fround(0.0)) {
   f2 = Math_fround(Math_fround(-f2) / Math_fround(f3 - f2));
   i4 = HEAP32[i18 >> 2] | 0;
   i9 = i4 + 1 | 0;
   i11 = HEAP32[i19 >> 2] | 0;
   i12 = i11 & 2147483647;
   do if (i9 >>> 0 > i12 >>> 0) {
    i1 = i11 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i12 >>> 0 < i1 >>> 0) if ((i11 | 0) > -1) {
     HEAP32[i19 >> 2] = i1;
     HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i12 | 0, HEAP32[i21 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i21 >> 2] = i12;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i9;
   i12 = HEAP32[i21 >> 2] | 0;
   f10 = Math_fround(f2 * Math_fround(HEAPF32[i5 >> 2]));
   f26 = Math_fround(f2 * Math_fround(HEAPF32[i16 + (i17 * 12 | 0) + 4 >> 2]));
   f27 = Math_fround(f2 * Math_fround(HEAPF32[i16 + (i17 * 12 | 0) + 8 >> 2]));
   f7 = Math_fround(Math_fround(1.0) - f2);
   f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7);
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7);
   f26 = Math_fround(f6 + f26);
   f27 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7) + f27);
   HEAPF32[i12 + (i4 * 12 | 0) >> 2] = Math_fround(f8 + f10);
   HEAPF32[i12 + (i4 * 12 | 0) + 4 >> 2] = f26;
   HEAPF32[i12 + (i4 * 12 | 0) + 8 >> 2] = f27;
  }
  if (f3 <= Math_fround(0.0)) __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i21, i5);
  i1 = i17 + 1 | 0;
  if ((i1 | 0) == (i24 | 0)) {
   i1 = 0;
   break;
  }
  i15 = i16 + (i17 * 12 | 0) + 8 | 0;
  i4 = i16 + (i17 * 12 | 0) + 4 | 0;
  f2 = f3;
  i17 = i1;
  i1 = i15;
  i16 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i25;
 return i1 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E9copy_fromERKSL_j(i7, i26, i2) {
 i7 = i7 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 12 | 0;
 i6 = i28 + 24 | 0;
 i27 = i28;
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5clearEv(i7);
 f1 = Math_fround(((HEAP32[i26 + 92 >> 2] | 0) - (HEAP32[i26 + 4 >> 2] | 0) | 0) >>> 0);
 i3 = 32;
 while (1) {
  if (i3 >>> 0 >= i2 >>> 0) {
   f4 = Math_fround(i3 >>> 0);
   f5 = Math_fround(f4 * Math_fround(.5));
   if (!(f1 >= f5)) break;
  }
  i3 = i3 << 1;
 }
 i24 = i7 + 88 | 0;
 if (i3 >>> 0 > (HEAP32[i24 >> 2] | 0) >>> 0) {
  HEAP8[i25 >> 0] = HEAP8[i6 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i7, i3, i25);
  HEAP32[i24 >> 2] = i3;
  HEAP32[i7 + 100 >> 2] = ~~f5 >>> 0;
  HEAP32[i7 + 96 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
  HEAP8[i7 + 104 >> 0] = 0;
 }
 i16 = i26 + 84 | 0;
 i18 = HEAP32[i16 >> 2] | 0;
 i17 = i26 + 88 | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i25, i26, i18, i18 + ((HEAP32[i17 >> 2] | 0) * 36 | 0) | 0, 1);
 i18 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 36 | 0) | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i27, i26, i18, i18, 1);
 i18 = i25 + 4 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i19 = i27 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i19 >> 2] | 0)) {
  STACKTOP = i28;
  return;
 }
 i20 = i7 + 84 | 0;
 i21 = i7 + 68 | 0;
 i22 = i7 + 48 | 0;
 i23 = i7 + 52 | 0;
 i15 = i7 + 92 | 0;
 do {
  i12 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i14 = i2 + 4 | 0;
  i3 = (i3 | 0) == 0 ? i14 : i3;
  i7 = HEAP8[i3 >> 0] | 0;
  if (!(i7 << 24 >> 24)) i6 = 5381; else {
   i6 = 5381;
   do {
    i3 = i3 + 1 | 0;
    i6 = i6 * 33 ^ i7 << 24 >> 24;
    i7 = HEAP8[i3 >> 0] | 0;
   } while (i7 << 24 >> 24 != 0);
  }
  i13 = HEAP32[i20 >> 2] | 0;
  i10 = HEAP32[i21 >> 2] | 0;
  i11 = HEAP32[i22 >> 2] | 0;
  i11 = (i11 | 0) == 0 ? i23 : i11;
  L19 : do if (!i10) {
   i3 = i6 & i12;
   if (HEAP32[i13 + (i3 * 36 | 0) + 20 >> 2] | 0) {
    i6 = 0;
    do {
     i6 = i6 + 1 | 0;
     i3 = i6 + i3 & i12;
    } while ((HEAP32[i13 + (i3 * 36 | 0) + 20 >> 2] | 0) != 0);
   }
  } else {
   i9 = 0;
   while (1) {
    i3 = i6 & i12;
    L25 : do if ((i10 | 0) == (HEAP32[i13 + (i3 * 36 | 0) + 20 >> 2] | 0)) {
     i7 = HEAP32[i13 + (i3 * 36 | 0) >> 2] | 0;
     i6 = i10;
     i7 = (i7 | 0) == 0 ? i13 + (i3 * 36 | 0) + 4 | 0 : i7;
     i8 = i11;
     while (1) {
      if ((HEAP8[i8 >> 0] | 0) != (HEAP8[i7 >> 0] | 0)) break L25;
      i6 = i6 + -1 | 0;
      if (!i6) break L19; else {
       i7 = i7 + 1 | 0;
       i8 = i8 + 1 | 0;
      }
     }
    } while (0);
    i6 = i9 + 1 | 0;
    i9 = i6;
    i6 = i6 + i3 | 0;
   }
  } while (0);
  i11 = i13 + (i3 * 36 | 0) | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if (i6 | 0) if (HEAP32[i13 + (i3 * 36 | 0) + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i6, i13 + (i3 * 36 | 0) + 24 | 0);
  HEAP32[i11 >> 2] = 0;
  i12 = i13 + (i3 * 36 | 0) + 20 | 0;
  HEAP32[i12 >> 2] = 0;
  i10 = i13 + (i3 * 36 | 0) + 24 | 0;
  i8 = i2 + 24 | 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i10;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i9;
  i6 = i13 + (i3 * 36 | 0) + 4 | 0;
  HEAP8[i6 >> 0] = 0;
  do if ((i11 | 0) != (i2 | 0)) {
   i8 = HEAP32[i2 >> 2] | 0;
   i29 = (i8 | 0) == 0;
   i8 = i29 ? i14 : i8;
   i9 = HEAP32[i2 + 20 >> 2] | 0;
   i7 = i13 + (i3 * 36 | 0) + 4 | 0;
   if (!((HEAP32[i2 + 4 >> 2] | 0) != 0 | i29)) {
    HEAP32[i11 >> 2] = i8;
    HEAP32[i12 >> 2] = i9;
    HEAP32[i7 >> 2] = 0;
    break;
   }
   if (i9 >>> 0 > 15) {
    i29 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + 1 | 0, 16, i10, 0, gb + 1047486 | 0, 251) | 0;
    HEAP32[i11 >> 2] = i29;
    HEAP32[i7 >> 2] = i9;
    i6 = (i29 | 0) == 0 ? i6 : i29;
   }
   _memcpy(i6 | 0, i8 | 0, i9 | 0) | 0;
   HEAP8[i6 + i9 >> 0] = 0;
   HEAP32[i12 >> 2] = i9;
  } while (0);
  HEAP32[i13 + (i3 * 36 | 0) + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i25) | 0;
  i29 = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 36 | 0) | 0;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i27, i26, i29, i29, 1);
  i2 = HEAP32[i18 >> 2] | 0;
 } while ((i2 | 0) != (HEAP32[i19 >> 2] | 0));
 STACKTOP = i28;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags(i37, i32, i1) {
 i37 = i37 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36 + 56 | 0;
 i28 = i36 + 44 | 0;
 i29 = i36 + 40 | 0;
 i34 = i36 + 20 | 0;
 i30 = i36;
 i31 = i32 + 8 | 0;
 HEAP32[i29 >> 2] = HEAP32[i31 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i37, gb + 1041885 | 0, gb + 1041885 | 0, i29) | 0)) {
  STACKTOP = i36;
  return;
 };
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 HEAP32[i34 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i34 >> 2] = 0;
 HEAP32[i34 + 4 >> 2] = 0;
 HEAP32[i34 + 8 >> 2] = 0;
 i7 = i34 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i27 = i32 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i32, HEAP32[i27 >> 2] | 0);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i32 >> 2] = i27;
 HEAP32[i27 >> 2] = 0;
 if ((HEAP32[i29 >> 2] | 0) > 0) {
  i8 = HEAP32[gb + 37152 >> 2] | 0;
  i1 = i34 + 11 | 0;
  i9 = i34 + 4 | 0;
  i10 = i30 + 12 | 0;
  i6 = i30 + 12 | 0;
  i11 = i33 + 4 | 0;
  i12 = i30 + 8 | 0;
  i13 = i30 + 4 | 0;
  i14 = i30 + 16 | 0;
  i15 = i32 + 4 | 0;
  i16 = i30 + 11 | 0;
  i17 = i33 + 4 | 0;
  i18 = HEAP32[gb + 37008 >> 2] | 0;
  i19 = HEAP32[gb + 37260 >> 2] | 0;
  i20 = HEAP32[gb + 37224 >> 2] | 0;
  i21 = HEAP32[gb + 37040 >> 2] | 0;
  i22 = i37 + 16 | 0;
  i23 = i37 + 80 | 0;
  i24 = i37 + 20 | 0;
  i25 = i37 + 32 | 0;
  i26 = i37 + 36 | 0;
  i27 = i37 + 24 | 0;
  i5 = 0;
  do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i37, gb + 1041891 | 0, i8, i28, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) {
     i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i37, i18, i19, i33, 0) | 0;
     if (i2 | 0) {
      if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i37, i34, 1); else {
       i2 = HEAP32[i33 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i34 | 0, i37 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i37);
     }
     i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i37, i20, i21, i33, 0) | 0;
     if (i2 | 0) {
      if ((i2 | 0) > 0) {
       i4 = HEAP32[i24 >> 2] | 0;
       i2 = i4 + (HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i26 >> 2] | 0, 0 - (HEAP32[i25 >> 2] | 0) | 0) | 0) | 0;
       HEAP32[i22 >> 2] = i2;
       if (i2 >>> 0 < i4 >>> 0) i35 = 21; else {
        i3 = i2 + 4 | 0;
        if (i3 >>> 0 > (HEAP32[i27 >> 2] | 0) >>> 0) i35 = 21; else {
         HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i22 >> 2] = i3;
        }
       }
       if ((i35 | 0) == 21) {
        i35 = 0;
        __ZN12CachedReader15UpdateReadCacheEPvj(i22, i7, 4);
       }
       if (HEAP32[i37 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
      } else {
       i2 = HEAP32[i33 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i7 | 0, i37 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i37);
     }
    } else {
     i2 = HEAP32[i28 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i34 | 0, i37 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i37);
   }
   i4 = HEAP8[i1 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i34 >> 2] | 0 : i34;
   i4 = i2 ? HEAP32[i9 >> 2] | 0 : i4 & 255;
   HEAP32[i30 >> 2] = 0;
   HEAP32[i30 + 4 >> 2] = 0;
   HEAP32[i30 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i30);
    i2 = HEAP32[i6 >> 2] | 0;
    i35 = 34;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i16 >> 0] = i4;
    if (!i4) i2 = i30; else {
     i2 = i30;
     i35 = 36;
    }
   } else i35 = 34;
   if ((i35 | 0) == 34) {
    i38 = i4 + 16 & -16;
    HEAP32[i33 >> 2] = 66;
    HEAP32[i11 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i38, 16, i33, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i30 >> 2] = i2;
    HEAP32[i12 >> 2] = i38 | -2147483648;
    HEAP32[i13 >> 2] = i4;
    i35 = 36;
   }
   if ((i35 | 0) == 36) {
    i35 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
   i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i32, i33, i30) | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i28, i32, i30);
    i2 = HEAP32[i28 >> 2] | 0;
    HEAP32[i28 >> 2] = 0;
    i4 = HEAP32[i33 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i2;
    i4 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i32 >> 2] = i4;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 >> 2] | 0, i2);
    HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
   }
   if ((HEAP8[i16 >> 0] | 0) < 0) {
    i38 = HEAP32[i30 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    HEAP32[i33 >> 2] = 66;
    HEAP32[i17 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i38, i33);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i29 >> 2] | 0));
 } else i1 = i34 + 11 | 0;
 __ZN14SafeBinaryRead16EndArrayTransferEv(i37);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i38 = HEAP32[i34 >> 2] | 0;
  i37 = HEAP32[i34 + 12 >> 2] | 0;
  HEAP32[i33 >> 2] = 66;
  HEAP32[i33 + 4 >> 2] = i37;
  __Z19free_alloc_internalPvRK10MemLabelId(i38, i33);
 }
 STACKTOP = i36;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_121parse_integer_literalINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_(i1, i2, i13, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 52 | 0;
 i6 = i15 + 16 | 0;
 i7 = i15 + 40 | 0;
 i8 = i15;
 i14 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i1, i2) | 0;
 if (!((i14 | 0) == (i1 | 0) | (i14 | 0) == (i2 | 0))) if ((HEAP8[i14 >> 0] | 0) == 69) {
  i11 = i13 + 11 | 0;
  i5 = HEAP8[i11 >> 0] | 0;
  i12 = i13 + 4 | 0;
  L4 : do if ((i5 << 24 >> 24 < 0 ? HEAP32[i12 >> 2] | 0 : i5 & 255) >>> 0 > 3) {
   __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EEPKS8_RKSB_(i8, gb + 1086383 | 0, i13);
   __THREW__ = 0;
   i3 = invoke_iii(fb + 1152 | 0, i8 | 0, gb + 1086288 | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   L6 : do if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i6, i7);
    i2 = i10 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i10 + 8 >> 2] | 0;
    i5 = i4;
    do if (i3 >>> 0 < i4 >>> 0) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i3, i6);
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 24;
    } else {
     i4 = HEAP32[i10 >> 2] | 0;
     i2 = (i3 - i4 | 0) / 24 | 0;
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > 178956970) {
      __THREW__ = 0;
      invoke_vi(fb + 4014 | 0, i10 | 0);
      __THREW__ = 0;
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      break L6;
     } else {
      i4 = (i5 - i4 | 0) / 24 | 0;
      i5 = i4 << 1;
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i4 >>> 0 < 89478485 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 178956970, i2, i10 + 12 | 0);
      i5 = i9 + 8 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i4, i6);
      HEAP32[i5 >> 2] = i4 + 24;
      __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i9);
      __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
      break;
     }
    } while (0);
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i6);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
    break L4;
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
   ___resumeException(i1 | 0);
  } else {
   i4 = i10 + 4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i10 + 8 >> 2] | 0;
   i5 = i8;
   if (i3 >>> 0 < i8 >>> 0) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i3 + 12 >> 2] = 0;
    HEAP32[i3 + 16 >> 2] = 0;
    HEAP32[i3 + 20 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    i3 = i3 + 12 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) == 3) break;
     HEAP32[i3 + (i2 << 2) >> 2] = 0;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 24;
    break;
   }
   i4 = HEAP32[i10 >> 2] | 0;
   i2 = (i3 - i4 | 0) / 24 | 0;
   i3 = i2 + 1 | 0;
   if (i3 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i5 = (i5 - i4 | 0) / 24 | 0;
   i4 = i5 << 1;
   __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i9, i5 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970, i2, i10 + 12 | 0);
   i4 = i9 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   i2 = 0;
   while (1) {
    if ((i2 | 0) == 3) break;
    HEAP32[i5 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   }
   i3 = i5 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i2 = 0;
   while (1) {
    if ((i2 | 0) == 3) break;
    HEAP32[i3 + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   }
   HEAP32[i4 >> 2] = i5 + 24;
   __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i10, i9);
   __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i9);
  } while (0);
  i3 = i10 + 4 | 0;
  if ((HEAP8[i1 >> 0] | 0) == 110) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc((HEAP32[i3 >> 2] | 0) + -24 | 0, 45);
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISC_EE5valueERS7_E4typeESC_SC_((HEAP32[i3 >> 2] | 0) + -24 | 0, i1, i14);
  i1 = HEAP8[i11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
  if (i1 >>> 0 < 4) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj((HEAP32[i3 >> 2] | 0) + -24 | 0, i2 ? HEAP32[i13 >> 2] | 0 : i13, i1) | 0;
  i1 = i14 + 1 | 0;
 }
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN20ArchiveStorageReader21FillStreamCachedBlockEPNS_11CachedBlockE(i24, i27) {
 i24 = i24 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 8 | 0;
 i25 = i28;
 i2 = HEAP32[i27 >> 2] | 0;
 i6 = i24 + 104 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = (HEAPU16[i3 + (i2 * 12 | 0) + 8 >> 1] | 0) & 63;
 i5 = i24 + 2392 + (i4 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = gb + 63552 | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i25;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  i1 = __Z18CreateDecompressor15CompressionType10MemLabelId(i4, i26) | 0;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i27 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (!i1) if (!(HEAP16[i3 + (i2 * 12 | 0) + 8 >> 1] & 63)) {
   i23 = 1;
   i1 = 0;
  } else {
   i27 = -1;
   STACKTOP = i28;
   return i27 | 0;
  } else i23 = 0;
 } else i23 = 0;
 i18 = (HEAP32[i24 + 156 >> 2] | 0) + (i2 << 3) | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 i18 = HEAP32[i18 + 4 >> 2] | 0;
 i19 = HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i15 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
 i20 = i27 + 8 | 0;
 i21 = i27 + 20 | 0;
 i16 = i27 + 4 | 0;
 i14 = (HEAP32[i16 >> 2] | 0) + (HEAP32[i21 >> 2] | 0) | 0;
 HEAP32[i16 >> 2] = i14;
 i14 = i15 - i14 | 0;
 i14 = i14 >>> 0 > 65536 ? 65536 : i14;
 HEAP32[i21 >> 2] = i14;
 i22 = i27 + 24 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i14 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i22 >> 2] = i14;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i14, 1, i27 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 1, i27 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] | 0) | 0;
  HEAP32[i22 >> 2] = i14;
  HEAP32[i20 >> 2] = i13;
  break;
 } while (0);
 L13 : do if (!i14) {
  i3 = 0;
  i2 = 0;
 } else {
  i7 = i27 + 64 | 0;
  i8 = i27 + 56 | 0;
  i9 = i27 + 68 | 0;
  i10 = i27 + 44 | 0;
  i11 = i27 + 40 | 0;
  i12 = i27 + 60 | 0;
  i13 = i27 + 48 | 0;
  i3 = 0;
  i6 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   if (i6 >>> 0 >= i2 >>> 0) {
    i5 = i19 - i4 | 0;
    i5 = i5 >>> 0 > 65536 ? 65536 : i5;
    if (i5) {
     HEAP32[i7 >> 2] = 0;
     HEAP32[i8 >> 2] = i5;
     i2 = HEAP32[i12 >> 2] | 0;
     do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i12 >> 2] = i5;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i5, 1, i13, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i10 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
      HEAP32[i12 >> 2] = i5;
      HEAP32[i10 >> 2] = i2;
      break;
     } else i2 = HEAP32[i10 >> 2] | 0; while (0);
     i6 = _i64Add(HEAP32[i9 >> 2] | 0, 0, i17 | 0, i18 | 0) | 0;
     if (!(__ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy(i24, i6, getTempRet0() | 0, i5, 0, i2, i26) | 0)) {
      i4 = 24;
      break;
     }
     i4 = HEAP32[i26 >> 2] | 0;
     HEAP32[i8 >> 2] = i4;
     i2 = HEAP32[i12 >> 2] | 0;
     do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i12 >> 2] = i4;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i4, 1, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
      HEAP32[i12 >> 2] = i4;
      HEAP32[i10 >> 2] = i6;
      break;
     } while (0);
     i4 = i26;
     i4 = _i64Add(HEAP32[i9 >> 2] | 0, 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
     getTempRet0() | 0;
     HEAP32[i9 >> 2] = i4;
     i2 = HEAP32[i8 >> 2] | 0;
     i6 = HEAP32[i7 >> 2] | 0;
    }
   }
   i5 = i2 - i6 | 0;
   HEAP32[i26 >> 2] = i5;
   i2 = HEAP32[i21 >> 2] | 0;
   HEAP32[i25 >> 2] = i2 - i3;
   if ((i5 + i4 | 0) == (i19 | 0)) i4 = ((HEAP32[i16 >> 2] | 0) + i2 | 0) == (i15 | 0); else i4 = 0;
   i2 = (i5 | 0) == 0;
   if (i2 & (i23 | i4 ^ 1)) {
    i1 = 1;
    i4 = 34;
    break;
   }
   if (i23) {
    _memcpy((HEAP32[i20 >> 2] | 0) + i3 | 0, (HEAP32[i10 >> 2] | 0) + i6 | 0, i5 | 0) | 0;
    i2 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i25 >> 2] | 0;
   } else {
    if (i2) i2 = 0; else i2 = (HEAP32[i10 >> 2] | 0) + i6 | 0;
    if (!(mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, HEAP32[i11 >> 2] | 0, i2 | 0, i26 | 0, (HEAP32[i20 >> 2] | 0) + i3 | 0, i25 | 0, i4 | 0) | 0)) {
     i1 = -1;
     i4 = 34;
     break;
    }
    i2 = HEAP32[i26 >> 2] | 0;
    i4 = HEAP32[i25 >> 2] | 0;
    if (!(i4 | i2)) {
     i1 = 1;
     i4 = 34;
     break;
    }
   }
   i6 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
   HEAP32[i7 >> 2] = i6;
   i3 = i4 + i3 | 0;
   if (i3 >>> 0 >= i14 >>> 0) {
    i2 = 0;
    break L13;
   }
  }
  if ((i4 | 0) == 24) {
   i2 = -2;
   break;
  } else if ((i4 | 0) == 34) {
   i2 = i1;
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i3;
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i1 & 2147483647) >>> 0 >= i3 >>> 0) {
  i27 = i2;
  STACKTOP = i28;
  return i27 | 0;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i22 >> 2] = i3;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i3, 1, i27 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i27 = i2;
  STACKTOP = i28;
  return i27 | 0;
 } else {
  i27 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i27 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i27 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i21 >> 2] | 0) | 0;
  HEAP32[i22 >> 2] = i3;
  HEAP32[i20 >> 2] = i27;
  i27 = i2;
  STACKTOP = i28;
  return i27 | 0;
 }
 return 0;
}

function __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f(i4, i1, i2, f35) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f35 = Math_fround(f35);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, i40 = 0, f41 = f0, i42 = 0, f43 = f0, i44 = 0, f45 = f0, f46 = f0, i47 = 0, f48 = f0, i49 = 0, f50 = f0, i51 = 0, f52 = f0, i53 = 0, f54 = f0, i55 = 0, f56 = f0, i57 = 0, f58 = f0, i59 = 0, f60 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i37;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = (i3 | 0) > 0 ? i3 : 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i6 = (i6 | 0) < 64 ? i6 : 64;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = (i1 | 0) > 0 ? i1 : 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (i2 | 0) < 64 ? i2 : 64;
 if (!((i3 | 0) < (i6 | 0) & (i1 | 0) < (i2 | 0))) {
  i36 = 0;
  STACKTOP = i37;
  return i36 | 0;
 }
 i12 = i3 >> 2;
 i27 = i1 >> 2;
 i23 = HEAP32[gb + 78668 + ((i3 & 3) << 2) >> 2] | 0;
 i30 = HEAP32[gb + 78684 + ((i6 & 3) << 2) >> 2] | 0;
 i14 = HEAP32[gb + 78700 + ((i1 & 3) << 2) >> 2] | 0;
 i29 = HEAP32[gb + 78716 + ((i2 & 3) << 2) >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 i32 = i5 + 20 | 0;
 HEAP32[i32 >> 2] = 0;
 i34 = i5 + 24 | 0;
 HEAP32[i34 >> 2] = -1;
 i31 = i5 + 32 | 0;
 HEAP32[i31 >> 2] = 0;
 i33 = i5 + 36 | 0;
 HEAP32[i33 >> 2] = -1;
 HEAP32[i5 + 16 >> 2] = 0;
 i24 = i4 + 1424 | 0;
 HEAP32[i5 + 4 >> 2] = i24;
 HEAP8[i5 + 12 >> 0] = 0;
 i5 = (i2 + 3 >> 2) - i27 | 0;
 i24 = (i27 << 10) + i24 | 0;
 i27 = (i5 << 10) + i24 | 0;
 i28 = i12 << 6;
 i12 = (i6 + 3 >> 2) - i12 | 0;
 i25 = i12 + -1 | 0;
 i5 = i5 + -1 | 0;
 i14 = i14 & ((i5 | 0) == 0 ? i29 : -1);
 i23 = ((i12 | 0) == 1 ? i30 : -1) & i23;
 i12 = i14 & i23;
 i1 = 0;
 i4 = i12;
 i6 = i14;
 i7 = i14;
 i8 = 0;
 i3 = i12;
 i9 = i14;
 i10 = 0;
 i11 = i24 + i28 | 0;
 i2 = i12;
 i13 = i25;
 i15 = 0;
 L4 : while (1) {
  i26 = i24 >>> 0 < i27 >>> 0;
  i21 = i1;
  i1 = i14;
  while (1) {
   i16 = (i13 | 0) == 0;
   if (i16) {
    i1 = (i15 | i21 | i8 | i10 | 0) != 0;
    if (!i26) {
     i36 = 11;
     break L4;
    }
    if (i1) {
     i2 = 0;
     break L4;
    }
    i5 = i5 + -1 | 0;
    i14 = (i5 | 0) == 0 ? i29 : -1;
    i9 = i14 & i23;
    i17 = i9;
    i4 = i4 & i30;
    i6 = i14;
    i19 = i14;
    i3 = i3 & i30;
    i20 = i14;
    i2 = i2 & i30;
    i22 = i9;
    i18 = i9;
    i1 = i12 & i30;
    i12 = i9;
   } else {
    i17 = i6;
    i19 = i7;
    i20 = i9;
    i22 = i1;
    i14 = i1;
    i18 = i7;
    i1 = i12;
    i12 = i9;
   }
   i53 = i11;
   f58 = Math_fround(HEAPF32[i53 >> 2]);
   f50 = Math_fround(HEAPF32[i53 + 4 >> 2]);
   f43 = Math_fround(HEAPF32[i53 + 8 >> 2]);
   f56 = Math_fround(HEAPF32[i53 + 12 >> 2]);
   i59 = (HEAP32[tempDoublePtr >> 2] = i4 & 1, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i51 = (HEAP32[tempDoublePtr >> 2] = i1 & 2, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i44 = (HEAP32[tempDoublePtr >> 2] = i3 & 4, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = (HEAP32[tempDoublePtr >> 2] = i2 & 8, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f56 < f35;
   f56 = Math_fround(HEAPF32[i53 + 16 >> 2]);
   f48 = Math_fround(HEAPF32[i53 + 20 >> 2]);
   f41 = Math_fround(HEAPF32[i53 + 24 >> 2]);
   f54 = Math_fround(HEAPF32[i53 + 28 >> 2]);
   i57 = (HEAP32[tempDoublePtr >> 2] = i4 & 16, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i49 = (HEAP32[tempDoublePtr >> 2] = i1 & 32, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i42 = (HEAP32[tempDoublePtr >> 2] = i3 & 64, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 128, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f54 < f35;
   f54 = Math_fround(HEAPF32[i53 + 32 >> 2]);
   f46 = Math_fround(HEAPF32[i53 + 36 >> 2]);
   f39 = Math_fround(HEAPF32[i53 + 40 >> 2]);
   f52 = Math_fround(HEAPF32[i53 + 44 >> 2]);
   i55 = (HEAP32[tempDoublePtr >> 2] = i4 & 256, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i47 = (HEAP32[tempDoublePtr >> 2] = i1 & 512, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i40 = (HEAP32[tempDoublePtr >> 2] = i3 & 1024, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 2048, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f52 < f35;
   f52 = Math_fround(HEAPF32[i53 + 48 >> 2]);
   f45 = Math_fround(HEAPF32[i53 + 52 >> 2]);
   f38 = Math_fround(HEAPF32[i53 + 56 >> 2]);
   f60 = Math_fround(HEAPF32[i53 + 60 >> 2]);
   i53 = (HEAP32[tempDoublePtr >> 2] = i4 & 4096, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i4 = (HEAP32[tempDoublePtr >> 2] = i1 & 8192, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i7 = (HEAP32[tempDoublePtr >> 2] = i3 & 16384, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 32768, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f60 < f35;
   i1 = i59 & f58 < f35 | i57 & f56 < f35 | i55 & f54 < f35 | i53 & f52 < f35 ? -1 : i21;
   i15 = i51 & f50 < f35 | i49 & f48 < f35 | i47 & f46 < f35 | i4 & f45 < f35 ? -1 : i15;
   i2 = i44 & f43 < f35 | i42 & f41 < f35 | i40 & f39 < f35 | i7 & f38 < f35 ? -1 : i8;
   i10 = i9 ? -1 : i10;
   if (i16) break;
   i21 = i1;
   i4 = i17;
   i7 = i19;
   i8 = i2;
   i3 = i18;
   i9 = i20;
   i11 = i11 + 64 | 0;
   i2 = i12;
   i13 = i13 + -1 | 0;
   i1 = i14;
   i12 = i22;
  }
  i59 = i24 + 1024 | 0;
  i13 = i59 >>> 0 < i27 >>> 0;
  i4 = i17;
  i7 = i19;
  i8 = i2;
  i3 = i18;
  i9 = i20;
  i11 = i13 ? i59 + i28 | 0 : i11;
  i2 = i12;
  i13 = i13 ? i25 : 0;
  i24 = i59;
  i12 = i22;
 }
 if ((i36 | 0) == 11) i2 = i1 ^ 1;
 i1 = HEAP32[i31 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i33 >> 2];
 i1 = HEAP32[i32 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i34 >> 2];
 i59 = i2;
 STACKTOP = i37;
 return i59 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i4, i1, i12, i10) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i11 = i4 + 4 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9;
 do if ((i9 | 0) != (i11 | 0)) {
  i7 = i10;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i9 + 16 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i6 | 0) == (i2 | 0) & (i7 | 0) == (i3 | 0)) {
   i3 = i10 + 8 | 0;
   i13 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i9 + 24 | 0;
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   if (i13 >>> 0 < i2 >>> 0 | ((i13 | 0) == (i2 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0)) break;
   i5 = i9 + 24 | 0;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i13 = i10 + 8 | 0;
   i4 = HEAP32[i13 + 4 >> 2] | 0;
   if (!(i3 >>> 0 < i4 >>> 0 | ((i3 | 0) == (i4 | 0) ? (HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0))) i8 = 55;
  } else {
   if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i6 >>> 0 < i2 >>> 0) break;
   if (!(i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i6 >>> 0)) i8 = 55;
  }
  if ((i8 | 0) == 55) {
   HEAP32[i12 >> 2] = i1;
   i13 = i12;
   return i13 | 0;
  }
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = (i1 | 0) == 0;
  if (i5) {
   i2 = i9;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  do if ((i1 | 0) != (i11 | 0)) {
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i6 | 0) == (i2 | 0) & (i7 | 0) == (i3 | 0)) {
    i8 = i10 + 8 | 0;
    i2 = HEAP32[i8 + 4 >> 2] | 0;
    i13 = i1 + 24 | 0;
    i3 = HEAP32[i13 + 4 >> 2] | 0;
    if (i2 >>> 0 < i3 >>> 0 | ((i2 | 0) == (i3 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) break;
   } else if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i6 >>> 0 < i2 >>> 0) break;
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) {
    HEAP32[i12 >> 2] = i11;
    i13 = i11;
    return i13 | 0;
   }
   i5 = i10 + 8 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   while (1) {
    i3 = i1 + 16 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i6 | 0) == (i2 | 0) & (i7 | 0) == (i3 | 0)) {
     i3 = i1 + 24 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if (i5 >>> 0 < i3 >>> 0 | (i5 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) i8 = 46; else if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) i8 = 50; else {
      i8 = 53;
      break;
     }
    } else if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i6 >>> 0 < i2 >>> 0) i8 = 46; else if (i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i6 >>> 0) i8 = 50; else {
     i8 = 53;
     break;
    }
    if ((i8 | 0) == 46) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i8 = 47;
      break;
     } else i1 = i2;
    } else if ((i8 | 0) == 50) {
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i8 = 52;
      break;
     } else i1 = i2;
    }
   }
   if ((i8 | 0) == 47) {
    HEAP32[i12 >> 2] = i1;
    i13 = i1;
    return i13 | 0;
   } else if ((i8 | 0) == 52) {
    HEAP32[i12 >> 2] = i1;
    i13 = i3;
    return i13 | 0;
   } else if ((i8 | 0) == 53) {
    HEAP32[i12 >> 2] = i1;
    i13 = i12;
    return i13 | 0;
   }
  } while (0);
  if (i5) {
   HEAP32[i12 >> 2] = i9;
   i13 = i4;
   return i13 | 0;
  } else {
   HEAP32[i12 >> 2] = i1;
   i13 = i1;
   return i13 | 0;
  }
 } while (0);
 do if ((i9 | 0) != (HEAP32[i4 >> 2] | 0)) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) {
   i1 = i9;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i2; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = i2;
  i4 = i2 + 16 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i10;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  if ((i3 | 0) == (i6 | 0) & (i4 | 0) == (i7 | 0)) {
   i8 = i2 + 24 | 0;
   i4 = HEAP32[i8 + 4 >> 2] | 0;
   i13 = i10 + 8 | 0;
   i5 = HEAP32[i13 + 4 >> 2] | 0;
   if (i4 >>> 0 < i5 >>> 0 | ((i4 | 0) == (i5 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) break;
  } else if (i4 >>> 0 < i7 >>> 0 | (i4 | 0) == (i7 | 0) & i3 >>> 0 < i6 >>> 0) break;
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) {
   HEAP32[i12 >> 2] = i11;
   i13 = i11;
   return i13 | 0;
  }
  i5 = i10 + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  while (1) {
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i6 | 0) == (i2 | 0) & (i7 | 0) == (i3 | 0)) {
    i3 = i1 + 24 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (i5 >>> 0 < i3 >>> 0 | (i5 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) i8 = 20; else if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) i8 = 24; else {
     i8 = 27;
     break;
    }
   } else if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i6 >>> 0 < i2 >>> 0) i8 = 20; else if (i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i6 >>> 0) i8 = 24; else {
    i8 = 27;
    break;
   }
   if ((i8 | 0) == 20) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i8 = 21;
     break;
    } else i1 = i2;
   } else if ((i8 | 0) == 24) {
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i8 = 26;
     break;
    } else i1 = i2;
   }
  }
  if ((i8 | 0) == 21) {
   HEAP32[i12 >> 2] = i1;
   i13 = i1;
   return i13 | 0;
  } else if ((i8 | 0) == 26) {
   HEAP32[i12 >> 2] = i1;
   i13 = i3;
   return i13 | 0;
  } else if ((i8 | 0) == 27) {
   HEAP32[i12 >> 2] = i1;
   i13 = i12;
   return i13 | 0;
  }
 } while (0);
 if (!(HEAP32[i9 >> 2] | 0)) {
  HEAP32[i12 >> 2] = i9;
  i13 = i9;
  return i13 | 0;
 } else {
  i13 = i1;
  HEAP32[i12 >> 2] = i13;
  i13 = i13 + 4 | 0;
  return i13 | 0;
 }
 return 0;
}

function __ZN5physx14PxsAABBManager31removeEmptyActorsFromAggregatesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i20 + 528 | 0;
 i18 = i20;
 i15 = i8 + 280 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i8 + 196 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 + 512 >> 2] = i4;
 i16 = i18 + 516 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 520 | 0;
 HEAP32[i17 >> 2] = 0;
 if (i1 | 0) {
  i3 = (i1 + 31 | 0) >>> 5;
  do if (i1 >>> 0 > 4096) {
   i1 = (i3 << 2) + 15 & 1073741808;
   if (!i4) {
    i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i1, gb + 717789 | 0, 1998) | 0;
    HEAP32[i16 >> 2] = i2;
    i1 = i3 | -2147483648;
    HEAP32[i17 >> 2] = i1;
    break;
   } else {
    i2 = __ZN5physx19PxcScratchAllocator5allocEjb(i4, i1, 1) | 0;
    HEAP32[i16 >> 2] = i2;
    i1 = i3 | -2147483648;
    HEAP32[i17 >> 2] = i1;
    break;
   }
  } else {
   HEAP32[i16 >> 2] = i18;
   i1 = i3 | -2147483648;
   HEAP32[i17 >> 2] = i1;
   i2 = i18;
  } while (0);
  _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
 }
 i7 = i8 + 284 | 0;
 i5 = HEAP32[i7 >> 2] & 2147483647;
 L14 : do if (i5 | 0) {
  i4 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L14;
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L20 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    break L20;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i3 | 0) != -1) {
   i5 = HEAP32[i8 + 260 >> 2] | 0;
   i6 = HEAP32[i18 + 516 >> 2] | 0;
   do {
    i4 = i1 << 5;
    while (1) {
     i13 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
     i14 = i6 + (i13 >>> 5 << 2) | 0;
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i13 & 31);
     if (!i2) break L14;
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i3 | 0) == -1) break L14;
    }
    i4 = HEAP32[i7 >> 2] & 2147483647;
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i3 | 0) != -1);
  }
 } while (0);
 i5 = HEAP32[i17 >> 2] & 2147483647;
 L38 : do if (i5 | 0) {
  i4 = HEAP32[i16 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L38;
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L44 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    break L44;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i3 | 0) != -1) {
   i9 = i8 + 180 | 0;
   i10 = i8 + 252 | 0;
   i11 = i8 + 256 | 0;
   i12 = i8 + 292 | 0;
   i13 = i8 + 248 | 0;
   i14 = i8 + 260 | 0;
   i8 = i8 + 268 | 0;
   do {
    i7 = i1 << 5;
    while (1) {
     i5 = (HEAP32[i9 >> 2] | 0) + (i3 * 1048 | 0) + 1040 | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     L54 : do if ((i3 | 0) == 1073741823) i19 = 40; else {
      while (1) {
       i4 = (HEAP32[i10 >> 2] | 0) + i3 | 0;
       if (HEAP8[i4 >> 0] | 0) break;
       i6 = i3;
       i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i3 << 2) >> 2] | 0;
       HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 * 24 | 0) >> 2] = HEAP32[i12 >> 2];
       HEAP32[i12 >> 2] = i6;
       HEAP8[i4 >> 0] = 0;
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2] = 1073741823;
       HEAP32[(HEAP32[i14 >> 2] | 0) + (i6 << 2) >> 2] = 1073741823;
       i4 = ~(1 << (i6 & 31));
       i6 = i6 >>> 5;
       i21 = (HEAP32[i8 >> 2] | 0) + (i6 << 2) | 0;
       HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & i4;
       i6 = (HEAP32[i15 >> 2] | 0) + (i6 << 2) | 0;
       HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & i4;
       if ((i3 | 0) == 1073741823) {
        i19 = 40;
        break L54;
       }
      }
      HEAP32[i5 >> 2] = i3;
      i5 = HEAP32[i11 >> 2] | 0;
      i4 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
      L59 : do if ((i4 | 0) != 1073741823) while (1) {
       while (1) {
        i6 = (HEAP32[i10 >> 2] | 0) + i4 | 0;
        if (HEAP8[i6 >> 0] | 0) {
         i6 = i4;
         break;
        }
        i21 = i4;
        i4 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
        HEAP32[(HEAP32[i13 >> 2] | 0) + (i21 * 24 | 0) >> 2] = HEAP32[i12 >> 2];
        HEAP32[i12 >> 2] = i21;
        HEAP8[i6 >> 0] = 0;
        i5 = HEAP32[i11 >> 2] | 0;
        HEAP32[i5 + (i21 << 2) >> 2] = 1073741823;
        HEAP32[(HEAP32[i14 >> 2] | 0) + (i21 << 2) >> 2] = 1073741823;
        i6 = ~(1 << (i21 & 31));
        i21 = i21 >>> 5;
        i22 = (HEAP32[i8 >> 2] | 0) + (i21 << 2) | 0;
        HEAP32[i22 >> 2] = HEAP32[i22 >> 2] & i6;
        i21 = (HEAP32[i15 >> 2] | 0) + (i21 << 2) | 0;
        HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & i6;
        if ((i4 | 0) == 1073741823) break L59;
       }
       HEAP32[i5 + (i3 << 2) >> 2] = i6;
       i4 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
       if ((i4 | 0) == 1073741823) {
        i3 = i6;
        break;
       } else i3 = i6;
      } while (0);
      HEAP32[i5 + (i3 << 2) >> 2] = 1073741823;
     } while (0);
     if ((i19 | 0) == 40) {
      i19 = 0;
      HEAP32[i5 >> 2] = 1073741823;
     }
     if (!i2) break L38;
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i7;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i3 | 0) == -1) break L38;
    }
    i4 = HEAP32[i17 >> 2] & 2147483647;
    i5 = HEAP32[i16 >> 2] | 0;
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i3 | 0) != -1);
  }
 } while (0);
 __ZN5physx12InlineBitmapILj4096EED2Ev(i18);
 STACKTOP = i20;
 return;
}

function __ZN14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj(i1, i14, i22) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i29;
 if (!i22) {
  STACKTOP = i29;
  return;
 }
 i24 = i1 + 72 | 0;
 i25 = i1 + 76 | 0;
 i26 = i1 + 68 | 0;
 i27 = i1 + 108 | 0;
 i28 = i1 + 140 | 0;
 i15 = i1 + 148 | 0;
 i16 = i1 + 160 | 0;
 i17 = i1 + 164 | 0;
 i18 = i1 + 152 | 0;
 i19 = i1 + 116 | 0;
 i20 = i1 + 128 | 0;
 i21 = i1 + 132 | 0;
 i13 = i1 + 120 | 0;
 i12 = 0;
 do {
  i10 = HEAP32[i14 + (i12 * 24 | 0) >> 2] | 0;
  L6 : do if (!(HEAP8[i14 + (i12 * 24 | 0) + 20 >> 0] & 3)) {
   i3 = HEAP32[(HEAP32[i14 + (i12 * 24 | 0) + 8 >> 2] | 0) + 8 >> 2] | 0;
   i2 = HEAP32[i10 + 8 >> 2] | 0;
   i11 = 45;
  } else {
   i9 = HEAP32[i14 + (i12 * 24 | 0) + 8 >> 2] | 0;
   i1 = HEAP32[i27 >> 2] | 0;
   do if (!i1) {
    i6 = 0;
    i3 = 0;
    i2 = 0;
   } else {
    i3 = i27;
    L10 : while (1) {
     i2 = i1;
     while (1) {
      i1 = HEAP32[i2 + 16 >> 2] | 0;
      if ((i1 | 0) == (i10 | 0)) {
       if ((HEAP32[i2 + 20 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
      } else if (i1 >>> 0 >= i10 >>> 0) break;
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) break L10; else i2 = i1;
     }
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) {
      i3 = i2;
      break;
     } else i3 = i2;
    }
    if ((i3 | 0) == (i27 | 0)) {
     i6 = 0;
     i3 = 0;
     i2 = 0;
    } else {
     i1 = HEAP32[i3 + 16 >> 2] | 0;
     if ((i10 | 0) == (i1 | 0)) {
      if (i9 >>> 0 < (HEAP32[i3 + 20 >> 2] | 0) >>> 0) {
       i6 = 0;
       i3 = 0;
       i2 = 0;
       break;
      }
     } else if (i10 >>> 0 < i1 >>> 0) {
      i6 = 0;
      i3 = 0;
      i2 = 0;
      break;
     }
     if ((HEAP8[i3 + 24 >> 0] | 0) != 0 | (i3 | 0) == (i27 | 0)) {
      i6 = 0;
      i3 = 0;
      i2 = 0;
     } else {
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i8 = HEAP32[i3 + 32 >> 2] | 0;
      i1 = i3 + 24 | 0;
      if (!(HEAP8[i1 >> 0] | 0)) {
       HEAP8[i1 >> 0] = 1;
       i3 = i3 + 16 | 0;
       i4 = HEAP32[i20 >> 2] | 0;
       i5 = i4 + 1 | 0;
       i6 = HEAP32[i21 >> 2] | 0;
       i7 = i6 & 2147483647;
       do if (i5 >>> 0 > i7 >>> 0) {
        i1 = i6 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
         HEAP32[i21 >> 2] = i1;
         HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1 << 3, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i7 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i20 >> 2] << 3 | 0) | 0;
         HEAP32[i21 >> 2] = i1;
         HEAP32[i19 >> 2] = i7;
         break;
        }
       } while (0);
       HEAP32[i20 >> 2] = i5;
       i7 = i3;
       i3 = HEAP32[i7 + 4 >> 2] | 0;
       i6 = (HEAP32[i19 >> 2] | 0) + (i4 << 3) | 0;
       HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i6 + 4 >> 2] = i3;
       i6 = 1;
       i3 = i8;
      } else {
       i6 = 1;
       i3 = i8;
      }
     }
    }
   } while (0);
   i1 = HEAP32[i28 >> 2] | 0;
   do if (i1 | 0) {
    i5 = i28;
    i4 = i1;
    L36 : while (1) {
     i1 = i4;
     while (1) {
      i4 = HEAP32[i1 + 16 >> 2] | 0;
      if ((i4 | 0) == (i10 | 0)) {
       if ((HEAP32[i1 + 20 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
      } else if (i4 >>> 0 >= i10 >>> 0) break;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) {
       i4 = i5;
       break L36;
      }
     }
     i4 = HEAP32[i1 >> 2] | 0;
     if (!i4) {
      i4 = i1;
      break;
     } else i5 = i1;
    }
    if ((i4 | 0) != (i28 | 0)) {
     i1 = HEAP32[i4 + 16 >> 2] | 0;
     if ((i10 | 0) == (i1 | 0)) {
      if (i9 >>> 0 < (HEAP32[i4 + 20 >> 2] | 0) >>> 0) break;
     } else if (i10 >>> 0 < i1 >>> 0) break;
     if (!((HEAP8[i4 + 24 >> 0] | 0) != 0 | (i4 | 0) == (i28 | 0))) {
      i2 = HEAP32[i4 + 28 >> 2] | 0;
      i3 = HEAP32[i4 + 32 >> 2] | 0;
      i1 = i4 + 24 | 0;
      if (HEAP8[i1 >> 0] | 0) {
       i11 = 45;
       break L6;
      }
      HEAP8[i1 >> 0] = 1;
      i4 = i4 + 16 | 0;
      i5 = HEAP32[i16 >> 2] | 0;
      i6 = i5 + 1 | 0;
      i7 = HEAP32[i17 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i6 >>> 0 > i8 >>> 0) {
       i1 = i7 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i17 >> 2] = i1;
        HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 3, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i11 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
        HEAP32[i17 >> 2] = i1;
        HEAP32[i15 >> 2] = i11;
        break;
       }
      } while (0);
      HEAP32[i16 >> 2] = i6;
      i9 = i4;
      i10 = HEAP32[i9 + 4 >> 2] | 0;
      i11 = (HEAP32[i15 >> 2] | 0) + (i5 << 3) | 0;
      HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i11 + 4 >> 2] = i10;
      i11 = 45;
      break L6;
     }
    }
   } while (0);
   if (i6) i11 = 45;
  } while (0);
  if ((i11 | 0) == 45) {
   i11 = 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   i1 = HEAP32[i24 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i25 >> 2] | 0)) {
    __ZNSt3__26vectorI15RecordedTriggerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i26, i23);
    i1 = HEAP32[i24 >> 2] | 0;
   } else {
    HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
    i1 = (HEAP32[i24 >> 2] | 0) + 12 | 0;
    HEAP32[i24 >> 2] = i1;
   }
   HEAP32[i1 + -8 >> 2] = i2;
   HEAP32[i1 + -4 >> 2] = i3;
   HEAP32[i1 + -12 >> 2] = HEAP32[i14 + (i12 * 24 | 0) + 16 >> 2];
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i22 | 0));
 STACKTOP = i29;
 return;
}

function __ZN11b2RopeJoint23InitVelocityConstraintsERK12b2SolverData(i19, i20) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, f33 = f0;
 i18 = HEAP32[i19 + 48 >> 2] | 0;
 i2 = HEAP32[i18 + 8 >> 2] | 0;
 i27 = i19 + 96 | 0;
 HEAP32[i27 >> 2] = i2;
 i4 = HEAP32[i19 + 52 >> 2] | 0;
 i31 = HEAP32[i4 + 8 >> 2] | 0;
 i25 = i19 + 100 | 0;
 HEAP32[i25 >> 2] = i31;
 i28 = i18 + 28 | 0;
 i30 = HEAP32[i28 >> 2] | 0;
 i28 = HEAP32[i28 + 4 >> 2] | 0;
 i11 = i19 + 128 | 0;
 HEAP32[i11 >> 2] = i30;
 HEAP32[i11 + 4 >> 2] = i28;
 i11 = i4 + 28 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i14 = i19 + 136 | 0;
 HEAP32[i14 >> 2] = i12;
 HEAP32[i14 + 4 >> 2] = i11;
 i14 = i19 + 144 | 0;
 HEAP32[i14 >> 2] = HEAP32[i18 + 120 >> 2];
 i17 = i19 + 148 | 0;
 HEAP32[i17 >> 2] = HEAP32[i4 + 120 >> 2];
 i15 = i19 + 152 | 0;
 HEAP32[i15 >> 2] = HEAP32[i18 + 128 >> 2];
 i18 = i19 + 156 | 0;
 HEAP32[i18 >> 2] = HEAP32[i4 + 128 >> 2];
 i4 = HEAP32[i20 + 24 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 8 >> 2]);
 i26 = i20 + 28 | 0;
 i32 = HEAP32[i26 >> 2] | 0;
 i3 = HEAP32[i32 + (i2 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i32 + (i2 * 12 | 0) + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i32 + (i2 * 12 | 0) + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + (i31 * 12 | 0) >> 2]);
 f8 = Math_fround(HEAPF32[i4 + (i31 * 12 | 0) + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + (i31 * 12 | 0) + 8 >> 2]);
 i4 = HEAP32[i32 + (i31 * 12 | 0) >> 2] | 0;
 i2 = HEAP32[i32 + (i31 * 12 | 0) + 4 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i32 + (i31 * 12 | 0) + 8 >> 2]);
 f23 = Math_fround(+Math_sin(+f10));
 f10 = Math_fround(+Math_cos(+f10));
 f29 = Math_fround(+Math_sin(+f13));
 f13 = Math_fround(+Math_cos(+f13));
 f24 = Math_fround(HEAPF32[i19 + 68 >> 2]);
 f24 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f22 = Math_fround(HEAPF32[i19 + 72 >> 2]);
 f22 = Math_fround(f22 - (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f21 = Math_fround(Math_fround(f10 * f24) - Math_fround(f23 * f22));
 f22 = Math_fround(Math_fround(f23 * f24) + Math_fround(f10 * f22));
 HEAPF32[i19 + 112 >> 2] = f21;
 HEAPF32[i19 + 116 >> 2] = f22;
 f10 = Math_fround(HEAPF32[i19 + 76 >> 2]);
 f10 = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f24 = Math_fround(HEAPF32[i19 + 80 >> 2]);
 f24 = Math_fround(f24 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f23 = Math_fround(Math_fround(f13 * f10) - Math_fround(f29 * f24));
 f24 = Math_fround(Math_fround(f29 * f10) + Math_fround(f13 * f24));
 HEAPF32[i19 + 120 >> 2] = f23;
 HEAPF32[i19 + 124 >> 2] = f24;
 f7 = Math_fround(Math_fround(Math_fround(f16 + f23) - f7) - f21);
 f9 = Math_fround(Math_fround(Math_fround(f8 + f24) - f9) - f22);
 i11 = i19 + 104 | 0;
 HEAPF32[i11 >> 2] = f7;
 i12 = i19 + 108 | 0;
 HEAPF32[i12 >> 2] = f9;
 f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f9 * f9))));
 HEAPF32[i19 + 88 >> 2] = f8;
 i28 = Math_fround(f8 - Math_fround(HEAPF32[i19 + 84 >> 2])) > Math_fround(0.0);
 HEAP32[i19 + 164 >> 2] = i28 ? 2 : 0;
 if (!(f8 > Math_fround(.00499999989))) {
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 160 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 92 >> 2] = Math_fround(0.0);
  return;
 }
 f13 = Math_fround(Math_fround(1.0) / f8);
 f16 = Math_fround(f13 * f7);
 HEAPF32[i11 >> 2] = f16;
 f13 = Math_fround(f13 * f9);
 HEAPF32[i12 >> 2] = f13;
 f33 = Math_fround(Math_fround(f13 * f21) - Math_fround(f22 * f16));
 f29 = Math_fround(Math_fround(f13 * f23) - Math_fround(f16 * f24));
 f10 = Math_fround(HEAPF32[i14 >> 2]);
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f33 = Math_fround(f10 + Math_fround(f33 * Math_fround(f33 * f9)));
 f7 = Math_fround(HEAPF32[i17 >> 2]);
 f33 = Math_fround(f7 + f33);
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f29 = Math_fround(f33 + Math_fround(f29 * Math_fround(f29 * f8)));
 i32 = f29 != Math_fround(0.0);
 f29 = Math_fround(Math_fround(1.0) / f29);
 HEAPF32[i19 + 160 >> 2] = i32 ? f29 : Math_fround(0.0);
 if (!(HEAP8[i20 + 20 >> 0] | 0)) HEAPF32[i19 + 92 >> 2] = Math_fround(0.0); else {
  f33 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  i32 = i19 + 92 | 0;
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i32 >> 2]));
  HEAPF32[i32 >> 2] = f33;
  f29 = Math_fround(f33 * f16);
  f16 = Math_fround(f33 * f13);
  f13 = Math_fround(f29 * f10);
  f33 = Math_fround(f16 * f10);
  f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f13);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f33);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
  f6 = Math_fround(f6 - Math_fround(f9 * Math_fround(Math_fround(f16 * f21) - Math_fround(f29 * f22))));
  f22 = Math_fround(f29 * f7);
  f33 = Math_fround(f16 * f7);
  f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f22);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
  f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(Math_fround(f16 * f23) - Math_fround(f29 * f24))));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i31 = HEAP32[i27 >> 2] | 0;
 i32 = HEAP32[i26 >> 2] | 0;
 HEAP32[i32 + (i31 * 12 | 0) >> 2] = i3;
 HEAP32[i32 + (i31 * 12 | 0) + 4 >> 2] = i1;
 i31 = HEAP32[i26 >> 2] | 0;
 HEAPF32[i31 + ((HEAP32[i27 >> 2] | 0) * 12 | 0) + 8 >> 2] = f6;
 i32 = HEAP32[i25 >> 2] | 0;
 HEAP32[i31 + (i32 * 12 | 0) >> 2] = i4;
 HEAP32[i31 + (i32 * 12 | 0) + 4 >> 2] = i2;
 HEAPF32[(HEAP32[i26 >> 2] | 0) + ((HEAP32[i25 >> 2] | 0) * 12 | 0) + 8 >> 2] = f5;
 return;
}

function __ZN18UnityPropertySheetaSERKS_(i13, i11) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i14 = i16 + 4 | 0;
 i15 = i16;
 i10 = (i13 | 0) == (i11 | 0);
 if (i10) {
  STACKTOP = i16;
  return i13 | 0;
 }
 i1 = i13 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i13, HEAP32[i1 >> 2] | 0);
 i8 = i13 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = i11 + 4 | 0;
 if ((i2 | 0) != (i9 | 0)) {
  i7 = i13 + 4 | 0;
  i6 = i2;
  while (1) {
   i4 = i6 + 16 | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
   i5 = __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SG_EEiEESJ_RKT_(i13, i12, i14, i4) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i3 = __Znwj(40) | 0;
    HEAP32[i3 + 16 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
    HEAP32[i3 + 32 >> 2] = HEAP32[i6 + 32 >> 2];
    HEAP32[i3 + 36 >> 2] = HEAP32[i6 + 36 >> 2];
    i4 = HEAP32[i14 >> 2] | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = i4;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i13 >> 2] = i4;
     i3 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i3);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     break;
    } else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
   }
   if ((i2 | 0) == (i9 | 0)) break; else i6 = i2;
  }
  if (i10) {
   STACKTOP = i16;
   return i13 | 0;
  }
 }
 i7 = i13 + 12 | 0;
 i1 = i13 + 16 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i7, HEAP32[i1 >> 2] | 0);
 i8 = i13 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i9 = i11 + 16 | 0;
 if ((i2 | 0) != (i9 | 0)) {
  i6 = i13 + 16 | 0;
  i4 = i2;
  i3 = i2;
  while (1) {
   i4 = i4 + 16 | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
   i5 = __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SE_EEiEESH_RKT_(i7, i12, i14, i4) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i18 = i4;
    i17 = HEAP32[i18 + 4 >> 2] | 0;
    i4 = i2 + 16 | 0;
    HEAP32[i4 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i4 + 4 >> 2] = i17;
    i4 = HEAP32[i14 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i4;
    HEAP32[i5 >> 2] = i2;
    i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i7 >> 2] = i4;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i2);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   if ((i2 | 0) == (i9 | 0)) break; else {
    i4 = i2;
    i3 = i2;
   }
  }
  if (i10) {
   STACKTOP = i16;
   return i13 | 0;
  }
 }
 i8 = i13 + 24 | 0;
 i1 = i13 + 28 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i8, HEAP32[i1 >> 2] | 0);
 i9 = i13 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i11 + 24 >> 2] | 0;
 i7 = i11 + 28 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i16;
  return i13 | 0;
 }
 i6 = i13 + 28 | 0;
 i4 = i2;
 i3 = i2;
 while (1) {
  i4 = i4 + 16 | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  i5 = __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SF_EEiEESI_RKT_(i8, i12, i14, i4) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   i2 = __Znwj(36) | 0;
   i18 = i2 + 16 | 0;
   HEAP32[i18 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i18 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i4;
   HEAP32[i5 >> 2] = i2;
   i4 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i8 >> 2] = i4;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i2);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i7 | 0)) break; else {
   i4 = i2;
   i3 = i2;
  }
 }
 STACKTOP = i16;
 return i13 | 0;
}

function runPostSets58() {
 HEAP32[gb + 67568 >> 2] = fb + 28;
 HEAP32[gb + 67572 >> 2] = fb + 276;
 HEAP32[gb + 67576 >> 2] = fb + 29;
 HEAP32[gb + 67580 >> 2] = fb + 34;
 HEAP32[gb + 67584 >> 2] = fb + 608;
 HEAP32[gb + 67588 >> 2] = fb + 609;
 HEAP32[gb + 67592 >> 2] = fb + 610;
 HEAP32[gb + 67596 >> 2] = fb + 611;
 HEAP32[gb + 67600 >> 2] = fb + 612;
 HEAP32[gb + 67604 >> 2] = fb + 613;
 HEAP32[gb + 67608 >> 2] = fb + 36;
 HEAP32[gb + 67620 >> 2] = fb + 759;
 HEAP32[gb + 67624 >> 2] = fb + 760;
 HEAP32[gb + 67628 >> 2] = (HEAP32[gb + 67628 >> 2] | 0) + (gb + 589945 | 0);
 HEAP32[gb + 67632 >> 2] = (HEAP32[gb + 67632 >> 2] | 0) + (gb + 470211 | 0);
 HEAP32[gb + 67636 >> 2] = (HEAP32[gb + 67636 >> 2] | 0) + (gb + 470227 | 0);
 HEAP32[gb + 67640 >> 2] = (HEAP32[gb + 67640 >> 2] | 0) + (gb + 470241 | 0);
 HEAP32[gb + 67644 >> 2] = (HEAP32[gb + 67644 >> 2] | 0) + (gb + 470248 | 0);
 HEAP32[gb + 67648 >> 2] = (HEAP32[gb + 67648 >> 2] | 0) + (gb + 470252 | 0);
 HEAP32[gb + 67672 >> 2] = (HEAP32[gb + 67672 >> 2] | 0) + (gb + 470258 | 0);
 HEAP32[gb + 67684 >> 2] = fb + 761;
 HEAP32[gb + 67688 >> 2] = fb + 762;
 HEAP32[gb + 67692 >> 2] = fb + 763;
 HEAP32[gb + 67696 >> 2] = fb + 614;
 HEAP32[gb + 67700 >> 2] = fb + 764;
 HEAP32[gb + 67704 >> 2] = fb + 39;
 HEAP32[gb + 67708 >> 2] = fb + 40;
 HEAP32[gb + 67712 >> 2] = fb + 19;
 HEAP32[gb + 67716 >> 2] = fb + 332;
 HEAP32[gb + 67720 >> 2] = fb + 333;
 HEAP32[gb + 67724 >> 2] = fb + 615;
 HEAP32[gb + 67728 >> 2] = fb + 62;
 HEAP32[gb + 67732 >> 2] = fb + 28;
 HEAP32[gb + 67736 >> 2] = fb + 63;
 HEAP32[gb + 67740 >> 2] = fb + 29;
 HEAP32[gb + 67744 >> 2] = fb + 34;
 HEAP32[gb + 67748 >> 2] = fb + 616;
 HEAP32[gb + 67752 >> 2] = fb + 617;
 HEAP32[gb + 67756 >> 2] = fb + 618;
 HEAP32[gb + 67760 >> 2] = fb + 619;
 HEAP32[gb + 67764 >> 2] = fb + 620;
 HEAP32[gb + 67768 >> 2] = fb + 621;
 HEAP32[gb + 67772 >> 2] = fb + 36;
 HEAP32[gb + 67776 >> 2] = fb + 334;
 HEAP32[gb + 67868 >> 2] = (HEAP32[gb + 67868 >> 2] | 0) + (gb + 935336 | 0);
 HEAP32[gb + 67872 >> 2] = (HEAP32[gb + 67872 >> 2] | 0) + (gb + 472289 | 0);
 HEAP32[gb + 67876 >> 2] = (HEAP32[gb + 67876 >> 2] | 0) + (gb + 472312 | 0);
 HEAP32[gb + 67880 >> 2] = (HEAP32[gb + 67880 >> 2] | 0) + (gb + 472328 | 0);
 HEAP32[gb + 67884 >> 2] = (HEAP32[gb + 67884 >> 2] | 0) + (gb + 472359 | 0);
 HEAP32[gb + 67888 >> 2] = (HEAP32[gb + 67888 >> 2] | 0) + (gb + 472374 | 0);
 HEAP32[gb + 67892 >> 2] = (HEAP32[gb + 67892 >> 2] | 0) + (gb + 472404 | 0);
 HEAP32[gb + 67896 >> 2] = (HEAP32[gb + 67896 >> 2] | 0) + (gb + 472414 | 0);
 HEAP32[gb + 67900 >> 2] = (HEAP32[gb + 67900 >> 2] | 0) + (gb + 472439 | 0);
 HEAP32[gb + 67904 >> 2] = (HEAP32[gb + 67904 >> 2] | 0) + (gb + 472457 | 0);
 HEAP32[gb + 67908 >> 2] = (HEAP32[gb + 67908 >> 2] | 0) + (gb + 472490 | 0);
 HEAP32[gb + 67912 >> 2] = (HEAP32[gb + 67912 >> 2] | 0) + (gb + 472507 | 0);
 HEAP32[gb + 67916 >> 2] = (HEAP32[gb + 67916 >> 2] | 0) + (gb + 472539 | 0);
 HEAP32[gb + 67920 >> 2] = (HEAP32[gb + 67920 >> 2] | 0) + (gb + 472548 | 0);
 HEAP32[gb + 67924 >> 2] = (HEAP32[gb + 67924 >> 2] | 0) + (gb + 472572 | 0);
 HEAP32[gb + 67928 >> 2] = (HEAP32[gb + 67928 >> 2] | 0) + (gb + 472587 | 0);
 HEAP32[gb + 67932 >> 2] = (HEAP32[gb + 67932 >> 2] | 0) + (gb + 472617 | 0);
 HEAP32[gb + 67936 >> 2] = (HEAP32[gb + 67936 >> 2] | 0) + (gb + 472623 | 0);
 HEAP32[gb + 67940 >> 2] = (HEAP32[gb + 67940 >> 2] | 0) + (gb + 472644 | 0);
 HEAP32[gb + 67944 >> 2] = (HEAP32[gb + 67944 >> 2] | 0) + (gb + 472670 | 0);
 HEAP32[gb + 67948 >> 2] = (HEAP32[gb + 67948 >> 2] | 0) + (gb + 472711 | 0);
 HEAP32[gb + 67952 >> 2] = (HEAP32[gb + 67952 >> 2] | 0) + (gb + 472732 | 0);
 HEAP32[gb + 67956 >> 2] = (HEAP32[gb + 67956 >> 2] | 0) + (gb + 472768 | 0);
 HEAP32[gb + 67960 >> 2] = (HEAP32[gb + 67960 >> 2] | 0) + (gb + 472797 | 0);
 HEAP32[gb + 67964 >> 2] = (HEAP32[gb + 67964 >> 2] | 0) + (gb + 472841 | 0);
 HEAP32[gb + 67968 >> 2] = (HEAP32[gb + 67968 >> 2] | 0) + (gb + 472869 | 0);
 HEAP32[gb + 67972 >> 2] = (HEAP32[gb + 67972 >> 2] | 0) + (gb + 472912 | 0);
 HEAP32[gb + 67976 >> 2] = (HEAP32[gb + 67976 >> 2] | 0) + (gb + 472932 | 0);
 HEAP32[gb + 67980 >> 2] = (HEAP32[gb + 67980 >> 2] | 0) + (gb + 472967 | 0);
 HEAP32[gb + 67984 >> 2] = (HEAP32[gb + 67984 >> 2] | 0) + (gb + 472986 | 0);
 HEAP32[gb + 67988 >> 2] = (HEAP32[gb + 67988 >> 2] | 0) + (gb + 473020 | 0);
 HEAP32[gb + 67992 >> 2] = (HEAP32[gb + 67992 >> 2] | 0) + (gb + 473048 | 0);
 HEAP32[gb + 67996 >> 2] = (HEAP32[gb + 67996 >> 2] | 0) + (gb + 473091 | 0);
 HEAP32[gb + 68e3 >> 2] = (HEAP32[gb + 68e3 >> 2] | 0) + (gb + 473118 | 0);
 HEAP32[gb + 68004 >> 2] = (HEAP32[gb + 68004 >> 2] | 0) + (gb + 473160 | 0);
 HEAP32[gb + 68008 >> 2] = (HEAP32[gb + 68008 >> 2] | 0) + (gb + 473184 | 0);
 HEAP32[gb + 68012 >> 2] = (HEAP32[gb + 68012 >> 2] | 0) + (gb + 473223 | 0);
 HEAP32[gb + 68016 >> 2] = (HEAP32[gb + 68016 >> 2] | 0) + (gb + 473251 | 0);
 HEAP32[gb + 68020 >> 2] = (HEAP32[gb + 68020 >> 2] | 0) + (gb + 473294 | 0);
 HEAP32[gb + 68024 >> 2] = (HEAP32[gb + 68024 >> 2] | 0) + (gb + 473325 | 0);
 HEAP32[gb + 68028 >> 2] = (HEAP32[gb + 68028 >> 2] | 0) + (gb + 473371 | 0);
 HEAP32[gb + 68032 >> 2] = (HEAP32[gb + 68032 >> 2] | 0) + (gb + 473401 | 0);
 HEAP32[gb + 68036 >> 2] = (HEAP32[gb + 68036 >> 2] | 0) + (gb + 473446 | 0);
 HEAP32[gb + 68040 >> 2] = (HEAP32[gb + 68040 >> 2] | 0) + (gb + 473468 | 0);
 HEAP32[gb + 68044 >> 2] = (HEAP32[gb + 68044 >> 2] | 0) + (gb + 473505 | 0);
 HEAP32[gb + 68048 >> 2] = (HEAP32[gb + 68048 >> 2] | 0) + (gb + 473526 | 0);
 HEAP32[gb + 68052 >> 2] = (HEAP32[gb + 68052 >> 2] | 0) + (gb + 473562 | 0);
 HEAP32[gb + 68056 >> 2] = (HEAP32[gb + 68056 >> 2] | 0) + (gb + 473591 | 0);
 HEAP32[gb + 68060 >> 2] = (HEAP32[gb + 68060 >> 2] | 0) + (gb + 473635 | 0);
 HEAP32[gb + 68064 >> 2] = (HEAP32[gb + 68064 >> 2] | 0) + (gb + 473658 | 0);
 HEAP32[gb + 68068 >> 2] = (HEAP32[gb + 68068 >> 2] | 0) + (gb + 473696 | 0);
 HEAP32[gb + 68072 >> 2] = (HEAP32[gb + 68072 >> 2] | 0) + (gb + 473723 | 0);
 HEAP32[gb + 68076 >> 2] = (HEAP32[gb + 68076 >> 2] | 0) + (gb + 473765 | 0);
 HEAP32[gb + 68080 >> 2] = (HEAP32[gb + 68080 >> 2] | 0) + (gb + 473787 | 0);
 HEAP32[gb + 68084 >> 2] = (HEAP32[gb + 68084 >> 2] | 0) + (gb + 473824 | 0);
 HEAP32[gb + 68088 >> 2] = (HEAP32[gb + 68088 >> 2] | 0) + (gb + 473854 | 0);
 runPostSets59();
}

function __Z16CalculateWeightsILb0EEvPP14AnimationStateiiPfi(i8, i23, i9, i24, i1) {
 i8 = i8 | 0;
 i23 = i23 | 0;
 i9 = i9 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f25 = f0, f26 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 32 | 0;
 i20 = i22 + 20 | 0;
 i14 = i22 + 8 | 0;
 i17 = i22 + 4 | 0;
 i18 = i22;
 HEAP32[i19 >> 2] = 0;
 i21 = i19 + 4 | 0;
 i5 = gb + 63160 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i13 = i21;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i13 + 4 >> 2] = i5;
 i13 = i23 << 2;
 i11 = (i13 | 0) != 0;
 do if (i11) {
  i1 = i13 | 3;
  if (i1 >>> 0 < 2e3) {
   i3 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = i5;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 865) | 0;
   i4 = gb + 64016 | 0;
   i16 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i3;
   i1 = i21;
   HEAP32[i1 >> 2] = i16;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = gb + 63160 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } else {
  i3 = 0;
  i1 = i5;
 } while (0);
 i15 = i3 + 3 & -4;
 HEAP32[i20 >> 2] = 0;
 i16 = i20 + 4 | 0;
 i12 = i16;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i1;
 do if (i11) {
  i3 = i13 | 3;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 868) | 0;
   i7 = gb + 64016 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   i12 = i16;
   HEAP32[i12 >> 2] = i6;
   HEAP32[i12 + 4 >> 2] = i7;
   break;
  }
 } else i1 = 0; while (0);
 i1 = i1 + 3 & -4;
 i7 = i1;
 i12 = (i23 | 0) > 0;
 if (i12) {
  i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0;
  _memset(i1 | 0, 0, i13 | 0) | 0;
  i3 = 0;
  i6 = 0;
  while (1) {
   i5 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
   if (!(HEAP32[i5 + 96 >> 2] | 0)) i10 = 18; else if (!(HEAP16[i5 + 56 >> 1] & 2)) i10 = 18; else {
    i1 = i5 + 8 | 0;
    f2 = Math_fround(HEAPF32[i1 >> 2]);
    if (f2 > Math_fround(.0000999999974)) if (!(HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + (i9 << 2) >> 2] | 0)) i10 = 18; else if (!(HEAP32[i5 + 72 >> 2] | 0)) {
     i5 = i5 + 32 | 0;
     i3 = ((i4 | 0) != (HEAP32[i5 >> 2] | 0) & 1) + i3 | 0;
     i4 = i7 + (i3 << 2) | 0;
     HEAPF32[i4 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i4 >> 2]));
     HEAP32[i15 + (i6 << 2) >> 2] = i3;
     HEAP32[i24 + (i6 << 2) >> 2] = HEAP32[i1 >> 2];
     i1 = i5;
    } else i10 = 18; else i10 = 18;
   }
   if ((i10 | 0) == 18) {
    i10 = 0;
    HEAPF32[i24 + (i6 << 2) >> 2] = Math_fround(0.0);
    HEAP32[i15 + (i6 << 2) >> 2] = 0;
    i1 = i5 + 32 | 0;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i23 | 0)) {
    i5 = i3;
    break;
   } else i4 = HEAP32[i1 >> 2] | 0;
  }
 } else i5 = 0;
 HEAP32[i14 >> 2] = 0;
 i6 = i14 + 4 | 0;
 i8 = gb + 63160 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 do if (i11) {
  i3 = i13 | 3;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 931) | 0;
   i13 = gb + 64016 | 0;
   i11 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i4;
   i1 = i6;
   HEAP32[i1 >> 2] = i11;
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = i4;
   break;
  }
 } else {
  i1 = 0;
  i4 = 0;
 } while (0);
 i3 = i1 + 3 & -4;
 HEAP32[i17 >> 2] = 1065353216;
 if ((i5 | 0) >= 0) {
  i1 = 0;
  f2 = Math_fround(1.0);
  while (1) {
   i14 = i7 + (i1 << 2) | 0;
   f26 = Math_fround(HEAPF32[i14 >> 2]);
   i13 = f26 > Math_fround(1.0);
   f26 = i13 ? f26 : Math_fround(1.0);
   i13 = f26 > Math_fround(.0000999999974);
   f26 = Math_fround(Math_fround(1.0) / f26);
   HEAPF32[i3 + (i1 << 2) >> 2] = Math_fround(f2 * (i13 ? f26 : Math_fround(0.0)));
   f26 = Math_fround(HEAPF32[i14 >> 2]);
   f25 = Math_fround(HEAPF32[i17 >> 2]);
   f25 = Math_fround(f25 - Math_fround(f26 * f25));
   HEAPF32[i17 >> 2] = f25;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   i14 = f25 > Math_fround(0.0);
   i14 = HEAP32[(i14 ? i17 : i18) >> 2] | 0;
   HEAP32[i17 >> 2] = i14;
   f2 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i1 | 0) == (i5 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 if (i12) {
  i1 = 0;
  f2 = Math_fround(0.0);
 } else {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  i24 = HEAP32[i20 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i16);
  i24 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i21);
  STACKTOP = i22;
  return;
 }
 do {
  f26 = Math_fround(HEAPF32[i3 + (HEAP32[i15 + (i1 << 2) >> 2] << 2) >> 2]);
  i18 = i24 + (i1 << 2) | 0;
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i18 >> 2]));
  HEAPF32[i18 >> 2] = f26;
  f2 = Math_fround(f2 + f26);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 i18 = f2 > Math_fround(.0000999999974);
 f2 = Math_fround(Math_fround(1.0) / f2);
 f2 = i18 ? f2 : Math_fround(0.0);
 if (i12) i1 = 0; else {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  i24 = HEAP32[i20 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i16);
  i24 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i21);
  STACKTOP = i22;
  return;
 }
 do {
  i18 = i24 + (i1 << 2) | 0;
  HEAPF32[i18 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 i24 = HEAP32[i20 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i16);
 i24 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i21);
 STACKTOP = i22;
 return;
}

function __ZN5physx17ConvexMeshBuilder15computeMassInfoEv(i21) {
 i21 = i21 | 0;
 var d1 = 0.0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 176 | 0;
 i22 = i25 + 168 | 0;
 i20 = i25;
 i11 = i25 + 192 | 0;
 i10 = i25 + 180 | 0;
 i24 = i21 + 88 | 0;
 if (!(Math_fround(HEAPF32[i24 >> 2]) <= Math_fround(0.0))) {
  STACKTOP = i25;
  return;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP16[i11 + 24 >> 1] = 0;
 i19 = HEAP8[i21 + 54 >> 0] | 0;
 i9 = i19 & 255;
 HEAP32[i11 + 8 >> 2] = i9;
 HEAP32[i11 + 20 >> 2] = HEAP32[i21 + 164 >> 2];
 HEAP32[i11 >> 2] = 12;
 HEAP32[i11 + 12 >> 2] = 12;
 i2 = HEAP32[i21 + 132 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 16 >> 2] = HEAP32[i21 + 168 >> 2];
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 i7 = i10 + 4 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i8 = i10 + 8 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 if (!(i19 << 24 >> 24)) {
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 } else {
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  i6 = 0;
  do {
   f5 = Math_fround(Math_fround(HEAPF32[i2 + (i6 * 12 | 0) >> 2]) + f5);
   HEAPF32[i10 >> 2] = f5;
   f4 = Math_fround(Math_fround(HEAPF32[i2 + (i6 * 12 | 0) + 4 >> 2]) + f4);
   HEAPF32[i7 >> 2] = f4;
   f3 = Math_fround(Math_fround(HEAPF32[i2 + (i6 * 12 | 0) + 8 >> 2]) + f3);
   HEAPF32[i8 >> 2] = f3;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i9 >>> 0);
 }
 f26 = Math_fround(Math_fround(1.0) / Math_fround(i9 | 0));
 HEAPF32[i10 >> 2] = Math_fround(f26 * f5);
 HEAPF32[i7 >> 2] = Math_fround(f26 * f4);
 HEAPF32[i8 >> 2] = Math_fround(f26 * f3);
 if (__ZN5physx28computeVolumeIntegralsEberlyERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsERKNS_6PxVec3E(i11, Math_fround(1.0), i20, i10) | 0) {
  i18 = i21 + 92 | 0;
  f31 = Math_fround(+HEAPF64[i20 + 24 >> 3]);
  HEAPF32[i18 >> 2] = f31;
  f3 = Math_fround(+HEAPF64[i20 + 48 >> 3]);
  HEAPF32[i18 + 4 >> 2] = f3;
  f30 = Math_fround(+HEAPF64[i20 + 72 >> 3]);
  HEAPF32[i18 + 8 >> 2] = f30;
  i13 = i18 + 12 | 0;
  f29 = Math_fround(+HEAPF64[i20 + 32 >> 3]);
  HEAPF32[i13 >> 2] = f29;
  f28 = Math_fround(+HEAPF64[i20 + 56 >> 3]);
  HEAPF32[i13 + 4 >> 2] = f28;
  f27 = Math_fround(+HEAPF64[i20 + 80 >> 3]);
  HEAPF32[i13 + 8 >> 2] = f27;
  i13 = i18 + 24 | 0;
  f4 = Math_fround(+HEAPF64[i20 + 40 >> 3]);
  HEAPF32[i13 >> 2] = f4;
  f5 = Math_fround(+HEAPF64[i20 + 64 >> 3]);
  HEAPF32[i13 + 4 >> 2] = f5;
  f26 = Math_fround(+HEAPF64[i20 + 88 >> 3]);
  HEAPF32[i13 + 8 >> 2] = f26;
  i13 = HEAP32[i20 >> 2] | 0;
  HEAP32[i21 + 40 >> 2] = i13;
  i14 = HEAP32[i20 + 4 >> 2] | 0;
  HEAP32[i21 + 44 >> 2] = i14;
  i15 = HEAP32[i20 + 8 >> 2] | 0;
  HEAP32[i21 + 48 >> 2] = i15;
  i19 = ((HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040;
  i2 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  if (i19) {
   i19 = i21 + 96 | 0;
   if (((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040) {
    i17 = i21 + 100 | 0;
    if ((i2 & 2139095040) >>> 0 < 2139095040 & (i6 & 2139095040) >>> 0 < 2139095040) {
     i11 = i21 + 108 | 0;
     if ((i7 & 2139095040) >>> 0 < 2139095040) {
      i8 = i21 + 112 | 0;
      if ((i9 & 2139095040) >>> 0 < 2139095040 & (i10 & 2139095040) >>> 0 < 2139095040) {
       i7 = i21 + 120 | 0;
       if ((i12 & 2139095040) >>> 0 < 2139095040) {
        i6 = i21 + 124 | 0;
        if ((i16 & 2139095040) >>> 0 < 2139095040 & (i13 & 2139095040) >>> 0 < 2139095040 & (i14 & 2139095040) >>> 0 < 2139095040 & (i15 & 2139095040) >>> 0 < 2139095040) {
         i2 = i20 + 16 | 0;
         d1 = +HEAPF64[i2 >> 3];
         f31 = Math_fround(d1);
         if (((HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040) {
          if (d1 < 0.0) {
           __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 726597 | 0, 166, gb + 729978 | 0, i22);
           d1 = -+HEAPF64[i2 >> 3];
           HEAPF64[i2 >> 3] = d1;
           f3 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
           f4 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
           f5 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
           i22 = i21 + 104 | 0;
           f26 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
           f27 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
           f28 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
           i23 = i21 + 116 | 0;
           f29 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
           f30 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
           f31 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
           HEAPF32[i18 >> 2] = f3;
           HEAPF32[i19 >> 2] = f4;
           HEAPF32[i17 >> 2] = f5;
           HEAPF32[i22 >> 2] = f26;
           HEAPF32[i11 >> 2] = f27;
           HEAPF32[i8 >> 2] = f28;
           HEAPF32[i23 >> 2] = f29;
           HEAPF32[i7 >> 2] = f30;
           HEAPF32[i6 >> 2] = f31;
          }
          HEAPF32[i24 >> 2] = Math_fround(d1);
          STACKTOP = i25;
          return;
         }
        }
       }
      }
     }
    }
   }
  }
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726597 | 0, 175, gb + 730100 | 0, i23);
 STACKTOP = i25;
 return;
}

function __ZN5audio5mixer14EffectConstant8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 12 | 0;
 i10 = i11;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1047471 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863408 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863427 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863449 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863466 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863482 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i7 + 28;
 HEAP32[i10 + 4 >> 2] = i7 + 24;
 HEAP32[i10 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863489 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i9, i10, 0); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i11;
 return;
}

function __ZN14VelocityModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles(i7, i1, i2, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1648 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 1608 | 0;
 i9 = i11;
 if ((HEAP16[gb + 1452104 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452104 | 0, i5);
  i6 = gb + 1452104 | 0;
 } else i6 = 0;
 i2 = __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_(i5, (HEAP32[i1 + 280 >> 2] | 0) == 1, (HEAP8[i7 + 800 >> 0] | 0) != 0, i2 + 52 | 0, i2 + 180 | 0) | 0;
 i3 = i7 + 8 | 0;
 i1 = i7 + 272 | 0;
 if (!(HEAP8[i7 + 94 >> 0] | 0)) i10 = 7; else if (!(HEAP8[i7 + 358 >> 0] | 0)) i10 = 7; else {
  i4 = i7 + 536 | 0;
  if (!(HEAP8[i7 + 622 >> 0] | 0)) i10 = 7; else {
   i12 = HEAP32[i7 + 12 >> 2] | 0;
   i15 = HEAP32[i7 + 16 >> 2] | 0;
   i13 = HEAP32[i7 + 20 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 + 4 >> 2] = i12;
   HEAP32[i9 + 8 >> 2] = i15;
   HEAP32[i9 + 12 >> 2] = i13;
   i13 = HEAP32[i7 + 28 >> 2] | 0;
   i15 = HEAP32[i7 + 32 >> 2] | 0;
   i12 = HEAP32[i7 + 36 >> 2] | 0;
   HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 24 >> 2];
   HEAP32[i9 + 20 >> 2] = i13;
   HEAP32[i9 + 24 >> 2] = i15;
   HEAP32[i9 + 28 >> 2] = i12;
   i12 = i7 + 40 | 0;
   i15 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i9 + 32 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = i15;
   i13 = HEAP32[i7 + 52 >> 2] | 0;
   i15 = HEAP32[i7 + 56 >> 2] | 0;
   i12 = HEAP32[i7 + 60 >> 2] | 0;
   HEAP32[i9 + 40 >> 2] = HEAP32[i7 + 48 >> 2];
   HEAP32[i9 + 44 >> 2] = i13;
   HEAP32[i9 + 48 >> 2] = i15;
   HEAP32[i9 + 52 >> 2] = i12;
   i12 = HEAP32[i7 + 68 >> 2] | 0;
   i15 = HEAP32[i7 + 72 >> 2] | 0;
   i13 = HEAP32[i7 + 76 >> 2] | 0;
   HEAP32[i9 + 56 >> 2] = HEAP32[i7 + 64 >> 2];
   HEAP32[i9 + 60 >> 2] = i12;
   HEAP32[i9 + 64 >> 2] = i15;
   HEAP32[i9 + 68 >> 2] = i13;
   i13 = i7 + 80 | 0;
   i15 = HEAP32[i13 + 4 >> 2] | 0;
   i12 = i9 + 72 | 0;
   HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i12 + 4 >> 2] = i15;
   __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i9);
   i12 = i9 + 80 | 0;
   i15 = HEAP32[i7 + 276 >> 2] | 0;
   i13 = HEAP32[i7 + 280 >> 2] | 0;
   i14 = HEAP32[i7 + 284 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 84 >> 2] = i15;
   HEAP32[i9 + 88 >> 2] = i13;
   HEAP32[i9 + 92 >> 2] = i14;
   i14 = HEAP32[i7 + 292 >> 2] | 0;
   i13 = HEAP32[i7 + 296 >> 2] | 0;
   i15 = HEAP32[i7 + 300 >> 2] | 0;
   HEAP32[i9 + 96 >> 2] = HEAP32[i7 + 288 >> 2];
   HEAP32[i9 + 100 >> 2] = i14;
   HEAP32[i9 + 104 >> 2] = i13;
   HEAP32[i9 + 108 >> 2] = i15;
   i15 = i7 + 304 | 0;
   i13 = HEAP32[i15 + 4 >> 2] | 0;
   i14 = i9 + 112 | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i14 = HEAP32[i7 + 316 >> 2] | 0;
   i13 = HEAP32[i7 + 320 >> 2] | 0;
   i15 = HEAP32[i7 + 324 >> 2] | 0;
   HEAP32[i9 + 120 >> 2] = HEAP32[i7 + 312 >> 2];
   HEAP32[i9 + 124 >> 2] = i14;
   HEAP32[i9 + 128 >> 2] = i13;
   HEAP32[i9 + 132 >> 2] = i15;
   i15 = HEAP32[i7 + 332 >> 2] | 0;
   i13 = HEAP32[i7 + 336 >> 2] | 0;
   i14 = HEAP32[i7 + 340 >> 2] | 0;
   HEAP32[i9 + 136 >> 2] = HEAP32[i7 + 328 >> 2];
   HEAP32[i9 + 140 >> 2] = i15;
   HEAP32[i9 + 144 >> 2] = i13;
   HEAP32[i9 + 148 >> 2] = i14;
   i14 = i7 + 344 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i15 = i9 + 152 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = i13;
   __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i12);
   i12 = i9 + 160 | 0;
   i15 = HEAP32[i7 + 540 >> 2] | 0;
   i13 = HEAP32[i7 + 544 >> 2] | 0;
   i14 = HEAP32[i7 + 548 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 164 >> 2] = i15;
   HEAP32[i9 + 168 >> 2] = i13;
   HEAP32[i9 + 172 >> 2] = i14;
   i14 = HEAP32[i7 + 556 >> 2] | 0;
   i13 = HEAP32[i7 + 560 >> 2] | 0;
   i15 = HEAP32[i7 + 564 >> 2] | 0;
   HEAP32[i9 + 176 >> 2] = HEAP32[i7 + 552 >> 2];
   HEAP32[i9 + 180 >> 2] = i14;
   HEAP32[i9 + 184 >> 2] = i13;
   HEAP32[i9 + 188 >> 2] = i15;
   i15 = i7 + 568 | 0;
   i13 = HEAP32[i15 + 4 >> 2] | 0;
   i14 = i9 + 192 | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i14 = HEAP32[i7 + 580 >> 2] | 0;
   i13 = HEAP32[i7 + 584 >> 2] | 0;
   i15 = HEAP32[i7 + 588 >> 2] | 0;
   HEAP32[i9 + 200 >> 2] = HEAP32[i7 + 576 >> 2];
   HEAP32[i9 + 204 >> 2] = i14;
   HEAP32[i9 + 208 >> 2] = i13;
   HEAP32[i9 + 212 >> 2] = i15;
   i15 = HEAP32[i7 + 596 >> 2] | 0;
   i13 = HEAP32[i7 + 600 >> 2] | 0;
   i14 = HEAP32[i7 + 604 >> 2] | 0;
   HEAP32[i9 + 216 >> 2] = HEAP32[i7 + 592 >> 2];
   HEAP32[i9 + 220 >> 2] = i15;
   HEAP32[i9 + 224 >> 2] = i13;
   HEAP32[i9 + 228 >> 2] = i14;
   i14 = i7 + 608 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i7 = i9 + 232 | 0;
   HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i7 + 4 >> 2] = i13;
   __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i12);
   __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb(i9, i3, i1, i4, i8, i5, i2);
  }
 }
 if ((i10 | 0) == 7) {
  i15 = i9 + 240 | 0;
  f16 = Math_fround(HEAPF32[i7 + 88 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i15, i7 + 96 | 0, f16, HEAP16[i7 + 92 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i15);
  i15 = i9 + 696 | 0;
  f16 = Math_fround(HEAPF32[i7 + 352 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i15, i7 + 360 | 0, f16, HEAP16[i7 + 356 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i15);
  i15 = i9 + 1152 | 0;
  f16 = Math_fround(HEAPF32[i7 + 616 >> 2]);
  __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i15, i7 + 624 | 0, f16, HEAP16[i7 + 620 >> 1] | 0);
  __ZN16MinMaxPolyCurves9IntegrateEv(i15);
  __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb(i9, i3, i1, i7 + 536 | 0, i8, i5, i2);
 }
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return;
}

function __ZN23ShaderVariantCollection17WarmupShadersImplEPFvP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContextES9_SA_(i4, i25, i26, i27) {
 i4 = i4 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i33 + 8 | 0;
 i29 = i33;
 i32 = i33 + 16 | 0;
 i30 = i32 + 36 | 0;
 i1 = i32 + 40 | 0;
 i2 = i32;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 1;
 HEAP32[i30 >> 2] = gb + 33952 + 8;
 i21 = gb + 63280 | 0;
 i24 = HEAP32[i21 + 4 >> 2] | 0;
 i23 = i29;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i32 + 68 >> 2] = 0;
 HEAP32[i32 + 80 >> 2] = 0;
 i23 = i32 + 84 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i32 + 72 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i29);
 i21 = i28;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i18 = i24;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i22;
 i18 = gb + 63280 | 0;
 i22 = HEAP32[i18 + 4 >> 2] | 0;
 i21 = i29;
 HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i21 + 4 >> 2] = i22;
 HEAP32[i32 + 88 >> 2] = 0;
 HEAP32[i32 + 100 >> 2] = 0;
 i21 = i32 + 104 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i32 + 92 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i29);
 i18 = i28;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i20 = i22;
 HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 i20 = gb + 63280 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i29;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 i18 = i32 + 108 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i32 + 120 >> 2] = 0;
 i19 = i32 + 124 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i32 + 112 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i28, i29);
 i2 = i28;
 i17 = HEAP32[i2 + 4 >> 2] | 0;
 i16 = i20;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i32 + 128 >> 2] = 0;
 HEAP32[i32 + 132 >> 2] = 0;
 i16 = gb + 63280 | 0;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i2 = i32 + 136 | 0;
 HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i2 + 4 >> 2] = i17;
 HEAP8[i32 + 144 >> 0] = 1;
 i2 = i32 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i32 + 148 >> 0] = 1;
 HEAP8[i32 + 149 >> 0] = 0;
 __ZN17ShaderPassContext8CopyFromERKS_(i32, HEAP32[gb + 1166248 >> 2] | 0);
 i2 = HEAP32[i4 + 32 >> 2] | 0;
 i17 = i4 + 36 | 0;
 if ((i2 | 0) != (i17 | 0)) while (1) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  L5 : do if (i1 | 0) {
   HEAP32[i29 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i31 = 16; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i28, i1, i29);
     i3 = HEAP32[i28 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i31 = 16; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i31 = 18;
    }
   }
   if ((i31 | 0) == 16) i31 = 18;
   if ((i31 | 0) == 18) {
    i31 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i15 = i1 + 32 | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   if (i5 | 0) {
    i16 = i2 + 20 | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP32[i2 + 24 >> 2] | 0;
    if ((i4 | 0) != (i3 | 0)) {
     i13 = i3 - i4 | 0;
     i14 = (i13 | 0) / 36 | 0;
     if (i13 | 0) {
      i3 = 0;
      while (1) {
       i12 = HEAP32[i4 + (i3 * 36 | 0) + 32 >> 2] | 0;
       L23 : do if (i12 >>> 0 <= 12) {
        i13 = __ZN6Shader25GetGlobalMaximumShaderLODEv() | 0;
        i11 = HEAP32[i5 >> 2] | 0;
        i10 = (HEAP32[i5 + 4 >> 2] | 0) - i11 >> 2;
        if (i10 | 0) {
         i5 = 0;
         L25 : while (1) {
          i6 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
          if ((HEAP32[i6 + 36 >> 2] | 0) <= (i13 | 0)) {
           i9 = HEAP32[i6 + 20 >> 2] | 0;
           if (i9 | 0) {
            i7 = HEAP32[i6 >> 2] | 0;
            i6 = 0;
            do {
             i8 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
             i6 = i6 + 1 | 0;
             if ((HEAP32[i8 + 696 >> 2] | 0) == (i12 | 0)) break L25;
            } while ((i6 | 0) != (i9 | 0));
           }
          }
          i5 = i5 + 1 | 0;
          if ((i5 | 0) == (i10 | 0)) break L23;
         }
         if (i8 | 0) if (!(HEAP32[i8 + 744 >> 2] | 0)) mftCall_viiiiiii(i25 | 0, i1 | 0, i5 | 0, i8 | 0, i4 + (i3 * 36 | 0) | 0, i26 | 0, i27 | 0, i32 | 0);
        }
       } while (0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i14 | 0)) break L5;
       i4 = HEAP32[i16 >> 2] | 0;
       i5 = HEAP32[i15 >> 2] | 0;
      }
     }
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i17 | 0)) break; else i2 = i1;
 }
 HEAP32[i30 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i20);
  HEAP32[i18 >> 2] = 0;
 }
 i1 = i32 + 88 | 0;
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i22);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i32 + 68 | 0;
 if ((HEAP32[i23 >> 2] | 0) <= -1) {
  STACKTOP = i33;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i24);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i33;
 return;
}

function _UNITY_LZ4_decompress_safe_forceExtDict(i24, i20, i3, i4, i1, i2) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0;
 i21 = i24 + i3 | 0;
 i22 = i20 + i4 | 0;
 i23 = i20 + (0 - i2) | 0;
 i19 = i1 + i2 | 0;
 i17 = i2 >>> 0 < 65536;
 i18 = i22 + -12 | 0;
 if (!i4) {
  if ((i3 | 0) == 1) i1 = (HEAP8[i24 >> 0] | 0) != 0; else i1 = 1;
  i25 = i1 << 31 >> 31;
  return i25 | 0;
 }
 i10 = i21 + -15 | 0;
 i11 = i21 + -8 | 0;
 i12 = i21 + -5 | 0;
 i13 = i22 + -5 | 0;
 i14 = i20;
 i15 = i22 + -8 | 0;
 i16 = i15;
 i5 = i24;
 i4 = i20;
 L8 : while (1) {
  i1 = i5 + 1 | 0;
  i8 = HEAPU8[i5 >> 0] | 0;
  i2 = i8 >>> 4;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    i9 = i1;
    i1 = i1 + 1 | 0;
    i9 = HEAP8[i9 >> 0] | 0;
    i2 = (i9 & 255) + i2 | 0;
   } while (i9 << 24 >> 24 == -1 & i1 >>> 0 < i10 >>> 0);
   if ((i2 | 0) < 0) break;
  }
  i9 = i4 + i2 | 0;
  i3 = i1 + i2 | 0;
  if (i9 >>> 0 > i18 >>> 0 | i3 >>> 0 > i11 >>> 0) {
   i25 = 10;
   break;
  } else i2 = i4;
  while (1) {
   i6 = i1;
   i4 = i6;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i6 = i6 + 4 | 0;
   i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   i7 = i2;
   i5 = i7;
   HEAP8[i5 >> 0] = i4;
   HEAP8[i5 + 1 >> 0] = i4 >> 8;
   HEAP8[i5 + 2 >> 0] = i4 >> 16;
   HEAP8[i5 + 3 >> 0] = i4 >> 24;
   i7 = i7 + 4 | 0;
   HEAP8[i7 >> 0] = i6;
   HEAP8[i7 + 1 >> 0] = i6 >> 8;
   HEAP8[i7 + 2 >> 0] = i6 >> 16;
   HEAP8[i7 + 3 >> 0] = i6 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i9 >>> 0) break; else i1 = i1 + 8 | 0;
  }
  i5 = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 >> 0];
  i6 = i5 & 65535;
  i7 = i9 + (0 - i5) | 0;
  i1 = i3 + 2 | 0;
  if (i17 & i7 >>> 0 < i23 >>> 0) break;
  i2 = i8 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    if (i1 >>> 0 > i12 >>> 0) break L8;
    i8 = i1;
    i1 = i1 + 1 | 0;
    i8 = HEAP8[i8 >> 0] | 0;
    i2 = (i8 & 255) + i2 | 0;
   } while (i8 << 24 >> 24 == -1);
   if ((i2 | 0) < 0) break;
  }
  i4 = i2 + 4 | 0;
  i8 = i9 + i4 | 0;
  if (i7 >>> 0 < i20 >>> 0) {
   if (i8 >>> 0 > i13 >>> 0) break;
   i3 = i14 - i7 | 0;
   i2 = i19 + (0 - i3) | 0;
   if (i4 >>> 0 <= i3 >>> 0) {
    _memcpy(i9 | 0, i2 | 0, i4 | 0) | 0;
    i5 = i1;
    i4 = i8;
    continue;
   }
   _memcpy(i9 | 0, i2 | 0, i3 | 0) | 0;
   i2 = i9 + i3 | 0;
   i3 = i4 - i3 | 0;
   if (i3 >>> 0 <= (i2 - i14 | 0) >>> 0) {
    _memcpy(i2 | 0, i20 | 0, i3 | 0) | 0;
    i5 = i1;
    i4 = i2 + i3 | 0;
    continue;
   }
   i5 = i2 + i3 | 0;
   if ((i3 | 0) > 0) i3 = i20; else {
    i5 = i1;
    i4 = i2;
    continue;
   }
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    if (i4 >>> 0 < i5 >>> 0) {
     i3 = i3 + 1 | 0;
     i2 = i4;
    } else {
     i5 = i1;
     continue L8;
    }
   }
  }
  if ((i6 & 65535) < 8) {
   i3 = HEAP32[gb + 74112 + (i5 << 2) >> 2] | 0;
   HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP8[i9 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
   HEAP8[i9 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
   HEAP8[i9 + 3 >> 0] = HEAP8[i7 + 3 >> 0] | 0;
   i7 = i7 + (HEAP32[gb + 74144 + (i5 << 2) >> 2] | 0) | 0;
   i6 = i9 + 4 | 0;
   i5 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i3 = i7 + (0 - i3) | 0;
  } else {
   i6 = i7;
   i4 = i6;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i6 = i6 + 4 | 0;
   i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   i3 = i9;
   i5 = i3;
   HEAP8[i5 >> 0] = i4;
   HEAP8[i5 + 1 >> 0] = i4 >> 8;
   HEAP8[i5 + 2 >> 0] = i4 >> 16;
   HEAP8[i5 + 3 >> 0] = i4 >> 24;
   i3 = i3 + 4 | 0;
   HEAP8[i3 >> 0] = i6;
   HEAP8[i3 + 1 >> 0] = i6 >> 8;
   HEAP8[i3 + 2 >> 0] = i6 >> 16;
   HEAP8[i3 + 3 >> 0] = i6 >> 24;
   i3 = i7 + 8 | 0;
  }
  i2 = i9 + 8 | 0;
  if (i8 >>> 0 <= i18 >>> 0) while (1) {
   i7 = i3;
   i5 = i7;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i7 = i7 + 4 | 0;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i9 = i2;
   i6 = i9;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i9 = i9 + 4 | 0;
   HEAP8[i9 >> 0] = i7;
   HEAP8[i9 + 1 >> 0] = i7 >> 8;
   HEAP8[i9 + 2 >> 0] = i7 >> 16;
   HEAP8[i9 + 3 >> 0] = i7 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 < i8 >>> 0) i3 = i3 + 8 | 0; else {
    i5 = i1;
    i4 = i8;
    continue L8;
   }
  }
  if (i8 >>> 0 > i13 >>> 0) break;
  if (i2 >>> 0 < i15 >>> 0) {
   i4 = i2;
   i5 = i3;
   while (1) {
    i7 = i5;
    i26 = i7;
    i26 = HEAPU8[i26 >> 0] | HEAPU8[i26 + 1 >> 0] << 8 | HEAPU8[i26 + 2 >> 0] << 16 | HEAPU8[i26 + 3 >> 0] << 24;
    i7 = i7 + 4 | 0;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i9 = i4;
    i6 = i9;
    HEAP8[i6 >> 0] = i26;
    HEAP8[i6 + 1 >> 0] = i26 >> 8;
    HEAP8[i6 + 2 >> 0] = i26 >> 16;
    HEAP8[i6 + 3 >> 0] = i26 >> 24;
    i9 = i9 + 4 | 0;
    HEAP8[i9 >> 0] = i7;
    HEAP8[i9 + 1 >> 0] = i7 >> 8;
    HEAP8[i9 + 2 >> 0] = i7 >> 16;
    HEAP8[i9 + 3 >> 0] = i7 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i15 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i3 = i3 + (i16 - i2) | 0;
   i2 = i15;
  }
  if (i2 >>> 0 >= i8 >>> 0) {
   i5 = i1;
   i4 = i8;
   continue;
  }
  while (1) {
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   if (i4 >>> 0 < i8 >>> 0) {
    i3 = i3 + 1 | 0;
    i2 = i4;
   } else {
    i5 = i1;
    i4 = i8;
    continue L8;
   }
  }
 }
 if ((i25 | 0) == 10) if (!(i9 >>> 0 > i22 >>> 0 | (i3 | 0) != (i21 | 0))) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i26 = i9 - i14 | 0;
  return i26 | 0;
 }
 i26 = i24 + -1 - i1 | 0;
 return i26 | 0;
}

function __ZN5Umbra8QueryExt14clusterPortalsERNS_9IndexListEi(i1, i5, i9) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26;
 i10 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i25 >> 2] = i10;
 i2 = HEAP32[i10 + 76 >> 2] | 0;
 HEAP32[i25 + 4 >> 2] = i2;
 i24 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i24 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i24 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i25 + 8 >> 2] = i1;
 HEAP32[i25 + 12 >> 2] = i1 + i4;
 i2 = i25 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i25 + 20 >> 2] = i4;
 i8 = i25 + 24 | 0;
 i23 = i25 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i25 + 40 >> 2] = -1;
 i8 = i10 + 84 | 0;
 i22 = HEAP32[i8 >> 2] | 0;
 HEAP32[i25 + 44 >> 2] = i22;
 i24 = i25 + 48 | 0;
 HEAP32[i24 >> 2] = i22;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i25 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i25 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i6 = HEAP32[i10 >> 2] | 0;
 i7 = i6;
 if (!i6) {
  i24 = 6;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i24 | 0;
 }
 i21 = i5 + 3 & -4;
 i22 = i21 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 L11 : do if (!i5) i11 = 9; else if (!(HEAP8[i5 + 24 >> 0] | 0)) i11 = 9; else {
  do if ((i9 | 0) >= 0) if ((HEAP32[i6 + 124 >> 2] | 0) > (i9 | 0)) {
   i2 = HEAP32[i5 + 44 >> 2] | 0;
   if (!i2) i1 = 0; else {
    i1 = HEAP32[i10 + 108 >> 2] | 0;
    if ((i1 | 0) > (i9 | 0)) i11 = 16; else if ((i9 - i1 | 0) < (HEAP32[(HEAP32[i10 + 100 >> 2] | 0) + 124 >> 2] | 0)) i1 = HEAP32[i10 + 92 >> 2] | 0; else i11 = 16;
    if ((i11 | 0) == 16) {
     i3 = HEAP32[i6 + 180 >> 2] | 0;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = i4 + 1;
     i3 = (i3 | 0) == 0 ? 0 : i6 + i3 | 0;
     i1 = i2 + -1 | 0;
     if ((i1 | 0) > 0) {
      i2 = i1;
      i1 = 0;
      do {
       i20 = (i2 + 1 + i1 | 0) / 2 | 0;
       i19 = (HEAP32[i3 + (i20 << 2) >> 2] | 0) > (i9 | 0);
       i1 = i19 ? i1 : i20;
       i2 = i19 ? i20 + -1 | 0 : i2;
      } while ((i2 | 0) > (i1 | 0));
     } else i1 = 0;
     HEAP32[i8 >> 2] = i4;
    }
    if ((i1 | 0) == -1) break;
   }
   i2 = (HEAP32[i5 + 32 >> 2] | 0) + ((HEAP32[i5 + 40 >> 2] | 0) + (i1 << 5)) | 0;
   if (i2 | 0) {
    i3 = HEAP32[i2 >> 2] | 0;
    i13 = HEAP32[i6 + (HEAP32[i6 + 180 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i20 = i6 + (HEAP32[i6 + 184 >> 2] | 0) | 0;
    i16 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
    i20 = (HEAP32[i20 + (i1 + 1 << 2) >> 2] | 0) - i16 | 0;
    HEAP32[i10 + 92 >> 2] = i1;
    HEAP32[i10 + 96 >> 2] = i2;
    HEAP32[i10 + 100 >> 2] = i3;
    HEAP32[i10 + 104 >> 2] = i7;
    HEAP32[i10 + 108 >> 2] = i13;
    HEAP32[i10 + 112 >> 2] = i16;
    HEAP32[i10 + 116 >> 2] = i20;
    i13 = i9 - i13 | 0;
    i1 = i3;
    i3 = i7;
    break L11;
   }
  } while (0);
  HEAP32[i10 + 92 >> 2] = 0;
  HEAP32[i10 + 96 >> 2] = 0;
  HEAP32[i10 + 100 >> 2] = i7;
  HEAP32[i10 + 104 >> 2] = i7;
  HEAP32[i10 + 108 >> 2] = 0;
  HEAP32[i10 + 112 >> 2] = 0;
  HEAP32[i10 + 116 >> 2] = 0;
  i13 = i9;
  i1 = i7;
  i3 = i7;
  i16 = 0;
  i2 = 0;
 } while (0);
 if ((i11 | 0) == 9) {
  i13 = i9;
  i1 = HEAP32[i10 + 100 >> 2] | 0;
  i3 = HEAP32[i10 + 104 >> 2] | 0;
  i16 = HEAP32[i10 + 112 >> 2] | 0;
  i2 = HEAP32[i10 + 96 >> 2] | 0;
 }
 if ((i13 | 0) > -1) {
  i15 = i1;
  i19 = i15 + 124 | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  if ((i13 | 0) < (i4 | 0)) {
   i20 = i15 + 128 | 0;
   i5 = HEAP32[i20 >> 2] | 0;
   i17 = i1;
   i18 = HEAP32[i24 >> 2] | 0;
   HEAP32[i24 >> 2] = i18 + 1;
   i12 = (i2 | 0) == 0;
   if (i12) {
    i1 = 0;
    i2 = 0;
    i11 = 0;
    i10 = 0;
   } else {
    i2 = HEAP32[i2 + 20 >> 2] | 0;
    i10 = (i2 | 0) == 0;
    i1 = i10 ? 0 : i3;
    i11 = i10 ? 0 : 8;
    i10 = i10 ? 0 : i4;
   }
   i9 = (i2 | 0) == 0 ? 0 : i1 + i2 | 0;
   i8 = HEAP32[i15 + 132 >> 2] | 0;
   i14 = i15 + 180 | 0;
   HEAP32[i24 >> 2] = i18 + 3;
   i8 = (i8 | 0) == 0 ? 0 : i17 + i8 | 0;
   i5 = ((i5 | 0) == 0 ? 0 : i17 + i5 | 0) + (i13 * 20 | 0) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i5 | 0) > 0) {
    i6 = i21 + 4 | 0;
    i7 = i12 ? 0 : i16;
    i3 = 0;
    do {
     i2 = i3 + i4 | 0;
     if (!(HEAP32[i8 + (i2 << 4) >> 2] & 268435456)) {
      i1 = HEAP32[i22 >> 2] | 0;
      if ((i1 | 0) < (HEAP32[i6 >> 2] | 0)) {
       HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = i2 + i7;
       i1 = HEAP32[i22 >> 2] | 0;
      }
      HEAP32[i22 >> 2] = i1 + 1;
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i5 | 0));
   }
   if (i10 | 0) {
    i1 = i9 + (Math_imul(i11, i13) | 0) | 0;
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    if ((i7 | 0) > 0) {
     i8 = i21 + 4 | 0;
     i5 = (i12 ? 0 : i16) + (HEAP32[i1 >> 2] | 0) | 0;
     i6 = i15 + 184 | 0;
     i4 = i15 + 176 | 0;
     i3 = 0;
     do {
      if (!(HEAP32[i14 >> 2] | 0)) {
       i2 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
       i16 = i17 + (HEAP32[i20 >> 2] | 0) | 0;
       i2 = (HEAP32[i16 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i16 + (i2 * 20 | 0) >> 2] | 0) | 0;
      } else i2 = HEAP32[i17 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) >> 2] | 0;
      i1 = HEAP32[i22 >> 2] | 0;
      if ((i1 | 0) < (HEAP32[i8 >> 2] | 0)) {
       HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 2) >> 2] = i5 + i3 + i2;
       i1 = HEAP32[i22 >> 2] | 0;
      }
      HEAP32[i22 >> 2] = i1 + 1;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
    }
   }
   HEAP32[i24 >> 2] = i18;
  }
 }
 if ((HEAP32[i22 >> 2] | 0) > (HEAP32[i21 + 4 >> 2] | 0)) {
  HEAP32[i23 >> 2] = 2;
  i24 = 2;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i24 | 0;
 } else {
  i24 = HEAP32[i23 >> 2] | 0;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i24 | 0;
 }
 return 0;
}

function __ZN5Umbra12PortalCuller4initEbbRKNS_4AABBEi(i17, i8, i7, i9, i14) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 72 | 0;
 i10 = i18 + 24 | 0;
 i15 = i18 + 16 | 0;
 i16 = i18;
 i5 = i17 + 2300 | 0;
 i6 = i17 + 2306 | 0;
 HEAP16[i6 >> 1] = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP16[i2 + 2 >> 1] = 0;
 HEAP16[i2 >> 1] = 0;
 i1 = HEAP32[i17 + 2296 >> 2] | 0;
 i3 = i1 & 65535;
 i13 = i17 + 2304 | 0;
 HEAP16[i13 >> 1] = 1;
 if ((i3 & 65535) > 1) {
  i4 = 1;
  do {
   i20 = i4;
   i4 = i4 + 1 | 0;
   i19 = i4 & 65535;
   HEAP16[i2 + (i20 << 4) >> 1] = i19;
  } while (i19 << 16 >> 16 != i3 << 16 >> 16);
 }
 HEAP16[i2 + ((i1 & 65535) + -1 << 4) >> 1] = 0;
 i1 = HEAP16[i13 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i1 = HEAP16[i6 >> 1] | 0;
  if (!(i1 << 16 >> 16)) i1 = 0; else {
   i11 = i1 & 65535;
   HEAP16[i6 >> 1] = HEAP16[(HEAP32[i5 >> 2] | 0) + (i11 << 4) >> 1] | 0;
   i2 = i17 + 7048 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   __ZN5Umbra12PortalCuller12finalizeCellEt(i17, i1);
   i2 = HEAP32[i5 >> 2] | 0;
   i20 = i2 + (i11 << 4) + 8 | 0;
   __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i17 + 292 >> 2] | 0, i20);
   HEAP8[i20 >> 0] = 0;
   HEAP8[i20 + 1 >> 0] = 0;
   HEAP8[i20 + 2 >> 0] = 0;
   HEAP8[i20 + 3 >> 0] = 0;
   HEAP32[i2 + (i11 << 4) + 12 >> 2] = 0;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP16[i17 + 2936 + (HEAPU16[i2 + (i11 << 4) + 4 >> 1] << 1) >> 1] = i1;
   i11 = 7;
  }
 } else {
  HEAP16[i13 >> 1] = HEAP16[i2 + ((i1 & 65535) << 4) >> 1] | 0;
  i11 = 7;
 }
 if ((i11 | 0) == 7) HEAP16[i2 + ((i1 & 65535) << 4) + 4 >> 1] = 0;
 HEAP16[i17 + 7030 >> 1] = i1;
 i4 = i17 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i7) i1 = HEAP8[i5 + 1224 >> 0] ^ 1; else i1 = 0;
 HEAP8[i17 + 7040 >> 0] = i1;
 i1 = (HEAP8[i5 + 1365 >> 0] | 0) != 0 | i8;
 if (i1) {
  f23 = Math_fround(HEAPF32[i5 + 128 >> 2]);
  f22 = Math_fround(HEAPF32[i5 + 132 >> 2]);
  f21 = Math_fround(HEAPF32[i5 + 136 >> 2]);
  f25 = Math_fround(HEAPF32[i5 + 140 >> 2]);
  f24 = Math_fround(f23 * Math_fround(HEAPF32[i5 + 1184 >> 2]));
  f24 = Math_fround(f24 + Math_fround(f22 * Math_fround(HEAPF32[i5 + 1188 >> 2])));
  HEAPF32[i17 + 7036 >> 2] = Math_fround(Math_fround(-Math_fround(f25 + Math_fround(f24 + Math_fround(f21 * Math_fround(HEAPF32[i5 + 1192 >> 2]))))) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)) + Math_fround(f21 * f21)))));
 }
 i2 = i10;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f25 = Math_fround(HEAPF32[i9 >> 2]);
 if (!(f25 <= Math_fround(HEAPF32[i9 + 12 >> 2]))) i11 = 16; else {
  f25 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  if (!(f25 <= Math_fround(HEAPF32[i9 + 16 >> 2]))) i11 = 16; else {
   f25 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   if (!(f25 <= Math_fround(HEAPF32[i9 + 20 >> 2]))) i11 = 16; else {
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 >> 2] = i9;
   }
  }
 }
 do if ((i11 | 0) == 16) if (i1) {
  __ZNK5Umbra11Transformer16getNearPlaneQuadEv(i10, i5);
  HEAP32[i15 + 4 >> 2] = 1;
  HEAP32[i15 >> 2] = i10;
  break;
 } else {
  HEAP32[i15 + 4 >> 2] = 2;
  HEAP32[i15 >> 2] = i5 + 1184;
  break;
 } while (0);
 i19 = HEAP32[HEAP32[HEAP32[i17 >> 2] >> 2] >> 2] | 0;
 i11 = i19 + 20 | 0;
 i19 = i19 + 32 | 0;
 i20 = i12 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 if (!(__ZNK5Umbra15IntersectFilter11boundsCheckERKNS_4AABBE(i15, i12) | 0)) {
  HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] = 5;
  i20 = 0;
  STACKTOP = i18;
  return i20 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[i2 + 1365 >> 0] | 0)) {
  i20 = HEAP32[i2 + 1188 >> 2] | 0;
  i1 = HEAP32[i2 + 1192 >> 2] | 0;
  HEAP32[i17 + 436 >> 2] = HEAP32[i2 + 1184 >> 2];
  HEAP32[i17 + 440 >> 2] = i20;
  HEAP32[i17 + 444 >> 2] = i1;
  i1 = 1;
 } else {
  f24 = Math_fround(HEAPF32[i2 + 128 >> 2]);
  f25 = Math_fround(HEAPF32[i2 + 132 >> 2]);
  i19 = f24 >= Math_fround(0.0) & 1;
  i20 = f25 >= Math_fround(0.0) & 1;
  i1 = Math_fround(HEAPF32[i2 + 136 >> 2]) >= Math_fround(0.0) & 1;
  HEAPF32[i17 + 436 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 440 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 444 >> 2] = Math_fround(0.0);
  HEAP8[i17 + 448 >> 0] = i19;
  HEAP8[i17 + 449 >> 0] = i20;
  HEAP8[i17 + 450 >> 0] = i1;
  i1 = 0;
 }
 HEAP8[i17 + 451 >> 0] = i1;
 HEAP32[i16 >> 2] = i17;
 HEAP32[i16 + 4 >> 2] = i15;
 HEAP32[i16 + 8 >> 2] = i14;
 f25 = Math_fround(HEAPF32[i17 + 296 >> 2]);
 HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 if (__ZN5Umbra16TileTraverseTree4initINS_15StartCellFinderEEEbRKNS_11TransformerERKNS_15IntersectFilterET_f(i17 + 432 | 0, i2, i15, i12, f25) | 0) if (HEAP16[i13 >> 1] | 0) {
  i4 = HEAP32[i17 >> 2] | 0;
  i1 = i4 + 28 | 0;
  if ((HEAP32[i17 + 524 >> 2] | 0) == -1) {
   HEAP32[i1 >> 2] = 5;
   i20 = 0;
   STACKTOP = i18;
   return i20 | 0;
  }
  if (HEAP32[i1 >> 2] | 0) {
   i20 = 0;
   STACKTOP = i18;
   return i20 | 0;
  }
  i2 = i4 + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = i1 + 32928 | 0;
  if (i3 >>> 0 > (HEAP32[i4 + 12 >> 2] | 0) >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
  i2 = i1;
  i3 = i2 + 128 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i1 + 128 >> 2] = -1;
  HEAP32[i1 + 132 >> 2] = 0;
  HEAP32[i1 + 136 >> 2] = 1024;
  HEAP32[i17 + 292 >> 2] = i1;
  if (!i1) {
   HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] = 2;
   i20 = 0;
   STACKTOP = i18;
   return i20 | 0;
  } else {
   HEAP32[i1 + 32912 >> 2] = HEAP32[i17 + 348 >> 2];
   _memset(i17 + 2936 | 0, 0, 4094) | 0;
   i20 = 1;
   STACKTOP = i18;
   return i20 | 0;
  }
 }
 HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] = 2;
 i20 = 0;
 STACKTOP = i18;
 return i20 | 0;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i24, i25, i2, i27, i26, i18, i19, i16, i1, i21, i22) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i17 = 0, i20 = 0, i23 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i28 + 208 | 0;
 i17 = i28 + 160 | 0;
 i20 = i28 + 16 | 0;
 i23 = i28;
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i40 = i17 + 4 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAPF32[i17 + 20 >> 2] = Math_fround(1.0);
 i40 = i17 + 24 | 0;
 HEAP32[i40 >> 2] = 0;
 HEAP32[i40 + 4 >> 2] = 0;
 HEAP32[i40 + 8 >> 2] = 0;
 HEAP32[i40 + 12 >> 2] = 0;
 HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 44 >> 2] = Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f39 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f38 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f36 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f14 * f36);
 f35 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f9 * f35));
 f12 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f8 * f12));
 f33 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f14 * f33);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * f3));
 f13 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f8 * f13));
 f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f14 = Math_fround(f14 * f29);
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f9 = Math_fround(f14 + Math_fround(f9 * f5));
 f14 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f6 = Math_fround(f37 + f6);
 f7 = Math_fround(f34 + f7);
 f8 = Math_fround(f4 + Math_fround(f9 + Math_fround(f8 * f14)));
 f9 = Math_fround(f37 + Math_fround(Math_fround(Math_fround(f39 * f36) + Math_fround(f38 * f35)) + Math_fround(f11 * f12)));
 f10 = Math_fround(f34 + Math_fround(Math_fround(Math_fround(f39 * f33) + Math_fround(f38 * f3)) + Math_fround(f11 * f13)));
 f11 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f39 * f29) + Math_fround(f38 * f5)) + Math_fround(f11 * f14)));
 f12 = Math_fround(f37 + Math_fround(Math_fround(Math_fround(f30 * f36) + Math_fround(f32 * f35)) + Math_fround(f31 * f12)));
 f13 = Math_fround(f34 + Math_fround(Math_fround(Math_fround(f30 * f33) + Math_fround(f32 * f3)) + Math_fround(f31 * f13)));
 f14 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f32 * f5)) + Math_fround(f31 * f14)));
 f31 = Math_fround(f9 - f6);
 f5 = Math_fround(f10 - f7);
 f32 = Math_fround(f11 - f8);
 f29 = Math_fround(f12 - f6);
 f30 = Math_fround(f13 - f7);
 f4 = Math_fround(f14 - f8);
 f3 = Math_fround(Math_fround(f5 * f4) - Math_fround(f30 * f32));
 f4 = Math_fround(Math_fround(f29 * f32) - Math_fround(f31 * f4));
 f5 = Math_fround(Math_fround(f31 * f30) - Math_fround(f29 * f5));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))));
 f3 = Math_fround(f29 * f3);
 f4 = Math_fround(f29 * f4);
 f5 = Math_fround(f29 * f5);
 if (!i19) {
  f39 = Math_fround(f3 * Math_fround(HEAPF32[i25 + 16 >> 2]));
  f39 = Math_fround(f39 + Math_fround(f4 * Math_fround(HEAPF32[i25 + 20 >> 2])));
  if (Math_fround(Math_fround(f39 + Math_fround(f5 * Math_fround(HEAPF32[i25 + 24 >> 2]))) - Math_fround(Math_fround(f8 * f5) + Math_fround(Math_fround(f6 * f3) + Math_fround(f7 * f4)))) < Math_fround(0.0)) {
   i40 = 0;
   STACKTOP = i28;
   return i40 | 0;
  }
 }
 i40 = i20 + 64 | 0;
 HEAP32[i20 + 80 >> 2] = 7;
 HEAPF32[i20 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i40 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i40 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i40 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i40 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 f38 = Math_fround(Math_fround(f13 + Math_fround(f7 + f10)) * Math_fround(.333332986));
 f39 = Math_fround(Math_fround(f14 + Math_fround(f8 + f11)) * Math_fround(.333332986));
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(f12 + Math_fround(f6 + f9)) * Math_fround(.333332986));
 HEAPF32[i20 + 4 >> 2] = f38;
 HEAPF32[i20 + 8 >> 2] = f39;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 96 >> 2] = f6;
 HEAPF32[i20 + 100 >> 2] = f7;
 HEAPF32[i20 + 104 >> 2] = f8;
 HEAPF32[i20 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 112 >> 2] = f9;
 HEAPF32[i20 + 116 >> 2] = f10;
 HEAPF32[i20 + 120 >> 2] = f11;
 HEAPF32[i20 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 128 >> 2] = f12;
 HEAPF32[i20 + 132 >> 2] = f13;
 HEAPF32[i20 + 136 >> 2] = f14;
 HEAPF32[i20 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i15 + 32 >> 2] = i16;
 HEAP32[i15 + 36 >> 2] = i17;
 HEAP32[i15 + 40 >> 2] = i17;
 HEAP8[i15 + 44 >> 0] = 1;
 HEAP32[i15 >> 2] = gb + 84676 + 8;
 HEAP32[i15 + 48 >> 2] = i20;
 __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSG_5Vec3VE(i20, i27, i26, i24, i15, i25, i21, i22, i18, i23) | 0;
 i40 = 1;
 STACKTOP = i28;
 return i40 | 0;
}

function __ZN5physx16PxsSolverEndTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24;
 i21 = HEAP32[HEAP32[i1 + 24 >> 2] >> 2] | 0;
 i22 = i21 + 9168 | 0;
 HEAP32[i21 + 9180 >> 2] = HEAP32[i21 + 9028 >> 2];
 i23 = i1 + 20 | 0;
 i5 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i5 + 100 >> 2] | 0;
 i4 = HEAP32[i1 + 64 >> 2] | 0;
 i5 = HEAP32[i5 + 112 >> 2] | 0;
 i6 = i1 + 48 | 0;
 i19 = HEAP32[i6 >> 2] | 0;
 if (i19 | 0) {
  i2 = i1 + 28 | 0;
  i1 = 0;
  do {
   i18 = i1 + i4 | 0;
   i19 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 64 >> 2] | 0;
   HEAP32[i19 + 64 >> 2] = HEAP32[i3 + (i18 << 5) >> 2];
   HEAP32[i19 + 68 >> 2] = HEAP32[i3 + (i18 << 5) + 4 >> 2];
   HEAP32[i19 + 72 >> 2] = HEAP32[i3 + (i18 << 5) + 8 >> 2];
   HEAP32[i19 + 80 >> 2] = HEAP32[i3 + (i18 << 5) + 16 >> 2];
   HEAP32[i19 + 84 >> 2] = HEAP32[i3 + (i18 << 5) + 20 >> 2];
   HEAP32[i19 + 88 >> 2] = HEAP32[i3 + (i18 << 5) + 24 >> 2];
   i1 = i1 + 1 | 0;
   HEAP32[i5 + (i1 + i4 << 6) + 40 >> 2] = 0;
   i19 = HEAP32[i6 >> 2] | 0;
  } while (i1 >>> 0 < i19 >>> 0);
 }
 i16 = i21 + 8968 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 if (i17 | 0) {
  i18 = i21 + 8976 | 0;
  i15 = HEAP32[i21 + 8964 >> 2] | 0;
  i19 = 0;
  do {
   i9 = i15 + (i19 << 5) | 0;
   i7 = HEAP32[i15 + (i19 << 5) + 8 >> 2] | 0;
   i3 = i7 + 98 | 0;
   i2 = i7 + 28 | 0;
   if (!(HEAP16[i3 >> 1] & 16)) {
    i14 = 0;
    i1 = i7 + 32 | 0;
   } else {
    i1 = i7 + 32 | 0;
    i14 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) + 15 & -16) | 0;
   }
   i13 = i7 + 20 | 0;
   i8 = HEAP16[i13 >> 1] | 0;
   HEAP32[i2 >> 2] = HEAP32[i15 + (i19 << 5) + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i15 + (i19 << 5) + 16 >> 2];
   HEAP16[i13 >> 1] = HEAP16[i15 + (i19 << 5) + 20 >> 1] | 0;
   HEAP16[i3 >> 1] = HEAP16[i15 + (i19 << 5) + 22 >> 1] | 0;
   i1 = HEAP16[i15 + (i19 << 5) + 4 >> 1] | 0;
   if ((i1 & 65535) > 1) {
    i6 = HEAP32[i9 >> 2] | 0;
    i4 = i1 & 65535;
    i3 = HEAP32[i18 >> 2] | 0;
    i5 = i7 + 40 | 0;
    i1 = i7 + 36 | 0;
    i2 = 1;
    do {
     i13 = HEAP32[(HEAP32[i3 + (i6 + i2 << 2) >> 2] | 0) + 12 >> 2] | 0;
     HEAP32[i13 + 56 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i13 + 52 >> 2] = HEAP32[i1 >> 2];
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i4 >>> 0);
   }
   if (!((i14 | 0) == 0 | i8 << 16 >> 16 == 0)) {
    i12 = HEAP32[i15 + (i19 << 5) + 28 >> 2] | 0;
    i13 = HEAP32[i18 >> 2] | 0;
    i10 = i8 & 65535;
    i11 = 0;
    i1 = 0;
    i3 = 0;
    i2 = HEAP32[i9 >> 2] | 0;
    do {
     i8 = HEAPU16[i12 + (i11 << 1) >> 1] | 0;
     L23 : while (1) {
      i7 = HEAP32[(HEAP32[i13 + (i2 << 2) >> 2] | 0) + 12 >> 2] | 0;
      i5 = HEAP16[i7 + 36 >> 1] | 0;
      i6 = i5 << 16 >> 16 == 0;
      do {
       i4 = i8 >>> 0 > i1 >>> 0;
       if (!(i4 | i6)) break L23;
       i25 = i8 - i1 | 0;
       i9 = (i4 ? i5 : 0) & 65535;
       i4 = i9 - i3 | 0;
       i4 = i25 >>> 0 < i4 >>> 0 ? i25 : i4;
       i1 = i4 + i1 | 0;
       i3 = i4 + i3 | 0;
      } while ((i3 | 0) != (i9 | 0));
      i3 = 0;
      i2 = i2 + 1 | 0;
     }
     if (HEAP16[i7 + 114 >> 1] & 16) HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + ((HEAP32[i7 + 48 >> 2] | 0) + 15 & -16) + (i3 << 2) >> 2] = HEAP32[i14 + (i11 << 2) >> 2];
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i10 | 0));
   }
   i19 = i19 + 1 | 0;
  } while ((i19 | 0) != (i17 | 0));
 }
 HEAP32[i16 >> 2] = 0;
 __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(HEAP32[i21 + 328 >> 2] | 0, i21 + 316 | 0);
 i1 = (HEAP32[i23 >> 2] | 0) + 156 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i25 = HEAP32[(HEAP32[i23 >> 2] | 0) + 96 >> 2] | 0;
 i2 = i25 + 5864 | 0;
 i3 = i21 + 9112 | 0;
 i4 = HEAP32[i21 + 9060 >> 2] | 0;
 i5 = i21 + 9116 | 0;
 HEAP32[i5 >> 2] = i4;
 i6 = HEAP32[i25 + 5868 >> 2] | 0;
 i7 = i4 + i6 | 0;
 i8 = i7 + 63 & -64;
 if ((HEAP32[i25 + 5872 >> 2] & 2147483647) >>> 0 >= i8 >>> 0) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i2, i7, i20);
  i19 = HEAP32[i2 >> 2] | 0;
  i19 = i19 + (i6 << 4) | 0;
  i20 = HEAP32[i3 >> 2] | 0;
  i25 = i4 << 4;
  _memcpy(i19 | 0, i20 | 0, i25 | 0) | 0;
  HEAP32[i5 >> 2] = 0;
  i25 = HEAP32[i23 >> 2] | 0;
  i25 = i25 + 96 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE(i25, i22);
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  i25 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i25);
  i25 = HEAP32[i23 >> 2] | 0;
  i25 = i25 + 96 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  i25 = i25 + 224 | 0;
  i25 = HEAP32[i25 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i25, i21);
  STACKTOP = i24;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, i8);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i2, i7, i20);
 i19 = HEAP32[i2 >> 2] | 0;
 i19 = i19 + (i6 << 4) | 0;
 i20 = HEAP32[i3 >> 2] | 0;
 i25 = i4 << 4;
 _memcpy(i19 | 0, i20 | 0, i25 | 0) | 0;
 HEAP32[i5 >> 2] = 0;
 i25 = HEAP32[i23 >> 2] | 0;
 i25 = i25 + 96 | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE(i25, i22);
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 i25 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i25);
 i25 = HEAP32[i23 >> 2] | 0;
 i25 = i25 + 96 | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 i25 = i25 + 224 | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i25, i21);
 STACKTOP = i24;
 return;
}

function __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 44 | 0;
 i9 = i13 + 16 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13;
 i12 = i10;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i12 = i7 + 32 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i10 | 0, i10 + 4 | 0);
  i6 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 i6 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
 i4 = i7 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i14 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 11;
  }
  if ((i5 | 0) == 9) i5 = 11;
  if ((i5 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i14 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 19;
   }
  }
  if ((i5 | 0) == 17) i5 = 19;
  if ((i5 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 52 >> 2] | 0;
 } while (0);
 i14 = (HEAP8[i7 + 159 >> 0] | 0) == 0;
 i2 = __Z14GetDynamicsSDKv() | 0;
 if (i14) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
  i1 = __ZN5physx21PxRevoluteJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i2, i6, i8, i1, i9) | 0;
  HEAP32[i12 >> 2] = i1;
 } else {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
  i1 = __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i2, i6, i8, i1, i9) | 0;
  HEAP32[i12 >> 2] = i1;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 0, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 1, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 2, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 3, (HEAP8[i7 + 156 >> 0] | 0 ? 1 : 2) | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 4, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 5, 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = i11;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i11 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i11 | 0, i2 | 0);
 if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i10 + 4 >> 2] | 0)) {
  i14 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i14 >> 2] | 0;
  i12 = i12 + 28 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(i12 | 0, i14 | 0, i8 | 0, i9 | 0);
  i14 = HEAP32[i8 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i14);
  i14 = HEAP32[i9 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i14);
  STACKTOP = i13;
  return;
 }
 HEAP8[i7 + 76 >> 0] = 1;
 i14 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i12 = i12 + 28 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_viii(i12 | 0, i14 | 0, i8 | 0, i9 | 0);
 i14 = HEAP32[i8 >> 2] | 0;
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i14);
 i14 = HEAP32[i9 >> 2] | 0;
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i14);
 STACKTOP = i13;
 return;
}

function __ZN31CollisionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 613976 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613976 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614008 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614008 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614040 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614040 + 46 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614087 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614087 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614116 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614116 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614145 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614145 + 35 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 5;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614181 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614181 + 34 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100001;
 HEAP32[i7 + 12 >> 2] = 6;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614216 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614216 + 27 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 7;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Umbra9Matrix4x4mLERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i17 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i17 >> 2]);
 i11 = i1 + 32 | 0;
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 i23 = i1 + 48 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 i26 = i2 + 4 | 0;
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i26 >> 2])));
 i25 = i2 + 8 | 0;
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i25 >> 2])));
 i24 = i2 + 12 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i24 >> 2])));
 i22 = i2 + 16 | 0;
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i22 >> 2]));
 i21 = i2 + 20 | 0;
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2])));
 i20 = i2 + 24 | 0;
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2])));
 i19 = i2 + 28 | 0;
 HEAPF32[i17 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i19 >> 2])));
 i17 = i2 + 32 | 0;
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 i16 = i2 + 36 | 0;
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
 i15 = i2 + 40 | 0;
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
 i13 = i2 + 44 | 0;
 HEAPF32[i11 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2])));
 i11 = i2 + 48 | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2]));
 i9 = i2 + 52 | 0;
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 i7 = i2 + 56 | 0;
 f8 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])));
 i4 = i2 + 60 | 0;
 HEAPF32[i23 >> 2] = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])));
 i23 = i1 + 4 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 i18 = i1 + 20 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 i12 = i1 + 36 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i3 = i1 + 52 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i26 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i25 >> 2])));
 HEAPF32[i23 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i24 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f8 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 i3 = i1 + 8 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i12 = i1 + 24 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i18 = i1 + 40 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 i23 = i1 + 56 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i26 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i25 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i24 >> 2])));
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i22 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2]));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 f8 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i23 >> 2] = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])));
 i23 = i1 + 12 | 0;
 f10 = Math_fround(HEAPF32[i23 >> 2]);
 i18 = i1 + 28 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 i12 = i1 + 44 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i3 = i1 + 60 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i26 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i25 >> 2])));
 HEAPF32[i23 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i24 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f8 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZN15b2ContactSolver27SolveTOIPositionConstraintsEii(i2, i47, i48) {
 i2 = i2 | 0;
 i47 = i47 | 0;
 i48 = i48 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, f55 = f0;
 i54 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i49 = i54 + 40 | 0;
 i50 = i54 + 24 | 0;
 i51 = i54;
 i52 = i2 + 48 | 0;
 if ((HEAP32[i52 >> 2] | 0) <= 0) {
  f31 = Math_fround(0.0);
  i53 = f31 >= Math_fround(-.00749999983);
  STACKTOP = i54;
  return i53 | 0;
 }
 i53 = i2 + 36 | 0;
 i38 = i2 + 24 | 0;
 i39 = i49 + 8 | 0;
 i40 = i49 + 12 | 0;
 i41 = i50 + 8 | 0;
 i42 = i50 + 12 | 0;
 i37 = i49 + 4 | 0;
 i36 = i50 + 4 | 0;
 i35 = i51 + 4 | 0;
 i43 = i51 + 8 | 0;
 i34 = i51 + 12 | 0;
 i44 = i51 + 16 | 0;
 f1 = Math_fround(0.0);
 i33 = 0;
 do {
  i2 = HEAP32[i53 >> 2] | 0;
  i27 = i2 + (i33 * 88 | 0) | 0;
  i45 = HEAP32[i2 + (i33 * 88 | 0) + 32 >> 2] | 0;
  i46 = HEAP32[i2 + (i33 * 88 | 0) + 36 >> 2] | 0;
  f28 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 48 >> 2]);
  f29 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 52 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 56 >> 2]);
  f31 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 60 >> 2]);
  i32 = HEAP32[i2 + (i33 * 88 | 0) + 84 >> 2] | 0;
  if ((i45 | 0) == (i47 | 0) | (i45 | 0) == (i48 | 0)) {
   f25 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 40 >> 2]);
   f26 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 64 >> 2]);
  } else {
   f25 = Math_fround(0.0);
   f26 = Math_fround(0.0);
  }
  if ((i46 | 0) == (i47 | 0) | (i46 | 0) == (i48 | 0)) {
   f24 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 44 >> 2]);
   f23 = Math_fround(HEAPF32[i2 + (i33 * 88 | 0) + 68 >> 2]);
  } else {
   f23 = Math_fround(0.0);
   f24 = Math_fround(0.0);
  }
  i2 = HEAP32[i38 >> 2] | 0;
  i5 = HEAP32[i2 + (i45 * 12 | 0) >> 2] | 0;
  i3 = HEAP32[i2 + (i45 * 12 | 0) + 4 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i2 + (i45 * 12 | 0) + 8 >> 2]);
  i6 = HEAP32[i2 + (i46 * 12 | 0) >> 2] | 0;
  i4 = HEAP32[i2 + (i46 * 12 | 0) + 4 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i2 + (i46 * 12 | 0) + 8 >> 2]);
  if ((i32 | 0) > 0) {
   f22 = Math_fround(f25 + f24);
   i2 = 0;
   do {
    f13 = Math_fround(+Math_sin(+f7));
    HEAPF32[i39 >> 2] = f13;
    f16 = Math_fround(+Math_cos(+f7));
    HEAPF32[i40 >> 2] = f16;
    f12 = Math_fround(+Math_sin(+f8));
    HEAPF32[i41 >> 2] = f12;
    f18 = Math_fround(+Math_cos(+f8));
    HEAPF32[i42 >> 2] = f18;
    f19 = Math_fround(Math_fround(f28 * f16) - Math_fround(f29 * f13));
    f13 = Math_fround(Math_fround(f29 * f16) + Math_fround(f28 * f13));
    f16 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = Math_fround(f16 - f19);
    f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f17 - f13);
    HEAPF32[i49 >> 2] = f19;
    HEAPF32[i37 >> 2] = f13;
    f13 = Math_fround(Math_fround(f30 * f18) - Math_fround(f31 * f12));
    f12 = Math_fround(Math_fround(f31 * f18) + Math_fround(f30 * f12));
    f18 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f18 - f13);
    f19 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f19 - f12);
    HEAPF32[i50 >> 2] = f13;
    HEAPF32[i36 >> 2] = f12;
    __ZN24b2PositionSolverManifold10InitializeEP27b2ContactPositionConstraintRK11b2TransformS4_i(i51, i27, i49, i50, i2);
    f12 = Math_fround(HEAPF32[i51 >> 2]);
    f13 = Math_fround(HEAPF32[i35 >> 2]);
    f20 = Math_fround(HEAPF32[i43 >> 2]);
    f21 = Math_fround(HEAPF32[i34 >> 2]);
    f10 = Math_fround(HEAPF32[i44 >> 2]);
    f14 = Math_fround(f20 - f16);
    f15 = Math_fround(f21 - f17);
    f20 = Math_fround(f20 - f18);
    f21 = Math_fround(f21 - f19);
    f1 = f1 < f10 ? f1 : f10;
    f10 = Math_fround(Math_fround(HEAPF32[gb + 151908 >> 2]) * Math_fround(f10 + Math_fround(.00499999989)));
    f9 = Math_fround(-Math_fround(HEAPF32[gb + 151880 >> 2]));
    i6 = f10 < Math_fround(0.0);
    f10 = i6 ? f10 : Math_fround(0.0);
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f12 * f15));
    f55 = Math_fround(Math_fround(f13 * f20) - Math_fround(f12 * f21));
    f11 = Math_fround(Math_fround(f55 * Math_fround(f23 * f55)) + Math_fround(f22 + Math_fround(f11 * Math_fround(f26 * f11))));
    if (f11 > Math_fround(0.0)) f9 = Math_fround(Math_fround(-(f10 < f9 ? f9 : f10)) / f11); else f9 = Math_fround(0.0);
    f55 = Math_fround(f12 * f9);
    f13 = Math_fround(f13 * f9);
    f12 = Math_fround(f25 * f13);
    f16 = Math_fround(f16 - Math_fround(f25 * f55));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    f17 = Math_fround(f17 - f12);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround(f7 - Math_fround(f26 * Math_fround(Math_fround(f14 * f13) - Math_fround(f15 * f55))));
    f17 = Math_fround(f24 * f13);
    f18 = Math_fround(f18 + Math_fround(f24 * f55));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    f19 = Math_fround(f19 + f17);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    f8 = Math_fround(f8 + Math_fround(f23 * Math_fround(Math_fround(f20 * f13) - Math_fround(f21 * f55))));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i32 | 0));
   i2 = HEAP32[i38 >> 2] | 0;
  }
  HEAP32[i2 + (i45 * 12 | 0) >> 2] = i5;
  HEAP32[i2 + (i45 * 12 | 0) + 4 >> 2] = i3;
  i32 = HEAP32[i38 >> 2] | 0;
  HEAPF32[i32 + (i45 * 12 | 0) + 8 >> 2] = f7;
  HEAP32[i32 + (i46 * 12 | 0) >> 2] = i6;
  HEAP32[i32 + (i46 * 12 | 0) + 4 >> 2] = i4;
  HEAPF32[(HEAP32[i38 >> 2] | 0) + (i46 * 12 | 0) + 8 >> 2] = f8;
  i33 = i33 + 1 | 0;
 } while ((i33 | 0) < (HEAP32[i52 >> 2] | 0));
 i53 = f1 >= Math_fround(-.00749999983);
 STACKTOP = i54;
 return i53 | 0;
}

function __ZN27ColorModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 614610 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614610 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614642 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614642 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614674 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614674 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614706 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614706 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614738 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614738 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614770 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614770 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 5;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614802 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614802 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 6;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 614834 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 614834 + 31 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 7;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb(i16, i5, i3, i4) {
 i16 = i16 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i2 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 L1 : do if (!i2) i6 = 5; else {
  i2 = i1 + (i2 << 2) | 0;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i16 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i6 = 5;
    break;
   }
  }
 } while (0);
 if ((i6 | 0) == 5) {
  if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 383656 | 0, 0, gb + 380852 | 0, 370, 512, i1, 0, 0);
 }
 i15 = i16 + 144 | 0;
 if (!((HEAP8[i15 >> 0] | 0) == 0 | i4)) {
  i16 = HEAP32[i16 + 152 >> 2] | 0;
  return i16 | 0;
 }
 HEAP8[i15 >> 0] = 0;
 HEAP32[i16 + 168 >> 2] = 0;
 HEAP32[i16 + 172 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i16 + 160 >> 0] = 1;
 i14 = HEAP32[gb + 1112272 >> 2] | 0;
 L16 : do switch (i5 | 0) {
 case 2:
  {
   __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i14, 3, i16, 63);
   break;
  }
 case 1:
  {
   i10 = i14 + 12 | 0;
   i9 = i14 + 24 | 0;
   i6 = i14 + 88 | 0;
   i7 = i14 + 84 | 0;
   i8 = i14 + 96 | 0;
   i11 = i14 + 100 | 0;
   i12 = i14 + 80 | 0;
   i5 = 0;
   while (1) {
    i13 = 1 << i5;
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    L33 : do if (i2 | 0) {
     i2 = i1 + (i2 << 2) | 0;
     while (1) {
      if ((HEAP32[i1 >> 2] | 0) == (i16 | 0)) break;
      i1 = i1 + 4 | 0;
      if ((i1 | 0) == (i2 | 0)) break L33;
     }
     i4 = HEAP32[i6 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     i17 = i4 - i3 >> 2;
     i2 = HEAP32[i8 >> 2] | 0;
     i1 = HEAP32[i11 >> 2] | 0;
     if ((((i17 | 0) == 0 ? 0 : (i17 * 341 | 0) + -1 | 0) | 0) == (i1 + i2 | 0)) {
      __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i12);
      i1 = HEAP32[i11 >> 2] | 0;
      i2 = HEAP32[i8 >> 2] | 0;
      i4 = HEAP32[i6 >> 2] | 0;
      i3 = HEAP32[i7 >> 2] | 0;
     }
     i1 = i1 + i2 | 0;
     if ((i4 | 0) == (i3 | 0)) i1 = 0; else i1 = (HEAP32[i3 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
     HEAP32[i1 >> 2] = i16;
     HEAP32[i1 + 4 >> 2] = i13;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    } while (0);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == 6) {
     i6 = 32;
     break;
    }
   }
   break;
  }
 default:
  {
   i10 = i14 + 12 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i9 = i14 + 24 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) i6 = 32; else {
    i2 = i1 + (i2 << 2) | 0;
    while (1) {
     if ((HEAP32[i1 >> 2] | 0) == (i16 | 0)) break;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i6 = 32;
      break L16;
     }
    }
    i6 = i14 + 88 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i7 = i14 + 84 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i17 = i3 - i2 >> 2;
    i5 = i14 + 96 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i8 = i14 + 100 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if ((((i17 | 0) == 0 ? 0 : (i17 * 341 | 0) + -1 | 0) | 0) == (i1 + i4 | 0)) {
     __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i14 + 80 | 0);
     i1 = HEAP32[i8 >> 2] | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = i1 + i4 | 0;
    if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i1 + 4 >> 2] = 63;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    i6 = 32;
   }
  }
 } while (0);
 if ((i6 | 0) == 32) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  L48 : do if (i2 | 0) {
   i4 = i1 + (i2 << 2) | 0;
   i3 = i1;
   do {
    if ((HEAP32[i3 >> 2] | 0) == (i16 | 0)) {
     i6 = 36;
     break;
    }
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) != (i4 | 0));
   if ((i6 | 0) == 36) {
    i6 = i14 + 88 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i7 = i14 + 84 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i17 = i3 - i2 >> 2;
    i4 = i14 + 96 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i8 = i14 + 100 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if ((((i17 | 0) == 0 ? 0 : (i17 * 341 | 0) + -1 | 0) | 0) == (i1 + i5 | 0)) {
     __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i14 + 80 | 0);
     i1 = HEAP32[i8 >> 2] | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = i1 + i5 | 0;
    if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i1 + 4 >> 2] = 63;
    HEAP32[i1 + 8 >> 2] = 1;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   }
   if (i2 | 0) {
    i2 = i1 + (i2 << 2) | 0;
    while (1) {
     if ((HEAP32[i1 >> 2] | 0) == (i16 | 0)) break;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i2 | 0)) break L48;
    }
    i6 = i14 + 88 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i7 = i14 + 84 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i17 = i3 - i2 >> 2;
    i5 = i14 + 96 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i8 = i14 + 100 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if ((((i17 | 0) == 0 ? 0 : (i17 * 341 | 0) + -1 | 0) | 0) == (i1 + i4 | 0)) {
     __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i14 + 80 | 0);
     i1 = HEAP32[i8 >> 2] | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = i1 + i4 | 0;
    if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i1 + 4 >> 2] = 63;
    HEAP32[i1 + 8 >> 2] = 2;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   }
  } while (0);
  HEAP8[i15 >> 0] = 1;
 }
 i17 = HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2] | 0;
 HEAP32[i16 + 152 >> 2] = i17;
 return i17 | 0;
}

function __Z30ProcessDynamicBatchGeometryJobP25DynamicVBOGeometryJobDataj(i2, i24) {
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 8 | 0;
 i1 = i25;
 if ((HEAP16[gb + 1157708 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157708 | 0, i22);
  i23 = gb + 1157708 | 0;
 } else i23 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i21 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + (i24 * 20 | 0) | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i5 = i1 + (i24 * 20 | 0) + 4 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   _memset(i22 | 0, 0, 256) | 0;
   i20 = i21 + (i24 * 11284 | 0) + 11276 | 0;
   i2 = HEAP32[i20 >> 2] | 0;
   if (i2 | 0) {
    if ((HEAP32[i21 + (i24 * 11284 | 0) + 11264 >> 2] | 0) == 2) {
     i1 = 0;
     i3 = 0;
     do {
      i19 = ((HEAP32[i21 + (i24 * 11284 | 0) + 10496 + (i3 << 2) >> 2] | 0) >>> 2) * 6 | 0;
      HEAP32[i22 + (i3 << 2) >> 2] = i19;
      i1 = (i19 | 0) > (i1 | 0) ? i19 : i1;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
     if ((i1 | 0) > 0) {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, gb + 64016 | 0, 0, gb + 392365 | 0, 236) | 0;
      i2 = HEAP32[i20 >> 2] | 0;
     } else i1 = 0;
     if (i2) i4 = 11;
    } else {
     i1 = 0;
     i4 = 11;
    }
    if ((i4 | 0) == 11) {
     i17 = i21 + (i24 * 11284 | 0) + 11264 | 0;
     i18 = i21 + (i24 * 11284 | 0) + 11272 | 0;
     i19 = i21 + (i24 * 11284 | 0) + 11280 | 0;
     i15 = 0;
     i16 = HEAP32[i21 + (i24 * 11284 | 0) + 11268 >> 2] | 0;
     i14 = HEAP32[i5 >> 2] | 0;
     i13 = HEAP32[i6 >> 2] | 0;
     while (1) {
      i12 = i21 + (i24 * 11284 | 0) + 4352 + (i15 * 92 | 0) | 0;
      i11 = HEAP32[i21 + (i24 * 11284 | 0) + 10240 + (i15 << 2) >> 2] | 0;
      i2 = HEAP32[i17 >> 2] | 0;
      if ((i2 | 0) == 2) {
       i2 = HEAP32[i21 + (i24 * 11284 | 0) + 10496 + (i15 << 2) >> 2] | 0;
       if (i2 >>> 0 > 3) {
        i4 = i2 >>> 2;
        i2 = i11;
        i3 = 0;
        while (1) {
         i11 = i3 * 6 | 0;
         HEAP16[i1 + (i11 << 1) >> 1] = HEAP16[i2 >> 1] | 0;
         HEAP16[i1 + ((i11 | 1) << 1) >> 1] = HEAP16[i2 + 2 >> 1] | 0;
         i10 = i2 + 4 | 0;
         HEAP16[i1 + (i11 + 2 << 1) >> 1] = HEAP16[i10 >> 1] | 0;
         HEAP16[i1 + (i11 + 3 << 1) >> 1] = HEAP16[i2 >> 1] | 0;
         HEAP16[i1 + (i11 + 4 << 1) >> 1] = HEAP16[i10 >> 1] | 0;
         HEAP16[i1 + (i11 + 5 << 1) >> 1] = HEAP16[i2 + 6 >> 1] | 0;
         i3 = i3 + 1 | 0;
         if (i3 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
        }
       }
       i8 = HEAP32[i22 + (i15 << 2) >> 2] | 0;
       i4 = i21 + (i24 * 11284 | 0) + 10752 + (i15 << 2) | 0;
       i6 = i16 - (HEAP32[i4 >> 2] | 0) | 0;
       i2 = i8 >>> 1;
       i7 = i2 << 1;
       i2 = (i2 | 0) == 0;
       if ((i6 | 0) > -1) {
        if (!i2) {
         i2 = 0;
         i3 = i14;
         i5 = i1;
         while (1) {
          HEAP16[i3 >> 1] = (HEAPU16[i5 >> 1] | 0) + i6;
          i2 = i2 + 1 | 0;
          if ((i2 | 0) == (i7 | 0)) break; else {
           i3 = i3 + 2 | 0;
           i5 = i5 + 2 | 0;
          }
         }
        }
       } else if (!i2) {
        i2 = 0;
        i3 = i14;
        i5 = i1;
        while (1) {
         HEAP16[i3 >> 1] = (HEAPU16[i5 >> 1] | 0) + i6;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i7 | 0)) break; else {
          i3 = i3 + 2 | 0;
          i5 = i5 + 2 | 0;
         }
        }
       }
       if ((i7 | 0) != (i8 | 0)) {
        i11 = i8 + -1 | 0;
        HEAP16[i14 + (i11 << 1) >> 1] = (HEAPU16[i1 + (i11 << 1) >> 1] | 0) + i6;
       }
       i3 = i8 << 1;
      } else {
       i10 = HEAP32[i21 + (i24 * 11284 | 0) + 10496 + (i15 << 2) >> 2] | 0;
       i4 = i21 + (i24 * 11284 | 0) + 10752 + (i15 << 2) | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       i9 = (i2 | 0) == 1;
       if ((i16 | 0) != 0 & i9) {
        HEAP16[i14 >> 1] = HEAP16[i14 + -2 >> 1] | 0;
        i6 = i16 - i3 | 0;
        HEAP16[i14 + 2 >> 1] = (HEAPU16[i11 >> 1] | 0) + i6;
        i8 = i14 + 4 | 0;
       } else {
        i8 = i14;
        i6 = i16 - i3 | 0;
       }
       i2 = i10 >>> 1;
       i7 = i2 << 1;
       i2 = (i2 | 0) == 0;
       if ((i6 | 0) > -1) {
        if (!i2) {
         i2 = 0;
         i3 = i8;
         i5 = i11;
         while (1) {
          HEAP16[i3 >> 1] = (HEAPU16[i5 >> 1] | 0) + i6;
          i2 = i2 + 1 | 0;
          if ((i2 | 0) == (i7 | 0)) break; else {
           i3 = i3 + 2 | 0;
           i5 = i5 + 2 | 0;
          }
         }
        }
       } else if (!i2) {
        i2 = 0;
        i3 = i8;
        i5 = i11;
        while (1) {
         HEAP16[i3 >> 1] = (HEAPU16[i5 >> 1] | 0) + i6;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i7 | 0)) break; else {
          i3 = i3 + 2 | 0;
          i5 = i5 + 2 | 0;
         }
        }
       }
       if ((i7 | 0) != (i10 | 0)) {
        i7 = i10 + -1 | 0;
        HEAP16[i8 + (i7 << 1) >> 1] = (HEAPU16[i11 + (i7 << 1) >> 1] | 0) + i6;
       }
       i2 = i8 + (i10 << 1) | 0;
       if (!((i10 & 1 | 0) == 0 | i9 ^ 1)) {
        HEAP16[i2 >> 1] = HEAP16[i2 + -2 >> 1] | 0;
        i2 = i2 + 2 | 0;
       }
       i3 = i2 - i14 | 0;
      }
      i2 = __Z17TransformVerticesPhRK10Matrix4x4fRK16VertexBufferDatajjj25GfxTransformVerticesFlags(i13, i21 + (i24 * 11284 | 0) + 256 + (i15 << 6) | 0, i12, HEAP32[i4 >> 2] | 0, HEAP32[i21 + (i24 * 11284 | 0) + 11008 + (i15 << 2) >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i21 + (i24 * 11284 | 0) + (i15 << 2) >> 2] | 0) | 0;
      i13 = i13 + (Math_imul(HEAP32[i19 >> 2] | 0, i2) | 0) | 0;
      i15 = i15 + 1 | 0;
      if (i15 >>> 0 >= (HEAP32[i20 >> 2] | 0) >>> 0) break; else {
       i16 = i2 + i16 | 0;
       i14 = i14 + (i3 >> 1 << 1) | 0;
      }
     }
    }
    if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
   }
  }
 }
 if (!i23) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i23);
 STACKTOP = i25;
 return;
}

function _tre_copy_ast(i14, i15, i1, i2, i21, i17, i3, i18) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22 + 4 | 0;
 i19 = i22;
 i20 = i15 + 12 | 0;
 i16 = HEAP32[i20 >> 2] | 0;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 _tre_stack_push(i15, i13) | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 i1 = _tre_stack_push(i15, i13) | 0;
 L1 : do if (!i1) {
  i11 = i15 + 16 | 0;
  i12 = (i2 & 1 | 0) == 0;
  i10 = (i2 & 2 | 0) != 0;
  i2 = 0;
  i9 = 1;
  i1 = i3;
  while (1) {
   i3 = HEAP32[i20 >> 2] | 0;
   if ((i3 | 0) > (i16 | 0)) i8 = i1; else {
    i1 = 0;
    break L1;
   }
   L5 : while (1) {
    i4 = HEAP32[i11 >> 2] | 0;
    L7 : while (1) {
     i7 = i3 + -1 | 0;
     HEAP32[i20 >> 2] = i7;
     switch (HEAP32[i4 + (i7 << 2) >> 2] | 0) {
     case 1:
      {
       i6 = 7;
       break L7;
      }
     case 0:
      {
       i1 = i3 + -2 | 0;
       HEAP32[i20 >> 2] = i1;
       i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
       switch (HEAP32[i1 >> 2] | 0) {
       case 0:
        {
         i6 = 9;
         break L5;
        }
       case 3:
        {
         i6 = 20;
         break L5;
        }
       case 1:
        {
         i6 = 27;
         break L5;
        }
       case 2:
        {
         i6 = 34;
         break L7;
        }
       default:
        {}
       }
       break;
      }
     default:
      {}
     }
     i3 = HEAP32[i20 >> 2] | 0;
     if ((i3 | 0) <= (i16 | 0)) {
      i1 = 0;
      break L1;
     }
    }
    if ((i6 | 0) == 7) {
     i1 = i3 + -2 | 0;
     HEAP32[i20 >> 2] = i1;
     i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    } else if ((i6 | 0) == 34) {
     i3 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
     i1 = _tre_stack_push(i15, i13) | 0;
     if (i1 | 0) break L1;
     HEAP32[i19 >> 2] = 0;
     HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
     i1 = _tre_stack_push(i15, i13) | 0;
     if (i1 | 0) break L1;
     i1 = _tre_ast_new_iter(i14, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP8[i3 + 12 >> 0] & 1) | 0;
     HEAP32[i8 >> 2] = i1;
     if (!i1) {
      i1 = 12;
      break L1;
     }
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    i3 = HEAP32[i20 >> 2] | 0;
    if ((i3 | 0) <= (i16 | 0)) {
     i1 = 0;
     break L1;
    } else i8 = i1;
   }
   if ((i6 | 0) == 9) {
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = HEAP32[i7 + 8 >> 2] | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    i1 = HEAP32[i7 + 4 >> 2] | 0;
    if ((i3 | 0) > -1 | (i3 | 0) == -4) {
     i6 = (HEAP32[i21 >> 2] | 0) + i4 | 0;
     i2 = i2 + 1 | 0;
     i5 = i9;
    } else if (i12 | (i3 | 0) != -3) if ((i3 | 0) == -3) if (i10 & (i9 | 0) != 0) {
     HEAP32[i17 + (i1 << 2) >> 2] = 1;
     i3 = -3;
     i6 = i4;
     i5 = 0;
    } else {
     i3 = -3;
     i6 = i4;
     i5 = i9;
    } else {
     i6 = i4;
     i5 = i9;
    } else {
     i1 = -1;
     i3 = -1;
     i6 = -1;
     i5 = i9;
    }
    i4 = _tre_ast_new_node(i14, 0, 20) | 0;
    if (!i4) {
     HEAP32[i8 >> 2] = 0;
     i1 = 12;
    } else {
     i9 = i4 + 4 | 0;
     i23 = HEAP32[i9 >> 2] | 0;
     HEAP32[i23 >> 2] = i3;
     HEAP32[i23 + 4 >> 2] = i1;
     HEAP32[i23 + 8 >> 2] = i6;
     HEAP32[i8 >> 2] = i4;
     i1 = HEAP32[i9 >> 2] | 0;
     HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     i1 = 0;
    }
    if ((i6 | 0) > (HEAP32[i18 >> 2] | 0)) {
     HEAP32[i18 >> 2] = i6;
     i3 = i8;
    } else i3 = i8;
   } else if ((i6 | 0) == 20) {
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = i4 + 4 | 0;
    i1 = _tre_ast_new_union(i14, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    if (!i1) {
     i1 = 12;
     break L1;
    }
    i6 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = i6 + 4;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i5 = i9;
    i3 = i6;
    i1 = _tre_stack_push(i15, i13) | 0;
   } else if ((i6 | 0) == 27) {
    i6 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = i6 + 4 | 0;
    i1 = _tre_ast_new_catenation(i14, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    if (!i1) {
     i1 = 12;
     break L1;
    }
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i3 >> 2] = 0;
    i5 = i3 + 4 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = i5;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 1;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i1 = _tre_stack_push(i15, i13) | 0;
    if (i1 | 0) break L1;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
    i5 = i9;
    i1 = _tre_stack_push(i15, i13) | 0;
   }
   if (!i1) {
    i9 = i5;
    i1 = i3;
   } else break;
  }
 } else i2 = 0; while (0);
 HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i2;
 STACKTOP = i22;
 return i1 | 0;
}

function __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags(i6, i5 + 860 | 0, 0);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 4 | 0, i6);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 724 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 740 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 744 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 752 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 756 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 764 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 768 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 776 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 780 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 788 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 792 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 800 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 816 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 832 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 848 | 0;
  __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i5);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = i2;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 800 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 816 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 832 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  i9 = i5 + 848 | 0;
  __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i6);
  __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i5);
  STACKTOP = i10;
  return;
 }
}

function __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i6 = i12;
 i3 = i12 + 8 | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10);
 i1 = i9 + 328 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = i10 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 }
 i4 = i9 + 268 | 0;
 HEAP8[i7 >> 0] = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i5;
  HEAP32[i11 >> 2] = i1;
  i1 = i5;
 }
 i2 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
 i1 = (i1 & 255) << 6 & 192 | i2 & 16777023;
 HEAP16[i4 >> 1] = i1;
 HEAP8[i4 + 2 >> 0] = i1 >>> 16;
 HEAP8[i7 >> 0] = (i2 & 16777215) >>> 8 & 1;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 i2 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
 i1 = (i1 & 255) << 8 & 256 | i2 & 16776959;
 HEAP16[i4 >> 1] = i1;
 HEAP8[i4 + 2 >> 0] = i1 >>> 16;
 HEAP8[i3 >> 0] = (i2 & 16777215) >>> 10 & 3;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 i2 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
 i1 = (i1 & 255) << 10 & 3072 | i2 & 16774143;
 HEAP16[i4 >> 1] = i1;
 HEAP8[i4 + 2 >> 0] = i1 >>> 16;
 HEAP8[i7 >> 0] = (i2 & 16777215) >>> 16 & 3;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 i2 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
 i1 = (i1 & 255) << 16 & 196608 | i2 & 16580607;
 HEAP16[i4 >> 1] = i1;
 HEAP8[i4 + 2 >> 0] = i1 >>> 16;
 HEAP8[i7 >> 0] = (i2 & 16777215) >>> 14 & 3;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 i5 = (i1 & 255) << 14 & 49152 | (HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16728063;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i5 = i9 + 260 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i5, 2);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i5 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i11 >> 2] = i2;
  i4 = i3;
 }
 i1 = i5 + 2 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 2); else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i11 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i10, i9 + 228 | 0, gb + 931957 | 0, 8388609);
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i10, i9 + 244 | 0, gb + 931980 | 0, 8388609);
 i3 = i9 + 288 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = i10 + 8 | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i9 + 292 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 HEAP32[i7 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i3, i1, i7, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i9 + 300 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 216 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 2 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 2);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i11 >> 2] = i3;
 }
 i1 = i9 + 218 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 2); else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i11 >> 2] = i2;
 }
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 308 | 0, i10);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 280 | 0, i10);
 __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 276 | 0, i10);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i1 = i9 + 332 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 >> 2] = i4;
 }
 i1 = i9 + 336 | 0;
 i2 = i4 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 2);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i11 >> 2] = i2;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 }
}

function __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = HEAP32[gb + 36980 >> 2] | 0;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 i7 = i3 + 16 | 0;
 i8 = i3 + 24 | 0;
 i1 = 0;
 do {
  i10 = i2 + (i1 << 2) | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[gb + 43960 + (i1 << 2) >> 2] | 0, i5, i10, 1);
  __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 2);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048334 | 0, i6, i10, 1);
  HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i10 = HEAP32[gb + 37288 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034039 | 0, i10, i2 + 32 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034046 | 0, i10, i2 + 34 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034053 | 0, i10, i2 + 36 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034060 | 0, i10, i2 + 38 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034067 | 0, i10, i2 + 40 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034074 | 0, i10, i2 + 42 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034081 | 0, i10, i2 + 44 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034088 | 0, i10, i2 + 46 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034095 | 0, i10, i2 + 48 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034102 | 0, i10, i2 + 50 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034109 | 0, i10, i2 + 52 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034116 | 0, i10, i2 + 54 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034123 | 0, i10, i2 + 56 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034130 | 0, i10, i2 + 58 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034137 | 0, i10, i2 + 60 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034144 | 0, i10, i2 + 62 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i10 = i2 + 68 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034151 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 i10 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034158 | 0, i10, i2 + 64 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1034173 | 0, i10, i2 + 65 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 STACKTOP = i9;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesERKNS0_14IterationStateIS2_EE(i56, i4) {
 i56 = i56 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i57 = 0;
 i57 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i57 + 656 | 0;
 i3 = i57 + 632 | 0;
 i50 = i57 + 664 | 0;
 i55 = i57 + 568 | 0;
 i52 = i57 + 392 | 0;
 i6 = i57 + 384 | 0;
 i22 = i57 + 368 | 0;
 i33 = i57 + 360 | 0;
 i41 = i57 + 344 | 0;
 i43 = i57 + 336 | 0;
 i44 = i57 + 320 | 0;
 i45 = i57 + 312 | 0;
 i46 = i57 + 296 | 0;
 i47 = i57 + 288 | 0;
 i49 = i57 + 456 | 0;
 i54 = i57 + 272 | 0;
 i48 = i57 + 256 | 0;
 i53 = i57 + 240 | 0;
 i23 = i57 + 224 | 0;
 i24 = i57 + 216 | 0;
 i25 = i57 + 200 | 0;
 i26 = i57 + 192 | 0;
 i27 = i57 + 176 | 0;
 i28 = i57 + 168 | 0;
 i29 = i57 + 152 | 0;
 i30 = i57 + 144 | 0;
 i51 = i57 + 408 | 0;
 i31 = i57 + 128 | 0;
 i32 = i57 + 112 | 0;
 i34 = i57 + 96 | 0;
 i35 = i57 + 80 | 0;
 i36 = i57 + 64 | 0;
 i37 = i57 + 48 | 0;
 i38 = i57 + 32 | 0;
 i39 = i57 + 16 | 0;
 i40 = i57;
 i7 = i56 + 432 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  STACKTOP = i57;
  return;
 }
 i42 = i56 + 436 | 0;
 i21 = __ZN14StackAllocatorILj16EE8allocateEj(HEAP32[i42 >> 2] | 0, HEAP32[i1 + 172 >> 2] << 5) | 0;
 i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + 168 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i4 + 192 >> 2] | 0) == 1) __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fPKS1_EEvPT_RKT0_j(i21, i5, HEAP32[i2 + 172 >> 2] | 0); else {
  i20 = HEAP32[i2 + 164 >> 2] | 0;
  __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ES4_S4_f(i3, i20, i1, Math_fround(__ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv(i4)));
  __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j(i21, i3, HEAP32[(HEAP32[i7 >> 2] | 0) + 172 >> 2] | 0);
 }
 i2 = (HEAP32[i7 >> 2] | 0) + 216 | 0;
 i20 = Math_fround(HEAPF32[i2 >> 2]) > Math_fround(0.0);
 HEAP32[i6 >> 2] = __Z6simd4fRKf(i2) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i52, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i19 = HEAP32[i2 >> 2] << 2;
 i3 = i1 + (i19 << 2) | 0;
 if ((i19 | 0) > 0) {
  i4 = i50 + 16 | 0;
  i5 = i50 + 32 | 0;
  i6 = i50 + 48 | 0;
  i7 = i49 + 96 | 0;
  i8 = i55 + 16 | 0;
  i9 = i55 + 32 | 0;
  i10 = i55 + 48 | 0;
  i11 = i49 + 16 | 0;
  i12 = i49 + 32 | 0;
  i13 = i49 + 48 | 0;
  i14 = i49 + 64 | 0;
  i15 = i49 + 80 | 0;
  i16 = i51 + 16 | 0;
  i17 = i51 + 32 | 0;
  i18 = i49 + 16 | 0;
  i19 = i49 + 32 | 0;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  while (1) {
   __Z11loadAlignedPKfj(i33, i1, 0);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i22, i33);
   __ZN8Scalar4faSERKS_(i50, i22) | 0;
   __Z11loadAlignedPKfj(i43, i1, 16);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i41, i43);
   __ZN8Scalar4faSERKS_(i4, i41) | 0;
   __Z11loadAlignedPKfj(i45, i1, 32);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i44, i45);
   __ZN8Scalar4faSERKS_(i5, i44) | 0;
   __Z11loadAlignedPKfj(i47, i1, 48);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i46, i47);
   __ZN8Scalar4faSERKS_(i6, i46) | 0;
   __Z9transposeR8Scalar4fS0_S0_S0_(i50, i4, i5, i6);
   __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i49);
   __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesEPKS2_PS2_RNS3_18ImpulseAccumulatorE(i56, i21, i50, i49);
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i48, gb + 1097856 | 0);
   if (__Z10anyGreaterRK8Scalar4fS1_RS_(i7, i48, i54) | 0) {
    __Z5recipRK8Scalar4f(i53, i7);
    if (i20) {
     __Z11loadAlignedPKfj(i24, i2, 0);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i23, i24);
     __ZN8Scalar4faSERKS_(i55, i23) | 0;
     __Z11loadAlignedPKfj(i26, i2, 16);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i25, i26);
     __ZN8Scalar4faSERKS_(i8, i25) | 0;
     __Z11loadAlignedPKfj(i28, i2, 32);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i27, i28);
     __ZN8Scalar4faSERKS_(i9, i27) | 0;
     __Z11loadAlignedPKfj(i30, i2, 48);
     __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i29, i30);
     __ZN8Scalar4faSERKS_(i10, i29) | 0;
     __Z9transposeR8Scalar4fS0_S0_S0_(i55, i8, i9, i10);
     __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_(i49, i11, i12, i13, i14, i15, i50, i55, i53, i52, i54, i51);
     __ZmiRK8Scalar4fS1_(i31, i55, i51);
     __ZN8Scalar4faSERKS_(i55, i31) | 0;
     __ZmiRK8Scalar4fS1_(i32, i8, i16);
     __ZN8Scalar4faSERKS_(i8, i32) | 0;
     __ZmiRK8Scalar4fS1_(i34, i9, i17);
     __ZN8Scalar4faSERKS_(i9, i34) | 0;
     __Z9transposeR8Scalar4fS0_S0_S0_(i55, i8, i9, i10);
     __Z12storeAlignedPfjRK8Scalar4f(i2, 0, i55);
     __Z12storeAlignedPfjRK8Scalar4f(i2, 16, i8);
     __Z12storeAlignedPfjRK8Scalar4f(i2, 32, i9);
     __Z12storeAlignedPfjRK8Scalar4f(i2, 48, i10);
    }
    __ZmlRK8Scalar4fS1_(i36, i49, i53);
    __ZplRK8Scalar4fS1_(i35, i50, i36);
    __ZN8Scalar4faSERKS_(i50, i35) | 0;
    __ZmlRK8Scalar4fS1_(i38, i18, i53);
    __ZplRK8Scalar4fS1_(i37, i4, i38);
    __ZN8Scalar4faSERKS_(i4, i37) | 0;
    __ZmlRK8Scalar4fS1_(i40, i19, i53);
    __ZplRK8Scalar4fS1_(i39, i5, i40);
    __ZN8Scalar4faSERKS_(i5, i39) | 0;
    __Z9transposeR8Scalar4fS0_S0_S0_(i50, i4, i5, i6);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 0, i50);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 16, i4);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 32, i5);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 48, i6);
   }
   i1 = i1 + 64 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 64 | 0;
  }
 }
 __ZN14StackAllocatorILj16EE10deallocateEPv(HEAP32[i42 >> 2] | 0, i21);
 STACKTOP = i57;
 return;
}

function __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i11, i14, i12, i1) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i9 = i14 + 16 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = i7 & 255;
 i10 = i11 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 & 255;
 i6 = (i7 & 65535) >>> 8 & 255;
 i3 = (i1 & 65535) >>> 8 & 255;
 do if (i8 << 24 >> 24 == i2 << 24 >> 24) if (i6 << 24 >> 24 == i3 << 24 >> 24) {
  i4 = (i7 & 65536 | 0) == 0 & (i1 & 65536 | 0) != 0;
  break;
 } else {
  i4 = (i6 & 255) < (i3 & 255);
  break;
 } else i4 = (i8 & 255) < (i2 & 255); while (0);
 i5 = i12 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 & 255;
 i3 = (i1 & 65535) >>> 8 & 255;
 do if (i2 << 24 >> 24 == i8 << 24 >> 24) if (i3 << 24 >> 24 == i6 << 24 >> 24) {
  i1 = (i1 & 65536 | 0) == 0 & (i7 & 65536 | 0) != 0;
  break;
 } else {
  i1 = (i3 & 255) < (i6 & 255);
  break;
 } else i1 = (i2 & 255) < (i8 & 255); while (0);
 if (!i4) {
  if (!i1) {
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  };
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP16[i14 + 16 >> 1] = HEAP16[i12 + 16 >> 1] | 0;
  HEAP8[i14 + 18 >> 0] = HEAP8[i12 + 18 >> 0] | 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP16[i12 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
  HEAP8[i12 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 & 255;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1 & 255;
  i3 = (i5 & 65535) >>> 8 & 255;
  i4 = (i1 & 65535) >>> 8 & 255;
  do if (i6 << 24 >> 24 == i2 << 24 >> 24) if (i3 << 24 >> 24 == i4 << 24 >> 24) {
   if ((i5 & 65536 | 0) == 0 & (i1 & 65536 | 0) != 0) break; else i1 = 1;
   STACKTOP = i15;
   return i1 | 0;
  } else {
   if ((i3 & 255) < (i4 & 255)) break; else i1 = 1;
   STACKTOP = i15;
   return i1 | 0;
  } else if ((i6 & 255) >= (i2 & 255)) {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  } while (0);
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP16[i11 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
  HEAP8[i11 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP16[i14 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
  HEAP8[i14 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
  i14 = 2;
  STACKTOP = i15;
  return i14 | 0;
 };
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 if (i1) {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP16[i11 + 16 >> 1] = HEAP16[i12 + 16 >> 1] | 0;
  HEAP8[i11 + 18 >> 0] = HEAP8[i12 + 18 >> 0] | 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP16[i12 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
  HEAP8[i12 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 };
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP16[i11 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
 HEAP8[i11 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i14 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i14 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i5 & 255;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 & 255;
 i3 = (i5 & 65535) >>> 8 & 255;
 i4 = (i1 & 65535) >>> 8 & 255;
 do if (i6 << 24 >> 24 == i2 << 24 >> 24) if (i3 << 24 >> 24 == i4 << 24 >> 24) {
  if ((i5 & 65536 | 0) == 0 & (i1 & 65536 | 0) != 0) break; else i1 = 1;
  STACKTOP = i15;
  return i1 | 0;
 } else {
  if ((i3 & 255) < (i4 & 255)) break; else i1 = 1;
  STACKTOP = i15;
  return i1 | 0;
 } else if ((i6 & 255) >= (i2 & 255)) {
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP16[i14 + 16 >> 1] = HEAP16[i12 + 16 >> 1] | 0;
 HEAP8[i14 + 18 >> 0] = HEAP8[i12 + 18 >> 0] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i12 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i12 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 i14 = 2;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx14NpRigidDynamic17setCMassLocalPoseERKNS_11PxTransformE(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i21 + 56 | 0;
 i18 = i21 + 28 | 0;
 i19 = i21;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f13 * f13));
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f12 * f12));
 f11 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14 + Math_fround(f11 * f11)))));
 f13 = Math_fround(f13 * f14);
 f12 = Math_fround(f12 * f14);
 f11 = Math_fround(f11 * f14);
 HEAPF32[i22 >> 2] = Math_fround(f15 * f14);
 HEAPF32[i22 + 4 >> 2] = f13;
 HEAPF32[i22 + 8 >> 2] = f12;
 HEAPF32[i22 + 12 >> 2] = f11;
 HEAP32[i22 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i3 = i20 + 284 | 0;
 i2 = i20 + 56 | 0;
 i1 = (HEAP32[i3 >> 2] & 512 | 0) == 0 ? i20 + 112 | 0 : (HEAP32[i2 >> 2] | 0) + 144 | 0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setCMassLocalPoseInternalERKNS_11PxTransformE(i20, i22);
 i3 = HEAP32[i3 >> 2] | 0;
 if (!(i3 & 4096)) i1 = i20 + 108 | 0; else i1 = (HEAP32[i2 >> 2] | 0) + 268 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) {
  STACKTOP = i21;
  return;
 }
 do if (!(i3 & 8192)) {
  if ((HEAP32[i20 + 52 >> 2] | 0) >>> 0 > 3221225471) {
   STACKTOP = i21;
   return;
  }
  if (__ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i20 + 64 | 0, i18) | 0) {
   f5 = Math_fround(HEAPF32[i18 + 12 >> 2]);
   f6 = Math_fround(HEAPF32[i18 >> 2]);
   f7 = Math_fround(HEAPF32[i18 + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i18 + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i18 + 16 >> 2]);
   f10 = Math_fround(HEAPF32[i18 + 20 >> 2]);
   f4 = Math_fround(HEAPF32[i18 + 24 >> 2]);
   break;
  } else {
   STACKTOP = i21;
   return;
  }
 } else {
  i22 = HEAP32[i2 >> 2] | 0;
  i24 = HEAP32[i22 + 192 >> 2] | 0;
  HEAP32[i18 >> 2] = i24;
  i23 = HEAP32[i22 + 196 >> 2] | 0;
  HEAP32[i18 + 4 >> 2] = i23;
  i1 = HEAP32[i22 + 200 >> 2] | 0;
  HEAP32[i18 + 8 >> 2] = i1;
  i25 = HEAP32[i22 + 204 >> 2] | 0;
  HEAP32[i18 + 12 >> 2] = i25;
  i2 = HEAP32[i22 + 208 >> 2] | 0;
  HEAP32[i18 + 16 >> 2] = i2;
  i3 = HEAP32[i22 + 212 >> 2] | 0;
  HEAP32[i18 + 20 >> 2] = i3;
  i22 = HEAP32[i22 + 216 >> 2] | 0;
  HEAP32[i18 + 24 >> 2] = i22;
  f5 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while (0);
 f15 = Math_fround(f15 * Math_fround(-2.0));
 f16 = Math_fround(f16 * Math_fround(-2.0));
 f31 = Math_fround(f17 * Math_fround(-2.0));
 f32 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f11 * f15) + Math_fround(f12 * f16)) + Math_fround(f13 * f31));
 f28 = Math_fround(-f11);
 f26 = Math_fround(-f12);
 f27 = Math_fround(-f13);
 f29 = Math_fround(Math_fround(Math_fround(f11 * f17) + Math_fround(Math_fround(f15 * f32) - Math_fround(f14 * Math_fround(Math_fround(f12 * f31) - Math_fround(f13 * f16))))) * Math_fround(2.0));
 f30 = Math_fround(Math_fround(Math_fround(f12 * f17) + Math_fround(Math_fround(f32 * f16) - Math_fround(f14 * Math_fround(Math_fround(f13 * f15) - Math_fround(f11 * f31))))) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f31) - Math_fround(f14 * Math_fround(Math_fround(f11 * f16) - Math_fround(f12 * f15)))) + Math_fround(f13 * f17)) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f29 * f6) + Math_fround(f30 * f7)) + Math_fround(f12 * f8));
 f15 = Math_fround(f9 + Math_fround(Math_fround(f6 * f17) + Math_fround(Math_fround(f29 * f11) + Math_fround(f5 * Math_fround(Math_fround(f12 * f7) - Math_fround(f30 * f8))))));
 f16 = Math_fround(f10 + Math_fround(Math_fround(f7 * f17) + Math_fround(Math_fround(f30 * f11) + Math_fround(f5 * Math_fround(Math_fround(f29 * f8) - Math_fround(f12 * f6))))));
 f17 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f5 * Math_fround(Math_fround(f30 * f6) - Math_fround(f29 * f7)))) + Math_fround(f8 * f17)));
 f11 = Math_fround(Math_fround(Math_fround(f8 * f28) + Math_fround(Math_fround(f5 * f26) + Math_fround(f14 * f7))) - Math_fround(f6 * f27));
 f12 = Math_fround(Math_fround(Math_fround(f6 * f26) + Math_fround(Math_fround(f5 * f27) + Math_fround(f14 * f8))) - Math_fround(f7 * f28));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f5) - Math_fround(f6 * f28)) - Math_fround(f7 * f26)) - Math_fround(f8 * f27));
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f28) + Math_fround(f14 * f6)) + Math_fround(f7 * f27)) - Math_fround(f8 * f26));
 HEAPF32[i19 + 4 >> 2] = f11;
 HEAPF32[i19 + 8 >> 2] = f12;
 HEAPF32[i19 + 12 >> 2] = f13;
 HEAPF32[i19 + 16 >> 2] = f15;
 HEAPF32[i19 + 20 >> 2] = f16;
 HEAPF32[i19 + 24 >> 2] = f17;
 __ZN5physx14NpRigidDynamic26setKinematicTargetInternalERKNS_11PxTransformE(i20, i19);
 STACKTOP = i21;
 return;
}

function __Z16tessMeshMakeEdgeP8TESSmesh(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 136 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i8 = 3; else if (!(HEAP32[i1 >> 2] | 0)) i8 = 3; else i8 = 7;
 if ((i8 | 0) == 3) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i10 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) i10 = 0; else {
   i3 = i5 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do {
    i2 = i2 - i3 | 0;
    i10 = i1;
    i1 = i4 + i2 | 0;
    HEAP32[i1 >> 2] = i10;
   } while ((i2 | 0) != 4);
   HEAP32[i5 >> 2] = i1;
   i8 = 7;
  }
 }
 if ((i8 | 0) == 7) {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i10 = i1;
 }
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i8 = 10; else if (!(HEAP32[i1 >> 2] | 0)) i8 = 10; else i8 = 14;
 if ((i8 | 0) == 10) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i9 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) i9 = 0; else {
   i3 = i5 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do {
    i2 = i2 - i3 | 0;
    i9 = i1;
    i1 = i4 + i2 | 0;
    HEAP32[i1 >> 2] = i9;
   } while ((i2 | 0) != 4);
   HEAP32[i5 >> 2] = i1;
   i8 = 14;
  }
 }
 if ((i8 | 0) == 14) {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i9 = i1;
 }
 i6 = i12 + 140 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i8 = 17; else if (!(HEAP32[i1 >> 2] | 0)) i8 = 17; else {
  i7 = i1;
  i8 = 22;
 }
 do if ((i8 | 0) == 17) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i8 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i2 = (i9 | 0) == 0;
   if (!i10) {
    i1 = 0;
    i3 = i2;
    i2 = 1;
    i8 = 25;
    break;
   } else {
    i1 = 0;
    i3 = i2;
    i2 = 1;
    i8 = 24;
    break;
   }
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i1 = i1 - i3 | 0;
   i8 = i2;
   i2 = i4 + i1 | 0;
   HEAP32[i2 >> 2] = i8;
  } while ((i1 | 0) != 4);
  HEAP32[i5 >> 2] = i2;
  i7 = i2;
  i8 = 22;
 } while (0);
 do if ((i8 | 0) == 22) {
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  i1 = (i10 | 0) == 0;
  i3 = (i9 | 0) == 0;
  i2 = (i7 | 0) == 0;
  if (i1 | i3 | i2) if (i1) {
   i1 = i7;
   i8 = 25;
   break;
  } else {
   i1 = i7;
   i8 = 24;
   break;
  }
  i6 = i12 + 68 | 0;
  i5 = HEAP32[i12 + 132 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i8 = 32; else {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i8 = 32; else HEAP32[i5 >> 2] = i2;
  }
  if ((i8 | 0) == 32) {
   i1 = i5 + 8 | 0;
   i2 = i5 + 12 | 0;
   i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
   i11 = HEAP32[i5 + 20 >> 2] | 0;
   i4 = mftCall_iii(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 12 >> 2] | 0, i4 | 0) | 0;
   if (!i4) {
    i12 = 0;
    return i12 | 0;
   }
   i3 = i5 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do {
    i2 = i2 - i3 | 0;
    i11 = i1;
    i1 = i4 + i2 | 0;
    HEAP32[i1 >> 2] = i11;
   } while ((i2 | 0) != 4);
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   if (!i1) {
    i12 = 0;
    return i12 | 0;
   }
  }
  i4 = i1 + 32 | 0;
  i2 = HEAP32[i12 + 72 >> 2] | 0;
  i2 = i2 >>> 0 < i6 >>> 0 ? i2 : i6;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 >> 2] = i11;
  HEAP32[HEAP32[i11 + 4 >> 2] >> 2] = i1;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i4;
  HEAP32[i1 + 8 >> 2] = i1;
  HEAP32[i1 + 12 >> 2] = i4;
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = i1;
  HEAP32[i1 + 40 >> 2] = i4;
  HEAP32[i1 + 44 >> 2] = i1;
  i3 = i1 + 48 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  i3 = i12 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i2;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i10 >> 2] = i12;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i10 + 8 >> 2] = i1;
  i2 = i1;
  do {
   HEAP32[i2 + 16 >> 2] = i10;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i9 >> 2] = i12;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i9 + 8 >> 2] = i4;
  i2 = i4;
  do {
   HEAP32[i2 + 16 >> 2] = i9;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } while ((i2 | 0) != (i4 | 0));
  i2 = i12 + 48 | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 + 4 >> 2] = i11;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i7 >> 2] = i12 + 44;
  HEAP32[i2 >> 2] = i7;
  HEAP32[i7 + 8 >> 2] = i1;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP8[i7 + 20 >> 0] = 0;
  HEAP8[i7 + 21 >> 0] = HEAP8[i12 + 65 >> 0] | 0;
  i2 = i1;
  do {
   HEAP32[i2 + 20 >> 2] = i7;
   i2 = HEAP32[i2 + 12 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  return i1 | 0;
 } while (0);
 if ((i8 | 0) == 24) {
  i12 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i10;
  if (i3) i8 = 27; else i8 = 26;
 } else if ((i8 | 0) == 25) if (i3) i8 = 27; else i8 = 26;
 if ((i8 | 0) == 26) {
  i12 = HEAP32[i11 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i9;
  if (i2) {
   i12 = 0;
   return i12 | 0;
  }
 } else if ((i8 | 0) == 27) if (i2) {
  i12 = 0;
  return i12 | 0;
 }
 i12 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i1;
 i12 = 0;
 return i12 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i14, i21, i6) {
 i14 = i14 | 0;
 i21 = i21 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i27;
 i24 = i14 + 36 | 0;
 i25 = i14 + 40 | 0;
 HEAP32[i25 >> 2] = 32;
 i11 = i14 + 52 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i14 + 48 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i14 + 56 | 0;
 HEAP8[i13 >> 0] = 0;
 i8 = i14 + 60 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = 65;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(384, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) {
  i23 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i23;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i24 >> 2] = i2;
 i3 = i2 + ((HEAP32[i25 >> 2] | 0) * 12 | 0) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i14 + 24 | 0;
  i1 = i2;
  do {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i22 = i14 + 44 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i23 = i21 + 4 | 0;
 f5 = Math_fround(((HEAP32[i21 + 44 >> 2] | 0) - (HEAP32[i23 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f9 = Math_fround(i2 >>> 0);
   f10 = Math_fround(f9 * Math_fround(.5));
   if (!(f5 >= f10)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i25 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i24 >> 2] | 0;
  if (i1 | 0) {
   i20 = HEAP32[i25 >> 2] | 0;
   i4 = i1 + (i20 * 12 | 0) | 0;
   if (i20) {
    i3 = i6;
    while (1) {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 12 | 0;
    }
    i1 = HEAP32[i24 >> 2] | 0;
   }
   i20 = HEAP32[i8 >> 2] | 0;
   HEAP32[i7 >> 2] = 65;
   HEAP32[i7 + 4 >> 2] = i20;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i25 >> 2] | 0;
  i3 = i6 + (i2 * 12 | 0) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i14 + 24 | 0;
   i1 = i6 + (i1 * 12 | 0) | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i24 >> 2] = i6;
  HEAP32[i25 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f10 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i18 = i21 + 36 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i19 = i21 + 40 | 0;
 i17 = HEAP32[i19 >> 2] | 0;
 i20 = i1 + (i17 * 12 | 0) | 0;
 L31 : do if (i17) {
  i7 = HEAP32[i21 + 24 >> 2] | 0;
  i8 = HEAP32[i21 + 28 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i6 = HEAP32[i21 + 16 >> 2] | 0;
  if (!((HEAP8[i21 + 8 >> 0] | 0) != 0 & (HEAP32[i23 >> 2] | 0) != 0)) {
   do {
    if ((i7 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    if ((i8 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L31;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i20 | 0));
   STACKTOP = i27;
   return;
  }
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i7 | 0) == (i3 | 0)) {
    if ((i8 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i26 = 24;
   } else i26 = 24;
   if ((i26 | 0) == 24) {
    i26 = 0;
    if ((i4 | 0) != (i3 | 0)) break L31;
    if ((i6 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L31;
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i20 | 0));
  STACKTOP = i27;
  return;
 } while (0);
 if ((i1 | 0) == (i20 | 0)) {
  STACKTOP = i27;
  return;
 }
 i17 = i14 + 24 | 0;
 i12 = i14 + 28 | 0;
 i13 = i21 + 24 | 0;
 i14 = i21 + 28 | 0;
 i15 = i21 + 12 | 0;
 i16 = i21 + 16 | 0;
 i11 = i21 + 8 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i6 = HEAP32[i24 >> 2] | 0;
  i7 = HEAP32[i17 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  while (1) {
   i2 = i2 & i4;
   if ((i7 | 0) == (HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0)) if ((i8 | 0) == (HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0)) break;
   i21 = i3 + 1 | 0;
   i3 = i21;
   i2 = i21 + i2 | 0;
  }
  i21 = i6 + (i2 * 12 | 0) | 0;
  HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
  i1 = i1 + 12 | 0;
  L60 : do if ((i1 | 0) == (i20 | 0)) i1 = i20; else {
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   if (!((HEAP8[i11 >> 0] | 0) != 0 & (HEAP32[i23 >> 2] | 0) != 0)) while (1) {
    if ((i6 | 0) != (HEAP32[i1 >> 2] | 0)) break L60;
    if ((i7 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L60;
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i20 | 0)) {
     i1 = i20;
     break L60;
    }
   }
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     if ((i7 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i26 = 43;
    } else i26 = 43;
    if ((i26 | 0) == 43) {
     i26 = 0;
     if ((i3 | 0) != (i2 | 0)) break L60;
     if ((i4 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L60;
    }
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i20 | 0)) {
     i1 = i20;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i18 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 12 | 0) | 0)) break;
  i2 = HEAP32[i25 >> 2] | 0;
 }
 STACKTOP = i27;
 return;
}

function __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 16 | 0;
 i11 = i16;
 __ZN8Material8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i13);
 i1 = i12 + 112 | 0;
 i14 = i13 + 16 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i15 = i13 + 24 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i1, 4);
  i4 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = i4;
 }
 i1 = i12 + 116 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i1, 4);
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 >> 2] = i3;
 }
 i1 = i12 + 120 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i14, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i13);
 i3 = i12 + 124 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i12 + 128 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i13);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i5 = i12 + 172 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 i9 = i1 & 1;
 i4 = i12 + 256 | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i5 >> 2] = i1 & -131074;
 HEAP32[i10 >> 2] = i9;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i14 >> 2] = i1;
  i1 = i9;
 }
 HEAP32[i4 >> 2] = i1;
 __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12 + 108 | 0, i13);
 i3 = i12 + 176 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i14 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i12 + 180 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i13);
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i12 + 156 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i13, i7, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i13);
 i8 = i7 + 11 | 0;
 i5 = HEAP8[i8 >> 0] | 0;
 i9 = i12 + 160 | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i5 & 255) | 0)) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 + 12 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i11 + 12 >> 2] | 0;
   i6 = 30;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i11 + 11 >> 0] = i3;
   if (!i3) i1 = i11; else {
    i1 = i11;
    i6 = 32;
   }
  } else i6 = 30;
  if ((i6 | 0) == 30) {
   i5 = i3 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i11 + 8 >> 2] = i5 | -2147483648;
   HEAP32[i11 + 4 >> 2] = i3;
   i6 = 32;
  }
  if ((i6 | 0) == 32) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  i4 = i11 + 11 | 0;
  do if ((i7 | 0) != (i11 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
   i6 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i8 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i12 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    HEAP32[i9 >> 2] = i6;
    break;
   } else {
    HEAP8[i8 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i9 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
 }
 i1 = i12 + 264 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i15 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i1, 4);
  i15 = i12 + 240 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i13);
  STACKTOP = i16;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 >> 2] = i3;
  i15 = i12 + 240 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i13);
  STACKTOP = i16;
  return;
 }
}

function __ZN7mecanim9animation16EvaluateAvatarIKEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb(i2, i1, i3, i12, i13, i14) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i2 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i8 = i9;
 i7 = i1 + i8 + 40 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = i6 + i7 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i3 + 24 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = Math_fround(HEAPF32[i4 + 52 >> 2]) > Math_fround(0.0);
 i2 = Math_fround(HEAPF32[i4 + 56 >> 2]) > Math_fround(0.0);
 i3 = Math_fround(HEAPF32[i4 + 60 >> 2]) > Math_fround(0.0);
 L7 : do if (i1 | i2 | i3 | Math_fround(HEAPF32[i4 + 64 >> 2]) > Math_fround(0.0)) i1 = 1; else {
  i2 = 0;
  i1 = 0;
  do {
   if (Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 40 >> 2]) > Math_fround(0.0)) {
    i1 = 1;
    break L7;
   }
   if (Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 44 >> 2]) > Math_fround(0.0)) {
    i1 = 1;
    break L7;
   }
   i1 = i1 | Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 60 >> 2]) > Math_fround(0.0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < 4 & (i1 ^ 1));
 } while (0);
 i3 = HEAP32[i13 >> 2] | 0;
 i16 = i3 + 4 | 0;
 i16 = i16 + (HEAP32[i16 >> 2] | 0) | 0;
 i2 = i16;
 i15 = HEAP32[i4 + 4 >> 2] | 0;
 i17 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i15;
 HEAP32[i2 + 8 >> 2] = i17;
 i17 = HEAP32[i4 + 16 >> 2] | 0;
 i15 = HEAP32[i4 + 20 >> 2] | 0;
 i16 = HEAP32[i4 + 24 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = i17;
 HEAP32[i2 + 20 >> 2] = i15;
 HEAP32[i2 + 24 >> 2] = i16;
 i16 = HEAP32[i4 + 32 >> 2] | 0;
 i15 = HEAP32[i4 + 36 >> 2] | 0;
 HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = i16;
 HEAP32[i2 + 36 >> 2] = i15;
 if (i1 | i14) {
  i2 = i13 + 4 | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i6 | 0) == 0 ? 0 : i7, i3, HEAP32[i2 >> 2] | 0);
  if (i14) {
   i15 = i10 + 4 | 0;
   i16 = i10 + 8 | 0;
   i17 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE(i10, (i7 | 0) == 0 ? 0 : i7 + i8 | 0, HEAP32[i2 >> 2] | 0, 0);
   i7 = HEAP32[i15 >> 2] | 0;
   i14 = HEAP32[i16 >> 2] | 0;
   HEAP32[i17 + 116 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i17 + 120 >> 2] = i7;
   HEAP32[i17 + 124 >> 2] = i14;
   i17 = HEAP32[i5 >> 2] | 0;
   i14 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE(i10, (i14 | 0) == 0 ? 0 : i14 + i8 | 0, HEAP32[i2 >> 2] | 0, 1);
   i14 = HEAP32[i15 >> 2] | 0;
   i7 = HEAP32[i16 >> 2] | 0;
   HEAP32[i17 + 180 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i17 + 184 >> 2] = i14;
   HEAP32[i17 + 188 >> 2] = i7;
   i17 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE(i10, (i7 | 0) == 0 ? 0 : i7 + i8 | 0, HEAP32[i2 >> 2] | 0, 2);
   i7 = HEAP32[i15 >> 2] | 0;
   i14 = HEAP32[i16 >> 2] | 0;
   HEAP32[i17 + 244 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i17 + 248 >> 2] = i7;
   HEAP32[i17 + 252 >> 2] = i14;
   i17 = HEAP32[i5 >> 2] | 0;
   i14 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE(i10, (i14 | 0) == 0 ? 0 : i14 + i8 | 0, HEAP32[i2 >> 2] | 0, 3);
   i15 = HEAP32[i15 >> 2] | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   HEAP32[i17 + 308 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i17 + 312 >> 2] = i15;
   HEAP32[i17 + 316 >> 2] = i16;
  }
  if (i1) {
   i17 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim5human13FullBodySolveEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESC_SC_((i17 | 0) == 0 ? 0 : i17 + i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0);
  }
 }
 i15 = HEAP32[i5 >> 2] | 0;
 i17 = HEAP32[i15 + 72 >> 2] | 0;
 i16 = HEAP32[i15 + 76 >> 2] | 0;
 HEAP32[i12 + 40 >> 2] = HEAP32[i15 + 68 >> 2];
 HEAP32[i12 + 44 >> 2] = i17;
 HEAP32[i12 + 48 >> 2] = i16;
 i16 = HEAP32[i15 + 84 >> 2] | 0;
 i17 = HEAP32[i15 + 88 >> 2] | 0;
 i14 = HEAP32[i15 + 92 >> 2] | 0;
 HEAP32[i12 + 52 >> 2] = HEAP32[i15 + 80 >> 2];
 HEAP32[i12 + 56 >> 2] = i16;
 HEAP32[i12 + 60 >> 2] = i17;
 HEAP32[i12 + 64 >> 2] = i14;
 i14 = HEAP32[i15 + 100 >> 2] | 0;
 i17 = HEAP32[i15 + 104 >> 2] | 0;
 HEAP32[i12 + 68 >> 2] = HEAP32[i15 + 96 >> 2];
 HEAP32[i12 + 72 >> 2] = i14;
 HEAP32[i12 + 76 >> 2] = i17;
 i17 = HEAP32[i15 + 136 >> 2] | 0;
 i14 = HEAP32[i15 + 140 >> 2] | 0;
 HEAP32[i12 + 80 >> 2] = HEAP32[i15 + 132 >> 2];
 HEAP32[i12 + 84 >> 2] = i17;
 HEAP32[i12 + 88 >> 2] = i14;
 i14 = HEAP32[i15 + 148 >> 2] | 0;
 i17 = HEAP32[i15 + 152 >> 2] | 0;
 i16 = HEAP32[i15 + 156 >> 2] | 0;
 HEAP32[i12 + 92 >> 2] = HEAP32[i15 + 144 >> 2];
 HEAP32[i12 + 96 >> 2] = i14;
 HEAP32[i12 + 100 >> 2] = i17;
 HEAP32[i12 + 104 >> 2] = i16;
 i16 = HEAP32[i15 + 164 >> 2] | 0;
 i17 = HEAP32[i15 + 168 >> 2] | 0;
 HEAP32[i12 + 108 >> 2] = HEAP32[i15 + 160 >> 2];
 HEAP32[i12 + 112 >> 2] = i16;
 HEAP32[i12 + 116 >> 2] = i17;
 i17 = HEAP32[i5 >> 2] | 0;
 HEAPF32[i17 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 192 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 236 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 256 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 300 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 304 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 320 >> 2] = Math_fround(0.0);
 i17 = i17 + 52 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i1, i14, i15) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i13 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i13 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = HEAP32[i16 + (i1 * 40 | 0) >> 2] | 0;
 i5 = HEAP32[i16 + (i1 * 40 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i16 + (i1 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i7;
 i8 = i14 + 4 | 0;
 HEAP32[i8 >> 2] = i5;
 i9 = i14 + 8 | 0;
 HEAP32[i9 >> 2] = i6;
 i11 = HEAP32[i16 + (i1 * 40 | 0) + 16 >> 2] | 0;
 i12 = HEAP32[i16 + (i1 * 40 | 0) + 20 >> 2] | 0;
 i17 = HEAP32[i16 + (i1 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i16 + (i1 * 40 | 0) + 12 >> 2];
 i10 = i15 + 4 | 0;
 HEAP32[i10 >> 2] = i11;
 i11 = i15 + 8 | 0;
 HEAP32[i11 >> 2] = i12;
 i12 = i15 + 12 | 0;
 HEAP32[i12 >> 2] = i17;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i1 = HEAP32[i13 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do {
  f22 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 28 >> 2]);
  f19 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 32 >> 2]);
  f21 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 36 >> 2]);
  f36 = Math_fround(f2 * f22);
  f20 = Math_fround(f3 * f19);
  f33 = Math_fround(f4 * f21);
  i31 = i16 + (i1 * 40 | 0) + 16 | 0;
  f18 = Math_fround(HEAPF32[i31 >> 2]);
  i6 = i16 + (i1 * 40 | 0) + 12 | 0;
  f32 = Math_fround(HEAPF32[i6 >> 2]);
  i29 = i16 + (i1 * 40 | 0) + 24 | 0;
  f26 = Math_fround(HEAPF32[i29 >> 2]);
  i5 = i16 + (i1 * 40 | 0) + 20 | 0;
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f38 = Math_fround(f18 * Math_fround(-2.0));
  f28 = Math_fround(f18 * Math_fround(2.0));
  f35 = Math_fround(f38 * f26);
  f23 = Math_fround(f37 * Math_fround(2.0));
  f34 = Math_fround(f37 * Math_fround(-2.0));
  f39 = Math_fround(f26 * f34);
  f27 = Math_fround(f32 * Math_fround(-2.0));
  f24 = Math_fround(f32 * Math_fround(2.0));
  f26 = Math_fround(f26 * f27);
  f25 = Math_fround(Math_fround(f36 + Math_fround(f36 * Math_fround(Math_fround(f18 * f38) - Math_fround(f37 * f23)))) + Math_fround(Math_fround(f33 * Math_fround(Math_fround(f24 * f37) - f35)) + Math_fround(f20 * Math_fround(f39 - Math_fround(f18 * f27)))));
  f24 = Math_fround(Math_fround(f20 + Math_fround(f36 * Math_fround(Math_fround(f32 * f28) - f39))) + Math_fround(Math_fround(f33 * Math_fround(f26 - Math_fround(f38 * f37))) + Math_fround(f20 * Math_fround(Math_fround(f37 * f34) - Math_fround(f32 * f24)))));
  f26 = Math_fround(Math_fround(f33 + Math_fround(f36 * Math_fround(f35 - Math_fround(f32 * f34)))) + Math_fround(Math_fround(f33 * Math_fround(Math_fround(f32 * f27) - Math_fround(f18 * f28))) + Math_fround(f20 * Math_fround(Math_fround(f18 * f23) - f26))));
  f23 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 4 >> 2]);
  f2 = Math_fround(f23 + f25);
  f3 = Math_fround(f18 + f24);
  f4 = Math_fround(Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 8 >> 2]) + f26);
  HEAPF32[i14 >> 2] = f2;
  HEAPF32[i8 >> 2] = f3;
  HEAPF32[i9 >> 2] = f4;
  i17 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
  f21 = (HEAP32[tempDoublePtr >> 2] = i17 & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = (HEAP32[tempDoublePtr >> 2] = i7 & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f22 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f19 * f22);
  f22 = Math_fround(f21 * f22);
  f19 = Math_fround(f21 * f19);
  i30 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i30 = i30 & -2147483648 ^ HEAP32[i15 >> 2];
  i7 = i7 & -2147483648 ^ HEAP32[i10 >> 2];
  i17 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ HEAP32[i11 >> 2];
  f19 = Math_fround(HEAPF32[i12 >> 2]);
  HEAP32[i15 >> 2] = i30;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i17;
  f22 = Math_fround(HEAPF32[i31 >> 2]);
  f26 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(f22 * f26);
  f24 = Math_fround(HEAPF32[i29 >> 2]);
  f18 = Math_fround(f24 * f19);
  f25 = Math_fround(HEAPF32[i5 >> 2]);
  f23 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = Math_fround(f25 * f23);
  f28 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(Math_fround(Math_fround(f21 - Math_fround(f24 * f27)) - Math_fround(f19 * f25)) - Math_fround(f23 * f28));
  f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f26 * f28)) - Math_fround(f25 * f27)) - Math_fround(f22 * f23));
  f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f22 * f27)) - Math_fround(f26 * f24)) - Math_fround(f19 * f28));
  f19 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f23)) - Math_fround(f22 * f19));
  i17 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  HEAP32[i15 >> 2] = i6 ^ -2147483648;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i11 >> 2] = i17 ^ -2147483648;
  HEAPF32[i12 >> 2] = f18;
  i1 = HEAP32[i13 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 return;
}

function __ZN9ShaderLab20SerializedSubProgramaSERKS0_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i6 = i10;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i9;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 i11 = (i10 | 0) == (i9 | 0);
 if (i11) {
  HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  i8 = 14;
 } else {
  i5 = HEAP32[i10 + 8 >> 2] | 0;
  i1 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + 8 | 0;
  i6 = i9 + 20 | 0;
  HEAP32[i6 >> 2] = i1;
  i3 = i9 + 24 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i9 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i2 >> 2] = i1;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i2 >> 2] = i7;
   i1 = i7;
   break;
  } else i1 = HEAP32[i2 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i9 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
  i2 = i9 + 32 | 0;
  if (i11) i8 = 14; else {
   i6 = HEAP32[i10 + 32 >> 2] | 0;
   i7 = i9 + 44 | 0;
   i1 = HEAP32[i10 + 44 >> 2] << 3;
   i3 = i1 >> 3;
   HEAP32[i7 >> 2] = i3;
   i4 = i9 + 48 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i3;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i9 + 36 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i2 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 36 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i3;
    HEAP32[i2 >> 2] = i1;
    break;
   } else i1 = HEAP32[i2 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
   HEAP32[i9 + 52 >> 2] = HEAP32[i10 + 52 >> 2];
   i5 = i9 + 56 | 0;
   if (!i11) {
    i6 = HEAP32[i10 + 56 >> 2] | 0;
    i7 = i9 + 68 | 0;
    i1 = HEAP32[i10 + 68 >> 2] << 1;
    i2 = i1 >> 1;
    HEAP32[i7 >> 2] = i2;
    i3 = i9 + 72 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 2, i9 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i5 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, i9 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i5 >> 2] = i1;
     break;
    } else i1 = HEAP32[i5 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
    i8 = i9 + 76 | 0;
    i7 = i10 + 76 | 0;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
    HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
    if (i11) return i9 | 0;
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 108 | 0, HEAP32[i10 + 108 >> 2] | 0, HEAP32[i10 + 112 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 120 | 0, HEAP32[i10 + 120 >> 2] | 0, HEAP32[i10 + 124 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 132 | 0, HEAP32[i10 + 132 >> 2] | 0, HEAP32[i10 + 136 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 144 | 0, HEAP32[i10 + 144 >> 2] | 0, HEAP32[i10 + 148 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 156 | 0, HEAP32[i10 + 156 >> 2] | 0, HEAP32[i10 + 160 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 168 | 0, HEAP32[i10 + 168 >> 2] | 0, HEAP32[i10 + 172 >> 2] | 0);
    __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9 + 180 | 0, HEAP32[i10 + 180 >> 2] | 0, HEAP32[i10 + 184 >> 2] | 0);
    return i9 | 0;
   }
  }
 }
 if ((i8 | 0) == 14) HEAP32[i9 + 52 >> 2] = HEAP32[i10 + 52 >> 2];
 i11 = i9 + 76 | 0;
 i10 = i10 + 76 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 return i9 | 0;
}

function __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i12, i13, i8, i9) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 1728 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 1696 | 0;
 i15 = i17 + 1376 | 0;
 i16 = i17;
 if ((HEAP16[gb + 1110424 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = i12;
  HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110424 | 0, i10);
  i11 = gb + 1110424 | 0;
 } else i11 = 0;
 i14 = HEAP32[gb + 1110424 >> 2] | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 648 >> 2] | 0, i7 | 0, i14 | 0);
 i14 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZN13RenderManager18UpdateAllRenderersEv();
 if ((HEAP32[i12 + 1108 >> 2] | 0) != 4) {
  __Z20PlayerUpdateCanvasesv();
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i4 = i2 + 27016 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = 0;
   do {
    i5 = i2 + 26248 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i2 + 26248 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i5 >> 2] | 0, i12 | 0); else mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 + 26248 + (i1 * 12 | 0) + 4 >> 2] | 0, i12 | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
 }
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 252 >> 2] = 0;
 HEAP32[i15 + 256 >> 2] = 0;
 i1 = i15 + 260 | 0;
 i2 = i15 + 16 | 0;
 i4 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 1;
 HEAP32[i15 + 264 >> 2] = 0;
 i7 = i15 + 268 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = -1;
 HEAP32[i15 + 284 >> 2] = 0;
 HEAP32[i15 + 288 >> 2] = 0;
 HEAP32[i15 + 292 >> 2] = 1;
 HEAP32[i15 + 296 >> 2] = 0;
 i7 = i15 + 300 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = -1;
 i7 = (i13 & 16 | 0) == 0;
 if (i7) __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext(i15, i14);
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i12);
 i1 = i12 + 1086 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __ZL19GetCameraTargetRectRK6Camerab(i10, i12, 1);
  f3 = Math_fround(HEAPF32[i12 + 864 >> 2]);
  f6 = Math_fround(HEAPF32[i12 + 868 >> 2]);
  f22 = Math_fround(HEAPF32[i12 + 872 >> 2]);
  f19 = Math_fround(HEAPF32[i12 + 876 >> 2]);
  f23 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f3 = Math_fround(f3 * f23);
  f22 = Math_fround(f22 * f23);
  f6 = Math_fround(f6 * f20);
  f19 = Math_fround(f19 * f20);
  f21 = Math_fround(HEAPF32[i10 >> 2]);
  f18 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f3 = Math_fround(f3 + f21);
  f6 = Math_fround(f6 + f18);
  f22 = Math_fround(f22 + f3);
  f19 = Math_fround(f19 + f6);
  f23 = Math_fround(f23 + f21);
  f20 = Math_fround(f20 + f18);
  f3 = Math_fround((f22 > f23 ? f23 : f22) - (f3 < f21 ? f21 : f3));
  f6 = Math_fround((f19 > f20 ? f20 : f19) - (f6 < f18 ? f18 : f6));
  i5 = f6 < Math_fround(0.0);
  f6 = i5 ? Math_fround(0.0) : f6;
  if (f6 != Math_fround(0.0)) {
   i5 = f3 < Math_fround(0.0);
   f3 = Math_fround((i5 ? Math_fround(0.0) : f3) / f6);
  } else f3 = Math_fround(1.0);
  HEAPF32[i12 + 1060 >> 2] = f3;
  HEAP8[i12 + 1077 >> 0] = 1;
  HEAP8[i12 + 1079 >> 0] = 1;
  HEAP8[i12 + 1078 >> 0] = 1;
  HEAP8[i1 >> 0] = 1;
 }
 __ZN11CullResultsC2Ev(i16);
 i2 = i10 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i10 >> 2] = i12;
 i1 = i10 + 12 | 0;
 HEAP32[i1 >> 2] = 5;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 if (HEAP8[i12 + 1089 >> 0] | 0) HEAP32[i1 >> 2] = 7;
 i5 = (i8 | 0) == 0;
 if (!i5) {
  HEAP32[i2 >> 2] = i8;
  i8 = HEAP8[i9 + 11 >> 0] | 0;
  if (!((i8 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i8 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i12, i10, i16);
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i1 + 4192 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 496 >> 2] | 0, i1 | 0);
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0) {
   i1 = 1;
   i2 = 23;
  } else i2 = 26;
 } else {
  i1 = 0;
  i2 = 23;
 }
 if ((i2 | 0) == 23) {
  __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i9 = i12 + 904 | 0;
  f20 = Math_fround(HEAPF32[i10 >> 2]);
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i9 >> 2]));
  f22 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f22 = Math_fround(f22 - Math_fround(HEAPF32[i12 + 908 >> 2]));
  f23 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f23 = Math_fround(f23 - Math_fround(HEAPF32[i12 + 912 >> 2]));
  f21 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
  f22 = Math_fround(f22 * f21);
  f23 = Math_fround(f23 * f21);
  HEAPF32[i12 + 892 >> 2] = Math_fround(f20 * f21);
  HEAPF32[i12 + 896 >> 2] = f22;
  HEAPF32[i12 + 900 >> 2] = f23;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv(i12, i16, i14, 0, (i5 ? 1 : 65) | i13, 0);
  __ZN21IntermediateRenderers5ClearEj(HEAP32[i12 + 1132 >> 2] | 0, 0);
  if (i7) __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext(i15, i14);
  if (i1 << 24 >> 24) i2 = 26;
 }
 if ((i2 | 0) == 26) {
  i15 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 500 >> 2] | 0, i15 | 0);
 }
 __ZN11CullResultsD2Ev(i16);
 i16 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 652 >> 2] | 0, i16 | 0);
 if (!i11) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i17;
 return;
}

function runPostSets10() {
 HEAP32[gb + 31120 >> 2] = (HEAP32[gb + 31120 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31124 >> 2] = (HEAP32[gb + 31124 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31160 >> 2] = (HEAP32[gb + 31160 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31164 >> 2] = (HEAP32[gb + 31164 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31200 >> 2] = (HEAP32[gb + 31200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31204 >> 2] = (HEAP32[gb + 31204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31240 >> 2] = (HEAP32[gb + 31240 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31244 >> 2] = (HEAP32[gb + 31244 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31280 >> 2] = (HEAP32[gb + 31280 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31284 >> 2] = (HEAP32[gb + 31284 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31320 >> 2] = (HEAP32[gb + 31320 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31324 >> 2] = (HEAP32[gb + 31324 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31360 >> 2] = (HEAP32[gb + 31360 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31364 >> 2] = (HEAP32[gb + 31364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31400 >> 2] = (HEAP32[gb + 31400 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31404 >> 2] = (HEAP32[gb + 31404 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31440 >> 2] = (HEAP32[gb + 31440 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31444 >> 2] = (HEAP32[gb + 31444 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31480 >> 2] = (HEAP32[gb + 31480 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31484 >> 2] = (HEAP32[gb + 31484 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31520 >> 2] = (HEAP32[gb + 31520 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31524 >> 2] = (HEAP32[gb + 31524 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31560 >> 2] = (HEAP32[gb + 31560 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31564 >> 2] = (HEAP32[gb + 31564 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31600 >> 2] = (HEAP32[gb + 31600 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31604 >> 2] = (HEAP32[gb + 31604 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31640 >> 2] = (HEAP32[gb + 31640 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31644 >> 2] = (HEAP32[gb + 31644 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31680 >> 2] = (HEAP32[gb + 31680 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31684 >> 2] = (HEAP32[gb + 31684 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31720 >> 2] = (HEAP32[gb + 31720 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31724 >> 2] = (HEAP32[gb + 31724 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31760 >> 2] = (HEAP32[gb + 31760 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31764 >> 2] = (HEAP32[gb + 31764 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31800 >> 2] = (HEAP32[gb + 31800 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31804 >> 2] = (HEAP32[gb + 31804 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31840 >> 2] = (HEAP32[gb + 31840 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31844 >> 2] = (HEAP32[gb + 31844 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31880 >> 2] = (HEAP32[gb + 31880 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31884 >> 2] = (HEAP32[gb + 31884 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31920 >> 2] = (HEAP32[gb + 31920 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31924 >> 2] = (HEAP32[gb + 31924 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 31960 >> 2] = (HEAP32[gb + 31960 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 31964 >> 2] = (HEAP32[gb + 31964 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32e3 >> 2] = (HEAP32[gb + 32e3 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32004 >> 2] = (HEAP32[gb + 32004 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32040 >> 2] = (HEAP32[gb + 32040 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32044 >> 2] = (HEAP32[gb + 32044 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32080 >> 2] = (HEAP32[gb + 32080 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32084 >> 2] = (HEAP32[gb + 32084 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32120 >> 2] = (HEAP32[gb + 32120 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32124 >> 2] = (HEAP32[gb + 32124 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32160 >> 2] = (HEAP32[gb + 32160 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32164 >> 2] = (HEAP32[gb + 32164 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32200 >> 2] = (HEAP32[gb + 32200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32204 >> 2] = (HEAP32[gb + 32204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32240 >> 2] = (HEAP32[gb + 32240 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32244 >> 2] = (HEAP32[gb + 32244 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32280 >> 2] = (HEAP32[gb + 32280 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32284 >> 2] = (HEAP32[gb + 32284 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32344 >> 2] = fb + 95;
 HEAP32[gb + 32348 >> 2] = fb + 96;
 HEAP32[gb + 32352 >> 2] = fb + 38;
 HEAP32[gb + 32356 >> 2] = fb + 39;
 HEAP32[gb + 32360 >> 2] = fb + 16;
 HEAP32[gb + 32364 >> 2] = fb + 39;
 HEAP32[gb + 32368 >> 2] = fb + 40;
 HEAP32[gb + 32372 >> 2] = fb + 19;
 HEAP32[gb + 32376 >> 2] = fb + 107;
 HEAP32[gb + 32380 >> 2] = fb + 31;
 HEAP32[gb + 32384 >> 2] = fb + 27;
 HEAP32[gb + 32388 >> 2] = fb + 62;
 HEAP32[gb + 32392 >> 2] = fb + 28;
 HEAP32[gb + 32396 >> 2] = fb + 63;
 HEAP32[gb + 32400 >> 2] = fb + 29;
 HEAP32[gb + 32404 >> 2] = fb + 34;
 HEAP32[gb + 32408 >> 2] = fb + 111;
 HEAP32[gb + 32412 >> 2] = fb + 112;
 HEAP32[gb + 32416 >> 2] = fb + 113;
 HEAP32[gb + 32420 >> 2] = fb + 114;
 HEAP32[gb + 32424 >> 2] = fb + 115;
 HEAP32[gb + 32428 >> 2] = fb + 116;
 HEAP32[gb + 32432 >> 2] = fb + 36;
 HEAP32[gb + 32444 >> 2] = fb + 97;
 HEAP32[gb + 32448 >> 2] = fb + 98;
 HEAP32[gb + 32452 >> 2] = fb + 80;
 HEAP32[gb + 32456 >> 2] = fb + 39;
 HEAP32[gb + 32460 >> 2] = fb + 16;
 HEAP32[gb + 32464 >> 2] = fb + 39;
 HEAP32[gb + 32468 >> 2] = fb + 99;
 HEAP32[gb + 32472 >> 2] = fb + 19;
 HEAP32[gb + 32476 >> 2] = fb + 108;
 HEAP32[gb + 32480 >> 2] = fb + 99;
 HEAP32[gb + 32484 >> 2] = fb + 40;
 HEAP32[gb + 32488 >> 2] = fb + 109;
 HEAP32[gb + 32492 >> 2] = fb + 28;
 HEAP32[gb + 32496 >> 2] = fb + 63;
 HEAP32[gb + 32500 >> 2] = fb + 29;
 HEAP32[gb + 32504 >> 2] = fb + 34;
 HEAP32[gb + 32508 >> 2] = fb + 117;
 runPostSets11();
}

function _TT_Load_Simple_Glyph(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i23;
 i19 = i13 + 200 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i13 + 204 >> 2] | 0;
 i21 = HEAP32[i13 + 12 >> 2] | 0;
 i22 = HEAP16[i13 + 32 >> 1] | 0;
 i3 = i22 << 16 >> 16;
 if (i22 << 16 >> 16) {
  if (((HEAP16[i21 + 20 >> 1] | 0) + i3 + (HEAP16[i21 + 56 >> 1] | 0) | 0) >>> 0 > (HEAP32[i21 + 8 >> 2] | 0) >>> 0) {
   i1 = _UNITY_FT_GlyphLoader_CheckPoints(i21, 0, i3) | 0;
   if (i1 | 0) {
    i22 = i1;
    STACKTOP = i23;
    return i22 | 0;
   }
  }
  if (i22 << 16 >> 16 > 4094) {
   i22 = 20;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 i4 = HEAP32[i21 + 68 >> 2] | 0;
 i7 = i4 + (i3 << 1) | 0;
 if ((i5 + ((i3 << 1) + 2) | 0) >>> 0 > i20 >>> 0) {
  i22 = 20;
  STACKTOP = i23;
  return i22 | 0;
 }
 i1 = HEAPU8[i5 >> 0] << 8;
 i3 = i1 | HEAPU8[i5 + 1 >> 0];
 i6 = i22 << 16 >> 16 > 0;
 if (i6) HEAP16[i4 >> 1] = i3;
 if (!(i1 & 32768)) i9 = i5; else {
  i22 = 20;
  STACKTOP = i23;
  return i22 | 0;
 }
 while (1) {
  i8 = i9 + 2 | 0;
  i1 = i4 + 2 | 0;
  if (i1 >>> 0 >= i7 >>> 0) break;
  i5 = i3;
  i3 = HEAPU8[i8 >> 0] << 8 | HEAPU8[i9 + 3 >> 0];
  HEAP16[i1 >> 1] = i3;
  if ((i3 << 16 | 0) <= (i5 << 16 | 0)) {
   i16 = 20;
   i12 = 49;
   break;
  } else {
   i4 = i1;
   i9 = i8;
  }
 }
 if ((i12 | 0) == 49) {
  STACKTOP = i23;
  return i16 | 0;
 }
 do if (i6) {
  i7 = HEAP16[i4 >> 1] | 0;
  i1 = i7 << 16 >> 16;
  i3 = i1 + 1 | 0;
  if (i7 << 16 >> 16 < -1) {
   i22 = 20;
   STACKTOP = i23;
   return i22 | 0;
  } else {
   i1 = i1 + 5 | 0;
   if (!i1) {
    i17 = i3;
    break;
   } else {
    i11 = i3;
    i10 = i1;
    i12 = 14;
    break;
   }
  }
 } else {
  i11 = 0;
  i10 = 4;
  i12 = 14;
 } while (0);
 if ((i12 | 0) == 14) if (((HEAP16[i21 + 22 >> 1] | 0) + i10 + (HEAP16[i21 + 58 >> 1] | 0) | 0) >>> 0 > (HEAP32[i21 + 4 >> 2] | 0) >>> 0) {
  i1 = _UNITY_FT_GlyphLoader_CheckPoints(i21, i10, 0) | 0;
  if (!i1) i17 = i11; else {
   i22 = i1;
   STACKTOP = i23;
   return i22 | 0;
  }
 } else i17 = i11;
 i5 = i13 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + 140 >> 2] = 0;
 HEAP32[i6 + 136 >> 2] = 0;
 i6 = i9 + 4 | 0;
 if (i6 >>> 0 > i20 >>> 0) {
  i22 = 20;
  STACKTOP = i23;
  return i22 | 0;
 }
 i4 = HEAPU8[i8 >> 0] << 8 | HEAPU8[i9 + 3 >> 0];
 if ((i20 - i6 | 0) < (i4 | 0)) {
  i22 = 22;
  STACKTOP = i23;
  return i22 | 0;
 }
 do if (!(HEAP32[i13 + 16 >> 2] & 2)) {
  i1 = i13 + 160 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i3 + 388 >> 2];
  i3 = _Update_Max(HEAP32[i3 + 8 >> 2] | 0, i14, 1, i3 + 392 | 0, i4) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 388 >> 2] = HEAP32[i14 >> 2] & 65535;
  if (!i3) {
   i13 = HEAP32[i5 >> 2] | 0;
   HEAP32[i13 + 140 >> 2] = i4;
   i14 = HEAP32[i1 + 392 >> 2] | 0;
   HEAP32[i13 + 136 >> 2] = i14;
   _memcpy(i14 | 0, i6 | 0, i4 | 0) | 0;
   break;
  } else {
   i22 = i3;
   STACKTOP = i23;
   return i22 | 0;
  }
 } while (0);
 i3 = i6 + i4 | 0;
 i13 = i21 + 64 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i7 = i1 + i17 | 0;
 i11 = (i17 | 0) > 0;
 L45 : do if (i11) {
  while (1) {
   i4 = i3 + 1 | 0;
   if (i4 >>> 0 > i20 >>> 0) {
    i16 = 20;
    i12 = 49;
    break;
   }
   i5 = HEAP8[i3 >> 0] | 0;
   i6 = i1 + 1 | 0;
   HEAP8[i1 >> 0] = i5;
   if (!(i5 & 8)) {
    i1 = i6;
    i3 = i4;
   } else {
    i3 = i3 + 2 | 0;
    if (i3 >>> 0 > i20 >>> 0) {
     i16 = 20;
     i12 = 49;
     break;
    }
    i4 = HEAP8[i4 >> 0] | 0;
    if ((i6 + (i4 & 255) | 0) >>> 0 > i7 >>> 0) {
     i16 = 20;
     i12 = 49;
     break;
    }
    if (!(i4 << 24 >> 24)) i1 = i6; else {
     i14 = i4 + -1 & 255;
     _memset(i6 | 0, i5 | 0, i14 + 1 | 0) | 0;
     i1 = i1 + 2 + i14 | 0;
    }
   }
   if (i1 >>> 0 >= i7 >>> 0) {
    i15 = i3;
    break L45;
   }
  }
  if ((i12 | 0) == 49) {
   STACKTOP = i23;
   return i16 | 0;
  }
 } else i15 = i3; while (0);
 i10 = i21 + 60 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i1 + (i17 << 3) | 0;
 if (i15 >>> 0 > i20 >>> 0) {
  i22 = 20;
  STACKTOP = i23;
  return i22 | 0;
 }
 L63 : do if (i11) {
  i8 = 0;
  i7 = HEAP32[i13 >> 2] | 0;
  i5 = i15;
  while (1) {
   i6 = HEAPU8[i7 >> 0] | 0;
   if (!(i6 & 2)) if (!(i6 & 16)) {
    i3 = i5 + 2 | 0;
    if (i3 >>> 0 > i20 >>> 0) {
     i16 = 20;
     i12 = 49;
     break;
    }
    i4 = (HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0]) << 16 >> 16;
    i2 = i3;
   } else {
    i4 = 0;
    i2 = i5;
   } else {
    i3 = i5 + 1 | 0;
    if (i3 >>> 0 > i20 >>> 0) {
     i16 = 20;
     i12 = 49;
     break;
    }
    i4 = HEAPU8[i5 >> 0] | 0;
    i4 = (i6 & 16 | 0) == 0 ? 0 - i4 | 0 : i4;
    i2 = i3;
   }
   i8 = i4 + i8 | 0;
   HEAP32[i1 >> 2] = i8;
   HEAP8[i7 >> 0] = i6 & 237;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i9 >>> 0) {
    i12 = 39;
    break;
   } else {
    i7 = i7 + 1 | 0;
    i5 = i2;
   }
  }
  if ((i12 | 0) == 39) {
   i1 = HEAP32[i10 >> 2] | 0;
   i8 = i1 + (i17 << 3) | 0;
   if (!i11) {
    i18 = i2;
    break;
   }
   i7 = 0;
   i6 = HEAP32[i13 >> 2] | 0;
   while (1) {
    i5 = HEAPU8[i6 >> 0] | 0;
    if (!(i5 & 4)) if (!(i5 & 32)) {
     i3 = i2 + 2 | 0;
     if (i3 >>> 0 > i20 >>> 0) {
      i16 = 20;
      i12 = 49;
      break;
     }
     i4 = (HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0]) << 16 >> 16;
     i2 = i3;
    } else i4 = 0; else {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 > i20 >>> 0) {
      i16 = 20;
      i12 = 49;
      break;
     }
     i4 = HEAPU8[i2 >> 0] | 0;
     i4 = (i5 & 32 | 0) == 0 ? 0 - i4 | 0 : i4;
     i2 = i3;
    }
    i7 = i4 + i7 | 0;
    HEAP32[i1 + 4 >> 2] = i7;
    HEAP8[i6 >> 0] = i5 & 1;
    i1 = i1 + 8 | 0;
    if (i1 >>> 0 >= i8 >>> 0) {
     i18 = i2;
     break L63;
    } else i6 = i6 + 1 | 0;
   }
   if ((i12 | 0) == 49) {
    STACKTOP = i23;
    return i16 | 0;
   }
  } else if ((i12 | 0) == 49) {
   STACKTOP = i23;
   return i16 | 0;
  }
 } else i18 = i15; while (0);
 HEAP16[i21 + 58 >> 1] = i17;
 HEAP16[i21 + 56 >> 1] = i22;
 HEAP32[i19 >> 2] = i18;
 i22 = 0;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN5Light9SetupHaloEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21;
 i13 = i2 + 44 | 0;
 if (HEAP8[(HEAP32[i13 >> 2] | 0) + 85 >> 0] | 0) {
  i19 = i2 + 28 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) {
   f18 = Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 300 >> 2]);
   i8 = i2 + 56 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) {
    i2 = HEAP32[gb + 1110376 >> 2] | 0;
    i3 = i2 + 4 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) i1 = 1; else i1 = (HEAP32[i4 + -8 >> 2] | 0) + 1 | 0;
    HEAPF32[i12 >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
    i6 = i12 + 24 | 0;
    HEAP8[i6 >> 0] = 0;
    HEAP8[i12 + 25 >> 0] = 0;
    HEAP8[i12 + 26 >> 0] = 0;
    HEAP8[i12 + 27 >> 0] = -1;
    HEAPF32[i12 + 28 >> 2] = Math_fround(1.0);
    HEAP32[i12 + 32 >> 2] = i1;
    HEAP32[i12 + 36 >> 2] = 1;
    if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i2, i12); else {
     HEAP32[i4 >> 2] = 0;
     HEAP32[i4 + 4 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = 0;
     HEAP32[i4 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     HEAP32[i4 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
     i17 = i4 + 24 | 0;
     HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 40;
    }
    HEAP32[i8 >> 2] = i1;
    if (!i1) {
     STACKTOP = i21;
     return;
    }
   }
   i3 = HEAP32[i13 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f5 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 20 >> 2]));
   f7 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 24 >> 2]));
   f9 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 28 >> 2]));
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 32 >> 2]));
   do if (!(f18 <= Math_fround(0.0))) {
    if (f18 <= Math_fround(.00313080009)) {
     f10 = Math_fround(f18 * Math_fround(12.9200001));
     break;
    }
    if (f18 < Math_fround(1.0)) {
     f10 = Math_fround(Math_fround(Math_fround(+Math_pow(+f18, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f18 == Math_fround(1.0)) f10 = Math_fround(1.0); else f10 = Math_fround(+Math_pow(+f18, .454545468));
   } else f10 = Math_fround(0.0); while (0);
   f14 = Math_fround(f5 * f10);
   f7 = Math_fround(f7 * f10);
   f9 = Math_fround(f9 * f10);
   f5 = Math_fround(f11 * f10);
   if ((HEAP32[i3 + 40 >> 2] | 0) == 3) {
    i2 = i3 + 52 | 0;
    i17 = i3 + 56 | 0;
    f11 = Math_fround(HEAPF32[i2 >> 2]);
    i16 = f11 < Math_fround(HEAPF32[i17 >> 2]);
    i2 = i16 ? i17 : i2;
   } else i2 = i3 + 48 | 0;
   f11 = Math_fround(HEAPF32[i2 >> 2]);
   i4 = HEAP32[gb + 1110376 >> 2] | 0;
   i16 = HEAP32[i3 + 264 >> 2] | 0;
   i17 = HEAP32[i3 + 268 >> 2] | 0;
   i15 = HEAP32[i3 + 272 >> 2] | 0;
   i13 = f14 < Math_fround(0.0);
   f14 = i13 ? Math_fround(0.0) : f14;
   i13 = f14 > Math_fround(1.0);
   i13 = ~~Math_fround(Math_fround((i13 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i12 = f7 < Math_fround(0.0);
   f14 = i12 ? Math_fround(0.0) : f7;
   i12 = f14 > Math_fround(1.0);
   i12 = ~~Math_fround(Math_fround((i12 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i8 = f9 < Math_fround(0.0);
   f14 = i8 ? Math_fround(0.0) : f9;
   i8 = f14 > Math_fround(1.0);
   i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i6 = f5 < Math_fround(0.0);
   f5 = i6 ? Math_fround(0.0) : f5;
   i6 = f5 > Math_fround(1.0);
   i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f5) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f5 = Math_fround(f18 * f11);
   i3 = 1 << HEAP32[(HEAP32[i19 >> 2] | 0) + 48 >> 2];
   i2 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) {
    STACKTOP = i21;
    return;
   }
   while (1) {
    if ((HEAP32[i2 + 32 >> 2] | 0) == (i1 | 0)) break;
    i2 = i2 + 40 | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i20 = 34;
     break;
    }
   }
   if ((i20 | 0) == 34) {
    STACKTOP = i21;
    return;
   }
   HEAP32[i2 >> 2] = i16;
   HEAP32[i2 + 4 >> 2] = i17;
   HEAP32[i2 + 8 >> 2] = i15;
   HEAP32[i2 + 24 >> 2] = i13 & 255 | i6 << 24 | i8 << 16 & 16711680 | i12 << 8 & 65280;
   HEAPF32[i2 + 28 >> 2] = f5;
   HEAP32[i2 + 36 >> 2] = i3;
   STACKTOP = i21;
   return;
  }
 }
 i6 = i2 + 56 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i4) {
  STACKTOP = i21;
  return;
 }
 i2 = HEAP32[gb + 1110376 >> 2] | 0;
 i8 = i2 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == (i1 | 0)) break;
  i3 = i2 + 40 | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i4 | 0)) {
   i20 = 29;
   break;
  } else i2 = i3;
 }
 do if ((i20 | 0) == 29) {
  if ((i3 | 0) != (i1 | 0)) {
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    i20 = i2 + 28 | 0;
    i19 = i3 + 28 | 0;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
    i3 = i3 + 40 | 0;
    i2 = i2 + 40 | 0;
   } while ((i3 | 0) != (i1 | 0));
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) break;
  }
  HEAP32[i8 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
 } while (0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZN5physx13PxsCCDContextC2EPNS_10PxsContextE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP16[i6 + 4 >> 1] = -1;
 HEAP16[i6 + 6 >> 1] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 102692 + 8;
 HEAP32[i6 + 20 >> 2] = i6;
 HEAP32[i6 + 24 >> 2] = gb + 714457;
 i1 = i6 + 28 | 0;
 HEAP16[i6 + 32 >> 1] = -1;
 HEAP16[i6 + 34 >> 1] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 102736 + 8;
 HEAP32[i6 + 48 >> 2] = i6;
 HEAP32[i6 + 52 >> 2] = gb + 714481;
 i1 = i6 + 56 | 0;
 HEAP16[i6 + 60 >> 1] = -1;
 HEAP16[i6 + 62 >> 1] = 0;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 102780 + 8;
 HEAP32[i6 + 76 >> 2] = i6;
 HEAP32[i6 + 80 >> 2] = gb + 714507;
 HEAP8[i6 + 88 >> 0] = 0;
 HEAP32[i6 + 92 >> 2] = 0;
 HEAP32[i6 + 96 >> 2] = 0;
 i1 = i6 + 100 | 0;
 i2 = i6 + 104 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i4 >> 2] = mftCall_iiiiii(i9 | 0, i8 | 0, 2560, (i3 ? gb + 714537 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 185) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 108 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i10 = i4;
  i8 = HEAP32[i10 + 4 >> 2] | 0;
  i9 = (HEAP32[i1 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i4) | 0;
 i1 = i6 + 116 | 0;
 i2 = i6 + 120 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i4 >> 2] = mftCall_iiiiii(i9 | 0, i10 | 0, 1024, (i3 ? gb + 714801 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 185) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 124 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i4;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i1 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i4) | 0;
 i2 = i6 + 132 | 0;
 i3 = i6 + 136 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = mftCall_iiiiii(i9 | 0, i10 | 0, 12288, (i1 ? gb + 714989 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 185) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 140 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i8 = i4;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i2, i4) | 0;
 i1 = i6 + 196 | 0;
 i2 = i6 + 148 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.75);
 HEAP32[i6 + 200 >> 2] = -1;
 HEAP32[i6 + 204 >> 2] = 0;
 HEAP32[i6 + 208 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE15reserveInternalEj(i6 + 172 | 0, 64);
 i1 = i6 + 212 | 0;
 i2 = i6 + 216 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i4 >> 2] = mftCall_iiiiii(i9 | 0, i10 | 0, 13824, (i3 ? gb + 715173 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 185) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 220 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i8 = i4;
  i10 = HEAP32[i8 + 4 >> 2] | 0;
  i9 = (HEAP32[i1 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i9 = i6 + 228 | 0;
  i10 = i6 + 260 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  HEAP32[i9 + 28 >> 2] = 0;
  HEAP32[i10 >> 2] = 1;
  i10 = i6 + 264 | 0;
  HEAP32[i10 >> 2] = i5;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i4) | 0;
  i9 = i6 + 228 | 0;
  i10 = i6 + 260 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  HEAP32[i9 + 28 >> 2] = 0;
  HEAP32[i10 >> 2] = 1;
  i10 = i6 + 264 | 0;
  HEAP32[i10 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
}

function __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object(i18, i7, i9, i13, i15, i22, i19, i23) {
 i18 = i18 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 16 | 0;
 i17 = i24;
 i16 = i24 + 8 | 0;
 HEAP8[i19 >> 0] = 0;
 i2 = HEAP32[i18 + 32 >> 2] | 0;
 i8 = HEAP32[i18 + 36 >> 2] | 0;
 i1 = i8 - i2 | 0;
 if (i1) {
  i6 = (i1 | 0) / 24 | 0;
  i1 = i2;
  i3 = i2;
  while (1) {
   i14 = (i6 | 0) / 2 | 0;
   i5 = i3 + (i14 * 24 | 0) | 0;
   i4 = i5;
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   i4 = (i2 | 0) < (i9 | 0) | ((i2 | 0) == (i9 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i5 = i5 + 24 | 0;
   i2 = i4 ? i5 : i1;
   i6 = i4 ? i6 + -1 - i14 | 0 : i14;
   if (!i6) break; else {
    i1 = i2;
    i3 = i4 ? i5 : i3;
   }
  }
 }
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i24;
  return;
 }
 i14 = i2;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 if ((i12 | 0) > (i9 | 0) | ((i12 | 0) == (i9 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 > i7 >>> 0 : 0) | (i2 | 0) == (i8 | 0)) {
  STACKTOP = i24;
  return;
 }
 i14 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i11 = i2 + 16 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i18 >> 2] | 0;
 i12 = i9 + (i8 * 56 | 0) | 0;
 if (HEAP8[i18 + 52 >> 0] | 0) {
  i3 = i9 + (i8 * 56 | 0) + 48 | 0;
  if (!((HEAP32[i3 >> 2] | 0) != -1 ? 1 : (HEAP8[i9 + (i8 * 56 | 0) + 41 >> 0] | 0) == 0)) {
   i4 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63720 | 0, 16, gb + 588245 | 0, 1880) | 0;
   __ZN8TypeTreeC2ERK10MemLabelId(i4, gb + 63720 | 0);
   __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i23, i4, HEAP32[i18 + 48 >> 2] | 8192);
   i1 = HEAP32[i9 + (i8 * 56 | 0) + 44 >> 2] | 0;
   if ((i4 | 0) != 0 & (i1 | 0) != 0) {
    HEAP32[i20 >> 2] = i1;
    HEAP32[i20 + 4 >> 2] = 0;
    HEAP32[i17 >> 2] = i4;
    HEAP32[i17 + 4 >> 2] = 0;
    i1 = (__Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_(i20, i17) | 0) & 1 ^ 1;
   } else i1 = 1;
   HEAP32[i3 >> 2] = i1;
   if (i4 | 0) {
    i1 = i4 + 40 | 0;
    if ((HEAP32[i4 + 56 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 44 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    if ((HEAP32[i4 + 36 >> 2] | 0) > -1) {
     i10 = i4 + 20 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i4 + 24 | 0);
     HEAP32[i10 >> 2] = 0;
    }
    if ((HEAP32[i4 + 16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
     HEAP32[i4 >> 2] = 0;
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63720 | 0);
  }
 }
 i10 = i18 + 48 | 0;
 i6 = i18 + 44 | 0;
 i5 = (HEAP8[i6 >> 0] | 0 ? 513 : 1) | HEAP32[i10 >> 2];
 i5 = (i13 | 0) == 1 ? i5 | 8388608 : i5;
 __ZN6Object15SetIsPersistentEb(i23, i15);
 i1 = i2 + 8 | 0;
 i3 = i18 + 20 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0;
 i7 = i9 + (i8 * 56 | 0) + 44 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i21 = 23; else if (!(HEAP32[i9 + (i8 * 56 | 0) + 48 >> 2] | 0)) i21 = 23; else {
  __ZN14SafeBinaryReadC2Ev(i20);
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = 0;
  i2 = i2 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  __ZNK6Object14GetMemoryLabelEv(i16, i23);
  i1 = __ZN14SafeBinaryRead4InitERK16TypeTreeIteratorii24TransferInstructionFlagsRK10MemLabelId(i20, i17, i4, i1, i5, i16) | 0;
  __ZN12CachedReader8InitReadER15CacheReaderBasejj(i1, HEAP32[i18 + 128 >> 2] | 0, i4, HEAP32[i2 >> 2] | 0);
  mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 24 >> 2] | 0, i23 | 0);
  mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 84 >> 2] | 0, i23 | 0, i20 | 0);
  i1 = (__ZN12CachedReader3EndEv(i1) | 0) - i4 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZL23OutOfBoundsReadingErroriiiR6Object(HEAP32[i12 >> 2] | 0, i2, i1, i23);
  HEAP8[i19 >> 0] = 1;
  __ZN14SafeBinaryReadD2Ev(i20);
 }
 do if ((i21 | 0) == 23) if (!(HEAP8[i6 >> 0] | 0)) {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  i21 = i20 + 16 | 0;
  __ZN12CachedReaderC2Ev(i21);
  __ZNK6Object14GetMemoryLabelEv(i17, i23);
  i16 = i17;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i19 = i20 + 8 | 0;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i19 + 4 >> 2] = i17;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 >> 2] = i5;
  i2 = i2 + 12 | 0;
  __ZN12CachedReader8InitReadER15CacheReaderBasejj(i21, HEAP32[i18 + 128 >> 2] | 0, (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0, HEAP32[i2 >> 2] | 0);
  __ZN12CachedReader18InitResourceImagesER18ResourceImageGroup(i21, i18 + 132 | 0);
  mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 68 >> 2] | 0, i23 | 0, i20 | 0);
  i1 = (__ZN12CachedReader3EndEv(i21) | 0) - i4 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) __ZL23OutOfBoundsReadingErroriiiR6Object(HEAP32[(HEAP32[i18 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 56 | 0) >> 2] | 0, i2, i1, i23);
  break;
 } else {
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  i1 = i20 + 16 | 0;
  __ZN12CachedReaderC2Ev(i1);
  __ZNK6Object14GetMemoryLabelEv(i17, i23);
  i19 = HEAP32[i17 + 4 >> 2] | 0;
  i21 = i20 + 8 | 0;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i21 + 4 >> 2] = i19;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 >> 2] = i5;
  i2 = i2 + 12 | 0;
  __ZN12CachedReader8InitReadER15CacheReaderBasejj(i1, HEAP32[i18 + 128 >> 2] | 0, i4, HEAP32[i2 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 80 >> 2] | 0, i23 | 0, i20 | 0);
  i1 = (__ZN12CachedReader3EndEv(i1) | 0) - i4 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) __ZL23OutOfBoundsReadingErroriiiR6Object(HEAP32[i12 >> 2] | 0, i2, i1, i23);
  break;
 } while (0);
 HEAP32[i22 >> 2] = HEAP32[i7 >> 2];
 if (HEAP32[i10 >> 2] & 16777216 | 0) {
  i23 = i23 + 8 | 0;
  HEAP32[i23 >> 2] = HEAP32[i23 >> 2] & -1040385 | 516096;
 }
 if (!i14) {
  STACKTOP = i24;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i24;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold19reduceBatchContactsEPKNS0_17PersistentContactEj(i9, i19, i18) {
 i9 = i9 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i20 = 0, f21 = f0, f22 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20;
 _memset(i17 | 0, 0, i18 | 0) | 0;
 i13 = i18 >>> 0 > 1;
 if (i13) {
  i4 = HEAP32[i19 + 44 >> 2] | 0;
  i6 = 1;
  i1 = 0;
  while (1) {
   i3 = HEAP32[i19 + (i6 * 48 | 0) + 44 >> 2] | 0;
   f15 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i5 = f15 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i5 ? i6 : i1;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i18 | 0)) break; else i4 = i5 ? i3 : i4;
  }
 } else i1 = 0;
 i16 = i9 + 44 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i5 = i19 + (i1 * 48 | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i17 + i1 >> 0] = 1;
 f2 = Math_fround(HEAPF32[i19 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i19 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i19 + 24 >> 2]);
 i6 = HEAP32[i16 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f2 = Math_fround(f2 - f10);
 f7 = Math_fround(f7 - f11);
 f8 = Math_fround(f8 - f12);
 if (i13) {
  f15 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f7 * f7)) + Math_fround(f8 * f8));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = 1;
  i1 = 0;
  while (1) {
   f14 = Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 16 >> 2]);
   f15 = Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 20 >> 2]);
   f14 = Math_fround(f14 - f10);
   f15 = Math_fround(f15 - f11);
   f2 = Math_fround(Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 24 >> 2]) - f12);
   f2 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f2 * f2));
   i4 = f2 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i4 ? i5 : i1;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i18 | 0)) break; else i3 = i4 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i3;
  }
 } else i1 = 0;
 i4 = i6 + 48 | 0;
 i5 = i19 + (i1 * 48 | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i17 + i1 >> 0] = 1;
 i6 = HEAP32[i16 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 68 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 72 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f21 = Math_fround(f21 - f8);
 f12 = Math_fround(f12 - f10);
 f22 = Math_fround(f22 - f11);
 f7 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f14 = Math_fround(Math_fround(f12 * f15) - Math_fround(f22 * f2));
 f15 = Math_fround(Math_fround(f22 * f7) - Math_fround(f21 * f15));
 f7 = Math_fround(Math_fround(f21 * f2) - Math_fround(f12 * f7));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))))));
 f14 = Math_fround(f14 * f12);
 f15 = Math_fround(f15 * f12);
 f12 = Math_fround(f7 * f12);
 i13 = (i18 | 0) == 0;
 if (i13) {
  i9 = -8388609;
  f2 = Math_fround(3402823469999999843913219.0e14);
  i3 = -1;
  i1 = -1;
 } else {
  i9 = -8388609;
  f7 = Math_fround(3402823469999999843913219.0e14);
  i5 = 0;
  i3 = -1;
  i1 = -1;
  while (1) {
   if (!(HEAP8[i17 + i5 >> 0] | 0)) {
    f22 = Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 16 >> 2]);
    f2 = Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 20 >> 2]);
    f2 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(f22 - f8)) + Math_fround(f15 * Math_fround(f2 - f10))) + Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i19 + (i5 * 48 | 0) + 24 >> 2]) - f11)));
    i4 = f2 > (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i9 = i4 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i9;
    i3 = i4 ? i5 : i3;
    if (f7 > f2) i1 = i5; else f2 = f7;
   } else f2 = f7;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i18 | 0)) break; else f7 = f2;
  }
 }
 i4 = i6 + 96 | 0;
 i5 = i19 + (i3 * 48 | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i17 + i3 >> 0] = 1;
 if (!(Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]))) > Math_fround(0.0)) | i13) {
  i5 = i1;
  i4 = HEAP32[i16 >> 2] | 0;
  i4 = i4 + 144 | 0;
  i5 = i19 + (i5 * 48 | 0) | 0;
  i6 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
  } while ((i4 | 0) < (i6 | 0));
  STACKTOP = i20;
  return;
 } else {
  i3 = -8388609;
  i4 = 0;
 }
 do {
  if (!(HEAP8[i17 + i4 >> 0] | 0)) {
   f10 = Math_fround(HEAPF32[i19 + (i4 * 48 | 0) + 16 >> 2]);
   f21 = Math_fround(HEAPF32[i19 + (i4 * 48 | 0) + 20 >> 2]);
   f2 = Math_fround(HEAPF32[i19 + (i4 * 48 | 0) + 24 >> 2]);
   i13 = HEAP32[i16 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f22 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f2 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(f10 - f11)) + Math_fround(f15 * Math_fround(f21 - f22))) + Math_fround(f12 * Math_fround(f2 - Math_fround(HEAPF32[i13 + 24 >> 2]))));
   if (f2 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = i4;
   }
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i18 | 0));
 i4 = HEAP32[i16 >> 2] | 0;
 i4 = i4 + 144 | 0;
 i5 = i19 + (i1 * 48 | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 STACKTOP = i20;
 return;
}

function __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 L1 : while (1) {
  i9 = i2;
  i10 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i8 = i1;
    i3 = i9 - i8 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 2:
     {
      i11 = 5;
      break L1;
     }
    case 3:
     {
      i11 = 7;
      break L1;
     }
    case 4:
     {
      i11 = 8;
      break L1;
     }
    case 5:
     {
      i11 = 9;
      break L1;
     }
    case 1:
    case 0:
     {
      i11 = 52;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i11 = 11;
     break L1;
    }
    i6 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_(i1, i1 + (i3 << 2) | 0, i6, i6 + (i3 << 2) | 0, i10, i12) | 0;
    } else i3 = __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i1, i6, i10, i12) | 0;
    if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
     i4 = i10;
     break;
    } else i4 = i10;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
      i11 = 35;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0)) {
     if ((i3 | 0) == (i10 | 0)) {
      i11 = 52;
      break L1;
     }
     while (1) {
      if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break;
      i3 = i3 + 4 | 0;
      if ((i3 | 0) == (i10 | 0)) {
       i11 = 52;
       break L1;
      }
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i10 >> 2] = i8;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i10 | 0)) {
     i11 = 52;
     break L1;
    } else i4 = i10;
    while (1) {
     while (1) {
      i5 = i3 + 4 | 0;
      if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) break; else i3 = i5;
     }
     do i4 = i4 + -4 | 0; while (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     i8 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i8;
     i3 = i5;
    }
   }
   if ((i11 | 0) == 35) {
    i11 = 0;
    i7 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i7 = i6;
    while (1) {
     while (1) {
      i6 = i5 + 4 | 0;
      if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0) i5 = i6; else break;
     }
     do i4 = i4 + -4 | 0; while (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i4 = i7;
      break L35;
     }
     i13 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i13;
     i7 = (i7 | 0) == (i5 | 0) ? i4 : i7;
     i5 = i6;
     i3 = i3 + 1 | 0;
    }
   } else i4 = i6; while (0);
   if ((i5 | 0) != (i4 | 0)) if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) {
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i13;
    i3 = i3 + 1 | 0;
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIR15ReflProbeSorterPP15ReflectionProbeEEbT0_S6_T_(i1, i5, i12) | 0;
    i4 = i5 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIR15ReflProbeSorterPP15ReflectionProbeEEbT0_S6_T_(i4, i2, i12) | 0) {
     i11 = 51;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i8 | 0) >= (i9 - i13 | 0)) {
    i11 = 50;
    break;
   }
   __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_(i1, i5, i12);
   i1 = i5 + 4 | 0;
  }
  if ((i11 | 0) == 50) {
   i11 = 0;
   __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_(i5 + 4 | 0, i2, i12);
   i2 = i5;
   continue;
  } else if ((i11 | 0) == 51) {
   i11 = 0;
   if (i3) {
    i11 = 52;
    break;
   } else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i11 | 0) == 5) {
  if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) return;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i13;
  return;
 } else if ((i11 | 0) == 7) {
  __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i1, i1 + 4 | 0, i10, i12) | 0;
  return;
 } else if ((i11 | 0) == 8) {
  __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i10, i12) | 0;
  return;
 } else if ((i11 | 0) == 9) {
  __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i10, i12) | 0;
  return;
 } else if ((i11 | 0) == 11) {
  i4 = i1 + 8 | 0;
  __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i1, i1 + 4 | 0, i4, i12) | 0;
  i3 = i1 + 12 | 0;
  if ((i3 | 0) == (i2 | 0)) return;
  while (1) {
   if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i7 = i6;
    i5 = i3;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     if ((i4 | 0) == (i1 | 0)) break;
     i5 = i4 + -4 | 0;
     if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i12, i7, HEAP32[i5 >> 2] | 0) | 0) {
      i13 = i4;
      i4 = i5;
      i5 = i13;
     } else break;
    }
    HEAP32[i4 >> 2] = i6;
   }
   i4 = i3 + 4 | 0;
   if ((i4 | 0) == (i2 | 0)) break; else {
    i13 = i3;
    i3 = i4;
    i4 = i13;
   }
  }
  return;
 } else if ((i11 | 0) == 52) return;
}

function __ZN5physx2Sc8ClothSim19addCollisionCapsuleEPKNS0_8ShapeSimE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 128 | 0;
 i2 = i15 + 100 | 0;
 i3 = i15 + 72 | 0;
 i11 = i15 + 40 | 0;
 i6 = i15 + 32 | 0;
 i10 = i15 + 24 | 0;
 i7 = i15 + 16 | 0;
 i8 = HEAP32[i13 + 84 >> 2] | 0;
 i9 = HEAP32[i13 + 52 >> 2] | 0;
 i4 = i13 + 88 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + (HEAP32[i9 + 76 >> 2] | 0) | 0;
 if (i5 >>> 0 > 31) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 227, gb + 719639 | 0, i15);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = (i1 << 1) + i8 + (HEAP32[i9 + 72 >> 2] | 0) | 0;
 if (i1 >>> 0 > 31) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 234, gb + 719690 | 0, i15 + 8 | 0);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i24 = HEAP32[i14 + 28 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i2, i9);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i3, i14);
 f18 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f28 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 f27 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 f30 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f26 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i2 + 20 >> 2]));
 f29 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f26 = Math_fround(f26 * Math_fround(2.0));
 f29 = Math_fround(Math_fround(f29 - Math_fround(HEAPF32[i2 + 24 >> 2])) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
 f20 = Math_fround(Math_fround(Math_fround(f16 * f18) + Math_fround(f26 * f28)) + Math_fround(f29 * f27));
 f19 = Math_fround(Math_fround(f20 * f18) + Math_fround(Math_fround(f25 * f16) + Math_fround(f30 * Math_fround(Math_fround(f29 * f28) - Math_fround(f26 * f27)))));
 f21 = Math_fround(Math_fround(f20 * f28) + Math_fround(Math_fround(f25 * f26) + Math_fround(f30 * Math_fround(Math_fround(f16 * f27) - Math_fround(f29 * f18)))));
 f20 = Math_fround(Math_fround(Math_fround(f25 * f29) + Math_fround(f30 * Math_fround(Math_fround(f26 * f18) - Math_fround(f16 * f28)))) + Math_fround(f20 * f27));
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 f26 = Math_fround(f30 * f16);
 f29 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f29 * f18));
 f25 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f25 * f28));
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f26 = Math_fround(f26 - Math_fround(f17 * f27));
 f22 = Math_fround(Math_fround(Math_fround(f16 * f27) + Math_fround(Math_fround(f29 * f28) + Math_fround(f30 * f17))) - Math_fround(f25 * f18));
 f23 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(Math_fround(f29 * f27) + Math_fround(f30 * f25))) - Math_fround(f16 * f28));
 f27 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f29) - Math_fround(f16 * f18)) - Math_fround(f17 * f28)) - Math_fround(f25 * f27));
 f25 = Math_fround(Math_fround(HEAPF32[i24 + 76 >> 2]) * Math_fround(2.0));
 f28 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f17 = Math_fround(f22 * Math_fround(0.0));
 f18 = Math_fround(f23 * Math_fround(0.0));
 f16 = Math_fround(f18 + Math_fround(Math_fround(f25 * f26) + f17));
 f18 = Math_fround(Math_fround(f26 * f16) + Math_fround(Math_fround(f25 * f28) + Math_fround(f27 * Math_fround(f17 - f18))));
 f28 = Math_fround(f28 * Math_fround(0.0));
 f26 = Math_fround(f26 * Math_fround(0.0));
 f17 = Math_fround(Math_fround(f28 + Math_fround(f27 * Math_fround(Math_fround(f25 * f23) - f26))) + Math_fround(f22 * f16));
 f16 = Math_fround(Math_fround(f28 + Math_fround(f27 * Math_fround(f26 - Math_fround(f25 * f22)))) + Math_fround(f23 * f16));
 i3 = HEAP32[i24 + 72 >> 2] | 0;
 f23 = Math_fround(f21 - f17);
 f22 = Math_fround(f20 - f16);
 HEAPF32[i11 >> 2] = Math_fround(f19 - f18);
 HEAPF32[i11 + 4 >> 2] = f23;
 HEAPF32[i11 + 8 >> 2] = f22;
 HEAP32[i11 + 12 >> 2] = i3;
 f17 = Math_fround(f21 + f17);
 f16 = Math_fround(f20 + f16);
 HEAPF32[i11 + 16 >> 2] = Math_fround(f19 + f18);
 HEAPF32[i11 + 20 >> 2] = f17;
 HEAPF32[i11 + 24 >> 2] = f16;
 HEAP32[i11 + 28 >> 2] = i3;
 i3 = i9 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i6 >> 2] = i11;
 HEAP32[i6 + 4 >> 2] = i11 + 32;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 mftCall_viiii(i9 | 0, i2 | 0, i12 | 0, i1 | 0, i1 | 0);
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i1 + 1;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0;
 HEAP32[i7 >> 2] = i10;
 HEAP32[i7 + 4 >> 2] = i10 + 8;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i3 | 0, i1 | 0, i12 | 0, i5 | 0, i5 | 0);
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i5 + 1;
 i5 = i5 + i8 | 0;
 i1 = i13 + 116 | 0;
 HEAP32[i12 >> 2] = 0;
 i3 = i13 + 120 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i13 + 124 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i12) | 0;
  i4 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i24 = HEAP32[i4 >> 2] | 0;
  HEAP32[i24 + (i1 << 2) >> 2] = HEAP32[i24 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i24 = i1;
   i1 = i2;
   i2 = i24;
  } else break;
 }
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = i14;
 i24 = 1;
 STACKTOP = i15;
 return i24 | 0;
}

function __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 24 | 0;
 i5 = i16 + 20 | 0;
 i13 = i16;
 i7 = i16 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i12 = __Z12GetGfxDevicev() | 0;
 HEAP32[i9 >> 2] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 868 >> 2] | 0, i12 | 0) | 0;
 i12 = i13 + 8 | 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, 4, i13, i12);
 HEAP32[i9 >> 2] = HEAP32[i14 + 36 >> 2];
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, 4, i13, i12);
 i6 = i14 + 172 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) i8 = 20; else {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i8 = 9;
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
    i8 = 20;
    break;
   }
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i8 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 18;
   }
  }
  if ((i8 | 0) == 16) i8 = 18;
  if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = i1 + 80 | 0;
 } while (0);
 if ((i8 | 0) == 20) i1 = i14 + 52 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i7, 4, i13, i12);
 i1 = i14 + 140 | 0;
 HEAP8[i9 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, 1, i13, i12);
 HEAP32[i9 >> 2] = __Z19GetActiveColorSpacev() | 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, 4, i13, i12);
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP8[i1 >> 0] ^ 1; else i1 = 0;
 HEAP8[i9 >> 0] = i1;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, 1, i13, i12);
 i10 = i15 + 40 | 0;
 i11 = i15 + 52 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 L34 : do if (i5 | 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  i8 = i13;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i12;
  i9 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = 0;
  while (1) {
   i3 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
   i4 = i3;
   if ((HEAP32[i4 >> 2] | 0) == (i7 | 0) ? (HEAP32[i4 + 4 >> 2] | 0) == (i8 | 0) : 0) {
    i4 = i3 + 8 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i9 | 0) ? (HEAP32[i4 + 4 >> 2] | 0) == (i2 | 0) : 0) {
     i4 = i3 + 16 | 0;
     if (HEAP8[i4 >> 0] | 0) break;
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L34;
  }
  HEAP8[i4 >> 0] = 0;
  i15 = i3;
  STACKTOP = i16;
  return i15 | 0;
 } while (0);
 i7 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63536 | 0, 16, gb + 380852 | 0, 668) | 0;
 __ZN13ProbeRendererC2Ev(i7);
 i8 = i7;
 i9 = i13;
 i13 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i1;
 HEAP8[i7 + 16 >> 0] = 0;
 i13 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 8;
 i1 = __Z15GetGraphicsCapsv() | 0;
 if (i13) if (!(HEAP8[i1 + 704 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 726 >> 0] | 0) != 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 20;
 HEAP32[i7 + 20 >> 2] = __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb(i14, i1) | 0;
 i13 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 8;
 i1 = __Z15GetGraphicsCapsv() | 0;
 if (i13) if (!(HEAP8[i1 + 704 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 726 >> 0] | 0) != 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 20;
 HEAP32[i7 + 24 >> 2] = __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb(i14, i1) | 0;
 HEAP8[i7 + 28 >> 0] = 1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = i15 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i15 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i15 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i10 >> 2] = i15;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i3;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i8;
 i15 = i7;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 188820 + 8;
 i3 = i4 + 8 | 0;
 i2 = i4 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 116 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 132 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 148 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 160 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 164 >> 2] = 1;
 HEAP32[i4 + 168 >> 2] = 1;
 HEAP32[i4 + 172 >> 2] = 2592e3;
 HEAP32[i4 + 176 >> 2] = 20;
 HEAP32[i4 + 180 >> 2] = 60;
 i2 = i4 + 184 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 196 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046961 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046961 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046961 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046961 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046961 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046961 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i4 + 200 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046968 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046968 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046968 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046968 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046968 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046968 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i4 + 216 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046975 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046975 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046975 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046975 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046975 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046975 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i4 + 232 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 244 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 248 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 260 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 264 >> 2] = 0;
 HEAP32[i4 + 268 >> 2] = 0;
 HEAP32[i4 + 272 >> 2] = 0;
 HEAP32[i4 + 276 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 280 >> 2] = 0;
 HEAP32[i4 + 284 >> 2] = 1;
 i2 = i4 + 296 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 308 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 312 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 324 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 328 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 340 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i4 + 344 >> 0] = 0;
 HEAP8[i4 + 345 >> 0] = 0;
 __ZN11UnityEngine7Connect18ConnectSessionInfoC2Ev(i4 + 352 | 0);
 __ZN11UnityEngine7Connect13ConnectConfigC2Ev(i4 + 548 | 0);
 HEAP32[i4 + 660 >> 2] = i1;
 HEAP32[i4 + 664 >> 2] = 0;
 HEAP32[i4 + 668 >> 2] = 0;
 HEAP32[i4 + 672 >> 2] = 0;
 HEAP32[i4 + 676 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 113 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP8[i4 + 112 >> 0] = 1;
 HEAP8[i4 + 111 >> 0] = 0;
 HEAP8[i4 + 109 >> 0] = 0;
 HEAP8[i4 + 110 >> 0] = 0;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 292 >> 2] = 0;
 i2 = i1;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 44 >> 0] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63160 | 0, 16, gb + 1042345 | 0, 56) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = i3 + 4;
 HEAP32[i3 + 16 >> 2] = 1;
 HEAP32[i4 + 544 >> 2] = i3;
 return;
}

function __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_(i17, i16, i15, i14, i1, i13) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 f11 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[gb + 158836 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[gb + 158848 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 158836 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[gb + 158848 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 158848 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 158836 >> 2]);
 if (!i14) return;
 f9 = Math_fround(Math_fround(Math_fround(f6 * f2) - Math_fround(f3 * f7)) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(f3 * f4) - Math_fround(f2 * f5)) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(Math_fround(f7 * f5) - Math_fround(f6 * f4)) * Math_fround(2.0));
 i1 = 0;
 do {
  f4 = Math_fround(HEAPF32[i15 + (i1 * 148 | 0) + 76 >> 2]);
  f2 = Math_fround(HEAPF32[i17 + (i1 * 48 | 0) + 20 >> 2]);
  if (f4 > Math_fround(0.0)) {
   f7 = Math_fround(f4 * Math_fround(HEAPF32[i17 + (i1 * 48 | 0) + 24 >> 2]));
   f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i17 + (i1 * 48 | 0) + 32 >> 2])));
  } else {
   f7 = Math_fround(f4 * Math_fround(HEAPF32[i17 + (i1 * 48 | 0) + 28 >> 2]));
   f2 = Math_fround(f2 - Math_fround(f7 * Math_fround(HEAPF32[i17 + (i1 * 48 | 0) + 36 >> 2])));
  }
  f24 = Math_fround(f11 + Math_fround(HEAPF32[i17 + 784 + (i1 * 12 | 0) >> 2]));
  f28 = Math_fround(f12 + Math_fround(HEAPF32[i17 + 784 + (i1 * 12 | 0) + 4 >> 2]));
  f7 = Math_fround(f10 + Math_fround(HEAPF32[i17 + 784 + (i1 * 12 | 0) + 8 >> 2]));
  f5 = Math_fround(f4 * Math_fround(HEAPF32[i17 + 640 + (i1 * 12 | 0) >> 2]));
  f6 = Math_fround(f4 * Math_fround(HEAPF32[i17 + 640 + (i1 * 12 | 0) + 4 >> 2]));
  f5 = Math_fround(f24 - f5);
  f6 = Math_fround(f28 - f6);
  f7 = Math_fround(f7 - Math_fround(f4 * Math_fround(HEAPF32[i17 + 640 + (i1 * 12 | 0) + 8 >> 2])));
  f28 = Math_fround(Math_fround(HEAPF32[i15 + (i1 * 148 | 0) + 116 >> 2]) * Math_fround(.5));
  f24 = Math_fround(+Math_sin(+f28));
  f28 = Math_fround(+Math_cos(+f28));
  f4 = Math_fround(f24 * Math_fround(HEAPF32[gb + 158848 >> 2]));
  f27 = Math_fround(f24 * Math_fround(HEAPF32[gb + 158848 + 4 >> 2]));
  f24 = Math_fround(f24 * Math_fround(HEAPF32[gb + 158848 + 8 >> 2]));
  f23 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
  f22 = Math_fround(Math_fround(Math_fround(f9 * f4) + Math_fround(f8 * f27)) + Math_fround(f3 * f24));
  f19 = Math_fround(f2 * Math_fround(.5));
  f20 = Math_fround(+Math_sin(+f19));
  f19 = Math_fround(+Math_cos(+f19));
  f2 = Math_fround(f20 * Math_fround(Math_fround(f4 * f22) + Math_fround(Math_fround(f9 * f23) + Math_fround(f28 * Math_fround(Math_fround(f3 * f27) - Math_fround(f8 * f24))))));
  f18 = Math_fround(f20 * Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f8 * f23) + Math_fround(f28 * Math_fround(Math_fround(f9 * f24) - Math_fround(f3 * f4))))));
  f22 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(f28 * Math_fround(Math_fround(f8 * f4) - Math_fround(f9 * f27)))) + Math_fround(f24 * f22)));
  f23 = Math_fround(Math_fround(Math_fround(f24 * f18) + Math_fround(Math_fround(f4 * f19) + Math_fround(f28 * f2))) - Math_fround(f27 * f22));
  f20 = Math_fround(Math_fround(Math_fround(f4 * f22) + Math_fround(Math_fround(f27 * f19) + Math_fround(f28 * f18))) - Math_fround(f24 * f2));
  f26 = Math_fround(Math_fround(Math_fround(f27 * f2) + Math_fround(Math_fround(f24 * f19) + Math_fround(f28 * f22))) - Math_fround(f4 * f18));
  f22 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f19) - Math_fround(f4 * f2)) - Math_fround(f27 * f18)) - Math_fround(f24 * f22));
  f24 = Math_fround(HEAPF32[i16 + 32 + (i1 << 2) >> 2]);
  f18 = Math_fround(Math_fround(HEAPF32[gb + 158836 >> 2]) * Math_fround(2.0));
  f2 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 4 >> 2]) * Math_fround(2.0));
  f27 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 8 >> 2]) * Math_fround(2.0));
  f4 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
  f19 = Math_fround(Math_fround(f27 * f26) + Math_fround(Math_fround(f18 * f23) + Math_fround(f2 * f20)));
  f24 = Math_fround(f24 * Math_fround(.5));
  f28 = Math_fround(+Math_sin(+f24));
  f24 = Math_fround(+Math_cos(+f24));
  f21 = Math_fround(f28 * Math_fround(Math_fround(f23 * f19) + Math_fround(Math_fround(f18 * f4) + Math_fround(f22 * Math_fround(Math_fround(f27 * f20) - Math_fround(f2 * f26))))));
  f25 = Math_fround(f28 * Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f2 * f4) + Math_fround(f22 * Math_fround(Math_fround(f18 * f26) - Math_fround(f27 * f23))))));
  f19 = Math_fround(f28 * Math_fround(Math_fround(Math_fround(f27 * f4) + Math_fround(f22 * Math_fround(Math_fround(f2 * f23) - Math_fround(f18 * f20)))) + Math_fround(f26 * f19)));
  f18 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(Math_fround(f24 * f20) + Math_fround(f22 * f25))) - Math_fround(f26 * f21));
  f2 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(Math_fround(f24 * f26) + Math_fround(f22 * f19))) - Math_fround(f23 * f25));
  f4 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f22) - Math_fround(f23 * f21)) - Math_fround(f20 * f25)) - Math_fround(f26 * f19));
  HEAPF32[i13 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * f21))) - Math_fround(f20 * f19));
  HEAPF32[i13 + (i1 * 28 | 0) + 4 >> 2] = f18;
  HEAPF32[i13 + (i1 * 28 | 0) + 8 >> 2] = f2;
  HEAPF32[i13 + (i1 * 28 | 0) + 12 >> 2] = f4;
  HEAPF32[i13 + (i1 * 28 | 0) + 16 >> 2] = f5;
  HEAPF32[i13 + (i1 * 28 | 0) + 20 >> 2] = f6;
  HEAPF32[i13 + (i1 * 28 | 0) + 24 >> 2] = f7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i14 | 0));
 return;
}

function __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii(i17, i5, i18, i2, i3, i1, i19, i20, i21) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 i12 = i17 + 860 | 0;
 i13 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i18) | 0;
 i14 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i12 >> 2] | 0, i2) | 0;
 i15 = (i3 | 0) > 1;
 if (i15) {
  switch (i2 | 0) {
  case 50:
  case 49:
  case 46:
  case 45:
   {
    i1 = 16;
    break;
   }
  case 52:
  case 51:
  case 48:
  case 47:
   {
    i1 = (i18 | 0) == 2 ? 8 : 16;
    break;
   }
  default:
   i1 = HEAP32[i14 + 12 >> 2] & 2 | 0 ? 4 : 1;
  }
  i11 = __Z22CalculateMipMapCount3Diii(i1, i1, i1) | 0;
  i11 = (i11 | 0) > (i3 | 0) ? 1 : i3 + 1 - i11 | 0;
 } else i11 = i3;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 714 >> 0] | 0) != 0;
 i2 = i2 ? i3 : i11;
 i7 = i17 + 1600 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i17 + 1604 + (i9 << 2) >> 2] | 0;
 i9 = HEAP32[i17 + 1732 + (i9 << 2) >> 2] | 0;
 i10 = i17 + 1992 | 0;
 if (!((HEAP8[i10 >> 0] | 0) != 0 & (i8 | 0) == (i5 | 0))) {
  i3 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i18) | 0;
  mftCall_vii(HEAP32[i17 + 812 >> 2] | 0, i3 | 0, i5 | 0);
  HEAP32[i17 + 1604 + (HEAP32[i7 >> 2] << 2) >> 2] = i5;
  HEAP32[i17 + 1732 + (HEAP32[i7 >> 2] << 2) >> 2] = i18;
 }
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 684 >> 0] | 0) {
  HEAP32[i4 >> 2] = 0;
  mftCall_viii(HEAP32[i17 + 96 >> 2] | 0, i13 | 0, 37167, i4 | 0);
  if ((HEAP32[i4 >> 2] | 0) != 1) break;
  if (!(HEAP8[i10 >> 0] | 0)) i6 = 12; else if ((HEAP32[i17 + 1604 + (HEAP32[i7 >> 2] << 2) >> 2] | 0) != (i8 | 0)) i6 = 12;
  if ((i6 | 0) == 12) {
   i21 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i9) | 0;
   mftCall_vii(HEAP32[i17 + 812 >> 2] | 0, i21 | 0, i8 | 0);
   HEAP32[i17 + 1604 + (HEAP32[i7 >> 2] << 2) >> 2] = i8;
   HEAP32[i17 + 1732 + (HEAP32[i7 >> 2] << 2) >> 2] = i9;
  }
  STACKTOP = i16;
  return i11 | 0;
 } while (0);
 i1 = i17 + 180 | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, i13 | 0, 10241, (i15 ? 9984 : 9728) | 0);
 mftCall_viii(HEAP32[i1 >> 2] | 0, i13 | 0, 10240, 9728);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 686 >> 0] | 0) mftCall_viii(HEAP32[i1 >> 2] | 0, i13 | 0, 33084, 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 154 >> 0] | 0) mftCall_viii(HEAP32[i1 >> 2] | 0, i13 | 0, 33085, i11 + -1 | 0);
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 L29 : do if (!(i1 & 4)) {
  L31 : do if (!(i1 & 1)) {
   i3 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1;
   i2 = i14 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i3 ? i1 : HEAP32[i14 >> 2] | 0;
   switch (i18 | 0) {
   case 4:
    {
     i18 = i17 + 176 | 0;
     i21 = i14 + 8 | 0;
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34069, 0, i3 | 0, i19 | 0, i20 | 0, 0, i1 | 0, HEAP32[i21 >> 2] | 0, 0);
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34070, 0, i3 | 0, i19 | 0, i20 | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, 0);
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34071, 0, i3 | 0, i19 | 0, i20 | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, 0);
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34072, 0, i3 | 0, i19 | 0, i20 | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, 0);
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34073, 0, i3 | 0, i19 | 0, i20 | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, 0);
     mftCall_viiiiiiiii(HEAP32[i18 >> 2] | 0, 34074, 0, i3 | 0, i19 | 0, i20 | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, 0);
     break L31;
    }
   case 2:
    {
     mftCall_viiiiiiiii(HEAP32[i17 + 176 >> 2] | 0, i13 | 0, 0, i3 | 0, i19 | 0, i20 | 0, 0, i1 | 0, HEAP32[i14 + 8 >> 2] | 0, 0);
     break L31;
    }
   case 6:
   case 5:
   case 3:
    {
     mftCall_viiiiiiiiii(HEAP32[i17 + 572 >> 2] | 0, i13 | 0, 0, i3 | 0, i19 | 0, i20 | 0, i21 | 0, 0, i1 | 0, HEAP32[i14 + 8 >> 2] | 0, 0);
     break L31;
    }
   default:
    break L31;
   }
  } else switch (i18 | 0) {
  case 4:
   {
    i21 = i17 + 184 | 0;
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34069, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34070, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34071, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34072, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34073, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    mftCall_viiiiiiii(HEAP32[i21 >> 2] | 0, 34074, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    break L31;
   }
  case 2:
   {
    mftCall_viiiiiiii(HEAP32[i17 + 184 >> 2] | 0, i13 | 0, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, 0, 0, 0);
    break L31;
   }
  case 6:
  case 5:
  case 3:
   {
    mftCall_viiiiiiiii(HEAP32[i17 + 592 >> 2] | 0, i13 | 0, 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, i21 | 0, 0, 0, 0);
    break L31;
   }
  default:
   break L31;
  } while (0);
  if (i15) mftCall_vi(HEAP32[i17 + 612 >> 2] | 0, i13 | 0);
 } else switch (i18 | 0) {
 case 3:
 case 5:
 case 6:
  {
   mftCall_viiiiii(HEAP32[i17 + 588 >> 2] | 0, i13 | 0, i2 | 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0, i21 | 0);
   break L29;
  }
 default:
  {
   mftCall_viiiii(HEAP32[i17 + 584 >> 2] | 0, i13 | 0, i2 | 0, HEAP32[i14 >> 2] | 0, i19 | 0, i20 | 0);
   break L29;
  }
 } while (0);
 if (HEAP8[i10 >> 0] | 0) if ((HEAP32[i17 + 1604 + (HEAP32[i7 >> 2] << 2) >> 2] | 0) == (i8 | 0)) {
  STACKTOP = i16;
  return i11 | 0;
 }
 i21 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i9) | 0;
 mftCall_vii(HEAP32[i17 + 812 >> 2] | 0, i21 | 0, i8 | 0);
 HEAP32[i17 + 1604 + (HEAP32[i7 >> 2] << 2) >> 2] = i8;
 HEAP32[i17 + 1732 + (HEAP32[i7 >> 2] << 2) >> 2] = i9;
 STACKTOP = i16;
 return i11 | 0;
}

function __Z30AudioMixerFaderProcessCallbackP21UnityAudioEffectStatePfS1_jii(i1, i5, i17, i20, i2, i18) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i17 = i17 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i21 = 0, i22 = 0;
 i19 = HEAP32[i1 + 28 >> 2] | 0;
 i16 = i19 + 28 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (!(i1 & 1)) i13 = 10; else {
  f4 = Math_fround(HEAPF32[i19 >> 2]);
  if (!(Math_fround(Math_abs(Math_fround(f4 + Math_fround(-1.0)))) >= Math_fround(.00100000005))) i13 = 10; else {
   i12 = i19 + 4 | 0;
   f3 = Math_fround(HEAPF32[i12 >> 2]);
   f4 = Math_fround(Math_fround(f4 - f3) / Math_fround(i20 >>> 0));
   L4 : do if (i20) {
    if ((i18 | 0) > 0) {
     i9 = i17;
     i8 = 0;
    } else {
     i2 = 0;
     while (1) {
      f3 = Math_fround(f4 + f3);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break L4;
     }
    }
    while (1) {
     i2 = 0;
     i6 = i5;
     i5 = i5 + (i18 << 2) | 0;
     i7 = i9;
     while (1) {
      HEAPF32[i7 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]));
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i18 | 0)) break; else {
       i6 = i6 + 4 | 0;
       i7 = i7 + 4 | 0;
      }
     }
     f3 = Math_fround(f4 + f3);
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == (i20 | 0)) break; else i9 = i9 + (i18 << 2) | 0;
    }
   } while (0);
   HEAPF32[i12 >> 2] = f3;
  }
 }
 if ((i13 | 0) == 10) if ((i17 | 0) != (i5 | 0)) {
  _memcpy(i17 | 0, i5 | 0, Math_imul(i20 << 2, i18) | 0) | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 do if (i1 & 2 | 0) {
  i15 = (i18 | 0) > 8 ? 8 : i18;
  i12 = (i20 | 0) == 0;
  if (!i12) {
   i13 = i19 + 236 | 0;
   i14 = i19 + 240 | 0;
   i7 = i19 + 8 | 0;
   i8 = i19 + 24 | 0;
   i9 = i19 + 16 | 0;
   if ((i18 | 0) > 0) {
    i1 = i17;
    i6 = 0;
    do {
     i5 = 0;
     f10 = Math_fround(0.0);
     f11 = Math_fround(0.0);
     do {
      i2 = i1;
      i1 = i1 + 4 | 0;
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      f4 = Math_fround(f4 * f4);
      i2 = i19 + 36 + (i5 * 24 | 0) + 8 | 0;
      f3 = Math_fround(HEAPF32[i2 >> 2]);
      f4 = Math_fround(f4 - f3);
      f4 = Math_fround(f3 + Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2])) + Math_fround(1.00000002e-16)));
      HEAPF32[i2 >> 2] = f4;
      i2 = i19 + 36 + (i5 * 24 | 0) + 12 | 0;
      f3 = Math_fround(HEAPF32[i2 >> 2]);
      if (f4 > f3) {
       HEAPF32[i2 >> 2] = f4;
       HEAP32[i19 + 36 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i8 >> 2];
       f3 = f4;
      } else {
       i22 = i19 + 36 + (i5 * 24 | 0) + 20 | 0;
       i21 = HEAP32[i22 >> 2] | 0;
       HEAP32[i22 >> 2] = i21 + -1;
       if ((i21 | 0) < 1) {
        f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i9 >> 2])) + Math_fround(1.00000002e-16));
        HEAPF32[i2 >> 2] = f3;
       }
      }
      f11 = Math_fround(_fmaxf(f11, f4));
      f10 = Math_fround(_fmaxf(f10, f3));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i15 | 0));
     HEAPF32[i13 >> 2] = f11;
     HEAPF32[i14 >> 2] = f10;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i20 | 0));
   } else {
    i1 = 0;
    do i1 = i1 + 1 | 0; while ((i1 | 0) != (i20 | 0));
    HEAPF32[i13 >> 2] = Math_fround(0.0);
    HEAPF32[i14 >> 2] = Math_fround(0.0);
   }
   if (!i12) {
    i12 = i19 + 228 | 0;
    i13 = i19 + 232 | 0;
    i7 = i19 + 12 | 0;
    i8 = i19 + 24 | 0;
    i9 = i19 + 16 | 0;
    if ((i18 | 0) > 0) {
     i6 = 0;
     i1 = i17;
    } else {
     i1 = 0;
     do i1 = i1 + 1 | 0; while ((i1 | 0) != (i20 | 0));
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     HEAPF32[i13 >> 2] = Math_fround(0.0);
     break;
    }
    do {
     i5 = 0;
     f10 = Math_fround(0.0);
     f11 = Math_fround(0.0);
     do {
      i2 = i1;
      i1 = i1 + 4 | 0;
      f3 = Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2])));
      i2 = i19 + 36 + (i5 * 24 | 0) | 0;
      f4 = Math_fround(HEAPF32[i2 >> 2]);
      if (!(f3 >= f4)) f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2])) + Math_fround(1.00000002e-16)); else f4 = f3;
      HEAPF32[i2 >> 2] = f4;
      i2 = i19 + 36 + (i5 * 24 | 0) + 4 | 0;
      f3 = Math_fround(HEAPF32[i2 >> 2]);
      if (f4 > f3) {
       HEAPF32[i2 >> 2] = f4;
       HEAP32[i19 + 36 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i8 >> 2];
       f3 = f4;
      } else {
       i21 = i19 + 36 + (i5 * 24 | 0) + 16 | 0;
       i22 = HEAP32[i21 >> 2] | 0;
       HEAP32[i21 >> 2] = i22 + -1;
       if ((i22 | 0) < 1) {
        f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i9 >> 2])) + Math_fround(1.00000002e-16));
        HEAPF32[i2 >> 2] = f3;
       }
      }
      f11 = Math_fround(_fmaxf(f11, f4));
      f10 = Math_fround(_fmaxf(f10, f3));
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) < (i15 | 0));
     HEAPF32[i12 >> 2] = f11;
     HEAPF32[i13 >> 2] = f10;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i20 | 0));
   }
  }
 } while (0);
 if (!(HEAP32[i16 >> 2] & 4)) return 0;
 do if (i20 | 0) {
  i8 = i19 + 20 | 0;
  i7 = i19 + 8 | 0;
  if ((i18 | 0) > 0) {
   i6 = 0;
   i1 = i17;
   while (1) {
    f3 = Math_fround(0.0);
    i2 = 0;
    i5 = i1;
    while (1) {
     f3 = Math_fround(_fmaxf(f3, Math_fround(Math_abs(Math_fround(HEAPF32[i5 >> 2])))));
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i18 | 0)) break; else i5 = i5 + 4 | 0;
    }
    f11 = Math_fround(f3 * f3);
    f10 = Math_fround(HEAPF32[i8 >> 2]);
    f11 = Math_fround(f11 - f10);
    HEAPF32[i8 >> 2] = Math_fround(f10 + Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i7 >> 2])) + Math_fround(1.00000002e-16)));
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i20 | 0)) break; else i1 = i1 + (i18 << 2) | 0;
   }
  } else {
   f4 = Math_fround(HEAPF32[i8 >> 2]);
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   i1 = 0;
   do {
    f4 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(Math_fround(0.0) - f4) * f3) + Math_fround(1.00000002e-16)));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i20 | 0));
   HEAPF32[i8 >> 2] = f4;
   break;
  }
 } while (0);
 i1 = i19 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i22 = i2 - i20 | 0;
  HEAP32[i1 >> 2] = (i22 | 0) < 0 ? 0 : i22;
  return 0;
 } else return 0;
 return 0;
}

function __ZN5physx2Sc8ClothSim23addCollisionHeightfieldEPKNS0_8ShapeSimE(i19, i6) {
 i19 = i19 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i21 + 104 | 0;
 i20 = i21 + 56 | 0;
 i3 = i21 + 28 | 0;
 i5 = i21;
 i2 = (HEAP32[i19 + 88 >> 2] | 0) + (HEAP32[i19 + 84 >> 2] | 0) + (HEAP32[i19 + 92 >> 2] | 0) + (HEAP32[i19 + 96 >> 2] | 0) + (HEAP32[i19 + 100 >> 2] | 0) + (HEAP32[i19 + 104 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i3, HEAP32[i19 + 52 >> 2] | 0);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i5, i6);
 f14 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i3 + 4 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 f24 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f12 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 + 20 >> 2]));
 f25 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f12 = Math_fround(f12 * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f25 - Math_fround(HEAPF32[i3 + 24 >> 2])) * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f14) + Math_fround(f12 * f15)) + Math_fround(f25 * f10));
 f16 = Math_fround(Math_fround(f18 * f14) + Math_fround(Math_fround(f22 * f13) + Math_fround(f24 * Math_fround(Math_fround(f25 * f15) - Math_fround(f12 * f10)))));
 f17 = Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f22 * f12) + Math_fround(f24 * Math_fround(Math_fround(f13 * f10) - Math_fround(f25 * f14)))));
 f18 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(f24 * Math_fround(Math_fround(f12 * f14) - Math_fround(f13 * f15)))) + Math_fround(f18 * f10));
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(f24 * f13);
 f25 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f25 * f14));
 f22 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f22 * f15));
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f11 * f10));
 f23 = Math_fround(Math_fround(Math_fround(f13 * f10) + Math_fround(Math_fround(f25 * f15) + Math_fround(f24 * f11))) - Math_fround(f22 * f14));
 f7 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f25 * f10) + Math_fround(f24 * f22))) - Math_fround(f13 * f15));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f25) - Math_fround(f13 * f14)) - Math_fround(f11 * f15)) - Math_fround(f22 * f10));
 f22 = Math_fround(f12 + f12);
 f15 = Math_fround(f23 + f23);
 f11 = Math_fround(f7 + f7);
 f14 = Math_fround(f22 * f10);
 f13 = Math_fround(f10 * f15);
 f10 = Math_fround(f10 * f11);
 f25 = Math_fround(f12 * f15);
 f24 = Math_fround(f12 * f11);
 f15 = Math_fround(f23 * f15);
 f23 = Math_fround(f23 * f11);
 f11 = Math_fround(f7 * f11);
 f7 = Math_fround(Math_fround(Math_fround(1.0) - f15) - f11);
 f8 = Math_fround(f10 + f25);
 f9 = Math_fround(f24 - f13);
 f10 = Math_fround(f25 - f10);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f22));
 f11 = Math_fround(f22 - f11);
 f12 = Math_fround(f14 + f23);
 f13 = Math_fround(f24 + f13);
 f14 = Math_fround(f23 - f14);
 f15 = Math_fround(f22 - f15);
 HEAPF32[i20 + 36 >> 2] = f16;
 HEAPF32[i20 + 40 >> 2] = f17;
 HEAPF32[i20 + 44 >> 2] = f18;
 f22 = Math_fround(HEAPF32[i4 + 80 >> 2]);
 f7 = Math_fround(f22 * f7);
 HEAPF32[i20 >> 2] = f7;
 f8 = Math_fround(f22 * f8);
 HEAPF32[i20 + 4 >> 2] = f8;
 f9 = Math_fround(f22 * f9);
 HEAPF32[i20 + 8 >> 2] = f9;
 f22 = Math_fround(HEAPF32[i4 + 76 >> 2]);
 f10 = Math_fround(f22 * f10);
 HEAPF32[i20 + 12 >> 2] = f10;
 f11 = Math_fround(f22 * f11);
 HEAPF32[i20 + 16 >> 2] = f11;
 f12 = Math_fround(f22 * f12);
 HEAPF32[i20 + 20 >> 2] = f12;
 f22 = Math_fround(HEAPF32[i4 + 84 >> 2]);
 f13 = Math_fround(f22 * f13);
 HEAPF32[i20 + 24 >> 2] = f13;
 f14 = Math_fround(f22 * f14);
 HEAPF32[i20 + 28 >> 2] = f14;
 f15 = Math_fround(f22 * f15);
 HEAPF32[i20 + 32 >> 2] = f15;
 i4 = i19 + 108 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i5 + 1;
 i5 = i2 + i5 | 0;
 i2 = i19 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i19 + 120 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i19 + 124 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] = 0;
  i1 = i3 + 1 | 0;
  HEAP32[i4 >> 2] = i1;
  i3 = i2;
  i2 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i2, i1) | 0;
  i3 = i2;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i4 = i1;
   i1 = i2;
   i2 = i4;
  } else break;
 }
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i6;
 i1 = i19 + 128 | 0;
 i2 = i19 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i19 + 136 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i20 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i20 + (i3 * 48 | 0) >> 2] = f7;
  HEAPF32[i20 + (i3 * 48 | 0) + 4 >> 2] = f8;
  HEAPF32[i20 + (i3 * 48 | 0) + 8 >> 2] = f9;
  HEAPF32[i20 + (i3 * 48 | 0) + 12 >> 2] = f10;
  HEAPF32[i20 + (i3 * 48 | 0) + 16 >> 2] = f11;
  HEAPF32[i20 + (i3 * 48 | 0) + 20 >> 2] = f12;
  HEAPF32[i20 + (i3 * 48 | 0) + 24 >> 2] = f13;
  HEAPF32[i20 + (i3 * 48 | 0) + 28 >> 2] = f14;
  HEAPF32[i20 + (i3 * 48 | 0) + 32 >> 2] = f15;
  HEAPF32[i20 + (i3 * 48 | 0) + 36 >> 2] = f16;
  HEAPF32[i20 + (i3 * 48 | 0) + 40 >> 2] = f17;
  HEAPF32[i20 + (i3 * 48 | 0) + 44 >> 2] = f18;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i21;
  return 1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Cm8Matrix34ENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i20) | 0;
  STACKTOP = i21;
  return 1;
 }
 return 0;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i29, i30, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33 + 60 | 0;
 i26 = i33 + 56 | 0;
 i32 = i33 + 28 | 0;
 i27 = i33;
 i28 = i29 + 16 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i25 = i29 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i25 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i28, i26, 4); else {
  HEAP32[i26 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i28 >> 2] = i2;
 };
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i32 + 24 >> 2] = 0;
 HEAP32[i32 + 16 >> 2] = 0;
 i11 = i32 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i30 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i30, HEAP32[i12 >> 2] | 0);
 i13 = i30 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i30 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 if ((HEAP32[i26 >> 2] | 0) > 0) {
  i14 = i32 + 16 | 0;
  i15 = i32 + 24 | 0;
  i1 = i32 + 11 | 0;
  i16 = i32 + 4 | 0;
  i17 = i27 + 12 | 0;
  i10 = i27 + 12 | 0;
  i18 = i31 + 4 | 0;
  i19 = i27 + 8 | 0;
  i20 = i27 + 4 | 0;
  i21 = i27 + 16 | 0;
  i22 = i30 + 4 | 0;
  i23 = i27 + 11 | 0;
  i24 = i31 + 4 | 0;
  i9 = 0;
  do {
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i29, i32, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i29);
   i2 = HEAP32[i28 >> 2] | 0;
   i3 = i2 + 4 | 0;
   i4 = HEAP32[i25 >> 2] | 0;
   if (i3 >>> 0 > i4 >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i28, i14, 4);
    i3 = HEAP32[i28 >> 2] | 0;
    i4 = HEAP32[i25 >> 2] | 0;
   } else {
    HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i28 >> 2] = i3;
   }
   i2 = i3 + 4 | 0;
   if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i28, i11, 4); else {
    HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i28 >> 2] = i2;
   }
   __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i29);
   i4 = HEAP8[i1 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i32 >> 2] | 0 : i32;
   i4 = i2 ? HEAP32[i16 >> 2] | 0 : i4 & 255;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i27 + 4 >> 2] = 0;
   HEAP32[i27 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i17 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = 19;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i23 >> 0] = i4;
    if (!i4) i2 = i27; else {
     i2 = i27;
     i5 = 21;
    }
   } else i5 = 19;
   if ((i5 | 0) == 19) {
    i8 = i4 + 16 & -16;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i18 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i27 >> 2] = i2;
    HEAP32[i19 >> 2] = i8 | -2147483648;
    HEAP32[i20 >> 2] = i4;
    i5 = 21;
   }
   if ((i5 | 0) == 21) {
    i5 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i21 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i2 = HEAP32[i12 >> 2] | 0;
   do if (!i2) {
    i3 = i12;
    i4 = i12;
   } else {
    i7 = HEAP8[i23 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i20 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i27 >> 2] | 0 : i27;
    while (1) {
     i4 = i2 + 16 | 0;
     i6 = HEAP8[i4 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
     i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
     if (!i3) i5 = 26; else {
      i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
      if (!i3) i5 = 26; else if ((i3 | 0) < 0) i5 = 28; else i5 = 30;
     }
     if ((i5 | 0) == 26) if (i7 >>> 0 < i6 >>> 0) i5 = 28; else i5 = 30;
     if ((i5 | 0) == 28) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i5 = 29;
       break;
      } else i2 = i3;
     } else if ((i5 | 0) == 30) {
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i5 = 32;
       break;
      } else i2 = i3;
     }
    }
    if ((i5 | 0) == 29) {
     i5 = 0;
     i3 = i2;
     i4 = i2;
     break;
    } else if ((i5 | 0) == 32) {
     i5 = 0;
     i3 = i2;
     break;
    }
   } while (0);
   __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i31, i30, i27);
   i2 = HEAP32[i31 >> 2] | 0;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i30 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i22 >> 2] | 0, i2);
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   if ((HEAP8[i23 >> 0] | 0) < 0) {
    i8 = HEAP32[i27 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i31 >> 2] = 66;
    HEAP32[i24 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i31);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (HEAP32[i26 >> 2] | 0));
 } else i1 = i32 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i33;
  return;
 }
 i30 = HEAP32[i32 >> 2] | 0;
 i32 = HEAP32[i32 + 12 >> 2] | 0;
 HEAP32[i31 >> 2] = 66;
 HEAP32[i31 + 4 >> 2] = i32;
 __Z19free_alloc_internalPvRK10MemLabelId(i30, i31);
 STACKTOP = i33;
 return;
}

function __ZN17CapsuleCollider2D14CreateInternalEP11Rigidbody2D(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i28 + 240 | 0;
 i21 = i28 + 232 | 0;
 i22 = i28 + 52 | 0;
 i23 = i28 + 24 | 0;
 i24 = i28;
 i25 = i28 + 16 | 0;
 i26 = i28 + 8 | 0;
 if ((HEAP16[gb + 1457908 + 6 >> 1] | 0) > -1) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457908 | 0, i18);
  i19 = gb + 1457908 | 0;
 } else i19 = 0;
 i2 = HEAP32[i20 + 28 >> 2] | 0;
 if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
  __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i20, i21, i18, i1);
  f15 = Math_fround(Math_fround(HEAPF32[i20 + 160 >> 2]) * Math_fround(.5));
  f29 = Math_fround(Math_fround(HEAPF32[i20 + 164 >> 2]) * Math_fround(.5));
  f30 = Math_fround(HEAPF32[i20 + 40 >> 2]);
  f11 = Math_fround(f30 - f15);
  f5 = Math_fround(HEAPF32[i20 + 44 >> 2]);
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f10 = Math_fround(f11 * f9);
  f3 = Math_fround(HEAPF32[i18 + 16 >> 2]);
  f12 = Math_fround(f5 * f3);
  f10 = Math_fround(f10 + f12);
  f16 = Math_fround(Math_fround(HEAPF32[i18 + 32 >> 2]) * Math_fround(0.0));
  f10 = Math_fround(f10 + f16);
  f8 = Math_fround(HEAPF32[i18 + 48 >> 2]);
  f10 = Math_fround(f8 + f10);
  f7 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f11 = Math_fround(f11 * f7);
  f4 = Math_fround(HEAPF32[i18 + 20 >> 2]);
  f13 = Math_fround(f5 * f4);
  f11 = Math_fround(f11 + f13);
  f17 = Math_fround(Math_fround(HEAPF32[i18 + 36 >> 2]) * Math_fround(0.0));
  f11 = Math_fround(f11 + f17);
  f6 = Math_fround(HEAPF32[i18 + 52 >> 2]);
  f11 = Math_fround(f6 + f11);
  f15 = Math_fround(f15 + f30);
  f12 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(f15 * f9) + f12) + f16));
  f13 = Math_fround(f6 + Math_fround(Math_fround(Math_fround(f15 * f7) + f13) + f17));
  f15 = Math_fround(f5 - f29);
  f9 = Math_fround(f30 * f9);
  f14 = Math_fround(f8 + Math_fround(Math_fround(f9 + Math_fround(f15 * f3)) + f16));
  f7 = Math_fround(f30 * f7);
  f15 = Math_fround(f6 + Math_fround(Math_fround(f7 + Math_fround(f15 * f4)) + f17));
  f5 = Math_fround(f29 + f5);
  f16 = Math_fround(f8 + Math_fround(Math_fround(f9 + Math_fround(f5 * f3)) + f16));
  f17 = Math_fround(f6 + Math_fround(Math_fround(f7 + Math_fround(f5 * f4)) + f17));
  f4 = Math_fround(f12 - f10);
  f5 = Math_fround(f13 - f11);
  f7 = Math_fround(f16 - f14);
  f6 = Math_fround(f17 - f15);
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))));
  if (f3 < Math_fround(1.1920929e-07)) f9 = Math_fround(0.0); else {
   f30 = Math_fround(Math_fround(1.0) / f3);
   f9 = f3;
   f4 = Math_fround(f4 * f30);
   f5 = Math_fround(f30 * f5);
  }
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6))));
  if (f3 < Math_fround(1.1920929e-07)) f8 = Math_fround(0.0); else {
   f30 = Math_fround(Math_fround(1.0) / f3);
   f8 = f3;
   f7 = Math_fround(f7 * f30);
   f6 = Math_fround(f6 * f30);
  }
  HEAP32[i22 >> 2] = gb + 151688 + 8;
  HEAP32[i22 + 28 >> 2] = gb + 151728 + 8;
  HEAP32[i22 + 32 >> 2] = 2;
  i2 = HEAP32[gb + 151644 >> 2] | 0;
  HEAP32[i22 + 36 >> 2] = i2;
  HEAP32[i22 + 176 >> 2] = 0;
  HEAPF32[i22 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i22 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i22 + 4 >> 2] = 4;
  HEAP32[i22 + 8 >> 2] = i2;
  i2 = i22 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP16[i23 + 22 >> 1] = 1;
  HEAP16[i23 + 24 >> 1] = -1;
  HEAP16[i23 + 26 >> 1] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAPF32[i23 + 8 >> 2] = Math_fround(.200000003);
  HEAPF32[i23 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i23 + 16 >> 2] = Math_fround(0.0);
  HEAP8[i23 + 20 >> 0] = 0;
  HEAP32[i23 >> 2] = i22;
  do if (!(HEAP32[i20 + 168 >> 2] | 0)) {
   f3 = Math_fround(f9 * Math_fround(.5));
   if (Math_fround(f3 * f3) < Math_fround(6.24999984e-06)) {
    HEAP32[i20 + 56 >> 2] = 1;
    break;
   }
   f30 = Math_fround(f8 + Math_fround(-.0000999999974));
   f30 = Math_fround((f8 > f9 ? f9 : f30) * Math_fround(.5));
   HEAPF32[i24 >> 2] = Math_fround(f4 * f3);
   HEAPF32[i24 + 4 >> 2] = Math_fround(f3 * f5);
   f29 = Math_fround(f7 * f30);
   f30 = Math_fround(f6 * f30);
   f15 = Math_fround(f15 + f30);
   HEAPF32[i25 >> 2] = Math_fround(f14 + f29);
   HEAPF32[i25 + 4 >> 2] = f15;
   f30 = Math_fround(f17 - f30);
   HEAPF32[i26 >> 2] = Math_fround(f16 - f29);
   HEAPF32[i26 + 4 >> 2] = f30;
   if (__ZN14b2CapsuleShape12SetByEndCapsEfRK6b2Vec2S2_S2_(i22, f3, i25, i26, i24) | 0) {
    i27 = 20;
    break;
   } else {
    HEAP32[i20 + 56 >> 2] = 1;
    break;
   }
  } else {
   f3 = Math_fround(f8 * Math_fround(.5));
   if (Math_fround(f3 * f3) < Math_fround(6.24999984e-06)) {
    HEAP32[i20 + 56 >> 2] = 1;
    break;
   }
   f30 = Math_fround(f9 + Math_fround(-.0000999999974));
   f30 = Math_fround((f9 > f8 ? f8 : f30) * Math_fround(.5));
   f29 = Math_fround(f4 * f30);
   f30 = Math_fround(f5 * f30);
   HEAPF32[i24 >> 2] = Math_fround(f3 * f7);
   HEAPF32[i24 + 4 >> 2] = Math_fround(f3 * f6);
   f17 = Math_fround(f11 + f30);
   HEAPF32[i25 >> 2] = Math_fround(f10 + f29);
   HEAPF32[i25 + 4 >> 2] = f17;
   f30 = Math_fround(f13 - f30);
   HEAPF32[i26 >> 2] = Math_fround(f12 - f29);
   HEAPF32[i26 + 4 >> 2] = f30;
   if (__ZN14b2CapsuleShape12SetByEndCapsEfRK6b2Vec2S2_S2_(i22, f3, i25, i26, i24) | 0) {
    i27 = 20;
    break;
   } else {
    HEAP32[i20 + 56 >> 2] = 1;
    break;
   }
  } while (0);
  if ((i27 | 0) == 20) __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i20, i18, i23, HEAP32[i21 >> 2] | 0, 0);
 }
 if (!i19) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i28;
 return;
}

function __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 }
 HEAP32[i7 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i7 + 36 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i7 + 44 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i7 + 45 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i8, i7 + 52 | 0, gb + 839093 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i8, i7 + 64 | 0, gb + 839116 | 0, 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i7 + 88 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i7 + 92 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i7 + 93 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i7 + 124 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i3 >> 2] = i10;
  i10 = i7 + 128 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  i10 = i7 + 148 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  i10 = i7 + 168 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  STACKTOP = i11;
  return;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  i10 = i6;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i3 >> 2] = i10;
  i10 = i7 + 128 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  i10 = i7 + 148 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  i10 = i7 + 168 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i8, i10, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN16ScriptingManager33RebuildNativeTypeToScriptingClassEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i6 = i17;
 i16 = i17 + 16 | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i16 >> 2] = 0;
 i9 = i16 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i6);
 i6 = i13;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i15;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i5;
 __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE(gb + 28304 | 0, i16, 0);
 i10 = i12 + 168 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = i12 + 172 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i5;
 if ((i1 | 0) == (i5 | 0)) i4 = i1; else {
  i4 = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2) | 0;
  HEAP32[i6 >> 2] = i4;
 }
 i3 = HEAP32[gb + 1106156 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 i1 = i4 - i2 >> 2;
 if (i3 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIP11Il2CppClassNS_9allocatorIS2_EEE8__appendEjRKS2_(i10, i3 - i1 | 0, i13); else if (i3 >>> 0 < i1 >>> 0) {
  i1 = i5 + (i3 << 2) | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i4 + (~((i4 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i12 + 200 >> 2] | 0;
 i11 = i12 + 204 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 i5 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66600 >> 2] | 0, gb + 590125 | 0) | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i6 = i13 + 4 | 0;
  i7 = i12 + 208 | 0;
  i8 = i12 + 200 | 0;
  i4 = 0;
  do {
   i3 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i2 = i3;
   while (1) {
    i1 = __ZL30FindScriptingClassForClassNamePKc(HEAP32[i2 + 8 >> 2] | 0) | 0;
    if (i1 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i5) | 0) break;
    if ((i2 | 0) == (gb + 28304 | 0)) {
     i1 = 0;
     break;
    }
    i2 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = i1;
   i1 = __ZL30FindScriptingClassForClassNamePKc(HEAP32[i3 + 8 >> 2] | 0) | 0;
   if (i1 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i5) | 0) {
    HEAP32[i13 >> 2] = i1;
    HEAP32[i6 >> 2] = i3;
    i1 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i8, i13); else {
     i18 = i13;
     i2 = HEAP32[i18 + 4 >> 2] | 0;
     i3 = i1;
     HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i3 + 4 >> 2] = i2;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
    }
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i1 = __ZL30FindScriptingClassForClassNamePKc(gb + 779307 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 29512;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12 + 200 | 0, i13); else {
   i9 = i13;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i18 = i1;
   HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i18 + 4 >> 2] = i10;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
  }
 }
 i1 = __ZL30FindScriptingClassForClassNamePKc(gb + 801622 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 29552;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12 + 200 | 0, i13); else {
   i9 = i13;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i18 = i1;
   HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i18 + 4 >> 2] = i10;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
  }
 }
 i1 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 44 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 29232;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12 + 200 | 0, i13); else {
   i9 = i13;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i18 = i1;
   HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i18 + 4 >> 2] = i10;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
  }
 }
 i1 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 36 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 29192;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12 + 200 | 0, i13); else {
   i9 = i13;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i18 = i1;
   HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i18 + 4 >> 2] = i10;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
  }
 }
 i1 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 88 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = gb + 29272;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i12 + 200 | 0, i13); else {
   i10 = i13;
   i13 = HEAP32[i10 + 4 >> 2] | 0;
   i18 = i1;
   HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i18 + 4 >> 2] = i13;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 8;
  }
 }
 __ZN13sorted_vectorINSt3__24pairIP11Il2CppClassPKN5Unity4TypeEEEN10vector_mapIS3_S7_NS0_4lessIS3_EENS0_9allocatorIS8_EEE13value_compareESD_E21sort_clear_duplicatesEv(i12 + 196 | 0);
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_(i17, i18, i10, i9, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i16 = __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i17, i18, i10, i1) | 0;
 i5 = i9;
 i8 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i10;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 do if ((i8 | 0) == (i6 | 0) & (i5 | 0) == (i7 | 0)) {
  i1 = i9 + 8 | 0;
  i15 = i1;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i3 = i10 + 8 | 0;
  i2 = i3;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(i14 >>> 0 < i2 >>> 0 | ((i14 | 0) == (i2 | 0) ? (HEAP32[i15 >> 2] | 0) >>> 0 < i4 >>> 0 : 0))) {
   i18 = i16;
   return i18 | 0;
  }
 } else if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i8 >>> 0 < i6 >>> 0) {
  i3 = i10 + 8 | 0;
  i2 = i3;
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  break;
 } else {
  i18 = i16;
  return i18 | 0;
 } while (0);
 i14 = i10;
 HEAP32[i14 >> 2] = i8;
 HEAP32[i14 + 4 >> 2] = i5;
 i14 = i1;
 i5 = HEAP32[i14 + 4 >> 2] | 0;
 i13 = i3;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = i5;
 i13 = i9;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i7;
 i13 = i1;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i13 + 4 >> 2] = i2;
 i13 = i10 + 16 | 0;
 i5 = i13;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i14 = i10 + 24 | 0;
 i8 = i14;
 i12 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i15 = i10 + 32 | 0;
 i7 = i15;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i9 + 16 | 0;
 i20 = i1;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i11 + 4 >> 2] = i19;
 i11 = i9 + 24 | 0;
 i19 = i11;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i2 = i14;
 HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i2 + 4 >> 2] = i20;
 i2 = i9 + 32 | 0;
 i20 = i2;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i9 = i15;
 HEAP32[i9 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i9 + 4 >> 2] = i19;
 i9 = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i11;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i16 + 1 | 0;
 i7 = i10;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i18;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 do if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
  i20 = i3;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i4 = i18 + 8 | 0;
  i1 = i4;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i19 >>> 0 < i1 >>> 0 | ((i19 | 0) == (i1 | 0) ? (HEAP32[i20 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) i2 = i5; else {
   i20 = i2;
   return i20 | 0;
  }
 } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
  i4 = i18 + 8 | 0;
  i1 = i4;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  break;
 } else {
  i20 = i2;
  return i20 | 0;
 } while (0);
 i11 = i18;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i11 + 4 >> 2] = i7;
 i11 = i3;
 i19 = HEAP32[i11 + 4 >> 2] | 0;
 i20 = i4;
 HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = i3;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i1;
 i10 = i18 + 16 | 0;
 i20 = i10;
 i19 = HEAP32[i20 >> 2] | 0;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 i11 = i18 + 24 | 0;
 i9 = i11;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i12 = i18 + 32 | 0;
 i7 = i12;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i13;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i14;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = i15;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i13;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i20;
 i2 = i14;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = i15;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i16 + 2 | 0;
 i7 = i18;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i17;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 do if ((i6 | 0) == (i8 | 0) & (i7 | 0) == (i9 | 0)) {
  i20 = i4;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i3 = i17 + 8 | 0;
  i1 = i3;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i19 >>> 0 < i1 >>> 0 | ((i19 | 0) == (i1 | 0) ? (HEAP32[i20 >> 2] | 0) >>> 0 < i5 >>> 0 : 0)) i2 = i5; else {
   i20 = i2;
   return i20 | 0;
  }
 } else if (i7 >>> 0 < i9 >>> 0 | (i7 | 0) == (i9 | 0) & i6 >>> 0 < i8 >>> 0) {
  i3 = i17 + 8 | 0;
  i1 = i3;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  break;
 } else {
  i20 = i2;
  return i20 | 0;
 } while (0);
 i15 = i17;
 HEAP32[i15 >> 2] = i6;
 HEAP32[i15 + 4 >> 2] = i7;
 i15 = i4;
 i13 = HEAP32[i15 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i7 + 4 >> 2] = i13;
 i7 = i18;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i9;
 i7 = i4;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = i17 + 16 | 0;
 i13 = i7;
 i9 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i17 + 24 | 0;
 i15 = i8;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 i20 = i17 + 32 | 0;
 i19 = i20;
 i18 = HEAP32[i19 >> 2] | 0;
 i19 = HEAP32[i19 + 4 >> 2] | 0;
 i6 = i10;
 i17 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i17;
 i7 = i11;
 i17 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i17;
 i8 = i12;
 i17 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i20 + 4 >> 2] = i17;
 i20 = i10;
 HEAP32[i20 >> 2] = i9;
 HEAP32[i20 + 4 >> 2] = i13;
 i20 = i11;
 HEAP32[i20 >> 2] = i14;
 HEAP32[i20 + 4 >> 2] = i15;
 i20 = i12;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i20 + 4 >> 2] = i19;
 i20 = i16 + 3 | 0;
 return i20 | 0;
}

function __ZN5Umbra8QueryExt16queryLocalLightsERNS_9IndexListEjPKNS_11SphereLightEiRKS1_PS6_(i2, i22, i1, i23, i19, i7, i17) {
 i2 = i2 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i19 = i19 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26;
 i15 = (i2 | 0) == 0 ? 0 : i2 + 3 & -4;
 HEAP32[i25 >> 2] = i15;
 i2 = HEAP32[i15 + 76 >> 2] | 0;
 HEAP32[i25 + 4 >> 2] = i2;
 i21 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i21 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i21 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i25 + 8 >> 2] = i1;
 i9 = i1 + i4 | 0;
 HEAP32[i25 + 12 >> 2] = i9;
 i20 = i25 + 16 | 0;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i25 + 20 >> 2] = i4;
 i18 = i25 + 24 | 0;
 i21 = i25 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i25 + 40 >> 2] = -1;
 i18 = HEAP32[i15 + 84 >> 2] | 0;
 HEAP32[i25 + 44 >> 2] = i18;
 i8 = i25 + 48 | 0;
 HEAP32[i8 >> 2] = i18;
 HEAP32[i25 + 52 >> 2] = 0;
 HEAP32[i25 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i3 = 0; else {
  i2 = i1 + 80 | 0;
  HEAP32[i20 >> 2] = i2;
  if (!i1) {
   i3 = 0;
   i1 = i2;
  } else {
   HEAP32[i1 >> 2] = 13;
   i3 = i1 + 16 | 0;
   i1 = i2;
  }
 }
 HEAP32[i25 + 60 >> 2] = i3;
 i2 = i3;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = HEAP32[i15 >> 2] | 0;
 if (!i2) {
  i24 = 6;
  __ZN5Umbra12QueryContextD2Ev(i25);
  STACKTOP = i26;
  return i24 | 0;
 }
 i18 = i22 + 8 | 0;
 HEAP32[i18 >> 2] = 0;
 i2 = (HEAP32[i2 + 124 >> 2] | 0) + 31 >> 5;
 i3 = i2 << 2;
 i6 = i1 + (i3 + 31 & -16) | 0;
 if (i6 >>> 0 > i9 >>> 0) i5 = 0; else {
  HEAP32[i20 >> 2] = i6;
  if (!i1) {
   i5 = 0;
   i1 = i6;
  } else {
   HEAP32[i1 >> 2] = i2;
   i5 = i1 + 16 | 0;
   _memset(i5 | 0, 0, i3 | 0) | 0;
   i1 = i7 + 3 & -4;
   i3 = i1 + 8 | 0;
   i4 = i1 + 4 | 0;
   i14 = HEAP32[i3 >> 2] | 0;
   i16 = HEAP32[i4 >> 2] | 0;
   if ((((i14 | 0) <= (i16 | 0) ? i14 : i16) | 0) > 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    i1 = 0;
    do {
     i16 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
     i14 = i5 + (i16 >> 5 << 2) | 0;
     HEAP32[i14 >> 2] = 1 << (i16 & 31) | HEAP32[i14 >> 2];
     i1 = i1 + 1 | 0;
     i14 = HEAP32[i3 >> 2] | 0;
     i16 = HEAP32[i4 >> 2] | 0;
    } while ((i1 | 0) < (((i14 | 0) <= (i16 | 0) ? i14 : i16) | 0));
    i1 = i6;
   } else i1 = i6;
  }
 }
 i3 = i25 + 4 | 0;
 i2 = i1 + 80128 | 0;
 if (i2 >>> 0 > i9 >>> 0) i16 = 0; else {
  HEAP32[i20 >> 2] = i2;
  i16 = i1;
  i1 = i2;
 }
 HEAP32[i16 >> 2] = i25;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = i3;
 i11 = i25 + 44 | 0;
 i13 = i16 + 20 | 0;
 HEAP32[i13 >> 2] = i11;
 i10 = HEAP32[i8 >> 2] | 0;
 i14 = i16 + 24 | 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i16 + 28 >> 2] = 20;
 HEAP32[i16 + 44 >> 2] = i3;
 i12 = i16 + 56 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i8 >> 2] = i10 + 2;
 i11 = i16 + 60 | 0;
 HEAP32[i11 >> 2] = i10 + 1;
 HEAP32[i16 + 64 >> 2] = 8;
 i10 = i16 + 92 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i10 = i16 + 80112 | 0;
 HEAP32[i10 >> 2] = 0;
 i2 = (HEAP32[(HEAP32[i15 >> 2] | 0) + 124 >> 2] | 0) + 31 >> 5;
 i3 = i1 + ((i2 << 2) + 31 & -16) | 0;
 if (i3 >>> 0 > i9 >>> 0) i24 = 16; else {
  HEAP32[i20 >> 2] = i3;
  if (!i1) i24 = 16; else {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i10 >> 2] = i1 + 16;
  }
 }
 if ((i24 | 0) == 16) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i21 >> 2] = 2;
 }
 i9 = (i5 | 0) != 0;
 if (i9) {
  if (!(HEAP32[i21 >> 2] | 0)) {
   i2 = (i17 | 0) != 0;
   if (i2) {
    i8 = i17 + 3 & -4;
    i15 = HEAP32[i8 + 8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i8 = (i15 | 0) <= (i8 | 0) ? i15 : i8;
   } else i8 = i19;
   L33 : do if ((i8 | 0) > 0) {
    i7 = i17 + 3 & -4;
    i1 = i22 + 4 | 0;
    if (i2) i6 = 0; else {
     i4 = 0;
     while (1) {
      i2 = i23 + (i4 << 4) | 0;
      i3 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i25, i2) | 0;
      if ((i3 | 0) == -1) i24 = 36; else if (__ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf(i16, 0, i5, i3, i2, Math_fround(HEAPF32[i23 + (i4 << 4) + 12 >> 2]), 0) | 0) i24 = 36;
      if ((i24 | 0) == 36) {
       i24 = 0;
       i2 = HEAP32[i18 >> 2] | 0;
       if ((i2 | 0) < (HEAP32[i1 >> 2] | 0)) {
        HEAP32[(HEAP32[i22 >> 2] | 0) + (i2 << 2) >> 2] = i4;
        i2 = HEAP32[i18 >> 2] | 0;
       }
       HEAP32[i18 >> 2] = i2 + 1;
      }
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i8 | 0)) break L33;
     }
    }
    while (1) {
     i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
     if (!((i4 | 0) > -1 & (i4 | 0) < (i19 | 0))) break;
     i2 = i23 + (i4 << 4) | 0;
     i3 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i25, i2) | 0;
     if ((i3 | 0) == -1) i24 = 29; else if (__ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf(i16, 0, i5, i3, i2, Math_fround(HEAPF32[i23 + (i4 << 4) + 12 >> 2]), 0) | 0) i24 = 29;
     if ((i24 | 0) == 29) {
      i24 = 0;
      i2 = HEAP32[i18 >> 2] | 0;
      if ((i2 | 0) < (HEAP32[i1 >> 2] | 0)) {
       HEAP32[(HEAP32[i22 >> 2] | 0) + (i2 << 2) >> 2] = i4;
       i2 = HEAP32[i18 >> 2] | 0;
      }
      HEAP32[i18 >> 2] = i2 + 1;
     }
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i8 | 0)) break L33;
    }
    HEAP32[i21 >> 2] = 3;
   } else i1 = i22 + 4 | 0; while (0);
   if ((HEAP32[i18 >> 2] | 0) > (HEAP32[i1 >> 2] | 0)) HEAP32[i21 >> 2] = 2;
  }
 } else HEAP32[i21 >> 2] = 2;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i20 >> 2] = i16;
 if (i9) HEAP32[i20 >> 2] = i5 + -16;
 i24 = HEAP32[i21 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i25);
 STACKTOP = i26;
 return i24 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessIyyEEPyEEvT0_S5_T_(i1, i2, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 L1 : while (1) {
  i15 = i2;
  i18 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i17 = 5;
      break L1;
     }
    case 3:
     {
      i17 = 7;
      break L1;
     }
    case 4:
     {
      i17 = 8;
      break L1;
     }
    case 5:
     {
      i17 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 248) {
     i17 = 11;
     break L1;
    }
    i9 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 3) | 0, i9, i9 + (i3 << 3) | 0, i18, i16) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i1, i9, i18, i16) | 0;
    i11 = i1;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = i9;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    if (i11 >>> 0 < i8 >>> 0 | (i11 | 0) == (i8 | 0) & i10 >>> 0 < i7 >>> 0) {
     i4 = i18;
     break;
    } else i4 = i18;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = i4;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
      i17 = 29;
      break L5;
     }
    }
    i3 = i1 + 8 | 0;
    i7 = i18;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    if (!(i11 >>> 0 < i7 >>> 0 | (i11 | 0) == (i7 | 0) & i10 >>> 0 < i6 >>> 0)) {
     while (1) {
      if ((i3 | 0) == (i18 | 0)) break L1;
      i5 = i3;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if (i11 >>> 0 < i5 >>> 0 | (i11 | 0) == (i5 | 0) & i10 >>> 0 < i4 >>> 0) break;
      i3 = i3 + 8 | 0;
     }
     i14 = i3;
     HEAP32[i14 >> 2] = i6;
     HEAP32[i14 + 4 >> 2] = i7;
     i14 = i18;
     HEAP32[i14 >> 2] = i4;
     HEAP32[i14 + 4 >> 2] = i5;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i18 | 0)) break L1; else i4 = i18;
    while (1) {
     i11 = i1;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     while (1) {
      i8 = i3;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i9 = i3 + 8 | 0;
      if (i11 >>> 0 < i8 >>> 0 | (i11 | 0) == (i8 | 0) & i10 >>> 0 < i7 >>> 0) break; else i3 = i9;
     }
     do {
      i4 = i4 + -8 | 0;
      i6 = i4;
      i5 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
     } while (i11 >>> 0 < i6 >>> 0 | (i11 | 0) == (i6 | 0) & i10 >>> 0 < i5 >>> 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i3 + 4 >> 2] = i6;
     i3 = i4;
     HEAP32[i3 >> 2] = i7;
     HEAP32[i3 + 4 >> 2] = i8;
     i3 = i9;
    }
   }
   if ((i17 | 0) == 29) {
    i17 = 0;
    i13 = i1;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i13 + 4 >> 2] = i6;
    i13 = i4;
    HEAP32[i13 >> 2] = i10;
    HEAP32[i13 + 4 >> 2] = i11;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i13 = i9;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    while (1) {
     i10 = i5;
     i8 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     i11 = i5 + 8 | 0;
     if (i10 >>> 0 < i13 >>> 0 | (i10 | 0) == (i13 | 0) & i8 >>> 0 < i12 >>> 0) i5 = i11; else break;
    }
    do {
     i4 = i4 + -8 | 0;
     i7 = i4;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
    } while (!(i7 >>> 0 < i13 >>> 0 | (i7 | 0) == (i13 | 0) & i6 >>> 0 < i12 >>> 0));
    if (i5 >>> 0 > i4 >>> 0) break L35;
    i13 = i5;
    HEAP32[i13 >> 2] = i6;
    HEAP32[i13 + 4 >> 2] = i7;
    i13 = i4;
    HEAP32[i13 >> 2] = i8;
    HEAP32[i13 + 4 >> 2] = i10;
    i9 = (i9 | 0) == (i5 | 0) ? i4 : i9;
    i5 = i11;
    i3 = i3 + 1 | 0;
   } while (0);
   if ((i5 | 0) != (i9 | 0)) {
    i6 = i9;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    if (i6 >>> 0 < i8 >>> 0 | (i6 | 0) == (i8 | 0) & i4 >>> 0 < i7 >>> 0) {
     i13 = i5;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i13 + 4 >> 2] = i6;
     i13 = i9;
     HEAP32[i13 >> 2] = i7;
     HEAP32[i13 + 4 >> 2] = i8;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIyyEEPyEEbT0_S5_T_(i1, i5, i16) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIyyEEPyEEbT0_S5_T_(i4, i2, i16) | 0) {
     i17 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i17 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIyyEEPyEEvT0_S5_T_(i1, i5, i16);
   i1 = i5 + 8 | 0;
  }
  if ((i17 | 0) == 44) {
   i17 = 0;
   __ZNSt3__26__sortIRNS_6__lessIyyEEPyEEvT0_S5_T_(i5 + 8 | 0, i2, i16);
   i2 = i5;
   continue;
  } else if ((i17 | 0) == 45) {
   i17 = 0;
   if (i3) break; else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i17 | 0) == 5) {
  i3 = i18;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i17 = i1;
   HEAP32[i17 >> 2] = i2;
   HEAP32[i17 + 4 >> 2] = i3;
   HEAP32[i18 >> 2] = i4;
   HEAP32[i18 + 4 >> 2] = i5;
  }
 } else if ((i17 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i18, i16) | 0; else if ((i17 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i18, i16) | 0; else if ((i17 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i18, i16) | 0; else if ((i17 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIyyEEPyEEvT0_S5_T_(i1, i2, i16);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i1, i2, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 L1 : while (1) {
  i15 = i2;
  i18 = i2 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i14 = i1;
    i3 = i15 - i14 | 0;
    i4 = i3 >> 3;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i17 = 5;
      break L1;
     }
    case 3:
     {
      i17 = 7;
      break L1;
     }
    case 4:
     {
      i17 = 8;
      break L1;
     }
    case 5:
     {
      i17 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 248) {
     i17 = 11;
     break L1;
    }
    i9 = i1 + (((i4 | 0) / 2 | 0) << 3) | 0;
    if ((i3 | 0) > 7992) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 3) | 0, i9, i9 + (i3 << 3) | 0, i18, i16) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i1, i9, i18, i16) | 0;
    i11 = i1;
    i10 = HEAP32[i11 >> 2] | 0;
    i11 = HEAP32[i11 + 4 >> 2] | 0;
    i8 = i9;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    if ((i11 | 0) < (i8 | 0) | (i11 | 0) == (i8 | 0) & i10 >>> 0 < i7 >>> 0) {
     i4 = i18;
     break;
    } else i4 = i18;
    while (1) {
     i4 = i4 + -8 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = i4;
     i5 = HEAP32[i6 >> 2] | 0;
     i6 = HEAP32[i6 + 4 >> 2] | 0;
     if ((i6 | 0) < (i8 | 0) | (i6 | 0) == (i8 | 0) & i5 >>> 0 < i7 >>> 0) {
      i17 = 29;
      break L5;
     }
    }
    i3 = i1 + 8 | 0;
    i7 = i18;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    if (!((i11 | 0) < (i7 | 0) | (i11 | 0) == (i7 | 0) & i10 >>> 0 < i6 >>> 0)) {
     while (1) {
      if ((i3 | 0) == (i18 | 0)) break L1;
      i5 = i3;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if ((i11 | 0) < (i5 | 0) | (i11 | 0) == (i5 | 0) & i10 >>> 0 < i4 >>> 0) break;
      i3 = i3 + 8 | 0;
     }
     i14 = i3;
     HEAP32[i14 >> 2] = i6;
     HEAP32[i14 + 4 >> 2] = i7;
     i14 = i18;
     HEAP32[i14 >> 2] = i4;
     HEAP32[i14 + 4 >> 2] = i5;
     i3 = i3 + 8 | 0;
    }
    if ((i3 | 0) == (i18 | 0)) break L1; else i4 = i18;
    while (1) {
     i11 = i1;
     i10 = HEAP32[i11 >> 2] | 0;
     i11 = HEAP32[i11 + 4 >> 2] | 0;
     while (1) {
      i8 = i3;
      i7 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      i9 = i3 + 8 | 0;
      if ((i11 | 0) < (i8 | 0) | (i11 | 0) == (i8 | 0) & i10 >>> 0 < i7 >>> 0) break; else i3 = i9;
     }
     do {
      i4 = i4 + -8 | 0;
      i6 = i4;
      i5 = HEAP32[i6 >> 2] | 0;
      i6 = HEAP32[i6 + 4 >> 2] | 0;
     } while ((i11 | 0) < (i6 | 0) | (i11 | 0) == (i6 | 0) & i10 >>> 0 < i5 >>> 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i3 + 4 >> 2] = i6;
     i3 = i4;
     HEAP32[i3 >> 2] = i7;
     HEAP32[i3 + 4 >> 2] = i8;
     i3 = i9;
    }
   }
   if ((i17 | 0) == 29) {
    i17 = 0;
    i13 = i1;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i13 + 4 >> 2] = i6;
    i13 = i4;
    HEAP32[i13 >> 2] = i10;
    HEAP32[i13 + 4 >> 2] = i11;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 8 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) while (1) {
    i13 = i9;
    i12 = HEAP32[i13 >> 2] | 0;
    i13 = HEAP32[i13 + 4 >> 2] | 0;
    while (1) {
     i10 = i5;
     i8 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     i11 = i5 + 8 | 0;
     if ((i10 | 0) < (i13 | 0) | (i10 | 0) == (i13 | 0) & i8 >>> 0 < i12 >>> 0) i5 = i11; else break;
    }
    do {
     i4 = i4 + -8 | 0;
     i7 = i4;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
    } while (!((i7 | 0) < (i13 | 0) | (i7 | 0) == (i13 | 0) & i6 >>> 0 < i12 >>> 0));
    if (i5 >>> 0 > i4 >>> 0) break L35;
    i13 = i5;
    HEAP32[i13 >> 2] = i6;
    HEAP32[i13 + 4 >> 2] = i7;
    i13 = i4;
    HEAP32[i13 >> 2] = i8;
    HEAP32[i13 + 4 >> 2] = i10;
    i9 = (i9 | 0) == (i5 | 0) ? i4 : i9;
    i5 = i11;
    i3 = i3 + 1 | 0;
   } while (0);
   if ((i5 | 0) != (i9 | 0)) {
    i6 = i9;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i5;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    if ((i6 | 0) < (i8 | 0) | (i6 | 0) == (i8 | 0) & i4 >>> 0 < i7 >>> 0) {
     i13 = i5;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i13 + 4 >> 2] = i6;
     i13 = i9;
     HEAP32[i13 >> 2] = i7;
     HEAP32[i13 + 4 >> 2] = i8;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i1, i5, i16) | 0;
    i4 = i5 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i4, i2, i16) | 0) {
     i17 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i13 = i5;
   if ((i13 - i14 | 0) >= (i15 - i13 | 0)) {
    i17 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i1, i5, i16);
   i1 = i5 + 8 | 0;
  }
  if ((i17 | 0) == 44) {
   i17 = 0;
   __ZNSt3__26__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_(i5 + 8 | 0, i2, i16);
   i2 = i5;
   continue;
  } else if ((i17 | 0) == 45) {
   i17 = 0;
   if (i3) break; else {
    i2 = i5;
    continue;
   }
  }
 }
 if ((i17 | 0) == 5) {
  i3 = i18;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i3 | 0) < (i5 | 0) | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i17 = i1;
   HEAP32[i17 >> 2] = i2;
   HEAP32[i17 + 4 >> 2] = i3;
   HEAP32[i18 >> 2] = i4;
   HEAP32[i18 + 4 >> 2] = i5;
  }
 } else if ((i17 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i18, i16) | 0; else if ((i17 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i18, i16) | 0; else if ((i17 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i18, i16) | 0; else if ((i17 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_(i1, i2, i16);
 return;
}

function __ZN5physx9NpFactory13addCollectionERKNS_2Cm10CollectionE(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 4 | 0;
 i17 = i21;
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i14 = HEAP32[i1 + 48 >> 2] | 0;
 i15 = i20 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i15 >> 2] | 0);
 if (!i18) {
  i20 = HEAP32[i15 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i20);
  STACKTOP = i21;
  return;
 }
 i6 = i20 + 3944 | 0;
 i7 = i20 + 3948 | 0;
 i8 = i20 + 3952 | 0;
 i9 = i20 + 564 | 0;
 i10 = i20 + 604 | 0;
 i11 = i20 + 484 | 0;
 i12 = i20 + 524 | 0;
 i13 = i20 + 444 | 0;
 i16 = 0;
 do {
  i3 = HEAP32[i14 + (i16 << 4) >> 2] | 0;
  L6 : do switch (HEAP16[i3 + 4 >> 1] | 0) {
  case 1:
   {
    HEAP32[i3 + 112 >> 2] = i20;
    __ZN5physx13GuMeshFactory14addHeightFieldEPNS_2Gu11HeightFieldEb(i20, i3, 0);
    break;
   }
  case 2:
   {
    HEAP32[i3 + 128 >> 2] = i20;
    __ZN5physx13GuMeshFactory13addConvexMeshEPNS_2Gu10ConvexMeshEb(i20, i3, 0);
    break;
   }
  case 3:
   {
    HEAP32[i3 + 224 >> 2] = i20;
    __ZN5physx13GuMeshFactory15addTriangleMeshEPNS_2Gu12TriangleMeshEb(i20, i3, 0);
    break;
   }
  case 4:
   {
    HEAP32[i19 >> 2] = i3;
    i2 = i3;
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) if ((HEAP32[i8 >> 2] & 2147483584) >>> 0 < 64) {
     __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, 64);
     i1 = HEAP32[i7 >> 2] | 0;
    } else i1 = 0;
    if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i2;
     HEAP32[i7 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i19) | 0;
    break;
   }
  case 5:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 6:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 7:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb(i10, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 14:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i11, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 9:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 10:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 11:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 12:
   {
    HEAP32[i17 >> 2] = i3;
    i2 = i3;
    if (i3 | 0) {
     i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
    }
    break;
   }
  case 13:
   {
    HEAP32[i17 >> 2] = i3;
    i1 = i3;
    if (i3 | 0) {
     i2 = __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i13, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i2 >> 2] = i1;
    }
    i5 = i3 + 36 | 0;
    if (HEAP32[i5 >> 2] | 0) {
     i3 = i3 + 40 | 0;
     i4 = 0;
     while (1) {
      i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      switch (HEAP16[i1 + 4 >> 1] | 0) {
      case 6:
       {
        HEAP32[i17 >> 2] = i1;
        i2 = i1;
        if (i1 | 0) {
         i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
         if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
        }
        break;
       }
      case 5:
       {
        HEAP32[i17 >> 2] = i1;
        i2 = i1;
        if (i1 | 0) {
         i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i9, i17, i19) | 0;
         if (!(HEAP8[i19 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
        }
        break;
       }
      default:
       {}
      }
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) break L6;
     }
    }
    break;
   }
  default:
   {}
  } while (0);
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) != (i18 | 0));
 i20 = HEAP32[i15 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i20);
 STACKTOP = i21;
 return;
}

function __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 260 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj458ENS_22PxRepXPropertyAccessorILj458ES4_RKNS_22PxJointLinearLimitPairES9_EEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj459ES3_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 276 | 0, i10 + 3 | 0);
 i5 = i6 + 292 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj460ENS_22PxRepXPropertyAccessorILj460ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 308 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj461ENS_22PxRepXPropertyAccessorILj461ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 7 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 7 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14EdgeCollider2D14CreateInternalEP11Rigidbody2D(i21, i2) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i29 + 8 | 0;
 i27 = i29;
 i22 = i29 + 112 | 0;
 i23 = i29 + 108 | 0;
 i24 = i29 + 96 | 0;
 i25 = i29 + 56 | 0;
 i26 = i29 + 36 | 0;
 if ((HEAP16[gb + 1458100 + 6 >> 1] | 0) > -1) {
  HEAP32[i27 >> 2] = 0;
  HEAP32[i19 >> 2] = HEAP32[i27 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458100 | 0, i19);
  i20 = gb + 1458100 | 0;
 } else i20 = 0;
 i1 = HEAP32[i21 + 28 >> 2] | 0;
 do if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i6 = i21 + 172 | 0;
  if ((HEAP32[i6 >> 2] | 0) >>> 0 < 2) {
   HEAP32[i21 + 56 >> 2] = 1;
   break;
  }
  __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i21, i23, i22, i2);
  HEAP32[i24 >> 2] = 0;
  i18 = i24 + 4 | 0;
  i2 = gb + 63160 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i18;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i1;
  i7 = HEAP32[i6 >> 2] | 0;
  i1 = i7 << 3;
  i2 = i1 + 8 | 0;
  do if (!i2) i1 = 0; else {
   i5 = i1 + 11 | 0;
   if (i5 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, gb + 64016 | 0, 0, gb + 801303 | 0, 180) | 0;
    i17 = gb + 64016 | 0;
    i16 = HEAP32[i17 >> 2] | 0;
    i17 = HEAP32[i17 + 4 >> 2] | 0;
    HEAP32[i24 >> 2] = i1;
    i7 = i18;
    HEAP32[i7 >> 2] = i16;
    HEAP32[i7 + 4 >> 2] = i17;
    i7 = HEAP32[i6 >> 2] | 0;
    break;
   }
  } while (0);
  i17 = i1 + 3 & -4;
  do if (!i7) i28 = 19; else {
   i8 = i21 + 40 | 0;
   i9 = i21 + 44 | 0;
   i10 = i22 + 16 | 0;
   i11 = i22 + 32 | 0;
   i12 = i22 + 48 | 0;
   i13 = i22 + 4 | 0;
   i14 = i22 + 20 | 0;
   i15 = i22 + 36 | 0;
   i16 = i22 + 52 | 0;
   i5 = 0;
   i2 = 0;
   i6 = HEAP32[i21 + 160 >> 2] | 0;
   i1 = i17;
   while (1) {
    f30 = Math_fround(HEAPF32[i6 >> 2]);
    f30 = Math_fround(f30 + Math_fround(HEAPF32[i8 >> 2]));
    f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
    f4 = Math_fround(f4 + Math_fround(HEAPF32[i9 >> 2]));
    f3 = Math_fround(f30 * Math_fround(HEAPF32[i22 >> 2]));
    f3 = Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i10 >> 2])));
    f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(0.0)));
    f3 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f3);
    f30 = Math_fround(f30 * Math_fround(HEAPF32[i13 >> 2]));
    f4 = Math_fround(f30 + Math_fround(f4 * Math_fround(HEAPF32[i14 >> 2])));
    f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i15 >> 2]) * Math_fround(0.0)));
    f4 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f4);
    if ((i2 | 0) > 0) {
     f31 = Math_fround(Math_fround(HEAPF32[i1 + -8 >> 2]) - f3);
     f30 = Math_fround(Math_fround(HEAPF32[i1 + -4 >> 2]) - f4);
     if (!(Math_fround(Math_fround(f31 * f31) + Math_fround(f30 * f30)) <= Math_fround(.000050249997))) i28 = 15;
    } else i28 = 15;
    if ((i28 | 0) == 15) {
     i28 = 0;
     HEAPF32[i1 >> 2] = f3;
     HEAPF32[i1 + 4 >> 2] = f4;
     i2 = i2 + 1 | 0;
     i1 = i1 + 8 | 0;
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i7 | 0)) break; else i6 = i6 + 8 | 0;
   }
   if ((i2 | 0) < 2) i28 = 19; else {
    f3 = Math_fround(HEAPF32[i17 >> 2]);
    i1 = 1;
    f4 = Math_fround(HEAPF32[i17 + 4 >> 2]);
    do {
     f30 = f3;
     f3 = Math_fround(HEAPF32[i17 + (i1 << 3) >> 2]);
     f30 = Math_fround(f30 - f3);
     f31 = f4;
     f4 = Math_fround(HEAPF32[i17 + (i1 << 3) + 4 >> 2]);
     f31 = Math_fround(f31 - f4);
     i1 = i1 + 1 | 0;
     if (Math_fround(Math_fround(f30 * f30) + Math_fround(f31 * f31)) < Math_fround(.000050249997)) {
      i28 = 22;
      break;
     }
    } while ((i1 | 0) < (i2 | 0));
    if ((i28 | 0) == 22) {
     HEAP32[i21 + 56 >> 2] = 1;
     break;
    }
    HEAP32[i25 >> 2] = gb + 151604 + 8;
    HEAP32[i25 + 4 >> 2] = 3;
    HEAP32[i25 + 8 >> 2] = HEAP32[gb + 151644 >> 2];
    HEAP32[i25 + 12 >> 2] = 0;
    HEAP32[i25 + 16 >> 2] = 0;
    HEAP8[i25 + 36 >> 0] = 0;
    HEAP8[i25 + 37 >> 0] = 0;
    __ZN12b2ChainShape11CreateChainEPK6b2Vec2i(i25, i17, i2);
    i1 = gb + 64016 | 0;
    i17 = HEAP32[i1 + 4 >> 2] | 0;
    i16 = i27;
    HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i16 + 4 >> 2] = i17;
    HEAP32[i26 >> 2] = 0;
    i16 = i26 + 12 | 0;
    HEAP32[i16 >> 2] = 0;
    i17 = i26 + 16 | 0;
    i1 = i26 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i27);
    i14 = i19;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i27 = i1;
    HEAP32[i27 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i27 + 4 >> 2] = i15;
    HEAP32[i17 >> 2] = 1;
    i27 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i1, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i26 >> 2] = i27;
    HEAP32[i16 >> 2] = 1;
    HEAP32[i27 >> 2] = i25;
    HEAP16[i19 + 22 >> 1] = 1;
    HEAP16[i19 + 24 >> 1] = -1;
    HEAP16[i19 + 26 >> 1] = 0;
    HEAP32[i19 >> 2] = 0;
    HEAP32[i19 + 4 >> 2] = 0;
    HEAPF32[i19 + 8 >> 2] = Math_fround(.200000003);
    HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i19 + 16 >> 2] = Math_fround(0.0);
    HEAP8[i19 + 20 >> 0] = 0;
    __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i21, i22, i19, HEAP32[i23 >> 2] | 0, i26);
    if ((HEAP32[i17 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i1);
     HEAP32[i26 >> 2] = 0;
    }
    __ZN12b2ChainShapeD2Ev(i25);
   }
  } while (0);
  if ((i28 | 0) == 19) HEAP32[i21 + 56 >> 2] = 1;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i18);
 } while (0);
 if (!i20) {
  STACKTOP = i29;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i20);
 STACKTOP = i29;
 return;
}

function __ZN9Projector17PrepareRenderNodeEjjPS_R15RenderNodeQueueR22PerThreadPageAllocator(i16, i17, i6, i14, i18) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i21 + 8 | 0;
 i11 = i21;
 i19 = i21 + 136 | 0;
 i15 = i21 + 40 | 0;
 i20 = i21 + 16 | 0;
 i4 = HEAP32[i6 + 64 >> 2] | 0;
 if (!i4) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAP32[i11 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i11);
   i2 = HEAP32[i8 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 9;
  }
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  }
 }
 i5 = HEAP32[gb + 1112268 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i7 = 15; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i11);
   i3 = HEAP32[i8 >> 2] | 0;
   i13 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i7 = 15; else {
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) i7 = 17;
  }
 }
 if ((i7 | 0) == 15) i7 = 17;
 if ((i7 | 0) == 17) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 if (!(1 << HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i2 + 880 >> 2])) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (__ZNK6Camera20GetReplacementShaderEv(i2) | 0) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 __ZN9Projector22SetupProjectorSettingsEP8MaterialR23ProjectorRenderSettings(i6, i1, i19 + 4 | 0);
 i9 = HEAP32[i6 + 60 >> 2] | 0;
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i19 + 196 | 0, i15);
 i13 = gb + 64024 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i20 >> 2] = 0;
 i10 = i20 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i12 = i20 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i11);
 i7 = i8;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i11;
 i8 = HEAP32[i14 + 32804 >> 2] | 0;
 if ((i8 | 0) > 0) {
  i7 = 0;
  do {
   i2 = HEAP32[i14 >> 2] | 0;
   if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i2 + (i7 * 360 | 0) + 128 | 0, i15) | 0) if (!(1 << HEAP32[i2 + (i7 * 360 | 0) + 240 >> 2] & i9)) {
    i3 = HEAP32[i10 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i12 >> 2] = i2;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i2;
      HEAP32[i20 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    HEAP32[(HEAP32[i20 >> 2] | 0) + (i3 << 2) >> 2] = i7;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i8 | 0));
  if (!(HEAP32[i10 >> 2] | 0)) i1 = 0; else {
   i6 = HEAP32[i14 >> 2] | 0;
   _memset(i6 + (i17 * 360 | 0) | 0, 0, 360) | 0;
   HEAP32[i6 + (i17 * 360 | 0) + 240 >> 2] = i16;
   HEAP32[i6 + (i17 * 360 | 0) + 236 >> 2] = 1;
   HEAP32[i6 + (i17 * 360 | 0) + 332 >> 2] = fb + 497;
   HEAP32[i6 + (i17 * 360 | 0) + 344 >> 2] = fb + 2380;
   HEAP32[i19 >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(i1) | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i19 + 272 >> 2] = i3;
   i2 = HEAP32[i20 >> 2] | 0;
   i3 = i3 << 2;
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = i18 + 8 | 0;
   if ((i1 + i3 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
    __ZN22PerThreadPageAllocator14AcquireNewPageEj(i18, i3 >>> 0 < 32768 ? 32768 : i3);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i16 = (HEAP32[i18 >> 2] | 0) + i1 | 0;
   HEAP32[i5 >> 2] = i1 + i3;
   _memcpy(i16 | 0, i2 | 0, i3 | 0) | 0;
   HEAP32[i19 + 276 >> 2] = i16;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 + 280 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
    __ZN22PerThreadPageAllocator14AcquireNewPageEj(i18, 32768);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i18 = (HEAP32[i18 >> 2] | 0) + i1 | 0;
   HEAP32[i5 >> 2] = i1 + 280;
   _memcpy(i18 | 0, i19 | 0, 280) | 0;
   HEAP32[i6 + (i17 * 360 | 0) + 328 >> 2] = i18;
   i1 = 1;
  }
 } else i1 = 0;
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i13);
  HEAP32[i20 >> 2] = 0;
 }
 i20 = i1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN12AudioManager29ShutdownReinitializeAndReloadEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 56 | 0;
 i15 = i18 + 40 | 0;
 i13 = i18 + 24 | 0;
 i11 = i18 + 8 | 0;
 i12 = i18;
 i17 = i18 + 72 | 0;
 if (!(HEAP32[i16 + 88 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 __ZN12AudioManager9CloseFMODEv(i16);
 __ZN12AudioManager8InitFMODEv(i16) | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i17 >> 2] = 0;
 i6 = i17 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i17 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i9 = i11;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 170640 | 0, i17, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i5 = 0;
  do {
   i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i2 + 108 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) {
    i10 = i2 + 112 | 0;
    HEAP32[i4 + 4 >> 2] = HEAP32[i10 >> 2];
    HEAP32[HEAP32[i10 >> 2] >> 2] = i4;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
   }
   if (HEAP32[i2 + 8 >> 2] & 1048576) {
    __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i2) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i8);
  HEAP32[i17 >> 2] = 0;
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i17 >> 2] = 0;
 i2 = i17 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i17 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i8 = i11;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 171656 | 0, i17, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   i10 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i4);
  HEAP32[i17 >> 2] = 0;
 }
 i1 = HEAP32[i16 + 56 >> 2] | 0;
 i3 = i16 + 52 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  __ZN13AudioListener12ApplyFiltersEv(HEAP32[i1 + 8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i17 >> 2] = 0;
 i5 = i17 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i9 = i17 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i6 = i11;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 27592 | 0, i17, 0);
 if (HEAP32[i5 >> 2] | 0) {
  i6 = i11 + 11 | 0;
  i7 = i11 + 11 | 0;
  i8 = i11 + 11 | 0;
  i4 = 0;
  do {
   i1 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i2 = __ZN13MonoBehaviour14GetOrCreateDSPEv(i1) | 0;
   if (i2 | 0) {
    HEAP32[i12 >> 2] = 0;
    i3 = __ZN4FMOD3DSP11getUserDataEPPv(i2, i12) | 0;
    if (!i3) {
     i1 = __ZN4FMOD3DSP9setBypassEb(i2, (HEAP8[(HEAP32[i12 >> 2] | 0) + 13 >> 0] | 0) != 0) | 0;
     if (i1 | 0) {
      i3 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
      HEAP32[i13 >> 2] = gb + 856220;
      HEAP32[i13 + 4 >> 2] = 724;
      HEAP32[i13 + 8 >> 2] = gb + 856291;
      HEAP32[i13 + 12 >> 2] = i3;
      __Z6FormatPKcz(i11, gb + 883334 | 0, i13);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     }
    } else {
     i3 = __ZL16FMOD_ErrorString11FMOD_RESULT(i3) | 0;
     HEAP32[i15 >> 2] = gb + 856220;
     HEAP32[i15 + 4 >> 2] = 722;
     HEAP32[i15 + 8 >> 2] = gb + 856340;
     HEAP32[i15 + 12 >> 2] = i3;
     __Z6FormatPKcz(i11, gb + 883334 | 0, i15);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     i1 = __ZN4FMOD3DSP9setBypassEb(i2, (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) ^ 1) | 0;
     if (i1 | 0) {
      i3 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
      HEAP32[i14 >> 2] = gb + 856220;
      HEAP32[i14 + 4 >> 2] = 726;
      HEAP32[i14 + 8 >> 2] = gb + 856389;
      HEAP32[i14 + 12 >> 2] = i3;
      __Z6FormatPKcz(i11, gb + 883334 | 0, i14);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     }
    }
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i16 + 84 >> 2] | 0;
 i3 = i16 + 80 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  __ZN15AudioReverbZone4InitEv(HEAP32[i1 + 8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 HEAP8[i16 + 226 >> 0] = 1;
 __ZN12AudioManager39HandlePendingAudioConfigurationCallbackEv(i16);
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i10);
  HEAP32[i17 >> 2] = 0;
 }
 STACKTOP = i18;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl17AwakeFromLoadImplE17AwakeFromLoadMode(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 248 | 0;
 i11 = i14 + 8 | 0;
 i12 = i14;
 i7 = i9 + 36 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) < Math_fround(0.0)) {
  i8 = i9 + 76 | 0;
  i5 = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[i8 >> 2] | 0) | 0;
  do if (!i5) f3 = Math_fround(1.0); else {
   HEAP32[i11 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i11);
     i2 = HEAP32[i13 >> 2] | 0;
     i15 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i6 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 10;
    }
   }
   if ((i6 | 0) == 8) i6 = 10;
   if ((i6 | 0) == 10) {
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) {
     f3 = Math_fround(1.0);
     break;
    }
   }
   f3 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
   f3 = Math_fround(f3 / Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0));
  } while (0);
  HEAPF32[i7 >> 2] = f3;
  i2 = i9 + 52 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i4 = i9 + 40 | 0;
   i1 = 0;
   do {
    i15 = HEAP32[i4 >> 2] | 0;
    f16 = Math_fround(Math_fround(1.0) / f3);
    f3 = Math_fround(Math_fround(-1.0) / f3);
    HEAPF32[i15 + (i1 * 60 | 0) + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i15 + (i1 * 60 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i15 + (i1 * 60 | 0) + 28 >> 2] = f16;
    HEAPF32[i15 + (i1 * 60 | 0) + 32 >> 2] = f3;
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    i15 = i15 + (i1 * 60 | 0) + 36 | 0;
    HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) / f3);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i15 = (HEAP32[i8 >> 2] | 0) + 32 | 0;
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) / f3);
 }
 i1 = HEAP32[i9 + 60 >> 2] | 0;
 i2 = i9 + 64 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i4 + (~(((i4 + -60 - i1 | 0) >>> 0) / 60 | 0) * 60 | 0);
 i4 = i9 + 52 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i9 + 40 | 0;
  i6 = i9 + 76 | 0;
  i7 = i9 + 60 | 0;
  i2 = 0;
  do {
   i1 = HEAP32[i5 >> 2] | 0;
   i8 = i1 + (i2 * 60 | 0) | 0;
   if ((HEAP32[i8 >> 2] | 0) == -1) HEAP32[i8 >> 2] = i2;
   i1 = i1 + (i2 * 60 | 0) + 40 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2];
   __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_(i13, i7, i8);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i9 + 32 >> 2] | 0) == -2) {
  i1 = i9 + 100 | 0;
  i2 = i9 + 104 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 944906 | 0, 0, gb + 944940 | 0, 339, 1, 0, 0, 0);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i4 = i11 + 11 | 0;
   HEAP8[i4 >> 0] = 5;
   HEAP8[i11 >> 0] = HEAP8[gb + 945483 >> 0] | 0;
   HEAP8[i11 + 1 >> 0] = HEAP8[gb + 945483 + 1 >> 0] | 0;
   HEAP8[i11 + 2 >> 0] = HEAP8[gb + 945483 + 2 >> 0] | 0;
   HEAP8[i11 + 3 >> 0] = HEAP8[gb + 945483 + 3 >> 0] | 0;
   HEAP8[i11 + 4 >> 0] = HEAP8[gb + 945483 + 4 >> 0] | 0;
   HEAP8[i11 + 5 >> 0] = 0;
   i5 = HEAP32[i2 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i9 + 108 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i11); else {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP8[i5 + 11 >> 0] = 5;
    HEAP8[i5 >> 0] = HEAP8[i11 >> 0] | 0;
    HEAP8[i5 + 1 >> 0] = HEAP8[i11 + 1 >> 0] | 0;
    HEAP8[i5 + 2 >> 0] = HEAP8[i11 + 2 >> 0] | 0;
    HEAP8[i5 + 3 >> 0] = HEAP8[i11 + 3 >> 0] | 0;
    HEAP8[i5 + 4 >> 0] = HEAP8[i11 + 4 >> 0] | 0;
    HEAP8[i5 + 5 >> 0] = 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
   }
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i15 = HEAP32[i11 >> 2] | 0;
    i8 = HEAP32[i11 + 12 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i13 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i13);
   }
  }
  __ZN20TextRenderingPrivate8FontImpl16SetupDynamicFontEv(i9);
  __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i9) | 0;
  i1 = i10 & 1;
  if (!((i10 | 0) != 0 & (i1 | 0) == 0)) {
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 76 >> 2] | 0) | 0;
   if (i2 | 0) {
    i9 = (__Z32GetTextRenderingScriptingClassesv() | 0) + 4 | 0;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i15 = i12;
    HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i15 + 4 >> 2] = i10;
    HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i11, i13);
    __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i11, i2);
    HEAP32[i13 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i11, i13, 0) | 0;
   }
  }
 } else i1 = i10 & 1;
 if (i1 | 0) {
  STACKTOP = i14;
  return;
 }
 __ZN20TextRenderingPrivate13ApplyToMeshesEv();
 STACKTOP = i14;
 return;
}

function __ZN8Animator13GetAvatarRootEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i6 = i11;
 i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i7 = i8 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i4 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i9 = 9;
 }
 if ((i9 | 0) == 7) i9 = 9;
 do if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 if (!(__ZN6Avatar8GetAssetEv(i1) | 0)) i1 = 0; else {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 25; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 25; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 27;
   }
  }
  if ((i9 | 0) == 25) i9 = 27;
  if ((i9 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i4 = __ZN6Avatar8GetAssetEv(i1) | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) == 0 | (i3 | 0) == (0 - i4 | 0)) i1 = 0; else {
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 34; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
     i2 = HEAP32[i5 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 34; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 36;
    }
   }
   if ((i9 | 0) == 34) i9 = 36;
   if ((i9 | 0) == 36) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
   i4 = __ZN6Avatar8GetAssetEv(i1) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i4 = (i1 | 0) == 0 ? 0 : i1 + i4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 42; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
     i2 = HEAP32[i5 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 42; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 44;
    }
   }
   if ((i9 | 0) == 42) i9 = 44;
   if ((i9 | 0) == 44) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
   i9 = (__ZN6Avatar8GetAssetEv(i1) | 0) + 16 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i1 = __Z14FindAvatarRootPKN7mecanim8skeleton8SkeletonEPKjR9Transformb(i4, (i1 | 0) == 0 ? 0 : i9 + i1 | 0, i10, (HEAP8[i8 + 561 >> 0] | 0) != 0) | 0;
  }
 }
 i10 = (i1 | 0) == 0 ? i10 : i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN19VREyeTextureManager12BlitToBufferE15UnityVRBlitModeRK5RectTIfEfP13RenderTexture(i3, i17, i11, f25, i28) {
 i3 = i3 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 f25 = Math_fround(f25);
 i28 = i28 | 0;
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0, i36 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i34 + 200 | 0;
 i30 = i34 + 192 | 0;
 i31 = i34 + 184 | 0;
 i32 = i34 + 176 | 0;
 i33 = i34 + 168 | 0;
 i18 = i34 + 160 | 0;
 i19 = i34 + 144 | 0;
 i4 = i34 + 136 | 0;
 i5 = i34 + 112 | 0;
 i6 = i34 + 104 | 0;
 i7 = i34 + 96 | 0;
 i20 = i34 + 120 | 0;
 i8 = i34 + 88 | 0;
 i9 = i34 + 80 | 0;
 i10 = i34 + 72 | 0;
 i12 = i34 + 64 | 0;
 i13 = i34 + 56 | 0;
 i14 = i34 + 48 | 0;
 i15 = i34 + 40 | 0;
 i16 = i34 + 32 | 0;
 i21 = i34 + 24 | 0;
 i22 = i34 + 16 | 0;
 i23 = i34 + 8 | 0;
 i24 = i34;
 i26 = HEAP8[i3 + 68 >> 0] | 0;
 i27 = i3 + 36 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 if (!i1) {
  STACKTOP = i34;
  return;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i34;
  return;
 }
 i1 = (i1 & 2 | 0) != 0;
 i36 = __Z16GetScreenManagerv() | 0;
 f35 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 80 >> 2] | 0, i36 | 0) | 0);
 i36 = __Z16GetScreenManagerv() | 0;
 f2 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i36 >> 2] | 0) + 84 >> 2] | 0, i36 | 0) | 0);
 HEAPF32[i29 >> 2] = f35;
 HEAPF32[i29 + 4 >> 2] = f2;
 f2 = Math_fround((HEAP32[i3 + 56 >> 2] | 0) >>> 0);
 HEAPF32[i30 + 4 >> 2] = Math_fround((HEAP32[i3 + 60 >> 2] | 0) >>> 0);
 HEAPF32[i30 >> 2] = Math_fround((i1 ? Math_fround(2.0) : Math_fround(1.0)) * f2);
 do if ((i17 | 0) == 3) if (i1) {
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 12 >> 2] = Math_fround(1.0);
  __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_(i30, i11, i29, i19, 1, f25, i31, i32, i33, i18);
  i36 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b(i36, i4, i5, i28, i6, i7, i26 << 24 >> 24 != 0);
  break;
 } else {
  HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 8 >> 2] = Math_fround(.5);
  HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 12 >> 2] = Math_fround(1.0);
  __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_(i30, i19, i29, i20, 1, f25, i31, i32, i33, i18);
  i17 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i31 >> 2];
  i21 = i31 + 4 | 0;
  HEAP32[i8 + 4 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i32 >> 2];
  i22 = i32 + 4 | 0;
  HEAP32[i9 + 4 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i33 >> 2];
  i23 = i33 + 4 | 0;
  HEAP32[i10 + 4 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
  i24 = i18 + 4 | 0;
  HEAP32[i12 + 4 >> 2] = HEAP32[i24 >> 2];
  i36 = i26 << 24 >> 24 != 0;
  __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b(i17, i8, i9, i28, i10, i12, i36);
  HEAPF32[i20 >> 2] = Math_fround(.5);
  HEAPF32[i20 + 8 >> 2] = Math_fround(.5);
  HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 12 >> 2] = Math_fround(1.0);
  __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_(i30, i19, i29, i20, 1, f25, i31, i32, i33, i18);
  i30 = HEAP32[(HEAP32[i27 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i24 >> 2];
  __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b(i30, i13, i14, i28, i15, i16, i36);
  break;
 } else {
  HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  if (i1) {
   i36 = i19 + 8 | 0;
   HEAPF32[i36 >> 2] = Math_fround(Math_fround(HEAPF32[i36 >> 2]) * Math_fround(.5));
   f2 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * Math_fround(.5));
   HEAPF32[i19 >> 2] = f2;
   if ((i17 | 0) == 2) {
    HEAPF32[i19 >> 2] = Math_fround(f2 + Math_fround(.5));
    i1 = 0;
   } else i1 = 0;
  } else i1 = (i17 | 0) == 2 & 1;
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 12 >> 2] = Math_fround(1.0);
  __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_(i30, i19, i29, i20, 1, f25, i31, i32, i33, i18);
  i36 = HEAP32[(HEAP32[i27 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i21 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i23 >> 2] = HEAP32[i33 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i33 + 4 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b(i36, i21, i22, i28, i23, i24, i26 << 24 >> 24 != 0);
 } while (0);
 STACKTOP = i34;
 return;
}

function __ZN43CapsuleHeightfieldContactGenerationCallback7onEventEjPj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, f55 = f0, i56 = 0, i57 = 0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 960 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i46 = i49 + 96 | 0;
 i48 = i49 + 48 | 0;
 i47 = i49 + 60 | 0;
 i44 = i49;
 i45 = i49 + 12 | 0;
 i40 = i46 + 848 | 0;
 HEAP32[i40 >> 2] = 0;
 i41 = (i3 + 15 | 0) >>> 4;
 if (!i41) {
  STACKTOP = i49;
  return 1;
 }
 i42 = i1 + 4 | 0;
 i43 = i1 + 28 | 0;
 i35 = i1 + 8 | 0;
 i36 = i47 + 12 | 0;
 i37 = i47 + 16 | 0;
 i38 = i47 + 4 | 0;
 i18 = i47 + 20 | 0;
 i19 = i47 + 8 | 0;
 i20 = i47 + 24 | 0;
 i21 = i47 + 28 | 0;
 i22 = i47 + 32 | 0;
 i23 = i45 + 12 | 0;
 i24 = i45 + 16 | 0;
 i25 = i45 + 4 | 0;
 i26 = i45 + 20 | 0;
 i27 = i45 + 8 | 0;
 i28 = i45 + 24 | 0;
 i29 = i45 + 28 | 0;
 i30 = i45 + 32 | 0;
 i31 = i47 + 12 | 0;
 i32 = i47 + 24 | 0;
 i33 = i48 + 4 | 0;
 i34 = i48 + 8 | 0;
 i39 = 0;
 do {
  HEAP32[i40 >> 2] = 0;
  i17 = i3 >>> 0 < 16 ? i3 : 16;
  if (i17) {
   i14 = (i3 ^ -16) >>> 0 > 4294967279;
   i13 = i17;
   i16 = i2;
   do {
    i13 = i13 + -1 | 0;
    i15 = HEAP32[i16 >> 2] | 0;
    i16 = i16 + 4 | 0;
    __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i43 >> 2] | 0, HEAP32[i35 >> 2] | 0, i47, i48, i44, i15, 0, 0) | 0;
    f10 = Math_fround(HEAPF32[i36 >> 2]);
    f7 = Math_fround(HEAPF32[i47 >> 2]);
    f10 = Math_fround(f10 - f7);
    f5 = Math_fround(HEAPF32[i37 >> 2]);
    f11 = Math_fround(HEAPF32[i38 >> 2]);
    f5 = Math_fround(f5 - f11);
    f9 = Math_fround(HEAPF32[i18 >> 2]);
    f6 = Math_fround(HEAPF32[i19 >> 2]);
    f9 = Math_fround(f9 - f6);
    f7 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f7);
    f11 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f11);
    f6 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f6);
    f4 = Math_fround(Math_fround(f5 * f6) - Math_fround(f9 * f11));
    f6 = Math_fround(Math_fround(f9 * f7) - Math_fround(f10 * f6));
    f7 = Math_fround(Math_fround(f10 * f11) - Math_fround(f5 * f7));
    f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)))));
    if (f5 > Math_fround(0.0)) {
     f11 = Math_fround(Math_fround(1.0) / f5);
     f4 = Math_fround(f4 * f11);
     f6 = Math_fround(f6 * f11);
     f7 = Math_fround(f7 * f11);
    }
    i12 = 0;
    i1 = 0;
    do {
     i8 = HEAP32[i44 + (i12 << 2) >> 2] | 0;
     if ((i8 | 0) == -1) i1 = (1 << i12 + 3 | i1 & 255) & 255; else {
      __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i43 >> 2] | 0, HEAP32[i35 >> 2] | 0, i45, 0, 0, i8, 0, 0) | 0;
      f54 = Math_fround(HEAPF32[i23 >> 2]);
      f51 = Math_fround(HEAPF32[i45 >> 2]);
      f54 = Math_fround(f54 - f51);
      f52 = Math_fround(HEAPF32[i24 >> 2]);
      f50 = Math_fround(HEAPF32[i25 >> 2]);
      f52 = Math_fround(f52 - f50);
      f55 = Math_fround(HEAPF32[i26 >> 2]);
      f9 = Math_fround(HEAPF32[i27 >> 2]);
      f55 = Math_fround(f55 - f9);
      f5 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f51);
      f53 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f50);
      f11 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) - f9);
      f10 = Math_fround(Math_fround(f52 * f11) - Math_fround(f55 * f53));
      f11 = Math_fround(Math_fround(f55 * f5) - Math_fround(f54 * f11));
      f5 = Math_fround(Math_fround(f54 * f53) - Math_fround(f52 * f5));
      i8 = HEAPU8[gb + 768833 + i12 >> 0] | 0;
      f51 = Math_fround(Math_fround(HEAPF32[i47 + (i8 * 12 | 0) >> 2]) - f51);
      f50 = Math_fround(Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 4 >> 2]) - f50);
      if (Math_fround(Math_fround(Math_fround(f10 * f51) + Math_fround(f11 * f50)) + Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i47 + (i8 * 12 | 0) + 8 >> 2]) - f9))) < Math_fround(0.0)) {
       f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)))));
       if (f9 > Math_fround(0.0)) {
        f55 = Math_fround(Math_fround(1.0) / f9);
        f10 = Math_fround(f10 * f55);
        f9 = Math_fround(f11 * f55);
        f5 = Math_fround(f5 * f55);
       } else f9 = f11;
       if (Math_fround(Math_fround(f7 * f5) + Math_fround(Math_fround(f6 * f9) + Math_fround(f4 * f10))) < Math_fround(.999000012)) i1 = (1 << i12 + 3 | i1 & 255) & 255;
      }
     }
     i12 = i12 + 1 | 0;
    } while ((i12 | 0) != 3);
    i12 = HEAP32[i40 >> 2] | 0;
    HEAP32[i40 >> 2] = i12 + 1;
    i57 = i12 * 3 | 0;
    HEAP32[i46 + (i57 * 12 | 0) >> 2] = HEAP32[i47 >> 2];
    HEAP32[i46 + (i57 * 12 | 0) + 4 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i46 + (i57 * 12 | 0) + 8 >> 2] = HEAP32[i19 >> 2];
    i56 = i57 + 1 | 0;
    HEAP32[i46 + (i56 * 12 | 0) >> 2] = HEAP32[i31 >> 2];
    HEAP32[i46 + (i56 * 12 | 0) + 4 >> 2] = HEAP32[i37 >> 2];
    HEAP32[i46 + (i56 * 12 | 0) + 8 >> 2] = HEAP32[i18 >> 2];
    i8 = i57 + 2 | 0;
    HEAP32[i46 + (i8 * 12 | 0) >> 2] = HEAP32[i32 >> 2];
    HEAP32[i46 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i46 + (i8 * 12 | 0) + 8 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i46 + 576 + (i57 << 2) >> 2] = HEAP32[i48 >> 2];
    HEAP32[i46 + 576 + (i56 << 2) >> 2] = HEAP32[i33 >> 2];
    HEAP32[i46 + 576 + (i8 << 2) >> 2] = HEAP32[i34 >> 2];
    HEAP32[i46 + 768 + (i12 << 2) >> 2] = i15;
    HEAP8[i46 + 832 + i12 >> 0] = i1;
   } while ((i13 | 0) != 0);
   i2 = i2 + ((i14 ? i3 : 16) << 2) | 0;
  }
  i3 = i3 - i17 | 0;
  __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE(i42, i46) | 0;
  i39 = i39 + 1 | 0;
 } while ((i39 | 0) != (i41 | 0));
 STACKTOP = i49;
 return 1;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i8 = i15;
 i3 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 36 | 0;
 i5 = i1;
 if (i2 >>> 0 < i6 >>> 0) {
  i5 = i12 + 8 | 0;
  if ((((HEAP32[i5 >> 2] | 0) - i1 | 0) / 36 | 0 | 0) == (i6 | 0)) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE8__appendEj(i12, i6 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i8, i6);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i11, i14);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = (i2 - i4 | 0) / 36 | 0;
  i1 = i2;
  if (i3 >>> 0 < i6 >>> 0) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE8__appendEj(i8, i6 - i3 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i3 >>> 0 > i6 >>> 0) {
   i4 = i4 + (i6 * 36 | 0) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i2 = i1 + -36 | 0;
     HEAP32[i7 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i11 = HEAP32[i1 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
      i2 = HEAP32[i7 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i13 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i5 + (i6 * 36 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i6 * 36 | 0;
 i2 = (i1 | 0) / 36 | 0;
 if (!i1) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = __Znwj(i1) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i3;
  i2 = i3 + (i2 * 36 | 0) | 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i3;
  if (!i6) {
   i4 = i8;
   i5 = i1;
   i3 = i1;
  } else {
   i6 = i14 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i1 = i4 << 24 >> 24 < 0;
    i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 + 12 >> 2] = i1;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     i9 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i3 + 11 >> 0] = i4;
     if (!i4) i1 = i3; else {
      i1 = i3;
      i9 = 34;
     }
    } else i9 = 32;
    if ((i9 | 0) == 32) {
     i16 = i4 + 16 & -16;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i6 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i3 + 8 >> 2] = i16 | -2147483648;
     HEAP32[i3 + 4 >> 2] = i4;
     i9 = 34;
    }
    if ((i9 | 0) == 34) {
     i9 = 0;
     _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i16 = i3 + 16 | 0;
    i4 = i5 + 16 | 0;
    HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP8[i16 + 16 >> 0] = HEAP8[i4 + 16 >> 0] | 0;
    i5 = i5 + 36 | 0;
    i3 = (HEAP32[i10 >> 2] | 0) + 36 | 0;
    HEAP32[i10 >> 2] = i3;
   } while ((i5 | 0) != (i7 | 0));
   i4 = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i13 >> 2] = i3;
 i13 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i4 = i1;
 i2 = i16;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -36 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i16 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i8 = i15;
 i3 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 36 | 0;
 i5 = i1;
 if (i2 >>> 0 < i6 >>> 0) {
  i5 = i12 + 8 | 0;
  if ((((HEAP32[i5 >> 2] | 0) - i1 | 0) / 36 | 0 | 0) == (i6 | 0)) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE8__appendEj(i12, i6 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i8, i6);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i11, i14);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = (i2 - i4 | 0) / 36 | 0;
  i1 = i2;
  if (i3 >>> 0 < i6 >>> 0) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE8__appendEj(i8, i6 - i3 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i3 >>> 0 > i6 >>> 0) {
   i4 = i4 + (i6 * 36 | 0) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i2 = i1 + -36 | 0;
     HEAP32[i7 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i11 = HEAP32[i1 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
      i2 = HEAP32[i7 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i13 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i5 + (i6 * 36 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i6 * 36 | 0;
 i2 = (i1 | 0) / 36 | 0;
 if (!i1) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = __Znwj(i1) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i3;
  i2 = i3 + (i2 * 36 | 0) | 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i3;
  if (!i6) {
   i4 = i8;
   i5 = i1;
   i3 = i1;
  } else {
   i6 = i14 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i1 = i4 << 24 >> 24 < 0;
    i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 + 12 >> 2] = i1;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     i9 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i3 + 11 >> 0] = i4;
     if (!i4) i1 = i3; else {
      i1 = i3;
      i9 = 34;
     }
    } else i9 = 32;
    if ((i9 | 0) == 32) {
     i16 = i4 + 16 & -16;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i6 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i3 + 8 >> 2] = i16 | -2147483648;
     HEAP32[i3 + 4 >> 2] = i4;
     i9 = 34;
    }
    if ((i9 | 0) == 34) {
     i9 = 0;
     _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i16 = i3 + 16 | 0;
    i4 = i5 + 16 | 0;
    HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP8[i16 + 16 >> 0] = HEAP8[i4 + 16 >> 0] | 0;
    i5 = i5 + 36 | 0;
    i3 = (HEAP32[i10 >> 2] | 0) + 36 | 0;
    HEAP32[i10 >> 2] = i3;
   } while ((i5 | 0) != (i7 | 0));
   i4 = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i13 >> 2] = i3;
 i13 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i4 = i1;
 i2 = i16;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -36 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i16 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_(i2, i1, i6, i8, i7, i14, i15) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var f3 = f0, i4 = 0, f5 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f16 = f0, f17 = f0;
 L1 : do switch ((Math_imul(i6, -3) | 0) + i1 | 0) {
 case 0:
  {
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i2 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 36 >> 2] | 0;
   f3 = Math_fround(f11 * Math_fround(HEAP16[i2 + (i6 << 2) >> 1] | 0));
   f11 = Math_fround(f11 * Math_fround(HEAP16[i2 + (i6 + 1 << 2) >> 1] | 0));
   f10 = Math_fround(Math_fround(i8 >>> 0) * Math_fround(HEAPF32[i1 + 12 >> 2]));
   f12 = Math_fround(i7 >>> 0);
   f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f12 = Math_fround(f12 * f13);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(f11 - f3);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 0;
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(Math_fround(f13 * f13) + Math_fround(f3 * f3));
   break;
  }
 case 1:
  {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   i4 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   if ((HEAP8[i4 + (i6 << 2) + 2 >> 0] | 0) < 0) {
    f13 = Math_fround(f3 * Math_fround(HEAP16[i4 + (i6 << 2) >> 1] | 0));
    f3 = Math_fround(f3 * Math_fround(HEAP16[i4 + (i6 + 1 + i1 << 2) >> 1] | 0));
    f11 = Math_fround(Math_fround(i8 >>> 0) * f5);
    f12 = Math_fround(Math_fround(i7 >>> 0) * f9);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f3 = Math_fround(f3 - f13);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
    f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9)) + Math_fround(f3 * f3));
    break L1;
   } else {
    f13 = Math_fround(f3 * Math_fround(HEAP16[i4 + (i6 + 1 << 2) >> 1] | 0));
    f3 = Math_fround(f3 * Math_fround(HEAP16[i4 + (i1 + i6 << 2) >> 1] | 0));
    f11 = Math_fround(Math_fround(i8 >>> 0) * f5);
    f12 = Math_fround(Math_fround((i7 + 1 | 0) >>> 0) * f9);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    f3 = Math_fround(f3 - f13);
    f13 = Math_fround(-f9);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
    f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9)) + Math_fround(f3 * f3));
    break L1;
   }
  }
 case 2:
  {
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   i2 = HEAP32[i2 + 12 >> 2] | 0;
   i4 = HEAP32[i2 + 36 >> 2] | 0;
   f3 = Math_fround(f11 * Math_fround(HEAP16[i4 + (i6 << 2) >> 1] | 0));
   f11 = Math_fround(f11 * Math_fround(HEAP16[i4 + ((HEAP32[i2 + 20 >> 2] | 0) + i6 << 2) >> 1] | 0));
   f10 = Math_fround(i8 >>> 0);
   f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f10 = Math_fround(f10 * f13);
   f12 = Math_fround(Math_fround(i7 >>> 0) * Math_fround(HEAPF32[i1 + 16 >> 2]));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f3 = Math_fround(f11 - f3);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = 0;
   f3 = Math_fround(Math_fround(f13 * f13) + Math_fround(f3 * f3));
   break;
  }
 default:
  {
   i6 = 0;
   i7 = 0;
   i8 = 0;
   i1 = 0;
   i2 = 0;
   i4 = 0;
   f3 = Math_fround(0.0);
  }
 } while (0);
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 - f12);
 f17 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f13 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(f17 - f13);
 f16 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f16 - f11);
 f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f10 * f5);
 f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(f5 + Math_fround(f9 * f17));
 f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_fround(f17 + Math_fround(f5 * f16)) / f3);
 if (f3 < Math_fround(0.0)) {
  HEAP32[i15 >> 2] = i6;
  HEAP32[i15 + 4 >> 2] = i7;
  HEAP32[i15 + 8 >> 2] = i8;
  return Math_fround(f3);
 }
 if (f3 > Math_fround(1.0)) {
  f16 = Math_fround(f13 + f9);
  f17 = Math_fround(f11 + f5);
  HEAPF32[i15 >> 2] = Math_fround(f12 + f10);
  HEAPF32[i15 + 4 >> 2] = f16;
  HEAPF32[i15 + 8 >> 2] = f17;
  return Math_fround(f3);
 } else {
  f16 = Math_fround(f13 + Math_fround(f9 * f3));
  f17 = Math_fround(f11 + Math_fround(f5 * f3));
  HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(f10 * f3));
  HEAPF32[i15 + 4 >> 2] = f16;
  HEAPF32[i15 + 8 >> 2] = f17;
  return Math_fround(f3);
 }
 return f0;
}

function __ZNK5Umbra11Transformer16getNearPlaneQuadEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i3 = i1 + 4 + 8 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i29 = i2 + 128 | 0;
 f5 = Math_fround(HEAPF32[i29 >> 2]);
 i28 = i2 + 132 | 0;
 f14 = Math_fround(HEAPF32[i28 >> 2]);
 i27 = i2 + 136 | 0;
 f7 = Math_fround(HEAPF32[i27 >> 2]);
 i26 = i2 + 140 | 0;
 f12 = Math_fround(HEAPF32[i26 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 160 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 164 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 168 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 172 >> 2]);
 i22 = i2 + 192 | 0;
 f17 = Math_fround(HEAPF32[i22 >> 2]);
 i21 = i2 + 196 | 0;
 f6 = Math_fround(HEAPF32[i21 >> 2]);
 i3 = i2 + 200 | 0;
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i2 + 204 | 0;
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f20 = Math_fround(Math_fround(f10 * f24) - Math_fround(f9 * f6));
 f13 = Math_fround(Math_fround(f9 * f17) - Math_fround(f11 * f24));
 f8 = Math_fround(Math_fround(f11 * f6) - Math_fround(f10 * f17));
 f23 = Math_fround(Math_fround(f14 * f9) - Math_fround(f7 * f10));
 f16 = Math_fround(Math_fround(f7 * f11) - Math_fround(f5 * f9));
 f25 = Math_fround(Math_fround(f5 * f10) - Math_fround(f14 * f11));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f7 * f8) + Math_fround(Math_fround(f5 * f20) + Math_fround(f14 * f13))));
 f13 = Math_fround(-Math_fround(Math_fround(Math_fround(f16 * f19) + Math_fround(Math_fround(f12 * f13) + Math_fround(f18 * Math_fround(Math_fround(f5 * f24) - Math_fround(f7 * f17))))) * f15));
 f17 = Math_fround(-Math_fround(Math_fround(Math_fround(f25 * f19) + Math_fround(Math_fround(f12 * f8) + Math_fround(f18 * Math_fround(Math_fround(f14 * f17) - Math_fround(f5 * f6))))) * f15));
 HEAPF32[i1 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(Math_fround(f12 * f20) + Math_fround(f18 * Math_fround(Math_fround(f7 * f6) - Math_fround(f14 * f24))))) * f15));
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f17;
 f17 = Math_fround(HEAPF32[i2 + 208 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 212 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 216 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 220 >> 2]);
 f6 = Math_fround(Math_fround(f10 * f15) - Math_fround(f9 * f13));
 f9 = Math_fround(Math_fround(f9 * f17) - Math_fround(f11 * f15));
 f10 = Math_fround(Math_fround(f11 * f13) - Math_fround(f10 * f17));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f7 * f10) + Math_fround(Math_fround(f5 * f6) + Math_fround(f14 * f9))));
 f9 = Math_fround(-Math_fround(Math_fround(Math_fround(f16 * f24) + Math_fround(Math_fround(f12 * f9) + Math_fround(f18 * Math_fround(Math_fround(f5 * f15) - Math_fround(f7 * f17))))) * f11));
 f5 = Math_fround(-Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(Math_fround(f12 * f10) + Math_fround(f18 * Math_fround(Math_fround(f14 * f17) - Math_fround(f5 * f13))))) * f11));
 HEAPF32[i1 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f23 * f24) + Math_fround(Math_fround(f12 * f6) + Math_fround(f18 * Math_fround(Math_fround(f7 * f13) - Math_fround(f14 * f15))))) * f11));
 HEAPF32[i1 + 16 >> 2] = f9;
 HEAPF32[i1 + 20 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i29 >> 2]);
 f9 = Math_fround(HEAPF32[i28 >> 2]);
 f11 = Math_fround(HEAPF32[i27 >> 2]);
 f14 = Math_fround(HEAPF32[i26 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 176 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 180 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 184 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 188 >> 2]);
 f23 = Math_fround(Math_fround(f18 * f15) - Math_fround(f6 * f13));
 f10 = Math_fround(Math_fround(f6 * f17) - Math_fround(f7 * f15));
 f25 = Math_fround(Math_fround(f7 * f13) - Math_fround(f18 * f17));
 f16 = Math_fround(Math_fround(f9 * f6) - Math_fround(f11 * f18));
 f20 = Math_fround(Math_fround(f11 * f7) - Math_fround(f5 * f6));
 f19 = Math_fround(Math_fround(f5 * f18) - Math_fround(f9 * f7));
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f11 * f25) + Math_fround(Math_fround(f5 * f23) + Math_fround(f9 * f10))));
 f10 = Math_fround(-Math_fround(Math_fround(Math_fround(f20 * f24) + Math_fround(Math_fround(f14 * f10) + Math_fround(f12 * Math_fround(Math_fround(f5 * f15) - Math_fround(f11 * f17))))) * f8));
 f17 = Math_fround(-Math_fround(Math_fround(Math_fround(f19 * f24) + Math_fround(Math_fround(f14 * f25) + Math_fround(f12 * Math_fround(Math_fround(f9 * f17) - Math_fround(f5 * f13))))) * f8));
 HEAPF32[i1 + 24 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f16 * f24) + Math_fround(Math_fround(f14 * f23) + Math_fround(f12 * Math_fround(Math_fround(f11 * f13) - Math_fround(f9 * f15))))) * f8));
 HEAPF32[i1 + 28 >> 2] = f10;
 HEAPF32[i1 + 32 >> 2] = f17;
 f17 = Math_fround(HEAPF32[i22 >> 2]);
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(Math_fround(f18 * f8) - Math_fround(f6 * f10));
 f6 = Math_fround(Math_fround(f6 * f17) - Math_fround(f7 * f8));
 f18 = Math_fround(Math_fround(f7 * f10) - Math_fround(f18 * f17));
 f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f11 * f18) + Math_fround(Math_fround(f5 * f13) + Math_fround(f9 * f6))));
 f6 = Math_fround(-Math_fround(Math_fround(Math_fround(f20 * f15) + Math_fround(Math_fround(f14 * f6) + Math_fround(f12 * Math_fround(Math_fround(f5 * f8) - Math_fround(f11 * f17))))) * f7));
 f5 = Math_fround(-Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(Math_fround(f14 * f18) + Math_fround(f12 * Math_fround(Math_fround(f9 * f17) - Math_fround(f5 * f10))))) * f7));
 HEAPF32[i1 + 36 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f8))))) * f7));
 HEAPF32[i1 + 40 >> 2] = f6;
 HEAPF32[i1 + 44 >> 2] = f5;
 return;
}

function __ZN14DetailDatabase17RefreshPrototypesEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 20 | 0;
 i18 = i20 + 8 | 0;
 i3 = i20;
 HEAP32[i18 >> 2] = 0;
 i19 = i18 + 4 | 0;
 i15 = gb + 63160 | 0;
 i13 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 i14 = i17 + 16 | 0;
 i13 = i17 + 20 | 0;
 i15 = (HEAP32[i13 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0;
 i1 = ((i15 | 0) / 136 | 0) << 2;
 do if (!i15) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 577) | 0;
   i12 = gb + 64016 | 0;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i15 = i19;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i15 + 4 >> 2] = i12;
   break;
  }
 } while (0);
 i9 = i1 + 3 & -4;
 __ZN14DetailDatabase22RefreshPrototypesStep1EPP9Texture2D(i17, i9);
 i15 = i17 + 56 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) {
  i4 = gb + 63520 | 0;
  i11 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = i3;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  i12 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i16) | 0;
  HEAP32[i15 >> 2] = i12;
  mftCall_iiiiiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 188 >> 2] | 0, i12 | 0, 2, 2, 5, 1, 1, -1, 0) | 0;
  i12 = HEAP32[i15 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0, 61);
  __ZN7Texture11SetWrapModeEi(HEAP32[i15 >> 2] | 0, 1);
 } else if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
  __ZN7Texture11SetWrapModeEi(HEAP32[i15 >> 2] | 0, 1);
  i11 = i17 + 116 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i10 = i1;
  if ((i2 | 0) != (i1 | 0)) {
   i4 = (i2 - i1 | 0) / 136 | 0;
   i3 = 0;
   do {
    f5 = Math_fround(HEAPF32[i12 + (i3 << 4) >> 2]);
    f6 = Math_fround(HEAPF32[i12 + (i3 << 4) + 4 >> 2]);
    f7 = Math_fround(HEAPF32[i12 + (i3 << 4) + 8 >> 2]);
    f8 = Math_fround(HEAPF32[i12 + (i3 << 4) + 12 >> 2]);
    i1 = HEAP32[i10 + (i3 * 136 | 0) + 104 >> 2] | 0;
    i2 = HEAP32[i10 + (i3 * 136 | 0) + 100 >> 2] | 0;
    i9 = i2;
    if ((i1 | 0) != (i2 | 0)) {
     i2 = i1 - i2 >> 3;
     i1 = 0;
     do {
      i16 = i9 + (i1 << 3) | 0;
      HEAPF32[i16 >> 2] = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i16 >> 2])));
      i16 = i9 + (i1 << 3) + 4 | 0;
      HEAPF32[i16 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i4 >>> 0);
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i12, gb + 63312 | 0);
  HEAP32[i11 >> 2] = 0;
  __Z18UploadTextureAtlasP9Texture2Db(HEAP32[i15 >> 2] | 0, 0);
  HEAP8[i17 >> 0] = 0;
  i18 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
  STACKTOP = i20;
  return;
 }
 HEAP32[i16 >> 2] = 0;
 i12 = i16 + 4 | 0;
 i11 = gb + 63160 | 0;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 i4 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i11 = i4 - i2 | 0;
 i1 = ((i11 | 0) / 136 | 0) << 4;
 do if (!i11) {
  i1 = 0;
  i3 = i4;
 } else {
  i3 = (i1 | 4) + -1 | 0;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i3 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 608) | 0;
   i2 = gb + 64016 | 0;
   i11 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = i1;
   i3 = i12;
   HEAP32[i3 >> 2] = i11;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  }
 } while (0);
 i11 = i1 + 3 & -4;
 i4 = i3 - i2 | 0;
 i2 = (i4 | 0) / 136 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 L29 : do if ((i4 | 0) > 0) {
  i1 = 0;
  while (1) {
   i4 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if (i4 | 0) if (HEAP32[i4 + 60 >> 2] | 0) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i10 = 24;
    break L29;
   }
  }
  __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
 } else i10 = 24; while (0);
 if ((i10 | 0) == 24) __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 0);
 __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb(HEAP32[i15 >> 2] | 0, 2048, i2, i9, i11, 0, 1, 0) | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i10 = i1;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = (i2 - i1 | 0) / 136 | 0;
  i3 = 0;
  do {
   f5 = Math_fround(HEAPF32[i11 + (i3 << 4) >> 2]);
   f6 = Math_fround(HEAPF32[i11 + (i3 << 4) + 4 >> 2]);
   f7 = Math_fround(HEAPF32[i11 + (i3 << 4) + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i11 + (i3 << 4) + 12 >> 2]);
   i1 = HEAP32[i10 + (i3 * 136 | 0) + 104 >> 2] | 0;
   i2 = HEAP32[i10 + (i3 * 136 | 0) + 100 >> 2] | 0;
   i9 = i2;
   if ((i1 | 0) != (i2 | 0)) {
    i2 = i1 - i2 >> 3;
    i1 = 0;
    do {
     i15 = i9 + (i1 << 3) | 0;
     HEAPF32[i15 >> 2] = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i15 >> 2])));
     i15 = i9 + (i1 << 3) + 4 | 0;
     HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i12);
 HEAP8[i17 >> 0] = 0;
 i18 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
 STACKTOP = i20;
 return;
}

function __ZN15DirectorManager17RemoveFromManagerEP14DirectorPlayer(i19, i18) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i22 + 8 | 0;
 i8 = i22;
 i20 = i22 + 36 | 0;
 i21 = i22 + 16 | 0;
 i4 = HEAP32[i19 + 444 >> 2] | 0;
 i5 = i19 + 456 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L1 : do if (i6 | 0) {
  L3 : do if (!i18) {
   i2 = i4 + (i6 << 2) | 0;
   i1 = i4;
   while (1) {
    if (!(HEAP32[i1 >> 2] | 0)) {
     i2 = 0;
     break L3;
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) break L1;
   }
  } else {
   i2 = HEAP32[i18 + 4 >> 2] | 0;
   i3 = i4 + (i6 << 2) | 0;
   i1 = i4;
   while (1) {
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break L3;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i3 | 0)) break L1;
   }
  } while (0);
  i17 = i4 + (i6 + -1 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i17 >> 2] = i2;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 } while (0);
 i11 = i19 + 376 | 0;
 i2 = (HEAP32[i19 + 396 >> 2] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i8;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i20 >> 2] = 0;
 i13 = i20 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i20 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i8);
 i12 = i7;
 i16 = HEAP32[i12 + 4 >> 2] | 0;
 i17 = i15;
 HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i17 + 4 >> 2] = i16;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i12 = i8;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i12 + 4 >> 2] = i16;
 HEAP32[i21 >> 2] = 0;
 i12 = i21 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i16 = i21 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i8);
 i9 = i7;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i17;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = HEAP32[i14 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i14 >> 2] = i2;
  HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i2 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i20 >> 2] = i10;
  break;
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i16 >> 2] = i2;
  HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
  HEAP32[i16 >> 2] = i2;
  HEAP32[i21 >> 2] = i10;
  break;
 } while (0);
 i8 = i19 + 364 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i7 = HEAP32[i8 >> 2] | 0;
  do {
   i10 = HEAP32[i7 >> 2] | 0;
   i9 = i10 + 4 | 0;
   i10 = i10 + 16 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) {
    i6 = HEAP32[i9 >> 2] | 0;
    do {
     do if ((HEAP32[i6 >> 2] | 0) == (i18 | 0)) if (i1 >>> 0 > 1) {
      i2 = HEAP32[i12 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i16 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i16 >> 2] = i1;
        HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i1 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i5 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
        HEAP32[i16 >> 2] = i1;
        HEAP32[i21 >> 2] = i5;
        break;
       }
      } while (0);
      HEAP32[i12 >> 2] = i3;
      HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i7 >> 2];
      break;
     } else {
      i2 = HEAP32[i13 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i14 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i14 >> 2] = i1;
        HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i5 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
        HEAP32[i14 >> 2] = i1;
        HEAP32[i20 >> 2] = i5;
        break;
       }
      } while (0);
      HEAP32[i13 >> 2] = i3;
      HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i7 >> 2];
      break;
     } while (0);
     i6 = i6 + 4 | 0;
     i1 = HEAP32[i10 >> 2] | 0;
    } while ((i6 | 0) != ((HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0));
   }
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) != ((HEAP32[i8 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) | 0));
 }
 if (HEAP32[i13 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN15DirectorManager17RemoveFromManagerEP18PlayableController(i19, HEAP32[(HEAP32[i20 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i17);
  HEAP32[i21 >> 2] = 0;
 }
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i22;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i15);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i22;
 return;
}

function __ZN17MessageIdentifier17GetSortedMessagesEb(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20;
 i13 = i20 + 56 | 0;
 i14 = i20 + 24 | 0;
 i15 = i20 + 88 | 0;
 i16 = i5 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i5 + 8 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = i18;
 i19 = HEAP32[gb + 1104732 >> 2] | 0;
 i1 = HEAP32[i19 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i19 | 0)) {
  STACKTOP = i20;
  return;
 }
 i7 = i14 + 12 | 0;
 i8 = i13 + 12 | 0;
 i9 = i12 + 11 | 0;
 i10 = i12 + 11 | 0;
 i11 = i12 + 11 | 0;
 do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i1 + 16 | 0;
  do if (!((HEAP32[i3 >> 2] & 2 | 0) != 0 ^ i6)) {
   i4 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, _strlen(i4) | 0);
   i4 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i5, i12) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   if ((i4 | 0) == (i18 | 0)) {
    i3 = HEAP32[i1 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i3, _strlen(i3) | 0);
    HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i15);
    HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i14);
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESL_RKT_(i5, i12, i13) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) {
     i1 = __Znwj(48) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i13);
     i4 = i1 + 28 | 0;
     HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     i4 = HEAP32[i12 >> 2] | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = i4;
     HEAP32[i3 >> 2] = i1;
     i4 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     if (i4) {
      HEAP32[i5 >> 2] = i4;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i1);
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
    break;
   }
   if ((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i4 + 40 >> 2] | 0)) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 372749 | 0, 50);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, HEAP32[i1 >> 2] | 0) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 372800 | 0) | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 372890 | 0, 51, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   }
   if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i4 + 32 >> 2] | 0)) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 372749 | 0, 50);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, HEAP32[i1 >> 2] | 0) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 372800 | 0) | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 372890 | 0, 59, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   }
   if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i4 + 44 >> 2] | 0)) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 372972 | 0, 46);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, HEAP32[i1 >> 2] | 0) | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 372890 | 0, 66, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i19 | 0));
 STACKTOP = i20;
 return;
}

function __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f(i4, i1, i2, f35) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f35 = Math_fround(f35);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, f37 = f0, f38 = f0, i39 = 0, f40 = f0, i41 = 0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, i46 = 0, f47 = f0, i48 = 0, f49 = f0, i50 = 0, f51 = f0, i52 = 0, f53 = f0, i54 = 0, f55 = f0, i56 = 0, f57 = f0, i58 = 0, f59 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i36;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = (i3 | 0) > 0 ? i3 : 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i6 = (i6 | 0) < 64 ? i6 : 64;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = (i1 | 0) > 0 ? i1 : 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (i2 | 0) < 64 ? i2 : 64;
 if (!((i3 | 0) < (i6 | 0) & (i1 | 0) < (i2 | 0))) {
  i34 = 0;
  STACKTOP = i36;
  return i34 | 0;
 }
 i25 = i3 >> 2;
 i26 = i1 >> 2;
 i23 = HEAP32[gb + 78732 + ((i3 & 3) << 2) >> 2] | 0;
 i31 = HEAP32[gb + 78748 + ((i6 & 3) << 2) >> 2] | 0;
 i13 = HEAP32[gb + 78764 + ((i1 & 3) << 2) >> 2] | 0;
 i29 = HEAP32[gb + 78780 + ((i2 & 3) << 2) >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 i32 = i5 + 20 | 0;
 HEAP32[i32 >> 2] = 0;
 i34 = i5 + 24 | 0;
 HEAP32[i34 >> 2] = -1;
 i30 = i5 + 32 | 0;
 HEAP32[i30 >> 2] = 0;
 i33 = i5 + 36 | 0;
 HEAP32[i33 >> 2] = -1;
 HEAP32[i5 + 16 >> 2] = 0;
 i24 = i4 + 1424 | 0;
 HEAP32[i5 + 4 >> 2] = i24;
 HEAP8[i5 + 12 >> 0] = 0;
 i5 = (i2 + 3 >> 2) - i26 | 0;
 i24 = (i26 << 10) + i24 | 0;
 i26 = (i5 << 10) + i24 | 0;
 i27 = i25 << 6;
 i1 = (i6 + 3 >> 2) - i25 | 0;
 i25 = i1 + -1 | 0;
 i5 = i5 + -1 | 0;
 i13 = i13 & ((i5 | 0) == 0 ? i29 : -1);
 i23 = ((i1 | 0) == 1 ? i31 : -1) & i23;
 i1 = i13 & i23;
 i6 = 0;
 i4 = i1;
 i7 = i13;
 i8 = i13;
 i2 = 0;
 i3 = i1;
 i9 = i13;
 i10 = 0;
 i11 = i24 + i27 | 0;
 i12 = i1;
 i14 = i25;
 i15 = 0;
 L4 : while (1) {
  i28 = i24 >>> 0 >= i26 >>> 0;
  i21 = i2;
  while (1) {
   i16 = (i14 | 0) == 0;
   if (i16) {
    i2 = (i15 | i6 | i21 | i10 | 0) != 0;
    if (i2 | i28) break L4;
    i5 = i5 + -1 | 0;
    i13 = (i5 | 0) == 0 ? i29 : -1;
    i9 = i13 & i23;
    i17 = i9;
    i4 = i4 & i31;
    i7 = i13;
    i19 = i13;
    i3 = i3 & i31;
    i20 = i13;
    i2 = i12 & i31;
    i22 = i9;
    i18 = i9;
    i1 = i1 & i31;
    i12 = i9;
   } else {
    i17 = i7;
    i19 = i8;
    i20 = i9;
    i2 = i12;
    i22 = i13;
    i18 = i8;
    i12 = i9;
   }
   i52 = i11;
   f57 = Math_fround(HEAPF32[i52 >> 2]);
   f49 = Math_fround(HEAPF32[i52 + 4 >> 2]);
   f42 = Math_fround(HEAPF32[i52 + 8 >> 2]);
   f55 = Math_fround(HEAPF32[i52 + 12 >> 2]);
   i58 = (HEAP32[tempDoublePtr >> 2] = i4 & 1, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i50 = (HEAP32[tempDoublePtr >> 2] = i1 & 2, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i43 = (HEAP32[tempDoublePtr >> 2] = i3 & 4, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = (HEAP32[tempDoublePtr >> 2] = i2 & 8, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f55 >= f35;
   f55 = Math_fround(HEAPF32[i52 + 16 >> 2]);
   f47 = Math_fround(HEAPF32[i52 + 20 >> 2]);
   f40 = Math_fround(HEAPF32[i52 + 24 >> 2]);
   f53 = Math_fround(HEAPF32[i52 + 28 >> 2]);
   i56 = (HEAP32[tempDoublePtr >> 2] = i4 & 16, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i48 = (HEAP32[tempDoublePtr >> 2] = i1 & 32, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i41 = (HEAP32[tempDoublePtr >> 2] = i3 & 64, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 128, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f53 >= f35;
   f53 = Math_fround(HEAPF32[i52 + 32 >> 2]);
   f45 = Math_fround(HEAPF32[i52 + 36 >> 2]);
   f38 = Math_fround(HEAPF32[i52 + 40 >> 2]);
   f51 = Math_fround(HEAPF32[i52 + 44 >> 2]);
   i54 = (HEAP32[tempDoublePtr >> 2] = i4 & 256, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i46 = (HEAP32[tempDoublePtr >> 2] = i1 & 512, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i39 = (HEAP32[tempDoublePtr >> 2] = i3 & 1024, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 2048, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f51 >= f35;
   f51 = Math_fround(HEAPF32[i52 + 48 >> 2]);
   f44 = Math_fround(HEAPF32[i52 + 52 >> 2]);
   f37 = Math_fround(HEAPF32[i52 + 56 >> 2]);
   f59 = Math_fround(HEAPF32[i52 + 60 >> 2]);
   i52 = (HEAP32[tempDoublePtr >> 2] = i4 & 4096, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i4 = (HEAP32[tempDoublePtr >> 2] = i1 & 8192, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i8 = (HEAP32[tempDoublePtr >> 2] = i3 & 16384, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0);
   i9 = i9 | (HEAP32[tempDoublePtr >> 2] = i2 & 32768, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & f59 >= f35;
   i1 = i58 & f57 >= f35 | i56 & f55 >= f35 | i54 & f53 >= f35 | i52 & f51 >= f35 ? -1 : i6;
   i15 = i50 & f49 >= f35 | i48 & f47 >= f35 | i46 & f45 >= f35 | i4 & f44 >= f35 ? -1 : i15;
   i2 = i43 & f42 >= f35 | i41 & f40 >= f35 | i39 & f38 >= f35 | i8 & f37 >= f35 ? -1 : i21;
   i10 = i9 ? -1 : i10;
   if (i16) break;
   i6 = i1;
   i4 = i17;
   i8 = i19;
   i21 = i2;
   i3 = i18;
   i9 = i20;
   i11 = i11 + 64 | 0;
   i14 = i14 + -1 | 0;
   i1 = i22;
  }
  i58 = i24 + 1024 | 0;
  i14 = i58 >>> 0 < i26 >>> 0;
  i6 = i1;
  i4 = i17;
  i8 = i19;
  i3 = i18;
  i9 = i20;
  i11 = i14 ? i58 + i27 | 0 : i11;
  i14 = i14 ? i25 : 0;
  i24 = i58;
  i1 = i22;
 }
 i1 = HEAP32[i30 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i33 >> 2];
 i1 = HEAP32[i32 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i34 >> 2];
 i58 = i2 | i28 ^ 1;
 STACKTOP = i36;
 return i58 | 0;
}

function __ZN5physx2Gu18sweepSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleERKNS_6PxVec3EfRfRS7_SB_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i17, i11, i15, f6, i14, i20, i18, i4) {
 i17 = i17 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 f6 = Math_fround(f6);
 i14 = i14 | 0;
 i20 = i20 | 0;
 i18 = i18 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, i19 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i21 + 44 | 0;
 i13 = i21 + 16 | 0;
 i12 = i21 + 8 | 0;
 i16 = i21;
 i19 = i11 + 24 | 0;
 f3 = Math_fround(HEAPF32[i19 >> 2]);
 i8 = i17 + 12 | 0;
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i8 >> 2]));
 if (!(HEAP16[i4 >> 1] & 16)) if (Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i11, i11 + 12 | 0, i17, 0)) < Math_fround(f3 * f3)) {
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  f2 = Math_fround(-Math_fround(HEAPF32[i15 >> 2]));
  f3 = Math_fround(-Math_fround(HEAPF32[i15 + 4 >> 2]));
  f6 = Math_fround(-Math_fround(HEAPF32[i15 + 8 >> 2]));
  HEAPF32[i18 >> 2] = f2;
  HEAPF32[i18 + 4 >> 2] = f3;
  HEAPF32[i18 + 8 >> 2] = f6;
  i20 = 1;
  STACKTOP = i21;
  return i20 | 0;
 }
 f1 = Math_fround(HEAPF32[i11 >> 2]);
 f2 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 i4 = i11 + 4 | 0;
 if (f1 == f2) {
  f23 = Math_fround(HEAPF32[i4 >> 2]);
  f22 = Math_fround(HEAPF32[i11 + 16 >> 2]);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  if (f23 == f22) {
   f23 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   if (f23 == Math_fround(HEAPF32[i11 + 20 >> 2])) {
    f22 = Math_fround(HEAPF32[i8 >> 2]);
    f23 = Math_fround(HEAPF32[i19 >> 2]);
    f1 = Math_fround(HEAPF32[i15 >> 2]);
    f2 = Math_fround(HEAPF32[i15 + 4 >> 2]);
    f2 = Math_fround(-Math_fround(f2 * f6));
    f3 = Math_fround(-Math_fround(Math_fround(HEAPF32[i15 + 8 >> 2]) * f6));
    HEAPF32[i7 >> 2] = Math_fround(-Math_fround(f1 * f6));
    HEAPF32[i7 + 4 >> 2] = f2;
    HEAPF32[i7 + 8 >> 2] = f3;
    if (!(__ZN5physx2Gu17sweepSphereSphereERKNS_6PxVec3EfS3_fS3_RfRS1_(i17, f22, i11, f23, i7, i14, i18) | 0)) {
     i20 = 0;
     STACKTOP = i21;
     return i20 | 0;
    }
    HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f6);
    f23 = Math_fround(HEAPF32[i8 >> 2]);
    f6 = Math_fround(f23 * Math_fround(HEAPF32[i18 >> 2]));
    f22 = Math_fround(f23 * Math_fround(HEAPF32[i18 + 4 >> 2]));
    f23 = Math_fround(f23 * Math_fround(HEAPF32[i18 + 8 >> 2]));
    f6 = Math_fround(f6 + Math_fround(HEAPF32[i17 >> 2]));
    f22 = Math_fround(f22 + Math_fround(HEAPF32[i17 + 4 >> 2]));
    f23 = Math_fround(f23 + Math_fround(HEAPF32[i17 + 8 >> 2]));
    HEAPF32[i20 >> 2] = f6;
    HEAPF32[i20 + 4 >> 2] = f22;
    HEAPF32[i20 + 8 >> 2] = f23;
    i20 = 1;
    STACKTOP = i21;
    return i20 | 0;
   }
  }
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i11 + 16 >> 2] | 0;
 }
 HEAPF32[i13 >> 2] = f1;
 i10 = i13 + 4 | 0;
 HEAP32[i10 >> 2] = i4;
 i8 = i13 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 + 8 >> 2];
 i9 = i13 + 12 | 0;
 HEAPF32[i9 >> 2] = f2;
 i7 = i13 + 16 | 0;
 HEAP32[i7 >> 2] = i5;
 i5 = i13 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAPF32[i13 + 24 >> 2] = f3;
 i4 = __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i17, i15, i13, i9, f3, i12) | 0;
 if (!i4) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 f1 = Math_fround(HEAPF32[i12 >> 2]);
 if ((i4 | 0) != 1) {
  f23 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f1 = f1 < f23 ? f1 : f23;
 }
 HEAPF32[i16 >> 2] = f1;
 if (!(f1 >= Math_fround(0.0)) | !(f1 <= f6)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAPF32[i14 >> 2] = f1;
 f24 = Math_fround(HEAPF32[i15 >> 2]);
 f3 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f24 = Math_fround(f1 * f24);
 f3 = Math_fround(f1 * f3);
 f23 = Math_fround(f1 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f24);
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f3);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f23);
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f24);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f3);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f23);
 Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i13, i9, i17, i16));
 f23 = Math_fround(HEAPF32[i16 >> 2]);
 f3 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 f3 = Math_fround(f3 - f24);
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f2 = Math_fround(f2 - f22);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(f24 + Math_fround(f23 * f3));
 f2 = Math_fround(f22 + Math_fround(f23 * f2));
 f1 = Math_fround(f1 + Math_fround(f23 * Math_fround(f6 - f1)));
 HEAPF32[i20 >> 2] = f3;
 i7 = i20 + 4 | 0;
 HEAPF32[i7 >> 2] = f2;
 i8 = i20 + 8 | 0;
 HEAPF32[i8 >> 2] = f1;
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i17 >> 2]));
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i17 + 4 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i17 + 8 >> 2]));
 HEAPF32[i18 >> 2] = f3;
 i4 = i18 + 4 | 0;
 HEAPF32[i4 >> 2] = f2;
 i5 = i18 + 8 | 0;
 HEAPF32[i5 >> 2] = f1;
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)) + Math_fround(f1 * f1))));
 if (f6 > Math_fround(0.0)) {
  f24 = Math_fround(Math_fround(1.0) / f6);
  f3 = Math_fround(f3 * f24);
  HEAPF32[i18 >> 2] = f3;
  f2 = Math_fround(f2 * f24);
  HEAPF32[i4 >> 2] = f2;
  f1 = Math_fround(f1 * f24);
  HEAPF32[i5 >> 2] = f1;
 }
 f24 = Math_fround(HEAPF32[i19 >> 2]);
 f22 = Math_fround(f24 * f3);
 f23 = Math_fround(f24 * f2);
 f24 = Math_fround(f24 * f1);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f22);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f23);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f24);
 i20 = 1;
 STACKTOP = i21;
 return i20 | 0;
}

function _PxRegisterPhysicsSerializers(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 131) | 0;
 HEAP32[i3 >> 2] = gb + 139172 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754608;
 mftCall_viii(i2 | 0, i1 | 0, 2, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 132) | 0;
 HEAP32[i2 >> 2] = gb + 139220 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754619;
 mftCall_viii(i3 | 0, i1 | 0, 3, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 133) | 0;
 HEAP32[i3 >> 2] = gb + 139268 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754632;
 mftCall_viii(i2 | 0, i1 | 0, 1, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 134) | 0;
 HEAP32[i2 >> 2] = gb + 139316 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754644;
 mftCall_viii(i3 | 0, i1 | 0, 5, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 135) | 0;
 HEAP32[i3 >> 2] = gb + 139364 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754659;
 mftCall_viii(i2 | 0, i1 | 0, 6, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 136) | 0;
 HEAP32[i2 >> 2] = gb + 139412 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754673;
 mftCall_viii(i3 | 0, i1 | 0, 7, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 137) | 0;
 HEAP32[i3 >> 2] = gb + 139460 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754681;
 mftCall_viii(i2 | 0, i1 | 0, 8, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 138) | 0;
 HEAP32[i2 >> 2] = gb + 139508 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754692;
 mftCall_viii(i3 | 0, i1 | 0, 9, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 139) | 0;
 HEAP32[i3 >> 2] = gb + 139556 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754705;
 mftCall_viii(i2 | 0, i1 | 0, 13, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 140) | 0;
 HEAP32[i2 >> 2] = gb + 139604 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754717;
 mftCall_viii(i3 | 0, i1 | 0, 14, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 141) | 0;
 HEAP32[i3 >> 2] = gb + 139652 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754732;
 mftCall_viii(i2 | 0, i1 | 0, 15, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 142) | 0;
 HEAP32[i2 >> 2] = gb + 139700 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754751;
 mftCall_viii(i3 | 0, i1 | 0, 16, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 145) | 0;
 HEAP32[i3 >> 2] = gb + 139748 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754771;
 mftCall_viii(i2 | 0, i1 | 0, 10, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 146) | 0;
 HEAP32[i2 >> 2] = gb + 139796 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754779;
 mftCall_viii(i3 | 0, i1 | 0, 4, i2 | 0);
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 150) | 0;
 HEAP32[i3 >> 2] = gb + 139844 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 754793;
 mftCall_viii(i2 | 0, i1 | 0, 11, i3 | 0);
 i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 8, gb + 830897 | 0, gb + 754527 | 0, 151) | 0;
 HEAP32[i2 >> 2] = gb + 139892 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 754810;
 mftCall_viii(i3 | 0, i1 | 0, 12, i2 | 0);
 return;
}

function __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter(i23, i20, i21, i15, i16, i22, i17, i18) {
 i23 = i23 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25;
 i24 = i23 + 8 | 0;
 i1 = i24;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i24 >> 2] = -2147483648;
 i13 = i23 + 24 | 0;
 HEAP32[i13 >> 2] = i20;
 HEAP32[i13 + 4 >> 2] = i21;
 i13 = i23 + 32 | 0;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i13 + 4 >> 2] = i16;
 HEAP32[i23 + 40 >> 2] = HEAP32[i22 >> 2];
 i13 = i22 + 4 | 0;
 HEAP32[i23 + 44 >> 2] = HEAP32[i13 >> 2];
 i14 = i22 + 8 | 0;
 HEAP32[i23 + 48 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i23 + 52 >> 2] = HEAP32[i17 >> 2];
 i11 = i17 + 4 | 0;
 HEAP32[i23 + 56 >> 2] = HEAP32[i11 >> 2];
 i12 = i17 + 8 | 0;
 HEAP32[i23 + 60 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i23 + 64 >> 2] = i18;
 if (!(((i20 | 0) != 0 | (i21 | 0) != 0) & ((i15 | 0) != 0 | (i16 | 0) != 0))) {
  i24 = -2147483640;
  STACKTOP = i25;
  return i24 | 0;
 }
 i5 = HEAP32[i23 >> 2] | 0;
 i8 = _bitshift64Lshr(i20 | 0, i21 | 0, 48) | 0;
 getTempRet0() | 0;
 i9 = _bitshift64Lshr(i20 | 0, i21 | 0, 20) | 0;
 getTempRet0() | 0;
 i9 = i9 & 268435455;
 i10 = i20 & 65535;
 i6 = (i20 & 983040 | 0) == 65536 & 0 == 0;
 if (i6) {
  if (i10 >>> 0 >= (HEAP32[i5 + 44 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  if ((HEAP32[(HEAP32[i5 + 48 >> 2] | 0) + (i10 * 104 | 0) + 92 >> 2] | 0) != (i8 | 0)) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
 } else {
  if (i9 >>> 0 >= (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  if ((HEAP32[i1 + (i9 * 56 | 0) + 4 >> 2] | 0) != (i8 | 0)) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  i1 = HEAP32[i1 + (i9 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  if (i10 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 i1 = _bitshift64Lshr(i15 | 0, i16 | 0, 48) | 0;
 getTempRet0() | 0;
 i2 = _bitshift64Lshr(i15 | 0, i16 | 0, 20) | 0;
 getTempRet0() | 0;
 i2 = i2 & 268435455;
 i4 = i15 & 65535;
 if ((i15 & 983040 | 0) == 65536 & 0 == 0) {
  if (i4 >>> 0 >= (HEAP32[i5 + 44 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  if ((HEAP32[(HEAP32[i5 + 48 >> 2] | 0) + (i4 * 104 | 0) + 92 >> 2] | 0) != (i1 | 0)) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
 } else {
  if (i2 >>> 0 >= (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  if ((HEAP32[i3 + (i2 * 56 | 0) + 4 >> 2] | 0) != (i1 | 0)) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  i1 = HEAP32[i3 + (i2 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
  if (i4 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i24 = -2147483640;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 if (i6) if (i10 >>> 0 > (HEAP32[i5 + 44 >> 2] | 0) >>> 0) i1 = 0; else {
  i1 = HEAP32[i5 + 48 >> 2] | 0;
  if ((i1 + (i10 * 104 | 0) | 0) == 0 ? 1 : (i8 | 0) != (HEAP32[i1 + (i10 * 104 | 0) + 92 >> 2] | 0)) i1 = 0; else i1 = HEAP32[i1 + (i10 * 104 | 0) + 76 >> 2] | 0;
 } else if (i9 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
  i2 = HEAP32[i5 + 20 >> 2] | 0;
  if ((HEAP32[i2 + (i9 * 56 | 0) + 4 >> 2] | 0) == (i8 | 0)) {
   i1 = HEAP32[i2 + (i9 * 56 | 0) + 8 >> 2] | 0;
   if (!i1) i1 = 0; else if (i10 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) i1 = HEAP32[(HEAP32[i2 + (i9 * 56 | 0) + 16 >> 2] | 0) + (i10 << 5) + 24 >> 2] | 0; else i1 = 0;
  } else i1 = 0;
 } else i1 = 0;
 if (!(HEAP32[i18 + 128 >> 2] & i1)) {
  i24 = -2147483648;
  STACKTOP = i25;
  return i24 | 0;
 }
 if ((i20 | 0) == (i15 | 0) & (i21 | 0) == (i16 | 0)) {
  HEAP32[i24 >> 2] = 1073741824;
  i24 = 1073741824;
  STACKTOP = i25;
  return i24 | 0;
 }
 i8 = i23 + 76 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 _memset(HEAP32[i6 + 4 >> 2] | 0, -1, HEAP32[i6 + 16 >> 2] << 1 | 0) | 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i6 = i23 + 80 | 0;
 HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] = 0;
 __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf(i23, i20, i21, i17, i19) | 0;
 f27 = Math_fround(HEAPF32[i17 >> 2]);
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i19 >> 2]));
 f26 = Math_fround(HEAPF32[i11 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i19 + 4 >> 2]));
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i19 + 8 >> 2]));
 f7 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f26 * f26)) + Math_fround(f7 * f7)))) * Math_fround(.999000012));
 i8 = __ZN10dtNodePool7getNodeEy(HEAP32[i8 >> 2] | 0, i20, i21) | 0;
 HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i14 >> 2];
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = f7;
 i22 = i8 + 24 | 0;
 HEAP32[i22 >> 2] = i20;
 HEAP32[i22 + 4 >> 2] = i21;
 HEAP32[i8 + 20 >> 2] = 1073741824;
 i6 = HEAP32[i6 >> 2] | 0;
 i22 = i6 + 8 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 HEAP32[i22 >> 2] = i1 + 1;
 L57 : do if ((i1 | 0) > 0) {
  i3 = i1;
  while (1) {
   i2 = i3 + -1 | 0;
   i1 = (i2 | 0) / 2 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (!(Math_fround(HEAPF32[i5 + 16 >> 2]) > f7)) {
    i1 = i3;
    break L57;
   }
   HEAP32[i4 + (i3 << 2) >> 2] = i5;
   if ((i2 | 0) > 1) i3 = i1; else break;
  }
 } while (0);
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i8;
 HEAP32[i24 >> 2] = 536870912;
 HEAP32[i23 + 12 >> 2] = i8;
 HEAPF32[i23 + 20 >> 2] = f7;
 i24 = 536870912;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN9ShaderLab9SubShader8PostLoadEP6Shader(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 8 | 0;
 i19 = i24;
 i22 = i24 + 28 | 0;
 i23 = i24 + 16 | 0;
 i13 = HEAP32[i17 + 12 >> 2] | 0;
 i14 = i17 + 40 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i17 + 47 | 0;
 HEAP8[i15 >> 0] = 0;
 i16 = i17 + 46 | 0;
 HEAP8[i16 >> 0] = 0;
 if (i13 | 0) {
  i9 = HEAP32[i17 >> 2] | 0;
  i10 = i17 + 44 | 0;
  i11 = i17 + 45 | 0;
  i1 = 0;
  i8 = 0;
  i5 = 0;
  i12 = 0;
  i2 = 0;
  do {
   i6 = HEAP32[i9 + (i8 << 2) >> 2] | 0;
   i3 = HEAP32[i6 + 752 >> 2] | 0;
   i4 = HEAP32[i6 + 696 >> 2] | 0;
   if (5374 >>> i4 & 1) {
    i5 = i5 | 1 << HEAP32[gb + 68916 + (i4 << 2) >> 2];
    HEAP32[i14 >> 2] = i5;
   }
   i12 = (i5 & 13 | 0) != 0 | i12 & 255;
   switch (i4 | 0) {
   case 5:
    {
     HEAP8[i10 >> 0] = 1;
     i3 = HEAP32[i6 + 32 >> 2] | 0;
     if (!i3) i21 = 9; else if (!(HEAP8[i3 + 205 >> 0] | 0)) i21 = 9; else i3 = 1;
     do if ((i21 | 0) == 9) {
      i21 = 0;
      i3 = HEAP32[i6 + 36 >> 2] | 0;
      if (i3 | 0) if (HEAP8[i3 + 205 >> 0] | 0) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i6 + 40 >> 2] | 0;
      if (i3 | 0) if (HEAP8[i3 + 205 >> 0] | 0) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i6 + 44 >> 2] | 0;
      if (i3 | 0) if (HEAP8[i3 + 205 >> 0] | 0) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i6 + 48 >> 2] | 0;
      if (i3 | 0) if (HEAP8[i3 + 205 >> 0] | 0) {
       i3 = 1;
       break;
      }
      i3 = HEAP32[i6 + 52 >> 2] | 0;
      if (i3 | 0) if (HEAP8[i3 + 205 >> 0] | 0) {
       i3 = 1;
       break;
      }
      i3 = 0;
     } while (0);
     i7 = i2 & 255 | i3;
     HEAP8[i16 >> 0] = i7;
     i6 = i6 + 760 | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     if (!i3) i21 = 27; else {
      i2 = i6;
      L31 : while (1) {
       i4 = i3;
       while (1) {
        if ((HEAP32[i4 + 16 >> 2] | 0) >= 11) break;
        i3 = HEAP32[i4 + 4 >> 2] | 0;
        if (!i3) break L31; else i4 = i3;
       }
       i3 = HEAP32[i4 >> 2] | 0;
       if (!i3) {
        i2 = i4;
        break;
       } else i2 = i4;
      }
      if ((i2 | 0) == (i6 | 0)) i21 = 27; else if ((HEAP32[i2 + 16 >> 2] | 0) > 11) i21 = 27;
     }
     if ((i21 | 0) == 27) {
      i21 = 0;
      i2 = i6;
     }
     i2 = (i7 | (i2 | 0) != (i6 | 0)) & 255;
     HEAP8[i16 >> 0] = i2;
     break;
    }
   case 4:
    {
     if (i3 & 2) HEAP8[i11 >> 0] = 1;
     break;
    }
   case 0:
    {
     i1 = 1;
     break;
    }
   default:
    {}
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i13 | 0));
  HEAP8[i15 >> 0] = i12;
  if (!((i5 | 0) != 0 | i1 ^ 1)) HEAP32[i14 >> 2] = 5;
 }
 HEAP32[i17 + 52 >> 2] = __ZN9ShaderLabL17FindLightModePassEPNS_9SubShaderE14ShaderPassType(i17) | 0;
 i6 = i17 + 28 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = (i3 | 0) == 0;
 if (i5) {
  HEAP32[i17 + 56 >> 2] = -1;
  STACKTOP = i24;
  return;
 } else {
  i1 = i6;
  i4 = i3;
 }
 L52 : while (1) {
  i2 = i4;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= 9) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L52;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) != (i6 | 0)) if (!((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 + 16 >> 2] | 0) > 9)) if ((HEAP32[i1 + 20 >> 2] | 0) == 6) HEAP8[i17 + 48 >> 0] = 0;
 i7 = i17 + 56 | 0;
 HEAP32[i7 >> 2] = -1;
 if (i5) {
  STACKTOP = i24;
  return;
 } else i1 = i6;
 L66 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= 7) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L66;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i24;
  return;
 }
 if ((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 + 16 >> 2] | 0) > 7) {
  STACKTOP = i24;
  return;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[gb + 1166564 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 L79 : do if ((i2 | 0) == (i4 | 0)) i21 = 59; else {
  while (1) {
   if ((HEAP32[i2 + 20 >> 2] | 0) == (i3 | 0)) break;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i4 | 0)) {
    i21 = 59;
    break L79;
   } else i1 = i2;
  }
  i17 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i17, _strlen(i17) | 0);
 } while (0);
 if ((i21 | 0) == 59) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, gb + 480497 | 0, 13);
 }
 if (!(__ZN9ShaderLab19ParseQueueAndOffsetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERi(i22, i7) | 0)) {
  if (!i18) {
   i1 = (HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
   HEAP32[i20 >> 2] = gb + 585672;
   HEAP32[i20 + 4 >> 2] = i1;
   __Z6FormatPKcz(i23, gb + 481204 | 0, i20);
   i1 = 0;
  } else {
   i21 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
   i1 = (HEAP8[i22 + 11 >> 0] | 0) < 0 ? HEAP32[i22 >> 2] | 0 : i22;
   HEAP32[i19 >> 2] = i21;
   HEAP32[i19 + 4 >> 2] = i1;
   __Z6FormatPKcz(i23, gb + 481204 | 0, i19);
   i1 = HEAP32[i18 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i23 + 11 >> 0] | 0) < 0 ? HEAP32[i23 >> 2] | 0 : i23, 0, gb + 481282 | 0, 282, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
 STACKTOP = i24;
 return;
}

function __ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_(i5, i2, i1, i3, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i6 + 80 | 0;
 i19 = i6 + 48 | 0;
 i7 = i6 + 16 | 0;
 f8 = Math_fround(HEAPF32[i5 + 272 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 276 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 280 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 1296 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 1300 >> 2]);
 f12 = Math_fround(f8 - f12);
 f9 = Math_fround(f10 - f9);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i5 + 1304 >> 2]));
 f10 = Math_fround(HEAPF32[i5 + 288 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 292 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 296 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 1312 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 1316 >> 2]);
 f16 = Math_fround(f12 - Math_fround(f10 - f16));
 f14 = Math_fround(f9 - Math_fround(f8 - f14));
 f13 = Math_fround(f11 - Math_fround(f13 - Math_fround(HEAPF32[i5 + 1320 >> 2])));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f14 * f14)) + Math_fround(f13 * f13)))));
 f16 = Math_fround(f16 * f11);
 f14 = Math_fround(f14 * f11);
 f11 = Math_fround(f13 * f11);
 f13 = Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f16 * f16) + Math_fround(f14 * f14)));
 f8 = Math_fround(f11 * f13);
 f9 = Math_fround(f14 * f13);
 f10 = Math_fround(f8 - f9);
 f13 = Math_fround(f16 * f13);
 f8 = Math_fround(f13 - f8);
 f13 = Math_fround(f9 - f13);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f10 * f10) + Math_fround(f8 * f8))))));
 f10 = Math_fround(f9 * f10);
 f8 = Math_fround(f9 * f8);
 f13 = Math_fround(f9 * f13);
 f9 = Math_fround(Math_fround(f11 * f10) - Math_fround(f16 * f13));
 f10 = Math_fround(Math_fround(f16 * f8) - Math_fround(f14 * f10));
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(f14 * f13) - Math_fround(f11 * f8));
 i17 = i20 + 4 | 0;
 HEAPF32[i17 >> 2] = f9;
 i18 = i20 + 8 | 0;
 HEAPF32[i18 >> 2] = f10;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i20 | 0, i5 + 272 | 0, i5 + 1296 | 0, i6 + 64 | 0);
 f16 = Math_fround(f16 * Math_fround(.866025388));
 f14 = Math_fround(f14 * Math_fround(.866025388));
 f11 = Math_fround(f11 * Math_fround(.866025388));
 f10 = Math_fround(HEAPF32[i20 >> 2]);
 f9 = Math_fround(HEAPF32[i17 >> 2]);
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f14 * f9)) + Math_fround(f11 * f8));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f8) - Math_fround(f11 * f9)) * Math_fround(-.5)) - Math_fround(f10 * Math_fround(.25)))) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(Math_fround(Math_fround(Math_fround(f11 * f10) - Math_fround(f16 * f8)) * Math_fround(-.5)) - Math_fround(f9 * Math_fround(.25)))) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f16 * f9) - Math_fround(f14 * f10)) * Math_fround(-.5)) - Math_fround(f8 * Math_fround(.25))) + Math_fround(f11 * f13)) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f12 * f12) + Math_fround(f15 * f15))))));
 f15 = Math_fround(f8 * f15);
 f13 = Math_fround(f8 * f13);
 HEAPF32[i19 >> 2] = Math_fround(f8 * f12);
 i18 = i19 + 4 | 0;
 HEAPF32[i18 >> 2] = f15;
 i17 = i19 + 8 | 0;
 HEAPF32[i17 >> 2] = f13;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i19 | 0, i5 + 288 | 0, i5 + 1312 | 0, i6 + 32 | 0);
 f13 = Math_fround(HEAPF32[i19 >> 2]);
 f15 = Math_fround(HEAPF32[i18 >> 2]);
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(f14 * f15)) + Math_fround(f11 * f12));
 f10 = Math_fround(Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(Math_fround(Math_fround(f14 * f12) - Math_fround(f11 * f15)) * Math_fround(-.5)) - Math_fround(f13 * Math_fround(.25)))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(Math_fround(Math_fround(f11 * f13) - Math_fround(f16 * f12)) * Math_fround(-.5)) - Math_fround(f15 * Math_fround(.25)))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13)) * Math_fround(-.5)) - Math_fround(f12 * Math_fround(.25))) + Math_fround(f11 * f8)) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9))))));
 f9 = Math_fround(f11 * f9);
 f8 = Math_fround(f11 * f8);
 HEAPF32[i7 >> 2] = Math_fround(f11 * f10);
 HEAPF32[i7 + 4 >> 2] = f9;
 HEAPF32[i7 + 8 >> 2] = f8;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i7 | 0, i5 + 304 | 0, i5 + 1328 | 0, i6 | 0);
 HEAP32[i1 >> 2] = 3;
 i2 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i5, 0, 1, 2, i3, i4) | 0;
 i1 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i5, 1, 0, 2, i3, i4) | 0;
 if ((i2 | 0) == 0 | (i1 | 0) == 0) {
  i20 = 0;
  STACKTOP = i6;
  return i20 | 0;
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i20 = 0;
  STACKTOP = i6;
  return i20 | 0;
 }
 HEAP32[i2 + 20 >> 2] = i1;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP8[i2 + 33 >> 0] = 2;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP8[i1 + 34 >> 0] = 1;
 HEAP32[i2 + 28 >> 2] = i1;
 HEAP8[i2 + 34 >> 0] = 1;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP8[i1 + 33 >> 0] = 2;
 i20 = 1;
 STACKTOP = i6;
 return i20 | 0;
}

function _UNITY_TT_Set_MM_Blend(i19, i3, i17) {
 i19 = i19 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22 + 28 | 0;
 i4 = i22 + 24 | 0;
 i8 = i22 + 4 | 0;
 i20 = i22;
 HEAP32[i20 >> 2] = 0;
 i21 = HEAP32[i19 + 100 >> 2] | 0;
 i18 = i19 + 672 | 0;
 HEAP8[i18 >> 0] = 0;
 i1 = i19 + 676 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) {
  i16 = _UNITY_TT_Get_MM_Var(i19, 0) | 0;
  HEAP32[i20 >> 2] = i16;
  if (!i16) {
   i16 = HEAP32[i1 >> 2] | 0;
   break;
  } else {
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 } else i16 = i2; while (0);
 i2 = i16 + 8 | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i15 = i15 >>> 0 < i3 >>> 0 ? i15 : i3;
 i12 = (i15 | 0) == 0;
 L7 : do if (!i12) {
  i1 = 0;
  while (1) {
   if (((HEAP32[i17 + (i1 << 2) >> 2] | 0) + 65536 | 0) >>> 0 > 131072) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) break L7;
  }
  HEAP32[i20 >> 2] = 6;
  i21 = HEAP32[i20 >> 2] | 0;
  STACKTOP = i22;
  return i21 | 0;
 } while (0);
 i5 = i16 + 36 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i11 = HEAP32[i19 + 104 >> 2] | 0;
  i7 = HEAP32[i11 + 28 >> 2] | 0;
  i1 = mftCall_iiiii(HEAP32[i19 + 508 >> 2] | 0, i19 | 0, 1735811442, i11 | 0, i4 | 0) | 0;
  HEAP32[i13 >> 2] = i1;
  do if (!i1) {
   i6 = _UNITY_FT_Stream_Pos(i11) | 0;
   i1 = _UNITY_FT_Stream_ReadFields(i11, gb + 227794 | 0, i8) | 0;
   HEAP32[i13 >> 2] = i1;
   if (!i1) {
    i9 = i16 + 24 | 0;
    HEAP32[i9 >> 2] = HEAPU16[i8 + 6 >> 1];
    i1 = HEAPU16[i8 + 12 >> 1] | 0;
    i3 = i16 + 32 | 0;
    HEAP32[i3 >> 2] = i1;
    i4 = (HEAP32[i8 + 16 >> 2] | 0) + i6 | 0;
    if ((HEAP32[i8 >> 2] | 0) != 65536) {
     HEAP32[i13 >> 2] = 8;
     i1 = 8;
     break;
    }
    i10 = i8 + 4 | 0;
    if ((HEAP16[i10 >> 1] | 0) != (HEAP32[HEAP32[i2 >> 2] >> 2] & 65535) << 16 >> 16) {
     HEAP32[i13 >> 2] = 8;
     i1 = 8;
     break;
    }
    HEAP32[i5 >> 2] = _UNITY_ft_mem_realloc(i7, 4, 0, i1 + 1 | 0, 0, i13) | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    if (!i1) {
     i1 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
     if (!(HEAP16[i8 + 14 >> 1] & 1)) {
      i1 = _UNITY_FT_Stream_EnterFrame(i11, i1 << 1) | 0;
      HEAP32[i13 >> 2] = i1;
      if (!i1) i1 = 0; else break;
      do {
       i2 = (((_UNITY_FT_Stream_GetUShort(i11) | 0) & 65535) << 1) + i4 | 0;
       HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i2;
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0);
      _UNITY_FT_Stream_ExitFrame(i11);
     } else {
      i1 = _UNITY_FT_Stream_EnterFrame(i11, i1 << 2) | 0;
      HEAP32[i13 >> 2] = i1;
      if (!i1) i1 = 0; else break;
      do {
       i2 = (_UNITY_FT_Stream_GetULong(i11) | 0) + i4 | 0;
       HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i2;
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0);
      _UNITY_FT_Stream_ExitFrame(i11);
     }
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) {
      i4 = i16 + 28 | 0;
      HEAP32[i4 >> 2] = _UNITY_ft_mem_realloc(i7, 4, 0, Math_imul(HEAPU16[i10 >> 1] | 0, i1) | 0, 0, i13) | 0;
      i1 = HEAP32[i13 >> 2] | 0;
      if (i1 | 0) break;
      i1 = _UNITY_FT_Stream_Seek(i11, (HEAP32[i8 + 8 >> 2] | 0) + i6 | 0) | 0;
      HEAP32[i13 >> 2] = i1;
      if (i1 | 0) break;
      i1 = _UNITY_FT_Stream_EnterFrame(i11, Math_imul(HEAP32[i9 >> 2] << 1, HEAPU16[i10 >> 1] | 0) | 0) | 0;
      HEAP32[i13 >> 2] = i1;
      if (i1 | 0) break;
      i1 = HEAP32[i9 >> 2] | 0;
      if (i1 | 0) {
       i3 = 0;
       i2 = HEAP16[i10 >> 1] | 0;
       do {
        if (!(i2 << 16 >> 16)) i2 = 0; else {
         i1 = 0;
         do {
          i6 = (_UNITY_FT_Stream_GetUShort(i11) | 0) << 16 >> 16 << 2;
          i2 = HEAP16[i10 >> 1] | 0;
          i8 = i2 & 65535;
          i7 = (Math_imul(i8, i3) | 0) + i1 | 0;
          HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 << 2) >> 2] = i6;
          i1 = i1 + 1 | 0;
         } while (i1 >>> 0 < i8 >>> 0);
         i1 = HEAP32[i9 >> 2] | 0;
        }
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i1 >>> 0);
      }
      _UNITY_FT_Stream_ExitFrame(i11);
     }
     i1 = HEAP32[i13 >> 2] | 0;
    }
   }
  } while (0);
  HEAP32[i20 >> 2] = i1;
  if (i1 | 0) {
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 }
 i2 = i16 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 L55 : do if (!i1) {
  i1 = _UNITY_ft_mem_realloc(i21, 4, 0, HEAP32[i14 >> 2] | 0, 0, i20) | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(HEAP32[i20 >> 2] | 0)) {
   i4 = 1;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  } else {
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 } else {
  L61 : do if (i12) {
   i4 = 0;
   i2 = 0;
  } else {
   i2 = 0;
   while (1) {
    if ((HEAP32[i1 + (i2 << 2) >> 2] | 0) != (HEAP32[i17 + (i2 << 2) >> 2] | 0)) {
     i4 = 2;
     break L61;
    }
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i15 >>> 0) {
     i4 = 0;
     break;
    }
   }
  } while (0);
  i3 = HEAP32[i14 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) while (1) {
   if (HEAP32[i1 + (i2 << 2) >> 2] | 0) {
    i4 = 2;
    i2 = i3;
    break L55;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i3 >>> 0) {
    i2 = i3;
    break;
   }
  } else i2 = i3;
 } while (0);
 HEAP32[i16 >> 2] = i2;
 _memcpy(i1 | 0, i17 | 0, i15 << 2 | 0) | 0;
 HEAP8[i18 >> 0] = 1;
 i1 = i19 + 648 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i21 = HEAP32[i20 >> 2] | 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 switch (i4 | 0) {
 case 2:
  {
   _UNITY_ft_mem_free(i21, i2);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i20 >> 2] = _UNITY_tt_face_load_cvt(i19, HEAP32[i19 + 104 >> 2] | 0) | 0;
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 case 1:
  {
   HEAP32[i20 >> 2] = _UNITY_tt_face_vary_cvt(i19, HEAP32[i19 + 104 >> 2] | 0) | 0;
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 default:
  {
   i21 = HEAP32[i20 >> 2] | 0;
   STACKTOP = i22;
   return i21 | 0;
  }
 }
 return 0;
}

function __ZN18AssetBundleManager55CollectPreloadObjectsFromAssetBundleLoadAssetOperationsER13dynamic_arrayIiLj4EE(i7, i24) {
 i7 = i7 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i27 + 24 | 0;
 i20 = i27 + 20 | 0;
 i22 = i27 + 16 | 0;
 i26 = i27;
 i23 = i7 + 20 | 0;
 if ((HEAP32[i7 + 52 >> 2] | 0) == (HEAP32[i23 >> 2] | 0)) {
  STACKTOP = i27;
  return;
 }
 i15 = i26 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i16 = i26 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i25 = i26 + 4 | 0;
 HEAP32[i26 >> 2] = i25;
 i17 = i7 + 44 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i18 = i7 + 48 | 0;
 i13 = HEAP32[i18 >> 2] | 0;
 i19 = i2 + (i13 << 3) | 0;
 i1 = i2;
 i21 = i25;
 L4 : do if (i13) {
  i5 = i7 + 24 | 0;
  i6 = i7 + 28 | 0;
  i4 = HEAP32[i7 + 36 >> 2] | 0;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    if (!(HEAP8[i5 >> 0] | 0)) break L4;
    if (!(HEAP32[i23 >> 2] | 0)) break L4;
    if ((HEAP32[i6 >> 2] | 0) != (i3 | 0)) break L4;
   }
   i2 = i2 + 8 | 0;
   i1 = i2;
  } while ((i2 | 0) != (i19 | 0));
 } while (0);
 if ((i1 | 0) != (i19 | 0)) {
  i9 = i26 + 8 | 0;
  i10 = i14 + 4 | 0;
  i11 = i14 + 4 | 0;
  i12 = i7 + 24 | 0;
  i13 = i7 + 28 | 0;
  i8 = i7 + 36 | 0;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0) | 0) {
    i2 = HEAP32[i7 + 196 >> 2] | 0;
    i5 = HEAP32[i7 + 208 >> 2] | 0;
    i6 = i2 + (i5 << 2) | 0;
    if (i5 | 0) do {
     HEAP32[i22 >> 2] = i21;
     HEAP32[i14 >> 2] = HEAP32[i22 >> 2];
     i4 = __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS9_EEiEESC_RKT_(i26, i14, i20, i2) | 0;
     if (!(HEAP32[i4 >> 2] | 0)) {
      i3 = HEAP32[i9 >> 2] | 0;
      HEAP32[i14 >> 2] = 1;
      HEAP32[i11 >> 2] = i3;
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(20, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i3 + 16 >> 2] = HEAP32[i2 >> 2];
      i5 = HEAP32[i20 >> 2] | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = i5;
      HEAP32[i4 >> 2] = i3;
      i5 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
      if (i5) {
       HEAP32[i26 >> 2] = i5;
       i3 = HEAP32[i4 >> 2] | 0;
      }
      __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 >> 2] | 0, i3);
      HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
     }
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i6 | 0));
    i2 = HEAP32[i7 + 216 >> 2] | 0;
    i7 = HEAP32[i7 + 228 >> 2] | 0;
    i6 = i2 + (i7 << 2) | 0;
    if (i7 | 0) {
     i5 = i2;
     do {
      HEAP32[i22 >> 2] = i21;
      HEAP32[i14 >> 2] = HEAP32[i22 >> 2];
      i3 = __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS9_EEiEESC_RKT_(i26, i14, i20, i5) | 0;
      if (!(HEAP32[i3 >> 2] | 0)) {
       i2 = HEAP32[i9 >> 2] | 0;
       HEAP32[i14 >> 2] = 1;
       HEAP32[i10 >> 2] = i2;
       i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(20, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
       HEAP32[i2 + 16 >> 2] = HEAP32[i5 >> 2];
       i4 = HEAP32[i20 >> 2] | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i4;
       HEAP32[i3 >> 2] = i2;
       i4 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
       if (i4) {
        HEAP32[i26 >> 2] = i4;
        i2 = HEAP32[i3 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 >> 2] | 0, i2);
       HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
      }
      i5 = i5 + 4 | 0;
     } while ((i5 | 0) != (i6 | 0));
    }
   }
   i2 = i1 + 8 | 0;
   i1 = i2;
   L39 : do if ((i2 | 0) != (i19 | 0)) {
    i4 = HEAP32[i8 >> 2] | 0;
    do {
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i4 | 0) != (i3 | 0)) {
      if (!(HEAP8[i12 >> 0] | 0)) break L39;
      if (!(HEAP32[i23 >> 2] | 0)) break L39;
      if ((HEAP32[i13 >> 2] | 0) != (i3 | 0)) break L39;
     }
     i2 = i2 + 8 | 0;
     i1 = i2;
    } while ((i2 | 0) != (i19 | 0));
   } while (0);
  } while ((i1 | 0) != ((HEAP32[i17 >> 2] | 0) + (HEAP32[i18 >> 2] << 3) | 0));
  i1 = HEAP32[i26 >> 2] | 0;
  if ((i1 | 0) != (i25 | 0)) {
   i8 = i24 + 12 | 0;
   i9 = i24 + 16 | 0;
   i10 = i24 + 4 | 0;
   i2 = i1;
   while (1) {
    i3 = i2 + 16 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i9 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i1 = i6 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i9 >> 2] = i1;
      HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i23 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i23 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i24 >> 2] = i23;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i5;
    HEAP32[(HEAP32[i24 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i25 | 0)) break; else i2 = i1;
   }
  }
 }
 __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE(i26, HEAP32[i25 >> 2] | 0);
 STACKTOP = i27;
 return;
}

function __Z17RenderStaticBatchR9GfxDevice10Matrix4x4fRNSt3__26vectorI7SubMesh13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEEERK11MeshBuffersPK17BatchInstanceDatajRK14ChannelAssigns(i26, i1, i19, i29, i20, i30, i31) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i29 = i29 | 0;
 i20 = i20 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i32 = 0, d33 = 0.0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i32 + 8 | 0;
 i21 = i32;
 d33 = +_emscripten_get_now() * 1.0e6;
 i27 = ~~d33 >>> 0;
 i28 = +Math_abs(d33) >= 1.0 ? (d33 > 0.0 ? ~~+Math_min(+Math_floor(d33 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d33 - +(~~d33 >>> 0)) / 4294967296.0) >>> 0) : 0;
 if ((HEAP16[gb + 1157684 + 6 >> 1] | 0) > -1) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157684 | 0, i23);
  i25 = gb + 1157684 | 0;
 } else i25 = 0;
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 696 >> 2] | 0, i26 | 0, 1);
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 104 >> 2] | 0, i26 | 0, i1 | 0, 0);
 if (mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 200 >> 2] | 0, i26 | 0, 4) | 0) i17 = 1; else i17 = mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 200 >> 2] | 0, i26 | 0, 5) | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i23 + 4 | 0;
 i16 = gb + 63160 | 0;
 i18 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i24;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = i30 << 5;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = (i1 | 4) + -1 | 0;
  if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 392365 | 0, 139) | 0;
   i18 = gb + 64016 | 0;
   i16 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   HEAP32[i23 >> 2] = i1;
   i2 = i24;
   HEAP32[i2 >> 2] = i16;
   HEAP32[i2 + 4 >> 2] = i18;
   i2 = i1;
   break;
  }
 } while (0);
 i18 = i2 + 3 & -4;
 if (!i30) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i15 = i19 + 4 | 0;
  i3 = 0;
  i2 = 0;
  i12 = 0;
  i13 = 0;
  i4 = 0;
  do {
   i16 = HEAP32[i19 >> 2] | 0;
   i6 = (((HEAP32[i15 >> 2] | 0) - i16 | 0) / 52 | 0) + -1 | 0;
   i14 = HEAP32[i20 + (i13 << 3) + 4 >> 2] | 0;
   i14 = (i6 | 0) < (i14 | 0) ? i6 : i14;
   i6 = HEAP32[i16 + (i14 * 52 | 0) + 32 >> 2] | 0;
   if (!i12) i22 = 20; else if ((i6 | 0) == ((HEAP32[i12 + 36 >> 2] << 1) + (HEAP32[i12 + 32 >> 2] | 0) | 0)) {
    i1 = HEAP32[i16 + (i14 * 52 | 0) + 40 >> 2] | 0;
    if ((i1 | 2 | 0) == 2) if ((i1 | 0) == (HEAP32[i12 + 40 >> 2] | 0)) {
     i5 = i2 + -1 | 0;
     i12 = HEAP32[i16 + (i14 * 52 | 0) + 36 >> 2] | 0;
     i8 = i18 + (i5 << 5) + 8 | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i12;
     i8 = i18 + (i5 << 5) + 16 | 0;
     i11 = HEAP32[i8 >> 2] | 0;
     i5 = i18 + (i5 << 5) + 20 | 0;
     i10 = (HEAP32[i5 >> 2] | 0) + i11 | 0;
     i7 = HEAP32[i16 + (i14 * 52 | 0) + 44 >> 2] | 0;
     i9 = (HEAP32[i16 + (i14 * 52 | 0) + 48 >> 2] | 0) + i7 | 0;
     i11 = i7 >>> 0 < i11 >>> 0 ? i7 : i11;
     HEAP32[i8 >> 2] = i11;
     HEAP32[i5 >> 2] = (i10 >>> 0 < i9 >>> 0 ? i9 : i10) - i11;
     i5 = i1;
     i1 = i12;
    } else i22 = 20; else i22 = 20;
   } else i22 = 20;
   i12 = i16 + (i14 * 52 | 0) | 0;
   if ((i22 | 0) == 20) {
    i22 = 0;
    i7 = i2 + 1 | 0;
    i8 = i21;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i8 + 4 >> 2] = 0;
    i8 = HEAP32[i16 + (i14 * 52 | 0) + 44 >> 2] | 0;
    i11 = i16 + (i14 * 52 | 0) + 36 | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i10 = i16 + (i14 * 52 | 0) + 40 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i9 = HEAP32[i16 + (i14 * 52 | 0) + 48 >> 2] | 0;
    if (i17) {
     if ((i5 | 0) == 1) i22 = 23;
    } else if ((i5 | 0) == 2) i22 = 23;
    if ((i22 | 0) == 23) {
     i22 = 0;
     i5 = 0;
     i6 = HEAP32[i12 >> 2] | 0;
     i1 = HEAP32[i16 + (i14 * 52 | 0) + 4 >> 2] | 0;
    }
    HEAP32[i18 + (i2 << 5) >> 2] = i5;
    HEAP32[i18 + (i2 << 5) + 4 >> 2] = i6;
    HEAP32[i18 + (i2 << 5) + 8 >> 2] = i1;
    HEAP32[i18 + (i2 << 5) + 12 >> 2] = 0;
    HEAP32[i18 + (i2 << 5) + 16 >> 2] = i8;
    HEAP32[i18 + (i2 << 5) + 20 >> 2] = i9;
    i1 = i21;
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i18 + (i2 << 5) + 24 | 0;
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = i7;
    i5 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   switch (i5 | 0) {
   case 0:
    {
     i1 = (i1 | 0) / 3 | 0;
     break;
    }
   case 1:
    {
     i1 = i1 + -2 | 0;
     break;
    }
   case 2:
    {
     i1 = (i1 | 0) / 4 | 0;
     break;
    }
   case 3:
    {
     i1 = (i1 | 0) / 2 | 0;
     break;
    }
   case 4:
    {
     i1 = i1 + -1 | 0;
     break;
    }
   case 5:
    break;
   default:
    i1 = 0;
   }
   i4 = i1 + i4 | 0;
   i3 = (HEAP32[i16 + (i14 * 52 | 0) + 48 >> 2] | 0) + i3 | 0;
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i30 | 0));
  i1 = HEAP32[i23 >> 2] | 0;
 }
 mftCall_viiiiiiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 244 >> 2] | 0, i26 | 0, HEAP32[i29 >> 2] | 0, i29 + 8 | 0, HEAP32[i29 + 4 >> 2] | 0, i18 | 0, i2 | 0, HEAP32[i29 + 40 >> 2] | 0, i31 | 0);
 __Z15gpu_time_samplev();
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 696 >> 2] | 0, i26 | 0, 0);
 d33 = +_emscripten_get_now() * 1.0e6;
 i31 = +Math_abs(d33) >= 1.0 ? (d33 > 0.0 ? ~~+Math_min(+Math_floor(d33 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d33 - +(~~d33 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i29 = HEAP32[(HEAP32[i26 >> 2] | 0) + 268 >> 2] | 0;
 i31 = _i64Subtract(~~d33 >>> 0 | 0, i31 | 0, i27 | 0, i28 | 0) | 0;
 mftCall_viiiiiii(i29 | 0, i26 | 0, 0, i4 | 0, i3 | 0, i30 | 0, i31 | 0, getTempRet0() | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i24);
 if (!i25) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i25);
 STACKTOP = i32;
 return;
}

function __ZN5physx8debugger4comm31PvdCommStreamInternalConnection6createERNS_19PxAllocatorCallbackES4_RNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamENS_7PxFlagsINS0_17PvdConnectionType4EnumEjEERNS1_21PvdConnectionListenerERNS_6shdfnd6MutexTINS0_19ForwardingAllocatorEEEb(i11, i3, i1, i5, i2, i10, i9, i4) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, 144, gb + 1027167 | 0, gb + 773844 | 0, 799) | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = gb + 147904 + 8;
 HEAP32[i12 + 4 >> 2] = gb + 147904 + 120;
 HEAP32[i12 + 8 >> 2] = gb + 147904 + 144;
 HEAP32[i12 + 12 >> 2] = gb + 147904 + 168;
 HEAP32[i12 + 16 >> 2] = i11;
 i2 = i12 + 20 | 0;
 HEAP32[i2 >> 2] = i3;
 i8 = i12 + 24 | 0;
 if (i4) i1 = __ZN5physx8debugger19PvdNetworkOutStream20createDoubleBufferedERNS_19PxAllocatorCallbackERS1_j(i11, i1, 131072) | 0;
 HEAP32[i8 >> 2] = __ZN5physx8debugger21PvdNetworkStreamOwner6createERNS_19PxAllocatorCallbackERNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamE(i11, i1, i5) | 0;
 i1 = i12 + 28 | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, 16, gb + 773932 | 0, gb + 773844 | 0, 484) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 >> 2] = gb + 148084 + 8;
 HEAP32[i3 + 4 >> 2] = i11;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i3 + 12 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 HEAP32[i1 >> 2] = i3;
 i3 = i12 + 32 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 88, gb + 773950 | 0, gb + 773844 | 0, 485) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 >> 2] = gb + 148124 + 8;
 HEAP32[i5 + 4 >> 2] = i2;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackE(i2) | 0;
 i14 = i5 + 16 | 0;
 HEAP32[i14 >> 2] = i2;
 i13 = i5 + 20 | 0;
 HEAP32[i13 >> 2] = gb + 773967;
 HEAP32[i5 + 12 >> 2] = gb + 148172 + 8;
 i4 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i13 = mftCall_iiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i4 | 0, HEAP32[i13 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i5 + 24 >> 2] = i13;
 __ZN5physx6shdfnd9MutexImplC2Ev(i13);
 HEAP32[i5 + 28 >> 2] = 0;
 i13 = i5 + 32 | 0;
 HEAP32[i5 + 36 >> 2] = i2;
 HEAP32[i5 + 40 >> 2] = gb + 773992;
 HEAP32[i13 >> 2] = gb + 148188 + 8;
 i2 = i5 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i5 + 68 >> 2] = Math_fround(.75);
 HEAP32[i5 + 72 >> 2] = -1;
 HEAP32[i5 + 76 >> 2] = 0;
 HEAP32[i5 + 80 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i13, 64);
 HEAP32[i5 + 84 >> 2] = i10;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 108 >> 2] | 0, i6 | 0);
 HEAP32[i3 >> 2] = i5;
 i5 = i11;
 HEAP32[i12 + 40 >> 2] = i5;
 HEAP32[i12 + 44 >> 2] = gb + 774019;
 HEAP32[i12 + 48 >> 2] = 0;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i12 + 56 >> 2] = 0;
 HEAP32[i12 + 36 >> 2] = gb + 148204 + 8;
 HEAP32[i12 + 60 >> 2] = 8192;
 i6 = i12 + 64 | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i12 + 72 | 0;
 i13 = i12 + 76 | 0;
 HEAP32[i13 >> 2] = i5;
 i2 = i12 + 80 | 0;
 HEAP32[i2 >> 2] = gb + 774051;
 HEAP32[i6 >> 2] = gb + 148172 + 8;
 i4 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i4 | 0, HEAP32[i2 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i12 + 84 >> 2] = i2;
 __ZN5physx6shdfnd9MutexImplC2Ev(i2);
 i2 = i12 + 92 | 0;
 HEAP32[i2 >> 2] = i5;
 i5 = i12 + 96 | 0;
 HEAP32[i5 >> 2] = gb + 774085;
 HEAP32[i12 + 88 >> 2] = gb + 148172 + 8;
 i4 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i5 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i12 + 100 >> 2] = i5;
 __ZN5physx6shdfnd9MutexImplC2Ev(i5);
 HEAP32[i12 + 104 >> 2] = 0;
 i5 = i12 + 108 | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i12 + 112 >> 2] = i7;
 HEAP32[i12 + 116 >> 2] = i10;
 HEAP32[i12 + 120 >> 2] = 0;
 HEAP32[i12 + 124 >> 2] = i9;
 i4 = i12 + 128 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP8[i12 + 132 >> 0] = 1;
 HEAP8[i12 + 133 >> 0] = 0;
 HEAP32[i12 + 136 >> 2] = 0;
 i10 = HEAP32[i8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0);
 i10 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0);
 i10 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0);
 i10 = HEAP32[i8 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0)) return i12 | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, 24, gb + 774112 | 0, gb + 773844 | 0, 507) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 >> 2] = gb + 86828 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd10ThreadImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
  i14 = _PxGetFoundation() | 0;
  i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
  i1 = mftCall_iiiiii(i11 | 0, i13 | 0, i1 | 0, (i14 ? gb + 775304 | 0 : gb + 837976 | 0) | 0, gb + 775428 | 0, 236) | 0;
 }
 i14 = i3 + 4 | 0;
 HEAP32[i14 >> 2] = i1;
 __ZN5physx6shdfnd10ThreadImplC2Ev(i1);
 HEAP32[i3 >> 2] = gb + 148220 + 8;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i5;
 HEAP32[i3 + 16 >> 2] = i2;
 HEAP8[i3 + 20 >> 0] = 1;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE(HEAP32[i14 >> 2] | 0, 16384, i3);
 HEAP32[i4 >> 2] = i3;
 return i12 | 0;
}

function __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (HEAP32[i1 + 4 >> 2] | 0) {
  i7 = i1;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + (HEAP32[i7 + 4 >> 2] << 2) >> 2] | 0;
  i6 = i2;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i6 + 4 >> 2] = i7;
  __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E(i2, i3, i4);
 }
 i16 = i1;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 i16 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
 i7 = i16 + (i1 * 40 | 0) + 12 | 0;
 i8 = i16 + (i1 * 40 | 0) + 16 | 0;
 f21 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 24 >> 2]);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i3 + 4 | 0;
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 i6 = i3 + 8 | 0;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f25 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 4 >> 2]);
 f25 = Math_fround(f18 - f25);
 f23 = Math_fround(f12 - f23);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 8 >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i7 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i16 + (i1 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f12 * Math_fround(-2.0));
 f13 = Math_fround(f12 * Math_fround(2.0));
 f26 = Math_fround(f21 * f20);
 f17 = Math_fround(f22 * Math_fround(2.0));
 f24 = Math_fround(f22 * Math_fround(-2.0));
 f28 = Math_fround(f21 * f24);
 f15 = Math_fround(f18 * Math_fround(-2.0));
 f27 = Math_fround(f18 * Math_fround(2.0));
 f19 = Math_fround(f21 * f15);
 f14 = Math_fround(Math_fround(f25 + Math_fround(Math_fround(Math_fround(f12 * f20) - Math_fround(f22 * f17)) * f25)) + Math_fround(Math_fround(Math_fround(f28 - Math_fround(f12 * f15)) * f23) + Math_fround(Math_fround(Math_fround(f27 * f22) - f26) * f9)));
 f20 = Math_fround(Math_fround(f23 + Math_fround(Math_fround(Math_fround(f18 * f13) - f28) * f25)) + Math_fround(Math_fround(Math_fround(Math_fround(f22 * f24) - Math_fround(f18 * f27)) * f23) + Math_fround(Math_fround(f19 - Math_fround(f22 * f20)) * f9)));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f26 - Math_fround(f18 * f24)) * f25) + f9) + Math_fround(Math_fround(Math_fround(Math_fround(f12 * f17) - f19) * f23) + Math_fround(Math_fround(Math_fround(f18 * f15) - Math_fround(f12 * f13)) * f9)));
 f13 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 36 >> 2]);
 i1 = Math_fround(Math_abs(Math_fround(f13))) < Math_fround(9.99999971e-10);
 i16 = Math_fround(Math_abs(Math_fround(f12))) < Math_fround(9.99999971e-10);
 i2 = Math_fround(Math_abs(Math_fround(f15))) < Math_fround(9.99999971e-10);
 f18 = Math_fround(Math_fround(1.0) / f13);
 f18 = i1 ? Math_fround(1.0) : f18;
 f23 = Math_fround(Math_fround(1.0) / f12);
 f23 = i16 ? Math_fround(1.0) : f23;
 f19 = Math_fround(Math_fround(1.0) / f15);
 f23 = Math_fround(f20 * f23);
 f19 = Math_fround(f9 * (i2 ? Math_fround(1.0) : f19));
 HEAPF32[i3 >> 2] = Math_fround(f14 * f18);
 HEAPF32[i10 >> 2] = f23;
 HEAPF32[i6 >> 2] = f19;
 f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(f19 * f23);
 i8 = i4 + 12 | 0;
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(f21 * f14);
 i3 = i4 + 4 | 0;
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(f22 * f20);
 f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i7 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = i4 + 8 | 0;
 f24 = Math_fround(HEAPF32[i7 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f21 * f24)) - Math_fround(f22 * f14)) - Math_fround(f25 * f20));
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f25 * f23)) - Math_fround(f22 * f24)) - Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f19 * f24)) - Math_fround(f21 * f23)) - Math_fround(f25 * f14));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f20)) - Math_fround(f19 * f14));
 i6 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 i16 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
 f15 = (HEAP32[tempDoublePtr >> 2] = i16 & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i1 & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f12 * f13);
 f13 = Math_fround(f15 * f13);
 f12 = Math_fround(f15 * f12);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ (i6 ^ -2147483648);
 HEAP32[i4 >> 2] = i11 & -2147483648 ^ (i10 ^ -2147483648);
 HEAP32[i3 >> 2] = i1 & -2147483648 ^ i2;
 HEAP32[i7 >> 2] = i6;
 HEAPF32[i8 >> 2] = f9;
 STACKTOP = i5;
 return;
}

function __ZN20TextRenderingPrivate15GetFormatStringER11UTF16StringR13dynamic_arrayINS_16TextFormatChangeELj4EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i31 + 56 | 0;
 i27 = i31 + 60 | 0;
 i28 = i31 + 12 | 0;
 i29 = i31;
 i30 = i9 + 16 | 0;
 if ((HEAP32[i30 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i9 + 4 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i11 = i8 + 4 | 0;
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i12 = i28 + 8 | 0;
  i13 = i28 + 12 | 0;
  i14 = i28 + 16 | 0;
  i15 = i28 + 20 | 0;
  i16 = i28 + 24 | 0;
  i18 = i28 + 32 | 0;
  i19 = i28 + 28 | 0;
  i20 = i28 + 36 | 0;
  i21 = i28 + 40 | 0;
  i22 = i29 + 11 | 0;
  i23 = i28 + 12 | 0;
  i24 = i29 + 11 | 0;
  i25 = i28 + 4 | 0;
  i26 = i9 + 4 | 0;
  i2 = 0;
  do {
   i7 = __Z6GetTagR11UTF16StringRiRb(i8, i17, i27) | 0;
   if ((i7 | 0) == -1) i1 = HEAP32[i17 >> 2] | 0; else {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = -1;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i15 >> 2] = 0;
    HEAPF32[i16 >> 2] = Math_fround(0.0);
    HEAPF32[i18 >> 2] = Math_fround(1.0);
    HEAPF32[i19 >> 2] = Math_fround(0.0);
    HEAPF32[i20 >> 2] = Math_fround(1.0);
    HEAP32[i21 >> 2] = 32768;
    switch (i7 | 0) {
    case 0:
     {
      HEAP32[i21 >> 2] = 1;
      i1 = 32769;
      break;
     }
    case 1:
     {
      HEAP32[i21 >> 2] = 2;
      i1 = 32770;
      break;
     }
    case 3:
     {
      HEAP32[i21 >> 2] = 8;
      i1 = 32776;
      break;
     }
    case 2:
     {
      HEAP32[i21 >> 2] = 4;
      i1 = 32772;
      break;
     }
    case 4:
     {
      HEAP32[i21 >> 2] = 16;
      i1 = 32784;
      break;
     }
    case 5:
     {
      HEAP32[i21 >> 2] = 32;
      i1 = 32800;
      break;
     }
    default:
     i1 = 32768;
    }
    L19 : do if (!(HEAP8[i27 >> 0] | 0)) switch (i7 | 0) {
    case 3:
     {
      __Z12GetParameterR11UTF16StringRib(i29, i8, i17, 0);
      HEAP32[i14 >> 2] = __Z11StringToIntPKc((HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
      break L19;
     }
    case 2:
     {
      __Z12GetParameterR11UTF16StringRib(i29, i8, i17, 0);
      i6 = __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32(i29, i23) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
      if (i6) break L19;
      HEAP32[i23 >> 2] = -1;
      break L19;
     }
    case 4:
     {
      __Z12GetParameterR11UTF16StringRib(i29, i8, i17, 0);
      HEAP32[i15 >> 2] = __Z11StringToIntPKc((HEAP8[i24 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29) | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
      break L19;
     }
    case 5:
     {
      __Z20ParseImageParametersR11UTF16StringRiRN20TextRenderingPrivate16TextFormatChangeE(i8, i17, i28);
      break L19;
     }
    default:
     break L19;
    } else HEAP32[i21 >> 2] = i1; while (0);
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i25 >> 2] = 1 - i2 + i1;
    HEAP32[i28 >> 2] = i2;
    i3 = HEAP32[i10 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i30 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i30 >> 2] = i2;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 44 | 0, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 44 | 0) | 0;
      HEAP32[i30 >> 2] = i2;
      HEAP32[i9 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    i2 = (HEAP32[i9 >> 2] | 0) + (i3 * 44 | 0) | 0;
    i3 = i28;
    i4 = i2 + 44 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    if ((i7 | 0) == 5) {
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 32768;
     HEAP32[i25 >> 2] = 0;
     i3 = HEAP32[i10 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i30 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i30 >> 2] = i2;
       HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 44 | 0, 4, i26, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i26, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 44 | 0) | 0;
       HEAP32[i30 >> 2] = i2;
       HEAP32[i9 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i4;
     i2 = (HEAP32[i9 >> 2] | 0) + (i3 * 44 | 0) | 0;
     i3 = i28;
     i4 = i2 + 44 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i2 = i2 + 4 | 0;
      i3 = i3 + 4 | 0;
     } while ((i2 | 0) < (i4 | 0));
    }
   }
   i2 = i1 + 1 | 0;
   HEAP32[i17 >> 2] = i2;
  } while ((i2 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 if (__Z14ValidateFormatR13dynamic_arrayIN20TextRenderingPrivate16TextFormatChangeELj4EE(i9) | 0) {
  STACKTOP = i31;
  return;
 }
 if ((HEAP32[i30 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i9 + 4 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i30 >> 2] = 0;
 STACKTOP = i31;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRT_RT0_(i25, i1, i3, i2) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 152 | 0;
 i22 = i24 + 144 | 0;
 i21 = i24 + 136 | 0;
 i20 = i24 + 128 | 0;
 i19 = i24;
 i18 = i24 + 160 | 0;
 i17 = i25 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 if (!i14) {
  STACKTOP = i24;
  return;
 }
 i9 = i19 + 4 | 0;
 i10 = i25 + 4 | 0;
 i11 = i25 + 12 | 0;
 i12 = i19 + 4 | 0;
 i15 = 0;
 i16 = 0;
 do {
  i2 = i18;
  i7 = i2 + 32 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  i8 = i16 | 1;
  HEAP32[i20 >> 2] = i16;
  _sprintf(i18, gb + 832301 | 0, i20) | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   i2 = 0;
  } else {
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i2 = HEAP32[i25 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   } else i3 = i1;
  }
  HEAP32[i19 >> 2] = i18;
  HEAP8[i9 >> 0] = 0;
  i1 = i3 + 8 | 0;
  if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i26 = i19;
   i4 = HEAP32[i26 + 4 >> 2] | 0;
   i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i7 >> 2] = HEAP32[i26 >> 2];
   HEAP32[i7 + 4 >> 2] = i4;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
  f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  d6 = +f5;
  i2 = i19;
  i7 = i2 + 128 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  HEAPF64[i21 >> 3] = d6;
  __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
  if (HEAP8[i19 >> 0] | 0) {
   i26 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   mftCall_iiii(i26 | 0, i4 | 0, i19 | 0, _strlen(i19) | 0) | 0;
  }
  HEAP8[i19 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i19 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i2 = HEAP32[i25 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
    i1 = HEAP32[i10 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
    i1 = HEAP32[i25 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
  }
  i16 = i16 + 2 | 0;
  HEAP32[i22 >> 2] = i8;
  _sprintf(i18, gb + 832301 | 0, i22) | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   i2 = 0;
  } else {
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i2 = HEAP32[i25 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   } else i3 = i1;
  }
  HEAP32[i19 >> 2] = i18;
  HEAP8[i12 >> 0] = 0;
  i1 = i3 + 8 | 0;
  if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i7 = i19;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i26 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i26 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i26 + 4 >> 2] = i8;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
  f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  d6 = +f5;
  i2 = i19;
  i7 = i2 + 128 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  HEAPF64[i23 >> 3] = d6;
  __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i23) | 0;
  if (HEAP8[i19 >> 0] | 0) {
   i26 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   mftCall_iiii(i26 | 0, i4 | 0, i19 | 0, _strlen(i19) | 0) | 0;
  }
  HEAP8[i19 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i19 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
    i2 = HEAP32[i10 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    i1 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   }
   HEAP32[i1 + 8 >> 2] = i2 + -1;
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != (i14 | 0));
 STACKTOP = i24;
 return;
}

function __ZN5physx2Gu20computeMTD_BoxConvexERNS_6PxVec3ERfRKNS0_3BoxERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i19, i18, i1, i3, i4) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0, f39 = f0, f40 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i22 + 624 | 0;
 i14 = i22 + 848 | 0;
 i15 = i22 + 776 | 0;
 i12 = i22 + 576 | 0;
 i13 = i22 + 512 | 0;
 i10 = i22 + 712 | 0;
 i23 = i22 + 496 | 0;
 i9 = i22 + 320 | 0;
 i28 = i22 + 480 | 0;
 i29 = i22 + 96 | 0;
 i11 = i22 + 112 | 0;
 i16 = i22 + 64 | 0;
 i17 = i22 + 32 | 0;
 i20 = i22 + 16 | 0;
 i21 = i22;
 i6 = i22 + 696 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i5, i1);
 i36 = HEAP32[i5 >> 2] | 0;
 i35 = HEAP32[i5 + 4 >> 2] | 0;
 i34 = HEAP32[i5 + 8 >> 2] | 0;
 i33 = HEAP32[i5 + 12 >> 2] | 0;
 i32 = HEAP32[i1 + 36 >> 2] | 0;
 i31 = HEAP32[i1 + 40 >> 2] | 0;
 i30 = HEAP32[i1 + 44 >> 2] | 0;
 i7 = i1 + 48 | 0;
 i37 = HEAP32[i7 >> 2] | 0;
 i8 = i1 + 52 | 0;
 i24 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 56 | 0;
 i27 = HEAP32[i2 >> 2] | 0;
 i1 = i9 + 64 | 0;
 HEAP32[i9 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAP32[i9 + 80 >> 2] = 3;
 HEAPF32[i9 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i9 + 144 >> 2] = i37;
 HEAP32[i9 + 148 >> 2] = i24;
 HEAP32[i9 + 152 >> 2] = i27;
 HEAPF32[i9 + 156 >> 2] = Math_fround(0.0);
 f40 = (HEAP32[tempDoublePtr >> 2] = i37, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f38 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f39 = f40 <= f39 ? f40 : f39;
 f38 = f39 <= f38 ? f39 : f38;
 HEAPF32[i9 + 16 >> 2] = Math_fround(f38 * Math_fround(.150000006));
 HEAPF32[i9 + 32 >> 2] = Math_fround(f38 * Math_fround(.0500000007));
 i27 = (HEAP32[i3 + 32 >> 2] | 0) + 16 | 0;
 i1 = i3 + 4 | 0;
 i24 = HEAP32[i1 + 4 >> 2] | 0;
 i37 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i28 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i28 + 4 >> 2] = i24;
 HEAP32[i28 + 8 >> 2] = i37;
 HEAPF32[i28 + 12 >> 2] = Math_fround(0.0);
 i37 = i3 + 16 | 0;
 i24 = HEAP32[i37 + 4 >> 2] | 0;
 i25 = HEAP32[i37 + 8 >> 2] | 0;
 i26 = HEAP32[i37 + 12 >> 2] | 0;
 HEAP32[i29 >> 2] = HEAP32[i37 >> 2];
 HEAP32[i29 + 4 >> 2] = i24;
 HEAP32[i29 + 8 >> 2] = i25;
 HEAP32[i29 + 12 >> 2] = i26;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i11, i27, i23, i28, i29);
 i29 = HEAP32[i4 >> 2] | 0;
 i28 = HEAP32[i4 + 4 >> 2] | 0;
 i27 = HEAP32[i4 + 8 >> 2] | 0;
 i26 = HEAP32[i4 + 12 >> 2] | 0;
 i4 = i4 + 16 | 0;
 i25 = HEAP32[i4 >> 2] | 0;
 i24 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i36;
 HEAP32[i16 + 4 >> 2] = i35;
 HEAP32[i16 + 8 >> 2] = i34;
 HEAP32[i16 + 12 >> 2] = i33;
 HEAP32[i16 + 16 >> 2] = i32;
 HEAP32[i16 + 20 >> 2] = i31;
 HEAP32[i16 + 24 >> 2] = i30;
 HEAPF32[i16 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i17 >> 2] = i29;
 HEAP32[i17 + 4 >> 2] = i28;
 HEAP32[i17 + 8 >> 2] = i27;
 HEAP32[i17 + 12 >> 2] = i26;
 HEAP32[i17 + 16 >> 2] = i25;
 HEAP32[i17 + 20 >> 2] = i24;
 HEAP32[i17 + 24 >> 2] = i4;
 HEAPF32[i17 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i3 + 8 >> 2]) == Math_fround(1.0)) i1 = Math_fround(HEAPF32[i3 + 12 >> 2]) == Math_fround(1.0); else i1 = 0; else i1 = 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 >> 2];
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i14, i6);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i14, i5);
 HEAP32[i5 + 32 >> 2] = gb + 656139;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i11, i1, i15);
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i37 = i12 + 4 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAPF32[i12 + 20 >> 2] = Math_fround(1.0);
 i37 = i12 + 24 | 0;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i37 + 4 >> 2] = 0;
 HEAP32[i37 + 8 >> 2] = 0;
 HEAP32[i37 + 12 >> 2] = 0;
 HEAPF32[i12 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i13 + 32 >> 2] = i16;
 HEAP32[i13 + 36 >> 2] = i12;
 HEAP32[i13 + 40 >> 2] = i12;
 HEAP8[i13 + 44 >> 0] = 1;
 HEAP32[i13 >> 2] = gb + 84376 + 8;
 HEAP32[i13 + 48 >> 2] = i9;
 HEAP32[i10 + 32 >> 2] = i17;
 HEAP32[i10 + 36 >> 2] = i11 + 96;
 HEAP32[i10 + 40 >> 2] = i11 + 144;
 HEAP8[i10 + 44 >> 0] = i1 & 1;
 HEAP32[i10 >> 2] = i1 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i10 + 48 >> 2] = i11;
 i1 = __ZN5physx2Gu10computeMTDERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_RNS_6shdfnd3aos6FloatVERNS6_5Vec3VE(i5, i15, i13, i10, i21, i20) | 0;
 if (!i1) {
  STACKTOP = i22;
  return i1 | 0;
 }
 f40 = Math_fround(HEAPF32[i21 >> 2]);
 i36 = f40 > Math_fround(0.0);
 HEAPF32[i18 >> 2] = i36 ? f40 : Math_fround(0.0);
 i36 = HEAP32[i20 + 4 >> 2] | 0;
 i37 = HEAP32[i20 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i19 + 4 >> 2] = i36;
 HEAP32[i19 + 8 >> 2] = i37;
 STACKTOP = i22;
 return i1 | 0;
}

function __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i11, i13) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 i9 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = i3 - i9 | 0;
 i8 = (i6 | 0) / 88 | 0;
 i12 = i10 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = i4;
 if (i8 >>> 0 > ((i2 - i4 | 0) / 88 | 0) >>> 0) {
  if (!i4) i1 = i2; else {
   i5 = i10 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0)) i1 = i4; else {
    i3 = i2;
    while (1) {
     i2 = i3 + -88 | 0;
     HEAP32[i5 >> 2] = i2;
     i4 = i3 + -32 | 0;
     if ((HEAP32[i3 + -16 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i3 + -28 | 0);
      HEAP32[i4 >> 2] = 0;
      i2 = HEAP32[i5 >> 2] | 0;
     }
     if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i9 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } else i2 = 0;
  i9 = (i1 - i2 | 0) / 88 | 0;
  i1 = i9 << 1;
  i1 = i9 >>> 0 < 1073741823 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 88 | 0, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i7 = i10 + 4 | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i12 >> 2] = i2 + (i1 * 88 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i14;
   return;
  }
  do {
   i4 = i2;
   i5 = i1;
   i6 = i4 + 56 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 56 | 0, i1 + 56 | 0);
   i13 = i2 + 76 | 0;
   i12 = i1 + 76 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = i1 + 88 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i14;
  return;
 }
 i12 = i10 + 4 | 0;
 i11 = ((HEAP32[i12 >> 2] | 0) - i4 | 0) / 88 | 0;
 i10 = i8 >>> 0 > i11 >>> 0;
 i11 = i10 ? i9 + (i11 * 88 | 0) | 0 : i3;
 if ((i9 | 0) == (i11 | 0)) i4 = i1; else {
  do {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   i3 = i1 + 28 | 0;
   i8 = i9 + 28 | 0;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   i3 = i1 + 56 | 0;
   if ((i9 | 0) != (i1 | 0)) {
    i7 = HEAP32[i9 + 56 >> 2] | 0;
    i8 = i1 + 68 | 0;
    i2 = HEAP32[i9 + 68 >> 2] << 4;
    i4 = i2 >> 4;
    HEAP32[i8 >> 2] = i4;
    i5 = i1 + 72 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i4;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i3 >> 2] = i2;
     break;
    } else {
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i1 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
     HEAP32[i5 >> 2] = i4;
     HEAP32[i3 >> 2] = i2;
     break;
    } else i2 = HEAP32[i3 >> 2] | 0; while (0);
    _memcpy(i2 | 0, i7 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
   }
   i8 = i1 + 76 | 0;
   i7 = i9 + 76 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i9 = i9 + 88 | 0;
   i1 = i1 + 88 | 0;
  } while ((i9 | 0) != (i11 | 0));
  i4 = i1;
 }
 if (i10) {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i11 | 0) == (i2 | 0)) {
   STACKTOP = i14;
   return;
  }
  i3 = HEAP32[i12 >> 2] | 0;
  i1 = i11;
  do {
   i4 = i3;
   i5 = i1;
   i6 = i4 + 56 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i3 + 56 | 0, i1 + 56 | 0);
   i13 = i3 + 76 | 0;
   i11 = i1 + 76 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = i1 + 88 | 0;
   i3 = (HEAP32[i12 >> 2] | 0) + 88 | 0;
   HEAP32[i12 >> 2] = i3;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  i2 = i1 + -88 | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = i1 + -32 | 0;
  if ((HEAP32[i1 + -16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -28 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i29, i30, i22, i15, i8, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i22 = i22 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, f32 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31;
 i23 = i31 + 12 | 0;
 i24 = __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i29, i30, i22, i15, i1) | 0;
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i15 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 > Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 i10 = i15 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 20 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i9 = i15 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i25 = i15;
 i26 = i8;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i5;
 HEAP32[i8 + 16 >> 2] = i6;
 HEAP32[i8 + 20 >> 2] = i7;
 i27 = i8 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i22 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 > Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 1 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 i17 = i22 + 4 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i19 = i22 + 12 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 16 | 0;
 i6 = HEAP32[i20 >> 2] | 0;
 i21 = i22 + 20 | 0;
 i7 = HEAP32[i21 >> 2] | 0;
 i16 = i22 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i25 = i22;
 i26 = i15;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i9 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i30 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 > Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 2 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i30 >> 2] | 0;
 i9 = i30 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i30 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i30 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i30 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i30 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i30 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i25 = i30;
 i26 = i22;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i22 >> 2] = i2;
 HEAP32[i17 >> 2] = i3;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i19 >> 2] = i5;
 HEAP32[i20 >> 2] = i6;
 HEAP32[i21 >> 2] = i7;
 HEAP32[i16 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i29 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 > Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 3 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = HEAP32[i29 + 4 >> 2] | 0;
 i3 = HEAP32[i29 + 8 >> 2] | 0;
 i4 = HEAP32[i29 + 12 >> 2] | 0;
 i5 = HEAP32[i29 + 16 >> 2] | 0;
 i6 = HEAP32[i29 + 20 >> 2] | 0;
 i25 = i29 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 i25 = i29;
 i26 = i30;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i30 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 i30 = i24 + 4 | 0;
 STACKTOP = i31;
 return i30 | 0;
}

function __ZN2UIL20AddRenderersToCanvasER8JobFencePK9TransformPNS_6CanvasERi(i7, i6, i10, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i4 = i12;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 187020 | 0) | 0;
 i9 = (i11 | 0) != 0;
 do if (i9) {
  i1 = i11 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i5 = 12; else if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
   i1 = __Z34FindAncestorComponentExactTypeImplR10GameObjecti(HEAP32[i1 >> 2] | 0, 223) | 0;
   if ((i1 | 0) == (i10 | 0)) {
    if (!i10) i1 = 0; else {
     i1 = i11 + 188 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i10 | 0)) __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i2, i11);
     HEAP32[i1 >> 2] = i10;
     __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE(0, i11 + 204 | 0, i10 + 112 | 0);
     HEAP32[i11 + 196 >> 2] = 0;
     HEAP32[i11 + 192 >> 2] = 0;
     i4 = i11 + 162 | 0;
     HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 3071;
     __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 >> 2] | 0, i11);
     i1 = i10;
    }
    i1 = (i1 | 0) == (i10 | 0);
    break;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 344 >> 2] | 0;
     if ((i2 | 0) == 0 | (i2 | 0) == (i10 | 0)) break; else i1 = i2;
    }
    i2 = i1 + 348 | 0;
    if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(-1.0)) {
     i14 = __ZN13dynamic_arrayIN2UI13UIInstructionELj4EE19push_back_constructEv(i10 + 196 | 0) | 0;
     HEAP32[i14 + 480 >> 2] = (HEAP32[i10 + 208 >> 2] | 0) + -1;
     i13 = i14 + 668 | 0;
     HEAP8[i13 >> 0] = 1;
     i23 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
     __ZNK9Transform21GetLocalToWorldMatrixEv(i3, i23);
     i24 = i14 + 484 | 0;
     __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(i1 + 112 | 0, i3, i24);
     i23 = __ZNK2UI13RectTransform7GetRectEv(i23) | 0;
     f28 = Math_fround(HEAPF32[i23 >> 2]);
     f29 = Math_fround(HEAPF32[i23 + 4 >> 2]);
     f15 = Math_fround(HEAPF32[i23 + 8 >> 2]);
     f19 = Math_fround(HEAPF32[i23 + 12 >> 2]);
     f27 = Math_fround(HEAPF32[gb + 62500 >> 2]);
     f26 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
     f25 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
     f18 = Math_fround(-f27);
     f21 = Math_fround(-f26);
     f22 = Math_fround(-f25);
     f27 = f28 < f27 ? f28 : f27;
     f26 = f29 < f26 ? f29 : f26;
     i23 = f25 > Math_fround(0.0);
     f25 = i23 ? Math_fround(0.0) : f25;
     f16 = f28 > f18 ? f28 : f18;
     f20 = f29 > f21 ? f29 : f21;
     i23 = f22 < Math_fround(0.0);
     f17 = i23 ? Math_fround(0.0) : f22;
     f15 = Math_fround(f28 + f15);
     f27 = f15 < f27 ? f15 : f27;
     f16 = f16 < f15 ? f15 : f16;
     f19 = Math_fround(f29 + f19);
     f27 = f28 < f27 ? f28 : f27;
     f16 = f16 < f28 ? f28 : f16;
     HEAPF32[i14 + 548 >> 2] = f15 < f27 ? f15 : f27;
     HEAPF32[i14 + 552 >> 2] = f19 < f26 ? f19 : f26;
     HEAPF32[i14 + 556 >> 2] = f25;
     HEAPF32[i14 + 560 >> 2] = f16 < f15 ? f15 : f16;
     HEAPF32[i14 + 564 >> 2] = f20 < f19 ? f19 : f20;
     HEAPF32[i14 + 568 >> 2] = f17;
     HEAP32[i4 >> 2] = HEAP32[gb + 62500 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
     i23 = i4 + 12 | 0;
     HEAPF32[i23 >> 2] = f18;
     i3 = i4 + 16 | 0;
     HEAPF32[i3 >> 2] = f21;
     HEAPF32[i4 + 20 >> 2] = f22;
     __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i14 + 548 | 0, i24, i4);
     f22 = Math_fround(HEAPF32[i4 >> 2]);
     f21 = Math_fround(HEAPF32[i4 + 4 >> 2]);
     f18 = Math_fround(HEAPF32[i23 >> 2]);
     f17 = Math_fround(HEAPF32[i3 >> 2]);
     f20 = Math_fround(-f18);
     f19 = Math_fround(-f17);
     f16 = Math_fround(-f22);
     f15 = Math_fround(-f21);
     HEAPF32[i14 + 596 >> 2] = f22;
     HEAPF32[i14 + 600 >> 2] = f21;
     HEAPF32[i14 + 604 >> 2] = f20;
     HEAPF32[i14 + 608 >> 2] = f19;
     HEAPF32[i14 + 612 >> 2] = f18;
     HEAPF32[i14 + 616 >> 2] = f17;
     HEAPF32[i14 + 620 >> 2] = f16;
     HEAPF32[i14 + 624 >> 2] = f15;
     HEAP8[i13 >> 0] = 1;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = i4 + 1;
     HEAPF32[i2 >> 2] = Math_fround(i4 | 0);
    }
    i1 = (i1 | 0) == (i10 | 0);
    if (i1) break;
    STACKTOP = i12;
    return;
   }
  } else i5 = 12;
 } else i5 = 12; while (0);
 if ((i5 | 0) == 12) i1 = (i10 | 0) == 0;
 i4 = i6 + 92 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i3 = i6 + 80 | 0;
  i2 = 0;
  do {
   __ZN2UIL20AddRenderersToCanvasER8JobFencePK9TransformPNS_6CanvasERi(i7, HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0, i10, i8);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 if (!(i9 & i1)) {
  STACKTOP = i12;
  return;
 }
 if (!(HEAP8[i11 + 184 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i11 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if ((i10 | 0) == 0 | (__ZNK10GameObject8IsActiveEv(i1) | 0) ^ 1) {
  STACKTOP = i12;
  return;
 }
 i1 = i11 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i10 | 0)) __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i2, i11);
 HEAP32[i1 >> 2] = i10;
 __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE(0, i11 + 220 | 0, i10 + 112 | 0);
 HEAP32[i11 + 196 >> 2] = 0;
 HEAP32[i11 + 192 >> 2] = 0;
 i24 = i11 + 162 | 0;
 HEAP16[i24 >> 1] = HEAPU16[i24 >> 1] | 3071;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 >> 2] | 0, i11);
 STACKTOP = i12;
 return;
}

function __ZN22NavMeshProjectSettings5ResetEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 i1 = i9 + 28 | 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i5 = i11 + 11 | 0;
 HEAP8[i5 >> 0] = 8;
 i8 = i11;
 HEAP32[i8 >> 2] = 1802264919;
 HEAP32[i8 + 4 >> 2] = 1701601889;
 HEAP8[i11 + 8 >> 0] = 0;
 L1 : do if ((i1 | 0) != (i11 | 0)) {
  i4 = i1 + 11 | 0;
  do if ((HEAP8[i4 >> 0] | 0) < 0) {
   i2 = HEAP32[i9 + 36 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 8) {
    i8 = HEAP32[i9 + 32 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i8, 0, i8, 8, i11);
    break L1;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } while (0);
  i7 = i11;
  i3 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = i1;
  i6 = i8;
  HEAP8[i6 >> 0] = i3;
  HEAP8[i6 + 1 >> 0] = i3 >> 8;
  HEAP8[i6 + 2 >> 0] = i3 >> 16;
  HEAP8[i6 + 3 >> 0] = i3 >> 24;
  i8 = i8 + 4 | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP8[i8 + 1 >> 0] = i7 >> 8;
  HEAP8[i8 + 2 >> 0] = i7 >> 16;
  HEAP8[i8 + 3 >> 0] = i7 >> 24;
  HEAP8[i1 + 8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 32 >> 2] = 8;
   break;
  } else {
   HEAP8[i4 >> 0] = 8;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 HEAPF32[i9 + 44 >> 2] = Math_fround(1.0);
 i1 = i9 + 48 | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i2;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = -2147483632;
 i6 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = 12;
 i3 = i2;
 i4 = gb + 844262 | 0;
 i5 = i3 + 12 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i2 + 12 >> 0] = 0;
 i7 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i4 = HEAP8[i7 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i8 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
  i6 = i2 ? HEAP32[i6 >> 2] | 0 : i4 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 52 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 HEAPF32[i9 + 64 >> 2] = Math_fround(1.0);
 i1 = i9 + 68 | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i11 + 11 | 0;
 HEAP8[i4 >> 0] = 4;
 HEAP32[i11 >> 2] = 1886221642;
 HEAP8[i11 + 4 >> 0] = 0;
 L43 : do if ((i1 | 0) != (i11 | 0)) {
  i5 = i1 + 11 | 0;
  do if ((HEAP8[i5 >> 0] | 0) < 0) {
   i2 = HEAP32[i9 + 76 >> 2] & 2147483647;
   i3 = i2 + -1 | 0;
   if (i3 >>> 0 < 4) {
    i8 = HEAP32[i9 + 72 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 5 - i2 | 0, i8, 0, i8, 4, i11);
    break L43;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   }
  } while (0);
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP8[i1 >> 0] = i8;
  HEAP8[i1 + 1 >> 0] = i8 >> 8;
  HEAP8[i1 + 2 >> 0] = i8 >> 16;
  HEAP8[i1 + 3 >> 0] = i8 >> 24;
  HEAP8[i1 + 4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i9 + 72 >> 2] = 4;
   break;
  } else {
   HEAP8[i5 >> 0] = 4;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 HEAPF32[i9 + 84 >> 2] = Math_fround(2.0);
 HEAPF32[i9 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 164 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 204 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 244 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 264 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 284 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 324 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 344 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 384 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 404 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 424 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 444 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 464 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 484 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 504 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 524 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 544 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 564 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 584 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 604 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 624 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 644 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 664 >> 2] = Math_fround(1.0);
 STACKTOP = i12;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE(i13, i16) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 24 | 0;
 i11 = i18;
 i17 = i18 + 72 | 0;
 i8 = i13 + 44 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i9 = i13 + 40 | 0;
 __ZN5physx6shdfnd4sortINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS3_25SortCUDAProfileOccurencesENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(HEAP32[i9 >> 2] | 0, i1, i18 + 84 | 0, i15, 32);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i17 >> 2] = 0;
 i10 = i17 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i14 = i17 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 if ((HEAP32[i8 >> 2] | 0) >>> 0 > 1) {
  i7 = i11 + 16 | 0;
  i3 = 1;
  while (1) {
   i6 = i1 + (i3 * 24 | 0) | 0;
   do if (i2 << 16 >> 16 == (HEAP16[i6 >> 1] | 0)) {
    i5 = i7;
    i4 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
    i19 = i1 + (i3 * 24 | 0) + 8 | 0;
    i20 = HEAP32[i19 + 4 >> 2] | 0;
    if (!(i5 >>> 0 < i20 >>> 0 | ((i5 | 0) == (i20 | 0) ? i4 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0 : 0))) {
     i19 = i1 + (i3 * 24 | 0) + 16 | 0;
     i1 = HEAP32[i19 >> 2] | 0;
     i19 = HEAP32[i19 + 4 >> 2] | 0;
     i6 = i5 >>> 0 < i19 >>> 0 | (i5 | 0) == (i19 | 0) & i4 >>> 0 < i1 >>> 0;
     i20 = i7;
     HEAP32[i20 >> 2] = i6 ? i1 : i4;
     HEAP32[i20 + 4 >> 2] = i6 ? i19 : i5;
     break;
    }
    i1 = HEAP32[i10 >> 2] | 0;
    if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i20 = (HEAP32[i17 >> 2] | 0) + (i1 * 24 | 0) | 0;
     HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i10 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i17, i11) | 0;
    HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i20 = (HEAP32[i17 >> 2] | 0) + (i1 * 24 | 0) | 0;
     HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i20 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i20 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i20 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i10 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i17, i11) | 0;
    HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    i2 = HEAP16[i6 >> 1] | 0;
   } while (0);
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) break;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i20 = (HEAP32[i17 >> 2] | 0) + (i1 * 24 | 0) | 0;
   HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i20 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i20 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i20 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   i1 = i1 + 1 | 0;
   HEAP32[i10 >> 2] = i1;
  } else i12 = 18;
 } else i12 = 18;
 if ((i12 | 0) == 18) {
  __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i17, i11) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (i1 | 0) {
  i8 = HEAP32[i17 >> 2] | 0;
  i2 = i13 + 36 | 0;
  i3 = i15 + 8 | 0;
  i4 = i15 + 16 | 0;
  i5 = i15 + 20 | 0;
  i6 = i15 + 24 | 0;
  i7 = i15 + 32 | 0;
  do {
   i1 = i1 + -1 | 0;
   i20 = i8 + (i1 * 24 | 0) | 0;
   i13 = __ZN5physx3Ext20ProfileZoneInterface19getProfileEventNameEy(HEAP32[i2 >> 2] | 0, HEAPU16[i20 >> 1] | 0, 0) | 0;
   i19 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0;
   i19 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, i19 | 0) | 0;
   i12 = i8 + (i1 * 24 | 0) + 8 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i15;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i10 = i8 + (i1 * 24 | 0) + 16 | 0;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i3;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i4 >> 2] = i13;
   HEAP32[i5 >> 2] = i19;
   HEAP16[i6 >> 1] = HEAP16[i20 >> 1] | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP16[i7 + 12 >> 1] = 0;
   mftCall_vii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i15 | 0);
  } while ((i1 | 0) != 0);
 }
 i20 = HEAP32[i14 >> 2] | 0;
 if (!((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
 STACKTOP = i18;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i13, i8) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i12 = i16 + 24 | 0;
 i11 = i16;
 i4 = i16 + 20 | 0;
 i5 = i16 + 16 | 0;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = (HEAP32[i14 >> 2] | 0) - i2 >> 6;
 i1 = i2;
 if (i3 >>> 0 >= i8 >>> 0) {
  if (i3 >>> 0 <= i8 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i6 = i1 + (i8 << 6) | 0;
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  i9 = i12 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i10 = i12 + 12 | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = i8 << 6;
  i4 = i3 >> 6;
  if (!i4) {
   i4 = i12 + 8 | 0;
   i6 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
    i2 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i2;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i12 >> 2] = i3;
   i2 = i3 + (i4 << 6) | 0;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = i2;
   i5 = i3;
   if (!i8) {
    i4 = i7;
    i6 = i5;
    i3 = i5;
   } else {
    i2 = i3;
    do {
     __ZN14AnimationEventC2ERKS_(i2, i1);
     i1 = i1 + 64 | 0;
     i2 = (HEAP32[i9 >> 2] | 0) + 64 | 0;
     HEAP32[i9 >> 2] = i2;
    } while ((i1 | 0) != (i6 | 0));
    i4 = i7;
    i6 = HEAP32[i12 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i9 >> 2] = i11;
  HEAP32[i14 >> 2] = i3;
  i5 = i13 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  i5 = i1;
  i2 = i11;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i3 = i15 + 4 | 0;
    i4 = i15 + 4 | 0;
    do {
     HEAP32[i9 >> 2] = i2 + -64;
     i1 = i2 + -44 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i14 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -32 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
     }
     i1 = i2 + -60 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i14 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -48 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i4 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
     }
     i2 = HEAP32[i9 >> 2] | 0;
    } while ((i2 | 0) != (i5 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i14 = HEAP32[i10 >> 2] | 0;
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if (((HEAP32[i7 >> 2] | 0) - i2 >> 6 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i13, i8 - i3 | 0);
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i2;
 __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj(i11, i8);
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i12, i15);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = i2 - i3 >> 6;
 i5 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i11, i8 - i1 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i6 = i3 + (i8 << 6) | 0;
  if ((i5 | 0) != (i6 | 0)) {
   i3 = i15 + 4 | 0;
   i4 = i15 + 4 | 0;
   i2 = i5;
   do {
    HEAP32[i9 >> 2] = i2 + -64;
    i1 = i2 + -44 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i2 + -32 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i8;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
    }
    i1 = i2 + -60 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i1 >> 2] | 0;
     i8 = HEAP32[i2 + -48 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i8;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i6 | 0));
  }
 }
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i13 >> 2] = i5;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i11 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i3 = i15 + 4 | 0;
   i4 = i15 + 4 | 0;
   do {
    HEAP32[i9 >> 2] = i2 + -64;
    i1 = i2 + -44 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -32 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
    }
    i1 = i2 + -60 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -48 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i14 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 >> 2] = 25;
  HEAP32[i15 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 }
 STACKTOP = i16;
 return;
}

function __ZNK22UnityProfilerPerThread15SaveToFrameDataER17ProfilerFrameData(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = HEAP32[i10 + 276 >> 2] | 0;
 if ((i12 | 0) >= (HEAP32[i1 + 1128 >> 2] | 0)) return;
 i11 = HEAP32[i1 + 1124 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i11 + (i12 * 144 | 0) + 120 | 0, HEAP32[i10 + 268 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i11 + (i12 * 144 | 0) + 132 | 0, HEAP32[i10 + 272 >> 2] | 0) | 0;
 i8 = i11 + (i12 * 144 | 0) | 0;
 i1 = i11 + (i12 * 144 | 0) + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i11 + (i12 * 144 | 0) + 4 | 0);
  HEAP32[i8 >> 2] = 0;
 }
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + (i12 * 144 | 0) + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i6 = i10 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 L7 : do if (i1 | 0) {
  i7 = i10 + 16 | 0;
  i5 = 0;
  i2 = 0;
  i3 = 0;
  i4 = 0;
  while (1) {
   i1 = i1 - i2 | 0;
   i1 = i1 >>> 0 > 16384 ? 16384 : i1;
   i13 = HEAP32[HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] >> 2] | 0;
   __ZN13dynamic_arrayI14ProfilerSampleLj8EE6insertEPS0_PKS0_S4_(i8, i3 + (i4 * 24 | 0) | 0, i13, i13 + (i1 * 24 | 0) | 0) | 0;
   i2 = i1 + i2 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 <= i2 >>> 0) break L7;
   i5 = i5 + 1 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
 } while (0);
 i2 = i11 + (i12 * 144 | 0) + 20 | 0;
 i6 = HEAP32[i10 + 56 >> 2] | 0;
 i7 = i11 + (i12 * 144 | 0) + 32 | 0;
 i1 = HEAP32[i10 + 68 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i7 >> 2] = i3;
 i4 = i11 + (i12 * 144 | 0) + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i11 + (i12 * 144 | 0) + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11 + (i12 * 144 | 0) + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i2 = i11 + (i12 * 144 | 0) + 40 | 0;
 i6 = HEAP32[i10 + 76 >> 2] | 0;
 i7 = i11 + (i12 * 144 | 0) + 52 | 0;
 i1 = HEAP32[i10 + 88 >> 2] << 3;
 i3 = i1 >> 3;
 HEAP32[i7 >> 2] = i3;
 i4 = i11 + (i12 * 144 | 0) + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i11 + (i12 * 144 | 0) + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11 + (i12 * 144 | 0) + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 i2 = i11 + (i12 * 144 | 0) + 60 | 0;
 i6 = HEAP32[i10 + 96 >> 2] | 0;
 i7 = i11 + (i12 * 144 | 0) + 72 | 0;
 i1 = HEAP32[i10 + 108 >> 2] << 3;
 i3 = i1 >> 3;
 HEAP32[i7 >> 2] = i3;
 i4 = i11 + (i12 * 144 | 0) + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i11 + (i12 * 144 | 0) + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11 + (i12 * 144 | 0) + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 i2 = i11 + (i12 * 144 | 0) + 80 | 0;
 i6 = HEAP32[i10 + 116 >> 2] | 0;
 i7 = i11 + (i12 * 144 | 0) + 92 | 0;
 i1 = HEAP32[i10 + 128 >> 2] << 2;
 i3 = i1 >> 2;
 HEAP32[i7 >> 2] = i3;
 i4 = i11 + (i12 * 144 | 0) + 96 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i11 + (i12 * 144 | 0) + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i11 + (i12 * 144 | 0) + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 i5 = i11 + (i12 * 144 | 0) + 100 | 0;
 i6 = HEAP32[i10 + 136 >> 2] | 0;
 i7 = i11 + (i12 * 144 | 0) + 112 | 0;
 i1 = (HEAP32[i10 + 148 >> 2] | 0) * 264 | 0;
 i2 = (i1 | 0) / 264 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i11 + (i12 * 144 | 0) + 116 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 8, i11 + (i12 * 144 | 0) + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i11 + (i12 * 144 | 0) + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 264 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 264 | 0) | 0;
 return;
}

function __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags(i6, i5 + 860 | 0, 0);
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 4 | 0, i6);
 i1 = i5 + 724 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
  i2 = i4;
 }
 i4 = i5 + 740 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i5 + 744 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 752 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 756 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 764 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 768 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 776 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 780 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 788 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 792 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 192 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP8[i7 >> 0] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 800 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 816 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 832 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 848 | 0;
  __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i5);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = i2;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 800 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 816 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 832 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i9 = i5 + 848 | 0;
  __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv(i5);
  STACKTOP = i10;
  return;
 }
}

function __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi(i16, i22, i17, i21, i15, i18) {
 i16 = i16 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i21 = i21 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i19 = 0, i20 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i23 + 24 | 0;
 i19 = i23 + 40 | 0;
 i20 = i23;
 i8 = HEAP32[i16 + 76 >> 2] | 0;
 if ((i8 | 0) > (i18 | 0)) {
  i4 = HEAP32[(HEAP32[i16 + 68 >> 2] | 0) + (i18 << 5) >> 2] | 0;
  i2 = i4;
  i5 = i4 + 12 | 0;
  i6 = i4 + 16 | 0;
  i1 = i4 + 20 | 0;
  i3 = i4 + 4 | 0;
  i4 = i4 + 8 | 0;
 } else {
  i4 = i18 - i8 | 0;
  i7 = HEAP32[i16 + 164 >> 2] | 0;
  i2 = i7 + (i4 * 40 | 0) | 0;
  i5 = i7 + (i4 * 40 | 0) + 12 | 0;
  i6 = i7 + (i4 * 40 | 0) + 16 | 0;
  i1 = i7 + (i4 * 40 | 0) + 20 | 0;
  i3 = i7 + (i4 * 40 | 0) + 4 | 0;
  i4 = i7 + (i4 * 40 | 0) + 8 | 0;
 }
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i15 + 12 | 0;
 f13 = Math_fround(HEAPF32[i15 >> 2]);
 if (!(f13 <= f9)) i2 = 0; else {
  f12 = Math_fround(HEAPF32[i7 >> 2]);
  if (!(f12 >= (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])))) i2 = 0; else i2 = 1;
 }
 if (f13 < f9) {
  f12 = Math_fround(HEAPF32[i7 >> 2]);
  if (f12 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i1 = 1; else i1 = 0;
 } else i1 = 0;
 f12 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 if (f12 <= f10) {
  f9 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  if (f9 >= (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i2 = i2 + 1 | 0;
 }
 if (f12 < f10) {
  f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  if (f10 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i1 = i1 + 1 | 0;
 }
 f9 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 if (f9 <= f11) {
  f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  if (f10 >= (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i2 = i2 + 1 | 0;
 }
 if (f9 < f11) {
  f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  if (f11 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i1 = i1 + 1 | 0;
 }
 if (!((i2 | 0) == 3 & (i1 | 0) > 1)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[(HEAP32[i16 + 148 >> 2] | 0) + (i21 << 2) >> 2] | 0;
 if ((i1 | 0) > -1) if (!((i8 | 0) <= (i1 | 0) | (i8 | 0) <= (i18 | 0))) {
  i6 = HEAP32[i16 + 460 >> 2] | 0;
  if ((HEAP32[i6 + (i21 << 5) >> 2] | 0) == (HEAP32[i6 + (HEAP32[(HEAP32[i16 + 68 >> 2] | 0) + (i18 << 5) + 4 >> 2] << 5) >> 2] | 0)) {
   STACKTOP = i23;
   return;
  }
 }
 i6 = i21 << 1;
 i6 = (HEAP32[(HEAP32[i17 + 4 >> 2] | 0) + (i6 >> 5 << 2) >> 2] | 0) >>> (i6 & 30) & 3;
 if ((i6 | 0) != 3) {
  i5 = (__ZNK5Umbra6KDTree4rankEi(i17, i21) | 0) << 1;
  if ((HEAP32[i17 + 24 >> 2] | 0) > (i21 | 0)) {
   i2 = (HEAP32[i17 + 12 >> 2] | 0) + (HEAP32[i17 + 16 >> 2] | 0) + (i21 << 2) | 0;
   i3 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = HEAP32[i15 + 16 >> 2] | 0;
   i1 = HEAP32[i15 + 20 >> 2] | 0;
  } else {
   f24 = Math_fround(HEAPF32[i7 >> 2]);
   f27 = Math_fround(Math_fround(f24 + f13) * Math_fround(.5));
   f10 = Math_fround(HEAPF32[i15 + 16 >> 2]);
   f26 = Math_fround(Math_fround(f10 + f12) * Math_fround(.5));
   f11 = Math_fround(HEAPF32[i15 + 20 >> 2]);
   f25 = Math_fround(Math_fround(f11 + f9) * Math_fround(.5));
   HEAPF32[i14 >> 2] = f27;
   HEAPF32[i14 + 4 >> 2] = f26;
   HEAPF32[i14 + 8 >> 2] = f25;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = i14 + (i6 << 2) | 0;
   i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i21 = HEAP32[i2 >> 2] | 0;
  HEAPF32[i19 >> 2] = f13;
  HEAPF32[i19 + 4 >> 2] = f12;
  HEAPF32[i19 + 8 >> 2] = f9;
  HEAP32[i19 + 12 >> 2] = i3;
  HEAP32[i19 + 16 >> 2] = i4;
  HEAP32[i19 + 20 >> 2] = i1;
  HEAPF32[i20 >> 2] = f13;
  HEAPF32[i20 + 4 >> 2] = f12;
  HEAPF32[i20 + 8 >> 2] = f9;
  HEAP32[i20 + 12 >> 2] = i3;
  HEAP32[i20 + 16 >> 2] = i4;
  HEAP32[i20 + 20 >> 2] = i1;
  HEAP32[i19 + 12 + (i6 << 2) >> 2] = i21;
  HEAP32[i20 + (i6 << 2) >> 2] = i21;
  __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi(i16, i22, i17, i5 + -1 | 0, i19, i18);
  __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi(i16, i22, i17, i5, i20, i18);
  STACKTOP = i23;
  return;
 }
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i23;
  return;
 }
 if (!((i8 | 0) <= (i18 | 0) | (i8 | 0) <= (i1 | 0))) {
  i20 = HEAP32[i16 + 460 >> 2] | 0;
  if ((HEAP32[i20 + (i21 << 5) >> 2] | 0) == (HEAP32[i20 + (HEAP32[(HEAP32[i16 + 68 >> 2] | 0) + (i18 << 5) + 4 >> 2] << 5) >> 2] | 0)) {
   STACKTOP = i23;
   return;
  }
 }
 i6 = i22 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i3 = i22 + 8 | 0;
 if ((HEAP32[i3 >> 2] | 0) > (i7 | 0)) i1 = HEAP32[i22 + 4 >> 2] | 0; else {
  i2 = i8 << 1;
  i2 = (i2 | 0) > 16 ? i2 : 16;
  i1 = HEAP32[i22 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
  if (!i1) {
   STACKTOP = i23;
   return;
  }
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i22 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    i3 = (i2 | 0) <= (i8 | 0) ? i2 : i8;
    if ((i3 | 0) > 0) {
     i2 = 0;
     do {
      HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
    }
   }
   i22 = HEAP32[i22 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i5 + -16 | 0);
  }
  HEAP32[i4 >> 2] = i1;
 }
 HEAP32[i6 >> 2] = i8;
 HEAP32[i1 + (i7 << 2) >> 2] = i21;
 STACKTOP = i23;
 return;
}

function __ZN13AnimationClip13AddFloatCurveERK17AnimationCurveTplIfERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEEiSC_(i1, i9, i10, i12, i13) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14;
 i7 = i14 + 8 | 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i11 = i7 + 16 | 0;
 HEAP32[i7 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAPF32[i7 + 44 >> 2] = Math_fround(inf);
 HEAP32[i7 + 40 >> 2] = 0;
 i11 = i7 + 48 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i7 + 72 >> 2] = Math_fround(inf);
 HEAP32[i7 + 68 >> 2] = 0;
 i11 = i7 + 76 | 0;
 HEAP32[i7 + 108 >> 2] = 0;
 i3 = i7 + 112 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 100 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i11 = i6;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i7 + 120 >> 2] = 2;
 HEAP32[i7 + 116 >> 2] = 2;
 HEAP32[i7 + 124 >> 2] = 4;
 HEAP32[i7 + 128 >> 2] = 0;
 i5 = i1 + 168 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 172 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 164 | 0, i7); else {
  __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i7);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 132;
 }
 i1 = i7 + 96 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i7 + 28 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i1 = i11 + -132 | 0;
 i8 = i11 + -92 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i3 = i11 + -64 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i3 = i11 + -36 | 0;
 if ((i8 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i8 = i11 + -24 | 0;
  i2 = HEAP32[i9 + 68 >> 2] << 4;
  i4 = i2 >> 4;
  HEAP32[i8 >> 2] = i4;
  i5 = i11 + -20 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 4, i11 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i3 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i11 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i3 >> 2] = i2;
   break;
  } else i2 = HEAP32[i3 >> 2] | 0; while (0);
  _memcpy(i2 | 0, i7 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
 }
 i6 = i11 + -16 | 0;
 i4 = i9 + 76 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i11 + -124 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i11 + -128 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + -128 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i11 + -100 >> 2] = i12;
 i1 = i11 + -116 | 0;
 i6 = HEAP8[i13 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
 i6 = i4 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i11 + -108 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i11 + -112 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
  STACKTOP = i14;
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i11 + -112 >> 2] = i6;
  STACKTOP = i14;
  return;
 } else {
  HEAP8[i4 >> 0] = i6;
  STACKTOP = i14;
  return;
 }
}

function __ZN10AudioMixer11SetupGroupsEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = i13 + 8 | 0;
 i7 = i13 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i13;
  return;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i12) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 221, 1, 0, 0, 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 100 >> 2] | 0;
 i8 = i12 + 92 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L8 : do if (i2) {
  HEAP32[i7 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i9 = 10; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i5 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i7);
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
    i2 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i9 = 10; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i9 = 12;
  }
  if ((i9 | 0) == 10) i9 = 12;
  if ((i9 | 0) == 12) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) break;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  if (!i2) i9 = 19; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i5 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i7);
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
    i2 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i9 = 19; else {
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    if (!i3) i9 = 21;
   }
  }
  if ((i9 | 0) == 19) i9 = 21;
  if ((i9 | 0) == 21) {
   i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  i6 = HEAP32[i3 + 52 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  if (!i2) i9 = 27; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i5 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i7);
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
    i2 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i9 = 27; else {
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    if (!i3) i9 = 29; else i5 = i3;
   }
  }
  if ((i9 | 0) == 27) i9 = 29;
  if ((i9 | 0) == 29) {
   i5 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  if (!i2) i9 = 35; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i7);
    i3 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 35; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i9 = 37;
   }
  }
  if ((i9 | 0) == 35) i9 = 37;
  if ((i9 | 0) == 37) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  i2 = i2 + 56 | 0;
  do if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) if (__ZN10AudioMixer18EnsureValidRuntimeEv(i5) | 0) {
   i2 = __ZN5audio5mixer16FindChannelGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID(HEAP32[i5 + 72 >> 2] | 0, HEAP32[i5 + 76 >> 2] | 0, i2) | 0;
   if (!i2) break; else {
    i1 = i2;
    break L8;
   }
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 430, 1, 0, 0, 0);
   break;
  } while (0);
  HEAP32[i11 >> 2] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0) | 0;
  __Z6FormatPKcz(i10, gb + 861680 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 861578 | 0, 233, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 } while (0);
 __ZN5audio5mixer17AssignOutputGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPN4FMOD12ChannelGroupE(HEAP32[i12 + 72 >> 2] | 0, HEAP32[i12 + 76 >> 2] | 0, i1);
 __ZN12AudioManager25RebindAudioSourcesToMixerEP10AudioMixer(__Z21GetManagerFromContexti(3) | 0, i12);
 STACKTOP = i13;
 return;
}

function __ZN11AudioSource16CheckConsistencyEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 16 | 0;
 i7 = i10;
 i2 = i8 + 412 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 i1 = f12 > Math_fround(1.0);
 f12 = i1 ? Math_fround(1.0) : f12;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f12;
 i2 = i8 + 388 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i3 | 0) < 0 ? 0 : (i3 | 0) > 256 ? 256 : i3;
 i2 = i8 + 408 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(-3.0);
 i1 = f12 > Math_fround(3.0);
 f12 = i1 ? Math_fround(3.0) : f12;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(-3.0) : f12;
 i2 = i8 + 392 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 i1 = f12 > Math_fround(5.0);
 f12 = i1 ? Math_fround(5.0) : f12;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f12;
 i2 = i8 + 396 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f12 < Math_fround(0.0);
 f12 = i3 ? Math_fround(0.0) : f12;
 HEAPF32[i2 >> 2] = f12;
 i2 = i8 + 400 | 0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f12 + Math_fround(9.99999997e-07));
 HEAPF32[i2 >> 2] = f11 < f12 ? f12 : f11;
 i2 = i8 + 300 | 0;
 i3 = i8 + 368 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) < 1) {
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(0.0), i7);
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i2, i6) | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(1.0), i7);
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i2, i6) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((i1 | 0) == 1) {
  i5 = (HEAP32[i8 + 356 >> 2] | 0) + 4 | 0;
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  i4 = f12 < Math_fround(0.0);
  i3 = f12 > Math_fround(1.0);
  f12 = i3 ? Math_fround(1.0) : f12;
  HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f12;
 }
 i5 = i8 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) < 1) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  __ZN11KeyframeTplIfEC2EfRKf(i7, Math_fround(0.0), i6);
  __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i8 + 36 | 0, i7, i7 + 16 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 | 0) == 1) {
  i4 = (HEAP32[i8 + 92 >> 2] | 0) + 4 | 0;
  f12 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = f12 < Math_fround(0.0);
  i2 = f12 > Math_fround(1.0);
  f12 = i2 ? Math_fround(1.0) : f12;
  HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f12;
 }
 i2 = i8 + 280 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < 1) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  __ZN11KeyframeTplIfEC2EfRKf(i7, Math_fround(0.0), i6);
  __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i8 + 212 | 0, i7, i7 + 16 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) == 1) {
  i4 = (HEAP32[i8 + 268 >> 2] | 0) + 4 | 0;
  f12 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = f12 < Math_fround(0.0);
  i2 = f12 > Math_fround(1.0);
  f12 = i2 ? Math_fround(1.0) : f12;
  HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f12;
 }
 i2 = i8 + 192 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < 1) {
  HEAPF32[i6 >> 2] = Math_fround(1.0);
  __ZN11KeyframeTplIfEC2EfRKf(i7, Math_fround(0.0), i6);
  __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i8 + 124 | 0, i7, i7 + 16 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) == 1) {
  i4 = (HEAP32[i8 + 180 >> 2] | 0) + 4 | 0;
  f12 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = f12 < Math_fround(0.0);
  i2 = f12 > Math_fround(1.10000002);
  f12 = i2 ? Math_fround(1.10000002) : f12;
  HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f12;
 }
 if (!(HEAP8[i8 + 548 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i8 + 436 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 24; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 24; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 26;
 }
 if ((i9 | 0) == 24) i9 = 26;
 if ((i9 | 0) == 26) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i5 >> 2] | 0) != 1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 33; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 33; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 35;
  }
 }
 if ((i9 | 0) == 33) i9 = 35;
 if ((i9 | 0) == 35) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i1 + 66 >> 0] | 0) {
  STACKTOP = i10;
  return;
 }
 HEAPF32[(HEAP32[i8 + 92 >> 2] | 0) + 4 >> 2] = Math_fround(0.0);
 HEAPF32[(HEAP32[i8 + 180 >> 2] | 0) + 4 >> 2] = Math_fround(0.0);
 STACKTOP = i10;
 return;
}

function __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i29, i30, i22, i15, i8, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i22 = i22 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, f32 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31;
 i23 = i31 + 12 | 0;
 i24 = __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i29, i30, i22, i15, i1) | 0;
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i15 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 < Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 i10 = i15 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 20 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i9 = i15 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i25 = i15;
 i26 = i8;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i5;
 HEAP32[i8 + 16 >> 2] = i6;
 HEAP32[i8 + 20 >> 2] = i7;
 i27 = i8 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i22 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 < Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 1 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 i17 = i22 + 4 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i19 = i22 + 12 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 16 | 0;
 i6 = HEAP32[i20 >> 2] | 0;
 i21 = i22 + 20 | 0;
 i7 = HEAP32[i21 >> 2] | 0;
 i16 = i22 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i25 = i22;
 i26 = i15;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i9 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 i1 = i30 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 < Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 2 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i2 = HEAP32[i30 >> 2] | 0;
 i9 = i30 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i30 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i30 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i30 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i30 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i30 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i25 = i30;
 i26 = i22;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i22 >> 2] = i2;
 HEAP32[i17 >> 2] = i3;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i19 >> 2] = i5;
 HEAP32[i20 >> 2] = i6;
 HEAP32[i21 >> 2] = i7;
 HEAP32[i16 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i28, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f32 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i29 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f32 < Math_fround(HEAPF32[i23 + 8 >> 2]))) {
  i30 = i24 + 3 | 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = HEAP32[i29 + 4 >> 2] | 0;
 i3 = HEAP32[i29 + 8 >> 2] | 0;
 i4 = HEAP32[i29 + 12 >> 2] | 0;
 i5 = HEAP32[i29 + 16 >> 2] | 0;
 i6 = HEAP32[i29 + 20 >> 2] | 0;
 i25 = i29 + 24 | 0;
 HEAP32[i28 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i28 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i28 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 i25 = i29;
 i26 = i30;
 i27 = i25 + 36 | 0;
 do {
  HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
  i25 = i25 + 4 | 0;
  i26 = i26 + 4 | 0;
 } while ((i25 | 0) < (i27 | 0));
 HEAP32[i30 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i28 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i28 + 8 >> 2];
 i30 = i24 + 4 | 0;
 STACKTOP = i31;
 return i30 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_18demangleINS0_2DbEEEvPKcS4_RT_Ri(i1, i10, i11, i12) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 24 | 0;
 i8 = i13 + 12 | 0;
 i9 = i13;
 L1 : do if (i1 >>> 0 < i10 >>> 0) {
  L3 : do if ((HEAP8[i1 >> 0] | 0) == 95) {
   i4 = i10;
   if ((i4 - i1 | 0) <= 3) {
    HEAP32[i12 >> 2] = -2;
    break L1;
   }
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 90:
    {
     i6 = i1 + 2 | 0;
     i5 = __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i6, i10, i11) | 0;
     i1 = (i5 | 0) == (i10 | 0);
     if (!((i5 | 0) == (i6 | 0) | i1)) if ((HEAP8[i5 >> 0] | 0) == 46) {
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      if ((HEAP32[i11 >> 2] | 0) != (i2 | 0)) {
       i6 = i2 + -24 | 0;
       HEAP32[i9 >> 2] = 0;
       HEAP32[i9 + 4 >> 2] = 0;
       HEAP32[i9 + 8 >> 2] = 0;
       i4 = i4 - i5 | 0;
       if (i4 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
       if (i4 >>> 0 < 11) {
        HEAP8[i9 + 11 >> 0] = i4;
        i3 = i9;
       } else {
        i2 = i4 + 16 & -16;
        i3 = _malloc(i2) | 0;
        HEAP32[i9 >> 2] = i3;
        HEAP32[i9 + 8 >> 2] = i2 | -2147483648;
        HEAP32[i9 + 4 >> 2] = i4;
       }
       i1 = i5;
       i2 = i3;
       while (1) {
        if ((i1 | 0) == (i10 | 0)) break;
        HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
        i1 = i1 + 1 | 0;
        i2 = i2 + 1 | 0;
       }
       HEAP8[i3 + i4 >> 0] = 0;
       __THREW__ = 0;
       i2 = invoke_iiii(fb + 520 | 0, i9 | 0, 0, gb + 1086285 | 0) | 0;
       i10 = __THREW__;
       __THREW__ = 0;
       if (i10 & 1) {
        i1 = ___cxa_find_matching_catch_2() | 0;
        getTempRet0() | 0;
       } else {
        HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
        HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
        i1 = 0;
        while (1) {
         if ((i1 | 0) == 3) break;
         HEAP32[i2 + (i1 << 2) >> 2] = 0;
         i1 = i1 + 1 | 0;
        }
        __THREW__ = 0;
        i2 = invoke_iii(fb + 1152 | 0, i8 | 0, gb + 1086288 | 0) | 0;
        i10 = __THREW__;
        __THREW__ = 0;
        do if (i10 & 1) {
         i1 = ___cxa_find_matching_catch_2() | 0;
         getTempRet0() | 0;
        } else {
         HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
         HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
         HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
         i1 = 0;
         while (1) {
          if ((i1 | 0) == 3) break;
          HEAP32[i2 + (i1 << 2) >> 2] = 0;
          i1 = i1 + 1 | 0;
         }
         i10 = HEAP8[i7 + 11 >> 0] | 0;
         i5 = i10 << 24 >> 24 < 0;
         __THREW__ = 0;
         invoke_iiii(fb + 519 | 0, i6 | 0, (i5 ? HEAP32[i7 >> 2] | 0 : i7) | 0, (i5 ? HEAP32[i7 + 4 >> 2] | 0 : i10 & 255) | 0) | 0;
         i10 = __THREW__;
         __THREW__ = 0;
         if (i10 & 1) {
          i1 = ___cxa_find_matching_catch_2() | 0;
          getTempRet0() | 0;
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
          break;
         } else {
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
          __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
          break L3;
         }
        } while (0);
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i9);
       ___resumeException(i1 | 0);
      }
     }
     if (i1) break L3;
     HEAP32[i12 >> 2] = -2;
     break L1;
    }
   case 95:
    {
     if ((HEAP8[i1 + 2 >> 0] | 0) == 95) if ((HEAP8[i1 + 3 >> 0] | 0) == 90) {
      i9 = i1 + 4 | 0;
      i3 = __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i9, i10, i11) | 0;
      if ((i3 | 0) == (i9 | 0) | (i3 | 0) == (i10 | 0)) {
       HEAP32[i12 >> 2] = -2;
       break L1;
      }
      L52 : do if ((i4 - i3 | 0) > 12) {
       i2 = 0;
       i1 = i3;
       while (1) {
        if ((i2 | 0) >= 13) break;
        if ((HEAP8[i1 >> 0] | 0) != (HEAP8[gb + 1086290 + i2 >> 0] | 0)) {
         i1 = i3;
         break L52;
        }
        i2 = i2 + 1 | 0;
        i1 = i1 + 1 | 0;
       }
       L58 : do if ((i1 | 0) == (i10 | 0)) i1 = i10; else {
        if ((HEAP8[i1 >> 0] | 0) == 95) {
         i2 = i1 + 1 | 0;
         if ((i2 | 0) == (i10 | 0)) {
          i1 = i3;
          break L52;
         }
         if (((HEAP8[i2 >> 0] | 0) + -48 | 0) >>> 0 >= 10) {
          i1 = i3;
          break L52;
         }
         i1 = i1 + 2 | 0;
        }
        while (1) {
         if ((i1 | 0) == (i10 | 0)) {
          i1 = i10;
          break L58;
         }
         if (((HEAP8[i1 >> 0] | 0) + -48 | 0) >>> 0 >= 10) break L58;
         i1 = i1 + 1 | 0;
        }
       } while (0);
       i2 = HEAP32[i11 + 4 >> 2] | 0;
       if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) i1 = i3; else __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i2 + -24 | 0, 0, gb + 1086304 | 0) | 0;
      } else i1 = i3; while (0);
      if ((i1 | 0) == (i10 | 0)) break L3;
      HEAP32[i12 >> 2] = -2;
      break L1;
     }
     break;
    }
   default:
    {}
   }
   HEAP32[i12 >> 2] = -2;
   break L1;
  } else if ((__ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i1, i10, i11) | 0) != (i10 | 0)) {
   HEAP32[i12 >> 2] = -2;
   break L1;
  } while (0);
  if (!(HEAP32[i12 >> 2] | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i11 + 4 >> 2] | 0)) HEAP32[i12 >> 2] = -2;
 } else HEAP32[i12 >> 2] = -2; while (0);
 STACKTOP = i13;
 return;
}

function __ZN14AreaEffector2D8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i10 = i6 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800830 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i5 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i10, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 92 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800847 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 15; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 15; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 15) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802350 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 26; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 26; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 26) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802367 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 37; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 37; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 37) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags(i9, i6 + 112 | 0, gb + 802414 | 0, 0);
 i4 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802440 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 48; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 48; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 48) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802447 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i7 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 59; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 59; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 59) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i10 >> 0] = 1;
 STACKTOP = i11;
 return;
}

function __ZN5physx19PxcContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i2, i5, i10, i14, i3, i1, i33) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i33 = i33 | 0;
 var f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0;
 f32 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f30 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f18 = Math_fround(f6 - f30);
 f7 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f29 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f19 = Math_fround(f7 - f29);
 f21 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f20 = Math_fround(f21 - f23);
 f8 = Math_fround(f18 * Math_fround(2.0));
 f12 = Math_fround(f19 * Math_fround(2.0));
 f11 = Math_fround(f20 * Math_fround(2.0));
 f25 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i14 >> 2]);
 f15 = Math_fround(f8 * f27);
 f28 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f12 * f28));
 f24 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f11 * f24));
 f4 = Math_fround(Math_fround(f27 * f15) + Math_fround(Math_fround(f8 * f26) - Math_fround(f25 * Math_fround(Math_fround(f11 * f28) - Math_fround(f12 * f24)))));
 f9 = Math_fround(Math_fround(f28 * f15) + Math_fround(Math_fround(f12 * f26) - Math_fround(f25 * Math_fround(Math_fround(f8 * f24) - Math_fround(f11 * f27)))));
 f15 = Math_fround(Math_fround(Math_fround(f11 * f26) - Math_fround(f25 * Math_fround(Math_fround(f12 * f27) - Math_fround(f8 * f28)))) + Math_fround(f24 * f15));
 f8 = Math_fround(-f13);
 if (f4 < f8) {
  f12 = f8;
  i1 = 1;
 } else if (f4 > f13) {
  f12 = f13;
  i1 = 1;
 } else {
  f12 = f4;
  i1 = 0;
 }
 f4 = Math_fround(-f16);
 if (f9 < f4) {
  f11 = f4;
  i2 = 1;
 } else if (f9 > f16) {
  f11 = f16;
  i2 = 1;
 } else {
  f11 = f9;
  i2 = i1;
 }
 f4 = Math_fround(-f17);
 if (f15 < f4) i31 = 9; else {
  i1 = f15 > f17;
  if (i1 | i2) {
   f4 = i1 ? f17 : f15;
   i31 = 9;
  } else {
   f4 = Math_fround(f13 - Math_fround(Math_abs(Math_fround(f12))));
   f9 = Math_fround(f16 - Math_fround(Math_abs(Math_fround(f11))));
   f8 = Math_fround(f17 - Math_fround(Math_abs(Math_fround(f15))));
   do if (f9 < f4) if (f9 < f8) {
    i14 = f11 > Math_fround(0.0);
    f4 = f9;
    i1 = 0;
    f8 = Math_fround(0.0);
    f9 = i14 ? Math_fround(2.0) : Math_fround(-2.0);
    break;
   } else {
    i1 = f15 > Math_fround(0.0);
    f4 = f8;
    i1 = i1 ? 1065353216 : -1082130432;
    f8 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    break;
   } else if (f4 < f8) {
    i14 = f12 > Math_fround(0.0);
    i1 = 0;
    f8 = i14 ? Math_fround(2.0) : Math_fround(-2.0);
    f9 = Math_fround(0.0);
    break;
   } else {
    i1 = f15 > Math_fround(0.0);
    f4 = f8;
    i1 = i1 ? 1065353216 : -1082130432;
    f8 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    break;
   } while (0);
   f4 = Math_fround(-f4);
   f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
   f30 = Math_fround(Math_fround(Math_fround(f8 * f27) + Math_fround(f9 * f28)) + Math_fround(f11 * f24));
   f16 = Math_fround(Math_fround(Math_fround(f11 * f26) + Math_fround(f25 * Math_fround(Math_fround(f9 * f27) - Math_fround(f8 * f28)))) + Math_fround(f24 * f30));
   f15 = Math_fround(Math_fround(f28 * f30) + Math_fround(Math_fround(f9 * f26) + Math_fround(f25 * Math_fround(Math_fround(f8 * f24) - Math_fround(f11 * f27)))));
   f11 = Math_fround(Math_fround(f27 * f30) + Math_fround(Math_fround(f8 * f26) + Math_fround(f25 * Math_fround(Math_fround(f11 * f28) - Math_fround(f9 * f24)))));
   f8 = f21;
  }
 }
 do if ((i31 | 0) == 9) {
  f6 = Math_fround(f12 * Math_fround(2.0));
  f9 = Math_fround(f11 * Math_fround(2.0));
  f7 = Math_fround(f4 * Math_fround(2.0));
  f8 = Math_fround(Math_fround(Math_fround(f27 * f6) + Math_fround(f28 * f9)) + Math_fround(f24 * f7));
  f13 = Math_fround(Math_fround(f27 * f8) + Math_fround(Math_fround(f26 * f6) + Math_fround(f25 * Math_fround(Math_fround(f28 * f7) - Math_fround(f24 * f9)))));
  f12 = Math_fround(Math_fround(f28 * f8) + Math_fround(Math_fround(f26 * f9) + Math_fround(f25 * Math_fround(Math_fround(f24 * f6) - Math_fround(f27 * f7)))));
  f8 = Math_fround(Math_fround(Math_fround(f25 * Math_fround(Math_fround(f27 * f9) - Math_fround(f28 * f6))) + Math_fround(f26 * f7)) + Math_fround(f24 * f8));
  f7 = Math_fround(f18 - f13);
  f6 = Math_fround(f19 - f12);
  f4 = Math_fround(f20 - f8);
  f9 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
  f28 = Math_fround(f32 + f22);
  if (f9 > Math_fround(f28 * f28)) {
   i33 = 0;
   return i33 | 0;
  } else {
   f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9))));
   f16 = Math_fround(f4 * f28);
   f15 = Math_fround(f6 * f28);
   f11 = Math_fround(f7 * f28);
   f8 = Math_fround(f8 + f23);
   f7 = Math_fround(f12 + f29);
   f6 = Math_fround(f13 + f30);
   f4 = Math_fround(f9 * f28);
   break;
  }
 } while (0);
 i1 = i33 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i33 = 1;
  return i33 | 0;
 }
 f32 = Math_fround(f4 - f32);
 HEAP32[i1 >> 2] = i2 + 1;
 HEAPF32[i33 + (i2 << 6) >> 2] = f11;
 HEAPF32[i33 + (i2 << 6) + 4 >> 2] = f15;
 HEAPF32[i33 + (i2 << 6) + 8 >> 2] = f16;
 HEAPF32[i33 + (i2 << 6) + 16 >> 2] = f6;
 HEAPF32[i33 + (i2 << 6) + 20 >> 2] = f7;
 HEAPF32[i33 + (i2 << 6) + 24 >> 2] = f8;
 HEAPF32[i33 + (i2 << 6) + 12 >> 2] = f32;
 HEAP32[i33 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i33 + (i2 << 6) + 52 >> 2] = -1;
 i33 = 1;
 return i33 | 0;
}

function __ZN5physx14PxsAABBManagerD2Ev(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 4 | 0;
 i10 = i13 + 3 | 0;
 i6 = i13 + 2 | 0;
 i7 = i13 + 1 | 0;
 i8 = i13;
 i9 = i12 + 49860 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i12 + 49856 | 0;
 if (i1 | 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = 0;
  do {
   i3 = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] | 0;
   if (i3) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 8 | 0, i1);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i3);
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i12 + 49832 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i12 + 49844 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, HEAP32[i5 >> 2] | 0);
 i2 = i12 + 512 | 0;
 __ZN5physx12InlineBufferIjLj4096EE4freeEv(i2);
 i3 = i12 + 16928 | 0;
 __ZN5physx12InlineBufferIjLj4096EE4freeEv(i3);
 i4 = i12 + 41584 | 0;
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i4);
 i5 = i12 + 45712 | 0;
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i5);
 i9 = HEAP32[i12 + 51620 >> 2] | 0;
 if ((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 + 51612 >> 2] | 0;
  if (i1 | 0) {
   i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
  }
 }
 i9 = HEAP32[i12 + 51608 >> 2] | 0;
 if ((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 + 51600 >> 2] | 0;
  if (i1 | 0) {
   i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
  }
 }
 HEAP32[i12 + 51556 >> 2] = gb + 87404 + 8;
 HEAP32[i12 + 51564 >> 2] = 0;
 __ZN5physx14SingleAABBTaskD2Ev(i12 + 51100 | 0);
 HEAP32[i12 + 51056 >> 2] = gb + 87404 + 8;
 HEAP32[i12 + 51064 >> 2] = 0;
 HEAP32[i12 + 51012 >> 2] = gb + 87404 + 8;
 HEAP32[i12 + 51020 >> 2] = 0;
 __ZN5physx17AggregateAABBTaskD2Ev(i12 + 50608 | 0);
 __ZN5physx13ActorAABBTaskD2Ev(i12 + 50324 | 0);
 __ZN5physx14SingleAABBTaskD2Ev(i12 + 49868 | 0);
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i5);
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i4);
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i12 + 37456 | 0);
 __ZN5physx12InlineBufferIjLj1024EE4freeEv(i12 + 33344 | 0);
 __ZN5physx12InlineBufferIjLj4096EE4freeEv(i3);
 __ZN5physx12InlineBufferIjLj4096EE4freeEv(i2);
 i1 = i12 + 356 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i12 + 368 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 360 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 364 | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 + 296 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 + 344 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 + 332 >> 2] | 0);
 i1 = HEAP32[i12 + 244 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i1);
 i1 = HEAP32[i12 + 280 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 284 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 288 | 0, i1);
 i1 = HEAP32[i12 + 268 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 272 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 276 | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 + 176 >> 2] | 0);
 i1 = HEAP32[i12 + 232 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 236 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 240 | 0, i1);
 i1 = HEAP32[i12 + 220 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 224 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 228 | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 + 152 >> 2] | 0);
 i1 = i12 + 124 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i12 + 136 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 128 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 132 | 0, i1);
 i1 = i12 + 96 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i12 + 108 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i12 + 100 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 104 | 0, i1);
 i1 = i12 + 68 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i12 + 80 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i10 = i12 + 8 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
  i10 = i12 + 56 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
  i12 = i12 + 44 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i12);
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i12 + 72 >> 2] | 0) <= -1) {
  i10 = i12 + 8 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
  i10 = i12 + 56 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
  i12 = i12 + 44 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i12);
  STACKTOP = i13;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 76 | 0, i1);
 i10 = i12 + 8 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
 i10 = i12 + 56 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
 i12 = i12 + 44 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i12);
 STACKTOP = i13;
 return;
}

function __ZN9InputAxis6UpdateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 f7 = Math_fround(HEAPF32[(__Z21GetManagerFromContexti(7) | 0) + 112 >> 2]);
 i9 = i8 + 105 | 0;
 if (HEAP8[i9 >> 0] | 0) {
  i6 = i8 + 80 | 0;
  HEAPF32[i6 >> 2] = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 }
 L4 : do switch (HEAP32[i8 + 76 >> 2] | 0) {
 case 0:
  {
   i1 = __Z21GetManagerFromContexti(1) | 0;
   i6 = HEAP32[i8 + 56 >> 2] | 0;
   i3 = i6 >>> 5;
   if (!((HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + (i3 << 2) >> 2] | HEAP32[(HEAP32[i1 + 68 >> 2] | 0) + (i3 << 2) >> 2]) & 1 << (i6 & 31))) {
    i3 = __Z21GetManagerFromContexti(1) | 0;
    i1 = HEAP32[i8 + 64 >> 2] | 0;
    i6 = i1 >>> 5;
    i1 = ((HEAP32[(HEAP32[i3 + 48 >> 2] | 0) + (i6 << 2) >> 2] | HEAP32[(HEAP32[i3 + 68 >> 2] | 0) + (i6 << 2) >> 2]) & 1 << (i1 & 31) | 0) != 0;
   } else i1 = 1;
   i11 = __Z21GetManagerFromContexti(1) | 0;
   i6 = HEAP32[i8 + 60 >> 2] | 0;
   i3 = i6 >>> 5;
   if (!((HEAP32[(HEAP32[i11 + 48 >> 2] | 0) + (i3 << 2) >> 2] | HEAP32[(HEAP32[i11 + 68 >> 2] | 0) + (i3 << 2) >> 2]) & 1 << (i6 & 31))) {
    i6 = __Z21GetManagerFromContexti(1) | 0;
    i3 = HEAP32[i8 + 68 >> 2] | 0;
    i11 = i3 >>> 5;
    i3 = ((HEAP32[(HEAP32[i6 + 48 >> 2] | 0) + (i11 << 2) >> 2] | HEAP32[(HEAP32[i6 + 68 >> 2] | 0) + (i11 << 2) >> 2]) & 1 << (i3 & 31) | 0) != 0;
   } else i3 = 1;
   i6 = i8 + 84 | 0;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   if (!(i1 & i3)) {
    if (i1) {
     i1 = i8 + 80 | 0;
     f2 = Math_fround(HEAPF32[i1 >> 2]);
     if ((HEAP8[i8 + 104 >> 0] | 0) != 0 & f2 < Math_fround(0.0)) {
      HEAPF32[i1 >> 2] = Math_fround(0.0);
      f2 = Math_fround(0.0);
     } else {
      f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 100 >> 2])));
      HEAPF32[i1 >> 2] = f2;
      if (f2 < Math_fround(0.0)) {
       f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 92 >> 2])));
       HEAPF32[i1 >> 2] = f2;
      }
     }
     HEAPF32[i5 >> 2] = Math_fround(1.0);
     i11 = f2 < Math_fround(1.0);
     HEAP32[i1 >> 2] = HEAP32[(i11 ? i1 : i5) >> 2];
     HEAPF32[i6 >> 2] = Math_fround(1.0);
     break L4;
    }
    if (i3) {
     i1 = i8 + 80 | 0;
     f2 = Math_fround(HEAPF32[i1 >> 2]);
     if ((HEAP8[i8 + 104 >> 0] | 0) != 0 & f2 > Math_fround(0.0)) {
      HEAPF32[i1 >> 2] = Math_fround(0.0);
      f2 = Math_fround(0.0);
     } else {
      f2 = Math_fround(f2 - Math_fround(f7 * Math_fround(HEAPF32[i8 + 100 >> 2])));
      HEAPF32[i1 >> 2] = f2;
      if (f2 > Math_fround(0.0)) {
       f2 = Math_fround(f2 - Math_fround(f7 * Math_fround(HEAPF32[i8 + 92 >> 2])));
       HEAPF32[i1 >> 2] = f2;
      }
     }
     HEAPF32[i5 >> 2] = Math_fround(-1.0);
     i11 = f2 > Math_fround(-1.0);
     HEAP32[i1 >> 2] = HEAP32[(i11 ? i1 : i5) >> 2];
     HEAPF32[i6 >> 2] = Math_fround(-1.0);
     break L4;
    }
    f2 = Math_fround(HEAPF32[i8 + 92 >> 2]);
    if (f2 != Math_fround(0.0)) {
     i1 = i8 + 80 | 0;
     f4 = Math_fround(HEAPF32[i1 >> 2]);
     if (f4 > Math_fround(0.0)) {
      f7 = Math_fround(f4 - Math_fround(f7 * f2));
      HEAPF32[i1 >> 2] = f7;
      if (!(f7 < Math_fround(0.0))) break L4;
      HEAPF32[i1 >> 2] = Math_fround(0.0);
      break L4;
     }
     if (f4 < Math_fround(0.0)) {
      f7 = Math_fround(Math_fround(f7 * f2) + f4);
      HEAPF32[i1 >> 2] = f7;
      if (f7 > Math_fround(0.0)) HEAPF32[i1 >> 2] = Math_fround(0.0);
     }
    }
   }
   break;
  }
 case 1:
  {
   i1 = __Z21GetManagerFromContexti(1) | 0;
   switch (HEAP32[i8 + 88 >> 2] | 0) {
   case 0:
    {
     i3 = HEAP32[i1 + 100 >> 2] | 0;
     i1 = i8 + 80 | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   case 1:
    {
     i3 = HEAP32[i1 + 104 >> 2] | 0;
     i1 = i8 + 80 | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   case 3:
    {
     i3 = HEAP32[i1 + 108 >> 2] | 0;
     i1 = i8 + 80 | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   default:
    {
     i3 = HEAP32[i1 + 112 >> 2] | 0;
     i1 = i8 + 80 | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   HEAP32[i8 + 84 >> 2] = i3;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i8 + 100 >> 2]) * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   break;
  }
 case 2:
  {
   i6 = __Z21GetManagerFromContexti(1) | 0;
   i1 = HEAP32[i8 + 72 >> 2] | 0;
   i3 = HEAP32[i8 + 88 >> 2] | 0;
   i11 = HEAP32[i6 + 124 >> 2] | 0;
   i5 = i11;
   if ((((HEAP32[i6 + 128 >> 2] | 0) - i11 | 0) / 12 | 0 | 0) > (i1 | 0)) {
    i6 = HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0;
    if (((HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0) - i6 >> 2 | 0) > (i3 | 0)) f2 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]); else f2 = Math_fround(0.0);
   } else f2 = Math_fround(0.0);
   i1 = i8 + 80 | 0;
   HEAPF32[i8 + 84 >> 2] = f2;
   f2 = Math_fround(f2 * Math_fround(HEAPF32[i8 + 100 >> 2]));
   HEAPF32[i1 >> 2] = f2;
   if (f2 > Math_fround(1.0)) {
    HEAPF32[i1 >> 2] = Math_fround(1.0);
    break L4;
   }
   if (f2 < Math_fround(-1.0)) {
    HEAPF32[i1 >> 2] = Math_fround(-1.0);
    break L4;
   }
   f4 = Math_fround(HEAPF32[i8 + 96 >> 2]);
   if (f2 < f4 & f2 > Math_fround(-f4)) {
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    break L4;
   }
   if (f2 > Math_fround(0.0)) {
    f7 = Math_fround(Math_fround(f2 - f4) / Math_fround(Math_fround(1.0) - f4));
    HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(0.0)));
    break L4;
   } else {
    f7 = Math_fround(Math_fround(Math_fround(-f2) - f4) / Math_fround(Math_fround(1.0) - f4));
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(0.0)) - f7);
    break L4;
   }
  }
 default:
  {}
 } while (0);
 if (!(HEAP8[i9 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i11 = i8 + 80 | 0;
 HEAPF32[i11 >> 2] = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 i11 = i8 + 84 | 0;
 HEAPF32[i11 >> 2] = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 STACKTOP = i10;
 return;
}

function _LzmaDec_DecodeToDic(i29, i30, i13, i31, i12, i33) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i13 = i13 | 0;
 i31 = i31 | 0;
 i12 = i12 | 0;
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i32 = 0, i34 = 0;
 i14 = HEAP32[i31 >> 2] | 0;
 HEAP32[i31 >> 2] = 0;
 i32 = i29 + 72 | 0;
 i7 = HEAP32[i32 >> 2] | 0;
 if ((i7 + -1 | 0) >>> 0 < 273) {
  i8 = HEAP32[i29 + 20 >> 2] | 0;
  i11 = i29 + 36 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i9 = HEAP32[i29 + 40 >> 2] | 0;
  i10 = HEAP32[i29 + 56 >> 2] | 0;
  i2 = i30 - i1 | 0;
  i2 = i2 >>> 0 < i7 >>> 0 ? i2 : i7;
  i5 = i29 + 48 | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   i6 = HEAP32[i29 + 12 >> 2] | 0;
   i4 = i29 + 44 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i6 - i3 | 0) >>> 0 <= i2 >>> 0) HEAP32[i5 >> 2] = i6;
  } else {
   i3 = i29 + 44 | 0;
   i4 = i3;
   i3 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i4 >> 2] = i3 + i2;
  HEAP32[i32 >> 2] = i7 - i2;
  if (i2) do {
   i2 = i2 + -1 | 0;
   HEAP8[i8 + i1 >> 0] = HEAP8[i8 + (i1 - i10 + (i1 >>> 0 < i10 >>> 0 ? i9 : 0)) >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) != 0);
  HEAP32[i11 >> 2] = i1;
 }
 HEAP32[i33 >> 2] = 0;
 L13 : do if ((HEAP32[i32 >> 2] | 0) == 274) i2 = i29 + 32 | 0; else {
  i15 = i29 + 76 | 0;
  i16 = i29 + 36 | 0;
  i17 = i29 + 80 | 0;
  i18 = i29 + 88 | 0;
  i19 = i29 + 24 | 0;
  i20 = i29 + 92 | 0;
  i21 = i20;
  i22 = i29 + 4 | 0;
  i23 = i29 + 16 | 0;
  i24 = i29 + 68 | 0;
  i25 = i29 + 64 | 0;
  i26 = i29 + 60 | 0;
  i27 = i29 + 56 | 0;
  i28 = i29 + 52 | 0;
  i2 = i29 + 32 | 0;
  i9 = (i12 | 0) == 0;
  i10 = i29 + 96 | 0;
  i11 = i29 + 28 | 0;
  i1 = i13;
  i3 = i14;
  while (1) {
   if (!(HEAP32[i15 >> 2] | 0)) i4 = i3; else {
    L20 : do if (!i3) i34 = 16; else while (1) {
     i4 = HEAP32[i18 >> 2] | 0;
     if (i4 >>> 0 >= 5) {
      i4 = i3;
      break L20;
     }
     i5 = i1 + 1 | 0;
     i14 = HEAP8[i1 >> 0] | 0;
     HEAP32[i18 >> 2] = i4 + 1;
     HEAP8[i29 + 92 + i4 >> 0] = i14;
     HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + 1;
     i3 = i3 + -1 | 0;
     if (!i3) {
      i1 = i5;
      i34 = 16;
      break;
     } else i1 = i5;
    } while (0);
    if ((i34 | 0) == 16) {
     i34 = 0;
     if ((HEAP32[i18 >> 2] | 0) >>> 0 < 5) {
      i34 = 17;
      break;
     } else i4 = 0;
    }
    i3 = HEAP32[i20 >> 2] | 0;
    if ((i3 & 255) << 24 >> 24) {
     i1 = 1;
     i34 = 54;
     break;
    }
    HEAP32[i2 >> 2] = i3 & 16711680 | i3 << 16 & -16777216 | i3 >>> 24 << 8 | (HEAPU8[i10 >> 0] | 0);
    HEAP32[i11 >> 2] = -1;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
   }
   if ((HEAP32[i16 >> 2] | 0) >>> 0 < i30 >>> 0) i8 = 0; else {
    i3 = (HEAP32[i32 >> 2] | 0) == 0;
    if (i3) if (!(HEAP32[i2 >> 2] | 0)) {
     i34 = 23;
     break;
    }
    if (i9) {
     i34 = 25;
     break;
    }
    if (i3) i8 = 1; else {
     i34 = 27;
     break;
    }
   }
   if (HEAP32[i17 >> 2] | 0) {
    i5 = (768 << (HEAP32[i22 >> 2] | 0) + (HEAP32[i29 >> 2] | 0)) + 1846 | 0;
    i6 = HEAP32[i23 >> 2] | 0;
    if (i5 | 0) {
     i3 = 0;
     do {
      HEAP16[i6 + (i3 << 1) >> 1] = 1024;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i5 | 0));
    }
    HEAP32[i24 >> 2] = 1;
    HEAP32[i25 >> 2] = 1;
    HEAP32[i26 >> 2] = 1;
    HEAP32[i27 >> 2] = 1;
    HEAP32[i28 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
   i3 = HEAP32[i18 >> 2] | 0;
   if (!i3) {
    i3 = (i8 | 0) != 0;
    if (i4 >>> 0 < 20 | i3) {
     i5 = _LzmaDec_TryDummy(i29, i1, i4) | 0;
     if (!i5) {
      i34 = 36;
      break;
     }
     if (i3 & (i5 | 0) != 2) {
      i34 = 38;
      break;
     } else i3 = i1;
    } else i3 = i1 + i4 + -20 | 0;
    HEAP32[i19 >> 2] = i1;
    if (_LzmaDec_DecodeReal2(i29, i30, i3) | 0) {
     i1 = 1;
     i34 = 54;
     break;
    }
    i14 = HEAP32[i19 >> 2] | 0;
    i3 = i14 - i1 | 0;
    HEAP32[i31 >> 2] = i3 + (HEAP32[i31 >> 2] | 0);
    i1 = i14;
   } else {
    i5 = i3 >>> 0 < 20;
    if (i5 & (i4 | 0) != 0) {
     i5 = 0;
     while (1) {
      i6 = i5 + 1 | 0;
      i7 = i3 + 1 | 0;
      HEAP8[i29 + 92 + i3 >> 0] = HEAP8[i1 + i5 >> 0] | 0;
      i3 = i7 >>> 0 < 20;
      if (i3 & i6 >>> 0 < i4 >>> 0) {
       i5 = i6;
       i3 = i7;
      } else break;
     }
    } else {
     i6 = 0;
     i7 = i3;
     i3 = i5;
    }
    HEAP32[i18 >> 2] = i7;
    i5 = (i8 | 0) != 0;
    if (i5 | i3) {
     i3 = _LzmaDec_TryDummy(i29, i20, i7) | 0;
     if (!i3) {
      i34 = 46;
      break;
     }
     if (i5 & (i3 | 0) != 2) {
      i34 = 48;
      break;
     }
    }
    HEAP32[i19 >> 2] = i20;
    if (_LzmaDec_DecodeReal2(i29, i30, i20) | 0) {
     i1 = 1;
     i34 = 54;
     break;
    }
    i3 = i6 - (i7 + i21) + (HEAP32[i19 >> 2] | 0) | 0;
    HEAP32[i31 >> 2] = i3 + (HEAP32[i31 >> 2] | 0);
    HEAP32[i18 >> 2] = 0;
    i1 = i1 + i3 | 0;
   }
   if ((HEAP32[i32 >> 2] | 0) == 274) break L13; else i3 = i4 - i3 | 0;
  }
  if ((i34 | 0) == 17) {
   HEAP32[i33 >> 2] = 3;
   i34 = 0;
   return i34 | 0;
  } else if ((i34 | 0) == 23) {
   HEAP32[i33 >> 2] = 4;
   i34 = 0;
   return i34 | 0;
  } else if ((i34 | 0) == 25) {
   HEAP32[i33 >> 2] = 2;
   i34 = 0;
   return i34 | 0;
  } else if ((i34 | 0) == 27) {
   HEAP32[i33 >> 2] = 2;
   i34 = 1;
   return i34 | 0;
  } else if ((i34 | 0) == 36) {
   _memcpy(i20 | 0, i1 | 0, i4 | 0) | 0;
   HEAP32[i18 >> 2] = i4;
   HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + i4;
   HEAP32[i33 >> 2] = 3;
   i34 = 0;
   return i34 | 0;
  } else if ((i34 | 0) == 38) {
   HEAP32[i33 >> 2] = 2;
   i34 = 1;
   return i34 | 0;
  } else if ((i34 | 0) == 46) {
   HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + i6;
   HEAP32[i33 >> 2] = 3;
   i34 = 0;
   return i34 | 0;
  } else if ((i34 | 0) == 48) {
   HEAP32[i33 >> 2] = 2;
   i34 = 1;
   return i34 | 0;
  } else if ((i34 | 0) == 54) return i1 | 0;
 } while (0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i33 >> 2] = 1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i34 = (i1 | 0) != 0 & 1;
 return i34 | 0;
}

function __ZN19ShaderPropertySheet14LerpPropertiesERKS_S1_f(i26, i23, i21, f27) {
 i26 = i26 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 f27 = Math_fround(f27);
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f22 = f0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i29;
 i1 = HEAP32[i23 + 8 >> 2] | 0;
 i19 = i23 + 12 | 0;
 i20 = HEAP32[i19 >> 2] | 0;
 if ((i1 | 0) != (i20 | 0)) {
  i11 = i23 + 32 | 0;
  i12 = i21 + 8 | 0;
  i13 = i21 + 12 | 0;
  i14 = i21 + 32 | 0;
  i15 = i21 + 52 | 0;
  i16 = i21 + 72 | 0;
  i17 = i23 + 52 | 0;
  i18 = i23 + 72 | 0;
  f4 = Math_fround(Math_fround(1.0) - f27);
  do {
   i10 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   i6 = HEAP32[i13 >> 2] | 0;
   L5 : do if ((i2 | 0) < (i6 | 0)) {
    i7 = HEAP32[i14 >> 2] | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    while (1) {
     if ((HEAP32[i7 + (i2 << 2) >> 2] | 0) == (i8 | 0)) break;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i6 | 0)) {
      f3 = Math_fround(0.0);
      break L5;
     }
    }
    if ((i2 | 0) > -1) f3 = Math_fround(HEAPF32[(HEAP32[i16 >> 2] | 0) + (HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] & 1048575) >> 2]); else f3 = Math_fround(0.0);
   } else f3 = Math_fround(0.0); while (0);
   i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   f3 = Math_fround(Math_fround(f3 * f27) + Math_fround(f4 * Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + (i2 & 1048575) >> 2])));
   i2 = i2 & 1073741824;
   do if (i2) if ((__Z19GetActiveColorSpacev() | 0) == 1) if (!(f3 <= Math_fround(0.0))) {
    if (f3 <= Math_fround(.00313080009)) {
     f3 = Math_fround(f3 * Math_fround(12.9200001));
     break;
    }
    if (f3 < Math_fround(1.0)) {
     f3 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, .454545468));
   } else f3 = Math_fround(0.0); while (0);
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i26, i10, f3, i2 >>> 30);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i20 | 0));
  i1 = HEAP32[i19 >> 2] | 0;
 }
 i17 = HEAP32[i23 + 16 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i29;
  return;
 }
 i18 = i23 + 32 | 0;
 i19 = i21 + 12 | 0;
 i20 = i21 + 16 | 0;
 i24 = i21 + 32 | 0;
 i25 = i21 + 52 | 0;
 i15 = i21 + 72 | 0;
 i16 = i23 + 52 | 0;
 i11 = i23 + 72 | 0;
 f22 = Math_fround(Math_fround(1.0) - f27);
 i12 = i28 + 4 | 0;
 i13 = i28 + 8 | 0;
 i14 = i28 + 12 | 0;
 do {
  i10 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  i2 = HEAP32[i19 >> 2] | 0;
  i6 = HEAP32[i20 >> 2] | 0;
  L32 : do if ((i2 | 0) < (i6 | 0)) {
   i7 = HEAP32[i24 >> 2] | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   while (1) {
    if ((HEAP32[i7 + (i2 << 2) >> 2] | 0) == (i8 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i6 | 0)) {
     i2 = gb + 1162376 | 0;
     break L32;
    }
   }
   if ((i2 | 0) > -1) i2 = (HEAP32[i15 >> 2] | 0) + (HEAP32[(HEAP32[i25 >> 2] | 0) + (i2 << 2) >> 2] & 1048575) | 0; else i2 = gb + 1162376 | 0;
  } else i2 = gb + 1162376 | 0; while (0);
  f32 = Math_fround(HEAPF32[i2 >> 2]);
  f31 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i23 = (HEAP32[i11 >> 2] | 0) + (i2 & 1048575) | 0;
  f4 = Math_fround(HEAPF32[i23 >> 2]);
  f5 = Math_fround(HEAPF32[i23 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i23 + 8 >> 2]);
  f4 = Math_fround(Math_fround(f32 * f27) + Math_fround(f22 * f4));
  f5 = Math_fround(Math_fround(f31 * f27) + Math_fround(f22 * f5));
  f3 = Math_fround(Math_fround(f30 * f27) + Math_fround(f22 * f3));
  f9 = Math_fround(Math_fround(f9 * f27) + Math_fround(f22 * Math_fround(HEAPF32[i23 + 12 >> 2])));
  HEAPF32[i28 >> 2] = f4;
  HEAPF32[i12 >> 2] = f5;
  HEAPF32[i13 >> 2] = f3;
  HEAPF32[i14 >> 2] = f9;
  i2 = i2 & 1073741824;
  if (i2 | 0) {
   do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
    do if (!(f4 <= Math_fround(0.0))) {
     if (f4 <= Math_fround(.00313080009)) {
      f4 = Math_fround(f4 * Math_fround(12.9200001));
      break;
     }
     if (f4 < Math_fround(1.0)) {
      f4 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, .454545468));
    } else f4 = Math_fround(0.0); while (0);
    do if (!(f5 <= Math_fround(0.0))) {
     if (f5 <= Math_fround(.00313080009)) {
      f5 = Math_fround(f5 * Math_fround(12.9200001));
      break;
     }
     if (f5 < Math_fround(1.0)) {
      f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f5, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, .454545468));
    } else f5 = Math_fround(0.0); while (0);
    if (!(f3 <= Math_fround(0.0))) {
     if (f3 <= Math_fround(.00313080009)) {
      f3 = Math_fround(f3 * Math_fround(12.9200001));
      break;
     }
     if (f3 < Math_fround(1.0)) {
      f3 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, .454545468));
    } else f3 = Math_fround(0.0);
   } while (0);
   HEAPF32[i28 >> 2] = f4;
   HEAPF32[i12 >> 2] = f5;
   HEAPF32[i13 >> 2] = f3;
   HEAPF32[i14 >> 2] = f9;
  }
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i26, i10, i28, i2 >>> 30);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i17 | 0));
 STACKTOP = i29;
 return;
}

function __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i11, i7, i12) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 32 | 0;
 i10 = i16 + 24 | 0;
 i8 = i16 + 12 | 0;
 i14 = i16;
 __ZNK9Transform18GetWorldScaleLossyEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i11 + 76 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(HEAPF32[i11 + 80 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 HEAPF32[i7 >> 2] = f5;
 i8 = i7 + 4 | 0;
 HEAPF32[i8 >> 2] = f6;
 i13 = i11 + 36 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if (!i1) i15 = 11; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i15 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i15 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i15 = 9;
  }
  if ((i15 | 0) == 7) i15 = 9;
  if ((i15 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
    i15 = 11;
    break;
   }
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  if (!i1) i15 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i15 = 19;
   }
  }
  if ((i15 | 0) == 17) i15 = 19;
  if ((i15 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 } while (0);
 if ((i15 | 0) == 11) {
  HEAP32[i14 >> 2] = HEAP32[gb + 62512 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 }
 if (HEAP8[i11 + 92 >> 0] | 0) if (!(HEAP8[i11 + 52 >> 0] | 0)) {
  i1 = __ZNK7Joint2D10FetchBodyAEv(i11) | 0;
  f17 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f19 = Math_fround(HEAPF32[i7 >> 2]);
  f5 = Math_fround(f17 * f19);
  f18 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  f5 = Math_fround(f5 - Math_fround(f18 * f6));
  f5 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f5);
  f6 = Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * f6));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i1 + 16 >> 2]));
  i1 = HEAP32[i13 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 30; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 30; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i15 = 32;
   }
   if ((i15 | 0) == 30) i15 = 32;
   if ((i15 | 0) == 32) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) break;
   i15 = __ZNK7Joint2D10FetchBodyBEv(i11) | 0;
   f17 = Math_fround(f5 - Math_fround(HEAPF32[i15 + 12 >> 2]));
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i15 + 16 >> 2]));
   f5 = Math_fround(HEAPF32[i15 + 24 >> 2]);
   f18 = Math_fround(f17 * f5);
   f19 = Math_fround(HEAPF32[i15 + 20 >> 2]);
   f18 = Math_fround(f18 + Math_fround(f6 * f19));
   f19 = Math_fround(Math_fround(f5 * f6) - Math_fround(f17 * f19));
   f6 = Math_fround(f18 / Math_fround(HEAPF32[i14 >> 2]));
   f17 = Math_fround(f19 / Math_fround(HEAPF32[i14 + 4 >> 2]));
   HEAPF32[i11 + 84 >> 2] = f6;
   HEAPF32[i11 + 88 >> 2] = f17;
   HEAPF32[i12 >> 2] = f18;
   HEAPF32[i12 + 4 >> 2] = f19;
   STACKTOP = i16;
   return;
  } while (0);
  HEAPF32[i11 + 84 >> 2] = f5;
  HEAPF32[i11 + 88 >> 2] = f6;
  HEAPF32[i12 >> 2] = f5;
  HEAPF32[i12 + 4 >> 2] = f6;
  STACKTOP = i16;
  return;
 }
 f18 = Math_fround(HEAPF32[i11 + 84 >> 2]);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i14 >> 2]));
 f19 = Math_fround(HEAPF32[i11 + 88 >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i14 + 4 >> 2]));
 HEAPF32[i12 >> 2] = f18;
 HEAPF32[i12 + 4 >> 2] = f19;
 STACKTOP = i16;
 return;
}

function __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i14, i3, i13, i1, i5) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 32 | 0;
 i12 = i17;
 i16 = i17 + 24 | 0;
 i2 = i5 << 2;
 i10 = i2 >>> 0 > 1024;
 i15 = i16 + 4 | 0;
 HEAP8[i15 >> 0] = i10 & 1;
 if (i10) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i17 + 36 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i16 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i16 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i8 = 0;
  i4 = 0;
  i10 = i5;
  L7 : while (1) {
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i9 = mftCall_iii(HEAP32[i13 >> 2] | 0, i14 + (i6 * 40 | 0) | 0, i14 + (i5 * 40 | 0) | 0) | 0;
       i5 = i9 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i24 = i14 + (i5 * 40 | 0) + 4 | 0;
       i21 = HEAPU16[i24 >> 1] | HEAPU16[i24 + 2 >> 1] << 16;
       i19 = i14 + (i5 * 40 | 0) + 8 | 0;
       i19 = HEAPU16[i19 >> 1] | HEAPU16[i19 + 2 >> 1] << 16;
       i6 = i14 + (i5 * 40 | 0) + 12 | 0;
       i9 = i14 + (i5 * 40 | 0) + 16 | 0;
       HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
       i18 = HEAP32[i6 >> 2] | 0;
       i22 = i14 + (i5 * 40 | 0) + 20 | 0;
       HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
       HEAP32[i12 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
       HEAP32[i12 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
       i20 = i14 + (i7 * 40 | 0) + 4 | 0;
       i23 = i20;
       i25 = i23;
       i25 = HEAPU16[i25 >> 1] | HEAPU16[i25 + 2 >> 1] << 16;
       i23 = i23 + 4 | 0;
       i23 = HEAPU16[i23 >> 1] | HEAPU16[i23 + 2 >> 1] << 16;
       i5 = i24;
       i24 = i5;
       HEAP16[i24 >> 1] = i25;
       HEAP16[i24 + 2 >> 1] = i25 >>> 16;
       i5 = i5 + 4 | 0;
       HEAP16[i5 >> 1] = i23;
       HEAP16[i5 + 2 >> 1] = i23 >>> 16;
       i5 = i14 + (i7 * 40 | 0) + 12 | 0;
       HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
       i6 = i14 + (i7 * 40 | 0) + 16 | 0;
       HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
       i9 = i14 + (i7 * 40 | 0) + 20 | 0;
       HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i22 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i22 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i22 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       HEAP32[i22 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
       HEAP16[i20 >> 1] = i21;
       HEAP16[i20 + 2 >> 1] = i21 >>> 16;
       i7 = i14 + (i7 * 40 | 0) + 8 | 0;
       HEAP16[i7 >> 1] = i19;
       HEAP16[i7 + 2 >> 1] = i19 >>> 16;
       HEAP32[i5 >> 2] = i18;
       HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
       HEAP32[i9 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i25 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i25 << 2) >> 2] | 0;
    i8 = i25;
   }
   i9 = __ZN5physx6shdfnd8internal9partitionINS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEiPT_iiRT0_(i14, i4, i3, i13) | 0;
   if ((i9 - i4 | 0) < (i3 - i9 | 0)) {
    i7 = i9 + -1 | 0;
    if (i8 >>> 0 < (i10 + -1 | 0) >>> 0) i5 = i10; else {
     i5 = i10 << 3;
     if (!i5) i6 = 0; else {
      i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i24 = HEAP32[(HEAP32[i25 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i24 | 0, i25 | 0, i5 | 0, (i6 ? gb + 838215 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i10 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i7;
    i4 = i9 + 1 | 0;
   } else {
    i6 = i9 + 1 | 0;
    if (i8 >>> 0 < (i10 + -1 | 0) >>> 0) i5 = i10; else {
     i5 = i10 << 3;
     if (!i5) i5 = 0; else {
      i24 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i23 = HEAP32[(HEAP32[i24 >> 2] | 0) + 8 >> 2] | 0;
      i25 = _PxGetFoundation() | 0;
      i25 = mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 24 >> 2] | 0, i25 | 0) | 0;
      i5 = mftCall_iiiiii(i23 | 0, i24 | 0, i5 | 0, (i25 ? gb + 838215 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i10 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i9 + -1 | 0;
   }
   i8 = i8 + 2 | 0;
   i10 = i5;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i17;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx28PxTriangleMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i16, i2, i3, i4, i12, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 96 | 0;
 i10 = i24 + 32 | 0;
 i1 = i24 + 80 | 0;
 i7 = i24 + 72 | 0;
 i13 = i24;
 i18 = i10 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i10 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP16[i10 + 24 >> 1] = 0;
 HEAPF32[i10 + 36 >> 2] = Math_fround(.00100000005);
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i3, gb + 673324 | 0, i23, i10, i10 + 8 | 0, i4);
 HEAP32[i10 + 4 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS0_8TriangleIjEEEEvRNS_9XmlReaderEPKcRPvRjSA_RNS_18XmlMemoryAllocatorE(i3, gb + 673331 | 0, i23, i10 + 12 | 0, i10 + 20 | 0, i4);
 HEAP32[i10 + 16 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyItEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i3, gb + 753833 | 0, i23, i18, i24 + 88 | 0, i4);
 HEAP32[i14 >> 2] = HEAP32[i23 >> 2];
 i14 = i1 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIhEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i3, gb + 673178 | 0, i23, i1, i7, i4);
 i1 = HEAP32[i23 >> 2] | 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i23 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 i14 = i23 + 4 | 0;
 HEAP32[i14 >> 2] = i23;
 i18 = i23;
 HEAP32[i23 + 8 >> 2] = i18;
 i21 = i23 + 12 | 0;
 HEAP32[i21 >> 2] = 0;
 i15 = i23 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i22 = i23 + 20 | 0;
 HEAP32[i22 >> 2] = 0;
 i9 = i23 + 24 | 0;
 HEAP32[i9 >> 2] = i18;
 i18 = i23 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAPF32[i23 + 52 >> 2] = Math_fround(.75);
 i19 = i23 + 56 | 0;
 HEAP32[i19 >> 2] = -1;
 HEAP32[i23 + 60 >> 2] = 0;
 i20 = i23 + 64 | 0;
 HEAP32[i20 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i9, 64);
 HEAP32[i23 + 68 >> 2] = 32;
 i9 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 HEAP32[i11 >> 2] = i23;
 i8 = i13 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i13 >> 2] = gb + 89528 + 8;
 HEAP32[i9 >> 2] = gb + 89528 + 32;
 i7 = HEAP32[i7 >> 2] | 0;
 if (!i7) {
  i3 = i13 + 4 | 0;
  i1 = i12;
  i2 = i13 + 20 | 0;
  i17 = 10;
 } else {
  i6 = i13 + 24 | 0;
  i2 = 32;
  while (1) if (i2 >>> 0 < i7 >>> 0) i2 = i2 << 1; else {
   i5 = i2;
   break;
  }
  i4 = __ZN5physx19CVariableMemoryPool8allocateEj(i23 + 4 | 0, i5) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i13 + 20 | 0;
  if (i3 | 0) _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i11 >> 2] | 0) + 4 | 0, i3 + -8 | 0, HEAP32[i3 + -4 >> 2] | 0);
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  _memcpy(i4 + (HEAP32[i8 >> 2] | 0) | 0, i1 | 0, i7 | 0) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i7;
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = i13 + 4 | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i3 | 0) | 0;
  if (!i1) {
   i1 = i12;
   i17 = 10;
  }
 }
 if ((i17 | 0) == 10) {
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  i17 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0, i17 | 0, i10 | 0, i13 | 0) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i3 | 0) | 0;
 }
 HEAP32[i16 >> 2] = gb + 753858;
 HEAP32[i16 + 4 >> 2] = i1;
 i17 = i16 + 8 | 0;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = gb + 89572 + 8;
 HEAP32[i9 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i11 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 i1 = HEAP32[i21 >> 2] | 0;
 i17 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + (i17 << 2) | 0;
 if (i17 | 0) do {
  i17 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i15 >> 2] = 0;
 i1 = HEAP32[i23 + 48 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i20 >> 2] | 0) == 0)) {
  _memset(HEAP32[i23 + 40 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i23 + 44 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i23 + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[HEAP32[i23 + 24 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i24;
  return;
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 i23 = HEAP32[HEAP32[i23 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i24;
 return;
}

function __ZN6prcore14BlitImageFloatERK14ImageReferenceRS0_NS0_8BlitModeE(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i2 = i8 + 4 | 0;
 i3 = i7 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i8 + 8 >> 2] | 0) == (HEAP32[i7 + 8 >> 2] | 0)) i1 = 0; else i10 = 3; else i10 = 3;
 if ((i10 | 0) == 3) i1 = (i1 + -1 | 0) >>> 0 < 2;
 if (!(__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i7 >> 2] | 0) | 0)) if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i7 >> 2] | 0) | 0)) {
  if (!i1) {
   __ZN6prcoreL18BlitIntegerToFloatERK14ImageReferenceRS0_(i7, i8);
   STACKTOP = i11;
   return;
  }
  __ZN5ImageC2Eii13TextureFormat(i9, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 8 >> 2] | 0, HEAP32[i8 >> 2] | 0);
  __ZN6prcoreL18BlitIntegerToFloatERK14ImageReferenceRS0_(i7, i9);
  if (__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i8 >> 2] | 0) | 0) i10 = 9; else if (__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i8 >> 2] | 0) | 0) i10 = 9;
  if ((i10 | 0) == 9) __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_(i9, i8);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 + 16 >> 2] | 0, gb + 63184 | 0);
  STACKTOP = i11;
  return;
 }
 if (!(__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i8 >> 2] | 0) | 0)) if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i8 >> 2] | 0) | 0)) {
  if (!i1) {
   __ZN6prcoreL18BlitFloatToIntegerERK14ImageReferenceRS0_(i7, i8);
   STACKTOP = i11;
   return;
  }
  __ZN5ImageC2Eii13TextureFormat(i9, HEAP32[i2 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0, HEAP32[i7 >> 2] | 0);
  if (__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i7 >> 2] | 0) | 0) i10 = 18; else if (__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i7 >> 2] | 0) | 0) i10 = 18; else i1 = i9;
  if ((i10 | 0) == 18) {
   __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_(i7, i9);
   i1 = i9;
  }
  __ZN6prcoreL18BlitFloatToIntegerERK14ImageReferenceRS0_(i1, i8);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 + 16 >> 2] | 0, gb + 63184 | 0);
  STACKTOP = i11;
  return;
 }
 if (i1) {
  __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_(i7, i8);
  STACKTOP = i11;
  return;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i4 = (i3 | 0) == 18;
 if (i4) {
  i1 = 0;
  i10 = 25;
 } else if ((i3 | 0) == 19) {
  i1 = 8;
  i10 = 25;
 } else if ((i3 | 0) == 23) {
  i1 = 16;
  i10 = 25;
 } else if ((i3 | 0) == 20) {
  i1 = 24;
  i10 = 25;
 } else if ((i3 | 0) == 6) {
  i1 = 32;
  i10 = 25;
 } else if ((i3 | 0) == 15) {
  i1 = 40;
  i10 = 25;
 } else if ((i3 | 0) == 16) {
  i1 = 48;
  i10 = 25;
 } else switch (i3 | 0) {
 case 17:
  {
   i1 = 56;
   i10 = 25;
   break;
  }
 case 23:
  {
   i1 = 19;
   i10 = 60;
   break;
  }
 default:
  i10 = 63;
 }
 do if ((i10 | 0) == 25) {
  i5 = (i6 | 0) == 18;
  if (i5) {
   i2 = 0;
   i10 = 39;
  } else if ((i6 | 0) == 19) {
   i2 = 1;
   i10 = 39;
  } else if ((i6 | 0) == 23) {
   i2 = 2;
   i10 = 39;
  } else if ((i6 | 0) == 20) {
   i2 = 3;
   i10 = 39;
  } else if ((i6 | 0) == 6) {
   i2 = 4;
   i10 = 39;
  } else if ((i6 | 0) == 15) {
   i2 = 5;
   i10 = 39;
  } else if ((i6 | 0) == 16) {
   i2 = 6;
   i10 = 39;
  } else if ((i6 | 0) == 17) {
   i2 = 7;
   i10 = 39;
  }
  if ((i10 | 0) == 39) if (HEAP32[gb + 56608 + ((i2 | i1) << 2) >> 2] | 0) {
   if (i4) {
    i2 = 0;
    i10 = 42;
   } else if ((i3 | 0) == 19) {
    i2 = 8;
    i10 = 42;
   } else if ((i3 | 0) == 23) {
    i2 = 16;
    i10 = 42;
   } else if ((i3 | 0) == 20) {
    i2 = 24;
    i10 = 42;
   } else if ((i3 | 0) == 6) {
    i2 = 32;
    i10 = 42;
   } else if ((i3 | 0) == 15) {
    i2 = 40;
    i10 = 42;
   } else if ((i3 | 0) == 16) {
    i2 = 48;
    i10 = 42;
   } else if ((i3 | 0) == 17) {
    i2 = 56;
    i10 = 42;
   } else i1 = 0;
   do if ((i10 | 0) == 42) {
    if (i5) i1 = 0; else if ((i6 | 0) == 19) i1 = 1; else if ((i6 | 0) == 23) i1 = 2; else if ((i6 | 0) == 20) i1 = 3; else if ((i6 | 0) == 6) i1 = 4; else if ((i6 | 0) == 15) i1 = 5; else if ((i6 | 0) == 16) i1 = 6; else if ((i6 | 0) == 17) i1 = 7; else {
     i1 = 0;
     break;
    }
    i1 = HEAP32[gb + 56608 + ((i1 | i2) << 2) >> 2] | 0;
   } while (0);
   HEAP8[i9 >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = i1;
   i1 = i9 + 8 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = i9 + 12 | 0;
   break;
  }
  if (i4) {
   i1 = 3;
   i10 = 60;
  } else if ((i3 | 0) == 19) {
   i1 = 11;
   i10 = 60;
  } else if ((i3 | 0) == 23) {
   i1 = 19;
   i10 = 60;
  } else if ((i3 | 0) == 20) {
   i1 = 27;
   i10 = 60;
  } else i10 = 63;
 } while (0);
 if ((i10 | 0) == 63) if ((i3 | 0) == 6) {
  i1 = 35;
  i10 = 60;
 } else if ((i3 | 0) == 15) {
  i1 = 43;
  i10 = 60;
 } else if ((i3 | 0) == 16) {
  i1 = 51;
  i10 = 60;
 } else if ((i3 | 0) == 17) {
  i1 = 59;
  i10 = 60;
 } else {
  i2 = 0;
  i10 = 67;
 }
 if ((i10 | 0) == 60) {
  i2 = HEAP32[gb + 56608 + (i1 << 2) >> 2] | 0;
  i10 = 67;
 }
 if ((i10 | 0) == 67) {
  if ((i6 | 0) == 18) {
   i1 = 24;
   i10 = 69;
  } else if ((i6 | 0) == 19) {
   i1 = 25;
   i10 = 69;
  } else if ((i6 | 0) == 23) {
   i1 = 26;
   i10 = 69;
  } else if ((i6 | 0) == 20) {
   i1 = 27;
   i10 = 69;
  } else if ((i6 | 0) == 6) {
   i1 = 28;
   i10 = 69;
  } else if ((i6 | 0) == 15) {
   i1 = 29;
   i10 = 69;
  } else if ((i6 | 0) == 16) {
   i1 = 30;
   i10 = 69;
  } else if ((i6 | 0) == 17) {
   i1 = 31;
   i10 = 69;
  } else i1 = 0;
  if ((i10 | 0) == 69) i1 = HEAP32[gb + 56608 + (i1 << 2) >> 2] | 0;
  i10 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(20) | 0) + 4 >> 2] | 0;
  HEAP8[i9 >> 0] = 1;
  HEAP32[i9 + 4 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i1;
  i1 = i9 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = i10;
 }
 __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE(i8, i7, i9);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL11updateStateEb(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f17 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i15 = i14 + 44 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i3 = i14 + 4 | 0;
 i7 = HEAP16[i3 >> 1] | 0;
 i4 = i14 + 6 | 0;
 i1 = HEAP16[i4 >> 1] | 0;
 if (i1 & 2) {
  if (i2) {
   __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i14);
   i1 = HEAP16[i4 >> 1] | 0;
  }
  HEAP16[i4 >> 1] = i1 & 65533;
 }
 HEAP16[i3 >> 1] = 0;
 i11 = i14 + 32 | 0;
 i5 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i11 >> 2] | 0) | 0;
 i6 = i5 + 1204 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 do if (i7 & 33) {
  i4 = HEAP32[i15 >> 2] | 0;
  i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i11 >> 2] | 0) | 0;
  i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i14 + 36 >> 2] | 0) | 0;
  if (!i1) i13 = 8; else if (!(HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 44 >> 0] & 1)) if (!(i4 & 1)) i13 = 11; else i13 = 12; else i13 = 8;
  if ((i13 | 0) == 8) if (!i2) i13 = 11; else if ((i4 & 1 | 0) == 0 ? 1 : (HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 44 >> 0] & 1) != 0) i13 = 11; else i13 = 12;
  if ((i13 | 0) == 11) {
   i3 = 0;
   i1 = HEAP32[i15 >> 2] | 262144;
  } else if ((i13 | 0) == 12) {
   i3 = 1;
   i1 = HEAP32[i15 >> 2] & -262145;
  }
  HEAP32[i15 >> 2] = i1;
  do if ((i10 >>> 18 & 1 ^ 1 | 0) != (i3 & 1 | 0)) {
   i1 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i6 >> 2] | 0) | 0;
   i2 = i14 + 60 | 0;
   if (i3) {
    __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i1, i2);
    break;
   } else {
    __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i1, i2);
    break;
   }
  } while (0);
  if (!(i4 & 514)) if (!(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i5, 7)) != Math_fround(0.0))) if (!(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i5, 8)) != Math_fround(0.0))) if (!(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i5, 9)) != Math_fround(0.0))) if (!(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i5, 10)) != Math_fround(0.0))) {
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -131073;
   break;
  }
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 131072;
 } while (0);
 i9 = i7 & 65535;
 do if ((i9 & 5 | 0) == 5) {
  i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i11 >> 2] | 0) | 0;
  i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i14 + 36 >> 2] | 0) | 0;
  if (!i1) i13 = 29; else if (!(HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 44 >> 0] & 1)) i13 = 29; else i1 = HEAP32[i15 >> 2] | 16777216;
  if ((i13 | 0) == 29) i1 = HEAP32[i15 >> 2] & -16777217;
  HEAP32[i15 >> 2] = i1;
  if (i2 | 0) if (HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 44 >> 0] & 1) {
   i1 = i1 | 33554432;
   HEAP32[i15 >> 2] = i1;
   break;
  }
  i1 = i1 & -33554433;
  HEAP32[i15 >> 2] = i1;
 } else i1 = HEAP32[i15 >> 2] | 0; while (0);
 L47 : do if (i1 & 476) {
  if ((HEAP32[i14 + 52 >> 2] | 0) == -1) if (__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[i6 >> 2] | 0, i14 + 8 | 0) | 0) {
   i7 = HEAP32[i15 >> 2] | 0;
   if (!((i7 & 32768 | 0) == 0 | (i7 & 448 | 0) == 0)) __ZN5physx2Sc10NPhaseCore36addToForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(HEAP32[i5 + 1104 >> 2] | 0, i14);
  }
  i1 = HEAP32[i15 >> 2] | 0;
  do if (i1 & 512 | 0) {
   if (((HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0) + 68 >> 2] | 0) + -5 | 0) >>> 0 >= 2) if (((HEAP32[(HEAP32[(HEAP32[i14 + 36 >> 2] | 0) + 28 >> 2] | 0) + 68 >> 2] | 0) + -5 | 0) >>> 0 >= 2) break;
   i1 = i1 | 67108864;
   HEAP32[i15 >> 2] = i1;
   break L47;
  } while (0);
  i1 = i1 & -67108865;
  HEAP32[i15 >> 2] = i1;
 } while (0);
 do if (!((i1 ^ i10) & 393694)) {
  i4 = i14 + 56 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i13 = 59; else {
   i5 = HEAP32[i11 >> 2] | 0;
   i6 = i14 + 36 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if (i9 & 8) {
    i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(i5) | 0;
    i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(i7) | 0;
    if (!i1) i3 = 0; else i3 = HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 12 >> 0] | 0;
    if (!i2) i1 = 0; else i1 = HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 12 >> 0] | 0;
    __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh(i12, __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i11 >> 2] | 0) | 0, i3, i1);
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 100 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i1 + 104 >> 2] = HEAP32[i12 + 4 >> 2];
   }
   if (i9 & 16 | 0) {
    f17 = Math_fround(HEAPF32[(HEAP32[i5 + 28 >> 2] | 0) + 128 >> 2]);
    HEAPF32[i1 + 108 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[(HEAP32[i7 + 28 >> 2] | 0) + 128 >> 2]));
   }
   if (!(HEAP8[(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) if (!(HEAP8[(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) {
    HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 134217728;
    break;
   }
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -134217729;
   if (!i1) __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv(i14);
  }
 } else i13 = 59; while (0);
 do if ((i13 | 0) == 59) if (__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(i8, i14 + 8 | 0) | 0) {
  __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv(i14);
  if (!(HEAP8[(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) if (!(HEAP8[(HEAP32[(HEAP32[i14 + 36 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) {
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 134217728;
   break;
  }
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -134217729;
  __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv(i14);
 } while (0);
 i1 = HEAP32[i14 + 56 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 __ZN5physx17PxsContactManager6setCCDEb(i1, (HEAP32[i15 >> 2] & 2048 | 0) != 0);
 STACKTOP = i16;
 return;
}

function __ZN5Unity14CharacterJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 96 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 108 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 112 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 116 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 120 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 124 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 128 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 140 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 144 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 148 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 152 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 156 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 160 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 164 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 168 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 172 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 176 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __ZN11Rigidbody2D13AwakeFromLoadE17AwakeFromLoadMode(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 4 | 0;
 i11 = i12;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (!(HEAP32[i9 + 92 >> 2] | 0)) __ZN11Rigidbody2D6CreateEv(i9);
 do if (!(i10 & 7)) {
  i7 = i9 + 92 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) __ZN6b2Body9SetActiveEb(i1, (HEAP8[i9 + 48 >> 0] | 0) != 0);
  __ZN11Rigidbody2D11SetBodyTypeENS_8BodyTypeEb(i9, HEAP32[i9 + 68 >> 2] | 0, 1);
  if (!(HEAP8[i9 + 49 >> 0] | 0)) {
   i1 = i9 + 32 | 0;
   f4 = Math_fround(HEAPF32[i1 >> 2]);
   i6 = f4 < Math_fround(.0000999999974);
   i5 = f4 > Math_fround(1.0e6);
   f4 = i5 ? Math_fround(1.0e6) : f4;
   HEAPF32[i1 >> 2] = i6 ? Math_fround(.0000999999974) : f4;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) __ZN6b2Body13ResetMassDataEv(i1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) __ZN6b2Body13ResetMassDataEv(i1);
  }
  i3 = i9 + 36 | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = f4 < Math_fround(0.0);
  i6 = f4 > Math_fround(1.0e6);
  f4 = i6 ? Math_fround(1.0e6) : f4;
  f4 = i1 ? Math_fround(0.0) : f4;
  HEAPF32[i3 >> 2] = f4;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = (i3 | 0) == 0;
  if (!i1) if (!(HEAP8[i9 + 226 >> 0] | 0)) HEAPF32[i3 + 132 >> 2] = f4;
  i6 = i9 + 40 | 0;
  f4 = Math_fround(HEAPF32[i6 >> 2]);
  i5 = f4 < Math_fround(0.0);
  i2 = f4 > Math_fround(1.0e6);
  f4 = i2 ? Math_fround(1.0e6) : f4;
  f4 = i5 ? Math_fround(0.0) : f4;
  HEAPF32[i6 >> 2] = f4;
  if (!i1) if (!(HEAP8[i9 + 227 >> 0] | 0)) HEAPF32[i3 + 136 >> 2] = f4;
  i6 = i9 + 44 | 0;
  f4 = Math_fround(HEAPF32[i6 >> 2]);
  i5 = f4 < Math_fround(-1.0e6);
  i2 = f4 > Math_fround(1.0e6);
  f4 = i2 ? Math_fround(1.0e6) : f4;
  f4 = i5 ? Math_fround(-1.0e6) : f4;
  HEAPF32[i6 >> 2] = f4;
  do if (i1) i2 = 0; else {
   i1 = i3 + 140 | 0;
   f13 = Math_fround(f4 - Math_fround(HEAPF32[i1 >> 2]));
   i6 = f13 < Math_fround(0.0);
   f14 = Math_fround(-f13);
   if (!((i6 ? f14 : f13) <= Math_fround(9.99999997e-07))) {
    HEAPF32[i1 >> 2] = f4;
    if (f4 != f4 | Math_fround(0.0) != Math_fround(0.0) | f4 == Math_fround(0.0)) i2 = i3; else {
     i1 = i3 + 4 | 0;
     i2 = HEAPU16[i1 >> 1] | 0;
     if (!(HEAP32[i3 >> 2] | 0)) {
      HEAP16[i1 >> 1] = i2 & 65533;
      HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
      i2 = i3 + 64 | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAP32[i2 + 16 >> 2] = 0;
      HEAP32[i2 + 20 >> 2] = 0;
      i2 = HEAP32[i7 >> 2] | 0;
      break;
     }
     if (!(i2 & 2)) {
      HEAP16[i1 >> 1] = i2 | 2;
      HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
      i2 = i3;
     } else i2 = i3;
    }
   } else i2 = i3;
  } while (0);
  HEAP8[i9 + 225 >> 0] = 0;
  i6 = i9 + 128 | 0;
  i5 = i9 + 184 | 0;
  i3 = i9 + 156 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i6 = i9 + 140 | 0;
  i3 = i9 + 196 | 0;
  i5 = i9 + 168 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  do if (!i2) i1 = i9 + 60 | 0; else {
   i3 = i2 + 4 | 0;
   i6 = HEAPU16[i3 >> 1] | 0;
   i6 = (HEAP32[i9 + 64 >> 2] | 0) == 1 ? i6 | 8 : i6 & 65527;
   HEAP16[i3 >> 1] = i6;
   i1 = i9 + 60 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    HEAP16[i3 >> 1] = i6 | 4;
    break;
   }
   i5 = i6 & 65531;
   HEAP16[i3 >> 1] = i5;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP16[i3 >> 1] = i6 & 65529;
    HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
    i6 = i2 + 64 | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    HEAP32[i6 + 20 >> 2] = 0;
    break;
   }
   if (!(i6 & 2)) {
    HEAP16[i3 >> 1] = i5 | 2;
    HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
   }
  } while (0);
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) break;
   i2 = i1 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    HEAP16[i2 >> 1] = i3 & 65533;
    HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    i7 = i1 + 64 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    HEAP32[i7 + 20 >> 2] = 0;
    break;
   }
   if (i3 & 2 | 0) break;
   HEAP16[i2 >> 1] = i3 | 2;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   break;
  }
  if (i10 & 8 | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   if (i3 | 0) {
    if ((i1 | 0) != 2) if (HEAP32[i3 >> 2] | 0) {
     i1 = i3 + 4 | 0;
     i2 = HEAPU16[i1 >> 1] | 0;
     if (i2 & 2 | 0) break;
     HEAP16[i1 >> 1] = i2 | 2;
     HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
     break;
    }
    i7 = i3 + 4 | 0;
    HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] & 65533;
    HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
    i7 = i3 + 64 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    HEAP32[i7 + 20 >> 2] = 0;
   }
  }
 } while (0);
 if (i10 & 4 | 0) __ZN11Rigidbody2D24InformCollidersOfNewBodyEv(i9);
 if ((i10 | 0) != 0 & (i10 & 20 | 0) == 0) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 >> 2] = HEAP32[i9 + 72 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 __ZN11Rigidbody2D11SetMaterialE4PPtrI17PhysicsMaterial2DE(i9, i8);
 __ZN11Rigidbody2D19RecalculateContactsEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN4crnd12crn_unpacker11unpack_dxt1EPPhjjjjjj(i4, i42, i1, i43, i3, i2, i44, i45) {
 i4 = i4 | 0;
 i42 = i42 | 0;
 i1 = i1 | 0;
 i43 = i43 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i44 = i44 | 0;
 i45 = i45 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i46 = 0, i47 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i41;
 i32 = HEAP32[i4 + 240 >> 2] | 0;
 i33 = HEAP32[i4 + 256 >> 2] | 0;
 i39 = HEAP8[(HEAP32[i4 + 88 >> 2] | 0) + 17 >> 0] | 0;
 i34 = i39 & 255;
 i35 = i43 >>> 2;
 if (!(i39 << 24 >> 24)) {
  STACKTOP = i41;
  return 1;
 }
 i36 = (i45 | 0) == 0;
 i37 = i44 + -1 | 0;
 i38 = i37 << 4;
 i39 = i45 + -1 | 0;
 i26 = (i2 & 1 | 0) != 0;
 i27 = i43 << 1;
 i28 = i4 + 92 | 0;
 i29 = i4 + 116 | 0;
 i30 = i4 + 140 | 0;
 i31 = i4 + 236 | 0;
 i25 = (i3 & 1 | 0) != 0;
 i24 = i4 + 188 | 0;
 i20 = i4 + 252 | 0;
 i21 = i35 + 1 | 0;
 i22 = i35 + 2 | 0;
 i23 = i35 + 3 | 0;
 i19 = 0;
 i2 = 0;
 i1 = 0;
 i3 = 1;
 do {
  if (!i36) {
   i17 = HEAP32[i42 + (i19 << 2) >> 2] | 0;
   i18 = 0;
   while (1) {
    i15 = i18 & 1;
    i6 = (i15 | 0) == 0;
    i14 = (i15 << 5 ^ 32) + -16 | 0;
    i15 = (i15 << 1 ^ 2) + -1 | 0;
    i13 = i6 ? i44 : -1;
    i5 = i6 ? 0 : i37;
    i4 = (i18 | 0) == (i39 | 0);
    i16 = i26 & i4;
    if ((i5 | 0) != (i13 | 0)) {
     i12 = i26 & i4 ^ 1;
     i11 = i6 ? i17 : i17 + i38 | 0;
     while (1) {
      if ((i3 | 0) == 1) i3 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i29) | 0 | 512;
      i10 = i3 & 7;
      i3 = i3 >>> 3;
      i6 = HEAPU8[gb + 401462 + i10 >> 0] | 0;
      i4 = 0;
      do {
       i7 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i30) | 0) + i1 | 0;
       i8 = i7 - i32 | 0;
       i9 = i8 >> 31;
       i1 = i9 & i7 | i8 & ~i9;
       HEAP32[i40 + (i4 << 2) >> 2] = HEAP32[(HEAP32[i31 >> 2] | 0) + (i1 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while (i4 >>> 0 < i6 >>> 0);
      i9 = i25 & (i5 | 0) == (i37 | 0);
      if (i16 | i9) {
       i8 = 0;
       do {
        i4 = i11 + (Math_imul(i8, i43) | 0) | 0;
        i7 = (i8 | 0) == 0 | i12;
        i6 = i8 << 1;
        i47 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
        i46 = i47 - i33 | 0;
        i2 = i46 >> 31;
        i2 = i2 & i47 | i46 & ~i2;
        do if (i9) if (i7) {
         HEAP32[i4 >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) + i6 >> 0] | 0) << 2) >> 2];
         HEAP32[i4 + 4 >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2];
         i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
         i47 = i46 - i33 | 0;
         i2 = i47 >> 31;
         i2 = i2 & i46 | i47 & ~i2;
         break;
        } else {
         i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
         i47 = i46 - i33 | 0;
         i2 = i47 >> 31;
         i2 = i2 & i46 | i47 & ~i2;
         break;
        } else if (i7) {
         HEAP32[i4 >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) + i6 >> 0] | 0) << 2) >> 2];
         HEAP32[i4 + 4 >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2];
         i47 = i4 + 8 | 0;
         i7 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
         i46 = i7 - i33 | 0;
         i2 = i46 >> 31;
         i2 = i2 & i7 | i46 & ~i2;
         HEAP32[i47 >> 2] = HEAP32[i40 + ((HEAPU8[(i6 | 1) + (gb + 401470 + (i10 << 2)) >> 0] | 0) << 2) >> 2];
         HEAP32[i47 + 4 >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2];
         break;
        } else {
         i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
         i47 = i46 - i33 | 0;
         i2 = i47 >> 31;
         i2 = i2 & i46 | i47 & ~i2;
         break;
        } while (0);
        i8 = i8 + 1 | 0;
       } while ((i8 | 0) != 2);
      } else {
       HEAP32[i11 >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) >> 0] | 0) << 2) >> 2];
       i2 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
       i47 = i2 - i33 | 0;
       i46 = i47 >> 31;
       i46 = i46 & i2 | i47 & ~i46;
       HEAP32[i11 + 4 >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i46 << 2) >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) + 1 >> 0] | 0) << 2) >> 2];
       i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i46 | 0;
       i47 = i46 - i33 | 0;
       i2 = i47 >> 31;
       i2 = i2 & i46 | i47 & ~i2;
       HEAP32[i11 + 12 >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2];
       HEAP32[i11 + (i35 << 2) >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) + 2 >> 0] | 0) << 2) >> 2];
       i2 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i2 | 0;
       i47 = i2 - i33 | 0;
       i46 = i47 >> 31;
       i46 = i46 & i2 | i47 & ~i46;
       HEAP32[i11 + (i21 << 2) >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i46 << 2) >> 2];
       HEAP32[i11 + (i22 << 2) >> 2] = HEAP32[i40 + ((HEAPU8[gb + 401470 + (i10 << 2) + 3 >> 0] | 0) << 2) >> 2];
       i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i28, i24) | 0) + i46 | 0;
       i47 = i46 - i33 | 0;
       i2 = i47 >> 31;
       i2 = i2 & i46 | i47 & ~i2;
       HEAP32[i11 + (i23 << 2) >> 2] = HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2];
      }
      i5 = i15 + i5 | 0;
      if ((i5 | 0) == (i13 | 0)) break; else i11 = i11 + i14 | 0;
     }
    }
    i18 = i18 + 1 | 0;
    if ((i18 | 0) == (i45 | 0)) break; else i17 = i17 + i27 | 0;
   }
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != (i34 | 0));
 STACKTOP = i41;
 return 1;
}

function __ZN4crnd12crn_unpacker10unpack_dxnEPPhjjjjjj(i4, i40, i1, i41, i2, i3, i42, i43) {
 i4 = i4 | 0;
 i40 = i40 | 0;
 i1 = i1 | 0;
 i41 = i41 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i42 = i42 | 0;
 i43 = i43 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i44 = 0, i45 = 0, i46 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i39 + 16 | 0;
 i38 = i39;
 i24 = HEAP32[i4 + 272 >> 2] | 0;
 i36 = HEAP32[i4 + 88 >> 2] | 0;
 i25 = (HEAPU8[i36 + 63 >> 0] | 0) << 8 | (HEAPU8[i36 + 64 >> 0] | 0);
 i36 = HEAP8[i36 + 17 >> 0] | 0;
 i26 = i36 & 255;
 if (!(i36 << 24 >> 24)) {
  STACKTOP = i39;
  return 1;
 }
 i27 = (i43 | 0) == 0;
 i28 = i42 + -1 | 0;
 i29 = i28 << 5;
 i30 = i43 + -1 | 0;
 i31 = i41 << 1;
 i32 = i4 + 92 | 0;
 i33 = i4 + 116 | 0;
 i34 = i4 + 164 | 0;
 i35 = i4 + 268 | 0;
 i36 = i4 + 212 | 0;
 i23 = (i2 & 1 | 0) == 0;
 i22 = (i3 & 1 | 0) == 0;
 i21 = i4 + 284 | 0;
 i20 = 0;
 i4 = 0;
 i3 = 0;
 i2 = 0;
 i1 = 0;
 i5 = 1;
 do {
  if (!i27) {
   i18 = HEAP32[i40 + (i20 << 2) >> 2] | 0;
   i19 = 0;
   while (1) {
    i17 = i19 & 1;
    i7 = (i17 | 0) == 0;
    i16 = (i17 << 6 ^ 64) + -32 | 0;
    i17 = (i17 << 1 ^ 2) + -1 | 0;
    i14 = i7 ? i42 : -1;
    i6 = i7 ? 0 : i28;
    if ((i6 | 0) != (i14 | 0)) {
     i15 = i22 | (i19 | 0) != (i30 | 0);
     i13 = i7 ? i18 : i18 + i29 | 0;
     while (1) {
      if ((i5 | 0) == 1) i5 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i33) | 0 | 512;
      i12 = i5 & 7;
      i5 = i5 >>> 3;
      i8 = HEAPU8[gb + 401462 + i12 >> 0] | 0;
      i7 = 0;
      do {
       i9 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i34) | 0) + i1 | 0;
       i10 = i9 - i24 | 0;
       i11 = i10 >> 31;
       i1 = i11 & i9 | i10 & ~i11;
       HEAP32[i37 + (i7 << 2) >> 2] = HEAPU16[(HEAP32[i35 >> 2] | 0) + (i1 << 1) >> 1];
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i8 >>> 0);
      i7 = 0;
      do {
       i9 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i34) | 0) + i3 | 0;
       i10 = i9 - i24 | 0;
       i11 = i10 >> 31;
       i3 = i11 & i9 | i10 & ~i11;
       HEAP32[i38 + (i7 << 2) >> 2] = HEAPU16[(HEAP32[i35 >> 2] | 0) + (i3 << 1) >> 1];
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i8 >>> 0);
      i11 = i23 | (i6 | 0) != (i28 | 0);
      i9 = 0;
      i10 = i13;
      while (1) {
       i8 = i15 | (i9 | 0) == 0;
       i7 = i9 << 1;
       i44 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i2 | 0;
       i45 = i44 - i25 | 0;
       i2 = i45 >> 31;
       i2 = i2 & i44 | i45 & ~i2;
       i45 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i4 | 0;
       i44 = i45 - i25 | 0;
       i4 = i44 >> 31;
       i4 = i4 & i45 | i44 & ~i4;
       if (i11) {
        if (i8) {
         i44 = HEAPU8[gb + 401470 + (i12 << 2) + i7 >> 0] | 0;
         i45 = HEAP32[i21 >> 2] | 0;
         i46 = i45 + (i2 * 3 << 1) | 0;
         i45 = i45 + (i4 * 3 << 1) | 0;
         HEAP32[i10 >> 2] = (HEAPU16[i46 >> 1] | 0) << 16 | HEAP32[i37 + (i44 << 2) >> 2];
         HEAP32[i10 + 4 >> 2] = (HEAPU16[i46 + 4 >> 1] | 0) << 16 | (HEAPU16[i46 + 2 >> 1] | 0);
         HEAP32[i10 + 8 >> 2] = (HEAPU16[i45 >> 1] | 0) << 16 | HEAP32[i38 + (i44 << 2) >> 2];
         HEAP32[i10 + 12 >> 2] = (HEAPU16[i45 + 4 >> 1] | 0) << 16 | (HEAPU16[i45 + 2 >> 1] | 0);
        }
        i46 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i2 | 0;
        i45 = i46 - i25 | 0;
        i2 = i45 >> 31;
        i2 = i2 & i46 | i45 & ~i2;
        i45 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i4 | 0;
        i46 = i45 - i25 | 0;
        i4 = i46 >> 31;
        i4 = i4 & i45 | i46 & ~i4;
        if (i8) {
         i45 = HEAPU8[(i7 | 1) + (gb + 401470 + (i12 << 2)) >> 0] | 0;
         i46 = HEAP32[i21 >> 2] | 0;
         i44 = i46 + (i2 * 3 << 1) | 0;
         i46 = i46 + (i4 * 3 << 1) | 0;
         HEAP32[i10 + 16 >> 2] = (HEAPU16[i44 >> 1] | 0) << 16 | HEAP32[i37 + (i45 << 2) >> 2];
         HEAP32[i10 + 20 >> 2] = (HEAPU16[i44 + 4 >> 1] | 0) << 16 | (HEAPU16[i44 + 2 >> 1] | 0);
         HEAP32[i10 + 24 >> 2] = (HEAPU16[i46 >> 1] | 0) << 16 | HEAP32[i38 + (i45 << 2) >> 2];
         HEAP32[i10 + 28 >> 2] = (HEAPU16[i46 + 4 >> 1] | 0) << 16 | (HEAPU16[i46 + 2 >> 1] | 0);
        }
       } else {
        if (i8) {
         i45 = HEAPU8[gb + 401470 + (i12 << 2) + i7 >> 0] | 0;
         i46 = HEAP32[i21 >> 2] | 0;
         i44 = i46 + (i2 * 3 << 1) | 0;
         i46 = i46 + (i4 * 3 << 1) | 0;
         HEAP32[i10 >> 2] = (HEAPU16[i44 >> 1] | 0) << 16 | HEAP32[i37 + (i45 << 2) >> 2];
         HEAP32[i10 + 4 >> 2] = (HEAPU16[i44 + 4 >> 1] | 0) << 16 | (HEAPU16[i44 + 2 >> 1] | 0);
         HEAP32[i10 + 8 >> 2] = (HEAPU16[i46 >> 1] | 0) << 16 | HEAP32[i38 + (i45 << 2) >> 2];
         HEAP32[i10 + 12 >> 2] = (HEAPU16[i46 + 4 >> 1] | 0) << 16 | (HEAPU16[i46 + 2 >> 1] | 0);
        }
        i45 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i2 | 0;
        i46 = i45 - i25 | 0;
        i2 = i46 >> 31;
        i8 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i32, i36) | 0) + i4 | 0;
        i44 = i8 - i25 | 0;
        i4 = i44 >> 31;
        i4 = i4 & i8 | i44 & ~i4;
        i2 = i2 & i45 | i46 & ~i2;
       }
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == 2) break; else i10 = i10 + i41 | 0;
      }
      i6 = i17 + i6 | 0;
      if ((i6 | 0) == (i14 | 0)) break; else i13 = i13 + i16 | 0;
     }
    }
    i19 = i19 + 1 | 0;
    if ((i19 | 0) == (i43 | 0)) break; else i18 = i18 + i31 | 0;
   }
  }
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) != (i26 | 0));
 STACKTOP = i39;
 return 1;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i8 = i15;
 i3 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i1 >> 5;
 i5 = i1;
 if (i2 >>> 0 < i6 >>> 0) {
  i5 = i12 + 8 | 0;
  if (((HEAP32[i5 >> 2] | 0) - i1 >> 5 | 0) == (i6 | 0)) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE8__appendEj(i12, i6 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i8, i6);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i11, i14);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i2 - i4 >> 5;
  i1 = i2;
  if (i3 >>> 0 < i6 >>> 0) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE8__appendEj(i8, i6 - i3 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i3 >>> 0 > i6 >>> 0) {
   i4 = i4 + (i6 << 5) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i2 = i1 + -32 | 0;
     HEAP32[i7 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i11 = HEAP32[i1 + -20 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
      i2 = HEAP32[i7 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i13 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -32 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -20 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i5 + (i6 << 5) | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i6 << 5;
 i2 = i1 >> 5;
 if (!i2) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = __Znwj(i1) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i3;
  i2 = i3 + (i2 << 5) | 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i3;
  if (!i6) {
   i4 = i8;
   i5 = i1;
   i3 = i1;
  } else {
   i6 = i14 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i1 = i4 << 24 >> 24 < 0;
    i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 + 12 >> 2] = i1;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     i9 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i3 + 11 >> 0] = i4;
     if (!i4) i1 = i3; else {
      i1 = i3;
      i9 = 34;
     }
    } else i9 = 32;
    if ((i9 | 0) == 32) {
     i16 = i4 + 16 & -16;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i6 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i3 + 8 >> 2] = i16 | -2147483648;
     HEAP32[i3 + 4 >> 2] = i4;
     i9 = 34;
    }
    if ((i9 | 0) == 34) {
     i9 = 0;
     _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i16 = i3 + 16 | 0;
    i4 = i5 + 16 | 0;
    HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i5 = i5 + 32 | 0;
    i3 = (HEAP32[i10 >> 2] | 0) + 32 | 0;
    HEAP32[i10 >> 2] = i3;
   } while ((i5 | 0) != (i7 | 0));
   i4 = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i13 >> 2] = i3;
 i13 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i4 = i1;
 i2 = i16;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -32 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i16 = HEAP32[i2 + -20 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __Z16CalculateWeightsILb1EEvPP14AnimationStateiiPfi(i8, i22, i1, i23, i9) {
 i8 = i8 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i9 = i9 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, f25 = f0, f26 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 32 | 0;
 i19 = i21 + 20 | 0;
 i13 = i21 + 8 | 0;
 i16 = i21 + 4 | 0;
 i17 = i21;
 HEAP32[i18 >> 2] = 0;
 i20 = i18 + 4 | 0;
 i5 = gb + 63160 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i20;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i5;
 i12 = i22 << 2;
 i10 = (i12 | 0) != 0;
 do if (i10) {
  i1 = i12 | 3;
  if (i1 >>> 0 < 2e3) {
   i3 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = i5;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 865) | 0;
   i4 = gb + 64016 | 0;
   i15 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i3;
   i1 = i20;
   HEAP32[i1 >> 2] = i15;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = gb + 63160 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } else {
  i3 = 0;
  i1 = i5;
 } while (0);
 i14 = i3 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i15 = i19 + 4 | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = i1;
 do if (i10) {
  i3 = i12 | 3;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 868) | 0;
   i7 = gb + 64016 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i11 = i15;
   HEAP32[i11 >> 2] = i6;
   HEAP32[i11 + 4 >> 2] = i7;
   break;
  }
 } else i1 = 0; while (0);
 i1 = i1 + 3 & -4;
 i7 = i1;
 i11 = (i22 | 0) > 0;
 if (i11) {
  i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0;
  _memset(i1 | 0, 0, i12 | 0) | 0;
  i1 = i3;
  i3 = 0;
  i5 = 0;
  i6 = 1;
  while (1) {
   if (!(i6 & i9)) {
    HEAPF32[i23 + (i5 << 2) >> 2] = Math_fround(0.0);
    i4 = 0;
    i1 = i8 + (i5 << 2) | 0;
   } else {
    i24 = i8 + (i5 << 2) | 0;
    i4 = HEAP32[i24 >> 2] | 0;
    i3 = ((i1 | 0) != (HEAP32[i4 + 32 >> 2] | 0) & 1) + i3 | 0;
    i4 = i4 + 8 | 0;
    f2 = Math_fround(HEAPF32[i4 >> 2]);
    i1 = i7 + (i3 << 2) | 0;
    HEAPF32[i1 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i1 >> 2]));
    HEAP32[i23 + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
    i4 = i3;
    i1 = i24;
   }
   HEAP32[i14 + (i5 << 2) >> 2] = i4;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i22 | 0)) {
    i5 = i3;
    break;
   } else {
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
    i6 = i6 << 1;
   }
  }
 } else i5 = 0;
 HEAP32[i13 >> 2] = 0;
 i6 = i13 + 4 | 0;
 i8 = gb + 63160 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i24 = i6;
 HEAP32[i24 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i24 + 4 >> 2] = i9;
 do if (i10) {
  i3 = i12 | 3;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 931) | 0;
   i24 = gb + 64016 | 0;
   i12 = HEAP32[i24 >> 2] | 0;
   i24 = HEAP32[i24 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i4;
   i1 = i6;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 4 >> 2] = i24;
   i1 = i4;
   break;
  }
 } else {
  i1 = 0;
  i4 = 0;
 } while (0);
 i3 = i1 + 3 & -4;
 HEAP32[i16 >> 2] = 1065353216;
 if ((i5 | 0) >= 0) {
  i1 = 0;
  f2 = Math_fround(1.0);
  while (1) {
   i24 = i7 + (i1 << 2) | 0;
   f26 = Math_fround(HEAPF32[i24 >> 2]);
   i13 = f26 > Math_fround(1.0);
   f26 = i13 ? f26 : Math_fround(1.0);
   i13 = f26 > Math_fround(.0000999999974);
   f26 = Math_fround(Math_fround(1.0) / f26);
   HEAPF32[i3 + (i1 << 2) >> 2] = Math_fround(f2 * (i13 ? f26 : Math_fround(0.0)));
   f26 = Math_fround(HEAPF32[i24 >> 2]);
   f25 = Math_fround(HEAPF32[i16 >> 2]);
   f25 = Math_fround(f25 - Math_fround(f26 * f25));
   HEAPF32[i16 >> 2] = f25;
   HEAPF32[i17 >> 2] = Math_fround(0.0);
   i24 = f25 > Math_fround(0.0);
   i24 = HEAP32[(i24 ? i16 : i17) >> 2] | 0;
   HEAP32[i16 >> 2] = i24;
   f2 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i1 | 0) == (i5 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 if (i11) {
  i1 = 0;
  f2 = Math_fround(0.0);
 } else {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  i24 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i15);
  i24 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i20);
  STACKTOP = i21;
  return;
 }
 do {
  f26 = Math_fround(HEAPF32[i3 + (HEAP32[i14 + (i1 << 2) >> 2] << 2) >> 2]);
  i24 = i23 + (i1 << 2) | 0;
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i24 >> 2] = f26;
  f2 = Math_fround(f2 + f26);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i22 | 0));
 i24 = f2 > Math_fround(.0000999999974);
 f2 = Math_fround(Math_fround(1.0) / f2);
 f2 = i24 ? f2 : Math_fround(0.0);
 if (i11) i1 = 0; else {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  i24 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i15);
  i24 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i20);
  STACKTOP = i21;
  return;
 }
 do {
  i24 = i23 + (i1 << 2) | 0;
  HEAPF32[i24 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i24 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i22 | 0));
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 i24 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i15);
 i24 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i20);
 STACKTOP = i21;
 return;
}

function __ZN5physx2Sc12MaterialCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i13 >> 2] = HEAP32[gb + 131108 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 131108 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 131108 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 131108 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 131108 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 131108 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 131108 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 131108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 131140 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 131140 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 131140 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 131140 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 131140 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 131140 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 131140 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 131140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 131172 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 131172 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 131172 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 131172 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 131172 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 131172 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 131172 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 131172 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 131204 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 131204 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 131204 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 131204 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 131204 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 131204 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 131204 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 131204 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 131236 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 131236 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 131236 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 131236 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 131236 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 131236 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 131236 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 131236 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 131268 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 131268 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 131268 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 131268 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 131268 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 131268 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 131268 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 131268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 131300 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 131300 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 131300 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 131300 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 131300 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 131300 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 131300 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 131300 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 131332 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 131332 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 131332 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 131332 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 131332 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 131332 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 131332 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 131332 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 131364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 131364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 131364 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 131364 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 131364 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 131364 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 131364 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 131364 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 131396 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 131396 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 131396 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 131396 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 131396 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 131396 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 131396 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 131396 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 131428 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 131428 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 131428 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 131428 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 131428 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 131428 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 131428 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 131428 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN21ImposterRenderTexture14UpdateImposterERK5RectTIfERKN12TreeDatabase9PrototypeE(i4, i5, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i15 = i18 + 24 | 0;
 i6 = i18 + 12 | 0;
 i7 = i18;
 i16 = i8 + 128 | 0;
 if (!(HEAP32[i16 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i13 = i8 + 16 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i17 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
   i2 = HEAP32[i14 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i17 = 10;
 }
 if ((i17 | 0) == 8) i17 = 10;
 if ((i17 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0)) {
  STACKTOP = i18;
  return;
 }
 i12 = i4 + 16 | 0;
 i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f22 = Math_fround(HEAPF32[i8 + 140 >> 2]);
 i10 = i8 + 136 | 0;
 f22 = Math_fround(f22 - Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(.5)));
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 4 >> 2] = f22;
 HEAPF32[i14 + 8 >> 2] = Math_fround(0.0);
 __ZN9Transform11SetPositionERK8Vector3f(i9, i14);
 __ZNK9Transform11GetPositionEv(i15, i9);
 f22 = Math_fround(HEAPF32[gb + 62548 >> 2]);
 f20 = Math_fround(HEAPF32[gb + 62548 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[gb + 62548 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i8 + 144 | 0;
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i11 >> 2]));
 f20 = Math_fround(Math_fround(f20 * f19) * Math_fround(-2.0));
 f21 = Math_fround(Math_fround(f21 * f19) * Math_fround(-2.0));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f22 * f19) * Math_fround(-2.0));
 HEAPF32[i7 + 4 >> 2] = f20;
 HEAPF32[i7 + 8 >> 2] = f21;
 __ZNK9Transform18TransformDirectionERK8Vector3f(i6, i9, i7);
 f21 = Math_fround(HEAPF32[i15 >> 2]);
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i6 >> 2]));
 f20 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i6 + 4 >> 2]));
 f19 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i6 + 8 >> 2]));
 HEAPF32[i14 >> 2] = f21;
 HEAPF32[i14 + 4 >> 2] = f20;
 HEAPF32[i14 + 8 >> 2] = f19;
 __ZN9Transform11SetPositionERK8Vector3f(i9, i14);
 __ZN6Camera13SetClearFlagsEi(HEAP32[i12 >> 2] | 0, 4);
 __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(HEAP32[i12 >> 2] | 0, i5);
 f19 = Math_fround(HEAPF32[i8 + 148 >> 2]);
 i9 = f19 < Math_fround(1.0);
 __ZN6Camera9SetAspectEf(HEAP32[i12 >> 2] | 0, i9 ? f19 : Math_fround(1.0));
 f19 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(HEAPF32[i11 >> 2]);
 __ZN6Camera19SetOrthographicSizeEf(HEAP32[i12 >> 2] | 0, Math_fround((f19 < f20 ? f20 : f19) * Math_fround(.5)));
 __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(HEAP32[i12 >> 2] | 0, HEAP32[gb + 1166248 >> 2] | 0, 4);
 HEAP32[i6 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, gb + 1017536 | 0);
 i12 = HEAP32[gb + 1166248 >> 2] | 0;
 if (HEAP32[i16 >> 2] | 0) {
  i6 = i8 + 116 | 0;
  i7 = i14 + 4 | 0;
  i8 = i14 + 8 | 0;
  i9 = i14 + 12 | 0;
  i5 = 0;
  do {
   i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   if ((__ZNK8Material12GetPassCountEv(i10) | 0) > 0) {
    i4 = 0;
    do {
     if (__Z21CheckShouldRenderPassiR8Material(i4, i10) | 0) {
      i11 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i10, i4, i12, 0, 1) | 0;
      if (i11 | 0) {
       HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
       i1 = HEAP32[gb + 1104264 >> 2] | 0;
       if (!i1) i17 = 23; else {
        if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
         i2 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[i1 + 32 >> 2] | 0;
         i1 = i2 + (i3 << 3) | 0;
        } else {
         __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
         i2 = HEAP32[i14 >> 2] | 0;
         i23 = HEAP32[i1 + 28 >> 2] | 0;
         i3 = HEAP32[gb + 1104264 >> 2] | 0;
         i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
         i2 = HEAP32[i3 + 28 >> 2] | 0;
         i3 = HEAP32[i3 + 32 >> 2] | 0;
        }
        if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 23; else {
         i1 = HEAP32[i1 + 4 >> 2] | 0;
         if (!i1) i17 = 25;
        }
       }
       if ((i17 | 0) == 23) i17 = 25;
       if ((i17 | 0) == 25) {
        i17 = 0;
        i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i13 >> 2] | 0) | 0;
       }
       HEAPF32[i14 >> 2] = Math_fround(0.0);
       HEAPF32[i7 >> 2] = Math_fround(0.0);
       HEAPF32[i8 >> 2] = Math_fround(0.0);
       HEAPF32[i9 >> 2] = Math_fround(1.0);
       __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK8Vector3fRK11Quaternionfi(i11, i1, gb + 1162364 | 0, i14, i5);
      }
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (__ZNK8Material12GetPassCountEv(i10) | 0));
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
 }
 STACKTOP = i18;
 return;
}

function __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i16, i13, i2, i11, i1, i17) {
 i16 = i16 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = i16 + 76 | 0;
 i19 = i16 + 64 | 0;
 i14 = i13 + 4 | 0;
 while (1) {
  i10 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = HEAP32[i18 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) i12 = 5; else {
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i12 = 5; else HEAP32[i7 >> 2] = i4;
  }
  if ((i12 | 0) == 5) {
   i12 = 0;
   i3 = i7 + 8 | 0;
   i4 = i7 + 12 | 0;
   i6 = (Math_imul(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) + 4 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0, i6 | 0) | 0;
   if (!i6) {
    i12 = 9;
    break;
   }
   i5 = i7 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i6;
   i5 = HEAP32[i3 >> 2] | 0;
   i4 = (Math_imul(HEAP32[i4 >> 2] | 0, i5) | 0) + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   do {
    i4 = i4 - i5 | 0;
    i9 = i3;
    i3 = i6 + i4 | 0;
    HEAP32[i3 >> 2] = i9;
   } while ((i4 | 0) != 4);
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   if (!i3) {
    i12 = 9;
    break;
   }
  }
  HEAP32[i3 >> 2] = i10;
  i4 = HEAP32[i19 >> 2] | 0;
  i5 = i4 + 20 | 0;
  i6 = i4 + 12 | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  do {
   i9 = HEAP32[i9 + 8 >> 2] | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   if (!i7) break;
  } while (!(mftCall_iiii(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7 | 0, i3 | 0) | 0));
  i8 = HEAP32[i4 + 16 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (!i4) i12 = 16; else {
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) i12 = 16; else HEAP32[i8 >> 2] = i5;
  }
  if ((i12 | 0) == 16) {
   i12 = 0;
   i4 = i8 + 8 | 0;
   i5 = i8 + 12 | 0;
   i7 = (Math_imul(HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) + 4 | 0;
   i6 = HEAP32[i8 + 20 >> 2] | 0;
   i7 = mftCall_iii(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i7 | 0) | 0;
   if (!i7) {
    i12 = 20;
    break;
   }
   i6 = i8 + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i7;
   i6 = HEAP32[i4 >> 2] | 0;
   i5 = (Math_imul(HEAP32[i5 >> 2] | 0, i6) | 0) + 4 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   do {
    i5 = i5 - i6 | 0;
    i20 = i4;
    i4 = i7 + i5 | 0;
    HEAP32[i4 >> 2] = i20;
   } while ((i5 | 0) != 4);
   HEAP32[i8 >> 2] = i4;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   if (!i4) {
    i12 = 20;
    break;
   }
  }
  HEAP32[i4 >> 2] = i3;
  i20 = i9 + 4 | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i20 >> 2];
  HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] = i4;
  HEAP32[i4 + 8 >> 2] = i9;
  HEAP32[i20 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i10 + 24 >> 2] = i3;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if ((i2 | 0) == (i11 | 0)) {
   i12 = 22;
   break;
  }
 }
 if ((i12 | 0) == 9) _longjmp(i16 + 144 | 0, 1); else if ((i12 | 0) == 20) {
  HEAP32[i3 + 4 >> 2] = 0;
  _longjmp(i16 + 144 | 0, 1);
 } else if ((i12 | 0) == 22) {
  i3 = HEAP32[HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] >> 2] | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0;
  if (!i1) i1 = HEAP32[i2 + 8 >> 2] | 0;
  L32 : do if ((HEAP32[i2 + 16 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = i16 + 60 | 0;
   i5 = i13;
   i8 = 1;
   i7 = i2;
   i6 = i3;
   i4 = i14;
   while (1) {
    if ((HEAP32[i7 + 8 >> 2] | 0) != (i1 | 0)) {
     if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i16 >> 2] | 0, HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] | 0, i7) | 0)) {
      i12 = 28;
      break;
     }
     if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i16 >> 2] | 0, HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] | 0, i7) | 0)) {
      i12 = 30;
      break;
     }
    }
    i3 = i7 + 28 | 0;
    i2 = (HEAP32[i5 + 8 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 + 8 >> 2] = i2;
    switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      i2 = i2 & 1;
      break;
     }
    case 1:
     {
      i2 = (i2 | 0) != 0 & 1;
      break;
     }
    case 2:
     {
      i2 = (i2 | 0) > 0 & 1;
      break;
     }
    case 3:
     {
      i2 = i2 >>> 31;
      break;
     }
    case 4:
     {
      i2 = (i2 + 1 | 0) >>> 0 > 2 & 1;
      break;
     }
    default:
     i2 = 0;
    }
    HEAP32[i6 + 12 >> 2] = i2;
    HEAP32[i5 + 20 >> 2] = 1;
    if (!i8) if (__ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion(i16, i5) | 0) {
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 + 28 >> 2] | 0);
     i20 = (HEAP32[i7 + 4 >> 2] | 0) + 28 | 0;
     HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + (HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 28 >> 2] | 0);
     HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] = 0;
     i20 = HEAP32[i19 >> 2] | 0;
     i14 = HEAP32[i4 >> 2] | 0;
     i13 = i14 + 8 | 0;
     i12 = HEAP32[i14 + 4 >> 2] | 0;
     HEAP32[i12 + 8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] = i12;
     i20 = HEAP32[i20 + 16 >> 2] | 0;
     HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i20 >> 2] = i14;
     i20 = HEAP32[i18 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i20 >> 2] = i5;
     if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i16 >> 2] | 0, i1) | 0)) {
      i12 = 41;
      break;
     }
    }
    i4 = i6 + 4 | 0;
    i1 = HEAP32[HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
    i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
    if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i7 + 16 >> 2] | 0)) {
     i15 = i6;
     break L32;
    } else {
     i5 = i6;
     i20 = i7;
     i8 = 0;
     i7 = i2;
     i6 = i1;
     i1 = i20;
    }
   }
   if ((i12 | 0) == 28) _longjmp(i16 + 144 | 0, 1); else if ((i12 | 0) == 30) _longjmp(i16 + 144 | 0, 1); else if ((i12 | 0) == 41) _longjmp(i16 + 144 | 0, 1);
  } else i15 = i13; while (0);
  HEAP32[i15 + 20 >> 2] = 1;
  if (!i17) return;
  __ZL16WalkDirtyRegionsP14TESStesselatorP12ActiveRegion(i16, i15);
  return;
 }
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj(i22, i3, i1, i2) {
 i22 = i22 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23 + 64 | 0;
 i17 = i23 + 8 | 0;
 i15 = i23;
 i10 = i23 + 52 | 0;
 i11 = i23 + 40 | 0;
 i19 = i23 + 28 | 0;
 i20 = i23 + 16 | 0;
 i21 = i1 * 3 | 0;
 i2 = i2 * 3 | 0;
 i1 = i3;
 i16 = HEAP32[i1 + 4 >> 2] | 0;
 i12 = i15;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i12 + 4 >> 2] = i16;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj(i17, i18, i2 - i21 | 0);
 i18 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i3;
 HEAP32[i15 >> 2] = i18;
 HEAP32[i15 + 4 >> 2] = i17;
 i15 = i22 + 432 | 0;
 i3 = i22 + 436 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i16 = i17;
 i1 = i18;
 i18 = (i17 - i18 | 0) / 12 | 0;
 i17 = i21 - i2 + i12 + i18 | 0;
 if (!(i17 | i12)) {
  STACKTOP = i23;
  return;
 }
 if (!i12) {
  __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE19resizeUninitializedEj(i15, i18);
  i2 = HEAP32[i15 >> 2] | 0;
  i21 = HEAP32[i3 >> 2] | 0;
  i3 = i2 + (i21 * 12 | 0) | 0;
  if ((i21 | 0) > 0) while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 12 | 0;
  }
 } else {
  i8 = i17 >>> 0 > i12 >>> 0 ? i17 : i12;
  i4 = HEAP32[i22 + 440 >> 2] & 2147483647;
  i14 = i22 + 444 | 0;
  i9 = i22 + 452 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i7 = i3 & 2147483647;
  if (i8 >>> 0 > (i4 >>> 0 < i7 >>> 0 ? i4 : i7) >>> 0) {
   if (i4 >>> 0 < i17 >>> 0) {
    __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i15, i17);
    i3 = HEAP32[i9 >> 2] | 0;
   }
   if ((i3 & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i14, i8);
  }
  i6 = i22 + 448 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  L16 : do if (i3 >>> 0 < i12 >>> 0) {
   i7 = i3;
   while (1) {
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 + (i3 * 12 | 0) | 0;
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
     i24 = HEAP32[i14 >> 2] | 0;
     HEAP32[i24 + (i7 * 12 | 0) >> 2] = HEAP32[i5 >> 2];
     HEAP32[i24 + (i7 * 12 | 0) + 4 >> 2] = HEAP32[i4 + (i3 * 12 | 0) + 4 >> 2];
     HEAP32[i24 + (i7 * 12 | 0) + 8 >> 2] = HEAP32[i4 + (i3 * 12 | 0) + 8 >> 2];
     HEAP32[i6 >> 2] = i7 + 1;
    } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_(i14, i5) | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i12 | 0)) break L16;
    i7 = HEAP32[i6 >> 2] | 0;
   }
  } while (0);
  __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i15, i8, i10);
  __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i14, i8, i11);
  if ((i17 | 0) != (i12 | 0)) {
   i9 = HEAP32[i15 >> 2] | 0;
   i7 = i17 - i12 + i2 | 0;
   i8 = i7 >>> 0 > i2 >>> 0;
   i6 = i12 >>> 0 > i2 >>> 0;
   if (i8) if (i6) {
    i3 = i12;
    i4 = i17;
    do {
     i4 = i4 + -1 | 0;
     i3 = i3 + -1 | 0;
     HEAP32[i9 + (i4 * 12 | 0) >> 2] = HEAP32[i9 + (i3 * 12 | 0) >> 2];
     HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2];
     HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2];
    } while (i3 >>> 0 > i2 >>> 0);
    i13 = 23;
   } else i13 = 29; else if (i6) {
    i3 = i2;
    i4 = i7;
    while (1) {
     HEAP32[i9 + (i4 * 12 | 0) >> 2] = HEAP32[i9 + (i3 * 12 | 0) >> 2];
     HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i9 + (i3 * 12 | 0) + 4 >> 2];
     HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i9 + (i3 * 12 | 0) + 8 >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i13 = 23;
      break;
     } else i4 = i4 + 1 | 0;
    }
   }
   do if ((i13 | 0) == 23) {
    i5 = HEAP32[i14 >> 2] | 0;
    if (i8) {
     if (i6) {
      i3 = i12;
      i4 = i17;
     } else {
      i13 = 29;
      break;
     }
     do {
      i4 = i4 + -1 | 0;
      i3 = i3 + -1 | 0;
      HEAP32[i5 + (i4 * 12 | 0) >> 2] = HEAP32[i5 + (i3 * 12 | 0) >> 2];
      HEAP32[i5 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2];
      HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2];
     } while (i3 >>> 0 > i2 >>> 0);
    } else {
     if (i6) {
      i4 = i2;
      i3 = i7;
     } else break;
     while (1) {
      HEAP32[i5 + (i3 * 12 | 0) >> 2] = HEAP32[i5 + (i4 * 12 | 0) >> 2];
      HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i5 + (i4 * 12 | 0) + 4 >> 2];
      HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i12 | 0)) break; else i3 = i3 + 1 | 0;
     }
    }
    if (i8) i13 = 29;
   } while (0);
   if ((i13 | 0) == 29) {
    i3 = i18 + i21 | 0;
    do {
     i24 = i2 - i21 | 0;
     HEAP32[i9 + (i2 * 12 | 0) >> 2] = HEAP32[i1 + (i24 * 12 | 0) >> 2];
     HEAP32[i9 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i24 * 12 | 0) + 4 >> 2];
     HEAP32[i9 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i24 * 12 | 0) + 8 >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i15, i17, i19);
   __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i14, i17, i20);
  }
  if ((i16 | 0) != (i1 | 0)) {
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = 0;
   do {
    i24 = i3 + i21 | 0;
    HEAP32[i2 + (i24 * 12 | 0) >> 2] = HEAP32[i1 + (i3 * 12 | 0) >> 2];
    HEAP32[i2 + (i24 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2];
    HEAP32[i2 + (i24 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2];
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i18 >>> 0);
  }
 }
 HEAP32[i22 + 540 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZN6b2Body13ResetMassDataEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i19;
 i12 = i16 + 116 | 0;
 i14 = i16 + 120 | 0;
 i13 = i16 + 124 | 0;
 i15 = i16 + 128 | 0;
 i17 = i16 + 28 | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 i18 = i16 + 32 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) >>> 0 < 2) {
  i17 = i16 + 12 | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i17 = HEAP32[i17 + 4 >> 2] | 0;
  i18 = i16 + 36 | 0;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = i16 + 44 | 0;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i16 + 52 >> 2] = HEAP32[i16 + 56 >> 2];
  STACKTOP = i19;
  return;
 }
 i2 = HEAP32[gb + 1457504 >> 2] | 0;
 i1 = HEAP32[gb + 1457504 + 4 >> 2] | 0;
 i6 = HEAP32[i16 + 100 >> 2] | 0;
 if (!i6) i11 = 11; else {
  i8 = i7 + 4 | 0;
  i9 = i7 + 8 | 0;
  i10 = i7 + 12 | 0;
  do {
   f3 = Math_fround(HEAPF32[i6 + 20 >> 2]);
   if (!(f3 == Math_fround(0.0))) if (!(HEAP8[i6 + 58 >> 0] | 0)) {
    i20 = HEAP32[i6 + 32 >> 2] | 0;
    mftCall_viif(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0, i7 | 0, +f3);
    f5 = Math_fround(HEAPF32[i7 >> 2]);
    HEAPF32[i12 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i12 >> 2]));
    f4 = Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2]));
    f5 = Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2]));
    f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f4);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f5);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(HEAPF32[i10 >> 2]);
    HEAPF32[i13 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i13 >> 2]));
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   }
   i6 = HEAP32[i6 + 24 >> 2] | 0;
  } while ((i6 | 0) != 0);
  f3 = Math_fround(HEAPF32[i12 >> 2]);
  if (f3 > Math_fround(0.0)) {
   f5 = Math_fround(Math_fround(1.0) / f3);
   HEAPF32[i14 >> 2] = f5;
   f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f5);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f5);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  } else i11 = 11;
 }
 if ((i11 | 0) == 11) {
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  f3 = Math_fround(1.0);
 }
 i6 = HEAP32[i16 + 148 >> 2] | 0;
 if (HEAP8[i6 + 49 >> 0] | 0) {
  i20 = f3 < Math_fround(.0000999999974);
  i11 = f3 > Math_fround(1.0e6);
  f5 = i11 ? Math_fround(1.0e6) : f3;
  f5 = i20 ? Math_fround(.0000999999974) : f5;
  HEAPF32[i12 >> 2] = f5;
  HEAPF32[i6 + 32 >> 2] = f5;
 }
 if (!(HEAP16[i16 + 4 >> 1] & 16)) {
  f3 = Math_fround(HEAPF32[i13 >> 2]);
  if (f3 > Math_fround(0.0)) {
   f5 = Math_fround(HEAPF32[i12 >> 2]);
   f21 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f21 = Math_fround(f21 * f21);
   f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(f3 - Math_fround(Math_fround(f21 + Math_fround(f4 * f4)) * f5));
   HEAPF32[i13 >> 2] = f4;
   f3 = Math_fround(HEAPF32[i6 + 32 >> 2]);
   HEAPF32[i12 >> 2] = f3;
   if (!(HEAP8[i6 + 77 >> 0] | 0)) f4 = Math_fround(Math_fround(f3 / f5) * f4); else f4 = Math_fround(HEAPF32[i6 + 88 >> 2]);
   HEAPF32[i13 >> 2] = f4;
  } else {
   if (!(HEAP8[i6 + 77 >> 0] | 0)) f4 = Math_fround(1.0); else f4 = Math_fround(HEAPF32[i6 + 88 >> 2]);
   HEAPF32[i13 >> 2] = f4;
   i20 = HEAP32[i6 + 32 >> 2] | 0;
   HEAP32[i12 >> 2] = i20;
   f3 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(1.0) / f4);
  HEAPF32[i14 >> 2] = Math_fround(Math_fround(1.0) / f3);
 } else {
  f21 = Math_fround(HEAPF32[i6 + 32 >> 2]);
  HEAPF32[i12 >> 2] = f21;
  HEAPF32[i14 >> 2] = Math_fround(Math_fround(1.0) / f21);
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i15 >> 2] = Math_fround(0.0);
 }
 if (HEAP8[i6 + 76 >> 0] | 0) {
  i2 = HEAP32[i6 + 80 >> 2] | 0;
  i1 = HEAP32[i6 + 84 >> 2] | 0;
 }
 i15 = i16 + 44 | 0;
 f21 = Math_fround(HEAPF32[i15 >> 2]);
 i20 = i16 + 48 | 0;
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 HEAP32[i17 >> 2] = i2;
 HEAP32[i18 >> 2] = i1;
 f3 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f24 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f24 * f3);
 f23 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f22 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f4 - Math_fround(f23 * f22));
 f4 = Math_fround(Math_fround(HEAPF32[i16 + 12 >> 2]) + f4);
 f22 = Math_fround(Math_fround(f24 * f23) + Math_fround(f3 * f22));
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i16 + 16 >> 2]));
 HEAPF32[i15 >> 2] = f4;
 HEAPF32[i20 >> 2] = f22;
 HEAPF32[i16 + 36 >> 2] = f4;
 HEAPF32[i16 + 40 >> 2] = f22;
 f3 = Math_fround(HEAPF32[i16 + 72 >> 2]);
 f5 = Math_fround(f3 * Math_fround(f22 - f5));
 f21 = Math_fround(f3 * Math_fround(f4 - f21));
 i20 = i16 + 64 | 0;
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f5);
 i20 = i16 + 68 | 0;
 HEAPF32[i20 >> 2] = Math_fround(f21 + Math_fround(HEAPF32[i20 >> 2]));
 __ZN11Rigidbody2D17UpdateConstraintsEb(i6, 0);
 STACKTOP = i19;
 return;
}

function __ZN5physx2Sc9ActorCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i13 >> 2] = HEAP32[gb + 132356 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 132356 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 132356 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 132356 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 132356 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 132356 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 132356 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 132356 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 132388 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 132388 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 132388 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 132388 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 132388 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 132388 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 132388 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 132388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 132420 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 132420 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 132420 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 132420 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 132420 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 132420 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 132420 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 132420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 132452 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 132452 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 132452 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 132452 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 132452 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 132452 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 132452 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 132452 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 132484 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 132484 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 132484 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 132484 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 132484 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 132484 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 132484 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 132484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 132516 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 132516 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 132516 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 132516 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 132516 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 132516 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 132516 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 132516 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 132548 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 132548 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 132548 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 132548 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 132548 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 132548 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 132548 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 132548 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 132580 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 132580 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 132580 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 132580 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 132580 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 132580 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 132580 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 132580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 132612 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 132612 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 132612 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 132612 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 132612 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 132612 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 132612 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 132612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 132644 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 132644 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 132644 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 132644 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 132644 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 132644 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 132644 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 132644 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 132676 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 132676 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 132676 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 132676 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 132676 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 132676 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 132676 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 132676 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i8 = i15;
 i3 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 28 | 0;
 i5 = i1;
 if (i2 >>> 0 < i6 >>> 0) {
  i5 = i12 + 8 | 0;
  if ((((HEAP32[i5 >> 2] | 0) - i1 | 0) / 28 | 0 | 0) == (i6 | 0)) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE8__appendEj(i12, i6 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE7reserveEj(i8, i6);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i11, i14);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = (i2 - i4 | 0) / 28 | 0;
  i1 = i2;
  if (i3 >>> 0 < i6 >>> 0) {
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE8__appendEj(i8, i6 - i3 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i3 >>> 0 > i6 >>> 0) {
   i4 = i4 + (i6 * 28 | 0) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i2 = i1 + -28 | 0;
     HEAP32[i7 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i11 = HEAP32[i1 + -16 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
      i2 = HEAP32[i7 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i13 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -28 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -16 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i5 + (i6 * 28 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i6 * 28 | 0;
 i2 = (i1 | 0) / 28 | 0;
 if (!i1) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = __Znwj(i1) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i3;
  i2 = i3 + (i2 * 28 | 0) | 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i3;
  if (!i6) {
   i4 = i8;
   i5 = i1;
   i3 = i1;
  } else {
   i6 = i14 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i1 = i4 << 24 >> 24 < 0;
    i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i3 + 12 >> 2] = i1;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
     i1 = HEAP32[i3 + 12 >> 2] | 0;
     i9 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i3 + 11 >> 0] = i4;
     if (!i4) i1 = i3; else {
      i1 = i3;
      i9 = 34;
     }
    } else i9 = 32;
    if ((i9 | 0) == 32) {
     i16 = i4 + 16 & -16;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i6 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i3 + 8 >> 2] = i16 | -2147483648;
     HEAP32[i3 + 4 >> 2] = i4;
     i9 = 34;
    }
    if ((i9 | 0) == 34) {
     i9 = 0;
     _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i16 = i3 + 16 | 0;
    i4 = i5 + 16 | 0;
    HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    i5 = i5 + 28 | 0;
    i3 = (HEAP32[i10 >> 2] | 0) + 28 | 0;
    HEAP32[i10 >> 2] = i3;
   } while ((i5 | 0) != (i7 | 0));
   i4 = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i13 >> 2] = i3;
 i13 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i4 = i1;
 i2 = i16;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -28 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i16 = HEAP32[i2 + -16 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __ZN23ForwardShaderRenderLoop16PerformRenderingER8JobFencePK11ActiveLightRK13ShadowJobDatabbbN6Camera10RenderFlagE(i14, i15, i7, i1, i4, i5, i16, i6) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i16 = i16 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f17 = f0, f18 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i2 = i13;
 i1 = i16 ? gb + 1114848 | 0 : gb + 1114884 | 0;
 i12 = i14 + 8 | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i10);
  i11 = i1;
 } else i11 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 648 >> 2] | 0, i3 | 0, i9 | 0);
 i9 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZN23ForwardShaderRenderLoop23RenderForwardShadowMapsEPK11ActiveLightbN6Camera10RenderFlagER17ShaderPassContext(i14, i7, i5, i6, i9);
 i3 = __Z17GetRenderSettingsv() | 0;
 i8 = __Z19GetLightmapSettingsv() | 0;
 __ZNK16LightmapSettings23GetLightmapDecodeValuesEv(i10, i8);
 __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv(i2, i8);
 __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext(i10, i2, i9);
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, (HEAP32[i12 >> 2] | 0) + 1732 | 0);
 if (i5) __ZN6Camera13ClearNoSkyboxEb(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, 0); else mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 340 >> 2] | 0, i8 | 0);
 __ZNK14RenderSettings12SetupAmbientEv(i3);
 if ((i6 & 128 | 0) == 0 & i16) if (__Z12GetIVRDevicev() | 0) {
  i6 = __Z12GetIVRDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i6 | 0);
 }
 i2 = i16 ? 10 : 16;
 i6 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[i6 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i5 + 1136 | 0, i2, i9, HEAP32[i6 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i5 + 4 >> 2] | 0);
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i6 + 1136 | 0, i2, i9, HEAP32[i5 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i6 + 4 >> 2] | 0);
 if ((HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0) == 0 | i4) i1 = 4; else i1 = HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] << 1 & 255 ^ 6;
 i4 = i14 + 524 | 0;
 HEAP8[i4 >> 0] = i1 | HEAP8[i4 >> 0] & -7;
 HEAP32[i14 + 16 >> 2] = i7;
 i1 = i14 + 20 | 0;
 i4 = __ZNK14RenderSettings20GetDefaultSpotCookieEv(i3) | 0;
 if (!i4) HEAP32[i1 >> 2] = 0; else {
  HEAP32[i1 >> 2] = HEAP32[i4 + 48 >> 2];
  HEAP32[i14 + 24 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 148 >> 2] | 0, i4 | 0) | 0;
  HEAP32[i14 + 28 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0) | 0;
  i3 = HEAP32[i4 + 68 >> 2] | 0;
  i2 = HEAP32[i4 + 72 >> 2] | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0, i4 | 0) | 0;
  f18 = Math_fround(i7 | 0);
  f17 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0) | 0);
  HEAP32[i14 + 32 >> 2] = i3;
  HEAP32[i14 + 36 >> 2] = i2;
  HEAPF32[i14 + 40 >> 2] = f18;
  HEAPF32[i14 + 44 >> 2] = f17;
  i2 = i14 + 48 | 0;
  i3 = HEAP32[i4 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i4 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i10, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 }
 i1 = i14 + 64 | 0;
 i2 = __ZN10builtintex21GetAttenuationTextureEv() | 0;
 if (!i2) HEAP32[i1 >> 2] = 0; else {
  HEAP32[i1 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i14 + 68 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i14 + 72 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0) | 0;
  i4 = HEAP32[i2 + 68 >> 2] | 0;
  i3 = HEAP32[i2 + 72 >> 2] | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0) | 0;
  f17 = Math_fround(i7 | 0);
  f18 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0) | 0);
  HEAP32[i14 + 76 >> 2] = i4;
  HEAP32[i14 + 80 >> 2] = i3;
  HEAPF32[i14 + 84 >> 2] = f17;
  HEAPF32[i14 + 88 >> 2] = f18;
  i3 = i14 + 92 | 0;
  i4 = HEAP32[i2 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i2 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i10, i4, i1);
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 }
 __ZN23ForwardShaderRenderLoop15StartRenderJobsER8JobFencebR17ShaderPassContext(i14, i15, i16, i9);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, (HEAP32[i12 >> 2] | 0) + 1732 | 0);
 i10 = i16 ? 11 : 17;
 i16 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i16 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i15 + 1136 | 0, i10, i9, HEAP32[i16 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i15 + 4 >> 2] | 0);
 i15 = HEAP32[i12 >> 2] | 0;
 i16 = HEAP32[i15 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i16 + 1136 | 0, i10, i9, HEAP32[i15 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i16 + 4 >> 2] | 0);
 __ZN23ForwardShaderRenderLoop21CleanupAfterRenderingEv(i14);
 i16 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 652 >> 2] | 0, i16 | 0);
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i13;
 return;
}

function __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i29) {
 i1 = i1 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i32 + 60 | 0;
 i23 = i32 + 48 | 0;
 i31 = i32 + 32 | 0;
 i24 = i32 + 16 | 0;
 i25 = i32;
 i26 = i31 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i31 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i22 = i31 + 12 | 0;
 HEAP32[i22 >> 2] = 0;
 i30 = i31 + 4 | 0;
 HEAP32[i31 >> 2] = i30;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i1 + 4 | 0;
 if ((i2 | 0) == (i11 | 0)) i1 = 0; else {
  i12 = i25 + 11 | 0;
  i13 = i25 + 4 | 0;
  i14 = i24 + 12 | 0;
  i10 = i24 + 12 | 0;
  i15 = i28 + 4 | 0;
  i16 = i24 + 8 | 0;
  i17 = i24 + 4 | 0;
  i18 = i28 + 11 | 0;
  i19 = i28 + 4 | 0;
  i20 = i24 + 11 | 0;
  i21 = i28 + 4 | 0;
  while (1) {
   __ZN9shadertag16GetShaderTagNameEi(i25, HEAP32[i2 + 16 >> 2] | 0);
   i4 = HEAP8[i12 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i25 >> 2] | 0 : i25;
   i4 = i1 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i14 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
    i1 = HEAP32[i10 >> 2] | 0;
    i27 = 6;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i20 >> 0] = i4;
    if (!i4) i1 = i24; else {
     i1 = i24;
     i27 = 8;
    }
   } else i27 = 6;
   if ((i27 | 0) == 6) {
    i9 = i4 + 16 & -16;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i15 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i28, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i24 >> 2] = i1;
    HEAP32[i16 >> 2] = i9 | -2147483648;
    HEAP32[i17 >> 2] = i4;
    i27 = 8;
   }
   if ((i27 | 0) == 8) {
    i27 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i4 = __ZNKSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i31, i28, i24) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE25__construct_node_with_keyERS6_(i23, i31, i24);
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i23 >> 2] = 0;
    i3 = HEAP32[i28 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i31 >> 2] >> 2] | 0;
    if (!i3) i3 = i1; else {
     HEAP32[i31 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i26 >> 2] | 0, i3);
    HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   }
   i3 = i1 + 32 | 0;
   __ZN9shadertag16GetShaderTagNameEi(i28, HEAP32[i2 + 20 >> 2] | 0);
   i9 = HEAP8[i18 >> 0] | 0;
   i6 = i9 << 24 >> 24 < 0;
   i8 = i6 ? HEAP32[i28 >> 2] | 0 : i28;
   i9 = i6 ? HEAP32[i19 >> 2] | 0 : i9 & 255;
   i6 = i3 + 11 | 0;
   i4 = HEAP8[i6 >> 0] | 0;
   i5 = i4 << 24 >> 24 < 0;
   if (i5) i7 = (HEAP32[i1 + 40 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
   do if (i9 >>> 0 > i7 >>> 0) {
    if (i5) i1 = HEAP32[i1 + 36 >> 2] | 0; else i1 = i4 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i7, i9 - i7 | 0, i1, 0, i1, i9, i8);
   } else {
    if (i5) i3 = HEAP32[i3 >> 2] | 0;
    if (i9 | 0) _memmove(i3 | 0, i8 | 0, i9 | 0) | 0;
    HEAP8[i3 + i9 >> 0] = 0;
    if ((HEAP8[i6 >> 0] | 0) < 0) {
     HEAP32[i1 + 36 >> 2] = i9;
     break;
    } else {
     HEAP8[i6 >> 0] = i9;
     break;
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i9 = HEAP32[i24 >> 2] | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    HEAP32[i28 >> 2] = 66;
    HEAP32[i21 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i28);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i11 | 0)) break; else i2 = i1;
  }
  i1 = HEAP32[i22 >> 2] | 0;
 }
 HEAP32[i28 >> 2] = i1;
 i2 = i29 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i29 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i28, 4);
 i1 = HEAP32[i31 >> 2] | 0;
 if ((i1 | 0) == (i30 | 0)) {
  i30 = HEAP32[i30 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i31, i30);
  STACKTOP = i32;
  return;
 }
 i2 = i1;
 while (1) {
  __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i2 + 16 | 0, i29);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i30 | 0)) break; else i2 = i1;
 }
 i30 = HEAP32[i30 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i31, i30);
 STACKTOP = i32;
 return;
}

function __ZN6Camera8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 844 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 848 | 0, i6);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 864 | 0, i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 920 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 924 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 292 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 1088 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 916 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 888 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 880 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 928 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 744 | 0, i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 820 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 824 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 1091 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 1089 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 1100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 1096 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i8 + 1112 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i10 = HEAP8[i9 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN7mecanim5human14HumanSetupAxesEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i26, i27) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i32 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i28;
 i11 = i26 + 4 | 0;
 i12 = i26 + 8 | 0;
 i13 = i26 + 12 | 0;
 i14 = i26 + 16 | 0;
 i15 = i26 + 20 | 0;
 i16 = i26 + 24 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i26 + 16 >> 2] = 0;
 HEAP32[i26 + 20 >> 2] = 0;
 HEAP32[i16 >> 2] = 1065353216;
 i17 = i26 + 28 | 0;
 HEAP32[i17 >> 2] = 1065353216;
 i8 = i26 + 32 | 0;
 HEAP32[i8 >> 2] = 1065353216;
 i9 = i26 + 36 | 0;
 HEAP32[i9 >> 2] = 1065353216;
 i6 = i10 + 4 | 0;
 i7 = i10 + 8 | 0;
 f1 = Math_fround(0.0);
 i5 = 0;
 f2 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 do {
  if ((HEAP32[i26 + 72 + (i5 << 2) >> 2] | 0) > -1) {
   f30 = Math_fround(HEAPF32[i26 + 168 + (i5 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i10, i26, i27, i5);
   f31 = Math_fround(HEAPF32[i10 >> 2]);
   f29 = Math_fround(HEAPF32[i6 >> 2]);
   f1 = Math_fround(f1 + f30);
   f2 = Math_fround(f2 + Math_fround(f30 * f31));
   f3 = Math_fround(f3 + Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2])));
   f4 = Math_fround(f4 + Math_fround(f30 * f29));
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 24);
 f29 = Math_fround(f2 / f1);
 f31 = Math_fround(f4 / f1);
 f30 = Math_fround(f3 / f1);
 __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i10, i26, i27);
 i20 = HEAP32[i10 >> 2] | 0;
 i19 = HEAP32[i10 + 4 >> 2] | 0;
 i18 = HEAP32[i10 + 8 >> 2] | 0;
 i7 = HEAP32[i10 + 12 >> 2] | 0;
 HEAPF32[i26 >> 2] = f29;
 HEAPF32[i11 >> 2] = f31;
 HEAPF32[i12 >> 2] = f30;
 HEAP32[i13 >> 2] = i20;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i15 >> 2] = i18;
 HEAP32[i16 >> 2] = i7;
 HEAP32[i17 >> 2] = 1065353216;
 HEAP32[i8 >> 2] = 1065353216;
 HEAP32[i9 >> 2] = 1065353216;
 HEAPF32[i26 + 360 >> 2] = f31;
 i7 = i26 + 40 | 0;
 i11 = HEAP32[i7 >> 2] | 0;
 i8 = i7;
 i9 = i26 + 44 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i11 | 0) == 0 ? 0 : i11 + i8 | 0, i27, (i10 | 0) == 0 ? 0 : i10 + i9 | 0);
 i9 = i26 + 108 | 0;
 i10 = i26 + 104 | 0;
 i11 = i26 + 100 | 0;
 i12 = i27 + 4 | 0;
 i13 = i12;
 i14 = i26 + 132 | 0;
 i15 = i26 + 136 | 0;
 i16 = i26 + 92 | 0;
 i17 = i26 + 96 | 0;
 i18 = i26 + 84 | 0;
 i19 = i26 + 88 | 0;
 i20 = i26 + 112 | 0;
 i21 = i26 + 124 | 0;
 i22 = i26 + 128 | 0;
 i23 = i26 + 140 | 0;
 i24 = i26 + 144 | 0;
 i6 = 0;
 do {
  i25 = HEAP32[i26 + 72 + (i6 << 2) >> 2] | 0;
  do switch (i6 | 0) {
  case 23:
  case 22:
  case 21:
   {
    f1 = Math_fround(.100000001);
    i5 = -1;
    break;
   }
  case 10:
   {
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i5 | 0) > -1) f1 = Math_fround(-1.0); else {
     i5 = HEAP32[i10 >> 2] | 0;
     if ((i5 | 0) > -1) f1 = Math_fround(-.5); else {
      f1 = Math_fround(-.25);
      i5 = HEAP32[i11 >> 2] | 0;
     }
    }
    break;
   }
  case 5:
   {
    f1 = Math_fround(-Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i13 + (i25 * 40 | 0) + 4 >> 2]));
    i5 = -1;
    break;
   }
  case 6:
   {
    f1 = Math_fround(-Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i13 + (i25 * 40 | 0) + 4 >> 2]));
    i5 = -1;
    break;
   }
  case 17:
   {
    f1 = Math_fround(-.5);
    i5 = HEAP32[i14 >> 2] | 0;
    break;
   }
  case 18:
   {
    f1 = Math_fround(-.5);
    i5 = HEAP32[i15 >> 2] | 0;
    break;
   }
  case 19:
   {
    f1 = Math_fround(.5);
    i5 = HEAP32[i16 >> 2] | 0;
    break;
   }
  case 20:
   {
    f1 = Math_fround(.5);
    i5 = HEAP32[i17 >> 2] | 0;
    break;
   }
  case 0:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i11 >> 2] | 0;
    break;
   }
  case 1:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i18 >> 2] | 0;
    break;
   }
  case 2:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i19 >> 2] | 0;
    break;
   }
  case 3:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i16 >> 2] | 0;
    break;
   }
  case 4:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i17 >> 2] | 0;
    break;
   }
  case 7:
   {
    i5 = HEAP32[i10 >> 2] | 0;
    if ((i5 | 0) > -1) f1 = Math_fround(1.0); else {
     i5 = HEAP32[i9 >> 2] | 0;
     if ((i5 | 0) > -1) f1 = Math_fround(1.0); else {
      f1 = Math_fround(1.0);
      i5 = HEAP32[i20 >> 2] | 0;
     }
    }
    break;
   }
  case 8:
   {
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i5 | 0) > -1) f1 = Math_fround(1.0); else {
     f1 = Math_fround(1.0);
     i5 = HEAP32[i20 >> 2] | 0;
    }
    break;
   }
  case 9:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i20 >> 2] | 0;
    break;
   }
  case 11:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i21 >> 2] | 0;
    break;
   }
  case 12:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i22 >> 2] | 0;
    break;
   }
  case 13:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i14 >> 2] | 0;
    break;
   }
  case 14:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i15 >> 2] | 0;
    break;
   }
  case 15:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i23 >> 2] | 0;
    break;
   }
  case 16:
   {
    f1 = Math_fround(1.0);
    i5 = HEAP32[i24 >> 2] | 0;
    break;
   }
  default:
   {
    f1 = Math_fround(1.0);
    i5 = -1;
   }
  } while (0);
  if ((i25 | 0) > -1) {
   i32 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf((i32 | 0) == 0 ? 0 : i32 + i8 | 0, i27, gb + 181416 + (i6 * 88 | 0) | 0, i25, i5, 1, f1);
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 24);
 STACKTOP = i28;
 return;
}

function __Z21sweepConvex_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i6, i53, i54, i50, f4, i55, i2, f3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 i50 = i50 | 0;
 f4 = Math_fround(f4);
 i55 = i55 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i51 = 0, i52 = 0, i56 = 0, d57 = 0.0, f58 = f0, f59 = f0;
 i56 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i56 + 16 | 0;
 i52 = i56;
 i7 = HEAP32[i53 + 32 >> 2] | 0;
 HEAP32[i55 + 8 >> 2] = -1;
 i10 = HEAP32[i7 + 56 >> 2] | 0;
 i11 = HEAP8[i7 + 55 >> 0] | 0;
 i7 = HEAP8[i7 + 54 >> 0] | 0;
 i51 = (HEAP16[i2 >> 1] & 512) == 0;
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i1, i53 + 4 | 0, i53 + 16 | 0);
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i52, i6);
 i46 = i52 + 12 | 0;
 f37 = Math_fround(Math_fround(HEAPF32[i46 >> 2]) - f3);
 HEAPF32[i46 >> 2] = f37;
 i46 = i55 + 40 | 0;
 HEAPF32[i46 >> 2] = f4;
 if (!(i7 << 24 >> 24)) {
  i55 = 0;
  STACKTOP = i56;
  return i55 | 0;
 }
 i38 = i54 + 16 | 0;
 i39 = i54 + 20 | 0;
 i40 = i54 + 24 | 0;
 i41 = i50 + 4 | 0;
 i42 = i50 + 8 | 0;
 i47 = i55 + 12 | 0;
 i43 = i55 + 16 | 0;
 i44 = i55 + 20 | 0;
 i45 = i55 + 24 | 0;
 i48 = i55 + 32 | 0;
 i49 = i55 + 36 | 0;
 f29 = Math_fround(HEAPF32[i1 >> 2]);
 f30 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f31 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f20 = Math_fround(HEAPF32[i54 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i54 >> 2]);
 f22 = Math_fround(HEAPF32[i54 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i54 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i52 >> 2]);
 f25 = Math_fround(HEAPF32[i52 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i52 + 8 >> 2]);
 f27 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 i28 = i55 + 28 | 0;
 i2 = i7 & 255;
 f18 = f4;
 i6 = i10 + ((i11 & 255) * 20 | 0) | 0;
 i1 = 0;
 L4 : while (1) {
  i2 = i2 + -1 | 0;
  f14 = Math_fround(HEAPF32[i38 >> 2]);
  f15 = Math_fround(HEAPF32[i39 >> 2]);
  f16 = Math_fround(HEAPF32[i40 >> 2]);
  f5 = Math_fround(HEAPF32[i50 >> 2]);
  f17 = Math_fround(f5 * f24);
  f4 = Math_fround(HEAPF32[i41 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f4 * f25));
  f3 = Math_fround(HEAPF32[i42 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f3 * f26));
  d57 = +f17;
  if (d57 > -1.0e-07 & d57 < 1.0e-07) {
   i6 = 4;
   break;
  }
  while (1) {
   f59 = Math_fround(HEAPF32[i6 >> 2]);
   f9 = Math_fround(f59 * f29);
   f58 = Math_fround(f59 * f30);
   f59 = Math_fround(f59 * f31);
   f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f8 * f32));
   f58 = Math_fround(f58 + Math_fround(f8 * f33));
   f8 = Math_fround(f59 + Math_fround(f8 * f34));
   f59 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   i6 = i6 + 12 | 0;
   f9 = Math_fround(Math_fround(f9 + Math_fround(f59 * f35)) * Math_fround(2.0));
   f58 = Math_fround(Math_fround(f58 + Math_fround(f59 * f36)) * Math_fround(2.0));
   f59 = Math_fround(Math_fround(f8 + Math_fround(f59 * f19)) * Math_fround(2.0));
   f8 = Math_fround(Math_fround(Math_fround(f9 * f21) + Math_fround(f58 * f22)) + Math_fround(f59 * f23));
   f13 = Math_fround(f14 + Math_fround(Math_fround(f21 * f8) + Math_fround(Math_fround(f9 * f27) + Math_fround(f20 * Math_fround(Math_fround(f59 * f22) - Math_fround(f58 * f23))))));
   f12 = Math_fround(f15 + Math_fround(Math_fround(f22 * f8) + Math_fround(Math_fround(f58 * f27) + Math_fround(f20 * Math_fround(Math_fround(f9 * f23) - Math_fround(f21 * f59))))));
   f8 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f59 * f27) + Math_fround(f20 * Math_fround(Math_fround(f58 * f21) - Math_fround(f9 * f22)))) + Math_fround(f23 * f8)));
   f9 = Math_fround(Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f24 * f13) + Math_fround(f12 * f25)) + Math_fround(f8 * f26)) + f37)) / f17);
   if (Math_fround(f37 + Math_fround(Math_fround(Math_fround(f13 * f24) + Math_fround(f12 * f25)) + Math_fround(f8 * f26))) <= Math_fround(0.0)) {
    i6 = 10;
    break L4;
   }
   if (!(!(f9 > Math_fround(0.0)) | !(f9 <= f18))) break;
   if (!i2) {
    i6 = 13;
    break L4;
   } else i2 = i2 + -1 | 0;
  }
  f18 = Math_fround(f13 + Math_fround(f5 * f9));
  f58 = Math_fround(f12 + Math_fround(f4 * f9));
  f59 = Math_fround(f8 + Math_fround(f3 * f9));
  HEAPF32[i46 >> 2] = f9;
  HEAP16[i47 >> 1] = 7;
  HEAPF32[i43 >> 2] = f18;
  HEAPF32[i44 >> 2] = f58;
  HEAPF32[i45 >> 2] = f59;
  HEAPF32[i28 >> 2] = f24;
  HEAPF32[i48 >> 2] = f25;
  HEAPF32[i49 >> 2] = f26;
  if (!i2) {
   i1 = 1;
   i6 = 13;
   break;
  } else {
   f18 = f9;
   i1 = 1;
  }
 }
 if ((i6 | 0) == 4) {
  while (1) if (!i2) break; else i2 = i2 + -1 | 0;
  STACKTOP = i56;
  return i1 | 0;
 } else if ((i6 | 0) == 10) if (i51) {
  HEAPF32[i46 >> 2] = Math_fround(0.0);
  HEAP16[i47 >> 1] = 6;
  f58 = Math_fround(-f4);
  f59 = Math_fround(-f3);
  HEAPF32[i55 + 28 >> 2] = Math_fround(-f5);
  HEAPF32[i48 >> 2] = f58;
  HEAPF32[i49 >> 2] = f59;
  i55 = 1;
  STACKTOP = i56;
  return i55 | 0;
 } else {
  HEAP16[i47 >> 1] = 7;
  i55 = __ZN5physx2Gu22computePlane_ConvexMTDERKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformERNS_10PxSweepHitE(i52, i53, i54, i55) | 0;
  STACKTOP = i56;
  return i55 | 0;
 } else if ((i6 | 0) == 13) {
  STACKTOP = i56;
  return i1 | 0;
 }
 return 0;
}

function __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_RKNS_6bitsetILj66EEE(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 if ((HEAP32[i6 + 8 >> 2] | 0) == 3) if ((HEAP32[i6 + 4 >> 2] | 0) == -1) if ((HEAP32[i6 >> 2] | 0) == -1) {
  __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i4, i5, 0);
  return;
 } else i1 = 0; else i1 = 0; else i1 = 0;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  if (!(HEAP32[i6 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) HEAPF32[i4 + 596 + (i2 << 2) >> 2] = Math_fround(0.0); else HEAP32[i4 + 596 + (i2 << 2) >> 2] = HEAP32[i5 + 596 + (i2 << 2) >> 2];
 } while ((i1 | 0) != 52);
 i1 = i6 + 4 | 0;
 if (!(HEAP32[i1 >> 2] & 33554432)) {
  i2 = i4 + 364 | 0;
  i3 = i2 + 80 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } else {
  HEAP32[i4 + 364 >> 2] = HEAP32[i5 + 364 >> 2];
  HEAP32[i4 + 368 >> 2] = HEAP32[i5 + 368 >> 2];
  HEAP32[i4 + 372 >> 2] = HEAP32[i5 + 372 >> 2];
  HEAP32[i4 + 376 >> 2] = HEAP32[i5 + 376 >> 2];
  HEAP32[i4 + 380 >> 2] = HEAP32[i5 + 380 >> 2];
  HEAP32[i4 + 384 >> 2] = HEAP32[i5 + 384 >> 2];
  HEAP32[i4 + 388 >> 2] = HEAP32[i5 + 388 >> 2];
  HEAP32[i4 + 392 >> 2] = HEAP32[i5 + 392 >> 2];
  HEAP32[i4 + 396 >> 2] = HEAP32[i5 + 396 >> 2];
  HEAP32[i4 + 400 >> 2] = HEAP32[i5 + 400 >> 2];
  HEAP32[i4 + 404 >> 2] = HEAP32[i5 + 404 >> 2];
  HEAP32[i4 + 408 >> 2] = HEAP32[i5 + 408 >> 2];
  HEAP32[i4 + 412 >> 2] = HEAP32[i5 + 412 >> 2];
  HEAP32[i4 + 416 >> 2] = HEAP32[i5 + 416 >> 2];
  HEAP32[i4 + 420 >> 2] = HEAP32[i5 + 420 >> 2];
  HEAP32[i4 + 424 >> 2] = HEAP32[i5 + 424 >> 2];
  HEAP32[i4 + 428 >> 2] = HEAP32[i5 + 428 >> 2];
  HEAP32[i4 + 432 >> 2] = HEAP32[i5 + 432 >> 2];
  HEAP32[i4 + 436 >> 2] = HEAP32[i5 + 436 >> 2];
  HEAP32[i4 + 440 >> 2] = HEAP32[i5 + 440 >> 2];
 }
 if (!(HEAP32[i1 >> 2] & 67108864)) {
  i2 = i4 + 500 | 0;
  i3 = i2 + 80 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i1 = 0;
 } else {
  HEAP32[i4 + 500 >> 2] = HEAP32[i5 + 500 >> 2];
  HEAP32[i4 + 504 >> 2] = HEAP32[i5 + 504 >> 2];
  HEAP32[i4 + 508 >> 2] = HEAP32[i5 + 508 >> 2];
  HEAP32[i4 + 512 >> 2] = HEAP32[i5 + 512 >> 2];
  HEAP32[i4 + 516 >> 2] = HEAP32[i5 + 516 >> 2];
  HEAP32[i4 + 520 >> 2] = HEAP32[i5 + 520 >> 2];
  HEAP32[i4 + 524 >> 2] = HEAP32[i5 + 524 >> 2];
  HEAP32[i4 + 528 >> 2] = HEAP32[i5 + 528 >> 2];
  HEAP32[i4 + 532 >> 2] = HEAP32[i5 + 532 >> 2];
  HEAP32[i4 + 536 >> 2] = HEAP32[i5 + 536 >> 2];
  HEAP32[i4 + 540 >> 2] = HEAP32[i5 + 540 >> 2];
  HEAP32[i4 + 544 >> 2] = HEAP32[i5 + 544 >> 2];
  HEAP32[i4 + 548 >> 2] = HEAP32[i5 + 548 >> 2];
  HEAP32[i4 + 552 >> 2] = HEAP32[i5 + 552 >> 2];
  HEAP32[i4 + 556 >> 2] = HEAP32[i5 + 556 >> 2];
  HEAP32[i4 + 560 >> 2] = HEAP32[i5 + 560 >> 2];
  HEAP32[i4 + 564 >> 2] = HEAP32[i5 + 564 >> 2];
  HEAP32[i4 + 568 >> 2] = HEAP32[i5 + 568 >> 2];
  HEAP32[i4 + 572 >> 2] = HEAP32[i5 + 572 >> 2];
  HEAP32[i4 + 576 >> 2] = HEAP32[i5 + 576 >> 2];
  i1 = 0;
 }
 do {
  i3 = i1 + 53 | 0;
  i2 = i4 + 68 + (i1 << 6) | 0;
  if (!(HEAP32[i6 + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
   HEAP32[i2 >> 2] = 0;
   i3 = i4 + 68 + (i1 << 6) + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i4 + 68 + (i1 << 6) + 24 >> 2] = 1065353216;
   HEAP32[i4 + 68 + (i1 << 6) + 28 >> 2] = 1065353216;
   HEAP32[i4 + 68 + (i1 << 6) + 32 >> 2] = 1065353216;
   HEAP32[i4 + 68 + (i1 << 6) + 36 >> 2] = 1065353216;
  } else {
   i3 = HEAP32[i5 + 68 + (i1 << 6) + 4 >> 2] | 0;
   i7 = HEAP32[i5 + 68 + (i1 << 6) + 8 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 + 68 + (i1 << 6) >> 2];
   HEAP32[i4 + 68 + (i1 << 6) + 4 >> 2] = i3;
   HEAP32[i4 + 68 + (i1 << 6) + 8 >> 2] = i7;
   i7 = HEAP32[i5 + 68 + (i1 << 6) + 16 >> 2] | 0;
   i3 = HEAP32[i5 + 68 + (i1 << 6) + 20 >> 2] | 0;
   i2 = HEAP32[i5 + 68 + (i1 << 6) + 24 >> 2] | 0;
   HEAP32[i4 + 68 + (i1 << 6) + 12 >> 2] = HEAP32[i5 + 68 + (i1 << 6) + 12 >> 2];
   HEAP32[i4 + 68 + (i1 << 6) + 16 >> 2] = i7;
   HEAP32[i4 + 68 + (i1 << 6) + 20 >> 2] = i3;
   HEAP32[i4 + 68 + (i1 << 6) + 24 >> 2] = i2;
   i2 = HEAP32[i5 + 68 + (i1 << 6) + 32 >> 2] | 0;
   i3 = HEAP32[i5 + 68 + (i1 << 6) + 36 >> 2] | 0;
   HEAP32[i4 + 68 + (i1 << 6) + 28 >> 2] = HEAP32[i5 + 68 + (i1 << 6) + 28 >> 2];
   HEAP32[i4 + 68 + (i1 << 6) + 32 >> 2] = i2;
   HEAP32[i4 + 68 + (i1 << 6) + 36 >> 2] = i3;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 if (!(HEAP32[i6 >> 2] & 1)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = 1065353216;
  HEAP32[i4 + 28 >> 2] = 1065353216;
  HEAP32[i4 + 32 >> 2] = 1065353216;
  HEAP32[i4 + 36 >> 2] = 1065353216;
  i1 = 0;
 } else {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i3;
  i3 = HEAP32[i5 + 16 >> 2] | 0;
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  i7 = HEAP32[i5 + 24 >> 2] | 0;
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = i3;
  HEAP32[i4 + 20 >> 2] = i1;
  HEAP32[i4 + 24 >> 2] = i7;
  i7 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = HEAP32[i5 + 36 >> 2] | 0;
  HEAP32[i4 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP32[i4 + 32 >> 2] = i7;
  HEAP32[i4 + 36 >> 2] = i1;
  i1 = 0;
 }
 do {
  i7 = i1 + 59 | 0;
  i2 = i4 + 804 + (i1 * 12 | 0) | 0;
  if (!(HEAP32[i6 + (i7 >>> 5 << 2) >> 2] & 1 << (i7 & 31))) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 + 804 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i4 + 804 + (i1 * 12 | 0) + 8 >> 2] = 0;
  } else {
   i3 = HEAP32[i5 + 804 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i5 + 804 + (i1 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 + 804 + (i1 * 12 | 0) >> 2];
   HEAP32[i4 + 804 + (i1 * 12 | 0) + 4 >> 2] = i3;
   HEAP32[i4 + 804 + (i1 * 12 | 0) + 8 >> 2] = i7;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 return;
}

function __ZN26b2PolygonAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i4, i11, i12, i13) {
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 i15 = HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i9 = (HEAP32[i7 + 176 >> 2] | 0) == 0;
 i8 = i7 + 12 | 0;
 i10 = i7 + 20 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i10 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i10 + 4 >> 2]));
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3))));
 if (f2 < Math_fround(1.1920929e-07)) {
  f18 = f1;
  f17 = f3;
 } else {
  f17 = Math_fround(Math_fround(1.0) / f2);
  f18 = Math_fround(f1 * f17);
  f17 = Math_fround(f3 * f17);
 }
 do if (i9) i6 = i11 + 60 | 0; else {
  __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i11, i15, i12, i7 + 28 | 0, i13);
  i6 = i11 + 60 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = HEAP32[i11 + 40 >> 2] | 0;
   i4 = HEAP32[i11 + 44 >> 2] | 0;
   if ((HEAP32[i11 + 56 >> 2] | 0) == 1) {
    f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
    f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f21 * f20);
    f3 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f1 - Math_fround(f2 * f3));
    f3 = Math_fround(Math_fround(f2 * f20) + Math_fround(f21 * f3));
    f21 = Math_fround(HEAPF32[i13 + 12 >> 2]);
    f20 = Math_fround(f21 * f1);
    f2 = Math_fround(HEAPF32[i13 + 8 >> 2]);
    f20 = Math_fround(f20 + Math_fround(f2 * f3));
    f2 = Math_fround(Math_fround(f21 * f3) - Math_fround(f1 * f2));
    f1 = Math_fround(-f20);
    f3 = Math_fround(-f2);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(f2 * f2))));
    if (f2 < Math_fround(1.1920929e-07)) i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0); else {
     f21 = Math_fround(Math_fround(1.0) / f2);
     f20 = Math_fround(f21 * f1);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
     f21 = Math_fround(f21 * f3);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
    }
   }
   f21 = Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f21 = Math_fround(Math_fround(f18 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f21);
   if (!(f21 >= Math_fround(.99999988) | f21 <= Math_fround(-.99999988))) {
    HEAP32[i6 >> 2] = 0;
    break;
   }
   HEAP32[i11 + 68 >> 2] = HEAP32[gb + 151644 >> 2];
   STACKTOP = i19;
   return;
  }
 } while (0);
 HEAP32[i14 >> 2] = gb + 151824 + 8;
 i4 = i14 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i4 = i14 + 12 | 0;
 i5 = i8;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i11, i15, i12, i14, i13, 0);
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  if (!i9) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i11 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i11 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(f18 * f2) + Math_fround(f17 * f1)) >= Math_fround(0.0))) {
    HEAP32[i6 >> 2] = 0;
    i16 = 18;
   }
  }
 } else i16 = 18;
 if ((i16 | 0) == 18) if (!i9) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i16 = i4;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i11, i15, i12, i14, i13, 0);
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i11 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i11 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(-Math_fround(f17 * f1)) - Math_fround(f18 * f2)) >= Math_fround(0.0))) HEAP32[i6 >> 2] = 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i5, i6) {
 i17 = i17 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18 + 60 | 0;
 i2 = i18 + 48 | 0;
 i3 = i18 + 36 | 0;
 i7 = i18;
 i19 = i17 + 44 | 0;
 HEAP16[i19 >> 1] = (HEAP16[i19 >> 1] | 0) + 1 << 16 >> 16;
 if (!(__ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_(i17 + 16 | 0, i17 + 28 | 0, i4, i5, i6) | 0)) {
  STACKTOP = i18;
  return;
 }
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f26 = Math_fround(f15 - f16);
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f25 = Math_fround(f8 - f9);
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f24 = Math_fround(f10 - f11);
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f29 = Math_fround(f16 - f12);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f28 = Math_fround(f9 - f13);
 f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f27 = Math_fround(f11 - f14);
 f23 = Math_fround(f12 - f15);
 f22 = Math_fround(f13 - f8);
 f20 = Math_fround(f14 - f10);
 f21 = Math_fround(HEAPF32[i17 + 40 >> 2]);
 i19 = (Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f28 * f28)) + Math_fround(f27 * f27)) > f21 & 1) << 1 | Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25)) + Math_fround(f24 * f24)) > f21 | (Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)) + Math_fround(f20 * f20)) > f21 & 1) << 2;
 f21 = Math_fround(Math_fround(f8 + f9) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f10 + f11) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f15 + f16) * Math_fround(.5));
 HEAPF32[i1 + 4 >> 2] = f21;
 HEAPF32[i1 + 8 >> 2] = f20;
 f20 = Math_fround(Math_fround(f9 + f13) * Math_fround(.5));
 f21 = Math_fround(Math_fround(f11 + f14) * Math_fround(.5));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f16 + f12) * Math_fround(.5));
 HEAPF32[i2 + 4 >> 2] = f20;
 HEAPF32[i2 + 8 >> 2] = f21;
 f21 = Math_fround(Math_fround(f13 + f8) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f14 + f10) * Math_fround(.5));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(f12 + f15) * Math_fround(.5));
 HEAPF32[i3 + 4 >> 2] = f21;
 HEAPF32[i3 + 8 >> 2] = f20;
 switch (i19 | 0) {
 case 0:
  {
   i1 = HEAP32[i17 + 8 >> 2] | 0;
   HEAPF32[i7 >> 2] = f15;
   HEAPF32[i7 + 4 >> 2] = f8;
   HEAPF32[i7 + 8 >> 2] = f10;
   HEAPF32[i7 + 12 >> 2] = f16;
   HEAPF32[i7 + 16 >> 2] = f9;
   HEAPF32[i7 + 20 >> 2] = f11;
   HEAPF32[i7 + 24 >> 2] = f12;
   HEAPF32[i7 + 28 >> 2] = f13;
   HEAPF32[i7 + 32 >> 2] = f14;
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = HEAP32[i1 >> 2] | 0;
    HEAPF32[i19 + (i3 * 36 | 0) >> 2] = f15;
    HEAPF32[i19 + (i3 * 36 | 0) + 4 >> 2] = f8;
    HEAPF32[i19 + (i3 * 36 | 0) + 8 >> 2] = f10;
    HEAPF32[i19 + (i3 * 36 | 0) + 12 >> 2] = f16;
    HEAPF32[i19 + (i3 * 36 | 0) + 16 >> 2] = f9;
    HEAPF32[i19 + (i3 * 36 | 0) + 20 >> 2] = f11;
    HEAPF32[i19 + (i3 * 36 | 0) + 24 >> 2] = f12;
    HEAPF32[i19 + (i3 * 36 | 0) + 28 >> 2] = f13;
    HEAPF32[i19 + (i3 * 36 | 0) + 32 >> 2] = f14;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i7) | 0;
   i1 = HEAP32[i17 + 12 >> 2] | 0;
   i2 = i17 + 4 | 0;
   i3 = i1 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i2) | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
   STACKTOP = i18;
   return;
  }
 case 1:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i1, i6);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i1, i5, i6);
   STACKTOP = i18;
   return;
  }
 case 2:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i5, i2);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i2, i6);
   STACKTOP = i18;
   return;
  }
 case 3:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i1, i2);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i2, i6);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i1, i5, i2);
   STACKTOP = i18;
   return;
  }
 case 4:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i5, i3);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i5, i6, i3);
   STACKTOP = i18;
   return;
  }
 case 5:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i1, i3);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i1, i5, i3);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i3, i5, i6);
   STACKTOP = i18;
   return;
  }
 case 6:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i5, i2);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i2, i3);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i3, i2, i6);
   STACKTOP = i18;
   return;
  }
 case 7:
  {
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i4, i1, i3);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i1, i5, i2);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i3, i2, i6);
   __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_(i17, i1, i2, i3);
   STACKTOP = i18;
   return;
  }
 default:
  {}
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRK16NavMeshCarveDataS3_EPS1_EEbT0_S8_T_(i31, i32, i27) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i33;
 switch ((i32 - i31 | 0) / 88 | 0 | 0) {
 case 2:
  {
   i23 = i32 + -88 | 0;
   if (!(mftCall_iii(HEAP32[i27 >> 2] | 0, i23 | 0, i31 | 0) | 0)) {
    i32 = 1;
    STACKTOP = i33;
    return i32 | 0;
   }
   i1 = HEAP32[i31 >> 2] | 0;
   i2 = HEAP32[i31 + 4 >> 2] | 0;
   i3 = HEAP32[i31 + 8 >> 2] | 0;
   i4 = HEAP32[i31 + 12 >> 2] | 0;
   i5 = HEAP32[i31 + 16 >> 2] | 0;
   i6 = HEAP32[i31 + 20 >> 2] | 0;
   i7 = HEAP32[i31 + 24 >> 2] | 0;
   i8 = HEAP32[i31 + 28 >> 2] | 0;
   i9 = HEAP32[i31 + 32 >> 2] | 0;
   i10 = HEAP32[i31 + 36 >> 2] | 0;
   i11 = HEAP32[i31 + 40 >> 2] | 0;
   i12 = HEAP32[i31 + 44 >> 2] | 0;
   i13 = HEAP32[i31 + 48 >> 2] | 0;
   i14 = HEAP32[i31 + 52 >> 2] | 0;
   i15 = HEAP32[i31 + 56 >> 2] | 0;
   i16 = HEAP32[i31 + 60 >> 2] | 0;
   i17 = HEAP32[i31 + 64 >> 2] | 0;
   i18 = HEAP32[i31 + 68 >> 2] | 0;
   i19 = HEAP32[i31 + 72 >> 2] | 0;
   i20 = HEAP32[i31 + 76 >> 2] | 0;
   i21 = HEAP32[i31 + 80 >> 2] | 0;
   i22 = HEAP32[i31 + 84 >> 2] | 0;
   i28 = i31;
   i29 = i23;
   i30 = i28 + 88 | 0;
   do {
    HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
    i28 = i28 + 4 | 0;
    i29 = i29 + 4 | 0;
   } while ((i28 | 0) < (i30 | 0));
   HEAP32[i23 >> 2] = i1;
   HEAP32[i32 + -84 >> 2] = i2;
   HEAP32[i32 + -80 >> 2] = i3;
   HEAP32[i32 + -76 >> 2] = i4;
   HEAP32[i32 + -72 >> 2] = i5;
   HEAP32[i32 + -68 >> 2] = i6;
   HEAP32[i32 + -64 >> 2] = i7;
   HEAP32[i32 + -60 >> 2] = i8;
   HEAP32[i32 + -56 >> 2] = i9;
   HEAP32[i32 + -52 >> 2] = i10;
   HEAP32[i32 + -48 >> 2] = i11;
   HEAP32[i32 + -44 >> 2] = i12;
   HEAP32[i32 + -40 >> 2] = i13;
   HEAP32[i32 + -36 >> 2] = i14;
   HEAP32[i32 + -32 >> 2] = i15;
   HEAP32[i32 + -28 >> 2] = i16;
   HEAP32[i32 + -24 >> 2] = i17;
   HEAP32[i32 + -20 >> 2] = i18;
   HEAP32[i32 + -16 >> 2] = i19;
   HEAP32[i32 + -12 >> 2] = i20;
   HEAP32[i32 + -8 >> 2] = i21;
   HEAP32[i32 + -4 >> 2] = i22;
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i31, i31 + 88 | 0, i32 + -88 | 0, i27) | 0;
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_(i31, i31 + 88 | 0, i31 + 176 | 0, i32 + -88 | 0, i27) | 0;
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i31, i31 + 88 | 0, i31 + 176 | 0, i31 + 264 | 0, i32 + -88 | 0, i27) | 0;
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 case 1:
 case 0:
  {
   i32 = 1;
   STACKTOP = i33;
   return i32 | 0;
  }
 default:
  {
   i2 = i31 + 176 | 0;
   __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i31, i31 + 88 | 0, i2, i27) | 0;
   i1 = i31 + 264 | 0;
   L3 : do if ((i1 | 0) == (i32 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i5 + 4 | 0;
    i7 = i5 + 8 | 0;
    i8 = i5 + 12 | 0;
    i9 = i5 + 16 | 0;
    i10 = i5 + 20 | 0;
    i11 = i5 + 24 | 0;
    i12 = i5 + 28 | 0;
    i13 = i5 + 32 | 0;
    i14 = i5 + 36 | 0;
    i15 = i5 + 40 | 0;
    i16 = i5 + 44 | 0;
    i17 = i5 + 48 | 0;
    i18 = i5 + 52 | 0;
    i19 = i5 + 56 | 0;
    i20 = i5 + 60 | 0;
    i21 = i5 + 64 | 0;
    i22 = i5 + 68 | 0;
    i23 = i5 + 72 | 0;
    i24 = i5 + 76 | 0;
    i25 = i5 + 80 | 0;
    i26 = i5 + 84 | 0;
    i4 = i1;
    i1 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i27 >> 2] | 0, i4 | 0, i2 | 0) | 0) {
      HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 >> 2] = HEAP32[i4 + 4 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i4 + 8 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i4 + 12 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i4 + 16 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i4 + 20 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i4 + 24 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i4 + 28 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i4 + 32 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i4 + 36 >> 2];
      HEAP32[i15 >> 2] = HEAP32[i4 + 40 >> 2];
      HEAP32[i16 >> 2] = HEAP32[i4 + 44 >> 2];
      HEAP32[i17 >> 2] = HEAP32[i4 + 48 >> 2];
      HEAP32[i18 >> 2] = HEAP32[i4 + 52 >> 2];
      HEAP32[i19 >> 2] = HEAP32[i4 + 56 >> 2];
      HEAP32[i20 >> 2] = HEAP32[i4 + 60 >> 2];
      HEAP32[i21 >> 2] = HEAP32[i4 + 64 >> 2];
      HEAP32[i22 >> 2] = HEAP32[i4 + 68 >> 2];
      HEAP32[i23 >> 2] = HEAP32[i4 + 72 >> 2];
      HEAP32[i24 >> 2] = HEAP32[i4 + 76 >> 2];
      HEAP32[i25 >> 2] = HEAP32[i4 + 80 >> 2];
      HEAP32[i26 >> 2] = HEAP32[i4 + 84 >> 2];
      i3 = i4;
      while (1) {
       i28 = i3;
       i29 = i2;
       i30 = i28 + 88 | 0;
       do {
        HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
        i28 = i28 + 4 | 0;
        i29 = i29 + 4 | 0;
       } while ((i28 | 0) < (i30 | 0));
       if ((i2 | 0) == (i31 | 0)) break;
       i3 = i2 + -88 | 0;
       if (mftCall_iii(HEAP32[i27 >> 2] | 0, i5 | 0, i3 | 0) | 0) {
        i30 = i2;
        i2 = i3;
        i3 = i30;
       } else break;
      }
      i28 = i2;
      i29 = i5;
      i30 = i28 + 88 | 0;
      do {
       HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
       i28 = i28 + 4 | 0;
       i29 = i29 + 4 | 0;
      } while ((i28 | 0) < (i30 | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i4 + 88 | 0) == (i32 | 0);
       break L3;
      }
     }
     i2 = i4 + 88 | 0;
     if ((i2 | 0) == (i32 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i30 = i4;
      i4 = i2;
      i2 = i30;
     }
    }
   } while (0);
   i32 = i1 | i2;
   STACKTOP = i33;
   return i32 | 0;
  }
 }
 return 0;
}

function __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i4, i1, i5, i18) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 32 | 0;
 i19 = i21 + 8 | 0;
 i17 = i21;
 i15 = i21 + 24 | 0;
 i16 = i21 + 16 | 0;
 i7 = i1;
 i6 = i4;
 i2 = i7 - i6 | 0;
 i3 = (i2 | 0) > 372;
 L1 : do if ((i5 | 0) > 0 & i3) {
  i14 = i18;
  i13 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i7;
  while (1) {
   i11 = i1 + -12 | 0;
   while (1) {
    i10 = i17;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    i10 = ((i2 | 0) / 12 | 0) + -1 | 0;
    i2 = i19;
    HEAP32[i2 >> 2] = i13;
    HEAP32[i2 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i4, i11, i10, i20);
    i2 = -1;
    i3 = i10;
    while (1) {
     while (1) {
      i8 = i2 + 1 | 0;
      i9 = i4 + (i8 * 12 | 0) | 0;
      if ((i8 | 0) == (i10 | 0) | (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i17, i9, i11) | 0) ^ 1) break; else i2 = i8;
     }
     do {
      i3 = i3 + -1 | 0;
      i7 = i4 + (i3 * 12 | 0) | 0;
     } while (!((i3 | 0) == 0 | (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i17, i11, i7) | 0) ^ 1));
     if ((i8 | 0) >= (i3 | 0)) break;
     HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i2 = i8;
    }
    HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i8 = i4 + ((i2 + 2 | 0) * 12 | 0) | 0;
    i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
    i9 = i4 + (i2 * 12 | 0) + 12 | 0;
    i10 = i9;
    i3 = (i10 - i6 | 0) / 12 | 0;
    i6 = i8;
    i2 = i12 - i6 | 0;
    i7 = (i2 | 0) / 12 | 0;
    if ((i3 | 0) >= (i7 | 0)) break;
    i10 = i15;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i4, i9, i3, i20);
    i3 = (i2 | 0) > 372;
    if (!((i5 | 0) > 0 & i3)) break L1; else i4 = i8;
   }
   i6 = i16;
   HEAP32[i6 >> 2] = i13;
   HEAP32[i6 + 4 >> 2] = i14;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i8, i1, i7, i20);
   i6 = i4;
   i2 = i10 - i6 | 0;
   i3 = (i2 | 0) > 372;
   if ((i5 | 0) > 0 & i3) {
    i1 = i9;
    i12 = i10;
   } else {
    i8 = i4;
    i1 = i9;
    break;
   }
  }
 } else i8 = i4; while (0);
 if (i3) {
  i5 = i18;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i20;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  i2 = (i2 >>> 0) / 12 | 0;
  i3 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i20, i2, i8 + (i3 * 12 | 0) | 0);
   if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
  }
  i18 = i19;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  do {
   i1 = i1 + -12 | 0;
   HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i19, i2, i8);
  } while ((i2 | 0) > 1);
  STACKTOP = i21;
  return;
 }
 if ((i2 | 0) <= 12) {
  STACKTOP = i21;
  return;
 }
 i16 = i18;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 if (i8 >>> 0 < i1 >>> 0) {
  i2 = i8;
  do {
   L36 : do if (i2 >>> 0 > i8 >>> 0) {
    i3 = i2;
    do {
     i4 = i3;
     i3 = i3 + -12 | 0;
     if (!(__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i19, i4, i3) | 0)) break L36;
     HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    } while (i3 >>> 0 > i8 >>> 0);
   } while (0);
   i2 = i2 + 12 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 STACKTOP = i21;
 return;
}

function __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i4, i1, i5, i18) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 32 | 0;
 i19 = i21 + 8 | 0;
 i17 = i21;
 i15 = i21 + 24 | 0;
 i16 = i21 + 16 | 0;
 i7 = i1;
 i6 = i4;
 i2 = i7 - i6 | 0;
 i3 = (i2 | 0) > 372;
 L1 : do if ((i5 | 0) > 0 & i3) {
  i14 = i18;
  i13 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i7;
  while (1) {
   i11 = i1 + -12 | 0;
   while (1) {
    i10 = i17;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    i10 = ((i2 | 0) / 12 | 0) + -1 | 0;
    i2 = i19;
    HEAP32[i2 >> 2] = i13;
    HEAP32[i2 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
    __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i4, i11, i10, i20);
    i2 = -1;
    i3 = i10;
    while (1) {
     while (1) {
      i8 = i2 + 1 | 0;
      i9 = i4 + (i8 * 12 | 0) | 0;
      if ((i8 | 0) == (i10 | 0) | (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i17, i9, i11) | 0) ^ 1) break; else i2 = i8;
     }
     do {
      i3 = i3 + -1 | 0;
      i7 = i4 + (i3 * 12 | 0) | 0;
     } while (!((i3 | 0) == 0 | (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i17, i11, i7) | 0) ^ 1));
     if ((i8 | 0) >= (i3 | 0)) break;
     HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
     i2 = i8;
    }
    HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i8 = i4 + ((i2 + 2 | 0) * 12 | 0) | 0;
    i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
    i9 = i4 + (i2 * 12 | 0) + 12 | 0;
    i10 = i9;
    i3 = (i10 - i6 | 0) / 12 | 0;
    i6 = i8;
    i2 = i12 - i6 | 0;
    i7 = (i2 | 0) / 12 | 0;
    if ((i3 | 0) >= (i7 | 0)) break;
    i10 = i15;
    HEAP32[i10 >> 2] = i13;
    HEAP32[i10 + 4 >> 2] = i14;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i4, i9, i3, i20);
    i3 = (i2 | 0) > 372;
    if (!((i5 | 0) > 0 & i3)) break L1; else i4 = i8;
   }
   i6 = i16;
   HEAP32[i6 >> 2] = i13;
   HEAP32[i6 + 4 >> 2] = i14;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i8, i1, i7, i20);
   i6 = i4;
   i2 = i10 - i6 | 0;
   i3 = (i2 | 0) > 372;
   if ((i5 | 0) > 0 & i3) {
    i1 = i9;
    i12 = i10;
   } else {
    i8 = i4;
    i1 = i9;
    break;
   }
  }
 } else i8 = i4; while (0);
 if (i3) {
  i5 = i18;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i20;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  i2 = (i2 >>> 0) / 12 | 0;
  i3 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i20, i2, i8 + (i3 * 12 | 0) | 0);
   if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
  }
  i18 = i19;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i5;
  do {
   i1 = i1 + -12 | 0;
   HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i19, i2, i8);
  } while ((i2 | 0) > 1);
  STACKTOP = i21;
  return;
 }
 if ((i2 | 0) <= 12) {
  STACKTOP = i21;
  return;
 }
 i16 = i18;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 if (i8 >>> 0 < i1 >>> 0) {
  i2 = i8;
  do {
   L36 : do if (i2 >>> 0 > i8 >>> 0) {
    i3 = i2;
    do {
     i4 = i3;
     i3 = i3 + -12 | 0;
     if (!(__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i19, i4, i3) | 0)) break L36;
     HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i20 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i20 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    } while (i3 >>> 0 > i8 >>> 0);
   } while (0);
   i2 = i2 + 12 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 STACKTOP = i21;
 return;
}

function __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = i4 + 24 | 0;
 i7 = i9 + 8 | 0;
 i2 = HEAP32[i7 >> 2] & 2147483647;
 if (i1 >>> 0 > i2 >>> 0) {
  i3 = (i1 * 3 | 0) + 256 | 0;
  if (i2 >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i3);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i1);
 i5 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i8 >> 2] = i1;
 i5 = HEAP32[i6 >> 2] | 0;
 if (i5) {
  i1 = i4 + 36 | 0;
  i2 = HEAP32[i7 >> 2] & 2147483647;
  if (i1 >>> 0 > i2 >>> 0) {
   i3 = (i1 * 3 | 0) + 256 | 0;
   if (i2 >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i3);
  }
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i1);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 + i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + (i4 + 4) >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + (i4 + 8) >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 if (i4) {
  i1 = i1 + 12 | 0;
  i2 = HEAP32[i7 >> 2] & 2147483647;
  if (i1 >>> 0 > i2 >>> 0) {
   i3 = (i1 * 3 | 0) + 256 | 0;
   if (i2 >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i3);
  }
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i1);
  i3 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 + i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + (i5 + 4) >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + (i5 + 8) >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i4 = HEAP32[i6 + 16 >> 2] | 0;
 if (i4) {
  i1 = i1 + 28 | 0;
  i2 = HEAP32[i7 >> 2] & 2147483647;
  if (i1 >>> 0 > i2 >>> 0) {
   i3 = (i1 * 3 | 0) + 256 | 0;
   if (i2 >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i3);
  }
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i1);
  i3 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 + i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + (i5 + 4) >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + (i5 + 8) >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + (i5 + 12) >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + (i5 + 16) >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + (i5 + 20) >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i3 + (i5 + 24) >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i6) return;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i7 >> 2] & 2147483647;
 if (i3 >>> 0 > i4 >>> 0) {
  i5 = (i3 * 3 | 0) + 256 | 0;
  if (i4 >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i5);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
 HEAP32[(HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) >> 2] = i2;
 HEAP32[i8 >> 2] = i3;
 switch (i2 | 0) {
 case 2:
  {
   i3 = i1 + 16 | 0;
   i1 = HEAP32[i7 >> 2] & 2147483647;
   if (i3 >>> 0 > i1 >>> 0) {
    i2 = (i3 * 3 | 0) + 256 | 0;
    if (i1 >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i2);
   }
   __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
   i9 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i8 >> 2] = i3;
   return;
  }
 case 0:
  {
   i3 = i1 + 12 | 0;
   i1 = HEAP32[i7 >> 2] & 2147483647;
   if (i3 >>> 0 > i1 >>> 0) {
    i2 = (i3 * 3 | 0) + 256 | 0;
    if (i1 >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i2);
   }
   __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i9 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = i7;
   HEAP32[i8 >> 2] = i3;
   return;
  }
 case 4:
  {
   i3 = i1 + 40 | 0;
   i1 = HEAP32[i7 >> 2] & 2147483647;
   if (i3 >>> 0 > i1 >>> 0) {
    i2 = (i3 * 3 | 0) + 256 | 0;
    if (i1 >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i2);
   }
   __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i7 + i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + (i9 + 4) >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + (i9 + 8) >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + (i9 + 12) >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i7 + (i9 + 16) >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i7 + (i9 + 20) >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i7 + (i9 + 24) >> 2] = HEAP32[i6 + 24 >> 2];
   HEAP32[i7 + (i9 + 28) >> 2] = HEAP32[i6 + 28 >> 2];
   HEAP32[i7 + (i9 + 32) >> 2] = HEAP32[i6 + 32 >> 2];
   HEAP32[i8 >> 2] = i3;
   return;
  }
 case 3:
  {
   i3 = i1 + 20 | 0;
   i1 = HEAP32[i7 >> 2] & 2147483647;
   if (i3 >>> 0 > i1 >>> 0) {
    i2 = (i3 * 3 | 0) + 256 | 0;
    if (i1 >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i2);
   }
   __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i7 + i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + (i9 + 4) >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + (i9 + 8) >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + (i9 + 12) >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i8 >> 2] = i3;
   return;
  }
 default:
  return;
 }
}

function __ZN23b2EdgeAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i4, i11, i12, i13) {
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 i15 = HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i9 = (HEAP32[i7 + 176 >> 2] | 0) == 0;
 i8 = i7 + 12 | 0;
 i10 = i7 + 20 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i10 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i10 + 4 >> 2]));
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3))));
 if (f2 < Math_fround(1.1920929e-07)) {
  f18 = f1;
  f17 = f3;
 } else {
  f17 = Math_fround(Math_fround(1.0) / f2);
  f18 = Math_fround(f1 * f17);
  f17 = Math_fround(f3 * f17);
 }
 do if (i9) i6 = i11 + 60 | 0; else {
  __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_(i11, i15, i12, i7 + 28 | 0, i13);
  i6 = i11 + 60 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = HEAP32[i11 + 40 >> 2] | 0;
   i4 = HEAP32[i11 + 44 >> 2] | 0;
   if ((HEAP32[i11 + 56 >> 2] | 0) == 1) {
    f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
    f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f21 * f20);
    f3 = Math_fround(HEAPF32[i12 + 8 >> 2]);
    f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f1 = Math_fround(f1 - Math_fround(f2 * f3));
    f3 = Math_fround(Math_fround(f2 * f20) + Math_fround(f21 * f3));
    f21 = Math_fround(HEAPF32[i13 + 12 >> 2]);
    f20 = Math_fround(f21 * f1);
    f2 = Math_fround(HEAPF32[i13 + 8 >> 2]);
    f20 = Math_fround(f20 + Math_fround(f2 * f3));
    f2 = Math_fround(Math_fround(f21 * f3) - Math_fround(f1 * f2));
    f1 = Math_fround(-f20);
    f3 = Math_fround(-f2);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(f2 * f2))));
    if (f2 < Math_fround(1.1920929e-07)) i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0); else {
     f21 = Math_fround(Math_fround(1.0) / f2);
     f20 = Math_fround(f21 * f1);
     i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
     f21 = Math_fround(f21 * f3);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
    }
   }
   f21 = Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f21 = Math_fround(Math_fround(f18 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) - f21);
   if (!(f21 >= Math_fround(.99999988) | f21 <= Math_fround(-.99999988))) {
    HEAP32[i6 >> 2] = 0;
    break;
   }
   HEAP32[i11 + 68 >> 2] = HEAP32[gb + 151644 >> 2];
   STACKTOP = i19;
   return;
  }
 } while (0);
 HEAP32[i14 >> 2] = gb + 151824 + 8;
 i4 = i14 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i4 = i14 + 12 | 0;
 i5 = i8;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_(i11, i15, i12, i14, i13);
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  if (!i9) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i11 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i11 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(f18 * f2) + Math_fround(f17 * f1)) >= Math_fround(0.0))) {
    HEAP32[i6 >> 2] = 0;
    i16 = 18;
   }
  }
 } else i16 = 18;
 if ((i16 | 0) == 18) if (!i9) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i16 = i4;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = i10;
  __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_(i11, i15, i12, i14, i13);
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i11 + 40 >> 2]);
   f2 = Math_fround(f20 * f3);
   f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i11 + 44 >> 2]);
   f2 = Math_fround(f2 - Math_fround(f21 * f1));
   f1 = Math_fround(Math_fround(f3 * f21) + Math_fround(f20 * f1));
   f20 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   f21 = Math_fround(f20 * f2);
   f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f3 * f1));
   f3 = Math_fround(Math_fround(f20 * f1) - Math_fround(f2 * f3));
   f2 = Math_fround(-f21);
   f1 = Math_fround(-f3);
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f3 * f3))));
   if (!(f3 < Math_fround(1.1920929e-07))) {
    f21 = Math_fround(Math_fround(1.0) / f3);
    f2 = Math_fround(f21 * f2);
    f1 = Math_fround(f21 * f1);
   }
   if (!(Math_fround(Math_fround(-Math_fround(f17 * f1)) - Math_fround(f18 * f2)) >= Math_fround(0.0))) HEAP32[i6 >> 2] = 0;
  }
 }
 STACKTOP = i19;
 return;
}

function __Z19UpdateProceduralTplILb1EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E(i10, i1, i19, i20) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 32 | 0;
 i22 = i25 + 16 | 0;
 i23 = i25;
 i24 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i24) {
  STACKTOP = i25;
  return;
 }
 i11 = i1 + 520 | 0;
 i12 = i23 + 4 | 0;
 i13 = i23 + 8 | 0;
 i14 = i23 + 12 | 0;
 i15 = i1 + 500 | 0;
 i16 = i20 + 4 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20 + 12 | 0;
 i2 = i1 + 540 | 0;
 i3 = i10 + 40 | 0;
 i4 = i22 + 4 | 0;
 i5 = i21 + 4 | 0;
 i6 = i22 + 8 | 0;
 i7 = i21 + 8 | 0;
 i8 = i22 + 12 | 0;
 i9 = i21 + 12 | 0;
 i1 = 0;
 do {
  i44 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f31 = Math_fround(HEAPF32[i44 >> 2]);
  f29 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  f29 = Math_fround(f29 * Math_fround(.00999999977));
  f46 = Math_fround(f46 * Math_fround(.00999999977));
  f48 = Math_fround(Math_fround(HEAPF32[i44 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i23 >> 2] = Math_fround(f31 * Math_fround(.00999999977));
  HEAPF32[i12 >> 2] = f29;
  HEAPF32[i13 >> 2] = f46;
  HEAPF32[i14 >> 2] = f48;
  i44 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  i26 = HEAP32[i44 >> 2] | 0;
  i30 = HEAP32[i44 + 4 >> 2] | 0;
  i37 = HEAP32[i44 + 8 >> 2] | 0;
  i44 = HEAP32[i44 + 12 >> 2] | 0;
  i53 = i26 + 1793934638 | 0;
  i51 = i30 + 1793934638 | 0;
  i45 = i37 + 1793934638 | 0;
  i32 = i44 + 1793934638 | 0;
  i52 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
  i50 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i28 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i53 = i53 << 11 ^ i53;
  i51 = i51 << 11 ^ i51;
  i45 = i45 << 11 ^ i45;
  i32 = i32 << 11 ^ i32;
  f48 = Math_fround(Math_fround((i52 ^ i53 ^ i53 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f46 = Math_fround(Math_fround((i50 ^ i51 ^ i51 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f29 = Math_fround(Math_fround((i43 ^ i45 ^ i45 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f31 = Math_fround(Math_fround((i28 ^ i32 ^ i32 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i26 = i26 + -13913692 | 0;
  i30 = i30 + -13913692 | 0;
  i37 = i37 + -13913692 | 0;
  i44 = i44 + -13913692 | 0;
  i28 = (Math_imul(i26, 1790253981) | 0) + 1900727103 | 0;
  i32 = (Math_imul(i30, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i37, 1790253981) | 0) + 1900727103 | 0;
  i45 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
  i26 = i26 << 11 ^ i26;
  i30 = i30 << 11 ^ i30;
  i37 = i37 << 11 ^ i37;
  i44 = i44 << 11 ^ i44;
  f38 = Math_fround(Math_fround((i28 ^ i26 ^ i26 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f40 = Math_fround(Math_fround((i32 ^ i30 ^ i30 >>> 8) & 8388607 ^ i32 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i43 ^ i37 ^ i37 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i45 ^ i44 ^ i44 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i45 = f38 > Math_fround(HEAPF32[i20 >> 2]);
  i44 = f40 > Math_fround(HEAPF32[i16 >> 2]);
  i43 = f42 > Math_fround(HEAPF32[i17 >> 2]);
  i37 = f35 > Math_fround(HEAPF32[i18 >> 2]);
  i32 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  f35 = Math_fround(HEAPF32[i32 >> 2]);
  f42 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i32 + 8 >> 2]);
  f35 = Math_fround(Math_fround(1.0) / f35);
  f42 = Math_fround(Math_fround(1.0) / f42);
  f40 = Math_fround(Math_fround(1.0) / f40);
  f38 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i32 + 12 >> 2]));
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i21, i3, i23);
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i22, i10, i23);
  f34 = Math_fround(HEAPF32[i22 >> 2]);
  f49 = Math_fround(HEAPF32[i21 >> 2]);
  f34 = Math_fround(f34 - f49);
  f41 = Math_fround(HEAPF32[i4 >> 2]);
  f47 = Math_fround(HEAPF32[i5 >> 2]);
  f41 = Math_fround(f41 - f47);
  f39 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(HEAPF32[i7 >> 2]);
  f39 = Math_fround(f39 - f27);
  f33 = Math_fround(HEAPF32[i8 >> 2]);
  f36 = Math_fround(HEAPF32[i9 >> 2]);
  f34 = Math_fround(f49 + Math_fround(f48 * f34));
  f41 = Math_fround(f47 + Math_fround(f46 * f41));
  f39 = Math_fround(f27 + Math_fround(f29 * f39));
  f36 = Math_fround(f36 + Math_fround(f31 * Math_fround(f33 - f36)));
  i32 = i19 + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i32 >> 2]);
  i30 = i32 + 4 | 0;
  f31 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i32 + 8 | 0;
  f29 = Math_fround(HEAPF32[i28 >> 2]);
  i26 = i32 + 12 | 0;
  f27 = Math_fround(HEAPF32[i26 >> 2]);
  f34 = Math_fround((i45 ? Math_fround(1.0) : Math_fround(-1.0)) * f34);
  f41 = Math_fround((i44 ? Math_fround(1.0) : Math_fround(-1.0)) * f41);
  f39 = Math_fround((i43 ? Math_fround(1.0) : Math_fround(-1.0)) * f39);
  f31 = Math_fround(Math_fround(f42 * f41) + f31);
  f29 = Math_fround(Math_fround(f40 * f39) + f29);
  f27 = Math_fround(Math_fround(f38 * Math_fround((i37 ? Math_fround(1.0) : Math_fround(-1.0)) * f36)) + f27);
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(f35 * f34) + f33);
  HEAPF32[i30 >> 2] = f31;
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i26 >> 2] = f27;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i24 >>> 0);
 STACKTOP = i25;
 return;
}

function __Z19UpdateProceduralTplILb0EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E(i2, i1, i19, i20) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, i43 = 0, i44 = 0, i45 = 0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, i51 = 0, i52 = 0, i53 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 32 | 0;
 i22 = i25 + 16 | 0;
 i23 = i25;
 i24 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i24) {
  STACKTOP = i25;
  return;
 }
 i11 = i1 + 520 | 0;
 i12 = i23 + 4 | 0;
 i13 = i23 + 8 | 0;
 i14 = i23 + 12 | 0;
 i15 = i1 + 500 | 0;
 i16 = i20 + 4 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20 + 12 | 0;
 i9 = i1 + 540 | 0;
 i10 = i2 + 308 | 0;
 i2 = i2 + 80 | 0;
 i3 = i22 + 4 | 0;
 i4 = i21 + 4 | 0;
 i5 = i22 + 8 | 0;
 i6 = i21 + 8 | 0;
 i7 = i22 + 12 | 0;
 i8 = i21 + 12 | 0;
 i1 = 0;
 do {
  i44 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
  f31 = Math_fround(HEAPF32[i44 >> 2]);
  f29 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f46 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  f29 = Math_fround(f29 * Math_fround(.00999999977));
  f46 = Math_fround(f46 * Math_fround(.00999999977));
  f48 = Math_fround(Math_fround(HEAPF32[i44 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i23 >> 2] = Math_fround(f31 * Math_fround(.00999999977));
  HEAPF32[i12 >> 2] = f29;
  HEAPF32[i13 >> 2] = f46;
  HEAPF32[i14 >> 2] = f48;
  i44 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
  i26 = HEAP32[i44 >> 2] | 0;
  i30 = HEAP32[i44 + 4 >> 2] | 0;
  i37 = HEAP32[i44 + 8 >> 2] | 0;
  i44 = HEAP32[i44 + 12 >> 2] | 0;
  i53 = i26 + 1793934638 | 0;
  i51 = i30 + 1793934638 | 0;
  i45 = i37 + 1793934638 | 0;
  i32 = i44 + 1793934638 | 0;
  i52 = (Math_imul(i53, 1790253981) | 0) + 1900727103 | 0;
  i50 = (Math_imul(i51, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i45, 1790253981) | 0) + 1900727103 | 0;
  i28 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i53 = i53 << 11 ^ i53;
  i51 = i51 << 11 ^ i51;
  i45 = i45 << 11 ^ i45;
  i32 = i32 << 11 ^ i32;
  f48 = Math_fround(Math_fround((i52 ^ i53 ^ i53 >>> 8) & 8388607 ^ i52 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f46 = Math_fround(Math_fround((i50 ^ i51 ^ i51 >>> 8) & 8388607 ^ i50 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f29 = Math_fround(Math_fround((i43 ^ i45 ^ i45 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f31 = Math_fround(Math_fround((i28 ^ i32 ^ i32 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i26 = i26 + -13913692 | 0;
  i30 = i30 + -13913692 | 0;
  i37 = i37 + -13913692 | 0;
  i44 = i44 + -13913692 | 0;
  i28 = (Math_imul(i26, 1790253981) | 0) + 1900727103 | 0;
  i32 = (Math_imul(i30, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i37, 1790253981) | 0) + 1900727103 | 0;
  i45 = (Math_imul(i44, 1790253981) | 0) + 1900727103 | 0;
  i26 = i26 << 11 ^ i26;
  i30 = i30 << 11 ^ i30;
  i37 = i37 << 11 ^ i37;
  i44 = i44 << 11 ^ i44;
  f38 = Math_fround(Math_fround((i28 ^ i26 ^ i26 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f40 = Math_fround(Math_fround((i32 ^ i30 ^ i30 >>> 8) & 8388607 ^ i32 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i43 ^ i37 ^ i37 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i45 ^ i44 ^ i44 >>> 8) & 8388607 ^ i45 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i45 = f38 > Math_fround(HEAPF32[i20 >> 2]);
  i44 = f40 > Math_fround(HEAPF32[i16 >> 2]);
  i43 = f42 > Math_fround(HEAPF32[i17 >> 2]);
  i37 = f35 > Math_fround(HEAPF32[i18 >> 2]);
  i32 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f35 = Math_fround(HEAPF32[i32 >> 2]);
  f42 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f40 = Math_fround(HEAPF32[i32 + 8 >> 2]);
  f35 = Math_fround(Math_fround(1.0) / f35);
  f42 = Math_fround(Math_fround(1.0) / f42);
  f40 = Math_fround(Math_fround(1.0) / f40);
  f38 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i32 + 12 >> 2]));
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i21, i10, i23);
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i22, i2, i23);
  f34 = Math_fround(HEAPF32[i22 >> 2]);
  f49 = Math_fround(HEAPF32[i21 >> 2]);
  f34 = Math_fround(f34 - f49);
  f41 = Math_fround(HEAPF32[i3 >> 2]);
  f47 = Math_fround(HEAPF32[i4 >> 2]);
  f41 = Math_fround(f41 - f47);
  f39 = Math_fround(HEAPF32[i5 >> 2]);
  f27 = Math_fround(HEAPF32[i6 >> 2]);
  f39 = Math_fround(f39 - f27);
  f33 = Math_fround(HEAPF32[i7 >> 2]);
  f36 = Math_fround(HEAPF32[i8 >> 2]);
  f34 = Math_fround(f49 + Math_fround(f48 * f34));
  f41 = Math_fround(f47 + Math_fround(f46 * f41));
  f39 = Math_fround(f27 + Math_fround(f29 * f39));
  f36 = Math_fround(f36 + Math_fround(f31 * Math_fround(f33 - f36)));
  i32 = i19 + (i1 << 2) | 0;
  f33 = Math_fround(HEAPF32[i32 >> 2]);
  i30 = i32 + 4 | 0;
  f31 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i32 + 8 | 0;
  f29 = Math_fround(HEAPF32[i28 >> 2]);
  i26 = i32 + 12 | 0;
  f27 = Math_fround(HEAPF32[i26 >> 2]);
  f34 = Math_fround((i45 ? Math_fround(1.0) : Math_fround(-1.0)) * f34);
  f41 = Math_fround((i44 ? Math_fround(1.0) : Math_fround(-1.0)) * f41);
  f39 = Math_fround((i43 ? Math_fround(1.0) : Math_fround(-1.0)) * f39);
  f31 = Math_fround(Math_fround(f42 * f41) + f31);
  f29 = Math_fround(Math_fround(f40 * f39) + f29);
  f27 = Math_fround(Math_fround(f38 * Math_fround((i37 ? Math_fround(1.0) : Math_fround(-1.0)) * f36)) + f27);
  HEAPF32[i32 >> 2] = Math_fround(Math_fround(f35 * f34) + f33);
  HEAPF32[i30 >> 2] = f31;
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i26 >> 2] = f27;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i24 >>> 0);
 STACKTOP = i25;
 return;
}

function __ZN9Texture3D11InitTextureEiii13TextureFormatb(i16, i10, i11, i12, i8, i6) {
 i16 = i16 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 64 | 0;
 i15 = i19 + 48 | 0;
 i5 = i19 + 32 | 0;
 i4 = i19 + 24 | 0;
 i3 = i19 + 16 | 0;
 i1 = i19;
 i17 = i19 + 60 | 0;
 if (!(i10 + -1 & i10)) if (!(i11 + -1 & i11)) if (!(i12 + -1 & i12)) {
  i1 = (i8 + -10 | 0) >>> 0 < 3;
  L5 : do if (!((i8 + -1 | 0) >>> 0 < 23 | i1)) {
   i2 = i8 | 1;
   switch (i2 | 0) {
   case 25:
   case 27:
    break L5;
   default:
    {}
   }
   if ((i8 + -48 | 0) >>> 0 >= 12) {
    switch (i8 | 0) {
    case 28:
    case 29:
    case 30:
    case 31:
    case 32:
    case 33:
    case 34:
    case 35:
    case 36:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
    case 47:
     break L5;
    default:
     {}
    }
    if ((i2 | 0) != 61) {
     HEAP32[i3 >> 2] = i8;
     __Z6FormatPKcz(i18, gb + 418621 | 0, i3);
     if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 411375 | 0, 85, 1, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
     i18 = 0;
     STACKTOP = i19;
     return i18 | 0;
    }
   }
  } while (0);
  do if (!i1) if (((i8 | 1) + -25 | 0) >>> 0 >= 5) {
   i1 = i8 + -30 | 0;
   if (i1 >>> 0 < 15) {
    if ((i8 + -48 | 0) >>> 0 < 12 | ((i8 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
   } else if ((i8 + -45 | 0) >>> 0 < 3 | (i8 + -48 | 0) >>> 0 < 12) break;
   if (i12 >>> 0 > 2048 | (i10 >>> 0 > 2048 | i11 >>> 0 > 2048)) {
    HEAP32[i5 >> 2] = i10;
    HEAP32[i5 + 4 >> 2] = i11;
    HEAP32[i5 + 8 >> 2] = i12;
    HEAP32[i5 + 12 >> 2] = 2048;
    __Z6FormatPKcz(i18, gb + 418721 | 0, i5);
    if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 411375 | 0, 97, 1, i1, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    i18 = 0;
    STACKTOP = i19;
    return i18 | 0;
   }
   i13 = i16 + 80 | 0;
   HEAP32[i13 >> 2] = i10;
   i14 = i16 + 84 | 0;
   HEAP32[i14 >> 2] = i11;
   HEAP32[i16 + 88 >> 2] = i12;
   i7 = i16 + 92 | 0;
   HEAP32[i7 >> 2] = i8;
   if (i6) {
    i1 = __Z22CalculateMipMapCount3Diii(i10, i11, i12) | 0;
    HEAP32[i16 + 76 >> 2] = i1;
    if ((i1 | 0) > 0) {
     i5 = i16;
     i9 = 30;
    } else {
     i6 = 0;
     i5 = i16;
    }
   } else {
    HEAP32[i16 + 76 >> 2] = 1;
    i5 = i16;
    i1 = 1;
    i9 = 30;
   }
   if ((i9 | 0) == 30) {
    i3 = HEAP32[gb + 45784 + (i8 << 2) >> 2] | 0;
    i2 = 0;
    i6 = 0;
    i4 = 0;
    do {
     i20 = i10 >> i2;
     i8 = i11 >> i2;
     i9 = i12 >> i2;
     i9 = Math_imul(Math_imul(Math_imul((i20 | 0) < 1 ? 1 : i20, i3) | 0, (i8 | 0) < 1 ? 1 : i8) | 0, (i9 | 0) < 1 ? 1 : i9) | 0;
     i6 = _i64Add(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, i6 | 0, i4 | 0) | 0;
     i4 = getTempRet0() | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
    if (i4 >>> 0 > 0 | (i4 | 0) == 0 & i6 >>> 0 > 2147483647) {
     HEAP32[i15 >> 2] = i10;
     HEAP32[i15 + 4 >> 2] = i11;
     HEAP32[i15 + 8 >> 2] = i12;
     __Z6FormatPKcz(i18, gb + 418798 | 0, i15);
     if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 411375 | 0, 111, 1, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
     i20 = 0;
     STACKTOP = i19;
     return i20 | 0;
    }
   }
   i1 = (HEAP32[gb + 45784 + (HEAP32[i7 >> 2] << 2) >> 2] | 0) + i6 | 0;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
   if (!i4) {
    i20 = 0;
    STACKTOP = i19;
    return i20 | 0;
   }
   _memset(i4 | 0, -51, i1 | 0) | 0;
   i1 = i16 + 96 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63272 | 0);
   HEAP32[i1 >> 2] = 0;
   i2 = i16 + 100 | 0;
   HEAP32[i2 >> 2] = 0;
   i3 = i16 + 104 | 0;
   if (HEAP8[i3 >> 0] | 0) {
    i20 = __Z12GetGfxDevicev() | 0;
    i15 = HEAP32[(HEAP32[i20 >> 2] | 0) + 452 >> 2] | 0;
    HEAP32[i17 >> 2] = HEAP32[i16 + 48 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
    mftCall_vii(i15 | 0, i20 | 0, i18 | 0);
    HEAP8[i3 >> 0] = 0;
   }
   HEAP32[i1 >> 2] = i4;
   HEAP32[i2 >> 2] = i6;
   f22 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i13 >> 2] | 0));
   f21 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i14 >> 2] | 0));
   HEAPF32[i5 + 68 >> 2] = f22;
   HEAPF32[i5 + 72 >> 2] = f21;
   i20 = 1;
   STACKTOP = i19;
   return i20 | 0;
  } while (0);
  HEAP32[i4 >> 2] = i8;
  __Z6FormatPKcz(i18, gb + 418663 | 0, i4);
  if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 411375 | 0, 90, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i20 = 0;
  STACKTOP = i19;
  return i20 | 0;
 }
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i11;
 HEAP32[i1 + 8 >> 2] = i12;
 __Z6FormatPKcz(i18, gb + 418574 | 0, i1);
 if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 411375 | 0, 80, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 i20 = 0;
 STACKTOP = i19;
 return i20 | 0;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j(i15, i11) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 40 | 0;
 i12 = i18 + 36 | 0;
 i17 = i18 + 24 | 0;
 i6 = i18 + 12 | 0;
 i9 = i18 + 20 | 0;
 i10 = i18 + 16 | 0;
 i14 = i18;
 i16 = i15 + 4 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 28 | 0;
 i4 = i1;
 if (i3 >>> 0 >= i11 >>> 0) {
  if (i3 >>> 0 <= i11 >>> 0) {
   STACKTOP = i18;
   return;
  }
  i5 = i4 + (i11 * 28 | 0) | 0;
  HEAP32[i14 >> 2] = 0;
  i9 = i14 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  i3 = i11 * 28 | 0;
  i4 = (i3 | 0) / 28 | 0;
  if (!i3) {
   i5 = i14;
   i6 = i9;
   i7 = i14 + 8 | 0;
   i8 = 0;
   i4 = 0;
   i3 = 0;
  } else {
   if (i4 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
   i7 = __Znwj(i3) | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i14 >> 2] = i7;
   i8 = i14 + 8 | 0;
   HEAP32[i8 >> 2] = i7 + (i4 * 28 | 0);
   HEAP32[i17 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
   __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i14, i12, i13, i4);
   i5 = i14;
   i6 = i9;
   i7 = i8;
   i8 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i15 >> 2] = i4;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i16 >> 2] = i3;
  i5 = i15 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i8;
  i5 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    do {
     i4 = i2 + -28 | 0;
     HEAP32[i9 >> 2] = i4;
     __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + -16 | 0, HEAP32[i2 + -12 >> 2] | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) {
      i3 = i2 + -24 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) {
       do {
        i17 = i2 + -872 | 0;
        HEAP32[i3 >> 2] = i17;
        __ZN9ShaderLab14SerializedPassD2Ev(i17);
        i2 = HEAP32[i3 >> 2] | 0;
       } while ((i2 | 0) != (i1 | 0));
       i1 = HEAP32[i4 >> 2] | 0;
      }
      __ZdlPv(i1);
     }
     i2 = HEAP32[i9 >> 2] | 0;
    } while ((i2 | 0) != (i5 | 0));
    i1 = HEAP32[i14 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i18;
  return;
 }
 i7 = i15 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 28 | 0 | 0) == (i11 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6resizeEj(i15, i11);
  STACKTOP = i18;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 i14 = i17 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i3 = i17 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i8 = i17 + 8 | 0;
 if (i11) {
  HEAP32[i13 + 16 >> 2] = i3;
  i1 = __Znwj(i11 * 28 | 0) | 0;
  HEAP32[i13 >> 2] = i1;
  i5 = i13 + 8 | 0;
  HEAP32[i5 >> 2] = i1;
  i6 = i13 + 4 | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i13 + 12 >> 2] = i1 + (i11 * 28 | 0);
  __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i17, i13);
  i6 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i3 = i1 + -28 | 0;
   HEAP32[i5 >> 2] = i3;
   __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + -16 | 0, HEAP32[i1 + -12 >> 2] | 0);
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) {
    i2 = i1 + -24 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
     do {
      i19 = i1 + -872 | 0;
      HEAP32[i2 >> 2] = i19;
      __ZN9ShaderLab14SerializedPassD2Ev(i19);
      i1 = HEAP32[i2 >> 2] | 0;
     } while ((i1 | 0) != (i4 | 0));
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZdlPv(i1);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i6 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i17, i12, i13);
 __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6resizeEj(i17, i11);
 i5 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i15 >> 2] = i5;
 i5 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i16 >> 2] = i5;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   do {
    i4 = i2 + -28 | 0;
    HEAP32[i14 >> 2] = i4;
    __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + -16 | 0, HEAP32[i2 + -12 >> 2] | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     i3 = i2 + -24 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) != (i1 | 0)) {
      do {
       i19 = i2 + -872 | 0;
       HEAP32[i3 >> 2] = i19;
       __ZN9ShaderLab14SerializedPassD2Ev(i19);
       i2 = HEAP32[i3 >> 2] | 0;
      } while ((i2 | 0) != (i1 | 0));
      i1 = HEAP32[i4 >> 2] | 0;
     }
     __ZdlPv(i1);
    }
    i2 = HEAP32[i14 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
   i1 = HEAP32[i17 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i18;
 return;
}

function __Z43ParticleSystemRenderer_RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i24, i25, i27) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, d33 = 0.0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i32 + 8 | 0;
 i1 = i32;
 i7 = i32 + 28 | 0;
 if ((HEAP16[gb + 1452260 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452260 | 0, i23);
  i28 = gb + 1452260 | 0;
 } else i28 = 0;
 d33 = +_emscripten_get_now() * 1.0e6;
 i30 = ~~d33 >>> 0;
 i31 = +Math_abs(d33) >= 1.0 ? (d33 > 0.0 ? ~~+Math_min(+Math_floor(d33 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d33 - +(~~d33 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i29 = __Z12GetGfxDevicev() | 0;
 i26 = __ZN9GfxDevice13GetDynamicVBOEv(i29) | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i23, i1);
 i2 = i23;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i22 = i6;
 HEAP32[i22 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i22 + 4 >> 2] = i1;
 i22 = i25 + 4 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i2 = i1 << 1;
 if (i2 | 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 40 | 0, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
 }
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = -1;
 HEAP32[i23 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 104 >> 2] | 0, i29 | 0, gb + 1162292 | 0, 0);
 if (!(HEAP32[i22 >> 2] | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  i3 = 0;
  i2 = 0;
  do {
   i21 = __Z34ParticleSystemRenderer_RenderTrailRK15RenderNodeQueueRK17BatchInstanceDataR21DynamicVBOChunkHandleR13dynamic_arrayIN10DynamicVBO10DrawParamsELj4EER9GfxDevice(i24, (HEAP32[i25 >> 2] | 0) + (i3 << 3) | 0, i23, i7, i29) | 0;
   i1 = ((i21 | 0) != 0 & 1) + i1 | 0;
   i2 = i21 + i2 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i4 >> 2] | 0) {
  i19 = HEAP32[(HEAP32[i26 >> 2] | 0) + 16 >> 2] | 0;
  i21 = HEAP32[gb + 1452272 + 4 >> 2] | 0;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i21 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i21, HEAP32[i27 >> 2] | 0, 0) | 0;
  mftCall_viiiiiii(i19 | 0, i26 | 0, i23 | 0, i27 | 0, i20 | 0, i21 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
  HEAP32[i7 >> 2] = 0;
 }
 if (!(HEAP32[i22 >> 2] | 0)) i3 = 0; else {
  i18 = i23 + 4 | 0;
  i19 = i23 + 8 | 0;
  i20 = i23 + 12 | 0;
  i21 = i23 + 16 | 0;
  i3 = 0;
  i17 = 0;
  do {
   i4 = HEAP32[i25 >> 2] | 0;
   if ((HEAP32[i4 + (i17 << 3) + 4 >> 2] | 0) != 1) {
    i4 = HEAP32[i4 + (i17 << 3) >> 2] | 0;
    i5 = HEAP32[i24 >> 2] | 0;
    i15 = HEAP32[i5 + (i4 * 360 | 0) + 328 >> 2] | 0;
    if (HEAP32[i15 + 88 >> 2] | 0) {
     if ((HEAP16[gb + 1452248 + 6 >> 1] | 0) > -1) {
      __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1452248 | 0, HEAP32[i5 + (i4 * 360 | 0) + 352 >> 2] | 0);
      i16 = gb + 1452248 | 0;
     } else i16 = 0;
     mftCall_viii(HEAP32[(HEAP32[i29 >> 2] | 0) + 104 >> 2] | 0, i29 | 0, i15 + 92 | 0, (HEAP8[i15 + 480 >> 0] | 0 ? 4 : 0) | 0);
     i4 = HEAP32[i5 + (i4 * 360 | 0) + 188 >> 2] | 0;
     if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 188 >> 2] | 0, i29 | 0, i4 | 0);
     i13 = HEAP32[i15 + 472 >> 2] | 0;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i13 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i13, HEAP32[i27 >> 2] | 0, 0) | 0;
     i14 = i15 + 158 | 0;
     i5 = HEAP16[i14 >> 1] | 0;
     if (!(i5 << 16 >> 16)) {
      i6 = 0;
      i4 = 0;
      i5 = i5 & 65535;
     } else {
      i8 = i15 + 476 | 0;
      i9 = i15 + 80 | 0;
      i10 = i15 + 84 | 0;
      i11 = i15 + 64 | 0;
      i7 = 0;
      i6 = 0;
      i4 = 0;
      do {
       i34 = i15 + 196 + (i7 << 2) | 0;
       i36 = (HEAP32[i34 >> 2] | 0) - i4 | 0;
       i5 = i15 + 228 + (i7 << 2) | 0;
       i35 = (HEAP32[i5 >> 2] | 0) - i6 | 0;
       i38 = HEAP32[i8 >> 2] | 0;
       i37 = (HEAP32[i9 >> 2] | 0) + (Math_imul(i38, i4) | 0) | 0;
       i4 = (HEAP32[i10 >> 2] | 0) + (i6 << 1) | 0;
       HEAP32[i23 >> 2] = i38;
       HEAP32[i18 >> 2] = i37;
       HEAP32[i19 >> 2] = i36;
       HEAP32[i20 >> 2] = i4;
       HEAP32[i21 >> 2] = i35;
       mftCall_viiiiiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 16 >> 2] | 0, i26 | 0, i11 | 0, i27 | 0, i12 | 0, i13 | 0, i23 | 0, 1);
       __Z15gpu_time_samplev();
       i4 = HEAP32[i34 >> 2] | 0;
       i6 = HEAP32[i5 >> 2] | 0;
       i7 = i7 + 1 | 0;
       i5 = HEAPU16[i14 >> 1] | 0;
      } while ((i7 | 0) < (i5 | 0));
     }
     i2 = i4 + i2 | 0;
     i3 = i6 + i3 | 0;
     i1 = i5 + i1 | 0;
     if (i16) __Z12profiler_endP19ProfilerInformation(i16);
    }
   }
   i17 = i17 + 1 | 0;
  } while (i17 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
 }
 if ((i1 | 0) > 0) {
  i37 = HEAP32[(HEAP32[i29 >> 2] | 0) + 268 >> 2] | 0;
  d33 = +_emscripten_get_now() * 1.0e6;
  i38 = _i64Subtract(~~d33 >>> 0 | 0, (+Math_abs(d33) >= 1.0 ? (d33 > 0.0 ? ~~+Math_min(+Math_floor(d33 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d33 - +(~~d33 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i30 | 0, i31 | 0) | 0;
  mftCall_viiiiiii(i37 | 0, i29 | 0, 1, (i3 | 0) / 3 | 0 | 0, i2 | 0, i1 | 0, i38 | 0, getTempRet0() | 0);
 }
 if (!i28) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i28);
 STACKTOP = i32;
 return;
}

function __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 96 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 104 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 108 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 112 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 116 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 120 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 124 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 128 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 140 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 144 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 148 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 152 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 156 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i3;
 }
 i1 = i6 + 160 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 164 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 168 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 172 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 176 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __Z17CalculateGlobalRS23TransformAccessReadOnly(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i19 = HEAP32[i1 >> 2] | 0;
 i21 = HEAP32[i19 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 12 >> 2]);
 f25 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 20 >> 2]);
 f10 = Math_fround(f26 * Math_fround(-2.0));
 f23 = Math_fround(f26 * Math_fround(2.0));
 f24 = Math_fround(f26 * f10);
 f8 = Math_fround(f2 * Math_fround(-2.0));
 f7 = Math_fround(f2 * Math_fround(2.0));
 f5 = Math_fround(f2 * f8);
 f6 = Math_fround(Math_fround(f24 + f5) + Math_fround(1.0));
 f9 = Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(f25 * f7)) + Math_fround(0.0));
 f10 = Math_fround(Math_fround(Math_fround(f10 * f25) + Math_fround(f22 * f7)) + Math_fround(0.0));
 i11 = i20 + 4 | 0;
 i12 = i20 + 8 | 0;
 f4 = Math_fround(f22 * Math_fround(2.0));
 f3 = Math_fround(f22 * Math_fround(-2.0));
 f22 = Math_fround(f22 * f3);
 f8 = Math_fround(Math_fround(Math_fround(f26 * f4) + Math_fround(f25 * f8)) + Math_fround(0.0));
 f5 = Math_fround(Math_fround(f22 + f5) + Math_fround(1.0));
 f7 = Math_fround(Math_fround(Math_fround(f25 * f4) + Math_fround(f26 * f7)) + Math_fround(0.0));
 i13 = i20 + 12 | 0;
 i14 = i20 + 16 | 0;
 i15 = i20 + 20 | 0;
 f4 = Math_fround(Math_fround(Math_fround(f23 * f25) + Math_fround(f4 * f2)) + Math_fround(0.0));
 f2 = Math_fround(Math_fround(Math_fround(f25 * f3) + Math_fround(f23 * f2)) + Math_fround(0.0));
 f22 = Math_fround(Math_fround(f24 + f22) + Math_fround(1.0));
 i16 = i20 + 24 | 0;
 i17 = i20 + 28 | 0;
 i18 = i20 + 32 | 0;
 f24 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 28 >> 2]);
 f23 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 36 >> 2]);
 f6 = Math_fround(f24 * f6);
 f9 = Math_fround(f24 * f9);
 f10 = Math_fround(f24 * f10);
 f8 = Math_fround(f23 * f8);
 f5 = Math_fround(f23 * f5);
 f7 = Math_fround(f23 * f7);
 f4 = Math_fround(f3 * f4);
 f2 = Math_fround(f3 * f2);
 f3 = Math_fround(f22 * f3);
 HEAPF32[i20 >> 2] = f6;
 HEAPF32[i11 >> 2] = f9;
 HEAPF32[i12 >> 2] = f10;
 HEAPF32[i13 >> 2] = f8;
 HEAPF32[i14 >> 2] = f5;
 HEAPF32[i15 >> 2] = f7;
 HEAPF32[i16 >> 2] = f4;
 HEAPF32[i17 >> 2] = f2;
 HEAPF32[i18 >> 2] = f3;
 i19 = HEAP32[i19 + 12 >> 2] | 0;
 i1 = HEAP32[i19 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 do {
  f35 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 12 >> 2]);
  f34 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 24 >> 2]);
  f27 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 20 >> 2]);
  f22 = Math_fround(f35 * Math_fround(-2.0));
  f32 = Math_fround(f35 * Math_fround(2.0));
  f33 = Math_fround(f35 * f22);
  f30 = Math_fround(f27 * Math_fround(-2.0));
  f24 = Math_fround(f27 * Math_fround(2.0));
  f28 = Math_fround(f27 * f30);
  f31 = Math_fround(Math_fround(f33 + f28) + Math_fround(1.0));
  f29 = Math_fround(Math_fround(Math_fround(f23 * f32) + Math_fround(f34 * f24)) + Math_fround(0.0));
  f22 = Math_fround(Math_fround(Math_fround(f22 * f34) + Math_fround(f23 * f24)) + Math_fround(0.0));
  f25 = Math_fround(f23 * Math_fround(2.0));
  f26 = Math_fround(f23 * Math_fround(-2.0));
  f23 = Math_fround(f23 * f26);
  f30 = Math_fround(Math_fround(Math_fround(f35 * f25) + Math_fround(f34 * f30)) + Math_fround(0.0));
  f28 = Math_fround(Math_fround(f23 + f28) + Math_fround(1.0));
  f24 = Math_fround(Math_fround(Math_fround(f34 * f25) + Math_fround(f35 * f24)) + Math_fround(0.0));
  f25 = Math_fround(Math_fround(Math_fround(f32 * f34) + Math_fround(f25 * f27)) + Math_fround(0.0));
  f27 = Math_fround(Math_fround(Math_fround(f34 * f26) + Math_fround(f32 * f27)) + Math_fround(0.0));
  f23 = Math_fround(Math_fround(f33 + f23) + Math_fround(1.0));
  f33 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 28 >> 2]);
  f32 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 32 >> 2]);
  f26 = Math_fround(HEAPF32[i21 + (i1 * 40 | 0) + 36 >> 2]);
  f31 = Math_fround(f33 * f31);
  f29 = Math_fround(f33 * f29);
  f22 = Math_fround(f33 * f22);
  f30 = Math_fround(f32 * f30);
  f28 = Math_fround(f32 * f28);
  f24 = Math_fround(f32 * f24);
  f25 = Math_fround(f25 * f26);
  f27 = Math_fround(f27 * f26);
  f26 = Math_fround(f23 * f26);
  f23 = f6;
  f6 = Math_fround(Math_fround(f6 * f31) + Math_fround(Math_fround(f9 * f30) + Math_fround(f25 * f10)));
  f32 = f9;
  f9 = Math_fround(Math_fround(f23 * f29) + Math_fround(Math_fround(f9 * f28) + Math_fround(f27 * f10)));
  f10 = Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f32 * f24) + Math_fround(f26 * f10)));
  f32 = f8;
  f8 = Math_fround(Math_fround(f31 * f8) + Math_fround(Math_fround(f30 * f5) + Math_fround(f25 * f7)));
  f23 = f5;
  f5 = Math_fround(Math_fround(f29 * f32) + Math_fround(Math_fround(f28 * f5) + Math_fround(f27 * f7)));
  f7 = Math_fround(Math_fround(f22 * f32) + Math_fround(Math_fround(f24 * f23) + Math_fround(f26 * f7)));
  f23 = f4;
  f4 = Math_fround(Math_fround(f31 * f4) + Math_fround(Math_fround(f30 * f2) + Math_fround(f25 * f3)));
  f25 = f2;
  f2 = Math_fround(Math_fround(f29 * f23) + Math_fround(Math_fround(f28 * f2) + Math_fround(f27 * f3)));
  f3 = Math_fround(Math_fround(f22 * f23) + Math_fround(Math_fround(f24 * f25) + Math_fround(f26 * f3)));
  i1 = HEAP32[i19 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i20 >> 2] = f6;
 HEAPF32[i11 >> 2] = f9;
 HEAPF32[i12 >> 2] = f10;
 HEAPF32[i13 >> 2] = f8;
 HEAPF32[i14 >> 2] = f5;
 HEAPF32[i15 >> 2] = f7;
 HEAPF32[i16 >> 2] = f4;
 HEAPF32[i17 >> 2] = f2;
 HEAPF32[i18 >> 2] = f3;
 return;
}

function __ZN5physx2Sc8ClothSim20removeCollisionShapeEPKNS0_8ShapeSimE(i13, i5) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 8 | 0;
 i15 = i16;
 switch (HEAP32[(HEAP32[i5 + 28 >> 2] | 0) + 68 >> 2] | 0) {
 case 0:
  {
   i8 = HEAP32[i13 + 52 >> 2] | 0;
   i9 = i13 + 116 | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i10 = i13 + 84 | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   i3 = 0;
   while (1) {
    if (i3 >>> 0 >= i7 >>> 0) break;
    i2 = i6 + (i3 << 2) | 0;
    i1 = i3 + 1 | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
     i5 = i3;
     i4 = 5;
     break;
    } else i3 = i1;
   }
   if ((i4 | 0) == 5) {
    i3 = i13 + 120 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i1 >>> 0 < i4 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
     i1 = i5 + 2 | 0;
     if (i1 >>> 0 < i4 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i4 | 0));
    }
    HEAP32[i3 >> 2] = i4 + -1;
    HEAP32[i10 >> 2] = i7 + -1;
    i13 = (HEAP32[i8 + 72 >> 2] | 0) + i5 | 0;
    i12 = HEAP32[i8 + 28 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 164 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    mftCall_viiii(i11 | 0, i12 | 0, i14 | 0, i13 | 0, i13 + 1 | 0);
   }
   STACKTOP = i16;
   return;
  }
 case 1:
  {
   i8 = HEAP32[i13 + 52 >> 2] | 0;
   i1 = (HEAP32[i13 + 88 >> 2] | 0) + (HEAP32[i13 + 84 >> 2] | 0) | 0;
   i9 = i13 + 116 | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   i10 = i13 + 92 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   L16 : do if (i11 | 0) {
    i4 = 0;
    while (1) {
     i3 = i1 + i4 | 0;
     i2 = i7 + (i3 << 2) | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i11 >>> 0) break L16;
    }
    i1 = i3 + 1 | 0;
    i5 = i13 + 120 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if (i1 >>> 0 < i6 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
     i1 = i3 + 2 | 0;
     if (i1 >>> 0 < i6 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i6 | 0));
    }
    HEAP32[i5 >> 2] = i6 + -1;
    HEAP32[i10 >> 2] = i11 + -1;
    i13 = (HEAP32[i8 + 80 >> 2] | 0) + i4 | 0;
    i12 = HEAP32[i8 + 28 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 180 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    mftCall_viiii(i11 | 0, i12 | 0, i14 | 0, i13 | 0, i13 + 1 | 0);
   } while (0);
   STACKTOP = i16;
   return;
  }
 case 2:
  {
   i8 = HEAP32[i13 + 52 >> 2] | 0;
   i9 = HEAP32[i13 + 84 >> 2] | 0;
   i10 = i13 + 116 | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   i11 = i13 + 88 | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   L29 : do if (i12 | 0) {
    i3 = 0;
    while (1) {
     i1 = i3 + i9 | 0;
     i2 = i7 + (i1 << 2) | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
      i6 = i3;
      break;
     }
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 >= i12 >>> 0) break L29;
    }
    i3 = i1 + 1 | 0;
    i4 = i13 + 120 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (i3 >>> 0 < i5 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i7 + (i3 << 2) >> 2];
     i1 = i1 + 2 | 0;
     if (i1 >>> 0 < i5 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i5 | 0));
    }
    HEAP32[i4 >> 2] = i5 + -1;
    HEAP32[i11 >> 2] = i12 + -1;
    i13 = (i6 << 1) + i9 + (HEAP32[i8 + 72 >> 2] | 0) | 0;
    i12 = HEAP32[i8 + 28 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 164 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    mftCall_viiii(i11 | 0, i12 | 0, i14 | 0, i13 | 0, i13 + 2 | 0);
   } while (0);
   STACKTOP = i16;
   return;
  }
 case 3:
  {
   i8 = HEAP32[i13 + 52 >> 2] | 0;
   i9 = HEAP32[i13 + 92 >> 2] | 0;
   i1 = (HEAP32[i13 + 88 >> 2] | 0) + (HEAP32[i13 + 84 >> 2] | 0) + i9 | 0;
   i10 = i13 + 116 | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   i11 = i13 + 96 | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   L42 : do if (i12 | 0) {
    i4 = 0;
    while (1) {
     i3 = i1 + i4 | 0;
     i2 = i7 + (i3 << 2) | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i12 >>> 0) break L42;
    }
    i1 = i3 + 1 | 0;
    i5 = i13 + 120 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if (i1 >>> 0 < i6 >>> 0) {
     HEAP32[i2 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
     i1 = i3 + 2 | 0;
     if (i1 >>> 0 < i6 >>> 0) do {
      i2 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i6 | 0));
    }
    HEAP32[i5 >> 2] = i6 + -1;
    HEAP32[i11 >> 2] = i12 + -1;
    i13 = (i4 * 6 | 0) + i9 + (HEAP32[i8 + 80 >> 2] | 0) | 0;
    i12 = HEAP32[i8 + 28 >> 2] | 0;
    i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 180 >> 2] | 0;
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    mftCall_viiii(i11 | 0, i12 | 0, i14 | 0, i13 | 0, i13 + 6 | 0);
   } while (0);
   STACKTOP = i16;
   return;
  }
 case 4:
  {
   __ZN5physx2Sc8ClothSim21removeCollisionConvexEPKNS0_8ShapeSimE(i13, i5);
   STACKTOP = i16;
   return;
  }
 case 5:
  {
   __ZN5physx2Sc8ClothSim19removeCollisionMeshEPKNS0_8ShapeSimE(i13, i5);
   STACKTOP = i16;
   return;
  }
 case 6:
  {
   __ZN5physx2Sc8ClothSim26removeCollisionHeightfieldEPKNS0_8ShapeSimE(i13, i5);
   STACKTOP = i16;
   return;
  }
 default:
  {
   STACKTOP = i16;
   return;
  }
 }
}

function __ZN5physx17PxScaleRigidActorERNS_12PxRigidActorEfb(i26, f29, i30) {
 i26 = i26 | 0;
 f29 = Math_fround(f29);
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, i39 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i33 + 184 | 0;
 i28 = i33 + 176 | 0;
 i1 = i33 + 108 | 0;
 i3 = i33 + 80 | 0;
 i27 = i33 + 136 | 0;
 i12 = i33 + 68 | 0;
 i21 = i33 + 56 | 0;
 i22 = i33 + 28 | 0;
 i23 = i33;
 i31 = i32 + 256 | 0;
 i24 = i32 + 260 | 0;
 i25 = i32 + 264 | 0;
 HEAP32[i25 >> 2] = 0;
 i2 = i32 + 268 | 0;
 HEAP8[i31 >> 0] = 1;
 HEAP32[i24 >> 2] = i32;
 HEAP32[i2 >> 2] = 64;
 i20 = mftCall_ii(HEAP32[(HEAP32[i26 >> 2] | 0) + 104 >> 2] | 0, i26 | 0) | 0;
 HEAP32[i28 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i32, i20, i28);
 mftCall_iiiii(HEAP32[(HEAP32[i26 >> 2] | 0) + 108 >> 2] | 0, i26 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i25 >> 2] | 0, 0) | 0;
 L1 : do if (HEAP32[i25 >> 2] | 0) {
  i4 = i3 + 16 | 0;
  i5 = i3 + 20 | 0;
  i6 = i3 + 24 | 0;
  i7 = i1 + 4 | 0;
  i8 = i3 + 4 | 0;
  i9 = i1 + 8 | 0;
  i10 = i3 + 8 | 0;
  i11 = i1 + 12 | 0;
  i13 = i3 + 12 | 0;
  i14 = i1 + 16 | 0;
  i15 = i1 + 20 | 0;
  i16 = i1 + 24 | 0;
  i17 = i27 + 4 | 0;
  i18 = i27 + 8 | 0;
  i19 = i27 + 12 | 0;
  i20 = i27 + 16 | 0;
  i28 = 0;
  while (1) {
   i34 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i28 << 2) >> 2] | 0;
   i39 = HEAP32[i34 >> 2] | 0;
   i35 = HEAP32[i39 + 68 >> 2] | 0;
   mftCall_vii(HEAP32[i39 + 72 >> 2] | 0, i3 | 0, i34 | 0);
   f38 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f29);
   f37 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f29);
   f36 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f29);
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAPF32[i14 >> 2] = f38;
   HEAPF32[i15 >> 2] = f37;
   HEAPF32[i16 >> 2] = f36;
   mftCall_vii(i35 | 0, i34 | 0, i1 | 0);
   i34 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i28 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i34 >> 2] | 0) + 32 >> 2] | 0, i27 | 0, i34 | 0);
   switch (HEAP32[i27 >> 2] | 0) {
   case 0:
    {
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f29);
     break;
    }
   case 6:
    {
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f29);
     HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f29);
     break;
    }
   case 2:
    {
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f29);
     break;
    }
   case 3:
    {
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f29);
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f29);
     break;
    }
   case 4:
    {
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f29);
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f29);
     break;
    }
   case 5:
    {
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f29);
     HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f29);
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f29);
     break;
    }
   default:
    {}
   }
   i39 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i28 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 28 >> 2] | 0, i39 | 0, i27 | 0);
   i28 = i28 + 1 | 0;
   if (i28 >>> 0 >= (HEAP32[i25 >> 2] | 0) >>> 0) break L1;
  }
 } while (0);
 if (i30) if ((HEAP16[i26 + 4 >> 1] | 0) == 5) {
  f36 = Math_fround(Math_fround(f29 * f29) * f29);
  i39 = HEAP32[i26 >> 2] | 0;
  i35 = HEAP32[i39 + 128 >> 2] | 0;
  mftCall_vif(i35 | 0, i26 | 0, +Math_fround(f36 * Math_fround(+mftCall_fi(HEAP32[i39 + 132 >> 2] | 0, i26 | 0))));
  i39 = HEAP32[i26 >> 2] | 0;
  i35 = HEAP32[i39 + 140 >> 2] | 0;
  mftCall_vii(HEAP32[i39 + 144 >> 2] | 0, i21 | 0, i26 | 0);
  f38 = Math_fround(f36 * Math_fround(HEAPF32[i21 >> 2]));
  f37 = Math_fround(f36 * Math_fround(HEAPF32[i21 + 4 >> 2]));
  f37 = Math_fround(Math_fround(f37 * f29) * f29);
  f36 = Math_fround(Math_fround(Math_fround(f36 * Math_fround(HEAPF32[i21 + 8 >> 2])) * f29) * f29);
  HEAPF32[i12 >> 2] = Math_fround(Math_fround(f38 * f29) * f29);
  HEAPF32[i12 + 4 >> 2] = f37;
  HEAPF32[i12 + 8 >> 2] = f36;
  mftCall_vii(i35 | 0, i26 | 0, i12 | 0);
  i35 = HEAP32[i26 >> 2] | 0;
  i39 = HEAP32[i35 + 120 >> 2] | 0;
  mftCall_vii(HEAP32[i35 + 124 >> 2] | 0, i23 | 0, i26 | 0);
  f36 = Math_fround(Math_fround(HEAPF32[i23 + 16 >> 2]) * f29);
  f37 = Math_fround(Math_fround(HEAPF32[i23 + 20 >> 2]) * f29);
  f38 = Math_fround(Math_fround(HEAPF32[i23 + 24 >> 2]) * f29);
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
  HEAPF32[i22 + 16 >> 2] = f36;
  HEAPF32[i22 + 20 >> 2] = f37;
  HEAPF32[i22 + 24 >> 2] = f38;
  mftCall_vii(i39 | 0, i26 | 0, i22 | 0);
 }
 i39 = HEAP32[i2 >> 2] | 0;
 if (!((i39 | 0) > -1 & (i39 & 2147483647 | 0) != 0)) {
  STACKTOP = i33;
  return;
 }
 i1 = HEAP32[i24 >> 2] | 0;
 if ((i32 | 0) == (i1 | 0)) {
  HEAP8[i31 >> 0] = 0;
  STACKTOP = i33;
  return;
 }
 if (!i1) {
  STACKTOP = i33;
  return;
 }
 i39 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i39 >> 2] | 0) + 12 >> 2] | 0, i39 | 0, i1 | 0);
 STACKTOP = i33;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator12makeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEE(i24, i21) {
 i24 = i24 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 24 | 0;
 i9 = i25 + 16 | 0;
 i11 = i25 + 12 | 0;
 i13 = i25 + 8 | 0;
 i3 = i25 + 4 | 0;
 i7 = i25;
 i22 = i24 + 60 | 0;
 i16 = HEAP32[i22 >> 2] | 0;
 if ((i16 | 0) > 0) {
  i17 = i24 + 104 | 0;
  i18 = i24 + 108 | 0;
  i19 = i24 + 112 | 0;
  i20 = i24 + 116 | 0;
  i14 = i24 + 120 | 0;
  i15 = i24 + 124 | 0;
  i2 = HEAP32[i24 + 56 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i17 >> 2]);
  f5 = Math_fround(HEAPF32[i18 >> 2]);
  f6 = Math_fround(HEAPF32[i19 >> 2]);
  f8 = Math_fround(HEAPF32[i20 >> 2]);
  f10 = Math_fround(HEAPF32[i14 >> 2]);
  i1 = 0;
  f12 = Math_fround(HEAPF32[i15 >> 2]);
  do {
   i26 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i31 = HEAP32[i26 + 20 >> 2] | 0;
   HEAP32[i23 >> 2] = i31;
   i30 = HEAP32[i26 + 24 >> 2] | 0;
   HEAP32[i9 >> 2] = i30;
   i29 = HEAP32[i26 + 28 >> 2] | 0;
   HEAP32[i11 >> 2] = i29;
   i28 = HEAP32[i26 + 32 >> 2] | 0;
   HEAP32[i13 >> 2] = i28;
   i27 = HEAP32[i26 + 36 >> 2] | 0;
   HEAP32[i3 >> 2] = i27;
   i26 = HEAP32[i26 + 40 >> 2] | 0;
   HEAP32[i7 >> 2] = i26;
   i31 = f4 <= (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i31 = HEAP32[(i31 ? i17 : i23) >> 2] | 0;
   i30 = f5 <= (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i30 = HEAP32[(i30 ? i18 : i9) >> 2] | 0;
   i29 = f6 <= (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i29 = HEAP32[(i29 ? i19 : i11) >> 2] | 0;
   HEAP32[i17 >> 2] = i31;
   HEAP32[i18 >> 2] = i30;
   HEAP32[i19 >> 2] = i29;
   i28 = f8 >= (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i28 = HEAP32[(i28 ? i20 : i13) >> 2] | 0;
   i27 = f10 >= (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i27 = HEAP32[(i27 ? i14 : i3) >> 2] | 0;
   i26 = f12 >= (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i26 = HEAP32[(i26 ? i15 : i7) >> 2] | 0;
   HEAP32[i20 >> 2] = i28;
   HEAP32[i14 >> 2] = i27;
   HEAP32[i15 >> 2] = i26;
   i1 = i1 + 1 | 0;
   f4 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i1 | 0) < (i16 | 0));
 }
 i1 = i24 + 80 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i24 + 92 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f4 <= f5) {
  i3 = i24 + 84 | 0;
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  i7 = i24 + 96 | 0;
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  if (f6 <= f8) {
   i9 = i24 + 88 | 0;
   f10 = Math_fround(HEAPF32[i9 >> 2]);
   i11 = i24 + 100 | 0;
   f12 = Math_fround(HEAPF32[i11 >> 2]);
   if (f10 <= f12) {
    f33 = Math_fround(Math_floor(Math_fround(f4)));
    HEAPF32[i1 >> 2] = f33;
    f32 = Math_fround(Math_floor(Math_fround(f6)));
    HEAPF32[i1 + 4 >> 2] = f32;
    f4 = Math_fround(Math_floor(Math_fround(f10)));
    HEAPF32[i1 + 8 >> 2] = f4;
    f6 = Math_fround(Math_ceil(Math_fround(f5)));
    HEAPF32[i2 >> 2] = f6;
    f10 = Math_fround(Math_ceil(Math_fround(f8)));
    HEAPF32[i2 + 4 >> 2] = f10;
    f12 = Math_fround(Math_ceil(Math_fround(f12)));
    HEAPF32[i2 + 8 >> 2] = f12;
    i31 = i24 + 104 | 0;
    i30 = Math_fround(HEAPF32[i31 >> 2]) <= f33;
    i29 = i24 + 108 | 0;
    i28 = Math_fround(HEAPF32[i29 >> 2]) <= f32;
    i28 = HEAP32[(i28 ? i29 : i3) >> 2] | 0;
    i27 = i24 + 112 | 0;
    i26 = Math_fround(HEAPF32[i27 >> 2]) <= f4;
    i26 = HEAP32[(i26 ? i27 : i9) >> 2] | 0;
    HEAP32[i31 >> 2] = HEAP32[(i30 ? i31 : i1) >> 2];
    HEAP32[i29 >> 2] = i28;
    HEAP32[i27 >> 2] = i26;
    i27 = i24 + 116 | 0;
    i26 = Math_fround(HEAPF32[i27 >> 2]) >= f6;
    i29 = i24 + 120 | 0;
    i28 = Math_fround(HEAPF32[i29 >> 2]) >= f10;
    i28 = HEAP32[(i28 ? i29 : i7) >> 2] | 0;
    i31 = i24 + 124 | 0;
    i30 = Math_fround(HEAPF32[i31 >> 2]) >= f12;
    i30 = HEAP32[(i30 ? i31 : i11) >> 2] | 0;
    HEAP32[i27 >> 2] = HEAP32[(i26 ? i27 : i2) >> 2];
    HEAP32[i29 >> 2] = i28;
    HEAP32[i31 >> 2] = i30;
   }
  }
 }
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9constructERNS2_11ConstructorEiPS1_(i21, i23, 0, HEAP32[i24 >> 2] | 0);
 i3 = HEAP32[i24 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i22 >> 2] << 2 | 0, 0) | 0;
 if (!i3) {
  HEAP32[i24 + 464 >> 2] = 1;
  i31 = 0;
  STACKTOP = i25;
  return i31 | 0;
 }
 if ((HEAP32[i22 >> 2] | 0) > 0) {
  i2 = 0;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP32[i3 + (i2 << 2) >> 2] = i2;
   if ((i1 | 0) < (HEAP32[i22 >> 2] | 0)) i2 = i1; else break;
  }
 } else i1 = 0;
 i31 = __ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij(i24, i23, i24 + 104 | 0, i3, i1, 63) | 0;
 i30 = HEAP32[i24 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i3 | 0);
 if (i31) {
  i31 = 1;
  STACKTOP = i25;
  return i31 | 0;
 }
 i1 = i24 + 464 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i31 = 0;
  STACKTOP = i25;
  return i31 | 0;
 }
 HEAP32[i1 >> 2] = 5;
 i31 = 0;
 STACKTOP = i25;
 return i31 | 0;
}

function __ZL15ProcessVerticesRNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEEEPFbNS_11__wrap_iterIPS2_EES9_S9_E(i28) {
 i28 = i28 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i3 = i1;
 i5 = i3 + 64 | 0;
 i29 = i28 + 4 | 0;
 i7 = HEAP32[i29 >> 2] | 0;
 i18 = i7;
 L1 : do if ((i5 | 0) == (i7 | 0)) {
  i6 = i18;
  i3 = i18;
  i4 = i18;
  i1 = i18;
 } else {
  i19 = i3;
  i3 = i18;
  i4 = i18;
  i6 = i18;
  i21 = i18;
  while (1) {
   i26 = i1 + 36 | 0;
   i23 = i19 + 68 | 0;
   i27 = i1 + 32 | 0;
   i24 = i1 + 64 | 0;
   i25 = i24;
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   i20 = i7;
   while (1) {
    f9 = Math_fround(HEAPF32[i27 >> 2]);
    f10 = Math_fround(HEAPF32[i26 >> 2]);
    f11 = Math_fround(HEAPF32[i5 >> 2]);
    f12 = Math_fround(HEAPF32[i23 >> 2]);
    f13 = Math_fround(f11 - f16);
    f14 = Math_fround(f12 - f17);
    f2 = Math_fround(f9 - f16);
    f8 = Math_fround(f10 - f17);
    f15 = Math_fround(Math_fround(f2 * f13) + Math_fround(f8 * f14));
    do if (!(f15 <= Math_fround(0.0))) {
     f2 = Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14));
     if (!(f2 <= f15)) {
      f2 = Math_fround(f15 / f2);
      f15 = Math_fround(f9 - Math_fround(f16 + Math_fround(f13 * f2)));
      f2 = Math_fround(f10 - Math_fround(f17 + Math_fround(f14 * f2)));
      f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(f2 * f2))));
      break;
     } else {
      f15 = Math_fround(f9 - f11);
      f2 = Math_fround(f10 - f12);
      f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(f2 * f2))));
      break;
     }
    } else f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f8 * f8)))); while (0);
    if (!(f2 <= Math_fround(.0000999999974))) break;
    i7 = i18 - i25 | 0;
    i22 = i7 >> 5;
    if (!i22) i19 = i21; else {
     _memmove(i27 | 0, i24 | 0, i7 | 0) | 0;
     i18 = HEAP32[i29 >> 2] | 0;
     i19 = i18;
     i3 = i19;
     i4 = i19;
     i6 = i19;
     i20 = i18;
    }
    i7 = i27 + (i22 << 5) | 0;
    if ((i18 | 0) == (i7 | 0)) i7 = i20; else {
     i7 = i18 + (~((i18 + -32 - i7 | 0) >>> 5) << 5) | 0;
     HEAP32[i29 >> 2] = i7;
     i19 = i7;
     i3 = i19;
     i4 = i19;
     i6 = i19;
    }
    if ((i5 | 0) == (i7 | 0)) {
     i1 = i19;
     break L1;
    } else {
     i20 = i7;
     i21 = i19;
     i18 = i7;
    }
   }
   i5 = i1 + 96 | 0;
   if ((i5 | 0) == (i20 | 0)) {
    i1 = i21;
    i5 = i20;
    break;
   } else {
    i1 = i27;
    i19 = i27;
    i7 = i20;
    i18 = i20;
   }
  }
 } while (0);
 i19 = HEAP32[i28 >> 2] | 0;
 i20 = i19;
 if (i1 - i19 >> 5 >>> 0 > 2) {
  i18 = i20 + 32 | 0;
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  f10 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i5 + -32 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + -28 >> 2]);
  f13 = Math_fround(HEAPF32[i18 >> 2]);
  f14 = Math_fround(HEAPF32[i20 + 36 >> 2]);
  f15 = Math_fround(f13 - f11);
  f16 = Math_fround(f14 - f12);
  f2 = Math_fround(f9 - f11);
  f8 = Math_fround(f10 - f12);
  f17 = Math_fround(Math_fround(f2 * f15) + Math_fround(f8 * f16));
  do if (!(f17 <= Math_fround(0.0))) {
   f2 = Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16));
   if (!(f2 <= f17)) {
    f2 = Math_fround(f17 / f2);
    f17 = Math_fround(f9 - Math_fround(f11 + Math_fround(f15 * f2)));
    f2 = Math_fround(f10 - Math_fround(f12 + Math_fround(f16 * f2)));
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f2 * f2))));
    break;
   } else {
    f17 = Math_fround(f9 - f13);
    f2 = Math_fround(f10 - f14);
    f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f2 * f2))));
    break;
   }
  } else f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f8 * f8)))); while (0);
  if (f2 <= Math_fround(.0000999999974)) {
   i1 = i6 - i18 | 0;
   i7 = i1 >> 5;
   if (i7) {
    _memmove(i19 | 0, i18 | 0, i1 | 0) | 0;
    i5 = HEAP32[i29 >> 2] | 0;
    i4 = i5;
    i6 = i5;
    i3 = i4;
   }
   i1 = i20 + (i7 << 5) | 0;
   if ((i6 | 0) != (i1 | 0)) {
    i5 = i6 + (~((i6 + -32 - i1 | 0) >>> 5) << 5) | 0;
    HEAP32[i29 >> 2] = i5;
    i3 = i5;
    i4 = i3;
   }
  }
 }
 i28 = HEAP32[i28 >> 2] | 0;
 i1 = i28;
 if (i4 - i28 >> 5 >>> 0 <= 2) return;
 i6 = i5 + -32 | 0;
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + -28 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + -64 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + -60 >> 2]);
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f17 - f15);
 f11 = Math_fround(f9 - f16);
 f2 = Math_fround(f13 - f15);
 f8 = Math_fround(f14 - f16);
 f12 = Math_fround(Math_fround(f2 * f10) + Math_fround(f8 * f11));
 do if (!(f12 <= Math_fround(0.0))) {
  f2 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
  if (!(f2 <= f12)) {
   f2 = Math_fround(f12 / f2);
   f17 = Math_fround(f13 - Math_fround(f15 + Math_fround(f10 * f2)));
   f2 = Math_fround(f14 - Math_fround(f16 + Math_fround(f11 * f2)));
   f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f2 * f2))));
   break;
  } else {
   f17 = Math_fround(f13 - f17);
   f2 = Math_fround(f14 - f9);
   f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(f2 * f2))));
   break;
  }
 } else f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f8 * f8)))); while (0);
 if (!(f2 <= Math_fround(.0000999999974))) return;
 i1 = i3 - i5 | 0;
 i4 = i1 >> 5;
 if (i4) {
  _memmove(i6 | 0, i5 | 0, i1 | 0) | 0;
  i3 = HEAP32[i29 >> 2] | 0;
 }
 i1 = i6 + (i4 << 5) | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 HEAP32[i29 >> 2] = i3 + (~((i3 + -32 - i1 | 0) >>> 5) << 5);
 return;
}

function _realize_virt_arrays(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = i15 + 4 | 0;
 i13 = HEAP32[i16 >> 2] | 0;
 i4 = i13 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i2 = 0;
  i3 = 0;
  do {
   if (!(HEAP32[i1 >> 2] | 0)) {
    i14 = HEAP32[i1 + 8 >> 2] | 0;
    i2 = (Math_imul(i14, HEAP32[i1 + 12 >> 2] | 0) | 0) + i2 | 0;
    i3 = (Math_imul(HEAP32[i1 + 4 >> 2] | 0, i14) | 0) + i3 | 0;
   }
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i12 = i13 + 72 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i1 = i3; else {
  do {
   if (!(HEAP32[i1 >> 2] | 0)) {
    i14 = HEAP32[i1 + 8 >> 2] | 0;
    i2 = (Math_imul(HEAP32[i1 + 12 >> 2] << 7, i14) | 0) + i2 | 0;
    i3 = (Math_imul(i14 << 7, HEAP32[i1 + 4 >> 2] | 0) | 0) + i3 | 0;
   }
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i1 = i3;
 }
 if (!i2) return;
 i3 = _jpeg_mem_available(i15, i2, i1, HEAP32[i13 + 76 >> 2] | 0) | 0;
 if (i3 >>> 0 < i1 >>> 0) i14 = i2 >>> 0 > i3 >>> 0 ? 1 : (i3 >>> 0) / (i2 >>> 0) | 0; else i14 = 1e9;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i11 = i13 + 80 | 0;
  do {
   if (!(HEAP32[i1 >> 2] | 0)) {
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if (((((i3 + -1 | 0) >>> 0) / (i2 >>> 0) | 0) + 1 | 0) >>> 0 > i14 >>> 0) {
     i10 = i1 + 16 | 0;
     HEAP32[i10 >> 2] = Math_imul(i2, i14) | 0;
     i2 = i1 + 8 | 0;
     _jpeg_open_backing_store(i15, i1 + 40 | 0, Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0);
     HEAP8[i1 + 34 >> 0] = 1;
     i3 = HEAP32[i10 >> 2] | 0;
    } else {
     HEAP32[i1 + 16 >> 2] = i3;
     i2 = i1 + 8 | 0;
    }
    i5 = HEAP32[i16 >> 2] | 0;
    i10 = (HEAP32[i2 >> 2] | 0) + 15 & -16;
    i2 = 999999988 / (i10 >>> 0) | 0;
    if (i10 >>> 0 > 999999988) {
     i9 = HEAP32[i15 >> 2] | 0;
     HEAP32[i9 + 20 >> 2] = 70;
     mftCall_vi(HEAP32[i9 >> 2] | 0, i15 | 0);
    }
    i4 = (i2 | 0) < (i3 | 0) ? i2 : i3;
    HEAP32[i5 + 80 >> 2] = i4;
    i9 = _alloc_small(i15, 1, i3 << 2) | 0;
    if (i3 | 0) {
     i2 = 0;
     do {
      i5 = i3 - i2 | 0;
      i4 = i4 >>> 0 < i5 >>> 0 ? i4 : i5;
      i5 = Math_imul(i4, i10) | 0;
      i6 = HEAP32[i16 >> 2] | 0;
      i7 = i5 + 19 | 0;
      if (i7 >>> 0 > 1e9) {
       i8 = HEAP32[i15 >> 2] | 0;
       HEAP32[i8 + 20 >> 2] = 54;
       HEAP32[i8 + 24 >> 2] = 3;
       mftCall_vi(HEAP32[i8 >> 2] | 0, i15 | 0);
      }
      i8 = _jpeg_get_large(i15, i7) | 0;
      if (!i8) {
       i17 = HEAP32[i15 >> 2] | 0;
       HEAP32[i17 + 20 >> 2] = 54;
       HEAP32[i17 + 24 >> 2] = 4;
       mftCall_vi(HEAP32[i17 >> 2] | 0, i15 | 0);
      }
      i17 = i6 + 76 | 0;
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i7;
      i6 = i6 + 64 | 0;
      HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i8 + 4 >> 2] = i5;
      HEAP32[i8 + 8 >> 2] = 0;
      HEAP32[i6 >> 2] = i8;
      i5 = i8 + 12 | 0;
      i6 = i5 & 7;
      if (i4) {
       i6 = (i6 | 0) == 0 ? i5 : i5 + (8 - i6) | 0;
       i7 = i4;
       while (1) {
        i5 = i2 + 1 | 0;
        HEAP32[i9 + (i2 << 2) >> 2] = i6;
        i7 = i7 + -1 | 0;
        if (!i7) {
         i2 = i5;
         break;
        } else {
         i6 = i6 + i10 | 0;
         i2 = i5;
        }
       }
      }
     } while (i2 >>> 0 < i3 >>> 0);
    }
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 20 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = 0;
    HEAP8[i1 + 33 >> 0] = 0;
   }
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) return;
 i12 = i13 + 80 | 0;
 do {
  if (!(HEAP32[i1 >> 2] | 0)) {
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (((((i3 + -1 | 0) >>> 0) / (i2 >>> 0) | 0) + 1 | 0) >>> 0 > i14 >>> 0) {
    i17 = i1 + 16 | 0;
    HEAP32[i17 >> 2] = Math_imul(i2, i14) | 0;
    i2 = i1 + 8 | 0;
    _jpeg_open_backing_store(i15, i1 + 40 | 0, Math_imul(i3 << 7, HEAP32[i2 >> 2] | 0) | 0);
    HEAP8[i1 + 34 >> 0] = 1;
    i3 = HEAP32[i17 >> 2] | 0;
   } else {
    HEAP32[i1 + 16 >> 2] = i3;
    i2 = i1 + 8 | 0;
   }
   i10 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i16 >> 2] | 0;
   i11 = i10 << 7;
   i2 = 999999988 / (i11 >>> 0) | 0;
   if (i11 >>> 0 > 999999988) {
    i17 = HEAP32[i15 >> 2] | 0;
    HEAP32[i17 + 20 >> 2] = 70;
    mftCall_vi(HEAP32[i17 >> 2] | 0, i15 | 0);
   }
   i5 = (i2 | 0) < (i3 | 0) ? i2 : i3;
   HEAP32[i4 + 80 >> 2] = i5;
   i9 = _alloc_small(i15, 1, i3 << 2) | 0;
   if (i3 | 0) {
    i2 = 0;
    do {
     i4 = i3 - i2 | 0;
     i5 = i5 >>> 0 < i4 >>> 0 ? i5 : i4;
     i4 = Math_imul(i5, i11) | 0;
     i6 = HEAP32[i16 >> 2] | 0;
     i7 = i4 | 19;
     if (i7 >>> 0 > 1e9) {
      i17 = HEAP32[i15 >> 2] | 0;
      HEAP32[i17 + 20 >> 2] = 54;
      HEAP32[i17 + 24 >> 2] = 3;
      mftCall_vi(HEAP32[i17 >> 2] | 0, i15 | 0);
     }
     i8 = _jpeg_get_large(i15, i7) | 0;
     if (!i8) {
      i17 = HEAP32[i15 >> 2] | 0;
      HEAP32[i17 + 20 >> 2] = 54;
      HEAP32[i17 + 24 >> 2] = 4;
      mftCall_vi(HEAP32[i17 >> 2] | 0, i15 | 0);
     }
     i17 = i6 + 76 | 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i7;
     i6 = i6 + 64 | 0;
     HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i8 + 4 >> 2] = i4;
     HEAP32[i8 + 8 >> 2] = 0;
     HEAP32[i6 >> 2] = i8;
     i4 = i8 + 12 | 0;
     i6 = i4 & 7;
     if (i5) {
      i7 = i5;
      i6 = (i6 | 0) == 0 ? i4 : i4 + (8 - i6) | 0;
      while (1) {
       i4 = i2 + 1 | 0;
       HEAP32[i9 + (i2 << 2) >> 2] = i6;
       i7 = i7 + -1 | 0;
       if (!i7) {
        i2 = i4;
        break;
       } else {
        i6 = i6 + (i10 << 7) | 0;
        i2 = i4;
       }
      }
     }
    } while (i2 >>> 0 < i3 >>> 0);
   }
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 20 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP8[i1 + 33 >> 0] = 0;
  }
  i1 = HEAP32[i1 + 36 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN19SharedBillboardData8TransferI14SafeBinaryReadEEvRT_(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 8 | 0;
 i8 = i13;
 i9 = i13 + 16 | 0;
 i4 = i10 + 16 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1034504 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i7 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 422271 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i4 = i10 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1034510 | 0, i5, i11, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i12 + 16 | 0;
   i7 = HEAP32[i12 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i12 + 36 >> 2] | 0, 0 - (HEAP32[i12 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i12 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i6 = i10 + 28 | 0;
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 500475 | 0, i7, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i12, i6, 0); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i12, 1) | 0) {
  i5 = gb + 64016 | 0;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i8;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i9 >> 2] = 0;
  i2 = i9 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  i4 = i9 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i9 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i8);
  i3 = i11;
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i8;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 422278 | 0, i7, i11, 1) | 0;
  if (!i1) i1 = 0; else {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i12, i9, 0); else {
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i12 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i3 = HEAP32[i10 + 40 >> 2] | 0;
  i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
  if (i3 | 0) {
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = 0;
   do {
    if (HEAP8[i2 + i1 >> 0] | 0) {
     i8 = HEAP32[i6 >> 2] | 0;
     i14 = i8 + (i1 << 4) + 8 | 0;
     HEAPF32[i14 >> 2] = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
     i8 = i8 + (i1 << 4) + 12 | 0;
     HEAPF32[i8 >> 2] = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  }
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i5);
   HEAP32[i9 >> 2] = 0;
  }
 }
 i2 = i10 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 500490 | 0, i7, i11, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i12, i2, 0); else {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 }
 i2 = i10 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 753990 | 0, i7, i11, 1) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i12, i2, 0); else {
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i12 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 STACKTOP = i13;
 return;
}

function __ZN6CameraC2E10MemLabelId18ObjectCreationMode(i13, i1, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 16 | 0;
 i14 = i17;
 i15 = i17 + 8 | 0;
 i7 = i1;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i14;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i13, i16, i2);
 HEAP32[i13 + 28 >> 2] = 0;
 HEAP8[i13 + 32 >> 0] = 1;
 HEAP8[i13 + 33 >> 0] = 0;
 HEAP32[i13 >> 2] = gb + 32728 + 8;
 i3 = i13 + 36 | 0;
 i4 = i13 + 164 | 0;
 i7 = i13 + 296 | 0;
 i5 = i13 + 100 | 0;
 i6 = i13 + 228 | 0;
 i8 = i13 + 424 | 0;
 i9 = i13 + 748 | 0;
 i2 = i13 + 680 | 0;
 i10 = i13 + 784 | 0;
 HEAP32[i13 + 820 >> 2] = 0;
 i1 = i13 + 824 | 0;
 i11 = i13 + 744 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i1 >> 2] = 3;
 i11 = i13 + 828 | 0;
 i1 = i13 + 864 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i13 + 892 | 0;
 HEAP32[i13 + 1072 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i13 + 1076 >> 2] = 16843009;
 HEAP8[i13 + 1093 >> 0] = 0;
 HEAP32[i13 + 880 >> 2] = -1;
 HEAP32[i13 + 884 >> 2] = -1;
 i11 = i13 + 932 | 0;
 i12 = i11 + 128 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i13 + 904 | 0;
 HEAP8[i13 + 1090 >> 0] = 0;
 HEAP32[i13 + 1064 >> 2] = 0;
 HEAP32[i13 + 1068 >> 2] = 0;
 HEAP8[i13 + 1080 >> 0] = 1;
 HEAP8[i13 + 1081 >> 0] = 1;
 HEAP8[i13 + 1085 >> 0] = 1;
 HEAP8[i13 + 1086 >> 0] = 1;
 HEAP8[i13 + 1087 >> 0] = 1;
 HEAP8[i13 + 1082 >> 0] = 1;
 HEAP8[i13 + 1091 >> 0] = 0;
 HEAP8[i13 + 1092 >> 0] = 0;
 HEAPF32[i13 + 1060 >> 2] = Math_fround(1.0);
 HEAP32[i13 + 1108 >> 2] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i11 = i2;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i6;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i5;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i4;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 _memmove(i3 | 0, gb + 1162292 | 0, 64) | 0;
 HEAP8[i13 + 1089 >> 0] = 1;
 HEAP32[i13 + 780 >> 2] = 1;
 i1 = i13 + 1096 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 i11 = i10;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.0219999999);
 HEAPF32[i13 + 1100 >> 2] = Math_fround(10.0);
 HEAP32[i13 + 1104 >> 2] = 0;
 HEAP8[i13 + 1112 >> 0] = 0;
 HEAP8[i13 + 1083 >> 0] = 1;
 HEAP8[i13 + 1084 >> 0] = 1;
 i11 = i7;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i8;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i13 + 360 | 0;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i13 + 488 | 0;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i13 + 1116 >> 2] = 0;
 HEAP8[i13 + 1120 >> 0] = 1;
 __ZN19RenderEventsContextC2Ei(i13 + 1136 | 0, 23);
 HEAP32[i13 + 1144 >> 2] = 0;
 HEAP32[i13 + 1148 >> 2] = 0;
 HEAP32[i13 + 1152 >> 2] = 0;
 __ZNK6Object14GetMemoryLabelEv(i15, i13);
 i11 = HEAP32[i15 + 4 >> 2] | 0;
 i12 = i14;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i13 + 1156 >> 2] = 0;
 HEAP32[i13 + 1168 >> 2] = 0;
 HEAP32[i13 + 1172 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i14);
 i12 = i16;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i15 = i13 + 1160 | 0;
 HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 + 4 >> 2] = i11;
 HEAP32[i13 + 1124 >> 2] = __Z16CreateRenderLoopR6Camera(i13) | 0;
 HEAP32[i13 + 1128 >> 2] = __Z20CreateShadowMapCachev() | 0;
 __ZNK6Object14GetMemoryLabelEv(i14, i13);
 i15 = __ZnwjRK10MemLabelIdiPKci(40, i14, 16, gb + 375437 | 0, 214) | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i11 = i16;
 i14 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = i15 + 4 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = i14;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 32 >> 2] = 0;
 HEAP32[i15 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i12 = i16;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i15 + 24 | 0;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 + 4 >> 2] = i14;
 HEAP32[i13 + 1132 >> 2] = i15;
 STACKTOP = i17;
 return;
}

function __ZN5physx15PxCollectionExt16createCollectionERNS_9PxPhysicsE(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17 + 84 | 0;
 i1 = i17 + 80 | 0;
 i6 = i17 + 68 | 0;
 i5 = i17 + 64 | 0;
 i8 = i17 + 52 | 0;
 i7 = i17 + 48 | 0;
 i10 = i17 + 36 | 0;
 i9 = i17 + 32 | 0;
 i12 = i17 + 20 | 0;
 i11 = i17 + 16 | 0;
 i14 = i17 + 4 | 0;
 i13 = i17;
 i16 = __Z18PxCreateCollectionv() | 0;
 if (!i16) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 68 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i2, i18, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 72 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if (!((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i1 | 0) == 0)) {
  i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i6, i1, i5);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 44 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if (!((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i1 | 0) == 0)) {
  i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 56 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i8, i1, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if (!((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i1 | 0) == 0)) {
  i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 148 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = i10 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i10, i1, i9);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 152 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if (!((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i1 | 0) == 0)) {
  i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 84 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i12 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i12, i1, i11);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 88 >> 2] | 0, i15 | 0, i1 | 0, i2 | 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if (!((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i1 | 0) == 0)) {
  i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 128 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i3 = i14 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i14 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i14, i2, i13);
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 132 >> 2] | 0, i15 | 0, i2 | 0, i3 | 0, 0) | 0;
 if (i3 | 0) {
  i1 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i2 + (i1 << 2) >> 2] | 0, 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i18 = HEAP32[i4 >> 2] | 0;
 if ((i18 & 2147483647 | 0) == 0 | (i18 | 0) < 0 | (i2 | 0) == 0) {
  i18 = i16;
  STACKTOP = i17;
  return i18 | 0;
 }
 i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i2 | 0);
 i18 = i16;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE(i7, i13, i15) {
 i7 = i7 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18;
 i1 = i18 + 40 | 0;
 i2 = i18 + 36 | 0;
 i3 = i18 + 32 | 0;
 i6 = i18 + 28 | 0;
 i12 = i18 + 24 | 0;
 i17 = i18 + 20 | 0;
 i16 = i18 + 16 | 0;
 i8 = i18 + 12 | 0;
 i9 = i18 + 8 | 0;
 i10 = i13 + 16 | 0;
 i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i10, i11) | 0;
 i5 = i11;
 if (!(i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0))) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i7, i13 + 20 | 0) | 0)) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i7, i13 + 36 | 0) | 0)) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i4 = i1;
 i5 = i4 + 16 | 0;
 do {
  HEAP8[i4 >> 0] = 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i2 >> 2] = 0;
 if ((HEAP32[i10 >> 2] | 0) >>> 0 > 3) {
  i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 16, 0, i1, i11) | 0;
  i5 = i11;
  if (i4 & ((HEAP32[i5 >> 2] | 0) == 16 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
   i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i2, i11) | 0;
   i5 = i11;
   if (i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
    HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
    i14 = 8;
   } else i1 = 1;
  } else i1 = 1;
 } else i14 = 8;
 if ((i14 | 0) == 8) {
  i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i3, i11) | 0;
  i5 = i11;
  if (i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
   HEAP32[i3 >> 2] = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
   i2 = i13 + 68 | 0;
   i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i2, i11) | 0;
   i5 = i11;
   if (i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
    HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
    i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i6, i11) | 0;
    i5 = i11;
    if (i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
     HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
     i4 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i12, i11) | 0;
     i5 = i11;
     if (i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
      i1 = HEAP32[i12 >> 2] | 0;
      i5 = _llvm_bswap_i32(i1 | 0) | 0;
      HEAP32[i12 >> 2] = i5;
      if ((HEAP32[i6 >> 2] | 0) >>> 0 > i5 >>> 0) i1 = 1; else {
       HEAP32[i17 >> 2] = 0;
       HEAP32[i16 >> 2] = 0;
       L24 : do if (!i1) i14 = 18; else {
        i1 = 0;
        while (1) {
         i5 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i17, i11) | 0;
         i6 = i11;
         if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 4 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
          i1 = 1;
          break L24;
         }
         HEAP32[i17 >> 2] = _llvm_bswap_i32(HEAP32[i17 >> 2] | 0) | 0;
         i5 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i16, i11) | 0;
         i6 = i11;
         if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 4 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
          i1 = 1;
          break L24;
         }
         HEAP32[i16 >> 2] = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
         i1 = i1 + 1 | 0;
         if (i1 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
          i14 = 18;
          break;
         }
        }
       } while (0);
       L30 : do if ((i14 | 0) == 18) {
        L32 : do if ((HEAP32[i10 >> 2] | 0) >>> 0 > 1) {
         i12 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i8, i11) | 0;
         i14 = i11;
         do if (i12 & ((HEAP32[i14 >> 2] | 0) == 4 & (HEAP32[i14 + 4 >> 2] | 0) == 0)) {
          i12 = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
          HEAP32[i8 >> 2] = i12;
          i14 = i13 + 56 | 0;
          HEAP32[i14 >> 2] = i12;
          HEAP32[i14 + 4 >> 2] = 0;
          if ((HEAP32[i10 >> 2] | 0) >>> 0 > 2) {
           i12 = __ZN12FileAccessor4ReadEyPvPy(i7, 4, 0, i9, i11) | 0;
           i14 = i11;
           if (!(i12 & ((HEAP32[i14 >> 2] | 0) == 4 & (HEAP32[i14 + 4 >> 2] | 0) == 0))) break;
          }
          break L32;
         } while (0);
         i1 = 1;
         break L30;
        } else {
         i14 = i13 + 56 | 0;
         HEAP32[i14 >> 2] = 0;
         HEAP32[i14 + 4 >> 2] = 0;
        } while (0);
        i14 = HEAP8[i13 + 11 >> 0] | 0;
        i1 = i14 << 24 >> 24 < 0;
        if (((i1 ? HEAP32[i13 + 4 >> 2] | 0 : i14 & 255) | 0) == 8) i6 = ((_memcmp(i1 ? HEAP32[i13 >> 2] | 0 : i13, gb + 489810 | 0, 8) | 0) == 0 | 64) & 65535; else i6 = 64;
        HEAP32[i13 + 64 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i13 + 72 >> 2] = 0;
        i3 = i15 + 16 | 0;
        i4 = i15 + 20 | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        i1 = HEAP32[i3 >> 2] | 0;
        i15 = i5 - i1 | 0;
        i2 = (i15 | 0) / 12 | 0;
        do if (!i15) {
         __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i3, 1 - i2 | 0);
         i1 = HEAP32[i3 >> 2] | 0;
        } else if (i2 >>> 0 > 1) {
         i2 = i1 + 12 | 0;
         if ((i5 | 0) == (i2 | 0)) break;
         HEAP32[i4 >> 2] = i5 + (~(((i5 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
        } while (0);
        HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i1 + 4 >> 2] = HEAP32[i17 >> 2];
        HEAP16[i1 + 8 >> 1] = i6;
        i1 = 0;
       } while (0);
      }
     } else i1 = 1;
    } else i1 = 1;
   } else i1 = 1;
  } else i1 = 1;
 }
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i6) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 32 | 0;
 i14 = i16 + 16 | 0;
 i12 = i16;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i6);
 HEAP32[i14 >> 2] = 0;
 i15 = i14 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i7 = i14 + 8 | 0;
 i8 = i13 + 4 | 0;
 i1 = 0;
 i5 = 0;
 i2 = 0;
 while (1) {
  i3 = i11 + 28 + (i1 * 20 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i3); else {
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i2 ? HEAP32[i11 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i10 = 7;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i5 + 11 >> 0] = i4;
    if (!i4) i2 = i5; else {
     i2 = i5;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i9 = i4 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i9 | -2147483648;
    HEAP32[i5 + 4 >> 2] = i4;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 28 + (i1 * 20 | 0) + 16 >> 2];
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 20;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i5 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i6, i14, 0);
 i8 = 0;
 do {
  i5 = i11 + 28 + (i8 * 20 | 0) | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i1 = i9 + (i8 * 20 | 0) | 0;
  do if ((i5 | 0) != (i1 | 0)) {
   i7 = HEAP8[i1 + 11 >> 0] | 0;
   i3 = i7 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   i7 = i3 ? HEAP32[i9 + (i8 * 20 | 0) + 4 >> 2] | 0 : i7 & 255;
   i3 = i5 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i11 + 28 + (i8 * 20 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i7 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
    break;
   }
   if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] = i7;
    break;
   } else {
    HEAP8[i3 >> 0] = i7;
    break;
   }
  } while (0);
  HEAP32[i11 + 28 + (i8 * 20 | 0) + 16 >> 2] = HEAP32[i9 + (i8 * 20 | 0) + 16 >> 2];
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 32);
 i1 = i11 + 28 | 0;
 i6 = i1 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i11 + 32 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = i2 & 255;
  i5 = i1;
 }
 i3 = i4 >>> 0 > 7;
 i2 = i3 ? 7 : i4;
 if (!i2) i10 = 36; else if (!(_memcmp(i5, gb + 1012705 | 0, i2) | 0)) i10 = 36;
 if ((i10 | 0) == 36) if (i4 >>> 0 > 6 & (i3 ^ 1)) {
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i12 + 11 | 0;
  HEAP8[i4 >> 0] = 8;
  i10 = i12;
  HEAP32[i10 >> 2] = 1802264919;
  HEAP32[i10 + 4 >> 2] = 1701601889;
  HEAP8[i12 + 8 >> 0] = 0;
  L53 : do if ((i1 | 0) != (i12 | 0)) {
   do if ((HEAP8[i6 >> 0] | 0) < 0) {
    i2 = HEAP32[i11 + 36 >> 2] & 2147483647;
    i3 = i2 + -1 | 0;
    if (i3 >>> 0 < 8) {
     i11 = HEAP32[i11 + 32 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i11, 0, i11, 8, i12);
     break L53;
    } else {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } while (0);
   i9 = i12;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i10 = i1;
   i8 = i10;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = i9;
   HEAP8[i10 + 1 >> 0] = i9 >> 8;
   HEAP8[i10 + 2 >> 0] = i9 >> 16;
   HEAP8[i10 + 3 >> 0] = i9 >> 24;
   HEAP8[i1 + 8 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i11 + 32 >> 2] = 8;
    break;
   } else {
    HEAP8[i6 >> 0] = 8;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i13);
  }
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i13 + 4 | 0;
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i15 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
    i2 = HEAP32[i15 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i16;
 return;
}

function __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i6) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 32 | 0;
 i14 = i16 + 16 | 0;
 i12 = i16;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i6);
 HEAP32[i14 >> 2] = 0;
 i15 = i14 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i7 = i14 + 8 | 0;
 i8 = i13 + 4 | 0;
 i1 = 0;
 i5 = 0;
 i2 = 0;
 while (1) {
  i3 = i11 + 28 + (i1 * 20 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i14, i3); else {
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i2 ? HEAP32[i11 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i10 = 7;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i5 + 11 >> 0] = i4;
    if (!i4) i2 = i5; else {
     i2 = i5;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i9 = i4 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i9 | -2147483648;
    HEAP32[i5 + 4 >> 2] = i4;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 28 + (i1 * 20 | 0) + 16 >> 2];
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 20;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i5 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i6, i14, 0);
 i8 = 0;
 do {
  i5 = i11 + 28 + (i8 * 20 | 0) | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i1 = i9 + (i8 * 20 | 0) | 0;
  do if ((i5 | 0) != (i1 | 0)) {
   i7 = HEAP8[i1 + 11 >> 0] | 0;
   i3 = i7 << 24 >> 24 < 0;
   i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
   i7 = i3 ? HEAP32[i9 + (i8 * 20 | 0) + 4 >> 2] | 0 : i7 & 255;
   i3 = i5 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i11 + 28 + (i8 * 20 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i7 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
    break;
   }
   if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i11 + 28 + (i8 * 20 | 0) + 4 >> 2] = i7;
    break;
   } else {
    HEAP8[i3 >> 0] = i7;
    break;
   }
  } while (0);
  HEAP32[i11 + 28 + (i8 * 20 | 0) + 16 >> 2] = HEAP32[i9 + (i8 * 20 | 0) + 16 >> 2];
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 32);
 i1 = i11 + 28 | 0;
 i6 = i1 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i11 + 32 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = i2 & 255;
  i5 = i1;
 }
 i3 = i4 >>> 0 > 7;
 i2 = i3 ? 7 : i4;
 if (!i2) i10 = 36; else if (!(_memcmp(i5, gb + 1012705 | 0, i2) | 0)) i10 = 36;
 if ((i10 | 0) == 36) if (i4 >>> 0 > 6 & (i3 ^ 1)) {
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i12 + 11 | 0;
  HEAP8[i4 >> 0] = 8;
  i10 = i12;
  HEAP32[i10 >> 2] = 1802264919;
  HEAP32[i10 + 4 >> 2] = 1701601889;
  HEAP8[i12 + 8 >> 0] = 0;
  L53 : do if ((i1 | 0) != (i12 | 0)) {
   do if ((HEAP8[i6 >> 0] | 0) < 0) {
    i2 = HEAP32[i11 + 36 >> 2] & 2147483647;
    i3 = i2 + -1 | 0;
    if (i3 >>> 0 < 8) {
     i11 = HEAP32[i11 + 32 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i11, 0, i11, 8, i12);
     break L53;
    } else {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } while (0);
   i9 = i12;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i10 = i1;
   i8 = i10;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i10 = i10 + 4 | 0;
   HEAP8[i10 >> 0] = i9;
   HEAP8[i10 + 1 >> 0] = i9 >> 8;
   HEAP8[i10 + 2 >> 0] = i9 >> 16;
   HEAP8[i10 + 3 >> 0] = i9 >> 24;
   HEAP8[i1 + 8 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i11 + 32 >> 2] = 8;
    break;
   } else {
    HEAP8[i6 >> 0] = 8;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i13 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i13);
  }
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i13 + 4 | 0;
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i15 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
    i2 = HEAP32[i15 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i16;
 return;
}

function _compress_data(i32, i21) {
 i32 = i32 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0;
 i31 = i32 + 328 | 0;
 i2 = HEAP32[i31 >> 2] | 0;
 i28 = (HEAP32[i32 + 248 >> 2] | 0) + -1 | 0;
 i33 = i32 + 224 | 0;
 i29 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
 i22 = i2 + 16 | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i23 = i2 + 20 | 0;
 i5 = HEAP32[i23 >> 2] | 0;
 do if ((i4 | 0) < (i5 | 0)) {
  i24 = i2 + 12 | 0;
  i3 = i32 + 228 | 0;
  i1 = i2 + 8 | 0;
  i25 = i32 + 344 | 0;
  i26 = i32 + 348 | 0;
  i27 = i2 + 24 | 0;
  i6 = HEAP32[i24 >> 2] | 0;
  L3 : while (1) {
   if (i6 >>> 0 <= i28 >>> 0) {
    i20 = i4 << 3;
    i5 = i6;
    do {
     i7 = HEAP32[i3 >> 2] | 0;
     if ((i7 | 0) > 0) if (i5 >>> 0 < i28 >>> 0) {
      i6 = 0;
      i19 = 0;
      do {
       i14 = HEAP32[i32 + 232 + (i19 << 2) >> 2] | 0;
       i15 = i14 + 52 | 0;
       i16 = HEAP32[i15 >> 2] | 0;
       i17 = Math_imul(HEAP32[i14 + 64 >> 2] | 0, i5) | 0;
       i18 = i14 + 56 | 0;
       if ((HEAP32[i18 >> 2] | 0) > 0) {
        i13 = i14 + 4 | 0;
        i12 = i14 + 72 | 0;
        i10 = i20;
        i11 = 0;
        i7 = i16;
        while (1) {
         if ((HEAP32[i1 >> 2] | 0) >>> 0 < i29 >>> 0) i30 = 15; else if ((i11 + i4 | 0) < (HEAP32[i12 >> 2] | 0)) i30 = 15; else {
          _jzero_far(HEAP32[i2 + 24 + (i6 << 2) >> 2] | 0, i7 << 7);
          i8 = HEAP32[i15 >> 2] | 0;
          if ((i8 | 0) > 0) {
           i9 = HEAP32[i2 + 24 + (i6 + -1 << 2) >> 2] | 0;
           i7 = 0;
           do {
            HEAP16[HEAP32[i2 + 24 + (i7 + i6 << 2) >> 2] >> 1] = HEAP16[i9 >> 1] | 0;
            i7 = i7 + 1 | 0;
           } while ((i7 | 0) < (i8 | 0));
          }
         }
         if ((i30 | 0) == 15) {
          i30 = 0;
          mftCall_viiiiiii(HEAP32[(HEAP32[i25 >> 2] | 0) + 4 >> 2] | 0, i32 | 0, i14 | 0, HEAP32[i21 + (HEAP32[i13 >> 2] << 2) >> 2] | 0, HEAP32[i2 + 24 + (i6 << 2) >> 2] | 0, i10 | 0, i17 | 0, i16 | 0);
          i7 = HEAP32[i15 >> 2] | 0;
          if ((i7 | 0) > (i16 | 0)) {
           _jzero_far(HEAP32[i2 + 24 + (i6 + i16 << 2) >> 2] | 0, i7 - i16 << 7);
           i8 = HEAP32[i15 >> 2] | 0;
           if ((i16 | 0) < (i8 | 0)) {
            i7 = i16;
            do {
             i9 = i7 + i6 | 0;
             HEAP16[HEAP32[i2 + 24 + (i9 << 2) >> 2] >> 1] = HEAP16[HEAP32[i2 + 24 + (i9 + -1 << 2) >> 2] >> 1] | 0;
             i7 = i7 + 1 | 0;
            } while ((i7 | 0) < (i8 | 0));
           }
          }
         }
         i7 = HEAP32[i15 >> 2] | 0;
         i6 = i7 + i6 | 0;
         i11 = i11 + 1 | 0;
         if ((i11 | 0) >= (HEAP32[i18 >> 2] | 0)) break; else i10 = i10 + 8 | 0;
        }
        i7 = HEAP32[i3 >> 2] | 0;
       }
       i19 = i19 + 1 | 0;
      } while ((i19 | 0) < (i7 | 0));
     } else {
      i6 = 0;
      i19 = 0;
      do {
       i16 = HEAP32[i32 + 232 + (i19 << 2) >> 2] | 0;
       i17 = i16 + 52 | 0;
       i18 = HEAP32[i16 + 68 >> 2] | 0;
       i14 = Math_imul(HEAP32[i16 + 64 >> 2] | 0, i5) | 0;
       i15 = i16 + 56 | 0;
       if ((HEAP32[i15 >> 2] | 0) > 0) {
        i12 = i16 + 4 | 0;
        i13 = i16 + 72 | 0;
        i10 = i20;
        i11 = 0;
        while (1) {
         if ((HEAP32[i1 >> 2] | 0) >>> 0 < i29 >>> 0) i30 = 25; else if ((i11 + i4 | 0) < (HEAP32[i13 >> 2] | 0)) i30 = 25; else {
          _jzero_far(HEAP32[i2 + 24 + (i6 << 2) >> 2] | 0, HEAP32[i17 >> 2] << 7);
          i7 = HEAP32[i17 >> 2] | 0;
          if ((i7 | 0) > 0) {
           i9 = HEAP32[i2 + 24 + (i6 + -1 << 2) >> 2] | 0;
           i8 = 0;
           do {
            HEAP16[HEAP32[i2 + 24 + (i8 + i6 << 2) >> 2] >> 1] = HEAP16[i9 >> 1] | 0;
            i8 = i8 + 1 | 0;
           } while ((i8 | 0) < (i7 | 0));
          }
         }
         if ((i30 | 0) == 25) {
          i30 = 0;
          mftCall_viiiiiii(HEAP32[(HEAP32[i25 >> 2] | 0) + 4 >> 2] | 0, i32 | 0, i16 | 0, HEAP32[i21 + (HEAP32[i12 >> 2] << 2) >> 2] | 0, HEAP32[i2 + 24 + (i6 << 2) >> 2] | 0, i10 | 0, i14 | 0, i18 | 0);
          i7 = HEAP32[i17 >> 2] | 0;
          if ((i7 | 0) > (i18 | 0)) {
           _jzero_far(HEAP32[i2 + 24 + (i6 + i18 << 2) >> 2] | 0, i7 - i18 << 7);
           i7 = HEAP32[i17 >> 2] | 0;
           if ((i18 | 0) < (i7 | 0)) {
            i8 = i18;
            do {
             i9 = i8 + i6 | 0;
             HEAP16[HEAP32[i2 + 24 + (i9 << 2) >> 2] >> 1] = HEAP16[HEAP32[i2 + 24 + (i9 + -1 << 2) >> 2] >> 1] | 0;
             i8 = i8 + 1 | 0;
            } while ((i8 | 0) < (i7 | 0));
           }
          }
         }
         i6 = i7 + i6 | 0;
         i11 = i11 + 1 | 0;
         if ((i11 | 0) >= (HEAP32[i15 >> 2] | 0)) break; else i10 = i10 + 8 | 0;
        }
        i7 = HEAP32[i3 >> 2] | 0;
       }
       i19 = i19 + 1 | 0;
      } while ((i19 | 0) < (i7 | 0));
     }
     if (!((mftCall_iii(HEAP32[(HEAP32[i26 >> 2] | 0) + 4 >> 2] | 0, i32 | 0, i27 | 0) | 0) << 24 >> 24)) break L3;
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 <= i28 >>> 0);
    i5 = HEAP32[i23 >> 2] | 0;
   }
   HEAP32[i24 >> 2] = 0;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) < (i5 | 0)) i6 = 0; else {
    i30 = 39;
    break;
   }
  }
  if ((i30 | 0) == 39) {
   i2 = HEAP32[i31 >> 2] | 0;
   break;
  }
  HEAP32[i22 >> 2] = i4;
  HEAP32[i24 >> 2] = i5;
  i33 = 0;
  return i33 | 0;
 } else {
  i3 = i32 + 228 | 0;
  i1 = i2 + 8 | 0;
 } while (0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 do if ((HEAP32[i3 >> 2] | 0) > 1) HEAP32[i2 + 20 >> 2] = 1; else {
  i1 = HEAP32[i32 + 232 >> 2] | 0;
  if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 < ((HEAP32[i33 >> 2] | 0) + -1 | 0) >>> 0) {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i33 = 1;
 return i33 | 0;
}

function __ZN5physx2Gu20computeMTD_SphereBoxERNS_6PxVec3ERfRKNS0_6SphereERKNS0_3BoxE(i21, i23, i3, i2) {
 i21 = i21 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f22 = f0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i24;
 f22 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i25, i2);
 f16 = Math_fround(HEAPF32[i25 >> 2]);
 f17 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f9 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f9);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f10);
 f7 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f7);
 f4 = Math_fround(f9 * Math_fround(2.0));
 f11 = Math_fround(f10 * Math_fround(2.0));
 f6 = Math_fround(f7 * Math_fround(2.0));
 f15 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f14 = Math_fround(Math_fround(Math_fround(f16 * f4) + Math_fround(f17 * f11)) + Math_fround(f18 * f6));
 f1 = Math_fround(Math_fround(f16 * f14) + Math_fround(Math_fround(f15 * f4) - Math_fround(f19 * Math_fround(Math_fround(f17 * f6) - Math_fround(f18 * f11)))));
 f5 = Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f15 * f11) - Math_fround(f19 * Math_fround(Math_fround(f18 * f4) - Math_fround(f16 * f6)))));
 f14 = Math_fround(Math_fround(Math_fround(f15 * f6) - Math_fround(f19 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f4)))) + Math_fround(f18 * f14));
 f4 = Math_fround(-f8);
 if (f1 < f4) {
  f11 = f4;
  i2 = 1;
 } else if (f1 > f8) {
  f11 = f8;
  i2 = 1;
 } else {
  f11 = f1;
  i2 = 0;
 }
 f1 = Math_fround(-f12);
 if (f5 < f1) {
  f6 = f1;
  i3 = 1;
 } else if (f5 > f12) {
  f6 = f12;
  i3 = 1;
 } else {
  f6 = f5;
  i3 = i2;
 }
 f1 = Math_fround(-f13);
 if (f14 < f1) i20 = 9; else {
  i2 = f14 > f13;
  if (i2 | i3) {
   f1 = i2 ? f13 : f14;
   i20 = 9;
  } else {
   f5 = Math_fround(f8 - Math_fround(Math_abs(Math_fround(f11))));
   f4 = Math_fround(f12 - Math_fround(Math_abs(Math_fround(f6))));
   f1 = Math_fround(f13 - Math_fround(Math_abs(Math_fround(f14))));
   do if (f4 < f5) if (f4 < f1) {
    i25 = f6 > Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(-f4);
    i2 = 0;
    f1 = Math_fround(0.0);
    f4 = i25 ? Math_fround(2.0) : Math_fround(-2.0);
    break;
   } else {
    i2 = f14 > Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(-f1);
    i2 = i2 ? 1065353216 : -1082130432;
    f1 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break;
   } else if (f5 < f1) {
    i25 = f11 > Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(-f5);
    i2 = 0;
    f1 = i25 ? Math_fround(2.0) : Math_fround(-2.0);
    f4 = Math_fround(0.0);
    break;
   } else {
    i2 = f14 > Math_fround(0.0);
    HEAPF32[i23 >> 2] = Math_fround(-f1);
    i2 = i2 ? 1065353216 : -1082130432;
    f1 = Math_fround(0.0);
    f4 = Math_fround(0.0);
    break;
   } while (0);
   f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(2.0));
   f11 = Math_fround(Math_fround(f18 * f12) + Math_fround(Math_fround(f17 * f4) + Math_fround(f16 * f1)));
   f13 = Math_fround(Math_fround(f17 * f11) + Math_fround(Math_fround(f15 * f4) + Math_fround(f19 * Math_fround(Math_fround(f18 * f1) - Math_fround(f16 * f12)))));
   f14 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(f19 * Math_fround(Math_fround(f16 * f4) - Math_fround(f17 * f1)))) + Math_fround(f18 * f11));
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f15 * f1) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f4)))));
   HEAPF32[i21 + 4 >> 2] = f13;
   HEAPF32[i21 + 8 >> 2] = f14;
   f1 = Math_fround(HEAPF32[i23 >> 2]);
  }
 }
 do if ((i20 | 0) == 9) {
  f11 = Math_fround(f11 * Math_fround(2.0));
  f8 = Math_fround(f6 * Math_fround(2.0));
  f12 = Math_fround(f1 * Math_fround(2.0));
  f13 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(f17 * f8)) + Math_fround(f18 * f12));
  f14 = Math_fround(f9 - Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(f15 * f11) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f8))))));
  f1 = Math_fround(f10 - Math_fround(Math_fround(f17 * f13) + Math_fround(Math_fround(f15 * f8) + Math_fround(f19 * Math_fround(Math_fround(f18 * f11) - Math_fround(f16 * f12))))));
  f19 = Math_fround(f7 - Math_fround(Math_fround(Math_fround(f19 * Math_fround(Math_fround(f16 * f8) - Math_fround(f17 * f11))) + Math_fround(f15 * f12)) + Math_fround(f18 * f13)));
  HEAPF32[i21 >> 2] = f14;
  i2 = i21 + 4 | 0;
  HEAPF32[i2 >> 2] = f1;
  i3 = i21 + 8 | 0;
  HEAPF32[i3 >> 2] = f19;
  f1 = Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f14 * f14) + Math_fround(f1 * f1)));
  f19 = Math_fround(f22 + Math_fround(0.0));
  if (f1 > Math_fround(f19 * f19)) {
   i25 = 0;
   STACKTOP = i24;
   return i25 | 0;
  } else {
   f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f1))));
   HEAPF32[i23 >> 2] = f19;
   HEAPF32[i21 >> 2] = Math_fround(f19 * Math_fround(HEAPF32[i21 >> 2]));
   HEAPF32[i2 >> 2] = Math_fround(f19 * Math_fround(HEAPF32[i2 >> 2]));
   HEAPF32[i3 >> 2] = Math_fround(f19 * Math_fround(HEAPF32[i3 >> 2]));
   f1 = Math_fround(f1 * Math_fround(HEAPF32[i23 >> 2]));
   break;
  }
 } while (0);
 f19 = Math_fround(f1 - f22);
 f22 = Math_fround(-f19);
 i25 = f19 < Math_fround(-0.0);
 HEAPF32[i23 >> 2] = i25 ? f22 : Math_fround(0.0);
 i25 = 1;
 STACKTOP = i24;
 return i25 | 0;
}

function __ZN11OffMeshLink13AddConnectionEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 32 | 0;
 i8 = i14 + 24 | 0;
 i12 = i14 + 12 | 0;
 i13 = i14;
 i9 = i11 + 52 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i10 = 9;
 }
 if ((i10 | 0) == 7) i10 = 9;
 if ((i10 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0)) {
  STACKTOP = i14;
  return;
 }
 i4 = i11 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 16; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i10 = 18;
 }
 if ((i10 | 0) == 16) i10 = 18;
 if ((i10 | 0) == 18) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  STACKTOP = i14;
  return;
 }
 i5 = i11 + 88 | 0;
 if ((HEAP32[i5 >> 2] | 0) == 1) {
  STACKTOP = i14;
  return;
 }
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 25; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i15 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 25; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i10 = 27;
  }
 }
 if ((i10 | 0) == 25) i10 = 27;
 if ((i10 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 __ZNK9Transform11GetPositionEv(i12, i1);
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 33; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i15 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 33; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i10 = 35;
  }
 }
 if ((i10 | 0) == 33) i10 = 35;
 if ((i10 | 0) == 35) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
 __ZNK9Transform11GetPositionEv(i13, i1);
 i10 = __Z17GetNavMeshManagerv() | 0;
 i10 = __ZN14NavMeshManager20AddOffMeshConnectionERK8Vector3fS2_ibh(i10, i12, i13, i6, (HEAP8[i11 + 98 >> 0] | 0) != 0, HEAP32[i5 >> 2] & 255) | 0;
 i15 = getTempRet0() | 0;
 i1 = i11 + 40 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i9 + 4 >> 2] = i15;
 if ((i10 | 0) == 0 & (i15 | 0) == 0) {
  i15 = i11 + 68 | 0;
  HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  i15 = i11 + 56 | 0;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 } else {
  i13 = __Z17GetNavMeshManagerv() | 0;
  i15 = i1;
  __ZN14NavMeshManager32SetOffMeshConnectionCostOverrideEyf(i13, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, Math_fround(HEAPF32[i11 + 84 >> 2]));
  i15 = __Z17GetNavMeshManagerv() | 0;
  i13 = i1;
  __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb(i15, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, (HEAP8[i11 + 99 >> 0] | 0) != 0);
  i13 = __Z17GetNavMeshManagerv() | 0;
  i15 = i1;
  __ZNK14NavMeshManager20GetOffMeshConnectionEyP8Vector3fS1_Pf(i13, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, i11 + 68 | 0, i11 + 56 | 0, i11 + 80 | 0) | 0;
 }
 STACKTOP = i14;
 return;
}

function _UNITY_tt_face_load_sbit_image(i5, i4, i10, i8, i11, i9, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 48 | 0;
 i7 = i14;
 switch (HEAP32[i5 + 732 >> 2] | 0) {
 case 2:
 case 1:
  {
   i2 = HEAP32[i5 + 104 >> 2] | 0;
   i1 = i5 + 508 | 0;
   if (!(mftCall_iiiii(HEAP32[i1 >> 2] | 0, i5 | 0, 1128416340, i2 | 0, i13 | 0) | 0)) i12 = 5; else if (!(mftCall_iiiii(HEAP32[i1 >> 2] | 0, i5 | 0, 1161970772, i2 | 0, i13 | 0) | 0)) i12 = 5; else {
    i1 = mftCall_iiiii(HEAP32[i1 >> 2] | 0, i5 | 0, 1650745716, i2 | 0, i13 | 0) | 0;
    if (!i1) i12 = 5;
   }
   if ((i12 | 0) == 5) {
    HEAP32[i7 >> 2] = i5;
    HEAP32[i7 + 4 >> 2] = i2;
    i6 = i5 + 84 | 0;
    HEAP32[i7 + 8 >> 2] = (HEAP32[i6 >> 2] | 0) + 76;
    HEAP32[i7 + 12 >> 2] = i3;
    HEAP8[i7 + 16 >> 0] = 0;
    HEAP8[i7 + 17 >> 0] = 0;
    HEAP32[i7 + 20 >> 2] = _UNITY_FT_Stream_Pos(i2) | 0;
    HEAP32[i7 + 24 >> 2] = HEAP32[i13 >> 2];
    i2 = HEAP32[i5 + 724 >> 2] | 0;
    HEAP32[i7 + 36 >> 2] = i2;
    i3 = HEAP32[i5 + 728 >> 2] | 0;
    HEAP32[i7 + 40 >> 2] = i2 + i3;
    i1 = i4 * 48 | 0;
    if (((i1 | 8) + 47 | 0) >>> 0 > i3 >>> 0) i1 = 3; else {
     i12 = i2 + 8 + i1 + 4 | 0;
     i1 = i12 + -4 | 0;
     i1 = HEAPU8[i1 + 1 >> 0] << 16 | HEAPU8[i1 >> 0] << 24 | HEAPU8[i1 + 2 >> 0] << 8 | HEAPU8[i1 + 3 >> 0];
     HEAP32[i7 + 28 >> 2] = i1;
     i12 = i12 + 4 + 4 | 0;
     i2 = i12 + -4 | 0;
     i2 = HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
     HEAP32[i7 + 32 >> 2] = i2;
     HEAP8[i7 + 18 >> 0] = HEAP8[i12 + 34 >> 0] | 0;
     if (i3 >>> 0 < i1 >>> 0) i1 = 3; else if (i2 >>> 0 > (i3 - i1 | 0) >>> 3 >>> 0) i1 = 3; else {
      i1 = _tt_sbit_decoder_load_image(i7, i10, 0, 0) | 0;
      if (i1 | i8 & 1048576 | 0) {
       i13 = i1;
       STACKTOP = i14;
       return i13 | 0;
      }
      i3 = i9 + 18 | 0;
      if ((HEAP8[i3 >> 0] | 0) != 7) {
       i13 = i1;
       STACKTOP = i14;
       return i13 | 0;
      }
      i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
      _UNITY_FT_Bitmap_Init(i13);
      i2 = _UNITY_FT_Bitmap_Convert(i1, i9, i13, 1) | 0;
      if (!i2) {
       HEAP8[i3 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
       HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
       HEAP16[i9 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
       _UNITY_ft_glyphslot_set_bitmap(HEAP32[i6 >> 2] | 0, HEAP32[i13 + 12 >> 2] | 0);
       i13 = (HEAP32[(HEAP32[i6 >> 2] | 0) + 156 >> 2] | 0) + 4 | 0;
       HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
      } else _UNITY_FT_Bitmap_Done(i1, i13) | 0;
      i13 = i2;
      STACKTOP = i14;
      return i13 | 0;
     }
    }
   }
   i13 = i1;
   STACKTOP = i14;
   return i13 | 0;
  }
 case 3:
  {
   HEAP16[i3 + 2 >> 1] = 0;
   HEAP16[i3 >> 1] = 0;
   i8 = (HEAP32[i5 + 724 >> 2] | 0) + 8 + (i4 << 2) + 4 + -4 | 0;
   i8 = HEAPU8[i8 + 1 >> 0] << 16 | HEAPU8[i8 >> 0] << 24 | HEAPU8[i8 + 2 >> 0] << 8 | HEAPU8[i8 + 3 >> 0];
   i1 = mftCall_iiiii(HEAP32[i5 + 508 >> 2] | 0, i5 | 0, 1935829368, i11 | 0, i13 | 0) | 0;
   L25 : do if (!i1) {
    i1 = _UNITY_FT_Stream_Pos(i11) | 0;
    i7 = i5 + 16 | 0;
    if ((HEAP32[i7 >> 2] | 0) >>> 0 < i10 >>> 0) i1 = 6; else {
     i5 = i1 + i8 | 0;
     i6 = i5 + 4 | 0;
     i4 = 0;
     i1 = i10;
     L28 : while (1) {
      i2 = HEAP32[i13 >> 2] | 0;
      if (i2 >>> 0 <= i8 >>> 0) {
       i1 = 3;
       break L25;
      }
      i1 = i1 << 2;
      if ((i2 - i8 | 0) >>> 0 < (i1 + 12 | 0) >>> 0) {
       i1 = 3;
       break L25;
      }
      i1 = _UNITY_FT_Stream_Seek(i11, i6 + i1 | 0) | 0;
      if (i1 | 0) break L25;
      i1 = _UNITY_FT_Stream_EnterFrame(i11, 8) | 0;
      if (i1 | 0) break L25;
      i1 = _UNITY_FT_Stream_GetULong(i11) | 0;
      i2 = _UNITY_FT_Stream_GetULong(i11) | 0;
      _UNITY_FT_Stream_ExitFrame(i11);
      if ((i2 | 0) == (i1 | 0)) {
       i1 = 6;
       break L25;
      }
      if (i2 >>> 0 < i1 >>> 0) {
       i1 = 3;
       break L25;
      }
      i3 = i2 - i1 | 0;
      if (i3 >>> 0 < 8) {
       i1 = 3;
       break L25;
      }
      if (((HEAP32[i13 >> 2] | 0) - i8 | 0) >>> 0 < i2 >>> 0) {
       i1 = 3;
       break L25;
      }
      i1 = _UNITY_FT_Stream_Seek(i11, i1 + i5 | 0) | 0;
      if (i1 | 0) break L25;
      i1 = _UNITY_FT_Stream_EnterFrame(i11, i3) | 0;
      if (i1 | 0) break L25;
      _UNITY_FT_Stream_GetUShort(i11) | 0;
      _UNITY_FT_Stream_GetUShort(i11) | 0;
      i1 = _UNITY_FT_Stream_GetULong(i11) | 0;
      if ((i1 | 0) >= 1919378028) {
       i12 = 36;
       break;
      }
      if ((i1 | 0) >= 1785751328) {
       i12 = 38;
       break;
      }
      switch (i1 | 0) {
      case 1685418085:
       break;
      default:
       {
        i1 = 7;
        break L28;
       }
      }
      if ((i4 | 0) >= 4) {
       i1 = 3;
       break;
      }
      i1 = (_UNITY_FT_Stream_GetUShort(i11) | 0) & 65535;
      _UNITY_FT_Stream_ExitFrame(i11);
      if (i1 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
       i1 = 6;
       break L25;
      } else i4 = i4 + 1 | 0;
     }
     L44 : do if ((i12 | 0) == 36) if ((i1 | 0) < 1953064550) switch (i1 | 0) {
     case 1919378028:
      {
       i12 = 25;
       break L44;
      }
     default:
      {
       i1 = 7;
       break L44;
      }
     } else switch (i1 | 0) {
     case 1953064550:
      {
       i12 = 25;
       break L44;
      }
     default:
      {
       i1 = 7;
       break L44;
      }
     } else if ((i12 | 0) == 38) switch (i1 | 0) {
     case 1785751328:
      {
       i12 = 25;
       break;
      }
     default:
      i1 = 7;
     } while (0);
     if ((i12 | 0) == 25) i1 = 2;
     _UNITY_FT_Stream_ExitFrame(i11);
    }
   } while (0);
   i13 = i1;
   STACKTOP = i14;
   return i13 | 0;
  }
 default:
  {
   i13 = 2;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxSphericalJointENS_29PxSphericalJointGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i2, i5, i4, i7, i6, i1, i3, i17) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 16 | 0;
 i14 = i18 + 120 | 0;
 i16 = i18 + 124 | 0;
 i19 = i18;
 i15 = i18 + 68 | 0;
 HEAP8[i16 >> 0] = 0;
 i11 = i4;
 i8 = i7;
 i9 = i6;
 i10 = i1;
 i12 = i3;
 i6 = i16;
 HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 4 >> 2] = i11;
 i4 = i13 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i8;
 HEAP32[i13 + 24 >> 2] = i9;
 HEAP32[i13 + 28 >> 2] = i10;
 HEAP32[i13 + 32 >> 2] = i12;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i6;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEEEEjT_j(i17, i13, 0) | 0;
 HEAP32[i15 >> 2] = i5;
 HEAP32[i15 + 4 >> 2] = i11;
 i11 = i15 + 8 | 0;
 HEAP32[i11 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 i11 = i15 + 20 | 0;
 HEAP32[i11 >> 2] = i8;
 i8 = i15 + 24 | 0;
 HEAP32[i8 >> 2] = i9;
 i9 = i15 + 28 | 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i15 + 32 >> 2] = i12;
 i12 = i15 + 36 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i6;
 i6 = i15 + 44 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj477ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i17 + 236 | 0, 0);
 i10 = HEAP32[i17 + 264 >> 2] | 0;
 i5 = HEAP32[i17 + 252 >> 2] | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i4) {
  i7 = i2;
  i1 = 0;
 } else {
  i3 = i4 + -1 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i3 << 3) + 4 >> 0] | 0)) {
   if (!(HEAP8[i12 >> 0] | 0)) {
    i3 = i4;
    i2 = 0;
   } else {
    i2 = HEAP32[i11 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i3 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i12 >> 0] = i2;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i1 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + ((HEAP32[i1 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i1 = HEAP32[i15 >> 2] | 0;
   i7 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } else {
   i7 = i2;
   i1 = i4;
  }
 }
 i2 = HEAP8[i12 >> 0] | 0;
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 HEAP8[i13 + 5 >> 0] = i2;
 i5 = i7 + 8 | 0;
 if ((HEAP32[i7 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i3 = i13;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i19 = (HEAP32[i7 + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i19 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i7, i13) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i13 >> 2] = 0;
 if (i2 << 24 >> 24) {
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
  i19 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i13 | 0) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  if (!((i1 | 0) == 0 | i19 ^ 1)) if (HEAP8[i1 >> 0] | 0) {
   HEAP32[i14 >> 2] = 0;
   __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i9 >> 2] | 0, i14, gb + 115184 | 0);
   i19 = HEAP32[i8 >> 2] | 0;
   HEAP16[i13 >> 1] = HEAP32[i14 >> 2];
   mftCall_vii(i10 | 0, i19 | 0, i13 | 0);
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP8[i12 >> 0] = 1;
  i19 = i17 + 268 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i19, 2);
  i19 = HEAP8[i16 >> 0] | 0;
  i19 = i19 << 24 >> 24 == 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = i7 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (HEAP8[i2 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i2 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i19 = i1 + -1 | 0;
 HEAP32[i5 >> 2] = i19;
 HEAP8[i12 >> 0] = 1;
 if (!i19) {
  i19 = i17 + 268 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i19, 2);
  i19 = HEAP8[i16 >> 0] | 0;
  i19 = i19 << 24 >> 24 == 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 if (HEAP8[(HEAP32[i4 >> 2] | 0) + (i1 + -2 << 3) + 5 >> 0] | 0) {
  i19 = i17 + 268 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i19, 2);
  i19 = HEAP8[i16 >> 0] | 0;
  i19 = i19 << 24 >> 24 == 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 HEAP8[i12 >> 0] = 0;
 i19 = i17 + 268 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i19, 2);
 i19 = HEAP8[i16 >> 0] | 0;
 i19 = i19 << 24 >> 24 == 0;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 8 | 0;
 i1 = i17;
 i6 = i17 + 32 | 0;
 i12 = i13 + 328 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i16 = i13 + 228 | 0;
 if (!(HEAP32[i16 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 112 >> 2] | 0, i13 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i15 = HEAP32[i16 >> 2] | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 96 >> 2] | 0, i15 | 0) | 0;
 if (!i15) {
  STACKTOP = i17;
  return;
 }
 i11 = HEAP32[i15 + 4 >> 2] | 0;
 i7 = i13 + 340 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) != Math_fround(1.0)) {
  i9 = HEAP32[i16 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 232 >> 2] | 0, i9 | 0) | 0)) i10 = 6; else {
   i4 = gb + 64016 | 0;
   i9 = HEAP32[i4 + 4 >> 2] | 0;
   i8 = i1;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = 0;
   i8 = i6 + 16 | 0;
   HEAP32[i8 >> 2] = 0;
   i9 = i6 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i1);
   i4 = i14;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i9;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = HEAP32[i13 + 240 >> 2] | 0;
   HEAP32[i6 + 12 >> 2] = i1;
   if (!i1) i1 = 0; else {
    HEAP32[i8 >> 2] = i1;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 4, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i6 >> 2] = i1;
   }
   i2 = HEAP32[i16 >> 2] | 0;
   mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 228 >> 2] | 0, i2 | 0, i1 | 0) | 0;
   i2 = i13 + 244 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i3 = i13 + 248 | 0;
    i4 = i13 + 336 | 0;
    i5 = i13 + 288 | 0;
    i1 = 0;
    do {
     i18 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i1) | 0) | 0;
     i20 = HEAPU16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0;
     i21 = HEAP32[i5 >> 2] | 0;
     i19 = i21 + (i20 * 12 | 0) | 0;
     i30 = HEAP32[i6 >> 2] | 0;
     f25 = Math_fround(HEAPF32[i30 + (i20 << 4) >> 2]);
     f23 = Math_fround(HEAPF32[i30 + (i20 << 4) + 4 >> 2]);
     f22 = Math_fround(HEAPF32[i30 + (i20 << 4) + 8 >> 2]);
     f27 = Math_fround(HEAPF32[i11 + (i20 << 4) >> 2]);
     f29 = Math_fround(HEAPF32[i11 + (i20 << 4) + 4 >> 2]);
     f28 = Math_fround(HEAPF32[i11 + (i20 << 4) + 8 >> 2]);
     f26 = Math_fround(HEAPF32[i7 >> 2]);
     f24 = Math_fround(Math_fround(1.0) - f26);
     f23 = Math_fround(Math_fround(f29 * f26) + Math_fround(f23 * f24));
     f22 = Math_fround(Math_fround(f28 * f26) + Math_fround(f22 * f24));
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f24));
     HEAPF32[i21 + (i20 * 12 | 0) + 4 >> 2] = f23;
     HEAPF32[i21 + (i20 * 12 | 0) + 8 >> 2] = f22;
     HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
     HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
   }
   if ((HEAP32[i8 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i9);
    HEAP32[i6 >> 2] = 0;
   }
  }
 } else i10 = 6;
 if ((i10 | 0) == 6) {
  i2 = i13 + 244 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i13 + 248 | 0;
   i4 = i13 + 336 | 0;
   i5 = i13 + 288 | 0;
   i1 = 0;
   do {
    i30 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i1) | 0) | 0;
    i20 = HEAPU16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0;
    i19 = HEAP32[i5 >> 2] | 0;
    i21 = i19 + (i20 * 12 | 0) | 0;
    i10 = HEAP32[i11 + (i20 << 4) + 4 >> 2] | 0;
    i18 = HEAP32[i11 + (i20 << 4) + 8 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i11 + (i20 << 4) >> 2];
    HEAP32[i19 + (i20 * 12 | 0) + 4 >> 2] = i10;
    HEAP32[i19 + (i20 * 12 | 0) + 8 >> 2] = i18;
    HEAP32[i30 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i30 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i30 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
 }
 i2 = i13 + 332 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  __ZN5Unity5Cloth13UpdateNormalsEv(i13);
  i3 = i13 + 244 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = i13 + 248 | 0;
   i5 = i13 + 336 | 0;
   i6 = i13 + 308 | 0;
   i1 = 0;
   do {
    i30 = (HEAP32[i2 >> 2] | 0) + (Math_imul(HEAP32[i5 >> 2] | 0, i1) | 0) | 0;
    i21 = (HEAP32[i6 >> 2] | 0) + ((HEAPU16[(HEAP32[i4 >> 2] | 0) + (i1 << 1) >> 1] | 0) * 12 | 0) | 0;
    HEAP32[i30 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i30 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i30 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 4 >> 2] | 0, i15 | 0);
 i30 = HEAP32[i16 >> 2] | 0;
 mftCall_viif(HEAP32[(HEAP32[i30 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i30 | 0, 1.0);
 f23 = Math_fround(HEAPF32[i14 >> 2]);
 f28 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f31 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f25 = Math_fround(Math_fround(f28 + f31) * Math_fround(.5));
 f26 = Math_fround(Math_fround(f29 + f22) * Math_fround(.5));
 f27 = Math_fround(Math_fround(f24 - f23) * Math_fround(.5));
 f28 = Math_fround(Math_fround(f31 - f28) * Math_fround(.5));
 f29 = Math_fround(Math_fround(f22 - f29) * Math_fround(.5));
 HEAPF32[i13 + 96 >> 2] = Math_fround(Math_fround(f23 + f24) * Math_fround(.5));
 HEAPF32[i13 + 100 >> 2] = f25;
 HEAPF32[i13 + 104 >> 2] = f26;
 HEAPF32[i13 + 108 >> 2] = f27;
 HEAPF32[i13 + 112 >> 2] = f28;
 HEAPF32[i13 + 116 >> 2] = f29;
 STACKTOP = i17;
 return;
}

function __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i4, i7, i5, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 816 | 0;
 i11 = i17 + 544 | 0;
 i15 = i17 + 272 | 0;
 i14 = i17;
 if (i1) {
  __ZN5physx3Scb5Scene16removeRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE(i4, i7, i4 + 2580 | 0);
  i1 = i7 + 236 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[((i2 & 4096 | 0) == 0 ? i7 + 60 | 0 : (HEAP32[i7 + 8 >> 2] | 0) + 268 | 0) >> 0] & 1)) {
   HEAP32[i7 + 232 >> 2] = 1;
   HEAP32[i1 >> 2] = i2 & -245761;
  } else __ZN5physx3Scb4Body18putToSleepInternalEv(i7);
  i16 = i7 + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & -33;
  STACKTOP = i17;
  return;
 }
 i2 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 do if ((HEAP32[i6 >> 2] & -1073741824 | 0) == 1073741824) {
  i3 = i7 + 172 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i13 = __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, 1) | 0;
   i1 = (HEAP32[i3 >> 2] | 0) == 0;
   if (i13) {
    if (i1) break;
    __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i2, HEAP32[(HEAP32[i7 >> 2] | 0) + 1248 >> 2] | 0, 1);
    break;
   }
   if (!i1) {
    i13 = (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, 0) | 0) ^ 1;
    if (!((HEAP32[i3 >> 2] | 0) == 0 | i13)) __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i2, HEAP32[(HEAP32[i7 >> 2] | 0) + 1248 >> 2] | 0, 0);
   }
  }
 } while (0);
 i1 = i4 + 2580 | 0;
 i3 = i4 + 2433 | 0;
 L19 : do if (!(HEAP8[i3 >> 0] | 0)) {
  __ZN10ScSceneFnsIN5physx3Scb4BodyEE6removeERNS0_2Sc5SceneERS2_b(i4 + 16 | 0, i7, i5);
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 268435455;
  HEAP32[i7 >> 2] = 0;
 } else {
  i2 = HEAP32[i6 >> 2] | 0;
  switch (i2 >>> 30 | 0) {
  case 1:
   {
    HEAP32[i6 >> 2] = i2 & 1073741823;
    HEAP32[i16 >> 2] = i7;
    __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i16) | 0;
    break L19;
   }
  case 2:
   break;
  default:
   break L19;
  }
  HEAP32[i6 >> 2] = i2 | -1073741824;
  if (!(i2 & 268435456)) {
   HEAP32[i11 >> 2] = i7;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i11, i16) | 0;
   if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  }
 } while (0);
 i1 = i7 + 236 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[((i2 & 4096 | 0) == 0 ? i7 + 60 | 0 : (HEAP32[i7 + 8 >> 2] | 0) + 268 | 0) >> 0] & 1)) {
  HEAP32[i7 + 232 >> 2] = 1;
  HEAP32[i1 >> 2] = i2 & -245761;
 } else __ZN5physx3Scb4Body18putToSleepInternalEv(i7);
 i1 = HEAP32[i6 >> 2] & -33;
 HEAP32[i6 >> 2] = i1;
 if (!(HEAP8[i3 >> 0] | 0)) {
  STACKTOP = i17;
  return;
 }
 if (i5) HEAP32[i6 >> 2] = i1 | 16;
 i1 = HEAP32[i4 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i7, i16) | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i7, i16) | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator21combineClusterPortalsEii(i2, i1, i28) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, f42 = f0, f43 = f0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i35 + 64 | 0;
 i31 = i35 + 40 | 0;
 i32 = i35 + 16 | 0;
 i33 = i35;
 i34 = i2 + 68 | 0;
 i3 = HEAP32[i34 >> 2] | 0;
 i4 = HEAP32[i3 + (i28 << 5) >> 2] | 0;
 if (!i4) {
  STACKTOP = i35;
  return;
 }
 if (!(HEAP32[i4 + 44 >> 2] & 1)) {
  STACKTOP = i35;
  return;
 }
 if (!(HEAP32[i3 + (i28 << 5) + 16 >> 2] | 0)) {
  STACKTOP = i35;
  return;
 }
 i29 = HEAP32[i3 + (i28 << 5) + 24 >> 2] | 0;
 if (!i29) {
  STACKTOP = i35;
  return;
 }
 i17 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i26 = i17 + 20 | 0;
 i17 = i17 + 32 | 0;
 i27 = i31 + 12 | 0;
 HEAP32[i31 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 HEAP32[i27 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i27 = i4 + 12 | 0;
 i17 = i32 + 12 | 0;
 HEAP32[i32 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i32 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i32 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 i17 = i4 + 52 | 0;
 L13 : do if (HEAP32[i17 >> 2] & 65535 | 0) {
  i18 = i32 + 12 | 0;
  f19 = Math_fround(HEAPF32[i31 + 12 >> 2]);
  f19 = Math_fround(f19 - Math_fround(HEAPF32[i31 >> 2]));
  f20 = Math_fround(HEAPF32[i31 + 16 >> 2]);
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i31 + 4 >> 2]));
  f21 = Math_fround(HEAPF32[i31 + 20 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i31 + 8 >> 2]));
  i22 = i30 + 4 | 0;
  i23 = i30 + 8 | 0;
  i12 = i30 + 4 | 0;
  i14 = i30 + 8 | 0;
  i16 = i30 + 12 | 0;
  i11 = i33 + 4 | 0;
  i13 = i33 + 8 | 0;
  i15 = i33 + 12 | 0;
  i24 = i2 + 148 | 0;
  i25 = i2 + 76 | 0;
  i26 = i2 + 460 | 0;
  i27 = i2 + 268 | 0;
  i10 = i2 + 288 | 0;
  i1 = 0;
  i2 = i4;
  while (1) {
   i9 = HEAP32[i2 + (HEAP32[i2 + 56 >> 2] | 0) + (i1 * 36 | 0) + 16 >> 2] | 0;
   i7 = (HEAP32[i3 + (i28 << 5) + 28 >> 2] | 0) + (HEAP32[i29 + (i1 << 3) >> 2] << 4) | 0;
   i8 = i29 + (i1 << 3) + 4 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i6 = 0;
    do {
     i5 = i7 + (i6 << 4) | 0;
     i3 = HEAP32[i5 >> 2] | 0;
     if (!(i3 & 335544320)) {
      i36 = HEAP32[i5 + 8 >> 2] | 0;
      i4 = HEAP32[i5 + 12 >> 2] | 0;
      i41 = i3 >>> 30;
      i3 = ((i41 + 1 | 0) >>> 0) % 3 | 0;
      f38 = Math_fround(HEAPF32[i32 + (i3 << 2) >> 2]);
      i41 = ((i41 + 2 | 0) >>> 0) % 3 | 0;
      f40 = Math_fround(HEAPF32[i32 + (i41 << 2) >> 2]);
      f39 = Math_fround(HEAPF32[i18 + (i3 << 2) >> 2]);
      f43 = Math_fround(HEAPF32[i18 + (i41 << 2) >> 2]);
      HEAPF32[i30 >> 2] = f19;
      HEAPF32[i22 >> 2] = f20;
      HEAPF32[i23 >> 2] = f21;
      f42 = Math_fround(HEAPF32[i31 + (i3 << 2) >> 2]);
      f38 = Math_fround(f38 - f42);
      f37 = Math_fround(HEAPF32[i30 + (i3 << 2) >> 2]);
      f38 = Math_fround(f38 / f37);
      f37 = Math_fround(Math_fround(f39 - f42) / f37);
      f42 = Math_fround(HEAPF32[i31 + (i41 << 2) >> 2]);
      f40 = Math_fround(f40 - f42);
      f39 = Math_fround(HEAPF32[i30 + (i41 << 2) >> 2]);
      f38 = Math_fround(~~Math_fround(f38 * Math_fround(65535.0)) | 0);
      f40 = Math_fround(~~Math_fround(Math_fround(f40 / f39) * Math_fround(65535.0)) | 0);
      f37 = Math_fround(Math_fround(~~Math_fround(f37 * Math_fround(65535.0)) | 0) - f38);
      f39 = Math_fround(Math_fround(~~Math_fround(Math_fround(Math_fround(f43 - f42) / f39) * Math_fround(65535.0)) | 0) - f40);
      f37 = Math_fround(f37 * Math_fround(HEAPF32[gb + 1451560 >> 2]));
      f39 = Math_fround(f39 * Math_fround(HEAPF32[gb + 1451560 + 4 >> 2]));
      f42 = Math_fround(Math_fround(HEAPF32[gb + 1451560 + 8 >> 2]) * Math_fround(0.0));
      i41 = ~~Math_fround(f40 + Math_fround(f39 * Math_fround(i4 >>> 16 | 0)));
      i3 = ~~Math_fround(Math_fround(f42 * Math_fround(0.0)) + Math_fround(0.0));
      i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[gb + 1451560 + 12 >> 2]) * Math_fround(0.0)) * Math_fround(0.0)) + Math_fround(0.0));
      HEAP32[i30 >> 2] = ~~Math_fround(f38 + Math_fround(f37 * Math_fround(i36 >>> 16 | 0)));
      HEAP32[i12 >> 2] = i41;
      HEAP32[i14 >> 2] = i3;
      HEAP32[i16 >> 2] = i2;
      i4 = ~~Math_fround(f40 + Math_fround(f39 * Math_fround(i4 & 65535 | 0)));
      HEAP32[i33 >> 2] = ~~Math_fround(f38 + Math_fround(f37 * Math_fround(i36 & 65535 | 0)));
      HEAP32[i11 >> 2] = i4;
      HEAP32[i13 >> 2] = i3;
      HEAP32[i15 >> 2] = i2;
      i2 = HEAP32[i5 >> 2] | 0;
      i3 = i2 & 67108863;
      i4 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      if ((HEAP32[i25 >> 2] | 0) > (i4 | 0)) {
       i41 = HEAP32[i5 + 4 >> 2] | 0;
       i36 = HEAP32[(HEAP32[i34 >> 2] | 0) + (i4 << 5) >> 2] | 0;
       __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_(i27, (HEAP32[i10 >> 2] | 0) + (i9 << 2) | 0, 0, HEAP32[i36 + (HEAP32[i36 + 56 >> 2] | 0) + ((i41 >>> 16) * 36 | 0) + 16 >> 2] | i2 & -536870912, HEAP32[(HEAP32[i26 >> 2] | 0) + (i3 << 5) >> 2] << 16 | i41 & 65535, i30, i33);
      }
      i2 = HEAP32[i8 >> 2] | 0;
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) < (i2 | 0));
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i17 >> 2] & 65535 | 0)) break L13;
   i3 = HEAP32[i34 >> 2] | 0;
   i2 = HEAP32[i3 + (i28 << 5) >> 2] | 0;
  }
 } while (0);
 STACKTOP = i35;
 return;
}

function _UNITY_tt_face_vary_cvt(i4, i21) {
 i4 = i4 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 8 | 0;
 i1 = i24 + 4 | 0;
 i19 = i24;
 i23 = HEAP32[i21 + 28 >> 2] | 0;
 i20 = HEAP32[i4 + 676 >> 2] | 0;
 if (!i20) {
  HEAP32[i22 >> 2] = 0;
  i19 = 0;
  i20 = 0;
  i21 = 0;
  _UNITY_ft_mem_free(i23, i19);
  _UNITY_ft_mem_free(i23, i20);
  _UNITY_ft_mem_free(i23, i21);
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i18 = i4 + 648 | 0;
 if (!(HEAP32[i18 >> 2] | 0)) {
  HEAP32[i22 >> 2] = 0;
  i19 = 0;
  i20 = 0;
  i21 = 0;
  _UNITY_ft_mem_free(i23, i19);
  _UNITY_ft_mem_free(i23, i20);
  _UNITY_ft_mem_free(i23, i21);
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i17 = mftCall_iiiii(HEAP32[i4 + 508 >> 2] | 0, i4 | 0, 1668702578, i21 | 0, i1 | 0) | 0;
 HEAP32[i22 >> 2] = i17;
 if (i17 | 0) {
  HEAP32[i22 >> 2] = 0;
  i19 = 0;
  i20 = 0;
  i21 = 0;
  _UNITY_ft_mem_free(i23, i19);
  _UNITY_ft_mem_free(i23, i20);
  _UNITY_ft_mem_free(i23, i21);
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i17 = _UNITY_FT_Stream_EnterFrame(i21, HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i22 >> 2] = i17;
 if (i17 | 0) {
  HEAP32[i22 >> 2] = 0;
  i19 = 0;
  i20 = 0;
  i21 = 0;
  _UNITY_ft_mem_free(i23, i19);
  _UNITY_ft_mem_free(i23, i20);
  _UNITY_ft_mem_free(i23, i21);
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i16 = i21 + 32 | 0;
 i5 = (HEAP32[i16 >> 2] | 0) - (HEAP32[i21 >> 2] | 0) | 0;
 if ((_UNITY_FT_Stream_GetULong(i21) | 0) == 65536) {
  i3 = _UNITY_ft_mem_realloc(i23, 4, 0, HEAP32[i20 >> 2] | 0, 0, i22) | 0;
  if (!(HEAP32[i22 >> 2] | 0)) {
   i2 = _UNITY_ft_mem_realloc(i23, 4, 0, HEAP32[i20 >> 2] | 0, 0, i22) | 0;
   if (!(HEAP32[i22 >> 2] | 0)) {
    i1 = _UNITY_ft_mem_realloc(i23, 4, 0, HEAP32[i20 >> 2] | 0, 0, i22) | 0;
    if (!(HEAP32[i22 >> 2] | 0)) {
     i17 = (_UNITY_FT_Stream_GetUShort(i21) | 0) & 65535;
     i6 = _UNITY_FT_Stream_GetUShort(i21) | 0;
     i17 = i17 & 4095;
     if (i17) {
      i15 = i4 + 644 | 0;
      i14 = 0;
      i11 = i5 + (i6 & 65535) | 0;
      while (1) {
       i12 = (_UNITY_FT_Stream_GetUShort(i21) | 0) & 65535;
       i6 = _UNITY_FT_Stream_GetUShort(i21) | 0;
       i7 = i6 & 65535;
       if (!(i7 & 32768)) {
        if (i7 & 16384 | 0) if (HEAP32[i20 >> 2] & 2147483647 | 0) {
         i4 = 0;
         do {
          _UNITY_FT_Stream_GetUShort(i21) | 0;
          i4 = i4 + 1 | 0;
         } while (i4 >>> 0 < HEAP32[i20 >> 2] << 1 >>> 0);
        }
       } else {
        if (!(HEAP32[i20 >> 2] | 0)) i4 = 0; else {
         i5 = 0;
         do {
          HEAP32[i3 + (i5 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i21) | 0) << 16 >> 16 << 2;
          i5 = i5 + 1 | 0;
          i4 = HEAP32[i20 >> 2] | 0;
         } while (i5 >>> 0 < i4 >>> 0);
        }
        if (!((i7 & 16384 | 0) == 0 | (i4 | 0) == 0)) {
         i4 = 0;
         do {
          HEAP32[i2 + (i4 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i21) | 0) << 16 >> 16 << 2;
          i4 = i4 + 1 | 0;
          i5 = HEAP32[i20 >> 2] | 0;
         } while (i4 >>> 0 < i5 >>> 0);
         if (i5 | 0) {
          i4 = 0;
          do {
           HEAP32[i1 + (i4 << 2) >> 2] = (_UNITY_FT_Stream_GetUShort(i21) | 0) << 16 >> 16 << 2;
           i4 = i4 + 1 | 0;
          } while (i4 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0);
         }
        }
        i10 = _ft_var_apply_tuple(i20, i6, i3, i2, i1) | 0;
        if (!((i7 & 8192 | 0) == 0 | (i10 | 0) == 0)) {
         i9 = HEAP32[i21 >> 2] | 0;
         i8 = (HEAP32[i16 >> 2] | 0) - i9 | 0;
         HEAP32[i16 >> 2] = i9 + i11;
         i9 = _ft_var_readpackedpoints(i21, i19) | 0;
         i6 = HEAP32[i19 >> 2] | 0;
         i5 = (i6 | 0) == 0;
         if (i5) i4 = HEAP32[i15 >> 2] | 0; else i4 = i6;
         i7 = _ft_var_readpackeddeltas(i21, i4) | 0;
         do if ((i9 | 0) == 0 | (i7 | 0) == 0) i13 = 37; else if ((i9 | 0) == (-1 | 0)) {
          if (!(HEAP32[i15 >> 2] | 0)) break;
          i4 = 0;
          i5 = HEAP32[i18 >> 2] | 0;
          do {
           i13 = HEAPU16[i5 + (i4 << 1) >> 1] | 0;
           i13 = (_UNITY_FT_MulFix(HEAP16[i7 + (i4 << 1) >> 1] | 0, i10) | 0) + i13 & 65535;
           i5 = HEAP32[i18 >> 2] | 0;
           HEAP16[i5 + (i4 << 1) >> 1] = i13;
           i4 = i4 + 1 | 0;
          } while (i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
          i13 = 37;
         } else {
          if (i5) {
           i13 = 38;
           break;
          }
          i4 = 0;
          i5 = HEAP32[i18 >> 2] | 0;
          do {
           i13 = HEAPU16[i9 + (i4 << 1) >> 1] | 0;
           i25 = HEAPU16[i5 + (i13 << 1) >> 1] | 0;
           i25 = (_UNITY_FT_MulFix(HEAP16[i7 + (i4 << 1) >> 1] | 0, i10) | 0) + i25 & 65535;
           i5 = HEAP32[i18 >> 2] | 0;
           HEAP16[i5 + (i13 << 1) >> 1] = i25;
           i4 = i4 + 1 | 0;
          } while (i4 >>> 0 < i6 >>> 0);
          i13 = 37;
         } while (0);
         if ((i13 | 0) == 37) {
          i13 = 0;
          if ((i9 | 0) != (-1 | 0)) i13 = 38;
         }
         if ((i13 | 0) == 38) {
          i13 = 0;
          _UNITY_ft_mem_free(i23, i9);
         }
         _UNITY_ft_mem_free(i23, i7);
         HEAP32[i16 >> 2] = (HEAP32[i21 >> 2] | 0) + i8;
        }
       }
       i14 = i14 + 1 | 0;
       if ((i14 | 0) == (i17 | 0)) break; else i11 = i12 + i11 | 0;
      }
     }
    }
   } else i1 = 0;
  } else {
   i2 = 0;
   i1 = 0;
  }
 } else {
  HEAP32[i22 >> 2] = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
 }
 _UNITY_FT_Stream_ExitFrame(i21);
 i20 = i3;
 i21 = i2;
 i25 = i1;
 _UNITY_ft_mem_free(i23, i20);
 _UNITY_ft_mem_free(i23, i21);
 _UNITY_ft_mem_free(i23, i25);
 i25 = HEAP32[i22 >> 2] | 0;
 STACKTOP = i24;
 return i25 | 0;
}

function __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i3, i4, i5, i16) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i7 = i4;
 i6 = i3;
 i1 = i7 - i6 | 0;
 i2 = (i1 | 0) > 248;
 L1 : do if ((i5 | 0) > 0 & i2) while (1) {
  i14 = i4 + -8 | 0;
  while (1) {
   i13 = (i1 >> 3) + -1 | 0;
   __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i3, i14, i13, i16);
   i1 = -1;
   i2 = i13;
   while (1) {
    while (1) {
     i11 = i1 + 1 | 0;
     i12 = i3 + (i11 << 3) | 0;
     if ((i11 | 0) == (i13 | 0) | (mftCall_iii(i16 | 0, i12 | 0, i14 | 0) | 0) ^ 1) break; else i1 = i11;
    }
    do {
     i2 = i2 + -1 | 0;
     i8 = i3 + (i2 << 3) | 0;
    } while (!((i2 | 0) == 0 | (mftCall_iii(i16 | 0, i14 | 0, i8 | 0) | 0) ^ 1));
    i10 = i12;
    i9 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    if ((i11 | 0) >= (i2 | 0)) break;
    i19 = i8;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i1 = i12;
    HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i1 + 4 >> 2] = i18;
    i1 = i8;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = i10;
    i1 = i11;
   }
   i8 = i14;
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i12;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i2;
   i11 = i14;
   HEAP32[i11 >> 2] = i9;
   HEAP32[i11 + 4 >> 2] = i10;
   i9 = i3 + (i1 + 2 << 3) | 0;
   i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
   i10 = i3 + (i1 << 3) + 8 | 0;
   i11 = i10;
   i2 = i11 - i6 >> 3;
   i6 = i9;
   i1 = i7 - i6 | 0;
   i8 = i1 >> 3;
   if ((i2 | 0) >= (i8 | 0)) break;
   __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i3, i10, i2, i16);
   i2 = (i1 | 0) > 248;
   if (!((i5 | 0) > 0 & i2)) break L1; else i3 = i9;
  }
  __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i9, i4, i8, i16);
  i6 = i3;
  i1 = i11 - i6 | 0;
  i2 = (i1 | 0) > 248;
  if ((i5 | 0) > 0 & i2) {
   i4 = i10;
   i7 = i11;
  } else {
   i9 = i3;
   i4 = i10;
   break;
  }
 } else i9 = i3; while (0);
 if (!i2) {
  if (i9 >>> 0 < i4 >>> 0 & (i1 | 0) > 8) i1 = i9; else {
   STACKTOP = i17;
   return;
  }
  do {
   L24 : do if (i1 >>> 0 > i9 >>> 0) {
    i2 = i1;
    do {
     i3 = i2;
     i2 = i2 + -8 | 0;
     if (!(mftCall_iii(i16 | 0, i3 | 0, i2 | 0) | 0)) break L24;
     i18 = i3;
     i15 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i13 = i2;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i19 = i3;
     HEAP32[i19 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i19 + 4 >> 2] = i14;
     i19 = i2;
     HEAP32[i19 >> 2] = i15;
     HEAP32[i19 + 4 >> 2] = i18;
    } while (i2 >>> 0 > i9 >>> 0);
   } while (0);
   i1 = i1 + 8 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
  STACKTOP = i17;
  return;
 }
 i7 = i1 >> 3;
 i8 = (i7 + -2 | 0) / 2 | 0;
 i6 = i8;
 while (1) {
  i3 = i9 + (i6 << 3) | 0;
  i1 = i6 << 3;
  if ((i8 | 0) >= (i1 >> 3 | 0)) {
   i5 = i1 >> 2;
   i1 = i5 | 1;
   i2 = i9 + (i1 << 3) | 0;
   i5 = i5 + 2 | 0;
   if ((i5 | 0) < (i7 | 0)) {
    i18 = i2 + 8 | 0;
    i19 = mftCall_iii(i16 | 0, i2 | 0, i18 | 0) | 0;
    i2 = i19 ? i18 : i2;
    i1 = i19 ? i5 : i1;
   }
   if (!(mftCall_iii(i16 | 0, i2 | 0, i3 | 0) | 0)) {
    i18 = i3;
    i19 = HEAP32[i18 + 4 >> 2] | 0;
    i5 = i15;
    HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i5 + 4 >> 2] = i19;
    i5 = i2;
    while (1) {
     i14 = i5;
     i18 = HEAP32[i14 + 4 >> 2] | 0;
     i19 = i3;
     HEAP32[i19 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
     if ((i8 | 0) < (i1 | 0)) break;
     i1 = i1 << 1 | 1;
     i2 = i9 + (i1 << 3) | 0;
     i3 = i1 + 1 | 0;
     if ((i3 | 0) < (i7 | 0)) {
      i18 = i2 + 8 | 0;
      i19 = mftCall_iii(i16 | 0, i2 | 0, i18 | 0) | 0;
      i2 = i19 ? i18 : i2;
      i1 = i19 ? i3 : i1;
     }
     if (mftCall_iii(i16 | 0, i2 | 0, i15 | 0) | 0) break; else {
      i3 = i5;
      i5 = i2;
     }
    }
    i14 = i15;
    i18 = HEAP32[i14 + 4 >> 2] | 0;
    i19 = i5;
    HEAP32[i19 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
   }
  }
  if ((i6 | 0) > 0) i6 = i6 + -1 | 0; else break;
 }
 i8 = i9 + 8 | 0;
 i10 = i9 + 16 | 0;
 do {
  i4 = i4 + -8 | 0;
  i19 = i9;
  i18 = HEAP32[i19 >> 2] | 0;
  i19 = HEAP32[i19 + 4 >> 2] | 0;
  i13 = i4;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = i14;
  i1 = i4;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i1 + 4 >> 2] = i19;
  i1 = i7;
  i7 = i7 + -1 | 0;
  if ((i1 | 0) != 2) {
   i19 = i1 + -3 | 0;
   i6 = (i19 | 0) / 2 | 0;
   if ((i19 | 0) >= -1) {
    if ((i7 | 0) > 2) {
     i2 = mftCall_iii(i16 | 0, i8 | 0, i10 | 0) | 0;
     i1 = i2 ? i10 : i8;
     i2 = i2 ? 2 : 1;
    } else {
     i1 = i8;
     i2 = 1;
    }
    if (!(mftCall_iii(i16 | 0, i1 | 0, i9 | 0) | 0)) {
     i18 = i9;
     i19 = HEAP32[i18 + 4 >> 2] | 0;
     i3 = i15;
     HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i3 + 4 >> 2] = i19;
     i3 = i9;
     while (1) {
      i14 = i1;
      i18 = HEAP32[i14 + 4 >> 2] | 0;
      i19 = i3;
      HEAP32[i19 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i19 + 4 >> 2] = i18;
      if ((i6 | 0) < (i2 | 0)) break;
      i2 = i2 << 1 | 1;
      i3 = i9 + (i2 << 3) | 0;
      i5 = i2 + 1 | 0;
      if ((i5 | 0) < (i7 | 0)) {
       i18 = i3 + 8 | 0;
       i19 = mftCall_iii(i16 | 0, i3 | 0, i18 | 0) | 0;
       i3 = i19 ? i18 : i3;
       i2 = i19 ? i5 : i2;
      }
      if (mftCall_iii(i16 | 0, i3 | 0, i15 | 0) | 0) break; else {
       i19 = i1;
       i1 = i3;
       i3 = i19;
      }
     }
     i14 = i15;
     i18 = HEAP32[i14 + 4 >> 2] | 0;
     i19 = i1;
     HEAP32[i19 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i19 + 4 >> 2] = i18;
    }
   }
  }
 } while ((i7 | 0) > 1);
 STACKTOP = i17;
 return;
}

function __ZNK5physx42PxClothMotionConstraintConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj399ENS_22PxRepXPropertyAccessorILj399ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj400ENS_22PxRepXPropertyAccessorILj400ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 32 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj401ENS_22PxRepXPropertyAccessorILj401ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 3 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 3 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5Umbra15StartCellFinder14findStartCellsENS_12PortalCuller4TileEPKNS_7ImpTileE(i14, i15, i17) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 1664 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 24 | 0;
 i19 = i20;
 i16 = HEAP32[i17 + 28 >> 2] | 0;
 i3 = i17 + 24 | 0;
 i9 = i17 + i16 | 0;
 if ((i16 | 0) == 0 | (i9 | 0) == 0) {
  HEAP32[(HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + 28 >> 2] = 2;
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i18 >> 2] = 0;
 i16 = i18 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i8 = i18 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i1 = i18 + 1632 | 0;
 i2 = i18 + 32 | 0;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 12 >> 2] = -1;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i21 = (HEAP32[i3 >> 2] | 0) >>> 5;
 i11 = HEAP32[i17 + 40 >> 2] | 0;
 i22 = HEAP32[i17 + 36 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i17 + 4 >> 2] | 0;
 i3 = HEAP32[i17 + 8 >> 2] | 0;
 i4 = HEAP32[i17 + 12 >> 2] | 0;
 i5 = HEAP32[i17 + 16 >> 2] | 0;
 i7 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = i18 + 28 | 0;
 HEAP32[i13 >> 2] = -1;
 HEAP32[i18 >> 2] = i21;
 HEAP32[i16 >> 2] = i9;
 HEAP32[i18 + 8 >> 2] = i9 + (((i21 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i8 >> 2] = i17;
 i12 = i18 + 16 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i18 + 20 >> 2] = 4;
 i11 = i18 + 24 | 0;
 HEAP32[i11 >> 2] = i22;
 if (!i21) {
  i1 = 0;
  i2 = -1;
  i10 = 7;
 } else {
  i22 = HEAP32[i9 >> 2] & 3;
  HEAP32[i18 + 32 >> 2] = i1;
  HEAP32[i18 + 36 >> 2] = i2;
  HEAP32[i18 + 40 >> 2] = i3;
  HEAP32[i18 + 44 >> 2] = 0;
  HEAP32[i18 + 48 >> 2] = i4;
  HEAP32[i18 + 52 >> 2] = i5;
  HEAP32[i18 + 56 >> 2] = i7;
  HEAP8[i18 + 60 >> 0] = 0;
  HEAP8[i18 + 61 >> 0] = i22;
  HEAP8[i18 + 62 >> 0] = 63;
  HEAP8[i18 + 63 >> 0] = 0;
  HEAP32[i13 >> 2] = 0;
  i1 = 0;
  i2 = 0;
 }
 L10 : while (1) {
  if ((i10 | 0) == 7) if ((i2 | 0) == -1) break;
  i4 = i14 + 4 | 0;
  i5 = i19 + 12 | 0;
  while (1) {
   i22 = HEAP32[i4 >> 2] | 0;
   i21 = i18 + 32 + (i2 * 40 | 0) | 0;
   i3 = i18 + 32 + (i2 * 40 | 0) + 16 | 0;
   HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i22 = __ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE(i22, i19) | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   if (i22) break;
   i2 = i3 + -1 | 0;
   HEAP32[i13 >> 2] = i2;
   if (!i3) break L10;
  }
  if ((HEAP8[i18 + 32 + (i3 * 40 | 0) + 29 >> 0] | 0) == 3) {
   i2 = HEAP32[i18 + 32 + (i3 * 40 | 0) + 12 >> 2] | 0;
   i2 = i2 - (__ZNK5Umbra6KDTree4rankEi(i18, i2) | 0) | 0;
   i2 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i17, i2, (HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0) + 1184 | 0) | 0;
   if ((i2 | 0) > -1) {
    __ZN5Umbra12PortalCuller12addStartCellERKNS0_4TileEi(HEAP32[i14 >> 2] | 0, i15, i2);
    i1 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
    if (!(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0)) i1 = 1; else if (!(HEAP32[i1 + 32 >> 2] & 16)) i1 = 1; else {
     __ZN5Umbra12QueryContext13visualizeCellEPKNS_7ImpTileEi(i1, i17, i2);
     i1 = 1;
    }
   }
  }
  i2 = HEAP32[i13 >> 2] | 0;
  i4 = i18 + 32 + (i2 * 40 | 0) + 29 | 0;
  i22 = HEAP8[i4 >> 0] | 0;
  i5 = i22 & 255;
  if (i22 << 24 >> 24 == 3) {
   i2 = i2 + -1 | 0;
   HEAP32[i13 >> 2] = i2;
   i10 = 7;
   continue;
  }
  i7 = i18 + 32 + (i2 * 40 | 0) + 12 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i11 >> 2] | 0) > (i8 | 0)) {
   f6 = Math_fround(HEAPF32[(HEAP32[i18 + 12 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2]);
   i3 = i18 + 32 + (i2 * 40 | 0) + (i5 << 2) | 0;
  } else {
   i3 = i18 + 32 + (i2 * 40 | 0) + (i5 << 2) | 0;
   f6 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i18 + 32 + (i2 * 40 | 0) + 16 + (i5 << 2) >> 2])) * Math_fround(.5));
  }
  i10 = i2 + 1 | 0;
  i22 = i18 + 32 + (i10 * 40 | 0) | 0;
  i9 = i18 + 32 + (i2 * 40 | 0) | 0;
  HEAP32[i22 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i22 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i22 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i22 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  i22 = __ZNK5Umbra6KDTree4rankEi(i18, i8) | 0;
  i9 = i22 << 1;
  HEAP32[i7 >> 2] = i9;
  i22 = i22 << 2;
  i21 = HEAP32[i16 >> 2] | 0;
  HEAP8[i4 >> 0] = (HEAP32[i21 + (i22 >> 5 << 2) >> 2] | 0) >>> (i22 & 28) & 3;
  HEAP32[i18 + 32 + (i2 * 40 | 0) + 32 >> 2] = 2;
  HEAPF32[i3 >> 2] = f6;
  i22 = i18 + 32 + (i2 * 40 | 0) + 28 | 0;
  HEAP8[i22 >> 0] = (HEAP8[i22 >> 0] | 0) + 1 << 24 >> 24;
  i22 = i5 << 1;
  i2 = i18 + 32 + (i2 * 40 | 0) + 30 | 0;
  HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] & (1 << i22 ^ 255);
  i2 = i9 + -1 | 0;
  HEAP32[i18 + 32 + (i10 * 40 | 0) + 12 >> 2] = i2;
  i2 = i2 << 1;
  HEAP8[i18 + 32 + (i10 * 40 | 0) + 29 >> 0] = (HEAP32[i21 + (i2 >> 5 << 2) >> 2] | 0) >>> (i2 & 30) & 3;
  HEAP32[i18 + 32 + (i10 * 40 | 0) + 32 >> 2] = 1;
  HEAPF32[i18 + 32 + (i10 * 40 | 0) + 16 + (i5 << 2) >> 2] = f6;
  i2 = i18 + 32 + (i10 * 40 | 0) + 28 | 0;
  HEAP8[i2 >> 0] = (HEAP8[i2 >> 0] | 0) + 1 << 24 >> 24;
  i2 = i18 + 32 + (i10 * 40 | 0) + 30 | 0;
  HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] & (2 << i22 ^ 255);
  HEAP32[i13 >> 2] = i10;
  i2 = i10;
  i10 = 7;
 }
 i22 = i1;
 STACKTOP = i20;
 return i22 | 0;
}

function __ZN11AudioSourceC2E10MemLabelId18ObjectCreationMode(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8 + 16 | 0;
 i3 = i8;
 i9 = i1;
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN14AudioBehaviourC2E10MemLabelId18ObjectCreationMode(i5, i7, i2);
 HEAP32[i5 >> 2] = gb + 175316 + 8;
 i2 = i5 + 36 | 0;
 HEAPF32[i5 + 40 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 i1 = i5 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i5 + 68 >> 2] = Math_fround(inf);
 HEAP32[i5 + 64 >> 2] = 0;
 i1 = i5 + 72 | 0;
 HEAP32[i5 + 104 >> 2] = 0;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i1 = i7;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i5 + 96 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i5 + 116 >> 2] = 2;
 HEAP32[i5 + 112 >> 2] = 2;
 HEAP32[i5 + 120 >> 2] = 4;
 HEAPF32[i5 + 128 >> 2] = Math_fround(inf);
 HEAP32[i5 + 124 >> 2] = 0;
 i4 = i5 + 132 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i5 + 156 >> 2] = Math_fround(inf);
 HEAP32[i5 + 152 >> 2] = 0;
 i4 = i5 + 160 | 0;
 HEAP32[i5 + 192 >> 2] = 0;
 HEAP32[i5 + 196 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i4 = i7;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i5 + 184 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i5 + 204 >> 2] = 2;
 HEAP32[i5 + 200 >> 2] = 2;
 HEAP32[i5 + 208 >> 2] = 4;
 HEAPF32[i5 + 216 >> 2] = Math_fround(inf);
 HEAP32[i5 + 212 >> 2] = 0;
 i1 = i5 + 220 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i5 + 244 >> 2] = Math_fround(inf);
 HEAP32[i5 + 240 >> 2] = 0;
 i1 = i5 + 248 | 0;
 HEAP32[i5 + 280 >> 2] = 0;
 HEAP32[i5 + 284 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i1 = i7;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i5 + 272 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i5 + 292 >> 2] = 2;
 HEAP32[i5 + 288 >> 2] = 2;
 HEAP32[i5 + 296 >> 2] = 4;
 HEAPF32[i5 + 304 >> 2] = Math_fround(inf);
 HEAP32[i5 + 300 >> 2] = 0;
 i4 = i5 + 308 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i5 + 332 >> 2] = Math_fround(inf);
 HEAP32[i5 + 328 >> 2] = 0;
 i4 = i5 + 336 | 0;
 HEAP32[i5 + 368 >> 2] = 0;
 HEAP32[i5 + 372 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i4 = i7;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i5 + 360 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i5 + 380 >> 2] = 2;
 HEAP32[i5 + 376 >> 2] = 2;
 HEAP32[i5 + 384 >> 2] = 4;
 i1 = i5 + 428 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i5 + 432 >> 2] = i1;
 i1 = i5 + 436 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i5 + 452 >> 2] = i5;
 HEAP32[i5 + 456 >> 2] = 0;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 HEAP32[i5 + 464 >> 2] = 0;
 HEAP32[i5 + 468 >> 2] = 0;
 HEAP32[i5 + 472 >> 2] = i5;
 i1 = i5 + 480 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP8[i5 + 497 >> 0] = 1;
 i1 = i5 + 520 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i5 + 528 >> 2] = 0;
 i1 = i5 + 532 | 0;
 i3 = i5 + 498 | 0;
 i4 = i3 + 18 | 0;
 do {
  HEAP16[i3 >> 1] = 0;
  i3 = i3 + 2 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 i9 = i5 + 536 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP8[i9 + 12 >> 0] = 0;
 HEAPF32[i5 + 408 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 412 >> 2] = Math_fround(1.0);
 HEAP32[i5 + 388 >> 2] = 128;
 HEAP8[i5 + 420 >> 0] = 0;
 HEAPF32[i5 + 404 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 392 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 396 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 400 >> 2] = Math_fround(500.0);
 i9 = i5 + 421 | 0;
 HEAP32[i5 + 416 >> 2] = 0;
 HEAP8[i9 >> 0] = 0;
 HEAP8[i9 + 1 >> 0] = 0;
 HEAP8[i9 + 2 >> 0] = 0;
 HEAP8[i9 + 3 >> 0] = 0;
 HEAP8[i9 + 4 >> 0] = 0;
 HEAP8[i9 + 5 >> 0] = 0;
 HEAP8[i9 + 6 >> 0] = 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(0.0), i7);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i2, i6, i6 + 16 | 0);
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(0.0), i7);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i5 + 212 | 0, i6, i6 + 16 | 0);
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(0.0), i7);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i5 + 124 | 0, i6, i6 + 16 | 0);
 HEAP32[gb + 1460020 >> 2] = (HEAP32[gb + 1460020 >> 2] | 0) + 1;
 STACKTOP = i8;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i12 = i16 + 24 | 0;
 i11 = i16;
 i4 = i16 + 20 | 0;
 i5 = i16 + 16 | 0;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = ((HEAP32[i14 >> 2] | 0) - i2 | 0) / 204 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i9 >>> 0) {
  if (i3 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i6 = i1 + (i9 * 204 | 0) | 0;
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  i8 = i12 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i10 = i12 + 12 | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = i9 * 204 | 0;
  i4 = (i3 | 0) / 204 | 0;
  if (!i3) {
   i4 = i12 + 8 | 0;
   i6 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
    i2 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i2;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i12 >> 2] = i3;
   i2 = i3 + (i4 * 204 | 0) | 0;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = i2;
   i5 = i3;
   if (!i9) {
    i4 = i7;
    i6 = i5;
    i3 = i5;
   } else {
    i2 = i3;
    do {
     __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i2, i1);
     i1 = i1 + 204 | 0;
     i2 = (HEAP32[i8 >> 2] | 0) + 204 | 0;
     HEAP32[i8 >> 2] = i2;
    } while ((i1 | 0) != (i6 | 0));
    i4 = i7;
    i6 = HEAP32[i12 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i14 >> 2] = i3;
  i5 = i13 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  i5 = i1;
  i2 = i11;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i4 = i15 + 4 | 0;
    do {
     i1 = i2 + -204 | 0;
     HEAP32[i8 >> 2] = i1;
     i3 = i2 + -36 | 0;
     if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
      HEAP32[i3 >> 2] = 0;
     }
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i14 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -192 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i4 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
     }
     i2 = HEAP32[i8 >> 2] | 0;
    } while ((i2 | 0) != (i5 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i14 = HEAP32[i10 >> 2] | 0;
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i2 | 0) / 204 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i13, i9 - i3 | 0);
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i2;
 __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i11, i9);
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i12, i15);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 204 | 0;
 i5 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i11, i9 - i1 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i6 = i3 + (i9 * 204 | 0) | 0;
  if ((i5 | 0) != (i6 | 0)) {
   i4 = i15 + 4 | 0;
   i2 = i5;
   do {
    i1 = i2 + -204 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i1 >> 2] | 0;
     i9 = HEAP32[i2 + -192 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
    }
    i2 = HEAP32[i8 >> 2] | 0;
   } while ((i2 | 0) != (i6 | 0));
  }
 }
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i13 >> 2] = i5;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i8 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i11 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i4 = i15 + 4 | 0;
   do {
    i1 = i2 + -204 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -192 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
    }
    i2 = HEAP32[i8 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i14 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 >> 2] = 25;
  HEAP32[i15 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 }
 STACKTOP = i16;
 return;
}

function runPostSets243() {
 HEAP32[gb + 216148 >> 2] = fb + 3210;
 HEAP32[gb + 216152 >> 2] = fb + 3214;
 HEAP32[gb + 216156 >> 2] = fb + 3212;
 HEAP32[gb + 216160 >> 2] = fb + 3213;
 HEAP32[gb + 216164 >> 2] = fb + 324;
 HEAP32[gb + 216168 >> 2] = fb + 149;
 HEAP32[gb + 216172 >> 2] = fb + 95;
 HEAP32[gb + 216176 >> 2] = fb + 184;
 HEAP32[gb + 13024 >> 2] = (HEAP32[gb + 13024 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 13028 >> 2] = (HEAP32[gb + 13028 >> 2] | 0) + (gb + 1085040 | 0);
 HEAP32[gb + 13032 >> 2] = (HEAP32[gb + 13032 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13036 >> 2] = (HEAP32[gb + 13036 >> 2] | 0) + (gb + 1085053 | 0);
 HEAP32[gb + 13040 >> 2] = (HEAP32[gb + 13040 >> 2] | 0) + (gb + 12992 | 0);
 HEAP32[gb + 216180 >> 2] = fb + 3;
 HEAP32[gb + 216188 >> 2] = (HEAP32[gb + 216188 >> 2] | 0) + (gb + 13048 | 0);
 HEAP32[gb + 216192 >> 2] = fb + 3215;
 HEAP32[gb + 216196 >> 2] = fb + 3216;
 HEAP32[gb + 216200 >> 2] = fb + 1547;
 HEAP32[gb + 13048 >> 2] = (HEAP32[gb + 13048 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13052 >> 2] = (HEAP32[gb + 13052 >> 2] | 0) + (gb + 1085392 | 0);
 HEAP32[gb + 13056 >> 2] = (HEAP32[gb + 13056 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216208 >> 2] = (HEAP32[gb + 216208 >> 2] | 0) + (gb + 13064 | 0);
 HEAP32[gb + 216212 >> 2] = fb + 3215;
 HEAP32[gb + 216216 >> 2] = fb + 3217;
 HEAP32[gb + 216220 >> 2] = fb + 1548;
 HEAP32[gb + 13064 >> 2] = (HEAP32[gb + 13064 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13068 >> 2] = (HEAP32[gb + 13068 >> 2] | 0) + (gb + 1085426 | 0);
 HEAP32[gb + 13072 >> 2] = (HEAP32[gb + 13072 >> 2] | 0) + (gb + 13048 | 0);
 HEAP32[gb + 216228 >> 2] = (HEAP32[gb + 216228 >> 2] | 0) + (gb + 13080 | 0);
 HEAP32[gb + 216232 >> 2] = fb + 3215;
 HEAP32[gb + 216236 >> 2] = fb + 3218;
 HEAP32[gb + 216240 >> 2] = fb + 1549;
 HEAP32[gb + 13080 >> 2] = (HEAP32[gb + 13080 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13084 >> 2] = (HEAP32[gb + 13084 >> 2] | 0) + (gb + 1085468 | 0);
 HEAP32[gb + 13088 >> 2] = (HEAP32[gb + 13088 >> 2] | 0) + (gb + 13048 | 0);
 HEAP32[gb + 216248 >> 2] = (HEAP32[gb + 216248 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216252 >> 2] = fb + 3219;
 HEAP32[gb + 216256 >> 2] = fb + 3220;
 HEAP32[gb + 216260 >> 2] = fb + 1550;
 HEAP32[gb + 216268 >> 2] = (HEAP32[gb + 216268 >> 2] | 0) + (gb + 13096 | 0);
 HEAP32[gb + 216272 >> 2] = fb + 3219;
 HEAP32[gb + 216276 >> 2] = fb + 3221;
 HEAP32[gb + 216280 >> 2] = fb + 1551;
 HEAP32[gb + 13096 >> 2] = (HEAP32[gb + 13096 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13100 >> 2] = (HEAP32[gb + 13100 >> 2] | 0) + (gb + 1085523 | 0);
 HEAP32[gb + 13104 >> 2] = (HEAP32[gb + 13104 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216288 >> 2] = (HEAP32[gb + 216288 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 216292 >> 2] = fb + 3222;
 HEAP32[gb + 216296 >> 2] = fb + 3223;
 HEAP32[gb + 216300 >> 2] = fb + 1406;
 HEAP32[gb + 13112 >> 2] = (HEAP32[gb + 13112 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13116 >> 2] = (HEAP32[gb + 13116 >> 2] | 0) + (gb + 1085541 | 0);
 HEAP32[gb + 13120 >> 2] = (HEAP32[gb + 13120 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216308 >> 2] = (HEAP32[gb + 216308 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 216312 >> 2] = fb + 3224;
 HEAP32[gb + 216316 >> 2] = fb + 3225;
 HEAP32[gb + 216320 >> 2] = fb + 1413;
 HEAP32[gb + 13128 >> 2] = (HEAP32[gb + 13128 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13132 >> 2] = (HEAP32[gb + 13132 >> 2] | 0) + (gb + 1085557 | 0);
 HEAP32[gb + 13136 >> 2] = (HEAP32[gb + 13136 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 216328 >> 2] = (HEAP32[gb + 216328 >> 2] | 0) + (gb + 13144 | 0);
 HEAP32[gb + 216332 >> 2] = fb + 3222;
 HEAP32[gb + 216336 >> 2] = fb + 3226;
 HEAP32[gb + 216340 >> 2] = fb + 1406;
 HEAP32[gb + 13144 >> 2] = (HEAP32[gb + 13144 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13148 >> 2] = (HEAP32[gb + 13148 >> 2] | 0) + (gb + 1085575 | 0);
 HEAP32[gb + 13152 >> 2] = (HEAP32[gb + 13152 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 216348 >> 2] = (HEAP32[gb + 216348 >> 2] | 0) + (gb + 13160 | 0);
 HEAP32[gb + 216352 >> 2] = fb + 3222;
 HEAP32[gb + 216356 >> 2] = fb + 3227;
 HEAP32[gb + 216360 >> 2] = fb + 1406;
 HEAP32[gb + 13160 >> 2] = (HEAP32[gb + 13160 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13164 >> 2] = (HEAP32[gb + 13164 >> 2] | 0) + (gb + 1085592 | 0);
 HEAP32[gb + 13168 >> 2] = (HEAP32[gb + 13168 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 216368 >> 2] = (HEAP32[gb + 216368 >> 2] | 0) + (gb + 13176 | 0);
 HEAP32[gb + 216372 >> 2] = fb + 3222;
 HEAP32[gb + 216376 >> 2] = fb + 3228;
 HEAP32[gb + 216380 >> 2] = fb + 1406;
 HEAP32[gb + 13176 >> 2] = (HEAP32[gb + 13176 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13180 >> 2] = (HEAP32[gb + 13180 >> 2] | 0) + (gb + 1085613 | 0);
 HEAP32[gb + 13184 >> 2] = (HEAP32[gb + 13184 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 216388 >> 2] = (HEAP32[gb + 216388 >> 2] | 0) + (gb + 13192 | 0);
 HEAP32[gb + 216392 >> 2] = fb + 3222;
 HEAP32[gb + 216396 >> 2] = fb + 3229;
 HEAP32[gb + 216400 >> 2] = fb + 1406;
 HEAP32[gb + 13192 >> 2] = (HEAP32[gb + 13192 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13196 >> 2] = (HEAP32[gb + 13196 >> 2] | 0) + (gb + 1085630 | 0);
 HEAP32[gb + 13200 >> 2] = (HEAP32[gb + 13200 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 216408 >> 2] = (HEAP32[gb + 216408 >> 2] | 0) + (gb + 13208 | 0);
 HEAP32[gb + 216412 >> 2] = fb + 3224;
 HEAP32[gb + 216416 >> 2] = fb + 3230;
 HEAP32[gb + 216420 >> 2] = fb + 1413;
 HEAP32[gb + 13208 >> 2] = (HEAP32[gb + 13208 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13212 >> 2] = (HEAP32[gb + 13212 >> 2] | 0) + (gb + 1085647 | 0);
 HEAP32[gb + 13216 >> 2] = (HEAP32[gb + 13216 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 216428 >> 2] = (HEAP32[gb + 216428 >> 2] | 0) + (gb + 13224 | 0);
 HEAP32[gb + 216432 >> 2] = fb + 3224;
 HEAP32[gb + 216436 >> 2] = fb + 3231;
 HEAP32[gb + 216440 >> 2] = fb + 1413;
 HEAP32[gb + 13224 >> 2] = (HEAP32[gb + 13224 >> 2] | 0) + (gb + 216140 | 0);
 runPostSets244();
}

function __ZN15b2ContactSolver24SolvePositionConstraintsEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, f53 = f0;
 i52 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i47 = i52 + 40 | 0;
 i48 = i52 + 24 | 0;
 i49 = i52;
 i50 = i2 + 48 | 0;
 if ((HEAP32[i50 >> 2] | 0) <= 0) {
  f31 = Math_fround(0.0);
  i51 = f31 >= Math_fround(-.0149999997);
  STACKTOP = i52;
  return i51 | 0;
 }
 i51 = i2 + 36 | 0;
 i45 = i2 + 24 | 0;
 i46 = i47 + 8 | 0;
 i38 = i47 + 12 | 0;
 i39 = i48 + 8 | 0;
 i40 = i48 + 12 | 0;
 i37 = i47 + 4 | 0;
 i36 = i48 + 4 | 0;
 i35 = i49 + 4 | 0;
 i41 = i49 + 8 | 0;
 i34 = i49 + 12 | 0;
 i42 = i49 + 16 | 0;
 f1 = Math_fround(0.0);
 i33 = 0;
 i2 = HEAP32[i45 >> 2] | 0;
 do {
  i32 = HEAP32[i51 >> 2] | 0;
  i23 = i32 + (i33 * 88 | 0) | 0;
  i43 = HEAP32[i32 + (i33 * 88 | 0) + 32 >> 2] | 0;
  i44 = HEAP32[i32 + (i33 * 88 | 0) + 36 >> 2] | 0;
  f24 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 48 >> 2]);
  f25 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 52 >> 2]);
  f26 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 40 >> 2]);
  f27 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 64 >> 2]);
  f28 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 56 >> 2]);
  f29 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 60 >> 2]);
  f30 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 44 >> 2]);
  f31 = Math_fround(HEAPF32[i32 + (i33 * 88 | 0) + 68 >> 2]);
  i32 = HEAP32[i32 + (i33 * 88 | 0) + 84 >> 2] | 0;
  i5 = HEAP32[i2 + (i43 * 12 | 0) >> 2] | 0;
  i3 = HEAP32[i2 + (i43 * 12 | 0) + 4 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i2 + (i43 * 12 | 0) + 8 >> 2]);
  i6 = HEAP32[i2 + (i44 * 12 | 0) >> 2] | 0;
  i4 = HEAP32[i2 + (i44 * 12 | 0) + 4 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i2 + (i44 * 12 | 0) + 8 >> 2]);
  if ((i32 | 0) > 0) {
   f22 = Math_fround(f26 + f30);
   i2 = 0;
   do {
    f13 = Math_fround(+Math_sin(+f8));
    HEAPF32[i46 >> 2] = f13;
    f16 = Math_fround(+Math_cos(+f8));
    HEAPF32[i38 >> 2] = f16;
    f12 = Math_fround(+Math_sin(+f7));
    HEAPF32[i39 >> 2] = f12;
    f18 = Math_fround(+Math_cos(+f7));
    HEAPF32[i40 >> 2] = f18;
    f19 = Math_fround(Math_fround(f24 * f16) - Math_fround(f25 * f13));
    f13 = Math_fround(Math_fround(f25 * f16) + Math_fround(f24 * f13));
    f16 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f19 = Math_fround(f16 - f19);
    f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f17 - f13);
    HEAPF32[i47 >> 2] = f19;
    HEAPF32[i37 >> 2] = f13;
    f13 = Math_fround(Math_fround(f28 * f18) - Math_fround(f29 * f12));
    f12 = Math_fround(Math_fround(f29 * f18) + Math_fround(f28 * f12));
    f18 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f18 - f13);
    f19 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f19 - f12);
    HEAPF32[i48 >> 2] = f13;
    HEAPF32[i36 >> 2] = f12;
    __ZN24b2PositionSolverManifold10InitializeEP27b2ContactPositionConstraintRK11b2TransformS4_i(i49, i23, i47, i48, i2);
    f12 = Math_fround(HEAPF32[i49 >> 2]);
    f13 = Math_fround(HEAPF32[i35 >> 2]);
    f20 = Math_fround(HEAPF32[i41 >> 2]);
    f21 = Math_fround(HEAPF32[i34 >> 2]);
    f10 = Math_fround(HEAPF32[i42 >> 2]);
    f14 = Math_fround(f20 - f16);
    f15 = Math_fround(f21 - f17);
    f20 = Math_fround(f20 - f18);
    f21 = Math_fround(f21 - f19);
    f1 = f1 < f10 ? f1 : f10;
    f10 = Math_fround(Math_fround(HEAPF32[gb + 151904 >> 2]) * Math_fround(f10 + Math_fround(.00499999989)));
    f9 = Math_fround(-Math_fround(HEAPF32[gb + 151880 >> 2]));
    i6 = f10 < Math_fround(0.0);
    f10 = i6 ? f10 : Math_fround(0.0);
    f11 = Math_fround(Math_fround(f13 * f14) - Math_fround(f12 * f15));
    f53 = Math_fround(Math_fround(f13 * f20) - Math_fround(f12 * f21));
    f11 = Math_fround(Math_fround(f53 * Math_fround(f31 * f53)) + Math_fround(f22 + Math_fround(f11 * Math_fround(f27 * f11))));
    if (f11 > Math_fround(0.0)) f9 = Math_fround(Math_fround(-(f10 < f9 ? f9 : f10)) / f11); else f9 = Math_fround(0.0);
    f53 = Math_fround(f12 * f9);
    f13 = Math_fround(f13 * f9);
    f12 = Math_fround(f26 * f13);
    f16 = Math_fround(f16 - Math_fround(f26 * f53));
    i5 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    f17 = Math_fround(f17 - f12);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
    f8 = Math_fround(f8 - Math_fround(f27 * Math_fround(Math_fround(f14 * f13) - Math_fround(f15 * f53))));
    f17 = Math_fround(f30 * f13);
    f18 = Math_fround(f18 + Math_fround(f30 * f53));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
    f19 = Math_fround(f19 + f17);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround(f7 + Math_fround(f31 * Math_fround(Math_fround(f20 * f13) - Math_fround(f21 * f53))));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i32 | 0));
   i2 = HEAP32[i45 >> 2] | 0;
  }
  HEAP32[i2 + (i43 * 12 | 0) >> 2] = i5;
  HEAP32[i2 + (i43 * 12 | 0) + 4 >> 2] = i3;
  i2 = HEAP32[i45 >> 2] | 0;
  HEAPF32[i2 + (i43 * 12 | 0) + 8 >> 2] = f8;
  HEAP32[i2 + (i44 * 12 | 0) >> 2] = i6;
  HEAP32[i2 + (i44 * 12 | 0) + 4 >> 2] = i4;
  i2 = HEAP32[i45 >> 2] | 0;
  HEAPF32[i2 + (i44 * 12 | 0) + 8 >> 2] = f7;
  i33 = i33 + 1 | 0;
 } while ((i33 | 0) < (HEAP32[i50 >> 2] | 0));
 i51 = f1 >= Math_fround(-.0149999997);
 STACKTOP = i52;
 return i51 | 0;
}

function __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i13, i14, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = HEAP32[i14 + 76 >> 2] | 0;
 i22 = HEAP32[i14 + 80 >> 2] | 0;
 i21 = HEAP32[i14 + 124 >> 2] | 0;
 i20 = HEAP32[i14 + 128 >> 2] | 0;
 i1 = i1 + 4 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 f17 = Math_fround(HEAPF32[i1 + (i23 * 40 | 0) >> 2]);
 f4 = Math_fround(HEAPF32[i1 + (i23 * 40 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + (i23 * 40 | 0) + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + (i22 * 40 | 0) >> 2]);
 f15 = Math_fround(HEAPF32[i1 + (i22 * 40 | 0) + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + (i22 * 40 | 0) + 8 >> 2]);
 f6 = Math_fround(Math_fround(f17 + f18) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f4 + f15) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f11 + f12) * Math_fround(.5));
 f9 = Math_fround(HEAPF32[i1 + (i21 * 40 | 0) >> 2]);
 f8 = Math_fround(HEAPF32[i1 + (i21 * 40 | 0) + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + (i21 * 40 | 0) + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + (i20 * 40 | 0) >> 2]);
 f5 = Math_fround(HEAPF32[i1 + (i20 * 40 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + (i20 * 40 | 0) + 8 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f9 + f16) * Math_fround(.5)) - f6);
 f2 = Math_fround(Math_fround(Math_fround(f8 + f5) * Math_fround(.5)) - f2);
 f7 = Math_fround(Math_fround(Math_fround(f3 + f10) * Math_fround(.5)) - f7);
 f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f2 * f2)) + Math_fround(Math_fround(f7 * f7) + Math_fround(0.0))))));
 f6 = Math_fround(f6 * f19);
 f2 = Math_fround(f19 * f2);
 f7 = Math_fround(f19 * f7);
 f9 = Math_fround(Math_fround(f18 - f17) + Math_fround(f16 - f9));
 f8 = Math_fround(Math_fround(f15 - f4) + Math_fround(f5 - f8));
 f3 = Math_fround(Math_fround(f12 - f11) + Math_fround(f10 - f3));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(Math_fround(f3 * f3) + Math_fround(0.0))))));
 f9 = Math_fround(f9 * f10);
 f8 = Math_fround(f8 * f10);
 f10 = Math_fround(f3 * f10);
 f3 = Math_fround(Math_fround(f2 * f9) - Math_fround(f6 * f8));
 f8 = Math_fround(Math_fround(f8 * f7) - Math_fround(f2 * f10));
 f9 = Math_fround(Math_fround(f6 * f10) - Math_fround(f9 * f7));
 f10 = Math_fround(Math_fround(f6 * f9) - Math_fround(f2 * f8));
 f11 = Math_fround(Math_fround(f2 * f3) - Math_fround(f7 * f9));
 f12 = Math_fround(Math_fround(f7 * f8) - Math_fround(f6 * f3));
 do if (!(f11 >= Math_fround(0.0))) {
  f2 = Math_fround(f2 - f3);
  if (!(f2 >= Math_fround(0.0))) {
   f4 = Math_fround(f8 + f10);
   f5 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f2);
   f3 = Math_fround(f12 - f6);
   f2 = Math_fround(f7 + f9);
   break;
  } else {
   f4 = Math_fround(f6 + f12);
   f5 = Math_fround(f7 + f9);
   f3 = Math_fround(f8 - f10);
   f2 = Math_fround(f2 + Math_fround(Math_fround(1.0) - f11));
   break;
  }
 } else {
  f2 = Math_fround(f2 + f3);
  if (!(f2 >= Math_fround(0.0))) {
   f4 = Math_fround(Math_fround(f11 + Math_fround(1.0)) - f2);
   f5 = Math_fround(f8 + f10);
   f3 = Math_fround(f7 - f9);
   f2 = Math_fround(f6 + f12);
   break;
  } else {
   f4 = Math_fround(f7 - f9);
   f5 = Math_fround(f12 - f6);
   f3 = Math_fround(f2 + Math_fround(f11 + Math_fround(1.0)));
   f2 = Math_fround(f8 - f10);
   break;
  }
 } while (0);
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
 f7 = Math_fround(f4 * f11);
 f15 = Math_fround(f2 * f11);
 f9 = Math_fround(f5 * f11);
 f11 = Math_fround(f3 * f11);
 f16 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f10 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i14 + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(f15 * f10);
 f19 = Math_fround(f11 * f16);
 f18 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i14 + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f9 * f18);
 f8 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i14 + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = Math_fround(Math_fround(Math_fround(f17 - Math_fround(f11 * f8)) - Math_fround(f9 * f16)) - Math_fround(f7 * f18));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f7 * f10)) - Math_fround(f9 * f8)) - Math_fround(f15 * f18));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f15 * f8)) - Math_fround(f11 * f10)) - Math_fround(f7 * f16));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f10)) - Math_fround(f11 * f18)) - Math_fround(f15 * f16));
 i23 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i21 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i22 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f16 = (HEAP32[tempDoublePtr >> 2] = i21 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f16 * f16);
 f17 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f17 * f17);
 f18 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f15) + Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18))))));
 f17 = Math_fround(f15 * f17);
 f18 = Math_fround(f15 * f18);
 f19 = Math_fround(f15 * f19);
 HEAPF32[i13 >> 2] = Math_fround(f15 * f16);
 HEAPF32[i13 + 4 >> 2] = f17;
 HEAPF32[i13 + 8 >> 2] = f18;
 HEAPF32[i13 + 12 >> 2] = f19;
 return;
}

function __ZN5physx24PxcArticulationFnsScalar8multiplyEPNS_2Cm13SpatialVectorEPKS2_RKNS_7PxMat33E(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 i32 = i2 + 4 | 0;
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i32 >> 2]));
 i31 = i2 + 8 | 0;
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i31 >> 2]));
 i30 = i2 + 16 | 0;
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i30 >> 2]));
 i29 = i2 + 20 | 0;
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i29 >> 2]));
 i28 = i2 + 24 | 0;
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i28 >> 2]));
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i27 = i2 + 32 | 0;
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i27 >> 2]));
 i26 = i2 + 36 | 0;
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2]));
 i25 = i2 + 40 | 0;
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i25 >> 2]));
 i24 = i2 + 48 | 0;
 f14 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
 i23 = i2 + 52 | 0;
 f13 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i2 + 56 | 0;
 f10 = Math_fround(f5 + f10);
 f16 = Math_fround(f6 + f16);
 f15 = Math_fround(f7 + f15);
 f14 = Math_fround(f8 + f14);
 f13 = Math_fround(f9 + f13);
 f12 = Math_fround(f4 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i21 = i2 + 64 | 0;
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i21 >> 2]));
 i20 = i2 + 68 | 0;
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i2 + 72 | 0;
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 i18 = i2 + 80 | 0;
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i18 >> 2]));
 i17 = i2 + 84 | 0;
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2]));
 i11 = i2 + 88 | 0;
 f8 = Math_fround(f16 + f8);
 f7 = Math_fround(f15 + f7);
 f6 = Math_fround(f14 + f6);
 f5 = Math_fround(f13 + f5);
 f4 = Math_fround(f12 + Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f10 + f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 16 >> 2] = f6;
 HEAPF32[i3 + 20 >> 2] = f5;
 HEAPF32[i3 + 24 >> 2] = f4;
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 i33 = i1 + 12 | 0;
 f4 = Math_fround(HEAPF32[i33 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i32 >> 2]));
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i31 >> 2]));
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i30 >> 2]));
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i29 >> 2]));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i28 >> 2]));
 f10 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
 f13 = Math_fround(f10 * Math_fround(HEAPF32[i26 >> 2]));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i25 >> 2]));
 f15 = Math_fround(f10 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 f12 = Math_fround(f5 + f12);
 f13 = Math_fround(f6 + f13);
 f14 = Math_fround(f7 + f14);
 f15 = Math_fround(f8 + f15);
 f16 = Math_fround(f9 + f16);
 f10 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2])));
 f4 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i21 >> 2]));
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2]));
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i18 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2]));
 f8 = Math_fround(f13 + f8);
 f7 = Math_fround(f14 + f7);
 f6 = Math_fround(f15 + f6);
 f5 = Math_fround(f16 + f5);
 f4 = Math_fround(f10 + Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2])));
 HEAPF32[i3 + 32 >> 2] = Math_fround(f12 + f9);
 HEAPF32[i3 + 36 >> 2] = f8;
 HEAPF32[i3 + 40 >> 2] = f7;
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 48 >> 2] = f6;
 HEAPF32[i3 + 52 >> 2] = f5;
 HEAPF32[i3 + 56 >> 2] = f4;
 HEAPF32[i3 + 60 >> 2] = Math_fround(0.0);
 i1 = i1 + 24 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i32 >> 2]));
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i31 >> 2]));
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i30 >> 2]));
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i29 >> 2]));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i28 >> 2]));
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i27 >> 2]));
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2]));
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i25 >> 2]));
 f14 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
 f13 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 f10 = Math_fround(f5 + f10);
 f16 = Math_fround(f6 + f16);
 f15 = Math_fround(f7 + f15);
 f14 = Math_fround(f8 + f14);
 f13 = Math_fround(f9 + f13);
 f12 = Math_fround(f4 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i21 >> 2]));
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2]));
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i18 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2]));
 f8 = Math_fround(f16 + f8);
 f7 = Math_fround(f15 + f7);
 f6 = Math_fround(f14 + f6);
 f5 = Math_fround(f13 + f5);
 f4 = Math_fround(f12 + Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2])));
 HEAPF32[i3 + 64 >> 2] = Math_fround(f10 + f9);
 HEAPF32[i3 + 68 >> 2] = f8;
 HEAPF32[i3 + 72 >> 2] = f7;
 HEAPF32[i3 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 80 >> 2] = f6;
 HEAPF32[i3 + 84 >> 2] = f5;
 HEAPF32[i3 + 88 >> 2] = f4;
 HEAPF32[i3 + 92 >> 2] = Math_fround(0.0);
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEbT0_S7_T_(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 switch ((i11 - i10 | 0) / 24 | 0 | 0) {
 case 2:
  {
   i3 = i11 + -24 | 0;
   i1 = _strcmp(HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
   if (!i1) {
    i2 = HEAP32[i10 + 4 >> 2] | 0;
    if (!i2) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    }
    i1 = HEAP32[i11 + -20 >> 2] | 0;
    if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >= (HEAP32[i2 + 16 >> 2] | 0)) {
     i12 = 1;
     STACKTOP = i13;
     return i12 | 0;
    }
   } else if ((i1 | 0) >= 0) {
    i12 = 1;
    STACKTOP = i13;
    return i12 | 0;
   };
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i10, i10 + 24 | 0, i11 + -24 | 0, i1) | 0;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_(i10, i10 + 24 | 0, i10 + 48 | 0, i11 + -24 | 0, i1) | 0;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_(i10, i10 + 24 | 0, i10 + 48 | 0, i10 + 72 | 0, i11 + -24 | 0, i1) | 0;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 default:
  {
   i3 = i10 + 48 | 0;
   __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i10, i10 + 24 | 0, i3, i1) | 0;
   i1 = i10 + 72 | 0;
   L3 : do if ((i1 | 0) == (i11 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     i4 = _strcmp(i8, HEAP32[i3 >> 2] | 0) | 0;
     if (!i4) {
      i4 = HEAP32[i3 + 4 >> 2] | 0;
      if (i4) {
       i5 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i5) {
        i5 = 0;
        i9 = 19;
       } else if ((HEAP32[i5 + 16 >> 2] | 0) < (HEAP32[i4 + 16 >> 2] | 0)) i9 = 19;
      }
     } else if ((i4 | 0) < 0) {
      i5 = HEAP32[i1 + 4 >> 2] | 0;
      i9 = 19;
     }
     if ((i9 | 0) == 19) {
      i9 = 0;
      i7 = i1 + 8 | 0;
      HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      i7 = i5 + 16 | 0;
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
      HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
      L15 : do if ((i3 | 0) == (i10 | 0)) i3 = i10; else {
       if (!i5) {
        i4 = i3;
        while (1) {
         i3 = i4;
         i4 = i4 + -24 | 0;
         i6 = _strcmp(i8, HEAP32[i4 >> 2] | 0) | 0;
         if (!i6) {
          if (!(HEAP32[i3 + -20 >> 2] | 0)) break L15;
         } else if ((i6 | 0) >= 0) break L15;
         HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
         HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
         HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
         HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
         HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
         HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
         if ((i4 | 0) == (i10 | 0)) {
          i3 = i10;
          break L15;
         }
        }
       } else i6 = i3;
       while (1) {
        i3 = i6;
        i6 = i6 + -24 | 0;
        i4 = _strcmp(i8, HEAP32[i6 >> 2] | 0) | 0;
        if (!i4) {
         i4 = HEAP32[i3 + -20 >> 2] | 0;
         if (!i4) break L15;
         if ((HEAP32[i7 >> 2] | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) break L15;
        } else if ((i4 | 0) >= 0) break L15;
        HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
        HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
        HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
        HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
        HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
        if ((i6 | 0) == (i10 | 0)) {
         i3 = i10;
         break;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = i8;
      HEAP32[i3 + 4 >> 2] = i5;
      i8 = i3 + 8 | 0;
      HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
      HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
      HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 24 | 0) == (i11 | 0);
       break L3;
      }
     }
     i3 = i1 + 24 | 0;
     if ((i3 | 0) == (i11 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i8 = i1;
      i1 = i3;
      i3 = i8;
     }
    }
   } while (0);
   i12 = i1 | i2;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN26AnimatorControllerPlayable13GetBehavioursEP11Il2CppClass(i9, i1, i11) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i13 = i18 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 i14 = i9 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i9 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i8 = i12;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i1 + 112 | 0;
 i7 = i1 + 124 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i6 = HEAP32[i10 >> 2] | 0;
 do {
  i8 = HEAP32[i6 >> 2] | 0;
  do if (i8 | 0) {
   HEAP32[i13 >> 2] = i8;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i4 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i17 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i17 = 11;
   }
   if ((i17 | 0) == 9) i17 = 11;
   if ((i17 | 0) == 11) {
    i17 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i8) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = i8;
   if (!i1) i17 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 20;
    }
   }
   if ((i17 | 0) == 18) i17 = 20;
   if ((i17 | 0) == 20) {
    i17 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
   }
   if ((__ZNK13MonoBehaviour8GetClassEv(i1) | 0) == (i11 | 0)) {
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i9 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i3;
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i8;
    break;
   }
   HEAP32[i13 >> 2] = i8;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 33; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 33; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 35;
    }
   }
   if ((i17 | 0) == 33) i17 = 35;
   if ((i17 | 0) == 35) {
    i17 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
   }
   if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__ZNK13MonoBehaviour8GetClassEv(i1) | 0, i11) | 0) {
    i2 = HEAP32[i14 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i16, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i9 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i3;
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i8;
   }
  } while (0);
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) != ((HEAP32[i10 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0));
 STACKTOP = i18;
 return;
}

function __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE(i1, i2, i3, i13, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 56 | 0;
 i12 = i21;
 i20 = i21 + 64 | 0;
 i15 = i16 + 12 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i21;
  return;
 }
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i17 = i12;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i20 >> 2] = 0;
 i17 = i20 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i20 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i12);
 i9 = i14;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i19;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i18 >> 2] | 0;
  if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
   if ((i2 | 0) > -1) {
    HEAP32[i18 >> 2] = i1;
    HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 5, 8, i19, 0, gb + 1047584 | 0, 464) | 0;
   } else {
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 8, i19, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i12 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i17 >> 2] << 5 | 0) | 0;
    HEAP32[i18 >> 2] = i1;
    HEAP32[i20 >> 2] = i12;
   }
   i1 = HEAP32[i15 >> 2] | 0;
  }
  if (i1 | 0) {
   i1 = HEAP32[i16 >> 2] | 0;
   do {
    __ZN18AssetBundleManager14AddPreloadDataEiR13dynamic_arrayINS_11PreloadDataELj8EEb(0, HEAP32[i1 >> 2] | 0, i20, i13);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i16 >> 2] | 0) + (HEAP32[i15 >> 2] << 2) | 0));
  }
 } else {
  __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev(i12);
  __ZN18AssetBundleManager29CollectPreloadDataRecursivelyEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEERK13dynamic_arrayIiLj4EER19InstanceIDHashTableIPKNS0_9AssetInfoENS3_4pairIKiSI_EEE(i1, i2, i3, i16, i12);
  i11 = i12 + 4 | 0;
  i1 = (HEAP32[i12 + 36 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
  i2 = HEAP32[i18 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i18 >> 2] = i1;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 5, 8, i19, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 8, i19, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i17 >> 2] << 5 | 0) | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i20 >> 2] = i10;
   break;
  } while (0);
  i8 = i12 + 28 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i9 = i12 + 32 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  i10 = i1 + (i7 << 3) | 0;
  i2 = i1;
  L23 : do if (i7) {
   i5 = HEAP32[i12 + 20 >> 2] | 0;
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   if ((HEAP8[i12 + 8 >> 0] | 0) != 0 & (HEAP32[i11 >> 2] | 0) != 0) {
    i3 = i1;
    do {
     i7 = HEAP32[i3 >> 2] | 0;
     if (!((i5 | 0) == (i7 | 0) | (i4 | 0) == (i7 | 0))) break L23;
     i3 = i3 + 8 | 0;
     i2 = i3;
    } while ((i3 | 0) != (i10 | 0));
   } else {
    i3 = i1;
    do {
     if ((i5 | 0) != (HEAP32[i3 >> 2] | 0)) break L23;
     i3 = i3 + 8 | 0;
     i2 = i3;
    } while ((i3 | 0) != (i10 | 0));
   }
  } while (0);
  if ((i2 | 0) != (i10 | 0)) {
   i5 = i12 + 20 | 0;
   i6 = i12 + 8 | 0;
   i7 = i12 + 12 | 0;
   do {
    __ZN18AssetBundleManager14AddPreloadDataEiR13dynamic_arrayINS_11PreloadDataELj8EEb(0, HEAP32[i2 >> 2] | 0, i20, i13);
    i1 = i2 + 8 | 0;
    i2 = i1;
    L37 : do if ((i1 | 0) != (i10 | 0)) {
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     if ((HEAP32[i11 >> 2] | 0) != 0 & (HEAP8[i6 >> 0] | 0) != 0) do {
      i22 = HEAP32[i1 >> 2] | 0;
      if (!((i4 | 0) == (i22 | 0) | (i3 | 0) == (i22 | 0))) break L37;
      i1 = i1 + 8 | 0;
      i2 = i1;
     } while ((i1 | 0) != (i10 | 0)); else do {
      if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L37;
      i1 = i1 + 8 | 0;
      i2 = i1;
     } while ((i1 | 0) != (i10 | 0));
    } while (0);
    i1 = HEAP32[i8 >> 2] | 0;
   } while ((i2 | 0) != (i1 + (HEAP32[i9 >> 2] << 3) | 0));
  }
  if (i1 | 0) {
   i22 = HEAP32[i12 + 52 >> 2] | 0;
   HEAP32[i14 >> 2] = 65;
   HEAP32[i14 + 4 >> 2] = i22;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  }
 }
 i1 = HEAP32[i20 >> 2] | 0;
 __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i1, i1 + (HEAP32[i17 >> 2] << 5) | 0, i14);
 i1 = HEAP32[i17 >> 2] | 0;
 HEAP32[i15 >> 2] = i1;
 i2 = i16 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 2, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i16 >> 2] = i22;
  break;
 } while (0);
 if (HEAP32[i17 >> 2] | 0) {
  i4 = HEAP32[i20 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i1 = 0;
  i2 = i4;
  while (1) {
   HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
   i2 = i2 + 32 | 0;
   if ((i2 | 0) == (i4 + (HEAP32[i17 >> 2] << 5) | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i19);
  HEAP32[i20 >> 2] = 0;
 }
 STACKTOP = i21;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadE25RuntimeInitializeLoadType(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 64 | 0;
 i9 = i14 + 48 | 0;
 i10 = i14 + 32 | 0;
 i7 = i14 + 16 | 0;
 i11 = i14;
 if ((i1 | 0) == 1) {
  i5 = i12 + 92 | 0;
  i1 = HEAP32[i12 + 104 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  i7 = i9 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i12 + 96 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
  i4 = i2 >> 2;
  if (i4 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i9 + 8 >> 2] = i3 + (i4 << 2);
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE(i12, i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i11 = HEAP32[i8 >> 2] | 0;
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  }
  i4 = i12 + 124 | 0;
  i1 = HEAP32[i12 + 136 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  i7 = i10 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i8 = i10 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i12 + 128 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i10 + 8 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE(i12, i10);
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) {
   STACKTOP = i14;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  i12 = HEAP32[i8 >> 2] | 0;
  HEAP32[i13 >> 2] = 12;
  HEAP32[i13 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  STACKTOP = i14;
  return;
 } else {
  i4 = i12 + 108 | 0;
  i1 = HEAP32[i12 + 120 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i9 = i7 + 12 | 0;
  HEAP32[i9 >> 2] = i1;
  i6 = i12 + 112 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 8 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE(i12, i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i10 = HEAP32[i9 >> 2] | 0;
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  }
  i4 = i12 + 140 | 0;
  i1 = HEAP32[i12 + 152 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  i7 = i11 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i12 + 144 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = i2 >> 2;
  if (i5 | 0) {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = 12;
   HEAP32[i13 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i11 >> 2] = i3;
   HEAP32[i11 + 8 >> 2] = i3 + (i5 << 2);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE(i12, i11);
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) {
   STACKTOP = i14;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  i12 = HEAP32[i8 >> 2] | 0;
  HEAP32[i13 >> 2] = 12;
  HEAP32[i13 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx15PxVehicleUpdate18suspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb(i29, i31, i32, i2, i3, i33) {
 i29 = i29 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i33 = i33 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i34 = 0, i35 = 0, i36 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i35 + 8 | 0;
 i27 = i35 + 4 | 0;
 i28 = i35;
 if (i2 | 0) {
  i1 = 0;
  do {
   HEAP8[i3 + (i1 * 80 | 0) + 77 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 };
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP8[i30 + 18 >> 0] = 0;
 i26 = i30 + 20 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i30 + 38 >> 0] = 0;
 i26 = i30 + 40 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i30 + 58 >> 0] = 0;
 i26 = i30 + 60 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i30 + 78 >> 0] = 0;
 HEAP16[i30 + 16 >> 1] = 7;
 HEAP16[i30 + 36 >> 1] = 7;
 HEAP16[i30 + 56 >> 1] = 7;
 HEAP16[i30 + 76 >> 1] = 7;
 if (!i31) {
  i34 = HEAP32[i29 >> 2] | 0;
  i34 = HEAP32[i34 >> 2] | 0;
  mftCall_vi(i34 | 0, i29 | 0);
  STACKTOP = i35;
  return;
 }
 i24 = i30 + 40 | 0;
 i25 = i30 + 20 | 0;
 i26 = (i33 | 0) == 0;
 i15 = i3 + (i2 * 80 | 0) | 0;
 i16 = i28 + 3 | 0;
 i17 = i28 + 2 | 0;
 i18 = i28 + 1 | 0;
 i19 = i30 + 60 | 0;
 i20 = i27 + 3 | 0;
 i21 = i27 + 2 | 0;
 i22 = i27 + 1 | 0;
 i23 = 0;
 i1 = i3;
 do {
  i7 = HEAP32[i32 + (i23 << 2) >> 2] | 0;
  i11 = HEAP32[i7 + 40 >> 2] | 0;
  i10 = HEAP32[i7 + 72 >> 2] | 0;
  i8 = HEAP32[i7 + 48 >> 2] | 0;
  i12 = i8 >>> 2;
  i9 = i12 << 2;
  i13 = i8 - i9 | 0;
  i14 = HEAP32[i7 + 104 >> 2] | 0;
  if (!i12) i4 = i1; else {
   i5 = i33 + i23 | 0;
   i6 = 0;
   do {
    HEAP32[i27 >> 2] = 0;
    i2 = HEAP32[i7 + 52 + ((i6 >>> 3 & 134217727) << 2) >> 2] | 0;
    i3 = i6 << 2 & 28;
    if (i2 & 1 << i3 | 0) HEAP8[i27 >> 0] = 1;
    if (i2 & 1 << (i3 | 1) | 0) HEAP8[i22 >> 0] = 1;
    if (i2 & 1 << (i3 | 2) | 0) HEAP8[i21 >> 0] = 1;
    if (i2 & 1 << (i3 | 3) | 0) HEAP8[i20 >> 0] = 1;
    i2 = i10 + (i6 * 224 | 0) | 0;
    i3 = i10 + (i6 * 224 | 0) + 212 | 0;
    HEAP32[i3 >> 2] = 0;
    if (i26) i34 = 17; else if (HEAP8[i5 >> 0] | 0) i34 = 17;
    if ((i34 | 0) == 17) {
     i34 = 0;
     i4 = i1 + 320 | 0;
     if (i15 >>> 0 < i4 >>> 0) i1 = i4; else {
      i36 = i11 + (i6 * 944 | 0) + 864 | 0;
      HEAP32[i30 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i30 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
      HEAP32[i30 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
      HEAP32[i30 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
      i36 = i11 + (i6 * 944 | 0) + 880 | 0;
      HEAP32[i25 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i25 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
      HEAP32[i25 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
      HEAP32[i25 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
      i36 = i11 + (i6 * 944 | 0) + 896 | 0;
      HEAP32[i24 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
      HEAP32[i24 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
      i36 = i11 + (i6 * 944 | 0) + 912 | 0;
      HEAP32[i19 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
      HEAP32[i19 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
      HEAP32[i3 >> 2] = i1;
      __Z34PxVehicleWheels4SuspensionRaycastsPN5physx12PxBatchQueryERKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataEPKNS_17PxQueryFilterDataEPKbjPNS_14PxRigidDynamicE(i29, i11 + (i6 * 944 | 0) | 0, i2, i30, i27, 4, i14);
      i1 = i4;
     }
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i12 | 0));
   i4 = i1;
  }
  do if ((i8 | 0) == (i9 | 0)) i1 = i4; else {
   HEAP32[i28 >> 2] = 0;
   i2 = HEAP32[i7 + 52 + (i8 >>> 5 << 2) >> 2] | 0;
   i1 = i9 & 28;
   if (i2 & 1 << i1 | 0) HEAP8[i28 >> 0] = 1;
   if (i2 & 1 << (i1 | 1) | 0) HEAP8[i18 >> 0] = 1;
   if (i2 & 1 << (i1 | 2) | 0) HEAP8[i17 >> 0] = 1;
   if (i2 & 1 << (i1 | 3) | 0) HEAP8[i16 >> 0] = 1;
   i3 = i10 + (i12 * 224 | 0) | 0;
   i2 = i10 + (i12 * 224 | 0) + 212 | 0;
   HEAP32[i2 >> 2] = 0;
   if (!i26) if (!(HEAP8[i33 + i23 >> 0] | 0)) {
    i1 = i4;
    break;
   }
   i1 = i4 + (i13 * 80 | 0) | 0;
   if (i15 >>> 0 >= i1 >>> 0) {
    i36 = i11 + (i12 * 944 | 0) + 864 | 0;
    HEAP32[i30 >> 2] = HEAP32[i36 >> 2];
    HEAP32[i30 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
    HEAP32[i30 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
    HEAP32[i30 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
    if (i13 >>> 0 > 1) {
     i36 = i11 + (i12 * 944 | 0) + 880 | 0;
     HEAP32[i25 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i25 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
     HEAP32[i25 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
     HEAP32[i25 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
     if (i13 >>> 0 > 2) {
      i36 = i11 + (i12 * 944 | 0) + 896 | 0;
      HEAP32[i24 >> 2] = HEAP32[i36 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
      HEAP32[i24 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
     }
    }
    HEAP32[i2 >> 2] = i4;
    __Z34PxVehicleWheels4SuspensionRaycastsPN5physx12PxBatchQueryERKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataEPKNS_17PxQueryFilterDataEPKbjPNS_14PxRigidDynamicE(i29, i11 + (i12 * 944 | 0) | 0, i3, i30, i28, i13, i14);
   }
  } while (0);
  i23 = i23 + 1 | 0;
 } while ((i23 | 0) != (i31 | 0));
 i36 = HEAP32[i29 >> 2] | 0;
 i36 = HEAP32[i36 >> 2] | 0;
 mftCall_vi(i36 | 0, i29 | 0);
 STACKTOP = i35;
 return;
}

function __ZN14AnimationState20UpdateAnimationStateEdRN5Unity9ComponentE(i17, d1, i16) {
 i17 = i17 | 0;
 d1 = +d1;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f18 = f0, d19 = 0.0, d20 = 0.0, i21 = 0, i22 = 0, f23 = f0, f24 = f0;
 i14 = i17 + 24 | 0;
 f18 = Math_fround(d1 - +HEAPF64[i14 >> 3]);
 HEAPF64[i14 >> 3] = d1;
 f4 = Math_fround(HEAPF32[i17 + 40 >> 2]);
 f2 = Math_fround(f18 * f4);
 if (!(f2 != Math_fround(0.0))) {
  i17 = __ZN14AnimationState12UpdateFadingEf(i17, f18) | 0;
  return i17 | 0;
 }
 i14 = i17 + 16 | 0;
 d1 = +HEAPF64[i14 >> 3];
 d11 = +f2 + d1;
 HEAPF64[i14 >> 3] = d11;
 i14 = i17 + 12 | 0;
 f15 = Math_fround(HEAPF32[i14 >> 2]);
 f3 = Math_fround(f2 + f15);
 f13 = Math_fround(HEAPF32[i17 + 88 >> 2]);
 f2 = Math_fround(HEAPF32[i17 + 92 >> 2]);
 i12 = f4 >= Math_fround(0.0);
 L4 : do switch (HEAP32[i17 + 68 >> 2] | 0) {
 case 2:
  {
   if (f3 >= f2) {
    d20 = +f13;
    d19 = d11 - d20;
    d1 = +f2 - d20;
    f4 = Math_fround(d20 + (d19 - d1 * +Math_floor(+(d19 / d1))));
    i5 = i17 + 56 | 0;
    if (!(HEAP16[i5 >> 1] & 128)) {
     f2 = f4;
     break L4;
    }
    f6 = Math_fround(f2 - f13);
    f3 = Math_fround(d11 - +Math_fround(f4 - f13) - +f6);
    if (!(__ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f2, i12, i16, f13, f3, 0) | 0)) {
     f2 = f4;
     break L4;
    }
    f2 = Math_fround(f6 + f3);
    HEAP32[i17 + 60 >> 2] = 0;
    HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -1537;
    __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f4, i12, i16, f13, f2, 0) | 0;
    f2 = f4;
    break L4;
   }
   if (!(f3 < f13)) {
    if (!(HEAP16[i17 + 56 >> 1] & 128)) {
     f2 = f3;
     break L4;
    }
    __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f3, i12, i16, f13, Math_fround(d11 - +Math_fround(f3 - f13)), 0) | 0;
    f2 = f3;
    break L4;
   }
   d1 = +f13;
   d19 = d11 - d1;
   d20 = +f2 - d1;
   f4 = Math_fround(d1 + (d19 - d20 * +Math_floor(+(d19 / d20))));
   i5 = i17 + 56 | 0;
   if (!(HEAP16[i5 >> 1] & 128)) f2 = f4; else {
    f3 = Math_fround(d11 + +Math_fround(f2 - f4));
    if (__ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f13, i12, i16, f13, f3, 0) | 0) {
     f2 = Math_fround(f3 - Math_fround(f2 - f13));
     i10 = HEAP32[i17 + 96 >> 2] | 0;
     HEAP32[i17 + 60 >> 2] = ((HEAP32[i10 + 200 >> 2] | 0) - (HEAP32[i10 + 196 >> 2] | 0) >> 6) + -1;
     HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -1537;
     __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f4, i12, i16, f13, f2, 0) | 0;
     f2 = f4;
    } else f2 = f4;
   }
   break;
  }
 case 8:
 case 1:
  {
   if (d11 < +f13) f2 = f13; else if (!(d11 > +f2)) f2 = Math_fround(d11);
   if (HEAP16[i17 + 56 >> 1] & 128) __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), Math_fround(d11), i12, i16, f13, f13, 0) | 0;
   break;
  }
 case 0:
  {
   if (!(HEAP16[i17 + 56 >> 1] & 128)) f2 = f3; else {
    __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f3, i12, i16, f13, f13, 0) | 0;
    f2 = f3;
   }
   break;
  }
 case 4:
  {
   f6 = Math_fround(Math_fround(d11) - f13);
   f3 = Math_fround(f2 - f13);
   f4 = Math_fround(f3 * Math_fround(2.0));
   f4 = Math_fround(Math_fround(f6 - Math_fround(f4 * Math_fround(Math_floor(Math_fround(f6 / f4))))) - f3);
   i9 = f4 < Math_fround(0.0);
   f6 = Math_fround(-f4);
   f4 = Math_fround(f13 + Math_fround(f3 - (i9 ? f6 : f4)));
   i9 = i17 + 56 | 0;
   if (!(HEAP16[i9 >> 1] & 128)) f2 = f4; else {
    i8 = HEAP32[i17 + 96 >> 2] | 0;
    i10 = i8 + 196 | 0;
    d19 = +f13;
    d20 = +f3;
    f3 = Math_fround((d1 - d19) / d20);
    i22 = f3 >= Math_fround(0.0);
    f6 = Math_fround(f3 + Math_fround(-.99999994));
    f24 = Math_fround((d11 - d19) / d20);
    i21 = f24 >= Math_fround(0.0);
    f23 = Math_fround(f24 + Math_fround(-.99999994));
    i21 = ~~(i21 ? f24 : f23);
    i7 = i12 ^ 1;
    i5 = (i21 & 1 | 0) == 0 ? i12 : i7;
    if ((~~(i22 ? f3 : f6) | 0) == (i21 | 0)) {
     __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f4, i5, i16, f13, Math_fround(d11 - +Math_fround(f4 - f13)), 0) | 0;
     f2 = f4;
     break L4;
    }
    if (i5) {
     d20 = +Math_fround(f4 - f13);
     f3 = Math_fround(d11 + (i12 ? -d20 : d20));
     if (!(__ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f13, 0, i16, f13, f3, i12) | 0)) {
      f2 = f4;
      break L4;
     }
     HEAP32[i17 + 60 >> 2] = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]) == f13 & 1;
     HEAP16[i9 >> 1] = HEAP16[i9 >> 1] & -1537;
     __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f4, 1, i16, f2, f3, i7) | 0;
     f2 = f4;
     break L4;
    } else {
     d20 = +Math_fround(f2 - f4);
     f3 = Math_fround(d11 + (i12 ? -d20 : d20));
     if (!(__ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f2, 1, i16, f2, f3, i7) | 0)) {
      f2 = f4;
      break L4;
     }
     i21 = HEAP32[i8 + 200 >> 2] | 0;
     i22 = Math_fround(HEAPF32[i21 + -64 >> 2]) == f2;
     HEAP32[i17 + 60 >> 2] = (i21 - (HEAP32[i10 >> 2] | 0) >> 6) - (i22 ? 2 : 1);
     HEAP16[i9 >> 1] = HEAP16[i9 >> 1] & -1537;
     __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, Math_fround(0.0), f4, 0, i16, f13, f3, i12) | 0;
     f2 = f4;
     break L4;
    }
   }
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 897006 | 0, 0, gb + 897023 | 0, 522, 1, 0, 0, 0);
   f2 = f3;
  }
 } while (0);
 if (!(Math_fround(HEAPF32[i14 >> 2]) == f15)) {
  i22 = __ZN14AnimationState12UpdateFadingEf(i17, f18) | 0;
  return i22 | 0;
 }
 HEAPF32[i14 >> 2] = f2;
 i22 = __ZN14AnimationState12UpdateFadingEf(i17, f18) | 0;
 return i22 | 0;
}

function __ZN15CollisionModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i17, i1, i7) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i14 = i16 + 12 | 0;
 i15 = i16;
 if (HEAP32[i17 + 136 >> 2] | 0) {
  STACKTOP = i16;
  return;
 }
 i6 = i7 + 448 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = 0;
 do {
  i5 = i17 + 972 + (i4 << 2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i14 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i18 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i2 = HEAP32[i13 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i18 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i18 = 12;
   }
   if ((i18 | 0) == 10) i18 = 12;
   if ((i18 | 0) == 12) {
    i18 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   }
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  } while (0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 6);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i12 = i7 + 444 | 0;
 HEAP32[i12 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 16, gb + 64024 | 0, 0, gb + 613323 | 0, 76) | 0;
 i7 = i13 + 4 | 0;
 i8 = i13 + 8 | 0;
 i9 = i13 + 12 | 0;
 i10 = i15 + 4 | 0;
 i11 = i15 + 8 | 0;
 i6 = 0;
 i1 = 0;
 do {
  i5 = i17 + 972 + (i6 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (i2) {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i18 = 22; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
     i3 = HEAP32[i13 >> 2] | 0;
     i19 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i18 = 22; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i18 = 24;
    }
   }
   if ((i18 | 0) == 22) i18 = 24;
   if ((i18 | 0) == 24) {
    i18 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) break;
   }
   __ZNK9Transform11GetPositionEv(i15, i2);
   __ZNK9Transform11GetRotationEv(i13, i2);
   f29 = Math_fround(HEAPF32[i13 >> 2]);
   f26 = Math_fround(f29 * Math_fround(2.0));
   f27 = Math_fround(HEAPF32[i7 >> 2]);
   f28 = Math_fround(f27 * Math_fround(2.0));
   f21 = Math_fround(HEAPF32[i8 >> 2]);
   f31 = Math_fround(f21 * Math_fround(2.0));
   f24 = Math_fround(f29 * f26);
   f23 = Math_fround(f27 * f28);
   f21 = Math_fround(f21 * f31);
   f32 = Math_fround(f29 * f28);
   f29 = Math_fround(f29 * f31);
   f27 = Math_fround(f27 * f31);
   f22 = Math_fround(HEAPF32[i9 >> 2]);
   f26 = Math_fround(f26 * f22);
   f28 = Math_fround(f28 * f22);
   f31 = Math_fround(f22 * f31);
   f22 = Math_fround(Math_fround(1.0) - Math_fround(f23 + f21));
   f30 = Math_fround(HEAPF32[gb + 62536 >> 2]);
   f22 = Math_fround(f30 * f22);
   f33 = Math_fround(f32 - f31);
   f25 = Math_fround(HEAPF32[gb + 62536 + 4 >> 2]);
   f22 = Math_fround(Math_fround(f33 * f25) + f22);
   f33 = Math_fround(f29 + f28);
   f20 = Math_fround(HEAPF32[gb + 62536 + 8 >> 2]);
   f22 = Math_fround(Math_fround(f33 * f20) + f22);
   f21 = Math_fround(Math_fround(Math_fround(f27 - f26) * f20) + Math_fround(Math_fround(f30 * Math_fround(f32 + f31)) + Math_fround(f25 * Math_fround(Math_fround(1.0) - Math_fround(f24 + f21)))));
   f20 = Math_fround(Math_fround(Math_fround(f30 * Math_fround(f29 - f28)) + Math_fround(Math_fround(f27 + f26) * f25)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f24 + f23)) * f20));
   i19 = HEAP32[i12 >> 2] | 0;
   HEAPF32[i19 + (i1 * 20 | 0) >> 2] = f22;
   HEAPF32[i19 + (i1 * 20 | 0) + 4 >> 2] = f21;
   HEAPF32[i19 + (i1 * 20 | 0) + 8 >> 2] = f20;
   f22 = Math_fround(f22 * Math_fround(HEAPF32[i15 >> 2]));
   f21 = Math_fround(f22 + Math_fround(f21 * Math_fround(HEAPF32[i10 >> 2])));
   HEAPF32[i19 + (i1 * 20 | 0) + 12 >> 2] = Math_fround(-Math_fround(f21 + Math_fround(f20 * Math_fround(HEAPF32[i11 >> 2]))));
   i19 = HEAP32[i12 >> 2] | 0;
   i5 = i19 + (i1 * 20 | 0) | 0;
   __Z15NormalizeRobustRK8Vector3fRf(i14, i5, i13);
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   f20 = Math_fround(HEAPF32[i13 >> 2]);
   i19 = i19 + (i1 * 20 | 0) + 12 | 0;
   HEAPF32[i19 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i19 >> 2]));
   HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 * 20 | 0) + 16 >> 2] = HEAP32[i2 + 4 >> 2];
   i1 = i1 + 1 | 0;
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 6);
 STACKTOP = i16;
 return;
}

function _sha256crypt(i15, i4, i1) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 112 | 0;
 i6 = i23 + 104 | 0;
 i17 = i23;
 i22 = i23 + 216 | 0;
 i18 = i23 + 184 | 0;
 i19 = i23 + 152 | 0;
 i20 = i23 + 128 | 0;
 i5 = i23 + 124 | 0;
 i2 = i20;
 i3 = i2 + 20 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i16 = _strnlen(i15, 257) | 0;
 L1 : do if (i16 >>> 0 > 256) i1 = 0; else if (!(_strncmp(i4, gb + 1059596 | 0, 3) | 0)) {
  i2 = i4 + 3 | 0;
  do if (!(_strncmp(i2, gb + 1059600 | 0, 7) | 0)) {
   i2 = i4 + 10 | 0;
   if (((HEAP8[i2 >> 0] | 0) + -48 | 0) >>> 0 < 10) {
    i3 = _strtoul(i2, i5, 10) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if ((HEAP8[i2 >> 0] | 0) == 36) {
     i14 = i3 >>> 0 < 1e3 ? 1e3 : i3 >>> 0 > 9999999 ? 9999999 : i3;
     HEAP32[i6 >> 2] = i14;
     _sprintf(i20, gb + 1059608 | 0, i6) | 0;
     i13 = i2 + 1 | 0;
     break;
    }
   }
   i1 = 0;
   break L1;
  } else {
   i13 = i2;
   i14 = 5e3;
  } while (0);
  i2 = 0;
  L11 : do {
   switch (HEAP8[i13 + i2 >> 0] | 0) {
   case 58:
   case 10:
    {
     i1 = 0;
     break L1;
    }
   case 0:
   case 36:
    break L11;
   default:
    {}
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < 16);
  i5 = i17;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = i17 + 8 | 0;
  HEAP32[i5 >> 2] = 1779033703;
  i6 = i17 + 12 | 0;
  HEAP32[i6 >> 2] = -1150833019;
  i7 = i17 + 16 | 0;
  HEAP32[i7 >> 2] = 1013904242;
  i8 = i17 + 20 | 0;
  HEAP32[i8 >> 2] = -1521486534;
  i9 = i17 + 24 | 0;
  HEAP32[i9 >> 2] = 1359893119;
  i10 = i17 + 28 | 0;
  HEAP32[i10 >> 2] = -1694144372;
  i11 = i17 + 32 | 0;
  HEAP32[i11 >> 2] = 528734635;
  i12 = i17 + 36 | 0;
  HEAP32[i12 >> 2] = 1541459225;
  _sha256_update(i17, i15, i16);
  _sha256_update(i17, i13, i2);
  _sha256_update(i17, i15, i16);
  _sha256_sum(i17, i22);
  i4 = i17;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i5 >> 2] = 1779033703;
  HEAP32[i6 >> 2] = -1150833019;
  HEAP32[i7 >> 2] = 1013904242;
  HEAP32[i8 >> 2] = -1521486534;
  HEAP32[i9 >> 2] = 1359893119;
  HEAP32[i10 >> 2] = -1694144372;
  HEAP32[i11 >> 2] = 528734635;
  HEAP32[i12 >> 2] = 1541459225;
  _sha256_update(i17, i15, i16);
  _sha256_update(i17, i13, i2);
  _hashmd(i17, i16, i22);
  i4 = (i16 | 0) == 0;
  if (i4) {
   _sha256_sum(i17, i22);
   i15 = i17;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i5 >> 2] = 1779033703;
   HEAP32[i6 >> 2] = -1150833019;
   HEAP32[i7 >> 2] = 1013904242;
   HEAP32[i8 >> 2] = -1521486534;
   HEAP32[i9 >> 2] = 1359893119;
   HEAP32[i10 >> 2] = -1694144372;
   HEAP32[i11 >> 2] = 528734635;
   HEAP32[i12 >> 2] = 1541459225;
  } else {
   i3 = i16;
   do {
    if (!(i3 & 1)) _sha256_update(i17, i15, i16); else _sha256_update(i17, i22, 32);
    i3 = i3 >>> 1;
   } while ((i3 | 0) != 0);
   _sha256_sum(i17, i22);
   i3 = i17;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i5 >> 2] = 1779033703;
   HEAP32[i6 >> 2] = -1150833019;
   HEAP32[i7 >> 2] = 1013904242;
   HEAP32[i8 >> 2] = -1521486534;
   HEAP32[i9 >> 2] = 1359893119;
   HEAP32[i10 >> 2] = -1694144372;
   HEAP32[i11 >> 2] = 528734635;
   HEAP32[i12 >> 2] = 1541459225;
   if (!i4) {
    i3 = 0;
    do {
     _sha256_update(i17, i15, i16);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i16 | 0));
   }
  }
  _sha256_sum(i17, i18);
  i4 = i17;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i5 >> 2] = 1779033703;
  HEAP32[i6 >> 2] = -1150833019;
  HEAP32[i7 >> 2] = 1013904242;
  HEAP32[i8 >> 2] = -1521486534;
  HEAP32[i9 >> 2] = 1359893119;
  HEAP32[i10 >> 2] = -1694144372;
  HEAP32[i11 >> 2] = 528734635;
  HEAP32[i12 >> 2] = 1541459225;
  i4 = (HEAPU8[i22 >> 0] | 0) + 15 | 0;
  i3 = 0;
  while (1) {
   _sha256_update(i17, i13, i2);
   if ((i3 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
  _sha256_sum(i17, i19);
  if (i14 | 0) {
   i3 = 0;
   do {
    i4 = i17;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i5 >> 2] = 1779033703;
    HEAP32[i6 >> 2] = -1150833019;
    HEAP32[i7 >> 2] = 1013904242;
    HEAP32[i8 >> 2] = -1521486534;
    HEAP32[i9 >> 2] = 1359893119;
    HEAP32[i10 >> 2] = -1694144372;
    HEAP32[i11 >> 2] = 528734635;
    HEAP32[i12 >> 2] = 1541459225;
    i4 = (i3 & 1 | 0) != 0;
    if (i4) _hashmd(i17, i16, i18); else _sha256_update(i17, i22, 32);
    if ((i3 >>> 0) % 3 | 0 | 0) _sha256_update(i17, i19, i2);
    if ((i3 >>> 0) % 7 | 0 | 0) _hashmd(i17, i16, i18);
    if (i4) _sha256_update(i17, i22, 32); else _hashmd(i17, i16, i18);
    _sha256_sum(i17, i22);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i14 | 0));
  }
  HEAP32[i21 >> 2] = i20;
  HEAP32[i21 + 4 >> 2] = i2;
  HEAP32[i21 + 8 >> 2] = i13;
  i5 = _sprintf(i1, gb + 1059619 | 0, i21) | 0;
  i7 = i5 + 40 | 0;
  i5 = i1 + i5 | 0;
  i6 = 0;
  while (1) {
   i2 = HEAPU8[i22 + (HEAPU8[gb + 1059630 + (i6 * 3 | 0) + 1 >> 0] | 0) >> 0] << 8 | HEAPU8[i22 + (HEAPU8[gb + 1059630 + (i6 * 3 | 0) >> 0] | 0) >> 0] << 16 | HEAPU8[i22 + (HEAPU8[gb + 1059630 + (i6 * 3 | 0) + 2 >> 0] | 0) >> 0];
   i3 = i5;
   i4 = 4;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
    if ((i4 | 0) > 1) {
     i2 = i2 >>> 6;
     i3 = i3 + 1 | 0;
     i4 = i4 + -1 | 0;
    } else break;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 10) break; else i5 = i5 + 4 | 0;
  }
  i5 = i1 + i7 | 0;
  i2 = HEAPU8[i22 + 31 >> 0] << 8 | HEAPU8[i22 + 30 >> 0];
  i3 = i5;
  i4 = 3;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
   if ((i4 | 0) > 1) {
    i2 = i2 >>> 6;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else break;
  }
  HEAP8[i5 + 3 >> 0] = 0;
 } else i1 = 0; while (0);
 STACKTOP = i23;
 return i1 | 0;
}

function __Z23RemapVertexDataChannelsPKjjR10VertexData(i11, i12, i17) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 104 | 0;
 i14 = i19;
 i3 = i19 + 120 | 0;
 i15 = i17 + 92 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i18 = i14 + 100 | 0;
 i1 = i14;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i18 >> 0] = 1;
 i10 = i17 + 88 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i17 + 32 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 44 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 56 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 68 >> 2];
 HEAP16[i3 >> 1] = HEAP16[i17 + 2 >> 1] | 0;
 HEAP16[i3 + 2 >> 1] = HEAP16[i17 + 6 >> 1] | 0;
 HEAP16[i3 + 4 >> 1] = HEAP16[i17 + 10 >> 1] | 0;
 HEAP16[i3 + 6 >> 1] = HEAP16[i17 + 14 >> 1] | 0;
 HEAP16[i3 + 8 >> 1] = HEAP16[i17 + 18 >> 1] | 0;
 HEAP16[i3 + 10 >> 1] = HEAP16[i17 + 22 >> 1] | 0;
 HEAP16[i3 + 12 >> 1] = HEAP16[i17 + 26 >> 1] | 0;
 HEAP16[i3 + 14 >> 1] = HEAP16[i17 + 30 >> 1] | 0;
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i14, i12, i8, 0, i13, i3);
 i8 = i17 + 84 | 0;
 i9 = i14 + 84 | 0;
 if (i12 | 0) {
  i2 = 0;
  do {
   if (HEAP8[i17 + (i2 << 2) + 3 >> 0] | 0) {
    i5 = HEAP16[i17 + (i2 << 2) >> 1] | 0;
    i3 = (HEAP32[i8 >> 2] | 0) + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i17 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i4 = HEAP16[i14 + (i2 << 2) >> 1] | 0;
    i4 = (HEAP32[i9 >> 2] | 0) + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i14 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i17 + 32 + ((i5 & 255) * 12 | 0) + 10 >> 0] | 0;
    i6 = HEAP16[i17 + (i2 << 2) + 2 >> 1] | 0;
    i6 = Math_imul((i6 & 65535) >>> 8 & 65535, HEAPU8[(i6 & 255) + (gb + 430676) >> 0] | 0) | 0;
    i1 = 0;
    do {
     i7 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
     if (i7 >>> 0 < i16 >>> 0) _memcpy(i4 + (Math_imul(i1, i5) | 0) | 0, i3 + (Math_imul(i7, i5) | 0) | 0, i6 | 0) | 0; else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430751 | 0, 0, gb + 430527 | 0, 683, 1, 0, 0, 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i12 | 0));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 8);
 }
 i12 = HEAP32[i17 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i12;
 i12 = i17 + 4 | 0;
 i1 = i14 + 4 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i1 = i17 + 8 | 0;
 i16 = i14 + 8 | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i12;
 i16 = i17 + 12 | 0;
 i12 = i14 + 12 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i1;
 i12 = i17 + 16 | 0;
 i1 = i14 + 16 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i1 = i17 + 20 | 0;
 i16 = i14 + 20 | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i12;
 i16 = i17 + 24 | 0;
 i12 = i14 + 24 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i1;
 i12 = i17 + 28 | 0;
 i1 = i14 + 28 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i1 = i17 + 32 | 0;
 i16 = i14 + 32 | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i16 = i17 + 44 | 0;
 i1 = i14 + 44 | 0;
 HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i1 = i17 + 56 | 0;
 i16 = i14 + 56 | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i16 = i17 + 68 | 0;
 i1 = i14 + 68 | 0;
 HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i13 = i14 + 88 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i17 + 80 | 0;
 i1 = i14 + 80 | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i1 = i14 + 92 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i15 = i17 + 96 | 0;
 i1 = i14 + 96 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i16;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i1;
 i16 = i17 + 100 | 0;
 i17 = HEAP8[i16 >> 0] | 0;
 HEAP8[i16 >> 0] = HEAP8[i18 >> 0] | 0;
 HEAP8[i18 >> 0] = i17;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 STACKTOP = i19;
 return;
}

function __ZN7mecanim12statemachine10StartStateERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEb(i3, i4, i1, i22, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i26 + 8 | 0;
 i24 = i26;
 HEAP8[i1 + 18 >> 0] = 1;
 if (!(HEAP32[i22 >> 2] | 0)) {
  STACKTOP = i26;
  return;
 }
 i21 = i2 ? i22 + 8 | 0 : i22 + 12 | 0;
 i20 = i1 + 12 | 0;
 i19 = i2 & 1 ^ 1;
 i16 = i3 + 4 | 0;
 i17 = i16;
 i18 = i4 + 4 | 0;
 i15 = i4 + 8 | 0;
 i14 = 0;
 do {
  i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i20 >> 2] >> 2] | 0) + (i14 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + (i19 << 3) + 4 >> 2] | 0;
  i1 = (HEAP32[i16 >> 2] | 0) + i17 + (HEAP32[i21 >> 2] << 2) | 0;
  i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
  i2 = i1 + 12 | 0;
  i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i14 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i13 = i1 + 20 | 0;
   i13 = (HEAP32[i13 >> 2] | 0) + i13 + (i2 << 2) | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = i13 + i12 | 0;
   i11 = i13;
   if (!((i12 | 0) == 0 | (i13 | 0) == 0)) {
    i12 = HEAP32[i3 + 8 >> 2] | 0;
    i13 = i12 + 16 | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    if (!i1) i3 = 0; else {
     i9 = i11 + 4 | 0;
     i10 = i9;
     i3 = 0;
     i8 = 0;
     do {
      i7 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
      i2 = (HEAP32[i9 >> 2] | 0) + i10 + (i8 << 2) | 0;
      i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
      if ((i2 | 0) != -1) {
       i4 = HEAP32[i18 >> 2] | 0;
       i6 = HEAP32[(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0) + (i2 * 40 | 0) >> 2] | 0;
       if (i6) {
        L17 : do if (!i4) i1 = i6; else {
         i1 = HEAP32[i4 >> 2] | 0;
         i5 = HEAP32[i4 + 12 >> 2] | 0;
         i4 = i1 + (i5 << 3) | 0;
         i2 = HEAP32[i6 + 4 >> 2] | 0;
         L19 : do if (i5) while (1) {
          if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break L19;
          i1 = i1 + 8 | 0;
          if ((i1 | 0) == (i4 | 0)) {
           i1 = i6;
           break L17;
          }
         } while (0);
         if ((i1 | 0) == (i4 | 0)) i1 = i6; else {
          i5 = i1 + 4 | 0;
          i1 = HEAP32[i5 >> 2] | 0;
          if (!i1) i1 = i6; else {
           HEAP32[i24 >> 2] = i1;
           i1 = HEAP32[gb + 1104264 >> 2] | 0;
           do if (!i1) i25 = 23; else {
            if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
             i2 = HEAP32[i1 + 28 >> 2] | 0;
             i4 = HEAP32[i1 + 32 >> 2] | 0;
             i1 = i2 + (i4 << 3) | 0;
            } else {
             __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
             i2 = HEAP32[i23 >> 2] | 0;
             i27 = HEAP32[i1 + 28 >> 2] | 0;
             i4 = HEAP32[gb + 1104264 >> 2] | 0;
             i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
             i2 = HEAP32[i4 + 28 >> 2] | 0;
             i4 = HEAP32[i4 + 32 >> 2] | 0;
            }
            if ((i1 | 0) == (i2 + (i4 << 3) | 0)) {
             i25 = 23;
             break;
            }
            if (!(HEAP32[i1 + 4 >> 2] | 0)) i25 = 25;
           } while (0);
           if ((i25 | 0) == 23) i25 = 25;
           if ((i25 | 0) == 25) {
            i25 = 0;
            if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
             i1 = i6;
             break;
            }
           }
           i1 = HEAP32[i5 >> 2] | 0;
           if (!i1) i1 = 0; else {
            HEAP32[i24 >> 2] = i1;
            i1 = HEAP32[gb + 1104264 >> 2] | 0;
            do if (!i1) i25 = 32; else {
             if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
              i2 = HEAP32[i1 + 28 >> 2] | 0;
              i4 = HEAP32[i1 + 32 >> 2] | 0;
              i1 = i2 + (i4 << 3) | 0;
             } else {
              __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i23, i1, i24);
              i2 = HEAP32[i23 >> 2] | 0;
              i27 = HEAP32[i1 + 28 >> 2] | 0;
              i4 = HEAP32[gb + 1104264 >> 2] | 0;
              i1 = (i2 | 0) == -1 ? i27 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i27 + (i2 << 3) | 0;
              i2 = HEAP32[i4 + 28 >> 2] | 0;
              i4 = HEAP32[i4 + 32 >> 2] | 0;
             }
             if ((i1 | 0) == (i2 + (i4 << 3) | 0)) {
              i25 = 32;
              break;
             }
             i1 = HEAP32[i1 + 4 >> 2] | 0;
             if (!i1) i25 = 34;
            } while (0);
            if ((i25 | 0) == 32) i25 = 34;
            if ((i25 | 0) == 34) {
             i25 = 0;
             i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
            }
           }
          }
         }
        } while (0);
        __ZN21AnimationClipPlayable7SetClipEP13AnimationClip(i7, i1);
        i1 = HEAP32[i11 >> 2] | 0;
       }
       i3 = i3 + 1 | 0;
      }
      i8 = i8 + 1 | 0;
     } while (i8 >>> 0 < i1 >>> 0);
    }
    i2 = i12 + 28 | 0;
    if (i3 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0) {
     i1 = i3;
     do {
      __ZN21AnimationClipPlayable7SetClipEP13AnimationClip(HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0, 0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0);
    }
   }
  }
  i14 = i14 + 1 | 0;
 } while (i14 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
 STACKTOP = i26;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i12 = i16 + 24 | 0;
 i11 = i16;
 i4 = i16 + 20 | 0;
 i5 = i16 + 16 | 0;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = ((HEAP32[i14 >> 2] | 0) - i2 | 0) / 172 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i9 >>> 0) {
  if (i3 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i6 = i1 + (i9 * 172 | 0) | 0;
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  i8 = i12 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i10 = i12 + 12 | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = i9 * 172 | 0;
  i4 = (i3 | 0) / 172 | 0;
  if (!i3) {
   i4 = i12 + 8 | 0;
   i6 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
    i2 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i2;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i12 >> 2] = i3;
   i2 = i3 + (i4 * 172 | 0) | 0;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = i2;
   i5 = i3;
   if (!i9) {
    i4 = i7;
    i6 = i5;
    i3 = i5;
   } else {
    i2 = i3;
    do {
     __ZN13AnimationClip12Vector3CurveC2ERKS0_(i2, i1);
     i1 = i1 + 172 | 0;
     i2 = (HEAP32[i8 >> 2] | 0) + 172 | 0;
     HEAP32[i8 >> 2] = i2;
    } while ((i1 | 0) != (i6 | 0));
    i4 = i7;
    i6 = HEAP32[i12 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i14 >> 2] = i3;
  i5 = i13 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  i5 = i1;
  i2 = i11;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i4 = i15 + 4 | 0;
    do {
     i1 = i2 + -172 | 0;
     HEAP32[i8 >> 2] = i1;
     i3 = i2 + -36 | 0;
     if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
      HEAP32[i3 >> 2] = 0;
     }
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i14 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -160 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i4 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
     }
     i2 = HEAP32[i8 >> 2] | 0;
    } while ((i2 | 0) != (i5 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i14 = HEAP32[i10 >> 2] | 0;
   HEAP32[i15 >> 2] = 25;
   HEAP32[i15 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i2 | 0) / 172 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i13, i9 - i3 | 0);
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i2;
 __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i11, i9);
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i12, i15);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 172 | 0;
 i5 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i11, i9 - i1 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i6 = i3 + (i9 * 172 | 0) | 0;
  if ((i5 | 0) != (i6 | 0)) {
   i4 = i15 + 4 | 0;
   i2 = i5;
   do {
    i1 = i2 + -172 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i1 >> 2] | 0;
     i9 = HEAP32[i2 + -160 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
    }
    i2 = HEAP32[i8 >> 2] | 0;
   } while ((i2 | 0) != (i6 | 0));
  }
 }
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i13 >> 2] = i5;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i8 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i11 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i4 = i15 + 4 | 0;
   do {
    i1 = i2 + -172 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -160 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
    }
    i2 = HEAP32[i8 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i14 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 >> 2] = 25;
  HEAP32[i15 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i5, i4, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i1 = i5 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 12 >> 2]) == Math_fround(1.0)) {
  i5 = i5 + 36 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  f16 = Math_fround(HEAPF32[i1 >> 2]);
  f23 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f11 = Math_fround(f16 + f23);
  f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f24 = Math_fround(f8 + f22);
  f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f11 = Math_fround(f11 * Math_fround(.5));
  f24 = Math_fround(f24 * Math_fround(.5));
  f13 = Math_fround(Math_fround(f10 + f21) * Math_fround(.5));
  f20 = Math_fround(HEAPF32[i4 >> 2]);
  f7 = Math_fround(f11 * f20);
  f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f12 = Math_fround(f11 * f18);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f11 = Math_fround(f11 * f15);
  f19 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f26 = Math_fround(f24 * f19);
  f17 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f25 = Math_fround(f24 * f17);
  f9 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f26 = Math_fround(f7 + f26);
  f25 = Math_fround(f12 + f25);
  f24 = Math_fround(f11 + Math_fround(f24 * f9));
  f11 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f12 = Math_fround(f13 * f11);
  f7 = Math_fround(HEAPF32[i4 + 28 >> 2]);
  f14 = Math_fround(f13 * f7);
  f6 = Math_fround(HEAPF32[i4 + 32 >> 2]);
  f12 = Math_fround(f26 + f12);
  f14 = Math_fround(f25 + f14);
  f13 = Math_fround(f24 + Math_fround(f13 * f6));
  f16 = Math_fround(Math_fround(f23 - f16) * Math_fround(.5));
  f8 = Math_fround(Math_fround(f22 - f8) * Math_fround(.5));
  f10 = Math_fround(Math_fround(f21 - f10) * Math_fround(.5));
  f11 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f20))) + Math_fround(Math_abs(Math_fround(f8 * f19)))) + Math_fround(Math_abs(Math_fround(f10 * f11))));
  f7 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f18))) + Math_fround(Math_abs(Math_fround(f8 * f17)))) + Math_fround(Math_abs(Math_fround(f10 * f7))));
  f6 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f15))) + Math_fround(Math_abs(Math_fround(f8 * f9)))) + Math_fround(Math_abs(Math_fround(f10 * f6))));
  f10 = Math_fround(f14 - f7);
  f9 = Math_fround(f13 - f6);
  f8 = Math_fround(f12 + f11);
  f7 = Math_fround(f14 + f7);
  f6 = Math_fround(f13 + f6);
  HEAPF32[i2 >> 2] = Math_fround(f12 - f11);
  HEAPF32[i2 + 4 >> 2] = f10;
  HEAPF32[i2 + 8 >> 2] = f9;
  HEAPF32[i2 + 12 >> 2] = f8;
  HEAPF32[i2 + 16 >> 2] = f7;
  HEAPF32[i2 + 20 >> 2] = f6;
  __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE(i3, HEAP32[i5 >> 2] | 0, i4);
  i5 = 1;
  return i5 | 0;
 }
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i4, i1, i5 + 16 | 0);
 i5 = i5 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f21 = Math_fround(f16 + f9);
 f24 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(f24 + f10);
 f22 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f21 = Math_fround(f21 * Math_fround(.5));
 f8 = Math_fround(f8 * Math_fround(.5));
 f19 = Math_fround(Math_fround(f22 + f11) * Math_fround(.5));
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(f21 * f12);
 f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f20 = Math_fround(f21 * f14);
 f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f21 = Math_fround(f21 * f17);
 f13 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f6 = Math_fround(f8 * f13);
 f15 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f7 = Math_fround(f8 * f15);
 f23 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f6 = Math_fround(f25 + f6);
 f7 = Math_fround(f20 + f7);
 f8 = Math_fround(f21 + Math_fround(f8 * f23));
 f21 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f20 = Math_fround(f19 * f21);
 f25 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f18 = Math_fround(f19 * f25);
 f26 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f20 = Math_fround(f6 + f20);
 f18 = Math_fround(f7 + f18);
 f19 = Math_fround(f8 + Math_fround(f19 * f26));
 f16 = Math_fround(Math_fround(f9 - f16) * Math_fround(.5));
 f24 = Math_fround(Math_fround(f10 - f24) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f11 - f22) * Math_fround(.5));
 f21 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f12))) + Math_fround(Math_abs(Math_fround(f24 * f13)))) + Math_fround(Math_abs(Math_fround(f22 * f21))));
 f25 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f14))) + Math_fround(Math_abs(Math_fround(f24 * f15)))) + Math_fround(Math_abs(Math_fround(f22 * f25))));
 f26 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f16 * f17))) + Math_fround(Math_abs(Math_fround(f24 * f23)))) + Math_fround(Math_abs(Math_fround(f22 * f26))));
 f22 = Math_fround(f18 - f25);
 f23 = Math_fround(f19 - f26);
 f24 = Math_fround(f20 + f21);
 f25 = Math_fround(f18 + f25);
 f26 = Math_fround(f19 + f26);
 HEAPF32[i2 >> 2] = Math_fround(f20 - f21);
 HEAPF32[i2 + 4 >> 2] = f22;
 HEAPF32[i2 + 8 >> 2] = f23;
 HEAPF32[i2 + 12 >> 2] = f24;
 HEAPF32[i2 + 16 >> 2] = f25;
 HEAPF32[i2 + 20 >> 2] = f26;
 __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE(i3, HEAP32[i5 >> 2] | 0, i4);
 i5 = i3 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i5 = 0;
 return i5 | 0;
}

function __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i14, i11, i15) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, d16 = 0.0;
 i1 = i14 + 248 | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
  i13 = i1;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i14, gb + 1163364 | 0, 0) | 0;
  i13 = HEAP32[(HEAP32[i14 + 36 >> 2] | 0) + ((HEAP32[i14 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
  i12 = HEAP32[HEAP32[(HEAP32[i14 + 16 >> 2] | 0) + (i13 >>> 14 << 2) >> 2] >> 2] | 0;
  d16 = +_emscripten_get_now() * 1.0e6;
  i10 = +Math_abs(d16) >= 1.0 ? (d16 > 0.0 ? ~~+Math_min(+Math_floor(d16 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d16 - +(~~d16 >>> 0)) / 4294967296.0) >>> 0) : 0;
  __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i14, gb + 1163364 | 0, ~~d16 >>> 0, i10) | 0;
  i10 = ___udivdi3(i2 | 0, i3 | 0, 1e3, 0) | 0;
  HEAPF32[i12 + ((i13 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i10 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 }
 i7 = i14 + 48 | 0;
 if (HEAP32[i14 + 280 >> 2] | 0) if ((HEAP32[i7 >> 2] | 0) == 1) {
  i13 = i14 + 224 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  d16 = +_emscripten_get_now() * 1.0e6;
  i13 = _i64Subtract(~~d16 >>> 0 | 0, (+Math_abs(d16) >= 1.0 ? (d16 > 0.0 ? ~~+Math_min(+Math_floor(d16 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d16 - +(~~d16 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i12 | 0, i13 | 0) | 0;
  i13 = __Z17TimeToNanosecondsy(i13, getTempRet0() | 0) | 0;
  if (Math_fround(Math_fround((+(i13 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3)) > Math_fround(1.0)) __ZN22UnityProfilerPerThread23InjectUnaccountedSampleEP19ProfilerInformationS1_(i14, HEAP32[i14 + 232 >> 2] | 0, i11);
 }
 i9 = i14 + 4 | 0;
 i2 = i14 + 36 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 + (i13 + -1 << 4) >> 2] | 0;
 i8 = (HEAP32[HEAP32[(HEAP32[i14 + 16 >> 2] | 0) + (i8 >>> 14 << 2) >> 2] >> 2] | 0) + ((i8 & 16383) * 24 | 0) + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i13 + 1 | 0;
 i4 = i14 + 52 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i8 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i1 << 4, 8, i14 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i2 >> 2] = i3;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 8, i14 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i3;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i8;
 i12 = i3 + (i13 << 4) | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 i10 = __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE9push_backEv(i9) | 0;
 HEAP32[i10 + 16 >> 2] = i11;
 if (HEAP16[i11 + 6 >> 1] & 2) {
  i2 = i14 + 116 | 0;
  i4 = i14 + 128 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i14 + 132 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i6 >>> 0 > i9 >>> 0) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i14 + 120 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 120 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i2 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i12 >> 2];
 }
 HEAP32[i10 + 12 >> 2] = 0;
 i11 = i10;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 if (!i15) {
  d16 = +_emscripten_get_now();
  d16 = d16 * 1.0e6;
  i11 = ~~d16 >>> 0;
  i14 = +Math_abs(d16) >= 1.0 ? (d16 > 0.0 ? ~~+Math_min(+Math_floor(d16 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d16 - +(~~d16 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i15 = i3 + (i13 << 4) + 8 | 0;
  i13 = i15;
  HEAP32[i13 >> 2] = i11;
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = i14;
  i15 = HEAP32[i12 >> 2] | 0;
  return i15 | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i14 + 76 | 0;
 i5 = i14 + 88 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i14 + 92 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i7 >>> 0 > i10 >>> 0) {
  i1 = i9 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 3, 4, i14 + 80 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i14 + 80 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i11 = (HEAP32[i4 >> 2] | 0) + (i6 << 3) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i15;
 d16 = +_emscripten_get_now();
 d16 = d16 * 1.0e6;
 i11 = ~~d16 >>> 0;
 i14 = +Math_abs(d16) >= 1.0 ? (d16 > 0.0 ? ~~+Math_min(+Math_floor(d16 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d16 - +(~~d16 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i15 = i3 + (i13 << 4) + 8 | 0;
 i13 = i15;
 HEAP32[i13 >> 2] = i11;
 i15 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i14;
 i15 = HEAP32[i12 >> 2] | 0;
 return i15 | 0;
}

function __ZN5physx2Sc27ConstraintProjectionManager21processPendingUpdatesERNS_19PxcScratchAllocatorE(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 12 | 0;
 i8 = i15 + 16 | 0;
 i13 = i15;
 i7 = i11 + 376 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i11 + 344 >> 2] | 0;
  i4 = 0;
  do {
   i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   i10 = i3 + 44 | 0;
   HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) & 251;
   if (HEAP32[i3 + 20 >> 2] | 0) __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE(i3);
   __ZN5physx2Sc24ConstraintProjectionTree20buildProjectionTreesERNS0_19ConstraintGroupNodeE(i3);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
  i1 = HEAP32[i11 + 360 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i11 + 352 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i11 + 356 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i11 + 348 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i11 + 368 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i10 = i11 + 336 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 if (!i6) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i13 >> 2] = i9;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
 i2 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i5 + (i4 + -1 << 2) >> 2] | 0;
 do if ((i1 - (HEAP32[i9 + 16 >> 2] | 0) | 0) < 272) i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, 272, gb + 717976 | 0, 82) | 0; else {
  i1 = i1 + -272 | 0;
  HEAP32[i12 >> 2] = i1;
  if ((HEAP32[i9 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[i5 + (i4 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = i4 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i2, i12) | 0;
   break;
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
 }
 HEAP32[i13 + 8 >> 2] = i1;
 i4 = HEAP32[i11 + 304 >> 2] | 0;
 i1 = 0;
 do {
  __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE(i11, HEAP32[i4 + (i1 << 2) >> 2] | 0, i13);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1;
 L33 : do if (!i1) i3 = 0; else {
  if (!(HEAP32[i2 + 4 >> 2] | 0)) {
   i2 = HEAP32[i2 >> 2] | 0;
   if (!i2) {
    i3 = 0;
    break;
   }
   i1 = i2;
  }
  i2 = i2 + 8 | 0;
  if (!i1) {
   __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE(i11, HEAP32[i2 >> 2] | 0, i13);
   i3 = 0;
   break;
  }
  while (1) {
   i3 = i1 + 4 | 0;
   __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE(i11, HEAP32[i2 >> 2] | 0, i13);
   if ((HEAP32[i3 >> 2] | 0) >>> 0 > 1) {
    i2 = 1;
    do {
     __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE(i11, HEAP32[i1 + 8 + (i2 << 2) >> 2] | 0, i13);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = 0;
    break L33;
   }
   i1 = i2;
   i2 = i2 + 8 | 0;
  }
 } while (0);
 do {
  i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
  i1 = HEAP32[i2 + 108 >> 2] | 0;
  if (!i1) i1 = HEAP32[i2 + 112 >> 2] | 0;
  i1 = __ZN5physx2Sc19ConstraintGroupNode7getRootEv(HEAP32[i1 + 60 >> 2] | 0) | 0;
  if (!(HEAP32[i1 + 20 >> 2] | 0)) __ZN5physx2Sc24ConstraintProjectionTree20buildProjectionTreesERNS0_19ConstraintGroupNodeE(i1);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 i1 = HEAP32[i11 + 320 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i10 >> 2] | 0) {
  _memset(HEAP32[i11 + 312 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i11 + 316 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i11 + 308 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i11 + 328 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 do {
  i5 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i10 + 16 >> 2] | 0;
  if (i2 >>> 0 > i5 >>> 0) i14 = 47; else if ((i2 + (HEAP32[i10 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
   i7 = i10 + 8 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i9 = i10 + 4 | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i2 = i8;
   while (1) {
    i4 = i2 + -1 | 0;
    i3 = i6 + (i4 << 2) | 0;
    if ((HEAP32[i3 >> 2] | 0) >>> 0 < i5 >>> 0) i2 = i4; else break;
   }
   if (i2 >>> 0 < i8 >>> 0) {
    HEAP32[i3 >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 < i8 >>> 0) do {
     i3 = i3 + 4 | 0;
     HEAP32[i3 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i8 | 0));
   }
   HEAP32[i7 >> 2] = i8 + -1;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
  } else i14 = 47;
  if ((i14 | 0) == 47) {
   i14 = 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, i5);
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i15;
 return;
}

function __ZNK5physx30PxTolerancesScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 12 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj207ENS_22PxRepXPropertyAccessorILj207ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 28 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj208ENS_22PxRepXPropertyAccessorILj208ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 44 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj209ENS_22PxRepXPropertyAccessorILj209ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14DetailDatabase15ValidateDetailsEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27 + 24 | 0;
 i21 = i27 + 8 | 0;
 i1 = i27;
 i22 = i27 + 28 | 0;
 i19 = ((HEAP32[i20 + 20 >> 2] | 0) - (HEAP32[i20 + 16 >> 2] | 0) | 0) / 136 | 0;
 i16 = HEAP32[i20 + 40 >> 2] | 0;
 i16 = Math_imul(i16, i16) | 0;
 i25 = gb + 64016 | 0;
 i24 = HEAP32[i25 + 4 >> 2] | 0;
 i23 = i1;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i22 >> 2] = 0;
 i23 = i22 + 12 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i22 + 16 | 0;
 HEAP32[i24 >> 2] = 0;
 i25 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i1);
 i1 = i21;
 i18 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = i25;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i20 + 4 | 0;
 i18 = i20 + 8 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 L1 : do if ((HEAP32[i18 >> 2] | 0) != (i1 | 0)) {
  i15 = 0;
  i3 = 0;
  do {
   i12 = i1 + (i15 * 52 | 0) + 28 | 0;
   i13 = i1 + (i15 * 52 | 0) + 32 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   L4 : do if ((i2 | 0) != (i4 | 0)) {
    i14 = i1 + (i15 * 52 | 0) + 40 | 0;
    i11 = i1 + (i15 * 52 | 0) + 44 | 0;
    i10 = 0;
    do {
     i1 = i4;
     i7 = Math_imul(i10, i16) | 0;
     i9 = i10;
     i10 = i10 + 1 | 0;
     i8 = Math_imul(i10, i16) | 0;
     L8 : do if ((i7 | 0) == (i8 | 0)) while (1) {
      i5 = i1 + i9 | 0;
      i6 = HEAPU8[i5 >> 0] | 0;
      if (i6 >>> 0 < i19 >>> 0) break L8;
      i1 = i5 + 1 | 0;
      i3 = i2 - i1 | 0;
      if (i3) {
       _memmove(i5 | 0, i1 | 0, i3 | 0) | 0;
       i2 = HEAP32[i13 >> 2] | 0;
      }
      i1 = i5 + i3 | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i1;
      i3 = HEAP32[i23 >> 2] | 0;
      if (i6 >>> 0 >= i3 >>> 0) {
       i1 = i6 + 1 | 0;
       HEAP32[i23 >> 2] = i1;
       i2 = HEAP32[i24 >> 2] | 0;
       do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1, 1, i25, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i25, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i8 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = i8;
        break;
       } while (0);
       if (i1 >>> 0 > i3 >>> 0) {
        i1 = i1 - i3 | 0;
        if (i1 | 0) _memset((HEAP32[i22 >> 2] | 0) + i3 | 0, 0, i1 | 0) | 0;
       }
      }
      i3 = HEAP32[i22 >> 2] | 0;
      HEAP8[i3 + i6 >> 0] = 1;
      i2 = HEAP32[i13 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      if (i9 >>> 0 < (i2 - i1 | 0) >>> 0) i4 = i1; else break L4;
     } else while (1) {
      i5 = i1 + i9 | 0;
      i6 = HEAPU8[i5 >> 0] | 0;
      if (i6 >>> 0 < i19 >>> 0) break L8;
      i1 = i5 + 1 | 0;
      i3 = i2 - i1 | 0;
      if (i3) {
       _memmove(i5 | 0, i1 | 0, i3 | 0) | 0;
       i2 = HEAP32[i13 >> 2] | 0;
      }
      i1 = i5 + i3 | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i1;
      i1 = HEAP32[i14 >> 2] | 0;
      i3 = i1 + i7 | 0;
      i1 = i1 + i8 | 0;
      i2 = HEAP32[i11 >> 2] | 0;
      i4 = i2 - i1 | 0;
      if (i4) {
       _memmove(i3 | 0, i1 | 0, i4 | 0) | 0;
       i2 = HEAP32[i11 >> 2] | 0;
      }
      i1 = i3 + i4 | 0;
      if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i1;
      i3 = HEAP32[i23 >> 2] | 0;
      if (i6 >>> 0 >= i3 >>> 0) {
       i1 = i6 + 1 | 0;
       HEAP32[i23 >> 2] = i1;
       i2 = HEAP32[i24 >> 2] | 0;
       do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1, 1, i25, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i25, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i5 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i23 >> 2] | 0) | 0;
        HEAP32[i24 >> 2] = i1;
        HEAP32[i22 >> 2] = i5;
        break;
       } while (0);
       if (i1 >>> 0 > i3 >>> 0) {
        i1 = i1 - i3 | 0;
        if (i1 | 0) _memset((HEAP32[i22 >> 2] | 0) + i3 | 0, 0, i1 | 0) | 0;
       }
      }
      i3 = HEAP32[i22 >> 2] | 0;
      HEAP8[i3 + i6 >> 0] = 1;
      i2 = HEAP32[i13 >> 2] | 0;
      i4 = HEAP32[i12 >> 2] | 0;
      if (i9 >>> 0 < (i2 - i4 | 0) >>> 0) i1 = i4; else break L4;
     } while (0);
    } while (i10 >>> 0 < (i2 - i4 | 0) >>> 0);
   } while (0);
   i15 = i15 + 1 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
  } while (i15 >>> 0 < (((HEAP32[i18 >> 2] | 0) - i1 | 0) / 52 | 0) >>> 0);
  i1 = HEAP32[i23 >> 2] | 0;
  if (i1 | 0) {
   i5 = i20 + 28 | 0;
   i6 = i21 + 11 | 0;
   i4 = 0;
   while (1) {
    if (!(HEAP8[i3 + i4 >> 0] | 0)) i2 = i1; else {
     HEAP32[i26 >> 2] = i4;
     __Z6FormatPKcz(i21, gb + 932953 | 0, i26);
     i1 = HEAP32[i5 >> 2] | 0;
     if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 932993 | 0, 707, 1, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
     i2 = HEAP32[i23 >> 2] | 0;
    }
    i1 = i4 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
    i4 = i1;
    i3 = HEAP32[i22 >> 2] | 0;
    i1 = i2;
   }
  }
 } while (0);
 if ((HEAP32[i24 >> 2] | 0) <= -1) {
  STACKTOP = i27;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i25);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i27;
 return;
}

function __ZN5physx2Gu15EdgeListBuilder18CreateFacesToEdgesEjPKjPKt(i23, i12, i7, i9) {
 i23 = i23 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i24;
 i22 = i24 + 4 | 0;
 i18 = i24 + 43 | 0;
 i19 = i24 + 42 | 0;
 i20 = i24 + 41 | 0;
 i21 = i24 + 40 | 0;
 if (i12 | 0) {
  i2 = (i7 | 0) != 0;
  i8 = (i9 | 0) != 0;
  if (i2 | i8) {
   i11 = i23 + 12 | 0;
   if (HEAP32[i11 >> 2] | 0) {
    i23 = 1;
    STACKTOP = i24;
    return i23 | 0;
   }
   i1 = i12 >>> 0 > 357913941 ? -1 : i12 * 12 | 0;
   if (!i1) i1 = 0; else {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
    i17 = _PxGetFoundation() | 0;
    i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
    i1 = mftCall_iiiiii(i15 | 0, i16 | 0, i1 | 0, (i17 ? gb + 728456 | 0 : gb + 837976 | 0) | 0, gb + 728039 | 0, 135) | 0;
   }
   HEAP32[i11 >> 2] = i1;
   i14 = i12 * 3 | 0;
   i1 = i14 >>> 0 > 1073741823 ? -1 : i14 << 2;
   if (!i1) {
    i17 = 0;
    i15 = 0;
    i16 = 0;
   } else {
    i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
    i15 = _PxGetFoundation() | 0;
    i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
    i15 = mftCall_iiiiii(i6 | 0, i13 | 0, i1 | 0, (i15 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 728039 | 0, 136) | 0;
    i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
    i16 = _PxGetFoundation() | 0;
    i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
    i17 = i15;
    i16 = mftCall_iiiiii(i6 | 0, i13 | 0, i1 | 0, (i16 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 728039 | 0, 137) | 0;
   }
   i1 = i14 >>> 0 > 536870911 ? -1 : i14 << 3;
   if (!i1) i13 = 0; else {
    i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
    i13 = _PxGetFoundation() | 0;
    i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0;
    i13 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i13 ? gb + 728584 | 0 : gb + 837976 | 0) | 0, gb + 728039 | 0, 138) | 0;
   }
   if (i2) {
    i6 = 0;
    do {
     i1 = i6 * 3 | 0;
     i2 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
     i3 = HEAP32[i7 + (i1 + 1 << 2) >> 2] | 0;
     i4 = HEAP32[i7 + (i1 + 2 << 2) >> 2] | 0;
     i5 = i15 + (i1 << 2) | 0;
     if (i2 >>> 0 < i3 >>> 0) {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i16 + (i1 << 2) >> 2] = i3;
     } else {
      HEAP32[i5 >> 2] = i3;
      HEAP32[i16 + (i1 << 2) >> 2] = i2;
     }
     i10 = i3 >>> 0 < i4 >>> 0;
     i9 = i1 + 1 | 0;
     HEAP32[i15 + (i9 << 2) >> 2] = i10 ? i3 : i4;
     HEAP32[i16 + (i9 << 2) >> 2] = i10 ? i4 : i3;
     i9 = i4 >>> 0 < i2 >>> 0;
     i10 = i1 + 2 | 0;
     HEAP32[i15 + (i10 << 2) >> 2] = i9 ? i4 : i2;
     HEAP32[i16 + (i10 << 2) >> 2] = i9 ? i2 : i4;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i12 | 0));
   } else {
    i6 = 0;
    do {
     i5 = i6 * 3 | 0;
     if (i8) {
      i25 = HEAP16[i9 + (i5 << 1) >> 1] | 0;
      i1 = i25 & 65535;
      i7 = HEAP16[i9 + (i5 + 1 << 1) >> 1] | 0;
      i2 = i7 & 65535;
      i4 = HEAPU16[i9 + (i5 + 2 << 1) >> 1] | 0;
      i3 = i15 + (i5 << 2) | 0;
      if ((i25 & 65535) < (i7 & 65535)) i10 = 19; else {
       HEAP32[i3 >> 2] = i2;
       HEAP32[i16 + (i5 << 2) >> 2] = i1;
       i3 = i4;
      }
     } else {
      i2 = 1;
      i4 = 2;
      i1 = 0;
      i3 = i15 + (i5 << 2) | 0;
      i10 = 19;
     }
     if ((i10 | 0) == 19) {
      i10 = 0;
      HEAP32[i3 >> 2] = i1;
      HEAP32[i16 + (i5 << 2) >> 2] = i2;
      i3 = i4;
     }
     i25 = i2 >>> 0 < i3 >>> 0;
     i7 = i5 + 1 | 0;
     HEAP32[i15 + (i7 << 2) >> 2] = i25 ? i2 : i3;
     HEAP32[i16 + (i7 << 2) >> 2] = i25 ? i3 : i2;
     i7 = i3 >>> 0 < i1 >>> 0;
     i25 = i5 + 2 | 0;
     HEAP32[i15 + (i25 << 2) >> 2] = i7 ? i3 : i1;
     HEAP32[i16 + (i25 << 2) >> 2] = i7 ? i1 : i3;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i12 | 0));
   }
   __ZN5physx2Gu17RadixSortBufferedC2Ev(i22);
   i7 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i22, i16, i14, 0) | 0, i15, i14, 0) | 0) + 8 >> 2] | 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = i12;
   if (!i14) i1 = 0; else {
    i2 = HEAP32[i11 >> 2] | 0;
    i4 = -1;
    i5 = -1;
    i6 = 0;
    do {
     i3 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
     i12 = i4;
     i4 = HEAP32[i15 + (i3 << 2) >> 2] | 0;
     i25 = i5;
     i5 = HEAP32[i16 + (i3 << 2) >> 2] | 0;
     i1 = HEAP32[i23 >> 2] | 0;
     if (!((i4 | 0) == (i12 | 0) & (i5 | 0) == (i25 | 0))) {
      HEAP32[i13 + (i1 << 3) >> 2] = i4;
      HEAP32[i13 + (i1 << 3) + 4 >> 2] = i5;
      i1 = i1 + 1 | 0;
      HEAP32[i23 >> 2] = i1;
     }
     HEAP32[i2 + (((i3 >>> 0) / 3 | 0) * 12 | 0) + (((i3 >>> 0) % 3 | 0) << 2) >> 2] = i1 + -1;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i14 | 0));
    i1 = HEAP32[i23 >> 2] << 3;
   }
   i25 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, i1, gb + 728039 | 0, 192) | 0;
   HEAP32[i23 + 4 >> 2] = i25;
   _memcpy(i25 | 0, i13 | 0, HEAP32[i23 >> 2] << 3 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, i13);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i20, i16);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i21, i17);
   __ZN5physx2Gu17RadixSortBufferedD2Ev(i22);
   i25 = 1;
   STACKTOP = i24;
   return i25 | 0;
  }
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 728039 | 0, 128, gb + 728410 | 0, i1);
 i25 = 0;
 STACKTOP = i24;
 return i25 | 0;
}

function __ZNK5physx28PxParticleFluidGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 348 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj187ENS_22PxRepXPropertyAccessorILj187ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 364 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i7;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj188ENS_22PxRepXPropertyAccessorILj188ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 380 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj189ENS_22PxRepXPropertyAccessorILj189ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __Z26InitClipMuscleAdditivePoseRN7mecanim9animation18ClipMuscleConstantES2_PN11UnityEngine9Animation20AnimationSetBindingsEfRNS_6memory9AllocatorE(i24, i25, i1, f2, i5) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i27 + 8 | 0;
 i6 = i27;
 i26 = i27 + 16 | 0;
 i21 = i1 + 36 | 0;
 i18 = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0;
 i23 = gb + 64016 | 0;
 i20 = HEAP32[i23 + 4 >> 2] | 0;
 i22 = i6;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i22 + 4 >> 2] = i20;
 HEAP32[i26 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i6 = i3;
 i22 = HEAP32[i6 + 4 >> 2] | 0;
 i20 = i26 + 4 | 0;
 HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i20 + 4 >> 2] = i22;
 i20 = i25 + 1060 | 0;
 i22 = HEAP32[i20 >> 2] | 0;
 i6 = i20;
 i22 = __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE((i22 | 0) == 0 ? 0 : i22 + i6 | 0, i26) | 0;
 i23 = HEAP32[i20 >> 2] | 0;
 i23 = __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipERNS_6memory9AllocatorE((i23 | 0) == 0 ? 0 : i23 + i6 | 0, i26) | 0;
 HEAPF32[i3 >> 2] = f2;
 i20 = HEAP32[i20 >> 2] | 0;
 __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE((i20 | 0) == 0 ? 0 : i20 + i6 | 0, i3, i23, i22);
 i21 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[(HEAP32[i21 >> 2] | 0) + 20 >> 2] | 0, i26) | 0;
 i3 = HEAP32[i24 + 1708 >> 2] | 0;
 HEAP32[i24 + 1716 >> 2] = i3;
 i6 = i24 + 1720 | 0;
 if (!i3) i1 = 0; else {
  i4 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i4 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i4 | 0) | 0;
 }
 i20 = i6;
 i19 = i1 | 0 ? i1 - i20 | 0 : 0;
 HEAP32[i6 >> 2] = i19;
 i3 = HEAP32[i18 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i18 + 48 >> 2] | 0;
  if (i4 | 0) {
   i5 = HEAP32[i21 >> 2] | 0;
   if (i5 | 0) {
    i6 = i19 + i20 | 0;
    i1 = 0;
    do {
     i16 = HEAP16[i3 + (i1 << 1) >> 1] | 0;
     i7 = i16 << 16 >> 16;
     i17 = HEAP16[i4 + (i1 << 1) >> 1] | 0;
     i8 = i17 << 16 >> 16;
     if (i16 << 16 >> 16 != -1 & i17 << 16 >> 16 != -1) {
      i17 = HEAP32[i22 >> 2] | 0;
      HEAP32[i6 + (i7 << 2) >> 2] = HEAP32[i17 + (i8 << 2) >> 2];
      HEAP32[i6 + (i7 + 1 << 2) >> 2] = HEAP32[i17 + (i8 + 1 << 2) >> 2];
      HEAP32[i6 + (i7 + 2 << 2) >> 2] = HEAP32[i17 + (i8 + 2 << 2) >> 2];
     }
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i5 >>> 0);
   }
  }
 }
 i12 = HEAP32[i18 + 12 >> 2] | 0;
 if (i12 | 0) {
  i13 = HEAP32[i18 + 52 >> 2] | 0;
  if (i13 | 0) {
   i14 = HEAP32[i21 + 8 >> 2] | 0;
   if (i14 | 0) {
    i15 = HEAP32[i18 + 16 >> 2] | 0;
    i16 = HEAP32[i18 + 56 >> 2] | 0;
    i17 = i19 + i20 | 0;
    i11 = 0;
    do {
     i7 = HEAP16[i12 + (i11 << 1) >> 1] | 0;
     i9 = i7 << 16 >> 16;
     i8 = HEAP16[i15 + (i11 << 1) >> 1] | 0;
     i10 = i8 << 16 >> 16;
     i1 = HEAP16[i13 + (i11 << 1) >> 1] | 0;
     i5 = i1 << 16 >> 16;
     i3 = HEAP16[i16 + (i11 << 1) >> 1] | 0;
     i6 = i3 << 16 >> 16;
     i7 = i7 << 16 >> 16 != -1;
     i8 = i8 << 16 >> 16 != -1;
     if (!(i7 & i8)) {
      i4 = i1 << 16 >> 16 != -1;
      i1 = i3 << 16 >> 16 != -1;
      if (!(i4 & i1)) {
       i7 = i7 & i4;
       i1 = i8 & i1;
       i3 = i7 ? i5 : i1 ? i6 : -1;
       i1 = i7 ? i9 : i1 ? i10 : -1;
       if ((i1 | 0) != -1 & (i3 | 0) != -1) {
        i10 = HEAP32[i22 >> 2] | 0;
        HEAP32[i17 + (i1 << 2) >> 2] = HEAP32[i10 + (i3 << 2) >> 2];
        HEAP32[i17 + (i1 + 1 << 2) >> 2] = HEAP32[i10 + (i3 + 1 << 2) >> 2];
        HEAP32[i17 + (i1 + 2 << 2) >> 2] = HEAP32[i10 + (i3 + 2 << 2) >> 2];
        HEAP32[i17 + (i1 + 3 << 2) >> 2] = HEAP32[i10 + (i3 + 3 << 2) >> 2];
       }
      }
     }
     i11 = i11 + 1 | 0;
    } while (i11 >>> 0 < i14 >>> 0);
   }
  }
 }
 i3 = HEAP32[i18 + 24 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i18 + 64 >> 2] | 0;
  if (i4 | 0) {
   i5 = HEAP32[i21 + 16 >> 2] | 0;
   if (i5 | 0) {
    i6 = i19 + i20 | 0;
    i1 = 0;
    do {
     i16 = HEAP16[i3 + (i1 << 1) >> 1] | 0;
     i7 = i16 << 16 >> 16;
     i17 = HEAP16[i4 + (i1 << 1) >> 1] | 0;
     i8 = i17 << 16 >> 16;
     if (i16 << 16 >> 16 != -1 & i17 << 16 >> 16 != -1) {
      i17 = HEAP32[i22 >> 2] | 0;
      HEAP32[i6 + (i7 << 2) >> 2] = HEAP32[i17 + (i8 << 2) >> 2];
      HEAP32[i6 + (i7 + 1 << 2) >> 2] = HEAP32[i17 + (i8 + 1 << 2) >> 2];
      HEAP32[i6 + (i7 + 2 << 2) >> 2] = HEAP32[i17 + (i8 + 2 << 2) >> 2];
     }
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i5 >>> 0);
   }
  }
 }
 i8 = HEAP32[i18 + 28 >> 2] | 0;
 if (i8 | 0) {
  i3 = HEAP32[i18 + 68 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i21 + 24 >> 2] | 0;
   if (i4 | 0) {
    i5 = i19 + i20 | 0;
    i1 = 0;
    do {
     i6 = HEAP16[i8 + (i1 << 1) >> 1] | 0;
     i7 = HEAP16[i3 + (i1 << 1) >> 1] | 0;
     if (i6 << 16 >> 16 != -1 & i7 << 16 >> 16 != -1) HEAP32[i5 + (i6 << 16 >> 16 << 2) >> 2] = HEAP32[(HEAP32[i22 >> 2] | 0) + (i7 << 16 >> 16 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   }
  }
 }
 i3 = i19 + i20 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i24 + 1088 + (i1 << 2) >> 2] | 0;
  i5 = HEAP32[i25 + 1088 + (i1 << 2) >> 2] | 0;
  if ((i4 | 0) != -1 & (i5 | 0) != -1) HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[(HEAP32[i22 >> 2] | 0) + (i5 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 155);
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i21, i26);
 __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE(i22, i26);
 __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE(i23, i26);
 STACKTOP = i27;
 return;
}

function __ZN5physx2Sc5Scene11postCCDPassEPNS_10PxBaseTaskE(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i22 + 40 | 0;
 i6 = i22 + 32 | 0;
 i10 = i22 + 28 | 0;
 i14 = i22 + 24 | 0;
 i21 = i22 + 16 | 0;
 i20 = i22 + 8 | 0;
 i3 = i22 + 57 | 0;
 i19 = i22;
 i4 = i22 + 56 | 0;
 i12 = i17 + 1204 | 0;
 i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 1e3 >> 2] | 0;
 i13 = __ZNK5physx10PxsContext17getCurrentCCDPassEv(i5) | 0;
 __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_(i5, i6, i10, i14) | 0;
 i1 = HEAP32[i6 >> 2] << 3;
 i16 = i1 >>> 0 > 1024;
 i18 = i21 + 4 | 0;
 HEAP8[i18 >> 0] = i16 & 1;
 if (i16) HEAP32[i21 >> 2] = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i22 + 58 | 0, i1, gb + 680241 | 0, 1638) | 0; else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i21 >> 2] = i2;
 }
 i2 = HEAP32[i10 >> 2] << 3;
 i15 = i2 >>> 0 > 1024;
 i16 = i20 + 4 | 0;
 HEAP8[i16 >> 0] = i15 & 1;
 if (i15) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i3, i2, gb + 680241 | 0, 1639) | 0;
  HEAP32[i20 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i20 >> 2] = i1;
 }
 i3 = HEAP32[i14 >> 2] << 3;
 i9 = i3 >>> 0 > 1024;
 i15 = i19 + 4 | 0;
 HEAP8[i15 >> 0] = i9 & 1;
 if (i9) {
  i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i4, i3, gb + 680241 | 0, 1640) | 0;
  HEAP32[i19 >> 2] = i2;
  i9 = i20;
  i1 = HEAP32[i20 >> 2] | 0;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i2;
  i9 = i20;
 }
 i3 = HEAP32[i21 >> 2] | 0;
 __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_(i5, i3, i6, i1, i10, i2, i14) | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb(HEAP32[i3 + 4 >> 2] | 0, i13, 1);
  if ((HEAP32[i6 >> 2] | 0) > 1) {
   i1 = 1;
   do {
    __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb(HEAP32[(HEAP32[i21 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, i13, 1);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
  }
 }
 if ((HEAP32[i10 >> 2] | 0) > 0) {
  i2 = i11 + 4 | 0;
  i3 = i11 + 8 | 0;
  i4 = i11 + 12 | 0;
  i5 = i17 + 1240 | 0;
  i6 = i17 + 1248 | 0;
  i7 = i17 + 1244 | 0;
  i8 = 0;
  do {
   i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 3) + 4 >> 2] | 0;
   if (__ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb(i1, i13, 1) | 0) if (!(HEAP32[i1 + 44 >> 2] & 262144)) {
    i23 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 + 32 >> 2] | 0) | 0;
    i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i23;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i3 >> 2] = HEAP32[i23 + 56 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i1 + 56 >> 2];
    i1 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i23 = (HEAP32[i5 >> 2] | 0) + (i1 << 4) | 0;
     HEAP32[i23 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i23 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i11) | 0;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) < (HEAP32[i10 >> 2] | 0));
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (HEAP32[i2 + 44 >> 2] & 32) {
    __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i2, 32, 0, 0, i13);
    i1 = HEAP32[i14 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 __ZN5physx2Sc5Scene11afterSolverEj(i17, i13);
 i1 = HEAP32[i12 >> 2] | 0;
 i9 = (HEAP32[i1 + 1e3 >> 2] | 0) + 7612 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i6 = i2 + (i1 + -1 << 2) | 0;
  i7 = i2;
  i1 = i2 + 32 | 0;
  do {
   i5 = HEAP32[i7 >> 2] | 0;
   if (i1 >>> 0 <= i6 >>> 0) {
    i4 = HEAP32[i1 >> 2] | 0;
    i3 = i4;
    i14 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
    i23 = getTempRet0() | 0;
    i3 = _i64Add(i3 | 0, 0, 511, 0) | 0;
    i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
    i2 = getTempRet0() | 0;
    i23 = _i64Subtract(1, 0, i14 | 0, i23 | 0) | 0;
    i2 = _i64Add(i23 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
    i3 = getTempRet0() | 0;
    while (1) {
     i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
     i3 = getTempRet0() | 0;
     if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
    }
    i1 = i1 + 4 | 0;
   }
   __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(i5, i9);
   i7 = i7 + 4 | 0;
  } while (i7 >>> 0 < i8 >>> 0);
 }
 i3 = i17 + 124 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = i17 + 120 | 0;
  i2 = 0;
  do {
   __ZN5physx2Sc15ArticulationSim22updateCachedTransformsERNS_17PxsTransformCacheEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] >> 2] | 0, i9, 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (HEAP8[i15 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 if (HEAP8[i16 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i20, HEAP32[i20 >> 2] | 0);
 if (!(HEAP8[i18 >> 0] | 0)) {
  STACKTOP = i22;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i21, HEAP32[i21 >> 2] | 0);
 STACKTOP = i22;
 return;
}

function __ZN4crnd12crn_unpacker11unpack_dxt5EPPhjjjjjj(i4, i46, i1, i47, i2, i3, i48, i49) {
 i4 = i4 | 0;
 i46 = i46 | 0;
 i1 = i1 | 0;
 i47 = i47 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i48 = i48 | 0;
 i49 = i49 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i50 = 0, i51 = 0;
 i45 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i43 = i45 + 16 | 0;
 i44 = i45;
 i25 = HEAP32[i4 + 240 >> 2] | 0;
 i26 = HEAP32[i4 + 256 >> 2] | 0;
 i27 = HEAP32[i4 + 272 >> 2] | 0;
 i42 = HEAP32[i4 + 88 >> 2] | 0;
 i28 = (HEAPU8[i42 + 63 >> 0] | 0) << 8 | (HEAPU8[i42 + 64 >> 0] | 0);
 i42 = HEAP8[i42 + 17 >> 0] | 0;
 i29 = i42 & 255;
 if (!(i42 << 24 >> 24)) {
  STACKTOP = i45;
  return 1;
 }
 i30 = (i49 | 0) == 0;
 i31 = i48 + -1 | 0;
 i32 = i31 << 5;
 i33 = i49 + -1 | 0;
 i34 = i47 << 1;
 i35 = i4 + 92 | 0;
 i36 = i4 + 116 | 0;
 i37 = i4 + 164 | 0;
 i38 = i4 + 268 | 0;
 i39 = i4 + 140 | 0;
 i40 = i4 + 236 | 0;
 i41 = i4 + 212 | 0;
 i42 = i4 + 188 | 0;
 i24 = (i2 & 1 | 0) == 0;
 i23 = (i3 & 1 | 0) == 0;
 i22 = i4 + 284 | 0;
 i21 = i4 + 252 | 0;
 i20 = 0;
 i4 = 0;
 i3 = 0;
 i2 = 0;
 i1 = 0;
 i5 = 1;
 do {
  if (!i30) {
   i18 = HEAP32[i46 + (i20 << 2) >> 2] | 0;
   i19 = 0;
   while (1) {
    i17 = i19 & 1;
    i7 = (i17 | 0) == 0;
    i16 = (i17 << 6 ^ 64) + -32 | 0;
    i17 = (i17 << 1 ^ 2) + -1 | 0;
    i14 = i7 ? i48 : -1;
    i6 = i7 ? 0 : i31;
    if ((i6 | 0) != (i14 | 0)) {
     i15 = i23 | (i19 | 0) != (i33 | 0);
     i13 = i7 ? i18 : i18 + i32 | 0;
     while (1) {
      if ((i5 | 0) == 1) i5 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i36) | 0 | 512;
      i12 = i5 & 7;
      i5 = i5 >>> 3;
      i8 = HEAPU8[gb + 401462 + i12 >> 0] | 0;
      i7 = 0;
      do {
       i9 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i37) | 0) + i3 | 0;
       i10 = i9 - i27 | 0;
       i11 = i10 >> 31;
       i3 = i11 & i9 | i10 & ~i11;
       HEAP32[i44 + (i7 << 2) >> 2] = HEAPU16[(HEAP32[i38 >> 2] | 0) + (i3 << 1) >> 1];
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i8 >>> 0);
      i7 = 0;
      do {
       i9 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i39) | 0) + i1 | 0;
       i10 = i9 - i25 | 0;
       i11 = i10 >> 31;
       i1 = i11 & i9 | i10 & ~i11;
       HEAP32[i43 + (i7 << 2) >> 2] = HEAP32[(HEAP32[i40 >> 2] | 0) + (i1 << 2) >> 2];
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i8 >>> 0);
      i11 = i24 | (i6 | 0) != (i31 | 0);
      i9 = 0;
      i10 = i13;
      while (1) {
       i8 = i15 | (i9 | 0) == 0;
       i7 = i9 << 1;
       i50 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i41) | 0) + i4 | 0;
       i51 = i50 - i28 | 0;
       i4 = i51 >> 31;
       i4 = i4 & i50 | i51 & ~i4;
       i51 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i42) | 0) + i2 | 0;
       i50 = i51 - i26 | 0;
       i2 = i50 >> 31;
       i2 = i2 & i51 | i50 & ~i2;
       if (i11) {
        if (i8) {
         i51 = HEAPU8[gb + 401470 + (i12 << 2) + i7 >> 0] | 0;
         i50 = (HEAP32[i22 >> 2] | 0) + (i4 * 3 << 1) | 0;
         HEAP32[i10 >> 2] = (HEAPU16[i50 >> 1] | 0) << 16 | HEAP32[i44 + (i51 << 2) >> 2];
         HEAP32[i10 + 4 >> 2] = (HEAPU16[i50 + 4 >> 1] | 0) << 16 | (HEAPU16[i50 + 2 >> 1] | 0);
         HEAP32[i10 + 8 >> 2] = HEAP32[i43 + (i51 << 2) >> 2];
         HEAP32[i10 + 12 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2];
        }
        i51 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i41) | 0) + i4 | 0;
        i50 = i51 - i28 | 0;
        i4 = i50 >> 31;
        i4 = i4 & i51 | i50 & ~i4;
        i50 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i42) | 0) + i2 | 0;
        i51 = i50 - i26 | 0;
        i2 = i51 >> 31;
        i2 = i2 & i50 | i51 & ~i2;
        if (i8) {
         i51 = HEAPU8[(i7 | 1) + (gb + 401470 + (i12 << 2)) >> 0] | 0;
         i50 = (HEAP32[i22 >> 2] | 0) + (i4 * 3 << 1) | 0;
         HEAP32[i10 + 16 >> 2] = (HEAPU16[i50 >> 1] | 0) << 16 | HEAP32[i44 + (i51 << 2) >> 2];
         HEAP32[i10 + 20 >> 2] = (HEAPU16[i50 + 4 >> 1] | 0) << 16 | (HEAPU16[i50 + 2 >> 1] | 0);
         HEAP32[i10 + 24 >> 2] = HEAP32[i43 + (i51 << 2) >> 2];
         HEAP32[i10 + 28 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2];
        }
       } else {
        if (i8) {
         i51 = HEAPU8[gb + 401470 + (i12 << 2) + i7 >> 0] | 0;
         i50 = (HEAP32[i22 >> 2] | 0) + (i4 * 3 << 1) | 0;
         HEAP32[i10 >> 2] = (HEAPU16[i50 >> 1] | 0) << 16 | HEAP32[i44 + (i51 << 2) >> 2];
         HEAP32[i10 + 4 >> 2] = (HEAPU16[i50 + 4 >> 1] | 0) << 16 | (HEAPU16[i50 + 2 >> 1] | 0);
         HEAP32[i10 + 8 >> 2] = HEAP32[i43 + (i51 << 2) >> 2];
         HEAP32[i10 + 12 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2];
        }
        i7 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i41) | 0) + i4 | 0;
        i8 = i7 - i28 | 0;
        i4 = i8 >> 31;
        i50 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i35, i42) | 0) + i2 | 0;
        i51 = i50 - i26 | 0;
        i2 = i51 >> 31;
        i4 = i4 & i7 | i8 & ~i4;
        i2 = i2 & i50 | i51 & ~i2;
       }
       i9 = i9 + 1 | 0;
       if ((i9 | 0) == 2) break; else i10 = i10 + i47 | 0;
      }
      i6 = i17 + i6 | 0;
      if ((i6 | 0) == (i14 | 0)) break; else i13 = i13 + i16 | 0;
     }
    }
    i19 = i19 + 1 | 0;
    if ((i19 | 0) == (i49 | 0)) break; else i18 = i18 + i34 | 0;
   }
  }
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) != (i29 | 0));
 STACKTOP = i45;
 return 1;
}

function runPostSets189() {
 HEAP32[gb + 159080 >> 2] = fb + 1785;
 HEAP32[gb + 159084 >> 2] = fb + 2490;
 HEAP32[gb + 159088 >> 2] = fb + 2491;
 HEAP32[gb + 159092 >> 2] = fb + 1730;
 HEAP32[gb + 159096 >> 2] = fb + 2492;
 HEAP32[gb + 159100 >> 2] = fb + 265;
 HEAP32[gb + 159104 >> 2] = fb + 1786;
 HEAP32[gb + 159108 >> 2] = fb + 1737;
 HEAP32[gb + 159112 >> 2] = fb + 75;
 HEAP32[gb + 159128 >> 2] = fb + 77;
 HEAP32[gb + 159140 >> 2] = fb + 1117;
 HEAP32[gb + 159144 >> 2] = fb + 121;
 HEAP32[gb + 159148 >> 2] = fb + 2493;
 HEAP32[gb + 159152 >> 2] = fb + 1787;
 HEAP32[gb + 159156 >> 2] = fb + 1788;
 HEAP32[gb + 159160 >> 2] = fb + 420;
 HEAP32[gb + 159164 >> 2] = fb + 1118;
 HEAP32[gb + 159168 >> 2] = fb + 2494;
 HEAP32[gb + 159172 >> 2] = fb + 2495;
 HEAP32[gb + 159184 >> 2] = (HEAP32[gb + 159184 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 159188 >> 2] = (HEAP32[gb + 159188 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 159224 >> 2] = fb + 2480;
 HEAP32[gb + 159228 >> 2] = fb + 1119;
 HEAP32[gb + 159232 >> 2] = fb + 456;
 HEAP32[gb + 159236 >> 2] = fb + 2481;
 HEAP32[gb + 159240 >> 2] = fb + 2496;
 HEAP32[gb + 159244 >> 2] = fb + 421;
 HEAP32[gb + 159248 >> 2] = fb + 1774;
 HEAP32[gb + 159252 >> 2] = fb + 1776;
 HEAP32[gb + 159264 >> 2] = fb + 2480;
 HEAP32[gb + 159268 >> 2] = fb + 1120;
 HEAP32[gb + 159272 >> 2] = fb + 456;
 HEAP32[gb + 159276 >> 2] = fb + 2497;
 HEAP32[gb + 159280 >> 2] = fb + 2498;
 HEAP32[gb + 159284 >> 2] = fb + 422;
 HEAP32[gb + 159288 >> 2] = fb + 1774;
 HEAP32[gb + 159292 >> 2] = fb + 1776;
 HEAP32[gb + 159304 >> 2] = fb + 2480;
 HEAP32[gb + 159308 >> 2] = fb + 1121;
 HEAP32[gb + 159312 >> 2] = fb + 456;
 HEAP32[gb + 159316 >> 2] = fb + 2499;
 HEAP32[gb + 159320 >> 2] = fb + 2500;
 HEAP32[gb + 159324 >> 2] = fb + 423;
 HEAP32[gb + 159328 >> 2] = fb + 1774;
 HEAP32[gb + 159332 >> 2] = fb + 1776;
 HEAP32[gb + 159344 >> 2] = fb + 2480;
 HEAP32[gb + 159348 >> 2] = fb + 1122;
 HEAP32[gb + 159352 >> 2] = fb + 456;
 HEAP32[gb + 159356 >> 2] = fb + 2501;
 HEAP32[gb + 159360 >> 2] = fb + 2502;
 HEAP32[gb + 159364 >> 2] = fb + 424;
 HEAP32[gb + 159368 >> 2] = fb + 1774;
 HEAP32[gb + 159372 >> 2] = fb + 1776;
 HEAP32[gb + 159376 >> 2] = (HEAP32[gb + 159376 >> 2] | 0) + (gb + 828164 | 0);
 HEAP32[gb + 159408 >> 2] = (HEAP32[gb + 159408 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159412 >> 2] = (HEAP32[gb + 159412 >> 2] | 0) + (gb + 828289 | 0);
 HEAP32[gb + 159440 >> 2] = (HEAP32[gb + 159440 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 159444 >> 2] = (HEAP32[gb + 159444 >> 2] | 0) + (gb + 828276 | 0);
 HEAP32[gb + 159472 >> 2] = (HEAP32[gb + 159472 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 159476 >> 2] = (HEAP32[gb + 159476 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 159504 >> 2] = (HEAP32[gb + 159504 >> 2] | 0) + (gb + 828195 | 0);
 HEAP32[gb + 159508 >> 2] = (HEAP32[gb + 159508 >> 2] | 0) + (gb + 828164 | 0);
 HEAP32[gb + 159536 >> 2] = (HEAP32[gb + 159536 >> 2] | 0) + (gb + 827908 | 0);
 HEAP32[gb + 159540 >> 2] = (HEAP32[gb + 159540 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 159568 >> 2] = (HEAP32[gb + 159568 >> 2] | 0) + (gb + 827793 | 0);
 HEAP32[gb + 159600 >> 2] = (HEAP32[gb + 159600 >> 2] | 0) + (gb + 828164 | 0);
 HEAP32[gb + 159604 >> 2] = (HEAP32[gb + 159604 >> 2] | 0) + (gb + 828182 | 0);
 HEAP32[gb + 159632 >> 2] = (HEAP32[gb + 159632 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159636 >> 2] = (HEAP32[gb + 159636 >> 2] | 0) + (gb + 828159 | 0);
 HEAP32[gb + 159664 >> 2] = (HEAP32[gb + 159664 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159668 >> 2] = (HEAP32[gb + 159668 >> 2] | 0) + (gb + 828147 | 0);
 HEAP32[gb + 159696 >> 2] = (HEAP32[gb + 159696 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159700 >> 2] = (HEAP32[gb + 159700 >> 2] | 0) + (gb + 828137 | 0);
 HEAP32[gb + 159728 >> 2] = (HEAP32[gb + 159728 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159732 >> 2] = (HEAP32[gb + 159732 >> 2] | 0) + (gb + 828112 | 0);
 HEAP32[gb + 159760 >> 2] = (HEAP32[gb + 159760 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159764 >> 2] = (HEAP32[gb + 159764 >> 2] | 0) + (gb + 828074 | 0);
 HEAP32[gb + 159792 >> 2] = (HEAP32[gb + 159792 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159796 >> 2] = (HEAP32[gb + 159796 >> 2] | 0) + (gb + 828033 | 0);
 HEAP32[gb + 159824 >> 2] = (HEAP32[gb + 159824 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159828 >> 2] = (HEAP32[gb + 159828 >> 2] | 0) + (gb + 828023 | 0);
 HEAP32[gb + 159856 >> 2] = (HEAP32[gb + 159856 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159860 >> 2] = (HEAP32[gb + 159860 >> 2] | 0) + (gb + 828008 | 0);
 HEAP32[gb + 159888 >> 2] = (HEAP32[gb + 159888 >> 2] | 0) + (gb + 827767 | 0);
 HEAP32[gb + 159920 >> 2] = (HEAP32[gb + 159920 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159924 >> 2] = (HEAP32[gb + 159924 >> 2] | 0) + (gb + 828e3 | 0);
 HEAP32[gb + 159952 >> 2] = (HEAP32[gb + 159952 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 159956 >> 2] = (HEAP32[gb + 159956 >> 2] | 0) + (gb + 827988 | 0);
 HEAP32[gb + 159984 >> 2] = (HEAP32[gb + 159984 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 159988 >> 2] = (HEAP32[gb + 159988 >> 2] | 0) + (gb + 827978 | 0);
 HEAP32[gb + 160016 >> 2] = (HEAP32[gb + 160016 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160020 >> 2] = (HEAP32[gb + 160020 >> 2] | 0) + (gb + 827966 | 0);
 HEAP32[gb + 160048 >> 2] = (HEAP32[gb + 160048 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160052 >> 2] = (HEAP32[gb + 160052 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 160080 >> 2] = (HEAP32[gb + 160080 >> 2] | 0) + (gb + 827739 | 0);
 HEAP32[gb + 160112 >> 2] = (HEAP32[gb + 160112 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 160116 >> 2] = (HEAP32[gb + 160116 >> 2] | 0) + (gb + 827956 | 0);
 HEAP32[gb + 160144 >> 2] = (HEAP32[gb + 160144 >> 2] | 0) + (gb + 827908 | 0);
 HEAP32[gb + 160148 >> 2] = (HEAP32[gb + 160148 >> 2] | 0) + (gb + 827942 | 0);
 HEAP32[gb + 160176 >> 2] = (HEAP32[gb + 160176 >> 2] | 0) + (gb + 827882 | 0);
 runPostSets190();
}

function _jpeg_default_colorspace(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 switch (HEAP32[i4 + 40 >> 2] | 0) {
 case 1:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 1;
   HEAP8[i4 + 204 >> 0] = 0;
   HEAP8[i4 + 196 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 1;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 1;
   HEAP32[i4 + 12 >> 2] = 1;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   return;
  }
 case 15:
 case 14:
 case 13:
 case 12:
 case 11:
 case 10:
 case 9:
 case 8:
 case 7:
 case 6:
 case 2:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 3;
   HEAP8[i4 + 204 >> 0] = 0;
   HEAP8[i4 + 196 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 3;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 2;
   HEAP32[i4 + 12 >> 2] = 2;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 2;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 1;
   HEAP32[i4 + 104 >> 2] = 1;
   HEAP32[i4 + 108 >> 2] = 1;
   HEAP32[i4 + 168 >> 2] = 3;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 1;
   HEAP32[i4 + 188 >> 2] = 1;
   HEAP32[i4 + 192 >> 2] = 1;
   return;
  }
 case 3:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 3;
   HEAP8[i4 + 204 >> 0] = 0;
   HEAP8[i4 + 196 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 3;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 2;
   HEAP32[i4 + 12 >> 2] = 2;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 2;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 1;
   HEAP32[i4 + 104 >> 2] = 1;
   HEAP32[i4 + 108 >> 2] = 1;
   HEAP32[i4 + 168 >> 2] = 3;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 1;
   HEAP32[i4 + 188 >> 2] = 1;
   HEAP32[i4 + 192 >> 2] = 1;
   return;
  }
 case 4:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 4;
   HEAP8[i4 + 196 >> 0] = 0;
   HEAP8[i4 + 204 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 4;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 67;
   HEAP32[i4 + 8 >> 2] = 1;
   HEAP32[i4 + 12 >> 2] = 1;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 77;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 0;
   HEAP32[i4 + 104 >> 2] = 0;
   HEAP32[i4 + 108 >> 2] = 0;
   HEAP32[i4 + 168 >> 2] = 89;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 0;
   HEAP32[i4 + 188 >> 2] = 0;
   HEAP32[i4 + 192 >> 2] = 0;
   HEAP32[i4 + 252 >> 2] = 75;
   HEAP32[i4 + 260 >> 2] = 1;
   HEAP32[i4 + 264 >> 2] = 1;
   HEAP32[i4 + 268 >> 2] = 0;
   HEAP32[i4 + 272 >> 2] = 0;
   HEAP32[i4 + 276 >> 2] = 0;
   return;
  }
 case 5:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 5;
   HEAP8[i4 + 196 >> 0] = 0;
   HEAP8[i4 + 204 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 4;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 2;
   HEAP32[i4 + 12 >> 2] = 2;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 2;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 1;
   HEAP32[i4 + 104 >> 2] = 1;
   HEAP32[i4 + 108 >> 2] = 1;
   HEAP32[i4 + 168 >> 2] = 3;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 1;
   HEAP32[i4 + 188 >> 2] = 1;
   HEAP32[i4 + 192 >> 2] = 1;
   HEAP32[i4 + 252 >> 2] = 4;
   HEAP32[i4 + 260 >> 2] = 2;
   HEAP32[i4 + 264 >> 2] = 2;
   HEAP32[i4 + 268 >> 2] = 0;
   HEAP32[i4 + 272 >> 2] = 0;
   HEAP32[i4 + 276 >> 2] = 0;
   return;
  }
 case 0:
  {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if ((i1 | 0) != 100) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 20;
    HEAP32[i3 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i4 + 64 >> 2] = 0;
   HEAP8[i4 + 196 >> 0] = 0;
   HEAP8[i4 + 204 >> 0] = 0;
   i1 = HEAP32[i4 + 36 >> 2] | 0;
   i2 = i4 + 60 | 0;
   HEAP32[i2 >> 2] = i1;
   if ((i1 + -1 | 0) >>> 0 > 9) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 26;
    HEAP32[i3 + 24 >> 2] = i1;
    HEAP32[i3 + 28 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
    i3 = HEAP32[i2 >> 2] | 0;
   } else i3 = i1;
   if ((i3 | 0) <= 0) return;
   i2 = HEAP32[i4 + 68 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 * 84 | 0) >> 2] = i1;
    HEAP32[i2 + (i1 * 84 | 0) + 8 >> 2] = 1;
    HEAP32[i2 + (i1 * 84 | 0) + 12 >> 2] = 1;
    HEAP32[i2 + (i1 * 84 | 0) + 16 >> 2] = 0;
    HEAP32[i2 + (i1 * 84 | 0) + 20 >> 2] = 0;
    HEAP32[i2 + (i1 * 84 | 0) + 24 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
 default:
  {
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 9;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   return;
  }
 }
}

function __ZN14SplatMaterials15UpdateMaterialsEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 8 | 0;
 i6 = i14;
 if ((HEAP16[gb + 1467260 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467260 | 0, i5);
  i13 = gb + 1467260 | 0;
 } else i13 = 0;
 i4 = i12 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  i2 = 0;
  i9 = 0;
  i10 = 0;
 } else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 11;
   }
  }
  if ((i11 | 0) == 9) i11 = 11;
  if ((i11 | 0) == 11) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i2 = 0;
    i9 = 0;
    i10 = 0;
    break;
   }
  }
  i10 = __ZN8Material10ComputeCRCEv(i1) | 0;
  i2 = i1;
  i9 = __ZNK8Material13GetShaderPPtrEv(i1) | 0;
 } while (0);
 i7 = i12 + 8 | 0;
 i8 = i12 + 12 | 0;
 if ((i9 | 0) == (HEAP32[i8 >> 2] | 0)) {
  i1 = (i2 | 0) == 0;
  if ((i10 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = 0; else i11 = 16;
 } else {
  i1 = i12 + 40 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 44 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 48 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 52 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 56 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 60 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 64 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 68 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + 72 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = -1;
  HEAP32[i8 >> 2] = 0;
  __ZN14SplatMaterials16LoadSplatShadersEv(i12);
  i1 = (i2 | 0) == 0;
  i11 = 16;
 }
 __ZN14SplatMaterials20UpdateSplatMaterialsEP8Materialb(i12, i2, i1);
 __ZN14SplatMaterials22UpdateBaseMapMaterialsEP8Materialb(i12, i2, i1);
 i1 = HEAP32[i12 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 23; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i4 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i11 = 23; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i11 = 25;
  }
  if ((i11 | 0) == 23) i11 = 25;
  if ((i11 | 0) == 25) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  if (!i1) i11 = 32; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 32; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 34;
   }
  }
  if ((i11 | 0) == 32) i11 = 34;
  if ((i11 | 0) == 34) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0;
  i4 = i1 + 32 | 0;
  i1 = i12 + 40 | 0;
  i2 = __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i1, gb + 1467272 | 0) | 0;
  i3 = i4 + 49 | 0;
  if ((i2 & 1 | 0) != (HEAPU8[i3 >> 0] | 0)) HEAP8[i4 + 50 >> 0] = 1;
  HEAP8[i3 >> 0] = i2 & 1;
  i1 = __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i1, gb + 1467288 | 0) | 0;
  i2 = i4 + 48 | 0;
  if ((i1 & 1 | 0) != (HEAPU8[i2 >> 0] | 0)) HEAP8[i4 + 50 >> 0] = 1;
  HEAP8[i2 >> 0] = i1 & 1;
 } while (0);
 HEAP32[i7 >> 2] = i10;
 HEAP32[i8 >> 2] = i9;
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_(i12, i13, i10, i9, i8, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_(i12, i13, i10, i9, i1) | 0;
 i6 = HEAP32[i8 + 16 >> 2] | 0;
 i1 = i6 & 255;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 & 255;
 i4 = (i6 & 65535) >>> 8 & 255;
 i5 = (i2 & 65535) >>> 8 & 255;
 do if (i1 << 24 >> 24 == i3 << 24 >> 24) if (i4 << 24 >> 24 == i5 << 24 >> 24) {
  if ((i6 & 65536 | 0) == 0 & (i2 & 65536 | 0) != 0) break; else i1 = i11;
  STACKTOP = i15;
  return i1 | 0;
 } else {
  if ((i4 & 255) < (i5 & 255)) break; else i1 = i11;
  STACKTOP = i15;
  return i1 | 0;
 } else if ((i1 & 255) >= (i3 & 255)) {
  i14 = i11;
  STACKTOP = i15;
  return i14 | 0;
 } while (0);
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP16[i9 + 16 >> 1] = HEAP16[i8 + 16 >> 1] | 0;
 HEAP8[i9 + 18 >> 0] = HEAP8[i8 + 18 >> 0] | 0;
 HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP16[i8 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
 HEAP8[i8 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
 i1 = i11 + 1 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 & 255;
 i8 = i10 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 & 255;
 i6 = (i2 & 65535) >>> 8 & 255;
 i7 = (i4 & 65535) >>> 8 & 255;
 do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
  if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
  STACKTOP = i15;
  return i1 | 0;
 } else {
  if ((i6 & 255) < (i7 & 255)) break;
  STACKTOP = i15;
  return i1 | 0;
 } else if ((i3 & 255) >= (i5 & 255)) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 } while (0);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP16[i10 + 16 >> 1] = HEAP16[i9 + 16 >> 1] | 0;
 HEAP8[i10 + 18 >> 0] = HEAP8[i9 + 18 >> 0] | 0;
 HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP16[i9 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
 HEAP8[i9 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
 i1 = i11 + 2 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 & 255;
 i8 = i13 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 & 255;
 i6 = (i2 & 65535) >>> 8 & 255;
 i7 = (i4 & 65535) >>> 8 & 255;
 do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
  if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
  STACKTOP = i15;
  return i1 | 0;
 } else {
  if ((i6 & 255) < (i7 & 255)) break;
  STACKTOP = i15;
  return i1 | 0;
 } else if ((i3 & 255) >= (i5 & 255)) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 } while (0);
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP16[i13 + 16 >> 1] = HEAP16[i10 + 16 >> 1] | 0;
 HEAP8[i13 + 18 >> 0] = HEAP8[i10 + 18 >> 0] | 0;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP16[i10 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
 HEAP8[i10 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
 i1 = i11 + 3 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 & 255;
 i4 = HEAP32[i12 + 16 >> 2] | 0;
 i5 = i4 & 255;
 i6 = (i2 & 65535) >>> 8 & 255;
 i7 = (i4 & 65535) >>> 8 & 255;
 do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
  if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
  STACKTOP = i15;
  return i1 | 0;
 } else {
  if ((i6 & 255) < (i7 & 255)) break;
  STACKTOP = i15;
  return i1 | 0;
 } else if ((i3 & 255) >= (i5 & 255)) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 } while (0);
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i12 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i12 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP16[i13 + 16 >> 1] = HEAP16[i14 + 16 >> 1] | 0;
 HEAP8[i13 + 18 >> 0] = HEAP8[i14 + 18 >> 0] | 0;
 i14 = i11 + 4 | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __Z19dtOverlapPolyPoly2DPKfiS0_i(i17, i18, i19, i20) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i21 = 0;
 i3 = i18 + -1 | 0;
 L1 : do if ((i18 | 0) > 0) {
  f10 = Math_fround(HEAPF32[i17 >> 2]);
  f11 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i19 >> 2]);
  f13 = Math_fround(HEAPF32[i19 + 8 >> 2]);
  i14 = (i20 | 0) > 1;
  if ((i18 | 0) == 1) {
   i4 = i17 + (i3 * 3 << 2) | 0;
   f6 = Math_fround(HEAPF32[i17 + 8 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i4 + 8 >> 2]));
   f7 = Math_fround(HEAPF32[i17 >> 2]);
   f7 = Math_fround(-Math_fround(f7 - Math_fround(HEAPF32[i4 >> 2])));
   f8 = Math_fround(Math_fround(f6 * f10) + Math_fround(f11 * f7));
   f5 = Math_fround(Math_fround(f6 * f12) + Math_fround(f13 * f7));
   if (i14) {
    i3 = 1;
    f1 = f5;
    f2 = f5;
    do {
     i14 = i19 + (i3 * 3 << 2) | 0;
     f13 = Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2]));
     f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i14 + 8 >> 2]) * f7));
     f2 = f2 < f13 ? f2 : f13;
     f1 = f1 > f13 ? f1 : f13;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   } else {
    f2 = f5;
    f1 = f5;
   }
   if (!(Math_fround(f8 + Math_fround(.0000999999974)) > f1) & !(Math_fround(f8 + Math_fround(-.0000999999974)) < f2)) break; else i3 = 0;
   return i3 | 0;
  } else i4 = 0;
  while (1) {
   i3 = i17 + (i3 * 3 << 2) | 0;
   i21 = i17 + (i4 * 3 << 2) | 0;
   f6 = Math_fround(HEAPF32[i21 + 8 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 8 >> 2]));
   f7 = Math_fround(HEAPF32[i21 >> 2]);
   f7 = Math_fround(-Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2])));
   f9 = Math_fround(Math_fround(f6 * f10) + Math_fround(f11 * f7));
   i3 = 1;
   f8 = f9;
   do {
    i21 = i17 + (i3 * 3 << 2) | 0;
    f5 = Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2]));
    f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f7));
    f9 = f9 < f5 ? f9 : f5;
    f8 = f8 > f5 ? f8 : f5;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i18 | 0));
   f5 = Math_fround(Math_fround(f6 * f12) + Math_fround(f13 * f7));
   if (i14) {
    i3 = 1;
    f1 = f5;
    f2 = f5;
    do {
     i21 = i19 + (i3 * 3 << 2) | 0;
     f5 = Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2]));
     f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f7));
     f2 = f2 < f5 ? f2 : f5;
     f1 = f1 > f5 ? f1 : f5;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   } else {
    f2 = f5;
    f1 = f5;
   }
   i3 = i4 + 1 | 0;
   if (!(!(Math_fround(f9 + Math_fround(.0000999999974)) > f1) & !(Math_fround(f8 + Math_fround(-.0000999999974)) < f2))) {
    i3 = 0;
    break;
   }
   if ((i3 | 0) < (i18 | 0)) {
    i21 = i4;
    i4 = i3;
    i3 = i21;
   } else break L1;
  }
  return i3 | 0;
 } while (0);
 i3 = i20 + -1 | 0;
 if ((i20 | 0) <= 0) {
  i21 = 1;
  return i21 | 0;
 }
 f13 = Math_fround(HEAPF32[i17 >> 2]);
 f10 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 i14 = (i20 | 0) != 1;
 if ((i18 | 0) > 1) {
  i15 = i3;
  i16 = 0;
 } else {
  i4 = 0;
  while (1) {
   i21 = i19 + (i3 * 3 << 2) | 0;
   i3 = i19 + (i4 * 3 << 2) | 0;
   f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i21 + 8 >> 2]));
   f7 = Math_fround(HEAPF32[i3 >> 2]);
   f7 = Math_fround(-Math_fround(f7 - Math_fround(HEAPF32[i21 >> 2])));
   f8 = Math_fround(Math_fround(f6 * f13) + Math_fround(f10 * f7));
   f5 = Math_fround(Math_fround(f6 * f11) + Math_fround(f12 * f7));
   if (i14) {
    i3 = 1;
    f1 = f5;
    f2 = f5;
    do {
     i21 = i19 + (i3 * 3 << 2) | 0;
     f9 = Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2]));
     f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f7));
     f2 = f2 < f9 ? f2 : f9;
     f1 = f1 > f9 ? f1 : f9;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i20 | 0));
   } else {
    f2 = f5;
    f1 = f5;
   }
   i3 = i4 + 1 | 0;
   if (!(!(Math_fround(f8 + Math_fround(.0000999999974)) > f1) & !(Math_fround(f8 + Math_fround(-.0000999999974)) < f2))) {
    i3 = 0;
    i4 = 24;
    break;
   }
   if ((i3 | 0) < (i20 | 0)) {
    i21 = i4;
    i4 = i3;
    i3 = i21;
   } else {
    i3 = 1;
    i4 = 24;
    break;
   }
  }
  if ((i4 | 0) == 24) return i3 | 0;
 }
 while (1) {
  i3 = i19 + (i15 * 3 << 2) | 0;
  i21 = i19 + (i16 * 3 << 2) | 0;
  f6 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 8 >> 2]));
  f7 = Math_fround(HEAPF32[i21 >> 2]);
  f7 = Math_fround(-Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2])));
  f9 = Math_fround(Math_fround(f6 * f13) + Math_fround(f10 * f7));
  i3 = 1;
  f8 = f9;
  do {
   i21 = i17 + (i3 * 3 << 2) | 0;
   f5 = Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2]));
   f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f7));
   f9 = f9 < f5 ? f9 : f5;
   f8 = f8 > f5 ? f8 : f5;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i18 | 0));
  f5 = Math_fround(Math_fround(f6 * f11) + Math_fround(f12 * f7));
  if (i14) {
   i3 = 1;
   f1 = f5;
   f2 = f5;
   do {
    i21 = i19 + (i3 * 3 << 2) | 0;
    f5 = Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2]));
    f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i21 + 8 >> 2]) * f7));
    f2 = f2 < f5 ? f2 : f5;
    f1 = f1 > f5 ? f1 : f5;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i20 | 0));
  } else {
   f2 = f5;
   f1 = f5;
  }
  i3 = i16 + 1 | 0;
  if (!(!(Math_fround(f9 + Math_fround(.0000999999974)) > f1) & !(Math_fround(f8 + Math_fround(-.0000999999974)) < f2))) {
   i3 = 0;
   i4 = 24;
   break;
  }
  if ((i3 | 0) < (i20 | 0)) {
   i15 = i16;
   i16 = i3;
  } else {
   i3 = 1;
   i4 = 24;
   break;
  }
 }
 if ((i4 | 0) == 24) return i3 | 0;
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i23) {
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i28;
 i21 = i28 + 144 | 0;
 i24 = i28 + 16 | 0;
 i26 = i23 + 108 | 0;
 i9 = i23 + 4 | 0;
 i1 = (HEAP32[i26 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i27 = i23 + 112 | 0;
 if (i1 >>> 0 >= (HEAP32[i27 >> 2] | 0) >>> 0) {
  i27 = i23 + 120 | 0;
  HEAP8[i27 >> 0] = 0;
  STACKTOP = i28;
  return;
 }
 i25 = i23 + 104 | 0;
 i2 = HEAP32[i25 >> 2] | 0;
 if (i2 >>> 0 <= 32) {
  i27 = i23 + 120 | 0;
  HEAP8[i27 >> 0] = 0;
  STACKTOP = i28;
  return;
 }
 f3 = Math_fround(i1 >>> 0);
 do {
  i20 = i2;
  i2 = i2 >>> 1;
  if (i20 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i2 >>> 0) * Math_fround(.200000003)));
 i1 = i24 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i24 + 8 | 0;
 i5 = i23 + 8 | 0;
 i7 = HEAP16[i5 >> 1] | 0;
 HEAP8[i4 >> 0] = i7;
 i6 = i24 + 9 | 0;
 HEAP8[i6 >> 0] = (i7 & 65535) >>> 8;
 i7 = i24 + 12 | 0;
 i8 = i23 + 12 | 0;
 i12 = i7;
 i13 = i8;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 i10 = i24 + 56 | 0;
 i11 = i23 + 56 | 0;
 i12 = i10;
 i13 = i11;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 i15 = i24 + 100 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i24 + 104 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i24 + 108 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i24 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i18 = i24 + 116 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i24 + 112 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 120 | 0;
 HEAP8[i20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i24, i23, i2);
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i2 = HEAP8[i5 >> 0] | 0;
 i12 = HEAP16[i4 >> 1] | 0;
 HEAP8[i5 >> 0] = i12;
 HEAP8[i4 >> 0] = i2;
 i2 = i23 + 9 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = (i12 & 65535) >>> 8;
 HEAP8[i6 >> 0] = i1;
 HEAP32[i22 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i1 = HEAP32[i23 + 28 >> 2] | 0;
 i2 = HEAP32[i23 + 32 >> 2] | 0;
 i4 = HEAP32[i23 + 36 >> 2] | 0;
 i12 = i23 + 40 | 0;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i12 = i8;
 i13 = i7;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i24 + 28 >> 2] = i1;
 HEAP32[i24 + 32 >> 2] = i2;
 HEAP32[i24 + 36 >> 2] = i4;
 i1 = i24 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i1 = HEAP32[i23 + 72 >> 2] | 0;
 i2 = HEAP32[i23 + 76 >> 2] | 0;
 i4 = HEAP32[i23 + 80 >> 2] | 0;
 i12 = i23 + 84 | 0;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i12 = i11;
 i13 = i10;
 i14 = i12 + 44 | 0;
 do {
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  i12 = i12 + 4 | 0;
  i13 = i13 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 HEAP32[i10 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i24 + 72 >> 2] = i1;
 HEAP32[i24 + 76 >> 2] = i2;
 HEAP32[i24 + 80 >> 2] = i4;
 i1 = i24 + 84 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 i21 = i23 + 100 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i1;
 i21 = HEAP32[i25 >> 2] | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i25 >> 2] = i15;
 HEAP32[i16 >> 2] = i21;
 i25 = HEAP32[i26 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i25;
 f3 = Math_fround(i15 >>> 0);
 HEAP32[i23 + 116 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i27 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i23 + 120 >> 0] = 0;
 f3 = Math_fround(i21 >>> 0);
 HEAP32[i18 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i19 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i20 >> 0] = 0;
 if (i1 | 0) {
  i27 = HEAP32[i24 + 124 >> 2] | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 4 >> 2] = i27;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
 }
 i27 = i23 + 120 | 0;
 HEAP8[i27 >> 0] = 0;
 STACKTOP = i28;
 return;
}

function __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i1, i5, i13, i14, i4, i3, i9, i15) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 40 | 0;
 i16 = i19 + 56 | 0;
 i2 = i19;
 i12 = __ZN4crnd17crnd_unpack_beginEPKvj(i1, HEAP32[i5 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 40;
 if (!(__ZN4crnd21crnd_get_texture_infoEPKvjPNS_16crn_texture_infoE(i1, HEAP32[i5 >> 2] | 0, i2) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401502 | 0, 0, gb + 401538 | 0, 24, 1, 0, 0, 0);
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i11 = i2 + 32 | 0;
 i10 = i11;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 switch (HEAP32[i10 >> 2] | 0) {
 case 0:
  {
   if (!i1) {
    HEAP32[i13 >> 2] = 10;
    i1 = 10;
   } else i18 = 7;
   break;
  }
 case 1:
  {
   if (!i1) {
    HEAP32[i13 >> 2] = 11;
    i1 = 11;
   } else i18 = 7;
   break;
  }
 case 2:
  {
   if (!i1) {
    HEAP32[i13 >> 2] = 12;
    i1 = 12;
   } else i18 = 7;
   break;
  }
 default:
  i18 = 7;
 }
 if ((i18 | 0) == 7) i1 = HEAP32[i13 >> 2] | 0;
 i8 = __Z24CalculateImageMipMapSizeii13TextureFormat(i4, i3, i1) | 0;
 i10 = Math_imul(i8, i9) | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i15, 0, gb + 401538 | 0, 47) | 0;
 L15 : do if ((i14 | 0) > 0) {
  L17 : do if ((i9 | 0) > 0) {
   i6 = 0;
   i7 = i10;
   while (1) {
    i2 = i4 + 3 | 0;
    i1 = 0;
    do {
     HEAP32[i16 + (i1 << 2) >> 2] = i7 + (Math_imul(i1, i8) | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
    i2 = (i2 | 0) / 4 | 0;
    i5 = i11;
    i1 = HEAP32[i5 + 4 >> 2] | 0;
    do switch (HEAP32[i5 >> 2] | 0) {
    case 0:
     {
      if (!i1) i1 = 8; else i18 = 15;
      break;
     }
    case 1:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 2:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 3:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 4:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 5:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 6:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 7:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 8:
     {
      if (!i1) i18 = 14; else i18 = 15;
      break;
     }
    case 9:
     {
      if (!i1) i1 = 8; else i18 = 15;
      break;
     }
    case 10:
     {
      if (!i1) i1 = 8; else i18 = 15;
      break;
     }
    default:
     i18 = 15;
    } while (0);
    if ((i18 | 0) == 14) {
     i18 = 0;
     i1 = 16;
    } else if ((i18 | 0) == 15) {
     i18 = 0;
     i1 = 0;
    }
    if (!(__ZN4crnd17crnd_unpack_levelEPvPS0_jjj(i12, i16, -1, Math_imul(i1, i2) | 0, i6) | 0)) break L17;
    i5 = __Z18CalculateImageSizeii13TextureFormat(i4, i3, HEAP32[i13 >> 2] | 0) | 0;
    i1 = (i4 | 0) / 2 | 0;
    i2 = (i3 | 0) / 2 | 0;
    i6 = i6 + 1 | 0;
    if ((i6 | 0) >= (i14 | 0)) break L15; else {
     i7 = i7 + i5 | 0;
     i4 = (i1 | 0) < 1 ? 1 : i1;
     i3 = (i2 | 0) < 1 ? 1 : i2;
    }
   }
  } else {
   i5 = 0;
   while (1) {
    i2 = (i4 + 3 | 0) / 4 | 0;
    i9 = i11;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    do switch (HEAP32[i9 >> 2] | 0) {
    case 0:
     {
      if (!i1) i1 = 8; else i18 = 44;
      break;
     }
    case 1:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 2:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 3:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 4:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 5:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 6:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 7:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 8:
     {
      if (!i1) i18 = 43; else i18 = 44;
      break;
     }
    case 9:
     {
      if (!i1) i1 = 8; else i18 = 44;
      break;
     }
    case 10:
     {
      if (!i1) i1 = 8; else i18 = 44;
      break;
     }
    default:
     i18 = 44;
    } while (0);
    if ((i18 | 0) == 43) {
     i18 = 0;
     i1 = 16;
    } else if ((i18 | 0) == 44) {
     i18 = 0;
     i1 = 0;
    }
    if (!(__ZN4crnd17crnd_unpack_levelEPvPS0_jjj(i12, i16, -1, Math_imul(i1, i2) | 0, i5) | 0)) break L17;
    __Z18CalculateImageSizeii13TextureFormat(i4, i3, HEAP32[i13 >> 2] | 0) | 0;
    i1 = (i4 | 0) / 2 | 0;
    i2 = (i3 | 0) / 2 | 0;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i14 | 0)) break L15; else {
     i4 = (i1 | 0) < 1 ? 1 : i1;
     i3 = (i2 | 0) < 1 ? 1 : i2;
    }
   }
  } while (0);
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401617 | 0, 0, gb + 401538 | 0, 59, 1, 0, 0, 0);
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 } while (0);
 if (i12 | 0) if ((HEAP32[i12 >> 2] | 0) == 519686845) {
  __ZN4crnd12crn_unpackerD2Ev(i12);
  if (!(i12 & 7)) {
   mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i12 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
   i18 = i10;
   STACKTOP = i19;
   return i18 | 0;
  } else {
   HEAP32[i17 >> 2] = gb + 401209;
   HEAP32[i17 + 4 >> 2] = 2513;
   HEAP32[i17 + 8 >> 2] = gb + 401349;
   _sprintf(i16, gb + 401176 | 0, i17) | 0;
   _puts(i16) | 0;
   i18 = i10;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i15);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401652 | 0, 0, gb + 401538 | 0, 69, 1, 0, 0, 0);
 i18 = 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZNK32RendererMaterialAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 48 | 0;
 i14 = i18 + 16 | 0;
 i5 = i18 + 32 | 0;
 i15 = i18 + 28 | 0;
 i9 = i18 + 24 | 0;
 i10 = i18 + 20 | 0;
 i11 = i18;
 i16 = HEAP32[i3 + 12 >> 2] | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i12 = i7 & 268435455;
 i6 = HEAP32[i16 + 224 >> 2] | 0;
 L1 : do if (i6 | 0) switch (i7 >>> 30 & 3) {
 case 2:
  {
   i2 = HEAP32[i6 + 8 >> 2] | 0;
   i3 = HEAP32[i6 + 12 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) break L1;
   i4 = HEAP32[i6 + 32 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i12 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) break L1;
   }
   if ((i2 | 0) <= -1) break L1;
   f1 = Math_fround(__ZNK19ShaderPropertySheet24GetFloatValueInsRGBSpaceEi(i6, i2));
   STACKTOP = i18;
   return Math_fround(f1);
  }
 case 1:
 case 0:
  {
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i3 = HEAP32[i6 + 16 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) break L1;
   i4 = HEAP32[i6 + 32 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i12 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) break L1;
   }
   if ((i2 | 0) <= -1) break L1;
   __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi(i5, i6, i2);
   f1 = Math_fround(HEAPF32[i5 + ((i7 >>> 28 & 3) << 2) >> 2]);
   STACKTOP = i18;
   return Math_fround(f1);
  }
 default:
  break L1;
 } while (0);
 L21 : do if ((mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0) > 0) {
  i2 = i7 >>> 30 & 255;
  i8 = i11 + ((i7 >>> 28 & 3) << 2) | 0;
  if ((i2 & 3) == 2) {
   i6 = 0;
   f1 = Math_fround(0.0);
   while (1) {
    i5 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 144 >> 2] | 0, i16 | 0, 0) | 0;
    do if (!i5) i2 = 4; else {
     HEAP32[i14 >> 2] = i5;
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i17 = 23; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i3 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i3 + (i4 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
       i3 = HEAP32[i13 >> 2] | 0;
       i11 = HEAP32[i2 + 28 >> 2] | 0;
       i4 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i3 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
       i3 = HEAP32[i4 + 28 >> 2] | 0;
       i4 = HEAP32[i4 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i17 = 23; else {
       i3 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i3) i17 = 24;
      }
     }
     if ((i17 | 0) == 23) i17 = 24;
     if ((i17 | 0) == 24) {
      i17 = 0;
      i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
      if (!i2) {
       i2 = 4;
       break;
      } else i3 = i2;
     }
     HEAP32[i15 >> 2] = i12;
     HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
     if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i3, i13) | 0) {
      HEAP32[i9 >> 2] = i12;
      HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
      i2 = 1;
      f1 = Math_fround(__ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE(i3, i13));
     } else i2 = 4;
    } while (0);
    switch (i2 & 7) {
    case 4:
    case 0:
     break;
    default:
     break L21;
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0)) {
     i2 = 2;
     break L21;
    }
   }
  }
  i7 = (i2 & 3) == 3;
  i6 = 0;
  f1 = Math_fround(0.0);
  while (1) {
   i5 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 144 >> 2] | 0, i16 | 0, 0) | 0;
   do if (!i5) i2 = 4; else {
    HEAP32[i14 >> 2] = i5;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i17 = 37; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
      i3 = HEAP32[i13 >> 2] | 0;
      i9 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i9 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i9 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i17 = 37; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i17 = 39;
     }
    }
    if ((i17 | 0) == 37) i17 = 39;
    if ((i17 | 0) == 39) {
     i17 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     if (!i2) {
      i2 = 4;
      break;
     }
    }
    HEAP32[i15 >> 2] = i12;
    HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
    i3 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i13) | 0;
    if (i7 | i3 ^ 1) i2 = i3 ? 0 : 4; else {
     HEAP32[i10 >> 2] = i12;
     HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
     __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i11, i2, i13);
     i2 = 1;
     f1 = Math_fround(HEAPF32[i8 >> 2]);
    }
   } while (0);
   switch (i2 & 7) {
   case 4:
   case 0:
    break;
   default:
    break L21;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0)) {
    i2 = 2;
    break L21;
   }
  }
 } else {
  i2 = 2;
  f1 = Math_fround(0.0);
 } while (0);
 f1 = (i2 | 0) == 2 ? Math_fround(0.0) : f1;
 STACKTOP = i18;
 return Math_fround(f1);
}

function __ZN5physx3Scb5SceneC2ERKNS_11PxSceneDescENS_2Cm13EventProfilerE(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN5physx2Sc5SceneC2ERKNS_11PxSceneDescERNS_2Cm13EventProfilerE(i6 + 16 | 0, i5, i1);
 HEAP32[i6 + 2416 >> 2] = 0;
 HEAP32[i6 + 2420 >> 2] = 0;
 HEAP32[i6 + 2424 >> 2] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i8 | 0, i2 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i6 + 2428 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP8[i6 + 2432 >> 0] = 0;
 HEAP8[i6 + 2433 >> 0] = (HEAP32[i5 + 152 >> 2] | 0) == 1 & 1;
 __ZN5physx2Cm9FlushPoolC2Ej(i6 + 2436 | 0, 16384);
 i1 = i6 + 2464 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i6 + 2488 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2492 >> 2] = -1;
 HEAP32[i6 + 2496 >> 2] = 0;
 HEAP32[i6 + 2500 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i6 + 2564 | 0;
 i2 = i6 + 2504 | 0;
 i3 = i2 + 60 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2568 >> 2] = -1;
 HEAP32[i6 + 2572 >> 2] = 0;
 HEAP32[i6 + 2576 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i6 + 2540 | 0, 64);
 i2 = i6 + 2580 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2604 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2608 >> 2] = -1;
 HEAP32[i6 + 2612 >> 2] = 0;
 HEAP32[i6 + 2616 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2620 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2644 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2648 >> 2] = -1;
 HEAP32[i6 + 2652 >> 2] = 0;
 HEAP32[i6 + 2656 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2660 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2684 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2688 >> 2] = -1;
 HEAP32[i6 + 2692 >> 2] = 0;
 HEAP32[i6 + 2696 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2700 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2724 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2728 >> 2] = -1;
 HEAP32[i6 + 2732 >> 2] = 0;
 HEAP32[i6 + 2736 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2740 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2764 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2768 >> 2] = -1;
 HEAP32[i6 + 2772 >> 2] = 0;
 HEAP32[i6 + 2776 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2780 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2804 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2808 >> 2] = -1;
 HEAP32[i6 + 2812 >> 2] = 0;
 HEAP32[i6 + 2816 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i6 + 2820 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 2844 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2848 >> 2] = -1;
 HEAP32[i6 + 2852 >> 2] = 0;
 HEAP32[i6 + 2856 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 HEAP32[i6 + 2860 >> 2] = HEAP32[i5 + 156 >> 2];
 HEAP16[i6 + 3348 >> 1] = 0;
 i2 = i6 + 3080 | 0;
 i3 = i2 + 124 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = i6 + 3012 | 0;
 i3 = i2 + 37 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i8 = i6 + 3356 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP8[i4 >> 0] = -1;
 __ZN5physx6shdfnd5ArrayINS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i6 + 3360 | 0, i4) | 0;
 HEAP32[i6 + 3372 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i7 = i13 + 564 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = _i64Add(i2 | 0, i4 | 0, -1, ~i2 | 0) | 0;
  i8 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i11 | 0, i8 | 0, 22) | 0;
  i11 = i10 ^ i11;
  i8 = (getTempRet0() | 0) ^ i8;
  i10 = _bitshift64Shl(i11 | 0, i8 | 0, 13) | 0;
  i10 = _i64Add(i11 | 0, i8 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i8 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i10 | 0, i8 | 0, 8) | 0;
  i8 = ___muldi3(i11 ^ i10 | 0, (getTempRet0() | 0) ^ i8 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i8 | 0, i10 | 0, 15) | 0;
  i8 = i11 ^ i8;
  i10 = (getTempRet0() | 0) ^ i10;
  i11 = _bitshift64Shl(i8 | 0, i10 | 0, 27) | 0;
  i11 = _i64Add(i8 | 0, i10 | 0, ~i11 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i8 = _bitshift64Lshr(i11 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i10 = i13 + 556 | 0;
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (((i8 ^ i11) & i1 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i8 = i13 + 548 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i11 = i13 + 552 | 0;
   while (1) {
    if ((HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) == (i2 | 0)) if ((HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i4 | 0)) break;
    i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i3 + (i1 * 12 | 0) | 0) {
    i5 = HEAP32[i3 + (i1 * 12 | 0) + 8 >> 2] | 0;
    i1 = i13 + 16 | 0;
    i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_(i13 + 544 | 0, i9) | 0;
    i2 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
    HEAP32[i13 >> 2] = i2;
    if ((i5 | 0) != (i2 | 0)) {
     i12 = HEAP32[i13 + 12 >> 2] | 0;
     i4 = i12 + (i2 << 3) | 0;
     i14 = HEAP32[i13 + 8 >> 2] | 0;
     HEAP32[i14 + (i5 * 24 | 0) >> 2] = HEAP32[i14 + (i2 * 24 | 0) >> 2];
     HEAP32[i14 + (i5 * 24 | 0) + 4 >> 2] = HEAP32[i14 + (i2 * 24 | 0) + 4 >> 2];
     HEAP32[i14 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i14 + (i2 * 24 | 0) + 8 >> 2];
     HEAP32[i14 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i14 + (i2 * 24 | 0) + 12 >> 2];
     HEAP32[i14 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i14 + (i2 * 24 | 0) + 16 >> 2];
     HEAP32[i14 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i14 + (i2 * 24 | 0) + 20 >> 2];
     i14 = i4;
     i3 = HEAP32[i14 + 4 >> 2] | 0;
     i9 = i12 + (i5 << 3) | 0;
     HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 + (i5 << 2) >> 2] = HEAP32[i1 + (HEAP32[i13 >> 2] << 2) >> 2];
     i1 = HEAP32[i7 >> 2] | 0;
     i4 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i12 + (i2 << 3) + 4 >> 2] | 0;
     i12 = _i64Add(i4 | 0, i2 | 0, -1, ~i4 | 0) | 0;
     i9 = getTempRet0() | 0;
     i3 = _bitshift64Lshr(i12 | 0, i9 | 0, 22) | 0;
     i12 = i3 ^ i12;
     i9 = (getTempRet0() | 0) ^ i9;
     i3 = _bitshift64Shl(i12 | 0, i9 | 0, 13) | 0;
     i3 = _i64Add(i12 | 0, i9 | 0, ~i3 | 0, ~(getTempRet0() | 0) | 0) | 0;
     i9 = getTempRet0() | 0;
     i12 = _bitshift64Lshr(i3 | 0, i9 | 0, 8) | 0;
     i9 = ___muldi3(i12 ^ i3 | 0, (getTempRet0() | 0) ^ i9 | 0, 9, 0) | 0;
     i3 = getTempRet0() | 0;
     i12 = _bitshift64Lshr(i9 | 0, i3 | 0, 15) | 0;
     i9 = i12 ^ i9;
     i3 = (getTempRet0() | 0) ^ i3;
     i12 = _bitshift64Shl(i9 | 0, i3 | 0, 27) | 0;
     i12 = _i64Add(i9 | 0, i3 | 0, ~i12 | 0, ~(getTempRet0() | 0) | 0) | 0;
     i3 = getTempRet0() | 0;
     i9 = _bitshift64Lshr(i12 | 0, i3 | 0, 31) | 0;
     (getTempRet0() | 0) ^ i3;
     i3 = HEAP32[i8 >> 2] | 0;
     i1 = (HEAP32[i10 >> 2] | 0) + (((i9 ^ i12) & i1 + -1) << 2) | 0;
     while (1) {
      i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i2 | 0)) break;
      i1 = (HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0;
     }
     HEAP32[i3 + (i1 * 12 | 0) + 8 >> 2] = i5;
    }
    if (HEAP8[i13 + 7584 >> 0] | 0) {
     i14 = 1;
     return i14 | 0;
    }
    i14 = HEAP32[i13 + 20 >> 2] | 0;
    HEAP32[i14 + (i6 << 5) >> 2] = 0;
    HEAP32[i14 + (i6 << 5) + 4 >> 2] = 0;
    HEAP32[i14 + (i6 << 5) + 8 >> 2] = 0;
    HEAP32[i14 + (i6 << 5) + 16 >> 2] = -25165825;
    HEAP32[i14 + (i6 << 5) + 20 >> 2] = -25165825;
    HEAP32[i14 + (i6 << 5) + 24 >> 2] = -25165825;
    i14 = 1;
    return i14 | 0;
   }
  }
 } while (0);
 i5 = i13 + 28 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  i14 = 0;
  return i14 | 0;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i2 = i13 + 32 + (i1 << 3) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i13 + 32 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i12 = 22;
   break;
  }
 }
 if ((i12 | 0) == 22) return i1 | 0;
 i12 = i6 + -1 | 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i13 + 160 + (i1 * 24 | 0) >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) >> 2];
 HEAP32[i13 + 160 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) + 4 >> 2];
 HEAP32[i13 + 160 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) + 8 >> 2];
 HEAP32[i13 + 160 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) + 12 >> 2];
 HEAP32[i13 + 160 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) + 16 >> 2];
 HEAP32[i13 + 160 + (i1 * 24 | 0) + 20 >> 2] = HEAP32[i13 + 160 + (i12 * 24 | 0) + 20 >> 2];
 i12 = i13 + 32 + (HEAP32[i5 >> 2] << 3) | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i2;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 i14 = 1;
 return i14 | 0;
}

function __ZN7mecanim8skeleton23Skeleton2BoneAdjustHintEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_f(i23, i24, i1, i3, i10, f26, i27, i28, f22) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 f26 = Math_fround(f26);
 i27 = i27 | 0;
 i28 = i28 | 0;
 f22 = Math_fround(f22);
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i25 = 0, f29 = f0, i30 = 0, i31 = 0, i32 = 0;
 i25 = i28 + 4 | 0;
 i25 = (HEAP32[i25 >> 2] | 0) + i25 | 0;
 f7 = Math_fround(HEAPF32[i25 + (i24 * 40 | 0) >> 2]);
 f8 = Math_fround(HEAPF32[i25 + (i24 * 40 | 0) + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i25 + (i24 * 40 | 0) + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) >> 2]);
 f21 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i25 + (i1 * 40 | 0) + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i25 + (i3 * 40 | 0) >> 2]);
 f18 = Math_fround(HEAPF32[i25 + (i3 * 40 | 0) + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i25 + (i3 * 40 | 0) + 8 >> 2]);
 f2 = Math_fround(f17 - f7);
 f4 = Math_fround(f18 - f8);
 f5 = Math_fround(f16 - f9);
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)))));
 if (!(f6 > Math_fround(0.0))) return;
 f29 = Math_fround(f2 / f6);
 f13 = Math_fround(f4 / f6);
 f11 = Math_fround(f5 / f6);
 f2 = Math_fround(f20 - f7);
 f14 = Math_fround(f21 - f8);
 f15 = Math_fround(f19 - f9);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f7 = Math_fround(f6 - f7);
 f8 = Math_fround(f12 - f8);
 f12 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f9);
 f6 = Math_fround(Math_fround(Math_fround(f2 * f29) + Math_fround(f14 * f13)) + Math_fround(Math_fround(f15 * f11) + Math_fround(0.0)));
 f9 = Math_fround(Math_fround(Math_fround(f29 * f7) + Math_fround(f13 * f8)) + Math_fround(Math_fround(f11 * f12) + Math_fround(0.0)));
 f4 = Math_fround(f2 - Math_fround(f29 * f6));
 f5 = Math_fround(f14 - Math_fround(f13 * f6));
 f6 = Math_fround(f15 - Math_fround(f11 * f6));
 f7 = Math_fround(f7 - Math_fround(f29 * f9));
 f8 = Math_fround(f8 - Math_fround(f13 * f9));
 f9 = Math_fround(f12 - Math_fround(f11 * f9));
 f11 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)));
 f12 = Math_fround(Math_sqrt(Math_fround(f11)));
 f13 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(Math_fround(f9 * f9) + Math_fround(0.0)));
 if (!(f12 > Math_fround(0.0) & Math_fround(Math_sqrt(Math_fround(f13))) > Math_fround(0.0))) return;
 f20 = Math_fround(f17 - f20);
 f21 = Math_fround(f18 - f21);
 f29 = Math_fround(f16 - f19);
 f2 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f15 * f15) + Math_fround(0.0))))) + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(Math_fround(f29 * f29) + Math_fround(0.0)))))) * f22);
 if (!(f12 > f2)) return;
 f14 = Math_fround(f2 * Math_fround(2.0));
 f16 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f14 - f12) / Math_fround(f14 - f2)));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f7) + Math_fround(f5 * f8)) + Math_fround(Math_fround(f6 * f9) + Math_fround(0.0))) + Math_fround(Math_sqrt(Math_fround(f11 * f13))));
 f16 = Math_fround((f12 > f14 ? Math_fround(1.0) : f16) * f26);
 f14 = Math_fround(Math_fround(Math_fround(f5 * f9) - Math_fround(f6 * f8)) * f16);
 f20 = Math_fround(Math_fround(Math_fround(f6 * f7) - Math_fround(f4 * f9)) * f16);
 f16 = Math_fround(Math_fround(Math_fround(f4 * f8) - Math_fround(f5 * f7)) * f16);
 i1 = i25 + (i24 * 40 | 0) + 12 | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(f20 * f17);
 i10 = i25 + (i24 * 40 | 0) + 24 | 0;
 f21 = Math_fround(HEAPF32[i10 >> 2]);
 f29 = Math_fround(f18 * f21);
 i3 = i25 + (i24 * 40 | 0) + 16 | 0;
 f26 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(f16 * f26);
 i25 = i25 + (i24 * 40 | 0) + 20 | 0;
 f15 = Math_fround(HEAPF32[i25 >> 2]);
 f22 = Math_fround(Math_fround(Math_fround(f22 - Math_fround(f18 * f15)) - Math_fround(f16 * f21)) - Math_fround(f14 * f26));
 f29 = Math_fround(Math_fround(Math_fround(f29 - Math_fround(f14 * f17)) - Math_fround(f16 * f15)) - Math_fround(f20 * f26));
 f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f20 * f15)) - Math_fround(f18 * f17)) - Math_fround(f14 * f21));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f17)) - Math_fround(f18 * f26)) - Math_fround(f20 * f21));
 i30 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i32 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f21 = (HEAP32[tempDoublePtr >> 2] = i32 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(f21 * f21);
 f22 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(f22 * f22);
 f26 = (HEAP32[tempDoublePtr >> 2] = i30 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f19 + f20) + Math_fround(Math_fround(f29 * f29) + Math_fround(f26 * f26))))));
 f22 = Math_fround(f20 * f22);
 f26 = Math_fround(f20 * f26);
 f29 = Math_fround(f20 * f29);
 HEAPF32[i1 >> 2] = Math_fround(f20 * f21);
 HEAPF32[i3 >> 2] = f22;
 HEAPF32[i25 >> 2] = f26;
 HEAPF32[i10 >> 2] = f29;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i23, i28, i27, i24, i24);
 return;
}

function __ZNK15HeightMeshQuery17GetGeometryHeightERK8Vector3fPf(i1, i19, i29) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i29 = i29 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i30;
 f21 = Math_fround(HEAPF32[i19 >> 2]);
 i25 = i1 + 20 | 0;
 f4 = Math_fround(HEAPF32[i25 >> 2]);
 f26 = Math_fround(f21 - f4);
 f23 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f20 = Math_fround(f23 - f4);
 f21 = Math_fround(f21 + f4);
 i28 = i19 + 4 | 0;
 f22 = Math_fround(HEAPF32[i28 >> 2]);
 f23 = Math_fround(f4 + f23);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i18 = i1 + 8 | 0;
 if ((i2 | 0) == (i18 | 0)) i1 = -8388608; else {
  i3 = i2;
  i1 = -8388608;
  while (1) {
   i16 = HEAP32[i3 + 20 >> 2] | 0;
   if (i16) {
    i17 = i16 + 4 | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    if ((HEAP32[i17 >> 2] | 0) != (i2 | 0)) {
     i15 = 0;
     do {
      i14 = i2 + (i15 * 84 | 0) | 0;
      f35 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 60 >> 2]);
      f34 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 72 >> 2]);
      f36 = Math_fround(f35 - f34);
      f38 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 64 >> 2]);
      f4 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 76 >> 2]);
      f31 = Math_fround(f38 - f4);
      f37 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 68 >> 2]);
      f33 = Math_fround(HEAPF32[i2 + (i15 * 84 | 0) + 80 >> 2]);
      f32 = Math_fround(f37 - f33);
      f4 = Math_fround(f38 + f4);
      f33 = Math_fround(f37 + f33);
      i13 = !(f21 < f36) & !(f26 > Math_fround(f35 + f34));
      L9 : do if (!(f20 > f33 | f23 < f32 | i13 & (!(f22 < f31) & !((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f4)) ^ 1)) {
       i12 = i2 + (i15 * 84 | 0) + 52 | 0;
       i5 = HEAP32[i12 >> 2] | 0;
       if (!i5) {
        i6 = i2 + (i15 * 84 | 0) + 32 | 0;
        if (!(HEAP32[i6 >> 2] | 0)) break;
        i5 = i2 + (i15 * 84 | 0) + 20 | 0;
        i2 = 0;
        while (1) {
         i13 = HEAP32[i5 >> 2] | 0;
         i12 = HEAP32[i14 >> 2] | 0;
         if (__ZL26ClosestHeightPointTriangleRK8Vector3ffS1_S1_S1_Rf(i19, Math_fround(HEAPF32[i25 >> 2]), i12 + ((HEAP32[i13 + (i2 << 2) >> 2] | 0) * 12 | 0) | 0, i12 + ((HEAP32[i13 + (i2 + 1 << 2) >> 2] | 0) * 12 | 0) | 0, i12 + ((HEAP32[i13 + (i2 + 2 << 2) >> 2] | 0) * 12 | 0) | 0, i24) | 0) {
          f4 = Math_fround(HEAPF32[i24 >> 2]);
          i13 = f4 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) & f4 < f22;
          i1 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1;
         }
         i2 = i2 + 3 | 0;
         if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break L9;
        }
       }
       i13 = i2 + (i15 * 84 | 0) + 40 | 0;
       i11 = i2 + (i15 * 84 | 0) + 20 | 0;
       i10 = 0;
       do {
        i8 = HEAP32[i13 >> 2] | 0;
        if (f26 > Math_fround(HEAPF32[i8 + (i10 << 5) + 12 >> 2])) i2 = 0; else if (f21 < Math_fround(HEAPF32[i8 + (i10 << 5) >> 2])) i2 = 0; else i2 = 1;
        f38 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
        if (f38 > Math_fround(HEAPF32[i8 + (i10 << 5) + 16 >> 2])) i2 = 0; else if (f22 < Math_fround(HEAPF32[i8 + (i10 << 5) + 4 >> 2])) i2 = 0;
        if (f20 > Math_fround(HEAPF32[i8 + (i10 << 5) + 20 >> 2])) i27 = 18; else if (f23 < Math_fround(HEAPF32[i8 + (i10 << 5) + 8 >> 2])) i27 = 18; else {
         i9 = i8 + (i10 << 5) + 24 | 0;
         i6 = HEAP32[i9 >> 2] | 0;
         i7 = (i6 | 0) > -1;
         if (i2 & i7) {
          i2 = i6 * 3 | 0;
          i7 = ((HEAP32[i8 + (i10 << 5) + 28 >> 2] | 0) + i6 | 0) * 3 | 0;
          if ((i2 | 0) < (i7 | 0)) {
           do {
            i8 = HEAP32[i11 >> 2] | 0;
            i6 = HEAP32[i14 >> 2] | 0;
            if (__ZL26ClosestHeightPointTriangleRK8Vector3ffS1_S1_S1_Rf(i19, Math_fround(HEAPF32[i25 >> 2]), i6 + ((HEAP32[i8 + (i2 << 2) >> 2] | 0) * 12 | 0) | 0, i6 + ((HEAP32[i8 + (i2 + 1 << 2) >> 2] | 0) * 12 | 0) | 0, i6 + ((HEAP32[i8 + (i2 + 2 << 2) >> 2] | 0) * 12 | 0) | 0, i24) | 0) {
             f4 = Math_fround(HEAPF32[i24 >> 2]);
             i8 = f4 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) & f4 < f22;
             i1 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : i1;
            }
            i2 = i2 + 3 | 0;
           } while ((i2 | 0) < (i7 | 0));
           i7 = 1;
           i2 = 1;
           i6 = HEAP32[i9 >> 2] | 0;
           i5 = HEAP32[i12 >> 2] | 0;
          } else {
           i7 = 1;
           i2 = 1;
          }
         }
        }
        if ((i27 | 0) == 18) {
         i27 = 0;
         i6 = HEAP32[i8 + (i10 << 5) + 24 >> 2] | 0;
         i7 = (i6 | 0) > -1;
         i2 = 0;
        }
        i10 = (i7 | i2 ? 1 : 0 - i6 | 0) + i10 | 0;
       } while (i10 >>> 0 < i5 >>> 0);
      } while (0);
      i15 = i15 + 1 | 0;
      i2 = HEAP32[i16 >> 2] | 0;
     } while (i15 >>> 0 < (((HEAP32[i17 >> 2] | 0) - i2 | 0) / 84 | 0) >>> 0);
    }
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   if ((i2 | 0) == (i18 | 0)) break; else i3 = i2;
  }
 }
 if ((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(-inf)) {
  HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
  i29 = 0;
  STACKTOP = i30;
  return i29 | 0;
 } else {
  HEAP32[i29 >> 2] = i1;
  i29 = 1;
  STACKTOP = i30;
  return i29 | 0;
 }
 return 0;
}

function __ZN9Heightmap8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 __ZN14SafeBinaryRead10SetVersionEi(i11, 2);
 i2 = i10 + 4 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932165 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932175 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932194 | 0, i3, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i11, i2, 0); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i7 = i10 + 72 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932215 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i8 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 24; else {
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i6 = i10 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932223 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i4 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i8 = 35; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 35; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932232 | 0, HEAP32[gb + 37012 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i11 + 16 | 0;
   i2 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 46; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932244 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i5 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 57; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 932253 | 0, HEAP32[gb + 37324 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 1) | 0)) {
  STACKTOP = i12;
  return;
 }
 __ZN9Heightmap15PrecomputeErrorEiiiib(i10, 0, 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0, 0);
 STACKTOP = i12;
 return;
}

function __ZN11AudioSource8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 440 | 0, i8);
 __ZN4PPtrI9AudioClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 436 | 0, i8);
 i1 = i7 + 497 | 0;
 i9 = i8 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i1 = i7 + 412 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 408 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 420 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 421 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 422 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 423 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i1 = i7 + 388 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 392 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 396 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 400 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 404 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i7 + 416 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i3 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i7 + 424 | 0;
 if ((i2 + 1 | 0) >>> 0 < i3 >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 425 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 426 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = i7 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = i7 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  i10 = i7 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd4sortIPKNS_24PxsIndexedContactManagerENS_25ArticulationSortPredicateENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[(HEAP32[(HEAP32[i18 + (i6 << 2) >> 2] | 0) + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0 < (HEAP32[(HEAP32[(HEAP32[i18 + (i5 << 2) >> 2] | 0) + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i13 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 76 >> 2] | 0;
   i10 = i7;
   i5 = i6;
   if ((HEAP32[(HEAP32[i6 + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0 < i9 >>> 0) {
    HEAP32[i13 >> 2] = i5;
    HEAP32[i14 >> 2] = i10;
    i15 = HEAP32[i13 >> 2] | 0;
    i5 = i10;
    i9 = HEAP32[(HEAP32[i15 + 12 >> 2] | 0) + 76 >> 2] | 0;
    i10 = i15;
   } else i7 = i6;
   i12 = i18 + (i3 << 2) | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i11 = HEAP32[(HEAP32[i6 + 12 >> 2] | 0) + 76 >> 2] | 0;
   if (i11 >>> 0 < i9 >>> 0) {
    HEAP32[i13 >> 2] = i6;
    HEAP32[i12 >> 2] = i10;
    i5 = HEAP32[i14 >> 2] | 0;
    i7 = i5;
    i9 = HEAP32[(HEAP32[i10 + 12 >> 2] | 0) + 76 >> 2] | 0;
    i6 = i10;
   } else i9 = i11;
   if (i9 >>> 0 < (HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0) {
    HEAP32[i14 >> 2] = i6;
    HEAP32[i12 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i6 = i4;
   while (1) {
    i12 = HEAP32[(HEAP32[i5 + 12 >> 2] | 0) + 76 >> 2] | 0;
    i10 = i6;
    while (1) {
     i6 = i10 + 1 | 0;
     i5 = i18 + (i6 << 2) | 0;
     i7 = HEAP32[i5 >> 2] | 0;
     if ((HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0 < i12 >>> 0) i10 = i6; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < (HEAP32[(HEAP32[i10 + 12 >> 2] | 0) + 76 >> 2] | 0) >>> 0);
    if ((i6 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i5 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i5 = HEAP32[i15 >> 2] | 0;
    i14 = i5;
   }
   HEAP32[i5 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i6 - i4 | 0) < (i3 - i6 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 720769 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 720769 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx14NpRigidDynamic13setGlobalPoseERKNS_11PxTransformEb(i18, i1, i17) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 i2 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i18) | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f10 * f10);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f7 * f7));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f9 * f9));
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f12 * f12)))));
 f10 = Math_fround(f10 * f5);
 f7 = Math_fround(f7 * f5);
 f9 = Math_fround(f9 * f5);
 f5 = Math_fround(f12 * f5);
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 i3 = (i2 | 0) != 0;
 if (i3) {
  __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i18 + 20 | 0, i2 + 3392 | 0);
  i15 = i2 + 3416 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7))))));
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(1.0) / f4);
  f5 = Math_fround(f5 * f4);
  f9 = Math_fround(f9 * f4);
  f7 = Math_fround(f7 * f4);
  f4 = Math_fround(f10 * f4);
 } else f4 = f10;
 i14 = i18 + 48 | 0;
 i15 = i18 + 284 | 0;
 i2 = i18 + 56 | 0;
 i8 = (HEAP32[i15 >> 2] & 512 | 0) == 0 ? i18 + 112 | 0 : (HEAP32[i2 >> 2] | 0) + 144 | 0;
 f22 = Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f5 * f5) + Math_fround(-.5));
 f24 = Math_fround(Math_fround(Math_fround(f4 * f22) + Math_fround(f7 * f25)) + Math_fround(f9 * f23));
 f10 = Math_fround(f12 + Math_fround(Math_fround(f4 * f24) + Math_fround(Math_fround(f21 * f22) + Math_fround(f5 * Math_fround(Math_fround(f7 * f23) - Math_fround(f9 * f25))))));
 f12 = Math_fround(f13 + Math_fround(Math_fround(f7 * f24) + Math_fround(Math_fround(f21 * f25) + Math_fround(f5 * Math_fround(Math_fround(f9 * f22) - Math_fround(f4 * f23))))));
 f13 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f21 * f23) + Math_fround(f5 * Math_fround(Math_fround(f4 * f25) - Math_fround(f7 * f22)))) + Math_fround(f9 * f24)));
 f24 = Math_fround(HEAPF32[i8 >> 2]);
 f22 = Math_fround(f5 * f24);
 f25 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f4 * f25));
 f11 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f7 * f11));
 f23 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f22 = Math_fround(f22 - Math_fround(f9 * f23));
 f21 = Math_fround(Math_fround(Math_fround(f9 * f24) + Math_fround(Math_fround(f7 * f25) + Math_fround(f5 * f23))) - Math_fround(f4 * f11));
 f20 = Math_fround(Math_fround(Math_fround(f4 * f23) + Math_fround(Math_fround(f9 * f25) + Math_fround(f5 * f11))) - Math_fround(f7 * f24));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f25) - Math_fround(f4 * f24)) - Math_fround(f7 * f23)) - Math_fround(f9 * f11));
 HEAPF32[i16 >> 2] = f22;
 HEAPF32[i16 + 4 >> 2] = f21;
 HEAPF32[i16 + 8 >> 2] = f20;
 HEAPF32[i16 + 12 >> 2] = f11;
 HEAPF32[i16 + 16 >> 2] = f10;
 HEAPF32[i16 + 20 >> 2] = f12;
 HEAPF32[i16 + 24 >> 2] = f13;
 HEAPF32[i18 + 224 >> 2] = f22;
 HEAPF32[i18 + 228 >> 2] = f21;
 HEAPF32[i18 + 232 >> 2] = f20;
 HEAPF32[i18 + 236 >> 2] = f11;
 HEAPF32[i18 + 240 >> 2] = f10;
 HEAPF32[i18 + 244 >> 2] = f12;
 HEAPF32[i18 + 248 >> 2] = f13;
 i8 = i18 + 52 | 0;
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i14 >> 2] | 0;
   i6 = 9;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i14 >> 2] | 0;
   if (!(HEAP8[i1 + 2433 >> 0] | 0)) i6 = 8; else i6 = 9;
   break;
  }
 default:
  i6 = 8;
 }
 if ((i6 | 0) == 8) __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i18 + 64 | 0, i16); else if ((i6 | 0) == 9) {
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -524289;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i14);
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 262144;
 }
 if (!(i3 & i17)) {
  STACKTOP = i19;
  return;
 }
 i17 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP16[((i17 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i17 >>> 24 & 15) << 2) >> 2] | 0) + i14 + 8 | 0 : i1) >> 1] & 8) {
  STACKTOP = i19;
  return;
 }
 if (HEAP8[((HEAP32[i15 >> 2] & 4096 | 0) == 0 ? i18 + 108 | 0 : i1 + 268 | 0) >> 0] & 1) {
  STACKTOP = i19;
  return;
 }
 f25 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i18) | 0) + 2876 >> 2]);
 i2 = i18 + 276 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i18 + 280 | 0;
 i17 = f4 < f25;
 f4 = i17 ? f25 : f4;
 if (!(i17 | (HEAP32[i3 >> 2] | 0) != 0)) {
  STACKTOP = i19;
  return;
 }
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i14 >> 2] | 0;
   i6 = 18;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i14 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i6 = 17; else i6 = 18;
   break;
  }
 default:
  i6 = 17;
 }
 if ((i6 | 0) == 17) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f4;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i18 + 64 | 0, f4, 1);
  STACKTOP = i19;
  return;
 } else if ((i6 | 0) == 18) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f4;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i14);
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -29360129 | 20971520;
  STACKTOP = i19;
  return;
 }
}

function __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i5, i9, i6, i1) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = _strcmp(i3, HEAP32[i5 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i1) i4 = 0; else {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   if (!i2) i4 = 1; else i4 = (HEAP32[i2 + 16 >> 2] | 0) < (HEAP32[i1 + 16 >> 2] | 0);
  }
 } else i4 = (i1 | 0) < 0;
 i1 = _strcmp(HEAP32[i6 >> 2] | 0, i3) | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i2 = HEAP32[i6 + 4 >> 2] | 0;
   if (!i2) i1 = 1; else i1 = (HEAP32[i2 + 16 >> 2] | 0) < (HEAP32[i1 + 16 >> 2] | 0);
  }
 } else i1 = (i1 | 0) < 0;
 if (!i4) {
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i1 = _strcmp(HEAP32[i9 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (!i1) {
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i1) {
    i9 = 1;
    STACKTOP = i8;
    return i9 | 0;
   }
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i9 = 1;
    STACKTOP = i8;
    return i9 | 0;
   }
  } else if ((i1 | 0) >= 0) {
   i9 = 1;
   STACKTOP = i8;
   return i9 | 0;
  };
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i9 = 2;
  STACKTOP = i8;
  return i9 | 0;
 }
 if (i1) {
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i1 = _strcmp(HEAP32[i6 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  if (!i1) {
   i9 = 1;
   STACKTOP = i8;
   return i9 | 0;
  }
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = 1;
   STACKTOP = i8;
   return i9 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i9 = 2;
 STACKTOP = i8;
 return i9 | 0;
}

function runPostSets228() {
 HEAP32[gb + 10800 >> 2] = (HEAP32[gb + 10800 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 10804 >> 2] = (HEAP32[gb + 10804 >> 2] | 0) + (gb + 1077486 | 0);
 HEAP32[gb + 10816 >> 2] = (HEAP32[gb + 10816 >> 2] | 0) + (gb + 10744 | 0);
 HEAP32[gb + 208880 >> 2] = (HEAP32[gb + 208880 >> 2] | 0) + (gb + 208840 | 0);
 HEAP32[gb + 208884 >> 2] = (HEAP32[gb + 208884 >> 2] | 0) + (gb + 208840 | 0);
 HEAP32[gb + 208896 >> 2] = (HEAP32[gb + 208896 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 208900 >> 2] = fb + 879;
 HEAP32[gb + 208904 >> 2] = fb + 880;
 HEAP32[gb + 208916 >> 2] = (HEAP32[gb + 208916 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 208920 >> 2] = fb + 881;
 HEAP32[gb + 208924 >> 2] = fb + 882;
 HEAP32[gb + 10824 >> 2] = (HEAP32[gb + 10824 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 10828 >> 2] = (HEAP32[gb + 10828 >> 2] | 0) + (gb + 1077533 | 0);
 HEAP32[gb + 10840 >> 2] = (HEAP32[gb + 10840 >> 2] | 0) + (gb + 10720 | 0);
 HEAP32[gb + 208928 >> 2] = (HEAP32[gb + 208928 >> 2] | 0) + (gb + 208888 | 0);
 HEAP32[gb + 208932 >> 2] = (HEAP32[gb + 208932 >> 2] | 0) + (gb + 208888 | 0);
 HEAP32[gb + 208944 >> 2] = (HEAP32[gb + 208944 >> 2] | 0) + (gb + 10848 | 0);
 HEAP32[gb + 208948 >> 2] = fb + 3049;
 HEAP32[gb + 208952 >> 2] = fb + 3050;
 HEAP32[gb + 208964 >> 2] = (HEAP32[gb + 208964 >> 2] | 0) + (gb + 10848 | 0);
 HEAP32[gb + 208968 >> 2] = fb + 3051;
 HEAP32[gb + 208972 >> 2] = fb + 3052;
 HEAP32[gb + 10848 >> 2] = (HEAP32[gb + 10848 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 10852 >> 2] = (HEAP32[gb + 10852 >> 2] | 0) + (gb + 1077580 | 0);
 HEAP32[gb + 10864 >> 2] = (HEAP32[gb + 10864 >> 2] | 0) + (gb + 10744 | 0);
 HEAP32[gb + 208976 >> 2] = (HEAP32[gb + 208976 >> 2] | 0) + (gb + 208936 | 0);
 HEAP32[gb + 208980 >> 2] = (HEAP32[gb + 208980 >> 2] | 0) + (gb + 208936 | 0);
 HEAP32[gb + 208992 >> 2] = (HEAP32[gb + 208992 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 208996 >> 2] = fb + 3053;
 HEAP32[gb + 209e3 >> 2] = fb + 3054;
 HEAP32[gb + 209012 >> 2] = (HEAP32[gb + 209012 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 209016 >> 2] = fb + 3055;
 HEAP32[gb + 209020 >> 2] = fb + 3056;
 HEAP32[gb + 209032 >> 2] = (HEAP32[gb + 209032 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 209036 >> 2] = fb + 3057;
 HEAP32[gb + 209040 >> 2] = fb + 3058;
 HEAP32[gb + 10872 >> 2] = (HEAP32[gb + 10872 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 10876 >> 2] = (HEAP32[gb + 10876 >> 2] | 0) + (gb + 1077627 | 0);
 HEAP32[gb + 10888 >> 2] = (HEAP32[gb + 10888 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 10896 >> 2] = (HEAP32[gb + 10896 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 209044 >> 2] = (HEAP32[gb + 209044 >> 2] | 0) + (gb + 208984 | 0);
 HEAP32[gb + 209048 >> 2] = (HEAP32[gb + 209048 >> 2] | 0) + (gb + 209072 | 0);
 HEAP32[gb + 209052 >> 2] = (HEAP32[gb + 209052 >> 2] | 0) + (gb + 209072 | 0);
 HEAP32[gb + 209056 >> 2] = (HEAP32[gb + 209056 >> 2] | 0) + (gb + 209112 | 0);
 HEAP32[gb + 209060 >> 2] = (HEAP32[gb + 209060 >> 2] | 0) + (gb + 209112 | 0);
 HEAP32[gb + 209064 >> 2] = (HEAP32[gb + 209064 >> 2] | 0) + (gb + 208984 | 0);
 HEAP32[gb + 209068 >> 2] = (HEAP32[gb + 209068 >> 2] | 0) + (gb + 208984 | 0);
 HEAP32[gb + 209080 >> 2] = (HEAP32[gb + 209080 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 209084 >> 2] = fb + 3041;
 HEAP32[gb + 209088 >> 2] = fb + 3042;
 HEAP32[gb + 209100 >> 2] = (HEAP32[gb + 209100 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 209104 >> 2] = fb + 3043;
 HEAP32[gb + 209108 >> 2] = fb + 3044;
 HEAP32[gb + 209120 >> 2] = (HEAP32[gb + 209120 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 209124 >> 2] = fb + 879;
 HEAP32[gb + 209128 >> 2] = fb + 880;
 HEAP32[gb + 209140 >> 2] = (HEAP32[gb + 209140 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 209144 >> 2] = fb + 881;
 HEAP32[gb + 209148 >> 2] = fb + 882;
 HEAP32[gb + 209156 >> 2] = (HEAP32[gb + 209156 >> 2] | 0) + (gb + 10904 | 0);
 HEAP32[gb + 209160 >> 2] = fb + 3059;
 HEAP32[gb + 209164 >> 2] = fb + 3060;
 HEAP32[gb + 209168 >> 2] = fb + 1413;
 HEAP32[gb + 10904 >> 2] = (HEAP32[gb + 10904 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10908 >> 2] = (HEAP32[gb + 10908 >> 2] | 0) + (gb + 1077675 | 0);
 HEAP32[gb + 10912 >> 2] = (HEAP32[gb + 10912 >> 2] | 0) + (gb + 12920 | 0);
 HEAP32[gb + 209284 >> 2] = (HEAP32[gb + 209284 >> 2] | 0) + (gb + 10920 | 0);
 HEAP32[gb + 209288 >> 2] = fb + 3029;
 HEAP32[gb + 209292 >> 2] = fb + 3061;
 HEAP32[gb + 209296 >> 2] = fb + 1414;
 HEAP32[gb + 209300 >> 2] = fb + 471;
 HEAP32[gb + 209304 >> 2] = fb + 300;
 HEAP32[gb + 209308 >> 2] = fb + 301;
 HEAP32[gb + 209312 >> 2] = fb + 473;
 HEAP32[gb + 10920 >> 2] = (HEAP32[gb + 10920 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10924 >> 2] = (HEAP32[gb + 10924 >> 2] | 0) + (gb + 1077746 | 0);
 HEAP32[gb + 10928 >> 2] = (HEAP32[gb + 10928 >> 2] | 0) + (gb + 12936 | 0);
 HEAP32[gb + 209320 >> 2] = (HEAP32[gb + 209320 >> 2] | 0) + (gb + 10936 | 0);
 HEAP32[gb + 209324 >> 2] = fb + 3039;
 HEAP32[gb + 209328 >> 2] = fb + 3062;
 HEAP32[gb + 209332 >> 2] = fb + 2296;
 HEAP32[gb + 209336 >> 2] = fb + 302;
 HEAP32[gb + 209340 >> 2] = fb + 144;
 HEAP32[gb + 209344 >> 2] = fb + 177;
 HEAP32[gb + 209348 >> 2] = fb + 1415;
 HEAP32[gb + 209352 >> 2] = fb + 1410;
 HEAP32[gb + 209356 >> 2] = fb + 303;
 HEAP32[gb + 209360 >> 2] = fb + 1411;
 HEAP32[gb + 209364 >> 2] = fb + 1412;
 HEAP32[gb + 209368 >> 2] = fb + 478;
 HEAP32[gb + 209372 >> 2] = fb + 305;
 HEAP32[gb + 209376 >> 2] = fb + 480;
 HEAP32[gb + 10936 >> 2] = (HEAP32[gb + 10936 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10940 >> 2] = (HEAP32[gb + 10940 >> 2] | 0) + (gb + 1077793 | 0);
 HEAP32[gb + 10944 >> 2] = (HEAP32[gb + 10944 >> 2] | 0) + (gb + 10768 | 0);
 HEAP32[gb + 209384 >> 2] = (HEAP32[gb + 209384 >> 2] | 0) + (gb + 10952 | 0);
 HEAP32[gb + 209388 >> 2] = fb + 3037;
 HEAP32[gb + 209392 >> 2] = fb + 3063;
 HEAP32[gb + 209396 >> 2] = fb + 2297;
 HEAP32[gb + 209400 >> 2] = fb + 96;
 runPostSets229();
}

function __ZN13SplatDatabase12GetAlphamapsER13dynamic_arrayIhLj1EEb(i16, i23, i1) {
 i16 = i16 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 24 | 0;
 i11 = i22 + 16 | 0;
 i10 = i22 + 8 | 0;
 i9 = i22;
 i17 = i22 + 40 | 0;
 i18 = i22 + 28 | 0;
 i19 = i16 + 12 | 0;
 i20 = i16 + 16 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) i1 = i16 + 36 | 0; else {
  i5 = i16 + 32 | 0;
  i6 = i17 + 11 | 0;
  i1 = i16 + 36 | 0;
  i7 = i17 + 11 | 0;
  i8 = i17 + 11 | 0;
  i4 = 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i2 + (i4 << 2) >> 2];
   i3 = __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i17) | 0;
   do if (!i3) {
    HEAP32[i9 >> 2] = i4;
    __Z6FormatPKcz(i17, gb + 930934 | 0, i9);
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 930755 | 0, 539, 1, i2, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   } else {
    i15 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
    if ((i15 | 0) != (HEAP32[i1 >> 2] | 0)) if (!i4) {
     HEAP32[i10 >> 2] = 0;
     __Z6FormatPKcz(i17, gb + 930968 | 0, i10);
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 930755 | 0, 547, 512, i2, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
     HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
     break;
    } else {
     HEAP32[i11 >> 2] = i4;
     __Z6FormatPKcz(i17, gb + 931083 | 0, i11);
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 930755 | 0, 552, 1, i2, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
     break;
    }
   } while (0);
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i19 >> 2] | 0;
  } while (i4 >>> 0 < (HEAP32[i20 >> 2] | 0) - i2 >> 2 >>> 0);
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i14 = Math_imul(i13, i13) | 0;
 i15 = ((HEAP32[i16 + 4 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) / 44 | 0;
 i1 = Math_imul(i15, i14) | 0;
 i2 = i23 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i23 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1, 1, i23 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i23 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i23 >> 2] = i12;
  break;
 } while (0);
 HEAP32[i17 >> 2] = 0;
 i11 = i17 + 4 | 0;
 i9 = gb + 63160 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = i10;
 i12 = i14 << 2;
 do if (!i12) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i12 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 4, gb + 64016 | 0, 0, gb + 930755 | 0, 564) | 0;
   i10 = gb + 64016 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i17 >> 2] = i2;
   i1 = i11;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 4 >> 2] = i10;
   i1 = i2;
   break;
  }
 } while (0);
 i10 = i1 + 3 & -4;
 i1 = HEAP32[i19 >> 2] | 0;
 if ((HEAP32[i20 >> 2] | 0) == (i1 | 0)) {
  i24 = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, i11);
  STACKTOP = i22;
  return;
 }
 i7 = i16 + 32 | 0;
 i8 = i18 + 11 | 0;
 i9 = (i14 | 0) != 0;
 i6 = 0;
 do {
  i2 = i6 << 2;
  i3 = i15 - i2 | 0;
  i5 = (i3 | 0) > 4 ? 4 : i3;
  HEAP32[i18 >> 2] = HEAP32[i1 + (i6 << 2) >> 2];
  i1 = __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i18) | 0;
  if (!i1) i24 = 33; else if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) == (i13 | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) == (i13 | 0)) __ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i(i1, 0, i10, i14) | 0; else i24 = 33; else i24 = 33;
  if ((i24 | 0) == 33) {
   i24 = 0;
   HEAP32[i21 >> 2] = i6;
   __Z6FormatPKcz(i18, gb + 931164 | 0, i21);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 930755 | 0, 577, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   _memset(i10 | 0, 0, i12 | 0) | 0;
  }
  if (i9 & (i3 | 0) > 0) {
   i4 = 0;
   while (1) {
    i3 = i10 + (i4 << 2) | 0;
    i1 = 0;
    do {
     HEAP8[(HEAP32[i23 >> 2] | 0) + (i1 + i2) >> 0] = HEAP8[i3 + i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i5 | 0));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (i14 | 0)) break; else i2 = i2 + i15 | 0;
   }
  }
  i6 = i6 + 1 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
 } while (i6 >>> 0 < (HEAP32[i20 >> 2] | 0) - i1 >> 2 >>> 0);
 i24 = HEAP32[i17 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i11);
 STACKTOP = i22;
 return;
}

function __Z28GetSplashScreenBackgroundUvsRK5RectTIfE(i15, i10) {
 i15 = i15 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i9 = (__Z17GetPlayerSettingsv() | 0) + 144 | 0;
 i8 = __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv(i9) | 0;
 if (!i8) i1 = 0; else {
  HEAP32[i13 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
    i3 = HEAP32[i12 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 9;
   }
  }
  if ((i14 | 0) == 7) i14 = 9;
  if ((i14 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
  i1 = (i1 | 0) != 0;
 }
 i11 = __Z16GetScreenManagerv() | 0;
 f7 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 80 >> 2] | 0, i11 | 0) | 0);
 if (i1 & f7 < Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i11 | 0) | 0)) f5 = Math_fround(__ZNK26PlayerSettingsSplashScreen39GetSplashScreenBackgroundPortraitAspectEv(i9)); else f5 = Math_fround(__ZNK26PlayerSettingsSplashScreen40GetSplashScreenBackgroundLandscapeAspectEv(i9));
 i11 = i10 + 8 | 0;
 f7 = Math_fround(HEAPF32[i11 >> 2]);
 i10 = i10 + 12 | 0;
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f6 = Math_fround(f5 * f2);
 if (f6 < f7) {
  f5 = Math_fround(f7 / f5);
  f5 = Math_fround(Math_fround(Math_fround(.5) - Math_fround(Math_fround(.5) - Math_fround(Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f5 - f2) / f5)) * Math_fround(.5)))) * Math_fround(2.0));
  f2 = Math_fround(1.0);
 } else {
  f5 = Math_fround(1.0);
  f2 = Math_fround(Math_fround(Math_fround(.5) - Math_fround(Math_fround(.5) - Math_fround(Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f6 - f7) / f6)) * Math_fround(.5)))) * Math_fround(2.0));
 }
 i9 = (__Z17GetPlayerSettingsv() | 0) + 144 | 0;
 i8 = __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv(i9) | 0;
 if (!i8) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  i1 = i15;
 } else {
  HEAP32[i13 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 24; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
    i3 = HEAP32[i12 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 24; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 26;
   }
  }
  if ((i14 | 0) == 24) i14 = 26;
  if ((i14 | 0) == 26) i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  f7 = Math_fround(HEAPF32[i11 >> 2]);
  if (i1 | 0 ? f7 < Math_fround(HEAPF32[i10 >> 2]) : 0) {
   i12 = __ZN26PlayerSettingsSplashScreen36GetSplashScreenBackgroundPortraitUvsEv(i9) | 0;
   HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i12 = i15 + 8 | 0;
   f18 = Math_fround(HEAPF32[i12 >> 2]);
   f2 = Math_fround(f2 * f18);
   i14 = i15 + 12 | 0;
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f7 = Math_fround(f5 * f6);
   f17 = Math_fround(HEAPF32[i15 >> 2]);
   f5 = Math_fround(f18 - f2);
   f5 = Math_fround(f5 * Math_fround(.5));
   f5 = Math_fround(f17 + f5);
   i13 = i15 + 4 | 0;
   f17 = Math_fround(HEAPF32[i13 >> 2]);
   f6 = Math_fround(f6 - f7);
   f6 = Math_fround(f6 * Math_fround(.5));
   f6 = Math_fround(f17 + f6);
   HEAPF32[i15 >> 2] = f5;
   HEAPF32[i12 >> 2] = f2;
   HEAPF32[i13 >> 2] = f6;
   HEAPF32[i14 >> 2] = f7;
   STACKTOP = i16;
   return;
  } else i1 = i15;
 }
 i12 = __ZN26PlayerSettingsSplashScreen37GetSplashScreenBackgroundLandscapeUvsEv(i9) | 0;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i12 = i15 + 8 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f2 * f6);
 i14 = i15 + 12 | 0;
 f17 = Math_fround(HEAPF32[i14 >> 2]);
 f18 = Math_fround(f5 * f17);
 f5 = Math_fround(HEAPF32[i15 >> 2]);
 f6 = Math_fround(f6 - f7);
 f6 = Math_fround(f6 * Math_fround(.5));
 f6 = Math_fround(f5 + f6);
 i13 = i15 + 4 | 0;
 f5 = Math_fround(HEAPF32[i13 >> 2]);
 f17 = Math_fround(f17 - f18);
 f17 = Math_fround(f17 * Math_fround(.5));
 f17 = Math_fround(f5 + f17);
 HEAPF32[i15 >> 2] = f6;
 HEAPF32[i12 >> 2] = f7;
 HEAPF32[i13 >> 2] = f17;
 HEAPF32[i14 >> 2] = f18;
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i7;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i8 + 8 | 0, i7 + 8 | 0);
 HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 __ZN13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEC2ERKS2_(i8 + 32 | 0, i7 + 32 | 0);
 HEAP32[i8 + 52 >> 2] = HEAP32[i7 + 52 >> 2];
 __ZN13dynamic_arrayItLj2EEC2ERKS0_(i8 + 56 | 0, i7 + 56 | 0);
 i1 = i8 + 76 | 0;
 i2 = i7 + 76 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i1 = i8 + 108 | 0;
 i2 = i7 + 108 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 112 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 116 >> 2] = 0;
 i4 = i7 + 112 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 36 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 116 >> 2] = i5 + (i6 * 36 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i8 + 120 | 0;
 i2 = i7 + 120 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 128 >> 2] = 0;
 i4 = i7 + 124 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 36 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 128 >> 2] = i5 + (i6 * 36 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i8 + 132 | 0;
 i2 = i7 + 132 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 136 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = 0;
 i4 = i7 + 136 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 >> 5;
 if (i6 | 0) {
  if (i6 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 140 >> 2] = i5 + (i6 << 5);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i8 + 144 | 0;
 i2 = i7 + 144 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 148 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 152 >> 2] = 0;
 i4 = i7 + 148 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 28 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 152 >> 2] = i5 + (i6 * 28 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i8 + 156 | 0;
 i2 = i7 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 160 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 164 >> 2] = 0;
 i4 = i7 + 160 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 24 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 164 >> 2] = i5 + (i6 * 24 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i2 = i8 + 168 | 0;
 i3 = i7 + 168 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 172 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 176 >> 2] = 0;
 i5 = i7 + 172 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 48 | 0;
 if (i1 | 0) {
  if (i4 >>> 0 > 89478485) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i1 = __Znwj(i1) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 + 176 >> 2] = i1 + (i4 * 48 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i1, i2);
   i2 = i2 + 48 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + 48 | 0;
   HEAP32[i6 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
 }
 i4 = i8 + 180 | 0;
 i5 = i7 + 180 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i8 + 184 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 188 >> 2] = 0;
 i1 = i7 + 184 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i3 = (i2 | 0) / 24 | 0;
 if (!i2) return;
 if (i3 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i7 = __Znwj(i2) | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i8 + 188 >> 2] = i7 + (i3 * 24 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i4, HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3);
 return;
}

function __ZN5physx3Cct15ObstacleContext14removeObstacleEj(i19, i18) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i5 = i18 & 65535;
 i15 = HEAP32[i19 + 36 >> 2] | 0;
 if (i5 >>> 0 >= i15 >>> 0) {
  i19 = 0;
  return i19 | 0;
 }
 i10 = i19 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP16[i1 + (i5 << 1) >> 1] | 0;
 i12 = i11 & 65535;
 if (!(i11 << 16 >> 16 != -1 & i12 >>> 0 < i15 >>> 0)) {
  i19 = 0;
  return i19 | 0;
 }
 i7 = i19 + 48 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 if ((HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0) != (i18 >>> 16 | 0)) {
  i19 = 0;
  return i19 | 0;
 }
 i14 = i19 + 28 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 i9 = i8 + (i12 << 2) | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 if (!i16) {
  i19 = 0;
  return i19 | 0;
 }
 i13 = i16;
 i17 = i13 >>> 16;
 switch (i13 & 65535 | 0) {
 case 4:
  {
   i13 = i19 + 8 | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i17 >>> 0 >= i4 >>> 0) {
    i19 = 0;
    return i19 | 0;
   }
   i2 = i19 + 32 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    i6 = i3 + -1 | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 >> 2] = HEAP32[i8 + (i6 << 2) >> 2];
    i9 = HEAP32[i19 + 44 >> 2] | 0;
    i6 = i9 + (i6 << 1) | 0;
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP16[i1 + ((HEAPU16[i6 >> 1] | 0) << 1) >> 1] = i11;
    HEAP16[i9 + (i12 << 1) >> 1] = HEAP16[i6 >> 1] | 0;
    HEAP16[i6 >> 1] = i18;
    HEAP16[i1 + (i5 << 1) >> 1] = -1;
    i6 = i19 + 52 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    i6 = HEAP32[i7 >> 2] | 0;
    i12 = i6 + (i5 << 1) | 0;
    HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
   }
   i3 = i4 + -1 | 0;
   i2 = i19 + 4 | 0;
   if ((i3 | 0) != (i17 | 0)) {
    i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 * 72 | 0) >> 2] | 0;
    i5 = i4 & 65535;
    if (i5 >>> 0 < i15 >>> 0) {
     i12 = HEAP16[i1 + (i5 << 1) >> 1] | 0;
     i1 = i12 & 65535;
     if (i12 << 16 >> 16 != -1 & i1 >>> 0 < i15 >>> 0) if ((HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0) == (i4 >>> 16 | 0)) HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] = i16;
    }
   }
   i16 = HEAP32[i2 >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   HEAP32[i16 + (i17 * 72 | 0) >> 2] = HEAP32[i16 + (i3 * 72 | 0) >> 2];
   i15 = i16 + (i17 * 72 | 0) + 8 | 0;
   i14 = i16 + (i3 * 72 | 0) + 8 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i15 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i15 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
   HEAP32[i15 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 40 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 40 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 44 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 44 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 48 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 48 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 52 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 52 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 56 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 56 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 60 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 60 >> 2];
   HEAP32[i16 + (i17 * 72 | 0) + 64 >> 2] = HEAP32[i16 + (i3 * 72 | 0) + 64 >> 2];
   __ZNK5physx3Cct26CharacterControllerManager17onObstacleRemovedEj(HEAP32[i19 + 56 >> 2] | 0, i18);
   i19 = 1;
   return i19 | 0;
  }
 case 3:
  {
   i13 = i19 + 20 | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i17 >>> 0 >= i4 >>> 0) {
    i19 = 0;
    return i19 | 0;
   }
   i2 = i19 + 32 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    i6 = i3 + -1 | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 >> 2] = HEAP32[i8 + (i6 << 2) >> 2];
    i9 = HEAP32[i19 + 44 >> 2] | 0;
    i6 = i9 + (i6 << 1) | 0;
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP16[i1 + ((HEAPU16[i6 >> 1] | 0) << 1) >> 1] = i11;
    HEAP16[i9 + (i12 << 1) >> 1] = HEAP16[i6 >> 1] | 0;
    HEAP16[i6 >> 1] = i18;
    HEAP16[i1 + (i5 << 1) >> 1] = -1;
    i6 = i19 + 52 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    i6 = HEAP32[i7 >> 2] | 0;
    i12 = i6 + (i5 << 1) | 0;
    HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
   }
   i3 = i4 + -1 | 0;
   i2 = i19 + 16 | 0;
   if ((i3 | 0) != (i17 | 0)) {
    i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 6) >> 2] | 0;
    i5 = i4 & 65535;
    if (i5 >>> 0 < i15 >>> 0) {
     i12 = HEAP16[i1 + (i5 << 1) >> 1] | 0;
     i1 = i12 & 65535;
     if (i12 << 16 >> 16 != -1 & i1 >>> 0 < i15 >>> 0) if ((HEAPU16[i6 + (i5 << 1) >> 1] | 0 | 0) == (i4 >>> 16 | 0)) HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] = i16;
    }
   }
   i14 = HEAP32[i2 >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   HEAP32[i14 + (i17 << 6) >> 2] = HEAP32[i14 + (i3 << 6) >> 2];
   i15 = i14 + (i17 << 6) + 8 | 0;
   i16 = i14 + (i3 << 6) + 8 | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
   HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
   HEAP32[i15 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
   HEAP32[i15 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
   HEAP32[i14 + (i17 << 6) + 40 >> 2] = HEAP32[i14 + (i3 << 6) + 40 >> 2];
   HEAP32[i14 + (i17 << 6) + 44 >> 2] = HEAP32[i14 + (i3 << 6) + 44 >> 2];
   HEAP32[i14 + (i17 << 6) + 48 >> 2] = HEAP32[i14 + (i3 << 6) + 48 >> 2];
   HEAP32[i14 + (i17 << 6) + 52 >> 2] = HEAP32[i14 + (i3 << 6) + 52 >> 2];
   i15 = i14 + (i3 << 6) + 56 | 0;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i14 + (i17 << 6) + 56 | 0;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   __ZNK5physx3Cct26CharacterControllerManager17onObstacleRemovedEj(HEAP32[i19 + 56 >> 2] | 0, i18);
   i19 = 1;
   return i19 | 0;
  }
 default:
  {
   i19 = 0;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZN17ProceduralTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431722 | 0, gb + 431742 | 0, i3, 0);
 i7 = i5 + 8 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i3, 1);
 i3 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37296 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431767 | 0, i7, i1 + 192 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 156 | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 773725 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 i9 = i1 + 164 | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431789 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431801 | 0, i7, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431818 | 0, i7, i1 + 180 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431841 | 0, i7, i1 + 181 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431865 | 0, i6, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 176 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 673385 | 0, i7, i5, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i9;
 if (i9 >>> 0 > 3) HEAP32[i6 >> 2] = 0;
 i9 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i9, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431911 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 104 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i8 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431923 | 0, gb + 431941 | 0, i9, 0);
 __ZN17ProceduralTexture17TextureParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 88 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431959 | 0, gb + 431941 | 0, i9, 0);
 __ZN17ProceduralTexture17TextureParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431979 | 0, i7, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932818 | 0, i7, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i8;
 return;
}

function __ZN13b2DynamicTree10InsertLeafEi(i22, i21) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i23 = 0, i24 = 0;
 i1 = i22 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i22 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i22 >> 2] = i21;
  HEAP32[(HEAP32[i22 + 4 >> 2] | 0) + (i21 * 36 | 0) + 20 >> 2] = -1;
  return;
 }
 i23 = i22 + 4 | 0;
 i4 = HEAP32[i23 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i4 + (i21 * 36 | 0) >> 2]);
 f20 = Math_fround(HEAPF32[i4 + (i21 * 36 | 0) + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + (i21 * 36 | 0) + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + (i21 * 36 | 0) + 12 >> 2]);
 i2 = HEAP32[i4 + (i1 * 36 | 0) + 24 >> 2] | 0;
 L5 : do if ((i2 | 0) == -1) i5 = i1; else while (1) {
  i3 = HEAP32[i4 + (i1 * 36 | 0) + 28 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i4 + (i1 * 36 | 0) + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + (i1 * 36 | 0) >> 2]);
  f15 = Math_fround(f8 - f7);
  f16 = Math_fround(HEAPF32[i4 + (i1 * 36 | 0) + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i4 + (i1 * 36 | 0) + 4 >> 2]);
  f15 = Math_fround(Math_fround(f15 + Math_fround(f16 - f6)) * Math_fround(2.0));
  f6 = Math_fround(Math_fround(Math_fround((f8 > f18 ? f8 : f18) - (f7 < f17 ? f7 : f17)) + Math_fround((f16 > f19 ? f16 : f19) - (f6 < f20 ? f6 : f20))) * Math_fround(2.0));
  f16 = Math_fround(f6 * Math_fround(2.0));
  f15 = Math_fround(Math_fround(f6 - f15) * Math_fround(2.0));
  f6 = Math_fround(HEAPF32[i4 + (i2 * 36 | 0) >> 2]);
  f7 = f17 < f6 ? f17 : f6;
  f8 = Math_fround(HEAPF32[i4 + (i2 * 36 | 0) + 4 >> 2]);
  f9 = f20 < f8 ? f20 : f8;
  f10 = Math_fround(HEAPF32[i4 + (i2 * 36 | 0) + 8 >> 2]);
  f11 = f18 > f10 ? f18 : f10;
  f12 = Math_fround(HEAPF32[i4 + (i2 * 36 | 0) + 12 >> 2]);
  f13 = f19 > f12 ? f19 : f12;
  if ((HEAP32[i4 + (i2 * 36 | 0) + 24 >> 2] | 0) == -1) f6 = Math_fround(Math_fround(Math_fround(f11 - f7) + Math_fround(f13 - f9)) * Math_fround(2.0)); else f6 = Math_fround(Math_fround(Math_fround(Math_fround(f11 - f7) + Math_fround(f13 - f9)) * Math_fround(2.0)) - Math_fround(Math_fround(Math_fround(f10 - f6) + Math_fround(f12 - f8)) * Math_fround(2.0)));
  f14 = Math_fround(f15 + f6);
  f6 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) >> 2]);
  f7 = f17 < f6 ? f17 : f6;
  f8 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 4 >> 2]);
  f9 = f20 < f8 ? f20 : f8;
  f10 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 8 >> 2]);
  f11 = f18 > f10 ? f18 : f10;
  f12 = Math_fround(HEAPF32[i4 + (i3 * 36 | 0) + 12 >> 2]);
  f13 = f19 > f12 ? f19 : f12;
  if ((HEAP32[i4 + (i3 * 36 | 0) + 24 >> 2] | 0) == -1) f6 = Math_fround(Math_fround(Math_fround(f11 - f7) + Math_fround(f13 - f9)) * Math_fround(2.0)); else f6 = Math_fround(Math_fround(Math_fround(Math_fround(f11 - f7) + Math_fround(f13 - f9)) * Math_fround(2.0)) - Math_fround(Math_fround(Math_fround(f10 - f6) + Math_fround(f12 - f8)) * Math_fround(2.0)));
  f6 = Math_fround(f15 + f6);
  if (f16 < f14 & f16 < f6) {
   i5 = i1;
   break L5;
  }
  i1 = f14 < f6 ? i2 : i3;
  i2 = HEAP32[i4 + (i1 * 36 | 0) + 24 >> 2] | 0;
  if ((i2 | 0) == -1) {
   i5 = i1;
   break;
  }
 } while (0);
 i4 = HEAP32[i4 + (i5 * 36 | 0) + 20 >> 2] | 0;
 i1 = __ZN13b2DynamicTree12AllocateNodeEv(i22) | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 HEAP32[i2 + (i1 * 36 | 0) + 20 >> 2] = i4;
 HEAP32[i2 + (i1 * 36 | 0) + 16 >> 2] = 0;
 f15 = Math_fround(HEAPF32[i2 + (i5 * 36 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i2 + (i5 * 36 | 0) + 4 >> 2]);
 HEAPF32[i2 + (i1 * 36 | 0) >> 2] = f17 < f15 ? f17 : f15;
 HEAPF32[i2 + (i1 * 36 | 0) + 4 >> 2] = f20 < f16 ? f20 : f16;
 f17 = Math_fround(HEAPF32[i2 + (i5 * 36 | 0) + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + (i5 * 36 | 0) + 12 >> 2]);
 HEAPF32[i2 + (i1 * 36 | 0) + 8 >> 2] = f18 > f17 ? f18 : f17;
 HEAPF32[i2 + (i1 * 36 | 0) + 12 >> 2] = f19 > f20 ? f19 : f20;
 i2 = HEAP32[i23 >> 2] | 0;
 HEAP32[i2 + (i1 * 36 | 0) + 32 >> 2] = (HEAP32[i2 + (i5 * 36 | 0) + 32 >> 2] | 0) + 1;
 if ((i4 | 0) == -1) {
  HEAP32[i2 + (i1 * 36 | 0) + 24 >> 2] = i5;
  HEAP32[i2 + (i1 * 36 | 0) + 28 >> 2] = i21;
  HEAP32[i2 + (i5 * 36 | 0) + 20 >> 2] = i1;
  i21 = i2 + (i21 * 36 | 0) + 20 | 0;
  HEAP32[i21 >> 2] = i1;
  HEAP32[i22 >> 2] = i1;
  i1 = HEAP32[i21 >> 2] | 0;
 } else {
  i3 = i2 + (i4 * 36 | 0) + 24 | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) HEAP32[i3 >> 2] = i1; else HEAP32[i2 + (i4 * 36 | 0) + 28 >> 2] = i1;
  HEAP32[i2 + (i1 * 36 | 0) + 24 >> 2] = i5;
  HEAP32[i2 + (i1 * 36 | 0) + 28 >> 2] = i21;
  HEAP32[i2 + (i5 * 36 | 0) + 20 >> 2] = i1;
  HEAP32[i2 + (i21 * 36 | 0) + 20 >> 2] = i1;
 }
 if ((i1 | 0) == -1) return;
 do {
  i21 = __ZN13b2DynamicTree7BalanceEi(i22, i1) | 0;
  i5 = HEAP32[i23 >> 2] | 0;
  i3 = HEAP32[i5 + (i21 * 36 | 0) + 24 >> 2] | 0;
  i4 = HEAP32[i5 + (i21 * 36 | 0) + 28 >> 2] | 0;
  i24 = HEAP32[i5 + (i3 * 36 | 0) + 32 >> 2] | 0;
  i2 = HEAP32[i5 + (i4 * 36 | 0) + 32 >> 2] | 0;
  HEAP32[i5 + (i21 * 36 | 0) + 32 >> 2] = ((i24 | 0) > (i2 | 0) ? i24 : i2) + 1;
  f20 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) >> 2]);
  f19 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 4 >> 2]);
  HEAPF32[i5 + (i21 * 36 | 0) >> 2] = f20 < f19 ? f20 : f19;
  HEAPF32[i5 + (i21 * 36 | 0) + 4 >> 2] = f18 < f17 ? f18 : f17;
  f17 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 12 >> 2]);
  HEAPF32[i5 + (i21 * 36 | 0) + 8 >> 2] = f17 > f18 ? f17 : f18;
  HEAPF32[i5 + (i21 * 36 | 0) + 12 >> 2] = f19 > f20 ? f19 : f20;
  i1 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i21 * 36 | 0) + 20 >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fE16collideParticlesEPKjjS5_jj(i32, i10, i5, i29, i8, i28) {
 i32 = i32 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i29 = i29 | 0;
 i8 = i8 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i33 + 20 | 0;
 i31 = i33;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 & 65535;
 i4 = i4 >>> 0 > i28 >>> 0 ? i28 : i4;
 i27 = i2 + i28 | 0;
 i7 = i2 | 65535;
 i7 = i27 >>> 0 < i7 >>> 0 ? i27 : i7;
 HEAP32[i30 >> 2] = i10;
 if (i2 >>> 0 < i7 >>> 0) {
  i1 = i10;
  do {
   i1 = i1 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
  } while (i3 >>> 0 < i7 >>> 0);
  i9 = i1;
 } else {
  i3 = i2;
  i9 = i10;
 }
 i6 = i2 - i4 | 0;
 HEAP32[i31 >> 2] = i9;
 i4 = i6 + 65536 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  i1 = i9;
  do {
   i1 = i1 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 } else i1 = i9;
 HEAP32[i30 + 4 >> 2] = i1;
 i4 = i7 + 65536 | 0;
 if (i3 >>> 0 < i4 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i4 >>> 0);
 HEAP32[i31 + 4 >> 2] = i1;
 i4 = i6 + 16711680 | 0;
 i1 = i10 + (i5 << 2) | 0;
 while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) i1 = i1 + 4 | 0; else break;
 }
 HEAP32[i30 + 8 >> 2] = i1;
 i4 = i7 + 16711680 | 0;
 if (i3 >>> 0 < i4 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i4 >>> 0);
 HEAP32[i31 + 8 >> 2] = i1;
 i4 = i6 + 16777216 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  i1 = i10;
  do {
   i1 = i1 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 } else {
  i3 = i2;
  i1 = i10;
 }
 HEAP32[i30 + 12 >> 2] = i1;
 i4 = i7 + 16777216 | 0;
 if (i3 >>> 0 < i4 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i4 >>> 0);
 HEAP32[i31 + 12 >> 2] = i1;
 i3 = i6 + 16842752 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i1 = i10;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else i1 = i10;
 HEAP32[i30 + 16 >> 2] = i1;
 i3 = i7 + 16842752 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i31 + 16 >> 2] = i1;
 i27 = i29 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i33;
  return;
 }
 i12 = i32 + 104 | 0;
 i13 = i32 + 80 | 0;
 i14 = i32 + 116 | 0;
 i15 = i32 + 84 | 0;
 i16 = i32 + 96 | 0;
 i17 = i32 + 108 | 0;
 i18 = i32 + 88 | 0;
 i19 = i32 + 4 | 0;
 i20 = i32 + 8 | 0;
 i21 = i32 + 12 | 0;
 i22 = i32 + 16 | 0;
 i23 = i32 + 20 | 0;
 i24 = i32 + 24 | 0;
 i25 = i32 + 28 | 0;
 i26 = i10;
 i1 = i10;
 i2 = i9;
 i3 = i29;
 while (1) {
  i9 = HEAP32[i3 >> 2] | 0;
  i11 = HEAP16[(HEAP32[i12 >> 2] | 0) + (i9 << 1) >> 1] | 0;
  HEAP16[i13 >> 1] = i11;
  i11 = i11 & 65535;
  HEAP32[i15 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + (i11 << 2) >> 2];
  i8 = HEAP32[i16 >> 2] | 0;
  i9 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  HEAP32[i18 >> 2] = i9;
  i10 = i8 + (i11 * 76 | 0) | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i32 >> 2] = HEAP32[i7 + (i9 << 4) >> 2];
  HEAP32[i19 >> 2] = HEAP32[i7 + (i9 << 4) + 4 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i7 + (i9 << 4) + 8 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i7 + (i9 << 4) + 12 >> 2];
  i11 = i8 + (i11 * 76 | 0) + 4 | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP32[i22 >> 2] = HEAP32[i8 + (i9 << 4) >> 2];
  HEAP32[i23 >> 2] = HEAP32[i8 + (i9 << 4) + 4 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i8 + (i9 << 4) + 8 >> 2];
  HEAP32[i25 >> 2] = HEAP32[i8 + (i9 << 4) + 12 >> 2];
  i9 = HEAP32[i1 >> 2] | 0;
  i8 = i9 & 65535;
  i8 = i9 - (i8 >>> 0 > i28 >>> 0 ? i28 : i8) | 0;
  i7 = i9 + i28 | 0;
  i9 = i9 | 65535;
  i9 = i7 >>> 0 < i9 >>> 0 ? i7 : i9;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < i9 >>> 0) {
   i1 = i2;
   do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i9 >>> 0);
   HEAP32[i31 >> 2] = i1;
  } else i1 = i2;
  i2 = i29 + (i1 - i26 >> 2 << 2) | 0;
  i3 = i3 + 4 | 0;
  if ((i3 | 0) == (i2 | 0)) i7 = 1; else {
   i1 = i3;
   do {
    __ZN5physx5cloth16SwInterCollisionI8Scalar4fE15collideParticleEj(i32, HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i7 = 1;
  }
  do {
   i5 = HEAP32[gb + 168536 + (i7 << 2) >> 2] | 0;
   i2 = i8 + i5 | 0;
   i4 = i30 + (i7 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i4 >> 2] = i1;
    i6 = i1;
   } else i6 = i1;
   i2 = i5 + i9 | 0;
   i4 = i31 + (i7 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i4 >> 2] = i1;
   }
   i5 = i1 - i26 >> 2;
   i2 = i29 + (i5 << 2) | 0;
   i1 = i6 - i26 >> 2;
   if ((i1 | 0) != (i5 | 0)) {
    i1 = i29 + (i1 << 2) | 0;
    do {
     __ZN5physx5cloth16SwInterCollisionI8Scalar4fE15collideParticleEj(i32, HEAP32[i1 >> 2] | 0);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 5);
  i1 = HEAP32[i18 >> 2] | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 + (i1 << 4) >> 2] = HEAP32[i32 >> 2];
  HEAP32[i10 + (i1 << 4) + 4 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i10 + (i1 << 4) + 8 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i10 + (i1 << 4) + 12 >> 2] = HEAP32[i21 >> 2];
  i1 = HEAP32[i18 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 + (i1 << 4) >> 2] = HEAP32[i22 >> 2];
  HEAP32[i11 + (i1 << 4) + 4 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i11 + (i1 << 4) + 8 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i11 + (i1 << 4) + 12 >> 2] = HEAP32[i25 >> 2];
  i1 = (HEAP32[i30 >> 2] | 0) + 4 | 0;
  HEAP32[i30 >> 2] = i1;
  if ((i3 | 0) == (i27 | 0)) break;
  i2 = HEAP32[i31 >> 2] | 0;
 }
 STACKTOP = i33;
 return;
}

function __ZN11AudioSource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 440 | 0, i7);
 __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 436 | 0, i7);
 i1 = i6 + 497 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 412 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 408 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 420 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 421 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 422 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 423 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 388 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 392 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 396 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 400 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 404 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
  i1 = i4;
 }
 i4 = i6 + 416 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i11 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i11;
  HEAP32[i8 >> 2] = i2;
  i3 = i1;
  i1 = i11;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i6 + 424 | 0;
 if ((i2 + 1 | 0) >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 425 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 426 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i11 = i6 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i11 = i6 + 300 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 36 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 212 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  i11 = i6 + 124 | 0;
  __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i10, i2, i1, i6, i4, i5) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i13 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, 472, gb + 775925 | 0, gb + 775936 | 0, 835) | 0;
 HEAP32[i13 >> 2] = gb + 149264 + 8;
 HEAP32[i13 + 4 >> 2] = gb + 149264 + 152;
 HEAP32[i13 + 8 >> 2] = i10;
 i11 = i13 + 12 | 0;
 i8 = i10;
 HEAP32[i13 + 16 >> 2] = i8;
 HEAP32[i13 + 20 >> 2] = gb + 776024;
 HEAP32[i11 >> 2] = gb + 148580 + 8;
 i12 = i13 + 24 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAPF32[i13 + 48 >> 2] = Math_fround(.75);
 HEAP32[i13 + 52 >> 2] = -1;
 HEAP32[i13 + 56 >> 2] = 0;
 HEAP32[i13 + 60 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, 64);
 i11 = i13 + 64 | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 + 68 >> 2] = 0;
 HEAP32[i13 + 76 >> 2] = i8;
 HEAP32[i13 + 80 >> 2] = gb + 776051;
 HEAP32[i13 + 84 >> 2] = 0;
 HEAP32[i13 + 88 >> 2] = 0;
 HEAP32[i13 + 92 >> 2] = 0;
 HEAP32[i13 + 72 >> 2] = gb + 148736 + 8;
 HEAP32[i13 + 96 >> 2] = gb + 149440 + 8;
 i12 = i13 + 100 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 + 104 >> 2] = i2;
 HEAP32[i13 + 112 >> 2] = i8;
 HEAP32[i13 + 116 >> 2] = gb + 776075;
 HEAP32[i13 + 120 >> 2] = 0;
 HEAP32[i13 + 124 >> 2] = 0;
 HEAP32[i13 + 128 >> 2] = 0;
 HEAP32[i13 + 108 >> 2] = gb + 149504 + 8;
 HEAP32[i13 + 136 >> 2] = i8;
 HEAP32[i13 + 140 >> 2] = gb + 776113;
 HEAP32[i13 + 144 >> 2] = 0;
 HEAP32[i13 + 148 >> 2] = 0;
 HEAP32[i13 + 152 >> 2] = 0;
 HEAP32[i13 + 132 >> 2] = gb + 148848 + 8;
 HEAP32[i13 + 160 >> 2] = i8;
 HEAP32[i13 + 164 >> 2] = gb + 776150;
 HEAP32[i13 + 168 >> 2] = 0;
 HEAP32[i13 + 172 >> 2] = 0;
 HEAP32[i13 + 176 >> 2] = 0;
 HEAP32[i13 + 156 >> 2] = gb + 148784 + 8;
 HEAP32[i13 + 184 >> 2] = i8;
 HEAP32[i13 + 188 >> 2] = gb + 776189;
 HEAP32[i13 + 192 >> 2] = 0;
 HEAP32[i13 + 196 >> 2] = 0;
 HEAP32[i13 + 200 >> 2] = 0;
 HEAP32[i13 + 180 >> 2] = gb + 149520 + 8;
 HEAP32[i13 + 204 >> 2] = 0;
 HEAP32[i13 + 208 >> 2] = i1;
 HEAP32[i13 + 216 >> 2] = i8;
 HEAP32[i13 + 220 >> 2] = gb + 776236;
 HEAP32[i13 + 224 >> 2] = 0;
 HEAP32[i13 + 228 >> 2] = 0;
 HEAP32[i13 + 232 >> 2] = 0;
 HEAP32[i13 + 212 >> 2] = gb + 148684 + 8;
 HEAP32[i13 + 236 >> 2] = gb + 148960 + 8;
 HEAP32[i13 + 240 >> 2] = gb + 1576256;
 HEAP32[i13 + 244 >> 2] = gb + 1576256;
 i2 = i13 + 248 | 0;
 i1 = i13 + 264 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 i2 = i1;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP16[i1 + 40 >> 1] = 0;
 HEAP32[i13 + 308 >> 2] = gb + 148944 + 8;
 HEAP32[i13 + 312 >> 2] = gb + 1576256;
 HEAP32[i13 + 316 >> 2] = gb + 1576256;
 HEAP32[i13 + 320 >> 2] = -1;
 HEAP32[i13 + 324 >> 2] = gb + 1576256;
 HEAP32[i13 + 328 >> 2] = gb + 1576256;
 HEAP32[i13 + 332 >> 2] = -1;
 i9 = i13 + 336 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i13 + 360 >> 2] = i8;
 HEAP32[i13 + 364 >> 2] = gb + 776276;
 HEAP32[i13 + 368 >> 2] = 0;
 HEAP32[i13 + 372 >> 2] = 0;
 HEAP32[i13 + 376 >> 2] = 0;
 HEAP32[i13 + 356 >> 2] = gb + 148684 + 8;
 HEAP32[i13 + 380 >> 2] = 0;
 HEAP32[i13 + 384 >> 2] = 0;
 i9 = i13 + 388 | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP8[i13 + 392 >> 0] = 1;
 i7 = i13 + 400 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP8[i13 + 408 >> 0] = 1;
 HEAP32[i13 + 416 >> 2] = i8;
 HEAP32[i13 + 420 >> 2] = gb + 776319;
 HEAP32[i13 + 424 >> 2] = 0;
 HEAP32[i13 + 428 >> 2] = 0;
 HEAP32[i13 + 432 >> 2] = 0;
 HEAP32[i13 + 412 >> 2] = gb + 149536 + 8;
 HEAP32[i13 + 436 >> 2] = i10;
 i7 = i13 + 440 | 0;
 HEAP32[i13 + 444 >> 2] = i8;
 HEAP32[i13 + 448 >> 2] = gb + 776368;
 i6 = i13 + 452 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i13 + 456 | 0;
 HEAP32[i3 >> 2] = 0;
 i8 = i13 + 460 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 149552 + 8;
 i4 = i13 + 464 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i13 + 468 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, 4096, gb + 776416 | 0, gb + 775936 | 0, 194) | 0;
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  i14 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i14;
  i14 = i14 + -1 | 0;
  HEAP32[i5 >> 2] = i14;
  HEAP32[i4 >> 2] = 0;
  i14 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  i11 = i11 + 8 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i14 | 0);
  i14 = HEAP32[i9 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  i11 = i11 + 8 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i14 | 0);
  HEAP32[i12 >> 2] = i13;
  STACKTOP = i15;
  return i13 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS2_(i7, i14) | 0;
  i14 = HEAP32[i3 >> 2] | 0;
  i14 = i14 + -1 | 0;
  HEAP32[i5 >> 2] = i14;
  HEAP32[i4 >> 2] = 0;
  i14 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  i11 = i11 + 8 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i14 | 0);
  i14 = HEAP32[i9 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  i11 = i11 + 8 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i14 | 0);
  HEAP32[i12 >> 2] = i13;
  STACKTOP = i15;
  return i13 | 0;
 }
 return 0;
}

function _UNITY_png_combine_row(i4, i15, i9) {
 i4 = i4 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i13 = HEAP8[i4 + 439 >> 0] | 0;
 i14 = i13 & 255;
 i16 = (HEAP32[i4 + 380 >> 2] | 0) + 1 | 0;
 i12 = HEAP32[i4 + 344 >> 2] | 0;
 i3 = HEAP8[i4 + 429 >> 0] | 0;
 i11 = i3 & 255;
 if (!(i13 << 24 >> 24)) _UNITY_png_error(i4, gb + 353674 | 0);
 i1 = HEAP32[i4 + 400 >> 2] | 0;
 if (i1 | 0) {
  if ((i13 & 255) > 7) i2 = Math_imul(i12, i14 >>> 3) | 0; else i2 = ((Math_imul(i12, i14) | 0) + 7 | 0) >>> 3;
  if ((i1 | 0) != (i2 | 0)) _UNITY_png_error(i4, gb + 353699 | 0);
 }
 if (!i12) _UNITY_png_error(i4, gb + 353735 | 0);
 i10 = Math_imul(i12, i14) | 0;
 i1 = i10 & 7;
 if (!i1) {
  i8 = 0;
  i6 = 0;
  i7 = 0;
 } else {
  i7 = Math_imul(i12, i14 >>> 3) | 0;
  i7 = i15 + ((i13 & 255) > 7 ? i7 : (i10 + 7 | 0) >>> 3) + -1 | 0;
  i8 = i7;
  i6 = 255 >>> i1;
  i7 = HEAP8[i7 >> 0] | 0;
 }
 L18 : do if (!(HEAP8[i4 + 428 >> 0] | 0)) i17 = 58; else if ((i3 & 255) < 6 ? (HEAP32[i4 + 212 >> 2] & 2 | 0) != 0 : 0) {
  switch (i9 | 0) {
  case 0:
   {
    i1 = i11 & 1;
    break;
   }
  case 1:
   {
    if (!(i11 & 1)) {
     i17 = 58;
     break L18;
    } else i1 = 1;
    break;
   }
  default:
   {
    i17 = 58;
    break L18;
   }
  }
  i1 = i1 << 3 - ((i11 + 1 | 0) >>> 1) & 7;
  if (i12 >>> 0 <= i1 >>> 0) return;
  if ((i13 & 255) < 8) {
   i5 = 8 / (i14 >>> 0) | 0;
   if (!i9) i1 = gb + 14768 + 72 + ((i13 << 24 >> 24 == 1 ? 0 : i13 << 24 >> 24 == 2 ? 1 : 2) * 24 | 0) + (i11 << 2) | 0; else i1 = gb + 14696 + 36 + ((i13 << 24 >> 24 == 1 ? 0 : i13 << 24 >> 24 == 2 ? 1 : 2) * 12 | 0) + (i11 >>> 1 << 2) | 0;
   i2 = i15;
   i3 = i16;
   i4 = i12;
   i1 = HEAP32[i1 >> 2] | 0;
   while (1) {
    switch ((i1 & 255) << 24 >> 24) {
    case 0:
     break;
    case -1:
     {
      HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
      break;
     }
    default:
     HEAP8[i2 >> 0] = HEAPU8[i3 >> 0] & i1 | HEAPU8[i2 >> 0] & (i1 ^ 255);
    }
    i1 = i1 >>> 8 | i1 << 24;
    if (i4 >>> 0 <= i5 >>> 0) break L18; else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
     i4 = i4 - i5 | 0;
    }
   }
  }
  if (i14 & 7 | 0) _UNITY_png_error(i4, gb + 353760 | 0);
  i7 = i14 >>> 3;
  i1 = Math_imul(i1, i7) | 0;
  i2 = (Math_imul(i12, i7) | 0) - i1 | 0;
  i3 = i15 + i1 | 0;
  i1 = i16 + i1 | 0;
  i4 = i7 << ((6 - i11 | 0) >>> 1);
  i4 = (i9 | 0) == 0 ? i7 : i4 >>> 0 > i2 >>> 0 ? i2 : i4;
  i7 = i7 << ((7 - i11 | 0) >>> 1);
  switch (i4 | 0) {
  case 1:
   {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    if (i2 >>> 0 <= i7 >>> 0) return;
    do {
     i3 = i3 + i7 | 0;
     i1 = i1 + i7 | 0;
     i2 = i2 - i7 | 0;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    } while (i2 >>> 0 > i7 >>> 0);
    return;
   }
  case 2:
   {
    do {
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + 1 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
     if (i2 >>> 0 <= i7 >>> 0) {
      i17 = 61;
      break;
     }
     i1 = i1 + i7 | 0;
     i3 = i3 + i7 | 0;
     i2 = i2 - i7 | 0;
    } while (i2 >>> 0 > 1);
    if ((i17 | 0) == 61) return;
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    return;
   }
  case 3:
   {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP8[i3 + 1 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
    HEAP8[i3 + 2 >> 0] = HEAP8[i1 + 2 >> 0] | 0;
    if (i2 >>> 0 <= i7 >>> 0) return;
    do {
     i1 = i1 + i7 | 0;
     i3 = i3 + i7 | 0;
     i2 = i2 - i7 | 0;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + 1 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
     HEAP8[i3 + 2 >> 0] = HEAP8[i1 + 2 >> 0] | 0;
    } while (i2 >>> 0 > i7 >>> 0);
    return;
   }
  default:
   {
    if (i4 >>> 0 < 16) {
     i5 = i3;
     if (!(i5 & 1)) {
      i6 = i1 | i7;
      if (!((i6 | i4) & 1)) if (!((i6 | i5 | i4) & 3)) {
       i6 = (i7 - i4 | 0) >>> 2;
       do {
        i5 = i4;
        do {
         i15 = i1;
         i1 = i1 + 4 | 0;
         i16 = i3;
         i3 = i3 + 4 | 0;
         HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
         i5 = i5 + -4 | 0;
        } while ((i5 | 0) != 0);
        i3 = i3 + (i6 << 2) | 0;
        i1 = i1 + (i6 << 2) | 0;
        i16 = i2;
        i2 = i2 - i7 | 0;
        if (i16 >>> 0 <= i7 >>> 0) {
         i17 = 61;
         break;
        }
       } while (i4 >>> 0 <= i2 >>> 0);
       if ((i17 | 0) == 61) return;
       while (1) {
        HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
        i2 = i2 + -1 | 0;
        if (!i2) break; else {
         i3 = i3 + 1 | 0;
         i1 = i1 + 1 | 0;
        }
       }
       return;
      } else {
       i6 = (i7 - i4 | 0) >>> 1;
       do {
        i5 = i4;
        do {
         i15 = i1;
         i1 = i1 + 2 | 0;
         i16 = i3;
         i3 = i3 + 2 | 0;
         HEAP16[i16 >> 1] = HEAP16[i15 >> 1] | 0;
         i5 = i5 + -2 | 0;
        } while ((i5 | 0) != 0);
        i3 = i3 + (i6 << 1) | 0;
        i1 = i1 + (i6 << 1) | 0;
        i16 = i2;
        i2 = i2 - i7 | 0;
        if (i16 >>> 0 <= i7 >>> 0) {
         i17 = 61;
         break;
        }
       } while (i4 >>> 0 <= i2 >>> 0);
       if ((i17 | 0) == 61) return;
       while (1) {
        HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
        i2 = i2 + -1 | 0;
        if (!i2) break; else {
         i3 = i3 + 1 | 0;
         i1 = i1 + 1 | 0;
        }
       }
       return;
      }
     }
    }
    _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
    if (i2 >>> 0 <= i7 >>> 0) return;
    do {
     i1 = i1 + i7 | 0;
     i3 = i3 + i7 | 0;
     i2 = i2 - i7 | 0;
     i4 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
     _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
    } while (i2 >>> 0 > i7 >>> 0);
    return;
   }
  }
 } else i17 = 58; while (0);
 if ((i17 | 0) == 58) {
  i17 = Math_imul(i12, i14 >>> 3) | 0;
  _memcpy(i15 | 0, i16 | 0, ((i13 & 255) > 7 ? i17 : (i10 + 7 | 0) >>> 3) | 0) | 0;
 }
 if (!i8) return;
 HEAP8[i8 >> 0] = HEAPU8[i8 >> 0] & (i6 ^ 255) | i7 & 255 & i6;
 return;
}

function __ZN14VRSplashScreen19CreateSplashObjectsE4PPtrI9Texture2DEf(i9, i1, f3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 12 | 0;
 i11 = i13;
 i12 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 8 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 do if (!i1) i8 = 10; else {
  HEAP32[i11 >> 2] = i1;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i8 = 7; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i5 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i11);
    i5 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i5 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i5 << 3) | 0;
    i5 = HEAP32[i6 + 28 >> 2] | 0;
    i6 = HEAP32[i6 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i5 + (i6 << 3) | 0)) i8 = 7; else if (HEAP32[i2 + 4 >> 2] | 0) {
    i8 = 11;
    break;
   }
  }
  if (!(__Z31ReadObjectFromPersistentManageri(i1) | 0)) i8 = 10; else i8 = 11;
 } while (0);
 if ((i8 | 0) == 10) {
  i1 = HEAP32[(__Z17GetPlayerSettingsv() | 0) + 260 >> 2] | 0;
  if (!i1) i8 = 20; else i8 = 11;
 }
 do if ((i8 | 0) == 11) {
  HEAP32[i11 >> 2] = i1;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i8 = 16; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[i2 + 32 >> 2] | 0;
    i7 = i5 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i11);
    i7 = HEAP32[i10 >> 2] | 0;
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i7 = (i7 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i7 << 3) | 0;
    i2 = i6;
    i5 = HEAP32[i6 + 28 >> 2] | 0;
    i6 = HEAP32[i6 + 32 >> 2] | 0;
   }
   if ((i7 | 0) == (i5 + (i6 << 3) | 0)) i8 = 16; else if (!(HEAP32[i7 + 4 >> 2] | 0)) i8 = 18;
  }
  if ((i8 | 0) == 16) i8 = 18;
  if ((i8 | 0) == 18) {
   if (!(__Z31ReadObjectFromPersistentManageri(i1) | 0)) {
    i8 = 20;
    break;
   }
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i1;
  if (!i2) i8 = 26; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i5 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i11);
    i5 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i5 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i5 << 3) | 0;
    i5 = HEAP32[i6 + 28 >> 2] | 0;
    i6 = HEAP32[i6 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i5 + (i6 << 3) | 0)) i8 = 26; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (i2 | 0) {
     i1 = i2;
     break;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(i1) | 0;
  i8 = 29;
 } while (0);
 if ((i8 | 0) == 20) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1046259 | 0, 20);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 32032 | 0, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i8 = 29;
 }
 if ((i8 | 0) == 29) if (!i1) {
  STACKTOP = i13;
  return;
 }
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i8 = (i8 | 0) / (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) | 0;
 f4 = Math_fround(i8 | 0);
 i8 = (i8 | 0) > 1;
 f14 = Math_fround(Math_fround(1.0) / f4);
 f4 = i8 ? Math_fround(1.0) : f4;
 f14 = i8 ? f14 : Math_fround(1.0);
 i8 = __Z12GetIVRDevicev() | 0;
 i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 176 >> 2] | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(3.0);
 f4 = Math_fround(f4 * f3);
 f3 = Math_fround(f14 * f3);
 HEAPF32[i11 >> 2] = f4;
 HEAPF32[i11 + 4 >> 2] = f3;
 HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
 i8 = mftCall_iiiii(i7 | 0, i8 | 0, i1 | 0, i10 | 0, i11 | 0) | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i8) {
  i8 = HEAP32[i9 + 40 >> 2] | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i10 + 8 >> 2] = i8;
  HEAPF32[i11 >> 2] = Math_fround(f4 * Math_fround(.5));
  HEAPF32[i11 + 4 >> 2] = f3;
  HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
  __ZL16CreateSplashQuadR9Transform4PPtrI9Texture2DERK8Vector3fS6_(i12, i1, i10, i11);
  HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 4 >> 2] | 0, gb + 29832 | 0) | 0) + 824 >> 2] = 0;
  STACKTOP = i13;
  return;
 } else {
  i9 = HEAP32[i9 + 40 >> 2] | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i10 + 8 >> 2] = i9;
  HEAPF32[i11 >> 2] = f4;
  HEAPF32[i11 + 4 >> 2] = f3;
  HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
  __ZL16CreateSplashQuadR9Transform4PPtrI9Texture2DERK8Vector3fS6_(i12, i1, i10, i11);
  STACKTOP = i13;
  return;
 }
}

function __ZL23AddConflictingClassIMPL11ClassIDTypeS_(i11, i13) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 28 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 4 | 0;
 i17 = i18;
 if ((i11 | 0) == -1 | (i13 | 0) == -1) {
  STACKTOP = i18;
  return;
 }
 i1 = gb + 64016 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 i9 = i16 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i16 + 4 >> 2] = i3;
 HEAP32[i16 + 8 >> 2] = i1;
 __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(i11, i16, 0);
 i1 = HEAP32[gb + 1162548 >> 2] | 0;
 if (!(HEAP32[i9 >> 2] | 0)) i5 = i1; else {
  i8 = HEAP32[i16 >> 2] | 0;
  do {
   i6 = HEAP32[i8 >> 2] | 0;
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   do if (!i2) {
    HEAP32[i12 >> 2] = i3;
    i5 = i3;
    i4 = i3;
    i10 = 37;
   } else {
    while (1) {
     i3 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i6 | 0) < (i3 | 0)) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i10 = 30;
       break;
      } else i2 = i3;
     } else {
      if ((i3 | 0) >= (i6 | 0)) {
       i10 = 36;
       break;
      }
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i10 = 34;
       break;
      } else i2 = i3;
     }
    }
    if ((i10 | 0) == 30) {
     HEAP32[i12 >> 2] = i2;
     i5 = i2;
     i4 = i2;
     i10 = 37;
     break;
    } else if ((i10 | 0) == 34) {
     HEAP32[i12 >> 2] = i2;
     i5 = i2;
     i10 = 37;
     break;
    } else if ((i10 | 0) == 36) {
     i10 = 0;
     HEAP32[i12 >> 2] = i2;
     if (!i2) {
      i5 = i2;
      i4 = i12;
      i10 = 37;
      break;
     } else break;
    }
   } while (0);
   if ((i10 | 0) == 37) {
    i10 = 0;
    i2 = __Znwj(32) | 0;
    HEAP32[i2 + 16 >> 2] = i6;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i5;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    if (!i3) i3 = i2; else {
     HEAP32[i1 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i1 + 4 >> 2] | 0, i3);
    i7 = i1 + 8 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   i7 = i2 + 20 | 0;
   HEAP32[i17 >> 2] = i13;
   i5 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i2 + 24 >> 2] | 0;
   i1 = i6 - i5 >> 2;
   i2 = i5;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i19 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i19 << 2) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
     i4 = i4 + 4 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i19 | 0 : i19;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   i2 = i1;
   if ((i1 | 0) == (i6 | 0)) i10 = 44; else if ((HEAP32[i1 >> 2] | 0) > (i13 | 0)) i10 = 44;
   if ((i10 | 0) == 44) {
    HEAP32[i15 >> 2] = i2;
    HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
    __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i7, i12, i17) | 0;
   }
   i8 = i8 + 4 | 0;
   i1 = HEAP32[gb + 1162548 >> 2] | 0;
  } while ((i8 | 0) != ((HEAP32[i16 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
  i5 = i1;
 }
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i10 = 16;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i11 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i10 = 9;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i11 | 0)) {
     i10 = 15;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i10 = 13;
     break;
    } else i1 = i2;
   }
  }
  if ((i10 | 0) == 9) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   i10 = 16;
   break;
  } else if ((i10 | 0) == 13) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i10 = 16;
   break;
  } else if ((i10 | 0) == 15) {
   HEAP32[i12 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i3 = i12;
    i10 = 16;
    break;
   } else break;
  }
 } while (0);
 if ((i10 | 0) == 16) {
  i1 = __Znwj(32) | 0;
  HEAP32[i1 + 16 >> 2] = i11;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
  i19 = i5 + 8 | 0;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 }
 i7 = i1 + 20 | 0;
 HEAP32[i17 >> 2] = i13;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i19 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i19 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i19 | 0 : i19;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i6 | 0)) i10 = 23; else if ((HEAP32[i1 >> 2] | 0) > (i13 | 0)) i10 = 23;
 if ((i10 | 0) == 23) {
  HEAP32[i15 >> 2] = i2;
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i7, i12, i17) | 0;
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i16 + 4 | 0);
  HEAP32[i16 >> 2] = 0;
 }
 STACKTOP = i18;
 return;
}

function __Z26TransformVerticesInnerLoopILb1ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i4, i28, i29, i3, i6, i30, i2, i31, i7, i32, i5, i1) {
 i4 = i4 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i30 = i30 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 i7 = i7 | 0;
 i32 = i32 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i8 = (i5 | 0) / 4 | 0;
 i1 = i3 + -1 | 0;
 if (!i3) return;
 i9 = i28 + 16 | 0;
 i10 = i28 + 32 | 0;
 i11 = i28 + 48 | 0;
 i12 = i28 + 4 | 0;
 i13 = i28 + 20 | 0;
 i14 = i28 + 36 | 0;
 i15 = i28 + 52 | 0;
 i16 = i28 + 8 | 0;
 i17 = i28 + 24 | 0;
 i18 = i28 + 40 | 0;
 i19 = i28 + 56 | 0;
 i20 = i29 + 12 | 0;
 i21 = i29 + 24 | 0;
 i22 = i29 + 4 | 0;
 i23 = i29 + 16 | 0;
 i24 = i29 + 28 | 0;
 i25 = i29 + 8 | 0;
 i26 = i29 + 20 | 0;
 i27 = i29 + 32 | 0;
 if ((i5 | 0) > 3) {
  i2 = i4;
  i3 = i7;
 } else {
  i3 = i6;
  i2 = i7;
  while (1) {
   f33 = Math_fround(HEAPF32[i28 >> 2]);
   f33 = Math_fround(f33 * Math_fround(HEAPF32[i3 >> 2]));
   f34 = Math_fround(HEAPF32[i9 >> 2]);
   i7 = i3 + 4 | 0;
   f35 = Math_fround(HEAPF32[i7 >> 2]);
   f34 = Math_fround(f33 + Math_fround(f34 * f35));
   f33 = Math_fround(HEAPF32[i10 >> 2]);
   f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f33 = Math_fround(f34 + Math_fround(f33 * f36));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f33);
   f33 = Math_fround(HEAPF32[i12 >> 2]);
   f34 = Math_fround(HEAPF32[i3 >> 2]);
   f33 = Math_fround(f33 * f34);
   f35 = Math_fround(f33 + Math_fround(f35 * Math_fround(HEAPF32[i13 >> 2])));
   f35 = Math_fround(f35 + Math_fround(f36 * Math_fround(HEAPF32[i14 >> 2])));
   HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f35);
   f34 = Math_fround(f34 * Math_fround(HEAPF32[i16 >> 2]));
   f35 = Math_fround(HEAPF32[i17 >> 2]);
   f35 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i7 >> 2])));
   f36 = Math_fround(f35 + Math_fround(f36 * Math_fround(HEAPF32[i18 >> 2])));
   HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f36);
   i7 = i3 + i30 | 0;
   f36 = Math_fround(HEAPF32[i29 >> 2]);
   f36 = Math_fround(f36 * Math_fround(HEAPF32[i7 >> 2]));
   f35 = Math_fround(HEAPF32[i20 >> 2]);
   i8 = i7 + 4 | 0;
   f34 = Math_fround(HEAPF32[i8 >> 2]);
   f35 = Math_fround(f36 + Math_fround(f35 * f34));
   f36 = Math_fround(HEAPF32[i21 >> 2]);
   f33 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   HEAPF32[i4 + 12 >> 2] = Math_fround(f35 + Math_fround(f36 * f33));
   f36 = Math_fround(HEAPF32[i22 >> 2]);
   f35 = Math_fround(HEAPF32[i7 >> 2]);
   f36 = Math_fround(f36 * f35);
   f34 = Math_fround(f36 + Math_fround(f34 * Math_fround(HEAPF32[i23 >> 2])));
   HEAPF32[i4 + 16 >> 2] = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i24 >> 2])));
   f35 = Math_fround(f35 * Math_fround(HEAPF32[i25 >> 2]));
   f34 = Math_fround(HEAPF32[i26 >> 2]);
   f34 = Math_fround(f35 + Math_fround(f34 * Math_fround(HEAPF32[i8 >> 2])));
   HEAPF32[i4 + 20 >> 2] = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i27 >> 2])));
   if (!i1) break; else {
    i4 = i4 + 24 | 0;
    i3 = i3 + i31 | 0;
    i2 = (i2 | 0) == 0 ? 0 : i2 + i32 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  return;
 }
 while (1) {
  f36 = Math_fround(HEAPF32[i28 >> 2]);
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i6 >> 2]));
  f35 = Math_fround(HEAPF32[i9 >> 2]);
  i5 = i6 + 4 | 0;
  f34 = Math_fround(HEAPF32[i5 >> 2]);
  f35 = Math_fround(f36 + Math_fround(f35 * f34));
  f36 = Math_fround(HEAPF32[i10 >> 2]);
  f33 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f36 = Math_fround(f35 + Math_fround(f36 * f33));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f36);
  f36 = Math_fround(HEAPF32[i12 >> 2]);
  f35 = Math_fround(HEAPF32[i6 >> 2]);
  f36 = Math_fround(f36 * f35);
  f34 = Math_fround(f36 + Math_fround(f34 * Math_fround(HEAPF32[i13 >> 2])));
  f34 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f34);
  f35 = Math_fround(f35 * Math_fround(HEAPF32[i16 >> 2]));
  f34 = Math_fround(HEAPF32[i17 >> 2]);
  f34 = Math_fround(f35 + Math_fround(f34 * Math_fround(HEAPF32[i5 >> 2])));
  f33 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i18 >> 2])));
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f33);
  i5 = i6 + i30 | 0;
  f33 = Math_fround(HEAPF32[i29 >> 2]);
  f33 = Math_fround(f33 * Math_fround(HEAPF32[i5 >> 2]));
  f34 = Math_fround(HEAPF32[i20 >> 2]);
  i7 = i5 + 4 | 0;
  f35 = Math_fround(HEAPF32[i7 >> 2]);
  f34 = Math_fround(f33 + Math_fround(f34 * f35));
  f33 = Math_fround(HEAPF32[i21 >> 2]);
  f36 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  HEAPF32[i2 + 12 >> 2] = Math_fround(f34 + Math_fround(f33 * f36));
  f33 = Math_fround(HEAPF32[i22 >> 2]);
  f34 = Math_fround(HEAPF32[i5 >> 2]);
  f33 = Math_fround(f33 * f34);
  f35 = Math_fround(f33 + Math_fround(f35 * Math_fround(HEAPF32[i23 >> 2])));
  HEAPF32[i2 + 16 >> 2] = Math_fround(f35 + Math_fround(f36 * Math_fround(HEAPF32[i24 >> 2])));
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i25 >> 2]));
  f35 = Math_fround(HEAPF32[i26 >> 2]);
  f35 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i7 >> 2])));
  HEAPF32[i2 + 20 >> 2] = Math_fround(f35 + Math_fround(f36 * Math_fround(HEAPF32[i27 >> 2])));
  i2 = i2 + 24 | 0;
  if (!i3) i3 = 0; else {
   i4 = i3;
   i5 = 0;
   while (1) {
    i7 = i2;
    i2 = i2 + 4 | 0;
    HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i8 | 0)) break; else i4 = i4 + 4 | 0;
   }
   i3 = i3 + i32 | 0;
  }
  if (!i1) break; else {
   i6 = i6 + i31 | 0;
   i1 = i1 + -1 | 0;
  }
 }
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl25addRepXObjectToCollectionERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_23PxRepXInstantiationArgsE(i24, i26, i18, i17, i16) {
 i24 = i24 | 0;
 i26 = i26 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i27 + 24 | 0;
 i15 = i27 + 72 | 0;
 i19 = i27 + 48 | 0;
 i25 = i27 + 32 | 0;
 i21 = i27;
 i1 = i18 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i23 = i18 + 8 | 0;
  i22 = i23;
  if (!((HEAP32[i22 >> 2] | 0) == 0 & (HEAP32[i22 + 4 >> 2] | 0) == 0)) {
   i14 = HEAP32[i26 + 12 >> 2] | 0;
   i14 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0, HEAP32[i18 >> 2] | 0) | 0;
   if (!i14) {
    i26 = i24;
    HEAP32[i26 >> 2] = 0;
    HEAP32[i26 + 4 >> 2] = 0;
    HEAP32[i24 + 8 >> 2] = 1;
    STACKTOP = i27;
    return;
   }
   i22 = i26 + 24 | 0;
   i2 = HEAP32[i22 >> 2] | 0;
   L8 : do if (i2 | 0) {
    i4 = HEAP32[i26 + 20 >> 2] | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = 0;
    while (1) {
     if ((HEAP32[i4 + (i1 * 24 | 0) + 4 >> 2] | 0) == (i3 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break L8;
    }
    if (i3 | 0) {
     i23 = i4 + (i1 * 24 | 0) + 8 | 0;
     i25 = HEAP32[i23 + 4 >> 2] | 0;
     i26 = i24;
     HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i26 + 4 >> 2] = i25;
     HEAP32[i24 + 8 >> 2] = 3;
     STACKTOP = i27;
     return;
    }
   } while (0);
   i5 = HEAP32[i26 + 8 >> 2] | 0;
   HEAP32[i19 >> 2] = gb + 146524 + 8;
   HEAP32[i19 + 4 >> 2] = i5;
   i7 = i19 + 8 | 0;
   HEAP32[i7 >> 2] = 0;
   i10 = i19 + 12 | 0;
   HEAP32[i10 >> 2] = 0;
   i8 = i19 + 16 | 0;
   HEAP32[i8 >> 2] = 1;
   i11 = i26 + 104 | 0;
   HEAP32[i25 >> 2] = gb + 146492 + 8;
   i12 = i25 + 4 | 0;
   HEAP32[i12 >> 2] = 0;
   i13 = i25 + 8 | 0;
   HEAP32[i13 >> 2] = i19;
   HEAP32[i25 + 12 >> 2] = i11;
   i4 = HEAP32[i18 >> 2] | 0;
   i5 = i5 + 8 | 0;
   i9 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, 24) | 0;
   HEAP32[i9 >> 2] = gb + 1576256;
   i6 = i9 + 4 | 0;
   HEAP32[i6 >> 2] = gb + 1576256;
   i3 = i9 + 8 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   if (!i4) i1 = gb + 1576256 | 0; else if (!(HEAP8[i4 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
    i2 = i4;
    i1 = 0;
    while (1) {
     i3 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) {
      i2 = i3;
      break;
     } else i1 = i3;
    }
    i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, i1 + 2 | 0) | 0;
    _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
    HEAP8[i1 + i2 >> 0] = 0;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = gb + 1576256;
   i1 = HEAP32[i7 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i9 + 20 >> 2] = i1;
    i1 = i1 + 16 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     HEAP32[i1 >> 2] = i9;
     break;
    }
    while (1) {
     i1 = i2 + 8 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    HEAP32[i1 >> 2] = i9;
    HEAP32[i9 + 12 >> 2] = i2;
   } while (0);
   if (!(HEAP32[i10 >> 2] | 0)) HEAP32[i10 >> 2] = i9;
   HEAP32[i7 >> 2] = i9;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i1 = i23;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = i15;
   i4 = i3 + 128 | 0;
   do {
    HEAP8[i3 >> 0] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i4 | 0));
   i9 = i20;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i15, 128, gb + 1084511 | 0, i20) | 0;
   if (HEAP8[i15 >> 0] | 0) {
    i9 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    mftCall_iiii(i9 | 0, i11 | 0, i15 | 0, _strlen(i15) | 0) | 0;
   }
   HEAP8[i20 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i20 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, i19 | 0, gb + 766945 | 0, HEAP32[i26 + 124 >> 2] | 0);
   HEAP32[i26 + 120 >> 2] = 0;
   HEAP32[i26 + 116 >> 2] = 0;
   mftCall_viiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i18 | 0, i17 | 0, i25 | 0, i11 | 0, i16 | 0);
   mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i21 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   HEAP32[i21 + 16 >> 2] = i1;
   i1 = HEAP32[i22 >> 2] | 0;
   if ((HEAP32[i26 + 28 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i26 = (HEAP32[i26 + 20 >> 2] | 0) + (i1 * 24 | 0) | 0;
    HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i26 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i26 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    HEAP32[i26 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
    HEAP32[i26 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
    HEAP32[i26 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
    HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i26 + 16 | 0, i21) | 0;
   i26 = HEAP32[i23 + 4 >> 2] | 0;
   i1 = i24;
   HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i1 + 4 >> 2] = i26;
   HEAP32[i24 + 8 >> 2] = 0;
   HEAP32[i25 >> 2] = gb + 146492 + 8;
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) {
    STACKTOP = i27;
    return;
   }
   do {
    HEAP32[i12 >> 2] = i1 + -1;
    i26 = HEAP32[i13 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0);
    i1 = HEAP32[i12 >> 2] | 0;
   } while ((i1 | 0) != 0);
   STACKTOP = i27;
   return;
  }
 }
 i26 = i24;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 2;
 STACKTOP = i27;
 return;
}

function __ZN5physx25PxAggregateRepXSerializer16objectToFileImplEPKNS_11PxAggregateEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i18, i16, i22, i21, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 152 | 0;
 i17 = i20 + 144 | 0;
 i15 = i20 + 136 | 0;
 i14 = i20 + 128 | 0;
 i2 = i20;
 i12 = i20 + 204 | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, i22 | 0, gb + 756565 | 0);
 if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 40 >> 2] | 0, i18 | 0) | 0) {
  i11 = i2 + 4 | 0;
  i5 = i2 + 8 | 0;
  i8 = i21 + 20 | 0;
  i9 = i21 + 16 | 0;
  i10 = i21 + 12 | 0;
  i13 = 0;
  i1 = 0;
  do {
   if (!(mftCall_iiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 48 >> 2] | 0, i18 | 0, i12 | 0, 1, i13 | 0) | 0)) i4 = 6; else {
    i1 = HEAP32[i12 >> 2] | 0;
    if ((HEAP16[i1 + 4 >> 1] | 0) == 15) i4 = 6; else i4 = 12;
   }
   do if ((i4 | 0) == 6) {
    i4 = 0;
    if (!i1) {
     i1 = HEAP32[i12 >> 2] | 0;
     i4 = 12;
     break;
    }
    if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0) | 0)) {
     i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0;
     if (!(mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i3 | 0) | 0)) {
      i7 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
      HEAP32[i14 >> 2] = gb + 674598;
      __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i7, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i14);
     }
     i25 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 52 >> 2] | 0, i16 | 0, i3 | 0) | 0;
     i23 = getTempRet0() | 0;
     i24 = (i25 | 0) == 0 & (i23 | 0) == 0;
     i7 = HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0;
     HEAP32[i2 >> 2] = gb + 765118;
     HEAP32[i11 >> 2] = i3;
     i6 = i5;
     HEAP32[i6 >> 2] = i24 ? i3 : i25;
     HEAP32[i6 + 4 >> 2] = i24 ? 0 : i23;
     mftCall_viii(i7 | 0, i22 | 0, gb + 674598 | 0, i2 | 0);
    }
   } while (0);
   if ((i4 | 0) == 12) {
    i1 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 52 >> 2] | 0, i16 | 0, i1 | 0) | 0;
    i3 = getTempRet0() | 0;
    i6 = (i1 | 0) == 0 & (i3 | 0) == 0;
    i1 = i6 ? HEAP32[i12 >> 2] | 0 : i1;
    i3 = i6 ? 0 : i3;
    i6 = i2;
    i7 = i6 + 128 | 0;
    do {
     HEAP8[i6 >> 0] = 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) < (i7 | 0));
    i25 = i15;
    HEAP32[i25 >> 2] = i1;
    HEAP32[i25 + 4 >> 2] = i3;
    __ZN5physx6string9sprintf_sEPcjPKcz(i2, 128, gb + 1084511 | 0, i15) | 0;
    if (HEAP8[i2 >> 0] | 0) {
     i25 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
     mftCall_iiii(i25 | 0, i21 | 0, i2 | 0, _strlen(i2) | 0) | 0;
    }
    HEAP8[i2 >> 0] = 0;
    mftCall_iiii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, i2 | 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, gb + 674616 | 0, HEAP32[i8 >> 2] | 0);
    HEAP32[i9 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
    i1 = 0;
   }
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 40 >> 2] | 0, i18 | 0) | 0) >>> 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] | 0, i22 | 0);
 i1 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 40 >> 2] | 0, i18 | 0) | 0;
 i6 = i2;
 i7 = i6 + 128 | 0;
 do {
  HEAP8[i6 >> 0] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i17 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i2, 128, gb + 1084495 | 0, i17) | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i25 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
  mftCall_iiii(i25 | 0, i21 | 0, i2 | 0, _strlen(i2) | 0) | 0;
 }
 HEAP8[i17 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, i17 | 0, 1) | 0;
 i3 = i21 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, gb + 674627 | 0, HEAP32[i3 >> 2] | 0);
 i4 = i21 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i21 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 44 >> 2] | 0, i18 | 0) | 0;
 i6 = i2;
 i7 = i6 + 128 | 0;
 do {
  HEAP8[i6 >> 0] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i19 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i2, 128, gb + 1084495 | 0, i19) | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i25 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
  mftCall_iiii(i25 | 0, i21 | 0, i2 | 0, _strlen(i2) | 0) | 0;
 }
 HEAP8[i19 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, i19 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, gb + 674637 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 56 >> 2] | 0, i18 | 0) | 0;
 i2 = i1 ? gb + 1087447 | 0 : gb + 1087441 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  HEAP8[i19 >> 0] = 0;
  i24 = HEAP32[i21 >> 2] | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  mftCall_iiii(i24 | 0, i21 | 0, i19 | 0, 1) | 0;
  i24 = HEAP32[i22 >> 2] | 0;
  i24 = i24 + 8 | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  i25 = HEAP32[i3 >> 2] | 0;
  mftCall_viii(i24 | 0, i22 | 0, gb + 674649 | 0, i25 | 0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  __ZN5physx24PxAggregateGeneratedInfoC2Ev(i19);
  STACKTOP = i20;
  return;
 }
 mftCall_iiii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, i2 | 0, (i1 ? 4 : 5) | 0) | 0;
 HEAP8[i19 >> 0] = 0;
 i24 = HEAP32[i21 >> 2] | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 mftCall_iiii(i24 | 0, i21 | 0, i19 | 0, 1) | 0;
 i24 = HEAP32[i22 >> 2] | 0;
 i24 = i24 + 8 | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 i25 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(i24 | 0, i22 | 0, gb + 674649 | 0, i25 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx24PxAggregateGeneratedInfoC2Ev(i19);
 STACKTOP = i20;
 return;
}

function __ZN5Umbra16VisibilityResultC2ERNS_12QueryContextERKNS_10VisibilityERKNS_11TransformerEb(i11, i3, i1, i20, i21) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0;
 HEAP32[i11 >> 2] = i3;
 i8 = i11 + 36 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 40 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 44 | 0;
 HEAP32[i10 >> 2] = 0;
 i13 = i11 + 52 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i11 + 56 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i11 + 60 | 0;
 HEAP32[i12 >> 2] = 0;
 i15 = i1 + 3 & -4;
 i1 = HEAP32[i15 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i7 = i11 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = HEAP32[i15 + 4 >> 2] | 0;
 i16 = i11 + 8 | 0;
 HEAP32[i16 >> 2] = (i6 | 0) == 0 ? 0 : i6 + 3 & -4;
 i6 = i11 + 12 | 0;
 i4 = i11 + 16 | 0;
 i17 = i11 + 20 | 0;
 i18 = i11 + 24 | 0;
 i22 = i11 + 28 | 0;
 i23 = i11 + 32 | 0;
 HEAP32[i11 + 68 >> 2] = 0;
 i19 = i15 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i2 = HEAP32[i19 >> 2] | 0;
 if (i2 | 0) if ((i2 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) {
  HEAP32[i3 + 28 >> 2] = 3;
  return;
 }
 i2 = HEAP32[i15 + 24 >> 2] | 0;
 if (i2) {
  HEAP32[i4 >> 2] = i2;
  _memset(i2 | 0, 0, (HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + 64 >> 2] | 0) + 31 >> 5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (!i1) {
  if (HEAP32[i4 >> 2] | 0) i5 = 8;
 } else i5 = 8;
 if ((i5 | 0) == 8) {
  i24 = HEAP32[i11 >> 2] | 0;
  i5 = (HEAP32[HEAP32[i24 >> 2] >> 2] | 0) + 64 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 31 >> 5;
  i2 = i24 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + ((i1 << 2) + 31 & -16) | 0;
  if (i4 >>> 0 > (HEAP32[i24 + 12 >> 2] | 0) >>> 0) i2 = 0; else {
   HEAP32[i2 >> 2] = i4;
   if (!i3) i2 = 0; else {
    HEAP32[i3 >> 2] = i1;
    i2 = i3 + 16 | 0;
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  if (!i1) _memset(i2 | 0, 0, (HEAP32[i5 >> 2] | 0) + 31 >> 5 << 2 | 0) | 0; else {
   i1 = i1 + 3 & -4;
   _memset(i2 | 0, -1, (HEAP32[i5 >> 2] | 0) + 31 >> 5 << 2 | 0) | 0;
   i4 = i1 + 8 | 0;
   i5 = i1 + 4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i24 = HEAP32[i5 >> 2] | 0;
   if ((((i3 | 0) <= (i24 | 0) ? i3 : i24) | 0) > 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = 0;
    do {
     i24 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
     i6 = i2 + (i24 >> 5 << 2) | 0;
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~(1 << (i24 & 31));
     i1 = i1 + 1 | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     i24 = HEAP32[i5 >> 2] | 0;
    } while ((i1 | 0) < (((i6 | 0) <= (i24 | 0) ? i6 : i24) | 0));
   }
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 8 >> 2] = 0;
  i1 = HEAP32[i15 + 20 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[(HEAP32[HEAP32[HEAP32[i11 >> 2] >> 2] >> 2] | 0) + 64 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i24;
   HEAP32[i10 >> 2] = 0;
  }
  i1 = HEAP32[i15 + 28 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = i24;
   HEAP32[i12 >> 2] = 0;
  }
 }
 if (HEAP32[i16 >> 2] | 0) {
  i24 = HEAP32[i11 >> 2] | 0;
  i6 = (HEAP32[HEAP32[i24 >> 2] >> 2] | 0) + 124 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 31 >> 5;
  i3 = i24 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + ((i2 << 2) + 31 & -16) | 0;
  if (i5 >>> 0 > (HEAP32[i24 + 12 >> 2] | 0) >>> 0) i2 = 0; else {
   HEAP32[i3 >> 2] = i5;
   if (!i4) i2 = 0; else {
    HEAP32[i4 >> 2] = i2;
    i2 = i4 + 16 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
  }
  HEAP32[i17 >> 2] = i2;
  _memset(i2 | 0, 0, i1 + 31 >> 5 << 2 | 0) | 0;
  HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] = 0;
 }
 i1 = HEAP32[i15 + 8 >> 2] | 0;
 if (i1 | 0) {
  i17 = i1 + 15 & -16;
  i24 = i17;
  HEAP32[i18 >> 2] = i24;
  HEAP8[i24 + 1412 >> 0] = 1;
  HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i24 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i24 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  HEAP32[i24 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
  HEAP32[i24 + 24 >> 2] = HEAP32[i20 + 24 >> 2];
  HEAP32[i24 + 28 >> 2] = HEAP32[i20 + 28 >> 2];
  HEAP32[i24 + 32 >> 2] = HEAP32[i20 + 32 >> 2];
  HEAP32[i24 + 36 >> 2] = HEAP32[i20 + 36 >> 2];
  HEAP32[i24 + 40 >> 2] = HEAP32[i20 + 40 >> 2];
  HEAP32[i24 + 44 >> 2] = HEAP32[i20 + 44 >> 2];
  HEAP32[i24 + 48 >> 2] = HEAP32[i20 + 48 >> 2];
  HEAP32[i24 + 52 >> 2] = HEAP32[i20 + 52 >> 2];
  HEAP32[i24 + 56 >> 2] = HEAP32[i20 + 56 >> 2];
  HEAP32[i24 + 60 >> 2] = HEAP32[i20 + 60 >> 2];
  HEAP32[i24 + 64 >> 2] = HEAP32[i20 + 64 >> 2];
  HEAP32[i24 + 68 >> 2] = HEAP32[i20 + 68 >> 2];
  HEAP32[i24 + 72 >> 2] = HEAP32[i20 + 72 >> 2];
  HEAP32[i24 + 76 >> 2] = HEAP32[i20 + 76 >> 2];
  HEAP32[i24 + 80 >> 2] = HEAP32[i20 + 80 >> 2];
  HEAP32[i24 + 84 >> 2] = HEAP32[i20 + 84 >> 2];
  HEAP32[i24 + 88 >> 2] = HEAP32[i20 + 88 >> 2];
  HEAP32[i24 + 92 >> 2] = HEAP32[i20 + 92 >> 2];
  HEAP32[i24 + 96 >> 2] = HEAP32[i20 + 96 >> 2];
  HEAP32[i24 + 100 >> 2] = HEAP32[i20 + 100 >> 2];
  HEAP32[i24 + 104 >> 2] = HEAP32[i20 + 104 >> 2];
  HEAP32[i24 + 108 >> 2] = HEAP32[i20 + 108 >> 2];
  HEAP32[i24 + 112 >> 2] = HEAP32[i20 + 112 >> 2];
  HEAP32[i24 + 116 >> 2] = HEAP32[i20 + 116 >> 2];
  HEAP32[i24 + 120 >> 2] = HEAP32[i20 + 120 >> 2];
  HEAP32[i24 + 124 >> 2] = HEAP32[i20 + 124 >> 2];
  _memcpy(i24 + 128 | 0, i20 + 128 | 0, 1276) | 0;
  HEAP32[i24 + 1408 >> 2] = i21 ? i24 + 1424 | 0 : 0;
  HEAPF32[i24 + 1416 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + 15 & -16;
 if (!(HEAP8[i1 + 1412 >> 0] | 0)) return;
 HEAP32[i22 >> 2] = HEAP32[i1 + 1408 >> 2];
 HEAP32[i23 >> 2] = HEAP32[i1 + 1416 >> 2];
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer7RestoreERK8UnityStrPvy(i14, i9, i10, i11, i12) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 56 | 0;
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i6 = i17 + 12 | 0;
 i7 = i17;
 i1 = HEAP8[i14 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i14 + 4 >> 2] | 0;
 } else {
  i2 = i14;
  i1 = i1 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, i1);
 i4 = i9 + 11 | 0;
 i3 = HEAP8[i4 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i5 = i9 + 4 | 0;
 i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i3 = i2 ? HEAP32[i5 >> 2] | 0 : i3 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, i3);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i13, i6, i7);
 i3 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i8 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i16 + 11 >> 0] = i3;
  if (!i3) i1 = i16; else {
   i1 = i16;
   i8 = 9;
  }
 } else i8 = 7;
 if ((i8 | 0) == 7) {
  i18 = i3 + 16 & -16;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 8 >> 2] = i18 | -2147483648;
  HEAP32[i16 + 4 >> 2] = i3;
  i8 = 9;
 }
 if ((i8 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i18 = __Z14StringToUInt64PKc((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0;
 i1 = getTempRet0() | 0;
 i8 = i14 + 96 | 0;
 HEAP32[i8 >> 2] = i18;
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = ___udivdi3(i18 | 0, i1 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP32[i14 + 104 + 4 >> 2] = i8;
 i1 = ___uremdi3(i18 | 0, i1 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP16[i14 + 112 >> 1] = i1;
 i1 = i14 + 16 | 0;
 do if ((i1 | 0) != (i9 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
  i6 = i4 ? HEAP32[i5 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i14 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i14 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i14 + 20 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i18 = i13 + 11 | 0;
 HEAP8[i18 >> 0] = 1;
 HEAP8[i13 >> 0] = 101;
 HEAP8[i13 + 1 >> 0] = 0;
 i1 = __ZN11UnityEngine15CloudWebService16SessionContainer17RestoreEventQueueERK8UnityStrS4_Pvy(i14, i16, i13, i10, i11, i12) | 0;
 if ((HEAP8[i18 >> 0] | 0) < 0) {
  i18 = HEAP32[i13 >> 2] | 0;
  i12 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
 };
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i18 = i13 + 11 | 0;
 HEAP8[i18 >> 0] = 1;
 HEAP8[i13 >> 0] = 115;
 HEAP8[i13 + 1 >> 0] = 0;
 i2 = __ZN11UnityEngine15CloudWebService16SessionContainer20RestoreSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE(0, i16, i13, i14 + 52 | 0) | 0;
 if ((HEAP8[i18 >> 0] | 0) < 0) {
  i18 = HEAP32[i13 >> 2] | 0;
  i12 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
 };
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i18 = i13 + 11 | 0;
 HEAP8[i18 >> 0] = 1;
 HEAP8[i13 >> 0] = 103;
 HEAP8[i13 + 1 >> 0] = 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer20RestoreSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE(0, i16, i13, i14 + 36 | 0) | 0;
 if ((HEAP8[i18 >> 0] | 0) < 0) {
  i18 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 66;
  HEAP32[i15 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
 }
 i1 = i1 | i2;
 if (i1) HEAP8[i14 + 89 >> 0] = 0;
 if ((HEAP8[i16 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i17;
  return i1 | 0;
 }
 i18 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = 66;
 HEAP32[i15 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i29, i2, i1, i30) {
 i29 = i29 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0, i41 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i35 + 40 | 0;
 i32 = i35 + 24 | 0;
 i33 = i35 + 8 | 0;
 i34 = i35;
 __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i34, i29 + 800 | 0);
 i28 = i1 ? 3 : 1;
 i20 = i29 + 808 | 0;
 i21 = i34 + 4 | 0;
 i22 = i2 + 12 | 0;
 i23 = i2 + 24 | 0;
 i24 = i2 + 16 | 0;
 i25 = i2 + 28 | 0;
 i26 = i2 + 20 | 0;
 i27 = i2 + 32 | 0;
 i2 = i2 + 100 | 0;
 i4 = i32 + 12 | 0;
 i5 = i32 + 8 | 0;
 i6 = i32 + 4 | 0;
 i7 = i33 + 12 | 0;
 i8 = i33 + 8 | 0;
 i9 = i33 + 4 | 0;
 i10 = i32 + 12 | 0;
 i11 = i32 + 8 | 0;
 i12 = i32 + 4 | 0;
 i13 = i33 + 12 | 0;
 i14 = i33 + 8 | 0;
 i15 = i33 + 4 | 0;
 i1 = 0;
 do {
  i16 = HEAP8[i20 >> 0] | 0 ? i1 : 0;
  i17 = i29 + 8 + (i16 * 264 | 0) | 0;
  i18 = HEAP16[i29 + 8 + (i16 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i18 << 16 >> 16)) {
   i19 = i30 + (i1 << 2) | 0;
   f3 = Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 80 >> 2]);
   i18 = f3 > Math_fround(0.0);
   f3 = i18 ? f3 : Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f3);
  } else {
   if (!(HEAP8[i29 + 8 + (i16 * 264 | 0) + 86 >> 0] | 0)) {
    i19 = i30 + (i1 << 2) | 0;
    f38 = Math_fround(HEAPF32[i34 >> 2]);
    f39 = Math_fround(HEAPF32[i21 >> 2]);
    f37 = Math_fround(HEAPF32[i22 >> 2]);
    f37 = Math_fround(f37 + Math_fround(HEAPF32[i23 >> 2]));
    f3 = Math_fround(HEAPF32[i24 >> 2]);
    f3 = Math_fround(f3 + Math_fround(HEAPF32[i25 >> 2]));
    f36 = Math_fround(HEAPF32[i26 >> 2]);
    f36 = Math_fround(f36 + Math_fround(HEAPF32[i27 >> 2]));
    f36 = Math_fround(f39 + Math_fround(f38 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f37 * f37) + Math_fround(f3 * f3)) + Math_fround(f36 * f36))))));
    i16 = f36 < Math_fround(0.0);
    i18 = f36 > Math_fround(1.0);
    f36 = i18 ? Math_fround(1.0) : f36;
    f36 = i16 ? Math_fround(0.0) : f36;
    i16 = (HEAP32[i2 >> 2] | 0) + -209354897 | 0;
    i18 = (Math_imul(i16, 1790253981) | 0) + 1900727103 | 0;
    i16 = i16 << 11 ^ i16;
    f3 = Math_fround(Math_fround(((i18 ^ i16 ^ i16 >>> 8) & 8388607 ^ i18 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    HEAPF32[i4 >> 2] = f36;
    HEAPF32[i5 >> 2] = f36;
    HEAPF32[i6 >> 2] = f36;
    HEAPF32[i32 >> 2] = f36;
    HEAPF32[i7 >> 2] = f3;
    HEAPF32[i8 >> 2] = f3;
    HEAPF32[i9 >> 2] = f3;
    HEAPF32[i33 >> 2] = f3;
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i31, i17, i32, i33);
    f3 = Math_fround(HEAPF32[i31 >> 2]);
    i18 = f3 > Math_fround(0.0);
    f3 = i18 ? f3 : Math_fround(0.0);
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f3);
    break;
   }
   i19 = i30 + (i1 << 2) | 0;
   f37 = Math_fround(HEAPF32[i34 >> 2]);
   f36 = Math_fround(HEAPF32[i21 >> 2]);
   f38 = Math_fround(HEAPF32[i22 >> 2]);
   f38 = Math_fround(f38 + Math_fround(HEAPF32[i23 >> 2]));
   f39 = Math_fround(HEAPF32[i24 >> 2]);
   f39 = Math_fround(f39 + Math_fround(HEAPF32[i25 >> 2]));
   f3 = Math_fround(HEAPF32[i26 >> 2]);
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i27 >> 2]));
   f3 = Math_fround(f36 + Math_fround(f37 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f38 * f38) + Math_fround(f39 * f39)) + Math_fround(f3 * f3))))));
   i40 = f3 < Math_fround(0.0);
   i41 = f3 > Math_fround(1.0);
   f3 = i41 ? Math_fround(1.0) : f3;
   f3 = i40 ? Math_fround(0.0) : f3;
   if ((i18 | 1) << 16 >> 16 == 3) {
    i40 = (HEAP32[i2 >> 2] | 0) + -209354897 | 0;
    i41 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
    i40 = i40 << 11 ^ i40;
    f39 = Math_fround(Math_fround(((i41 ^ i40 ^ i40 >>> 8) & 8388607 ^ i41 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    HEAPF32[i10 >> 2] = f3;
    HEAPF32[i11 >> 2] = f3;
    HEAPF32[i12 >> 2] = f3;
    HEAPF32[i32 >> 2] = f3;
    HEAPF32[i13 >> 2] = f39;
    HEAPF32[i14 >> 2] = f39;
    HEAPF32[i15 >> 2] = f39;
    HEAPF32[i33 >> 2] = f39;
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i31, i17, i32, i33);
    f39 = Math_fround(HEAPF32[i31 >> 2]);
    i41 = f39 > Math_fround(0.0);
    f39 = i41 ? f39 : Math_fround(0.0);
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f39);
    break;
   } else {
    f37 = Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 32 >> 2]);
    f39 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f3);
    f39 = Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 4 >> 2]) + f39));
    f39 = Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 8 >> 2]) + f39));
    f39 = Math_fround(Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 12 >> 2]) + f39);
    f36 = Math_fround(f3 - f37);
    f38 = Math_fround(f36 * Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 16 >> 2]));
    f38 = Math_fround(f36 * Math_fround(f38 + Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 20 >> 2])));
    f38 = Math_fround(f36 * Math_fround(Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 24 >> 2]) + f38));
    f38 = Math_fround(Math_fround(HEAPF32[i29 + 8 + (i16 * 264 | 0) + 28 >> 2]) + f38);
    f39 = f3 > f37 ? f38 : f39;
    i41 = f39 > Math_fround(0.0);
    f39 = i41 ? f39 : Math_fround(0.0);
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f39);
    break;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i28 | 0));
 STACKTOP = i35;
 return;
}

function __Z26RandomBarycentricCoordEdgeR5RandN(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i29 = HEAP32[i2 >> 2] | 0;
 i20 = i2 + 4 | 0;
 i28 = HEAP32[i20 >> 2] | 0;
 i19 = i2 + 8 | 0;
 i27 = HEAP32[i19 >> 2] | 0;
 i33 = i2 + 12 | 0;
 i26 = HEAP32[i33 >> 2] | 0;
 i29 = i29 << 11 ^ i29;
 i28 = i28 << 11 ^ i28;
 i27 = i27 << 11 ^ i27;
 i26 = i26 << 11 ^ i26;
 i22 = i2 + 16 | 0;
 i23 = i2 + 20 | 0;
 i30 = HEAP32[i23 >> 2] | 0;
 i24 = i2 + 24 | 0;
 i31 = HEAP32[i24 >> 2] | 0;
 i25 = i2 + 28 | 0;
 i32 = HEAP32[i25 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i20 >> 2] = i30;
 HEAP32[i19 >> 2] = i31;
 HEAP32[i33 >> 2] = i32;
 i33 = i2 + 32 | 0;
 i32 = i2 + 36 | 0;
 i19 = HEAP32[i32 >> 2] | 0;
 i31 = i2 + 40 | 0;
 i20 = HEAP32[i31 >> 2] | 0;
 i30 = i2 + 44 | 0;
 i21 = HEAP32[i30 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i33 >> 2];
 HEAP32[i23 >> 2] = i19;
 HEAP32[i24 >> 2] = i20;
 HEAP32[i25 >> 2] = i21;
 i25 = i2 + 48 | 0;
 i21 = HEAP32[i25 >> 2] | 0;
 i24 = i2 + 52 | 0;
 i20 = HEAP32[i24 >> 2] | 0;
 i23 = i2 + 56 | 0;
 i19 = HEAP32[i23 >> 2] | 0;
 i22 = i2 + 60 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 HEAP32[i33 >> 2] = i21;
 HEAP32[i32 >> 2] = i20;
 HEAP32[i31 >> 2] = i19;
 HEAP32[i30 >> 2] = i2;
 i21 = i29 >>> 8 ^ i29 ^ i21 ^ i21 >>> 19;
 i20 = i28 >>> 8 ^ i28 ^ i20 ^ i20 >>> 19;
 i19 = i27 >>> 8 ^ i27 ^ i19 ^ i19 >>> 19;
 i2 = i26 >>> 8 ^ i26 ^ i2 ^ i2 >>> 19;
 HEAP32[i25 >> 2] = i21;
 HEAP32[i24 >> 2] = i20;
 HEAP32[i23 >> 2] = i19;
 HEAP32[i22 >> 2] = i2;
 f10 = Math_fround(Math_fround(i21 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(i20 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(i19 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f10 = Math_fround(Math_fround(f10 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f10) * Math_fround(3.0)));
 f9 = Math_fround(Math_fround(f9 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f9) * Math_fround(3.0)));
 f8 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f8) * Math_fround(3.0)));
 f7 = Math_fround(Math_fround(f7 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(3.0)));
 f18 = Math_fround(f10 + Math_fround(-1.0));
 f17 = Math_fround(f9 + Math_fround(-1.0));
 f16 = Math_fround(f8 + Math_fround(-1.0));
 f15 = Math_fround(f7 + Math_fround(-1.0));
 i2 = f18 < Math_fround(0.0);
 f18 = i2 ? Math_fround(0.0) : f18;
 i2 = f17 < Math_fround(0.0);
 f17 = i2 ? Math_fround(0.0) : f17;
 i2 = f16 < Math_fround(0.0);
 f16 = i2 ? Math_fround(0.0) : f16;
 i2 = f15 < Math_fround(0.0);
 f15 = i2 ? Math_fround(0.0) : f15;
 i2 = f18 > Math_fround(1.0);
 f18 = i2 ? Math_fround(1.0) : f18;
 i2 = f17 > Math_fround(1.0);
 f17 = i2 ? Math_fround(1.0) : f17;
 i2 = f16 > Math_fround(1.0);
 f16 = i2 ? Math_fround(1.0) : f16;
 i2 = f15 > Math_fround(1.0);
 f15 = i2 ? Math_fround(1.0) : f15;
 f6 = Math_fround(f10 + Math_fround(-2.0));
 f5 = Math_fround(f9 + Math_fround(-2.0));
 f4 = Math_fround(f8 + Math_fround(-2.0));
 f3 = Math_fround(f7 + Math_fround(-2.0));
 i2 = f6 < Math_fround(0.0);
 f6 = i2 ? Math_fround(0.0) : f6;
 i2 = f5 < Math_fround(0.0);
 f5 = i2 ? Math_fround(0.0) : f5;
 i2 = f4 < Math_fround(0.0);
 f4 = i2 ? Math_fround(0.0) : f4;
 i2 = f3 < Math_fround(0.0);
 f3 = i2 ? Math_fround(0.0) : f3;
 i2 = f6 > Math_fround(1.0);
 f6 = i2 ? Math_fround(1.0) : f6;
 i2 = f5 > Math_fround(1.0);
 f5 = i2 ? Math_fround(1.0) : f5;
 i2 = f4 > Math_fround(1.0);
 f4 = i2 ? Math_fround(1.0) : f4;
 i2 = f3 > Math_fround(1.0);
 f3 = i2 ? Math_fround(1.0) : f3;
 f14 = Math_fround(Math_fround(1.0) - f10);
 f13 = Math_fround(Math_fround(1.0) - f9);
 f12 = Math_fround(Math_fround(1.0) - f8);
 f11 = Math_fround(Math_fround(1.0) - f7);
 i2 = f14 < Math_fround(0.0);
 f14 = i2 ? Math_fround(0.0) : f14;
 i2 = f13 < Math_fround(0.0);
 f13 = i2 ? Math_fround(0.0) : f13;
 i2 = f12 < Math_fround(0.0);
 f12 = i2 ? Math_fround(0.0) : f12;
 i2 = f11 < Math_fround(0.0);
 f11 = i2 ? Math_fround(0.0) : f11;
 i2 = f14 > Math_fround(1.0);
 f14 = i2 ? Math_fround(1.0) : f14;
 i2 = f13 > Math_fround(1.0);
 f13 = i2 ? Math_fround(1.0) : f13;
 i2 = f12 > Math_fround(1.0);
 f12 = i2 ? Math_fround(1.0) : f12;
 i2 = f11 > Math_fround(1.0);
 f14 = Math_fround(f14 + f6);
 f13 = Math_fround(f13 + f5);
 f12 = Math_fround(f12 + f4);
 f11 = Math_fround((i2 ? Math_fround(1.0) : f11) + f3);
 i2 = f10 < Math_fround(0.0);
 f10 = i2 ? Math_fround(0.0) : f10;
 i2 = f9 < Math_fround(0.0);
 f9 = i2 ? Math_fround(0.0) : f9;
 i2 = f8 < Math_fround(0.0);
 f8 = i2 ? Math_fround(0.0) : f8;
 i2 = f7 < Math_fround(0.0);
 f7 = i2 ? Math_fround(0.0) : f7;
 i2 = f10 > Math_fround(1.0);
 f10 = i2 ? Math_fround(1.0) : f10;
 i2 = f9 > Math_fround(1.0);
 f9 = i2 ? Math_fround(1.0) : f9;
 i2 = f8 > Math_fround(1.0);
 f8 = i2 ? Math_fround(1.0) : f8;
 i2 = f7 > Math_fround(1.0);
 f10 = Math_fround(f10 - f18);
 f9 = Math_fround(f9 - f17);
 f8 = Math_fround(f8 - f16);
 f7 = Math_fround((i2 ? Math_fround(1.0) : f7) - f15);
 f6 = Math_fround(f18 - f6);
 f5 = Math_fround(f17 - f5);
 f4 = Math_fround(f16 - f4);
 f3 = Math_fround(f15 - f3);
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = f11;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 28 >> 2] = f7;
 HEAPF32[i1 + 32 >> 2] = f6;
 HEAPF32[i1 + 36 >> 2] = f5;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAPF32[i1 + 44 >> 2] = f3;
 return;
}

function __ZNK5Umbra12PortalCuller15visualizePortalERKNS_6PortalEbb(i10, i11, i2, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 16 | 0;
 i13 = i17;
 i14 = i17 + 56 | 0;
 i15 = i17 + 44 | 0;
 i16 = i17 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 do if (i1) {
  HEAPF32[i14 >> 2] = Math_fround(.800000011);
  HEAPF32[i14 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i14 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i14 + 12 >> 2] = Math_fround(.5);
 } else {
  HEAPF32[i14 >> 2] = Math_fround(.600000024);
  i1 = i14 + 4 | 0;
  if (i2) {
   HEAPF32[i1 >> 2] = Math_fround(.800000011);
   HEAPF32[i14 + 8 >> 2] = Math_fround(.600000024);
   HEAPF32[i14 + 12 >> 2] = Math_fround(.5);
   break;
  } else {
   HEAPF32[i1 >> 2] = Math_fround(.600000024);
   HEAPF32[i14 + 8 >> 2] = Math_fround(.800000011);
   HEAPF32[i14 + 12 >> 2] = Math_fround(.5);
   break;
  }
 } while (0);
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 i9 = i15 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i1 = i15 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 i2 = i16 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i16 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = HEAP32[i11 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i10 + 2352 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + 2356 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 2360 >> 2]);
 i8 = HEAP32[i11 + 12 >> 2] | 0;
 if (!(i4 & 134217728)) {
  i9 = i4 >>> 30;
  i3 = 1 << i9 & 3;
  i4 = 1 << i3 & 3;
  i2 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i12 + (i3 << 2) >> 2] = i2 >>> 16;
  HEAP32[i12 + (i4 << 2) >> 2] = i8 >>> 16;
  i11 = HEAP32[i11 + 4 >> 2] & 65535;
  HEAP32[i12 + (i9 << 2) >> 2] = i11;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i13 + (i3 << 2) >> 2] = i2 & 65535;
  HEAP32[i13 + (i4 << 2) >> 2] = i8 & 65535;
  HEAP32[i13 + (i9 << 2) >> 2] = i11;
  HEAP32[i13 + 12 >> 2] = 0;
  f21 = Math_fround(HEAPF32[i10 + 2308 >> 2]);
  f24 = Math_fround(f5 + f21);
  f26 = Math_fround(HEAPF32[i10 + 2312 >> 2]);
  f23 = Math_fround(f6 + f26);
  f25 = Math_fround(HEAPF32[i10 + 2316 >> 2]);
  f22 = Math_fround(f7 + f25);
  f21 = Math_fround(f21 - f5);
  f26 = Math_fround(f26 - f6);
  f25 = Math_fround(f25 - f7);
  f20 = Math_fround(HEAP32[i12 >> 2] | 0);
  f19 = Math_fround(HEAP32[i12 + 4 >> 2] | 0);
  f18 = Math_fround(HEAP32[i12 + 8 >> 2] | 0);
  f5 = Math_fround(HEAPF32[i10 + 2324 >> 2]);
  f20 = Math_fround(f20 * f5);
  f6 = Math_fround(HEAPF32[i10 + 2328 >> 2]);
  f19 = Math_fround(f19 * f6);
  f7 = Math_fround(HEAPF32[i10 + 2332 >> 2]);
  f19 = Math_fround(f26 + f19);
  f18 = Math_fround(f25 + Math_fround(f18 * f7));
  f5 = Math_fround(f24 + Math_fround(Math_fround(HEAP32[i13 >> 2] | 0) * f5));
  f6 = Math_fround(f23 + Math_fround(Math_fround(HEAP32[i13 + 4 >> 2] | 0) * f6));
  f7 = Math_fround(f22 + Math_fround(Math_fround(HEAP32[i13 + 8 >> 2] | 0) * f7));
  HEAPF32[i15 >> 2] = Math_fround(f21 + f20);
  HEAPF32[i15 + 4 >> 2] = f19;
  HEAPF32[i15 + 8 >> 2] = f18;
  HEAPF32[i16 >> 2] = f5;
  HEAPF32[i16 + 4 >> 2] = f6;
  HEAPF32[i16 + 8 >> 2] = f7;
 } else {
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  i11 = HEAP32[i10 + 2700 >> 2] | 0;
  i12 = i8 >>> 12;
  i11 = i11 + (HEAP32[i11 + 112 >> 2] | 0) | 0;
  i13 = i11 + (i12 * 12 | 0) | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i13 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i13 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i13 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i13 + 3 >> 0];
  f21 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  i8 = i11 + (i12 * 12 | 0) + 4 | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i8 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i8 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i8 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i8 + 3 >> 0];
  f22 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  i12 = i11 + (i12 * 12 | 0) + 8 | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i12 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i12 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i12 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i12 + 3 >> 0];
  f23 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  i12 = i13 + 12 | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i12 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i12 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i12 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i12 + 3 >> 0];
  f24 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  i12 = i13 + 16 | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i12 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i12 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i12 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i12 + 3 >> 0];
  f25 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  i13 = i13 + 20 | 0;
  HEAP8[tempDoublePtr >> 0] = HEAP8[i13 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i13 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i13 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i13 + 3 >> 0];
  f26 = Math_fround(HEAPF32[tempDoublePtr >> 2]);
  f22 = Math_fround(f22 - f6);
  f23 = Math_fround(f23 - f7);
  HEAPF32[i15 >> 2] = Math_fround(f21 - f5);
  HEAPF32[i9 >> 2] = f22;
  HEAPF32[i1 >> 2] = f23;
  f25 = Math_fround(f6 + f25);
  f26 = Math_fround(f7 + f26);
  HEAPF32[i16 >> 2] = Math_fround(f5 + f24);
  HEAPF32[i2 >> 2] = f25;
  HEAPF32[i3 >> 2] = f26;
 }
 i1 = HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i15 | 0, i16 | 0, i14 | 0);
 STACKTOP = i17;
 return;
}

function __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i24, i5, i26, i27, i28, i29, i30, i8, i4, i2, i25, i1) {
 i24 = i24 | 0;
 i5 = i5 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i31 = 0;
 i21 = HEAP32[i5 >> 2] | 0;
 i22 = HEAP32[i5 + 16 >> 2] | 0;
 i23 = i24 + 860 | 0;
 i1 = __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace(HEAP32[i23 >> 2] | 0, i26, i25) | 0;
 __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(HEAP32[gb + 1451096 >> 2] | 0, i21, i22, 0, 4);
 L1 : do if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 680 >> 2] | 0) == 2) {
  switch (i26 | 0) {
  case 1:
  case 8:
  case 9:
  case 14:
   break;
  default:
   break L1;
  }
  __ZN7ApiGLES14TextureSwizzleEj16TextureDimensionN2gl18TextureSwizzleFuncE(i24, i21, i22, HEAP32[i1 + 16 >> 2] | 0);
 } while (0);
 i3 = __Z29NeedToDecompressTextureFormat13TextureFormat(i26) | 0;
 i20 = __ZN12_GLOBAL__N_112UploadFormatE13TextureFormat(i26) | 0;
 i1 = __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i23 >> 2] | 0, i20, i25) | 0;
 HEAP32[i5 + 20 >> 2] = i1;
 HEAP32[i5 + 24 >> 2] = i29;
 HEAP32[i5 + 28 >> 2] = i30;
 i6 = i5 + 32 | 0;
 HEAP32[i6 >> 2] = i8;
 i2 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i23 >> 2] | 0, i1) | 0;
 if (i3) __Z37PrintWarningAboutDecompressingTexture13TextureFormat(i26);
 i7 = (i22 + -5 | 0) >>> 0 < 2;
 if (i7 | (HEAP32[i2 + 12 >> 2] & 4 | 0) != 0) i4 = __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii(i24, i21, i22, i1, i4, 1, i29, i30, i8) | 0;
 HEAP32[i5 + 36 >> 2] = i4;
 i2 = i3 ? 1 : (i20 | 0) == (i26 | 0) ? 0 : 2;
 i18 = (i2 | 0) == 0;
 if (i18) {
  i19 = 0;
  i17 = 0;
 } else {
  i1 = __Z33GetMinimumTextureMipSizeForFormat13TextureFormat(i20) | 0;
  i1 = __Z18CalculateImageSizeii13TextureFormat((i1 | 0) > (i29 | 0) ? i1 : i29, (i1 | 0) > (i30 | 0) ? i1 : i30, i20) | 0;
  i1 = Math_imul(i1, (i22 | 0) == 3 ? i8 : 1) | 0;
  if (!i1) {
   i19 = 0;
   i17 = 0;
  } else {
   i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, gb + 64016 | 0, 0, gb + 609603 | 0, 276) | 0;
   i17 = i1;
  }
 }
 if ((i22 | 0) == 4) {
  HEAP32[i6 >> 2] = 6;
  i1 = 6;
 } else i1 = 1;
 i16 = i7 ? i8 : i1;
 i14 = i7 ? 1 : i8;
 if ((i16 | 0) > 0) {
  i15 = (i4 | 0) > 0;
  i13 = i2 & 255;
  i12 = (i13 & 3) == 2;
  i13 = (i13 & 3) == 1;
  i11 = 0;
  i1 = 0;
  do {
   i2 = i27 + (Math_imul(i11, i28) | 0) | 0;
   L22 : do if (i15) {
    if (i18) {
     i3 = i2;
     i2 = 0;
     i5 = 0;
     while (1) {
      i8 = i29 >> i5;
      i8 = (i8 | 0) < 1 ? 1 : i8;
      i9 = i30 >> i5;
      i9 = (i9 | 0) < 1 ? 1 : i9;
      i10 = i14 >> i5;
      i10 = (i10 | 0) < 1 ? 1 : i10;
      i6 = Math_imul(i10, __Z18CalculateImageSizeii13TextureFormat(i8, i9, i26) | 0) | 0;
      i7 = Math_imul(i10, __Z18CalculateImageSizeii13TextureFormat(i8, i9, i26) | 0) | 0;
      __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(i24, i21, i22, i11, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i23 >> 2] | 0, i20, i25) | 0, i5, i8, i9, i10, i7, i3);
      i2 = (Math_imul(__Z18CalculateImageSizeii13TextureFormat(i8, i9, i20) | 0, i10) | 0) + i2 | 0;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i4 | 0)) break L22; else i3 = i3 + i6 | 0;
     }
    }
    if (i12) {
     i3 = i2;
     i2 = 0;
     i5 = 0;
     while (1) {
      i8 = i29 >> i5;
      i8 = (i8 | 0) < 1 ? 1 : i8;
      i9 = i30 >> i5;
      i9 = (i9 | 0) < 1 ? 1 : i9;
      i10 = i14 >> i5;
      i10 = (i10 | 0) < 1 ? 1 : i10;
      i6 = Math_imul(i10, __Z18CalculateImageSizeii13TextureFormat(i8, i9, i26) | 0) | 0;
      __ZN12_GLOBAL__N_127ConvertUncompressedMipLevelE13TextureFormatS0_iiiPKvPv(i26, i20, i8, i9, i10, i3, i19);
      i7 = Math_imul(__Z18CalculateImageSizeii13TextureFormat(i8, i9, i26) | 0, i10) | 0;
      __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(i24, i21, i22, i11, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i23 >> 2] | 0, i20, i25) | 0, i5, i8, i9, i10, i7, i19);
      i2 = (Math_imul(__Z18CalculateImageSizeii13TextureFormat(i8, i9, i20) | 0, i10) | 0) + i2 | 0;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i4 | 0)) break L22; else i3 = i3 + i6 | 0;
     }
    } else {
     i8 = i2;
     i2 = 0;
     i9 = 0;
    }
    while (1) {
     i7 = i29 >> i9;
     i7 = (i7 | 0) < 1 ? 1 : i7;
     i6 = i30 >> i9;
     i6 = (i6 | 0) < 1 ? 1 : i6;
     i5 = i14 >> i9;
     i5 = (i5 | 0) < 1 ? 1 : i5;
     i10 = Math_imul(i5, __Z18CalculateImageSizeii13TextureFormat(i7, i6, i26) | 0) | 0;
     if (i13) {
      __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i26, i20, i7, i6, i8, (i7 | 0) < (i5 | 0) ? i5 : i7, (i6 | 0) < (i5 | 0) ? i5 : i6, i19) | 0;
      i3 = i19;
     } else i3 = 0;
     i31 = Math_imul(__Z18CalculateImageSizeii13TextureFormat(i7, i6, i26) | 0, i5) | 0;
     __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(i24, i21, i22, i11, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i23 >> 2] | 0, i20, i25) | 0, i9, i7, i6, i5, i31, i3);
     i2 = (Math_imul(__Z18CalculateImageSizeii13TextureFormat(i7, i6, i20) | 0, i5) | 0) + i2 | 0;
     i9 = i9 + 1 | 0;
     if ((i9 | 0) == (i4 | 0)) break; else i8 = i8 + i10 | 0;
    }
   } else i2 = 0; while (0);
   i1 = i2 + i1 | 0;
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i16 | 0));
 } else i1 = 0;
 if (!i17) return i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i19, gb + 64016 | 0);
 return i1 | 0;
}

function __ZN5physx20BigConvexDataBuilder10PrecomputeEj(i32, i31) {
 i32 = i32 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i1 = Math_imul(i31 * 6 | 0, i31) | 0;
 i30 = i32 + 4 | 0;
 i2 = HEAP32[i30 >> 2] | 0;
 HEAP16[i2 >> 1] = i31;
 i29 = i1 & 65535;
 HEAP16[i2 + 2 >> 1] = i29;
 if (!(i29 << 16 >> 16)) {
  i1 = i2;
  i2 = 0;
 } else {
  i29 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i28 = HEAP32[(HEAP32[i29 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = mftCall_iiiiii(i28 | 0, i29 | 0, i1 << 1 & 131068 | 0, (i2 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 729209 | 0, 44) | 0;
  i1 = HEAP32[i30 >> 2] | 0;
 }
 HEAP32[i1 + 4 >> 2] = i2;
 f26 = Math_fround(Math_fround((i31 + -1 | 0) >>> 0) * Math_fround(.5));
 i27 = (i31 | 0) == 0;
 i28 = i32 + 8 | 0;
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 i29 = 0;
 do {
  if (!i27) {
   i20 = Math_imul(i29, i31) | 0;
   i21 = (i29 | 0) == 0;
   f22 = i21 ? Math_fround(-1.0) : Math_fround(1.0);
   f23 = (i29 | 0) == 2 ? Math_fround(-1.0) : Math_fround(1.0);
   f24 = (i29 | 0) == 4 ? Math_fround(-1.0) : Math_fround(1.0);
   f25 = Math_fround(f22 * f22);
   i19 = 0;
   do {
    f18 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(i19 >>> 0) / f26));
    L10 : do if (i21) {
     f15 = Math_fround(f18 * f18);
     i17 = 0;
     do {
      i16 = (Math_imul(i17 + i20 | 0, i31) | 0) + i19 | 0;
      f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(i17 >>> 0) / f26));
      f3 = Math_fround(Math_sqrt(Math_fround(f15 + Math_fround(Math_fround(f4 * f4) + f25))));
      if (f3 > Math_fround(0.0)) {
       f5 = Math_fround(Math_fround(1.0) / f3);
       f3 = Math_fround(f22 * f5);
       f4 = Math_fround(f4 * f5);
       f5 = Math_fround(f18 * f5);
      } else {
       f3 = f22;
       f5 = f18;
      }
      i1 = HEAP8[(HEAP32[i32 >> 2] | 0) + 38 >> 0] | 0;
      i14 = HEAP32[i28 >> 2] | 0;
      if (!(i1 << 24 >> 24)) {
       i2 = 0;
       i1 = 0;
      } else {
       i2 = i1 & 255;
       i1 = 0;
       i7 = 0;
       i11 = 0;
       f12 = Math_fround(3402823469999999843913219.0e14);
       f13 = Math_fround(3402823469999999843913219.0e14);
       while (1) {
        f6 = Math_fround(f3 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) >> 2]));
        f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) + 4 >> 2])));
        f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) + 8 >> 2])));
        i8 = f6 < f13;
        i1 = i8 ? i11 : i1;
        f9 = Math_fround(-f6);
        i10 = f12 > f9;
        i7 = i10 ? i11 : i7;
        i11 = i11 + 1 | 0;
        if ((i11 | 0) == (i2 | 0)) break; else {
         f12 = i10 ? f9 : f12;
         f13 = i8 ? f6 : f13;
        }
       }
       i2 = i1 & 255;
       i1 = i7 & 255;
      }
      HEAP8[(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0) + i16 >> 0] = i2;
      i14 = HEAP32[i30 >> 2] | 0;
      HEAP8[(HEAP32[i14 + 4 >> 2] | 0) + ((HEAPU16[i14 + 2 >> 1] | 0) + i16) >> 0] = i1;
      i17 = i17 + 1 | 0;
     } while ((i17 | 0) != (i31 | 0));
    } else {
     i17 = 0;
     while (1) {
      i16 = (Math_imul(i17 + i20 | 0, i31) | 0) + i19 | 0;
      switch (i29 | 0) {
      case 1:
      case 0:
       {
        f3 = f22;
        f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(i17 >>> 0) / f26));
        f5 = f18;
        break;
       }
      case 3:
      case 2:
       {
        f3 = f18;
        f4 = f23;
        f5 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(i17 >>> 0) / f26));
        break;
       }
      case 5:
      case 4:
       {
        f3 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(i17 >>> 0) / f26));
        f4 = f18;
        f5 = f24;
        break;
       }
      default:
       {}
      }
      f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)))));
      if (f6 > Math_fround(0.0)) {
       f15 = Math_fround(Math_fround(1.0) / f6);
       f3 = Math_fround(f3 * f15);
       f4 = Math_fround(f4 * f15);
       f5 = Math_fround(f5 * f15);
      }
      i1 = HEAP8[(HEAP32[i32 >> 2] | 0) + 38 >> 0] | 0;
      i14 = HEAP32[i28 >> 2] | 0;
      if (!(i1 << 24 >> 24)) {
       i2 = 0;
       i1 = 0;
      } else {
       i2 = i1 & 255;
       i1 = 0;
       i7 = 0;
       i11 = 0;
       f12 = Math_fround(3402823469999999843913219.0e14);
       f13 = Math_fround(3402823469999999843913219.0e14);
       while (1) {
        f6 = Math_fround(f3 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) >> 2]));
        f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) + 4 >> 2])));
        f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i14 + (i11 * 12 | 0) + 8 >> 2])));
        i8 = f6 < f13;
        i1 = i8 ? i11 : i1;
        f9 = Math_fround(-f6);
        i10 = f12 > f9;
        i7 = i10 ? i11 : i7;
        i11 = i11 + 1 | 0;
        if ((i11 | 0) == (i2 | 0)) break; else {
         f12 = i10 ? f9 : f12;
         f13 = i8 ? f6 : f13;
        }
       }
       i2 = i1 & 255;
       i1 = i7 & 255;
      }
      HEAP8[(HEAP32[(HEAP32[i30 >> 2] | 0) + 4 >> 2] | 0) + i16 >> 0] = i2;
      i14 = HEAP32[i30 >> 2] | 0;
      HEAP8[(HEAP32[i14 + 4 >> 2] | 0) + ((HEAPU16[i14 + 2 >> 1] | 0) + i16) >> 0] = i1;
      i17 = i17 + 1 | 0;
      if ((i17 | 0) == (i31 | 0)) break L10;
     }
    } while (0);
    i19 = i19 + 1 | 0;
   } while ((i19 | 0) != (i31 | 0));
  }
  i29 = i29 + 1 | 0;
 } while ((i29 | 0) != 6);
 return 1;
}

function __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE(i28, i22, i23, i29, i24, i2, i1) {
 i28 = i28 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i29 = i29 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i30 + 48 | 0;
 i26 = i30 + 24 | 0;
 i21 = i30;
 i3 = i29 << 1;
 i3 = (HEAP32[(HEAP32[i23 + 4 >> 2] | 0) + (i3 >> 5 << 2) >> 2] | 0) >>> (i3 & 30) & 3;
 i27 = HEAP32[i22 + (HEAP32[i22 + 160 >> 2] | 0) + (i29 << 3) >> 2] | 0;
 if ((i3 | 0) == 3) {
  if ((i2 | 0) != 1) {
   STACKTOP = i30;
   return;
  }
  i2 = HEAP32[i24 >> 2] | 0;
  i1 = HEAP32[i28 + 76 >> 2] | 0;
  if ((i2 | 0) < (i1 | 0)) {
   i1 = HEAP32[i28 + 68 >> 2] | 0;
   if ((i27 | 0) != (HEAP32[i1 + (i2 << 5) >> 2] | 0)) {
    STACKTOP = i30;
    return;
   }
   i27 = HEAP32[i1 + (i2 << 5) + 4 >> 2] | 0;
   HEAP32[(HEAP32[i28 + 248 >> 2] | 0) + (i27 << 2) >> 2] = i29;
   HEAP32[(HEAP32[i28 + 232 >> 2] | 0) + (i29 << 2) >> 2] = i27;
   STACKTOP = i30;
   return;
  }
  if (!(HEAP32[i27 + 44 >> 2] & 2)) {
   STACKTOP = i30;
   return;
  }
  i1 = i2 - i1 | 0;
  i2 = HEAP32[i28 + 164 >> 2] | 0;
  f40 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) >> 2]);
  f38 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 8 >> 2]);
  f34 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 12 >> 2]);
  f32 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 20 >> 2]);
  f39 = Math_fround(HEAPF32[i27 >> 2]);
  f37 = Math_fround(HEAPF32[i27 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i27 + 8 >> 2]);
  f33 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  f31 = Math_fround(HEAPF32[i27 + 16 >> 2]);
  if (!(f40 == f39 & f38 == f37 & f36 == f35 & f34 == f33 & f32 == f31 & f20 == Math_fround(HEAPF32[i27 + 20 >> 2]))) {
   STACKTOP = i30;
   return;
  }
  i27 = HEAP32[i2 + (i1 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[(HEAP32[i28 + 248 >> 2] | 0) + (i27 << 2) >> 2] = i29;
  HEAP32[(HEAP32[i28 + 232 >> 2] | 0) + (i29 << 2) >> 2] = i27;
  STACKTOP = i30;
  return;
 }
 if ((HEAP32[i23 + 24 >> 2] | 0) > (i29 | 0)) f20 = Math_fround(HEAPF32[(HEAP32[i23 + 12 >> 2] | 0) + (HEAP32[i23 + 16 >> 2] | 0) + (i29 << 2) >> 2]); else {
  f20 = Math_fround(HEAPF32[i1 + 12 + (i3 << 2) >> 2]);
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 + (i3 << 2) >> 2])) * Math_fround(.5));
 }
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i25 >> 2] = i14;
 i15 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i25 + 4 >> 2] = i15;
 i16 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i25 + 8 >> 2] = i16;
 i17 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i25 + 12 >> 2] = i17;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i25 + 16 >> 2] = i18;
 i19 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i25 + 20 >> 2] = i19;
 HEAPF32[i25 + 12 + (i3 << 2) >> 2] = f20;
 HEAP32[i26 >> 2] = i14;
 HEAP32[i26 + 4 >> 2] = i15;
 HEAP32[i26 + 8 >> 2] = i16;
 HEAP32[i26 + 12 >> 2] = i17;
 HEAP32[i26 + 16 >> 2] = i18;
 HEAP32[i26 + 20 >> 2] = i19;
 HEAPF32[i26 + (i3 << 2) >> 2] = f20;
 if ((i2 | 0) > 0) {
  i16 = i28 + 76 | 0;
  i17 = i28 + 68 | 0;
  i18 = i21 + 12 | 0;
  i19 = i21 + 12 + (i3 << 2) | 0;
  i8 = i21 + (i3 << 2) | 0;
  i9 = i28 + 248 | 0;
  i10 = i28 + 232 | 0;
  i11 = i28 + 164 | 0;
  i12 = i21 + 4 | 0;
  i13 = i21 + 8 | 0;
  i14 = i21 + 16 | 0;
  i15 = i21 + 20 | 0;
  i1 = 0;
  i3 = 0;
  do {
   i7 = i24 + (i3 << 2) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   i6 = (i4 | 0) < (i5 | 0);
   if (i6) {
    i41 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i4 << 5) >> 2] | 0;
    i5 = i41 + 12 | 0;
    HEAP32[i21 >> 2] = HEAP32[i41 >> 2];
    HEAP32[i21 + 4 >> 2] = HEAP32[i41 + 4 >> 2];
    HEAP32[i21 + 8 >> 2] = HEAP32[i41 + 8 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i18 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   } else {
    i41 = i4 - i5 | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i5 + (i41 * 40 | 0) >> 2];
    HEAP32[i12 >> 2] = HEAP32[i5 + (i41 * 40 | 0) + 4 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i5 + (i41 * 40 | 0) + 8 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i5 + (i41 * 40 | 0) + 12 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i5 + (i41 * 40 | 0) + 16 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i5 + (i41 * 40 | 0) + 20 >> 2];
   }
   if (!(Math_fround(HEAPF32[i19 >> 2]) <= f20)) {
    if (!(Math_fround(HEAPF32[i8 >> 2]) >= f20)) {
     if (i6) {
      i5 = HEAP32[i17 >> 2] | 0;
      if ((i27 | 0) == (HEAP32[i5 + (i4 << 5) >> 2] | 0)) {
       i4 = HEAP32[i5 + (i4 << 5) + 4 >> 2] | 0;
       HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i29;
       HEAP32[(HEAP32[i10 >> 2] | 0) + (i29 << 2) >> 2] = i4;
       i4 = HEAP32[i7 >> 2] | 0;
      }
     }
     i2 = i2 + -1 | 0;
     i41 = i24 + (i2 << 2) | 0;
     HEAP32[i7 >> 2] = HEAP32[i41 >> 2];
     HEAP32[i41 >> 2] = i4;
     i3 = i3 + -1 | 0;
    }
   } else {
    i5 = i24 + (i1 << 2) | 0;
    if ((i3 | 0) != (i1 | 0)) {
     HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i5 >> 2] = i4;
    }
    i1 = i1 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i2 | 0));
 } else i1 = 0;
 __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE(i28, i22, i23, ((__ZNK5Umbra6KDTree4rankEi(i23, i29) | 0) << 1) + -1 | 0, i24, i1, i25);
 __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE(i28, i22, i23, (__ZNK5Umbra6KDTree4rankEi(i23, i29) | 0) << 1, i24 + (i1 << 2) | 0, i2 - i1 | 0, i26);
 STACKTOP = i30;
 return;
}

function __ZL25processBrokenEdgeIslands2PKjjRN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerEPjS8_S8_RNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEE(i25, i26, i1, i2, i3, i23, i24, i22, i21) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = HEAP32[i2 + 4 >> 2] | 0;
 i18 = HEAP32[i1 + 24 >> 2] | 0;
 i17 = HEAP32[i2 + 24 >> 2] | 0;
 i16 = i3 + 12 | 0;
 _memset(i23 | 0, -1, HEAP32[i16 >> 2] << 2 | 0) | 0;
 _memset(i24 | 0, -1, HEAP32[i16 >> 2] << 2 | 0) | 0;
 _memset(i22 | 0, -1, HEAP32[i16 >> 2] << 2 | 0) | 0;
 if (!i26) return;
 i13 = i3 + 4 | 0;
 i14 = i3 + 16 | 0;
 i15 = i3 + 8 | 0;
 i16 = i3 + 20 | 0;
 i11 = i3 + 36 | 0;
 i12 = 0;
 do {
  i9 = HEAP32[i25 + (i12 << 2) >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i1 + (i9 << 4) >> 2] | 0;
  i4 = HEAP32[i1 + (i9 << 4) + 4 >> 2] | 0;
  i1 = i1 + (i9 << 4) | 0;
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = -1;
  HEAP32[i1 + 8 >> 2] = -1;
  HEAP32[i1 + 12 >> 2] = -1;
  i1 = HEAP32[i15 >> 2] | 0;
  HEAP32[i1 + (i9 << 2) >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i9;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  i10 = (HEAP32[HEAP32[i11 >> 2] >> 2] | 0) + (i9 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~(1 << (i9 & 31));
  i10 = (i3 | 0) == -1;
  L6 : do if (!i10) {
   i2 = i3;
   while (1) {
    i8 = HEAP32[i14 >> 2] | 0;
    i9 = i1 + (i8 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = -1;
    i9 = (HEAP32[i13 >> 2] | 0) + (i8 << 4) | 0;
    HEAP32[i9 >> 2] = -1;
    HEAP32[i9 + 4 >> 2] = -1;
    HEAP32[i9 + 8 >> 2] = -1;
    HEAP32[i9 + 12 >> 2] = -1;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
    i9 = (HEAP32[HEAP32[i11 >> 2] >> 2] | 0) + (i8 >>> 5 << 2) | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1 << (i8 & 31);
    i9 = i18 + (i2 << 2) | 0;
    HEAP32[i23 + (i2 << 2) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i24 + (i2 << 2) >> 2] = i8;
    HEAP32[i22 + (i8 << 2) >> 2] = -1;
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) == -1) break L6;
    i1 = HEAP32[i15 >> 2] | 0;
   }
  } while (0);
  i9 = (i4 | 0) == -1;
  if (!i9) {
   i8 = i4;
   do {
    i6 = i8;
    i8 = HEAP32[i17 + (i8 << 2) >> 2] | 0;
    i1 = HEAP32[i20 + (i6 * 12 | 0) >> 2] | 0;
    i6 = HEAP32[i20 + (i6 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) == -1) {
     i2 = 0;
     i1 = -1;
    } else {
     i1 = HEAP32[i24 + (i1 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) {
      i2 = 0;
      i1 = -1;
     } else {
      i2 = 0;
      while (1) {
       i2 = i2 + 1 | 0;
       i5 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
       if ((i5 | 0) == -1) break; else i1 = i5;
      }
     }
    }
    do if ((i6 | 0) != -1) {
     i5 = HEAP32[i24 + (i6 << 2) >> 2] | 0;
     if ((i5 | 0) != -1) {
      i6 = 0;
      while (1) {
       i6 = i6 + 1 | 0;
       i7 = HEAP32[i22 + (i5 << 2) >> 2] | 0;
       if ((i7 | 0) == -1) break; else i5 = i7;
      }
      if (!((i1 | 0) == (i5 | 0) | (i1 | 0) == -1)) if (i2 >>> 0 < i6 >>> 0) {
       HEAP32[i22 + (i1 << 2) >> 2] = i5;
       break;
      } else {
       HEAP32[i22 + (i5 << 2) >> 2] = i1;
       break;
      }
     }
    } while (0);
   } while ((i8 | 0) != -1);
  }
  if (!i10) {
   i5 = HEAP32[i13 >> 2] | 0;
   i6 = i3;
   do {
    i1 = HEAP32[i24 + (i6 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = -1; else while (1) {
     i2 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
     if ((i2 | 0) == -1) break; else i1 = i2;
    }
    HEAP32[i19 + (i6 * 12 | 0) + 4 >> 2] = i1;
    i8 = i5 + (i1 << 4) | 0;
    HEAP32[i18 + (i6 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i6;
    i8 = i5 + (i1 << 4) + 8 | 0;
    i7 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = (i7 | 0) == -1 ? i6 : i7;
    i6 = HEAP32[i23 + (i6 << 2) >> 2] | 0;
   } while ((i6 | 0) != -1);
   if (!i10) do {
    i1 = HEAP32[i24 + (i3 << 2) >> 2] | 0;
    i2 = HEAP32[i13 >> 2] | 0;
    if ((HEAP32[i2 + (i1 << 4) >> 2] | 0) == -1) {
     i8 = i2 + (i1 << 4) | 0;
     HEAP32[i8 >> 2] = -1;
     HEAP32[i8 + 4 >> 2] = -1;
     HEAP32[i8 + 8 >> 2] = -1;
     HEAP32[i8 + 12 >> 2] = -1;
     HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i14 >> 2];
     HEAP32[i14 >> 2] = i1;
     HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
     i8 = ~(1 << (i1 & 31));
     i10 = i1 >>> 5;
     i7 = (HEAP32[HEAP32[i11 >> 2] >> 2] | 0) + (i10 << 2) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & i8;
     i10 = (HEAP32[i21 >> 2] | 0) + (i10 << 2) | 0;
     HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & i8;
    } else {
     i10 = (HEAP32[i21 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
     HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << (i1 & 31);
    }
    i3 = HEAP32[i23 + (i3 << 2) >> 2] | 0;
   } while ((i3 | 0) != -1);
  }
  if (!i9) do {
   i1 = i17 + (i4 << 2) | 0;
   i5 = i4;
   i4 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i20 + (i5 * 12 | 0) >> 2] | 0;
   i3 = HEAP32[i20 + (i5 * 12 | 0) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) {
    if ((i3 | 0) != -1) {
     i10 = HEAP32[i19 + (i3 * 12 | 0) + 4 >> 2] | 0;
     i9 = HEAP32[i13 >> 2] | 0;
     i8 = i9 + (i10 << 4) + 4 | 0;
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i8 >> 2] = i5;
     i10 = i9 + (i10 << 4) + 12 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = (i9 | 0) == -1 ? i5 : i9;
    }
   } else {
    i10 = HEAP32[i19 + (i2 * 12 | 0) + 4 >> 2] | 0;
    i9 = HEAP32[i13 >> 2] | 0;
    i8 = i9 + (i10 << 4) + 4 | 0;
    HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    i10 = i9 + (i10 << 4) + 12 | 0;
    i9 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = (i9 | 0) == -1 ? i5 : i9;
   }
  } while ((i4 | 0) != -1);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i26 | 0));
 return;
}

function __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i22 = i25;
 i19 = HEAP32[i1 >> 2] | 0;
 i20 = HEAP32[i1 + 8 >> 2] | 0;
 i21 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i19) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 if (!((i21 | 0) != 0 & (HEAP32[i1 + 36 >> 2] | 0) != 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i7 = HEAP8[i1 + 39 >> 0] | 0;
 if ((i7 & 255) < 4) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i8 = HEAP8[i1 + 38 >> 0] | 0;
 i18 = i8 << 24 >> 24 == 0;
 if (i18) {
  f4 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  i1 = i8 & 255;
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
  i6 = 0;
  do {
   f27 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i19 + (i6 * 12 | 0) + 8 >> 2]);
   f27 = Math_fround(Math_abs(Math_fround(f27)));
   f5 = f27 > f5 ? f27 : f5;
   f26 = Math_fround(Math_abs(Math_fround(f26)));
   f3 = f26 > f3 ? f26 : f3;
   f4 = Math_fround(Math_abs(Math_fround(f4)));
   f2 = f4 > f2 ? f4 : f2;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i1 >>> 0);
  f4 = Math_fround(f2 + Math_fround(.0199999996));
  f3 = Math_fround(f3 + Math_fround(.0199999996));
  f2 = Math_fround(f5 + Math_fround(.0199999996));
 }
 i17 = i22;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAPF32[i23 >> 2] = f2;
 HEAPF32[i23 + 4 >> 2] = f3;
 HEAPF32[i23 + 8 >> 2] = f4;
 f26 = Math_fround(-f3);
 f27 = Math_fround(-f4);
 HEAPF32[i23 + 12 >> 2] = f2;
 HEAPF32[i23 + 16 >> 2] = f26;
 HEAPF32[i23 + 20 >> 2] = f27;
 HEAPF32[i23 + 24 >> 2] = f2;
 HEAPF32[i23 + 28 >> 2] = f3;
 HEAPF32[i23 + 32 >> 2] = f27;
 HEAPF32[i23 + 36 >> 2] = f2;
 HEAPF32[i23 + 40 >> 2] = f26;
 HEAPF32[i23 + 44 >> 2] = f4;
 f5 = Math_fround(-f2);
 HEAPF32[i23 + 48 >> 2] = f5;
 HEAPF32[i23 + 52 >> 2] = f3;
 HEAPF32[i23 + 56 >> 2] = f4;
 HEAPF32[i23 + 60 >> 2] = f5;
 HEAPF32[i23 + 64 >> 2] = f26;
 HEAPF32[i23 + 68 >> 2] = f4;
 HEAPF32[i23 + 72 >> 2] = f5;
 HEAPF32[i23 + 76 >> 2] = f3;
 HEAPF32[i23 + 80 >> 2] = f27;
 HEAPF32[i23 + 84 >> 2] = f5;
 HEAPF32[i23 + 88 >> 2] = f26;
 HEAPF32[i23 + 92 >> 2] = f27;
 L16 : do if (!(i7 << 24 >> 24)) i1 = 0; else {
  i16 = i7 & 255;
  i17 = i8 & 255;
  i14 = i8 & 255;
  i15 = 0;
  do {
   i10 = i21 + (i15 * 20 | 0) | 0;
   i11 = i21 + (i15 * 20 | 0) + 4 | 0;
   i12 = i21 + (i15 * 20 | 0) + 8 | 0;
   i13 = i21 + (i15 * 20 | 0) + 12 | 0;
   i6 = 0;
   do {
    i1 = i22 + i6 | 0;
    if (!(HEAP8[i1 >> 0] | 0)) {
     f27 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) >> 2]);
     f27 = Math_fround(f27 * Math_fround(HEAPF32[i10 >> 2]));
     f26 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 4 >> 2]);
     f26 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i11 >> 2])));
     f27 = Math_fround(HEAPF32[i23 + (i6 * 12 | 0) + 8 >> 2]);
     f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2])));
     if (Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f27) >= Math_fround(0.0)) HEAP8[i1 >> 0] = 1;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != 8);
   L27 : do if (!i18) {
    i9 = HEAP8[i21 + (i15 * 20 | 0) + 18 >> 0] | 0;
    i6 = i9 & 255;
    if (!(i9 << 24 >> 24)) {
     f5 = Math_fround(HEAPF32[i10 >> 2]);
     f4 = Math_fround(HEAPF32[i11 >> 2]);
     f3 = Math_fround(HEAPF32[i12 >> 2]);
     f2 = Math_fround(HEAPF32[i13 >> 2]);
     i1 = 0;
     while (1) {
      f27 = Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) >> 2]) * f5);
      f27 = Math_fround(f27 + Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) + 4 >> 2]) * f4));
      if (Math_fround(f2 + Math_fround(f27 + Math_fround(Math_fround(HEAPF32[i19 + (i1 * 12 | 0) + 8 >> 2]) * f3))) > Math_fround(.0199999996)) {
       i1 = 0;
       break L16;
      }
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i17 >>> 0) break L27;
     }
    }
    i7 = HEAPU16[i21 + (i15 * 20 | 0) + 16 >> 1] | 0;
    i8 = 0;
    do {
     i1 = i8 & 255;
     i9 = 0;
     while (1) {
      if ((HEAP8[i20 + (i7 + i9) >> 0] | 0) == i1 << 24 >> 24) break;
      i9 = i9 + 1 | 0;
      if (i9 >>> 0 >= i6 >>> 0) {
       i24 = 17;
       break;
      }
     }
     if ((i24 | 0) == 17) {
      i24 = 0;
      f27 = Math_fround(HEAPF32[i19 + (i8 * 12 | 0) >> 2]);
      f27 = Math_fround(f27 * Math_fround(HEAPF32[i10 >> 2]));
      f26 = Math_fround(HEAPF32[i19 + (i8 * 12 | 0) + 4 >> 2]);
      f26 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i11 >> 2])));
      f27 = Math_fround(HEAPF32[i19 + (i8 * 12 | 0) + 8 >> 2]);
      f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2])));
      if (Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f27) > Math_fround(.0199999996)) {
       i1 = 0;
       break L16;
      }
     }
     i8 = i8 + 1 | 0;
    } while (i8 >>> 0 < i14 >>> 0);
   } while (0);
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < i16 >>> 0);
  if (!(HEAP8[i22 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 1 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 2 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 3 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 4 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 5 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i22 + 6 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[i22 + 7 >> 0] | 0) != 0;
 } while (0);
 i24 = i1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN2UI14CanvasRenderer7SetMeshEP4Mesh(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17;
 i4 = i17 + 8 | 0;
 i5 = i15 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i14 = i1 + 4 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
  if (!(HEAP32[i14 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 HEAP32[i5 >> 2] = 0;
 i12 = i15 + 76 | 0;
 i13 = i15 + 92 | 0;
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i15 + 80 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 HEAP32[i12 >> 2] = 0;
 i14 = i15 + 88 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 i1 = i15 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f20 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i1 = i15 + 64 | 0;
 HEAPF32[i1 >> 2] = f20;
 i2 = i15 + 68 | 0;
 HEAPF32[i2 >> 2] = f19;
 i3 = i15 + 72 | 0;
 HEAPF32[i3 >> 2] = f18;
 if (!i16) {
  i14 = i15 + 162 | 0;
  i16 = HEAP16[i14 >> 1] | 0;
  i16 = i16 & 65535;
  i16 = i16 | 2085;
  i16 = i16 & 65535;
  HEAP16[i14 >> 1] = i16;
  i14 = HEAP32[gb + 1467948 >> 2] | 0;
  i16 = i15 + 188 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i14, i16, i15);
  STACKTOP = i17;
  return;
 }
 HEAP32[i5 >> 2] = __ZN4Mesh21AcquireSharedMeshDataEv(i16) | 0;
 f26 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f18 = Math_fround(HEAPF32[i16 + 60 >> 2]);
 f23 = Math_fround(f26 - f18);
 f25 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f19 = Math_fround(HEAPF32[i16 + 64 >> 2]);
 f22 = Math_fround(f25 - f19);
 f24 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 f20 = Math_fround(HEAPF32[i16 + 68 >> 2]);
 f21 = Math_fround(f24 - f20);
 f18 = Math_fround(f26 + f18);
 f19 = Math_fround(f25 + f19);
 f20 = Math_fround(f24 + f20);
 HEAPF32[i15 + 52 >> 2] = f23;
 HEAPF32[i15 + 56 >> 2] = f22;
 HEAPF32[i15 + 60 >> 2] = f21;
 HEAPF32[i1 >> 2] = f18;
 HEAPF32[i2 >> 2] = f19;
 HEAPF32[i3 >> 2] = f20;
 if ((__ZNK4Mesh15GetSubMeshCountEv(i16) | 0) >>> 0 > 8) {
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0, i16 | 0) | 0;
  HEAP32[i6 + 4 >> 2] = 8;
  __Z6FormatPKcz(i4, gb + 1011633 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1011708 | 0, 214, 512, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 if (!(__ZNK4Mesh15GetSubMeshCountEv(i16) | 0)) {
  i14 = i15 + 162 | 0;
  i16 = HEAP16[i14 >> 1] | 0;
  i16 = i16 & 65535;
  i16 = i16 | 2085;
  i16 = i16 & 65535;
  HEAP16[i14 >> 1] = i16;
  i14 = HEAP32[gb + 1467948 >> 2] | 0;
  i16 = i15 + 188 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i14, i16, i15);
  STACKTOP = i17;
  return;
 }
 i10 = i16 + 32 | 0;
 i11 = i15 + 80 | 0;
 i9 = 0;
 do {
  if (!(__ZNK4Mesh15GetSubMeshCountEv(i16) | 0)) i1 = 0; else i1 = (__ZNK4Mesh15GetSubMeshCountEv(i16) | 0) + -1 | 0;
  i2 = (i1 | 0) < (i9 | 0) ? i1 : i9;
  i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + 128 >> 2] | 0;
  i4 = i3 + (i2 * 52 | 0) | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[i13 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i13 >> 2] = i1;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 * 52 | 0, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 52 | 0, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i14 >> 2] | 0) * 52 | 0) | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i14 >> 2] = i6;
  i8 = HEAP32[i12 >> 2] | 0;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i8 + (i5 * 52 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i8 + (i5 * 52 | 0) + 8 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 8 >> 2];
  HEAP32[i8 + (i5 * 52 | 0) + 12 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 12 >> 2];
  HEAP32[i8 + (i5 * 52 | 0) + 16 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 16 >> 2];
  HEAP32[i8 + (i5 * 52 | 0) + 20 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 20 >> 2];
  HEAP32[i8 + (i5 * 52 | 0) + 24 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 24 >> 2];
  HEAP32[i8 + (i5 * 52 | 0) + 28 >> 2] = HEAP32[i3 + (i2 * 52 | 0) + 28 >> 2];
  i8 = i8 + (i5 * 52 | 0) + 32 | 0;
  i7 = i3 + (i2 * 52 | 0) + 32 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  i9 = i9 + 1 | 0;
 } while (i9 >>> 0 < (__ZNK4Mesh15GetSubMeshCountEv(i16) | 0) >>> 0);
 i14 = i15 + 162 | 0;
 i16 = HEAP16[i14 >> 1] | 0;
 i16 = i16 & 65535;
 i16 = i16 | 2085;
 i16 = i16 & 65535;
 HEAP16[i14 >> 1] = i16;
 i14 = HEAP32[gb + 1467948 >> 2] | 0;
 i16 = i15 + 188 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i14, i16, i15);
 STACKTOP = i17;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 56 | 0;
 i8 = i17 + 48 | 0;
 i13 = i17 + 24 | 0;
 i7 = i17 + 16 | 0;
 i5 = i17 + 44 | 0;
 i6 = i17 + 40 | 0;
 i12 = i17;
 i15 = i14 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 24 | 0;
 i4 = i1;
 if (i3 >>> 0 >= i9 >>> 0) {
  if (i3 >>> 0 <= i9 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i5 = HEAP32[i14 + 12 >> 2] | 0;
  i6 = i4 + (i9 * 24 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  i10 = i12 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i11 = i12 + 12 | 0;
  HEAP32[i11 >> 2] = i5;
  i3 = i9 * 24 | 0;
  i4 = (i3 | 0) / 24 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i12 + 8 | 0;
   i8 = i12;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
    i2 = HEAP32[i11 >> 2] | 0;
   } else i2 = i5;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i2;
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i12 >> 2] = i5;
   i9 = i12 + 8 | 0;
   HEAP32[i9 >> 2] = i5 + (i4 * 24 | 0);
   HEAP32[i13 >> 2] = i1;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i12, i8, i16, i4);
   i6 = i10;
   i7 = i9;
   i8 = i12;
   i1 = HEAP32[i14 >> 2] | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  i5 = i14 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i5 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i4 = i16 + 4 | 0;
    while (1) {
     i1 = i2 + -24 | 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i2 + -20 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i15 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i4 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i7 = i14 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 24 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i14, i9 - i3 | 0);
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 i10 = i13 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i11 = i13 + 12 | 0;
 HEAP32[i11 >> 2] = i2;
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj(i13, i9);
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i13, i8, i16);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 24 | 0;
 i4 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i13, i9 - i1 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i6 = i3 + (i9 * 24 | 0) | 0;
  if ((i4 | 0) != (i6 | 0)) {
   i5 = i16 + 4 | 0;
   i1 = i4;
   while (1) {
    i2 = i1 + -24 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = i1 + -20 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i3 >> 2] | 0;
     i12 = HEAP32[i1 + -8 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i5 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i16);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i2;
   }
  }
 }
 i5 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i5;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i2 = i13 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i4 = i16 + 4 | 0;
   while (1) {
    i1 = i2 + -24 | 0;
    HEAP32[i10 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     i15 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i4 >> 2] = i15;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i15 = HEAP32[i11 >> 2] | 0;
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i28, i4, i27, i29, i30, i31, i32) {
 i28 = i28 | 0;
 i4 = i4 | 0;
 i27 = i27 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, i26 = 0;
 f1 = Math_fround(HEAPF32[i29 >> 2]);
 f11 = Math_fround(HEAPF32[i27 >> 2]);
 f21 = Math_fround(f1 - f11);
 i23 = i29 + 4 | 0;
 f2 = Math_fround(HEAPF32[i23 >> 2]);
 i24 = i27 + 4 | 0;
 f14 = Math_fround(HEAPF32[i24 >> 2]);
 f25 = Math_fround(f2 - f14);
 i26 = i29 + 8 | 0;
 f3 = Math_fround(HEAPF32[i26 >> 2]);
 i15 = i27 + 8 | 0;
 f13 = Math_fround(HEAPF32[i15 >> 2]);
 f16 = Math_fround(f3 - f13);
 f6 = Math_fround(HEAPF32[i30 >> 2]);
 f17 = Math_fround(f6 - f11);
 i18 = i30 + 4 | 0;
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f19 = Math_fround(f7 - f14);
 i20 = i30 + 8 | 0;
 f8 = Math_fround(HEAPF32[i20 >> 2]);
 f22 = Math_fround(f8 - f13);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f9 - f11);
 f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(f10 - f14);
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(f5 - f13);
 f12 = Math_fround(Math_fround(Math_fround(f21 * f11) + Math_fround(f25 * f14)) + Math_fround(f16 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f17 * f11) + Math_fround(f19 * f14)) + Math_fround(f22 * f13));
 if (f12 <= Math_fround(0.0) & f13 <= Math_fround(0.0)) {
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i15 >> 2];
  return;
 }
 f1 = Math_fround(f9 - f1);
 f14 = Math_fround(f10 - f2);
 f11 = Math_fround(f5 - f3);
 f2 = Math_fround(Math_fround(Math_fround(f21 * f1) + Math_fround(f25 * f14)) + Math_fround(f16 * f11));
 f11 = Math_fround(Math_fround(Math_fround(f17 * f1) + Math_fround(f19 * f14)) + Math_fround(f22 * f11));
 if (!(!(f2 >= Math_fround(0.0)) | !(f11 <= f2))) {
  HEAPF32[i31 >> 2] = Math_fround(1.0);
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i26 >> 2];
  return;
 }
 f14 = Math_fround(Math_fround(f12 * f11) - Math_fround(f2 * f13));
 if (f2 <= Math_fround(0.0) & (f12 >= Math_fround(0.0) & f14 <= Math_fround(0.0))) {
  f19 = Math_fround(f12 / Math_fround(f12 - f2));
  HEAPF32[i31 >> 2] = f19;
  HEAPF32[i32 >> 2] = Math_fround(0.0);
  f21 = Math_fround(f21 * f19);
  f22 = Math_fround(f25 * f19);
  f25 = Math_fround(f16 * f19);
  f21 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f21);
  f22 = Math_fround(f22 + Math_fround(HEAPF32[i24 >> 2]));
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i15 >> 2]));
  HEAPF32[i28 >> 2] = f21;
  HEAPF32[i28 + 4 >> 2] = f22;
  HEAPF32[i28 + 8 >> 2] = f25;
  return;
 }
 f9 = Math_fround(f9 - f6);
 f10 = Math_fround(f10 - f7);
 f6 = Math_fround(f5 - f8);
 f1 = Math_fround(Math_fround(Math_fround(f21 * f9) + Math_fround(f25 * f10)) + Math_fround(f16 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f9) + Math_fround(f19 * f10)) + Math_fround(f22 * f6));
 if (!(!(f6 >= Math_fround(0.0)) | !(f1 <= f6))) {
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i32 >> 2] = Math_fround(1.0);
  HEAP32[i28 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i20 >> 2];
  return;
 }
 f5 = Math_fround(Math_fround(f1 * f13) - Math_fround(f12 * f6));
 if (f6 <= Math_fround(0.0) & (f13 >= Math_fround(0.0) & f5 <= Math_fround(0.0))) {
  f25 = Math_fround(f13 / Math_fround(f13 - f6));
  HEAPF32[i31 >> 2] = Math_fround(0.0);
  HEAPF32[i32 >> 2] = f25;
  f21 = Math_fround(f17 * f25);
  f19 = Math_fround(f19 * f25);
  f25 = Math_fround(f22 * f25);
  f21 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f21);
  f22 = Math_fround(f19 + Math_fround(HEAPF32[i24 >> 2]));
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i15 >> 2]));
  HEAPF32[i28 >> 2] = f21;
  HEAPF32[i28 + 4 >> 2] = f22;
  HEAPF32[i28 + 8 >> 2] = f25;
  return;
 }
 f3 = Math_fround(Math_fround(f2 * f6) - Math_fround(f1 * f11));
 if (f3 <= Math_fround(0.0)) {
  f2 = Math_fround(f11 - f2);
  if (f2 >= Math_fround(0.0)) {
   f1 = Math_fround(f1 - f6);
   if (f1 >= Math_fround(0.0)) {
    f19 = Math_fround(f2 / Math_fround(f2 + f1));
    HEAPF32[i31 >> 2] = Math_fround(Math_fround(1.0) - f19);
    HEAPF32[i32 >> 2] = f19;
    f21 = Math_fround(HEAPF32[i30 >> 2]);
    f17 = Math_fround(HEAPF32[i29 >> 2]);
    f21 = Math_fround(f21 - f17);
    f22 = Math_fround(HEAPF32[i18 >> 2]);
    f14 = Math_fround(HEAPF32[i23 >> 2]);
    f22 = Math_fround(f22 - f14);
    f16 = Math_fround(HEAPF32[i20 >> 2]);
    f25 = Math_fround(HEAPF32[i26 >> 2]);
    f22 = Math_fround(f14 + Math_fround(f19 * f22));
    f25 = Math_fround(f25 + Math_fround(f19 * Math_fround(f16 - f25)));
    HEAPF32[i28 >> 2] = Math_fround(f17 + Math_fround(f19 * f21));
    HEAPF32[i28 + 4 >> 2] = f22;
    HEAPF32[i28 + 8 >> 2] = f25;
    return;
   }
  }
 }
 f13 = Math_fround(Math_fround(1.0) / Math_fround(f14 + Math_fround(f3 + f5)));
 f12 = Math_fround(f5 * f13);
 f14 = Math_fround(f14 * f13);
 HEAPF32[i31 >> 2] = f12;
 HEAPF32[i32 >> 2] = f14;
 f13 = Math_fround(f21 * f12);
 f21 = Math_fround(f25 * f12);
 f25 = Math_fround(f16 * f12);
 f16 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f13);
 f21 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f21);
 f21 = Math_fround(Math_fround(f19 * f14) + f21);
 f25 = Math_fround(Math_fround(f22 * f14) + Math_fround(f25 + Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(f17 * f14) + f16);
 HEAPF32[i28 + 4 >> 2] = f21;
 HEAPF32[i28 + 8 >> 2] = f25;
 return;
}

function __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i1, i22, i17, i18, i2, i12) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 52 | 0;
 i16 = i24 + 48 | 0;
 i4 = i24 + 44 | 0;
 i13 = i24 + 40 | 0;
 i14 = i24 + 36 | 0;
 i20 = i24 + 32 | 0;
 i21 = i24 + 28 | 0;
 i5 = i24 + 24 | 0;
 i6 = i24 + 20 | 0;
 i7 = i24 + 16 | 0;
 i8 = i24 + 12 | 0;
 i9 = i24 + 8 | 0;
 i10 = i24 + 4 | 0;
 i11 = i24;
 switch (i18 | 0) {
 case 2:
  {
   i4 = HEAP32[i22 >> 2] | 0;
   i5 = i4 + -8 | 0;
   HEAP32[i22 >> 2] = i5;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 >= i3 >>> 0) {
    STACKTOP = i24;
    return;
   }
   HEAP32[i1 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i21 = i1 + 4 | 0;
   i23 = i4 + -4 | 0;
   i22 = HEAP32[i21 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i23 >> 2] = i22;
   STACKTOP = i24;
   return;
  }
 case 1:
 case 0:
  {
   STACKTOP = i24;
   return;
  }
 default:
  {
   if ((i18 | 0) < 1) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i22 >> 2] | 0;
    if ((i10 | 0) == (i9 | 0)) {
     STACKTOP = i24;
     return;
    }
    i1 = i10 + 8 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     STACKTOP = i24;
     return;
    } else i3 = i10;
    while (1) {
     i2 = i1;
     i8 = HEAP32[i1 >> 2] | 0;
     i7 = HEAP32[i3 + 12 >> 2] | 0;
     L12 : do if ((i1 | 0) != (i10 | 0)) {
      i6 = i8;
      i5 = i1;
      do {
       i3 = i5;
       i5 = i5 + -8 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if (i6 >>> 0 >= i4 >>> 0) break L12;
       i23 = i2;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i23 + 4 >> 2] = HEAP32[i3 + -4 >> 2];
       i2 = i23 + -8 | 0;
      } while ((i5 | 0) != (i10 | 0));
     } while (0);
     HEAP32[i2 >> 2] = i8;
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = i1 + 8 | 0;
     if ((i2 | 0) == (i9 | 0)) break; else {
      i3 = i1;
      i1 = i2;
     }
    }
    STACKTOP = i24;
    return;
   }
   i19 = i18 >>> 1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = i1 + (i19 << 3) | 0;
   if ((i18 | 0) > (i12 | 0)) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
    __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i16, i15, i17, i19, i2, i12);
    HEAP32[i7 >> 2] = i3;
    i22 = HEAP32[i22 >> 2] | 0;
    HEAP32[i8 >> 2] = i22;
    i23 = i18 - i19 | 0;
    HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
    __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i16, i15, i17, i23, i2, i12);
    HEAP32[i9 >> 2] = i1;
    HEAP32[i10 >> 2] = i3;
    HEAP32[i11 >> 2] = i22;
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
    __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi(i4, i16, i15, i17, i19, i23, i2, i12);
    STACKTOP = i24;
    return;
   }
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = i3;
   HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   __ZNSt3__218__stable_sort_moveIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeE(i16, i15, i17, i19, i2);
   HEAP32[i20 >> 2] = i3;
   HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
   i8 = i2 + (i19 << 3) | 0;
   HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
   __ZNSt3__218__stable_sort_moveIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeE(i16, i15, i17, i18 - i19 | 0, i8);
   i7 = i2 + (i18 << 3) | 0;
   i3 = i8;
   while (1) {
    if ((i3 | 0) == (i7 | 0)) break;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    i6 = i1;
    if (i4 >>> 0 < i5 >>> 0) {
     HEAP32[i1 >> 2] = i4;
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     i3 = i3 + 8 | 0;
    } else {
     HEAP32[i1 >> 2] = i5;
     HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     i2 = i2 + 8 | 0;
    }
    i1 = i6 + 8 | 0;
    if ((i2 | 0) == (i8 | 0)) {
     i23 = 14;
     break;
    }
   }
   if ((i23 | 0) == 14) {
    if ((i3 | 0) == (i7 | 0)) {
     STACKTOP = i24;
     return;
    } else i2 = i3;
    while (1) {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 8 | 0;
    }
    STACKTOP = i24;
    return;
   }
   if ((i2 | 0) == (i8 | 0)) {
    STACKTOP = i24;
    return;
   }
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 8 | 0;
   }
   STACKTOP = i24;
   return;
  }
 }
}

function __ZN19MemoryProfilerStats14RegisterObjectEP6Object(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i1 + 8 | 0;
 i11 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i13 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
 i9 = i1;
 do if ((i11 | 0) == 28) {
  i6 = i10 + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 + 24 >> 2] = i7;
  i2 = i7 + 1 | 0;
  i3 = i10 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i2 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i10 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i2;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] = i9;
 } else {
  i6 = i10 + 20 | 0;
  if ((i11 | 0) == 43) {
   i7 = i10 + 32 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = i8;
   i2 = i8 + 1 | 0;
   i3 = i10 + 36 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
   break;
  }
  i6 = i10 + 40 | 0;
  if ((i11 | 0) == 21) {
   i7 = i10 + 52 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = i8;
   i2 = i8 + 1 | 0;
   i3 = i10 + 56 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i10 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
   break;
  }
  i6 = i10 + 60 | 0;
  if ((i11 | 0) == 74) {
   i7 = i10 + 72 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = i8;
   i2 = i8 + 1 | 0;
   i3 = i10 + 76 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
   break;
  }
  i6 = i10 + 80 | 0;
  if ((i11 | 0) == 83) {
   i7 = i10 + 92 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 + 24 >> 2] = i8;
   i2 = i8 + 1 | 0;
   i3 = i10 + 96 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i10 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
  }
 } while (0);
 i1 = i10 + 120 | 0;
 if ((HEAP32[i10 + 132 >> 2] | 0) >>> 0 <= i11 >>> 0) {
  HEAP32[i12 >> 2] = 0;
  __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i1, i11 + 1 | 0, i12, 1);
 }
 i12 = (HEAP32[i1 >> 2] | 0) + (i11 << 2) | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 if (HEAP32[i13 >> 2] & 1048576 | 0) {
  i13 = i10 + 100 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  STACKTOP = i14;
  return;
 }
 i13 = i10 + 104 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 if ((i11 | 0) != 1) {
  STACKTOP = i14;
  return;
 }
 i13 = i10 + 108 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 STACKTOP = i14;
 return;
}

function __ZN23ForwardShaderRenderLoop17PrepareShadowMapsEPK11ActiveLightRK11CullResults(i5, i4, i12) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 do if (!i4) i4 = 0; else {
  i1 = __Z20FindShadowMapInCacheP14ShadowMapCachei(HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 1728 >> 2] | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0) | 0;
  i2 = i5 + 328 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 + 188 >> 2] = i4;
  if (!i1) {
   i1 = i5 + 304 | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-.00999999977));
   i11 = i5 + 308 | 0;
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(-.00999999977));
   i11 = i5 + 312 | 0;
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(-.00999999977));
   i11 = i5 + 316 | 0;
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(.00999999977));
   i11 = i5 + 320 | 0;
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(.00999999977));
   i11 = i5 + 324 | 0;
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(.00999999977));
   HEAP32[i5 + 332 >> 2] = __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB(i12, i4, i1) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i4 = (HEAP32[i5 + 332 >> 2] | 0) == 0 ? 0 : i4;
    break;
   }
  }
  i2 = i5 + 192 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = 0;
   break;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i5 + 196 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i5 + 200 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f16 = Math_fround(i11 | 0);
  f15 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i5 + 204 >> 2] = i3;
  HEAP32[i5 + 208 >> 2] = i2;
  HEAPF32[i5 + 212 >> 2] = f16;
  HEAPF32[i5 + 216 >> 2] = f15;
  i2 = i5 + 220 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i13, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 } while (0);
 i10 = HEAP32[i5 + 352 >> 2] | 0;
 if ((i10 | 0) <= 0) {
  STACKTOP = i14;
  return i4 | 0;
 }
 i11 = i5 + 340 | 0;
 i9 = i5 + 8 | 0;
 i8 = 0;
 do {
  i7 = HEAP32[i11 >> 2] | 0;
  i2 = i7 + (i8 * 152 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i4 | 0) != (i3 | 0)) {
   i1 = __Z20FindShadowMapInCacheP14ShadowMapCachei(HEAP32[(HEAP32[i9 >> 2] | 0) + 1728 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0) | 0;
   i6 = i7 + (i8 * 152 | 0) + 140 | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i3;
   if (!i1) {
    i1 = i7 + (i8 * 152 | 0) + 116 | 0;
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-.00999999977));
    i5 = i7 + (i8 * 152 | 0) + 120 | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(-.00999999977));
    i5 = i7 + (i8 * 152 | 0) + 124 | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(-.00999999977));
    i5 = i7 + (i8 * 152 | 0) + 128 | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(.00999999977));
    i5 = i7 + (i8 * 152 | 0) + 132 | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(.00999999977));
    i5 = i7 + (i8 * 152 | 0) + 136 | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(.00999999977));
    HEAP32[i7 + (i8 * 152 | 0) + 144 >> 2] = __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB(i12, i3, i1) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    if (!i1) break;
   }
   i2 = i7 + (i8 * 152 | 0) + 4 | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   if (!i5) HEAP32[i2 >> 2] = 0; else {
    HEAP32[i2 >> 2] = HEAP32[i5 + 48 >> 2];
    HEAP32[i7 + (i8 * 152 | 0) + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 148 >> 2] | 0, i5 | 0) | 0;
    HEAP32[i7 + (i8 * 152 | 0) + 12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0, i5 | 0) | 0;
    i3 = HEAP32[i5 + 68 >> 2] | 0;
    i2 = HEAP32[i5 + 72 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0, i5 | 0) | 0;
    f15 = Math_fround(i1 | 0);
    f16 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0, i5 | 0) | 0);
    HEAP32[i7 + (i8 * 152 | 0) + 16 >> 2] = i3;
    HEAP32[i7 + (i8 * 152 | 0) + 20 >> 2] = i2;
    HEAPF32[i7 + (i8 * 152 | 0) + 24 >> 2] = f15;
    HEAPF32[i7 + (i8 * 152 | 0) + 28 >> 2] = f16;
    i2 = i7 + (i8 * 152 | 0) + 32 | 0;
    i3 = HEAP32[i5 + 56 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i5 + 60 >> 2] | 0; else i1 = 0;
    __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i13, i3, i1);
    HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i7 + (i8 * 152 | 0) + 52 | 0;
   i1 = i1 + 4 | 0;
   i2 = i3 + 64 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  } while (0);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i10 | 0));
 STACKTOP = i14;
 return i4 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEbT0_S7_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 switch (i18 - i17 >> 5 | 0) {
 case 2:
  {
   i8 = i18 + -32 | 0;
   i9 = i18 + -28 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   i6 = i17 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   do if ((i10 | 0) == (i7 | 0)) {
    i4 = i18 + -24 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i5 = i17 + 8 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if ((i1 | 0) != (i2 | 0)) {
     if ((i1 | 0) < (i2 | 0)) {
      i3 = i5;
      break;
     } else i1 = 1;
     return i1 | 0;
    }
    i2 = HEAP32[i18 + -20 >> 2] | 0;
    i3 = HEAP32[i17 + 12 >> 2] | 0;
    if ((i2 | 0) == (i3 | 0)) {
     if ((HEAP32[i8 >> 2] | 0) < (HEAP32[i17 >> 2] | 0)) {
      i3 = i5;
      i2 = i1;
      break;
     } else i1 = 1;
     return i1 | 0;
    } else {
     if (i2 >>> 0 < i3 >>> 0) {
      i3 = i5;
      i2 = i1;
      break;
     } else i1 = 1;
     return i1 | 0;
    }
   } else if ((i10 | 0) < (i7 | 0)) {
    i2 = i17 + 8 | 0;
    i1 = i18 + -24 | 0;
    i4 = i1;
    i3 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    break;
   } else {
    i18 = 1;
    return i18 | 0;
   } while (0);
   i15 = HEAP32[i17 >> 2] | 0;
   i14 = i17 + 12 | 0;
   i16 = HEAP32[i14 >> 2] | 0;
   HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i6 >> 2] = i10;
   HEAP32[i3 >> 2] = i1;
   i18 = i18 + -20 | 0;
   HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i8 >> 2] = i15;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i18 >> 2] = i16;
   i18 = 1;
   return i18 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i17, i17 + 32 | 0, i18 + -32 | 0, i1) | 0;
   i18 = 1;
   return i18 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_(i17, i17 + 32 | 0, i17 + 64 | 0, i18 + -32 | 0, i1) | 0;
   i18 = 1;
   return i18 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i17, i17 + 32 | 0, i17 + 64 | 0, i17 + 96 | 0, i18 + -32 | 0, i1) | 0;
   i18 = 1;
   return i18 | 0;
  }
 case 1:
 case 0:
  {
   i18 = 1;
   return i18 | 0;
  }
 default:
  {
   i3 = i17 + 64 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i17, i17 + 32 | 0, i3, i1) | 0;
   i1 = i17 + 96 | 0;
   L3 : do if ((i1 | 0) == (i18 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i9 = i1 + 4 | 0;
     i15 = HEAP32[i9 >> 2] | 0;
     i11 = i3 + 4 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     do if ((i15 | 0) == (i10 | 0)) {
      i7 = i1 + 8 | 0;
      i8 = HEAP32[i7 >> 2] | 0;
      i6 = i3 + 8 | 0;
      i4 = HEAP32[i6 >> 2] | 0;
      if ((i8 | 0) != (i4 | 0)) if ((i8 | 0) < (i4 | 0)) {
       i14 = i8;
       i16 = 23;
       break;
      } else break;
      i4 = HEAP32[i1 + 12 >> 2] | 0;
      i5 = HEAP32[i3 + 12 >> 2] | 0;
      if ((i4 | 0) == (i5 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) {
       i14 = i8;
       i4 = i8;
       i16 = 23;
       break;
      } else break; else if (i4 >>> 0 < i5 >>> 0) {
       i14 = i8;
       i4 = i8;
       i16 = 23;
       break;
      } else break;
     } else if ((i15 | 0) < (i10 | 0)) {
      i14 = i1 + 8 | 0;
      i4 = i3 + 8 | 0;
      i6 = i4;
      i7 = i14;
      i14 = HEAP32[i14 >> 2] | 0;
      i4 = HEAP32[i4 >> 2] | 0;
      i16 = 23;
     } while (0);
     if ((i16 | 0) == 23) {
      i16 = 0;
      i12 = HEAP32[i1 >> 2] | 0;
      i8 = i1 + 12 | 0;
      i13 = HEAP32[i8 >> 2] | 0;
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i9 >> 2] = i10;
      HEAP32[i7 >> 2] = i4;
      i4 = i3 + 12 | 0;
      HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
      L18 : do if ((i3 | 0) == (i17 | 0)) i5 = i11; else {
       i5 = i11;
       i11 = i3;
       while (1) {
        i3 = i11 + -32 | 0;
        i10 = i11 + -28 | 0;
        i9 = HEAP32[i10 >> 2] | 0;
        do if ((i15 | 0) == (i9 | 0)) {
         i8 = i11 + -24 | 0;
         i7 = HEAP32[i8 >> 2] | 0;
         if ((i14 | 0) != (i7 | 0)) if ((i14 | 0) < (i7 | 0)) {
          i6 = i8;
          i4 = i7;
          break;
         } else {
          i3 = i11;
          break L18;
         }
         i7 = HEAP32[i11 + -20 >> 2] | 0;
         if ((i13 | 0) == (i7 | 0)) if ((i12 | 0) < (HEAP32[i3 >> 2] | 0)) {
          i6 = i8;
          i4 = i14;
          break;
         } else {
          i3 = i11;
          break L18;
         } else if (i13 >>> 0 < i7 >>> 0) {
          i6 = i8;
          i4 = i14;
          break;
         } else {
          i3 = i11;
          break L18;
         }
        } else {
         if ((i15 | 0) >= (i9 | 0)) {
          i3 = i11;
          break L18;
         }
         i4 = i11 + -24 | 0;
         i6 = i4;
         i4 = HEAP32[i4 >> 2] | 0;
        } while (0);
        HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i11 + 4 >> 2] = i9;
        HEAP32[i11 + 8 >> 2] = i4;
        i4 = i11 + -20 | 0;
        HEAP32[i11 + 12 >> 2] = HEAP32[i4 >> 2];
        if ((i3 | 0) == (i17 | 0)) {
         i5 = i10;
         break;
        } else {
         i5 = i10;
         i11 = i3;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = i12;
      HEAP32[i5 >> 2] = i15;
      HEAP32[i6 >> 2] = i14;
      HEAP32[i4 >> 2] = i13;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 32 | 0) == (i18 | 0);
       break L3;
      }
     }
     i3 = i1 + 32 | 0;
     if ((i3 | 0) == (i18 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i15 = i1;
      i1 = i3;
      i3 = i15;
     }
    }
   } while (0);
   i18 = i1 | i2;
   return i18 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE(i17, i18, i6, i7, i2) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 104 | 0;
 i13 = i19 + 88 | 0;
 i9 = i19 + 8 | 0;
 i4 = i19;
 i23 = i19 + 32 | 0;
 i22 = i19 + 16 | 0;
 i12 = i19 + 72 | 0;
 i14 = i19 + 56 | 0;
 i10 = i19 + 48 | 0;
 i11 = i19 + 12 | 0;
 HEAP16[i17 >> 1] = 0;
 HEAP16[i17 + 2 >> 1] = 0;
 i16 = i17 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i10 | 0, i12 | 0);
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 | 0, i14 | 0);
 i1 = HEAP32[i18 >> 2] | 0;
 i21 = HEAP32[i1 + 1116 >> 2] | 0;
 i20 = HEAP32[i10 >> 2] | 0;
 HEAP32[i23 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i8 = i17 + 2 | 0;
 i3 = HEAP32[i1 + 1108 >> 2] | 0;
 i1 = HEAP32[i1 + 1112 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 i1 = mftCall_iiiiiiii(i21 | 0, i20 | 0, i13 | 0, i5 | 0, i15 | 0, i8 | 0, i3 | 0, i1 | 0) | 0;
 HEAP16[i17 >> 1] = i1;
 i3 = i1 & 65535;
 do if (i3 & 4) {
  if (!(HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0)) {
   HEAP16[i17 >> 1] = i3 & 65523;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 701939 | 0, 1219, gb + 702028 | 0, i4);
   i1 = HEAP16[i17 >> 1] | 0;
   break;
  }
  if (!i2) i2 = __ZN5physx2Sc10NPhaseCore16createFilterPairEv(i18) | 0;
  i23 = i6 + 12 | 0;
  i23 = _bitshift64Lshr(HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0, 30) | 0;
  getTempRet0() | 0;
  switch (i23 & 3 | 0) {
  case 0:
   {
    i5 = __ZN5physx2Sc8RigidSim10getPxActorEv(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i6) | 0) | 0;
    i4 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i6 + 28 >> 2] | 0) | 0;
    break;
   }
  case 1:
   {
    i5 = __ZN5physx2Sc18ParticleSystemCore17getPxParticleBaseEv(__ZNK5physx2Sc17ParticleSystemSim7getCoreEv(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i6) | 0) | 0) | 0;
    i4 = 0;
    break;
   }
  default:
   {
    i5 = 0;
    i4 = 0;
   }
  }
  i23 = i7 + 12 | 0;
  i23 = _bitshift64Lshr(HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0, 30) | 0;
  getTempRet0() | 0;
  switch (i23 & 3 | 0) {
  case 0:
   {
    i3 = __ZN5physx2Sc8RigidSim10getPxActorEv(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i7) | 0) | 0;
    i1 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i7 + 28 >> 2] | 0) | 0;
    break;
   }
  case 1:
   {
    i3 = __ZN5physx2Sc18ParticleSystemCore17getPxParticleBaseEv(__ZNK5physx2Sc17ParticleSystemSim7getCoreEv(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i7) | 0) | 0) | 0;
    i1 = 0;
    break;
   }
  default:
   {
    i3 = 0;
    i1 = 0;
   }
  }
  i20 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
  i7 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i22 = HEAP32[i10 >> 2] | 0;
  i23 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  i1 = mftCall_iiiiiiiiiiii(i7 | 0, i20 | 0, i21 | 0, i22 | 0, i13 | 0, i5 | 0, i4 | 0, i23 | 0, i15 | 0, i3 | 0, i1 | 0, i8 | 0) | 0;
  HEAP16[i17 >> 1] = i1;
  HEAP32[i16 >> 2] = i2;
 } while (0);
 if ((i1 & 3) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 701939 | 0, 850, gb + 702085 | 0, i9);
  i1 = i1 & 65534;
 }
 HEAP16[i17 >> 1] = i1;
 if (!i2) {
  STACKTOP = i19;
  return;
 }
 switch (i1 & 13) {
 case 13:
  {
   i21 = HEAP32[(HEAP32[i18 >> 2] | 0) + 1120 >> 2] | 0;
   i20 = HEAP32[(HEAP32[i21 >> 2] | 0) + 4 >> 2] | 0;
   i22 = HEAP32[i2 >> 2] | 0;
   i23 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   mftCall_viiiiiii(i20 | 0, i21 | 0, i22 | 0, i23 | 0, i13 | 0, i1 | 0, i15 | 0, 0);
   i1 = HEAP16[i17 >> 1] | 0;
   break;
  }
 case 12:
  {
   STACKTOP = i19;
   return;
  }
 default:
  {}
 }
 i1 = i1 & 65535;
 if ((i1 & 12 | 0) != 12) HEAP16[i17 >> 1] = i1 & 65523;
 __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i18, i2);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZN5Umbra12PortalCuller9enterTileERKNS0_4TileE(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 16 | 0;
 i7 = i11;
 i5 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i5 + 60 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = ((i4 | 0) < 0 ? 0 : i4) + 1;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i5, i10 + 2692 | 0, HEAP32[i8 + 4 >> 2] | 0);
 i5 = HEAP32[i10 + 2720 >> 2] | 0;
 if (!(HEAP8[i10 + 7040 >> 0] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[i10 + 2700 >> 2] | 0) + 16 >> 2] & 1;
 HEAP8[i10 + 7041 >> 0] = i1;
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 i9 = i5 + 52 | 0;
 i4 = HEAP32[i9 >> 2] & 65535;
 HEAP32[i10 + 2856 >> 2] = i4;
 HEAP32[i10 + 2828 >> 2] = (i1 | 0) == 0 ? 0 : i5 + i1 | 0;
 i1 = HEAP32[i10 + 2724 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i3 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   i3 = HEAP32[i10 + 2704 >> 2] | 0;
   i2 = i1;
   i1 = i4;
  }
 }
 HEAP32[i10 + 2892 >> 2] = i1;
 HEAP32[i10 + 2864 >> 2] = (i2 | 0) == 0 ? 0 : i3 + i2 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f22 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 HEAP32[i10 + 2308 >> 2] = i4;
 HEAP32[i10 + 2312 >> 2] = i1;
 HEAP32[i10 + 2316 >> 2] = i3;
 HEAPF32[i10 + 2320 >> 2] = Math_fround(1.0);
 f20 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f15 - f20);
 f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f22 - f18);
 f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = Math_fround(f30 * Math_fround(.0000152590219));
 f29 = Math_fround(f29 * Math_fround(.0000152590219));
 f28 = Math_fround(Math_fround(f21 - f17) * Math_fround(.0000152590219));
 HEAPF32[i10 + 2324 >> 2] = f30;
 HEAPF32[i10 + 2328 >> 2] = f29;
 HEAPF32[i10 + 2332 >> 2] = f28;
 HEAPF32[i10 + 2336 >> 2] = Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i5 + 1208 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 1212 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 1216 >> 2]);
 f19 = Math_fround(f12 + f19);
 f14 = Math_fround(f12 + f14);
 f13 = Math_fround(f12 + f13);
 f12 = Math_fround(Math_fround(HEAPF32[i5 + 1220 >> 2]) + Math_fround(0.0));
 f25 = Math_fround(HEAPF32[i5 + 1184 >> 2]);
 f27 = Math_fround(HEAPF32[i5 + 1188 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 1192 >> 2]);
 i3 = f30 == Math_fround(0.0);
 f16 = Math_fround(Math_fround(1.0) / f30);
 f16 = i3 ? Math_fround(1.0) : f16;
 i3 = f29 == Math_fround(0.0);
 f24 = Math_fround(Math_fround(1.0) / f29);
 f24 = i3 ? Math_fround(1.0) : f24;
 i3 = f28 == Math_fround(0.0);
 f23 = Math_fround(Math_fround(1.0) / f28);
 f23 = i3 ? Math_fround(1.0) : f23;
 f16 = Math_fround(Math_fround(f16 + f16) - Math_fround(f16 * Math_fround(f30 * f16)));
 f24 = Math_fround(Math_fround(f24 + f24) - Math_fround(f24 * Math_fround(f29 * f24)));
 f23 = Math_fround(Math_fround(f23 + f23) - Math_fround(f23 * Math_fround(f28 * f23)));
 i3 = ~~Math_fround(Math_fround(f27 - f18) * f24);
 i1 = ~~Math_fround(Math_fround(f26 - f17) * f23);
 i4 = i10 + 2656 | 0;
 HEAP32[i4 >> 2] = ~~Math_fround(Math_fround(f25 - f20) * f16);
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = -2;
 i4 = ~~Math_fround(Math_fround(f14 * f24) + Math_fround(1.0));
 i1 = ~~Math_fround(Math_fround(f13 * f23) + Math_fround(1.0));
 i3 = ~~Math_fround(Math_fround(f12 * Math_fround(2.0)) + Math_fround(1.0));
 i2 = i10 + 2672 | 0;
 HEAP32[i2 >> 2] = ~~Math_fround(Math_fround(f19 * f16) + Math_fround(1.0));
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 12 >> 2] = i3;
 HEAPF32[i10 + 2352 >> 2] = f19;
 HEAPF32[i10 + 2356 >> 2] = f14;
 HEAPF32[i10 + 2360 >> 2] = f13;
 HEAPF32[i10 + 2364 >> 2] = f12;
 f18 = Math_fround(f18 - f14);
 f17 = Math_fround(f17 - f13);
 f16 = Math_fround(Math_fround(1.0) - f12);
 f15 = Math_fround(f15 + f19);
 f14 = Math_fround(f22 + f14);
 f13 = Math_fround(f21 + f13);
 f12 = Math_fround(f12 + Math_fround(1.0));
 HEAPF32[i6 >> 2] = Math_fround(f20 - f19);
 HEAPF32[i6 + 4 >> 2] = f18;
 HEAPF32[i6 + 8 >> 2] = f17;
 HEAPF32[i6 + 12 >> 2] = f16;
 HEAPF32[i7 >> 2] = f15;
 HEAPF32[i7 + 4 >> 2] = f14;
 HEAPF32[i7 + 8 >> 2] = f13;
 HEAPF32[i7 + 12 >> 2] = f12;
 __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i5, i10 + 2732 | 0, 0, i6, i7) | 0;
 i5 = HEAP32[i10 + 2300 >> 2] | 0;
 i2 = (HEAP32[i10 + 484 >> 2] | 0) + (HEAP32[i8 >> 2] << 1) | 0;
 i3 = i10 + 7032 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP16[i2 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = i9 << 1;
  i9 = i9 & 131070;
  i10 = i10 + 7048 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 i4 = i5 + 2 | 0;
 do {
  i8 = i1 & 65535;
  i7 = i5 + (i8 << 4) | 0;
  HEAP16[i2 >> 1] = HEAP16[i7 >> 1] | 0;
  HEAP16[i5 + (i8 << 4) + 2 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP16[i7 >> 1] = 0;
  HEAP16[i5 + (HEAPU16[i4 >> 1] << 4) >> 1] = i1;
  HEAP16[i4 >> 1] = i1;
  HEAP16[i10 + 2936 + (HEAPU16[i5 + (i8 << 4) + 4 >> 1] << 1) >> 1] = i8 | 32768;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP16[i2 >> 1] | 0;
 } while (i1 << 16 >> 16 != 0);
 i9 = HEAP32[i9 >> 2] | 0;
 i9 = i9 << 1;
 i9 = i9 & 131070;
 i10 = i10 + 7048 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN5physx26PxConvexMeshRepXSerializer16objectToFileImplEPKNS_12PxConvexMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i7, i6, i1, i16, i15, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i24;
 i13 = i24 + 160 | 0;
 i8 = i24 + 80 | 0;
 i23 = i24 + 8 | 0;
 i17 = i24 + 132 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 if ((i2 | 0) != 0 & (i3 | 0) != 0) {
  i4 = 0;
  do {
   i1 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
   if ((i4 | 0) != 0 & (i4 & 1 | 0) == 0) mftCall_iiii(i1 | 0, i15 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i15 | 0, gb + 1086395 | 0, 1) | 0;
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i15, i2 + (i4 * 12 | 0) | 0) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
  HEAP8[i13 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i13 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, gb + 673324 | 0, HEAP32[i15 + 20 >> 2] | 0);
  HEAP32[i15 + 16 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
 }
 i2 = i5 + 4 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i24;
  return;
 }
 i1 = i8 + 50 | 0;
 i9 = i8;
 i10 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 HEAP16[i8 + 48 >> 1] = 0;
 HEAP16[i1 >> 1] = 256;
 HEAP32[i8 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i8 >> 2] = 12;
 HEAP32[i8 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i8 + 48 >> 1] = 4;
 HEAP32[i23 >> 2] = HEAP32[i7 + 4 >> 2];
 i11 = i23 + 4 | 0;
 HEAP32[i11 >> 2] = i23;
 i18 = i23;
 HEAP32[i23 + 8 >> 2] = i18;
 i21 = i23 + 12 | 0;
 HEAP32[i21 >> 2] = 0;
 i12 = i23 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i22 = i23 + 20 | 0;
 HEAP32[i22 >> 2] = 0;
 i6 = i23 + 24 | 0;
 HEAP32[i6 >> 2] = i18;
 i18 = i23 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAPF32[i23 + 52 >> 2] = Math_fround(.75);
 i19 = i23 + 56 | 0;
 HEAP32[i19 >> 2] = -1;
 HEAP32[i23 + 60 >> 2] = 0;
 i20 = i23 + 64 | 0;
 HEAP32[i20 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i6, 64);
 HEAP32[i23 + 68 >> 2] = 32;
 i6 = i17 + 4 | 0;
 i7 = i17 + 8 | 0;
 HEAP32[i7 >> 2] = i23;
 i4 = i17 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i17 >> 2] = gb + 89528 + 8;
 HEAP32[i6 >> 2] = gb + 89528 + 32;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i8 | 0, i17 | 0, 0) | 0;
 i3 = i17 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != 0 & (i4 | 0) != 0) {
  i5 = 0;
  do {
   i2 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
   if ((i5 | 0) != 0 & (i5 & 15 | 0) == 0) mftCall_iiii(i2 | 0, i15 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i2 | 0, i15 | 0, gb + 1086395 | 0, 1) | 0;
   i2 = HEAPU8[i1 + i5 >> 0] | 0;
   i9 = i13;
   i10 = i9 + 128 | 0;
   do {
    HEAP8[i9 >> 0] = 0;
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) < (i10 | 0));
   HEAP32[i14 >> 2] = i2;
   __ZN5physx6string9sprintf_sEPcjPKcz(i13, 128, gb + 1084495 | 0, i14) | 0;
   if (HEAP8[i13 >> 0] | 0) {
    i10 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
    mftCall_iiii(i10 | 0, i15 | 0, i13 | 0, _strlen(i13) | 0) | 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
  HEAP8[i14 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i14 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, gb + 673178 | 0, HEAP32[i15 + 20 >> 2] | 0);
  HEAP32[i15 + 16 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i17 >> 2] = gb + 89572 + 8;
 HEAP32[i6 >> 2] = gb + 89572 + 32;
 if (i1 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i7 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 i1 = HEAP32[i21 >> 2] | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + (i17 << 2) | 0;
 if (i17 | 0) do {
  i17 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[i23 + 48 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i20 >> 2] | 0) == 0)) {
  _memset(HEAP32[i23 + 40 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i23 + 44 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i23 + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[HEAP32[i23 + 24 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i23 = HEAP32[HEAP32[i23 + 8 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
  }
 }
 STACKTOP = i24;
 return;
}

function _main(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 52 | 0;
 i10 = i14 + 40 | 0;
 i12 = i14 + 20 | 0;
 i13 = i14 + 32 | 0;
 __Z9SetupArgviPPKc(i1, i2);
 __Z9InitInputv();
 __Z20scripting_gc_disablev();
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 491564 | 0, 7);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 364133 | 0, 10);
 __Z24InitializeIl2CppFromMainRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_iPPKc(i9, i10, i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __Z17RuntimeInitializev();
 i4 = _JS_SystemInfo_GetDocumentURL(0, 0) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i12, i4, 0);
 i4 = i12 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 _JS_SystemInfo_GetDocumentURL((i3 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i3 ? HEAP32[i12 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
 __Z33InitializeWebGLPersistentDataPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i12);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 11576 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i9, gb + 1048800 | 0, i14);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 10808 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 10808 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 10808 + (i1 * 12 | 0) >> 2] = fb + 4;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1576256 | 0, 0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1576256 | 0, 0);
 i8 = __Z26PlayerInitEngineNoGraphicsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i9, i10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if (!i8) {
  _printf_console(gb + 364144 | 0, i14 + 8 | 0);
  i13 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(__Z24PlayerInitEngineGraphicsb(0) | 0)) {
  _printf_console(gb + 364144 | 0, i14 + 16 | 0);
  i13 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZN16ScriptingManager33RebuildNativeTypeToScriptingClassEv(__Z19GetScriptingManagerv() | 0);
 i6 = __Z17GetPlayerSettingsv() | 0;
 i1 = i6 + 524 | 0;
 i8 = HEAP8[i4 >> 0] | 0;
 i4 = i8 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
 i8 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + 532 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i8 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + 528 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + 528 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 _JS_FileSystem_SetSyncInterval(1e3);
 __Z20RegisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE(0);
 __Z20PlayerLoadFirstSceneb(0) | 0;
 i4 = HEAP32[(__Z17GetPlayerSettingsv() | 0) + 268 >> 2] | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i10 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 28; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 28; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 30;
   }
  }
  if ((i11 | 0) == 28) i11 = 30;
  if ((i11 | 0) == 30) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 i11 = __Z17GetPlayerSettingsv() | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 + 272 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 276 >> 2];
 __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f(i1, i13);
 _emscripten_set_main_loop(fb + 5 | 0, 0, 1);
 i13 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i9 = i11;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i10);
 i1 = i7 + 32 | 0;
 i5 = i10 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i10 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 28 | 0, i10);
 i1 = i7 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 72 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i4;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 92 | 0;
 if ((i2 + 1 | 0) >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i7 + 94 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i3 = i7 + 168 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i5 = i10 + 8 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i7 + 172 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
 }
 HEAP32[i8 >> 2] = 0;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i3, i1, i8, 1);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, HEAP32[i3 >> 2] | 0, i1 << 2);
 STACKTOP = i11;
 return;
}

function __ZN6Shader23HandleShadersWithErrorsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i8 = HEAP32[gb + 1166332 + 12 >> 2] | 0;
 if (!(i8 | HEAP32[gb + 1166312 + 12 >> 2])) {
  STACKTOP = i12;
  return;
 }
 if (i8 | 0) {
  i7 = 0;
  do {
   i4 = (HEAP32[gb + 1166332 >> 2] | 0) + (i7 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 16;
     }
    }
    if ((i11 | 0) == 14) i11 = 16;
    if ((i11 | 0) == 16) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i4 = i1 + 32 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) != (HEAP32[gb + 1166244 >> 2] | 0)) {
     __ZN9ShaderLab9IntShader27RemoveUnsupportedSubShadersEv(i2);
     i2 = i1 + 36 | 0;
     do if (HEAP32[i2 >> 2] | 0) {
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       HEAP32[i2 >> 2] = 0;
       break;
      } else {
       HEAP32[i2 >> 2] = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(i3, i1 + 40 | 0) | 0;
       break;
      }
     } while (0);
     i6 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i6 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 4 >> 2] | 0;
      i3 = HEAP32[gb + 1166312 + 12 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i5 = HEAP32[gb + 1166312 + 16 >> 2] | 0;
      i6 = i5 & 2147483647;
      do if (i4 >>> 0 > i6 >>> 0) {
       i1 = i5 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[gb + 1166312 + 16 >> 2] = i1;
        i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1166312 >> 2] | 0, i1 << 2, 4, gb + 1166312 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[gb + 1166312 >> 2] = i6;
        break;
       } else {
        i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, gb + 1166312 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i6 | 0, HEAP32[gb + 1166312 >> 2] | 0, HEAP32[gb + 1166312 + 12 >> 2] << 2 | 0) | 0;
        HEAP32[gb + 1166312 + 16 >> 2] = i1;
        HEAP32[gb + 1166312 >> 2] = i6;
        break;
       }
      } while (0);
      HEAP32[gb + 1166312 + 12 >> 2] = i4;
      HEAP32[(HEAP32[gb + 1166312 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     }
    }
   } while (0);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i8 | 0));
 }
 if ((HEAP32[gb + 1166332 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1166332 >> 2] | 0, gb + 1166332 + 4 | 0);
  HEAP32[gb + 1166332 >> 2] = 0;
 }
 HEAP32[gb + 1166332 >> 2] = 0;
 HEAP32[gb + 1166332 + 12 >> 2] = 0;
 HEAP32[gb + 1166332 + 16 >> 2] = 0;
 i6 = HEAP32[gb + 1166312 + 12 >> 2] | 0;
 if (i6 | 0) {
  i5 = 0;
  do {
   i4 = (HEAP32[gb + 1166312 >> 2] | 0) + (i5 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 39; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i8 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 39; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 41;
     }
    }
    if ((i11 | 0) == 39) i11 = 41;
    if ((i11 | 0) == 41) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i2 = i1 + 32 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (HEAP32[gb + 1166244 >> 2] | 0)) {
     if ((HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[gb + 1188344 >> 2] | 0)) HEAP32[gb + 1188348 >> 2] = 0;
     if (i3 | 0) __ZN9ShaderLab9IntShaderD2Ev(i3);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
     HEAP32[i2 >> 2] = HEAP32[gb + 1166244 >> 2];
     HEAP32[i1 + 36 >> 2] = 0;
     HEAP32[i1 + 40 >> 2] = 0;
    }
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 if ((HEAP32[gb + 1166312 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1166312 >> 2] | 0, gb + 1166312 + 4 | 0);
  HEAP32[gb + 1166312 >> 2] = 0;
 }
 HEAP32[gb + 1166312 >> 2] = 0;
 HEAP32[gb + 1166312 + 12 >> 2] = 0;
 HEAP32[gb + 1166312 + 16 >> 2] = 0;
 __ZN8Material26ResetAllCachedMaterialDataEP6Shader(0);
 STACKTOP = i12;
 return;
}

function __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i11, i1, i10, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i12 = i14 + 16 | 0;
 i7 = i14 + 12 | 0;
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 __ZN14ParticleSystem21SendCollisionMessagesERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i11, 0, 0);
 i5 = i10 + 460 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) > 0) {
  i2 = HEAP32[i10 + 456 >> 2] | 0;
  i3 = i10 + 400 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 + (i1 * 112 | 0) + 88 >> 2] | 0) * 600 | 0) + 596 >> 2] | 0;
   if (i4 | 0) __ZN14ParticleSystem4EmitERS_RK21SubEmitterEmitCommand(i4, i2 + (i1 * 112 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  HEAP32[i5 >> 2] = 0;
 }
 __ZN19ParticleSystemState28ClearSubEmitterCommandBufferEv(i10);
 i4 = i11 + 916 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) {
  HEAP32[i12 >> 2] = 0;
  i5 = i12 + 4 | 0;
  i2 = gb + 63160 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i5;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
  i1 = (__ZNK9SubModule19GetSubEmittersCountEv(i1) | 0) << 2;
  do if (!i1) {
   i2 = 0;
   i1 = 0;
  } else {
   i3 = i1 | 3;
   if (i3 >>> 0 < 2e3) {
    i2 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    i1 = 0;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 3240) | 0;
    i6 = gb + 64016 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    HEAP32[i12 >> 2] = i1;
    i2 = i5;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i2 + 4 >> 2] = i6;
    i2 = i1;
    break;
   }
  } while (0);
  i3 = i2 + 3 & -4;
  i2 = __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_(HEAP32[i4 >> 2] | 0, i3, 0, i7, i8, i9) | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    __ZN11ShapeModule15ReleaseMeshDataEv((HEAP32[i3 + (i1 << 2) >> 2] | 0) + 48 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = HEAP32[i11 + 908 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN11TrailModule17UpdateStripLengthER23ParticleSystemParticles(i1, HEAP32[i11 + 32 >> 2] | 0);
 __ZN12LightsModule9FreeCacheER19ParticleSystemState(i10);
 __ZN15CollisionModule9FreeCacheER19ParticleSystemState(i10);
 __ZN20ExternalForcesModule9FreeCacheER19ParticleSystemState(i10);
 __ZN11ShapeModule15ReleaseMeshDataEv(i11 + 48 | 0);
 i3 = i11 + 28 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 80260 | 0) | 0;
 if (i1 | 0) {
  i2 = HEAP32[i11 + 40 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i2 + 368 >> 2]);
  f18 = Math_fround(HEAPF32[i2 + 380 >> 2]);
  f23 = Math_fround(f17 + f18);
  f16 = Math_fround(HEAPF32[i2 + 372 >> 2]);
  f20 = Math_fround(HEAPF32[i2 + 384 >> 2]);
  f22 = Math_fround(f16 + f20);
  f15 = Math_fround(HEAPF32[i2 + 376 >> 2]);
  f19 = Math_fround(HEAPF32[i2 + 388 >> 2]);
  f22 = Math_fround(f22 * Math_fround(.5));
  f21 = Math_fround(Math_fround(f15 + f19) * Math_fround(.5));
  HEAPF32[i12 >> 2] = Math_fround(f23 * Math_fround(.5));
  HEAPF32[i12 + 4 >> 2] = f22;
  HEAPF32[i12 + 8 >> 2] = f21;
  f16 = Math_fround(Math_fround(f20 - f16) * Math_fround(.5));
  f15 = Math_fround(Math_fround(f19 - f15) * Math_fround(.5));
  HEAPF32[i12 + 12 >> 2] = Math_fround(Math_fround(f18 - f17) * Math_fround(.5));
  HEAPF32[i12 + 16 >> 2] = f16;
  HEAPF32[i12 + 20 >> 2] = f15;
  if ((HEAP32[(HEAP32[i11 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1) __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i12, i2 + 52 | 0, i12);
  i9 = i1 + 568 | 0;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  __ZN8Renderer18UpdateManagerStateEb(i1, 1);
 }
 i1 = i10 + 27 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  HEAP8[i1 >> 0] = 0;
  __ZN9Transform20SendTransformChangedEi(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0, 8);
 }
 if (!(HEAP8[(HEAP32[i11 + 920 >> 2] | 0) + 4 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = HEAP32[i2 + 37824 >> 2] | 0;
 L39 : do if (i3 | 0) {
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + 37056 + (i1 * 12 | 0) >> 2] | 0) == (fb + 153 | 0)) {
    if (!(HEAP8[i2 + 37056 + (i1 * 12 | 0) + 8 >> 0] | 0)) {
     i1 = 33;
     break;
    }
    if (!(HEAP32[i2 + 37056 + (i1 * 12 | 0) + 4 >> 2] | 0)) {
     i1 = 33;
     break;
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L39;
  }
  if ((i1 | 0) == 33) {
   STACKTOP = i14;
   return;
  }
 } while (0);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 37824 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i12, gb + 1048800 | 0, i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 37056 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 37056 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 37056 + (i1 * 12 | 0) >> 2] = fb + 153;
 STACKTOP = i14;
 return;
}

function __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader(i19, i10) {
 i19 = i19 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 48 | 0;
 i21 = i25 + 32 | 0;
 i22 = i25 + 16 | 0;
 i23 = i25;
 i24 = i10;
 i6 = i19 + 20 | 0;
 i7 = i19 + 32 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = i8 + 1 | 0;
 i3 = i19 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i19 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i18 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i18;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i2;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i24;
 i1 = i10 + 2344 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i22 + 12 >> 2] = i2;
 i3 = _strlen(i1) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i22);
  i2 = HEAP32[i22 + 12 >> 2] | 0;
  i9 = 12;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i22 + 11 >> 0] = i3;
  if (!i3) i1 = i22; else {
   i2 = i22;
   i9 = 14;
  }
 } else i9 = 12;
 if ((i9 | 0) == 12) {
  i18 = i3 + 16 & -16;
  HEAP32[i20 >> 2] = 54;
  HEAP32[i20 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 8 >> 2] = i18 | -2147483648;
  HEAP32[i22 + 4 >> 2] = i3;
  i9 = 14;
 }
 if ((i9 | 0) == 14) {
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  i1 = i2;
 }
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i18 = i10 + 120 | 0;
 i8 = i10 + 124 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((HEAP32[i8 >> 2] | 0) != (i1 | 0)) {
  i9 = i21 + 11 | 0;
  i10 = i21 + 4 | 0;
  i11 = i23 + 11 | 0;
  i12 = i23 + 8 | 0;
  i13 = i23 + 4 | 0;
  i14 = i21 + 12 | 0;
  i15 = i20 + 4 | 0;
  i16 = i19 + 136 | 0;
  i17 = i19 + 140 | 0;
  i7 = i19 + 148 | 0;
  i6 = 0;
  do {
   __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i21, i22, i1 + (i6 * 40 | 0) + 20 | 0);
   i5 = HEAP8[i9 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
   i5 = i1 ? HEAP32[i10 >> 2] | 0 : i5 & 255;
   i1 = HEAP8[i11 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i12 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   do if (i5 >>> 0 > i3 >>> 0) {
    i19 = i2 ? HEAP32[i13 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i23, i3, i5 - i3 | 0, i19, 0, i19, i5, i4);
   } else {
    i1 = i2 ? HEAP32[i23 >> 2] | 0 : i23;
    if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    if ((HEAP8[i11 >> 0] | 0) < 0) {
     HEAP32[i13 >> 2] = i5;
     break;
    } else {
     HEAP8[i11 >> 0] = i5;
     break;
    }
   } while (0);
   if ((HEAP8[i9 >> 0] | 0) < 0) {
    i19 = HEAP32[i21 >> 2] | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    HEAP32[i20 >> 2] = 54;
    HEAP32[i15 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
   }
   i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSD_(i16, i20, i23) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE25__construct_node_with_keyERSD_(i21, i16, i23);
    i1 = HEAP32[i21 >> 2] | 0;
    HEAP32[i21 >> 2] = 0;
    i2 = HEAP32[i20 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i16 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i17 >> 2] | 0, i2);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   HEAP32[i1 + 32 >> 2] = i24;
   i19 = HEAP32[i18 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = i19 + (i6 * 40 | 0);
   i6 = i6 + 1 | 0;
   i1 = i19;
  } while (i6 >>> 0 < (((HEAP32[i8 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0);
  if ((HEAP8[i11 >> 0] | 0) < 0) {
   i24 = HEAP32[i23 >> 2] | 0;
   i23 = HEAP32[i23 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 54;
   HEAP32[i20 + 4 >> 2] = i23;
   __Z19free_alloc_internalPvRK10MemLabelId(i24, i20);
  }
 }
 if ((HEAP8[i22 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i25;
  return;
 }
 i24 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i22 + 12 >> 2] | 0;
 HEAP32[i20 >> 2] = 54;
 HEAP32[i20 + 4 >> 2] = i23;
 __Z19free_alloc_internalPvRK10MemLabelId(i24, i20);
 STACKTOP = i25;
 return;
}

function __ZN15CollisionModule8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 3);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1047471 | 0, i7, i2 + 136 | 0, 0);
 i8 = i3 + 16 | 0;
 i9 = i3 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619893 | 0, i7, i2 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i4 = i6 + 8 | 0;
 i5 = HEAP32[gb + 37248 >> 2] | 0;
 i1 = 0;
 do {
  i11 = i2 + 972 + (i1 << 2) | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[gb + 82944 + (i1 << 2) >> 2] | 0, gb + 842702 | 0, i11, 0);
  i12 = i4;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i7, i11, 1);
  HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i5, i4, 1);
  HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 6);
 i12 = i2 + 144 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619907 | 0, gb + 620173 | 0, i12, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i12 = i2 + 408 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619916 | 0, gb + 620173 | 0, i12, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i12 = i2 + 672 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619925 | 0, gb + 620173 | 0, i12, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i12 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619949 | 0, i12, i2 + 936 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619962 | 0, i12, i2 + 940 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619975 | 0, i12, i2 + 944 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i11 = i2 + 956 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619987 | 0, gb + 1048681 | 0, i11, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i11, 4194305);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 62e4 | 0, i7, i2 + 952 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 620267 | 0, i7, i2 + 960 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 620019 | 0, i12, i2 + 964 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i12 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 620029 | 0, i12, i2 + 968 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 620047 | 0, i12, i2 + 948 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 620067 | 0, i12, i2 + 949 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 STACKTOP = i10;
 return;
}

function __ZL20AddRequiredClassIMPL11ClassIDTypeS_(i11, i13) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 28 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 4 | 0;
 i17 = i18;
 i1 = gb + 64016 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 i9 = i16 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i16 + 4 >> 2] = i3;
 HEAP32[i16 + 8 >> 2] = i1;
 __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(i11, i16, 0);
 i1 = HEAP32[gb + 1162544 >> 2] | 0;
 if (!(HEAP32[i9 >> 2] | 0)) i5 = i1; else {
  i8 = HEAP32[i16 >> 2] | 0;
  do {
   i6 = HEAP32[i8 >> 2] | 0;
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   do if (!i2) {
    HEAP32[i12 >> 2] = i3;
    i5 = i3;
    i4 = i3;
    i10 = 36;
   } else {
    while (1) {
     i3 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i6 | 0) < (i3 | 0)) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i10 = 29;
       break;
      } else i2 = i3;
     } else {
      if ((i3 | 0) >= (i6 | 0)) {
       i10 = 35;
       break;
      }
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i10 = 33;
       break;
      } else i2 = i3;
     }
    }
    if ((i10 | 0) == 29) {
     HEAP32[i12 >> 2] = i2;
     i5 = i2;
     i4 = i2;
     i10 = 36;
     break;
    } else if ((i10 | 0) == 33) {
     HEAP32[i12 >> 2] = i2;
     i5 = i2;
     i10 = 36;
     break;
    } else if ((i10 | 0) == 35) {
     i10 = 0;
     HEAP32[i12 >> 2] = i2;
     if (!i2) {
      i5 = i2;
      i4 = i12;
      i10 = 36;
      break;
     } else break;
    }
   } while (0);
   if ((i10 | 0) == 36) {
    i10 = 0;
    i2 = __Znwj(32) | 0;
    HEAP32[i2 + 16 >> 2] = i6;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i5;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
    if (!i3) i3 = i2; else {
     HEAP32[i1 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i1 + 4 >> 2] | 0, i3);
    i7 = i1 + 8 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   i7 = i2 + 20 | 0;
   HEAP32[i17 >> 2] = i13;
   i5 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i2 + 24 >> 2] | 0;
   i1 = i6 - i5 >> 2;
   i2 = i5;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i19 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i19 << 2) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
     i4 = i4 + 4 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i19 | 0 : i19;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   i2 = i1;
   if ((i1 | 0) == (i6 | 0)) i10 = 43; else if ((HEAP32[i1 >> 2] | 0) > (i13 | 0)) i10 = 43;
   if ((i10 | 0) == 43) {
    HEAP32[i15 >> 2] = i2;
    HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
    __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i7, i12, i17) | 0;
   }
   i8 = i8 + 4 | 0;
   i1 = HEAP32[gb + 1162544 >> 2] | 0;
  } while ((i8 | 0) != ((HEAP32[i16 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
  i5 = i1;
 }
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i10 = 15;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i11 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i10 = 8;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i11 | 0)) {
     i10 = 14;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i10 = 12;
     break;
    } else i1 = i2;
   }
  }
  if ((i10 | 0) == 8) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   i10 = 15;
   break;
  } else if ((i10 | 0) == 12) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i10 = 15;
   break;
  } else if ((i10 | 0) == 14) {
   HEAP32[i12 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i3 = i12;
    i10 = 15;
    break;
   } else break;
  }
 } while (0);
 if ((i10 | 0) == 15) {
  i1 = __Znwj(32) | 0;
  HEAP32[i1 + 16 >> 2] = i11;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
  i19 = i5 + 8 | 0;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 }
 i7 = i1 + 20 | 0;
 HEAP32[i17 >> 2] = i13;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i19 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i19 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i19 | 0 : i19;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i6 | 0)) i10 = 22; else if ((HEAP32[i1 >> 2] | 0) > (i13 | 0)) i10 = 22;
 if ((i10 | 0) == 22) {
  HEAP32[i15 >> 2] = i2;
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i7, i12, i17) | 0;
 }
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i16 + 4 | 0);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __Z15_CheckFMODError11FMOD_RESULTPKciS1_(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 16 | 0;
 if (!i2) {
  STACKTOP = i8;
  return i2 | 0;
 }
 do switch (i2 | 0) {
 case 1:
  {
   i1 = gb + 883274 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 883139 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 883092 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 883034 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 882997 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 882957 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 882926 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 882885 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 882856 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 882819 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 882757 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 882607 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 882553 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 882416 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 882316 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 882254 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 882069 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 881965 | 0;
   break;
  }
 case 92:
  {
   i1 = gb + 881830 | 0;
   break;
  }
 case 83:
  {
   i1 = gb + 881718 | 0;
   break;
  }
 case 91:
  {
   i1 = gb + 881673 | 0;
   break;
  }
 case 84:
  {
   i1 = gb + 881617 | 0;
   break;
  }
 case 85:
  {
   i1 = gb + 881547 | 0;
   break;
  }
 case 86:
  {
   i1 = gb + 881448 | 0;
   break;
  }
 case 87:
  {
   i1 = gb + 881285 | 0;
   break;
  }
 case 88:
  {
   i1 = gb + 881238 | 0;
   break;
  }
 case 90:
  {
   i1 = gb + 881153 | 0;
   break;
  }
 case 89:
  {
   i1 = gb + 881065 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 881044 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 880938 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 880904 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 880815 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 880798 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 880767 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 880732 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 880650 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 880585 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 880517 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 880486 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 880457 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 880395 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 880349 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 880288 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 880185 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 880130 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 880094 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 880043 | 0;
   break;
  }
 case 38:
  {
   i1 = gb + 879988 | 0;
   break;
  }
 case 39:
  {
   i1 = gb + 879905 | 0;
   break;
  }
 case 40:
  {
   i1 = gb + 879853 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 879791 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 879722 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 879689 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 879565 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 879511 | 0;
   break;
  }
 case 95:
  {
   i1 = gb + 879453 | 0;
   break;
  }
 case 94:
  {
   i1 = gb + 879405 | 0;
   break;
  }
 case 93:
  {
   i1 = gb + 879330 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 879250 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 879170 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 879046 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 878859 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 878818 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 878723 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 878682 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 878614 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 878527 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 878411 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 878372 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 878239 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 878124 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 878024 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 877989 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 877891 | 0;
   break;
  }
 case 62:
  {
   i1 = gb + 877796 | 0;
   break;
  }
 case 63:
  {
   i1 = gb + 877741 | 0;
   break;
  }
 case 64:
  {
   i1 = gb + 877676 | 0;
   break;
  }
 case 65:
  {
   i1 = gb + 877612 | 0;
   break;
  }
 case 66:
  {
   i1 = gb + 877549 | 0;
   break;
  }
 case 67:
  {
   i1 = gb + 877423 | 0;
   break;
  }
 case 68:
  {
   i1 = gb + 877308 | 0;
   break;
  }
 case 69:
  {
   i1 = gb + 877197 | 0;
   break;
  }
 case 70:
  {
   i1 = gb + 877136 | 0;
   break;
  }
 case 71:
  {
   i1 = gb + 876992 | 0;
   break;
  }
 case 75:
  {
   i1 = gb + 876711 | 0;
   break;
  }
 case 72:
  {
   i1 = gb + 876565 | 0;
   break;
  }
 case 73:
  {
   i1 = gb + 876446 | 0;
   break;
  }
 case 74:
  {
   i1 = gb + 876315 | 0;
   break;
  }
 case 76:
  {
   i1 = gb + 876255 | 0;
   break;
  }
 case 77:
  {
   i1 = gb + 876103 | 0;
   break;
  }
 case 78:
  {
   i1 = gb + 876024 | 0;
   break;
  }
 case 79:
  {
   i1 = gb + 875945 | 0;
   break;
  }
 case 80:
  {
   i1 = gb + 875837 | 0;
   break;
  }
 case 81:
  {
   i1 = gb + 875793 | 0;
   break;
  }
 case 82:
  {
   i1 = gb + 875735 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i7 + 8 >> 2] = i5;
 HEAP32[i7 + 12 >> 2] = i1;
 __Z6FormatPKcz(i6, gb + 883334 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return i2 | 0;
}

function __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i1, i13, i14, i5, i6, i15, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 424 | 0;
 i11 = i16;
 i1 = i16 + 24 | 0;
 i18 = i16 + 16 | 0;
 i10 = i16 + 12 | 0;
 i17 = i16 + 8 | 0;
 i7 = i16 + 564 | 0;
 i3 = i16 + 4 | 0;
 i9 = i16 + 464 | 0;
 HEAP32[i18 >> 2] = i1;
 i20 = i18 + 4 | 0;
 HEAP32[i20 >> 2] = fb + 4003;
 i4 = i1 + 400 | 0;
 __THREW__ = 0;
 i2 = invoke_ii(fb + 2804 | 0, i6 | 0) | 0;
 i22 = __THREW__;
 __THREW__ = 0;
 if (i22 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  HEAP32[i18 >> 2] = 0;
  i3 = fb + 4003 | 0;
  i21 = 54;
 } else {
  HEAP32[i17 >> 2] = i2;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i17 | 0, gb + 1474588 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (i22 & 1) {
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   HEAP8[i7 >> 0] = 0;
   HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   __THREW__ = 0;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   i1 = invoke_iiiiiiiiiiii(fb + 2 | 0, i13 | 0, i8 | 0, i5 | 0, i17 | 0, i1 | 0, i15 | 0, i7 | 0, i2 | 0, i18 | 0, i10 | 0, i4 | 0) | 0;
   i22 = __THREW__;
   __THREW__ = 0;
   L7 : do if (i22 & 1) i21 = 11; else {
    L9 : do if (i1) {
     __THREW__ = 0;
     invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, gb + 1079964 | 0, gb + 1079964 + 10 | 0, i8 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i1 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0;
      if ((i1 | 0) > 392) {
       i1 = _malloc((i1 >> 2) + 2 | 0) | 0;
       i2 = i1;
       if (!i1) {
        __THREW__ = 0;
        invoke_v(fb + 459 | 0);
        i22 = __THREW__;
        __THREW__ = 0;
        if (!(i22 & 1)) {
         i1 = 0;
         i21 = 16;
        }
       } else i21 = 16;
      } else {
       i1 = i9;
       i2 = 0;
       i21 = 16;
      }
      do if ((i21 | 0) == 16) {
       if (HEAP8[i7 >> 0] | 0) {
        HEAP8[i1 >> 0] = 45;
        i1 = i1 + 1 | 0;
       }
       i6 = i8 + 40 | 0;
       i7 = i8;
       i5 = HEAP32[i18 >> 2] | 0;
       while (1) {
        if (i5 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break;
        i4 = HEAP32[i5 >> 2] | 0;
        i3 = i8;
        while (1) {
         if ((i3 | 0) == (i6 | 0)) {
          i3 = i6;
          break;
         }
         if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break;
         i3 = i3 + 4 | 0;
        }
        HEAP8[i1 >> 0] = HEAP8[(i3 - i7 >> 2) + (gb + 1079964) >> 0] | 0;
        i5 = i5 + 4 | 0;
        i1 = i1 + 1 | 0;
       }
       HEAP8[i1 >> 0] = 0;
       HEAP32[i11 >> 2] = i12;
       if ((_sscanf(i9, gb + 1084519 | 0, i11) | 0) != 1) {
        __THREW__ = 0;
        invoke_vi(fb + 4004 | 0, gb + 1079853 | 0);
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) break;
       }
       if (i2 | 0) _free(i2);
       break L9;
      } while (0);
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      if (i2 | 0) _free(i2);
     }
     break L7;
    } while (0);
    i1 = HEAP32[i13 >> 2] | 0;
    do if (!i1) i3 = 1; else {
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i21 = 11;
       break L7;
      }
     } else i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i13 >> 2] = 0;
      i3 = 1;
      break;
     } else {
      i3 = (HEAP32[i13 >> 2] | 0) == 0;
      break;
     }
    } while (0);
    i2 = HEAP32[i14 >> 2] | 0;
    do if (!i2) i21 = 44; else {
     i1 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i21 = 11;
       break L7;
      }
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i14 >> 2] = 0;
      i21 = 44;
      break;
     } else if (i3) break; else {
      i21 = 46;
      break;
     }
    } while (0);
    if ((i21 | 0) == 44) if (i3) i21 = 46;
    if ((i21 | 0) == 46) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
    i2 = HEAP32[i13 >> 2] | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i17 >> 2] | 0) | 0;
    i1 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(HEAP32[i20 >> 2] | 0, i1 | 0);
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i22 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i22);
     }
    }
    STACKTOP = i16;
    return i2 | 0;
   } while (0);
   if ((i21 | 0) == 11) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   i2 = i1;
  }
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i17 >> 2] | 0) | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  if (!i1) i19 = i2; else {
   i3 = HEAP32[i20 >> 2] | 0;
   i21 = 54;
  }
 }
 if ((i21 | 0) == 54) {
  __THREW__ = 0;
  invoke_vi(i3 | 0, i1 | 0);
  i22 = __THREW__;
  __THREW__ = 0;
  if (i22 & 1) {
   i22 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i22);
  } else i19 = i2;
 }
 ___resumeException(i19 | 0);
 return 0;
}

function __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i15, i5) {
 i15 = i15 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 136 | 0;
 i13 = i16 + 128 | 0;
 i10 = i16 + 124 | 0;
 i14 = i16 + 32 | 0;
 i9 = i16;
 i4 = i15 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i2 = i4; else {
  i1 = i4;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if (!(__ZNK18VertexChannelsInfoltERKS_(i2 + 16 | 0, i5) | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  i2 = i1;
  if ((i1 | 0) != (i4 | 0)) if (!(__ZNK18VertexChannelsInfoltERKS_(i5, i1 + 16 | 0) | 0)) {
   i15 = i1;
   i15 = i15 + 48 | 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 i3 = i15 + 16 | 0;
 i7 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 i3 = (HEAP8[i5 + 7 >> 0] | 0 ? 2 : 0) | (HEAP8[i5 + 3 >> 0] | 0) != 0 | (HEAP8[i5 + 11 >> 0] | 0 ? 4 : 0) | (HEAP8[i5 + 15 >> 0] | 0 ? 8 : 0) | (HEAP8[i5 + 19 >> 0] | 0 ? 16 : 0) | (HEAP8[i5 + 23 >> 0] | 0 ? 32 : 0) | (HEAP8[i5 + 27 >> 0] | 0 ? 64 : 0) | (HEAP8[i5 + 31 >> 0] | 0 ? 128 : 0);
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 i5 = i14 + 40 | 0;
 i8 = i14 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 80 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i14 + 84 >> 2] = 0;
 i6 = i14 + 32 | 0;
 HEAP32[i6 >> 2] = i7;
 i7 = i14 + 36 | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i14 + 76 | 0, 0, 0);
 i3 = i14 + 88 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 i2 = __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i15, i12, i13, i14) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) {
  i4 = HEAP32[i15 + 8 >> 2] | 0;
  HEAP32[i12 >> 2] = 16;
  HEAP32[i12 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(108, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i12 = i4 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i12 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  i10 = i4 + 56 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 20 >> 2] = 0;
  HEAP32[i10 + 24 >> 2] = 0;
  HEAP32[i10 + 28 >> 2] = 0;
  i1 = i4 + 92 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 96 >> 2] = 0;
  HEAP32[i4 + 100 >> 2] = 0;
  HEAP32[i4 + 48 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 52 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP8[i4 + 88 >> 0] = HEAP8[i14 + 72 >> 0] | 0;
  if ((i12 | 0) != (i14 | 0)) __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i1, HEAP32[i8 >> 2] | 0, HEAP32[i11 >> 2] | 0);
  HEAP8[i4 + 104 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
  if (!i1) i1 = i4; else {
   HEAP32[i15 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 + 4 >> 2] | 0, i1);
  i15 = i15 + 12 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i11 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i3 + (~((i3 + -16 - i2 | 0) >>> 4) << 4);
  __ZdlPv(i1);
 }
 i15 = i4;
 i15 = i15 + 48 | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN14ParticleSystem18Update1IncrementalERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesfNS_11UpdateFlagsE(i27, i28, i30, i31, f32, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 f32 = Math_fround(f32);
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0, d38 = 0.0, i39 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i36 + 16 | 0;
 i34 = i36;
 i35 = i30 + 396 | 0;
 i29 = Math_fround(HEAPF32[i35 >> 2]) == Math_fround(0.0);
 i11 = (i1 & 2 | 0) != 0;
 f2 = Math_fround(HEAPF32[i30 >> 2]);
 if (!(f2 >= f32)) {
  STACKTOP = i36;
  return;
 }
 i12 = i28 + 264 | 0;
 i13 = i30 + 4 | 0;
 i14 = i28 + 277 | 0;
 i15 = i30 + 13 | 0;
 i16 = i27 + 268 | 0;
 i17 = i30 + 488 | 0;
 i18 = i27 + 272 | 0;
 i19 = i27 + 880 | 0;
 i20 = i31 + 12 | 0;
 i21 = i34 + 12 | 0;
 i22 = i34 + 8 | 0;
 i23 = i34 + 4 | 0;
 i24 = i30 + 480 | 0;
 i25 = i30 + 468 | 0;
 i26 = i27 + 40 | 0;
 i10 = i27 + 32 | 0;
 f3 = f32;
 do {
  if (f2 > Math_fround(10.0)) {
   if (!(f3 > Math_fround(1.0))) {
    f3 = Math_fround(HEAPF32[i12 >> 2]);
    i6 = f3 < Math_fround(1.0);
    f3 = i6 ? f3 : Math_fround(1.0);
   }
  } else if (f2 > Math_fround(5.0)) {
   if (!(f3 > Math_fround(.200000003))) {
    f3 = Math_fround(HEAPF32[i12 >> 2]);
    i6 = f3 < Math_fround(.200000003);
    f3 = i6 ? f3 : Math_fround(.200000003);
   }
  } else f3 = f32;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = Math_fround(HEAPF32[i35 >> 2]);
  if (Math_fround(HEAPF32[i13 >> 2]) == Math_fround(0.0)) {
   __ZN19ParticleSystemState4TickERK27ParticleSystemReadOnlyStatef(i30, i28, f3);
   f9 = Math_fround(HEAPF32[i35 >> 2]);
   f2 = Math_fround(HEAPF32[i30 >> 2]);
  } else f9 = f8;
  f37 = Math_fround(HEAPF32[i12 >> 2]);
  f7 = Math_fround(Math_fround(f2 / f3) + Math_fround(-1.0));
  i6 = f7 > Math_fround(0.0);
  f7 = i6 ? f7 : Math_fround(0.0);
  if (!(!(f9 >= f37) | (HEAP8[i14 >> 0] | 0) != 0)) {
   i4 = HEAP32[i26 >> 2] | 0;
   HEAP8[i4 + 12 >> 0] = 1;
   HEAP8[i4 + 13 >> 0] = 1;
   d38 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
   HEAPF64[(HEAP32[i26 >> 2] | 0) + 40 >> 3] = d38;
   i4 = HEAP32[i10 >> 2] | 0;
   if (!(HEAP32[i4 + 12 >> 2] | 0)) {
    __ZN23ParticleSystemParticles12array_resizeEj(i4, 0);
    i4 = HEAP32[i10 >> 2] | 0;
    HEAP32[i4 + 652 >> 2] = 0;
    HEAP32[i4 + 672 >> 2] = 0;
    HEAP32[i4 + 692 >> 2] = 0;
    HEAP32[i4 + 712 >> 2] = 0;
    if (HEAP32[i4 + 732 >> 2] | 0) _memset(HEAP32[i4 + 728 >> 2] | 0, 0, HEAP32[i4 + 736 >> 2] << 2 | 0) | 0;
    i4 = HEAP32[i26 >> 2] | 0;
    HEAP32[i4 + 480 >> 2] = 0;
    i4 = i4 + 32 | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    i4 = HEAP32[i26 >> 2] | 0;
    if (HEAP8[i4 + 13 >> 0] | 0) HEAP32[i4 + 8 >> 2] = 0;
    __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i27, HEAP32[i10 >> 2] | 0, i4);
   }
  }
  if (i11) {
   i5 = HEAP32[i24 >> 2] | 0;
   if (i5 | 0) {
    i6 = HEAP32[i25 >> 2] | 0;
    i4 = 0;
    do {
     i39 = i6 + (i4 * 24 | 0) + 4 | 0;
     HEAPF32[i39 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i39 >> 2]));
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i5 >>> 0);
   }
  } else {
   HEAPF32[i33 >> 2] = f3;
   i39 = HEAP32[i20 >> 2] | 0;
   HEAPF32[i21 >> 2] = f3;
   HEAPF32[i22 >> 2] = f3;
   HEAPF32[i23 >> 2] = f3;
   HEAPF32[i34 >> 2] = f3;
   __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i27, i28, i30, i31, 0, i39, i34);
   __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj(i27, i28, i30, i31, 0, i33, 0);
   HEAPF32[i34 >> 2] = f3;
   __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i27, i28, i30, i31, 0, i34);
  }
  if (!(HEAP8[i15 >> 0] | 0)) {
   if (i29) {
    f2 = Math_fround(HEAPF32[i13 >> 2]);
    if (f2 > Math_fround(0.0)) {
     f37 = Math_fround(f2 - f3);
     HEAPF32[i13 >> 2] = f37;
     HEAPF32[i33 >> 2] = Math_fround(-f37);
     HEAPF32[i34 >> 2] = Math_fround(0.0);
     i1 = f37 > Math_fround(-0.0);
     i1 = HEAP32[(i1 ? i34 : i33) >> 2] | 0;
     HEAPF32[i33 >> 2] = Math_fround(0.0);
     i39 = f37 < Math_fround(0.0);
     HEAP32[i13 >> 2] = HEAP32[(i39 ? i33 : i13) >> 2];
    }
   }
   f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i39 = !(f2 > Math_fround(0.0));
   if (!(i39 | (HEAP8[i16 >> 0] | 0) == 0)) {
    HEAP32[i33 >> 2] = 0;
    i1 = __ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff(i17, i33, i18, f8, f9, Math_fround(HEAPF32[i12 >> 2])) | 0;
    i4 = HEAP32[i33 >> 2] | 0;
    if (i11) __ZN14ParticleSystem24StartParticlesProceduralERS_R23ParticleSystemParticlesfffjjf(i27, 0, Math_fround(0.0), f9, f2, i4, i1, Math_fround(0.0)); else __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf(i27, i31, Math_fround(0.0), f9, f2, i4, i1, f7);
   }
  }
  f2 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) - f3);
  HEAPF32[i30 >> 2] = f2;
  if (!(i11 | !(f2 >= f3))) if (HEAP8[(HEAP32[i19 >> 2] | 0) + 4 >> 0] | 0) {
   __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i27, i31, i30);
   f2 = Math_fround(HEAPF32[i30 >> 2]);
  }
 } while (f2 >= f3);
 STACKTOP = i36;
 return;
}

function __ZN9Texture2D8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15;
 i14 = i15 + 32 | 0;
 i4 = i15 + 28 | 0;
 i5 = i15 + 24 | 0;
 i6 = i15 + 20 | 0;
 i7 = i15 + 16 | 0;
 i8 = i15 + 12 | 0;
 i11 = i15 + 8 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i13);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i13, 2);
 i10 = i12 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i9 + 8 | 0);
  i2 = i1 + 28 | 0;
  i9 = i9 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  i2 = HEAP32[i10 >> 2] | 0;
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i2 = i14 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i9 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i17 = i3;
 i1 = HEAP32[i17 + 4 >> 2] | 0;
 i16 = i9;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 1;
 i16 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 932215 | 0, i16, i3, 16);
 i3 = i13 + 16 | 0;
 i1 = i13 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 932223 | 0, i16, i4, 16);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 411088 | 0, i16, i6, 16);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 411108 | 0, i16, i5, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 410444 | 0, i16, i8, 16);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i12 + 111 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 411133 | 0, i16, i7, 16);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 411146 | 0, i16, i12 + 80 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 i8 = i12 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 431875 | 0, gb + 431893 | 0, i8, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i13);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 431979 | 0, i16, i12 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i13, gb + 932818 | 0, i16, i12 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i13);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i11 >> 2] = i1;
 __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i13, i11, gb + 411165 | 0, 1);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i13, HEAP32[i11 >> 2] | 0, i1, 0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i13, 2, gb + 411176 | 0, i12 + 120 | 0, i1, 0);
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i9);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx27PxcFsGetImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_(i10, i8, i6, i4, i9, i7, i5) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 64 | 0;
 i3 = i11 + 32 | 0;
 i1 = i11;
 if ((HEAPU8[i10 + 64 + i9 >> 0] | 0 | 0) == (i8 | 0)) {
  i23 = i10 + (HEAPU16[i10 + 10 >> 1] | 0) | 0;
  i24 = i10 + ((HEAPU16[i10 + 26 >> 1] | 0) + 144) | 0;
  i13 = i24 + (i9 * 160 | 0) | 0;
  i12 = i23 + (i9 << 5) | 0;
  f35 = Math_fround(HEAPF32[i7 >> 2]);
  f34 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f35 = Math_fround(-f35);
  f34 = Math_fround(-f34);
  f33 = Math_fround(-Math_fround(HEAPF32[i7 + 8 >> 2]));
  f25 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f21 = Math_fround(HEAPF32[i7 + 24 >> 2]);
  f32 = Math_fround(-f25);
  f29 = Math_fround(-f14);
  f26 = Math_fround(-f21);
  i7 = i10 + (((HEAPU16[i10 + 8 >> 1] | 0) * 432 | 0) + (HEAPU16[i10 + 24 >> 1] | 0)) + (i9 * 96 | 0) | 0;
  f27 = Math_fround(HEAPF32[i23 + (i9 << 5) + 16 >> 2]);
  f15 = Math_fround(HEAPF32[i23 + (i9 << 5) + 20 >> 2]);
  f31 = Math_fround(HEAPF32[i23 + (i9 << 5) + 24 >> 2]);
  f25 = Math_fround(Math_fround(Math_fround(f31 * f34) - Math_fround(f15 * f33)) - f25);
  f14 = Math_fround(Math_fround(Math_fround(f27 * f33) - Math_fround(f31 * f35)) - f14);
  f21 = Math_fround(Math_fround(Math_fround(f15 * f35) - Math_fround(f27 * f34)) - f21);
  HEAPF32[i2 >> 2] = f25;
  HEAPF32[i2 + 4 >> 2] = f14;
  HEAPF32[i2 + 8 >> 2] = f21;
  HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
  f27 = Math_fround(HEAPF32[i13 >> 2]);
  f15 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 32 >> 2]);
  f28 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 36 >> 2]);
  f17 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 40 >> 2]);
  f19 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 64 >> 2]);
  f18 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 68 >> 2]);
  f19 = Math_fround(Math_fround(f27 * f25) + Math_fround(Math_fround(f14 * f30) + Math_fround(f21 * f19)));
  f18 = Math_fround(Math_fround(f15 * f25) + Math_fround(Math_fround(f14 * f28) + Math_fround(f21 * f18)));
  f17 = Math_fround(Math_fround(f25 * f31) + Math_fround(Math_fround(f14 * f17) + Math_fround(f21 * Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 72 >> 2]))));
  f31 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 16 >> 2]);
  f28 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 20 >> 2]);
  f15 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 24 >> 2]);
  f30 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 48 >> 2]);
  f27 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 52 >> 2]);
  f20 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 56 >> 2]);
  f16 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 80 >> 2]);
  f22 = Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 84 >> 2]);
  f19 = Math_fround(f35 - f19);
  f18 = Math_fround(f34 - f18);
  f17 = Math_fround(f33 - f17);
  f16 = Math_fround(f32 - Math_fround(Math_fround(f25 * f31) + Math_fround(Math_fround(f14 * f30) + Math_fround(f21 * f16))));
  f22 = Math_fround(f29 - Math_fround(Math_fround(f25 * f28) + Math_fround(Math_fround(f14 * f27) + Math_fround(f21 * f22))));
  f21 = Math_fround(f26 - Math_fround(Math_fround(f25 * f15) + Math_fround(Math_fround(f14 * f20) + Math_fround(f21 * Math_fround(HEAPF32[i24 + (i9 * 160 | 0) + 88 >> 2])))));
  f20 = Math_fround(HEAPF32[i12 >> 2]);
  f14 = Math_fround(HEAPF32[i23 + (i9 << 5) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i23 + (i9 << 5) + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(Math_fround(f17 * f14) - Math_fround(f18 * f15)));
  f15 = Math_fround(f22 + Math_fround(Math_fround(f19 * f15) - Math_fround(f17 * f20)));
  f14 = Math_fround(f21 + Math_fround(Math_fround(f18 * f20) - Math_fround(f19 * f14)));
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  f21 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f19 = Math_fround(f20 - f19);
  f18 = Math_fround(f21 - f18);
  f17 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f17);
  f21 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f16 = Math_fround(f21 - f16);
  f15 = Math_fround(f20 - f15);
  f14 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) - f14);
  HEAPF32[i3 >> 2] = f19;
  HEAPF32[i3 + 4 >> 2] = f18;
  HEAPF32[i3 + 8 >> 2] = f17;
  HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 16 >> 2] = f16;
  HEAPF32[i3 + 20 >> 2] = f15;
  HEAPF32[i3 + 24 >> 2] = f14;
  HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
  __ZN5physx23PxcFsGetImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_(i10, i8, i3, i4);
  __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i1, i13, i12, i2, i4, i7);
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i10 = i5 + 16 | 0;
  i9 = i1 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  STACKTOP = i11;
  return;
 } else {
  __ZN5physx22getImpulseResponseSlowERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_(i10, i8, i6, i4, i9, i7, i5);
  STACKTOP = i11;
  return;
 }
}

function __ZL10KeyHandleriPK23EmscriptenKeyboardEventPv(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0, f13 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = __Z15GetInputManagerv() | 0;
 i1 = HEAP32[i11 + 156 >> 2] | 0;
 if ((i1 | 0) < 225) i1 = HEAP32[gb + 1100524 + (i1 << 2) >> 2] | 0;
 if ((HEAP32[i11 + 64 >> 2] | 0) == 2) i6 = (((i1 + -304 | 0) >>> 0 < 7) << 31 >> 31) + i1 | 0; else i6 = i1;
 if (__ZN12InputManager17GetTextFieldInputEv(i7) | 0) {
  if (!(__ZN12InputManager30GetEatKeyPressOnTextFieldFocusEv(i7) | 0)) i4 = 7;
 } else i4 = 7;
 if ((i4 | 0) == 7) {
  i5 = (i10 | 0) == 2;
  do if ((__ZN10systeminfo24GetOperatingSystemFamilyEv() | 0) == 1) {
   if (!i5) {
    if ((i6 + -309 | 0) >>> 0 >= 2) break;
    i1 = HEAP32[gb + 1103732 >> 2] | 0;
    if ((i1 | 0) != (gb + 1103732 + 4 | 0)) {
     i2 = i1;
     while (1) {
      __ZN12InputManager11SetKeyStateEib(i7, HEAP32[i2 + 16 >> 2] | 0, 0);
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((i1 | 0) == (gb + 1103732 + 4 | 0)) break; else i2 = i1;
     }
    }
    __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(gb + 1103732 | 0, HEAP32[gb + 1103732 + 4 >> 2] | 0);
    HEAP32[gb + 1103732 + 8 >> 2] = 0;
    HEAP32[gb + 1103732 >> 2] = gb + 1103732 + 4;
    HEAP32[gb + 1103732 + 4 >> 2] = 0;
    break;
   }
   i1 = HEAP32[gb + 1103732 + 4 >> 2] | 0;
   do if (!i1) {
    HEAP32[i8 >> 2] = gb + 1103732 + 4;
    i2 = gb + 1103732 + 4 | 0;
    i3 = gb + 1103732 + 4 | 0;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i6 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 12;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i6 | 0)) {
       i4 = 17;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 16;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 12) {
     HEAP32[i8 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     break;
    } else if ((i4 | 0) == 16) {
     HEAP32[i8 >> 2] = i1;
     i2 = i1;
     break;
    } else if ((i4 | 0) == 17) {
     HEAP32[i8 >> 2] = i1;
     i2 = i1;
     i3 = i8;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(20) | 0;
    HEAP32[i1 + 16 >> 2] = i6;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[gb + 1103732 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[gb + 1103732 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[gb + 1103732 + 4 >> 2] | 0, i1);
    HEAP32[gb + 1103732 + 8 >> 2] = (HEAP32[gb + 1103732 + 8 >> 2] | 0) + 1;
   }
   if (HEAP32[i11 + 80 >> 2] | 0) {
    i4 = i6 >>> 5;
    if ((HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + (i4 << 2) >> 2] | HEAP32[(HEAP32[i7 + 68 >> 2] | 0) + (i4 << 2) >> 2]) & 1 << (i6 & 31) | 0) __ZN12InputManager11SetKeyStateEib(i7, i6, 0);
   }
  } while (0);
  if (i6 | 0) __ZN12InputManager11SetKeyStateEib(i7, i6, i5);
 }
 L53 : do if ((HEAP32[gb + 1103744 >> 2] | 0) == 1) {
  switch (i6 | 0) {
  case 8:
   {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7 + 136 | 0, gb + 363719 | 0) | 0;
    break;
   }
  case 276:
  case 275:
  case 274:
  case 273:
  case 9:
   break;
  default:
   {
    i1 = 0;
    break L53;
   }
  }
  i1 = 1;
 } else i1 = 0; while (0);
 HEAP32[i8 + 44 >> 2] = 0;
 __ZN10InputEvent4InitEi(i8, 0);
 HEAP32[i8 >> 2] = (i10 | 0) == 2 ? 4 : 5;
 if (HEAP32[i11 + 68 >> 2] | 0) {
  i10 = i8 + 24 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
 }
 if (HEAP32[i11 + 72 >> 2] | 0) {
  i10 = i8 + 24 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 }
 if (HEAP32[i11 + 76 >> 2] | 0) {
  i10 = i8 + 24 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 4;
 }
 if (!(HEAP32[i11 + 80 >> 2] | 0)) {
  i10 = i6 & 65535;
  i11 = i8 + 38 | 0;
  HEAP16[i11 >> 1] = i10;
  i11 = __Z15GetInputManagerv() | 0;
  i10 = i11 + 116 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i11 + 120 | 0;
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  i11 = __Z16GetScreenManagerv() | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i7 = i7 + 84 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i11 = mftCall_ii(i7 | 0, i11 | 0) | 0;
  i11 = i11 + -1 | 0;
  f13 = Math_fround(i11 | 0);
  f12 = Math_fround(f13 - f12);
  i11 = i8 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  i11 = i8 + 8 | 0;
  HEAPF32[i11 >> 2] = f12;
  __Z16SanitizeKeyEventR10InputEvent(i8);
  i11 = __Z18GetGUIEventManagerv() | 0;
  __ZN15GUIEventManager10QueueEventERK10InputEvent(i11, i8);
  __ZN10InputEventD2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 i10 = i8 + 24 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 8;
 i10 = i6 & 65535;
 i11 = i8 + 38 | 0;
 HEAP16[i11 >> 1] = i10;
 i11 = __Z15GetInputManagerv() | 0;
 i10 = i11 + 116 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = i11 + 120 | 0;
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 i11 = __Z16GetScreenManagerv() | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i7 = i7 + 84 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i11 = mftCall_ii(i7 | 0, i11 | 0) | 0;
 i11 = i11 + -1 | 0;
 f12 = Math_fround(i11 | 0);
 f13 = Math_fround(f12 - f13);
 i11 = i8 + 4 | 0;
 HEAP32[i11 >> 2] = i10;
 i11 = i8 + 8 | 0;
 HEAPF32[i11 >> 2] = f13;
 __Z16SanitizeKeyEventR10InputEvent(i8);
 i11 = __Z18GetGUIEventManagerv() | 0;
 __ZN15GUIEventManager10QueueEventERK10InputEvent(i11, i8);
 __ZN10InputEventD2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 56 | 0;
 i8 = i17 + 48 | 0;
 i13 = i17 + 24 | 0;
 i7 = i17 + 16 | 0;
 i5 = i17 + 44 | 0;
 i6 = i17 + 40 | 0;
 i12 = i17;
 i15 = i14 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 36 | 0;
 i4 = i1;
 if (i3 >>> 0 >= i9 >>> 0) {
  if (i3 >>> 0 <= i9 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i5 = HEAP32[i14 + 12 >> 2] | 0;
  i6 = i4 + (i9 * 36 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  i10 = i12 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i11 = i12 + 12 | 0;
  HEAP32[i11 >> 2] = i5;
  i3 = i9 * 36 | 0;
  i4 = (i3 | 0) / 36 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i12 + 8 | 0;
   i8 = i12;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
    i2 = HEAP32[i11 >> 2] | 0;
   } else i2 = i5;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i2;
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i5;
   HEAP32[i12 >> 2] = i5;
   i9 = i12 + 8 | 0;
   HEAP32[i9 >> 2] = i5 + (i4 * 36 | 0);
   HEAP32[i13 >> 2] = i1;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i12, i8, i16, i4);
   i6 = i10;
   i7 = i9;
   i8 = i12;
   i1 = HEAP32[i14 >> 2] | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  i5 = i14 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i5 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i4 = i16 + 4 | 0;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i2 + -28 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i15 = HEAP32[i2 + -16 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i4 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i7 = i14 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 36 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i14, i9 - i3 | 0);
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 i10 = i13 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i11 = i13 + 12 | 0;
 HEAP32[i11 >> 2] = i2;
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj(i13, i9);
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i13, i8, i16);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 36 | 0;
 i4 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i13, i9 - i1 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i6 = i3 + (i9 * 36 | 0) | 0;
  if ((i4 | 0) != (i6 | 0)) {
   i5 = i16 + 4 | 0;
   i1 = i4;
   while (1) {
    i2 = i1 + -36 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = i1 + -28 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i3 >> 2] | 0;
     i12 = HEAP32[i1 + -16 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i5 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i16);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i2;
   }
  }
 }
 i5 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i5;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i2 = i13 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i4 = i16 + 4 | 0;
   while (1) {
    i1 = i2 + -36 | 0;
    HEAP32[i10 >> 2] = i1;
    i3 = i2 + -28 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     i15 = HEAP32[i2 + -16 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i4 >> 2] = i15;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i15 = HEAP32[i11 >> 2] | 0;
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff(i16, i17, f18, f19) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 f18 = Math_fround(f18);
 f19 = Math_fround(f19);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0;
 i20 = i16 + 12 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i16 + 16 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 do if ((i1 & 2147483644) >>> 0 < 12) if ((i1 | 0) > -1) {
  HEAP32[i21 >> 2] = 12;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, 96, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i20 >> 2] << 3 | 0) | 0;
  HEAP32[i21 >> 2] = 12;
  HEAP32[i16 >> 2] = i15;
  break;
 } while (0);
 if ((HEAP32[i17 + 12 >> 2] | 0) != 8) return;
 i15 = i16 + 4 | 0;
 i8 = 0;
 do {
  i1 = HEAP32[i17 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i1 + (i8 * 12 | 0) + 4 >> 2]);
  if (f12 > f18 & f12 < f19) {
   i9 = HEAP32[i1 + (i8 * 12 | 0) >> 2] | 0;
   i1 = HEAP32[i1 + (i8 * 12 | 0) + 8 >> 2] | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i21 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i21 >> 2] = i2;
     HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 3, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i14 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i20 >> 2] << 3 | 0) | 0;
     HEAP32[i21 >> 2] = i2;
     HEAP32[i16 >> 2] = i14;
     break;
    }
   } while (0);
   HEAP32[i20 >> 2] = i5;
   i14 = HEAP32[i16 >> 2] | 0;
   HEAP32[i14 + (i4 << 3) >> 2] = i9;
   HEAP32[i14 + (i4 << 3) + 4 >> 2] = i1;
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 8);
 i14 = 0;
 do {
  i5 = HEAP32[gb + 169872 + (i14 << 2) >> 2] | 0;
  i13 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i13 + (i5 * 12 | 0) >> 2] | 0;
  f10 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 4 >> 2]);
  i5 = HEAP32[i13 + (i5 * 12 | 0) + 8 >> 2] | 0;
  i4 = HEAP32[gb + 169920 + (i14 << 2) >> 2] | 0;
  i1 = HEAP32[i13 + (i4 * 12 | 0) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i13 + (i4 * 12 | 0) + 4 >> 2]);
  i4 = HEAP32[i13 + (i4 * 12 | 0) + 8 >> 2] | 0;
  if (f3 < f10) {
   i13 = i2;
   i9 = i5;
   f12 = f10;
  } else {
   i13 = i1;
   i1 = i2;
   i9 = i4;
   i4 = i5;
   f12 = f3;
   f3 = f10;
  }
  if (f12 > f19 & f3 < f19) {
   f11 = Math_fround(Math_fround(f19 - f3) / Math_fround(f12 - f3));
   f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
   f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
   f11 = Math_fround(Math_fround(1.0) - f11);
   f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11);
   f10 = Math_fround(f23 + f10);
   f11 = Math_fround(f22 + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11));
   i5 = HEAP32[i20 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i7 = HEAP32[i21 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i6 >>> 0 > i8 >>> 0) {
    i2 = i7 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i21 >> 2] = i2;
     HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 3, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i20 >> 2] << 3 | 0) | 0;
     HEAP32[i21 >> 2] = i2;
     HEAP32[i16 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i20 >> 2] = i6;
   i8 = HEAP32[i16 >> 2] | 0;
   HEAPF32[i8 + (i5 << 3) >> 2] = f10;
   HEAPF32[i8 + (i5 << 3) + 4 >> 2] = f11;
  }
  if (f12 > f18 & f3 < f18) {
   f3 = Math_fround(Math_fround(f18 - f3) / Math_fround(f12 - f3));
   f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f3 = Math_fround(Math_fround(1.0) - f3);
   f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3);
   f10 = Math_fround(f22 + f10);
   f3 = Math_fround(f23 + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3));
   i2 = HEAP32[i20 >> 2] | 0;
   i4 = i2 + 1 | 0;
   i5 = HEAP32[i21 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i21 >> 2] = i1;
     HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 3, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i13 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i20 >> 2] << 3 | 0) | 0;
     HEAP32[i21 >> 2] = i1;
     HEAP32[i16 >> 2] = i13;
     break;
    }
   } while (0);
   HEAP32[i20 >> 2] = i4;
   i13 = HEAP32[i16 >> 2] | 0;
   HEAPF32[i13 + (i2 << 3) >> 2] = f10;
   HEAPF32[i13 + (i2 << 3) + 4 >> 2] = f3;
  }
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != 12);
 return;
}

function __ZN17Physics2DSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5);
 i1 = i6 + 32 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i9 = i5 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 28 | 0, i5);
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 if ((i2 + 1 | 0) >>> 0 < i3 >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 93 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 94 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i4 = i6 + 180 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i6 + 168 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function _jinit_color_deconverter(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i7 + 4 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 28) | 0;
 i5 = i7 + 420 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 3274;
 i3 = i7 + 40 | 0;
 switch (HEAP32[i3 >> 2] | 0) {
 case 1:
  {
   if ((HEAP32[i7 + 36 >> 2] | 0) != 1) {
    i6 = HEAP32[i7 >> 2] | 0;
    HEAP32[i6 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
   }
   break;
  }
 case 3:
 case 2:
  {
   if ((HEAP32[i7 + 36 >> 2] | 0) != 3) {
    i6 = HEAP32[i7 >> 2] | 0;
    HEAP32[i6 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
   }
   break;
  }
 case 5:
 case 4:
  {
   if ((HEAP32[i7 + 36 >> 2] | 0) != 4) {
    i6 = HEAP32[i7 >> 2] | 0;
    HEAP32[i6 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
   }
   break;
  }
 default:
  if ((HEAP32[i7 + 36 >> 2] | 0) < 1) {
   i6 = HEAP32[i7 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 10;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
  }
 }
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 L11 : do switch (i1 | 0) {
 case 1:
  {
   HEAP32[i7 + 100 >> 2] = 1;
   switch (HEAP32[i3 >> 2] | 0) {
   case 3:
   case 1:
    {
     HEAP32[i2 + 4 >> 2] = fb + 106;
     i2 = HEAP32[i7 + 36 >> 2] | 0;
     if ((i2 | 0) <= 1) break L11;
     i3 = HEAP32[i7 + 196 >> 2] | 0;
     i1 = 1;
     do {
      HEAP8[i3 + (i1 * 84 | 0) + 48 >> 0] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
     break;
    }
   case 2:
    {
     HEAP32[i2 + 4 >> 2] = fb + 107;
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 3072) | 0;
     HEAP32[i1 + 24 >> 2] = i2;
     i1 = 0;
     do {
      HEAP32[i2 + (i1 << 2) >> 2] = i1 * 19595;
      HEAP32[i2 + (i1 + 256 << 2) >> 2] = i1 * 38470;
      HEAP32[i2 + (i1 + 512 << 2) >> 2] = (i1 * 7471 | 0) + 32768;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != 256);
     break;
    }
   default:
    {
     i6 = HEAP32[i7 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
     break L11;
    }
   }
   break;
  }
 case 15:
 case 14:
 case 13:
 case 12:
 case 11:
 case 10:
 case 9:
 case 8:
 case 7:
 case 6:
 case 2:
  {
   HEAP32[i7 + 100 >> 2] = HEAP32[gb + 16264 + (i1 << 2) >> 2];
   switch (HEAP32[i3 >> 2] | 0) {
   case 3:
    {
     i1 = i2 + 4 | 0;
     if (_jsimd_can_ycc_rgb() | 0) {
      HEAP32[i1 >> 2] = fb + 108;
      break L11;
     }
     HEAP32[i1 >> 2] = fb + 109;
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = i2 + 8 | 0;
     HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i5 = i2 + 12 | 0;
     HEAP32[i5 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i6 = i2 + 16 | 0;
     HEAP32[i6 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i3 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     i4 = HEAP32[i1 >> 2] | 0;
     i5 = HEAP32[i5 >> 2] | 0;
     i6 = HEAP32[i6 >> 2] | 0;
     i1 = 0;
     i2 = -128;
     while (1) {
      HEAP32[i4 + (i1 << 2) >> 2] = (i2 * 91881 | 0) + 32768 >> 16;
      HEAP32[i5 + (i1 << 2) >> 2] = (i2 * 116130 | 0) + 32768 >> 16;
      HEAP32[i6 + (i1 << 2) >> 2] = Math_imul(i2, -46802) | 0;
      HEAP32[i3 + (i1 << 2) >> 2] = (Math_imul(i2, -22554) | 0) + 32768;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 256) break; else i2 = i2 + 1 | 0;
     }
     break;
    }
   case 1:
    {
     HEAP32[i2 + 4 >> 2] = fb + 110;
     break L11;
    }
   case 2:
    {
     if (4292 >>> i1 & 1 | 0) if (13252 >>> i1 & 1 | 0) if (324 >>> i1 & 1 | 0) {
      HEAP32[i2 + 4 >> 2] = fb + 111;
      break L11;
     }
     HEAP32[i2 + 4 >> 2] = fb + 112;
     break L11;
    }
   default:
    {
     i6 = HEAP32[i7 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
     break L11;
    }
   }
   break;
  }
 case 4:
  {
   HEAP32[i7 + 100 >> 2] = 4;
   switch (HEAP32[i3 >> 2] | 0) {
   case 5:
    {
     HEAP32[i2 + 4 >> 2] = fb + 113;
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = i2 + 8 | 0;
     HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i5 = i2 + 12 | 0;
     HEAP32[i5 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i6 = i2 + 16 | 0;
     HEAP32[i6 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     i3 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i7 | 0, 1, 1024) | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     i4 = HEAP32[i1 >> 2] | 0;
     i5 = HEAP32[i5 >> 2] | 0;
     i6 = HEAP32[i6 >> 2] | 0;
     i1 = 0;
     i2 = -128;
     while (1) {
      HEAP32[i4 + (i1 << 2) >> 2] = (i2 * 91881 | 0) + 32768 >> 16;
      HEAP32[i5 + (i1 << 2) >> 2] = (i2 * 116130 | 0) + 32768 >> 16;
      HEAP32[i6 + (i1 << 2) >> 2] = Math_imul(i2, -46802) | 0;
      HEAP32[i3 + (i1 << 2) >> 2] = (Math_imul(i2, -22554) | 0) + 32768;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 256) break; else i2 = i2 + 1 | 0;
     }
     break;
    }
   case 4:
    {
     HEAP32[i2 + 4 >> 2] = fb + 111;
     break L11;
    }
   default:
    {
     i6 = HEAP32[i7 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
     break L11;
    }
   }
   break;
  }
 default:
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   HEAP32[i7 + 100 >> 2] = HEAP32[i7 + 36 >> 2];
   HEAP32[i2 + 4 >> 2] = fb + 111;
   break L11;
  } else {
   i6 = HEAP32[i7 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 27;
   mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
   break L11;
  }
 } while (0);
 if (HEAP8[i7 + 74 >> 0] | 0) {
  i6 = 1;
  i7 = i7 + 104 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i6 = HEAP32[i7 + 100 >> 2] | 0;
 i7 = i7 + 104 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionE(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i20 + 32 | 0;
 i18 = i20 + 24 | 0;
 i16 = i20 + 84 | 0;
 i5 = i20 + 72 | 0;
 i6 = i20 + 64 | 0;
 i7 = i20 + 56 | 0;
 i10 = i20;
 i15 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] | 0, i17 | 0) | 0;
 __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj(i17, i15, gb + 144032 | 0, 284);
 i8 = mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 52 >> 2] | 0, i17 | 0, gb + 764812 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0, i17 | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] | 0, i17 | 0) | 0;
 if ((i1 | 0) == (i9 | 0)) {
  i19 = HEAP32[i15 >> 2] | 0;
  i19 = i19 + 68 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i15 | 0);
  i19 = HEAP32[i17 >> 2] | 0;
  i19 = i19 + 8 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i17 | 0);
  STACKTOP = i20;
  return i8 | 0;
 }
 i11 = i10 + 4 | 0;
 i12 = i10 + 16 | 0;
 i13 = i7 + 4 | 0;
 i14 = i6 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 40 >> 2] | 0, i17 | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
  HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  if (!(_strstr(i2, gb + 764818 | 0) | 0)) if (!(_strstr(i2, gb + 764826 | 0) | 0)) {
   if (!(_strstr(i2, gb + 764992 | 0) | 0)) {
    if (_strstr(i2, gb + 765009 | 0) | 0) i19 = 8;
   } else i19 = 8;
   if ((i19 | 0) == 8) {
    i19 = 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] | 0, i15 | 0, i3 | 0);
    if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 773183 | 0) | 0) {
     i21 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
     mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 64 >> 2] | 0, i15 | 0, gb + 773183 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 56 >> 2] | 0, i15 | 0, gb + 765025 | 0);
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0, i21 | 0);
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
    }
    if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 773198 | 0) | 0) {
     i21 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
     mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 64 >> 2] | 0, i15 | 0, gb + 773198 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 56 >> 2] | 0, i15 | 0, gb + 765035 | 0);
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0, i21 | 0);
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
    }
    if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 773213 | 0) | 0) {
     i21 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
     mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 64 >> 2] | 0, i15 | 0, gb + 773213 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 56 >> 2] | 0, i15 | 0, gb + 765046 | 0);
     mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 60 >> 2] | 0, i15 | 0, i21 | 0);
     mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
    }
   }
   if (!(_strstr(i2, gb + 765058 | 0) | 0)) if (!(_strstr(i2, gb + 765075 | 0) | 0)) if (!(_strstr(i2, gb + 765091 | 0) | 0)) if (!(_strstr(i2, gb + 765108 | 0) | 0)) {
    if (_strstr(i2, gb + 765118 | 0) | 0) i19 = 19;
   } else i19 = 19; else i19 = 19; else i19 = 19; else i19 = 19;
   if ((i19 | 0) == 19) {
    i19 = 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] | 0, i15 | 0, i3 | 0);
    HEAP32[i14 >> 2] = i15;
    HEAP32[i6 >> 2] = gb + 146304 + 8;
    __ZN5physx2Sn18RecursiveTraversal8traverseEv(i6);
   }
   if (_strstr(i2, gb + 765118 | 0) | 0) {
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] | 0, i15 | 0, i3 | 0);
    HEAP32[i13 >> 2] = i15;
    HEAP32[i7 >> 2] = gb + 146324 + 8;
    __ZN5physx2Sn18RecursiveTraversal8traverseEv(i7);
   }
   i21 = HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i12 >> 2] = i3;
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
   mftCall_vii(i21 | 0, i8 | 0, i4 | 0);
  } else i19 = 5; else i19 = 5;
  if ((i19 | 0) == 5) {
   i19 = 0;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 764840 | 0, 299, gb + 764944 | 0, i18);
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i9 | 0));
 i21 = HEAP32[i15 >> 2] | 0;
 i21 = i21 + 68 | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 mftCall_vi(i21 | 0, i15 | 0);
 i21 = HEAP32[i17 >> 2] | 0;
 i21 = i21 + 8 | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 mftCall_vi(i21 | 0, i17 | 0);
 STACKTOP = i20;
 return i8 | 0;
}

function __ZN15TerrainRenderer12RebuildNodesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 8 | 0;
 i1 = i21;
 i4 = i6 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i5 = 6; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i19 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i19 + (i3 << 3) | 0;
   i2 = i19;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i2, i1);
   i1 = HEAP32[i20 >> 2] | 0;
   i19 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i18 = i1 + 248 | 0;
 i19 = i18 + 80 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i1 = 1 << i4;
  i2 = 0;
  i3 = 0;
  while (1) {
   i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i1 = i1 >> 1;
  }
  i1 = i2 + 1 | 0;
 } else i1 = 1;
 i17 = i6 + 16 | 0;
 i4 = i6 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = i5 - i3 >> 6;
 if (i1 >>> 0 > i2 >>> 0) __ZNSt3__26vectorI12QuadTreeNodeNS_9allocatorIS1_EEE8__appendEj(i17, i1 - i2 | 0); else if (i1 >>> 0 < i2 >>> 0) {
  i1 = i3 + (i1 << 6) | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -64 - i1 | 0) >>> 6) << 6);
 }
 i12 = i6 + 28 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) < 0) {
  STACKTOP = i21;
  return;
 }
 i13 = i18 + 24 | 0;
 i14 = i18 + 92 | 0;
 i15 = i6 + 32 | 0;
 i16 = i6 + 36 | 0;
 i11 = i6 + 40 | 0;
 i10 = 0;
 while (1) {
  i9 = i1 - i10 | 0;
  i8 = 1 << i9;
  if ((i9 | 0) != 31) {
   i9 = (i10 | 0) > 0;
   i7 = 0;
   do {
    if (i9) {
     i6 = 0;
     do {
      i1 = 1 << HEAP32[i12 >> 2];
      i2 = 0;
      i3 = 0;
      do {
       i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
       i1 = i1 >> 1;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i10 | 0));
      i5 = i2 + i6 + (Math_imul(i1, i7) | 0) | 0;
      i4 = HEAP32[i17 >> 2] | 0;
      HEAP32[i4 + (i5 << 6) + 24 >> 2] = i6;
      HEAP32[i4 + (i5 << 6) + 28 >> 2] = i7;
      HEAP32[i4 + (i5 << 6) + 32 >> 2] = i10;
      i1 = 1 << HEAP32[i19 >> 2];
      i2 = 0;
      i3 = 0;
      do {
       i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
       i1 = i1 >> 1;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i10 | 0));
      i3 = i2 + i6 + (Math_imul(i1, i7) | 0) | 0;
      f22 = Math_fround(HEAPF32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2]);
      HEAPF32[i4 + (i5 << 6) + 12 >> 2] = Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2]));
      i4 = i4 + (i5 << 6) + 36 | 0;
      __ZNK9Heightmap15CalculateBoundsEiii(i20, i18, i6, i7, i10);
      HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
      HEAP32[i4 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
      i4 = HEAP32[i17 >> 2] | 0;
      f22 = Math_fround(HEAPF32[i15 >> 2]);
      i3 = i4 + (i5 << 6) + 36 | 0;
      HEAPF32[i3 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i3 >> 2]));
      f22 = Math_fround(HEAPF32[i16 >> 2]);
      i3 = i4 + (i5 << 6) + 40 | 0;
      HEAPF32[i3 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i3 >> 2]));
      f22 = Math_fround(HEAPF32[i11 >> 2]);
      i5 = i4 + (i5 << 6) + 44 | 0;
      HEAPF32[i5 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i5 >> 2]));
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (i8 | 0));
    } else {
     i1 = 0;
     do {
      i6 = i1 + (i7 << HEAP32[i12 >> 2]) | 0;
      i5 = HEAP32[i17 >> 2] | 0;
      HEAP32[i5 + (i6 << 6) + 24 >> 2] = i1;
      HEAP32[i5 + (i6 << 6) + 28 >> 2] = i7;
      HEAP32[i5 + (i6 << 6) + 32 >> 2] = i10;
      f22 = Math_fround(HEAPF32[(HEAP32[i13 >> 2] | 0) + (i1 + (i7 << HEAP32[i19 >> 2]) << 2) >> 2]);
      HEAPF32[i5 + (i6 << 6) + 12 >> 2] = Math_fround(f22 * Math_fround(HEAPF32[i14 >> 2]));
      i5 = i5 + (i6 << 6) + 36 | 0;
      __ZNK9Heightmap15CalculateBoundsEiii(i20, i18, i1, i7, i10);
      HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
      HEAP32[i5 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
      HEAP32[i5 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
      HEAP32[i5 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
      HEAP32[i5 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
      i5 = HEAP32[i17 >> 2] | 0;
      f22 = Math_fround(HEAPF32[i15 >> 2]);
      i4 = i5 + (i6 << 6) + 36 | 0;
      HEAPF32[i4 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i4 >> 2]));
      f22 = Math_fround(HEAPF32[i16 >> 2]);
      i4 = i5 + (i6 << 6) + 40 | 0;
      HEAPF32[i4 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i4 >> 2]));
      f22 = Math_fround(HEAPF32[i11 >> 2]);
      i6 = i5 + (i6 << 6) + 44 | 0;
      HEAPF32[i6 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i6 >> 2]));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i8 | 0));
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (i8 | 0));
  }
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) <= (i10 | 0)) break; else i10 = i10 + 1 | 0;
 }
 STACKTOP = i21;
 return;
}

function __Z17BuildSmoothCornerjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_RK11ColorRGBA32(i3, i25, i28, i1, i2, i31, i32) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f26 = f0, f27 = f0, i29 = 0, f30 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0, i42 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i33 + 8 | 0;
 i22 = i33;
 i29 = HEAP32[i1 + 8 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i29 + (i3 << 3) >> 2]);
 f27 = Math_fround(HEAPF32[i29 + (i3 << 3) + 4 >> 2]);
 i29 = i29 + (i3 + 1 << 3) | 0;
 f6 = Math_fround(HEAPF32[i29 >> 2]);
 f6 = Math_fround(Math_fround(+Math_atan2(+Math_fround(HEAPF32[i29 + 4 >> 2]), +f6)) - Math_fround(+Math_atan2(+f27, +f26)));
 i29 = f6 < Math_fround(-3.14159274);
 f30 = Math_fround(f6 + Math_fround(6.28318548));
 f6 = i29 ? f30 : f6;
 i29 = f6 > Math_fround(3.14159274);
 f30 = Math_fround(f6 + Math_fround(-6.28318548));
 f6 = i29 ? f30 : f6;
 i29 = i1 + 16 | 0;
 i20 = HEAP32[i29 >> 2] | 0;
 f30 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(i20 | 0)) * f6);
 i19 = HEAP32[i1 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i19 + (i3 << 4) + 8 >> 2]);
 f6 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ -1082130432, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i21 = f24 > Math_fround(0.0);
 f4 = Math_fround(-f6);
 f6 = i21 ? f4 : f6;
 i21 = (HEAP32[i1 + 12 >> 2] | 0) + (i3 + -1 << 3) | 0;
 f4 = Math_fround(HEAPF32[i21 >> 2]);
 f4 = Math_fround(f4 * f6);
 f5 = Math_fround(Math_fround(HEAPF32[i21 + 4 >> 2]) * f6);
 i21 = i23 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(f4 * f8);
 f5 = Math_fround(f5 * f8);
 f34 = Math_fround(HEAPF32[i19 + (i3 << 4) >> 2]);
 f4 = Math_fround(f34 + f4);
 f5 = Math_fround(Math_fround(HEAPF32[i19 + (i3 << 4) + 4 >> 2]) + f5);
 HEAPF32[i23 >> 2] = f4;
 HEAPF32[i21 >> 2] = f5;
 f8 = Math_fround(f6 * Math_fround(f8 * Math_fround(2.0)));
 if ((i20 | 0) < 0) {
  STACKTOP = i33;
  return;
 }
 i7 = i22 + 4 | 0;
 i9 = f8 < Math_fround(0.0);
 i2 = i9 ? i22 : i23;
 i9 = i9 ? i23 : i22;
 i10 = i28 + 16 | 0;
 i11 = i28 + 20 | 0;
 i12 = i28 + 24 | 0;
 i13 = i28 + 4 | 0;
 i14 = i28 + 8 | 0;
 i15 = i28 + 48 | 0;
 i16 = i28 + 52 | 0;
 i17 = i28 + 56 | 0;
 i18 = i28 + 32 | 0;
 i19 = i28 + 36 | 0;
 i20 = i28 + 40 | 0;
 f6 = Math_fround(0.0);
 i3 = 0;
 i1 = HEAP32[i25 >> 2] | 0;
 while (1) {
  f38 = Math_fround(+Math_cos(+f6));
  f39 = Math_fround(+Math_sin(+f6));
  f40 = Math_fround(f5 + Math_fround(f8 * Math_fround(Math_fround(f27 * f38) + Math_fround(f26 * f39))));
  HEAPF32[i22 >> 2] = Math_fround(f4 + Math_fround(f8 * Math_fround(Math_fround(f26 * f38) - Math_fround(f27 * f39))));
  HEAPF32[i7 >> 2] = f40;
  i35 = i2;
  i41 = i9;
  i42 = HEAP32[i41 >> 2] | 0;
  i41 = HEAP32[i41 + 4 >> 2] | 0;
  f40 = Math_fround(HEAPF32[i35 >> 2]);
  f39 = Math_fround(HEAPF32[i35 + 4 >> 2]);
  f38 = Math_fround(f39 * Math_fround(HEAPF32[i10 >> 2]));
  f4 = Math_fround(f39 * Math_fround(HEAPF32[i11 >> 2]));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i12 >> 2]));
  f37 = Math_fround(f40 * Math_fround(HEAPF32[i28 >> 2]));
  f5 = Math_fround(f40 * Math_fround(HEAPF32[i13 >> 2]));
  f37 = Math_fround(f38 + f37);
  f5 = Math_fround(f4 + f5);
  f40 = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i14 >> 2])));
  f39 = Math_fround(HEAPF32[i15 >> 2]);
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  f38 = Math_fround(HEAPF32[i17 >> 2]);
  f34 = Math_fround(f24 * Math_fround(HEAPF32[i18 >> 2]));
  f36 = Math_fround(f24 * Math_fround(HEAPF32[i19 >> 2]));
  f36 = Math_fround(f5 + Math_fround(f4 + f36));
  f38 = Math_fround(f40 + Math_fround(f38 + Math_fround(f24 * Math_fround(HEAPF32[i20 >> 2]))));
  HEAPF32[i1 >> 2] = Math_fround(f37 + Math_fround(f39 + f34));
  HEAPF32[i1 + 4 >> 2] = f36;
  HEAPF32[i1 + 8 >> 2] = f38;
  HEAP32[i1 + 12 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i31 >> 2];
  HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
  i35 = i1 + 24 | 0;
  f38 = (HEAP32[tempDoublePtr >> 2] = i42, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f36 = (HEAP32[tempDoublePtr >> 2] = i41, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f36 * Math_fround(HEAPF32[i10 >> 2]));
  f39 = Math_fround(f36 * Math_fround(HEAPF32[i11 >> 2]));
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i12 >> 2]));
  f37 = Math_fround(f38 * Math_fround(HEAPF32[i28 >> 2]));
  f40 = Math_fround(f38 * Math_fround(HEAPF32[i13 >> 2]));
  f37 = Math_fround(f34 + f37);
  f40 = Math_fround(f39 + f40);
  f38 = Math_fround(f36 + Math_fround(f38 * Math_fround(HEAPF32[i14 >> 2])));
  f36 = Math_fround(HEAPF32[i15 >> 2]);
  f39 = Math_fround(HEAPF32[i16 >> 2]);
  f34 = Math_fround(HEAPF32[i17 >> 2]);
  f4 = Math_fround(f24 * Math_fround(HEAPF32[i18 >> 2]));
  f5 = Math_fround(f24 * Math_fround(HEAPF32[i19 >> 2]));
  f5 = Math_fround(f40 + Math_fround(f39 + f5));
  f34 = Math_fround(f38 + Math_fround(f34 + Math_fround(f24 * Math_fround(HEAPF32[i20 >> 2]))));
  HEAPF32[i35 >> 2] = Math_fround(f37 + Math_fround(f36 + f4));
  HEAPF32[i35 + 4 >> 2] = f5;
  HEAPF32[i35 + 8 >> 2] = f34;
  HEAP32[i1 + 36 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i31 >> 2];
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  i1 = i1 + 48 | 0;
  if ((i3 | 0) >= (HEAP32[i29 >> 2] | 0)) break;
  f5 = Math_fround(f30 + f6);
  f4 = Math_fround(HEAPF32[i23 >> 2]);
  f6 = f5;
  i3 = i3 + 1 | 0;
  f5 = Math_fround(HEAPF32[i21 >> 2]);
 }
 HEAP32[i25 >> 2] = i1;
 STACKTOP = i33;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i7 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i8, i7 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i7 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i8, i7 + 56 | 0, 0);
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 1);
  i1 = HEAP8[i4 >> 0] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i4 >> 0] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = i1 << 24 >> 24;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 1);
  i1 = HEAP8[i4 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i4 >> 0] = i3;
  HEAP32[i5 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i7 + 4 >> 2] = i1 << 24 >> 24;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i3 = i7 + 108 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 112 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 120 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 124 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 132 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 136 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i8, i7 + 156 | 0, 0);
 i3 = i7 + 168 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 172 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i8, i7 + 180 | 0, 0);
 i3 = i7 + 144 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 148 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN9ShaderLab20SerializedSubProgram12UAVParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZL18InitializeIfNeededv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 100 | 0;
 i12 = i19 + 88 | 0;
 i1 = i19 + 24 | 0;
 i15 = i19 + 68 | 0;
 i16 = i19;
 i17 = i19 + 56 | 0;
 i18 = i19 + 40 | 0;
 if (HEAP32[gb + 1103828 >> 2] | 0) {
  STACKTOP = i19;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, gb + 1103752 | 0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 363730 | 0, 11);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i17, i11, i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i14 = HEAP32[gb + 1103788 >> 2] | 0;
 i13 = i14 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i14, HEAP32[i13 >> 2] | 0);
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i13 >> 2] = 0;
 HEAP8[gb + 1544208 >> 0] = 0;
 HEAP32[gb + 1103828 >> 2] = 16;
 HEAP32[gb + 1103832 >> 2] = 1048576;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i13 = i18 + 11 | 0;
 if (__Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE(i18, i17) | 0) {
  i3 = HEAP8[i13 >> 0] | 0;
  i14 = i3 << 24 >> 24 < 0;
  i2 = i14 ? HEAP32[i18 >> 2] | 0 : i18;
  i3 = i14 ? HEAP32[i18 + 4 >> 2] | 0 : i3 & 255;
  HEAP8[gb + 1544208 >> 0] = 1;
  HEAP32[i12 >> 2] = i2;
  i14 = i2 + i3 | 0;
  if (i3 >>> 0 >= 16) {
   i4 = i2;
   i9 = i4;
   i4 = i4 + 4 | 0;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
   HEAP32[i10 + 4 >> 2] = i4;
   i10 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP32[i1 + 8 >> 2] = i10;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i1 + 12 >> 2] = i4;
   HEAP32[i12 >> 2] = i2 + 16;
   if ((i10 | 0) == 65536 & (_memcmp(HEAP32[gb + 25444 >> 2] | 0, i1, 8) | 0) == 0) {
    HEAP32[gb + 1103832 >> 2] = i4;
    if ((i3 | 0) > 16) {
     i5 = i16 + 8 | 0;
     i6 = i15 + 8 | 0;
     i7 = i5 + 11 | 0;
     i8 = i16 + 12 | 0;
     i9 = i6 + 11 | 0;
     i10 = i15 + 12 | 0;
     do {
      __ZL11DecodeValuePPKcS0_(i15, i12, i14);
      i2 = HEAP32[i12 >> 2] | 0;
      if ((HEAP32[i15 >> 2] | 0) == 128 & i2 >>> 0 < i14 >>> 0) {
       __ZL11DecodeValuePPKcS0_(i16, i12, i14);
       if ((HEAP32[i16 >> 2] | 0) == 255) i1 = 3; else {
        i4 = HEAP32[gb + 1103788 >> 2] | 0;
        i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i4, i11, i6) | 0;
        i1 = HEAP32[i3 >> 2] | 0;
        if (!i1) {
         i1 = __Znwj(48) | 0;
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i6);
         HEAP32[i1 + 28 >> 2] = 255;
         i2 = i1 + 36 | 0;
         HEAP32[i2 >> 2] = 0;
         HEAP32[i2 + 4 >> 2] = 0;
         HEAP32[i2 + 8 >> 2] = 0;
         i2 = HEAP32[i11 >> 2] | 0;
         HEAP32[i1 >> 2] = 0;
         HEAP32[i1 + 4 >> 2] = 0;
         HEAP32[i1 + 8 >> 2] = i2;
         HEAP32[i3 >> 2] = i1;
         i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
         if (!i2) i2 = i1; else {
          HEAP32[i4 >> 2] = i2;
          i2 = HEAP32[i3 >> 2] | 0;
         }
         __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
         i4 = i4 + 8 | 0;
         HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
        }
        i2 = i16;
        i3 = HEAP32[i2 + 4 >> 2] | 0;
        i4 = i1 + 28 | 0;
        HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 + 4 >> 2] = i3;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 36 | 0, i5) | 0;
        if (((HEAP32[i15 >> 2] | 0) + -253 | 0) >>> 0 < 2) i2 = 5; else {
         i2 = HEAP8[i9 >> 0] | 0;
         i2 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i2 & 255;
         i2 = (i2 >>> 0 < 128 ? 1 : 5) + i2 | 0;
        }
        if (((HEAP32[i16 >> 2] | 0) + -253 | 0) >>> 0 < 2) i1 = 5; else {
         i1 = HEAP8[i7 >> 0] | 0;
         i1 = i1 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i1 & 255;
         i1 = (i1 >>> 0 < 128 ? 1 : 5) + i1 | 0;
        }
        HEAP32[gb + 1103828 >> 2] = i1 + i2 + (HEAP32[gb + 1103828 >> 2] | 0);
        i1 = 0;
       }
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
       i2 = HEAP32[i12 >> 2] | 0;
      } else i1 = 3;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
     } while (i2 >>> 0 < i14 >>> 0 & (i1 | 0) == 0);
    }
    HEAP8[gb + 1544208 >> 0] = 0;
   }
  }
 }
 if ((HEAP8[i13 >> 0] | 0) < 0) {
  i16 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i19;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5Unity5Cloth22SetUseVirtualParticlesEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 8 | 0;
 i2 = i21;
 i19 = i21 + 20 | 0;
 HEAP8[i5 + 93 >> 0] = i1 & 1;
 i20 = i5 + 228 | 0;
 if (!(HEAP32[i20 >> 2] | 0)) {
  STACKTOP = i21;
  return;
 }
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i15 = i2;
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i15 = i19 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i2);
 i12 = i16;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 if (i1) {
  i3 = i5 + 280 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = (i4 >>> 0) / 3 | 0;
  i2 = i1 << 2;
  if (!i2) {
   i1 = 0;
   i2 = 0;
  } else {
   HEAP32[i17 >> 2] = i2;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 4, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i19 >> 2] = i2;
   i1 = i2;
   i4 = HEAP32[i3 >> 2] | 0;
  }
  if (i4) {
   i14 = i5 + 268 | 0;
   i13 = 0;
   i5 = i1;
   i6 = i1;
   i9 = i2;
   while (1) {
    i11 = i13 + 1 | 0;
    i7 = HEAPU16[(HEAP32[i14 >> 2] | 0) + (i13 << 1) >> 1] | 0;
    i8 = HEAP32[i15 >> 2] | 0;
    i10 = i8 + 1 | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i10 >>> 0 > i3 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i17 >> 2] = i1;
      i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i1 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i9;
      i1 = i9;
      i2 = i9;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i1;
      HEAP32[i19 >> 2] = i9;
      i1 = i9;
      i2 = i9;
      break;
     } else {
      i1 = i5;
      i2 = i6;
     }
    } else {
     i1 = i5;
     i2 = i6;
    } while (0);
    HEAP32[i15 >> 2] = i10;
    HEAP32[i2 + (i8 << 2) >> 2] = i7;
    i12 = i13 + 2 | 0;
    i7 = HEAPU16[(HEAP32[i14 >> 2] | 0) + (i11 << 1) >> 1] | 0;
    i8 = HEAP32[i15 >> 2] | 0;
    i10 = i8 + 1 | 0;
    i5 = HEAP32[i17 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i10 >>> 0 > i6 >>> 0) {
     i3 = i5 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i6 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i17 >> 2] = i3;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i3 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i2;
      i9 = i2;
      i1 = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i3;
      HEAP32[i19 >> 2] = i2;
      i9 = i2;
      i1 = i2;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i10;
    HEAP32[i2 + (i8 << 2) >> 2] = i7;
    i13 = i13 + 3 | 0;
    i7 = HEAPU16[(HEAP32[i14 >> 2] | 0) + (i12 << 1) >> 1] | 0;
    i8 = HEAP32[i15 >> 2] | 0;
    i10 = i8 + 1 | 0;
    i5 = HEAP32[i17 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i10 >>> 0 > i6 >>> 0) {
     i3 = i5 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i6 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i17 >> 2] = i3;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i3 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i1;
      i2 = i1;
      i9 = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i3;
      HEAP32[i19 >> 2] = i1;
      i2 = i1;
      i9 = i1;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i10;
    HEAP32[i2 + (i8 << 2) >> 2] = i7;
    i7 = HEAP32[i15 >> 2] | 0;
    i8 = i7 + 1 | 0;
    i5 = HEAP32[i17 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i8 >>> 0 > i6 >>> 0) {
     i3 = i5 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i6 >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i17 >> 2] = i3;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i3 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i1;
      i2 = i1;
      break;
     } else {
      i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i1 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i3;
      HEAP32[i19 >> 2] = i1;
      i2 = i1;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i8;
    HEAP32[i2 + (i7 << 2) >> 2] = 0;
    if (i13 >>> 0 >= i4 >>> 0) break; else {
     i5 = i1;
     i6 = i2;
     i9 = i2;
    }
   }
  }
 } else i1 = 0;
 HEAPF32[i16 >> 2] = Math_fround(.333333343);
 HEAPF32[i16 + 4 >> 2] = Math_fround(.333333343);
 HEAPF32[i16 + 8 >> 2] = Math_fround(.333333343);
 i20 = HEAP32[i20 >> 2] | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i20 >> 2] | 0) + 352 >> 2] | 0, i20 | 0, (HEAP32[i15 >> 2] | 0) >>> 2 | 0, i1 | 0, 1, i16 | 0);
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
  HEAP32[i19 >> 2] = 0;
 }
 STACKTOP = i21;
 return;
}

function __ZN21ArchiveStorageCreator10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i10 = i15;
 i13 = i15 + 32 | 0;
 i14 = i15 + 16 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i2) | 0;
 i9 = i1 + 1080 | 0;
 i11 = i1 + 1084 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i9, HEAP32[i11 >> 2] | 0);
 HEAP32[i1 + 1092 >> 2] = 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i11 >> 2] = 0;
 i11 = i1 + 1096 | 0;
 i9 = i1 + 1168 | 0;
 i2 = HEAP32[i9 >> 2] & -129 | (i3 ? 0 : 128);
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i1 + 1192 >> 2] | 0;
 i4 = i1 + 1196 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i6 = i1 + 1176 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = HEAP32[i1 + 1208 >> 2] | 0;
 i7 = i1 + 1212 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) != (i6 | 0)) {
  i5 = i13 + 4 | 0;
  while (1) {
   i2 = i3 + -40 | 0;
   HEAP32[i7 >> 2] = i2;
   i4 = i3 + -20 | 0;
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i3 + -8 >> 2] | 0;
    HEAP32[i13 >> 2] = 54;
    HEAP32[i5 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
    i2 = HEAP32[i7 >> 2] | 0;
   }
   if ((i2 | 0) == (i6 | 0)) break; else i3 = i2;
  }
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i7 = i1 + 1224 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 if (!(i2 & 128)) i2 = __Z8CRCBeginv() | 0; else i2 = 0;
 HEAP32[i1 + 1248 >> 2] = i2;
 i7 = i1 + 11 | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i2;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  i8 = 17;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i14 + 11 >> 0] = i4;
  if (!i4) i2 = i14; else {
   i2 = i14;
   i8 = 19;
  }
 } else i8 = 17;
 if ((i8 | 0) == 17) {
  i6 = i4 + 16 & -16;
  HEAP32[i13 >> 2] = 1;
  HEAP32[i13 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i14 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i4;
  i8 = 19;
 }
 if ((i8 | 0) == 19) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 i6 = i14 + 11 | 0;
 do if (!(HEAP32[i9 >> 2] & 128)) {
  i2 = HEAP8[i6 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) {
   i4 = (HEAP32[i14 + 8 >> 2] & 2147483647) + -1 | 0;
   i2 = HEAP32[i14 + 4 >> 2] | 0;
  } else {
   i4 = 10;
   i2 = i2 & 255;
  }
  if ((i4 - i2 | 0) >>> 0 < 4) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i14, i4, 4 - i4 + i2 | 0, i2, i2, 0, 4, gb + 491584 | 0);
   break;
  }
  i3 = i3 ? HEAP32[i14 >> 2] | 0 : i14;
  i8 = i3 + i2 | 0;
  HEAP8[i8 >> 0] = 46;
  HEAP8[i8 + 1 >> 0] = 116;
  HEAP8[i8 + 2 >> 0] = 109;
  HEAP8[i8 + 3 >> 0] = 112;
  i2 = i2 + 4 | 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) HEAP32[i14 + 4 >> 2] = i2; else HEAP8[i6 >> 0] = i2;
  HEAP8[i3 + i2 >> 0] = 0;
 } while (0);
 i5 = i1 + 12 | 0;
 do if (__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 1, 0) | 0) {
  i4 = HEAP32[i9 >> 2] | 0;
  if (!(i4 & 128)) i1 = 1; else {
   i2 = HEAP8[i1 + 1116 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i3 = HEAP32[i1 + 1120 >> 2] | 0; else i3 = i2 & 255;
   i2 = HEAP8[i1 + 1132 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i2 = HEAP32[i1 + 1136 >> 2] | 0; else i2 = i2 & 255;
   i3 = i3 + 5 + i2 | 0;
   if (!(i4 & 256)) {
    i2 = HEAP8[i11 + 11 >> 0] | 0;
    if (i2 << 24 >> 24 < 0) i2 = HEAP32[i1 + 1100 >> 2] | 0; else i2 = i2 & 255;
    i2 = i3 + 22 + i2 | 0;
   } else i2 = i3 + 31 | 0;
   if (__ZN12FileAccessor9SetLengthEy(i5, i2, 0) | 0) if (__ZN12FileAccessor4SeekEx10FileOrigin(i5, 0, 0, 3) | 0) {
    i1 = 1;
    break;
   }
   if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 490648 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 490375 | 0, 59, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i1 = 0;
  }
 } else {
  HEAP32[i10 >> 2] = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
  __Z6FormatPKcz(i13, gb + 490259 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 490375 | 0, 50, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i1 = 0;
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i15;
  return i1 | 0;
 }
 i12 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN19ComputeShaderKernel8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 28 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469507 | 0, i9, i1 + 4 | 0, 0);
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469624 | 0, i6, 0);
 __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469511 | 0, i9, i1 + 16 | 0, 0);
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469624 | 0, i6, 0);
 __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469520 | 0, i9, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469578 | 0, i6, 0);
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469606 | 0, i10, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469614 | 0, i10, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469536 | 0, i9, i1 + 40 | 0, 0);
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469624 | 0, i6, 0);
 __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469546 | 0, i9, i1 + 52 | 0, 0);
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469624 | 0, i6, 0);
 __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469557 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 64 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i8 >> 2] = 3;
 HEAP32[i8 + 4 >> 2] = i1 + 84;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469562 | 0, HEAP32[gb + 37256 >> 2] | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5Light8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 __ZNK5Light16UnshareLightDataEv(i10);
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
 i8 = i10 + 44 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i12 = i7 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i2 = i3;
 }
 HEAP32[i3 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + 20 | 0, i7);
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i5 = i4;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i12 >> 2] = i1;
  i6 = i5;
 }
 HEAP32[i5 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i4 = i6;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i12 >> 2] = i1;
  i1 = i2;
  i2 = i4;
 }
 HEAP32[i4 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + 96 | 0, i7);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP32[i8 >> 2] | 0) + 92 | 0, i7);
 i3 = (HEAP32[i8 >> 2] | 0) + 85 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 1);
  i1 = HEAP8[i11 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i11 >> 0] = i1;
  HEAP32[i12 >> 2] = i2;
 }
 HEAP8[i3 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i3 = (HEAP32[i8 >> 2] | 0) + 88 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 48 | 0, i7);
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i5 = i4;
 }
 HEAP32[i4 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i12 >> 2] = i1;
  i4 = i5;
 }
 HEAP32[i5 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i5 = i4;
 }
 HEAP32[i4 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i12 >> 2] = i1;
 }
 HEAP32[i5 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i5 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i10 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i12 = HEAP32[i11 >> 2] | 0;
  i12 = _llvm_bswap_i32(i12 | 0) | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 } else {
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i12 >> 2] = i2;
  i12 = i10;
  i12 = _llvm_bswap_i32(i12 | 0) | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx6shdfnd4sortIPNS_15PxsContactPatchENS_27SortBoundsPredicateManifoldENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i19, i3, i1, i2, i4) {
 i19 = i19 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i2 = i4 << 2;
 i17 = i2 >>> 0 > 1024;
 i18 = i20 + 4 | 0;
 HEAP8[i18 >> 0] = i17 & 1;
 if (i17) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i21 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i20 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i20 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i17 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i16 = i4;
      break;
     }
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       f11 = Math_fround(HEAPF32[(HEAP32[i19 + (i6 << 2) >> 2] | 0) + 16 >> 2]);
       i16 = f11 < Math_fround(HEAPF32[(HEAP32[i19 + (i5 << 2) >> 2] | 0) + 16 >> 2]);
       i5 = i16 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i14 = i19 + (i5 << 2) | 0;
       i16 = i19 + (i7 << 2) | 0;
       i15 = HEAP32[i14 >> 2] | 0;
       HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i16 >> 2] = i15;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i16 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i16 << 2) >> 2] | 0;
    i8 = i16;
   }
   i13 = i19 + (((i3 + i16 | 0) / 2 | 0) << 2) | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   i12 = i19 + (i16 << 2) | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f9 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   i7 = i6;
   i4 = i5;
   if (f11 < f9) {
    HEAP32[i12 >> 2] = i4;
    HEAP32[i13 >> 2] = i7;
    i15 = HEAP32[i12 >> 2] | 0;
    i4 = i7;
    f9 = Math_fround(HEAPF32[i15 + 16 >> 2]);
    i7 = i15;
   } else i6 = i5;
   i10 = i19 + (i3 << 2) | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   f11 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   if (f11 < f9) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i10 >> 2] = i7;
    i4 = HEAP32[i13 >> 2] | 0;
    i6 = i4;
    f9 = Math_fround(HEAPF32[i7 + 16 >> 2]);
    i5 = i7;
   } else f9 = f11;
   if (f9 < Math_fround(HEAPF32[i6 + 16 >> 2])) {
    HEAP32[i13 >> 2] = i5;
    HEAP32[i10 >> 2] = i4;
    i4 = HEAP32[i13 >> 2] | 0;
   }
   i7 = i3 + -1 | 0;
   i15 = i19 + (i7 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i4;
   i14 = i4;
   i5 = i16;
   while (1) {
    f9 = Math_fround(HEAPF32[i4 + 16 >> 2]);
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i4 = i19 + (i5 << 2) | 0;
     i6 = HEAP32[i4 >> 2] | 0;
     if (Math_fround(HEAPF32[i6 + 16 >> 2]) < f9) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i7 = i7 + -1 | 0;
     i12 = i19 + (i7 << 2) | 0;
     i10 = HEAP32[i12 >> 2] | 0;
    } while (f9 < Math_fround(HEAPF32[i10 + 16 >> 2]));
    if ((i5 | 0) >= (i7 | 0)) {
     i7 = i14;
     break;
    }
    HEAP32[i4 >> 2] = i10;
    HEAP32[i12 >> 2] = i6;
    i4 = HEAP32[i15 >> 2] | 0;
    i14 = i4;
   }
   HEAP32[i4 >> 2] = i7;
   HEAP32[i15 >> 2] = i6;
   if ((i5 - i16 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i17 + -1 | 0) >>> 0) i4 = i17; else {
     i4 = i17 << 3;
     if (!i4) i4 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i4 = mftCall_iiiiii(i12 | 0, i14 | 0, i4 | 0, (i15 ? gb + 720469 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i17 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i16;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i5 = i4;
    i4 = i13 + 2 | 0;
   } else {
    i5 = i13 + 2 | 0;
    if (i8 >>> 0 < (i17 + -1 | 0) >>> 0) i4 = i17; else {
     i4 = i17 << 3;
     if (!i4) i4 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i4 = mftCall_iiiiii(i12 | 0, i14 | 0, i4 | 0, (i15 ? gb + 720469 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i17 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i5;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i16;
    i3 = i13;
   }
   i17 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i18 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i20, HEAP32[i20 >> 2] | 0);
 STACKTOP = i21;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags(i30, i26, i1) {
 i30 = i30 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 60 | 0;
 i23 = i29 + 56 | 0;
 i28 = i29 + 28 | 0;
 i24 = i29;
 i25 = i26 + 8 | 0;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i30, gb + 1041885 | 0, gb + 1041885 | 0, i23) | 0)) {
  STACKTOP = i29;
  return;
 };
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 24 >> 2] = 0;
 HEAP32[i28 + 16 >> 2] = 0;
 HEAP32[i28 + 20 >> 2] = 0;
 i11 = i26 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i26, HEAP32[i11 >> 2] | 0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i26 >> 2] = i11;
 HEAP32[i11 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i12 = HEAP32[gb + 37152 >> 2] | 0;
  i1 = i28 + 11 | 0;
  i13 = i28 + 4 | 0;
  i14 = i24 + 12 | 0;
  i10 = i24 + 12 | 0;
  i15 = i27 + 4 | 0;
  i16 = i24 + 8 | 0;
  i17 = i24 + 4 | 0;
  i18 = i24 + 16 | 0;
  i19 = i28 + 16 | 0;
  i20 = i26 + 4 | 0;
  i21 = i24 + 11 | 0;
  i22 = i27 + 4 | 0;
  i9 = 0;
  do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i30, gb + 1041891 | 0, i12, i27, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI14SafeBinaryReadEEvRS5_RT_(i28, i30); else {
     i2 = HEAP32[i27 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i28 | 0, i30 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i30);
   }
   i4 = HEAP8[i1 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i28 >> 2] | 0 : i28;
   i4 = i2 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i14 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = 17;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i21 >> 0] = i4;
    if (!i4) i2 = i24; else {
     i2 = i24;
     i5 = 19;
    }
   } else i5 = 17;
   if ((i5 | 0) == 17) {
    i8 = i4 + 16 & -16;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i15 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i24 >> 2] = i2;
    HEAP32[i16 >> 2] = i8 | -2147483648;
    HEAP32[i17 >> 2] = i4;
    i5 = 19;
   }
   if ((i5 | 0) == 19) {
    i5 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i2 = HEAP32[i11 >> 2] | 0;
   do if (!i2) {
    i3 = i11;
    i4 = i11;
   } else {
    i7 = HEAP8[i21 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i17 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i24 >> 2] | 0 : i24;
    while (1) {
     i4 = i2 + 16 | 0;
     i6 = HEAP8[i4 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
     i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
     if (!i3) i5 = 24; else {
      i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
      if (!i3) i5 = 24; else if ((i3 | 0) < 0) i5 = 26; else i5 = 28;
     }
     if ((i5 | 0) == 24) if (i7 >>> 0 < i6 >>> 0) i5 = 26; else i5 = 28;
     if ((i5 | 0) == 26) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i5 = 27;
       break;
      } else i2 = i3;
     } else if ((i5 | 0) == 28) {
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i5 = 30;
       break;
      } else i2 = i3;
     }
    }
    if ((i5 | 0) == 27) {
     i5 = 0;
     i3 = i2;
     i4 = i2;
     break;
    } else if ((i5 | 0) == 30) {
     i5 = 0;
     i3 = i2;
     break;
    }
   } while (0);
   __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i27, i26, i24);
   i2 = HEAP32[i27 >> 2] | 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i26 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i20 >> 2] | 0, i2);
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
   if ((HEAP8[i21 >> 0] | 0) < 0) {
    i8 = HEAP32[i24 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i22 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i27);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (HEAP32[i23 >> 2] | 0));
 } else i1 = i28 + 11 | 0;
 __ZN14SafeBinaryRead16EndArrayTransferEv(i30);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i30 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 12 >> 2] | 0;
  HEAP32[i27 >> 2] = 66;
  HEAP32[i27 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
 }
 STACKTOP = i29;
 return;
}

function __Z37GenerateCombinedDynamicVisibleListJobP11CullResults(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i20 + 4 | 0;
 i2 = i20;
 if ((HEAP16[gb + 1112972 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112972 | 0, i1);
  i17 = gb + 1112972 | 0;
 } else i17 = 0;
 if (HEAP8[i6 + 76 >> 0] | 0) {
  i18 = HEAP32[(HEAP32[i6 + 1308 >> 2] | 0) + 952 >> 2] | 0;
  i14 = HEAP32[i18 + 832 >> 2] | 0;
  i7 = i6 + 1320 | 0;
  i19 = i6 + 1340 | 0;
  if ((HEAP16[gb + 1112912 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112912 | 0, i1);
   i16 = gb + 1112912 | 0;
  } else i16 = 0;
  i8 = i14 + 16 | 0;
  i9 = i14 + 20 | 0;
  i10 = i14 + 28 | 0;
  i11 = i14 + 32 | 0;
  i12 = i14 + 40 | 0;
  i13 = i14 + 44 | 0;
  i15 = i14 + 52 | 0;
  i1 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) + (HEAP32[i15 >> 2] | 0) | 0;
  i5 = (HEAP32[i11 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) + (HEAP32[i14 + 56 >> 2] | 0) | 0;
  i2 = i6 + 1332 | 0;
  HEAP32[i2 >> 2] = i1;
  i3 = i6 + 1336 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i6 + 1324 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i6 + 1324 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  } while (0);
  i1 = i5 << 1;
  i2 = i6 + 1352 | 0;
  HEAP32[i2 >> 2] = i1;
  i3 = i6 + 1356 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i5 * 24 | 0, 4, i6 + 1344 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 24 | 0, 4, i6 + 1344 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i19 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i19 >> 2] = i6;
   break;
  } while (0);
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i14 + 12 >> 2] | 0;
  if ((HEAP32[i8 >> 2] | 0) > 0) {
   i2 = 0;
   while (1) {
    i1 = i2 + 1 | 0;
    HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
    if ((i1 | 0) < (HEAP32[i8 >> 2] | 0)) i2 = i1; else break;
   }
  } else i1 = 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i14 + 24 >> 2] | 0;
  if ((HEAP32[i10 >> 2] | 0) > 0) {
   i3 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    HEAP32[i6 + (i1 << 2) >> 2] = (HEAP32[i4 + (i3 << 2) >> 2] | 0) + i5;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (HEAP32[i10 >> 2] | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  }
  i5 = (HEAP32[i11 >> 2] | 0) + i5 | 0;
  i4 = HEAP32[i14 + 36 >> 2] | 0;
  if ((HEAP32[i12 >> 2] | 0) > 0) {
   i3 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    HEAP32[i6 + (i1 << 2) >> 2] = (HEAP32[i4 + (i3 << 2) >> 2] | 0) + i5;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (HEAP32[i12 >> 2] | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  }
  i4 = (HEAP32[i13 >> 2] | 0) + i5 | 0;
  i3 = HEAP32[i14 + 48 >> 2] | 0;
  if ((HEAP32[i15 >> 2] | 0) > 0) {
   i2 = 0;
   while (1) {
    HEAP32[i6 + (i1 << 2) >> 2] = i4 + (HEAP32[i3 + (i2 << 2) >> 2] | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (HEAP32[i15 >> 2] | 0)) break; else i1 = i1 + 1 | 0;
   }
  }
  i5 = 1;
  i1 = 0;
  do {
   i3 = HEAP32[i18 + 752 + (i5 * 12 | 0) >> 2] | 0;
   i4 = i18 + 752 + (i5 * 12 | 0) + 8 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i2 = 0;
    do {
     i15 = i1 + 1 | 0;
     i14 = HEAP32[i19 >> 2] | 0;
     i8 = i3 + (i2 * 24 | 0) | 0;
     f21 = Math_fround(HEAPF32[i8 >> 2]);
     i9 = i3 + (i2 * 24 | 0) + 12 | 0;
     f21 = Math_fround(f21 - Math_fround(HEAPF32[i9 >> 2]));
     i10 = i3 + (i2 * 24 | 0) + 4 | 0;
     f22 = Math_fround(HEAPF32[i10 >> 2]);
     i11 = i3 + (i2 * 24 | 0) + 16 | 0;
     f22 = Math_fround(f22 - Math_fround(HEAPF32[i11 >> 2]));
     i12 = i3 + (i2 * 24 | 0) + 8 | 0;
     f23 = Math_fround(HEAPF32[i12 >> 2]);
     i13 = i3 + (i2 * 24 | 0) + 20 | 0;
     f23 = Math_fround(f23 - Math_fround(HEAPF32[i13 >> 2]));
     HEAPF32[i14 + (i1 * 12 | 0) >> 2] = f21;
     HEAPF32[i14 + (i1 * 12 | 0) + 4 >> 2] = f22;
     HEAPF32[i14 + (i1 * 12 | 0) + 8 >> 2] = f23;
     i1 = i1 + 2 | 0;
     i14 = HEAP32[i19 >> 2] | 0;
     f23 = Math_fround(HEAPF32[i8 >> 2]);
     f23 = Math_fround(f23 + Math_fround(HEAPF32[i9 >> 2]));
     f22 = Math_fround(HEAPF32[i10 >> 2]);
     f22 = Math_fround(f22 + Math_fround(HEAPF32[i11 >> 2]));
     f21 = Math_fround(HEAPF32[i12 >> 2]);
     f21 = Math_fround(f21 + Math_fround(HEAPF32[i13 >> 2]));
     HEAPF32[i14 + (i15 * 12 | 0) >> 2] = f23;
     HEAPF32[i14 + (i15 * 12 | 0) + 4 >> 2] = f22;
     HEAPF32[i14 + (i15 * 12 | 0) + 8 >> 2] = f21;
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 5);
  if (i16 | 0) __Z12profiler_endP19ProfilerInformation(i16);
 }
 if (!i17) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i20;
 return;
}

function __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 32 | 0;
 i3 = i9 + 16 | 0;
 i4 = i9;
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619424 | 0, gb + 1033990 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i5, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619436 | 0, gb + 1033990 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i8, 1) | 0) {
  i2 = i5 + 144 | 0;
  i3 = HEAP32[gb + 36980 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619448 | 0, i3, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i2 = i5 + 148 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619457 | 0, i3, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i2 = HEAP32[gb + 36980 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619448 | 0, i2, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i8); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619457 | 0, i2, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i4, i8); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = f10 < Math_fround(0.0);
  f10 = i2 ? Math_fround(0.0) : f10;
  i2 = f10 > Math_fround(1.0);
  HEAP8[i5 + 144 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i2 = f10 < Math_fround(0.0);
  f10 = i2 ? Math_fround(0.0) : f10;
  i2 = f10 > Math_fround(1.0);
  HEAP8[i5 + 145 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i2 = f10 < Math_fround(0.0);
  f10 = i2 ? Math_fround(0.0) : f10;
  i2 = f10 > Math_fround(1.0);
  HEAP8[i5 + 146 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  i3 = f10 < Math_fround(0.0);
  f10 = i3 ? Math_fround(0.0) : f10;
  i3 = f10 > Math_fround(1.0);
  HEAP8[i5 + 147 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = f10 < Math_fround(0.0);
  f10 = i3 ? Math_fround(0.0) : f10;
  i3 = f10 > Math_fround(1.0);
  HEAP8[i5 + 148 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  i3 = f10 < Math_fround(0.0);
  f10 = i3 ? Math_fround(0.0) : f10;
  i3 = f10 > Math_fround(1.0);
  HEAP8[i5 + 149 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  i3 = f10 < Math_fround(0.0);
  f10 = i3 ? Math_fround(0.0) : f10;
  i3 = f10 > Math_fround(1.0);
  HEAP8[i5 + 150 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  i4 = f10 < Math_fround(0.0);
  f10 = i4 ? Math_fround(0.0) : f10;
  i4 = f10 > Math_fround(1.0);
  HEAP8[i5 + 151 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 }
 i4 = i5 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 619491 | 0, HEAP32[gb + 37240 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 45; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 45; else {
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN10AudioMixer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 80 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i3);
 i7 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 862996 | 0, gb + 863920 | 0, i7, 0);
 i11 = i4 + 8 | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i8, i7, 1);
 i7 = i3 + 16 | 0;
 i6 = i3 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i9, i11, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i11 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863010 | 0, gb + 863920 | 0, i11, 0);
 i10 = i4 + 8 | 0;
 i12 = i10;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i8, i11, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i9, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863024 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 48 | 0, 0);
 HEAP32[i2 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 84 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 863052 | 0, i2, 0);
 i10 = i4 + 8 | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i8, i2, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i9, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i10 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863036 | 0, gb + 863052 | 0, i10, 0);
 i2 = i4 + 8 | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i8, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i9, i2, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863077 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863096 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 i2 = i1 + 104 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 902271 | 0, i8, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 HEAP32[i3 + 4 >> 2] = i1 + 32;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i1 = i4 + 28 | 0;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 863112 | 0, gb + 863128 | 0, i4, 0);
 __ZN5audio5mixer18AudioMixerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 STACKTOP = i5;
 return;
}

function __Z11UpdateInputv() {
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, i34 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 1600 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i29 + 1480 | 0;
 i27 = i29 + 1464 | 0;
 i26 = i29 + 1448 | 0;
 i25 = i29 + 1432 | 0;
 i8 = i29;
 i9 = i29 + 1492 | 0;
 i18 = __Z15GetInputManagerv() | 0;
 i19 = _emscripten_get_num_gamepads() | 0;
 if ((i19 | 0) > 0) {
  i20 = i8 + 1368 | 0;
  i21 = i8 + 16 | 0;
  i22 = i8 + 24 | 0;
  i23 = i8 + 576 | 0;
  i24 = i8 + 32 | 0;
  i10 = i8 + 40 | 0;
  i11 = i8 + 584 | 0;
  i12 = i8 + 1088 | 0;
  i13 = i8 + 1092 | 0;
  i14 = i8 + 1096 | 0;
  i15 = i8 + 1100 | 0;
  i16 = i8 + 8 | 0;
  i17 = i8 + 12 | 0;
  i1 = 0;
  i3 = 0;
  do {
   L5 : do if (!(_emscripten_get_gamepad_status(i3 | 0, i8 | 0) | 0)) {
    i1 = i1 + 1 | 0;
    if (_strncmp(i20, gb + 363721 | 0, 64) | 0) {
     if ((HEAP32[i16 >> 2] | 0) > 0) {
      i2 = 0;
      do {
       __ZN12InputManager19SetJoystickPositionEiif(i18, i1, i2, Math_fround(+HEAPF64[i8 + 16 + (i2 << 3) >> 3]));
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) < (HEAP32[i16 >> 2] | 0));
     }
     if ((HEAP32[i17 >> 2] | 0) > 0) i2 = 0; else break;
     while (1) {
      HEAP32[i27 >> 2] = i1;
      HEAP32[i27 + 4 >> 2] = i2;
      _sprintf(i9, gb + 441307 | 0, i27) | 0;
      HEAP32[i27 >> 2] = 0;
      HEAP32[i27 + 4 >> 2] = 0;
      HEAP32[i27 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i27, i9, _strlen(i9) | 0);
      i31 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i27) | 0;
      i30 = i8 + 1040 + (i2 << 2) | 0;
      __ZN12InputManager11SetKeyStateEib(i18, i31, (HEAP32[i30 >> 2] | 0) != 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
      HEAP32[i28 >> 2] = i2;
      _sprintf(i9, gb + 441329 | 0, i28) | 0;
      HEAP32[i28 >> 2] = 0;
      HEAP32[i28 + 4 >> 2] = 0;
      HEAP32[i28 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i28, i9, _strlen(i9) | 0);
      i31 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i28) | 0;
      __ZN12InputManager11SetKeyStateEib(i18, i31, (HEAP32[i30 >> 2] | 0) != 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (HEAP32[i17 >> 2] | 0)) break L5;
     }
    }
    f33 = Math_fround(+HEAPF64[i21 >> 3]);
    f32 = Math_fround(+HEAPF64[i22 >> 3]);
    f6 = Math_fround(+HEAPF64[i23 >> 3]);
    f4 = Math_fround(+HEAPF64[i24 >> 3]);
    f5 = Math_fround(+HEAPF64[i10 >> 3]);
    f7 = Math_fround(+HEAPF64[i11 >> 3]);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 0, f33);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 1, f32);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 3, f4);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 4, f5);
    if (!(HEAP32[i12 >> 2] | 0)) f5 = (HEAP32[i13 >> 2] | 0) == 0 ? Math_fround(0.0) : Math_fround(-1.0); else f5 = Math_fround(1.0);
    if (!(HEAP32[i14 >> 2] | 0)) f4 = (HEAP32[i15 >> 2] | 0) == 0 ? Math_fround(0.0) : Math_fround(1.0); else f4 = Math_fround(-1.0);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 6, f5);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 5, f4);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 8, f6);
    __ZN12InputManager19SetJoystickPositionEiif(i18, i1, 9, f7);
    i2 = 0;
    do {
     if ((i2 & -2 | 0) != 6) {
      i30 = HEAP32[gb + 25792 + (i2 << 2) >> 2] | 0;
      HEAP32[i25 >> 2] = i1;
      HEAP32[i25 + 4 >> 2] = i30;
      _sprintf(i9, gb + 441307 | 0, i25) | 0;
      HEAP32[i25 >> 2] = 0;
      HEAP32[i25 + 4 >> 2] = 0;
      HEAP32[i25 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, i9, _strlen(i9) | 0);
      i34 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i25) | 0;
      i31 = i8 + 1040 + (i2 << 2) | 0;
      __ZN12InputManager11SetKeyStateEib(i18, i34, (HEAP32[i31 >> 2] | 0) != 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
      HEAP32[i26 >> 2] = i30;
      _sprintf(i9, gb + 441329 | 0, i26) | 0;
      HEAP32[i26 >> 2] = 0;
      HEAP32[i26 + 4 >> 2] = 0;
      HEAP32[i26 + 8 >> 2] = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i26, i9, _strlen(i9) | 0);
      i30 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i26) | 0;
      __ZN12InputManager11SetKeyStateEib(i18, i30, (HEAP32[i31 >> 2] | 0) != 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 16);
   } while (0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i19 | 0));
 }
 i1 = HEAP32[gb + 1101424 >> 2] | 0;
 if ((i1 | 0) > 0) i2 = 0; else {
  STACKTOP = i29;
  return;
 }
 do {
  do if (((HEAP32[gb + 1101428 + (i2 * 68 | 0) + 36 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
   i3 = gb + 1103604 + (i2 << 2) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0)) {
    HEAPF32[i3 >> 2] = Math_fround(0.0);
    break;
   } else {
    i1 = i1 + -1 | 0;
    HEAP32[gb + 1101424 >> 2] = i1;
    i34 = gb + 1101428 + (i2 * 68 | 0) | 0;
    _memmove(i34 | 0, i34 + 68 | 0, (i1 - i2 | 0) * 68 | 0) | 0;
    i2 = i2 + -1 | 0;
    break;
   }
  } while (0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i1 | 0));
 STACKTOP = i29;
 return;
}

function __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 56 | 0;
 i8 = i10;
 i9 = i10 + 44 | 0;
 i6 = i10 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __Z11IntToStringi(i9, -1);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i3 ? HEAP32[i9 >> 2] | 0 : i9, i4, i4 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 1074320 | 0, 1) | 0;
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i3 ? HEAP32[i8 >> 2] | 0 : i8, i3 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __Z11IntToStringi(i9, i1);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i1 ? HEAP32[i9 >> 2] | 0 : i9, i4, i4 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 1074320 | 0, 1) | 0;
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i1 ? HEAP32[i8 >> 2] | 0 : i8, i1 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i4 = i2 + 4 | 0;
 __Z11IntToStringi(i9, ((HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 12 | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = HEAP8[i9 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i3 ? HEAP32[i9 >> 2] | 0 : i9, i1, i1 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 1074320 | 0, 1) | 0;
 i1 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i3 ? HEAP32[i8 >> 2] | 0 : i8, i3 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) {
  i2 = i8 + 11 | 0;
  i3 = i8 + 4 | 0;
  do {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i12 = i11 << 24 >> 24 < 0;
   i11 = i12 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i12 ? HEAP32[i1 >> 2] | 0 : i1, i11, i11 + 1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 1074320 | 0, 1) | 0;
   i11 = HEAP8[i2 >> 0] | 0;
   i12 = i11 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i12 ? HEAP32[i8 >> 2] | 0 : i8, i12 ? HEAP32[i3 >> 2] | 0 : i11 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
 }
 __ZN4FileC2Ev(i8);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 444384 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i9, i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!(__ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i8, i9, 1, 3) | 0)) {
  i12 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZN4FileD2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i10;
  return i12 | 0;
 }
 __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i9, 10, 10) | 0;
 i1 = i7 + 11 | 0;
 i12 = HEAP8[i1 >> 0] | 0;
 i11 = i12 << 24 >> 24 < 0;
 i12 = __ZN4File5WriteEPKvj(i8, i11 ? HEAP32[i7 >> 2] | 0 : i7, i11 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255) | 0;
 __ZN4File5CloseEv(i8) | 0;
 if (!i12) {
  i12 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZN4FileD2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i10;
  return i12 | 0;
 }
 i1 = HEAP8[i1 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZN4FileD2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i10;
  return i12 | 0;
 } else {
  i12 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZN4FileD2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i10;
  return i12 | 0;
 }
 return 0;
}

function __ZN5physx20PxsParticleSystemSim4initERNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterE(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 1 | 0;
 i7 = i10;
 i4 = i9 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 __ZN5physx15PxsParticleData13clearSimStateEv(i1);
 i8 = i9 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 HEAPF32[i9 + 1104 >> 2] = Math_fround(0.0);
 HEAP32[i9 + 1112 >> 2] = 0;
 HEAP32[i9 + 1116 >> 2] = 0;
 HEAP32[i9 + 1120 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = 0;
 __ZN5physx20PxsParticleSystemSim19initializeParameterEv(i9);
 i4 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = (i4 << 4) + 19 | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i11 | 0, i2 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 331) | 0;
 if (!i1) i1 = 0; else {
  i11 = i1 + 19 & -16;
  HEAP32[i11 + -4 >> 2] = i11 - i1;
  i1 = i11;
 }
 HEAP32[i9 + 44 >> 2] = i1;
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i2 | 0, i11 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 332) | 0;
 if (!i1) i1 = 0; else {
  i11 = i1 + 19 & -16;
  HEAP32[i11 + -4 >> 2] = i11 - i1;
  i1 = i11;
 }
 HEAP32[i9 + 48 >> 2] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!(i2 & 2)) {
  HEAP32[i9 + 52 >> 2] = 0;
  HEAP32[i9 + 56 >> 2] = 0;
 } else {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i11 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 335) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 52 >> 2] = i1;
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i11 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 336) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 56 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i1 + 20 >> 2] | 0;
 }
 if ((i2 & 3 | 0) == 3) {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i11 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 346) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 20 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i1 + 20 >> 2] | 0;
 }
 if (i2 & 32) {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i11 | 0, i4 << 5 | 19 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 362) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 60 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i1 + 20 >> 2] | 0;
 }
 if (!(i2 & 65536)) {
  i1 = HEAP16[i1 + 80 >> 1] | 0;
  if (i1 & 16) i5 = 22;
 } else i5 = 22;
 if ((i5 | 0) == 22) {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i11 | 0, (i4 * 12 | 0) + 19 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 370) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 64 >> 2] = i1;
  i1 = HEAP16[(HEAP32[i8 >> 2] | 0) + 80 >> 1] | 0;
 }
 if (i1 & 32) {
  i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i11 | 0, (i4 * 12 | 0) + 19 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 373) | 0;
  if (!i1) i1 = 0; else {
   i11 = i1 + 19 & -16;
   HEAP32[i11 + -4 >> 2] = i11 - i1;
   i1 = i11;
  }
  HEAP32[i9 + 68 >> 2] = i1;
 }
 HEAP32[i9 + 24 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, 8192, gb + 769032 | 0, 375) | 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 24, gb + 769032 | 0, 380) | 0;
 HEAP32[i9 + 72 >> 2] = i1;
 if (!i1) {
  i11 = i9 + 1304 | 0;
  HEAP32[i11 >> 2] = 0;
  i11 = i9 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 f12 = Math_fround(HEAPF32[i9 + 92 >> 2]);
 i11 = HEAP32[i8 >> 2] | 0;
 __ZN5physx19PxsFluidSpatialHashC2Ejfjb(i1, 1024, f12, HEAP32[i11 + 24 >> 2] | 0, (HEAP32[i11 + 20 >> 2] & 65536 | 0) != 0);
 i11 = i9 + 1304 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = i9 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i44, i41, i45) {
 i44 = i44 | 0;
 i41 = i41 | 0;
 i45 = i45 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i42 = 0, i43 = 0, i46 = 0, i47 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i46 + 144 | 0;
 i43 = i46 + 136 | 0;
 i40 = i46;
 i39 = i46 + 24 | 0;
 if (!i41) {
  STACKTOP = i46;
  return;
 }
 i9 = i39 + 4 | 0;
 i20 = i39 + 8 | 0;
 i29 = i39 + 12 | 0;
 i31 = i39 + 16 | 0;
 i32 = i39 + 20 | 0;
 i33 = i39 + 24 | 0;
 i35 = i39 + 28 | 0;
 i36 = i39 + 32 | 0;
 i37 = i39 + 36 | 0;
 i10 = i39 + 40 | 0;
 i11 = i39 + 44 | 0;
 i12 = i39 + 48 | 0;
 i13 = i39 + 52 | 0;
 i14 = i39 + 56 | 0;
 i15 = i39 + 60 | 0;
 i16 = i39 + 64 | 0;
 i17 = i39 + 68 | 0;
 i18 = i39 + 72 | 0;
 i19 = i39 + 76 | 0;
 i21 = i39 + 80 | 0;
 i22 = i39 + 84 | 0;
 i23 = i39 + 88 | 0;
 i24 = i39 + 92 | 0;
 i25 = i39 + 96 | 0;
 i26 = i39 + 100 | 0;
 i27 = i39 + 104 | 0;
 i28 = i39 + 108 | 0;
 i38 = 0;
 do {
  i1 = HEAP32[i45 + (i38 << 2) >> 2] | 0;
  i7 = HEAP32[i1 + 104 >> 2] | 0;
  i30 = i44 + (i38 * 36 | 0) | 0;
  if (!(HEAP8[i44 + (i38 * 36 | 0) + 32 >> 0] | 0)) {
   if (HEAP8[i44 + (i38 * 36 | 0) + 33 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 284 >> 2] | 0, i7 | 0);
   if (!(HEAP8[gb + 1552705 >> 0] | 0)) {
    mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 156 >> 2] | 0, i7 | 0, i44 + (i38 * 36 | 0) + 8 | 0, 0);
    mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 164 >> 2] | 0, i7 | 0, i44 + (i38 * 36 | 0) + 20 | 0, 0);
   } else {
    mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 168 >> 2] | 0, i7 | 0, i44 + (i38 * 36 | 0) + 8 | 0, 3, 0);
    mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 172 >> 2] | 0, i7 | 0, i44 + (i38 * 36 | 0) + 20 | 0, 3, 0);
   }
   i34 = HEAP32[i1 + 48 >> 2] | 0;
   i8 = HEAP32[i1 + 44 >> 2] | 0;
   i2 = i34 + 4 - (i8 << 2) | 0;
   HEAP32[i40 >> 2] = 0;
   HEAP32[i40 + 4 >> 2] = 0;
   HEAP32[i40 + 8 >> 2] = 0;
   HEAP32[i40 + 12 >> 2] = 0;
   HEAP32[i40 + 16 >> 2] = 0;
   HEAP32[i40 >> 2] = i34 >>> 0 < 4 ? i34 : 4;
   i3 = i8 + -1 | 0;
   if (i3 >>> 0 > 1) {
    i4 = 1;
    do {
     HEAP32[i40 + (i4 << 2) >> 2] = 4;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i3 | 0));
   }
   HEAP32[i40 + (i3 << 2) >> 2] = i2;
   if (i8 | 0) {
    i4 = i1 + 40 | 0;
    i6 = 0;
    do {
     i2 = i6 << 2;
     i3 = HEAP32[i30 >> 2] | 0;
     HEAP32[i39 >> 2] = HEAP32[i3 + (i2 * 56 | 0) >> 2];
     HEAP32[i9 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 4 >> 2];
     HEAP32[i20 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 8 >> 2];
     HEAP32[i29 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 12 >> 2];
     HEAP32[i31 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 16 >> 2];
     HEAP32[i32 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 20 >> 2];
     HEAP32[i33 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 24 >> 2];
     i5 = i2 | 1;
     HEAP32[i35 >> 2] = HEAP32[i3 + (i5 * 56 | 0) >> 2];
     HEAP32[i36 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 4 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 8 >> 2];
     HEAP32[i10 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 12 >> 2];
     HEAP32[i11 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 16 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 20 >> 2];
     HEAP32[i13 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 24 >> 2];
     i5 = i2 | 2;
     HEAP32[i14 >> 2] = HEAP32[i3 + (i5 * 56 | 0) >> 2];
     HEAP32[i15 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 4 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 8 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 12 >> 2];
     HEAP32[i18 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 16 >> 2];
     HEAP32[i19 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 20 >> 2];
     HEAP32[i21 >> 2] = HEAP32[i3 + (i5 * 56 | 0) + 24 >> 2];
     i2 = i2 | 3;
     HEAP32[i22 >> 2] = HEAP32[i3 + (i2 * 56 | 0) >> 2];
     HEAP32[i23 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 4 >> 2];
     HEAP32[i24 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 8 >> 2];
     HEAP32[i25 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 12 >> 2];
     HEAP32[i26 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 16 >> 2];
     HEAP32[i27 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 20 >> 2];
     HEAP32[i28 >> 2] = HEAP32[i3 + (i2 * 56 | 0) + 24 >> 2];
     i2 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i40 + (i6 << 2) >> 2] | 0;
     mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i42 | 0, 128, 0) | 0;
     if (i3 | 0) {
      i5 = 0;
      do {
       i1 = HEAP8[i2 + (i6 * 944 | 0) + 928 + i5 >> 0] | 0;
       i47 = i1 << 24 >> 24 == -1;
       i1 = i47 ? -1 : i1 & 255;
       if (!i47) {
        if ((i1 | 0) < 128) i1 = HEAP32[i42 + (i1 << 2) >> 2] | 0; else {
         mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i43 | 0, 1, i1 | 0) | 0;
         i1 = HEAP32[i43 >> 2] | 0;
        }
        mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i39 + (i5 * 28 | 0) | 0);
       }
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i3 | 0));
     }
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i8 | 0));
   }
   if (i34 | 0) {
    i3 = 0;
    do {
     i1 = HEAP32[i30 >> 2] | 0;
     i2 = HEAP32[i1 + (i3 * 56 | 0) + 28 >> 2] | 0;
     if (i2 | 0) __ZN5physx14PxRigidBodyExt13addForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i2, i1 + (i3 * 56 | 0) + 32 | 0, i1 + (i3 * 56 | 0) + 44 | 0, 0, 1);
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i34 | 0));
   }
  }
  i38 = i38 + 1 | 0;
 } while ((i38 | 0) != (i41 | 0));
 STACKTOP = i46;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i9, i1) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 409;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i7 >> 2] = i6;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx7Cooking14cookConvexMeshERKNS_16PxConvexMeshDescERNS_14PxOutputStreamEPNS_25PxConvexMeshCookingResult4EnumE(i16, i2, i15, i20) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24 + 24 | 0;
 i13 = i24 + 16 | 0;
 i12 = i24 + 8 | 0;
 i3 = i24;
 i14 = i24 + 264 | 0;
 i11 = i24 + 232 | 0;
 i19 = i24 + 32 | 0;
 i23 = i24 + 28 | 0;
 i22 = i24 + 56 | 0;
 i18 = (i20 | 0) != 0;
 if (i18) HEAP32[i20 >> 2] = 2;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 L4 : do if (i1 >>> 0 >= 3) {
  if (i1 >>> 0 > 65535) if (HEAP16[i2 + 48 >> 1] & 2) break;
  if (HEAP32[i2 + 4 >> 2] | 0) if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 12) {
   do if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    if (!(HEAP32[i2 + 28 >> 2] | 0)) {
     i1 = HEAP16[i2 + 48 >> 1] | 0;
     if (!(i1 & 4)) break L4; else break;
    }
    if ((HEAP32[i2 + 32 >> 2] | 0) >>> 0 < 4) break L4;
    if (!(HEAP32[i2 + 40 >> 2] | 0)) break L4;
    i1 = HEAP16[i2 + 48 >> 1] | 0;
    if ((HEAP32[i2 + 36 >> 2] | 0) >>> 0 < ((i1 & 2 ^ 2) + 2 | 0) >>> 0) break L4;
    if ((HEAP32[i2 + 24 >> 2] | 0) >>> 0 < 20) break L4;
   } else {
    if ((HEAP32[i2 + 20 >> 2] | 0) >>> 0 < 2) break L4;
    i1 = HEAP16[i2 + 48 >> 1] | 0;
    if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 < (i1 & 2 ? 6 : 12) >>> 0) break L4;
   } while (0);
   i10 = HEAP16[i2 + 50 >> 1] | 0;
   i9 = i10 + -4 << 16 >> 16;
   if ((i9 & 65535) < 253) {
    i4 = i14;
    i3 = i4 + 48 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i4 = i4 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i4 | 0) < (i3 | 0));
    i4 = i14 + 48 | 0;
    HEAP16[i4 >> 1] = i1;
    HEAP16[i14 + 50 >> 1] = i10;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    HEAP32[i11 + 12 >> 2] = 0;
    HEAPF32[i11 + 16 >> 2] = Math_fround(.00100000005);
    i5 = i11 + 28 | 0;
    HEAP32[i5 >> 2] = 4096;
    i6 = i11 + 20 | 0;
    HEAPF32[i6 >> 2] = Math_fround(.00999999977);
    HEAP8[i19 >> 0] = 1;
    i7 = i19 + 4 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    __ZN5physx11HullLibraryC2Ev(i23);
    i8 = i1 & 65535;
    L23 : do if (!(i8 & 4)) {
     i1 = HEAP32[i14 + 8 >> 2] | 0;
     i21 = 35;
    } else {
     i1 = (i1 & 20) == 20;
     HEAP32[i11 >> 2] = 5;
     i2 = i14 + 8 | 0;
     HEAP32[i11 + 4 >> 2] = HEAP32[i2 >> 2];
     i3 = i14 + 4 | 0;
     HEAP32[i11 + 8 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i14 >> 2];
     if (!(i8 & 8)) HEAPF32[i6 >> 2] = Math_fround(0.0); else {
      i8 = HEAP32[i16 + 8 >> 2] | 0;
      HEAP32[i6 >> 2] = i8;
      if ((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) {
       __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726521 | 0, 232, gb + 728979 | 0, i12);
       i1 = 0;
       break;
      }
     }
     if (i1) {
      i12 = HEAP32[i16 + 12 >> 2] | 0;
      HEAP32[i11 + 24 >> 2] = i12;
      if ((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) {
       __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726521 | 0, 238, gb + 729052 | 0, i13);
       i1 = 0;
       break;
      }
     } else HEAPF32[i11 + 24 >> 2] = Math_fround(0.0);
     if ((i9 & 65535) < 252) HEAP32[i5 >> 2] = i10 & 65535;
     switch (__ZN5physx11HullLibrary16CreateConvexHullERKNS_8HullDescERNS_10HullResultE(i23, i11, i19) | 0) {
     case 0:
      {
       i1 = HEAP32[i7 >> 2] | 0;
       HEAP32[i2 >> 2] = i1;
       HEAP32[i14 >> 2] = 12;
       HEAP32[i3 >> 2] = HEAP32[i19 + 8 >> 2];
       HEAP32[i14 + 20 >> 2] = HEAP32[i19 + 12 >> 2];
       HEAP32[i14 + 16 >> 2] = HEAP32[i19 + 20 >> 2];
       HEAP32[i14 + 12 >> 2] = 12;
       HEAP16[i4 >> 1] = HEAP16[i4 >> 1] & -5;
       i21 = 35;
       break L23;
      }
     case 3:
      break;
     default:
      {
       i1 = 0;
       break L23;
      }
     }
     if (i18) {
      HEAP32[i20 >> 2] = 1;
      i1 = 0;
     } else i1 = 0;
    } while (0);
    do if ((i21 | 0) == 35) {
     if (i1 >>> 0 > 255) {
      __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726521 | 0, 273, gb + 729131 | 0, i17);
      __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE(i23, i19) | 0;
      i1 = 0;
      break;
     }
     __ZN5physx17ConvexMeshBuilderC2Ev(i22);
     if (__ZN5physx17ConvexMeshBuilder12loadFromDescERKNS_16PxConvexMeshDescENS_10PxPlatform4EnumE(i22, i14, HEAP32[i16 + 4 >> 2] | 0) | 0) {
      i1 = __ZNK5physx17ConvexMeshBuilder4saveERNS_14PxOutputStreamEb(i22, i15, mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0) | 0) | 0;
      __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE(i23, i19) | 0;
      if (i18 & i1) {
       HEAP32[i20 >> 2] = 0;
       i1 = 1;
      }
     } else {
      __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE(i23, i19) | 0;
      i1 = 0;
     }
     __ZN5physx17ConvexMeshBuilderD2Ev(i22);
    } while (0);
    __ZN5physx11HullLibraryD2Ev(i23);
    i23 = i1;
    STACKTOP = i24;
    return i23 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726521 | 0, 212, gb + 728905 | 0, i3);
 i23 = 0;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZNK12ShaderErrors9LogErrorsEPKcS1_P6Objecti(i2, i40, i3, i1, i41) {
 i2 = i2 | 0;
 i40 = i40 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i41 = i41 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i39 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i39 + 32 | 0;
 i38 = i39 + 24 | 0;
 i37 = i39 + 16 | 0;
 i35 = i39;
 i33 = i39 + 72 | 0;
 i34 = i39 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i32 = i2 + 4 | 0;
 if ((i1 | 0) == (i32 | 0)) {
  STACKTOP = i39;
  return;
 }
 i12 = i33 + 20 | 0;
 i13 = i33 + 24 | 0;
 i14 = i33 + 4 | 0;
 i15 = i34 + 4 | 0;
 i16 = i34 + 4 | 0;
 i17 = i34 + 20 | 0;
 i18 = i33 + 4 | 0;
 i19 = i34 + 4 | 0;
 i20 = i34 + 20 | 0;
 i21 = i34 + 4 | 0;
 i22 = i34 + 24 | 0;
 i23 = i34 + 4 | 0;
 i24 = i34 + 20 | 0;
 i25 = i34 + 4 | 0;
 i26 = i34 + 24 | 0;
 i27 = i34 + 4 | 0;
 i28 = i34 + 20 | 0;
 i29 = i34 + 4 | 0;
 i30 = i34 + 24 | 0;
 i31 = i34 + 24 | 0;
 do {
  i2 = i1 + 16 | 0;
  i11 = (HEAP8[i1 + 72 >> 0] | 0) != 0;
  HEAP32[i33 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i8 = gb + 64016 | 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i13;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP8[i14 >> 0] = 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i35 >> 2] = i11 ? gb + 661507 | 0 : gb + 597964 | 0;
  HEAP32[i35 + 4 >> 2] = i40;
  HEAP32[i35 + 8 >> 2] = i2;
  __Z12FormatStringPKcz(i34, gb + 480390 | 0, i35);
  i10 = HEAP32[i34 >> 2] | 0;
  i8 = (i10 | 0) == 0;
  i10 = i8 ? i16 : i10;
  i9 = HEAP32[i17 >> 2] | 0;
  i6 = HEAP32[i33 >> 2] | 0;
  i7 = (i6 | 0) == 0;
  do if ((HEAP32[i15 >> 2] | 0) != 0 | i8) {
   i8 = i7 ? i14 : i6;
   if (i8 >>> 0 <= i10 >>> 0) {
    i2 = HEAP32[i12 >> 2] | 0;
    if ((i8 + i2 | 0) >>> 0 > i10 >>> 0) {
     i2 = i2 >>> 0 < i9 >>> 0 ? i2 : i9;
     if ((i8 | 0) != (i10 | 0)) _memmove(i8 | 0, i10 | 0, i2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     break;
    }
   }
   i2 = HEAP32[i18 >> 2] | 0;
   i4 = (i2 | 0) == 0;
   if (i4) if (i7) {
    i2 = 15;
    i5 = 16;
   } else i5 = 19; else {
    i2 = i7 ? 15 : i2;
    i5 = 16;
   }
   if ((i5 | 0) == 16) {
    i5 = 0;
    if (i2 >>> 0 < i9 >>> 0) if (i7 | i4) i5 = 19; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i6, i13);
     i5 = 19;
    } else i2 = i8;
   }
   if ((i5 | 0) == 19) {
    if (i9 >>> 0 > 15) {
     i2 = i9;
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + 1 | 0, 16, i13, 0, gb + 1047486 | 0, 251) | 0;
    } else {
     i2 = 0;
     i4 = 0;
    }
    HEAP32[i33 >> 2] = i4;
    HEAP32[i18 >> 2] = i2;
    i2 = (i4 | 0) == 0 ? i14 : i4;
   }
   _memcpy(i2 | 0, i10 | 0, i9 | 0) | 0;
   HEAP8[i2 + i9 >> 0] = 0;
   HEAP32[i12 >> 2] = i9;
  } else {
   if (!(i7 | (HEAP32[i18 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i6, i13);
   HEAP32[i33 >> 2] = i10;
   HEAP32[i12 >> 2] = i9;
   HEAP32[i18 >> 2] = 0;
  } while (0);
  i2 = HEAP32[i34 >> 2] | 0;
  if (!((i2 | 0) == 0 | (HEAP32[i15 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i2, i31);
  i8 = i1 + 68 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  do if ((i5 | 0) > 0) {
   i6 = i1 + 48 | 0;
   i7 = i6 + 11 | 0;
   i2 = HEAP8[i7 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   if (i4) i2 = HEAP32[i1 + 52 >> 2] | 0; else i2 = i2 & 255;
   if (!i2) {
    HEAP32[i37 >> 2] = i5;
    __Z12FormatStringPKcz(i34, gb + 480412 | 0, i37);
    i2 = HEAP32[i34 >> 2] | 0;
    __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i33, HEAP32[i12 >> 2] | 0, 0, (i2 | 0) == 0 ? i19 : i2, HEAP32[i20 >> 2] | 0);
    i2 = HEAP32[i34 >> 2] | 0;
    if (!((i2 | 0) == 0 | (HEAP32[i21 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i2, i22);
    break;
   }
   if (i4) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
   HEAP32[i38 >> 2] = i2;
   HEAP32[i38 + 4 >> 2] = i5;
   __Z12FormatStringPKcz(i34, gb + 480424 | 0, i38);
   i2 = HEAP32[i34 >> 2] | 0;
   __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i33, HEAP32[i12 >> 2] | 0, 0, (i2 | 0) == 0 ? i23 : i2, HEAP32[i24 >> 2] | 0);
   i2 = HEAP32[i34 >> 2] | 0;
   if (!((i2 | 0) == 0 | (HEAP32[i25 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i2, i26);
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    i3 = HEAP32[i6 >> 2] | 0;
    break;
   } else {
    i3 = i6;
    break;
   }
  } while (0);
  i2 = i1 + 32 | 0;
  i10 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i10 << 24 >> 24 < 0;
  if ((i4 ? HEAP32[i1 + 36 >> 2] | 0 : i10 & 255) | 0) {
   if (i4) i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i36 >> 2] = i2;
   __Z12FormatStringPKcz(i34, gb + 480435 | 0, i36);
   i2 = HEAP32[i34 >> 2] | 0;
   __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i33, HEAP32[i12 >> 2] | 0, 0, (i2 | 0) == 0 ? i27 : i2, HEAP32[i28 >> 2] | 0);
   i2 = HEAP32[i34 >> 2] | 0;
   if (!((i2 | 0) == 0 | (HEAP32[i29 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i2, i30);
  }
  i2 = HEAP32[i33 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i2 | 0) == 0 ? i14 : i2, 0, i3, HEAP32[i8 >> 2] | 0, i11 ? 262276 : 262212, i41, i41, 0);
  i2 = HEAP32[i33 >> 2] | 0;
  if (!((i2 | 0) == 0 | (HEAP32[i18 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
 } while ((i1 | 0) != (i32 | 0));
 STACKTOP = i39;
 return;
}

function __ZN19AssetBundleManifest22CollectAllDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE(i7, i3, i17) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i23;
 i19 = i23 + 24 | 0;
 i20 = i23 + 8 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i21 = i17 + 4 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i4 = i18 + 4 | 0;
  i2 = i1;
  while (1) {
   i1 = i2 + -16 | 0;
   HEAP32[i21 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i16 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i4 >> 2] = i16;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
    i1 = HEAP32[i21 >> 2] | 0;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 i4 = __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr(i7, i3) | 0;
 if ((i4 | 0) == -1) {
  STACKTOP = i23;
  return;
 }
 HEAP32[i19 + 4 >> 2] = 0;
 i5 = i19 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i16 = i19 + 4 | 0;
 HEAP32[i19 >> 2] = i16;
 __ZN19AssetBundleManifest33CollectAllDependenciesRecursivelyEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(i7, i4, i19);
 i6 = HEAP32[i16 >> 2] | 0;
 if (i6 | 0) {
  i3 = i16;
  i2 = i6;
  L13 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L13;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i16 | 0)) if ((i4 | 0) >= (HEAP32[i3 + 16 >> 2] | 0)) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i19 >> 2] | 0) == (i3 | 0)) HEAP32[i19 >> 2] = i1;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i3);
   __ZdlPv(i3);
  }
 }
 i2 = HEAP32[i19 >> 2] | 0;
 if ((i2 | 0) != (i16 | 0)) {
  i7 = i7 + 48 | 0;
  i8 = i20 + 12 | 0;
  i6 = i20 + 12 | 0;
  i9 = i18 + 4 | 0;
  i10 = i20 + 8 | 0;
  i11 = i20 + 4 | 0;
  i12 = i17 + 8 | 0;
  i13 = i20 + 11 | 0;
  i14 = i18 + 4 | 0;
  i15 = i18 + 4 | 0;
  while (1) {
   __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_(i7, i18, i2 + 16 | 0);
   i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 >> 2] = i1;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i20);
    i1 = HEAP32[i6 >> 2] | 0;
    i22 = 26;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i13 >> 0] = i4;
    if (!i4) i1 = i20; else {
     i1 = i20;
     i22 = 28;
    }
   } else i22 = 26;
   if ((i22 | 0) == 26) {
    i5 = i4 + 16 & -16;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i9 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i20 >> 2] = i1;
    HEAP32[i10 >> 2] = i5 | -2147483648;
    HEAP32[i11 >> 2] = i4;
    i22 = 28;
   }
   if ((i22 | 0) == 28) {
    i22 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i1 = HEAP32[i21 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i17, i20); else {
    i5 = HEAP8[i13 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i20 >> 2] | 0 : i20;
    i5 = i3 ? HEAP32[i11 >> 2] | 0 : i5 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i3;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i3 = HEAP32[i1 + 12 >> 2] | 0;
     i22 = 33;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i5;
     if (i5) i22 = 35;
    } else i22 = 33;
    if ((i22 | 0) == 33) {
     i24 = i5 + 16 & -16;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i15 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i1 + 8 >> 2] = i24 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i5;
     i1 = i3;
     i22 = 35;
    }
    if ((i22 | 0) == 35) {
     i22 = 0;
     _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i1 + i5 >> 0] = 0;
    HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 16;
   }
   if ((HEAP8[i13 >> 0] | 0) < 0) {
    i24 = HEAP32[i20 >> 2] | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i14 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i24, i18);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i16 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(HEAP32[i17 >> 2] | 0, HEAP32[i21 >> 2] | 0, i18);
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i19, HEAP32[i16 >> 2] | 0);
 STACKTOP = i23;
 return;
}

function __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i30 + 48 | 0;
 i26 = i30 + 32 | 0;
 i27 = i30 + 16 | 0;
 i24 = i30;
 i28 = i6 + 20 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 i29 = i6 + 32 | 0;
 i23 = HEAP32[i29 >> 2] | 0;
 i2 = i1 + (i23 << 2) | 0;
 L1 : do if (!i23) i23 = i1; else {
  do {
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
    i23 = i1;
    break L1;
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i30;
  return;
 } while (0);
 if ((i23 | 0) == (i2 | 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = i5 + 2344 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i26 + 12 >> 2] = i2;
 i3 = _strlen(i1) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i26);
  i2 = HEAP32[i26 + 12 >> 2] | 0;
  i4 = 11;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i26 + 11 >> 0] = i3;
  if (!i3) i1 = i26; else {
   i2 = i26;
   i4 = 13;
  }
 } else i4 = 11;
 if ((i4 | 0) == 11) {
  i22 = i3 + 16 & -16;
  HEAP32[i25 >> 2] = 54;
  HEAP32[i25 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i26 >> 2] = i2;
  HEAP32[i26 + 8 >> 2] = i22 | -2147483648;
  HEAP32[i26 + 4 >> 2] = i3;
  i4 = 13;
 }
 if ((i4 | 0) == 13) {
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  i1 = i2;
 }
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 i22 = i5 + 120 | 0;
 i11 = i5 + 124 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) i1 = i27 + 11 | 0; else {
  i12 = i24 + 11 | 0;
  i13 = i24 + 4 | 0;
  i1 = i27 + 11 | 0;
  i14 = i27 + 8 | 0;
  i15 = i27 + 4 | 0;
  i16 = i24 + 12 | 0;
  i17 = i25 + 4 | 0;
  i18 = i6 + 136 | 0;
  i19 = i6 + 140 | 0;
  i20 = i6 + 148 | 0;
  i21 = i6 + 144 | 0;
  i8 = i6 + 140 | 0;
  i9 = i25 + 4 | 0;
  i10 = i25 + 4 | 0;
  i7 = 0;
  do {
   __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i24, i26, i2 + (i7 * 40 | 0) + 20 | 0);
   i6 = HEAP8[i12 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   i5 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
   i6 = i2 ? HEAP32[i13 >> 2] | 0 : i6 & 255;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i4 = (HEAP32[i14 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   do if (i6 >>> 0 > i4 >>> 0) {
    i3 = i3 ? HEAP32[i15 >> 2] | 0 : i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i27, i4, i6 - i4 | 0, i3, 0, i3, i6, i5);
   } else {
    i2 = i3 ? HEAP32[i27 >> 2] | 0 : i27;
    if (i6 | 0) _memmove(i2 | 0, i5 | 0, i6 | 0) | 0;
    HEAP8[i2 + i6 >> 0] = 0;
    if ((HEAP8[i1 >> 0] | 0) < 0) {
     HEAP32[i15 >> 2] = i6;
     break;
    } else {
     HEAP8[i1 >> 0] = i6;
     break;
    }
   } while (0);
   if ((HEAP8[i12 >> 0] | 0) < 0) {
    i6 = HEAP32[i24 >> 2] | 0;
    i5 = HEAP32[i16 >> 2] | 0;
    HEAP32[i25 >> 2] = 54;
    HEAP32[i17 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i25);
   }
   i4 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i18, i27) | 0;
   if ((i4 | 0) != (i19 | 0)) {
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) {
     i3 = i4;
     while (1) {
      i2 = HEAP32[i3 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
     }
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((HEAP32[i18 >> 2] | 0) == (i4 | 0)) HEAP32[i18 >> 2] = i2;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
    __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i4);
    i2 = i4 + 16 | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i6 = HEAP32[i2 >> 2] | 0;
     i5 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i25 >> 2] = 54;
     HEAP32[i9 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i6, i25);
    }
    i6 = HEAP32[i21 >> 2] | 0;
    HEAP32[i25 >> 2] = 54;
    HEAP32[i10 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i25);
   }
   i7 = i7 + 1 | 0;
   i2 = HEAP32[i22 >> 2] | 0;
  } while (i7 >>> 0 < (((HEAP32[i11 >> 2] | 0) - i2 | 0) / 40 | 0) >>> 0);
 }
 i24 = i23 + 4 | 0;
 _memmove(i23 | 0, i24 | 0, (HEAP32[i28 >> 2] | 0) + (HEAP32[i29 >> 2] << 2) - i24 | 0) | 0;
 HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + -1;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i29 = HEAP32[i27 >> 2] | 0;
  i28 = HEAP32[i27 + 12 >> 2] | 0;
  HEAP32[i25 >> 2] = 54;
  HEAP32[i25 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i29, i25);
 }
 if ((HEAP8[i26 + 11 >> 0] | 0) < 0) {
  i29 = HEAP32[i26 >> 2] | 0;
  i28 = HEAP32[i26 + 12 >> 2] | 0;
  HEAP32[i25 >> 2] = 54;
  HEAP32[i25 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i29, i25);
 }
 STACKTOP = i30;
 return;
}

function __ZN11RadixSorter4SortEPjjb(i17, i18, i19, i14) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i20 = 0;
 i2 = i17 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 < i19 >>> 0) {
  i4 = i17 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  HEAP32[i4 >> 2] = 0;
  i5 = i17 + 12 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  i16 = i19 >>> 0 > 1073741823 ? -1 : i19 << 2;
  i3 = __Znaj(i16) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = __Znaj(i16) | 0;
  HEAP32[i2 >> 2] = i19;
  if (i19) {
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i3 + (i1 << 2) >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
 } else i5 = i17 + 12 | 0;
 _memset(HEAP32[i17 >> 2] | 0, 0, 4096) | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 i9 = i18 + (i19 << 2) | 0;
 i16 = HEAP32[i17 >> 2] | 0;
 i10 = i16 + 1024 | 0;
 i11 = i16 + 2048 | 0;
 i12 = i16 + 3072 | 0;
 i6 = HEAP32[i18 + (HEAP32[i15 >> 2] << 2) >> 2] | 0;
 i1 = (i9 | 0) == (i18 | 0);
 i2 = i15;
 if (i14) {
  if (i1) return i17 | 0; else {
   i3 = i6;
   i7 = i15;
   i8 = i18;
   i1 = 1;
  }
  while (1) {
   i4 = i7 + 4 | 0;
   i1 = (i6 | 0) < (i3 | 0) ? 0 : i1;
   i3 = i16 + ((HEAPU8[i8 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i10 + ((HEAPU8[i8 + 1 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i11 + ((HEAPU8[i8 + 2 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i8 + 4 | 0;
   i13 = i12 + ((HEAPU8[i8 + 3 >> 0] | 0) << 2) | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   if ((i3 | 0) == (i9 | 0)) break;
   i13 = i6;
   i7 = i4;
   i8 = i3;
   i6 = HEAP32[i18 + (HEAP32[i4 >> 2] << 2) >> 2] | 0;
   i3 = i13;
  }
  if (i1 & 1) return i17 | 0;
 } else {
  if (i1) return i17 | 0; else {
   i1 = 1;
   i4 = i15;
   i8 = i18;
   i3 = i6;
   i7 = i6;
  }
  while (1) {
   i6 = i4 + 4 | 0;
   i1 = i1 & i7 >>> 0 >= i3 >>> 0;
   i3 = i16 + ((HEAPU8[i8 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i10 + ((HEAPU8[i8 + 1 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i11 + ((HEAPU8[i8 + 2 >> 0] | 0) << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = i8 + 4 | 0;
   i13 = i12 + ((HEAPU8[i8 + 3 >> 0] | 0) << 2) | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   if ((i3 | 0) == (i9 | 0)) break;
   i13 = i7;
   i4 = i6;
   i8 = i3;
   i7 = HEAP32[i18 + (HEAP32[i6 >> 2] << 2) >> 2] | 0;
   i3 = i13;
  }
  if (i1) return i17 | 0;
 }
 if (i14) {
  i1 = 128;
  i10 = 0;
  do {
   i10 = (HEAP32[i12 + (i1 << 2) >> 2] | 0) + i10 | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  i11 = i17 + 4 | 0;
  i13 = i17 + 16 | 0;
  if (i14) {
   i9 = (i19 | 0) == 0;
   i8 = 0;
   i1 = i15;
   do {
    i6 = i16 + (i8 << 8 << 2) | 0;
    i3 = 0;
    while (1) {
     i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
     if ((i4 | 0) == (i19 | 0)) break;
     i3 = i3 + 1 | 0;
     if (!((i4 | 0) == 0 & i3 >>> 0 < 256)) {
      i20 = 39;
      break;
     }
    }
    if ((i20 | 0) == 39) {
     i20 = 0;
     i7 = HEAP32[i11 >> 2] | 0;
     if ((i8 | 0) == 3) {
      HEAP32[i7 >> 2] = i10;
      i3 = 1;
      i4 = i10;
      do {
       i4 = (HEAP32[i6 + (i3 + -1 << 2) >> 2] | 0) + i4 | 0;
       HEAP32[i7 + (i3 << 2) >> 2] = i4;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 128);
      HEAP32[i7 + 512 >> 2] = 0;
      i3 = 129;
      i4 = 0;
      do {
       i4 = (HEAP32[i6 + (i3 + -1 << 2) >> 2] | 0) + i4 | 0;
       HEAP32[i7 + (i3 << 2) >> 2] = i4;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 256);
     } else {
      HEAP32[i7 >> 2] = 0;
      i3 = 1;
      i4 = 0;
      do {
       i4 = (HEAP32[i6 + (i3 + -1 << 2) >> 2] | 0) + i4 | 0;
       HEAP32[i7 + (i3 << 2) >> 2] = i4;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != 256);
     }
     i4 = i1 + (i19 << 2) | 0;
     i6 = i18 + i8 | 0;
     if (i9) i1 = HEAP32[i13 >> 2] | 0; else {
      do {
       i14 = HEAP32[i1 >> 2] | 0;
       i1 = i1 + 4 | 0;
       i3 = i7 + ((HEAPU8[i6 + (i14 << 2) >> 0] | 0) << 2) | 0;
       i15 = HEAP32[i3 >> 2] | 0;
       HEAP32[i3 >> 2] = i15 + 1;
       i3 = HEAP32[i13 >> 2] | 0;
       HEAP32[i3 + (i15 << 2) >> 2] = i14;
      } while ((i1 | 0) != (i4 | 0));
      i1 = i3;
     }
     HEAP32[i5 >> 2] = i1;
     HEAP32[i13 >> 2] = i2;
     i2 = i1;
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != 4);
   return i17 | 0;
  } else {
   i12 = i13;
   i9 = i13;
  }
 } else {
  i9 = i17 + 16 | 0;
  i11 = i17 + 4 | 0;
  i12 = i9;
 }
 i10 = (i19 | 0) == 0;
 i8 = 0;
 i1 = i15;
 do {
  i6 = i16 + (i8 << 8 << 2) | 0;
  i3 = 0;
  while (1) {
   i4 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
   if ((i4 | 0) == (i19 | 0)) break;
   i3 = i3 + 1 | 0;
   if (!((i4 | 0) == 0 & i3 >>> 0 < 256)) {
    i20 = 28;
    break;
   }
  }
  if ((i20 | 0) == 28) {
   i20 = 0;
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i7 >> 2] = 0;
   i3 = 1;
   i4 = 0;
   do {
    i4 = (HEAP32[i6 + (i3 + -1 << 2) >> 2] | 0) + i4 | 0;
    HEAP32[i7 + (i3 << 2) >> 2] = i4;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != 256);
   i6 = i1 + (i19 << 2) | 0;
   i4 = i18 + i8 | 0;
   if (i10) i1 = HEAP32[i9 >> 2] | 0; else {
    i3 = i1;
    do {
     i14 = HEAP32[i3 >> 2] | 0;
     i3 = i3 + 4 | 0;
     i1 = i7 + ((HEAPU8[i4 + (i14 << 2) >> 0] | 0) << 2) | 0;
     i15 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = i15 + 1;
     i1 = HEAP32[i12 >> 2] | 0;
     HEAP32[i1 + (i15 << 2) >> 2] = i14;
    } while ((i3 | 0) != (i6 | 0));
   }
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
   i2 = i1;
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 4);
 return i17 | 0;
}

function _UNITY_png_handle_iCCP(i19, i20, i2) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1248 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 4 | 0;
 i15 = i21 + 1164 | 0;
 i11 = i21 + 1032 | 0;
 i13 = i21 + 8 | 0;
 i14 = i21;
 HEAP32[i16 >> 2] = i2;
 i1 = HEAP32[i19 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i19, gb + 352205 | 0);
 if (i1 & 6 | 0) {
  _UNITY_png_crc_finish(i19, i2) | 0;
  _UNITY_png_chunk_benign_error(i19, gb + 352423 | 0);
  STACKTOP = i21;
  return;
 }
 if (i2 >>> 0 < 9) {
  _UNITY_png_crc_finish(i19, i2) | 0;
  _UNITY_png_chunk_benign_error(i19, gb + 352548 | 0);
  STACKTOP = i21;
  return;
 }
 i12 = i19 + 680 | 0;
 i17 = i19 + 754 | 0;
 i1 = HEAPU16[i17 >> 1] | 0;
 if (i1 & 32768 | 0) {
  _UNITY_png_crc_finish(i19, i2) | 0;
  STACKTOP = i21;
  return;
 }
 L16 : do if (!(i1 & 4)) {
  i3 = i2 >>> 0 < 81 ? i2 : 81;
  _UNITY_png_read_data(i19, i15, i3);
  _UNITY_png_calculate_crc(i19, i15, i3);
  i2 = i2 - i3 | 0;
  HEAP32[i16 >> 2] = i2;
  do if (!i3) i1 = gb + 352289 | 0; else {
   i1 = 0;
   do {
    if (!(HEAP8[i15 + i1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < 80 & i1 >>> 0 < i3 >>> 0);
   if ((i1 + -1 | 0) >>> 0 < 79) {
    i10 = i1 + 1 | 0;
    if (i10 >>> 0 < i3 >>> 0) if (!(HEAP8[i15 + i10 >> 0] | 0)) {
     i1 = i1 + 2 | 0;
     if (_UNITY_png_inflate_claim(i19, 1766015824) | 0) {
      i1 = HEAP32[i19 + 244 >> 2] | 0;
      break;
     }
     HEAP32[i14 >> 2] = 132;
     HEAP32[i19 + 220 >> 2] = i15 + i1;
     HEAP32[i19 + 224 >> 2] = i3 - i1;
     _UNITY_png_inflate_read(i19, i13, i16, i11, i14, 0);
     L29 : do if (!(HEAP32[i14 >> 2] | 0)) {
      i8 = HEAPU8[i11 + 1 >> 0] << 16 | HEAPU8[i11 >> 0] << 24 | HEAPU8[i11 + 2 >> 0] << 8 | HEAPU8[i11 + 3 >> 0];
      if (!(_UNITY_png_icc_check_length(i19, i12, i15, i8) | 0)) {
       i2 = 0;
       i1 = 0;
       i18 = 37;
      } else if (!(_UNITY_png_icc_check_header(i19, i12, i15, i8, i11, HEAPU8[i19 + 431 >> 0] | 0) | 0)) {
       i2 = 0;
       i1 = 0;
       i18 = 37;
      } else {
       i3 = HEAP8[i11 + 128 >> 0] | 0;
       i4 = HEAP8[i11 + 129 >> 0] | 0;
       i5 = HEAP8[i11 + 130 >> 0] | 0;
       i6 = HEAP8[i11 + 131 >> 0] | 0;
       i9 = i19 + 644 | 0;
       i1 = HEAP32[i9 >> 2] | 0;
       if (!i1) i18 = 23; else {
        i2 = i19 + 648 | 0;
        if ((HEAP32[i2 >> 2] | 0) >>> 0 < i8 >>> 0) {
         HEAP32[i9 >> 2] = 0;
         HEAP32[i2 >> 2] = 0;
         _UNITY_png_free(i19, i1);
         i18 = 23;
        } else i7 = i1;
       }
       if ((i18 | 0) == 23) {
        i1 = _UNITY_png_malloc_base(i19, i8) | 0;
        if (!i1) {
         i2 = 0;
         i1 = gb + 661520 | 0;
         i18 = 37;
         break;
        }
        HEAP32[i9 >> 2] = i1;
        HEAP32[i19 + 648 >> 2] = i8;
        i7 = i1;
       }
       _memcpy(i7 | 0, i11 | 0, 132) | 0;
       i1 = ((i4 & 255) << 16 | (i3 & 255) << 24 | (i5 & 255) << 8 | i6 & 255) * 12 | 0;
       HEAP32[i14 >> 2] = i1;
       i2 = i7 + 132 | 0;
       _UNITY_png_inflate_read(i19, i13, i16, i2, i14, 0);
       if (HEAP32[i14 >> 2] | 0) {
        i2 = 0;
        i1 = HEAP32[i19 + 244 >> 2] | 0;
        i18 = 37;
        break;
       }
       if (!(_UNITY_png_icc_check_tag_table(i19, i12, i15, i8, i7) | 0)) {
        i2 = 0;
        i1 = 0;
        i18 = 37;
       } else {
        HEAP32[i14 >> 2] = i8 + -132 - i1;
        _UNITY_png_inflate_read(i19, i13, i16, i2 + i1 | 0, i14, 1);
        i1 = HEAP32[i16 >> 2] | 0;
        if (i1 | 0) if (!(HEAP32[i19 + 208 >> 2] & 1048576)) {
         i2 = 0;
         i1 = gb + 352236 | 0;
         i18 = 37;
         break;
        }
        if (HEAP32[i14 >> 2] | 0) {
         i2 = 0;
         i1 = gb + 352279 | 0;
         i18 = 37;
         break;
        }
        _UNITY_png_crc_finish(i19, i1) | 0;
        _UNITY_png_icc_set_sRGB(i19, i12, i7, HEAP32[i19 + 268 >> 2] | 0);
        do if (i20 | 0) {
         _UNITY_png_free_data(i19, i20, 16, 0);
         i1 = _UNITY_png_malloc_base(i19, i10) | 0;
         HEAP32[i20 + 116 >> 2] = i1;
         if (!i1) {
          HEAP16[i17 >> 1] = HEAPU16[i17 >> 1] | 32768;
          _UNITY_png_colorspace_sync(i19, i20);
          i2 = 1;
          i1 = gb + 661520 | 0;
          i18 = 37;
          break L29;
         } else {
          _memcpy(i1 | 0, i15 | 0, i10 | 0) | 0;
          HEAP32[i20 + 124 >> 2] = i8;
          HEAP32[i20 + 120 >> 2] = i7;
          HEAP32[i9 >> 2] = 0;
          i15 = i20 + 220 | 0;
          HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 16;
          i15 = i20 + 8 | 0;
          HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4096;
          _UNITY_png_colorspace_sync(i19, i20);
          break;
         }
        } while (0);
        HEAP32[i19 + 216 >> 2] = 0;
        i3 = 0;
        i2 = 1;
        i1 = 0;
       }
      }
     } else {
      i2 = 0;
      i1 = HEAP32[i19 + 244 >> 2] | 0;
      i18 = 37;
     } while (0);
     if ((i18 | 0) == 37) {
      HEAP32[i19 + 216 >> 2] = 0;
      i3 = 1;
     }
     if (!i3) {
      STACKTOP = i21;
      return;
     }
     if (i2 | 0) break L16;
     i2 = HEAP32[i16 >> 2] | 0;
     i18 = 43;
     break L16;
    } else i1 = gb + 352558 | 0; else i1 = gb + 352558 | 0;
   } else i1 = gb + 352289 | 0;
  } while (0);
  i18 = 43;
 } else {
  i1 = gb + 352581 | 0;
  i18 = 43;
 } while (0);
 if ((i18 | 0) == 43) _UNITY_png_crc_finish(i19, i2) | 0;
 HEAP16[i17 >> 1] = HEAPU16[i17 >> 1] | 32768;
 _UNITY_png_colorspace_sync(i19, i20);
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 _UNITY_png_chunk_benign_error(i19, i1);
 STACKTOP = i21;
 return;
}

function __ZN9Texture2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i20;
 i19 = i20 + 32 | 0;
 i6 = i20 + 28 | 0;
 i8 = i20 + 24 | 0;
 i7 = i20 + 20 | 0;
 i10 = i20 + 16 | 0;
 i9 = i20 + 12 | 0;
 i16 = i20 + 8 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i17, i18);
 i15 = i17 + 52 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i14 + 8 | 0);
  i2 = i1 + 28 | 0;
  i14 = i14 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  i2 = HEAP32[i15 >> 2] | 0;
  i14 = i2 + 4 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
  if (!(HEAP32[i14 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i15 >> 2] = i1;
 }
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 i13 = i19 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i11 = i5;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = 1;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i4 = 0; else {
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i6 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 + 48 >> 2];
 }
 i12 = i18 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i18 + 24 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i5, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i6, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i7, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i17 + 111 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i18);
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i2 = i17 + 80 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i2, 4);
 __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i17 + 32 | 0, i18);
 i1 = i17 + 56 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i17 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i16 >> 2] = i1;
 __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i18, i16, gb + 411165 | 0, 1);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i18, HEAP32[i16 >> 2] | 0, i1, 0);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i18, 2, gb + 411176 | 0, i17 + 120 | 0, i1, 0);
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i14);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __Z26TransformVerticesInnerLoopILb0ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i8, i21, i2, i4, i6, i3, i22, i23, i7, i24, i5, i1) {
 i8 = i8 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i7 = i7 | 0;
 i24 = i24 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i9 = (i5 | 0) / 4 | 0;
 i1 = i4 + -1 | 0;
 if (!i4) return;
 i10 = i21 + 16 | 0;
 i11 = i21 + 32 | 0;
 i12 = i21 + 48 | 0;
 i13 = i21 + 4 | 0;
 i14 = i21 + 20 | 0;
 i15 = i21 + 36 | 0;
 i16 = i21 + 52 | 0;
 i17 = i21 + 8 | 0;
 i18 = i21 + 24 | 0;
 i19 = i21 + 40 | 0;
 i20 = i21 + 56 | 0;
 if ((i5 | 0) > 3) {
  i2 = i7;
  i3 = i8;
 } else {
  i4 = i6;
  i3 = i7;
  i2 = i8;
  while (1) {
   f25 = Math_fround(HEAPF32[i21 >> 2]);
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i4 >> 2]));
   f26 = Math_fround(HEAPF32[i10 >> 2]);
   i9 = i4 + 4 | 0;
   f27 = Math_fround(HEAPF32[i9 >> 2]);
   f26 = Math_fround(f25 + Math_fround(f26 * f27));
   f25 = Math_fround(HEAPF32[i11 >> 2]);
   f28 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f25 = Math_fround(f26 + Math_fround(f25 * f28));
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f25);
   f25 = Math_fround(HEAPF32[i13 >> 2]);
   f26 = Math_fround(HEAPF32[i4 >> 2]);
   f25 = Math_fround(f25 * f26);
   f27 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2])));
   f27 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2])));
   HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f27);
   f26 = Math_fround(f26 * Math_fround(HEAPF32[i17 >> 2]));
   f27 = Math_fround(HEAPF32[i18 >> 2]);
   f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i9 >> 2])));
   f28 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2])));
   HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f28);
   i9 = i4 + i22 | 0;
   f28 = Math_fround(HEAPF32[i21 >> 2]);
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i9 >> 2]));
   f27 = Math_fround(HEAPF32[i10 >> 2]);
   i8 = i9 + 4 | 0;
   f26 = Math_fround(HEAPF32[i8 >> 2]);
   f27 = Math_fround(f28 + Math_fround(f27 * f26));
   f28 = Math_fround(HEAPF32[i11 >> 2]);
   f25 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   HEAPF32[i2 + 12 >> 2] = Math_fround(f27 + Math_fround(f28 * f25));
   f28 = Math_fround(HEAPF32[i13 >> 2]);
   f27 = Math_fround(HEAPF32[i9 >> 2]);
   f28 = Math_fround(f28 * f27);
   f26 = Math_fround(f28 + Math_fround(f26 * Math_fround(HEAPF32[i14 >> 2])));
   HEAPF32[i2 + 16 >> 2] = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i15 >> 2])));
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2]));
   f26 = Math_fround(HEAPF32[i18 >> 2]);
   f26 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i8 >> 2])));
   HEAPF32[i2 + 20 >> 2] = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i19 >> 2])));
   HEAP32[i2 + 24 >> 2] = HEAP32[i9 + 12 >> 2];
   if (!i1) break; else {
    i4 = i4 + i23 | 0;
    i3 = (i3 | 0) == 0 ? 0 : i3 + i24 | 0;
    i2 = i2 + 28 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  return;
 }
 while (1) {
  f25 = Math_fround(HEAPF32[i21 >> 2]);
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i6 >> 2]));
  f26 = Math_fround(HEAPF32[i10 >> 2]);
  i8 = i6 + 4 | 0;
  f27 = Math_fround(HEAPF32[i8 >> 2]);
  f26 = Math_fround(f25 + Math_fround(f26 * f27));
  f25 = Math_fround(HEAPF32[i11 >> 2]);
  f28 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f25 = Math_fround(f26 + Math_fround(f25 * f28));
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f25);
  f25 = Math_fround(HEAPF32[i13 >> 2]);
  f26 = Math_fround(HEAPF32[i6 >> 2]);
  f25 = Math_fround(f25 * f26);
  f27 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2])));
  f27 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2])));
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f27);
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i17 >> 2]));
  f27 = Math_fround(HEAPF32[i18 >> 2]);
  f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i8 >> 2])));
  f28 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2])));
  HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f28);
  i3 = i3 + 12 | 0;
  if (!i2) i2 = 0; else {
   i5 = 0;
   i4 = i2;
   while (1) {
    i8 = i3;
    i3 = i3 + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i9 | 0)) break; else i4 = i4 + 4 | 0;
   }
   i2 = i2 + i24 | 0;
  }
  i8 = i6 + i22 | 0;
  f25 = Math_fround(HEAPF32[i21 >> 2]);
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i8 >> 2]));
  f26 = Math_fround(HEAPF32[i10 >> 2]);
  i7 = i8 + 4 | 0;
  f27 = Math_fround(HEAPF32[i7 >> 2]);
  f26 = Math_fround(f25 + Math_fround(f26 * f27));
  f25 = Math_fround(HEAPF32[i11 >> 2]);
  f28 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(f26 + Math_fround(f25 * f28));
  f25 = Math_fround(HEAPF32[i13 >> 2]);
  f26 = Math_fround(HEAPF32[i8 >> 2]);
  f25 = Math_fround(f25 * f26);
  f27 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i3 + 4 >> 2] = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2])));
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i17 >> 2]));
  f27 = Math_fround(HEAPF32[i18 >> 2]);
  f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i7 >> 2])));
  HEAPF32[i3 + 8 >> 2] = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2])));
  HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  if (!i1) break; else {
   i6 = i6 + i23 | 0;
   i3 = i3 + 16 | 0;
   i1 = i1 + -1 | 0;
  }
 }
 return;
}

function __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z17BeginSplashScreenv() {
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i12 = i14;
 HEAP32[gb + 1157848 >> 2] = 1;
 d15 = +__Z19GetTimeSinceStartupv();
 HEAPF64[gb + 1098064 >> 3] = d15;
 HEAPF64[gb + 1098072 >> 3] = d15;
 i10 = __Z17GetPlayerSettingsv() | 0;
 switch (HEAP32[i10 + 156 >> 2] | 0) {
 case 1:
  {
   HEAPF32[gb + 1157852 >> 2] = Math_fround(.200000003);
   HEAPF32[gb + 1157856 >> 2] = Math_fround(.600000024);
   break;
  }
 case 2:
  {
   HEAP32[gb + 1157852 >> 2] = HEAP32[i10 + 164 >> 2];
   HEAP32[gb + 1157856 >> 2] = HEAP32[i10 + 168 >> 2];
   break;
  }
 default:
  {
   HEAPF32[gb + 1157852 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1157856 >> 2] = Math_fround(0.0);
  }
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1046259 | 0, 20);
 i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31832 | 0, i11) | 0;
 HEAP32[gb + 1157860 >> 2] = i2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i2 = HEAP32[gb + 1157860 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 f4 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f4 = Math_fround(f4 / Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF32[gb + 1157864 >> 2] = f4;
 HEAPF32[gb + 1157868 >> 2] = Math_fround(0.0);
 i8 = i10 + 216 | 0;
 i9 = i10 + 228 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i2 = 1;
  f4 = Math_fround(0.0);
 } else {
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = 0;
  i7 = i5;
  i3 = i1;
  f4 = Math_fround(0.0);
  do {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i12 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 17; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i2 = HEAP32[i11 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 17; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 19;
     }
    }
    if ((i13 | 0) == 17) i13 = 19;
    if ((i13 | 0) == 19) {
     i13 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
    }
    f4 = Math_fround(HEAPF32[gb + 1157868 >> 2]);
    i2 = HEAP32[gb + 1157860 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i9 >> 2] | 0;
   }
   i6 = i6 | (i1 | 0) == (i2 | 0);
   f4 = Math_fround(f4 + Math_fround(_fmaxf(Math_fround(HEAPF32[i7 + 4 >> 2]), Math_fround(2.0))));
   HEAPF32[gb + 1157868 >> 2] = f4;
   i7 = i7 + 8 | 0;
  } while ((i7 | 0) != (i5 + (i3 << 3) | 0));
  i2 = i6 & 1 ^ 1;
 }
 i9 = f4 < Math_fround(2.0);
 HEAP32[gb + 1157868 >> 2] = i9 ? 1073741824 : (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0)) i1 = 1; else if (!(HEAP8[i10 + 149 >> 0] | 0)) i1 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0) == 0; else i1 = 1;
 HEAP8[gb + 1545905 >> 0] = i1 ? i2 : 0;
 HEAP32[gb + 1157872 >> 2] = 0;
 if (__ZL17CreateLogoPresetsj(0) | 0 | i1 ^ 1) {
  STACKTOP = i14;
  return;
 }
 HEAP8[gb + 1545905 >> 0] = 0;
 d15 = +Math_fround(_fmaxf(Math_fround(0.0), Math_fround(2.0)));
 HEAPF64[gb + 1098080 >> 3] = d15;
 HEAP32[gb + 1157876 >> 2] = HEAP32[gb + 1157864 >> 2];
 i5 = __ZNK6Sprite24GetRenderDataForPlayModeEv(HEAP32[gb + 1157860 >> 2] | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i12 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 30; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 30; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 32;
   }
  }
  if ((i13 | 0) == 30) i13 = 32;
  if ((i13 | 0) == 32) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 HEAP32[gb + 1157880 >> 2] = i1;
 i10 = (HEAP32[(__Z17GetPlayerSettingsv() | 0) + 152 >> 2] | 0) == 0;
 i10 = i10 ? gb + 43052 | 0 : gb + 62560 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = HEAP32[i10 + 8 >> 2] | 0;
 i13 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[gb + 1157884 >> 2] = HEAP32[i10 >> 2];
 HEAP32[gb + 1157884 + 4 >> 2] = i11;
 HEAP32[gb + 1157884 + 8 >> 2] = i12;
 HEAP32[gb + 1157884 + 12 >> 2] = i13;
 __ZL9SetUvRectP6SpriteR5RectTIfE(HEAP32[gb + 1157860 >> 2] | 0, gb + 1157900 | 0);
 STACKTOP = i14;
 return;
}

function __ZNK9ShaderLab11ShaderState16ApplyShaderStateEjPK19ShaderPropertySheetRK17ShaderPassContextP6ShaderPNS_4PassEP11SubPrograms(i10, i8, i16, i9, i3, i2, i4) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 8 | 0;
 i13 = i18;
 i14 = i18 + 112 | 0;
 i15 = i18 + 88 | 0;
 i7 = i18 + 64 | 0;
 i5 = i18 + 40 | 0;
 i6 = i18 + 16 | 0;
 i17 = __Z12GetGfxDevicev() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __ZNK9ShaderLab11ShaderState20FindSubProgramsToUseEPK6ShaderPKNS_4PassER11SubProgramsRK17ShaderPassContext(i10, i3, 0, i6, i9);
 if (i4 | 0) {
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 }
 i11 = i9 + 36 | 0;
 if (!(HEAP8[i17 + 4194 >> 0] | 0)) mftCall_viiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 196 >> 2] | 0, i17 | 0, i6 | 0, i16 | 0, i11 | 0); else {
  i20 = gb + 64016 | 0;
  i2 = HEAP32[i20 + 4 >> 2] | 0;
  i4 = i13;
  HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  i4 = i5 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  i2 = i5 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
  i20 = i12;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i3 + 4 >> 2] = i19;
  __ZN14GraphicsHelper28PrepareShaderParameterBufferER13dynamic_arrayIhLj4EERA6_P10GpuProgramRA6_PK20GpuProgramParametersRA6_PKhRK11SubProgramsPK19ShaderPropertySheetSL_(i5, i14, i15, i7, i6, i16, i11);
  mftCall_viiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 908 >> 2] | 0, i17 | 0, i14 | 0, i15 | 0, i7 | 0);
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i2);
   HEAP32[i5 >> 2] = 0;
  }
 }
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? 0 : i6 + 4 | 0;
 if (HEAP8[i10 + 76 >> 0] | 0) {
  __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE(i10, i17, i16, i11, i7);
  i5 = i10 + 20 | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 60 >> 2] | 0, i17 | 0, HEAP32[i7 + 4 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 68 >> 2] | 0, i17 | 0, HEAP32[i7 + 8 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 64 >> 2] | 0, i17 | 0, HEAP32[i7 + 12 >> 2] | 0);
  if (!(HEAP8[i9 + 148 >> 0] | 0)) {
   i3 = HEAP32[(HEAP32[i17 >> 2] | 0) + 76 >> 2] | 0;
   i2 = HEAP32[i10 + 24 >> 2] | 0;
   if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 >> 2]); else {
    HEAP32[i13 >> 2] = -1;
    HEAP32[i13 + 4 >> 2] = 4;
    HEAP32[i14 >> 2] = i2;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i15, i16, i11, i12, i13);
    f1 = Math_fround(HEAPF32[HEAP32[i15 >> 2] >> 2]);
   }
   mftCall_vii(i3 | 0, i17 | 0, ~~f1 | 0);
  } else {
   i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + 72 >> 2] | 0;
   i3 = HEAP32[i7 + 16 >> 2] | 0;
   i2 = HEAP32[i10 + 24 >> 2] | 0;
   if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 >> 2]); else {
    HEAP32[i13 >> 2] = -1;
    HEAP32[i13 + 4 >> 2] = 4;
    HEAP32[i14 >> 2] = i2;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i15, i16, i11, i12, i13);
    f1 = Math_fround(HEAPF32[HEAP32[i15 >> 2] >> 2]);
   }
   mftCall_viii(i4 | 0, i17 | 0, i3 | 0, ~~f1 | 0);
  }
  STACKTOP = i18;
  return i6 | 0;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i20 = HEAP32[i10 + 12 >> 2] | 0;
 i4 = i3 + (i20 * 20 | 0) | 0;
 L27 : do if (!i20) i2 = i3; else {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break L27;
   i2 = i2 + 20 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i2 = i3;
    break;
   }
  }
 } while (0);
 i5 = i10 + 20 | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 60 >> 2] | 0, i17 | 0, HEAP32[i2 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 68 >> 2] | 0, i17 | 0, HEAP32[i2 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 64 >> 2] | 0, i17 | 0, HEAP32[i2 + 12 >> 2] | 0);
 if (!(HEAP8[i9 + 148 >> 0] | 0)) {
  i3 = HEAP32[(HEAP32[i17 >> 2] | 0) + 76 >> 2] | 0;
  i2 = HEAP32[i10 + 24 >> 2] | 0;
  if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 >> 2]); else {
   HEAP32[i13 >> 2] = -1;
   HEAP32[i13 + 4 >> 2] = 4;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i15, i16, i11, i12, i13);
   f1 = Math_fround(HEAPF32[HEAP32[i15 >> 2] >> 2]);
  }
  mftCall_vii(i3 | 0, i17 | 0, ~~f1 | 0);
  STACKTOP = i18;
  return i6 | 0;
 } else {
  i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + 72 >> 2] | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i2 = HEAP32[i10 + 24 >> 2] | 0;
  if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i5 >> 2]); else {
   HEAP32[i13 >> 2] = -1;
   HEAP32[i13 + 4 >> 2] = 4;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i15, i16, i11, i12, i13);
   f1 = Math_fround(HEAPF32[HEAP32[i15 >> 2] >> 2]);
  }
  mftCall_viii(i4 | 0, i17 | 0, i3 | 0, ~~f1 | 0);
  STACKTOP = i18;
  return i6 | 0;
 }
 return 0;
}

function __ZNK11OffMeshLink17HasEndpointsMovedEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 32 | 0;
 i8 = i12 + 24 | 0;
 i5 = i12 + 12 | 0;
 i10 = i12;
 i4 = i9 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 9;
 }
 if ((i11 | 0) == 7) i11 = 9;
 if ((i11 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i9 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 18;
 }
 if ((i11 | 0) == 16) i11 = 18;
 if ((i11 | 0) == 18) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 24; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 24; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 26;
  }
 }
 if ((i11 | 0) == 24) i11 = 26;
 if ((i11 | 0) == 26) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 __ZNK9Transform11GetPositionEv(i5, i1);
 i4 = i9 + 80 | 0;
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i9 + 68 >> 2]));
 f16 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i9 + 72 >> 2]));
 f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i9 + 76 >> 2]));
 if (!(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f15 * f15)) <= Math_fround(f14 * f14))) i1 = 1; else {
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 33; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 33; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 35;
   }
  }
  if ((i11 | 0) == 33) i11 = 35;
  if ((i11 | 0) == 35) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  __ZNK9Transform11GetPositionEv(i10, i1);
  f17 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(HEAPF32[i10 >> 2]);
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i9 + 56 >> 2]));
  f15 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i9 + 60 >> 2]));
  f16 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i9 + 64 >> 2]));
  i1 = !(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16)) <= Math_fround(f17 * f17));
 }
 i13 = i1;
 STACKTOP = i12;
 return i13 | 0;
}

function _UNITY_png_compress_IDAT(i32, i4, i5, i24) {
 i32 = i32 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i35;
 i34 = i32 + 216 | 0;
 do if ((HEAP32[i34 >> 2] | 0) == 1229209940) {
  i23 = i32 + 276 | 0;
  i25 = i32 + 280 | 0;
  i30 = i32 + 232 | 0;
  i31 = i32 + 236 | 0;
 } else {
  i3 = i32 + 276 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i29 = _UNITY_png_malloc(i32, (HEAP32[i32 + 280 >> 2] | 0) + 4 | 0) | 0;
   HEAP32[i3 >> 2] = i29;
   HEAP32[i29 >> 2] = 0;
  } else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i2 >> 2] = 0;
    do {
     i29 = i1;
     i1 = HEAP32[i1 >> 2] | 0;
     _UNITY_png_free(i32, i29);
    } while ((i1 | 0) != 0);
   }
  }
  if (!(_UNITY_png_deflate_claim(i32, 1229209940, _UNITY_png_image_size(i32) | 0) | 0)) {
   i30 = i32 + 232 | 0;
   HEAP32[i30 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
   i25 = i32 + 280 | 0;
   i31 = i32 + 236 | 0;
   HEAP32[i31 >> 2] = HEAP32[i25 >> 2];
   i23 = i3;
   break;
  } else _UNITY_png_error(i32, HEAP32[i32 + 244 >> 2] | 0);
 } while (0);
 i21 = i32 + 220 | 0;
 HEAP32[i21 >> 2] = i4;
 i8 = i32 + 224 | 0;
 HEAP32[i8 >> 2] = 0;
 i26 = i32 + 204 | 0;
 i22 = i32 + 620 | 0;
 i27 = i32 + 656 | 0;
 i9 = i33 + 1 | 0;
 i10 = i33 + 2 | 0;
 i11 = i33 + 3 | 0;
 i12 = i33 + 4 | 0;
 i13 = i33 + 5 | 0;
 i14 = i33 + 6 | 0;
 i15 = i33 + 7 | 0;
 i28 = i32 + 372 | 0;
 i29 = i32 + 408 | 0;
 i16 = i33 + 1 | 0;
 i17 = i33 + 2 | 0;
 i18 = i33 + 3 | 0;
 i20 = (i24 | 0) == 0;
 while (1) {
  HEAP32[i8 >> 2] = i5;
  i19 = _unity_z_deflate(i21, i24) | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i1 = HEAP32[i31 >> 2] | 0;
  if (!i1) {
   i4 = HEAP32[i23 >> 2] | 0;
   i6 = i4 + 4 | 0;
   i2 = HEAP32[i25 >> 2] | 0;
   if (!(HEAP32[i26 >> 2] & 4)) if (!(HEAP8[i22 >> 0] | 0)) {
    i7 = _UNITY_png_image_size(i32) | 0;
    if (i7 >>> 0 < 16385) {
     i1 = HEAPU8[i6 >> 0] | 0;
     if ((i1 & 15 | 0) == 8 & (i1 & 240) >>> 0 < 113) {
      i1 = i1 >>> 4;
      i3 = 1 << i1 + 7;
      if (i3 >>> 0 >= i7 >>> 0) {
       do {
        i3 = i3 >>> 1;
        i1 = i1 + -1 | 0;
       } while (!((i1 | 0) == 0 | i3 >>> 0 < i7 >>> 0));
       i3 = i1 << 4 | 8;
       HEAP8[i6 >> 0] = i3;
       i7 = i4 + 5 | 0;
       i4 = HEAPU8[i7 >> 0] & 224;
       HEAP8[i7 >> 0] = (((i4 | i3 << 8) >>> 0) % 31 | 0 | i4) ^ 31;
      }
     }
    }
   }
   if ((i2 | 0) < 0) {
    i1 = 21;
    break;
   }
   HEAP32[i27 >> 2] = 34;
   HEAP8[i33 >> 0] = i2 >>> 24;
   HEAP8[i9 >> 0] = i2 >>> 16;
   HEAP8[i10 >> 0] = i2 >>> 8;
   HEAP8[i11 >> 0] = i2;
   HEAP8[i12 >> 0] = 73;
   HEAP8[i13 >> 0] = 68;
   HEAP8[i14 >> 0] = 65;
   HEAP8[i15 >> 0] = 84;
   _UNITY_png_write_data(i32, i33, 8);
   HEAP32[i28 >> 2] = 1229209940;
   _UNITY_png_reset_crc(i32);
   _UNITY_png_calculate_crc(i32, i12, 4);
   HEAP32[i27 >> 2] = 66;
   if (i2 | 0) {
    _UNITY_png_write_data(i32, i6, i2);
    _UNITY_png_calculate_crc(i32, i6, i2);
   }
   HEAP32[i27 >> 2] = 130;
   i7 = HEAP32[i29 >> 2] | 0;
   HEAP8[i33 >> 0] = i7 >>> 24;
   HEAP8[i16 >> 0] = i7 >>> 16;
   HEAP8[i17 >> 0] = i7 >>> 8;
   HEAP8[i18 >> 0] = i7;
   _UNITY_png_write_data(i32, i33, 4);
   HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | 4;
   HEAP32[i30 >> 2] = i6;
   HEAP32[i31 >> 2] = i2;
   if (!(i20 | (i19 | 0) != 0)) continue;
  } else i2 = i1;
  if (i19 | 0) {
   i1 = 29;
   break;
  }
  if (!i5) {
   i1 = 27;
   break;
  }
 }
 if ((i1 | 0) == 21) _UNITY_png_error(i32, gb + 356027 | 0); else if ((i1 | 0) == 27) if ((i24 | 0) == 4) _UNITY_png_error(i32, gb + 356053 | 0); else {
  STACKTOP = i35;
  return;
 } else if ((i1 | 0) == 29) {
  if (!((i24 | 0) == 4 & (i19 | 0) == 1)) {
   _UNITY_png_zstream_error(i32, i19);
   _UNITY_png_error(i32, HEAP32[i32 + 244 >> 2] | 0);
  }
  i5 = HEAP32[i23 >> 2] | 0;
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i25 >> 2] | 0) - i2 | 0;
  if (!(HEAP32[i26 >> 2] & 4)) if (!(HEAP8[i22 >> 0] | 0)) {
   i3 = _UNITY_png_image_size(i32) | 0;
   if (i3 >>> 0 < 16385) {
    i1 = HEAPU8[i6 >> 0] | 0;
    if ((i1 & 15 | 0) == 8 & (i1 & 240) >>> 0 < 113) {
     i1 = i1 >>> 4;
     i2 = 1 << i1 + 7;
     if (i2 >>> 0 >= i3 >>> 0) {
      do {
       i2 = i2 >>> 1;
       i1 = i1 + -1 | 0;
      } while (!((i1 | 0) == 0 | i2 >>> 0 < i3 >>> 0));
      i23 = i1 << 4 | 8;
      HEAP8[i6 >> 0] = i23;
      i25 = i5 + 5 | 0;
      i24 = HEAPU8[i25 >> 0] & 224;
      HEAP8[i25 >> 0] = (((i24 | i23 << 8) >>> 0) % 31 | 0 | i24) ^ 31;
     }
    }
   }
  }
  if ((i4 | 0) < 0) _UNITY_png_error(i32, gb + 356027 | 0);
  HEAP32[i27 >> 2] = 34;
  HEAP8[i33 >> 0] = i4 >>> 24;
  HEAP8[i33 + 1 >> 0] = i4 >>> 16;
  HEAP8[i33 + 2 >> 0] = i4 >>> 8;
  HEAP8[i33 + 3 >> 0] = i4;
  i25 = i33 + 4 | 0;
  HEAP8[i25 >> 0] = 73;
  HEAP8[i33 + 5 >> 0] = 68;
  HEAP8[i33 + 6 >> 0] = 65;
  HEAP8[i33 + 7 >> 0] = 84;
  _UNITY_png_write_data(i32, i33, 8);
  HEAP32[i28 >> 2] = 1229209940;
  _UNITY_png_reset_crc(i32);
  _UNITY_png_calculate_crc(i32, i25, 4);
  HEAP32[i27 >> 2] = 66;
  if (i4 | 0) {
   _UNITY_png_write_data(i32, i6, i4);
   _UNITY_png_calculate_crc(i32, i6, i4);
  }
  HEAP32[i27 >> 2] = 130;
  i29 = HEAP32[i29 >> 2] | 0;
  HEAP8[i33 >> 0] = i29 >>> 24;
  HEAP8[i33 + 1 >> 0] = i29 >>> 16;
  HEAP8[i33 + 2 >> 0] = i29 >>> 8;
  HEAP8[i33 + 3 >> 0] = i29;
  _UNITY_png_write_data(i32, i33, 4);
  HEAP32[i31 >> 2] = 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i26 >> 2] = HEAP32[i26 >> 2] | 12;
  HEAP32[i34 >> 2] = 0;
  STACKTOP = i35;
  return;
 }
}

function _UNITY_png_read_row(i18, i14, i15) {
 i18 = i18 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 if (!i18) {
  STACKTOP = i19;
  return;
 }
 if (!(HEAP32[i18 + 208 >> 2] & 64)) _UNITY_png_read_start_row(i18);
 i1 = HEAP32[i18 + 364 >> 2] | 0;
 HEAP32[i16 >> 2] = i1;
 i9 = i16 + 8 | 0;
 HEAP8[i9 >> 0] = HEAP8[i18 + 431 >> 0] | 0;
 i2 = HEAP32[i18 + 432 >> 2] | 0;
 HEAP8[i16 + 9 >> 0] = i2;
 HEAP8[i16 + 10 >> 0] = i2 >>> 24;
 i2 = i2 >>> 16;
 i13 = i2 & 255;
 i11 = i16 + 11 | 0;
 HEAP8[i11 >> 0] = i13;
 i2 = i2 & 255;
 if ((i13 & 255) > 7) i5 = Math_imul(i1, i2 >>> 3) | 0; else i5 = ((Math_imul(i1, i2) | 0) + 7 | 0) >>> 3;
 i4 = i16 + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 i13 = i18 + 368 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i10 = i18 + 428 | 0;
 i12 = HEAP16[i10 >> 1] | 0;
 i2 = (i12 & 65535) >>> 8 & 255;
 L11 : do if ((i12 & 255) << 24 >> 24) if (HEAP32[i18 + 212 >> 2] & 2 | 0) switch (i2 << 24 >> 24) {
 case 0:
  {
   if (!(i1 & 7)) break L11;
   if (i15 | 0) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 case 1:
  {
   if (!(i1 & 7)) if ((HEAP32[i18 + 344 >> 2] | 0) >>> 0 >= 5) break L11;
   if (i15 | 0) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 case 2:
  {
   if ((i1 & 7 | 0) == 4) break L11;
   if (!((i15 | 0) == 0 | (i1 & 4 | 0) == 0)) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 case 3:
  {
   if (!(i1 & 3)) if ((HEAP32[i18 + 344 >> 2] | 0) >>> 0 >= 3) break L11;
   if (i15 | 0) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 case 4:
  {
   if ((i1 & 3 | 0) == 2) break L11;
   if (!((i15 | 0) == 0 | (i1 & 2 | 0) == 0)) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 case 5:
  {
   if (!(i1 & 1)) if ((HEAP32[i18 + 344 >> 2] | 0) >>> 0 >= 2) break L11;
   if (i15 | 0) _UNITY_png_combine_row(i18, i15, 1);
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 default:
  {
   if (i1 & 1 | 0) break L11;
   _UNITY_png_read_finish_row(i18);
   STACKTOP = i19;
   return;
  }
 } while (0);
 if (!(HEAP32[i18 + 204 >> 2] & 4)) _UNITY_png_error(i18, gb + 353398 | 0);
 i12 = i18 + 380 | 0;
 _UNITY_png_read_IDAT_data(i18, HEAP32[i12 >> 2] | 0, i5 + 1 | 0);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i3 = i2 & 255;
 do if (!(i2 << 24 >> 24)) {
  i6 = i18 + 376 | 0;
  i7 = i5;
  i8 = i1;
 } else if ((i2 & 255) < 5) {
  i6 = i18 + 376 | 0;
  _UNITY_png_read_filter_row(i18, i16, i1 + 1 | 0, (HEAP32[i6 >> 2] | 0) + 1 | 0, i3);
  i7 = HEAP32[i4 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  break;
 } else _UNITY_png_error(i18, gb + 353431 | 0); while (0);
 _memcpy(HEAP32[i6 >> 2] | 0, i8 | 0, i7 + 1 | 0) | 0;
 L71 : do if (HEAP32[i18 + 596 >> 2] & 4 | 0) if ((HEAP8[i18 + 600 >> 0] | 0) == 64) {
  i1 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP16[i9 >> 1] | 0;
  i3 = i2 & 255;
  if (i3 & 2) switch (((i2 & 65535) >>> 8 & 255) << 24 >> 24) {
  case 8:
   {
    switch (i3 << 24 >> 24) {
    case 2:
     {
      i3 = 3;
      break;
     }
    case 6:
     {
      i3 = 4;
      break;
     }
    default:
     break L71;
    }
    if (!i4) break L71; else i2 = 0;
    while (1) {
     i8 = HEAPU8[i1 + 1 >> 0] | 0;
     HEAP8[i1 >> 0] = i8 + (HEAPU8[i1 >> 0] | 0);
     i9 = i1 + 2 | 0;
     HEAP8[i9 >> 0] = (HEAPU8[i9 >> 0] | 0) + i8;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + i3 | 0;
    }
    break;
   }
  case 16:
   {
    switch (i3 << 24 >> 24) {
    case 2:
     {
      i3 = 6;
      break;
     }
    case 6:
     {
      i3 = 8;
      break;
     }
    default:
     break L71;
    }
    if (!i4) break L71; else i2 = 0;
    while (1) {
     i6 = i1 + 1 | 0;
     i8 = HEAPU8[i1 + 2 >> 0] << 8 | HEAPU8[i1 + 3 >> 0];
     i7 = i1 + 4 | 0;
     i9 = i1 + 5 | 0;
     i5 = i8 + (HEAPU8[i1 >> 0] << 8 | HEAPU8[i6 >> 0]) | 0;
     i8 = (HEAPU8[i7 >> 0] << 8 | HEAPU8[i9 >> 0]) + i8 | 0;
     HEAP8[i1 >> 0] = i5 >>> 8;
     HEAP8[i6 >> 0] = i5;
     HEAP8[i7 >> 0] = i8 >>> 8;
     HEAP8[i9 >> 0] = i8;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + i3 | 0;
    }
    break;
   }
  default:
   break L71;
  }
 } while (0);
 i4 = i18 + 212 | 0;
 if (HEAP32[i4 >> 2] | 0) _UNITY_png_do_read_transformations(i18, i16);
 i2 = i18 + 439 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 if (!(i3 << 24 >> 24)) {
  HEAP8[i2 >> 0] = i1;
  if ((i1 & 255) > (HEAPU8[i18 + 438 >> 0] | 0)) _UNITY_png_error(i18, gb + 353457 | 0);
 } else if (i3 << 24 >> 24 != i1 << 24 >> 24) _UNITY_png_error(i18, gb + 353481 | 0);
 i11 = HEAP16[i10 >> 1] | 0;
 i2 = (i11 & 65535) >>> 8;
 i3 = i2 & 255;
 if (!((i11 & 255) << 24 >> 24)) i17 = 73; else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!(i1 & 2)) i17 = 73; else {
   if ((i3 & 255) < 6) _UNITY_png_do_read_interlace(i16, (HEAP32[i12 >> 2] | 0) + 1 | 0, i2 & 65535, i1);
   if (i15 | 0) _UNITY_png_combine_row(i18, i15, 1);
   if (i14 | 0) _UNITY_png_combine_row(i18, i14, 0);
  }
 }
 if ((i17 | 0) == 73) {
  if (i14 | 0) _UNITY_png_combine_row(i18, i14, -1);
  if (i15 | 0) _UNITY_png_combine_row(i18, i15, -1);
 }
 _UNITY_png_read_finish_row(i18);
 i1 = HEAP32[i18 + 540 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 mftCall_viii(i1 | 0, i18 | 0, HEAP32[i13 >> 2] | 0, HEAPU8[i18 + 429 >> 0] | 0);
 STACKTOP = i19;
 return;
}

function runPostSets51() {
 HEAP32[gb + 62972 >> 2] = (HEAP32[gb + 62972 >> 2] | 0) + (gb + 442698 | 0);
 HEAP32[gb + 62976 >> 2] = (HEAP32[gb + 62976 >> 2] | 0) + (gb + 442714 | 0);
 HEAP32[gb + 62980 >> 2] = (HEAP32[gb + 62980 >> 2] | 0) + (gb + 462565 | 0);
 HEAP32[gb + 62984 >> 2] = (HEAP32[gb + 62984 >> 2] | 0) + (gb + 442727 | 0);
 HEAP32[gb + 62988 >> 2] = (HEAP32[gb + 62988 >> 2] | 0) + (gb + 442737 | 0);
 HEAP32[gb + 62992 >> 2] = (HEAP32[gb + 62992 >> 2] | 0) + (gb + 442750 | 0);
 HEAP32[gb + 62996 >> 2] = (HEAP32[gb + 62996 >> 2] | 0) + (gb + 462574 | 0);
 HEAP32[gb + 63e3 >> 2] = (HEAP32[gb + 63e3 >> 2] | 0) + (gb + 590408 | 0);
 HEAP32[gb + 63004 >> 2] = (HEAP32[gb + 63004 >> 2] | 0) + (gb + 442761 | 0);
 HEAP32[gb + 63008 >> 2] = (HEAP32[gb + 63008 >> 2] | 0) + (gb + 442777 | 0);
 HEAP32[gb + 63012 >> 2] = (HEAP32[gb + 63012 >> 2] | 0) + (gb + 464732 | 0);
 HEAP32[gb + 63016 >> 2] = (HEAP32[gb + 63016 >> 2] | 0) + (gb + 442784 | 0);
 HEAP32[gb + 63020 >> 2] = (HEAP32[gb + 63020 >> 2] | 0) + (gb + 442789 | 0);
 HEAP32[gb + 63024 >> 2] = (HEAP32[gb + 63024 >> 2] | 0) + (gb + 442799 | 0);
 HEAP32[gb + 63028 >> 2] = (HEAP32[gb + 63028 >> 2] | 0) + (gb + 442813 | 0);
 HEAP32[gb + 63032 >> 2] = (HEAP32[gb + 63032 >> 2] | 0) + (gb + 442828 | 0);
 HEAP32[gb + 63036 >> 2] = (HEAP32[gb + 63036 >> 2] | 0) + (gb + 442839 | 0);
 HEAP32[gb + 63040 >> 2] = (HEAP32[gb + 63040 >> 2] | 0) + (gb + 442844 | 0);
 HEAP32[gb + 63044 >> 2] = (HEAP32[gb + 63044 >> 2] | 0) + (gb + 442858 | 0);
 HEAP32[gb + 63048 >> 2] = (HEAP32[gb + 63048 >> 2] | 0) + (gb + 442869 | 0);
 HEAP32[gb + 63052 >> 2] = (HEAP32[gb + 63052 >> 2] | 0) + (gb + 442886 | 0);
 HEAP32[gb + 63056 >> 2] = (HEAP32[gb + 63056 >> 2] | 0) + (gb + 442899 | 0);
 HEAP32[gb + 63060 >> 2] = (HEAP32[gb + 63060 >> 2] | 0) + (gb + 442913 | 0);
 HEAP32[gb + 63064 >> 2] = (HEAP32[gb + 63064 >> 2] | 0) + (gb + 442925 | 0);
 HEAP32[gb + 63068 >> 2] = (HEAP32[gb + 63068 >> 2] | 0) + (gb + 442937 | 0);
 HEAP32[gb + 63072 >> 2] = (HEAP32[gb + 63072 >> 2] | 0) + (gb + 442946 | 0);
 HEAP32[gb + 63076 >> 2] = (HEAP32[gb + 63076 >> 2] | 0) + (gb + 442951 | 0);
 HEAP32[gb + 63080 >> 2] = (HEAP32[gb + 63080 >> 2] | 0) + (gb + 442959 | 0);
 HEAP32[gb + 63084 >> 2] = (HEAP32[gb + 63084 >> 2] | 0) + (gb + 442971 | 0);
 HEAP32[gb + 63088 >> 2] = (HEAP32[gb + 63088 >> 2] | 0) + (gb + 442984 | 0);
 HEAP32[gb + 63092 >> 2] = (HEAP32[gb + 63092 >> 2] | 0) + (gb + 443e3 | 0);
 HEAP32[gb + 63096 >> 2] = (HEAP32[gb + 63096 >> 2] | 0) + (gb + 443007 | 0);
 HEAP32[gb + 63100 >> 2] = (HEAP32[gb + 63100 >> 2] | 0) + (gb + 443022 | 0);
 HEAP32[gb + 63104 >> 2] = (HEAP32[gb + 63104 >> 2] | 0) + (gb + 443040 | 0);
 HEAP32[gb + 63108 >> 2] = (HEAP32[gb + 63108 >> 2] | 0) + (gb + 443055 | 0);
 HEAP32[gb + 63112 >> 2] = (HEAP32[gb + 63112 >> 2] | 0) + (gb + 443064 | 0);
 HEAP32[gb + 63116 >> 2] = (HEAP32[gb + 63116 >> 2] | 0) + (gb + 443081 | 0);
 HEAP32[gb + 63120 >> 2] = (HEAP32[gb + 63120 >> 2] | 0) + (gb + 443089 | 0);
 HEAP32[gb + 63124 >> 2] = (HEAP32[gb + 63124 >> 2] | 0) + (gb + 443103 | 0);
 HEAP32[gb + 63128 >> 2] = (HEAP32[gb + 63128 >> 2] | 0) + (gb + 443116 | 0);
 HEAP32[gb + 63132 >> 2] = (HEAP32[gb + 63132 >> 2] | 0) + (gb + 443125 | 0);
 HEAP32[gb + 63136 >> 2] = (HEAP32[gb + 63136 >> 2] | 0) + (gb + 443138 | 0);
 HEAP32[gb + 63140 >> 2] = (HEAP32[gb + 63140 >> 2] | 0) + (gb + 443153 | 0);
 HEAP32[gb + 63144 >> 2] = (HEAP32[gb + 63144 >> 2] | 0) + (gb + 443172 | 0);
 HEAP32[gb + 63148 >> 2] = (HEAP32[gb + 63148 >> 2] | 0) + (gb + 443195 | 0);
 HEAP32[gb + 63152 >> 2] = (HEAP32[gb + 63152 >> 2] | 0) + (gb + 443214 | 0);
 HEAP32[gb + 63156 >> 2] = (HEAP32[gb + 63156 >> 2] | 0) + (gb + 443233 | 0);
 HEAP32[gb + 64176 >> 2] = fb + 659;
 HEAP32[gb + 64180 >> 2] = fb + 660;
 HEAP32[gb + 64184 >> 2] = fb + 1;
 HEAP32[gb + 64188 >> 2] = fb + 1;
 HEAP32[gb + 64192 >> 2] = fb + 288;
 HEAP32[gb + 64196 >> 2] = fb + 522;
 HEAP32[gb + 64200 >> 2] = fb + 88;
 HEAP32[gb + 64204 >> 2] = fb + 69;
 HEAP32[gb + 64208 >> 2] = fb + 60;
 HEAP32[gb + 64220 >> 2] = fb + 661;
 HEAP32[gb + 64224 >> 2] = fb + 662;
 HEAP32[gb + 64228 >> 2] = fb + 80;
 HEAP32[gb + 64232 >> 2] = fb + 523;
 HEAP32[gb + 64236 >> 2] = fb + 16;
 HEAP32[gb + 64240 >> 2] = fb + 39;
 HEAP32[gb + 64244 >> 2] = fb + 40;
 HEAP32[gb + 64248 >> 2] = fb + 19;
 HEAP32[gb + 64252 >> 2] = fb + 289;
 HEAP32[gb + 64256 >> 2] = fb + 99;
 HEAP32[gb + 64260 >> 2] = fb + 40;
 HEAP32[gb + 64264 >> 2] = fb + 62;
 HEAP32[gb + 64268 >> 2] = fb + 28;
 HEAP32[gb + 64272 >> 2] = fb + 63;
 HEAP32[gb + 64276 >> 2] = fb + 29;
 HEAP32[gb + 64280 >> 2] = fb + 34;
 HEAP32[gb + 64284 >> 2] = fb + 524;
 HEAP32[gb + 64288 >> 2] = fb + 525;
 HEAP32[gb + 64292 >> 2] = fb + 526;
 HEAP32[gb + 64296 >> 2] = fb + 527;
 HEAP32[gb + 64300 >> 2] = fb + 528;
 HEAP32[gb + 64304 >> 2] = fb + 529;
 HEAP32[gb + 64308 >> 2] = fb + 36;
 HEAP32[gb + 64312 >> 2] = fb + 96;
 HEAP32[gb + 64316 >> 2] = fb + 81;
 HEAP32[gb + 64320 >> 2] = fb + 82;
 HEAP32[gb + 64324 >> 2] = (HEAP32[gb + 64324 >> 2] | 0) + (gb + 1049797 | 0);
 HEAP32[gb + 64336 >> 2] = (HEAP32[gb + 64336 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 64340 >> 2] = (HEAP32[gb + 64340 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 64376 >> 2] = fb + 663;
 HEAP32[gb + 64380 >> 2] = fb + 664;
 HEAP32[gb + 64384 >> 2] = fb + 80;
 HEAP32[gb + 64388 >> 2] = fb + 530;
 HEAP32[gb + 64392 >> 2] = fb + 16;
 HEAP32[gb + 64396 >> 2] = fb + 665;
 HEAP32[gb + 64400 >> 2] = fb + 666;
 HEAP32[gb + 64404 >> 2] = fb + 667;
 HEAP32[gb + 64408 >> 2] = fb + 290;
 HEAP32[gb + 64412 >> 2] = fb + 99;
 HEAP32[gb + 64416 >> 2] = fb + 40;
 HEAP32[gb + 64420 >> 2] = fb + 62;
 HEAP32[gb + 64424 >> 2] = fb + 28;
 HEAP32[gb + 64428 >> 2] = fb + 63;
 HEAP32[gb + 64432 >> 2] = fb + 29;
 runPostSets52();
}

function __ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i6, i4, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 if (i6) if (HEAP8[i2 + 28 >> 0] & 4) {
  f9 = Math_fround(__Z18computeSweptBoundsRKN5physx18PxcAABBDataDynamicERNS_9PxBounds3E(i4, i7));
  STACKTOP = i8;
  return Math_fround(f9);
 }
 f19 = Math_fround(-Math_fround(HEAPF32[i2 + 48 >> 2]));
 f33 = Math_fround(-Math_fround(HEAPF32[i2 + 52 >> 2]));
 f28 = Math_fround(-Math_fround(HEAPF32[i2 + 56 >> 2]));
 f24 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i6 = i2 + 32 | 0;
 f25 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f27 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f29 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f35 = Math_fround(Math_fround(Math_fround(f25 * f19) + Math_fround(f9 * f33)) + Math_fround(f32 * f28));
 f22 = Math_fround(Math_fround(Math_fround(f25 * f35) + Math_fround(Math_fround(f29 * f19) - Math_fround(f27 * Math_fround(Math_fround(f9 * f28) - Math_fround(f32 * f33))))) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f35) + Math_fround(Math_fround(f29 * f33) - Math_fround(f27 * Math_fround(Math_fround(f32 * f19) - Math_fround(f25 * f28))))) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(Math_fround(f32 * f35) + Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * Math_fround(Math_fround(f25 * f33) - Math_fround(f9 * f19))))) * Math_fround(2.0));
 f25 = Math_fround(-f25);
 f9 = Math_fround(-f9);
 f32 = Math_fround(-f32);
 f33 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f29 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f35 = Math_fround(HEAPF32[i1 >> 2]);
 f36 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(f18 * f19) + Math_fround(Math_fround(f16 * f22) + Math_fround(f20 * f17)));
 f31 = Math_fround(Math_fround(f21 * f27) - Math_fround(Math_fround(Math_fround(f16 * f25) + Math_fround(f20 * f9)) + Math_fround(f18 * f32)));
 f26 = Math_fround(Math_fround(Math_fround(f20 * f32) - Math_fround(f18 * f9)) + Math_fround(Math_fround(f21 * f25) + Math_fround(f16 * f27)));
 f30 = Math_fround(Math_fround(Math_fround(f18 * f25) - Math_fround(f16 * f32)) + Math_fround(Math_fround(f21 * f9) + Math_fround(f20 * f27)));
 f27 = Math_fround(Math_fround(Math_fround(f16 * f9) - Math_fround(f20 * f25)) + Math_fround(Math_fround(f21 * f32) + Math_fround(f18 * f27)));
 f32 = Math_fround(Math_fround(f31 * f31) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(f27 * f29) + Math_fround(Math_fround(f33 * f26) + Math_fround(f28 * f30)));
 f14 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(f31 * Math_fround(Math_fround(f33 * f27) - Math_fround(f26 * f29)))) + Math_fround(f30 * f25)) * Math_fround(2.0)) + Math_fround(f14 + Math_fround(Math_fround(Math_fround(Math_fround(f23 * f17) + Math_fround(f21 * Math_fround(Math_fround(f18 * f22) - Math_fround(f16 * f19)))) + Math_fround(f20 * f15)) * Math_fround(2.0))));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f29 * f32) + Math_fround(f31 * Math_fround(Math_fround(f28 * f26) - Math_fround(f33 * f30)))) + Math_fround(f27 * f25)) * Math_fround(2.0)) + Math_fround(f13 + Math_fround(Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f21 * Math_fround(Math_fround(f16 * f17) - Math_fround(f20 * f22)))) + Math_fround(f18 * f15)) * Math_fround(2.0))));
 f9 = Math_fround(Math_fround(f31 * f10) - Math_fround(Math_fround(Math_fround(f26 * f35) + Math_fround(f30 * f36)) + Math_fround(f27 * f34)));
 f12 = Math_fround(Math_fround(Math_fround(f30 * f34) - Math_fround(f27 * f36)) + Math_fround(Math_fround(f31 * f35) + Math_fround(f26 * f10)));
 f11 = Math_fround(Math_fround(Math_fround(f27 * f35) - Math_fround(f26 * f34)) + Math_fround(Math_fround(f31 * f36) + Math_fround(f30 * f10)));
 f10 = Math_fround(Math_fround(Math_fround(f26 * f36) - Math_fround(f30 * f35)) + Math_fround(Math_fround(f31 * f34) + Math_fround(f27 * f10)));
 HEAPF32[i5 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f31 * Math_fround(Math_fround(f30 * f29) - Math_fround(f28 * f27)))) + Math_fround(f26 * f25)) * Math_fround(2.0)) + Math_fround(f24 + Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)))) + Math_fround(f16 * f15)) * Math_fround(2.0))));
 HEAPF32[i5 + 20 >> 2] = f14;
 HEAPF32[i5 + 24 >> 2] = f13;
 HEAPF32[i5 >> 2] = f12;
 HEAPF32[i5 + 4 >> 2] = f11;
 HEAPF32[i5 + 8 >> 2] = f10;
 HEAPF32[i5 + 12 >> 2] = f9;
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1 + 36 | 0, i7, i5, Math_fround(HEAPF32[i1 + 28 >> 2]), i3);
 f9 = Math_fround(0.0);
 STACKTOP = i8;
 return Math_fround(f9);
}

function _emit_sof(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 24 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = -1;
 i7 = i1 + 4 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i4;
 if (!i4) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = i2;
 i4 = i1 + 4 | 0;
 i7 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i4 = i5 + 60 | 0;
 i2 = ((HEAP32[i4 >> 2] | 0) * 3 | 0) + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i8 + 1;
 HEAP8[i8 >> 0] = i2 >>> 8;
 i8 = i1 + 4 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i2;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i2 = i5 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 65535) i3 = 15; else if ((HEAP32[i5 + 28 >> 2] | 0) > 65535) i3 = 15;
 if ((i3 | 0) == 15) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 41;
  HEAP32[i8 + 24 >> 2] = 65535;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i5 + 56 >> 2] & 255;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i8;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i2 >>> 8;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i2;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i2 >>> 8;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i2;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] & 255;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = i8;
 i7 = i1 + 4 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i2 = 0;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 while (1) {
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i3 >> 2] & 255;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = i8;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i5 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
  }
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = (HEAP32[i3 + 8 >> 2] << 4) + (HEAP32[i3 + 12 >> 2] | 0) & 255;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = i8;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i5 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
  }
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i3 + 16 >> 2] & 255;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  HEAP8[i7 >> 0] = i8;
  i7 = i1 + 4 | 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
   i8 = HEAP32[i5 >> 2] | 0;
   HEAP32[i8 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i8 >> 2] | 0, i5 | 0);
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (HEAP32[i4 >> 2] | 0)) break; else i3 = i3 + 84 | 0;
 }
 return;
}

function __ZN16MemoryFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i9, i10, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 16 | 0;
 i6 = i11;
 if ((HEAP16[gb + 1179068 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179068 | 0, i7);
  i8 = gb + 1179068 | 0;
 } else i8 = 0;
 switch (i5 | 0) {
 case 0:
  {
   HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i9, i10, i6);
   i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i9 + 4 | 0, i6) | 0;
   if ((i1 | 0) == (i9 + 8 | 0)) i2 = 0; else i2 = HEAP32[i1 + 32 >> 2] | 0;
   if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i6 + 12 >> 2] | 0;
    HEAP32[i7 >> 2] = 54;
    HEAP32[i7 + 4 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
   }
   do if (!i2) i1 = 0; else {
    i1 = i2 + 12 | 0;
    if (HEAP32[i2 >> 2] | 0) if ((HEAP32[i1 >> 2] | 0) == 2) {
     i1 = 0;
     break;
    }
    HEAP32[i1 >> 2] = 1;
    i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63552 | 0, 16, gb + 492052 | 0, 140) | 0;
    i12 = gb + 63552 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i2 = HEAP32[i2 >> 2] | 0;
    HEAP32[i1 >> 2] = gb + 71428 + 8;
    i3 = i1 + 4 | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = 0;
    i4 = i1 + 12 | 0;
    i5 = i4;
    HEAP32[i5 >> 2] = i13;
    HEAP32[i5 + 4 >> 2] = i12;
    i5 = i1 + 24 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    if (!i2) {
     i13 = __ZnwjRK10MemLabelIdiPKci(48, i4, 16, gb + 492276 | 0, 15) | 0;
     i5 = HEAP32[i4 + 4 >> 2] | 0;
     i12 = i6;
     HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i12 + 4 >> 2] = i5;
     HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i13, i7, 8192);
     HEAP32[i3 >> 2] = i13;
    } else {
     i13 = i2 + 4 | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    }
   } while (0);
   i2 = 32;
   break;
  }
 case 2:
 case 3:
 case 1:
  {
   i4 = __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i9, i10, 0) | 0;
   L23 : do if (!i4) i1 = 0; else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else {
     i2 = i4 + 12 | 0;
     if ((HEAP32[i2 >> 2] | 0) == 2) i1 = 0; else {
      i3 = i4 + 20 | 0;
      if (HEAP8[i3 >> 0] | 0) {
       HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
       i13 = i1 + 4 | 0;
       HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
       if (!(HEAP32[i13 >> 2] | 0)) {
        mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
        __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
       }
       HEAP8[i3 >> 0] = 0;
      }
      HEAP32[i2 >> 2] = 2;
      i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63552 | 0, 16, gb + 492052 | 0, 162) | 0;
      i12 = gb + 63552 | 0;
      i14 = HEAP32[i12 >> 2] | 0;
      i12 = HEAP32[i12 + 4 >> 2] | 0;
      i2 = HEAP32[i4 >> 2] | 0;
      HEAP32[i1 >> 2] = gb + 71428 + 8;
      i3 = i1 + 4 | 0;
      HEAP32[i3 >> 2] = i2;
      HEAP32[i1 + 8 >> 2] = i5;
      i4 = i1 + 12 | 0;
      i13 = i4;
      HEAP32[i13 >> 2] = i14;
      HEAP32[i13 + 4 >> 2] = i12;
      i13 = i1 + 24 | 0;
      HEAP32[i13 >> 2] = 0;
      HEAP32[i13 + 4 >> 2] = 0;
      if (!i2) {
       i14 = __ZnwjRK10MemLabelIdiPKci(48, i4, 16, gb + 492276 | 0, 15) | 0;
       i12 = HEAP32[i4 + 4 >> 2] | 0;
       i13 = i6;
       HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i13 + 4 >> 2] = i12;
       HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
       __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i14, i7, 8192);
       HEAP32[i3 >> 2] = i14;
      } else {
       i14 = i2 + 4 | 0;
       HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
      }
      switch (i5 | 0) {
      case 1:
       {
        if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, 0, 0) | 0) break L23;
        mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
        break L23;
       }
      case 3:
       {
        if (mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, 0, 0, 3) | 0) break L23;
        mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
        break L23;
       }
      default:
       break L23;
      }
     }
    }
   } while (0);
   i2 = 32;
   break;
  }
 default:
  i1 = 0;
 }
 do if ((i2 | 0) == 32) if (!i1) i1 = 0; else if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
  HEAP32[i10 + 1040 >> 2] = i9;
  HEAP32[i10 + 1044 >> 2] = i9;
  HEAP32[i10 + 1052 >> 2] = i1;
  i1 = 1;
  break;
 } else {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i10 + 1056 >> 2] = 14;
  i1 = 0;
  break;
 } while (0);
 if (!i8) {
  STACKTOP = i11;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZL16RegisterVRDevice23UnityVRDeviceDefinition(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 60 | 0;
 i17 = i21 + 48 | 0;
 i14 = i21 + 32 | 0;
 i15 = i21 + 16 | 0;
 i18 = i21;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 i2 = _strlen(i20) | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i3 = 4;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i18 + 11 >> 0] = i2;
  if (!i2) i1 = i18; else {
   i1 = i18;
   i3 = 6;
  }
 } else i3 = 4;
 if ((i3 | 0) == 4) {
  i16 = i2 + 16 & -16;
  HEAP32[i19 >> 2] = 66;
  HEAP32[i19 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 8 >> 2] = i16 | -2147483648;
  HEAP32[i18 + 4 >> 2] = i2;
  i3 = 6;
 }
 if ((i3 | 0) == 6) _memcpy(i1 | 0, i20 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 i2 = __Z16GetBuildSettingsv() | 0;
 i1 = i2 + 64 | 0;
 HEAP32[i17 >> 2] = 0;
 i16 = i17 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i2 = i2 + 68 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 i4 = i3 >> 4;
 if (!i4) i1 = 0; else {
  if (i4 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i17);
  i13 = __Znwj(i3) | 0;
  HEAP32[i16 >> 2] = i13;
  HEAP32[i17 >> 2] = i13;
  HEAP32[i17 + 8 >> 2] = i13 + (i4 << 4);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i17, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i4);
  i2 = HEAP32[i17 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i16 >> 2] | 0)) i1 = 0; else {
   i6 = i14 + 11 | 0;
   i7 = i14 + 4 | 0;
   i8 = i15 + 11 | 0;
   i9 = i15 + 4 | 0;
   i10 = i15 + 12 | 0;
   i11 = i19 + 4 | 0;
   i12 = i14 + 12 | 0;
   i13 = i19 + 4 | 0;
   while (1) {
    __Z7ToLowerI8UnityStrET_RKS1_(i14, i2);
    __Z7ToLowerI8UnityStrET_RKS1_(i15, i18);
    i1 = HEAP8[i6 >> 0] | 0;
    i3 = i1 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i7 >> 2] | 0 : i1 & 255;
    i22 = HEAP8[i8 >> 0] | 0;
    i5 = i22 << 24 >> 24 < 0;
    if ((i4 | 0) == ((i5 ? HEAP32[i9 >> 2] | 0 : i22 & 255) | 0)) i3 = (_strncmp(i3 ? HEAP32[i14 >> 2] | 0 : i14, i5 ? HEAP32[i15 >> 2] | 0 : i15, i4) | 0) == 0; else i3 = 0;
    if (i5) {
     i1 = HEAP32[i15 >> 2] | 0;
     i22 = HEAP32[i10 >> 2] | 0;
     HEAP32[i19 >> 2] = 66;
     HEAP32[i11 >> 2] = i22;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
     i1 = HEAP8[i6 >> 0] | 0;
    }
    if (i1 << 24 >> 24 < 0) {
     i22 = HEAP32[i14 >> 2] | 0;
     i5 = HEAP32[i12 >> 2] | 0;
     HEAP32[i19 >> 2] = 66;
     HEAP32[i13 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i22, i19);
    }
    i2 = i2 + 16 | 0;
    if (i3) {
     i1 = 1;
     break;
    }
    if ((i2 | 0) == (HEAP32[i16 >> 2] | 0)) {
     i1 = 0;
     break;
    }
   }
   i2 = HEAP32[i17 >> 2] | 0;
  }
  if (i2) {
   i3 = HEAP32[i16 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i5 = i19 + 4 | 0;
    do {
     i4 = i3 + -16 | 0;
     HEAP32[i16 >> 2] = i4;
     if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
      i22 = HEAP32[i4 >> 2] | 0;
      i3 = HEAP32[i3 + -4 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i5 >> 2] = i3;
      __Z19free_alloc_internalPvRK10MemLabelId(i22, i19);
      i3 = HEAP32[i16 >> 2] | 0;
     } else i3 = i4;
    } while ((i3 | 0) != (i2 | 0));
    i2 = HEAP32[i17 >> 2] | 0;
   }
   __ZdlPv(i2);
  }
 }
 if ((HEAP8[i18 + 11 >> 0] | 0) < 0) {
  i22 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i19 >> 2] = 66;
  HEAP32[i19 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i22, i19);
 }
 if (!i1) {
  STACKTOP = i21;
  return;
 };
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, i20, _strlen(i20) | 0);
 i22 = __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i19) | 0;
 i22 = (i22 | 0) == 0 ? 1 : (i22 | 0) == (HEAP32[gb + 1469348 + 4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 if (i22) i1 = HEAP32[gb + 1469348 + 4 >> 2] | 0; else {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i19, i20, _strlen(i20) | 0);
  i4 = __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i19) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  i2 = i4 + 668 | 0;
  i1 = HEAP32[gb + 1469348 + 4 >> 2] | 0;
  i3 = i1 - i2 | 0;
  if (i3) {
   _memmove(i4 | 0, i2 | 0, i3 | 0) | 0;
   i1 = HEAP32[gb + 1469348 + 4 >> 2] | 0;
  }
  i2 = i4 + (((i3 | 0) / 668 | 0) * 668 | 0) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i1 = i1 + (~(((0 - i2 + (i1 + -668) | 0) >>> 0) / 668 | 0) * 668 | 0) | 0;
   HEAP32[gb + 1469348 + 4 >> 2] = i1;
  }
 }
 if ((i1 | 0) == (HEAP32[gb + 1469348 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI23UnityVRDeviceDefinition13stl_allocatorIS1_L18MemLabelIdentifier87ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(gb + 1469348 | 0, i20);
  STACKTOP = i21;
  return;
 } else {
  _memcpy(i1 | 0, i20 | 0, 668) | 0;
  HEAP32[gb + 1469348 + 4 >> 2] = i1 + 668;
  STACKTOP = i21;
  return;
 }
}

function runPostSets226() {
 HEAP32[gb + 191168 >> 2] = fb + 210;
 HEAP32[gb + 191172 >> 2] = fb + 70;
 HEAP32[gb + 191176 >> 2] = fb + 71;
 HEAP32[gb + 191180 >> 2] = fb + 110;
 HEAP32[gb + 191184 >> 2] = fb + 105;
 HEAP32[gb + 191188 >> 2] = fb + 3013;
 HEAP32[gb + 191200 >> 2] = (HEAP32[gb + 191200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 191204 >> 2] = (HEAP32[gb + 191204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 191240 >> 2] = fb + 3014;
 HEAP32[gb + 191244 >> 2] = fb + 3015;
 HEAP32[gb + 191248 >> 2] = fb + 38;
 HEAP32[gb + 191252 >> 2] = fb + 100;
 HEAP32[gb + 191256 >> 2] = fb + 16;
 HEAP32[gb + 191260 >> 2] = fb + 93;
 HEAP32[gb + 191264 >> 2] = fb + 3016;
 HEAP32[gb + 191268 >> 2] = fb + 19;
 HEAP32[gb + 191272 >> 2] = fb + 1403;
 HEAP32[gb + 191276 >> 2] = fb + 103;
 HEAP32[gb + 191280 >> 2] = fb + 101;
 HEAP32[gb + 191284 >> 2] = fb + 62;
 HEAP32[gb + 191288 >> 2] = fb + 28;
 HEAP32[gb + 191292 >> 2] = fb + 63;
 HEAP32[gb + 191296 >> 2] = fb + 29;
 HEAP32[gb + 191300 >> 2] = fb + 34;
 HEAP32[gb + 191304 >> 2] = fb + 2289;
 HEAP32[gb + 191308 >> 2] = fb + 2290;
 HEAP32[gb + 191312 >> 2] = fb + 2291;
 HEAP32[gb + 191316 >> 2] = fb + 2292;
 HEAP32[gb + 191320 >> 2] = fb + 2293;
 HEAP32[gb + 191324 >> 2] = fb + 2294;
 HEAP32[gb + 191328 >> 2] = fb + 36;
 HEAP32[gb + 191332 >> 2] = fb + 104;
 HEAP32[gb + 191336 >> 2] = fb + 108;
 HEAP32[gb + 191340 >> 2] = fb + 94;
 HEAP32[gb + 191344 >> 2] = fb + 109;
 HEAP32[gb + 191348 >> 2] = fb + 105;
 HEAP32[gb + 191352 >> 2] = fb + 106;
 HEAP32[gb + 191356 >> 2] = fb + 110;
 HEAP32[gb + 191368 >> 2] = (HEAP32[gb + 191368 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 191372 >> 2] = (HEAP32[gb + 191372 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 191628 >> 2] = (HEAP32[gb + 191628 >> 2] | 0) + (gb + 191632 | 0);
 HEAP32[gb + 191644 >> 2] = fb + 1404;
 HEAP32[gb + 191668 >> 2] = fb + 295;
 HEAP32[gb + 191672 >> 2] = fb + 296;
 HEAP32[gb + 191676 >> 2] = (HEAP32[gb + 191676 >> 2] | 0) + (gb + 1573591 | 0);
 HEAP32[gb + 191744 >> 2] = (HEAP32[gb + 191744 >> 2] | 0) + (gb + 191632 | 0);
 HEAP32[gb + 191748 >> 2] = (HEAP32[gb + 191748 >> 2] | 0) + (gb + 191752 | 0);
 HEAP32[gb + 191764 >> 2] = fb + 1404;
 HEAP32[gb + 191784 >> 2] = fb + 297;
 HEAP32[gb + 191792 >> 2] = fb + 296;
 HEAP32[gb + 191796 >> 2] = (HEAP32[gb + 191796 >> 2] | 0) + (gb + 1573599 | 0);
 HEAP32[gb + 191864 >> 2] = (HEAP32[gb + 191864 >> 2] | 0) + (gb + 191752 | 0);
 HEAP32[gb + 191868 >> 2] = (HEAP32[gb + 191868 >> 2] | 0) + (gb + 191872 | 0);
 HEAP32[gb + 191884 >> 2] = fb + 1404;
 HEAP32[gb + 191908 >> 2] = fb + 298;
 HEAP32[gb + 191912 >> 2] = fb + 296;
 HEAP32[gb + 191916 >> 2] = (HEAP32[gb + 191916 >> 2] | 0) + (gb + 1574631 | 0);
 HEAP32[gb + 191984 >> 2] = (HEAP32[gb + 191984 >> 2] | 0) + (gb + 191872 | 0);
 HEAP32[gb + 198680 >> 2] = fb + 299;
 HEAP32[gb + 203460 >> 2] = (HEAP32[gb + 203460 >> 2] | 0) + (gb + 228086 | 0);
 HEAP32[gb + 203464 >> 2] = (HEAP32[gb + 203464 >> 2] | 0) + (gb + 203468 | 0);
 HEAP32[gb + 205004 >> 2] = (HEAP32[gb + 205004 >> 2] | 0) + (gb + 205008 | 0);
 HEAP32[gb + 206672 >> 2] = (HEAP32[gb + 206672 >> 2] | 0) + (gb + 1087625 | 0);
 HEAP32[gb + 206676 >> 2] = (HEAP32[gb + 206676 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206680 >> 2] = (HEAP32[gb + 206680 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206684 >> 2] = (HEAP32[gb + 206684 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206688 >> 2] = (HEAP32[gb + 206688 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206692 >> 2] = (HEAP32[gb + 206692 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206696 >> 2] = (HEAP32[gb + 206696 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206700 >> 2] = (HEAP32[gb + 206700 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206704 >> 2] = (HEAP32[gb + 206704 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 206708 >> 2] = (HEAP32[gb + 206708 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 207772 >> 2] = (HEAP32[gb + 207772 >> 2] | 0) + (gb + 207780 | 0);
 HEAP32[gb + 207912 >> 2] = (HEAP32[gb + 207912 >> 2] | 0) + (gb + 1074318 | 0);
 HEAP32[gb + 207920 >> 2] = (HEAP32[gb + 207920 >> 2] | 0) + (gb + 1074320 | 0);
 HEAP32[gb + 207928 >> 2] = (HEAP32[gb + 207928 >> 2] | 0) + (gb + 1074322 | 0);
 HEAP32[gb + 207936 >> 2] = (HEAP32[gb + 207936 >> 2] | 0) + (gb + 1074324 | 0);
 HEAP32[gb + 207944 >> 2] = (HEAP32[gb + 207944 >> 2] | 0) + (gb + 1074326 | 0);
 HEAP32[gb + 207952 >> 2] = (HEAP32[gb + 207952 >> 2] | 0) + (gb + 1074328 | 0);
 HEAP32[gb + 207960 >> 2] = (HEAP32[gb + 207960 >> 2] | 0) + (gb + 1074330 | 0);
 HEAP32[gb + 207968 >> 2] = (HEAP32[gb + 207968 >> 2] | 0) + (gb + 1074343 | 0);
 HEAP32[gb + 207976 >> 2] = (HEAP32[gb + 207976 >> 2] | 0) + (gb + 1074357 | 0);
 HEAP32[gb + 207984 >> 2] = (HEAP32[gb + 207984 >> 2] | 0) + (gb + 1074369 | 0);
 HEAP32[gb + 207992 >> 2] = (HEAP32[gb + 207992 >> 2] | 0) + (gb + 1074382 | 0);
 HEAP32[gb + 208e3 >> 2] = (HEAP32[gb + 208e3 >> 2] | 0) + (gb + 1074394 | 0);
 HEAP32[gb + 208088 >> 2] = (HEAP32[gb + 208088 >> 2] | 0) + (gb + 10640 | 0);
 HEAP32[gb + 208092 >> 2] = fb + 3017;
 HEAP32[gb + 208096 >> 2] = fb + 3018;
 HEAP32[gb + 208100 >> 2] = fb + 1405;
 HEAP32[gb + 10640 >> 2] = (HEAP32[gb + 10640 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10644 >> 2] = (HEAP32[gb + 10644 >> 2] | 0) + (gb + 1076127 | 0);
 HEAP32[gb + 10648 >> 2] = (HEAP32[gb + 10648 >> 2] | 0) + (gb + 13256 | 0);
 HEAP32[gb + 208108 >> 2] = (HEAP32[gb + 208108 >> 2] | 0) + (gb + 10656 | 0);
 HEAP32[gb + 208112 >> 2] = fb + 3019;
 HEAP32[gb + 208116 >> 2] = fb + 3020;
 HEAP32[gb + 208120 >> 2] = fb + 1;
 HEAP32[gb + 208124 >> 2] = fb + 1;
 HEAP32[gb + 208128 >> 2] = fb + 1;
 HEAP32[gb + 208132 >> 2] = fb + 1;
 HEAP32[gb + 10656 >> 2] = (HEAP32[gb + 10656 >> 2] | 0) + (gb + 216100 | 0);
 runPostSets227();
}

function _rgb_rgb_convert_25(i1, i12, i7, i8, i3) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 switch (HEAP32[i1 + 44 >> 2] | 0) {
 case 6:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     HEAP8[i2 + 3 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 + 2 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i6 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 + 2 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 3 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 + 3 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 + 1 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 3 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i9 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    while (1) {
     HEAP8[i2 >> 0] = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = HEAP8[i5 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 4 | 0;
     i7 = i7 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN10MonoScript27InitializeAndRegisterScriptEP11Il2CppClass(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 88 | 0;
 i8 = i14 + 72 | 0;
 i9 = i14 + 56 | 0;
 i10 = i14 + 40 | 0;
 i11 = i14 + 24 | 0;
 i12 = i14 + 12 | 0;
 i13 = i14;
 i2 = __Z24scripting_class_get_nameP11Il2CppClass(i4) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i8 + 11 >> 0] = i3;
  if (!i3) i1 = i8; else {
   i1 = i8;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i15 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i3;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i2 = __Z29scripting_class_get_namespaceP11Il2CppClass(i4) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i5 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i9 + 11 >> 0] = i3;
  if (!i3) i1 = i9; else {
   i1 = i9;
   i5 = 12;
  }
 } else i5 = 10;
 if ((i5 | 0) == 10) {
  i15 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i3;
  i5 = 12;
 }
 if ((i5 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i2 = __Z32scripting_class_get_assemblynameP11Il2CppClass(i4) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i5 = 16;
 } else if (i4 >>> 0 < 11) {
  i3 = i10 + 11 | 0;
  HEAP8[i3 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i5 = 18;
  }
 } else i5 = 16;
 if ((i5 | 0) == 16) {
  i3 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i3 = i10 + 11 | 0;
  i5 = 18;
 }
 if ((i5 | 0) == 18) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i8 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i5 = i2 << 24 >> 24 < 0;
 i15 = i5 ? HEAP32[i8 >> 2] | 0 : i8;
 i2 = i5 ? HEAP32[i8 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i15, i2);
 i2 = i9 + 11 | 0;
 i15 = HEAP8[i2 >> 0] | 0;
 i5 = i15 << 24 >> 24 < 0;
 i4 = i5 ? HEAP32[i9 >> 2] | 0 : i9;
 i15 = i5 ? HEAP32[i9 + 4 >> 2] | 0 : i15 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, i15);
 i15 = HEAP8[i3 >> 0] | 0;
 i4 = i15 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i10 >> 2] | 0 : i10;
 i15 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i15 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i5, i15);
 __ZN10MonoScript27InitializeAndRegisterScriptERK8UnityStrRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_SB_b(i6, i11, i7, i12, i13, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if ((HEAP8[i11 + 11 >> 0] | 0) < 0) {
  i15 = HEAP32[i11 >> 2] | 0;
  i13 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i7);
 }
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i15 = HEAP32[i10 >> 2] | 0;
  i13 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i7);
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i15 = HEAP32[i9 >> 2] | 0;
  i13 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i7);
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i14;
  return;
 }
 i15 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, i7);
 STACKTOP = i14;
 return;
}

function __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb(i12, i1, i6, i9, i7, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i5 = i12 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i11 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i11) return;
 if ((i6 | 0) != 2147483647) __ZN7ApiGLES23BindShaderStorageBufferEjj(i12 + 4620 | 0, i6, HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0);
 if (i7) __ZN14DataBufferGLES12RecordRenderEv(HEAP32[i11 >> 2] | 0);
 i1 = i11 + 16 | 0;
 i10 = i1;
 i6 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i12 + 7360 | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 if (i5 >>> 0 < i6 >>> 0 | ((i5 | 0) == (i6 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0)) {
  i7 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 + 5480 >> 2] | 0, 12) | 0;
  i10 = i12 + 7376 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i7;
 }
 if (HEAP32[i11 + 12 >> 2] & 256 | 0) {
  i10 = i1;
  i6 = HEAP32[i10 + 4 >> 2] | 0;
  i7 = i12 + 7304 | 0;
  i5 = HEAP32[i7 + 4 >> 2] | 0;
  if (i5 >>> 0 < i6 >>> 0 | ((i5 | 0) == (i6 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0)) {
   i7 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 + 5480 >> 2] | 0, 5) | 0;
   i10 = i12 + 7376 | 0;
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i7;
  }
 }
 if (i8) {
  i7 = i12 + 7368 | 0;
  i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, 1, 0) | 0;
  i8 = getTempRet0() | 0;
  i10 = i1;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i10 + 4 >> 2] = i8;
  __ZN14DataBufferGLES12RecordUpdateEv(HEAP32[i11 >> 2] | 0);
 }
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i10 | 0) <= -1) return;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 if ((i5 | 0) <= -1) return;
 HEAP32[i11 + 28 >> 2] = i10;
 HEAP32[i11 + 32 >> 2] = i5;
 i8 = i12 + 7424 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, 1024, 10, 1) | 0;
  HEAP32[i8 >> 2] = i1;
 }
 i6 = i5 >>> 2;
 i7 = i12 + 7428 + (i6 << 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == 0 | (i2 | 0) == (i11 | 0)) i3 = i12 + 7352 | 0; else {
  i9 = i2 + 40 | 0;
  i13 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i12 + 7352 | 0;
  i4 = i3;
  i14 = HEAP32[i4 + 4 >> 2] | 0;
  if (i14 >>> 0 < i13 >>> 0 | ((i14 | 0) == (i13 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0 : 0)) {
   i2 = HEAP32[i12 + 4860 >> 2] | 0;
   i1 = i12 + 5480 | 0;
   mftCall_vi(i2 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i1 >> 2] | 0, 11) | 0);
   i2 = i12 + 7368 | 0;
   i14 = i2;
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i4 = _i64Add(i13 | 0, i14 | 0, 1, 0) | 0;
   i9 = getTempRet0() | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i9;
   i2 = i3;
   HEAP32[i2 >> 2] = i13;
   HEAP32[i2 + 4 >> 2] = i14;
   i1 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i1 >> 2] | 0, 11) | 0);
   i2 = i12 + 7376 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & i1;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  __ZN14DataBufferGLES11CopySubDataEPKS_iii(HEAP32[i2 + 24 >> 2] | 0, i1, i5, 0, 4);
  HEAP32[i7 >> 2] = 0;
  i2 = 0;
 }
 i4 = i11 + 40 | 0;
 i1 = i4;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i14 = i3;
 i9 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i9 >>> 0 < i13 >>> 0 | ((i9 | 0) == (i13 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0 : 0);
 do if ((i2 | 0) == (i11 | 0)) {
  if (i1) {
   i13 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 + 5480 >> 2] | 0, 11) | 0;
   i14 = i12 + 7376 | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | i13;
  }
 } else {
  if (i1) {
   i14 = HEAP32[i12 + 4860 >> 2] | 0;
   i13 = i12 + 5480 | 0;
   mftCall_vi(i14 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i13 >> 2] | 0, 11) | 0);
   i14 = i12 + 7368 | 0;
   i9 = i14;
   i2 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i15 = _i64Add(i2 | 0, i9 | 0, 1, 0) | 0;
   i1 = getTempRet0() | 0;
   HEAP32[i14 >> 2] = i15;
   HEAP32[i14 + 4 >> 2] = i1;
   i14 = i3;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i14 + 4 >> 2] = i9;
   i13 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i13 >> 2] | 0, 11) | 0);
   i14 = i12 + 7376 | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & i13;
  }
  i1 = HEAP32[i11 + 36 >> 2] | 0;
  if ((i1 | 0) > -1) if ((HEAP32[i12 + 7428 + (i1 << 2) >> 2] | 0) == (i11 | 0)) {
   i15 = HEAP32[i8 >> 2] | 0;
   __ZN14DataBufferGLES11CopySubDataEPKS_iii(i15, i15, i1 << 2, i5, 4);
   break;
  }
  __ZN14DataBufferGLES11CopySubDataEPKS_iii(HEAP32[i8 >> 2] | 0, HEAP32[i11 + 24 >> 2] | 0, 0, i5, 4);
 } while (0);
 i15 = i12 + 7368 | 0;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i11 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!((i1 | 0) < 0 | (i6 | 0) == (i1 | 0))) {
  i1 = i12 + 7428 + (i1 << 2) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i7 >> 2] = i11;
 HEAP32[i2 >> 2] = i6;
 __ZN7ApiGLES23BindAtomicCounterBufferEjj(i12 + 4620 | 0, i10, HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0);
 return;
}

function __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i18, i19, i15, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = i19 + 16 | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 i14 = i12 + 12 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 i16 = i18 + 16 | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 i12 = i12 + 8 | 0;
 i7 = HEAP32[i8 + (i9 << 5) + 8 >> 2] | 0;
 i10 = HEAP32[HEAP32[(HEAP32[i12 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
 i6 = HEAP32[i8 + (i11 << 5) + 8 >> 2] | 0;
 i2 = HEAP32[i10 + (i7 * 360 | 0) + 184 >> 2] | 0;
 i1 = HEAP32[i10 + (i6 * 360 | 0) + 184 >> 2] | 0;
 do if ((i2 | 0) == (i1 | 0)) {
  i1 = HEAP16[i8 + (i9 << 5) + 12 >> 1] | 0;
  i5 = HEAP16[i8 + (i11 << 5) + 12 >> 1] | 0;
  if (i1 << 16 >> 16 != i5 << 16 >> 16) if (i1 << 16 >> 16 < i5 << 16 >> 16) {
   i17 = 14;
   break;
  } else break;
  f3 = Math_fround(HEAPF32[i8 + (i9 << 5) + 20 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  f4 = Math_fround(HEAPF32[i8 + (i11 << 5) + 20 >> 2]);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i5 | 0)) if (i1 >>> 0 < i5 >>> 0) {
   i17 = 14;
   break;
  } else break;
  i1 = HEAP32[i8 + (i9 << 5) + 28 >> 2] | 0;
  i5 = HEAP32[i8 + (i11 << 5) + 28 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) if (i1 >>> 0 > i5 >>> 0) {
   i17 = 14;
   break;
  } else break;
  if (f3 != f4) if (f3 > f4) {
   i17 = 14;
   break;
  } else break;
  i5 = HEAP16[i10 + (i7 * 360 | 0) + 270 >> 1] | 0;
  i1 = HEAP16[i10 + (i6 * 360 | 0) + 270 >> 1] | 0;
  if (i5 << 16 >> 16 == i1 << 16 >> 16) if ((i9 | 0) < (i11 | 0)) {
   i17 = 14;
   break;
  } else break; else if ((i5 & 65535) > (i1 & 65535)) {
   i17 = 14;
   break;
  } else break;
 } else if (i2 >>> 0 < i1 >>> 0) i17 = 14; while (0);
 if ((i17 | 0) == 14) {
  _memcpy(i20 | 0, i19 | 0, 212) | 0;
  _memcpy(i19 | 0, i18 | 0, 212) | 0;
  _memcpy(i18 | 0, i20 | 0, 212) | 0;
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[HEAP32[(HEAP32[i12 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
  i7 = HEAP32[i8 + (i9 << 5) + 8 >> 2] | 0;
  i10 = i2;
  i2 = HEAP32[i2 + (i7 * 360 | 0) + 184 >> 2] | 0;
 }
 i11 = HEAP32[i15 + 16 >> 2] | 0;
 i6 = HEAP32[i8 + (i11 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i10 + (i6 * 360 | 0) + 184 >> 2] | 0;
 do if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP16[i8 + (i11 << 5) + 12 >> 1] | 0;
  i5 = HEAP16[i8 + (i9 << 5) + 12 >> 1] | 0;
  if (i1 << 16 >> 16 != i5 << 16 >> 16) if (i1 << 16 >> 16 < i5 << 16 >> 16) {
   i17 = 28;
   break;
  } else break;
  f3 = Math_fround(HEAPF32[i8 + (i11 << 5) + 20 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  f4 = Math_fround(HEAPF32[i8 + (i9 << 5) + 20 >> 2]);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i5 | 0)) if (i1 >>> 0 < i5 >>> 0) {
   i17 = 28;
   break;
  } else break;
  i1 = HEAP32[i8 + (i11 << 5) + 28 >> 2] | 0;
  i5 = HEAP32[i8 + (i9 << 5) + 28 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) if (i1 >>> 0 > i5 >>> 0) {
   i17 = 28;
   break;
  } else break;
  if (f3 != f4) if (f3 > f4) {
   i17 = 28;
   break;
  } else break;
  i1 = HEAP16[i10 + (i6 * 360 | 0) + 270 >> 1] | 0;
  i5 = HEAP16[i10 + (i7 * 360 | 0) + 270 >> 1] | 0;
  if (i1 << 16 >> 16 == i5 << 16 >> 16) if ((i11 | 0) < (i9 | 0)) {
   i17 = 28;
   break;
  } else break; else if ((i1 & 65535) > (i5 & 65535)) {
   i17 = 28;
   break;
  } else break;
 } else if (i1 >>> 0 < i2 >>> 0) i17 = 28; while (0);
 if ((i17 | 0) == 28) {
  _memcpy(i20 | 0, i15 | 0, 212) | 0;
  _memcpy(i15 | 0, i19 | 0, 212) | 0;
  _memcpy(i19 | 0, i20 | 0, 212) | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  i8 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i8 + (i9 << 5) + 8 >> 2] | 0;
  i2 = HEAP32[HEAP32[(HEAP32[i12 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
  i10 = i2;
  i2 = HEAP32[i2 + (i7 * 360 | 0) + 184 >> 2] | 0;
 }
 i6 = HEAP32[i16 >> 2] | 0;
 i5 = HEAP32[i8 + (i6 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i10 + (i5 * 360 | 0) + 184 >> 2] | 0;
 do if ((i2 | 0) == (i1 | 0)) {
  i1 = HEAP16[i8 + (i9 << 5) + 12 >> 1] | 0;
  i2 = HEAP16[i8 + (i6 << 5) + 12 >> 1] | 0;
  if (i1 << 16 >> 16 != i2 << 16 >> 16) {
   if (i1 << 16 >> 16 < i2 << 16 >> 16) break;
   STACKTOP = i21;
   return;
  }
  f3 = Math_fround(HEAPF32[i8 + (i9 << 5) + 20 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  f4 = Math_fround(HEAPF32[i8 + (i6 << 5) + 20 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i2 | 0)) {
   if (i1 >>> 0 < i2 >>> 0) break;
   STACKTOP = i21;
   return;
  }
  i2 = HEAP32[i8 + (i9 << 5) + 28 >> 2] | 0;
  i1 = HEAP32[i8 + (i6 << 5) + 28 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   if (i2 >>> 0 > i1 >>> 0) break;
   STACKTOP = i21;
   return;
  }
  if (f3 != f4) {
   if (f3 > f4) break;
   STACKTOP = i21;
   return;
  }
  i2 = HEAP16[i10 + (i7 * 360 | 0) + 270 >> 1] | 0;
  i1 = HEAP16[i10 + (i5 * 360 | 0) + 270 >> 1] | 0;
  if (i2 << 16 >> 16 == i1 << 16 >> 16) {
   if ((i9 | 0) < (i6 | 0)) break;
   STACKTOP = i21;
   return;
  } else {
   if ((i2 & 65535) > (i1 & 65535)) break;
   STACKTOP = i21;
   return;
  }
 } else if (i2 >>> 0 >= i1 >>> 0) {
  STACKTOP = i21;
  return;
 } while (0);
 _memcpy(i20 | 0, i19 | 0, 212) | 0;
 _memcpy(i19 | 0, i18 | 0, 212) | 0;
 _memcpy(i18 | 0, i20 | 0, 212) | 0;
 STACKTOP = i21;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE(f2, i7, i1, i8, f3, i9, i10, i13) {
 f2 = Math_fround(f2);
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i11 = 0, i12 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 f6 = Math_fround(f2 * f3);
 f24 = Math_fround(f6 * Math_fround(HEAPF32[i1 >> 2]));
 f27 = Math_fround(f6 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i9 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i9 >> 2]));
 i21 = i9 + 4 | 0;
 HEAPF32[i21 >> 2] = Math_fround(f27 + Math_fround(HEAPF32[i21 >> 2]));
 i20 = i9 + 8 | 0;
 HEAPF32[i20 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i20 >> 2]));
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 i1 = i13 + 4 | 0;
 f27 = Math_fround(HEAPF32[i1 >> 2]);
 i11 = i13 + 8 | 0;
 f24 = Math_fround(HEAPF32[i11 >> 2]);
 i12 = i13 + 12 | 0;
 f15 = Math_fround(HEAPF32[i12 >> 2]);
 f28 = Math_fround(f6 + f6);
 f17 = Math_fround(f27 + f27);
 f29 = Math_fround(f24 + f24);
 f19 = Math_fround(f27 * f17);
 f25 = Math_fround(f24 * f29);
 f27 = Math_fround(f28 * f27);
 f4 = Math_fround(f28 * f24);
 f2 = Math_fround(f28 * f15);
 f24 = Math_fround(f17 * f24);
 f17 = Math_fround(f17 * f15);
 f15 = Math_fround(f29 * f15);
 f29 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f25);
 f26 = Math_fround(f27 + f15);
 f22 = Math_fround(f4 - f17);
 f15 = Math_fround(f27 - f15);
 f28 = Math_fround(Math_fround(1.0) - Math_fround(f6 * f28));
 f25 = Math_fround(f28 - f25);
 f6 = Math_fround(f24 + f2);
 f17 = Math_fround(f4 + f17);
 f2 = Math_fround(f24 - f2);
 f19 = Math_fround(f28 - f19);
 f28 = Math_fround(HEAPF32[i7 >> 2]);
 f24 = Math_fround(f28 * f29);
 f4 = Math_fround(f28 * f26);
 f28 = Math_fround(f28 * f22);
 f27 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f23 = Math_fround(f27 * f15);
 f5 = Math_fround(f27 * f25);
 f27 = Math_fround(f27 * f6);
 f16 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f18 = Math_fround(f17 * f16);
 f14 = Math_fround(f2 * f16);
 f17 = Math_fround(Math_fround(Math_fround(f29 * f24) + Math_fround(f15 * f23)) + Math_fround(f17 * f18));
 f15 = Math_fround(Math_fround(Math_fround(f26 * f4) + Math_fround(f25 * f5)) + Math_fround(f2 * f14));
 f16 = Math_fround(Math_fround(Math_fround(f22 * f28) + Math_fround(f6 * f27)) + Math_fround(f19 * Math_fround(f19 * f16)));
 f2 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f25 * f23)) + Math_fround(f2 * f18));
 f18 = Math_fround(Math_fround(Math_fround(f22 * f24) + Math_fround(f6 * f23)) + Math_fround(f19 * f18));
 f14 = Math_fround(Math_fround(Math_fround(f22 * f4) + Math_fround(f6 * f5)) + Math_fround(f19 * f14));
 f19 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f3);
 f5 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) * f3);
 f6 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) * f3);
 f17 = Math_fround(Math_fround(Math_fround(f19 * f17) + Math_fround(f5 * f2)) + Math_fround(f18 * f6));
 f15 = Math_fround(Math_fround(Math_fround(f19 * f2) + Math_fround(f5 * f15)) + Math_fround(f14 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f5 * f14)) + Math_fround(f16 * f6));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f17);
 i7 = i10 + 4 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f15);
 i8 = i10 + 8 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f3);
 f15 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f3);
 f17 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f3);
 i9 = i13 + 16 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i9 >> 2]));
 i9 = i13 + 20 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i9 >> 2]));
 i9 = i13 + 24 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i9 >> 2]));
 f17 = Math_fround(HEAPF32[i10 >> 2]);
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f16 = Math_fround(HEAPF32[i13 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f3 * Math_fround(.5));
 f2 = Math_fround(f16 + Math_fround(f19 * Math_fround(Math_fround(Math_fround(f15 * f5) + Math_fround(Math_fround(f16 * Math_fround(0.0)) + Math_fround(f17 * f18))) - Math_fround(f6 * f14))));
 f3 = Math_fround(f14 + Math_fround(f19 * Math_fround(Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f14 * Math_fround(0.0)) + Math_fround(f15 * f18))) - Math_fround(f17 * f5))));
 f4 = Math_fround(f5 + Math_fround(f19 * Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f5 * Math_fround(0.0)) + Math_fround(f6 * f18))) - Math_fround(f15 * f16))));
 f5 = Math_fround(f18 + Math_fround(f19 * Math_fround(Math_fround(Math_fround(Math_fround(f18 * Math_fround(0.0)) - Math_fround(f17 * f16)) - Math_fround(f15 * f14)) - Math_fround(f6 * f5))));
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3))))));
 if (!(f6 != Math_fround(0.0))) {
  f29 = f5;
  f28 = f4;
  f27 = f3;
  f26 = f2;
  HEAPF32[i13 >> 2] = f26;
  HEAPF32[i1 >> 2] = f27;
  HEAPF32[i11 >> 2] = f28;
  HEAPF32[i12 >> 2] = f29;
  return;
 }
 f26 = Math_fround(Math_fround(1.0) / f6);
 f29 = Math_fround(f5 * f26);
 f28 = Math_fround(f4 * f26);
 f27 = Math_fround(f3 * f26);
 f26 = Math_fround(f2 * f26);
 HEAPF32[i13 >> 2] = f26;
 HEAPF32[i1 >> 2] = f27;
 HEAPF32[i11 >> 2] = f28;
 HEAPF32[i12 >> 2] = f29;
 return;
}

function runPostSets242() {
 HEAP32[gb + 215752 >> 2] = (HEAP32[gb + 215752 >> 2] | 0) + (gb + 215788 | 0);
 HEAP32[gb + 215756 >> 2] = (HEAP32[gb + 215756 >> 2] | 0) + (gb + 215848 | 0);
 HEAP32[gb + 215760 >> 2] = (HEAP32[gb + 215760 >> 2] | 0) + (gb + 215848 | 0);
 HEAP32[gb + 215764 >> 2] = (HEAP32[gb + 215764 >> 2] | 0) + (gb + 215888 | 0);
 HEAP32[gb + 215768 >> 2] = (HEAP32[gb + 215768 >> 2] | 0) + (gb + 215888 | 0);
 HEAP32[gb + 215772 >> 2] = (HEAP32[gb + 215772 >> 2] | 0) + (gb + 215788 | 0);
 HEAP32[gb + 215776 >> 2] = (HEAP32[gb + 215776 >> 2] | 0) + (gb + 215788 | 0);
 HEAP32[gb + 215780 >> 2] = (HEAP32[gb + 215780 >> 2] | 0) + (gb + 215688 | 0);
 HEAP32[gb + 215784 >> 2] = (HEAP32[gb + 215784 >> 2] | 0) + (gb + 215688 | 0);
 HEAP32[gb + 215796 >> 2] = (HEAP32[gb + 215796 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 215800 >> 2] = fb + 3053;
 HEAP32[gb + 215804 >> 2] = fb + 3054;
 HEAP32[gb + 215816 >> 2] = (HEAP32[gb + 215816 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 215820 >> 2] = fb + 3055;
 HEAP32[gb + 215824 >> 2] = fb + 3056;
 HEAP32[gb + 215836 >> 2] = (HEAP32[gb + 215836 >> 2] | 0) + (gb + 10872 | 0);
 HEAP32[gb + 215840 >> 2] = fb + 3057;
 HEAP32[gb + 215844 >> 2] = fb + 3058;
 HEAP32[gb + 215856 >> 2] = (HEAP32[gb + 215856 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 215860 >> 2] = fb + 3041;
 HEAP32[gb + 215864 >> 2] = fb + 3042;
 HEAP32[gb + 215876 >> 2] = (HEAP32[gb + 215876 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 215880 >> 2] = fb + 3043;
 HEAP32[gb + 215884 >> 2] = fb + 3044;
 HEAP32[gb + 215896 >> 2] = (HEAP32[gb + 215896 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 215900 >> 2] = fb + 879;
 HEAP32[gb + 215904 >> 2] = fb + 880;
 HEAP32[gb + 215916 >> 2] = (HEAP32[gb + 215916 >> 2] | 0) + (gb + 10824 | 0);
 HEAP32[gb + 215920 >> 2] = fb + 881;
 HEAP32[gb + 215924 >> 2] = fb + 882;
 HEAP32[gb + 215932 >> 2] = (HEAP32[gb + 215932 >> 2] | 0) + (gb + 12912 | 0);
 HEAP32[gb + 215936 >> 2] = fb + 3029;
 HEAP32[gb + 215940 >> 2] = fb + 3204;
 HEAP32[gb + 215944 >> 2] = fb + 1;
 HEAP32[gb + 215948 >> 2] = fb + 471;
 HEAP32[gb + 215952 >> 2] = fb + 300;
 HEAP32[gb + 215956 >> 2] = fb + 301;
 HEAP32[gb + 215960 >> 2] = fb + 1;
 HEAP32[gb + 12912 >> 2] = (HEAP32[gb + 12912 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 12916 >> 2] = (HEAP32[gb + 12916 >> 2] | 0) + (gb + 1084607 | 0);
 HEAP32[gb + 215968 >> 2] = (HEAP32[gb + 215968 >> 2] | 0) + (gb + 12920 | 0);
 HEAP32[gb + 215972 >> 2] = fb + 3205;
 HEAP32[gb + 215976 >> 2] = fb + 3206;
 HEAP32[gb + 215980 >> 2] = fb + 1413;
 HEAP32[gb + 12920 >> 2] = (HEAP32[gb + 12920 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12924 >> 2] = (HEAP32[gb + 12924 >> 2] | 0) + (gb + 1084632 | 0);
 HEAP32[gb + 12928 >> 2] = (HEAP32[gb + 12928 >> 2] | 0) + (gb + 13128 | 0);
 HEAP32[gb + 215988 >> 2] = (HEAP32[gb + 215988 >> 2] | 0) + (gb + 12936 | 0);
 HEAP32[gb + 215992 >> 2] = fb + 3029;
 HEAP32[gb + 215996 >> 2] = fb + 3207;
 HEAP32[gb + 216e3 >> 2] = fb + 1;
 HEAP32[gb + 216004 >> 2] = fb + 471;
 HEAP32[gb + 216008 >> 2] = fb + 300;
 HEAP32[gb + 216012 >> 2] = fb + 301;
 HEAP32[gb + 216016 >> 2] = fb + 474;
 HEAP32[gb + 12936 >> 2] = (HEAP32[gb + 12936 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12940 >> 2] = (HEAP32[gb + 12940 >> 2] | 0) + (gb + 1084655 | 0);
 HEAP32[gb + 12944 >> 2] = (HEAP32[gb + 12944 >> 2] | 0) + (gb + 12912 | 0);
 HEAP32[gb + 216024 >> 2] = (HEAP32[gb + 216024 >> 2] | 0) + (gb + 12952 | 0);
 HEAP32[gb + 216028 >> 2] = fb + 3029;
 HEAP32[gb + 216032 >> 2] = fb + 3208;
 HEAP32[gb + 216036 >> 2] = fb + 1545;
 HEAP32[gb + 216040 >> 2] = fb + 471;
 HEAP32[gb + 216044 >> 2] = fb + 300;
 HEAP32[gb + 216048 >> 2] = fb + 301;
 HEAP32[gb + 216052 >> 2] = fb + 475;
 HEAP32[gb + 12952 >> 2] = (HEAP32[gb + 12952 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12956 >> 2] = (HEAP32[gb + 12956 >> 2] | 0) + (gb + 1084686 | 0);
 HEAP32[gb + 12960 >> 2] = (HEAP32[gb + 12960 >> 2] | 0) + (gb + 12936 | 0);
 HEAP32[gb + 216060 >> 2] = (HEAP32[gb + 216060 >> 2] | 0) + (gb + 12968 | 0);
 HEAP32[gb + 216064 >> 2] = fb + 3029;
 HEAP32[gb + 216068 >> 2] = fb + 3209;
 HEAP32[gb + 216072 >> 2] = fb + 1546;
 HEAP32[gb + 216076 >> 2] = fb + 476;
 HEAP32[gb + 216080 >> 2] = fb + 300;
 HEAP32[gb + 216084 >> 2] = fb + 301;
 HEAP32[gb + 216088 >> 2] = fb + 477;
 HEAP32[gb + 12968 >> 2] = (HEAP32[gb + 12968 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12972 >> 2] = (HEAP32[gb + 12972 >> 2] | 0) + (gb + 1084728 | 0);
 HEAP32[gb + 12976 >> 2] = (HEAP32[gb + 12976 >> 2] | 0) + (gb + 12936 | 0);
 HEAP32[gb + 216092 >> 2] = fb + 2;
 HEAP32[gb + 12984 >> 2] = (HEAP32[gb + 12984 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 12988 >> 2] = (HEAP32[gb + 12988 >> 2] | 0) + (gb + 1084994 | 0);
 HEAP32[gb + 216096 >> 2] = (HEAP32[gb + 216096 >> 2] | 0) + (gb + 1084985 | 0);
 HEAP32[gb + 216104 >> 2] = (HEAP32[gb + 216104 >> 2] | 0) + (gb + 12992 | 0);
 HEAP32[gb + 216108 >> 2] = fb + 3210;
 HEAP32[gb + 216112 >> 2] = fb + 3211;
 HEAP32[gb + 216116 >> 2] = fb + 3212;
 HEAP32[gb + 216120 >> 2] = fb + 3213;
 HEAP32[gb + 216124 >> 2] = fb + 324;
 HEAP32[gb + 216128 >> 2] = fb + 148;
 HEAP32[gb + 216132 >> 2] = fb + 94;
 HEAP32[gb + 216136 >> 2] = fb + 183;
 HEAP32[gb + 12992 >> 2] = (HEAP32[gb + 12992 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12996 >> 2] = (HEAP32[gb + 12996 >> 2] | 0) + (gb + 1085090 | 0);
 HEAP32[gb + 13e3 >> 2] = (HEAP32[gb + 13e3 >> 2] | 0) + (gb + 13008 | 0);
 HEAP32[gb + 13008 >> 2] = (HEAP32[gb + 13008 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 13012 >> 2] = (HEAP32[gb + 13012 >> 2] | 0) + (gb + 1085007 | 0);
 HEAP32[gb + 13016 >> 2] = (HEAP32[gb + 13016 >> 2] | 0) + (gb + 13024 | 0);
 HEAP32[gb + 216144 >> 2] = (HEAP32[gb + 216144 >> 2] | 0) + (gb + 13032 | 0);
 runPostSets243();
}

function __ZN9Polygon2D5ResetEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i9 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i3 | 0;
 i1 = (i8 | 0) / 20 | 0;
 if (!i8) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i9, 1 - i1 | 0); else if (i1 >>> 0 > 1) {
  i3 = i3 + 20 | 0;
  if ((i2 | 0) != (i3 | 0)) while (1) {
   i1 = i2 + -20 | 0;
   HEAP32[i4 >> 2] = i1;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else i3 = i1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483644) >>> 0 < 4) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = 4;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, 32, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 12 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = 4;
  HEAP32[i3 >> 2] = i8;
  break;
 } while (0);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + (i4 << 3) >> 2] = -1082130432;
 HEAP32[i2 + (i4 << 3) + 4 >> 2] = -1082130432;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 + (i4 << 3) >> 2] = -1082130432;
 HEAP32[i3 + (i4 << 3) + 4 >> 2] = 1065353216;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i3 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = i8 & 2147483647;
 do if (i6 >>> 0 > i2 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i2 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 3, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + (i5 << 3) >> 2] = 1065353216;
 HEAP32[i2 + (i5 << 3) + 4 >> 2] = 1065353216;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = 1065353216;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = -1082130432;
  return;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = 1065353216;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = -1082130432;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = 1065353216;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = -1082130432;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = 1065353216;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = -1082130432;
  return;
 }
}

function _Cubic_To(i34, i1, i4, i2, i5, i6, i3) {
 i34 = i34 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0;
 i32 = i34 + 180 | 0;
 i33 = i34 + 52 | 0;
 HEAP32[i33 >> 2] = i32;
 i36 = i34 + 68 | 0;
 HEAP32[i34 + 204 >> 2] = HEAP32[i36 >> 2];
 i35 = i34 + 72 | 0;
 i17 = HEAP32[i35 >> 2] | 0;
 HEAP32[i34 + 208 >> 2] = i17;
 HEAP32[i34 + 196 >> 2] = i1;
 HEAP32[i34 + 200 >> 2] = i4;
 HEAP32[i34 + 188 >> 2] = i2;
 HEAP32[i34 + 192 >> 2] = i5;
 HEAP32[i32 >> 2] = i6;
 HEAP32[i34 + 184 >> 2] = i3;
 i18 = i34 + 100 | 0;
 i19 = i34 + 76 | 0;
 i20 = i34 + 80 | 0;
 i21 = i34 + 86 | 0;
 i22 = i34 + 88 | 0;
 i23 = i34 + 4 | 0;
 i24 = i34 + 8 | 0;
 i25 = i34 + 92 | 0;
 i26 = i34 + 40 | 0;
 i27 = i34 + 36 | 0;
 i28 = i34 + 176 | 0;
 i29 = i34 + 96 | 0;
 i30 = i34 + 87 | 0;
 i31 = i34 + 84 | 0;
 i2 = i32;
 L1 : while (1) {
  i12 = i2 + 28 | 0;
  i13 = i2 + 20 | 0;
  i14 = i2 + 12 | 0;
  i16 = i2 + 4 | 0;
  i15 = (i17 | 0) <= (i3 | 0);
  i11 = (i4 | 0) > (i5 | 0);
  do if (((i11 ? i5 : i4) | 0) < ((i15 ? i17 : i3) | 0) ? 1 : ((i11 ? i4 : i5) | 0) > ((i15 ? i3 : i17) | 0)) {
   i15 = i2 + 24 | 0;
   i16 = HEAP32[i15 >> 2] | 0;
   HEAP32[i2 + 48 >> 2] = i16;
   i7 = i2 + 8 | 0;
   i9 = i2 + 16 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   i8 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   i11 = i6 + i8 >> 1;
   HEAP32[i7 >> 2] = i11;
   i16 = i16 + 1 + i10 >> 1;
   HEAP32[i2 + 40 >> 2] = i16;
   i10 = (i8 + i10 >> 1) + 1 | 0;
   i11 = i10 + i11 >> 1;
   HEAP32[i9 >> 2] = i11;
   i16 = i10 + i16 >> 1;
   HEAP32[i2 + 32 >> 2] = i16;
   HEAP32[i15 >> 2] = i11 + 1 + i16 >> 1;
   HEAP32[i2 + 52 >> 2] = i17;
   i15 = i5 + 1 | 0;
   i16 = i3 + i15 >> 1;
   HEAP32[i14 >> 2] = i16;
   i17 = i17 + 1 + i4 >> 1;
   HEAP32[i2 + 44 >> 2] = i17;
   i15 = (i15 + i4 >> 1) + 1 | 0;
   i16 = i15 + i16 >> 1;
   HEAP32[i13 >> 2] = i16;
   i17 = i15 + i17 >> 1;
   HEAP32[i2 + 36 >> 2] = i17;
   HEAP32[i12 >> 2] = i16 + 1 + i17 >> 1;
   HEAP32[i33 >> 2] = i2 + 24;
  } else {
   if ((i17 | 0) == (i3 | 0)) {
    HEAP32[i33 >> 2] = i2 + -24;
    break;
   }
   i11 = i15 ? 1 : 2;
   i2 = HEAP32[i18 >> 2] | 0;
   if ((i2 | 0) != (i11 | 0)) {
    i1 = HEAP32[i23 >> 2] | 0;
    if (i15) i10 = ((i17 + -1 + i1 & 0 - i1) - i17 | 0) >= (HEAP32[i24 >> 2] | 0); else i10 = (i1 + -1 & i17 | 0) >= (HEAP32[i24 >> 2] | 0);
    if (i2 | 0) {
     i8 = HEAP32[i26 >> 2] | 0;
     i9 = HEAP32[i22 >> 2] | 0;
     i2 = i8 - (HEAP32[i9 + 8 >> 2] | 0) | 0;
     i1 = i8;
     if ((i2 | 0) < 0) {
      i2 = 12;
      break L1;
     }
     if (i2) {
      HEAP32[i9 + 16 >> 2] = i2 >> 2;
      do if (i10) {
       i2 = i9 + 12 | 0;
       i7 = HEAPU16[i2 >> 1] | 0;
       if (!(i7 & 8)) {
        HEAP16[i2 >> 1] = i7 | 32;
        break;
       } else {
        HEAP16[i2 >> 1] = i7 | 16;
        break;
       }
      } while (0);
      HEAP32[i22 >> 2] = i8;
      i1 = i1 + 32 | 0;
      HEAP32[i26 >> 2] = i1;
      i7 = i8;
      HEAP32[i7 + 16 >> 2] = 0;
      HEAP32[i7 + 8 >> 2] = i1;
      HEAP32[i9 + 28 >> 2] = i8;
      HEAP16[i31 >> 1] = (HEAP16[i31 >> 1] | 0) + 1 << 16 >> 16;
     }
     if (i1 >>> 0 >= (HEAP32[i27 >> 2] | 0) >>> 0) {
      i2 = 20;
      break L1;
     }
     HEAP8[i30 >> 0] = 0;
    }
    if (!(HEAP32[i25 >> 2] | 0)) {
     i1 = HEAP32[i26 >> 2] | 0;
     HEAP32[i22 >> 2] = i1;
     HEAP32[i25 >> 2] = i1;
     i1 = i1 + 32 | 0;
     HEAP32[i26 >> 2] = i1;
    } else i1 = HEAP32[i26 >> 2] | 0;
    if (i1 >>> 0 >= (HEAP32[i27 >> 2] | 0) >>> 0) {
     i2 = 26;
     break L1;
    }
    i2 = HEAP32[i22 >> 2] | 0;
    i7 = i2 + 12 | 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    i1 = HEAP8[i28 >> 0] | 0;
    HEAP16[i7 >> 1] = i1 & 255;
    if (i15) {
     i1 = i1 & 255;
     HEAP16[i7 >> 1] = i1 | 8;
     if (i10) HEAP16[i7 >> 1] = i1 | 40;
    } else if (i10) HEAP16[i7 >> 1] = i1 & 255 | 16;
    if (!(HEAP32[i29 >> 2] | 0)) HEAP32[i29 >> 2] = i2;
    HEAP32[i18 >> 2] = i11;
    HEAP8[i21 >> 0] = 1;
    HEAP8[i30 >> 0] = 0;
   }
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = HEAP32[i20 >> 2] | 0;
   if (i15) if (!((_Bezier_Up(i34, 3, fb + 3858 | 0, i1, i2) | 0) << 24 >> 24)) break; else {
    i1 = 1;
    i2 = 44;
    break L1;
   }
   HEAP32[i16 >> 2] = 0 - i3;
   HEAP32[i14 >> 2] = 0 - i5;
   HEAP32[i13 >> 2] = 0 - i4;
   HEAP32[i12 >> 2] = 0 - i17;
   i17 = HEAP8[i21 >> 0] | 0;
   i1 = _Bezier_Up(i34, 3, fb + 3858 | 0, 0 - i2 | 0, 0 - i1 | 0) | 0;
   if (i17 << 24 >> 24) if (!(HEAP8[i21 >> 0] | 0)) {
    i17 = (HEAP32[i22 >> 2] | 0) + 20 | 0;
    HEAP32[i17 >> 2] = 0 - (HEAP32[i17 >> 2] | 0);
   }
   HEAP32[i16 >> 2] = 0 - (HEAP32[i16 >> 2] | 0);
   if (i1 << 24 >> 24) {
    i1 = 1;
    i2 = 44;
    break L1;
   }
  } while (0);
  i1 = HEAP32[i33 >> 2] | 0;
  if (i1 >>> 0 < i32 >>> 0) {
   i2 = 43;
   break;
  }
  i2 = i1;
  i17 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i1 + 20 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) == 12) {
  HEAP32[i34 + 44 >> 2] = 99;
  i36 = 1;
  return i36 | 0;
 } else if ((i2 | 0) == 20) {
  HEAP32[i34 + 44 >> 2] = 98;
  i36 = 1;
  return i36 | 0;
 } else if ((i2 | 0) == 26) {
  HEAP32[i34 + 44 >> 2] = 98;
  i36 = 1;
  return i36 | 0;
 } else if ((i2 | 0) == 43) {
  HEAP32[i36 >> 2] = i6;
  HEAP32[i35 >> 2] = i3;
  i36 = 0;
  return i36 | 0;
 } else if ((i2 | 0) == 44) return i1 | 0;
 return 0;
}

function __ZN23ForwardShaderRenderLoop21RenderLightShadowMapsER16ForwardShadowMapbbR17ShaderPassContext(i12, i15, i13, i1, i14) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 348 | 0;
 i20 = i22;
 i17 = __Z12GetGfxDevicev() | 0;
 i21 = i12 + 8 | 0;
 i2 = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0;
 i16 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
 i8 = __Z19GetGraphicsSettingsv() | 0;
 i8 = (HEAP8[i8 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0) == 0;
 i9 = i16 + 40 | 0;
 i10 = i16 + 96 | 0;
 i11 = i12 + 368 | 0;
 __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i14, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, 0, i13);
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 112 >> 2] | 0, i17 | 0, (HEAP32[i21 >> 2] | 0) + 1732 | 0);
 i17 = __ZNK6Camera16GetStereoEnabledEv(i2) | 0;
 HEAP32[i20 >> 2] = 0;
 i18 = i15 + 140 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  if (i17) {
   __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE(i2, i19);
   __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f(i2, (HEAP32[i21 >> 2] | 0) + 1664 | 0);
   __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(i2, (HEAP32[i21 >> 2] | 0) + 1600 | 0);
  }
  i3 = HEAP32[i15 + 144 >> 2] | 0;
  HEAP32[i20 >> 2] = __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext(i3, i14) | 0;
  HEAP32[i20 + 344 >> 2] = HEAP32[i3 + 35884 >> 2];
  _memcpy(i20 + 4 | 0, i3 + 34040 | 0, 256) | 0;
  i1 = i20 + 260 | 0;
  i4 = i3 + 35824 | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  i1 = i20 + 280 | 0;
  i3 = i3 + 35760 | 0;
  i4 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   i1 = i1 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  if (i17) __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE(i2, i19);
 } else _memcpy(i20 | 0, i1 | 0, 348) | 0;
 i7 = i15 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) HEAP32[i7 >> 2] = 0; else {
  HEAP32[i7 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i15 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i15 + 12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f25 = Math_fround(i6 | 0);
  f24 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i15 + 16 >> 2] = i3;
  HEAP32[i15 + 20 >> 2] = i2;
  HEAPF32[i15 + 24 >> 2] = f25;
  HEAPF32[i15 + 28 >> 2] = f24;
  i2 = i15 + 32 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i19, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 }
 i1 = i15 + 52 | 0;
 i3 = i20 + 4 | 0;
 i4 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 i5 = i15 + 148 | 0;
 HEAP8[i5 >> 0] = 0;
 i6 = i15 + 48 | 0;
 HEAP32[i6 >> 2] = 0;
 do if (i8) i23 = 26; else if (!(HEAP32[i7 >> 2] | 0)) i23 = 26; else if ((HEAP32[i9 >> 2] | 0) == 1) {
  if (!i17) if (HEAP32[i18 >> 2] | 0) break;
  __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i14, 1, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, 0, i13);
  i4 = __ZN23ForwardShaderRenderLoop14CollectShadowsER17ShadowCachingDataRK15SharedLightDatabbR17ShaderPassContext(i12, i20, i16, 0, 0, i14) | 0;
  if (!i4) HEAP32[i7 >> 2] = 0; else {
   HEAP32[i7 >> 2] = HEAP32[i4 + 48 >> 2];
   HEAP32[i15 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 148 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i15 + 12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0) | 0;
   i2 = HEAP32[i4 + 68 >> 2] | 0;
   i1 = HEAP32[i4 + 72 >> 2] | 0;
   i14 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0, i4 | 0) | 0;
   f24 = Math_fround(i14 | 0);
   f25 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0) | 0);
   HEAP32[i15 + 16 >> 2] = i2;
   HEAP32[i15 + 20 >> 2] = i1;
   HEAPF32[i15 + 24 >> 2] = f24;
   HEAPF32[i15 + 28 >> 2] = f25;
   i1 = i15 + 32 | 0;
   i2 = HEAP32[i4 + 56 >> 2] | 0;
   if ((__Z19GetActiveColorSpacev() | 0) == 1) i3 = HEAP32[i4 + 60 >> 2] | 0; else i3 = 0;
   __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i19, i2, i3);
   HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  }
  if (i17) {
   HEAP32[i6 >> 2] = i4;
   HEAP8[i5 >> 0] = 1;
   break;
  } else {
   HEAP32[i20 >> 2] = i4;
   break;
  }
 } else i23 = 26; while (0);
 if ((i23 | 0) == 26) __Z20SetNoShadowsKeywordsR17ShaderPassContext(i14);
 if ((HEAP32[i18 >> 2] | 0) != 0 | (HEAP32[i20 >> 2] | 0) == 0) {
  STACKTOP = i22;
  return;
 }
 __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai(HEAP32[(HEAP32[i21 >> 2] | 0) + 1728 >> 2] | 0, i20, HEAP32[i16 + 16 >> 2] | 0);
 STACKTOP = i22;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 414;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 116;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 120;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 76;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 128;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj76ENS0_26PxPvdRangePropertyAccessorILj76ES4_fEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 132;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj76ENS0_26PxPvdRangePropertyAccessorILj76ES4_fEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 71;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 104;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj71ENS0_26PxPvdRangePropertyAccessorILj71ES4_fEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 108;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj71ENS0_26PxPvdRangePropertyAccessorILj71ES4_fEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 44 | 0;
 i2 = i18;
 i14 = i18 + 28 | 0;
 i16 = i18 + 40 | 0;
 i17 = i18 + 8 | 0;
 if ((HEAP32[i13 + 32 >> 2] | 0) != -2) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0;
 i1 = i1 >>> 0 > 4096 ? 4096 : i1;
 i15 = i13 + 168 | 0;
 i12 = i13 + 172 | 0;
 if ((HEAP32[i15 >> 2] | 0) >>> 0 <= i1 >>> 0) if ((HEAP32[i12 >> 2] | 0) >>> 0 <= i1 >>> 0) {
  i1 = i13 + 40 | 0;
  i2 = i13 + 56 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i13 + 44 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 + 52 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = HEAP32[i13 + 60 >> 2] | 0;
  i2 = i13 + 64 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -60 - i1 | 0) >>> 0) / 60 | 0) * 60 | 0);
  i9 = i13 + 76 | 0;
  HEAP32[i11 >> 2] = __ZNK13TextRendering4Font10GetTextureEv(HEAP32[i9 >> 2] | 0) | 0;
  i10 = __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E(i11) | 0;
  if (!i10) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
  if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0)) HEAP8[i10 + 112 >> 0] = 1; else HEAP8[i10 + 111 >> 0] = 1;
  i8 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if ((i8 | 0) == (HEAP32[i15 >> 2] | 0)) {
   i8 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0) | 0;
   if ((i8 | 0) == (HEAP32[i12 >> 2] | 0)) i2 = (HEAP8[i10 + 109 >> 0] | 0) == 0; else i2 = 1;
  } else i2 = 1;
  if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 16) i4 = 20; else {
   i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
   if (i1 >>> 0 < 10) i1 = (521 >>> (i1 & 1023) & 1) != 0; else i1 = 0;
   if (i2 | i1) i4 = 20;
  }
  do if ((i4 | 0) == 20) if (mftCall_iiiiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 188 >> 2] | 0, i10 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i12 >> 2] | 0, 1, 0, 1, -1, 0) | 0) {
   mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 192 >> 2] | 0, i10 | 0);
   break;
  } else {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  } while (0);
  HEAP32[i14 >> 2] = 0;
  i8 = i14 + 4 | 0;
  i2 = gb + 63160 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = i8;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = Math_imul(i4, i1) | 0;
  do if (!i2) {
   i3 = 0;
   i2 = i4;
  } else if (i2 >>> 0 < 2e3) {
   i3 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i4;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 944940 | 0, 491) | 0;
   i1 = gb + 64016 | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i3;
   i2 = i8;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i2 + 4 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   break;
  } while (0);
  _memset(i3 | 0, 0, Math_imul(i2, i1) | 0) | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0)) {
   i1 = Math_imul(i2, i1) | 0;
   i2 = __Z12GetGfxDevicev() | 0;
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + 440 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i10 + 48 >> 2];
   i5 = HEAP32[i15 >> 2] | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   if ((__Z19GetActiveColorSpacev() | 0) == 1) i7 = HEAP32[i10 + 60 >> 2] | 0; else i7 = 0;
   HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
   mftCall_viiiiiiiiiii(i4 | 0, i2 | 0, i11 | 0, i3 | 0, i1 | 0, 0, 0, 0, i5 | 0, i6 | 0, 1, i7 | 0);
  }
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i10, i11, 0, 0) | 0) {
    i16 = HEAP32[i15 >> 2] | 0;
    __ZN14ImageReferenceC2Eiii13TextureFormatPv(i17, i16, HEAP32[i12 >> 2] | 0, i16, 1, i3);
    __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i17, 0);
   }
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 515 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 192 >> 2] | 0, i10 | 0);
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i8);
  __ZN20TextRenderingPrivate8FontImpl16ResetPackingDataEv(i13);
  HEAP32[i13 + 184 >> 2] = 0;
  i17 = i13 + 180 | 0;
  i14 = (HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] << 3) + -1 | 0;
  i14 = i14 >>> 16 | i14;
  i14 = i14 >>> 8 | i14;
  i14 = i14 >>> 4 | i14;
  i14 = i14 >>> 2 | i14;
  i14 = (i14 >>> 1 | i14) + 1 | 0;
  i16 = HEAP32[i17 >> 2] | 0;
  i16 = i16 >>> 0 < i14 >>> 0 ? i14 : i16;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i17 >> 2] = i15 >>> 0 < i16 >>> 0 ? i15 : i16;
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i17 = HEAP32[i13 + 76 >> 2] | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 36 >> 2] | 0, i17 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 __Z6FormatPKcz(i11, gb + 945975 | 0, i2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 944940 | 0, 452, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 HEAP32[i15 >> 2] = i1;
 HEAP32[i12 >> 2] = i1;
 i17 = 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_16IslandPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i15 = i4;
      break;
     }
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[(HEAP32[i18 + (i6 << 2) >> 2] | 0) + 56 >> 2] | 0) >>> 0 < (HEAP32[(HEAP32[i18 + (i5 << 2) >> 2] | 0) + 56 >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i13 = i18 + (((i3 + i15 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i15 << 2) | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = HEAP32[i6 + 56 >> 2] | 0;
   i9 = i6;
   i4 = i5;
   if ((HEAP32[i5 + 56 >> 2] | 0) >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i4;
    HEAP32[i13 >> 2] = i9;
    i14 = HEAP32[i12 >> 2] | 0;
    i4 = i9;
    i7 = HEAP32[i14 + 56 >> 2] | 0;
    i9 = i14;
   } else i6 = i5;
   i11 = i18 + (i3 << 2) | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i10 = HEAP32[i5 + 56 >> 2] | 0;
   if (i10 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i11 >> 2] = i9;
    i4 = HEAP32[i13 >> 2] | 0;
    i6 = i4;
    i7 = HEAP32[i9 + 56 >> 2] | 0;
    i5 = i9;
   } else i7 = i10;
   if (i7 >>> 0 < (HEAP32[i6 + 56 >> 2] | 0) >>> 0) {
    HEAP32[i13 >> 2] = i5;
    HEAP32[i11 >> 2] = i4;
    i4 = HEAP32[i13 >> 2] | 0;
   }
   i6 = i3 + -1 | 0;
   i14 = i18 + (i6 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i4;
   i7 = i4;
   i5 = i4;
   i4 = i15;
   while (1) {
    i12 = HEAP32[i5 + 56 >> 2] | 0;
    i10 = i4;
    while (1) {
     i4 = i10 + 1 | 0;
     i5 = i18 + (i4 << 2) | 0;
     i9 = HEAP32[i5 >> 2] | 0;
     if ((HEAP32[i9 + 56 >> 2] | 0) >>> 0 < i12 >>> 0) i10 = i4; else {
      i11 = i9;
      i13 = i10;
      break;
     }
    }
    do {
     i6 = i6 + -1 | 0;
     i9 = i18 + (i6 << 2) | 0;
     i10 = HEAP32[i9 >> 2] | 0;
    } while (i12 >>> 0 < (HEAP32[i10 + 56 >> 2] | 0) >>> 0);
    if ((i4 | 0) >= (i6 | 0)) {
     i6 = i11;
     break;
    }
    HEAP32[i5 >> 2] = i10;
    HEAP32[i9 >> 2] = i11;
    i5 = HEAP32[i14 >> 2] | 0;
    i7 = i5;
   }
   HEAP32[i5 >> 2] = i7;
   HEAP32[i14 >> 2] = i6;
   if ((i4 - i15 | 0) < (i3 - i4 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i4 = i16; else {
     i4 = i16 << 3;
     if (!i4) i4 = 0; else {
      i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
      i14 = _PxGetFoundation() | 0;
      i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
      i4 = mftCall_iiiiii(i11 | 0, i12 | 0, i4 | 0, (i14 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i15;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i5 = i4;
    i4 = i13 + 2 | 0;
   } else {
    i5 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i4 = i16; else {
     i4 = i16 << 3;
     if (!i4) i4 = 0; else {
      i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
      i14 = _PxGetFoundation() | 0;
      i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
      i4 = mftCall_iiiiii(i11 | 0, i12 | 0, i4 | 0, (i14 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i5;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i15;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN15AABBTreeOverlapIN5physx2Gu15CapsuleAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i1, i59, i61, i60, i62) {
 i1 = i1 | 0;
 i59 = i59 | 0;
 i61 = i61 | 0;
 i60 = i60 | 0;
 i62 = i62 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i63 = 0, i64 = 0, i65 = 0, f66 = f0, f67 = f0, f68 = f0, i69 = 0, i70 = 0, f71 = f0, f72 = f0, f73 = f0, f74 = f0, f75 = f0, f76 = f0, f77 = f0;
 i63 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i57 = i63 + 8 | 0;
 i58 = i63;
 i33 = HEAP32[i61 + 4 >> 2] | 0;
 HEAP32[i57 >> 2] = i33;
 i44 = i60 + 48 | 0;
 i50 = i60 + 52 | 0;
 i51 = i60 + 56 | 0;
 i52 = i60 + 4 | 0;
 i53 = i60 + 8 | 0;
 i54 = i60 + 32 | 0;
 i55 = i60 + 36 | 0;
 i56 = i60 + 40 | 0;
 i34 = i60 + 16 | 0;
 i35 = i60 + 20 | 0;
 i36 = i60 + 24 | 0;
 i37 = i60 + 80 | 0;
 i38 = i60 + 84 | 0;
 i39 = i60 + 88 | 0;
 i40 = i60 + 64 | 0;
 i41 = i60 + 68 | 0;
 i42 = i60 + 72 | 0;
 i43 = i60 + 96 | 0;
 i45 = i60 + 100 | 0;
 i46 = i60 + 104 | 0;
 i47 = i60 + 112 | 0;
 i48 = i60 + 116 | 0;
 i49 = i60 + 120 | 0;
 i1 = 1;
 while (1) {
  i1 = i1 + -1 | 0;
  i8 = HEAP32[i57 + (i1 << 2) >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f5 = Math_fround(Math_fround(i2 & 255 | 0) * f7);
  f6 = Math_fround(Math_fround(i3 & 255 | 0) * f7);
  f7 = Math_fround(Math_fround(i4 & 255 | 0) * f7);
  f9 = Math_fround(HEAPF32[i44 >> 2]);
  f10 = Math_fround(HEAPF32[i50 >> 2]);
  f11 = Math_fround(HEAPF32[i51 >> 2]);
  f12 = Math_fround(HEAPF32[i60 >> 2]);
  f13 = Math_fround(HEAPF32[i52 >> 2]);
  f14 = Math_fround(HEAPF32[i53 >> 2]);
  f15 = Math_fround(HEAPF32[i54 >> 2]);
  f16 = Math_fround(HEAPF32[i55 >> 2]);
  f17 = Math_fround(HEAPF32[i56 >> 2]);
  f18 = Math_fround(HEAPF32[i34 >> 2]);
  f19 = Math_fround(HEAPF32[i35 >> 2]);
  f20 = Math_fround(HEAPF32[i36 >> 2]);
  f21 = Math_fround(HEAPF32[i37 >> 2]);
  f22 = Math_fround(HEAPF32[i38 >> 2]);
  f23 = Math_fround(HEAPF32[i39 >> 2]);
  f24 = Math_fround(HEAPF32[i40 >> 2]);
  f25 = Math_fround(HEAPF32[i41 >> 2]);
  f26 = Math_fround(HEAPF32[i42 >> 2]);
  f27 = Math_fround(HEAPF32[i43 >> 2]);
  f28 = Math_fround(HEAPF32[i45 >> 2]);
  f29 = Math_fround(HEAPF32[i46 >> 2]);
  f30 = Math_fround(HEAPF32[i47 >> 2]);
  f31 = Math_fround(HEAPF32[i48 >> 2]);
  f32 = Math_fround(HEAPF32[i49 >> 2]);
  while (1) {
   f77 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f75 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f71 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f76 = Math_fround(f5 + f9);
   f74 = Math_fround(f6 + f10);
   f66 = Math_fround(f7 + f11);
   f68 = Math_fround(f12 - f77);
   f6 = Math_fround(f13 - f75);
   f72 = Math_fround(f14 - f71);
   f67 = Math_fround(Math_fround(f6 * f18) - Math_fround(f68 * f15));
   f6 = Math_fround(Math_fround(f72 * f19) - Math_fround(f6 * f16));
   f72 = Math_fround(Math_fround(f68 * f20) - Math_fround(f72 * f17));
   f68 = Math_fround(Math_fround(f76 * f21) + Math_fround(f74 * f24));
   f5 = Math_fround(Math_fround(f74 * f22) + Math_fround(f66 * f25));
   f73 = Math_fround(Math_fround(f66 * f23) + Math_fround(f76 * f26));
   i65 = Math_fround(f77 + f76) >= f27;
   i3 = Math_fround(f75 + f74) >= f28;
   i70 = Math_fround(f71 + f66) >= f29;
   i2 = f30 >= Math_fround(f77 - f76);
   i4 = f31 >= Math_fround(f75 - f74);
   i69 = f32 >= Math_fround(f71 - f66);
   f66 = Math_fround(-f67);
   f7 = Math_fround(-f6);
   f71 = Math_fround(-f72);
   if (!(f73 >= (f72 > f71 ? f72 : f71) & (i70 & i69) & (f68 >= (f67 > f66 ? f67 : f66) & (i65 & i2) & (f5 >= (f6 > f7 ? f6 : f7) & (i3 & i4))))) break;
   i2 = i8 + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!((i3 & 1 | 0) == 0 & 0 == 0)) {
    i64 = 5;
    break;
   }
   i2 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   i2 = i2 & 524287;
   i8 = i33 + (i2 * 24 | 0) | 0;
   HEAP32[i57 + (i1 << 2) >> 2] = i33 + ((i2 + 1 | 0) * 24 | 0);
   i65 = HEAP32[i8 >> 2] | 0;
   i69 = HEAP32[i33 + (i2 * 24 | 0) + 4 >> 2] | 0;
   i70 = HEAP32[i33 + (i2 * 24 | 0) + 8 >> 2] | 0;
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i33 + (i2 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   i2 = i65;
   i3 = i69;
   i4 = i70;
   f5 = Math_fround(Math_fround(i65 & 255 | 0) * f7);
   f6 = Math_fround(Math_fround(i69 & 255 | 0) * f7);
   f7 = Math_fround(Math_fround(i70 & 255 | 0) * f7);
   i1 = i1 + 1 | 0;
  }
  if ((i64 | 0) == 5) {
   i64 = 0;
   i69 = HEAP32[i61 >> 2] | 0;
   i70 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   if (!(mftCall_iiiii(HEAP32[HEAP32[i62 >> 2] >> 2] | 0, i62 | 0, i58 | 0, i59 + (HEAP32[i69 + ((i70 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
    i1 = 0;
    i64 = 8;
    break;
   }
  }
  if (!i1) {
   i1 = 1;
   i64 = 8;
   break;
  }
 }
 if ((i64 | 0) == 8) {
  STACKTOP = i63;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Sc8ClothSim17addCollisionPlaneEPKNS0_8ShapeSimE(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 104 | 0;
 i1 = i13 + 76 | 0;
 i2 = i13 + 48 | 0;
 i9 = i13 + 32 | 0;
 i4 = i13 + 24 | 0;
 i8 = i13 + 16 | 0;
 i5 = i13 + 8 | 0;
 i6 = HEAP32[i11 + 52 >> 2] | 0;
 i7 = i11 + 92 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i6 + 80 >> 2] | 0) | 0;
 if (i3 >>> 0 > 31) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 289, gb + 719740 | 0, i13);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i14 = (HEAP32[i11 + 84 >> 2] | 0) + (HEAP32[i11 + 88 >> 2] | 0) | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i1, i6);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i2, i12);
 f17 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f25 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f29 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f24 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f28 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f27 = Math_fround(f27 * Math_fround(2.0));
 f24 = Math_fround(f24 * Math_fround(2.0));
 f28 = Math_fround(Math_fround(f28 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f29 * f29) + Math_fround(-.5));
 f21 = Math_fround(Math_fround(Math_fround(f27 * f17) + Math_fround(f24 * f18)) + Math_fround(f28 * f25));
 f20 = Math_fround(Math_fround(f21 * f17) + Math_fround(Math_fround(f26 * f27) + Math_fround(f29 * Math_fround(Math_fround(f28 * f18) - Math_fround(f24 * f25)))));
 f16 = Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f26 * f24) + Math_fround(f29 * Math_fround(Math_fround(f27 * f25) - Math_fround(f28 * f17)))));
 f21 = Math_fround(Math_fround(Math_fround(f26 * f28) + Math_fround(f29 * Math_fround(Math_fround(f24 * f17) - Math_fround(f27 * f18)))) + Math_fround(f21 * f25));
 f27 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(f29 * f27);
 f28 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f28 * f17));
 f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f26 * f18));
 f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f24 = Math_fround(f24 - Math_fround(f19 * f25));
 f23 = Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(Math_fround(f28 * f18) + Math_fround(f29 * f19))) - Math_fround(f26 * f17));
 f22 = Math_fround(Math_fround(Math_fround(f19 * f17) + Math_fround(Math_fround(f28 * f25) + Math_fround(f29 * f26))) - Math_fround(f27 * f18));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * f17)) - Math_fround(f19 * f18)) - Math_fround(f26 * f25));
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f18 = Math_fround(f23 * Math_fround(0.0));
 f19 = Math_fround(f22 * Math_fround(0.0));
 f17 = Math_fround(f19 + Math_fround(Math_fround(f24 * Math_fround(2.0)) + f18));
 f19 = Math_fround(Math_fround(f24 * f17) + Math_fround(Math_fround(f26 * Math_fround(2.0)) + Math_fround(f25 * Math_fround(f18 - f19))));
 f26 = Math_fround(f26 * Math_fround(0.0));
 f24 = Math_fround(f24 * Math_fround(0.0));
 f18 = Math_fround(Math_fround(f26 + Math_fround(f25 * Math_fround(Math_fround(f22 * Math_fround(2.0)) - f24))) + Math_fround(f23 * f17));
 f17 = Math_fround(Math_fround(f26 + Math_fround(f25 * Math_fround(f24 - Math_fround(f23 * Math_fround(2.0))))) + Math_fround(f22 * f17));
 f16 = Math_fround(Math_fround(0.0) - Math_fround(Math_fround(f21 * f17) + Math_fround(Math_fround(f20 * f19) + Math_fround(f16 * f18))));
 HEAPF32[i9 >> 2] = f19;
 HEAPF32[i9 + 4 >> 2] = f18;
 HEAPF32[i9 + 8 >> 2] = f17;
 HEAPF32[i9 + 12 >> 2] = f16;
 i2 = i6 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i4 + 4 >> 2] = i9 + 16;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 mftCall_viiii(i15 | 0, i1 | 0, i10 | 0, i3 | 0, i3 | 0);
 i1 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i6 + 84 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = 1 << i3;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i5 + 4 >> 2] = i8 + 4;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 mftCall_viiii(i2 | 0, i3 | 0, i10 | 0, i1 | 0, i1 | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 1;
 i5 = i14 + i5 | 0;
 i1 = i11 + 116 | 0;
 HEAP32[i10 >> 2] = 0;
 i3 = i11 + 120 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i11 + 124 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i10) | 0;
  i4 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i15 = HEAP32[i4 >> 2] | 0;
  HEAP32[i15 + (i1 << 2) >> 2] = HEAP32[i15 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i15 = i1;
   i1 = i2;
   i2 = i15;
  } else break;
 }
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = i12;
 i15 = 1;
 STACKTOP = i13;
 return i15 | 0;
}

function __ZN17ArchiveFileSystemC2EPKc(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i12 + 8 | 0;
 HEAP32[i9 >> 2] = gb + 70492 + 8;
 i2 = i9 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = i1;
 i5 = _strlen(i4) | 0;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
  i1 = HEAP32[i9 + 16 >> 2] | 0;
  i6 = 4;
 } else if (i5 >>> 0 < 11) {
  i3 = i2 + 11 | 0;
  HEAP8[i3 >> 0] = i5;
  if (!i5) {
   i1 = i2;
   i8 = i3;
  } else {
   i1 = i2;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i3 = i5 + 16 & -16;
  HEAP32[i10 >> 2] = 54;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 + 12 >> 2] = i3 | -2147483648;
  HEAP32[i9 + 8 >> 2] = i5;
  i3 = i2 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  i8 = i3;
 }
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i6 = i10;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i9 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP8[i9 + 48 >> 0] = 0;
 HEAP8[i9 + 49 >> 0] = 0;
 i1 = i9 + 52 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i9 + 68 | 0;
 i7 = i9 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i9 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i9 + 88 >> 2] = 0;
 HEAP32[i9 + 92 >> 2] = 0;
 i7 = i9 + 40 | 0;
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 32;
 HEAP32[i9 + 100 >> 2] = 0;
 HEAP32[i9 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f13 = Math_fround((HEAP32[i1 >> 2] | 0) >>> 0);
 HEAP32[i9 + 108 >> 2] = ~~Math_fround(f13 * Math_fround(.5)) >>> 0;
 HEAP32[i9 + 104 >> 2] = ~~Math_fround(f13 * Math_fround(.200000003)) >>> 0;
 HEAP8[i9 + 112 >> 0] = 0;
 HEAP32[i9 + 124 >> 2] = 0;
 HEAP32[i9 + 128 >> 2] = 0;
 HEAP32[i9 + 120 >> 2] = i9 + 124;
 HEAP32[i9 + 140 >> 2] = 0;
 HEAP32[i9 + 144 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 148 >> 2] = 0;
 HEAP32[i9 + 136 >> 2] = i9 + 140;
 HEAP32[i9 + 152 >> 2] = 0;
 HEAP32[i9 + 156 >> 2] = 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i6 = i1 << 24 >> 24 < 0;
 if (i6) i3 = HEAP32[i9 + 8 >> 2] | 0; else i3 = i1 & 255;
 do if (i3 | 0) {
  if (i6) {
   i3 = HEAP32[i9 + 8 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
  } else {
   i3 = i1 & 255;
   i4 = i2;
  }
  if ((HEAP8[i4 + (i3 + -1) >> 0] | 0) == 47) {
   if (i6) {
    i4 = HEAP32[i9 + 8 >> 2] | 0;
    i3 = i4;
   } else {
    i3 = i1 & 255;
    i4 = i1 & 255;
   }
   i3 = i3 + -1 | 0;
   if (i3 >>> 0 <= i4 >>> 0) if (i6) {
    HEAP8[(HEAP32[i2 >> 2] | 0) + i3 >> 0] = 0;
    HEAP32[i9 + 8 >> 2] = i3;
    break;
   } else {
    HEAP8[i2 + i3 >> 0] = 0;
    HEAP8[i8 >> 0] = i3;
    break;
   }
   i5 = i3 - i4 | 0;
   if (i5 | 0) {
    if (i6) {
     i3 = (HEAP32[i9 + 12 >> 2] & 2147483647) + -1 | 0;
     i4 = HEAP32[i9 + 8 >> 2] | 0;
    } else {
     i3 = 10;
     i4 = i1 & 255;
    }
    if ((i3 - i4 | 0) >>> 0 < i5 >>> 0) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj(i2, i3, i5 - i3 + i4 | 0, i4, i4, 0, 0);
     i1 = HEAP8[i8 >> 0] | 0;
    }
    if (i1 << 24 >> 24 < 0) i2 = HEAP32[i2 >> 2] | 0;
    _memset(i2 + i4 | 0, 0, i5 | 0) | 0;
    i1 = i4 + i5 | 0;
    if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i9 + 8 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
    HEAP8[i2 + i1 >> 0] = 0;
   }
  }
 } while (0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i11 + 11 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP8[i11 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE13set_empty_keyERSF_(i7, i11);
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 54;
  HEAP32[i10 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i11 + 11 | 0;
 HEAP8[i9 >> 0] = 2;
 HEAP16[i11 >> 1] = 15932;
 HEAP8[i11 + 2 >> 0] = 0;
 __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE15set_deleted_keyERSF_(i7, i11);
 if ((HEAP8[i9 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 54;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN5physx2Gu17pcmContactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i22, i23, i24, i15, i1, i14) {
 i2 = i2 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i25 + 320 | 0;
 i16 = i25 + 760 | 0;
 i19 = i25 + 688 | 0;
 i18 = i25 + 616 | 0;
 i20 = i25 + 144 | 0;
 i13 = i25 + 160 | 0;
 i12 = i25 + 112 | 0;
 i21 = i25 + 392 | 0;
 i17 = i25 + 64 | 0;
 i11 = i25;
 i8 = HEAP32[i1 >> 2] & -16;
 i9 = i2 + 4 | 0;
 f28 = Math_fround(HEAPF32[i9 >> 2]);
 f31 = Math_fround(-f28);
 i6 = i2 + 8 | 0;
 f27 = Math_fround(HEAPF32[i6 >> 2]);
 f30 = Math_fround(-f27);
 i5 = i2 + 12 | 0;
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 f29 = Math_fround(-f26);
 HEAPF32[i16 >> 2] = f31;
 HEAPF32[i16 + 4 >> 2] = f30;
 HEAPF32[i16 + 8 >> 2] = f29;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i16 + 12 >> 2] = f28;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i16 + 16 >> 2] = f27;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i16 + 20 >> 2] = f26;
 i4 = i22 + 4 | 0;
 if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i22 + 8 >> 2]) == Math_fround(1.0)) i7 = Math_fround(HEAPF32[i22 + 12 >> 2]) == Math_fround(1.0); else i7 = 0; else i7 = 0;
 HEAP32[i19 >> 2] = 1065353216;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 1065353216;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i19 + 24 >> 2] = 0;
 HEAP32[i19 + 28 >> 2] = 0;
 HEAP32[i19 + 32 >> 2] = 1065353216;
 HEAP32[i19 + 36 >> 2] = 1065353216;
 HEAP32[i19 + 40 >> 2] = 0;
 HEAP32[i19 + 44 >> 2] = 0;
 HEAP32[i19 + 48 >> 2] = 0;
 HEAP32[i19 + 52 >> 2] = 1065353216;
 HEAP32[i19 + 56 >> 2] = 0;
 HEAP32[i19 + 60 >> 2] = 0;
 HEAP32[i19 + 64 >> 2] = 0;
 HEAP32[i19 + 68 >> 2] = 1065353216;
 if (!i7) {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i19, i4, i22 + 16 | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i18 >> 2] = 1065353216;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 1065353216;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = 0;
 HEAP32[i18 + 32 >> 2] = 1065353216;
 HEAP32[i18 + 36 >> 2] = 1065353216;
 HEAP32[i18 + 40 >> 2] = 0;
 HEAP32[i18 + 44 >> 2] = 0;
 HEAP32[i18 + 48 >> 2] = 0;
 HEAP32[i18 + 52 >> 2] = 1065353216;
 HEAP32[i18 + 56 >> 2] = 0;
 HEAP32[i18 + 60 >> 2] = 0;
 HEAP32[i18 + 64 >> 2] = 0;
 HEAP32[i18 + 68 >> 2] = 1065353216;
 f29 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f31 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f30 = f29 <= f30 ? f29 : f30;
 f31 = f30 <= f31 ? f30 : f31;
 f30 = Math_fround(f31 * Math_fround(.150000006));
 HEAPF32[i20 >> 2] = f30;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 64 | 0;
 HEAP32[i13 + 80 >> 2] = 3;
 HEAPF32[i13 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i13 + 144 >> 2] = i3;
 HEAP32[i13 + 148 >> 2] = i2;
 HEAP32[i13 + 152 >> 2] = i1;
 HEAPF32[i13 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 16 >> 2] = f30;
 HEAPF32[i13 + 32 >> 2] = Math_fround(f31 * Math_fround(.0500000007));
 i1 = HEAP32[i23 + 4 >> 2] | 0;
 i2 = HEAP32[i23 + 8 >> 2] | 0;
 i3 = HEAP32[i23 + 12 >> 2] | 0;
 i6 = i23 + 16 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i12 + 4 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i2;
 HEAP32[i12 + 12 >> 2] = i3;
 HEAP32[i12 + 16 >> 2] = i4;
 HEAP32[i12 + 20 >> 2] = i5;
 HEAP32[i12 + 24 >> 2] = i6;
 HEAPF32[i12 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i21, i9);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i21, i10);
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i21 = i17 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAPF32[i17 + 20 >> 2] = Math_fround(1.0);
 i21 = i17 + 24 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i11 + 32 >> 2] = i12;
 HEAP32[i11 + 36 >> 2] = i17;
 HEAP32[i11 + 40 >> 2] = i17;
 HEAP8[i11 + 44 >> 0] = 1;
 HEAP32[i11 >> 2] = gb + 84376 + 8;
 HEAP32[i11 + 48 >> 2] = i13;
 i24 = __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE(i10, i11, i20, i16, i22, i23, i24, Math_fround(HEAPF32[i15 >> 2]), i14, i18, i19, 1, i7, i8) | 0;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 56 | 0;
 i13 = i15 + 40 | 0;
 i4 = i15 + 36 | 0;
 i9 = i15 + 12 | 0;
 i8 = i15;
 i5 = i15 + 32 | 0;
 i6 = i15 + 28 | 0;
 i7 = i15 + 24 | 0;
 i1 = __Z16GetBuildSettingsv() | 0;
 i2 = i1 + 64 | 0;
 if ((i2 | 0) != (i10 | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i10, HEAP32[i2 >> 2] | 0, HEAP32[i1 + 68 >> 2] | 0);
 i11 = i10 + 4 | 0;
 if ((HEAP32[i11 >> 2] | 0) != (HEAP32[i10 >> 2] | 0)) {
  i11 = HEAP32[gb + 189480 >> 2] | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i11, _strlen(i11) | 0);
  i11 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  if (!i11) {
   STACKTOP = i15;
   return;
  }
  i11 = HEAP32[gb + 189480 >> 2] | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i11, _strlen(i11) | 0);
  __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9, i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i11 = HEAP8[i9 + 11 >> 0] | 0;
  if (!((i11 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i11 & 255) | 0)) {
   if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i9, 0, -1, gb + 1576256 | 0, 0) | 0) i12 = 25;
  } else i12 = 25;
  if ((i12 | 0) == 25) {
   HEAP32[i8 >> 2] = 0;
   i3 = i8 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi(i9, 44, i8, 0);
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6insertINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISF_E9referenceEEE5valueENS6_IPS1_EEE4typeENS6_IPKS1_EESF_SF_(i10, i4, i13, i14) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) {
     do {
      i14 = i2 + -12 | 0;
      HEAP32[i3 >> 2] = i14;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
      i2 = HEAP32[i3 >> 2] | 0;
     } while ((i2 | 0) != (i1 | 0));
     i1 = HEAP32[i8 >> 2] | 0;
    }
    __ZdlPv(i1);
   }
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[gb + 189476 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i12 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i13 + 11 >> 0] = i3;
  if (!i3) i1 = i13; else {
   i1 = i13;
   i12 = 9;
  }
 } else i12 = 7;
 if ((i12 | 0) == 7) {
  i9 = i3 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i3;
  i12 = 9;
 }
 if ((i12 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i10 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i13);
  i1 = i13 + 11 | 0;
 } else {
  i1 = i13 + 11 | 0;
  i5 = HEAP8[i1 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i13 >> 2] | 0 : i13;
  i5 = i3 ? HEAP32[i13 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 14;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (i5) i12 = 16;
  } else i12 = 14;
  if ((i12 | 0) == 14) {
   i9 = i5 + 16 & -16;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i3;
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i10;
   HEAP32[i2 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i10;
   i12 = 16;
  }
  if ((i12 | 0) == 16) _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i2 + i5 >> 0] = 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i14);
 }
 STACKTOP = i15;
 return;
}

function __ZN18GlslGpuProgramGLES25LoadFromBinaryShaderCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER14ChannelAssignsPKc(i14, i8, i9, i1) {
 i14 = i14 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 16 | 0;
 i10 = i20;
 i19 = i20 + 28 | 0;
 i16 = i20 + 24 | 0;
 i17 = HEAP32[gb + 64016 + 4 >> 2] | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = HEAP32[gb + 64016 >> 2];
 HEAP32[i6 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i6 = i19 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i10);
 i13 = i15;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 i7 = i18;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = i19 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i18);
 HEAP32[i19 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i5 = _fopen(i1, gb + 945625 | 0) | 0;
 do if (!i5) i1 = 0; else {
  if (!(_fseek(i5, 0, 2) | 0)) {
   i4 = _ftell(i5) | 0;
   if ((i4 | 0) != -1) if (!(i4 >>> 0 < 4 | (_fseek(i5, 0, 0) | 0) != 0)) {
    HEAP32[i6 >> 2] = i4;
    i1 = HEAP32[i17 >> 2] | 0;
    do if ((i1 & 2147483647) >>> 0 < i4 >>> 0) if ((i1 | 0) > -1) {
     HEAP32[i17 >> 2] = i4;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i4, 1, i18, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i19 >> 2] = i2;
     break;
    } else {
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i18, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i2 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
     HEAP32[i17 >> 2] = i4;
     HEAP32[i19 >> 2] = i2;
     break;
    } else i2 = HEAP32[i19 >> 2] | 0; while (0);
    i11 = i19 + 28 | 0;
    HEAP32[i11 >> 2] = i2 + 4;
    i12 = i19 + 24 | 0;
    HEAP32[i12 >> 2] = i4 + -4;
    i13 = i19 + 32 | 0;
    HEAP32[i13 >> 2] = i2;
    if (!(_ferror(i5) | 0)) {
     i1 = _fread(i2, i4, 1, i5) | 0;
     L16 : do if (_ferror(i5) | 0) {
      i3 = ___errno_location() | 0;
      do {
       if ((HEAP32[i3 >> 2] | 0) != 4) break L16;
       _clearerr(i5);
       i1 = _fread(i2, i4, 1, i5) | 0;
      } while ((_ferror(i5) | 0) != 0);
     } while (0);
     if ((i1 | 0) == 1) {
      _fclose(i5) | 0;
      i7 = __ZN7ApiGLES13CreateProgramEv(HEAP32[gb + 1451080 >> 2] | 0) | 0;
      HEAP32[i16 >> 2] = i7;
      L23 : do if (!i7) i1 = 0; else {
       L25 : do if (__ZL27BindVertexProgramAttributesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER14ChannelAssignsj(i8, i9, i7) | 0) {
        i6 = HEAP32[gb + 1451080 >> 2] | 0;
        if (HEAP32[i11 >> 2] | 0) {
         i1 = HEAP32[i13 >> 2] | 0;
         if (i1 | 0) {
          i4 = HEAP32[i1 >> 2] | 0;
          HEAP32[i15 >> 2] = 0;
          i2 = i6 + 88 | 0;
          mftCall_vii(HEAP32[i2 >> 2] | 0, 34814, i15 | 0);
          i1 = HEAP32[i15 >> 2] | 0;
          HEAP32[i10 >> 2] = 0;
          i5 = i10 + 4 | 0;
          HEAP32[i5 >> 2] = 0;
          HEAP32[i10 + 8 >> 2] = 0;
          if (!i1) i1 = 0; else {
           if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
           i8 = i1 << 2;
           i9 = __Znwj(i8) | 0;
           HEAP32[i10 >> 2] = i9;
           i1 = i9 + (i1 << 2) | 0;
           HEAP32[i10 + 8 >> 2] = i1;
           _memset(i9 | 0, 0, i8 | 0) | 0;
           HEAP32[i5 >> 2] = i1;
           i1 = i9;
          }
          mftCall_vii(HEAP32[i2 >> 2] | 0, 34815, i1 | 0);
          i2 = HEAP32[i15 >> 2] | 0;
          i3 = HEAP32[i10 >> 2] | 0;
          L35 : do if (!i2) {
           if (i3 | 0) {
            i1 = 0;
            break;
           }
           break L25;
          } else {
           i1 = 0;
           while (1) {
            if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
             i1 = 1;
             break L35;
            }
            i1 = i1 + 1 | 0;
            if (i1 >>> 0 >= i2 >>> 0) {
             i1 = 0;
             break;
            }
           }
          } while (0);
          i2 = HEAP32[i5 >> 2] | 0;
          if ((i2 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
          __ZdlPv(i3);
          if (!i1) break;
          mftCall_viiii(HEAP32[i6 + 228 >> 2] | 0, i7 | 0, HEAP32[HEAP32[i13 >> 2] >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0);
          HEAP32[i15 >> 2] = 0;
          mftCall_viii(HEAP32[i6 + 92 >> 2] | 0, i7 | 0, 35714, i15 | 0);
          if (!(HEAP32[i15 >> 2] | 0)) break;
          HEAP32[i14 + 88 >> 2] = HEAP32[i16 >> 2];
          i1 = 1;
          break L23;
         }
        }
       } while (0);
       __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i16);
       HEAP32[i14 + 88 >> 2] = 0;
       i1 = 0;
      } while (0);
      break;
     }
    };
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    if ((HEAP32[i17 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
     HEAP32[i19 >> 2] = 0;
    }
    HEAP32[i19 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i17 >> 2] = 0;
   }
  }
  _fclose(i5) | 0;
  i1 = 0;
 } while (0);
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i20;
 return i1 | 0;
}

function _UNITY_tt_face_load_font_dir(i19, i23) {
 i19 = i19 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i25 + 40 | 0;
 i16 = i25 + 24 | 0;
 i22 = i25 + 8 | 0;
 i24 = i25;
 i20 = HEAP32[i23 + 28 >> 2] | 0;
 i21 = i22 + 12 | 0;
 HEAP32[i21 >> 2] = _UNITY_FT_Stream_Pos(i23) | 0;
 HEAP32[i22 >> 2] = _UNITY_FT_Stream_ReadULong(i23, i24) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) {
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadFields(i23, gb + 223216 | 0, i22) | 0;
 HEAP32[i24 >> 2] = i1;
 if (i1 | 0) {
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 }
 L7 : do if ((HEAP32[i22 >> 2] | 0) == 1330926671) {
  i2 = HEAP16[i22 + 4 >> 1] | 0;
  i1 = 1330926671;
 } else {
  i2 = HEAP32[i21 >> 2] | 0;
  i1 = _UNITY_FT_Stream_Seek(i23, i2 + 12 | 0) | 0;
  HEAP32[i17 >> 2] = i1;
  do if (!i1) {
   i12 = i22 + 4 | 0;
   if (HEAP16[i12 >> 1] | 0) {
    i13 = i16 + 8 | 0;
    i14 = i23 + 4 | 0;
    i15 = i16 + 12 | 0;
    i11 = i2 + 28 | 0;
    i10 = 0;
    i4 = 0;
    i3 = 0;
    i1 = 0;
    i2 = 0;
    i9 = 0;
    L14 : while (1) {
     i8 = _UNITY_FT_Stream_ReadFields(i23, gb + 223240 | 0, i16) | 0;
     HEAP32[i17 >> 2] = i8;
     if (i8 | 0) {
      i18 = 8;
      break;
     }
     i6 = HEAP32[i13 >> 2] | 0;
     i5 = HEAP32[i14 >> 2] | 0;
     L17 : do if (i5 >>> 0 >= i6 >>> 0) {
      i7 = HEAP32[i15 >> 2] | 0;
      i8 = HEAP32[i16 >> 2] | 0;
      L19 : do if (i7 >>> 0 > (i5 - i6 | 0) >>> 0) if ((i8 | 0) < 1986884728) switch (i8 | 0) {
      case 1752003704:
       break L19;
      default:
       break L17;
      } else switch (i8 | 0) {
      case 1986884728:
       break L19;
      default:
       break L17;
      } while (0);
      i2 = i2 + 1 << 16 >> 16;
      L25 : do if ((i8 | 0) < 1651008868) switch (i8 | 0) {
      case 1397313095:
       {
        i3 = 1;
        break L17;
       }
      default:
       {}
      } else {
       if ((i8 | 0) < 1751474532) switch (i8 | 0) {
       case 1651008868:
        break;
       default:
        break L25;
       } else switch (i8 | 0) {
       case 1751474532:
        break;
       default:
        break L25;
       }
       if (i7 >>> 0 < 54) {
        i18 = 14;
        break L14;
       }
       i1 = _UNITY_FT_Stream_Seek(i23, i6 + 12 | 0) | 0;
       HEAP32[i17 >> 2] = i1;
       if (i1 | 0) {
        i18 = 19;
        break L14;
       }
       _UNITY_FT_Stream_ReadULong(i23, i17) | 0;
       i1 = HEAP32[i17 >> 2] | 0;
       if (i1 | 0) {
        i18 = 19;
        break L14;
       }
       i1 = _UNITY_FT_Stream_Seek(i23, i11 + (i9 << 4) | 0) | 0;
       HEAP32[i17 >> 2] = i1;
       if (!i1) {
        i1 = 1;
        break L17;
       } else {
        i18 = 19;
        break L14;
       }
      } while (0);
      i4 = (i8 | 0) == 1296389185 ? 1 : i4;
     } while (0);
     i5 = i10 + 1 << 16 >> 16;
     if ((i5 & 65535) < (HEAPU16[i12 >> 1] | 0)) {
      i10 = i5;
      i9 = i5 & 65535;
     } else break;
    }
    if ((i18 | 0) == 8) HEAP16[i12 >> 1] = i10 + -1 << 16 >> 16; else if ((i18 | 0) == 14) {
     HEAP32[i17 >> 2] = 142;
     i1 = 142;
     i18 = 19;
    }
    if ((i18 | 0) == 19) break;
    if (i2 << 16 >> 16) {
     if (!i1) if (!((i3 | 0) != 0 & (i4 | 0) != 0)) {
      HEAP32[i17 >> 2] = 142;
      i1 = 142;
      break;
     }
     HEAP32[i24 >> 2] = 0;
     i1 = HEAP32[i22 >> 2] | 0;
     break L7;
    }
   }
   HEAP32[i17 >> 2] = 2;
   i1 = 2;
  } while (0);
  HEAP32[i24 >> 2] = i1;
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 } while (0);
 i12 = i19 + 152 | 0;
 HEAP16[i12 >> 1] = i2;
 HEAP32[i19 + 148 >> 2] = i1;
 i11 = i19 + 156 | 0;
 HEAP32[i11 >> 2] = _UNITY_ft_mem_realloc(i20, 16, 0, i2 & 65535, 0, i24) | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) {
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 }
 i1 = _UNITY_FT_Stream_Seek(i23, (HEAP32[i21 >> 2] | 0) + 12 | 0) | 0;
 HEAP32[i24 >> 2] = i1;
 if (i1 | 0) {
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 }
 i10 = i22 + 4 | 0;
 i1 = _UNITY_FT_Stream_EnterFrame(i23, HEAPU16[i10 >> 1] << 4) | 0;
 HEAP32[i24 >> 2] = i1;
 if (i1 | 0) {
  i24 = i1;
  STACKTOP = i25;
  return i24 | 0;
 }
 if (!(HEAP16[i10 >> 1] | 0)) i1 = 0; else {
  i9 = i23 + 4 | 0;
  i8 = 0;
  i1 = 0;
  do {
   i5 = _UNITY_FT_Stream_GetULong(i23) | 0;
   i6 = _UNITY_FT_Stream_GetULong(i23) | 0;
   i7 = _UNITY_FT_Stream_GetULong(i23) | 0;
   i4 = _UNITY_FT_Stream_GetULong(i23) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   L65 : do if (i2 >>> 0 >= i7 >>> 0) {
    i2 = i2 - i7 | 0;
    if (i4 >>> 0 > i2 >>> 0) {
     if ((i5 | 0) < 1986884728) switch (i5 | 0) {
     case 1752003704:
      break;
     default:
      break L65;
     } else switch (i5 | 0) {
     case 1986884728:
      break;
     default:
      break L65;
     }
     i4 = i2 & -4;
    }
    i3 = HEAP32[i11 >> 2] | 0;
    if (i1 << 16 >> 16) {
     i2 = 0;
     do {
      if ((HEAP32[i3 + ((i2 & 65535) << 4) >> 2] | 0) == (i5 | 0)) break L65;
      i2 = i2 + 1 << 16 >> 16;
     } while ((i2 & 65535) < (i1 & 65535));
    }
    i22 = i1 & 65535;
    HEAP32[i3 + (i22 << 4) >> 2] = i5;
    HEAP32[i3 + (i22 << 4) + 4 >> 2] = i6;
    HEAP32[i3 + (i22 << 4) + 8 >> 2] = i7;
    HEAP32[i3 + (i22 << 4) + 12 >> 2] = i4;
    i1 = i1 + 1 << 16 >> 16;
   } while (0);
   i8 = i8 + 1 << 16 >> 16;
  } while ((i8 & 65535) < (HEAPU16[i10 >> 1] | 0));
 }
 HEAP16[i12 >> 1] = i1;
 _UNITY_FT_Stream_ExitFrame(i23);
 i24 = HEAP32[i24 >> 2] | 0;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNKSt3__220__time_get_c_storageIcE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if (!(HEAP8[gb + 1099856 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099856 | 0) | 0) {
  if (!(HEAP8[gb + 1099864 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099864 | 0) | 0) {
   i2 = gb + 1474968 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1474968 + 288 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1149 | 0, gb + 1474968 | 0, gb + 1078506 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  do if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, gb + 1474968 + 12 | 0, gb + 1078514 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, gb + 1474968 + 24 | 0, gb + 1078523 | 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_iii(fb + 1149 | 0, gb + 1474968 + 36 | 0, gb + 1078529 | 0) | 0;
     i2 = __THREW__;
     __THREW__ = 0;
     if (!(i2 & 1)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, gb + 1474968 + 48 | 0, gb + 1078535 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (!(i2 & 1)) {
       __THREW__ = 0;
       invoke_iii(fb + 1149 | 0, gb + 1474968 + 60 | 0, gb + 1078539 | 0) | 0;
       i2 = __THREW__;
       __THREW__ = 0;
       if (!(i2 & 1)) {
        __THREW__ = 0;
        invoke_iii(fb + 1149 | 0, gb + 1474968 + 72 | 0, gb + 1078544 | 0) | 0;
        i2 = __THREW__;
        __THREW__ = 0;
        if (!(i2 & 1)) {
         __THREW__ = 0;
         invoke_iii(fb + 1149 | 0, gb + 1474968 + 84 | 0, gb + 1078549 | 0) | 0;
         i2 = __THREW__;
         __THREW__ = 0;
         if (!(i2 & 1)) {
          __THREW__ = 0;
          invoke_iii(fb + 1149 | 0, gb + 1474968 + 96 | 0, gb + 1078556 | 0) | 0;
          i2 = __THREW__;
          __THREW__ = 0;
          if (!(i2 & 1)) {
           __THREW__ = 0;
           invoke_iii(fb + 1149 | 0, gb + 1474968 + 108 | 0, gb + 1078566 | 0) | 0;
           i2 = __THREW__;
           __THREW__ = 0;
           if (!(i2 & 1)) {
            __THREW__ = 0;
            invoke_iii(fb + 1149 | 0, gb + 1474968 + 120 | 0, gb + 1078574 | 0) | 0;
            i2 = __THREW__;
            __THREW__ = 0;
            if (!(i2 & 1)) {
             __THREW__ = 0;
             invoke_iii(fb + 1149 | 0, gb + 1474968 + 132 | 0, gb + 1078583 | 0) | 0;
             i2 = __THREW__;
             __THREW__ = 0;
             if (!(i2 & 1)) {
              __THREW__ = 0;
              invoke_iii(fb + 1149 | 0, gb + 1474968 + 144 | 0, gb + 1078592 | 0) | 0;
              i2 = __THREW__;
              __THREW__ = 0;
              if (!(i2 & 1)) {
               __THREW__ = 0;
               invoke_iii(fb + 1149 | 0, gb + 1474968 + 156 | 0, gb + 1078596 | 0) | 0;
               i2 = __THREW__;
               __THREW__ = 0;
               if (!(i2 & 1)) {
                __THREW__ = 0;
                invoke_iii(fb + 1149 | 0, gb + 1474968 + 168 | 0, gb + 1078600 | 0) | 0;
                i2 = __THREW__;
                __THREW__ = 0;
                if (!(i2 & 1)) {
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 180 | 0, gb + 1078604 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 192 | 0, gb + 1078535 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 204 | 0, gb + 1078608 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 216 | 0, gb + 1078612 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 228 | 0, gb + 1078616 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 240 | 0, gb + 1078620 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 252 | 0, gb + 1078624 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 264 | 0, gb + 1078628 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1149 | 0, gb + 1474968 + 276 | 0, gb + 1078632 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 HEAP32[gb + 1475256 >> 2] = gb + 1474968;
                 break L1;
                }
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  } while (0);
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1475256 >> 2] | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 49;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 24 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 176;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj49ENS0_26PxPvdRangePropertyAccessorILj49ES4_jEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 180;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj49ENS0_26PxPvdRangePropertyAccessorILj49ES4_jEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZN7mecanim12statemachine13EvaluateStateERKNS_18ValueArrayConstantERKNS0_13StateConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_11StateOutputERNS0_14StateWorkspaceEbb(i4, i12, i11, i10, i30, i31, i1, i9, i8) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var f2 = f0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i7 = i30 + 36 | 0;
 i27 = i9 ? i30 + 32 | 0 : i7;
 i28 = i9 ? i30 + 40 | 0 : i30 + 44 | 0;
 i29 = i9 ? i30 + 52 | 0 : i30 + 56 | 0;
 f6 = Math_fround(__ZN7mecanim12statemachine21DoBlendTreeEvaluationERKNS0_13StateConstantERNS0_11StateOutputERNS0_14StateWorkspaceERKNS_18ValueArrayConstantERKNS0_17StateMachineInputEb(i12, i31, i1, i4, i11, i9));
 i3 = f6 != Math_fround(0.0);
 f6 = i3 ? f6 : Math_fround(1.0);
 i3 = HEAP32[i11 + 16 >> 2] | 0;
 i1 = HEAP32[i12 + 40 >> 2] | 0;
 if (!i1) f2 = Math_fround(1.0); else {
  i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i4, i1) | 0;
  if ((i1 | 0) > -1) {
   i25 = i4 + 4 | 0;
   i24 = i3 + 28 | 0;
   f2 = Math_fround(HEAPF32[(HEAP32[i24 >> 2] | 0) + i24 + (HEAP32[(HEAP32[i25 >> 2] | 0) + i25 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2]);
  } else f2 = Math_fround(1.0);
 }
 HEAPF32[i29 >> 2] = f2;
 i25 = i12 + 52 | 0;
 f2 = Math_fround(f2 * Math_fround(Math_abs(Math_fround(HEAPF32[i25 >> 2]))));
 f2 = Math_fround(Math_fround(HEAPF32[i11 + 12 >> 2]) * f2);
 if (f2 != Math_fround(0.0)) f5 = Math_fround(f6 / Math_fround(Math_abs(Math_fround(f2)))); else f5 = Math_fround(inf);
 HEAPF32[i28 >> 2] = f5;
 f2 = Math_fround(Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2])) / f6);
 i1 = i30 + 83 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i26 = 9; else {
  i3 = HEAP32[i11 + 24 >> 2] | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   i24 = i3 + 16 | 0;
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i24 >> 2]) / f5));
   HEAPF32[i27 >> 2] = Math_fround(f6 - f2);
   HEAP8[i1 >> 0] = 0;
   HEAPF32[i24 >> 2] = Math_fround(0.0);
   f2 = f6;
  } else i26 = 9;
 }
 do if ((i26 | 0) == 9) if (i8) {
  f6 = Math_fround(HEAPF32[i7 >> 2]);
  i24 = (HEAP32[i11 + 24 >> 2] | 0) + 16 | 0;
  f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i24 >> 2]) / f5));
  HEAPF32[i27 >> 2] = Math_fround(f6 - f2);
  HEAPF32[i24 >> 2] = Math_fround(0.0);
  f2 = f6;
  break;
 } else {
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i27 >> 2]));
  break;
 } while (0);
 i21 = i12 + 8 | 0;
 if (!(HEAP32[i21 >> 2] | 0)) {
  HEAPF32[i27 >> 2] = f2;
  return;
 }
 i22 = i12 + 12 | 0;
 i23 = i22;
 i24 = i31 + 4 | 0;
 i19 = i9 & 1 ^ 1;
 i20 = i12 + 61 | 0;
 i18 = i10 + 16 | 0;
 i16 = i11 + 28 | 0;
 i17 = i12 + 60 | 0;
 i14 = i12 + 20 | 0;
 i15 = i14;
 i13 = 0;
 do {
  i1 = HEAP32[(HEAP32[i22 >> 2] | 0) + i23 + (i13 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i3 = 0; else {
   i12 = (HEAP32[i14 >> 2] | 0) + i15 + (i1 << 2) | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i3 = (i3 | 0) == 0 ? 0 : i12 + i3 | 0;
  }
  i12 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[i24 >> 2] | 0) + (i13 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + (i19 << 3) + 4 >> 2] | 0;
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  i11 = i1 + 16 | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i3) {
   i1 = i1 + -1 | 0;
   if (!(HEAP8[i20 >> 0] | 0)) i26 = 31; else i26 = 32;
  } else {
   i1 = i1 + -1 | 0;
   if (!i1) i3 = 0; else {
    i9 = 0;
    i10 = 0;
    do {
     i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 3) + 4 >> 2] | 0;
     i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0) | 0;
     if (!i3) i26 = 24; else if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 65780 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 65780 + 28 >> 2] | 0) >>> 0) i26 = 24;
     if ((i26 | 0) == 24) {
      i26 = 0;
      i3 = 0;
     }
     i4 = HEAP32[i11 >> 2] | 0;
     i8 = Math_fround(HEAPF32[i4 + (i9 << 3) >> 2]) > Math_fround(0.0);
     i10 = i8 & 1 | i10 & 255;
     if (i3 | 0) {
      i4 = HEAP32[i4 + (i9 << 3) + 4 >> 2] | 0;
      i7 = i4 + 120 | 0;
      if (!((HEAP32[i7 >> 2] & 128 | 0) == 0 | i8 ^ 1)) HEAP32[i7 >> 2] = (HEAP32[i16 >> 2] | 0) == 1 ? 25 : 28;
      HEAP8[i4 + 172 >> 0] = HEAP8[i17 >> 0] | 0;
      HEAPF32[i4 + 96 >> 2] = Math_fround(f2 * Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0)));
      f6 = Math_fround(HEAPF32[i27 >> 2]);
      HEAPF32[i4 + 100 >> 2] = Math_fround(f6 * Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0)));
      HEAP32[i4 + 124 >> 2] = i30;
      HEAP32[i4 + 116 >> 2] = HEAP32[i16 >> 2];
      HEAP8[i4 + 113 >> 0] = HEAP8[i20 >> 0] | 0;
      HEAPF32[i4 + 140 >> 2] = f2;
      HEAP32[i4 + 144 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i4 + 148 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i4 + 152 >> 2] = HEAP32[i29 >> 2];
     }
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i1 | 0));
    i3 = i10 & 255;
   }
   if (!((i3 | HEAP8[i20 >> 0]) << 24 >> 24)) i26 = 31; else i26 = 32;
  }
  if ((i26 | 0) == 31) {
   i26 = 0;
   i11 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
   __ZN8Playable14SetInputWeightEif(i12, i1, Math_fround(1.0));
   HEAP8[i11 + 80 >> 0] = 1;
   i1 = 1;
  } else if ((i26 | 0) == 32) {
   i26 = 0;
   __ZN8Playable14SetInputWeightEif(i12, i1, Math_fround(0.0));
   i1 = 0;
  }
  HEAP8[i18 >> 0] = i1;
  i1 = HEAP32[i31 >> 2] | 0;
  if (HEAP32[i1 >> 2] & 128 | 0) HEAP32[i1 >> 2] = (HEAP32[i16 >> 2] | 0) == 1 ? 25 : 28;
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i21 >> 2] | 0) >>> 0);
 HEAPF32[i27 >> 2] = f2;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i13, i8, i1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 24 | 0;
 i12 = i14 + 8 | 0;
 HEAP32[i1 >> 2] = 87;
 i11 = HEAP32[i13 + 24 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? i1 : i11;
 i1 = HEAP32[i13 + 28 >> 2] | 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i10;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i12 + 12 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 20;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj87ENS0_26PxPvdRangePropertyAccessorILj87ES4_jEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i3 = 0;
  i4 = i10;
 } else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if (!i5) {
   i3 = 0;
   i4 = i10;
  } else {
   i3 = i5 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i13 + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = i3;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    i4 = i10;
   } else {
    i3 = i5;
    i4 = i10;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i10;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i4) | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i6 >> 2] = i9 + 24;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj87ENS0_26PxPvdRangePropertyAccessorILj87ES4_jEEEEvjRKT0_(i13, HEAP32[i11 >> 2] | 0, i12);
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb1EE4initEPKc(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i4 = i7;
 i9 = _newlocale(2147483647, i1, 0) | 0;
 i10 = (i9 | 0) == 0;
 L1 : do if (i10) {
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i7 = _strlen(i1) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i4 | 0, i1 | 0, i7 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i4 | 0, 0, gb + 1081806 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i8 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } else {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2805 | 0, i9 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  do if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i5 = invoke_i(fb + 318 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (!i2) break;
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (!(i4 & 1)) break;
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   }
   if (i2 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i4 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i4);
    }
   }
   i4 = HEAP8[HEAP32[i5 + 20 >> 2] >> 0] | 0;
   HEAP8[i6 + 8 >> 0] = i4 << 24 >> 24 == 0 ? 127 : i4;
   i4 = HEAP8[HEAP32[i5 + 24 >> 2] >> 0] | 0;
   HEAP8[i6 + 9 >> 0] = i4 << 24 >> 24 == 0 ? 127 : i4;
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, i6 + 12 | 0, HEAP32[i5 + 28 >> 2] | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   do if (!(i4 & 1)) {
    i3 = i6 + 24 | 0;
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, i3 | 0, HEAP32[i5 + 12 >> 2] | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (!(i4 & 1)) {
     i4 = HEAP8[i5 + 40 >> 0] | 0;
     HEAP32[i6 + 60 >> 2] = i4 << 24 >> 24 == 127 ? 0 : i4 << 24 >> 24;
     i4 = i5 + 52 | 0;
     i1 = i6 + 36 | 0;
     if (!(HEAP8[i4 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, gb + 1081849 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) break;
     } else {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, HEAP32[i5 + 32 >> 2] | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) break;
     }
     i1 = i5 + 53 | 0;
     i2 = i6 + 48 | 0;
     if (!(HEAP8[i1 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i2 | 0, gb + 1081849 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) break;
     } else {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i2 | 0, HEAP32[i5 + 36 >> 2] | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4529 | 0, i8 | 0, i3 | 0);
     i2 = __THREW__;
     __THREW__ = 0;
     if (!(i2 & 1)) {
      i2 = HEAP16[i5 + 48 >> 1] | 0;
      __THREW__ = 0;
      invoke_viiiiii(fb + 203 | 0, i6 + 64 | 0, i8 | 0, 1, i2 & 255 | 0, (i2 & 65535) >>> 8 & 255 | 0, HEAP8[i4 >> 0] | 0);
      i4 = __THREW__;
      __THREW__ = 0;
      if (!(i4 & 1)) {
       i5 = HEAP16[i5 + 50 >> 1] | 0;
       __THREW__ = 0;
       invoke_viiiiii(fb + 203 | 0, i6 + 68 | 0, i3 | 0, 1, i5 & 255 | 0, (i5 & 65535) >>> 8 & 255 | 0, HEAP8[i1 >> 0] | 0);
       i6 = __THREW__;
       __THREW__ = 0;
       if (!(i6 & 1)) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
        __THREW__ = 0;
        invoke_vi(fb + 4002 | 0, i9 | 0);
        i6 = __THREW__;
        __THREW__ = 0;
        if (i6 & 1) {
         i7 = ___cxa_find_matching_catch_3(0) | 0;
         getTempRet0() | 0;
         ___clang_call_terminate(i7);
        } else {
         STACKTOP = i7;
         return;
        }
       }
      }
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
      break L1;
     }
    }
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break L1;
  } while (0);
 } while (0);
 if (!i10) {
  __THREW__ = 0;
  invoke_vi(fb + 4002 | 0, i9 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i10 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i10);
  }
 }
 ___resumeException(i1 | 0);
}

function __Z21PlayerStartFirstSceneb(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 64 | 0;
 i11 = i12 + 48 | 0;
 i8 = i12 + 32 | 0;
 i9 = i12 + 16 | 0;
 i7 = i12;
 i1 = __Z15GetSceneManagerv() | 0;
 i2 = i1 + 68 | 0;
 i3 = i1 + 84 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 72 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN11TimeManager9ResetTimeEb(__Z14GetTimeManagerv() | 0, 1);
 i1 = HEAP32[(__Z16GetBuildSettingsv() | 0) + 28 >> 2] | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i2 = i6 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = i6 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i5 = 6;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i5 = 8;
  }
 } else i5 = 6;
 if ((i5 | 0) == 6) {
  i6 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i5 = 8;
 }
 if ((i5 | 0) == 8) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 if (i4) {
  HEAP32[i8 >> 2] = 0;
  i1 = __Z15GetSceneManagerv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i3 = i9 + 11 | 0;
  HEAP8[i3 >> 0] = 6;
  HEAP8[i9 >> 0] = HEAP8[gb + 583666 >> 0] | 0;
  HEAP8[i9 + 1 >> 0] = HEAP8[gb + 583666 + 1 >> 0] | 0;
  HEAP8[i9 + 2 >> 0] = HEAP8[gb + 583666 + 2 >> 0] | 0;
  HEAP8[i9 + 3 >> 0] = HEAP8[gb + 583666 + 3 >> 0] | 0;
  HEAP8[i9 + 4 >> 0] = HEAP8[gb + 583666 + 4 >> 0] | 0;
  HEAP8[i9 + 5 >> 0] = HEAP8[gb + 583666 + 5 >> 0] | 0;
  HEAP8[i9 + 6 >> 0] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 + 12 >> 2] = i2;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = -2147483616;
  HEAP32[i7 + 4 >> 2] = 20;
  i4 = i2;
  i5 = gb + 583673 | 0;
  i6 = i4 + 20 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  HEAP8[i2 + 20 >> 0] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  i1 = __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene(i1, i11, i9, i7, i10, 0, 2, 0, i8) | 0;
  if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
  }
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
  }
 } else {
  i1 = __Z15GetSceneManagerv() | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = 6;
  HEAP8[i8 >> 0] = HEAP8[gb + 583666 >> 0] | 0;
  HEAP8[i8 + 1 >> 0] = HEAP8[gb + 583666 + 1 >> 0] | 0;
  HEAP8[i8 + 2 >> 0] = HEAP8[gb + 583666 + 2 >> 0] | 0;
  HEAP8[i8 + 3 >> 0] = HEAP8[gb + 583666 + 3 >> 0] | 0;
  HEAP8[i8 + 4 >> 0] = HEAP8[gb + 583666 + 4 >> 0] | 0;
  HEAP8[i8 + 5 >> 0] = HEAP8[gb + 583666 + 5 >> 0] | 0;
  HEAP8[i8 + 6 >> 0] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 + 12 >> 2] = i3;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 8 >> 2] = -2147483616;
  HEAP32[i9 + 4 >> 2] = 20;
  i4 = i3;
  i5 = gb + 583673 | 0;
  i6 = i4 + 20 | 0;
  do {
   HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i4 | 0) < (i6 | 0));
  HEAP8[i3 + 20 >> 0] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  __ZN19RuntimeSceneManager9LoadSceneERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeE(i1, i11, i8, i9, i10, 0, 2) | 0;
  if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i10);
  }
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   i9 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i10 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i1 = 0;
 }
 if ((HEAP8[i11 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN19SkinnedMeshRenderer8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i5 = i6 + 460 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429171 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 464 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429181 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 465 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429203 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 352 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048075 | 0, gb + 1048082 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 360 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429226 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 416 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429234 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 380 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429254 | 0, gb + 842702 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 436 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429265 | 0, gb + 1034406 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 466 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 429272 | 0, i4, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe(i1, i13, i14, i5, i6, i15, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 24 | 0;
 i11 = i16;
 i1 = i16 + 140 | 0;
 i18 = i16 + 16 | 0;
 i10 = i16 + 12 | 0;
 i17 = i16 + 8 | 0;
 i7 = i16 + 136 | 0;
 i3 = i16 + 4 | 0;
 i9 = i16 + 36 | 0;
 HEAP32[i18 >> 2] = i1;
 i19 = i18 + 4 | 0;
 HEAP32[i19 >> 2] = fb + 4003;
 i4 = i1 + 100 | 0;
 __THREW__ = 0;
 i2 = invoke_ii(fb + 2804 | 0, i6 | 0) | 0;
 i22 = __THREW__;
 __THREW__ = 0;
 if (i22 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  HEAP32[i18 >> 2] = 0;
  i3 = fb + 4003 | 0;
  i21 = 52;
 } else {
  HEAP32[i17 >> 2] = i2;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i17 | 0, gb + 1474556 | 0) | 0;
  i22 = __THREW__;
  __THREW__ = 0;
  if (i22 & 1) {
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   HEAP8[i7 >> 0] = 0;
   HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   __THREW__ = 0;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   i1 = invoke_iiiiiiiiiiii(fb + 1 | 0, i13 | 0, i8 | 0, i5 | 0, i17 | 0, i1 | 0, i15 | 0, i7 | 0, i2 | 0, i18 | 0, i10 | 0, i4 | 0) | 0;
   i22 = __THREW__;
   __THREW__ = 0;
   L7 : do if (i22 & 1) i21 = 11; else {
    L9 : do if (i1) {
     __THREW__ = 0;
     invoke_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, gb + 1079842 | 0, gb + 1079842 + 10 | 0, i8 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
     } else {
      i1 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0;
      if ((i1 | 0) > 98) {
       i1 = _malloc(i1 + 2 | 0) | 0;
       i2 = i1;
       if (!i1) {
        __THREW__ = 0;
        invoke_v(fb + 459 | 0);
        i22 = __THREW__;
        __THREW__ = 0;
        if (!(i22 & 1)) {
         i1 = 0;
         i21 = 16;
        }
       } else i21 = 16;
      } else {
       i1 = i9;
       i2 = 0;
       i21 = 16;
      }
      do if ((i21 | 0) == 16) {
       if (HEAP8[i7 >> 0] | 0) {
        HEAP8[i1 >> 0] = 45;
        i1 = i1 + 1 | 0;
       }
       i6 = i8 + 10 | 0;
       i7 = i8;
       i5 = HEAP32[i18 >> 2] | 0;
       while (1) {
        if (i5 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break;
        i4 = HEAP8[i5 >> 0] | 0;
        i3 = i8;
        while (1) {
         if ((i3 | 0) == (i6 | 0)) {
          i3 = i6;
          break;
         }
         if ((HEAP8[i3 >> 0] | 0) == i4 << 24 >> 24) break;
         i3 = i3 + 1 | 0;
        }
        HEAP8[i1 >> 0] = HEAP8[i3 - i7 + (gb + 1079842) >> 0] | 0;
        i5 = i5 + 1 | 0;
        i1 = i1 + 1 | 0;
       }
       HEAP8[i1 >> 0] = 0;
       HEAP32[i11 >> 2] = i12;
       if ((_sscanf(i9, gb + 1084519 | 0, i11) | 0) != 1) {
        __THREW__ = 0;
        invoke_vi(fb + 4004 | 0, gb + 1079853 | 0);
        i22 = __THREW__;
        __THREW__ = 0;
        if (i22 & 1) break;
       }
       if (i2 | 0) _free(i2);
       break L9;
      } while (0);
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      if (i2 | 0) _free(i2);
     }
     break L7;
    } while (0);
    i1 = HEAP32[i13 >> 2] | 0;
    do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i21 = 11;
      break L7;
     }
     if ((i1 | 0) == -1) {
      HEAP32[i13 >> 2] = 0;
      i1 = 0;
      break;
     } else {
      i1 = HEAP32[i13 >> 2] | 0;
      break;
     }
    } while (0);
    i2 = (i1 | 0) == 0;
    i1 = HEAP32[i14 >> 2] | 0;
    do if (!i1) i21 = 43; else {
     if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i22 = __THREW__;
      __THREW__ = 0;
      if (i22 & 1) {
       i21 = 11;
       break L7;
      }
      if ((i1 | 0) == -1) {
       HEAP32[i14 >> 2] = 0;
       i21 = 43;
       break;
      }
     }
     if (!i2) i21 = 44;
    } while (0);
    if ((i21 | 0) == 43) if (i2) i21 = 44;
    if ((i21 | 0) == 44) HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
    i2 = HEAP32[i13 >> 2] | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i17 >> 2] | 0) | 0;
    i1 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(HEAP32[i19 >> 2] | 0, i1 | 0);
     i22 = __THREW__;
     __THREW__ = 0;
     if (i22 & 1) {
      i22 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i22);
     }
    }
    STACKTOP = i16;
    return i2 | 0;
   } while (0);
   if ((i21 | 0) == 11) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   i2 = i1;
  }
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i17 >> 2] | 0) | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  if (!i1) i20 = i2; else {
   i3 = HEAP32[i19 >> 2] | 0;
   i21 = 52;
  }
 }
 if ((i21 | 0) == 52) {
  __THREW__ = 0;
  invoke_vi(i3 | 0, i1 | 0);
  i22 = __THREW__;
  __THREW__ = 0;
  if (i22 & 1) {
   i22 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i22);
  } else i20 = i2;
 }
 ___resumeException(i20 | 0);
 return 0;
}

function __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i21, i3, i20, i1, i4) {
 i21 = i21 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24;
 i2 = i4 << 2;
 i19 = i2 >>> 0 > 1024;
 i22 = i23 + 4 | 0;
 HEAP8[i22 >> 0] = i19 & 1;
 if (i19) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i24 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i23 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i23 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i19 = i20 + 4 | 0;
  i2 = 0;
  i18 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i10 = HEAP32[i19 >> 2] | 0;
   i9 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) {
      i17 = i4;
      break;
     }
     do {
      i8 = i4;
      i4 = i4 + 1 | 0;
      i6 = HEAP32[i20 >> 2] | 0;
      i7 = i4;
      i5 = i8;
      while (1) {
       i17 = HEAP32[i21 + (i7 << 2) >> 2] | 0;
       f25 = Math_fround(HEAPF32[i10 + (i17 << 5) + (i6 << 2) >> 2]);
       f25 = Math_fround(f25 + Math_fround(HEAPF32[i10 + (i17 << 5) + 16 + (i6 << 2) >> 2]));
       i17 = HEAP32[i21 + (i5 << 2) >> 2] | 0;
       f13 = Math_fround(HEAPF32[i10 + (i17 << 5) + (i6 << 2) >> 2]);
       i17 = f25 < Math_fround(f13 + Math_fround(HEAPF32[i10 + (i17 << 5) + 16 + (i6 << 2) >> 2]));
       i5 = i17 ? i7 : i5;
       if ((i7 | 0) < (i3 | 0)) i7 = i7 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i8 | 0)) {
       i15 = i21 + (i5 << 2) | 0;
       i17 = i21 + (i8 << 2) | 0;
       i16 = HEAP32[i15 >> 2] | 0;
       HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i17 >> 2] = i16;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i9) break L7;
    i17 = i9 + -2 | 0;
    i3 = HEAP32[i1 + (i9 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i17 << 2) >> 2] | 0;
    i9 = i17;
   }
   __ZN5physx6shdfnd8internal7median3IjKNS_19SortBoundsPredicateEEEvPT_iiRT0_(i21, i17, i3, i20);
   i8 = i3 + -1 | 0;
   i16 = i21 + (i8 << 2) | 0;
   i15 = HEAP32[i19 >> 2] | 0;
   i5 = i17;
   while (1) {
    i12 = HEAP32[i20 >> 2] | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    f13 = Math_fround(HEAPF32[i15 + (i4 << 5) + (i12 << 2) >> 2]);
    f13 = Math_fround(f13 + Math_fround(HEAPF32[i15 + (i4 << 5) + 16 + (i12 << 2) >> 2]));
    i10 = i5;
    while (1) {
     i7 = i10 + 1 | 0;
     i6 = i21 + (i7 << 2) | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     f25 = Math_fround(HEAPF32[i15 + (i5 << 5) + (i12 << 2) >> 2]);
     if (Math_fround(f25 + Math_fround(HEAPF32[i15 + (i5 << 5) + 16 + (i12 << 2) >> 2])) < f13) i10 = i7; else {
      i14 = i10;
      break;
     }
    }
    while (1) {
     i11 = i8 + -1 | 0;
     i10 = i21 + (i11 << 2) | 0;
     i8 = HEAP32[i10 >> 2] | 0;
     f25 = Math_fround(HEAPF32[i15 + (i8 << 5) + (i12 << 2) >> 2]);
     if (f13 < Math_fround(f25 + Math_fround(HEAPF32[i15 + (i8 << 5) + 16 + (i12 << 2) >> 2]))) i8 = i11; else break;
    }
    if ((i7 | 0) >= (i11 | 0)) break;
    HEAP32[i6 >> 2] = i8;
    HEAP32[i10 >> 2] = i5;
    i5 = i7;
    i8 = i11;
   }
   HEAP32[i6 >> 2] = i4;
   HEAP32[i16 >> 2] = i5;
   if ((i7 - i17 | 0) < (i3 - i7 | 0)) {
    if (i9 >>> 0 < (i18 + -1 | 0) >>> 0) i4 = i18; else {
     i4 = i18 << 3;
     if (!i4) i4 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i16 = _PxGetFoundation() | 0;
      i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
      i4 = mftCall_iiiiii(i12 | 0, i15 | 0, i4 | 0, (i16 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i18 << 1;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i17;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i14;
    i5 = i4;
    i4 = i14 + 2 | 0;
   } else {
    i5 = i14 + 2 | 0;
    if (i9 >>> 0 < (i18 + -1 | 0) >>> 0) i4 = i18; else {
     i4 = i18 << 3;
     if (!i4) i4 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i16 = _PxGetFoundation() | 0;
      i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
      i4 = mftCall_iiiiii(i12 | 0, i15 | 0, i4 | 0, (i16 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i4 | 0, i1 | 0, i9 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
     }
     i1 = i4;
     i2 = 1;
     i4 = i18 << 1;
    }
    HEAP32[i1 + (i9 << 2) >> 2] = i5;
    HEAP32[i1 + (i9 + 1 << 2) >> 2] = i3;
    i5 = i4;
    i4 = i17;
    i3 = i14;
   }
   i18 = i5;
   i5 = i9 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i22 >> 0] | 0)) {
  STACKTOP = i24;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i23, HEAP32[i23 >> 2] | 0);
 STACKTOP = i24;
 return;
}

function __ZN11AudioSource21Update3DPanParametersE12SoundChannelf(i13, i11, f4) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 80 | 0;
 i7 = i15 + 64 | 0;
 i6 = i15 + 48 | 0;
 i9 = i15 + 32 | 0;
 i8 = i15 + 16 | 0;
 i5 = i15;
 i14 = i15 + 96 | 0;
 i1 = i13 + 400 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 > Math_fround(0.0) ? (HEAP32[i13 + 104 >> 2] | 0) != 1 : 0) {
  f3 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13 + 36 | 0, Math_fround(f4 / f2), 0));
  f2 = Math_fround(HEAPF32[i1 >> 2]);
 } else f3 = Math_fround(HEAPF32[(HEAP32[i13 + 92 >> 2] | 0) + 4 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i16 = f3 > Math_fround(1.0);
 f12 = i16 ? Math_fround(1.0) : f3;
 f12 = i1 ? Math_fround(0.0) : f12;
 if (f2 > Math_fround(0.0) ? (HEAP32[i13 + 280 >> 2] | 0) != 1 : 0) f2 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13 + 212 | 0, Math_fround(f4 / f2), 0)); else f2 = Math_fround(HEAPF32[(HEAP32[i13 + 268 >> 2] | 0) + 4 >> 2]);
 i1 = f2 < Math_fround(0.0);
 i16 = f2 > Math_fround(1.0);
 f2 = i16 ? Math_fround(1.0) : f2;
 f2 = i1 ? Math_fround(0.0) : f2;
 f3 = Math_fround(HEAPF32[i13 + 404 >> 2]);
 i1 = f3 < Math_fround(-1.0);
 i16 = f3 > Math_fround(1.0);
 f3 = i16 ? Math_fround(1.0) : f3;
 f3 = i1 ? Math_fround(-1.0) : f3;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!(HEAP32[i13 + 540 >> 2] | 0)) {
  i1 = __ZN20SoundChannelInstance13set3DPanLevelEf(i1, f12) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i6 >> 2] = gb + 855390;
   HEAP32[i6 + 4 >> 2] = 842;
   HEAP32[i6 + 8 >> 2] = gb + 866207;
   HEAP32[i6 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZN20SoundChannelInstance11set3DSpreadEf(i1, Math_fround(f2 * Math_fround(360.0))) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i7 >> 2] = gb + 855390;
   HEAP32[i7 + 4 >> 2] = 843;
   HEAP32[i7 + 8 >> 2] = gb + 866147;
   HEAP32[i7 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZN20SoundChannelInstance6setPanEf(i1, f3) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i10 >> 2] = gb + 855390;
   HEAP32[i10 + 4 >> 2] = 844;
   HEAP32[i10 + 8 >> 2] = gb + 866249;
   HEAP32[i10 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i10);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
 } else {
  i1 = __ZN20SoundChannelInstance13set3DPanLevelEf(i1, Math_fround(0.0)) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i5 >> 2] = gb + 855390;
   HEAP32[i5 + 4 >> 2] = 836;
   HEAP32[i5 + 8 >> 2] = gb + 866118;
   HEAP32[i5 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZN20SoundChannelInstance11set3DSpreadEf(i1, Math_fround(f2 * Math_fround(360.0))) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i8 >> 2] = gb + 855390;
   HEAP32[i8 + 4 >> 2] = 837;
   HEAP32[i8 + 8 >> 2] = gb + 866147;
   HEAP32[i8 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZN20SoundChannelInstance6setPanEf(i1, Math_fround(0.0)) | 0;
  if (i1 | 0) {
   i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i9 >> 2] = gb + 855390;
   HEAP32[i9 + 4 >> 2] = 838;
   HEAP32[i9 + 8 >> 2] = gb + 866185;
   HEAP32[i9 + 12 >> 2] = i16;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
 }
 i1 = HEAP32[i13 + 544 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 HEAPF32[i1 + 128 >> 2] = f12;
 HEAPF32[i1 + 136 >> 2] = Math_fround(f2 * Math_fround(360.0));
 HEAPF32[i1 + 140 >> 2] = f3;
 STACKTOP = i15;
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER14SafeBinaryRead(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i1 = i11;
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, HEAP32[gb + 67408 >> 2] | 0, gb + 737107 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i6, i9);
   i4 = i6 + 40 | 0;
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 754137 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 8; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 44 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 754122 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 48 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801720 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i5 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i8 = 30; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 32 | 0;
   i5 = HEAP32[gb + 37040 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 737122 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 41; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 36 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 737138 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i7 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 52; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 52; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i11;
 return;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i6 = i11 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i2 = i9;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i9 >> 2] = i1;
 } else {
  i2 = i9;
  i6 = i11 + 4 | 0;
 }
 __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i11);
 __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i11, i9 + 4 | 0, gb + 905809 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i11, i9 + 8 | 0, gb + 905840 | 0, 0);
 i5 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i11 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i11 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 12 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i11, i2 + i4 | 0, i1 << 2);
 }
 i1 = i9 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 396, 4) | 0;
  __ZN7mecanim5human5HumanC2Ev(i2);
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i1 | 0, i11);
 i5 = i9 + 28 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 24 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i11, i2 + i4 | 0, i1 << 2);
 }
 i5 = i9 + 36 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i10, 4);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i7 >> 2] = i2;
  i2 = i3;
 }
 HEAP32[i9 + 32 >> 2] = i2;
 if (!i2) HEAP32[i5 >> 2] = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  i3 = i5;
  i2 = i1 | 0 ? i1 - i3 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i11, i2 + i3 | 0, i1 << 2);
 }
 i1 = i9 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i9 + 44 | 0, i11);
 i1 = i9 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  i5 = i1;
  i2 = i2 | 0 ? i2 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i5;
 }
 __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i1 | 0, i11);
 __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i11, i9 + 88 | 0, gb + 906016 | 0, 0);
 i5 = i9 + 96 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i10, 4);
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 92 >> 2] = i3;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
  STACKTOP = i12;
  return;
 }
 i1 = i3 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i3 = i5;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
  STACKTOP = i12;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i11, i2 + i3 | 0, i1 << 2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE(i16, i1, i7) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 16 | 0;
 i8 = i17;
 i2 = i17 + 48 | 0;
 i3 = i17 + 44 | 0;
 i5 = i17 + 32 | 0;
 i6 = HEAP32[i16 + 36 >> 2] | 0;
 i4 = i1 << 1;
 i4 = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (i4 >> 5 << 2) >> 2] | 0) >>> (i4 & 30) & 3;
 if ((i4 | 0) != 3) {
  i2 = (__ZNK5Umbra6KDTree4rankEi(i6, i1) | 0) << 1;
  i3 = HEAP32[i16 + 56 + (i4 << 2) >> 2] | 0;
  if ((HEAP32[i6 + 24 >> 2] | 0) > (i1 | 0)) {
   f18 = Math_fround(HEAPF32[(HEAP32[i6 + 12 >> 2] | 0) + (HEAP32[i6 + 16 >> 2] | 0) + (i1 << 2) >> 2]);
   i1 = i16 + 12 | 0;
   f18 = Math_fround(f18 - Math_fround(HEAPF32[i1 + (i4 << 2) >> 2]));
   f21 = Math_fround(HEAPF32[i16 + 24 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i1 >> 2]));
   f20 = Math_fround(HEAPF32[i16 + 28 >> 2]);
   f20 = Math_fround(f20 - Math_fround(HEAPF32[i16 + 16 >> 2]));
   f19 = Math_fround(HEAPF32[i16 + 32 >> 2]);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i16 + 20 >> 2]));
   HEAPF32[i5 >> 2] = f21;
   HEAPF32[i5 + 4 >> 2] = f20;
   HEAPF32[i5 + 8 >> 2] = f19;
   i1 = ~~Math_fround(Math_fround(f18 / Math_fround(HEAPF32[i5 + (i4 << 2) >> 2])) * Math_fround(65535.0));
  } else i1 = ((HEAP32[i7 + 8 + (i3 << 2) >> 2] | 0) + (HEAP32[i7 + (i3 << 2) >> 2] | 0) | 0) / 2 | 0;
  i12 = i7;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i9;
  HEAP32[i14 >> 2] = i11;
  HEAP32[i14 + 4 >> 2] = i12;
  i14 = i7 + 8 | 0;
  i13 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  i15 = i9 + 8 | 0;
  HEAP32[i15 >> 2] = i13;
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i9 + 8 + (i3 << 2) >> 2] = i1;
  i15 = i8;
  HEAP32[i15 >> 2] = i11;
  HEAP32[i15 + 4 >> 2] = i12;
  i15 = i8 + 8 | 0;
  HEAP32[i15 >> 2] = i13;
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i8 + (i3 << 2) >> 2] = i1;
  __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE(i16, i2 + -1 | 0, i9);
  __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE(i16, i2, i8);
  STACKTOP = i17;
  return;
 }
 i12 = HEAP32[i16 + 40 >> 2] | 0;
 i14 = i1 - (__ZNK5Umbra6KDTree4rankEi(i6, i1) | 0) | 0;
 i11 = HEAP32[i16 + 44 >> 2] | 0;
 i14 = Math_imul(i14, i11) | 0;
 i13 = i14 >> 5;
 i14 = i14 & 31;
 i11 = (HEAP32[i12 + (i13 + 1 << 2) >> 2] << 32 - i14 & -1 << (i14 ^ 31) | (HEAP32[i12 + (i13 << 2) >> 2] | 0) >>> i14) & (1 << i11) + -1;
 if ((i11 | 0) == (HEAP32[i16 + 48 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i13 = HEAP32[i7 + 4 >> 2] | 0;
 i14 = HEAP32[i7 + 8 >> 2] | 0;
 i10 = HEAP32[i7 + 12 >> 2] | 0;
 i5 = HEAP32[i16 + 8 >> 2] | 0;
 i6 = i5 >>> 1 & 3;
 i1 = i16 + 24 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = i16 + 12 | 0;
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i7 >> 2]));
 f20 = Math_fround(HEAPF32[i16 + 28 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i16 + 16 >> 2]));
 f21 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i16 + 20 >> 2]));
 HEAPF32[i9 >> 2] = f19;
 HEAPF32[i9 + 4 >> 2] = f20;
 HEAPF32[i9 + 8 >> 2] = f21;
 i4 = i5 >> 1;
 f21 = Math_fround(HEAPF32[((i5 & 1 | 0) == 0 ? i7 + (i4 << 2) | 0 : i1 + (i4 << 2) | 0) >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i7 + (i6 << 2) >> 2]));
 f21 = Math_fround(f21 / Math_fround(HEAPF32[i9 + (i6 << 2) >> 2]));
 HEAPF32[i8 >> 2] = f21;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i6 = f21 <= Math_fround(0.0);
 i6 = i6 ? i3 : i8;
 i7 = Math_fround(HEAPF32[i6 >> 2]) >= Math_fround(1.0);
 i6 = HEAP32[(i7 ? i2 : i6) >> 2] | 0;
 HEAP32[i8 >> 2] = i6;
 i5 = i5 << 29 | 335544319;
 i6 = ~~Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(65535.0)) | -65536;
 i7 = i16 + 4 | 0;
 i3 = HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 L12 : do if (!i3) i15 = 9; else {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i3;
  while (1) {
   i1 = i1 + -1 | 0;
   if ((HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i2 + (i1 * 28 | 0) >> 2] | 0) == (i5 | 0)) break;
   i1 = HEAP32[i2 + (i1 * 28 | 0) + 24 >> 2] | 0;
   if (!i1) {
    i15 = 9;
    break L12;
   }
  }
  i16 = i2 + (i1 * 28 | 0) + 8 | 0;
  i7 = HEAP32[i16 >> 2] | 0;
  i8 = HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] | 0;
  i9 = HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] | 0;
  i11 = HEAP32[i2 + (i1 * 28 | 0) + 20 >> 2] | 0;
  HEAP32[i16 >> 2] = (i12 | 0) <= (i7 | 0) ? i12 : i7;
  HEAP32[i16 + 4 >> 2] = (i13 | 0) <= (i8 | 0) ? i13 : i8;
  i16 = i2 + (i1 * 28 | 0) + 16 | 0;
  HEAP32[i16 >> 2] = (i14 | 0) >= (i9 | 0) ? i14 : i9;
  HEAP32[i16 + 4 >> 2] = (i10 | 0) >= (i11 | 0) ? i10 : i11;
 } while (0);
 if ((i15 | 0) == 9) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if (__ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb(i4, i1 + 1 | 0, 1, 0, 0) | 0) {
   i15 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = i15 + (i1 * 28 | 0) | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i9 + 4 >> 2] = i6;
   i9 = i15 + (i1 * 28 | 0) + 8 | 0;
   HEAP32[i9 >> 2] = i12;
   HEAP32[i9 + 4 >> 2] = i13;
   i13 = i15 + (i1 * 28 | 0) + 16 | 0;
   HEAP32[i13 >> 2] = i14;
   HEAP32[i13 + 4 >> 2] = i10;
   HEAP32[i15 + (i1 * 28 | 0) + 24 >> 2] = i3;
  }
  HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2];
 }
 STACKTOP = i17;
 return;
}

function __ZN8Animator8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = i10 + 4 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 3);
 __ZN14DirectorPlayer8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i2 = i7 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 905764 | 0, gb + 902244 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6AvatarE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 905632 | 0, gb + 905645 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator11CullingModeEEvRT_RT0_PKc17TransferMetaFlags(i9, i7 + 92 | 0, gb + 902257 | 0, 0);
 i4 = i7 + 96 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator10UpdateModeEEvRT_RT0_PKc17TransferMetaFlags(i9, i4, gb + 902271 | 0, 0);
 i3 = i7 + 417 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902284 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 418 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902302 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 2) | 0) {
  HEAP8[i5 >> 0] = 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896315 | 0, i6, i8, 0) | 0;
  if (!i1) i1 = 0; else {
   do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i11 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i11 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 1);
   } else {
    i1 = HEAP32[i8 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
   i1 = HEAP8[i5 >> 0] | 0;
  }
  HEAP32[i4 >> 2] = i1 & 255;
 }
 i3 = i7 + 561 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902327 | 0, i6, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i11 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 560 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902351 | 0, i6, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i11 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i11 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i11 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZL27SetupActiveDirectionalLightRK5LightR11ActiveLight(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i2 = i10;
 i7 = i1 + 44 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[i8 >> 2] = i1;
 HEAP8[i8 + 8 >> 0] = 1;
 i1 = i8 + 24 | 0;
 i5 = i9 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i1 + 40 >> 2] | 0) == 3) i1 = 2; else if ((HEAP32[i1 + 88 >> 2] | 0) > -1) i1 = (HEAP32[i1 + 80 >> 2] | 0) == 1 ? 1 : 2; else i1 = 0;
 HEAP32[i8 + 12 >> 2] = i1;
 HEAP8[i8 + 9 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = -1;
 HEAPF32[i8 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 76 >> 2] = Math_fround(1.0);
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 36 >> 2];
 HEAP8[i8 + 81 >> 0] = HEAP8[i4 + 84 >> 0] | 0;
 i5 = i8 + 84 | 0;
 i4 = HEAP32[i4 + 92 >> 2] | 0;
 do if (i4 | 0) {
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i2);
    i2 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 12;
   }
  }
  if ((i6 | 0) == 10) i6 = 12;
  if ((i6 | 0) == 12) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) break;
  }
  HEAP32[i5 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i8 + 88 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i8 + 92 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i1 + 72 >> 2] | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
  f13 = Math_fround(i11 | 0);
  f12 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i8 + 96 >> 2] = i3;
  HEAP32[i8 + 100 >> 2] = i2;
  HEAPF32[i8 + 104 >> 2] = f13;
  HEAPF32[i8 + 108 >> 2] = f12;
  i2 = i8 + 112 | 0;
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i9, i3, i1);
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i11 = HEAP32[i7 >> 2] | 0;
  i9 = i11 + 76 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i7 = i8 + 128 | 0;
  HEAP32[i7 >> 2] = i9;
  i7 = i11 + 40 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 132 | 0;
  HEAP32[i9 >> 2] = i7;
  i9 = i8 + 172 | 0;
  HEAP8[i9 >> 0] = 0;
  i9 = i8 + 176 | 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  i9 = i11 + 20 | 0;
  f13 = Math_fround(HEAPF32[i9 >> 2]);
  f13 = Math_fround(f13 * Math_fround(.300000012));
  i9 = i11 + 24 | 0;
  f12 = Math_fround(HEAPF32[i9 >> 2]);
  f12 = Math_fround(f12 * Math_fround(.589999974));
  f12 = Math_fround(f13 + f12);
  i9 = i11 + 28 | 0;
  f13 = Math_fround(HEAPF32[i9 >> 2]);
  f13 = Math_fround(f13 * Math_fround(.109999999));
  f13 = Math_fround(f12 + f13);
  i11 = i11 + 44 | 0;
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  f13 = Math_fround(f12 * f13);
  i11 = i8 + 168 | 0;
  HEAPF32[i11 >> 2] = f13;
  STACKTOP = i10;
  return;
 } while (0);
 HEAP32[i5 >> 2] = 0;
 i11 = HEAP32[i7 >> 2] | 0;
 i9 = i11 + 76 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i7 = i8 + 128 | 0;
 HEAP32[i7 >> 2] = i9;
 i7 = i11 + 40 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 132 | 0;
 HEAP32[i9 >> 2] = i7;
 i9 = i8 + 172 | 0;
 HEAP8[i9 >> 0] = 0;
 i9 = i8 + 176 | 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 i9 = i11 + 20 | 0;
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(f13 * Math_fround(.300000012));
 i9 = i11 + 24 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(f12 * Math_fround(.589999974));
 f12 = Math_fround(f13 + f12);
 i9 = i11 + 28 | 0;
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(f13 * Math_fround(.109999999));
 f13 = Math_fround(f12 + f13);
 i11 = i11 + 44 | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f12 * f13);
 i11 = i8 + 168 | 0;
 HEAPF32[i11 >> 2] = f13;
 STACKTOP = i10;
 return;
}

function __ZNKSt3__220__time_get_c_storageIwE8__monthsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if (!(HEAP8[gb + 1099936 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099936 | 0) | 0) {
  if (!(HEAP8[gb + 1099944 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099944 | 0) | 0) {
   i2 = gb + 1475780 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1475780 + 288 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1150 | 0, gb + 1475780 | 0, gb + 210264 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  do if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1150 | 0, gb + 1475780 + 12 | 0, gb + 210296 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __THREW__ = 0;
    invoke_iii(fb + 1150 | 0, gb + 1475780 + 24 | 0, gb + 210332 | 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_iii(fb + 1150 | 0, gb + 1475780 + 36 | 0, gb + 210356 | 0) | 0;
     i2 = __THREW__;
     __THREW__ = 0;
     if (!(i2 & 1)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, gb + 1475780 + 48 | 0, gb + 210380 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (!(i2 & 1)) {
       __THREW__ = 0;
       invoke_iii(fb + 1150 | 0, gb + 1475780 + 60 | 0, gb + 210396 | 0) | 0;
       i2 = __THREW__;
       __THREW__ = 0;
       if (!(i2 & 1)) {
        __THREW__ = 0;
        invoke_iii(fb + 1150 | 0, gb + 1475780 + 72 | 0, gb + 210416 | 0) | 0;
        i2 = __THREW__;
        __THREW__ = 0;
        if (!(i2 & 1)) {
         __THREW__ = 0;
         invoke_iii(fb + 1150 | 0, gb + 1475780 + 84 | 0, gb + 210436 | 0) | 0;
         i2 = __THREW__;
         __THREW__ = 0;
         if (!(i2 & 1)) {
          __THREW__ = 0;
          invoke_iii(fb + 1150 | 0, gb + 1475780 + 96 | 0, gb + 210464 | 0) | 0;
          i2 = __THREW__;
          __THREW__ = 0;
          if (!(i2 & 1)) {
           __THREW__ = 0;
           invoke_iii(fb + 1150 | 0, gb + 1475780 + 108 | 0, gb + 210504 | 0) | 0;
           i2 = __THREW__;
           __THREW__ = 0;
           if (!(i2 & 1)) {
            __THREW__ = 0;
            invoke_iii(fb + 1150 | 0, gb + 1475780 + 120 | 0, gb + 210536 | 0) | 0;
            i2 = __THREW__;
            __THREW__ = 0;
            if (!(i2 & 1)) {
             __THREW__ = 0;
             invoke_iii(fb + 1150 | 0, gb + 1475780 + 132 | 0, gb + 210572 | 0) | 0;
             i2 = __THREW__;
             __THREW__ = 0;
             if (!(i2 & 1)) {
              __THREW__ = 0;
              invoke_iii(fb + 1150 | 0, gb + 1475780 + 144 | 0, gb + 210608 | 0) | 0;
              i2 = __THREW__;
              __THREW__ = 0;
              if (!(i2 & 1)) {
               __THREW__ = 0;
               invoke_iii(fb + 1150 | 0, gb + 1475780 + 156 | 0, gb + 210624 | 0) | 0;
               i2 = __THREW__;
               __THREW__ = 0;
               if (!(i2 & 1)) {
                __THREW__ = 0;
                invoke_iii(fb + 1150 | 0, gb + 1475780 + 168 | 0, gb + 210640 | 0) | 0;
                i2 = __THREW__;
                __THREW__ = 0;
                if (!(i2 & 1)) {
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 180 | 0, gb + 210656 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 192 | 0, gb + 210380 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 204 | 0, gb + 210672 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 216 | 0, gb + 210688 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 228 | 0, gb + 210704 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 240 | 0, gb + 210720 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 252 | 0, gb + 210736 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 264 | 0, gb + 210752 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 __THREW__ = 0;
                 invoke_iii(fb + 1150 | 0, gb + 1475780 + 276 | 0, gb + 210768 | 0) | 0;
                 i2 = __THREW__;
                 __THREW__ = 0;
                 if (i2 & 1) break;
                 HEAP32[gb + 1476068 >> 2] = gb + 1475780;
                 break L1;
                }
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  } while (0);
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1476068 >> 2] | 0;
}

function __ZN23TransformChangeDispatch40GetAndClearChangedAsBatchedJobs_InternalE27TransformChangeSystemHandlePFvPvPK23TransformAccessReadOnlyjES1_PFvS1_E(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 976 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 776 | 0;
 i13 = i18 + 768 | 0;
 i7 = i18 + 576 | 0;
 i8 = i18 + 48 | 0;
 i11 = i18 + 44 | 0;
 i12 = i18 + 40 | 0;
 i16 = i18 + 28 | 0;
 i17 = i18;
 i9 = i2 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  if (!i6) {
   STACKTOP = i18;
   return;
  }
  mftCall_vi(i6 | 0, i5 | 0);
  STACKTOP = i18;
  return;
 }
 i10 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i7, i1, 1) | 0;
 __ZN14BatchAllocatorC2Ev(i8);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, i11, -1, 224, 1, 4);
 HEAP32[i11 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, 204, 0, 8, i10, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i8, i12, -1, 8, i10, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i8, gb + 64024 | 0);
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i15 + 4 >> 2] = i2;
 HEAP32[i15 + 208 >> 2] = i5;
 HEAP32[i15 + 212 >> 2] = i4;
 HEAP32[i15 + 216 >> 2] = i6;
 HEAP32[i15 + 200 >> 2] = i10;
 HEAP32[i15 + 220 >> 2] = HEAP32[i2 + 48 >> 2];
 _memcpy(i15 + 8 | 0, i7 | 0, 192) | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i16 + 4 | 0;
 i7 = gb + 63160 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i15;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = HEAP32[i9 >> 2] << 3;
 if (i1 | 0) if (((i1 | 4) + -1 | 0) >>> 0 >= 2e3) {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 421957 | 0, 172) | 0;
  i8 = gb + 64016 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i16 >> 2] = i9;
  i9 = i15;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i9 + 4 >> 2] = i8;
 }
 __ZN18JobBatchDispatcherC2E11JobPriorityi(i17, 0, -1);
 if (i10 | 0) {
  i2 = i14 + 4 | 0;
  i1 = 0;
  do {
   HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 3) >> 2] = HEAP32[i11 >> 2];
   HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 3) + 4 >> 2] = i1;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   __Z21ClearFenceWithoutSyncR8JobFence((HEAP32[(HEAP32[i11 >> 2] | 0) + 204 >> 2] | 0) + (i1 << 3) | 0);
   __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i17, (HEAP32[(HEAP32[i11 >> 2] | 0) + 204 >> 2] | 0) + (i1 << 3) | 0, fb + 3381 | 0, (HEAP32[i12 >> 2] | 0) + (i1 << 3) | 0, i14);
   __Z21ClearFenceWithoutSyncR8JobFence(i14);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
 }
 __ZN18JobBatchDispatcher8KickJobsEv(i17);
 i12 = HEAP32[i11 >> 2] | 0;
 if ((HEAP16[gb + 1159888 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159888 | 0, i14);
  i11 = gb + 1159888 | 0;
 } else i11 = 0;
 i4 = i12 + 200 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i5 = i12 + 204 | 0;
  i3 = 0;
  do {
   i2 = (HEAP32[i5 >> 2] | 0) + (i3 << 3) | 0;
   if (HEAP32[i2 >> 2] | 0) {
    __Z21CompleteFenceInternalR8JobFence(i2);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i1 | 0));
 }
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 if ((HEAP16[gb + 1162184 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162184 | 0, i14);
  i9 = gb + 1162184 | 0;
 } else i9 = 0;
 _memcpy(i14 | 0, i12 + 8 | 0, 192) | 0;
 i6 = i1 + -1 | 0;
 if (i6 | 0) {
  i4 = 0;
  do {
   i5 = i4;
   i4 = i4 + 1 | 0;
   i7 = HEAP32[i14 + (i4 * 12 | 0) >> 2] | 0;
   i8 = i14 + (i5 * 12 | 0) + 4 | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i14 + (i5 * 12 | 0) >> 2] | 0) | 0;
   L35 : do if (i2 >>> 0 < i7 >>> 0) do {
    i3 = __ZN18BlockRangeInternal16PopLastNodeIndexEP10BlockRangeji(i14, i1, i5) | 0;
    if ((i3 | 0) == -1) break L35;
    i13 = HEAP32[i10 >> 2] | 0;
    HEAP32[i13 + (i2 << 2) >> 2] = HEAP32[i13 + (i3 << 2) >> 2];
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i7 >>> 0); while (0);
  } while ((i4 | 0) != (i6 | 0));
 }
 i3 = __ZN18BlockRangeInternal25GetSizeFromLastBlockRangeEP10BlockRangej(i14, i1) | 0;
 if (i9 | 0) __Z12profiler_endP19ProfilerInformation(i9);
 i1 = i10 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i2 = i10 + 16 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i3 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i2 >> 2] = i3;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i3 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i10 >> 2] = i14;
  }
  i3 = HEAP32[i1 >> 2] | 0;
 }
 if (i3 | 0) {
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 32 >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i12 + 216 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, HEAP32[i12 + 208 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i12, gb + 64024 | 0);
 if (i11 | 0) __Z12profiler_endP19ProfilerInformation(i11);
 __ZN18JobBatchDispatcherD2Ev(i17);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
 STACKTOP = i18;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i30, i26, i1) {
 i30 = i30 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 44 | 0;
 i23 = i29 + 40 | 0;
 i28 = i29 + 20 | 0;
 i24 = i29;
 i25 = i26 + 12 | 0;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i30, gb + 1041885 | 0, gb + 1041885 | 0, i23) | 0)) {
  STACKTOP = i29;
  return;
 };
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 i11 = i28 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i26 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i26, HEAP32[i12 >> 2] | 0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i26 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i13 = HEAP32[gb + 37152 >> 2] | 0;
  i1 = i28 + 11 | 0;
  i14 = i28 + 4 | 0;
  i15 = i24 + 12 | 0;
  i10 = i24 + 12 | 0;
  i16 = i27 + 4 | 0;
  i17 = i24 + 8 | 0;
  i18 = i24 + 4 | 0;
  i19 = i24 + 16 | 0;
  i20 = i26 + 4 | 0;
  i21 = i24 + 11 | 0;
  i22 = i27 + 4 | 0;
  i9 = 0;
  do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i30, gb + 1041891 | 0, i13, i27, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i28, i30); else {
     i2 = HEAP32[i27 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i28 | 0, i30 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i30);
   }
   i4 = HEAP8[i1 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i28 >> 2] | 0 : i28;
   i4 = i2 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i15 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = 17;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i21 >> 0] = i4;
    if (!i4) i2 = i24; else {
     i2 = i24;
     i5 = 19;
    }
   } else i5 = 17;
   if ((i5 | 0) == 17) {
    i8 = i4 + 16 & -16;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i16 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i24 >> 2] = i2;
    HEAP32[i17 >> 2] = i8 | -2147483648;
    HEAP32[i18 >> 2] = i4;
    i5 = 19;
   }
   if ((i5 | 0) == 19) {
    i5 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
   i2 = HEAP32[i12 >> 2] | 0;
   do if (!i2) {
    i3 = i12;
    i4 = i12;
   } else {
    i7 = HEAP8[i21 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i18 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i24 >> 2] | 0 : i24;
    while (1) {
     i4 = i2 + 16 | 0;
     i6 = HEAP8[i4 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
     i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
     if (!i3) i5 = 24; else {
      i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
      if (!i3) i5 = 24; else if ((i3 | 0) < 0) i5 = 26; else i5 = 28;
     }
     if ((i5 | 0) == 24) if (i7 >>> 0 < i6 >>> 0) i5 = 26; else i5 = 28;
     if ((i5 | 0) == 26) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i5 = 27;
       break;
      } else i2 = i3;
     } else if ((i5 | 0) == 28) {
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i5 = 30;
       break;
      } else i2 = i3;
     }
    }
    if ((i5 | 0) == 27) {
     i5 = 0;
     i3 = i2;
     i4 = i2;
     break;
    } else if ((i5 | 0) == 30) {
     i5 = 0;
     i3 = i2;
     break;
    }
   } while (0);
   __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i27, i26, i24);
   i2 = HEAP32[i27 >> 2] | 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i26 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i20 >> 2] | 0, i2);
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
   if ((HEAP8[i21 >> 0] | 0) < 0) {
    i8 = HEAP32[i24 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i22 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i27);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (HEAP32[i23 >> 2] | 0));
 } else i1 = i28 + 11 | 0;
 __ZN14SafeBinaryRead16EndArrayTransferEv(i30);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i30 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 12 >> 2] | 0;
  HEAP32[i27 >> 2] = 66;
  HEAP32[i27 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
 }
 STACKTOP = i29;
 return;
}

function __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext(i20, i15) {
 i20 = i20 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i22 + 8 | 0;
 i19 = i22;
 i21 = i22 + 16 | 0;
 i17 = i20 + 32 | 0;
 i13 = HEAP32[i20 + 12 >> 2] | 0;
 i18 = i20 + 24 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(20, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i13 + (i14 * 40 | 0);
 HEAP32[i1 + 8 >> 2] = (i14 * 40 | 0) / 40 | 0;
 HEAP32[i1 + 16 >> 2] = gb + 1115280;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i17, fb + 3351 | 0, i1, i16, 0);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!(HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] | 0)) {
  i2 = 1;
  i3 = i1;
 } else {
  i2 = __Z22GetJobQueueThreadCountv() | 0;
  i3 = HEAP32[i18 >> 2] | 0;
 }
 i14 = ((i1 | 0) / 256 | 0) + 1 | 0;
 i14 = (i2 | 0) < (i14 | 0) ? i2 : i14;
 i12 = (i3 >>> 0) / (i14 >>> 0) | 0;
 HEAP32[i21 >> 2] = 0;
 i13 = i21 + 4 | 0;
 i10 = gb + 63160 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = i14 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 388526 | 0, 305) | 0;
   i10 = gb + 64016 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i21 >> 2] = i1;
   i11 = i13;
   HEAP32[i11 >> 2] = i9;
   HEAP32[i11 + 4 >> 2] = i10;
   break;
  }
 } while (0);
 i2 = i1 + 3 & -4;
 i11 = i2;
 i3 = (i14 | 0) > 0;
 if (i3) {
  i1 = 0;
  do {
   i4 = i11 + (i1 << 2) | 0;
   i5 = __ZnwjRK10MemLabelIdiPKci(172, gb + 64024 | 0, 16, gb + 388526 | 0, 309) | 0;
   HEAP32[i5 + 4 >> 2] = 1;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 36896 + 8;
   i6 = i5 + 12 | 0;
   i7 = i5 + 48 | 0;
   i8 = i5 + 52 | 0;
   i9 = i6;
   i10 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = 0;
    i9 = i9 + 4 | 0;
   } while ((i9 | 0) < (i10 | 0));
   HEAP32[i8 >> 2] = 1;
   HEAP32[i7 >> 2] = gb + 33952 + 8;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 80 >> 2] = 0;
   HEAP32[i5 + 92 >> 2] = 0;
   HEAP32[i5 + 96 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 84 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 100 >> 2] = 0;
   HEAP32[i5 + 112 >> 2] = 0;
   HEAP32[i5 + 116 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 104 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 120 >> 2] = 0;
   HEAP32[i5 + 132 >> 2] = 0;
   HEAP32[i5 + 136 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 124 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i5 + 140 >> 2] = 0;
   HEAP32[i5 + 144 >> 2] = 0;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i5 + 148 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP8[i5 + 156 >> 0] = 1;
   i10 = i5 + 56 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   HEAP8[i5 + 160 >> 0] = 1;
   HEAP8[i5 + 161 >> 0] = 0;
   HEAP32[i4 >> 2] = i5;
   __ZN17ShaderPassContext8CopyFromERKS_(i6, i15);
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP8[i10 + 156 >> 0] = 0;
   HEAP32[i10 + 164 >> 2] = Math_imul(i1, i12) | 0;
   HEAP32[i10 + 168 >> 2] = i12;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i14 | 0));
 }
 i19 = HEAP32[i11 + (i14 + -1 << 2) >> 2] | 0;
 HEAP32[i19 + 168 >> 2] = (HEAP32[i18 >> 2] | 0) - (HEAP32[i19 + 164 >> 2] | 0);
 i19 = __Z12GetGfxDevicev() | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 892 >> 2] | 0, i19 | 0, i14 | 0, fb + 2394 | 0, i2 | 0, i20 | 0, i17 | 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i17);
 if (i3) {
  i1 = 0;
  do {
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   i19 = i2 + 4 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
   if (!(HEAP32[i19 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i14 | 0));
 }
 i19 = i20 + 4 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
 if (HEAP32[i19 >> 2] | 0) {
  i21 = HEAP32[i21 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i13);
  STACKTOP = i22;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
 i21 = HEAP32[i21 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i21, i13);
 STACKTOP = i22;
 return;
}

function __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 if ((i1 | 0) == 22) {
  i1 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
  i2 = i1 + -8 | 0;
  if (i2 >>> 0 < 10) if (!(521 >>> (i2 & 1023) & 1)) {
   i10 = i1;
   i2 = 0;
   i6 = 0;
  } else {
   i2 = HEAP32[(HEAP32[gb + 1166136 >> 2] | 0) + 540 >> 2] | 0;
   i10 = i1;
   i3 = i2;
   i2 = (i2 + -1 | 0) >>> 0 < 4;
   i6 = 0;
  } else {
   i10 = i1;
   i2 = 0;
   i6 = 0;
  }
 } else {
  i10 = i1;
  i2 = 0;
  i6 = 1;
 }
 i8 = i10 + -8 | 0;
 L6 : do if (i8 >>> 0 < 10) {
  i5 = i4 + 32 | 0;
  i7 = i4 + 36 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i4 | 0;
  i9 = (i1 | 0) / 36 | 0;
  if (!(521 >>> (i8 & 1023) & 1)) {
   i6 = i9;
   i11 = 22;
  } else if (i1) {
   if (i6) {
    i2 = 0;
    while (1) {
     i1 = i4 + (i2 * 36 | 0) | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) if ((HEAP32[i4 + (i2 * 36 | 0) + 4 >> 2] | 0) == (i3 | 0)) break;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i9 >>> 0) break L6;
    }
    STACKTOP = i14;
    return i1 | 0;
   }
   L18 : do if (i2) {
    i8 = 0;
    i2 = i9;
    while (1) {
     i1 = i4 + (i8 * 36 | 0) | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
      i6 = HEAP32[i4 + (i8 * 36 | 0) + 4 >> 2] | 0;
      if ((i6 | 0) == (i3 | 0)) break;
      if ((i6 + -1 | 0) >>> 0 < 4) {
       if (i2 >>> 0 < i9 >>> 0) i1 = HEAP32[i4 + (i2 * 36 | 0) + 4 >> 2] | 0; else i1 = -1;
       if ((i6 | 0) < (i3 | 0)) i1 = (i6 | 0) > (i1 | 0) ? i8 : i2; else i1 = i2;
      } else i1 = i2;
     } else i1 = i2;
     i8 = i8 + 1 | 0;
     if (i8 >>> 0 >= i9 >>> 0) break L18; else i2 = i1;
    }
    STACKTOP = i14;
    return i1 | 0;
   } else {
    i8 = 0;
    i2 = i9;
    while (1) {
     i1 = i4 + (i8 * 36 | 0) | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
      i6 = HEAP32[i4 + (i8 * 36 | 0) + 4 >> 2] | 0;
      if ((i6 | 0) == (i3 | 0)) break;
      if (((HEAP32[i4 + (i8 * 36 | 0) + 4 >> 2] | 0) + -5 | 0) >>> 0 < 8) {
       if (i2 >>> 0 < i9 >>> 0) i1 = HEAP32[i4 + (i2 * 36 | 0) + 4 >> 2] | 0; else i1 = -1;
       if ((i6 | 0) < (i3 | 0)) i1 = (i6 | 0) > (i1 | 0) ? i8 : i2; else i1 = i2;
      } else i1 = i2;
     } else i1 = i2;
     i8 = i8 + 1 | 0;
     if (i8 >>> 0 >= i9 >>> 0) break L18; else i2 = i1;
    }
    STACKTOP = i14;
    return i1 | 0;
   } while (0);
   if (i1 >>> 0 < i9 >>> 0) {
    i13 = i4 + (i1 * 36 | 0) | 0;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
 } else {
  i5 = i4 + 32 | 0;
  i7 = i4 + 36 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i6 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 36 | 0;
  i11 = 22;
 } while (0);
 L47 : do if ((i11 | 0) == 22) if (i6) {
  i2 = 0;
  while (1) {
   i1 = i4 + (i2 * 36 | 0) | 0;
   i2 = i2 + 1 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) break;
   if (i2 >>> 0 >= i6 >>> 0) break L47;
  }
  STACKTOP = i14;
  return i1 | 0;
 } while (0);
 i6 = i13 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i13 + 4 >> 2] = i3;
 i6 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i8 = i13 + 20 | 0;
 i11 = i13 + 24 | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i9 = i13 + 32 | 0;
 HEAP8[i9 >> 0] = 0;
 i10 = HEAP32[i7 >> 2] | 0;
 if ((i10 | 0) == (i4 | 0)) {
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i5, i13);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = i13;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i10;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i5;
  i3 = i10 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  i5 = i10 + 12 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  i1 = (HEAP32[i12 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
  i4 = (i1 | 0) / 96 | 0;
  if (i1 | 0) {
   if (i4 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i2 = __Znwj(i1) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 + 16 >> 2] = i2 + (i4 * 96 | 0);
   i1 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   if ((i1 | 0) != (i3 | 0)) do {
    __ZN19ComputeShaderKernelC2ERKS_(i2, i1);
    i1 = i1 + 96 | 0;
    i2 = (HEAP32[i5 >> 2] | 0) + 96 | 0;
    HEAP32[i5 >> 2] = i2;
   } while ((i1 | 0) != (i3 | 0));
  }
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_(i10 + 20 | 0, i8);
  HEAP8[i10 + 32 >> 0] = HEAP8[i9 >> 0] | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 36 | 0;
  HEAP32[i7 >> 2] = i1;
 }
 i7 = i1 + -36 | 0;
 i6 = i13 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i11 >> 2] = i3;
    i4 = HEAP32[i2 + -12 >> 2] | 0;
    i5 = i4;
    if (!i4) i2 = i3; else {
     i2 = i2 + -8 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i5 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i4);
     i2 = HEAP32[i11 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i13 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i13 = i2 + -96 | 0;
    HEAP32[i12 >> 2] = i13;
    __ZN19ComputeShaderKernelD2Ev(i13);
    i2 = HEAP32[i12 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i13 = i7;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN7mecanim12statemachine21DoBlendTreeEvaluationERKNS0_13StateConstantERNS0_11StateOutputERNS0_14StateWorkspaceERKNS_18ValueArrayConstantERKNS0_17StateMachineInputEb(i10, i6, i32, i33, i8, i7) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f9 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f34 = f0, i35 = 0, f36 = f0;
 f34 = Math_fround(HEAPF32[i10 + 52 >> 2]);
 i35 = i8 + 16 | 0;
 i4 = HEAP32[i35 >> 2] | 0;
 i2 = HEAP32[i10 + 44 >> 2] | 0;
 i3 = HEAP8[i10 + 63 >> 0] | 0;
 if (i2) {
  i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i33, i2) | 0;
  if ((i2 | 0) > -1) {
   i3 = i33 + 4 | 0;
   i31 = i4 + 44 | 0;
   i3 = HEAP8[(HEAP32[i31 >> 2] | 0) + i31 + (HEAP32[(HEAP32[i3 >> 2] | 0) + i3 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0;
  }
 }
 i31 = i3 << 24 >> 24 != 0;
 i5 = HEAP32[i35 >> 2] | 0;
 i2 = HEAP32[i10 + 56 >> 2] | 0;
 i4 = HEAP32[i10 + 48 >> 2] | 0;
 if (i4) {
  i4 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i33, i4) | 0;
  if ((i4 | 0) > -1) {
   i2 = i33 + 4 | 0;
   i30 = i5 + 28 | 0;
   i2 = HEAP32[(HEAP32[i30 >> 2] | 0) + i30 + (HEAP32[(HEAP32[i2 >> 2] | 0) + i2 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0;
  }
 }
 f27 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
 i28 = i10 + 8 | 0;
 if (!(HEAP32[i28 >> 2] | 0)) {
  f34 = Math_fround(0.0);
  return Math_fround(f34);
 }
 i29 = i10 + 12 | 0;
 i30 = i29;
 i26 = i6 + 4 | 0;
 i22 = i7 & 1 ^ 1;
 i23 = i32 + 4 | 0;
 i24 = i32 + 8 | 0;
 i25 = i8 + 8 | 0;
 i14 = i8 + 20 | 0;
 i15 = i10 + 20 | 0;
 i16 = i15;
 f17 = i31 ? Math_fround(.5) : Math_fround(0.0);
 i18 = i10 + 24 | 0;
 i19 = i10 + 28 | 0;
 i20 = i10 + 32 | 0;
 i21 = i10 + 36 | 0;
 i13 = i10 + 62 | 0;
 f1 = Math_fround(0.0);
 i12 = 0;
 do {
  i2 = HEAP32[(HEAP32[i29 >> 2] | 0) + i30 + (i12 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) i4 = 0; else {
   i11 = (HEAP32[i15 >> 2] | 0) + i16 + (i2 << 2) | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i4 = (i4 | 0) == 0 ? 0 : i11 + i4 | 0;
  }
  i10 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[i26 >> 2] | 0) + (i12 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + (i22 << 3) + 4 >> 2] | 0;
  i11 = i10 + 8 | 0;
  if (HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0) {
   i2 = 0;
   do {
    __ZN8Playable14SetInputWeightEif(i10, i2, Math_fround(0.0));
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0) >>> 0);
  }
  if (!i4) i2 = HEAP32[i28 >> 2] | 0; else {
   i2 = (HEAP32[i32 >> 2] | 0) + (i12 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = HEAP32[i35 >> 2];
   HEAP32[HEAP32[i2 >> 2] >> 2] = i33;
   __ZN7mecanim9animation17EvaluateBlendTreeERKNS0_17BlendTreeConstantERKNS0_14BlendTreeInputERNS0_15BlendTreeOutputERNS0_18BlendTreeWorkspaceERKNS0_12AnimationSetE(i4, HEAP32[i2 >> 2] | 0, HEAP32[(HEAP32[i23 >> 2] | 0) + (i12 << 2) >> 2] | 0, HEAP32[(HEAP32[i24 >> 2] | 0) + (i12 << 2) >> 2] | 0, HEAP32[i25 >> 2] | 0);
   i4 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i4 + (i12 << 2) >> 2] | 0;
   L24 : do if (!(HEAP32[i2 + 4 >> 2] | 0)) i10 = i4; else {
    i8 = 0;
    i7 = HEAP32[i2 >> 2] | 0;
    i2 = i4;
    while (1) {
     if ((HEAP32[i7 + (i8 * 24 | 0) + 4 >> 2] | 0) == -1) {
      i10 = i2;
      break L24;
     }
     i5 = HEAP32[i7 + (i8 * 24 | 0) + 20 >> 2] | 0;
     __ZN8Playable14SetInputWeightEif(i10, i5, Math_fround(HEAPF32[i7 + (i8 * 24 | 0) >> 2]));
     i5 = HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     i2 = HEAP32[i23 >> 2] | 0;
     i6 = HEAP32[i2 + (i12 << 2) >> 2] | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     HEAPF32[i5 + 104 >> 2] = Math_fround(f34 * Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 8 >> 2]));
     i4 = HEAP8[i7 + (i8 * 24 | 0) + 12 >> 0] | 0;
     if (!((i4 | i3) << 24 >> 24)) i4 = 0; else i4 = i31 & i4 << 24 >> 24 != 0 ^ 1;
     HEAP8[i5 + 112 >> 0] = i4 & 1;
     HEAPF32[i5 + 108 >> 2] = Math_fround(f17 + Math_fround(f27 + Math_fround(HEAPF32[i7 + (i8 * 24 | 0) + 16 >> 2])));
     HEAP32[i5 + 128 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i5 + 132 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i5 + 136 >> 2] = HEAP32[i20 >> 2];
     HEAP32[i5 + 156 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i5 + 160 >> 2] = HEAPU8[i13 >> 0];
     i8 = i8 + 1 | 0;
     if (i8 >>> 0 >= (HEAP32[i6 + 4 >> 2] | 0) >>> 0) {
      i10 = i2;
      break;
     }
    }
   } while (0);
   i2 = HEAP32[i28 >> 2] | 0;
   i5 = i2 + -1 | 0;
   L33 : do if ((i5 | 0) > (i12 | 0)) {
    i7 = (HEAP32[i29 >> 2] | 0) + i30 | 0;
    i8 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    f9 = Math_fround(1.0);
    do {
     while (1) {
      i6 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
      if ((i6 | 0) != -1) {
       i6 = i8 + (i6 << 2) | 0;
       i11 = HEAP32[i6 >> 2] | 0;
       if (!((i11 | 0) == 0 | (i6 | 0) == (0 - i11 | 0))) break;
      }
      i5 = i5 + -1 | 0;
      if ((i5 | 0) <= (i12 | 0)) break L33;
     }
     f9 = Math_fround(f9 - Math_fround(f9 * Math_fround(HEAPF32[i4 + (i5 << 2) >> 2])));
     i5 = i5 + -1 | 0;
    } while ((i5 | 0) > (i12 | 0));
   } else {
    f9 = Math_fround(1.0);
    i4 = HEAP32[i14 >> 2] | 0;
   } while (0);
   f36 = Math_fround(HEAPF32[(HEAP32[i10 + (i12 << 2) >> 2] | 0) + 8 >> 2]);
   f1 = Math_fround(f1 + Math_fround(f9 * Math_fround(f36 * Math_fround(HEAPF32[i4 + (i12 << 2) >> 2]))));
  }
  i12 = i12 + 1 | 0;
 } while (i12 >>> 0 < i2 >>> 0);
 return Math_fround(f1);
}

function __ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i18, f13, i3, i5, i14, i16, i17, i4, f15) {
 i18 = i18 | 0;
 f13 = Math_fround(f13);
 i3 = i3 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i19 + 88 | 0;
 i1 = i19 + 126 | 0;
 i12 = i19;
 i7 = i19 + 124 | 0;
 i8 = i19 + 122 | 0;
 i11 = i19 + 28 | 0;
 i9 = i19 + 120 | 0;
 i10 = i19 + 118 | 0;
 i2 = i19 + 116 | 0;
 switch (HEAP32[i3 >> 2] | 0) {
 case 0:
  {
   i12 = HEAP32[i3 + 4 >> 2] | 0;
   i9 = HEAP32[i5 + 16 >> 2] | 0;
   HEAP32[i6 >> 2] = i9;
   i10 = HEAP32[i5 + 20 >> 2] | 0;
   HEAP32[i6 + 4 >> 2] = i10;
   i11 = HEAP32[i5 + 24 >> 2] | 0;
   HEAP32[i6 + 8 >> 2] = i11;
   HEAP32[i6 + 12 >> 2] = i9;
   HEAP32[i6 + 16 >> 2] = i10;
   HEAP32[i6 + 20 >> 2] = i11;
   HEAP32[i6 + 24 >> 2] = i12;
   i12 = HEAP32[gb + 84516 + (HEAP32[i14 >> 2] << 2) >> 2] | 0;
   HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
   i18 = mftCall_iiiiifiif(i12 | 0, i14 | 0, i16 | 0, i6 | 0, i18 | 0, +f13, i17 | 0, i1 | 0, +f15) | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 2:
  {
   f28 = Math_fround(HEAPF32[i5 >> 2]);
   f25 = Math_fround(f28 * Math_fround(2.0));
   f22 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f23 = Math_fround(f22 * Math_fround(2.0));
   f22 = Math_fround(Math_fround(f28 * f25) + Math_fround(Math_fround(f22 * f23) + Math_fround(-1.0)));
   f28 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f21 = Math_fround(f28 * f23);
   f20 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f21 = Math_fround(f21 + Math_fround(f25 * f20));
   f20 = Math_fround(Math_fround(f25 * f28) - Math_fround(f23 * f20));
   f23 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f22 = Math_fround(f23 * f22);
   f21 = Math_fround(f23 * f21);
   f20 = Math_fround(f23 * f20);
   f23 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f28 = Math_fround(f23 + f22);
   f25 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f27 = Math_fround(f25 + f21);
   f24 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f26 = Math_fround(f20 + f24);
   HEAPF32[i12 >> 2] = f28;
   HEAPF32[i12 + 4 >> 2] = f27;
   HEAPF32[i12 + 8 >> 2] = f26;
   f21 = Math_fround(f25 - f21);
   f20 = Math_fround(f24 - f20);
   HEAPF32[i12 + 12 >> 2] = Math_fround(f23 - f22);
   HEAPF32[i12 + 16 >> 2] = f21;
   HEAPF32[i12 + 20 >> 2] = f20;
   HEAP32[i12 + 24 >> 2] = HEAP32[i3 + 4 >> 2];
   i1 = HEAP16[i4 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   if (!(i1 & 256)) {
    i11 = HEAP32[gb + 84516 + (i2 << 2) >> 2] | 0;
    HEAP16[i8 >> 1] = i1;
    i18 = mftCall_iiiiifiif(i11 | 0, i14 | 0, i16 | 0, i12 | 0, i18 | 0, +f13, i17 | 0, i8 | 0, +f15) | 0;
    STACKTOP = i19;
    return i18 | 0;
   } else {
    i11 = HEAP32[gb + 84516 + 28 + (i2 << 2) >> 2] | 0;
    HEAP16[i7 >> 1] = i1;
    i18 = mftCall_iiiiifiif(i11 | 0, i14 | 0, i16 | 0, i12 | 0, i18 | 0, +f13, i17 | 0, i7 | 0, +f15) | 0;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
 case 3:
  {
   HEAP32[i11 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i11 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i11 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
   HEAP32[i11 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
   f24 = Math_fround(HEAPF32[i5 >> 2]);
   f25 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f30 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f28 = Math_fround(f24 + f24);
   f26 = Math_fround(f25 + f25);
   f21 = Math_fround(f30 + f30);
   f29 = Math_fround(f25 * f26);
   f20 = Math_fround(f30 * f21);
   f25 = Math_fround(f28 * f25);
   f31 = Math_fround(f28 * f30);
   f27 = Math_fround(f28 * f23);
   f30 = Math_fround(f26 * f30);
   f26 = Math_fround(f26 * f23);
   f23 = Math_fround(f21 * f23);
   f21 = Math_fround(f25 + f23);
   f22 = Math_fround(f31 - f26);
   f23 = Math_fround(f25 - f23);
   f28 = Math_fround(Math_fround(1.0) - Math_fround(f24 * f28));
   f24 = Math_fround(f28 - f20);
   f25 = Math_fround(f30 + f27);
   f26 = Math_fround(f31 + f26);
   f27 = Math_fround(f30 - f27);
   f28 = Math_fround(f28 - f29);
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f29) - f20);
   HEAPF32[i11 + 4 >> 2] = f21;
   HEAPF32[i11 + 8 >> 2] = f22;
   HEAPF32[i11 + 12 >> 2] = f23;
   HEAPF32[i11 + 16 >> 2] = f24;
   HEAPF32[i11 + 20 >> 2] = f25;
   HEAPF32[i11 + 24 >> 2] = f26;
   HEAPF32[i11 + 28 >> 2] = f27;
   HEAPF32[i11 + 32 >> 2] = f28;
   i1 = HEAP16[i4 >> 1] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   if (!(i1 & 256)) {
    i12 = HEAP32[gb + 84516 + 56 + (i2 << 2) >> 2] | 0;
    HEAP16[i10 >> 1] = i1;
    i1 = mftCall_iiiiifiif(i12 | 0, i14 | 0, i16 | 0, i11 | 0, i18 | 0, +f13, i17 | 0, i10 | 0, +f15) | 0;
   } else {
    i12 = HEAP32[gb + 84516 + 84 + (i2 << 2) >> 2] | 0;
    HEAP16[i9 >> 1] = i1;
    i1 = mftCall_iiiiifiif(i12 | 0, i14 | 0, i16 | 0, i11 | 0, i18 | 0, +f13, i17 | 0, i9 | 0, +f15) | 0;
   }
   i18 = i1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 4:
  {
   i12 = HEAP32[gb + 84516 + 112 + (HEAP32[i14 >> 2] << 2) >> 2] | 0;
   HEAP16[i2 >> 1] = HEAP16[i4 >> 1] | 0;
   i18 = mftCall_iiiiiifiif(i12 | 0, i14 | 0, i16 | 0, i3 | 0, i5 | 0, i18 | 0, +f13, i17 | 0, i2 | 0, +f15) | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 default:
  {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 return 0;
}

function __ZN9DepthPass16PerformRenderingER17ShaderPassContext(i20, i15) {
 i20 = i20 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i22 + 8 | 0;
 i19 = i22;
 i21 = i22 + 16 | 0;
 i17 = i20 + 32 | 0;
 i13 = HEAP32[i20 + 12 >> 2] | 0;
 i18 = i20 + 24 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(20, gb + 64024 | 0, 16, gb + 388619 | 0, 580) | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i13 + (i14 * 24 | 0);
 HEAP32[i1 + 8 >> 2] = (i14 * 24 | 0) / 24 | 0;
 HEAP32[i1 + 16 >> 2] = gb + 1115256;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i17, fb + 3352 | 0, i1, i16, 0);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!(HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] | 0)) {
  i2 = 1;
  i3 = i1;
 } else {
  i2 = __Z22GetJobQueueThreadCountv() | 0;
  i3 = HEAP32[i18 >> 2] | 0;
 }
 i14 = ((i1 | 0) / 256 | 0) + 1 | 0;
 i14 = (i2 | 0) < (i14 | 0) ? i2 : i14;
 i12 = (i3 >>> 0) / (i14 >>> 0) | 0;
 HEAP32[i21 >> 2] = 0;
 i13 = i21 + 4 | 0;
 i10 = gb + 63160 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = i14 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 388526 | 0, 596) | 0;
   i10 = gb + 64016 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i21 >> 2] = i1;
   i11 = i13;
   HEAP32[i11 >> 2] = i9;
   HEAP32[i11 + 4 >> 2] = i10;
   break;
  }
 } while (0);
 i2 = i1 + 3 & -4;
 i11 = i2;
 i3 = (i14 | 0) > 0;
 if (i3) {
  i1 = 0;
  do {
   i4 = i11 + (i1 << 2) | 0;
   i5 = __ZnwjRK10MemLabelIdiPKci(172, gb + 64024 | 0, 16, gb + 388526 | 0, 600) | 0;
   HEAP32[i5 + 4 >> 2] = 1;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 >> 2] = gb + 36896 + 8;
   i6 = i5 + 12 | 0;
   i7 = i5 + 48 | 0;
   i8 = i5 + 52 | 0;
   i9 = i6;
   i10 = i9 + 36 | 0;
   do {
    HEAP32[i9 >> 2] = 0;
    i9 = i9 + 4 | 0;
   } while ((i9 | 0) < (i10 | 0));
   HEAP32[i8 >> 2] = 1;
   HEAP32[i7 >> 2] = gb + 33952 + 8;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 80 >> 2] = 0;
   HEAP32[i5 + 92 >> 2] = 0;
   HEAP32[i5 + 96 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 84 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 100 >> 2] = 0;
   HEAP32[i5 + 112 >> 2] = 0;
   HEAP32[i5 + 116 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 104 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i19;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i5 + 120 >> 2] = 0;
   HEAP32[i5 + 132 >> 2] = 0;
   HEAP32[i5 + 136 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i19);
   i10 = i16;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i5 + 124 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i5 + 140 >> 2] = 0;
   HEAP32[i5 + 144 >> 2] = 0;
   i8 = gb + 64024 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i5 + 148 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP8[i5 + 156 >> 0] = 1;
   i10 = i5 + 56 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   HEAP8[i5 + 160 >> 0] = 1;
   HEAP8[i5 + 161 >> 0] = 0;
   HEAP32[i4 >> 2] = i5;
   __ZN17ShaderPassContext8CopyFromERKS_(i6, i15);
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP8[i10 + 156 >> 0] = 0;
   HEAP32[i10 + 164 >> 2] = Math_imul(i1, i12) | 0;
   HEAP32[i10 + 168 >> 2] = i12;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i14 | 0));
 }
 i19 = HEAP32[i11 + (i14 + -1 << 2) >> 2] | 0;
 HEAP32[i19 + 168 >> 2] = (HEAP32[i18 >> 2] | 0) - (HEAP32[i19 + 164 >> 2] | 0);
 i19 = __Z12GetGfxDevicev() | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 892 >> 2] | 0, i19 | 0, i14 | 0, fb + 2395 | 0, i2 | 0, i20 | 0, i17 | 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i17);
 if (i3) {
  i1 = 0;
  do {
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   i19 = i2 + 4 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
   if (!(HEAP32[i19 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i14 | 0));
 }
 i19 = i20 + 4 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
 if (HEAP32[i19 >> 2] | 0) {
  i21 = HEAP32[i21 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i21, i13);
  STACKTOP = i22;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
 i21 = HEAP32[i21 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i21, i13);
 STACKTOP = i22;
 return;
}

function __ZN14SplatMaterials16LoadSplatShadersEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i2 = i9;
 i8 = __Z15GetScriptMapperv() | 0;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i5 = 10; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i2);
    i2 = HEAP32[i7 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i5 = 10;
    break;
   }
  }
  i1 = __ZN8Material9GetShaderEv(i1) | 0;
  i2 = i6 + 32 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!i1) i5 = 12; else i5 = 14;
 } while (0);
 if ((i5 | 0) == 10) {
  i2 = i6 + 32 | 0;
  HEAP32[i2 >> 2] = 0;
  i5 = 12;
 }
 if ((i5 | 0) == 12) {
  i1 = HEAP32[HEAP32[i6 + 16 >> 2] >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, _strlen(i1) | 0);
  HEAP32[i2 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i3 = i6 + 36 | 0;
   HEAP32[i3 >> 2] = 0;
  } else i5 = 14;
 }
 if ((i5 | 0) == 14) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 931221 | 0, 13);
  i3 = i6 + 36 | 0;
  HEAP32[i3 >> 2] = __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = i6 + 28 | 0;
  HEAP32[i1 >> 2] = 0;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 931235 | 0, 13);
  i10 = i6 + 28 | 0;
  HEAP32[i10 >> 2] = __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = i10;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i10 = HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i10, _strlen(i10) | 0);
  HEAP32[i3 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i10 = HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i10, _strlen(i10) | 0);
  HEAP32[i1 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i1 = i6 + 28 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 935336 | 0, 7);
  HEAP32[i1 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = 1;
 } else i1 = 0;
 i2 = i6 + 32 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 935336 | 0, 7);
  HEAP32[i2 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i2 = 1;
 } else i2 = i1;
 i1 = i6 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 935336 | 0, 7);
  HEAP32[i1 >> 2] = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 } else if (!i2) {
  STACKTOP = i9;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 935217 | 0, 0, gb + 931249 | 0, 384, 1, 0, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim25visualizeCollisionNormalsERNS_2Cm12RenderOutputE(i2, i24) {
 i2 = i2 | 0;
 i24 = i24 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, i30 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i26 + 136 | 0;
 i4 = i26 + 96 | 0;
 i3 = i26 + 32 | 0;
 i21 = i26;
 HEAP32[i6 + 16 >> 2] = 0;
 i22 = i6 + 20 | 0;
 HEAP32[i22 >> 2] = 12;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 12;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 4;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 4;
 i1 = i2 + 56 | 0;
 i23 = HEAP32[i1 >> 2] | 0;
 i23 = mftCall_ii(HEAP32[HEAP32[i23 >> 2] >> 2] | 0, i23 | 0) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i23 >> 2] | 0) + 20 >> 2] | 0, i23 | 0, i6 | 0, 0, 0);
 if (!(HEAP32[i6 + 4 >> 2] | 0)) {
  STACKTOP = i26;
  return;
 }
 i19 = i2 + 52 | 0;
 i23 = (__ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(HEAP32[i19 >> 2] | 0) | 0) & 1;
 i19 = (__ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(HEAP32[i19 >> 2] | 0) | 0) & 16;
 if (i19 << 16 >> 16 == 0 | (i23 << 16 >> 16 == 0 | !(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0, 25)) > Math_fround(0.0)))) {
  STACKTOP = i26;
  return;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 8 >> 2] = 0;
 i23 = i4 + 12 | 0;
 HEAP32[i23 >> 2] = 12;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 12;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 12;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 4;
 i17 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i17 >> 2] | 0) + 4 >> 2] | 0, i17 | 0, i4 | 0, 0);
 f20 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0, 25));
 f20 = Math_fround(f20 * Math_fround(HEAPF32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0) + 1408 >> 2]));
 i17 = __ZN5physx2Cm12RenderOutputlsEj(i24, -16711936) | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i19 = i3 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAPF32[i3 + 20 >> 2] = Math_fround(1.0);
 i19 = i3 + 24 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAPF32[i3 + 40 >> 2] = Math_fround(1.0);
 i19 = i3 + 44 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i17, i3) | 0;
 i17 = i4 + 8 | 0;
 L7 : do if (HEAP32[i17 >> 2] | 0) {
  i18 = HEAP32[i6 + 12 >> 2] | 0;
  i19 = i18 + 4 | 0;
  i4 = HEAP32[i19 >> 2] & 2147483647;
  if (i4 | 0) {
   i3 = HEAP32[i18 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (i2 | 0) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) break L7;
   }
   i7 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i7 = HEAP32[gb + 90668 + (i7 << 2) >> 2] | i1 << 5;
   i2 = i2 + -1 & i2;
   L14 : do if (!i2) do {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) {
     i2 = 0;
     break L14;
    }
    i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   } while ((i2 | 0) == 0); while (0);
   if ((i7 | 0) != -1) {
    i9 = i6 + 16 | 0;
    f10 = Math_fround(f20 * Math_fround(.100000001));
    i11 = i21 + 4 | 0;
    i12 = i21 + 8 | 0;
    i13 = i21 + 12 | 0;
    i14 = i21 + 16 | 0;
    i15 = i21 + 20 | 0;
    i16 = i21 + 24 | 0;
    i3 = i7;
    do {
     i8 = i1 << 5;
     while (1) {
      i7 = HEAP32[i17 >> 2] | 0;
      i4 = Math_imul(HEAP32[i23 >> 2] | 0, i3) | 0;
      f5 = Math_fround(HEAPF32[i7 + i4 >> 2]);
      i6 = i7 + (i4 + 4) | 0;
      if (f5 == Math_fround(0.0)) if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0)) {
       if (!(Math_fround(HEAPF32[i7 + (i4 + 8) >> 2]) == Math_fround(0.0))) i25 = 18;
      } else i25 = 18; else i25 = 18;
      if ((i25 | 0) == 18) {
       i25 = 0;
       i30 = HEAP32[i9 >> 2] | 0;
       i29 = Math_imul(HEAP32[i22 >> 2] | 0, i3) | 0;
       i3 = i30 + i29 | 0;
       f28 = Math_fround(f20 * f5);
       f27 = Math_fround(f20 * Math_fround(HEAPF32[i6 >> 2]));
       f5 = Math_fround(f20 * Math_fround(HEAPF32[i7 + (i4 + 8) >> 2]));
       HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
       i6 = i30 + (i29 + 4) | 0;
       HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
       i7 = i30 + (i29 + 8) | 0;
       HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
       f28 = Math_fround(f28 + Math_fround(HEAPF32[i3 >> 2]));
       f27 = Math_fround(f27 + Math_fround(HEAPF32[i6 >> 2]));
       f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 >> 2]));
       HEAPF32[i13 >> 2] = f28;
       HEAPF32[i14 >> 2] = f27;
       HEAPF32[i15 >> 2] = f5;
       HEAPF32[i16 >> 2] = f10;
       __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i24, i21) | 0;
      }
      if (!i2) break L7;
      i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
      i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i8;
      i2 = i2 + -1 & i2;
      if (!i2) break;
      if ((i3 | 0) == -1) break L7;
     }
     i4 = HEAP32[i19 >> 2] & 2147483647;
     do {
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i4 >>> 0) {
       i2 = 0;
       break;
      }
      i2 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     } while ((i2 | 0) == 0);
    } while ((i3 | 0) != -1);
   }
  }
 } while (0);
 STACKTOP = i26;
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb0EE4initEPKc(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 12 | 0;
 i4 = i6;
 i8 = _newlocale(2147483647, i1, 0) | 0;
 i9 = (i8 | 0) == 0;
 L1 : do if (i9) {
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i6 = _strlen(i1) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i4 | 0, i1 | 0, i6 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i4 | 0, 0, gb + 1081806 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i7 | 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } else {
  __THREW__ = 0;
  i2 = invoke_ii(fb + 2805 | 0, i8 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  do if (i4 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i4 = invoke_i(fb + 318 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    if (!i2) break;
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) break;
    i3 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i3);
   }
   if (i2 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i3 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i3);
    }
   }
   i3 = HEAP8[HEAP32[i4 + 20 >> 2] >> 0] | 0;
   HEAP8[i5 + 8 >> 0] = i3 << 24 >> 24 == 0 ? 127 : i3;
   i3 = HEAP8[HEAP32[i4 + 24 >> 2] >> 0] | 0;
   HEAP8[i5 + 9 >> 0] = i3 << 24 >> 24 == 0 ? 127 : i3;
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, i5 + 12 | 0, HEAP32[i4 + 28 >> 2] | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   do if (!(i3 & 1)) {
    i2 = i5 + 24 | 0;
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, i2 | 0, HEAP32[i4 + 16 >> 2] | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i3 = HEAP8[i4 + 41 >> 0] | 0;
     HEAP32[i5 + 60 >> 2] = i3 << 24 >> 24 == 127 ? 0 : i3 << 24 >> 24;
     i3 = i4 + 46 | 0;
     i1 = i5 + 36 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, gb + 1081849 | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) break;
     } else {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, HEAP32[i4 + 32 >> 2] | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) break;
     }
     i1 = i5 + 48 | 0;
     if (!(HEAP8[i4 + 47 >> 0] | 0)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, gb + 1081849 | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) break;
     } else {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, i1 | 0, HEAP32[i4 + 36 >> 2] | 0) | 0;
      i1 = __THREW__;
      __THREW__ = 0;
      if (i1 & 1) break;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4529 | 0, i7 | 0, i2 | 0);
     i1 = __THREW__;
     __THREW__ = 0;
     if (!(i1 & 1)) {
      i1 = HEAP16[i4 + 42 >> 1] | 0;
      __THREW__ = 0;
      invoke_viiiiii(fb + 203 | 0, i5 + 64 | 0, i7 | 0, 0, i1 & 255 | 0, (i1 & 65535) >>> 8 & 255 | 0, HEAP8[i3 >> 0] | 0);
      i3 = __THREW__;
      __THREW__ = 0;
      if (!(i3 & 1)) {
       i4 = HEAP32[i4 + 44 >> 2] | 0;
       __THREW__ = 0;
       invoke_viiiiii(fb + 203 | 0, i5 + 68 | 0, i2 | 0, 0, i4 & 255 | 0, (i4 & 65535) >>> 8 & 255 | 0, i4 >>> 24 & 255 | 0);
       i5 = __THREW__;
       __THREW__ = 0;
       if (!(i5 & 1)) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
        __THREW__ = 0;
        invoke_vi(fb + 4002 | 0, i8 | 0);
        i5 = __THREW__;
        __THREW__ = 0;
        if (i5 & 1) {
         i6 = ___cxa_find_matching_catch_3(0) | 0;
         getTempRet0() | 0;
         ___clang_call_terminate(i6);
        } else {
         STACKTOP = i6;
         return;
        }
       }
      }
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
      break L1;
     }
    }
   } while (0);
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break L1;
  } while (0);
 } while (0);
 if (!i9) {
  __THREW__ = 0;
  invoke_vi(fb + 4002 | 0, i8 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  }
 }
 ___resumeException(i1 | 0);
}

function __ZN7SubMesh8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 4 | 0;
 i11 = i12;
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i4 = i6 + 32 | 0;
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426529 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426539 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i5 = i6 + 40 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16GfxPrimitiveTypeEvRT_RT0_PKc17TransferMetaFlags(i10, i5, gb + 426550 | 0, 0);
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426457 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426469 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426559 | 0, gb + 1034406 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i10, 1) | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 426569 | 0, i7, i8, 0) | 0;
 if (!i1) i1 = 0; else {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i8 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i9 = 57; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 57; else {
     HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i11, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = (HEAP32[i11 >> 2] | 0) != 0;
 }
 HEAP32[i5 >> 2] = i1 & 1;
 STACKTOP = i12;
 return;
}

function __ZN5physx16PxVehicleDriveNW17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i2 + 320 | 0;
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i13 >> 2] = HEAP32[gb + 161456 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 161456 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 161456 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 161456 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 161456 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[gb + 161456 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[gb + 161456 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[gb + 161456 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i13 | 0, 32) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 161488 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 161488 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 161488 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 161488 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 161488 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 161488 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 161488 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 161488 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 161520 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 161520 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 161520 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 161520 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 161520 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 161520 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 161520 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 161520 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 161552 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 161552 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 161552 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 161552 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 161552 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 161552 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 161552 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 161552 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 161584 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 161584 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 161584 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 161584 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 161584 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 161584 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 161584 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 161584 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 161616 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 161616 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 161616 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 161616 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 161616 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 161616 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 161616 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 161616 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 828758;
 HEAP32[i7 + 4 >> 2] = gb + 827821;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 544;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 161648 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 161648 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 161648 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 161648 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 161648 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 161648 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 161648 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 161648 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 165808 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 165808 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 165808 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 165808 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 165808 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 165808 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 165808 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 165808 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 834943;
 HEAP32[i4 + 4 >> 2] = gb + 828300;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 768;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 165840 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 165840 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 165840 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 165840 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 165840 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 165840 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 165840 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 165840 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx29PxClothSimpleTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i26, i1) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i30 + 40 | 0;
 i13 = i30 + 24 | 0;
 i25 = i30 + 12 | 0;
 i20 = i30 + 8 | 0;
 i23 = i30 + 4 | 0;
 i22 = i30;
 i24 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 HEAP32[i29 >> 2] = 0;
 i19 = i29 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i28 = i29 + 8 | 0;
 HEAP32[i28 >> 2] = 0;
 i21 = (i24 | 0) == 0;
 if (!i21) {
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i29, i24);
  i14 = HEAP32[i1 >> 2] | 0;
  i15 = HEAP32[i1 + 12 >> 2] | 0;
  i16 = i13 + 4 | 0;
  i17 = i13 + 8 | 0;
  i18 = i13 + 12 | 0;
  i9 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = 0;
  while (1) {
   i2 = i9;
   if (!i1) {
    i6 = 0;
    f5 = Math_fround(1.0);
   } else {
    i6 = i1 + i15 | 0;
    f5 = Math_fround(HEAPF32[i1 >> 2]);
   }
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = i4;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP32[i17 >> 2] = i1;
   HEAPF32[i18 >> 2] = f5;
   i2 = HEAP32[i19 >> 2] | 0;
   if ((HEAP32[i28 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i31 = HEAP32[i29 >> 2] | 0;
    HEAP32[i31 + (i2 << 4) >> 2] = i3;
    HEAP32[i31 + (i2 << 4) + 4 >> 2] = i4;
    HEAP32[i31 + (i2 << 4) + 8 >> 2] = i1;
    HEAPF32[i31 + (i2 << 4) + 12 >> 2] = f5;
    HEAP32[i19 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i29, i13) | 0;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i24 | 0)) break; else {
    i9 = i9 + i14 | 0;
    i1 = i6;
   }
  }
 }
 HEAP32[i25 >> 2] = 0;
 i1 = i25 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i18 = i25 + 8 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 if (i21) i27 = 18; else {
  i2 = HEAP32[i29 >> 2] | 0;
  i3 = 0;
  do {
   do if (Math_fround(HEAPF32[i2 + (i3 << 4) + 12 >> 2]) == Math_fround(0.0)) {
    i4 = HEAP32[i1 >> 2] | 0;
    if ((HEAP32[i18 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     HEAP32[(HEAP32[i25 >> 2] | 0) + (i4 << 2) >> 2] = i3;
     HEAP32[i1 >> 2] = i4 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i25, i20) | 0;
     break;
    }
   } while (0);
   i3 = i3 + 1 | 0;
   HEAP32[i20 >> 2] = i3;
  } while (i3 >>> 0 < i24 >>> 0);
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == 0 | i21) i27 = 18; else {
   i9 = i26 + 8 | 0;
   i13 = i26 + 12 | 0;
   i14 = i26 + 20 | 0;
   i15 = HEAP32[i29 >> 2] | 0;
   i16 = HEAP32[i25 >> 2] | 0;
   i1 = i26 + 4 | 0;
   i17 = i26 + 16 | 0;
   i6 = i16 + (i2 << 2) | 0;
   i7 = 0;
   do {
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 < i24 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i26, i24);
    if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 < i24 >>> 0) __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj(i13, i24);
    f10 = Math_fround(HEAPF32[i15 + (i7 << 4) >> 2]);
    f11 = Math_fround(HEAPF32[i15 + (i7 << 4) + 4 >> 2]);
    f12 = Math_fround(HEAPF32[i15 + (i7 << 4) + 8 >> 2]);
    HEAP32[i23 >> 2] = i24;
    i3 = i24;
    i4 = i16;
    f8 = Math_fround(3402823469999999843913219.0e14);
    while (1) {
     i2 = HEAP32[i4 >> 2] | 0;
     f33 = Math_fround(Math_fround(HEAPF32[i15 + (i2 << 4) >> 2]) - f10);
     f32 = Math_fround(Math_fround(HEAPF32[i15 + (i2 << 4) + 4 >> 2]) - f11);
     f5 = Math_fround(Math_fround(HEAPF32[i15 + (i2 << 4) + 8 >> 2]) - f12);
     f5 = Math_fround(Math_fround(Math_fround(f33 * f33) + Math_fround(f32 * f32)) + Math_fround(f5 * f5));
     if (f8 > f5) {
      HEAP32[i23 >> 2] = i2;
      i3 = i2;
     } else f5 = f8;
     i4 = i4 + 4 | 0;
     if ((i4 | 0) == (i6 | 0)) break; else f8 = f5;
    }
    i2 = HEAP32[i1 >> 2] | 0;
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i26 >> 2] | 0) + (i2 << 2) >> 2] = i3;
     HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i26, i23) | 0;
    f5 = Math_fround(Math_sqrt(Math_fround(f5)));
    HEAPF32[i22 >> 2] = f5;
    i2 = HEAP32[i17 >> 2] | 0;
    if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAPF32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = f5;
     HEAP32[i17 >> 2] = i2 + 1;
    } else __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf(i13, i22) | 0;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i24 | 0));
  }
 }
 if ((i27 | 0) == 18) i1 = i26 + 4 | 0;
 if ((i24 | 0) == (HEAP32[i1 >> 2] | 0)) if ((i24 | 0) == (HEAP32[i26 + 16 >> 2] | 0)) HEAP32[i26 + 24 >> 2] = 0;
 i31 = HEAP32[i18 >> 2] | 0;
 if ((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i25 >> 2] | 0;
  if (i1 | 0) {
   i31 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, i1 | 0);
  }
 }
 i31 = HEAP32[i28 >> 2] | 0;
 if (!((i31 | 0) > -1 & (i31 & 2147483647 | 0) != 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = HEAP32[i29 >> 2] | 0;
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i31 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i31 >> 2] | 0) + 12 >> 2] | 0, i31 | 0, i1 | 0);
 STACKTOP = i30;
 return;
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i3, i4, i5, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 i2 = i5 + 4 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = (i6 | 0) == 0 ? 0 : i6 + i2 | 0;
 i6 = i3 + 4 | 0;
 i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i7 << 3) >> 2] | 0;
 if ((i6 | 0) == -1) {
  i8 = HEAP32[i1 + (i7 * 40 | 0) + 4 >> 2] | 0;
  i5 = HEAP32[i1 + (i7 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i2 + (i7 * 40 | 0) >> 2] = HEAP32[i1 + (i7 * 40 | 0) >> 2];
  HEAP32[i2 + (i7 * 40 | 0) + 4 >> 2] = i8;
  HEAP32[i2 + (i7 * 40 | 0) + 8 >> 2] = i5;
  i5 = HEAP32[i1 + (i7 * 40 | 0) + 16 >> 2] | 0;
  i8 = HEAP32[i1 + (i7 * 40 | 0) + 20 >> 2] | 0;
  i6 = HEAP32[i1 + (i7 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i2 + (i7 * 40 | 0) + 12 >> 2] = HEAP32[i1 + (i7 * 40 | 0) + 12 >> 2];
  HEAP32[i2 + (i7 * 40 | 0) + 16 >> 2] = i5;
  HEAP32[i2 + (i7 * 40 | 0) + 20 >> 2] = i8;
  HEAP32[i2 + (i7 * 40 | 0) + 24 >> 2] = i6;
  i6 = HEAP32[i1 + (i7 * 40 | 0) + 32 >> 2] | 0;
  i8 = HEAP32[i1 + (i7 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i2 + (i7 * 40 | 0) + 28 >> 2] = HEAP32[i1 + (i7 * 40 | 0) + 28 >> 2];
  HEAP32[i2 + (i7 * 40 | 0) + 32 >> 2] = i6;
  HEAP32[i2 + (i7 * 40 | 0) + 36 >> 2] = i8;
  return;
 }
 if ((i7 | 0) != (i8 | 0)) __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i3, i4, i5, i6, i8);
 f26 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) >> 2]);
 f22 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 28 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 32 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 36 >> 2]);
 f26 = Math_fround(f26 * f17);
 f22 = Math_fround(f22 * f16);
 f20 = Math_fround(f20 * f9);
 f19 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 20 >> 2]);
 f27 = Math_fround(f19 * Math_fround(-2.0));
 f11 = Math_fround(f19 * Math_fround(2.0));
 f24 = Math_fround(f27 * f21);
 f18 = Math_fround(f23 * Math_fround(2.0));
 f10 = Math_fround(f23 * Math_fround(-2.0));
 f28 = Math_fround(f21 * f10);
 f12 = Math_fround(f25 * Math_fround(-2.0));
 f14 = Math_fround(f25 * Math_fround(2.0));
 f13 = Math_fround(f21 * f12);
 f15 = Math_fround(Math_fround(f26 + Math_fround(f26 * Math_fround(Math_fround(f19 * f27) - Math_fround(f23 * f18)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f14 * f23) - f24)) + Math_fround(f22 * Math_fround(f28 - Math_fround(f19 * f12)))));
 f14 = Math_fround(Math_fround(f22 + Math_fround(f26 * Math_fround(Math_fround(f25 * f11) - f28))) + Math_fround(Math_fround(f20 * Math_fround(f13 - Math_fround(f27 * f23))) + Math_fround(f22 * Math_fround(Math_fround(f23 * f10) - Math_fround(f25 * f14)))));
 f13 = Math_fround(Math_fround(f20 + Math_fround(f26 * Math_fround(f24 - Math_fround(f25 * f10)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f25 * f12) - Math_fround(f19 * f11))) + Math_fround(f22 * Math_fround(Math_fround(f19 * f18) - f13))));
 f18 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) >> 2]);
 f22 = Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 4 >> 2]);
 f15 = Math_fround(f18 + f15);
 f14 = Math_fround(f22 + f14);
 f13 = Math_fround(Math_fround(HEAPF32[i2 + (i6 * 40 | 0) + 8 >> 2]) + f13);
 f22 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 12 >> 2]);
 f18 = Math_fround(f19 * f22);
 f11 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 24 >> 2]);
 f12 = Math_fround(f21 * f11);
 f20 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 16 >> 2]);
 f10 = Math_fround(f23 * f20);
 f24 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 20 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f21 * f24)) - Math_fround(f23 * f11)) - Math_fround(f25 * f20));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f25 * f22)) - Math_fround(f23 * f24)) - Math_fround(f19 * f20));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f19 * f24)) - Math_fround(f21 * f22)) - Math_fround(f25 * f11));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f20)) - Math_fround(f19 * f11));
 i8 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f11 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 32 >> 2]);
 f11 = Math_fround(f17 * f11);
 f10 = Math_fround(f16 * f10);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 36 >> 2]));
 HEAPF32[i2 + (i7 * 40 | 0) >> 2] = f15;
 HEAPF32[i2 + (i7 * 40 | 0) + 4 >> 2] = f14;
 HEAPF32[i2 + (i7 * 40 | 0) + 8 >> 2] = f13;
 HEAP32[i2 + (i7 * 40 | 0) + 12 >> 2] = i5 ^ -2147483648;
 HEAP32[i2 + (i7 * 40 | 0) + 16 >> 2] = i6;
 HEAP32[i2 + (i7 * 40 | 0) + 20 >> 2] = i8 ^ -2147483648;
 HEAPF32[i2 + (i7 * 40 | 0) + 24 >> 2] = f12;
 HEAPF32[i2 + (i7 * 40 | 0) + 28 >> 2] = f11;
 HEAPF32[i2 + (i7 * 40 | 0) + 32 >> 2] = f10;
 HEAPF32[i2 + (i7 * 40 | 0) + 36 >> 2] = f9;
 return;
}

function __ZN8VRDevice19RenderOcclusionMeshEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 40 | 0;
 i13 = i17 + 36 | 0;
 i14 = i17 + 32 | 0;
 i15 = i17 + 16 | 0;
 i16 = i17;
 if (!(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i3 = i11 + 316 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) < 0) {
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i11 + 248 >> 2] | 0;
 if (i2 | 0) mftCall_vi(i2 | 0, i1 | 0);
 i8 = i11 + 244 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i9 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[i9 + 4212 >> 2] | 0;
 if (!i10) {
  HEAP32[i14 >> 2] = 0;
  mftCall_viiii(HEAP32[i8 >> 2] | 0, HEAP32[i3 >> 2] | 0, i12 | 0, i13 | 0, i14 | 0);
  __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0);
  STACKTOP = i17;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 856 >> 2] | 0, i9 | 0, 0);
 i1 = i15 + 4 | 0;
 i2 = i15 + 8 | 0;
 i3 = i15 + 12 | 0;
 i4 = i16 + 8 | 0;
 i5 = i16 + 4 | 0;
 i6 = i16 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 mftCall_viiii(HEAP32[i8 >> 2] | 0, 0, i12 | 0, i13 | 0, i14 | 0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i7 = mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0, i11 | 0, 0, i15 | 0) | 0;
 if ((i10 | 0) == 2) {
  if (i7) {
   i20 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 360 >> 2] | 0, i9 | 0) | 0;
   i18 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 364 >> 2] | 0, i9 | 0) | 0;
   f22 = Math_fround(i20 | 0);
   i20 = ~~Math_fround(f22 * Math_fround(HEAPF32[i15 >> 2]));
   f21 = Math_fround(i18 | 0);
   i18 = ~~Math_fround(f21 * Math_fround(HEAPF32[i1 >> 2]));
   i19 = ~~Math_fround(f22 * Math_fround(HEAPF32[i2 >> 2]));
   i7 = ~~Math_fround(f21 * Math_fround(HEAPF32[i3 >> 2]));
   HEAP32[i16 >> 2] = i20;
   HEAP32[i4 >> 2] = i19;
   HEAP32[i5 >> 2] = i18;
   HEAP32[i6 >> 2] = i7;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i16 | 0);
  }
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(__ZN13RenderTexture9GetActiveEi(0) | 0, 0, -1, 0, 0);
  __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0);
  HEAP32[i14 >> 2] = 0;
  mftCall_viiii(HEAP32[i8 >> 2] | 0, 1, i12 | 0, i13 | 0, i14 | 0);
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0, i11 | 0, 1, i15 | 0) | 0) {
   i18 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 360 >> 2] | 0, i9 | 0) | 0;
   i19 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 364 >> 2] | 0, i9 | 0) | 0;
   f21 = Math_fround(i18 | 0);
   i15 = ~~Math_fround(f21 * Math_fround(HEAPF32[i15 >> 2]));
   f22 = Math_fround(i19 | 0);
   i19 = ~~Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
   i18 = ~~Math_fround(f21 * Math_fround(HEAPF32[i2 >> 2]));
   i20 = ~~Math_fround(f22 * Math_fround(HEAPF32[i3 >> 2]));
   HEAP32[i16 >> 2] = i15;
   HEAP32[i4 >> 2] = i18;
   HEAP32[i5 >> 2] = i19;
   HEAP32[i6 >> 2] = i20;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i16 | 0);
  }
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(__ZN13RenderTexture9GetActiveEi(0) | 0, 0, -1, 1, 0);
  __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0);
 } else {
  if (i7) {
   i7 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 360 >> 2] | 0, i9 | 0) | 0;
   i19 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 364 >> 2] | 0, i9 | 0) | 0;
   f21 = Math_fround(i7 | 0);
   i7 = ~~Math_fround(f21 * Math_fround(HEAPF32[i15 >> 2]));
   f22 = Math_fround(i19 | 0);
   i19 = ~~Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
   i18 = ~~Math_fround(f21 * Math_fround(HEAPF32[i2 >> 2]));
   i20 = ~~Math_fround(f22 * Math_fround(HEAPF32[i3 >> 2]));
   HEAP32[i16 >> 2] = i7;
   HEAP32[i4 >> 2] = i18;
   HEAP32[i5 >> 2] = i19;
   HEAP32[i6 >> 2] = i20;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i16 | 0);
  }
  __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0);
  HEAP32[i14 >> 2] = 0;
  mftCall_viiii(HEAP32[i8 >> 2] | 0, 1, i12 | 0, i13 | 0, i14 | 0);
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0, i11 | 0, 1, i15 | 0) | 0) {
   i18 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 360 >> 2] | 0, i9 | 0) | 0;
   i19 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 364 >> 2] | 0, i9 | 0) | 0;
   f21 = Math_fround(i18 | 0);
   i15 = ~~Math_fround(f21 * Math_fround(HEAPF32[i15 >> 2]));
   f22 = Math_fround(i19 | 0);
   i19 = ~~Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
   i18 = ~~Math_fround(f21 * Math_fround(HEAPF32[i2 >> 2]));
   i20 = ~~Math_fround(f22 * Math_fround(HEAPF32[i3 >> 2]));
   HEAP32[i16 >> 2] = i15;
   HEAP32[i4 >> 2] = i18;
   HEAP32[i5 >> 2] = i19;
   HEAP32[i6 >> 2] = i20;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i16 | 0);
  }
  __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 856 >> 2] | 0, i9 | 0, i10 | 0);
 STACKTOP = i17;
 return;
}

function __ZN4Mesh9SetColorsEPK11ColorRGBA32j(i9, i2, i5) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i10 = i11 + 24 | 0;
 i6 = i11 + 8 | 0;
 i7 = i9 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i3 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i7 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i12 = i3 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i7 >> 2] = i1;
  i3 = i1;
 }
 if (!((i2 | 0) != 0 & (i5 | 0) != 0)) {
  i1 = i3 + 8 | 0;
  i2 = HEAP32[i3 + 100 >> 2] | 0;
  if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  } else i8 = 8; else i8 = 8;
  if ((i8 | 0) == 8) {
   HEAP32[i6 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i2, 0, 4, i6, gb + 1546313 | 0);
  i5 = i9 + 44 | 0;
  i1 = HEAP8[i5 >> 0] | 1;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i10 >> 2] = gb + 30832;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = i9;
  i2 = HEAP32[i9 + 236 >> 2] | 0;
  i4 = i9 + 232 | 0;
  i3 = i2;
  if ((i3 | 0) != (i4 | 0)) {
   i1 = i3;
   do {
    i12 = i2;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
    i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   i1 = HEAP8[i5 >> 0] | 0;
  }
  HEAP8[i5 >> 0] = i1 & -17;
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i3 + 100 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[gb + 58184 + 8 >> 2];
  __Z6FormatPKcz(i10, gb + 427581 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 942, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return;
 }
 i1 = i3 + 8 | 0;
 if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
  HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 } else i8 = 18; else i8 = 18;
 if ((i8 | 0) == 18) {
  HEAP32[i6 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i5, 4, 0, i6, gb + 1546313 | 0);
 i12 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0;
 i6 = i9 + 44 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] & -17 | i12 << 4 & 255;
 i5 = i2 + (i5 << 2) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i1 = HEAP16[i3 + 18 >> 1] | 0;
 i1 = (i1 & 65535) < 1024 | (i1 & 255) != 2;
 if (!(i12 << 24 >> 24)) {
  if (i1) {
   i1 = 0;
   i3 = 0;
  } else {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i3 = 1;
   } else if (!(HEAP8[i3 + 19 >> 0] | 0)) {
    i1 = 0;
    i3 = 1;
   } else {
    i12 = HEAP16[i3 + 16 >> 1] | 0;
    i1 = i1 + (((i12 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i12 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i3 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
  }
 } else {
  if (i1) {
   i1 = 0;
   i4 = 0;
  } else {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i4 = 1;
   } else if (!(HEAP8[i3 + 19 >> 0] | 0)) {
    i1 = 0;
    i4 = 1;
   } else {
    i12 = HEAP16[i3 + 16 >> 1] | 0;
    i1 = i1 + (((i12 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i12 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i4 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  i3 = i1;
  while (1) {
   i12 = HEAP32[i2 >> 2] | 0;
   HEAP32[i1 >> 2] = i12 & -16777216 | HEAPU8[i2 + 2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | i12 << 16 & 16711680;
   i2 = i2 + 4 | 0;
   i1 = i3 + i4 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i1;
  }
 }
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 1;
 HEAP32[i10 >> 2] = gb + 30832;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = i9;
 i2 = HEAP32[i9 + 236 >> 2] | 0;
 i3 = i9 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i12 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i11;
 return;
}

function __ZN26EnlightenSystemInformation8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402714 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402728 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402741 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402752 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402765 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 50; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 50; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402778 | 0, gb + 455698 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402794 | 0, gb + 455698 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z29CalculatePolygonSubmergedAreaRK11b2TransformiPK6b2Vec2RK10b2MassDatafRS2_(i19, i16, i17, i14, f1, i22) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 f1 = Math_fround(f1);
 i22 = i22 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i15 = 0, i18 = 0, f20 = f0, i21 = 0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 8 | 0;
 i18 = i24;
 f23 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f2 = Math_fround(f23 * Math_fround(0.0));
 f20 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f2 = Math_fround(f2 + f20);
 f3 = Math_fround(f23 - Math_fround(f20 * Math_fround(0.0)));
 f10 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(f10 * Math_fround(0.0));
 i21 = i19 + 4 | 0;
 f13 = Math_fround(HEAPF32[i21 >> 2]);
 f1 = Math_fround(f1 - Math_fround(f25 + f13));
 if ((i16 | 0) > 0) {
  i7 = 0;
  i4 = -1;
  i5 = -1;
  i11 = 0;
  i12 = 0;
 } else {
  f25 = Math_fround(0.0);
  STACKTOP = i24;
  return Math_fround(f25);
 }
 while (1) {
  f25 = Math_fround(f2 * Math_fround(HEAPF32[i17 + (i12 << 3) >> 2]));
  f25 = Math_fround(Math_fround(f25 + Math_fround(f3 * Math_fround(HEAPF32[i17 + (i12 << 3) + 4 >> 2]))) - f1);
  HEAPF32[i15 + (i12 << 2) >> 2] = f25;
  i8 = i11;
  i11 = f25 < Math_fround(-1.1920929e-07);
  do if ((i12 | 0) > 0) {
   i9 = i12 + -1 | 0;
   i6 = i7 + 1 | 0;
   if (i11) {
    i6 = i8 ? i7 : i6;
    i4 = i8 ? i4 : i9;
    break;
   } else {
    i6 = i8 ? i6 : i7;
    i5 = i8 ? i9 : i5;
    break;
   }
  } else i6 = i7; while (0);
  i12 = i12 + 1 | 0;
  if ((i12 | 0) == (i16 | 0)) break; else i7 = i6;
 }
 switch (i6 | 0) {
 case 0:
  {
   if (!i11) {
    f25 = Math_fround(0.0);
    STACKTOP = i24;
    return Math_fround(f25);
   }
   f25 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f2 = Math_fround(f23 * f25);
   f3 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f25 = Math_fround(Math_fround(Math_fround(f25 * f20) + Math_fround(f23 * f3)) + f13);
   HEAPF32[i22 >> 2] = Math_fround(f10 + Math_fround(f2 - Math_fround(f20 * f3)));
   HEAPF32[i22 + 4 >> 2] = f25;
   f25 = Math_fround(HEAPF32[i14 + 16 >> 2]);
   STACKTOP = i24;
   return Math_fround(f25);
  }
 case 1:
  {
   i12 = (i4 | 0) == -1;
   i14 = i16 + -1 | 0;
   i4 = i12 ? i14 : i4;
   i5 = i12 ? i5 : i14;
   break;
  }
 default:
  {}
 }
 i6 = (i4 + 1 | 0) % (i16 | 0) | 0;
 i9 = (i5 + 1 | 0) % (i16 | 0) | 0;
 f10 = Math_fround(HEAPF32[i15 + (i4 << 2) >> 2]);
 f25 = Math_fround(-f10);
 f10 = Math_fround(f25 / Math_fround(Math_fround(HEAPF32[i15 + (i6 << 2) >> 2]) - f10));
 f25 = Math_fround(HEAPF32[i15 + (i5 << 2) >> 2]);
 f3 = Math_fround(-f25);
 f25 = Math_fround(f3 / Math_fround(Math_fround(HEAPF32[i15 + (i9 << 2) >> 2]) - f25));
 f3 = Math_fround(Math_fround(1.0) - f10);
 f2 = Math_fround(Math_fround(1.0) - f25);
 f13 = Math_fround(Math_fround(HEAPF32[i17 + (i4 << 3) >> 2]) * f3);
 i7 = i17 + (i6 << 3) | 0;
 f13 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2])));
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i17 + (i4 << 3) + 4 >> 2]));
 i4 = i17 + (i6 << 3) + 4 | 0;
 f10 = Math_fround(f3 + Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])));
 f3 = Math_fround(f2 * Math_fround(HEAPF32[i17 + (i5 << 3) >> 2]));
 f3 = Math_fround(f3 + Math_fround(f25 * Math_fround(HEAPF32[i17 + (i9 << 3) >> 2])));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i17 + (i5 << 3) + 4 >> 2]));
 f25 = Math_fround(f2 + Math_fround(f25 * Math_fround(HEAPF32[i17 + (i9 << 3) + 4 >> 2])));
 HEAPF32[i18 >> 2] = f3;
 HEAPF32[i18 + 4 >> 2] = f25;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 i8 = i22 + 4 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 if ((i6 | 0) == (i9 | 0)) {
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f3 = Math_fround(0.0);
  i5 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  do {
   i6 = (i6 + 1 | 0) % (i16 | 0) | 0;
   i15 = (i6 | 0) == (i9 | 0);
   i11 = i15 ? i18 : i17 + (i6 << 3) | 0;
   i12 = i5;
   i5 = HEAP32[i11 >> 2] | 0;
   i14 = i4;
   i4 = HEAP32[i11 + 4 >> 2] | 0;
   f28 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = Math_fround(f28 - f13);
   f29 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(f29 - f10);
   f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(f27 - f13);
   f25 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = Math_fround(Math_fround(Math_fround(f31 * Math_fround(f25 - f10)) - Math_fround(f30 * f26)) * Math_fround(.5));
   f3 = Math_fround(f3 + f26);
   f26 = Math_fround(f26 * Math_fround(.333333343));
   f25 = Math_fround(Math_fround(Math_fround(f10 + f29) + f25) * f26);
   f2 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f13 + f28) + f27) * f26));
   HEAPF32[i22 >> 2] = f2;
   f1 = Math_fround(f1 + f25);
   HEAPF32[i8 >> 2] = f1;
  } while (!i15);
 }
 f29 = Math_fround(Math_fround(1.0) / f3);
 f31 = Math_fround(f29 * f2);
 HEAPF32[i22 >> 2] = f31;
 f29 = Math_fround(f29 * f1);
 HEAPF32[i8 >> 2] = f29;
 f30 = Math_fround(Math_fround(f31 * f23) - Math_fround(f29 * f20));
 f30 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f30);
 f31 = Math_fround(Math_fround(f29 * f23) + Math_fround(f31 * f20));
 f31 = Math_fround(f31 + Math_fround(HEAPF32[i21 >> 2]));
 HEAPF32[i22 >> 2] = f30;
 HEAPF32[i8 >> 2] = f31;
 f31 = f3;
 STACKTOP = i24;
 return Math_fround(f31);
}

function __Z10WritePixelPhRK11ColorRGBA3213TextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0;
 do switch (i3 | 0) {
 case 1:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
   return;
  }
 case 3:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   return;
  }
 case 8:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 >> 0] | 0;
   return;
  }
 case 4:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
   return;
  }
 case 14:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
   return;
  }
 case 5:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   return;
  }
 case 1e3:
  {
   HEAP8[i1 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i2 >> 0] | 0;
   return;
  }
 case 2:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP16[i1 >> 1] = i3 << 4 & 3840 | (HEAPU8[i2 + 3 >> 0] | 0) >>> 4 << 12 | i3 >>> 8 & 240 | i3 >>> 20 & 15;
   return;
  }
 case 13:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP16[i1 >> 1] = i3 >>> 4 & 3840 | i3 << 8 & 61440 | i3 >>> 16 & 240 | i3 >>> 28;
   return;
  }
 case 7:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP16[i1 >> 1] = i3 >>> 5 & 2016 | i3 << 8 & 63488 | i3 >>> 19 & 31;
   return;
  }
 case 15:
  {
   f4 = Math_fround(Math_fround(HEAPU8[i2 >> 0] | 0) * Math_fround(.00392156886));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = i2 >>> 23 & 255;
   HEAP16[i1 >> 1] = i2 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i3 << 1) >> 1] | 0) | (i2 & 8388607) >>> (HEAPU8[gb + 1546331 + i3 >> 0] | 0);
   return;
  }
 case 16:
  {
   i2 = HEAP16[i2 >> 1] | 0;
   f4 = Math_fround(Math_fround(i2 & 255) * Math_fround(.00392156886));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = i5 >>> 23 & 255;
   HEAP16[i1 >> 1] = i5 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i3 << 1) >> 1] | 0) | (i5 & 8388607) >>> (HEAPU8[gb + 1546331 + i3 >> 0] | 0);
   f4 = Math_fround(Math_fround((i2 & 65535) >>> 8 & 255) * Math_fround(.00392156886));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = i2 >>> 23 & 255;
   HEAP16[i1 + 2 >> 1] = i2 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i3 << 1) >> 1] | 0) | (i2 & 8388607) >>> (HEAPU8[gb + 1546331 + i3 >> 0] | 0);
   return;
  }
 case 17:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   f4 = Math_fround(Math_fround(i3 & 255) * Math_fround(.00392156886));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i2 >>> 23 & 255;
   HEAP16[i1 >> 1] = i2 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i5 << 1) >> 1] | 0) | (i2 & 8388607) >>> (HEAPU8[gb + 1546331 + i5 >> 0] | 0);
   f4 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) * Math_fround(.00392156886));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = i5 >>> 23 & 255;
   HEAP16[i1 + 2 >> 1] = i5 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i2 << 1) >> 1] | 0) | (i5 & 8388607) >>> (HEAPU8[gb + 1546331 + i2 >> 0] | 0);
   f4 = Math_fround(Math_fround(i3 >>> 16 & 255) * Math_fround(.00392156886));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i2 >>> 23 & 255;
   HEAP16[i1 + 4 >> 1] = i2 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i5 << 1) >> 1] | 0) | (i2 & 8388607) >>> (HEAPU8[gb + 1546331 + i5 >> 0] | 0);
   f4 = Math_fround(Math_fround(i3 >>> 24 & 255) * Math_fround(.00392156886));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i3 >>> 23 & 255;
   HEAP16[i1 + 6 >> 1] = i3 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i5 << 1) >> 1] | 0) | (i3 & 8388607) >>> (HEAPU8[gb + 1546331 + i5 >> 0] | 0);
   return;
  }
 case 18:
  {
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPU8[i2 >> 0] | 0) * Math_fround(.00392156886));
   return;
  }
 case 19:
  {
   i5 = HEAP16[i2 >> 1] | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(i5 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) * Math_fround(.00392156886));
   return;
  }
 case 23:
  {
   i5 = HEAP32[i2 >> 2] | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(i5 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(i5 >>> 16 & 255) * Math_fround(.00392156886));
   return;
  }
 case 20:
  {
   i5 = HEAP32[i2 >> 2] | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(i5 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(i5 >>> 16 & 255) * Math_fround(.00392156886));
   HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(i5 >>> 24 & 255) * Math_fround(.00392156886));
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 404494 | 0, 1313, 1, 0, 0, 0);
   return;
  }
 } while (0);
}

function _cff_parse_font_bbox(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = HEAP32[i8 + 412 >> 2] | 0;
 i9 = i8 + 32 | 0;
 if ((HEAP32[i8 + 404 >> 2] | 0) >>> 0 < i9 >>> 0) {
  i11 = 161;
  return i11 | 0;
 }
 i6 = i8 + 20 | 0;
 i2 = HEAP32[i8 + 16 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP8[i2 >> 0] | 0;
 do if (i5 << 24 >> 24 == 30) i1 = _cff_parse_real(i2, i1, 0, 0) | 0; else {
  i3 = i2 + 1 | 0;
  i4 = i5 & 255;
  L7 : do switch (i5 << 24 >> 24) {
  case 28:
   {
    if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
    break;
   }
  case 29:
   {
    if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
     i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     i10 = 16;
    }
    break;
   }
  default:
   {
    if ((i5 & 255) < 247) {
     i1 = i4 + -139 | 0;
     break L7;
    }
    i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i5 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L7;
     }
     i1 = (HEAPU8[i3 >> 0] | 0 | (i4 << 8) + -63232) + 108 | 0;
     i10 = 16;
     break L7;
    } else {
     if (i1) {
      i1 = 0;
      break L7;
     }
     i1 = (251 - i4 << 8) + -108 - (HEAPU8[i3 >> 0] | 0) | 0;
     i10 = 16;
     break L7;
    }
   }
  } while (0);
  if ((i10 | 0) == 16) if ((i1 | 0) > 32767) {
   i1 = 2147483647;
   break;
  }
  i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
 } while (0);
 HEAP32[i11 + 84 >> 2] = _UNITY_FT_RoundFix(i1) | 0;
 i7 = i8 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 == 30) i1 = _cff_parse_real(i2, i1, 0, 0) | 0; else {
  i4 = i2 + 1 | 0;
  i5 = i3 & 255;
  L28 : do switch (i3 << 24 >> 24) {
  case 28:
   {
    if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
    break;
   }
  case 29:
   {
    if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
     i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     i10 = 32;
    }
    break;
   }
  default:
   {
    if ((i3 & 255) < 247) {
     i1 = i5 + -139 | 0;
     break L28;
    }
    i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i3 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L28;
     }
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     i10 = 32;
     break L28;
    } else {
     if (i1) {
      i1 = 0;
      break L28;
     }
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     i10 = 32;
     break L28;
    }
   }
  } while (0);
  if ((i10 | 0) == 32) if ((i1 | 0) > 32767) {
   i1 = 2147483647;
   break;
  }
  i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
 } while (0);
 HEAP32[i11 + 88 >> 2] = _UNITY_FT_RoundFix(i1) | 0;
 i6 = i8 + 28 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 == 30) i1 = _cff_parse_real(i2, i1, 0, 0) | 0; else {
  i4 = i2 + 1 | 0;
  i5 = i3 & 255;
  L49 : do switch (i3 << 24 >> 24) {
  case 28:
   {
    if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
    break;
   }
  case 29:
   {
    if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
     i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     i10 = 48;
    }
    break;
   }
  default:
   {
    if ((i3 & 255) < 247) {
     i1 = i5 + -139 | 0;
     break L49;
    }
    i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i3 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L49;
     }
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     i10 = 48;
     break L49;
    } else {
     if (i1) {
      i1 = 0;
      break L49;
     }
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     i10 = 48;
     break L49;
    }
   }
  } while (0);
  if ((i10 | 0) == 48) if ((i1 | 0) > 32767) {
   i1 = 2147483647;
   break;
  }
  i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
 } while (0);
 HEAP32[i11 + 92 >> 2] = _UNITY_FT_RoundFix(i1) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 do if (i3 << 24 >> 24 == 30) i1 = _cff_parse_real(i2, i1, 0, 0) | 0; else {
  i4 = i2 + 1 | 0;
  i5 = i3 & 255;
  L70 : do switch (i3 << 24 >> 24) {
  case 28:
   {
    if ((i2 + 3 | 0) >>> 0 > i1 >>> 0) i1 = 0; else i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i2 + 2 >> 0] | 0)) << 16 >> 16;
    break;
   }
  case 29:
   {
    if ((i2 + 5 | 0) >>> 0 > i1 >>> 0) i1 = 0; else {
     i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i2 + 3 >> 0] | 0) << 8 | (HEAPU8[i2 + 4 >> 0] | 0);
     i10 = 64;
    }
    break;
   }
  default:
   {
    if ((i3 & 255) < 247) {
     i1 = i5 + -139 | 0;
     break L70;
    }
    i1 = (i2 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i3 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L70;
     }
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     i10 = 64;
     break L70;
    } else {
     if (i1) {
      i1 = 0;
      break L70;
     }
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     i10 = 64;
     break L70;
    }
   }
  } while (0);
  if ((i10 | 0) == 64) if ((i1 | 0) > 32767) {
   i1 = 2147483647;
   break;
  }
  i1 = (i1 | 0) < -32767 ? -2147483647 : i1 << 16;
 } while (0);
 HEAP32[i11 + 96 >> 2] = _UNITY_FT_RoundFix(i1) | 0;
 i11 = 0;
 return i11 | 0;
}

function __ZN19TouchPhaseEmulation23DiscardRedundantTouchesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i20 = i1 + 4 | 0;
 i21 = i1 + 12 | 0;
 i22 = i1 + 16 | 0;
 i19 = i1 + 8 | 0;
 i18 = 0;
 do {
  i14 = HEAP32[i20 >> 2] | 0;
  i17 = i14 + (i18 * 96 | 0) | 0;
  do if ((HEAP32[i17 >> 2] | 0) != -1) {
   i15 = i14 + (i18 * 96 | 0) + 88 | 0;
   i6 = HEAP32[i15 >> 2] | 0;
   if ((i6 | 0) == (HEAP32[i21 >> 2] | 0)) {
    i10 = i14 + (i18 * 96 | 0) + 84 | 0;
    if ((HEAP32[i10 >> 2] | 0) == (i6 | 0)) {
     i11 = i14 + (i18 * 96 | 0) + 92 | 0;
     if (((HEAP32[i11 >> 2] | 0) + -3 | 0) >>> 0 < 2) if (((HEAP32[i14 + (i18 * 96 | 0) + 36 >> 2] | 0) + -3 | 0) >>> 0 > 1) {
      i12 = i14 + (i18 * 96 | 0) + 80 | 0;
      i7 = i14 + (i18 * 96 | 0) + 32 | 0;
      i13 = i14 + (i18 * 96 | 0) + 72 | 0;
      i8 = i14 + (i18 * 96 | 0) + 4 | 0;
      i9 = i14 + (i18 * 96 | 0) + 8 | 0;
      i2 = 0;
      i1 = 0;
      i3 = i14;
      while (1) {
       i16 = i3 + (i2 * 96 | 0) | 0;
       if (!((i18 | 0) == (i2 | 0) | (HEAP32[i16 >> 2] | 0) == -1)) if ((HEAP32[i3 + (i2 * 96 | 0) + 88 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + (i2 * 96 | 0) + 84 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + (i2 * 96 | 0) + 80 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) if ((HEAP32[i3 + (i2 * 96 | 0) + 32 >> 2] | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
        i5 = i3 + (i2 * 96 | 0) + 72 | 0;
        i4 = HEAP32[i5 >> 2] | 0;
        i5 = HEAP32[i5 + 4 >> 2] | 0;
        if (!(HEAP8[gb + 1098144 >> 0] | 0)) {
         f25 = Math_fround(Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(.400000006)) * Math_fround(.393700987));
         HEAPF32[gb + 1162096 >> 2] = f25;
         i24 = gb + 1098144 | 0;
         HEAP32[i24 >> 2] = 1;
         HEAP32[i24 + 4 >> 2] = 0;
        }
        if (!(HEAP8[gb + 1098152 >> 0] | 0)) {
         f25 = Math_fround(HEAPF32[gb + 1162096 >> 2]);
         f25 = Math_fround(f25 * f25);
         HEAPF32[gb + 1162100 >> 2] = f25;
         i24 = gb + 1098152 | 0;
         HEAP32[i24 >> 2] = 1;
         HEAP32[i24 + 4 >> 2] = 0;
        }
        i24 = i13;
        i24 = _i64Subtract(i4 | 0, i5 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i24 + 4 >> 2] | 0) | 0;
        i5 = getTempRet0() | 0;
        if ((i5 | 0) < 0 | (i5 | 0) == 0 & i24 >>> 0 < 15e4) {
         f26 = Math_fround(HEAPF32[i8 >> 2]);
         f26 = Math_fround(f26 - Math_fround(HEAPF32[i3 + (i2 * 96 | 0) + 4 >> 2]));
         f25 = Math_fround(HEAPF32[i9 >> 2]);
         f25 = Math_fround(f25 - Math_fround(HEAPF32[i3 + (i2 * 96 | 0) + 8 >> 2]));
         f25 = Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25));
         if (f25 < Math_fround(HEAPF32[gb + 1162100 >> 2])) {
          if ((HEAP32[i16 >> 2] | 0) == -1) break;
          i24 = ((HEAP32[i3 + (i2 * 96 | 0) + 36 >> 2] | 0) + -3 | 0) >>> 0 > 1;
          i1 = i1 | i24;
          if (i24) {
           i23 = 24;
           break;
          }
         }
        }
       }
       i2 = i2 + 1 | 0;
       if (i2 >>> 0 >= 32) {
        i23 = 24;
        break;
       }
       i3 = HEAP32[i20 >> 2] | 0;
      }
      if ((i23 | 0) == 24) {
       i23 = 0;
       if (!i1) {
        i3 = HEAP32[i17 >> 2] | 0;
        i4 = HEAP32[i19 >> 2] | 0;
        i1 = 0;
        while (1) {
         i2 = 1 << i1;
         if (!(i2 & i4)) {
          i23 = 36;
          break;
         }
         i1 = i1 + 1 | 0;
         if ((i1 | 0) >= 32) {
          i1 = i3;
          break;
         }
        }
        if ((i23 | 0) == 36) {
         i23 = 0;
         if ((i1 | 0) > (i3 | 0)) i1 = i3; else HEAP32[i19 >> 2] = (i2 | i4) & ~(1 << i3);
        }
        HEAP32[i17 >> 2] = i1;
        break;
       }
      }
      HEAP32[i11 >> 2] = 0;
      i1 = HEAP32[i17 >> 2] | 0;
      if ((i1 | 0) == -1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 441549 | 0, 0, gb + 441584 | 0, 504, 1, 0, 0, 0); else {
       HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & ~(1 << i1);
       HEAP32[i17 >> 2] = -1;
       HEAP32[i14 + (i18 * 96 | 0) + 36 >> 2] = 4;
       HEAP32[i11 >> 2] = 0;
       HEAP32[i10 >> 2] = 0;
       HEAP32[i15 >> 2] = 0;
       i24 = i14 + (i18 * 96 | 0) + 4 | 0;
       i17 = i13;
       HEAP32[i17 >> 2] = 0;
       HEAP32[i17 + 4 >> 2] = 0;
       HEAP32[i24 >> 2] = 0;
       HEAP32[i24 + 4 >> 2] = 0;
       HEAP32[i24 + 8 >> 2] = 0;
       HEAP32[i24 + 12 >> 2] = 0;
       HEAP32[i24 + 16 >> 2] = 0;
       HEAP32[i24 + 20 >> 2] = 0;
       HEAP32[i24 + 24 >> 2] = 0;
       HEAP32[i24 + 28 >> 2] = 0;
       HEAP32[i12 >> 2] = -1;
       HEAPF32[i14 + (i18 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
       HEAPF32[i14 + (i18 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
       HEAP32[i14 + (i18 * 96 | 0) + 40 >> 2] = 0;
       i24 = i14 + (i18 * 96 | 0) + 52 | 0;
       HEAP32[i24 >> 2] = 0;
       HEAP32[i24 + 4 >> 2] = 0;
       HEAP32[i24 + 8 >> 2] = 0;
       HEAP32[i24 + 12 >> 2] = 0;
      }
      i3 = HEAP32[i16 >> 2] | 0;
      i4 = HEAP32[i19 >> 2] | 0;
      i1 = 0;
      while (1) {
       i2 = 1 << i1;
       if (!(i2 & i4)) {
        i23 = 30;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) >= 32) {
        i1 = i3;
        break;
       }
      }
      if ((i23 | 0) == 30) {
       i23 = 0;
       if ((i1 | 0) > (i3 | 0)) i1 = i3; else HEAP32[i19 >> 2] = (i2 | i4) & ~(1 << i3);
      }
      HEAP32[i16 >> 2] = i1;
     }
    }
   }
  } while (0);
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != 32);
 return;
}

function _get_sof(i11, i3, i4) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i11 + 24 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP8[i11 + 200 >> 0] = i3;
 HEAP8[i11 + 201 >> 0] = i4;
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  break;
 } while (0);
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAPU8[i2 >> 0] << 8;
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  break;
 } else i2 = i3; while (0);
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 i8 = HEAPU8[i2 >> 0] | i4;
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  break;
 } else i2 = i3; while (0);
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 HEAP32[i11 + 192 >> 2] = HEAPU8[i2 >> 0];
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  break;
 } else i2 = i3; while (0);
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 i2 = HEAPU8[i2 >> 0] << 8;
 i7 = i11 + 32 | 0;
 HEAP32[i7 >> 2] = i2;
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  break;
 } else i4 = i2; while (0);
 i1 = i1 + -1 | 0;
 i2 = i3 + 1 | 0;
 HEAP32[i7 >> 2] = i4 + (HEAPU8[i3 >> 0] | 0);
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  break;
 } while (0);
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 i2 = HEAPU8[i2 >> 0] << 8;
 i6 = i11 + 28 | 0;
 HEAP32[i6 >> 2] = i2;
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  break;
 } while (0);
 i1 = i1 + -1 | 0;
 i4 = i3 + 1 | 0;
 HEAP32[i6 >> 2] = i2 + (HEAPU8[i3 >> 0] | 0);
 do if (!i1) if (!((mftCall_ii(HEAP32[i12 + 12 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i5 = HEAP32[i13 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  break;
 } else i5 = i1; while (0);
 i9 = i11 + 36 | 0;
 HEAP32[i9 >> 2] = HEAPU8[i4 >> 0];
 i2 = i8 + -8 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 + 24 >> 2] = HEAP32[i11 + 380 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 32 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 36 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 20 >> 2] = 100;
 mftCall_vii(HEAP32[i8 + 4 >> 2] | 0, i11 | 0, 1);
 i8 = i11 + 404 | 0;
 if (HEAP8[(HEAP32[i8 >> 2] | 0) + 13 >> 0] | 0) {
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 58;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i11 | 0);
 }
 if (!(HEAP32[i7 >> 2] | 0)) i10 = 30; else if (!(HEAP32[i6 >> 2] | 0)) i10 = 30; else {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) < 1) i10 = 30;
 }
 if ((i10 | 0) == 30) {
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 32;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i11 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if ((i2 | 0) != (i1 * 3 | 0)) {
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 11;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i11 | 0);
 }
 i1 = i11 + 196 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = mftCall_iiii(HEAP32[HEAP32[i11 + 4 >> 2] >> 2] | 0, i11 | 0, 1, (HEAP32[i9 >> 2] | 0) * 84 | 0) | 0;
  HEAP32[i1 >> 2] = i3;
 } else i3 = i2;
 i2 = i5 + -1 | 0;
 i1 = i4 + 1 | 0;
 L64 : do if ((HEAP32[i9 >> 2] | 0) > 0) {
  i7 = i12 + 12 | 0;
  i6 = 0;
  i5 = i3;
  while (1) {
   HEAP32[i5 + 4 >> 2] = i6;
   if (!i2) {
    if (!((mftCall_ii(HEAP32[i7 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     i10 = 48;
     break;
    }
    i2 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i2 = i2 + -1 | 0;
   i3 = i1 + 1 | 0;
   HEAP32[i5 >> 2] = HEAPU8[i1 >> 0];
   if (!i2) {
    if (!((mftCall_ii(HEAP32[i7 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     i10 = 48;
     break;
    }
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
   } else {
    i1 = i2;
    i2 = i3;
   }
   i1 = i1 + -1 | 0;
   i3 = i2 + 1 | 0;
   i10 = HEAPU8[i2 >> 0] | 0;
   i2 = i5 + 8 | 0;
   HEAP32[i2 >> 2] = i10 >>> 4;
   i4 = i5 + 12 | 0;
   HEAP32[i4 >> 2] = i10 & 15;
   if (!i1) {
    if (!((mftCall_ii(HEAP32[i7 >> 2] | 0, i11 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     i10 = 48;
     break;
    }
    i1 = HEAP32[i13 >> 2] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
   }
   i14 = i5 + 16 | 0;
   HEAP32[i14 >> 2] = HEAPU8[i3 >> 0];
   i10 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 + 24 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 + 32 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i10 + 36 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i10 + 20 >> 2] = 101;
   mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i11 | 0, 1);
   i6 = i6 + 1 | 0;
   i2 = i1 + -1 | 0;
   i1 = i3 + 1 | 0;
   if ((i6 | 0) >= (HEAP32[i9 >> 2] | 0)) break L64; else i5 = i5 + 84 | 0;
  }
  if ((i10 | 0) == 48) return i1 | 0;
 } while (0);
 HEAP8[(HEAP32[i8 >> 2] | 0) + 13 >> 0] = 1;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 i14 = 1;
 return i14 | 0;
}

function _rgb_rgb_convert(i1, i7, i12, i8, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 switch (HEAP32[i1 + 40 >> 2] | 0) {
 case 6:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i6 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) <= 0) return;
   i10 = i12 + 4 | 0;
   i11 = i12 + 8 | 0;
   if (!i9) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i7 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i5 + i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
     HEAP8[i6 + i1 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i8 = i8 + 1 | 0;
     i7 = i7 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN9Transform37InitializeTransformHierarchyRecursiveER18TransformHierarchyRii(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i6 + 36 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = i6 + 32 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i2 >> 2] = i7;
 HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + (i9 << 2) >> 2] = i1;
 HEAP32[(HEAP32[i7 + 24 >> 2] | 0) + (i9 << 2) >> 2] = i6;
 HEAP8[(HEAP32[i7 + 28 >> 2] | 0) + i9 >> 0] = 0;
 if (!i4) {
  i2 = i6 + 32 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i21 = i6 + 56 | 0;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = HEAP32[i21 + 8 >> 2] | 0;
  i15 = i6 + 40 | 0;
  i18 = HEAP32[i15 >> 2] | 0;
  i17 = HEAP32[i15 + 4 >> 2] | 0;
  i16 = HEAP32[i15 + 8 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  i4 = i6 + 68 | 0;
  i10 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i14 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i14 + (i3 * 40 | 0) >> 2] = HEAP32[i21 >> 2];
  HEAP32[i14 + (i3 * 40 | 0) + 4 >> 2] = i20;
  HEAP32[i14 + (i3 * 40 | 0) + 8 >> 2] = i19;
  HEAP32[i14 + (i3 * 40 | 0) + 12 >> 2] = i18;
  HEAP32[i14 + (i3 * 40 | 0) + 16 >> 2] = i17;
  HEAP32[i14 + (i3 * 40 | 0) + 20 >> 2] = i16;
  HEAP32[i14 + (i3 * 40 | 0) + 24 >> 2] = i15;
  HEAP32[i14 + (i3 * 40 | 0) + 28 >> 2] = i10;
  HEAP32[i14 + (i3 * 40 | 0) + 32 >> 2] = i1;
  HEAP32[i14 + (i3 * 40 | 0) + 36 >> 2] = i4;
  f13 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = (HEAP32[tempDoublePtr >> 2] = i1 & -2147483648 ^ (i10 & -2147483648 | 1065353216) ^ i4 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
  i10 = ((Math_fround(Math_abs(Math_fround(f11 - f13))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f13 - f12))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f12 - f11))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i4) ^ 1;
  i10 = (i4 << 2 | 3) & ~(i10 << 1) & (i10 & ((Math_fround(Math_abs(Math_fround(f13 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f12 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f11 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
  HEAP32[(HEAP32[i2 + 64 >> 2] | 0) + (i3 << 2) >> 2] = i10;
  i3 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  if (!i2) {
   i1 = 1 << (i9 & 31);
   i5 = 6;
  } else {
   i1 = 1 << (i9 & 31);
   if (__ZN10GameObject17WillHandleMessageERK17MessageIdentifier(i2, gb + 1105016 | 0) | 0) {
    i21 = i3 + (i9 >>> 5 << 2) | 0;
    HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i1;
   } else i5 = 6;
  }
  if ((i5 | 0) == 6) {
   i21 = i3 + (i9 >>> 5 << 2) | 0;
   HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & ~i1;
  }
  HEAP32[(HEAP32[i7 + 56 >> 2] | 0) + (i9 << 2) >> 2] = 1 << HEAP32[gb + 1477024 >> 2];
  HEAP32[(HEAP32[i7 + 60 >> 2] | 0) + (i9 << 2) >> 2] = 1 << HEAP32[gb + 1477024 >> 2];
 } else {
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  i20 = HEAP32[i4 + 8 >> 2] | 0;
  i2 = HEAP32[i20 + (i3 * 40 | 0) + 4 >> 2] | 0;
  i19 = HEAP32[i20 + (i3 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i1 + (i9 * 40 | 0) >> 2] = HEAP32[i20 + (i3 * 40 | 0) >> 2];
  HEAP32[i1 + (i9 * 40 | 0) + 4 >> 2] = i2;
  HEAP32[i1 + (i9 * 40 | 0) + 8 >> 2] = i19;
  i19 = HEAP32[i20 + (i3 * 40 | 0) + 16 >> 2] | 0;
  i2 = HEAP32[i20 + (i3 * 40 | 0) + 20 >> 2] | 0;
  i21 = HEAP32[i20 + (i3 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i1 + (i9 * 40 | 0) + 12 >> 2] = HEAP32[i20 + (i3 * 40 | 0) + 12 >> 2];
  HEAP32[i1 + (i9 * 40 | 0) + 16 >> 2] = i19;
  HEAP32[i1 + (i9 * 40 | 0) + 20 >> 2] = i2;
  HEAP32[i1 + (i9 * 40 | 0) + 24 >> 2] = i21;
  i21 = HEAP32[i20 + (i3 * 40 | 0) + 32 >> 2] | 0;
  i2 = HEAP32[i20 + (i3 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i1 + (i9 * 40 | 0) + 28 >> 2] = HEAP32[i20 + (i3 * 40 | 0) + 28 >> 2];
  HEAP32[i1 + (i9 * 40 | 0) + 32 >> 2] = i21;
  HEAP32[i1 + (i9 * 40 | 0) + 36 >> 2] = i2;
  HEAP32[(HEAP32[i7 + 64 >> 2] | 0) + (i9 << 2) >> 2] = HEAP32[(HEAP32[i4 + 64 >> 2] | 0) + (i3 << 2) >> 2];
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = 1 << (i9 & 31);
  if (!(HEAP32[(HEAP32[i4 + 20 >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
   i21 = i1 + (i9 >>> 5 << 2) | 0;
   HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & ~i2;
  } else {
   i21 = i1 + (i9 >>> 5 << 2) | 0;
   HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i2;
  }
  HEAP32[(HEAP32[i7 + 56 >> 2] | 0) + (i9 << 2) >> 2] = HEAP32[(HEAP32[i4 + 56 >> 2] | 0) + (i3 << 2) >> 2];
  HEAP32[(HEAP32[i7 + 60 >> 2] | 0) + (i9 << 2) >> 2] = HEAP32[(HEAP32[i4 + 60 >> 2] | 0) + (i3 << 2) >> 2];
 }
 i1 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i6 + 92 >> 2] | 0;
 if (!i3) {
  i20 = i1;
  i20 = i20 - i9 | 0;
  i21 = i7 + 16 | 0;
  i21 = HEAP32[i21 >> 2] | 0;
  i21 = i21 + (i9 << 2) | 0;
  HEAP32[i21 >> 2] = i20;
  return;
 }
 i2 = i6 + 80 | 0;
 i1 = 0;
 do {
  __ZN9Transform37InitializeTransformHierarchyRecursiveER18TransformHierarchyRii(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i7, i8, i9);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i20 = HEAP32[i8 >> 2] | 0;
 i20 = i20 - i9 | 0;
 i21 = i7 + 16 | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i21 = i21 + (i9 << 2) | 0;
 HEAP32[i21 >> 2] = i20;
 return;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE(i23, i26, i24, i25, i22) {
 i23 = i23 | 0;
 i26 = i26 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i11 = i23 + 53 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = i23 + 52 | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i25 = 0;
  i26 = i26 + 4096 | 0;
  HEAP32[i26 >> 2] = i25;
  i26 = (i25 | 0) != 0;
  return i26 | 0;
 }
 i16 = i25 + 4 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 12 | 0;
 i19 = i24 + 4 | 0;
 i20 = i24 + 8 | 0;
 i21 = i24 + 12 | 0;
 i13 = i24 + 16 | 0;
 i14 = i24 + 20 | 0;
 i15 = i24 + 24 | 0;
 i3 = i1;
 i5 = 0;
 i1 = 0;
 i2 = 0;
 while (1) {
  i10 = HEAPU8[i23 + 48 + i2 >> 0] | 0;
  i8 = HEAP32[i23 + 64 + (i10 * 400 | 0) + 384 >> 2] | 0;
  HEAP8[i11 >> 0] = (i5 & 255) + i8;
  f4 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + 32 >> 2]);
  f6 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + 36 >> 2]);
  f7 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + 40 >> 2]);
  if (i8 >>> 0 > 1) {
   i5 = 1;
   do {
    f28 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i5 << 6) + 32 >> 2]);
    f27 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i5 << 6) + 36 >> 2]);
    f4 = Math_fround(f4 + f28);
    f6 = Math_fround(f6 + f27);
    f7 = Math_fround(f7 + Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i5 << 6) + 40 >> 2]));
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  f31 = Math_fround(HEAPF32[i25 >> 2]);
  f30 = Math_fround(HEAPF32[i16 >> 2]);
  f34 = Math_fround(HEAPF32[i17 >> 2]);
  f32 = Math_fround(HEAPF32[i18 >> 2]);
  f28 = Math_fround(Math_fround(f32 * f32) + Math_fround(-.5));
  f33 = Math_fround(Math_fround(Math_fround(f4 * f31) + Math_fround(f6 * f30)) + Math_fround(f7 * f34));
  f29 = Math_fround(Math_fround(Math_fround(f31 * f33) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f7 * f30) - Math_fround(f6 * f34))) + Math_fround(f4 * f28))) * Math_fround(2.0));
  f27 = Math_fround(Math_fround(Math_fround(f30 * f33) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f4 * f34) - Math_fround(f7 * f31))) + Math_fround(f6 * f28))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(Math_fround(f32 * Math_fround(Math_fround(f6 * f31) - Math_fround(f4 * f30))) + Math_fround(f7 * f28))) * Math_fround(2.0));
  f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f29 * f29) + Math_fround(f27 * f27))))));
  f4 = Math_fround(f28 * f29);
  f6 = Math_fround(f28 * f27);
  f7 = Math_fround(f28 * f7);
  if ((i8 | 0) != 0 & i1 >>> 0 < 64) {
   i3 = 0 - i8 | 0;
   i9 = i1 + -64 | 0;
   i9 = i9 >>> 0 < i3 >>> 0 ? i3 : i9;
   i3 = 0 - i9 | 0;
   i5 = i1;
   i8 = 0;
   while (1) {
    f34 = Math_fround(HEAPF32[i22 >> 2]);
    f36 = Math_fround(HEAPF32[i24 >> 2]);
    f28 = Math_fround(HEAPF32[i19 >> 2]);
    f30 = Math_fround(HEAPF32[i20 >> 2]);
    f37 = Math_fround(HEAPF32[i21 >> 2]);
    f31 = Math_fround(HEAPF32[i13 >> 2]);
    f32 = Math_fround(HEAPF32[i14 >> 2]);
    f40 = Math_fround(HEAPF32[i15 >> 2]);
    f29 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i8 << 6) >> 2]);
    f27 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i8 << 6) + 4 >> 2]);
    f38 = Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i8 << 6) + 8 >> 2]);
    f39 = Math_fround(Math_fround(f37 * f37) + Math_fround(-.5));
    f33 = Math_fround(Math_fround(Math_fround(f36 * f29) + Math_fround(f28 * f27)) + Math_fround(f30 * f38));
    f31 = Math_fround(Math_fround(f31 + Math_fround(Math_fround(Math_fround(f36 * f33) + Math_fround(Math_fround(f39 * f29) + Math_fround(f37 * Math_fround(Math_fround(f28 * f38) - Math_fround(f30 * f27))))) * Math_fround(2.0))) - Math_fround(f4 * f34));
    f32 = Math_fround(Math_fround(f32 + Math_fround(Math_fround(Math_fround(f28 * f33) + Math_fround(Math_fround(f39 * f27) + Math_fround(f37 * Math_fround(Math_fround(f30 * f29) - Math_fround(f36 * f38))))) * Math_fround(2.0))) - Math_fround(f6 * f34));
    f33 = Math_fround(Math_fround(f40 + Math_fround(Math_fround(Math_fround(Math_fround(f39 * f38) + Math_fround(f37 * Math_fround(Math_fround(f36 * f27) - Math_fround(f28 * f29)))) + Math_fround(f30 * f33)) * Math_fround(2.0))) - Math_fround(f7 * f34));
    f34 = Math_fround(Math_fround(HEAPF32[i23 + 64 + (i10 * 400 | 0) + (i8 << 6) + 44 >> 2]) - f34);
    i35 = i26 + (i5 << 6) | 0;
    HEAPF32[i35 >> 2] = f4;
    HEAPF32[i35 + 4 >> 2] = f6;
    HEAPF32[i35 + 8 >> 2] = f7;
    HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
    i35 = i26 + (i5 << 6) + 16 | 0;
    HEAPF32[i35 >> 2] = f31;
    HEAPF32[i35 + 4 >> 2] = f32;
    HEAPF32[i35 + 8 >> 2] = f33;
    HEAPF32[i35 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i26 + (i5 << 6) + 12 >> 2] = f34;
    HEAP32[i26 + (i5 << 6) + 48 >> 2] = -1;
    HEAP32[i26 + (i5 << 6) + 52 >> 2] = HEAP32[i23 + 64 + (i10 * 400 | 0) + (i8 << 6) + 48 >> 2];
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i3 | 0)) break; else i5 = i5 + 1 | 0;
   }
   i3 = HEAP8[i12 >> 0] | 0;
   i1 = i1 - i9 | 0;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= (i3 & 255) >>> 0) break;
  i5 = HEAP8[i11 >> 0] | 0;
 }
 i35 = i26 + 4096 | 0;
 HEAP32[i35 >> 2] = i1;
 i35 = (i1 | 0) != 0;
 return i35 | 0;
}

function __ZN15DirectorManager22ScheduleForDestructionEP8Playable(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i14 = i16;
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 i1 = i12 + 52 | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 if (i2 & 1) {
  STACKTOP = i16;
  return;
 }
 HEAP16[i1 >> 1] = i2 | 1;
 i8 = i12 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 L7 : do if (i1 | 0) if (HEAP32[i1 + 28 >> 2] | 0) {
  i9 = i11 + 456 | 0;
  i10 = i11 + 444 | 0;
  i7 = 0;
  while (1) {
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i7 << 3) + 4 >> 2] | 0;
   L12 : do switch (i1 | 0) {
   case 0:
    break;
   case 2:
    {
     if (HEAP32[i9 >> 2] | 0) {
      i5 = 0;
      L15 : while (1) {
       i6 = (HEAP32[i10 >> 2] | 0) + (i5 << 2) | 0;
       i1 = HEAP32[i6 >> 2] | 0;
       do if (i1 | 0) {
        HEAP32[i14 >> 2] = i1;
        i1 = HEAP32[gb + 1104264 >> 2] | 0;
        if (!i1) i15 = 14; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i4 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
          i4 = HEAP32[i13 >> 2] | 0;
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
          i1 = i3;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i15 = 14; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i15 = 16;
        }
        if ((i15 | 0) == 14) i15 = 16;
        if ((i15 | 0) == 16) {
         i15 = 0;
         if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
         i1 = HEAP32[gb + 1104264 >> 2] | 0;
        }
        HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
        if (!i1) i15 = 23; else {
         if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
          i2 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[i1 + 32 >> 2] | 0;
          i1 = i2 + (i3 << 3) | 0;
         } else {
          __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
          i2 = HEAP32[i13 >> 2] | 0;
          i4 = HEAP32[i1 + 28 >> 2] | 0;
          i3 = HEAP32[gb + 1104264 >> 2] | 0;
          i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
          i2 = HEAP32[i3 + 28 >> 2] | 0;
          i3 = HEAP32[i3 + 32 >> 2] | 0;
         }
         if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 23; else {
          i1 = HEAP32[i1 + 4 >> 2] | 0;
          if (!i1) i15 = 25;
         }
        }
        if ((i15 | 0) == 23) i15 = 25;
        if ((i15 | 0) == 25) {
         i15 = 0;
         i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
        }
        i1 = HEAP32[i1 + 36 >> 2] | 0;
        if (i1 | 0) if (__ZN18PlayableController18DoesPlayableExistsEPK8Playable(i1, i12) | 0) break L15;
       } while (0);
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (HEAP32[i9 >> 2] | 0)) break L12;
      }
      __ZN8Playable10DisconnectEPS_i(2, i7);
      HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i15 = 33; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
        i2 = HEAP32[i13 >> 2] | 0;
        i5 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 33; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i15 = 35;
       }
      }
      if ((i15 | 0) == 33) i15 = 35;
      if ((i15 | 0) == 35) {
       i15 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      }
      i6 = HEAP32[i1 + 36 >> 2] | 0;
      i5 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63784 | 0, 16, gb + 582681 | 0, 412) | 0;
      HEAP32[i5 + 4 >> 2] = i6;
      i6 = HEAP32[gb + 1188416 >> 2] | 0;
      HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i6 >> 2] = i5;
     }
     break;
    }
   default:
    {
     __ZN8Playable10DisconnectEPS_i(i12, i7);
     __ZN15DirectorManager22ScheduleForDestructionEP8Playable(i11, i1);
    }
   } while (0);
   i7 = i7 + 1 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i7 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) break L7;
  }
 } while (0);
 i14 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63784 | 0, 16, gb + 582681 | 0, 847) | 0;
 HEAP32[i14 + 4 >> 2] = i12;
 i15 = HEAP32[gb + 1188424 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i2 + 152 | 0;
 i21 = i2 + 88 | 0;
 i16 = i2 + 24 | 0;
 i6 = i2 + 12 | 0;
 i3 = i2;
 i20 = i1 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i20 >> 2] | 0, gb + 28940 | 0) | 0);
 f19 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 i5 = f19 < Math_fround(0.0);
 f12 = Math_fround(-f19);
 f19 = i5 ? f12 : f19;
 i5 = f19 < Math_fround(9.99999974e-06);
 f19 = i5 ? Math_fround(9.99999974e-06) : f19;
 f12 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i20 >> 2] | 0, gb + 28940 | 0) | 0);
 f17 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 i5 = f11 < Math_fround(0.0);
 f10 = Math_fround(-f11);
 f11 = Math_fround(f17 * (i5 ? f10 : f11));
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i20 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 i5 = f10 < Math_fround(0.0);
 f17 = Math_fround(-f10);
 f10 = i5 ? f17 : f10;
 i5 = f10 < Math_fround(9.99999974e-06);
 f10 = i5 ? Math_fround(9.99999974e-06) : f10;
 i5 = (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) + 56 >> 2] | 0) + 8 | 0;
 i4 = i1 + 148 | 0;
 i14 = __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i5, HEAP32[i4 >> 2] | 0) | 0;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i20 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i20 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i21, i13);
 __ZNK9Rigidbody15GetCenterOfMassEv(i15, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
 f17 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f17 = Math_fround(f17 * f8);
 f18 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f18 = Math_fround(f17 + Math_fround(f18 * f9));
 f17 = Math_fround(HEAPF32[i21 + 32 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f17 = Math_fround(f18 + Math_fround(f17 * f7));
 f17 = Math_fround(Math_fround(HEAPF32[i21 + 48 >> 2]) + f17);
 f18 = Math_fround(f8 * Math_fround(HEAPF32[i21 + 4 >> 2]));
 f18 = Math_fround(f18 + Math_fround(f9 * Math_fround(HEAPF32[i21 + 20 >> 2])));
 f18 = Math_fround(f18 + Math_fround(f7 * Math_fround(HEAPF32[i21 + 36 >> 2])));
 f18 = Math_fround(Math_fround(HEAPF32[i21 + 52 >> 2]) + f18);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i21 + 8 >> 2]));
 f9 = Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[i21 + 24 >> 2])));
 f7 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i21 + 40 >> 2])));
 f7 = Math_fround(Math_fround(HEAPF32[i21 + 56 >> 2]) + f7);
 __ZNK9Transform14TransformPointERK8Vector3f(i15, i20, i1 + 60 | 0);
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i16, i13);
 f17 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f17);
 f18 = Math_fround(Math_fround(HEAPF32[i15 + 4 >> 2]) - f18);
 f7 = Math_fround(Math_fround(HEAPF32[i15 + 8 >> 2]) - f7);
 f9 = Math_fround(f17 * Math_fround(HEAPF32[i16 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f18 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 f8 = Math_fround(f17 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f18 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 36 >> 2])));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 f7 = Math_fround(f18 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 40 >> 2])));
 HEAPF32[i6 >> 2] = f9;
 i16 = i6 + 4 | 0;
 HEAPF32[i16 >> 2] = f8;
 i15 = i6 + 8 | 0;
 HEAPF32[i15 >> 2] = f7;
 f12 = Math_fround(Math_fround(1.0) - f12);
 f18 = Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2]));
 i13 = i14 + 4 | 0;
 f17 = Math_fround(f12 * Math_fround(HEAPF32[i13 >> 2]));
 i1 = i14 + 8 | 0;
 f17 = Math_fround(f19 * f17);
 f12 = Math_fround(f19 * Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2])));
 f9 = Math_fround(Math_fround(f19 * f18) + f9);
 HEAPF32[i6 >> 2] = f9;
 f8 = Math_fround(f17 + f8);
 HEAPF32[i16 >> 2] = f8;
 f7 = Math_fround(f12 + f7);
 HEAPF32[i15 >> 2] = f7;
 f11 = Math_fround(f10 - f11);
 f10 = Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f11 * Math_fround(HEAPF32[i13 >> 2]));
 f8 = Math_fround(f12 + f8);
 f7 = Math_fround(Math_fround(f11 * Math_fround(HEAPF32[i1 >> 2])) + f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 + f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i5, HEAP32[i4 >> 2] | 0, i6);
 __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i5, HEAP32[i4 >> 2] | 0, i3);
 __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i5, HEAP32[i4 >> 2] | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6insertINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISF_E9referenceEEE5valueENS6_IPS1_EEE4typeENS6_IPKS1_EESF_SF_(i16, i1, i2, i3) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 32 | 0;
 i17 = i19 + 8 | 0;
 i11 = i19 + 4 | 0;
 i12 = i19;
 i13 = HEAP32[i16 >> 2] | 0;
 i10 = i13;
 i1 = i13 + ((HEAP32[i1 >> 2] | 0) - i10 >> 4 << 4) | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i9 = i2 - i13 | 0;
 i8 = (i9 | 0) / 12 | 0;
 i7 = i13;
 i14 = i2;
 if ((i9 | 0) <= 0) {
  i18 = i1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i5 = i16 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i16 + 4 >> 2] | 0;
 i3 = i9;
 if ((i8 | 0) > (i6 - i3 >> 4 | 0)) {
  i4 = (i3 - i10 >> 4) + i8 | 0;
  if (i4 >>> 0 > 268435455) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i16);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
  } else {
   i2 = i6;
   i3 = i10;
  }
  i11 = i2 - i3 | 0;
  i12 = i11 >> 3;
  i4 = i11 >> 4 >>> 0 < 134217727 ? (i12 >>> 0 < i4 >>> 0 ? i4 : i12) : 268435455;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i17 + 16 >> 2] = i16 + 8;
  if (!i4) i5 = 0; else i5 = __Znwj(i4 << 4) | 0;
  HEAP32[i17 >> 2] = i5;
  i2 = i5 + (i1 - i3 >> 4 << 4) | 0;
  i10 = i17 + 8 | 0;
  HEAP32[i10 >> 2] = i2;
  i9 = i17 + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i17 + 12 >> 2] = i5 + (i4 << 4);
  if ((i7 | 0) != (i14 | 0)) {
   i8 = i18 + 4 | 0;
   i6 = i13;
   while (1) {
    i5 = HEAP8[i7 + 11 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
    i5 = i3 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i2 + 12 >> 2] = i3;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     i15 = 31;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i5;
     if (i5) i15 = 33;
    } else i15 = 31;
    if ((i15 | 0) == 31) {
     i12 = i5 + 16 & -16;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i8 >> 2] = i3;
     i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i13;
     HEAP32[i2 + 8 >> 2] = i12 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i13;
     i15 = 33;
    }
    if ((i15 | 0) == 33) {
     i15 = 0;
     _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
    i2 = (HEAP32[i10 >> 2] | 0) + 16 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = i6 + 12 | 0;
    if ((i3 | 0) == (i14 | 0)) break; else {
     i6 = i3;
     i7 = i3;
    }
   }
  }
  i5 = __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EEPS1_(i16, i17, i1) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i4 = i18 + 4 | 0;
   do {
    i2 = i1 + -16 | 0;
    HEAP32[i10 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i16 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i1 + -4 >> 2] | 0;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i4 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
     i1 = HEAP32[i10 >> 2] | 0;
    } else i1 = i2;
   } while ((i1 | 0) != (i3 | 0));
  }
  i1 = HEAP32[i17 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
  i18 = i5;
  STACKTOP = i19;
  return i18 | 0;
 } else {
  i3 = i3 - i1 | 0;
  i4 = i3 >> 4;
  if ((i8 | 0) > (i4 | 0)) {
   i5 = i7 + (i4 * 12 | 0) | 0;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
   __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESF_SF_j(i16, i17, i18, i8 - i4 | 0);
   if ((i3 | 0) > 0) i2 = i5; else {
    i18 = i1;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE12__move_rangeEPS1_S5_S5_(i16, i1, i9, i1 + (i8 << 4) | 0);
  if ((i7 | 0) == (i2 | 0)) {
   i18 = i1;
   STACKTOP = i19;
   return i18 | 0;
  } else i10 = i1;
  while (1) {
   i9 = HEAP8[i7 + 11 >> 0] | 0;
   i5 = i9 << 24 >> 24 < 0;
   i8 = i5 ? HEAP32[i7 >> 2] | 0 : i7;
   i9 = i5 ? HEAP32[i7 + 4 >> 2] | 0 : i9 & 255;
   i5 = i10 + 11 | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   i4 = i3 << 24 >> 24 < 0;
   if (i4) i6 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
   do if (i9 >>> 0 > i6 >>> 0) {
    if (i4) i3 = HEAP32[i10 + 4 >> 2] | 0; else i3 = i3 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i6, i9 - i6 | 0, i3, 0, i3, i9, i8);
   } else {
    if (i4) i3 = HEAP32[i10 >> 2] | 0; else i3 = i10;
    if (i9 | 0) _memmove(i3 | 0, i8 | 0, i9 | 0) | 0;
    HEAP8[i3 + i9 >> 0] = 0;
    if ((HEAP8[i5 >> 0] | 0) < 0) {
     HEAP32[i10 + 4 >> 2] = i9;
     break;
    } else {
     HEAP8[i5 >> 0] = i9;
     break;
    }
   } while (0);
   i7 = i7 + 12 | 0;
   if ((i7 | 0) == (i2 | 0)) break; else i10 = i10 + 16 | 0;
  }
  STACKTOP = i19;
  return i1 | 0;
 }
 return 0;
}

function _PxUnregisterPhysicsSerializers(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 2) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 3) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 1) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 5) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 6) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 7) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 8) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 9) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 13) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 14) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 15) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 16) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 10) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 4) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 11) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 12) | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN7ApiGLES16CheckFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEEb(i12, i2, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 32 | 0;
 i17 = i22 + 24 | 0;
 i13 = i22 + 8 | 0;
 i16 = i22;
 i18 = i22 + 72 | 0;
 i19 = i22 + 68 | 0;
 i14 = i22 + 56 | 0;
 i15 = i22 + 52 | 0;
 i20 = i22 + 40 | 0;
 i9 = i12 + 876 | 0;
 i8 = i9;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i12 + 876 | 0;
 i4 = (i2 | 0) == 0;
 if (i2 | i1 | 0) {
  i5 = i3;
  if (!((i2 | 0) == (i1 | 0) ? (HEAP32[i12 + 880 >> 2] | 0) == (i5 | 0) : 0)) {
   i6 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i12 + 860 >> 2] | 0, 0) | 0;
   if ((i6 | 0) == 36160) {
    i23 = i7;
    HEAP32[i23 >> 2] = i2;
    HEAP32[i23 + 4 >> 2] = i3;
    i23 = i12 + 884 | 0;
    HEAP32[i23 >> 2] = i2;
    HEAP32[i23 + 4 >> 2] = i3;
   } else {
    i23 = i9;
    HEAP32[i23 >> 2] = i2;
    HEAP32[i23 + 4 >> 2] = i3;
   }
   i3 = HEAP32[i12 + 544 >> 2] | 0;
   if (i4) i10 = 8; else if ((HEAP32[i12 + 1988 >> 2] | 0) == (i5 | 0)) i10 = 8; else i2 = -1;
   mftCall_vii(i3 | 0, i6 | 0, i2 | 0);
  }
 }
 i6 = mftCall_ii(HEAP32[i12 + 552 >> 2] | 0, 36160) | 0;
 i3 = (i1 | 0) == 0;
 if (i3) {
  if (HEAP32[i9 >> 2] | 0) i10 = 12;
 } else i10 = 12;
 do if ((i10 | 0) == 12) {
  i4 = i8;
  if ((HEAP32[i12 + 880 >> 2] | 0) == (i4 | 0)) if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) break;
  i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i12 + 860 >> 2] | 0, 0) | 0;
  if ((i5 | 0) == 36160) {
   i23 = i7;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 4 >> 2] = i8;
   i23 = i12 + 884 | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 4 >> 2] = i8;
  } else {
   i23 = i9;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i23 + 4 >> 2] = i8;
  }
  i2 = HEAP32[i12 + 544 >> 2] | 0;
  if (i3) i10 = 19; else if ((HEAP32[i12 + 1988 >> 2] | 0) == (i4 | 0)) i10 = 19; else i1 = -1;
  mftCall_vii(i2 | 0, i5 | 0, i1 | 0);
 } while (0);
 i7 = (i6 | 0) == 36053;
 if (i7 | i11 ^ 1) {
  STACKTOP = i22;
  return i7 | 0;
 }
 switch (i6 | 0) {
 case 36054:
  {
   i1 = gb + 600058 | 0;
   break;
  }
 case 36055:
  {
   i1 = gb + 600028 | 0;
   break;
  }
 case 36057:
  {
   i1 = gb + 600006 | 0;
   break;
  }
 case 36058:
  {
   i1 = gb + 599987 | 0;
   break;
  }
 case 36059:
  {
   i1 = gb + 599964 | 0;
   break;
  }
 case 36060:
  {
   i1 = gb + 599941 | 0;
   break;
  }
 case 36061:
  {
   i1 = gb + 599929 | 0;
   break;
  }
 case 36182:
  {
   i1 = gb + 599891 | 0;
   break;
  }
 default:
  i1 = gb + 661452 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 __Z6FormatPKcz(i18, gb + 600080 | 0, i16);
 i6 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 140 >> 2] | 0;
 if ((i6 | 0) > 0) {
  i1 = i12 + 556 | 0;
  i3 = i14 + 11 | 0;
  i4 = i14 + 4 | 0;
  i2 = 0;
  do {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i5 = i2 + 36064 | 0;
   mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, i5 | 0, 36048, i19 | 0);
   mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, i5 | 0, 36049, i16 | 0);
   i5 = HEAP32[i16 >> 2] | 0;
   if (i5 | 0) {
    i23 = HEAP32[i19 >> 2] | 0;
    HEAP32[i13 >> 2] = i2;
    HEAP32[i13 + 4 >> 2] = (i23 | 0) == 36161 ? gb + 600143 | 0 : (i23 | 0) == 5890 ? gb + 600124 | 0 : gb + 600135 | 0;
    HEAP32[i13 + 8 >> 2] = i5;
    __Z6FormatPKcz(i14, gb + 600159 | 0, i13);
    i23 = HEAP8[i3 >> 0] | 0;
    i12 = i23 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, i12 ? HEAP32[i14 >> 2] | 0 : i14, i12 ? HEAP32[i4 >> 2] | 0 : i23 & 255) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
 } else i1 = i12 + 556 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, 36096, 36048, i16 | 0);
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, 36096, 36049, i14 | 0);
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, 36128, 36048, i19 | 0);
 mftCall_viiii(HEAP32[i1 >> 2] | 0, 36160, 36128, 36049, i15 | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i23 = HEAP32[i16 >> 2] | 0;
  HEAP32[i17 >> 2] = (i23 | 0) == 36161 ? gb + 600143 | 0 : (i23 | 0) == 5890 ? gb + 600124 | 0 : gb + 600135 | 0;
  HEAP32[i17 + 4 >> 2] = i1;
  __Z6FormatPKcz(i20, gb + 600199 | 0, i17);
  i23 = HEAP8[i20 + 11 >> 0] | 0;
  i17 = i23 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, i17 ? HEAP32[i20 >> 2] | 0 : i20, i17 ? HEAP32[i20 + 4 >> 2] | 0 : i23 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) {
  i23 = HEAP32[i19 >> 2] | 0;
  HEAP32[i21 >> 2] = (i23 | 0) == 36161 ? gb + 600143 | 0 : (i23 | 0) == 5890 ? gb + 600124 | 0 : gb + 600135 | 0;
  HEAP32[i21 + 4 >> 2] = i1;
  __Z6FormatPKcz(i20, gb + 600237 | 0, i21);
  i23 = HEAP8[i20 + 11 >> 0] | 0;
  i21 = i23 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i18, i21 ? HEAP32[i20 >> 2] | 0 : i20, i21 ? HEAP32[i20 + 4 >> 2] | 0 : i23 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 STACKTOP = i22;
 return i7 | 0;
}

function __ZN10TagManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 24 | 0;
 i13 = i15 + 12 | 0;
 i10 = i15;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i4 = (HEAP32[i11 + 32 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i6 = (i3 | 0) == 0;
 if (i6) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i4;
  i5 = i3;
  L2 : while (1) {
   i1 = i5;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= 2e4) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i5 = HEAP32[i1 >> 2] | 0;
   if (!i5) {
    i2 = i1;
    break;
   } else i2 = i1;
  }
  L9 : do if (!i6) while (1) {
   i1 = i3;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 3e4) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L9;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    i4 = i1;
    break;
   } else i4 = i1;
  } while (0);
  if ((i2 | 0) == (i4 | 0)) {
   i2 = 0;
   i1 = 0;
  } else {
   i5 = i13 + 8 | 0;
   while (1) {
    if (!(HEAP32[i12 >> 2] & 1)) i7 = 15; else if (HEAP32[i2 + 40 >> 2] | 0) i7 = 15;
    do if ((i7 | 0) == 15) {
     i7 = 0;
     i1 = i2 + 20 | 0;
     i3 = HEAP32[i14 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) {
      __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i13, i1);
      break;
     } else {
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 20 >> 2] = 0;
      i16 = i2 + 44 | 0;
      i6 = HEAP32[i16 + 4 >> 2] | 0;
      i8 = i3 + 24 | 0;
      HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i8 + 4 >> 2] = i6;
      HEAP8[i3 + 4 >> 0] = 0;
      __ZN4core20StringStorageDefaultIcE6assignERKS1_(i3, i1);
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 32;
      break;
     }
    } while (0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = HEAP32[i13 >> 2] | 0;
  }
 }
 i3 = i2 - i1 >> 5;
 HEAP32[i9 >> 2] = i3;
 i6 = i12 + 16 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i7 = i12 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 4);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 8 | 0;
 i1 = 0;
 do {
  i3 = i11 + 44 + (i1 << 5) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i10, i3); else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i17 = i11 + 44 + (i1 << 5) + 24 | 0;
   i5 = HEAP32[i17 + 4 >> 2] | 0;
   i16 = i2 + 24 | 0;
   HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i16 + 4 >> 2] = i5;
   HEAP8[i2 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i3);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 32;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i2 - i1 >> 5;
 HEAP32[i9 >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i12, i1, 1);
   __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (i1 | 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i8 >> 2] = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i12, i11 + 1068 | 0, 0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i14 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i14 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i15;
 return;
}

function __Z13FormatOrderedPKcz(i11, i4, i1) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 72 | 0;
 i10 = i13 + 32 | 0;
 i5 = i13 + 16 | 0;
 i12 = i13;
 i3 = _strlen(i4) | 0;
 HEAP32[i5 >> 2] = i1;
 i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = i7 + 4;
 if (!i2) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i4, _strlen(i4) | 0);
  STACKTOP = i13;
  return;
 }
 i1 = _strlen(i2) | 0;
 HEAP32[i10 >> 2] = i1;
 i1 = i1 + (i3 + 1) | 0;
 HEAP32[i9 >> 2] = i2;
 i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = i7 + 4;
 if (!i2) {
  i2 = 1;
  i8 = 3;
 } else {
  i7 = _strlen(i2) | 0;
  HEAP32[i10 + 4 >> 2] = i7;
  i1 = i7 + i1 | 0;
  HEAP32[i9 + 4 >> 2] = i2;
  i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i5 >> 2] = i7 + 4;
  if (!i2) {
   i2 = 2;
   i8 = 3;
  } else {
   i7 = _strlen(i2) | 0;
   HEAP32[i10 + 8 >> 2] = i7;
   i1 = i7 + i1 | 0;
   HEAP32[i9 + 8 >> 2] = i2;
   i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i5 >> 2] = i7 + 4;
   if (!i2) {
    i2 = 3;
    i8 = 3;
   } else {
    i7 = _strlen(i2) | 0;
    HEAP32[i10 + 12 >> 2] = i7;
    i1 = i7 + i1 | 0;
    HEAP32[i9 + 12 >> 2] = i2;
    i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i5 >> 2] = i7 + 4;
    if (!i2) {
     i2 = 4;
     i8 = 3;
    } else {
     i7 = _strlen(i2) | 0;
     HEAP32[i10 + 16 >> 2] = i7;
     i1 = i7 + i1 | 0;
     HEAP32[i9 + 16 >> 2] = i2;
     i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
     i2 = HEAP32[i7 >> 2] | 0;
     HEAP32[i5 >> 2] = i7 + 4;
     if (!i2) {
      i2 = 5;
      i8 = 3;
     } else {
      i7 = _strlen(i2) | 0;
      HEAP32[i10 + 20 >> 2] = i7;
      i1 = i7 + i1 | 0;
      HEAP32[i9 + 20 >> 2] = i2;
      i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
      i2 = HEAP32[i7 >> 2] | 0;
      HEAP32[i5 >> 2] = i7 + 4;
      if (!i2) {
       i2 = 6;
       i8 = 3;
      } else {
       i7 = _strlen(i2) | 0;
       HEAP32[i10 + 24 >> 2] = i7;
       i1 = i7 + i1 | 0;
       HEAP32[i9 + 24 >> 2] = i2;
       i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
       i2 = HEAP32[i7 >> 2] | 0;
       HEAP32[i5 >> 2] = i7 + 4;
       if (!i2) {
        i2 = 7;
        i8 = 3;
       } else {
        i7 = _strlen(i2) | 0;
        HEAP32[i10 + 28 >> 2] = i7;
        i1 = i7 + i1 | 0;
        HEAP32[i9 + 28 >> 2] = i2;
        i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
        i2 = HEAP32[i7 >> 2] | 0;
        HEAP32[i5 >> 2] = i7 + 4;
        if (!i2) {
         i2 = 8;
         i8 = 3;
        } else {
         i7 = _strlen(i2) | 0;
         HEAP32[i10 + 32 >> 2] = i7;
         i1 = i7 + i1 | 0;
         HEAP32[i9 + 32 >> 2] = i2;
         i7 = (HEAP32[i5 >> 2] | 0) + (4 - 1) & ~(4 - 1);
         i2 = HEAP32[i7 >> 2] | 0;
         HEAP32[i5 >> 2] = i7 + 4;
         if (!i2) {
          i2 = 9;
          i8 = 3;
         } else {
          i7 = _strlen(i2) | 0;
          HEAP32[i10 + 36 >> 2] = i7;
          HEAP32[i9 + 36 >> 2] = i2;
          i1 = i7 + i1 | 0;
          i2 = 10;
         }
        }
       }
      }
     }
    }
   }
  }
 }
 HEAP32[i12 >> 2] = 0;
 i7 = i12 + 4 | 0;
 i5 = gb + 63160 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 do if (!i1) i3 = 0; else if (i1 >>> 0 < 2e3) {
  i3 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, gb + 64016 | 0, 0, gb + 585605 | 0, 475) | 0;
  i6 = gb + 64016 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i12 >> 2] = i3;
  i8 = i7;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i8 + 4 >> 2] = i6;
  break;
 } while (0);
 i1 = i3;
 L24 : while (1) {
  i6 = HEAP8[i4 >> 0] | 0;
  switch (i6 << 24 >> 24) {
  case 0:
   break L24;
  case 123:
   {
    if ((HEAP8[i4 + 1 >> 0] | 0) == 123) i8 = 13; else {
     i4 = i4 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
     if ((i5 + -48 & 255) < 10) {
      i5 = (i5 << 24 >> 24) + -48 | 0;
      if ((i5 | 0) > -1 & (i5 | 0) < (i2 | 0)) {
       i8 = HEAP32[i10 + (i5 << 2) >> 2] | 0;
       _memcpy(i1 | 0, HEAP32[i9 + (i5 << 2) >> 2] | 0, i8 | 0) | 0;
       i1 = i1 + i8 | 0;
      }
     }
     do {
      i8 = HEAP8[i4 >> 0] | 0;
      i5 = i8 << 24 >> 24 == 0;
      i4 = i4 + 1 | 0;
     } while (i8 << 24 >> 24 != 125 & (i5 ^ 1));
     if (i5) break L24; else continue L24;
    }
    break;
   }
  case 125:
   {
    i5 = i4 + 1 | 0;
    if ((HEAP8[i5 >> 0] | 0) == 125) i8 = 13; else {
     i4 = i5;
     i8 = 21;
    }
    break;
   }
  default:
   {
    i4 = i4 + 1 | 0;
    i8 = 21;
   }
  }
  if ((i8 | 0) == 13) {
   HEAP8[i1 >> 0] = i6;
   i4 = i4 + 2 | 0;
   i1 = i1 + 1 | 0;
   continue;
  } else if ((i8 | 0) == 21) {
   HEAP8[i1 >> 0] = i6;
   i1 = i1 + 1 | 0;
   continue;
  }
 }
 HEAP8[i1 >> 0] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i3, _strlen(i3) | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i7);
 STACKTOP = i13;
 return;
}

function __ZN19SpriteMeshGenerator7invmaskERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEE(i22, i23) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i21 = (HEAP32[i23 + 4 >> 2] | 0) - i1 | 0;
 i24 = i21 >> 5;
 if ((i21 | 0) < 32) {
  i24 = 0;
  return i24 | 0;
 }
 i17 = ~~Math_fround(HEAPF32[i1 >> 2]);
 i18 = i22 + 40 | 0;
 i19 = i22 + 44 | 0;
 i20 = i22 + 56 | 0;
 i2 = 0;
 i16 = HEAP32[i1 + (i24 + -1 << 5) + 4 >> 2] | 0;
 while (1) {
  i3 = HEAP32[i1 + (i2 << 5) >> 2] | 0;
  i4 = HEAP32[i1 + (i2 << 5) + 4 >> 2] | 0;
  i2 = i2 + 1 | 0;
  L6 : do if ((i2 | 0) < (i24 | 0)) {
   i1 = HEAP32[i23 >> 2] | 0;
   f15 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i11 = i4;
   L8 : while (1) {
    f13 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i4 = f15 < f13;
    L10 : do if (f15 > f13) if (i4) while (1) {
     f8 = Math_fround(HEAPF32[i1 + (i2 << 5) + 4 >> 2]);
     if (!(f13 == f8)) {
      i14 = 1;
      break L6;
     }
     f9 = Math_fround(f12 - Math_fround(HEAPF32[i1 + (i2 << 5) >> 2]));
     f8 = Math_fround(f13 - f8);
     if (f9 > Math_fround(0.0)) i4 = 7; else i4 = (((f9 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
     i10 = f8 > Math_fround(0.0);
     i14 = (f8 < Math_fround(0.0)) << 31 >> 31;
     switch (HEAP32[gb + 38036 + (i4 - (i10 ? 1 : i14) << 2) >> 2] | 0) {
     case 5:
     case 1:
      break L10;
     default:
      {}
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i24 | 0)) {
      i14 = 0;
      break L6;
     }
    } else while (1) {
     f8 = Math_fround(HEAPF32[i1 + (i2 << 5) + 4 >> 2]);
     if (!(f13 == f8)) {
      i14 = 1;
      break L6;
     }
     f9 = Math_fround(f12 - Math_fround(HEAPF32[i1 + (i2 << 5) >> 2]));
     f8 = Math_fround(f13 - f8);
     if (f9 > Math_fround(0.0)) i4 = 7; else i4 = (((f9 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
     i10 = f8 > Math_fround(0.0);
     i14 = (f8 < Math_fround(0.0)) << 31 >> 31;
     if ((i4 - (i10 ? 1 : i14) | 0) == 7) break L10;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i24 | 0)) {
      i14 = 0;
      break L6;
     }
    } else {
     if (!i4) break L8;
     while (1) {
      f8 = Math_fround(HEAPF32[i1 + (i2 << 5) + 4 >> 2]);
      if (!(f13 == f8)) {
       i14 = 1;
       break L6;
      }
      f9 = Math_fround(f12 - Math_fround(HEAPF32[i1 + (i2 << 5) >> 2]));
      f8 = Math_fround(f13 - f8);
      if (f9 > Math_fround(0.0)) i4 = 7; else i4 = (((f9 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
      i10 = f8 > Math_fround(0.0);
      i14 = (f8 < Math_fround(0.0)) << 31 >> 31;
      if ((i4 - (i10 ? 1 : i14) | 0) == 1) break L10;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i24 | 0)) {
       i14 = 0;
       break L6;
      }
     }
    } while (0);
    i3 = HEAP32[i1 + (i2 << 5) >> 2] | 0;
    i4 = HEAP32[i1 + (i2 << 5) + 4 >> 2] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) < (i24 | 0)) i11 = i4; else {
     i14 = 0;
     i11 = i4;
     break L6;
    }
   }
   while (1) {
    if (!(f13 == Math_fround(HEAPF32[i1 + (i2 << 5) + 4 >> 2]))) {
     i14 = 1;
     break L6;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i24 | 0)) {
     i14 = 0;
     break;
    }
   }
  } else {
   i14 = 0;
   i11 = i4;
  } while (0);
  f9 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i10 = ~~f9;
  i7 = ~~(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i3 = (i7 | 0) < (i17 | 0) ? i7 : i17;
  i7 = (i17 | 0) < (i7 | 0) ? i7 : i17;
  i6 = (i3 | 0) < (i7 | 0);
  if (!((i10 | 0) < 0 | i6 ^ 1)) {
   i4 = i3;
   do {
    if ((i4 | 0) >= 0) {
     i5 = HEAP32[i18 >> 2] | 0;
     if ((i5 | 0) > (i4 | 0)) if ((HEAP32[i19 >> 2] | 0) > (i10 | 0)) {
      i25 = (Math_imul(i5, i10) | 0) + i4 | 0;
      i5 = (HEAP32[i20 >> 2] | 0) + (i25 >>> 5 << 2) | 0;
      HEAP32[i5 >> 2] = HEAP32[i5 >> 2] ^ 1 << (i25 & 31);
     }
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i7 | 0));
  }
  if (i14) {
   f8 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f8 != f9) {
    i1 = HEAP32[i23 >> 2] | 0;
    if (!((i10 | 0) < 0 | Math_fround(HEAPF32[i1 + (i2 << 5) + 4 >> 2]) == f8 & i6 ^ 1)) do {
     if ((i3 | 0) >= 0) {
      i4 = HEAP32[i18 >> 2] | 0;
      if ((i4 | 0) > (i3 | 0)) if ((HEAP32[i19 >> 2] | 0) > (i10 | 0)) {
       i16 = (Math_imul(i4, i10) | 0) + i3 | 0;
       i25 = (HEAP32[i20 >> 2] | 0) + (i16 >>> 5 << 2) | 0;
       HEAP32[i25 >> 2] = HEAP32[i25 >> 2] ^ 1 << (i16 & 31);
      }
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i7 | 0));
   }
  }
  if ((i2 | 0) < (i24 | 0)) i16 = i11; else break;
 }
 if ((i21 | 0) <= 0) {
  i25 = 1;
  return i25 | 0;
 }
 i6 = i22 + 40 | 0;
 i7 = i22 + 44 | 0;
 i5 = i22 + 56 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i23 >> 2] | 0;
  f15 = Math_fround(HEAPF32[i3 + (i1 << 5) >> 2]);
  i2 = ~~f15;
  i3 = ~~Math_fround(HEAPF32[i3 + (i1 << 5) + 4 >> 2]);
  if ((i2 | 0) >= 0) {
   i4 = HEAP32[i6 >> 2] | 0;
   if (!((i3 | 0) < 0 | (i4 | 0) <= (i2 | 0))) if ((HEAP32[i7 >> 2] | 0) > (i3 | 0)) {
    i22 = (Math_imul(i4, i3) | 0) + i2 | 0;
    i25 = (HEAP32[i5 >> 2] | 0) + (i22 >>> 5 << 2) | 0;
    HEAP32[i25 >> 2] = HEAP32[i25 >> 2] & ~(1 << (i22 & 31));
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i24 | 0));
 i1 = 1;
 return i1 | 0;
}

function __ZN14DetailDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 932261 | 0, 0);
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932271 | 0, i7, i1 + 16 | 0, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i5 + 32 >> 2] = Math_fround(.262745112);
 HEAPF32[i5 + 36 >> 2] = Math_fround(.976470589);
 HEAPF32[i5 + 40 >> 2] = Math_fround(.164705887);
 HEAPF32[i5 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 48 >> 2] = Math_fround(.80392158);
 HEAPF32[i5 + 52 >> 2] = Math_fround(.737254917);
 HEAPF32[i5 + 56 >> 2] = Math_fround(.101960786);
 HEAPF32[i5 + 60 >> 2] = Math_fround(1.0);
 i3 = i5 + 8 | 0;
 i8 = i5 + 76 | 0;
 i10 = i8 + 60 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(2.0);
 HEAPF32[i5 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 20 >> 2] = Math_fround(2.0);
 HEAPF32[i5 + 24 >> 2] = Math_fround(10.0);
 HEAPF32[i5 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 64 >> 2] = Math_fround(1.0);
 HEAP32[i5 + 68 >> 2] = 2;
 HEAP32[i5 + 72 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 937557 | 0, i5, 0);
 __ZN15DetailPrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN15DetailPrototypeD2Ev(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932290 | 0, i3, i1 + 36 | 0, 0);
 i8 = i2 + 16 | 0;
 i10 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932303 | 0, i3, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932318 | 0, i7, i1 + 44 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i5, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932336 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932352 | 0, i7, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932374 | 0, i7, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932394 | 0, i7, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN12TreeDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932413 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 104 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034905 | 0, i6, 0);
 i7 = i4 + 8 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i3, i6, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i9;
 return;
}

function __ZN14SubstanceInputaSERKS_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 12 | 0;
 i8 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 i14 = (i10 | 0) == (i11 | 0);
 if (i14) {
  i1 = i10 + 64 | 0;
  i2 = i11 + 64 | 0;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i7 = i10 + 116 | 0;
  i6 = i11 + 116 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 } else {
  i6 = HEAP8[i11 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i6 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
  i3 = i10 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  } else {
   if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i10 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
  i1 = i10 + 16 | 0;
  i6 = i11 + 16 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i11 + 20 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i10 + 20 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  i1 = i10 + 32 | 0;
  i6 = i11 + 32 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i11 + 36 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 40 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 36 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i10 + 36 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  i1 = i10 + 48 | 0;
  i6 = i11 + 48 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i11 + 52 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i10 + 52 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  i1 = i10 + 64 | 0;
  i2 = i11 + 64 | 0;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i10 + 104 | 0, HEAP32[i11 + 104 >> 2] | 0, HEAP32[i11 + 108 >> 2] | 0);
  i7 = i10 + 116 | 0;
  i6 = i11 + 116 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  if (!i14) __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i10 + 128 | 0, HEAP32[i11 + 128 >> 2] | 0, HEAP32[i11 + 132 >> 2] | 0);
 }
 HEAP32[i10 + 140 >> 2] = HEAP32[i11 + 140 >> 2];
 if (i14) {
  STACKTOP = i15;
  return i10 | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i11 + 144 >> 2];
 HEAP32[i13 >> 2] = i11 + 148;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE14__assign_multiINS_21__tree_const_iteratorIjPNS_11__tree_nodeIjPvEEiEEEEvT_SD_(i10 + 144 | 0, i8, i9);
 STACKTOP = i15;
 return i10 | 0;
}

function __ZN5physx14PxsAABBManager28removeAggregateAggregatePairEPNS_9AggregateES2_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i25, i1, i2, i17) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 17 | 0;
 i22 = i26 + 16 | 0;
 i23 = i26 + 8 | 0;
 i24 = i26;
 i14 = HEAP32[i1 + 1032 >> 2] | 0;
 i16 = i2 + 1032 | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP8[i1 + 1025 >> 0] | 0;
 i15 = i1 & 255;
 i9 = HEAP8[i2 + 1025 >> 0] | 0;
 i18 = i9 & 255;
 i19 = i23 + 4 | 0;
 HEAP8[i19 >> 0] = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i15 << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i23 >> 2] = i10;
 i20 = i24 + 4 | 0;
 HEAP8[i20 >> 0] = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i18 << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i24 >> 2] = i12;
 i13 = i1 << 24 >> 24 == 0;
 if (!i13) {
  i2 = i9 << 24 >> 24 == 0;
  i3 = i25 + 316 | 0;
  i1 = HEAP32[i25 + 308 >> 2] | 0;
  i5 = 0;
  i6 = i14;
  i7 = 0;
  while (1) {
   if (!((HEAP32[i1 + (i6 << 2) >> 2] | 0) != 1073741823 | i2)) {
    i4 = HEAP32[i17 >> 2] | 0;
    i8 = 0;
    do {
     i28 = i8 + i5 | 0;
     i27 = i4 + (i28 >>> 5 << 2) | 0;
     HEAP32[i27 >> 2] = HEAP32[i27 >> 2] & ~HEAP32[i25 + 384 + ((i28 & 31) << 2) >> 2];
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i18 | 0));
   }
   HEAP32[i10 + (i7 << 2) >> 2] = i6;
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i15 | 0)) break; else {
    i5 = i5 + i18 | 0;
    i6 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   }
  }
 }
 i6 = i9 << 24 >> 24 == 0;
 if (i6) i1 = 0; else {
  i4 = HEAP32[i25 + 308 >> 2] | 0;
  i5 = HEAP32[i25 + 316 >> 2] | 0;
  i2 = i11;
  i3 = 0;
  i1 = 0;
  while (1) {
   i1 = ((HEAP32[i4 + (i2 << 2) >> 2] | 0) != 1073741823 & 1) + i1 | 0;
   HEAP32[i12 + (i3 << 2) >> 2] = i2;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i18 | 0)) break; else i2 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  }
 }
 if (!((i1 | 0) == (i18 | 0) | i13)) {
  i7 = i25 + 316 | 0;
  if (!i6) {
   i5 = HEAP32[i25 + 308 >> 2] | 0;
   i6 = 0;
   i2 = i14;
   i3 = 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) != 1073741823) {
     i1 = i16;
     i4 = 0;
     while (1) {
      i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == 1073741823) {
       i27 = i4 + i6 | 0;
       i28 = (HEAP32[i17 >> 2] | 0) + (i27 >>> 5 << 2) | 0;
       HEAP32[i28 >> 2] = HEAP32[i28 >> 2] & ~HEAP32[i25 + 384 + ((i27 & 31) << 2) >> 2];
      }
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i18 | 0)) break; else i1 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
     }
    }
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i15 | 0)) break; else {
     i6 = i6 + i18 | 0;
     i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    }
   }
  }
 }
 i15 = HEAP32[i17 + 4 >> 2] & 2147483647;
 L29 : do if (i15 | 0) {
  i4 = HEAP32[i17 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) break L29;
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L35 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) {
    i2 = 0;
    break L35;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i3 | 0) != -1) {
   i10 = HEAP32[i17 >> 2] | 0;
   i11 = i25 + 304 | 0;
   i12 = i25 + 49848 | 0;
   i13 = i25 + 49852 | 0;
   i14 = i25 + 49844 | 0;
   do {
    i9 = i1 << 5;
    while (1) {
     i7 = i10 + (i3 >>> 5 << 2) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~HEAP32[i25 + 384 + ((i3 & 31) << 2) >> 2];
     i7 = HEAP32[i11 >> 2] | 0;
     i8 = HEAP32[i7 + (HEAP32[(HEAP32[i23 >> 2] | 0) + (((i3 >>> 0) / (i18 >>> 0) | 0) << 2) >> 2] << 2) >> 2] | 0;
     i7 = HEAP32[i7 + (HEAP32[(HEAP32[i24 >> 2] | 0) + (((i3 >>> 0) % (i18 >>> 0) | 0) << 2) >> 2] << 2) >> 2] | 0;
     i4 = HEAP32[i12 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i13 >> 2] | 0)) {
      i5 = (i4 | 0) == 0 ? 32 : i4 << 1;
      i6 = HEAP32[i14 >> 2] | 0;
      i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i21, i5 << 3, gb + 717789 | 0, 59) | 0;
      if (i6 | 0) _memcpy(i3 | 0, i6 | 0, i4 << 3 | 0) | 0;
      _memset(i3 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i6);
      HEAP32[i14 >> 2] = i3;
      HEAP32[i13 >> 2] = i5;
      i4 = HEAP32[i12 >> 2] | 0;
     } else i3 = HEAP32[i14 >> 2] | 0;
     HEAP32[i12 >> 2] = i4 + 1;
     HEAP32[i3 + (i4 << 3) >> 2] = i8;
     HEAP32[i3 + (i4 << 3) + 4 >> 2] = i7;
     if (!i2) break L29;
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i9;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i3 | 0) == -1) break L29;
    }
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i15 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i3 | 0) != -1);
  }
 } while (0);
 if (HEAP8[i20 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i24, HEAP32[i24 >> 2] | 0);
 if (!(HEAP8[i19 >> 0] | 0)) {
  STACKTOP = i26;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i23, HEAP32[i23 >> 2] | 0);
 STACKTOP = i26;
 return;
}

function __Z21GetSceneHierarchyPathPK6Object(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29 + 64 | 0;
 i27 = i29 + 48 | 0;
 i23 = i29 + 32 | 0;
 i24 = i29 + 16 | 0;
 i25 = i29;
 do if (i1 | 0) {
  i3 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
  if ((i3 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) {
   if ((i3 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) break;
   i1 = HEAP32[i1 + 28 >> 2] | 0;
  }
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  i22 = i27 + 12 | 0;
  HEAP32[i22 >> 2] = i3;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  i4 = __ZNK10GameObject23QueryComponentTransformEv(i1) | 0;
  if (!i4) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = i3;
   i1 = i27 + 11 | 0;
   i28 = 28;
  } else {
   i1 = i27 + 11 | 0;
   i9 = i27 + 4 | 0;
   i10 = i25 + 12 | 0;
   i11 = i25 + 11 | 0;
   i12 = i23 + 11 | 0;
   i13 = i23 + 4 | 0;
   i14 = i27 + 8 | 0;
   i15 = i23 + 12 | 0;
   i16 = i26 + 4 | 0;
   i17 = i24 + 11 | 0;
   i18 = i24 + 12 | 0;
   i19 = i26 + 4 | 0;
   i20 = i25 + 12 | 0;
   i21 = i26 + 4 | 0;
   do {
    i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    i5 = HEAP8[i1 >> 0] | 0;
    i5 = ((i5 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i5 & 255) | 0) == 0;
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    HEAP32[i10 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    i6 = i5 & 1 ^ 1;
    HEAP8[i11 >> 0] = i6;
    if (i6 | 0) _memcpy(i25 | 0, (i5 ? gb + 1576256 | 0 : gb + 1087627 | 0) | 0, i6 | 0) | 0;
    HEAP8[i25 + i6 >> 0] = 0;
    __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_(i24, i3, i25);
    __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i23, i24, i27);
    i8 = HEAP8[i12 >> 0] | 0;
    i3 = i8 << 24 >> 24 < 0;
    i7 = i3 ? HEAP32[i23 >> 2] | 0 : i23;
    i8 = i3 ? HEAP32[i13 >> 2] | 0 : i8 & 255;
    i3 = HEAP8[i1 >> 0] | 0;
    i5 = i3 << 24 >> 24 < 0;
    if (i5) i6 = (HEAP32[i14 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
    do if (i8 >>> 0 > i6 >>> 0) {
     i5 = i5 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i27, i6, i8 - i6 | 0, i5, 0, i5, i8, i7);
    } else {
     i3 = i5 ? HEAP32[i27 >> 2] | 0 : i27;
     if (i8 | 0) _memmove(i3 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i3 + i8 >> 0] = 0;
     if ((HEAP8[i1 >> 0] | 0) < 0) {
      HEAP32[i9 >> 2] = i8;
      break;
     } else {
      HEAP8[i1 >> 0] = i8;
      break;
     }
    } while (0);
    if ((HEAP8[i12 >> 0] | 0) < 0) {
     i8 = HEAP32[i23 >> 2] | 0;
     i7 = HEAP32[i15 >> 2] | 0;
     HEAP32[i26 >> 2] = 1;
     HEAP32[i16 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i26);
    }
    if ((HEAP8[i17 >> 0] | 0) < 0) {
     i8 = HEAP32[i24 >> 2] | 0;
     i7 = HEAP32[i18 >> 2] | 0;
     HEAP32[i26 >> 2] = 1;
     HEAP32[i19 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i26);
    }
    if ((HEAP8[i11 >> 0] | 0) < 0) {
     i8 = HEAP32[i25 >> 2] | 0;
     i7 = HEAP32[i20 >> 2] | 0;
     HEAP32[i26 >> 2] = 1;
     HEAP32[i21 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i26);
    }
    i4 = HEAP32[i4 + 100 >> 2] | 0;
   } while ((i4 | 0) != 0);
   i3 = HEAP32[i22 >> 2] | 0;
   i25 = (HEAP8[i1 >> 0] | 0) < 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i4 = i2 + 12 | 0;
   HEAP32[i4 >> 2] = i3;
   if (i25) {
    i5 = HEAP32[i27 >> 2] | 0;
    i6 = HEAP32[i27 + 4 >> 2] | 0;
    if (i6 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i3 = HEAP32[i4 >> 2] | 0;
     i28 = 32;
    } else if (i6 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i6;
     if (i6) i28 = 34;
    } else i28 = 32;
    if ((i28 | 0) == 32) {
     i24 = i6 + 16 & -16;
     HEAP32[i26 >> 2] = 1;
     HEAP32[i26 + 4 >> 2] = i3;
     i25 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i26, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i25;
     HEAP32[i2 + 8 >> 2] = i24 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i6;
     i2 = i25;
     i28 = 34;
    }
    if ((i28 | 0) == 34) _memcpy(i2 | 0, i5 | 0, i6 | 0) | 0;
    HEAP8[i2 + i6 >> 0] = 0;
   } else i28 = 28;
  }
  if ((i28 | 0) == 28) {
   HEAP32[i2 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
  }
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   i28 = HEAP32[i27 >> 2] | 0;
   i27 = HEAP32[i27 + 12 >> 2] | 0;
   HEAP32[i26 >> 2] = 1;
   HEAP32[i26 + 4 >> 2] = i27;
   __Z19free_alloc_internalPvRK10MemLabelId(i28, i26);
  }
  STACKTOP = i29;
  return;
 } while (0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 STACKTOP = i29;
 return;
}

function runPostSets233() {
 HEAP32[gb + 11740 >> 2] = (HEAP32[gb + 11740 >> 2] | 0) + (gb + 1079702 | 0);
 HEAP32[gb + 11744 >> 2] = (HEAP32[gb + 11744 >> 2] | 0) + (gb + 11600 | 0);
 HEAP32[gb + 211920 >> 2] = (HEAP32[gb + 211920 >> 2] | 0) + (gb + 11752 | 0);
 HEAP32[gb + 211924 >> 2] = fb + 3105;
 HEAP32[gb + 211928 >> 2] = fb + 3106;
 HEAP32[gb + 211932 >> 2] = fb + 3068;
 HEAP32[gb + 211936 >> 2] = fb + 1482;
 HEAP32[gb + 211940 >> 2] = fb + 1483;
 HEAP32[gb + 211944 >> 2] = fb + 2330;
 HEAP32[gb + 211948 >> 2] = fb + 2331;
 HEAP32[gb + 211952 >> 2] = fb + 2332;
 HEAP32[gb + 211956 >> 2] = fb + 2333;
 HEAP32[gb + 211960 >> 2] = fb + 1484;
 HEAP32[gb + 211964 >> 2] = fb + 2334;
 HEAP32[gb + 211968 >> 2] = fb + 2335;
 HEAP32[gb + 11752 >> 2] = (HEAP32[gb + 11752 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11756 >> 2] = (HEAP32[gb + 11756 >> 2] | 0) + (gb + 1079737 | 0);
 HEAP32[gb + 11760 >> 2] = (HEAP32[gb + 11760 >> 2] | 0) + (gb + 11640 | 0);
 HEAP32[gb + 211976 >> 2] = (HEAP32[gb + 211976 >> 2] | 0) + (gb + 11768 | 0);
 HEAP32[gb + 211980 >> 2] = fb + 3107;
 HEAP32[gb + 211984 >> 2] = fb + 3108;
 HEAP32[gb + 211988 >> 2] = fb + 3068;
 HEAP32[gb + 211992 >> 2] = fb + 1485;
 HEAP32[gb + 211996 >> 2] = fb + 1486;
 HEAP32[gb + 212e3 >> 2] = fb + 2336;
 HEAP32[gb + 212004 >> 2] = fb + 2337;
 HEAP32[gb + 212008 >> 2] = fb + 2338;
 HEAP32[gb + 212012 >> 2] = fb + 2339;
 HEAP32[gb + 212016 >> 2] = fb + 1487;
 HEAP32[gb + 212020 >> 2] = fb + 2340;
 HEAP32[gb + 212024 >> 2] = fb + 2341;
 HEAP32[gb + 11768 >> 2] = (HEAP32[gb + 11768 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11772 >> 2] = (HEAP32[gb + 11772 >> 2] | 0) + (gb + 1079772 | 0);
 HEAP32[gb + 11776 >> 2] = (HEAP32[gb + 11776 >> 2] | 0) + (gb + 11672 | 0);
 HEAP32[gb + 212032 >> 2] = (HEAP32[gb + 212032 >> 2] | 0) + (gb + 11784 | 0);
 HEAP32[gb + 212036 >> 2] = fb + 3109;
 HEAP32[gb + 212040 >> 2] = fb + 3110;
 HEAP32[gb + 212044 >> 2] = fb + 3068;
 HEAP32[gb + 212048 >> 2] = fb + 1488;
 HEAP32[gb + 212052 >> 2] = fb + 1489;
 HEAP32[gb + 212056 >> 2] = fb + 2342;
 HEAP32[gb + 212060 >> 2] = fb + 2343;
 HEAP32[gb + 212064 >> 2] = fb + 2344;
 HEAP32[gb + 212068 >> 2] = fb + 2345;
 HEAP32[gb + 212072 >> 2] = fb + 1490;
 HEAP32[gb + 212076 >> 2] = fb + 2346;
 HEAP32[gb + 212080 >> 2] = fb + 2347;
 HEAP32[gb + 11784 >> 2] = (HEAP32[gb + 11784 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11788 >> 2] = (HEAP32[gb + 11788 >> 2] | 0) + (gb + 1079807 | 0);
 HEAP32[gb + 11792 >> 2] = (HEAP32[gb + 11792 >> 2] | 0) + (gb + 11704 | 0);
 HEAP32[gb + 212088 >> 2] = (HEAP32[gb + 212088 >> 2] | 0) + (gb + 11800 | 0);
 HEAP32[gb + 212092 >> 2] = fb + 3111;
 HEAP32[gb + 212096 >> 2] = fb + 3112;
 HEAP32[gb + 212100 >> 2] = fb + 3068;
 HEAP32[gb + 212104 >> 2] = fb + 79;
 HEAP32[gb + 212108 >> 2] = fb + 80;
 HEAP32[gb + 11800 >> 2] = (HEAP32[gb + 11800 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11804 >> 2] = (HEAP32[gb + 11804 >> 2] | 0) + (gb + 1079869 | 0);
 HEAP32[gb + 11816 >> 2] = (HEAP32[gb + 11816 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11824 >> 2] = (HEAP32[gb + 11824 >> 2] | 0) + (gb + 11832 | 0);
 HEAP32[gb + 11832 >> 2] = (HEAP32[gb + 11832 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11836 >> 2] = (HEAP32[gb + 11836 >> 2] | 0) + (gb + 1079939 | 0);
 HEAP32[gb + 212116 >> 2] = (HEAP32[gb + 212116 >> 2] | 0) + (gb + 11840 | 0);
 HEAP32[gb + 212120 >> 2] = fb + 3113;
 HEAP32[gb + 212124 >> 2] = fb + 3114;
 HEAP32[gb + 212128 >> 2] = fb + 3068;
 HEAP32[gb + 212132 >> 2] = fb + 81;
 HEAP32[gb + 212136 >> 2] = fb + 82;
 HEAP32[gb + 11840 >> 2] = (HEAP32[gb + 11840 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11844 >> 2] = (HEAP32[gb + 11844 >> 2] | 0) + (gb + 1079975 | 0);
 HEAP32[gb + 11856 >> 2] = (HEAP32[gb + 11856 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11864 >> 2] = (HEAP32[gb + 11864 >> 2] | 0) + (gb + 11872 | 0);
 HEAP32[gb + 11872 >> 2] = (HEAP32[gb + 11872 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11876 >> 2] = (HEAP32[gb + 11876 >> 2] | 0) + (gb + 1080045 | 0);
 HEAP32[gb + 212144 >> 2] = (HEAP32[gb + 212144 >> 2] | 0) + (gb + 11880 | 0);
 HEAP32[gb + 212148 >> 2] = fb + 3115;
 HEAP32[gb + 212152 >> 2] = fb + 3116;
 HEAP32[gb + 212156 >> 2] = fb + 3068;
 HEAP32[gb + 212160 >> 2] = fb + 1;
 HEAP32[gb + 212164 >> 2] = fb + 128;
 HEAP32[gb + 11880 >> 2] = (HEAP32[gb + 11880 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11884 >> 2] = (HEAP32[gb + 11884 >> 2] | 0) + (gb + 1080076 | 0);
 HEAP32[gb + 11896 >> 2] = (HEAP32[gb + 11896 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11904 >> 2] = (HEAP32[gb + 11904 >> 2] | 0) + (gb + 11912 | 0);
 HEAP32[gb + 11912 >> 2] = (HEAP32[gb + 11912 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11916 >> 2] = (HEAP32[gb + 11916 >> 2] | 0) + (gb + 1080146 | 0);
 HEAP32[gb + 212172 >> 2] = (HEAP32[gb + 212172 >> 2] | 0) + (gb + 11920 | 0);
 HEAP32[gb + 212176 >> 2] = fb + 3117;
 HEAP32[gb + 212180 >> 2] = fb + 3118;
 HEAP32[gb + 212184 >> 2] = fb + 3068;
 HEAP32[gb + 212188 >> 2] = fb + 2;
 HEAP32[gb + 212192 >> 2] = fb + 129;
 HEAP32[gb + 11920 >> 2] = (HEAP32[gb + 11920 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11924 >> 2] = (HEAP32[gb + 11924 >> 2] | 0) + (gb + 1080171 | 0);
 HEAP32[gb + 11936 >> 2] = (HEAP32[gb + 11936 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11944 >> 2] = (HEAP32[gb + 11944 >> 2] | 0) + (gb + 11952 | 0);
 HEAP32[gb + 11952 >> 2] = (HEAP32[gb + 11952 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11956 >> 2] = (HEAP32[gb + 11956 >> 2] | 0) + (gb + 1080241 | 0);
 HEAP32[gb + 212200 >> 2] = (HEAP32[gb + 212200 >> 2] | 0) + (gb + 11960 | 0);
 HEAP32[gb + 212204 >> 2] = fb + 3119;
 runPostSets234();
}

function __Z29AddRenderersToRenderNodeQueuePP12BaseRendererjR15RenderNodeQueue(i9, i11, i12) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1744 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 16 | 0;
 i10 = i14;
 i13 = i14 + 32 | 0;
 i1 = i13 + 1304 | 0;
 i2 = i13 + 24 | 0;
 do {
  __ZN22PerThreadPageAllocatorC2Ev(i2 + 16 | 0);
  i8 = i2 + 32 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  i8 = gb + 64024 | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i10;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 68 >> 2] = 0;
  HEAP32[i2 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i10);
  i6 = i5;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 60 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i2 = i2 + 80 | 0;
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i13 + 1304 >> 2] = 0;
 HEAP32[i13 + 1308 >> 2] = 0;
 i1 = HEAP32[gb + 1112412 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1508 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 16 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1512 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 32 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1516 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1520 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 64 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1524 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 80 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1528 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 96 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1532 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 112 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1536 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 128 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1540 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 144 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1544 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 160 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1548 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 176 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1552 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 192 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1556 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 208 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1560 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 224 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1564 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 240 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i13 + 1568 >> 2] = i1;
 __ZN22PerThreadPageAllocatorC2ER19AtomicPageAllocator(i5, i12 + 20 | 0);
 i8 = i12 + 12 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) + i11 | 0;
 HEAP32[i8 >> 2] = i2;
 i7 = i12 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 * 360 | 0, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 360 | 0, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 360 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i12 >> 2] = i6;
  break;
 } while (0);
 HEAP32[i10 >> 2] = 0;
 i3 = i10 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i10 + 8 | 0;
 HEAP32[i10 + 12 >> 2] = i5;
 i5 = i12 + 32804 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i6;
 if (!i11) i2 = i6; else {
  i2 = HEAP32[gb + 1161204 >> 2] | 0;
  i1 = 0;
  do {
   i15 = i9 + (i1 << 2) | 0;
   i16 = HEAP32[i15 >> 2] | 0;
   HEAP32[i10 >> 2] = i16;
   HEAP32[i3 >> 2] = i2;
   mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0);
   i15 = HEAP32[i15 >> 2] | 0;
   if ((mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i12 | 0, i10 | 0) | 0) != -1) HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  i2 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i2;
 if (i2 >>> 0 >= (i6 + i11 | 0) >>> 0) {
  __ZN29RenderNodeQueuePrepareContextD2Ev(i13);
  STACKTOP = i14;
  return;
 }
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 & 2147483647) >>> 0 >= i2 >>> 0) {
  __ZN29RenderNodeQueuePrepareContextD2Ev(i13);
  STACKTOP = i14;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 * 360 | 0, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  __ZN29RenderNodeQueuePrepareContextD2Ev(i13);
  STACKTOP = i14;
  return;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 360 | 0, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 360 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i12 >> 2] = i16;
  __ZN29RenderNodeQueuePrepareContextD2Ev(i13);
  STACKTOP = i14;
  return;
 }
}

function __ZN22ParticleSystemRenderer23UpdateVertexInputLayoutEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i15 = i16;
 i4 = i13 + 340 | 0;
 i1 = HEAP16[i13 + 388 >> 1] | 0;
 i3 = i1 & 255;
 i5 = i3 << 24 >> 24 == 0;
 if (i5) i8 = (HEAP16[i4 >> 1] | 0) == 4; else i8 = 0;
 i9 = i13 + 396 | 0;
 i2 = HEAP32[i13 + 392 >> 2] | 0;
 if (!((HEAP32[i9 >> 2] | 0) != (i2 | 0) | (i8 | ((i1 & 65535) >>> 8 & 255) << 24 >> 24 != i3 << 24 >> 24))) {
  STACKTOP = i16;
  return;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP8[i13 + 389 >> 0] = i3;
 i12 = i13 + 400 | 0;
 HEAP16[i12 >> 1] = 0;
 i10 = i13 + 402 | 0;
 HEAP16[i10 >> 1] = 0;
 HEAP16[i14 >> 1] = 0;
 HEAP16[i14 + 2 >> 1] = 0;
 HEAP16[i14 + 4 >> 1] = 0;
 HEAP16[i14 + 6 >> 1] = 0;
 HEAP16[i14 + 8 >> 1] = 0;
 HEAP16[i14 + 10 >> 1] = 0;
 HEAP16[i14 + 12 >> 1] = 0;
 HEAP16[i14 + 14 >> 1] = 0;
 if (i5) if ((HEAP16[i4 >> 1] | 0) == 4) {
  i1 = HEAP32[i13 + 408 >> 2] | 0;
  if (!i1) {
   i2 = 9;
   i11 = 9;
  } else {
   i11 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = HEAP8[i11 + 15 >> 0] | 0 ? 11 : 9;
   i2 = HEAP8[i11 + 39 >> 0] | 0 ? i2 | 4 : i2;
   i11 = 8;
  }
 } else {
  i2 = 27;
  i11 = 9;
 } else i11 = 8;
 if ((i11 | 0) == 8) if (!(i2 & 1)) {
  i1 = 0;
  i3 = 0;
 } else i11 = 9;
 if ((i11 | 0) == 9) {
  HEAP16[i12 >> 1] = 12;
  HEAP16[i14 >> 1] = 768;
  i1 = 1;
  i3 = 12;
 }
 if (i2 & 2) {
  i3 = (i3 & 65535) + 12 & 65535;
  HEAP16[i12 >> 1] = i3;
  HEAP16[i14 + 2 >> 1] = 768;
  i1 = i1 | 2;
 }
 if (i2 & 4) {
  i3 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i3;
  HEAP16[i14 + 14 >> 1] = 1024;
  i1 = i1 | 128;
 }
 if (i2 & 8) {
  i3 = (i3 & 65535) + 4 & 65535;
  HEAP16[i12 >> 1] = i3;
  HEAP16[i14 + 4 >> 1] = 1026;
  i1 = i1 | 4;
 }
 i7 = (i2 & 16 | 0) != 0;
 if (i7) {
  i3 = (i3 & 65535) + 8 & 65535;
  HEAP16[i12 >> 1] = i3;
  HEAP16[i14 + 6 >> 1] = 512;
  i4 = 1;
  i1 = i1 | 8;
 } else i4 = 0;
 i6 = (i2 & 32 | 0) != 0;
 if (i6) {
  i3 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = i4 + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 1024;
  i4 = i4 + 1 | 0;
  i1 = 1 << i5 | i1;
 }
 if (i2 & 64) {
  i3 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = i4 + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 1024;
  i4 = i4 + 1 | 0;
  i1 = 1 << i5 | i1;
 }
 if (i2 & 128) {
  i3 = (i3 & 65535) + 12 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = i4 + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 768;
  i4 = i4 + 1 | 0;
  i1 = 1 << i5 | i1;
 }
 if (i2 & 256) {
  i3 = (i3 & 65535) + 12 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 768;
  i4 = i4 + 1 | 0;
  i1 = 1 << i5 | i1;
 }
 if (i2 & 512) {
  i3 = (i3 & 65535) + 12 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 768;
  i4 = i4 + 1 | 0;
  i1 = 1 << i5 | i1;
 }
 if (i2 & 1024) {
  i3 = (i3 & 65535) + 8 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 512;
  i1 = 1 << i5 | i1;
  i4 = i4 + 1 | 0;
 }
 if (i2 & 2048) {
  i3 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 1024;
  i1 = 1 << i5 | i1;
  i4 = i4 + 1 | 0;
 }
 if (i2 & 4096) {
  i3 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i3;
  i5 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i5 << 1) >> 1] = 1024;
  i1 = 1 << i5 | i1;
  i4 = i4 + 1 | 0;
 }
 if (!(i2 & 8192)) i5 = i3; else {
  i5 = (i3 & 65535) + 16 & 65535;
  HEAP16[i12 >> 1] = i5;
  i4 = (i4 >>> 0 > 3 ? 3 : i4) + 3 | 0;
  HEAP16[i14 + (i4 << 1) >> 1] = 1024;
  i1 = 1 << i4 | i1;
 }
 if (i7) {
  HEAP16[i10 >> 1] = 1;
  i3 = 1;
 } else i3 = 0;
 if (i6) {
  i4 = i3 + 1 << 16 >> 16;
  HEAP16[i10 >> 1] = i4;
 } else i4 = i3;
 L61 : do if (i8) {
  i3 = HEAP32[i13 + 408 >> 2] | 0;
  if (!i3) break;
  HEAP32[i9 >> 2] = i2;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
  if ((HEAPU16[i3 + 22 >> 1] | 0) < 256) i2 = i4; else {
   i2 = i4 << 16 >> 16 == 0 ? 1 : i4;
   HEAP16[i10 >> 1] = i2;
  }
  if ((HEAPU16[i3 + 26 >> 1] | 0) >= 256) {
   i2 = i2 & 65535;
   i2 = (i2 >>> 0 < 2 ? 2 : i2) & 65535;
   HEAP16[i10 >> 1] = i2;
  }
  if ((HEAPU16[i3 + 30 >> 1] | 0) < 256) i4 = i2; else {
   i4 = i2 & 65535;
   i4 = (i4 >>> 0 < 3 ? 3 : i4) & 65535;
   HEAP16[i10 >> 1] = i4;
  }
  i2 = i4 & 65535;
  do if ((HEAPU16[i3 + 34 >> 1] | 0) < 256) {
   i3 = (i5 & 65535) + (i2 << 3) | 0;
   if ((i4 & 65535) > 1) {
    i11 = 45;
    break;
   }
   HEAP16[i12 >> 1] = i3;
   if (!(i4 << 16 >> 16)) break L61; else i3 = i2;
  } else {
   i2 = i2 >>> 0 < 4 ? 4 : i2;
   HEAP16[i10 >> 1] = i2;
   i3 = (i5 & 65535) + (i2 << 3) | 0;
   i11 = 45;
  } while (0);
  if ((i11 | 0) == 45) {
   HEAP16[i12 >> 1] = i3 + 8;
   i3 = i2;
  }
  i2 = 0;
  do {
   i12 = i2 + 3 | 0;
   HEAP16[i14 + (i12 << 1) >> 1] = (i2 | 0) == 1 ? 1024 : 512;
   i1 = 1 << i12 | i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } while (0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(i1, i14, i15) | 0;
 HEAP32[i13 + 1e3 >> 2] = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i15) | 0;
 STACKTOP = i16;
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN2UI16PixelAdjustPointERK8Vector2fP9TransformPNS_6CanvasE(i18, i15, i11, i14) {
 i18 = i18 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, i16 = 0, i17 = 0, i19 = 0, f20 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 64 | 0;
 i17 = i19;
 if (!((i11 | 0) == 0 | (i14 | 0) == 0)) if ((__ZNK2UI6Canvas13GetRenderModeEv(i14) | 0) != 2) {
  i3 = i14;
  while (1) {
   i4 = HEAP32[i3 + 344 >> 2] | 0;
   if (!i4) break; else i3 = i4;
  }
  if (!(Math_fround(HEAPF32[i3 + 352 >> 2]) == Math_fround(0.0))) {
   i3 = i14;
   while (1) {
    i4 = HEAP32[i3 + 344 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i3 + 361 >> 0] | 0)) i3 = i4; else break;
   }
   if (HEAP8[i3 + 360 >> 0] | 0) {
    i3 = 0;
    i7 = i14;
    while (1) {
     i4 = i7;
     while (1) {
      i5 = HEAP32[i4 + 344 >> 2] | 0;
      if (!i5) break;
      if (!(HEAP8[i4 + 361 >> 0] | 0)) i4 = i5; else break;
     }
     if (!(HEAP8[i4 + 360 >> 0] | 0)) break;
     i3 = HEAP32[i7 + 344 >> 2] | 0;
     if (!i3) {
      i3 = i7;
      break;
     } else {
      i5 = i7;
      i7 = i3;
      i3 = i5;
     }
    }
    i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
    if (!i7) {
     HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
     STACKTOP = i19;
     return;
    }
    __ZNK9Transform21GetWorldToLocalMatrixEv(i16, i7);
    __ZNK9Transform21GetLocalToWorldMatrixEv(i17, i11);
    __ZN10Matrix4x4fmLERKS_(i16, i17) | 0;
    i3 = i17;
    i4 = i16;
    i5 = i3 + 64 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    __Z20InvertMatrix4x4_FullPKfPf(i17, i17) | 0;
    i3 = __ZNK2UI13RectTransform7GetRectEv(i7) | 0;
    f12 = Math_fround(HEAPF32[i3 >> 2]);
    f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    i3 = i14;
    while (1) {
     i4 = HEAP32[i3 + 344 >> 2] | 0;
     if (!i4) break; else i3 = i4;
    }
    f9 = Math_fround(HEAPF32[i3 + 352 >> 2]);
    f10 = Math_fround(Math_fround(1.0) / f9);
    f6 = Math_fround(HEAPF32[i15 >> 2]);
    f1 = Math_fround(HEAPF32[i15 + 4 >> 2]);
    f2 = Math_fround(f6 * Math_fround(HEAPF32[i16 + 12 >> 2]));
    f2 = Math_fround(f2 + Math_fround(f1 * Math_fround(HEAPF32[i16 + 28 >> 2])));
    f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i16 + 44 >> 2]) * Math_fround(0.0)));
    f2 = Math_fround(Math_fround(HEAPF32[i16 + 60 >> 2]) + f2);
    i15 = f2 < Math_fround(0.0);
    f8 = Math_fround(-f2);
    if ((i15 ? f8 : f2) > Math_fround(1.00000001e-07)) {
     f8 = Math_fround(f6 * Math_fround(HEAPF32[i16 + 8 >> 2]));
     f8 = Math_fround(f8 + Math_fround(f1 * Math_fround(HEAPF32[i16 + 24 >> 2])));
     f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i16 + 40 >> 2]) * Math_fround(0.0)));
     f8 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + f8);
     f20 = Math_fround(f6 * Math_fround(HEAPF32[i16 + 4 >> 2]));
     f20 = Math_fround(f20 + Math_fround(f1 * Math_fround(HEAPF32[i16 + 20 >> 2])));
     f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i16 + 36 >> 2]) * Math_fround(0.0)));
     f20 = Math_fround(Math_fround(HEAPF32[i16 + 52 >> 2]) + f20);
     f6 = Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2]));
     f1 = Math_fround(f6 + Math_fround(f1 * Math_fround(HEAPF32[i16 + 16 >> 2])));
     f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i16 + 32 >> 2]) * Math_fround(0.0)));
     f6 = Math_fround(Math_fround(1.0) / f2);
     f8 = Math_fround(f6 * f8);
     f2 = Math_fround(f6 * f20);
     f1 = Math_fround(f6 * Math_fround(Math_fround(HEAPF32[i16 + 48 >> 2]) + f1));
    } else {
     f8 = Math_fround(0.0);
     f2 = Math_fround(0.0);
     f1 = Math_fround(0.0);
    }
    f6 = Math_fround(f12 + Math_fround(f10 * Math_fround(Math_floor(Math_fround(Math_fround(f9 * Math_fround(f1 - f12)) + Math_fround(.5))))));
    f1 = Math_fround(f13 + Math_fround(f10 * Math_fround(Math_floor(Math_fround(Math_fround(f9 * Math_fround(f2 - f13)) + Math_fround(.5))))));
    f2 = Math_fround(f6 * Math_fround(HEAPF32[i17 + 12 >> 2]));
    f2 = Math_fround(f2 + Math_fround(f1 * Math_fround(HEAPF32[i17 + 28 >> 2])));
    f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i17 + 44 >> 2])));
    f2 = Math_fround(Math_fround(HEAPF32[i17 + 60 >> 2]) + f2);
    i16 = f2 < Math_fround(0.0);
    f20 = Math_fround(-f2);
    if ((i16 ? f20 : f2) > Math_fround(1.00000001e-07)) {
     f13 = Math_fround(f6 * Math_fround(HEAPF32[i17 + 4 >> 2]));
     f13 = Math_fround(f13 + Math_fround(f1 * Math_fround(HEAPF32[i17 + 20 >> 2])));
     f13 = Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i17 + 36 >> 2])));
     f13 = Math_fround(Math_fround(HEAPF32[i17 + 52 >> 2]) + f13);
     f20 = Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2]));
     f1 = Math_fround(f20 + Math_fround(f1 * Math_fround(HEAPF32[i17 + 16 >> 2])));
     f1 = Math_fround(f1 + Math_fround(f8 * Math_fround(HEAPF32[i17 + 32 >> 2])));
     f20 = Math_fround(Math_fround(1.0) / f2);
     f2 = Math_fround(f20 * f13);
     f1 = Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i17 + 48 >> 2]) + f1));
    } else {
     f2 = Math_fround(0.0);
     f1 = Math_fround(0.0);
    }
    HEAPF32[i18 >> 2] = f1;
    HEAPF32[i18 + 4 >> 2] = f2;
    STACKTOP = i19;
    return;
   }
  }
 }
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 STACKTOP = i19;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i9 + 28 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i10 + 24 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 20 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 if ((HEAP32[i1 >> 2] | 0) == -2) {
  __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i8 >> 2] = 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i11 >> 2] = i2;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 } else {
  i4 = i9 + 52 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i1 = HEAP32[i9 + 40 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i2 = i1 + (i7 * 60 | 0) | 0;
  if (i7 | 0) do {
   __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i10, i9, 0);
 i1 = i9 + 36 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i4 = i9 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 80 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 192 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 196 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 188 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i10, i9 + 100 | 0, 0);
 i6 = i9 + 116 | 0;
 i7 = i9 + 120 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 2;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 200 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx22PxClothGeneratedValuesC2EPKNS_7PxClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 24 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 28 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i2 + 32 | 0, i1 | 0);
 HEAPF32[i2 + 60 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 64 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 68 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i2 + 72 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i2 + 84 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i2 + 96 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i2 + 108 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i2 + 120 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i2 + 132 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i2 + 144 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i2 + 156 | 0, i1 | 0);
 i5 = i2 + 168 | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 188 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 204 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 228 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 232 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 240 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 244 >> 2] = Math_fround(1.0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i2 + 248 | 0, i1 | 0);
 HEAPF32[i2 + 256 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 376 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 260 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 264 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 392 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 268 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 400 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 432 >> 2] | 0, i2 + 272 | 0, i1 | 0);
 HEAPF32[i2 + 288 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 440 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 448 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 296 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 456 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 300 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 464 >> 2] | 0, i1 | 0));
 HEAP8[i2 + 304 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 476 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAP32[i2 + 308 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i1 | 0, 0);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i2 + 184 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i1 | 0, 1);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i2 + 200 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i1 | 0, 2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i2 + 216 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i1 | 0, 3);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i2 = i2 + 232 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i1 | 0, 4);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 40 | 0;
 i11 = i15 + 24 | 0;
 i10 = i15;
 i3 = i15 + 20 | 0;
 i4 = i15 + 16 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 88 | 0;
 i5 = i1;
 if (i2 >>> 0 >= i8 >>> 0) {
  if (i2 >>> 0 <= i8 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i7 = i5 + (i8 * 88 | 0) | 0;
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i10 = i11 + 12 | 0;
  HEAP32[i10 >> 2] = i1;
  i2 = i8 * 88 | 0;
  i4 = (i2 | 0) / 88 | 0;
  if (!i2) {
   i4 = i11 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i11 >> 2] = i3;
   i2 = i3 + (i4 * 88 | 0) | 0;
   i6 = i11 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i1 = i3;
   if (!i8) {
    i4 = i6;
    i5 = i1;
    i3 = i1;
   } else {
    i1 = i5;
    do {
     i2 = i3;
     i4 = i1;
     i5 = i2 + 56 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
      i2 = i2 + 4 | 0;
      i4 = i4 + 4 | 0;
     } while ((i2 | 0) < (i5 | 0));
     __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i3 + 56 | 0, i1 + 56 | 0);
     i8 = i3 + 76 | 0;
     i5 = i1 + 76 | 0;
     HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     i1 = i1 + 88 | 0;
     i3 = (HEAP32[i9 >> 2] | 0) + 88 | 0;
     HEAP32[i9 >> 2] = i3;
    } while ((i1 | 0) != (i7 | 0));
    i4 = i6;
    i5 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i5;
  i8 = HEAP32[i13 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i13 >> 2] = i3;
  i13 = i12 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i2;
  i4 = i1;
  i2 = i8;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    while (1) {
     i1 = i2 + -88 | 0;
     HEAP32[i9 >> 2] = i1;
     i3 = i2 + -32 | 0;
     if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -28 | 0);
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i9 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  }
  STACKTOP = i15;
  return;
 }
 i6 = i12 + 8 | 0;
 if ((((HEAP32[i6 >> 2] | 0) - i1 | 0) / 88 | 0 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj(i12, i8 - i2 | 0);
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i9 = i10 + 12 | 0;
 HEAP32[i9 >> 2] = i2;
 __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj(i10, i8);
 HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i11, i14);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 88 | 0;
 i4 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj(i10, i8 - i1 | 0);
  i2 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i5 = i3 + (i8 * 88 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -88 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = i2 + -32 | 0;
    if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -28 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   while (1) {
    i1 = i2 + -88 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = i2 + -32 | 0;
    if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -28 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i13 = HEAP32[i9 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 }
 STACKTOP = i15;
 return;
}

function __Z18sweepBox_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i2, i10, i18, f16, i17, i8, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i18 = i18 | 0;
 f16 = Math_fround(f16);
 i17 = i17 | 0;
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, d24 = 0.0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i14 = i15 + 16 | 0;
 HEAP32[i17 + 8 >> 2] = -1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i9, i2);
 i13 = i9 + 12 | 0;
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f3);
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i14, i10 + 36 | 0, i10 + 48 | 0, i10, i10 + 12 | 0, i10 + 24 | 0);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 i7 = i9 + 4 | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 i11 = i9 + 8 | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f4);
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i14 + 4 >> 2]) * f5));
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i14 + 8 >> 2]) * f6));
 i12 = f3 < Math_fround(3402823469999999843913219.0e14);
 f3 = i12 ? f3 : Math_fround(3402823469999999843913219.0e14);
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 12 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 16 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 20 >> 2]) * f6));
 i12 = f23 < f3;
 f3 = i12 ? f23 : f3;
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 24 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 28 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 32 >> 2]) * f6));
 i1 = f23 < f3;
 f3 = i1 ? f23 : f3;
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 36 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 40 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 44 >> 2]) * f6));
 i2 = f23 < f3;
 f3 = i2 ? f23 : f3;
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 48 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 52 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 56 >> 2]) * f6));
 i19 = f23 < f3;
 f3 = i19 ? f23 : f3;
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 60 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 64 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 68 >> 2]) * f6));
 i20 = f23 < f3;
 f3 = i20 ? f23 : f3;
 f23 = Math_fround(Math_fround(HEAPF32[i14 + 72 >> 2]) * f4);
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 76 >> 2]) * f5));
 f23 = Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i14 + 80 >> 2]) * f6));
 i21 = f23 < f3;
 f3 = i21 ? f23 : f3;
 f4 = Math_fround(Math_fround(HEAPF32[i14 + 84 >> 2]) * f4);
 f5 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i14 + 88 >> 2]) * f5));
 f6 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i14 + 92 >> 2]) * f6));
 i22 = f6 < f3;
 f3 = i22 ? f6 : f3;
 i12 = i22 ? 7 : i21 ? 6 : i20 ? 5 : i19 ? 4 : i2 ? 3 : i1 ? 2 : i12 & 1;
 i1 = HEAPU16[i8 >> 1] | 0;
 if (!(i1 & 512)) {
  if (!(i1 & 16)) if (f3 <= Math_fround(-Math_fround(HEAPF32[i13 >> 2]))) {
   HEAP16[i17 + 12 >> 1] = 6;
   HEAPF32[i17 + 40 >> 2] = Math_fround(0.0);
   f6 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
   f16 = Math_fround(-Math_fround(HEAPF32[i18 + 4 >> 2]));
   f23 = Math_fround(-Math_fround(HEAPF32[i18 + 8 >> 2]));
   HEAPF32[i17 + 28 >> 2] = f6;
   HEAPF32[i17 + 32 >> 2] = f16;
   HEAPF32[i17 + 36 >> 2] = f23;
   i22 = 1;
   STACKTOP = i15;
   return i22 | 0;
  }
 } else if (f3 <= Math_fround(-Math_fround(HEAPF32[i13 >> 2]))) {
  HEAP16[i17 + 12 >> 1] = 7;
  i22 = __ZN5physx2Gu19computePlane_BoxMTDERKNS_7PxPlaneERKNS0_3BoxERNS_10PxSweepHitE(i9, i10, i17) | 0;
  STACKTOP = i15;
  return i22 | 0;
 }
 f4 = Math_fround(HEAPF32[i18 >> 2]);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(f4 * f6);
 i2 = i18 + 4 | 0;
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f23 = Math_fround(f4 + Math_fround(f23 * f5));
 i1 = i18 + 8 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i11 >> 2]);
 f4 = Math_fround(f23 + Math_fround(f4 * f3));
 d24 = +f4;
 if (d24 > -1.0e-07 & d24 < 1.0e-07) {
  i22 = 0;
  STACKTOP = i15;
  return i22 | 0;
 }
 f26 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) >> 2]);
 f23 = Math_fround(f6 * f26);
 f25 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f5 * f25));
 f28 = Math_fround(HEAPF32[i14 + (i12 * 12 | 0) + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f3 * f28));
 f23 = Math_fround(Math_fround(-Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f23)) / f4);
 HEAPF32[i17 + 40 >> 2] = f23;
 f27 = Math_fround(HEAPF32[i18 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(Math_fround(f23 * f4) + f25);
 f4 = Math_fround(Math_fround(f23 * Math_fround(HEAPF32[i1 >> 2])) + f28);
 HEAPF32[i17 + 16 >> 2] = Math_fround(Math_fround(f23 * f27) + f26);
 HEAPF32[i17 + 20 >> 2] = f25;
 HEAPF32[i17 + 24 >> 2] = f4;
 if (!(f23 > Math_fround(0.0)) | !(f23 <= f16)) {
  i22 = 0;
  STACKTOP = i15;
  return i22 | 0;
 }
 HEAPF32[i17 + 28 >> 2] = f6;
 HEAPF32[i17 + 32 >> 2] = f5;
 HEAPF32[i17 + 36 >> 2] = f3;
 HEAP16[i17 + 12 >> 1] = 7;
 i22 = 1;
 STACKTOP = i15;
 return i22 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i22, i24, i1) {
 i22 = i22 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25 + 20 | 0;
 i20 = i25;
 switch ((i24 - i22 | 0) / 36 | 0 | 0) {
 case 2:
  {
   i7 = i24 + -36 | 0;
   __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i24 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f26 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i22 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   if (!(f26 > Math_fround(HEAPF32[i21 + 8 >> 2]))) {
    i24 = 1;
    STACKTOP = i25;
    return i24 | 0;
   }
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i22 + 4 >> 2] | 0;
   i3 = HEAP32[i22 + 8 >> 2] | 0;
   i4 = HEAP32[i22 + 12 >> 2] | 0;
   i5 = HEAP32[i22 + 16 >> 2] | 0;
   i6 = HEAP32[i22 + 20 >> 2] | 0;
   i12 = i22 + 24 | 0;
   HEAP32[i23 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i12 = i22;
   i13 = i7;
   i14 = i12 + 36 | 0;
   do {
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    i12 = i12 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i12 | 0) < (i14 | 0));
   HEAP32[i7 >> 2] = i1;
   HEAP32[i24 + -32 >> 2] = i2;
   HEAP32[i24 + -28 >> 2] = i3;
   HEAP32[i24 + -24 >> 2] = i4;
   HEAP32[i24 + -20 >> 2] = i5;
   HEAP32[i24 + -16 >> 2] = i6;
   i24 = i24 + -12 | 0;
   HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i22, i22 + 36 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i22, i22 + 36 | 0, i22 + 72 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i22, i22 + 36 | 0, i22 + 72 | 0, i22 + 108 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 1:
 case 0:
  {
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 default:
  {
   i2 = i22 + 72 | 0;
   __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i22, i22 + 36 | 0, i2, i1) | 0;
   i1 = i22 + 108 | 0;
   L3 : do if ((i1 | 0) == (i24 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i16 = i23 + 8 | 0;
    i17 = i21 + 8 | 0;
    i18 = i23 + 8 | 0;
    i19 = i21 + 8 | 0;
    i15 = i1;
    i1 = 0;
    while (1) {
     __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f26 = Math_fround(HEAPF32[i16 >> 2]);
     __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f26 > Math_fround(HEAPF32[i17 >> 2])) {
      i6 = HEAP32[i15 >> 2] | 0;
      i7 = HEAP32[i15 + 4 >> 2] | 0;
      i8 = HEAP32[i15 + 8 >> 2] | 0;
      i9 = HEAP32[i15 + 12 >> 2] | 0;
      i10 = HEAP32[i15 + 16 >> 2] | 0;
      i11 = HEAP32[i15 + 20 >> 2] | 0;
      i3 = i15 + 24 | 0;
      i4 = HEAP32[i3 + 4 >> 2] | 0;
      i5 = i20;
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      i5 = HEAP32[i15 + 32 >> 2] | 0;
      i4 = i5 + 28 | 0;
      i3 = i15;
      while (1) {
       i12 = i3;
       i13 = i2;
       i14 = i12 + 36 | 0;
       do {
        HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
        i12 = i12 + 4 | 0;
        i13 = i13 + 4 | 0;
       } while ((i12 | 0) < (i14 | 0));
       if ((i2 | 0) == (i22 | 0)) {
        i2 = i22;
        break;
       }
       __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0);
       f26 = Math_fround(HEAPF32[i18 >> 2]);
       __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
       if (f26 > Math_fround(HEAPF32[i19 >> 2])) {
        i3 = i2;
        i2 = i2 + -36 | 0;
       } else break;
      }
      HEAP32[i2 >> 2] = i6;
      HEAP32[i2 + 4 >> 2] = i7;
      HEAP32[i2 + 8 >> 2] = i8;
      HEAP32[i2 + 12 >> 2] = i9;
      HEAP32[i2 + 16 >> 2] = i10;
      HEAP32[i2 + 20 >> 2] = i11;
      i12 = i20;
      i13 = HEAP32[i12 + 4 >> 2] | 0;
      i14 = i2 + 24 | 0;
      HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i14 + 4 >> 2] = i13;
      HEAP32[i2 + 32 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i15 + 36 | 0) == (i24 | 0);
       break L3;
      }
     }
     i2 = i15 + 36 | 0;
     if ((i2 | 0) == (i24 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i14 = i15;
      i15 = i2;
      i2 = i14;
     }
    }
   } while (0);
   i24 = i1 | i2;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 return 0;
}

function __ZN15ParticleEmitter14WriteParticlesEPK14SimpleParticlei(i6, i11, i1) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14;
 i2 = i14 + 4 | 0;
 if ((i1 | 0) > 16250) {
  HEAP32[i3 >> 2] = 16250;
  __Z6FormatPKcz(i2, gb + 1049421 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1049329 | 0, 402, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = 16250;
 }
 i10 = i6 + 72 | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f17 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f16 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i7 = i6 + 84 | 0;
 HEAPF32[i7 >> 2] = f17;
 i8 = i6 + 88 | 0;
 HEAPF32[i8 >> 2] = f16;
 i9 = i6 + 92 | 0;
 HEAPF32[i9 >> 2] = f15;
 i12 = i6 + 56 | 0;
 i13 = i6 + 60 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = (i4 - i3 | 0) / 48 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj(i12, i1 - i2 | 0); else if (i1 >>> 0 < i2 >>> 0) {
  i2 = i3 + (i1 * 48 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i13 >> 2] = i4 + (~(((i4 + -48 - i2 | 0) >>> 0) / 48 | 0) * 48 | 0);
 }
 if ((i1 | 0) > 0) {
  i5 = i6 + 76 | 0;
  i4 = i6 + 80 | 0;
  i2 = 0;
  i3 = 0;
  do {
   i18 = i11 + (i3 * 60 | 0) | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i19 = i6 + (i2 * 48 | 0) | 0;
   HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   f16 = Math_fround(HEAPF32[i10 >> 2]);
   f22 = Math_fround(HEAPF32[i18 >> 2]);
   f15 = Math_fround(HEAPF32[i5 >> 2]);
   f20 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 4 >> 2]);
   f21 = Math_fround(HEAPF32[i4 >> 2]);
   f17 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 8 >> 2]);
   HEAPF32[i10 >> 2] = f22 < f16 ? f22 : f16;
   HEAPF32[i5 >> 2] = f20 < f15 ? f20 : f15;
   HEAPF32[i4 >> 2] = f17 < f21 ? f17 : f21;
   f21 = Math_fround(HEAPF32[i7 >> 2]);
   f15 = Math_fround(HEAPF32[i8 >> 2]);
   f16 = Math_fround(HEAPF32[i9 >> 2]);
   HEAPF32[i7 >> 2] = f21 < f22 ? f22 : f21;
   HEAPF32[i8 >> 2] = f15 < f20 ? f20 : f15;
   HEAPF32[i9 >> 2] = f16 < f17 ? f17 : f16;
   i18 = i6 + (i2 * 48 | 0) + 12 | 0;
   i19 = i11 + (i3 * 60 | 0) + 12 | 0;
   HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i6 + (i2 * 48 | 0) + 24 >> 2] = HEAP32[i11 + (i3 * 60 | 0) + 24 >> 2];
   HEAPF32[i6 + (i2 * 48 | 0) + 28 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 28 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
   HEAPF32[i6 + (i2 * 48 | 0) + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 32 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
   i18 = HEAP32[i11 + (i3 * 60 | 0) + 36 >> 2] | 0;
   HEAP32[i6 + (i2 * 48 | 0) + 36 >> 2] = i18;
   f16 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 40 >> 2]);
   f17 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAPF32[i6 + (i2 * 48 | 0) + 40 >> 2] = f16 < f17 ? f17 : f16;
   f16 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 44 >> 2]);
   i18 = f16 < Math_fround(0.0);
   f16 = i18 ? Math_fround(0.0) : f16;
   i18 = f16 > Math_fround(1.0);
   HEAP8[i6 + (i2 * 48 | 0) + 44 >> 0] = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f16 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 48 >> 2]);
   i18 = f16 < Math_fround(0.0);
   f16 = i18 ? Math_fround(0.0) : f16;
   i18 = f16 > Math_fround(1.0);
   HEAP8[i6 + (i2 * 48 | 0) + 45 >> 0] = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f16 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 52 >> 2]);
   i18 = f16 < Math_fround(0.0);
   f16 = i18 ? Math_fround(0.0) : f16;
   i18 = f16 > Math_fround(1.0);
   HEAP8[i6 + (i2 * 48 | 0) + 46 >> 0] = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f16 = Math_fround(HEAPF32[i11 + (i3 * 60 | 0) + 56 >> 2]);
   i18 = f16 < Math_fround(0.0);
   f16 = i18 ? Math_fround(0.0) : f16;
   i18 = f16 > Math_fround(1.0);
   HEAP8[i6 + (i2 * 48 | 0) + 47 >> 0] = ~~Math_fround(Math_fround((i18 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   i2 = (f17 > Math_fround(0.0) & 1) + i2 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  i1 = i2;
 } else i1 = 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = (i4 - i2 | 0) / 48 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj(i12, i1 - i3 | 0);
  STACKTOP = i14;
  return;
 }
 if (i1 >>> 0 >= i3 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i1 = i2 + (i1 * 48 | 0) | 0;
 if ((i4 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i13 >> 2] = i4 + (~(((i4 + -48 - i1 | 0) >>> 0) / 48 | 0) * 48 | 0);
 STACKTOP = i14;
 return;
}

function __ZN17PersistentManager29GetAllFileIDsAndTypesFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EERS9_IPKN5Unity4TypeELj4EE(i2, i1, i19, i20) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i23 + 8 | 0;
 i4 = i23;
 i21 = i23 + 16 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i23;
  return;
 }
 i15 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i1) | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i23;
  return;
 }
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i16 = i4;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i21 >> 2] = 0;
 i16 = i21 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i2 = i3;
 i14 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i18;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 __ZNK14SerializedFile13GetAllFileIDsER13dynamic_arrayIxLj8EE(HEAP32[i15 >> 2] | 0, i21);
 i1 = HEAP32[i16 >> 2] | 0;
 i14 = i19 + 16 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i14 >> 2] = i1;
  HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1 << 3, 8, i19 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i19 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i19 + 12 >> 2] << 3 | 0) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i19 >> 2] = i13;
  break;
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 i13 = i20 + 16 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i20 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i20 >> 2] = i12;
  }
  i1 = HEAP32[i16 >> 2] | 0;
 }
 if (i1 | 0) {
  i2 = HEAP32[i21 >> 2] | 0;
  i8 = i15 + 16 | 0;
  i9 = i19 + 12 | 0;
  i10 = i19 + 4 | 0;
  i11 = i20 + 12 | 0;
  i12 = i20 + 4 | 0;
  i7 = i2;
  do {
   i6 = i7;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   L24 : do if (!i4) i22 = 22; else {
    i3 = HEAP32[i4 >> 2] | 0;
    i24 = HEAP32[i4 + 12 >> 2] | 0;
    i4 = i3 + (i24 << 3) | 0;
    L26 : do if (i24) while (1) {
     i24 = i3;
     if ((HEAP32[i24 >> 2] | 0) == (i5 | 0) ? (HEAP32[i24 + 4 >> 2] | 0) == (i6 | 0) : 0) break L26;
     i3 = i3 + 8 | 0;
     if ((i3 | 0) == (i4 | 0)) {
      i22 = 22;
      break L24;
     }
    } while (0);
    if ((i3 | 0) == (i4 | 0)) i22 = 22;
   } while (0);
   if ((i22 | 0) == 22) {
    i22 = 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1 << 3, 8, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i24 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i19 >> 2] = i24;
      break;
     }
    } while (0);
    HEAP32[i9 >> 2] = i3;
    i4 = i7;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    i2 = (HEAP32[i19 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i2 + 4 >> 2] = i3;
    i2 = i7;
    i2 = __ZNK14SerializedFile7GetTypeEx(HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i13 >> 2] = i1;
      HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i24 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i13 >> 2] = i1;
      HEAP32[i20 >> 2] = i24;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[(HEAP32[i20 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i16 >> 2] | 0;
   }
   i7 = i7 + 8 | 0;
  } while ((i7 | 0) != (i2 + (i1 << 3) | 0));
 }
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i18);
  HEAP32[i21 >> 2] = 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S6_EEEEEEEEvRT_17TransferMetaFlags(i30, i26, i1) {
 i30 = i30 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 44 | 0;
 i23 = i29 + 40 | 0;
 i28 = i29 + 20 | 0;
 i24 = i29;
 i25 = i26 + 8 | 0;
 HEAP32[i23 >> 2] = HEAP32[i25 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i30, gb + 1041885 | 0, gb + 1041885 | 0, i23) | 0)) {
  STACKTOP = i29;
  return;
 };
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 HEAP32[i28 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = 0;
 i11 = i28 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i26 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i26, HEAP32[i12 >> 2] | 0);
 HEAP32[i25 >> 2] = 0;
 HEAP32[i26 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i13 = HEAP32[gb + 37152 >> 2] | 0;
  i1 = i28 + 11 | 0;
  i14 = i28 + 4 | 0;
  i15 = i24 + 12 | 0;
  i10 = i24 + 12 | 0;
  i16 = i27 + 4 | 0;
  i17 = i24 + 8 | 0;
  i18 = i24 + 4 | 0;
  i19 = i24 + 16 | 0;
  i20 = i26 + 4 | 0;
  i21 = i24 + 11 | 0;
  i22 = i27 + 4 | 0;
  i9 = 0;
  do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i30, gb + 1041891 | 0, i13, i27, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i28, i30); else {
     i2 = HEAP32[i27 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i28 | 0, i30 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i30);
   }
   i4 = HEAP8[i1 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i28 >> 2] | 0 : i28;
   i4 = i2 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i24 + 4 >> 2] = 0;
   HEAP32[i24 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i15 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i24);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = 17;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i21 >> 0] = i4;
    if (!i4) i2 = i24; else {
     i2 = i24;
     i5 = 19;
    }
   } else i5 = 17;
   if ((i5 | 0) == 17) {
    i8 = i4 + 16 & -16;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i16 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i27, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i24 >> 2] = i2;
    HEAP32[i17 >> 2] = i8 | -2147483648;
    HEAP32[i18 >> 2] = i4;
    i5 = 19;
   }
   if ((i5 | 0) == 19) {
    i5 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
   i2 = HEAP32[i12 >> 2] | 0;
   do if (!i2) {
    i3 = i12;
    i4 = i12;
   } else {
    i7 = HEAP8[i21 >> 0] | 0;
    i8 = i7 << 24 >> 24 < 0;
    i7 = i8 ? HEAP32[i18 >> 2] | 0 : i7 & 255;
    i8 = i8 ? HEAP32[i24 >> 2] | 0 : i24;
    while (1) {
     i4 = i2 + 16 | 0;
     i6 = HEAP8[i4 + 11 >> 0] | 0;
     i5 = i6 << 24 >> 24 < 0;
     i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
     i3 = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
     if (!i3) i5 = 24; else {
      i3 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
      if (!i3) i5 = 24; else if ((i3 | 0) < 0) i5 = 26; else i5 = 28;
     }
     if ((i5 | 0) == 24) if (i7 >>> 0 < i6 >>> 0) i5 = 26; else i5 = 28;
     if ((i5 | 0) == 26) {
      i3 = HEAP32[i2 >> 2] | 0;
      if (!i3) {
       i5 = 27;
       break;
      } else i2 = i3;
     } else if ((i5 | 0) == 28) {
      i4 = i2 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i5 = 30;
       break;
      } else i2 = i3;
     }
    }
    if ((i5 | 0) == 27) {
     i5 = 0;
     i3 = i2;
     i4 = i2;
     break;
    } else if ((i5 | 0) == 30) {
     i5 = 0;
     i3 = i2;
     break;
    }
   } while (0);
   __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i27, i26, i24);
   i2 = HEAP32[i27 >> 2] | 0;
   HEAP32[i27 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i26 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i20 >> 2] | 0, i2);
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 1;
   if ((HEAP8[i21 >> 0] | 0) < 0) {
    i8 = HEAP32[i24 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i27 >> 2] = 66;
    HEAP32[i22 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i27);
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (HEAP32[i23 >> 2] | 0));
 } else i1 = i28 + 11 | 0;
 __ZN14SafeBinaryRead16EndArrayTransferEv(i30);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i30 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 12 >> 2] | 0;
  HEAP32[i27 >> 2] = 66;
  HEAP32[i27 + 4 >> 2] = i28;
  __Z19free_alloc_internalPvRK10MemLabelId(i30, i27);
 }
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration18addContactsToPatchERKNS_6shdfnd3aos5Vec3VEjj(i26, i1, i25, i3) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 16 | 0;
 i23 = i27;
 i21 = i27 + 32 | 0;
 f28 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i19 = i26 + 2256 | 0;
 f10 = Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2]));
 i20 = i26 + 2260 | 0;
 f10 = Math_fround(f10 + Math_fround(f2 * Math_fround(HEAPF32[i20 >> 2])));
 i9 = i26 + 2264 | 0;
 f10 = Math_fround(f10 + Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2])));
 i11 = i26 + 2272 | 0;
 f14 = Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2]));
 i12 = i26 + 2276 | 0;
 f14 = Math_fround(f14 + Math_fround(f2 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i26 + 2280 | 0;
 f14 = Math_fround(f14 + Math_fround(f18 * Math_fround(HEAPF32[i13 >> 2])));
 i15 = i26 + 2288 | 0;
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2]));
 i16 = i26 + 2292 | 0;
 f2 = Math_fround(f28 + Math_fround(f2 * Math_fround(HEAPF32[i16 >> 2])));
 i17 = i26 + 2296 | 0;
 f18 = Math_fround(f2 + Math_fround(f18 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i24 >> 2] = f10;
 HEAPF32[i24 + 4 >> 2] = f14;
 HEAPF32[i24 + 8 >> 2] = f18;
 HEAPF32[i24 + 12 >> 2] = Math_fround(0.0);
 if (i3 >>> 0 > 4) {
  i1 = (__ZN5physx2Gu31SinglePersistentContactManifold14reduceContactsEPNS0_21MeshPersistentContactEj((HEAP32[i26 + 2320 >> 2] | 0) + (i25 << 6) | 0, i3) | 0) + i25 | 0;
  i22 = i26 + 2324 | 0;
  HEAP32[i22 >> 2] = i1;
 } else {
  i1 = i26 + 2324 | 0;
  i22 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAPF32[i23 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (i1 >>> 0 > i25 >>> 0) {
  i3 = i26 + 2320 | 0;
  i4 = i26 + 2304 | 0;
  i5 = i26 + 2308 | 0;
  i6 = i26 + 2312 | 0;
  i7 = i23 + 4 | 0;
  f2 = Math_fround(3402823469999999843913219.0e14);
  i8 = i25;
  do {
   i1 = HEAP32[i3 >> 2] | 0;
   f28 = Math_fround(HEAPF32[i1 + (i8 << 6) + 44 >> 2]);
   HEAPF32[i1 + (i8 << 6) + 32 >> 2] = f10;
   HEAPF32[i1 + (i8 << 6) + 36 >> 2] = f14;
   HEAPF32[i1 + (i8 << 6) + 40 >> 2] = f18;
   i1 = HEAP32[i3 >> 2] | 0;
   i33 = i1 + (i8 << 6) + 16 | 0;
   f32 = Math_fround(HEAPF32[i33 >> 2]);
   i31 = i1 + (i8 << 6) + 20 | 0;
   f34 = Math_fround(HEAPF32[i31 >> 2]);
   i29 = i1 + (i8 << 6) + 24 | 0;
   f30 = Math_fround(HEAPF32[i29 >> 2]);
   f36 = Math_fround(HEAPF32[i4 >> 2]);
   f35 = Math_fround(HEAPF32[i5 >> 2]);
   f36 = Math_fround(f32 - f36);
   f35 = Math_fround(f34 - f35);
   f30 = Math_fround(f30 - Math_fround(HEAPF32[i6 >> 2]));
   f34 = Math_fround(f36 * Math_fround(HEAPF32[i19 >> 2]));
   f34 = Math_fround(f34 + Math_fround(f35 * Math_fround(HEAPF32[i20 >> 2])));
   f34 = Math_fround(f34 + Math_fround(f30 * Math_fround(HEAPF32[i9 >> 2])));
   f32 = Math_fround(f36 * Math_fround(HEAPF32[i11 >> 2]));
   f32 = Math_fround(f32 + Math_fround(f35 * Math_fround(HEAPF32[i12 >> 2])));
   f32 = Math_fround(f32 + Math_fround(f30 * Math_fround(HEAPF32[i13 >> 2])));
   f36 = Math_fround(f36 * Math_fround(HEAPF32[i15 >> 2]));
   f35 = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i16 >> 2])));
   f30 = Math_fround(f35 + Math_fround(f30 * Math_fround(HEAPF32[i17 >> 2])));
   HEAPF32[i33 >> 2] = f34;
   HEAPF32[i31 >> 2] = f32;
   HEAPF32[i29 >> 2] = f30;
   HEAPF32[i1 + (i8 << 6) + 28 >> 2] = Math_fround(0.0);
   f2 = f2 > f28 ? f28 : f2;
   HEAP32[i7 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i22 >> 2] | 0;
  } while (i8 >>> 0 < i1 >>> 0);
  HEAPF32[i23 >> 2] = f2;
 }
 if (i1 >>> 0 > i25 >>> 0) {
  i8 = i26 + 2320 | 0;
  i9 = i26 + 2240 | 0;
  i7 = i25;
  do {
   i6 = i7;
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 < i1 >>> 0) {
    i3 = i7;
    do {
     i4 = HEAP32[i8 >> 2] | 0;
     f30 = Math_fround(HEAPF32[i4 + (i3 << 6) + 16 >> 2]);
     f32 = Math_fround(HEAPF32[i4 + (i3 << 6) + 20 >> 2]);
     f36 = Math_fround(HEAPF32[i4 + (i3 << 6) + 24 >> 2]);
     f34 = Math_fround(HEAPF32[i4 + (i6 << 6) + 16 >> 2]);
     f35 = Math_fround(HEAPF32[i4 + (i6 << 6) + 20 >> 2]);
     f34 = Math_fround(f30 - f34);
     f35 = Math_fround(f32 - f35);
     f36 = Math_fround(f36 - Math_fround(HEAPF32[i4 + (i6 << 6) + 24 >> 2]));
     f36 = Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f35 * f35)) + Math_fround(f36 * f36));
     if (Math_fround(HEAPF32[i9 >> 2]) > f36) {
      i5 = i4 + (i3 << 6) | 0;
      i1 = i4 + (i1 + -1 << 6) | 0;
      i4 = i5 + 52 | 0;
      do {
       HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
       i5 = i5 + 4 | 0;
       i1 = i1 + 4 | 0;
      } while ((i5 | 0) < (i4 | 0));
      i1 = (HEAP32[i22 >> 2] | 0) + -1 | 0;
      HEAP32[i22 >> 2] = i1;
      i3 = i3 + -1 | 0;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
  } while (i7 >>> 0 < i1 >>> 0);
 }
 __ZN5physx2Gu24PCMMeshContactGeneration23addManifoldPointToPatchERKNS_6shdfnd3aos5Vec3VERKNS3_6FloatVEj(i26, i24, i23, i25);
 if ((HEAP32[i22 >> 2] | 0) >>> 0 <= 15) {
  STACKTOP = i27;
  return;
 }
 __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb(i26, 6, 1);
 STACKTOP = i27;
 return;
}

function __ZN9Animation14CloneAnimationEP14AnimationState(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 40 | 0;
 i15 = i17 + 32 | 0;
 i9 = i17 + 16 | 0;
 i10 = i17;
 __ZN9Animation20BuildAnimationStatesEv(i14);
 i1 = HEAP32[i14 + 104 >> 2] | 0;
 i16 = i14 + 108 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i13 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i11 = 38;
   break;
  }
 }
 if ((i11 | 0) == 38) {
  STACKTOP = i17;
  return i1 | 0;
 }
 if (!i13) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((HEAP16[gb + 1465176 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = i14;
  HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465176 | 0, i8);
  i12 = gb + 1465176 | 0;
 } else i12 = 0;
 i4 = __Znwj(160) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAPF32[i4 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 92 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = i4;
 i7 = i4 + 112 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 128 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 148 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i4 + 152 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = i7;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i7 = i4 + 56 | 0;
 HEAP16[i7 >> 1] = HEAP16[i7 >> 1] & -257;
 HEAP32[i15 >> 2] = i4;
 i7 = i13 + 112 | 0;
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i10, i7, gb + 896666 | 0);
 i5 = i10 + 11 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i11 = 10;
 } else if (i6 >>> 0 < 11) {
  i1 = i9 + 11 | 0;
  HEAP8[i1 >> 0] = i6;
  if (!i6) i2 = i9; else {
   i2 = i9;
   i11 = 12;
  }
 } else i11 = 10;
 if ((i11 | 0) == 10) {
  i18 = i6 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i18 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i6;
  i1 = i9 + 11 | 0;
  i11 = 12;
 }
 if ((i11 | 0) == 12) _memcpy(i2 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i2 + i6 >> 0] = 0;
 i18 = HEAP32[i13 + 96 >> 2] | 0;
 d19 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib(i4, i9, i18, d19, HEAP32[i13 + 68 >> 2] | 0, 1);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i18 = HEAP32[i9 >> 2] | 0;
  i11 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i8);
 }
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i18 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i8);
 }
 i6 = HEAP32[i15 >> 2] | 0;
 i1 = i6 + 128 | 0;
 do if ((i1 | 0) != (i7 | 0)) {
  i8 = HEAP8[i7 + 11 >> 0] | 0;
  i5 = i8 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i7 >> 2] | 0 : i7;
  i8 = i5 ? HEAP32[i13 + 116 >> 2] | 0 : i8 & 255;
  i5 = i1 + 11 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i6 + 136 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i8 >>> 0 > i4 >>> 0) {
   if (i3) i2 = HEAP32[i6 + 132 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i8 - i4 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i6 + 132 >> 2] = i8;
   break;
  } else {
   HEAP8[i5 >> 0] = i8;
   break;
  }
 } while (0);
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i13 + 32 >> 2];
 i1 = i2 + 56 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -17;
 HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i2 + 64 >> 2] = 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i14 + 112 >> 2] | 0)) __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i14 + 104 | 0, i15); else {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 4;
 }
 i1 = i14 + 252 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 2;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i12) {
  i18 = i1;
  STACKTOP = i17;
  return i18 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 i18 = i1;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZN14MessageHandler28InitializeMessageIdentifiersEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 24 | 0;
 i13 = i16 + 12 | 0;
 i14 = i16;
 i15 = __ZN17MessageIdentifier21GetRegisteredMessagesEv() | 0;
 __ZN17MessageIdentifier17GetSortedMessagesEb(i13, 0);
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i8 + 56 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~(((i2 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
 i10 = i8 + 64 | 0;
 i1 = i8 + 68 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i10, HEAP32[i1 >> 2] | 0);
 i11 = i8 + 72 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i13 + 8 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = (i4 - i3 | 0) / 20 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZNSt3__26vectorI17MessageIdentifierNS_9allocatorIS1_EEE8__appendEj(i7, i1 - i2 | 0); else if (i1 >>> 0 < i2 >>> 0) {
  i1 = i3 + (i1 * 20 | 0) | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i4 + (~(((i4 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 i9 = i13 + 4 | 0;
 if ((i1 | 0) != (i9 | 0)) {
  i6 = i8 + 68 | 0;
  i5 = 0;
  i2 = i1;
  while (1) {
   i3 = i2 + 16 | 0;
   i4 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i10, i12, i3) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    i1 = __Znwj(32) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i3);
    HEAP32[i1 + 28 >> 2] = 0;
    i3 = HEAP32[i12 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    if (!i3) i3 = i1; else {
     HEAP32[i10 >> 2] = i3;
     i3 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i3);
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   }
   HEAP32[i1 + 28 >> 2] = i5;
   i1 = (HEAP32[i7 >> 2] | 0) + (i5 * 20 | 0) | 0;
   i4 = i2 + 28 | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 * 20 | 0) + 8 >> 2] = i5;
   i5 = i5 + 1 | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i15 | 0)) {
  i15 = HEAP32[i9 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i13, i15);
  STACKTOP = i16;
  return;
 }
 i6 = i8 + 68 | 0;
 i5 = i2;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i8, _strlen(i8) | 0);
  i8 = (__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE14__count_uniqueIS7_EEjRKT_(i10, i12) | 0) == 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  if (!i8) {
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, i3, _strlen(i3) | 0);
   i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i10, i12, i14) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = __Znwj(32) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i14);
    HEAP32[i1 + 28 >> 2] = 0;
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i10 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i2);
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   }
   HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 28 >> 2];
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i5 = i1;
 } while ((i5 | 0) != (i15 | 0));
 i15 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i13, i15);
 STACKTOP = i16;
 return;
}

function __Z11CopyTextureP7TextureiiS0_ii(i10, i11, i12, i13, i14, i15) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19 + 36 | 0;
 i8 = i19 + 32 | 0;
 i18 = i19 + 16 | 0;
 i5 = i19;
 i16 = i19 + 28 | 0;
 i17 = i19 + 24 | 0;
 if (!(__ZL28CheckCopyTextureMipArgumentsP7TextureiiS0_ii(i10, i11, i12, i13, i14, i15) | 0)) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i4 = (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 100 >> 2] | 0, i10 | 0) | 0) >> i12;
 i4 = (i4 | 0) < 1 ? 1 : i4;
 i3 = (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0) | 0) >> i12;
 i3 = (i3 | 0) < 1 ? 1 : i3;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0, i13 | 0) | 0) >> i15;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i1 = (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 104 >> 2] | 0, i13 | 0) | 0) >> i15;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if (!((i4 | 0) == (i2 | 0) & (i3 | 0) == (i1 | 0))) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i5 + 8 >> 2] = i2;
  HEAP32[i5 + 12 >> 2] = i1;
  __Z6FormatPKcz(i9, gb + 398698 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 398117 | 0, 290, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i3 = i10 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (((i1 >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
  __ZN9Texture2D18UnshareTextureDataEv(i10);
  i1 = HEAP32[i10 + 52 >> 2] | 0;
  if (!i1) i2 = 0; else {
   i2 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i11) | 0;
   i2 = (HEAP32[i1 + 8 >> 2] | 0) + i2 | 0;
  }
  i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 184 >> 2] | 0, i10 | 0) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i5 = -1;
  i2 = 0;
 }
 i3 = i1 >>> 21;
 i6 = HEAP32[gb + 32072 + 24 >> 2] | 0;
 i4 = HEAP32[gb + 32072 + 28 >> 2] | 0;
 if ((i3 - i6 | 0) >>> 0 < i4 >>> 0) {
  i2 = (HEAP32[i10 + 96 >> 2] | 0) + (Math_imul(HEAP32[i10 + 104 >> 2] | 0, i11) | 0) | 0;
  i1 = HEAP32[i10 + 92 >> 2] | 0;
 } else i1 = i5;
 if ((i3 - (HEAP32[gb + 32112 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32112 + 28 >> 2] | 0) >>> 0) {
  i7 = HEAP32[i10 + 92 >> 2] | 0;
  i2 = HEAP32[i10 + 96 >> 2] | 0;
 } else i7 = i1;
 i5 = i13 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (((i3 >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
  __ZN9Texture2D18UnshareTextureDataEv(i13);
  i1 = HEAP32[i13 + 52 >> 2] | 0;
  if (!i1) i3 = 0; else {
   i3 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i14) | 0;
   i3 = (HEAP32[i1 + 8 >> 2] | 0) + i3 | 0;
  }
  i1 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 184 >> 2] | 0, i13 | 0) | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[gb + 32072 + 24 >> 2] | 0;
  i4 = HEAP32[gb + 32072 + 28 >> 2] | 0;
 } else {
  i1 = -1;
  i5 = i3;
  i3 = 0;
 }
 i5 = i5 >>> 21;
 if ((i5 - i6 | 0) >>> 0 < i4 >>> 0) {
  i3 = (HEAP32[i13 + 96 >> 2] | 0) + (Math_imul(HEAP32[i13 + 104 >> 2] | 0, i14) | 0) | 0;
  i1 = HEAP32[i13 + 92 >> 2] | 0;
 }
 if ((i5 - (HEAP32[gb + 32112 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32112 + 28 >> 2] | 0) >>> 0) {
  i1 = HEAP32[i13 + 92 >> 2] | 0;
  i3 = HEAP32[i13 + 96 >> 2] | 0;
 }
 do if ((i2 | 0) != 0 & (i3 | 0) != 0) {
  i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  i5 = __Z21CalculateMipMapOffsetii13TextureFormati(i5, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0) | 0, i7, i12) | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 136 >> 2] | 0, i13 | 0) | 0;
  i6 = __Z21CalculateMipMapOffsetii13TextureFormati(i6, mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 140 >> 2] | 0, i13 | 0) | 0, i1, i15) | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  i4 = __Z26CalculateImageMipLevelSizeii13TextureFormatj(i4, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0) | 0, i7, i12) | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 136 >> 2] | 0, i13 | 0) | 0;
  i1 = __Z26CalculateImageMipLevelSizeii13TextureFormatj(i7, mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 140 >> 2] | 0, i13 | 0) | 0, i1, i15) | 0;
  if ((i4 | 0) == (i1 | 0)) {
   _memcpy(i3 + i6 | 0, i2 + i5 | 0, i4 | 0) | 0;
   break;
  }
  HEAP32[i18 >> 2] = i4;
  HEAP32[i18 + 4 >> 2] = i1;
  __Z6FormatPKcz(i9, gb + 398771 | 0, i18);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 398117 | 0, 179, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 } while (0);
 i7 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 116 >> 2] | 0, i10 | 0) | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 116 >> 2] | 0, i13 | 0) | 0;
 i5 = HEAP32[i10 + 48 >> 2] | 0;
 i6 = HEAP32[i13 + 48 >> 2] | 0;
 i13 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i13 >> 2] | 0) + 472 >> 2] | 0;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i17 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i17 >> 2];
 mftCall_viiiiiiiii(i10 | 0, i13 | 0, i8 | 0, i11 | 0, i12 | 0, i7 | 0, i9 | 0, i14 | 0, i15 | 0, i18 | 0);
 i18 = 1;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN9b2Fixture4DumpEi(i1, i23) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, d35 = 0.0, d36 = 0.0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 360 | 0;
 i24 = i28 + 352 | 0;
 i27 = i28 + 344 | 0;
 i26 = i28 + 336 | 0;
 i15 = i28 + 312 | 0;
 i21 = i28 + 304 | 0;
 i20 = i28 + 296 | 0;
 i19 = i28 + 280 | 0;
 i18 = i28 + 264 | 0;
 i17 = i28 + 256 | 0;
 i13 = i28 + 248 | 0;
 i12 = i28 + 240 | 0;
 i14 = i28 + 216 | 0;
 i16 = i28 + 208 | 0;
 i11 = i28 + 200 | 0;
 i10 = i28 + 184 | 0;
 i9 = i28 + 176 | 0;
 i8 = i28 + 160 | 0;
 i7 = i28 + 144 | 0;
 i6 = i28 + 128 | 0;
 i5 = i28 + 112 | 0;
 i4 = i28 + 104 | 0;
 i3 = i28 + 80 | 0;
 i2 = i28 + 72 | 0;
 i22 = i28 + 56 | 0;
 i29 = i28 + 48 | 0;
 i30 = i28 + 40 | 0;
 i31 = i28 + 32 | 0;
 i32 = i28 + 24 | 0;
 i33 = i28 + 16 | 0;
 i34 = i28 + 8 | 0;
 __Z5b2LogPKcz(gb + 803853 | 0, i28);
 HEAPF64[i34 >> 3] = +Math_fround(HEAPF32[i1 + 36 >> 2]);
 __Z5b2LogPKcz(gb + 803875 | 0, i34);
 HEAPF64[i33 >> 3] = +Math_fround(HEAPF32[i1 + 40 >> 2]);
 __Z5b2LogPKcz(gb + 803903 | 0, i33);
 HEAPF64[i32 >> 3] = +Math_fround(HEAPF32[i1 + 20 >> 2]);
 __Z5b2LogPKcz(gb + 803934 | 0, i32);
 HEAP32[i31 >> 2] = HEAPU8[i1 + 58 >> 0];
 __Z5b2LogPKcz(gb + 803961 | 0, i31);
 HEAP32[i30 >> 2] = HEAPU16[i1 + 52 >> 1];
 __Z5b2LogPKcz(gb + 803990 | 0, i30);
 HEAP32[i29 >> 2] = HEAPU16[i1 + 54 >> 1];
 __Z5b2LogPKcz(gb + 804032 | 0, i29);
 HEAP32[i22 >> 2] = HEAP16[i1 + 56 >> 1];
 __Z5b2LogPKcz(gb + 804070 | 0, i22);
 i22 = HEAP32[i1 + 32 >> 2] | 0;
 switch (HEAP32[i22 + 4 >> 2] | 0) {
 case 0:
  {
   __Z5b2LogPKcz(gb + 804109 | 0, i28 + 64 | 0);
   HEAPF64[i2 >> 3] = +Math_fround(HEAPF32[i22 + 8 >> 2]);
   __Z5b2LogPKcz(gb + 804135 | 0, i2);
   d36 = +Math_fround(HEAPF32[i22 + 12 >> 2]);
   d35 = +Math_fround(HEAPF32[i22 + 16 >> 2]);
   HEAPF64[i3 >> 3] = d36;
   HEAPF64[i3 + 8 >> 3] = d35;
   __Z5b2LogPKcz(gb + 804166 | 0, i3);
   break;
  }
 case 1:
  {
   __Z5b2LogPKcz(gb + 804204 | 0, i28 + 96 | 0);
   HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i22 + 8 >> 2]);
   __Z5b2LogPKcz(gb + 804135 | 0, i4);
   i34 = i22 + 28 | 0;
   d36 = +Math_fround(HEAPF32[i34 >> 2]);
   d35 = +Math_fround(HEAPF32[i34 + 4 >> 2]);
   HEAPF64[i5 >> 3] = d36;
   HEAPF64[i5 + 8 >> 3] = d35;
   __Z5b2LogPKcz(gb + 804228 | 0, i5);
   d35 = +Math_fround(HEAPF32[i22 + 12 >> 2]);
   d36 = +Math_fround(HEAPF32[i22 + 16 >> 2]);
   HEAPF64[i6 >> 3] = d35;
   HEAPF64[i6 + 8 >> 3] = d36;
   __Z5b2LogPKcz(gb + 804272 | 0, i6);
   i34 = i22 + 20 | 0;
   d36 = +Math_fround(HEAPF32[i34 >> 2]);
   d35 = +Math_fround(HEAPF32[i34 + 4 >> 2]);
   HEAPF64[i7 >> 3] = d36;
   HEAPF64[i7 + 8 >> 3] = d35;
   __Z5b2LogPKcz(gb + 804316 | 0, i7);
   d35 = +Math_fround(HEAPF32[i22 + 36 >> 2]);
   d36 = +Math_fround(HEAPF32[i22 + 40 >> 2]);
   HEAPF64[i8 >> 3] = d35;
   HEAPF64[i8 + 8 >> 3] = d36;
   __Z5b2LogPKcz(gb + 804360 | 0, i8);
   HEAP32[i9 >> 2] = HEAPU8[i22 + 44 >> 0];
   __Z5b2LogPKcz(gb + 804404 | 0, i9);
   HEAP32[i10 >> 2] = HEAPU8[i22 + 45 >> 0];
   __Z5b2LogPKcz(gb + 804440 | 0, i10);
   break;
  }
 case 2:
  {
   __Z5b2LogPKcz(gb + 804476 | 0, i28 + 192 | 0);
   HEAP32[i11 >> 2] = 8;
   __Z5b2LogPKcz(gb + 804503 | 0, i11);
   i4 = i22 + 148 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) > 0) {
    i3 = i22 + 20 | 0;
    i2 = 0;
    do {
     d35 = +Math_fround(HEAPF32[i3 + (i2 << 3) >> 2]);
     d36 = +Math_fround(HEAPF32[i3 + (i2 << 3) + 4 >> 2]);
     HEAP32[i14 >> 2] = i2;
     HEAPF64[i14 + 8 >> 3] = d35;
     HEAPF64[i14 + 16 >> 3] = d36;
     __Z5b2LogPKcz(gb + 804547 | 0, i14);
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    } while ((i2 | 0) < (i1 | 0));
   }
   HEAP32[i16 >> 2] = i1;
   __Z5b2LogPKcz(gb + 804523 | 0, i16);
   break;
  }
 case 3:
  {
   __Z5b2LogPKcz(gb + 804582 | 0, i12);
   i4 = i22 + 16 | 0;
   HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
   __Z5b2LogPKcz(gb + 804503 | 0, i13);
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) > 0) {
    i3 = i22 + 12 | 0;
    i2 = 0;
    do {
     i1 = HEAP32[i3 >> 2] | 0;
     d35 = +Math_fround(HEAPF32[i1 + (i2 << 3) >> 2]);
     d36 = +Math_fround(HEAPF32[i1 + (i2 << 3) + 4 >> 2]);
     HEAP32[i15 >> 2] = i2;
     HEAPF64[i15 + 8 >> 3] = d35;
     HEAPF64[i15 + 16 >> 3] = d36;
     __Z5b2LogPKcz(gb + 804547 | 0, i15);
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    } while ((i2 | 0) < (i1 | 0));
   }
   HEAP32[i17 >> 2] = i1;
   __Z5b2LogPKcz(gb + 804607 | 0, i17);
   i34 = i22 + 20 | 0;
   d36 = +Math_fround(HEAPF32[i34 >> 2]);
   d35 = +Math_fround(HEAPF32[i34 + 4 >> 2]);
   HEAPF64[i18 >> 3] = d36;
   HEAPF64[i18 + 8 >> 3] = d35;
   __Z5b2LogPKcz(gb + 804639 | 0, i18);
   i34 = i22 + 28 | 0;
   d35 = +Math_fround(HEAPF32[i34 >> 2]);
   d36 = +Math_fround(HEAPF32[i34 + 4 >> 2]);
   HEAPF64[i19 >> 3] = d35;
   HEAPF64[i19 + 8 >> 3] = d36;
   __Z5b2LogPKcz(gb + 804686 | 0, i19);
   HEAP32[i20 >> 2] = HEAPU8[i22 + 36 >> 0];
   __Z5b2LogPKcz(gb + 804733 | 0, i20);
   HEAP32[i21 >> 2] = HEAPU8[i22 + 37 >> 0];
   __Z5b2LogPKcz(gb + 804772 | 0, i21);
   break;
  }
 default:
  {
   STACKTOP = i28;
   return;
  }
 }
 __Z5b2LogPKcz(gb + 1074320 | 0, i26);
 __Z5b2LogPKcz(gb + 804811 | 0, i27);
 __Z5b2LogPKcz(gb + 1074320 | 0, i24);
 HEAP32[i25 >> 2] = i23;
 __Z5b2LogPKcz(gb + 804835 | 0, i25);
 STACKTOP = i28;
 return;
}

function __Z25CollectNeighbourObstaclesR12dtCrowdAgentRK17ReadonlyCrowdInfo(i34, i1) {
 i34 = i34 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i38;
 i29 = i38 + 584 | 0;
 i30 = i38 + 600 | 0;
 i36 = i38 + 72 | 0;
 i37 = i38 + 8 | 0;
 f32 = Math_fround(HEAPF32[i34 + 480 >> 2]);
 f22 = Math_fround(HEAPF32[i34 + 484 >> 2]);
 f23 = Math_fround(HEAPF32[i34 + 488 >> 2]);
 f24 = Math_fround(HEAPF32[i34 + 292 >> 2]);
 i25 = HEAP8[i34 + 316 >> 0] | 0;
 f26 = Math_fround(f22 + Math_fround(HEAPF32[i34 + 296 >> 2]));
 i27 = i34 + 304 | 0;
 f2 = Math_fround(HEAPF32[i27 >> 2]);
 i28 = i1 + 40 | 0;
 f2 = Math_fround(f24 + Math_fround(f2 * Math_fround(HEAPF32[i28 >> 2])));
 HEAPF32[i29 >> 2] = Math_fround(f32 - f2);
 HEAPF32[i29 + 4 >> 2] = Math_fround(f23 - f2);
 HEAPF32[i29 + 8 >> 2] = Math_fround(f32 + f2);
 HEAPF32[i29 + 12 >> 2] = Math_fround(f23 + f2);
 i29 = __ZNK15dtProximityGrid10queryItemsEPKfPti(HEAP32[i1 + 8 >> 2] | 0, i29, i30, 64) | 0;
 f2 = Math_fround(HEAPF32[i34 + 504 >> 2]);
 f4 = Math_fround(f2 * f2);
 f3 = Math_fround(HEAPF32[i34 + 508 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i34 + 512 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f4 * f4))));
 i31 = f3 > Math_fround(.00999999977);
 if (i31) {
  f16 = Math_fround(Math_fround(1.0) / f3);
  f21 = Math_fround(f2 * f16);
  f16 = Math_fround(f4 * f16);
 } else {
  f21 = Math_fround(0.0);
  f16 = Math_fround(0.0);
 }
 if ((i29 | 0) <= 0) {
  i30 = 0;
  i33 = (i30 | 0) < 8;
  i33 = i33 ? i30 : 8;
  i30 = i36 + (i30 << 3) | 0;
  i31 = i37 + (i33 << 3) | 0;
  __ZNSt3__219__partial_sort_copyIRNS_6__lessI16dtCrowdNeighbourS2_EEPS2_S5_EET1_T0_S7_S6_S6_T_(i36, i30, i37, i31, i35) | 0;
  i35 = i34 + 320 | 0;
  i36 = i33 << 3;
  _memcpy(i35 | 0, i37 | 0, i36 | 0) | 0;
  i37 = i34 + 384 | 0;
  HEAP32[i37 >> 2] = i33;
  STACKTOP = i38;
  return;
 }
 i17 = HEAP32[i1 + 24 >> 2] | 0;
 i18 = HEAP32[i1 + 16 >> 2] | 0;
 i19 = HEAP32[i1 + 28 >> 2] | 0;
 i20 = HEAP32[i1 + 20 >> 2] | 0;
 i15 = HEAP32[i1 + 32 >> 2] | 0;
 i14 = 0;
 i1 = 0;
 do {
  i13 = HEAPU16[i30 + (i14 << 1) >> 1] | 0;
  if ((i13 | 0) < (i15 | 0)) {
   i5 = HEAP32[i17 + (i13 << 2) >> 2] | 0;
   if ((i18 + (i5 * 608 | 0) | 0) != (i34 | 0)) if ((HEAPU8[i18 + (i5 * 608 | 0) + 316 >> 0] | 0) >= (i25 & 255)) {
    f12 = Math_fround(HEAPF32[i18 + (i5 * 608 | 0) + 484 >> 2]);
    f10 = Math_fround(HEAPF32[i18 + (i5 * 608 | 0) + 292 >> 2]);
    f11 = f12;
    i6 = i18 + (i5 * 608 | 0) + 516 | 0;
    i8 = i18 + (i5 * 608 | 0) + 480 | 0;
    i9 = i18 + (i5 * 608 | 0) + 488 | 0;
    i7 = i18 + (i5 * 608 | 0) + 520 | 0;
    f12 = Math_fround(f12 + Math_fround(HEAPF32[i18 + (i5 * 608 | 0) + 296 >> 2]));
    i5 = i18 + (i5 * 608 | 0) + 524 | 0;
    i33 = 11;
   }
  } else {
   i5 = HEAP32[i19 + (i13 - i15 << 2) >> 2] | 0;
   f4 = Math_fround(HEAPF32[i20 + (i5 * 92 | 0) + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i20 + (i5 * 92 | 0) + 36 >> 2]);
   f12 = Math_fround(f12 * f12);
   f10 = Math_fround(HEAPF32[i20 + (i5 * 92 | 0) + 44 >> 2]);
   f10 = Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f10 * f10))));
   f12 = Math_fround(HEAPF32[i20 + (i5 * 92 | 0) + 40 >> 2]);
   f11 = Math_fround(f4 - f12);
   i6 = i20 + (i5 * 92 | 0) + 12 | 0;
   i8 = i20 + (i5 * 92 | 0) | 0;
   i9 = i20 + (i5 * 92 | 0) + 8 | 0;
   i7 = i20 + (i5 * 92 | 0) + 16 | 0;
   f12 = Math_fround(f4 + f12);
   i5 = i20 + (i5 * 92 | 0) + 20 | 0;
   i33 = 11;
  }
  do if ((i33 | 0) == 11) {
   i33 = 0;
   f4 = Math_fround(HEAPF32[i6 >> 2]);
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   f2 = Math_fround(HEAPF32[i5 >> 2]);
   i6 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   if (i31) {
    f39 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f32);
    if (Math_fround(Math_fround(f21 * f39) + Math_fround(f16 * Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23))) < Math_fround(-Math_fround(f24 + f10))) break;
   }
   if (!(f26 < f11 | f12 < f22)) {
    f12 = Math_fround(f32 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f39 = Math_fround(f23 - (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
    f39 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f12 * f12) + Math_fround(f39 * f39)))) - f10) - f24);
    f2 = Math_fround(f39 / Math_fround(Math_fround(HEAPF32[i27 >> 2]) + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2))))));
    if (!(f2 > Math_fround(HEAPF32[i28 >> 2]))) {
     HEAP32[i36 + (i1 << 3) >> 2] = i13;
     HEAPF32[i36 + (i1 << 3) + 4 >> 2] = f2;
     i1 = i1 + 1 | 0;
    }
   }
  } while (0);
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != (i29 | 0));
 i33 = (i1 | 0) < 8;
 i33 = i33 ? i1 : 8;
 i30 = i36 + (i1 << 3) | 0;
 i31 = i37 + (i33 << 3) | 0;
 __ZNSt3__219__partial_sort_copyIRNS_6__lessI16dtCrowdNeighbourS2_EEPS2_S5_EET1_T0_S7_S6_S6_T_(i36, i30, i37, i31, i35) | 0;
 i35 = i34 + 320 | 0;
 i36 = i33 << 3;
 _memcpy(i35 | 0, i37 | 0, i36 | 0) | 0;
 i37 = i34 + 384 | 0;
 HEAP32[i37 >> 2] = i33;
 STACKTOP = i38;
 return;
}

function __ZNK16ReflectionProbes21GenerateDefaultSampleEv(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 24 | 0;
 i12 = i15 + 16 | 0;
 i13 = i15;
 i1 = i9;
 i2 = i1 + 124 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i7 = i11 + 12 | 0;
 i8 = i10 + 4 | 0;
 i6 = 0;
 do {
  i1 = i9 + (i6 * 60 | 0) | 0;
  HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  i1 = HEAP32[i10 >> 2] | 0;
  do if (!i1) i14 = 22; else {
   HEAP32[i12 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i4 = HEAP32[i11 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i14 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i14 = 11;
   }
   if ((i14 | 0) == 9) i14 = 11;
   if ((i14 | 0) == 11) {
    i14 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0)) {
     i14 = 22;
     break;
    }
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   if (!i1) i14 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 20;
    }
   }
   if ((i14 | 0) == 18) i14 = 20;
   if ((i14 | 0) == 20) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0;
   }
   i1 = HEAP32[i1 + 48 >> 2] | 0;
  } while (0);
  if ((i14 | 0) == 22) {
   i14 = 0;
   i1 = __ZN10builtintex21GetBlackCubeTextureIDEv() | 0;
  }
  HEAP32[i9 + (i6 * 60 | 0) + 24 >> 2] = i1;
  i4 = i9 + (i6 * 60 | 0) + 28 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  do if (!i1) i14 = 32; else {
   HEAP32[i12 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 29; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i2 = HEAP32[i11 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 29; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 31;
    }
   }
   if ((i14 | 0) == 29) i14 = 31;
   if ((i14 | 0) == 31) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0;
    if (!i1) {
     i14 = 32;
     break;
    }
   }
   f5 = Math_fround(HEAPF32[i8 >> 2]);
   i2 = HEAP32[i1 + 56 >> 2] | 0;
   if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
   __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i13, i2, i1, __Z19GetActiveColorSpacev() | 0, f5);
  } while (0);
  if ((i14 | 0) == 32) {
   i14 = 0;
   __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i13, 0, 0);
  };
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  i16 = i9 + (i6 * 60 | 0) + 44 | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
 } while ((i6 | 0) != 2);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i8, i1, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i10 = i13 + 24 | 0;
 i11 = i8 + 80 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12maybe_shrinkEv(i8);
 i12 = i8 + 64 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i9 = i8 + 68 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i8 + 76 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i8 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i8 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i19;
 i21 = i10 + 9 | 0;
 HEAP8[i21 >> 0] = (i19 & 65535) >>> 8;
 i19 = i10 + 12 | 0;
 i20 = i8 + 12 | 0;
 HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
 i17 = i10 + 36 | 0;
 i18 = i8 + 36 | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 i14 = i10 + 60 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 64 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 68 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 72 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 80 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j(i10, i8, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i8 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i21 >> 0] = i2;
 HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 i2 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 32 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 i2 = HEAP32[i8 + 56 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i10 + 56 >> 2] = i2;
 i2 = i8 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i8 + 76 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i8 + 72 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 84 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 STACKTOP = i13;
 return;
}

function __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 72 | 0;
 i8 = i16 + 40 | 0;
 i13 = i16 + 20 | 0;
 i14 = i16;
 i15 = i16 + 56 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_(i11, i2) | 0;
 if ((i1 | 0) != (i11 + 4 | 0)) {
  i15 = HEAP32[i1 + 32 >> 2] | 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i11 + 8 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i1 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i7 = 6;
 } else if (i4 >>> 0 < 11) {
  i2 = i15 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i15;
   i6 = i2;
  } else {
   i1 = i15;
   i7 = 8;
  }
 } else i7 = 6;
 if ((i7 | 0) == 6) {
  i2 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i4;
  i2 = i15 + 11 | 0;
  i7 = 8;
 }
 if ((i7 | 0) == 8) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i6 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 i4 = HEAP8[i6 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i15 >> 2] | 0 : i15;
 i4 = i1 ? HEAP32[i15 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  i7 = 12;
 } else if (i4 >>> 0 < 11) {
  i2 = i14 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i14;
   i5 = i2;
  } else {
   i1 = i14;
   i7 = 14;
  }
 } else i7 = 12;
 if ((i7 | 0) == 12) {
  i2 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i4;
  i2 = i14 + 11 | 0;
  i7 = 14;
 }
 if ((i7 | 0) == 14) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i5 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i14 + 16 | 0;
 HEAP32[i3 >> 2] = i10;
 i4 = HEAP8[i5 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
 i4 = i1 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i7 = 18;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i13 + 11 >> 0] = i4;
  if (!i4) i1 = i13; else {
   i1 = i13;
   i7 = 20;
  }
 } else i7 = 18;
 if ((i7 | 0) == 18) {
  i17 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i17 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i4;
  i7 = 20;
 }
 if ((i7 | 0) == 20) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i13 + 16 >> 2] = HEAP32[i3 >> 2];
 i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i11, i12, i13) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i8, i11, i13);
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i2 = HEAP32[i12 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i11 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 4 >> 2] | 0, i1);
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 if ((HEAP8[i13 + 11 >> 0] | 0) < 0) {
  i17 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i12);
 }
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i17 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i12);
 }
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i17 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i12);
 }
 i17 = i10;
 STACKTOP = i16;
 return i17 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i8 = i15;
 i3 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i1 >> 4;
 i5 = i1;
 if (i2 >>> 0 < i6 >>> 0) {
  i5 = i12 + 8 | 0;
  if (((HEAP32[i5 >> 2] | 0) - i1 >> 4 | 0) == (i6 | 0)) {
   __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj(i12, i6 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj(i8, i6);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i8, i11, i14);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i2 - i4 >> 4;
  i1 = i2;
  if (i3 >>> 0 < i6 >>> 0) {
   __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj(i8, i6 - i3 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i3 >>> 0 > i6 >>> 0) {
   i4 = i4 + (i6 << 4) | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i2 = i1 + -16 | 0;
     HEAP32[i7 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i2 = HEAP32[i2 >> 2] | 0;
      i11 = HEAP32[i1 + -4 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
      i2 = HEAP32[i7 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
    }
   }
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i13 >> 2] = i2;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i4 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i7 = i5 + (i6 << 4) | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = i6 << 4;
 i2 = i1 >> 4;
 if (!i2) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = __Znwj(i1) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = i1;
  i2 = i1 + (i2 << 4) | 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = i2;
  i3 = i1;
  if (!i6) {
   i4 = i8;
   i5 = i3;
  } else {
   i6 = i14 + 4 | 0;
   do {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
    i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i9 = 32;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i9 = 34;
    } else i9 = 32;
    if ((i9 | 0) == 32) {
     i16 = i4 + 16 & -16;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i16 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i2;
     i9 = 34;
    }
    if ((i9 | 0) == 34) {
     i9 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    i5 = i5 + 16 | 0;
    i1 = (HEAP32[i10 >> 2] | 0) + 16 | 0;
    HEAP32[i10 >> 2] = i1;
   } while ((i5 | 0) != (i7 | 0));
   i4 = i8;
   i5 = HEAP32[i11 >> 2] | 0;
   i3 = i1;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i13 >> 2] = i3;
 i13 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i4 = i1;
 i2 = i16;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i16 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i16;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __ZNK9dtNavMesh19findConnectingPolysEPKfiPK10dtMeshTileiPyPfi(i2, i1, i3, i37, i38, i39, i40, i41) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 i41 = i41 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i42 = 0, i43 = 0, i44 = 0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i44 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i42 = i44 + 328 | 0;
 i43 = i44 + 136 | 0;
 i33 = i44 + 8 | 0;
 i34 = i44;
 if ((i3 | 0) < 2 | (i37 | 0) == 0) {
  i43 = 0;
  STACKTOP = i44;
  return i43 | 0;
 }
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 92 >> 2]) * Math_fround(.5));
 __ZL19makeDetailEdgeSlabsPfPKfii(i42, i1, i3, i38);
 i35 = i42 + ((i3 << 1) + -2 << 2) | 0;
 i36 = i38 | 4;
 switch (i36 | 0) {
 case 4:
  {
   f32 = Math_fround(HEAPF32[i1 >> 2]);
   break;
  }
 case 6:
  {
   f32 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   break;
  }
 default:
  f32 = Math_fround(0.0);
 }
 HEAP32[i34 >> 2] = 0;
 i27 = (i37 - (HEAP32[i2 + 20 >> 2] | 0) | 0) / 56 | 0;
 i25 = _bitshift64Shl(HEAP32[i37 + 4 >> 2] | 0, 0, 48) | 0;
 i26 = getTempRet0() | 0;
 i27 = _bitshift64Shl(i27 | 0, 0, 20) | 0;
 i25 = i27 | i25;
 i26 = getTempRet0() | 0 | i26;
 i27 = i37 + 8 | 0;
 if ((HEAP32[(HEAP32[i27 >> 2] | 0) + 20 >> 2] | 0) > 0) {
  i28 = i37 + 16 | 0;
  i29 = i38 & 32767 | 32768;
  i30 = i37 + 20 | 0;
  i31 = i3 + -1 | 0;
  i24 = (i3 | 0) > 1;
  f22 = Math_fround(f4 * Math_fround(2.0));
  f22 = Math_fround(f22 * f22);
  f23 = Math_fround(HEAPF32[i42 >> 2]);
  i1 = 0;
  i21 = 0;
  do {
   i19 = HEAP32[i28 >> 2] | 0;
   i18 = HEAP8[i19 + (i21 << 5) + 28 >> 0] | 0;
   i20 = i18 & 255;
   L12 : do if (i18 << 24 >> 24) {
    i18 = 0;
    L13 : while (1) {
     if ((HEAPU16[i19 + (i21 << 5) + 12 + (i18 << 1) >> 1] | 0 | 0) == (i29 | 0)) {
      i2 = (HEAP32[i30 >> 2] | 0) + ((HEAPU16[i19 + (i21 << 5) + (i18 << 1) >> 1] | 0) * 3 << 2) | 0;
      switch (i36 | 0) {
      case 4:
       {
        f4 = Math_fround(HEAPF32[i2 >> 2]);
        break;
       }
      case 6:
       {
        f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
        break;
       }
      default:
       f4 = Math_fround(0.0);
      }
      f17 = Math_fround(f32 - f4);
      i16 = f17 < Math_fround(0.0);
      f14 = Math_fround(-f17);
      if (!((i16 ? f14 : f17) > Math_fround(.00999999977))) {
       __ZNK9dtNavMesh23getPolyEdgeDetailPointsEPK10dtMeshTileiiPfPii(0, i37, i21, i18, i43, i34, 16) | 0;
       i10 = HEAP32[i34 >> 2] | 0;
       if (i10 | 0) {
        __ZL19makeDetailEdgeSlabsPfPKfii(i33, i43, i10, i38);
        if (i24) {
         i11 = i10 + -1 | 0;
         if ((i10 | 0) > 1) {
          i8 = 0;
          do {
           i16 = i42 + (i8 << 1 << 2) | 0;
           i8 = i8 + 1 | 0;
           i15 = i42 + (i8 << 1 << 2) | 0;
           f12 = Math_fround(HEAPF32[i16 >> 2]);
           f13 = Math_fround(f12 + Math_fround(.00999999977));
           f17 = Math_fround(HEAPF32[i15 >> 2]);
           f14 = Math_fround(f17 + Math_fround(-.00999999977));
           i15 = i15 + 4 | 0;
           i16 = i16 + 4 | 0;
           f17 = Math_fround(f17 - f12);
           i9 = 0;
           do {
            i2 = i33 + (i9 << 1 << 2) | 0;
            i9 = i9 + 1 | 0;
            i3 = i33 + (i9 << 1 << 2) | 0;
            f4 = Math_fround(HEAPF32[i2 >> 2]);
            f5 = Math_fround(f4 + Math_fround(.00999999977));
            f5 = f13 > f5 ? f13 : f5;
            f6 = Math_fround(HEAPF32[i3 >> 2]);
            f7 = Math_fround(f6 + Math_fround(-.00999999977));
            f7 = f14 < f7 ? f14 : f7;
            if (!(f5 > f7)) {
             f46 = Math_fround(HEAPF32[i15 >> 2]);
             f45 = Math_fround(HEAPF32[i16 >> 2]);
             f46 = Math_fround(Math_fround(f46 - f45) / f17);
             f45 = Math_fround(f45 - Math_fround(f12 * f46));
             f48 = Math_fround(HEAPF32[i3 + 4 >> 2]);
             f47 = Math_fround(HEAPF32[i2 + 4 >> 2]);
             f6 = Math_fround(Math_fround(f48 - f47) / Math_fround(f6 - f4));
             f4 = Math_fround(f47 - Math_fround(f4 * f6));
             f5 = Math_fround(Math_fround(Math_fround(f5 * f6) + f4) - Math_fround(Math_fround(f5 * f46) + f45));
             f4 = Math_fround(Math_fround(Math_fround(f7 * f6) + f4) - Math_fround(Math_fround(f7 * f46) + f45));
             if (Math_fround(f5 * f4) < Math_fround(0.0)) break L13;
             if (Math_fround(f4 * f4) <= f22 | Math_fround(f5 * f5) <= f22) break L13;
            }
           } while ((i9 | 0) < (i11 | 0));
          } while ((i8 | 0) < (i31 | 0));
         }
        }
       }
      }
     }
     i18 = i18 + 1 | 0;
     if ((i18 | 0) >= (i20 | 0)) break L12;
    }
    if ((i1 | 0) < (i41 | 0)) {
     f47 = Math_fround(HEAPF32[i33 >> 2]);
     i20 = i1 << 1;
     HEAPF32[i40 + (i20 << 2) >> 2] = f23 > f47 ? f23 : f47;
     f47 = Math_fround(HEAPF32[i35 >> 2]);
     f48 = Math_fround(HEAPF32[i33 + ((i10 << 1) + -2 << 2) >> 2]);
     HEAPF32[i40 + ((i20 | 1) << 2) >> 2] = f47 < f48 ? f47 : f48;
     i20 = i39 + (i1 << 3) | 0;
     HEAP32[i20 >> 2] = i21 | i25;
     HEAP32[i20 + 4 >> 2] = i26;
     i1 = i1 + 1 | 0;
    }
   } while (0);
   i21 = i21 + 1 | 0;
  } while ((i21 | 0) < (HEAP32[(HEAP32[i27 >> 2] | 0) + 20 >> 2] | 0));
 } else i1 = 0;
 i43 = i1;
 STACKTOP = i44;
 return i43 | 0;
}

function __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i3 = i8;
 i7 = ((HEAP32[i2 >> 2] | 0) - i3 | 0) / 40 | 0;
 i11 = i8 + (i7 * 40 | 0) | 0;
 i12 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = i10 + 8 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i4 = i2;
 i6 = i9;
 if (i2 >>> 0 < i9 >>> 0) {
  if ((i11 | 0) == (i2 | 0)) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i8 + (i7 * 40 | 0) + 20 >> 2] = 0;
   i6 = i1 + 24 | 0;
   i9 = HEAP32[i6 + 4 >> 2] | 0;
   i10 = i8 + (i7 * 40 | 0) + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP8[i8 + (i7 * 40 | 0) + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i11, i1);
   i10 = i8 + (i7 * 40 | 0) + 32 | 0;
   i9 = i1 + 32 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP8[i10 + 4 >> 0] = HEAP8[i9 + 4 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 40;
   i12 = i11;
   return i12 | 0;
  }
  i5 = i4 - (i11 + 40) | 0;
  i3 = i11 + (((i5 | 0) / 40 | 0) * 40 | 0) | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   i4 = i3;
   i6 = i2;
   do {
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 20 >> 2] = 0;
    i13 = i4 + 24 | 0;
    i9 = HEAP32[i13 + 4 >> 2] | 0;
    i10 = i6 + 24 | 0;
    HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
    HEAP8[i6 + 4 >> 0] = 0;
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i6, i4);
    i10 = i6 + 32 | 0;
    i9 = i4 + 32 | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP8[i10 + 4 >> 0] = HEAP8[i9 + 4 >> 0] | 0;
    i4 = i4 + 40 | 0;
    i6 = (HEAP32[i12 >> 2] | 0) + 40 | 0;
    HEAP32[i12 >> 2] = i6;
   } while (i4 >>> 0 < i2 >>> 0);
  }
  if (i5 | 0) do {
   i13 = i2;
   i2 = i2 + -40 | 0;
   i10 = i3;
   i3 = i3 + -40 | 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i3);
   i13 = i13 + -8 | 0;
   i10 = i10 + -8 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP8[i13 + 4 >> 0] = HEAP8[i10 + 4 >> 0] | 0;
  } while ((i3 | 0) != (i11 | 0));
  if (i11 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i12 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 40 | 0 : i1;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i11, i1);
  i13 = i8 + (i7 * 40 | 0) + 32 | 0;
  i12 = i1 + 32 | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP8[i13 + 4 >> 0] = HEAP8[i12 + 4 >> 0] | 0;
  i13 = i11;
  return i13 | 0;
 }
 i4 = ((i4 - i3 | 0) / 40 | 0) + 1 | 0;
 if (i4 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i9 = i5;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = i5;
  i2 = i6;
 }
 i5 = (i2 - i3 | 0) / 40 | 0;
 i7 = i5 << 1;
 i7 = i5 >>> 0 < 53687091 ? (i7 >>> 0 < i4 >>> 0 ? i4 : i7) : 107374182;
 i3 = i11 - i3 | 0;
 i5 = (i3 | 0) / 40 | 0;
 if (!i7) i8 = 0; else i8 = __Znwj(i7 * 40 | 0) | 0;
 i6 = i8 + (i5 * 40 | 0) | 0;
 i4 = i6;
 i2 = i8 + (i7 * 40 | 0) | 0;
 do if ((i5 | 0) == (i7 | 0)) {
  if ((i3 | 0) > 0) {
   i4 = i6 + (((i7 + 1 | 0) / -2 | 0) * 40 | 0) | 0;
   break;
  }
  i2 = i7 * 40 | 0;
  i2 = (i2 | 0) == 0 ? 1 : ((i2 | 0) / 40 | 0) << 1;
  if (!i2) i3 = 0; else i3 = __Znwj(i2 * 40 | 0) | 0;
  i4 = i3 + ((i2 >>> 2) * 40 | 0) | 0;
  i2 = i3 + (i2 * 40 | 0) | 0;
  if (i8) __ZdlPv(i8);
 } while (0);
 i7 = i4;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 i13 = i1 + 24 | 0;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i7 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP8[i7 + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i7, i1);
 i8 = i7 + 32 | 0;
 i1 = i1 + 32 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i8 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i1 = i7 + 40 | 0;
 i7 = i1;
 i8 = i4;
 i6 = HEAP32[i10 >> 2] | 0;
 if ((i6 | 0) == (i11 | 0)) i3 = i8; else {
  i5 = i11;
  i3 = i8;
  do {
   i14 = i3 + -40 | 0;
   i13 = i5;
   i5 = i5 + -40 | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i3 + -20 >> 2] = 0;
   i17 = i13 + -16 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i15 = i3 + -16 | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP8[i3 + -36 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i14, i5);
   i3 = i3 + -8 | 0;
   i13 = i13 + -8 | 0;
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   HEAP8[i3 + 4 >> 0] = HEAP8[i13 + 4 >> 0] | 0;
   i3 = i4 + -40 | 0;
   i4 = i3;
  } while ((i5 | 0) != (i6 | 0));
 }
 i6 = HEAP32[i12 >> 2] | 0;
 if ((i6 | 0) == (i11 | 0)) {
  i5 = i7;
  i1 = i11;
 } else {
  i5 = i11;
  i3 = i7;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i15 = i5 + 24 | 0;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i1 + 24 | 0;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   HEAP8[i1 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i1, i5);
   i17 = i1 + 32 | 0;
   i16 = i5 + 32 | 0;
   HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
   HEAP8[i17 + 4 >> 0] = HEAP8[i16 + 4 >> 0] | 0;
   i5 = i5 + 40 | 0;
   i1 = i3 + 40 | 0;
   i3 = i1;
  } while ((i5 | 0) != (i6 | 0));
  i5 = i3;
  i3 = i4;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i9 >> 2] = i2;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -36 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i4) {
  i17 = i8;
  return i17 | 0;
 }
 __ZdlPv(i4);
 i17 = i8;
 return i17 | 0;
}

function runPostSets227() {
 HEAP32[gb + 10660 >> 2] = (HEAP32[gb + 10660 >> 2] | 0) + (gb + 1076413 | 0);
 HEAP32[gb + 208140 >> 2] = (HEAP32[gb + 208140 >> 2] | 0) + (gb + 10664 | 0);
 HEAP32[gb + 208144 >> 2] = fb + 3021;
 HEAP32[gb + 208148 >> 2] = fb + 3022;
 HEAP32[gb + 10664 >> 2] = (HEAP32[gb + 10664 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 10668 >> 2] = (HEAP32[gb + 10668 >> 2] | 0) + (gb + 1076766 | 0);
 HEAP32[gb + 208156 >> 2] = (HEAP32[gb + 208156 >> 2] | 0) + (gb + 10672 | 0);
 HEAP32[gb + 208160 >> 2] = fb + 3023;
 HEAP32[gb + 208164 >> 2] = fb + 3024;
 HEAP32[gb + 208168 >> 2] = fb + 1406;
 HEAP32[gb + 10672 >> 2] = (HEAP32[gb + 10672 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10676 >> 2] = (HEAP32[gb + 10676 >> 2] | 0) + (gb + 1076787 | 0);
 HEAP32[gb + 10680 >> 2] = (HEAP32[gb + 10680 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 208176 >> 2] = (HEAP32[gb + 208176 >> 2] | 0) + (gb + 10688 | 0);
 HEAP32[gb + 208180 >> 2] = fb + 3025;
 HEAP32[gb + 208184 >> 2] = fb + 3026;
 HEAP32[gb + 208188 >> 2] = fb + 3027;
 HEAP32[gb + 208192 >> 2] = fb + 3028;
 HEAP32[gb + 10688 >> 2] = (HEAP32[gb + 10688 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10692 >> 2] = (HEAP32[gb + 10692 >> 2] | 0) + (gb + 1077157 | 0);
 HEAP32[gb + 10696 >> 2] = (HEAP32[gb + 10696 >> 2] | 0) + (gb + 12768 | 0);
 HEAP32[gb + 208200 >> 2] = (HEAP32[gb + 208200 >> 2] | 0) + (gb + 10704 | 0);
 HEAP32[gb + 208204 >> 2] = fb + 3029;
 HEAP32[gb + 208208 >> 2] = fb + 3030;
 HEAP32[gb + 208212 >> 2] = fb + 1407;
 HEAP32[gb + 208216 >> 2] = fb + 471;
 HEAP32[gb + 208220 >> 2] = fb + 300;
 HEAP32[gb + 208224 >> 2] = fb + 301;
 HEAP32[gb + 208228 >> 2] = fb + 472;
 HEAP32[gb + 10704 >> 2] = (HEAP32[gb + 10704 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10708 >> 2] = (HEAP32[gb + 10708 >> 2] | 0) + (gb + 1077123 | 0);
 HEAP32[gb + 10712 >> 2] = (HEAP32[gb + 10712 >> 2] | 0) + (gb + 12936 | 0);
 HEAP32[gb + 208620 >> 2] = (HEAP32[gb + 208620 >> 2] | 0) + (gb + 10720 | 0);
 HEAP32[gb + 208624 >> 2] = fb + 3031;
 HEAP32[gb + 208628 >> 2] = fb + 3032;
 HEAP32[gb + 10720 >> 2] = (HEAP32[gb + 10720 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10724 >> 2] = (HEAP32[gb + 10724 >> 2] | 0) + (gb + 1077257 | 0);
 HEAP32[gb + 10728 >> 2] = (HEAP32[gb + 10728 >> 2] | 0) + (gb + 10736 | 0);
 HEAP32[gb + 208636 >> 2] = (HEAP32[gb + 208636 >> 2] | 0) + (gb + 10736 | 0);
 HEAP32[gb + 208640 >> 2] = fb + 3033;
 HEAP32[gb + 208644 >> 2] = fb + 3034;
 HEAP32[gb + 10736 >> 2] = (HEAP32[gb + 10736 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 10740 >> 2] = (HEAP32[gb + 10740 >> 2] | 0) + (gb + 1077239 | 0);
 HEAP32[gb + 208652 >> 2] = (HEAP32[gb + 208652 >> 2] | 0) + (gb + 10744 | 0);
 HEAP32[gb + 208656 >> 2] = fb + 3035;
 HEAP32[gb + 208660 >> 2] = fb + 3036;
 HEAP32[gb + 10744 >> 2] = (HEAP32[gb + 10744 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10748 >> 2] = (HEAP32[gb + 10748 >> 2] | 0) + (gb + 1077299 | 0);
 HEAP32[gb + 10752 >> 2] = (HEAP32[gb + 10752 >> 2] | 0) + (gb + 10736 | 0);
 HEAP32[gb + 208668 >> 2] = (HEAP32[gb + 208668 >> 2] | 0) + (gb + 10760 | 0);
 HEAP32[gb + 208672 >> 2] = fb + 3037;
 HEAP32[gb + 208676 >> 2] = fb + 3038;
 HEAP32[gb + 208680 >> 2] = fb + 706;
 HEAP32[gb + 208684 >> 2] = fb + 96;
 HEAP32[gb + 208688 >> 2] = fb + 143;
 HEAP32[gb + 208692 >> 2] = fb + 176;
 HEAP32[gb + 208696 >> 2] = fb + 400;
 HEAP32[gb + 208700 >> 2] = fb + 401;
 HEAP32[gb + 208704 >> 2] = fb + 97;
 HEAP32[gb + 208708 >> 2] = fb + 1408;
 HEAP32[gb + 208712 >> 2] = fb + 403;
 HEAP32[gb + 208716 >> 2] = fb + 476;
 HEAP32[gb + 208720 >> 2] = fb + 98;
 HEAP32[gb + 208724 >> 2] = fb + 477;
 HEAP32[gb + 10760 >> 2] = (HEAP32[gb + 10760 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 10764 >> 2] = (HEAP32[gb + 10764 >> 2] | 0) + (gb + 1077341 | 0);
 HEAP32[gb + 208732 >> 2] = (HEAP32[gb + 208732 >> 2] | 0) + (gb + 10768 | 0);
 HEAP32[gb + 208736 >> 2] = fb + 3039;
 HEAP32[gb + 208740 >> 2] = fb + 3040;
 HEAP32[gb + 208744 >> 2] = fb + 2295;
 HEAP32[gb + 208748 >> 2] = fb + 302;
 HEAP32[gb + 208752 >> 2] = fb + 144;
 HEAP32[gb + 208756 >> 2] = fb + 177;
 HEAP32[gb + 208760 >> 2] = fb + 1409;
 HEAP32[gb + 208764 >> 2] = fb + 1410;
 HEAP32[gb + 208768 >> 2] = fb + 303;
 HEAP32[gb + 208772 >> 2] = fb + 1411;
 HEAP32[gb + 208776 >> 2] = fb + 1412;
 HEAP32[gb + 208780 >> 2] = fb + 478;
 HEAP32[gb + 208784 >> 2] = fb + 304;
 HEAP32[gb + 208788 >> 2] = fb + 479;
 HEAP32[gb + 10768 >> 2] = (HEAP32[gb + 10768 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 10772 >> 2] = (HEAP32[gb + 10772 >> 2] | 0) + (gb + 1077390 | 0);
 HEAP32[gb + 208800 >> 2] = (HEAP32[gb + 208800 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 208804 >> 2] = fb + 3041;
 HEAP32[gb + 208808 >> 2] = fb + 3042;
 HEAP32[gb + 208820 >> 2] = (HEAP32[gb + 208820 >> 2] | 0) + (gb + 10776 | 0);
 HEAP32[gb + 208824 >> 2] = fb + 3043;
 HEAP32[gb + 208828 >> 2] = fb + 3044;
 HEAP32[gb + 10776 >> 2] = (HEAP32[gb + 10776 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 10780 >> 2] = (HEAP32[gb + 10780 >> 2] | 0) + (gb + 1077439 | 0);
 HEAP32[gb + 10792 >> 2] = (HEAP32[gb + 10792 >> 2] | 0) + (gb + 10720 | 0);
 HEAP32[gb + 208832 >> 2] = (HEAP32[gb + 208832 >> 2] | 0) + (gb + 208792 | 0);
 HEAP32[gb + 208836 >> 2] = (HEAP32[gb + 208836 >> 2] | 0) + (gb + 208792 | 0);
 HEAP32[gb + 208848 >> 2] = (HEAP32[gb + 208848 >> 2] | 0) + (gb + 10800 | 0);
 HEAP32[gb + 208852 >> 2] = fb + 3045;
 HEAP32[gb + 208856 >> 2] = fb + 3046;
 HEAP32[gb + 208868 >> 2] = (HEAP32[gb + 208868 >> 2] | 0) + (gb + 10800 | 0);
 HEAP32[gb + 208872 >> 2] = fb + 3047;
 HEAP32[gb + 208876 >> 2] = fb + 3048;
 runPostSets228();
}

function __ZL12CullGroupJobP20CullingGroupsJobDataj(i27, i2) {
 i27 = i27 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 8 | 0;
 i1 = i28;
 if ((HEAP16[gb + 1114368 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i26 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114368 | 0, i26);
  i24 = gb + 1114368 | 0;
 } else i24 = 0;
 i25 = i27 + 56 + (i2 * 12 | 0) | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 i23 = i27 + 56 + (i2 * 12 | 0) + 4 | 0;
 L4 : do if (i1 >>> 0 < ((HEAP32[i23 >> 2] | 0) + i1 | 0) >>> 0) {
  i12 = i27 + 16 | 0;
  i13 = i27 + 12 | 0;
  i14 = i27 + 36 | 0;
  i15 = i27 + 8 | 0;
  i16 = i26 + 4 | 0;
  i17 = i26 + 8 | 0;
  i18 = i26 + 12 | 0;
  i19 = i27 + 4 | 0;
  i20 = i26 + 4 | 0;
  i21 = i26 + 8 | 0;
  i22 = i26 + 12 | 0;
  while (1) {
   i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i11 = HEAP32[i13 >> 2] | 0;
   i4 = i11 + (i10 * 48 | 0) | 0;
   L8 : do switch (HEAP32[i11 + (i10 * 48 | 0) + 32 >> 2] | 0) {
   case 0:
    {
     i3 = HEAP32[i14 >> 2] | 0;
     i2 = HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0;
     i3 = (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 | 0;
     if (i3 >>> 0 > i2 >>> 0) {
      i4 = i11 + (i10 * 48 | 0) + 44 | 0;
      do {
       i9 = (HEAP32[i4 >> 2] | 0) + i2 | 0;
       HEAP8[i9 >> 0] = HEAPU8[i9 >> 0] & 127;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i3 | 0));
     }
     break;
    }
   case 1:
    {
     i3 = HEAP32[i14 >> 2] | 0;
     i2 = i3 + (i1 * 12 | 0) | 0;
     if (HEAP8[HEAP32[i15 >> 2] >> 0] | 0) {
      i8 = __Z9GetIUmbrav() | 0;
      i9 = HEAP32[i2 >> 2] | 0;
      mftCall_viiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 72 >> 2] | 0, i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i19 >> 2] | 0, i9 | 0, (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) + i9 | 0, HEAP32[i11 + (i10 * 48 | 0) + 44 >> 2] | 0, -128, 1);
      break L8;
     }
     i5 = HEAP32[i27 >> 2] | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 >> 2] | 0;
     i6 = (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 | 0;
     i7 = HEAP32[i11 + (i10 * 48 | 0) + 44 >> 2] | 0;
     i8 = i5 + 352 | 0;
     if (i2 >>> 0 < i6 >>> 0) {
      i5 = i5 + 188 | 0;
      do {
       i30 = i9 + (i2 << 4) | 0;
       i3 = HEAP32[i30 + 4 >> 2] | 0;
       i4 = HEAP32[i30 + 8 >> 2] | 0;
       i29 = HEAP32[i30 + 12 >> 2] | 0;
       HEAP32[i26 >> 2] = HEAP32[i30 >> 2];
       HEAP32[i16 >> 2] = i3;
       HEAP32[i17 >> 2] = i4;
       HEAP32[i18 >> 2] = i29;
       i29 = __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i(i26, i8, HEAP32[i5 >> 2] | 0) | 0;
       i4 = i7 + i2 | 0;
       i3 = HEAP8[i4 >> 0] | 0;
       if (i29) i3 = i3 | -128; else i3 = i3 & 127;
       HEAP8[i4 >> 0] = i3;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i6 | 0));
     }
     break;
    }
   case 2:
    {
     __ZL24CalculateDistanceIndicesR16CullingGroupDataR10BlockRangeR20CullingGroupsJobData(i4, (HEAP32[i14 >> 2] | 0) + (i1 * 12 | 0) | 0);
     break;
    }
   case 3:
    {
     i3 = HEAP32[i14 >> 2] | 0;
     i2 = i3 + (i1 * 12 | 0) | 0;
     __ZL24CalculateDistanceIndicesR16CullingGroupDataR10BlockRangeR20CullingGroupsJobData(i4, i2);
     if (HEAP8[HEAP32[i15 >> 2] >> 0] | 0) {
      i29 = __Z9GetIUmbrav() | 0;
      i30 = HEAP32[i2 >> 2] | 0;
      mftCall_viiiiiiii(HEAP32[(HEAP32[i29 >> 2] | 0) + 72 >> 2] | 0, i29 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i19 >> 2] | 0, i30 | 0, (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) + i30 | 0, HEAP32[i11 + (i10 * 48 | 0) + 44 >> 2] | 0, -128, 1);
      break L8;
     }
     i5 = HEAP32[i27 >> 2] | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 >> 2] | 0;
     i6 = (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 | 0;
     i7 = HEAP32[i11 + (i10 * 48 | 0) + 44 >> 2] | 0;
     i8 = i5 + 352 | 0;
     if (i2 >>> 0 < i6 >>> 0) {
      i5 = i5 + 188 | 0;
      do {
       i29 = i9 + (i2 << 4) | 0;
       i3 = HEAP32[i29 + 4 >> 2] | 0;
       i4 = HEAP32[i29 + 8 >> 2] | 0;
       i30 = HEAP32[i29 + 12 >> 2] | 0;
       HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
       HEAP32[i20 >> 2] = i3;
       HEAP32[i21 >> 2] = i4;
       HEAP32[i22 >> 2] = i30;
       i30 = __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i(i26, i8, HEAP32[i5 >> 2] | 0) | 0;
       i4 = i7 + i2 | 0;
       i3 = HEAP8[i4 >> 0] | 0;
       if (i30) i3 = i3 | -128; else i3 = i3 & 127;
       HEAP8[i4 >> 0] = i3;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i6 | 0));
     }
     break;
    }
   default:
    {}
   } while (0);
   if (HEAP8[i11 + (i10 * 48 | 0) + 40 >> 0] | 0) {
    i6 = HEAP32[i14 >> 2] | 0;
    i2 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
    i6 = (HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 | 0;
    if (i6 >>> 0 > i2 >>> 0) {
     i7 = i11 + (i10 * 48 | 0) + 44 | 0;
     i5 = i11 + (i10 * 48 | 0) + 36 | 0;
     do {
      i3 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
      i4 = HEAPU8[i3 >> 0] & 127;
      if (i4 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) HEAP8[i3 >> 0] = i4;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i6 | 0));
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= ((HEAP32[i23 >> 2] | 0) + (HEAP32[i25 >> 2] | 0) | 0) >>> 0) break L4;
  }
 } while (0);
 if (!i24) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i28;
 return;
}

function __ZN5physx2Sc15ClothFabricCore4loadERNS_13PxInputStreamE(i19, i18) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i22;
 i1 = i22 + 108 | 0;
 i17 = i22 + 112 | 0;
 i21 = i22 + 96 | 0;
 i4 = i22 + 88 | 0;
 i20 = i22 + 72 | 0;
 i5 = i22 + 68 | 0;
 i7 = i22 + 56 | 0;
 i6 = i22 + 52 | 0;
 i11 = i22 + 40 | 0;
 i10 = i22 + 36 | 0;
 i14 = i22 + 24 | 0;
 i13 = i22 + 20 | 0;
 i16 = i22 + 8 | 0;
 i15 = i22 + 4 | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i1 | 0, 4) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) < 197376) switch (i1 | 0) {
 case 1:
  break;
 default:
  i3 = 2;
 } else switch (i1 | 0) {
 case 197376:
 case 197377:
  break;
 default:
  i3 = 2;
 }
 if ((i3 | 0) == 2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 723467 | 0, 152, gb + 723890 | 0, i2);
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = i17;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i17 | 0, 4) | 0;
 i3 = i17 + 4 | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i3 | 0, 4) | 0;
 i1 = i17 + 12 | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i1 | 0, 4) | 0;
 i2 = i17 + 28 | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i2 | 0, 4) | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 i12 = i21 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i21, i8, i4);
 i8 = HEAP32[i21 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i8 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i17 + 8 >> 2] = i8;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 i3 = i20 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i20 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i20, i8, i5);
 i8 = HEAP32[i20 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i8 | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
 HEAP32[i17 + 16 >> 2] = i8;
 i3 = HEAP32[i8 + ((HEAP32[i3 >> 2] | 0) + -1 << 2) >> 2] | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i7, i3, i6);
 i6 = HEAP32[i7 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i6 | 0, i3 << 2 | 0) | 0;
 HEAP32[i17 + 24 >> 2] = i6;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i11, i3 << 1, i10);
 i4 = HEAP32[i11 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i4 | 0, i3 << 3 | 0) | 0;
 HEAP32[i17 + 20 >> 2] = i4;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i5 = i14 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i14, i3, i13);
 i3 = HEAP32[i14 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i3 | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 HEAP32[i17 + 32 >> 2] = i3;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i14 = i16 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i16, i1, i15);
 i1 = HEAP32[i16 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, i1 | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 HEAP32[i17 + 36 >> 2] = i1;
 i2 = __ZN5physx2Sc15ClothFabricCore4loadERKNS_17PxClothFabricDescE(i19, i17) | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 if (!((i19 & 2147483647 | 0) == 0 | (i19 | 0) < 0 | (i1 | 0) == 0)) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i1 | 0);
 }
 i19 = HEAP32[i5 >> 2] | 0;
 if (!((i19 & 2147483647 | 0) == 0 | (i19 | 0) < 0 | (i3 | 0) == 0)) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i3 | 0);
 }
 i19 = HEAP32[i7 >> 2] | 0;
 if (!((i19 & 2147483647 | 0) == 0 | (i19 | 0) < 0 | (i4 | 0) == 0)) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i4 | 0);
 }
 i19 = HEAP32[i8 >> 2] | 0;
 if (!((i19 & 2147483647 | 0) == 0 | (i19 | 0) < 0 | (i6 | 0) == 0)) {
  i19 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i6 | 0);
 }
 i19 = HEAP32[i9 >> 2] | 0;
 if ((i19 | 0) > -1 & (i19 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) {
   i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
  }
 }
 i20 = HEAP32[i12 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = i2;
 STACKTOP = i22;
 return i21 | 0;
}

function __Z16ClipPolysByPlanehPK8Vector3fRK5PlanePhPS_S5_S6_(i2, i18, i7, i24, i19, i20, i21) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i7 = i7 | 0;
 i24 = i24 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i22 = 0, i23 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 i22 = i2 & 255;
 if ((i2 & 255) < 3) {
  HEAP8[i24 >> 0] = 0;
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i23 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i22 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 i1 = 0;
 do {
  f17 = Math_fround(f3 * Math_fround(HEAPF32[i18 + (i1 * 12 | 0) >> 2]));
  f17 = Math_fround(f17 + Math_fround(f4 * Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 4 >> 2])));
  HEAP8[i23 + i1 >> 0] = Math_fround(f6 + Math_fround(f17 + Math_fround(f5 * Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 8 >> 2])))) < Math_fround(0.0) & 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i22 | 0));
 L8 : do if (!(i2 << 24 >> 24)) i1 = 0; else {
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  i1 = 0;
  i2 = 0;
  do {
   L12 : while (1) {
    i11 = i2;
    while (1) {
     i2 = i11 + 1 | 0;
     i13 = (i2 | 0) < (i22 | 0);
     i12 = i13 ? i2 : 0;
     i7 = (HEAP8[i23 + i12 >> 0] | 0) == 0;
     if (!(HEAP8[i23 + i11 >> 0] | 0)) {
      if (i7) break;
      f10 = Math_fround(HEAPF32[i18 + (i12 * 12 | 0) >> 2]);
      f9 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) >> 2]);
      f10 = Math_fround(f10 - f9);
      f8 = Math_fround(HEAPF32[i18 + (i12 * 12 | 0) + 4 >> 2]);
      f6 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) + 4 >> 2]);
      f8 = Math_fround(f8 - f6);
      f5 = Math_fround(HEAPF32[i18 + (i12 * 12 | 0) + 8 >> 2]);
      f4 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) + 8 >> 2]);
      f5 = Math_fround(f5 - f4);
      f3 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(f8 * f16)) + Math_fround(f5 * f17));
      i12 = f3 < Math_fround(0.0);
      f26 = Math_fround(-f3);
      if (!((i12 ? f26 : f3) <= Math_fround(9.99999997e-07))) {
       f3 = Math_fround(Math_fround(Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f15) + Math_fround(f6 * f16)) + Math_fround(f4 * f17))) - f14) / f3);
       if (!(f3 < Math_fround(0.0) | f3 > Math_fround(1.0))) {
        i7 = 17;
        break L12;
       }
      }
     } else if (i7) {
      i7 = 10;
      break L12;
     }
     if (i13) i11 = i2; else break L8;
    }
    i7 = i1 + 1 << 24 >> 24;
    i11 = i19 + ((i1 & 255) * 12 | 0) | 0;
    i12 = i18 + (i12 * 12 | 0) | 0;
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    if (i13) i1 = i7; else {
     i1 = i7;
     break L8;
    }
   }
   if ((i7 | 0) == 10) {
    i7 = i18 + (i12 * 12 | 0) | 0;
    f8 = Math_fround(HEAPF32[i7 >> 2]);
    f6 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) >> 2]);
    f8 = Math_fround(f8 - f6);
    f10 = Math_fround(HEAPF32[i18 + (i12 * 12 | 0) + 4 >> 2]);
    f9 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) + 4 >> 2]);
    f10 = Math_fround(f10 - f9);
    f5 = Math_fround(HEAPF32[i18 + (i12 * 12 | 0) + 8 >> 2]);
    f4 = Math_fround(HEAPF32[i18 + (i11 * 12 | 0) + 8 >> 2]);
    f5 = Math_fround(f5 - f4);
    f3 = Math_fround(Math_fround(Math_fround(f8 * f15) + Math_fround(f10 * f16)) + Math_fround(f5 * f17));
    i12 = f3 < Math_fround(0.0);
    f26 = Math_fround(-f3);
    if (!((i12 ? f26 : f3) <= Math_fround(9.99999997e-07))) {
     f3 = Math_fround(Math_fround(Math_fround(-Math_fround(Math_fround(Math_fround(f6 * f15) + Math_fround(f9 * f16)) + Math_fround(f4 * f17))) - f14) / f3);
     if (!(f3 < Math_fround(0.0) | f3 > Math_fround(1.0))) {
      f8 = Math_fround(f6 + Math_fround(f8 * f3));
      f10 = Math_fround(f9 + Math_fround(f10 * f3));
      f26 = Math_fround(f4 + Math_fround(f5 * f3));
      i12 = i1 & 255;
      HEAPF32[i19 + (i12 * 12 | 0) >> 2] = f8;
      HEAPF32[i19 + (i12 * 12 | 0) + 4 >> 2] = f10;
      HEAPF32[i19 + (i12 * 12 | 0) + 8 >> 2] = f26;
      i12 = HEAP8[i20 >> 0] | 0;
      HEAP8[i20 >> 0] = i12 + 1 << 24 >> 24;
      i12 = i12 & 255;
      HEAPF32[i21 + (i12 * 12 | 0) >> 2] = f8;
      HEAPF32[i21 + (i12 * 12 | 0) + 4 >> 2] = f10;
      HEAPF32[i21 + (i12 * 12 | 0) + 8 >> 2] = f26;
      i1 = i1 + 1 << 24 >> 24;
     }
    }
    i12 = i19 + ((i1 & 255) * 12 | 0) | 0;
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   } else if ((i7 | 0) == 17) {
    f9 = Math_fround(f9 + Math_fround(f10 * f3));
    f10 = Math_fround(f6 + Math_fround(f8 * f3));
    f26 = Math_fround(f4 + Math_fround(f5 * f3));
    i12 = i1 & 255;
    HEAPF32[i19 + (i12 * 12 | 0) >> 2] = f9;
    HEAPF32[i19 + (i12 * 12 | 0) + 4 >> 2] = f10;
    HEAPF32[i19 + (i12 * 12 | 0) + 8 >> 2] = f26;
    i12 = HEAP8[i20 >> 0] | 0;
    HEAP8[i20 >> 0] = i12 + 1 << 24 >> 24;
    i12 = i12 & 255;
    HEAPF32[i21 + (i12 * 12 | 0) >> 2] = f9;
    HEAPF32[i21 + (i12 * 12 | 0) + 4 >> 2] = f10;
    HEAPF32[i21 + (i12 * 12 | 0) + 8 >> 2] = f26;
   }
   i1 = i1 + 1 << 24 >> 24;
  } while (i13);
 } while (0);
 HEAP8[i24 >> 0] = i1;
 i24 = i1 << 24 >> 24 != 0;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN9Transform16CheckConsistencyEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i17);
 i1 = i17 + 40 | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i16 & 2139095040 | 0) == 2139095040) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 i8 = i17 + 44 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i16 & 2139095040 | 0) == 2139095040) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 i7 = i17 + 48 | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i16 & 2139095040 | 0) == 2139095040) {
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  f5 = Math_fround(0.0);
 }
 i4 = i17 + 52 | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i16 & 2139095040 | 0) == 2139095040) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  f6 = Math_fround(0.0);
 }
 i1 = i17 + 56 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i17 + 60 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i17 + 64 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i17 + 68 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i17 + 72 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i17 + 76 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) HEAPF32[i1 >> 2] = Math_fround(0.0);
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
 if (f9 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f6 = Math_fround(1.0);
  f5 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  f6 = Math_fround(f6 / f9);
  f5 = Math_fround(f5 / f9);
  f3 = Math_fround(f3 / f9);
  f2 = Math_fround(f2 / f9);
 }
 HEAPF32[i17 + 40 >> 2] = f2;
 HEAPF32[i8 >> 2] = f3;
 HEAPF32[i7 >> 2] = f5;
 HEAPF32[i4 >> 2] = f6;
 i14 = HEAP32[i17 + 100 >> 2] | 0;
 L34 : do if (i14 | 0) {
  i1 = HEAP32[i14 + 80 >> 2] | 0;
  i15 = i14 + 92 | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  i7 = i1 + (i16 << 2) | 0;
  L36 : do if (i16 | 0) {
   i4 = i1;
   while (1) {
    if ((HEAP32[i4 >> 2] | 0) == (i17 | 0)) break;
    i4 = i4 + 4 | 0;
    if ((i4 | 0) == (i7 | 0)) break L36;
   }
   if ((i4 | 0) != (i7 | 0)) break L34;
  } while (0);
  i7 = i14 + 80 | 0;
  i12 = i17;
  i13 = i16 + 1 | 0;
  i8 = i14 + 96 | 0;
  i10 = HEAP32[i8 >> 2] | 0;
  i11 = i10 & 2147483647;
  do if (i13 >>> 0 > i11 >>> 0) {
   i4 = i10 << 1;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   if (i11 >>> 0 < i4 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i8 >> 2] = i4;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 << 2, 4, i14 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i7 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i14 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i4;
    HEAP32[i7 >> 2] = i1;
    break;
   }
  } while (0);
  HEAP32[i15 >> 2] = i13;
  HEAP32[i1 + (i16 << 2) >> 2] = i12;
 } while (0);
 i15 = i17 + 92 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i13 = i17 + 80 | 0;
 i14 = i17 + 4 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i13 >> 2] | 0;
  i7 = i8 + (i1 << 2) | 0;
  i12 = HEAP32[i7 >> 2] | 0;
  do if (!i12) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 421293 | 0, 0, gb + 421343 | 0, 1299, 1, HEAP32[i14 >> 2] | 0, 0, 0);
   i12 = HEAP32[i13 >> 2] | 0;
   i11 = i12 + (i1 << 2) | 0;
   i16 = i11 + 4 | 0;
   _memmove(i11 | 0, i16 | 0, i12 + (HEAP32[i15 >> 2] << 2) - i16 | 0) | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
   i1 = i1 + -1 | 0;
  } else {
   if ((HEAP32[i12 + 100 >> 2] | 0) != (i17 | 0)) {
    i16 = i7 + 4 | 0;
    _memmove(i7 | 0, i16 | 0, i8 + (i4 << 2) - i16 | 0) | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 421414 | 0, 0, gb + 421343 | 0, 1323, 1, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
    i1 = i1 + -1 | 0;
    break;
   }
   i7 = i1 + 1 | 0;
   if ((i7 | 0) < (i4 | 0)) {
    i11 = 0;
    i10 = i8;
    L61 : while (1) {
     while (1) {
      i8 = i10 + (i7 << 2) | 0;
      if ((HEAP32[i8 >> 2] | 0) == (i12 | 0)) break;
      i7 = i7 + 1 | 0;
      if ((i7 | 0) >= (i4 | 0)) {
       i18 = 43;
       break L61;
      }
     }
     i16 = i8 + 4 | 0;
     _memmove(i8 | 0, i16 | 0, i10 + (i4 << 2) - i16 | 0) | 0;
     i4 = (HEAP32[i15 >> 2] | 0) + -1 | 0;
     HEAP32[i15 >> 2] = i4;
     if ((i7 | 0) >= (i4 | 0)) break;
     i11 = 1;
     i10 = HEAP32[i13 >> 2] | 0;
    }
    if ((i18 | 0) == 43) {
     i18 = 0;
     if (!i11) break;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 421467 | 0, 0, gb + 421343 | 0, 1342, 1, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
   }
  } while (0);
  i1 = i1 + 1 | 0;
  i4 = HEAP32[i15 >> 2] | 0;
 } while ((i1 | 0) < (i4 | 0));
 return;
}

function __ZN14Texture2DArray11InitTextureEiii13TextureFormatb(i13, i3, i2, i9, i11, i10) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 36 | 0;
 i8 = i16 + 24 | 0;
 i7 = i16 + 16 | 0;
 i6 = i16 + 8 | 0;
 i4 = i16;
 i14 = i16 + 32 | 0;
 i5 = __Z15GetGraphicsCapsv() | 0;
 if (!(HEAP8[i5 + 482 >> 0] | 0)) {
  if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417658 | 0, 0, gb + 411289 | 0, 69, 1, i1, 0, 0);
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 if (!(i3 + -1 & i3)) if (!(i2 + -1 & i2)) {
  L11 : do if (!((i11 + -1 | 0) >>> 0 < 23 | (i11 + -10 | 0) >>> 0 < 3)) {
   i1 = i11 | 1;
   switch (i1 | 0) {
   case 25:
   case 27:
    break L11;
   default:
    {}
   }
   if ((i11 + -48 | 0) >>> 0 >= 12) {
    switch (i11 | 0) {
    case 28:
    case 29:
    case 30:
    case 31:
    case 32:
    case 33:
    case 34:
    case 35:
    case 36:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
    case 47:
     break L11;
    default:
     {}
    }
    if ((i1 | 0) != 61) {
     HEAP32[i4 >> 2] = i11;
     __Z6FormatPKcz(i15, gb + 417752 | 0, i4);
     if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 411289 | 0, 81, 1, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
     i15 = 0;
     STACKTOP = i16;
     return i15 | 0;
    }
   }
  } while (0);
  i1 = HEAP32[i5 + 124 >> 2] | 0;
  if ((i3 | 0) < 1 | (i1 | 0) < (i3 | 0)) {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i1;
   __Z6FormatPKcz(i15, gb + 417799 | 0, i6);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 411289 | 0, 87, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  if ((i2 | 0) < 1 | (i1 | 0) < (i2 | 0)) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i7 + 4 >> 2] = i1;
   __Z6FormatPKcz(i15, gb + 417863 | 0, i7);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 411289 | 0, 92, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  i1 = HEAP32[i5 + 136 >> 2] | 0;
  if ((i9 | 0) < 1 | (i1 | 0) < (i9 | 0)) {
   HEAP32[i8 >> 2] = i9;
   HEAP32[i8 + 4 >> 2] = i1;
   __Z6FormatPKcz(i15, gb + 417928 | 0, i8);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 411289 | 0, 97, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  i8 = i13 + 80 | 0;
  HEAP32[i8 >> 2] = i3;
  i12 = i13 + 84 | 0;
  HEAP32[i12 >> 2] = i2;
  i5 = i13 + 88 | 0;
  HEAP32[i5 >> 2] = i9;
  i1 = i13 + 92 | 0;
  HEAP32[i1 >> 2] = i11;
  if (i10) {
   i4 = __Z22CalculateMipMapCount3Diii(i3, i2, 1) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
  } else {
   i4 = 1;
   i1 = i11;
  }
  HEAP32[i13 + 76 >> 2] = i4;
  i7 = __Z21CalculateMipMapOffsetii13TextureFormati(i3, i2, i1, i4) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i3 = ___muldi3(i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0, i7 | 0, 0) | 0;
  i11 = getTempRet0() | 0;
  if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i3 >>> 0 > 2147483647) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417992 | 0, 0, gb + 411289 | 0, 111, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
  if (!i4) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  _memset(i4 | 0, -1, i3 | 0) | 0;
  i5 = i13 + 96 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, gb + 63272 | 0);
  HEAP32[i5 >> 2] = 0;
  i6 = i13 + 100 | 0;
  HEAP32[i6 >> 2] = 0;
  i1 = i13 + 104 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i13 + 108 | 0;
  if (HEAP8[i2 >> 0] | 0) {
   i11 = __Z12GetGfxDevicev() | 0;
   i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 452 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i13 + 48 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   mftCall_vii(i10 | 0, i11 | 0, i15 | 0);
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i5 >> 2] = i4;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i1 >> 2] = i7;
  f18 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i8 >> 2] | 0));
  f17 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i12 >> 2] | 0));
  HEAPF32[i13 + 68 >> 2] = f18;
  HEAPF32[i13 + 72 >> 2] = f17;
  i15 = 1;
  STACKTOP = i16;
  return i15 | 0;
 }
 if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417711 | 0, 0, gb + 411289 | 0, 76, 1, i1, 0, 0);
 i15 = 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i10 = HEAP32[i11 >> 2] | 0;
 i3 = i10;
 i8 = ((HEAP32[i2 >> 2] | 0) - i3 | 0) / 40 | 0;
 i12 = i10 + (i8 * 40 | 0) | 0;
 i9 = i11 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i11 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  if ((i12 | 0) != (i4 | 0)) {
   __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE12__move_rangeEPS4_S8_S8_(i11, i12, i4, i12 + 40 | 0);
   if (i12 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i9 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 40 | 0 : i1;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   i13 = i1 + 8 | 0;
   i11 = HEAP32[i13 + 4 >> 2] | 0;
   i9 = i10 + (i8 * 40 | 0) + 8 | 0;
   HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i9 + 4 >> 2] = i11;
   i9 = i1 + 16 | 0;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i13 = i10 + (i8 * 40 | 0) + 16 | 0;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = i11;
   if ((i12 | 0) == (i1 | 0)) {
    i13 = i12;
    STACKTOP = i14;
    return i13 | 0;
   }
   __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i10 + (i8 * 40 | 0) + 24 | 0, HEAP32[i1 + 24 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0);
   i13 = i12;
   STACKTOP = i14;
   return i13 | 0;
  }
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  i3 = i10 + (i8 * 40 | 0) + 8 | 0;
  i4 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i3 = i10 + (i8 * 40 | 0) + 24 | 0;
  i4 = i1 + 24 | 0;
  HEAP32[i3 >> 2] = 0;
  i7 = i10 + (i8 * 40 | 0) + 28 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 + (i8 * 40 | 0) + 32 >> 2] = 0;
  i5 = i1 + 28 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i2 = i1 >> 2;
  if (i2 | 0) {
   if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i6 = __Znwj(i1) | 0;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i3 >> 2] = i6;
   HEAP32[i10 + (i8 * 40 | 0) + 32 >> 2] = i6 + (i2 << 2);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i7 >> 2] = i6 + (i1 >> 2 << 2);
   }
  }
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 40;
  i13 = i12;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = ((i4 - i3 | 0) / 40 | 0) + 1 | 0;
 if (i4 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i2 = (i2 - i3 | 0) / 40 | 0;
 i5 = i2 << 1;
 i5 = i2 >>> 0 < 53687091 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 107374182;
 i2 = i12 - i3 | 0;
 i4 = (i2 | 0) / 40 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i11 + 8;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 40 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i3 = i6 + (i4 * 40 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i3;
 i9 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = i3;
 i7 = i13 + 12 | 0;
 HEAP32[i7 >> 2] = i6 + (i5 * 40 | 0);
 do if ((i4 | 0) == (i5 | 0)) {
  if ((i2 | 0) > 0) {
   i3 = i3 + (((((i2 >>> 0) / 40 | 0) + 1 | 0) / -2 | 0) * 40 | 0) | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i9 >> 2] = i3;
   break;
  }
  i2 = i5 * 40 | 0;
  i2 = (i2 | 0) == 0 ? 1 : ((i2 | 0) / 40 | 0) << 1;
  if (!i2) i4 = 0; else i4 = __Znwj(i2 * 40 | 0) | 0;
  i3 = i4 + ((i2 >>> 2) * 40 | 0) | 0;
  i8 = i3;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i8;
  HEAP32[i7 >> 2] = i4 + (i2 * 40 | 0);
  if (i6) __ZdlPv(i6);
 } while (0);
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i4 = i3 + 8 | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = i3 + 24 | 0;
 i5 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i3 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i6 = i1 + 28 | 0;
 i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 if (i2 | 0) {
  if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i7 = __Znwj(i1) | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i3 + 32 >> 2] = i7 + (i2 << 2);
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i7 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i8 >> 2] = i7 + (i1 >> 2 << 2);
  }
 }
 HEAP32[i10 >> 2] = i3 + 40;
 i6 = __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS4_RS6_EEPS4_(i11, i13, i12) | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = i1 + -40 | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = HEAP32[i1 + -16 >> 2] | 0;
  i4 = i3;
  if (!i3) i1 = i2; else {
   i1 = i1 + -12 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i3);
   i1 = HEAP32[i10 >> 2] | 0;
  }
 } while ((i1 | 0) != (i5 | 0));
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 i13 = i6;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = i8 + 28 | 0;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i9, i8 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i1 = i8 + 52 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i9, i8 + 56 | 0, 0);
 HEAP8[i5 >> 0] = HEAP32[i8 >> 2];
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 >> 2] = i1 << 24 >> 24;
 i4 = i8 + 4 | 0;
 HEAP8[i5 >> 0] = HEAP32[i4 >> 2];
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 >> 2] = i1 << 24 >> 24;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i3 = i8 + 108 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 112 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 120 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 124 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 132 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 136 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i9, i8 + 156 | 0, 0);
 i3 = i8 + 168 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 172 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i7 = i8 + 180 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i9, i7, 0);
  i8 = i8 + 144 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i9, i8, 0);
  STACKTOP = i10;
  return;
 }
 do {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i8 + 180 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i9, i7, 0);
 i8 = i8 + 144 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i9, i8, 0);
 STACKTOP = i10;
 return;
}

function __ZN2UI13RectTransform10SmartResetEv(i12) {
 i12 = i12 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i3 = i13 + 8 | 0;
 i9 = i13;
 i2 = HEAP32[i12 + 28 >> 2] | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 31792 | 0) | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 i5 = HEAP32[i2 + 340 >> 2] | 0;
 do if (i5 | 0) {
  HEAP32[i3 >> 2] = i5;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i11 = 9; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i3);
    i3 = HEAP32[i10 >> 2] | 0;
    i14 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 9; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i11 = 11;
   }
  }
  if ((i11 | 0) == 9) i11 = 11;
  if ((i11 | 0) == 11) {
   i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   if (!i2) break;
  }
  f6 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  f1 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  f8 = Math_fround(HEAPF32[i2 + 140 >> 2]);
  f6 = Math_fround(f6 / f8);
  f8 = Math_fround(f1 / f8);
  i5 = i12 + 160 | 0;
  f1 = Math_fround(HEAPF32[i5 >> 2]);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i4 ^ i3 | 0) > -1) {
   i14 = ((i3 | 0) < 0 ? -2147483648 - i3 | 0 : i3) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
   if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) > 10) i11 = 18; else i11 = 15;
  } else if (f1 == f6) i11 = 15; else i11 = 18;
  do if ((i11 | 0) == 15) {
   f1 = Math_fround(HEAPF32[i12 + 164 >> 2]);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i3 ^ i4 | 0) > -1) {
    i14 = ((i3 | 0) < 0 ? -2147483648 - i3 | 0 : i3) - ((i4 | 0) < 0 ? -2147483648 - i4 | 0 : i4) | 0;
    if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) < 11) break; else {
     i11 = 18;
     break;
    }
   } else if (f1 == f8) break; else {
    i11 = 18;
    break;
   }
  } while (0);
  if ((i11 | 0) == 18) {
   HEAPF32[i5 >> 2] = f6;
   HEAPF32[i12 + 164 >> 2] = f8;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i12, 1, 0);
  }
  if (!(f6 != Math_fround(0.0) & f8 != Math_fround(0.0))) {
   STACKTOP = i13;
   return;
  }
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  __ZNK6Sprite9GetBoundsE8Vector2fbb(i10, i2, i9, 0, 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i10 + 12 >> 2]));
  f1 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f7 = Math_fround(Math_fround(-f7) / f6);
  f6 = Math_fround(Math_fround(-Math_fround(f1 - Math_fround(HEAPF32[i10 + 16 >> 2]))) / f8);
  i4 = i12 + 168 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i2 ^ i3 | 0) > -1) {
   i14 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i3 | 0) < 0 ? -2147483648 - i3 | 0 : i3) | 0;
   if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) > 10) i11 = 26; else i11 = 23;
  } else if (f1 == f7) i11 = 23; else i11 = 26;
  do if ((i11 | 0) == 23) {
   f1 = Math_fround(HEAPF32[i12 + 172 >> 2]);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   if ((i2 ^ i3 | 0) > -1) {
    i14 = ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) - ((i3 | 0) < 0 ? -2147483648 - i3 | 0 : i3) | 0;
    if ((((i14 | 0) < 0 ? 0 - i14 | 0 : i14) | 0) < 11) break; else {
     i11 = 26;
     break;
    }
   } else if (f1 == f6) break; else {
    i11 = 26;
    break;
   }
  } while (0);
  if ((i11 | 0) == 26) {
   HEAPF32[i4 >> 2] = f7;
   HEAPF32[i12 + 172 >> 2] = f6;
   __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i12, 1, 0);
  }
  STACKTOP = i13;
  return;
 } while (0);
 i3 = i12 + 160 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i2 | 0) > -1) {
  if ((((i2 | 0) < 1065353216 ? 1065353216 - i2 | 0 : i2 + -1065353216 | 0) | 0) <= 10) i11 = 31;
 } else if (f1 == Math_fround(1.0)) i11 = 31;
 do if ((i11 | 0) == 31) {
  f1 = Math_fround(HEAPF32[i12 + 164 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i2 | 0) > -1) {
   if ((((i2 | 0) < 1065353216 ? 1065353216 - i2 | 0 : i2 + -1065353216 | 0) | 0) >= 11) break;
   STACKTOP = i13;
   return;
  } else {
   if (!(f1 == Math_fround(1.0))) break;
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i3 >> 2] = 1065353216;
 HEAP32[i12 + 164 >> 2] = 1065353216;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i12, 1, 0);
 STACKTOP = i13;
 return;
}

function __ZN19ShaderPropertySheet38CopyTextureWithAuxiliaryPropertiesFromERKN9ShaderLab16FastPropertyNameERKS_(i15, i9, i14) {
 i15 = i15 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i1 = HEAP32[i14 + 20 >> 2] | 0;
 i3 = HEAP32[i14 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i3 | 0)) {
  i4 = HEAP32[i14 + 32 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i1 = -1;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i1 = HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i1 = -1;
 } else i1 = -1; while (0);
 i13 = i14 + 72 | 0;
 i12 = (HEAP32[i13 >> 2] | 0) + i1 | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = -1;
 HEAP32[i5 + 8 >> 2] = -1;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i7 = HEAP32[i12 + 8 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i12 + 16 >> 2];
 i1 = HEAP32[i15 + 20 >> 2] | 0;
 i2 = HEAP32[i15 + 24 >> 2] | 0;
 L9 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i15 + 32 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i11 = 13;
    break L9;
   }
  }
  if ((i1 | 0) > -1) i1 = HEAP32[(HEAP32[i15 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i11 = 13;
 } else i11 = 13; while (0);
 if ((i11 | 0) == 13) i1 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i15, i9, 0) | 0;
 i1 = (HEAP32[i15 + 72 >> 2] | 0) + i1 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i1 + 12 >> 2] = i8;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i7 = HEAP32[i14 + 12 >> 2] | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i5 = i1 + i7 | 0;
  i2 = (HEAP32[i14 + 32 >> 2] | 0) + (i5 << 2) | 0;
  i6 = i14 + 52 | 0;
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i15, i2, (HEAP32[i13 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] & 1048575) | 0, 0);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i3 = HEAP32[i15 + 16 >> 2] | 0;
  L21 : do if ((i1 | 0) < (i3 | 0)) {
   i4 = HEAP32[i15 + 32 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
     i3 = i1;
     break L21;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i3 = -1;
     break;
    }
   }
  } else i3 = -1; while (0);
  i2 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 & 1073741824) {
   i1 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1073741824;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if ((i1 | 0) < 0) {
   i11 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | -2147483648;
  }
 }
 i1 = HEAP32[i12 + 24 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i5 = i1 + i7 | 0;
  i2 = (HEAP32[i14 + 32 >> 2] | 0) + (i5 << 2) | 0;
  i6 = i14 + 52 | 0;
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i15, i2, (HEAP32[i13 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] & 1048575) | 0, 0);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i3 = HEAP32[i15 + 16 >> 2] | 0;
  L34 : do if ((i1 | 0) < (i3 | 0)) {
   i4 = HEAP32[i15 + 32 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
     i3 = i1;
     break L34;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i3 = -1;
     break;
    }
   }
  } else i3 = -1; while (0);
  i2 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 & 1073741824) {
   i1 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1073741824;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if ((i1 | 0) < 0) {
   i11 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | -2147483648;
  }
 }
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i16;
  return;
 }
 i6 = i1 + i7 | 0;
 i2 = (HEAP32[i14 + 32 >> 2] | 0) + (i6 << 2) | 0;
 i5 = i14 + 52 | 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i15, i2, (HEAP32[i13 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 << 2) >> 2] & 1048575) | 0, 0);
 i1 = HEAP32[i15 + 12 >> 2] | 0;
 i3 = HEAP32[i15 + 16 >> 2] | 0;
 L48 : do if ((i1 | 0) < (i3 | 0)) {
  i4 = HEAP32[i15 + 32 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
    i3 = i1;
    break L48;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i3 = -1;
    break;
   }
  }
 } else i3 = -1; while (0);
 i2 = (HEAP32[i5 >> 2] | 0) + (i6 << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 1073741824) {
  i1 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1073741824;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) >= 0) {
  STACKTOP = i16;
  return;
 }
 i15 = (HEAP32[i15 + 52 >> 2] | 0) + (i3 << 2) | 0;
 HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | -2147483648;
 STACKTOP = i16;
 return;
}

function __ZN13SplatDatabase8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932752 | 0, i2, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SplatPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i9, i7, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932761 | 0, i2, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i9, i3, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 36 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932777 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932798 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932818 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i3 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i3;
   if (i3 >>> 0 < i5 >>> 0) i6 = 40; else {
    i1 = i3 + 4 | 0;
    if (i1 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 >> 2] = i1;
    }
   }
   if ((i6 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 48 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932831 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 49 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932858 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN8GUIStyle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 16 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 20 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 36 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 40 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 56 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 60 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 76 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 80 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 96 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 100 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 116 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 120 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 136 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 140 | 0, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 156 | 0, i6);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 160 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 176 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 192 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 208 | 0, i6);
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 224 | 0, i6);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 240 | 0, i6);
 i1 = i5 + 284 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 288 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 244 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 248 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 249 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 252 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 256 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 260 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 264 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 276 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 280 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 292 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 293 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i4 + 28 | 0;
 i20 = i4;
 i5 = i3 + 76 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i21 >> 2] | 0) + 32 >> 2] | 0, i21 | 0, i1 | 0, i2 | 0);
 i21 = i3 + 80 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i23, i3, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i23 + 4 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i23 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i23 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 + 20 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAPF32[i23 + 24 >> 2])) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f10 * f10) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f6 * f8)) + Math_fround(f11 * f18));
 f12 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f19 * f13) + Math_fround(f10 * Math_fround(Math_fround(f11 * f8) - Math_fround(f6 * f18)))));
 f15 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f10 * Math_fround(Math_fround(f13 * f18) - Math_fround(f11 * f7)))));
 f16 = Math_fround(Math_fround(Math_fround(f19 * f11) + Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f13 * f8)))) + Math_fround(f16 * f18));
 f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f7));
 f19 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f8));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f11 * f8) + Math_fround(f10 * f9))) - Math_fround(f19 * f7));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(Math_fround(f11 * f18) + Math_fround(f10 * f19))) - Math_fround(f13 * f8));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f7)) - Math_fround(f9 * f8)) - Math_fround(f19 * f18));
 HEAPF32[i22 >> 2] = Math_fround(f6 - Math_fround(f9 * f18));
 HEAPF32[i22 + 4 >> 2] = f14;
 HEAPF32[i22 + 8 >> 2] = f17;
 HEAPF32[i22 + 12 >> 2] = f19;
 HEAPF32[i22 + 16 >> 2] = f12;
 HEAPF32[i22 + 20 >> 2] = f15;
 HEAPF32[i22 + 24 >> 2] = f16;
 i1 = HEAP32[i21 >> 2] | 0;
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i3, i2);
 f16 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 64 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f17 = Math_fround(f17 * Math_fround(2.0));
 f14 = Math_fround(f14 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f14 * f15)) + Math_fround(f18 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f9 * f17) + Math_fround(f19 * Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f9 * f14) + Math_fround(f19 * Math_fround(Math_fround(f17 * f12) - Math_fround(f18 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f18) + Math_fround(f19 * Math_fround(Math_fround(f14 * f16) - Math_fround(f17 * f15)))) + Math_fround(f6 * f12));
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f14 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f16));
 f9 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f9 * f15));
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(Math_fround(f18 * f15) + Math_fround(f19 * f13))) - Math_fround(f9 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f9))) - Math_fround(f17 * f15));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f13 * f15)) - Math_fround(f9 * f12));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f14 - Math_fround(f13 * f12));
 HEAPF32[i1 + 32 >> 2] = f11;
 HEAPF32[i1 + 36 >> 2] = f10;
 HEAPF32[i1 + 40 >> 2] = f9;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = f7;
 HEAPF32[i1 + 52 >> 2] = f6;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setCMassLocalPoseInternalERKNS_11PxTransformE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 28 | 0;
 i7 = i13;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i12 | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) * Math_fround(2.0));
 i9 = i11 + 20 | 0;
 f20 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
 i5 = i11 + 24 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
 f27 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f26 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f25 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f24 * f25);
 f23 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f23));
 f21 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f17 * f21));
 f16 = Math_fround(Math_fround(f25 * f14) + Math_fround(Math_fround(f24 * f26) + Math_fround(f27 * Math_fround(Math_fround(f17 * f23) - Math_fround(f20 * f21)))));
 f15 = Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f20 * f26) + Math_fround(f27 * Math_fround(Math_fround(f24 * f21) - Math_fround(f17 * f25)))));
 f14 = Math_fround(Math_fround(Math_fround(f17 * f26) + Math_fround(f27 * Math_fround(Math_fround(f20 * f25) - Math_fround(f24 * f23)))) + Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f16);
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f15);
 f14 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f14);
 f24 = Math_fround(HEAPF32[i11 >> 2]);
 f20 = Math_fround(f27 * f24);
 i7 = i11 + 12 | 0;
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f25 * f26));
 i8 = i11 + 8 | 0;
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f23 * f17));
 i10 = i11 + 4 | 0;
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(f20 - Math_fround(f21 * f22));
 f19 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f23 * f26) + Math_fround(f27 * f22))) - Math_fround(f25 * f17));
 f18 = Math_fround(Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f21 * f26) + Math_fround(f27 * f17))) - Math_fround(f23 * f24));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24)) - Math_fround(f23 * f22)) - Math_fround(f21 * f17));
 HEAPF32[i1 >> 2] = f20;
 HEAPF32[i1 + 4 >> 2] = f19;
 HEAPF32[i1 + 8 >> 2] = f18;
 HEAPF32[i1 + 12 >> 2] = f17;
 HEAPF32[i1 + 16 >> 2] = f16;
 HEAPF32[i1 + 20 >> 2] = f15;
 HEAPF32[i1 + 24 >> 2] = f14;
 i6 = i12 + 48 | 0;
 HEAPF32[i12 + 224 >> 2] = f20;
 HEAPF32[i12 + 228 >> 2] = f19;
 HEAPF32[i12 + 232 >> 2] = f18;
 HEAPF32[i12 + 236 >> 2] = f17;
 HEAPF32[i12 + 240 >> 2] = f16;
 HEAPF32[i12 + 244 >> 2] = f15;
 HEAPF32[i12 + 248 >> 2] = f14;
 i3 = i12 + 52 | 0;
 switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i12 + 64 | 0, i1); else if ((i2 | 0) == 4) {
  i1 = i12 + 284 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & 262144)) HEAP32[i1 >> 2] = i2 | 524288;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i6 >> 2] | 0, i6);
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 262144;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   i2 = 11;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 10; else {
    i4 = i6;
    i2 = 11;
   }
   break;
  }
 default:
  i2 = 10;
 }
 if ((i2 | 0) == 10) {
  HEAP32[i12 + 112 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 116 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 120 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 124 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 128 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i12 + 132 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 136 >> 2] = HEAP32[i5 >> 2];
 } else if ((i2 | 0) == 11) {
  i2 = i12 + 56 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP32[i1 + 144 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 148 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 152 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 156 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 160 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 164 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 168 >> 2] = HEAP32[i5 >> 2];
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
  i11 = i12 + 284 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 512;
 }
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i1 = 0;
 while (1) {
  if (!(HEAP8[i3 + (i1 << 3) >> 0] | 0)) {
   i2 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   if (!i2) {
    i2 = 21;
    break;
   }
   __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE(i2, i12);
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i2 = 21;
   break;
  }
 }
 if ((i2 | 0) == 21) {
  STACKTOP = i13;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIR24RayHitsByDepthComparitorP12RaycastHit2DEEbT0_S5_T_(i22, i24, i1) {
 i22 = i22 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25 + 20 | 0;
 i20 = i25;
 switch ((i24 - i22 | 0) / 36 | 0 | 0) {
 case 2:
  {
   i7 = i24 + -36 | 0;
   __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i24 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f26 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i22 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   if (!(f26 < Math_fround(HEAPF32[i21 + 8 >> 2]))) {
    i24 = 1;
    STACKTOP = i25;
    return i24 | 0;
   }
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i22 + 4 >> 2] | 0;
   i3 = HEAP32[i22 + 8 >> 2] | 0;
   i4 = HEAP32[i22 + 12 >> 2] | 0;
   i5 = HEAP32[i22 + 16 >> 2] | 0;
   i6 = HEAP32[i22 + 20 >> 2] | 0;
   i12 = i22 + 24 | 0;
   HEAP32[i23 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i12 = i22;
   i13 = i7;
   i14 = i12 + 36 | 0;
   do {
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    i12 = i12 + 4 | 0;
    i13 = i13 + 4 | 0;
   } while ((i12 | 0) < (i14 | 0));
   HEAP32[i7 >> 2] = i1;
   HEAP32[i24 + -32 >> 2] = i2;
   HEAP32[i24 + -28 >> 2] = i3;
   HEAP32[i24 + -24 >> 2] = i4;
   HEAP32[i24 + -20 >> 2] = i5;
   HEAP32[i24 + -16 >> 2] = i6;
   i24 = i24 + -12 | 0;
   HEAP32[i24 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i24 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i22, i22 + 36 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i22, i22 + 36 | 0, i22 + 72 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_(i22, i22 + 36 | 0, i22 + 72 | 0, i22 + 108 | 0, i24 + -36 | 0, i1) | 0;
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 case 1:
 case 0:
  {
   i24 = 1;
   STACKTOP = i25;
   return i24 | 0;
  }
 default:
  {
   i2 = i22 + 72 | 0;
   __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i22, i22 + 36 | 0, i2, i1) | 0;
   i1 = i22 + 108 | 0;
   L3 : do if ((i1 | 0) == (i24 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i16 = i23 + 8 | 0;
    i17 = i21 + 8 | 0;
    i18 = i23 + 8 | 0;
    i19 = i21 + 8 | 0;
    i15 = i1;
    i1 = 0;
    while (1) {
     __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i15 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f26 = Math_fround(HEAPF32[i16 >> 2]);
     __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f26 < Math_fround(HEAPF32[i17 >> 2])) {
      i6 = HEAP32[i15 >> 2] | 0;
      i7 = HEAP32[i15 + 4 >> 2] | 0;
      i8 = HEAP32[i15 + 8 >> 2] | 0;
      i9 = HEAP32[i15 + 12 >> 2] | 0;
      i10 = HEAP32[i15 + 16 >> 2] | 0;
      i11 = HEAP32[i15 + 20 >> 2] | 0;
      i3 = i15 + 24 | 0;
      i4 = HEAP32[i3 + 4 >> 2] | 0;
      i5 = i20;
      HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      i5 = HEAP32[i15 + 32 >> 2] | 0;
      i4 = i5 + 28 | 0;
      i3 = i15;
      while (1) {
       i12 = i3;
       i13 = i2;
       i14 = i12 + 36 | 0;
       do {
        HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
        i12 = i12 + 4 | 0;
        i13 = i13 + 4 | 0;
       } while ((i12 | 0) < (i14 | 0));
       if ((i2 | 0) == (i22 | 0)) {
        i2 = i22;
        break;
       }
       __ZNK9Transform11GetPositionEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0);
       f26 = Math_fround(HEAPF32[i18 >> 2]);
       __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
       if (f26 < Math_fround(HEAPF32[i19 >> 2])) {
        i3 = i2;
        i2 = i2 + -36 | 0;
       } else break;
      }
      HEAP32[i2 >> 2] = i6;
      HEAP32[i2 + 4 >> 2] = i7;
      HEAP32[i2 + 8 >> 2] = i8;
      HEAP32[i2 + 12 >> 2] = i9;
      HEAP32[i2 + 16 >> 2] = i10;
      HEAP32[i2 + 20 >> 2] = i11;
      i12 = i20;
      i13 = HEAP32[i12 + 4 >> 2] | 0;
      i14 = i2 + 24 | 0;
      HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i14 + 4 >> 2] = i13;
      HEAP32[i2 + 32 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i15 + 36 | 0) == (i24 | 0);
       break L3;
      }
     }
     i2 = i15 + 36 | 0;
     if ((i2 | 0) == (i24 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i14 = i15;
      i15 = i2;
      i2 = i14;
     }
    }
   } while (0);
   i24 = i1 | i2;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 return 0;
}

function __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i11 + 28 | 0;
 i9 = i12 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN9ShaderLab22SerializedBindChannels8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 32 | 0, i12);
 i4 = i11 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i11 + 56 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i7 << 1) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i11 >> 2] & 255;
 HEAP8[i8 >> 0] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  i3 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
  i3 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = HEAP8[i8 >> 0];
 i1 = i11 + 4 | 0;
 i2 = HEAP32[i1 >> 2] & 255;
 HEAP8[i8 >> 0] = i2;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = i2;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
 HEAP32[i1 >> 2] = HEAP8[i8 >> 0];
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 i3 = i11 + 108 | 0;
 i7 = i11 + 112 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 120 | 0;
 i7 = i11 + 124 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i11 + 132 | 0;
 i7 = i11 + 136 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 5;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i12, i11 + 156 | 0, 0);
 i3 = i11 + 168 | 0;
 i7 = i11 + 172 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 48 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  i10 = i11 + 180 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i12, i10, 0);
  i11 = i11 + 144 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i12, i11, 0);
  STACKTOP = i13;
  return;
 }
 do {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i10 = i11 + 180 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i12, i10, 0);
 i11 = i11 + 144 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i12, i11, 0);
 STACKTOP = i13;
 return;
}

function __ZN9AudioClip10InitStreamEP10IWWWStreamPKcP13MoviePlaybackbb15FMOD_SOUND_TYPE(i16, i7, i5, i15, i9, i10, i2) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 8 | 0;
 i6 = i17;
 i13 = i17 + 36 | 0;
 i14 = i17 + 24 | 0;
 i4 = i17 + 12 | 0;
 __ZN9AudioClip16EnableLegacyModeEv(i16);
 if (i7 | 0) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, _strlen(i5) | 0);
  __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i13, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i13);
  i8 = i14 + 11 | 0;
  i18 = HEAP8[i8 >> 0] | 0;
  i1 = i18 << 24 >> 24 < 0;
  i3 = i14 + 4 | 0;
  if ((i1 ? HEAP32[i3 >> 2] | 0 : i18 & 255) | 0) {
   i1 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
   do {
    i19 = HEAP8[i1 >> 0] | 0;
    i18 = i19 << 24 >> 24;
    HEAP8[i1 >> 0] = (i19 + -65 & 255) < 26 ? i18 + 32 | 0 : i18;
    i1 = i1 + 1 | 0;
    i18 = HEAP8[i8 >> 0] | 0;
    i19 = i18 << 24 >> 24 < 0;
   } while ((i1 | 0) != ((i19 ? HEAP32[i14 >> 2] | 0 : i14) + (i19 ? HEAP32[i3 >> 2] | 0 : i18 & 255) | 0));
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  if (!i2) {
   i2 = __ZN9AudioClip22GetFormatFromExtensionERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i14) | 0;
   i3 = i16 + 124 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   if (!i2) {
    HEAP32[i6 >> 2] = i5;
    __Z6FormatPKcz(i13, gb + 870493 | 0, i6);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 854464 | 0, 344, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i19 = 0;
    STACKTOP = i17;
    return i19 | 0;
   }
  } else {
   i3 = i16 + 124 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
  }
  L14 : do if (i9) {
   switch (i2 | 0) {
   case 14:
    {
     i12 = 19;
     break L14;
    }
   case 17:
   case 12:
   case 10:
   case 21:
    break;
   default:
    break L14;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 870573 | 0, 0, gb + 854464 | 0, 354, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i19 = 0;
   STACKTOP = i17;
   return i19 | 0;
  } else if ((i2 | 0) == 14) i12 = 19; while (0);
  if ((i12 | 0) == 19) {
   HEAP32[i11 >> 2] = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
   __Z6FormatPKcz(i13, gb + 870685 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 854464 | 0, 375, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i19 = 0;
   STACKTOP = i17;
   return i19 | 0;
  }
  HEAP32[i1 + 36 >> 2] = i7;
  HEAP8[i1 + 40 >> 0] = 1;
  HEAP8[i1 + 80 >> 0] = i9 & 1;
  HEAP8[i1 + 81 >> 0] = i10 & 1;
  i1 = HEAP32[i3 >> 2] | 0;
  i7 = i1 + 8 | 0;
  i8 = i1 + 16 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (((HEAP32[i8 >> 2] | 0) - i2 | 0) >>> 0 < 65536) {
   i9 = i1 + 20 | 0;
   i6 = i1 + 12 | 0;
   i4 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP32[i13 >> 2] = 27;
   HEAP32[i13 + 4 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(65536, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i4 = i3 + i4 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) - i1 | 0;
   i5 = i4 + (0 - i2) | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i5 | 0, i1 | 0, i2 | 0) | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   HEAP32[i7 >> 2] = i5;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i8 >> 2] = i3 + 65536;
   if (i1 | 0) {
    i19 = HEAP32[i9 >> 2] | 0;
    HEAP32[i13 >> 2] = 27;
    HEAP32[i13 + 4 >> 2] = i19;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
   }
  }
  __ZN9AudioClip9LoadSoundEv(i16) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 }
 do if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  __ZN9AudioClip16EnableLegacyModeEv(i16);
  i3 = i16 + 124 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 44 >> 2] = i15;
  if (!i15) {
   i19 = 1;
   STACKTOP = i17;
   return i19 | 0;
  }
  HEAP8[i1 + 40 >> 0] = 1;
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  if (i2) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = 0;
  }
  HEAP32[i16 + 36 >> 2] = 1;
  HEAP32[i16 + 32 >> 2] = 22050;
  HEAP32[i16 + 40 >> 2] = 16;
  HEAP32[i1 + 4 >> 2] = 2;
  HEAP32[i1 >> 2] = 16;
  HEAP32[i1 + 48 >> 2] = 3;
 } else if (!i15) {
  i19 = 1;
  STACKTOP = i17;
  return i19 | 0;
 } else {
  i1 = HEAP32[i16 + 124 >> 2] | 0;
  break;
 } while (0);
 HEAP8[i1 + 40 >> 0] = 1;
 __ZN9AudioClip9LoadSoundEv(i16) | 0;
 i19 = 1;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setCMassLocalPoseInternalERKNS_11PxTransformE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 28 | 0;
 i7 = i13;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i12 | 0);
 f24 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) * Math_fround(2.0));
 i9 = i11 + 20 | 0;
 f20 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
 i5 = i11 + 24 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(2.0));
 f27 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f26 = Math_fround(Math_fround(f27 * f27) + Math_fround(-.5));
 f25 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f24 * f25);
 f23 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f23));
 f21 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f17 * f21));
 f16 = Math_fround(Math_fround(f25 * f14) + Math_fround(Math_fround(f24 * f26) + Math_fround(f27 * Math_fround(Math_fround(f17 * f23) - Math_fround(f20 * f21)))));
 f15 = Math_fround(Math_fround(f23 * f14) + Math_fround(Math_fround(f20 * f26) + Math_fround(f27 * Math_fround(Math_fround(f24 * f21) - Math_fround(f17 * f25)))));
 f14 = Math_fround(Math_fround(Math_fround(f17 * f26) + Math_fround(f27 * Math_fround(Math_fround(f20 * f25) - Math_fround(f24 * f23)))) + Math_fround(f21 * f14));
 f16 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f16);
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f15);
 f14 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f14);
 f24 = Math_fround(HEAPF32[i11 >> 2]);
 f20 = Math_fround(f27 * f24);
 i7 = i11 + 12 | 0;
 f26 = Math_fround(HEAPF32[i7 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f25 * f26));
 i8 = i11 + 8 | 0;
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f23 * f17));
 i10 = i11 + 4 | 0;
 f22 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(f20 - Math_fround(f21 * f22));
 f19 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f23 * f26) + Math_fround(f27 * f22))) - Math_fround(f25 * f17));
 f18 = Math_fround(Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f21 * f26) + Math_fround(f27 * f17))) - Math_fround(f23 * f24));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24)) - Math_fround(f23 * f22)) - Math_fround(f21 * f17));
 HEAPF32[i1 >> 2] = f20;
 HEAPF32[i1 + 4 >> 2] = f19;
 HEAPF32[i1 + 8 >> 2] = f18;
 HEAPF32[i1 + 12 >> 2] = f17;
 HEAPF32[i1 + 16 >> 2] = f16;
 HEAPF32[i1 + 20 >> 2] = f15;
 HEAPF32[i1 + 24 >> 2] = f14;
 i6 = i12 + 48 | 0;
 HEAPF32[i12 + 224 >> 2] = f20;
 HEAPF32[i12 + 228 >> 2] = f19;
 HEAPF32[i12 + 232 >> 2] = f18;
 HEAPF32[i12 + 236 >> 2] = f17;
 HEAPF32[i12 + 240 >> 2] = f16;
 HEAPF32[i12 + 244 >> 2] = f15;
 HEAPF32[i12 + 248 >> 2] = f14;
 i3 = i12 + 52 | 0;
 switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i12 + 64 | 0, i1); else if ((i2 | 0) == 4) {
  i1 = i12 + 284 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & 262144)) HEAP32[i1 >> 2] = i2 | 524288;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i6 >> 2] | 0, i6);
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 262144;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   i2 = 11;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 10; else {
    i4 = i6;
    i2 = 11;
   }
   break;
  }
 default:
  i2 = 10;
 }
 if ((i2 | 0) == 10) {
  HEAP32[i12 + 112 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 116 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 120 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 124 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 128 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i12 + 132 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i12 + 136 >> 2] = HEAP32[i5 >> 2];
 } else if ((i2 | 0) == 11) {
  i2 = i12 + 56 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP32[i1 + 144 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 148 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 152 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 156 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 160 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i1 + 164 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 168 >> 2] = HEAP32[i5 >> 2];
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
  i11 = i12 + 284 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 512;
 }
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i1 = 0;
 while (1) {
  if (!(HEAP8[i3 + (i1 << 3) >> 0] | 0)) {
   i2 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   if (!i2) {
    i2 = 21;
    break;
   }
   __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE(i2, i12);
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i2 = 21;
   break;
  }
 }
 if ((i2 | 0) == 21) {
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx2Gu15MeshRayCollider7collideILi0ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i10, i8, f13, i7, i14, i12, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 f13 = Math_fround(f13);
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 264 | 0;
 i15 = i16;
 i3 = i16 + 252 | 0;
 i4 = i16 + 240 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i1 = i6 + 16 | 0;
 i5 = i6 + 8 | 0;
 i6 = i6 + 12 | 0;
 if (f13 == Math_fround(0.0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  HEAP32[i15 + 8 >> 2] = i14;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i9;
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i9;
  i10 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i10;
  i20 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i20;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i5;
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i8;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f13;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i7 = i15 + 84 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i12 + 4 >> 2] | 0) == 1 & 1;
  i12 = i15 + 180 | 0;
  HEAP8[i12 >> 0] = 0;
  HEAP32[i15 + 208 >> 2] = i6;
  HEAP32[i15 + 212 >> 2] = i9;
  HEAP32[i15 + 216 >> 2] = i10;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i20;
  HEAP32[i15 + 228 >> 2] = i5;
  HEAP32[i15 + 232 >> 2] = i8;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i3 + 4 >> 2] = i9;
  HEAP32[i3 + 8 >> 2] = i10;
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  HEAPF32[i4 >> 2] = f19;
  HEAPF32[i4 + 4 >> 2] = f18;
  HEAPF32[i4 + 8 >> 2] = f13;
  __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i14, i3, i4, 4, i11, i15 + 4 | 0);
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  if (HEAP8[i12 >> 0] | 0) {
   i20 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 86012 + 8;
  HEAP32[i17 >> 2] = gb + 86012 + 32;
  HEAP32[i15 + 8 >> 2] = i14;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i9;
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  i22 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i22;
  i21 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i21;
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i3;
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i4;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i5;
  i6 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i6;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f13;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i20 = i15 + 84 | 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  HEAP32[i20 + 16 >> 2] = 0;
  HEAP32[i20 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i12 + 4 >> 2] | 0) == 1 & 1;
  i20 = i15 + 180 | 0;
  HEAP8[i20 >> 0] = 0;
  HEAP32[i15 + 208 >> 2] = i22;
  HEAP32[i15 + 212 >> 2] = i21;
  HEAP32[i15 + 216 >> 2] = i3;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i4;
  HEAP32[i15 + 228 >> 2] = i5;
  HEAP32[i15 + 232 >> 2] = i6;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  __ZNK5physx2Gu5RTree11traverseRayILi0EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(HEAP32[i14 + 4 >> 2] | 0, i10, i8, 4, i11, i15, i9, f13);
  HEAP32[i15 >> 2] = gb + 86012 + 8;
  HEAP32[i17 >> 2] = gb + 86012 + 32;
  if (HEAP8[i20 >> 0] | 0) {
   i22 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx2Gu15MeshRayCollider7collideILi0ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_(i10, i8, f13, i7, i14, i12, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 f13 = Math_fround(f13);
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 264 | 0;
 i15 = i16;
 i3 = i16 + 252 | 0;
 i4 = i16 + 240 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i1 = i6 + 16 | 0;
 i5 = i6 + 8 | 0;
 i6 = i6 + 12 | 0;
 if (f13 == Math_fround(0.0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  HEAP32[i15 + 8 >> 2] = i14;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i9;
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i6;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i9;
  i10 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i10;
  i20 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i20;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i5;
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i8;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f13;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i7 = i15 + 84 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i12 + 4 >> 2] | 0) == 1 & 1;
  i12 = i15 + 180 | 0;
  HEAP8[i12 >> 0] = 0;
  HEAP32[i15 + 208 >> 2] = i6;
  HEAP32[i15 + 212 >> 2] = i9;
  HEAP32[i15 + 216 >> 2] = i10;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i20;
  HEAP32[i15 + 228 >> 2] = i5;
  HEAP32[i15 + 232 >> 2] = i8;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  i14 = HEAP32[i14 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i3 + 4 >> 2] = i9;
  HEAP32[i3 + 8 >> 2] = i10;
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(0.0));
  HEAPF32[i4 >> 2] = f19;
  HEAPF32[i4 + 4 >> 2] = f18;
  HEAPF32[i4 + 8 >> 2] = f13;
  __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i14, i3, i4, 4, i11, i15 + 4 | 0);
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  if (HEAP8[i12 >> 0] | 0) {
   i20 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  i17 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  HEAP32[i15 + 8 >> 2] = i14;
  i2 = i15 + 12 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i15 + 16 >> 2] = i1;
  HEAP32[i15 + 20 >> 2] = i5;
  HEAP32[i15 + 24 >> 2] = i6;
  HEAP32[i15 + 28 >> 2] = i9;
  i1 = HEAP32[i14 + 8 >> 2] | 0;
  i22 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 + 32 >> 2] = i22;
  i21 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i15 + 36 >> 2] = i21;
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = i3;
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 + 44 >> 2] = i4;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i15 + 48 >> 2] = i5;
  i6 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i15 + 52 >> 2] = i6;
  HEAP8[i15 + 56 >> 0] = i7 & 1;
  HEAP32[i15 + 60 >> 2] = i1;
  i1 = i15 + 64 | 0;
  HEAPF32[i1 >> 2] = f13;
  HEAP32[i15 + 68 >> 2] = 0;
  HEAP32[i15 + 72 >> 2] = 0;
  HEAP32[i15 + 76 >> 2] = -1;
  HEAP16[i15 + 80 >> 1] = 0;
  i20 = i15 + 84 | 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  HEAP32[i20 + 12 >> 2] = 0;
  HEAP32[i20 + 16 >> 2] = 0;
  HEAP32[i20 + 20 >> 2] = 0;
  HEAPF32[i15 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i15 + 112 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 116 >> 2] = Math_fround(0.0);
  HEAP8[i15 + 181 >> 0] = (HEAP32[i12 + 4 >> 2] | 0) == 1 & 1;
  i20 = i15 + 180 | 0;
  HEAP8[i20 >> 0] = 0;
  HEAP32[i15 + 208 >> 2] = i22;
  HEAP32[i15 + 212 >> 2] = i21;
  HEAP32[i15 + 216 >> 2] = i3;
  HEAPF32[i15 + 220 >> 2] = Math_fround(0.0);
  HEAP32[i15 + 224 >> 2] = i4;
  HEAP32[i15 + 228 >> 2] = i5;
  HEAP32[i15 + 232 >> 2] = i6;
  HEAPF32[i15 + 236 >> 2] = Math_fround(0.0);
  __ZNK5physx2Gu5RTree11traverseRayILi0EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f(HEAP32[i14 + 4 >> 2] | 0, i10, i8, 4, i11, i15, i9, f13);
  HEAP32[i15 >> 2] = gb + 84176 + 8;
  HEAP32[i17 >> 2] = gb + 84176 + 32;
  if (HEAP8[i20 >> 0] | 0) {
   i22 = HEAP32[i2 >> 2] | 0;
   mftCall_iiiiiiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i15 + 68 | 0, i15 + 132 | 0, i15 + 144 | 0, i15 + 156 | 0, i1 | 0, i15 + 168 | 0) | 0;
  }
  STACKTOP = i16;
  return;
 }
}

function __ZNK9ShaderLab7Program21GetMatchingSubProgramEPK6ShaderPKNS_4PassERK16ShaderKeywordSetjPS7_R19ShaderSnippetResult(i7, i1, i2, i8, i3, i9, i12) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i2 = i15 + 56 | 0;
 i14 = i15 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 if ((HEAP32[i7 + 196 >> 2] | 0) == -1) if (!(HEAP32[i7 + 20 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = _XXH32(i8, 32, -1756908921) | 0;
 i11 = i7 + 48 | 0;
 if ((HEAP32[i7 + 148 >> 2] | 0) == (HEAP32[i7 + 52 >> 2] | 0)) {
  i4 = i7 + 140 | 0;
  i3 = i7 + 144 | 0;
  i6 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i14 >> 2] = i11;
  i1 = i14 + 4 | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i14 + 8 >> 2] = i6;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i14);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E13find_positionERS5_(i13, i11, i2);
  i1 = HEAP32[i13 >> 2] | 0;
  i6 = i7 + 140 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i7 + 144 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i5 = i4 + (i5 * 40 | 0) | 0;
   HEAP32[i14 >> 2] = i11;
   i1 = i14 + 4 | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i14 + 8 >> 2] = i5;
   __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i14);
  } else {
   HEAP32[i14 >> 2] = i11;
   i16 = i14 + 4 | 0;
   HEAP32[i16 >> 2] = i4 + (i1 * 40 | 0);
   HEAP32[i14 + 8 >> 2] = i4 + (i5 * 40 | 0);
   i1 = i16;
  }
  i4 = i6;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i6 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 40 | 0) | 0;
 HEAP32[i13 >> 2] = i11;
 i16 = i13 + 4 | 0;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i13 + 8 >> 2] = i6;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i13);
 L13 : do if ((i1 | 0) == (HEAP32[i16 >> 2] | 0)) if ((HEAP32[i12 >> 2] | 0) == 2) i1 = 0; else {
  i1 = __ZN9ShaderLab32FindBestMatchingShaderKeywordSetERK16ShaderKeywordSetRK13dynamic_arrayIS0_Lj4EEPS5_(i8, i7 + 28 | 0, i7 + 172 | 0) | 0;
  do if ((i1 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i12 >> 2] = 0;
    i4 = i1 + 8 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     __ZN9ShaderLab10SubProgram7CompileEv(i1);
     i3 = HEAP32[i4 >> 2] | 0;
     if (i3 | 0) i10 = 16;
    } else i10 = 16;
    if ((i10 | 0) == 16) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0) | 0) break;
    if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) != 4) {
     __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i7, i8);
     if (i9 | 0) {
      i16 = i1 + 16 | 0;
      __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i7, i16);
      HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
      HEAP32[i9 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
      HEAP32[i9 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
      HEAP32[i9 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
      HEAP32[i9 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
     }
     HEAP32[i12 >> 2] = 2;
     break L13;
    }
   }
  } else i1 = 0; while (0);
  if ((HEAP32[i12 >> 2] | 0) != 2) {
   i4 = i13;
   i3 = i4 + 36 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    i4 = i4 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i4 | 0) < (i3 | 0));
   HEAP32[i13 + 36 >> 2] = i1;
   __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj(i11, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS9_(i14, i11, i13);
  }
 } else i1 = HEAP32[i1 + 36 >> 2] | 0; while (0);
 i16 = i1;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj(i6, i1, i2, i7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i13 + 8 | 0;
 i14 = i13;
 HEAP32[i6 >> 2] = gb + 57900 + 8;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i14;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
 i3 = i15;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP8[i6 + 24 >> 0] = 0;
 HEAP8[i6 + 25 >> 0] = 0;
 HEAP32[i6 >> 2] = gb + 57952 + 8;
 HEAP32[i6 + 28 >> 2] = i1;
 HEAP32[i6 + 32 >> 2] = i2;
 i2 = i6 + 36 | 0;
 i5 = gb + 63160 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i14;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 52 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 40 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
 i11 = i15;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 i9 = i6 + 56 | 0;
 i12 = gb + 63160 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i14;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i6 + 68 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i6 + 72 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i6 + 60 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i14);
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 + 84 >> 2] = -1;
 HEAP32[i6 + 88 >> 2] = -1;
 HEAP32[i6 + 92 >> 2] = i7;
 HEAP32[i6 + 96 >> 2] = i8;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483640) >>> 0 < 8) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = 8;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 32, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = 8;
  HEAP32[i2 >> 2] = i15;
  break;
 } while (0);
 i1 = HEAP32[i11 >> 2] | 0;
 do if ((i1 & 2147483640) >>> 0 < 8) if ((i1 | 0) > -1) {
  HEAP32[i11 >> 2] = 8;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, 32, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  HEAP32[i11 >> 2] = 8;
  HEAP32[i9 >> 2] = i15;
  break;
 } while (0);
 i15 = gb + 63536 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = gb + 1161272 + 4 | 0;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = gb + 1161272 + 24 | 0;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = HEAP32[gb + 1161272 + 16 >> 2] | 0;
 do if ((i1 & 2147483584) >>> 0 < 64) if ((i1 | 0) > -1) {
  HEAP32[gb + 1161272 + 16 >> 2] = 64;
  i15 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1161272 >> 2] | 0, 2304, 4, gb + 1161272 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[gb + 1161272 >> 2] = i15;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2304, 4, gb + 1161272 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[gb + 1161272 >> 2] | 0, (HEAP32[gb + 1161272 + 12 >> 2] | 0) * 36 | 0) | 0;
  HEAP32[gb + 1161272 + 16 >> 2] = 64;
  HEAP32[gb + 1161272 >> 2] = i15;
  break;
 } while (0);
 i1 = HEAP32[gb + 1161272 + 36 >> 2] | 0;
 do if ((i1 & 2147483584) >>> 0 < 64) if ((i1 | 0) > -1) {
  HEAP32[gb + 1161272 + 36 >> 2] = 64;
  i15 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1161272 + 20 >> 2] | 0, 2304, 4, gb + 1161272 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[gb + 1161272 + 20 >> 2] = i15;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2304, 4, gb + 1161272 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[gb + 1161272 + 20 >> 2] | 0, (HEAP32[gb + 1161272 + 32 >> 2] | 0) * 36 | 0) | 0;
  HEAP32[gb + 1161272 + 36 >> 2] = 64;
  HEAP32[gb + 1161272 + 20 >> 2] = i15;
  break;
 } while (0);
 i14 = gb + 63536 | 0;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = gb + 1161312 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = HEAP32[gb + 1161312 + 16 >> 2] | 0;
 if ((i1 & 2147483584) >>> 0 >= 64) {
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[gb + 1161312 + 16 >> 2] = 64;
  i15 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1161312 >> 2] | 0, 2304, 4, gb + 1161312 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[gb + 1161312 >> 2] = i15;
  STACKTOP = i13;
  return;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2304, 4, gb + 1161312 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[gb + 1161312 >> 2] | 0, (HEAP32[gb + 1161312 + 12 >> 2] | 0) * 36 | 0) | 0;
  HEAP32[gb + 1161312 + 16 >> 2] = 64;
  HEAP32[gb + 1161312 >> 2] = i15;
  STACKTOP = i13;
  return;
 }
}

function __Z22GetProjectRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i16, i14) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 48 | 0;
 i18 = i19 + 36 | 0;
 i11 = i19 + 24 | 0;
 i12 = i19 + 12 | 0;
 i13 = i19;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i17, i14);
 i7 = i17 + 11 | 0;
 i10 = HEAP8[i7 >> 0] | 0;
 i1 = i10 << 24 >> 24 < 0;
 i8 = i17 + 4 | 0;
 if ((i1 ? HEAP32[i8 >> 2] | 0 : i10 & 255) | 0) {
  i1 = i1 ? HEAP32[i17 >> 2] | 0 : i17;
  do {
   i9 = HEAP8[i1 >> 0] | 0;
   i10 = i9 << 24 >> 24;
   HEAP8[i1 >> 0] = (i9 + -65 & 255) < 26 ? i10 + 32 | 0 : i10;
   i1 = i1 + 1 | 0;
   i10 = HEAP8[i7 >> 0] | 0;
   i9 = i10 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i9 ? HEAP32[i17 >> 2] | 0 : i17) + (i9 ? HEAP32[i8 >> 2] | 0 : i10 & 255) | 0));
 }
 __ZN4File19GetCurrentDirectoryEv(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i12);
 i5 = i11 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i6 = i11 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i4 ? i2 : i3 & 255) | 0) {
  i4 = i4 ? i1 : i11;
  do {
   i10 = HEAP8[i4 >> 0] | 0;
   i3 = i10 << 24 >> 24;
   HEAP8[i4 >> 0] = (i10 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   i10 = i3 << 24 >> 24 < 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i4 | 0) != ((i10 ? i1 : i11) + (i10 ? i2 : i3 & 255) | 0));
 };
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? i2 : i3 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i18, i10 ? i1 : i11, i2, i2 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i18, 47);
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i17 >> 2] | 0 : i17;
 i2 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = HEAP8[i18 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i6 = i10 ? HEAP32[i18 >> 2] | 0 : i18;
 i3 = i10 ? HEAP32[i18 + 4 >> 2] | 0 : i3 & 255;
 do if (i2 >>> 0 < i3 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 } else {
  if (!i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  } else {
   i9 = i1 + i2 | 0;
   i7 = i6 + i3 | 0;
   i8 = i9;
   i10 = i1;
   L17 : do if ((i2 | 0) < (i3 | 0)) i1 = i8; else {
    i4 = i9 + (1 - i3) | 0;
    if ((i4 | 0) == (i1 | 0)) i1 = i8; else {
     i5 = HEAP8[i6 >> 0] | 0;
     L20 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i6;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i8;
        break L17;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break L20;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i8;
       break L17;
      }
     }
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   if (!((i1 | 0) == (i10 | 0) & (i1 | 0) != (i9 | 0))) break;
  }
  __ZN4File19GetCurrentDirectoryEv(i13);
  i5 = HEAP8[i13 + 11 >> 0] | 0;
  i5 = (i5 << 24 >> 24 < 0 ? HEAP32[i13 + 4 >> 2] | 0 : i5 & 255) + 1 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i4 = HEAP8[i14 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i14 >> 2] | 0 : i14;
  i2 = i6 + i5 | 0;
  i4 = i3 ? HEAP32[i14 + 4 >> 2] | 0 : i4 & 255;
  i6 = i6 + i4 | 0;
  i3 = i2;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i1 = i6 - i3 | 0;
  if (i1 >>> 0 > 4294967279) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
   i15 = 27;
  } else if (i1 >>> 0 < 11) {
   HEAP8[i18 + 11 >> 0] = i1;
   i1 = i18;
  } else i15 = 27;
  if ((i15 | 0) == 27) {
   i14 = i1 + 16 & -16;
   i15 = __Znwj(i14) | 0;
   HEAP32[i18 >> 2] = i15;
   HEAP32[i18 + 8 >> 2] = i14 | -2147483648;
   HEAP32[i18 + 4 >> 2] = i1;
   i1 = i15;
  }
  if ((i5 | 0) != (i4 | 0)) while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
   if ((i2 | 0) == (i6 | 0)) break; else i3 = i2;
  }
  HEAP8[i1 >> 0] = 0;
  __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i16, i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i19;
  return;
 } while (0);
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i19;
 return;
}

function __ZNK5physx2Sq16BucketPrunerCore9visualizeERNS_2Cm12RenderOutputEj(i24, i23, i1) {
 i24 = i24 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 28 | 0;
 i2 = i25;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i23, i2) | 0;
 __ZN5physx2Cm12RenderOutputlsEj(i23, i1) | 0;
 f34 = Math_fround(HEAPF32[i24 + 608 >> 2]);
 f28 = Math_fround(HEAPF32[i24 + 624 >> 2]);
 f31 = Math_fround(f34 - f28);
 f33 = Math_fround(HEAPF32[i24 + 612 >> 2]);
 f27 = Math_fround(HEAPF32[i24 + 628 >> 2]);
 f30 = Math_fround(f33 - f27);
 f32 = Math_fround(HEAPF32[i24 + 616 >> 2]);
 f26 = Math_fround(HEAPF32[i24 + 632 >> 2]);
 f29 = Math_fround(f32 - f26);
 f28 = Math_fround(f34 + f28);
 f27 = Math_fround(f33 + f27);
 f26 = Math_fround(f32 + f26);
 HEAPF32[i22 >> 2] = f31;
 HEAPF32[i22 + 4 >> 2] = f30;
 HEAPF32[i22 + 8 >> 2] = f29;
 HEAPF32[i22 + 12 >> 2] = f28;
 HEAPF32[i22 + 16 >> 2] = f27;
 HEAPF32[i22 + 20 >> 2] = f26;
 HEAP8[i22 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i22) | 0;
 i1 = i22 + 4 | 0;
 i2 = i22 + 8 | 0;
 i3 = i22 + 12 | 0;
 i4 = i22 + 16 | 0;
 i5 = i22 + 20 | 0;
 i6 = i22 + 24 | 0;
 i7 = i22 + 4 | 0;
 i8 = i22 + 8 | 0;
 i9 = i22 + 12 | 0;
 i10 = i22 + 16 | 0;
 i11 = i22 + 20 | 0;
 i12 = i22 + 24 | 0;
 i13 = i22 + 4 | 0;
 i14 = i22 + 8 | 0;
 i15 = i22 + 12 | 0;
 i16 = i22 + 16 | 0;
 i17 = i22 + 20 | 0;
 i18 = i22 + 24 | 0;
 i19 = 0;
 do {
  if (HEAP32[i24 + 640 + (i19 << 2) >> 2] | 0) {
   f26 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) >> 2]);
   f32 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) + 16 >> 2]);
   f29 = Math_fround(f26 - f32);
   f27 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) + 4 >> 2]);
   f33 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) + 20 >> 2]);
   f30 = Math_fround(f27 - f33);
   f28 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) + 8 >> 2]);
   f34 = Math_fround(HEAPF32[i24 + 688 + (i19 << 5) + 24 >> 2]);
   f31 = Math_fround(f28 - f34);
   f32 = Math_fround(f26 + f32);
   f33 = Math_fround(f27 + f33);
   f34 = Math_fround(f28 + f34);
   HEAPF32[i22 >> 2] = f29;
   HEAPF32[i1 >> 2] = f30;
   HEAPF32[i2 >> 2] = f31;
   HEAPF32[i3 >> 2] = f32;
   HEAPF32[i4 >> 2] = f33;
   HEAPF32[i5 >> 2] = f34;
   HEAP8[i6 >> 0] = 1;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i22) | 0;
   i20 = 0;
   do {
    if (HEAP32[i24 + 864 + (i19 * 224 | 0) + (i20 << 2) >> 2] | 0) {
     f26 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) >> 2]);
     f32 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) + 16 >> 2]);
     f29 = Math_fround(f26 - f32);
     f27 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) + 4 >> 2]);
     f33 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) + 20 >> 2]);
     f30 = Math_fround(f27 - f33);
     f28 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) + 8 >> 2]);
     f34 = Math_fround(HEAPF32[i24 + 864 + (i19 * 224 | 0) + 48 + (i20 << 5) + 24 >> 2]);
     f31 = Math_fround(f28 - f34);
     f32 = Math_fround(f26 + f32);
     f33 = Math_fround(f27 + f33);
     f34 = Math_fround(f28 + f34);
     HEAPF32[i22 >> 2] = f29;
     HEAPF32[i7 >> 2] = f30;
     HEAPF32[i8 >> 2] = f31;
     HEAPF32[i9 >> 2] = f32;
     HEAPF32[i10 >> 2] = f33;
     HEAPF32[i11 >> 2] = f34;
     HEAP8[i12 >> 0] = 1;
     __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i22) | 0;
     i21 = 0;
     do {
      if (HEAP32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + (i21 << 2) >> 2] | 0) {
       f26 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) >> 2]);
       f32 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) + 16 >> 2]);
       f29 = Math_fround(f26 - f32);
       f27 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) + 4 >> 2]);
       f33 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) + 20 >> 2]);
       f30 = Math_fround(f27 - f33);
       f28 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) + 8 >> 2]);
       f34 = Math_fround(HEAPF32[i24 + 1984 + (i19 * 1120 | 0) + (i20 * 224 | 0) + 48 + (i21 << 5) + 24 >> 2]);
       f31 = Math_fround(f28 - f34);
       f32 = Math_fround(f26 + f32);
       f33 = Math_fround(f27 + f33);
       f34 = Math_fround(f28 + f34);
       HEAPF32[i22 >> 2] = f29;
       HEAPF32[i13 >> 2] = f30;
       HEAPF32[i14 >> 2] = f31;
       HEAPF32[i15 >> 2] = f32;
       HEAPF32[i16 >> 2] = f33;
       HEAPF32[i17 >> 2] = f34;
       HEAP8[i18 >> 0] = 1;
       __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i22) | 0;
      }
      i21 = i21 + 1 | 0;
     } while ((i21 | 0) != 5);
    }
    i20 = i20 + 1 | 0;
   } while ((i20 | 0) != 5);
  }
  i19 = i19 + 1 | 0;
 } while ((i19 | 0) != 5);
 STACKTOP = i25;
 return;
}

function __ZNK5Umbra18ImpOcclusionBuffer9dumpFloatEPfRKNS_15OcclusionBuffer10BufferDescE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i4 = HEAP32[i1 + 1408 >> 2] | 0;
 if (!i4) {
  i11 = 4;
  return i11 | 0;
 }
 i10 = (HEAP32[i1 + 1200 >> 2] | 0) == 1;
 f12 = i10 ? Math_fround(-1.0) : Math_fround(0.0);
 f13 = i10 ? Math_fround(2.0) : Math_fround(1.0);
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i11 = i10 << 2;
 i9 = 0;
 while (1) {
  i6 = 0;
  i7 = i4;
  i8 = i3;
  while (1) {
   if (!(i8 & 15)) {
    i1 = 0;
    i2 = i8;
    i5 = i7;
    while (1) {
     f29 = Math_fround(HEAPF32[i5 >> 2]);
     f28 = Math_fround(HEAPF32[i5 + 4 >> 2]);
     f27 = Math_fround(HEAPF32[i5 + 8 >> 2]);
     f29 = Math_fround(f12 + Math_fround(f13 * f29));
     f28 = Math_fround(f12 + Math_fround(f13 * f28));
     f27 = Math_fround(f12 + Math_fround(f13 * f27));
     f26 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 12 >> 2])));
     f25 = Math_fround(HEAPF32[i5 + 64 >> 2]);
     f24 = Math_fround(HEAPF32[i5 + 68 >> 2]);
     f23 = Math_fround(HEAPF32[i5 + 72 >> 2]);
     f25 = Math_fround(f12 + Math_fround(f13 * f25));
     f24 = Math_fround(f12 + Math_fround(f13 * f24));
     f23 = Math_fround(f12 + Math_fround(f13 * f23));
     f22 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 76 >> 2])));
     f21 = Math_fround(HEAPF32[i5 + 128 >> 2]);
     f20 = Math_fround(HEAPF32[i5 + 132 >> 2]);
     f19 = Math_fround(HEAPF32[i5 + 136 >> 2]);
     f21 = Math_fround(f12 + Math_fround(f13 * f21));
     f20 = Math_fround(f12 + Math_fround(f13 * f20));
     f19 = Math_fround(f12 + Math_fround(f13 * f19));
     f18 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 140 >> 2])));
     f17 = Math_fround(HEAPF32[i5 + 192 >> 2]);
     f16 = Math_fround(HEAPF32[i5 + 196 >> 2]);
     f15 = Math_fround(HEAPF32[i5 + 200 >> 2]);
     f17 = Math_fround(f12 + Math_fround(f13 * f17));
     f16 = Math_fround(f12 + Math_fround(f13 * f16));
     f15 = Math_fround(f12 + Math_fround(f13 * f15));
     f14 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 204 >> 2])));
     HEAPF32[i2 >> 2] = f29;
     HEAPF32[i2 + 4 >> 2] = f28;
     HEAPF32[i2 + 8 >> 2] = f27;
     HEAPF32[i2 + 12 >> 2] = f26;
     HEAPF32[i2 + 16 >> 2] = f25;
     HEAPF32[i2 + 20 >> 2] = f24;
     HEAPF32[i2 + 24 >> 2] = f23;
     HEAPF32[i2 + 28 >> 2] = f22;
     HEAPF32[i2 + 32 >> 2] = f21;
     HEAPF32[i2 + 36 >> 2] = f20;
     HEAPF32[i2 + 40 >> 2] = f19;
     HEAPF32[i2 + 44 >> 2] = f18;
     HEAPF32[i2 + 48 >> 2] = f17;
     HEAPF32[i2 + 52 >> 2] = f16;
     HEAPF32[i2 + 56 >> 2] = f15;
     HEAPF32[i2 + 60 >> 2] = f14;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) >= 16) break; else {
      i2 = i2 + 64 | 0;
      i5 = i5 + 256 | 0;
     }
    }
   } else {
    i1 = 0;
    i2 = i8;
    i5 = i7;
    while (1) {
     f14 = Math_fround(HEAPF32[i5 >> 2]);
     f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
     f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
     f14 = Math_fround(f12 + Math_fround(f13 * f14));
     f15 = Math_fround(f12 + Math_fround(f13 * f15));
     f16 = Math_fround(f12 + Math_fround(f13 * f16));
     f17 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 12 >> 2])));
     f18 = Math_fround(HEAPF32[i5 + 64 >> 2]);
     f19 = Math_fround(HEAPF32[i5 + 68 >> 2]);
     f20 = Math_fround(HEAPF32[i5 + 72 >> 2]);
     f18 = Math_fround(f12 + Math_fround(f13 * f18));
     f19 = Math_fround(f12 + Math_fround(f13 * f19));
     f20 = Math_fround(f12 + Math_fround(f13 * f20));
     f21 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 76 >> 2])));
     f22 = Math_fround(HEAPF32[i5 + 128 >> 2]);
     f23 = Math_fround(HEAPF32[i5 + 132 >> 2]);
     f24 = Math_fround(HEAPF32[i5 + 136 >> 2]);
     f22 = Math_fround(f12 + Math_fround(f13 * f22));
     f23 = Math_fround(f12 + Math_fround(f13 * f23));
     f24 = Math_fround(f12 + Math_fround(f13 * f24));
     f25 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 140 >> 2])));
     f26 = Math_fround(HEAPF32[i5 + 192 >> 2]);
     f27 = Math_fround(HEAPF32[i5 + 196 >> 2]);
     f28 = Math_fround(HEAPF32[i5 + 200 >> 2]);
     f26 = Math_fround(f12 + Math_fround(f13 * f26));
     f27 = Math_fround(f12 + Math_fround(f13 * f27));
     f28 = Math_fround(f12 + Math_fround(f13 * f28));
     f29 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i5 + 204 >> 2])));
     HEAPF32[i2 >> 2] = f14;
     HEAPF32[i2 + 4 >> 2] = f15;
     HEAPF32[i2 + 8 >> 2] = f16;
     HEAPF32[i2 + 12 >> 2] = f17;
     HEAPF32[i2 + 16 >> 2] = f18;
     HEAPF32[i2 + 20 >> 2] = f19;
     HEAPF32[i2 + 24 >> 2] = f20;
     HEAPF32[i2 + 28 >> 2] = f21;
     HEAPF32[i2 + 32 >> 2] = f22;
     HEAPF32[i2 + 36 >> 2] = f23;
     HEAPF32[i2 + 40 >> 2] = f24;
     HEAPF32[i2 + 44 >> 2] = f25;
     HEAPF32[i2 + 48 >> 2] = f26;
     HEAPF32[i2 + 52 >> 2] = f27;
     HEAPF32[i2 + 56 >> 2] = f28;
     HEAPF32[i2 + 60 >> 2] = f29;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) >= 16) break; else {
      i2 = i2 + 64 | 0;
      i5 = i5 + 256 | 0;
     }
    }
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 4) break; else {
    i7 = i7 + 16 | 0;
    i8 = i8 + i10 | 0;
   }
  }
  i9 = i9 + 4 | 0;
  if ((i9 | 0) >= 64) {
   i1 = 0;
   break;
  } else {
   i3 = i3 + i11 | 0;
   i4 = i4 + 1024 | 0;
  }
 }
 return i1 | 0;
}

function __ZN5Umbra12QueryContext17addQueryDebugAABBERKNS_7Vector3ES3_RKNS_7Vector4Eb(i1, i2, i3, i29, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i29 = i29 | 0;
 i4 = i4 | 0;
 var f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i33 + 92 | 0;
 i28 = i33 + 88 | 0;
 i24 = i33 + 84 | 0;
 i25 = i33 + 80 | 0;
 i26 = i33 + 76 | 0;
 i27 = i33 + 72 | 0;
 i30 = i33 + 24 | 0;
 i31 = i33 + 12 | 0;
 i32 = i33;
 i22 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i22) {
  STACKTOP = i33;
  return;
 }
 if (!i4) {
  mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 16 >> 2] | 0, i22 | 0, i2 | 0, i3 | 0, i29 | 0);
  STACKTOP = i33;
  return;
 }
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i28 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i24 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i26 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i27 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = i30;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i6 = i30 + 4 | 0;
 i10 = i30 + 8 | 0;
 i11 = i30 + 12 | 0;
 i2 = i30 + 16 | 0;
 i7 = i30 + 20 | 0;
 i12 = i30 + 24 | 0;
 i3 = i30 + 28 | 0;
 i8 = i30 + 32 | 0;
 i13 = i30 + 36 | 0;
 i4 = i30 + 40 | 0;
 i9 = i30 + 44 | 0;
 i14 = i31 + 4 | 0;
 i15 = i31 + 8 | 0;
 i16 = i32 + 4 | 0;
 i17 = i32 + 8 | 0;
 i18 = i31 + 4 | 0;
 i19 = i31 + 8 | 0;
 i20 = i32 + 4 | 0;
 i21 = i32 + 8 | 0;
 i1 = 0;
 do {
  i36 = HEAP32[((i1 | 0) != 4 ? i28 : i26) >> 2] | 0;
  i34 = HEAP32[((i1 | 0) != 5 ? i24 : i27) >> 2] | 0;
  HEAP32[i30 >> 2] = HEAP32[((i1 | 0) != 3 ? i23 : i25) >> 2];
  HEAP32[i6 >> 2] = i36;
  HEAP32[i10 >> 2] = i34;
  i34 = (21 >>> i1 & 1 | 0) != 0;
  i36 = (i1 + -2 | 0) >>> 0 > 2;
  i37 = HEAP32[(i36 ? i28 : i26) >> 2] | 0;
  i35 = (i1 + -1 | 0) >>> 0 < 3;
  i38 = HEAP32[(i35 ? i24 : i27) >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[(i34 ? i23 : i25) >> 2];
  HEAP32[i2 >> 2] = i37;
  HEAP32[i7 >> 2] = i38;
  i38 = HEAP32[((i1 | 0) == 1 ? i28 : i26) >> 2] | 0;
  i37 = HEAP32[((i1 | 0) == 2 ? i24 : i27) >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[((i1 | 0) == 0 ? i23 : i25) >> 2];
  HEAP32[i3 >> 2] = i38;
  HEAP32[i8 >> 2] = i37;
  i35 = HEAP32[(i35 ? i28 : i26) >> 2] | 0;
  i34 = HEAP32[(i34 ? i24 : i27) >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[(i36 ? i23 : i25) >> 2];
  HEAP32[i4 >> 2] = i35;
  HEAP32[i9 >> 2] = i34;
  mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i30 | 0, i11 | 0, i29 | 0);
  mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i11 | 0, i12 | 0, i29 | 0);
  mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i12 | 0, i13 | 0, i29 | 0);
  mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i13 | 0, i30 | 0, i29 | 0);
  f5 = Math_fround(0.0);
  do {
   f44 = Math_fround(HEAPF32[i11 >> 2]);
   f42 = Math_fround(HEAPF32[i30 >> 2]);
   f44 = Math_fround(f44 - f42);
   f40 = Math_fround(HEAPF32[i2 >> 2]);
   f43 = Math_fround(HEAPF32[i6 >> 2]);
   f40 = Math_fround(f40 - f43);
   f41 = Math_fround(HEAPF32[i7 >> 2]);
   f39 = Math_fround(HEAPF32[i10 >> 2]);
   f40 = Math_fround(f43 + Math_fround(f5 * f40));
   f41 = Math_fround(f39 + Math_fround(f5 * Math_fround(f41 - f39)));
   HEAPF32[i31 >> 2] = Math_fround(f42 + Math_fround(f5 * f44));
   HEAPF32[i14 >> 2] = f40;
   HEAPF32[i15 >> 2] = f41;
   f41 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f42);
   f40 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f43);
   f40 = Math_fround(f43 + Math_fround(f5 * f40));
   f39 = Math_fround(f39 + Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f39)));
   HEAPF32[i32 >> 2] = Math_fround(f42 + Math_fround(f5 * f41));
   HEAPF32[i16 >> 2] = f40;
   HEAPF32[i17 >> 2] = f39;
   mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i31 | 0, i32 | 0, i29 | 0);
   f5 = Math_fround(f5 + Math_fround(.100000001));
  } while (f5 <= Math_fround(1.0));
  f5 = Math_fround(0.0);
  do {
   f42 = Math_fround(HEAPF32[i12 >> 2]);
   f45 = Math_fround(HEAPF32[i11 >> 2]);
   f44 = Math_fround(f42 - f45);
   f43 = Math_fround(HEAPF32[i3 >> 2]);
   f46 = Math_fround(HEAPF32[i2 >> 2]);
   f39 = Math_fround(f43 - f46);
   f40 = Math_fround(HEAPF32[i8 >> 2]);
   f41 = Math_fround(HEAPF32[i7 >> 2]);
   f39 = Math_fround(f46 + Math_fround(f5 * f39));
   f41 = Math_fround(f41 + Math_fround(f5 * Math_fround(f40 - f41)));
   HEAPF32[i31 >> 2] = Math_fround(f45 + Math_fround(f5 * f44));
   HEAPF32[i18 >> 2] = f39;
   HEAPF32[i19 >> 2] = f41;
   f41 = Math_fround(HEAPF32[i13 >> 2]);
   f42 = Math_fround(f42 - f41);
   f39 = Math_fround(HEAPF32[i4 >> 2]);
   f43 = Math_fround(f43 - f39);
   f44 = Math_fround(HEAPF32[i9 >> 2]);
   f43 = Math_fround(f39 + Math_fround(f5 * f43));
   f44 = Math_fround(f44 + Math_fround(f5 * Math_fround(f40 - f44)));
   HEAPF32[i32 >> 2] = Math_fround(f41 + Math_fround(f5 * f42));
   HEAPF32[i20 >> 2] = f43;
   HEAPF32[i21 >> 2] = f44;
   mftCall_viiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i31 | 0, i32 | 0, i29 | 0);
   f5 = Math_fround(f5 + Math_fround(.100000001));
  } while (f5 <= Math_fround(1.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 6);
 STACKTOP = i33;
 return;
}

function __ZN9Rigidbody14SetIsKinematicEb(i15, i12) {
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i23 + 8 | 0;
 i14 = i23;
 i22 = i23 + 16 | 0;
 i17 = i15 + 84 | 0;
 HEAP8[i17 >> 0] = i12 & 1;
 i18 = i15 + 52 | 0;
 i21 = HEAP32[i18 >> 2] | 0;
 if (!(((mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 200 >> 2] | 0, i21 | 0) | 0) & 1) != 0 ^ i12)) {
  STACKTOP = i23;
  return;
 }
 i13 = i15;
 if ((HEAP16[gb + 1452840 + 6 >> 1] | 0) > -1) {
  HEAP32[i14 >> 2] = i13;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452840 | 0, i11);
  i19 = gb + 1452840 | 0;
 } else i19 = 0;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i16 = i14;
 HEAP32[i16 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i16 + 4 >> 2] = i20;
 HEAP32[i22 >> 2] = 0;
 i16 = i22 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i20 = i22 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i14);
 i9 = i11;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i21;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i15 + 48 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i15 + 44 | 0;
 i2 = i1;
 L7 : do if ((i2 | 0) == (i9 | 0)) i1 = HEAP32[i16 >> 2] | 0; else {
  i3 = i2;
  while (1) {
   do if ((i3 | 0) == (i2 | 0)) {
    i2 = HEAP32[i20 >> 2] | 0;
    if ((i2 & 2147483616) >>> 0 < 32) if ((i2 | 0) > -1) {
     HEAP32[i20 >> 2] = 32;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, 128, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
     i10 = 13;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(128, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
     HEAP32[i20 >> 2] = 32;
     HEAP32[i22 >> 2] = i10;
     i10 = 13;
     break;
    }
   } else i10 = 13; while (0);
   if ((i10 | 0) == 13) {
    i10 = 0;
    i2 = HEAP32[i20 >> 2] | 0;
   }
   i5 = HEAP32[i1 + 8 >> 2] | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i1 = i6 + 1 | 0;
   i7 = i2 & 2147483647;
   do if (i1 >>> 0 > i7 >>> 0) {
    i4 = i2 << 1;
    i4 = (i4 | 0) == 0 ? 1 : i4;
    if (i7 >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
     HEAP32[i20 >> 2] = i4;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i4 << 2, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
     HEAP32[i20 >> 2] = i4;
     HEAP32[i22 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i16 >> 2] = i1;
   HEAP32[(HEAP32[i22 >> 2] | 0) + (i6 << 2) >> 2] = i5;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
   if ((i3 | 0) == (i9 | 0)) break L7;
   i1 = i2;
   i2 = HEAP32[i8 >> 2] | 0;
  }
 } while (0);
 if (!((i1 | 0) == 0 | i12)) if (HEAP8[i15 + 80 >> 0] | 0) {
  if ((HEAP16[gb + 1452852 + 6 >> 1] | 0) > -1) {
   HEAP32[i14 >> 2] = i13;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452852 | 0, i11);
   i2 = gb + 1452852 | 0;
   i1 = HEAP32[i16 >> 2] | 0;
  } else i2 = 0;
  if (i1 | 0) {
   i1 = HEAP32[i22 >> 2] | 0;
   do {
    __ZN8Collider25CreateWithoutIgnoreAttachEv(HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i22 >> 2] | 0) + (HEAP32[i16 >> 2] << 2) | 0));
  }
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 }
 i1 = HEAP32[i18 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, 1, i12 | 0);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!((i1 | 0) == 0 | i12 ^ 1)) if (HEAP8[i15 + 80 >> 0] | 0) {
  if ((HEAP16[gb + 1452852 + 6 >> 1] | 0) > -1) {
   HEAP32[i14 >> 2] = i13;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452852 | 0, i11);
   i2 = gb + 1452852 | 0;
   i1 = HEAP32[i16 >> 2] | 0;
  } else i2 = 0;
  if (i1 | 0) {
   i1 = HEAP32[i22 >> 2] | 0;
   do {
    __ZN8Collider25CreateWithoutIgnoreAttachEv(HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i22 >> 2] | 0) + (HEAP32[i16 >> 2] << 2) | 0));
  }
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 }
 __ZN9Rigidbody23UpdateInterpolationNodeEv(i15);
 __ZN9Rigidbody22UpdateMassDistributionEv(i15);
 i16 = HEAP32[i18 >> 2] | 0;
 i16 = (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 200 >> 2] | 0, i16 | 0) | 0) & 1;
 HEAP8[i17 >> 0] = i16;
 i17 = i15 + 104 | 0;
 HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -2;
 if (!(i16 << 24 >> 24)) {
  i1 = HEAP32[i18 >> 2] | 0;
  if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 }
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i21);
  HEAP32[i22 >> 2] = 0;
 }
 if (!i19) {
  STACKTOP = i23;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i23;
 return;
}

function __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i5, i7, i1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 816 | 0;
 i11 = i18 + 544 | 0;
 i16 = i18 + 272 | 0;
 i15 = i18;
 i3 = i5 + 2580 | 0;
 if (i1) {
  __ZN5physx3Scb5Scene13addRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE(i5, i7, i3);
  if (Math_fround(HEAPF32[i7 + 228 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 204 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 208 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 212 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 216 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 220 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 224 >> 2]) == Math_fround(0.0)) {
   HEAP32[i7 + 232 >> 2] = 1;
   STACKTOP = i18;
   return;
  }
  HEAP32[i7 + 232 >> 2] = 0;
  STACKTOP = i18;
  return;
 }
 HEAP32[i7 >> 2] = i5;
 i4 = i5 + 2433 | 0;
 i14 = i7 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 do if (!(HEAP8[i4 >> 0] | 0)) {
  HEAP32[i14 >> 2] = i2 & 268435455 | -2147483648;
  __ZN10ScSceneFnsIN5physx3Scb4BodyEE6insertERNS0_2Sc5SceneERS2_(i5 + 16 | 0, i7);
 } else {
  i1 = i2 & 1073741823;
  if (i2 >>> 0 > 3221225471) {
   HEAP32[i14 >> 2] = i1 | -2147483648;
   if (i2 & 268435456 | 0) break;
   HEAP32[i17 >> 2] = i7;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i17) | 0;
   break;
  }
  HEAP32[i14 >> 2] = i1 | 1073741824;
  HEAP32[i11 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i11, i17) | 0;
  if (!(HEAP8[i17 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
 } while (0);
 if (Math_fround(HEAPF32[i7 + 228 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 204 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 208 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 212 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 216 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 220 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 224 >> 2]) == Math_fround(0.0)) HEAP32[i7 + 232 >> 2] = 1; else i6 = 18; else i6 = 18; else i6 = 18; else i6 = 18; else i6 = 18; else i6 = 18; else i6 = 18;
 if ((i6 | 0) == 18) HEAP32[i7 + 232 >> 2] = 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i5 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i16 + 256 | 0;
  i10 = i16 + 260 | 0;
  HEAP32[i16 + 264 >> 2] = 0;
  i11 = i16 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i16;
  HEAP32[i11 >> 2] = 64;
  i12 = i15 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i15, i16);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i7, i17) | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i17 = HEAP32[i15 + 268 >> 2] | 0;
  do if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i15 + 260 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  } while (0);
  i17 = HEAP32[i11 >> 2] | 0;
  do if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i16 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i7, i17) | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i17 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i18;
 return;
}

function __ZN17SurfaceEffector2D8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 92 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903494 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803088 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803105 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 104 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803118 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 105 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803136 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 106 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803150 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN21EnlightenSceneMappingaSERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = (i9 | 0) == (i8 | 0);
 if (i10) {
  HEAP8[i8 + 120 >> 0] = HEAP8[i9 + 120 >> 0] | 0;
  return i8 | 0;
 }
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i8 + 12 | 0;
 i1 = (HEAP32[i9 + 12 >> 2] | 0) * 40 | 0;
 i2 = (i1 | 0) / 40 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  break;
 } else i1 = HEAP32[i8 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
 i2 = i8 + 20 | 0;
 i6 = HEAP32[i9 + 20 >> 2] | 0;
 i7 = i8 + 32 | 0;
 i1 = (HEAP32[i9 + 32 >> 2] | 0) * 56 | 0;
 i3 = (i1 | 0) / 56 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 8, i8 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 56 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 56 | 0) | 0;
 i2 = i8 + 40 | 0;
 i6 = HEAP32[i9 + 40 >> 2] | 0;
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i9 + 52 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 8, i8 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i2 = i8 + 60 | 0;
 i6 = HEAP32[i9 + 60 >> 2] | 0;
 i7 = i8 + 72 | 0;
 i1 = (HEAP32[i9 + 72 >> 2] | 0) * 28 | 0;
 i3 = (i1 | 0) / 28 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 28 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 28 | 0) | 0;
 i3 = i8 + 80 | 0;
 i6 = HEAP32[i9 + 80 >> 2] | 0;
 i7 = i8 + 92 | 0;
 i1 = HEAP32[i9 + 92 >> 2] << 5;
 i4 = i1 >> 5;
 HEAP32[i7 >> 2] = i4;
 i5 = i8 + 96 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i5 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1, 8, i8 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  break;
 } else i1 = HEAP32[i3 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
 i2 = i8 + 100 | 0;
 i6 = HEAP32[i9 + 100 >> 2] | 0;
 i7 = i8 + 112 | 0;
 i1 = (HEAP32[i9 + 112 >> 2] | 0) * 12 | 0;
 i3 = (i1 | 0) / 12 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 116 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 HEAP8[i8 + 120 >> 0] = HEAP8[i9 + 120 >> 0] | 0;
 if (i10) return i8 | 0;
 __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8 + 124 | 0, HEAP32[i9 + 124 >> 2] | 0, HEAP32[i9 + 128 >> 2] | 0);
 return i8 | 0;
}

function __ZN13GfxDeviceGLES20SetRenderTargetsImplERK20GfxRenderTargetSetup(i20, i18) {
 i20 = i20 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 96 | 0;
 i14 = i21;
 i16 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i20 + 4616 >> 2] | 0) | 0;
 i15 = i13 + 68 | 0;
 i17 = i18 + 36 | 0;
 i3 = i13;
 i4 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i1 = HEAP32[i17 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i18 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i13 >> 2] = 1;
  i3 = i13;
  i19 = 6;
  break;
 } else {
  HEAP32[i13 >> 2] = 0;
  i2 = 0;
  break;
 } else {
  HEAP32[i13 >> 2] = i1;
  if (!i1) i2 = 0; else {
   i3 = i13;
   i19 = 6;
  }
 } while (0);
 if ((i19 | 0) == 6) {
  i1 = 0;
  do {
   i2 = HEAP32[i18 + (i1 << 2) >> 2] | 0;
   HEAP32[i13 + 4 + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 36 + (i1 << 2) >> 2] = HEAP32[i2 + 36 >> 2];
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = HEAP32[i18 + 32 >> 2] | 0;
 do if (!i1) {
  HEAP8[i13 + 92 >> 0] = 0;
  i8 = 0;
 } else {
  i3 = i13 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i3 >> 0] = 1;
   HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i13 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   i8 = 1;
   break;
  } else {
   HEAP8[i3 >> 0] = 0;
   i8 = 0;
   break;
  }
 } while (0);
 i9 = HEAP32[i18 + 40 >> 2] | 0;
 HEAP32[i13 + 80 >> 2] = i9;
 i10 = HEAP32[i18 + 48 >> 2] | 0;
 HEAP32[i13 + 84 >> 2] = i10;
 i11 = HEAP32[i18 + 44 >> 2] | 0;
 HEAP32[i13 + 88 >> 2] = i11;
 i12 = i14 + 68 | 0;
 i1 = i16 + 248 | 0;
 i3 = i14;
 i4 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i16 + 212 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i14 >> 2] = 1;
  i4 = i14;
  i19 = 18;
  break;
 } else {
  HEAP32[i14 >> 2] = 0;
  i3 = 0;
  break;
 } else {
  HEAP32[i14 >> 2] = i1;
  if (!i1) i3 = 0; else {
   i4 = i14;
   i19 = 18;
  }
 } while (0);
 if ((i19 | 0) == 18) {
  i1 = 0;
  do {
   i3 = HEAP32[i16 + 212 + (i1 << 2) >> 2] | 0;
   HEAP32[i14 + 4 + (i1 << 2) >> 2] = HEAP32[i3 >> 2];
   HEAP32[i14 + 36 + (i1 << 2) >> 2] = HEAP32[i3 + 36 >> 2];
   i1 = i1 + 1 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i1 = HEAP32[i16 + 244 >> 2] | 0;
 do if (!i1) {
  HEAP8[i14 + 92 >> 0] = 0;
  i4 = 0;
 } else {
  i4 = i14 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i4 >> 0] = 1;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i14 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   i4 = 1;
   break;
  } else {
   HEAP8[i4 >> 0] = 0;
   i4 = 0;
   break;
  }
 } while (0);
 i5 = HEAP32[i16 + 252 >> 2] | 0;
 HEAP32[i14 + 80 >> 2] = i5;
 i6 = HEAP32[i16 + 260 >> 2] | 0;
 HEAP32[i14 + 84 >> 2] = i6;
 i7 = HEAP32[i16 + 256 >> 2] | 0;
 HEAP32[i14 + 88 >> 2] = i7;
 L37 : do if ((i2 | 0) == (i3 | 0)) {
  if (i2 | 0) {
   i1 = 0;
   do {
    if ((HEAP32[i13 + 4 + (i1 << 2) >> 2] | 0) != (HEAP32[i14 + 4 + (i1 << 2) >> 2] | 0)) break L37;
    if ((HEAP32[i13 + 36 + (i1 << 2) >> 2] | 0) != (HEAP32[i14 + 36 + (i1 << 2) >> 2] | 0)) break L37;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  if (i8 << 24 >> 24 == i4 << 24 >> 24) {
   if (!(i8 << 24 >> 24)) {
    if (!((i9 | 0) == (i5 | 0) & (i10 | 0) == (i6 | 0) & (i11 | 0) == (i7 | 0))) break;
   } else {
    if ((HEAP32[i13 + 72 >> 2] | 0) != (HEAP32[i14 + 72 >> 2] | 0)) break;
    if ((HEAP32[i15 >> 2] | 0) != (HEAP32[i12 >> 2] | 0)) break;
    if (!(((i9 | 0) == (i5 | 0) ? (HEAP32[i13 + 76 >> 2] | 0) == (HEAP32[i14 + 76 >> 2] | 0) : 0) & (i10 | 0) == (i6 | 0) & (i11 | 0) == (i7 | 0))) break;
   }
   if (!(HEAP32[i18 + 52 >> 2] & 16)) {
    STACKTOP = i21;
    return;
   }
  }
 } while (0);
 i1 = __Z16GetRealGfxDevicev() | 0;
 if (HEAP8[i1 + 3896 >> 0] | 0) {
  i15 = i1 + 3620 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i16, i18);
 if (HEAP32[i18 + 52 >> 2] & 16 | 0) __ZN18GfxFramebufferGLES7PrepareEv(i16);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 536 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 i3 = HEAP32[i17 >> 2] | 0;
 if (!i3) i19 = 45; else {
  i1 = 1;
  i2 = 0;
  do {
   i1 = (((HEAP32[(HEAP32[i18 + (i2 << 2) >> 2] | 0) + 20 >> 2] | 0) >>> 2 ^ 1) & (i1 & 1) | 0) != 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
  if (i1) i19 = 45; else i1 = 0;
 }
 if ((i19 | 0) == 45) i1 = HEAPU8[(HEAP32[i18 >> 2] | 0) + 31 >> 0] ^ 1;
 i2 = i20 + 7192 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP8[i20 + 7186 >> 0] | 0;
 i1 = i1 << 24 >> 24 != 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 536 >> 0] | 0) i1 = i1 & (HEAP32[i2 >> 2] | 0) < 1;
 i3 = i1 & 1;
 i4 = i20 + 7188 | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i21;
  return;
 }
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 653 >> 0] | 0) {
  i2 = i20 + 4620 | 0;
  if (i1) {
   __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i2, 6);
   break;
  } else {
   __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i2, 6);
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i3;
 STACKTOP = i21;
 return;
}

function __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i1, i22, i17, i18, i2, i12) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 52 | 0;
 i16 = i24 + 48 | 0;
 i4 = i24 + 44 | 0;
 i13 = i24 + 40 | 0;
 i14 = i24 + 36 | 0;
 i20 = i24 + 32 | 0;
 i21 = i24 + 28 | 0;
 i5 = i24 + 24 | 0;
 i6 = i24 + 20 | 0;
 i7 = i24 + 16 | 0;
 i8 = i24 + 12 | 0;
 i9 = i24 + 8 | 0;
 i10 = i24 + 4 | 0;
 i11 = i24;
 switch (i18 | 0) {
 case 2:
  {
   i4 = HEAP32[i22 >> 2] | 0;
   i5 = i4 + -8 | 0;
   HEAP32[i22 >> 2] = i5;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    STACKTOP = i24;
    return;
   }
   HEAP32[i1 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i21 = i1 + 4 | 0;
   i23 = i4 + -4 | 0;
   i22 = HEAP32[i21 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i23 >> 2] = i22;
   STACKTOP = i24;
   return;
  }
 case 1:
 case 0:
  {
   STACKTOP = i24;
   return;
  }
 default:
  {
   if ((i18 | 0) < 1) {
    i9 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i22 >> 2] | 0;
    if ((i9 | 0) == (i8 | 0)) {
     STACKTOP = i24;
     return;
    }
    i1 = i9 + 8 | 0;
    if ((i1 | 0) == (i8 | 0)) {
     STACKTOP = i24;
     return;
    }
    do {
     i2 = i1;
     i7 = i1;
     i6 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 4 >> 2] | 0;
     L12 : do if ((i1 | 0) != (i9 | 0)) {
      i5 = i1;
      do {
       i3 = i5;
       i5 = i5 + -8 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if ((i6 | 0) >= (i4 | 0)) break L12;
       HEAP32[i2 >> 2] = i4;
       HEAP32[i2 + 4 >> 2] = HEAP32[i3 + -4 >> 2];
       i2 = i2 + -8 | 0;
      } while ((i5 | 0) != (i9 | 0));
     } while (0);
     i23 = i2;
     HEAP32[i23 >> 2] = i6;
     HEAP32[i23 + 4 >> 2] = i7;
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i8 | 0));
    STACKTOP = i24;
    return;
   }
   i19 = i18 >>> 1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = i1 + (i19 << 3) | 0;
   if ((i18 | 0) > (i12 | 0)) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
    __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i16, i15, i17, i19, i2, i12);
    HEAP32[i7 >> 2] = i3;
    i22 = HEAP32[i22 >> 2] | 0;
    HEAP32[i8 >> 2] = i22;
    i23 = i18 - i19 | 0;
    HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
    __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i16, i15, i17, i23, i2, i12);
    HEAP32[i9 >> 2] = i1;
    HEAP32[i10 >> 2] = i3;
    HEAP32[i11 >> 2] = i22;
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
    __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi(i4, i16, i15, i17, i19, i23, i2, i12);
    STACKTOP = i24;
    return;
   }
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = i3;
   HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   __ZNSt3__218__stable_sort_moveIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeE(i16, i15, i17, i19, i2);
   HEAP32[i20 >> 2] = i3;
   HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
   i7 = i2 + (i19 << 3) | 0;
   HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
   __ZNSt3__218__stable_sort_moveIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeE(i16, i15, i17, i18 - i19 | 0, i7);
   i6 = i2 + (i18 << 3) | 0;
   i4 = i7;
   while (1) {
    if ((i4 | 0) == (i6 | 0)) break;
    i3 = HEAP32[i4 >> 2] | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) < (i5 | 0)) {
     HEAP32[i1 >> 2] = i3;
     i3 = i4;
     i4 = i4 + 8 | 0;
    } else {
     HEAP32[i1 >> 2] = i5;
     i3 = i2;
     i2 = i2 + 8 | 0;
    }
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    i1 = i1 + 8 | 0;
    if ((i2 | 0) == (i7 | 0)) {
     i23 = 13;
     break;
    }
   }
   if ((i23 | 0) == 13) {
    if ((i4 | 0) == (i6 | 0)) {
     STACKTOP = i24;
     return;
    } else i2 = i4;
    while (1) {
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + 8 | 0;
    }
    STACKTOP = i24;
    return;
   }
   if ((i2 | 0) == (i7 | 0)) {
    STACKTOP = i24;
    return;
   }
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    i2 = i2 + 8 | 0;
    if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 8 | 0;
   }
   STACKTOP = i24;
   return;
  }
 }
}

function runPostSets234() {
 HEAP32[gb + 212208 >> 2] = fb + 3120;
 HEAP32[gb + 212212 >> 2] = fb + 3068;
 HEAP32[gb + 212216 >> 2] = fb + 309;
 HEAP32[gb + 212220 >> 2] = fb + 145;
 HEAP32[gb + 212224 >> 2] = fb + 2348;
 HEAP32[gb + 11960 >> 2] = (HEAP32[gb + 11960 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11964 >> 2] = (HEAP32[gb + 11964 >> 2] | 0) + (gb + 1080266 | 0);
 HEAP32[gb + 11976 >> 2] = (HEAP32[gb + 11976 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11984 >> 2] = (HEAP32[gb + 11984 >> 2] | 0) + (gb + 11992 | 0);
 HEAP32[gb + 11992 >> 2] = (HEAP32[gb + 11992 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11996 >> 2] = (HEAP32[gb + 11996 >> 2] | 0) + (gb + 1080287 | 0);
 HEAP32[gb + 212232 >> 2] = (HEAP32[gb + 212232 >> 2] | 0) + (gb + 12e3 | 0);
 HEAP32[gb + 212236 >> 2] = fb + 3121;
 HEAP32[gb + 212240 >> 2] = fb + 3122;
 HEAP32[gb + 212244 >> 2] = fb + 3068;
 HEAP32[gb + 212248 >> 2] = fb + 310;
 HEAP32[gb + 212252 >> 2] = fb + 146;
 HEAP32[gb + 212256 >> 2] = fb + 2349;
 HEAP32[gb + 12e3 >> 2] = (HEAP32[gb + 12e3 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12004 >> 2] = (HEAP32[gb + 12004 >> 2] | 0) + (gb + 1080438 | 0);
 HEAP32[gb + 12016 >> 2] = (HEAP32[gb + 12016 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12024 >> 2] = (HEAP32[gb + 12024 >> 2] | 0) + (gb + 11992 | 0);
 HEAP32[gb + 212264 >> 2] = (HEAP32[gb + 212264 >> 2] | 0) + (gb + 12088 | 0);
 HEAP32[gb + 212268 >> 2] = fb + 3123;
 HEAP32[gb + 212272 >> 2] = fb + 3124;
 HEAP32[gb + 212276 >> 2] = fb + 3068;
 HEAP32[gb + 212280 >> 2] = fb + 22;
 HEAP32[gb + 212284 >> 2] = fb + 23;
 HEAP32[gb + 212288 >> 2] = fb + 94;
 HEAP32[gb + 212292 >> 2] = fb + 1491;
 HEAP32[gb + 212296 >> 2] = fb + 1492;
 HEAP32[gb + 212300 >> 2] = fb + 95;
 HEAP32[gb + 212304 >> 2] = fb + 1493;
 HEAP32[gb + 212312 >> 2] = (HEAP32[gb + 212312 >> 2] | 0) + (gb + 12032 | 0);
 HEAP32[gb + 212316 >> 2] = fb + 3123;
 HEAP32[gb + 212320 >> 2] = fb + 3125;
 HEAP32[gb + 212324 >> 2] = fb + 3068;
 HEAP32[gb + 212328 >> 2] = fb + 22;
 HEAP32[gb + 212332 >> 2] = fb + 23;
 HEAP32[gb + 212336 >> 2] = fb + 94;
 HEAP32[gb + 212340 >> 2] = fb + 1491;
 HEAP32[gb + 212344 >> 2] = fb + 1492;
 HEAP32[gb + 212348 >> 2] = fb + 95;
 HEAP32[gb + 212352 >> 2] = fb + 1493;
 HEAP32[gb + 12032 >> 2] = (HEAP32[gb + 12032 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12036 >> 2] = (HEAP32[gb + 12036 >> 2] | 0) + (gb + 1080311 | 0);
 HEAP32[gb + 12040 >> 2] = (HEAP32[gb + 12040 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 12048 >> 2] = (HEAP32[gb + 12048 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12052 >> 2] = (HEAP32[gb + 12052 >> 2] | 0) + (gb + 1080346 | 0);
 HEAP32[gb + 12064 >> 2] = (HEAP32[gb + 12064 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12072 >> 2] = (HEAP32[gb + 12072 >> 2] | 0) + (gb + 12080 | 0);
 HEAP32[gb + 12080 >> 2] = (HEAP32[gb + 12080 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 12084 >> 2] = (HEAP32[gb + 12084 >> 2] | 0) + (gb + 1080381 | 0);
 HEAP32[gb + 12088 >> 2] = (HEAP32[gb + 12088 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12092 >> 2] = (HEAP32[gb + 12092 >> 2] | 0) + (gb + 1080404 | 0);
 HEAP32[gb + 12096 >> 2] = (HEAP32[gb + 12096 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 212360 >> 2] = (HEAP32[gb + 212360 >> 2] | 0) + (gb + 12104 | 0);
 HEAP32[gb + 212364 >> 2] = fb + 3126;
 HEAP32[gb + 212368 >> 2] = fb + 3127;
 HEAP32[gb + 212372 >> 2] = fb + 3068;
 HEAP32[gb + 212376 >> 2] = fb + 309;
 HEAP32[gb + 212380 >> 2] = fb + 145;
 HEAP32[gb + 212384 >> 2] = fb + 2348;
 HEAP32[gb + 12104 >> 2] = (HEAP32[gb + 12104 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12108 >> 2] = (HEAP32[gb + 12108 >> 2] | 0) + (gb + 1080459 | 0);
 HEAP32[gb + 12112 >> 2] = (HEAP32[gb + 12112 >> 2] | 0) + (gb + 11960 | 0);
 HEAP32[gb + 212392 >> 2] = (HEAP32[gb + 212392 >> 2] | 0) + (gb + 12120 | 0);
 HEAP32[gb + 212396 >> 2] = fb + 3128;
 HEAP32[gb + 212400 >> 2] = fb + 3129;
 HEAP32[gb + 212404 >> 2] = fb + 3068;
 HEAP32[gb + 212408 >> 2] = fb + 310;
 HEAP32[gb + 212412 >> 2] = fb + 146;
 HEAP32[gb + 212416 >> 2] = fb + 2349;
 HEAP32[gb + 12120 >> 2] = (HEAP32[gb + 12120 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12124 >> 2] = (HEAP32[gb + 12124 >> 2] | 0) + (gb + 1080488 | 0);
 HEAP32[gb + 12128 >> 2] = (HEAP32[gb + 12128 >> 2] | 0) + (gb + 12e3 | 0);
 HEAP32[gb + 212424 >> 2] = (HEAP32[gb + 212424 >> 2] | 0) + (gb + 12136 | 0);
 HEAP32[gb + 212428 >> 2] = fb + 3130;
 HEAP32[gb + 212432 >> 2] = fb + 3131;
 HEAP32[gb + 212436 >> 2] = fb + 3068;
 HEAP32[gb + 212440 >> 2] = fb + 24;
 HEAP32[gb + 212444 >> 2] = fb + 25;
 HEAP32[gb + 212448 >> 2] = fb + 96;
 HEAP32[gb + 212452 >> 2] = fb + 1494;
 HEAP32[gb + 212456 >> 2] = fb + 1495;
 HEAP32[gb + 212460 >> 2] = fb + 97;
 HEAP32[gb + 212464 >> 2] = fb + 1496;
 HEAP32[gb + 12136 >> 2] = (HEAP32[gb + 12136 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12140 >> 2] = (HEAP32[gb + 12140 >> 2] | 0) + (gb + 1080517 | 0);
 HEAP32[gb + 12144 >> 2] = (HEAP32[gb + 12144 >> 2] | 0) + (gb + 12152 | 0);
 HEAP32[gb + 12152 >> 2] = (HEAP32[gb + 12152 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12156 >> 2] = (HEAP32[gb + 12156 >> 2] | 0) + (gb + 1080559 | 0);
 HEAP32[gb + 12168 >> 2] = (HEAP32[gb + 12168 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12176 >> 2] = (HEAP32[gb + 12176 >> 2] | 0) + (gb + 12080 | 0);
 HEAP32[gb + 212472 >> 2] = (HEAP32[gb + 212472 >> 2] | 0) + (gb + 12184 | 0);
 HEAP32[gb + 212476 >> 2] = fb + 3132;
 HEAP32[gb + 212480 >> 2] = fb + 3133;
 HEAP32[gb + 212484 >> 2] = fb + 3068;
 HEAP32[gb + 212488 >> 2] = fb + 26;
 HEAP32[gb + 212492 >> 2] = fb + 27;
 runPostSets235();
}

function __Z25InvertMatrix4x4_General3DPKfPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 i11 = i2 + 20 | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f16 * f12);
 i14 = i2 + 40 | 0;
 f15 = Math_fround(HEAPF32[i14 >> 2]);
 f13 = Math_fround(f13 * f15);
 i3 = !(f13 >= Math_fround(0.0));
 f13 = Math_fround(f13 + Math_fround(0.0));
 f18 = i3 ? Math_fround(0.0) : f13;
 f13 = i3 ? f13 : Math_fround(0.0);
 i3 = i2 + 4 | 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i2 + 24 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f21 = Math_fround(f19 * f5);
 i6 = i2 + 32 | 0;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f21 = Math_fround(f21 * f20);
 i7 = !(f21 >= Math_fround(0.0));
 f24 = Math_fround(f18 + f21);
 f21 = Math_fround(f13 + f21);
 f24 = i7 ? f18 : f24;
 f13 = i7 ? f21 : f13;
 i7 = i2 + 8 | 0;
 f21 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i2 + 16 | 0;
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f23 = Math_fround(f21 * f18);
 i9 = i2 + 36 | 0;
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 f23 = Math_fround(f23 * f10);
 i17 = !(f23 >= Math_fround(0.0));
 f22 = Math_fround(f24 + f23);
 f23 = Math_fround(f13 + f23);
 f22 = i17 ? f24 : f22;
 f13 = i17 ? f23 : f13;
 f21 = Math_fround(f20 * Math_fround(f12 * f21));
 i17 = !(f21 <= Math_fround(-0.0));
 f20 = Math_fround(f22 - f21);
 f21 = Math_fround(f13 - f21);
 f20 = i17 ? f22 : f20;
 f13 = i17 ? f21 : f13;
 f18 = Math_fround(f15 * Math_fround(f19 * f18));
 i17 = !(f18 <= Math_fround(-0.0));
 f19 = Math_fround(f20 - f18);
 f18 = Math_fround(f13 - f18);
 f19 = i17 ? f20 : f19;
 f13 = i17 ? f18 : f13;
 f16 = Math_fround(Math_fround(f16 * f5) * f10);
 i17 = !(f16 <= Math_fround(-0.0));
 f18 = Math_fround(f19 - f16);
 f16 = Math_fround(f13 - f16);
 f13 = Math_fround((i17 ? f19 : f18) + (i17 ? f16 : f13));
 if (+Math_fround(f13 * f13) < 1.0e-25) {
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i17 = 0;
  return i17 | 0;
 } else {
  f25 = Math_fround(Math_fround(1.0) / f13);
  f15 = Math_fround(Math_fround(Math_fround(f12 * f15) - Math_fround(f5 * f10)) * f25);
  HEAPF32[i1 >> 2] = f15;
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i14 >> 2]));
  f16 = Math_fround(HEAPF32[i4 >> 2]);
  f16 = Math_fround(-Math_fround(f25 * Math_fround(f13 - Math_fround(f16 * Math_fround(HEAPF32[i6 >> 2])))));
  HEAPF32[i1 + 16 >> 2] = f16;
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i9 >> 2]));
  f18 = Math_fround(HEAPF32[i11 >> 2]);
  f18 = Math_fround(f25 * Math_fround(f13 - Math_fround(f18 * Math_fround(HEAPF32[i6 >> 2]))));
  HEAPF32[i1 + 32 >> 2] = f18;
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i14 >> 2]));
  f19 = Math_fround(HEAPF32[i7 >> 2]);
  f19 = Math_fround(-Math_fround(f25 * Math_fround(f13 - Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2])))));
  HEAPF32[i1 + 4 >> 2] = f19;
  f13 = Math_fround(HEAPF32[i2 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i14 >> 2]));
  f20 = Math_fround(HEAPF32[i7 >> 2]);
  f20 = Math_fround(f25 * Math_fround(f13 - Math_fround(f20 * Math_fround(HEAPF32[i6 >> 2]))));
  HEAPF32[i1 + 20 >> 2] = f20;
  f13 = Math_fround(HEAPF32[i2 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i9 >> 2]));
  f21 = Math_fround(HEAPF32[i3 >> 2]);
  f21 = Math_fround(-Math_fround(f25 * Math_fround(f13 - Math_fround(f21 * Math_fround(HEAPF32[i6 >> 2])))));
  HEAPF32[i1 + 36 >> 2] = f21;
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i4 >> 2]));
  f22 = Math_fround(HEAPF32[i7 >> 2]);
  f22 = Math_fround(f25 * Math_fround(f13 - Math_fround(f22 * Math_fround(HEAPF32[i11 >> 2]))));
  HEAPF32[i1 + 8 >> 2] = f22;
  f13 = Math_fround(HEAPF32[i2 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i4 >> 2]));
  f23 = Math_fround(HEAPF32[i7 >> 2]);
  f23 = Math_fround(-Math_fround(f25 * Math_fround(f13 - Math_fround(f23 * Math_fround(HEAPF32[i8 >> 2])))));
  HEAPF32[i1 + 24 >> 2] = f23;
  f13 = Math_fround(HEAPF32[i2 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i11 >> 2]));
  f24 = Math_fround(HEAPF32[i3 >> 2]);
  f24 = Math_fround(f25 * Math_fround(f13 - Math_fround(f24 * Math_fround(HEAPF32[i8 >> 2]))));
  HEAPF32[i1 + 40 >> 2] = f24;
  i11 = i2 + 48 | 0;
  f15 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f15);
  i14 = i2 + 52 | 0;
  f16 = Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f16));
  i17 = i2 + 56 | 0;
  HEAPF32[i1 + 48 >> 2] = Math_fround(-Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f18)));
  f19 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f19);
  f20 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f20));
  HEAPF32[i1 + 52 >> 2] = Math_fround(-Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f21)));
  f22 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f22);
  f23 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f23));
  HEAPF32[i1 + 56 >> 2] = Math_fround(-Math_fround(f23 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f24)));
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
  i17 = 1;
  return i17 | 0;
 }
 return 0;
}

function __ZN5Unity11SpringJoint6CreateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 28 | 0;
 i8 = i13;
 i11 = i13 + 56 | 0;
 i12 = i10 + 32 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i9 = 5; else {
  if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) __ZN5Unity5Joint7CleanupEv(i10);
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) i9 = 5;
 }
 if ((i9 | 0) == 5) {
  i6 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
  i5 = i10 + 92 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (!i1) i1 = 0; else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i3 = HEAP32[i7 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 11; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 13;
   }
   if ((i9 | 0) == 11) i9 = 13;
   if ((i9 | 0) == 13) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
    i1 = 0;
    break;
   }
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i3 = HEAP32[i7 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 21;
    }
   }
   if ((i9 | 0) == 19) i9 = 21;
   if ((i9 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   i1 = HEAP32[i1 + 52 >> 2] | 0;
  } while (0);
  i14 = HEAP32[gb + 1457408 >> 2] | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  i1 = __ZN5physx21PxDistanceJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i14, i6, i7, i1, i8) | 0;
  HEAP32[i12 >> 2] = i1;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i10 + 104 >> 2]));
 i1 = HEAP32[i12 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i10 + 108 >> 2]));
 i1 = HEAP32[i12 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i10 + 112 >> 2]));
 i1 = HEAP32[i12 >> 2] | 0;
 f15 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0));
 i1 = i10 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
 if (f15 < f2) {
  mftCall_vif(i4 | 0, i3 | 0, +Math_fround(HEAPF32[i10 + 96 >> 2]));
  i14 = HEAP32[i12 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i14 >> 2] | 0) + 132 >> 2] | 0, i14 | 0, +Math_fround(HEAPF32[i1 >> 2]));
  i14 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i12 = i9 + 164 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i9 = i9 + 172 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = mftCall_ii(i9 | 0, i14 | 0) | 0;
  i9 = i9 & 65535;
  i9 = i9 | 14;
  i9 = i9 & 65535;
  HEAP16[i11 >> 1] = i9;
  mftCall_vii(i12 | 0, i14 | 0, i11 | 0);
  __ZN5Unity5Joint14FinalizeCreateEb(i10, 0);
  STACKTOP = i13;
  return;
 } else {
  mftCall_vif(i4 | 0, i3 | 0, +f2);
  i14 = HEAP32[i12 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i14 >> 2] | 0) + 132 >> 2] | 0, i14 | 0, +Math_fround(HEAPF32[i10 + 96 >> 2]));
  i14 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i12 = i9 + 164 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i9 = i9 + 172 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = mftCall_ii(i9 | 0, i14 | 0) | 0;
  i9 = i9 & 65535;
  i9 = i9 | 14;
  i9 = i9 & 65535;
  HEAP16[i11 >> 1] = i9;
  mftCall_vii(i12 | 0, i14 | 0, i11 | 0);
  __ZN5Unity5Joint14FinalizeCreateEb(i10, 0);
  STACKTOP = i13;
  return;
 }
}

function __ZN20TextRenderingPrivate8FontImpl16SetupDynamicFontEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 24 | 0;
 i8 = i15 + 16 | 0;
 i6 = i15 + 20 | 0;
 i10 = i15;
 i11 = i13 + 92 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i12 = i13 + 204 | 0;
  if (!(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0)) {
   HEAP32[i8 >> 2] = 0;
   i9 = i13 + 80 | 0;
   if (!(_UNITY_FT_New_Memory_Face(HEAP32[gb + 1467876 >> 2] | 0, HEAP32[i9 >> 2] | 0, i1, 0, i8) | 0)) {
    i2 = (HEAP32[i8 >> 2] | 0) + 20 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     HEAP32[i2 >> 2] = gb + 946169;
     i1 = gb + 946169 | 0;
    }
    i5 = i13 + 100 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i3 = HEAP32[i2 >> 2] | 0; else i3 = i2;
    if (_strcmp(i3, i1) | 0) {
     HEAP32[i6 >> 2] = i2;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     HEAP32[i10 + 8 >> 2] = 0;
     i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
     HEAP32[i10 + 12 >> 2] = i2;
     i4 = _strlen(i1) | 0;
     if (i4 >>> 0 > 2147483631) {
      __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
      i2 = HEAP32[i10 + 12 >> 2] | 0;
      i7 = 14;
     } else if (i4 >>> 0 < 11) {
      i3 = i10 + 11 | 0;
      HEAP8[i3 >> 0] = i4;
      if (!i4) {
       i2 = i10;
       i1 = i3;
      } else {
       i2 = i10;
       i7 = 16;
      }
     } else i7 = 14;
     if ((i7 | 0) == 14) {
      i3 = i4 + 16 & -16;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i14 + 4 >> 2] = i2;
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
      HEAP32[i10 >> 2] = i2;
      HEAP32[i10 + 8 >> 2] = i3 | -2147483648;
      HEAP32[i10 + 4 >> 2] = i4;
      i3 = i10 + 11 | 0;
      i7 = 16;
     }
     if ((i7 | 0) == 16) {
      _memcpy(i2 | 0, i1 | 0, i4 | 0) | 0;
      i1 = i3;
     }
     HEAP8[i2 + i4 >> 0] = 0;
     HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
     __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_(i5, i14, i10) | 0;
     if ((HEAP8[i1 >> 0] | 0) < 0) {
      i7 = HEAP32[i10 >> 2] | 0;
      i6 = HEAP32[i10 + 12 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i14 + 4 >> 2] = i6;
      __Z19free_alloc_internalPvRK10MemLabelId(i7, i14);
     }
     i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0;
    };
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    HEAP32[i10 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i1, _strlen(i1) | 0);
    i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i10);
    i1 = i14 + 12 | 0;
    HEAP32[i1 >> 2] = i7 << 1 & 2 | i7 >>> 1 & 1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    i10 = HEAP32[i8 >> 2] | 0;
    HEAP32[(__ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(HEAP32[i12 >> 2] | 0, i14) | 0) >> 2] = i10;
    if (HEAP32[i1 >> 2] | 0) {
     HEAP32[i1 >> 2] = 0;
     if (!(_UNITY_FT_New_Memory_Face(HEAP32[gb + 1467876 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] | 0, 0, i8) | 0)) {
      i11 = HEAP32[i8 >> 2] | 0;
      HEAP32[(__ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(HEAP32[i12 >> 2] | 0, i14) | 0) >> 2] = i11;
     }
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 946137 | 0, 0, gb + 945383 | 0, 801, 1, 0, 0, 0);
  }
 }
 i3 = i13 + 192 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0))) {
  STACKTOP = i15;
  return;
 }
 i1 = i13 + 204 | 0;
 i4 = i13 + 76 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i2 = i13 + 116 | 0;
 if (__ZN20TextRenderingPrivate15DynamicFontData21GetFontMetricsForFaceERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEiRKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEPfSI_(HEAP32[i1 >> 2] | 0, i13 + 100 | 0, HEAP32[i12 + 36 >> 2] | 0, i2, i3, i12 + 32 | 0) | 0) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 i12 = __ZN20TextRenderingPrivate12GetFallbacksEv() | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 if (__ZN20TextRenderingPrivate15DynamicFontData21GetFontMetricsForFaceERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEiRKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEPfSI_(i11, i12, HEAP32[i13 + 36 >> 2] | 0, i2, i3, i13 + 32 | 0) | 0) {
  STACKTOP = i15;
  return;
 };
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 1017543 | 0, 9);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i14) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 HEAPF32[i3 >> 2] = Math_fround(__ZNK13TextRendering4Font9GetAscentEv(i1));
 HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN12TreeRenderer17PopulateRenderersEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i3 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i16;
  return;
 }
 i2 = (i1 - i2 | 0) / 156 | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i3 + (i1 * 156 | 0) + 4 >> 2] | 0) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i14 = 45;
   break;
  }
 }
 if ((i14 | 0) == 45) {
  STACKTOP = i16;
  return;
 }
 __ZN12TreeRenderer24InitializePrototypeInfosEv(i15);
 i10 = HEAP32[i15 >> 2] | 0;
 i9 = i10 + 16 | 0;
 i10 = i10 + 20 | 0;
 __ZN15LODGroupManager21ReserveInternalArraysEj(i15 + 304 | 0, (((HEAP32[i10 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 40 | 0) + 1 | 0);
 i11 = i15 + 236 | 0;
 i1 = ((HEAP32[i10 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 40 | 0;
 i2 = i15 + 248 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i15 + 252 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i15 + 240 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 240 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  break;
 } while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) != (i1 | 0)) {
  i8 = 0;
  do {
   i6 = HEAP32[i1 + (i8 * 40 | 0) + 32 >> 2] | 0;
   i7 = HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0;
   i5 = i7 + (i6 * 156 | 0) + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if ((i1 | 0) == 2) {
    i4 = HEAP32[i7 + (i6 * 156 | 0) + 8 >> 2] | 0;
    if (!i4) i14 = 36; else {
     HEAP32[i13 >> 2] = i4;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i14 = 20; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
       i2 = HEAP32[i12 >> 2] | 0;
       i17 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 20; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i14 = 22;
     }
     if ((i14 | 0) == 20) i14 = 22;
     if ((i14 | 0) == 22) {
      i14 = 0;
      if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
       i1 = HEAP32[i5 >> 2] | 0;
       i14 = 25;
       break;
      }
     }
     __ZN12TreeRenderer25CreateLODRenderersForTreeEi(i15, i8);
    }
   } else i14 = 25; while (0);
   do if ((i14 | 0) == 25) {
    i14 = 0;
    if ((i1 | 0) == 1) {
     i4 = HEAP32[i7 + (i6 * 156 | 0) + 16 >> 2] | 0;
     if (!i4) i14 = 36; else {
      HEAP32[i13 >> 2] = i4;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i14 = 32; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
        i2 = HEAP32[i12 >> 2] | 0;
        i17 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 32; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i14 = 34;
      }
      if ((i14 | 0) == 32) i14 = 34;
      if ((i14 | 0) == 34) {
       i14 = 0;
       if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
        i14 = 36;
        break;
       }
      }
      __ZN12TreeRenderer29CreateMeshTreeRendererForTreeEi(i15, i8);
     }
    } else i14 = 36;
   } while (0);
   if ((i14 | 0) == 36) {
    i14 = 0;
    HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] = -1;
   }
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } while (i8 >>> 0 < (((HEAP32[i10 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0);
 }
 i5 = i15 + 392 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i4 = i15 + 380 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i1 + (i3 * 88 | 0) + 80 >> 2] | 0;
  if (i2 | 0) if (!(HEAP32[i2 + 44 >> 2] | 0)) __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i2, 0);
  i1 = HEAP32[i1 + (i3 * 88 | 0) + 84 >> 2] | 0;
  if (i1 | 0) if (!(HEAP32[i1 + 44 >> 2] | 0)) __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i1, 1);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx31PxProfileBulkMemoryEventHandler16parseEventBufferEPKhjRS0_bPNS_19PxAllocatorCallbackE(i4, i5, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!i1) {
  i13 = _PxGetFoundation() | 0;
  i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0) | 0;
 } else i13 = i1;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, 131080, gb + 766896 | 0, gb + 740601 | 0, 223) | 0;
 i10 = i12 + 131072 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 131076 | 0;
 HEAP32[i11 >> 2] = i2;
 if (i3) {
  HEAP32[i14 >> 2] = i13;
  i8 = i14 + 4 | 0;
  HEAP32[i8 >> 2] = i14;
  i9 = i14 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAPF32[i14 + 32 >> 2] = Math_fround(.75);
  HEAP32[i14 + 36 >> 2] = -1;
  HEAP32[i14 + 40 >> 2] = 0;
  HEAP32[i14 + 44 >> 2] = 0;
  __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i8, 64);
  i8 = i14 + 48 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP8[i8 + 8 >> 0] = 0;
  __ZN5physx7profile14parseEventDataILb1ENS0_17MemoryEventParserILb1EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_(i14, i4, i5, i12) | 0;
  i8 = i14 + 20 | 0;
  L6 : do if (!(HEAP32[i14 + 24 >> 2] | 0)) {
   i1 = -1;
   i2 = 0;
  } else {
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i3 = HEAP32[i14 + 28 >> 2] | 0;
    i1 = 0;
    while (1) {
     i2 = i1 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) {
      i1 = -1;
      i2 = i3;
      break L6;
     }
     i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) i1 = i2; else break;
    }
   } else i2 = 0;
  } while (0);
  i6 = i14 + 12 | 0;
  i7 = i14 + 16 | 0;
  i5 = i14 + 28 | 0;
  L13 : while (1) {
   do {
    if ((i1 | 0) == -1) break L13;
    i4 = HEAP32[i14 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
    i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   } while ((i1 | 0) != -1);
   i4 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   while (1) {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i1 = -1;
     i2 = i4;
     continue L13;
    }
    i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) != -1) continue L13;
   }
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i14 = HEAP32[HEAP32[i14 + 4 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
  }
 } else {
  HEAP32[i14 >> 2] = i13;
  i8 = i14 + 4 | 0;
  HEAP32[i8 >> 2] = i14;
  i9 = i14 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAPF32[i14 + 32 >> 2] = Math_fround(.75);
  HEAP32[i14 + 36 >> 2] = -1;
  HEAP32[i14 + 40 >> 2] = 0;
  HEAP32[i14 + 44 >> 2] = 0;
  __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i8, 64);
  i8 = i14 + 48 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP8[i8 + 8 >> 0] = 0;
  __ZN5physx7profile14parseEventDataILb0ENS0_17MemoryEventParserILb0EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_(i14, i4, i5, i12) | 0;
  i8 = i14 + 20 | 0;
  L27 : do if (!(HEAP32[i14 + 24 >> 2] | 0)) {
   i1 = -1;
   i2 = 0;
  } else {
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i3 = HEAP32[i14 + 28 >> 2] | 0;
    i1 = 0;
    while (1) {
     i2 = i1 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) {
      i1 = -1;
      i2 = i3;
      break L27;
     }
     i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) i1 = i2; else break;
    }
   } else i2 = 0;
  } while (0);
  i6 = i14 + 12 | 0;
  i7 = i14 + 16 | 0;
  i5 = i14 + 28 | 0;
  L34 : while (1) {
   do {
    if ((i1 | 0) == -1) break L34;
    i4 = HEAP32[i14 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
    i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   } while ((i1 | 0) != -1);
   i4 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   while (1) {
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i1 = -1;
     i2 = i4;
     continue L34;
    }
    i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) != -1) continue L34;
   }
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i14 = HEAP32[HEAP32[i14 + 4 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  HEAP32[i10 >> 2] = 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i14 = i14 + 12 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  mftCall_vii(i14 | 0, i13 | 0, i12 | 0);
  STACKTOP = i15;
  return;
 }
 i14 = HEAP32[i11 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i12 | 0, i1 | 0);
 HEAP32[i10 >> 2] = 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i14 = i14 + 12 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 mftCall_vii(i14 | 0, i13 | 0, i12 | 0);
 STACKTOP = i15;
 return;
}

function __ZNSt3__28ios_base4InitC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[gb + 191748 >> 2] | 0;
 __ZNSt3__210__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(gb + 1474188 | 0, i1, gb + 1474244 | 0);
 HEAP32[gb + 1473508 >> 2] = gb + 208792 + 12;
 HEAP32[gb + 1473508 + 8 >> 2] = gb + 208792 + 32;
 HEAP32[gb + 1473508 + 4 >> 2] = 0;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473508 + 8 | 0, gb + 1474188 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(gb + 1473508 + 8 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473508 + 80 >> 2] = 0;
 HEAP32[gb + 1473508 + 84 >> 2] = -1;
 __ZNSt3__210__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(gb + 1474252 | 0, i1, gb + 1474308 | 0);
 HEAP32[gb + 1473596 >> 2] = gb + 208840 + 12;
 HEAP32[gb + 1473596 + 8 >> 2] = gb + 208840 + 32;
 HEAP32[gb + 1473596 + 4 >> 2] = 0;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473596 + 8 | 0, gb + 1474252 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev(gb + 1473596 + 8 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473596 + 80 >> 2] = 0;
 HEAP32[gb + 1473596 + 84 >> 2] = -1;
 i1 = HEAP32[gb + 191868 >> 2] | 0;
 __ZNSt3__211__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(gb + 1474316 | 0, i1, gb + 1474364 | 0);
 HEAP32[gb + 1473684 >> 2] = gb + 208888 + 12;
 HEAP32[gb + 1473684 + 4 >> 2] = gb + 208888 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473684 + 4 | 0, gb + 1474316 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(gb + 1473684 + 4 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473684 + 76 >> 2] = 0;
 HEAP32[gb + 1473684 + 80 >> 2] = -1;
 __ZNSt3__211__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(gb + 1474372 | 0, i1, gb + 1474420 | 0);
 HEAP32[gb + 1473768 >> 2] = gb + 208936 + 12;
 HEAP32[gb + 1473768 + 4 >> 2] = gb + 208936 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473768 + 4 | 0, gb + 1474372 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev(gb + 1473768 + 4 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473768 + 76 >> 2] = 0;
 HEAP32[gb + 1473768 + 80 >> 2] = -1;
 i1 = HEAP32[gb + 191628 >> 2] | 0;
 __ZNSt3__211__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(gb + 1474428 | 0, i1, gb + 1474476 | 0);
 HEAP32[gb + 1473852 >> 2] = gb + 208888 + 12;
 HEAP32[gb + 1473852 + 4 >> 2] = gb + 208888 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473852 + 4 | 0, gb + 1474428 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(gb + 1473852 + 4 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473852 + 76 >> 2] = 0;
 HEAP32[gb + 1473852 + 80 >> 2] = -1;
 i2 = HEAP32[(HEAP32[(HEAP32[gb + 1473852 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473852) + 24 >> 2] | 0;
 HEAP32[gb + 1474020 >> 2] = gb + 208888 + 12;
 HEAP32[gb + 1474020 + 4 >> 2] = gb + 208888 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1474020 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(gb + 1474020 + 4 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1474020 + 76 >> 2] = 0;
 HEAP32[gb + 1474020 + 80 >> 2] = -1;
 __ZNSt3__211__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(gb + 1474484 | 0, i1, gb + 1474532 | 0);
 HEAP32[gb + 1473936 >> 2] = gb + 208936 + 12;
 HEAP32[gb + 1473936 + 4 >> 2] = gb + 208936 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1473936 + 4 | 0, gb + 1474484 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev(gb + 1473936 + 4 | 0);
  ___resumeException(i2 | 0);
 }
 HEAP32[gb + 1473936 + 76 >> 2] = 0;
 HEAP32[gb + 1473936 + 80 >> 2] = -1;
 i2 = HEAP32[(HEAP32[(HEAP32[gb + 1473936 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473936) + 24 >> 2] | 0;
 HEAP32[gb + 1474104 >> 2] = gb + 208936 + 12;
 HEAP32[gb + 1474104 + 4 >> 2] = gb + 208936 + 32;
 __THREW__ = 0;
 invoke_vii(fb + 4510 | 0, gb + 1474104 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev(gb + 1474104 + 4 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[gb + 1474104 + 76 >> 2] = 0;
  HEAP32[gb + 1474104 + 80 >> 2] = -1;
  HEAP32[(HEAP32[(HEAP32[gb + 1473508 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473508) + 72 >> 2] = gb + 1473684;
  HEAP32[(HEAP32[(HEAP32[gb + 1473596 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473596) + 72 >> 2] = gb + 1473768;
  i2 = (HEAP32[(HEAP32[gb + 1473852 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473852) + 4 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8192;
  i2 = (HEAP32[(HEAP32[gb + 1473936 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473936) + 4 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8192;
  HEAP32[(HEAP32[(HEAP32[gb + 1473852 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473852) + 72 >> 2] = gb + 1473684;
  HEAP32[(HEAP32[(HEAP32[gb + 1473936 >> 2] | 0) + -12 >> 2] | 0) + (gb + 1473936) + 72 >> 2] = gb + 1473768;
  return;
 }
}

function __ZN5physx14PxsAABBManagerC2ERNS_2Cm13EventProfilerERNS_19PxcScratchAllocatorE(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 1073741823;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 1073741823;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 1073741823;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i5 + 80 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 HEAP32[i5 + 88 >> 2] = 0;
 HEAP32[i5 + 92 >> 2] = 64;
 HEAP32[i5 + 96 >> 2] = 0;
 HEAP32[i5 + 100 >> 2] = 0;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 112 >> 2] = 0;
 HEAP32[i5 + 116 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 64;
 HEAP32[i5 + 124 >> 2] = 0;
 HEAP32[i5 + 128 >> 2] = 0;
 HEAP32[i5 + 136 >> 2] = 0;
 HEAP32[i5 + 140 >> 2] = 0;
 HEAP32[i5 + 144 >> 2] = 0;
 HEAP32[i5 + 148 >> 2] = 64;
 i1 = i5 + 208 | 0;
 i3 = i5 + 152 | 0;
 i4 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 1073741822;
 i1 = i5 + 212 | 0;
 HEAP32[i5 + 232 >> 2] = 0;
 HEAP32[i5 + 236 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i5 + 244 | 0;
 HEAP32[i5 + 280 >> 2] = 0;
 HEAP32[i5 + 284 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i5 + 292 >> 2] = 1073741823;
 i1 = i5 + 296 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i5 + 328 >> 2] = 1073741823;
 HEAP32[i5 + 332 >> 2] = 0;
 HEAP32[i5 + 336 >> 2] = 0;
 HEAP32[i5 + 340 >> 2] = 1073741823;
 HEAP32[i5 + 344 >> 2] = 0;
 HEAP32[i5 + 348 >> 2] = 0;
 HEAP32[i5 + 352 >> 2] = 1073741823;
 HEAP32[i5 + 356 >> 2] = 0;
 HEAP32[i5 + 360 >> 2] = 0;
 HEAP32[i5 + 368 >> 2] = 0;
 HEAP32[i5 + 372 >> 2] = 0;
 HEAP32[i5 + 376 >> 2] = 0;
 HEAP32[i5 + 380 >> 2] = 64;
 HEAP32[i5 + 16896 >> 2] = i2;
 HEAP32[i5 + 16900 >> 2] = 0;
 HEAP32[i5 + 16904 >> 2] = 0;
 HEAP32[i5 + 16912 >> 2] = 0;
 HEAP32[i5 + 33312 >> 2] = i2;
 HEAP32[i5 + 33316 >> 2] = 0;
 HEAP32[i5 + 33320 >> 2] = 0;
 HEAP32[i5 + 33328 >> 2] = 0;
 HEAP32[i5 + 37440 >> 2] = i2;
 HEAP32[i5 + 37444 >> 2] = 0;
 HEAP32[i5 + 37448 >> 2] = 0;
 HEAP32[i5 + 41552 >> 2] = i2;
 HEAP32[i5 + 41556 >> 2] = 0;
 HEAP32[i5 + 41560 >> 2] = 0;
 HEAP32[i5 + 41568 >> 2] = 0;
 HEAP32[i5 + 45680 >> 2] = i2;
 HEAP32[i5 + 45684 >> 2] = 0;
 HEAP32[i5 + 45688 >> 2] = 0;
 HEAP32[i5 + 45696 >> 2] = 0;
 HEAP32[i5 + 49808 >> 2] = i2;
 HEAP32[i5 + 49812 >> 2] = 0;
 HEAP32[i5 + 49816 >> 2] = 0;
 i1 = i5 + 49868 | 0;
 i3 = i5 + 49824 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx14SingleAABBTaskC2Ev(i1);
 __ZN5physx13ActorAABBTaskC2Ev(i5 + 50324 | 0);
 __ZN5physx17AggregateAABBTaskC2Ev(i5 + 50608 | 0);
 i4 = i5 + 51012 | 0;
 HEAP16[i5 + 51016 >> 1] = -1;
 HEAP16[i5 + 51018 >> 1] = 0;
 HEAP32[i5 + 51020 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 51024 >> 2] = 0;
 HEAP32[i5 + 51028 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 104236 + 8;
 HEAP32[i5 + 51032 >> 2] = 0;
 i4 = i5 + 51056 | 0;
 HEAP16[i5 + 51060 >> 1] = -1;
 HEAP16[i5 + 51062 >> 1] = 0;
 HEAP32[i5 + 51064 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 51068 >> 2] = 0;
 HEAP32[i5 + 51072 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 104280 + 8;
 HEAP32[i5 + 51096 >> 2] = 0;
 __ZN5physx14SingleAABBTaskC2Ev(i5 + 51100 | 0);
 i4 = i5 + 51556 | 0;
 HEAP16[i5 + 51560 >> 1] = -1;
 HEAP16[i5 + 51562 >> 1] = 0;
 HEAP32[i5 + 51564 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 51568 >> 2] = 0;
 HEAP32[i5 + 51572 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 104324 + 8;
 i4 = i5 + 51596 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i5 + 384 >> 2] = 1;
 HEAP32[i5 + 388 >> 2] = 2;
 HEAP32[i5 + 392 >> 2] = 4;
 HEAP32[i5 + 396 >> 2] = 8;
 HEAP32[i5 + 400 >> 2] = 16;
 HEAP32[i5 + 404 >> 2] = 32;
 HEAP32[i5 + 408 >> 2] = 64;
 HEAP32[i5 + 412 >> 2] = 128;
 HEAP32[i5 + 416 >> 2] = 256;
 HEAP32[i5 + 420 >> 2] = 512;
 HEAP32[i5 + 424 >> 2] = 1024;
 HEAP32[i5 + 428 >> 2] = 2048;
 HEAP32[i5 + 432 >> 2] = 4096;
 HEAP32[i5 + 436 >> 2] = 8192;
 HEAP32[i5 + 440 >> 2] = 16384;
 HEAP32[i5 + 444 >> 2] = 32768;
 HEAP32[i5 + 448 >> 2] = 65536;
 HEAP32[i5 + 452 >> 2] = 131072;
 HEAP32[i5 + 456 >> 2] = 262144;
 HEAP32[i5 + 460 >> 2] = 524288;
 HEAP32[i5 + 464 >> 2] = 1048576;
 HEAP32[i5 + 468 >> 2] = 2097152;
 HEAP32[i5 + 472 >> 2] = 4194304;
 HEAP32[i5 + 476 >> 2] = 8388608;
 HEAP32[i5 + 480 >> 2] = 16777216;
 HEAP32[i5 + 484 >> 2] = 33554432;
 HEAP32[i5 + 488 >> 2] = 67108864;
 HEAP32[i5 + 492 >> 2] = 134217728;
 HEAP32[i5 + 496 >> 2] = 268435456;
 HEAP32[i5 + 500 >> 2] = 536870912;
 HEAP32[i5 + 504 >> 2] = 1073741824;
 HEAP32[i5 + 508 >> 2] = -2147483648;
 __ZN5physx14PxsAABBManager11preAllocateEjjj(i5, 64, 64, 0);
 return;
}

function __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i8);
 i3 = i4 + 28 | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i4 + 32 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i4 + 48 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i4 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i4 + 64 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i4 + 76 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i4 + 80 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i4 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 i3 = i4 + 108 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 i3 = i4 + 124 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 i3 = i4 + 140 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN9ShaderLab10SubProgram7CompileEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i29 + 8 | 0;
 i15 = i29;
 i27 = i29 + 64 | 0;
 i22 = i29 + 48 | 0;
 i24 = i29 + 36 | 0;
 i25 = i29 + 16 | 0;
 if ((HEAP16[gb + 1166520 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166520 | 0, i14);
  i26 = gb + 1166520 | 0;
 } else i26 = 0;
 i6 = __Z12GetGfxDevicev() | 0;
 __ZN22CreateGpuProgramOutputC2Ev(i27);
 HEAP32[i22 >> 2] = 0;
 i28 = i22 + 4 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i3 = i15;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = i20;
 HEAP32[i25 >> 2] = 0;
 i3 = i25 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i20 = i25 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i15);
 i18 = i14;
 i23 = HEAP32[i18 + 4 >> 2] | 0;
 i17 = i21;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = i23;
 i17 = i19 + 8 | 0;
 do if (!(HEAP32[i17 >> 2] | 0)) {
  i4 = HEAP32[i19 + 48 >> 2] | 0;
  i23 = i19 + 72 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i24, i23) | 0;
  i18 = i19 + 52 | 0;
  if ((i18 | 0) != (i25 | 0)) {
   i5 = HEAP32[i18 >> 2] | 0;
   i1 = HEAP32[i19 + 64 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[i20 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i20 >> 2] = i1;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i25 >> 2] | 0, i1, 1, i21, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i25 >> 2] = i1;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i21, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i20 >> 2] = i1;
    HEAP32[i25 >> 2] = i13;
    i1 = i13;
    break;
   } else i1 = HEAP32[i25 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0;
  }
  HEAP32[i27 + 8 >> 2] = i22;
  HEAP32[i27 + 12 >> 2] = i24;
  i1 = mftCall_iiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 192 >> 2] | 0, i6 | 0, i4 | 0, i25 | 0, i27 | 0) | 0;
  i2 = (i1 | 0) == 0;
  if (!i2) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 692 >> 2] | 0, i6 | 0, i1 | 0, ((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24) | 0);
  if (HEAP32[i17 >> 2] | 0) {
   if (i2) break;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 208 >> 2] | 0, i6 | 0, i1 | 0);
   break;
  }
  HEAP32[i17 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i23, i24) | 0;
  i12 = HEAP32[i19 + 84 >> 2] | 0;
  i1 = HEAP32[i28 >> 2] | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i13 = i12 + 4 | 0;
   i11 = 0;
   do {
    i9 = i2 + (i11 << 2) | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i10 = HEAP32[i13 >> 2] | 0;
    i3 = i10 - i4 >> 2;
    if (!i3) i3 = i4; else {
     i8 = HEAP32[i9 >> 2] | 0;
     i7 = i3;
     i3 = i4;
     i5 = i4;
     while (1) {
      i30 = (i7 | 0) / 2 | 0;
      i4 = i5 + (i30 << 2) | 0;
      i6 = (HEAP32[i4 >> 2] | 0) < (i8 | 0);
      i4 = i4 + 4 | 0;
      i3 = i6 ? i4 : i3;
      i7 = i6 ? i7 + -1 - i30 | 0 : i30;
      if (!i7) break; else i5 = i6 ? i4 : i5;
     }
    }
    i4 = i3;
    if ((i3 | 0) == (i10 | 0)) i16 = 22; else if ((HEAP32[i9 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) i16 = 22;
    if ((i16 | 0) == 22) {
     i16 = 0;
     HEAP32[i15 >> 2] = i4;
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i12, i14, i9) | 0;
     i1 = HEAP32[i28 >> 2] | 0;
     i2 = HEAP32[i22 >> 2] | 0;
    }
    i11 = i11 + 1 | 0;
   } while (i11 >>> 0 < i1 - i2 >> 2 >>> 0);
  }
  i1 = HEAP32[i27 >> 2] | 0;
  if (i1 | 0) __ZN20GpuProgramParametersaSERKS_(HEAP32[i19 >> 2] | 0, i1) | 0;
  i1 = HEAP32[i27 + 4 >> 2] | 0;
  if (i1 | 0) HEAP32[i19 + 4 >> 2] = HEAP32[i1 >> 2];
  if (HEAP32[i17 >> 2] | 0) {
   i1 = i19 + 68 | 0;
   if ((HEAP32[i1 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i19 + 56 | 0);
    HEAP32[i18 >> 2] = 0;
   }
   HEAP32[i18 >> 2] = 0;
   HEAP32[i19 + 64 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = i23 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i23 >> 2] >> 0] = 0;
    HEAP32[i19 + 76 >> 2] = 0;
    break;
   } else {
    HEAP8[i23 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
    break;
   }
  }
 } while (0);
 if ((HEAP32[i20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i21);
  HEAP32[i25 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 i1 = HEAP32[i22 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i28 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i28 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 __ZN22CreateGpuProgramOutputD2Ev(i27);
 if (!i26) {
  STACKTOP = i29;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i26);
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu17rayAABBIntersect2ERKNS_6PxVec3ES3_S3_S3_RS1_Rf(i14, i18, i13, i16, i17, i19) {
 i14 = i14 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20;
 HEAPF32[i12 >> 2] = Math_fround(-1.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(-1.0);
 f3 = Math_fround(HEAPF32[i13 >> 2]);
 f1 = Math_fround(HEAPF32[i14 >> 2]);
 if (f3 < f1) {
  HEAPF32[i17 >> 2] = f1;
  i2 = HEAP32[i16 >> 2] | 0;
  if (!i2) {
   f8 = Math_fround(-1.0);
   i2 = 0;
  } else {
   f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = Math_fround(HEAPF32[i14 >> 2]);
   f8 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i13 >> 2])) / f8);
   HEAPF32[i12 >> 2] = f8;
   i2 = 0;
  }
 } else {
  f1 = Math_fround(HEAPF32[i18 >> 2]);
  if (f3 > f1) {
   HEAPF32[i17 >> 2] = f1;
   i2 = HEAP32[i16 >> 2] | 0;
   if (!i2) {
    f8 = Math_fround(-1.0);
    i2 = 0;
   } else {
    f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = Math_fround(HEAPF32[i18 >> 2]);
    f8 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i13 >> 2])) / f8);
    HEAPF32[i12 >> 2] = f8;
    i2 = 0;
   }
  } else {
   f8 = Math_fround(-1.0);
   i2 = 1;
  }
 }
 i10 = i13 + 4 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i14 + 4 | 0;
 f1 = Math_fround(HEAPF32[i11 >> 2]);
 if (f3 < f1) {
  HEAPF32[i17 + 4 >> 2] = f1;
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  if (!i2) {
   f6 = Math_fround(-1.0);
   i2 = 0;
  } else {
   f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i10 >> 2])) / f6);
   HEAPF32[i12 + 4 >> 2] = f6;
   i2 = 0;
  }
 } else {
  i4 = i18 + 4 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  if (f3 > f1) {
   HEAPF32[i17 + 4 >> 2] = f1;
   i2 = HEAP32[i16 + 4 >> 2] | 0;
   if (!i2) {
    f6 = Math_fround(-1.0);
    i2 = 0;
   } else {
    f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(HEAPF32[i4 >> 2]);
    f6 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i10 >> 2])) / f6);
    HEAPF32[i12 + 4 >> 2] = f6;
    i2 = 0;
   }
  } else f6 = Math_fround(-1.0);
 }
 i7 = i13 + 8 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i14 + 8 | 0;
 f1 = Math_fround(HEAPF32[i9 >> 2]);
 do if (f3 < f1) {
  HEAPF32[i17 + 8 >> 2] = f1;
  i2 = HEAP32[i16 + 8 >> 2] | 0;
  if (!i2) f1 = Math_fround(-1.0); else {
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i9 >> 2]);
   f1 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i7 >> 2])) / f1);
   HEAPF32[i12 + 8 >> 2] = f1;
  }
 } else {
  i4 = i18 + 8 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  if (f3 > f1) {
   HEAPF32[i17 + 8 >> 2] = f1;
   i2 = HEAP32[i16 + 8 >> 2] | 0;
   if (!i2) {
    f1 = Math_fround(-1.0);
    break;
   }
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i4 >> 2]);
   f1 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i7 >> 2])) / f1);
   HEAPF32[i12 + 8 >> 2] = f1;
   break;
  }
  if (!i2) f1 = Math_fround(-1.0); else {
   HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   i19 = 1;
   STACKTOP = i20;
   return i19 | 0;
  }
 } while (0);
 i5 = f6 > f8 & 1;
 i2 = f1 > Math_fround(HEAPF32[i12 + (i5 << 2) >> 2]);
 i5 = i2 ? 2 : i5;
 i4 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i4 | 0) < 0) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 do if (!i5) i15 = 15; else {
  f1 = Math_fround(HEAPF32[i13 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i17 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i14 >> 2]) + Math_fround(-9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i18 >> 2]) + Math_fround(9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  } else if ((i5 | 0) == 1) break; else {
   i15 = 15;
   break;
  }
 } while (0);
 if ((i15 | 0) == 15) {
  f1 = Math_fround(HEAPF32[i10 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i16 + 4 >> 2])));
  HEAPF32[i17 + 4 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(-9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) + Math_fround(9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
 }
 if (!i2) {
  f1 = Math_fround(HEAPF32[i7 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i16 + 8 >> 2])));
  HEAPF32[i17 + 8 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i9 >> 2]) + Math_fround(-9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) + Math_fround(9.99999974e-06))) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
 }
 HEAP32[i19 >> 2] = i4;
 i19 = i5 + 1 | 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZNK7VRInput22GetWorldToCameraMatrixERK8UnityStr4PPtrI9TransformE(i8, i4, i1, i2) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i5 = i10;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i8, i9) | 0;
 i1 = __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_(i4 + 20 | 0, i1) | 0;
 if ((i1 | 0) != (i4 + 24 | 0)) {
  f11 = Math_fround(-Math_fround(HEAPF32[i1 + 44 >> 2]));
  f12 = Math_fround(-Math_fround(HEAPF32[i1 + 48 >> 2]));
  f13 = Math_fround(-Math_fround(HEAPF32[i1 + 52 >> 2]));
  i6 = HEAP32[i1 + 56 >> 2] | 0;
  HEAPF32[i5 >> 2] = f11;
  HEAPF32[i5 + 4 >> 2] = f12;
  HEAPF32[i5 + 8 >> 2] = f13;
  HEAP32[i5 + 12 >> 2] = i6;
  __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i5, i9);
  __ZN10Matrix4x4fmLERKS_(i8, i9) | 0;
  f13 = Math_fround(-Math_fround(HEAPF32[i1 + 32 >> 2]));
  f12 = Math_fround(-Math_fround(HEAPF32[i1 + 36 >> 2]));
  f11 = Math_fround(-Math_fround(HEAPF32[i1 + 40 >> 2]));
  HEAPF32[i5 >> 2] = f13;
  HEAPF32[i5 + 4 >> 2] = f12;
  HEAPF32[i5 + 8 >> 2] = f11;
  __ZN10Matrix4x4f9TranslateERK8Vector3f(i8, i5) | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
   i2 = HEAP32[i9 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 11;
 }
 if ((i7 | 0) == 9) i7 = 11;
 if ((i7 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i4 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i7 = 20; else {
  i1 = i4;
  L21 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i6 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L21; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i4 | 0)) i7 = 20; else if ((i6 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i7 = 20; else i1 = i1 + 20 | 0;
 }
 if ((i7 | 0) == 20) if (!(HEAP8[gb + 1573589 >> 0] | 0)) {
  HEAP32[gb + 1469228 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[gb + 1469228 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[gb + 1469228 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[gb + 1469228 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1469228 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1469228 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[gb + 1469228 + 24 >> 2] = Math_fround(1.0);
  i1 = gb + 1469228 + 28 | 0;
  i2 = gb + 1162292 | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP8[gb + 1573589 >> 0] = 1;
  i1 = gb + 1469228 | 0;
 } else i1 = gb + 1469228 | 0;
 __ZN10Matrix4x4fmLERKS_(i8, i1 + 28 | 0) | 0;
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 27; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
   i2 = HEAP32[i9 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 27; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 29;
  }
 }
 if ((i7 | 0) == 27) i7 = 29;
 if ((i7 | 0) == 29) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 48 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i8 + 52 | 0;
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 i14 = i8 + 56 | 0;
 f13 = Math_fround(HEAPF32[i14 >> 2]);
 __ZNK9Transform18GetWorldScaleLossyEv(i9, i1);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i9 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i9 + 4 >> 2]));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i9 + 8 >> 2]));
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i7 >> 2] = f12;
 HEAPF32[i14 >> 2] = f13;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i9, i1);
 __ZN10Matrix4x4fmLERKS_(i8, i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN27TimeSliceAwakeFromLoadQueue19IntegrateTimeSlicedEi(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, i19 = 0, i20 = 0, i21 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 16 | 0;
 i1 = i17 + 8 | 0;
 i6 = i17;
 i14 = i9 + 20 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) if (!(HEAP32[i9 + 52 >> 2] | 0)) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 d18 = +_emscripten_get_now() * 1.0e6;
 i11 = ~~d18 >>> 0;
 i12 = +Math_abs(d18) >= 1.0 ? (d18 > 0.0 ? ~~+Math_min(+Math_floor(d18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d18 - +(~~d18 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i13 = __Z20GetPersistentManagerv() | 0;
 d18 = +_emscripten_get_now() * 1.0e6;
 i8 = _i64Subtract(~~d18 >>> 0 | 0, (+Math_abs(d18) >= 1.0 ? (d18 > 0.0 ? ~~+Math_min(+Math_floor(d18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d18 - +(~~d18 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i11 | 0, i12 | 0) | 0;
 i8 = __Z17TimeToNanosecondsy(i8, getTempRet0() | 0) | 0;
 i8 = ___udivdi3(i8 | 0, getTempRet0() | 0, 1e6, 0) | 0;
 getTempRet0() | 0;
 L5 : do if ((i8 | 0) < (i10 | 0)) {
  i2 = i9 + 32 | 0;
  i3 = i13 + 113 | 0;
  i4 = i9 + 56 | 0;
  i5 = i9 + 52 | 0;
  i7 = i9 + 48 | 0;
  while (1) {
   if (!(__ZN19RingbufferTemplates23PeekValueFromRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RPKT_(i2, i1) | 0)) {
    i16 = 16;
    break;
   }
   i8 = __Z21GetAsyncUploadManagerv() | 0;
   i21 = HEAP32[i1 >> 2] | 0;
   i20 = HEAP32[i21 + 4 >> 2] | 0;
   i19 = i6;
   HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i19 + 4 >> 2] = i20;
   HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   if (!(__ZN18AsyncUploadManager12HasCompletedE10AsyncFence(i8, i15) | 0)) break;
   if (!(__ZN5Mutex7TryLockEv(i3) | 0)) break;
   __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi(i13, HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0) | 0;
   i21 = (HEAP32[i4 >> 2] | 0) + 20 | 0;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 12;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -12;
   if (HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0) {
    i21 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i21 + 24 >> 2] | 0) == (HEAP32[i21 + 20 >> 2] | 0)) {
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - (HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0);
     i8 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2];
     if (i8 | 0) {
      if (HEAP8[i8 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i8 + 8 | 0);
      __ZdlPv(i8);
     }
    }
   }
   d18 = +_emscripten_get_now() * 1.0e6;
   i21 = _i64Subtract(~~d18 >>> 0 | 0, (+Math_abs(d18) >= 1.0 ? (d18 > 0.0 ? ~~+Math_min(+Math_floor(d18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d18 - +(~~d18 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i11 | 0, i12 | 0) | 0;
   i21 = __Z17TimeToNanosecondsy(i21, getTempRet0() | 0) | 0;
   i21 = ___udivdi3(i21 | 0, getTempRet0() | 0, 1e6, 0) | 0;
   getTempRet0() | 0;
   if ((i21 | 0) >= (i10 | 0)) break L5;
  }
  if ((i16 | 0) == 16) break;
  i21 = 0;
  STACKTOP = i17;
  return i21 | 0;
 } while (0);
 d18 = +_emscripten_get_now() * 1.0e6;
 i21 = _i64Subtract(~~d18 >>> 0 | 0, (+Math_abs(d18) >= 1.0 ? (d18 > 0.0 ? ~~+Math_min(+Math_floor(d18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d18 - +(~~d18 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i11 | 0, i12 | 0) | 0;
 i21 = __Z17TimeToNanosecondsy(i21, getTempRet0() | 0) | 0;
 i21 = ___udivdi3(i21 | 0, getTempRet0() | 0, 1e6, 0) | 0;
 getTempRet0() | 0;
 L25 : do if ((i21 | 0) < (i10 | 0)) {
  i1 = i13 + 113 | 0;
  i2 = i9 + 24 | 0;
  i3 = i9 + 16 | 0;
  while (1) {
   if (!(__ZN19RingbufferTemplates23PeekValueFromRingBufferIi17GrowingRingbufferEEbRT0_RPKT_(i9, i15) | 0)) {
    i16 = 29;
    break;
   }
   if (!(__ZN5Mutex7TryLockEv(i1) | 0)) break;
   __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi(i13, HEAP32[HEAP32[i15 >> 2] >> 2] | 0) | 0;
   i21 = (HEAP32[i2 >> 2] | 0) + 20 | 0;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 4;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
   if (HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0) {
    i21 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i21 + 24 >> 2] | 0) == (HEAP32[i21 + 20 >> 2] | 0)) {
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - (HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0);
     i4 = HEAP32[i2 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2];
     if (i4 | 0) {
      if (HEAP8[i4 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 8 | 0);
      __ZdlPv(i4);
     }
    }
   }
   d18 = +_emscripten_get_now() * 1.0e6;
   i21 = _i64Subtract(~~d18 >>> 0 | 0, (+Math_abs(d18) >= 1.0 ? (d18 > 0.0 ? ~~+Math_min(+Math_floor(d18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d18 - +(~~d18 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i11 | 0, i12 | 0) | 0;
   i21 = __Z17TimeToNanosecondsy(i21, getTempRet0() | 0) | 0;
   i21 = ___udivdi3(i21 | 0, getTempRet0() | 0, 1e6, 0) | 0;
   getTempRet0() | 0;
   if ((i21 | 0) >= (i10 | 0)) break L25;
  }
  if ((i16 | 0) == 29) break;
  i21 = 0;
  STACKTOP = i17;
  return i21 | 0;
 } while (0);
 if (!(HEAP32[i14 >> 2] | 0)) if (!(HEAP32[i9 + 52 >> 2] | 0)) {
  i21 = 1;
  STACKTOP = i17;
  return i21 | 0;
 }
 i21 = 0;
 STACKTOP = i17;
 return i21 | 0;
}

function __ZN5physx2Gu5Debug9visualizeERKNS_16PxSphereGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i4, i20, i19, i12, i11, i1, f2, i3) {
 i4 = i4 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 88 | 0;
 i13 = i18 + 16 | 0;
 i17 = i18 + 24 | 0;
 i14 = i18 + 8 | 0;
 i15 = i18;
 do if ((i11 & 1073741824 | 0) == 0 & 0 == 0) if ((i11 & 8192 | 0) == 0 & 0 == 0) {
  STACKTOP = i18;
  return;
 } else {
  i5 = i4 + 4 | 0;
  i4 = HEAP32[i19 + 36 >> 2] | 0;
  i3 = HEAP32[i19 + 40 >> 2] | 0;
  i1 = HEAP32[i19 + 44 >> 2] | 0;
  break;
 } else {
  i5 = i4 + 4 | 0;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  f6 = Math_fround(HEAPF32[i19 + 36 >> 2]);
  f24 = Math_fround(f6 - f2);
  f23 = Math_fround(HEAPF32[i19 + 40 >> 2]);
  f7 = Math_fround(f23 - f2);
  f22 = Math_fround(HEAPF32[i19 + 44 >> 2]);
  f8 = Math_fround(f22 - f2);
  f9 = Math_fround(f2 + f23);
  f10 = Math_fround(f2 + f22);
  i21 = f24 > Math_fround(HEAPF32[i12 + 12 >> 2]);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  if (i21) {
   STACKTOP = i18;
   return;
  }
  f24 = Math_fround(f2 + f6);
  if (Math_fround(HEAPF32[i12 >> 2]) > f24) {
   STACKTOP = i18;
   return;
  }
  if (f7 > Math_fround(HEAPF32[i12 + 16 >> 2])) {
   STACKTOP = i18;
   return;
  }
  if (Math_fround(HEAPF32[i12 + 4 >> 2]) > f9) {
   STACKTOP = i18;
   return;
  }
  if (f8 > Math_fround(HEAPF32[i12 + 20 >> 2])) {
   STACKTOP = i18;
   return;
  }
  if ((i11 & 8192 | 0) == 0 & 0 == 0 | Math_fround(HEAPF32[i12 + 8 >> 2]) > f10) {
   STACKTOP = i18;
   return;
  }
 } while (0);
 i21 = HEAP32[i19 + 4 >> 2] | 0;
 i35 = HEAP32[i19 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
 i36 = i16 + 4 | 0;
 HEAP32[i36 >> 2] = i21;
 i21 = i16 + 8 | 0;
 HEAP32[i21 >> 2] = i35;
 i35 = i16 + 12 | 0;
 HEAP32[i35 >> 2] = 0;
 i26 = i16 + 16 | 0;
 i11 = HEAP32[i19 + 16 >> 2] | 0;
 i34 = HEAP32[i19 + 20 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i19 + 12 >> 2];
 i25 = i16 + 20 | 0;
 HEAP32[i25 >> 2] = i11;
 i11 = i16 + 24 | 0;
 HEAP32[i11 >> 2] = i34;
 i34 = i16 + 28 | 0;
 HEAP32[i34 >> 2] = 0;
 i33 = i16 + 32 | 0;
 i32 = HEAP32[i19 + 28 >> 2] | 0;
 i31 = HEAP32[i19 + 32 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i19 + 24 >> 2];
 i12 = i16 + 36 | 0;
 HEAP32[i12 >> 2] = i32;
 i32 = i16 + 40 | 0;
 HEAP32[i32 >> 2] = i31;
 i31 = i16 + 44 | 0;
 HEAP32[i31 >> 2] = 0;
 i30 = i16 + 48 | 0;
 HEAP32[i30 >> 2] = i4;
 i29 = i16 + 52 | 0;
 HEAP32[i29 >> 2] = i3;
 i28 = i16 + 56 | 0;
 HEAP32[i28 >> 2] = i1;
 i27 = i16 + 60 | 0;
 HEAP32[i27 >> 2] = 0;
 i19 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i20, -65281) | 0, i16) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i13 >> 2] = 100;
 HEAP32[i13 + 4 >> 2] = i3;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i19, i13) | 0;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 i16 = i17 + 4 | 0;
 HEAP32[i16 >> 2] = HEAP32[i36 >> 2];
 i19 = i17 + 8 | 0;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 i21 = i17 + 12 | 0;
 HEAP32[i21 >> 2] = HEAP32[i35 >> 2];
 i26 = HEAP32[i26 >> 2] | 0;
 i25 = HEAP32[i25 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i34 >> 2] | 0;
 i1 = i17 + 32 | 0;
 f24 = Math_fround(HEAPF32[i33 >> 2]);
 i4 = i17 + 36 | 0;
 f23 = Math_fround(HEAPF32[i12 >> 2]);
 i12 = i17 + 40 | 0;
 f22 = Math_fround(HEAPF32[i32 >> 2]);
 i13 = i17 + 44 | 0;
 f10 = Math_fround(HEAPF32[i31 >> 2]);
 HEAP32[i17 + 48 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i17 + 52 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i17 + 56 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i17 + 60 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i1 >> 2] = i26;
 HEAP32[i4 >> 2] = i25;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i13 >> 2] = i3;
 f23 = Math_fround(-f23);
 f22 = Math_fround(-f22);
 f10 = Math_fround(-f10);
 HEAPF32[i17 + 16 >> 2] = Math_fround(-f24);
 HEAPF32[i17 + 20 >> 2] = f23;
 HEAPF32[i17 + 24 >> 2] = f22;
 HEAPF32[i17 + 28 >> 2] = f10;
 i3 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i20, -65281) | 0, i17) | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i14 >> 2] = 100;
 HEAP32[i14 + 4 >> 2] = i11;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i3, i14) | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i11 = HEAP32[i19 >> 2] | 0;
 i14 = HEAP32[i21 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f23 = Math_fround(HEAPF32[i12 >> 2]);
 f24 = Math_fround(HEAPF32[i13 >> 2]);
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i4 >> 2] = i3;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i13 >> 2] = i14;
 f22 = Math_fround(-f22);
 f23 = Math_fround(-f23);
 f24 = Math_fround(-f24);
 HEAPF32[i17 >> 2] = Math_fround(-f10);
 HEAPF32[i16 >> 2] = f22;
 HEAPF32[i19 >> 2] = f23;
 HEAPF32[i21 >> 2] = f24;
 i21 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i20, -65281) | 0, i17) | 0;
 i20 = HEAP32[i5 >> 2] | 0;
 HEAP32[i15 >> 2] = 100;
 HEAP32[i15 + 4 >> 2] = i20;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i21, i15) | 0;
 STACKTOP = i18;
 return;
}

function __ZN15b2RevoluteJoint24SolvePositionConstraintsERK12b2SolverData(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i15 = i14 + 128 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i11 = i1 + 24 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i16 + (i8 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i16 + (i8 * 12 | 0) + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i16 + (i8 * 12 | 0) + 8 >> 2]);
 i8 = i14 + 132 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) >> 2]);
 f10 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i14 + 176 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 180 >> 2]);
 if (!(HEAP8[i14 + 112 >> 0] | 0)) f2 = Math_fround(0.0); else {
  i16 = Math_fround(f6 + f7) == Math_fround(0.0);
  i1 = HEAP32[i14 + 224 >> 2] | 0;
  if ((i1 | 0) == 0 | i16) f2 = Math_fround(0.0); else {
   f2 = Math_fround(f3 - f5);
   f2 = Math_fround(f2 - Math_fround(HEAPF32[i14 + 116 >> 2]));
   switch (i1 | 0) {
   case 3:
    {
     f2 = Math_fround(f2 - Math_fround(HEAPF32[i14 + 120 >> 2]));
     f17 = Math_fround(HEAPF32[gb + 151884 >> 2]);
     f4 = Math_fround(-f17);
     f17 = f2 < f17 ? f2 : f17;
     f17 = f17 < f4 ? f4 : f17;
     f4 = Math_fround(-Math_fround(Math_fround(HEAPF32[i14 + 220 >> 2]) * f17));
     i16 = f17 > Math_fround(0.0);
     f2 = Math_fround(-f17);
     f2 = i16 ? f17 : f2;
     break;
    }
   case 1:
    {
     f4 = Math_fround(f2 - Math_fround(HEAPF32[i14 + 120 >> 2]));
     f2 = Math_fround(-f4);
     f4 = Math_fround(f4 + Math_fround(.0349065885));
     f17 = Math_fround(-Math_fround(HEAPF32[gb + 151884 >> 2]));
     i16 = f4 < Math_fround(0.0);
     f4 = i16 ? f4 : Math_fround(0.0);
     f4 = Math_fround(-Math_fround(Math_fround(HEAPF32[i14 + 220 >> 2]) * (f4 < f17 ? f17 : f4)));
     break;
    }
   case 2:
    {
     f2 = Math_fround(f2 - Math_fround(HEAPF32[i14 + 124 >> 2]));
     f17 = Math_fround(f2 + Math_fround(-.0349065885));
     f4 = Math_fround(HEAPF32[gb + 151884 >> 2]);
     f4 = f17 < f4 ? f17 : f4;
     i16 = f4 < Math_fround(0.0);
     f4 = Math_fround(-Math_fround((i16 ? Math_fround(0.0) : f4) * Math_fround(HEAPF32[i14 + 220 >> 2])));
     break;
    }
   default:
    {
     f2 = Math_fround(0.0);
     f4 = Math_fround(0.0);
    }
   }
   f5 = Math_fround(f5 - Math_fround(f4 * f6));
   f3 = Math_fround(f3 + Math_fround(f4 * f7));
  }
 }
 f22 = Math_fround(+Math_sin(+f5));
 f28 = Math_fround(+Math_cos(+f5));
 f17 = Math_fround(+Math_sin(+f3));
 f26 = Math_fround(+Math_cos(+f3));
 f20 = Math_fround(HEAPF32[i14 + 68 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i14 + 152 >> 2]));
 f24 = Math_fround(HEAPF32[i14 + 72 >> 2]);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i14 + 156 >> 2]));
 f25 = Math_fround(Math_fround(f28 * f20) - Math_fround(f22 * f24));
 f24 = Math_fround(Math_fround(f22 * f20) + Math_fround(f28 * f24));
 f28 = Math_fround(HEAPF32[i14 + 76 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i14 + 160 >> 2]));
 f20 = Math_fround(HEAPF32[i14 + 80 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i14 + 164 >> 2]));
 f22 = Math_fround(Math_fround(f26 * f28) - Math_fround(f17 * f20));
 f20 = Math_fround(Math_fround(f17 * f28) + Math_fround(f26 * f20));
 f26 = Math_fround(Math_fround(Math_fround(f9 + f22) - f12) - f25);
 f28 = Math_fround(Math_fround(Math_fround(f10 + f20) - f13) - f24);
 f17 = Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(f28 * f28))));
 f4 = Math_fround(HEAPF32[i14 + 168 >> 2]);
 f23 = Math_fround(HEAPF32[i14 + 172 >> 2]);
 f29 = Math_fround(f4 + f23);
 f27 = Math_fround(Math_fround(f29 + Math_fround(f24 * Math_fround(f24 * f6))) + Math_fround(f20 * Math_fround(f20 * f7)));
 f21 = Math_fround(f25 * f6);
 f19 = Math_fround(f22 * f7);
 f18 = Math_fround(Math_fround(-Math_fround(f24 * f21)) - Math_fround(f20 * f19));
 f19 = Math_fround(Math_fround(f29 + Math_fround(f25 * f21)) + Math_fround(f22 * f19));
 f21 = Math_fround(Math_fround(f27 * f19) - Math_fround(f18 * f18));
 i14 = f21 != Math_fround(0.0);
 f29 = Math_fround(Math_fround(1.0) / f21);
 f21 = i14 ? f29 : f21;
 f19 = Math_fround(-Math_fround(Math_fround(Math_fround(f26 * f19) - Math_fround(f28 * f18)) * f21));
 f21 = Math_fround(-Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f18)) * f21));
 f18 = Math_fround(f12 - Math_fround(f4 * f19));
 f4 = Math_fround(f13 - Math_fround(f4 * f21));
 f6 = Math_fround(f5 - Math_fround(f6 * Math_fround(Math_fround(f25 * f21) - Math_fround(f24 * f19))));
 f9 = Math_fround(f9 + Math_fround(f23 * f19));
 f12 = Math_fround(f10 + Math_fround(f23 * f21));
 f13 = Math_fround(f3 + Math_fround(f7 * Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f19))));
 i14 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 HEAPF32[i16 + (i14 * 12 | 0) >> 2] = f18;
 HEAPF32[i16 + (i14 * 12 | 0) + 4 >> 2] = f4;
 i14 = HEAP32[i11 >> 2] | 0;
 HEAPF32[i14 + ((HEAP32[i15 >> 2] | 0) * 12 | 0) + 8 >> 2] = f6;
 i16 = HEAP32[i8 >> 2] | 0;
 HEAPF32[i14 + (i16 * 12 | 0) >> 2] = f9;
 HEAPF32[i14 + (i16 * 12 | 0) + 4 >> 2] = f12;
 HEAPF32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 12 | 0) + 8 >> 2] = f13;
 return f2 <= Math_fround(.0349065885) & f17 <= Math_fround(.00499999989) | 0;
}

function __ZN5physx38PxsSolverCreateFinalizeConstraintsTask11runInternalEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0;
 i23 = HEAP32[HEAP32[i22 + 24 >> 2] >> 2] | 0;
 i24 = HEAP32[i23 + 8796 >> 2] | 0;
 i19 = HEAP32[i23 + 8896 >> 2] | 0;
 i18 = i23 + 8940 | 0;
 i21 = i23 + 8944 | 0;
 HEAP32[i21 >> 2] = 0;
 if ((HEAP32[i23 + 8948 >> 2] & 2147483647) >>> 0 < i19 >>> 0) __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i18, i19);
 HEAP32[i21 >> 2] = i19;
 i17 = (i24 | 0) == 0;
 i16 = i23 + 8820 | 0;
 if (i17) i1 = 0; else i1 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
 i20 = i23 + 8928 | 0;
 i2 = 0;
 i15 = 0;
 i3 = 0;
 L7 : while (1) {
  i12 = (i15 | 0) != -1;
  i13 = (i15 | 0) != -1;
  i14 = (i1 | 0) == (i24 | 0);
  i11 = i2;
  i2 = 0;
  i6 = i3;
  while (1) {
   if (i11 >>> 0 >= i24 >>> 0) {
    i1 = i15;
    break L7;
   }
   i3 = i6 + 1 | 0;
   i10 = HEAP32[i18 >> 2] | 0;
   HEAP32[i10 + (i6 << 3) >> 2] = i11;
   i7 = i1 - i11 | 0;
   i7 = i7 >>> 0 < 4 ? i7 : 4;
   i8 = HEAP32[i20 >> 2] | 0;
   L12 : do if ((HEAP16[i8 + (i11 << 5) + 12 >> 1] & HEAP16[i8 + (i11 << 5) + 8 >> 1]) << 16 >> 16 == -1) {
    i9 = HEAP16[i8 + (i11 << 5) + 26 >> 1] | 0;
    if (i9 << 16 >> 16 == 1) if (i12 & i7 >>> 0 > 1) {
     i5 = 1;
     i4 = 1;
    } else {
     i4 = 1;
     break;
    } else if (i13 & i9 << 16 >> 16 == 2 & i7 >>> 0 > 1) {
     i5 = 1;
     i4 = 1;
    } else {
     i4 = 1;
     break;
    }
    do {
     i5 = i5 + i11 | 0;
     if (i9 << 16 >> 16 != (HEAP16[i8 + (i5 << 5) + 26 >> 1] | 0)) break L12;
     if ((HEAP16[i8 + (i5 << 5) + 12 >> 1] & HEAP16[i8 + (i5 << 5) + 8 >> 1]) << 16 >> 16 != -1) break L12;
     i4 = i4 + 1 << 16 >> 16;
     i5 = i4 & 65535;
    } while (i5 >>> 0 < i7 >>> 0);
   } else i4 = 1; while (0);
   HEAP16[i10 + (i6 << 3) + 4 >> 1] = i4;
   i2 = i2 + 1 | 0;
   i11 = (i4 & 65535) + i11 | 0;
   if (!(i14 | (i1 | 0) != (i11 | 0))) break; else i6 = i3;
  }
  i13 = HEAP32[i16 >> 2] | 0;
  HEAP32[i13 + (i15 << 2) >> 2] = i2;
  i14 = i15 + 1 | 0;
  i2 = i1;
  i15 = i14;
  i1 = HEAP32[i13 + (i14 << 2) >> 2] | 0;
 }
 if (!i17) HEAP32[(HEAP32[i16 >> 2] | 0) + (i1 << 2) >> 2] = i2;
 HEAP32[i23 + 8824 >> 2] = HEAP32[i23 + 9044 >> 2];
 if ((i19 | 0) == (i24 | 0)) i14 = i6; else {
  i4 = HEAP32[i18 >> 2] | 0;
  i5 = i6 + i19 | 0;
  i1 = i19 - i24 | 0;
  i2 = 0;
  i3 = i6;
  while (1) {
   HEAP32[i4 + (i3 << 3) >> 2] = i2 + i24;
   HEAP16[i4 + (i3 << 3) + 4 >> 1] = 1;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i1 | 0)) break; else i3 = i3 + 1 | 0;
  }
  i14 = i5 - i24 | 0;
 }
 HEAP32[i21 >> 2] = i14;
 HEAP32[i23 + 9012 >> 2] = i6;
 HEAP32[i23 + 9016 >> 2] = i14 - i6;
 i9 = HEAP32[i20 >> 2] | 0;
 i1 = (i14 + 31 | 0) >>> 5;
 i2 = i1 >>> 0 > 64 ? 64 : i1;
 i21 = i2 >>> 0 > 1;
 i2 = i21 ? i2 : 1;
 i10 = ((i14 + -1 + i2 | 0) >>> 0) / (i2 >>> 0) | 0;
 i10 = i10 >>> 0 > 32 ? i10 : 32;
 if (!i21) {
  i24 = HEAP32[i22 + 20 >> 2] | 0;
  __ZN5physx18PxsDynamicsContext22createFinalizeContactsENS_14PxFrictionType4EnumEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEjPNS_10PxBaseTaskERNS_16PxsThreadContextE(i24, HEAP32[i23 + 8764 >> 2] | 0, 0, HEAP32[i24 + 112 >> 2] | 0, 0, 0, i23);
  return;
 }
 if (!i2) return;
 i11 = i22 + 20 | 0;
 i12 = i23 + 8764 | 0;
 i13 = i23 + 9028 | 0;
 i8 = i22 + 12 | 0;
 i7 = (i1 ^ -64) >>> 0 > 4294967231 ? i1 : 64;
 i7 = i7 >>> 0 > 1 ? i7 : 1;
 i6 = HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + 96 >> 2] | 0) + 6960 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i1 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i6, i2 * 72 | 0, 16) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 i6 = 0;
 do {
  i21 = Math_imul(i6, i10) | 0;
  i5 = i21 + i10 | 0;
  i2 = i1 + (i6 * 72 | 0) | 0;
  i25 = HEAP32[i12 >> 2] | 0;
  i20 = HEAP32[i11 >> 2] | 0;
  i16 = HEAP32[i20 + 124 >> 2] | 0;
  i15 = HEAP32[i20 + 128 >> 2] | 0;
  i17 = HEAP32[i20 + 140 >> 2] | 0;
  i18 = HEAP32[i20 + 144 >> 2] | 0;
  i19 = HEAP32[i20 + 112 >> 2] | 0;
  i20 = HEAP32[i20 + 96 >> 2] | 0;
  HEAP16[i1 + (i6 * 72 | 0) + 4 >> 1] = -1;
  HEAP16[i1 + (i6 * 72 | 0) + 6 >> 1] = 0;
  i3 = i1 + (i6 * 72 | 0) + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = gb + 87404 + 8;
  i4 = i1 + (i6 * 72 | 0) + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i22 = i1 + (i6 * 72 | 0) + 16 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i2 >> 2] = gb + 106224 + 8;
  HEAP32[i1 + (i6 * 72 | 0) + 20 >> 2] = i25;
  HEAP32[i1 + (i6 * 72 | 0) + 24 >> 2] = i15;
  HEAP32[i1 + (i6 * 72 | 0) + 28 >> 2] = i16;
  HEAP32[i1 + (i6 * 72 | 0) + 32 >> 2] = i17;
  HEAP32[i1 + (i6 * 72 | 0) + 36 >> 2] = i18;
  HEAP32[i1 + (i6 * 72 | 0) + 40 >> 2] = i24;
  HEAP32[i1 + (i6 * 72 | 0) + 44 >> 2] = i9;
  HEAP32[i1 + (i6 * 72 | 0) + 48 >> 2] = i19;
  HEAP32[i1 + (i6 * 72 | 0) + 52 >> 2] = i13;
  HEAP32[i1 + (i6 * 72 | 0) + 56 >> 2] = i23;
  HEAP32[i1 + (i6 * 72 | 0) + 60 >> 2] = i20;
  HEAP32[i1 + (i6 * 72 | 0) + 64 >> 2] = i21;
  HEAP32[i1 + (i6 * 72 | 0) + 68 >> 2] = i5 >>> 0 < i14 >>> 0 ? i5 : i14;
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i4 >> 2] = i5;
  if (i5 | 0) {
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
   HEAP32[i3 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
  }
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 return;
}

function __ZN5physx25PxProfileBulkEventHandler16parseEventBufferEPKhjRS0_b(i13, i5, i3, i4) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 8304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i24 + 8280 | 0;
 i19 = i24 + 8264 | 0;
 i18 = i24 + 8224 | 0;
 i21 = i24 + 8296 | 0;
 i20 = i24 + 8200 | 0;
 i17 = i24 + 8248 | 0;
 i23 = i24;
 i1 = i23 + 8192 | 0;
 i2 = i23;
 do {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i2 + 1 >> 0] = -1;
  HEAP16[i2 + 2 >> 1] = 0;
  i2 = i2 + 32 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i14 = i23 + 8192 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i23 + 8196 | 0;
 HEAP32[i15 >> 2] = i3;
 if (i4) {
  HEAP32[i19 >> 2] = i13;
  i12 = i19 + 4 | 0;
  HEAP32[i12 >> 2] = i5;
  i11 = i19 + 8 | 0;
  HEAP8[i11 >> 0] = 0;
  if (!i13) {
   HEAP32[i12 >> 2] = 0;
   i5 = 0;
  }
  HEAP8[i21 >> 0] = 0;
  i4 = i21 + 1 | 0;
  HEAP8[i4 >> 0] = -1;
  i6 = i21 + 2 | 0;
  HEAP16[i6 >> 1] = 0;
  i10 = i20 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  L9 : do if (i5 | 0) {
   i7 = i6 + 1 | 0;
   i8 = i17 + 4 | 0;
   i9 = i17 + 8 | 0;
   i10 = i17 + 12 | 0;
   i2 = HEAP8[i13 >> 0] | 0;
   HEAP8[i21 >> 0] = i2;
   i1 = i13 + 1 | 0;
   HEAP32[i19 >> 2] = i1;
   i3 = i5 + -1 | 0;
   HEAP32[i12 >> 2] = i3;
   L11 : do if (!i3) i22 = 8; else {
    i3 = i13;
    while (1) {
     HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
     i1 = i3 + 2 | 0;
     HEAP32[i19 >> 2] = i1;
     i13 = i5 + -2 | 0;
     HEAP32[i12 >> 2] = i13;
     if (i13 >>> 0 < 2) break L11;
     i13 = HEAP8[i1 >> 0] | 0;
     HEAP8[i6 >> 0] = i13;
     i1 = i3 + 3 | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i12 >> 2] = i5 + -3;
     i1 = HEAP8[i1 >> 0] | 0;
     HEAP32[i19 >> 2] = i3 + 4;
     HEAP32[i12 >> 2] = i5 + -4;
     HEAP8[i6 >> 0] = i1;
     HEAP8[i7 >> 0] = i13;
     HEAP32[i17 >> 2] = i20;
     HEAP32[i8 >> 2] = i19;
     HEAP32[i9 >> 2] = i21;
     HEAP32[i10 >> 2] = i23;
     HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2 & 255, i18, i16) | 0;
     i5 = HEAP32[i12 >> 2] | 0;
     if (!((i5 | 0) != 0 & (HEAP8[i11 >> 0] | 0) == 0)) break L9;
     i3 = HEAP32[i19 >> 2] | 0;
     i2 = HEAP8[i3 >> 0] | 0;
     HEAP8[i21 >> 0] = i2;
     i1 = i3 + 1 | 0;
     HEAP32[i19 >> 2] = i1;
     i13 = i5 + -1 | 0;
     HEAP32[i12 >> 2] = i13;
     if (!i13) {
      i22 = 8;
      break;
     }
    }
   } while (0);
   if ((i22 | 0) == 8) HEAP8[i11 >> 0] = 1;
   HEAP8[i11 >> 0] = 1;
  } while (0);
 } else {
  HEAP32[i19 >> 2] = i13;
  i11 = i19 + 4 | 0;
  HEAP32[i11 >> 2] = i5;
  i12 = i19 + 8 | 0;
  HEAP8[i12 >> 0] = 0;
  if (!i13) {
   HEAP32[i11 >> 2] = 0;
   i5 = 0;
  }
  HEAP8[i21 >> 0] = 0;
  i4 = i21 + 1 | 0;
  HEAP8[i4 >> 0] = -1;
  i6 = i21 + 2 | 0;
  HEAP16[i6 >> 1] = 0;
  i7 = i20 + 16 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i7 = i6 + 1 | 0;
  i8 = i17 + 4 | 0;
  i9 = i17 + 8 | 0;
  i10 = i17 + 12 | 0;
  L24 : do if (i5 | 0) {
   i2 = HEAP8[i13 >> 0] | 0;
   HEAP8[i21 >> 0] = i2;
   i1 = i13 + 1 | 0;
   HEAP32[i19 >> 2] = i1;
   i3 = i5 + -1 | 0;
   HEAP32[i11 >> 2] = i3;
   L26 : do if (!i3) i22 = 18; else {
    i3 = i13;
    while (1) {
     HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
     i1 = i3 + 2 | 0;
     HEAP32[i19 >> 2] = i1;
     i13 = i5 + -2 | 0;
     HEAP32[i11 >> 2] = i13;
     if (i13 >>> 0 < 2) break L26;
     HEAP8[i6 >> 0] = HEAP8[i1 >> 0] | 0;
     i13 = i3 + 3 | 0;
     HEAP32[i19 >> 2] = i13;
     HEAP32[i11 >> 2] = i5 + -3;
     HEAP8[i7 >> 0] = HEAP8[i13 >> 0] | 0;
     HEAP32[i19 >> 2] = i3 + 4;
     HEAP32[i11 >> 2] = i5 + -4;
     HEAP32[i17 >> 2] = i20;
     HEAP32[i8 >> 2] = i19;
     HEAP32[i9 >> 2] = i21;
     HEAP32[i10 >> 2] = i23;
     HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2 & 255, i18, i16) | 0;
     i5 = HEAP32[i11 >> 2] | 0;
     if (!((HEAP8[i12 >> 0] | 0) == 0 & (i5 | 0) != 0)) break L24;
     i3 = HEAP32[i19 >> 2] | 0;
     i2 = HEAP8[i3 >> 0] | 0;
     HEAP8[i21 >> 0] = i2;
     i1 = i3 + 1 | 0;
     HEAP32[i19 >> 2] = i1;
     i13 = i5 + -1 | 0;
     HEAP32[i11 >> 2] = i13;
     if (!i13) {
      i22 = 18;
      break;
     }
    }
   } while (0);
   if ((i22 | 0) == 18) HEAP8[i12 >> 0] = 1;
   HEAP8[i12 >> 0] = 1;
  } while (0);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 i22 = HEAP32[i15 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i23 | 0, i1 | 0);
 STACKTOP = i24;
 return;
}

function __Z22FindAndLoadUnityPluginPKcPPv(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 112 | 0;
 i8 = i16 + 100 | 0;
 i15 = i16 + 88 | 0;
 i9 = i16 + 76 | 0;
 i10 = i16 + 40 | 0;
 i11 = i16;
 i12 = i16 + 64 | 0;
 i13 = i16 + 24 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i14, _strlen(i14) | 0);
 if (i1 | 0) HEAP32[i1 >> 2] = 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1162664 >> 2] | 0, i15) | 0;
 if ((i1 | 0) == ((HEAP32[gb + 1162664 >> 2] | 0) + 4 | 0)) {
  __Z26GetApplicationContentsPathv(i5);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i7 = HEAP8[i5 + 11 >> 0] | 0;
  if (!((i7 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i7 & 255) | 0)) i2 = 7; else if (__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i5); else i2 = 7;
  if ((i2 | 0) == 7) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i14, _strlen(i14) | 0);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = _strlen(i14) | 0;
  i7 = HEAP8[i9 + 11 >> 0] | 0;
  if ((i1 | 0) == ((i7 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i7 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i9, 0, -1, i14, i1) | 0)) {
   __Z20FindPluginExecutablePKc(i5, i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i5) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
  i4 = HEAP32[gb + 1162664 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i12, i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i12);
  i6 = i11 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i11);
  i7 = i10 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i6);
  i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i4, i8, i10) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   HEAP32[i5 >> 2] = 12;
   HEAP32[i5 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 28 | 0, i7);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i4 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
   i8 = i4 + 12 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 }
 i3 = i1 + 28 | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i1 = HEAP32[i1 + 32 >> 2] | 0; else i1 = i2 & 255;
 if (i1 | 0) {
  if (i4) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
  if (_strcmp(i1, i14) | 0) if (i4) {
   i14 = HEAP32[i3 >> 2] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   STACKTOP = i16;
   return i14 | 0;
  } else {
   i14 = i3;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   STACKTOP = i16;
   return i14 | 0;
  }
 }
 if (i4) {
  i14 = HEAP32[i3 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i16;
  return i14 | 0;
 } else {
  i14 = i3;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  STACKTOP = i16;
  return i14 | 0;
 }
 return 0;
}

function __ZN14b2PolygonShape8ValidateEPK6b2Vec2i(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, f18 = f0, i19 = 0, f20 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 if ((i16 + -3 | 0) >>> 0 > 5) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = (i16 | 0) > 0;
 L4 : do if (i14) {
  i2 = 0;
  i8 = 0;
  while (1) {
   i4 = HEAP32[i15 + (i8 << 3) >> 2] | 0;
   i7 = HEAP32[i15 + (i8 << 3) + 4 >> 2] | 0;
   L7 : do if ((i2 | 0) > 0) {
    f1 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i3 = 0;
    while (1) {
     f6 = Math_fround(f1 - Math_fround(HEAPF32[i13 + (i3 << 3) >> 2]));
     f9 = Math_fround(f5 - Math_fround(HEAPF32[i13 + (i3 << 3) + 4 >> 2]));
     i3 = i3 + 1 | 0;
     if (Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)) < Math_fround(6.24999984e-06)) {
      i12 = i2;
      break L7;
     }
     if ((i3 | 0) >= (i2 | 0)) {
      i10 = 8;
      break;
     }
    }
   } else i10 = 8; while (0);
   if ((i10 | 0) == 8) {
    i10 = 0;
    HEAP32[i13 + (i2 << 3) >> 2] = i4;
    HEAP32[i13 + (i2 << 3) + 4 >> 2] = i7;
    i12 = i2 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i16 | 0)) break; else i2 = i12;
  }
  if ((i12 | 0) < 3) i2 = 0; else {
   i3 = 1;
   f1 = Math_fround(HEAPF32[i13 >> 2]);
   i2 = 0;
   do {
    f5 = Math_fround(HEAPF32[i13 + (i3 << 3) >> 2]);
    if (f5 > f1) i10 = 24; else if (f5 == f1) {
     f9 = Math_fround(HEAPF32[i13 + (i3 << 3) + 4 >> 2]);
     if (f9 < Math_fround(HEAPF32[i13 + (i2 << 3) + 4 >> 2])) i10 = 24;
    }
    if ((i10 | 0) == 24) {
     i10 = 0;
     f1 = f5;
     i2 = i3;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i12 | 0));
   if ((i12 | 0) > 1) {
    i8 = i2;
    i3 = 0;
    while (1) {
     if ((i3 | 0) >= 8) {
      i2 = 0;
      break L4;
     }
     i10 = i13 + (i8 << 3) | 0;
     i11 = i13 + (i8 << 3) + 4 | 0;
     i7 = 1;
     i4 = 0;
     do {
      if ((i4 | 0) == (i8 | 0)) i4 = i7; else {
       f1 = Math_fround(HEAPF32[i13 + (i4 << 3) >> 2]);
       f6 = Math_fround(HEAPF32[i10 >> 2]);
       f1 = Math_fround(f1 - f6);
       f5 = Math_fround(HEAPF32[i13 + (i4 << 3) + 4 >> 2]);
       f9 = Math_fround(HEAPF32[i11 >> 2]);
       f5 = Math_fround(f5 - f9);
       f6 = Math_fround(Math_fround(HEAPF32[i13 + (i7 << 3) >> 2]) - f6);
       f9 = Math_fround(Math_fround(HEAPF32[i13 + (i7 << 3) + 4 >> 2]) - f9);
       f18 = Math_fround(Math_fround(f1 * f9) - Math_fround(f5 * f6));
       i19 = f18 < Math_fround(0.0);
       i4 = i19 ? i7 : i4;
       if (f18 == Math_fround(0.0)) if (Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9)) > Math_fround(Math_fround(f1 * f1) + Math_fround(f5 * f5))) i4 = i7;
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i12 | 0));
     if ((i4 | 0) == (i2 | 0)) break; else {
      i8 = i4;
      i3 = i3 + 1 | 0;
     }
    }
   } else {
    i3 = (i2 | 0) == 0;
    i2 = 0;
    while (1) {
     if ((i2 | 0) >= 8) {
      i2 = 0;
      break L4;
     }
     if (i3) {
      i3 = i2;
      break;
     } else i2 = i2 + 1 | 0;
    }
   }
   i2 = 0;
   while (1) {
    if ((i2 | 0) > (i3 | 0)) break;
    i19 = i2;
    i2 = i2 + 1 | 0;
    i13 = (i19 | 0) < (i3 | 0) ? i2 : 0;
    f9 = Math_fround(HEAPF32[i15 + (i13 << 3) >> 2]);
    f9 = Math_fround(f9 - Math_fround(HEAPF32[i15 + (i19 << 3) >> 2]));
    f18 = Math_fround(HEAPF32[i15 + (i13 << 3) + 4 >> 2]);
    f18 = Math_fround(f18 - Math_fround(HEAPF32[i15 + (i19 << 3) + 4 >> 2]));
    if (!(Math_fround(Math_fround(f9 * f9) + Math_fround(f18 * f18)) > Math_fround(1.42108547e-14))) {
     i2 = 0;
     break L4;
    }
   }
   if (i14) {
    i3 = 0;
    i4 = HEAP32[gb + 1457504 >> 2] | 0;
    i2 = HEAP32[gb + 1457504 + 4 >> 2] | 0;
    while (1) {
     f1 = Math_fround(HEAPF32[i15 + (i3 << 3) >> 2]);
     f1 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f1);
     i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
     f5 = Math_fround(HEAPF32[i15 + (i3 << 3) + 4 >> 2]);
     f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f5);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i16 | 0)) break; else i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    }
    f18 = Math_fround(Math_fround(1.0) / Math_fround(i16 | 0));
    f6 = Math_fround(f18 * f1);
    f5 = Math_fround(f18 * f5);
    if (i14) {
     i3 = i15 + 4 | 0;
     f1 = Math_fround(0.0);
     i2 = 0;
     do {
      f20 = Math_fround(Math_fround(HEAPF32[i15 + (i2 << 3) >> 2]) - f6);
      f9 = Math_fround(Math_fround(HEAPF32[i15 + (i2 << 3) + 4 >> 2]) - f5);
      i2 = i2 + 1 | 0;
      i19 = (i2 | 0) < (i16 | 0);
      f18 = Math_fround(Math_fround(HEAPF32[(i19 ? i15 + (i2 << 3) | 0 : i15) >> 2]) - f6);
      f1 = Math_fround(f1 + Math_fround(Math_fround(Math_fround(f20 * Math_fround(Math_fround(HEAPF32[(i19 ? i15 + (i2 << 3) + 4 | 0 : i3) >> 2]) - f5)) - Math_fround(f9 * f18)) * Math_fround(.5)));
     } while ((i2 | 0) != (i16 | 0));
    } else f1 = Math_fround(0.0);
   } else f1 = Math_fround(0.0);
   i2 = Math_fround(Math_abs(Math_fround(f1))) > Math_fround(1.1920929e-07);
  }
 } else i2 = 0; while (0);
 i19 = i2;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i39, i36, i37, i38) {
 i39 = i39 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 i38 = i38 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i40 = 0, i41 = 0, i42 = 0, f43 = f0, f44 = f0, f45 = f0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i42 + 32 | 0;
 i41 = i42 + 48 | 0;
 i35 = i42 + 16 | 0;
 i40 = i42;
 i5 = HEAP32[i39 + 16 >> 2] | 0;
 i33 = HEAP16[i39 + 26 >> 1] | 0;
 i34 = i5 + ((i33 & 65535) << 4) | 0;
 i6 = HEAP32[i39 + 20 >> 2] | 0;
 i7 = HEAP32[i39 + 52 >> 2] | 0;
 i8 = HEAP32[i39 + 84 >> 2] | 0;
 i9 = HEAP32[i39 + 116 >> 2] | 0;
 i27 = (HEAP8[i5 >> 0] | 0) == 7;
 i26 = i27 ? 240 : 144;
 i27 = i27 ? 224 : 128;
 HEAP32[i41 >> 2] = 0;
 if (!(i33 << 16 >> 16)) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  i28 = i41 + 1 | 0;
  i29 = i41 + 2 | 0;
  i30 = i41 + 3 | 0;
  i31 = i35 + 12 | 0;
  i32 = i35 + 8 | 0;
  i33 = i35 + 4 | 0;
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  do {
   i15 = i5 + 144 | 0;
   i20 = HEAP8[i5 + 1 >> 0] | 0;
   i16 = i20 & 255;
   i22 = HEAP8[i5 + 2 >> 0] | 0;
   i17 = i22 & 255;
   i21 = i16 << 4;
   i24 = i21 + 144 + (Math_imul(i16, i26) | 0) | 0;
   i18 = HEAPU8[i5 + 3 >> 0] | 0;
   i21 = i24 + ((i18 & 1 | 0) == 0 ? 0 : i21) | 0;
   i24 = i5 + i21 | 0;
   i22 = i22 << 24 >> 24 != 0;
   i19 = i17 << 4;
   i17 = i19 + (Math_imul(i17, i27) | 0) | 0;
   i23 = i5;
   i5 = i5 + (i17 + ((i18 & 2 | 0) == 0 ? 0 : i19) + (i22 ? i21 + 128 | 0 : i21)) | 0;
   HEAP8[i41 >> 0] = HEAP8[i23 + 4 >> 0] & 1;
   HEAP8[i28 >> 0] = HEAP8[i23 + 5 >> 0] & 1;
   HEAP8[i29 >> 0] = HEAP8[i23 + 6 >> 0] & 1;
   HEAP8[i30 >> 0] = HEAP8[i23 + 7 >> 0] & 1;
   if (i20 << 24 >> 24) {
    i17 = i23 + 11 | 0;
    i18 = i23 + 10 | 0;
    i19 = i23 + 9 | 0;
    i20 = i23 + 8 | 0;
    i14 = 0;
    do {
     i10 = HEAP32[i15 + (i14 << 4) >> 2] | 0;
     i11 = HEAP32[i15 + (i14 << 4) + 4 >> 2] | 0;
     i12 = HEAP32[i15 + (i14 << 4) + 8 >> 2] | 0;
     i13 = HEAP32[i15 + (i14 << 4) + 12 >> 2] | 0;
     f45 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f44 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f43 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f1 = Math_fround(f1 + f45);
     f2 = Math_fround(f2 + f44);
     f3 = Math_fround(f3 + f43);
     f4 = Math_fround(f4 + (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
     if (!i6) i6 = 0; else if (i14 >>> 0 < (HEAPU8[i20 >> 0] | 0) >>> 0) {
      HEAP32[i6 >> 2] = i10;
      i6 = i6 + 4 | 0;
     }
     if (!i7) i7 = 0; else if (i14 >>> 0 < (HEAPU8[i19 >> 0] | 0) >>> 0) {
      HEAP32[i7 >> 2] = i11;
      i7 = i7 + 4 | 0;
     }
     if (!i8) i8 = 0; else if (i14 >>> 0 < (HEAPU8[i18 >> 0] | 0) >>> 0) {
      HEAP32[i8 >> 2] = i12;
      i8 = i8 + 4 | 0;
     }
     if (!i9) i9 = 0; else if (i14 >>> 0 < (HEAPU8[i17 >> 0] | 0) >>> 0) {
      HEAP32[i9 >> 2] = i13;
      i9 = i9 + 4 | 0;
     }
     i14 = i14 + 1 | 0;
    } while ((i14 | 0) != (i16 | 0));
   }
   if (i22) {
    _memmove(i25 | 0, i24 | 0, 16) | 0;
    HEAP32[i35 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i35 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
    HEAP32[i35 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
    HEAP32[i35 + 12 >> 2] = HEAP32[i25 + 12 >> 2];
    if (!((HEAP8[i23 + 12 >> 0] | 0) == 0 | (HEAP32[i35 >> 2] | 0) == 0)) HEAP8[HEAP32[i23 + (i21 + 16) >> 2] >> 0] = 1;
    if (!((HEAP8[i23 + 13 >> 0] | 0) == 0 | (HEAP32[i33 >> 2] | 0) == 0)) HEAP8[HEAP32[i23 + (i21 + 20) >> 2] >> 0] = 1;
    if (!((HEAP8[i23 + 14 >> 0] | 0) == 0 | (HEAP32[i32 >> 2] | 0) == 0)) HEAP8[HEAP32[i23 + (i21 + 24) >> 2] >> 0] = 1;
    if (!((HEAP8[i23 + 15 >> 0] | 0) == 0 | (HEAP32[i31 >> 2] | 0) == 0)) HEAP8[HEAP32[i23 + (i21 + 28) >> 2] >> 0] = 1;
   }
  } while (i5 >>> 0 < i34 >>> 0);
 }
 HEAPF32[i40 >> 2] = f1;
 HEAPF32[i40 + 4 >> 2] = f2;
 HEAPF32[i40 + 8 >> 2] = f3;
 HEAPF32[i40 + 12 >> 2] = f4;
 i10 = i36 + 8 | 0;
 i6 = i36 + 4 | 0;
 i9 = 0;
 do {
  if (HEAP8[i41 + i9 >> 0] | 0) if ((HEAP16[i39 + (i9 << 5) + 8 >> 1] | 0) == -1) if ((HEAP16[i39 + (i9 << 5) + 12 >> 1] | 0) == -1) {
   i7 = HEAP32[i40 + (i9 << 2) >> 2] | 0;
   if (i7 | 0) {
    i8 = HEAP32[i37 + (i9 << 2) >> 2] | 0;
    f2 = Math_fround(HEAPF32[i8 + 36 >> 2]);
    i36 = f2 < Math_fround(3402823469999999843913219.0e14);
    i5 = HEAP32[i38 + (i9 << 2) >> 2] | 0;
    f1 = Math_fround(HEAPF32[i5 + 36 >> 2]);
    if (i36 | f1 < Math_fround(3402823469999999843913219.0e14)) {
     i33 = HEAP32[i8 + 40 >> 2] | 0;
     i34 = HEAP32[i5 + 40 >> 2] | 0;
     i32 = i34 >>> 0 < i33 >>> 0;
     i36 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = i36 + 1;
     i35 = HEAP32[i6 >> 2] | 0;
     HEAP32[i35 + (i36 << 4) >> 2] = i32 ? i34 : i33;
     HEAP32[i35 + (i36 << 4) + 4 >> 2] = i32 ? i33 : i34;
     HEAP32[i35 + (i36 << 4) + 8 >> 2] = i7;
     HEAPF32[i35 + (i36 << 4) + 12 >> 2] = f2 < f1 ? f2 : f1;
    }
   }
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != 4);
 STACKTOP = i42;
 return;
}

function __ZN27AnimatorControllerParameter7SetNameEPKc(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i7 = i8 + 11 | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
 if (!(_strcmp(i1, i2) | 0)) {
  STACKTOP = i12;
  return;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i11 = 8;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i11 = 10;
  }
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i6 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i10 + 11 | 0;
 do if ((i8 | 0) != (i10 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
  i6 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i4 = i8 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 35; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 35; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 37;
 }
 if ((i11 | 0) == 35) i11 = 37;
 if ((i11 | 0) == 37) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 43; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 43; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 45;
  }
 }
 if ((i11 | 0) == 43) i11 = 45;
 if ((i11 | 0) == 45) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 51; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 51; else if (HEAP32[i1 + 4 >> 2] | 0) {
   STACKTOP = i12;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine7Connect18ConnectSessionInfo12ToJsonStringER8UnityStr(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 192 | 0;
 i12 = i14;
 i13 = i14 + 160 | 0;
 i11 = i14 + 144 | 0;
 __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i12, 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i3, gb + 1040635 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i3 + 16 | 0, gb + 1040641 | 0, 0);
 __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i12, i3 + 32 | 0, gb + 1040648 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i3 + 60 | 0, gb + 1040658 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i12, i3 + 76 | 0, gb + 1040667 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i3 + 40 | 0, gb + 1040678 | 0, 0);
 i1 = i3 + 56 | 0;
 if (HEAP8[i1 >> 0] | 0) __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1040686 | 0, 0);
 i2 = i3 + 80 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 84 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040699 | 0, 0);
 i2 = i3 + 96 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 100 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040711 | 0, 0);
 i2 = i3 + 112 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 116 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040726 | 0, 0);
 i2 = i3 + 128 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 132 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040741 | 0, 0);
 i2 = i3 + 144 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 148 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040756 | 0, 0);
 i2 = i3 + 160 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 164 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040766 | 0, 0);
 i2 = i3 + 176 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 180 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i12, i2, gb + 1040775 | 0, 0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 i8 = i13 + 24 | 0;
 i3 = gb + 64016 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i13 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i12, i13, 0);
 i2 = HEAP32[i13 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? i1 : i2;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = 41;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i4 = 43;
  }
 } else i4 = 41;
 if ((i4 | 0) == 41) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i4 = 43;
 }
 if ((i4 | 0) == 43) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i11 + 11 | 0;
 do if ((i11 | 0) != (i9 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
  i6 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
  i7 = i9 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i7 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i6 - i3 | 0, i7, 0, i7, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  __ZN9JSONWriteD2Ev(i12);
  STACKTOP = i14;
  return;
 }
 if (!(HEAP32[i13 + 4 >> 2] | 0)) {
  __ZN9JSONWriteD2Ev(i12);
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 __ZN9JSONWriteD2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN7mecanim13ValueArraySubERKNS_10ValueArrayERS0_PKNS_14ValueArrayMaskE(i10, i9, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i4 | 0) {
  i3 = i8 + 4 | 0;
  i5 = i9 + 4 | 0;
  i6 = i5;
  i7 = i10 + 4 | 0;
  i2 = i7;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i1 = 0;
  do {
   if (HEAP8[i3 + i1 >> 0] | 0) {
    i11 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    i15 = i11 + (i1 * 12 | 0) | 0;
    f17 = Math_fround(HEAPF32[i15 >> 2]);
    i13 = i11 + (i1 * 12 | 0) + 4 | 0;
    f19 = Math_fround(HEAPF32[i13 >> 2]);
    i11 = i11 + (i1 * 12 | 0) + 8 | 0;
    f12 = Math_fround(HEAPF32[i11 >> 2]);
    i18 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
    f16 = Math_fround(HEAPF32[i18 + (i1 * 12 | 0) >> 2]);
    f14 = Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 4 >> 2]);
    f14 = Math_fround(f19 - f14);
    f12 = Math_fround(f12 - Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 8 >> 2]));
    HEAPF32[i15 >> 2] = Math_fround(f17 - f16);
    HEAPF32[i13 >> 2] = f14;
    HEAPF32[i11 >> 2] = f12;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i2 = HEAP32[i9 + 8 >> 2] | 0;
 if (i2 | 0) {
  i7 = i8 + 12 | 0;
  i3 = i9 + 12 | 0;
  i4 = i3;
  i5 = i10 + 12 | 0;
  i6 = i5;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i1 = 0;
  do {
   if (HEAP8[i7 + i1 >> 0] | 0) {
    i18 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
    i11 = i18 + (i1 << 4) | 0;
    f26 = Math_fround(HEAPF32[i11 >> 2]);
    i13 = i18 + (i1 << 4) + 4 | 0;
    f24 = Math_fround(HEAPF32[i13 >> 2]);
    i15 = i18 + (i1 << 4) + 8 | 0;
    f28 = Math_fround(HEAPF32[i15 >> 2]);
    i18 = i18 + (i1 << 4) + 12 | 0;
    f12 = Math_fround(HEAPF32[i18 >> 2]);
    i21 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    f17 = Math_fround(HEAPF32[i21 + (i1 << 4) + 12 >> 2]);
    f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 << 4) + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = Math_fround(f26 * f14);
    f19 = Math_fround(f12 * f17);
    f25 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 << 4) + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f24 * f25);
    f27 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i21 + (i1 << 4) >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f28 * f17)) - Math_fround(f12 * f25)) - Math_fround(f24 * f27));
    f19 = Math_fround(Math_fround(Math_fround(f19 - Math_fround(f26 * f27)) - Math_fround(f28 * f25)) - Math_fround(f24 * f14));
    f20 = Math_fround(Math_fround(Math_fround(f20 - Math_fround(f28 * f14)) - Math_fround(f26 * f17)) - Math_fround(f12 * f27));
    f14 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f17)) - Math_fround(f12 * f14));
    i21 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    i23 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f14 = (HEAP32[tempDoublePtr >> 2] = i23 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f20 = Math_fround(f14 * f14);
    f16 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(f16 * f16);
    f17 = (HEAP32[tempDoublePtr >> 2] = i21 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f17 * f17)) + Math_fround(f20 + f12)))));
    f16 = Math_fround(f12 * f16);
    f17 = Math_fround(f12 * f17);
    f19 = Math_fround(f12 * f19);
    HEAPF32[i11 >> 2] = Math_fround(f12 * f14);
    HEAPF32[i13 >> 2] = f16;
    HEAPF32[i15 >> 2] = f17;
    HEAPF32[i18 >> 2] = f19;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i9 + 16 >> 2] | 0;
 if (i2 | 0) {
  i7 = i8 + 20 | 0;
  i3 = i9 + 20 | 0;
  i4 = i3;
  i5 = i10 + 20 | 0;
  i6 = i5;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i1 = 0;
  do {
   if (HEAP8[i7 + i1 >> 0] | 0) {
    i23 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
    i21 = i23 + (i1 * 12 | 0) | 0;
    f25 = Math_fround(HEAPF32[i21 >> 2]);
    i22 = i23 + (i1 * 12 | 0) + 4 | 0;
    f24 = Math_fround(HEAPF32[i22 >> 2]);
    i23 = i23 + (i1 * 12 | 0) + 8 | 0;
    f28 = Math_fround(HEAPF32[i23 >> 2]);
    i18 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
    f26 = Math_fround(HEAPF32[i18 + (i1 * 12 | 0) >> 2]);
    f27 = Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 4 >> 2]);
    f27 = Math_fround(f24 - f27);
    f28 = Math_fround(f28 - Math_fround(HEAPF32[i18 + (i1 * 12 | 0) + 8 >> 2]));
    HEAPF32[i21 >> 2] = Math_fround(f25 - f26);
    HEAPF32[i22 >> 2] = f27;
    HEAPF32[i23 >> 2] = f28;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i5) return;
 i4 = i8 + 28 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i3 = i9 + 28 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i2 = i10 + 28 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 0;
 do {
  if (HEAP8[i4 + i1 >> 0] | 0) {
   i23 = i3 + (i1 << 2) | 0;
   f28 = Math_fround(HEAPF32[i23 >> 2]);
   HEAPF32[i23 >> 2] = Math_fround(f28 - Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_(i7, i8, i5, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i6 = __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i7, i8, i5, i1) | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 i4 = i5 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i9 = i6;
    STACKTOP = i10;
    return i9 | 0;
   }
   i1 = i3 + 16 | 0;
   i12 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = i5 + 16 | 0;
   i11 = HEAP32[i2 + 4 >> 2] | 0;
   if (!((i12 | 0) < (i11 | 0) | ((i12 | 0) == (i11 | 0) ? (HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 : 0))) {
    i12 = i6;
    STACKTOP = i10;
    return i12 | 0;
   }
  }
 } else if ((i2 | 0) >= (i1 | 0)) {
  i12 = i6;
  STACKTOP = i10;
  return i12 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i3 = i6 + 1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = i8 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i2 = HEAP32[i8 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i12 = i3;
    STACKTOP = i10;
    return i12 | 0;
   }
   i11 = i5 + 16 | 0;
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i8 + 16 | 0;
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   if (!((i1 | 0) < (i2 | 0) | ((i1 | 0) == (i2 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 : 0))) {
    i12 = i3;
    STACKTOP = i10;
    return i12 | 0;
   }
  }
 } else if ((i1 | 0) >= (i2 | 0)) {
  i12 = i3;
  STACKTOP = i10;
  return i12 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i3 = i6 + 2 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   if ((i1 | 0) > (i2 | 0)) {
    i12 = i3;
    STACKTOP = i10;
    return i12 | 0;
   }
   i11 = i8 + 16 | 0;
   i4 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i7 + 16 | 0;
   i5 = HEAP32[i12 + 4 >> 2] | 0;
   if (!((i4 | 0) < (i5 | 0) | ((i4 | 0) == (i5 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 : 0))) {
    i12 = i3;
    STACKTOP = i10;
    return i12 | 0;
   }
  }
 } else if ((i1 | 0) >= (i2 | 0)) {
  i12 = i3;
  STACKTOP = i10;
  return i12 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i12 = i6 + 3 | 0;
 STACKTOP = i10;
 return i12 | 0;
}

function __ZN7Striper16ConnectAllStripsER13STRIPERRESULT(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = __Znwj(12) | 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i13 = __Znwj(16) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 4096;
 HEAP32[i13 + 4 >> 2] = __Znaj(4096) | 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i1 + 24 >> 2] = i12;
 i13 = i1 + 20 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 8 | 0;
 if (HEAP32[i15 >> 2] | 0) {
  i11 = HEAP32[i15 + 4 >> 2] | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i10 = 0;
  while (1) {
   do if (i10) {
    i6 = HEAP32[i9 + -4 >> 2] | 0;
    i7 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i1 = i4 + 12 | 0;
    if (((HEAP32[i4 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) {
     i5 = __Znwj(16) | 0;
     i3 = i5 + 4 | 0;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     if (!i4) {
      i2 = 0;
      i1 = 0;
     } else {
      i2 = 1;
      i1 = HEAP32[i1 >> 2] << 1;
     }
     HEAP32[i5 + 12 >> 2] = i1;
     HEAP32[i3 >> 2] = __Znaj(i1) | 0;
     HEAP32[i5 + 8 >> 2] = 0;
     HEAP32[i12 >> 2] = i5;
     if (i2) {
      HEAP32[i4 >> 2] = i5;
      i2 = i5;
      i1 = i5;
     } else {
      i2 = i5;
      i1 = i5;
     }
    } else {
     i2 = i4;
     i1 = i4;
    }
    i8 = i2 + 8 | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + i5 >> 2] = i6;
    HEAP32[i8 >> 2] = i5 + 4;
    i2 = i1 + 12 | 0;
    if (((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
     i4 = __Znwj(16) | 0;
     i5 = i4 + 4 | 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i4 >> 2] = 0;
     if (!i1) {
      i3 = 0;
      i2 = 0;
     } else {
      i3 = 1;
      i2 = HEAP32[i2 >> 2] << 1;
     }
     HEAP32[i4 + 12 >> 2] = i2;
     HEAP32[i5 >> 2] = __Znaj(i2) | 0;
     HEAP32[i4 + 8 >> 2] = 0;
     HEAP32[i12 >> 2] = i4;
     if (i3) {
      HEAP32[i1 >> 2] = i4;
      i1 = i4;
     } else i1 = i4;
    }
    i8 = i1 + 8 | 0;
    i6 = HEAP32[i8 >> 2] | 0;
    HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + i6 >> 2] = i7;
    HEAP32[i8 >> 2] = i6 + 4;
    i8 = (HEAP32[i13 >> 2] | 0) + 2 | 0;
    HEAP32[i13 >> 2] = i8;
    if (i8 & 1) {
     i1 = i9 + 4 | 0;
     if ((i7 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i9 = i11 + (i10 << 2) | 0;
      HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
      i9 = i1;
      break;
     }
     i1 = HEAP32[i12 >> 2] | 0;
     i2 = i1 + 12 | 0;
     if (((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
      i4 = __Znwj(16) | 0;
      i5 = i4 + 4 | 0;
      HEAP32[i5 >> 2] = 0;
      HEAP32[i4 >> 2] = 0;
      if (!i1) {
       i3 = 0;
       i2 = 0;
      } else {
       i3 = 1;
       i2 = HEAP32[i2 >> 2] << 1;
      }
      HEAP32[i4 + 12 >> 2] = i2;
      HEAP32[i5 >> 2] = __Znaj(i2) | 0;
      HEAP32[i4 + 8 >> 2] = 0;
      HEAP32[i12 >> 2] = i4;
      if (i3) {
       HEAP32[i1 >> 2] = i4;
       i1 = i4;
      } else i1 = i4;
     }
     i8 = i1 + 8 | 0;
     i6 = HEAP32[i8 >> 2] | 0;
     HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + i6 >> 2] = i7;
     HEAP32[i8 >> 2] = i6 + 4;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    }
   } while (0);
   i8 = i11 + (i10 << 2) | 0;
   if (!(HEAP32[i8 >> 2] | 0)) i1 = 0; else {
    i7 = 0;
    i2 = HEAP32[i12 >> 2] | 0;
    do {
     i6 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
     i1 = i2 + 12 | 0;
     if (((HEAP32[i2 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) {
      i5 = __Znwj(16) | 0;
      i4 = i5 + 4 | 0;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i5 >> 2] = 0;
      if (!i2) {
       i3 = 0;
       i1 = 0;
      } else {
       i3 = 1;
       i1 = HEAP32[i1 >> 2] << 1;
      }
      HEAP32[i5 + 12 >> 2] = i1;
      HEAP32[i4 >> 2] = __Znaj(i1) | 0;
      HEAP32[i5 + 8 >> 2] = 0;
      HEAP32[i12 >> 2] = i5;
      if (i3) {
       HEAP32[i2 >> 2] = i5;
       i1 = i5;
       i2 = i5;
      } else {
       i1 = i5;
       i2 = i5;
      }
     } else i1 = i2;
     i5 = i1 + 8 | 0;
     i4 = HEAP32[i5 >> 2] | 0;
     HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + i4 >> 2] = i6;
     HEAP32[i5 >> 2] = i4 + 4;
     i7 = i7 + 1 | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    } while (i7 >>> 0 < i1 >>> 0);
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i1;
   i10 = i10 + 1 | 0;
   if (i10 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else i9 = i9 + (i1 << 2) | 0;
  }
 }
 HEAP32[i15 >> 2] = 1;
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i3; else {
  __ZdaPv(i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i2 = 0;
 do {
  i12 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = (HEAP32[i12 + 8 >> 2] | 0) + i2 | 0;
 } while ((i1 | 0) != 0);
 if (!i2) {
  HEAP32[i4 >> 2] = 0;
  i12 = 0;
  HEAP32[i14 >> 2] = i12;
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = i13;
  return 1;
 }
 i1 = __Znaj(i2) | 0;
 HEAP32[i4 >> 2] = i1;
 i12 = (HEAP32[i3 >> 2] | 0) == 0;
 i2 = i3 + 8 | 0;
 _memcpy(i1 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (i12) {
  i12 = i1;
  HEAP32[i14 >> 2] = i12;
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = i13;
  return 1;
 } else i4 = i1;
 do {
  i4 = i4 + (HEAP32[i2 >> 2] | 0) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i12 = (HEAP32[i3 >> 2] | 0) == 0;
  i2 = i3 + 8 | 0;
  _memcpy(i4 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 } while (!i12);
 HEAP32[i14 >> 2] = i1;
 i15 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i13;
 return 1;
}

function __ZN5physx26PxConvexMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i16, i2, i5, i6, i14, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 96 | 0;
 i13 = i24 + 32 | 0;
 i2 = i24 + 88 | 0;
 i7 = i24 + 28 | 0;
 i15 = i24;
 i1 = i13 + 50 | 0;
 i3 = i13;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP16[i13 + 48 >> 1] = 0;
 HEAP16[i1 >> 1] = 256;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i5, gb + 673324 | 0, i23, i13, i13 + 8 | 0, i6);
 HEAP32[i13 + 4 >> 2] = HEAP32[i23 >> 2];
 HEAP16[i13 + 48 >> 1] = 4;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIhEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i5, gb + 673178 | 0, i23, i2, i7, i6);
 i1 = HEAP32[i23 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i23 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i11 = i23 + 4 | 0;
 HEAP32[i11 >> 2] = i23;
 i18 = i23;
 HEAP32[i23 + 8 >> 2] = i18;
 i21 = i23 + 12 | 0;
 HEAP32[i21 >> 2] = 0;
 i12 = i23 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i22 = i23 + 20 | 0;
 HEAP32[i22 >> 2] = 0;
 i9 = i23 + 24 | 0;
 HEAP32[i9 >> 2] = i18;
 i18 = i23 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAPF32[i23 + 52 >> 2] = Math_fround(.75);
 i19 = i23 + 56 | 0;
 HEAP32[i19 >> 2] = -1;
 HEAP32[i23 + 60 >> 2] = 0;
 i20 = i23 + 64 | 0;
 HEAP32[i20 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i9, 64);
 HEAP32[i23 + 68 >> 2] = 32;
 i9 = i15 + 4 | 0;
 i10 = i15 + 8 | 0;
 HEAP32[i10 >> 2] = i23;
 i8 = i15 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i15 >> 2] = gb + 89528 + 8;
 HEAP32[i9 >> 2] = gb + 89528 + 32;
 i7 = HEAP32[i7 >> 2] | 0;
 if (!i7) {
  i3 = i15 + 4 | 0;
  i1 = i14;
  i2 = i15 + 20 | 0;
  i17 = 10;
 } else {
  i6 = i15 + 24 | 0;
  i2 = 32;
  while (1) if (i2 >>> 0 < i7 >>> 0) i2 = i2 << 1; else {
   i5 = i2;
   break;
  }
  i4 = __ZN5physx19CVariableMemoryPool8allocateEj(i23 + 4 | 0, i5) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i15 + 20 | 0;
  if (i3 | 0) _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i10 >> 2] | 0) + 4 | 0, i3 + -8 | 0, HEAP32[i3 + -4 >> 2] | 0);
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  _memcpy(i4 + (HEAP32[i8 >> 2] | 0) | 0, i1 | 0, i7 | 0) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i7;
  i1 = HEAP32[i14 >> 2] | 0;
  i3 = i15 + 4 | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i3 | 0) | 0;
  if (!i1) {
   i1 = i14;
   i17 = 10;
  }
 }
 if ((i17 | 0) == 10) {
  HEAP32[i15 + 16 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] | 0, i17 | 0, i13 | 0, i15 | 0, 0) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i3 | 0) | 0;
 }
 HEAP32[i16 >> 2] = gb + 753930;
 HEAP32[i16 + 4 >> 2] = i1;
 i17 = i16 + 8 | 0;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i15 >> 2] = gb + 89572 + 8;
 HEAP32[i9 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i10 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 i1 = HEAP32[i21 >> 2] | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + (i17 << 2) | 0;
 if (i17 | 0) do {
  i17 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[i23 + 48 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i20 >> 2] | 0) == 0)) {
  _memset(HEAP32[i23 + 40 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i23 + 44 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i23 + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i20 >> 2] = 0;
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[HEAP32[i23 + 24 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i24;
  return;
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 i23 = HEAP32[HEAP32[i23 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i24;
 return;
}

function __ZN12GeomQueryAnyIN5physx10PxSweepHitEE7geomHitERKNS0_2Sq17SceneQueryManagerERKNS0_15MultiQueryInputERKNS3_9ShapeDataERKNS0_10PxGeometryERKNS0_11PxTransformENS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEjPS1_fbPNS0_9PxBounds3E(i16, i12, i21, i20, i19, i17, i2, i18, f4, i1, i5) {
 i16 = i16 | 0;
 i12 = i12 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 f4 = Math_fround(f4);
 i1 = i1 | 0;
 i5 = i5 | 0;
 var f3 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i41 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i41 = i15 + 80 | 0;
 i23 = i15 + 64 | 0;
 i2 = i15 + 60 | 0;
 i1 = i15 + 56 | 0;
 i24 = i15 + 44 | 0;
 i22 = i15 + 32 | 0;
 i14 = i15 + 4 | 0;
 i6 = i15 + 110 | 0;
 i7 = i15 + 108 | 0;
 i8 = i15 + 106 | 0;
 i9 = i15 + 104 | 0;
 i10 = HEAP32[i12 + 12 >> 2] | 0;
 i11 = HEAP32[i12 + 16 >> 2] | 0;
 f29 = Math_fround(HEAPF32[i5 >> 2]);
 f35 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f34 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i20, i41, i19, Math_fround(0.0), 0);
 f40 = Math_fround(Math_fround(f28 - f29) * Math_fround(.5));
 f39 = Math_fround(Math_fround(f34 - f35) * Math_fround(.5));
 f36 = Math_fround(Math_fround(f31 - f32) * Math_fround(.5));
 f26 = Math_fround(HEAPF32[i41 + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i41 >> 2]);
 f38 = Math_fround(f26 - f27);
 f25 = Math_fround(HEAPF32[i41 + 16 >> 2]);
 f33 = Math_fround(HEAPF32[i41 + 4 >> 2]);
 f37 = Math_fround(f25 - f33);
 f3 = Math_fround(HEAPF32[i41 + 20 >> 2]);
 f30 = Math_fround(HEAPF32[i41 + 8 >> 2]);
 f38 = Math_fround(Math_fround(f40 + Math_fround(f38 * Math_fround(.5))) * Math_fround(1.00999999));
 f37 = Math_fround(Math_fround(f39 + Math_fround(f37 * Math_fround(.5))) * Math_fround(1.00999999));
 f36 = Math_fround(Math_fround(f36 + Math_fround(Math_fround(f3 - f30) * Math_fround(.5))) * Math_fround(1.00999999));
 HEAPF32[i23 >> 2] = f38;
 HEAPF32[i23 + 4 >> 2] = f37;
 HEAPF32[i23 + 8 >> 2] = f36;
 f37 = Math_fround(-f37);
 f36 = Math_fround(-f36);
 HEAPF32[i24 >> 2] = Math_fround(-f38);
 HEAPF32[i24 + 4 >> 2] = f37;
 HEAPF32[i24 + 8 >> 2] = f36;
 f25 = Math_fround(Math_fround(Math_fround(f35 + f34) * Math_fround(.5)) - Math_fround(Math_fround(f33 + f25) * Math_fround(.5)));
 f3 = Math_fround(Math_fround(Math_fround(f32 + f31) * Math_fround(.5)) - Math_fround(Math_fround(f30 + f3) * Math_fround(.5)));
 HEAPF32[i22 >> 2] = Math_fround(Math_fround(Math_fround(f29 + f28) * Math_fround(.5)) - Math_fround(Math_fround(f27 + f26) * Math_fround(.5)));
 HEAPF32[i22 + 4 >> 2] = f25;
 HEAPF32[i22 + 8 >> 2] = f3;
 i5 = i12 + 4 | 0;
 if (__ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i24, i23, i22, HEAP32[i5 >> 2] | 0, f4, i2, i1) | 0) f3 = Math_fround(HEAPF32[i1 >> 2]); else {
  f40 = Math_fround(HEAPF32[i2 >> 2]);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  if (f40 > f3) {
   i41 = 0;
   STACKTOP = i15;
   return i41 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 f4 = f3 < f4 ? f3 : f4;
 f3 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 switch (HEAP32[i10 >> 2] | 0) {
 case 0:
  {
   i22 = i11 + 16 | 0;
   i24 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i22 >> 2];
   i23 = i11 + 20 | 0;
   HEAP32[i14 + 4 >> 2] = HEAP32[i23 >> 2];
   i41 = i11 + 24 | 0;
   HEAP32[i14 + 8 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i41 >> 2];
   HEAP32[i14 + 24 >> 2] = i24;
   i24 = HEAP16[i17 >> 1] | 0;
   i41 = HEAP32[i20 >> 2] | 0;
   i41 = HEAP32[(i24 & 256 ? i1 + 28 + (i41 << 2) | 0 : i1 + (i41 << 2) | 0) >> 2] | 0;
   HEAP16[i6 >> 1] = i24;
   i41 = (mftCall_iiiiifiif(i41 | 0, i20 | 0, i19 | 0, i14 | 0, i2 | 0, +f4, i18 | 0, i6 | 0, +f3) | 0) & 1;
   STACKTOP = i15;
   return i41 | 0;
  }
 case 2:
  {
   i24 = HEAP16[i17 >> 1] | 0;
   i41 = HEAP32[i20 >> 2] | 0;
   i41 = HEAP32[(i24 & 256 ? i1 + 28 + (i41 << 2) | 0 : i1 + (i41 << 2) | 0) >> 2] | 0;
   HEAP16[i7 >> 1] = i24;
   i41 = (mftCall_iiiiifiif(i41 | 0, i20 | 0, i19 | 0, i21 + 148 | 0, i2 | 0, +f4, i18 | 0, i7 | 0, +f3) | 0) & 1;
   STACKTOP = i15;
   return i41 | 0;
  }
 case 3:
  {
   i24 = HEAP16[i17 >> 1] | 0;
   i41 = HEAP32[i20 >> 2] | 0;
   i41 = HEAP32[(i24 & 256 ? i1 + 84 + (i41 << 2) | 0 : i1 + 56 + (i41 << 2) | 0) >> 2] | 0;
   HEAP16[i8 >> 1] = i24;
   i41 = (mftCall_iiiiifiif(i41 | 0, i20 | 0, i19 | 0, i21 + 148 | 0, i2 | 0, +f4, i18 | 0, i8 | 0, +f3) | 0) & 1;
   STACKTOP = i15;
   return i41 | 0;
  }
 case 4:
  {
   i41 = HEAP32[i1 + 112 + (HEAP32[i20 >> 2] << 2) >> 2] | 0;
   HEAP16[i9 >> 1] = HEAP16[i17 >> 1] | 0;
   i41 = (mftCall_iiiiiifiif(i41 | 0, i20 | 0, i19 | 0, i10 | 0, i11 | 0, i2 | 0, +f4, i18 | 0, i9 | 0, +f3) | 0) & 1;
   STACKTOP = i15;
   return i41 | 0;
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 688250 | 0, 282, gb + 688326 | 0, i13);
   i41 = 0;
   STACKTOP = i15;
   return i41 | 0;
  }
 }
 return 0;
}

function _compress_block(i19, i18, i14) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = i19 + 5792 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  i5 = i19 + 5820 | 0;
  i1 = i19 + 5816 | 0;
  i7 = i1;
  i6 = i5;
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP16[i1 >> 1] | 0;
 } else {
  i16 = i19 + 5796 | 0;
  i17 = i19 + 5784 | 0;
  i6 = i19 + 5820 | 0;
  i7 = i19 + 5816 | 0;
  i12 = i19 + 20 | 0;
  i13 = i19 + 8 | 0;
  i11 = 0;
  do {
   i8 = HEAP16[(HEAP32[i16 >> 2] | 0) + (i11 << 1) >> 1] | 0;
   i10 = i8 & 65535;
   i9 = HEAPU8[(HEAP32[i17 >> 2] | 0) + i11 >> 0] | 0;
   i11 = i11 + 1 | 0;
   if (!(i8 << 16 >> 16)) {
    i4 = HEAPU16[i18 + (i9 << 2) + 2 >> 1] | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    i2 = HEAPU16[i18 + (i9 << 2) >> 1] | 0;
    i3 = HEAPU16[i7 >> 1] | 0 | i2 << i5;
    i1 = i3 & 65535;
    HEAP16[i7 >> 1] = i1;
    if ((i5 | 0) > (16 - i4 | 0)) {
     i1 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i1 >> 0] = i3;
     i1 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i5 >> 0] = i1;
     i5 = HEAP32[i6 >> 2] | 0;
     i1 = i2 >>> (16 - i5 | 0) & 65535;
     HEAP16[i7 >> 1] = i1;
     i5 = i4 + -16 + i5 | 0;
    } else i5 = i5 + i4 | 0;
    HEAP32[i6 >> 2] = i5;
   } else {
    i8 = HEAPU8[gb + 361974 + i9 >> 0] | 0;
    i1 = (i8 | 256) + 1 | 0;
    i4 = HEAPU16[i18 + (i1 << 2) + 2 >> 1] | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    i1 = HEAPU16[i18 + (i1 << 2) >> 1] | 0;
    i3 = HEAPU16[i7 >> 1] | 0 | i1 << i5;
    i2 = i3 & 65535;
    HEAP16[i7 >> 1] = i2;
    if ((i5 | 0) > (16 - i4 | 0)) {
     i2 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i2 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i2 >> 0] = i3;
     i2 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i5 >> 0] = i2;
     i5 = HEAP32[i6 >> 2] | 0;
     i2 = i1 >>> (16 - i5 | 0) & 65535;
     HEAP16[i7 >> 1] = i2;
     i4 = i4 + -16 + i5 | 0;
    } else i4 = i5 + i4 | 0;
    HEAP32[i6 >> 2] = i4;
    i5 = HEAP32[gb + 16488 + (i8 << 2) >> 2] | 0;
    if ((i8 + -8 | 0) >>> 0 < 20) {
     i3 = i9 - (HEAP32[gb + 16604 + (i8 << 2) >> 2] | 0) | 0;
     i1 = i2 & 65535 | i3 << i4;
     i2 = i1 & 65535;
     HEAP16[i7 >> 1] = i2;
     if ((i4 | 0) > (16 - i5 | 0)) {
      i2 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i2 + 1;
      HEAP8[(HEAP32[i13 >> 2] | 0) + i2 >> 0] = i1;
      i2 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
      i1 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i1 + 1;
      HEAP8[(HEAP32[i13 >> 2] | 0) + i1 >> 0] = i2;
      i1 = HEAP32[i6 >> 2] | 0;
      i2 = (i3 & 65535) >>> (16 - i1 | 0) & 65535;
      HEAP16[i7 >> 1] = i2;
      i1 = i5 + -16 + i1 | 0;
     } else i1 = i4 + i5 | 0;
     HEAP32[i6 >> 2] = i1;
     i5 = i1;
    } else i5 = i4;
    i8 = i10 + -1 | 0;
    i9 = HEAPU8[(i8 >>> 0 < 256 ? i8 : (i8 >>> 7) + 256 | 0) + (gb + 361462) >> 0] | 0;
    i3 = HEAPU16[i14 + (i9 << 2) + 2 >> 1] | 0;
    i4 = HEAPU16[i14 + (i9 << 2) >> 1] | 0;
    i2 = i2 & 65535 | i4 << i5;
    i1 = i2 & 65535;
    HEAP16[i7 >> 1] = i1;
    if ((i5 | 0) > (16 - i3 | 0)) {
     i1 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i1 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i1 >> 0] = i2;
     i1 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
     i5 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i5 + 1;
     HEAP8[(HEAP32[i13 >> 2] | 0) + i5 >> 0] = i1;
     i5 = HEAP32[i6 >> 2] | 0;
     i1 = i4 >>> (16 - i5 | 0) & 65535;
     HEAP16[i7 >> 1] = i1;
     i5 = i3 + -16 + i5 | 0;
    } else i5 = i5 + i3 | 0;
    HEAP32[i6 >> 2] = i5;
    i4 = HEAP32[gb + 16720 + (i9 << 2) >> 2] | 0;
    if ((i9 + -4 | 0) >>> 0 < 26) {
     i3 = i8 - (HEAP32[gb + 16840 + (i9 << 2) >> 2] | 0) | 0;
     i2 = i1 & 65535 | i3 << i5;
     i1 = i2 & 65535;
     HEAP16[i7 >> 1] = i1;
     if ((i5 | 0) > (16 - i4 | 0)) {
      i1 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i1 + 1;
      HEAP8[(HEAP32[i13 >> 2] | 0) + i1 >> 0] = i2;
      i1 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
      i5 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i5 + 1;
      HEAP8[(HEAP32[i13 >> 2] | 0) + i5 >> 0] = i1;
      i5 = HEAP32[i6 >> 2] | 0;
      i1 = (i3 & 65535) >>> (16 - i5 | 0) & 65535;
      HEAP16[i7 >> 1] = i1;
      i5 = i4 + -16 + i5 | 0;
     } else i5 = i5 + i4 | 0;
     HEAP32[i6 >> 2] = i5;
    }
   }
  } while (i11 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 i3 = i18 + 1026 | 0;
 i4 = HEAPU16[i3 >> 1] | 0;
 i2 = HEAPU16[i18 + 1024 >> 1] | 0;
 i1 = i1 & 65535 | i2 << i5;
 HEAP16[i7 >> 1] = i1;
 if ((i5 | 0) > (16 - i4 | 0)) {
  i15 = i19 + 20 | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = i16 + 1;
  i17 = i19 + 8 | 0;
  HEAP8[(HEAP32[i17 >> 2] | 0) + i16 >> 0] = i1;
  i16 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i18 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = i18 + 1;
  HEAP8[(HEAP32[i17 >> 2] | 0) + i18 >> 0] = i16;
  i18 = HEAP32[i6 >> 2] | 0;
  HEAP16[i7 >> 1] = i2 >>> (16 - i18 | 0);
  i18 = i4 + -16 + i18 | 0;
  HEAP32[i6 >> 2] = i18;
  i18 = HEAP16[i3 >> 1] | 0;
  i18 = i18 & 65535;
  i19 = i19 + 5812 | 0;
  HEAP32[i19 >> 2] = i18;
  return;
 } else {
  i18 = i5 + i4 | 0;
  HEAP32[i6 >> 2] = i18;
  i18 = HEAP16[i3 >> 1] | 0;
  i18 = i18 & 65535;
  i19 = i19 + 5812 | 0;
  HEAP32[i19 >> 2] = i18;
  return;
 }
}

function __ZN21WorldParticleCollider8TransferI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i5 = i11;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i6, i10);
 i4 = i6 + 36 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048629 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i9 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048644 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i9 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048666 | 0, gb + 1048681 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i5 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i9 = 30; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 30; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i9 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i8 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   if (__ZN14SafeBinaryRead12IsOldVersionEi(i10, 1) | 0) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 32 | 0) HEAP32[i4 >> 2] = i1 | -65536;
   }
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i3 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048697 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1048720 | 0, i7, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i8 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i8 >>> 0) i9 = 56; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 56; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i9 | 0) == 56) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE4FindERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i4 << 24 >> 24 < 0;
 i2 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  i3 = i9 + 11 | 0;
  HEAP8[i3 >> 0] = i4;
  if (!i4) i1 = i9; else {
   i1 = i9;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i3 = i4 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i4;
  i3 = i9 + 11 | 0;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESL_EERKT_(i8, i5 + 12 | 0, i9);
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = 0;
 L13 : while (1) {
  i6 = (i1 | 0) == 0;
  while (1) {
   if (!i6) {
    i3 = i2;
    break;
   }
   i4 = i2;
   if ((i4 | 0) == (i7 | 0)) {
    i1 = 0;
    i10 = 42;
    break L13;
   }
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     break;
    } else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
   }
   i5 = i4 + 32 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if (i3 | 0) {
    i10 = 18;
    break;
   }
  }
  if ((i10 | 0) == 18) {
   i10 = 0;
   HEAP32[i9 >> 2] = i3;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 24; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 24; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 25;
    }
   }
   if ((i10 | 0) == 24) i10 = 25;
   if ((i10 | 0) == 25) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
   continue;
  }
  while (1) {
   i4 = i3;
   if ((i4 | 0) == (i7 | 0)) {
    i10 = 42;
    break L13;
   }
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   i3 = i2;
   i6 = i4 + 32 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) {
    i6 = i1;
    i2 = i3;
    i1 = i6;
    continue L13;
   }
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 38; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i4 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i4 + (i5 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i4 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i4 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
     i4 = HEAP32[i5 + 28 >> 2] | 0;
     i5 = HEAP32[i5 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i10 = 38; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i10 = 40;
    }
   }
   if ((i10 | 0) == 38) i10 = 40;
   if ((i10 | 0) == 40) {
    i10 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    if (!i2) {
     i12 = i1;
     i2 = i3;
     i1 = i12;
     continue L13;
    }
   }
   if ((HEAP32[i2 + 8 >> 2] & 499712 | 0) != 499712) {
    i1 = i2;
    i2 = i3;
    continue L13;
   }
  }
 }
 if ((i10 | 0) == 42) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i13, f8, i1) {
 i13 = i13 | 0;
 f8 = Math_fround(f8);
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, d15 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 4 | 0;
 i4 = i14;
 if ((HEAP16[gb + 1452164 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452164 | 0, i7);
  i12 = gb + 1452164 | 0;
 } else i12 = 0;
 i9 = i1 & 1;
 if (!(i1 & 2)) {
  i11 = i13 + 40 | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i7 + 8 >> 2] = 1;
  i10 = i13 + 36 | 0;
  __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i13, HEAP32[i10 >> 2] | 0, i7, f8, i9);
  __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i13, HEAP32[i13 + 32 >> 2] | 0, f8, i9, 0);
  __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i13, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, i9);
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 + 8 >> 2] = 2;
  HEAP8[i11 + 12 >> 0] = 0;
  __ZN14ParticleSystem17RemoveFromManagerEv(i13);
 } else {
  __ZN14ParticleSystem10ResetSeedsEv(i13);
  i10 = i13 + 40 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP8[i11 + 12 >> 0] = 1;
  HEAP8[i11 + 13 >> 0] = 1;
  d15 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  HEAPF64[(HEAP32[i10 >> 2] | 0) + 40 >> 3] = d15;
  i11 = i13 + 32 | 0;
  __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i11 >> 2] | 0, 0);
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 + 652 >> 2] = 0;
  HEAP32[i1 + 672 >> 2] = 0;
  HEAP32[i1 + 692 >> 2] = 0;
  HEAP32[i1 + 712 >> 2] = 0;
  if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 + 480 >> 2] = 0;
  i1 = i1 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if (HEAP8[i1 + 13 >> 0] | 0) HEAP32[i1 + 8 >> 2] = 0;
  __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i13, HEAP32[i11 >> 2] | 0, i1);
  __ZN14ParticleSystem4PlayEb(i13, 0);
  i5 = i13 + 36 | 0;
  i6 = f8 == Math_fround(0.0) ? 1 : (HEAP8[(HEAP32[i5 >> 2] | 0) + 277 >> 0] | 0) == 0;
  if (i6) {
   i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   if (Math_fround(HEAPF32[i2 + 396 >> 2]) == Math_fround(0.0)) {
    i2 = i2 + 4 | 0;
    f3 = Math_fround(HEAPF32[i2 >> 2]);
    if (f3 > Math_fround(0.0)) {
     f3 = Math_fround(f3 - f8);
     HEAPF32[i2 >> 2] = f3;
     HEAPF32[i7 >> 2] = Math_fround(-f3);
     HEAPF32[i4 >> 2] = Math_fround(0.0);
     i1 = f3 > Math_fround(-0.0);
     i1 = HEAP32[(i1 ? i4 : i7) >> 2] | 0;
     HEAPF32[i7 >> 2] = Math_fround(0.0);
     i4 = f3 < Math_fround(0.0);
     HEAP32[i2 >> 2] = HEAP32[(i4 ? i7 : i2) >> 2];
    }
   }
  } else i1 = 0;
  i4 = __ZN14ParticleSystem29ComputePrewarmStartParametersERff(i13, i7, (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i4) {
   if (!(HEAP8[i2 + 25 >> 0] | 0)) i1 = i9; else i1 = (HEAP8[i2 + 26 >> 0] | 0) == 0 ? i9 | 2 : i9;
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i13, HEAP32[i5 >> 2] | 0, i2, f3, i1);
   __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i13, HEAP32[i11 >> 2] | 0, f3, i1, 0);
   __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i13, HEAP32[i5 >> 2] | 0, HEAP32[i10 >> 2] | 0, i1);
   if (!i6) {
    __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i13, HEAP32[i5 >> 2] | 0, HEAP32[i10 >> 2] | 0, f8, i9);
    __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i13, HEAP32[i11 >> 2] | 0, f8, i9, 0);
    __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i13, HEAP32[i5 >> 2] | 0, HEAP32[i10 >> 2] | 0, i9);
   }
   i11 = HEAP32[i10 >> 2] | 0;
   HEAP32[i11 + 8 >> 2] = 2;
   HEAP8[i11 + 12 >> 0] = 0;
   __ZN14ParticleSystem17RemoveFromManagerEv(i13);
  } else {
   HEAP8[i2 + 12 >> 0] = 1;
   HEAP8[i2 + 13 >> 0] = 1;
   d15 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
   HEAPF64[(HEAP32[i10 >> 2] | 0) + 40 >> 3] = d15;
   __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i11 >> 2] | 0, 0);
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i1 + 652 >> 2] = 0;
   HEAP32[i1 + 672 >> 2] = 0;
   HEAP32[i1 + 692 >> 2] = 0;
   HEAP32[i1 + 712 >> 2] = 0;
   if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + 480 >> 2] = 0;
   i1 = i1 + 32 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if (HEAP8[i1 + 13 >> 0] | 0) HEAP32[i1 + 8 >> 2] = 0;
   __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i13, HEAP32[i11 >> 2] | 0, i1);
  }
 }
 if (!i12) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i14;
 return;
}

function __ZN8Gradient19InitializeOptimizedER17OptimizedGradient(i13, i16) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, f23 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 16 | 0;
 i15 = i17;
 i12 = HEAP16[i13 + 64 >> 1] | 0;
 i4 = i12 & 255;
 i2 = (i12 & 65535) >>> 8;
 if ((i12 & 255) << 24 >> 24) {
  i1 = 0;
  do {
   f19 = Math_fround(HEAPU16[i13 + 32 + (i1 << 1) >> 1] | 0);
   f18 = Math_fround(HEAPU16[i13 + 32 + ((i1 | 1) << 1) >> 1] | 0);
   f5 = Math_fround(HEAPU16[i13 + 32 + ((i1 | 2) << 1) >> 1] | 0);
   f18 = Math_fround(f18 * Math_fround(.0000152590219));
   f5 = Math_fround(f5 * Math_fround(.0000152590219));
   f10 = Math_fround(Math_fround(HEAPU16[i13 + 32 + ((i1 | 3) << 1) >> 1] | 0) * Math_fround(.0000152590219));
   i12 = i16 + 64 + (i1 << 2) | 0;
   HEAPF32[i12 >> 2] = Math_fround(f19 * Math_fround(.0000152590219));
   HEAPF32[i12 + 4 >> 2] = f18;
   HEAPF32[i12 + 8 >> 2] = f5;
   HEAPF32[i12 + 12 >> 2] = f10;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 i3 = i2 & 65535;
 if (i2 << 16 >> 16) {
  i1 = i4;
  i2 = 0;
  while (1) {
   HEAPF32[i16 + 64 + (i1 << 2) >> 2] = Math_fround(Math_fround(HEAPU16[i13 + 48 + (i2 << 1) >> 1] | 0) / Math_fround(65535.0));
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i3 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 i1 = i4 + i3 | 0;
 i2 = i1 + -1 | 0;
 if (i1 >>> 0 > 1) {
  i6 = 0;
  do {
   i2 = i6;
   i6 = i6 + 1 | 0;
   L12 : do if ((i6 | 0) < (i1 | 0)) {
    i4 = i16 + 64 + (i2 << 2) | 0;
    i2 = i6;
    do {
     f10 = Math_fround(HEAPF32[i4 >> 2]);
     while (1) {
      i3 = i16 + 64 + (i2 << 2) | 0;
      f5 = Math_fround(HEAPF32[i3 >> 2]);
      if (f10 == f5) break;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i1 | 0)) break L12;
     }
     i1 = i1 + -1 | 0;
     i12 = i16 + 64 + (i1 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
     HEAPF32[i12 >> 2] = f5;
    } while ((i2 | 0) < (i1 | 0));
   } while (0);
   i2 = i1 + -1 | 0;
  } while ((i6 | 0) < (i2 | 0));
 }
 i12 = i13 + 68 | 0;
 if ((HEAP32[i12 >> 2] | 0) == 1 & (i1 | 0) > 0) {
  i3 = 0;
  do {
   i6 = i16 + 64 + (i3 << 2) | 0;
   f5 = Math_fround(HEAPF32[i6 >> 2]);
   i8 = i6 + 4 | 0;
   f10 = Math_fround(HEAPF32[i8 >> 2]);
   i9 = i6 + 8 | 0;
   f18 = Math_fround(HEAPF32[i9 >> 2]);
   i11 = i6 + 12 | 0;
   f10 = Math_fround(f10 + Math_fround(-.0000152590219));
   f18 = Math_fround(f18 + Math_fround(-.0000152590219));
   f19 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(-.0000152590219));
   HEAPF32[i6 >> 2] = Math_fround(f5 + Math_fround(-.0000152590219));
   HEAPF32[i8 >> 2] = f10;
   HEAPF32[i9 >> 2] = f18;
   HEAPF32[i11 >> 2] = f19;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 if ((i1 | 0) > 1) {
  i3 = 0;
  i4 = 1;
  while (1) {
   i6 = i16 + 64 + (i3 << 2) | 0;
   f10 = Math_fround(HEAPF32[i6 >> 2]);
   i4 = i16 + 64 + (i4 << 2) | 0;
   f5 = Math_fround(HEAPF32[i4 >> 2]);
   if (f10 > f5) {
    HEAPF32[i6 >> 2] = f5;
    HEAPF32[i4 >> 2] = f10;
    i3 = (i3 | 0) > 0 ? i3 + -2 | 0 : i3;
   }
   i4 = i3 + 2 | 0;
   if ((i4 | 0) >= (i1 | 0)) break; else i3 = i3 + 1 | 0;
  }
  if ((i1 | 0) < 16) i7 = 20; else {
   HEAPF32[i16 + 64 + (i2 << 2) >> 2] = Math_fround(1.0);
   i11 = i1;
  }
 } else i7 = 20;
 if ((i7 | 0) == 20) {
  HEAPF32[i16 + 64 + (i1 << 2) >> 2] = Math_fround(1.0);
  i11 = i1 + 1 | 0;
 }
 if (i11 & 3 | 0) {
  i1 = i11;
  do {
   HEAPF32[i16 + 64 + (i1 << 2) >> 2] = Math_fround(1.0);
   i1 = i1 + 1 | 0;
  } while ((i1 & 3 | 0) != 0);
 }
 if ((i11 | 0) <= 0) {
  HEAP32[i16 + 192 >> 2] = i11;
  STACKTOP = i17;
  return;
 }
 i6 = i14 + 4 | 0;
 i7 = i14 + 8 | 0;
 i8 = i14 + 12 | 0;
 i2 = i15 + 4 | 0;
 i3 = i15 + 8 | 0;
 i4 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = i16 + 64 + (i1 << 2) | 0;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  i20 = HEAP32[i22 + 8 >> 2] | 0;
  i9 = HEAP32[i22 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i6 >> 2] = i21;
  HEAP32[i7 >> 2] = i20;
  HEAP32[i8 >> 2] = i9;
  i9 = i16 + (i1 << 2) | 0;
  if (!(HEAP32[i12 >> 2] | 0)) __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i15, i13, i14); else __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i15, i13, i14);
  i20 = HEAP32[i2 >> 2] | 0;
  i21 = HEAP32[i3 >> 2] | 0;
  i22 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i9 + 4 >> 2] = i20;
  HEAP32[i9 + 8 >> 2] = i21;
  HEAP32[i9 + 12 >> 2] = i22;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i11 | 0));
 HEAP32[i16 + 192 >> 2] = i11;
 if ((i11 | 0) > 1) i1 = 1; else {
  STACKTOP = i17;
  return;
 }
 do {
  i22 = i16 + 128 + (i1 << 2) | 0;
  i21 = i16 + 64 + (i1 << 2) | 0;
  f5 = Math_fround(HEAPF32[i21 >> 2]);
  f18 = Math_fround(HEAPF32[i21 + 4 >> 2]);
  f19 = Math_fround(HEAPF32[i21 + 8 >> 2]);
  f23 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  f10 = Math_fround(Math_fround(1.0) / Math_fround(f18 - f5));
  f18 = Math_fround(Math_fround(1.0) / Math_fround(f19 - f18));
  f19 = Math_fround(Math_fround(1.0) / Math_fround(f23 - f19));
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(f5 - Math_fround(HEAPF32[i16 + 64 + (i1 + -1 << 2) >> 2])));
  HEAPF32[i22 + 4 >> 2] = f10;
  HEAPF32[i22 + 8 >> 2] = f18;
  HEAPF32[i22 + 12 >> 2] = f19;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i11 | 0));
 STACKTOP = i17;
 return;
}

function __ZN5Unity14CharacterJoint16CheckConsistencyEv(i13) {
 i13 = i13 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 __ZN5Unity5Joint16CheckConsistencyEv(i13);
 i4 = i13 + 116 | 0;
 i12 = i13 + 128 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i13 + 120 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i13 + 124 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 i10 = i13 + 132 | 0;
 i11 = i13 + 136 | 0;
 i9 = f1 < Math_fround(-177.0);
 i14 = f1 > Math_fround(177.0);
 f1 = i14 ? Math_fround(177.0) : f1;
 i14 = i9 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f5 < Math_fround(-177.0);
 i15 = f5 > Math_fround(177.0);
 f8 = i15 ? Math_fround(177.0) : f5;
 f8 = i9 ? Math_fround(-177.0) : f8;
 i9 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = f8 < (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i14 = i15 ? i9 : i14;
 i15 = f7 < Math_fround(0.0);
 i16 = f7 > Math_fround(340282326000000008404918.0e15);
 f1 = i16 ? Math_fround(340282326000000008404918.0e15) : f7;
 f1 = i15 ? Math_fround(0.0) : f1;
 i15 = f6 < Math_fround(0.0);
 i16 = f6 > Math_fround(1.0);
 f5 = i16 ? Math_fround(1.0) : f6;
 f5 = i15 ? Math_fround(0.0) : f5;
 HEAP32[i4 >> 2] = i14;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = f1;
 f1 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 i14 = f1 < Math_fround(-177.0);
 i4 = f1 > Math_fround(177.0);
 f1 = i4 ? Math_fround(177.0) : f1;
 i2 = i14 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = f8 < (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = f6 < Math_fround(0.0);
 i16 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i16 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i4 ? Math_fround(0.0) : f6;
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(1.0);
 f5 = i16 ? Math_fround(1.0) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 HEAP32[i12 >> 2] = i3 ? i2 : i9;
 HEAPF32[i10 >> 2] = f5;
 HEAPF32[i11 >> 2] = f6;
 i2 = i13 + 152 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0);
 f6 = i4 ? Math_fround(1.0) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 156 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i16 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = i13 + 148 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(0.0); else {
  i16 = f1 < Math_fround(3.0);
  i15 = f1 > Math_fround(177.0);
  f1 = i15 ? Math_fround(177.0) : f1;
  f1 = i16 ? Math_fround(3.0) : f1;
 }
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i3 >> 2] = f5;
 i2 = i13 + 164 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0);
 f6 = i4 ? Math_fround(1.0) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i13 + 168 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i16 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i16 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = i13 + 160 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(0.0); else {
  i16 = f1 < Math_fround(3.0);
  i15 = f1 > Math_fround(177.0);
  f1 = i15 ? Math_fround(177.0) : f1;
  f1 = i16 ? Math_fround(3.0) : f1;
 }
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i3 >> 2] = f5;
 i4 = i13 + 108 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i13 + 112 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i16 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i16;
 i4 = i13 + 140 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i13 + 144 | 0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i15 ? Math_fround(340282326000000008404918.0e15) : f1;
 i16 = i16 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i16;
 i16 = i13 + 176 | 0;
 f8 = Math_fround(HEAPF32[i16 >> 2]);
 i15 = f8 < Math_fround(0.0);
 i14 = f8 > Math_fround(340282326000000008404918.0e15);
 f8 = i14 ? Math_fround(340282326000000008404918.0e15) : f8;
 HEAPF32[i16 >> 2] = i15 ? Math_fround(0.0) : f8;
 i16 = i13 + 180 | 0;
 f8 = Math_fround(HEAPF32[i16 >> 2]);
 i15 = f8 < Math_fround(0.0);
 i14 = f8 > Math_fround(180.0);
 f8 = i14 ? Math_fround(180.0) : f8;
 HEAPF32[i16 >> 2] = i15 ? Math_fround(0.0) : f8;
 return;
}

function __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf(i1, i56, i57, i58) {
 i1 = i1 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 i58 = i58 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, f63 = f0;
 i62 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i60 = i62 + 16 | 0;
 i61 = i62 + 4 | 0;
 i59 = i62;
 HEAP32[i60 >> 2] = 0;
 HEAP32[i60 + 4 >> 2] = 0;
 i15 = i60 + 8 | 0;
 HEAP32[i15 >> 2] = -1;
 i26 = i60 + 12 | 0;
 HEAP16[i26 >> 1] = 0;
 i53 = i60 + 16 | 0;
 i47 = i60 + 40 | 0;
 HEAP32[i53 >> 2] = 0;
 HEAP32[i53 + 4 >> 2] = 0;
 HEAP32[i53 + 8 >> 2] = 0;
 HEAP32[i53 + 12 >> 2] = 0;
 HEAP32[i53 + 16 >> 2] = 0;
 HEAP32[i53 + 20 >> 2] = 0;
 HEAPF32[i47 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i53 = i60 + 44 | 0;
 HEAPF32[i53 >> 2] = Math_fround(0.0);
 HEAPF32[i60 + 48 >> 2] = Math_fround(0.0);
 if (!i56) {
  i61 = 1;
  STACKTOP = i62;
  return i61 | 0;
 }
 i54 = i1 + 16 | 0;
 i55 = i1 + 20 | 0;
 i16 = i1 + 24 | 0;
 i17 = i61 + 4 | 0;
 i18 = i61 + 8 | 0;
 i19 = i1 + 32 | 0;
 i20 = i1 + 64 | 0;
 i21 = i1 + 181 | 0;
 i22 = i1 + 12 | 0;
 i23 = i1 + 108 | 0;
 i24 = i1 + 68 | 0;
 i25 = i1 + 80 | 0;
 i27 = i1 + 84 | 0;
 i28 = i60 + 16 | 0;
 i29 = i60 + 20 | 0;
 i30 = i1 + 88 | 0;
 i31 = i60 + 24 | 0;
 i32 = i1 + 92 | 0;
 i33 = i1 + 96 | 0;
 i34 = i60 + 28 | 0;
 i35 = i60 + 32 | 0;
 i36 = i1 + 100 | 0;
 i37 = i60 + 36 | 0;
 i38 = i1 + 104 | 0;
 i39 = i1 + 112 | 0;
 i40 = i1 + 132 | 0;
 i41 = i1 + 136 | 0;
 i42 = i1 + 140 | 0;
 i43 = i1 + 144 | 0;
 i44 = i1 + 148 | 0;
 i45 = i1 + 152 | 0;
 i46 = i1 + 156 | 0;
 i48 = i1 + 160 | 0;
 i49 = i1 + 164 | 0;
 i50 = i1 + 168 | 0;
 i51 = i1 + 172 | 0;
 i52 = i1 + 176 | 0;
 i10 = i1 + 180 | 0;
 i14 = 0;
 L4 : while (1) {
  i12 = HEAP32[i57 + (i14 << 2) >> 2] | 0;
  i11 = (i12 >>> 1 & 15) + 1 | 0;
  i12 = i12 >>> 5;
  i13 = 0;
  do {
   i9 = i13 + i12 | 0;
   i1 = HEAP32[HEAP32[i55 >> 2] >> 2] | 0;
   if (!(HEAP32[i54 >> 2] | 0)) {
    i8 = i1 + (i9 * 12 | 0) | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i6 = HEAP32[i8 + 4 >> 2] | 0;
    i8 = HEAP32[i8 + 8 >> 2] | 0;
   } else {
    i8 = i1 + (i9 * 6 | 0) | 0;
    i4 = HEAPU16[i8 >> 1] | 0;
    i6 = HEAPU16[i8 + 2 >> 1] | 0;
    i8 = HEAPU16[i8 + 4 >> 1] | 0;
   }
   i1 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i2 = i1 + (i4 * 12 | 0) | 0;
   i5 = i1 + (i6 * 12 | 0) | 0;
   i7 = i1 + (i8 * 12 | 0) | 0;
   HEAP32[i61 >> 2] = i4;
   HEAP32[i17 >> 2] = i6;
   HEAP32[i18 >> 2] = i8;
   if (__ZNK19SimpleRayTriOverlap7overlapERKN5physx6PxVec3ES3_S3_RNS0_12PxRaycastHitE(i19, i2, i5, i7, i60) | 0) {
    f3 = Math_fround(HEAPF32[i47 >> 2]);
    if (f3 <= Math_fround(HEAPF32[i20 >> 2])) {
     HEAP32[i15 >> 2] = i9;
     HEAP16[i26 >> 1] = 5;
     if (!(HEAP8[i21 >> 0] | 0)) {
      HEAP32[i59 >> 2] = HEAP32[i58 >> 2];
      i9 = HEAP32[i22 >> 2] | 0;
      if (!(mftCall_iiiiiiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i60 | 0, i2 | 0, i5 | 0, i7 | 0, i59 | 0, i61 | 0) | 0)) {
       i1 = 0;
       i2 = 18;
       break L4;
      }
      f3 = Math_fround(HEAPF32[i59 >> 2]);
      if (f3 < Math_fround(HEAPF32[i58 >> 2])) {
       HEAPF32[i58 >> 2] = f3;
       HEAPF32[i20 >> 2] = f3;
      }
     } else if (f3 < Math_fround(HEAPF32[i23 >> 2])) {
      HEAP32[i24 >> 2] = HEAP32[i60 >> 2];
      HEAP32[i24 + 4 >> 2] = HEAP32[i60 + 4 >> 2];
      HEAP32[i24 + 8 >> 2] = HEAP32[i60 + 8 >> 2];
      HEAP16[i25 >> 1] = 5;
      HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
      HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
      HEAP32[i32 >> 2] = HEAP32[i31 >> 2];
      HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
      HEAP32[i36 >> 2] = HEAP32[i35 >> 2];
      HEAP32[i38 >> 2] = HEAP32[i37 >> 2];
      HEAPF32[i23 >> 2] = f3;
      HEAP32[i39 >> 2] = HEAP32[i53 >> 2];
      HEAP32[i39 + 4 >> 2] = HEAP32[i53 + 4 >> 2];
      HEAP32[i39 + 8 >> 2] = HEAP32[i53 + 8 >> 2];
      HEAP32[i39 + 12 >> 2] = HEAP32[i53 + 12 >> 2];
      HEAP32[i39 + 16 >> 2] = HEAP32[i53 + 16 >> 2];
      f63 = Math_fround(HEAPF32[i58 >> 2]);
      HEAPF32[i58 >> 2] = f3 < f63 ? f3 : f63;
      HEAP32[i40 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i41 >> 2] = HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2];
      HEAP32[i42 >> 2] = HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2];
      HEAP32[i43 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i44 >> 2] = HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2];
      HEAP32[i45 >> 2] = HEAP32[i1 + (i6 * 12 | 0) + 8 >> 2];
      HEAP32[i46 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i48 >> 2] = HEAP32[i1 + (i8 * 12 | 0) + 4 >> 2];
      HEAP32[i49 >> 2] = HEAP32[i1 + (i8 * 12 | 0) + 8 >> 2];
      HEAP32[i50 >> 2] = HEAP32[i61 >> 2];
      HEAP32[i51 >> 2] = HEAP32[i17 >> 2];
      HEAP32[i52 >> 2] = HEAP32[i18 >> 2];
      HEAP8[i10 >> 0] = 1;
     }
     if (!(HEAP32[(HEAP32[i22 >> 2] | 0) + 4 >> 2] | 0)) {
      i1 = 0;
      i2 = 18;
      break L4;
     }
    }
   }
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < i11 >>> 0);
  i14 = i14 + 1 | 0;
  if (i14 >>> 0 >= i56 >>> 0) {
   i1 = 1;
   i2 = 18;
   break;
  }
 }
 if ((i2 | 0) == 18) {
  STACKTOP = i62;
  return i1 | 0;
 }
 return 0;
}

function __ZN5audio5mixer13GroupConstant8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863520 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863540 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863552 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 12 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863563 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 13 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863568 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 14 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863573 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i20, i1, i15) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 24 | 0;
 i19 = i22 + 16 | 0;
 i16 = i22 + 12 | 0;
 i17 = i22 + 8 | 0;
 i10 = i22 + 4 | 0;
 i11 = i22;
 i9 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i7 = i13 - i9 | 0;
 i18 = (i7 | 0) / 36 | 0;
 i8 = i20 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i9;
 i5 = i2;
 if (i18 >>> 0 > ((i1 - i2 | 0) / 36 | 0) >>> 0) {
  if (i2) {
   i6 = i20 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) i1 = i2; else {
    i4 = i21 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i2 + -28 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i17 = HEAP32[i2 + -16 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i4 >> 2] = i17;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i20 >> 2] | 0;
   }
   i17 = HEAP32[i20 + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = 12;
   HEAP32[i21 + 4 >> 2] = i17;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   i1 = 0;
  }
  if ((i7 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i20);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i20 >> 2] | 0;
  } else i2 = 0;
  i17 = (i1 - i2 | 0) / 36 | 0;
  i1 = i17 << 1;
  i1 = i17 >>> 0 < 1073741823 ? (i1 >>> 0 < i18 >>> 0 ? i18 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i20);
  i17 = HEAP32[i20 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 12;
  HEAP32[i21 + 4 >> 2] = i17;
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i20 + 4 >> 2] = i17;
  HEAP32[i20 >> 2] = i17;
  HEAP32[i8 >> 2] = i17 + (i1 * 36 | 0);
  HEAP32[i10 >> 2] = i9;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i20, i19, i21, i18);
  STACKTOP = i22;
  return;
 }
 i14 = i20 + 4 | 0;
 i11 = ((HEAP32[i14 >> 2] | 0) - i2 | 0) / 36 | 0;
 i12 = i18 >>> 0 > i11 >>> 0;
 i11 = i12 ? i3 + (i11 * 36 | 0) | 0 : i13;
 i10 = i11;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i5;
  i9 = i3;
  do {
   i13 = i9;
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   i6 = i1;
   HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i6 + 4 >> 2] = i2;
   i6 = i1 + 8 | 0;
   i2 = i9 + 8 | 0;
   do if ((i1 | 0) != (i9 | 0)) {
    i8 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i8 = i4 ? HEAP32[i9 + 12 >> 2] | 0 : i8 & 255;
    i4 = i6 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 16 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i8 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 12 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
     break;
    }
    if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
    if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
    HEAP8[i2 + i8 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 12 >> 2] = i8;
     break;
    } else {
     HEAP8[i4 >> 0] = i8;
     break;
    }
   } while (0);
   i13 = i1 + 24 | 0;
   i8 = i9 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP8[i13 + 8 >> 0] = HEAP8[i8 + 8 >> 0] | 0;
   i9 = i9 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i9 | 0) != (i10 | 0));
  i5 = i1;
 }
 if (i12) {
  HEAP32[i16 >> 2] = i11;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  i18 = i18 - (((HEAP32[i14 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) / 36 | 0) | 0;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i20, i19, i21, i18);
  STACKTOP = i22;
  return;
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i22;
  return;
 }
 i4 = i21 + 4 | 0;
 do {
  i2 = i1 + -36 | 0;
  HEAP32[i14 >> 2] = i2;
  i3 = i1 + -28 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i20 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i1 + -16 >> 2] | 0;
   HEAP32[i21 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
   i1 = HEAP32[i14 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i22;
 return;
}

function __ZNK22ParticleSystemRenderer20PrepareForMeshRenderER26ParticleSystemTempMeshDataR14ParticleSystem(i8, i22, i12) {
 i8 = i8 | 0;
 i22 = i22 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23;
 i10 = i23 + 40 | 0;
 i11 = i23 + 24 | 0;
 i19 = i23 + 8 | 0;
 i1 = 0;
 i3 = 0;
 do {
  i2 = HEAP32[i8 + 408 + (i3 << 2) >> 2] | 0;
  if (!i2) break;
  i18 = (HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 92 >> 2] | 0) != 0;
  i1 = (i18 & 1) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while (i18 & (i3 | 0) < 4);
 HEAP16[i22 >> 1] = i1;
 i7 = i22 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = (i1 | 0) > 0;
 if (i3) {
  i2 = 0;
  do {
   HEAP32[i10 + (i2 << 2) >> 2] = HEAP32[i8 + 472 + (i2 * 20 | 0) >> 2];
   HEAP32[i11 + (i2 << 2) >> 2] = HEAP32[i8 + 472 + (i2 * 20 | 0) + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  if (i3) {
   i5 = 0;
   do {
    i6 = __ZN4Mesh21AcquireSharedMeshDataEv(HEAP32[i8 + 408 + (i5 << 2) >> 2] | 0) | 0;
    i2 = i10 + (i5 << 2) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i18 = HEAP32[i6 + 112 >> 2] | 0;
     HEAP32[i2 >> 2] = i18;
     i4 = ((HEAP32[i6 + 116 >> 2] | 0) - i18 | 0) >>> 1;
     HEAP32[i11 + (i5 << 2) >> 2] = i4;
     i2 = i18;
    } else {
     i4 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
     i2 = i3;
    }
    HEAP32[i22 + 104 + (i5 * 12 | 0) + 8 >> 2] = i6;
    HEAP32[i22 + 104 + (i5 * 12 | 0) >> 2] = i4;
    HEAP32[i22 + 104 + (i5 * 12 | 0) + 4 >> 2] = i2;
    i17 = HEAP32[i6 + 100 >> 2] | 0;
    i18 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = (i18 | 0) < (i17 | 0) ? i17 : i18;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i1 | 0));
  }
 }
 i17 = i22 + 2 | 0;
 HEAP16[i17 >> 1] = 0;
 i2 = HEAP32[i12 + 32 >> 2] | 0;
 i18 = HEAP32[i2 + 12 >> 2] | 0;
 L16 : do if ((i1 | 0) == 1) {
  i7 = HEAP32[(HEAP32[i22 + 112 >> 2] | 0) + 100 >> 2] | 0;
  i8 = HEAP32[i22 + 104 >> 2] | 0;
  if (!i18) {
   i4 = 0;
   i3 = 0;
   i2 = 0;
   i1 = 0;
   i21 = 29;
  } else {
   i6 = 0;
   i2 = 0;
   i4 = 0;
   i5 = 0;
   i1 = 0;
   while (1) {
    i3 = i5 + i7 | 0;
    if ((i3 | 0) >= (i2 + 65535 | 0)) {
     i15 = i1 & 65535;
     HEAP32[i22 + 8 + (i15 << 2) >> 2] = i6;
     HEAP32[i22 + 40 + (i15 << 2) >> 2] = i5;
     HEAP32[i22 + 72 + (i15 << 2) >> 2] = i4;
     i1 = i1 + 1 << 16 >> 16;
     HEAP16[i17 >> 1] = i1;
     if (i1 << 16 >> 16 == 8) break L16; else i2 = i5;
    }
    i4 = i4 + i8 | 0;
    i6 = i6 + 1 | 0;
    if (i6 >>> 0 >= i18 >>> 0) {
     i2 = i1;
     i21 = 28;
     break;
    } else i5 = i3;
   }
  }
 } else {
  i1 = HEAP32[i22 >> 2] | 0;
  i15 = i1 & 65535;
  f16 = Math_fround(Math_fround(1.0) / Math_fround(i15 & 65535));
  i5 = i1 >>> 16 & 65535;
  if (!i18) {
   i4 = 0;
   i3 = 0;
   i2 = i5;
   i1 = i5;
   i21 = 28;
  } else {
   i14 = HEAP32[i2 + 500 >> 2] | 0;
   i13 = i1 & 65535;
   i12 = 0;
   i4 = 0;
   i11 = 0;
   i6 = 0;
   i2 = i5;
   i3 = i15;
   i10 = i5;
   i1 = i5;
   while (1) {
    i7 = (HEAP32[i14 + (i12 << 2) >> 2] | 0) + -1135456673 | 0;
    i8 = (Math_imul(i7, 1790253981) | 0) + 1900727103 | 0;
    i7 = i7 << 11 ^ i7;
    f9 = Math_fround(Math_fround(((i8 ^ i7 ^ i7 >>> 8) & 8388607 ^ i8 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    L27 : do if (!(i3 << 16 >> 16)) {
     i7 = 0;
     i3 = 0;
     i8 = 0;
    } else {
     i5 = 0;
     while (1) {
      i3 = i5 + 1 | 0;
      if (f9 >= Math_fround(f16 * Math_fround(i5 | 0))) if (f9 <= Math_fround(f16 * Math_fround(i3 | 0))) break;
      if ((i3 | 0) < (i13 | 0)) i5 = i3; else {
       i7 = 0;
       i3 = 0;
       i8 = i15;
       break L27;
      }
     }
     i7 = HEAP32[i22 + 104 + (i5 * 12 | 0) >> 2] | 0;
     i3 = HEAP32[(HEAP32[i22 + 104 + (i5 * 12 | 0) + 8 >> 2] | 0) + 100 >> 2] | 0;
     i8 = i15;
    } while (0);
    i3 = i3 + i11 | 0;
    if ((i3 | 0) < (i6 + 65535 | 0)) i5 = i10; else {
     i5 = i10 & 65535;
     HEAP32[i22 + 8 + (i5 << 2) >> 2] = i12;
     HEAP32[i22 + 40 + (i5 << 2) >> 2] = i11;
     HEAP32[i22 + 72 + (i5 << 2) >> 2] = i4;
     i5 = i10 + 1 << 16 >> 16;
     HEAP16[i17 >> 1] = i5;
     if (i5 << 16 >> 16 == 8) break L16; else {
      i6 = i11;
      i2 = i5;
      i1 = i5;
     }
    }
    i4 = i7 + i4 | 0;
    i12 = i12 + 1 | 0;
    if (i12 >>> 0 >= i18 >>> 0) {
     i21 = 28;
     break;
    } else {
     i11 = i3;
     i3 = i8;
     i10 = i5;
    }
   }
  }
 } while (0);
 if ((i21 | 0) == 28) if ((i2 & 65535) < 8) i21 = 29;
 if ((i21 | 0) == 29) {
  HEAP32[i22 + 8 + ((i2 & 65535) << 2) >> 2] = i18;
  i21 = i1 & 65535;
  HEAP32[i22 + 40 + (i21 << 2) >> 2] = i3;
  HEAP32[i22 + 72 + (i21 << 2) >> 2] = i4;
  HEAP16[i17 >> 1] = i1 + 1 << 16 >> 16;
  STACKTOP = i23;
  return;
 }
 i21 = HEAP16[i22 >> 1] | 0;
 i2 = i21 & 65535;
 if (!(i21 << 16 >> 16)) i1 = 0; else i1 = Math_imul(HEAP32[(HEAP32[i22 + 112 >> 2] | 0) + 100 >> 2] | 0, i2 >>> 0 > 1 ? i2 : 1) | 0;
 i22 = ((Math_imul(i1, i18) | 0) >>> 0) / (i2 >>> 0) | 0;
 HEAP32[i20 >> 2] = i22 >>> 0 < 524281 ? 524281 : i22;
 HEAP32[i20 + 4 >> 2] = 524280;
 __Z6FormatPKcz(i19, gb + 621958 | 0, i20);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 622060 | 0, 506, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 STACKTOP = i23;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i20, i18) {
 i20 = i20 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23 + 40 | 0;
 i19 = i23 + 24 | 0;
 i17 = i23;
 i11 = i23 + 20 | 0;
 i12 = i23 + 16 | 0;
 i21 = i20 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i2 = ((HEAP32[i21 >> 2] | 0) - i1 | 0) / 72 | 0;
 i4 = i1;
 if (i2 >>> 0 >= i18 >>> 0) {
  if (i2 >>> 0 <= i18 >>> 0) {
   STACKTOP = i23;
   return;
  }
  i7 = i4 + (i18 * 72 | 0) | 0;
  i1 = HEAP32[i20 + 12 >> 2] | 0;
  HEAP32[i19 >> 2] = 0;
  i8 = i19 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  i11 = i19 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i18 * 72 | 0;
  i3 = (i2 | 0) / 72 | 0;
  if (!i2) {
   i3 = i19 + 8 | 0;
   i4 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i19 >> 2] = i2;
   i1 = i2 + (i3 * 72 | 0) | 0;
   i3 = i19 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i6 = i2;
   if (!i18) {
    i4 = i6;
    i2 = i6;
   } else {
    i5 = i2;
    while (1) {
     i9 = i4;
     i10 = i5 + 72 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
      i5 = i5 + 4 | 0;
      i9 = i9 + 4 | 0;
     } while ((i5 | 0) < (i10 | 0));
     i4 = i4 + 72 | 0;
     i2 = i2 + 72 | 0;
     if ((i4 | 0) == (i7 | 0)) break; else i5 = i2;
    }
    HEAP32[i8 >> 2] = i2;
    i4 = i6;
   }
  }
  i18 = HEAP32[i20 >> 2] | 0;
  HEAP32[i19 >> 2] = i18;
  HEAP32[i20 >> 2] = i4;
  i17 = HEAP32[i21 >> 2] | 0;
  HEAP32[i8 >> 2] = i17;
  HEAP32[i21 >> 2] = i2;
  i2 = i20 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i18;
  i2 = i17;
  if (i18 | 0) {
   if ((i2 | 0) != (i1 | 0)) {
    do {
     HEAP32[i8 >> 2] = i2 + -72;
     i2 = HEAP32[i8 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i19 >> 2] | 0;
   }
   i21 = HEAP32[i11 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i21;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
  }
  STACKTOP = i23;
  return;
 }
 i14 = i20 + 8 | 0;
 if ((((HEAP32[i14 >> 2] | 0) - i1 | 0) / 72 | 0 | 0) == (i18 | 0)) {
  __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i20, i18 - i2 | 0);
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i20 + 12 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 i15 = i17 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i16 = i17 + 12 | 0;
 HEAP32[i16 >> 2] = i1;
 i13 = i17 + 8 | 0;
 if (i18 | 0) {
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 4 >> 2] = i1;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18 * 72 | 0, 16, i22, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i7 = i4;
  i8 = i4 + (i18 * 72 | 0) | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i3 = i1;
   i2 = i7;
  } else {
   i6 = i1;
   i2 = i7;
   do {
    i6 = i6 + -72 | 0;
    i5 = i4 + -72 | 0;
    i9 = i6;
    i10 = i5 + 72 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
     i5 = i5 + 4 | 0;
     i9 = i9 + 4 | 0;
    } while ((i5 | 0) < (i10 | 0));
    i4 = i2 + -72 | 0;
    i2 = i4;
   } while ((i6 | 0) != (i3 | 0));
  }
  HEAP32[i17 >> 2] = i2;
  HEAP32[i15 >> 2] = i7;
  HEAP32[i13 >> 2] = i8;
  if ((i1 | 0) != (i3 | 0)) do i1 = i1 + -72 | 0; while ((i1 | 0) != (i3 | 0));
  if (i3 | 0) {
   i10 = HEAP32[i16 >> 2] | 0;
   HEAP32[i22 >> 2] = 1;
   HEAP32[i22 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i22);
  }
 }
 HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i12 >> 2];
 __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i17, i19, i22);
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = (i1 - i3 | 0) / 72 | 0;
 i4 = i1;
 if (i2 >>> 0 < i18 >>> 0) {
  __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i17, i18 - i2 | 0);
  i1 = HEAP32[i15 >> 2] | 0;
 } else if (i2 >>> 0 > i18 >>> 0) {
  i2 = i3 + (i18 * 72 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i15 >> 2] = i1 + -72;
    i1 = HEAP32[i15 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i19 = HEAP32[i20 >> 2] | 0;
 HEAP32[i17 >> 2] = i19;
 HEAP32[i20 >> 2] = i2;
 i2 = HEAP32[i21 >> 2] | 0;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i21 >> 2] = i1;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i1 = i19;
 if (i19 | 0) {
  if ((i2 | 0) != (i1 | 0)) {
   do {
    HEAP32[i15 >> 2] = i2 + -72;
    i2 = HEAP32[i15 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i17 >> 2] | 0;
  }
  i21 = HEAP32[i16 >> 2] | 0;
  HEAP32[i22 >> 2] = 1;
  HEAP32[i22 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
 }
 STACKTOP = i23;
 return;
}

function __ZN13ProbeRenderer10RenderQuadEP15ReflectionProbeP13RenderTextureib(i7, i8, i1, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 48 | 0;
 i3 = i6 + 32 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 if ((HEAP16[gb + 1111224 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111224 | 0, i1);
  i2 = gb + 1111224 | 0;
 } else i2 = 0;
 i11 = i7 + 28 | 0;
 __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 >> 2] | 0, gb + 28940 | 0) | 0);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i11 = f13 < Math_fround(.00999999977);
 f13 = i11 ? Math_fround(.00999999977) : f13;
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i11 = f12 < Math_fround(.00999999977);
 f12 = i11 ? Math_fround(.00999999977) : f12;
 i11 = __ZN16ReflectionProbes9GetCameraEv(__Z19GetReflectionProbesv() | 0) | 0;
 i18 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f22 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 i21 = i1 + 32 | 0;
 f15 = Math_fround(HEAPF32[i21 >> 2]);
 i20 = i1 + 36 | 0;
 f17 = Math_fround(HEAPF32[i20 >> 2]);
 i19 = i1 + 40 | 0;
 f10 = Math_fround(HEAPF32[i19 >> 2]);
 i16 = i7 + 88 | 0;
 f14 = Math_fround(HEAPF32[i16 >> 2]);
 f17 = Math_fround(f24 + Math_fround(f17 * f14));
 f10 = Math_fround(f23 + Math_fround(f10 * f14));
 HEAPF32[i3 >> 2] = Math_fround(f22 + Math_fround(f15 * f14));
 HEAPF32[i3 + 4 >> 2] = f17;
 HEAPF32[i3 + 8 >> 2] = f10;
 __ZN9Transform11SetPositionERK8Vector3f(i18, i3);
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f17 = Math_fround(HEAPF32[i20 >> 2]);
 f17 = Math_fround(-f17);
 f14 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i4 >> 2] = Math_fround(-f10);
 HEAPF32[i4 + 4 >> 2] = f17;
 HEAPF32[i4 + 8 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f17 = Math_fround(-f17);
 f10 = Math_fround(-Math_fround(HEAPF32[i1 + 24 >> 2]));
 HEAPF32[i5 >> 2] = Math_fround(-f14);
 HEAPF32[i5 + 4 >> 2] = f17;
 HEAPF32[i5 + 8 >> 2] = f10;
 __Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i4, i5, i3) | 0;
 __ZN9Transform11SetRotationERK11Quaternionf(i18, i3);
 i5 = __Z18GetQualitySettingsv() | 0;
 f10 = Math_fround(HEAPF32[(HEAP32[i5 + 28 >> 2] | 0) + ((HEAP32[i5 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2]);
 i5 = __Z18GetQualitySettingsv() | 0;
 __ZN15QualitySettings28SetShadowDistanceTemporarilyEf(i5, Math_fround(HEAPF32[i7 + 96 >> 2]));
 f17 = Math_fround(HEAPF32[i7 + 108 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 112 >> 2]);
 f15 = Math_fround(HEAPF32[i7 + 116 >> 2]);
 i5 = f17 < Math_fround(0.0);
 f17 = i5 ? Math_fround(0.0) : f17;
 i5 = f17 > Math_fround(1.0);
 i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f17) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = f14 < Math_fround(0.0);
 f14 = i1 ? Math_fround(0.0) : f14;
 i1 = f14 > Math_fround(1.0);
 i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f15 < Math_fround(0.0);
 f15 = i3 ? Math_fround(0.0) : f15;
 i3 = f15 > Math_fround(1.0);
 i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 __ZN6Camera7SetNearEf(i11, Math_fround(HEAPF32[i16 >> 2]));
 __ZN6Camera6SetFarEf(i11, Math_fround(HEAPF32[i7 + 92 >> 2]));
 __ZN6Camera13SetClearFlagsEi(i11, HEAP32[i7 + 104 >> 2] | 0);
 f15 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 f14 = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(i5 & 255) / Math_fround(255.0));
 HEAPF32[i4 + 4 >> 2] = f15;
 HEAPF32[i4 + 8 >> 2] = f14;
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i11, i4);
 __ZN6Camera14SetCullingMaskEj(i11, HEAP32[i7 + 100 >> 2] | 0);
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i11, i4);
 __ZN6Camera15SetOrthographicEb(i11, 1);
 __ZN6Camera19SetOrthographicSizeEf(i11, f12);
 __ZN6Camera9SetAspectEf(i11, Math_fround(f13 / f12));
 HEAP8[i11 + 1089 >> 0] = i9 & 1;
 __ZN6Camera16SetTargetTextureEP13RenderTexture(i11, i8);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i11, 4, 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN15QualitySettings28SetShadowDistanceTemporarilyEf(__Z18GetQualitySettingsv() | 0, f10);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN14PlayerSettingsC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 64368 + 8;
 i2 = i4 + 28 | 0;
 i1 = i4 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 112 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = i4;
 HEAP32[i4 + 228 >> 2] = 0;
 HEAP32[i4 + 232 >> 2] = 0;
 i1 = i4 + 220 | 0;
 i2 = i4 + 184 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i4 + 236 >> 2] = 0;
 HEAP32[i4 + 240 >> 2] = 0;
 HEAP32[i4 + 260 >> 2] = 0;
 HEAP32[i4 + 264 >> 2] = 0;
 HEAP32[i4 + 268 >> 2] = 0;
 i3 = i4 + 320 | 0;
 HEAP8[i3 >> 0] = 1;
 HEAP8[i3 + 1 >> 0] = 1;
 HEAP8[i3 + 2 >> 0] = 1;
 HEAP8[i3 + 3 >> 0] = 1;
 HEAP8[i3 + 4 >> 0] = 1;
 HEAP32[i4 + 340 >> 2] = 0;
 HEAP32[i4 + 352 >> 2] = 0;
 HEAP32[i4 + 356 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i4 + 344 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i4 + 456 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 468 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 472 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 484 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 488 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 500 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 524 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 536 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 540 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 552 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 556 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 568 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 572 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 584 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = i4 + 588 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 600 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i4 + 604 >> 2] = 0;
 HEAP32[i4 + 616 >> 2] = 0;
 HEAP32[i4 + 620 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4 + 608 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 STACKTOP = i6;
 return;
}

function __ZNK9ShaderLab20ShaderBlendStateDesc15ToGfxBlendStateEPK19ShaderPropertySheetS3_R13GfxBlendState(i14, i15, i17, i12) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 24 | 0;
 i18 = i21 + 16 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i4 = i14 + 456 | 0;
 i16 = i12 + 64 | 0;
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & -2 | HEAPU8[i4 >> 0];
 i4 = HEAP8[i4 >> 0] | 0 ? 8 : 1;
 i5 = i18 + 4 | 0;
 i6 = i18 + 4 | 0;
 i7 = i18 + 4 | 0;
 i8 = i18 + 4 | 0;
 i9 = i18 + 4 | 0;
 i10 = i18 + 4 | 0;
 i11 = i18 + 4 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 4 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i11 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 1 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 10 ? 10 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 12 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 8 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i10 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 2 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 10 ? 10 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 20 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 16 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i9 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 3 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 10 ? 10 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 28 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 24 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i8 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 4 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 10 ? 10 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 36 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 32 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i7 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 5 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 35 ? 35 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 44 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 40 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i6 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) + 6 >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 35 ? 35 : i1) & 255;
  i1 = HEAP32[i14 + (i3 * 56 | 0) + 52 >> 2] | 0;
  if ((i1 | 0) == -1) f2 = Math_fround(HEAPF32[i14 + (i3 * 56 | 0) + 48 >> 2]); else {
   HEAP32[i18 >> 2] = -1;
   HEAP32[i5 >> 2] = 4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
   __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
   f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  }
  i1 = ~~f2;
  HEAP8[i12 + (i3 << 3) >> 0] = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 15 ? 15 : i1) & 255;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i1 = HEAP32[i14 + 452 >> 2] | 0;
 if ((i1 | 0) == -1) {
  f2 = Math_fround(HEAPF32[i14 + 448 >> 2]);
  i19 = f2 != Math_fround(0.0);
  i19 = i19 & 1;
  i20 = HEAP32[i16 >> 2] | 0;
  i19 = i19 << 1;
  i20 = i20 & -3;
  i20 = i19 | i20;
  HEAP32[i16 >> 2] = i20;
  STACKTOP = i21;
  return;
 } else {
  HEAP32[i18 >> 2] = -1;
  HEAP32[i18 + 4 >> 2] = 4;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i20, i15, i17, i13, i18);
  f2 = Math_fround(HEAPF32[HEAP32[i20 >> 2] >> 2]);
  i19 = f2 != Math_fround(0.0);
  i19 = i19 & 1;
  i20 = HEAP32[i16 >> 2] | 0;
  i19 = i19 << 1;
  i20 = i20 & -3;
  i20 = i19 | i20;
  HEAP32[i16 >> 2] = i20;
  STACKTOP = i21;
  return;
 }
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i1, i2, i3, i4, i5, i27, i28, i29, i30) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0, i40 = 0, f41 = f0, i42 = 0, f43 = f0, i44 = 0, f45 = f0, i46 = 0, f47 = f0, i48 = 0, f49 = f0, i50 = 0, f51 = f0, i52 = 0, f53 = f0, f54 = f0, f55 = f0, f56 = f0, f57 = f0, f58 = f0, f59 = f0, f60 = f0, f61 = f0, f62 = f0, f63 = f0, f64 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i32 + 16 | 0;
 i22 = i32;
 if (i5 >>> 0 >= i27 >>> 0) {
  STACKTOP = i32;
  return;
 }
 i23 = i4 + 500 | 0;
 i24 = i22 + 4 | 0;
 i25 = i22 + 8 | 0;
 i26 = i22 + 12 | 0;
 i21 = i1 + 80 | 0;
 i20 = i2 + 80 | 0;
 i6 = i3 + 80 | 0;
 i7 = i29 + 12 | 0;
 i8 = i29 + 24 | 0;
 i9 = i29 + 4 | 0;
 i10 = i29 + 16 | 0;
 i11 = i29 + 28 | 0;
 i12 = i29 + 8 | 0;
 i13 = i29 + 20 | 0;
 i14 = i29 + 32 | 0;
 i15 = i30 + 4 | 0;
 i16 = i30 + 8 | 0;
 i17 = i30 + 12 | 0;
 i18 = i4 + 60 | 0;
 i19 = i4 + 80 | 0;
 i4 = i4 + 100 | 0;
 do {
  i33 = (HEAP32[i23 >> 2] | 0) + (i5 << 2) | 0;
  i1 = (HEAP32[i33 + 4 >> 2] | 0) + 306581307 | 0;
  i3 = (HEAP32[i33 + 8 >> 2] | 0) + 306581307 | 0;
  i2 = (HEAP32[i33 + 12 >> 2] | 0) + 306581307 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i33 >> 2] | 0) + 306581307;
  HEAP32[i24 >> 2] = i1;
  HEAP32[i25 >> 2] = i3;
  HEAP32[i26 >> 2] = i2;
  __Z17GenerateRandomNx3RKN4math5_int4E(i31, i22);
  i2 = HEAP32[i21 >> 2] | 0;
  i3 = HEAP32[i20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i28) {
   f37 = Math_fround(HEAPF32[i29 >> 2]);
   f36 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround(f36 * f37);
   f38 = Math_fround(HEAPF32[i7 >> 2]);
   f35 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f38 = Math_fround(f37 + Math_fround(f35 * f38));
   f37 = Math_fround(HEAPF32[i8 >> 2]);
   f34 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f37 = Math_fround(f38 + Math_fround(f34 * f37));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   f37 = Math_fround(f36 * Math_fround(HEAPF32[i9 >> 2]));
   f37 = Math_fround(f37 + Math_fround(f35 * Math_fround(HEAPF32[i10 >> 2])));
   f37 = Math_fround(f37 + Math_fround(f34 * Math_fround(HEAPF32[i11 >> 2])));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f37, HEAP32[tempDoublePtr >> 2] | 0);
   f36 = Math_fround(f36 * Math_fround(HEAPF32[i12 >> 2]));
   f35 = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i13 >> 2])));
   f34 = Math_fround(f35 + Math_fround(f34 * Math_fround(HEAPF32[i14 >> 2])));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
  }
  f62 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = Math_fround(HEAPF32[i30 >> 2]);
  f54 = Math_fround(f62 * f57);
  f56 = Math_fround(HEAPF32[i15 >> 2]);
  f64 = Math_fround(f62 * f56);
  f55 = Math_fround(HEAPF32[i16 >> 2]);
  f63 = Math_fround(f62 * f55);
  f38 = Math_fround(HEAPF32[i17 >> 2]);
  f62 = Math_fround(f62 * f38);
  f58 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f61 = Math_fround(f58 * f57);
  f60 = Math_fround(f58 * f56);
  f59 = Math_fround(f58 * f55);
  f58 = Math_fround(f58 * f38);
  f53 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f57 = Math_fround(f57 * f53);
  f56 = Math_fround(f53 * f56);
  f55 = Math_fround(f53 * f55);
  f38 = Math_fround(f53 * f38);
  i52 = (HEAP32[i18 >> 2] | 0) + (i5 << 2) | 0;
  f53 = Math_fround(HEAPF32[i52 >> 2]);
  i50 = i52 + 4 | 0;
  f51 = Math_fround(HEAPF32[i50 >> 2]);
  i48 = i52 + 8 | 0;
  f49 = Math_fround(HEAPF32[i48 >> 2]);
  i46 = i52 + 12 | 0;
  f47 = Math_fround(HEAPF32[i46 >> 2]);
  i44 = (HEAP32[i19 >> 2] | 0) + (i5 << 2) | 0;
  f45 = Math_fround(HEAPF32[i44 >> 2]);
  i42 = i44 + 4 | 0;
  f43 = Math_fround(HEAPF32[i42 >> 2]);
  i40 = i44 + 8 | 0;
  f41 = Math_fround(HEAPF32[i40 >> 2]);
  i39 = i44 + 12 | 0;
  f34 = Math_fround(HEAPF32[i39 >> 2]);
  i1 = (HEAP32[i4 >> 2] | 0) + (i5 << 2) | 0;
  f35 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i1 + 4 | 0;
  f36 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i1 + 8 | 0;
  f37 = Math_fround(HEAPF32[i3 >> 2]);
  i33 = i1 + 12 | 0;
  f51 = Math_fround(f64 + f51);
  f49 = Math_fround(f63 + f49);
  f47 = Math_fround(f62 + f47);
  f45 = Math_fround(f61 + f45);
  f43 = Math_fround(f60 + f43);
  f41 = Math_fround(f59 + f41);
  f34 = Math_fround(f58 + f34);
  f35 = Math_fround(f57 + f35);
  f36 = Math_fround(f56 + f36);
  f37 = Math_fround(f55 + f37);
  f38 = Math_fround(f38 + Math_fround(HEAPF32[i33 >> 2]));
  HEAPF32[i52 >> 2] = Math_fround(f54 + f53);
  HEAPF32[i50 >> 2] = f51;
  HEAPF32[i48 >> 2] = f49;
  HEAPF32[i46 >> 2] = f47;
  HEAPF32[i44 >> 2] = f45;
  HEAPF32[i42 >> 2] = f43;
  HEAPF32[i40 >> 2] = f41;
  HEAPF32[i39 >> 2] = f34;
  HEAPF32[i1 >> 2] = f35;
  HEAPF32[i2 >> 2] = f36;
  HEAPF32[i3 >> 2] = f37;
  HEAPF32[i33 >> 2] = f38;
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < i27 >>> 0);
 STACKTOP = i32;
 return;
}

function __ZN5physx2Sn14sortCollectionERNS_2Cm10CollectionERNS0_21SerializationRegistryEb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i24 + 116 | 0;
 i16 = i24 + 120 | 0;
 i15 = i24;
 i23 = i24 + 32 | 0;
 HEAP32[i23 >> 2] = gb + 140260 + 8;
 i19 = i23 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAPF32[i23 + 28 >> 2] = Math_fround(.75);
 HEAP32[i23 + 32 >> 2] = -1;
 HEAP32[i23 + 36 >> 2] = 0;
 HEAP32[i23 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i19, 64);
 i19 = i23 + 44 | 0;
 HEAP32[i19 >> 2] = 0;
 i13 = i23 + 48 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i23 + 52 | 0;
 HEAP32[i14 >> 2] = 0;
 i22 = i23 + 56 | 0;
 HEAP32[i22 >> 2] = i3;
 i17 = i23 + 60 | 0;
 HEAP32[i17 >> 2] = i1;
 i20 = i23 + 64 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i23 + 68 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i23 + 72 >> 2] = 0;
 HEAP8[i23 + 80 >> 0] = i2 & 1;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP8[i11 + 20 >> 0] = 0;
 i18 = HEAP32[i3 + 80 >> 2] | 0;
 i7 = HEAP32[i3 + 48 >> 2] | 0;
 if (i18 | 0) {
  i8 = i23 + 44 | 0;
  i9 = i23 + 4 | 0;
  i10 = i15 + 16 | 0;
  i3 = 0;
  i1 = 0;
  while (1) {
   i4 = HEAP32[i7 + (i1 << 4) >> 2] | 0;
   HEAP32[i15 >> 2] = i4;
   i6 = i7 + (i1 << 4) + 8 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i11;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i6;
   HEAP32[i12 >> 2] = i4;
   i2 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i9, i12, i16) | 0;
   if (!(HEAP8[i16 >> 0] | 0)) {
    HEAP32[i2 >> 2] = i4;
    HEAP32[i2 + 4 >> 2] = i3;
   }
   i2 = HEAP32[i13 >> 2] | 0;
   if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i3 = HEAP32[i8 >> 2] | 0;
    HEAP32[i3 + (i2 << 5) >> 2] = i4;
    i4 = i3 + (i2 << 5) + 8 | 0;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i4 + 4 >> 2] = i6;
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE(i3 + (i2 << 5) + 16 | 0, i10);
    HEAP8[i3 + (i2 << 5) + 28 >> 0] = 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_116CollectionSorter7ElementENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i8, i15) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i18 | 0)) break;
   i3 = HEAP32[i13 >> 2] | 0;
  }
  i1 = i23 + 76 | 0;
  i2 = 0;
  do {
   i16 = (HEAP32[i19 >> 2] | 0) + (i2 << 5) | 0;
   HEAP32[i1 >> 2] = i16;
   i15 = HEAP32[i17 >> 2] | 0;
   i16 = mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, HEAP16[(HEAP32[i16 >> 2] | 0) + 4 >> 1] | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0, i16 | 0, HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i23 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
  i2 = 0;
  do {
   i1 = HEAP32[i19 >> 2] | 0;
   if (!(HEAP8[i1 + (i2 << 5) + 28 >> 0] | 0)) __ZN12_GLOBAL__N_116CollectionSorter10AddElementERNS0_7ElementE(i23, i1 + (i2 << 5) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
 }
 i7 = HEAP32[i22 >> 2] | 0;
 i1 = HEAP32[i7 + 64 >> 2] | 0;
 if (i1 | 0) {
  i8 = i7 + 80 | 0;
  if (HEAP32[i8 >> 2] | 0) {
   _memset(HEAP32[i7 + 56 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i7 + 60 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i7 + 52 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i7 + 72 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
  }
 }
 if (!(HEAP32[i21 >> 2] | 0)) {
  __ZN12_GLOBAL__N_116CollectionSorterD2Ev(i23);
  STACKTOP = i24;
  return;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 i2 = i1;
 do {
  i17 = HEAP32[i22 >> 2] | 0;
  i19 = i2 + 8 | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i19 = HEAP32[i19 + 4 >> 2] | 0;
  i16 = HEAP32[i2 >> 2] | 0;
  i15 = i16 + ~(i16 << 15) | 0;
  i15 = (i15 >>> 10 ^ i15) * 9 | 0;
  i15 = i15 >>> 6 ^ i15;
  i15 = i15 + ~(i15 << 11) | 0;
  i15 = (i15 >>> 16 ^ i15) & (HEAP32[i17 + 64 >> 2] | 0) + -1;
  i14 = i17 + 72 | 0;
  i20 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i20 + 1;
  i15 = (HEAP32[i17 + 56 >> 2] | 0) + (i15 << 2) | 0;
  HEAP32[(HEAP32[i17 + 52 >> 2] | 0) + (i20 << 2) >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i20;
  i15 = i17 + 80 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  i15 = i17 + 76 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  i17 = HEAP32[i17 + 48 >> 2] | 0;
  HEAP32[i17 + (i20 << 4) >> 2] = i16;
  i20 = i17 + (i20 << 4) + 8 | 0;
  HEAP32[i20 >> 2] = i18;
  HEAP32[i20 + 4 >> 2] = i19;
  i2 = i2 + 16 | 0;
 } while ((i2 | 0) != (i1 + (HEAP32[i21 >> 2] << 4) | 0));
 __ZN12_GLOBAL__N_116CollectionSorterD2Ev(i23);
 STACKTOP = i24;
 return;
}

function _ps_hints_t1stem3(i14, i1, i4) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 12 | 0;
 i6 = i22;
 i21 = i14 + 4 | 0;
 if (HEAP32[i21 >> 2] | 0) {
  STACKTOP = i22;
  return;
 }
 i20 = HEAP32[i14 >> 2] | 0;
 i13 = i1 >>> 0 > 1 ? 1 : i1;
 i2 = i14 + 16 + (i13 * 36 | 0) | 0;
 L4 : do if ((HEAP32[i14 + 12 >> 2] | 0) == 1) {
  i1 = (_UNITY_FT_RoundFix(HEAP32[i4 >> 2] | 0) | 0) >> 16;
  i1 = _ps_dimension_add_t1stem(i2, i1, (_UNITY_FT_RoundFix(HEAP32[i4 + 4 >> 2] | 0) | 0) >> 16, i20, i6) | 0;
  if (!i1) {
   i1 = (_UNITY_FT_RoundFix(HEAP32[i4 + 8 >> 2] | 0) | 0) >> 16;
   i5 = i6 + 4 | 0;
   i1 = _ps_dimension_add_t1stem(i2, i1, (_UNITY_FT_RoundFix(HEAP32[i4 + 12 >> 2] | 0) | 0) >> 16, i20, i5) | 0;
   if (!i1) {
    i1 = (_UNITY_FT_RoundFix(HEAP32[i4 + 16 >> 2] | 0) | 0) >> 16;
    i3 = i6 + 8 | 0;
    i1 = _ps_dimension_add_t1stem(i2, i1, (_UNITY_FT_RoundFix(HEAP32[i4 + 20 >> 2] | 0) | 0) >> 16, i20, i3) | 0;
    if (!i1) {
     i15 = HEAP32[i6 >> 2] | 0;
     i16 = HEAP32[i5 >> 2] | 0;
     i17 = HEAP32[i3 >> 2] | 0;
     i12 = i14 + 16 + (i13 * 36 | 0) + 24 | 0;
     i11 = HEAP32[i12 >> 2] | 0;
     L9 : do if (!i11) i18 = 13; else {
      i2 = i15 >> 3;
      i3 = 128 >>> (i15 & 7);
      i4 = i16 >> 3;
      i5 = 128 >>> (i16 & 7);
      i6 = i17 >> 3;
      i8 = 128 >>> (i17 & 7);
      i1 = i11;
      i7 = HEAP32[i14 + 16 + (i13 * 36 | 0) + 32 >> 2] | 0;
      while (1) {
       i9 = i7;
       i10 = HEAP32[i9 >> 2] | 0;
       if (i10 >>> 0 > i15 >>> 0) if ((HEAPU8[(HEAP32[i9 + 8 >> 2] | 0) + i2 >> 0] | 0) & i3 | 0) break L9;
       if (i10 >>> 0 > i16 >>> 0) if ((HEAPU8[(HEAP32[i9 + 8 >> 2] | 0) + i4 >> 0] | 0) & i5 | 0) break L9;
       if (i10 >>> 0 > i17 >>> 0) if ((HEAPU8[(HEAP32[i9 + 8 >> 2] | 0) + i6 >> 0] | 0) & i8 | 0) break L9;
       i1 = i1 + -1 | 0;
       if (!i1) {
        i18 = 13;
        break;
       } else i7 = i9 + 16 | 0;
      }
     } while (0);
     if ((i18 | 0) == 13) {
      i5 = i11 + 1 | 0;
      i4 = i14 + 16 + (i13 * 36 | 0) + 28 | 0;
      i1 = HEAP32[i4 >> 2] | 0;
      do if (i5 >>> 0 > i1 >>> 0) {
       HEAP32[i19 >> 2] = 0;
       i3 = i11 + 8 & -8;
       i14 = i14 + 16 + (i13 * 36 | 0) + 32 | 0;
       i2 = _UNITY_ft_mem_realloc(i20, 16, i1, i3, HEAP32[i14 >> 2] | 0, i19) | 0;
       HEAP32[i14 >> 2] = i2;
       i1 = HEAP32[i19 >> 2] | 0;
       if (!i1) {
        HEAP32[i4 >> 2] = i3;
        i1 = i2;
        break;
       } else break L4;
      } else i1 = HEAP32[i14 + 16 + (i13 * 36 | 0) + 32 >> 2] | 0; while (0);
      i7 = i1 + (i5 << 4) + -16 | 0;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i7 + 12 >> 2] = 0;
      HEAP32[i12 >> 2] = i5;
     }
     if ((i15 | 0) > -1) {
      i5 = i7;
      if ((HEAP32[i5 >> 2] | 0) >>> 0 <= i15 >>> 0) {
       i6 = i15 + 1 | 0;
       i4 = i5 + 4 | 0;
       i2 = ((HEAP32[i4 >> 2] | 0) + 7 | 0) >>> 3;
       i1 = (i15 + 8 | 0) >>> 3;
       HEAP32[i19 >> 2] = 0;
       do if (i1 >>> 0 > i2 >>> 0) {
        i3 = i1 + 7 & 1073741816;
        i1 = i5 + 8 | 0;
        HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i20, 1, i2, i3, HEAP32[i1 >> 2] | 0, i19) | 0;
        i1 = HEAP32[i19 >> 2] | 0;
        if (!i1) {
         HEAP32[i4 >> 2] = i3 << 3;
         break;
        } else break L4;
       } while (0);
       HEAP32[i5 >> 2] = i6;
      }
      i14 = (HEAP32[i5 + 8 >> 2] | 0) + (i15 >>> 3) | 0;
      HEAP8[i14 >> 0] = HEAPU8[i14 >> 0] | 0 | 128 >>> (i15 & 7);
     }
     if ((i16 | 0) > -1) {
      i6 = i7;
      if ((HEAP32[i6 >> 2] | 0) >>> 0 <= i16 >>> 0) {
       i4 = i16 + 1 | 0;
       i5 = i6 + 4 | 0;
       i2 = ((HEAP32[i5 >> 2] | 0) + 7 | 0) >>> 3;
       i1 = (i16 + 8 | 0) >>> 3;
       HEAP32[i19 >> 2] = 0;
       do if (i1 >>> 0 > i2 >>> 0) {
        i3 = i1 + 7 & 1073741816;
        i1 = i6 + 8 | 0;
        HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i20, 1, i2, i3, HEAP32[i1 >> 2] | 0, i19) | 0;
        i1 = HEAP32[i19 >> 2] | 0;
        if (!i1) {
         HEAP32[i5 >> 2] = i3 << 3;
         break;
        } else break L4;
       } while (0);
       HEAP32[i6 >> 2] = i4;
      }
      i15 = (HEAP32[i6 + 8 >> 2] | 0) + (i16 >>> 3) | 0;
      HEAP8[i15 >> 0] = HEAPU8[i15 >> 0] | 0 | 128 >>> (i16 & 7);
      if ((i17 | 0) > -1) {
       i7 = i6;
       i18 = 37;
      }
     } else if ((i17 | 0) > -1) {
      i6 = i7;
      i7 = i6;
      i18 = 37;
     }
     if ((i18 | 0) == 37) {
      if ((HEAP32[i6 >> 2] | 0) >>> 0 <= i17 >>> 0) {
       i4 = i17 + 1 | 0;
       i5 = i7 + 4 | 0;
       i2 = ((HEAP32[i5 >> 2] | 0) + 7 | 0) >>> 3;
       i1 = (i17 + 8 | 0) >>> 3;
       HEAP32[i19 >> 2] = 0;
       do if (i1 >>> 0 > i2 >>> 0) {
        i3 = i1 + 7 & 1073741816;
        i1 = i7 + 8 | 0;
        HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i20, 1, i2, i3, HEAP32[i1 >> 2] | 0, i19) | 0;
        i1 = HEAP32[i19 >> 2] | 0;
        if (!i1) {
         HEAP32[i5 >> 2] = i3 << 3;
         break;
        } else break L4;
       } while (0);
       HEAP32[i6 >> 2] = i4;
      }
      i21 = (HEAP32[i7 + 8 >> 2] | 0) + (i17 >>> 3) | 0;
      HEAP8[i21 >> 0] = HEAPU8[i21 >> 0] | 0 | 128 >>> (i17 & 7);
     }
     STACKTOP = i22;
     return;
    }
   }
  }
 } else i1 = 6; while (0);
 HEAP32[i21 >> 2] = i1;
 STACKTOP = i22;
 return;
}

function __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i11, i8, i9, i10, i1, i2) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0, i28 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 32 | 0;
 i23 = i24 + 4 | 0;
 i22 = i24;
 HEAP32[i11 + 108 >> 2] = i2;
 __ZN5physx22PxVehicleWheelsSimDataaSERKS0_(i11 + 8 | 0, i10) | 0;
 i20 = i11 + 104 | 0;
 HEAP32[i20 >> 2] = i9;
 i7 = HEAP32[i10 + 36 >> 2] | 0;
 i1 = (i7 | 0) == 0;
 if (!i1) {
  i2 = HEAP32[i11 + 72 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i2 + (i3 * 224 | 0) + 212 >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i7 | 0));
  if (!i1) {
   i3 = i11 + 72 | 0;
   i4 = i10 + 32 | 0;
   i5 = 0;
   do {
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 * 224 | 0) + 208 >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i6 = 0;
    do {
     HEAP32[i1 + 4 + (i6 * 12 | 0) >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 688 + (i6 * 12 | 0) >> 2];
     HEAP32[i1 + 4 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 688 + (i6 * 12 | 0) + 4 >> 2];
     HEAP32[i1 + 4 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 688 + (i6 * 12 | 0) + 8 >> 2];
     HEAP32[i1 + 52 + (i6 * 12 | 0) >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 640 + (i6 * 12 | 0) >> 2];
     HEAP32[i1 + 52 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 640 + (i6 * 12 | 0) + 4 >> 2];
     HEAP32[i1 + 52 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i2 + (i5 * 944 | 0) + 640 + (i6 * 12 | 0) + 8 >> 2];
     HEAPF32[i1 + 100 + (i6 << 2) >> 2] = Math_fround(0.0);
     HEAP8[i1 + 116 + i6 >> 0] = 0;
     HEAP32[i1 + 120 + (i6 * 12 | 0) >> 2] = 0;
     HEAP32[i1 + 120 + (i6 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i1 + 120 + (i6 * 12 | 0) + 8 >> 2] = 0;
     HEAP32[i1 + 168 + (i6 * 12 | 0) >> 2] = 0;
     HEAP32[i1 + 168 + (i6 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i1 + 168 + (i6 * 12 | 0) + 8 >> 2] = 0;
     HEAPF32[i1 + 216 + (i6 << 2) >> 2] = Math_fround(0.0);
     HEAP8[i1 + 232 + i6 >> 0] = 0;
     HEAP32[i1 + 236 + (i6 * 12 | 0) >> 2] = 0;
     HEAP32[i1 + 236 + (i6 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i1 + 236 + (i6 * 12 | 0) + 8 >> 2] = 0;
     HEAP32[i1 + 284 + (i6 * 12 | 0) >> 2] = 0;
     HEAP32[i1 + 284 + (i6 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i1 + 284 + (i6 * 12 | 0) + 8 >> 2] = 0;
     HEAPF32[i1 + 332 + (i6 << 2) >> 2] = Math_fround(0.0);
     HEAP8[i1 + 348 + i6 >> 0] = 0;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != 4);
    i19 = mftCall_iiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 136 >> 2] | 0, i8 | 0, i9 | 0, 0, i1 | 0, gb + 159112 | 0, 364) | 0;
    HEAP32[i1 + 368 >> 2] = i19;
    mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 36 >> 2] | 0, i19 | 0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
 }
 i19 = i10 + 40 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 if (!i4) i1 = 0; else {
  i1 = i11 + 40 | 0;
  i2 = i11 + 76 | 0;
  i3 = 0;
  do {
   HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + (i3 << 2) >> 2] = (HEAP32[i1 >> 2] | 0) + ((i3 >>> 2) * 944 | 0) + 384 + ((i3 & 3) << 6);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
  i1 = i4;
 }
 i2 = HEAP32[i11 + 44 >> 2] << 2;
 if (i1 >>> 0 < i2 >>> 0) {
  do {
   i18 = i11 + 52 + (i1 >>> 5 << 2) | 0;
   HEAP32[i18 >> 2] = HEAP32[i18 >> 2] & ~(1 << (i1 & 31));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i4 = HEAP32[i19 >> 2] | 0;
 }
 if (!i4) {
  STACKTOP = i24;
  return;
 }
 i6 = i11 + 40 | 0;
 i7 = i23 + 4 | 0;
 i8 = i21 + 4 | 0;
 i9 = i23 + 8 | 0;
 i10 = i21 + 8 | 0;
 i11 = i23 + 12 | 0;
 i12 = i21 + 12 | 0;
 i13 = i23 + 16 | 0;
 i14 = i21 + 16 | 0;
 i15 = i23 + 20 | 0;
 i16 = i21 + 20 | 0;
 i17 = i23 + 24 | 0;
 i18 = i21 + 24 | 0;
 i5 = 0;
 do {
  i1 = i5 >>> 2;
  i2 = i5 & 3;
  i3 = HEAP8[(HEAP32[i6 >> 2] | 0) + (i1 * 944 | 0) + 928 + i2 >> 0] | 0;
  if (i3 << 24 >> 24 != -1) {
   i28 = HEAP32[i20 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 124 >> 2] | 0, i21 | 0, i28 | 0);
   HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   i28 = HEAP32[i14 >> 2] | 0;
   HEAP32[i13 >> 2] = i28;
   i27 = HEAP32[i16 >> 2] | 0;
   HEAP32[i15 >> 2] = i27;
   i4 = HEAP32[i18 >> 2] | 0;
   HEAP32[i17 >> 2] = i4;
   i26 = HEAP32[i6 >> 2] | 0;
   f25 = Math_fround(HEAPF32[i26 + (i1 * 944 | 0) + 784 + (i2 * 12 | 0) >> 2]);
   HEAPF32[i13 >> 2] = Math_fround(f25 + (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f25 = Math_fround(HEAPF32[i26 + (i1 * 944 | 0) + 784 + (i2 * 12 | 0) + 4 >> 2]);
   HEAPF32[i15 >> 2] = Math_fround(f25 + (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f25 = Math_fround(HEAPF32[i26 + (i1 * 944 | 0) + 784 + (i2 * 12 | 0) + 8 >> 2]);
   HEAPF32[i17 >> 2] = Math_fround(f25 + (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i4 = HEAP32[i20 >> 2] | 0;
   mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, i22 | 0, 1, i3 & 255 | 0) | 0;
   i4 = HEAP32[i22 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0, i23 | 0);
   i4 = HEAP32[i19 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i4 >>> 0);
 STACKTOP = i24;
 return;
}

function _UNITY_LZ4_decompress_safe_partial(i20, i17, i2, i1, i3) {
 i20 = i20 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i18 = i20 + i2 | 0;
 i19 = i17 + i3 | 0;
 i15 = i17 + i1 | 0;
 i16 = i19 + -12 | 0;
 i15 = i15 >>> 0 > i16 >>> 0 ? i16 : i15;
 if (!i3) {
  if ((i2 | 0) == 1) i1 = (HEAP8[i20 >> 0] | 0) != 0; else i1 = 1;
  i21 = i1 << 31 >> 31;
  return i21 | 0;
 }
 i9 = i18 + -15 | 0;
 i10 = i18 + -8 | 0;
 i11 = i18 + -5 | 0;
 i12 = i19 + -5 | 0;
 i13 = i19 + -8 | 0;
 i14 = i13;
 i2 = i20;
 i3 = i17;
 L8 : while (1) {
  i1 = i2 + 1 | 0;
  i7 = HEAPU8[i2 >> 0] | 0;
  i2 = i7 >>> 4;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    i8 = i1;
    i1 = i1 + 1 | 0;
    i8 = HEAP8[i8 >> 0] | 0;
    i2 = (i8 & 255) + i2 | 0;
   } while (i8 << 24 >> 24 == -1 & i1 >>> 0 < i9 >>> 0);
   if ((i2 | 0) < 0) break;
  }
  i8 = i3 + i2 | 0;
  i4 = i1 + i2 | 0;
  if (i8 >>> 0 > i15 >>> 0 | i4 >>> 0 > i10 >>> 0) {
   i21 = 10;
   break;
  } else i2 = i3;
  while (1) {
   i5 = i1;
   i22 = i5;
   i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i2;
   i3 = i6;
   HEAP8[i3 >> 0] = i22;
   HEAP8[i3 + 1 >> 0] = i22 >> 8;
   HEAP8[i3 + 2 >> 0] = i22 >> 16;
   HEAP8[i3 + 3 >> 0] = i22 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 8 | 0;
  }
  i3 = HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 >> 0];
  i5 = i3 & 65535;
  i6 = i8 + (0 - i3) | 0;
  i1 = i4 + 2 | 0;
  if (i6 >>> 0 < i17 >>> 0) break;
  i2 = i7 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    if (i1 >>> 0 > i11 >>> 0) break L8;
    i22 = i1;
    i1 = i1 + 1 | 0;
    i22 = HEAP8[i22 >> 0] | 0;
    i2 = (i22 & 255) + i2 | 0;
   } while (i22 << 24 >> 24 == -1);
   if ((i2 | 0) < 0) break;
  }
  i7 = i8 + (i2 + 4) | 0;
  if ((i5 & 65535) < 8) {
   i22 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
   HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
   i3 = i6 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
   i6 = i8 + 4 | 0;
   i5 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i3 = i3 + (0 - i22) | 0;
  } else {
   i22 = i6;
   i4 = i22;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i22 = i22 + 4 | 0;
   i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
   i3 = i8;
   i5 = i3;
   HEAP8[i5 >> 0] = i4;
   HEAP8[i5 + 1 >> 0] = i4 >> 8;
   HEAP8[i5 + 2 >> 0] = i4 >> 16;
   HEAP8[i5 + 3 >> 0] = i4 >> 24;
   i3 = i3 + 4 | 0;
   HEAP8[i3 >> 0] = i22;
   HEAP8[i3 + 1 >> 0] = i22 >> 8;
   HEAP8[i3 + 2 >> 0] = i22 >> 16;
   HEAP8[i3 + 3 >> 0] = i22 >> 24;
   i3 = i6 + 8 | 0;
  }
  i2 = i8 + 8 | 0;
  if (i7 >>> 0 <= i16 >>> 0) while (1) {
   i8 = i3;
   i5 = i8;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i8 = i8 + 4 | 0;
   i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
   i22 = i2;
   i6 = i22;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i22 = i22 + 4 | 0;
   HEAP8[i22 >> 0] = i8;
   HEAP8[i22 + 1 >> 0] = i8 >> 8;
   HEAP8[i22 + 2 >> 0] = i8 >> 16;
   HEAP8[i22 + 3 >> 0] = i8 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
  if (i7 >>> 0 > i12 >>> 0) break;
  if (i2 >>> 0 < i13 >>> 0) {
   i4 = i2;
   i5 = i3;
   while (1) {
    i8 = i5;
    i23 = i8;
    i23 = HEAPU8[i23 >> 0] | HEAPU8[i23 + 1 >> 0] << 8 | HEAPU8[i23 + 2 >> 0] << 16 | HEAPU8[i23 + 3 >> 0] << 24;
    i8 = i8 + 4 | 0;
    i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
    i22 = i4;
    i6 = i22;
    HEAP8[i6 >> 0] = i23;
    HEAP8[i6 + 1 >> 0] = i23 >> 8;
    HEAP8[i6 + 2 >> 0] = i23 >> 16;
    HEAP8[i6 + 3 >> 0] = i23 >> 24;
    i22 = i22 + 4 | 0;
    HEAP8[i22 >> 0] = i8;
    HEAP8[i22 + 1 >> 0] = i8 >> 8;
    HEAP8[i22 + 2 >> 0] = i8 >> 16;
    HEAP8[i22 + 3 >> 0] = i8 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i13 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i3 = i3 + (i14 - i2) | 0;
   i2 = i13;
  }
  if (i2 >>> 0 >= i7 >>> 0) {
   i2 = i1;
   i3 = i7;
   continue;
  }
  while (1) {
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   if (i4 >>> 0 < i7 >>> 0) {
    i3 = i3 + 1 | 0;
    i2 = i4;
   } else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
 }
 if ((i21 | 0) == 10) if (!(i8 >>> 0 > i19 >>> 0 | i4 >>> 0 > i18 >>> 0)) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i23 = i8 - i17 | 0;
  return i23 | 0;
 }
 i23 = i20 + -1 - i1 | 0;
 return i23 | 0;
}

function __ZN5physx27InternalTriangleMeshBuilder20createSharedEdgeDataEbb(i13, i4, i3) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i15 + 5 | 0, HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0);
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i1 + 152 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i15 + 4 | 0, HEAP32[i1 + 168 >> 2] | 0);
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i1 + 168 >> 2] = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i5) i2 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = mftCall_iiiiii(i12 | 0, i1 | 0, i5 | 0, (i2 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 254) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i1 + 152 >> 2] = i2;
 if (!(i4 | i3)) {
  _memset(i2 | 0, 56, i5 | 0) | 0;
  STACKTOP = i15;
  return;
 }
 _memset(i2 | 0, 0, i5 | 0) | 0;
 i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 730919 | 0, 267, gb + 731015 | 0, i15);
  STACKTOP = i15;
  return;
 }
 __ZN5physx27InternalTriangleMeshBuilder14createEdgeListEv(i13);
 i3 = i13 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) == (HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0)) if (HEAP32[i1 + 8 >> 2] | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   if ((HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0) <= -1) {
    i11 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0) + i2 | 0;
    HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 0 | 8;
   }
   if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) <= -1) {
    i11 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0) + i2 | 0;
    HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 0 | 16;
   }
   if ((HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) <= -1) {
    i11 = (HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0) + i2 | 0;
    HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 0 | 32;
   }
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  } while (i2 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0);
 }
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i1 = i5 * 3 | 0;
 i1 = i1 >>> 0 > 1073741823 ? -1 : i1 << 2;
 if (!i1) i1 = 0; else {
  i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
  i11 = _PxGetFoundation() | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
  i1 = mftCall_iiiiii(i9 | 0, i10 | 0, i1 | 0, (i11 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 291) | 0;
 }
 HEAP32[(HEAP32[i13 >> 2] | 0) + 168 >> 2] = i1;
 _memset(i1 | 0, -1, i5 * 12 | 0) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i11 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i10 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if ((HEAPU16[i10 + 2 >> 1] | 0) > 1) {
   i8 = HEAP32[i10 + 4 >> 2] | 0;
   i7 = HEAP32[i11 + (i8 << 2) >> 2] | 0;
   i8 = HEAP32[i11 + (i8 + 1 << 2) >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i9 + 4 >> 2] | 0;
   i2 = HEAP32[i12 + (i7 * 12 | 0) >> 2] | 0;
   i3 = (i2 | 0) == (i5 | 0);
   if (i3) if ((HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) i4 = 0; else i14 = 25; else i14 = 25;
   do if ((i14 | 0) == 25) {
    i14 = 0;
    i2 = (i2 | 0) == (i6 | 0);
    if (i2) if ((HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0) == (i5 | 0)) {
     i4 = 0;
     break;
    }
    if (i3) if ((HEAP32[i12 + (i7 * 12 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
     i4 = 2;
     break;
    }
    if (i2) if ((HEAP32[i12 + (i7 * 12 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
     i4 = 2;
     break;
    }
    i2 = HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0)) if ((HEAP32[i12 + (i7 * 12 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
     i4 = 1;
     break;
    }
    if ((i2 | 0) == (i6 | 0)) if ((HEAP32[i12 + (i7 * 12 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
     i4 = 1;
     break;
    }
    i4 = 255;
   } while (0);
   i2 = HEAP32[i12 + (i8 * 12 | 0) >> 2] | 0;
   i3 = (i2 | 0) == (i5 | 0);
   if (i3) if ((HEAP32[i12 + (i8 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) i2 = 0; else i14 = 38; else i14 = 38;
   do if ((i14 | 0) == 38) {
    i14 = 0;
    i2 = (i2 | 0) == (i6 | 0);
    if (i2) if ((HEAP32[i12 + (i8 * 12 | 0) + 4 >> 2] | 0) == (i5 | 0)) {
     i2 = 0;
     break;
    }
    if (i3) if ((HEAP32[i12 + (i8 * 12 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
     i2 = 2;
     break;
    }
    if (i2) if ((HEAP32[i12 + (i8 * 12 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
     i2 = 2;
     break;
    }
    i2 = HEAP32[i12 + (i8 * 12 | 0) + 4 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0)) if ((HEAP32[i12 + (i8 * 12 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
     i2 = 1;
     break;
    }
    if ((i2 | 0) == (i6 | 0)) if ((HEAP32[i12 + (i8 * 12 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
     i2 = 1;
     break;
    }
    i2 = 255;
   } while (0);
   i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + 168 >> 2] | 0;
   HEAP32[i6 + (i4 + (i7 * 3 | 0) << 2) >> 2] = i8;
   HEAP32[i6 + (i2 + (i8 * 3 | 0) << 2) >> 2] = i7;
  }
  if (!i1) break; else {
   i10 = i10 + 8 | 0;
   i9 = i9 + 8 | 0;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i27, i28, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i31 + 56 | 0;
 i23 = i31 + 44 | 0;
 i24 = i31 + 40 | 0;
 i30 = i31 + 20 | 0;
 i25 = i31;
 i26 = i28 + 8 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i27, gb + 1041885 | 0, gb + 1041885 | 0, i24) | 0)) {
  STACKTOP = i31;
  return;
 }
 i7 = i30 + 4 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i28 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i28, HEAP32[i8 >> 2] | 0);
 HEAP32[i26 >> 2] = 0;
 HEAP32[i28 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i24 >> 2] | 0) > 0) {
  i9 = HEAP32[gb + 37152 >> 2] | 0;
  i10 = i25 + 4 | 0;
  i11 = i7 + 11 | 0;
  i12 = i30 + 8 | 0;
  i13 = i25 + 16 | 0;
  i6 = i25 + 16 | 0;
  i14 = i29 + 4 | 0;
  i15 = i25 + 12 | 0;
  i16 = i25 + 8 | 0;
  i17 = i8;
  i18 = i28 + 4 | 0;
  i19 = i25 + 4 | 0;
  i20 = i19 + 11 | 0;
  i21 = i29 + 4 | 0;
  i22 = i10 + 11 | 0;
  i5 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i27, gb + 1041891 | 0, i9, i29, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i30, i27); else {
     i1 = HEAP32[i29 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i30 | 0, i27 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i27);
   }
   HEAP32[i25 >> 2] = HEAP32[i30 >> 2];
   i3 = HEAP8[i11 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
   i3 = i1 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
    i1 = HEAP32[i6 >> 2] | 0;
    i4 = 16;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 >> 0] = i3;
    if (!i3) i1 = i10; else {
     i1 = i10;
     i4 = 18;
    }
   } else i4 = 16;
   if ((i4 | 0) == 16) {
    i32 = i3 + 16 & -16;
    HEAP32[i29 >> 2] = 66;
    HEAP32[i14 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i32, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i15 >> 2] = i32 | -2147483648;
    HEAP32[i16 >> 2] = i3;
    i4 = 18;
   }
   if ((i4 | 0) == 18) {
    i4 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i8 >> 2] | 0;
   do if (!i1) {
    HEAP32[i29 >> 2] = i8;
    i2 = i17;
    i3 = i8;
   } else {
    i4 = HEAP32[i25 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i4 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 23;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i4 | 0)) {
       i4 = 28;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 27;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 23) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     break;
    } else if ((i4 | 0) == 27) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     break;
    } else if ((i4 | 0) == 28) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     i3 = i29;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE(i23, i28, i25);
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i28 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 >> 2] | 0, i1);
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i32 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i29 >> 2] = 66;
    HEAP32[i21 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i29);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i24 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i27);
 i1 = i30 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i32 = HEAP32[i1 >> 2] | 0;
  i30 = HEAP32[i30 + 16 >> 2] | 0;
  HEAP32[i29 >> 2] = 66;
  HEAP32[i29 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i32, i29);
 }
 STACKTOP = i31;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i29, i30, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28 + 40 | 0;
 i26 = i28 + 20 | 0;
 i27 = i28;
 i1 = i29 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i29 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i25, 4);
  i1 = HEAP32[i25 >> 2] | 0;
 } else {
  i24 = HEAP32[i2 >> 2] | 0;
  HEAP32[i25 >> 2] = i24;
  HEAP32[i1 >> 2] = i3;
  i1 = i24;
 }
 i10 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i11 = i26 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i30 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i30, HEAP32[i12 >> 2] | 0);
 i13 = i30 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i30 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 if ((i10 | 0) <= 0) {
  STACKTOP = i28;
  return;
 }
 i14 = i26 + 16 | 0;
 i15 = i26 + 11 | 0;
 i16 = i26 + 4 | 0;
 i17 = i27 + 12 | 0;
 i9 = i27 + 12 | 0;
 i18 = i25 + 4 | 0;
 i19 = i27 + 8 | 0;
 i20 = i27 + 4 | 0;
 i21 = i27 + 16 | 0;
 i22 = i30 + 4 | 0;
 i23 = i27 + 11 | 0;
 i24 = i25 + 4 | 0;
 i8 = 0;
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i29, i26, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i29);
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i14, i29);
  i3 = HEAP8[i15 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i26 >> 2] | 0 : i26;
  i3 = i1 ? HEAP32[i16 >> 2] | 0 : i3 & 255;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i17 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
   i1 = HEAP32[i9 >> 2] | 0;
   i4 = 12;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i23 >> 0] = i3;
   if (!i3) i1 = i27; else {
    i1 = i27;
    i4 = 14;
   }
  } else i4 = 12;
  if ((i4 | 0) == 12) {
   i7 = i3 + 16 & -16;
   HEAP32[i25 >> 2] = 66;
   HEAP32[i18 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i27 >> 2] = i1;
   HEAP32[i19 >> 2] = i7 | -2147483648;
   HEAP32[i20 >> 2] = i3;
   i4 = 14;
  }
  if ((i4 | 0) == 14) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
  i1 = HEAP32[i12 >> 2] | 0;
  do if (!i1) {
   i2 = i12;
   i3 = i12;
  } else {
   i6 = HEAP8[i23 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i6 = i7 ? HEAP32[i20 >> 2] | 0 : i6 & 255;
   i7 = i7 ? HEAP32[i27 >> 2] | 0 : i27;
   while (1) {
    i3 = i1 + 16 | 0;
    i5 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
    i2 = i5 >>> 0 < i6 >>> 0 ? i5 : i6;
    if (!i2) i4 = 19; else {
     i2 = _memcmp(i7, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
     if (!i2) i4 = 19; else if ((i2 | 0) < 0) i4 = 21; else i4 = 23;
    }
    if ((i4 | 0) == 19) if (i6 >>> 0 < i5 >>> 0) i4 = 21; else i4 = 23;
    if ((i4 | 0) == 21) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 22;
      break;
     } else i1 = i2;
    } else if ((i4 | 0) == 23) {
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 25;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 22) {
    i4 = 0;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 25) {
    i4 = 0;
    i2 = i1;
    break;
   }
  } while (0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i25, i30, i27);
  i1 = HEAP32[i25 >> 2] | 0;
  HEAP32[i25 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i30 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i22 >> 2] | 0, i1);
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  if ((HEAP8[i23 >> 0] | 0) < 0) {
   i7 = HEAP32[i27 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i25 >> 2] = 66;
   HEAP32[i24 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i25);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i10 | 0));
 if ((HEAP8[i15 >> 0] | 0) >= 0) {
  STACKTOP = i28;
  return;
 }
 i30 = HEAP32[i26 >> 2] | 0;
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i25 >> 2] = 66;
 HEAP32[i25 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i30, i25);
 STACKTOP = i28;
 return;
}

function __ZN19CharacterController4MoveERK8Vector3f(i16, i2) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, f18 = f0, d19 = 0.0, d20 = 0.0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17 + 72 | 0;
 i4 = i17 + 56 | 0;
 i15 = i17 + 32 | 0;
 i7 = i17 + 16 | 0;
 i8 = i17;
 i9 = i17 + 44 | 0;
 i14 = i16 + 60 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i13 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 f10 = Math_fround(+HEAPF64[i13 >> 3]);
 f11 = Math_fround(+HEAPF64[i13 + 8 >> 3]);
 f12 = Math_fround(+HEAPF64[i13 + 16 >> 3]);
 i13 = HEAP32[i14 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 72 >> 2] | 0, i13 | 0);
 i13 = HEAP32[i16 + 36 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i13 | 0);
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i16 + 64;
 HEAP16[i4 + 8 >> 1] = 7;
 HEAP32[i4 + 12 >> 2] = gb + 1452864;
 d19 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 32 >> 3];
 i13 = i16 + 144 | 0;
 d20 = +HEAPF64[i13 >> 3];
 f18 = Math_fround(d19 - d20);
 f18 = d20 > 0.0 ? f18 : Math_fround(0.0);
 HEAPF64[i13 >> 3] = d19;
 i13 = HEAP32[i14 >> 2] | 0;
 i13 = (mftCall_iiiffii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i2 | 0, +Math_fround(HEAPF32[i16 + 72 >> 2]), +f18, i4 | 0, 0) | 0) & 255;
 i5 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 i6 = HEAP32[gb + 1452868 + 4 >> 2] | 0;
 HEAP32[gb + 1452868 + 4 >> 2] = 0;
 i2 = HEAP32[gb + 1452868 + 8 >> 2] | 0;
 HEAP32[gb + 1452868 + 8 >> 2] = 0;
 HEAP32[gb + 1452868 + 12 >> 2] = 0;
 L4 : do if ((i6 | 0) == (i2 | 0)) i1 = 1; else {
  i3 = i9 + 4 | 0;
  i4 = i9 + 8 | 0;
  i1 = i6;
  while (1) {
   i22 = i1 + 4 | 0;
   HEAP32[i15 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i22 = i1 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i22 = i1 + 28 | 0;
   HEAP32[i8 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   i22 = HEAP32[i1 + 40 >> 2] | 0;
   i24 = __ZN9Scripting19ScriptingWrapperForEP6Object(i16) | 0;
   i23 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 >> 2] | 0) | 0;
   i21 = _il2cpp_object_new(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
   HEAP32[i21 + 8 >> 2] = i24;
   HEAP32[i21 + 12 >> 2] = i23;
   i23 = i21 + 16 | 0;
   HEAP32[i23 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   i23 = i21 + 28 | 0;
   HEAP32[i23 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i23 = i21 + 40 | 0;
   HEAP32[i23 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i21 + 52 >> 2] = i22;
   HEAP32[i21 + 56 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 >> 2] = i21;
   HEAP32[i9 >> 2] = gb + 29592;
   __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i16, gb + 1105416 | 0, i9);
   i1 = i1 + 44 | 0;
   if (!(HEAP32[i14 >> 2] | 0)) {
    i1 = 0;
    break L4;
   }
   if ((i1 | 0) == (i2 | 0)) {
    i1 = 1;
    break;
   }
  }
 } while (0);
 if (i6 | 0) __ZdlPv(i6);
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i5) | 0;
 if (i1) {
  HEAP32[i16 + 140 >> 2] = i13;
  if (i13 & 4 | 0) {
   i1 = i16 + 112 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) < Math_fround(0.0)) HEAPF32[i1 >> 2] = Math_fround(0.0);
  }
  i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
  f26 = Math_fround(+HEAPF64[i1 >> 3]);
  f25 = Math_fround(+HEAPF64[i1 + 8 >> 3]);
  f18 = Math_fround(+HEAPF64[i1 + 16 >> 3]);
  HEAPF32[i15 >> 2] = f26;
  HEAPF32[i15 + 4 >> 2] = f25;
  HEAPF32[i15 + 8 >> 2] = f18;
  f10 = Math_fround(f26 - f10);
  f25 = Math_fround(f25 - f11);
  f18 = Math_fround(f18 - f12);
  f11 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
  f12 = Math_fround(f25 * f11);
  f18 = Math_fround(f18 * f11);
  HEAPF32[i16 + 116 >> 2] = Math_fround(f10 * f11);
  HEAPF32[i16 + 120 >> 2] = f12;
  HEAPF32[i16 + 124 >> 2] = f18;
  i1 = __ZN14MessageHandler3GetEv() | 0;
  i2 = HEAP32[gb + 111552 + 24 >> 2] | 0;
  if ((i2 | 0) != -2147483648) {
   i23 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
   i24 = (HEAP32[i1 + 16 >> 2] | 0) + (i23 >>> 5 << 2) | 0;
   HEAP32[i24 >> 2] = HEAP32[i24 >> 2] & ~(1 << (i23 & 31));
  }
  __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i3, i15, i16 + 96 | 0);
  i1 = __ZN14MessageHandler3GetEv() | 0;
  i2 = HEAP32[gb + 111552 + 24 >> 2] | 0;
  if ((i2 | 0) != -2147483648) {
   i23 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
   i24 = (HEAP32[i1 + 16 >> 2] | 0) + (i23 >>> 5 << 2) | 0;
   HEAP32[i24 >> 2] = 1 << (i23 & 31) | HEAP32[i24 >> 2];
  }
 }
 i24 = i13;
 STACKTOP = i17;
 return i24 | 0;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i31, i32, i1) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i30 + 56 | 0;
 i26 = i30 + 40 | 0;
 i27 = i30 + 20 | 0;
 i28 = i30;
 i29 = i31 + 16 | 0;
 i1 = HEAP32[i29 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i24 = i31 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i29, i25, 4);
  i1 = HEAP32[i25 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i25 >> 2] = i1;
  HEAP32[i29 >> 2] = i2;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 i8 = i27 + 4 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = i32 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i32, HEAP32[i9 >> 2] | 0);
 i10 = i32 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i32 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 if ((i7 | 0) <= 0) {
  STACKTOP = i30;
  return;
 }
 i11 = i28 + 4 | 0;
 i12 = i8 + 11 | 0;
 i13 = i27 + 8 | 0;
 i14 = i28 + 16 | 0;
 i6 = i28 + 16 | 0;
 i15 = i25 + 4 | 0;
 i16 = i28 + 12 | 0;
 i17 = i28 + 8 | 0;
 i18 = i9;
 i19 = i32 + 4 | 0;
 i20 = i28 + 4 | 0;
 i21 = i20 + 11 | 0;
 i22 = i25 + 4 | 0;
 i23 = i11 + 11 | 0;
 i5 = 0;
 do {
  i1 = HEAP32[i29 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i24 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i29, i25, 4);
   i1 = HEAP32[i25 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i25 >> 2] = i1;
   HEAP32[i29 >> 2] = i2;
  }
  HEAP32[i27 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i31, i8, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i31);
  HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
  i3 = HEAP8[i12 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  i3 = i1 ? HEAP32[i13 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i14 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = 15;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i23 >> 0] = i3;
   if (!i3) i1 = i11; else {
    i1 = i11;
    i4 = 17;
   }
  } else i4 = 15;
  if ((i4 | 0) == 15) {
   i33 = i3 + 16 & -16;
   HEAP32[i25 >> 2] = 66;
   HEAP32[i15 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i33, 16, i25, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i16 >> 2] = i33 | -2147483648;
   HEAP32[i17 >> 2] = i3;
   i4 = 17;
  }
  if ((i4 | 0) == 17) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if (!i1) {
   HEAP32[i25 >> 2] = i9;
   i2 = i18;
   i3 = i9;
  } else {
   i4 = HEAP32[i28 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 22;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i4 = 27;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 26;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 22) {
    i4 = 0;
    HEAP32[i25 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 26) {
    i4 = 0;
    HEAP32[i25 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 27) {
    i4 = 0;
    HEAP32[i25 >> 2] = i1;
    i2 = i1;
    i3 = i25;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i26, i32, i28);
   i1 = HEAP32[i26 >> 2] | 0;
   HEAP32[i26 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i32 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 >> 2] | 0, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  if ((HEAP8[i21 >> 0] | 0) < 0) {
   i33 = HEAP32[i20 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i25 >> 2] = 66;
   HEAP32[i22 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i33, i25);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 if ((HEAP8[i27 + 4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i30;
  return;
 }
 i33 = HEAP32[i27 + 4 >> 2] | 0;
 i32 = HEAP32[i27 + 16 >> 2] | 0;
 HEAP32[i25 >> 2] = 66;
 HEAP32[i25 + 4 >> 2] = i32;
 __Z19free_alloc_internalPvRK10MemLabelId(i33, i25);
 STACKTOP = i30;
 return;
}

function _jpeg_idct_islow(i1, i2, i3, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i7 = HEAP32[i1 + 288 >> 2] | 0;
 i6 = i8;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i2 = 8;
 while (1) {
  i4 = HEAP16[i3 + 16 >> 1] | 0;
  i1 = HEAP16[i3 + 32 >> 1] | 0;
  if (!((i4 | i1) << 16 >> 16)) if (!(HEAP16[i3 + 48 >> 1] | 0)) if (!(HEAP16[i3 + 64 >> 1] | 0)) if (!(HEAP16[i3 + 80 >> 1] | 0)) if (!(HEAP16[i3 + 96 >> 1] | 0)) if (!(HEAP16[i3 + 112 >> 1] | 0)) {
   i4 = Math_imul(HEAP32[i5 >> 2] << 2, HEAP16[i3 >> 1] | 0) | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 32 >> 2] = i4;
   HEAP32[i6 + 64 >> 2] = i4;
   HEAP32[i6 + 96 >> 2] = i4;
   HEAP32[i6 + 128 >> 2] = i4;
   HEAP32[i6 + 160 >> 2] = i4;
   HEAP32[i6 + 192 >> 2] = i4;
   HEAP32[i6 + 224 >> 2] = i4;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else i11 = 9;
  if ((i11 | 0) == 9) {
   i11 = 0;
   i1 = Math_imul(i1 << 16 >> 16, HEAP32[i5 + 64 >> 2] | 0) | 0;
   i15 = Math_imul(HEAP16[i3 + 96 >> 1] | 0, HEAP32[i5 + 192 >> 2] | 0) | 0;
   i23 = (i15 + i1 | 0) * 4433 | 0;
   i15 = i23 + (Math_imul(i15, -15137) | 0) | 0;
   i1 = i23 + (i1 * 6270 | 0) | 0;
   i23 = Math_imul(HEAP16[i3 >> 1] | 0, HEAP32[i5 >> 2] | 0) | 0;
   i16 = Math_imul(HEAP16[i3 + 64 >> 1] | 0, HEAP32[i5 + 128 >> 2] | 0) | 0;
   i13 = i16 + i23 << 13;
   i16 = i23 - i16 << 13;
   i23 = Math_imul(HEAP16[i3 + 112 >> 1] | 0, HEAP32[i5 + 224 >> 2] | 0) | 0;
   i14 = Math_imul(HEAP16[i3 + 80 >> 1] | 0, HEAP32[i5 + 160 >> 2] | 0) | 0;
   i21 = Math_imul(HEAP16[i3 + 48 >> 1] | 0, HEAP32[i5 + 96 >> 2] | 0) | 0;
   i19 = Math_imul(i4 << 16 >> 16, HEAP32[i5 + 32 >> 2] | 0) | 0;
   i17 = i21 + i23 | 0;
   i18 = i19 + i14 | 0;
   i4 = (i18 + i17 | 0) * 9633 | 0;
   i20 = Math_imul(i19 + i23 | 0, -7373) | 0;
   i22 = Math_imul(i21 + i14 | 0, -20995) | 0;
   i17 = i4 + (Math_imul(i17, -16069) | 0) | 0;
   i18 = i4 + (Math_imul(i18, -3196) | 0) | 0;
   i4 = i20 + (i23 * 2446 | 0) + i17 | 0;
   i14 = i22 + (i14 * 16819 | 0) + i18 | 0;
   i17 = i22 + (i21 * 25172 | 0) + i17 | 0;
   i18 = i20 + (i19 * 12299 | 0) + i18 | 0;
   i19 = i13 + i1 + 1024 | 0;
   HEAP32[i6 >> 2] = i19 + i18 >> 11;
   HEAP32[i6 + 224 >> 2] = i19 - i18 >> 11;
   i18 = i16 + i15 + 1024 | 0;
   HEAP32[i6 + 32 >> 2] = i18 + i17 >> 11;
   HEAP32[i6 + 192 >> 2] = i18 - i17 >> 11;
   i15 = i16 - i15 + 1024 | 0;
   HEAP32[i6 + 64 >> 2] = i15 + i14 >> 11;
   HEAP32[i6 + 160 >> 2] = i15 - i14 >> 11;
   i1 = i13 - i1 + 1024 | 0;
   HEAP32[i6 + 96 >> 2] = i1 + i4 >> 11;
   HEAP32[i6 + 128 >> 2] = i1 - i4 >> 11;
  }
  if ((i2 | 0) > 1) {
   i6 = i6 + 4 | 0;
   i5 = i5 + 4 | 0;
   i3 = i3 + 2 | 0;
   i2 = i2 + -1 | 0;
  } else break;
 }
 i6 = i7 + 128 | 0;
 i5 = 0;
 i2 = i8;
 while (1) {
  i3 = (HEAP32[i9 + (i5 << 2) >> 2] | 0) + i10 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!(i4 | i1)) if (!(HEAP32[i2 + 12 >> 2] | 0)) if (!(HEAP32[i2 + 16 >> 2] | 0)) if (!(HEAP32[i2 + 20 >> 2] | 0)) if (!(HEAP32[i2 + 24 >> 2] | 0)) if (!(HEAP32[i2 + 28 >> 2] | 0)) {
   i23 = HEAP8[i6 + (((HEAP32[i2 >> 2] | 0) + 16 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 >> 0] = i23;
   _memset(i3 + 1 | 0, i23 | 0, 7) | 0;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else i11 = 19;
  if ((i11 | 0) == 19) {
   i11 = 0;
   i19 = HEAP32[i2 + 24 >> 2] | 0;
   i22 = (i19 + i1 | 0) * 4433 | 0;
   i19 = i22 + (Math_imul(i19, -15137) | 0) | 0;
   i22 = i22 + (i1 * 6270 | 0) | 0;
   i23 = HEAP32[i2 >> 2] | 0;
   i18 = HEAP32[i2 + 16 >> 2] | 0;
   i21 = i18 + i23 << 13;
   i18 = i23 - i18 << 13;
   i23 = HEAP32[i2 + 28 >> 2] | 0;
   i20 = HEAP32[i2 + 20 >> 2] | 0;
   i14 = HEAP32[i2 + 12 >> 2] | 0;
   i17 = i14 + i23 | 0;
   i16 = i4 + i20 | 0;
   i8 = (i16 + i17 | 0) * 9633 | 0;
   i15 = Math_imul(i4 + i23 | 0, -7373) | 0;
   i13 = Math_imul(i14 + i20 | 0, -20995) | 0;
   i17 = i8 + (Math_imul(i17, -16069) | 0) | 0;
   i16 = i8 + (Math_imul(i16, -3196) | 0) | 0;
   i23 = i15 + (i23 * 2446 | 0) + i17 | 0;
   i20 = i13 + (i20 * 16819 | 0) + i16 | 0;
   i17 = i13 + (i14 * 25172 | 0) + i17 | 0;
   i16 = i15 + (i4 * 12299 | 0) + i16 | 0;
   i15 = i21 + i22 + 131072 | 0;
   HEAP8[i3 >> 0] = HEAP8[i6 + ((i15 + i16 | 0) >>> 18 & 1023) >> 0] | 0;
   HEAP8[i3 + 7 >> 0] = HEAP8[i6 + ((i15 - i16 | 0) >>> 18 & 1023) >> 0] | 0;
   i16 = i18 + i19 + 131072 | 0;
   HEAP8[i3 + 1 >> 0] = HEAP8[i6 + ((i16 + i17 | 0) >>> 18 & 1023) >> 0] | 0;
   HEAP8[i3 + 6 >> 0] = HEAP8[i6 + ((i16 - i17 | 0) >>> 18 & 1023) >> 0] | 0;
   i19 = i18 - i19 + 131072 | 0;
   HEAP8[i3 + 2 >> 0] = HEAP8[i6 + ((i19 + i20 | 0) >>> 18 & 1023) >> 0] | 0;
   HEAP8[i3 + 5 >> 0] = HEAP8[i6 + ((i19 - i20 | 0) >>> 18 & 1023) >> 0] | 0;
   i22 = i21 - i22 + 131072 | 0;
   HEAP8[i3 + 3 >> 0] = HEAP8[i6 + ((i22 + i23 | 0) >>> 18 & 1023) >> 0] | 0;
   HEAP8[i3 + 4 >> 0] = HEAP8[i6 + ((i22 - i23 | 0) >>> 18 & 1023) >> 0] | 0;
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 8) break; else i2 = i2 + 32 | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN5Umbra18ImpCameraTransform6updateEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i32 + 128 | 0;
 i22 = i32 + 64 | 0;
 i24 = i32;
 if (!(HEAP8[i19 + 436 >> 0] | 0)) {
  STACKTOP = i32;
  return;
 }
 i31 = HEAP32[i19 + 340 >> 2] | 0;
 HEAP32[i20 >> 2] = i31;
 i9 = HEAP32[i19 + 344 >> 2] | 0;
 i3 = i20 + 4 | 0;
 HEAP32[i3 >> 2] = i9;
 i2 = HEAP32[i19 + 348 >> 2] | 0;
 i4 = i20 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i7 = HEAP32[i19 + 352 >> 2] | 0;
 i21 = i20 + 12 | 0;
 HEAP32[i21 >> 2] = i7;
 i10 = HEAP32[i19 + 356 >> 2] | 0;
 HEAP32[i20 + 16 >> 2] = i10;
 i23 = HEAP32[i19 + 360 >> 2] | 0;
 HEAP32[i20 + 20 >> 2] = i23;
 i1 = HEAP32[i19 + 364 >> 2] | 0;
 HEAP32[i20 + 24 >> 2] = i1;
 i15 = HEAP32[i19 + 368 >> 2] | 0;
 HEAP32[i20 + 28 >> 2] = i15;
 i17 = HEAP32[i19 + 372 >> 2] | 0;
 HEAP32[i20 + 32 >> 2] = i17;
 i18 = HEAP32[i19 + 376 >> 2] | 0;
 HEAP32[i20 + 36 >> 2] = i18;
 i25 = HEAP32[i19 + 380 >> 2] | 0;
 HEAP32[i20 + 40 >> 2] = i25;
 i5 = HEAP32[i19 + 384 >> 2] | 0;
 i26 = i20 + 44 | 0;
 HEAP32[i26 >> 2] = i5;
 i8 = HEAP32[i19 + 388 >> 2] | 0;
 i27 = i20 + 48 | 0;
 HEAP32[i27 >> 2] = i8;
 i16 = HEAP32[i19 + 392 >> 2] | 0;
 i28 = i20 + 52 | 0;
 HEAP32[i28 >> 2] = i16;
 i6 = HEAP32[i19 + 396 >> 2] | 0;
 i29 = i20 + 56 | 0;
 HEAP32[i29 >> 2] = i6;
 i30 = i20 + 60 | 0;
 HEAP32[i30 >> 2] = HEAP32[i19 + 400 >> 2];
 if (!(HEAP32[i19 + 432 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i10;
  HEAP32[i20 + 16 >> 2] = i9;
  HEAP32[i4 >> 2] = i17;
  HEAP32[i20 + 32 >> 2] = i2;
  HEAP32[i21 >> 2] = i8;
  HEAP32[i20 + 48 >> 2] = i7;
  HEAP32[i20 + 24 >> 2] = i18;
  HEAP32[i20 + 36 >> 2] = i1;
  i11 = i20 + 28 | 0;
  HEAP32[i11 >> 2] = i16;
  HEAP32[i20 + 52 >> 2] = i15;
  i12 = i20 + 44 | 0;
  HEAP32[i12 >> 2] = i6;
  HEAP32[i20 + 56 >> 2] = i5;
  i13 = i10;
  i14 = i17;
  i6 = i8;
  i4 = i9;
  i5 = i18;
  i3 = i16;
 } else {
  i11 = i20 + 28 | 0;
  i12 = i20 + 44 | 0;
  i13 = i9;
  i14 = i2;
  i6 = i7;
  i4 = i10;
  i5 = i1;
  i3 = i15;
  i2 = i17;
  i1 = i18;
 }
 f44 = Math_fround(HEAPF32[i19 + 420 >> 2]);
 f36 = Math_fround(f44 * Math_fround(2.0));
 f42 = Math_fround(HEAPF32[i19 + 408 >> 2]);
 f41 = Math_fround(HEAPF32[i19 + 404 >> 2]);
 f37 = Math_fround(f42 - f41);
 f38 = Math_fround(f36 / f37);
 f40 = Math_fround(HEAPF32[i19 + 412 >> 2]);
 f39 = Math_fround(HEAPF32[i19 + 416 >> 2]);
 f35 = Math_fround(f40 - f39);
 f36 = Math_fround(f36 / f35);
 f43 = Math_fround(HEAPF32[i19 + 424 >> 2]);
 f33 = Math_fround(f43 - f44);
 f34 = Math_fround(f43 / f33);
 f33 = Math_fround(Math_fround(-Math_fround(f44 * f43)) / f33);
 f37 = Math_fround(Math_fround(f42 + f41) / f37);
 f35 = Math_fround(Math_fround(f40 + f39) / f35);
 HEAPF32[i22 >> 2] = f38;
 HEAPF32[i22 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 8 >> 2] = f37;
 HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 20 >> 2] = f36;
 HEAPF32[i22 + 24 >> 2] = f35;
 HEAPF32[i22 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 40 >> 2] = f34;
 HEAPF32[i22 + 44 >> 2] = f33;
 HEAPF32[i22 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i22 + 60 >> 2] = Math_fround(0.0);
 HEAP32[i24 >> 2] = i31;
 i8 = i24 + 4 | 0;
 HEAP32[i8 >> 2] = i13;
 i9 = i24 + 8 | 0;
 HEAP32[i9 >> 2] = i14;
 i10 = i24 + 12 | 0;
 HEAP32[i10 >> 2] = i6;
 i13 = i24 + 16 | 0;
 HEAP32[i13 >> 2] = i4;
 i14 = i24 + 20 | 0;
 HEAP32[i14 >> 2] = i23;
 i15 = i24 + 24 | 0;
 HEAP32[i15 >> 2] = i5;
 i16 = i24 + 28 | 0;
 HEAP32[i16 >> 2] = i3;
 i17 = i24 + 32 | 0;
 HEAP32[i17 >> 2] = i2;
 i18 = i24 + 36 | 0;
 HEAP32[i18 >> 2] = i1;
 i23 = i24 + 40 | 0;
 HEAP32[i23 >> 2] = i25;
 i25 = i24 + 44 | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 i26 = i24 + 48 | 0;
 HEAP32[i26 >> 2] = HEAP32[i27 >> 2];
 i27 = i24 + 52 | 0;
 HEAP32[i27 >> 2] = HEAP32[i28 >> 2];
 i28 = i24 + 56 | 0;
 HEAP32[i28 >> 2] = HEAP32[i29 >> 2];
 i31 = i24 + 60 | 0;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 __ZN5Umbra9Matrix4x4mLERKS0_(i24, i22) | 0;
 HEAP32[i19 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i19 + 32 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i19 + 36 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i19 + 40 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i19 + 44 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i19 + 48 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i19 + 52 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i19 + 56 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i19 + 60 >> 2] = HEAP32[i31 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i20, i20) | 0;
 i30 = HEAP32[i11 >> 2] | 0;
 i31 = HEAP32[i12 >> 2] | 0;
 HEAP32[i19 + 320 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 324 >> 2] = i30;
 HEAP32[i19 + 328 >> 2] = i31;
 STACKTOP = i32;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i28, i29, i1) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i27 + 56 | 0;
 i25 = i27 + 28 | 0;
 i26 = i27;
 i1 = i28 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i28 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i24, 4);
  i1 = HEAP32[i24 >> 2] | 0;
 } else {
  i23 = HEAP32[i2 >> 2] | 0;
  HEAP32[i24 >> 2] = i23;
  HEAP32[i1 >> 2] = i3;
  i1 = i23;
 }
 i10 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 24 >> 2] = 0;
 HEAP32[i25 + 16 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 i11 = i29 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i29, HEAP32[i11 >> 2] | 0);
 i12 = i29 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i29 >> 2] = i11;
 HEAP32[i11 >> 2] = 0;
 if ((i10 | 0) <= 0) {
  STACKTOP = i27;
  return;
 }
 i13 = i25 + 11 | 0;
 i14 = i25 + 4 | 0;
 i15 = i26 + 12 | 0;
 i9 = i26 + 12 | 0;
 i16 = i24 + 4 | 0;
 i17 = i26 + 8 | 0;
 i18 = i26 + 4 | 0;
 i19 = i26 + 16 | 0;
 i20 = i25 + 16 | 0;
 i21 = i29 + 4 | 0;
 i22 = i26 + 11 | 0;
 i23 = i24 + 4 | 0;
 i8 = 0;
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEEEvRT_PKc17TransferMetaFlags(i28, i25, gb + 1041891 | 0, 0);
  i3 = HEAP8[i13 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i25 >> 2] | 0 : i25;
  i3 = i1 ? HEAP32[i14 >> 2] | 0 : i3 & 255;
  HEAP32[i26 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i15 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i26);
   i1 = HEAP32[i9 >> 2] | 0;
   i4 = 12;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i22 >> 0] = i3;
   if (!i3) i1 = i26; else {
    i1 = i26;
    i4 = 14;
   }
  } else i4 = 12;
  if ((i4 | 0) == 12) {
   i7 = i3 + 16 & -16;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i16 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i26 >> 2] = i1;
   HEAP32[i17 >> 2] = i7 | -2147483648;
   HEAP32[i18 >> 2] = i3;
   i4 = 14;
  }
  if ((i4 | 0) == 14) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i1 = HEAP32[i11 >> 2] | 0;
  do if (!i1) {
   i2 = i11;
   i3 = i11;
  } else {
   i6 = HEAP8[i22 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i6 = i7 ? HEAP32[i18 >> 2] | 0 : i6 & 255;
   i7 = i7 ? HEAP32[i26 >> 2] | 0 : i26;
   while (1) {
    i3 = i1 + 16 | 0;
    i5 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
    i2 = i5 >>> 0 < i6 >>> 0 ? i5 : i6;
    if (!i2) i4 = 19; else {
     i2 = _memcmp(i7, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
     if (!i2) i4 = 19; else if ((i2 | 0) < 0) i4 = 21; else i4 = 23;
    }
    if ((i4 | 0) == 19) if (i6 >>> 0 < i5 >>> 0) i4 = 21; else i4 = 23;
    if ((i4 | 0) == 21) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 22;
      break;
     } else i1 = i2;
    } else if ((i4 | 0) == 23) {
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 25;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 22) {
    i4 = 0;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 25) {
    i4 = 0;
    i2 = i1;
    break;
   }
  } while (0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i24, i29, i26);
  i1 = HEAP32[i24 >> 2] | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i29 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i29 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i1);
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  if ((HEAP8[i22 >> 0] | 0) < 0) {
   i7 = HEAP32[i26 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i23 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i24);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i10 | 0));
 if ((HEAP8[i13 >> 0] | 0) >= 0) {
  STACKTOP = i27;
  return;
 }
 i29 = HEAP32[i25 >> 2] | 0;
 i28 = HEAP32[i25 + 12 >> 2] | 0;
 HEAP32[i24 >> 2] = 66;
 HEAP32[i24 + 4 >> 2] = i28;
 __Z19free_alloc_internalPvRK10MemLabelId(i29, i24);
 STACKTOP = i27;
 return;
}

function __Z28AddGenericCurveToClipBuilderR17AnimationCurveTplIfERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilderb(i8, i13, i14, i2) {
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 8 | 0;
 i6 = i15;
 f10 = Math_fround(HEAPF32[i14 + 1084 >> 2]);
 i1 = i8 + 68 | 0;
 L1 : do if (!(HEAP32[i1 >> 2] | 0)) i12 = -1; else {
  __ZNK17AnimationCurveTplIfE8GetRangeEv(i5, i8);
  if ((HEAP32[i5 >> 2] & 2139095040 | 0) == 2139095040) {
   i12 = -1;
   break;
  }
  __ZNK17AnimationCurveTplIfE8GetRangeEv(i6, i8);
  if ((HEAP32[i6 + 4 >> 2] & 2139095040 | 0) == 2139095040) i12 = -1; else {
   i3 = i8 + 56 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   if ((i7 | 0) > 0) {
    f16 = Math_fround(f9 - f9);
    i12 = f16 < Math_fround(0.0);
    f17 = Math_fround(-f16);
    L8 : do if ((i12 ? f17 : f16) <= Math_fround(9.99999997e-07)) {
     i1 = 0;
     do {
      f17 = Math_fround(HEAPF32[i4 + (i1 << 4) + 8 >> 2]);
      i12 = f17 < Math_fround(0.0);
      f16 = Math_fround(-f17);
      if (!((i12 ? f16 : f17) <= Math_fround(9.99999997e-07))) break L8;
      f17 = Math_fround(HEAPF32[i4 + (i1 << 4) + 12 >> 2]);
      i12 = f17 < Math_fround(0.0);
      f16 = Math_fround(-f17);
      i1 = i1 + 1 | 0;
      if (!((i12 ? f16 : f17) <= Math_fround(9.99999997e-07))) break L8;
      if ((i1 | 0) >= (i7 | 0)) {
       i12 = 2;
       break L1;
      }
      f17 = Math_fround(Math_fround(HEAPF32[i4 + (i1 << 4) + 4 >> 2]) - f9);
      i12 = f17 < Math_fround(0.0);
      f16 = Math_fround(-f17);
     } while ((i12 ? f16 : f17) <= Math_fround(9.99999997e-07));
    } while (0);
    if (i2) i12 = 0; else {
     f9 = Math_fround(Math_fround(1.0) / f10);
     L16 : do if ((HEAP32[i4 + 8 >> 2] & 2139095040 | 0) != 2139095040) if ((HEAP32[i4 + 12 >> 2] & 2139095040 | 0) != 2139095040) {
      __ZNK17AnimationCurveTplIfE8GetRangeEv(i5, i8);
      f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
      __ZNK17AnimationCurveTplIfE8GetRangeEv(i6, i8);
      if (!(Math_fround((i7 * 28 | 0) >>> 0) < Math_fround(Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i6 >> 2])) / f9) * Math_fround(4.0)))) {
       if ((i7 | 0) > 1) {
        i2 = HEAP32[i3 >> 2] | 0;
        i1 = 1;
        do {
         if ((HEAP32[i2 + (i1 << 4) + 8 >> 2] & 2139095040 | 0) == 2139095040) break L16;
         if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] & 2139095040 | 0) == 2139095040) break L16;
         f17 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
         if (Math_fround(Math_fround(Math_abs(Math_fround(f17 - Math_fround(HEAPF32[i2 + (i1 + -1 << 4) >> 2])))) - f9) < Math_fround(-.000500000024)) break L16;
         i1 = i1 + 1 | 0;
        } while ((i1 | 0) < (i7 | 0));
       }
       i12 = 1;
       break L1;
      }
     } while (0);
     i12 = 0;
    }
   } else i12 = 2;
  }
 } while (0);
 if ((HEAP16[i13 + 12 >> 1] | 0) == 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 913573 | 0, 0, gb + 913410 | 0, 452, 512, 0, 0, 0);
  STACKTOP = i15;
  return;
 }
 if ((i12 | 0) == -1) {
  STACKTOP = i15;
  return;
 }
 i11 = i14 + 620 + (i12 * 148 | 0) + 80 | 0;
 i2 = i8;
 i3 = i14 + 620 + (i12 * 148 | 0) + 92 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i14 + 620 + (i12 * 148 | 0) + 96 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i14 + 620 + (i12 * 148 | 0) + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 620 + (i12 * 148 | 0) + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i2 = i14 + 620 + (i12 * 148 | 0) + 128 | 0;
 i3 = i14 + 620 + (i12 * 148 | 0) + 140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i14 + 620 + (i12 * 148 | 0) + 144 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i14 + 620 + (i12 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i14 + 620 + (i12 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i14 = (HEAP32[i2 >> 2] | 0) + (i4 << 4) | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i14, i22, i6) {
 i14 = i14 | 0;
 i22 = i22 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i25 = i14 + 36 | 0;
 i26 = i14 + 40 | 0;
 HEAP32[i26 >> 2] = 32;
 i8 = i14 + 52 | 0;
 HEAP32[i8 >> 2] = 16;
 i9 = i14 + 48 | 0;
 HEAP32[i9 >> 2] = 6;
 i10 = i14 + 56 | 0;
 HEAP8[i10 >> 0] = 0;
 i4 = __Znwj(384) | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 if (!i1) i1 = 32; else {
  __ZdlPv(i1);
  i1 = HEAP32[i26 >> 2] | 0;
 }
 HEAP32[i25 >> 2] = i4;
 i2 = i4 + (i1 * 12 | 0) | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i3 = i14 + 24 | 0;
  i1 = i4;
  do {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i23 = i14 + 44 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i24 = i22 + 4 | 0;
 f5 = Math_fround(((HEAP32[i22 + 44 >> 2] | 0) - (HEAP32[i24 >> 2] | 0) | 0) >>> 0);
 i7 = 32;
 while (1) {
  if (i7 >>> 0 >= i6 >>> 0) {
   f12 = Math_fround(i7 >>> 0);
   f13 = Math_fround(f12 * Math_fround(.5));
   if (!(f5 >= f13)) break;
  }
  i7 = i7 << 1;
 }
 i2 = HEAP32[i26 >> 2] | 0;
 if (i7 >>> 0 > i2 >>> 0) {
  i4 = __Znwj(i7 * 12 | 0) | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i3 = i1 + (i2 * 12 | 0) | 0;
  if (!i2) i1 = 0; else {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 12 | 0;
   }
   i1 = HEAP32[i26 >> 2] | 0;
  }
  i2 = i4 + (i7 * 12 | 0) | 0;
  if ((i1 | 0) != (i7 | 0)) {
   i3 = i14 + 24 | 0;
   i1 = i4 + (i1 * 12 | 0) | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  __ZdlPv(HEAP32[i25 >> 2] | 0);
  HEAP32[i25 >> 2] = i4;
  HEAP32[i26 >> 2] = i7;
  HEAP32[i8 >> 2] = ~~f13 >>> 0;
  HEAP32[i9 >> 2] = ~~Math_fround(f12 * Math_fround(.200000003)) >>> 0;
  HEAP8[i10 >> 0] = 0;
  i2 = i7;
 }
 i19 = i22 + 36 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 40 | 0;
 i18 = HEAP32[i20 >> 2] | 0;
 i21 = i1 + (i18 * 12 | 0) | 0;
 L28 : do if (i18) {
  i7 = HEAP32[i22 + 24 >> 2] | 0;
  i8 = HEAP32[i22 + 28 >> 2] | 0;
  i9 = i22 + 8 | 0;
  i10 = i22 + 12 | 0;
  i11 = i22 + 16 | 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i7 | 0) == (i3 | 0)) {
    if ((i8 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i27 = 22;
   } else i27 = 22;
   do if ((i27 | 0) == 22) {
    i27 = 0;
    if ((i8 | 0) == (i3 | 0)) if ((i7 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
    if (!(HEAP8[i9 >> 0] | 0)) break L28;
    if (!(HEAP32[i24 >> 2] | 0)) break L28;
    i4 = HEAP32[i10 >> 2] | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    if ((i4 | 0) == (i3 | 0)) if ((i6 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
    if ((i6 | 0) != (i3 | 0)) break L28;
    if ((i4 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L28;
   } while (0);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i21 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i21 | 0)) return;
 i18 = i14 + 24 | 0;
 i11 = i14 + 28 | 0;
 i14 = i22 + 24 | 0;
 i15 = i22 + 28 | 0;
 i16 = i22 + 8 | 0;
 i17 = i22 + 12 | 0;
 i10 = i22 + 16 | 0;
 while (1) {
  i9 = i2 + -1 | 0;
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i22 = _bitshift64Shl(i3 | 0, 0, 16) | 0;
  getTempRet0() | 0 | i3;
  i6 = HEAP32[i25 >> 2] | 0;
  i7 = HEAP32[i18 >> 2] | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  i4 = 0;
  i2 = (i2 | 0) < (i3 | 0) ? i2 << 16 | i3 : i22 | i2;
  while (1) {
   i2 = i2 & i9;
   i3 = HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0;
   if ((i7 | 0) == (i3 | 0)) if ((i8 | 0) == (HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0)) break;
   if ((i8 | 0) == (i3 | 0)) if ((i7 | 0) == (HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0)) break;
   i22 = i4 + 1 | 0;
   i4 = i22;
   i2 = i22 + i2 | 0;
  }
  i22 = i6 + (i2 * 12 | 0) | 0;
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
  i1 = i1 + 12 | 0;
  L62 : do if ((i1 | 0) == (i21 | 0)) i1 = i21; else {
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     if ((i7 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i27 = 46;
    } else i27 = 46;
    do if ((i27 | 0) == 46) {
     i27 = 0;
     if ((i7 | 0) == (i2 | 0)) if ((i6 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
     if (!(HEAP8[i16 >> 0] | 0)) break L62;
     if (!(HEAP32[i24 >> 2] | 0)) break L62;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (i2 | 0)) if ((i4 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) break;
     if ((i4 | 0) != (i2 | 0)) break L62;
     if ((i3 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L62;
    } while (0);
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i21 | 0)) {
     i1 = i21;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i19 >> 2] | 0) + ((HEAP32[i20 >> 2] | 0) * 12 | 0) | 0)) break;
  i2 = HEAP32[i26 >> 2] | 0;
 }
 return;
}

function __Z13UpdateMoveJobP9CrowdInfoj(i27, i28) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i30 + 4 | 0;
 i25 = i30;
 i29 = i27 + (i28 << 4) | 0;
 i21 = HEAP32[i27 + 256 + (i28 << 2) >> 2] | 0;
 if ((HEAP16[gb + 1459356 + 6 >> 1] | 0) > -1) {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459356 | 0, i24);
  i16 = gb + 1459356 | 0;
 } else i16 = 0;
 i26 = i27 + (i28 << 4) + 12 | 0;
 i22 = HEAP32[i26 >> 2] | 0;
 if ((i22 | 0) > 0) {
  i17 = i27 + (i28 << 4) + 8 | 0;
  i18 = i27 + 332 | 0;
  i15 = 0;
  do {
   i19 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i15 << 2) >> 2] | 0;
   i20 = HEAP32[i29 >> 2] | 0;
   i1 = i20 + (i19 * 608 | 0) + 601 | 0;
   if ((HEAP8[i1 >> 0] | 0) == 2) HEAPF32[i20 + (i19 * 608 | 0) + 552 >> 2] = Math_fround(inf); else {
    i7 = i20 + (i19 * 608 | 0) | 0;
    i12 = i20 + (i19 * 608 | 0) + 480 | 0;
    __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i7, i12, i21, (HEAP32[i18 >> 2] | 0) + (i19 * 132 | 0) | 0);
    i3 = HEAP32[i7 >> 2] | 0;
    HEAP32[i12 >> 2] = i3;
    i4 = HEAP32[i20 + (i19 * 608 | 0) + 4 >> 2] | 0;
    i13 = i20 + (i19 * 608 | 0) + 484 | 0;
    HEAP32[i13 >> 2] = i4;
    i5 = HEAP32[i20 + (i19 * 608 | 0) + 8 >> 2] | 0;
    i14 = i20 + (i19 * 608 | 0) + 488 | 0;
    HEAP32[i14 >> 2] = i5;
    if (!(HEAP8[i1 >> 0] | 0)) {
     i6 = i20 + (i19 * 608 | 0) + 32 | 0;
     i2 = HEAP32[i20 + (i19 * 608 | 0) + 28 >> 2] | 0;
     if (!(HEAP32[i6 >> 2] | 0)) {
      i1 = HEAP32[(HEAP32[i20 + (i19 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
      i23 = 13;
     } else {
      i31 = i2;
      i1 = HEAP32[(HEAP32[i20 + (i19 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
      if ((HEAP32[i31 >> 2] | 0) == 0 & (HEAP32[i31 + 4 >> 2] | 0) == 0) i23 = 13; else {
       HEAP32[i20 + (i19 * 608 | 0) + 12 >> 2] = i3;
       HEAP32[i20 + (i19 * 608 | 0) + 16 >> 2] = i4;
       HEAP32[i20 + (i19 * 608 | 0) + 20 >> 2] = i5;
       i2 = 1;
      }
     }
     if ((i23 | 0) == 13) {
      i23 = 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      i2 = 0;
     }
     HEAP32[i6 >> 2] = 1;
     HEAP8[i20 + (i19 * 608 | 0) + 44 >> 0] = i2;
     HEAP32[i20 + (i19 * 608 | 0) + 48 >> 2] = i1;
    }
    i2 = i20 + (i19 * 608 | 0) + 476 | 0;
    __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i7, i20 + (i19 * 608 | 0) + 424 | 0, i20 + (i19 * 608 | 0) + 472 | 0, i20 + (i19 * 608 | 0) + 392 | 0, i2, 4, i21) | 0;
    i2 = HEAP32[i2 >> 2] | 0;
    if (!i2) if ((HEAP32[i20 + (i19 * 608 | 0) + 32 >> 2] | 0) == 1) {
     f10 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 12 >> 2]);
     f10 = Math_fround(f10 - Math_fround(HEAPF32[i12 >> 2]));
     f11 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 16 >> 2]);
     f11 = Math_fround(f11 - Math_fround(HEAPF32[i13 >> 2]));
     f8 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 20 >> 2]);
     f8 = Math_fround(f8 - Math_fround(HEAPF32[i14 >> 2]));
     f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f8 * f8))));
    } else f8 = Math_fround(inf); else if (!(HEAP8[i2 + -1 + (i20 + (i19 * 608 | 0) + 472) >> 0] & 2)) f8 = Math_fround(inf); else if ((i2 | 0) > 0) {
     f10 = Math_fround(HEAPF32[i12 >> 2]);
     f11 = Math_fround(HEAPF32[i13 >> 2]);
     f8 = Math_fround(0.0);
     i1 = 0;
     f9 = Math_fround(HEAPF32[i14 >> 2]);
     do {
      i31 = i20 + (i19 * 608 | 0) + 424 + (i1 * 3 << 2) | 0;
      f34 = f10;
      f10 = Math_fround(HEAPF32[i31 >> 2]);
      f34 = Math_fround(f34 - f10);
      f33 = f11;
      f11 = Math_fround(HEAPF32[i31 + 4 >> 2]);
      f33 = Math_fround(f33 - f11);
      f32 = f9;
      f9 = Math_fround(HEAPF32[i31 + 8 >> 2]);
      f32 = Math_fround(f32 - f9);
      f8 = Math_fround(f8 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f33 * f33)) + Math_fround(f32 * f32)))));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    } else f8 = Math_fround(0.0);
    HEAPF32[i20 + (i19 * 608 | 0) + 552 >> 2] = f8;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i22 | 0));
 }
 if (i16 | 0) __Z12profiler_endP19ProfilerInformation(i16);
 i7 = i27 + 320 | 0;
 if (!(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0)) {
  STACKTOP = i30;
  return;
 }
 if ((HEAP16[gb + 1459440 + 6 >> 1] | 0) > -1) {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459440 | 0, i24);
  i6 = gb + 1459440 | 0;
 } else i6 = 0;
 i5 = HEAP32[i26 >> 2] | 0;
 if ((i5 | 0) > 0) {
  i2 = i27 + (i28 << 4) + 8 | 0;
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i4 = HEAP32[i29 >> 2] | 0;
   if ((HEAP8[i4 + (i3 * 608 | 0) + 601 >> 0] | 0) != 2) __ZNK15HeightMeshQuery17SetPositionHeightEPf(HEAP32[i7 >> 2] | 0, i4 + (i3 * 608 | 0) + 480 | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 if (!i6) {
  STACKTOP = i30;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i30;
 return;
}

function ___lgamma_r(d1, i4) {
 d1 = +d1;
 i4 = i4 | 0;
 var d2 = 0.0, d3 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, d11 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i6 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 i7 = i5 & 2147483647;
 do if (i7 >>> 0 > 2146435071) d1 = d1 * d1; else {
  i9 = (i5 | 0) < 0;
  if (i7 >>> 0 < 999292928) {
   if (i9) {
    HEAP32[i4 >> 2] = -1;
    d1 = -d1;
   }
   d1 = -+Math_log(+d1);
   break;
  }
  if (i9) {
   d3 = -d1;
   d2 = d1 * -.5;
   d2 = (d2 - +Math_floor(+d2)) * 2.0;
   i10 = (~~(d2 * 4.0) + 1 | 0) / 2 | 0;
   d2 = (d2 - +Math_fround(Math_fround(i10 | 0) * Math_fround(.5))) * 3.141592653589793;
   switch (i10 | 0) {
   case 3:
    {
     d2 = -+___cos(d2, 0.0);
     break;
    }
   case 1:
    {
     d2 = +___cos(d2, 0.0);
     break;
    }
   case 2:
    {
     d2 = +___sin(-d2, 0.0, 0);
     break;
    }
   default:
    d2 = +___sin(d2, 0.0, 0);
   }
   if (d2 == 0.0) {
    d1 = 1.0 / (d1 - d1);
    break;
   }
   if (d2 > 0.0) {
    HEAP32[i4 >> 2] = -1;
    d1 = d2;
   } else d1 = -d2;
   d8 = +Math_log(+(3.141592653589793 / (d1 * d3)));
   d1 = d3;
  } else d8 = 0.0;
  L26 : do if ((i5 | 0) < 1072693248) if ((i5 | 0) < -1073741824) switch (i5 | 0) {
  case -1074790400:
   {
    i4 = 20;
    break L26;
   }
  default:
   {
    i4 = 21;
    break L26;
   }
  } else switch (i5 | 0) {
  case -1073741824:
   {
    i4 = 20;
    break L26;
   }
  default:
   {
    i4 = 21;
    break L26;
   }
  } else if ((i5 | 0) < 1073741824) switch (i5 | 0) {
  case 1072693248:
   {
    i4 = 20;
    break L26;
   }
  default:
   {
    i4 = 21;
    break L26;
   }
  } else switch (i5 | 0) {
  case 1073741824:
   {
    i4 = 20;
    break L26;
   }
  default:
   {
    i4 = 21;
    break L26;
   }
  } while (0);
  if ((i4 | 0) == 20) if (!i6) d1 = 0.0; else i4 = 21;
  L37 : do if ((i4 | 0) == 21) if (i7 >>> 0 < 1073741824) {
   do if (i7 >>> 0 < 1072483533) {
    d2 = -+Math_log(+d1);
    if (i7 >>> 0 > 1072130371) {
     d3 = 1.0;
     i4 = 29;
    } else if (i7 >>> 0 > 1070442080) {
     d1 = d1 + -.46163214496836225;
     i4 = 30;
    } else i4 = 31;
   } else if (i7 >>> 0 > 1073460418) {
    d2 = 0.0;
    d3 = 2.0;
    i4 = 29;
   } else if (i7 >>> 0 > 1072936131) {
    d2 = 0.0;
    d1 = d1 + -1.4616321449683622;
    i4 = 30;
    break;
   } else {
    d2 = 0.0;
    d1 = d1 + -1.0;
    i4 = 31;
    break;
   } while (0);
   if ((i4 | 0) == 29) {
    d1 = d3 - d1;
    d3 = d1 * d1;
    d1 = d2 + (d1 * (d3 * (d3 * (d3 * (d3 * (d3 * 2.5214456545125733e-05 + 2.2086279071390839e-04) + 1.1927076318336207e-03) + .007385550860814029) + .06735230105312927) + .07721566490153287) + d3 * (d3 * (d3 * (d3 * (d3 * (d3 * 4.4864094961891516e-05 + 1.0801156724758394e-04) + 5.100697921535113e-04) + 2.8905138367341563e-03) + .020580808432516733) + .3224670334241136) - d1 * .5);
    break;
   } else if ((i4 | 0) == 30) {
    d11 = d1 * d1;
    d3 = d1 * d11;
    d1 = d2 + (d11 * (d3 * (d3 * (d3 * (d3 * 3.1563207090362595e-04 + -1.4034646998923284e-03) + .006100538702462913) + -.032788541075985965) + .48383612272381005) - (-3.638676997039505e-18 - d3 * (d3 * (d3 * (d3 * (.000881081882437654 - d3 * 3.1275416837512086e-04) + -3.6845201678113826e-03) + .01797067508118204) + -.1475877229945939 + d1 * (d3 * (d3 * (d3 * (d3 * 3.355291926355191e-04 + -5.385953053567405e-04) + 2.2596478090061247e-03) + -.010314224129834144) + .06462494023913339))) + -.12148629053584961);
    break;
   } else if ((i4 | 0) == 31) {
    d1 = d2 + (d1 * (d1 * (d1 * (d1 * (d1 * (d1 * .013381091853678766 + .22896372806469245) + .9777175279633727) + 1.4549225013723477) + .6328270640250934) + -.07721566490153287) / (d1 * (d1 * (d1 * (d1 * (d1 * .003217092422824239 + .10422264559336913) + .7692851504566728) + 2.128489763798934) + 2.4559779371304113) + 1.0) - d1 * .5);
    break;
   }
  } else {
   if (i7 >>> 0 >= 1075838976) {
    d2 = +Math_log(+d1);
    if (i7 >>> 0 < 1133510656) {
     d3 = 1.0 / d1;
     d11 = d3 * d3;
     d1 = d3 * (d11 * (d11 * (d11 * (d11 * (8.363399189962821e-04 - d11 * 1.6309293409657527e-03) + -.00059518755745034) + 7.936505586430196e-04) + -2.7777777772877554e-03) + .08333333333333297) + .4189385332046727 + (d1 + -.5) * (d2 + -1.0);
     break;
    } else {
     d1 = d1 * (d2 + -1.0);
     break;
    }
   }
   i10 = ~~d1;
   d3 = d1 - +(i10 | 0);
   d1 = d3 * .5 + d3 * (d3 * (d3 * (d3 * (d3 * (d3 * (d3 * 3.194753265841009e-05 + 1.8402845140733772e-03) + .02664227030336386) + .14635047265246445) + .325778796408931) + .21498241596060885) + -.07721566490153287) / (d3 * (d3 * (d3 * (d3 * (d3 * (d3 * 7.326684307446256e-06 + 7.779424963818936e-04) + .01864591917156529) + .17193386563280308) + .7219355475671381) + 1.3920053346762105) + 1.0);
   switch (i10 | 0) {
   case 7:
    {
     d2 = d3 + 6.0;
     i4 = 35;
     break;
    }
   case 6:
    {
     d2 = 1.0;
     i4 = 35;
     break;
    }
   case 5:
    {
     d2 = 1.0;
     i4 = 36;
     break;
    }
   case 4:
    {
     d2 = 1.0;
     i4 = 37;
     break;
    }
   case 3:
    {
     d2 = 1.0;
     break;
    }
   default:
    break L37;
   }
   if ((i4 | 0) == 35) {
    d2 = (d3 + 5.0) * d2;
    i4 = 36;
   }
   if ((i4 | 0) == 36) {
    d2 = (d3 + 4.0) * d2;
    i4 = 37;
   }
   if ((i4 | 0) == 37) d2 = (d3 + 3.0) * d2;
   d1 = d1 + +Math_log(+((d3 + 2.0) * d2));
   break;
  } while (0);
  d1 = i9 ? d8 - d1 : d1;
 } while (0);
 return +d1;
}

function __ZN13TriggerModule8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i2 = 0;
 do {
  i3 = i6 + 28 + (i2 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, HEAP32[gb + 82920 + (i2 << 2) >> 2] | 0, gb + 619781 | 0, i7, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i3, i9); else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i9);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 i4 = i6 + 8 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619755 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 7; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 7; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619762 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619770 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619776 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 40; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 619975 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 51; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 51; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z23CreateSparseTextureGLES9TextureIDiiN2gl9TexFormatEi(i18, i6, i13, i14, i15, i7) {
 i18 = i18 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 24 | 0;
 i9 = i19;
 i16 = i19 + 20 | 0;
 i17 = i19 + 16 | 0;
 i10 = i19 + 12 | 0;
 i5 = i18;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = 1;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[gb + 1451152 + 4 >> 2] | 0;
 if (i4 | 0) {
  i3 = gb + 1451152 + 4 | 0;
  i2 = i4;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (gb + 1451152 + 4 | 0)) if (i5 >>> 0 >= (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[gb + 1451152 >> 2] | 0) == (i3 | 0)) HEAP32[gb + 1451152 >> 2] = i1;
   HEAP32[gb + 1451152 + 8 >> 2] = (HEAP32[gb + 1451152 + 8 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i4, i3);
   __ZdlPv(i3);
  }
 }
 i4 = HEAP32[gb + 1451080 >> 2] | 0;
 HEAP32[i9 >> 2] = i5;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i12, i1, i9);
  i2 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 20; else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) i11 = 20;
 }
 if ((i11 | 0) == 20) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 17) | 0;
  HEAP32[i1 >> 2] = 0;
  i11 = i1 + 8 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 2;
  HEAP32[i1 + 20 >> 2] = 3;
  HEAP32[i1 + 24 >> 2] = 1;
  HEAP32[i1 + 28 >> 2] = 1;
  HEAP32[i1 + 32 >> 2] = 1;
  HEAP32[i1 + 36 >> 2] = 1;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i12, i1);
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(i4, 2) | 0;
  HEAP32[i1 + 16 >> 2] = 2;
 }
 HEAP32[i1 + 20 >> 2] = i15;
 HEAP32[i1 + 24 >> 2] = i13;
 HEAP32[i1 + 28 >> 2] = i14;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = i7;
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = i8;
 i11 = __Z16GetRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 176 >> 2] | 0, i11 | 0, 2, 1, i9 | 0);
 HEAP32[i16 >> 2] = 1;
 HEAP32[i17 >> 2] = 1;
 HEAP32[i10 >> 2] = 0;
 if (!(__ZN7ApiGLES19CreateSparseTextureEj16TextureDimensionN2gl9TexFormatEiiiiRiS3_S3_(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i1 >> 2] | 0, 2, i15, i7, i13, i14, 1, i16, i17, i10) | 0)) {
  STACKTOP = i19;
  return;
 }
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[gb + 1451152 + 4 >> 2] | 0;
 do if (!i3) {
  HEAP32[i12 >> 2] = gb + 1451152 + 4;
  i6 = gb + 1451152 + 4 | 0;
  i4 = gb + 1451152 + 4 | 0;
 } else {
  while (1) {
   i4 = HEAP32[i3 + 16 >> 2] | 0;
   if (i8 >>> 0 < i4 >>> 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) {
     i11 = 27;
     break;
    } else i3 = i4;
   } else {
    if (i4 >>> 0 >= i8 >>> 0) {
     i11 = 32;
     break;
    }
    i5 = i3 + 4 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    if (!i4) {
     i11 = 31;
     break;
    } else i3 = i4;
   }
  }
  if ((i11 | 0) == 27) {
   HEAP32[i12 >> 2] = i3;
   i6 = i3;
   i4 = i3;
   break;
  } else if ((i11 | 0) == 31) {
   HEAP32[i12 >> 2] = i3;
   i6 = i3;
   i4 = i5;
   break;
  } else if ((i11 | 0) == 32) {
   HEAP32[i12 >> 2] = i3;
   i6 = i3;
   i4 = i12;
   break;
  }
 } while (0);
 if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = __Znwj(44) | 0;
  HEAP32[i3 + 16 >> 2] = i8;
  HEAP32[i3 + 20 >> 2] = i13;
  HEAP32[i3 + 24 >> 2] = i14;
  HEAP32[i3 + 28 >> 2] = i2;
  HEAP32[i3 + 32 >> 2] = i1;
  HEAP32[i3 + 36 >> 2] = i7;
  HEAP32[i3 + 40 >> 2] = i15;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = i6;
  HEAP32[i4 >> 2] = i3;
  i1 = HEAP32[HEAP32[gb + 1451152 >> 2] >> 2] | 0;
  if (!i1) i1 = i3; else {
   HEAP32[gb + 1451152 >> 2] = i1;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[gb + 1451152 + 4 >> 2] | 0, i1);
  HEAP32[gb + 1451152 + 8 >> 2] = (HEAP32[gb + 1451152 + 8 >> 2] | 0) + 1;
  i2 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i17 >> 2] | 0;
 }
 HEAP32[i18 >> 2] = i2;
 HEAP32[i18 + 4 >> 2] = i1;
 STACKTOP = i19;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i11 = i15 + 20 | 0;
 i10 = i15;
 i4 = i15 + 16 | 0;
 i5 = i15 + 12 | 0;
 i13 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = (HEAP32[i13 >> 2] | 0) - i2 >> 5;
 i1 = i2;
 if (i3 >>> 0 >= i7 >>> 0) {
  if (i3 >>> 0 <= i7 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i5 = i1 + (i7 << 5) | 0;
  HEAP32[i11 >> 2] = 0;
  i8 = i11 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i2 = i7 << 5;
  i3 = i2 >> 5;
  if (!i3) {
   i4 = i11 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i4 = __Znwj(i2) | 0;
   HEAP32[i8 >> 2] = i4;
   HEAP32[i11 >> 2] = i4;
   i2 = i4 + (i3 << 5) | 0;
   i6 = i11 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i7) {
    i4 = i6;
    i5 = i3;
   } else {
    i3 = i4;
    do {
     __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i3, i1);
     i1 = i1 + 32 | 0;
     i3 = (HEAP32[i8 >> 2] | 0) + 32 | 0;
     HEAP32[i8 >> 2] = i3;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i5;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i13 >> 2] = i3;
  i6 = i12 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i2;
  i6 = i1;
  i2 = i10;
  if (i1 | 0) {
   if ((i2 | 0) != (i6 | 0)) {
    i4 = i14 + 4 | 0;
    i5 = i14 + 4 | 0;
    do {
     i1 = i2 + -32 | 0;
     HEAP32[i8 >> 2] = i1;
     i3 = i2 + -16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i13 = HEAP32[i3 >> 2] | 0;
      i12 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i4 >> 2] = i12;
      __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
     }
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i13 = HEAP32[i1 >> 2] | 0;
      i12 = HEAP32[i2 + -20 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i5 >> 2] = i12;
      __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
     }
     i2 = HEAP32[i8 >> 2] | 0;
    } while ((i2 | 0) != (i6 | 0));
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
 i8 = i12 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i2 >> 5 | 0) == (i7 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE8__appendEj(i12, i7 - i3 | 0);
  STACKTOP = i15;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE7reserveEj(i10, i7);
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i11, i14);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = i2 - i3 >> 5;
 i6 = i2;
 if (i1 >>> 0 < i7 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE8__appendEj(i10, i7 - i1 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 } else if (i1 >>> 0 > i7 >>> 0) {
  i7 = i3 + (i7 << 5) | 0;
  if ((i6 | 0) != (i7 | 0)) {
   i4 = i14 + 4 | 0;
   i5 = i14 + 4 | 0;
   i2 = i6;
   do {
    i1 = i2 + -32 | 0;
    HEAP32[i9 >> 2] = i1;
    i3 = i2 + -16 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i11 = HEAP32[i3 >> 2] | 0;
     i6 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i4 >> 2] = i6;
     __Z19free_alloc_internalPvRK10MemLabelId(i11, i14);
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i11 = HEAP32[i1 >> 2] | 0;
     i6 = HEAP32[i2 + -20 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i5 >> 2] = i6;
     __Z19free_alloc_internalPvRK10MemLabelId(i11, i14);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i7 | 0));
  }
 }
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i6;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i6;
 i6 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i6 | 0)) {
   i4 = i14 + 4 | 0;
   i5 = i14 + 4 | 0;
   do {
    i1 = i2 + -32 | 0;
    HEAP32[i9 >> 2] = i1;
    i3 = i2 + -16 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i13 = HEAP32[i3 >> 2] | 0;
     i12 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i4 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i13 = HEAP32[i1 >> 2] | 0;
     i12 = HEAP32[i2 + -20 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i5 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i6 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __ZN5physx24updateCollDataStaticMeshERNS_19PxsParticleCollDataERKNS_11PxTransformEf(i11, i3, f1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i2 = HEAP32[i11 + 124 >> 2] | 0;
 if (!(i2 & 56)) return;
 if (i2 & 8 | 0) {
  f4 = Math_fround(Math_fround(HEAPF32[i11 + 144 >> 2]) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(HEAPF32[i11 + 148 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i11 + 152 >> 2]) * Math_fround(2.0));
  f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
  f1 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(f4 * f1);
  f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f12 * f5));
  f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f9 = Math_fround(f9 + Math_fround(f15 * f6));
  f7 = Math_fround(Math_fround(f1 * f9) + Math_fround(Math_fround(f4 * f14) + Math_fround(f13 * Math_fround(Math_fround(f15 * f5) - Math_fround(f12 * f6)))));
  f8 = Math_fround(Math_fround(f5 * f9) + Math_fround(Math_fround(f12 * f14) + Math_fround(f13 * Math_fround(Math_fround(f4 * f6) - Math_fround(f15 * f1)))));
  f9 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * Math_fround(Math_fround(f12 * f1) - Math_fround(f4 * f5)))) + Math_fround(f6 * f9));
  i10 = i11 + 12 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -4 | 2;
  HEAPF32[i11 >> 2] = f7;
  HEAPF32[i11 + 4 >> 2] = f8;
  HEAPF32[i11 + 8 >> 2] = f9;
  HEAP32[i11 + 16 >> 2] = HEAP32[i11 + 48 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i11 + 52 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i11 + 56 >> 2];
  i10 = i11 + 60 | 0;
  HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 0 | 2;
 }
 if (!(i2 & 16)) return;
 i10 = i11 + 172 | 0;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 if (f4 < Math_fround(3.0)) {
  i2 = Math_fround(f4 + Math_fround(-1.5)) >= Math_fround(0.0);
  f1 = i2 ? Math_fround(.5) : Math_fround(1.0);
 } else f1 = Math_fround(Math_fround(1.0) / f4);
 f18 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 144 >> 2]));
 f8 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 148 >> 2]));
 f9 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 152 >> 2]));
 f13 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 160 >> 2]));
 f17 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 164 >> 2]));
 f20 = Math_fround(f1 * Math_fround(HEAPF32[i11 + 168 >> 2]));
 f1 = Math_fround(f18 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f1 * f12);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f8 * f14));
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * f15));
 f5 = Math_fround(f4 * Math_fround(Math_fround(f12 * f7) + Math_fround(Math_fround(f1 * f19) + Math_fround(f18 * Math_fround(Math_fround(f9 * f14) - Math_fround(f8 * f15))))));
 f6 = Math_fround(f4 * Math_fround(Math_fround(f14 * f7) + Math_fround(Math_fround(f8 * f19) + Math_fround(f18 * Math_fround(Math_fround(f1 * f15) - Math_fround(f9 * f12))))));
 f7 = Math_fround(f4 * Math_fround(Math_fround(Math_fround(f9 * f19) + Math_fround(f18 * Math_fround(Math_fround(f8 * f12) - Math_fround(f1 * f14)))) + Math_fround(f15 * f7)));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(f17 * Math_fround(2.0));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f1 = Math_fround(Math_fround(Math_fround(f13 * f12) + Math_fround(f17 * f14)) + Math_fround(f20 * f15));
 f8 = Math_fround(Math_fround(f12 * f1) + Math_fround(Math_fround(f13 * f19) + Math_fround(f18 * Math_fround(Math_fround(f20 * f14) - Math_fround(f17 * f15)))));
 f9 = Math_fround(Math_fround(f14 * f1) + Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f20 * f12)))));
 f1 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * Math_fround(Math_fround(f17 * f12) - Math_fround(f13 * f14)))) + Math_fround(f15 * f1));
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
 f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
 f8 = Math_fround(f4 * f8);
 f9 = Math_fround(f4 * f9);
 f1 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f1));
 i2 = i11 + 12 | 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i3 = i16 | 1;
 HEAP32[i2 >> 2] = i3;
 if (!(i16 & 4)) {
  HEAPF32[i11 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i11 >> 2]));
  i16 = i11 + 4 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i16 >> 2]));
  i16 = i11 + 8 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i16 >> 2]));
 } else {
  HEAPF32[i11 >> 2] = f5;
  HEAPF32[i11 + 4 >> 2] = f6;
  HEAPF32[i11 + 8 >> 2] = f7;
  HEAP32[i2 >> 2] = i3 & -5;
 }
 i16 = i11 + 16 | 0;
 HEAPF32[i16 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i16 >> 2]));
 i16 = i11 + 20 | 0;
 HEAPF32[i16 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i16 >> 2]));
 i16 = i11 + 24 | 0;
 HEAPF32[i16 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i16 >> 2]));
 f20 = Math_fround(HEAPF32[i10 >> 2]);
 i16 = i11 + 28 | 0;
 HEAPF32[i16 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2]));
 i16 = i11 + 60 | 0;
 HEAP16[i16 >> 1] = HEAPU16[i16 >> 1] | 0 | 2;
 return;
}

function __ZN21EnlightenSceneMapping8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402495 | 0, i9, i1, 0);
 HEAP32[i6 >> 2] = 0;
 i10 = i6 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 402814 | 0, i6, 0);
 __ZN28EnlightenRendererInformation8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402507 | 0, i9, i1 + 20 | 0, 0);
 i10 = i6 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 402687 | 0, i6, 0);
 __ZN26EnlightenSystemInformation8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402517 | 0, i9, i1 + 40 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 455698 | 0, i6, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402529 | 0, i9, i1 + 80 | 0, 0);
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 402635 | 0, i6, 0);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402667 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402677 | 0, gb + 455698 | 0, i10, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402595 | 0, i7, i6 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402545 | 0, i9, i1 + 100 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 402561 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402595 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402609 | 0, i7, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402622 | 0, i7, i6 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function runPostSets231() {
 HEAP32[gb + 210016 >> 2] = fb + 1432;
 HEAP32[gb + 210020 >> 2] = fb + 1433;
 HEAP32[gb + 210024 >> 2] = fb + 1434;
 HEAP32[gb + 210028 >> 2] = fb + 1435;
 HEAP32[gb + 210032 >> 2] = fb + 1436;
 HEAP32[gb + 11344 >> 2] = (HEAP32[gb + 11344 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11348 >> 2] = (HEAP32[gb + 11348 >> 2] | 0) + (gb + 1078891 | 0);
 HEAP32[gb + 11360 >> 2] = (HEAP32[gb + 11360 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11368 >> 2] = (HEAP32[gb + 11368 >> 2] | 0) + (gb + 11328 | 0);
 HEAP32[gb + 11376 >> 2] = (HEAP32[gb + 11376 >> 2] | 0) + (gb + 11384 | 0);
 HEAP32[gb + 11384 >> 2] = (HEAP32[gb + 11384 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11388 >> 2] = (HEAP32[gb + 11388 >> 2] | 0) + (gb + 1078960 | 0);
 HEAP32[gb + 211320 >> 2] = (HEAP32[gb + 211320 >> 2] | 0) + (gb + 11392 | 0);
 HEAP32[gb + 211324 >> 2] = fb + 3083;
 HEAP32[gb + 211328 >> 2] = fb + 3084;
 HEAP32[gb + 211332 >> 2] = fb + 3068;
 HEAP32[gb + 211336 >> 2] = fb + 1437;
 HEAP32[gb + 211340 >> 2] = fb + 118;
 HEAP32[gb + 211344 >> 2] = fb + 119;
 HEAP32[gb + 211348 >> 2] = fb + 120;
 HEAP32[gb + 211352 >> 2] = fb + 121;
 HEAP32[gb + 211356 >> 2] = fb + 122;
 HEAP32[gb + 211360 >> 2] = fb + 20;
 HEAP32[gb + 211364 >> 2] = fb + 1438;
 HEAP32[gb + 211368 >> 2] = fb + 1439;
 HEAP32[gb + 211372 >> 2] = fb + 1440;
 HEAP32[gb + 211376 >> 2] = fb + 1441;
 HEAP32[gb + 211380 >> 2] = fb + 1442;
 HEAP32[gb + 211384 >> 2] = fb + 1443;
 HEAP32[gb + 211388 >> 2] = fb + 1444;
 HEAP32[gb + 211396 >> 2] = (HEAP32[gb + 211396 >> 2] | 0) + (gb + 11392 | 0);
 HEAP32[gb + 211400 >> 2] = fb + 1445;
 HEAP32[gb + 211404 >> 2] = fb + 1446;
 HEAP32[gb + 211408 >> 2] = fb + 1447;
 HEAP32[gb + 211412 >> 2] = fb + 1448;
 HEAP32[gb + 211416 >> 2] = fb + 1449;
 HEAP32[gb + 211420 >> 2] = fb + 1450;
 HEAP32[gb + 211424 >> 2] = fb + 1451;
 HEAP32[gb + 11392 >> 2] = (HEAP32[gb + 11392 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11396 >> 2] = (HEAP32[gb + 11396 >> 2] | 0) + (gb + 1078994 | 0);
 HEAP32[gb + 11408 >> 2] = (HEAP32[gb + 11408 >> 2] | 0) + (gb + 11288 | 0);
 HEAP32[gb + 11416 >> 2] = (HEAP32[gb + 11416 >> 2] | 0) + (gb + 11424 | 0);
 HEAP32[gb + 11424 >> 2] = (HEAP32[gb + 11424 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11428 >> 2] = (HEAP32[gb + 11428 >> 2] | 0) + (gb + 1079071 | 0);
 HEAP32[gb + 11432 >> 2] = (HEAP32[gb + 11432 >> 2] | 0) + (gb + 11440 | 0);
 HEAP32[gb + 11440 >> 2] = (HEAP32[gb + 11440 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11444 >> 2] = (HEAP32[gb + 11444 >> 2] | 0) + (gb + 1079103 | 0);
 HEAP32[gb + 211432 >> 2] = (HEAP32[gb + 211432 >> 2] | 0) + (gb + 11448 | 0);
 HEAP32[gb + 211436 >> 2] = fb + 3085;
 HEAP32[gb + 211440 >> 2] = fb + 3086;
 HEAP32[gb + 211444 >> 2] = fb + 3068;
 HEAP32[gb + 211448 >> 2] = fb + 1452;
 HEAP32[gb + 211452 >> 2] = fb + 123;
 HEAP32[gb + 211456 >> 2] = fb + 124;
 HEAP32[gb + 211460 >> 2] = fb + 125;
 HEAP32[gb + 211464 >> 2] = fb + 126;
 HEAP32[gb + 211468 >> 2] = fb + 127;
 HEAP32[gb + 211472 >> 2] = fb + 21;
 HEAP32[gb + 211476 >> 2] = fb + 1453;
 HEAP32[gb + 211480 >> 2] = fb + 1454;
 HEAP32[gb + 211484 >> 2] = fb + 1455;
 HEAP32[gb + 211488 >> 2] = fb + 1456;
 HEAP32[gb + 211492 >> 2] = fb + 1457;
 HEAP32[gb + 211496 >> 2] = fb + 1458;
 HEAP32[gb + 211500 >> 2] = fb + 1459;
 HEAP32[gb + 211508 >> 2] = (HEAP32[gb + 211508 >> 2] | 0) + (gb + 11448 | 0);
 HEAP32[gb + 211512 >> 2] = fb + 1460;
 HEAP32[gb + 211516 >> 2] = fb + 1461;
 HEAP32[gb + 211520 >> 2] = fb + 1462;
 HEAP32[gb + 211524 >> 2] = fb + 1463;
 HEAP32[gb + 211528 >> 2] = fb + 1464;
 HEAP32[gb + 211532 >> 2] = fb + 1465;
 HEAP32[gb + 211536 >> 2] = fb + 1466;
 HEAP32[gb + 11448 >> 2] = (HEAP32[gb + 11448 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11452 >> 2] = (HEAP32[gb + 11452 >> 2] | 0) + (gb + 1079124 | 0);
 HEAP32[gb + 11464 >> 2] = (HEAP32[gb + 11464 >> 2] | 0) + (gb + 11344 | 0);
 HEAP32[gb + 11472 >> 2] = (HEAP32[gb + 11472 >> 2] | 0) + (gb + 11480 | 0);
 HEAP32[gb + 11480 >> 2] = (HEAP32[gb + 11480 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11484 >> 2] = (HEAP32[gb + 11484 >> 2] | 0) + (gb + 1079201 | 0);
 HEAP32[gb + 11488 >> 2] = (HEAP32[gb + 11488 >> 2] | 0) + (gb + 11440 | 0);
 HEAP32[gb + 211544 >> 2] = (HEAP32[gb + 211544 >> 2] | 0) + (gb + 11496 | 0);
 HEAP32[gb + 211548 >> 2] = fb + 3087;
 HEAP32[gb + 211552 >> 2] = fb + 3088;
 HEAP32[gb + 211556 >> 2] = fb + 3068;
 HEAP32[gb + 211560 >> 2] = fb + 77;
 HEAP32[gb + 11496 >> 2] = (HEAP32[gb + 11496 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11500 >> 2] = (HEAP32[gb + 11500 >> 2] | 0) + (gb + 1079233 | 0);
 HEAP32[gb + 11512 >> 2] = (HEAP32[gb + 11512 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11520 >> 2] = (HEAP32[gb + 11520 >> 2] | 0) + (gb + 11528 | 0);
 HEAP32[gb + 11528 >> 2] = (HEAP32[gb + 11528 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11532 >> 2] = (HEAP32[gb + 11532 >> 2] | 0) + (gb + 1079302 | 0);
 HEAP32[gb + 211568 >> 2] = (HEAP32[gb + 211568 >> 2] | 0) + (gb + 11536 | 0);
 HEAP32[gb + 211572 >> 2] = fb + 3089;
 HEAP32[gb + 211576 >> 2] = fb + 3090;
 HEAP32[gb + 211580 >> 2] = fb + 3068;
 HEAP32[gb + 211584 >> 2] = fb + 78;
 HEAP32[gb + 11536 >> 2] = (HEAP32[gb + 11536 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11540 >> 2] = (HEAP32[gb + 11540 >> 2] | 0) + (gb + 1079344 | 0);
 HEAP32[gb + 11552 >> 2] = (HEAP32[gb + 11552 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11560 >> 2] = (HEAP32[gb + 11560 >> 2] | 0) + (gb + 11528 | 0);
 runPostSets232();
}

function __ZN26AnimatorControllerPlayable13GetParametersEv(i21, i1) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 36 | 0;
 i24 = i27;
 HEAP32[i21 >> 2] = 0;
 i25 = i21 + 4 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i27;
  return;
 }
 i22 = i1 + 92 | 0;
 i20 = (HEAP32[i22 >> 2] | 0) + 16 | 0;
 __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE7reserveEj(i21, HEAP32[i20 + (HEAP32[i20 >> 2] | 0) >> 2] | 0);
 i20 = (HEAP32[i22 >> 2] | 0) + 16 | 0;
 if (!(HEAP32[i20 + (HEAP32[i20 >> 2] | 0) >> 2] | 0)) {
  STACKTOP = i27;
  return;
 }
 i7 = i1 + 84 | 0;
 i8 = i23 + 11 | 0;
 i9 = i23 + 4 | 0;
 i10 = i24 + 11 | 0;
 i11 = i24 + 8 | 0;
 i12 = i24 + 4 | 0;
 i13 = i24 + 16 | 0;
 i14 = i21 + 8 | 0;
 i15 = i24 + 12 | 0;
 i16 = i23 + 4 | 0;
 i17 = i23 + 4 | 0;
 i18 = i24 + 20 | 0;
 i19 = i24 + 24 | 0;
 i20 = i24 + 28 | 0;
 i6 = 0;
 do {
  __ZN27AnimatorControllerParameterC2Ev(i24);
  i1 = (HEAP32[i22 >> 2] | 0) + 16 | 0;
  i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) {
   HEAP32[i23 >> 2] = 0;
   HEAP32[i23 + 4 >> 2] = 0;
   HEAP32[i23 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i23, gb + 1576256 | 0, 0);
  } else mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i23 | 0, i2 | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + i1 + (i6 * 12 | 0) >> 2] | 0);
  i5 = HEAP8[i8 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i4 = i1 ? HEAP32[i23 >> 2] | 0 : i23;
  i5 = i1 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
  i1 = HEAP8[i10 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i11 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i5 >>> 0 > i3 >>> 0) {
   i2 = i2 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i24, i3, i5 - i3 | 0, i2, 0, i2, i5, i4);
  } else {
   i1 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i10 >> 0] | 0) < 0) {
    HEAP32[i12 >> 2] = i5;
    break;
   } else {
    HEAP8[i10 >> 0] = i5;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
  i1 = HEAP32[i22 >> 2] | 0;
  i2 = i1 + 16 | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) + 4 | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
  i5 = HEAP32[i2 + (i6 * 12 | 0) + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = i5;
  switch (i5 | 0) {
  case 1:
   {
    i5 = i1 + 20 | 0;
    i5 = i5 + (HEAP32[i5 >> 2] | 0) + 28 | 0;
    HEAP32[i18 >> 2] = HEAP32[i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i2 + (i6 * 12 | 0) + 8 >> 2] << 2) >> 2];
    break;
   }
  case 3:
   {
    i5 = i1 + 20 | 0;
    i5 = i5 + (HEAP32[i5 >> 2] | 0) + 36 | 0;
    HEAP32[i19 >> 2] = HEAP32[i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i2 + (i6 * 12 | 0) + 8 >> 2] << 2) >> 2];
    break;
   }
  case 4:
   {
    i5 = i1 + 20 | 0;
    i5 = i5 + (HEAP32[i5 >> 2] | 0) + 44 | 0;
    HEAP8[i20 >> 0] = HEAP8[i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i2 + (i6 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0;
    break;
   }
  default:
   {}
  }
  i3 = HEAP32[i25 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i14 >> 2] | 0)) __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i21, i24); else {
   i4 = HEAP8[i10 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i24 >> 2] | 0 : i24;
   i4 = i1 ? HEAP32[i12 >> 2] | 0 : i4 & 255;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i3 + 12 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    i26 = 24;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i3 + 11 >> 0] = i4;
    if (!i4) i1 = i3; else {
     i1 = i3;
     i26 = 26;
    }
   } else i26 = 24;
   if ((i26 | 0) == 24) {
    i5 = i4 + 16 & -16;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i17 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i3 + 8 >> 2] = i5 | -2147483648;
    HEAP32[i3 + 4 >> 2] = i4;
    i26 = 26;
   }
   if ((i26 | 0) == 26) {
    i26 = 0;
    _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   i5 = i3 + 16 | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
   HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + 36;
  }
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i5 = HEAP32[i24 >> 2] | 0;
   i4 = HEAP32[i15 >> 2] | 0;
   HEAP32[i23 >> 2] = 66;
   HEAP32[i16 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i23);
  }
  i6 = i6 + 1 | 0;
  i5 = (HEAP32[i22 >> 2] | 0) + 16 | 0;
 } while (i6 >>> 0 < (HEAP32[i5 + (HEAP32[i5 >> 2] | 0) >> 2] | 0) >>> 0);
 STACKTOP = i27;
 return;
}

function __ZN5physx6shdfnd4sortINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS3_25SortCUDAProfileOccurencesENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i14, i3, i13, i1, i5) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i16 = i17 + 24 | 0;
 i2 = i5 << 2;
 i11 = i2 >>> 0 > 1024;
 i15 = i16 + 4 | 0;
 HEAP8[i15 >> 0] = i11 & 1;
 if (i11) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i17 + 32 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i16 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i16 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i6 = 0;
  i4 = 0;
  i11 = i5;
  L7 : while (1) {
   i10 = i6;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i9 = i4;
      i4 = i4 + 1 | 0;
      i8 = i4;
      i5 = i9;
      while (1) {
       i6 = HEAP16[i14 + (i8 * 24 | 0) >> 1] | 0;
       i7 = HEAP16[i14 + (i5 * 24 | 0) >> 1] | 0;
       if ((i6 & 65535) < (i7 & 65535)) i6 = 1; else {
        i18 = i14 + (i5 * 24 | 0) + 8 | 0;
        i20 = HEAP32[i18 + 4 >> 2] | 0;
        i19 = i14 + (i8 * 24 | 0) + 8 | 0;
        i21 = HEAP32[i19 + 4 >> 2] | 0;
        i6 = i6 << 16 >> 16 == i7 << 16 >> 16 & (i21 >>> 0 < i20 >>> 0 | ((i21 | 0) == (i20 | 0) ? (HEAP32[i19 >> 2] | 0) >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0 : 0));
       }
       i5 = i6 ? i8 : i5;
       if ((i8 | 0) < (i3 | 0)) i8 = i8 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i9 | 0)) {
       i20 = i14 + (i5 * 24 | 0) | 0;
       i21 = i14 + (i9 * 24 | 0) | 0;
       HEAP32[i12 >> 2] = HEAP32[i20 >> 2];
       HEAP32[i12 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
       HEAP32[i12 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
       HEAP32[i12 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
       HEAP32[i12 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
       HEAP32[i12 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
       HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
       HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
       HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
       HEAP32[i20 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
       HEAP32[i20 + 16 >> 2] = HEAP32[i21 + 16 >> 2];
       HEAP32[i20 + 20 >> 2] = HEAP32[i21 + 20 >> 2];
       HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
       HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
       HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
       HEAP32[i21 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
       HEAP32[i21 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i10) break L7;
    i4 = i10 + -2 | 0;
    i3 = HEAP32[i1 + (i10 + -1 << 2) >> 2] | 0;
    i10 = i4;
    i4 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   }
   i8 = __ZN5physx6shdfnd8internal9partitionINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceEKNS4_25SortCUDAProfileOccurencesEEEiPT_iiRT0_(i14, i4, i3, i13) | 0;
   if ((i8 - i4 | 0) < (i3 - i8 | 0)) {
    i7 = i8 + -1 | 0;
    if (i10 >>> 0 < (i11 + -1 | 0) >>> 0) i5 = i11; else {
     i5 = i11 << 3;
     if (!i5) i6 = 0; else {
      i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i20 = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i20 | 0, i21 | 0, i5 | 0, (i6 ? gb + 659991 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i10 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i11 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i10 << 2) >> 2] = i4;
    HEAP32[i1 + (i10 + 1 << 2) >> 2] = i7;
    i4 = i8 + 1 | 0;
   } else {
    i6 = i8 + 1 | 0;
    if (i10 >>> 0 < (i11 + -1 | 0) >>> 0) i5 = i11; else {
     i5 = i11 << 3;
     if (!i5) i5 = 0; else {
      i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i19 = HEAP32[(HEAP32[i20 >> 2] | 0) + 8 >> 2] | 0;
      i21 = _PxGetFoundation() | 0;
      i21 = mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 24 >> 2] | 0, i21 | 0) | 0;
      i5 = mftCall_iiiiii(i19 | 0, i20 | 0, i5 | 0, (i21 ? gb + 659991 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i10 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i11 << 1;
    }
    HEAP32[i1 + (i10 << 2) >> 2] = i6;
    HEAP32[i1 + (i10 + 1 << 2) >> 2] = i3;
    i3 = i8 + -1 | 0;
   }
   i6 = i10 + 2 | 0;
   i11 = i5;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i17;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i17;
 return;
}

function __ZN22ParticleSystemRenderer16UpdateCachedMeshEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i14 = i17;
 i15 = i12 + 404 | 0;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 i11 = 0;
 i1 = 0;
 do {
  HEAP32[i12 + 408 + (i11 << 2) >> 2] = 0;
  i5 = i12 + 552 + (i11 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (!i2) i16 = 34; else {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i16 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
     i3 = HEAP32[i13 >> 2] | 0;
     i10 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i16 = 9; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i16 = 11;
    }
   }
   if ((i16 | 0) == 9) i16 = 11;
   if ((i16 | 0) == 11) {
    i16 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) {
     i16 = 34;
     break;
    }
   }
   if ((__ZNK4Mesh15GetSubMeshCountEv(i2) | 0) != 1) {
    i2 = i12 + 424 + (i11 * 12 | 0) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 | 0) {
     i10 = i12 + 424 + (i11 * 12 | 0) + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i10 >> 2];
     HEAP32[HEAP32[i10 >> 2] >> 2] = i3;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i10 >> 2] = 0;
    }
    HEAP32[i12 + 472 + (i11 * 20 | 0) + 12 >> 2] = 0;
    break;
   }
   HEAP32[i12 + 408 + (i1 << 2) >> 2] = i2;
   i3 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 128 >> 2] | 0;
   i10 = __ZN4Mesh18GetSubMeshBuffer16Ei(i2, 0) | 0;
   if ((HEAP32[i3 + 40 >> 2] | 0) == 1) {
    i8 = i3 + 36 | 0;
    i3 = __Z21CountTrianglesInStripItEiPKT_i(i10, HEAP32[i8 >> 2] | 0) | 0;
    i9 = i3 * 3 | 0;
    i4 = i12 + 472 + (i1 * 20 | 0) | 0;
    i5 = i12 + 472 + (i1 * 20 | 0) + 12 | 0;
    HEAP32[i5 >> 2] = i9;
    i6 = i12 + 472 + (i1 * 20 | 0) + 16 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    do if ((i7 & 2147483647) >>> 0 < i9 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i9;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3 * 6 | 0, 2, i12 + 472 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i3;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 6 | 0, 2, i12 + 472 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 1 | 0) | 0;
     HEAP32[i6 >> 2] = i9;
     HEAP32[i4 >> 2] = i3;
     break;
    } else i3 = HEAP32[i4 >> 2] | 0; while (0);
    __Z10DestripifyIttEvPKT_iPT0_i(i10, HEAP32[i8 >> 2] | 0, i3, i9);
   }
   i3 = HEAP32[i2 + 236 >> 2] | 0;
   i5 = i2 + 232 | 0;
   i4 = i3;
   L33 : do if ((i4 | 0) == (i5 | 0)) i16 = 23; else while (1) {
    if ((HEAP32[i3 + 8 >> 2] | 0) == (i12 | 0)) break L33;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    i4 = i3;
    if ((i4 | 0) == (i5 | 0)) {
     i16 = 23;
     break;
    }
   } while (0);
   if ((i16 | 0) == 23) {
    i16 = 0;
    i3 = i12 + 424 + (i11 * 12 | 0) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i10 = i12 + 424 + (i11 * 12 | 0) + 4 | 0;
     HEAP32[i4 + 4 >> 2] = HEAP32[i10 >> 2];
     HEAP32[HEAP32[i10 >> 2] >> 2] = i4;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i10 >> 2] = 0;
    }
    i4 = i12 + 424 + (i1 * 12 | 0) | 0;
    if ((i4 | 0) != (i5 | 0)) {
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) i3 = i12 + 424 + (i1 * 12 | 0) + 4 | 0; else {
      i10 = i12 + 424 + (i1 * 12 | 0) + 4 | 0;
      HEAP32[i3 + 4 >> 2] = HEAP32[i10 >> 2];
      HEAP32[HEAP32[i10 >> 2] >> 2] = i3;
      HEAP32[i4 >> 2] = 0;
      HEAP32[i10 >> 2] = 0;
      i3 = i10;
     }
     i10 = HEAP32[i5 >> 2] | 0;
     HEAP32[i4 >> 2] = i10;
     HEAP32[i3 >> 2] = i5;
     HEAP32[i10 + 4 >> 2] = i4;
     HEAP32[HEAP32[i3 >> 2] >> 2] = i4;
    }
   }
   i10 = i2 + 48 | 0;
   f18 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   f18 = Math_fround(f18 * f18);
   f19 = Math_fround(HEAPF32[i10 + 16 >> 2]);
   f19 = Math_fround(f18 + Math_fround(f19 * f19));
   f18 = Math_fround(HEAPF32[i10 + 20 >> 2]);
   f18 = Math_fround(Math_sqrt(Math_fround(f19 + Math_fround(f18 * f18))));
   HEAPF32[i13 >> 2] = f18;
   i10 = Math_fround(HEAPF32[i15 >> 2]) < f18;
   HEAP32[i15 >> 2] = HEAP32[(i10 ? i13 : i15) >> 2];
   i1 = i1 + 1 | 0;
  } while (0);
  if ((i16 | 0) == 34) {
   i16 = 0;
   i2 = i12 + 424 + (i11 * 12 | 0) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    i10 = i12 + 424 + (i11 * 12 | 0) + 4 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i10 >> 2];
    HEAP32[HEAP32[i10 >> 2] >> 2] = i3;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
   }
   HEAP32[i12 + 472 + (i11 * 20 | 0) + 12 >> 2] = 0;
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != 4);
 STACKTOP = i17;
 return;
}

function __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i26 + 72 | 0;
 i17 = i26 + 60 | 0;
 i18 = i26 + 56 | 0;
 i19 = i26 + 52 | 0;
 i20 = i26 + 48 | 0;
 i21 = i26 + 32 | 0;
 i22 = i26 + 16 | 0;
 i23 = i26;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i20 >> 2] = 1;
 i24 = i21 + 12 | 0;
 i12 = i22 + 12 | 0;
 i13 = i22 + 11 | 0;
 i14 = i22 + 4 | 0;
 i15 = i17 + 11 | 0;
 i16 = i17 + 4 | 0;
 i9 = 0;
 do {
  if (__ZN20TextRenderingPrivate15GetFontMetadataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERS6_S9_RjSA_iPi(i10, i11, i17, i18, i19, i9, i20) | 0) if (HEAP32[i19 >> 2] & 1 | 0) {
   i4 = HEAP32[i18 >> 2] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i21, i11);
   HEAP32[i24 >> 2] = i4 << 1 & 2 | i4 >>> 1 & 1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i23, i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i22, i23);
   HEAP32[i12 >> 2] = i9;
   i4 = (HEAP32[gb + 1467884 >> 2] | 0) + 4 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i25 = 12; else {
    i1 = i4;
    L7 : while (1) {
     i3 = i2;
     while (1) {
      if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i3 + 16 | 0, i21) | 0)) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L7; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) == (i4 | 0)) i25 = 12; else if (__ZNK20TextRenderingPrivate7FontRefltERKS0_(i21, i1 + 16 | 0) | 0) i25 = 12;
   }
   if ((i25 | 0) == 12) {
    i25 = 0;
    i1 = i4;
   }
   i2 = HEAP32[gb + 1467884 >> 2] | 0;
   L18 : do if ((i1 | 0) == (i2 + 4 | 0)) {
    i8 = __ZNSt3__23mapIN20TextRenderingPrivate7FontRefENS1_6OSFontENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEixERS8_(i2, i21) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i22) | 0;
    HEAP32[i8 + 12 >> 2] = HEAP32[i12 >> 2];
   } else {
    i3 = i1 + 32 | 0;
    do if ((HEAP32[i1 + 44 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) {
     i2 = HEAP8[i3 + 11 >> 0] | 0;
     i8 = i2 << 24 >> 24 < 0;
     i2 = i2 & 255;
     i5 = i8 ? HEAP32[i1 + 36 >> 2] | 0 : i2;
     i7 = HEAP8[i13 >> 0] | 0;
     i1 = i7 << 24 >> 24 < 0;
     if ((i5 | 0) == ((i1 ? HEAP32[i14 >> 2] | 0 : i7 & 255) | 0)) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i8 ? i6 : i3;
      i1 = i1 ? HEAP32[i22 >> 2] | 0 : i22;
      i4 = (i5 | 0) == 0;
      if (i8) {
       if (i4) break L18;
       if (!(_memcmp(i7, i1, i5) | 0)) break L18; else break;
      }
      if (i4) break L18;
      if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) do {
       i2 = i2 + -1 | 0;
       i3 = i3 + 1 | 0;
       if (!i2) break L18;
       i1 = i1 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
     }
    } while (0);
    switch (HEAP32[i24 >> 2] | 0) {
    case 0:
     {
      i8 = HEAP8[i15 >> 0] | 0;
      if (((i8 << 24 >> 24 < 0 ? HEAP32[i16 >> 2] | 0 : i8 & 255) | 0) != 7) break L18;
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i17, 0, -1, gb + 1006961 | 0, 7) | 0) break L18;
      break;
     }
    case 2:
     {
      i8 = HEAP8[i15 >> 0] | 0;
      if (((i8 << 24 >> 24 < 0 ? HEAP32[i16 >> 2] | 0 : i8 & 255) | 0) != 6) break L18;
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i17, 0, -1, gb + 945628 | 0, 6) | 0) break L18;
      break;
     }
    case 1:
     {
      i8 = HEAP8[i15 >> 0] | 0;
      if (((i8 << 24 >> 24 < 0 ? HEAP32[i16 >> 2] | 0 : i8 & 255) | 0) != 4) break L18;
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i17, 0, -1, gb + 1006969 | 0, 4) | 0) break L18;
      break;
     }
    case 3:
     {
      i8 = HEAP8[i15 >> 0] | 0;
      if (((i8 << 24 >> 24 < 0 ? HEAP32[i16 >> 2] | 0 : i8 & 255) | 0) != 11) break L18;
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i17, 0, -1, gb + 945635 | 0, 11) | 0) break L18;
      break;
     }
    default:
     break L18;
    }
    i8 = __ZNSt3__23mapIN20TextRenderingPrivate7FontRefENS1_6OSFontENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEixERS8_(HEAP32[gb + 1467884 >> 2] | 0, i21) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i22) | 0;
    HEAP32[i8 + 12 >> 2] = HEAP32[i12 >> 2];
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (HEAP32[i20 >> 2] | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i26;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler19onCUDAProfileBufferEyfPKhjj(i6, i1, i2, f3, i31, i5, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i31 = i31 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 56 | 0;
 i29 = i30 + 24 | 0;
 i27 = i30;
 if ((i4 | 0) != 1) {
  STACKTOP = i30;
  return;
 }
 HEAP32[i28 >> 2] = 0;
 i25 = i28 + 4 | 0;
 HEAP32[i25 >> 2] = 0;
 i26 = i28 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 i22 = i5 >>> 4;
 if (!i22) {
  STACKTOP = i30;
  return;
 }
 i23 = i27 + 8 | 0;
 i24 = i27 + 16 | 0;
 i20 = i6 + 40 | 0;
 i21 = i6 + 48 | 0;
 i16 = i6 + 44 | 0;
 i17 = i29 + 8 | 0;
 i18 = i29 + 16 | 0;
 i5 = 0;
 i1 = 0;
 i6 = 0;
 i19 = 0;
 while (1) {
  i2 = HEAP8[i31 + (i19 << 4) + 3 >> 0] | 0;
  L9 : do if (!i5) i32 = 8; else {
   i4 = 0;
   while (1) {
    if ((HEAP8[i6 + (i4 << 5) >> 0] | 0) == i2 << 24 >> 24) break;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= i5 >>> 0) {
     i32 = 8;
     break L9;
    }
   }
   i15 = i6;
   i14 = i6 + (i4 << 5) + 8 | 0;
  } while (0);
  if ((i32 | 0) == 8) {
   i32 = 0;
   HEAP32[i17 >> 2] = -1;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   HEAP32[i18 + 12 >> 2] = 0;
   HEAP8[i29 >> 0] = i2;
   if ((HEAP32[i26 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
    i4 = i6 + (i5 << 5) | 0;
    HEAP32[i4 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i29 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i29 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i29 + 20 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i29 + 24 >> 2];
    HEAP32[i4 + 28 >> 2] = HEAP32[i29 + 28 >> 2];
    i4 = i5 + 1 | 0;
    HEAP32[i25 >> 2] = i4;
    i2 = i6;
   } else {
    __ZN5physx6shdfnd5ArrayINS_3Ext5Local18OverflowRecordPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i28, i29) | 0;
    i2 = HEAP32[i28 >> 2] | 0;
    i1 = i2;
    i4 = HEAP32[i25 >> 2] | 0;
   }
   i15 = i2;
   i5 = i4;
   i14 = i2 + (i4 + -1 << 5) + 8 | 0;
  }
  i12 = HEAP32[i31 + (i19 << 4) + 8 >> 2] | 0;
  i13 = (i12 | 0) < 0;
  i2 = HEAP32[i14 >> 2] | 0;
  do if ((i2 | 0) != -1 & (i13 ^ (i2 | 0) < 0)) {
   if (i13) {
    if ((i12 - i2 | 0) >>> 0 >= 1073741823) break;
    i9 = i14 + 16 | 0;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i11 = i14 + 8 | 0;
    HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i11 + 4 >> 2] = i10;
    break;
   }
   if ((i2 - i12 | 0) >>> 0 > 1073741823) {
    i2 = i14 + 16 | 0;
    i6 = i2;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    i11 = i14 + 8 | 0;
    if ((i4 | 0) == (HEAP32[i11 >> 2] | 0) ? (i6 | 0) == (HEAP32[i11 + 4 >> 2] | 0) : 0) {
     i9 = _i64Add(i4 | 0, i6 | 0, -1, 0) | 0;
     i10 = getTempRet0() | 0;
     i11 = i2;
     HEAP32[i11 >> 2] = i9;
     HEAP32[i11 + 4 >> 2] = i10;
    }
   }
  } while (0);
  HEAP32[i14 >> 2] = i12;
  i6 = i14 + 8 | 0;
  i7 = i14 + 16 | 0;
  i8 = i13 ? i6 : i7;
  i8 = _i64Add(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i12 | 0, 0) | 0;
  i9 = getTempRet0() | 0;
  i10 = HEAP32[i31 + (i19 << 4) + 12 >> 2] | 0;
  i11 = (i10 | 0) < 0;
  do if ((i12 | 0) != -1 & (i13 ^ i11)) {
   if (i11) {
    if ((i10 - i12 | 0) >>> 0 >= 1073741823) break;
    i4 = i7;
    i12 = HEAP32[i4 + 4 >> 2] | 0;
    i13 = i6;
    HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
    break;
   }
   if ((i12 - i10 | 0) >>> 0 > 1073741823) {
    i4 = i7;
    i2 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    i13 = i6;
    if ((i2 | 0) == (HEAP32[i13 >> 2] | 0) ? (i4 | 0) == (HEAP32[i13 + 4 >> 2] | 0) : 0) {
     i4 = _i64Add(i2 | 0, i4 | 0, -1, 0) | 0;
     i12 = getTempRet0() | 0;
     i13 = i7;
     HEAP32[i13 >> 2] = i4;
     HEAP32[i13 + 4 >> 2] = i12;
    }
   }
  } while (0);
  HEAP32[i14 >> 2] = i10;
  i13 = i11 ? i6 : i7;
  i13 = _i64Add(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, i10 | 0, 0) | 0;
  i14 = getTempRet0() | 0;
  HEAP16[i27 >> 1] = HEAP16[i31 + (i19 << 4) + 6 >> 1] | 0;
  i2 = i23;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i2 + 4 >> 2] = i9;
  i2 = i24;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i2 + 4 >> 2] = i14;
  i2 = HEAP32[i16 >> 2] | 0;
  if ((HEAP32[i21 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i14 = (HEAP32[i20 >> 2] | 0) + (i2 * 24 | 0) | 0;
   HEAP32[i14 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i27 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i27 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i27 + 20 >> 2];
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i20, i27) | 0;
  i19 = i19 + 1 | 0;
  if ((i19 | 0) == (i22 | 0)) break; else i6 = i15;
 }
 i32 = HEAP32[i26 >> 2] | 0;
 if ((i32 & 2147483647 | 0) == 0 | (i32 | 0) < 0 | (i1 | 0) == 0) {
  STACKTOP = i30;
  return;
 }
 i32 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i32 >> 2] | 0) + 12 >> 2] | 0, i32 | 0, i1 | 0);
 STACKTOP = i30;
 return;
}

function __ZN5physx2Gu31checkOverlapOBB_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 20 | 0;
 i6 = i4;
 f7 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f7 = Math_fround(f7 * Math_fround(-2.0));
 f9 = Math_fround(f9 * Math_fround(-2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * Math_fround(-2.0));
 f22 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f21 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(f7 * f10);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f9 * f19));
 f25 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f11 * f25));
 f13 = Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f7 * f21) - Math_fround(f22 * Math_fround(Math_fround(f11 * f19) - Math_fround(f9 * f25)))));
 f17 = Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f9 * f21) - Math_fround(f22 * Math_fround(Math_fround(f7 * f25) - Math_fround(f11 * f10)))));
 f18 = Math_fround(Math_fround(Math_fround(f11 * f21) - Math_fround(f22 * Math_fround(Math_fround(f9 * f10) - Math_fround(f7 * f19)))) + Math_fround(f25 * f18));
 f7 = Math_fround(-f10);
 f9 = Math_fround(-f19);
 f21 = Math_fround(-f25);
 f10 = Math_fround(f7 - f10);
 f19 = Math_fround(f9 - f19);
 f25 = Math_fround(f21 - f25);
 f11 = Math_fround(f22 * f10);
 f8 = Math_fround(f22 * f19);
 f22 = Math_fround(f22 * f25);
 f16 = Math_fround(f19 * f7);
 f12 = Math_fround(f25 * f7);
 f19 = Math_fround(f19 * f9);
 f9 = Math_fround(f25 * f9);
 f21 = Math_fround(f25 * f21);
 f25 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f21);
 f24 = Math_fround(f16 + f22);
 f20 = Math_fround(f12 - f8);
 f22 = Math_fround(f16 - f22);
 f7 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f7));
 f21 = Math_fround(f7 - f21);
 f10 = Math_fround(f11 + f9);
 f12 = Math_fround(f8 + f12);
 f11 = Math_fround(f9 - f11);
 f19 = Math_fround(f7 - f19);
 f7 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f9 = Math_fround(f7 * f25);
 f8 = Math_fround(f7 * f24);
 f7 = Math_fround(f7 * f20);
 f16 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f16 * f22));
 f8 = Math_fround(f8 + Math_fround(f16 * f21));
 f16 = Math_fround(f7 + Math_fround(f16 * f10));
 f7 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f9 = Math_fround(f13 + Math_fround(f9 + Math_fround(f12 * f7)));
 f8 = Math_fround(f17 + Math_fround(f8 + Math_fround(f11 * f7)));
 f7 = Math_fround(f18 + Math_fround(f16 + Math_fround(f19 * f7)));
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(f25 * f16);
 f17 = Math_fround(f24 * f16);
 f16 = Math_fround(f20 * f16);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f22 * f13));
 f17 = Math_fround(f17 + Math_fround(f21 * f13));
 f13 = Math_fround(f16 + Math_fround(f10 * f13));
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f12 * f16));
 f17 = Math_fround(f17 + Math_fround(f11 * f16));
 f16 = Math_fround(f13 + Math_fround(f19 * f16));
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f15 = Math_fround(f25 * f13);
 f14 = Math_fround(f24 * f13);
 f13 = Math_fround(f20 * f13);
 f23 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f22 * f23));
 f14 = Math_fround(f14 + Math_fround(f21 * f23));
 f23 = Math_fround(f13 + Math_fround(f10 * f23));
 f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f12 * f13));
 f14 = Math_fround(f14 + Math_fround(f11 * f13));
 f13 = Math_fround(f23 + Math_fround(f19 * f13));
 f23 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f25 = Math_fround(f25 * f23);
 f24 = Math_fround(f24 * f23);
 f23 = Math_fround(f20 * f23);
 f20 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f22 = Math_fround(f25 + Math_fround(f22 * f20));
 f21 = Math_fround(f24 + Math_fround(f21 * f20));
 f20 = Math_fround(f23 + Math_fround(f10 * f20));
 f10 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f12 = Math_fround(f22 + Math_fround(f12 * f10));
 f11 = Math_fround(f21 + Math_fround(f11 * f10));
 f10 = Math_fround(f20 + Math_fround(f19 * f10));
 HEAPF32[i5 >> 2] = f18;
 HEAPF32[i5 + 4 >> 2] = f17;
 HEAPF32[i5 + 8 >> 2] = f16;
 HEAPF32[i5 + 12 >> 2] = f15;
 HEAPF32[i5 + 16 >> 2] = f14;
 HEAPF32[i5 + 20 >> 2] = f13;
 HEAPF32[i5 + 24 >> 2] = f12;
 HEAPF32[i5 + 28 >> 2] = f11;
 HEAPF32[i5 + 32 >> 2] = f10;
 HEAPF32[i5 + 36 >> 2] = f9;
 HEAPF32[i5 + 40 >> 2] = f8;
 HEAPF32[i5 + 44 >> 2] = f7;
 HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 16 >> 2] = i2;
 HEAPF32[i6 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 12 >> 2]));
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 16 >> 2]));
 i3 = __ZN5physx2Gu23intersectHeightFieldBoxERKNS0_15HeightFieldUtilERKNS0_3BoxE(i6, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0;
 i9 = HEAP32[i1 + 64 >> 2] | 0;
 i11 = HEAP32[i1 + 144 >> 2] | 0;
 i15 = (HEAP32[i1 + 120 >> 2] | 0) + ((Math_imul(i11, i9) | 0) << 2) | 0;
 i16 = HEAP32[i1 + 100 >> 2] | 0;
 i13 = HEAP32[i1 + 104 >> 2] | 0;
 i14 = HEAP32[i1 + 128 >> 2] | 0;
 i10 = (i11 << 1) + (HEAP32[i1 + 4 >> 2] | 0) | 0;
 switch (i9 | 0) {
 case 1:
  {
   if ((i10 | 0) > 0) i2 = 0; else return;
   do {
    i1 = HEAP32[i16 + (i2 << 3) >> 2] | 0;
    i3 = HEAP32[i16 + (i2 << 3) + 4 >> 2] | 0;
    if ((i1 | 0) <= (i3 | 0)) {
     i4 = (Math_imul(i2, i14) | 0) - i1 | 0;
     i5 = i15 + (i2 - i11 << 2) | 0;
     while (1) {
      f8 = Math_fround(HEAPF32[i13 + (i4 + i1 << 2) >> 2]);
      f8 = Math_fround(f8 * Math_fround(HEAPF32[i5 >> 2]));
      i9 = i12 + (i1 << 2) | 0;
      HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f8);
      if ((i1 | 0) < (i3 | 0)) i1 = i1 + 1 | 0; else break;
     }
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i10 | 0));
   return;
  }
 case 2:
  {
   if ((i10 | 0) > 0) i3 = 0; else return;
   do {
    i1 = HEAP32[i16 + (i3 << 3) >> 2] | 0;
    i4 = HEAP32[i16 + (i3 << 3) + 4 >> 2] | 0;
    i2 = i3 - i11 << 1;
    if ((i1 | 0) <= (i4 | 0)) {
     i5 = (Math_imul(i3, i14) | 0) - i1 | 0;
     i6 = i15 + (i2 << 2) | 0;
     i2 = i15 + ((i2 | 1) << 2) | 0;
     while (1) {
      i9 = i1 << 1;
      f8 = Math_fround(HEAPF32[i13 + (i5 + i1 << 2) >> 2]);
      f17 = Math_fround(f8 * Math_fround(HEAPF32[i6 >> 2]));
      i7 = i12 + (i9 << 2) | 0;
      HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f17);
      f8 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
      i9 = i12 + ((i9 | 1) << 2) | 0;
      HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f8);
      if ((i1 | 0) < (i4 | 0)) i1 = i1 + 1 | 0; else break;
     }
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i10 | 0));
   return;
  }
 case 3:
  {
   if ((i10 | 0) > 0) i3 = 0; else return;
   do {
    i1 = HEAP32[i16 + (i3 << 3) >> 2] | 0;
    i4 = HEAP32[i16 + (i3 << 3) + 4 >> 2] | 0;
    i2 = (i3 - i11 | 0) * 3 | 0;
    if ((i1 | 0) <= (i4 | 0)) {
     i5 = (Math_imul(i3, i14) | 0) - i1 | 0;
     i6 = i15 + (i2 << 2) | 0;
     i7 = i15 + (i2 + 1 << 2) | 0;
     i2 = i15 + (i2 + 2 << 2) | 0;
     while (1) {
      i9 = i1 * 3 | 0;
      f17 = Math_fround(HEAPF32[i13 + (i5 + i1 << 2) >> 2]);
      f8 = Math_fround(f17 * Math_fround(HEAPF32[i6 >> 2]));
      i18 = i12 + (i9 << 2) | 0;
      HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f8);
      f8 = Math_fround(f17 * Math_fround(HEAPF32[i7 >> 2]));
      i18 = i12 + (i9 + 1 << 2) | 0;
      HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f8);
      f17 = Math_fround(f17 * Math_fround(HEAPF32[i2 >> 2]));
      i9 = i12 + (i9 + 2 << 2) | 0;
      HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f17);
      if ((i1 | 0) < (i4 | 0)) i1 = i1 + 1 | 0; else break;
     }
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i10 | 0));
   return;
  }
 case 4:
  {
   if ((i10 | 0) > 0) i3 = 0; else return;
   do {
    i1 = HEAP32[i16 + (i3 << 3) >> 2] | 0;
    i4 = HEAP32[i16 + (i3 << 3) + 4 >> 2] | 0;
    i2 = i3 - i11 << 2;
    if ((i1 | 0) <= (i4 | 0)) {
     i5 = (Math_imul(i3, i14) | 0) - i1 | 0;
     i6 = i15 + (i2 << 2) | 0;
     i7 = i15 + ((i2 | 1) << 2) | 0;
     i9 = i15 + ((i2 | 2) << 2) | 0;
     i2 = i15 + ((i2 | 3) << 2) | 0;
     while (1) {
      i18 = i1 << 2;
      f17 = Math_fround(HEAPF32[i13 + (i5 + i1 << 2) >> 2]);
      f8 = Math_fround(f17 * Math_fround(HEAPF32[i6 >> 2]));
      i19 = i12 + (i18 << 2) | 0;
      HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f8);
      f8 = Math_fround(f17 * Math_fround(HEAPF32[i7 >> 2]));
      i19 = i12 + ((i18 | 1) << 2) | 0;
      HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f8);
      f8 = Math_fround(f17 * Math_fround(HEAPF32[i9 >> 2]));
      i19 = i12 + ((i18 | 2) << 2) | 0;
      HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f8);
      f17 = Math_fround(f17 * Math_fround(HEAPF32[i2 >> 2]));
      i18 = i12 + ((i18 | 3) << 2) | 0;
      HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f17);
      if ((i1 | 0) < (i4 | 0)) i1 = i1 + 1 | 0; else break;
     }
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i10 | 0));
   return;
  }
 default:
  {
   if ((i10 | 0) > 0 & (i9 | 0) > 0) i4 = 0; else return;
   do {
    i1 = HEAP32[i16 + (i4 << 3) >> 2] | 0;
    i5 = HEAP32[i16 + (i4 << 3) + 4 >> 2] | 0;
    i6 = Math_imul(i4 - i11 | 0, i9) | 0;
    if ((i1 | 0) <= (i5 | 0)) {
     i7 = (Math_imul(i4, i14) | 0) - i1 | 0;
     while (1) {
      i3 = Math_imul(i1, i9) | 0;
      f8 = Math_fround(HEAPF32[i13 + (i7 + i1 << 2) >> 2]);
      i2 = 0;
      do {
       f17 = Math_fround(f8 * Math_fround(HEAPF32[i15 + (i2 + i6 << 2) >> 2]));
       i19 = i12 + (i2 + i3 << 2) | 0;
       HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f17);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i9 | 0));
      if ((i1 | 0) < (i5 | 0)) i1 = i1 + 1 | 0; else break;
     }
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i10 | 0));
   return;
  }
 }
}

function __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i6 = i5 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 4;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i5, i7, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 12;
 HEAP32[i7 + 4 >> 2] = i4 + 8;
 HEAP32[i7 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i5, i7, 0);
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 20;
 HEAP32[i7 + 4 >> 2] = i4 + 16;
 HEAP32[i7 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i5, i7, 0);
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i4 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i4 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 60 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i4 + 61 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i4 + 62 >> 0] = i1;
 i1 = i4 + 63 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i8;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__218__stable_sort_moveIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeE(i1, i11, i5, i6, i2) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 20 | 0;
 i3 = i13 + 16 | 0;
 i7 = i13 + 12 | 0;
 i8 = i13 + 8 | 0;
 i9 = i13 + 4 | 0;
 i10 = i13;
 switch (i6 | 0) {
 case 1:
  {
   i10 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   STACKTOP = i13;
   return;
  }
 case 2:
  {
   i3 = (HEAP32[i11 >> 2] | 0) + -8 | 0;
   HEAP32[i11 >> 2] = i3;
   i1 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0) {
    i12 = i3;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i2;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i1;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    STACKTOP = i13;
    return;
   } else {
    i12 = i1;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i2;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i3;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    STACKTOP = i13;
    return;
   }
  }
 case 0:
  {
   STACKTOP = i13;
   return;
  }
 default:
  {
   if ((i6 | 0) < 9) {
    i1 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (i7 | 0)) {
     STACKTOP = i13;
     return;
    }
    i10 = i1;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     STACKTOP = i13;
     return;
    } else i6 = i2;
    do {
     i3 = i6;
     i6 = i6 + 8 | 0;
     if ((HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
      i10 = i3;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i12 = i6;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
      L14 : do if ((i3 | 0) == (i2 | 0)) i3 = i2; else {
       i4 = i3;
       while (1) {
        i3 = i4;
        i4 = i4 + -8 | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        if ((HEAP32[i1 >> 2] | 0) >>> 0 >= i5 >>> 0) break L14;
        HEAP32[i3 >> 2] = i5;
        HEAP32[i3 + 4 >> 2] = HEAP32[i3 + -4 >> 2];
        if ((i4 | 0) == (i2 | 0)) {
         i3 = i2;
         break;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     } else {
      i10 = i1;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i12 = i6;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
     }
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i7 | 0));
    STACKTOP = i13;
    return;
   }
   i14 = i6 >>> 1;
   i1 = HEAP32[i1 >> 2] | 0;
   i12 = i1 + (i14 << 3) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i8 >> 2] = i12;
   HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i3, i4, i5, i14, i2, i14);
   HEAP32[i9 >> 2] = i12;
   i11 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i11;
   i8 = i6 - i14 | 0;
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i3, i4, i5, i8, i2 + (i14 << 3) | 0, i8);
   i4 = i11;
   L23 : do if (i14) {
    i3 = i12;
    while (1) {
     if ((i3 | 0) == (i4 | 0)) break;
     if ((HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0) {
      i10 = i3;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i14 = i2;
      HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i14 + 4 >> 2] = i11;
      i3 = i3 + 8 | 0;
     } else {
      i10 = i1;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i14 = i2;
      HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i14 + 4 >> 2] = i11;
      i1 = i1 + 8 | 0;
     }
     i2 = i2 + 8 | 0;
     if ((i1 | 0) == (i12 | 0)) {
      i1 = i3;
      break L23;
     }
    }
    if ((i1 | 0) == (i12 | 0)) {
     STACKTOP = i13;
     return;
    }
    while (1) {
     i10 = i1;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i14 = i2;
     HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i14 + 4 >> 2] = i11;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 8 | 0;
    }
    STACKTOP = i13;
    return;
   } while (0);
   if ((i1 | 0) == (i4 | 0)) {
    STACKTOP = i13;
    return;
   }
   while (1) {
    i11 = i1;
    i12 = HEAP32[i11 + 4 >> 2] | 0;
    i14 = i2;
    HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i14 + 4 >> 2] = i12;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 8 | 0;
   }
   STACKTOP = i13;
   return;
  }
 }
}

function __ZN5physx16PxsThreadContextD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 9156 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i2 + 9160 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 9164 | 0, i1);
 i1 = HEAP32[i2 + 9136 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i2 + 9140 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 9144 | 0, i1);
 i1 = HEAP32[i2 + 9132 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 9124 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 9120 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 9112 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 9008 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 9e3 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8996 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8988 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8984 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8976 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8972 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8964 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8960 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8952 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8948 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8940 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8936 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8928 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8924 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8916 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8912 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8904 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8900 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8892 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8888 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8880 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8876 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8868 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8864 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8856 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8852 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8844 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8840 >> 2] | 0;
 do if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 8832 >> 2] | 0;
  if (!i1) break;
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 } while (0);
 i3 = HEAP32[i2 + 8828 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) {
  i3 = i2 + 16 | 0;
  __ZN5physx18PxcNpThreadContextD2Ev(i3);
  return;
 }
 i1 = HEAP32[i2 + 8820 >> 2] | 0;
 if (!i1) {
  i3 = i2 + 16 | 0;
  __ZN5physx18PxcNpThreadContextD2Ev(i3);
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 i3 = i2 + 16 | 0;
 __ZN5physx18PxcNpThreadContextD2Ev(i3);
 return;
}

function __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i9 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 204 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 205 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 116 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 124 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 128 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 132 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i6 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i6 + 144 | 0, gb + 1047790 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i6 + 156 | 0, gb + 1047804 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i6 + 180 | 0, gb + 1047818 | 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i6 + 168 | 0, gb + 1047851 | 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 200 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 196 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i7 >> 0] = i5;
  HEAP32[i8 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 193 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 192 >> 0] = i1;
 i1 = i6 + 206 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN26LightProbeProxyVolumeUtilsL28ComputeGlobalAABBOnHierarchyER9TransformR10MinMaxAABB(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i1 = HEAP32[i17 + 28 >> 2] | 0;
 if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i15 = HEAP32[i1 + 40 >> 2] | 0;
  if ((i15 | 0) > 0) {
   i14 = i1 + 28 | 0;
   i9 = i18 + 4 | 0;
   i10 = i18 + 8 | 0;
   i11 = i18 + 12 | 0;
   i12 = i18 + 16 | 0;
   i13 = i18 + 20 | 0;
   i6 = 0;
   do {
    i4 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i6 << 3) + 4 >> 2] | 0;
    if (i4 | 0) if ((((HEAP32[i4 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) {
     i1 = HEAP32[i4 + 28 >> 2] | 0;
     if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
      i1 = i4 + 32 | 0;
      i5 = i4 + 268 | 0;
      if (((HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16) & 196608 | 0) == 131072) {
       i3 = i4 + 272 | 0;
       i5 = HEAP16[i3 >> 1] | 0;
       if ((i5 & 65535) > 255 | (i5 & 255) << 24 >> 24 != 0) {
        mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
        HEAP8[i3 >> 0] = 0;
        HEAP8[i1 + 241 >> 0] = 0;
       }
       i1 = i4 + 36 | 0;
       i3 = i1 + 140 | 0;
       f2 = Math_fround(HEAPF32[i3 >> 2]);
       f21 = Math_fround(f2 * f2);
       i4 = i1 + 144 | 0;
       f7 = Math_fround(HEAPF32[i4 >> 2]);
       f21 = Math_fround(f21 + Math_fround(f7 * f7));
       i5 = i1 + 148 | 0;
       f8 = Math_fround(HEAPF32[i5 >> 2]);
       if (Math_fround(f21 + Math_fround(f8 * f8)) > Math_fround(1.1920929e-07)) {
        i25 = i1 + 128 | 0;
        f21 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) - f2);
        i24 = i1 + 132 | 0;
        f22 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f7);
        i1 = i1 + 136 | 0;
        f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f8);
        f7 = Math_fround(HEAPF32[i18 >> 2]);
        f8 = Math_fround(HEAPF32[i9 >> 2]);
        f23 = Math_fround(HEAPF32[i10 >> 2]);
        HEAPF32[i18 >> 2] = f21 < f7 ? f21 : f7;
        HEAPF32[i9 >> 2] = f22 < f8 ? f22 : f8;
        HEAPF32[i10 >> 2] = f2 < f23 ? f2 : f23;
        f23 = Math_fround(HEAPF32[i25 >> 2]);
        f23 = Math_fround(f23 + Math_fround(HEAPF32[i3 >> 2]));
        f2 = Math_fround(HEAPF32[i24 >> 2]);
        f2 = Math_fround(f2 + Math_fround(HEAPF32[i4 >> 2]));
        f8 = Math_fround(HEAPF32[i1 >> 2]);
        f8 = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
        f22 = Math_fround(HEAPF32[i11 >> 2]);
        f7 = Math_fround(HEAPF32[i12 >> 2]);
        f21 = Math_fround(HEAPF32[i13 >> 2]);
        HEAPF32[i11 >> 2] = f22 < f23 ? f23 : f22;
        HEAPF32[i12 >> 2] = f7 < f2 ? f2 : f7;
        HEAPF32[i13 >> 2] = f21 < f8 ? f8 : f21;
       }
      }
     }
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i15 | 0));
  }
  i3 = HEAP32[i17 + 92 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i4 = i17 + 80 | 0;
   i1 = 0;
   do {
    __ZN26LightProbeProxyVolumeUtilsL28ComputeGlobalAABBOnHierarchyER9TransformR10MinMaxAABB(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0, i18);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 f23 = Math_fround(HEAPF32[i18 >> 2]);
 f2 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f23 == f2) {
  i4 = i18 + 4 | 0;
  f23 = Math_fround(HEAPF32[i4 >> 2]);
  if (f23 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   i1 = i18 + 8 | 0;
   f23 = Math_fround(HEAPF32[i1 >> 2]);
   if (f23 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
    i3 = i18 + 12 | 0;
    i6 = i18 + 16 | 0;
    i5 = i18 + 20 | 0;
   } else i16 = 21;
  } else i16 = 21;
 } else i16 = 21;
 do if ((i16 | 0) == 21) {
  f23 = Math_fround(-f2);
  f2 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i3 = i18 + 12 | 0;
  if (!(Math_fround(HEAPF32[i3 >> 2]) == f23)) {
   STACKTOP = i20;
   return;
  }
  f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  i4 = i18 + 16 | 0;
  if (!(Math_fround(HEAPF32[i4 >> 2]) == f23)) {
   STACKTOP = i20;
   return;
  }
  i5 = i18 + 20 | 0;
  if (Math_fround(HEAPF32[i5 >> 2]) != f2) {
   STACKTOP = i20;
   return;
  } else {
   i1 = i18 + 8 | 0;
   i6 = i4;
   i4 = i18 + 4 | 0;
   break;
  }
 } while (0);
 __ZNK9Transform11GetPositionEv(i19, i17);
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 f8 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f28 = Math_fround(f2 + Math_fround(-.5));
 f26 = Math_fround(f8 + Math_fround(-.5));
 f21 = Math_fround(f22 + Math_fround(-.5));
 f27 = Math_fround(HEAPF32[i18 >> 2]);
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i18 >> 2] = f28 < f27 ? f28 : f27;
 HEAPF32[i4 >> 2] = f26 < f23 ? f26 : f23;
 HEAPF32[i1 >> 2] = f21 < f7 ? f21 : f7;
 f2 = Math_fround(f2 + Math_fround(.5));
 f8 = Math_fround(f8 + Math_fround(.5));
 f22 = Math_fround(f22 + Math_fround(.5));
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f21 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 HEAPF32[i3 >> 2] = f7 < f2 ? f2 : f7;
 HEAPF32[i6 >> 2] = f21 < f8 ? f8 : f21;
 HEAPF32[i5 >> 2] = f23 < f22 ? f22 : f23;
 STACKTOP = i20;
 return;
}

function __ZN19SpriteMeshGenerator4path8cvx_costEi(i1, i23) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f24 = f0, f25 = f0, f26 = f0;
 i22 = HEAP32[i1 >> 2] | 0;
 i7 = (HEAP32[i1 + 4 >> 2] | 0) - i22 | 0;
 i20 = i7 >> 5;
 if ((i7 | 0) < 160) {
  i23 = 0;
  return i23 | 0;
 }
 i4 = i23 + -1 | 0;
 i3 = (i20 | 0) >= (i23 | 0);
 if (i3) if ((i23 | 0) > 0) i1 = i4; else i1 = i20 + -1 - ((0 - i23 | 0) % (i20 | 0) | 0) | 0; else i1 = (i4 | 0) % (i20 | 0) | 0;
 f21 = Math_fround(HEAPF32[i22 + (i1 << 5) + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i22 + (i1 << 5) + 12 >> 2]);
 i6 = i23 + 1 | 0;
 i7 = (i6 | 0) < (i20 | 0);
 if (i7) if ((i23 | 0) > -2) i1 = i6; else i1 = i20 + -1 - ((-2 - i23 | 0) % (i20 | 0) | 0) | 0; else i1 = (i6 | 0) % (i20 | 0) | 0;
 f19 = Math_fround(HEAPF32[i22 + (i1 << 5) + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i22 + (i1 << 5) + 12 >> 2]);
 f2 = Math_fround(Math_fround(f21 * f19) + Math_fround(f18 * f17));
 do if (!(f2 < Math_fround(0.0))) {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 | 0) > -1) {
   if ((i1 | 0) < 11) break;
   if ((((i1 | 0) < 1065353216 ? 1065353216 - i1 | 0 : i1 + -1065353216 | 0) | 0) < 11) break;
  } else if (f2 == Math_fround(0.0) | f2 == Math_fround(1.0)) break;
  if (i3) if ((i23 | 0) > 0) i1 = i4; else i1 = i20 + -1 - ((0 - i23 | 0) % (i20 | 0) | 0) | 0; else i1 = (i4 | 0) % (i20 | 0) | 0;
  f16 = Math_fround(HEAPF32[i22 + (i1 << 5) >> 2]);
  f15 = Math_fround(HEAPF32[i22 + (i1 << 5) + 4 >> 2]);
  if (i7) if ((i23 | 0) > -2) i1 = i6; else i1 = i20 + -1 - ((-2 - i23 | 0) % (i20 | 0) | 0) | 0; else i1 = (i6 | 0) % (i20 | 0) | 0;
  f13 = Math_fround(HEAPF32[i22 + (i1 << 5) >> 2]);
  f10 = Math_fround(HEAPF32[i22 + (i1 << 5) + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i22 + (i23 << 5) >> 2]);
  f12 = Math_fround(HEAPF32[i22 + (i23 << 5) + 4 >> 2]);
  f24 = Math_fround(-f21);
  f9 = Math_fround(f12 - f15);
  f5 = Math_fround(-Math_fround(f11 - f16));
  f26 = Math_fround(f16 - f13);
  f25 = Math_fround(f15 - f10);
  f2 = Math_fround(Math_fround(f25 * f5) + Math_fround(f26 * f9));
  f8 = Math_fround(Math_fround(f18 * f19) + Math_fround(f17 * f24));
  f9 = Math_fround(Math_fround(Math_fround(f18 * f26) + Math_fround(f25 * f24)) + Math_fround(Math_fround(Math_fround(f17 - f18) * f5) + Math_fround(Math_fround(f19 - f21) * f9)));
  f5 = Math_fround(-f9);
  i7 = f8 < Math_fround(0.0);
  f24 = Math_fround(-f8);
  if ((i7 ? f24 : f8) < Math_fround(9.99999974e-06)) {
   i7 = f9 > Math_fround(-0.0);
   if ((i7 ? f9 : f5) > Math_fround(9.99999974e-06)) {
    f5 = Math_fround(Math_fround(-f2) / f5);
    f2 = Math_fround(-1.0);
    i14 = 30;
   }
  } else {
   f2 = Math_fround(Math_fround(f9 * f9) - Math_fround(Math_fround(f8 * Math_fround(4.0)) * f2));
   if (!(f2 < Math_fround(0.0))) {
    f26 = Math_fround(Math_fround(.5) / f8);
    f2 = Math_fround(Math_sqrt(Math_fround(f2)));
    f5 = Math_fround(f26 * Math_fround(f9 + f2));
    f2 = Math_fround(f26 * Math_fround(f9 - f2));
    if (f5 > Math_fround(0.0) & f2 > Math_fround(0.0)) {
     f8 = f5;
     f9 = f2;
     i1 = f5 < f2;
     i14 = 31;
    } else i14 = 30;
   }
  }
  if ((i14 | 0) == 30) {
   f8 = f5;
   f9 = f2;
   i1 = f5 > f2;
   i14 = 31;
  }
  L39 : do if ((i14 | 0) == 31) {
   f8 = i1 ? f8 : f9;
   do if (!(f8 > Math_fround(0.0))) {
    i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    if ((i1 | 0) > -1) if ((i1 | 0) < 11) break; else break L39; else if (f8 == Math_fround(0.0)) break; else break L39;
   } while (0);
   i1 = i23 + -2 | 0;
   if ((i1 | 0) < (i20 | 0)) {
    if ((i1 | 0) <= -1) i1 = i20 + -1 - ((1 - i23 | 0) % (i20 | 0) | 0) | 0;
   } else i1 = (i1 | 0) % (i20 | 0) | 0;
   f5 = Math_fround(HEAPF32[i22 + (i1 << 5) >> 2]);
   f2 = Math_fround(HEAPF32[i22 + (i1 << 5) + 4 >> 2]);
   i1 = i23 + 2 | 0;
   if ((i1 | 0) < (i20 | 0)) {
    if ((i1 | 0) <= -1) i1 = i20 + -1 - ((-3 - i23 | 0) % (i20 | 0) | 0) | 0;
   } else i1 = (i1 | 0) % (i20 | 0) | 0;
   f24 = Math_fround(HEAPF32[i22 + (i1 << 5) >> 2]);
   f9 = Math_fround(f16 + Math_fround(f21 * f8));
   f21 = Math_fround(f15 + Math_fround(f18 * f8));
   f25 = Math_fround(f13 + Math_fround(f19 * f8));
   f26 = Math_fround(f10 + Math_fround(f17 * f8));
   HEAPF32[i22 + (i23 << 5) + 24 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f10 - f12) * Math_fround(f25 - f11)) - Math_fround(Math_fround(f11 - f13) * Math_fround(f12 - f26))) + Math_fround(Math_fround(Math_fround(Math_fround(f11 - f9) * Math_fround(f15 - f21)) - Math_fround(Math_fround(f9 - f16) * Math_fround(f21 - f12))) + Math_fround(Math_fround(Math_fround(f9 - f5) * Math_fround(f15 - f2)) - Math_fround(Math_fround(f5 - f16) * Math_fround(f2 - f21))))) + Math_fround(Math_fround(Math_fround(f10 - f26) * Math_fround(f24 - f25)) - Math_fround(Math_fround(f25 - f13) * Math_fround(f26 - Math_fround(HEAPF32[i22 + (i1 << 5) + 4 >> 2])))));
   HEAPF32[i22 + (i23 << 5) + 28 >> 2] = f8;
   i23 = 1;
   return i23 | 0;
  } while (0);
  HEAP32[i22 + (i23 << 5) + 24 >> 2] = -1082130432;
  HEAP32[i22 + (i23 << 5) + 28 >> 2] = 0;
  i23 = 0;
  return i23 | 0;
 } while (0);
 HEAP32[i22 + (i23 << 5) + 24 >> 2] = -1082130432;
 HEAP32[i22 + (i23 << 5) + 28 >> 2] = 0;
 i23 = 1;
 return i23 | 0;
}

function __ZN5physx10PxsCCDPair16sweepEstimateToiEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 100 | 0;
 i16 = i19 + 72 | 0;
 i17 = i19 + 60 | 0;
 i18 = i19 + 48 | 0;
 i12 = i19 + 36 | 0;
 i13 = i19 + 24 | 0;
 i5 = i19 + 12 | 0;
 i6 = i19;
 __ZN5physx10PxsCCDPair12updateShapesEv(i14);
 i4 = HEAP32[i14 + 4 >> 2] | 0;
 i26 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i14 + 8 >> 2] | 0;
 i3 = HEAP32[i14 + 12 >> 2] | 0;
 i7 = HEAP32[i14 + 64 >> 2] | 0;
 i8 = HEAP32[i14 + 60 >> 2] | 0;
 i9 = (i7 | 0) < (i8 | 0);
 i1 = i9 ? i2 : i3;
 i2 = i9 ? i3 : i2;
 i3 = i9 ? i4 : i26;
 i4 = i9 ? i26 : i4;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 i26 = i18 + 4 | 0;
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 i11 = i18 + 8 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAP32[i15 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 52 >> 2];
 i27 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i15 + 16 >> 2] = i27;
 i28 = HEAP32[i2 + 60 >> 2] | 0;
 HEAP32[i15 + 20 >> 2] = i28;
 i29 = HEAP32[i2 + 64 >> 2] | 0;
 HEAP32[i15 + 24 >> 2] = i29;
 f25 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f25);
 f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f24);
 f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f20);
 HEAPF32[i17 >> 2] = f25;
 HEAPF32[i17 + 4 >> 2] = f24;
 HEAPF32[i17 + 8 >> 2] = f20;
 HEAP32[i16 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 52 >> 2];
 i29 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i16 + 16 >> 2] = i29;
 i28 = HEAP32[i1 + 60 >> 2] | 0;
 HEAP32[i16 + 20 >> 2] = i28;
 i27 = HEAP32[i1 + 64 >> 2] | 0;
 HEAP32[i16 + 24 >> 2] = i27;
 f23 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
 f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f22);
 f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
 HEAPF32[i18 >> 2] = f23;
 HEAPF32[i26 >> 2] = f22;
 HEAPF32[i11 >> 2] = f21;
 f10 = Math_fround(HEAPF32[(HEAP32[i14 + 52 >> 2] | 0) + 108 >> 2]);
 i11 = f10 > Math_fround(0.0);
 f10 = i11 ? f10 : Math_fround(0.0);
 f23 = Math_fround(f25 - f23);
 f22 = Math_fround(f24 - f22);
 f21 = Math_fround(f20 - f21);
 f20 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i1 + 8 >> 2]));
 i11 = i14 + 100 | 0;
 HEAP32[i11 >> 2] = 0;
 if (Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)) + Math_fround(f21 * f21)) <= Math_fround(f20 * f20)) {
  HEAP32[i11 >> 2] = 0;
  HEAPF32[i14 + 28 >> 2] = Math_fround(3402823469999999843913219.0e14);
  f25 = Math_fround(3402823469999999843913219.0e14);
  STACKTOP = i19;
  return Math_fround(f25);
 }
 switch ((i9 ? i8 : i7) | 0) {
 case 5:
  {
   f25 = Math_fround(__ZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f(i2, i1, i3, i4, i15, i16, f10));
   HEAPF32[i14 + 28 >> 2] = f25;
   STACKTOP = i19;
   return Math_fround(f25);
  }
 case 6:
  {
   f25 = Math_fround(__ZN5physx35PxcSweepEstimateAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f(i2, i1, i3, i4, i15, i16, f10));
   HEAPF32[i14 + 28 >> 2] = f25;
   STACKTOP = i19;
   return Math_fround(f25);
  }
 default:
  {
   HEAP32[i12 >> 2] = HEAP32[i2 + 80 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 84 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 88 >> 2];
   f20 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 68 >> 2]));
   f21 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 72 >> 2]));
   f22 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 76 >> 2]));
   HEAP32[i13 >> 2] = HEAP32[i1 + 80 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 84 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 88 >> 2];
   f23 = Math_fround(HEAPF32[i1 + 68 >> 2]);
   f24 = Math_fround(HEAPF32[i1 + 72 >> 2]);
   f25 = Math_fround(HEAPF32[i1 + 76 >> 2]);
   f21 = Math_fround(f21 * Math_fround(1.10000002));
   f22 = Math_fround(f22 * Math_fround(1.10000002));
   HEAPF32[i5 >> 2] = Math_fround(f20 * Math_fround(1.10000002));
   HEAPF32[i5 + 4 >> 2] = f21;
   HEAPF32[i5 + 8 >> 2] = f22;
   f24 = Math_fround(f24 * Math_fround(1.10000002));
   f25 = Math_fround(f25 * Math_fround(1.10000002));
   HEAPF32[i6 >> 2] = Math_fround(f23 * Math_fround(1.10000002));
   HEAPF32[i6 + 4 >> 2] = f24;
   HEAPF32[i6 + 8 >> 2] = f25;
   f25 = Math_fround(__Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i12, i5, i13, i6, i17, i18));
   HEAPF32[i14 + 28 >> 2] = f25;
   STACKTOP = i19;
   return Math_fround(f25);
  }
 }
 return f0;
}

function __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i14 = i17 + 52 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = 65;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = 65;
  HEAP32[i10 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i7 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = 65;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  i3 = HEAP32[i22 >> 2] | 0;
  i16 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
  i4 = i1 + (i16 << 3) | 0;
  if (i16) {
   i3 = i7;
   while (1) {
    i6 = i1;
    i15 = HEAP32[i6 + 4 >> 2] | 0;
    i16 = i3;
    HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
   }
   i3 = HEAP32[i22 >> 2] | 0;
  }
  i4 = i7 + (i2 << 3) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i6 = i17 + 20 | 0;
   i1 = i7 + (i3 << 3) | 0;
   do {
    i3 = i6;
    i15 = HEAP32[i3 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  i16 = HEAP32[i21 >> 2] | 0;
  i15 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = 65;
  HEAP32[i10 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i10);
  HEAP32[i21 >> 2] = i7;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L28 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L28;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L28;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L49 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L49;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L49;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function runPostSets235() {
 HEAP32[gb + 212496 >> 2] = fb + 98;
 HEAP32[gb + 212500 >> 2] = fb + 1497;
 HEAP32[gb + 212504 >> 2] = fb + 1498;
 HEAP32[gb + 212508 >> 2] = fb + 99;
 HEAP32[gb + 212512 >> 2] = fb + 1499;
 HEAP32[gb + 12184 >> 2] = (HEAP32[gb + 12184 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12188 >> 2] = (HEAP32[gb + 12188 >> 2] | 0) + (gb + 1080627 | 0);
 HEAP32[gb + 12192 >> 2] = (HEAP32[gb + 12192 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 212520 >> 2] = (HEAP32[gb + 212520 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 212524 >> 2] = fb + 3134;
 HEAP32[gb + 212528 >> 2] = fb + 3135;
 HEAP32[gb + 212532 >> 2] = fb + 3068;
 HEAP32[gb + 212536 >> 2] = fb + 26;
 HEAP32[gb + 212540 >> 2] = fb + 27;
 HEAP32[gb + 212544 >> 2] = fb + 98;
 HEAP32[gb + 212548 >> 2] = fb + 1497;
 HEAP32[gb + 212552 >> 2] = fb + 1498;
 HEAP32[gb + 212556 >> 2] = fb + 99;
 HEAP32[gb + 212560 >> 2] = fb + 1499;
 HEAP32[gb + 12200 >> 2] = (HEAP32[gb + 12200 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12204 >> 2] = (HEAP32[gb + 12204 >> 2] | 0) + (gb + 1080593 | 0);
 HEAP32[gb + 12216 >> 2] = (HEAP32[gb + 12216 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12224 >> 2] = (HEAP32[gb + 12224 >> 2] | 0) + (gb + 12080 | 0);
 HEAP32[gb + 212568 >> 2] = (HEAP32[gb + 212568 >> 2] | 0) + (gb + 12232 | 0);
 HEAP32[gb + 212572 >> 2] = fb + 3136;
 HEAP32[gb + 212576 >> 2] = fb + 3137;
 HEAP32[gb + 212580 >> 2] = fb + 3068;
 HEAP32[gb + 212584 >> 2] = fb + 28;
 HEAP32[gb + 212588 >> 2] = fb + 29;
 HEAP32[gb + 212592 >> 2] = fb + 100;
 HEAP32[gb + 212596 >> 2] = fb + 1500;
 HEAP32[gb + 212600 >> 2] = fb + 1501;
 HEAP32[gb + 212604 >> 2] = fb + 101;
 HEAP32[gb + 212608 >> 2] = fb + 1502;
 HEAP32[gb + 12232 >> 2] = (HEAP32[gb + 12232 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12236 >> 2] = (HEAP32[gb + 12236 >> 2] | 0) + (gb + 1080669 | 0);
 HEAP32[gb + 12240 >> 2] = (HEAP32[gb + 12240 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 12248 >> 2] = (HEAP32[gb + 12248 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12252 >> 2] = (HEAP32[gb + 12252 >> 2] | 0) + (gb + 1080712 | 0);
 HEAP32[gb + 12264 >> 2] = (HEAP32[gb + 12264 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12272 >> 2] = (HEAP32[gb + 12272 >> 2] | 0) + (gb + 12080 | 0);
 HEAP32[gb + 212616 >> 2] = (HEAP32[gb + 212616 >> 2] | 0) + (gb + 12280 | 0);
 HEAP32[gb + 212620 >> 2] = fb + 3138;
 HEAP32[gb + 212624 >> 2] = fb + 3139;
 HEAP32[gb + 212628 >> 2] = fb + 3068;
 HEAP32[gb + 212632 >> 2] = fb + 22;
 HEAP32[gb + 212636 >> 2] = fb + 23;
 HEAP32[gb + 212640 >> 2] = fb + 94;
 HEAP32[gb + 212644 >> 2] = fb + 1491;
 HEAP32[gb + 212648 >> 2] = fb + 1492;
 HEAP32[gb + 212652 >> 2] = fb + 95;
 HEAP32[gb + 212656 >> 2] = fb + 1493;
 HEAP32[gb + 12280 >> 2] = (HEAP32[gb + 12280 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12284 >> 2] = (HEAP32[gb + 12284 >> 2] | 0) + (gb + 1080747 | 0);
 HEAP32[gb + 12288 >> 2] = (HEAP32[gb + 12288 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 212692 >> 2] = (HEAP32[gb + 212692 >> 2] | 0) + (gb + 12296 | 0);
 HEAP32[gb + 212696 >> 2] = fb + 3140;
 HEAP32[gb + 212700 >> 2] = fb + 3141;
 HEAP32[gb + 212704 >> 2] = fb + 3068;
 HEAP32[gb + 12296 >> 2] = (HEAP32[gb + 12296 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12300 >> 2] = (HEAP32[gb + 12300 >> 2] | 0) + (gb + 1080790 | 0);
 HEAP32[gb + 12304 >> 2] = (HEAP32[gb + 12304 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 212712 >> 2] = (HEAP32[gb + 212712 >> 2] | 0) + (gb + 12312 | 0);
 HEAP32[gb + 212716 >> 2] = fb + 3142;
 HEAP32[gb + 212720 >> 2] = fb + 3143;
 HEAP32[gb + 212724 >> 2] = fb + 3068;
 HEAP32[gb + 212728 >> 2] = fb + 102;
 HEAP32[gb + 212732 >> 2] = fb + 180;
 HEAP32[gb + 212736 >> 2] = fb + 307;
 HEAP32[gb + 12312 >> 2] = (HEAP32[gb + 12312 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12316 >> 2] = (HEAP32[gb + 12316 >> 2] | 0) + (gb + 1080812 | 0);
 HEAP32[gb + 12320 >> 2] = (HEAP32[gb + 12320 >> 2] | 0) + (gb + 11e3 | 0);
 HEAP32[gb + 212744 >> 2] = (HEAP32[gb + 212744 >> 2] | 0) + (gb + 12328 | 0);
 HEAP32[gb + 212748 >> 2] = fb + 3144;
 HEAP32[gb + 212752 >> 2] = fb + 3145;
 HEAP32[gb + 212756 >> 2] = fb + 3068;
 HEAP32[gb + 212760 >> 2] = fb + 103;
 HEAP32[gb + 212764 >> 2] = fb + 181;
 HEAP32[gb + 212768 >> 2] = fb + 308;
 HEAP32[gb + 12328 >> 2] = (HEAP32[gb + 12328 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12332 >> 2] = (HEAP32[gb + 12332 >> 2] | 0) + (gb + 1080840 | 0);
 HEAP32[gb + 12336 >> 2] = (HEAP32[gb + 12336 >> 2] | 0) + (gb + 11032 | 0);
 HEAP32[gb + 212776 >> 2] = (HEAP32[gb + 212776 >> 2] | 0) + (gb + 12344 | 0);
 HEAP32[gb + 212780 >> 2] = fb + 3146;
 HEAP32[gb + 212784 >> 2] = fb + 3147;
 HEAP32[gb + 212788 >> 2] = fb + 3068;
 HEAP32[gb + 212792 >> 2] = fb + 484;
 HEAP32[gb + 212796 >> 2] = fb + 311;
 HEAP32[gb + 212800 >> 2] = fb + 485;
 HEAP32[gb + 212804 >> 2] = fb + 312;
 HEAP32[gb + 212808 >> 2] = fb + 486;
 HEAP32[gb + 212812 >> 2] = fb + 127;
 HEAP32[gb + 212816 >> 2] = fb + 313;
 HEAP32[gb + 212820 >> 2] = fb + 104;
 HEAP32[gb + 12344 >> 2] = (HEAP32[gb + 12344 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12348 >> 2] = (HEAP32[gb + 12348 >> 2] | 0) + (gb + 1080868 | 0);
 HEAP32[gb + 12360 >> 2] = (HEAP32[gb + 12360 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12368 >> 2] = (HEAP32[gb + 12368 >> 2] | 0) + (gb + 12376 | 0);
 HEAP32[gb + 12376 >> 2] = (HEAP32[gb + 12376 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 12380 >> 2] = (HEAP32[gb + 12380 >> 2] | 0) + (gb + 1080886 | 0);
 runPostSets236();
}
function __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EE11ClassIDTypez(i22, i2, i1) {
 i22 = i22 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24 + 8 | 0;
 i18 = i24;
 i23 = i24 + 32 | 0;
 i7 = i24 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i9 = HEAP32[gb + 1104264 >> 2] | 0;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = i18;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 4 >> 2] = i20;
 HEAP32[i23 >> 2] = 0;
 i19 = i23 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i23 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i18);
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i1 = i21;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i2) | 0;
 if (i1 | 0) {
  HEAP32[i20 >> 2] = 1;
  i18 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i23 >> 2] = i18;
  HEAP32[i19 >> 2] = 1;
  HEAP32[i18 >> 2] = i1;
 }
 i18 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i7 >> 2] = i18 + 4;
 if ((i1 | 0) != -1) do {
  i18 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
  i2 = i18;
  if (i18 | 0) {
   i3 = HEAP32[i19 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i20 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i20 >> 2] = i1;
     HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 2, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i18 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
     HEAP32[i20 >> 2] = i1;
     HEAP32[i23 >> 2] = i18;
     break;
    }
   } while (0);
   HEAP32[i19 >> 2] = i4;
   HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  }
  i18 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i1 = HEAP32[i18 >> 2] | 0;
  HEAP32[i7 >> 2] = i18 + 4;
 } while ((i1 | 0) != -1);
 i16 = i9 + 28 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i17 = i9 + 32 | 0;
 i15 = HEAP32[i17 >> 2] | 0;
 i18 = i1 + (i15 << 3) | 0;
 L19 : do if (!i15) i8 = 19; else {
  i3 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) do {
   i15 = HEAP32[i1 >> 2] | 0;
   if (!((i3 | 0) == (i15 | 0) | (i2 | 0) == (i15 | 0))) {
    i8 = 19;
    break L19;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i18 | 0)); else do {
   if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i8 = 19;
    break L19;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i18 | 0));
 } while (0);
 if ((i8 | 0) == 19) if ((i1 | 0) != (i18 | 0)) {
  i12 = i22 + 12 | 0;
  i13 = i22 + 16 | 0;
  i14 = i22 + 4 | 0;
  i15 = i9 + 20 | 0;
  i10 = i9 + 8 | 0;
  i11 = i9 + 4 | 0;
  i8 = i9 + 12 | 0;
  do {
   i3 = HEAP32[i19 >> 2] | 0;
   L33 : do if (i3 | 0) {
    i7 = i1 + 4 | 0;
    i4 = HEAP32[i23 >> 2] | 0;
    i5 = (HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0) >>> 21;
    i2 = 0;
    while (1) {
     i9 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
     i2 = i2 + 1 | 0;
     if ((i5 - (HEAP32[i9 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i9 + 28 >> 2] | 0) >>> 0) break;
     if (i2 >>> 0 >= i3 >>> 0) break L33;
    }
    i3 = HEAP32[i12 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i13 >> 2] = i2;
      HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i2 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
      HEAP32[i13 >> 2] = i2;
      HEAP32[i22 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i4;
    HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i7 >> 2];
   } while (0);
   i1 = i1 + 8 | 0;
   L47 : do if ((i1 | 0) == (i18 | 0)) i1 = i18; else {
    i3 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((HEAP8[i10 >> 0] | 0) != 0 & (HEAP32[i11 >> 2] | 0) != 0) while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     if (!((i3 | 0) == (i9 | 0) | (i2 | 0) == (i9 | 0))) break L47;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i18;
      break;
     }
    } else while (1) {
     if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L47;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i18;
      break;
     }
    }
   } while (0);
  } while ((i1 | 0) != ((HEAP32[i16 >> 2] | 0) + (HEAP32[i17 >> 2] << 3) | 0));
 }
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i21);
 HEAP32[i23 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E(i23, i22) {
 i23 = i23 | 0;
 i22 = i22 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 f1 = Math_fround(HEAPF32[i22 >> 2]);
 i20 = f1 == Math_fround(0.0);
 i19 = i22 + 4 | 0;
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 if (i20 & f2 == Math_fround(0.0)) if (Math_fround(HEAPF32[i22 + 8 >> 2]) == Math_fround(0.0)) return;
 i20 = i23 + 44 | 0;
 f21 = Math_fround(HEAPF32[i20 >> 2]);
 i15 = i23 + 40 | 0;
 f16 = Math_fround(HEAPF32[i15 >> 2]);
 i17 = i23 + 36 | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 f14 = Math_fround(f18 + f1);
 f1 = Math_fround(f16 + f2);
 i3 = i22 + 8 | 0;
 f2 = Math_fround(f21 + Math_fround(HEAPF32[i3 >> 2]));
 i24 = f14 == Math_fround(0.0) & f1 == Math_fround(0.0) & f2 == Math_fround(0.0);
 f5 = Math_fround(f21 * Math_fround(0.0));
 f6 = Math_fround(f16 * Math_fround(-0.0));
 f10 = Math_fround(f21 * f18);
 f8 = Math_fround(Math_fround(0.0) - Math_fround(f21 * f21));
 f12 = Math_fround(f16 * f16);
 f7 = Math_fround(f16 * f18);
 f4 = Math_fround(f8 - f12);
 f5 = Math_fround(Math_fround(f5 + f5) + f7);
 f6 = Math_fround(f6 + Math_fround(f6 + f10));
 f26 = Math_fround(f21 * Math_fround(-0.0));
 f25 = Math_fround(f21 * f16);
 f9 = Math_fround(f18 * Math_fround(0.0));
 f13 = Math_fround(f18 * f18);
 f7 = Math_fround(Math_fround(f26 + f26) + f7);
 f8 = Math_fround(f8 - f13);
 f9 = Math_fround(f9 + Math_fround(f25 + f9));
 f26 = Math_fround(f16 * Math_fround(0.0));
 f11 = Math_fround(f18 * Math_fround(-0.0));
 f10 = Math_fround(f26 + Math_fround(f26 + f10));
 f11 = Math_fround(f11 + Math_fround(f25 + f11));
 f12 = Math_fround(Math_fround(Math_fround(-f13) - f12) + Math_fround(0.0));
 f13 = Math_fround(HEAPF32[i23 + 48 >> 2]);
 if (i24) {
  f4 = Math_fround(f4 * f13);
  f5 = Math_fround(f5 * f13);
  f6 = Math_fround(f6 * f13);
  f7 = Math_fround(f7 * f13);
  f8 = Math_fround(f8 * f13);
  f9 = Math_fround(f9 * f13);
  f14 = Math_fround(f10 * f13);
  f25 = Math_fround(f11 * f13);
  f26 = Math_fround(f12 * f13);
  HEAPF32[i23 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i23 >> 2]));
  i24 = i23 + 4 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 8 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 12 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 16 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 20 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 24 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 28 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 32 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i24 >> 2]));
 } else {
  f34 = Math_fround(f2 * Math_fround(0.0));
  f33 = Math_fround(f1 * Math_fround(-0.0));
  f27 = Math_fround(f14 * f2);
  f30 = Math_fround(Math_fround(0.0) - Math_fround(f2 * f2));
  f26 = Math_fround(f1 * f1);
  f32 = Math_fround(f14 * f1);
  f31 = Math_fround(f2 * Math_fround(-0.0));
  f25 = Math_fround(f1 * f2);
  f29 = Math_fround(f14 * Math_fround(0.0));
  f2 = Math_fround(f14 * f14);
  f28 = Math_fround(f1 * Math_fround(0.0));
  f1 = Math_fround(f14 * Math_fround(-0.0));
  f4 = Math_fround(Math_fround(f4 - Math_fround(f30 - f26)) * f13);
  f5 = Math_fround(Math_fround(f5 - Math_fround(f32 + Math_fround(f34 + f34))) * f13);
  f6 = Math_fround(Math_fround(f6 - Math_fround(f33 + Math_fround(f33 + f27))) * f13);
  f7 = Math_fround(Math_fround(f7 - Math_fround(f32 + Math_fround(f31 + f31))) * f13);
  f8 = Math_fround(Math_fround(f8 - Math_fround(f30 - f2)) * f13);
  f9 = Math_fround(Math_fround(f9 - Math_fround(f29 + Math_fround(f29 + f25))) * f13);
  f14 = Math_fround(Math_fround(f10 - Math_fround(f28 + Math_fround(f28 + f27))) * f13);
  f25 = Math_fround(Math_fround(f11 - Math_fround(f1 + Math_fround(f1 + f25))) * f13);
  f26 = Math_fround(Math_fround(f12 - Math_fround(Math_fround(Math_fround(-f2) - f26) + Math_fround(0.0))) * f13);
  HEAPF32[i23 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i23 >> 2]));
  i24 = i23 + 4 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 8 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 12 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 16 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 20 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 24 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 28 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i24 >> 2]));
  i24 = i23 + 32 | 0;
  HEAPF32[i24 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i24 >> 2]));
 }
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + f18);
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f16);
 HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f21);
 return;
}

function __ZL22ConvertImageToRGBM_JobP17ImageSliceJobDataj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20;
 i16 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i18 = HEAP32[i16 + 4 >> 2] | 0;
 i19 = HEAP32[i16 + 12 >> 2] | 0;
 i16 = HEAP32[i16 + 16 >> 2] | 0;
 i3 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i14 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 if ((i3 | 0) >= (i14 | 0)) {
  STACKTOP = i20;
  return;
 }
 i15 = (i18 | 0) > 0;
 do {
  if (i15) {
   i11 = 0;
   i12 = i16 + (Math_imul(i3, i19) | 0) | 0;
   while (1) {
    i13 = i12 + 4 | 0;
    f4 = Math_fround(HEAPF32[i13 >> 2]);
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f5 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    i2 = i12 + 8 | 0;
    f4 = Math_fround(HEAPF32[i2 >> 2]);
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f6 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    i1 = i12 + 12 | 0;
    f4 = Math_fround(HEAPF32[i1 >> 2]);
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f7 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    i21 = f7 < Math_fround(.0100228256);
    f10 = f5 < f6 ? f6 : f5;
    f8 = i21 ? Math_fround(.0100228256) : f7;
    f10 = Math_fround(Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+Math_pow(+(f10 < f8 ? f8 : f10), .454545438)) * Math_fround(.200000003)) * Math_fround(255.0)))) / Math_fround(255.0));
    f8 = Math_fround(+Math_pow(+Math_fround(f10 * Math_fround(5.0)), 2.20000005));
    HEAPF32[i12 >> 2] = f10;
    f4 = Math_fround(f5 / f8);
    i21 = f4 > Math_fround(1.0);
    i22 = f4 < Math_fround(0.0);
    f4 = i22 ? Math_fround(0.0) : f4;
    f4 = i21 ? Math_fround(1.0) : f4;
    do if (!(f4 <= Math_fround(0.0))) {
     if (f4 <= Math_fround(.00313080009)) {
      f9 = Math_fround(f4 * Math_fround(12.9200001));
      break;
     }
     if (f4 < Math_fround(1.0)) {
      f9 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f4 == Math_fround(1.0)) f9 = Math_fround(1.0); else f9 = Math_fround(+Math_pow(+f4, .454545468));
    } else f9 = Math_fround(0.0); while (0);
    HEAPF32[i13 >> 2] = f9;
    f4 = Math_fround(f6 / f8);
    i22 = f4 > Math_fround(1.0);
    i21 = f4 < Math_fround(0.0);
    f4 = i21 ? Math_fround(0.0) : f4;
    f4 = i22 ? Math_fround(1.0) : f4;
    do if (!(f4 <= Math_fround(0.0))) {
     if (f4 <= Math_fround(.00313080009)) {
      f5 = Math_fround(f4 * Math_fround(12.9200001));
      break;
     }
     if (f4 < Math_fround(1.0)) {
      f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f4 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f4, .454545468));
    } else f5 = Math_fround(0.0); while (0);
    HEAPF32[i2 >> 2] = f5;
    f4 = Math_fround(f7 / f8);
    i22 = f4 > Math_fround(1.0);
    i21 = f4 < Math_fround(0.0);
    f4 = i21 ? Math_fround(0.0) : f4;
    f4 = i22 ? Math_fround(1.0) : f4;
    do if (!(f4 <= Math_fround(0.0))) {
     if (f4 <= Math_fround(.00313080009)) {
      f4 = Math_fround(f4 * Math_fround(12.9200001));
      break;
     }
     if (f4 < Math_fround(1.0)) {
      f4 = Math_fround(Math_fround(Math_fround(+Math_pow(+f4, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
      break;
     }
     if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, .454545468));
    } else f4 = Math_fround(0.0); while (0);
    HEAPF32[i1 >> 2] = f4;
    HEAPF32[i17 >> 2] = Math_fround(1.0);
    i22 = f10 > Math_fround(1.0);
    HEAP32[i12 >> 2] = HEAP32[(i22 ? i17 : i12) >> 2];
    HEAPF32[i17 >> 2] = Math_fround(1.0);
    i22 = f9 > Math_fround(1.0);
    HEAP32[i13 >> 2] = HEAP32[(i22 ? i17 : i13) >> 2];
    HEAPF32[i17 >> 2] = Math_fround(1.0);
    i22 = f5 > Math_fround(1.0);
    HEAP32[i2 >> 2] = HEAP32[(i22 ? i17 : i2) >> 2];
    HEAPF32[i17 >> 2] = Math_fround(1.0);
    i22 = f4 > Math_fround(1.0);
    HEAP32[i1 >> 2] = HEAP32[(i22 ? i17 : i1) >> 2];
    i11 = i11 + 1 | 0;
    if ((i11 | 0) == (i18 | 0)) break; else i12 = i12 + 16 | 0;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i14 | 0));
 STACKTOP = i20;
 return;
}

function __ZL28GeomOverlapCallback_PlaneBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i5, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f33 = Math_fround(f6 + f6);
 f34 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(f34 + f34);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f16 = Math_fround(f12 + f12);
 f14 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f30 = Math_fround(f33 * f14);
 f29 = Math_fround(f11 * f14);
 f14 = Math_fround(f14 * f16);
 f13 = Math_fround(f6 * f11);
 f32 = Math_fround(f6 * f16);
 f11 = Math_fround(f34 * f11);
 f34 = Math_fround(f34 * f16);
 f16 = Math_fround(f12 * f16);
 f12 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f16);
 f15 = Math_fround(f13 + f14);
 f17 = Math_fround(f32 - f29);
 f14 = Math_fround(f13 - f14);
 f33 = Math_fround(Math_fround(1.0) - Math_fround(f6 * f33));
 f16 = Math_fround(f33 - f16);
 f6 = Math_fround(f34 + f30);
 f29 = Math_fround(f32 + f29);
 f30 = Math_fround(f34 - f30);
 f11 = Math_fround(f33 - f11);
 f33 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f34 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i2, i4);
 f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f26 = Math_fround(f29 * f31);
 f27 = Math_fround(f30 * f31);
 f28 = Math_fround(f11 * f31);
 f19 = Math_fround(f14 * f18);
 f20 = Math_fround(f16 * f18);
 f21 = Math_fround(f6 * f18);
 f18 = Math_fround(-f18);
 f14 = Math_fround(f14 * f18);
 f16 = Math_fround(f16 * f18);
 f18 = Math_fround(f6 * f18);
 f31 = Math_fround(-f31);
 f29 = Math_fround(f29 * f31);
 f30 = Math_fround(f30 * f31);
 f31 = Math_fround(f11 * f31);
 f11 = Math_fround(Math_fround(-1.0) * f13);
 f6 = Math_fround(f12 * f11);
 f10 = Math_fround(f15 * f11);
 f11 = Math_fround(f17 * f11);
 f7 = Math_fround(f6 + f14);
 f8 = Math_fround(f10 + f16);
 f9 = Math_fround(f11 + f18);
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f9 + f31))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f7 + f29))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f8 + f30)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f9 + f28))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f7 + f26))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f8 + f27)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 f8 = Math_fround(f6 + f19);
 f7 = Math_fround(f10 + f20);
 f6 = Math_fround(f11 + f21);
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f31))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f29))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f30)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f28))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f26))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f27)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 f10 = Math_fround(f12 * f13);
 f11 = Math_fround(f15 * f13);
 f9 = Math_fround(f17 * f13);
 f8 = Math_fround(f10 + f14);
 f7 = Math_fround(f11 + f16);
 f6 = Math_fround(f9 + f18);
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f31))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f29))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f30)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f28))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f26))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f27)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 f8 = Math_fround(f10 + f19);
 f7 = Math_fround(f11 + f20);
 f6 = Math_fround(f9 + f21);
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f31))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f29))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f30)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 if (Math_fround(f25 + Math_fround(Math_fround(f24 * Math_fround(f32 + Math_fround(f6 + f28))) + Math_fround(Math_fround(f22 * Math_fround(f33 + Math_fround(f8 + f26))) + Math_fround(f23 * Math_fround(f34 + Math_fround(f7 + f27)))))) <= Math_fround(0.0)) {
  i5 = 1;
  STACKTOP = i1;
  return i5 | 0;
 }
 i5 = 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN5physx2Gu16rayAABBIntersectERKNS_6PxVec3ES3_S3_S3_RS1_(i13, i17, i12, i15, i16) {
 i13 = i13 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18;
 HEAPF32[i11 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(-1.0);
 f3 = Math_fround(HEAPF32[i12 >> 2]);
 f1 = Math_fround(HEAPF32[i13 >> 2]);
 if (f3 < f1) {
  HEAPF32[i16 >> 2] = f1;
  i2 = HEAP32[i15 >> 2] | 0;
  if (!i2) {
   f8 = Math_fround(-1.0);
   i2 = 0;
  } else {
   f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f5 = Math_fround(HEAPF32[i13 >> 2]);
   f8 = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i12 >> 2])) / f8);
   HEAPF32[i11 >> 2] = f8;
   i2 = 0;
  }
 } else {
  f1 = Math_fround(HEAPF32[i17 >> 2]);
  if (f3 > f1) {
   HEAPF32[i16 >> 2] = f1;
   i2 = HEAP32[i15 >> 2] | 0;
   if (!i2) {
    f8 = Math_fround(-1.0);
    i2 = 0;
   } else {
    f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f5 = Math_fround(HEAPF32[i17 >> 2]);
    f8 = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i12 >> 2])) / f8);
    HEAPF32[i11 >> 2] = f8;
    i2 = 0;
   }
  } else {
   f8 = Math_fround(-1.0);
   i2 = 1;
  }
 }
 i9 = i12 + 4 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i13 + 4 | 0;
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 if (f3 < f1) {
  HEAPF32[i16 + 4 >> 2] = f1;
  i2 = HEAP32[i15 + 4 >> 2] | 0;
  if (!i2) {
   f5 = Math_fround(-1.0);
   i2 = 0;
  } else {
   f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i9 >> 2])) / f5);
   HEAPF32[i11 + 4 >> 2] = f5;
   i2 = 0;
  }
 } else {
  i4 = i17 + 4 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  if (f3 > f1) {
   HEAPF32[i16 + 4 >> 2] = f1;
   i2 = HEAP32[i15 + 4 >> 2] | 0;
   if (!i2) {
    f5 = Math_fround(-1.0);
    i2 = 0;
   } else {
    f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(HEAPF32[i4 >> 2]);
    f5 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i9 >> 2])) / f5);
    HEAPF32[i11 + 4 >> 2] = f5;
    i2 = 0;
   }
  } else f5 = Math_fround(-1.0);
 }
 i6 = i12 + 8 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i13 + 8 | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 do if (f3 < f1) {
  HEAPF32[i16 + 8 >> 2] = f1;
  i2 = HEAP32[i15 + 8 >> 2] | 0;
  if (!i2) f1 = Math_fround(-1.0); else {
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i7 >> 2]);
   f1 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i6 >> 2])) / f1);
   HEAPF32[i11 + 8 >> 2] = f1;
  }
 } else {
  i4 = i17 + 8 | 0;
  f1 = Math_fround(HEAPF32[i4 >> 2]);
  if (f3 > f1) {
   HEAPF32[i16 + 8 >> 2] = f1;
   i2 = HEAP32[i15 + 8 >> 2] | 0;
   if (!i2) {
    f1 = Math_fround(-1.0);
    break;
   }
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f3 = Math_fround(HEAPF32[i4 >> 2]);
   f1 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i6 >> 2])) / f1);
   HEAPF32[i11 + 8 >> 2] = f1;
   break;
  }
  if (!i2) f1 = Math_fround(-1.0); else {
   HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 } while (0);
 i2 = f5 > f8 & 1;
 i4 = f1 > Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]);
 i2 = i4 ? 2 : i2;
 i11 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i11 | 0) < 0) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 do if (!i2) i14 = 15; else {
  f1 = Math_fround(HEAPF32[i12 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i15 >> 2])));
  HEAPF32[i16 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i13 >> 2]) + Math_fround(-9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i17 >> 2]) + Math_fround(9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  } else if ((i2 | 0) == 1) break; else {
   i14 = 15;
   break;
  }
 } while (0);
 if ((i14 | 0) == 15) {
  f1 = Math_fround(HEAPF32[i9 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i15 + 4 >> 2])));
  HEAPF32[i16 + 4 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(-9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i17 + 4 >> 2]) + Math_fround(9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 if (!i4) {
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i15 + 8 >> 2])));
  HEAPF32[i16 + 8 >> 2] = f1;
  if (f1 < Math_fround(Math_fround(HEAPF32[i7 >> 2]) + Math_fround(-9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
  if (f1 > Math_fround(Math_fround(HEAPF32[i17 + 8 >> 2]) + Math_fround(9.99999974e-06))) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 i17 = 1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN16SpriteRenderData16GenerateQuadMeshERK5RectTIfERK8Vector2ff(i10, i9, i11, f12) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i6 = i10 + 56 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
  i2 = i5;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
  i3 = i5;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1 + 32 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i6 >> 2] = i1;
  i6 = i1;
 } else i6 = i1;
 f7 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(.5));
 f8 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) * Math_fround(.5));
 HEAPF32[i10 + 36 >> 2] = f12;
 f14 = Math_fround(f7 + Math_fround(HEAPF32[i9 >> 2]));
 HEAPF32[i10 + 40 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i11 >> 2]));
 HEAPF32[i10 + 44 >> 2] = f12;
 f14 = Math_fround(f8 + Math_fround(HEAPF32[i9 + 4 >> 2]));
 i5 = i11 + 4 | 0;
 HEAPF32[i10 + 48 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i5 >> 2]));
 i4 = i6 + 8 | 0;
 i1 = i6 + 20 | 0;
 HEAP32[i1 >> 2] = 4;
 i2 = i6 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483644) >>> 0 < 4) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, 80, 4, i6 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i1;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(80, 4, i6 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i2 >> 2] = 4;
  HEAP32[i4 >> 2] = i10;
  i1 = i10;
  break;
 } else i1 = HEAP32[i4 >> 2] | 0; while (0);
 f15 = Math_fround(-f7);
 f14 = Math_fround(Math_fround(f15 - Math_fround(HEAPF32[i11 >> 2])) / f12);
 f16 = Math_fround(Math_fround(f8 - Math_fround(HEAPF32[i5 >> 2])) / f12);
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i1 + 4 >> 2] = f16;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 f16 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i11 >> 2])) / f12);
 f14 = Math_fround(Math_fround(f8 - Math_fround(HEAPF32[i5 >> 2])) / f12);
 HEAPF32[i1 + 20 >> 2] = f16;
 HEAPF32[i1 + 24 >> 2] = f14;
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 f15 = Math_fround(Math_fround(f15 - Math_fround(HEAPF32[i11 >> 2])) / f12);
 f14 = Math_fround(-f8);
 f8 = Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i5 >> 2])) / f12);
 HEAPF32[i1 + 40 >> 2] = f15;
 HEAPF32[i1 + 44 >> 2] = f8;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 f8 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i11 >> 2])) / f12);
 f14 = Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i5 >> 2])) / f12);
 HEAPF32[i1 + 60 >> 2] = f8;
 HEAPF32[i1 + 64 >> 2] = f14;
 HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 i1 = i6 + 28 | 0;
 i2 = i6 + 40 | 0;
 HEAP32[i2 >> 2] = 6;
 i3 = i6 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483646) >>> 0 >= 6) {
  i11 = HEAP32[i1 >> 2] | 0;
  HEAP16[i11 >> 1] = 0;
  i10 = i11 + 2 | 0;
  HEAP16[i10 >> 1] = 1;
  i10 = i11 + 4 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 6 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 8 | 0;
  HEAP16[i10 >> 1] = 1;
  i11 = i11 + 10 | 0;
  HEAP16[i11 >> 1] = 3;
  STACKTOP = i13;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 6;
  i11 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 12, 2, i6 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP16[i11 >> 1] = 0;
  i10 = i11 + 2 | 0;
  HEAP16[i10 >> 1] = 1;
  i10 = i11 + 4 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 6 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 8 | 0;
  HEAP16[i10 >> 1] = 1;
  i11 = i11 + 10 | 0;
  HEAP16[i11 >> 1] = 3;
  STACKTOP = i13;
  return;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 2, i6 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = 6;
  HEAP32[i1 >> 2] = i11;
  HEAP16[i11 >> 1] = 0;
  i10 = i11 + 2 | 0;
  HEAP16[i10 >> 1] = 1;
  i10 = i11 + 4 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 6 | 0;
  HEAP16[i10 >> 1] = 2;
  i10 = i11 + 8 | 0;
  HEAP16[i10 >> 1] = 1;
  i11 = i11 + 10 | 0;
  HEAP16[i11 >> 1] = 3;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx2Gu20pcmContactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i16, i17, i18, i19, i7, i1, i6) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i22 + 336 | 0;
 i14 = i22 + 536 | 0;
 i11 = i22 + 464 | 0;
 i13 = i22 + 368 | 0;
 i15 = i22 + 392 | 0;
 i21 = i22 + 48 | 0;
 i10 = i22 + 32 | 0;
 i20 = i22 + 16 | 0;
 i8 = i22 + 128 | 0;
 i4 = i22;
 i9 = i22 + 64 | 0;
 i5 = HEAP32[i16 + 36 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] & -16;
 i26 = HEAP32[i18 + 4 >> 2] | 0;
 i25 = HEAP32[i18 + 8 >> 2] | 0;
 i24 = HEAP32[i18 + 12 >> 2] | 0;
 i2 = i18 + 16 | 0;
 i23 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i12 + 4 >> 2] = i26;
 HEAP32[i12 + 8 >> 2] = i25;
 HEAP32[i12 + 12 >> 2] = i24;
 HEAP32[i12 + 16 >> 2] = i23;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 24 >> 2] = i2;
 HEAPF32[i12 + 28 >> 2] = Math_fround(0.0);
 i2 = i17 + 4 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i17 + 8 >> 2]) == Math_fround(1.0)) i1 = Math_fround(HEAPF32[i17 + 12 >> 2]) == Math_fround(1.0); else i1 = 0; else i1 = 0;
 HEAP32[i14 >> 2] = 1065353216;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 1065353216;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP32[i14 + 32 >> 2] = 1065353216;
 HEAP32[i14 + 36 >> 2] = 1065353216;
 HEAP32[i14 + 40 >> 2] = 0;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 HEAP32[i14 + 52 >> 2] = 1065353216;
 HEAP32[i14 + 56 >> 2] = 0;
 HEAP32[i14 + 60 >> 2] = 0;
 HEAP32[i14 + 64 >> 2] = 0;
 HEAP32[i14 + 68 >> 2] = 1065353216;
 if (!i1) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i14, i2, i17 + 16 | 0);
 HEAP32[i11 >> 2] = 1065353216;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 1065353216;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 HEAP32[i11 + 40 >> 2] = 0;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 HEAP32[i11 + 52 >> 2] = 1065353216;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = 0;
 HEAP32[i11 + 64 >> 2] = 0;
 HEAP32[i11 + 68 >> 2] = 1065353216;
 i26 = __ZN5physx2Gu16getPCMConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i16, i11, i13, i15) | 0;
 i25 = HEAP32[i16 + 4 >> 2] | 0;
 i24 = HEAP32[i16 + 8 >> 2] | 0;
 i23 = HEAP32[i16 + 12 >> 2] | 0;
 HEAP32[i21 >> 2] = i25;
 HEAP32[i21 + 4 >> 2] = i24;
 HEAP32[i21 + 8 >> 2] = i23;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 f31 = Math_fround(HEAPF32[i5 + 52 >> 2]);
 f30 = Math_fround(HEAPF32[i5 + 56 >> 2]);
 f27 = Math_fround(HEAPF32[i5 + 60 >> 2]);
 f29 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f31 * f29);
 f28 = Math_fround(f30 * f28);
 f27 = Math_fround(f27 * (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f28 = f29 <= f28 ? f29 : f28;
 HEAPF32[i10 >> 2] = Math_fround((f28 <= f27 ? f28 : f27) * Math_fround(.25));
 i23 = HEAP32[i16 + 20 >> 2] | 0;
 i24 = HEAP32[i16 + 24 >> 2] | 0;
 i25 = HEAP32[i16 + 28 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i20 + 4 >> 2] = i23;
 HEAP32[i20 + 8 >> 2] = i24;
 HEAP32[i20 + 12 >> 2] = i25;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i8, i5, i4, i21, i20);
 if (i26) {
  HEAP32[i9 + 32 >> 2] = i12;
  HEAP32[i9 + 36 >> 2] = i8 + 96;
  HEAP32[i9 + 40 >> 2] = i8 + 144;
  HEAP8[i9 + 44 >> 0] = 1;
  HEAP32[i9 >> 2] = gb + 84224 + 8;
  HEAP32[i9 + 48 >> 2] = i8;
  i26 = __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE(i15, i9, i10, i13, i17, i18, i19, Math_fround(HEAPF32[i7 >> 2]), i6, i11, i14, 1, i1, i3) | 0;
  STACKTOP = i22;
  return i26 | 0;
 } else {
  HEAP32[i9 + 32 >> 2] = i12;
  HEAP32[i9 + 36 >> 2] = i8 + 96;
  HEAP32[i9 + 40 >> 2] = i8 + 144;
  HEAP8[i9 + 44 >> 0] = 0;
  HEAP32[i9 >> 2] = gb + 84252 + 8;
  HEAP32[i9 + 48 >> 2] = i8;
  i26 = __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE(i15, i9, i10, i13, i17, i18, i19, Math_fround(HEAPF32[i7 >> 2]), i6, i11, i14, 0, i1, i3) | 0;
  STACKTOP = i22;
  return i26 | 0;
 }
 return 0;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i29, i30, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 44 | 0;
 i25 = i28 + 40 | 0;
 i26 = i28 + 20 | 0;
 i27 = i28;
 i1 = i29 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i29 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i25, 4); else {
  HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 };
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 i10 = i26 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i30 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i30, HEAP32[i11 >> 2] | 0);
 i12 = i30 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i30 >> 2] = i11;
 HEAP32[i11 >> 2] = 0;
 if ((HEAP32[i25 >> 2] | 0) <= 0) {
  STACKTOP = i28;
  return;
 }
 i13 = i26 + 16 | 0;
 i14 = i26 + 11 | 0;
 i15 = i26 + 4 | 0;
 i16 = i27 + 12 | 0;
 i9 = i27 + 12 | 0;
 i17 = i24 + 4 | 0;
 i18 = i27 + 8 | 0;
 i19 = i27 + 4 | 0;
 i20 = i27 + 16 | 0;
 i21 = i30 + 4 | 0;
 i22 = i27 + 11 | 0;
 i23 = i24 + 4 | 0;
 i8 = 0;
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i29, i26, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i29);
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i13, i29);
  i3 = HEAP8[i14 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i26 >> 2] | 0 : i26;
  i3 = i1 ? HEAP32[i15 >> 2] | 0 : i3 & 255;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i16 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i27);
   i1 = HEAP32[i9 >> 2] | 0;
   i4 = 12;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i22 >> 0] = i3;
   if (!i3) i1 = i27; else {
    i1 = i27;
    i4 = 14;
   }
  } else i4 = 12;
  if ((i4 | 0) == 12) {
   i7 = i3 + 16 & -16;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i17 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i27 >> 2] = i1;
   HEAP32[i18 >> 2] = i7 | -2147483648;
   HEAP32[i19 >> 2] = i3;
   i4 = 14;
  }
  if ((i4 | 0) == 14) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
  i1 = HEAP32[i11 >> 2] | 0;
  do if (!i1) {
   i2 = i11;
   i3 = i11;
  } else {
   i6 = HEAP8[i22 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i6 = i7 ? HEAP32[i19 >> 2] | 0 : i6 & 255;
   i7 = i7 ? HEAP32[i27 >> 2] | 0 : i27;
   while (1) {
    i3 = i1 + 16 | 0;
    i5 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
    i2 = i5 >>> 0 < i6 >>> 0 ? i5 : i6;
    if (!i2) i4 = 19; else {
     i2 = _memcmp(i7, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
     if (!i2) i4 = 19; else if ((i2 | 0) < 0) i4 = 21; else i4 = 23;
    }
    if ((i4 | 0) == 19) if (i6 >>> 0 < i5 >>> 0) i4 = 21; else i4 = 23;
    if ((i4 | 0) == 21) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 22;
      break;
     } else i1 = i2;
    } else if ((i4 | 0) == 23) {
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 25;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 22) {
    i4 = 0;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 25) {
    i4 = 0;
    i2 = i1;
    break;
   }
  } while (0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i24, i30, i27);
  i1 = HEAP32[i24 >> 2] | 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i30 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i1);
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  if ((HEAP8[i22 >> 0] | 0) < 0) {
   i7 = HEAP32[i27 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i23 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i24);
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (HEAP32[i25 >> 2] | 0));
 if ((HEAP8[i14 >> 0] | 0) >= 0) {
  STACKTOP = i28;
  return;
 }
 i30 = HEAP32[i26 >> 2] | 0;
 i29 = HEAP32[i26 + 12 >> 2] | 0;
 HEAP32[i24 >> 2] = 66;
 HEAP32[i24 + 4 >> 2] = i29;
 __Z19free_alloc_internalPvRK10MemLabelId(i30, i24);
 STACKTOP = i28;
 return;
}

function __ZN12_GLOBAL__N_120RevoluteJointProjectEPKvRN5physx11PxTransformES4_b(i22, i18, i19, i23) {
 i22 = i22 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i23 = i23 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 84 | 0;
 i21 = i25 + 56 | 0;
 i6 = i25 + 28 | 0;
 i24 = i25;
 __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i22, i18, i19, i20, i21, i6);
 f5 = Math_fround(HEAPF32[i22 + 124 >> 2]);
 f1 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f4 = Math_fround(f1 * f1);
 f2 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f2 * f2));
 f3 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f3 * f3));
 i17 = f4 > Math_fround(f5 * f5);
 if (i17) {
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f3 = Math_fround(f5 * Math_fround(f3 * f16));
  f2 = Math_fround(f5 * Math_fround(f2 * f16));
  f1 = Math_fround(f5 * Math_fround(f1 * f16));
 }
 HEAPF32[i24 + 16 >> 2] = f1;
 HEAPF32[i24 + 20 >> 2] = f2;
 HEAPF32[i24 + 24 >> 2] = f3;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 i11 = f1 != Math_fround(0.0);
 f2 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 if (i11) {
  f16 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(0.0)) + Math_fround(f2 * f2)))));
  f14 = Math_fround(f1 * f16);
  f15 = Math_fround(f16 * Math_fround(0.0));
  f16 = Math_fround(f2 * f16);
 } else {
  f14 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f16 = Math_fround(1.0);
 }
 f26 = Math_fround(-f14);
 f29 = Math_fround(-f15);
 f3 = Math_fround(Math_fround(f2 * f26) + Math_fround(f16 * f1));
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f12 = Math_fround(f5 * f29);
 f3 = Math_fround(f3 + f12);
 f27 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f13 = Math_fround(f27 * f29);
 f3 = Math_fround(f3 - f13);
 f28 = Math_fround(f2 * f29);
 f29 = Math_fround(f1 * f29);
 f4 = Math_fround(Math_fround(Math_fround(f28 + Math_fround(f16 * f5)) + Math_fround(f27 * f26)) - f29);
 f5 = Math_fround(Math_fround(f29 + Math_fround(f28 + Math_fround(f16 * f27))) - Math_fround(f5 * f26));
 f1 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f2) - Math_fround(f1 * f26)) - f12) - f13);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 f13 = Math_fround(Math_fround(HEAPF32[i22 + 128 >> 2]) * Math_fround(.5));
 f12 = Math_fround(+Math_sin(+f13));
 f13 = Math_fround(+Math_cos(+f13));
 if (f12 > Math_fround(.999899983)) i9 = 0; else {
  if (!(f1 >= Math_fround(0.0))) {
   f27 = Math_fround(-f3);
   f28 = Math_fround(-f4);
   f29 = Math_fround(-f5);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i9 = i8;
   i10 = i7;
   i11 = i6;
  }
  f5 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(f5 * f5);
  f4 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f4 * f4) + f3);
  f2 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f2 * f2) + f3);
  i11 = f3 > Math_fround(f12 * f12);
  i9 = i11 & 1;
  if (i11) {
   f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
   f28 = Math_fround(Math_fround(f12 * f5) * f29);
   f1 = Math_fround(Math_fround(f12 * f4) * f29);
   f29 = Math_fround(Math_fround(f12 * f2) * f29);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   f1 = f13;
   i6 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  }
 }
 if (i9 << 24 >> 24 == 0 & (i17 ^ 1)) {
  STACKTOP = i25;
  return;
 }
 f13 = Math_fround(f14 * f1);
 f12 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f13 + Math_fround(f16 * f12));
 f28 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f29 = Math_fround(f15 * f28);
 f13 = Math_fround(f29 + f13);
 f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f15 * f5);
 f4 = Math_fround(f15 * f1);
 f15 = Math_fround(f15 * f12);
 f27 = Math_fround(Math_fround(Math_fround(f14 * f5) + Math_fround(f4 + Math_fround(f16 * f28))) - f15);
 f28 = Math_fround(Math_fround(Math_fround(f4 + Math_fround(f16 * f5)) + f15) - Math_fround(f14 * f28));
 f29 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f1) - Math_fround(f14 * f12)) - f29) - f26);
 HEAPF32[i24 >> 2] = Math_fround(f13 - f26);
 HEAPF32[i24 + 4 >> 2] = f27;
 HEAPF32[i24 + 8 >> 2] = f28;
 HEAPF32[i24 + 12 >> 2] = f29;
 __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i18, i19, i20, i21, i24, i22, i23);
 STACKTOP = i25;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 65;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 65;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EE11ClassIDTypez(i21, i2, i1) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i23 + 8 | 0;
 i17 = i23;
 i22 = i23 + 32 | 0;
 i7 = i23 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i10 = HEAP32[gb + 1104264 >> 2] | 0;
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i17;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i22 >> 2] = 0;
 i18 = i22 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i22 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i17);
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i2) | 0;
 if (i1 | 0) {
  HEAP32[i19 >> 2] = 1;
  i17 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i22 >> 2] = i17;
  HEAP32[i18 >> 2] = 1;
  HEAP32[i17 >> 2] = i1;
 }
 i17 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i1 = HEAP32[i17 >> 2] | 0;
 HEAP32[i7 >> 2] = i17 + 4;
 if ((i1 | 0) != -1) do {
  i17 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
  i2 = i17;
  if (i17 | 0) {
   i3 = HEAP32[i18 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i19 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i19 >> 2] = i1;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i17 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i22 >> 2] = i17;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i4;
   HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  }
  i17 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i7 >> 2] = i17 + 4;
 } while ((i1 | 0) != -1);
 i15 = i10 + 28 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i16 = i10 + 32 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 i17 = i1 + (i14 << 3) | 0;
 L19 : do if (!i14) i8 = 19; else {
  i3 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = HEAP32[i10 + 12 >> 2] | 0;
  if ((HEAP8[i10 + 8 >> 0] | 0) != 0 & (HEAP32[i10 + 4 >> 2] | 0) != 0) do {
   i14 = HEAP32[i1 >> 2] | 0;
   if (!((i3 | 0) == (i14 | 0) | (i2 | 0) == (i14 | 0))) {
    i8 = 19;
    break L19;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i17 | 0)); else do {
   if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i8 = 19;
    break L19;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i17 | 0));
 } while (0);
 if ((i8 | 0) == 19) if ((i1 | 0) != (i17 | 0)) {
  i11 = i21 + 12 | 0;
  i12 = i21 + 16 | 0;
  i13 = i21 + 4 | 0;
  i14 = i10 + 20 | 0;
  i8 = i10 + 8 | 0;
  i9 = i10 + 4 | 0;
  i7 = i10 + 12 | 0;
  do {
   i3 = HEAP32[i18 >> 2] | 0;
   L33 : do if (i3 | 0) {
    i4 = HEAP32[i22 >> 2] | 0;
    i5 = (HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0) >>> 21;
    i2 = 0;
    while (1) {
     i10 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
     i2 = i2 + 1 | 0;
     if ((i5 - (HEAP32[i10 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i10 + 28 >> 2] | 0) >>> 0) break;
     if (i2 >>> 0 >= i3 >>> 0) break L33;
    }
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i12 >> 2] = i2;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i2;
      HEAP32[i21 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[(HEAP32[i21 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
   } while (0);
   i1 = i1 + 8 | 0;
   L47 : do if ((i1 | 0) == (i17 | 0)) i1 = i17; else {
    i3 = HEAP32[i14 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((HEAP8[i8 >> 0] | 0) != 0 & (HEAP32[i9 >> 2] | 0) != 0) while (1) {
     i10 = HEAP32[i1 >> 2] | 0;
     if (!((i3 | 0) == (i10 | 0) | (i2 | 0) == (i10 | 0))) break L47;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i17 | 0)) {
      i1 = i17;
      break;
     }
    } else while (1) {
     if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L47;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i17 | 0)) {
      i1 = i17;
      break;
     }
    }
   } while (0);
  } while ((i1 | 0) != ((HEAP32[i15 >> 2] | 0) + (HEAP32[i16 >> 2] << 3) | 0));
 }
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i23;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i20);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRT_RKS7_SA_j(i20, i21, i22, i11) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i23;
 i17 = i21 + 11 | 0;
 i15 = HEAP8[i17 >> 0] | 0;
 i2 = i15 << 24 >> 24 < 0;
 i18 = i21 + 4 | 0;
 switch ((i2 ? HEAP32[i18 >> 2] | 0 : i15 & 255) | 0) {
 case 1:
  {
   i19 = 2;
   break;
  }
 case 0:
  {
   STACKTOP = i23;
   return;
  }
 default:
  {}
 }
 if ((i19 | 0) == 2) {
  i15 = HEAP8[i22 + 11 >> 0] | 0;
  i5 = i15 << 24 >> 24 < 0;
  if (((i5 ? HEAP32[i22 + 4 >> 2] | 0 : i15 & 255) | 0) == 1) {
   i4 = HEAP8[i20 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i1 = i3 ? HEAP32[i20 >> 2] | 0 : i20;
   i20 = i3 ? HEAP32[i20 + 4 >> 2] | 0 : i4 & 255;
   i4 = i1 + i20 | 0;
   i3 = i2 ? HEAP32[i21 >> 2] | 0 : i21;
   i2 = i5 ? HEAP32[i22 >> 2] | 0 : i22;
   if (!i20) {
    STACKTOP = i23;
    return;
   }
   do {
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0)) HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   STACKTOP = i23;
   return;
  }
 };
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i14 = i20 + 11 | 0;
 i2 = HEAP8[i14 >> 0] | 0;
 i15 = i20 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i16, i2 << 24 >> 24 < 0 ? HEAP32[i15 >> 2] | 0 : i2 & 255);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i16, i20, 0, i11) | 0;
 i2 = HEAP8[i14 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i10 = i3 ? HEAP32[i20 >> 2] | 0 : i20;
 i2 = i3 ? HEAP32[i15 >> 2] | 0 : i2 & 255;
 i3 = HEAP8[i17 >> 0] | 0;
 i13 = i3 << 24 >> 24 < 0;
 i8 = i13 ? HEAP32[i21 >> 2] | 0 : i21;
 i3 = i13 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
 L15 : do if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) i19 = 20; else {
  if (!i3) i1 = i11; else {
   i1 = i10 + i11 | 0;
   i9 = i10 + i2 | 0;
   i6 = i8 + i3 | 0;
   i7 = i9;
   L19 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
    i4 = i9 + (1 - i3) | 0;
    if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
     i5 = HEAP8[i8 >> 0] | 0;
     L22 : while (1) {
      while (1) {
       if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
        i2 = i8;
        i3 = i1;
        break;
       }
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i4 | 0)) {
        i1 = i7;
        break L19;
       }
      }
      do {
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i6 | 0)) break L22;
       i3 = i3 + 1 | 0;
      } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i7;
       break L19;
      }
     }
    }
   } while (0);
   if ((i1 | 0) == (i9 | 0)) {
    i19 = 20;
    break;
   } else i1 = i1 - i10 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i16, i20, i11, i1 - i11 | 0) | 0;
  if ((i1 | 0) != -1) {
   i12 = i22 + 11 | 0;
   i13 = i22 + 4 | 0;
   while (1) {
    i3 = HEAP8[i12 >> 0] | 0;
    i8 = i3 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i8 ? HEAP32[i22 >> 2] | 0 : i22, i8 ? HEAP32[i13 >> 2] | 0 : i3 & 255) | 0;
    i3 = HEAP8[i17 >> 0] | 0;
    i8 = i3 << 24 >> 24 < 0;
    i3 = i8 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
    i11 = i3 + i1 | 0;
    i2 = HEAP8[i14 >> 0] | 0;
    i9 = i2 << 24 >> 24 < 0;
    i10 = i9 ? HEAP32[i20 >> 2] | 0 : i20;
    i2 = i9 ? HEAP32[i15 >> 2] | 0 : i2 & 255;
    i8 = i8 ? HEAP32[i21 >> 2] | 0 : i21;
    if (i2 >>> 0 < i11 >>> 0 | (i2 - i11 | 0) >>> 0 < i3 >>> 0) break;
    if (!i3) i1 = i11; else {
     i1 = i10 + i11 | 0;
     i9 = i10 + i2 | 0;
     i6 = i8 + i3 | 0;
     i7 = i9;
     L40 : do if ((i7 - i1 | 0) < (i3 | 0)) i1 = i7; else {
      i4 = i9 + (1 - i3) | 0;
      if ((i4 | 0) == (i1 | 0)) i1 = i7; else {
       i5 = HEAP8[i8 >> 0] | 0;
       L43 : while (1) {
        while (1) {
         if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
          i2 = i8;
          i3 = i1;
          break;
         }
         i1 = i1 + 1 | 0;
         if ((i1 | 0) == (i4 | 0)) {
          i1 = i7;
          break L40;
         }
        }
        do {
         i2 = i2 + 1 | 0;
         if ((i2 | 0) == (i6 | 0)) break L43;
         i3 = i3 + 1 | 0;
        } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
        i1 = i1 + 1 | 0;
        if ((i1 | 0) == (i4 | 0)) {
         i1 = i7;
         break L40;
        }
       }
      }
     } while (0);
     if ((i1 | 0) == (i9 | 0)) break; else i1 = i1 - i10 | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i16, i20, i11, i1 - i11 | 0) | 0;
    if ((i1 | 0) == -1) break L15;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i16, i20, i11, ~i11) | 0;
  }
 } while (0);
 if ((i19 | 0) == 20) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i16, i20, i11, ~i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20, i16) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 STACKTOP = i23;
 return;
}

function __ZNK11DynamicMesh20BuildEdgeConnectionsER13dynamic_arrayINS_4EdgeELj2EE(i14, i17) {
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i25;
 i22 = i25 + 28 | 0;
 i23 = i25 + 8 | 0;
 i24 = HEAP32[i14 + 12 >> 2] | 0;
 i4 = i24 * 6 | 0;
 i15 = i17 + 12 | 0;
 HEAP32[i15 >> 2] = i4;
 i16 = i17 + 16 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i4 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i16 >> 2] = i4;
  HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i24 * 72 | 0, 2, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24 * 72 | 0, 2, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i17 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i17 >> 2] = i21;
  break;
 } while (0);
 i19 = HEAP32[i14 + 32 >> 2] | 0;
 HEAP32[i22 + 12 >> 2] = i19;
 i20 = i22 + 16 | 0;
 HEAP32[i20 >> 2] = i19;
 i21 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 64016 | 0);
 i18 = i3;
 i2 = HEAP32[i18 + 4 >> 2] | 0;
 i1 = i21;
 HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i19 << 1;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, i21, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i22 >> 2] = i2;
 if (i19 | 0) _memset(i2 | 0, -1, i1 | 0) | 0;
 HEAP32[i23 + 12 >> 2] = i4;
 i18 = i23 + 16 | 0;
 HEAP32[i18 >> 2] = i4;
 i19 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 64016 | 0);
 i13 = i3;
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i24 * 12 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, i19, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i23 >> 2] = i2;
 if (i4 | 0) _memset(i2 | 0, -1, i1 | 0) | 0;
 i13 = (i24 | 0) == 0;
 if (i13) i1 = 0; else {
  i9 = HEAP32[i14 >> 2] | 0;
  i10 = HEAP32[i17 >> 2] | 0;
  i11 = HEAP32[i22 >> 2] | 0;
  i12 = HEAP32[i23 >> 2] | 0;
  i1 = 0;
  i8 = 0;
  do {
   i7 = HEAP8[i9 + (i8 * 26 | 0) + 24 >> 0] | 0;
   i6 = i7 & 255;
   if (i7 << 24 >> 24) {
    i7 = i8 & 65535;
    i4 = i6 + -1 | 0;
    i5 = 0;
    while (1) {
     i2 = HEAP16[i9 + (i8 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0;
     i3 = HEAP16[i9 + (i8 * 26 | 0) + 12 + (i5 << 1) >> 1] | 0;
     if ((i2 & 65535) < (i3 & 65535)) {
      HEAP16[i10 + (i1 * 12 | 0) >> 1] = i2;
      HEAP16[i10 + (i1 * 12 | 0) + 2 >> 1] = i3;
      HEAP16[i10 + (i1 * 12 | 0) + 4 >> 1] = i7;
      HEAP16[i10 + (i1 * 12 | 0) + 6 >> 1] = -1;
      HEAP16[i10 + (i1 * 12 | 0) + 8 >> 1] = i4;
      HEAP16[i10 + (i1 * 12 | 0) + 10 >> 1] = -1;
      i4 = i11 + ((i2 & 65535) << 1) | 0;
      HEAP16[i12 + (i1 << 1) >> 1] = HEAP16[i4 >> 1] | 0;
      HEAP16[i4 >> 1] = i1;
      i1 = i1 + 1 | 0;
     }
     i2 = i5 + 1 | 0;
     if ((i2 | 0) == (i6 | 0)) break; else {
      i4 = i5;
      i5 = i2;
     }
    }
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i24 | 0));
 }
 HEAP32[i15 >> 2] = i1;
 i2 = HEAP32[i16 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i16 >> 2] = i1;
  HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 * 12 | 0, 2, i17 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 2, i17 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i17 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i17 >> 2] = i12;
  break;
 } while (0);
 if (!i13) {
  i11 = HEAP32[i14 >> 2] | 0;
  i12 = HEAP32[i22 >> 2] | 0;
  i9 = HEAP32[i17 >> 2] | 0;
  i10 = HEAP32[i23 >> 2] | 0;
  i6 = 0;
  do {
   i17 = HEAP8[i11 + (i6 * 26 | 0) + 24 >> 0] | 0;
   i7 = i17 & 255;
   if (i17 << 24 >> 24) {
    i8 = i6 & 65535;
    i5 = 0;
    i2 = i7 + -1 | 0;
    while (1) {
     i3 = HEAP16[i11 + (i6 * 26 | 0) + 12 + (i2 << 1) >> 1] | 0;
     i4 = HEAP16[i11 + (i6 * 26 | 0) + 12 + (i5 << 1) >> 1] | 0;
     L40 : do if ((i4 & 65535) < (i3 & 65535)) {
      i1 = HEAP16[i12 + ((i4 & 65535) << 1) >> 1] | 0;
      if (i1 << 16 >> 16 != -1) {
       i1 = i1 & 65535;
       while (1) {
        if ((HEAP16[i9 + (i1 * 12 | 0) >> 1] | 0) == i4 << 16 >> 16) if ((HEAP16[i9 + (i1 * 12 | 0) + 2 >> 1] | 0) == i3 << 16 >> 16) break;
        i1 = HEAP16[i10 + (i1 << 1) >> 1] | 0;
        if (i1 << 16 >> 16 == -1) break L40; else i1 = i1 & 65535;
       }
       HEAP16[i9 + (i1 * 12 | 0) + 6 >> 1] = i8;
       HEAP16[i9 + (i1 * 12 | 0) + 10 >> 1] = i2;
      }
     } while (0);
     i1 = i5 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else {
      i2 = i5;
      i5 = i1;
     }
    }
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i24 | 0));
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i19);
  HEAP32[i23 >> 2] = 0;
 }
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i25;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i21);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZN21GLESGpuProgramApplier10ApplyFloatERKN20GpuProgramParameters14ValueParameterEPKft(i9, i12, i11, i10) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i8 = i9 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if ((i4 | 0) == -1) {
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = i10 & 65535;
  i2 = (HEAP32[i2 + 20 >> 2] | 0) + (HEAP32[(HEAP32[i2 >> 2] | 0) + (((i12 - (HEAP32[i9 + 4 >> 2] | 0) | 0) / 20 | 0) + (HEAP32[i9 + 8 >> 2] | 0) << 2) >> 2] << 2) | 0;
  L3 : do if ((i10 & 65535) <= 64) {
   if (!(i10 << 16 >> 16)) {
    STACKTOP = i13;
    return;
   } else i1 = 0;
   do {
    if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) != (HEAP32[i11 + (i1 << 2) >> 2] | 0)) break L3;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
   STACKTOP = i13;
   return;
  } while (0);
  i1 = i5 << 2;
  _memcpy(i2 | 0, i11 | 0, i1 | 0) | 0;
  if (!(HEAP32[i12 + 12 >> 2] | 0)) {
   mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 124 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i5 | 0, i11 | 0);
   STACKTOP = i13;
   return;
  }
  HEAP32[i7 >> 2] = 0;
  i4 = i7 + 4 | 0;
  i6 = gb + 63160 | 0;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  if (!(i10 << 16 >> 16)) {
   i2 = 0;
   i1 = 0;
  } else {
   i3 = i1 | 3;
   if (i3 >>> 0 < 2e3) {
    i2 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    i1 = 0;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 598) | 0;
    i9 = gb + 64016 | 0;
    i8 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    i2 = i4;
    HEAP32[i2 >> 2] = i8;
    HEAP32[i2 + 4 >> 2] = i9;
    i2 = i1;
   }
   i2 = i2 + 3 & -4;
   i3 = 0;
   do {
    HEAP32[i2 + (i3 << 2) >> 2] = ~~Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]);
    i3 = i3 + 1 | 0;
   } while ((i3 & 65535) << 16 >> 16 != i10 << 16 >> 16);
  }
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 132 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i5 | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
  STACKTOP = i13;
  return;
 }
 i1 = i10 & 65535;
 i3 = (HEAP32[i12 + 12 >> 2] | 0) == 0;
 if ((i10 & 65535) <= 1) {
  i2 = HEAP32[i9 + 16 >> 2] | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  if (i3) {
   __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i2 + 6624 | 0, i4, i1, i11, 4);
   STACKTOP = i13;
   return;
  } else {
   HEAP32[i7 >> 2] = ~~Math_fround(HEAPF32[i11 >> 2]);
   __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i2 + 6624 | 0, i4, i1, i7, 4);
   STACKTOP = i13;
   return;
  }
 }
 if (i3) {
  HEAP32[i7 >> 2] = 0;
  i6 = i7 + 4 | 0;
  i4 = gb + 63160 | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i6;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = i1 << 4;
  i2 = (i5 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 556) | 0;
   i3 = gb + 64016 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   i1 = i6;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i4;
  }
  i1 = i1 + 3 & -4;
  i2 = i1;
  i3 = 0;
  do {
   i7 = i3 << 2;
   HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i11 + (i3 << 2) >> 2];
   HEAPF32[i2 + ((i7 | 1) << 2) >> 2] = Math_fround(0.0);
   HEAPF32[i2 + ((i7 | 2) << 2) >> 2] = Math_fround(0.0);
   HEAPF32[i2 + ((i7 | 3) << 2) >> 2] = Math_fround(0.0);
   i3 = i3 + 1 | 0;
  } while ((i3 & 65535) << 16 >> 16 != i10 << 16 >> 16);
  __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi((HEAP32[i9 + 16 >> 2] | 0) + 6624 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i1, i5);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  STACKTOP = i13;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  i6 = i7 + 4 | 0;
  i4 = gb + 63160 | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i6;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = i1 << 4;
  i2 = (i5 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 569) | 0;
   i3 = gb + 64016 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   i1 = i6;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i4;
  }
  i1 = i1 + 3 & -4;
  i2 = i1;
  i3 = 0;
  do {
   i7 = i3 << 2;
   HEAP32[i2 + (i7 << 2) >> 2] = ~~Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]);
   HEAP32[i2 + ((i7 | 1) << 2) >> 2] = 0;
   HEAP32[i2 + ((i7 | 2) << 2) >> 2] = 0;
   HEAP32[i2 + ((i7 | 3) << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 & 65535) << 16 >> 16 != i10 << 16 >> 16);
  __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi((HEAP32[i9 + 16 >> 2] | 0) + 6624 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i1, i5);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  STACKTOP = i13;
  return;
 }
}

function __ZN7mecanim9animation16MotionOutputCopyEPNS0_12MotionOutputEPKS1_bbRKNS_6bitsetILj66EEE(i3, i4, i1, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 do if (i1) i6 = 4; else if (i2) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!(i1 & 1)) break; else {
   i6 = 4;
   break;
  }
 } else return; while (0);
 do if ((i6 | 0) == 4) {
  i6 = HEAP32[i4 + 8 >> 2] | 0;
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = i6;
  HEAP32[i3 + 12 >> 2] = i1;
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i6 = HEAP32[i4 + 24 >> 2] | 0;
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = i1;
  HEAP32[i3 + 24 >> 2] = i6;
  HEAP32[i3 + 284 >> 2] = HEAP32[i4 + 284 >> 2];
  i6 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = HEAP32[i4 + 36 >> 2] | 0;
  HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i3 + 32 >> 2] = i6;
  HEAP32[i3 + 36 >> 2] = i1;
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  i6 = HEAP32[i4 + 48 >> 2] | 0;
  i7 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 40 >> 2];
  HEAP32[i3 + 44 >> 2] = i1;
  HEAP32[i3 + 48 >> 2] = i6;
  HEAP32[i3 + 52 >> 2] = i7;
  i7 = HEAP32[i4 + 60 >> 2] | 0;
  i6 = HEAP32[i4 + 64 >> 2] | 0;
  HEAP32[i3 + 56 >> 2] = HEAP32[i4 + 56 >> 2];
  HEAP32[i3 + 60 >> 2] = i7;
  HEAP32[i3 + 64 >> 2] = i6;
  i6 = HEAP32[i4 + 72 >> 2] | 0;
  i7 = HEAP32[i4 + 76 >> 2] | 0;
  HEAP32[i3 + 68 >> 2] = HEAP32[i4 + 68 >> 2];
  HEAP32[i3 + 72 >> 2] = i6;
  HEAP32[i3 + 76 >> 2] = i7;
  i7 = HEAP32[i4 + 84 >> 2] | 0;
  i6 = HEAP32[i4 + 88 >> 2] | 0;
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  HEAP32[i3 + 80 >> 2] = HEAP32[i4 + 80 >> 2];
  HEAP32[i3 + 84 >> 2] = i7;
  HEAP32[i3 + 88 >> 2] = i6;
  HEAP32[i3 + 92 >> 2] = i1;
  i1 = HEAP32[i4 + 100 >> 2] | 0;
  i6 = HEAP32[i4 + 104 >> 2] | 0;
  HEAP32[i3 + 96 >> 2] = HEAP32[i4 + 96 >> 2];
  HEAP32[i3 + 100 >> 2] = i1;
  HEAP32[i3 + 104 >> 2] = i6;
  i6 = HEAP32[i4 + 112 >> 2] | 0;
  i1 = HEAP32[i4 + 116 >> 2] | 0;
  HEAP32[i3 + 108 >> 2] = HEAP32[i4 + 108 >> 2];
  HEAP32[i3 + 112 >> 2] = i6;
  HEAP32[i3 + 116 >> 2] = i1;
  i1 = HEAP32[i4 + 124 >> 2] | 0;
  i6 = HEAP32[i4 + 128 >> 2] | 0;
  i7 = HEAP32[i4 + 132 >> 2] | 0;
  HEAP32[i3 + 120 >> 2] = HEAP32[i4 + 120 >> 2];
  HEAP32[i3 + 124 >> 2] = i1;
  HEAP32[i3 + 128 >> 2] = i6;
  HEAP32[i3 + 132 >> 2] = i7;
  i7 = HEAP32[i4 + 140 >> 2] | 0;
  i6 = HEAP32[i4 + 144 >> 2] | 0;
  HEAP32[i3 + 136 >> 2] = HEAP32[i4 + 136 >> 2];
  HEAP32[i3 + 140 >> 2] = i7;
  HEAP32[i3 + 144 >> 2] = i6;
  i6 = HEAP32[i4 + 152 >> 2] | 0;
  i7 = HEAP32[i4 + 156 >> 2] | 0;
  HEAP32[i3 + 148 >> 2] = HEAP32[i4 + 148 >> 2];
  HEAP32[i3 + 152 >> 2] = i6;
  HEAP32[i3 + 156 >> 2] = i7;
  i7 = HEAP32[i4 + 164 >> 2] | 0;
  i6 = HEAP32[i4 + 168 >> 2] | 0;
  i1 = HEAP32[i4 + 172 >> 2] | 0;
  HEAP32[i3 + 160 >> 2] = HEAP32[i4 + 160 >> 2];
  HEAP32[i3 + 164 >> 2] = i7;
  HEAP32[i3 + 168 >> 2] = i6;
  HEAP32[i3 + 172 >> 2] = i1;
  i1 = HEAP32[i4 + 180 >> 2] | 0;
  i6 = HEAP32[i4 + 184 >> 2] | 0;
  HEAP32[i3 + 176 >> 2] = HEAP32[i4 + 176 >> 2];
  HEAP32[i3 + 180 >> 2] = i1;
  HEAP32[i3 + 184 >> 2] = i6;
  if (i2) {
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  } else return;
 } while (0);
 if (i1 & 1 | 0) {
  i7 = HEAP32[i4 + 296 >> 2] | 0;
  i2 = HEAP32[i4 + 300 >> 2] | 0;
  HEAP32[i3 + 292 >> 2] = HEAP32[i4 + 292 >> 2];
  HEAP32[i3 + 296 >> 2] = i7;
  HEAP32[i3 + 300 >> 2] = i2;
  i2 = HEAP32[i4 + 308 >> 2] | 0;
  i7 = HEAP32[i4 + 312 >> 2] | 0;
  i6 = HEAP32[i4 + 316 >> 2] | 0;
  HEAP32[i3 + 304 >> 2] = HEAP32[i4 + 304 >> 2];
  HEAP32[i3 + 308 >> 2] = i2;
  HEAP32[i3 + 312 >> 2] = i7;
  HEAP32[i3 + 316 >> 2] = i6;
  i6 = HEAP32[i4 + 324 >> 2] | 0;
  i7 = HEAP32[i4 + 328 >> 2] | 0;
  HEAP32[i3 + 320 >> 2] = HEAP32[i4 + 320 >> 2];
  HEAP32[i3 + 324 >> 2] = i6;
  HEAP32[i3 + 328 >> 2] = i7;
 }
 if (__ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE(i5) | 0) {
  i7 = HEAP32[i4 + 192 >> 2] | 0;
  i2 = HEAP32[i4 + 196 >> 2] | 0;
  HEAP32[i3 + 188 >> 2] = HEAP32[i4 + 188 >> 2];
  HEAP32[i3 + 192 >> 2] = i7;
  HEAP32[i3 + 196 >> 2] = i2;
  i2 = HEAP32[i4 + 204 >> 2] | 0;
  i7 = HEAP32[i4 + 208 >> 2] | 0;
  i6 = HEAP32[i4 + 212 >> 2] | 0;
  HEAP32[i3 + 200 >> 2] = HEAP32[i4 + 200 >> 2];
  HEAP32[i3 + 204 >> 2] = i2;
  HEAP32[i3 + 208 >> 2] = i7;
  HEAP32[i3 + 212 >> 2] = i6;
  i6 = HEAP32[i4 + 220 >> 2] | 0;
  i7 = HEAP32[i4 + 224 >> 2] | 0;
  HEAP32[i3 + 216 >> 2] = HEAP32[i4 + 216 >> 2];
  HEAP32[i3 + 220 >> 2] = i6;
  HEAP32[i3 + 224 >> 2] = i7;
  HEAP32[i3 + 268 >> 2] = HEAP32[i4 + 268 >> 2];
  HEAP32[i3 + 272 >> 2] = HEAP32[i4 + 272 >> 2];
 }
 if (__ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE(i5) | 0) {
  i7 = HEAP32[i4 + 232 >> 2] | 0;
  i5 = HEAP32[i4 + 236 >> 2] | 0;
  HEAP32[i3 + 228 >> 2] = HEAP32[i4 + 228 >> 2];
  HEAP32[i3 + 232 >> 2] = i7;
  HEAP32[i3 + 236 >> 2] = i5;
  i5 = HEAP32[i4 + 244 >> 2] | 0;
  i7 = HEAP32[i4 + 248 >> 2] | 0;
  i6 = HEAP32[i4 + 252 >> 2] | 0;
  HEAP32[i3 + 240 >> 2] = HEAP32[i4 + 240 >> 2];
  HEAP32[i3 + 244 >> 2] = i5;
  HEAP32[i3 + 248 >> 2] = i7;
  HEAP32[i3 + 252 >> 2] = i6;
  i6 = HEAP32[i4 + 260 >> 2] | 0;
  i7 = HEAP32[i4 + 264 >> 2] | 0;
  HEAP32[i3 + 256 >> 2] = HEAP32[i4 + 256 >> 2];
  HEAP32[i3 + 260 >> 2] = i6;
  HEAP32[i3 + 264 >> 2] = i7;
  HEAP32[i3 + 276 >> 2] = HEAP32[i4 + 276 >> 2];
  HEAP32[i3 + 280 >> 2] = HEAP32[i4 + 280 >> 2];
 }
 HEAP32[i3 + 288 >> 2] = HEAP32[i4 + 288 >> 2];
 return;
}

function __ZN2UI13RectTransform18OnTransformChangedEi(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i8 = i12;
 if (i1 & 64 | 0) {
  __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i11, 1, 0);
  STACKTOP = i12;
  return;
 }
 if ((i1 & 385 | 0) != 1) {
  STACKTOP = i12;
  return;
 }
 i7 = i11 + 176 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i1 = i11 + 100 | 0; else {
  i1 = i11 + 100 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  if (!i6) {
   f5 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
  } else if ((((HEAP32[i6 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) {
   if (HEAP8[i6 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i6, 0, 0);
   f5 = Math_fround(HEAPF32[i6 + 120 >> 2]);
   f3 = Math_fround(HEAPF32[i6 + 124 >> 2]);
   f4 = Math_fround(HEAPF32[i6 + 128 >> 2]);
   f2 = Math_fround(HEAPF32[i6 + 132 >> 2]);
  } else {
   f5 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
  }
  f17 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i11 + 136 >> 2])));
  f13 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i11 + 140 >> 2])));
  f18 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i11 + 144 >> 2])));
  f14 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i11 + 148 >> 2])));
  f4 = Math_fround(f17 + Math_fround(HEAPF32[i11 + 152 >> 2]));
  f16 = Math_fround(HEAPF32[i11 + 160 >> 2]);
  f15 = Math_fround(HEAPF32[i11 + 168 >> 2]);
  f4 = Math_fround(f4 - Math_fround(f16 * f15));
  f2 = Math_fround(f13 + Math_fround(HEAPF32[i11 + 156 >> 2]));
  f3 = Math_fround(HEAPF32[i11 + 164 >> 2]);
  f5 = Math_fround(HEAPF32[i11 + 172 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(Math_fround(f18 - f17) + f16) * f15) + f4);
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f14 - f13) + f3) * f5) + Math_fround(f2 - Math_fround(f3 * f5)));
  __ZNK9Transform16GetLocalPositionEv(i10, i11);
  i9 = HEAP32[i10 + 8 >> 2] | 0;
  HEAPF32[i8 >> 2] = f4;
  HEAPF32[i8 + 4 >> 2] = f5;
  HEAP32[i8 + 8 >> 2] = i9;
  __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i11, i8);
  HEAP8[i7 >> 0] = 0;
 }
 __ZNK9Transform16GetLocalPositionEv(i10, i11);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) {
  if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
  f5 = Math_fround(HEAPF32[i1 + 120 >> 2]);
  f3 = Math_fround(HEAPF32[i1 + 124 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 128 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 } else {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f19 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i11 + 136 >> 2])));
 f16 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i11 + 140 >> 2])));
 f20 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i11 + 144 >> 2])));
 f15 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i11 + 148 >> 2])));
 f2 = Math_fround(HEAPF32[i11 + 152 >> 2]);
 f5 = Math_fround(f19 + f2);
 f13 = Math_fround(HEAPF32[i11 + 160 >> 2]);
 f14 = Math_fround(HEAPF32[i11 + 168 >> 2]);
 f5 = Math_fround(f5 - Math_fround(f13 * f14));
 i9 = i11 + 156 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f17 = Math_fround(f16 + f4);
 f18 = Math_fround(HEAPF32[i11 + 164 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + 172 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f20 - f19) + f13) * f14) + f5);
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f15 - f16) + f18) * f3) + Math_fround(f17 - Math_fround(f18 * f3)));
 f5 = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i10 >> 2])) - f5);
 f3 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i10 + 4 >> 2])) - f3);
 i8 = i11 + 152 | 0;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i6 ^ i1 | 0) > -1) {
  i10 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i10 | 0) < 0 ? 0 - i10 | 0 : i10) | 0) > 10) i7 = 23; else i7 = 20;
 } else if (f2 == f5) i7 = 20; else i7 = 23;
 do if ((i7 | 0) == 20) {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i6 | 0) > -1) {
   i10 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
   if ((((i10 | 0) < 0 ? 0 - i10 | 0 : i10) | 0) < 11) break; else {
    i7 = 23;
    break;
   }
  } else if (f4 == f3) break; else {
   i7 = 23;
   break;
  }
 } while (0);
 if ((i7 | 0) == 23) {
  HEAPF32[i8 >> 2] = f5;
  HEAPF32[i9 >> 2] = f3;
  __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i11, 1, 0);
 }
 STACKTOP = i12;
 return;
}

function __ZN23ForwardShaderRenderLoop15StartRenderJobsER8JobFencebR17ShaderPassContext(i15, i16, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i25 + 8 | 0;
 i22 = i25;
 i19 = __Z12GetGfxDevicev() | 0;
 i20 = i15 + 8 | 0;
 i21 = HEAP32[(HEAP32[i20 >> 2] | 0) + 1832 >> 2] | 0;
 i14 = i1 ? 2501 : 5e3;
 i7 = i1 ? 0 : 2501;
 if (!(HEAP8[i15 + 524 >> 0] & 16)) if (!(HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] | 0)) i10 = 1; else i10 = __Z22GetJobQueueThreadCountv() | 0; else i10 = 1;
 i9 = HEAP32[i15 + 180 >> 2] | 0;
 i8 = ((i9 >>> 0) / (i10 >>> 0) | 0) + 1 | 0;
 i8 = i8 >>> 0 > 128 ? i8 : 128;
 i24 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 << 2, 16, gb + 64024 | 0, 0, gb + 387960 | 0, 1041) | 0;
 i11 = i21 + 32804 | 0;
 i23 = 0;
 i5 = 0;
 do {
  i12 = i5 + i8 | 0;
  i6 = i5;
  i5 = i9 >>> 0 < i12 >>> 0 ? i9 : i12;
  i12 = __ZnwjRK10MemLabelIdiPKci(196, gb + 64024 | 0, 16, gb + 387960 | 0, 1048) | 0;
  HEAP32[i12 + 4 >> 2] = 1;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 >> 2] = gb + 36792 + 8;
  i13 = i12 + 12 | 0;
  i1 = i12 + 48 | 0;
  i2 = i12 + 52 | 0;
  i3 = i13;
  i4 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 33952 + 8;
  i4 = gb + 64024 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i22;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i12 + 80 >> 2] = 0;
  HEAP32[i12 + 92 >> 2] = 0;
  HEAP32[i12 + 96 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i22);
  i2 = i18;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i12 + 84 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = gb + 64024 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i22;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i12 + 100 >> 2] = 0;
  HEAP32[i12 + 112 >> 2] = 0;
  HEAP32[i12 + 116 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i22);
  i2 = i18;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i12 + 104 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = gb + 64024 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i22;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i12 + 120 >> 2] = 0;
  HEAP32[i12 + 132 >> 2] = 0;
  HEAP32[i12 + 136 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i22);
  i2 = i18;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i12 + 124 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i12 + 140 >> 2] = 0;
  HEAP32[i12 + 144 >> 2] = 0;
  i4 = gb + 64024 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i12 + 148 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = i12 + 156 | 0;
  HEAP8[i2 >> 0] = 1;
  i3 = i12 + 56 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP8[i12 + 160 >> 0] = 1;
  HEAP8[i12 + 161 >> 0] = 0;
  i3 = i12 + 164 | 0;
  i4 = i12 + 180 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = -1;
  HEAP8[i12 + 192 >> 0] = 0;
  i1 = i23;
  i23 = i23 + 1 | 0;
  i1 = i24 + (i1 << 2) | 0;
  HEAP32[i1 >> 2] = i12;
  __ZN17ShaderPassContext8CopyFromERKS_(i13, i17);
  HEAP8[i2 >> 0] = 0;
  i13 = HEAP32[i20 >> 2] | 0;
  i2 = i13 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP32[i12 + 168 >> 2] = i6;
  HEAP32[i12 + 172 >> 2] = i5;
  HEAP32[i3 >> 2] = i13;
  HEAP32[i12 + 176 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 >> 2] = i7;
  HEAP32[i12 + 184 >> 2] = i7;
  HEAP32[i12 + 188 >> 2] = i14;
 } while (i5 >>> 0 < i9 >>> 0);
 HEAP8[(HEAP32[i1 >> 2] | 0) + 192 >> 0] = 1;
 i22 = (HEAP32[i21 + 32808 >> 2] | 0) != 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 if (i23 >>> 0 > 1 & ((i9 | 0) != 0 & i22)) {
  i22 = __ZnwjRK10MemLabelIdiPKci(20, gb + 64024 | 0, 16, gb + 387960 | 0, 1070) | 0;
  HEAP32[i22 + 4 >> 2] = i15;
  HEAP32[i22 >> 2] = i24;
  HEAP32[i22 + 12 >> 2] = i7;
  HEAP32[i22 + 16 >> 2] = i8;
  HEAP32[i22 + 8 >> 2] = i10;
  __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i18, fb + 3347 | 0, i22, i16, 0);
 } else {
  i20 = i16;
  i21 = HEAP32[i20 + 4 >> 2] | 0;
  i22 = i18;
  HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i22 + 4 >> 2] = i21;
 }
 __Z21ClearFenceWithoutSyncR8JobFence(i16);
 mftCall_viiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 892 >> 2] | 0, i19 | 0, i23 | 0, fb + 2392 | 0, i24 | 0, i15 | 0, i18 | 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i18);
 if (!i23) {
  __Z19free_alloc_internalPvRK10MemLabelId(i24, gb + 64024 | 0);
  STACKTOP = i25;
  return;
 } else i1 = 0;
 do {
  i2 = HEAP32[i24 + (i1 << 2) >> 2] | 0;
  i22 = i2 + 4 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
  if (!(HEAP32[i22 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 __Z19free_alloc_internalPvRK10MemLabelId(i24, gb + 64024 | 0);
 STACKTOP = i25;
 return;
}

function __Z26TransformVerticesInnerLoopILb0ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i7, i32, i3, i4, i8, i1, i2, i33, i9, i34, i6, i5) {
 i7 = i7 | 0;
 i32 = i32 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i33 = i33 | 0;
 i9 = i9 | 0;
 i34 = i34 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i31 = (i6 | 0) / 4 | 0;
 i1 = (i5 & 1 | 0) == 0;
 if (i1) {
  i11 = 0;
  i12 = 0;
  i10 = 0;
 } else {
  i11 = HEAP32[i3 + 24 >> 2] | 0;
  i12 = HEAP32[i3 + 28 >> 2] | 0;
  i10 = HEAP32[i3 + 32 >> 2] | 0;
 }
 i30 = (i5 & 8 | 0) == 0;
 if (i30) {
  i27 = 0;
  i28 = 0;
  i29 = 0;
 } else {
  i27 = HEAP32[i32 >> 2] | 0;
  i28 = HEAP32[i32 + 4 >> 2] | 0;
  i29 = HEAP32[i32 + 8 >> 2] | 0;
 }
 i2 = i4 + -1 | 0;
 if (!i4) return;
 i15 = i32 + 16 | 0;
 i16 = i32 + 32 | 0;
 i17 = i32 + 48 | 0;
 i18 = i32 + 4 | 0;
 i19 = i32 + 20 | 0;
 i20 = i32 + 36 | 0;
 i21 = i32 + 52 | 0;
 i22 = i32 + 8 | 0;
 i23 = i32 + 24 | 0;
 i24 = i32 + 40 | 0;
 i25 = i32 + 56 | 0;
 i26 = (i5 & 2 | 0) == 0;
 i14 = (i5 & 4 | 0) == 0;
 i13 = (i6 | 0) > 3;
 if (i1) {
  i1 = i7;
  i5 = i9;
  i6 = i2;
  while (1) {
   f38 = Math_fround(HEAPF32[i32 >> 2]);
   f38 = Math_fround(f38 * Math_fround(HEAPF32[i8 >> 2]));
   f37 = Math_fround(HEAPF32[i15 >> 2]);
   i2 = i8 + 4 | 0;
   f36 = Math_fround(HEAPF32[i2 >> 2]);
   f37 = Math_fround(f38 + Math_fround(f37 * f36));
   f38 = Math_fround(HEAPF32[i16 >> 2]);
   f35 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f38 = Math_fround(f37 + Math_fround(f38 * f35));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f38);
   f38 = Math_fround(HEAPF32[i18 >> 2]);
   f37 = Math_fround(HEAPF32[i8 >> 2]);
   f38 = Math_fround(f38 * f37);
   f36 = Math_fround(f38 + Math_fround(f36 * Math_fround(HEAPF32[i19 >> 2])));
   f36 = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i20 >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f36);
   f37 = Math_fround(f37 * Math_fround(HEAPF32[i22 >> 2]));
   f36 = Math_fround(HEAPF32[i23 >> 2]);
   f36 = Math_fround(f37 + Math_fround(f36 * Math_fround(HEAPF32[i2 >> 2])));
   f35 = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i24 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f35);
   i2 = i1 + 12 | 0;
   if (i26) i1 = i2; else {
    HEAP32[i2 >> 2] = -1;
    i1 = i1 + 16 | 0;
   }
   if (!i14) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i1 + 8 | 0;
   }
   if (!i5) i2 = 0; else {
    if (i13) {
     i4 = 0;
     i2 = i1;
     i3 = i5;
     while (1) {
      i1 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i31 | 0)) break; else {
       i2 = i1;
       i3 = i3 + 4 | 0;
      }
     }
    }
    i2 = i5 + i34 | 0;
   }
   if (!i30) {
    HEAP32[i1 >> 2] = i27;
    HEAP32[i1 + 4 >> 2] = i28;
    HEAP32[i1 + 8 >> 2] = i29;
    HEAP32[i1 + 12 >> 2] = 1065353216;
    i1 = i1 + 16 | 0;
   }
   if (!i6) break; else {
    i8 = i8 + i33 | 0;
    i5 = i2;
    i6 = i6 + -1 | 0;
   }
  }
  return;
 } else {
  i1 = i7;
  i5 = i9;
  i6 = i2;
  while (1) {
   f35 = Math_fround(HEAPF32[i32 >> 2]);
   f35 = Math_fround(f35 * Math_fround(HEAPF32[i8 >> 2]));
   f36 = Math_fround(HEAPF32[i15 >> 2]);
   i2 = i8 + 4 | 0;
   f37 = Math_fround(HEAPF32[i2 >> 2]);
   f36 = Math_fround(f35 + Math_fround(f36 * f37));
   f35 = Math_fround(HEAPF32[i16 >> 2]);
   f38 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f35 = Math_fround(f36 + Math_fround(f35 * f38));
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f35);
   f35 = Math_fround(HEAPF32[i18 >> 2]);
   f36 = Math_fround(HEAPF32[i8 >> 2]);
   f35 = Math_fround(f35 * f36);
   f37 = Math_fround(f35 + Math_fround(f37 * Math_fround(HEAPF32[i19 >> 2])));
   f37 = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i20 >> 2])));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f37);
   f36 = Math_fround(f36 * Math_fround(HEAPF32[i22 >> 2]));
   f37 = Math_fround(HEAPF32[i23 >> 2]);
   f37 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i2 >> 2])));
   f38 = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i24 >> 2])));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f38);
   HEAP32[i1 + 12 >> 2] = i11;
   HEAP32[i1 + 16 >> 2] = i12;
   HEAP32[i1 + 20 >> 2] = i10;
   i2 = i1 + 24 | 0;
   if (i26) i1 = i2; else {
    HEAP32[i2 >> 2] = -1;
    i1 = i1 + 28 | 0;
   }
   if (!i14) {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = i1 + 8 | 0;
   }
   if (!i5) i2 = 0; else {
    if (i13) {
     i4 = 0;
     i2 = i1;
     i3 = i5;
     while (1) {
      i1 = i2 + 4 | 0;
      HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
      i4 = i4 + 1 | 0;
      if ((i4 | 0) >= (i31 | 0)) break; else {
       i2 = i1;
       i3 = i3 + 4 | 0;
      }
     }
    }
    i2 = i5 + i34 | 0;
   }
   if (!i30) {
    HEAP32[i1 >> 2] = i27;
    HEAP32[i1 + 4 >> 2] = i28;
    HEAP32[i1 + 8 >> 2] = i29;
    HEAP32[i1 + 12 >> 2] = 1065353216;
    i1 = i1 + 16 | 0;
   }
   if (!i6) break; else {
    i8 = i8 + i33 | 0;
    i5 = i2;
    i6 = i6 + -1 | 0;
   }
  }
  return;
 }
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i27, i28, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i31 + 56 | 0;
 i23 = i31 + 44 | 0;
 i24 = i31 + 40 | 0;
 i30 = i31 + 20 | 0;
 i25 = i31;
 i26 = i28 + 8 | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i27, gb + 1041885 | 0, gb + 1041885 | 0, i24) | 0)) {
  STACKTOP = i31;
  return;
 }
 i7 = i30 + 4 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 HEAP32[i30 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i28 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i28, HEAP32[i8 >> 2] | 0);
 HEAP32[i26 >> 2] = 0;
 HEAP32[i28 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i24 >> 2] | 0) > 0) {
  i9 = HEAP32[gb + 37152 >> 2] | 0;
  i10 = i25 + 4 | 0;
  i11 = i7 + 11 | 0;
  i12 = i30 + 8 | 0;
  i13 = i25 + 16 | 0;
  i6 = i25 + 16 | 0;
  i14 = i29 + 4 | 0;
  i15 = i25 + 12 | 0;
  i16 = i25 + 8 | 0;
  i17 = i8;
  i18 = i28 + 4 | 0;
  i19 = i25 + 4 | 0;
  i20 = i19 + 11 | 0;
  i21 = i29 + 4 | 0;
  i22 = i10 + 11 | 0;
  i5 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i27, gb + 1041891 | 0, i9, i29, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIj8UnityStrEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i30, i27); else {
     i1 = HEAP32[i29 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i30 | 0, i27 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i27);
   }
   HEAP32[i25 >> 2] = HEAP32[i30 >> 2];
   i3 = HEAP8[i11 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
   i3 = i1 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i13 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
    i1 = HEAP32[i6 >> 2] | 0;
    i4 = 16;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i22 >> 0] = i3;
    if (!i3) i1 = i10; else {
     i1 = i10;
     i4 = 18;
    }
   } else i4 = 16;
   if ((i4 | 0) == 16) {
    i32 = i3 + 16 & -16;
    HEAP32[i29 >> 2] = 66;
    HEAP32[i14 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i32, 16, i29, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i15 >> 2] = i32 | -2147483648;
    HEAP32[i16 >> 2] = i3;
    i4 = 18;
   }
   if ((i4 | 0) == 18) {
    i4 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i8 >> 2] | 0;
   do if (!i1) {
    HEAP32[i29 >> 2] = i8;
    i2 = i17;
    i3 = i8;
   } else {
    i4 = HEAP32[i25 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i4 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 23;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i4 >>> 0) {
       i4 = 28;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 27;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 23) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     break;
    } else if ((i4 | 0) == 27) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     break;
    } else if ((i4 | 0) == 28) {
     i4 = 0;
     HEAP32[i29 >> 2] = i1;
     i2 = i1;
     i3 = i29;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i23, i28, i25);
    i1 = HEAP32[i23 >> 2] | 0;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i28 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 >> 2] | 0, i1);
    HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
   }
   if ((HEAP8[i20 >> 0] | 0) < 0) {
    i32 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i29 >> 2] = 66;
    HEAP32[i21 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i32, i29);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i24 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i27);
 i1 = i30 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i32 = HEAP32[i1 >> 2] | 0;
  i30 = HEAP32[i30 + 16 >> 2] | 0;
  HEAP32[i29 >> 2] = 66;
  HEAP32[i29 + 4 >> 2] = i30;
  __Z19free_alloc_internalPvRK10MemLabelId(i32, i29);
 }
 STACKTOP = i31;
 return;
}

function __ZN14RenderSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 312 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 320 | 0, i7);
 i1 = i6 + 316 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 344 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 336 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 340 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 28 | 0, i7);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 44 | 0, i7);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 60 | 0, i7);
 i1 = i6 + 184 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 188 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 360 | 0, i7);
 i1 = i6 + 300 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 308 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 352 | 0, i7);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 348 | 0, i7);
 i1 = i6 + 368 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 372 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 376 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 364 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 392 | 0;
  __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 392 | 0;
  __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN5Umbra11ShadowUtils21getWorldToLightMatrixERNS_9Matrix4x4ERKS1_RKNS_7Vector3E(i12, i1, i13) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, d28 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 f15 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f2 * f2)) + Math_fround(f5 * f5)))));
 f15 = Math_fround(f15 * f3);
 f2 = Math_fround(f2 * f3);
 f3 = Math_fround(f5 * f3);
 __ZN5Umbra13MatrixFactory16orthonormalBasisERKNS_7Vector3E(i11, i13);
 i1 = HEAP32[i11 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i11 + 32 >> 2]);
 f7 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(f2 * f5)) + Math_fround(f3 * f6));
 f3 = Math_fround(Math_fround(Math_fround(f15 * f7) + Math_fround(f2 * f8)) + Math_fround(f3 * f9));
 f4 = Math_fround(Math_fround(f4 * f10) + Math_fround(f7 * f3));
 f2 = Math_fround(Math_fround(f5 * f10) + Math_fround(f8 * f3));
 f3 = Math_fround(Math_fround(f6 * f10) + Math_fround(f9 * f3));
 f10 = Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2)));
 if (!(Math_fround(Math_sqrt(Math_fround(f10))) > Math_fround(.00100000005))) {
  HEAP32[i12 >> 2] = i1;
  i21 = i12 + 4 | 0;
  HEAPF32[i21 >> 2] = f7;
  i25 = HEAP32[i11 + 8 >> 2] | 0;
  i26 = i12 + 8 | 0;
  HEAP32[i26 >> 2] = i25;
  i22 = HEAP32[i11 + 12 >> 2] | 0;
  i23 = i12 + 12 | 0;
  HEAP32[i23 >> 2] = i22;
  HEAPF32[i12 + 16 >> 2] = f5;
  HEAPF32[i12 + 20 >> 2] = f8;
  i13 = HEAP32[i11 + 24 >> 2] | 0;
  HEAP32[i12 + 24 >> 2] = i13;
  i17 = HEAP32[i11 + 28 >> 2] | 0;
  HEAP32[i12 + 28 >> 2] = i17;
  HEAPF32[i12 + 32 >> 2] = f6;
  HEAPF32[i12 + 36 >> 2] = f9;
  HEAP32[i12 + 40 >> 2] = HEAP32[i11 + 40 >> 2];
  i27 = HEAP32[i11 + 44 >> 2] | 0;
  HEAP32[i12 + 44 >> 2] = i27;
  i24 = HEAP32[i11 + 48 >> 2] | 0;
  HEAP32[i12 + 48 >> 2] = i24;
  i19 = HEAP32[i11 + 52 >> 2] | 0;
  HEAP32[i12 + 52 >> 2] = i19;
  i16 = HEAP32[i11 + 56 >> 2] | 0;
  HEAP32[i12 + 56 >> 2] = i16;
  HEAP32[i12 + 60 >> 2] = HEAP32[i11 + 60 >> 2];
  f15 = f9;
  f10 = f6;
  f8 = f5;
  f9 = f7;
  i20 = i12 + 24 | 0;
  i18 = i12 + 36 | 0;
  i1 = i12 + 44 | 0;
  i11 = i27;
  HEAPF32[i21 >> 2] = f8;
  i21 = i12 + 16 | 0;
  HEAPF32[i21 >> 2] = f9;
  i21 = i12 + 32 | 0;
  HEAPF32[i26 >> 2] = f10;
  HEAP32[i21 >> 2] = i25;
  i21 = i12 + 48 | 0;
  HEAP32[i23 >> 2] = i24;
  HEAP32[i21 >> 2] = i22;
  HEAPF32[i20 >> 2] = f15;
  HEAP32[i18 >> 2] = i13;
  i18 = i12 + 28 | 0;
  i13 = i12 + 52 | 0;
  HEAP32[i18 >> 2] = i19;
  HEAP32[i13 >> 2] = i17;
  i13 = i12 + 56 | 0;
  HEAP32[i1 >> 2] = i16;
  HEAP32[i13 >> 2] = i11;
  STACKTOP = i14;
  return;
 }
 if (f10 != Math_fround(0.0)) {
  d28 = 1.0 / +Math_sqrt(+(+f10));
  f4 = Math_fround(+f4 * d28);
  f3 = Math_fround(+f3 * d28);
  f2 = Math_fround(+f2 * d28);
 }
 i27 = i13 + 4 | 0;
 f8 = Math_fround(HEAPF32[i27 >> 2]);
 f9 = Math_fround(f3 * f8);
 i16 = i13 + 8 | 0;
 f10 = Math_fround(HEAPF32[i16 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f2 * f10));
 f10 = Math_fround(f4 * f10);
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 f10 = Math_fround(f10 - Math_fround(f3 * f15));
 f8 = Math_fround(Math_fround(f2 * f15) - Math_fround(f4 * f8));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10))))));
 f9 = Math_fround(f9 * f15);
 f10 = Math_fround(f10 * f15);
 f15 = Math_fround(f8 * f15);
 i19 = i12 + 4 | 0;
 i20 = i12 + 8 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 i20 = i12 + 24 | 0;
 i17 = i12 + 40 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i25 = i12 + 44 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAPF32[i12 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i12 >> 2] = f4;
 HEAPF32[i12 + 16 >> 2] = f2;
 HEAPF32[i12 + 32 >> 2] = f3;
 HEAPF32[i19 >> 2] = f9;
 HEAPF32[i12 + 20 >> 2] = f10;
 i22 = i12 + 36 | 0;
 HEAPF32[i22 >> 2] = f15;
 i13 = HEAP32[i13 >> 2] | 0;
 i11 = i12 + 8 | 0;
 HEAP32[i11 >> 2] = i13;
 i27 = HEAP32[i27 >> 2] | 0;
 HEAP32[i20 >> 2] = i27;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 f10 = f3;
 f8 = f2;
 i17 = i12 + 12 | 0;
 i16 = 0;
 i18 = 0;
 i21 = 0;
 i23 = 0;
 i24 = 0;
 i26 = 0;
 HEAPF32[i19 >> 2] = f8;
 i19 = i12 + 16 | 0;
 HEAPF32[i19 >> 2] = f9;
 i19 = i12 + 32 | 0;
 HEAPF32[i11 >> 2] = f10;
 HEAP32[i19 >> 2] = i13;
 i19 = i12 + 48 | 0;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i19 >> 2] = i18;
 HEAPF32[i20 >> 2] = f15;
 HEAP32[i22 >> 2] = i27;
 i22 = i12 + 28 | 0;
 i27 = i12 + 52 | 0;
 HEAP32[i22 >> 2] = i21;
 HEAP32[i27 >> 2] = i23;
 i27 = i12 + 56 | 0;
 HEAP32[i25 >> 2] = i24;
 HEAP32[i27 >> 2] = i26;
 STACKTOP = i14;
 return;
}

function __ZNK14b2PolygonShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i35, i36, i34, i33, i1) {
 i35 = i35 | 0;
 i36 = i36 | 0;
 i34 = i34 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i37 = 0, i38 = 0, f39 = f0, f40 = f0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i37;
 i25 = i35 + 8 | 0;
 f7 = Math_fround(HEAPF32[i25 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 151644 >> 2]);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 if (!(f7 <= f8)) {
  i3 = HEAP32[i34 + 16 >> 2] | 0;
  i26 = i35 + 148 | 0;
  i1 = HEAP32[i26 >> 2] | 0;
  L3 : do if ((i1 | 0) > 0) {
   i27 = i24 + 28 | 0;
   i28 = i24 + 32 | 0;
   i29 = i24 + 36 | 0;
   i30 = i24 + 176 | 0;
   i31 = i24 + 40 | 0;
   i32 = i24 + 44 | 0;
   i20 = i24 + 4 | 0;
   i21 = i24 + 8 | 0;
   i22 = i24 + 12 | 0;
   i23 = i24 + 20 | 0;
   i4 = i36 + 8 | 0;
   i19 = 0;
   i5 = 0;
   i6 = i1;
   i17 = i2;
   i2 = 0;
   i1 = 0;
   while (1) {
    i18 = i19 + 1 | 0;
    HEAP32[i24 >> 2] = gb + 151688 + 8;
    HEAP32[i27 >> 2] = gb + 151728 + 8;
    HEAP32[i28 >> 2] = 2;
    HEAP32[i29 >> 2] = i17;
    HEAP32[i30 >> 2] = 0;
    HEAPF32[i31 >> 2] = Math_fround(0.0);
    HEAPF32[i32 >> 2] = Math_fround(0.0);
    HEAP32[i20 >> 2] = 4;
    i38 = i35 + 20 + (i19 << 3) | 0;
    i19 = HEAP32[i38 + 4 >> 2] | 0;
    i17 = i22;
    HEAP32[i17 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i17 + 4 >> 2] = i19;
    i6 = i35 + 20 + (((i18 | 0) == (i6 | 0) ? 0 : i18) << 3) | 0;
    i17 = HEAP32[i6 + 4 >> 2] | 0;
    i19 = i23;
    HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i19 + 4 >> 2] = i17;
    HEAPF32[i21 >> 2] = Math_fround(f7 - f8);
    if (__ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i24, i36, i34, i33, 0) | 0) {
     f7 = Math_fround(HEAPF32[i4 >> 2]);
     if (f7 < (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      i1 = i36;
      i5 = 1;
      i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
      i2 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
     } else i5 = 1;
    }
    i6 = HEAP32[i26 >> 2] | 0;
    if ((i18 | 0) >= (i6 | 0)) {
     i6 = i36;
     break L3;
    }
    i38 = HEAP32[gb + 151644 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i25 >> 2]);
    i19 = i18;
    i17 = i38;
    f8 = (HEAP32[tempDoublePtr >> 2] = i38, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
  } else {
   i5 = 0;
   i6 = i36;
   i4 = i36 + 8 | 0;
   i2 = 0;
   i1 = 0;
  } while (0);
  i38 = i6;
  HEAP32[i38 >> 2] = i2;
  HEAP32[i38 + 4 >> 2] = i1;
  HEAP32[i4 >> 2] = i3;
  i38 = i5;
  STACKTOP = i37;
  return i38 | 0;
 }
 f12 = Math_fround(HEAPF32[i34 >> 2]);
 f14 = Math_fround(HEAPF32[i33 >> 2]);
 f12 = Math_fround(f12 - f14);
 f13 = Math_fround(HEAPF32[i34 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i33 + 4 >> 2]);
 f13 = Math_fround(f13 - f10);
 f16 = Math_fround(HEAPF32[i33 + 12 >> 2]);
 f11 = Math_fround(f12 * f16);
 f15 = Math_fround(HEAPF32[i33 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f13 * f15));
 f12 = Math_fround(Math_fround(f16 * f13) - Math_fround(f12 * f15));
 f14 = Math_fround(Math_fround(HEAPF32[i34 + 8 >> 2]) - f14);
 f10 = Math_fround(Math_fround(HEAPF32[i34 + 12 >> 2]) - f10);
 f13 = Math_fround(Math_fround(Math_fround(f16 * f14) + Math_fround(f15 * f10)) - f11);
 f14 = Math_fround(Math_fround(Math_fround(f16 * f10) - Math_fround(f15 * f14)) - f12);
 i3 = HEAP32[i35 + 148 >> 2] | 0;
 if ((i3 | 0) <= 0) {
  i38 = 0;
  STACKTOP = i37;
  return i38 | 0;
 }
 f10 = Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i34 + 16 >> 2]);
 i1 = -1;
 i2 = 0;
 L19 : while (1) {
  f40 = Math_fround(Math_fround(HEAPF32[i35 + 20 + (i2 << 3) >> 2]) - f11);
  f8 = Math_fround(Math_fround(HEAPF32[i35 + 20 + (i2 << 3) + 4 >> 2]) - f12);
  f39 = Math_fround(HEAPF32[i35 + 84 + (i2 << 3) >> 2]);
  f40 = Math_fround(f40 * f39);
  f9 = Math_fround(HEAPF32[i35 + 84 + (i2 << 3) + 4 >> 2]);
  f8 = Math_fround(f40 + Math_fround(f8 * f9));
  f9 = Math_fround(Math_fround(f13 * f39) + Math_fround(f14 * f9));
  do if (f9 == Math_fround(0.0)) {
   if (f8 < Math_fround(0.0)) {
    i1 = 0;
    i2 = 23;
    break L19;
   }
  } else {
   if (f9 < Math_fround(0.0) & f8 < Math_fround(f10 * f9)) {
    f10 = Math_fround(f8 / f9);
    i1 = i2;
    break;
   }
   if (f9 > Math_fround(0.0) & f8 < Math_fround(f7 * f9)) f7 = Math_fround(f8 / f9);
  } while (0);
  i2 = i2 + 1 | 0;
  if (f7 < f10) {
   i1 = 0;
   i2 = 23;
   break;
  }
  if ((i2 | 0) >= (i3 | 0)) {
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) {
  if ((i1 | 0) <= -1) {
   i38 = 0;
   STACKTOP = i37;
   return i38 | 0;
  }
  HEAPF32[i36 + 8 >> 2] = f10;
  f40 = Math_fround(HEAPF32[i35 + 84 + (i1 << 3) >> 2]);
  f14 = Math_fround(f16 * f40);
  f39 = Math_fround(HEAPF32[i35 + 84 + (i1 << 3) + 4 >> 2]);
  f40 = Math_fround(Math_fround(f40 * f15) + Math_fround(f16 * f39));
  HEAPF32[i36 >> 2] = Math_fround(f14 - Math_fround(f15 * f39));
  HEAPF32[i36 + 4 >> 2] = f40;
  i38 = 1;
  STACKTOP = i37;
  return i38 | 0;
 } else if ((i2 | 0) == 23) {
  STACKTOP = i37;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx15PxBroadPhaseExt28createRegionsFromWorldBoundsEPNS_9PxBounds3ERKS1_jj(i29, i26, i28, i30) {
 i29 = i29 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i27 = 0;
 i18 = i26 + 12 | 0;
 f23 = Math_fround(HEAPF32[i18 >> 2]);
 f22 = Math_fround(i28 >>> 0);
 f23 = Math_fround(Math_fround(f23 - Math_fround(HEAPF32[i26 >> 2])) / f22);
 i24 = i26 + 16 | 0;
 f19 = Math_fround(HEAPF32[i24 >> 2]);
 i25 = i26 + 4 | 0;
 f19 = Math_fround(Math_fround(f19 - Math_fround(HEAPF32[i25 >> 2])) / f22);
 i20 = i26 + 20 | 0;
 f17 = Math_fround(HEAPF32[i20 >> 2]);
 i21 = i26 + 8 | 0;
 f22 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i21 >> 2])) / f22);
 if (!i28) {
  i30 = 0;
  return i30 | 0;
 }
 i13 = 0;
 i3 = 0;
 i10 = 0;
 i11 = 0;
 i9 = 0;
 i12 = 0;
 i27 = 0;
 i1 = 0;
 while (1) {
  f14 = Math_fround(i27 >>> 0);
  f16 = Math_fround(f22 * f14);
  i27 = i27 + 1 | 0;
  f15 = Math_fround(i27 >>> 0);
  f17 = Math_fround(f22 * f15);
  f14 = Math_fround(f19 * f14);
  f15 = Math_fround(f19 * f15);
  switch (i30 | 0) {
  case 0:
   {
    i7 = 0;
    i9 = i1;
    while (1) {
     i4 = HEAP32[i26 >> 2] | 0;
     f2 = Math_fround(HEAPF32[i25 >> 2]);
     f8 = Math_fround(Math_fround(f19 * Math_fround(i7 >>> 0)) + f2);
     f6 = Math_fround(HEAPF32[i21 >> 2]);
     f5 = Math_fround(f16 + f6);
     i3 = HEAP32[i18 >> 2] | 0;
     f2 = Math_fround(Math_fround(f19 * Math_fround((i7 + 1 | 0) >>> 0)) + f2);
     f6 = Math_fround(f17 + f6);
     HEAP32[i29 + (i9 * 24 | 0) >> 2] = i4;
     HEAPF32[i29 + (i9 * 24 | 0) + 4 >> 2] = f8;
     HEAPF32[i29 + (i9 * 24 | 0) + 8 >> 2] = f5;
     HEAP32[i29 + (i9 * 24 | 0) + 12 >> 2] = i3;
     HEAPF32[i29 + (i9 * 24 | 0) + 16 >> 2] = f2;
     HEAPF32[i29 + (i9 * 24 | 0) + 20 >> 2] = f6;
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i28 | 0)) break; else i9 = i9 + 1 | 0;
    }
    i12 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = i1 + i28 | 0;
    i10 = i3;
    i9 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = i4;
    i4 = i12;
    i3 = i13;
    break;
   }
  case 1:
   {
    i9 = 0;
    i7 = i1;
    while (1) {
     f2 = Math_fround(HEAPF32[i26 >> 2]);
     f8 = Math_fround(Math_fround(f23 * Math_fround(i9 >>> 0)) + f2);
     i4 = HEAP32[i25 >> 2] | 0;
     f6 = Math_fround(HEAPF32[i21 >> 2]);
     f5 = Math_fround(f16 + f6);
     f2 = Math_fround(Math_fround(f23 * Math_fround((i9 + 1 | 0) >>> 0)) + f2);
     i3 = HEAP32[i24 >> 2] | 0;
     f6 = Math_fround(f17 + f6);
     i1 = i7 + 1 | 0;
     HEAPF32[i29 + (i7 * 24 | 0) >> 2] = f8;
     HEAP32[i29 + (i7 * 24 | 0) + 4 >> 2] = i4;
     HEAPF32[i29 + (i7 * 24 | 0) + 8 >> 2] = f5;
     HEAPF32[i29 + (i7 * 24 | 0) + 12 >> 2] = f2;
     HEAP32[i29 + (i7 * 24 | 0) + 16 >> 2] = i3;
     HEAPF32[i29 + (i7 * 24 | 0) + 20 >> 2] = f6;
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= i28 >>> 0) break; else i7 = i1;
    }
    i7 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = i3;
    i9 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = i13;
    break;
   }
  case 2:
   {
    i9 = 0;
    i7 = i1;
    while (1) {
     f2 = Math_fround(HEAPF32[i26 >> 2]);
     f6 = Math_fround(Math_fround(f23 * Math_fround(i9 >>> 0)) + f2);
     f5 = Math_fround(HEAPF32[i25 >> 2]);
     f8 = Math_fround(f14 + f5);
     i3 = HEAP32[i21 >> 2] | 0;
     f2 = Math_fround(Math_fround(f23 * Math_fround((i9 + 1 | 0) >>> 0)) + f2);
     f5 = Math_fround(f15 + f5);
     i4 = HEAP32[i20 >> 2] | 0;
     i1 = i7 + 1 | 0;
     HEAPF32[i29 + (i7 * 24 | 0) >> 2] = f6;
     HEAPF32[i29 + (i7 * 24 | 0) + 4 >> 2] = f8;
     HEAP32[i29 + (i7 * 24 | 0) + 8 >> 2] = i3;
     HEAPF32[i29 + (i7 * 24 | 0) + 12 >> 2] = f2;
     HEAPF32[i29 + (i7 * 24 | 0) + 16 >> 2] = f5;
     HEAP32[i29 + (i7 * 24 | 0) + 20 >> 2] = i4;
     i9 = i9 + 1 | 0;
     if (i9 >>> 0 >= i28 >>> 0) break; else i7 = i1;
    }
    i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    i13 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
    i10 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    i11 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i9 = i4;
    i4 = i13;
    break;
   }
  default:
   {
    i7 = 0;
    i4 = i1;
    while (1) {
     i1 = i4 + 1 | 0;
     HEAP32[i29 + (i4 * 24 | 0) >> 2] = i12;
     HEAP32[i29 + (i4 * 24 | 0) + 4 >> 2] = i13;
     HEAP32[i29 + (i4 * 24 | 0) + 8 >> 2] = i3;
     HEAP32[i29 + (i4 * 24 | 0) + 12 >> 2] = i10;
     HEAP32[i29 + (i4 * 24 | 0) + 16 >> 2] = i11;
     HEAP32[i29 + (i4 * 24 | 0) + 20 >> 2] = i9;
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 >= i28 >>> 0) {
      i7 = i12;
      i4 = i13;
      break;
     } else i4 = i1;
    }
   }
  }
  if (i27 >>> 0 >= i28 >>> 0) break; else {
   i13 = i4;
   i12 = i7;
  }
 }
 return i1 | 0;
}

function __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_(i1, i18, i19) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0;
 i14 = i19 + 4 | 0;
 i15 = i19 + 12 | 0;
 i16 = i18 + 4 | 0;
 i17 = i18 + 12 | 0;
 i10 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i11 = i19 + 8 | 0;
 i12 = i18 + 8 | 0;
 i13 = 0;
 do {
  i9 = i13;
  i13 = i13 + 1 | 0;
  i8 = HEAP32[i18 + (((i13 | 0) == 3 ? 0 : i13) << 2) >> 2] | 0;
  i9 = HEAP32[i18 + (((i9 + 2 | 0) % 3 | 0) << 2) >> 2] | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  i4 = (i1 | 0) == (i9 | 0);
  i5 = HEAP32[i14 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i8 | 0)) {
   i1 = 2;
   i20 = 3;
  } else {
   i1 = (i1 | 0) == (i8 | 0);
   i2 = (i5 | 0) == (i9 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i11 >> 2] | 0;
    if (i2 & (i3 | 0) == (i8 | 0)) {
     i1 = 0;
     i20 = 3;
     break;
    }
    if ((i5 | 0) == (i8 | 0) & (i3 | 0) == (i9 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i9 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 3;
      break;
     }
     if ((i3 | 0) != (i8 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i15 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 3) {
   i20 = 0;
   i1 = i15 + (i1 << 2) | 0;
  }
  i7 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  i4 = (i1 | 0) == (i8 | 0);
  i5 = HEAP32[i16 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i9 | 0)) {
   i1 = 2;
   i20 = 11;
  } else {
   i1 = (i1 | 0) == (i9 | 0);
   i2 = (i5 | 0) == (i8 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i12 >> 2] | 0;
    if (i2 & (i3 | 0) == (i9 | 0)) {
     i1 = 0;
     i20 = 11;
     break;
    }
    if ((i5 | 0) == (i9 | 0) & (i3 | 0) == (i8 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i8 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 11;
      break;
     }
     if ((i3 | 0) != (i9 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i17 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 11) {
   i20 = 0;
   i1 = i17 + (i1 << 2) | 0;
  }
  i6 = HEAP32[i10 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = (i1 | 0) == (i9 | 0);
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i8 | 0)) {
   i1 = 2;
   i20 = 19;
  } else {
   i1 = (i1 | 0) == (i8 | 0);
   i2 = (i5 | 0) == (i9 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i6 + 8 >> 2] | 0;
    if (i2 & (i3 | 0) == (i8 | 0)) {
     i1 = 0;
     i20 = 19;
     break;
    }
    if ((i5 | 0) == (i8 | 0) & (i3 | 0) == (i9 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i9 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 19;
      break;
     }
     if ((i3 | 0) != (i8 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i6 + 12 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 19) {
   i20 = 0;
   i1 = i6 + 12 + (i1 << 2) | 0;
  }
  HEAP32[i1 >> 2] = i7;
  i1 = HEAP32[i18 >> 2] | 0;
  i4 = (i1 | 0) == (i8 | 0);
  i5 = HEAP32[i16 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i9 | 0)) {
   i1 = 2;
   i20 = 27;
  } else {
   i1 = (i1 | 0) == (i9 | 0);
   i2 = (i5 | 0) == (i8 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i12 >> 2] | 0;
    if (i2 & (i3 | 0) == (i9 | 0)) {
     i1 = 0;
     i20 = 27;
     break;
    }
    if ((i5 | 0) == (i9 | 0) & (i3 | 0) == (i8 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i8 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 27;
      break;
     }
     if ((i3 | 0) != (i9 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i17 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 27) {
   i20 = 0;
   i1 = i17 + (i1 << 2) | 0;
  }
  i7 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  i4 = (i1 | 0) == (i9 | 0);
  i5 = HEAP32[i14 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i8 | 0)) {
   i1 = 2;
   i20 = 35;
  } else {
   i1 = (i1 | 0) == (i8 | 0);
   i2 = (i5 | 0) == (i9 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i11 >> 2] | 0;
    if (i2 & (i3 | 0) == (i8 | 0)) {
     i1 = 0;
     i20 = 35;
     break;
    }
    if ((i5 | 0) == (i8 | 0) & (i3 | 0) == (i9 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i9 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 35;
      break;
     }
     if ((i3 | 0) != (i8 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i15 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 35) {
   i20 = 0;
   i1 = i15 + (i1 << 2) | 0;
  }
  i6 = HEAP32[i10 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = (i1 | 0) == (i8 | 0);
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  do if (i4 & (i5 | 0) == (i9 | 0)) {
   i1 = 2;
   i20 = 43;
  } else {
   i1 = (i1 | 0) == (i9 | 0);
   i2 = (i5 | 0) == (i8 | 0);
   if (i1 & i2) i1 = 2; else {
    i3 = HEAP32[i6 + 8 >> 2] | 0;
    if (i2 & (i3 | 0) == (i9 | 0)) {
     i1 = 0;
     i20 = 43;
     break;
    }
    if ((i5 | 0) == (i9 | 0) & (i3 | 0) == (i8 | 0)) i1 = 0; else {
     if (!((i3 | 0) != (i8 | 0) | i1 ^ 1)) {
      i1 = 1;
      i20 = 43;
      break;
     }
     if ((i3 | 0) != (i9 | 0) | i4 ^ 1) {
      i1 = gb + 110160 | 0;
      break;
     } else i1 = 1;
    }
   }
   i1 = i6 + 12 + (i1 << 2) | 0;
  } while (0);
  if ((i20 | 0) == 43) {
   i20 = 0;
   i1 = i6 + 12 + (i1 << 2) | 0;
  }
  HEAP32[i1 >> 2] = i7;
 } while ((i13 | 0) != 3);
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 48 | 0;
 i6 = i17 + 40 | 0;
 i15 = i17 + 8 | 0;
 i7 = i17 + 36 | 0;
 i8 = i17 + 32 | 0;
 i1 = i17 + 28 | 0;
 i2 = i17 + 24 | 0;
 i3 = i17;
 i12 = i11 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = ((HEAP32[i12 >> 2] | 0) - i4 | 0) / 20 | 0;
 if (i5 >>> 0 >= i9 >>> 0) {
  if (i5 >>> 0 <= i9 >>> 0) {
   STACKTOP = i17;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i2 >> 2] = i4 + (i9 * 20 | 0);
  HEAP32[i3 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
  __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEEC2INS_11__wrap_iterIPS2_EEEET_SB_RKS5_PNS_9enable_ifIXaasr21__is_forward_iteratorISB_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeE(i15, i6, i16, i3, 0);
  i8 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  i8 = i15 + 4 | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i12 >> 2] = i13;
  i13 = i15 + 8 | 0;
  i7 = i11 + 8 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i14;
  i7 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i7 | 0)) {
    i6 = i16 + 4 | 0;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i8 >> 2] = i1;
     i4 = HEAP32[i2 + -16 >> 2] | 0;
     i5 = i4;
     if (i4) {
      i1 = i2 + -12 | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((i3 | 0) != (i4 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
      i1 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 51;
      HEAP32[i6 >> 2] = i1;
      __Z19free_alloc_internalPvRK10MemLabelId(i4, i16);
      i1 = HEAP32[i8 >> 2] | 0;
     }
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   i15 = HEAP32[i15 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i10 = i11 + 8 | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i4 | 0) / 20 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE8__appendEj(i11, i9 - i5 | 0);
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 i13 = i15 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i14 = i15 + 12 | 0;
 HEAP32[i14 >> 2] = i2;
 __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE7reserveEj(i15, i9);
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i15, i6, i16);
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 20 | 0;
 i4 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE8__appendEj(i15, i9 - i1 | 0);
  i2 = HEAP32[i13 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i7 = i3 + (i9 * 20 | 0) | 0;
  if ((i4 | 0) != (i7 | 0)) {
   i6 = i16 + 4 | 0;
   while (1) {
    i2 = i4 + -20 | 0;
    HEAP32[i13 >> 2] = i2;
    i3 = HEAP32[i4 + -16 >> 2] | 0;
    i5 = i3;
    if (i3) {
     i1 = i4 + -12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i5 | 0) >>> 2) << 2);
     i2 = HEAP32[i4 + -4 >> 2] | 0;
     HEAP32[i16 >> 2] = 51;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i16);
     i2 = HEAP32[i13 >> 2] | 0;
    }
    if ((i2 | 0) == (i7 | 0)) break; else i4 = i2;
   }
  }
 }
 i7 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i11 >> 2] = i7;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i12 >> 2] = i2;
 i2 = i15 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i7;
 i7 = i1;
 i2 = i11;
 if (i1 | 0) {
  if ((i2 | 0) != (i7 | 0)) {
   i6 = i16 + 4 | 0;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i13 >> 2] = i1;
    i4 = HEAP32[i2 + -16 >> 2] | 0;
    i5 = i4;
    if (i4) {
     i1 = i2 + -12 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) != (i4 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
     i1 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i16 >> 2] = 51;
     HEAP32[i6 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i16);
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i15 >> 2] | 0;
  }
  i15 = HEAP32[i14 >> 2] | 0;
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZNK5physx36PxVehicleDriveSimData4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j(i12, i17, i18) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i14 = i19 + 256 | 0;
 i16 = i19 + 224 | 0;
 i15 = i19 + 112 | 0;
 i6 = HEAP32[i12 + 72 >> 2] | 0;
 i5 = HEAP32[i12 + 64 >> 2] | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i13;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 i9 = i17 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev(i15);
 i10 = i17 + 8 | 0;
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i11 = i17 + 4 | 0;
 i7 = i17 + 12 | 0;
 i8 = i17 + 16 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i6;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i6 = HEAP32[i12 + 88 >> 2] | 0;
 i5 = HEAP32[i12 + 80 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i11 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i4 = i13;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i13) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i15;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev(i15);
 mftCall_vii(i6 | 0, i16 | 0, HEAP32[i10 >> 2] | 0);
 i12 = HEAP32[i17 >> 2] | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = i12;
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i14 + 8 >> 2] = i16;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP32[i14 + 16 >> 2] = i2;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx43PxVehicleAckermannGeometryDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEEEEEjT_j(i13, i14, 0) | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i18 = i18 + 2 | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i18 = i18 + 2 | 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 65;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 65;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 127;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 127;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 127;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 127;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i19, i17) {
 i19 = i19 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 40 | 0;
 i18 = i22 + 24 | 0;
 i16 = i22;
 i10 = i22 + 20 | 0;
 i11 = i22 + 16 | 0;
 i20 = i19 + 4 | 0;
 i9 = HEAP32[i19 >> 2] | 0;
 i1 = (HEAP32[i20 >> 2] | 0) - i9 >> 4;
 i4 = i9;
 if (i1 >>> 0 >= i17 >>> 0) {
  if (i1 >>> 0 <= i17 >>> 0) {
   STACKTOP = i22;
   return;
  }
  i8 = i4 + (i17 << 4) | 0;
  i1 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  i10 = i18 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i11 = i18 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i17 << 4;
  i3 = i2 >> 4;
  if (!i3) {
   i3 = i18 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i21 >> 2] = 1;
   HEAP32[i21 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i18 >> 2] = i6;
   i1 = i6 + (i3 << 4) | 0;
   i3 = i18 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i17) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -16 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     i2 = i2 + 16 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 16 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 4) + 1 << 4) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i19 >> 2] | 0;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i19 >> 2] = i5;
  i18 = HEAP32[i20 >> 2] | 0;
  HEAP32[i10 >> 2] = i18;
  HEAP32[i20 >> 2] = i2;
  i2 = i19 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i18;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -16 - i4 | 0) >>> 4) << 4);
   i20 = HEAP32[i11 >> 2] | 0;
   HEAP32[i21 >> 2] = 1;
   HEAP32[i21 + 4 >> 2] = i20;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
  }
  STACKTOP = i22;
  return;
 }
 i13 = i19 + 8 | 0;
 if (((HEAP32[i13 >> 2] | 0) - i9 >> 4 | 0) == (i17 | 0)) {
  __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i19, i17 - i1 | 0);
  STACKTOP = i22;
  return;
 }
 i1 = HEAP32[i19 + 12 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 i14 = i16 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i15 = i16 + 12 | 0;
 HEAP32[i15 >> 2] = i1;
 i12 = i16 + 8 | 0;
 if (i17 | 0) {
  HEAP32[i21 >> 2] = 1;
  HEAP32[i21 + 4 >> 2] = i1;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17 << 4, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = i4;
  i8 = i5;
  i9 = i5 + (i17 << 4) | 0;
  i7 = i4;
  if ((i2 | 0) == (i4 | 0)) {
   i2 = i8;
   i1 = i7;
  } else {
   i6 = i2 + -16 | 0;
   i3 = i5;
   while (1) {
    i23 = i2;
    i2 = i2 + -16 | 0;
    HEAP32[i3 + -16 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + -12 >> 2] = HEAP32[i23 + -12 >> 2];
    HEAP32[i3 + -8 >> 2] = HEAP32[i23 + -8 >> 2];
    HEAP32[i3 + -4 >> 2] = HEAP32[i23 + -4 >> 2];
    if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + -16 | 0;
   }
   i2 = i5 + (~((i6 - i7 | 0) >>> 4) << 4) | 0;
  }
  HEAP32[i16 >> 2] = i2;
  HEAP32[i14 >> 2] = i8;
  HEAP32[i12 >> 2] = i9;
  if (i1 | 0) {
   i23 = HEAP32[i15 >> 2] | 0;
   HEAP32[i21 >> 2] = 1;
   HEAP32[i21 + 4 >> 2] = i23;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
  }
 }
 HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
 __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i16, i18, i21);
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i2 = i1 - i4 >> 4;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i17 >>> 0) {
  __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i16, i17 - i2 | 0);
  i2 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
 } else if (i2 >>> 0 > i17 >>> 0) {
  i2 = i3 + (i17 << 4) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -16 - i2 | 0) >>> 4) << 4) | 0;
   HEAP32[i14 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i19 >> 2] | 0;
 HEAP32[i16 >> 2] = i3;
 HEAP32[i19 >> 2] = i2;
 i2 = HEAP32[i20 >> 2] | 0;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i20 >> 2] = i1;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i14 >> 2] = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4);
  i23 = HEAP32[i15 >> 2] | 0;
  HEAP32[i21 >> 2] = 1;
  HEAP32[i21 + 4 >> 2] = i23;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
 }
 STACKTOP = i22;
 return;
}

function __ZN24CompressedAnimationCurve19DecompressQuatCurveERN13AnimationClip15QuaternionCurveE(i21, i24) {
 i21 = i21 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i29;
 i26 = i29 + 28 | 0;
 i27 = i29 + 8 | 0;
 i19 = i24 + 16 | 0;
 __ZN24CompressedAnimationCurve18DecompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E(i21, i19);
 i23 = i21 + 20 | 0;
 i20 = HEAP32[i23 >> 2] | 0;
 HEAP32[i26 + 12 >> 2] = i20;
 i28 = i26 + 16 | 0;
 HEAP32[i28 >> 2] = i20;
 i25 = i26 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i17 = i4;
 i22 = HEAP32[i17 + 4 >> 2] | 0;
 i18 = i25;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = i22;
 i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20 << 4, 4, i25, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i26 >> 2] = i18;
 __ZN16PackedQuatVector11UnpackQuatsEP11Quaternionf(i23, i18);
 i18 = (i20 | 0) > 0;
 if (i18) {
  i3 = i24 + 168 | 0;
  i2 = HEAP32[i26 >> 2] | 0;
  i1 = 0;
  do {
   i23 = (HEAP32[i3 >> 2] | 0) + (i1 * 52 | 0) + 4 | 0;
   i22 = i2 + (i1 << 4) | 0;
   HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i20 | 0));
 }
 i16 = i20 << 3;
 HEAP32[i27 + 12 >> 2] = i16;
 i22 = i27 + 16 | 0;
 HEAP32[i22 >> 2] = i16;
 i23 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i15 = i4;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i23;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i14;
 i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20 << 5, 4, i23, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i27 >> 2] = i17;
 i14 = HEAP8[i21 + 48 >> 0] | 0;
 i15 = i14 & 255;
 d7 = +Math_fround(HEAPF32[i21 + 40 >> 2]);
 if (i14 << 24 >> 24) d7 = d7 / +((1 << i15) + -1 | 0);
 i10 = HEAP32[i21 + 36 >> 2] | 0;
 i11 = i17 + (i10 << 2) | 0;
 if (i10 | 0) {
  i12 = i21 + 44 | 0;
  i13 = i21 + 52 | 0;
  i4 = 0;
  i3 = 0;
  i9 = i17;
  i1 = i14;
  do {
   i2 = i1 & 255;
   if (!(i1 << 24 >> 24)) {
    i5 = 0;
    i1 = 0;
   } else {
    i8 = HEAP32[i13 >> 2] | 0;
    i6 = 0;
    i5 = 0;
    i1 = i4;
    while (1) {
     i4 = (HEAPU8[i8 + i1 >> 0] | 0) >>> i3 << i6 | i5;
     i5 = i2 - i6 | 0;
     i2 = 8 - i3 | 0;
     i5 = (i2 | 0) < (i5 | 0) ? i2 : i5;
     i3 = i5 + i3 | 0;
     i6 = i5 + i6 | 0;
     i5 = (i3 | 0) == 8;
     i3 = i5 ? 0 : i3;
     i1 = (i5 & 1) + i1 | 0;
     if ((i15 | 0) <= (i6 | 0)) {
      i5 = i4;
      i4 = i1;
      i2 = i15;
      i1 = i14;
      break;
     } else {
      i5 = i4;
      i2 = i15;
     }
    }
   }
   HEAPF32[i9 >> 2] = Math_fround(+Math_fround(HEAPF32[i12 >> 2]) + d7 * +(((1 << i2) + -1 & i5) >>> 0));
   i9 = i9 + 4 | 0;
  } while ((i9 | 0) != (i11 | 0));
 }
 i3 = (i10 | 0) == (i16 | 0) ? i20 : 0;
 if (i18) {
  i2 = HEAP32[i24 + 168 >> 2] | 0;
  i1 = 0;
  do {
   i18 = i1 << 2;
   HEAP32[i2 + (i1 * 52 | 0) + 20 >> 2] = HEAP32[i17 + (i18 << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 24 >> 2] = HEAP32[i17 + ((i18 | 1) << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 28 >> 2] = HEAP32[i17 + ((i18 | 2) << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 32 >> 2] = HEAP32[i17 + ((i18 | 3) << 2) >> 2];
   i18 = i1 + i3 << 2;
   HEAP32[i2 + (i1 * 52 | 0) + 36 >> 2] = HEAP32[i17 + (i18 << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 40 >> 2] = HEAP32[i17 + ((i18 | 1) << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 44 >> 2] = HEAP32[i17 + ((i18 | 2) << 2) >> 2];
   HEAP32[i2 + (i1 * 52 | 0) + 48 >> 2] = HEAP32[i17 + ((i18 | 3) << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i20 | 0));
 }
 HEAP32[i24 + 188 >> 2] = HEAP32[i21 + 64 >> 2];
 __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i19);
 HEAP32[i24 + 192 >> 2] = HEAP32[i21 + 68 >> 2];
 __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i19);
 i1 = i21 + 72 | 0;
 do if ((i24 | 0) != (i1 | 0)) {
  i4 = HEAP8[i1 + 11 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
  i4 = i5 ? HEAP32[i21 + 76 >> 2] | 0 : i4 & 255;
  i5 = i24 + 11 | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i24 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i4 >>> 0 > i3 >>> 0) {
   i21 = i2 ? HEAP32[i24 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i24, i3, i4 - i3 | 0, i21, 0, i21, i4, i6);
   break;
  }
  i1 = i2 ? HEAP32[i24 >> 2] | 0 : i24;
  if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i24 + 4 >> 2] = i4;
   break;
  } else {
   HEAP8[i5 >> 0] = i4;
   break;
  }
 } while (0);
 if ((HEAP32[i22 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i23);
  HEAP32[i27 >> 2] = 0;
 }
 if ((HEAP32[i28 >> 2] | 0) <= -1) {
  STACKTOP = i29;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i25);
 HEAP32[i26 >> 2] = 0;
 STACKTOP = i29;
 return;
}

function __ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 i15 = HEAP32[HEAP32[i2 + 8 >> 2] >> 2] | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i10 = HEAP32[i16 + 16 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 i8 = HEAP32[i4 + 16 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 do if (!(f7 < f9)) {
  if (f7 == f9) {
   f6 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   if (f6 <= Math_fround(HEAPF32[i8 + 28 >> 2])) break;
  }
  i3 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = HEAP32[i3 + 16 >> 2] | 0;
  f5 = Math_fround(f9 - Math_fround(HEAPF32[i1 + 24 >> 2]));
  f6 = Math_fround(f7 - f9);
  if (Math_fround(f5 + f6) > Math_fround(0.0)) {
   f17 = Math_fround(HEAPF32[i8 + 28 >> 2]);
   f5 = Math_fround(f5 * Math_fround(f17 - Math_fround(HEAPF32[i10 + 28 >> 2])));
   if (Math_fround(f5 + Math_fround(f6 * Math_fround(f17 - Math_fround(HEAPF32[i1 + 28 >> 2])))) < Math_fround(0.0)) {
    i16 = 0;
    return i16 | 0;
   }
  }
  HEAP32[i14 + 20 >> 2] = 1;
  HEAP32[(HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0) + 20 >> 2] = 1;
  i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i13 >> 2] | 0, i3) | 0;
  if (!i1) {
   i12 = i13 + 144 | 0;
   _longjmp(i12 | 0, 1);
  }
  i12 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i20 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 12 >> 2] | 0;
  i18 = i2 + 8 | 0;
  i11 = HEAP32[i18 >> 2] | 0;
  i1 = i20 + 8 | 0;
  i19 = HEAP32[i1 >> 2] | 0;
  HEAP32[(HEAP32[i11 + 4 >> 2] | 0) + 12 >> 2] = i20;
  HEAP32[(HEAP32[i19 + 4 >> 2] | 0) + 12 >> 2] = i2;
  HEAP32[i18 >> 2] = i19;
  HEAP32[i1 >> 2] = i11;
  i1 = HEAP32[i18 >> 2] | 0;
  i11 = i12 + 8 | 0;
  i19 = HEAP32[i11 >> 2] | 0;
  HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] = i12;
  HEAP32[(HEAP32[i19 + 4 >> 2] | 0) + 12 >> 2] = i2;
  HEAP32[i18 >> 2] = i19;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i2 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + 8 >> 2] = i11;
  HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i12 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i11 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  if (!i12) {
   i20 = i13 + 144 | 0;
   _longjmp(i20 | 0, 1);
  }
  if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i13 >> 2] | 0, HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] | 0, i16) | 0)) _longjmp(i13 + 144 | 0, 1); else {
   i20 = 1;
   return i20 | 0;
  }
 } while (0);
 i11 = i4 + 4 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 f5 = Math_fround(f7 - Math_fround(HEAPF32[i1 + 24 >> 2]));
 f6 = Math_fround(f9 - f7);
 if (Math_fround(f5 + f6) > Math_fround(0.0)) {
  f17 = Math_fround(HEAPF32[i10 + 28 >> 2]);
  f5 = Math_fround(f5 * Math_fround(f17 - Math_fround(HEAPF32[i8 + 28 >> 2])));
  if (Math_fround(f5 + Math_fround(f6 * Math_fround(f17 - Math_fround(HEAPF32[i1 + 28 >> 2])))) > Math_fround(0.0)) {
   i20 = 0;
   return i20 | 0;
  }
 }
 if (f7 == f9) {
  f17 = Math_fround(HEAPF32[i10 + 28 >> 2]);
  if (f17 == Math_fround(HEAPF32[i8 + 28 >> 2])) {
   if ((i10 | 0) == (i8 | 0)) {
    i20 = 1;
    return i20 | 0;
   }
   i2 = HEAP32[i13 + 68 >> 2] | 0;
   i1 = HEAP32[i10 + 32 >> 2] | 0;
   L30 : do if ((i1 | 0) > -1) __Z12pqHeapDeleteP13PriorityQHeapi(HEAP32[i2 >> 2] | 0, i1); else {
    HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (~i1 << 2) >> 2] = 0;
    i4 = i2 + 12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) > 0) {
     i3 = HEAP32[i2 + 8 >> 2] | 0;
     do {
      i2 = i1;
      i1 = i1 + -1 | 0;
      if (HEAP32[HEAP32[i3 + (i1 << 2) >> 2] >> 2] | 0) break L30;
      HEAP32[i4 >> 2] = i1;
     } while ((i2 | 0) > 1);
    }
   } while (0);
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i13 >> 2] | 0, HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i16) | 0)) _longjmp(i13 + 144 | 0, 1); else {
    i20 = 1;
    return i20 | 0;
   }
  }
 }
 i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i13 >> 2] | 0, i12) | 0;
 if (!i1) {
  i20 = i13 + 144 | 0;
  _longjmp(i20 | 0, 1);
 }
 i20 = HEAP32[i1 + 4 >> 2] | 0;
 i18 = HEAP32[i12 + 4 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i18 + 4 >> 2] | 0) + 12 >> 2] | 0;
 i8 = i18 + 8 | 0;
 i19 = HEAP32[i8 >> 2] | 0;
 i10 = i3 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[(HEAP32[i19 + 4 >> 2] | 0) + 12 >> 2] = i3;
 HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i18;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i19;
 i10 = HEAP32[i8 >> 2] | 0;
 i19 = i20 + 8 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i20;
 HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i18;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i19 >> 2] = i10;
 HEAP32[i18 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[(HEAP32[i19 + 16 >> 2] | 0) + 8 >> 2] = i19;
 HEAP32[i19 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 if (!i20) {
  i20 = i13 + 144 | 0;
  _longjmp(i20 | 0, 1);
 }
 if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i13 >> 2] | 0, i16, HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0) | 0)) _longjmp(i13 + 144 | 0, 1);
 HEAP32[i15 + 20 >> 2] = 1;
 HEAP32[i14 + 20 >> 2] = 1;
 i20 = 1;
 return i20 | 0;
}

function __Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags(i9, i4, i5, i6, i7) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 8 | 0;
 i3 = i13;
 i8 = (HEAP32[i5 + 16 >> 2] | 0) + (HEAP32[i5 + 4 >> 2] | 0) + (HEAP32[i5 + 28 >> 2] | 0) + (HEAP32[i5 + 40 >> 2] | 0) + (HEAP32[i5 + 52 >> 2] | 0) | 0;
 if (!i8) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i10 = __ZnwjRK10MemLabelIdiPKci(1704, gb + 64024 | 0, 16, gb + 383845 | 0, 334) | 0;
 i11 = i10 + 24 | 0;
 i12 = i10 + 1304 | 0;
 i1 = i11;
 do {
  __ZN22PerThreadPageAllocatorC2Ev(i1 + 16 | 0);
  i14 = i1 + 32 | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 + 16 >> 2] = 0;
  HEAP32[i14 + 20 >> 2] = 0;
  i14 = gb + 64024 | 0;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i3;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i15;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 68 >> 2] = 0;
  HEAP32[i1 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
  i16 = i2;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i1 + 60 | 0;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i12 | 0));
 HEAP32[i12 >> 2] = 0;
 HEAP32[i10 + 1308 >> 2] = 0;
 i1 = HEAP32[gb + 1112412 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1508 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 16 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1512 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 32 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1516 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1520 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 64 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1524 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 80 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1528 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 96 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1532 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 112 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1536 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 128 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1540 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 144 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1544 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 160 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1548 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 176 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1552 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 192 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1556 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 208 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1560 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 224 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1564 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 240 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i10 + 1568 >> 2] = i1;
 HEAP32[i10 + 1504 >> 2] = i7;
 HEAP32[i10 + 8 >> 2] = i4;
 HEAP32[i10 + 12 >> 2] = i5;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 16 >> 2] = i6;
 if (!(i7 & 1)) i1 = 0; else i1 = HEAP32[(HEAP32[gb + 1112268 >> 2] | 0) + 64 >> 2] | 0;
 i1 = i1 + i8 | 0;
 i2 = i9 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 * 360 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 360 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 360 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i16;
  break;
 } while (0);
 i4 = i10 + 1312 | 0;
 i2 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i4, i8, 128) | 0;
 i16 = __Z19GetLightmapSettingsv() | 0;
 __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings(i10 + 1572 | 0, i16, __Z21GetManagerFromContexti(25) | 0);
 HEAP32[i10 + 20 >> 2] = i2;
 if ((i2 | 0) > 0) {
  i3 = i9 + 20 | 0;
  i1 = 0;
  do {
   HEAP32[i11 + (i1 * 80 | 0) >> 2] = HEAP32[i9 >> 2];
   __ZN22PerThreadPageAllocator10InitializeER19AtomicPageAllocator(i11 + (i1 * 80 | 0) + 16 | 0, i3);
   HEAP32[i11 + (i1 * 80 | 0) + 4 >> 2] = HEAP32[i4 + (i1 * 12 | 0) >> 2];
   HEAP32[i11 + (i1 * 80 | 0) + 12 >> 2] = 0;
   HEAP32[i11 + (i1 * 80 | 0) + 76 >> 2] = i10;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 32804 >> 2];
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i12, fb + 2382 | 0, i10, i2, fb + 3330 | 0, 0);
 i16 = i10;
 STACKTOP = i13;
 return i16 | 0;
}

function __ZN5physx2Gu16buildPartialHullERKNS0_13PolygonalDataEPNS0_12SupportLocalERNS0_14SeparatingAxesERKNS_6shdfnd3aos5Vec3VESC_(i3, i2, i42, i41, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i42 = i42 | 0;
 i41 = i41 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i43 = 0, i44 = 0, i45 = 0, f46 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i40 = i43;
 f34 = Math_fround(HEAPF32[i1 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f36 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f35 * f35)) + Math_fround(f23 * f23)))));
 f34 = Math_fround(f34 * f36);
 f35 = Math_fround(f35 * f36);
 f36 = Math_fround(f23 * f36);
 i37 = i3 + 16 | 0;
 i1 = HEAP32[i37 >> 2] | 0;
 if (!i1) {
  STACKTOP = i43;
  return;
 }
 i38 = i3 + 24 | 0;
 i39 = i3 + 32 | 0;
 i33 = i2 + 36 | 0;
 i28 = i3 + 28 | 0;
 i29 = i41 + 4 | 0;
 i30 = i41 + 8 | 0;
 i31 = i40 + 4 | 0;
 i32 = i40 + 8 | 0;
 i27 = 0;
 do {
  i26 = HEAP32[i38 >> 2] | 0;
  i24 = HEAP32[i39 >> 2] | 0;
  i25 = HEAPU16[i26 + (i27 * 20 | 0) + 16 >> 1] | 0;
  i44 = HEAP32[i33 >> 2] | 0;
  i26 = i26 + (i27 * 20 | 0) + 18 | 0;
  i3 = HEAP8[i26 >> 0] | 0;
  i45 = HEAPU8[i24 + (i25 + -1 + (i3 & 255)) >> 0] | 0;
  i2 = HEAP32[i28 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i2 + (i45 * 12 | 0) >> 2]);
  f23 = Math_fround(HEAPF32[i2 + (i45 * 12 | 0) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i2 + (i45 * 12 | 0) + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i44 >> 2]);
  f13 = Math_fround(f12 * f4);
  f5 = Math_fround(HEAPF32[i44 + 16 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f23 * f5));
  f6 = Math_fround(HEAPF32[i44 + 32 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f15 * f6));
  f7 = Math_fround(HEAPF32[i44 + 4 >> 2]);
  f14 = Math_fround(f12 * f7);
  f8 = Math_fround(HEAPF32[i44 + 20 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f23 * f8));
  f9 = Math_fround(HEAPF32[i44 + 36 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f15 * f9));
  f10 = Math_fround(HEAPF32[i44 + 8 >> 2]);
  f12 = Math_fround(f12 * f10);
  f11 = Math_fround(HEAPF32[i44 + 24 >> 2]);
  f23 = Math_fround(f12 + Math_fround(f23 * f11));
  f12 = Math_fround(HEAPF32[i44 + 40 >> 2]);
  f15 = Math_fround(f23 + Math_fround(f15 * f12));
  if (i3 << 24 >> 24) {
   f16 = Math_fround(HEAPF32[i41 >> 2]);
   f23 = Math_fround(f34 * Math_fround(f13 - f16));
   f17 = Math_fround(HEAPF32[i29 >> 2]);
   f23 = Math_fround(f23 + Math_fround(f35 * Math_fround(f14 - f17)));
   f19 = Math_fround(HEAPF32[i30 >> 2]);
   f18 = f19;
   f19 = Math_fround(f23 + Math_fround(f36 * Math_fround(f15 - f19)));
   i1 = i2;
   i2 = 0;
   while (1) {
    i45 = HEAPU8[i24 + (i2 + i25) >> 0] | 0;
    f46 = Math_fround(HEAPF32[i1 + (i45 * 12 | 0) >> 2]);
    f23 = Math_fround(HEAPF32[i1 + (i45 * 12 | 0) + 4 >> 2]);
    f22 = Math_fround(HEAPF32[i1 + (i45 * 12 | 0) + 8 >> 2]);
    f20 = Math_fround(Math_fround(Math_fround(f46 * f4) + Math_fround(f23 * f5)) + Math_fround(f22 * f6));
    f21 = Math_fround(Math_fround(Math_fround(f46 * f7) + Math_fround(f23 * f8)) + Math_fround(f22 * f9));
    f22 = Math_fround(Math_fround(Math_fround(f46 * f10) + Math_fround(f23 * f11)) + Math_fround(f22 * f12));
    f23 = Math_fround(Math_fround(Math_fround(f34 * Math_fround(f20 - f16)) + Math_fround(f35 * Math_fround(f21 - f17))) + Math_fround(f36 * Math_fround(f22 - f18)));
    if (f19 > Math_fround(0.0) | f23 > Math_fround(0.0)) {
     f8 = Math_fround(f13 - f20);
     f7 = Math_fround(f14 - f21);
     f4 = Math_fround(f15 - f22);
     f5 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f4 * f4));
     if (f5 > Math_fround(0.0)) {
      f46 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
      f6 = Math_fround(f4 * f46);
      f5 = Math_fround(f7 * f46);
      f4 = Math_fround(f8 * f46);
     } else {
      f6 = Math_fround(0.0);
      f5 = Math_fround(0.0);
      f4 = Math_fround(0.0);
     }
     HEAPF32[i40 >> 2] = f4;
     HEAPF32[i31 >> 2] = f5;
     HEAPF32[i32 >> 2] = f6;
     __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E(i42, i40) | 0;
     i1 = HEAP8[i26 >> 0] | 0;
    } else i1 = i3;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (i1 & 255) >>> 0) break;
    i3 = HEAP32[i33 >> 2] | 0;
    f4 = Math_fround(HEAPF32[i3 >> 2]);
    f5 = Math_fround(HEAPF32[i3 + 16 >> 2]);
    f6 = Math_fround(HEAPF32[i3 + 32 >> 2]);
    f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i3 + 20 >> 2]);
    f9 = Math_fround(HEAPF32[i3 + 36 >> 2]);
    f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    f11 = Math_fround(HEAPF32[i3 + 24 >> 2]);
    f12 = Math_fround(HEAPF32[i3 + 40 >> 2]);
    f16 = Math_fround(HEAPF32[i41 >> 2]);
    f17 = Math_fround(HEAPF32[i29 >> 2]);
    f18 = Math_fround(HEAPF32[i30 >> 2]);
    f19 = f23;
    f13 = f20;
    f14 = f21;
    f15 = f22;
    i3 = i1;
    i1 = HEAP32[i28 >> 2] | 0;
   }
   i1 = HEAP32[i37 >> 2] | 0;
  }
  i27 = i27 + 1 | 0;
 } while (i27 >>> 0 < i1 >>> 0);
 STACKTOP = i43;
 return;
}

function __ZN15DirectorManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 84 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 104 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 124 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 144 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 184 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 204 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 224 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 244 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 264 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = 0;
 i3 = i1 + 368 | 0;
 i4 = i1 + 280 | 0;
 i6 = i4 + 88 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 384 >> 2] = 0;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP32[i1 + 400 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 388 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 + 408 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 416 >> 2] = 0;
 HEAP32[i1 + 404 >> 2] = i1 + 408;
 HEAP32[i1 + 420 >> 2] = 0;
 HEAP32[i1 + 432 >> 2] = 0;
 HEAP32[i1 + 436 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 424 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 444 >> 2] = 0;
 HEAP32[i1 + 456 >> 2] = 0;
 HEAP32[i1 + 460 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 448 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 __ZN15DirectorManager15InitializeClassEv(i1);
 STACKTOP = i5;
 return;
}

function _UNITY_LZ4_decompress_safe(i19, i15, i1, i2) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i16 = i19 + i1 | 0;
 i17 = i15 + i2 | 0;
 i18 = i17 + -12 | 0;
 if (!i2) {
  if ((i1 | 0) == 1) i1 = (HEAP8[i19 >> 0] | 0) != 0; else i1 = 1;
  i20 = i1 << 31 >> 31;
  return i20 | 0;
 }
 i9 = i16 + -15 | 0;
 i10 = i16 + -8 | 0;
 i11 = i16 + -5 | 0;
 i12 = i17 + -5 | 0;
 i13 = i17 + -8 | 0;
 i14 = i13;
 i2 = i19;
 i3 = i15;
 L8 : while (1) {
  i1 = i2 + 1 | 0;
  i7 = HEAPU8[i2 >> 0] | 0;
  i2 = i7 >>> 4;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    i8 = i1;
    i1 = i1 + 1 | 0;
    i8 = HEAP8[i8 >> 0] | 0;
    i2 = (i8 & 255) + i2 | 0;
   } while (i8 << 24 >> 24 == -1 & i1 >>> 0 < i9 >>> 0);
   if ((i2 | 0) < 0) break;
  }
  i8 = i3 + i2 | 0;
  i4 = i1 + i2 | 0;
  if (i8 >>> 0 > i18 >>> 0 | i4 >>> 0 > i10 >>> 0) {
   i20 = 10;
   break;
  } else i2 = i3;
  while (1) {
   i5 = i1;
   i21 = i5;
   i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i2;
   i3 = i6;
   HEAP8[i3 >> 0] = i21;
   HEAP8[i3 + 1 >> 0] = i21 >> 8;
   HEAP8[i3 + 2 >> 0] = i21 >> 16;
   HEAP8[i3 + 3 >> 0] = i21 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 8 | 0;
  }
  i3 = HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 >> 0];
  i5 = i3 & 65535;
  i6 = i8 + (0 - i3) | 0;
  i1 = i4 + 2 | 0;
  if (i6 >>> 0 < i15 >>> 0) break;
  i2 = i7 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    if (i1 >>> 0 > i11 >>> 0) break L8;
    i21 = i1;
    i1 = i1 + 1 | 0;
    i21 = HEAP8[i21 >> 0] | 0;
    i2 = (i21 & 255) + i2 | 0;
   } while (i21 << 24 >> 24 == -1);
   if ((i2 | 0) < 0) break;
  }
  i7 = i8 + (i2 + 4) | 0;
  if ((i5 & 65535) < 8) {
   i21 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
   HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
   i3 = i6 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
   i6 = i8 + 4 | 0;
   i5 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i3 = i3 + (0 - i21) | 0;
  } else {
   i21 = i6;
   i4 = i21;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i21 = i21 + 4 | 0;
   i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
   i3 = i8;
   i5 = i3;
   HEAP8[i5 >> 0] = i4;
   HEAP8[i5 + 1 >> 0] = i4 >> 8;
   HEAP8[i5 + 2 >> 0] = i4 >> 16;
   HEAP8[i5 + 3 >> 0] = i4 >> 24;
   i3 = i3 + 4 | 0;
   HEAP8[i3 >> 0] = i21;
   HEAP8[i3 + 1 >> 0] = i21 >> 8;
   HEAP8[i3 + 2 >> 0] = i21 >> 16;
   HEAP8[i3 + 3 >> 0] = i21 >> 24;
   i3 = i6 + 8 | 0;
  }
  i2 = i8 + 8 | 0;
  if (i7 >>> 0 <= i18 >>> 0) while (1) {
   i8 = i3;
   i5 = i8;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i8 = i8 + 4 | 0;
   i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
   i21 = i2;
   i6 = i21;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i21 = i21 + 4 | 0;
   HEAP8[i21 >> 0] = i8;
   HEAP8[i21 + 1 >> 0] = i8 >> 8;
   HEAP8[i21 + 2 >> 0] = i8 >> 16;
   HEAP8[i21 + 3 >> 0] = i8 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
  if (i7 >>> 0 > i12 >>> 0) break;
  if (i2 >>> 0 < i13 >>> 0) {
   i4 = i2;
   i5 = i3;
   while (1) {
    i8 = i5;
    i22 = i8;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i8 = i8 + 4 | 0;
    i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
    i21 = i4;
    i6 = i21;
    HEAP8[i6 >> 0] = i22;
    HEAP8[i6 + 1 >> 0] = i22 >> 8;
    HEAP8[i6 + 2 >> 0] = i22 >> 16;
    HEAP8[i6 + 3 >> 0] = i22 >> 24;
    i21 = i21 + 4 | 0;
    HEAP8[i21 >> 0] = i8;
    HEAP8[i21 + 1 >> 0] = i8 >> 8;
    HEAP8[i21 + 2 >> 0] = i8 >> 16;
    HEAP8[i21 + 3 >> 0] = i8 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i13 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i3 = i3 + (i14 - i2) | 0;
   i2 = i13;
  }
  if (i2 >>> 0 >= i7 >>> 0) {
   i2 = i1;
   i3 = i7;
   continue;
  }
  while (1) {
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   if (i4 >>> 0 < i7 >>> 0) {
    i3 = i3 + 1 | 0;
    i2 = i4;
   } else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
 }
 if ((i20 | 0) == 10) if (!(i8 >>> 0 > i17 >>> 0 | (i4 | 0) != (i16 | 0))) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i22 = i8 - i15 | 0;
  return i22 | 0;
 }
 i22 = i19 + -1 - i1 | 0;
 return i22 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_(i4, i5, i6, i7, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i8 = 0, f9 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 i8 = f9 < Math_fround(HEAPF32[i4 >> 2]);
 i1 = Math_fround(HEAPF32[i6 >> 2]) < f9;
 do if (i8) {
  if (i1) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 1;
   break;
  };
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f9 = Math_fround(HEAPF32[i6 >> 2]);
  if (f9 < Math_fround(HEAPF32[i5 >> 2])) {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  if (f9 < Math_fround(HEAPF32[i4 >> 2])) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f9 < Math_fround(HEAPF32[i6 >> 2]))) {
  i8 = i1;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f9 < Math_fround(HEAPF32[i5 >> 2]))) {
  i8 = i1 + 1 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 if (!(f9 < Math_fround(HEAPF32[i4 >> 2]))) {
  i8 = i1 + 2 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i8 = i1 + 3 | 0;
 STACKTOP = i3;
 return i8 | 0;
}

function __ZN5physx5cloth11SwClothDataC2ERNS0_7SwClothERKNS0_8SwFabricE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f4 = f0, i5 = 0, f6 = f0, i7 = 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 i7 = i2 + 32 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i5 = i2 + 44 | 0;
 HEAPF32[i3 + 12 >> 2] = Math_fround(f4 - Math_fround(HEAPF32[i5 >> 2]));
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i3 + 24 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i5 >> 2]));
 i5 = i2 + 36 | 0;
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 i7 = i2 + 48 | 0;
 HEAPF32[i3 + 16 >> 2] = Math_fround(f4 - Math_fround(HEAPF32[i7 >> 2]));
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 HEAPF32[i3 + 28 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 i7 = i2 + 40 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i5 = i2 + 52 | 0;
 HEAPF32[i3 + 20 >> 2] = Math_fround(f4 - Math_fround(HEAPF32[i5 >> 2]));
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i3 + 32 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i2 + 256 >> 2] | 0;
 i7 = (i5 | 0) == 0 ? 0 : HEAP32[i2 + 252 >> 2] | 0;
 HEAP32[i3 + 64 >> 2] = i7;
 HEAP32[i3 + 68 >> 2] = i7 + (i5 * 20 | 0);
 HEAP32[i3 + 72 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 76 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 80 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i3 + 84 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i3 + 88 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i3 + 92 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i3 + 96 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i3 + 100 >> 2] = HEAP32[i1 + 60 >> 2];
 f4 = Math_fround(HEAPF32[i2 + 144 >> 2]);
 f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i2 + 228 >> 2])) * Math_fround(.693147182));
 HEAP32[i3 + 104 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i3 + 108 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAPF32[i3 + 112 >> 2] = Math_fround(1.0 - +Math_exp(+(+Math_fround(f4 * Math_fround(HEAPF32[i2 + 264 >> 2])))));
 f6 = Math_fround(HEAPF32[i2 + 268 >> 2]);
 HEAPF32[i3 + 116 >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i1 + 80 >> 2]));
 HEAP32[i3 + 120 >> 2] = (HEAP32[i2 + 276 >> 2] | 0) == 0 ? 0 : HEAP32[i2 + 272 >> 2] | 0;
 HEAP32[i3 + 124 >> 2] = (HEAP32[i2 + 288 >> 2] | 0) == 0 ? 0 : HEAP32[i2 + 284 >> 2] | 0;
 HEAPF32[i3 + 128 >> 2] = Math_fround(1.0 - +Math_exp(+(+Math_fround(f4 * Math_fround(HEAPF32[i2 + 304 >> 2])))));
 HEAP32[i3 + 132 >> 2] = (HEAP32[i2 + 312 >> 2] | 0) == 0 ? 0 : HEAP32[i2 + 308 >> 2] | 0;
 HEAP32[i3 + 136 >> 2] = (HEAP32[i2 + 324 >> 2] | 0) == 0 ? 0 : HEAP32[i2 + 320 >> 2] | 0;
 HEAP32[i3 + 140 >> 2] = (HEAP32[i2 + 336 >> 2] | 0) == 0 ? 0 : HEAP32[i2 + 332 >> 2] | 0;
 i1 = HEAP32[i2 + 360 >> 2] | 0;
 i5 = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 356 >> 2] | 0;
 HEAP32[i3 + 144 >> 2] = i5;
 HEAP32[i3 + 148 >> 2] = (HEAP32[i2 + 372 >> 2] | 0) == 0 ? i5 : HEAP32[i2 + 368 >> 2] | 0;
 HEAP32[i3 + 152 >> 2] = i1;
 i1 = HEAP32[i2 + 348 >> 2] | 0;
 HEAP32[i3 + 156 >> 2] = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 344 >> 2] | 0;
 HEAP32[i3 + 160 >> 2] = i1;
 i1 = HEAP32[i2 + 396 >> 2] | 0;
 i5 = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 392 >> 2] | 0;
 HEAP32[i3 + 164 >> 2] = i5;
 HEAP32[i3 + 168 >> 2] = (HEAP32[i2 + 408 >> 2] | 0) == 0 ? i5 : HEAP32[i2 + 404 >> 2] | 0;
 HEAP32[i3 + 172 >> 2] = i1;
 i1 = HEAP32[i2 + 384 >> 2] | 0;
 HEAP32[i3 + 176 >> 2] = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 380 >> 2] | 0;
 HEAP32[i3 + 180 >> 2] = i1;
 i1 = HEAP32[i2 + 420 >> 2] | 0;
 i5 = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 416 >> 2] | 0;
 HEAP32[i3 + 184 >> 2] = i5;
 HEAP32[i3 + 188 >> 2] = (HEAP32[i2 + 432 >> 2] | 0) == 0 ? i5 : HEAP32[i2 + 428 >> 2] | 0;
 HEAP32[i3 + 192 >> 2] = (i1 >>> 0) / 3 | 0;
 i1 = HEAP32[i2 + 456 >> 2] | 0;
 i5 = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 452 >> 2] | 0;
 HEAP32[i3 + 196 >> 2] = i5;
 HEAP32[i3 + 200 >> 2] = i5 + (i1 << 2 << 1);
 i1 = HEAP32[i2 + 468 >> 2] | 0;
 HEAP32[i3 + 204 >> 2] = (i1 | 0) == 0 ? 0 : HEAP32[i2 + 464 >> 2] | 0;
 HEAP32[i3 + 208 >> 2] = i1;
 HEAP8[i3 + 212 >> 0] = HEAP8[i2 + 440 >> 0] | 0;
 HEAP32[i3 + 220 >> 2] = HEAP32[i2 + 444 >> 2];
 HEAP32[i3 + 216 >> 2] = HEAP32[i2 + 448 >> 2];
 HEAP32[i3 + 224 >> 2] = HEAP32[i2 + 480 >> 2];
 HEAPF32[i3 + 228 >> 2] = Math_fround(1.0 - +Math_exp(+(+Math_fround(f4 * Math_fround(HEAPF32[i2 + 484 >> 2])))));
 i1 = i2 + 492 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i3 + 236 >> 2] = 0; else {
  i7 = HEAP32[i2 + 488 >> 2] | 0;
  HEAP32[i3 + 236 >> 2] = i7;
  if (i7 | 0) {
   i5 = i1;
   i5 = HEAP32[i5 >> 2] | 0;
   i7 = i3 + 232 | 0;
   HEAP32[i7 >> 2] = i5;
   i7 = i2 + 504 | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i7 = (i7 | 0) == 0;
   i5 = i2 + 500 | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i5 = i7 ? 0 : i5;
   i7 = i3 + 240 | 0;
   HEAP32[i7 >> 2] = i5;
   i7 = i2 + 524 | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i5 = i3 + 244 | 0;
   HEAP32[i5 >> 2] = i7;
   i5 = i2 + 528 | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i7 = i3 + 248 | 0;
   HEAP32[i7 >> 2] = i5;
   return;
  }
 }
 i5 = i3;
 i5 = HEAP32[i5 >> 2] | 0;
 i7 = i3 + 232 | 0;
 HEAP32[i7 >> 2] = i5;
 i7 = i2 + 504 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i7 = (i7 | 0) == 0;
 i5 = i2 + 500 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = i7 ? 0 : i5;
 i7 = i3 + 240 | 0;
 HEAP32[i7 >> 2] = i5;
 i7 = i2 + 524 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i5 = i3 + 244 | 0;
 HEAP32[i5 >> 2] = i7;
 i5 = i2 + 528 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i7 = i3 + 248 | 0;
 HEAP32[i7 >> 2] = i5;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN15PointEffector2D8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i5, i9);
 i4 = i5 + 92 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802350 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802367 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802384 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags(i9, i5 + 112 | 0, gb + 802400 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags(i9, i5 + 116 | 0, gb + 802414 | 0, 0);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorForceMode2DEvRT_RT0_PKc17TransferMetaFlags(i9, i5 + 120 | 0, gb + 802428 | 0, 0);
 i4 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802440 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802447 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 50; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN4crnd12crn_unpackerD2Ev(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 128 | 0;
 i10 = i14 + 112 | 0;
 i13 = i14 + 96 | 0;
 i9 = i14 + 80 | 0;
 i7 = i14 + 64 | 0;
 i6 = i14 + 48 | 0;
 i5 = i14 + 32 | 0;
 i4 = i14 + 16 | 0;
 i3 = i14;
 i12 = i14 + 144 | 0;
 HEAP32[i11 >> 2] = 0;
 i1 = i11 + 284 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i3 >> 2] = gb + 401209;
   HEAP32[i3 + 4 >> 2] = 2513;
   HEAP32[i3 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i3) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 288 >> 2] = 0;
  HEAP32[i11 + 292 >> 2] = 0;
 }
 HEAP8[i11 + 296 >> 0] = 0;
 i1 = i11 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i4 >> 2] = gb + 401209;
   HEAP32[i4 + 4 >> 2] = 2513;
   HEAP32[i4 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i4) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 272 >> 2] = 0;
  HEAP32[i11 + 276 >> 2] = 0;
 }
 HEAP8[i11 + 280 >> 0] = 0;
 i1 = i11 + 252 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i5 >> 2] = gb + 401209;
   HEAP32[i5 + 4 >> 2] = 2513;
   HEAP32[i5 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i5) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 256 >> 2] = 0;
  HEAP32[i11 + 260 >> 2] = 0;
 }
 HEAP8[i11 + 264 >> 0] = 0;
 i1 = i11 + 236 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i6 >> 2] = gb + 401209;
   HEAP32[i6 + 4 >> 2] = 2513;
   HEAP32[i6 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i6) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 240 >> 2] = 0;
  HEAP32[i11 + 244 >> 2] = 0;
 }
 HEAP8[i11 + 248 >> 0] = 0;
 i1 = HEAP32[i11 + 232 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i11 + 216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i7 >> 2] = gb + 401209;
   HEAP32[i7 + 4 >> 2] = 2513;
   HEAP32[i7 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i7) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 220 >> 2] = 0;
  HEAP32[i11 + 224 >> 2] = 0;
 }
 HEAP8[i11 + 228 >> 0] = 0;
 i1 = HEAP32[i11 + 208 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i11 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i8 >> 2] = gb + 401209;
   HEAP32[i8 + 4 >> 2] = 2513;
   HEAP32[i8 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i8) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 196 >> 2] = 0;
  HEAP32[i11 + 200 >> 2] = 0;
 }
 HEAP8[i11 + 204 >> 0] = 0;
 i1 = HEAP32[i11 + 184 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i11 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i9 >> 2] = gb + 401209;
   HEAP32[i9 + 4 >> 2] = 2513;
   HEAP32[i9 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i9) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 172 >> 2] = 0;
  HEAP32[i11 + 176 >> 2] = 0;
 }
 HEAP8[i11 + 180 >> 0] = 0;
 i1 = HEAP32[i11 + 160 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i11 + 144 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i10 >> 2] = gb + 401209;
   HEAP32[i10 + 4 >> 2] = 2513;
   HEAP32[i10 + 8 >> 2] = gb + 401349;
   _sprintf(i12, gb + 401176 | 0, i10) | 0;
   _puts(i12) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 + 148 >> 2] = 0;
  HEAP32[i11 + 152 >> 2] = 0;
 }
 HEAP8[i11 + 156 >> 0] = 0;
 i1 = HEAP32[i11 + 136 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i11 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i13 = i11 + 132 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
  HEAP32[i13 >> 2] = gb + 401209;
  HEAP32[i13 + 4 >> 2] = 2513;
  HEAP32[i13 + 8 >> 2] = gb + 401349;
  _sprintf(i12, gb + 401176 | 0, i13) | 0;
  _puts(i12) | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i11 + 124 >> 2] = 0;
 HEAP32[i11 + 128 >> 2] = 0;
 i13 = i11 + 132 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead8TransferI18WheelFrictionCurveEEvRT_PKc17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i3 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, i2, gb + 827321 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i5 = HEAP32[gb + 37012 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827340 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i4 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i8 = 8; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 4 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827355 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 8 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827371 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 30; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 12 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827387 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 41; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 16 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 827404 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i7 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i7 >>> 0) i8 = 52; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 52; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 52) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i9;
 return;
}

function __Z21Resources_CUSTOM_LoadP12Il2CppStringP12Il2CppObject(i1, i18) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 24 | 0;
 i20 = i22 + 12 | 0;
 i16 = i22 + 8 | 0;
 i4 = i22;
 __ZN11ICallStringC2EP12Il2CppString(i16, i1);
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i18);
 i17 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i18) | 0;
 i3 = __Z18GetResourceManagerv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i20, i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i19, i20);
 i16 = HEAP8[i19 + 11 >> 0] | 0;
 i2 = i16 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i19 >> 2] | 0 : i19;
 i16 = i2 ? HEAP32[i19 + 4 >> 2] | 0 : i16 & 255;
 i2 = i1 + i16 | 0;
 if (i16 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN15ResourceManager12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i3, i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 i7 = i4 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i8 = i19 + 4 | 0;
 i9 = i19 + 8 | 0;
 i10 = i19 + 12 | 0;
 i11 = i19 + 13 | 0;
 i12 = i19 + 14 | 0;
 i13 = i19 + 16 | 0;
 i14 = i19 + 20 | 0;
 i15 = i19 + 21 | 0;
 i16 = i19 + 22 | 0;
 i6 = i1;
 i5 = i2;
 L11 : while (1) {
  i4 = i5 + 32 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i20 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i21 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i19, i1, i20);
     i2 = HEAP32[i19 >> 2] | 0;
     i23 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 13; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i21 = 15;
   }
   if ((i21 | 0) == 13) i21 = 15;
   if ((i21 | 0) == 15) {
    i21 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) break;
   }
   i1 = __Z18GetResourceManagerv() | 0;
   __ZN15ResourceManager19PreloadDependenciesEi(i1, HEAP32[i4 >> 2] | 0);
   i1 = HEAP32[i4 >> 2] | 0;
   do if (!i1) i2 = 0; else {
    HEAP32[i20 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i21 = 22; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i19, i1, i20);
      i2 = HEAP32[i19 >> 2] | 0;
      i23 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i23 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i23 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 22; else {
      i2 = HEAP32[i1 + 4 >> 2] | 0;
      if (i2 | 0) break;
     }
    }
    if ((i21 | 0) == 22) i21 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   } while (0);
   i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
   if (i1 | 0) {
    if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i17) | 0) {
     i21 = 35;
     break L11;
    }
    if (i2 | 0) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) {
     HEAP32[i19 >> 2] = i2;
     HEAP32[i8 >> 2] = i18;
     HEAP32[i9 >> 2] = 0;
     HEAP8[i10 >> 0] = 0;
     HEAP8[i11 >> 0] = 1;
     HEAP8[i12 >> 0] = 1;
     HEAP32[i13 >> 2] = 0;
     HEAP8[i14 >> 0] = 1;
     HEAP8[i15 >> 0] = 0;
     HEAP8[i16 >> 0] = 0;
     i1 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i19) | 0;
     if (i1 | 0) {
      i21 = 35;
      break L11;
     }
    }
   }
  } while (0);
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i1) {
   i1 = i6;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
   i1 = 0;
   i21 = 35;
   break;
  } else {
   i6 = i1;
   i5 = i1;
  }
 }
 if ((i21 | 0) == 35) {
  STACKTOP = i22;
  return i1 | 0;
 }
 return 0;
}

function __ZN24UserAuthorizationManager22GetAuthorizationDialogEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = i10 + 12 | 0;
 i7 = i10 + 8 | 0;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) == 0;
 i8 = i1 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 9;
   }
  }
  if ((i9 | 0) == 7) i9 = 9;
  if ((i9 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  i1 = (i1 | 0) != 0;
 }
 if (i4) {
  if (!i1) {
   i11 = 0;
   STACKTOP = i10;
   return i11 | 0;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 38; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 38; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 40;
    }
   }
   if ((i9 | 0) == 38) i9 = 40;
   if ((i9 | 0) == 40) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  }
  __Z22DestroyObjectHighLevelP6Objectb(i1, 1);
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
  HEAP32[i5 >> 2] = gb + 489306;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[(__Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i6, gb + 1044255 | 0, i5) | 0) + 4 >> 2];
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 20;
   }
  }
  if ((i9 | 0) == 18) i9 = 20;
  if ((i9 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 1);
 }
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 27; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 27; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 29;
  }
 }
 if ((i9 | 0) == 27) i9 = 29;
 if ((i9 | 0) == 29) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 27592 | 0) | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5physx18PxsDynamicsContext20solveParallelCoulombEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEES12_PPNS_12PxsRigidBodyEj(i2, i18, i22, i5, i4, i19, i30, i26, i3, i8, i9, i11, i12, i16, i25, i17, i14, i15, i33, i20, i21, i13, i32, i31, i27, i1, i28, i36, i23, i24, i7, i10, i34, i6) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i19 = i19 | 0;
 i30 = i30 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i25 = i25 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i33 = i33 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i13 = i13 | 0;
 i32 = i32 | 0;
 i31 = i31 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i36 = i36 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i34 = i34 | 0;
 i6 = i6 | 0;
 var i29 = 0, i35 = 0, i37 = 0, i38 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i37 = i35 + 4 | 0;
 i1 = i35;
 HEAP32[i37 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i38 = HEAP32[i2 + 136 >> 2] | 0;
 i29 = i2 + 124 | 0;
 mftCall_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii(HEAP32[(HEAP32[i38 >> 2] | 0) + 24 >> 2] | 0, i38 | 0, +Math_fround(HEAPF32[i29 >> 2]), i18 | 0, i22 | 0, i5 | 0, i4 | 0, i19 | 0, i30 | 0, i26 | 0, i3 | 0, i8 | 0, i9 | 0, i11 | 0, i12 | 0, i16 | 0, i25 | 0, i17 | 0, i14 | 0, i15 | 0, i20 | 0, i21 | 0, i13 | 0, i23 | 0, i24 | 0, i7 | 0, i10 | 0, i32 | 0, i37 | 0, i1 | 0, i6 | 0);
 i2 = (__ZN5physx6shdfnd9atomicAddEPVii(i33, 32) | 0) + -32 | 0;
 i3 = Math_imul(HEAP32[i37 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0) | 0;
 i3 = (Math_imul(HEAP32[i1 >> 2] | 0, HEAP32[i24 + 4 >> 2] | 0) | 0) + i3 | 0;
 if ((HEAP32[i25 >> 2] | 0) < (i3 | 0)) if ((HEAP32[i25 >> 2] | 0) < (i3 | 0)) if ((HEAP32[i25 >> 2] | 0) < (i3 | 0)) {
  i1 = 3e4;
  do {
   i1 = i1 + -1 | 0;
   if (!i1) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i1 = 1e4;
   }
  } while ((HEAP32[i25 >> 2] | 0) < (i3 | 0));
 }
 if ((i2 | 0) < (i28 | 0)) {
  i18 = i27 + 4 | 0;
  i19 = i27 + 8 | 0;
  i20 = ~i28;
  i17 = 32;
  i1 = 0;
  while (1) {
   i16 = i28 - i2 | 0;
   i16 = (i16 | 0) < 32 ? i16 : 32;
   i3 = i17 - i16 | 0;
   if ((i16 | 0) > 0) {
    i15 = i2 + i20 | 0;
    i15 = (i15 | 0) > -33 ? i15 : -33;
    i14 = i1 + -1 | 0;
    i11 = ~i15;
    i12 = 0;
    i13 = i2;
    while (1) {
     i1 = HEAP32[gb + 1457376 >> 2] | 0;
     if (i1 | 0) mftCall_vif(i1 | 0, i26 + (i13 * 40 | 0) | 0, +Math_fround(HEAPF32[i29 >> 2]));
     i9 = i26 + (i13 * 40 | 0) + 36 | 0;
     i1 = HEAP16[i9 >> 1] | 0;
     if (i1 << 16 >> 16) {
      i10 = i26 + (i13 * 40 | 0) + 4 | 0;
      i8 = 0;
      do {
       i7 = (HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 5) + 16 >> 2] | 0) + 68 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       if ((i7 | 0) != 1073741823) {
        i5 = (i7 + 32 | 0) >>> 5;
        if (i5 >>> 0 > (HEAP32[i18 >> 2] & 2147483647) >>> 0) {
         i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, i5 << 2, gb + 769739 | 0, 329) | 0;
         i1 = HEAP32[i27 >> 2] | 0;
         if (i1 | 0) {
          _memcpy(i4 | 0, i1 | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
          if ((HEAP32[i18 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, HEAP32[i27 >> 2] | 0);
         }
         i1 = HEAP32[i18 >> 2] | 0;
         _memset(i4 + ((i1 & 2147483647) << 2) | 0, 0, i5 - i1 << 2 | 0) | 0;
         HEAP32[i27 >> 2] = i4;
         HEAP32[i18 >> 2] = i5;
         i1 = HEAP16[i9 >> 1] | 0;
        } else i4 = HEAP32[i27 >> 2] | 0;
        i38 = _bitshift64Lshr(i6 | 0, i7 | 0, 37) | 0;
        getTempRet0() | 0;
        i38 = i4 + (i38 << 2) | 0;
        HEAP32[i38 >> 2] = HEAP32[i38 >> 2] | 1 << (i7 & 31);
       }
       i8 = i8 + 1 | 0;
      } while (i8 >>> 0 < (i1 & 65535) >>> 0);
     }
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i11 | 0)) break; else i13 = i13 + 1 | 0;
    }
    i2 = i2 + -1 - i15 | 0;
    i1 = i14 - i15 | 0;
   }
   if ((i17 | 0) == (i16 | 0)) {
    i3 = 32;
    i2 = (__ZN5physx6shdfnd9atomicAddEPVii(i33, 32) | 0) + -32 | 0;
   }
   if ((i2 | 0) < (i28 | 0)) i17 = i3; else break;
  }
 } else {
  i3 = 32;
  i1 = 0;
 }
 i2 = i2 - i28 | 0;
 if ((i2 | 0) >= (i30 | 0)) {
  i38 = i1;
  __ZN5physx6shdfnd9atomicAddEPVii(i36, i38) | 0;
  STACKTOP = i35;
  return;
 }
 i6 = -32 - i28 | 0;
 i7 = ~i30;
 while (1) {
  i38 = i30 - i2 | 0;
  if ((((i38 | 0) < (i3 | 0) ? i38 : i3) | 0) > 0) {
   i4 = i2 + i7 | 0;
   i5 = ~i3;
   i5 = (i4 | 0) > (i5 | 0) ? i4 : i5;
   i3 = ~i5;
   i4 = 0;
   while (1) {
    __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf(HEAP32[i31 + (i2 << 2) >> 2] | 0, HEAP32[i34 + (i2 << 2) >> 2] | 0, i32 + (i2 << 5) | 0, Math_fround(HEAPF32[i29 >> 2]));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
   }
   i1 = i1 + -1 - i5 | 0;
  }
  i2 = i6 + (__ZN5physx6shdfnd9atomicAddEPVii(i33, 32) | 0) | 0;
  if ((i2 | 0) >= (i30 | 0)) break; else i3 = 32;
 }
 __ZN5physx6shdfnd9atomicAddEPVii(i36, i1) | 0;
 STACKTOP = i35;
 return;
}

function __ZN8Animator20CreatePlayableMemoryEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i2 = i9 + 8 | 0;
 i6 = i9 + 16 | 0;
 i4 = i8 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i7 = 24; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i2);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i7 = 24;
    break;
   }
  }
  i3 = i8 + 624 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i2 = i8 + 112 | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 160, 8) | 0;
   __ZN26AnimatorControllerPlayableC2E18DirectorPlayerType(i2, 0);
   HEAP32[i3 >> 2] = i2;
  }
  __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(i2, i1);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = i8 + 628 | 0;
  i11 = gb + 37528 | 0;
  i4 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = i2;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = i4;
  if (i1 | 0) {
   __ZN8Playable6HandleEv(i5, i1);
   i4 = i5;
   i10 = HEAP32[i4 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
  }
  if (__ZNK9HPlayable7IsValidEv(i2) | 0) {
   i11 = HEAP32[(HEAP32[i8 + 628 >> 2] | 0) + 20 >> 2] | 0;
   HEAP8[i8 + 426 >> 0] = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0, i8 | 0) | 0) & 1;
  }
  if (HEAP8[i8 + 33 >> 0] | 0) {
   i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + 164 >> 2] | 0;
   __ZN8Playable6HandleEv(i6, HEAP32[i3 >> 2] | 0);
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   mftCall_viii(i11 | 0, i8 | 0, i5 | 0, 0);
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (HEAP32[i1 + 28 >> 2] | 0) {
    i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 4 >> 2] | 0;
    if (i1 | 0) {
     i5 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0;
     if (i5 | 0) {
      i4 = HEAP32[(HEAP32[i8 + 168 >> 2] | 0) + 32 >> 2] | 0;
      i2 = HEAP32[i1 + 100 >> 2] | 0;
      i3 = HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 24 >> 2] | 0;
      i4 = HEAP32[i4 + 12 >> 2] | 0;
      i1 = 0;
      do {
       HEAP8[i2 + (i1 * 12 | 0) >> 0] = HEAP8[i4 + i1 >> 0] | 0;
       HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i5 | 0));
     }
    }
   }
  }
 } while (0);
 if ((i7 | 0) == 24) if (__ZNK9HPlayable7IsValidEv(i8 + 628 | 0) | 0) {
  i11 = HEAP32[(HEAP32[i8 + 628 >> 2] | 0) + 20 >> 2] | 0;
  HEAP8[i8 + 426 >> 0] = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0, i8 | 0) | 0) & 1;
 }
 i1 = HEAP32[i8 + 168 >> 2] | 0;
 if (!i1) {
  i11 = i8 + 40 | 0;
  HEAP8[i8 + 76 >> 0] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i11 + 16 >> 2] = 0;
  HEAP32[i11 + 20 >> 2] = 0;
 } else {
  i11 = HEAP32[i1 + 32 >> 2] | 0;
  HEAP32[i8 + 40 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 + 44 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i8 + 48 >> 2] = HEAP32[i8 + 124 >> 2];
  HEAP32[i8 + 52 >> 2] = HEAP32[i11 + 8 >> 2];
  i11 = HEAP32[(HEAP32[i8 + 172 >> 2] | 0) + 36 >> 2] | 0;
  HEAP32[i8 + 56 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i8 + 60 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i8 + 64 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i8 + 68 >> 2] = HEAP32[i11 + 32 >> 2];
  HEAP8[i8 + 72 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
  if (__ZNK8Animator7IsHumanEv(i8) | 0) i1 = 0; else i1 = (HEAP32[(HEAP32[i8 + 132 >> 2] | 0) + 16 >> 2] | 0) != 0 & 1;
  HEAP8[i8 + 73 >> 0] = i1;
  HEAP8[i8 + 74 >> 0] = (__ZNK8Animator7IsHumanEv(i8) | 0) & 1;
  HEAP8[i8 + 75 >> 0] = HEAP8[(HEAP32[i8 + 128 >> 2] | 0) + 17 >> 0] | 0;
 }
 i1 = i8 + 628 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) {
  i10 = i8 + 628 | 0;
  i11 = i8 + 40 | 0;
  __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i11);
  i10 = HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i10 | 0, i11 | 0, 0);
 }
 if (!(__ZNK9HPlayable7IsValidEv(i1) | 0)) {
  STACKTOP = i9;
  return;
 }
 if (HEAP32[i8 + 596 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[(HEAP32[i8 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 92 >> 2] | 0, i11 | 0, i8 + 584 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx10PxsContext20createContactManagerERKNS_24PxvManagerDescRigidRigidEPNS_18PxsMaterialManagerE(i8, i3, i4) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i2 = i8 + 716 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) if (__ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE6extendEv(i8 + 696 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 } while (0);
 i9 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i9;
 i9 = HEAP32[(HEAP32[i8 + 712 >> 2] | 0) + (i9 << 2) >> 2] | 0;
 i10 = i9 + 76 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i7 = (HEAP32[i8 + 728 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i6 & 31);
 if (!i9) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN5physx17PxsContactManager4initERKNS_24PxvManagerDescRigidRigidEPKNS_18PxsMaterialManagerE(i9, i3, i4);
 do if (HEAP8[i8 + 7604 >> 0] | 0) {
  i1 = HEAP8[i9 + 112 >> 0] | 0;
  i2 = HEAP8[i9 + 113 >> 0] | 0;
  if (!(HEAP8[(i2 & 255) + (gb + 702560 + ((i1 & 255) * 7 | 0)) >> 0] | 0)) {
   HEAP32[i9 + 60 >> 2] = 0;
   break;
  }
  if (!((i1 & 255) < 5 & (i2 & 255) < 5)) {
   HEAP32[i9 + 60 >> 2] = 1;
   break;
  }
  if (i1 << 24 >> 24 == 0 | i2 << 24 >> 24 == 0) {
   i2 = i8 + 1328 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i8 + 1036 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i7 = i8 + 1316 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = i8 + 1320 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i7 = i1 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP8[i1 + 32 >> 0] = 0;
   HEAP8[i1 + 33 >> 0] = 0;
   HEAP32[i1 + 44 >> 2] = i1 + 48;
   HEAP32[i7 >> 2] = 2139095039;
   HEAP32[i1 + 20 >> 2] = 2139095039;
   HEAP32[i1 + 24 >> 2] = 2139095039;
   HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 1065353216;
   HEAP32[i9 + 60 >> 2] = i1;
   break;
  } else {
   i2 = i8 + 1032 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i8 + 740 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i7 = i8 + 1020 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = i8 + 1024 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i7 = i1 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP8[i1 + 32 >> 0] = 0;
   HEAP8[i1 + 33 >> 0] = 0;
   HEAP32[i1 + 44 >> 2] = i1 + 48;
   HEAP32[i7 >> 2] = 2139095039;
   HEAP32[i1 + 20 >> 2] = 2139095039;
   HEAP32[i1 + 24 >> 2] = 2139095039;
   HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 1065353216;
   HEAP32[i9 + 60 >> 2] = i1;
   break;
  }
 } while (0);
 i7 = i8 + 5840 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2 + 256 & -256;
 i4 = i1 >>> 5;
 i5 = i8 + 5844 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i3 = i8 + 5848 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 >>> 3, gb + 769739 | 0, 329) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (i2 | 0) {
   _memcpy(i1 | 0, i2 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i7 >> 2] | 0);
  }
  i2 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i2 & 2147483647) << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i8 + 1332 | 0;
 i1 = i2 + 256 & -256;
 i4 = i1 >>> 5;
 i5 = i8 + 1336 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i3 = i8 + 1340 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 >>> 3, gb + 769739 | 0, 329) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) {
   _memcpy(i1 | 0, i2 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i6 >> 2] | 0);
  }
  i2 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i2 & 2147483647) << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
  i2 = HEAP32[i10 >> 2] | 0;
 } else i1 = HEAP32[i6 >> 2] | 0;
 i8 = i1 + (i2 >>> 5 << 2) | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i2 & 31);
 if (!(HEAP32[i9 + 8 >> 2] & 1)) {
  i10 = i9;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = HEAP32[i10 >> 2] | 0;
 i10 = (HEAP32[i7 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << (i8 & 31);
 i10 = i9;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i8 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i9 = i15 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i15 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i6 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i5 = (Math_imul(i3, i10) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i5;
     HEAP32[i2 + 12 >> 2] = i5;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i5 = i13;
     i7 = HEAP32[i5 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = HEAP32[i11 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i6 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 88, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAP32[i2 + 16 >> 2] = 0;
      HEAP32[i2 + 20 >> 2] = -1;
      HEAP32[i2 + 24 >> 2] = -1;
      HEAP32[i2 + 28 >> 2] = 1;
      i3 = i2 + 32 | 0;
      i4 = i3;
      i5 = i4 + 52 | 0;
      do {
       HEAP32[i4 >> 2] = 0;
       i4 = i4 + 4 | 0;
      } while ((i4 | 0) < (i5 | 0));
      HEAP16[i3 + 52 >> 1] = 0;
      HEAP8[i3 + 54 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 913925 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine18StateMachineMemory8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i6 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i8, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i6 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 88, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP32[i2 + 12 >> 2] = 0;
       HEAP32[i2 + 16 >> 2] = 0;
       HEAP32[i2 + 20 >> 2] = -1;
       HEAP32[i2 + 24 >> 2] = -1;
       HEAP32[i2 + 28 >> 2] = 1;
       i3 = i2 + 32 | 0;
       i4 = i3;
       i5 = i4 + 52 | 0;
       do {
        HEAP32[i4 >> 2] = 0;
        i4 = i4 + 4 | 0;
       } while ((i4 | 0) < (i5 | 0));
       HEAP16[i3 + 52 >> 1] = 0;
       HEAP8[i3 + 54 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 913925 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine18StateMachineMemory8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i8 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN9Animation8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = i10 + 4 | 0;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i8, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 3);
 i2 = i8 + 280 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896236 | 0, gb + 905722 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i8 + 284 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896248 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896261 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i9, 2) | 0) {
  HEAP8[i6 >> 0] = 0;
  i4 = HEAP32[gb + 36972 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896272 | 0, i4, i7, 0) | 0;
  if (!i1) i1 = 0; else {
   do if ((i1 | 0) > 0) {
    i1 = i9 + 16 | 0;
    i5 = HEAP32[i9 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 >= i5 >>> 0) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
      HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i1 >> 2] = i3;
      break;
     }
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 1);
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i9);
   i1 = HEAP8[i6 >> 0] | 0;
  }
  HEAP32[i8 + 44 >> 2] = i1 & 255;
 } else i4 = HEAP32[gb + 36972 >> 2] | 0;
 i3 = i8 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896295 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 41 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896315 | 0, i4, i7, 0) | 0;
 if (!i1) {
  i8 = i8 + 44 | 0;
  __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9Animation11CullingTypeEEvRT_RT0_PKc17TransferMetaFlags(i9, i8, gb + 896332 | 0, 0);
  i9 = HEAP32[i8 >> 2] | 0;
  i7 = i9 | 1;
  i7 = (i7 | 0) == 3;
  i9 = i7 ? 1 : i9;
  HEAP32[i8 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 i8 = i8 + 44 | 0;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9Animation11CullingTypeEEvRT_RT0_PKc17TransferMetaFlags(i9, i8, gb + 896332 | 0, 0);
 i9 = HEAP32[i8 >> 2] | 0;
 i7 = i9 | 1;
 i7 = (i7 | 0) == 3;
 i9 = i7 ? 1 : i9;
 HEAP32[i8 >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 6;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 6;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 6;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 6;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (Math_imul((Math_imul((Math_imul((Math_imul(i2 >>> 24 ^ -2128831035, 16777619) | 0) ^ i2 >>> 16 & 255, 16777619) | 0) ^ i2 >>> 8 & 255, 16777619) | 0) ^ i2 & 255, 16777619) | 0) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function runPostSets230() {
 HEAP32[gb + 209720 >> 2] = fb + 103;
 HEAP32[gb + 209724 >> 2] = fb + 104;
 HEAP32[gb + 209728 >> 2] = fb + 105;
 HEAP32[gb + 209732 >> 2] = fb + 106;
 HEAP32[gb + 209736 >> 2] = fb + 107;
 HEAP32[gb + 209740 >> 2] = fb + 108;
 HEAP32[gb + 209744 >> 2] = fb + 109;
 HEAP32[gb + 209748 >> 2] = fb + 110;
 HEAP32[gb + 209752 >> 2] = fb + 111;
 HEAP32[gb + 209756 >> 2] = fb + 112;
 HEAP32[gb + 209760 >> 2] = fb + 113;
 HEAP32[gb + 11112 >> 2] = (HEAP32[gb + 11112 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11116 >> 2] = (HEAP32[gb + 11116 >> 2] | 0) + (gb + 1078142 | 0);
 HEAP32[gb + 11128 >> 2] = (HEAP32[gb + 11128 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11136 >> 2] = (HEAP32[gb + 11136 >> 2] | 0) + (gb + 11144 | 0);
 HEAP32[gb + 11144 >> 2] = (HEAP32[gb + 11144 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11148 >> 2] = (HEAP32[gb + 11148 >> 2] | 0) + (gb + 1078210 | 0);
 HEAP32[gb + 11160 >> 2] = (HEAP32[gb + 11160 >> 2] | 0) + (gb + 11104 | 0);
 HEAP32[gb + 209768 >> 2] = (HEAP32[gb + 209768 >> 2] | 0) + (gb + 11168 | 0);
 HEAP32[gb + 209772 >> 2] = fb + 3075;
 HEAP32[gb + 209776 >> 2] = fb + 3076;
 HEAP32[gb + 209780 >> 2] = fb + 3068;
 HEAP32[gb + 209784 >> 2] = fb + 86;
 HEAP32[gb + 209788 >> 2] = fb + 87;
 HEAP32[gb + 209792 >> 2] = fb + 114;
 HEAP32[gb + 209796 >> 2] = fb + 88;
 HEAP32[gb + 209800 >> 2] = fb + 115;
 HEAP32[gb + 209804 >> 2] = fb + 1;
 HEAP32[gb + 209808 >> 2] = fb + 2;
 HEAP32[gb + 209812 >> 2] = fb + 89;
 HEAP32[gb + 11168 >> 2] = (HEAP32[gb + 11168 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11172 >> 2] = (HEAP32[gb + 11172 >> 2] | 0) + (gb + 1078244 | 0);
 HEAP32[gb + 11184 >> 2] = (HEAP32[gb + 11184 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11192 >> 2] = (HEAP32[gb + 11192 >> 2] | 0) + (gb + 11200 | 0);
 HEAP32[gb + 11200 >> 2] = (HEAP32[gb + 11200 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11204 >> 2] = (HEAP32[gb + 11204 >> 2] | 0) + (gb + 1078312 | 0);
 HEAP32[gb + 11216 >> 2] = (HEAP32[gb + 11216 >> 2] | 0) + (gb + 11224 | 0);
 HEAP32[gb + 11224 >> 2] = (HEAP32[gb + 11224 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11228 >> 2] = (HEAP32[gb + 11228 >> 2] | 0) + (gb + 1078334 | 0);
 HEAP32[gb + 209820 >> 2] = (HEAP32[gb + 209820 >> 2] | 0) + (gb + 11232 | 0);
 HEAP32[gb + 209824 >> 2] = fb + 3077;
 HEAP32[gb + 209828 >> 2] = fb + 3078;
 HEAP32[gb + 209832 >> 2] = fb + 3068;
 HEAP32[gb + 209836 >> 2] = fb + 90;
 HEAP32[gb + 209840 >> 2] = fb + 91;
 HEAP32[gb + 209844 >> 2] = fb + 116;
 HEAP32[gb + 209848 >> 2] = fb + 92;
 HEAP32[gb + 209852 >> 2] = fb + 117;
 HEAP32[gb + 209856 >> 2] = fb + 3;
 HEAP32[gb + 209860 >> 2] = fb + 4;
 HEAP32[gb + 209864 >> 2] = fb + 93;
 HEAP32[gb + 11232 >> 2] = (HEAP32[gb + 11232 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11236 >> 2] = (HEAP32[gb + 11236 >> 2] | 0) + (gb + 1078359 | 0);
 HEAP32[gb + 11248 >> 2] = (HEAP32[gb + 11248 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11256 >> 2] = (HEAP32[gb + 11256 >> 2] | 0) + (gb + 11264 | 0);
 HEAP32[gb + 11264 >> 2] = (HEAP32[gb + 11264 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11268 >> 2] = (HEAP32[gb + 11268 >> 2] | 0) + (gb + 1078427 | 0);
 HEAP32[gb + 11280 >> 2] = (HEAP32[gb + 11280 >> 2] | 0) + (gb + 11224 | 0);
 HEAP32[gb + 209872 >> 2] = (HEAP32[gb + 209872 >> 2] | 0) + (gb + 11288 | 0);
 HEAP32[gb + 209876 >> 2] = fb + 3079;
 HEAP32[gb + 209880 >> 2] = fb + 3080;
 HEAP32[gb + 209884 >> 2] = fb + 3068;
 HEAP32[gb + 209888 >> 2] = fb + 1421;
 HEAP32[gb + 209892 >> 2] = fb + 118;
 HEAP32[gb + 209896 >> 2] = fb + 119;
 HEAP32[gb + 209900 >> 2] = fb + 120;
 HEAP32[gb + 209904 >> 2] = fb + 121;
 HEAP32[gb + 209908 >> 2] = fb + 122;
 HEAP32[gb + 209912 >> 2] = fb + 20;
 HEAP32[gb + 209920 >> 2] = (HEAP32[gb + 209920 >> 2] | 0) + (gb + 11288 | 0);
 HEAP32[gb + 209924 >> 2] = fb + 1422;
 HEAP32[gb + 209928 >> 2] = fb + 1423;
 HEAP32[gb + 209932 >> 2] = fb + 1424;
 HEAP32[gb + 209936 >> 2] = fb + 1425;
 HEAP32[gb + 209940 >> 2] = fb + 1426;
 HEAP32[gb + 209944 >> 2] = fb + 1427;
 HEAP32[gb + 209948 >> 2] = fb + 1428;
 HEAP32[gb + 11288 >> 2] = (HEAP32[gb + 11288 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11292 >> 2] = (HEAP32[gb + 11292 >> 2] | 0) + (gb + 1078769 | 0);
 HEAP32[gb + 11304 >> 2] = (HEAP32[gb + 11304 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11312 >> 2] = (HEAP32[gb + 11312 >> 2] | 0) + (gb + 11328 | 0);
 HEAP32[gb + 11320 >> 2] = (HEAP32[gb + 11320 >> 2] | 0) + (gb + 11336 | 0);
 HEAP32[gb + 11328 >> 2] = (HEAP32[gb + 11328 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11332 >> 2] = (HEAP32[gb + 11332 >> 2] | 0) + (gb + 1078872 | 0);
 HEAP32[gb + 11336 >> 2] = (HEAP32[gb + 11336 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11340 >> 2] = (HEAP32[gb + 11340 >> 2] | 0) + (gb + 1078838 | 0);
 HEAP32[gb + 209956 >> 2] = (HEAP32[gb + 209956 >> 2] | 0) + (gb + 11344 | 0);
 HEAP32[gb + 209960 >> 2] = fb + 3081;
 HEAP32[gb + 209964 >> 2] = fb + 3082;
 HEAP32[gb + 209968 >> 2] = fb + 3068;
 HEAP32[gb + 209972 >> 2] = fb + 1429;
 HEAP32[gb + 209976 >> 2] = fb + 123;
 HEAP32[gb + 209980 >> 2] = fb + 124;
 HEAP32[gb + 209984 >> 2] = fb + 125;
 HEAP32[gb + 209988 >> 2] = fb + 126;
 HEAP32[gb + 209992 >> 2] = fb + 127;
 HEAP32[gb + 209996 >> 2] = fb + 21;
 HEAP32[gb + 210004 >> 2] = (HEAP32[gb + 210004 >> 2] | 0) + (gb + 11344 | 0);
 HEAP32[gb + 210008 >> 2] = fb + 1430;
 HEAP32[gb + 210012 >> 2] = fb + 1431;
 runPostSets231();
}

function __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i6 = __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_(i7, i8, i5, i4, i1) | 0;
 i1 = _strcmp(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i9 = i6;
   STACKTOP = i10;
   return i9 | 0;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = i6;
   STACKTOP = i10;
   return i9 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i9 = i6;
  STACKTOP = i10;
  return i9 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i3 = i6 + 1 | 0;
 i1 = _strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i1) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i9 = i3;
  STACKTOP = i10;
  return i9 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i3 = i6 + 2 | 0;
 i1 = _strcmp(HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  if (!i1) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i9 = i3;
  STACKTOP = i10;
  return i9 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i3 = i6 + 3 | 0;
 i1 = _strcmp(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  if (!i1) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i9 = i3;
   STACKTOP = i10;
   return i9 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i9 = i3;
  STACKTOP = i10;
  return i9 | 0;
 };
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i9 = i6 + 4 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function _UNITY_LZ4_decompress_safe_withPrefix64k(i19, i15, i1, i2) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i16 = i19 + i1 | 0;
 i17 = i15 + i2 | 0;
 i18 = i17 + -12 | 0;
 if (!i2) {
  if ((i1 | 0) == 1) i1 = (HEAP8[i19 >> 0] | 0) != 0; else i1 = 1;
  i20 = i1 << 31 >> 31;
  return i20 | 0;
 }
 i9 = i16 + -15 | 0;
 i10 = i16 + -8 | 0;
 i11 = i16 + -5 | 0;
 i12 = i17 + -5 | 0;
 i13 = i17 + -8 | 0;
 i14 = i13;
 i2 = i19;
 i3 = i15;
 L8 : while (1) {
  i1 = i2 + 1 | 0;
  i7 = HEAPU8[i2 >> 0] | 0;
  i2 = i7 >>> 4;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    i8 = i1;
    i1 = i1 + 1 | 0;
    i8 = HEAP8[i8 >> 0] | 0;
    i2 = (i8 & 255) + i2 | 0;
   } while (i8 << 24 >> 24 == -1 & i1 >>> 0 < i9 >>> 0);
   if ((i2 | 0) < 0) break;
  }
  i8 = i3 + i2 | 0;
  i4 = i1 + i2 | 0;
  if (i8 >>> 0 > i18 >>> 0 | i4 >>> 0 > i10 >>> 0) {
   i20 = 10;
   break;
  } else i2 = i3;
  while (1) {
   i5 = i1;
   i21 = i5;
   i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i2;
   i3 = i6;
   HEAP8[i3 >> 0] = i21;
   HEAP8[i3 + 1 >> 0] = i21 >> 8;
   HEAP8[i3 + 2 >> 0] = i21 >> 16;
   HEAP8[i3 + 3 >> 0] = i21 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i8 >>> 0) break; else i1 = i1 + 8 | 0;
  }
  i3 = HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 >> 0];
  i5 = i3 & 65535;
  i6 = i8 + (0 - i3) | 0;
  i1 = i4 + 2 | 0;
  i2 = i7 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   do {
    if (i1 >>> 0 > i11 >>> 0) break L8;
    i21 = i1;
    i1 = i1 + 1 | 0;
    i21 = HEAP8[i21 >> 0] | 0;
    i2 = (i21 & 255) + i2 | 0;
   } while (i21 << 24 >> 24 == -1);
   if ((i2 | 0) < 0) break;
  }
  i7 = i8 + (i2 + 4) | 0;
  if ((i5 & 65535) < 8) {
   i21 = HEAP32[gb + 74112 + (i3 << 2) >> 2] | 0;
   HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
   i3 = i6 + (HEAP32[gb + 74144 + (i3 << 2) >> 2] | 0) | 0;
   i6 = i8 + 4 | 0;
   i5 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i3 = i3 + (0 - i21) | 0;
  } else {
   i21 = i6;
   i4 = i21;
   i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   i21 = i21 + 4 | 0;
   i21 = HEAPU8[i21 >> 0] | HEAPU8[i21 + 1 >> 0] << 8 | HEAPU8[i21 + 2 >> 0] << 16 | HEAPU8[i21 + 3 >> 0] << 24;
   i3 = i8;
   i5 = i3;
   HEAP8[i5 >> 0] = i4;
   HEAP8[i5 + 1 >> 0] = i4 >> 8;
   HEAP8[i5 + 2 >> 0] = i4 >> 16;
   HEAP8[i5 + 3 >> 0] = i4 >> 24;
   i3 = i3 + 4 | 0;
   HEAP8[i3 >> 0] = i21;
   HEAP8[i3 + 1 >> 0] = i21 >> 8;
   HEAP8[i3 + 2 >> 0] = i21 >> 16;
   HEAP8[i3 + 3 >> 0] = i21 >> 24;
   i3 = i6 + 8 | 0;
  }
  i2 = i8 + 8 | 0;
  if (i7 >>> 0 <= i18 >>> 0) while (1) {
   i8 = i3;
   i5 = i8;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i8 = i8 + 4 | 0;
   i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
   i21 = i2;
   i6 = i21;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i21 = i21 + 4 | 0;
   HEAP8[i21 >> 0] = i8;
   HEAP8[i21 + 1 >> 0] = i8 >> 8;
   HEAP8[i21 + 2 >> 0] = i8 >> 16;
   HEAP8[i21 + 3 >> 0] = i8 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 < i7 >>> 0) i3 = i3 + 8 | 0; else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
  if (i7 >>> 0 > i12 >>> 0) break;
  if (i2 >>> 0 < i13 >>> 0) {
   i4 = i2;
   i5 = i3;
   while (1) {
    i8 = i5;
    i22 = i8;
    i22 = HEAPU8[i22 >> 0] | HEAPU8[i22 + 1 >> 0] << 8 | HEAPU8[i22 + 2 >> 0] << 16 | HEAPU8[i22 + 3 >> 0] << 24;
    i8 = i8 + 4 | 0;
    i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
    i21 = i4;
    i6 = i21;
    HEAP8[i6 >> 0] = i22;
    HEAP8[i6 + 1 >> 0] = i22 >> 8;
    HEAP8[i6 + 2 >> 0] = i22 >> 16;
    HEAP8[i6 + 3 >> 0] = i22 >> 24;
    i21 = i21 + 4 | 0;
    HEAP8[i21 >> 0] = i8;
    HEAP8[i21 + 1 >> 0] = i8 >> 8;
    HEAP8[i21 + 2 >> 0] = i8 >> 16;
    HEAP8[i21 + 3 >> 0] = i8 >> 24;
    i4 = i4 + 8 | 0;
    if (i4 >>> 0 >= i13 >>> 0) break; else i5 = i5 + 8 | 0;
   }
   i3 = i3 + (i14 - i2) | 0;
   i2 = i13;
  }
  if (i2 >>> 0 >= i7 >>> 0) {
   i2 = i1;
   i3 = i7;
   continue;
  }
  while (1) {
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   if (i4 >>> 0 < i7 >>> 0) {
    i3 = i3 + 1 | 0;
    i2 = i4;
   } else {
    i2 = i1;
    i3 = i7;
    continue L8;
   }
  }
 }
 if ((i20 | 0) == 10) if (!(i8 >>> 0 > i17 >>> 0 | (i4 | 0) != (i16 | 0))) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i22 = i8 - i15 | 0;
  return i22 | 0;
 }
 i22 = i19 + -1 - i1 | 0;
 return i22 | 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 6;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 6;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 6;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 6;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 8 | 0;
 i10 = i18 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (Math_imul((Math_imul((Math_imul((Math_imul(i2 >>> 24 ^ -2128831035, 16777619) | 0) ^ i2 >>> 16 & 255, 16777619) | 0) ^ i2 >>> 8 & 255, 16777619) | 0) ^ i2 & 255, 16777619) | 0) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN12_GLOBAL__N_122createArticulationLinkERN5physx14NpArticulationEPNS0_18NpArticulationLinkERKNS0_11PxTransformE(i7, i10, i6) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 68 | 0;
 i2 = i12 + 40 | 0;
 i9 = i12 + 12 | 0;
 i3 = HEAP32[gb + 1457204 >> 2] | 0;
 i4 = i3 + 3040 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i5 = i3 + 3036 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i3 + 2744 | 0);
  i8 = HEAP32[i5 >> 2] | 0;
 } else i8 = i1;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i5 = i3 + 3024 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i3 + 3028 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (!i8) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 547, gb + 686311 | 0, i12);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZN5physx18NpArticulationLinkC2ERKNS_11PxTransformERNS_14NpArticulationEPS0_(i8, i6, i7, i10);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 if (!i10) {
  i11 = i8;
  STACKTOP = i12;
  return i11 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i10 | 0);
 f23 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f22 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f21 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i2 + 20 >> 2]));
 f25 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f24 = Math_fround(f24 * Math_fround(2.0));
 f21 = Math_fround(f21 * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f25 - Math_fround(HEAPF32[i2 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(f26 * f26) + Math_fround(-.5));
 f13 = Math_fround(Math_fround(Math_fround(f24 * f23) + Math_fround(f21 * f22)) + Math_fround(f25 * f19));
 f15 = Math_fround(Math_fround(f13 * f23) + Math_fround(Math_fround(f16 * f24) + Math_fround(f26 * Math_fround(Math_fround(f25 * f22) - Math_fround(f21 * f19)))));
 f14 = Math_fround(Math_fround(f13 * f22) + Math_fround(Math_fround(f16 * f21) + Math_fround(f26 * Math_fround(Math_fround(f24 * f19) - Math_fround(f25 * f23)))));
 f13 = Math_fround(Math_fround(Math_fround(f16 * f25) + Math_fround(f26 * Math_fround(Math_fround(f21 * f23) - Math_fround(f24 * f22)))) + Math_fround(f13 * f19));
 f24 = Math_fround(HEAPF32[i6 >> 2]);
 f21 = Math_fround(f26 * f24);
 f25 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f25 * f23));
 f16 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f16 * f22));
 f20 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f24 * f19) + Math_fround(Math_fround(f25 * f22) + Math_fround(f26 * f20))) - Math_fround(f16 * f23));
 f17 = Math_fround(Math_fround(Math_fround(f20 * f23) + Math_fround(Math_fround(f25 * f19) + Math_fround(f26 * f16))) - Math_fround(f24 * f22));
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23)) - Math_fround(f20 * f22)) - Math_fround(f16 * f19));
 HEAPF32[i11 >> 2] = Math_fround(f21 - Math_fround(f20 * f19));
 HEAPF32[i11 + 4 >> 2] = f18;
 HEAPF32[i11 + 8 >> 2] = f17;
 HEAPF32[i11 + 12 >> 2] = f16;
 HEAPF32[i11 + 16 >> 2] = f15;
 HEAPF32[i11 + 20 >> 2] = f14;
 HEAPF32[i11 + 24 >> 2] = f13;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 3340 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 3336 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 3044 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i7 = i2 + 3324 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = i2 + 3328 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 if (!i1) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 562, gb + 686367 | 0, i12 + 8 | 0);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 } else {
  __ZN5physx19NpArticulationJointC2ERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_(i1, i10, i11, i8, i9);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  HEAP32[i8 + 292 >> 2] = i1;
  i11 = i8;
  STACKTOP = i12;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 96 | 0;
 i9 = i11;
 i10 = __Z12GetGfxDevicev() | 0;
 i4 = i6 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i1);
 if (i1 | 0) {
  __ZNK6Camera28ExtractCameraRenderingParamsEv(i8, i1);
  __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i1, i7, i8, 0);
 }
 i4 = i6 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 21;
   }
  }
  if ((i5 | 0) == 19) i5 = 21;
  if ((i5 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 80 >> 2] | 0, i10 | 0, (HEAP8[i6 + 56 >> 0] | 0) != 0 | 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 152 >> 2] | 0, i10 | 0, i6 + 16 | 0);
 if (!(HEAP8[i6 + 57 >> 0] | 0)) mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 164 >> 2] | 0, i10 | 0); else mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i6 + 32 | 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 116 >> 2] | 0, i10 | 0, i6 + 188 | 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0, i6 + 124 | 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 108 >> 2] | 0, i10 | 0, i6 + 60 | 0);
 i12 = __Z12GetGfxDevicev() | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 132 >> 2] | 0, i12 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 140 >> 2] | 0, i12 | 0) | 0, i10, i8);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i8, i9);
 i10 = i12 + 1364 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i10 = i9 + 16 | 0;
 i8 = i12 + 1380 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i8 = i9 + 32 | 0;
 i10 = i12 + 1396 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i10 = i9 + 48 | 0;
 i8 = i12 + 1412 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i8 = i9 + 64 | 0;
 i10 = i12 + 1428 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i10 = i9 + 80 | 0;
 i12 = i12 + 1444 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i12 = i7 + 36 | 0;
 __ZN19ShaderPropertySheet18SetTexturePropertyERKN9ShaderLab16FastPropertyNameERKNS_15TexturePropertyE(i12, gb + 1110556 | 0, i6 + 252 | 0);
 __ZN19ShaderPropertySheet18SetTexturePropertyERKN9ShaderLab16FastPropertyNameERKNS_15TexturePropertyE(i12, gb + 1110560 | 0, i6 + 284 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_(i2, i3, i8, i4, f6, f5, i7, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i9 + 12 | 0;
 i33 = i9;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i30 | 0, i2 | 0);
 f16 = Math_fround(Math_fround(HEAPF32[i30 + 16 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i30 + 20 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i30 + 24 >> 2]) * Math_fround(2.0));
 i30 = i3 + 12 | 0;
 f12 = Math_fround(HEAPF32[i30 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f28 = Math_fround(HEAPF32[i3 >> 2]);
 f20 = Math_fround(f16 * f28);
 i32 = i3 + 4 | 0;
 f27 = Math_fround(HEAPF32[i32 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f18 * f27));
 i31 = i3 + 8 | 0;
 f10 = Math_fround(HEAPF32[i31 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f23 * f10));
 f19 = Math_fround(Math_fround(f28 * f20) + Math_fround(Math_fround(f16 * f13) + Math_fround(f12 * Math_fround(Math_fround(f23 * f27) - Math_fround(f18 * f10)))));
 f17 = Math_fround(Math_fround(f27 * f20) + Math_fround(Math_fround(f18 * f13) + Math_fround(f12 * Math_fround(Math_fround(f16 * f10) - Math_fround(f23 * f28)))));
 f20 = Math_fround(Math_fround(Math_fround(f23 * f13) + Math_fround(f12 * Math_fround(Math_fround(f18 * f28) - Math_fround(f16 * f27)))) + Math_fround(f10 * f20));
 f19 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f19);
 f17 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f17);
 f20 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f20);
 f10 = Math_fround(Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0)) * f6);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i33 | 0, i2 | 0);
 f27 = Math_fround(Math_fround(HEAPF32[i33 >> 2]) * f5);
 f16 = Math_fround(Math_fround(HEAPF32[i33 + 4 >> 2]) * f5);
 f28 = Math_fround(Math_fround(HEAPF32[i33 + 8 >> 2]) * f5);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i32 >> 2]);
 f12 = Math_fround(HEAPF32[i31 >> 2]);
 f13 = Math_fround(HEAPF32[i30 >> 2]);
 f23 = Math_fround(f18 + f18);
 f29 = Math_fround(f6 + f6);
 f5 = Math_fround(f12 + f12);
 f22 = Math_fround(f6 * f29);
 f11 = Math_fround(f12 * f5);
 f6 = Math_fround(f23 * f6);
 f15 = Math_fround(f23 * f12);
 f26 = Math_fround(f23 * f13);
 f12 = Math_fround(f29 * f12);
 f29 = Math_fround(f29 * f13);
 f13 = Math_fround(f5 * f13);
 f5 = Math_fround(Math_fround(Math_fround(1.0) - f22) - f11);
 f25 = Math_fround(f6 + f13);
 f14 = Math_fround(f15 - f29);
 f13 = Math_fround(f6 - f13);
 f23 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f23));
 f11 = Math_fround(f23 - f11);
 f18 = Math_fround(f12 + f26);
 f29 = Math_fround(f15 + f29);
 f26 = Math_fround(f12 - f26);
 f22 = Math_fround(f23 - f22);
 f23 = Math_fround(f27 * f5);
 f12 = Math_fround(f27 * f25);
 f15 = Math_fround(f16 * f13);
 f6 = Math_fround(f16 * f11);
 f24 = Math_fround(f28 * f29);
 f21 = Math_fround(f28 * f26);
 f13 = Math_fround(Math_fround(f29 * f24) + Math_fround(Math_fround(f5 * f23) + Math_fround(f13 * f15)));
 f5 = Math_fround(Math_fround(f26 * f21) + Math_fround(Math_fround(f25 * f12) + Math_fround(f11 * f6)));
 f16 = Math_fround(Math_fround(f22 * Math_fround(f28 * f22)) + Math_fround(Math_fround(f14 * Math_fround(f27 * f14)) + Math_fround(f18 * Math_fround(f16 * f18))));
 f11 = Math_fround(Math_fround(f26 * f24) + Math_fround(Math_fround(f25 * f23) + Math_fround(f11 * f15)));
 f15 = Math_fround(Math_fround(f22 * f24) + Math_fround(Math_fround(f14 * f23) + Math_fround(f18 * f15)));
 f6 = Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f14 * f12) + Math_fround(f18 * f6)));
 f18 = Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2]));
 i3 = i4 + 4 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2]));
 i2 = i4 + 8 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i7 >> 2] = f18;
 HEAPF32[i7 + 4 >> 2] = f12;
 HEAPF32[i7 + 8 >> 2] = f10;
 f19 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f19);
 f17 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f17);
 f20 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) - f20);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f17 * f10);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f20 * f18));
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(Math_fround(f20 * f14) - Math_fround(f19 * f10));
 f14 = Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f14));
 f5 = Math_fround(Math_fround(f6 * f14) + Math_fround(Math_fround(f11 * f12) + Math_fround(f5 * f10)));
 f6 = Math_fround(Math_fround(f16 * f14) + Math_fround(Math_fround(f15 * f12) + Math_fround(f6 * f10)));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * f10)));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f6;
 STACKTOP = i9;
 return;
}

function __ZN24b2PositionSolverManifold10InitializeEP27b2ContactPositionConstraintRK11b2TransformS4_i(i12, i13, i2, i3, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 switch (HEAP32[i13 + 72 >> 2] | 0) {
 case 0:
  {
   f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f10 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f11 = Math_fround(f7 * f10);
   f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f11 = Math_fround(Math_fround(f11 - Math_fround(f4 * f9)) + Math_fround(HEAPF32[i2 >> 2]));
   f9 = Math_fround(Math_fround(Math_fround(f10 * f4) + Math_fround(f7 * f9)) + Math_fround(HEAPF32[i2 + 4 >> 2]));
   f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f4 = Math_fround(HEAPF32[i13 >> 2]);
   f10 = Math_fround(f7 * f4);
   f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f6 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f10 = Math_fround(Math_fround(f10 - Math_fround(f8 * f6)) + Math_fround(HEAPF32[i3 >> 2]));
   f6 = Math_fround(Math_fround(Math_fround(f4 * f8) + Math_fround(f7 * f6)) + Math_fround(HEAPF32[i3 + 4 >> 2]));
   f7 = Math_fround(f10 - f11);
   f8 = Math_fround(f6 - f9);
   HEAPF32[i12 >> 2] = f7;
   i1 = i12 + 4 | 0;
   HEAPF32[i1 >> 2] = f8;
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))));
   if (f4 < Math_fround(1.1920929e-07)) {
    f4 = f7;
    f5 = f8;
   } else {
    f5 = Math_fround(Math_fround(1.0) / f4);
    f4 = Math_fround(f7 * f5);
    HEAPF32[i12 >> 2] = f4;
    f5 = Math_fround(f8 * f5);
    HEAPF32[i1 >> 2] = f5;
   }
   f9 = Math_fround(Math_fround(f9 + f6) * Math_fround(.5));
   HEAPF32[i12 + 8 >> 2] = Math_fround(Math_fround(f11 + f10) * Math_fround(.5));
   HEAPF32[i12 + 12 >> 2] = f9;
   HEAPF32[i12 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f4) + Math_fround(f8 * f5)) - Math_fround(HEAPF32[i13 + 76 >> 2])) - Math_fround(HEAPF32[i13 + 80 >> 2]));
   return;
  }
 case 1:
  {
   i16 = i2 + 12 | 0;
   f5 = Math_fround(HEAPF32[i16 >> 2]);
   f7 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f6 = Math_fround(f5 * f7);
   i15 = i2 + 8 | 0;
   f10 = Math_fround(HEAPF32[i15 >> 2]);
   f9 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f6 = Math_fround(f6 - Math_fround(f10 * f9));
   f9 = Math_fround(Math_fround(f7 * f10) + Math_fround(f5 * f9));
   HEAPF32[i12 >> 2] = f6;
   HEAPF32[i12 + 4 >> 2] = f9;
   f5 = Math_fround(HEAPF32[i16 >> 2]);
   f10 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f7 = Math_fround(f5 * f10);
   f14 = Math_fround(HEAPF32[i15 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f7 = Math_fround(Math_fround(f7 - Math_fround(f14 * f8)) + Math_fround(HEAPF32[i2 >> 2]));
   f8 = Math_fround(Math_fround(Math_fround(f10 * f14) + Math_fround(f5 * f8)) + Math_fround(HEAPF32[i2 + 4 >> 2]));
   f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f14 = Math_fround(HEAPF32[i13 + (i1 << 3) >> 2]);
   f10 = Math_fround(f5 * f14);
   f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i13 + (i1 << 3) + 4 >> 2]);
   f10 = Math_fround(Math_fround(f10 - Math_fround(f4 * f11)) + Math_fround(HEAPF32[i3 >> 2]));
   f11 = Math_fround(Math_fround(Math_fround(f14 * f4) + Math_fround(f5 * f11)) + Math_fround(HEAPF32[i3 + 4 >> 2]));
   HEAPF32[i12 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f6 * Math_fround(f10 - f7)) + Math_fround(Math_fround(f11 - f8) * f9)) - Math_fround(HEAPF32[i13 + 76 >> 2])) - Math_fround(HEAPF32[i13 + 80 >> 2]));
   HEAPF32[i12 + 8 >> 2] = f10;
   HEAPF32[i12 + 12 >> 2] = f11;
   return;
  }
 case 2:
  {
   i17 = i3 + 12 | 0;
   f6 = Math_fround(HEAPF32[i17 >> 2]);
   f7 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f11 = Math_fround(f6 * f7);
   i15 = i3 + 8 | 0;
   f9 = Math_fround(HEAPF32[i15 >> 2]);
   f14 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f11 = Math_fround(f11 - Math_fround(f9 * f14));
   f14 = Math_fround(Math_fround(f7 * f9) + Math_fround(f6 * f14));
   HEAPF32[i12 >> 2] = f11;
   i16 = i12 + 4 | 0;
   HEAPF32[i16 >> 2] = f14;
   f6 = Math_fround(HEAPF32[i17 >> 2]);
   f9 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f7 = Math_fround(f6 * f9);
   f4 = Math_fround(HEAPF32[i15 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 28 >> 2]);
   f7 = Math_fround(Math_fround(f7 - Math_fround(f4 * f8)) + Math_fround(HEAPF32[i3 >> 2]));
   f8 = Math_fround(Math_fround(Math_fround(f9 * f4) + Math_fround(f6 * f8)) + Math_fround(HEAPF32[i3 + 4 >> 2]));
   f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f4 = Math_fround(HEAPF32[i13 + (i1 << 3) >> 2]);
   f9 = Math_fround(f6 * f4);
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f10 = Math_fround(HEAPF32[i13 + (i1 << 3) + 4 >> 2]);
   f9 = Math_fround(Math_fround(f9 - Math_fround(f5 * f10)) + Math_fround(HEAPF32[i2 >> 2]));
   f10 = Math_fround(Math_fround(Math_fround(f4 * f5) + Math_fround(f6 * f10)) + Math_fround(HEAPF32[i2 + 4 >> 2]));
   HEAPF32[i12 + 16 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f11 * Math_fround(f9 - f7)) + Math_fround(Math_fround(f10 - f8) * f14)) - Math_fround(HEAPF32[i13 + 76 >> 2])) - Math_fround(HEAPF32[i13 + 80 >> 2]));
   HEAPF32[i12 + 8 >> 2] = f9;
   HEAPF32[i12 + 12 >> 2] = f10;
   f14 = Math_fround(-f14);
   HEAPF32[i12 >> 2] = Math_fround(-f11);
   HEAPF32[i16 >> 2] = f14;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i28, i29, i1) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i31 + 32 | 0;
 i30 = i31 + 16 | 0;
 i27 = i31;
 i1 = i28 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i28 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i26, 4);
  i1 = HEAP32[i26 >> 2] | 0;
 } else {
  i25 = HEAP32[i2 >> 2] | 0;
  HEAP32[i26 >> 2] = i25;
  HEAP32[i1 >> 2] = i3;
  i1 = i25;
 }
 i13 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i30 + 4 >> 2] = 0;
 HEAP32[i30 + 8 >> 2] = 0;
 HEAP32[i30 + 12 >> 2] = 0;
 i14 = i29 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i29, HEAP32[i14 >> 2] | 0);
 i15 = i29 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i29 >> 2] = i14;
 HEAP32[i14 >> 2] = 0;
 if ((i13 | 0) > 0) {
  i16 = i30 + 4 | 0;
  i17 = i27 + 4 | 0;
  i18 = i30 + 4 | 0;
  i19 = i27 + 8 | 0;
  i20 = i27 + 12 | 0;
  i21 = i30 + 8 | 0;
  i22 = i14;
  i23 = i29 + 4 | 0;
  i24 = i27 + 4 | 0;
  i25 = i27 + 12 | 0;
  i12 = 0;
  do {
   __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i30, i28);
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS4_EENS5_9allocatorIS4_EEEEEvRT_17TransferMetaFlags(i28, i16, 0);
   HEAP32[i27 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i17 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   i2 = HEAP32[i21 >> 2] | 0;
   i1 = HEAP32[i18 >> 2] | 0;
   i3 = i2 - i1 | 0;
   i4 = (i3 | 0) / 36 | 0;
   if (!i3) {
    i1 = 0;
    i11 = 0;
    i3 = 0;
   } else {
    if (i4 >>> 0 > 119304647) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i17);
     i5 = HEAP32[i18 >> 2] | 0;
     i2 = HEAP32[i21 >> 2] | 0;
    } else i5 = i1;
    i1 = __Znwj(i3) | 0;
    HEAP32[i19 >> 2] = i1;
    HEAP32[i17 >> 2] = i1;
    HEAP32[i25 >> 2] = i1 + (i4 * 36 | 0);
    i2 = i2 - i5 | 0;
    i3 = i1;
    if ((i2 | 0) > 0) {
     _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
     i11 = i1 + (((i2 >>> 0) / 36 | 0) * 36 | 0) | 0;
     HEAP32[i19 >> 2] = i11;
    } else i11 = i3;
   }
   i2 = HEAP32[i14 >> 2] | 0;
   do if (!i2) {
    HEAP32[i26 >> 2] = i14;
    i10 = i22;
    i5 = i14;
   } else {
    i6 = HEAP32[i27 >> 2] | 0;
    while (1) {
     i4 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i6 | 0) < (i4 | 0)) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i4 = 20;
       break;
      } else i2 = i4;
     } else {
      if ((i4 | 0) >= (i6 | 0)) {
       i4 = 25;
       break;
      }
      i5 = i2 + 4 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) {
       i4 = 24;
       break;
      } else i2 = i4;
     }
    }
    if ((i4 | 0) == 20) {
     HEAP32[i26 >> 2] = i2;
     i10 = i2;
     i5 = i2;
     break;
    } else if ((i4 | 0) == 24) {
     HEAP32[i26 >> 2] = i2;
     i10 = i2;
     break;
    } else if ((i4 | 0) == 25) {
     HEAP32[i26 >> 2] = i2;
     i10 = i2;
     i5 = i26;
     break;
    }
   } while (0);
   if (!(HEAP32[i5 >> 2] | 0)) {
    i1 = __Znwj(32) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i27 >> 2];
    i6 = i1 + 20 | 0;
    HEAP32[i6 >> 2] = 0;
    i9 = i1 + 24 | 0;
    HEAP32[i9 >> 2] = 0;
    i7 = i1 + 28 | 0;
    HEAP32[i7 >> 2] = 0;
    i4 = i11 - i3 | 0;
    i8 = (i4 | 0) / 36 | 0;
    if (i4 | 0) {
     if (i8 >>> 0 > 119304647) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
      i3 = HEAP32[i17 >> 2] | 0;
      i2 = HEAP32[i19 >> 2] | 0;
     } else i2 = i11;
     i4 = __Znwj(i4) | 0;
     HEAP32[i9 >> 2] = i4;
     HEAP32[i6 >> 2] = i4;
     HEAP32[i7 >> 2] = i4 + (i8 * 36 | 0);
     i2 = i2 - i3 | 0;
     if ((i2 | 0) > 0) {
      _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
      HEAP32[i9 >> 2] = i4 + (((i2 >>> 0) / 36 | 0) * 36 | 0);
     }
    }
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i10;
    HEAP32[i5 >> 2] = i1;
    i2 = HEAP32[HEAP32[i29 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i29 >> 2] = i2;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i23 >> 2] | 0, i1);
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
    i1 = HEAP32[i24 >> 2] | 0;
   }
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i19 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i19 >> 2] = i3 + (~(((i3 + -36 - i2 | 0) >>> 0) / 36 | 0) * 36 | 0);
    __ZdlPv(i1);
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i13 | 0));
 }
 i3 = HEAP32[i30 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i31;
  return;
 }
 i1 = i30 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -36 - i3 | 0) >>> 0) / 36 | 0) * 36 | 0);
 __ZdlPv(i3);
 STACKTOP = i31;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function runPostSets66() {
 HEAP32[gb + 73900 >> 2] = fb + 91;
 HEAP32[gb + 73904 >> 2] = fb + 17;
 HEAP32[gb + 73908 >> 2] = fb + 68;
 HEAP32[gb + 73912 >> 2] = fb + 69;
 HEAP32[gb + 73916 >> 2] = fb + 70;
 HEAP32[gb + 73920 >> 2] = fb + 56;
 HEAP32[gb + 73924 >> 2] = fb + 4;
 HEAP32[gb + 73928 >> 2] = fb + 92;
 HEAP32[gb + 73932 >> 2] = fb + 25;
 HEAP32[gb + 73936 >> 2] = fb + 128;
 HEAP32[gb + 73940 >> 2] = fb + 162;
 HEAP32[gb + 73944 >> 2] = (HEAP32[gb + 73944 >> 2] | 0) + (gb + 585865 | 0);
 HEAP32[gb + 73948 >> 2] = (HEAP32[gb + 73948 >> 2] | 0) + (gb + 585944 | 0);
 HEAP32[gb + 73952 >> 2] = (HEAP32[gb + 73952 >> 2] | 0) + (gb + 586034 | 0);
 HEAP32[gb + 73956 >> 2] = (HEAP32[gb + 73956 >> 2] | 0) + (gb + 586118 | 0);
 HEAP32[gb + 73960 >> 2] = (HEAP32[gb + 73960 >> 2] | 0) + (gb + 586144 | 0);
 HEAP32[gb + 73964 >> 2] = (HEAP32[gb + 73964 >> 2] | 0) + (gb + 586224 | 0);
 HEAP32[gb + 73976 >> 2] = fb + 1;
 HEAP32[gb + 73980 >> 2] = fb + 1;
 HEAP32[gb + 73984 >> 2] = fb + 1;
 HEAP32[gb + 73988 >> 2] = fb + 1;
 HEAP32[gb + 73992 >> 2] = fb + 1;
 HEAP32[gb + 73996 >> 2] = fb + 1;
 HEAP32[gb + 74e3 >> 2] = fb + 1;
 HEAP32[gb + 74004 >> 2] = fb + 1;
 HEAP32[gb + 74008 >> 2] = fb + 5;
 HEAP32[gb + 74012 >> 2] = fb + 1;
 HEAP32[gb + 74016 >> 2] = fb + 1;
 HEAP32[gb + 74020 >> 2] = fb + 6;
 HEAP32[gb + 74024 >> 2] = fb + 2;
 HEAP32[gb + 74028 >> 2] = fb + 1;
 HEAP32[gb + 74032 >> 2] = fb + 3;
 HEAP32[gb + 74036 >> 2] = fb + 1;
 HEAP32[gb + 74040 >> 2] = fb + 1;
 HEAP32[gb + 74044 >> 2] = fb + 1;
 HEAP32[gb + 74048 >> 2] = fb + 10;
 HEAP32[gb + 74052 >> 2] = fb + 11;
 HEAP32[gb + 74056 >> 2] = fb + 12;
 HEAP32[gb + 74060 >> 2] = fb + 4;
 HEAP32[gb + 74064 >> 2] = fb + 13;
 HEAP32[gb + 74068 >> 2] = fb + 5;
 HEAP32[gb + 74072 >> 2] = fb + 1;
 HEAP32[gb + 74076 >> 2] = fb + 828;
 HEAP32[gb + 74080 >> 2] = fb + 829;
 HEAP32[gb + 74108 >> 2] = (HEAP32[gb + 74108 >> 2] | 0) + (gb + 588243 | 0);
 HEAP32[gb + 75376 >> 2] = (HEAP32[gb + 75376 >> 2] | 0) + (gb + 600423 | 0);
 HEAP32[gb + 75380 >> 2] = (HEAP32[gb + 75380 >> 2] | 0) + (gb + 600437 | 0);
 HEAP32[gb + 75384 >> 2] = (HEAP32[gb + 75384 >> 2] | 0) + (gb + 600465 | 0);
 HEAP32[gb + 75388 >> 2] = (HEAP32[gb + 75388 >> 2] | 0) + (gb + 600496 | 0);
 HEAP32[gb + 75392 >> 2] = (HEAP32[gb + 75392 >> 2] | 0) + (gb + 600523 | 0);
 HEAP32[gb + 75396 >> 2] = (HEAP32[gb + 75396 >> 2] | 0) + (gb + 600550 | 0);
 HEAP32[gb + 75700 >> 2] = (HEAP32[gb + 75700 >> 2] | 0) + (gb + 602116 | 0);
 HEAP32[gb + 75704 >> 2] = (HEAP32[gb + 75704 >> 2] | 0) + (gb + 602147 | 0);
 HEAP32[gb + 75708 >> 2] = (HEAP32[gb + 75708 >> 2] | 0) + (gb + 602099 | 0);
 HEAP32[gb + 75712 >> 2] = (HEAP32[gb + 75712 >> 2] | 0) + (gb + 1085908 | 0);
 HEAP32[gb + 75764 >> 2] = (HEAP32[gb + 75764 >> 2] | 0) + (gb + 602859 | 0);
 HEAP32[gb + 75768 >> 2] = (HEAP32[gb + 75768 >> 2] | 0) + (gb + 602892 | 0);
 HEAP32[gb + 75772 >> 2] = (HEAP32[gb + 75772 >> 2] | 0) + (gb + 602925 | 0);
 HEAP32[gb + 75776 >> 2] = (HEAP32[gb + 75776 >> 2] | 0) + (gb + 602958 | 0);
 HEAP32[gb + 75780 >> 2] = (HEAP32[gb + 75780 >> 2] | 0) + (gb + 602995 | 0);
 HEAP32[gb + 75784 >> 2] = (HEAP32[gb + 75784 >> 2] | 0) + (gb + 603025 | 0);
 HEAP32[gb + 75788 >> 2] = (HEAP32[gb + 75788 >> 2] | 0) + (gb + 603055 | 0);
 HEAP32[gb + 75792 >> 2] = (HEAP32[gb + 75792 >> 2] | 0) + (gb + 603085 | 0);
 HEAP32[gb + 75796 >> 2] = (HEAP32[gb + 75796 >> 2] | 0) + (gb + 603115 | 0);
 HEAP32[gb + 75800 >> 2] = (HEAP32[gb + 75800 >> 2] | 0) + (gb + 603145 | 0);
 HEAP32[gb + 75804 >> 2] = (HEAP32[gb + 75804 >> 2] | 0) + (gb + 603175 | 0);
 HEAP32[gb + 75808 >> 2] = (HEAP32[gb + 75808 >> 2] | 0) + (gb + 603205 | 0);
 HEAP32[gb + 75812 >> 2] = (HEAP32[gb + 75812 >> 2] | 0) + (gb + 602675 | 0);
 HEAP32[gb + 75816 >> 2] = (HEAP32[gb + 75816 >> 2] | 0) + (gb + 602692 | 0);
 HEAP32[gb + 75820 >> 2] = (HEAP32[gb + 75820 >> 2] | 0) + (gb + 602709 | 0);
 HEAP32[gb + 75824 >> 2] = (HEAP32[gb + 75824 >> 2] | 0) + (gb + 602726 | 0);
 HEAP32[gb + 75828 >> 2] = (HEAP32[gb + 75828 >> 2] | 0) + (gb + 602747 | 0);
 HEAP32[gb + 75832 >> 2] = (HEAP32[gb + 75832 >> 2] | 0) + (gb + 602761 | 0);
 HEAP32[gb + 75836 >> 2] = (HEAP32[gb + 75836 >> 2] | 0) + (gb + 602775 | 0);
 HEAP32[gb + 75840 >> 2] = (HEAP32[gb + 75840 >> 2] | 0) + (gb + 602789 | 0);
 HEAP32[gb + 75844 >> 2] = (HEAP32[gb + 75844 >> 2] | 0) + (gb + 602803 | 0);
 HEAP32[gb + 75848 >> 2] = (HEAP32[gb + 75848 >> 2] | 0) + (gb + 602817 | 0);
 HEAP32[gb + 75852 >> 2] = (HEAP32[gb + 75852 >> 2] | 0) + (gb + 602831 | 0);
 HEAP32[gb + 75856 >> 2] = (HEAP32[gb + 75856 >> 2] | 0) + (gb + 602845 | 0);
 HEAP32[gb + 75868 >> 2] = fb + 830;
 HEAP32[gb + 75872 >> 2] = fb + 831;
 HEAP32[gb + 75876 >> 2] = fb + 832;
 HEAP32[gb + 75880 >> 2] = fb + 833;
 HEAP32[gb + 75884 >> 2] = fb + 834;
 HEAP32[gb + 75888 >> 2] = fb + 380;
 HEAP32[gb + 75892 >> 2] = fb + 260;
 HEAP32[gb + 75896 >> 2] = fb + 261;
 HEAP32[gb + 75900 >> 2] = fb + 1;
 HEAP32[gb + 75904 >> 2] = fb + 667;
 HEAP32[gb + 75908 >> 2] = fb + 835;
 HEAP32[gb + 75912 >> 2] = fb + 163;
 HEAP32[gb + 75916 >> 2] = fb + 164;
 HEAP32[gb + 75920 >> 2] = fb + 165;
 HEAP32[gb + 75924 >> 2] = fb + 166;
 HEAP32[gb + 75928 >> 2] = fb + 668;
 HEAP32[gb + 75932 >> 2] = fb + 669;
 HEAP32[gb + 75936 >> 2] = fb + 670;
 HEAP32[gb + 75940 >> 2] = fb + 62;
 HEAP32[gb + 75944 >> 2] = fb + 263;
 HEAP32[gb + 75948 >> 2] = fb + 671;
 runPostSets67();
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fE15collideParticleEj(i24, i1) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0;
 i23 = HEAPU16[(HEAP32[i24 + 104 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 if (!(1 << i23 & HEAP32[i24 + 84 >> 2])) return;
 i22 = HEAP32[i24 + 96 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i24 + 108 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i16 = HEAP32[i22 + (i23 * 76 | 0) >> 2] | 0;
 i2 = i16 + (i1 << 4) | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i24 >> 2]);
 f5 = Math_fround(f3 - f4);
 i6 = i16 + (i1 << 4) + 4 | 0;
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 i8 = i24 + 4 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f7 - f9);
 i11 = i16 + (i1 << 4) + 8 | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = i24 + 8 | 0;
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 f15 = Math_fround(f12 - f14);
 i16 = i16 + (i1 << 4) + 12 | 0;
 f17 = Math_fround(HEAPF32[i16 >> 2]);
 i18 = i24 + 12 | 0;
 f19 = Math_fround(HEAPF32[i18 >> 2]);
 f20 = Math_fround(f17 - f19);
 f21 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f10 * f10)) + Math_fround(f15 * f15));
 if (f21 > Math_fround(HEAPF32[i24 + 48 >> 2])) if (f21 > Math_fround(HEAPF32[i24 + 52 >> 2])) if (f21 > Math_fround(HEAPF32[i24 + 56 >> 2])) if (f21 > Math_fround(HEAPF32[i24 + 60 >> 2])) return;
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f21))));
 f35 = Math_fround(f21 * Math_fround(HEAPF32[i24 + 32 >> 2]));
 f34 = Math_fround(f21 * Math_fround(HEAPF32[i24 + 36 >> 2]));
 f33 = Math_fround(f21 * Math_fround(HEAPF32[i24 + 40 >> 2]));
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i24 + 44 >> 2]));
 f26 = Math_fround(HEAPF32[gb + 1097632 >> 2]);
 f27 = Math_fround(HEAPF32[gb + 1097632 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[gb + 1097632 + 8 >> 2]);
 f26 = Math_fround(Math_fround(1.0) / Math_fround(f17 + Math_fround(f19 + f26)));
 f27 = Math_fround(Math_fround(1.0) / Math_fround(f17 + Math_fround(f19 + f27)));
 f28 = Math_fround(Math_fround(1.0) / Math_fround(f17 + Math_fround(f19 + f28)));
 f25 = Math_fround(Math_fround(1.0) / Math_fround(f17 + Math_fround(f19 + Math_fround(HEAPF32[gb + 1097632 + 12 >> 2]))));
 f26 = Math_fround(f26 * Math_fround(HEAPF32[i24 + 64 >> 2]));
 f27 = Math_fround(f27 * Math_fround(HEAPF32[i24 + 68 >> 2]));
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i24 + 72 >> 2]));
 f26 = Math_fround(Math_fround(f5 - Math_fround(f5 * f35)) * f26);
 f27 = Math_fround(Math_fround(f10 - Math_fround(f10 * f34)) * f27);
 f10 = Math_fround(Math_fround(f15 - Math_fround(f15 * f33)) * f28);
 f15 = Math_fround(Math_fround(f20 - Math_fround(f20 * f21)) * Math_fround(f25 * Math_fround(HEAPF32[i24 + 76 >> 2])));
 i32 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i30 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i31 = HEAP32[gb + 1097600 + 4 >> 2] & i31;
 i30 = HEAP32[gb + 1097600 + 8 >> 2] & i30;
 i29 = HEAP32[gb + 1097600 + 12 >> 2] & (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097600 >> 2] & i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f19 * f15);
 f27 = (HEAP32[tempDoublePtr >> 2] = i31, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f19 * f27);
 f20 = (HEAP32[tempDoublePtr >> 2] = i30, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f19 * f20);
 f21 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f19 * f21);
 f28 = Math_fround(f26 + f9);
 f9 = Math_fround(f25 + f14);
 f19 = Math_fround(f5 + f19);
 HEAPF32[i24 >> 2] = Math_fround(f10 + f4);
 HEAPF32[i8 >> 2] = f28;
 HEAPF32[i13 >> 2] = f9;
 HEAPF32[i18 >> 2] = f19;
 f15 = Math_fround(f17 * f15);
 f19 = Math_fround(f17 * f27);
 f20 = Math_fround(f17 * f20);
 f21 = Math_fround(f17 * f21);
 f9 = Math_fround(f7 - f19);
 f14 = Math_fround(f12 - f20);
 f12 = Math_fround(f17 - f21);
 HEAPF32[i2 >> 2] = Math_fround(f3 - f15);
 HEAPF32[i6 >> 2] = f9;
 HEAPF32[i11 >> 2] = f14;
 HEAPF32[i16 >> 2] = f12;
 i16 = HEAP32[i22 + (i23 * 76 | 0) + 4 >> 2] | 0;
 i13 = i24 + 16 | 0;
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i13 >> 2]));
 i23 = i24 + 20 | 0;
 f12 = Math_fround(f26 + Math_fround(HEAPF32[i23 >> 2]));
 i22 = i24 + 24 | 0;
 f14 = Math_fround(f25 + Math_fround(HEAPF32[i22 >> 2]));
 i18 = i24 + 28 | 0;
 f17 = Math_fround(f5 + Math_fround(HEAPF32[i18 >> 2]));
 HEAPF32[i13 >> 2] = f10;
 HEAPF32[i23 >> 2] = f12;
 HEAPF32[i22 >> 2] = f14;
 HEAPF32[i18 >> 2] = f17;
 i18 = i16 + (i1 << 4) | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f15);
 i22 = i16 + (i1 << 4) + 4 | 0;
 f19 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f19);
 i23 = i16 + (i1 << 4) + 8 | 0;
 f20 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f20);
 i24 = i16 + (i1 << 4) + 12 | 0;
 f21 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f21);
 HEAPF32[i18 >> 2] = f17;
 HEAPF32[i22 >> 2] = f19;
 HEAPF32[i23 >> 2] = f20;
 HEAPF32[i24 >> 2] = f21;
 return;
}

function __ZN8Animator14CreateBindingsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i5 = i9;
 i6 = i8 + 108 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 __ZN8Animator24SetupAnimationClipsCacheEv(i8);
 i2 = HEAP32[i6 >> 2] | 0;
 do if (!i2) i7 = 22; else {
  HEAP32[i5 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i7 = 17; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i2, i5);
    i3 = HEAP32[i4 >> 2] | 0;
    i10 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i7 = 17; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i7 = 19;
  }
  if ((i7 | 0) == 17) i7 = 19;
  if ((i7 | 0) == 19) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
   i7 = 22;
   break;
  }
  if (!i1) {
   STACKTOP = i9;
   return;
  } else {
   i5 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
   __ZN8UserList7AddUserERS_(i1 + 32 | 0, i8 + 480 | 0);
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
   break;
  }
 } while (0);
 if ((i7 | 0) == 22) {
  if (!(__ZNK9HPlayable7IsValidEv(i8 + 628 | 0) | 0)) {
   STACKTOP = i9;
   return;
  }
  i5 = i8 + 604 | 0;
  i6 = i8 + 616 | 0;
  if (!(HEAP32[i6 >> 2] | 0)) __ZN8Animator24SetupAnimationClipsCacheEv(i8);
  i1 = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE(i5, 1, 0, i8 + 112 | 0) | 0;
  i2 = HEAP32[(HEAP32[i8 + 628 >> 2] | 0) + 20 >> 2] | 0;
  i7 = i8 + 480 | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i7 | 0);
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) i5 = 0; else {
   i4 = 0;
   do {
    i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    if (i3) {
     __ZN8UserList7AddUserERS_(i3 + 32 | 0, i7);
     i2 = HEAP32[i6 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i2 >>> 0);
   i5 = 0;
  }
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i10 = i8 + 168 | 0;
 i7 = i8 + 176 | 0;
 __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i10 >> 2] | 0, i7);
 i2 = i8 + 172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i3 = i8 + 124 | 0;
 i4 = i8 + 132 | 0;
 __ZN7mecanim9animation32DeallocateAvatarOuputForBindingsEPNS0_12AvatarOutputERNS_6memory9AllocatorE(HEAP32[i4 >> 2] | 0, i7);
 __ZN8Animator20SetupBindingsDataSetEPKN7mecanim9animation18ControllerConstantEPN11UnityEngine9Animation20AnimationSetBindingsERNS_15BindingsDataSetERNS_13AvatarDataSetE(i8, i5, i1, i10, i3);
 i1 = HEAP32[i8 + 168 >> 2] | 0;
 if (!i1) {
  i10 = i8 + 40 | 0;
  HEAP8[i8 + 76 >> 0] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 20 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i10 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i8 + 40 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i10 + 8 >> 2];
 i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i8 + 56 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 60 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 64 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i8 + 68 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP8[i8 + 72 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
 if (__ZNK8Animator7IsHumanEv(i8) | 0) i1 = 0; else i1 = (HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0) != 0 & 1;
 HEAP8[i8 + 73 >> 0] = i1;
 HEAP8[i8 + 74 >> 0] = (__ZNK8Animator7IsHumanEv(i8) | 0) & 1;
 HEAP8[i8 + 75 >> 0] = HEAP8[(HEAP32[i8 + 128 >> 2] | 0) + 17 >> 0] | 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EEPKN5Unity4TypeEz(i22, i2, i1) {
 i22 = i22 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i24 + 8 | 0;
 i17 = i24;
 i23 = i24 + 32 | 0;
 i7 = i24 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i9 = HEAP32[gb + 1104264 >> 2] | 0;
 i21 = gb + 64016 | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = i17;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 4 >> 2] = i20;
 HEAP32[i23 >> 2] = 0;
 i19 = i23 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i23 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i17);
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i21;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 if (!i2) i2 = 0; else {
  HEAP32[i20 >> 2] = 1;
  i18 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i23 >> 2] = i18;
  HEAP32[i19 >> 2] = 1;
  HEAP32[i18 >> 2] = i2;
  i2 = 1;
 }
 i18 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i7 >> 2] = i18 + 4;
 if (i1) {
  i6 = i2;
  while (1) {
   i2 = i6 + 1 | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i3 = i4 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i20 >> 2] = i3;
     HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i3 << 2, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i18 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
     HEAP32[i20 >> 2] = i3;
     HEAP32[i23 >> 2] = i18;
     break;
    }
   } while (0);
   HEAP32[i19 >> 2] = i2;
   HEAP32[(HEAP32[i23 >> 2] | 0) + (i6 << 2) >> 2] = i1;
   i18 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i1 = HEAP32[i18 >> 2] | 0;
   HEAP32[i7 >> 2] = i18 + 4;
   if (!i1) break; else i6 = i2;
  }
 }
 i16 = i9 + 28 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i17 = i9 + 32 | 0;
 i15 = HEAP32[i17 >> 2] | 0;
 i18 = i1 + (i15 << 3) | 0;
 L16 : do if (!i15) i8 = 17; else {
  i4 = HEAP32[i9 + 20 >> 2] | 0;
  i3 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) do {
   i15 = HEAP32[i1 >> 2] | 0;
   if (!((i4 | 0) == (i15 | 0) | (i3 | 0) == (i15 | 0))) {
    i8 = 17;
    break L16;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i18 | 0)); else do {
   if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i8 = 17;
    break L16;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i18 | 0));
 } while (0);
 L25 : do if ((i8 | 0) == 17) if ((i1 | 0) != (i18 | 0)) {
  i10 = i22 + 12 | 0;
  i11 = i22 + 16 | 0;
  i12 = i22 + 4 | 0;
  i13 = i9 + 20 | 0;
  i14 = i9 + 8 | 0;
  i15 = i9 + 4 | 0;
  i8 = i9 + 12 | 0;
  while (1) {
   L30 : do if (i2 | 0) {
    i7 = i1 + 4 | 0;
    i3 = HEAP32[i23 >> 2] | 0;
    i4 = (HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0) >>> 21;
    i5 = HEAP32[i19 >> 2] | 0;
    i2 = 0;
    while (1) {
     i9 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
     i2 = i2 + 1 | 0;
     if ((i4 - (HEAP32[i9 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i9 + 28 >> 2] | 0) >>> 0) break;
     if (i2 >>> 0 >= i5 >>> 0) break L30;
    }
    i3 = HEAP32[i10 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i11 >> 2] = i2;
      HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
      HEAP32[i11 >> 2] = i2;
      HEAP32[i22 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    HEAP32[(HEAP32[i22 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i7 >> 2];
   } while (0);
   i1 = i1 + 8 | 0;
   L44 : do if ((i1 | 0) == (i18 | 0)) i1 = i18; else {
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((HEAP8[i14 >> 0] | 0) != 0 & (HEAP32[i15 >> 2] | 0) != 0) while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     if (!((i3 | 0) == (i9 | 0) | (i2 | 0) == (i9 | 0))) break L44;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i18;
      break;
     }
    } else while (1) {
     if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L44;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i18;
      break;
     }
    }
   } while (0);
   if ((i1 | 0) == ((HEAP32[i16 >> 2] | 0) + (HEAP32[i17 >> 2] << 3) | 0)) break L25;
   i2 = HEAP32[i19 >> 2] | 0;
  }
 } while (0);
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i21);
 HEAP32[i23 >> 2] = 0;
 STACKTOP = i24;
 return;
}

function __ZN14RenderSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 312 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 320 | 0, i7);
 i1 = i6 + 316 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 344 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 336 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 340 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 28 | 0, i7);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 44 | 0, i7);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 60 | 0, i7);
 i1 = i6 + 184 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 188 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 360 | 0, i7);
 i1 = i6 + 300 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 304 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 308 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 352 | 0, i7);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 348 | 0, i7);
 i1 = i6 + 368 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 372 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 376 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 364 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 392 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 380 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 76 | 0;
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 384 | 0;
  __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 388 | 0;
  __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 392 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i12, i14, i17, i4, i1, i3, i2, i5) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 4 | 0;
 i11 = i18;
 i10 = i3 + 16 | 0;
 i7 = HEAP16[i10 >> 1] | 0;
 if (!i1) i8 = 0; else {
  i8 = __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i1 + 4 >> 2] | 0) | 0;
  i8 = __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(i8, HEAP32[i1 >> 2] | 0) | 0;
 }
 i9 = i12 + 3392 | 0;
 __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv(i9);
 i13 = i17 + 68 | 0;
 HEAP8[i13 >> 0] = 0;
 i16 = i17 + 80 | 0;
 HEAP32[i16 >> 2] = 0;
 i1 = HEAP32[i14 + 8 >> 2] | 0;
 i19 = HEAP16[i4 >> 1] | 0;
 HEAP32[i15 >> 2] = gb + 93128 + 8;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i14;
 HEAP32[i15 + 12 >> 2] = i17;
 HEAP16[i15 + 16 >> 1] = i19;
 HEAP32[i15 + 20 >> 2] = i3;
 HEAP32[i15 + 24 >> 2] = i2;
 i4 = i15 + 28 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i5;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP8[i15 + 68 >> 0] = 0;
 HEAP32[i15 + 72 >> 2] = 0;
 i2 = i15 + 41 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = (i7 & 65535) >>> 4 & 1;
 HEAP8[i15 + 39 >> 0] = i1;
 HEAP8[i15 + 40 >> 0] = i19 & 64 ? 1 : i1;
 i1 = HEAP16[i10 >> 1] | 0;
 i7 = (i1 & 65535) >>> 5 & 1;
 HEAP8[i15 + 38 >> 0] = i7;
 HEAP8[i15 + 37 >> 0] = i7;
 do if (!i8) i5 = 9; else if (!(HEAP32[i17 + 76 >> 2] | 0)) {
  i19 = __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE(i9, __ZN5physx2Sq8populateEPKNS0_10ActorShapeE(i8) | 0) | 0;
  HEAP8[i2 >> 0] = 1;
  i19 = __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i15, i11, i19, 1) | 0;
  HEAP8[i2 >> 0] = 0;
  if (i19) {
   i1 = HEAP16[i10 >> 1] | 0;
   i5 = 9;
   break;
  }
  i1 = HEAP8[i13 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i3 = (HEAP32[i16 >> 2] | 0) != 0;
   i2 = 0;
   i5 = 16;
  } else {
   i3 = 1;
   i2 = i1;
   i5 = 16;
  }
 } else i5 = 9; while (0);
 do if ((i5 | 0) == 9) {
  i3 = HEAP32[i12 + 3404 >> 2] | 0;
  i2 = HEAP32[i12 + 3408 >> 2] | 0;
  i19 = i1 & 65535;
  i1 = i19 & 2;
  if (i19 & 1 | 0) if (!(mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i4 | 0, i15 | 0) | 0)) {
   i1 = HEAP8[i13 >> 0] | 0;
   if (i1 << 24 >> 24) {
    i3 = 1;
    i2 = i1;
    i5 = 16;
    break;
   }
   i3 = (HEAP32[i16 >> 2] | 0) != 0;
   i2 = 0;
   i5 = 16;
   break;
  }
  if (!i1) i4 = 0; else i4 = (mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i4 | 0, i15 | 0) | 0) ^ 1;
  i2 = HEAP8[i13 >> 0] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
  i3 = i2 << 24 >> 24 != 0 | (i1 | 0) != 0;
  if (i4) {
   i19 = i3;
   i16 = HEAP32[i17 >> 2] | 0;
   i16 = i16 + 4 | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   mftCall_vi(i16 | 0, i17 | 0);
   STACKTOP = i18;
   return i19 | 0;
  }
 } while (0);
 if ((i5 | 0) == 16) i1 = HEAP32[i16 >> 2] | 0;
 if (i2 << 24 >> 24) {
  if (!i1) {
   i19 = i3;
   i16 = HEAP32[i17 >> 2] | 0;
   i16 = i16 + 4 | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   mftCall_vi(i16 | 0, i17 | 0);
   STACKTOP = i18;
   return i19 | 0;
  }
  i5 = HEAP32[i17 + 72 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i17 + 4 + 40 >> 2]);
  i7 = 0;
  i2 = i1;
  do {
   i4 = i5 + (i7 << 6) + 40 | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) > f6) {
    i2 = i2 + -1 | 0;
    i9 = HEAP16[i5 + (i2 << 6) + 12 >> 1] | 0;
    i10 = HEAP32[i5 + (i2 << 6) + 16 >> 2] | 0;
    i11 = HEAP32[i5 + (i2 << 6) + 20 >> 2] | 0;
    i12 = HEAP32[i5 + (i2 << 6) + 24 >> 2] | 0;
    i13 = HEAP32[i5 + (i2 << 6) + 28 >> 2] | 0;
    i14 = HEAP32[i5 + (i2 << 6) + 32 >> 2] | 0;
    i15 = HEAP32[i5 + (i2 << 6) + 36 >> 2] | 0;
    i19 = HEAP32[i5 + (i2 << 6) + 40 >> 2] | 0;
    _memmove(i5 + (i7 << 6) | 0, i5 + (i2 << 6) | 0, 12) | 0;
    HEAP16[i5 + (i7 << 6) + 12 >> 1] = i9;
    HEAP32[i5 + (i7 << 6) + 16 >> 2] = i10;
    HEAP32[i5 + (i7 << 6) + 20 >> 2] = i11;
    HEAP32[i5 + (i7 << 6) + 24 >> 2] = i12;
    HEAP32[i5 + (i7 << 6) + 28 >> 2] = i13;
    HEAP32[i5 + (i7 << 6) + 32 >> 2] = i14;
    HEAP32[i5 + (i7 << 6) + 36 >> 2] = i15;
    HEAP32[i4 >> 2] = i19;
    _memmove(i5 + (i7 << 6) + 44 | 0, i5 + (i2 << 6) + 44 | 0, 20) | 0;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
  i1 = i2;
  HEAP32[i16 >> 2] = i1;
 }
 if (!i1) {
  i19 = i3;
  i16 = HEAP32[i17 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vi(i16 | 0, i17 | 0);
  STACKTOP = i18;
  return i19 | 0;
 }
 if (!(mftCall_iiii(HEAP32[HEAP32[i17 >> 2] >> 2] | 0, i17 | 0, HEAP32[i17 + 72 >> 2] | 0, i1 | 0) | 0)) {
  i19 = i3;
  i16 = HEAP32[i17 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vi(i16 | 0, i17 | 0);
  STACKTOP = i18;
  return i19 | 0;
 }
 HEAP32[i16 >> 2] = 0;
 i19 = i3;
 i16 = HEAP32[i17 >> 2] | 0;
 i16 = i16 + 4 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vi(i16 | 0, i17 | 0);
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx17collideWithSphereERNS_19PxsParticleCollDataERKNS_16PxSphereGeometryEf(i21, i1, f19) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 f19 = Math_fround(f19);
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f20 = f0;
 f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i21 + 112 >> 2]);
 f9 = Math_fround(f14 * f14);
 f15 = Math_fround(HEAPF32[i21 + 116 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f15 * f15));
 f13 = Math_fround(HEAPF32[i21 + 120 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f13 * f13));
 f2 = Math_fround(f20 * f20);
 if (f9 < f2) {
  i1 = i21 + 144 | 0;
  HEAPF32[i1 >> 2] = f14;
  i5 = i21 + 148 | 0;
  HEAPF32[i5 >> 2] = f15;
  i6 = i21 + 152 | 0;
  HEAPF32[i6 >> 2] = f13;
  if (f9 > Math_fround(0.0)) {
   f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9))));
   f2 = Math_fround(f4 * f14);
   HEAPF32[i1 >> 2] = f2;
   f3 = Math_fround(f4 * f15);
   HEAPF32[i5 >> 2] = f3;
   f4 = Math_fround(f4 * f13);
   HEAPF32[i6 >> 2] = f4;
  } else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 1065353216;
   HEAP32[i6 >> 2] = 0;
   f2 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f4 = Math_fround(0.0);
  }
  f18 = Math_fround(f20 + Math_fround(HEAPF32[i21 + 92 >> 2]));
  f19 = Math_fround(f18 * f3);
  f20 = Math_fround(f18 * f4);
  HEAPF32[i21 + 160 >> 2] = Math_fround(f2 * f18);
  HEAPF32[i21 + 164 >> 2] = f19;
  HEAPF32[i21 + 168 >> 2] = f20;
  HEAPF32[i21 + 44 >> 2] = Math_fround(0.0);
  i21 = i21 + 124 | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 8;
  return;
 }
 f16 = Math_fround(HEAPF32[i21 + 128 >> 2]);
 f10 = Math_fround(f16 - f14);
 f17 = Math_fround(HEAPF32[i21 + 132 >> 2]);
 f11 = Math_fround(f17 - f15);
 f18 = Math_fround(HEAPF32[i21 + 136 >> 2]);
 f12 = Math_fround(f18 - f13);
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(f15 * f11)) + Math_fround(f13 * f12)) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f12 * f12)) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f3 * f3) - Math_fround(Math_fround(f9 - f2) * Math_fround(f4 * Math_fround(2.0))));
 if (f4 == Math_fround(0.0) | !(f2 > Math_fround(0.0))) {
  i7 = i21 + 124 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i8 & 2 | 0) return;
  f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
  i1 = i21 + 144 | 0;
  HEAPF32[i1 >> 2] = f16;
  i5 = i21 + 148 | 0;
  HEAPF32[i5 >> 2] = f17;
  i6 = i21 + 152 | 0;
  HEAPF32[i6 >> 2] = f18;
  if (!(f9 < Math_fround(f20 + f19))) return;
  if (f9 != Math_fround(0.0)) {
   f4 = Math_fround(Math_fround(1.0) / f9);
   f2 = Math_fround(f16 * f4);
   HEAPF32[i1 >> 2] = f2;
   f3 = Math_fround(f17 * f4);
   HEAPF32[i5 >> 2] = f3;
   f4 = Math_fround(f18 * f4);
   HEAPF32[i6 >> 2] = f4;
  } else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
  }
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i21 + 92 >> 2]));
  f18 = Math_fround(f3 * f20);
  f19 = Math_fround(f4 * f20);
  HEAPF32[i21 + 160 >> 2] = Math_fround(f2 * f20);
  HEAPF32[i21 + 164 >> 2] = f18;
  HEAPF32[i21 + 168 >> 2] = f19;
  HEAP32[i7 >> 2] = i8 | 32;
  if (!(f9 < f20)) return;
  HEAP32[i7 >> 2] = i8 | 48;
  return;
 }
 f2 = Math_fround(Math_fround(-Math_fround(f3 + Math_fround(Math_sqrt(Math_fround(f2))))) / f4);
 if (!(f2 < Math_fround(0.0) | f2 > Math_fround(1.0))) {
  i1 = i21 + 44 | 0;
  if (!(f2 < Math_fround(HEAPF32[i1 >> 2]))) return;
  f18 = Math_fround(f15 + Math_fround(f11 * f2));
  f19 = Math_fround(f13 + Math_fround(f12 * f2));
  f20 = Math_fround(Math_fround(1.0) / f20);
  HEAPF32[i21 + 144 >> 2] = Math_fround(f20 * Math_fround(f14 + Math_fround(f10 * f2)));
  HEAPF32[i21 + 148 >> 2] = Math_fround(f20 * f18);
  HEAPF32[i21 + 152 >> 2] = Math_fround(f20 * f19);
  HEAPF32[i21 + 160 >> 2] = f14;
  HEAPF32[i21 + 164 >> 2] = f15;
  HEAPF32[i21 + 168 >> 2] = f13;
  HEAPF32[i1 >> 2] = f2;
  i21 = i21 + 124 | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 8;
  return;
 }
 i7 = i21 + 124 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i8 & 2 | 0) return;
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
 i1 = i21 + 144 | 0;
 HEAPF32[i1 >> 2] = f16;
 i5 = i21 + 148 | 0;
 HEAPF32[i5 >> 2] = f17;
 i6 = i21 + 152 | 0;
 HEAPF32[i6 >> 2] = f18;
 if (!(f9 < Math_fround(f20 + f19))) return;
 if (f9 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(1.0) / f9);
  f2 = Math_fround(f16 * f4);
  HEAPF32[i1 >> 2] = f2;
  f3 = Math_fround(f17 * f4);
  HEAPF32[i5 >> 2] = f3;
  f4 = Math_fround(f18 * f4);
  HEAPF32[i6 >> 2] = f4;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i21 + 92 >> 2]));
 f18 = Math_fround(f3 * f20);
 f19 = Math_fround(f4 * f20);
 HEAPF32[i21 + 160 >> 2] = Math_fround(f2 * f20);
 HEAPF32[i21 + 164 >> 2] = f18;
 HEAPF32[i21 + 168 >> 2] = f19;
 HEAP32[i7 >> 2] = i8 | 32;
 if (!(f9 < f20)) return;
 HEAP32[i7 >> 2] = i8 | 48;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function runPostSets69() {
 HEAP32[gb + 76752 >> 2] = fb + 178;
 HEAP32[gb + 76756 >> 2] = fb + 295;
 HEAP32[gb + 76760 >> 2] = fb + 3;
 HEAP32[gb + 76764 >> 2] = fb + 396;
 HEAP32[gb + 76768 >> 2] = fb + 699;
 HEAP32[gb + 76772 >> 2] = fb + 700;
 HEAP32[gb + 76776 >> 2] = fb + 53;
 HEAP32[gb + 76780 >> 2] = fb + 175;
 HEAP32[gb + 76784 >> 2] = fb + 397;
 HEAP32[gb + 76788 >> 2] = fb + 849;
 HEAP32[gb + 76792 >> 2] = fb + 176;
 HEAP32[gb + 76796 >> 2] = fb + 177;
 HEAP32[gb + 76800 >> 2] = fb + 701;
 HEAP32[gb + 76812 >> 2] = fb + 6;
 HEAP32[gb + 76816 >> 2] = fb + 7;
 HEAP32[gb + 76820 >> 2] = fb + 8;
 HEAP32[gb + 76824 >> 2] = fb + 9;
 HEAP32[gb + 76832 >> 2] = fb + 10;
 HEAP32[gb + 76836 >> 2] = fb + 11;
 HEAP32[gb + 76840 >> 2] = fb + 12;
 HEAP32[gb + 76848 >> 2] = fb + 13;
 HEAP32[gb + 76852 >> 2] = fb + 14;
 HEAP32[gb + 76856 >> 2] = fb + 15;
 HEAP32[gb + 76864 >> 2] = fb + 16;
 HEAP32[gb + 76868 >> 2] = fb + 17;
 HEAP32[gb + 76872 >> 2] = fb + 18;
 HEAP32[gb + 76876 >> 2] = fb + 19;
 HEAP32[gb + 76880 >> 2] = fb + 20;
 HEAP32[gb + 76884 >> 2] = fb + 21;
 HEAP32[gb + 76888 >> 2] = fb + 22;
 HEAP32[gb + 76892 >> 2] = fb + 23;
 HEAP32[gb + 76896 >> 2] = fb + 24;
 HEAP32[gb + 76900 >> 2] = fb + 25;
 HEAP32[gb + 76904 >> 2] = fb + 26;
 HEAP32[gb + 76916 >> 2] = fb + 398;
 HEAP32[gb + 76920 >> 2] = fb + 850;
 HEAP32[gb + 76924 >> 2] = fb + 851;
 HEAP32[gb + 76936 >> 2] = fb + 852;
 HEAP32[gb + 76940 >> 2] = fb + 853;
 HEAP32[gb + 76944 >> 2] = fb + 399;
 HEAP32[gb + 76948 >> 2] = fb + 854;
 HEAP32[gb + 76960 >> 2] = fb + 855;
 HEAP32[gb + 76964 >> 2] = fb + 856;
 HEAP32[gb + 76968 >> 2] = fb + 399;
 HEAP32[gb + 76972 >> 2] = fb + 854;
 HEAP32[gb + 76984 >> 2] = fb + 306;
 HEAP32[gb + 76988 >> 2] = fb + 857;
 HEAP32[gb + 76992 >> 2] = fb + 65;
 HEAP32[gb + 76996 >> 2] = fb + 178;
 HEAP32[gb + 77e3 >> 2] = fb + 702;
 HEAP32[gb + 77012 >> 2] = fb + 858;
 HEAP32[gb + 77016 >> 2] = fb + 859;
 HEAP32[gb + 77028 >> 2] = fb + 860;
 HEAP32[gb + 77032 >> 2] = fb + 861;
 HEAP32[gb + 77036 >> 2] = fb + 179;
 HEAP32[gb + 77040 >> 2] = fb + 77;
 HEAP32[gb + 77044 >> 2] = (HEAP32[gb + 77044 >> 2] | 0) + (gb + 604961 | 0);
 HEAP32[gb + 77052 >> 2] = (HEAP32[gb + 77052 >> 2] | 0) + (gb + 604973 | 0);
 HEAP32[gb + 77060 >> 2] = (HEAP32[gb + 77060 >> 2] | 0) + (gb + 604986 | 0);
 HEAP32[gb + 77068 >> 2] = (HEAP32[gb + 77068 >> 2] | 0) + (gb + 605007 | 0);
 HEAP32[gb + 77076 >> 2] = (HEAP32[gb + 77076 >> 2] | 0) + (gb + 605027 | 0);
 HEAP32[gb + 77084 >> 2] = (HEAP32[gb + 77084 >> 2] | 0) + (gb + 605039 | 0);
 HEAP32[gb + 77092 >> 2] = (HEAP32[gb + 77092 >> 2] | 0) + (gb + 605050 | 0);
 HEAP32[gb + 77100 >> 2] = (HEAP32[gb + 77100 >> 2] | 0) + (gb + 605061 | 0);
 HEAP32[gb + 77108 >> 2] = (HEAP32[gb + 77108 >> 2] | 0) + (gb + 605071 | 0);
 HEAP32[gb + 77116 >> 2] = (HEAP32[gb + 77116 >> 2] | 0) + (gb + 605091 | 0);
 HEAP32[gb + 77124 >> 2] = (HEAP32[gb + 77124 >> 2] | 0) + (gb + 605104 | 0);
 HEAP32[gb + 77132 >> 2] = (HEAP32[gb + 77132 >> 2] | 0) + (gb + 605124 | 0);
 HEAP32[gb + 77140 >> 2] = (HEAP32[gb + 77140 >> 2] | 0) + (gb + 605137 | 0);
 HEAP32[gb + 77148 >> 2] = (HEAP32[gb + 77148 >> 2] | 0) + (gb + 605157 | 0);
 HEAP32[gb + 77156 >> 2] = (HEAP32[gb + 77156 >> 2] | 0) + (gb + 605170 | 0);
 HEAP32[gb + 77164 >> 2] = (HEAP32[gb + 77164 >> 2] | 0) + (gb + 605190 | 0);
 HEAP32[gb + 77172 >> 2] = (HEAP32[gb + 77172 >> 2] | 0) + (gb + 605203 | 0);
 HEAP32[gb + 77180 >> 2] = (HEAP32[gb + 77180 >> 2] | 0) + (gb + 605216 | 0);
 HEAP32[gb + 77224 >> 2] = (HEAP32[gb + 77224 >> 2] | 0) + (gb + 609072 | 0);
 HEAP32[gb + 77228 >> 2] = (HEAP32[gb + 77228 >> 2] | 0) + (gb + 609081 | 0);
 HEAP32[gb + 77232 >> 2] = (HEAP32[gb + 77232 >> 2] | 0) + (gb + 609090 | 0);
 HEAP32[gb + 77236 >> 2] = (HEAP32[gb + 77236 >> 2] | 0) + (gb + 609099 | 0);
 HEAP32[gb + 77240 >> 2] = (HEAP32[gb + 77240 >> 2] | 0) + (gb + 609108 | 0);
 HEAP32[gb + 77244 >> 2] = (HEAP32[gb + 77244 >> 2] | 0) + (gb + 609117 | 0);
 HEAP32[gb + 77248 >> 2] = (HEAP32[gb + 77248 >> 2] | 0) + (gb + 609129 | 0);
 HEAP32[gb + 77252 >> 2] = (HEAP32[gb + 77252 >> 2] | 0) + (gb + 609143 | 0);
 HEAP32[gb + 77256 >> 2] = (HEAP32[gb + 77256 >> 2] | 0) + (gb + 609151 | 0);
 HEAP32[gb + 77260 >> 2] = (HEAP32[gb + 77260 >> 2] | 0) + (gb + 609159 | 0);
 HEAP32[gb + 77264 >> 2] = (HEAP32[gb + 77264 >> 2] | 0) + (gb + 609174 | 0);
 HEAP32[gb + 77268 >> 2] = (HEAP32[gb + 77268 >> 2] | 0) + (gb + 609187 | 0);
 HEAP32[gb + 77272 >> 2] = (HEAP32[gb + 77272 >> 2] | 0) + (gb + 609198 | 0);
 HEAP32[gb + 77276 >> 2] = (HEAP32[gb + 77276 >> 2] | 0) + (gb + 609205 | 0);
 HEAP32[gb + 77280 >> 2] = (HEAP32[gb + 77280 >> 2] | 0) + (gb + 609212 | 0);
 HEAP32[gb + 77284 >> 2] = (HEAP32[gb + 77284 >> 2] | 0) + (gb + 609220 | 0);
 HEAP32[gb + 77288 >> 2] = (HEAP32[gb + 77288 >> 2] | 0) + (gb + 609233 | 0);
 HEAP32[gb + 77292 >> 2] = (HEAP32[gb + 77292 >> 2] | 0) + (gb + 609239 | 0);
 HEAP32[gb + 77296 >> 2] = (HEAP32[gb + 77296 >> 2] | 0) + (gb + 609258 | 0);
 HEAP32[gb + 77300 >> 2] = (HEAP32[gb + 77300 >> 2] | 0) + (gb + 609266 | 0);
 HEAP32[gb + 77304 >> 2] = (HEAP32[gb + 77304 >> 2] | 0) + (gb + 609274 | 0);
 HEAP32[gb + 77308 >> 2] = (HEAP32[gb + 77308 >> 2] | 0) + (gb + 609287 | 0);
 HEAP32[gb + 77320 >> 2] = fb + 862;
 HEAP32[gb + 77324 >> 2] = fb + 863;
 HEAP32[gb + 77328 >> 2] = fb + 864;
 HEAP32[gb + 77332 >> 2] = fb + 179;
 runPostSets70();
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx23collideWithConvexPlanesERNS_19PxsParticleCollDataEPKNS_7PxPlaneEjf(i21, i22, i13, f14) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f23 = f0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, f30 = f0;
 f18 = Math_fround(HEAPF32[i21 + 128 >> 2]);
 f16 = Math_fround(HEAPF32[i21 + 112 >> 2]);
 f11 = Math_fround(f18 - f16);
 f20 = Math_fround(HEAPF32[i21 + 132 >> 2]);
 f17 = Math_fround(HEAPF32[i21 + 116 >> 2]);
 f12 = Math_fround(f20 - f17);
 f19 = Math_fround(HEAPF32[i21 + 136 >> 2]);
 f15 = Math_fround(HEAPF32[i21 + 120 >> 2]);
 f10 = Math_fround(f19 - f15);
 if (!i13) {
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  i3 = 0;
  i9 = 0;
  f6 = Math_fround(-3402823469999999843913219.0e14);
  i1 = 0;
  i2 = 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i9 = 0;
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  i3 = 0;
  i8 = 0;
  f6 = Math_fround(-3402823469999999843913219.0e14);
  i1 = 0;
  i2 = 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
  do {
   f29 = Math_fround(HEAPF32[i22 + (i9 << 4) >> 2]);
   f30 = Math_fround(f18 * f29);
   f28 = Math_fround(HEAPF32[i22 + (i9 << 4) + 4 >> 2]);
   f30 = Math_fround(f30 + Math_fround(f20 * f28));
   f26 = Math_fround(HEAPF32[i22 + (i9 << 4) + 8 >> 2]);
   f30 = Math_fround(f30 + Math_fround(f19 * f26));
   f23 = Math_fround(HEAPF32[i22 + (i9 << 4) + 12 >> 2]);
   f30 = Math_fround(f23 + f30);
   f23 = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f29 * f16) + Math_fround(f28 * f17)) + Math_fround(f26 * f15)));
   i24 = f7 > Math_fround(0.0);
   i25 = f23 > f6;
   f6 = i25 ? f23 : f6;
   i1 = i25 ? i9 : i1;
   i25 = f30 > f7;
   f7 = i25 ? f30 : f7;
   i8 = i25 ? i9 : i8;
   i25 = f30 > Math_fround(0.0);
   i3 = i3 | i24 & i25;
   f26 = Math_fround(Math_fround(Math_fround(f11 * f29) + Math_fround(f12 * f28)) + Math_fround(f10 * f26));
   f23 = Math_fround(Math_fround(-f23) / f26);
   i24 = f23 > f5 & f26 < Math_fround(0.0);
   i27 = f23 < f4 & f26 > Math_fround(0.0);
   i2 = i24 ? i9 : i2;
   f4 = i27 ? f23 : f4;
   i25 = i25 & f26 == Math_fround(0.0);
   f5 = i25 ? Math_fround(3402823469999999843913219.0e14) : i24 ? f23 : f5;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i13 | 0));
  f10 = f7;
  i9 = i8;
 }
 i27 = !(f6 <= Math_fround(0.0));
 f7 = Math_fround(HEAPF32[i21 + 92 >> 2]);
 i8 = !(f10 <= f7);
 i3 = !(f10 > Math_fround(0.0)) | !(f10 <= f14) | i3;
 if (!i27) {
  i24 = i21 + 124 | 0;
  HEAP32[i24 >> 2] = HEAP32[i24 >> 2] | 8;
  HEAPF32[i21 + 44 >> 2] = Math_fround(0.0);
  i24 = i22 + (i1 << 4) | 0;
  HEAP32[i21 + 144 >> 2] = HEAP32[i24 >> 2];
  i25 = i22 + (i1 << 4) + 4 | 0;
  HEAP32[i21 + 148 >> 2] = HEAP32[i25 >> 2];
  i27 = i22 + (i1 << 4) + 8 | 0;
  HEAP32[i21 + 152 >> 2] = HEAP32[i27 >> 2];
  f30 = Math_fround(f7 - f6);
  f28 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f30);
  f29 = Math_fround(f30 * Math_fround(HEAPF32[i25 >> 2]));
  f29 = Math_fround(f29 + f17);
  f30 = Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i27 >> 2])) + f15);
  HEAPF32[i21 + 160 >> 2] = Math_fround(f28 + f16);
  HEAPF32[i21 + 164 >> 2] = f29;
  HEAPF32[i21 + 168 >> 2] = f30;
  return;
 }
 if (f5 >= Math_fround(0.0)) {
  i1 = i21 + 44 | 0;
  if (f5 <= f4 ? f5 < Math_fround(HEAPF32[i1 >> 2]) : 0) {
   HEAP32[i21 + 144 >> 2] = HEAP32[i22 + (i2 << 4) >> 2];
   HEAP32[i21 + 148 >> 2] = HEAP32[i22 + (i2 << 4) + 4 >> 2];
   HEAP32[i21 + 152 >> 2] = HEAP32[i22 + (i2 << 4) + 8 >> 2];
   HEAPF32[i21 + 160 >> 2] = f16;
   HEAPF32[i21 + 164 >> 2] = f17;
   HEAPF32[i21 + 168 >> 2] = f15;
   HEAPF32[i1 >> 2] = f5;
   i27 = i21 + 124 | 0;
   HEAP32[i27 >> 2] = HEAP32[i27 >> 2] | 8;
   return;
  }
 }
 i2 = i21 + 124 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 2 | 0) return;
 if (!i3) {
  i24 = i22 + (i9 << 4) | 0;
  HEAP32[i21 + 144 >> 2] = HEAP32[i24 >> 2];
  i25 = i22 + (i9 << 4) + 4 | 0;
  HEAP32[i21 + 148 >> 2] = HEAP32[i25 >> 2];
  i27 = i22 + (i9 << 4) + 8 | 0;
  HEAP32[i21 + 152 >> 2] = HEAP32[i27 >> 2];
  f30 = Math_fround(f7 - f10);
  f28 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f30);
  f29 = Math_fround(f30 * Math_fround(HEAPF32[i25 >> 2]));
  f29 = Math_fround(f29 + f20);
  f30 = Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i27 >> 2])) + f19);
  HEAPF32[i21 + 160 >> 2] = Math_fround(f28 + f18);
  HEAPF32[i21 + 164 >> 2] = f29;
  HEAPF32[i21 + 168 >> 2] = f30;
  i1 = i1 | 32;
  HEAP32[i2 >> 2] = i1;
 }
 if (i8) return;
 i24 = i22 + (i9 << 4) | 0;
 HEAP32[i21 + 144 >> 2] = HEAP32[i24 >> 2];
 i25 = i22 + (i9 << 4) + 4 | 0;
 HEAP32[i21 + 148 >> 2] = HEAP32[i25 >> 2];
 i27 = i22 + (i9 << 4) + 8 | 0;
 HEAP32[i21 + 152 >> 2] = HEAP32[i27 >> 2];
 f30 = Math_fround(f7 - f10);
 f28 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f30);
 f29 = Math_fround(f30 * Math_fround(HEAPF32[i25 >> 2]));
 f29 = Math_fround(f29 + f20);
 f30 = Math_fround(Math_fround(f30 * Math_fround(HEAPF32[i27 >> 2])) + f19);
 HEAPF32[i21 + 160 >> 2] = Math_fround(f28 + f18);
 HEAPF32[i21 + 164 >> 2] = f29;
 HEAPF32[i21 + 168 >> 2] = f30;
 HEAP32[i2 >> 2] = i1 | 16;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      HEAP32[i2 + 16 >> 2] = 0;
      HEAP32[i2 + 20 >> 2] = 0;
      HEAP32[i2 + 24 >> 2] = 0;
      HEAP32[i2 + 28 >> 2] = 0;
      HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
      HEAP8[i2 + 36 >> 0] = 0;
      HEAP8[i2 + 37 >> 0] = 0;
      HEAP32[i2 + 40 >> 2] = 0;
      HEAP8[i2 + 44 >> 0] = 1;
      HEAP8[i2 + 45 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903185 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine18TransitionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP32[i2 + 12 >> 2] = 0;
       HEAP32[i2 + 16 >> 2] = 0;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i2 + 24 >> 2] = 0;
       HEAP32[i2 + 28 >> 2] = 0;
       HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
       HEAP8[i2 + 36 >> 0] = 0;
       HEAP8[i2 + 37 >> 0] = 0;
       HEAP32[i2 + 40 >> 2] = 0;
       HEAP8[i2 + 44 >> 0] = 1;
       HEAP8[i2 + 45 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903185 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine18TransitionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function ___cxa_demangle(i10, i1, i13, i16) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 4208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 4176 | 0;
 i3 = i18;
 i17 = i18 + 4112 | 0;
 L1 : do if (!i10) i19 = 3; else {
  i2 = (i1 | 0) != 0;
  i15 = (i13 | 0) == 0;
  if (i2 & i15) i19 = 3; else {
   if (i2) i11 = HEAP32[i13 >> 2] | 0; else i11 = 0;
   HEAP32[i3 + 4096 >> 2] = i3;
   i2 = i3;
   HEAP32[i17 >> 2] = 0;
   i12 = i17 + 4 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i17 + 8 >> 2] = 0;
   HEAP32[i17 + 12 >> 2] = i2;
   i6 = i17 + 16 | 0;
   HEAP32[i6 >> 2] = 0;
   i7 = i17 + 20 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i17 + 24 >> 2] = 0;
   HEAP32[i17 + 28 >> 2] = i2;
   HEAP32[i17 + 32 >> 2] = 0;
   i4 = i17 + 36 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i17 + 40 >> 2] = 0;
   i8 = i17 + 44 | 0;
   HEAP32[i8 >> 2] = i2;
   i3 = i17 + 48 | 0;
   i5 = i17 + 61 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP8[i3 + 12 >> 0] = 0;
   HEAP8[i5 >> 0] = 1;
   i3 = i17 + 32 | 0;
   __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEEC2EjjSB_(i14, 1, 0, i8);
   i8 = i14 + 8 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = i2;
   HEAP32[i8 >> 2] = i9 + 16;
   __ZNSt3__26vectorINS0_INS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEEENS4_IS8_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS8_RS9_EE(i3, i14);
   __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEED2Ev(i14);
   i8 = i17 + 62 | 0;
   HEAP8[i8 >> 0] = 0;
   HEAP8[i17 + 63 >> 0] = 1;
   HEAP32[i14 >> 2] = 0;
   i9 = i10 + (_strlen(i10) | 0) | 0;
   __THREW__ = 0;
   invoke_viiii(fb + 364 | 0, i10 | 0, i9 | 0, i17 | 0, i14 | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   L7 : do if (i2 & 1) i19 = 21; else {
    i2 = HEAP32[i14 >> 2] | 0;
    do if ((i2 | 0) != 0 | (HEAP8[i8 >> 0] | 0) == 0) i19 = 22; else {
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) i19 = 23; else if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) i19 = 23; else {
      HEAP8[i8 >> 0] = 0;
      HEAP8[i5 >> 0] = 0;
      i2 = HEAP32[i17 >> 2] | 0;
      while (1) {
       i3 = HEAP32[i12 >> 2] | 0;
       if ((i3 | 0) == (i2 | 0)) break;
       i5 = i3 + -24 | 0;
       HEAP32[i12 >> 2] = i5;
       __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i5);
      }
      i2 = HEAP32[i6 >> 2] | 0;
      while (1) {
       i3 = HEAP32[i7 >> 2] | 0;
       if ((i3 | 0) == (i2 | 0)) break;
       i6 = i3 + -16 | 0;
       HEAP32[i7 >> 2] = i6;
       __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i6);
      }
      __THREW__ = 0;
      invoke_viiii(fb + 364 | 0, i10 | 0, i9 | 0, i17 | 0, i14 | 0);
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i19 = 21;
       break L7;
      }
      if (!(HEAP8[i8 >> 0] | 0)) {
       i2 = HEAP32[i14 >> 2] | 0;
       i19 = 22;
       break;
      } else {
       HEAP32[i14 >> 2] = -2;
       i1 = 0;
       i2 = -2;
       break;
      }
     }
    } while (0);
    if ((i19 | 0) == 22) if (!i2) i19 = 23; else i1 = 0;
    do if ((i19 | 0) == 23) {
     i3 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP8[i3 + -24 + 11 >> 0] | 0;
     if (i2 << 24 >> 24 < 0) i4 = HEAP32[i3 + -20 >> 2] | 0; else i4 = i2 & 255;
     i2 = HEAP8[i3 + -12 + 11 >> 0] | 0;
     if (i2 << 24 >> 24 < 0) i2 = HEAP32[i3 + -8 >> 2] | 0; else i2 = i2 & 255;
     i3 = i2 + i4 | 0;
     i2 = i3 + 1 | 0;
     if (i2 >>> 0 > i11 >>> 0) {
      i1 = _realloc(i1, i2) | 0;
      if (!i1) {
       HEAP32[i14 >> 2] = -1;
       i1 = 0;
       i2 = -1;
       break;
      }
      if (!i15) HEAP32[i13 >> 2] = i2;
     } else if (!i1) {
      i1 = 0;
      i2 = 0;
      break;
     }
     i14 = HEAP32[i12 >> 2] | 0;
     i11 = i14 + -12 | 0;
     i15 = HEAP8[i11 + 11 >> 0] | 0;
     i13 = i15 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i14 + -24 | 0, (i13 ? HEAP32[i11 >> 2] | 0 : i11) | 0, (i13 ? HEAP32[i14 + -8 >> 2] | 0 : i15 & 255) | 0) | 0;
     i15 = __THREW__;
     __THREW__ = 0;
     if (i15 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break L7;
     }
     i2 = (HEAP32[i12 >> 2] | 0) + -24 | 0;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
     _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
     HEAP8[i1 + i3 >> 0] = 0;
     i2 = 0;
    } while (0);
    if (i16 | 0) HEAP32[i16 >> 2] = i2;
    __ZN10__cxxabiv112_GLOBAL__N_12DbD2Ev(i17);
    break L1;
   } while (0);
   if ((i19 | 0) == 21) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   __ZN10__cxxabiv112_GLOBAL__N_12DbD2Ev(i17);
   ___resumeException(i1 | 0);
  }
 } while (0);
 if ((i19 | 0) == 3) if (!i16) i1 = 0; else {
  HEAP32[i16 >> 2] = -3;
  i1 = 0;
 }
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i20, i11, f21) {
 i20 = i20 | 0;
 i11 = i11 | 0;
 f21 = Math_fround(f21);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i23;
 i13 = HEAP32[i11 + 68 >> 2] | 0;
 if ((i13 | 0) > 3) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 if ((i13 | 0) >= 2) {
  i1 = HEAP32[i11 + 56 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  i19 = f17 < Math_fround(0.0);
  f16 = Math_fround(-f17);
  if (!((i19 ? f16 : f17) <= Math_fround(.0000999999974))) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  f17 = Math_fround(Math_fround(HEAPF32[i1 + (i13 + -1 << 4) >> 2]) + Math_fround(-1.0));
  i19 = f17 < Math_fround(0.0);
  f16 = Math_fround(-f17);
  if (!((i19 ? f16 : f17) <= Math_fround(.0000999999974))) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 i19 = i20 + 32 | 0;
 HEAPF32[i19 >> 2] = Math_fround(1.0);
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAP32[i20 + 24 >> 2] = 0;
 HEAP32[i20 + 28 >> 2] = 0;
 switch (i13 | 0) {
 case 1:
  {
   f21 = Math_fround(Math_fround(HEAPF32[(HEAP32[i11 + 56 >> 2] | 0) + 4 >> 2]) * f21);
   HEAPF32[i20 + 12 >> 2] = f21;
   HEAPF32[i20 + 28 >> 2] = f21;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 case 0:
  {
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 default:
  {
   i5 = i12 + 4 | 0;
   i6 = i12 + 8 | 0;
   i7 = i12 + 12 | 0;
   i8 = i12 + 16 | 0;
   i9 = i12 + 20 | 0;
   i10 = i12 + 24 | 0;
   i18 = i11 + 56 | 0;
   if (i13 >>> 0 > 1) {
    HEAPF32[i5 >> 2] = Math_fround(inf);
    HEAP32[i12 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i11, i12, 0, 1, Math_fround(0.0));
    i4 = HEAP32[i7 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP32[i20 >> 2] = i4;
    HEAP32[i20 + 4 >> 2] = i3;
    HEAP32[i20 + 8 >> 2] = i2;
    HEAP32[i20 + 12 >> 2] = i1;
    if ((i13 | 0) == 2) i22 = 11; else {
     HEAPF32[i5 >> 2] = Math_fround(inf);
     HEAP32[i12 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP32[i6 + 4 >> 2] = 0;
     HEAP32[i6 + 8 >> 2] = 0;
     HEAP32[i6 + 12 >> 2] = 0;
     HEAP32[i6 + 16 >> 2] = 0;
     __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i11, i12, 1, 2, Math_fround(0.0));
     i4 = HEAP32[i7 >> 2] | 0;
     i3 = HEAP32[i8 >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i10 >> 2] | 0;
     HEAP32[i20 + 16 >> 2] = i4;
     i9 = i20 + 20 | 0;
     HEAP32[i9 >> 2] = i3;
     i10 = i20 + 24 | 0;
     HEAP32[i10 >> 2] = i2;
     i11 = i20 + 28 | 0;
     HEAP32[i11 >> 2] = i1;
     f14 = Math_fround(HEAPF32[i20 >> 2]);
     i6 = i20 + 4 | 0;
     f15 = Math_fround(HEAPF32[i6 >> 2]);
     i7 = i20 + 8 | 0;
     f16 = Math_fround(HEAPF32[i7 >> 2]);
     i13 = i20 + 12 | 0;
     i8 = i13;
     i12 = i20;
     i5 = HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0;
     f17 = Math_fround(HEAPF32[i13 >> 2]);
    }
   } else {
    i4 = HEAP32[i20 + -16 >> 2] | 0;
    i3 = HEAP32[i20 + -12 >> 2] | 0;
    i2 = HEAP32[i20 + -8 >> 2] | 0;
    i1 = HEAP32[i20 + -4 >> 2] | 0;
    HEAP32[i20 >> 2] = i4;
    HEAP32[i20 + 4 >> 2] = i3;
    HEAP32[i20 + 8 >> 2] = i2;
    HEAP32[i20 + 12 >> 2] = i1;
    i22 = 11;
   }
   if ((i22 | 0) == 11) {
    f14 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f16 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f17 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    HEAP32[i20 + 16 >> 2] = i4;
    i9 = i20 + 20 | 0;
    HEAP32[i9 >> 2] = i3;
    i10 = i20 + 24 | 0;
    HEAP32[i10 >> 2] = i2;
    i11 = i20 + 28 | 0;
    HEAP32[i11 >> 2] = i1;
    i6 = i20 + 4 | 0;
    i7 = i20 + 8 | 0;
    i8 = i20 + 12 | 0;
    i12 = i20;
    i5 = 1065353216;
   }
   f24 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f25 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = Math_fround(f15 * f21);
   f16 = Math_fround(f16 * f21);
   f15 = Math_fround(f17 * f21);
   HEAPF32[i12 >> 2] = Math_fround(f14 * f21);
   HEAPF32[i6 >> 2] = f28;
   HEAPF32[i7 >> 2] = f16;
   HEAPF32[i8 >> 2] = f15;
   f15 = Math_fround(f27 * f21);
   f16 = Math_fround(f26 * f21);
   f17 = Math_fround(f25 * f21);
   HEAPF32[i20 + 16 >> 2] = Math_fround(f24 * f21);
   HEAPF32[i9 >> 2] = f15;
   HEAPF32[i10 >> 2] = f16;
   HEAPF32[i11 >> 2] = f17;
   HEAP32[i19 >> 2] = i5;
   i22 = 1;
   STACKTOP = i23;
   return i22 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j(i18, i3, i1, i2, i4) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i2 = i4 << 2;
 i16 = i2 >>> 0 > 1024;
 i17 = i19 + 4 | 0;
 HEAP8[i17 >> 0] = i16 & 1;
 if (i16) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i20 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i19 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i19 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i16 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i18 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i18 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i13 = i18 + (i5 << 2) | 0;
       i15 = i18 + (i7 << 2) | 0;
       i14 = HEAP32[i13 >> 2] | 0;
       HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
       HEAP32[i15 >> 2] = i14;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i15 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i15 << 2) >> 2] | 0;
    i8 = i15;
   }
   i14 = i18 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i12 = i18 + (i4 << 2) | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i9 = i7;
   i5 = i6;
   if (i6 >>> 0 < i7 >>> 0) {
    HEAP32[i12 >> 2] = i5;
    HEAP32[i14 >> 2] = i9;
    i15 = HEAP32[i12 >> 2] | 0;
    i5 = i9;
    i6 = i7;
    i11 = i15;
    i9 = i15;
   } else i11 = i7;
   i13 = i18 + (i3 << 2) | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   i7 = i10;
   if (i10 >>> 0 < i11 >>> 0) {
    HEAP32[i12 >> 2] = i7;
    HEAP32[i13 >> 2] = i9;
    i5 = HEAP32[i14 >> 2] | 0;
    i10 = i9;
    i6 = i5;
    i7 = i9;
   }
   if (i10 >>> 0 < i6 >>> 0) {
    HEAP32[i14 >> 2] = i7;
    HEAP32[i13 >> 2] = i5;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   i9 = i3 + -1 | 0;
   i15 = i18 + (i9 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   i14 = i5;
   i12 = i5;
   i5 = i4;
   while (1) {
    i10 = i5;
    while (1) {
     i5 = i10 + 1 | 0;
     i6 = i18 + (i5 << 2) | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     if (i7 >>> 0 < i12 >>> 0) i10 = i5; else {
      i13 = i10;
      break;
     }
    }
    do {
     i9 = i9 + -1 | 0;
     i11 = i18 + (i9 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i12 >>> 0 < i10 >>> 0);
    if ((i5 | 0) >= (i9 | 0)) {
     i9 = i14;
     break;
    }
    HEAP32[i6 >> 2] = i10;
    HEAP32[i11 >> 2] = i7;
    i12 = HEAP32[i15 >> 2] | 0;
    i14 = i12;
   }
   HEAP32[i6 >> 2] = i9;
   HEAP32[i15 >> 2] = i7;
   if ((i5 - i4 | 0) < (i3 - i5 | 0)) {
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i6 = 0; else {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i14 | 0, i15 | 0, i5 | 0, (i6 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i16 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i16 + -1 | 0) >>> 0) i5 = i16; else {
     i5 = i16 << 3;
     if (!i5) i5 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i15 = _PxGetFoundation() | 0;
      i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 24 >> 2] | 0, i15 | 0) | 0;
      i5 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i15 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i16 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i16 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZN10GameObject21EnsureUniqueTransformEbb(i20, i1, i15) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22;
 i18 = i22 + 4 | 0;
 i21 = i20 + 40 | 0;
 do if (!(HEAP32[i21 >> 2] | 0)) {
  i1 = 0;
  i4 = 21;
 } else {
  i16 = i20 + 28 | 0;
  i17 = i18 + 4 | 0;
  i11 = i1 ^ 1;
  i14 = i18 + 4 | 0;
  i12 = i18 + 4 | 0;
  i13 = i20 + 8 | 0;
  i5 = 0;
  i2 = 0;
  i4 = 0;
  i10 = 0;
  i1 = 0;
  L3 : while (1) {
   i9 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i10 << 3) + 4 >> 2] | 0;
   do if (!i9) i3 = i10; else {
    i6 = i9 + 8 | 0;
    i7 = (HEAP32[i6 >> 2] | 0) >>> 21;
    if ((i7 - (HEAP32[gb + 28940 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28940 + 28 >> 2] | 0) >>> 0) {
     i1 = i1 + 1 | 0;
     if (!i5) {
      i5 = i9;
      i2 = i10;
      i3 = i10;
     } else {
      if (!i15) if (HEAP32[i13 >> 2] & 1048576 | 0) {
       i1 = 0;
       i4 = 30;
       break L3;
      }
      i8 = i5 + 8 | 0;
      i3 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
      if (i4 | (HEAP32[gb + 1106156 + 4 + (i7 << 2) >> 2] | 0) == (i3 | 0)) {
       __Z24MergeTransformComponentsR9TransformS0_b(i9, i5, 0);
       __ZN10GameObject22RemoveComponentAtIndexEi(i20, i10);
       if (HEAP32[i6 >> 2] & 1048576 | 0) {
        i8 = __Z20GetPersistentManagerv() | 0;
        __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i8, HEAP32[i9 + 4 >> 2] | 0, 1);
       }
       __Z28delete_object_internal_step1P6Object(i9);
       i3 = HEAP32[i6 >> 2] & 2047;
       mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
       HEAP32[i18 >> 2] = i3;
       HEAP32[i17 >> 2] = 0;
       __Z19free_alloc_internalPvRK10MemLabelId(i9, i18);
       i3 = i10 + -1 | 0;
       break;
      }
      if ((i3 | 0) == (gb + 28980 | 0) & i11) {
       __Z24MergeTransformComponentsR9TransformS0_b(i9, i5, 1);
       __ZN10GameObject22RemoveComponentAtIndexEi(i20, i10);
       if (HEAP32[i6 >> 2] & 1048576 | 0) {
        i8 = __Z20GetPersistentManagerv() | 0;
        __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i8, HEAP32[i9 + 4 >> 2] | 0, 1);
       }
       __Z28delete_object_internal_step1P6Object(i9);
       i4 = HEAP32[i6 >> 2] & 2047;
       mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
       HEAP32[i18 >> 2] = i4;
       HEAP32[i14 >> 2] = 0;
       __Z19free_alloc_internalPvRK10MemLabelId(i9, i18);
       i4 = 1;
       i3 = i10 + -1 | 0;
       break;
      } else {
       __Z24MergeTransformComponentsR9TransformS0_b(i5, i9, 1);
       __ZN10GameObject22RemoveComponentAtIndexEi(i20, i2);
       i3 = i10 + -1 | 0;
       if (HEAP32[i8 >> 2] & 1048576 | 0) {
        i10 = __Z20GetPersistentManagerv() | 0;
        __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i10, HEAP32[i5 + 4 >> 2] | 0, 1);
       }
       __Z28delete_object_internal_step1P6Object(i5);
       i4 = HEAP32[i8 >> 2] & 2047;
       mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
       HEAP32[i18 >> 2] = i4;
       HEAP32[i12 >> 2] = 0;
       __Z19free_alloc_internalPvRK10MemLabelId(i5, i18);
       i4 = 1;
       i5 = i9;
       i2 = i3;
       break;
      }
     }
    } else i3 = i10;
   } while (0);
   i10 = i3 + 1 | 0;
   i3 = HEAP32[i21 >> 2] | 0;
   if (i10 >>> 0 >= i3 >>> 0) {
    i4 = 20;
    break;
   }
  }
  if ((i4 | 0) == 20) if (!i5) {
   i4 = 21;
   break;
  } else break; else if ((i4 | 0) == 30) {
   STACKTOP = i22;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 21) {
  __Z6FormatPKcz(i18, gb + 369238 | 0, i19);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 368833 | 0, 637, 1, HEAP32[i20 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __Z30AddTransformComponentUncheckedR10GameObjecti(i20, 4) | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i2 = i3 + -1 | 0;
 }
 if (i2 | 0) {
  i8 = i20 + 28 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = i5 + (i2 << 3) | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i5 + (i2 << 3) + 4 >> 2] | 0;
  i4 = i6 + 8 | 0;
  _memmove(i6 | 0, i4 | 0, i5 + (i3 << 3) - i4 | 0) | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i4 = i20 + 44 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i6 >>> 0 < i3 >>> 0) {
   i2 = i5 << 1;
   i2 = i2 >>> 0 > i3 >>> 0 ? i2 : i3;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i2;
    HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i2 << 3, 4, i20 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i20 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i20 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i21 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i8 >> 2] = i20;
    break;
   }
  } while (0);
  i21 = HEAP32[i8 >> 2] | 0;
  _memmove(i21 + 8 | 0, i21 | 0, (i3 << 3) + -8 | 0) | 0;
  HEAP32[i21 >> 2] = i9;
  HEAP32[i21 + 4 >> 2] = i7;
 }
 i21 = (i1 | 0) == 1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN2UI13UIInstructionC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 i7 = HEAP32[gb + 1155204 >> 2] | 0;
 i6 = HEAP32[gb + 1155204 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1155204 + 8 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i7;
 HEAP32[i1 + 44 >> 2] = i6;
 HEAP32[i1 + 48 >> 2] = i2;
 i10 = HEAP32[gb + 1155204 + 12 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = i10;
 i9 = HEAP32[gb + 1155204 + 16 >> 2] | 0;
 HEAP32[i1 + 56 >> 2] = i9;
 i8 = HEAP32[gb + 1155204 + 20 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = i8;
 i11 = i1 + 64 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = i7;
 HEAP32[i1 + 96 >> 2] = i6;
 HEAP32[i1 + 100 >> 2] = i2;
 HEAP32[i1 + 104 >> 2] = i10;
 HEAP32[i1 + 108 >> 2] = i9;
 HEAP32[i1 + 112 >> 2] = i8;
 i11 = i1 + 116 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = i7;
 HEAP32[i1 + 148 >> 2] = i6;
 HEAP32[i1 + 152 >> 2] = i2;
 HEAP32[i1 + 156 >> 2] = i10;
 HEAP32[i1 + 160 >> 2] = i9;
 HEAP32[i1 + 164 >> 2] = i8;
 i11 = i1 + 168 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = i7;
 HEAP32[i1 + 200 >> 2] = i6;
 HEAP32[i1 + 204 >> 2] = i2;
 HEAP32[i1 + 208 >> 2] = i10;
 HEAP32[i1 + 212 >> 2] = i9;
 HEAP32[i1 + 216 >> 2] = i8;
 i8 = i1 + 220 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = i7;
 HEAP32[i1 + 252 >> 2] = i6;
 HEAP32[i1 + 256 >> 2] = i2;
 HEAP32[i1 + 260 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i1 + 264 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i1 + 268 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i8 = i1 + 272 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = i7;
 HEAP32[i1 + 304 >> 2] = i6;
 HEAP32[i1 + 308 >> 2] = i2;
 HEAP32[i1 + 312 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i1 + 316 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i1 + 320 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i8 = i1 + 324 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i1 + 348 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = i7;
 HEAP32[i1 + 356 >> 2] = i6;
 HEAP32[i1 + 360 >> 2] = i2;
 HEAP32[i1 + 364 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i1 + 368 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i1 + 372 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i8 = i1 + 376 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i1 + 400 >> 2] = 0;
 HEAP32[i1 + 404 >> 2] = i7;
 HEAP32[i1 + 408 >> 2] = i6;
 HEAP32[i1 + 412 >> 2] = i2;
 HEAP32[i1 + 416 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i1 + 420 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i1 + 424 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i2 = i1 + 428 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 448 >> 2] = 0;
 HEAP32[i1 + 452 >> 2] = 0;
 HEAP32[i1 + 456 >> 2] = 0;
 HEAP32[i1 + 476 >> 2] = 0;
 HEAP32[i1 + 480 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 484 | 0) | 0;
 i2 = i1 + 548 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f3 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 560 >> 2] = f5;
 HEAPF32[i1 + 564 >> 2] = f4;
 HEAPF32[i1 + 568 >> 2] = f3;
 i2 = i1 + 572 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i1 + 584 >> 2] = f5;
 HEAPF32[i1 + 588 >> 2] = f4;
 HEAPF32[i1 + 592 >> 2] = f3;
 HEAPF32[i1 + 628 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 632 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 636 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 640 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 644 >> 2] = Math_fround(1.0);
 i2 = i1 + 648 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP8[i1 + 669 >> 0] = 1;
 HEAP8[i1 + 670 >> 0] = 0;
 HEAP8[i1 + 671 >> 0] = 0;
 return;
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i3, i4, i5, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 i2 = i5 + 4 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = (i6 | 0) == 0 ? 0 : i6 + i2 | 0;
 i6 = i3 + 4 | 0;
 i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i7 << 3) >> 2] | 0;
 if ((i6 | 0) == -1) {
  i8 = HEAP32[i1 + (i7 * 48 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i1 + (i7 * 48 | 0) + 8 >> 2] | 0;
  HEAP32[i2 + (i7 * 48 | 0) >> 2] = HEAP32[i1 + (i7 * 48 | 0) >> 2];
  HEAP32[i2 + (i7 * 48 | 0) + 4 >> 2] = i8;
  HEAP32[i2 + (i7 * 48 | 0) + 8 >> 2] = i6;
  i6 = HEAP32[i1 + (i7 * 48 | 0) + 16 >> 2] | 0;
  i8 = HEAP32[i1 + (i7 * 48 | 0) + 20 >> 2] | 0;
  HEAP32[i2 + (i7 * 48 | 0) + 12 >> 2] = HEAP32[i1 + (i7 * 48 | 0) + 12 >> 2];
  HEAP32[i2 + (i7 * 48 | 0) + 16 >> 2] = i6;
  HEAP32[i2 + (i7 * 48 | 0) + 20 >> 2] = i8;
  i8 = HEAP32[i1 + (i7 * 48 | 0) + 28 >> 2] | 0;
  i6 = HEAP32[i1 + (i7 * 48 | 0) + 32 >> 2] | 0;
  HEAP32[i2 + (i7 * 48 | 0) + 24 >> 2] = HEAP32[i1 + (i7 * 48 | 0) + 24 >> 2];
  HEAP32[i2 + (i7 * 48 | 0) + 28 >> 2] = i8;
  HEAP32[i2 + (i7 * 48 | 0) + 32 >> 2] = i6;
  i6 = HEAP32[i1 + (i7 * 48 | 0) + 40 >> 2] | 0;
  i8 = HEAP32[i1 + (i7 * 48 | 0) + 44 >> 2] | 0;
  HEAP32[i2 + (i7 * 48 | 0) + 36 >> 2] = HEAP32[i1 + (i7 * 48 | 0) + 36 >> 2];
  HEAP32[i2 + (i7 * 48 | 0) + 40 >> 2] = i6;
  HEAP32[i2 + (i7 * 48 | 0) + 44 >> 2] = i8;
  return;
 }
 if ((i7 | 0) != (i8 | 0)) __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii(i3, i4, i5, i6, i8);
 f24 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 36 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 40 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 44 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) >> 2]);
 f27 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 8 >> 2]);
 f20 = Math_fround(f24 * f29);
 f18 = Math_fround(f24 * f27);
 f24 = Math_fround(f24 * f25);
 f14 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 24 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 28 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 32 >> 2]);
 f11 = Math_fround(f22 * f14);
 f10 = Math_fround(f22 * f13);
 f22 = Math_fround(f22 * f21);
 f28 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 12 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 16 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 20 >> 2]);
 f11 = Math_fround(f20 + Math_fround(f11 + Math_fround(f9 * f28)));
 f10 = Math_fround(f18 + Math_fround(f10 + Math_fround(f9 * f26)));
 f9 = Math_fround(f24 + Math_fround(f22 + Math_fround(f9 * f23)));
 f22 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 36 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 40 >> 2]);
 f11 = Math_fround(f22 + f11);
 f10 = Math_fround(f24 + f10);
 f9 = Math_fround(Math_fround(HEAPF32[i2 + (i6 * 48 | 0) + 44 >> 2]) + f9);
 f24 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) >> 2]);
 f22 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 8 >> 2]);
 f20 = Math_fround(Math_fround(f29 * f24) + Math_fround(Math_fround(f28 * f22) + Math_fround(f14 * f18)));
 f19 = Math_fround(Math_fround(f27 * f24) + Math_fround(Math_fround(f26 * f22) + Math_fround(f13 * f18)));
 f18 = Math_fround(Math_fround(f25 * f24) + Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * f18)));
 f22 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 20 >> 2]);
 f17 = Math_fround(Math_fround(f29 * f22) + Math_fround(Math_fround(f28 * f24) + Math_fround(f14 * f15)));
 f16 = Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f26 * f24) + Math_fround(f13 * f15)));
 f15 = Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f23 * f24) + Math_fround(f21 * f15)));
 f24 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 24 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + (i7 * 48 | 0) + 32 >> 2]);
 f14 = Math_fround(Math_fround(f29 * f24) + Math_fround(Math_fround(f28 * f22) + Math_fround(f14 * f12)));
 f13 = Math_fround(Math_fround(f27 * f24) + Math_fround(Math_fround(f26 * f22) + Math_fround(f13 * f12)));
 f12 = Math_fround(Math_fround(f25 * f24) + Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * f12)));
 HEAPF32[i2 + (i7 * 48 | 0) >> 2] = f20;
 HEAPF32[i2 + (i7 * 48 | 0) + 4 >> 2] = f19;
 HEAPF32[i2 + (i7 * 48 | 0) + 8 >> 2] = f18;
 HEAPF32[i2 + (i7 * 48 | 0) + 12 >> 2] = f17;
 HEAPF32[i2 + (i7 * 48 | 0) + 16 >> 2] = f16;
 HEAPF32[i2 + (i7 * 48 | 0) + 20 >> 2] = f15;
 HEAPF32[i2 + (i7 * 48 | 0) + 24 >> 2] = f14;
 HEAPF32[i2 + (i7 * 48 | 0) + 28 >> 2] = f13;
 HEAPF32[i2 + (i7 * 48 | 0) + 32 >> 2] = f12;
 HEAPF32[i2 + (i7 * 48 | 0) + 36 >> 2] = f11;
 HEAPF32[i2 + (i7 * 48 | 0) + 40 >> 2] = f10;
 HEAPF32[i2 + (i7 * 48 | 0) + 44 >> 2] = f9;
 return;
}

function __ZNK12NavMeshAgent18SamplePathPositionEifP10NavMeshHit(i5, i1, f22, i23) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 f22 = Math_fround(f22);
 i23 = i23 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 24 | 0;
 i20 = i24 + 12 | 0;
 i21 = i24;
 i2 = i5 + 68 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844946 | 0, 0, gb + 841797 | 0, 665, 1, 0, 0, 0);
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i17 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i5 + 68 | 0) | 0;
 i6 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0;
 i18 = i17 + 476 | 0;
 if (f22 <= Math_fround(0.0) | (HEAP32[i18 >> 2] | 0) == 0) {
  i21 = HEAP32[i17 + 488 >> 2] | 0;
  i20 = HEAP32[i17 + 484 >> 2] | 0;
  HEAP32[i23 >> 2] = HEAP32[i17 + 480 >> 2];
  HEAP32[i23 + 4 >> 2] = i20;
  HEAP32[i23 + 8 >> 2] = i21;
  i21 = i23 + 12 | 0;
  HEAP32[i21 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[i23 + 24 >> 2] = Math_fround(0.0);
  HEAP32[i23 + 28 >> 2] = __ZNK12NavMeshAgent21GetCurrentPolygonMaskEv(i5) | 0;
  HEAP32[i23 + 32 >> 2] = 0;
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i25 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
 _memcpy(i19 | 0, __ZNK7dtCrowd14getAgentFilterEi(i25, HEAP32[i2 >> 2] | 0) | 0, 132) | 0;
 i25 = i19 + 128 | 0;
 i1 = HEAP32[i25 >> 2] & i1;
 HEAP32[i25 >> 2] = i1;
 i25 = HEAP32[i17 >> 2] | 0;
 HEAP32[i20 >> 2] = i25;
 i2 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i20 + 4 | 0;
 HEAP32[i15 >> 2] = i2;
 i4 = HEAP32[i17 + 8 >> 2] | 0;
 i16 = i20 + 8 | 0;
 HEAP32[i16 >> 2] = i4;
 f3 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!(HEAP32[i17 + 32 >> 2] | 0)) {
  i2 = 0;
  i4 = 0;
 } else {
  i4 = HEAP32[i17 + 28 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
 }
 if (!(i1 & (__ZNK9dtNavMesh12getPolyFlagsEy(i6, i2, i4) | 0))) {
  HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i1 = i23 + 12 | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[i23 + 24 >> 2] = Math_fround(0.0);
  HEAP32[i23 + 28 >> 2] = __ZNK12NavMeshAgent21GetCurrentPolygonMaskEv(i5) | 0;
  HEAP32[i23 + 32 >> 2] = 1;
  i1 = 1;
 } else {
  L15 : do if ((HEAP32[i18 >> 2] | 0) > 0) {
   i2 = i21 + 4 | 0;
   i4 = i21 + 8 | 0;
   i1 = 0;
   f14 = Math_fround(0.0);
   f12 = f3;
   f11 = f7;
   while (1) {
    i25 = i17 + 424 + (i1 * 3 << 2) | 0;
    i5 = HEAP32[i25 >> 2] | 0;
    HEAP32[i21 >> 2] = i5;
    i6 = HEAP32[i25 + 4 >> 2] | 0;
    HEAP32[i2 >> 2] = i6;
    i25 = HEAP32[i25 + 8 >> 2] | 0;
    HEAP32[i4 >> 2] = i25;
    f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f7 - f12);
    f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(f8 - f11);
    f9 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f9 - f10);
    f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f3 * f3)) + Math_fround(f13 * f13))));
    f3 = Math_fround(f22 - f14);
    if (f13 >= f3) {
     f28 = Math_fround(f3 / f13);
     f27 = Math_fround(Math_fround(1.0) - f28);
     f26 = Math_fround(Math_fround(f8 * f28) + Math_fround(f11 * f27));
     f3 = Math_fround(Math_fround(f9 * f28) + Math_fround(f10 * f27));
     HEAPF32[i21 >> 2] = Math_fround(Math_fround(f7 * f28) + Math_fround(f12 * f27));
     HEAPF32[i2 >> 2] = f26;
     HEAPF32[i4 >> 2] = f3;
     f3 = Math_fround(0.0);
    }
    if (__ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i23, i20, i21, i19) | 0) {
     i2 = 14;
     break;
    }
    if (f3 == Math_fround(0.0)) {
     i2 = 16;
     break;
    };
    HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
    HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (HEAP32[i18 >> 2] | 0)) {
     i2 = 0;
     i1 = 0;
     break L15;
    }
    f10 = Math_fround(f14 + f13);
    f12 = Math_fround(HEAPF32[i20 >> 2]);
    f11 = Math_fround(HEAPF32[i15 >> 2]);
    f14 = f10;
    f10 = Math_fround(HEAPF32[i16 >> 2]);
   }
   if ((i2 | 0) == 14) {
    i1 = i23 + 24 | 0;
    HEAPF32[i1 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i1 >> 2]));
    i1 = 1;
   } else if ((i2 | 0) == 16) {
    HEAPF32[i23 + 24 >> 2] = f22;
    i1 = 0;
   }
   i2 = 1;
  } else {
   i2 = 0;
   i1 = 0;
  } while (0);
  i1 = i2 & i1;
 }
 i25 = i1;
 STACKTOP = i24;
 return i25 | 0;
}

function __ZN10VertexData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i13 = i14 + 16 | 0;
 i9 = i14 + 40 | 0;
 i7 = i11 + 88 | 0;
 i5 = i12 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i12 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i11 + 92 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i5 >> 2] = i1;
  i1 = i6;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 i3 = i13 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i13 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i15 = i8;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i12, i13, 0);
 switch (HEAP32[i3 >> 2] | 0) {
 case 8:
  {
   _memmove(i11 | 0, HEAP32[i13 >> 2] | 0, 32) | 0;
   break;
  }
 case 6:
  {
   i15 = HEAP32[i13 >> 2] | 0;
   _memmove(i11 | 0, i15 | 0, 20) | 0;
   i3 = i11 + 20 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = HEAP32[i15 + 20 >> 2];
   if ((HEAP8[i11 + 10 >> 0] | 0) == 2) HEAP8[i11 + 11 >> 0] = 4;
   break;
  }
 case 0:
  {
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i15 << 2 & 128 | i15 & 31;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i11 + 24 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = 0;
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430681 | 0, 0, gb + 430527 | 0, 118, 1, 0, 0, 0);
   HEAP32[i7 >> 2] = 0;
  }
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if (!(HEAP8[i11 + 3 >> 0] | 0)) i1 = 0; else {
  i1 = i8 + (HEAPU8[i11 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
  i1 = 1;
 }
 if (HEAP8[i11 + 7 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 4 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
  i1 = i1 | 2;
 }
 if (HEAP8[i11 + 11 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 8 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4;
  i1 = i1 | 4;
 }
 if (HEAP8[i11 + 15 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 12 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 8;
  i1 = i1 | 8;
 }
 if (HEAP8[i11 + 19 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 16 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 16;
  i1 = i1 | 16;
 }
 if (HEAP8[i11 + 23 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 20 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 32;
  i1 = i1 | 32;
 }
 if (!(HEAP8[i11 + 27 >> 0] | 0)) i2 = i1; else {
  i2 = i8 + (HEAPU8[i11 + 24 >> 0] << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 64;
  i2 = i1 | 64;
 }
 if (!(HEAP8[i11 + 31 >> 0] | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i2) {
   i15 = HEAP32[i7 >> 2] | 0;
   __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i11, i1, i15, ~i15, gb + 59212 | 0, gb + 1546313 | 0);
  } else i10 = 16;
 } else {
  i1 = i8 + (HEAPU8[i11 + 28 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 128;
  i2 = i2 | 128;
  i1 = HEAP32[i4 >> 2] | 0;
  i10 = 16;
 }
 if ((i10 | 0) == 16) {
  HEAP16[i9 >> 1] = HEAP16[i11 + 2 >> 1] | 0;
  HEAP16[i9 + 2 >> 1] = HEAP16[i11 + 6 >> 1] | 0;
  HEAP16[i9 + 4 >> 1] = HEAP16[i11 + 10 >> 1] | 0;
  HEAP16[i9 + 6 >> 1] = HEAP16[i11 + 14 >> 1] | 0;
  HEAP16[i9 + 8 >> 1] = HEAP16[i11 + 18 >> 1] | 0;
  HEAP16[i9 + 10 >> 1] = HEAP16[i11 + 22 >> 1] | 0;
  HEAP16[i9 + 12 >> 1] = HEAP16[i11 + 26 >> 1] | 0;
  HEAP16[i9 + 14 >> 1] = HEAP16[i11 + 30 >> 1] | 0;
  __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i11, i1, i2, ~i2, i8, i9);
 }
 i4 = i11 + 96 | 0;
 __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i12, i4, gb + 430648 | 0, 1);
 i3 = i11 + 84 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 i1 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = i2;
  i1 = 0;
 } else {
  _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i12, i1, i2, 0);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i6);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EEPKN5Unity4TypeEz(i21, i2, i1) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i23 + 8 | 0;
 i16 = i23;
 i22 = i23 + 32 | 0;
 i7 = i23 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i9 = HEAP32[gb + 1104264 >> 2] | 0;
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i16;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i22 >> 2] = 0;
 i18 = i22 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i22 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i16);
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i16;
 if (!i2) i2 = 0; else {
  HEAP32[i19 >> 2] = 1;
  i17 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i22 >> 2] = i17;
  HEAP32[i18 >> 2] = 1;
  HEAP32[i17 >> 2] = i2;
  i2 = 1;
 }
 i17 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i1 = HEAP32[i17 >> 2] | 0;
 HEAP32[i7 >> 2] = i17 + 4;
 if (i1) {
  i6 = i2;
  while (1) {
   i2 = i6 + 1 | 0;
   i4 = HEAP32[i19 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i2 >>> 0 > i5 >>> 0) {
    i3 = i4 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i19 >> 2] = i3;
     HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i3 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i17 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
     HEAP32[i19 >> 2] = i3;
     HEAP32[i22 >> 2] = i17;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i2;
   HEAP32[(HEAP32[i22 >> 2] | 0) + (i6 << 2) >> 2] = i1;
   i17 = (HEAP32[i7 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i1 = HEAP32[i17 >> 2] | 0;
   HEAP32[i7 >> 2] = i17 + 4;
   if (!i1) break; else i6 = i2;
  }
 }
 i15 = i9 + 28 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i16 = i9 + 32 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 i17 = i1 + (i14 << 3) | 0;
 L16 : do if (!i14) i8 = 17; else {
  i4 = HEAP32[i9 + 20 >> 2] | 0;
  i3 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) do {
   i14 = HEAP32[i1 >> 2] | 0;
   if (!((i4 | 0) == (i14 | 0) | (i3 | 0) == (i14 | 0))) {
    i8 = 17;
    break L16;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i17 | 0)); else do {
   if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i8 = 17;
    break L16;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i17 | 0));
 } while (0);
 L25 : do if ((i8 | 0) == 17) if ((i1 | 0) != (i17 | 0)) {
  i8 = i21 + 12 | 0;
  i10 = i21 + 16 | 0;
  i11 = i21 + 4 | 0;
  i12 = i9 + 20 | 0;
  i13 = i9 + 8 | 0;
  i14 = i9 + 4 | 0;
  i7 = i9 + 12 | 0;
  while (1) {
   L30 : do if (i2 | 0) {
    i3 = HEAP32[i22 >> 2] | 0;
    i4 = (HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0) >>> 21;
    i5 = HEAP32[i18 >> 2] | 0;
    i2 = 0;
    while (1) {
     i9 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
     i2 = i2 + 1 | 0;
     if ((i4 - (HEAP32[i9 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i9 + 28 >> 2] | 0) >>> 0) break;
     if (i2 >>> 0 >= i5 >>> 0) break L30;
    }
    i3 = HEAP32[i8 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i10 >> 2] = i2;
      HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i10 >> 2] = i2;
      HEAP32[i21 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i4;
    HEAP32[(HEAP32[i21 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
   } while (0);
   i1 = i1 + 8 | 0;
   L44 : do if ((i1 | 0) == (i17 | 0)) i1 = i17; else {
    i3 = HEAP32[i12 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i14 >> 2] | 0) != 0) while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     if (!((i3 | 0) == (i9 | 0) | (i2 | 0) == (i9 | 0))) break L44;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i17 | 0)) {
      i1 = i17;
      break;
     }
    } else while (1) {
     if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L44;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i17 | 0)) {
      i1 = i17;
      break;
     }
    }
   } while (0);
   if ((i1 | 0) == ((HEAP32[i15 >> 2] | 0) + (HEAP32[i16 >> 2] << 3) | 0)) break L25;
   i2 = HEAP32[i18 >> 2] | 0;
  }
 } while (0);
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i23;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i20);
 HEAP32[i22 >> 2] = 0;
 STACKTOP = i23;
 return;
}

function __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i14, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i15 = i18 + 8 | 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i18 + 20 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(Math_fround(f2 + f3) * Math_fround(.5));
 i7 = i17 + 8 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i17 + 20 | 0;
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 i6 = f19 < Math_fround(Math_fround(f9 + f10) * Math_fround(.5));
 i12 = i14 + 8 | 0;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 20 | 0;
 i11 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < f19;
 if (!i6) {
  if (!i11) {
   i18 = 0;
   return i18 | 0;
  }
  i25 = HEAP32[i18 >> 2] | 0;
  i1 = i18 + 4 | 0;
  i24 = HEAP32[i1 >> 2] | 0;
  i4 = i18 + 12 | 0;
  i23 = HEAP32[i4 >> 2] | 0;
  i5 = i18 + 16 | 0;
  i22 = HEAP32[i5 >> 2] | 0;
  i6 = i18 + 24 | 0;
  i11 = i6;
  i21 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i18 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAP32[i14 >> 2] = i25;
  HEAP32[i14 + 4 >> 2] = i24;
  HEAPF32[i12 >> 2] = f2;
  HEAP32[i14 + 12 >> 2] = i23;
  HEAP32[i14 + 16 >> 2] = i22;
  HEAPF32[i13 >> 2] = f3;
  i14 = i14 + 24 | 0;
  HEAP32[i14 >> 2] = i21;
  HEAP32[i14 + 4 >> 2] = i11;
  f20 = Math_fround(HEAPF32[i15 >> 2]);
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  if (!(f20 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i25 = 1;
   return i25 | 0;
  }
  i14 = HEAP32[i17 >> 2] | 0;
  i21 = HEAP32[i17 + 4 >> 2] | 0;
  i22 = HEAP32[i17 + 12 >> 2] | 0;
  i25 = HEAP32[i17 + 16 >> 2] | 0;
  i24 = i17 + 24 | 0;
  i23 = HEAP32[i24 >> 2] | 0;
  i24 = HEAP32[i24 + 4 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
  HEAP32[i18 >> 2] = i14;
  HEAP32[i1 >> 2] = i21;
  HEAPF32[i15 >> 2] = f3;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i5 >> 2] = i25;
  HEAPF32[i16 >> 2] = f2;
  i25 = i6;
  HEAP32[i25 >> 2] = i23;
  HEAP32[i25 + 4 >> 2] = i24;
  i25 = 2;
  return i25 | 0;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i17 + 4 >> 2] | 0;
 i5 = HEAP32[i17 + 12 >> 2] | 0;
 i6 = HEAP32[i17 + 16 >> 2] | 0;
 i8 = i17 + 24 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 if (i11) {
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 4 >> 2] = i4;
  HEAPF32[i12 >> 2] = f9;
  HEAP32[i14 + 12 >> 2] = i5;
  HEAP32[i14 + 16 >> 2] = i6;
  HEAPF32[i13 >> 2] = f10;
  i25 = i14 + 24 | 0;
  HEAP32[i25 >> 2] = i7;
  HEAP32[i25 + 4 >> 2] = i8;
  i25 = 1;
  return i25 | 0;
 };
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 HEAP32[i18 >> 2] = i1;
 HEAP32[i18 + 4 >> 2] = i4;
 HEAPF32[i15 >> 2] = f9;
 HEAP32[i18 + 12 >> 2] = i5;
 HEAP32[i18 + 16 >> 2] = i6;
 HEAPF32[i16 >> 2] = f10;
 i25 = i18 + 24 | 0;
 HEAP32[i25 >> 2] = i7;
 HEAP32[i25 + 4 >> 2] = i8;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f9 + f10) * Math_fround(.5)))) {
  i25 = 1;
  return i25 | 0;
 };
 HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i4;
 HEAPF32[i12 >> 2] = f9;
 HEAP32[i14 + 12 >> 2] = i5;
 HEAP32[i14 + 16 >> 2] = i6;
 HEAPF32[i13 >> 2] = f10;
 i25 = i14 + 24 | 0;
 HEAP32[i25 >> 2] = i7;
 HEAP32[i25 + 4 >> 2] = i8;
 i25 = 2;
 return i25 | 0;
}

function __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i14, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i15 = i18 + 4 | 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i18 + 16 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(Math_fround(f2 + f3) * Math_fround(.5));
 i7 = i17 + 4 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i17 + 16 | 0;
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 i6 = f19 < Math_fround(Math_fround(f9 + f10) * Math_fround(.5));
 i12 = i14 + 4 | 0;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 16 | 0;
 i11 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < f19;
 if (!i6) {
  if (!i11) {
   i18 = 0;
   return i18 | 0;
  }
  i25 = HEAP32[i18 >> 2] | 0;
  i1 = i18 + 8 | 0;
  i24 = HEAP32[i1 >> 2] | 0;
  i4 = i18 + 12 | 0;
  i23 = HEAP32[i4 >> 2] | 0;
  i5 = i18 + 20 | 0;
  i22 = HEAP32[i5 >> 2] | 0;
  i6 = i18 + 24 | 0;
  i11 = i6;
  i21 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i18 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAP32[i14 >> 2] = i25;
  HEAPF32[i12 >> 2] = f2;
  HEAP32[i14 + 8 >> 2] = i24;
  HEAP32[i14 + 12 >> 2] = i23;
  HEAPF32[i13 >> 2] = f3;
  HEAP32[i14 + 20 >> 2] = i22;
  i14 = i14 + 24 | 0;
  HEAP32[i14 >> 2] = i21;
  HEAP32[i14 + 4 >> 2] = i11;
  f20 = Math_fround(HEAPF32[i15 >> 2]);
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  if (!(f20 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i25 = 1;
   return i25 | 0;
  }
  i14 = HEAP32[i17 >> 2] | 0;
  i21 = HEAP32[i17 + 8 >> 2] | 0;
  i22 = HEAP32[i17 + 12 >> 2] | 0;
  i25 = HEAP32[i17 + 20 >> 2] | 0;
  i24 = i17 + 24 | 0;
  i23 = HEAP32[i24 >> 2] | 0;
  i24 = HEAP32[i24 + 4 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
  HEAP32[i18 >> 2] = i14;
  HEAPF32[i15 >> 2] = f3;
  HEAP32[i1 >> 2] = i21;
  HEAP32[i4 >> 2] = i22;
  HEAPF32[i16 >> 2] = f2;
  HEAP32[i5 >> 2] = i25;
  i25 = i6;
  HEAP32[i25 >> 2] = i23;
  HEAP32[i25 + 4 >> 2] = i24;
  i25 = 2;
  return i25 | 0;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i17 + 8 >> 2] | 0;
 i5 = HEAP32[i17 + 12 >> 2] | 0;
 i6 = HEAP32[i17 + 20 >> 2] | 0;
 i8 = i17 + 24 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 if (i11) {
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAP32[i14 >> 2] = i1;
  HEAPF32[i12 >> 2] = f9;
  HEAP32[i14 + 8 >> 2] = i4;
  HEAP32[i14 + 12 >> 2] = i5;
  HEAPF32[i13 >> 2] = f10;
  HEAP32[i14 + 20 >> 2] = i6;
  i25 = i14 + 24 | 0;
  HEAP32[i25 >> 2] = i7;
  HEAP32[i25 + 4 >> 2] = i8;
  i25 = 1;
  return i25 | 0;
 };
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 HEAP32[i18 >> 2] = i1;
 HEAPF32[i15 >> 2] = f9;
 HEAP32[i18 + 8 >> 2] = i4;
 HEAP32[i18 + 12 >> 2] = i5;
 HEAPF32[i16 >> 2] = f10;
 HEAP32[i18 + 20 >> 2] = i6;
 i25 = i18 + 24 | 0;
 HEAP32[i25 >> 2] = i7;
 HEAP32[i25 + 4 >> 2] = i8;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f9 + f10) * Math_fround(.5)))) {
  i25 = 1;
  return i25 | 0;
 };
 HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 HEAP32[i14 >> 2] = i1;
 HEAPF32[i12 >> 2] = f9;
 HEAP32[i14 + 8 >> 2] = i4;
 HEAP32[i14 + 12 >> 2] = i5;
 HEAPF32[i13 >> 2] = f10;
 HEAP32[i14 + 20 >> 2] = i6;
 i25 = i14 + 24 | 0;
 HEAP32[i25 >> 2] = i7;
 HEAP32[i25 + 4 >> 2] = i8;
 i25 = 2;
 return i25 | 0;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE(i27, i28, i26) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i18 = i27 + 53 | 0;
 HEAP8[i18 >> 0] = 0;
 i19 = i27 + 52 | 0;
 i1 = HEAP8[i19 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i27 = 0;
  i28 = i28 + 4096 | 0;
  HEAP32[i28 >> 2] = i27;
  i28 = (i27 | 0) != 0;
  return i28 | 0;
 }
 i20 = i26 + 4 | 0;
 i21 = i26 + 8 | 0;
 i22 = i26 + 12 | 0;
 i23 = i26 + 16 | 0;
 i24 = i26 + 20 | 0;
 i25 = i26 + 24 | 0;
 i4 = 0;
 i3 = i1;
 i1 = 0;
 i2 = 0;
 while (1) {
  i17 = HEAPU8[i27 + 48 + i2 >> 0] | 0;
  i11 = HEAP32[i27 + 64 + (i17 * 400 | 0) + 384 >> 2] | 0;
  HEAP8[i18 >> 0] = (i4 & 255) + i11;
  f5 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + 32 >> 2]);
  f6 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + 36 >> 2]);
  f7 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + 40 >> 2]);
  if (i11 >>> 0 > 1) {
   i4 = 1;
   do {
    f15 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i4 << 6) + 32 >> 2]);
    f16 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i4 << 6) + 36 >> 2]);
    f5 = Math_fround(f5 + f15);
    f6 = Math_fround(f6 + f16);
    f7 = Math_fround(f7 + Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i4 << 6) + 40 >> 2]));
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i11 | 0));
  }
  f12 = Math_fround(HEAPF32[i26 >> 2]);
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  f10 = Math_fround(HEAPF32[i21 >> 2]);
  f8 = Math_fround(HEAPF32[i22 >> 2]);
  f16 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f29 = Math_fround(Math_fround(Math_fround(f5 * f12) + Math_fround(f6 * f9)) + Math_fround(f7 * f10));
  f14 = Math_fround(Math_fround(Math_fround(f12 * f29) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f7 * f9) - Math_fround(f6 * f10))) + Math_fround(f5 * f16))) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(Math_fround(f9 * f29) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f5 * f10) - Math_fround(f7 * f12))) + Math_fround(f6 * f16))) * Math_fround(2.0));
  f16 = Math_fround(Math_fround(Math_fround(f10 * f29) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f6 * f12) - Math_fround(f5 * f9))) + Math_fround(f7 * f16))) * Math_fround(2.0));
  f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) + Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15))))));
  f14 = Math_fround(f7 * f14);
  f15 = Math_fround(f7 * f15);
  f16 = Math_fround(f7 * f16);
  if ((i11 | 0) != 0 & i1 >>> 0 < 64) {
   i11 = 0 - i11 | 0;
   i13 = i1 + -64 | 0;
   i13 = i13 >>> 0 < i11 >>> 0 ? i11 : i13;
   i11 = 0 - i13 | 0;
   f7 = f9;
   f6 = f10;
   f5 = f12;
   i4 = i1;
   i3 = 0;
   while (1) {
    f10 = Math_fround(HEAPF32[i23 >> 2]);
    f12 = Math_fround(HEAPF32[i24 >> 2]);
    f35 = Math_fround(HEAPF32[i25 >> 2]);
    f9 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i3 << 6) + 16 >> 2]);
    f32 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i3 << 6) + 20 >> 2]);
    f33 = Math_fround(HEAPF32[i27 + 64 + (i17 * 400 | 0) + (i3 << 6) + 24 >> 2]);
    f34 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
    f29 = Math_fround(Math_fround(Math_fround(f5 * f9) + Math_fround(f7 * f32)) + Math_fround(f6 * f33));
    f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f5 * f29) + Math_fround(Math_fround(f34 * f9) + Math_fround(f8 * Math_fround(Math_fround(f7 * f33) - Math_fround(f6 * f32))))) * Math_fround(2.0)));
    f12 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f7 * f29) + Math_fround(Math_fround(f34 * f32) + Math_fround(f8 * Math_fround(Math_fround(f6 * f9) - Math_fround(f5 * f33))))) * Math_fround(2.0)));
    f29 = Math_fround(f35 + Math_fround(Math_fround(Math_fround(Math_fround(f34 * f33) + Math_fround(f8 * Math_fround(Math_fround(f5 * f32) - Math_fround(f7 * f9)))) + Math_fround(f6 * f29)) * Math_fround(2.0)));
    i30 = HEAP32[i27 + 64 + (i17 * 400 | 0) + (i3 << 6) + 44 >> 2] | 0;
    i31 = i28 + (i4 << 6) | 0;
    HEAPF32[i31 >> 2] = f14;
    HEAPF32[i31 + 4 >> 2] = f15;
    HEAPF32[i31 + 8 >> 2] = f16;
    HEAPF32[i31 + 12 >> 2] = Math_fround(0.0);
    i31 = i28 + (i4 << 6) + 16 | 0;
    HEAPF32[i31 >> 2] = f10;
    HEAPF32[i31 + 4 >> 2] = f12;
    HEAPF32[i31 + 8 >> 2] = f29;
    HEAPF32[i31 + 12 >> 2] = Math_fround(0.0);
    HEAP32[i28 + (i4 << 6) + 12 >> 2] = i30;
    HEAP32[i28 + (i4 << 6) + 48 >> 2] = -1;
    HEAP32[i28 + (i4 << 6) + 52 >> 2] = HEAP32[i27 + 64 + (i17 * 400 | 0) + (i3 << 6) + 48 >> 2];
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break;
    f5 = Math_fround(HEAPF32[i26 >> 2]);
    f7 = Math_fround(HEAPF32[i20 >> 2]);
    f6 = Math_fround(HEAPF32[i21 >> 2]);
    f8 = Math_fround(HEAPF32[i22 >> 2]);
    i4 = i4 + 1 | 0;
   }
   i3 = HEAP8[i19 >> 0] | 0;
   i1 = i1 - i13 | 0;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= (i3 & 255) >>> 0) break;
  i4 = HEAP8[i18 >> 0] | 0;
 }
 i31 = i28 + 4096 | 0;
 HEAP32[i31 >> 2] = i1;
 i31 = (i1 | 0) != 0;
 return i31 | 0;
}

function __ZN16HumanPoseHandler12GetHumanPoseER8Vector3fR11QuaternionfPf(i13, i14, i18, i19) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i17 = i13 + 16 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i15 = i1 + 28 | 0;
 i15 = HEAP32[i15 + (HEAP32[i15 >> 2] | 0) >> 2] | 0;
 i2 = HEAP32[i13 + 24 >> 2] | 0;
 i16 = i13 + 28 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 if ((i12 | 0) > 0) {
  i5 = i2 + 4 | 0;
  i6 = (HEAP32[i16 >> 2] | 0) + 4 | 0;
  i7 = i6;
  i2 = i20 + 4 | 0;
  i3 = i20 + 8 | 0;
  i8 = i20 + 4 | 0;
  i9 = i20 + 8 | 0;
  i10 = i20 + 12 | 0;
  i1 = 0;
  do {
   i11 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i11 | 0) {
    i22 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
    __ZNK9Transform16GetLocalPositionEv(i20, i11);
    i23 = HEAP32[i2 >> 2] | 0;
    i24 = HEAP32[i3 >> 2] | 0;
    HEAP32[i22 + (i1 * 40 | 0) >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + (i1 * 40 | 0) + 4 >> 2] = i23;
    HEAP32[i22 + (i1 * 40 | 0) + 8 >> 2] = i24;
    i22 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
    __ZNK9Transform16GetLocalRotationEv(i20, i11);
    i24 = HEAP32[i8 >> 2] | 0;
    i23 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i10 >> 2] | 0;
    HEAP32[i22 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i22 + (i1 * 40 | 0) + 16 >> 2] = i24;
    HEAP32[i22 + (i1 * 40 | 0) + 20 >> 2] = i23;
    HEAP32[i22 + (i1 * 40 | 0) + 24 >> 2] = i11;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  i1 = HEAP32[i17 >> 2] | 0;
 }
 i23 = HEAP32[i1 >> 2] | 0;
 i24 = i13 + 32 | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i23 | 0) == 0 ? 0 : i23 + i1 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i24 >> 2] | 0, i15, 0);
 i1 = HEAP32[i17 >> 2] | 0;
 i23 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 20 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 + 40 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = i13 + 36 | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE((i23 | 0) == 0 ? 0 : i23 + i1 | 0, HEAP32[i16 >> 2] | 0, (i5 | 0) == 0 ? 0 : i3 + i5 | 0, HEAP32[i2 >> 2] | 0);
 i5 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
 i3 = i5;
 i24 = (HEAP32[i24 >> 2] | 0) + 4 | 0;
 i24 = i24 + (HEAP32[i24 >> 2] | 0) | 0;
 i1 = HEAP32[i24 + (i15 * 40 | 0) + 4 >> 2] | 0;
 i23 = HEAP32[i24 + (i15 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i24 + (i15 * 40 | 0) >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = i23;
 i23 = HEAP32[i24 + (i15 * 40 | 0) + 16 >> 2] | 0;
 i1 = HEAP32[i24 + (i15 * 40 | 0) + 20 >> 2] | 0;
 i5 = HEAP32[i24 + (i15 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[i24 + (i15 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = i23;
 HEAP32[i3 + 20 >> 2] = i1;
 HEAP32[i3 + 24 >> 2] = i5;
 i5 = HEAP32[i24 + (i15 * 40 | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i24 + (i15 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i3 + 28 >> 2] = HEAP32[i24 + (i15 * 40 | 0) + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = i5;
 HEAP32[i3 + 36 >> 2] = i1;
 __ZN7mecanim5human9HumanPoseC2Ev(i20);
 i3 = (HEAP32[i17 >> 2] | 0) + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim5human12RetargetFromEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_SD_PKNS6_7_float3E((i1 | 0) == 0 ? 0 : i3 + i1 | 0, HEAP32[i2 >> 2] | 0, i20, HEAP32[i13 + 40 >> 2] | 0, HEAP32[i13 + 44 >> 2] | 0, HEAP32[i13 + 48 >> 2] | 0, HEAP32[i13 + 52 >> 2] | 0, 0);
 i2 = HEAP32[i20 + 4 >> 2] | 0;
 i1 = HEAP32[i20 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i14 + 4 >> 2] = i2;
 HEAP32[i14 + 8 >> 2] = i1;
 f28 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f30 = Math_fround(f28 * f28);
 f27 = Math_fround(HEAPF32[i20 + 16 >> 2]);
 f4 = Math_fround(f27 * f27);
 f26 = Math_fround(HEAPF32[i20 + 20 >> 2]);
 f25 = Math_fround(f26 * f26);
 f29 = Math_fround(HEAPF32[i20 + 24 >> 2]);
 f25 = Math_fround(Math_fround(f30 + f4) + Math_fround(f25 + Math_fround(f29 * f29)));
 f4 = Math_fround(Math_sqrt(Math_fround(f25)));
 f28 = Math_fround(f28 / f4);
 f27 = Math_fround(f27 / f4);
 f26 = Math_fround(f26 / f4);
 f4 = Math_fround(f29 / f4);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f25 > Math_fround(1.0e-30);
 i24 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i18 >> 2] = i5 ? i1 : 0;
 HEAP32[i18 + 4 >> 2] = i5 ? i2 : 0;
 HEAP32[i18 + 8 >> 2] = i5 ? i3 : 0;
 HEAP32[i18 + 12 >> 2] = i24;
 _memcpy(i19 | 0, i20 + 596 | 0, 208) | 0;
 i1 = i19 + 208 | 0;
 i2 = i20 + 364 | 0;
 i3 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i19 + 288 | 0;
 i2 = i20 + 500 | 0;
 i3 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i11 = i14 + 8 | 0;
 i12 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i3 - i1 | 0) / 132 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i10 = i1 + 16 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i1 + 36 >> 2] = 0;
   HEAPF32[i1 + 44 >> 2] = Math_fround(inf);
   HEAP32[i1 + 40 >> 2] = 0;
   i10 = i1 + 48 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAPF32[i1 + 72 >> 2] = Math_fround(inf);
   HEAP32[i1 + 68 >> 2] = 0;
   i10 = i1 + 76 | 0;
   HEAP32[i1 + 108 >> 2] = 0;
   HEAP32[i1 + 112 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i10 = i9;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i1 + 100 | 0;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i1 + 120 >> 2] = 2;
   HEAP32[i1 + 116 >> 2] = 2;
   HEAP32[i1 + 124 >> 2] = 4;
   HEAP32[i1 + 128 >> 2] = 0;
   i1 = (HEAP32[i13 >> 2] | 0) + 132 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i6 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 132 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 132 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i6;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = 25;
  HEAP32[i9 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 132 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (((i1 - i4 | 0) / 132 | 0) * 132 | 0) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i3 + (i5 * 132 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAPF32[i1 + 44 >> 2] = Math_fround(inf);
  HEAP32[i1 + 40 >> 2] = 0;
  i3 = i1 + 48 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAPF32[i1 + 72 >> 2] = Math_fround(inf);
  HEAP32[i1 + 68 >> 2] = 0;
  i3 = i1 + 76 | 0;
  HEAP32[i1 + 108 >> 2] = 0;
  HEAP32[i1 + 112 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i3 = i9;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1 + 100 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 + 120 >> 2] = 2;
  HEAP32[i1 + 116 >> 2] = 2;
  HEAP32[i1 + 124 >> 2] = 4;
  HEAP32[i1 + 128 >> 2] = 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 132 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i4 = i6;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i1 = i1 + -132 | 0;
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i2 + -132 | 0, i1);
   i2 = (HEAP32[i6 >> 2] | 0) + -132 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  i4 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i13;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx3Scb14ParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i12 >> 2] = HEAP32[gb + 124804 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 124804 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 124804 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 124804 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 124804 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 124804 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 124804 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 124804 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 124836 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 124836 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 124836 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 124836 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 124836 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 124836 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 124836 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 124836 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 124868 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 124868 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 124868 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 124868 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 124868 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 124868 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 124868 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 124868 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 124900 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 124900 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 124900 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 124900 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 124900 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 124900 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 124900 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 124900 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 124932 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 124932 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 124932 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 124932 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 124932 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 124932 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 124932 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 124932 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 747511;
 HEAP32[i7 + 4 >> 2] = gb + 747531;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 180;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 124964 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 124964 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 124964 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 124964 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 124964 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 124964 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 124964 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 124964 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124996 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124996 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124996 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124996 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124996 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124996 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124996 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124996 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 125028 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 125028 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 125028 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 125028 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 125028 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 125028 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 125028 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 125028 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125060 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125060 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125060 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125060 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125060 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125060 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125060 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125060 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4Mesh11SetVerticesEPK8Vector3fj(i12, i2, i6) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i7 = i13;
 if (i6 >>> 0 > 65535) {
  if (!i12) i1 = 0; else i1 = HEAP32[i12 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427391 | 0, 0, gb + 425656 | 0, 794, 1, i1, 0, 0);
  STACKTOP = i13;
  return;
 }
 i9 = i12 + 32 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[i1 + 100 >> 2] | 0;
 L8 : do if (i10 >>> 0 > i6 >>> 0) {
  i4 = HEAP32[i1 + 112 >> 2] | 0;
  i5 = ((HEAP32[i1 + 116 >> 2] | 0) - i4 | 0) >>> 1;
  if (i5 | 0) {
   i3 = 0;
   while (1) {
    if ((HEAPU16[i4 + (i3 << 1) >> 1] | 0) >>> 0 >= i6 >>> 0) break;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i5 >>> 0) break L8;
   }
   if (!i12) i1 = 0; else i1 = HEAP32[i12 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427465 | 0, 0, gb + 425656 | 0, 801, 1, i1, 0, 0);
   STACKTOP = i13;
   return;
  }
 } while (0);
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i9 >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  i5 = i3 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i9 >> 2] = i1;
 }
 if ((i10 | 0) != (i6 | 0)) {
  i3 = HEAP32[i1 + 96 >> 2] | 0;
  i4 = i3 | 1;
  if (!(HEAP32[i1 + 176 >> 2] | 0)) if ((HEAP32[i12 + 116 >> 2] | 0) == (HEAP32[i12 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i11, i1 + 8 | 0);
   HEAP32[i11 >> 2] = (HEAP32[i11 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i11 + 8 >> 2] & ~HEAP32[i11 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  } else i8 = 19; else i8 = 19;
  if ((i8 | 0) == 19) {
   HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i12, i6, i4, 0, gb + 1546313 | 0, i7);
  if ((i10 | 0) != 0 & i10 >>> 0 < i6 >>> 0) {
   i1 = i3 & -2;
   if (i1 | 0) __Z23ClearVertexDataChannelsjjjR14VertexDataInfo(i10, i6 - i10 | 0, i1, (HEAP32[i9 >> 2] | 0) + 8 | 0);
  }
 }
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i5 + 100 >> 2] | 0;
 i6 = (i3 | 0) < (i6 | 0) ? i3 : i6;
 i1 = i5 + 8 | 0;
 if (!(HEAP32[i5 + 176 >> 2] | 0)) if ((HEAP32[i12 + 116 >> 2] | 0) == (HEAP32[i12 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i11, i1);
  HEAP32[i11 >> 2] = (HEAP32[i11 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i11 + 8 >> 2] & ~HEAP32[i11 + 12 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 } else i8 = 26; else i8 = 26;
 if ((i8 | 0) == 26) {
  HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i3, 1, 0, i7, gb + 1546313 | 0);
 i5 = i2 + (i6 * 12 | 0) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i1 + 8 | 0;
 i9 = HEAP16[i1 + 10 >> 1] | 0;
 if ((i9 & 65535) < 768 | (i9 & 255) != 0) {
  i1 = 0;
  i3 = 0;
 } else {
  i3 = HEAP32[i1 + 92 >> 2] | 0;
  if (!i3) {
   i1 = 0;
   i3 = 1;
  } else if (!(HEAP8[i1 + 11 >> 0] | 0)) {
   i1 = 0;
   i3 = 1;
  } else {
   i1 = HEAP16[i4 >> 1] | 0;
   i1 = i3 + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i4 + 32 + ((HEAPU8[i4 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 if (i6 | 0) while (1) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i2 + 12 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
 }
 __ZN4Mesh16SetChannelsDirtyEjb(i12, 1, 0);
 if ((i10 | 0) == (i6 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN4Mesh25RecalculateBoundsInternalEv(i12);
 HEAP32[i11 >> 2] = gb + 30832;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = i12;
 i1 = HEAP32[i12 + 236 >> 2] | 0;
 i3 = i12 + 232 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i10 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i10 + 8 >> 2] | 0, gb + 1105176 | 0, i11);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i3 = i12 + 240 | 0;
 i1 = HEAP32[i12 + 244 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i12 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i13;
 return;
}

function __ZN14ParticleSystem13KillParticlesILb0EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj(i10, i11, i18, i27, i32, i1, i28) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i18 = i18 | 0;
 i27 = i27 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i33 + 16 | 0;
 i30 = i33;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 <= i1 >>> 0) {
  i31 = i2;
  __ZN23ParticleSystemParticles12array_resizeEj(i32, i31);
  STACKTOP = i33;
  return;
 }
 i12 = i32 + 520 | 0;
 i13 = i30 + 4 | 0;
 i14 = i30 + 8 | 0;
 i15 = i30 + 12 | 0;
 i16 = i32 + 800 | 0;
 i17 = i27 + 428 | 0;
 i19 = (i28 | 0) == 0;
 i20 = i27 + 496 | 0;
 i21 = i29 + 4 | 0;
 i22 = i29 + 8 | 0;
 i23 = i29 + 12 | 0;
 i24 = i29 + 16 | 0;
 i25 = i29 + 20 | 0;
 i26 = i27 + 424 | 0;
 i7 = i2;
 i8 = i1;
 i9 = i1;
 i4 = i1 + 2 | 0;
 i5 = i1 + 3 | 0;
 i6 = i1 + 1 | 0;
 i1 = i2;
 while (1) {
  i3 = (HEAP32[i12 >> 2] | 0) + (i8 << 2) | 0;
  f38 = Math_fround(HEAPF32[i3 >> 2]);
  f37 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i34 = (f38 > Math_fround(100.0)) << 31 >> 31;
  i35 = (f37 > Math_fround(100.0)) << 31 >> 31;
  i2 = (f36 > Math_fround(100.0)) << 31 >> 31;
  i3 = (Math_fround(HEAPF32[i3 + 12 >> 2]) > Math_fround(100.0)) << 31 >> 31;
  i34 = (i9 | 0) < (i7 | 0) ? i34 : 0;
  i35 = (i6 | 0) < (i7 | 0) ? i35 : 0;
  i2 = (i4 | 0) < (i7 | 0) ? i2 : 0;
  i3 = (i5 | 0) < (i7 | 0) ? i3 : 0;
  HEAP32[i30 >> 2] = i34;
  HEAP32[i13 >> 2] = i35;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  if ((i35 | i34 | i2 | i3 | 0) > -1) {
   i2 = i7;
   i31 = 22;
  } else {
   if (i11) {
    i1 = 0;
    i3 = 3;
    while (1) {
     if (HEAP32[i30 + (i3 << 2) >> 2] | 0) {
      i2 = i3 + i8 | 0;
      if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + (i2 << 2) >> 2] | 0)) {
       if (HEAP32[i17 >> 2] | 0) {
        i1 = 0;
        do {
         i35 = HEAP32[i20 >> 2] | 0;
         HEAPF32[i29 >> 2] = Math_fround(0.0);
         HEAPF32[i21 >> 2] = Math_fround(0.0);
         HEAP32[i22 >> 2] = i35;
         i35 = (Math_imul(i35, 1812433253) | 0) + 1 | 0;
         HEAP32[i23 >> 2] = i35;
         i35 = (Math_imul(i35, 1812433253) | 0) + 1 | 0;
         HEAP32[i24 >> 2] = i35;
         HEAP32[i25 >> 2] = (Math_imul(i35, 1812433253) | 0) + 1;
         __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i29, (HEAP32[i26 >> 2] | 0) + (i1 * 600 | 0) | 0, i18, i27, i32, 2, i1, i2, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
         i1 = i1 + 1 | 0;
        } while (i1 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
       }
       __ZN23ParticleSystemParticles14element_assignEjj(i32, i2, (HEAP32[i10 >> 2] | 0) + -1 | 0);
       HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
       if (i19) i1 = 1; else {
        i1 = HEAP32[i28 >> 2] | 0;
        if (!i1) i1 = 1; else {
         HEAP32[i28 >> 2] = i1 + -1;
         i1 = 1;
        }
       }
      }
     }
     if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
    }
   } else {
    i1 = 0;
    i3 = 3;
    while (1) {
     if (HEAP32[i30 + (i3 << 2) >> 2] | 0) {
      i2 = i3 + i8 | 0;
      if (HEAP32[i17 >> 2] | 0) {
       i1 = 0;
       do {
        i35 = HEAP32[i20 >> 2] | 0;
        HEAPF32[i29 >> 2] = Math_fround(0.0);
        HEAPF32[i21 >> 2] = Math_fround(0.0);
        HEAP32[i22 >> 2] = i35;
        i35 = (Math_imul(i35, 1812433253) | 0) + 1 | 0;
        HEAP32[i23 >> 2] = i35;
        i35 = (Math_imul(i35, 1812433253) | 0) + 1 | 0;
        HEAP32[i24 >> 2] = i35;
        HEAP32[i25 >> 2] = (Math_imul(i35, 1812433253) | 0) + 1;
        __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i29, (HEAP32[i26 >> 2] | 0) + (i1 * 600 | 0) | 0, i18, i27, i32, 2, i1, i2, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
        i1 = i1 + 1 | 0;
       } while (i1 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
      }
      __ZN23ParticleSystemParticles14element_assignEjj(i32, i2, (HEAP32[i10 >> 2] | 0) + -1 | 0);
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
      if (i19) i1 = 1; else {
       i1 = HEAP32[i28 >> 2] | 0;
       if (!i1) i1 = 1; else {
        HEAP32[i28 >> 2] = i1 + -1;
        i1 = 1;
       }
      }
     }
     if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
    }
   }
   i7 = HEAP32[i10 >> 2] | 0;
   if (i1) {
    i2 = i7;
    i3 = i9;
    i1 = i7;
   } else {
    i2 = i7;
    i1 = i7;
    i31 = 22;
   }
  }
  if ((i31 | 0) == 22) {
   i31 = 0;
   i8 = i8 + 4 | 0;
   i3 = i9 + 4 | 0;
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
   i6 = i6 + 4 | 0;
  }
  if (i8 >>> 0 < i1 >>> 0) {
   i7 = i2;
   i9 = i3;
  } else break;
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i32, i1);
 STACKTOP = i33;
 return;
}

function __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17;
 i16 = i13 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i13 + 16 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i12 = i14 + 12 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i1 = i1 + 1 | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i15 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 3, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i13 >> 2] = i11;
  break;
 } while (0);
 i10 = HEAP32[i14 >> 2] | 0;
 i11 = i10 + (HEAP32[i12 >> 2] << 3) | 0;
 HEAP32[i2 >> 2] = fb + 908;
 __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_(i10, i11, i2);
 if (!(HEAP32[i12 >> 2] | 0)) i1 = HEAP32[i16 >> 2] | 0; else {
  i11 = i13 + 4 | 0;
  i10 = 0;
  i1 = HEAP32[i16 >> 2] | 0;
  do {
   L15 : do if (i1 >>> 0 > 1) {
    i3 = HEAP32[i13 >> 2] | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    f4 = Math_fround(HEAPF32[i6 + (i10 << 3) >> 2]);
    f5 = Math_fround(HEAPF32[i6 + (i10 << 3) + 4 >> 2]);
    while (1) {
     i9 = i1 + -2 | 0;
     i2 = i1 + -1 | 0;
     f19 = Math_fround(HEAPF32[i3 + (i9 << 3) >> 2]);
     f18 = Math_fround(HEAPF32[i3 + (i9 << 3) + 4 >> 2]);
     f20 = Math_fround(HEAPF32[i3 + (i2 << 3) >> 2]);
     if (!(Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + (i2 << 3) + 4 >> 2]) - f18) * Math_fround(f4 - f19)) - Math_fround(Math_fround(f20 - f19) * Math_fround(f5 - f18))) <= Math_fround(0.0))) {
      i9 = i1;
      break L15;
     }
     HEAP32[i16 >> 2] = i2;
     if (i2 >>> 0 > 1) i1 = i2; else {
      i9 = i2;
      break;
     }
    }
   } else {
    i9 = i1;
    i6 = HEAP32[i14 >> 2] | 0;
   } while (0);
   i3 = i6 + (i10 << 3) | 0;
   i1 = i9 + 1 | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i1 >>> 0 > i8 >>> 0) {
    i2 = i7 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i15 >> 2] = i2;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 3, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
     HEAP32[i15 >> 2] = i2;
     HEAP32[i13 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i16 >> 2] = i1;
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP32[i2 + (i9 << 3) >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + (i9 << 3) + 4 >> 2] = HEAP32[i6 + (i10 << 3) + 4 >> 2];
   i10 = i10 + 1 | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } while (i10 >>> 0 < i2 >>> 0);
  i2 = i2 + -2 | 0;
  i11 = i9 + 2 | 0;
  if ((i2 | 0) > -1) {
   i12 = i13 + 4 | 0;
   while (1) {
    L33 : do if (i1 >>> 0 < i11 >>> 0) i6 = HEAP32[i14 >> 2] | 0; else {
     i3 = HEAP32[i13 >> 2] | 0;
     i6 = HEAP32[i14 >> 2] | 0;
     f4 = Math_fround(HEAPF32[i6 + (i2 << 3) >> 2]);
     f5 = Math_fround(HEAPF32[i6 + (i2 << 3) + 4 >> 2]);
     while (1) {
      i10 = i1 + -2 | 0;
      i7 = i1 + -1 | 0;
      f19 = Math_fround(HEAPF32[i3 + (i10 << 3) >> 2]);
      f20 = Math_fround(HEAPF32[i3 + (i10 << 3) + 4 >> 2]);
      f18 = Math_fround(HEAPF32[i3 + (i7 << 3) >> 2]);
      if (!(Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + (i7 << 3) + 4 >> 2]) - f20) * Math_fround(f4 - f19)) - Math_fround(Math_fround(f18 - f19) * Math_fround(f5 - f20))) <= Math_fround(0.0))) break L33;
      HEAP32[i16 >> 2] = i7;
      if (i7 >>> 0 < i11 >>> 0) {
       i1 = i7;
       break;
      } else i1 = i7;
     }
    } while (0);
    i7 = i6 + (i2 << 3) | 0;
    i8 = i1 + 1 | 0;
    i9 = HEAP32[i15 >> 2] | 0;
    i10 = i9 & 2147483647;
    do if (i8 >>> 0 > i10 >>> 0) {
     i3 = i9 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i10 >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
      HEAP32[i15 >> 2] = i3;
      HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i3 << 3, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
      HEAP32[i15 >> 2] = i3;
      HEAP32[i13 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i8;
    i10 = HEAP32[i13 >> 2] | 0;
    HEAP32[i10 + (i1 << 3) >> 2] = HEAP32[i7 >> 2];
    HEAP32[i10 + (i1 << 3) + 4 >> 2] = HEAP32[i6 + (i2 << 3) + 4 >> 2];
    if ((i2 | 0) > 0) {
     i2 = i2 + -1 | 0;
     i1 = i8;
    } else {
     i1 = i8;
     break;
    }
   }
  }
 }
 HEAP32[i16 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i31, i32, i1) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i30 + 56 | 0;
 i25 = i30 + 44 | 0;
 i26 = i30 + 40 | 0;
 i27 = i30 + 20 | 0;
 i28 = i30;
 i29 = i31 + 16 | 0;
 i2 = HEAP32[i29 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i23 = i31 + 24 | 0;
 if (i1 >>> 0 > (HEAP32[i23 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i29, i26, 4); else {
  HEAP32[i26 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i29 >> 2] = i1;
 }
 i7 = i27 + 4 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = 0;
 HEAP32[i27 + 8 >> 2] = 0;
 HEAP32[i27 + 12 >> 2] = 0;
 HEAP32[i27 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i32 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i32, HEAP32[i8 >> 2] | 0);
 i9 = i32 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i32 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i26 >> 2] | 0) <= 0) {
  STACKTOP = i30;
  return;
 }
 i10 = i28 + 4 | 0;
 i11 = i7 + 11 | 0;
 i12 = i27 + 8 | 0;
 i13 = i28 + 16 | 0;
 i6 = i28 + 16 | 0;
 i14 = i24 + 4 | 0;
 i15 = i28 + 12 | 0;
 i16 = i28 + 8 | 0;
 i17 = i8;
 i18 = i32 + 4 | 0;
 i19 = i28 + 4 | 0;
 i20 = i19 + 11 | 0;
 i21 = i24 + 4 | 0;
 i22 = i10 + 11 | 0;
 i5 = 0;
 do {
  i1 = HEAP32[i29 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i23 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i29, i27, 4); else {
   HEAP32[i27 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i29 >> 2] = i2;
  }
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i31, i7, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i31);
  HEAP32[i28 >> 2] = HEAP32[i27 >> 2];
  i3 = HEAP8[i11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
  i3 = i1 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = 15;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i22 >> 0] = i3;
   if (!i3) i1 = i10; else {
    i1 = i10;
    i4 = 17;
   }
  } else i4 = 15;
  if ((i4 | 0) == 15) {
   i33 = i3 + 16 & -16;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i14 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i33, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i15 >> 2] = i33 | -2147483648;
   HEAP32[i16 >> 2] = i3;
   i4 = 17;
  }
  if ((i4 | 0) == 17) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i24 >> 2] = i8;
   i2 = i17;
   i3 = i8;
  } else {
   i4 = HEAP32[i28 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 22;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i4 = 27;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 26;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 22) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 26) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 27) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    i3 = i24;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i25, i32, i28);
   i1 = HEAP32[i25 >> 2] | 0;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i32 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i32 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 >> 2] | 0, i1);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  if ((HEAP8[i20 >> 0] | 0) < 0) {
   i33 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i21 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i33, i24);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i26 >> 2] | 0));
 if ((HEAP8[i27 + 4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i30;
  return;
 }
 i33 = HEAP32[i27 + 4 >> 2] | 0;
 i32 = HEAP32[i27 + 16 >> 2] | 0;
 HEAP32[i24 >> 2] = 66;
 HEAP32[i24 + 4 >> 2] = i32;
 __Z19free_alloc_internalPvRK10MemLabelId(i33, i24);
 STACKTOP = i30;
 return;
}

function __ZN11UnityEngine9Animation30CreateAvatarBindingConstantOptER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 24 | 0;
 i18 = i19;
 i17 = i19 + 36 | 0;
 i16 = gb + 64016 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i8 = i18;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = i15;
 HEAP32[i17 >> 2] = 0;
 i8 = i17 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i15 = i17 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i18);
 i13 = i11;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i16;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i11 >> 2] = -1;
 __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i9, i11, i17, i1, 0);
 i6 = HEAP32[i1 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? 0 : i6 + i1 | 0;
 i12 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, 28, 4) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 + 12 >> 2] = i8;
 i13 = i18 + 16 | 0;
 HEAP32[i13 >> 2] = i8;
 i14 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 64016 | 0);
 i4 = i11;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i14;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i18 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 12 | 0, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
 L1 : do if ((i8 | 0) > 0) {
  if (!i6) {
   i1 = 0;
   i6 = 0;
   while (1) {
    i2 = HEAP32[i17 >> 2] | 0;
    i3 = HEAP32[i2 + (i6 * 12 | 0) + 4 >> 2] | 0;
    if ((HEAP32[i3 + 100 >> 2] | 0) == (i9 | 0)) {
     i5 = HEAP32[i18 >> 2] | 0;
     HEAP32[i5 + (i1 * 12 | 0) >> 2] = i3;
     i4 = i5 + (i1 * 12 | 0) + 4 | 0;
     HEAP32[i4 >> 2] = -1;
     i5 = i5 + (i1 * 12 | 0) + 8 | 0;
     HEAP32[i5 >> 2] = -1;
     i2 = HEAP32[i2 + (i6 * 12 | 0) + 8 >> 2] | 0;
     if ((i2 | 0) != -1) {
      HEAP32[i4 >> 2] = i2;
      HEAP32[i5 >> 2] = i2;
     }
     i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 31632 | 0) | 0;
     if (i2 | 0) __ZN19SkinnedMeshRenderer7GetMeshEv(i2) | 0;
     i1 = ((HEAP32[i5 >> 2] | 0) != -1 & 1) + i1 | 0;
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i8 | 0)) {
     i4 = i1;
     break L1;
    }
   }
  } else {
   i1 = 0;
   i7 = 0;
  }
  do {
   i2 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i2 + (i7 * 12 | 0) + 4 >> 2] | 0;
   if ((HEAP32[i4 + 100 >> 2] | 0) == (i9 | 0)) {
    i5 = HEAP32[i18 >> 2] | 0;
    HEAP32[i5 + (i1 * 12 | 0) >> 2] = i4;
    i3 = i5 + (i1 * 12 | 0) + 4 | 0;
    HEAP32[i3 >> 2] = -1;
    i5 = i5 + (i1 * 12 | 0) + 8 | 0;
    HEAP32[i5 >> 2] = -1;
    i2 = HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] | 0;
    if ((i2 | 0) != -1) {
     HEAP32[i3 >> 2] = i2;
     HEAP32[i5 >> 2] = i2;
    }
    i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 31632 | 0) | 0;
    if (i2 | 0) {
     i2 = __ZN19SkinnedMeshRenderer7GetMeshEv(i2) | 0;
     if (i2 | 0) {
      i2 = HEAP32[i2 + 184 >> 2] | 0;
      if (i2 | 0) {
       i2 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i6, i2) | 0;
       if ((i2 | 0) != -1) HEAP32[i5 >> 2] = i2;
      }
     }
    }
    i1 = ((HEAP32[i5 >> 2] | 0) != -1 & 1) + i1 | 0;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i8 | 0));
  i4 = i1;
 } else i4 = 0; while (0);
 HEAP32[i12 + 16 >> 2] = i4;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!i4) HEAP32[i12 + 20 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i4 * 12 | 0, 4) | 0;
  i2 = i3 + (i4 * 12 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i2 = i12 + 20 | 0;
  HEAP32[i2 >> 2] = i3;
  if ((i4 | 0) > 0) {
   i11 = HEAP32[i18 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   if ((i4 | 0) != 1) {
    i1 = 1;
    do {
     i11 = (HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) | 0;
     i10 = (HEAP32[i18 >> 2] | 0) + (i1 * 12 | 0) | 0;
     HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i4 | 0));
   }
  }
 }
 __ZN11UnityEngine9Animation28RegisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE(i12);
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i14);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i15 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return i12 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16);
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i19;
 return i12 | 0;
}

function __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471425 | 0, gb + 471434 | 0, i1, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471461 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471471 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471485 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471500 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471508 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471521 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i16, i8, i1) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i7 = i15 + 8 | 0;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i16 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i9 = HEAP32[gb + 37296 >> 2] | 0;
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 17; else {
      i3 = i2 + 8 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 17; else {
       i18 = HEAP32[i2 + 4 >> 2] | 0;
       i19 = i1;
       HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i19 + 4 >> 2] = i18;
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 17) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 8);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) {
      i18 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
      i19 = i1 + 4 | 0;
      HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i18;
     }
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i13 | 0)) break L20;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 30; else {
       i3 = i2 + 8 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 30; else {
        i11 = i2;
        i18 = HEAP32[i11 + 4 >> 2] | 0;
        i19 = i1;
        HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
        HEAP32[i19 + 4 >> 2] = i18;
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 30) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 8);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) {
       i18 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
       i19 = i1 + 4 | 0;
       HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
       HEAP32[i19 >> 2] = i18;
      }
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i16, i8, i1) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i7 = i15 + 8 | 0;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i16 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i9 = HEAP32[gb + 37248 >> 2] | 0;
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 17; else {
      i3 = i2 + 8 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 17; else {
       i18 = HEAP32[i2 + 4 >> 2] | 0;
       i19 = i1;
       HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i19 + 4 >> 2] = i18;
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 17) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 8);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) {
      i18 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
      i19 = i1 + 4 | 0;
      HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
      HEAP32[i19 >> 2] = i18;
     }
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i13 | 0)) break L20;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 30; else {
       i3 = i2 + 8 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 30; else {
        i11 = i2;
        i18 = HEAP32[i11 + 4 >> 2] | 0;
        i19 = i1;
        HEAP32[i19 >> 2] = HEAP32[i11 >> 2];
        HEAP32[i19 + 4 >> 2] = i18;
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 30) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 8);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) {
       i18 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
       i19 = i1 + 4 | 0;
       HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i19 >> 2] | 0) | 0;
       HEAP32[i19 >> 2] = i18;
      }
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZNK12PhysXRaycast7OverlapERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_j(i1, i2, i35, i36, f37, f3, i38, i39, i40) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i35 = i35 | 0;
 i36 = i36 | 0;
 f37 = Math_fround(f37);
 f3 = Math_fround(f3);
 i38 = i38 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i41 = 0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0, i55 = 0;
 i41 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i41 + 188 | 0;
 i27 = i41 + 160 | 0;
 i28 = i41 + 120 | 0;
 i29 = i41 + 88 | 0;
 i30 = i41 + 216 | 0;
 i31 = i41 + 80 | 0;
 i32 = i41 + 48 | 0;
 i33 = i41;
 HEAP32[i31 >> 2] = 0;
 HEAPF32[i31 + 4 >> 2] = f3;
 HEAP32[i32 >> 2] = 0;
 HEAP32[i32 + 4 >> 2] = 0;
 HEAP32[i32 + 8 >> 2] = 0;
 HEAP32[i32 + 12 >> 2] = 1065353216;
 HEAP32[i32 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i32 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i32 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 if (!i40) {
  i40 = 0;
  STACKTOP = i41;
  return i40 | 0;
 }
 i2 = i33 + 4 | 0;
 i4 = i33 + 8 | 0;
 i5 = i33 + 12 | 0;
 i6 = i33 + 16 | 0;
 i7 = i33 + 40 | 0;
 i8 = i27 + 16 | 0;
 i9 = i27 + 20 | 0;
 i10 = i27 + 24 | 0;
 i11 = i34 + 12 | 0;
 i12 = i34 + 4 | 0;
 i13 = i34 + 8 | 0;
 i14 = i34 + 16 | 0;
 i15 = i34 + 20 | 0;
 i16 = i34 + 24 | 0;
 i17 = i27 + 12 | 0;
 i18 = i27 + 8 | 0;
 i19 = i27 + 4 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29 + 8 | 0;
 i22 = i29 + 12 | 0;
 i23 = i29 + 16 | 0;
 i24 = i29 + 20 | 0;
 i25 = i29 + 24 | 0;
 i1 = 0;
 while (1) {
  if (__Z26IntersectAABBAABBInclusiveRK4AABBS1_(i36, i39 + (i1 * 24 | 0) | 0) | 0) {
   i26 = HEAP32[i38 + (i1 << 4) + 4 >> 2] | 0;
   if (i26 | 0) {
    HEAP32[i33 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i4 >> 2] = -1;
    HEAP16[i5 >> 1] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    HEAP32[i6 + 20 >> 2] = 0;
    HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
    i55 = HEAP32[i38 + (i1 << 4) >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 32 >> 2] | 0, i28 | 0, i26 | 0);
    mftCall_vii(HEAP32[(HEAP32[i55 >> 2] | 0) + 84 >> 2] | 0, i34 | 0, i55 | 0);
    mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 72 >> 2] | 0, i27 | 0, i26 | 0);
    f51 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * Math_fround(2.0));
    f49 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(2.0));
    f44 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(2.0));
    f54 = Math_fround(HEAPF32[i11 >> 2]);
    f53 = Math_fround(Math_fround(f54 * f54) + Math_fround(-.5));
    f52 = Math_fround(HEAPF32[i34 >> 2]);
    f3 = Math_fround(f51 * f52);
    f50 = Math_fround(HEAPF32[i12 >> 2]);
    f3 = Math_fround(f3 + Math_fround(f49 * f50));
    f48 = Math_fround(HEAPF32[i13 >> 2]);
    f3 = Math_fround(f3 + Math_fround(f44 * f48));
    f43 = Math_fround(Math_fround(f52 * f3) + Math_fround(Math_fround(f51 * f53) + Math_fround(f54 * Math_fround(Math_fround(f44 * f50) - Math_fround(f49 * f48)))));
    f42 = Math_fround(Math_fround(f50 * f3) + Math_fround(Math_fround(f49 * f53) + Math_fround(f54 * Math_fround(Math_fround(f51 * f48) - Math_fround(f44 * f52)))));
    f3 = Math_fround(Math_fround(Math_fround(f44 * f53) + Math_fround(f54 * Math_fround(Math_fround(f49 * f52) - Math_fround(f51 * f50)))) + Math_fround(f48 * f3));
    f43 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f43);
    f42 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f42);
    f3 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f3);
    f51 = Math_fround(HEAPF32[i27 >> 2]);
    f49 = Math_fround(f54 * f51);
    f53 = Math_fround(HEAPF32[i17 >> 2]);
    f49 = Math_fround(f49 + Math_fround(f52 * f53));
    f44 = Math_fround(HEAPF32[i18 >> 2]);
    f49 = Math_fround(f49 + Math_fround(f50 * f44));
    f47 = Math_fround(HEAPF32[i19 >> 2]);
    f46 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(Math_fround(f50 * f53) + Math_fround(f54 * f47))) - Math_fround(f52 * f44));
    f45 = Math_fround(Math_fround(Math_fround(f52 * f47) + Math_fround(Math_fround(f48 * f53) + Math_fround(f54 * f44))) - Math_fround(f50 * f51));
    f44 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f53) - Math_fround(f52 * f51)) - Math_fround(f50 * f47)) - Math_fround(f48 * f44));
    HEAPF32[i29 >> 2] = Math_fround(f49 - Math_fround(f48 * f47));
    HEAPF32[i20 >> 2] = f46;
    HEAPF32[i21 >> 2] = f45;
    HEAPF32[i22 >> 2] = f44;
    HEAPF32[i23 >> 2] = f43;
    HEAPF32[i24 >> 2] = f42;
    HEAPF32[i25 >> 2] = f3;
    HEAP16[i30 >> 1] = 0;
    if (__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i35, f37, i31, i32, i28, i29, i33, i30, Math_fround(0.0)) | 0) {
     i1 = 1;
     i2 = 7;
     break;
    }
   }
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i40 >>> 0) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i41;
  return i1 | 0;
 }
 return 0;
}

function __Z21RandomPointInsideCubeR5RandNPKf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0;
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(-f12);
 i31 = HEAP32[i2 >> 2] | 0;
 i49 = i2 + 4 | 0;
 i29 = HEAP32[i49 >> 2] | 0;
 i47 = i2 + 8 | 0;
 i27 = HEAP32[i47 >> 2] | 0;
 i45 = i2 + 12 | 0;
 i25 = HEAP32[i45 >> 2] | 0;
 i31 = i31 << 11 ^ i31;
 i29 = i29 << 11 ^ i29;
 i27 = i27 << 11 ^ i27;
 i25 = i25 << 11 ^ i25;
 i43 = i2 + 16 | 0;
 i19 = HEAP32[i43 >> 2] | 0;
 i41 = i2 + 20 | 0;
 i18 = HEAP32[i41 >> 2] | 0;
 i39 = i2 + 24 | 0;
 i26 = HEAP32[i39 >> 2] | 0;
 i37 = i2 + 28 | 0;
 i24 = HEAP32[i37 >> 2] | 0;
 i36 = i2 + 32 | 0;
 i32 = HEAP32[i36 >> 2] | 0;
 i35 = i2 + 36 | 0;
 i30 = HEAP32[i35 >> 2] | 0;
 i34 = i2 + 40 | 0;
 i28 = HEAP32[i34 >> 2] | 0;
 i33 = i2 + 44 | 0;
 i52 = HEAP32[i33 >> 2] | 0;
 i23 = i2 + 48 | 0;
 i51 = HEAP32[i23 >> 2] | 0;
 i22 = i2 + 52 | 0;
 i50 = HEAP32[i22 >> 2] | 0;
 i21 = i2 + 56 | 0;
 i48 = HEAP32[i21 >> 2] | 0;
 i20 = i2 + 60 | 0;
 i46 = HEAP32[i20 >> 2] | 0;
 i31 = i31 >>> 8 ^ i31 ^ i51;
 i44 = i31 ^ i51 >>> 19;
 i29 = i29 >>> 8 ^ i29 ^ i50;
 i42 = i29 ^ i50 >>> 19;
 i27 = i27 >>> 8 ^ i27 ^ i48;
 i40 = i27 ^ i48 >>> 19;
 i25 = i25 >>> 8 ^ i25 ^ i46;
 i38 = i25 ^ i46 >>> 19;
 f15 = Math_fround(Math_fround(i44 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f14 = Math_fround(Math_fround(i42 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f13 = Math_fround(Math_fround(i40 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(i38 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(Math_fround(f15 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f15) * f12));
 f14 = Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f14) * f12));
 f13 = Math_fround(Math_fround(f13 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f13) * f12));
 f12 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f8) * f12));
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(-f8);
 i19 = i19 << 11 ^ i19;
 i18 = i18 << 11 ^ i18;
 i26 = i26 << 11 ^ i26;
 i24 = i24 << 11 ^ i24;
 i19 = i19 >>> 8 ^ i19 ^ i44;
 i31 = i19 ^ i31 >>> 19;
 i18 = i18 >>> 8 ^ i18 ^ i42;
 i29 = i18 ^ i29 >>> 19;
 i26 = i26 >>> 8 ^ i26 ^ i40;
 i27 = i26 ^ i27 >>> 19;
 i24 = i24 >>> 8 ^ i24 ^ i38;
 i25 = i24 ^ i25 >>> 19;
 f11 = Math_fround(Math_fround(i31 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f10 = Math_fround(Math_fround(i29 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(i27 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(i25 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f11 = Math_fround(Math_fround(f11 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f11) * f8));
 f10 = Math_fround(Math_fround(f10 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f10) * f8));
 f9 = Math_fround(Math_fround(f9 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f9) * f8));
 f8 = Math_fround(Math_fround(f4 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f4) * f8));
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f17 = Math_fround(-f4);
 i32 = i32 << 11 ^ i32;
 i30 = i30 << 11 ^ i30;
 i28 = i28 << 11 ^ i28;
 i3 = i52 << 11 ^ i52;
 HEAP32[i2 >> 2] = i51;
 HEAP32[i49 >> 2] = i50;
 HEAP32[i47 >> 2] = i48;
 HEAP32[i45 >> 2] = i46;
 HEAP32[i43 >> 2] = i44;
 HEAP32[i41 >> 2] = i42;
 HEAP32[i39 >> 2] = i40;
 HEAP32[i37 >> 2] = i38;
 HEAP32[i36 >> 2] = i31;
 HEAP32[i35 >> 2] = i29;
 HEAP32[i34 >> 2] = i27;
 HEAP32[i33 >> 2] = i25;
 i19 = i32 >>> 8 ^ i32 ^ i31 ^ i19 >>> 19;
 i18 = i30 >>> 8 ^ i30 ^ i29 ^ i18 >>> 19;
 i2 = i28 >>> 8 ^ i28 ^ i27 ^ i26 >>> 19;
 i3 = i3 >>> 8 ^ i3 ^ i25 ^ i24 >>> 19;
 HEAP32[i23 >> 2] = i19;
 HEAP32[i22 >> 2] = i18;
 HEAP32[i21 >> 2] = i2;
 HEAP32[i20 >> 2] = i3;
 f7 = Math_fround(Math_fround(i19 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(i18 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f16 = Math_fround(Math_fround(i3 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(f7 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f7) * f4));
 f6 = Math_fround(Math_fround(f6 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f6) * f4));
 f5 = Math_fround(Math_fround(f5 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f5) * f4));
 f4 = Math_fround(Math_fround(f16 * f17) + Math_fround(Math_fround(Math_fround(1.0) - f16) * f4));
 HEAPF32[i1 >> 2] = f15;
 HEAPF32[i1 + 4 >> 2] = f14;
 HEAPF32[i1 + 8 >> 2] = f13;
 HEAPF32[i1 + 12 >> 2] = f12;
 HEAPF32[i1 + 16 >> 2] = f11;
 HEAPF32[i1 + 20 >> 2] = f10;
 HEAPF32[i1 + 24 >> 2] = f9;
 HEAPF32[i1 + 28 >> 2] = f8;
 HEAPF32[i1 + 32 >> 2] = f7;
 HEAPF32[i1 + 36 >> 2] = f6;
 HEAPF32[i1 + 40 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f4;
 return;
}

function _rgb_gray_convert(i1, i5, i9, i6, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i7 = 0, i8 = 0;
 switch (HEAP32[i1 + 40 >> 2] | 0) {
 case 6:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 3 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 3 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i8 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i5 >> 2] | 0;
    while (1) {
     HEAP8[i4 + i1 >> 0] = ((HEAP32[i8 + ((HEAPU8[i2 + 1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i8 + ((HEAPU8[i2 + 2 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 1 | 0;
     i5 = i5 + 4 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = (i3 | 0) == 0 ? 0 : i3 + i5 | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i4 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = (i4 | 0) == 0 ? 0 : i4 + i1 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i7;
 i7 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = i7;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 i4 = HEAP32[i3 + 36 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i4;
 if (i6 >>> 0 > 1) i2 = 1; else return;
 do {
  i7 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
  f26 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) >> 2]);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 8 >> 2]);
  f17 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 28 >> 2]);
  f16 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 32 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 36 >> 2]);
  f26 = Math_fround(f26 * f17);
  f22 = Math_fround(f22 * f16);
  f20 = Math_fround(f20 * f8);
  f19 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 16 >> 2]);
  f25 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 20 >> 2]);
  f27 = Math_fround(f19 * Math_fround(-2.0));
  f10 = Math_fround(f19 * Math_fround(2.0));
  f24 = Math_fround(f27 * f21);
  f18 = Math_fround(f23 * Math_fround(2.0));
  f9 = Math_fround(f23 * Math_fround(-2.0));
  f28 = Math_fround(f21 * f9);
  f11 = Math_fround(f25 * Math_fround(-2.0));
  f14 = Math_fround(f25 * Math_fround(2.0));
  f13 = Math_fround(f21 * f11);
  f15 = Math_fround(Math_fround(f26 + Math_fround(f26 * Math_fround(Math_fround(f19 * f27) - Math_fround(f23 * f18)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f14 * f23) - f24)) + Math_fround(f22 * Math_fround(f28 - Math_fround(f19 * f11)))));
  f14 = Math_fround(Math_fround(f22 + Math_fround(f26 * Math_fround(Math_fround(f25 * f10) - f28))) + Math_fround(Math_fround(f20 * Math_fround(f13 - Math_fround(f27 * f23))) + Math_fround(f22 * Math_fround(Math_fround(f23 * f9) - Math_fround(f25 * f14)))));
  f13 = Math_fround(Math_fround(f20 + Math_fround(f26 * Math_fround(f24 - Math_fround(f25 * f9)))) + Math_fround(Math_fround(f20 * Math_fround(Math_fround(f25 * f11) - Math_fround(f19 * f10))) + Math_fround(f22 * Math_fround(Math_fround(f19 * f18) - f13))));
  f18 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) >> 2]);
  f22 = Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 4 >> 2]);
  f15 = Math_fround(f18 + f15);
  f14 = Math_fround(f22 + f14);
  f13 = Math_fround(Math_fround(HEAPF32[i1 + (i7 * 40 | 0) + 8 >> 2]) + f13);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 12 >> 2]);
  f18 = Math_fround(f19 * f22);
  f10 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 24 >> 2]);
  f11 = Math_fround(f21 * f10);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 16 >> 2]);
  f9 = Math_fround(f23 * f20);
  f24 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 20 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f18 - Math_fround(f21 * f24)) - Math_fround(f23 * f10)) - Math_fround(f25 * f20));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f25 * f22)) - Math_fround(f23 * f24)) - Math_fround(f19 * f20));
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f19 * f24)) - Math_fround(f21 * f22)) - Math_fround(f25 * f10));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) - Math_fround(f23 * f22)) - Math_fround(f21 * f20)) - Math_fround(f19 * f10));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f10 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 28 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 32 >> 2]);
  f10 = Math_fround(f17 * f10);
  f9 = Math_fround(f16 * f9);
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 36 >> 2]));
  HEAPF32[i1 + (i2 * 40 | 0) >> 2] = f15;
  HEAPF32[i1 + (i2 * 40 | 0) + 4 >> 2] = f14;
  HEAPF32[i1 + (i2 * 40 | 0) + 8 >> 2] = f13;
  HEAP32[i1 + (i2 * 40 | 0) + 12 >> 2] = i12 ^ -2147483648;
  HEAP32[i1 + (i2 * 40 | 0) + 16 >> 2] = i4;
  HEAP32[i1 + (i2 * 40 | 0) + 20 >> 2] = i7 ^ -2147483648;
  HEAPF32[i1 + (i2 * 40 | 0) + 24 >> 2] = f11;
  HEAPF32[i1 + (i2 * 40 | 0) + 28 >> 2] = f10;
  HEAPF32[i1 + (i2 * 40 | 0) + 32 >> 2] = f9;
  HEAPF32[i1 + (i2 * 40 | 0) + 36 >> 2] = f8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_(i4, i5, i6, i7, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i8 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i6 >> 2] | 0) >>> 0 < i8 >>> 0;
 do if (i8 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  if (i1) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 1;
   break;
  };
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  if ((HEAP32[i6 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  if ((HEAP32[i5 >> 2] | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if ((HEAP32[i7 >> 2] | 0) >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
  i8 = i1;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 if ((HEAP32[i6 >> 2] | 0) >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
  i8 = i1 + 1 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 if ((HEAP32[i5 >> 2] | 0) >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
  i8 = i1 + 2 | 0;
  STACKTOP = i3;
  return i8 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i8 = i1 + 3 | 0;
 STACKTOP = i3;
 return i8 | 0;
}

function __ZNK16TypeTreeIterator10DebugPrintERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i4, i12, i9) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i5 = i15 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 if ((i9 | 0) > 0) {
  i1 = 0;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 1074318 | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = i7;
  i3 = i6;
 }
 i10 = HEAP32[i2 + (i3 * 24 | 0) + 8 >> 2] | 0;
 i3 = HEAP32[gb + 36932 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, ((i10 | 0) < 0 ? i3 : HEAP32[i1 + 20 >> 2] | 0) + (i10 & 2147483647) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 468056 | 0) | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, ((i11 | 0) < 0 ? i3 : HEAP32[i10 + 20 >> 2] | 0) + (i11 & 2147483647) | 0) | 0;
 __Z11IntToStringi(i5, HEAP32[i7 + (i6 * 24 | 0) + 12 >> 2] | 0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i11 = i5 + 11 | 0;
 i10 = HEAP8[i11 >> 0] | 0;
 i10 = i10 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, gb + 468063 | 0, 10, i10 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i10) | 0;
 i10 = HEAP8[i13 + 11 >> 0] | 0;
 i11 = i10 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i11 ? HEAP32[i13 >> 2] | 0 : i13, i11 ? HEAP32[i13 + 4 >> 2] | 0 : i10 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __Z11IntToStringi(i5, HEAP32[i7 + (i6 * 24 | 0) + 20 >> 2] | 0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i10 = i5 + 11 | 0;
 i11 = HEAP8[i10 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, gb + 468074 | 0, 10, i11 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i11) | 0;
 i11 = HEAP8[i13 + 11 >> 0] | 0;
 i10 = i11 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i10 ? HEAP32[i13 >> 2] | 0 : i13, i10 ? HEAP32[i13 + 4 >> 2] | 0 : i11 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (HEAP8[i7 + (i6 * 24 | 0) + 3 >> 0] | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 468085 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 468094 | 0) | 0;
 __Z11IntToStringi(i13, HEAP32[i8 >> 2] | 0);
 i11 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i11 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, i1 ? HEAP32[i13 >> 2] | 0 : i13, i1 ? HEAP32[i13 + 4 >> 2] | 0 : i11 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i12, gb + 468109 | 0) | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + (i1 * 24 | 0) | 0;
 if ((i3 + 24 | 0) >>> 0 < (i2 + ((HEAP32[i11 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i3 + 26 >> 0] | 0) == ((HEAPU8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i1 = i1 + 1 | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i1;
  if (!i11) {
   STACKTOP = i15;
   return;
  }
  i7 = i9 + 1 | 0;
  i6 = i13 + 4 | 0;
  i8 = i11 + 12 | 0;
  i9 = i11;
  i10 = (i11 | 0) == 0;
  L15 : while (1) {
   __ZNK16TypeTreeIterator10DebugPrintERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i13, i12, i7);
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
   i4 = i2 + ((HEAP32[i8 >> 2] | 0) * 24 | 0) | 0;
   i5 = i2;
   i2 = i2 + (i1 * 24 | 0) | 0;
   do {
    i1 = i2;
    i2 = i2 + 24 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break L15;
    i1 = HEAP8[i1 + 26 >> 0] | 0;
   } while ((i1 & 255) > (i3 & 255));
   if (i1 << 24 >> 24 != i3 << 24 >> 24) break;
   i1 = (i2 - i5 | 0) / 24 | 0;
   HEAP32[i13 >> 2] = i9;
   HEAP32[i6 >> 2] = i1;
   if (i10) {
    i14 = 11;
    break;
   }
  }
  if ((i14 | 0) == 11) {
   STACKTOP = i15;
   return;
  }
  HEAP32[i13 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN3MBP11shiftOriginERKN5physx6PxVec3E(i26, i1) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, f28 = f0, i29 = 0, i30 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i27;
 i3 = HEAP32[i26 + 8 >> 2] | 0;
 i24 = HEAP32[i26 + 28 >> 2] | 0;
 if (i3 | 0) {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i1 = 0;
  do {
   if (HEAP32[i24 + (i1 * 40 | 0) + 28 >> 2] | 0) {
    i13 = i24 + (i1 * 40 | 0) + 4 | 0;
    i12 = HEAP32[i13 >> 2] << 1;
    i15 = i24 + (i1 * 40 | 0) + 8 | 0;
    i14 = HEAP32[i15 >> 2] << 1;
    i17 = i24 + (i1 * 40 | 0) + 12 | 0;
    i16 = HEAP32[i17 >> 2] << 1;
    i19 = i24 + (i1 * 40 | 0) + 16 | 0;
    i18 = HEAP32[i19 >> 2] << 1;
    i21 = i24 + (i1 * 40 | 0) + 20 | 0;
    i20 = HEAP32[i21 >> 2] << 1;
    i23 = i24 + (i1 * 40 | 0) + 24 | 0;
    i22 = HEAP32[i23 >> 2] << 1;
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i12 | 0) < 0 ? i12 & 2147483646 : ~i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f4);
    i12 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i14 | 0) < 0 ? i14 & 2147483646 : ~i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f5);
    i14 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i16 | 0) < 0 ? i16 & 2147483646 : ~i16, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
    i16 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i18 | 0) < 0 ? i18 & 2147483646 : ~i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f4);
    i18 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i20 | 0) < 0 ? i20 & 2147483646 : ~i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f5);
    i20 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i22 | 0) < 0 ? i22 & 2147483646 : ~i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f2);
    i22 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    HEAP32[i13 >> 2] = ((i12 | 0) < 0 ? i12 ^ -2 : i12 | -2147483648) >>> 1;
    HEAP32[i15 >> 2] = ((i14 | 0) < 0 ? i14 ^ -2 : i14 | -2147483648) >>> 1;
    HEAP32[i17 >> 2] = ((i16 | 0) < 0 ? i16 ^ -2 : i16 | -2147483648) >>> 1;
    HEAP32[i19 >> 2] = ((i18 | 0) < 0 ? i18 ^ -2 : i18 | -2147483648) >>> 1;
    HEAP32[i21 >> 2] = ((i20 | 0) < 0 ? i20 ^ -2 : i20 | -2147483648) >>> 1;
    HEAP32[i23 >> 2] = ((i22 | 0) < 0 ? i22 ^ -2 : i22 | -2147483648) >>> 1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i23 = HEAP32[i26 + 40 >> 2] | 0;
 i19 = (i23 >>> 0) / 3 | 0;
 i20 = HEAP32[i26 + 44 >> 2] | 0;
 if (i23 >>> 0 <= 2) {
  STACKTOP = i27;
  return;
 }
 i21 = i26 + 5260 | 0;
 i22 = i25 + 4 | 0;
 i8 = i25 + 8 | 0;
 i9 = i25 + 12 | 0;
 i10 = i25 + 16 | 0;
 i11 = i25 + 20 | 0;
 i23 = 0;
 do {
  i1 = HEAP16[i20 + (i23 * 12 | 0) + 4 >> 1] | 0;
  i12 = i1 & 65535;
  if (i1 << 16 >> 16) {
   __ZNK5physx14PxsAABBManager11getBPBoundsEj(i25, HEAP32[i21 >> 2] | 0, HEAP32[i20 + (i23 * 12 | 0) >> 2] | 0);
   i13 = HEAP32[i25 >> 2] | 0;
   i13 = ((i13 | 0) < 0 ? i13 ^ -2 : i13 | -2147483648) >>> 1;
   i14 = HEAP32[i22 >> 2] | 0;
   i14 = ((i14 | 0) < 0 ? i14 ^ -2 : i14 | -2147483648) >>> 1;
   i15 = HEAP32[i8 >> 2] | 0;
   i15 = ((i15 | 0) < 0 ? i15 ^ -2 : i15 | -2147483648) >>> 1;
   i16 = HEAP32[i9 >> 2] | 0;
   i16 = ((i16 | 0) < 0 ? i16 ^ -2 : i16 | -2147483648) >>> 1;
   i17 = HEAP32[i10 >> 2] | 0;
   i17 = ((i17 | 0) < 0 ? i17 ^ -2 : i17 | -2147483648) >>> 1;
   i18 = HEAP32[i11 >> 2] | 0;
   i18 = ((i18 | 0) < 0 ? i18 ^ -2 : i18 | -2147483648) >>> 1;
   i3 = i20 + (i23 * 12 | 0) + 8 | 0;
   if (i1 << 16 >> 16 != 1) i3 = (HEAP32[i26 + 96 + (i12 << 4) + 8 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0;
   i7 = 0;
   do {
    i1 = HEAP32[i24 + ((HEAPU16[i3 + (i7 << 2) + 2 >> 1] | 0) * 40 | 0) + 28 >> 2] | 0;
    i29 = HEAPU16[i3 + (i7 << 2) >> 1] | 0;
    i30 = HEAP32[i1 + 76 >> 2] | 0;
    i6 = HEAP32[i30 + (i29 << 3) >> 2] | 0;
    if (!(HEAP32[i30 + (i29 << 3) + 4 >> 2] & 1)) {
     i30 = HEAP32[i1 + 100 >> 2] | 0;
     HEAP32[i30 + (i6 * 24 | 0) >> 2] = i13;
     HEAP32[i30 + (i6 * 24 | 0) + 4 >> 2] = i14;
     HEAP32[i30 + (i6 * 24 | 0) + 8 >> 2] = i15;
     HEAP32[i30 + (i6 * 24 | 0) + 12 >> 2] = i16;
     HEAP32[i30 + (i6 * 24 | 0) + 16 >> 2] = i17;
     HEAP32[i30 + (i6 * 24 | 0) + 20 >> 2] = i18;
    } else {
     i30 = HEAP32[i1 + 96 >> 2] | 0;
     HEAP32[i30 + (i6 * 24 | 0) >> 2] = i13;
     HEAP32[i30 + (i6 * 24 | 0) + 4 >> 2] = i14;
     HEAP32[i30 + (i6 * 24 | 0) + 8 >> 2] = i15;
     HEAP32[i30 + (i6 * 24 | 0) + 12 >> 2] = i16;
     HEAP32[i30 + (i6 * 24 | 0) + 16 >> 2] = i17;
     HEAP32[i30 + (i6 * 24 | 0) + 20 >> 2] = i18;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i12 | 0));
  }
  i23 = i23 + 1 | 0;
 } while (i23 >>> 0 < i19 >>> 0);
 STACKTOP = i27;
 return;
}

function __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 68 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i6 + 104 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 108 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 116 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 124 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 144 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i7, i9, 0);
  i9 = i6 + 128 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i9, 0);
  i9 = HEAP32[i1 >> 2] | 0;
  i9 = i9 & -13;
  i9 = i9 | 8;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 144 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i7, i9, 0);
  i9 = i6 + 128 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i9, 0);
  i9 = HEAP32[i1 >> 2] | 0;
  i9 = i9 & -13;
  i9 = i9 | 8;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function runPostSets1() {
 HEAP32[gb + 15312 >> 2] = (HEAP32[gb + 15312 >> 2] | 0) + (gb + 359942 | 0);
 HEAP32[gb + 15316 >> 2] = (HEAP32[gb + 15316 >> 2] | 0) + (gb + 36e4 | 0);
 HEAP32[gb + 15320 >> 2] = (HEAP32[gb + 15320 >> 2] | 0) + (gb + 360031 | 0);
 HEAP32[gb + 15324 >> 2] = (HEAP32[gb + 15324 >> 2] | 0) + (gb + 360046 | 0);
 HEAP32[gb + 15328 >> 2] = (HEAP32[gb + 15328 >> 2] | 0) + (gb + 360075 | 0);
 HEAP32[gb + 15332 >> 2] = (HEAP32[gb + 15332 >> 2] | 0) + (gb + 360105 | 0);
 HEAP32[gb + 15336 >> 2] = (HEAP32[gb + 15336 >> 2] | 0) + (gb + 360134 | 0);
 HEAP32[gb + 15340 >> 2] = (HEAP32[gb + 15340 >> 2] | 0) + (gb + 360159 | 0);
 HEAP32[gb + 15344 >> 2] = (HEAP32[gb + 15344 >> 2] | 0) + (gb + 360184 | 0);
 HEAP32[gb + 15348 >> 2] = (HEAP32[gb + 15348 >> 2] | 0) + (gb + 360250 | 0);
 HEAP32[gb + 15352 >> 2] = (HEAP32[gb + 15352 >> 2] | 0) + (gb + 360308 | 0);
 HEAP32[gb + 15356 >> 2] = (HEAP32[gb + 15356 >> 2] | 0) + (gb + 360362 | 0);
 HEAP32[gb + 15360 >> 2] = (HEAP32[gb + 15360 >> 2] | 0) + (gb + 360414 | 0);
 HEAP32[gb + 15364 >> 2] = (HEAP32[gb + 15364 >> 2] | 0) + (gb + 360434 | 0);
 HEAP32[gb + 15368 >> 2] = (HEAP32[gb + 15368 >> 2] | 0) + (gb + 360457 | 0);
 HEAP32[gb + 15372 >> 2] = (HEAP32[gb + 15372 >> 2] | 0) + (gb + 360495 | 0);
 HEAP32[gb + 15376 >> 2] = (HEAP32[gb + 15376 >> 2] | 0) + (gb + 360561 | 0);
 HEAP32[gb + 15380 >> 2] = (HEAP32[gb + 15380 >> 2] | 0) + (gb + 360621 | 0);
 HEAP32[gb + 15384 >> 2] = (HEAP32[gb + 15384 >> 2] | 0) + (gb + 360670 | 0);
 HEAP32[gb + 15388 >> 2] = (HEAP32[gb + 15388 >> 2] | 0) + (gb + 360706 | 0);
 HEAP32[gb + 15392 >> 2] = (HEAP32[gb + 15392 >> 2] | 0) + (gb + 360752 | 0);
 HEAP32[gb + 15396 >> 2] = (HEAP32[gb + 15396 >> 2] | 0) + (gb + 360779 | 0);
 HEAP32[gb + 15400 >> 2] = (HEAP32[gb + 15400 >> 2] | 0) + (gb + 360835 | 0);
 HEAP32[gb + 15404 >> 2] = (HEAP32[gb + 15404 >> 2] | 0) + (gb + 360878 | 0);
 HEAP32[gb + 15408 >> 2] = (HEAP32[gb + 15408 >> 2] | 0) + (gb + 360921 | 0);
 HEAP32[gb + 16328 >> 2] = (HEAP32[gb + 16328 >> 2] | 0) + (gb + 362390 | 0);
 HEAP32[gb + 16332 >> 2] = (HEAP32[gb + 16332 >> 2] | 0) + (gb + 362406 | 0);
 HEAP32[gb + 16336 >> 2] = (HEAP32[gb + 16336 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 16340 >> 2] = (HEAP32[gb + 16340 >> 2] | 0) + (gb + 362417 | 0);
 HEAP32[gb + 16344 >> 2] = (HEAP32[gb + 16344 >> 2] | 0) + (gb + 362428 | 0);
 HEAP32[gb + 16348 >> 2] = (HEAP32[gb + 16348 >> 2] | 0) + (gb + 362441 | 0);
 HEAP32[gb + 16352 >> 2] = (HEAP32[gb + 16352 >> 2] | 0) + (gb + 362452 | 0);
 HEAP32[gb + 16356 >> 2] = (HEAP32[gb + 16356 >> 2] | 0) + (gb + 362472 | 0);
 HEAP32[gb + 16360 >> 2] = (HEAP32[gb + 16360 >> 2] | 0) + (gb + 362485 | 0);
 HEAP32[gb + 16364 >> 2] = (HEAP32[gb + 16364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 16376 >> 2] = fb + 1;
 HEAP32[gb + 16388 >> 2] = fb + 2;
 HEAP32[gb + 16400 >> 2] = fb + 2;
 HEAP32[gb + 16412 >> 2] = fb + 2;
 HEAP32[gb + 16424 >> 2] = fb + 3;
 HEAP32[gb + 16436 >> 2] = fb + 3;
 HEAP32[gb + 16448 >> 2] = fb + 3;
 HEAP32[gb + 16460 >> 2] = fb + 3;
 HEAP32[gb + 16472 >> 2] = fb + 3;
 HEAP32[gb + 16484 >> 2] = fb + 3;
 HEAP32[gb + 25152 >> 2] = (HEAP32[gb + 25152 >> 2] | 0) + (gb + 216912 | 0);
 HEAP32[gb + 25156 >> 2] = (HEAP32[gb + 25156 >> 2] | 0) + (gb + 16488 | 0);
 HEAP32[gb + 25172 >> 2] = (HEAP32[gb + 25172 >> 2] | 0) + (gb + 218064 | 0);
 HEAP32[gb + 25176 >> 2] = (HEAP32[gb + 25176 >> 2] | 0) + (gb + 16720 | 0);
 HEAP32[gb + 25196 >> 2] = (HEAP32[gb + 25196 >> 2] | 0) + (gb + 25212 | 0);
 HEAP32[gb + 25288 >> 2] = fb + 4;
 HEAP32[gb + 25292 >> 2] = fb + 1;
 HEAP32[gb + 25296 >> 2] = fb + 1;
 HEAP32[gb + 25336 >> 2] = fb + 1;
 HEAP32[gb + 25340 >> 2] = fb + 2;
 HEAP32[gb + 25344 >> 2] = fb + 3;
 HEAP32[gb + 25348 >> 2] = fb + 4;
 HEAP32[gb + 25352 >> 2] = fb + 1;
 HEAP32[gb + 25356 >> 2] = fb + 1;
 HEAP32[gb + 25360 >> 2] = fb + 2;
 HEAP32[gb + 25364 >> 2] = fb + 3;
 HEAP32[gb + 25368 >> 2] = fb + 5;
 HEAP32[gb + 25372 >> 2] = fb + 1;
 HEAP32[gb + 25376 >> 2] = fb + 2;
 HEAP32[gb + 25380 >> 2] = fb + 6;
 HEAP32[gb + 25384 >> 2] = fb + 2;
 HEAP32[gb + 25388 >> 2] = fb + 7;
 HEAP32[gb + 25392 >> 2] = fb + 3;
 HEAP32[gb + 25396 >> 2] = fb + 8;
 HEAP32[gb + 25400 >> 2] = fb + 4;
 HEAP32[gb + 25404 >> 2] = fb + 9;
 HEAP32[gb + 25408 >> 2] = fb + 10;
 HEAP32[gb + 25412 >> 2] = fb + 11;
 HEAP32[gb + 25416 >> 2] = fb + 12;
 HEAP32[gb + 25420 >> 2] = fb + 4;
 HEAP32[gb + 25424 >> 2] = fb + 13;
 HEAP32[gb + 25428 >> 2] = fb + 5;
 HEAP32[gb + 25432 >> 2] = fb + 14;
 HEAP32[gb + 25436 >> 2] = fb + 5;
 HEAP32[gb + 25440 >> 2] = fb + 6;
 HEAP32[gb + 25444 >> 2] = (HEAP32[gb + 25444 >> 2] | 0) + (gb + 363161 | 0);
 HEAP32[gb + 25456 >> 2] = fb + 7;
 HEAP32[gb + 25460 >> 2] = fb + 8;
 HEAP32[gb + 25464 >> 2] = fb + 1;
 HEAP32[gb + 25468 >> 2] = fb + 15;
 HEAP32[gb + 25472 >> 2] = fb + 1;
 HEAP32[gb + 25476 >> 2] = fb + 1;
 HEAP32[gb + 25480 >> 2] = fb + 6;
 HEAP32[gb + 25484 >> 2] = fb + 7;
 HEAP32[gb + 25488 >> 2] = fb + 16;
 HEAP32[gb + 25492 >> 2] = fb + 8;
 HEAP32[gb + 25496 >> 2] = fb + 17;
 HEAP32[gb + 25500 >> 2] = fb + 9;
 HEAP32[gb + 25504 >> 2] = fb + 18;
 HEAP32[gb + 25508 >> 2] = fb + 10;
 HEAP32[gb + 25512 >> 2] = fb + 19;
 HEAP32[gb + 25516 >> 2] = fb + 11;
 HEAP32[gb + 25520 >> 2] = fb + 20;
 HEAP32[gb + 25524 >> 2] = fb + 12;
 HEAP32[gb + 25528 >> 2] = fb + 21;
 runPostSets2();
}

function __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i15, i16, i14, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 i8 = i16 + 12 | 0;
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(Math_fround(f2 + f3) * Math_fround(.5));
 f13 = Math_fround(HEAPF32[i15 >> 2]);
 i9 = i15 + 12 | 0;
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 i7 = f17 < Math_fround(Math_fround(f13 + f10) * Math_fround(.5));
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 i11 = i14 + 12 | 0;
 i12 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < f17;
 if (!i7) {
  if (!i12) {
   i16 = 0;
   return i16 | 0;
  }
  i1 = i16 + 4 | 0;
  i22 = HEAP32[i1 >> 2] | 0;
  i4 = i16 + 8 | 0;
  i21 = HEAP32[i4 >> 2] | 0;
  i5 = i16 + 16 | 0;
  i20 = HEAP32[i5 >> 2] | 0;
  i6 = i16 + 20 | 0;
  i19 = HEAP32[i6 >> 2] | 0;
  i7 = i16 + 24 | 0;
  i12 = i7;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i16 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAPF32[i14 >> 2] = f2;
  HEAP32[i14 + 4 >> 2] = i22;
  HEAP32[i14 + 8 >> 2] = i21;
  HEAPF32[i14 + 12 >> 2] = f3;
  HEAP32[i14 + 16 >> 2] = i20;
  HEAP32[i14 + 20 >> 2] = i19;
  i14 = i14 + 24 | 0;
  HEAP32[i14 >> 2] = i11;
  HEAP32[i14 + 4 >> 2] = i12;
  f18 = Math_fround(HEAPF32[i16 >> 2]);
  f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i9 >> 2]);
  if (!(f18 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i22 = 1;
   return i22 | 0;
  }
  i12 = HEAP32[i15 + 4 >> 2] | 0;
  i14 = HEAP32[i15 + 8 >> 2] | 0;
  i19 = HEAP32[i15 + 16 >> 2] | 0;
  i22 = HEAP32[i15 + 20 >> 2] | 0;
  i21 = i15 + 24 | 0;
  i20 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 4 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP32[i15 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
  HEAP32[i15 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
  HEAPF32[i16 >> 2] = f3;
  HEAP32[i1 >> 2] = i12;
  HEAP32[i4 >> 2] = i14;
  HEAPF32[i16 + 12 >> 2] = f2;
  HEAP32[i5 >> 2] = i19;
  HEAP32[i6 >> 2] = i22;
  i22 = i7;
  HEAP32[i22 >> 2] = i20;
  HEAP32[i22 + 4 >> 2] = i21;
  i22 = 2;
  return i22 | 0;
 }
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i4 = HEAP32[i15 + 8 >> 2] | 0;
 i5 = HEAP32[i15 + 16 >> 2] | 0;
 i6 = HEAP32[i15 + 20 >> 2] | 0;
 i8 = i15 + 24 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 if (i12) {
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i15 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i15 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAPF32[i14 >> 2] = f13;
  HEAP32[i14 + 4 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i4;
  HEAPF32[i14 + 12 >> 2] = f10;
  HEAP32[i14 + 16 >> 2] = i5;
  HEAP32[i14 + 20 >> 2] = i6;
  i22 = i14 + 24 | 0;
  HEAP32[i22 >> 2] = i7;
  HEAP32[i22 + 4 >> 2] = i8;
  i22 = 1;
  return i22 | 0;
 };
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 HEAPF32[i16 >> 2] = f13;
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = i4;
 HEAPF32[i16 + 12 >> 2] = f10;
 HEAP32[i16 + 16 >> 2] = i5;
 HEAP32[i16 + 20 >> 2] = i6;
 i22 = i16 + 24 | 0;
 HEAP32[i22 >> 2] = i7;
 HEAP32[i22 + 4 >> 2] = i8;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i11 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f13 + f10) * Math_fround(.5)))) {
  i22 = 1;
  return i22 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 HEAPF32[i14 >> 2] = f13;
 HEAP32[i14 + 4 >> 2] = i1;
 HEAP32[i14 + 8 >> 2] = i4;
 HEAPF32[i14 + 12 >> 2] = f10;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = i6;
 i22 = i14 + 24 | 0;
 HEAP32[i22 >> 2] = i7;
 HEAP32[i22 + 4 >> 2] = i8;
 i22 = 2;
 return i22 | 0;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvPKjtPKtj(i27, i11, i4, i22, i21) {
 i27 = i27 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28 + 52 | 0;
 i24 = i28 + 32 | 0;
 i25 = i28 + 16 | 0;
 i26 = i28;
 i7 = HEAP32[i27 + 48 >> 2] | 0;
 i19 = HEAP32[i7 + 4 >> 2] | 0;
 i20 = HEAP32[i7 + 240 >> 2] | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i3 = i9 & 65535;
 i3 = i3 >>> 0 > i21 >>> 0 ? i21 : i3;
 i18 = i9 + i21 | 0;
 i6 = i9 | 65535;
 i6 = i18 >>> 0 < i6 >>> 0 ? i18 : i6;
 HEAP32[i23 >> 2] = i11;
 if (i9 >>> 0 < i6 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i6 >>> 0);
  i8 = i1;
 } else {
  i2 = i9;
  i8 = i11;
 }
 i5 = i9 - i3 | 0;
 HEAP32[i24 >> 2] = i8;
 i3 = i5 + 65536 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i1 = i8;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else i1 = i8;
 HEAP32[i23 + 4 >> 2] = i1;
 i3 = i6 + 65536 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i24 + 4 >> 2] = i1;
 i3 = i5 + 16711680 | 0;
 i1 = i11 + ((i4 & 65535) << 2) | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) i1 = i1 + 4 | 0; else break;
 }
 HEAP32[i23 + 8 >> 2] = i1;
 i3 = i6 + 16711680 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i24 + 8 >> 2] = i1;
 i3 = i5 + 16777216 | 0;
 if (i9 >>> 0 < i3 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  i2 = i9;
  i1 = i11;
 }
 HEAP32[i23 + 12 >> 2] = i1;
 i3 = i6 + 16777216 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i24 + 12 >> 2] = i1;
 i3 = i5 + 16842752 | 0;
 if (i9 >>> 0 < i3 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  i2 = i9;
  i1 = i11;
 }
 HEAP32[i23 + 16 >> 2] = i1;
 i3 = i6 + 16842752 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i24 + 16 >> 2] = i1;
 i18 = HEAP32[i7 + 232 >> 2] | 0;
 i12 = i22 + (i18 << 1) | 0;
 if (!i18) {
  STACKTOP = i28;
  return;
 }
 i13 = i25 + 4 | 0;
 i14 = i25 + 8 | 0;
 i15 = i25 + 12 | 0;
 i16 = i26 + 4 | 0;
 i17 = i26 + 8 | 0;
 i18 = i26 + 12 | 0;
 i2 = i9;
 i1 = i8;
 i10 = i22;
 while (1) {
  i9 = HEAPU16[i10 >> 1] | 0;
  HEAP32[i25 >> 2] = HEAP32[i19 + (i9 << 4) >> 2];
  HEAP32[i13 >> 2] = HEAP32[i19 + (i9 << 4) + 4 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i19 + (i9 << 4) + 8 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i19 + (i9 << 4) + 12 >> 2];
  HEAP32[i26 >> 2] = HEAP32[i20 + (i9 << 4) >> 2];
  HEAP32[i16 >> 2] = HEAP32[i20 + (i9 << 4) + 4 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i20 + (i9 << 4) + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i20 + (i9 << 4) + 12 >> 2];
  i9 = i2 & 65535;
  i9 = i2 - (i9 >>> 0 > i21 >>> 0 ? i21 : i9) | 0;
  i7 = i2 + i21 | 0;
  i8 = i2 | 65535;
  i8 = i7 >>> 0 < i8 >>> 0 ? i7 : i8;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 < i8 >>> 0) {
   do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i8 >>> 0);
   HEAP32[i24 >> 2] = i1;
  }
  i1 = i22 + (i1 - i11 >> 2 << 1) | 0;
  i7 = i10 + 2 | 0;
  if ((i7 | 0) == (i1 | 0)) i6 = 1; else {
   i2 = i7;
   do {
    i6 = HEAPU16[i2 >> 1] | 0;
    __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvRS2_S5_RKS2_S7_(i27, i25, i19 + (i6 << 4) | 0, i26, i20 + (i6 << 4) | 0);
    i2 = i2 + 2 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i6 = 1;
  }
  do {
   i4 = HEAP32[gb + 168536 + (i6 << 2) >> 2] | 0;
   i2 = i9 + i4 | 0;
   i3 = i23 + (i6 << 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i3 >> 2] = i1;
    i5 = i1;
   } else i5 = i1;
   i2 = i4 + i8 | 0;
   i3 = i24 + (i6 << 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i3 >> 2] = i1;
   }
   i4 = i1 - i11 >> 2;
   i2 = i22 + (i4 << 1) | 0;
   i1 = i5 - i11 >> 2;
   if ((i1 | 0) != (i4 | 0)) {
    i1 = i22 + (i1 << 1) | 0;
    do {
     i5 = HEAPU16[i1 >> 1] | 0;
     __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvRS2_S5_RKS2_S7_(i27, i25, i19 + (i5 << 4) | 0, i26, i20 + (i5 << 4) | 0);
     i1 = i1 + 2 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 5);
  i1 = HEAPU16[i10 >> 1] | 0;
  HEAP32[i19 + (i1 << 4) >> 2] = HEAP32[i25 >> 2];
  HEAP32[i19 + (i1 << 4) + 4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i19 + (i1 << 4) + 8 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 + (i1 << 4) + 12 >> 2] = HEAP32[i15 >> 2];
  i1 = (HEAP32[i23 >> 2] | 0) + 4 | 0;
  HEAP32[i23 >> 2] = i1;
  if ((i7 | 0) == (i12 | 0)) break;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i24 >> 2] | 0;
  i10 = i7;
 }
 STACKTOP = i28;
 return;
}

function __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE(i33, i1, i35, i37, i34, f2, i36) {
 i33 = i33 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i37 = i37 | 0;
 i34 = i34 | 0;
 f2 = Math_fround(f2);
 i36 = i36 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, i50 = 0, f51 = f0, f52 = f0, f53 = f0, i54 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i32 + 92 | 0;
 i24 = i32 + 96 | 0;
 i29 = i32 + 80 | 0;
 i30 = i32 + 68 | 0;
 i27 = i32 + 56 | 0;
 i28 = i32 + 44 | 0;
 i25 = i32 + 40 | 0;
 i26 = i32 + 36 | 0;
 i31 = i32 + 24 | 0;
 i22 = i32 + 12 | 0;
 i23 = i32;
 HEAPF32[i21 >> 2] = f2;
 i1 = HEAP32[i33 + 124 >> 2] | 0;
 if (!(i1 & 2)) i1 = i1 >>> 3 & 1; else i1 = 1;
 HEAP8[i24 >> 0] = i1;
 HEAPF32[i29 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i29 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i30 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i30 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i28 >> 2] = Math_fround(0.0);
 HEAPF32[i28 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i28 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i25 >> 2] = Math_fround(0.0);
 HEAPF32[i26 >> 2] = Math_fround(0.0);
 if (!i34) {
  STACKTOP = i32;
  return;
 }
 i4 = i35 + 4 | 0;
 i5 = i35 + 8 | 0;
 i6 = i35 + 12 | 0;
 i7 = i35 + 16 | 0;
 i8 = i35 + 20 | 0;
 i9 = i35 + 24 | 0;
 i10 = i35 + 28 | 0;
 i11 = i35 + 32 | 0;
 i12 = i31 + 4 | 0;
 i13 = i31 + 8 | 0;
 i14 = i33 + 112 | 0;
 i15 = i33 + 128 | 0;
 i16 = i22 + 4 | 0;
 i17 = i22 + 8 | 0;
 i18 = i23 + 4 | 0;
 i19 = i23 + 8 | 0;
 i20 = i33 + 92 | 0;
 i3 = 0;
 while (1) {
  i50 = i3 * 3 | 0;
  f2 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) >> 2]);
  f53 = Math_fround(HEAPF32[i35 >> 2]);
  f39 = Math_fround(f2 * f53);
  f52 = Math_fround(HEAPF32[i4 >> 2]);
  f40 = Math_fround(f2 * f52);
  f47 = Math_fround(HEAPF32[i5 >> 2]);
  f2 = Math_fround(f2 * f47);
  f43 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) + 4 >> 2]);
  f49 = Math_fround(HEAPF32[i6 >> 2]);
  f44 = Math_fround(f43 * f49);
  f48 = Math_fround(HEAPF32[i7 >> 2]);
  f45 = Math_fround(f43 * f48);
  f41 = Math_fround(HEAPF32[i8 >> 2]);
  f44 = Math_fround(f39 + f44);
  f45 = Math_fround(f40 + f45);
  f43 = Math_fround(f2 + Math_fround(f43 * f41));
  f2 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) + 8 >> 2]);
  f40 = Math_fround(HEAPF32[i9 >> 2]);
  f39 = Math_fround(f2 * f40);
  f42 = Math_fround(HEAPF32[i10 >> 2]);
  f38 = Math_fround(f2 * f42);
  f46 = Math_fround(HEAPF32[i11 >> 2]);
  f39 = Math_fround(f44 + f39);
  f38 = Math_fround(f45 + f38);
  f2 = Math_fround(f43 + Math_fround(f2 * f46));
  HEAPF32[i31 >> 2] = f39;
  HEAPF32[i12 >> 2] = f38;
  HEAPF32[i13 >> 2] = f2;
  i54 = i50 + 1 | 0;
  f43 = Math_fround(HEAPF32[i37 + (i54 * 12 | 0) >> 2]);
  f45 = Math_fround(f43 * f53);
  f44 = Math_fround(f43 * f52);
  f43 = Math_fround(f43 * f47);
  f51 = Math_fround(HEAPF32[i37 + (i54 * 12 | 0) + 4 >> 2]);
  f45 = Math_fround(f45 + Math_fround(f51 * f49));
  f44 = Math_fround(f44 + Math_fround(f51 * f48));
  f51 = Math_fround(f43 + Math_fround(f51 * f41));
  f43 = Math_fround(HEAPF32[i37 + (i54 * 12 | 0) + 8 >> 2]);
  f45 = Math_fround(f45 + Math_fround(f43 * f40));
  f44 = Math_fround(f44 + Math_fround(f43 * f42));
  f43 = Math_fround(f51 + Math_fround(f43 * f46));
  i50 = i50 + 2 | 0;
  f51 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) >> 2]);
  f53 = Math_fround(f53 * f51);
  f52 = Math_fround(f52 * f51);
  f51 = Math_fround(f47 * f51);
  f47 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) + 4 >> 2]);
  f49 = Math_fround(f53 + Math_fround(f49 * f47));
  f48 = Math_fround(f52 + Math_fround(f48 * f47));
  f47 = Math_fround(f51 + Math_fround(f41 * f47));
  f41 = Math_fround(HEAPF32[i37 + (i50 * 12 | 0) + 8 >> 2]);
  f40 = Math_fround(f49 + Math_fround(f40 * f41));
  f42 = Math_fround(f48 + Math_fround(f42 * f41));
  f41 = Math_fround(f47 + Math_fround(f46 * f41));
  f44 = Math_fround(f44 - f38);
  f43 = Math_fround(f43 - f2);
  HEAPF32[i22 >> 2] = Math_fround(f45 - f39);
  HEAPF32[i16 >> 2] = f44;
  HEAPF32[i17 >> 2] = f43;
  f38 = Math_fround(f42 - f38);
  f2 = Math_fround(f41 - f2);
  HEAPF32[i23 >> 2] = Math_fround(f40 - f39);
  HEAPF32[i18 >> 2] = f38;
  HEAPF32[i19 >> 2] = f2;
  i1 = __ZN5physx23collideWithMeshTriangleERNS_6PxVec3ES1_S1_S1_RfS2_RKS0_S4_S4_S4_S4_bRKfS6_(i29, i30, i27, i28, i25, i26, i14, i15, i31, i22, i23, i1 << 24 >> 24 != 0, i20, i21) | 0;
  f2 = Math_fround(HEAPF32[i25 >> 2]);
  __Z19updateCollShapeDataRN5physx19PxsParticleCollDataERbjffRKNS_6PxVec3ES5_S5_S5_RKNS_11PxTransformE(i33, i24, i1, f2, Math_fround(HEAPF32[i26 >> 2]), i29, i30, i27, i28, i36);
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i34 | 0)) break;
  i1 = HEAP8[i24 >> 0] | 0;
 }
 STACKTOP = i32;
 return;
}

function __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EE13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS8_EERSE_(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i8 = HEAP32[i11 >> 2] | 0;
 i3 = i8;
 i7 = ((HEAP32[i2 >> 2] | 0) - i3 | 0) / 24 | 0;
 i13 = i8 + (i7 * 24 | 0) | 0;
 i14 = i11 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i5 = i11 + 8 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i4 = i2;
 i6 = i10;
 if (i2 >>> 0 < i10 >>> 0) {
  if ((i13 | 0) == (i2 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + (i7 * 24 | 0) + 12 | 0, i1 + 12 | 0);
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 24;
   i14 = i13;
   STACKTOP = i15;
   return i14 | 0;
  }
  i5 = i4 - (i13 + 24) | 0;
  i3 = i13 + (((i5 | 0) / 24 | 0) * 24 | 0) | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   i4 = i3;
   i6 = i2;
   do {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i4);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6 + 12 | 0, i4 + 12 | 0);
    i4 = i4 + 24 | 0;
    i6 = (HEAP32[i14 >> 2] | 0) + 24 | 0;
    HEAP32[i14 >> 2] = i6;
   } while (i4 >>> 0 < i2 >>> 0);
  }
  if (i5 | 0) do {
   i11 = i2;
   i2 = i2 + -24 | 0;
   i12 = i3;
   i3 = i3 + -24 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i11 + -12 | 0, i12 + -12 | 0) | 0;
  } while ((i3 | 0) != (i13 | 0));
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 24 | 0 : i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i13, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + (i7 * 24 | 0) + 12 | 0, i1 + 12 | 0) | 0;
  i14 = i13;
  STACKTOP = i15;
  return i14 | 0;
 }
 i10 = i11 + 12 | 0;
 i9 = i4 - i3 | 0;
 i4 = ((i9 | 0) / 24 | 0) + 1 | 0;
 if ((i9 | 0) < -24) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i9 = i5;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i5;
  i2 = i6;
 }
 i8 = (i2 - i3 | 0) / 24 | 0;
 i7 = i8 << 1;
 i7 = i8 >>> 0 < 1073741823 ? (i7 >>> 0 < i4 >>> 0 ? i4 : i7) : 2147483647;
 i3 = i13 - i3 | 0;
 i4 = (i3 | 0) / 24 | 0;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = 37;
  HEAP32[i12 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i5 = i8 + (i4 * 24 | 0) | 0;
 i6 = i5;
 i2 = i8 + (i7 * 24 | 0) | 0;
 do if ((i4 | 0) == (i7 | 0)) {
  if ((i3 | 0) > 0) {
   i6 = i5 + (((i7 + 1 | 0) / -2 | 0) * 24 | 0) | 0;
   break;
  }
  i3 = i7 * 24 | 0;
  i3 = (i3 | 0) == 0 ? 1 : ((i3 | 0) / 24 | 0) << 1;
  if (!i3) i2 = 0; else {
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP32[i12 >> 2] = 37;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  }
  i4 = i2 + ((i3 >>> 2) * 24 | 0) | 0;
  i2 = i2 + (i3 * 24 | 0) | 0;
  if (!i8) i6 = i4; else {
   i6 = HEAP32[i10 >> 2] | 0;
   HEAP32[i12 >> 2] = 37;
   HEAP32[i12 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
   i6 = i4;
  }
 } while (0);
 i3 = i6;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 12 | 0, i1 + 12 | 0);
 i1 = i3 + 24 | 0;
 i3 = i1;
 i8 = i6;
 i7 = HEAP32[i11 >> 2] | 0;
 if ((i7 | 0) == (i13 | 0)) i4 = i8; else {
  i5 = i13;
  i4 = i8;
  do {
   i16 = i5;
   i5 = i5 + -24 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4 + -24 | 0, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4 + -12 | 0, i16 + -12 | 0);
   i4 = i6 + -24 | 0;
   i6 = i4;
  } while ((i5 | 0) != (i7 | 0));
 }
 i5 = HEAP32[i14 >> 2] | 0;
 if ((i5 | 0) == (i13 | 0)) {
  i5 = i3;
  i1 = i13;
 } else {
  i4 = i13;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 12 | 0, i4 + 12 | 0);
   i4 = i4 + 24 | 0;
   i1 = i3 + 24 | 0;
   i3 = i1;
  } while ((i4 | 0) != (i5 | 0));
  i5 = i3;
  i4 = i6;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i3 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i9 >> 2] = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
  i1 = i1 + -24 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i3 | 0));
 if (!i3) {
  i16 = i8;
  STACKTOP = i15;
  return i16 | 0;
 }
 i16 = HEAP32[i10 >> 2] | 0;
 HEAP32[i12 >> 2] = 37;
 HEAP32[i12 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i12);
 i16 = i8;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN17RemapPPtrTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i25 + 60 | 0;
 i19 = i25;
 i20 = i19 + 24 | 0;
 HEAP8[i20 >> 0] = 1;
 i21 = i19 + 28 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i19 + 32 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i19 + 36 | 0;
 HEAP32[i23 >> 2] = -1;
 i24 = i19 + 44 | 0;
 HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
 i14 = i19 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i8 = i1 + 4 | 0;
 i15 = i19 + 4 | 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0) & 1;
 HEAP8[i15 >> 0] = i3;
 i16 = i19 + 8 | 0;
 HEAP32[i16 >> 2] = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0) | 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i24 >> 2] = i2;
 HEAP32[i19 + 40 >> 2] = i2;
 HEAP32[i19 + 48 >> 2] = i8;
 i8 = i8 - i2 >> 6;
 HEAP32[i19 + 56 >> 2] = i8;
 HEAP32[i19 + 52 >> 2] = i8;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
 if (!i8) {
  STACKTOP = i25;
  return;
 }
 i9 = i19 + 40 | 0;
 i10 = i19 + 20 | 0;
 i11 = i18 + 20 | 0;
 i12 = i18 + 16 | 0;
 if (!i7) {
  i1 = 0;
  while (1) {
   HEAP32[i24 >> 2] = i2;
   HEAP32[i10 >> 2] = i9;
   if (!(i3 << 24 >> 24)) {
    i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
    if (!i1) {
     i1 = _il2cpp_object_new(HEAP32[i17 >> 2] | 0) | 0;
     __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
     __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, HEAP32[i14 >> 2] | 0, i1);
    }
    i3 = HEAP32[i17 >> 2] | 0;
    HEAP8[i20 >> 0] = 1;
    HEAP32[i21 >> 2] = i1;
    HEAP32[i22 >> 2] = i3;
    i3 = HEAP32[i10 >> 2] | 0;
    i1 = -1;
   } else {
    i7 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    i1 = (Math_imul(HEAP32[i16 >> 2] | 0, i1) | 0) + 16 | 0;
    HEAP8[i20 >> 0] = 0;
    HEAP32[i21 >> 2] = i7;
    HEAP32[i22 >> 2] = i3;
    i3 = i9;
   }
   HEAP32[i23 >> 2] = i1;
   HEAP32[i11 >> 2] = i13;
   HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i12 >> 2] = i3;
   i4 = i3 + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i5 = i3 + 8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i3 = i3 + 12 | 0;
    do {
     i7 = i1 + 64 | 0;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i3 >> 2] = i2 - i7 >> 6;
     mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i18 | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i1 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
   HEAP32[i14 >> 2] = i1;
   if ((i1 | 0) == (i8 | 0)) break;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP8[i15 >> 0] | 0;
  }
  STACKTOP = i25;
  return;
 } else {
  i1 = 0;
  while (1) {
   HEAP32[i24 >> 2] = i2;
   HEAP32[i10 >> 2] = i9;
   if (!(i3 << 24 >> 24)) {
    i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
    if (!i1) {
     i1 = _il2cpp_object_new(HEAP32[i17 >> 2] | 0) | 0;
     __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
     __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, HEAP32[i14 >> 2] | 0, i1);
    }
    i2 = HEAP32[i17 >> 2] | 0;
    HEAP8[i20 >> 0] = 1;
    HEAP32[i21 >> 2] = i1;
    i1 = -1;
   } else {
    i6 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    i1 = (Math_imul(HEAP32[i16 >> 2] | 0, i1) | 0) + 16 | 0;
    HEAP8[i20 >> 0] = 0;
    HEAP32[i21 >> 2] = i6;
   }
   HEAP32[i22 >> 2] = i2;
   HEAP32[i23 >> 2] = i1;
   __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i13, i7);
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i11 >> 2] = i13;
   HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   HEAP32[i18 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
   HEAP32[i12 >> 2] = i1;
   i5 = i1 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i6 = i1 + 8 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i4 = i1 + 12 | 0;
    i1 = i3;
    do {
     i3 = i1 + 64 | 0;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 >> 2] = i2 - i3 >> 6;
     mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i18 | 0);
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   __ZN17RemapPPtrTransfer11PopMetaFlagEv(i13);
   i1 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
   HEAP32[i14 >> 2] = i1;
   if ((i1 | 0) == (i8 | 0)) break;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP8[i15 >> 0] | 0;
  }
  STACKTOP = i25;
  return;
 }
}

function __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 40 | 0;
 i11 = i15 + 24 | 0;
 i10 = i15;
 i4 = i15 + 20 | 0;
 i5 = i15 + 16 | 0;
 i13 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = ((HEAP32[i13 >> 2] | 0) - i2 | 0) / 296 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i8 >>> 0) {
  if (i3 >>> 0 <= i8 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i5 = i1 + (i8 * 296 | 0) | 0;
  i2 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i10 = i11 + 12 | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = i8 * 296 | 0;
  i4 = (i3 | 0) / 296 | 0;
  if (!i3) {
   i5 = i11 + 8 | 0;
   i4 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
    i2 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i11 >> 2] = i2;
   i3 = i2 + (i4 * 296 | 0) | 0;
   i7 = i11 + 8 | 0;
   HEAP32[i7 >> 2] = i3;
   i6 = i2;
   if (!i8) {
    i5 = i7;
    i4 = i6;
    i2 = i6;
   } else {
    do {
     __ZN8GUIStyleC2ERKS_(i2, i1);
     i1 = i1 + 296 | 0;
     i2 = (HEAP32[i9 >> 2] | 0) + 296 | 0;
     HEAP32[i9 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i5 = i7;
    i4 = i2;
    i3 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i13 >> 2] = i4;
  i4 = i12 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  i4 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i14 + 4 | 0;
    while (1) {
     i1 = i2 + -296 | 0;
     HEAP32[i9 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -284 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i9 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  }
  STACKTOP = i15;
  return;
 }
 i6 = i12 + 8 | 0;
 if ((((HEAP32[i6 >> 2] | 0) - i2 | 0) / 296 | 0 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i12, i8 - i3 | 0);
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i9 = i10 + 12 | 0;
 HEAP32[i9 >> 2] = i2;
 __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE7reserveEj(i10, i8);
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i11, i14);
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 296 | 0;
 i1 = i2;
 if (i3 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i10, i8 - i3 | 0);
  i2 = HEAP32[i7 >> 2] | 0;
 } else if (i3 >>> 0 > i8 >>> 0) {
  i4 = i4 + (i8 * 296 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i2 = i1 + -296 | 0;
    HEAP32[i7 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + -284 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
     i2 = HEAP32[i7 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
   }
  }
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -296 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -284 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i13 = HEAP32[i9 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 }
 STACKTOP = i15;
 return;
}

function __ZN4FMOD7SystemI11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(i10, i16, i1, i15, i9) {
 i10 = i10 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i8 = i18 + 32 | 0;
 i5 = i18 + 24 | 0;
 i4 = i18 + 16 | 0;
 i3 = i18 + 8 | 0;
 i2 = i18;
 i11 = i18 + 60 | 0;
 i12 = i18 + 56 | 0;
 i13 = i18 + 52 | 0;
 i7 = i18 + 48 | 0;
 i17 = __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7GetFreeEi(i10 + 172 | 0, -1) | 0;
 if (!i17) {
  HEAP32[i2 >> 2] = 36;
  HEAP32[i2 + 4 >> 2] = gb + 854022;
  _printf(gb + 853184 | 0, i2) | 0;
  i17 = 36;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!i9) {
  HEAP32[i3 >> 2] = 37;
  HEAP32[i3 + 4 >> 2] = gb + 854022;
  _printf(gb + 853277 | 0, i3) | 0;
  i17 = 37;
  STACKTOP = i18;
  return i17 | 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 68 >> 2];
 if (i1 & 2048 | 0) {
  HEAP32[i17 + 320 >> 2] = _JS_Sound_Load(i16 | 0, HEAP32[i15 + 4 >> 2] | 0) | 0;
  HEAP8[i17 + 64 >> 0] = 0;
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (i1 & 256 | 0) {
  i6 = i15 + 44 | 0;
  if (HEAP32[i6 >> 2] | 0) {
   i7 = i15 + 4 | 0;
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1644) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i2 = i15 + 12 | 0;
   } else {
    i5 = i15 + 48 | 0;
    i2 = i15 + 12 | 0;
    i3 = 0;
    i4 = 16384;
    do {
     i1 = i1 - i3 | 0;
     i4 = i1 >>> 0 < i4 >>> 0 ? i1 : i4;
     mftCall_iiii(HEAP32[i6 >> 2] | 0, HEAP32[i9 >> 2] | 0, i8 + i3 | 0, i4 | 0) | 0;
     i3 = i4 + i3 | 0;
     mftCall_iiiii(HEAP32[i5 >> 2] | 0, HEAP32[i9 >> 2] | 0, 0, (i3 >>> 0) / (HEAP32[i2 >> 2] << 2 >>> 0) | 0 | 0, 2) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
    } while (i1 >>> 0 > i3 >>> 0);
   }
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1653) | 0;
   i14 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i13 = i3 << 2;
   i4 = (i14 >>> 0) / (i13 >>> 0) | 0;
   if (!((i3 | 0) < 1 | i13 >>> 0 > i14 >>> 0)) {
    i1 = 0;
    do {
     i5 = Math_imul(i1, i4) | 0;
     i2 = 0;
     do {
      HEAP32[i6 + (i2 + i5 << 2) >> 2] = HEAP32[i8 + ((Math_imul(i3, i2) | 0) + i1 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < i4 >>> 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i3 | 0));
   }
   HEAP32[i17 + 36 >> 2] = i3;
   i15 = HEAP32[i15 + 16 >> 2] | 0;
   HEAP32[i17 + 40 >> 2] = i15;
   HEAP32[i17 + 320 >> 2] = _JS_Sound_Load_PCM(i3 | 0, i4 | 0, i15 | 0, i6 | 0) | 0;
   HEAP32[i17 + 48 >> 2] = 5;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64016 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 64016 | 0);
   _strcpy(i17 + 64 | 0, i16) | 0;
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 i1 = HEAP32[i15 + 76 >> 2] | 0;
 if (!i1) i1 = mftCall_iiiiii(HEAP32[i10 + 376 >> 2] | 0, i16 | 0, 0, i13 | 0, i11 | 0, i12 | 0) | 0; else i1 = mftCall_iiiiii(i1 | 0, i16 | 0, 0, i13 | 0, i11 | 0, i12 | 0) | 0;
 L35 : do if (!i1) {
  i1 = HEAP32[i15 + 4 >> 2] | 0;
  if (i1 | 0) HEAP32[i13 >> 2] = i1;
  i1 = HEAP32[i15 + 88 >> 2] | 0;
  if (!i1) i1 = mftCall_iiii(HEAP32[i10 + 388 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i15 + 8 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0; else i1 = mftCall_iiii(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i15 + 8 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
  if (i1 | 0) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 4 >> 2] = gb + 854022;
   _printf(gb + 854139 | 0, i5) | 0;
   break;
  }
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1693) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  L47 : do if (i1 | 0) {
   i4 = i15 + 84 | 0;
   i5 = i10 + 384 | 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) i1 = mftCall_iiiiii(HEAP32[i5 >> 2] | 0, HEAP32[i11 >> 2] | 0, i6 + i3 | 0, i1 - i3 | 0, i7 | 0, HEAP32[i12 >> 2] | 0) | 0; else i1 = mftCall_iiiiii(i2 | 0, HEAP32[i11 >> 2] | 0, i6 + i3 | 0, i1 - i3 | 0, i7 | 0, HEAP32[i12 >> 2] | 0) | 0;
    if (i1 | 0) break;
    i3 = (HEAP32[i7 >> 2] | 0) + i3 | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    if (i3 >>> 0 >= i1 >>> 0) break L47;
   }
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = gb + 854022;
   _printf(gb + 854139 | 0, i8) | 0;
   break L35;
  } while (0);
  i1 = HEAP32[i15 + 80 >> 2] | 0;
  if (!i1) i1 = mftCall_iii(HEAP32[i10 + 380 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0; else i1 = mftCall_iii(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
  if (i1 | 0) {
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = gb + 854022;
   _printf(gb + 854139 | 0, i14) | 0;
   break;
  }
  HEAP32[i17 + 320 >> 2] = _JS_Sound_Load(i6 | 0, HEAP32[i13 >> 2] | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 64016 | 0);
  _strcpy(i17 + 64 | 0, i16) | 0;
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 } else {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = gb + 854022;
  _printf(gb + 854139 | 0, i4) | 0;
 } while (0);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN12b2WheelJoint24SolveVelocityConstraintsERK12b2SolverData(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 f15 = Math_fround(HEAPF32[i9 + 156 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 160 >> 2]);
 f17 = Math_fround(HEAPF32[i9 + 164 >> 2]);
 f18 = Math_fround(HEAPF32[i9 + 168 >> 2]);
 i10 = i9 + 132 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i7 + 28 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i13 + (i11 * 12 | 0) >> 2] | 0;
 i8 = i13 + (i11 * 12 | 0) + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i13 + (i11 * 12 | 0) + 8 >> 2]);
 i14 = i9 + 136 | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i13 + (i19 * 12 | 0) >> 2] | 0;
 i5 = HEAP32[i13 + (i19 * 12 | 0) + 4 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i13 + (i19 * 12 | 0) + 8 >> 2]);
 if (Math_fround(HEAPF32[i9 + 68 >> 2]) > Math_fround(0.0)) {
  f24 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f28 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f26 = Math_fround(f24 - f28);
  f22 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(f22 - f27);
  f23 = Math_fround(HEAPF32[i9 + 172 >> 2]);
  f26 = Math_fround(f26 * f23);
  f20 = Math_fround(HEAPF32[i9 + 176 >> 2]);
  f21 = Math_fround(f26 + Math_fround(f21 * f20));
  f26 = Math_fround(HEAPF32[i9 + 192 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f1 * f26));
  f25 = Math_fround(HEAPF32[i9 + 188 >> 2]);
  f21 = Math_fround(f21 - Math_fround(f2 * f25));
  f31 = Math_fround(HEAPF32[i9 + 212 >> 2]);
  f21 = Math_fround(f21 + Math_fround(HEAPF32[i9 + 216 >> 2]));
  f29 = Math_fround(HEAPF32[i9 + 220 >> 2]);
  i6 = i9 + 116 | 0;
  f30 = Math_fround(HEAPF32[i6 >> 2]);
  f29 = Math_fround(f31 * Math_fround(f21 + Math_fround(f29 * f30)));
  f21 = Math_fround(-f29);
  HEAPF32[i6 >> 2] = Math_fround(f30 - f29);
  f23 = Math_fround(f23 * f21);
  f20 = Math_fround(f20 * f21);
  f25 = Math_fround(f25 * f21);
  f21 = Math_fround(f26 * f21);
  f26 = Math_fround(f15 * f20);
  f28 = Math_fround(f28 - Math_fround(f15 * f23));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(f27 - f26);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f2 = Math_fround(f2 - Math_fround(f17 * f25));
  f20 = Math_fround(f16 * f20);
  f23 = Math_fround(f24 + Math_fround(f16 * f23));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f20 = Math_fround(f22 + f20);
  f1 = Math_fround(f1 + Math_fround(f18 * f21));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (HEAP8[i9 + 128 >> 0] | 0) {
  f28 = Math_fround(f1 - f2);
  f28 = Math_fround(f28 - Math_fround(HEAPF32[i9 + 124 >> 2]));
  f28 = Math_fround(Math_fround(HEAPF32[i9 + 208 >> 2]) * f28);
  i19 = i9 + 112 | 0;
  f31 = Math_fround(HEAPF32[i19 >> 2]);
  f30 = Math_fround(HEAPF32[i7 >> 2]);
  f30 = Math_fround(f30 * Math_fround(HEAPF32[i9 + 120 >> 2]));
  f28 = Math_fround(f31 - f28);
  f29 = Math_fround(-f30);
  f30 = f28 < f30 ? f28 : f30;
  f30 = f30 < f29 ? f29 : f30;
  HEAPF32[i19 >> 2] = f30;
  f31 = Math_fround(f30 - f31);
  f2 = Math_fround(f2 - Math_fround(f17 * f31));
  f1 = Math_fround(f1 + Math_fround(f18 * f31));
 }
 f29 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f29 - f25);
 f23 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f23 - f27);
 f26 = Math_fround(HEAPF32[i9 + 180 >> 2]);
 f24 = Math_fround(f24 * f26);
 f30 = Math_fround(HEAPF32[i9 + 184 >> 2]);
 f22 = Math_fround(f24 + Math_fround(f22 * f30));
 f24 = Math_fround(HEAPF32[i9 + 200 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f1 * f24));
 f28 = Math_fround(HEAPF32[i9 + 196 >> 2]);
 f22 = Math_fround(f22 - Math_fround(f2 * f28));
 f22 = Math_fround(Math_fround(HEAPF32[i9 + 204 >> 2]) * f22);
 f31 = Math_fround(-f22);
 i19 = i9 + 108 | 0;
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f22);
 f26 = Math_fround(f26 * f31);
 f30 = Math_fround(f30 * f31);
 f27 = Math_fround(f27 - Math_fround(f15 * f30));
 f28 = Math_fround(f2 - Math_fround(f17 * Math_fround(f28 * f31)));
 f29 = Math_fround(f29 + Math_fround(f16 * f26));
 f30 = Math_fround(f23 + Math_fround(f16 * f30));
 f31 = Math_fround(f1 + Math_fround(f18 * Math_fround(f24 * f31)));
 HEAPF32[i13 + (i11 * 12 | 0) >> 2] = Math_fround(f25 - Math_fround(f15 * f26));
 HEAPF32[i8 >> 2] = f27;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAPF32[i13 + ((HEAP32[i10 >> 2] | 0) * 12 | 0) + 8 >> 2] = f28;
 i19 = HEAP32[i14 >> 2] | 0;
 HEAPF32[i13 + (i19 * 12 | 0) >> 2] = f29;
 HEAPF32[i13 + (i19 * 12 | 0) + 4 >> 2] = f30;
 HEAPF32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i14 >> 2] | 0) * 12 | 0) + 8 >> 2] = f31;
 return;
}

function _load_post_names(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 4 | 0;
 i1 = i16;
 i13 = HEAP32[i15 + 104 >> 2] | 0;
 i2 = mftCall_iiiii(HEAP32[i15 + 508 >> 2] | 0, i15 | 0, 1886352244, i13 | 0, i1 | 0) | 0;
 if (i2 | 0) {
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 }
 i8 = _UNITY_FT_Stream_Pos(i13) | 0;
 i8 = (HEAP32[i1 >> 2] | 0) + i8 | 0;
 i1 = HEAP32[i15 + 468 >> 2] | 0;
 i2 = _UNITY_FT_Stream_Skip(i13, 32) | 0;
 if (i2 | 0) {
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 }
 L7 : do if ((i1 | 0) < 163840) {
  switch (i1 | 0) {
  case 131072:
   break;
  default:
   {
    i1 = 3;
    break L7;
   }
  }
  i11 = HEAP32[i13 + 28 >> 2] | 0;
  i9 = _UNITY_FT_Stream_ReadUShort(i13, i14) | 0;
  i4 = i9 & 65535;
  i1 = HEAP32[i14 >> 2] | 0;
  L10 : do if (!i1) {
   if ((i9 & 65535) > (HEAPU16[i15 + 264 >> 1] | 0)) {
    HEAP32[i14 >> 2] = 3;
    i1 = 3;
    break;
   }
   i10 = _UNITY_ft_mem_realloc(i11, 2, 0, i4, 0, i14) | 0;
   L15 : do if (!(HEAP32[i14 >> 2] | 0)) {
    i7 = _UNITY_FT_Stream_EnterFrame(i13, i4 << 1) | 0;
    HEAP32[i14 >> 2] = i7;
    if (!i7) {
     if (!(i9 << 16 >> 16)) {
      _UNITY_FT_Stream_ExitFrame(i13);
      i7 = 0;
     } else {
      i1 = 0;
      do {
       HEAP16[i10 + (i1 << 1) >> 1] = _UNITY_FT_Stream_GetUShort(i13) | 0;
       i1 = i1 + 1 | 0;
      } while ((i1 | 0) != (i4 | 0));
      _UNITY_FT_Stream_ExitFrame(i13);
      i1 = 0;
      i3 = 0;
      do {
       i7 = HEAP16[i10 + (i3 << 1) >> 1] | 0;
       i2 = (i7 & 65535) + -257 | 0;
       if ((i7 & 65535) > 257) i1 = (i2 | 0) > (i1 & 65535 | 0) ? i2 & 65535 : i1;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i4 | 0));
      i7 = i1;
     }
     i6 = i7 & 65535;
     i1 = _UNITY_ft_mem_realloc(i11, 4, 0, i6, 0, i14) | 0;
     if (!(HEAP32[i14 >> 2] | 0)) {
      L30 : do if (i7 << 16 >> 16) {
       i2 = 0;
       while (1) {
        if ((_UNITY_FT_Stream_Pos(i13) | 0) >>> 0 >= i8 >>> 0) {
         i12 = 25;
         break;
        }
        i3 = (_UNITY_FT_Stream_ReadChar(i13, i14) | 0) & 255;
        if (HEAP32[i14 >> 2] | 0) {
         i2 = 0;
         break;
        }
        if (i8 >>> 0 < i3 >>> 0) i12 = 22; else if ((_UNITY_FT_Stream_Pos(i13) | 0) >>> 0 > (i8 - i3 | 0) >>> 0) i12 = 22;
        if ((i12 | 0) == 22) {
         i12 = 0;
         i3 = i8 - (_UNITY_FT_Stream_Pos(i13) | 0) | 0;
         i3 = (i3 | 0) < 0 ? 0 : i3;
        }
        i4 = _UNITY_ft_mem_realloc(i11, 1, 0, i3 + 1 | 0, 0, i14) | 0;
        i5 = i1 + (i2 << 2) | 0;
        HEAP32[i5 >> 2] = i4;
        if (HEAP32[i14 >> 2] | 0) {
         i2 = 0;
         break;
        }
        i4 = _UNITY_FT_Stream_Read(i13, i4, i3) | 0;
        HEAP32[i14 >> 2] = i4;
        if (i4 | 0) {
         i2 = 0;
         break;
        }
        HEAP8[(HEAP32[i5 >> 2] | 0) + i3 >> 0] = 0;
        i2 = i2 + 1 | 0;
        if (i2 >>> 0 >= i6 >>> 0) break L30;
       }
       L42 : do if ((i12 | 0) == 25) {
        if ((i2 & 65535) >= (i7 & 65535)) break L30;
        i3 = i2 & 65535;
        while (1) {
         i2 = _UNITY_ft_mem_realloc(i11, 1, 0, 1, 0, i14) | 0;
         HEAP32[i1 + (i3 << 2) >> 2] = i2;
         if (HEAP32[i14 >> 2] | 0) {
          i2 = 0;
          break L42;
         }
         HEAP8[i2 >> 0] = 0;
         i3 = i3 + 1 | 0;
         if (i3 >>> 0 >= i6 >>> 0) break L30;
        }
       } while (0);
       while (1) {
        i13 = i1 + (i2 << 2) | 0;
        _UNITY_ft_mem_free(i11, HEAP32[i13 >> 2] | 0);
        HEAP32[i13 >> 2] = 0;
        i2 = i2 + 1 | 0;
        if ((i2 & 65535) << 16 >> 16 == i7 << 16 >> 16) break L15;
       }
      } while (0);
      HEAP16[i15 + 616 >> 1] = i9;
      HEAP16[i15 + 618 >> 1] = i7;
      HEAP32[i15 + 620 >> 2] = i10;
      HEAP32[i15 + 624 >> 2] = i1;
      i1 = 0;
      break L10;
     }
    } else i1 = 0;
   } else i1 = 0; while (0);
   _UNITY_ft_mem_free(i11, i1);
   _UNITY_ft_mem_free(i11, i10);
   i1 = HEAP32[i14 >> 2] | 0;
  } while (0);
 } else {
  switch (i1 | 0) {
  case 163840:
   break;
  default:
   {
    i1 = 3;
    break L7;
   }
  }
  i3 = HEAP32[i13 + 28 >> 2] | 0;
  i4 = _UNITY_FT_Stream_ReadUShort(i13, i14) | 0;
  i5 = i4 & 65535;
  i1 = HEAP32[i14 >> 2] | 0;
  L55 : do if (!i1) {
   if ((i4 & 65535) > 258 ? 1 : (i4 & 65535) > (HEAPU16[i15 + 264 >> 1] | 0)) {
    HEAP32[i14 >> 2] = 3;
    i1 = 3;
    break;
   }
   i2 = _UNITY_ft_mem_realloc(i3, 1, 0, i5, 0, i14) | 0;
   L60 : do if (!(HEAP32[i14 >> 2] | 0)) {
    i13 = _UNITY_FT_Stream_Read(i13, i2, i5) | 0;
    HEAP32[i14 >> 2] = i13;
    if (!i13) {
     L63 : do if (i4 << 16 >> 16) {
      i1 = 0;
      while (1) {
       if (((HEAP8[i2 + i1 >> 0] | 0) + i1 | 0) >>> 0 > i5 >>> 0) break;
       i1 = i1 + 1 | 0;
       if ((i1 | 0) >= (i5 | 0)) break L63;
      }
      HEAP32[i14 >> 2] = 3;
      break L60;
     } while (0);
     HEAP16[i15 + 616 >> 1] = i4;
     HEAP32[i15 + 620 >> 2] = i2;
     i1 = 0;
     break L55;
    }
   } while (0);
   _UNITY_ft_mem_free(i3, i2);
   i1 = HEAP32[i14 >> 2] | 0;
  } while (0);
 } while (0);
 HEAP8[i15 + 612 >> 0] = 1;
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN8LODGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i8;
 i7 = i8 + 8 | 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425113 | 0, HEAP32[gb + 37324 >> 2] | 0, i5, 0);
 i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i3 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i11;
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i11, i5, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i11, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i11, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, i11, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 48 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425135 | 0, HEAP32[gb + 37040 >> 2] | 0, i12, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425146 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425167 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 56 | 0, 0);
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i10 = i7 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 i9 = i7 + 24 | 0;
 HEAP32[i9 >> 2] = 0;
 i6 = i7 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i15 = i12;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i6;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i12, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 590097 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425174 | 0, i11, i7, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425195 | 0, i11, i10, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i7 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 425215 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  i14 = i1 + 72 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i5, i14, 1);
  i14 = HEAP32[i3 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = HEAP32[i4 >> 2] | 0;
  i15 = i14 + (i15 * 24 | 0) + 12 | 0;
  HEAP32[i15 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i14 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i5, i14, 1);
 i14 = HEAP32[i3 >> 2] | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = HEAP32[i4 >> 2] | 0;
 i15 = i14 + (i15 * 24 | 0) + 12 | 0;
 HEAP32[i15 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i8;
 return;
}

function __ZN30RuntimeInitializeOnLoadManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP32[i8 >> 2] = gb + 64596 + 8;
 i4 = i8 + 156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 160 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i9 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i7 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 168 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 140 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 144 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i7 = HEAP32[i8 + 152 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 124 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 128 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i7 = HEAP32[i8 + 136 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 108 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 112 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i7 = HEAP32[i8 + 120 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 92 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 96 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i7 = HEAP32[i8 + 104 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i5 = i8 + 76 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i8 + 80 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i9 + 4 | 0;
   do {
    i3 = i2 + -24 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i7 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 88 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i5 = i8 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i8 + 64 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i9 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -28 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 + -16 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i7 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 72 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i4 = i8 + 44 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 48 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i9 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i7 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 56 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = gb + 28648 + 8;
  HEAP32[i8 >> 2] = gb + 28496 + 8;
  STACKTOP = i10;
  return;
 }
 i5 = i8 + 32 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i9 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i7 = HEAP32[i8 + 40 >> 2] | 0;
 HEAP32[i9 >> 2] = 12;
 HEAP32[i9 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 HEAP32[i8 >> 2] = gb + 28648 + 8;
 HEAP32[i8 >> 2] = gb + 28496 + 8;
 STACKTOP = i10;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i15, i1, i16, i17, i14, i18) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, f38 = f0, f39 = f0, i40 = 0, f41 = f0, f42 = f0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 if (i14 >>> 0 >= i18 >>> 0) return;
 i19 = HEAP32[i1 + 520 >> 2] | 0;
 i2 = HEAP32[i1 + 500 >> 2] | 0;
 i3 = i17 + 4 | 0;
 i4 = i17 + 8 | 0;
 i5 = i17 + 12 | 0;
 i6 = i15 + 32 | 0;
 i7 = i15 + 4 | 0;
 i8 = i15 + 8 | 0;
 i9 = i15 + 12 | 0;
 i10 = i15 + 16 | 0;
 i11 = i15 + 20 | 0;
 i12 = i15 + 24 | 0;
 i13 = i15 + 28 | 0;
 i1 = i14;
 do {
  i40 = i19 + (i1 << 2) | 0;
  f42 = Math_fround(HEAPF32[i40 >> 2]);
  f39 = Math_fround(HEAPF32[i40 + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i40 + 8 >> 2]);
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f39 = Math_fround(f39 * Math_fround(.00999999977));
  f36 = Math_fround(f36 * Math_fround(.00999999977));
  f30 = Math_fround(Math_fround(HEAPF32[i40 + 12 >> 2]) * Math_fround(.00999999977));
  i40 = i2 + (i1 << 2) | 0;
  i14 = (HEAP32[i40 >> 2] | 0) + -13913692 | 0;
  i23 = (HEAP32[i40 + 4 >> 2] | 0) + -13913692 | 0;
  i31 = (HEAP32[i40 + 8 >> 2] | 0) + -13913692 | 0;
  i40 = (HEAP32[i40 + 12 >> 2] | 0) + -13913692 | 0;
  i21 = (Math_imul(i14, 1790253981) | 0) + 1900727103 | 0;
  i25 = (Math_imul(i23, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i31, 1790253981) | 0) + 1900727103 | 0;
  i43 = (Math_imul(i40, 1790253981) | 0) + 1900727103 | 0;
  i14 = i14 << 11 ^ i14;
  i23 = i23 << 11 ^ i23;
  i31 = i31 << 11 ^ i31;
  i40 = i40 << 11 ^ i40;
  f32 = Math_fround(Math_fround((i21 ^ i14 ^ i14 >>> 8) & 8388607 ^ i21 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f33 = Math_fround(Math_fround((i25 ^ i23 ^ i23 >>> 8) & 8388607 ^ i25 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f34 = Math_fround(Math_fround((i37 ^ i31 ^ i31 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f27 = Math_fround(Math_fround((i43 ^ i40 ^ i40 >>> 8) & 8388607 ^ i43 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i43 = f32 > Math_fround(HEAPF32[i17 >> 2]);
  i40 = f33 > Math_fround(HEAPF32[i3 >> 2]);
  i37 = f34 > Math_fround(HEAPF32[i4 >> 2]);
  i31 = f27 > Math_fround(HEAPF32[i5 >> 2]);
  i25 = i16 + (i1 << 2) | 0;
  f27 = Math_fround(HEAPF32[i25 >> 2]);
  i23 = i25 + 4 | 0;
  f34 = Math_fround(HEAPF32[i23 >> 2]);
  i21 = i25 + 8 | 0;
  f33 = Math_fround(HEAPF32[i21 >> 2]);
  i14 = i25 + 12 | 0;
  f32 = Math_fround(HEAPF32[i14 >> 2]);
  f29 = Math_fround(HEAPF32[i6 >> 2]);
  f48 = Math_fround(HEAPF32[i15 >> 2]);
  f26 = Math_fround(f42 * f48);
  f24 = Math_fround(f39 * f48);
  f22 = Math_fround(f36 * f48);
  f48 = Math_fround(f30 * f48);
  f20 = Math_fround(HEAPF32[i7 >> 2]);
  f26 = Math_fround(f42 * Math_fround(f26 + f20));
  f24 = Math_fround(f39 * Math_fround(f24 + f20));
  f22 = Math_fround(f36 * Math_fround(f22 + f20));
  f20 = Math_fround(f30 * Math_fround(f48 + f20));
  f48 = Math_fround(HEAPF32[i8 >> 2]);
  f26 = Math_fround(f42 * Math_fround(f48 + f26));
  f24 = Math_fround(f39 * Math_fround(f48 + f24));
  f22 = Math_fround(f36 * Math_fround(f48 + f22));
  f20 = Math_fround(f30 * Math_fround(f48 + f20));
  f48 = Math_fround(HEAPF32[i9 >> 2]);
  f26 = Math_fround(f48 + f26);
  f24 = Math_fround(f48 + f24);
  f22 = Math_fround(f48 + f22);
  f20 = Math_fround(f48 + f20);
  f48 = Math_fround(f42 - f29);
  f47 = Math_fround(f39 - f29);
  f46 = Math_fround(f36 - f29);
  f45 = Math_fround(f30 - f29);
  f44 = Math_fround(HEAPF32[i10 >> 2]);
  f41 = Math_fround(f48 * f44);
  f38 = Math_fround(f47 * f44);
  f35 = Math_fround(f46 * f44);
  f44 = Math_fround(f45 * f44);
  f28 = Math_fround(HEAPF32[i11 >> 2]);
  f41 = Math_fround(f48 * Math_fround(f41 + f28));
  f38 = Math_fround(f47 * Math_fround(f38 + f28));
  f35 = Math_fround(f46 * Math_fround(f35 + f28));
  f28 = Math_fround(f45 * Math_fround(f44 + f28));
  f44 = Math_fround(HEAPF32[i12 >> 2]);
  f41 = Math_fround(f48 * Math_fround(f44 + f41));
  f38 = Math_fround(f47 * Math_fround(f44 + f38));
  f35 = Math_fround(f46 * Math_fround(f44 + f35));
  f28 = Math_fround(f45 * Math_fround(f44 + f28));
  f44 = Math_fround(HEAPF32[i13 >> 2]);
  f41 = Math_fround(f44 + f41);
  f38 = Math_fround(f44 + f38);
  f35 = Math_fround(f44 + f35);
  f28 = Math_fround(f44 + f28);
  f26 = Math_fround((i43 ? Math_fround(1.0) : Math_fround(-1.0)) * (f42 > f29 ? f41 : f26));
  f24 = Math_fround((i40 ? Math_fround(1.0) : Math_fround(-1.0)) * (f39 > f29 ? f38 : f24));
  f22 = Math_fround((i37 ? Math_fround(1.0) : Math_fround(-1.0)) * (f36 > f29 ? f35 : f22));
  f24 = Math_fround(f34 + f24);
  f22 = Math_fround(f33 + f22);
  f20 = Math_fround(f32 + Math_fround((i31 ? Math_fround(1.0) : Math_fround(-1.0)) * (f30 > f29 ? f28 : f20)));
  HEAPF32[i25 >> 2] = Math_fround(f27 + f26);
  HEAPF32[i23 >> 2] = f24;
  HEAPF32[i21 >> 2] = f22;
  HEAPF32[i14 >> 2] = f20;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i18 >>> 0);
 return;
}

function __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i1 = i7;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do switch (i3 >>> 24 & 15 | 0) {
 case 2:
 case 1:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2464 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 3:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2580 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 4:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2580 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 5:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2540 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 6:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2660 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 7:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2620 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 8:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2700 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 9:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2740 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 10:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2780 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 case 11:
  {
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i2 >> 2] = i3 | 268435456;
   if ((i3 & -1073741824 | 0) != -2147483648) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 2820 | 0, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 } while (0);
}

function __Z24CreateStreamClipConstantP19StreamedClipBuilderRN7mecanim9animation12StreamedClipERNS1_6memory9AllocatorE(i9, i10, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15;
 i13 = i15 + 8 | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 i7 = i9 + 12 | 0;
 __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_(i14, i14 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) | 0, i6);
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i11 = i13 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = ((HEAP32[i7 >> 2] | 0) * 28 | 0) + 28 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  break;
 } while (0);
 if (HEAP32[i7 >> 2] | 0) {
  i3 = 0;
  do {
   f5 = Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + (i3 * 24 | 0) >> 2]);
   i1 = (HEAP32[i14 >> 2] | 0) + 8 | 0;
   HEAP32[i14 >> 2] = i1;
   i2 = HEAP32[i11 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i13 >> 2] = i1;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i13 >> 2] = i6;
    i1 = i6;
    break;
   } else i1 = HEAP32[i13 >> 2] | 0; while (0);
   i6 = i1 + ((HEAP32[i14 >> 2] | 0) + -8) | 0;
   HEAPF32[i6 >> 2] = f5;
   i1 = HEAP32[i7 >> 2] | 0;
   L17 : do if (i3 >>> 0 < i1 >>> 0) {
    i2 = 0;
    i4 = i3;
    while (1) {
     if (!(Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + (i4 * 24 | 0) >> 2]) == f5)) {
      i3 = i4;
      break L17;
     }
     i1 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
     HEAP32[i14 >> 2] = i1;
     i3 = HEAP32[i11 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i11 >> 2] = i1;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i13 >> 2] = i1;
      break;
     } else {
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i3 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
      HEAP32[i11 >> 2] = i1;
      HEAP32[i13 >> 2] = i3;
      i1 = i3;
      break;
     } else i1 = HEAP32[i13 >> 2] | 0; while (0);
     i3 = i1 + ((HEAP32[i14 >> 2] | 0) + -20) | 0;
     i1 = HEAP32[i9 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i1 + (i4 * 24 | 0) + 4 >> 2];
     i3 = i3 + 4 | 0;
     i1 = i1 + (i4 * 24 | 0) + 8 | 0;
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     i3 = i4 + 1 | 0;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     if (i3 >>> 0 < i1 >>> 0) i4 = i3; else break;
    }
   } else i2 = 0; while (0);
   HEAP32[i6 + 4 >> 2] = i2;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = (HEAP32[i14 >> 2] | 0) + 8 | 0;
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i11 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i13 >> 2] = i1;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = i7;
  i1 = i7;
  break;
 } else i1 = HEAP32[i13 >> 2] | 0; while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i4 = i1 + (i2 + -8) | 0;
 HEAPF32[i4 >> 2] = Math_fround(inf);
 HEAP32[i4 + 4 >> 2] = 0;
 i2 = i2 >>> 2;
 HEAP32[i10 >> 2] = i2;
 i4 = i10 + 4 | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i8 = i4;
 i7 = i1 | 0 ? i1 - i8 | 0 : 0;
 HEAP32[i4 >> 2] = i7;
 _memcpy(((i7 | 0) == 0 ? 0 : i7 + i8 | 0) | 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 20 >> 2];
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i12);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN12b2MouseJoint23InitVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i24 = HEAP32[i1 + 52 >> 2] | 0;
 i25 = HEAP32[i24 + 8 >> 2] | 0;
 i10 = i1 + 116 | 0;
 HEAP32[i10 >> 2] = i25;
 i22 = i24 + 28 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 i22 = HEAP32[i22 + 4 >> 2] | 0;
 i21 = i1 + 128 | 0;
 HEAP32[i21 >> 2] = i23;
 HEAP32[i21 + 4 >> 2] = i22;
 i21 = HEAP32[i24 + 120 >> 2] | 0;
 i5 = i1 + 136 | 0;
 HEAP32[i5 >> 2] = i21;
 i4 = HEAP32[i24 + 128 >> 2] | 0;
 i6 = i1 + 140 | 0;
 HEAP32[i6 >> 2] = i4;
 i7 = HEAP32[i2 + 24 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i7 + (i25 * 12 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i7 + (i25 * 12 | 0) + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + (i25 * 12 | 0) + 8 >> 2]);
 i7 = i2 + 28 | 0;
 i26 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i26 + (i25 * 12 | 0) >> 2] | 0;
 i9 = HEAP32[i26 + (i25 * 12 | 0) + 4 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i26 + (i25 * 12 | 0) + 8 >> 2]);
 f16 = Math_fround(+Math_sin(+f18));
 f18 = Math_fround(+Math_cos(+f18));
 f19 = Math_fround(HEAPF32[i24 + 116 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 i24 = f13 > Math_fround(.0000999999974);
 f13 = Math_fround((i24 ? f13 : Math_fround(.0000999999974)) * Math_fround(6.28318548));
 f20 = Math_fround(f19 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 * Math_fround(HEAPF32[i1 + 88 >> 2])) * f13);
 f13 = Math_fround(f19 * Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 >> 2]);
 i24 = !(Math_fround(f20 + Math_fround(f19 * f13)) <= Math_fround(1.1920929e-07));
 f13 = Math_fround(f19 * (i24 ? f13 : Math_fround(1.1920929e-07)));
 f20 = Math_fround(f19 * Math_fround(f20 + f13));
 i24 = f20 != Math_fround(0.0);
 f19 = Math_fround(Math_fround(1.0) / f20);
 f20 = i24 ? f19 : f20;
 HEAPF32[i1 + 108 >> 2] = f20;
 f13 = Math_fround(f13 * f20);
 HEAPF32[i1 + 92 >> 2] = f13;
 f19 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f19 = Math_fround(f19 - (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f11 = Math_fround(Math_fround(f18 * f19) - Math_fround(f16 * f12));
 f12 = Math_fround(Math_fround(f16 * f19) + Math_fround(f18 * f12));
 HEAPF32[i1 + 120 >> 2] = f11;
 HEAPF32[i1 + 124 >> 2] = f12;
 f18 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = Math_fround(f20 + Math_fround(f18 + Math_fround(f12 * Math_fround(f12 * f19))));
 f19 = Math_fround(f19 * f11);
 f17 = Math_fround(f12 * f19);
 f19 = Math_fround(f20 + Math_fround(f18 + Math_fround(f11 * f19)));
 f18 = Math_fround(Math_fround(f16 * f19) - Math_fround(f17 * f17));
 i4 = f18 != Math_fround(0.0);
 f20 = Math_fround(Math_fround(1.0) / f18);
 f18 = i4 ? f20 : f18;
 f17 = Math_fround(f17 * f18);
 f16 = Math_fround(f16 * f18);
 HEAPF32[i1 + 144 >> 2] = Math_fround(f19 * f18);
 HEAPF32[i1 + 148 >> 2] = f17;
 HEAPF32[i1 + 152 >> 2] = f17;
 HEAPF32[i1 + 156 >> 2] = f16;
 f15 = Math_fround(f15 + f11);
 f14 = Math_fround(f14 + f12);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i1 + 76 >> 2]));
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i1 + 80 >> 2]));
 HEAPF32[i1 + 160 >> 2] = Math_fround(f15 * f13);
 HEAPF32[i1 + 164 >> 2] = Math_fround(f14 * f13);
 f3 = Math_fround(f3 * Math_fround(.980000019));
 i4 = i1 + 96 | 0;
 if (!(HEAP8[i2 + 20 >> 0] | 0)) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
  f20 = f3;
  i22 = i8;
  i25 = i9;
  i26 = HEAP32[i10 >> 2] | 0;
  i24 = HEAP32[i7 >> 2] | 0;
  i23 = i24 + (i26 * 12 | 0) | 0;
  HEAP32[i23 >> 2] = i22;
  i26 = i24 + (i26 * 12 | 0) + 4 | 0;
  HEAP32[i26 >> 2] = i25;
  i26 = HEAP32[i10 >> 2] | 0;
  i25 = HEAP32[i7 >> 2] | 0;
  i26 = i25 + (i26 * 12 | 0) + 8 | 0;
  HEAPF32[i26 >> 2] = f20;
  return;
 } else {
  f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f20 = Math_fround(f18 * Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i4 >> 2] = f20;
  i22 = i1 + 100 | 0;
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i22 >> 2]));
  HEAPF32[i22 >> 2] = f18;
  f19 = Math_fround(HEAPF32[i5 >> 2]);
  f17 = Math_fround(f20 * f19);
  f19 = Math_fround(f18 * f19);
  f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f17);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
  f20 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(Math_fround(f18 * f11) - Math_fround(f20 * f12))));
  i25 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = HEAP32[i10 >> 2] | 0;
  i24 = HEAP32[i7 >> 2] | 0;
  i23 = i24 + (i26 * 12 | 0) | 0;
  HEAP32[i23 >> 2] = i22;
  i26 = i24 + (i26 * 12 | 0) + 4 | 0;
  HEAP32[i26 >> 2] = i25;
  i26 = HEAP32[i10 >> 2] | 0;
  i25 = HEAP32[i7 >> 2] | 0;
  i26 = i25 + (i26 * 12 | 0) + 8 | 0;
  HEAPF32[i26 >> 2] = f20;
  return;
 }
}

function __Z26GetScriptClassIdComponentsRK8UnityStrRS_S2_S2_(i1, i7, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 12 | 0;
 i6 = i13;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i2 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, i5);
 __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcRNS_6vectorIS5_NS3_IS5_EEEEi(i6, gb + 459166 | 0, i11, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 i4 = i1 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = i1 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255;
 i6 = i7 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i6 = i2 ? HEAP32[i7 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i5 - i3 | 0, i6, 0, i6, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i7 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 i7 = HEAP32[i11 >> 2] | 0;
 i2 = i7;
 i1 = i7;
 L14 : do switch (((HEAP32[i12 >> 2] | 0) - i7 | 0) / 12 | 0 | 0) {
 case 2:
  {
   i1 = i9 + 11 | 0;
   if ((HEAP8[i1 >> 0] | 0) < 0) {
    HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    i1 = HEAP32[i11 >> 2] | 0;
   } else {
    HEAP8[i9 >> 0] = 0;
    HEAP8[i1 >> 0] = 0;
    i1 = i2;
   }
   i6 = i1 + 12 | 0;
   i4 = HEAP8[i6 + 11 >> 0] | 0;
   i5 = i4 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i6 >> 2] | 0 : i6;
   i4 = i5 ? HEAP32[i1 + 16 >> 2] | 0 : i4 & 255;
   i5 = i10 + 11 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i4 >>> 0 > i3 >>> 0) {
    i8 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i4 - i3 | 0, i8, 0, i8, i4, i6);
    i8 = 41;
    break L14;
   }
   i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
   if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i10 + 4 >> 2] = i4;
    i8 = 41;
    break L14;
   } else {
    HEAP8[i5 >> 0] = i4;
    i8 = 41;
    break L14;
   }
  }
 case 3:
  {
   i6 = i2 + 12 | 0;
   i4 = HEAP8[i6 + 11 >> 0] | 0;
   i5 = i4 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i6 >> 2] | 0 : i6;
   i4 = i5 ? HEAP32[i2 + 16 >> 2] | 0 : i4 & 255;
   i5 = i9 + 11 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   do if (i4 >>> 0 > i3 >>> 0) {
    i8 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i4 - i3 | 0, i8, 0, i8, i4, i6);
   } else {
    i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
    if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
    HEAP8[i1 + i4 >> 0] = 0;
    if ((HEAP8[i5 >> 0] | 0) < 0) {
     HEAP32[i9 + 4 >> 2] = i4;
     break;
    } else {
     HEAP8[i5 >> 0] = i4;
     break;
    }
   } while (0);
   i6 = HEAP32[i11 >> 2] | 0;
   i4 = i6 + 24 | 0;
   i5 = HEAP8[i4 + 11 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   i4 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
   i5 = i1 ? HEAP32[i6 + 28 >> 2] | 0 : i5 & 255;
   i6 = i10 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i5 >>> 0 > i3 >>> 0) {
    i8 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i3, i5 - i3 | 0, i8, 0, i8, i5, i4);
    i8 = 41;
    break L14;
   }
   i1 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
   if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i10 + 4 >> 2] = i5;
    i8 = 41;
    break L14;
   } else {
    HEAP8[i6 >> 0] = i5;
    i8 = 41;
    break L14;
   }
  }
 default:
  {}
 } while (0);
 if ((i8 | 0) == 41) i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i10 = i2 + -12 | 0;
   HEAP32[i12 >> 2] = i10;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i2 = HEAP32[i12 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 2);
  i1 = HEAP16[i6 >> 1] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i6 >> 1] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP16[i4 + 340 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 2);
  i2 = HEAP16[i6 >> 1] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i6 >> 1] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP16[i4 + 342 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 344 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 348 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 352 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 356 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 360 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 364 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 372 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 376 | 0, gb + 902162 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 388 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 392 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i4 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i4 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN10PngDecoder11InitDecoderEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = 4;
 i10 = _malloc(40) | 0;
 HEAP32[i10 >> 2] = 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 4 | 0;
 i9 = i13;
 __THREW__ = 0;
 i3 = invoke_iiiii(fb + 141 | 0, gb + 402099 | 0, 0, 0, fb + 2397 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
  if (!i2) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i2 = -1;
 i1 = getTempRet0() | 0;
 do if ((i2 | 0) == 1) {
  i4 = 0;
  i5 = 0;
 } else {
  i5 = i6 + 32 | 0;
  HEAP32[i5 >> 2] = i3;
  if (!i3) {
   HEAP8[i6 + 4 >> 0] = 1;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 + 36 >> 2] = 0;
   _free(i10 | 0);
   STACKTOP = i13;
   return;
  }
  __THREW__ = 0;
  i3 = invoke_ii(fb + 1566 | 0, i3 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) i4 = 0; else {
   i4 = i6 + 36 | 0;
   HEAP32[i4 >> 2] = i3;
   if (i3 | 0) {
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 347 | 0, HEAP32[i5 >> 2] | 0, fb + 2356 | 0, 156) | 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i3 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
     if (!i3) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i3 = -1;
    i1 = getTempRet0() | 0;
    if ((i3 | 0) == 1) break;
    i10 = _saveSetjmp(i2, 1, i10 | 0, i11 | 0) | 0;
    i11 = getTempRet0() | 0;
    __THREW__ = 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) break;
    i1 = 0;
    break;
   }
   HEAP8[i6 + 4 >> 0] = 1;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   if (HEAP32[i5 >> 2] | 0) {
    __THREW__ = 0;
    invoke_viii(fb + 498 | 0, i5 | 0, i4 | 0, 0);
    i1 = __THREW__;
    __THREW__ = 0;
    if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
     i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
     if (!i2) _longjmp(i1 | 0, threwValue | 0);
     setTempRet0(threwValue | 0);
    } else i2 = -1;
    i1 = getTempRet0() | 0;
    if ((i2 | 0) == 1) break;
   }
   HEAP32[i5 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   _free(i10 | 0);
   STACKTOP = i13;
   return;
  }
 } while (0);
 while (1) {
  if (i1 | 0) {
   HEAP8[i6 + 4 >> 0] = 1;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   if (!(HEAP32[i5 >> 2] | 0)) break;
   __THREW__ = 0;
   invoke_viii(fb + 498 | 0, i5 | 0, i4 | 0, 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) == 1) {
    i2 = i5;
    i3 = i4;
    i5 = i2;
    i4 = i3;
    continue;
   } else {
    i12 = 16;
    break;
   }
  }
  __THREW__ = 0;
  invoke_viii(fb + 499 | 0, HEAP32[i5 >> 2] | 0, i6 + 16 | 0, fb + 500 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) {
   i2 = i5;
   i3 = i4;
   i5 = i2;
   i4 = i3;
   continue;
  }
  __THREW__ = 0;
  invoke_vii(fb + 2398 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 1) {
   i2 = i5;
   i3 = i4;
   i5 = i2;
   i4 = i3;
   continue;
  }
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  __THREW__ = 0;
  invoke_iiiiiiiiii(fb + 3 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0, i7 | 0, i8 | 0, i9 | 0, i9 | 0, i9 | 0, 0, 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i10 | 0, i11 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i12 = 21;
   break;
  } else {
   i2 = i5;
   i3 = i4;
   i5 = i2;
   i4 = i3;
  }
 }
 if ((i12 | 0) != 16) if ((i12 | 0) == 21) {
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i8 >> 2];
  _free(i10 | 0);
  STACKTOP = i13;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 _free(i10 | 0);
 STACKTOP = i13;
 return;
}

function __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i18, i3, i19, i20, i21) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i22 + 468 | 0;
 i27 = i22 + 464 | 0;
 i15 = i22 + 472 | 0;
 i16 = i22 + 460 | 0;
 i17 = i22 + 456 | 0;
 i24 = i22 + 444 | 0;
 i25 = i22 + 432 | 0;
 i26 = i22 + 420 | 0;
 i9 = i22 + 416 | 0;
 i4 = i22 + 16 | 0;
 i11 = i22 + 8 | 0;
 i12 = i22 + 4 | 0;
 i13 = i22;
 HEAP32[i27 >> 2] = __ZNKSt3__28ios_base6getlocEv(i19) | 0;
 __THREW__ = 0;
 i14 = invoke_iii(fb + 1145 | 0, i27 | 0, gb + 1474588 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i6 = i21 + 8 + 3 | 0;
  i7 = HEAP8[i6 >> 0] | 0;
  i1 = i7 << 24 >> 24 < 0;
  i8 = i21 + 4 | 0;
  do if (!((i1 ? HEAP32[i8 >> 2] | 0 : i7 & 255) | 0)) i7 = 0; else {
   i1 = HEAP32[(i1 ? HEAP32[i21 >> 2] | 0 : i21) >> 2] | 0;
   __THREW__ = 0;
   i2 = invoke_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 44 >> 2] | 0, i14 | 0, 45) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L1;
   } else {
    i7 = (i1 | 0) == (i2 | 0);
    break;
   }
  } while (0);
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i24 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i25 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  HEAP32[i26 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i26 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __THREW__ = 0;
  invoke_viiiiiiiiii(fb + 14 | 0, i3 | 0, i7 | 0, i27 | 0, i15 | 0, i16 | 0, i17 | 0, i24 | 0, i25 | 0, i26 | 0, i9 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i5 = HEAP8[i6 >> 0] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i5 << 24 >> 24 < 0 ? i3 : i5 & 255;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) > (i1 | 0)) {
    i29 = HEAP8[i26 + 8 + 3 >> 0] | 0;
    i28 = HEAP8[i25 + 8 + 3 >> 0] | 0;
    i2 = (i29 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i29 & 255) + (i2 - i1 << 1 | 1) + (i28 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i28 & 255) | 0;
   } else {
    i29 = HEAP8[i26 + 8 + 3 >> 0] | 0;
    i2 = HEAP8[i25 + 8 + 3 >> 0] | 0;
    i2 = (i29 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i29 & 255) + 2 + (i2 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i2 & 255) | 0;
   }
   i2 = i2 + i1 | 0;
   do if (i2 >>> 0 > 100) {
    i4 = _malloc(i2 << 2) | 0;
    i2 = i4;
    if (!i4) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     } else {
      i4 = 0;
      i5 = HEAP8[i6 >> 0] | 0;
      i3 = HEAP32[i8 >> 2] | 0;
      i1 = HEAP32[i9 >> 2] | 0;
      i23 = 26;
      break;
     }
    } else i23 = 26;
   } else {
    i2 = 0;
    i23 = 26;
   } while (0);
   if ((i23 | 0) == 26) {
    i29 = i5 << 24 >> 24 < 0;
    i28 = i29 ? HEAP32[i21 >> 2] | 0 : i21;
    __THREW__ = 0;
    invoke_viiiiiiiiiiiiiii(fb + 4 | 0, i4 | 0, i11 | 0, i12 | 0, HEAP32[i19 + 4 >> 2] | 0, i28 | 0, i28 + ((i29 ? i3 : i5 & 255) << 2) | 0, i14 | 0, i7 | 0, i15 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i17 >> 2] | 0, i24 | 0, i25 | 0, i26 | 0, i1 | 0);
    i29 = __THREW__;
    __THREW__ = 0;
    if (!(i29 & 1)) {
     HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
     i29 = HEAP32[i11 >> 2] | 0;
     i1 = HEAP32[i12 >> 2] | 0;
     __THREW__ = 0;
     HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
     i1 = invoke_iiiiiii(fb + 147 | 0, i10 | 0, i4 | 0, i29 | 0, i1 | 0, i19 | 0, i20 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (!(i29 & 1)) {
      if (i2 | 0) _free(i2);
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i26);
      __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i25);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
      __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i27 >> 2] | 0) | 0;
      STACKTOP = i22;
      return i1 | 0;
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   if (i2 | 0) _free(i2);
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i26);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i25);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i27 >> 2] | 0) | 0;
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN9LensFlare11UpdateFlareEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 24 | 0;
 i3 = i15 + 12 | 0;
 i14 = i15;
 i6 = i13 + 72 | 0;
 i11 = i13 + 28 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 } else {
  i12 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(1.0);
  __ZNK9Transform18TransformDirectionERK8Vector3f(i2, i12, i3);
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i10 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i12 = i10 + 4 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 >> 2] = i12;
   i12 = i10 + 12 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i10;
   break;
  } else {
   i10 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i12 = i10 + 4 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 >> 2] = i12;
   i12 = i10 + 12 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i10;
   break;
  }
 } else i10 = i1; while (0);
 i12 = HEAP32[i13 + 68 >> 2] | 0;
 i4 = i13 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 14; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 16;
   }
  }
  if ((i5 | 0) == 14) i5 = 16;
  if ((i5 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i6 = HEAP8[i6 >> 0] | 0;
 i7 = HEAP32[i13 + 56 >> 2] | 0;
 i8 = i13 + 40 | 0;
 i9 = HEAP32[i13 + 60 >> 2] | 0;
 i4 = 1 << HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2];
 i5 = HEAP32[i13 + 64 >> 2] | 0;
 i2 = HEAP32[i10 + 12 >> 2] | 0;
 i3 = i2 + (i12 * 52 | 0) | 0;
 i11 = i2 + (i12 * 52 | 0) + 16 | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 if (!i1) {
  i10 = 0;
  i14 = i2 + (i12 * 52 | 0) + 28 | 0;
  HEAP32[i14 >> 2] = i10;
  i14 = i2 + (i12 * 52 | 0) + 48 | 0;
  HEAP8[i14 >> 0] = i6;
  i14 = i2 + (i12 * 52 | 0) + 40 | 0;
  HEAP32[i14 >> 2] = i7;
  i14 = HEAP32[i8 >> 2] | 0;
  i10 = i13 + 44 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i13 + 48 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i13 = i13 + 52 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  HEAP32[i3 >> 2] = i14;
  i14 = i2 + (i12 * 52 | 0) + 4 | 0;
  HEAP32[i14 >> 2] = i10;
  i14 = i2 + (i12 * 52 | 0) + 8 | 0;
  HEAP32[i14 >> 2] = i11;
  i14 = i2 + (i12 * 52 | 0) + 12 | 0;
  HEAP32[i14 >> 2] = i13;
  i14 = i2 + (i12 * 52 | 0) + 44 | 0;
  HEAP32[i14 >> 2] = i9;
  i14 = i2 + (i12 * 52 | 0) + 32 | 0;
  HEAP32[i14 >> 2] = i4;
  i14 = i2 + (i12 * 52 | 0) + 36 | 0;
  HEAP32[i14 >> 2] = i5;
  STACKTOP = i15;
  return;
 }
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i14 = i2 + (i12 * 52 | 0) + 28 | 0;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + (i12 * 52 | 0) + 48 | 0;
 HEAP8[i14 >> 0] = i6;
 i14 = i2 + (i12 * 52 | 0) + 40 | 0;
 HEAP32[i14 >> 2] = i7;
 i14 = HEAP32[i8 >> 2] | 0;
 i10 = i13 + 44 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = i13 + 48 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i13 = i13 + 52 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i3 >> 2] = i14;
 i14 = i2 + (i12 * 52 | 0) + 4 | 0;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + (i12 * 52 | 0) + 8 | 0;
 HEAP32[i14 >> 2] = i11;
 i14 = i2 + (i12 * 52 | 0) + 12 | 0;
 HEAP32[i14 >> 2] = i13;
 i14 = i2 + (i12 * 52 | 0) + 44 | 0;
 HEAP32[i14 >> 2] = i9;
 i14 = i2 + (i12 * 52 | 0) + 32 | 0;
 HEAP32[i14 >> 2] = i4;
 i14 = i2 + (i12 * 52 | 0) + 36 | 0;
 HEAP32[i14 >> 2] = i5;
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i20, i1, i15) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 24 | 0;
 i19 = i22 + 16 | 0;
 i16 = i22 + 12 | 0;
 i17 = i22 + 8 | 0;
 i10 = i22 + 4 | 0;
 i11 = i22;
 i9 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i7 = i13 - i9 | 0;
 i18 = (i7 | 0) / 24 | 0;
 i8 = i20 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = i9;
 i5 = i2;
 if (i18 >>> 0 > ((i1 - i2 | 0) / 24 | 0) >>> 0) {
  if (i2) {
   i6 = i20 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) i1 = i2; else {
    i4 = i21 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -24 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i2 + -20 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i17 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i21 >> 2] = 66;
      HEAP32[i4 >> 2] = i17;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i20 >> 2] | 0;
   }
   i17 = HEAP32[i20 + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = 12;
   HEAP32[i21 + 4 >> 2] = i17;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i21);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   i1 = 0;
  }
  if ((i7 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i20);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i20 >> 2] | 0;
  } else i2 = 0;
  i17 = (i1 - i2 | 0) / 24 | 0;
  i1 = i17 << 1;
  i1 = i17 >>> 0 < 1073741823 ? (i1 >>> 0 < i18 >>> 0 ? i18 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i20);
  i17 = HEAP32[i20 + 12 >> 2] | 0;
  HEAP32[i21 >> 2] = 12;
  HEAP32[i21 + 4 >> 2] = i17;
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 16, i21, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i20 + 4 >> 2] = i17;
  HEAP32[i20 >> 2] = i17;
  HEAP32[i8 >> 2] = i17 + (i1 * 24 | 0);
  HEAP32[i10 >> 2] = i9;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i19 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i20, i19, i21, i18);
  STACKTOP = i22;
  return;
 }
 i14 = i20 + 4 | 0;
 i11 = ((HEAP32[i14 >> 2] | 0) - i2 | 0) / 24 | 0;
 i12 = i18 >>> 0 > i11 >>> 0;
 i11 = i12 ? i3 + (i11 * 24 | 0) | 0 : i13;
 i10 = i11;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i5;
  i9 = i3;
  do {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   i6 = i1 + 4 | 0;
   i2 = i9 + 4 | 0;
   do if ((i1 | 0) != (i9 | 0)) {
    i8 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i8 = i4 ? HEAP32[i9 + 8 >> 2] | 0 : i8 & 255;
    i4 = i6 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i8 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 8 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
     break;
    }
    if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
    if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
    HEAP8[i2 + i8 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 8 >> 2] = i8;
     break;
    } else {
     HEAP8[i4 >> 0] = i8;
     break;
    }
   } while (0);
   HEAP32[i1 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   i9 = i9 + 24 | 0;
   i1 = i1 + 24 | 0;
  } while ((i9 | 0) != (i10 | 0));
  i5 = i1;
 }
 if (i12) {
  HEAP32[i16 >> 2] = i11;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  i18 = i18 - (((HEAP32[i14 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) / 24 | 0) | 0;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i20, i19, i21, i18);
  STACKTOP = i22;
  return;
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i22;
  return;
 }
 i4 = i21 + 4 | 0;
 do {
  i2 = i1 + -24 | 0;
  HEAP32[i14 >> 2] = i2;
  i3 = i1 + -20 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i20 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i1 + -8 >> 2] | 0;
   HEAP32[i21 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i20, i21);
   i1 = HEAP32[i14 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i22;
 return;
}

function __ZNSt3__218__stable_sort_moveIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeE(i1, i11, i5, i6, i2) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 20 | 0;
 i3 = i13 + 16 | 0;
 i7 = i13 + 12 | 0;
 i8 = i13 + 8 | 0;
 i9 = i13 + 4 | 0;
 i10 = i13;
 switch (i6 | 0) {
 case 1:
  {
   i10 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   STACKTOP = i13;
   return;
  }
 case 2:
  {
   i3 = (HEAP32[i11 >> 2] | 0) + -8 | 0;
   HEAP32[i11 >> 2] = i3;
   i1 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) < (HEAP32[i1 >> 2] | 0)) {
    i12 = i3;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i2;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i1;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    STACKTOP = i13;
    return;
   } else {
    i12 = i1;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i2;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i3;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2 + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    STACKTOP = i13;
    return;
   }
  }
 case 0:
  {
   STACKTOP = i13;
   return;
  }
 default:
  {
   if ((i6 | 0) < 9) {
    i1 = HEAP32[i1 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (i7 | 0)) {
     STACKTOP = i13;
     return;
    }
    i10 = i1;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i2;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i7 | 0)) {
     STACKTOP = i13;
     return;
    } else i6 = i2;
    do {
     i3 = i6;
     i6 = i6 + 8 | 0;
     if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) {
      i10 = i3;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i12 = i6;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
      L14 : do if ((i3 | 0) == (i2 | 0)) i3 = i2; else {
       i4 = i3;
       while (1) {
        i3 = i4;
        i4 = i4 + -8 | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        if ((HEAP32[i1 >> 2] | 0) >= (i5 | 0)) break L14;
        HEAP32[i3 >> 2] = i5;
        HEAP32[i3 + 4 >> 2] = HEAP32[i3 + -4 >> 2];
        if ((i4 | 0) == (i2 | 0)) {
         i3 = i2;
         break;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     } else {
      i10 = i1;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i12 = i6;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
     }
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i7 | 0));
    STACKTOP = i13;
    return;
   }
   i14 = i6 >>> 1;
   i1 = HEAP32[i1 >> 2] | 0;
   i12 = i1 + (i14 << 3) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i8 >> 2] = i12;
   HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i3, i4, i5, i14, i2, i14);
   HEAP32[i9 >> 2] = i12;
   i11 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i11;
   i8 = i6 - i14 | 0;
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i3, i4, i5, i8, i2 + (i14 << 3) | 0, i8);
   i4 = i11;
   L23 : do if (i14) {
    i3 = i12;
    while (1) {
     if ((i3 | 0) == (i4 | 0)) break;
     if ((HEAP32[i3 >> 2] | 0) < (HEAP32[i1 >> 2] | 0)) {
      i10 = i3;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i14 = i2;
      HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i14 + 4 >> 2] = i11;
      i3 = i3 + 8 | 0;
     } else {
      i10 = i1;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i14 = i2;
      HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i14 + 4 >> 2] = i11;
      i1 = i1 + 8 | 0;
     }
     i2 = i2 + 8 | 0;
     if ((i1 | 0) == (i12 | 0)) {
      i1 = i3;
      break L23;
     }
    }
    if ((i1 | 0) == (i12 | 0)) {
     STACKTOP = i13;
     return;
    }
    while (1) {
     i10 = i1;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i14 = i2;
     HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i14 + 4 >> 2] = i11;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 8 | 0;
    }
    STACKTOP = i13;
    return;
   } while (0);
   if ((i1 | 0) == (i4 | 0)) {
    STACKTOP = i13;
    return;
   }
   while (1) {
    i11 = i1;
    i12 = HEAP32[i11 + 4 >> 2] | 0;
    i14 = i2;
    HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i14 + 4 >> 2] = i12;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 8 | 0;
   }
   STACKTOP = i13;
   return;
  }
 }
}

function __Z18TransformDirection23TransformAccessReadOnlyRKN4math7_float3E(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i7 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 20 >> 2]);
 f19 = Math_fround(f18 * Math_fround(-2.0));
 f10 = Math_fround(f18 * Math_fround(2.0));
 f5 = Math_fround(f19 * f20);
 f11 = Math_fround(f4 * Math_fround(2.0));
 f14 = Math_fround(f4 * Math_fround(-2.0));
 f16 = Math_fround(f20 * f14);
 f17 = Math_fround(Math_fround(f18 * f19) - Math_fround(f4 * f11));
 f15 = Math_fround(Math_fround(f3 * f10) - f16);
 f13 = Math_fround(f5 - Math_fround(f3 * f14));
 f12 = Math_fround(f3 * Math_fround(-2.0));
 f21 = Math_fround(f3 * Math_fround(2.0));
 f20 = Math_fround(f20 * f12);
 f16 = Math_fround(f16 - Math_fround(f18 * f12));
 f14 = Math_fround(Math_fround(f4 * f14) - Math_fround(f3 * f21));
 f11 = Math_fround(Math_fround(f18 * f11) - f20);
 f5 = Math_fround(Math_fround(f21 * f4) - f5);
 f4 = Math_fround(f20 - Math_fround(f19 * f4));
 f10 = Math_fround(Math_fround(f3 * f12) - Math_fround(f18 * f10));
 f18 = Math_fround(HEAPF32[i9 >> 2]);
 f17 = Math_fround(f18 * f17);
 f15 = Math_fround(f18 * f15);
 f13 = Math_fround(f18 * f13);
 i2 = i9 + 4 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i9 + 8 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(Math_fround(f18 + f17) + Math_fround(Math_fround(f12 * f16) + Math_fround(f5 * f3)));
 f4 = Math_fround(Math_fround(f12 + f15) + Math_fround(Math_fround(f12 * f14) + Math_fround(f4 * f3)));
 f3 = Math_fround(Math_fround(f3 + f13) + Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f3)));
 HEAPF32[i9 >> 2] = f5;
 HEAPF32[i2 >> 2] = f4;
 HEAPF32[i6 >> 2] = f3;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 do {
  i24 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i23 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 28 >> 2]);
  f21 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 32 >> 2]);
  f10 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 36 >> 2]);
  f26 = Math_fround((f26 > Math_fround(0.0) & 1) - (f26 < Math_fround(0.0) & 1) | 0);
  f21 = Math_fround((f21 > Math_fround(0.0) & 1) - (f21 < Math_fround(0.0) & 1) | 0);
  f10 = Math_fround((f10 > Math_fround(0.0) & 1) - (f10 < Math_fround(0.0) & 1) | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i24;
  i23 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i23;
  i22 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i22;
  f10 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 16 >> 2]);
  f21 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 12 >> 2]);
  f26 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 20 >> 2]);
  f25 = Math_fround(f10 * Math_fround(-2.0));
  f20 = Math_fround(f10 * Math_fround(2.0));
  f13 = Math_fround(f25 * f26);
  f19 = Math_fround(f16 * Math_fround(2.0));
  f15 = Math_fround(f16 * Math_fround(-2.0));
  f12 = Math_fround(f26 * f15);
  f11 = Math_fround(Math_fround(f10 * f25) - Math_fround(f16 * f19));
  f14 = Math_fround(Math_fround(f21 * f20) - f12);
  f17 = Math_fround(f13 - Math_fround(f21 * f15));
  f18 = Math_fround(f21 * Math_fround(-2.0));
  f27 = Math_fround(f21 * Math_fround(2.0));
  f26 = Math_fround(f26 * f18);
  f12 = Math_fround(f12 - Math_fround(f10 * f18));
  f15 = Math_fround(Math_fround(f16 * f15) - Math_fround(f21 * f27));
  f19 = Math_fround(Math_fround(f10 * f19) - f26);
  f13 = Math_fround(Math_fround(f27 * f16) - f13);
  f16 = Math_fround(f26 - Math_fround(f25 * f16));
  f20 = Math_fround(Math_fround(f21 * f18) - Math_fround(f10 * f20));
  f10 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f10 * f11);
  f14 = Math_fround(f10 * f14);
  f17 = Math_fround(f10 * f17);
  f18 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(Math_fround(f10 + f11) + Math_fround(Math_fround(f18 * f12) + Math_fround(f13 * f21)));
  f4 = Math_fround(Math_fround(f18 + f14) + Math_fround(Math_fround(f18 * f15) + Math_fround(f16 * f21)));
  f3 = Math_fround(Math_fround(f21 + f17) + Math_fround(Math_fround(f18 * f19) + Math_fround(f20 * f21)));
  i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i9 >> 2] = f5;
 HEAPF32[i2 >> 2] = f4;
 HEAPF32[i6 >> 2] = f3;
 return;
}

function __ZN21ImposterRenderTextureC2ERK12TreeDatabase(i15, i4) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 16 | 0;
 i19 = i20 + 8 | 0;
 i16 = i20;
 HEAP32[i15 >> 2] = i4;
 i14 = i15 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAPF32[i15 + 28 >> 2] = Math_fround(inf);
 HEAPF32[i15 + 32 >> 2] = Math_fround(inf);
 i17 = i15 + 36 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = 0;
 i13 = i15 + 44 | 0;
 HEAP32[i13 >> 2] = 256;
 i8 = i15 + 48 | 0;
 HEAP32[i8 >> 2] = 2048;
 i1 = i15 + 52 | 0;
 i2 = gb + 1162292 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i4 + 28 | 0;
 i4 = i4 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i5 - i1 | 0;
 if (i2) {
  __ZNSt3__26vectorI5RectTIfENS_9allocatorIS2_EEE8__appendEj(i14, (i2 | 0) / 156 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
 }
 i12 = i1;
 i11 = (i5 | 0) == (i1 | 0);
 if (i11) f10 = Math_fround(0.0); else {
  f7 = Math_fround(HEAP32[i13 >> 2] | 0);
  i3 = (i5 - i1 | 0) / 156 | 0;
  i2 = 0;
  f6 = Math_fround(0.0);
  do {
   f10 = Math_fround(HEAPF32[i12 + (i2 * 156 | 0) + 148 >> 2]);
   i4 = f10 < Math_fround(1.0);
   f6 = Math_fround(f6 + Math_fround(Math_fround(f7 * (i4 ? f10 : Math_fround(1.0))) + Math_fround(1.0)));
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
  f10 = f6;
 }
 i2 = ~~Math_fround(f10 + Math_fround(.5)) >>> 0;
 i4 = i2 + -1 | 0;
 i4 = i4 >>> 16 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = (i4 >>> 1 | i4) + 1 | 0;
 i3 = i4 >>> 1;
 i4 = (i2 - i3 | 0) >>> 0 < (i4 - i2 | 0) >>> 0 ? i3 : i4;
 i8 = HEAP32[i8 >> 2] | 0;
 i8 = (i4 | 0) < (i8 | 0) ? i4 : i8;
 f9 = Math_fround(Math_fround(1.0) / Math_fround(i8 | 0));
 i4 = HEAP32[i13 >> 2] | 0;
 if (!i11) {
  f7 = Math_fround(i4 | 0);
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = (i5 - i1 | 0) / 156 | 0;
  i1 = 0;
  f6 = Math_fround(0.0);
  do {
   f21 = Math_fround(HEAPF32[i12 + (i1 * 156 | 0) + 148 >> 2]);
   i14 = f21 < Math_fround(1.0);
   f21 = Math_fround(Math_fround(f7 * (i14 ? f21 : Math_fround(1.0))) / f10);
   f22 = Math_fround(Math_fround(f21 - f9) - f9);
   HEAPF32[i3 + (i1 << 4) >> 2] = Math_fround(f9 + f6);
   HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f22;
   HEAPF32[i3 + (i1 << 4) + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i3 + (i1 << 4) + 12 >> 2] = Math_fround(1.0);
   f6 = Math_fround(f6 + f21);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i14 = i15 + 20 | 0;
 HEAP32[i14 >> 2] = 0;
 i13 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 935344 | 0, 32) | 0;
 i5 = gb + 63520 | 0;
 i11 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i16;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode(i13, i18, 0);
 __Z19pop_allocation_rootv();
 i13 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i13) | 0;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0, 61);
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 40 >> 2] | 0, i13 | 0, gb + 935426 | 0);
 __ZN13RenderTexture8SetWidthEi(i13, i8);
 __ZN13RenderTexture9SetHeightEi(i13, i4);
 __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i13, 0);
 __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat(i13, 1);
 __ZN13RenderTexture9SetMipMapEb(i13, 1);
 __ZN7Texture13SetMipMapBiasEf(i13, Math_fround(-1.0));
 __ZN13RenderTexture16SetSRGBReadWriteEb(i13, 0);
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, 4);
 i16 = i15 + 24 | 0;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, gb + 935448 | 0, 15);
 HEAP32[i19 >> 2] = 0;
 i13 = __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz(i18, 1, 61, gb + 1044265 | 0, i19) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i13, gb + 29832 | 0) | 0;
 i19 = i15 + 16 | 0;
 HEAP32[i19 >> 2] = i13;
 __ZN6Camera16SetTargetTextureEP13RenderTexture(i13, HEAP32[((HEAP8[i17 >> 0] | 0) == 0 ? i14 : i16) >> 2] | 0);
 __ZN6Camera13SetClearFlagsEi(HEAP32[i19 >> 2] | 0, 2);
 i17 = HEAP32[i19 >> 2] | 0;
 HEAPF32[i18 >> 2] = Math_fround(.200000003);
 HEAPF32[i18 + 4 >> 2] = Math_fround(.200000003);
 HEAPF32[i18 + 8 >> 2] = Math_fround(.200000003);
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i17, i18);
 __ZN6Camera15SetOrthographicEb(HEAP32[i19 >> 2] | 0, 1);
 __ZN6Camera14SetCullingMaskEj(HEAP32[i19 >> 2] | 0, 0);
 i19 = HEAP32[i19 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 116 >> 2] | 0, i19 | 0, 0);
 STACKTOP = i20;
 return;
}

function __ZNSt3__211__sift_downIR19ROSorterReplacementP17RODataReplacementEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i19, i1, i2, i20, i11) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i1 = (i11 - i19 | 0) / 40 | 0;
 if ((i20 | 0) < 2) {
  STACKTOP = i18;
  return;
 }
 i16 = (i20 + -2 | 0) / 2 | 0;
 if ((i16 | 0) < (i1 | 0)) {
  STACKTOP = i18;
  return;
 }
 i8 = i1 << 1 | 1;
 i1 = i19 + (i8 * 40 | 0) | 0;
 i10 = i8 + 1 | 0;
 if ((i10 | 0) < (i20 | 0)) {
  i9 = i1 + 40 | 0;
  i2 = HEAP32[i19 + (i8 * 40 | 0) + 28 >> 2] | 0;
  i3 = HEAP32[i9 + 28 >> 2] | 0;
  do if ((i2 | 0) == (i3 | 0)) {
   i3 = i1;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i9;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
    i6 = HEAP16[i19 + (i8 * 40 | 0) + 32 >> 1] | 0;
    i7 = HEAP16[i9 + 32 >> 1] | 0;
    if (i6 << 16 >> 16 != i7 << 16 >> 16) {
     i2 = (i6 & 65535) > (i7 & 65535);
     break;
    }
   }
   i2 = i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0;
  } else i2 = i2 >>> 0 < i3 >>> 0; while (0);
  i1 = i2 ? i9 : i1;
  i8 = i2 ? i10 : i8;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i15 = HEAP32[i11 + 28 >> 2] | 0;
 do if ((i2 | 0) == (i15 | 0)) {
  i6 = i1;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i7 = i11;
  i3 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0) & (i6 | 0) == (i7 | 0)) {
   i4 = HEAP16[i1 + 32 >> 1] | 0;
   i5 = HEAP16[i11 + 32 >> 1] | 0;
   if (i4 << 16 >> 16 != i5 << 16 >> 16) {
    if ((i4 & 65535) <= (i5 & 65535)) {
     i14 = i2;
     break;
    }
    STACKTOP = i18;
    return;
   }
  }
  if (i6 >>> 0 < i7 >>> 0 | (i6 | 0) == (i7 | 0) & i2 >>> 0 < i3 >>> 0) {
   STACKTOP = i18;
   return;
  } else {
   i14 = i3;
   i6 = i7;
  }
 } else if (i2 >>> 0 < i15 >>> 0) {
  STACKTOP = i18;
  return;
 } else {
  i6 = i11;
  i14 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  break;
 } while (0);
 i13 = i11 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 i13 = HEAP16[i11 + 32 >> 1] | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP16[i11 + 32 >> 1] = HEAP16[i1 + 32 >> 1] | 0;
 L31 : do if ((i16 | 0) >= (i8 | 0)) {
  i2 = i8;
  while (1) {
   i2 = i2 << 1 | 1;
   i7 = i19 + (i2 * 40 | 0) | 0;
   i12 = i2 + 1 | 0;
   if ((i12 | 0) < (i20 | 0)) {
    i11 = i7 + 40 | 0;
    i3 = HEAP32[i19 + (i2 * 40 | 0) + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 28 >> 2] | 0;
    do if ((i3 | 0) == (i4 | 0)) {
     i4 = i7;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     i8 = i11;
     i5 = HEAP32[i8 >> 2] | 0;
     i8 = HEAP32[i8 + 4 >> 2] | 0;
     if ((i3 | 0) == (i5 | 0) & (i4 | 0) == (i8 | 0)) {
      i9 = HEAP16[i19 + (i2 * 40 | 0) + 32 >> 1] | 0;
      i10 = HEAP16[i11 + 32 >> 1] | 0;
      if (i9 << 16 >> 16 != i10 << 16 >> 16) {
       i3 = (i9 & 65535) > (i10 & 65535);
       break;
      }
     }
     i3 = i4 >>> 0 < i8 >>> 0 | (i4 | 0) == (i8 | 0) & i3 >>> 0 < i5 >>> 0;
    } else i3 = i3 >>> 0 < i4 >>> 0; while (0);
    i7 = i3 ? i11 : i7;
    i2 = i3 ? i12 : i2;
   }
   i3 = HEAP32[i7 + 28 >> 2] | 0;
   do if ((i3 | 0) == (i15 | 0)) {
    i4 = i7;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i3 | 0) == (i14 | 0) & (i4 | 0) == (i6 | 0)) {
     i5 = HEAP16[i7 + 32 >> 1] | 0;
     if (i5 << 16 >> 16 != i13 << 16 >> 16) if ((i5 & 65535) > (i13 & 65535)) break L31; else break;
    }
    if (i4 >>> 0 < i6 >>> 0 | (i4 | 0) == (i6 | 0) & i3 >>> 0 < i14 >>> 0) break L31;
   } else if (i3 >>> 0 < i15 >>> 0) break L31; while (0);
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
   HEAP16[i1 + 32 >> 1] = HEAP16[i7 + 32 >> 1] | 0;
   if ((i16 | 0) < (i2 | 0)) {
    i1 = i7;
    break;
   } else i1 = i7;
  }
 } while (0);
 i20 = i1;
 HEAP32[i20 >> 2] = i14;
 HEAP32[i20 + 4 >> 2] = i6;
 i20 = i1 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i1 + 28 >> 2] = i15;
 HEAP16[i1 + 32 >> 1] = i13;
 STACKTOP = i18;
 return;
}

function __Z18MonoBehaviourDoGUIiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS1_E(i8, i9, i14, i15, i16, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 760 | 0;
 i17 = i22 + 488 | 0;
 i18 = i22 + 744 | 0;
 i19 = i22 + 752 | 0;
 i20 = i22 + 240 | 0;
 i10 = i22 + 736 | 0;
 i11 = i22;
 i12 = i22 + 728 | 0;
 i13 = i22 + 480 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i17 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i17);
   i4 = HEAP32[i21 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 6; else {
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) i7 = 8;
  }
 }
 if ((i7 | 0) == 6) i7 = 8;
 if ((i7 | 0) == 8) {
  i2 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
 }
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i17 >> 2] = i6;
 if (!i1) i7 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i17);
   i2 = HEAP32[i21 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 14; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 16;
  }
 }
 if ((i7 | 0) == 14) i7 = 16;
 if ((i7 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = __Z19GetSpecificGUIStatei(i8) | 0;
 i2 = i1 + 96 | 0;
 i3 = i1 + 280 | 0;
 __ZN12GUIClipState10BeginOnGUIER10InputEvent(i2, HEAP32[i3 >> 2] | 0);
 __ZN8GUIState10BeginOnGUIER14ObjectGUIState(i1, i9);
 i7 = (__Z24GetIMGUIScriptingClassesv() | 0) + 40 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i18;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i21 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i17, i21);
 __ZN18ScriptingArguments6AddIntEi(i17, i15);
 __ZN18ScriptingArguments6AddIntEi(i17, i4);
 __ZN18ScriptingArguments6AddIntEi(i17, i14);
 HEAP32[i21 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i17, i21, 0) | 0;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i18 = i10;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = i17;
 HEAP32[i21 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i20, i5, i21);
 HEAP8[i20 + 233 >> 0] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i20, i19, 0) | 0;
 if (!(HEAP32[i19 >> 2] | 0)) {
  i18 = (__Z24GetIMGUIScriptingClassesv() | 0) + 48 | 0;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i20 = i13;
  HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i20 + 4 >> 2] = i19;
  HEAP32[i21 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i11, i21);
  __ZN18ScriptingArguments6AddIntEi(i11, i14);
  HEAP32[i21 >> 2] = 0;
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i11, i21, 0) | 0;
  __ZN8GUIState8EndOnGUIEv(i1);
  __ZN12GUIClipState8EndOnGUIER10InputEvent(i2, HEAP32[i3 >> 2] | 0);
  i21 = (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) == 12;
  STACKTOP = i22;
  return i21 | 0;
 }
 i17 = (__Z24GetIMGUIScriptingClassesv() | 0) + 32 | 0;
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i20 = i12;
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i20 + 4 >> 2] = i18;
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i11, i21);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i11, HEAP32[i19 >> 2] | 0);
 HEAP32[i21 >> 2] = 0;
 i21 = __ZN19ScriptingInvocation6InvokeIbEET_PP15Il2CppExceptionb(i11, i21, 0) | 0;
 __ZN12GUIClipState19EndThroughExceptionEv(i2);
 __ZN8GUIState8EndOnGUIEv(i1);
 if (i21) i1 = (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) == 12; else {
  __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(HEAP32[i19 >> 2] | 0, i4, 0);
  i1 = 0;
 }
 i21 = i1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN9Texture2D8CompressEb(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16;
 i6 = i16 + 4 | 0;
 if (!(HEAP8[i14 + 111 >> 0] | 0)) {
  HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0) | 0;
  __Z6FormatPKcz(i6, gb + 417501 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 410682 | 0, 1581, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i16;
  return;
 }
 i12 = __Z20push_allocation_rootPvP13BaseAllocatorb(i14, 0, 0) | 0;
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 183 >> 0] | 0) {
  i13 = i14 + 52 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) {
   i5 = HEAP32[i14 + 92 >> 2] | 0;
   i5 = (i5 | 0) == -1 ? 5 : i5;
  } else i5 = HEAP32[i1 + 36 >> 2] | 0;
  if ((i5 + -10 | 0) >>> 0 >= 3) if (((i5 | 1) + -25 | 0) >>> 0 >= 5) {
   i1 = i5 + -30 | 0;
   if (i1 >>> 0 < 15) {
    if ((i5 + -48 | 0) >>> 0 < 12 | ((i5 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
   } else if ((i5 + -45 | 0) >>> 0 < 3 | (i5 + -48 | 0) >>> 0 < 12) break;
   i8 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 112 >> 2] | 0, i14 | 0) | 0;
   i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0) | 0;
   i11 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 140 >> 2] | 0, i14 | 0) | 0;
   if (i8) i1 = __Z24CalculateImageMipMapSizeii13TextureFormat(i10, i11, 4) | 0; else i1 = __Z18CalculateImageSizeii13TextureFormat(i10, i11, 4) | 0;
   i9 = __Znaj((i1 | 0) > -1 ? i1 : -1) | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 112 >> 2] | 0, i14 | 0) | 0) {
    i1 = __Z22CalculateMipMapCount3Diii(HEAP32[i14 + 84 >> 2] | 0, HEAP32[i14 + 88 >> 2] | 0, 1) | 0;
    if ((i1 | 0) > 0) i3 = 17; else i2 = 0;
   } else {
    i1 = 1;
    i3 = 17;
   }
   if ((i3 | 0) == 17) {
    i3 = i14 + 4 | 0;
    i2 = 0;
    do {
     i4 = i9 + (__Z21CalculateMipMapOffsetii13TextureFormati(i10, i11, 4, i2) | 0) | 0;
     i7 = i10 >> i2;
     i7 = (i7 | 0) < 1 ? 1 : i7;
     i17 = i11 >> i2;
     __ZN14ImageReferenceC2Eiii13TextureFormatPv(i6, i7, (i17 | 0) < 1 ? 1 : i17, i7 << 2, 4, i4);
     i4 = HEAP32[i13 >> 2] | 0;
     if (!i4) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411051 | 0, 0, gb + 410682 | 0, 351, 1, HEAP32[i3 >> 2] | 0, 0, 0); else __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i4, i6, 0, 1, 0) | 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
    i2 = 1;
   }
   switch (i5 | 0) {
   case 1:
   case 2:
   case 4:
   case 5:
   case 6:
   case 9:
   case 11:
   case 12:
   case 13:
   case 14:
   case 17:
   case 20:
   case 25:
   case 29:
   case 31:
   case 33:
   case 36:
   case 46:
   case 47:
    {
     i7 = 1;
     break;
    }
   default:
    i7 = (i5 | 0) == 61 | (i5 + -54 | 0) >>> 0 < 6;
   }
   i6 = i7 ? 12 : 10;
   if (!(mftCall_iiiiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 188 >> 2] | 0, i14 | 0, i10 | 0, i11 | 0, i6 | 0, i8 & 1 | 0, 1, -1, 0) | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417621 | 0, 0, gb + 410682 | 0, 1623, 1, 0, 0, 0);
    __ZdaPv(i9);
    break;
   }
   if (i2) {
    i4 = 0;
    do {
     i5 = i9 + (__Z21CalculateMipMapOffsetii13TextureFormati(i10, i11, 4, i4) | 0) | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     do if (!i2) i2 = 0; else {
      if ((HEAP32[i2 + 4 >> 2] | 0) != 1) {
       i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
       i17 = HEAP32[i13 >> 2] | 0;
       HEAP32[i2 + 4 >> 2] = 1;
       HEAP32[i2 >> 2] = gb + 41960 + 8;
       __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i2 + 8 | 0, i17 + 8 | 0);
       i3 = i2 + 28 | 0;
       i17 = i17 + 28 | 0;
       HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
       HEAP32[i3 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
       HEAP32[i3 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
       HEAP32[i3 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
       HEAP32[i3 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
       HEAP32[i3 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
       i3 = HEAP32[i13 >> 2] | 0;
       i17 = i3 + 4 | 0;
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
       if (!(HEAP32[i17 >> 2] | 0)) {
        mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
        __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63272 | 0);
       }
       HEAP32[i13 >> 2] = i2;
       if (!i2) {
        i2 = 0;
        break;
       }
      }
      i2 = HEAP32[i2 + 8 >> 2] | 0;
     } while (0);
     i17 = i2 + (__Z21CalculateMipMapOffsetii13TextureFormati(i10, i11, i6, i4) | 0) | 0;
     i3 = i10 >> i4;
     i8 = i11 >> i4;
     __Z17FastCompressImageiiPKhPhbb((i3 | 0) < 1 ? 1 : i3, (i8 | 0) < 1 ? 1 : i8, i5, i17, i7, i15);
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i1 | 0));
   }
   __ZdaPv(i9);
   mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 196 >> 2] | 0, i14 | 0);
  }
 } while (0);
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i16;
 return;
}

function __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i9, i3, i4, i1, i2, i22) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i21 + 24 | 0;
 i20 = i21;
 i19 = i21 + 16 | 0;
 i16 = i8 + 4 | 0;
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i6 = i9 + 84 | 0;
 i2 = (HEAP32[i6 >> 2] & 2 | 0) == 0;
 if (i2) i12 = HEAP32[i9 + 92 >> 2] | 0; else i12 = 0;
 i1 = HEAP32[i9 + 68 >> 2] | 0;
 i3 = i1 + -1 | 0;
 if ((i3 | 0) > -1) {
  i7 = i9 + 92 | 0;
  i5 = i1 + 1 | 0;
  i4 = i16;
  while (1) {
   if (i2) i1 = i3 * 112 | 0; else i1 = (HEAP32[i7 >> 2] | 0) + (i3 * 112 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   i3 = i3 + -1 | 0;
   i2 = (HEAP32[i6 >> 2] & 2 | 0) == 0;
   if ((i3 | 0) <= -1) break; else i4 = i4 + 4 | 0;
  }
  i1 = i8 + (i5 << 2) | 0;
  if (i2) i2 = 0; else i10 = 11;
 } else if (i2) {
  i2 = 0;
  i1 = i16;
 } else {
  i1 = i16;
  i10 = 11;
 }
 if ((i10 | 0) == 11) i2 = HEAP32[i9 + 92 >> 2] | 0;
 i8 = i20 + 4 | 0;
 i9 = i20 + 8 | 0;
 i10 = i20 + 12 | 0;
 i3 = 1;
 L17 : while (1) {
  i6 = i1 + -4 | 0;
  if (!i3) i7 = HEAP32[i6 >> 2] | 0; else i7 = i2;
  f41 = Math_fround(HEAPF32[i12 + i7 >> 2]);
  f35 = Math_fround(HEAPF32[i12 + (i7 + 4) >> 2]);
  f24 = Math_fround(HEAPF32[i12 + (i7 + 8) >> 2]);
  f29 = Math_fround(HEAPF32[i12 + (i7 + 12) >> 2]);
  f45 = Math_fround(HEAPF32[i12 + (i7 + 16) >> 2]);
  f39 = Math_fround(HEAPF32[i12 + (i7 + 20) >> 2]);
  f28 = Math_fround(HEAPF32[i12 + (i7 + 24) >> 2]);
  f33 = Math_fround(HEAPF32[i12 + (i7 + 28) >> 2]);
  f44 = Math_fround(HEAPF32[i12 + (i7 + 32) >> 2]);
  f38 = Math_fround(HEAPF32[i12 + (i7 + 36) >> 2]);
  f27 = Math_fround(HEAPF32[i12 + (i7 + 40) >> 2]);
  f32 = Math_fround(HEAPF32[i12 + (i7 + 44) >> 2]);
  f43 = Math_fround(HEAPF32[i12 + (i7 + 48) >> 2]);
  f37 = Math_fround(HEAPF32[i12 + (i7 + 52) >> 2]);
  f26 = Math_fround(HEAPF32[i12 + (i7 + 56) >> 2]);
  f31 = Math_fround(HEAPF32[i12 + (i7 + 60) >> 2]);
  f42 = Math_fround(HEAPF32[i12 + (i7 + 64) >> 2]);
  f36 = Math_fround(HEAPF32[i12 + (i7 + 68) >> 2]);
  f25 = Math_fround(HEAPF32[i12 + (i7 + 72) >> 2]);
  f30 = Math_fround(HEAPF32[i12 + (i7 + 76) >> 2]);
  f40 = Math_fround(HEAPF32[i12 + (i7 + 80) >> 2]);
  f34 = Math_fround(HEAPF32[i12 + (i7 + 84) >> 2]);
  f23 = Math_fround(HEAPF32[i12 + (i7 + 88) >> 2]);
  i5 = f45 > f15 | f44 > f11 | (f17 > f43 | f18 > f42 | (f41 > f14 | f13 > f40));
  i3 = (f39 > f15 | f38 > f11 | (f17 > f37 | f18 > f36 | (f35 > f14 | f13 > f34))) << 31 >> 31;
  i4 = (f33 > f15 | f32 > f11 | (f17 > f31 | f18 > f30 | (f29 > f14 ? 1 : f13 > Math_fround(HEAPF32[i12 + (i7 + 92) >> 2])))) << 31 >> 31;
  HEAP32[i20 >> 2] = i5 << 31 >> 31;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = (f28 > f15 | f27 > f11 | (f17 > f26 | f18 > f25 | (f24 > f14 | f13 > f23))) << 31 >> 31;
  HEAP32[i10 >> 2] = i4;
  i4 = HEAP32[i12 + (i7 + 96) >> 2] & -2;
  HEAP32[i19 >> 2] = i4;
  do if (i5) {
   i5 = i3;
   i3 = 0;
   i1 = i6;
  } else if (!(HEAP32[i12 + (i7 + 96) >> 2] & 1)) {
   HEAP32[i6 >> 2] = i4;
   i5 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
   i3 = 1;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 1, i19 | 0) | 0) {
   i5 = i3;
   i3 = 0;
   i1 = i6;
   break;
  } else {
   i10 = 20;
   break L17;
  } while (0);
  i4 = HEAP32[i12 + (i7 + 100) >> 2] & -2;
  HEAP32[i19 >> 2] = i4;
  do if (!i5) if (!(HEAP32[i12 + (i7 + 100) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i4;
   i4 = HEAP32[i19 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 1, i19 | 0) | 0) {
   i4 = i2;
   break;
  } else {
   i10 = 20;
   break L17;
  } else i4 = i2; while (0);
  i2 = HEAP32[i12 + (i7 + 104) >> 2] & -2;
  HEAP32[i19 >> 2] = i2;
  do if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP32[i12 + (i7 + 104) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i2;
   i4 = HEAP32[i19 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 1, i19 | 0) | 0) break; else {
   i10 = 20;
   break L17;
  } while (0);
  i2 = HEAP32[i12 + (i7 + 108) >> 2] & -2;
  HEAP32[i19 >> 2] = i2;
  do if (!(HEAP32[i10 >> 2] | 0)) if (!(HEAP32[i12 + (i7 + 108) >> 2] & 1)) {
   HEAP32[i1 >> 2] = i2;
   i2 = HEAP32[i19 >> 2] | 0;
   i3 = 1;
   i1 = i1 + 4 | 0;
   break;
  } else if (mftCall_iiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, 1, i19 | 0) | 0) {
   i2 = i4;
   break;
  } else {
   i10 = 20;
   break L17;
  } else i2 = i4; while (0);
  if (i1 >>> 0 <= i16 >>> 0) {
   i10 = 20;
   break;
  }
 }
 if ((i10 | 0) == 20) {
  STACKTOP = i21;
  return;
 }
}

function __ZN12_GLOBAL__N_113SetBlendStateER7ApiGLESR15DeviceStateGLESPK20DeviceBlendStateGLESi(i17, i1, i16, i13) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i1 = i1 + 468 | 0;
 i14 = HEAP32[i1 >> 2] | 0;
 if ((i14 | 0) == (i16 | 0)) return;
 HEAP32[i1 >> 2] = i16;
 i6 = __Z15GetGraphicsCapsv() | 0;
 i5 = (HEAP8[i14 + 180 >> 0] | 0) != 0;
 i15 = i16 + 64 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = i1 ^ HEAP32[i14 + 64 >> 2];
 L4 : do if (!(HEAP8[i16 + 180 >> 0] | 0)) {
  if (i5) __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i17, 0);
  i16 = HEAP8[i16 >> 0] | 0;
  i1 = i16 & 255;
  if (!((i3 & 1 | 0) == 0 ? (HEAP8[i14 >> 0] | 0) == i16 << 24 >> 24 : 0)) mftCall_viiii(HEAP32[i17 + 28 >> 2] | 0, i1 >>> 3 & 1 | 0, i1 >>> 2 & 1 | 0, i1 >>> 1 & 1 | 0, i1 & 1 | 0);
 } else {
  if (!i5) {
   __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i17, 0);
   i1 = HEAP32[i15 >> 2] | 0;
  }
  if (!(i1 & 1)) {
   i4 = i16 + 68 | 0;
   i13 = HEAP8[i16 >> 0] | 0;
   i2 = i13 & 255;
   i1 = (i3 & 1 | 0) == 0;
   if (!(i1 & (HEAP8[i14 >> 0] | 0) == i13 << 24 >> 24)) mftCall_viiii(HEAP32[i17 + 28 >> 2] | 0, i2 >>> 3 & 1 | 0, i2 >>> 2 & 1 | 0, i2 >>> 1 & 1 | 0, i2 & 1 | 0);
   i3 = i5 & i1;
   if (i3) {
    i2 = HEAP16[i14 + 68 >> 1] | 0;
    i1 = HEAP16[i4 >> 1] | 0;
    if (i2 << 16 >> 16 == i1 << 16 >> 16) if ((HEAP16[i14 + 70 >> 1] | 0) == (HEAP16[i16 + 70 >> 1] | 0)) if ((HEAP16[i14 + 72 >> 1] | 0) == (HEAP16[i16 + 72 >> 1] | 0)) if ((HEAP16[i14 + 74 >> 1] | 0) == (HEAP16[i16 + 74 >> 1] | 0)) i2 = 21; else {
     i1 = i2;
     i2 = 20;
    } else {
     i1 = i2;
     i2 = 20;
    } else {
     i1 = i2;
     i2 = 20;
    } else i2 = 20;
   } else {
    i1 = HEAP16[i4 >> 1] | 0;
    i2 = 20;
   }
   if ((i2 | 0) == 20) {
    mftCall_viiii(HEAP32[i17 + 20 >> 2] | 0, i1 & 65535 | 0, HEAPU16[i16 + 70 >> 1] | 0, HEAPU16[i16 + 72 >> 1] | 0, HEAPU16[i16 + 74 >> 1] | 0);
    if (i3) i2 = 21;
   }
   if ((i2 | 0) == 21) if ((HEAP16[i14 + 76 >> 1] | 0) == (HEAP16[i16 + 76 >> 1] | 0)) if ((HEAP16[i14 + 78 >> 1] | 0) == (HEAP16[i16 + 78 >> 1] | 0)) break;
   i2 = HEAP16[i16 + 80 >> 1] | 0;
   if (!(i2 & 2)) i1 = 1; else i1 = (HEAP8[i6 + 166 >> 0] | 0) == 0 ? 2 : 0;
   if (!(HEAP8[i6 + 164 >> 0] | 0)) i1 = (i2 & 1) == 0 ? i1 : 2;
   switch (i1 | 0) {
   case 1:
    {
     mftCall_vii(HEAP32[i17 + 12 >> 2] | 0, HEAPU16[i16 + 76 >> 1] | 0, HEAPU16[i16 + 78 >> 1] | 0);
     break L4;
    }
   case 0:
    {
     mftCall_vi(HEAP32[i17 + 4 >> 2] | 0, HEAPU16[i16 + 76 >> 1] | 0);
     break L4;
    }
   default:
    break L4;
   }
  }
  if ((i13 | 0) > 0) {
   i12 = (i3 & 1 | 0) == 0;
   i11 = i5 & i12;
   i8 = i6 + 164 | 0;
   i9 = i17 + 16 | 0;
   i10 = i17 + 8 | 0;
   i6 = i6 + 166 | 0;
   i7 = i17 + 24 | 0;
   i5 = i17 + 32 | 0;
   i4 = 0;
   do {
    i2 = i16 + 68 + (i4 * 14 | 0) | 0;
    i3 = HEAP8[i16 + (i4 << 3) >> 0] | 0;
    i1 = i3 & 255;
    if (!(i12 & (HEAP8[i14 + (i4 << 3) >> 0] | 0) == i3 << 24 >> 24)) mftCall_viiiii(HEAP32[i5 >> 2] | 0, i4 | 0, i1 >>> 3 & 1 | 0, i1 >>> 2 & 1 | 0, i1 >>> 1 & 1 | 0, i1 & 1 | 0);
    if (i11) {
     i3 = HEAP16[i14 + 68 + (i4 * 14 | 0) >> 1] | 0;
     i1 = HEAP16[i2 >> 1] | 0;
     if (i3 << 16 >> 16 == i1 << 16 >> 16) if ((HEAP16[i14 + 68 + (i4 * 14 | 0) + 2 >> 1] | 0) == (HEAP16[i16 + 68 + (i4 * 14 | 0) + 2 >> 1] | 0)) if ((HEAP16[i14 + 68 + (i4 * 14 | 0) + 4 >> 1] | 0) == (HEAP16[i16 + 68 + (i4 * 14 | 0) + 4 >> 1] | 0)) if ((HEAP16[i14 + 68 + (i4 * 14 | 0) + 6 >> 1] | 0) == (HEAP16[i16 + 68 + (i4 * 14 | 0) + 6 >> 1] | 0)) i2 = 39; else {
      i1 = i3;
      i2 = 38;
     } else {
      i1 = i3;
      i2 = 38;
     } else {
      i1 = i3;
      i2 = 38;
     } else i2 = 38;
    } else {
     i1 = HEAP16[i2 >> 1] | 0;
     i2 = 38;
    }
    if ((i2 | 0) == 38) {
     mftCall_viiiii(HEAP32[i7 >> 2] | 0, i4 | 0, i1 & 65535 | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 2 >> 1] | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 4 >> 1] | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 6 >> 1] | 0);
     if (i11) i2 = 39; else i2 = 41;
    }
    if ((i2 | 0) == 39) {
     i2 = 0;
     if ((HEAP16[i14 + 68 + (i4 * 14 | 0) + 8 >> 1] | 0) == (HEAP16[i16 + 68 + (i4 * 14 | 0) + 8 >> 1] | 0)) {
      if ((HEAP16[i14 + 68 + (i4 * 14 | 0) + 10 >> 1] | 0) != (HEAP16[i16 + 68 + (i4 * 14 | 0) + 10 >> 1] | 0)) i2 = 41;
     } else i2 = 41;
    }
    L58 : do if ((i2 | 0) == 41) {
     i2 = HEAP16[i16 + 68 + (i4 * 14 | 0) + 12 >> 1] | 0;
     if (!(i2 & 2)) i1 = 1; else i1 = (HEAP8[i6 >> 0] | 0) == 0 ? 2 : 0;
     if (!(HEAP8[i8 >> 0] | 0)) i1 = (i2 & 1) == 0 ? i1 : 2;
     switch (i1 | 0) {
     case 1:
      {
       mftCall_viii(HEAP32[i9 >> 2] | 0, i4 | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 8 >> 1] | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 10 >> 1] | 0);
       break L58;
      }
     case 0:
      {
       mftCall_vii(HEAP32[i10 >> 2] | 0, i4 | 0, HEAPU16[i16 + 68 + (i4 * 14 | 0) + 8 >> 1] | 0);
       break L58;
      }
     default:
      break L58;
     }
    } while (0);
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i13 | 0));
  }
 } while (0);
 if (!(HEAP32[i15 >> 2] & 2)) {
  __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i17, 12);
  return;
 } else {
  __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i17, 12);
  return;
 }
}

function __ZN19UnityConnectService25UnregisterGlobalCallbacksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i1 = i8 + 4 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 19296 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i4 = i6 + 18528 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (fb + 4429 | 0)) {
    i3 = i6 + 18528 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 18528 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i3 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L4;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i3 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 18528 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 18528 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 18528 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 18528 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 18528 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 18528 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 20840 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L15 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 20072 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3936 | 0)) {
    i4 = i6 + 20072 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 20072 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L15;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 20072 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 20072 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 20072 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 20072 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 20072 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 20072 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 24700 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L26 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 23932 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3937 | 0)) {
    i4 = i6 + 23932 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 23932 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L26;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 23932 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 23932 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 23932 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 23932 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 1540 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L37 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 772 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3938 | 0)) {
    i4 = i6 + 772 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 772 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L37;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 772 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 772 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 772 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 4628 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 3860 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 330 | 0)) {
   i4 = i6 + 3860 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 3860 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i9 = 37;
   break;
  }
 }
 if ((i9 | 0) == 37) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i9 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i9;
 if (i9 >>> 0 <= i1 >>> 0) return;
 do {
  i9 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 3860 + (i9 * 12 | 0) >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 3860 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 3860 + (i9 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 3860 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i21, i22, i19, i12, i5, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0;
 i20 = __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i21, i22, i19, i12, i1) | 0;
 i1 = i5 + 8 | 0;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 20 | 0;
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i6 = i12 + 8 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i12 + 20 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20;
  return i22 | 0;
 }
 i15 = HEAP32[i12 >> 2] | 0;
 i8 = i12 + 4 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 12 | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i10 = i12 + 16 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 24 | 0;
 i14 = i11;
 i18 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = i15;
 HEAP32[i5 + 4 >> 2] = i16;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 12 >> 2] = i17;
 HEAP32[i5 + 16 >> 2] = i13;
 HEAPF32[i4 >> 2] = f3;
 i13 = i5 + 24 | 0;
 HEAP32[i13 >> 2] = i18;
 HEAP32[i13 + 4 >> 2] = i14;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2])) * Math_fround(.5));
 i13 = i19 + 8 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i19 + 20 | 0;
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20 + 1 | 0;
  return i22 | 0;
 }
 i26 = HEAP32[i19 >> 2] | 0;
 i15 = i19 + 4 | 0;
 i25 = HEAP32[i15 >> 2] | 0;
 i16 = i19 + 12 | 0;
 i24 = HEAP32[i16 >> 2] | 0;
 i17 = i19 + 16 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i18 = i19 + 24 | 0;
 i4 = i18;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i12 >> 2] = i26;
 HEAP32[i8 >> 2] = i25;
 HEAPF32[i6 >> 2] = f2;
 HEAP32[i9 >> 2] = i24;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i7 >> 2] = f3;
 i1 = i11;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i4;
 f23 = Math_fround(HEAPF32[i13 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
 i1 = i22 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i22 + 20 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i26 = i20 + 2 | 0;
  return i26 | 0;
 }
 i10 = HEAP32[i22 >> 2] | 0;
 i5 = i22 + 4 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i22 + 12 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i7 = i22 + 16 | 0;
 i26 = HEAP32[i7 >> 2] | 0;
 i8 = i22 + 24 | 0;
 i25 = i8;
 i24 = HEAP32[i25 >> 2] | 0;
 i25 = HEAP32[i25 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 HEAP32[i19 >> 2] = i10;
 HEAP32[i15 >> 2] = i11;
 HEAPF32[i13 >> 2] = f2;
 HEAP32[i16 >> 2] = i12;
 HEAP32[i17 >> 2] = i26;
 HEAPF32[i14 >> 2] = f3;
 i26 = i18;
 HEAP32[i26 >> 2] = i24;
 HEAP32[i26 + 4 >> 2] = i25;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i26 = i20 + 3 | 0;
  return i26 | 0;
 }
 i17 = HEAP32[i21 >> 2] | 0;
 i18 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = HEAP32[i21 + 12 >> 2] | 0;
 i26 = HEAP32[i21 + 16 >> 2] | 0;
 i25 = i21 + 24 | 0;
 i24 = HEAP32[i25 >> 2] | 0;
 i25 = HEAP32[i25 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
 HEAP32[i22 >> 2] = i17;
 HEAP32[i5 >> 2] = i18;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i6 >> 2] = i19;
 HEAP32[i7 >> 2] = i26;
 HEAPF32[i4 >> 2] = f3;
 i26 = i8;
 HEAP32[i26 >> 2] = i24;
 HEAP32[i26 + 4 >> 2] = i25;
 i26 = i20 + 4 | 0;
 return i26 | 0;
}

function __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i21, i22, i19, i12, i5, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0;
 i20 = __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i21, i22, i19, i12, i1) | 0;
 i1 = i5 + 4 | 0;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 16 | 0;
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i6 = i12 + 4 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i12 + 16 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20;
  return i22 | 0;
 }
 i15 = HEAP32[i12 >> 2] | 0;
 i8 = i12 + 8 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 12 | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i10 = i12 + 20 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 24 | 0;
 i14 = i11;
 i18 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = i15;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 8 >> 2] = i16;
 HEAP32[i5 + 12 >> 2] = i17;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 20 >> 2] = i13;
 i13 = i5 + 24 | 0;
 HEAP32[i13 >> 2] = i18;
 HEAP32[i13 + 4 >> 2] = i14;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2])) * Math_fround(.5));
 i13 = i19 + 4 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i19 + 16 | 0;
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20 + 1 | 0;
  return i22 | 0;
 }
 i26 = HEAP32[i19 >> 2] | 0;
 i15 = i19 + 8 | 0;
 i25 = HEAP32[i15 >> 2] | 0;
 i16 = i19 + 12 | 0;
 i24 = HEAP32[i16 >> 2] | 0;
 i17 = i19 + 20 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i18 = i19 + 24 | 0;
 i4 = i18;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i12 >> 2] = i26;
 HEAPF32[i6 >> 2] = f2;
 HEAP32[i8 >> 2] = i25;
 HEAP32[i9 >> 2] = i24;
 HEAPF32[i7 >> 2] = f3;
 HEAP32[i10 >> 2] = i1;
 i1 = i11;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i4;
 f23 = Math_fround(HEAPF32[i13 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
 i1 = i22 + 4 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i22 + 16 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i26 = i20 + 2 | 0;
  return i26 | 0;
 }
 i10 = HEAP32[i22 >> 2] | 0;
 i5 = i22 + 8 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i22 + 12 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i7 = i22 + 20 | 0;
 i26 = HEAP32[i7 >> 2] | 0;
 i8 = i22 + 24 | 0;
 i25 = i8;
 i24 = HEAP32[i25 >> 2] | 0;
 i25 = HEAP32[i25 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i22 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 HEAP32[i19 >> 2] = i10;
 HEAPF32[i13 >> 2] = f2;
 HEAP32[i15 >> 2] = i11;
 HEAP32[i16 >> 2] = i12;
 HEAPF32[i14 >> 2] = f3;
 HEAP32[i17 >> 2] = i26;
 i26 = i18;
 HEAP32[i26 >> 2] = i24;
 HEAP32[i26 + 4 >> 2] = i25;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i26 = i20 + 3 | 0;
  return i26 | 0;
 }
 i17 = HEAP32[i21 >> 2] | 0;
 i18 = HEAP32[i21 + 8 >> 2] | 0;
 i19 = HEAP32[i21 + 12 >> 2] | 0;
 i26 = HEAP32[i21 + 20 >> 2] | 0;
 i25 = i21 + 24 | 0;
 i24 = HEAP32[i25 >> 2] | 0;
 i25 = HEAP32[i25 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
 HEAP32[i21 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
 HEAP32[i22 >> 2] = i17;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 >> 2] = i18;
 HEAP32[i6 >> 2] = i19;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i7 >> 2] = i26;
 i26 = i8;
 HEAP32[i26 >> 2] = i24;
 HEAP32[i26 + 4 >> 2] = i25;
 i26 = i20 + 4 | 0;
 return i26 | 0;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 24 | 0;
 i7 = i8 + 20 | 0;
 i5 = i8 + 8 | 0;
 i11 = i8;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i12 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903650 | 0, i12, i1, 0);
 i6 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903662 | 0, i12, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903677 | 0, i12, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i2 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 16;
 HEAP32[i5 + 4 >> 2] = i1 + 12;
 HEAP32[i5 + 8 >> 2] = i9;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903693 | 0, i9, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903708 | 0, gb + 905830 | 0, i1 + 20 | 0, 0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 904041 | 0, i11, 0);
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i5 >> 2] = i11 + 4;
 HEAP32[i5 + 4 >> 2] = i11;
 HEAP32[i5 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903818 | 0, i9, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i5, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903722 | 0, gb + 905830 | 0, i1 + 24 | 0, 0);
 i7 = i4;
 i9 = i7 + 40 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903736 | 0, i4, 0);
 __ZN7mecanim9animation19Blend2dDataConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903756 | 0, gb + 905830 | 0, i12, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation23BlendDirectDataConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i12, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903798 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903807 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898587 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898680 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i8;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = -1;
      HEAP32[i2 + 8 >> 2] = -1;
      i3 = i2 + 12 | 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      HEAP32[i3 + 12 >> 2] = 0;
      HEAP32[i3 + 16 >> 2] = 0;
      HEAP32[i2 + 32 >> 2] = -1;
      HEAPF32[i2 + 36 >> 2] = Math_fround(0.0);
      HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
      HEAP8[i2 + 44 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903628 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = -1;
       HEAP32[i2 + 8 >> 2] = -1;
       i3 = i2 + 12 | 0;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP32[i3 + 16 >> 2] = 0;
       HEAP32[i2 + 32 >> 2] = -1;
       HEAPF32[i2 + 36 >> 2] = Math_fround(0.0);
       HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
       HEAP8[i2 + 44 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903628 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i18, i3, i19, i20, i21) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i22 + 56 | 0;
 i27 = i22 + 52 | 0;
 i15 = i22 + 164 | 0;
 i16 = i22 + 161 | 0;
 i17 = i22 + 160 | 0;
 i24 = i22 + 40 | 0;
 i25 = i22 + 28 | 0;
 i26 = i22 + 16 | 0;
 i9 = i22 + 12 | 0;
 i4 = i22 + 60 | 0;
 i11 = i22 + 8 | 0;
 i12 = i22 + 4 | 0;
 i13 = i22;
 HEAP32[i27 >> 2] = __ZNKSt3__28ios_base6getlocEv(i19) | 0;
 __THREW__ = 0;
 i14 = invoke_iii(fb + 1145 | 0, i27 | 0, gb + 1474556 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i6 = i21 + 11 | 0;
  i7 = HEAP8[i6 >> 0] | 0;
  i1 = i7 << 24 >> 24 < 0;
  i8 = i21 + 4 | 0;
  do if (!((i1 ? HEAP32[i8 >> 2] | 0 : i7 & 255) | 0)) i7 = 0; else {
   i1 = HEAP8[(i1 ? HEAP32[i21 >> 2] | 0 : i21) >> 0] | 0;
   __THREW__ = 0;
   i2 = invoke_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0, 45) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L1;
   } else {
    i7 = i1 << 24 >> 24 == i2 << 24 >> 24;
    break;
   }
  } while (0);
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i24 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  HEAP32[i25 >> 2] = 0;
  HEAP32[i25 + 4 >> 2] = 0;
  HEAP32[i25 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i25 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  HEAP32[i26 >> 2] = 0;
  HEAP32[i26 + 4 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i26 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __THREW__ = 0;
  invoke_viiiiiiiiii(fb + 13 | 0, i3 | 0, i7 | 0, i27 | 0, i15 | 0, i16 | 0, i17 | 0, i24 | 0, i25 | 0, i26 | 0, i9 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i5 = HEAP8[i6 >> 0] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i5 << 24 >> 24 < 0 ? i3 : i5 & 255;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) > (i1 | 0)) {
    i29 = HEAP8[i26 + 11 >> 0] | 0;
    i28 = HEAP8[i25 + 11 >> 0] | 0;
    i2 = (i29 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i29 & 255) + (i2 - i1 << 1 | 1) + (i28 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i28 & 255) | 0;
   } else {
    i29 = HEAP8[i26 + 11 >> 0] | 0;
    i2 = HEAP8[i25 + 11 >> 0] | 0;
    i2 = (i29 << 24 >> 24 < 0 ? HEAP32[i26 + 4 >> 2] | 0 : i29 & 255) + 2 + (i2 << 24 >> 24 < 0 ? HEAP32[i25 + 4 >> 2] | 0 : i2 & 255) | 0;
   }
   i2 = i2 + i1 | 0;
   do if (i2 >>> 0 > 100) {
    i4 = _malloc(i2) | 0;
    i2 = i4;
    if (!i4) {
     __THREW__ = 0;
     invoke_v(fb + 459 | 0);
     i29 = __THREW__;
     __THREW__ = 0;
     if (i29 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     } else {
      i4 = 0;
      i5 = HEAP8[i6 >> 0] | 0;
      i3 = HEAP32[i8 >> 2] | 0;
      i1 = HEAP32[i9 >> 2] | 0;
      i23 = 26;
      break;
     }
    } else i23 = 26;
   } else {
    i2 = 0;
    i23 = 26;
   } while (0);
   if ((i23 | 0) == 26) {
    i29 = i5 << 24 >> 24 < 0;
    i28 = i29 ? HEAP32[i21 >> 2] | 0 : i21;
    __THREW__ = 0;
    invoke_viiiiiiiiiiiiiii(fb + 3 | 0, i4 | 0, i11 | 0, i12 | 0, HEAP32[i19 + 4 >> 2] | 0, i28 | 0, i28 + (i29 ? i3 : i5 & 255) | 0, i14 | 0, i7 | 0, i15 | 0, HEAP8[i16 >> 0] | 0, HEAP8[i17 >> 0] | 0, i24 | 0, i25 | 0, i26 | 0, i1 | 0);
    i29 = __THREW__;
    __THREW__ = 0;
    if (!(i29 & 1)) {
     HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
     i29 = HEAP32[i11 >> 2] | 0;
     i1 = HEAP32[i12 >> 2] | 0;
     __THREW__ = 0;
     HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
     i1 = invoke_iiiiiii(fb + 146 | 0, i10 | 0, i4 | 0, i29 | 0, i1 | 0, i19 | 0, i20 | 0) | 0;
     i29 = __THREW__;
     __THREW__ = 0;
     if (!(i29 & 1)) {
      if (i2 | 0) _free(i2);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
      __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i27 >> 2] | 0) | 0;
      STACKTOP = i22;
      return i1 | 0;
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   if (i2 | 0) _free(i2);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
 } while (0);
 __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i27 >> 2] | 0) | 0;
 ___resumeException(i1 | 0);
 return 0;
}

function runPostSets239() {
 HEAP32[gb + 213940 >> 2] = fb + 1534;
 HEAP32[gb + 213944 >> 2] = fb + 1535;
 HEAP32[gb + 213948 >> 2] = fb + 126;
 HEAP32[gb + 213952 >> 2] = fb + 1536;
 HEAP32[gb + 12688 >> 2] = (HEAP32[gb + 12688 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12692 >> 2] = (HEAP32[gb + 12692 >> 2] | 0) + (gb + 1081434 | 0);
 HEAP32[gb + 12696 >> 2] = (HEAP32[gb + 12696 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 213960 >> 2] = (HEAP32[gb + 213960 >> 2] | 0) + (gb + 12704 | 0);
 HEAP32[gb + 213964 >> 2] = fb + 3123;
 HEAP32[gb + 213968 >> 2] = fb + 3175;
 HEAP32[gb + 213972 >> 2] = fb + 3068;
 HEAP32[gb + 213976 >> 2] = fb + 50;
 HEAP32[gb + 213980 >> 2] = fb + 51;
 HEAP32[gb + 213984 >> 2] = fb + 127;
 HEAP32[gb + 213988 >> 2] = fb + 1537;
 HEAP32[gb + 213992 >> 2] = fb + 1538;
 HEAP32[gb + 213996 >> 2] = fb + 128;
 HEAP32[gb + 214e3 >> 2] = fb + 1539;
 HEAP32[gb + 12704 >> 2] = (HEAP32[gb + 12704 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12708 >> 2] = (HEAP32[gb + 12708 >> 2] | 0) + (gb + 1081468 | 0);
 HEAP32[gb + 12712 >> 2] = (HEAP32[gb + 12712 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 214008 >> 2] = (HEAP32[gb + 214008 >> 2] | 0) + (gb + 12720 | 0);
 HEAP32[gb + 214012 >> 2] = fb + 3123;
 HEAP32[gb + 214016 >> 2] = fb + 3176;
 HEAP32[gb + 214020 >> 2] = fb + 3068;
 HEAP32[gb + 214024 >> 2] = fb + 52;
 HEAP32[gb + 214028 >> 2] = fb + 53;
 HEAP32[gb + 214032 >> 2] = fb + 129;
 HEAP32[gb + 214036 >> 2] = fb + 1540;
 HEAP32[gb + 214040 >> 2] = fb + 1541;
 HEAP32[gb + 214044 >> 2] = fb + 130;
 HEAP32[gb + 214048 >> 2] = fb + 1542;
 HEAP32[gb + 12720 >> 2] = (HEAP32[gb + 12720 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12724 >> 2] = (HEAP32[gb + 12724 >> 2] | 0) + (gb + 1081503 | 0);
 HEAP32[gb + 12728 >> 2] = (HEAP32[gb + 12728 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 214056 >> 2] = (HEAP32[gb + 214056 >> 2] | 0) + (gb + 12736 | 0);
 HEAP32[gb + 214060 >> 2] = fb + 3148;
 HEAP32[gb + 214064 >> 2] = fb + 3177;
 HEAP32[gb + 214068 >> 2] = fb + 3068;
 HEAP32[gb + 214072 >> 2] = fb + 487;
 HEAP32[gb + 214076 >> 2] = fb + 314;
 HEAP32[gb + 214080 >> 2] = fb + 488;
 HEAP32[gb + 214084 >> 2] = fb + 315;
 HEAP32[gb + 214088 >> 2] = fb + 486;
 HEAP32[gb + 214092 >> 2] = fb + 127;
 HEAP32[gb + 214096 >> 2] = fb + 313;
 HEAP32[gb + 214100 >> 2] = fb + 104;
 HEAP32[gb + 12736 >> 2] = (HEAP32[gb + 12736 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12740 >> 2] = (HEAP32[gb + 12740 >> 2] | 0) + (gb + 1081547 | 0);
 HEAP32[gb + 12744 >> 2] = (HEAP32[gb + 12744 >> 2] | 0) + (gb + 12384 | 0);
 HEAP32[gb + 214108 >> 2] = (HEAP32[gb + 214108 >> 2] | 0) + (gb + 12752 | 0);
 HEAP32[gb + 214112 >> 2] = fb + 3150;
 HEAP32[gb + 214116 >> 2] = fb + 3178;
 HEAP32[gb + 214120 >> 2] = fb + 3068;
 HEAP32[gb + 214124 >> 2] = fb + 316;
 HEAP32[gb + 214128 >> 2] = fb + 128;
 HEAP32[gb + 214132 >> 2] = fb + 129;
 HEAP32[gb + 214136 >> 2] = fb + 130;
 HEAP32[gb + 214140 >> 2] = fb + 489;
 HEAP32[gb + 214144 >> 2] = fb + 317;
 HEAP32[gb + 214148 >> 2] = fb + 490;
 HEAP32[gb + 214152 >> 2] = fb + 318;
 HEAP32[gb + 214156 >> 2] = fb + 491;
 HEAP32[gb + 214160 >> 2] = fb + 131;
 HEAP32[gb + 214164 >> 2] = fb + 319;
 HEAP32[gb + 214168 >> 2] = fb + 105;
 HEAP32[gb + 12752 >> 2] = (HEAP32[gb + 12752 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12756 >> 2] = (HEAP32[gb + 12756 >> 2] | 0) + (gb + 1081675 | 0);
 HEAP32[gb + 12760 >> 2] = (HEAP32[gb + 12760 >> 2] | 0) + (gb + 12400 | 0);
 HEAP32[gb + 214188 >> 2] = (HEAP32[gb + 214188 >> 2] | 0) + (gb + 12768 | 0);
 HEAP32[gb + 214192 >> 2] = fb + 3179;
 HEAP32[gb + 214196 >> 2] = fb + 3180;
 HEAP32[gb + 214200 >> 2] = fb + 1;
 HEAP32[gb + 12768 >> 2] = (HEAP32[gb + 12768 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 12772 >> 2] = (HEAP32[gb + 12772 >> 2] | 0) + (gb + 1082174 | 0);
 HEAP32[gb + 214208 >> 2] = (HEAP32[gb + 214208 >> 2] | 0) + (gb + 12776 | 0);
 HEAP32[gb + 214212 >> 2] = fb + 3179;
 HEAP32[gb + 214216 >> 2] = fb + 3181;
 HEAP32[gb + 214220 >> 2] = fb + 1;
 HEAP32[gb + 214224 >> 2] = fb + 495;
 HEAP32[gb + 214228 >> 2] = fb + 1;
 HEAP32[gb + 12776 >> 2] = (HEAP32[gb + 12776 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12780 >> 2] = (HEAP32[gb + 12780 >> 2] | 0) + (gb + 1082199 | 0);
 HEAP32[gb + 12792 >> 2] = (HEAP32[gb + 12792 >> 2] | 0) + (gb + 12768 | 0);
 HEAP32[gb + 214236 >> 2] = (HEAP32[gb + 214236 >> 2] | 0) + (gb + 12800 | 0);
 HEAP32[gb + 214240 >> 2] = fb + 3182;
 HEAP32[gb + 214244 >> 2] = fb + 3183;
 HEAP32[gb + 214248 >> 2] = fb + 1543;
 HEAP32[gb + 12800 >> 2] = (HEAP32[gb + 12800 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12804 >> 2] = (HEAP32[gb + 12804 >> 2] | 0) + (gb + 1082242 | 0);
 HEAP32[gb + 12808 >> 2] = (HEAP32[gb + 12808 >> 2] | 0) + (gb + 12984 | 0);
 HEAP32[gb + 214256 >> 2] = (HEAP32[gb + 214256 >> 2] | 0) + (gb + 12816 | 0);
 HEAP32[gb + 214260 >> 2] = fb + 3184;
 HEAP32[gb + 214264 >> 2] = fb + 3185;
 HEAP32[gb + 214268 >> 2] = fb + 1406;
 HEAP32[gb + 12816 >> 2] = (HEAP32[gb + 12816 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12820 >> 2] = (HEAP32[gb + 12820 >> 2] | 0) + (gb + 1082504 | 0);
 HEAP32[gb + 12824 >> 2] = (HEAP32[gb + 12824 >> 2] | 0) + (gb + 13112 | 0);
 HEAP32[gb + 214276 >> 2] = (HEAP32[gb + 214276 >> 2] | 0) + (gb + 12832 | 0);
 HEAP32[gb + 214280 >> 2] = fb + 3186;
 runPostSets240();
}

function __ZN14TerrainManager27ClearLightmapsOnAllTerrainsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 8 | 0;
 i9 = i15;
 i13 = i15 + 16 | 0;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i9;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i11;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i11 = i13 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i9);
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 35740 | 0, i13, 0);
 i14 = HEAP32[i14 >> 2] | 0;
 if (i14 | 0) {
  i10 = HEAP32[i13 >> 2] | 0;
  i9 = 0;
  do {
   i8 = HEAP32[i10 + (i9 << 2) >> 2] | 0;
   do if (!(HEAP32[i8 + 8 >> 2] & 1048576)) {
    i4 = i8 + 152 | 0;
    i7 = HEAP32[i4 >> 2] | 0;
    i1 = i7 | 65535;
    if ((i7 | 0) != (i1 | 0)) {
     HEAP32[i4 >> 2] = i1;
     i2 = i8 + 228 | 0;
     i3 = i8 + 240 | 0;
     if (HEAP32[i3 >> 2] | 0) {
      i7 = HEAP32[i2 >> 2] | 0;
      HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 108 >> 2] = i1;
      HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
      i1 = i7 + 20 | 0;
      if ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0)) do {
       HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i4 >> 2];
       HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
       i1 = i1 + 20 | 0;
      } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
     }
    }
    i7 = HEAP32[i4 >> 2] | 0;
    i1 = i7 | -65536;
    if ((i7 | 0) != (i1 | 0)) {
     HEAP32[i4 >> 2] = i1;
     i2 = i8 + 228 | 0;
     i3 = i8 + 240 | 0;
     if (HEAP32[i3 >> 2] | 0) {
      i7 = HEAP32[i2 >> 2] | 0;
      HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 108 >> 2] = i1;
      HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
      i1 = i7 + 20 | 0;
      if ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0)) do {
       HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i4 >> 2];
       HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
       i1 = i1 + 20 | 0;
      } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
     }
    }
    i1 = i8 + 124 | 0;
    if (Math_fround(HEAPF32[i8 + 120 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i8 + 128 >> 2]) == Math_fround(0.0)) {
     if (!(Math_fround(HEAPF32[i8 + 132 >> 2]) == Math_fround(0.0))) i16 = 19;
    } else i16 = 19; else i16 = 19; else i16 = 19;
    if ((i16 | 0) == 19) {
     i16 = 0;
     HEAPF32[i8 + 120 >> 2] = Math_fround(1.0);
     HEAPF32[i1 >> 2] = Math_fround(1.0);
     HEAPF32[i8 + 128 >> 2] = Math_fround(0.0);
     HEAPF32[i8 + 132 >> 2] = Math_fround(0.0);
     i2 = i8 + 228 | 0;
     i3 = i8 + 240 | 0;
     if (HEAP32[i3 >> 2] | 0) {
      i1 = HEAP32[i2 >> 2] | 0;
      do {
       i7 = HEAP32[i1 + 4 >> 2] | 0;
       HEAP32[i7 + 76 >> 2] = 1065353216;
       HEAP32[i7 + 80 >> 2] = 1065353216;
       HEAP32[i7 + 84 >> 2] = 0;
       HEAP32[i7 + 88 >> 2] = 0;
       i7 = HEAP32[i1 + 12 >> 2] | 0;
       HEAP32[i7 + 32 >> 2] = 1065353216;
       HEAP32[i7 + 36 >> 2] = 1065353216;
       HEAP32[i7 + 40 >> 2] = 0;
       HEAP32[i7 + 44 >> 2] = 0;
       i1 = i1 + 20 | 0;
      } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
     }
    }
    i1 = i8 + 140 | 0;
    if (Math_fround(HEAPF32[i8 + 136 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i8 + 144 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i8 + 148 >> 2]) == Math_fround(0.0)) break;
    HEAPF32[i8 + 136 >> 2] = Math_fround(1.0);
    HEAPF32[i1 >> 2] = Math_fround(1.0);
    HEAPF32[i8 + 144 >> 2] = Math_fround(0.0);
    HEAPF32[i8 + 148 >> 2] = Math_fround(0.0);
    i3 = HEAP32[i8 + 156 >> 2] | 0;
    i4 = HEAP32[i8 + 160 >> 2] | 0;
    f5 = Math_fround(Math_fround(HEAPF32[i8 + 164 >> 2]) + Math_fround(0.0));
    f6 = Math_fround(Math_fround(HEAPF32[i8 + 168 >> 2]) + Math_fround(0.0));
    i7 = i8 + 228 | 0;
    i2 = i8 + 240 | 0;
    if (HEAP32[i2 >> 2] | 0) {
     i1 = HEAP32[i7 >> 2] | 0;
     do {
      i8 = HEAP32[i1 + 4 >> 2] | 0;
      HEAP32[i8 + 92 >> 2] = i3;
      HEAP32[i8 + 96 >> 2] = i4;
      HEAPF32[i8 + 100 >> 2] = f5;
      HEAPF32[i8 + 104 >> 2] = f6;
      i8 = HEAP32[i1 + 12 >> 2] | 0;
      HEAP32[i8 + 48 >> 2] = i3;
      HEAP32[i8 + 52 >> 2] = i4;
      HEAPF32[i8 + 56 >> 2] = f5;
      HEAPF32[i8 + 60 >> 2] = f6;
      i1 = i1 + 20 | 0;
     } while ((i1 | 0) != ((HEAP32[i7 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < i14 >>> 0);
 }
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i12);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN12_GLOBAL__N_122RevoluteJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i6, i5, i3, i4, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 28 | 0;
 i1 = i2;
 f9 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(f9 * f14);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f15 * f10));
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f21 * f17));
 f11 = Math_fround(Math_fround(f14 * f18) + Math_fround(Math_fround(f9 * f13) + Math_fround(f12 * Math_fround(Math_fround(f21 * f10) - Math_fround(f15 * f17)))));
 f16 = Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f15 * f13) + Math_fround(f12 * Math_fround(Math_fround(f9 * f17) - Math_fround(f21 * f14)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f15 * f14) - Math_fround(f9 * f10)))) + Math_fround(f17 * f18));
 f11 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f11);
 f16 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f16);
 f18 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f18);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f12 * f9);
 f13 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f14 * f13));
 f21 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f10 * f21));
 f8 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f17 * f9) + Math_fround(Math_fround(f10 * f13) + Math_fround(f12 * f8))) - Math_fround(f14 * f21));
 f20 = Math_fround(Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(f17 * f13) + Math_fround(f12 * f21))) - Math_fround(f10 * f9));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * f9)) - Math_fround(f10 * f8)) - Math_fround(f17 * f21));
 HEAPF32[i7 >> 2] = Math_fround(f15 - Math_fround(f17 * f8));
 HEAPF32[i7 + 4 >> 2] = f19;
 HEAPF32[i7 + 8 >> 2] = f20;
 HEAPF32[i7 + 12 >> 2] = f21;
 HEAPF32[i7 + 16 >> 2] = f11;
 HEAPF32[i7 + 20 >> 2] = f16;
 HEAPF32[i7 + 24 >> 2] = f18;
 f18 = Math_fround(Math_fround(HEAPF32[i5 + 44 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i5 + 48 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i5 + 52 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f18 * f19);
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f16 * f17));
 f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f11 * f15));
 f10 = Math_fround(Math_fround(f19 * f8) + Math_fround(Math_fround(f18 * f20) + Math_fround(f21 * Math_fround(Math_fround(f11 * f17) - Math_fround(f16 * f15)))));
 f9 = Math_fround(Math_fround(f17 * f8) + Math_fround(Math_fround(f16 * f20) + Math_fround(f21 * Math_fround(Math_fround(f18 * f15) - Math_fround(f11 * f19)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f19) - Math_fround(f18 * f17)))) + Math_fround(f15 * f8));
 f10 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f10);
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f8);
 f18 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f16 = Math_fround(f21 * f18);
 f20 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f19 * f20));
 f11 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f17 * f11));
 f14 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f17 * f20) + Math_fround(f21 * f14))) - Math_fround(f19 * f11));
 f12 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f15 * f20) + Math_fround(f21 * f11))) - Math_fround(f17 * f18));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f14)) - Math_fround(f15 * f11));
 HEAPF32[i1 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = f11;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i7 | 0, i1 | 0);
 if (!(HEAP16[i5 + 132 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 f21 = Math_fround(HEAPF32[i5 + 108 >> 2]);
 mftCall_viiffi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, i1 | 0, +f21, +Math_fround(HEAPF32[i5 + 104 >> 2]), 0);
 STACKTOP = i2;
 return;
}

function __ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i7, i23, i20, i5, i1) {
 i7 = i7 | 0;
 i23 = i23 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i21 = 0, i22 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 16 | 0;
 i12 = i24;
 if (mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, i5 | 0, i20 | 0) | 0) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 f4 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f18 = Math_fround(f4 * f15);
 f6 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f18 = Math_fround(f18 - Math_fround(f6 * f13));
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(f8 + f18);
 f13 = Math_fround(Math_fround(f15 * f6) + Math_fround(f4 * f13));
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(f13 + f15);
 HEAPF32[i21 >> 2] = f18;
 HEAPF32[i21 + 4 >> 2] = f13;
 f10 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f14 = Math_fround(f4 * f10);
 f9 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f14 = Math_fround(f8 + Math_fround(f14 - Math_fround(f6 * f9)));
 f15 = Math_fround(Math_fround(Math_fround(f10 * f6) + Math_fround(f4 * f9)) + f15);
 HEAPF32[i21 + 8 >> 2] = f14;
 HEAPF32[i21 + 12 >> 2] = f15;
 f9 = Math_fround(f14 - f18);
 f4 = Math_fround(f15 - f13);
 f6 = Math_fround(HEAPF32[i20 >> 2]);
 f10 = Math_fround(f18 - f6);
 i1 = i20 + 4 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(Math_fround(f9 * Math_fround(f13 - f8)) - Math_fround(f4 * f10));
 f19 = Math_fround(f10 * f10);
 i5 = i7 + 8 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(Math_fround(f9 * f9) + Math_fround(f4 * f4));
 if (!(f19 <= Math_fround(f3 * Math_fround(f2 * f2)))) {
  f2 = Math_fround(f2 / Math_fround(Math_sqrt(Math_fround(f3))));
  f8 = Math_fround(f4 * f2);
  f2 = Math_fround(f9 * f2);
  if (f10 < Math_fround(0.0)) {
   f4 = Math_fround(f2 + f13);
   f6 = Math_fround(f18 - f8);
   f3 = Math_fround(f2 + f15);
   f2 = Math_fround(f14 - f8);
  } else {
   f4 = Math_fround(f15 - f2);
   f6 = Math_fround(f8 + f14);
   f3 = Math_fround(f13 - f2);
   f2 = Math_fround(f8 + f18);
  }
  HEAPF32[i12 >> 2] = f2;
  HEAPF32[i12 + 4 >> 2] = f3;
  HEAPF32[i12 + 8 >> 2] = f6;
  HEAPF32[i12 + 12 >> 2] = f4;
  if (__Z16b2RaycastSegmentP15b2RayCastOutputRK14b2RayCastInputRK6b2Vec2S6_(i23, i20, i12, i12 + 8 | 0) | 0) i1 = 1; else {
   f11 = Math_fround(HEAPF32[i20 >> 2]);
   f10 = Math_fround(HEAPF32[i1 >> 2]);
   i22 = 8;
  }
 } else {
  f11 = f6;
  f10 = f8;
  i22 = 8;
 }
 do if ((i22 | 0) == 8) {
  f16 = Math_fround(Math_fround(HEAPF32[i20 + 8 >> 2]) - f11);
  f19 = Math_fround(Math_fround(HEAPF32[i20 + 12 >> 2]) - f10);
  f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(f19 * f19));
  if (f17 < Math_fround(1.1920929e-07)) i1 = 0; else {
   f2 = Math_fround(f14 - f11);
   f6 = Math_fround(f15 - f10);
   f9 = Math_fround(f18 - f11);
   f8 = Math_fround(f13 - f10);
   i12 = Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6)) < Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) & 1;
   f8 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(f8 * f8);
   i1 = i12 ^ 1;
   f9 = Math_fround(f17 * Math_fround(HEAPF32[i20 + 16 >> 2]));
   f6 = Math_fround(HEAPF32[i21 + (i12 << 3) + 4 >> 2]);
   f2 = Math_fround(f11 - Math_fround(HEAPF32[i21 + (i12 << 3) >> 2]));
   f6 = Math_fround(f10 - f6);
   f3 = Math_fround(Math_fround(f16 * f2) + Math_fround(f19 * f6));
   f4 = Math_fround(Math_fround(f3 * f3) - Math_fround(f17 * Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6)) - f8)));
   if (f4 < Math_fround(0.0)) i22 = 13; else {
    f18 = Math_fround(f3 + Math_fround(Math_sqrt(Math_fround(f4))));
    f3 = Math_fround(-f18);
    if (!(f18 <= Math_fround(-0.0)) | !(f9 >= f3)) i22 = 13;
   }
   if ((i22 | 0) == 13) {
    f6 = Math_fround(HEAPF32[i21 + (i1 << 3) + 4 >> 2]);
    f2 = Math_fround(f11 - Math_fround(HEAPF32[i21 + (i1 << 3) >> 2]));
    f6 = Math_fround(f10 - f6);
    f4 = Math_fround(Math_fround(f16 * f2) + Math_fround(f19 * f6));
    f3 = Math_fround(Math_fround(f4 * f4) - Math_fround(f17 * Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6)) - f8)));
    if (f3 < Math_fround(0.0)) {
     i1 = 0;
     break;
    }
    f18 = Math_fround(f4 + Math_fround(Math_sqrt(Math_fround(f3))));
    f3 = Math_fround(-f18);
    if (!(f18 <= Math_fround(-0.0)) | !(f9 >= f3)) {
     i1 = 0;
     break;
    }
   }
   f3 = Math_fround(f3 / f17);
   HEAPF32[i23 + 8 >> 2] = f3;
   f4 = Math_fround(f2 + Math_fround(f16 * f3));
   f2 = Math_fround(f6 + Math_fround(f19 * f3));
   HEAPF32[i23 >> 2] = f4;
   i1 = i23 + 4 | 0;
   HEAPF32[i1 >> 2] = f2;
   f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2))));
   if (f3 < Math_fround(1.1920929e-07)) i1 = 1; else {
    f19 = Math_fround(Math_fround(1.0) / f3);
    HEAPF32[i23 >> 2] = Math_fround(f4 * f19);
    HEAPF32[i1 >> 2] = Math_fround(f2 * f19);
    i1 = 1;
   }
  }
 } while (0);
 i23 = i1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i1, i8, i9, i3, f2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i10 + 4 | 0;
 i6 = i10;
 i7 = HEAP32[i1 + 152 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) >> 2]);
 HEAPF32[i8 + 4 >> 2] = Math_fround(f21 + f2);
 f28 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) >> 2]);
 HEAPF32[i8 + 8 >> 2] = Math_fround(f28 + f2);
 HEAP32[i8 >> 2] = i9;
 f21 = Math_fround(f28 - f21);
 HEAPF32[i12 >> 2] = f21;
 HEAPF32[i6 >> 2] = Math_fround(.0000999999974);
 i5 = f21 < Math_fround(.0000999999974);
 i6 = HEAP32[(i5 ? i6 : i12) >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 i12 = i7 + (i9 * 52 | 0) + 4 | 0;
 f21 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 16 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i12 >> 2]));
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 8 >> 2]));
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 12 >> 2]));
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 16 >> 2]));
 f32 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(Math_fround(1.0) / Math_fround(f32 * f32));
 i6 = i7 + (i9 * 52 | 0) + 36 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 40 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 44 >> 2]);
 f2 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 48 >> 2]);
 i5 = i7 + (i3 * 52 | 0) + 20 | 0;
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 24 >> 2]);
 f17 = Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 28 >> 2]);
 f20 = Math_fround(f32 * f15);
 f27 = Math_fround(f32 * f14);
 f25 = Math_fround(f32 * f13);
 f23 = Math_fround(f32 * f2);
 f19 = Math_fround(f32 * f19);
 f18 = Math_fround(f32 * f18);
 f17 = Math_fround(f32 * f17);
 f16 = Math_fround(f32 * Math_fround(HEAPF32[i7 + (i3 * 52 | 0) + 32 >> 2]));
 f31 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f27 + f18) - f28) - f28)) / f32);
 f30 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f25 + f17) - f26) - f26)) / f32);
 f29 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f23 + f16) - f24) - f24)) / f32);
 i3 = i8 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(f22 * Math_fround(Math_fround(Math_fround(f20 + f19) - f21) - f21)) / f32);
 HEAPF32[i8 + 16 >> 2] = f31;
 HEAPF32[i8 + 20 >> 2] = f30;
 HEAPF32[i8 + 24 >> 2] = f29;
 f18 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f28 + Math_fround(f28 + f28)) - f27) - f27) - f18));
 f17 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f26 + Math_fround(f26 + f26)) - f25) - f25) - f17));
 f16 = Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f24 + Math_fround(f24 + f24)) - f23) - f23) - f16));
 i1 = i8 + 28 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f22 * Math_fround(Math_fround(Math_fround(Math_fround(f21 + Math_fround(f21 + f21)) - f20) - f20) - f19));
 HEAPF32[i8 + 32 >> 2] = f18;
 HEAPF32[i8 + 36 >> 2] = f17;
 HEAPF32[i8 + 40 >> 2] = f16;
 i4 = i8 + 44 | 0;
 HEAPF32[i4 >> 2] = f15;
 HEAPF32[i8 + 48 >> 2] = f14;
 HEAPF32[i8 + 52 >> 2] = f13;
 HEAPF32[i8 + 56 >> 2] = f2;
 i11 = i8 + 60 | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i6 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i5 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i6 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i5 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i6 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i6 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i5 + 12 >> 2]) == Math_fround(inf))) {
  STACKTOP = i10;
  return;
 }
 i11 = i7 + (i9 * 52 | 0) + 4 | 0;
 i12 = i8 + 60 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN5physx16correlatePatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjj(i28, i27, i3, i4, f29, i5, i30) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f29 = Math_fround(f29);
 i5 = i5 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, i26 = 0, f31 = f0, f32 = f0, f33 = f0;
 i26 = i28 + 4232 | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if ((i1 + 1 | 0) >>> 0 > i30 >>> 0) {
  i2 = i30;
  do {
   HEAP32[i28 + 3968 + (i2 << 2) >> 2] = 65535;
   HEAP32[i28 + 3840 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i26 >> 2] | 0;
  } while (i2 >>> 0 < (i1 + 1 | 0) >>> 0);
 }
 i23 = i28 + 4228 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 if (i2 >>> 0 <= i5 >>> 0) {
  i30 = 0;
  return i30 | 0;
 }
 f24 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i3 = i2;
 i13 = i1;
 i2 = i5;
 i1 = 0;
 while (1) {
  i6 = HEAPU16[i28 + (i2 * 12 | 0) >> 1] | 0;
  f7 = Math_fround(HEAPF32[i27 + (i6 << 6) >> 2]);
  f8 = Math_fround(HEAPF32[i27 + (i6 << 6) + 4 >> 2]);
  f7 = Math_fround(f7 * Math_fround(2.0));
  f8 = Math_fround(f8 * Math_fround(2.0));
  f9 = Math_fround(Math_fround(HEAPF32[i27 + (i6 << 6) + 8 >> 2]) * Math_fround(2.0));
  f12 = Math_fround(Math_fround(Math_fround(f7 * f21) + Math_fround(f8 * f22)) + Math_fround(f9 * f15));
  f10 = Math_fround(Math_fround(f21 * f12) + Math_fround(Math_fround(f7 * f20) - Math_fround(f24 * Math_fround(Math_fround(f9 * f22) - Math_fround(f8 * f15)))));
  f11 = Math_fround(Math_fround(f22 * f12) + Math_fround(Math_fround(f8 * f20) - Math_fround(f24 * Math_fround(Math_fround(f7 * f15) - Math_fround(f9 * f21)))));
  f12 = Math_fround(Math_fround(Math_fround(f9 * f20) - Math_fround(f24 * Math_fround(Math_fround(f8 * f21) - Math_fround(f7 * f22)))) + Math_fround(f15 * f12));
  L10 : do if (i13 >>> 0 > i30 >>> 0) {
   i5 = i28 + (i2 * 12 | 0) + 8 | 0;
   i6 = i28 + (i2 * 12 | 0) + 10 | 0;
   i4 = i30;
   do {
    f31 = Math_fround(f10 * Math_fround(HEAPF32[i28 + 768 + (i4 * 96 | 0) + 24 >> 2]));
    f31 = Math_fround(f31 + Math_fround(f11 * Math_fround(HEAPF32[i28 + 768 + (i4 * 96 | 0) + 28 >> 2])));
    if (!(Math_fround(f31 + Math_fround(f12 * Math_fround(HEAPF32[i28 + 768 + (i4 * 96 | 0) + 32 >> 2]))) < f29)) if ((HEAP16[i28 + 768 + (i4 * 96 | 0) + 20 >> 1] | 0) == (HEAP16[i5 >> 1] | 0)) if ((HEAP16[i28 + 768 + (i4 * 96 | 0) + 18 >> 1] | 0) == (HEAP16[i6 >> 1] | 0)) break L10;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i13 >>> 0);
  } else i4 = i30; while (0);
  if ((i4 | 0) == (i13 | 0)) if (i1 | (i13 | 0) == 32) i1 = 1; else {
   HEAP16[i28 + 4100 + (i13 << 2) >> 1] = -1;
   HEAP16[i28 + 4100 + (HEAP32[i26 >> 2] << 2) + 2 >> 1] = -1;
   i1 = HEAP32[i26 >> 2] | 0;
   HEAP32[i26 >> 2] = i1 + 1;
   f31 = Math_fround(Math_fround(Math_fround(f7 * f18) + Math_fround(f8 * f19)) + Math_fround(f9 * f14));
   f33 = Math_fround(Math_fround(f18 * f31) + Math_fround(Math_fround(f7 * f17) - Math_fround(f16 * Math_fround(Math_fround(f9 * f19) - Math_fround(f8 * f14)))));
   f32 = Math_fround(Math_fround(f19 * f31) + Math_fround(Math_fround(f8 * f17) - Math_fround(f16 * Math_fround(Math_fround(f7 * f14) - Math_fround(f9 * f18)))));
   f31 = Math_fround(Math_fround(Math_fround(f9 * f17) - Math_fround(f16 * Math_fround(Math_fround(f8 * f18) - Math_fround(f7 * f19)))) + Math_fround(f14 * f31));
   i5 = HEAP16[i28 + (i2 * 12 | 0) + 8 >> 1] | 0;
   i6 = HEAP16[i28 + (i2 * 12 | 0) + 10 >> 1] | 0;
   i25 = HEAP16[i28 + (i2 * 12 | 0) + 6 >> 1] | 0;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 24 >> 2] = f10;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 28 >> 2] = f11;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 32 >> 2] = f12;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 36 >> 2] = f33;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 40 >> 2] = f32;
   HEAPF32[i28 + 768 + (i1 * 96 | 0) + 44 >> 2] = f31;
   HEAP16[i28 + 768 + (i1 * 96 | 0) + 16 >> 1] = 0;
   HEAP8[i28 + 768 + (i1 * 96 | 0) >> 0] = 0;
   HEAP16[i28 + 768 + (i1 * 96 | 0) + 20 >> 1] = i5;
   HEAP16[i28 + 768 + (i1 * 96 | 0) + 18 >> 1] = i6;
   HEAP16[i28 + 768 + (i1 * 96 | 0) + 22 >> 1] = i25;
   i1 = i13 + 1 | 0;
   if (i1 >>> 0 < 32) {
    HEAP32[i28 + 3840 + (i1 << 2) >> 2] = 0;
    HEAP32[i28 + 3968 + (i1 << 2) >> 2] = 65535;
    i1 = 0;
    i25 = 15;
   } else {
    i1 = 0;
    i25 = 15;
   }
  } else i25 = 15;
  if ((i25 | 0) == 15) {
   i25 = 0;
   i3 = i28 + 3968 + (i4 << 2) | 0;
   HEAP16[i28 + (i2 * 12 | 0) + 4 >> 1] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i2;
   i3 = i28 + 3840 + (i4 << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAPU16[i28 + (i2 * 12 | 0) + 2 >> 1] | 0);
   i3 = HEAP32[i23 >> 2] | 0;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break;
  i13 = HEAP32[i26 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i18, i19, i16, i10, i4, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i17 = __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i18, i19, i16, i10, i1) | 0;
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i4 + 12 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 i1 = i10 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i19 = i17;
  return i19 | 0;
 }
 i5 = i10 + 4 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i7 = i10 + 16 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 i8 = i10 + 20 | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 i9 = i10 + 24 | 0;
 i14 = i9;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i4 + 4 >> 2] = i21;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAPF32[i4 + 12 >> 2] = f3;
 HEAP32[i4 + 16 >> 2] = i12;
 HEAP32[i4 + 20 >> 2] = i15;
 i15 = i4 + 24 | 0;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i14;
 f20 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 i1 = i16 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i21 = i17 + 1 | 0;
  return i21 | 0;
 }
 i11 = i16 + 4 | 0;
 i25 = HEAP32[i11 >> 2] | 0;
 i12 = i16 + 8 | 0;
 i24 = HEAP32[i12 >> 2] | 0;
 i13 = i16 + 16 | 0;
 i23 = HEAP32[i13 >> 2] | 0;
 i14 = i16 + 20 | 0;
 i21 = HEAP32[i14 >> 2] | 0;
 i15 = i16 + 24 | 0;
 i4 = i15;
 i22 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAPF32[i10 >> 2] = f2;
 HEAP32[i5 >> 2] = i25;
 HEAP32[i6 >> 2] = i24;
 HEAPF32[i10 + 12 >> 2] = f3;
 HEAP32[i7 >> 2] = i23;
 HEAP32[i8 >> 2] = i21;
 i21 = i9;
 HEAP32[i21 >> 2] = i22;
 HEAP32[i21 + 4 >> 2] = i4;
 f20 = Math_fround(HEAPF32[i16 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 i1 = i19 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i17 + 2 | 0;
  return i25 | 0;
 }
 i4 = i19 + 4 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = i19 + 8 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 i6 = i19 + 16 | 0;
 i22 = HEAP32[i6 >> 2] | 0;
 i7 = i19 + 20 | 0;
 i25 = HEAP32[i7 >> 2] | 0;
 i8 = i19 + 24 | 0;
 i24 = i8;
 i23 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i19 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 HEAPF32[i16 >> 2] = f2;
 HEAP32[i11 >> 2] = i10;
 HEAP32[i12 >> 2] = i21;
 HEAPF32[i16 + 12 >> 2] = f3;
 HEAP32[i13 >> 2] = i22;
 HEAP32[i14 >> 2] = i25;
 i25 = i15;
 HEAP32[i25 >> 2] = i23;
 HEAP32[i25 + 4 >> 2] = i24;
 f20 = Math_fround(HEAPF32[i19 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i17 + 3 | 0;
  return i25 | 0;
 }
 i16 = HEAP32[i18 + 4 >> 2] | 0;
 i21 = HEAP32[i18 + 8 >> 2] | 0;
 i22 = HEAP32[i18 + 16 >> 2] | 0;
 i25 = HEAP32[i18 + 20 >> 2] | 0;
 i24 = i18 + 24 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 HEAPF32[i19 >> 2] = f2;
 HEAP32[i4 >> 2] = i16;
 HEAP32[i5 >> 2] = i21;
 HEAPF32[i19 + 12 >> 2] = f3;
 HEAP32[i6 >> 2] = i22;
 HEAP32[i7 >> 2] = i25;
 i25 = i8;
 HEAP32[i25 >> 2] = i23;
 HEAP32[i25 + 4 >> 2] = i24;
 i25 = i17 + 4 | 0;
 return i25 | 0;
}

function __ZN30RuntimeInitializeOnLoadManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i10, i8 + 28 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i10, i8 + 44 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i8 + 60 | 0;
 i7 = i8 + 64 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i9 >> 2] = i3;
 i11 = i10 + 16 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i3 = i8 + 76 | 0;
 i7 = i8 + 80 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 24 | 0;
 HEAP32[i9 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i2 = i8 + 92 | 0;
 i7 = i8 + 96 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 HEAP32[i9 >> 2] = i3;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i2 = i8 + 108 | 0;
 i7 = i8 + 112 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 HEAP32[i9 >> 2] = i3;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i2 = i8 + 124 | 0;
 i7 = i8 + 128 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 HEAP32[i9 >> 2] = i3;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = i8 + 140 | 0;
 i7 = i8 + 144 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i4 - i1 >> 2;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i11 >> 2] | 0;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i4 | 0)) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i13;
 return;
}

function __ZNK5physx2Gu12OBBAABBTestsILb1EEclENS_6shdfnd3aos5Vec3VES5_(i27, i1, i2) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 f24 = Math_fround(HEAPF32[i27 + 16 >> 2]);
 f23 = Math_fround(HEAPF32[i27 + 20 >> 2]);
 f22 = Math_fround(HEAPF32[i27 + 24 >> 2]);
 f25 = Math_fround(HEAPF32[i1 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f25 = Math_fround(f24 - f25);
 f26 = Math_fround(f23 - f26);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i27 + 128 >> 2]);
 f20 = Math_fround(HEAPF32[i27 + 132 >> 2]);
 f19 = Math_fround(f23 + f19);
 f20 = Math_fround(f24 + f20);
 f21 = Math_fround(f3 + Math_fround(HEAPF32[i27 + 136 >> 2]));
 if (f22 < Math_fround(-f21) | (f26 < Math_fround(-f20) | (f25 < Math_fround(-f19) | (f25 > f19 | f26 > f20 | f22 > f21)))) {
  i27 = 0;
  return i27 | 0;
 }
 f4 = Math_fround(HEAPF32[i27 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i27 + 36 >> 2]);
 f6 = Math_fround(HEAPF32[i27 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i27 + 48 >> 2]);
 f8 = Math_fround(HEAPF32[i27 + 52 >> 2]);
 f9 = Math_fround(HEAPF32[i27 + 56 >> 2]);
 f10 = Math_fround(HEAPF32[i27 + 64 >> 2]);
 f11 = Math_fround(HEAPF32[i27 + 68 >> 2]);
 f12 = Math_fround(HEAPF32[i27 + 72 >> 2]);
 f13 = Math_fround(HEAPF32[i27 + 80 >> 2]);
 f14 = Math_fround(HEAPF32[i27 + 84 >> 2]);
 f15 = Math_fround(HEAPF32[i27 + 88 >> 2]);
 f16 = Math_fround(HEAPF32[i27 + 96 >> 2]);
 f17 = Math_fround(HEAPF32[i27 + 100 >> 2]);
 f18 = Math_fround(HEAPF32[i27 + 104 >> 2]);
 f19 = Math_fround(HEAPF32[i27 + 112 >> 2]);
 f20 = Math_fround(HEAPF32[i27 + 116 >> 2]);
 f21 = Math_fround(HEAPF32[i27 + 120 >> 2]);
 f33 = Math_fround(Math_fround(Math_fround(f25 * f4) + Math_fround(f26 * f7)) + Math_fround(f22 * f10));
 f31 = Math_fround(Math_fround(Math_fround(f25 * f5) + Math_fround(f26 * f8)) + Math_fround(f22 * f11));
 f29 = Math_fround(Math_fround(Math_fround(f25 * f6) + Math_fround(f26 * f9)) + Math_fround(f22 * f12));
 f32 = Math_fround(HEAPF32[i27 >> 2]);
 f30 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f32 = Math_fround(Math_fround(f19 * f3) + Math_fround(Math_fround(f16 * f24) + Math_fround(Math_fround(f13 * f23) + f32)));
 f30 = Math_fround(Math_fround(f20 * f3) + Math_fround(Math_fround(f17 * f24) + Math_fround(Math_fround(f14 * f23) + f30)));
 f28 = Math_fround(Math_fround(f21 * f3) + Math_fround(Math_fround(f18 * f24) + Math_fround(Math_fround(f15 * f23) + Math_fround(HEAPF32[i27 + 8 >> 2]))));
 if (f29 < Math_fround(-f28) | (f31 < Math_fround(-f30) | (f33 < Math_fround(-f32) | (f33 > f32 | f31 > f30 | f29 > f28)))) {
  i27 = 0;
  return i27 | 0;
 }
 f28 = Math_fround(Math_fround(f22 * f7) - Math_fround(f26 * f10));
 f31 = Math_fround(Math_fround(f22 * f8) - Math_fround(f26 * f11));
 f29 = Math_fround(Math_fround(f22 * f9) - Math_fround(f26 * f12));
 f32 = Math_fround(HEAPF32[i27 + 144 >> 2]);
 f30 = Math_fround(HEAPF32[i27 + 148 >> 2]);
 f32 = Math_fround(Math_fround(f16 * f3) + Math_fround(Math_fround(f19 * f24) + f32));
 f30 = Math_fround(Math_fround(f17 * f3) + Math_fround(Math_fround(f20 * f24) + f30));
 f33 = Math_fround(Math_fround(f18 * f3) + Math_fround(Math_fround(f21 * f24) + Math_fround(HEAPF32[i27 + 152 >> 2])));
 i37 = f28 < Math_fround(-f32) | f28 > f32;
 i35 = f31 < Math_fround(-f30) | f31 > f30;
 i1 = f29 < Math_fround(-f33) | f29 > f33;
 f33 = Math_fround(Math_fround(f25 * f10) - Math_fround(f22 * f4));
 f29 = Math_fround(Math_fround(f25 * f11) - Math_fround(f22 * f5));
 f30 = Math_fround(Math_fround(f25 * f12) - Math_fround(f22 * f6));
 f31 = Math_fround(HEAPF32[i27 + 160 >> 2]);
 f32 = Math_fround(HEAPF32[i27 + 164 >> 2]);
 f31 = Math_fround(Math_fround(f13 * f3) + Math_fround(Math_fround(f19 * f23) + f31));
 f32 = Math_fround(Math_fround(f14 * f3) + Math_fround(Math_fround(f20 * f23) + f32));
 f28 = Math_fround(Math_fround(f15 * f3) + Math_fround(Math_fround(f21 * f23) + Math_fround(HEAPF32[i27 + 168 >> 2])));
 i36 = f33 < Math_fround(-f31) | f33 > f31;
 i34 = f29 < Math_fround(-f32) | f29 > f32;
 i2 = f30 < Math_fround(-f28) | f30 > f28;
 f28 = Math_fround(Math_fround(f26 * f4) - Math_fround(f25 * f7));
 f30 = Math_fround(Math_fround(f26 * f5) - Math_fround(f25 * f8));
 f32 = Math_fround(Math_fround(f26 * f6) - Math_fround(f25 * f9));
 f29 = Math_fround(HEAPF32[i27 + 176 >> 2]);
 f31 = Math_fround(HEAPF32[i27 + 180 >> 2]);
 f29 = Math_fround(Math_fround(f13 * f24) + Math_fround(Math_fround(f16 * f23) + f29));
 f31 = Math_fround(Math_fround(f14 * f24) + Math_fround(Math_fround(f17 * f23) + f31));
 f33 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f18 * f23) + Math_fround(HEAPF32[i27 + 184 >> 2])));
 i27 = (i37 | (i36 | (f28 < Math_fround(-f29) | f28 > f29)) | (i35 | (i34 | (f30 < Math_fround(-f31) | f30 > f31))) | (i1 | (i2 | (f32 < Math_fround(-f33) | f32 > f33)))) & 1 ^ 1;
 return i27 | 0;
}

function __GLOBAL__sub_I_runtime_dynamics2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1452356 >> 2] = 0;
 i3 = gb + 63648 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1452356 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = gb + 1452356 + 4 | 0;
 i2 = gb + 661598 | 0;
 i3 = i1 + 9 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[gb + 1452356 + 13 >> 0] = 0;
 HEAP32[gb + 1452356 + 20 >> 2] = 9;
 __ZN14CompletionTaskC2Ev(gb + 1452388 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452416 | 0, gb + 661608 | 0, 3, 0);
 HEAP32[gb + 1452428 >> 2] = gb + 87336 + 8;
 HEAP32[gb + 1452432 >> 2] = gb + 87356 + 8;
 HEAP32[gb + 1452436 >> 2] = gb + 87380 + 8;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452440 | 0, gb + 661637 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452452 | 0, gb + 661654 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452464 | 0, gb + 661690 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452476 | 0, gb + 661711 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452488 | 0, gb + 661733 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452500 | 0, gb + 661753 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452512 | 0, gb + 661776 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452524 | 0, gb + 661795 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452536 | 0, gb + 661812 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452548 | 0, gb + 661844 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452560 | 0, gb + 661870 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452572 | 0, gb + 661891 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452584 | 0, gb + 661912 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452596 | 0, gb + 661935 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452608 | 0, gb + 661951 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452620 | 0, gb + 661970 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452632 | 0, gb + 661991 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452644 | 0, gb + 662013 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452656 | 0, gb + 662036 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452668 | 0, gb + 662055 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452680 | 0, gb + 662075 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452692 | 0, gb + 662098 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452704 | 0, gb + 662115 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452716 | 0, gb + 662131 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452728 | 0, gb + 662150 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452740 | 0, gb + 662169 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452752 | 0, gb + 662199 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452764 | 0, gb + 662230 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452776 | 0, gb + 662257 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452788 | 0, gb + 662281 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452800 | 0, gb + 662309 | 0, 3, 0);
 HEAPF32[gb + 1452812 >> 2] = Math_fround(922337149.0e10);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452816 | 0, gb + 662333 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452828 | 0, gb + 662353 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452840 | 0, gb + 662376 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452852 | 0, gb + 662399 | 0, 3, 2);
 return;
}

function __ZN18DeferredRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDPS3_iRK8Vector4fRK14LightingLayersR10MinMaxAABBb(i4, i15, i16, i1, i17, i2, i18, i19, i3, i20) {
 i4 = i4 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 4 | 0;
 i1 = i14;
 i12 = i4 + 8 | 0;
 if ((HEAP16[gb + 1114612 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114612 | 0, i13);
  i7 = gb + 1114612 | 0;
 } else i7 = 0;
 i8 = HEAP32[gb + 1114612 >> 2] | 0;
 i9 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 648 >> 2] | 0, i9 | 0, i8 | 0);
 i8 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 5;
 i9 = __Z18GetQualitySettingsv() | 0;
 i9 = HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0;
 i10 = __Z18GetQualitySettingsv() | 0;
 i10 = HEAP32[(HEAP32[i10 + 28 >> 2] | 0) + ((HEAP32[i10 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] | 0;
 i11 = HEAP32[gb + 1166248 >> 2] | 0;
 __Z15InitLightMeshesv();
 mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 100 >> 2] | 0, i16 | 0) | 0;
 mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 104 >> 2] | 0, i16 | 0) | 0;
 i1 = i17 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i6 = i11 + 36 | 0;
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i6, gb + 1114756 | 0, i2);
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i6, gb + 1114764 | 0, HEAP32[i1 >> 2] | 0);
 }
 i4 = __Z12GetGfxDevicev() | 0;
 i6 = __Z12GetGfxDevicev() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0, i6 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 148 >> 2] | 0, i4 | 0, 0);
 i6 = HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP8[i13 + 1 >> 0] = -1;
 HEAP8[i13 + 2 >> 0] = -1;
 HEAP8[i13 + 3 >> 0] = 0;
 HEAP8[i13 + 4 >> 0] = 8;
 HEAP8[i13 + 5 >> 0] = 0;
 HEAP8[i13 + 6 >> 0] = 0;
 HEAP8[i13 + 7 >> 0] = 0;
 HEAP8[i13 + 8 >> 0] = 8;
 HEAP8[i13 + 9 >> 0] = 0;
 HEAP8[i13 + 10 >> 0] = 0;
 HEAP8[i13 + 11 >> 0] = 0;
 i6 = mftCall_iii(i6 | 0, i4 | 0, i13 | 0) | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i13, __Z12GetGfxDevicev() | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, gb + 1162292 | 0);
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i2 + 1136 | 0, 6, i11, HEAP32[i3 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i2 + 4 >> 2] | 0);
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i3 + 1136 | 0, 6, i11, HEAP32[i2 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i3 + 4 >> 2] | 0);
 if ((HEAP32[i15 >> 2] | 0) > 0) {
  i2 = i15 + 4 | 0;
  i3 = i17 + 12 | 0;
  i1 = 0;
  do {
   __ZL19RenderLightDeferredRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionP13RenderTextureS9_iiPK18DeviceStencilStateRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(HEAP32[i12 >> 2] | 0, (HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) | 0, i9, i10, HEAP32[i3 >> 2] | 0, i16, i6, i13, i18, i19, i20, i11);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
 }
 i1 = i15 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) __ZL19RenderLightDeferredRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionP13RenderTextureS9_iiPK18DeviceStencilStateRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext(HEAP32[i12 >> 2] | 0, i1, i9, i10, HEAP32[i17 + 12 >> 2] | 0, i16, i6, i13, i18, i19, i20, i11);
 __Z20SetNoShadowsKeywordsR17ShaderPassContext(i11);
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 72 >> 2] | 0, i4 | 0, i6 | 0, 0);
 i20 = HEAP32[i12 >> 2] | 0;
 i19 = HEAP32[i20 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i19 + 1136 | 0, 7, i11, HEAP32[i20 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i19 + 4 >> 2] | 0);
 i19 = HEAP32[i12 >> 2] | 0;
 i20 = HEAP32[i19 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i20 + 1136 | 0, 7, i11, HEAP32[i19 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i20 + 4 >> 2] | 0);
 __ZN22DeviceMVPMatricesStateD2Ev(i13);
 i20 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 96 >> 2] | 0, i20 | 0, i5 | 0);
 HEAP32[gb + 1163232 >> 2] = i8;
 i20 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 652 >> 2] | 0, i20 | 0);
 if (!i7) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i14;
 return;
}

function __ZN8GUIStyle14GetBuiltinFontEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i5 = i7;
 i1 = HEAP32[gb + 1468164 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 9;
  }
  if ((i6 | 0) == 7) i6 = 9;
  if ((i6 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468164 >> 2] | 0) | 0)) break;
  i1 = HEAP32[gb + 1468164 >> 2] | 0;
  if (!i1) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 18;
   }
  }
  if ((i6 | 0) == 16) i6 = 18;
  if ((i6 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468164 >> 2] | 0) | 0;
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1017543 | 0, 9);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i4) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[gb + 1468164 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = HEAP32[gb + 1468164 >> 2] | 0;
 do if (!i1) i6 = 31; else {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 28; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 28; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468164 >> 2] | 0) | 0)) i6 = 31;
 } while (0);
 if ((i6 | 0) == 31) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017553 | 0, 0, gb + 1017598 | 0, 321, 4, 0, 0, 0);
 i1 = HEAP32[gb + 1468164 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 38; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 38; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 40;
  }
 }
 if ((i6 | 0) == 38) i6 = 40;
 if ((i6 | 0) == 40) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468164 >> 2] | 0) | 0;
 i8 = i1;
 STACKTOP = i7;
 return i8 | 0;
}

function __Z36IsStreamedBinaryCompatibleAndIndicesRK16TypeTreeIteratorS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i13 = i15;
 i3 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i8 + (i7 * 24 | 0) + 12 >> 2] | 0) != (HEAP32[i10 + (i9 * 24 | 0) + 12 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP16[i8 + (i7 * 24 | 0) >> 1] | 0) != (HEAP16[i10 + (i9 * 24 | 0) >> 1] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP32[i8 + (i7 * 24 | 0) + 16 >> 2] | 0) != (HEAP32[i10 + (i9 * 24 | 0) + 16 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = HEAP32[i8 + (i7 * 24 | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[gb + 36932 >> 2] | 0;
 i1 = ((i1 | 0) < 0 ? i6 : i2) + (i1 & 2147483647) | 0;
 i4 = HEAP32[i10 + (i9 * 24 | 0) + 8 >> 2] | 0;
 i5 = HEAP32[i11 + 20 >> 2] | 0;
 i4 = ((i4 | 0) < 0 ? i6 : i5) + (i4 & 2147483647) | 0;
 do if (!i4) i14 = 6; else if (!i1) {
  i1 = 0;
  i14 = 6;
 } else {
  i16 = HEAP32[gb + 36936 >> 2] | 0;
  if (i16 >>> 0 > i4 >>> 0 & ((i6 >>> 0 > i4 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i16 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i4 | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  } else {
   if (!(_strcmp(i4, i1) | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 if ((i14 | 0) == 6) if ((i1 | 0) != (i4 | 0)) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 i1 = HEAP32[i8 + (i7 * 24 | 0) + 4 >> 2] | 0;
 i1 = ((i1 | 0) < 0 ? i6 : i2) + (i1 & 2147483647) | 0;
 i2 = HEAP32[i10 + (i9 * 24 | 0) + 4 >> 2] | 0;
 i2 = ((i2 | 0) < 0 ? i6 : i5) + (i2 & 2147483647) | 0;
 do if (!i2) i14 = 12; else if (!i1) {
  i1 = 0;
  i14 = 12;
 } else {
  i16 = HEAP32[gb + 36936 >> 2] | 0;
  if (i16 >>> 0 > i2 >>> 0 & ((i6 >>> 0 > i2 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i16 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 if ((i14 | 0) == 12) if ((i1 | 0) != (i2 | 0)) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 if ((HEAP32[i10 + (i9 * 24 | 0) + 20 >> 2] ^ HEAP32[i8 + (i7 * 24 | 0) + 20 >> 2]) & 16384 | 0) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 i1 = i8 + (i7 * 24 | 0) | 0;
 if ((i1 + 24 | 0) >>> 0 < (i8 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i1 + 26 >> 0] | 0) == ((HEAPU8[i8 + (i7 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i4 = i7 + 1 | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i4;
 } else i14 = 20; else i14 = 20;
 if ((i14 | 0) == 20) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i4 = 0;
  i3 = 0;
 }
 i1 = i10 + (i9 * 24 | 0) | 0;
 if ((i1 + 24 | 0) >>> 0 < (i10 + ((HEAP32[i11 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i1 + 26 >> 0] | 0) == ((HEAPU8[i10 + (i9 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i2 = i9 + 1 | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i2;
  i1 = i11;
 } else i14 = 24; else i14 = 24;
 if ((i14 | 0) == 24) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
 }
 i10 = i12 + 4 | 0;
 i9 = i13 + 4 | 0;
 i8 = i1;
 while (1) {
  i1 = (i8 | 0) == 0;
  if (!i3) {
   if (i1) {
    i14 = 43;
    break;
   }
   if ((i3 | 0) == 0 | (i8 | 0) == 0) {
    i14 = 42;
    break;
   }
  } else if (i1) {
   i14 = 42;
   break;
  }
  if (!(__Z36IsStreamedBinaryCompatibleAndIndicesRK16TypeTreeIteratorS1_(i12, i13) | 0)) {
   i14 = 42;
   break;
  }
  i16 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP8[i16 + (i4 * 24 | 0) + 2 >> 0] | 0;
  i6 = i16 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0;
  i7 = i16;
  i4 = i16 + (i4 * 24 | 0) | 0;
  while (1) {
   i1 = i4;
   i4 = i4 + 24 | 0;
   if (i4 >>> 0 >= i6 >>> 0) {
    i3 = 0;
    i4 = 0;
    break;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
   if ((i1 & 255) <= (i5 & 255)) {
    i14 = 34;
    break;
   }
  }
  if ((i14 | 0) == 34) {
   i14 = 0;
   if (i1 << 24 >> 24 == i5 << 24 >> 24) i4 = (i4 - i7 | 0) / 24 | 0; else {
    i3 = 0;
    i4 = 0;
   }
  }
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i4;
  i16 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP8[i16 + (i2 * 24 | 0) + 2 >> 0] | 0;
  i6 = i16 + ((HEAP32[i8 + 12 >> 2] | 0) * 24 | 0) | 0;
  i7 = i16;
  i2 = i16 + (i2 * 24 | 0) | 0;
  while (1) {
   i1 = i2;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i6 >>> 0) {
    i1 = 0;
    i2 = 0;
    break;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
   if ((i1 & 255) <= (i5 & 255)) {
    i14 = 39;
    break;
   }
  }
  if ((i14 | 0) == 39) {
   i14 = 0;
   if (i1 << 24 >> 24 == i5 << 24 >> 24) {
    i1 = i8;
    i2 = (i2 - i7 | 0) / 24 | 0;
   } else {
    i1 = 0;
    i2 = 0;
   }
  }
  HEAP32[i13 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i8 = i1;
 }
 if ((i14 | 0) == 42) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 } else if ((i14 | 0) == 43) {
  i16 = 1;
  STACKTOP = i15;
  return i16 | 0;
 }
 return 0;
}

function __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE(i39, i2, i1) {
 i39 = i39 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0, f52 = f0, f53 = f0, f54 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i40 + 56 | 0;
 i31 = i40 + 32 | 0;
 i32 = i40;
 HEAP32[i39 >> 2] = 2122317823;
 i35 = i39 + 4 | 0;
 HEAP32[i35 >> 2] = 2122317823;
 i36 = i39 + 8 | 0;
 HEAP32[i36 >> 2] = 2122317823;
 HEAP32[i39 + 12 >> 2] = -25165825;
 i37 = i39 + 16 | 0;
 HEAP32[i37 >> 2] = -25165825;
 i38 = i39 + 20 | 0;
 HEAP32[i38 >> 2] = -25165825;
 i34 = i2 + 4 | 0;
 i9 = HEAP16[i34 >> 1] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i33 | 0, i1 | 0);
 if ((HEAP16[i34 >> 1] | 0) != 1) i2 = HEAP32[i2 >> 2] | 0;
 if (!(i9 << 16 >> 16)) {
  STACKTOP = i40;
  return;
 }
 i14 = i33 + 12 | 0;
 i15 = i33 + 4 | 0;
 i16 = i33 + 8 | 0;
 i17 = i33 + 16 | 0;
 i18 = i33 + 20 | 0;
 i19 = i33 + 24 | 0;
 i20 = i32 + 4 | 0;
 i21 = i32 + 8 | 0;
 i22 = i32 + 12 | 0;
 i23 = i32 + 16 | 0;
 i24 = i32 + 20 | 0;
 i25 = i32 + 24 | 0;
 i26 = i31 + 4 | 0;
 i27 = i31 + 8 | 0;
 i34 = i39 + 12 | 0;
 i28 = i31 + 12 | 0;
 i29 = i31 + 16 | 0;
 i30 = i31 + 20 | 0;
 i12 = i9 & 65535;
 f8 = Math_fround(8507058669999999534545717.0e13);
 f7 = Math_fround(8507058669999999534545717.0e13);
 f6 = Math_fround(8507058669999999534545717.0e13);
 f5 = Math_fround(-8507058669999999534545717.0e13);
 f4 = Math_fround(-8507058669999999534545717.0e13);
 f3 = Math_fround(-8507058669999999534545717.0e13);
 i13 = 0;
 do {
  i9 = HEAP32[i2 + (i13 << 2) >> 2] | 0;
  i10 = HEAP32[i9 + 36 >> 2] | 0;
  if (!(i10 & 1)) {
   i1 = i9 + 116 | 0;
   i11 = HEAP32[i9 + 40 >> 2] | 0;
  } else {
   i11 = HEAP32[i9 + 40 >> 2] | 0;
   i1 = i11 + 56 | 0;
  }
  i11 = (i10 & 4 | 0) == 0 ? i9 + 80 | 0 : i11;
  f51 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) * Math_fround(2.0));
  f49 = Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) * Math_fround(2.0));
  f44 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) * Math_fround(2.0));
  f54 = Math_fround(HEAPF32[i14 >> 2]);
  f53 = Math_fround(Math_fround(f54 * f54) + Math_fround(-.5));
  f52 = Math_fround(HEAPF32[i33 >> 2]);
  f41 = Math_fround(f51 * f52);
  f50 = Math_fround(HEAPF32[i15 >> 2]);
  f41 = Math_fround(f41 + Math_fround(f49 * f50));
  f48 = Math_fround(HEAPF32[i16 >> 2]);
  f41 = Math_fround(f41 + Math_fround(f44 * f48));
  f43 = Math_fround(Math_fround(f52 * f41) + Math_fround(Math_fround(f51 * f53) + Math_fround(f54 * Math_fround(Math_fround(f44 * f50) - Math_fround(f49 * f48)))));
  f42 = Math_fround(Math_fround(f50 * f41) + Math_fround(Math_fround(f49 * f53) + Math_fround(f54 * Math_fround(Math_fround(f51 * f48) - Math_fround(f44 * f52)))));
  f41 = Math_fround(Math_fround(Math_fround(f44 * f53) + Math_fround(f54 * Math_fround(Math_fround(f49 * f52) - Math_fround(f51 * f50)))) + Math_fround(f48 * f41));
  f43 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f43);
  f42 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f42);
  f41 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f41);
  f51 = Math_fround(HEAPF32[i11 >> 2]);
  f49 = Math_fround(f54 * f51);
  f53 = Math_fround(HEAPF32[i11 + 12 >> 2]);
  f49 = Math_fround(f49 + Math_fround(f52 * f53));
  f44 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f49 = Math_fround(f49 + Math_fround(f50 * f44));
  f47 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f46 = Math_fround(Math_fround(Math_fround(f48 * f51) + Math_fround(Math_fround(f50 * f53) + Math_fround(f54 * f47))) - Math_fround(f52 * f44));
  f45 = Math_fround(Math_fround(Math_fround(f52 * f47) + Math_fround(Math_fround(f48 * f53) + Math_fround(f54 * f44))) - Math_fround(f50 * f51));
  f44 = Math_fround(Math_fround(Math_fround(Math_fround(f54 * f53) - Math_fround(f52 * f51)) - Math_fround(f50 * f47)) - Math_fround(f48 * f44));
  HEAPF32[i32 >> 2] = Math_fround(f49 - Math_fround(f48 * f47));
  HEAPF32[i20 >> 2] = f46;
  HEAPF32[i21 >> 2] = f45;
  HEAPF32[i22 >> 2] = f44;
  HEAPF32[i23 >> 2] = f43;
  HEAPF32[i24 >> 2] = f42;
  HEAPF32[i25 >> 2] = f41;
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1, i31, i32, Math_fround(0.0), 0);
  f41 = Math_fround(HEAPF32[i31 >> 2]);
  f8 = f8 < f41 ? f8 : f41;
  f41 = Math_fround(HEAPF32[i26 >> 2]);
  f7 = f7 < f41 ? f7 : f41;
  f41 = Math_fround(HEAPF32[i27 >> 2]);
  f6 = f6 < f41 ? f6 : f41;
  f41 = Math_fround(HEAPF32[i28 >> 2]);
  f5 = f5 > f41 ? f5 : f41;
  f41 = Math_fround(HEAPF32[i29 >> 2]);
  f4 = f4 > f41 ? f4 : f41;
  f41 = Math_fround(HEAPF32[i30 >> 2]);
  f3 = f3 > f41 ? f3 : f41;
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != (i12 | 0));
 HEAPF32[i39 >> 2] = f8;
 HEAPF32[i35 >> 2] = f7;
 HEAPF32[i36 >> 2] = f6;
 HEAPF32[i34 >> 2] = f5;
 HEAPF32[i37 >> 2] = f4;
 HEAPF32[i38 >> 2] = f3;
 STACKTOP = i40;
 return;
}

function __ZN12GUIClipState20CalculateMouseValuesER10InputEvent(i19, i20) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i21 = 0, f22 = f0;
 i16 = i19 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 if ((HEAP32[i19 >> 2] | 0) == (i3 | 0)) return;
 i5 = i19 + 140 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i19 + 144 | 0;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i19 + 88 | 0;
 f1 = Math_fround(f2 * Math_fround(HEAPF32[i7 >> 2]));
 i9 = i19 + 104 | 0;
 f1 = Math_fround(f1 + Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2])));
 i11 = i19 + 120 | 0;
 f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(0.0)));
 i13 = i19 + 136 | 0;
 f1 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f1);
 i21 = f1 < Math_fround(0.0);
 f18 = Math_fround(-f1);
 if ((i21 ? f18 : f1) > Math_fround(1.00000001e-07)) {
  f17 = Math_fround(f2 * Math_fround(HEAPF32[i19 + 80 >> 2]));
  f17 = Math_fround(f17 + Math_fround(f4 * Math_fround(HEAPF32[i19 + 96 >> 2])));
  f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i19 + 112 >> 2]) * Math_fround(0.0)));
  f17 = Math_fround(Math_fround(HEAPF32[i19 + 128 >> 2]) + f17);
  f2 = Math_fround(f2 * Math_fround(HEAPF32[i19 + 76 >> 2]));
  f2 = Math_fround(f2 + Math_fround(f4 * Math_fround(HEAPF32[i19 + 92 >> 2])));
  f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i19 + 108 >> 2]) * Math_fround(0.0)));
  f18 = Math_fround(Math_fround(1.0) / f1);
  f1 = Math_fround(f18 * f17);
  f2 = Math_fround(f18 * Math_fround(Math_fround(HEAPF32[i19 + 124 >> 2]) + f2));
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f4 = Math_fround(f2 - Math_fround(HEAPF32[i3 + -24 >> 2]));
 f17 = Math_fround(f1 - Math_fround(HEAPF32[i3 + -20 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + -56 >> 2]);
 f18 = Math_fround(f4 - f18);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i3 + -52 >> 2]));
 HEAPF32[i20 + 4 >> 2] = f18;
 HEAPF32[i20 + 8 >> 2] = f17;
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(f4 * f15);
 f14 = Math_fround(HEAPF32[i9 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f2 * f14));
 f12 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(0.0));
 f1 = Math_fround(f1 + f12);
 f10 = Math_fround(HEAPF32[i13 >> 2]);
 f1 = Math_fround(f10 + f1);
 i21 = f1 < Math_fround(0.0);
 f8 = Math_fround(-f1);
 if ((i21 ? f8 : f1) > Math_fround(1.00000001e-07)) {
  f22 = Math_fround(f4 * Math_fround(HEAPF32[i19 + 80 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f2 * Math_fround(HEAPF32[i19 + 96 >> 2])));
  f22 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i19 + 112 >> 2]) * Math_fround(0.0)));
  f22 = Math_fround(Math_fround(HEAPF32[i19 + 128 >> 2]) + f22);
  f8 = Math_fround(f4 * Math_fround(HEAPF32[i19 + 76 >> 2]));
  f8 = Math_fround(f8 + Math_fround(f2 * Math_fround(HEAPF32[i19 + 92 >> 2])));
  f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i19 + 108 >> 2]) * Math_fround(0.0)));
  f1 = Math_fround(Math_fround(1.0) / f1);
  f2 = Math_fround(f1 * f22);
  f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i19 + 124 >> 2]) + f8));
 } else {
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 i5 = HEAP32[i16 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i5 + -56 >> 2]);
 if (!(f8 <= f1)) i3 = 0; else if (Math_fround(f8 + Math_fround(HEAPF32[i5 + -48 >> 2])) > f1) {
  f1 = Math_fround(HEAPF32[i5 + -52 >> 2]);
  if (!(f1 <= f2)) i3 = 0; else i3 = Math_fround(f1 + Math_fround(HEAPF32[i5 + -44 >> 2])) > f2;
 } else i3 = 0;
 HEAP32[i19 + 172 >> 2] = i3 << 31 >> 31;
 if ((HEAP32[i20 >> 2] | 0) == 6) return;
 if ((HEAP32[i19 >> 2] | 0) == (i5 | 0)) {
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f2 = Math_fround(HEAPF32[i19 + 148 >> 2]);
  f4 = Math_fround(HEAPF32[i19 + 152 >> 2]);
  f1 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f2 * f15) + Math_fround(f4 * f14)) + f12));
  i21 = f1 < Math_fround(0.0);
  f22 = Math_fround(-f1);
  if ((i21 ? f22 : f1) > Math_fround(1.00000001e-07)) {
   f15 = Math_fround(f2 * Math_fround(HEAPF32[i19 + 80 >> 2]));
   f15 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i19 + 96 >> 2])));
   f15 = Math_fround(f15 + Math_fround(Math_fround(HEAPF32[i19 + 112 >> 2]) * Math_fround(0.0)));
   f15 = Math_fround(Math_fround(HEAPF32[i19 + 128 >> 2]) + f15);
   f22 = Math_fround(f2 * Math_fround(HEAPF32[i19 + 76 >> 2]));
   f22 = Math_fround(f22 + Math_fround(f4 * Math_fround(HEAPF32[i19 + 92 >> 2])));
   f22 = Math_fround(f22 + Math_fround(Math_fround(HEAPF32[i19 + 108 >> 2]) * Math_fround(0.0)));
   f1 = Math_fround(Math_fround(1.0) / f1);
   f2 = Math_fround(f1 * f15);
   f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i19 + 124 >> 2]) + f22));
  } else {
   f2 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
  f22 = Math_fround(f1 - Math_fround(HEAPF32[i5 + -24 >> 2]));
  f1 = Math_fround(f2 - Math_fround(HEAPF32[i5 + -20 >> 2]));
  f2 = Math_fround(f22 - f8);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i5 + -52 >> 2]));
 }
 f22 = Math_fround(f17 - f1);
 HEAPF32[i20 + 12 >> 2] = Math_fround(f18 - f2);
 HEAPF32[i20 + 16 >> 2] = f22;
 return;
}

function __ZN5physx25PxAggregateRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i12, i1, i13, i5, i4, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i8 = i11;
 i7 = i11 + 36 | 0;
 i2 = i11 + 32 | 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 674627 | 0, i2 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) _strtoul(i1, i7, 10) | 0;
 }
 if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 674637 | 0, i2 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = _strtoul(i1, i7, 10) | 0;
  i3 = i1;
 } else i3 = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 674649 | 0, i7 | 0) | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) {
   i1 = 1;
   i2 = 0;
  } else if (!(HEAP8[i2 >> 0] | 0)) {
   i1 = 1;
   i2 = 0;
  } else {
   i1 = 1;
   i2 = (_strcasecmp(i2, gb + 1087447 | 0) | 0) == 0;
  }
 } else {
  i1 = 0;
  i2 = 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 i6 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i3 | 0, i2 | 0) | 0;
 mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 __ZN5physx24PxAggregateGeneratedInfoC2Ev(i7);
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 44 >> 2] | 0, i13 | 0);
 if (mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, gb + 756565 | 0) | 0) {
  i1 = i1 & 1;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 44 >> 2] | 0, i13 | 0);
  if (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0) | 0) do {
   i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0) | 0;
   if (!(_strcasecmp(i2, gb + 674616 | 0) | 0)) {
    i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
    HEAP32[i7 >> 2] = i2;
    if (!i2) {
     i2 = 1;
     i4 = 0;
    } else if (!(HEAP8[i2 >> 0] | 0)) {
     i2 = 1;
     i4 = 0;
    } else {
     i2 = _strtoull(i2, i7, 10) | 0;
     i3 = getTempRet0() | 0;
     if ((i2 | 0) == 0 & (i3 | 0) == 0) {
      i2 = 1;
      i4 = 0;
     } else {
      i4 = mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i2 | 0, i3 | 0) | 0;
      if (!i4) {
       i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
       HEAP32[i8 >> 2] = gb + 747111;
       i14 = i8 + 8 | 0;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i14 + 4 >> 2] = i3;
       __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
      }
      i2 = (i4 | 0) != 0;
     }
    }
    i1 = i2 & 1 & (i1 & 255) & 255;
    if (i4) {
     i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0;
     if (i2 | 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i4 | 0, 1);
     mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0, i4 | 0) | 0;
    }
   } else if (!(_strcasecmp(i2, gb + 674598 | 0) | 0)) {
    i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
    HEAP32[i7 >> 2] = i2;
    if (!i2) {
     i2 = 1;
     i4 = 0;
    } else if (!(HEAP8[i2 >> 0] | 0)) {
     i2 = 1;
     i4 = 0;
    } else {
     i2 = _strtoull(i2, i7, 10) | 0;
     i3 = getTempRet0() | 0;
     if ((i2 | 0) == 0 & (i3 | 0) == 0) {
      i2 = 1;
      i4 = 0;
     } else {
      i4 = mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i2 | 0, i3 | 0) | 0;
      if (!i4) {
       i14 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
       HEAP32[i9 >> 2] = gb + 765118;
       i5 = i9 + 8 | 0;
       HEAP32[i5 >> 2] = i2;
       HEAP32[i5 + 4 >> 2] = i3;
       __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i14, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i9);
      }
      i2 = (i4 | 0) != 0;
     }
    }
    i1 = i2 & 1 & (i1 & 255) & 255;
    if (i4) {
     i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
     if (i2 | 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, i4 | 0, 1);
     mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0, i4 | 0) | 0;
    }
   }
  } while (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0);
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0);
  mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 40 >> 2] | 0, i13 | 0) | 0;
  i1 = (i1 & 1) != 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0);
 if (i1) {
  HEAP32[i12 + 4 >> 2] = i6;
  i14 = gb + 747736 | 0;
  i10 = i6;
  i13 = 0;
  HEAP32[i12 >> 2] = i14;
  i14 = i12 + 8 | 0;
  i12 = i14;
  HEAP32[i12 >> 2] = i10;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = i13;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i12 + 4 >> 2] = 0;
  i14 = gb + 1576256 | 0;
  i10 = 0;
  i13 = 0;
  HEAP32[i12 >> 2] = i14;
  i14 = i12 + 8 | 0;
  i12 = i14;
  HEAP32[i12 >> 2] = i10;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = i13;
  STACKTOP = i11;
  return;
 }
}

function __Z14PlaneCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersif(i43, i1, i4, i44, i3, i5, f2) {
 i43 = i43 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i44 = i44 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0;
 i42 = HEAP32[i44 + 12 >> 2] | 0;
 if (i42 >>> 0 <= i5 >>> 0) return;
 i32 = i44 + 20 | 0;
 i33 = i44 + 40 | 0;
 i34 = i44 + 60 | 0;
 i35 = i44 + 80 | 0;
 i36 = i44 + 100 | 0;
 i37 = i44 + 120 | 0;
 i38 = i44 + 140 | 0;
 i39 = i44 + 160 | 0;
 i40 = i44 + 871 | 0;
 i41 = i44 + 420 | 0;
 i30 = i3 + 20 | 0;
 i31 = i4 + 448 | 0;
 i24 = i4 + 444 | 0;
 i25 = i43 + 12 | 0;
 i26 = i43 + 16 | 0;
 i27 = i43 + 4 | 0;
 i28 = i44 + 440 | 0;
 i29 = i44 + 460 | 0;
 do {
  i18 = HEAP32[(HEAP32[i44 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i19 = HEAP32[(HEAP32[i32 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i20 = HEAP32[(HEAP32[i33 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  f16 = Math_fround(HEAPF32[(HEAP32[i34 >> 2] | 0) + (i5 << 2) >> 2]);
  f17 = Math_fround(HEAPF32[(HEAP32[i35 >> 2] | 0) + (i5 << 2) >> 2]);
  f23 = Math_fround(HEAPF32[(HEAP32[i36 >> 2] | 0) + (i5 << 2) >> 2]);
  f21 = Math_fround(HEAPF32[(HEAP32[i37 >> 2] | 0) + (i5 << 2) >> 2]);
  f22 = Math_fround(HEAPF32[(HEAP32[i38 >> 2] | 0) + (i5 << 2) >> 2]);
  f21 = Math_fround(f16 + f21);
  f22 = Math_fround(f17 + f22);
  f23 = Math_fround(f23 + Math_fround(HEAPF32[(HEAP32[i39 >> 2] | 0) + (i5 << 2) >> 2]));
  i1 = (HEAP32[i41 >> 2] | 0) + (i5 << 2) | 0;
  if (HEAP8[i40 >> 0] | 0) {
   i14 = (HEAP32[i28 >> 2] | 0) + (i5 << 2) | 0;
   f17 = Math_fround(HEAPF32[i1 >> 2]);
   i13 = f17 < Math_fround(HEAPF32[i14 >> 2]);
   i1 = i13 ? i14 : i1;
   i14 = (HEAP32[i29 >> 2] | 0) + (i5 << 2) | 0;
   f17 = Math_fround(HEAPF32[i1 >> 2]);
   i13 = f17 < Math_fround(HEAPF32[i14 >> 2]);
   i1 = i13 ? i14 : i1;
  }
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i30 >> 2]));
  i3 = HEAP32[i31 >> 2] | 0;
  L9 : do if (i3 | 0) {
   i14 = HEAP32[i24 >> 2] | 0;
   f15 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f16 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f17 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = 0;
   while (1) {
    i13 = i14 + (i1 * 20 | 0) | 0;
    f2 = Math_fround(HEAPF32[i13 >> 2]);
    f11 = Math_fround(f15 * f2);
    f9 = Math_fround(HEAPF32[i14 + (i1 * 20 | 0) + 4 >> 2]);
    f11 = Math_fround(f11 + Math_fround(f16 * f9));
    f10 = Math_fround(HEAPF32[i14 + (i1 * 20 | 0) + 8 >> 2]);
    f11 = Math_fround(f11 + Math_fround(f17 * f10));
    f11 = Math_fround(Math_fround(HEAPF32[i14 + (i1 * 20 | 0) + 12 >> 2]) + f11);
    if (!(f11 > f12)) {
     f2 = Math_fround(Math_fround(Math_fround(f21 * f2) + Math_fround(f22 * f9)) + Math_fround(f23 * f10));
     if (!(f2 == Math_fround(0.0) | f2 == Math_fround(-0.0))) break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i3 >>> 0) break L9;
   }
   f2 = Math_fround(Math_fround(-Math_fround(f11 - f12)) / f2);
   i4 = HEAP32[i25 >> 2] | 0;
   i6 = i4 + 1 | 0;
   i7 = HEAP32[i26 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i6 >>> 0 > i8 >>> 0) {
    i3 = i7 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i8 >>> 0 < i3 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i26 >> 2] = i3;
     HEAP32[i43 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i43 >> 2] | 0, i3 * 60 | 0, 4, i27, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 60 | 0, 4, i27, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i43 >> 2] | 0, (HEAP32[i25 >> 2] | 0) * 60 | 0) | 0;
     HEAP32[i26 >> 2] = i3;
     HEAP32[i43 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i25 >> 2] = i6;
   i8 = HEAP32[i43 >> 2] | 0;
   HEAP32[i8 + (i4 * 60 | 0) + 4 >> 2] = i18;
   HEAP32[i8 + (i4 * 60 | 0) + 8 >> 2] = i19;
   HEAP32[i8 + (i4 * 60 | 0) + 12 >> 2] = i20;
   HEAPF32[i8 + (i4 * 60 | 0) + 16 >> 2] = f21;
   HEAPF32[i8 + (i4 * 60 | 0) + 20 >> 2] = f22;
   HEAPF32[i8 + (i4 * 60 | 0) + 24 >> 2] = f23;
   f22 = Math_fround(f16 + Math_fround(f22 * f2));
   f23 = Math_fround(f17 + Math_fround(f23 * f2));
   HEAPF32[i8 + (i4 * 60 | 0) + 40 >> 2] = Math_fround(f15 + Math_fround(f21 * f2));
   HEAPF32[i8 + (i4 * 60 | 0) + 44 >> 2] = f22;
   HEAPF32[i8 + (i4 * 60 | 0) + 48 >> 2] = f23;
   HEAP32[i8 + (i4 * 60 | 0) >> 2] = i5;
   i20 = i8 + (i4 * 60 | 0) + 28 | 0;
   HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i20 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   i20 = HEAP32[i14 + (i1 * 20 | 0) + 16 >> 2] | 0;
   HEAP32[i8 + (i4 * 60 | 0) + 52 >> 2] = i20;
   HEAP32[i8 + (i4 * 60 | 0) + 56 >> 2] = i20;
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i42 | 0));
 return;
}

function __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 40 | 0;
 i11 = i15 + 32 | 0;
 i8 = i15 + 16 | 0;
 i5 = i15;
 i14 = i13 + 408 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i13);
  i1 = i13 + 340 | 0;
  if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
  i1 = i13 + 384 | 0;
  i2 = i13 + 400 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i13 + 388 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 + 396 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
 }
 i2 = i13 + 356 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 if (!i10) {
  STACKTOP = i15;
  return;
 }
 i12 = i10 + 156 | 0;
 if ((HEAP32[i12 >> 2] | 0) != (HEAP32[(HEAP32[i10 + 32 >> 2] | 0) + 156 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429122 | 0, 0, gb + 429036 | 0, 1569, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i15;
  return;
 }
 i3 = i13 + 28 | 0;
 i9 = __Z25FindAncestorComponentImplR10GameObjecti(HEAP32[i3 >> 2] | 0, 95) | 0;
 HEAP32[i14 >> 2] = i9;
 if (!i9) {
  STACKTOP = i15;
  return;
 }
 if (!(__Z13GetIAnimationv() | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = i13 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i9 = i13 + 384 | 0;
 i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) HEAP16[i13 + 404 >> 1] = 0; else {
  i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0;
  HEAP32[i11 >> 2] = i4;
  if (!i4) {
   i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
   __Z22CalculateTransformPathRK9TransformPS0_(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0, i4);
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
   i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 + 12 >> 2] = i1;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
    i1 = HEAP32[i8 + 12 >> 2] | 0;
    i6 = 20;
   } else if (i4 >>> 0 < 11) {
    i1 = i8 + 11 | 0;
    HEAP8[i1 >> 0] = i4;
    if (!i4) i2 = i8; else {
     i2 = i8;
     i6 = 22;
    }
   } else i6 = 20;
   if ((i6 | 0) == 20) {
    i16 = i4 + 16 & -16;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i7 + 4 >> 2] = i1;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i8 + 8 >> 2] = i16 | -2147483648;
    HEAP32[i8 + 4 >> 2] = i4;
    i1 = i8 + 11 | 0;
    i6 = 22;
   }
   if ((i6 | 0) == 22) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i2 + i4 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i4 = (HEAP8[i1 >> 0] | 0) < 0;
   i5 = HEAP32[i8 >> 2] | 0;
   i1 = i4 ? i5 : i8;
   i16 = _strlen(i1) | 0;
   i3 = i1 + i16 | 0;
   if ((i16 | 0) > 0) {
    i2 = -1;
    do {
     i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = ~i2;
   } else i1 = 0;
   HEAP32[i11 >> 2] = i1;
   if (i4) {
    i1 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i7 + 4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   if (!i1) {
    STACKTOP = i15;
    return;
   }
  }
  i16 = __Z13GetIAnimationv() | 0;
  if (!(mftCall_iiiiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i14 >> 2] | 0, i11 | 0, 1, i13 + 404 | 0) | 0)) {
   STACKTOP = i15;
   return;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i13 + 396 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i13 + 400 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 1, 2, i13 + 388 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i13 + 388 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i16;
  break;
 } while (0);
 i16 = __Z13GetIAnimationv() | 0;
 if (!(mftCall_iiiiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i10 + 144 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0)) {
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i13 + 388 | 0);
   HEAP32[i9 >> 2] = 0;
  }
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i14 >> 2] | 0, fb + 527 | 0, i13);
 STACKTOP = i15;
 return;
}

function __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j(i9, i11, i8) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 32 | 0;
 i12 = i17 + 16 | 0;
 i13 = i17;
 i14 = HEAP8[(HEAP32[i9 >> 2] | 0) + 31 >> 0] | 0;
 i16 = __Z12GetGfxDevicev() | 0;
 i7 = i9 + 52 | 0;
 if (!(HEAP32[i7 >> 2] & 32)) {
  i5 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 356 >> 2] | 0, i16 | 0) | 0;
  if (i5 | 0) {
   i6 = i9 + 36 | 0;
   i4 = 0;
   do {
    i2 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 348 >> 2] | 0, i16 | 0, i4 | 0) | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    L6 : do if (!i3) i15 = 8; else {
     i1 = 0;
     while (1) {
      if ((HEAP32[i9 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i3 >>> 0) {
       i15 = 8;
       break L6;
      }
     }
     if (HEAP32[i7 >> 2] & 8 | 0) i15 = 8;
    } while (0);
    do if ((i15 | 0) == 8) {
     i15 = 0;
     i1 = __Z12GetGfxDevicev() | 0;
     i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, i4 | 0) | 0;
     if (!i1) {
      i1 = __Z12GetGfxDevicev() | 0;
      i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 352 >> 2] | 0, i1 | 0) | 0;
      if (!i1) break;
      i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
     } else i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
     if (i1 | 0) if ((HEAP32[i1 + 88 >> 2] | 0) > 1) __ZN13RenderTexture25ResolveAntiAliasedSurfaceEv(i1);
    } while (0);
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
  }
 }
 L22 : do if ((HEAP32[i9 + 48 >> 2] | 0) < 0) {
  i1 = HEAP32[i9 + 32 >> 2] | 0;
  if (i1 | 0) if (!(HEAP32[i1 + 20 >> 2] & 4096)) {
   i2 = HEAP32[i9 + 36 >> 2] | 0;
   if (i2 | 0) {
    i1 = 0;
    while (1) {
     i3 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
     if (i3 | 0) if ((HEAP32[i3 + 24 >> 2] | 0) == 4) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break L22;
    }
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406276 | 0, 0, gb + 406201 | 0, 151, 512, 0, 0, 0);
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   }
  }
 } while (0);
 if ((HEAP16[gb + 1158232 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158232 | 0, i10);
  i3 = gb + 1158232 | 0;
 } else i3 = 0;
 __ZN9GfxDevice16SetRenderTargetsERK20GfxRenderTargetSetup(i16, i9);
 __Z15gpu_time_samplev();
 do if (!(i8 & 1)) {
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i2 = 0; else i2 = (HEAP8[i1 + 119 >> 0] | 0) != 0;
  if (!(i14 << 24 >> 24 != 0 | i2)) {
   i15 = HEAP32[i9 >> 2] | 0;
   i13 = HEAP32[i9 + 40 >> 2] | 0;
   i12 = (HEAP32[i15 + 4 >> 2] | 0) >>> i13;
   i13 = (HEAP32[i15 + 8 >> 2] | 0) >>> i13;
   i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 152 >> 2] | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = (i12 | 0) == 0 ? 1 : i12;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = (i13 | 0) == 0 ? 1 : i13;
   mftCall_vii(i15 | 0, i16 | 0, i10 | 0);
   break;
  };
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (!i1) i15 = 32; else if (__ZNK6Camera20IsCurrentlyRenderingEv(i1) | 0) {
   __ZNK6Camera13GetCameraRectEb(i13, i1, 0);
   __Z14RectfToRectIntRK5RectTIfE(i12, i13);
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  } else i15 = 32;
  do if ((i15 | 0) == 32) if (i2) {
   i15 = HEAP32[i11 >> 2] | 0;
   i13 = HEAP32[i15 + 80 >> 2] | 0;
   i15 = HEAP32[i15 + 84 >> 2] | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = i13;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = i15;
   break;
  } else {
   i15 = HEAP32[gb + 1158216 >> 2] | 0;
   f19 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 80 >> 2] | 0, i15 | 0) | 0);
   f18 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 84 >> 2] | 0, i15 | 0) | 0);
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   HEAPF32[i13 + 8 >> 2] = f19;
   HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i13 + 12 >> 2] = f18;
   __Z14RectfToRectIntRK5RectTIfE(i12, i13);
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   break;
  } while (0);
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 152 >> 2] | 0, i16 | 0, i10 | 0);
 } while (0);
 if (!(i14 << 24 >> 24)) if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 123 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) == 0; else i1 = 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 36 >> 2] | 0, i16 | 0, i1 | 0);
 if (!i3) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i16 = 1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5Umbra9intersectERKNS_6SphereERKNS_8TriangleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 f21 = Math_fround(HEAPF32[i1 >> 2]);
 f29 = Math_fround(HEAPF32[i2 >> 2]);
 f21 = Math_fround(f21 - f29);
 f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f22 = Math_fround(f22 - f30);
 f23 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f23 = Math_fround(f23 - f28);
 f24 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) - f29);
 f25 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) - f30);
 f27 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) - f28);
 f29 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) - f29);
 f30 = Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) - f30);
 f28 = Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) - f28);
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f26 = Math_fround(f26 * f26);
 f9 = Math_fround(f24 - f21);
 f10 = Math_fround(f25 - f22);
 f11 = Math_fround(f27 - f23);
 f18 = Math_fround(f29 - f21);
 f17 = Math_fround(f30 - f22);
 f20 = Math_fround(f28 - f23);
 f19 = Math_fround(Math_fround(f10 * f20) - Math_fround(f11 * f17));
 f20 = Math_fround(Math_fround(f11 * f18) - Math_fround(f9 * f20));
 f18 = Math_fround(Math_fround(f9 * f17) - Math_fround(f10 * f18));
 f17 = Math_fround(Math_fround(f23 * f18) + Math_fround(Math_fround(f21 * f19) + Math_fround(f22 * f20)));
 if (Math_fround(f17 * f17) > Math_fround(f26 * Math_fround(Math_fround(f18 * f18) + Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20))))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f22 * f22)) + Math_fround(f23 * f23));
 f4 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(f22 * f25)) + Math_fround(f23 * f27));
 f5 = Math_fround(Math_fround(Math_fround(f21 * f29) + Math_fround(f22 * f30)) + Math_fround(f23 * f28));
 f6 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f27 * f27));
 f7 = Math_fround(Math_fround(Math_fround(f24 * f29) + Math_fround(f25 * f30)) + Math_fround(f27 * f28));
 f8 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f30 * f30)) + Math_fround(f28 * f28));
 if (f4 > f3 & f3 > f26 & f5 > f3) {
  i2 = 0;
  return i2 | 0;
 }
 if (f4 > f6 & f6 > f26 & f7 > f6) {
  i2 = 0;
  return i2 | 0;
 }
 if (f7 > f8 & (f8 > f26 & f5 > f8)) {
  i2 = 0;
  return i2 | 0;
 }
 f34 = Math_fround(f29 - f24);
 f33 = Math_fround(f30 - f25);
 f32 = Math_fround(f28 - f27);
 f13 = Math_fround(f21 - f29);
 f14 = Math_fround(f22 - f30);
 f31 = Math_fround(f23 - f28);
 f4 = Math_fround(f4 - f3);
 f12 = Math_fround(f7 - f6);
 f15 = Math_fround(f5 - f8);
 f18 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11));
 f19 = Math_fround(Math_fround(Math_fround(f34 * f34) + Math_fround(f33 * f33)) + Math_fround(f32 * f32));
 f20 = Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14)) + Math_fround(f31 * f31));
 f17 = Math_fround(Math_fround(f21 * f18) - Math_fround(f9 * f4));
 f16 = Math_fround(Math_fround(f22 * f18) - Math_fround(f10 * f4));
 f9 = Math_fround(Math_fround(f23 * f18) - Math_fround(f11 * f4));
 f10 = Math_fround(Math_fround(f24 * f19) - Math_fround(f34 * f12));
 f11 = Math_fround(Math_fround(f25 * f19) - Math_fround(f33 * f12));
 f12 = Math_fround(Math_fround(f27 * f19) - Math_fround(f32 * f12));
 f13 = Math_fround(Math_fround(f29 * f20) - Math_fround(f13 * f15));
 f14 = Math_fround(Math_fround(f30 * f20) - Math_fround(f14 * f15));
 f15 = Math_fround(Math_fround(f28 * f20) - Math_fround(f31 * f15));
 f8 = Math_fround(Math_fround(f21 * f19) - f10);
 f7 = Math_fround(Math_fround(f22 * f19) - f11);
 f6 = Math_fround(Math_fround(f23 * f19) - f12);
 f5 = Math_fround(Math_fround(f24 * f20) - f13);
 f4 = Math_fround(Math_fround(f25 * f20) - f14);
 f3 = Math_fround(Math_fround(f27 * f20) - f15);
 if (Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16))) > Math_fround(f18 * Math_fround(f18 * f26))) if (Math_fround(Math_fround(f9 * Math_fround(Math_fround(f28 * f18) - f9)) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f29 * f18) - f17)) + Math_fround(f16 * Math_fround(Math_fround(f30 * f18) - f16)))) > Math_fround(0.0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11))) > Math_fround(f19 * Math_fround(f26 * f19))) if (Math_fround(Math_fround(f12 * f6) + Math_fround(Math_fround(f10 * f8) + Math_fround(f11 * f7))) > Math_fround(0.0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f13 * f13) + Math_fround(f14 * f14))) > Math_fround(f20 * Math_fround(f26 * f20))) if (Math_fround(Math_fround(f15 * f3) + Math_fround(Math_fround(f13 * f5) + Math_fround(f14 * f4))) > Math_fround(0.0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1;
 return i2 | 0;
}

function __ZN5IMGUI10DragWindowER8GUIStateRK5RectTIfE(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[i1 + 20 >> 2] | 0;
  if (i10 | 0) {
   i2 = HEAP32[i11 + 92 >> 2] | 0;
   if (!i2) {
    i1 = HEAP32[i11 + 276 >> 2] | 0;
    i9 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i9 + 1;
    i1 = i11 + 280 | 0;
   } else {
    i1 = i11 + 280 | 0;
    if ((HEAP32[HEAP32[i1 >> 2] >> 2] | 0) == 12) i9 = -1; else i9 = __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i2, i11, 0, 0) | 0;
   }
   i7 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i8 = (HEAP32[i11 + 276 >> 2] | 0) + 4 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   L9 : do if (!i2) {
    if (!(HEAP32[i11 + 60 >> 2] | 0)) {
     switch (i1 | 0) {
     case 7:
     case 8:
     case 12:
      break L9;
     default:
      {}
     }
     STACKTOP = i13;
     return;
    }
    if (!(HEAP32[i11 + 268 >> 2] | 0)) {
     switch (i1 | 0) {
     case 0:
     case 1:
     case 9:
     case 10:
     case 16:
      break;
     default:
      break L9;
     }
     STACKTOP = i13;
     return;
    }
   } else switch (i1 | 0) {
   case 3:
   case 2:
   case 1:
   case 0:
    {
     if (!(HEAP32[i11 + 60 >> 2] | 0)) {
      STACKTOP = i13;
      return;
     }
     if (HEAP32[i11 + 268 >> 2] | 0) break L9;
     i1 = (i2 | 0) == (i9 | 0) ? i1 : 11;
     break L9;
    }
   case 6:
   case 5:
   case 4:
    {
     if (!(HEAP32[i11 + 60 >> 2] | 0)) {
      STACKTOP = i13;
      return;
     }
     if ((i2 | 0) == (i9 | 0) | (HEAP32[i11 + 268 >> 2] | 0) != 0) break L9;
     i1 = (HEAP32[i11 >> 2] | 0) == (i9 | 0) ? i1 : 11;
     break L9;
    }
   default:
    break L9;
   } while (0);
   switch (i1 | 0) {
   case 0:
    {
     f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
     f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
     f4 = Math_fround(HEAPF32[i12 >> 2]);
     if (!(f4 <= f3)) {
      STACKTOP = i13;
      return;
     }
     if (!(Math_fround(f4 + Math_fround(HEAPF32[i12 + 8 >> 2])) > f3)) {
      STACKTOP = i13;
      return;
     }
     f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
     if (!(f3 <= f5)) {
      STACKTOP = i13;
      return;
     }
     if (!(Math_fround(f3 + Math_fround(HEAPF32[i12 + 12 >> 2])) > f5)) {
      STACKTOP = i13;
      return;
     }
     HEAP32[i8 >> 2] = i9;
     HEAP32[i7 >> 2] = 12;
     f15 = Math_fround(HEAPF32[i11 + 236 >> 2]);
     f14 = Math_fround(HEAPF32[i11 + 240 >> 2]);
     f3 = Math_fround(HEAPF32[i10 + 52 >> 2]);
     f5 = Math_fround(HEAPF32[i10 + 56 >> 2]);
     f4 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i10 + 180 >> 2])) + Math_fround(f5 * Math_fround(HEAPF32[i10 + 196 >> 2]))) + Math_fround(Math_fround(HEAPF32[i10 + 212 >> 2]) * Math_fround(0.0))) + Math_fround(HEAPF32[i10 + 228 >> 2]));
     f4 = Math_fround(f15 - f4);
     f5 = Math_fround(f14 - Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i10 + 184 >> 2])) + Math_fround(f5 * Math_fround(HEAPF32[i10 + 200 >> 2]))) + Math_fround(Math_fround(HEAPF32[i10 + 216 >> 2]) * Math_fround(0.0))) + Math_fround(HEAPF32[i10 + 232 >> 2])));
     HEAPF32[gb + 1100488 >> 2] = f4;
     HEAPF32[gb + 1100496 >> 2] = f5;
     i12 = HEAP32[i10 + 64 >> 2] | 0;
     HEAP32[gb + 1099736 >> 2] = HEAP32[i10 + 60 >> 2];
     HEAP32[gb + 1099736 + 4 >> 2] = i12;
     STACKTOP = i13;
     return;
    }
   case 1:
    {
     if ((i2 | 0) != (i9 | 0)) {
      STACKTOP = i13;
      return;
     }
     HEAP32[i8 >> 2] = 0;
     HEAP32[i7 >> 2] = 12;
     STACKTOP = i13;
     return;
    }
   case 3:
    {
     if ((i2 | 0) != (i9 | 0)) {
      STACKTOP = i13;
      return;
     }
     __Z20InvertMatrix4x4_FullPKfPf(i10 + 180 | 0, i6) | 0;
     f5 = Math_fround(HEAPF32[i11 + 236 >> 2]);
     f15 = Math_fround(HEAPF32[i11 + 240 >> 2]);
     f5 = Math_fround(f5 - Math_fround(HEAPF32[gb + 1100488 >> 2]));
     f15 = Math_fround(f15 - Math_fround(HEAPF32[gb + 1100496 >> 2]));
     f14 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])) + Math_fround(f15 * Math_fround(HEAPF32[i6 + 16 >> 2]))) + Math_fround(Math_fround(HEAPF32[i6 + 32 >> 2]) * Math_fround(0.0))) + Math_fround(HEAPF32[i6 + 48 >> 2]));
     f15 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i6 + 4 >> 2])) + Math_fround(f15 * Math_fround(HEAPF32[i6 + 20 >> 2]))) + Math_fround(Math_fround(HEAPF32[i6 + 36 >> 2]) * Math_fround(0.0))) + Math_fround(HEAPF32[i6 + 52 >> 2]));
     i11 = HEAP32[gb + 1099736 >> 2] | 0;
     i12 = HEAP32[gb + 1099736 + 4 >> 2] | 0;
     HEAPF32[i10 + 52 >> 2] = f14;
     HEAPF32[i10 + 56 >> 2] = f15;
     HEAP32[i10 + 60 >> 2] = i11;
     HEAP32[i10 + 64 >> 2] = i12;
     HEAP8[i10 + 117 >> 0] = 1;
     HEAP32[i7 >> 2] = 12;
     STACKTOP = i13;
     return;
    }
   default:
    {
     STACKTOP = i13;
     return;
    }
   }
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1018899 | 0, 0, gb + 1018710 | 0, 226, 1, 0, 0, 0);
 STACKTOP = i13;
 return;
}

function __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i3 = i11 + 4 | 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9);
 i1 = i8 + 328 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i4 = i8 + 268 | 0;
 i1 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3;
 HEAP8[i6 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 8 & 1;
 HEAP8[i6 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 10 & 3;
 HEAP8[i3 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i3, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 16 & 3;
 HEAP8[i6 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = ((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16777215) >>> 14 & 3;
 HEAP8[i6 >> 0] = i1;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = i1;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i5 = i8 + 260 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP16[i1 >> 1] = HEAP16[i5 >> 1] | 0;
  HEAP32[i10 >> 2] = i2;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 2);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 2 | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 2);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i8 + 228 | 0, gb + 931957 | 0, 8388609);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i8 + 244 | 0, gb + 931980 | 0, 8388609);
 i4 = i8 + 300 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
 i1 = HEAP32[i8 + 288 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 216 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 2 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 2);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 218 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 2);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 308 | 0, i9);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 280 | 0, i9);
 __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 276 | 0, i9);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i8 + 332 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 336 | 0;
 i2 = i4 + 2 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i10 >> 2] = i2;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN11AssetBundle7GetImplEiRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i9, i3) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i10 = i14;
 __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10, i2, i3);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i3 | 0) == (i10 | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i7 = i9 + -1e5 | 0;
 if ((i9 | 0) > 99999) {
  i6 = i3;
  L5 : while (1) {
   i5 = i6 + 40 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i12 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
      i3 = HEAP32[i11 >> 2] | 0;
      i9 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 10; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 11; else i8 = i1;
     }
    }
    if ((i13 | 0) == 10) i13 = 11;
    if ((i13 | 0) == 11) {
     i13 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i1) break; else i8 = i1;
    }
    i3 = HEAP32[gb + 1110260 >> 2] | 0;
    i1 = HEAP32[(HEAP32[(HEAP32[i3 + 44 >> 2] | 0) + 4 + ((HEAP32[i8 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
    if ((i1 | 0) > 99999) {
     i9 = HEAP32[i3 + 24 >> 2] | 0;
     i4 = i9 + (i1 + -1e5 << 3) | 0;
     i1 = i9;
    } else {
     i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i1 << 3) | 0;
     i1 = HEAP32[i3 + 24 >> 2] | 0;
    }
    if (((HEAP32[i4 >> 2] | 0) - (HEAP32[i1 + (i7 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + (i7 << 3) + 4 >> 2] | 0) >>> 0) {
     i1 = i8;
     i13 = 39;
     break L5;
    }
   } while (0);
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i10 | 0)) {
    i1 = 0;
    i13 = 39;
    break;
   } else {
    i2 = i1;
    i6 = i1;
   }
  }
  if ((i13 | 0) == 39) {
   STACKTOP = i14;
   return i1 | 0;
  }
 } else {
  i7 = i3;
  L36 : while (1) {
   i6 = i7 + 40 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   do if (i3 | 0) {
    HEAP32[i12 >> 2] = i3;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i13 = 27; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i3, i12);
      i4 = HEAP32[i11 >> 2] | 0;
      i8 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i8 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i8 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i13 = 27; else {
      i3 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i3) i13 = 29; else i1 = i3;
     }
    }
    if ((i13 | 0) == 27) i13 = 29;
    if ((i13 | 0) == 29) {
     i13 = 0;
     i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     if (!i3) break; else i1 = i3;
    }
    i4 = HEAP32[gb + 1110260 >> 2] | 0;
    i3 = HEAP32[(HEAP32[(HEAP32[i4 + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
    if ((i3 | 0) > 99999) {
     i5 = (HEAP32[i4 + 24 >> 2] | 0) + (i3 + -1e5 << 3) | 0;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
    } else {
     i8 = HEAP32[i4 + 4 >> 2] | 0;
     i5 = i8 + (i3 << 3) | 0;
     i3 = i8;
    }
    if (((HEAP32[i5 >> 2] | 0) - (HEAP32[i3 + (i9 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + (i9 << 3) + 4 >> 2] | 0) >>> 0) {
     i13 = 39;
     break L36;
    }
   } while (0);
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) break; else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i3 = i2;
      break;
     } else i2 = i3;
    }
   }
   if ((i3 | 0) == (i10 | 0)) {
    i1 = 0;
    i13 = 39;
    break;
   } else {
    i2 = i3;
    i7 = i3;
   }
  }
  if ((i13 | 0) == 39) {
   STACKTOP = i14;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZN5physx18PxcArticulationRef17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE(i2, i5, i4, i1, i6, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f8 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
 f22 = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
 f24 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f16 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f14 = Math_fround(f16 * f22);
 f18 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f18 * f24));
 f20 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f24 = Math_fround(Math_fround(f20 * f24) - Math_fround(f16 * f8));
 f22 = Math_fround(Math_fround(f18 * f8) - Math_fround(f20 * f22));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i6 >> 2]));
 f24 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) + f24);
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i6 + 8 >> 2]));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 96 >> 2]));
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 100 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 104 >> 2]));
 f25 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(f25 * Math_fround(HEAPF32[i5 + 112 >> 2]));
 f12 = Math_fround(f25 * Math_fround(HEAPF32[i5 + 116 >> 2]));
 f15 = Math_fround(f9 + f15);
 f12 = Math_fround(f10 + f12);
 f25 = Math_fround(f8 + Math_fround(f25 * Math_fround(HEAPF32[i5 + 120 >> 2])));
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 128 >> 2]));
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i5 + 132 >> 2]));
 f10 = Math_fround(f15 + f10);
 f9 = Math_fround(f12 + f9);
 f8 = Math_fround(f25 + Math_fround(f8 * Math_fround(HEAPF32[i5 + 136 >> 2])));
 f25 = Math_fround(f14 * Math_fround(HEAPF32[i5 >> 2]));
 f25 = Math_fround(f25 + Math_fround(f24 * Math_fround(HEAPF32[i5 + 4 >> 2])));
 f25 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i5 + 8 >> 2])));
 f12 = Math_fround(f20 * Math_fround(HEAPF32[i5 + 16 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f18 * Math_fround(HEAPF32[i5 + 20 >> 2])));
 f12 = Math_fround(f25 + Math_fround(f12 + Math_fround(f16 * Math_fround(HEAPF32[i5 + 24 >> 2]))));
 f25 = Math_fround(f14 * Math_fround(HEAPF32[i5 + 32 >> 2]));
 f25 = Math_fround(f25 + Math_fround(f24 * Math_fround(HEAPF32[i5 + 36 >> 2])));
 f25 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i5 + 40 >> 2])));
 f15 = Math_fround(f20 * Math_fround(HEAPF32[i5 + 48 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f18 * Math_fround(HEAPF32[i5 + 52 >> 2])));
 f15 = Math_fround(f25 + Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i5 + 56 >> 2]))));
 f25 = Math_fround(f14 * Math_fround(HEAPF32[i5 + 64 >> 2]));
 f25 = Math_fround(f25 + Math_fround(f24 * Math_fround(HEAPF32[i5 + 68 >> 2])));
 f25 = Math_fround(f25 + Math_fround(f22 * Math_fround(HEAPF32[i5 + 72 >> 2])));
 f7 = Math_fround(f20 * Math_fround(HEAPF32[i5 + 80 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f18 * Math_fround(HEAPF32[i5 + 84 >> 2])));
 f12 = Math_fround(f10 + f12);
 f15 = Math_fround(f9 + f15);
 f7 = Math_fround(f8 + Math_fround(f25 + Math_fround(f7 + Math_fround(f16 * Math_fround(HEAPF32[i5 + 88 >> 2])))));
 f25 = Math_fround(f12 * Math_fround(HEAPF32[i3 >> 2]));
 f8 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f9 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 16 >> 2]));
 f11 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 20 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 f13 = Math_fround(f15 * Math_fround(HEAPF32[i3 + 32 >> 2]));
 f23 = Math_fround(f15 * Math_fround(HEAPF32[i3 + 36 >> 2]));
 f21 = Math_fround(f15 * Math_fround(HEAPF32[i3 + 40 >> 2]));
 f19 = Math_fround(f15 * Math_fround(HEAPF32[i3 + 48 >> 2]));
 f17 = Math_fround(f15 * Math_fround(HEAPF32[i3 + 52 >> 2]));
 f13 = Math_fround(f25 + f13);
 f23 = Math_fround(f8 + f23);
 f21 = Math_fround(f9 + f21);
 f19 = Math_fround(f10 + f19);
 f17 = Math_fround(f11 + f17);
 f15 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i3 + 56 >> 2])));
 f12 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 64 >> 2]));
 f11 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 68 >> 2]));
 f10 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 72 >> 2]));
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 80 >> 2]));
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 84 >> 2]));
 f11 = Math_fround(f24 - Math_fround(f23 + f11));
 f10 = Math_fround(f22 - Math_fround(f21 + f10));
 f9 = Math_fround(f20 - Math_fround(f19 + f9));
 f8 = Math_fround(f18 - Math_fround(f17 + f8));
 f7 = Math_fround(f16 - Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 88 >> 2]))));
 HEAPF32[i2 >> 2] = Math_fround(f14 - Math_fround(f13 + f12));
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f9;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f7;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10TagManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 24 | 0;
 i13 = i15 + 12 | 0;
 i10 = i15;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i12);
 i9 = i11 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i11 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i13, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i5 = i13;
  i6 = i14;
  i4 = i2;
 } else {
  do {
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i11, i1, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
  i5 = i13;
  i6 = i14;
  i4 = i1;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if ((i2 | 0) != (i1 | 0)) {
  i2 = 2e4;
  i3 = 0;
  i1 = i4;
  while (1) {
   __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i12, i2, i1 + (i3 << 5) | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i6 >> 2] | 0) - i1 >> 5 >>> 0) break; else i2 = i2 + 1 | 0;
  }
 }
 HEAP32[i10 >> 2] = 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = i10 + 8 | 0;
 i1 = 0;
 do {
  i4 = i12 + 44 + (i1 << 5) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i10, i4); else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i17 = i12 + 44 + (i1 << 5) + 24 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i6 = i2 + 24 | 0;
   HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i6 + 4 >> 2] = i16;
   HEAP8[i2 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i4);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i10, _llvm_bswap_i32(i1 | 0) | 0);
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i1 = i3; else {
  i1 = i2;
  do {
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i11, i1, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = i2;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i3 - i2 >> 5;
 i3 = (i3 | 0) > 32 ? 32 : i3;
 if ((i3 | 0) > 8) {
  i2 = 8;
  do {
   __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i12, i2, i1 + (i2 << 5) | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i3 | 0));
 }
 if (i1 | 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i12 + 1068 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, 0);
 __ZN10TagManager23AddDefaultLayerIfNeededEv(i12);
 i4 = i12 + 1080 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i17 = (HEAP32[i12 + 1072 >> 2] | 0) - i3 | 0;
 i2 = (i17 | 0) / 40 | 0;
 L48 : do if (i17 | 0) {
  i1 = 0;
  while (1) {
   if (!(HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i2 | 0)) break L48;
  }
  HEAP32[i4 >> 2] = i1;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i14 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i14 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i15;
 return;
}

function __ZN20LocalFileSystemPosix4CopyER13FileEntryDataS1_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 3232 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i23 + 8 | 0;
 i11 = i23;
 i20 = i23 + 2156 | 0;
 i18 = i23 + 1088 | 0;
 i16 = i23 + 1068 | 0;
 HEAP32[i20 >> 2] = gb + 70828 + 8;
 i22 = i20 + 4 | 0;
 i21 = i20 + 1044 | 0;
 HEAP8[i22 >> 0] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP32[i21 + 16 >> 2] = 0;
 i19 = i10 + 1040 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 _strncpy(i22, i10, 1040) | 0;
 i19 = i20 + 1048 | 0;
 i1 = i20 + 1056 | 0;
 i2 = i20 + 1043 | 0;
 i3 = i2 + 21 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 0;
 i14 = i20 + 1064 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i18 >> 2] = gb + 70828 + 8;
 i15 = i18 + 4 | 0;
 i13 = i18 + 1044 | 0;
 HEAP8[i15 >> 0] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = 0;
 i2 = i10 + 1040 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 _strncpy(i15, i10, 1040) | 0;
 HEAP8[i18 + 1043 >> 0] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i12 = i18 + 1048 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 + 1044 >> 2];
 HEAP32[i18 + 1052 >> 2] = 0;
 i4 = i18 + 1056 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i18 + 1060 >> 2] = 0;
 i1 = i3;
 if (i3) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i15 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
 HEAP32[i4 >> 2] = 0;
 i9 = i18 + 1064 | 0;
 HEAP8[i9 >> 0] = 0;
 if (__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i20, i5, 0, 0) | 0) if (__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i18, i6, 1, 0) | 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (!i1) {
   i2 = 0;
   i3 = 0;
  } else {
   i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i22 | 0) | 0;
   i2 = getTempRet0() | 0;
  }
  i8 = i2 >>> 0 < 0 | (i2 | 0) == 0 & i3 >>> 0 < 65536;
  i4 = i8 ? i3 : 65536;
  if (!i4) i2 = 1; else {
   i1 = gb + 64016 | 0;
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   i7 = i11;
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i16 >> 2] = 0;
   i7 = i16 + 16 | 0;
   i8 = i16 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
   i1 = i10;
   i6 = HEAP32[i1 + 4 >> 2] | 0;
   i5 = i8;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = i6;
   HEAP32[i16 + 12 >> 2] = i4;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i4, 1, i8, 0, gb + 1047584 | 0, 464) | 0;
   i5 = 0;
   i6 = 0;
   while (1) {
    if ((i5 | 0) == (i3 | 0) & (i6 | 0) == (i2 | 0)) {
     i1 = 1;
     i17 = 17;
     break;
    }
    i1 = HEAP32[i19 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     i17 = 17;
     break;
    }
    if (!(mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i22 | 0, i4 | 0, 0, HEAP32[i16 >> 2] | 0, i10 | 0) | 0)) {
     i1 = 0;
     i17 = 17;
     break;
    }
    i1 = HEAP32[i12 >> 2] | 0;
    if (!i1) {
     i17 = 15;
     break;
    }
    i24 = i10;
    i1 = mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i15 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i24 + 4 >> 2] | 0, HEAP32[i16 >> 2] | 0, i11 | 0) | 0;
    i24 = i11;
    i5 = _i64Add((i1 ? HEAP32[i24 >> 2] | 0 : 0) | 0, (i1 ? HEAP32[i24 + 4 >> 2] | 0 : 0) | 0, i5 | 0, i6 | 0) | 0;
    i6 = getTempRet0() | 0;
    if (!i1) {
     i1 = 0;
     break;
    }
   }
   do if ((i17 | 0) == 15) i1 = 0; else if ((i17 | 0) == 17) if (HEAP8[i9 >> 0] | 0) {
    i2 = HEAP32[i12 >> 2] | 0;
    if (!i2) {
     i1 = 0;
     break;
    }
    if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i15 | 0) | 0)) {
     i1 = 0;
     break;
    }
   } while (0);
   if ((HEAP32[i7 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i8);
    HEAP32[i16 >> 2] = 0;
   }
   i2 = i1;
  }
 } else i2 = 0; else i2 = 0;
 HEAP32[i18 >> 2] = gb + 70828 + 8;
 if (HEAP8[i9 >> 0] | 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i15 | 0) | 0;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i15 | 0);
 HEAP32[i20 >> 2] = gb + 70828 + 8;
 if (HEAP8[i14 >> 0] | 0) {
  i1 = HEAP32[i19 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i22 | 0) | 0;
 }
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  STACKTOP = i23;
  return i2 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i22 | 0);
 STACKTOP = i23;
 return i2 | 0;
}

function __ZN18DelayedCallManager6UpdateEi(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, d28 = 0.0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i29 + 16 | 0;
 i21 = i29;
 i25 = i29 + 12 | 0;
 i26 = i29 + 8 | 0;
 i27 = i29 + 4 | 0;
 d28 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 i17 = HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2] | 0;
 i18 = i15 + 28 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i19 = i15 + 44 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 i20 = i15 + 32 | 0;
 i2 = i1;
 if ((i2 | 0) == (i20 | 0)) {
  STACKTOP = i29;
  return;
 }
 i22 = i15 + 40 | 0;
 i23 = i15 + 32 | 0;
 i24 = i15 + 36 | 0;
 while (1) {
  i13 = i2 + 16 | 0;
  if (!(+HEAPF64[i13 >> 3] <= d28)) {
   i12 = 36;
   break;
  }
  HEAP32[i22 >> 2] = i1;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i3) {
   i4 = i1;
   while (1) {
    i3 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
   }
  } else while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) break; else i3 = i4;
  }
  HEAP32[i22 >> 2] = i3;
  i7 = i2 + 52 | 0;
  do if (HEAP32[i7 >> 2] & i16 | 0) if ((HEAP32[i2 + 56 >> 2] | 0) != (HEAP32[i19 >> 2] | 0)) {
   i8 = i2 + 24 | 0;
   if ((HEAP32[i8 >> 2] | 0) <= (i17 | 0)) {
    HEAP32[i21 >> 2] = HEAP32[i2 + 48 >> 2];
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i3) i12 = 16; else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i4 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[i3 + 32 >> 2] | 0;
      i3 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i3, i21);
      i4 = HEAP32[i14 >> 2] | 0;
      i11 = HEAP32[i3 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i3 = (i4 | 0) == -1 ? i11 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i11 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i12 = 16; else {
      i9 = HEAP32[i3 + 4 >> 2] | 0;
      if (i9 | 0) {
       i10 = HEAP32[i2 + 36 >> 2] | 0;
       i11 = HEAP32[i2 + 40 >> 2] | 0;
       if (!(HEAP8[i2 + 32 >> 0] | 0)) {
        i2 = HEAP32[i2 + 44 >> 2] | 0;
        HEAP32[i25 >> 2] = i1;
        HEAP32[i14 >> 2] = HEAP32[i25 >> 2];
        __ZN18DelayedCallManager15RemoveNoCleanupERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i15, i13, i14);
        if (!((i2 | 0) != 0 & (mftCall_iii(i11 | 0, i9 | 0, i10 | 0) | 0) == 1)) break;
        mftCall_ii(i2 | 0, i10 | 0) | 0;
        break;
       }
       d6 = +Math_fround(HEAPF32[i2 + 28 >> 2]);
       HEAPF64[i13 >> 3] = +HEAPF64[i13 >> 3] + d6;
       if (HEAP32[i7 >> 2] & 8 | 0) HEAP32[i8 >> 2] = (HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2] | 0) + 1;
       i2 = HEAP32[i20 >> 2] | 0;
       do if (!i2) {
        i8 = i20;
        i4 = i20;
       } else {
        d6 = +HEAPF64[i13 >> 3];
        while (1) if (d6 < +HEAPF64[i2 + 16 >> 3]) {
         i3 = HEAP32[i2 >> 2] | 0;
         if (!i3) {
          i12 = 27;
          break;
         } else i2 = i3;
        } else {
         i4 = i2 + 4 | 0;
         i3 = HEAP32[i4 >> 2] | 0;
         if (!i3) {
          i12 = 30;
          break;
         } else i2 = i3;
        }
        if ((i12 | 0) == 27) {
         i12 = 0;
         i8 = i2;
         i4 = i2;
         break;
        } else if ((i12 | 0) == 30) {
         i12 = 0;
         i8 = i2;
         break;
        }
       } while (0);
       i2 = __Znwj(64) | 0;
       i3 = i2 + 16 | 0;
       i5 = i13;
       i7 = i3 + 48 | 0;
       do {
        HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
        i3 = i3 + 4 | 0;
        i5 = i5 + 4 | 0;
       } while ((i3 | 0) < (i7 | 0));
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = i8;
       HEAP32[i4 >> 2] = i2;
       i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
       if (i3) {
        HEAP32[i18 >> 2] = i3;
        i2 = HEAP32[i4 >> 2] | 0;
       }
       __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i23 >> 2] | 0, i2);
       HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
       HEAP32[i26 >> 2] = i1;
       HEAP32[i14 >> 2] = HEAP32[i26 >> 2];
       __ZN18DelayedCallManager15RemoveNoCleanupERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i15, i13, i14);
       mftCall_iii(i11 | 0, i9 | 0, i10 | 0) | 0;
       break;
      }
     }
    }
    if ((i12 | 0) == 16) i12 = 0;
    HEAP32[i27 >> 2] = i1;
    HEAP32[i14 >> 2] = HEAP32[i27 >> 2];
    __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i15, i13, i14);
   }
  } while (0);
  i1 = HEAP32[i22 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i20 | 0)) {
   i12 = 36;
   break;
  }
 }
 if ((i12 | 0) == 36) {
  STACKTOP = i29;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i17, i18, i6) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i23;
 i21 = i17 + 28 | 0;
 i22 = i17 + 32 | 0;
 HEAP32[i22 >> 2] = 32;
 i11 = i17 + 44 | 0;
 HEAP32[i11 >> 2] = 16;
 i12 = i17 + 40 | 0;
 HEAP32[i12 >> 2] = 6;
 i13 = i17 + 48 | 0;
 HEAP8[i13 >> 0] = 0;
 i10 = i17 + 52 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = 65;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (i1 | 0) {
  i20 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i20;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 HEAP32[i21 >> 2] = i2;
 i3 = i2 + (HEAP32[i22 >> 2] << 3) | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i17 + 20 | 0;
  i1 = i2;
  do {
   i16 = i4;
   i19 = HEAP32[i16 + 4 >> 2] | 0;
   i20 = i1;
   HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i19 = i17 + 36 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = i18 + 4 | 0;
 f5 = Math_fround(((HEAP32[i18 + 36 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 65;
  HEAP32[i7 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[i22 >> 2] | 0;
   i4 = i1 + (i16 << 3) | 0;
   if (i16) {
    i3 = i6;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i16 = HEAP32[i10 >> 2] | 0;
   HEAP32[i7 >> 2] = 65;
   HEAP32[i7 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
  }
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = i6 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i17 + 20 | 0;
   i1 = i6 + (i1 << 3) | 0;
   do {
    i14 = i4;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  HEAP32[i21 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i11 >> 2] = ~~f9 >>> 0;
  HEAP32[i12 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i13 >> 0] = 0;
 } else i2 = i1;
 i14 = i18 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i18 + 32 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 << 3) | 0;
 L31 : do if (i13) {
  i4 = HEAP32[i18 + 20 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((HEAP8[i18 + 8 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) {
   do {
    i13 = HEAP32[i1 >> 2] | 0;
    if (!((i4 | 0) == (i13 | 0) | (i3 | 0) == (i13 | 0))) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  } else {
   do {
    if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i16 | 0));
   STACKTOP = i23;
   return;
  }
 } while (0);
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i23;
  return;
 }
 i11 = i17 + 20 | 0;
 i12 = i18 + 8 | 0;
 i13 = i18 + 12 | 0;
 i10 = i18 + 20 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = (Math_imul(HEAP32[i1 >> 2] | 0, 1419247029) | 0) & i4;
  i7 = HEAP32[i21 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i6 = i1;
  i17 = HEAP32[i6 + 4 >> 2] | 0;
  i18 = i7 + (i2 << 3) | 0;
  HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L52 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   if ((HEAP8[i12 >> 0] | 0) != 0 & (HEAP32[i20 >> 2] | 0) != 0) while (1) {
    i18 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i18 | 0) | (i2 | 0) == (i18 | 0))) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L52;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i23;
 return;
}

function __ZN7mecanim9animation12GetHumanPoseINS0_10ValueDeltaEEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f11 = f0, f12 = f0, f13 = f0;
 i1 = HEAP32[i8 + 1116 >> 2] | 0;
 if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 i1 = HEAP32[i8 + 1120 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 i1 = HEAP32[i8 + 1124 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 HEAPF32[i10 >> 2] = f6;
 HEAPF32[i10 + 4 >> 2] = f5;
 HEAPF32[i10 + 8 >> 2] = f3;
 i1 = HEAP32[i8 + 1128 >> 2] | 0;
 if ((i1 | 0) == -1) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 i1 = HEAP32[i8 + 1132 >> 2] | 0;
 if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 i1 = HEAP32[i8 + 1136 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 i1 = HEAP32[i8 + 1140 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(1.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
 f11 = Math_fround(f6 * f12);
 f5 = Math_fround(f5 * f12);
 f6 = Math_fround(f3 * f12);
 HEAPF32[i10 + 12 >> 2] = Math_fround(f7 * f12);
 HEAPF32[i10 + 16 >> 2] = f11;
 HEAPF32[i10 + 20 >> 2] = f5;
 HEAPF32[i10 + 24 >> 2] = f6;
 HEAP32[i10 + 28 >> 2] = 1065353216;
 HEAP32[i10 + 32 >> 2] = 1065353216;
 HEAP32[i10 + 36 >> 2] = 1065353216;
 i2 = 0;
 i4 = 14;
 while (1) {
  i1 = HEAP32[i8 + 1088 + (i4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  HEAPF32[i10 + 68 + (i2 << 6) >> 2] = f6;
  HEAPF32[i10 + 68 + (i2 << 6) + 4 >> 2] = f5;
  HEAPF32[i10 + 68 + (i2 << 6) + 8 >> 2] = f3;
  i1 = HEAP32[i8 + 1088 + (i4 + 3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 5 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 6 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(1.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
  f6 = Math_fround(f6 * f13);
  f11 = Math_fround(f5 * f13);
  f12 = Math_fround(f3 * f13);
  HEAPF32[i10 + 68 + (i2 << 6) + 12 >> 2] = Math_fround(f7 * f13);
  HEAPF32[i10 + 68 + (i2 << 6) + 16 >> 2] = f6;
  HEAPF32[i10 + 68 + (i2 << 6) + 20 >> 2] = f11;
  HEAPF32[i10 + 68 + (i2 << 6) + 24 >> 2] = f12;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 4) {
   i1 = 0;
   i2 = 42;
   break;
  } else i4 = i4 + 7 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 596 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 596 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 3) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 52) {
   i1 = 0;
   i2 = 94;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 364 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 364 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 3) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 20) {
   i1 = 0;
   i2 = 114;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 500 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 500 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 3) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 20) {
   i2 = 0;
   i4 = 134;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i1 = HEAP32[i8 + 1088 + (i4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]);
  HEAPF32[i10 + 804 + (i2 * 12 | 0) >> 2] = f6;
  HEAPF32[i10 + 804 + (i2 * 12 | 0) + 4 >> 2] = f5;
  HEAPF32[i10 + 804 + (i2 * 12 | 0) + 8 >> 2] = f3;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 7) break; else i4 = i4 + 3 | 0;
 }
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags(i29, i30, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 56 | 0;
 i25 = i28 + 40 | 0;
 i26 = i28 + 20 | 0;
 i27 = i28;
 i1 = i29 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i29 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i24, 4);
  i1 = HEAP32[i24 >> 2] | 0;
 } else {
  i23 = HEAP32[i2 >> 2] | 0;
  HEAP32[i24 >> 2] = i23;
  HEAP32[i1 >> 2] = i3;
  i1 = i23;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 i8 = i26 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i26 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = i30 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i30, HEAP32[i9 >> 2] | 0);
 i10 = i30 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i30 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 if ((i7 | 0) <= 0) {
  STACKTOP = i28;
  return;
 }
 i11 = i27 + 4 | 0;
 i12 = i8 + 11 | 0;
 i13 = i26 + 8 | 0;
 i14 = i27 + 16 | 0;
 i6 = i27 + 16 | 0;
 i15 = i24 + 4 | 0;
 i16 = i27 + 12 | 0;
 i17 = i27 + 8 | 0;
 i18 = i9;
 i19 = i30 + 4 | 0;
 i20 = i27 + 4 | 0;
 i21 = i20 + 11 | 0;
 i22 = i24 + 4 | 0;
 i23 = i11 + 11 | 0;
 i5 = 0;
 do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i26, i29);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i29, i8, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i29);
  HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
  i3 = HEAP8[i12 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  i3 = i1 ? HEAP32[i13 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i14 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = 12;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i23 >> 0] = i3;
   if (!i3) i1 = i11; else {
    i1 = i11;
    i4 = 14;
   }
  } else i4 = 12;
  if ((i4 | 0) == 12) {
   i31 = i3 + 16 & -16;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i15 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i31, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i16 >> 2] = i31 | -2147483648;
   HEAP32[i17 >> 2] = i3;
   i4 = 14;
  }
  if ((i4 | 0) == 14) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if (!i1) {
   HEAP32[i24 >> 2] = i9;
   i2 = i18;
   i3 = i9;
  } else {
   i4 = HEAP32[i27 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 19;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i4 = 24;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 23;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 19) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 23) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 24) {
    i4 = 0;
    HEAP32[i24 >> 2] = i1;
    i2 = i1;
    i3 = i24;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE(i25, i30, i27);
   i1 = HEAP32[i25 >> 2] | 0;
   HEAP32[i25 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i30 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 >> 2] | 0, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  if ((HEAP8[i21 >> 0] | 0) < 0) {
   i31 = HEAP32[i20 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i24 >> 2] = 66;
   HEAP32[i22 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i31, i24);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 if ((HEAP8[i26 + 4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i28;
  return;
 }
 i31 = HEAP32[i26 + 4 >> 2] | 0;
 i30 = HEAP32[i26 + 16 >> 2] | 0;
 HEAP32[i24 >> 2] = 66;
 HEAP32[i24 + 4 >> 2] = i30;
 __Z19free_alloc_internalPvRK10MemLabelId(i31, i24);
 STACKTOP = i28;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainTetherEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 if (f2 == Math_fround(0.0)) return;
 i1 = HEAP32[i3 + 108 >> 2] | 0;
 if (!i1) return;
 i27 = HEAP32[i3 >> 2] | 0;
 i24 = HEAP32[i3 + 4 >> 2] | 0;
 i22 = i27 << 2;
 i25 = i24 + (i22 << 2) | 0;
 i4 = HEAP32[i3 + 104 >> 2] | 0;
 i26 = i4 + (i1 << 3) | 0;
 f23 = Math_fround(Math_fround(f2 * Math_fround(i27 >>> 0)) / Math_fround(i1 >>> 0));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 f23 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 if (!i22) return;
 i22 = i1 & HEAP32[gb + 1097472 + 12 >> 2];
 i12 = i1 & HEAP32[gb + 1097472 + 8 >> 2];
 i10 = i1 & HEAP32[gb + 1097472 + 4 >> 2];
 f14 = (HEAP32[tempDoublePtr >> 2] = i1 & HEAP32[gb + 1097472 >> 2], Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(HEAPF32[gb + 1097504 >> 2]);
 f19 = Math_fround(HEAPF32[gb + 1097504 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[gb + 1097504 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[gb + 1097504 + 12 >> 2]);
 i22 = i24;
 while (1) {
  f2 = Math_fround(HEAPF32[i22 >> 2]);
  i8 = i22 + 4 | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  i10 = i22 + 8 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  i12 = i22 + 12 | 0;
  f13 = Math_fround(HEAPF32[i12 >> 2]);
  if (i4 >>> 0 < i26 >>> 0) {
   i1 = 0;
   i3 = 0;
   i6 = 0;
   i5 = 0;
   i7 = i4;
   do {
    i32 = (HEAPU16[i7 >> 1] | 0) << 4;
    f36 = Math_fround(HEAPF32[i24 + i32 >> 2]);
    f35 = Math_fround(HEAPF32[i24 + (i32 | 4) >> 2]);
    f34 = Math_fround(HEAPF32[i24 + (i32 | 8) >> 2]);
    f36 = Math_fround(f36 - f2);
    f35 = Math_fround(f35 - f9);
    f34 = Math_fround(f34 - f11);
    f33 = Math_fround(Math_fround(HEAPF32[i24 + (i32 | 12) >> 2]) - f13);
    f28 = Math_fround(Math_fround(Math_fround(f36 * f36) + Math_fround(f35 * f35)) + Math_fround(f34 * f34));
    f31 = Math_fround(f18 + f28);
    f30 = Math_fround(f19 + f28);
    f29 = Math_fround(f28 + f20);
    f28 = Math_fround(f28 + f21);
    f37 = Math_fround(f23 * Math_fround(HEAPF32[i7 + 4 >> 2]));
    f31 = Math_fround(Math_fround(1.0) - Math_fround(f37 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f31))))));
    f30 = Math_fround(Math_fround(1.0) - Math_fround(f37 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f30))))));
    f29 = Math_fround(Math_fround(1.0) - Math_fround(f37 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f29))))));
    f28 = Math_fround(Math_fround(1.0) - Math_fround(f37 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f28))))));
    i32 = f31 < Math_fround(0.0);
    f31 = i32 ? Math_fround(0.0) : f31;
    i32 = f30 < Math_fround(0.0);
    f30 = i32 ? Math_fround(0.0) : f30;
    i32 = f29 < Math_fround(0.0);
    f29 = i32 ? Math_fround(0.0) : f29;
    i32 = f28 < Math_fround(0.0);
    f31 = Math_fround(f36 * f31);
    f30 = Math_fround(f35 * f30);
    f29 = Math_fround(f34 * f29);
    f28 = Math_fround(f33 * (i32 ? Math_fround(0.0) : f28));
    f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
    f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
    f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
    f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
    i7 = i7 + (i27 << 3) | 0;
   } while (i7 >>> 0 < i26 >>> 0);
  } else {
   i5 = 0;
   i6 = 0;
   i3 = 0;
   i1 = 0;
  }
  f34 = Math_fround(f14 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f35 = Math_fround(f15 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f36 = Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f35 = Math_fround(f9 + f35);
  f36 = Math_fround(f11 + f36);
  f37 = Math_fround(f13 + Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  HEAPF32[i22 >> 2] = Math_fround(f2 + f34);
  HEAPF32[i8 >> 2] = f35;
  HEAPF32[i10 >> 2] = f36;
  HEAPF32[i12 >> 2] = f37;
  i22 = i22 + 16 | 0;
  if ((i22 | 0) == (i25 | 0)) break; else i4 = i4 + 8 | 0;
 }
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR23TreeInstanceIndexSorterPjEEbT0_S4_T_(i12, i11, i10) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, f13 = f0;
 switch (i11 - i12 >> 2 | 0) {
 case 2:
  {
   i1 = i11 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i11 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   if (!(Math_fround(HEAPF32[i11 + (i2 * 40 | 0) + 36 >> 2]) > Math_fround(HEAPF32[i11 + (i3 * 40 | 0) + 36 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i12 = 1;
   return i12 | 0;
  }
 case 3:
  {
   i9 = i12 + 4 | 0;
   i5 = i11 + -4 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i8 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   f7 = Math_fround(HEAPF32[i8 + (i3 * 40 | 0) + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i8 + (i6 * 40 | 0) + 36 >> 2]);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 36 >> 2]) > f7;
   if (!(f7 > f4)) {
    if (!i2) {
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i9 >> 2] = i1;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    f7 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 36 >> 2]);
    if (!(f7 > Math_fround(HEAPF32[i8 + (i2 * 40 | 0) + 36 >> 2]))) {
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i12 >> 2] = i1;
    HEAP32[i9 >> 2] = i2;
    i12 = 1;
    return i12 | 0;
   }
   if (i2) {
    HEAP32[i12 >> 2] = i1;
    HEAP32[i5 >> 2] = i6;
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i3;
   HEAP32[i9 >> 2] = i6;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 36 >> 2]) > f4)) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i12, i12 + 4 | 0, i12 + 8 | 0, i11 + -4 | 0, i10) | 0;
   i12 = 1;
   return i12 | 0;
  }
 case 5:
  {
   i9 = i12 + 4 | 0;
   i8 = i12 + 8 | 0;
   i5 = i12 + 12 | 0;
   i1 = i11 + -4 | 0;
   __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i12, i9, i8, i5, i10) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   if (!(Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]) > Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 36 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i5 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i6 + (i2 * 40 | 0) + 36 >> 2]);
   if (!(f4 > Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 36 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i8 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[i9 >> 2] | 0;
   if (!(f4 > Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 36 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i9 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[i12 >> 2] | 0;
   if (!(f4 > Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 36 >> 2]))) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i9 >> 2] = i1;
   i12 = 1;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   return i12 | 0;
  }
 default:
  {
   i2 = i12 + 8 | 0;
   i1 = i12 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i8 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   f13 = Math_fround(HEAPF32[i8 + (i3 * 40 | 0) + 36 >> 2]);
   f4 = Math_fround(HEAPF32[i8 + (i5 * 40 | 0) + 36 >> 2]);
   i6 = HEAP32[i2 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i8 + (i6 * 40 | 0) + 36 >> 2]);
   i8 = f7 > f13;
   do if (f13 > f4) {
    if (i8) {
     HEAP32[i12 >> 2] = i6;
     HEAP32[i2 >> 2] = i5;
     i3 = i5;
     break;
    }
    HEAP32[i12 >> 2] = i3;
    HEAP32[i1 >> 2] = i5;
    if (f7 > f4) {
     HEAP32[i1 >> 2] = i6;
     HEAP32[i2 >> 2] = i5;
     i3 = i5;
    } else i3 = i6;
   } else if (i8) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i2 >> 2] = i3;
    if (f7 > f4) {
     HEAP32[i12 >> 2] = i6;
     HEAP32[i1 >> 2] = i5;
    }
   } else i3 = i6; while (0);
   i1 = i12 + 12 | 0;
   L13 : do if ((i1 | 0) == (i11 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i10 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    i9 = i1;
    i1 = 0;
    while (1) {
     i8 = HEAP32[i9 >> 2] | 0;
     f4 = Math_fround(HEAPF32[i10 + (i8 * 40 | 0) + 36 >> 2]);
     if (f4 > Math_fround(HEAPF32[i10 + (i3 * 40 | 0) + 36 >> 2])) {
      i5 = i9;
      i6 = i3;
      while (1) {
       HEAP32[i5 >> 2] = i6;
       if ((i2 | 0) == (i12 | 0)) {
        i2 = i12;
        break;
       }
       i3 = i2 + -4 | 0;
       i6 = HEAP32[i3 >> 2] | 0;
       if (!(f4 > Math_fround(HEAPF32[i10 + (i6 * 40 | 0) + 36 >> 2]))) break; else {
        i5 = i2;
        i2 = i3;
       }
      }
      HEAP32[i2 >> 2] = i8;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i9 + 4 | 0) == (i11 | 0);
       break L13;
      }
     }
     i2 = i9 + 4 | 0;
     if ((i2 | 0) == (i11 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i3 = HEAP32[i9 >> 2] | 0;
     i8 = i9;
     i9 = i2;
     i2 = i8;
    }
   } while (0);
   i12 = i1 | i2;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN4Mesh9SetColorsEPK10ColorRGBAfj(i11, i2, i7) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i12 = i13 + 40 | 0;
 i8 = i13 + 24 | 0;
 i6 = i13 + 8 | 0;
 i9 = i11 + 32 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i5 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i9 >> 2] | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  i5 = i3 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
 }
 if (!((i2 | 0) != 0 & (i7 | 0) != 0)) {
  i1 = i5 + 8 | 0;
  i2 = HEAP32[i5 + 100 >> 2] | 0;
  if (!(HEAP32[i5 + 176 >> 2] | 0)) if ((HEAP32[i11 + 116 >> 2] | 0) == (HEAP32[i11 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i12, i1);
   HEAP32[i12 >> 2] = (HEAP32[i12 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i12 + 8 >> 2] & ~HEAP32[i12 + 12 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  } else i10 = 8; else i10 = 8;
  if ((i10 | 0) == 8) {
   HEAP32[i8 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i2, 0, 4, i8, gb + 1546313 | 0);
  i5 = i11 + 44 | 0;
  i1 = HEAP8[i5 >> 0] | 1;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i12 >> 2] = gb + 30832;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = i11;
  i2 = HEAP32[i11 + 236 >> 2] | 0;
  i4 = i11 + 232 | 0;
  i3 = i2;
  if ((i3 | 0) != (i4 | 0)) {
   i1 = i3;
   do {
    i11 = i2;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i11 + 8 >> 2] | 0, gb + 1105196 | 0, i12);
    i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   i1 = HEAP8[i5 >> 0] | 0;
  }
  HEAP8[i5 >> 0] = i1 & -17;
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i5 + 100 >> 2] | 0) != (i7 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[gb + 58184 + 8 >> 2];
  __Z6FormatPKcz(i12, gb + 427581 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 425656 | 0, 971, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i13;
  return;
 }
 i1 = i8;
 i3 = i1 + 16 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 1 >> 0] = 4;
 i1 = i5 + 8 | 0;
 i3 = HEAP32[i5 + 100 >> 2] | 0;
 if (!(HEAP32[i5 + 176 >> 2] | 0)) if ((HEAP32[i11 + 116 >> 2] | 0) == (HEAP32[i11 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i12, i1);
  HEAP32[i12 >> 2] = (HEAP32[i12 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i12 + 8 >> 2] & ~HEAP32[i12 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 } else i10 = 18; else i10 = 18;
 if ((i10 | 0) == 18) {
  HEAP32[i6 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i3, 4, 0, i6, i8);
 i6 = i11 + 44 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] & -17;
 i5 = i2 + (i7 << 4) | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i10 = HEAP16[i3 + 18 >> 1] | 0;
 if ((i10 & 65535) < 1024 | (i10 & 255) != 0) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = 1;
  } else if (!(HEAP8[i3 + 19 >> 0] | 0)) {
   i1 = 0;
   i3 = 1;
  } else {
   i10 = HEAP16[i3 + 16 >> 1] | 0;
   i1 = i1 + (((i10 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i10 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 while (1) {
  i8 = HEAP32[i2 + 4 >> 2] | 0;
  i9 = HEAP32[i2 + 8 >> 2] | 0;
  i10 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i9;
  HEAP32[i1 + 12 >> 2] = i10;
  i2 = i2 + 16 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
 }
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 1;
 HEAP32[i12 >> 2] = gb + 30832;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = i11;
 i2 = HEAP32[i11 + 236 >> 2] | 0;
 i3 = i11 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i11 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i11 + 8 >> 2] | 0, gb + 1105196 | 0, i12);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i13;
 return;
}

function __ZN8LODGroup8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i7 = i11;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i8, i10);
 __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
 i2 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 425113 | 0, HEAP32[gb + 37324 >> 2] | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 842535 | 0, HEAP32[gb + 37012 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i6 >>> 0) i5 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8LODGroup11LODFadeModeEEvRT_RT0_PKc17TransferMetaFlags(i10, i8 + 48 | 0, gb + 425135 | 0, 0);
 i3 = i8 + 52 | 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 425146 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i10, 1) | 0) {
  HEAP32[i7 >> 2] = 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 425167 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup11LODStruct50ENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  __ZN8LODGroup18UpgradeFrom50AssetERKNSt3__26vectorINS_11LODStruct50ENS0_9allocatorIS2_EEEE(i8, i7);
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i3 = i2 + -32 | 0;
     HEAP32[i5 >> 2] = i3;
     i4 = i2 + -20 | 0;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i4 >> 2] = 0;
      i2 = HEAP32[i5 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 } else {
  i2 = i8 + 56 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 425167 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i2, 0); else {
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
 }
 i3 = i8 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1047713 | 0, i6, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd4sortINS_23PxcSolverConstraintDescENS_14ConstraintLessENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j(i13, i3, i12, i1, i5) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 8 | 0;
 i15 = i16;
 i2 = i5 << 2;
 i10 = i2 >>> 0 > 1024;
 i14 = i15 + 4 | 0;
 HEAP8[i14 >> 0] = i10 & 1;
 if (i10) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i16 + 40 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i15 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i15 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i8 = 0;
  i4 = 0;
  i10 = i5;
  L7 : while (1) {
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[(HEAP32[i13 + (i6 << 5) + 16 >> 2] | 0) + 56 >> 2] | 0) >>> 0 > (HEAP32[(HEAP32[i13 + (i5 << 5) + 16 >> 2] | 0) + 56 >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i6 = i13 + (i5 << 5) | 0;
       i9 = i13 + (i7 << 5) | 0;
       HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
       HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
       HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
       HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
       HEAP32[i11 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
       HEAP32[i11 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
       HEAP32[i11 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
       HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
       HEAP32[i6 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
       HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
       HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
       HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
       HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
       HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
       HEAP32[i9 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
       HEAP32[i9 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i9 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i9 << 2) >> 2] | 0;
    i8 = i9;
   }
   i9 = __ZN5physx6shdfnd8internal9partitionINS_23PxcSolverConstraintDescEKNS_14ConstraintLessEEEiPT_iiRT0_(i13, i4, i3, i12) | 0;
   if ((i9 - i4 | 0) < (i3 - i9 | 0)) {
    i7 = i9 + -1 | 0;
    if (i8 >>> 0 < (i10 + -1 | 0) >>> 0) i5 = i10; else {
     i5 = i10 << 3;
     if (!i5) i6 = 0; else {
      i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i18 = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i18 | 0, i17 | 0, i5 | 0, (i6 ? gb + 720921 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i10 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i7;
    i4 = i9 + 1 | 0;
   } else {
    i7 = i9 + 1 | 0;
    if (i8 >>> 0 < (i10 + -1 | 0) >>> 0) i5 = i10; else {
     i5 = i10 << 3;
     if (!i5) i6 = 0; else {
      i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i17 = HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i17 | 0, i18 | 0, i5 | 0, (i6 ? gb + 720921 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i10 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i7;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i9 + -1 | 0;
   }
   i8 = i8 + 2 | 0;
   i10 = i5;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i18 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i14 >> 0] | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i15, HEAP32[i15 >> 2] | 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx6shdfnd12PxRingBuffer15MultiPartPacket7processEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = i17 + 36 | 0;
 if (!(HEAP8[i12 >> 0] | 0)) {
  i9 = HEAP32[i17 + 4 >> 2] | 0;
  if (((HEAP32[i9 + 24 >> 2] | 0) + 8 | 0) >>> 0 < 16) {
   i17 = i17 + 32 | 0;
   i17 = HEAP32[i17 >> 2] | 0;
   return i17 | 0;
  }
  i11 = i9 + 16 | 0;
  i10 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  i2 = HEAP32[HEAP32[i9 + 20 >> 2] >> 2] | 0;
  i3 = i2 >>> 0 > i10 >>> 0;
  do if (i3) if ((i2 - i10 | 0) >>> 0 > 16) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   break;
  } else {
   i17 = i17 + 32 | 0;
   i17 = HEAP32[i17 >> 2] | 0;
   return i17 | 0;
  } else {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   i15 = i1 - i10 | 0;
   if ((i15 >>> 0 > i2 >>> 0 ? i15 : i2) >>> 0 <= 16) {
    i17 = i17 + 32 | 0;
    i17 = HEAP32[i17 >> 2] | 0;
    return i17 | 0;
   }
  } while (0);
  i5 = i10 + 16 | 0;
  i6 = (i1 - i5 | 0) >>> 0 < 17;
  if ((i2 | 0) == 0 & (i1 >>> 0 >= i5 >>> 0 & i6)) {
   i17 = i17 + 32 | 0;
   i17 = HEAP32[i17 >> 2] | 0;
   return i17 | 0;
  }
  i7 = HEAP32[i17 + 8 >> 2] | 0;
  i8 = HEAP32[i17 + 24 >> 2] | 0;
  if (i3) if ((i2 - i10 | 0) >>> 0 > 16) i16 = 11; else i1 = 3; else {
   i15 = i1 - i10 | 0;
   if ((i15 >>> 0 > i2 >>> 0 ? i15 : i2) >>> 0 > 16) i16 = 11; else i1 = 3;
  }
  if ((i16 | 0) == 11) {
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = i3 + i10 | 0;
   i2 = i9 + 4 | 0;
   if (i1 >>> 0 < i5 >>> 0) {
    HEAP32[i4 >> 2] = i1 - i10;
    HEAP32[i3 + (i10 + 4) >> 2] = -2147483647;
    HEAP32[i3 >> 2] = 16;
    i1 = (i1 + -16 | 0) >>> 0 < 17;
    HEAP32[i3 + 4 >> 2] = i1 ? -2147483646 : 2;
    i16 = i3 + 8 | 0;
    HEAP8[i16 >> 0] = i7;
    HEAP8[i16 + 1 >> 0] = i7 >> 8;
    HEAP8[i16 + 2 >> 0] = i7 >> 16;
    HEAP8[i16 + 3 >> 0] = i7 >> 24;
    i16 = i3 + 12 | 0;
    HEAP8[i16 >> 0] = i8;
    HEAP8[i16 + 1 >> 0] = i8 >> 8;
    HEAP8[i16 + 2 >> 0] = i8 >> 16;
    HEAP8[i16 + 3 >> 0] = i8 >> 24;
    i1 = i1 | (HEAP32[i2 >> 2] | 0) >>> 0 < 17 ? 0 : 16;
   } else {
    HEAP32[i4 >> 2] = 16;
    HEAP32[i3 + (i10 + 4) >> 2] = i6 ? -2147483646 : 2;
    i1 = i3 + (i10 + 8) | 0;
    HEAP8[i1 >> 0] = i7;
    HEAP8[i1 + 1 >> 0] = i7 >> 8;
    HEAP8[i1 + 2 >> 0] = i7 >> 16;
    HEAP8[i1 + 3 >> 0] = i7 >> 24;
    i1 = i3 + (i10 + 12) | 0;
    HEAP8[i1 >> 0] = i8;
    HEAP8[i1 + 1 >> 0] = i8 >> 8;
    HEAP8[i1 + 2 >> 0] = i8 >> 16;
    HEAP8[i1 + 3 >> 0] = i8 >> 24;
    i1 = i6 | i5 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0 ? 0 : i5;
   }
   HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
   i1 = 0;
  }
  HEAP32[i17 + 32 >> 2] = i1;
  HEAP8[i12 >> 0] = 1;
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 i14 = i17 + 16 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 if (!i3) {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 i15 = i17 + 24 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i13 = HEAP32[i17 + 12 >> 2] | 0;
 i13 = i2 >>> 0 > i13 >>> 0 ? i13 : i2;
 i7 = HEAP32[i17 + 4 >> 2] | 0;
 i10 = i13 + 8 | 0;
 if (i10 >>> 0 > ((HEAP32[i7 + 24 >> 2] | 0) + 8 | 0) >>> 0) {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 i12 = i7 + 16 | 0;
 i11 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i4 = HEAP32[HEAP32[i7 + 20 >> 2] >> 2] | 0;
 i5 = i4 >>> 0 > i11 >>> 0;
 do if (i5) if (i10 >>> 0 < (i4 - i11 | 0) >>> 0) {
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  break;
 } else {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 } else {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1 - i11 | 0;
  if (i10 >>> 0 < (i9 >>> 0 > i4 >>> 0 ? i9 : i4) >>> 0) i6 = i1; else {
   i17 = i17 + 32 | 0;
   i17 = HEAP32[i17 >> 2] | 0;
   return i17 | 0;
  }
 } while (0);
 i8 = i11 + i10 | 0;
 i9 = (i6 - i8 | 0) >>> 0 < 17;
 if ((i4 | 0) == 0 & (i6 >>> 0 >= i8 >>> 0 & i9)) {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 if (i5) if (i10 >>> 0 < (i4 - i11 | 0) >>> 0) i16 = 26; else i4 = 3; else {
  i5 = i6 - i11 | 0;
  if (i10 >>> 0 < (i5 >>> 0 > i4 >>> 0 ? i5 : i4) >>> 0) i16 = 26; else i4 = 3;
 }
 if ((i16 | 0) == 26) {
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = i2 + i11 | 0;
  i1 = i7 + 4 | 0;
  if (i6 >>> 0 < i8 >>> 0) {
   HEAP32[i4 >> 2] = i6 - i11;
   HEAP32[i2 + (i11 + 4) >> 2] = -2147483647;
   HEAP32[i2 >> 2] = i10;
   i16 = (i6 - i10 | 0) >>> 0 < 17;
   HEAP32[i2 + 4 >> 2] = i16 ? -2147483645 : 3;
   _memcpy(i2 + 8 | 0, i3 | 0, i13 | 0) | 0;
   i1 = i16 | (HEAP32[i1 >> 2] | 0) >>> 0 <= i10 >>> 0 ? 0 : i10;
  } else {
   HEAP32[i4 >> 2] = i10;
   HEAP32[i2 + (i11 + 4) >> 2] = i9 ? -2147483645 : 3;
   _memcpy(i2 + (i11 + 8) | 0, i3 | 0, i13 | 0) | 0;
   i1 = i9 | i8 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0 ? 0 : i8;
  }
  HEAP32[HEAP32[i12 >> 2] >> 2] = i1;
  i4 = 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 }
 i1 = i17 + 32 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i14 >> 2] = i3 + i13;
 HEAP32[i15 >> 2] = i2 - i13;
 if ((i2 | 0) != (i13 | 0)) {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 HEAP32[i14 >> 2] = 0;
 if (i4 | 0) {
  i17 = i17 + 32 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  return i17 | 0;
 }
 HEAP32[i1 >> 2] = 2;
 i17 = i17 + 32 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 return i17 | 0;
}

function __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 883274 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 883139 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 883092 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 883034 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 882997 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 882957 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 882926 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 882885 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 882856 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 882819 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 882757 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 882607 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 882553 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 882416 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 882316 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 882254 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 882069 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 881965 | 0;
   break;
  }
 case 92:
  {
   i1 = gb + 881830 | 0;
   break;
  }
 case 83:
  {
   i1 = gb + 881718 | 0;
   break;
  }
 case 91:
  {
   i1 = gb + 881673 | 0;
   break;
  }
 case 84:
  {
   i1 = gb + 881617 | 0;
   break;
  }
 case 85:
  {
   i1 = gb + 881547 | 0;
   break;
  }
 case 86:
  {
   i1 = gb + 881448 | 0;
   break;
  }
 case 87:
  {
   i1 = gb + 881285 | 0;
   break;
  }
 case 88:
  {
   i1 = gb + 881238 | 0;
   break;
  }
 case 90:
  {
   i1 = gb + 881153 | 0;
   break;
  }
 case 89:
  {
   i1 = gb + 881065 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 881044 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 880938 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 880904 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 880815 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 880798 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 880767 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 880732 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 880650 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 880585 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 880517 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 880486 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 880457 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 880395 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 880349 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 880288 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 880185 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 880130 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 880094 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 880043 | 0;
   break;
  }
 case 38:
  {
   i1 = gb + 879988 | 0;
   break;
  }
 case 39:
  {
   i1 = gb + 879905 | 0;
   break;
  }
 case 40:
  {
   i1 = gb + 879853 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 879791 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 879722 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 879689 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 879565 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 879511 | 0;
   break;
  }
 case 95:
  {
   i1 = gb + 879453 | 0;
   break;
  }
 case 94:
  {
   i1 = gb + 879405 | 0;
   break;
  }
 case 93:
  {
   i1 = gb + 879330 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 879250 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 879170 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 879046 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 878859 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 878818 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 878723 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 878682 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 878614 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 878527 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 878411 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 878372 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 878239 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 878124 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 878024 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 877989 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 877891 | 0;
   break;
  }
 case 62:
  {
   i1 = gb + 877796 | 0;
   break;
  }
 case 63:
  {
   i1 = gb + 877741 | 0;
   break;
  }
 case 64:
  {
   i1 = gb + 877676 | 0;
   break;
  }
 case 65:
  {
   i1 = gb + 877612 | 0;
   break;
  }
 case 66:
  {
   i1 = gb + 877549 | 0;
   break;
  }
 case 67:
  {
   i1 = gb + 877423 | 0;
   break;
  }
 case 68:
  {
   i1 = gb + 877308 | 0;
   break;
  }
 case 69:
  {
   i1 = gb + 877197 | 0;
   break;
  }
 case 70:
  {
   i1 = gb + 877136 | 0;
   break;
  }
 case 71:
  {
   i1 = gb + 876992 | 0;
   break;
  }
 case 75:
  {
   i1 = gb + 876711 | 0;
   break;
  }
 case 72:
  {
   i1 = gb + 876565 | 0;
   break;
  }
 case 73:
  {
   i1 = gb + 876446 | 0;
   break;
  }
 case 74:
  {
   i1 = gb + 876315 | 0;
   break;
  }
 case 76:
  {
   i1 = gb + 876255 | 0;
   break;
  }
 case 77:
  {
   i1 = gb + 876103 | 0;
   break;
  }
 case 78:
  {
   i1 = gb + 876024 | 0;
   break;
  }
 case 79:
  {
   i1 = gb + 875945 | 0;
   break;
  }
 case 80:
  {
   i1 = gb + 875837 | 0;
   break;
  }
 case 81:
  {
   i1 = gb + 875793 | 0;
   break;
  }
 case 82:
  {
   i1 = gb + 875735 | 0;
   break;
  }
 case 0:
  {
   i1 = gb + 859847 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 return i1 | 0;
}

function __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 883274 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 883139 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 883092 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 883034 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 882997 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 882957 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 882926 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 882885 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 882856 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 882819 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 882757 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 882607 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 882553 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 882416 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 882316 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 882254 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 882069 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 881965 | 0;
   break;
  }
 case 92:
  {
   i1 = gb + 881830 | 0;
   break;
  }
 case 83:
  {
   i1 = gb + 881718 | 0;
   break;
  }
 case 91:
  {
   i1 = gb + 881673 | 0;
   break;
  }
 case 84:
  {
   i1 = gb + 881617 | 0;
   break;
  }
 case 85:
  {
   i1 = gb + 881547 | 0;
   break;
  }
 case 86:
  {
   i1 = gb + 881448 | 0;
   break;
  }
 case 87:
  {
   i1 = gb + 881285 | 0;
   break;
  }
 case 88:
  {
   i1 = gb + 881238 | 0;
   break;
  }
 case 90:
  {
   i1 = gb + 881153 | 0;
   break;
  }
 case 89:
  {
   i1 = gb + 881065 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 881044 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 880938 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 880904 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 880815 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 880798 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 880767 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 880732 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 880650 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 880585 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 880517 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 880486 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 880457 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 880395 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 880349 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 880288 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 880185 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 880130 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 880094 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 880043 | 0;
   break;
  }
 case 38:
  {
   i1 = gb + 879988 | 0;
   break;
  }
 case 39:
  {
   i1 = gb + 879905 | 0;
   break;
  }
 case 40:
  {
   i1 = gb + 879853 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 879791 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 879722 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 879689 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 879565 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 879511 | 0;
   break;
  }
 case 95:
  {
   i1 = gb + 879453 | 0;
   break;
  }
 case 94:
  {
   i1 = gb + 879405 | 0;
   break;
  }
 case 93:
  {
   i1 = gb + 879330 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 879250 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 879170 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 879046 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 878859 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 878818 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 878723 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 878682 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 878614 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 878527 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 878411 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 878372 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 878239 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 878124 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 878024 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 877989 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 877891 | 0;
   break;
  }
 case 62:
  {
   i1 = gb + 877796 | 0;
   break;
  }
 case 63:
  {
   i1 = gb + 877741 | 0;
   break;
  }
 case 64:
  {
   i1 = gb + 877676 | 0;
   break;
  }
 case 65:
  {
   i1 = gb + 877612 | 0;
   break;
  }
 case 66:
  {
   i1 = gb + 877549 | 0;
   break;
  }
 case 67:
  {
   i1 = gb + 877423 | 0;
   break;
  }
 case 68:
  {
   i1 = gb + 877308 | 0;
   break;
  }
 case 69:
  {
   i1 = gb + 877197 | 0;
   break;
  }
 case 70:
  {
   i1 = gb + 877136 | 0;
   break;
  }
 case 71:
  {
   i1 = gb + 876992 | 0;
   break;
  }
 case 75:
  {
   i1 = gb + 876711 | 0;
   break;
  }
 case 72:
  {
   i1 = gb + 876565 | 0;
   break;
  }
 case 73:
  {
   i1 = gb + 876446 | 0;
   break;
  }
 case 74:
  {
   i1 = gb + 876315 | 0;
   break;
  }
 case 76:
  {
   i1 = gb + 876255 | 0;
   break;
  }
 case 77:
  {
   i1 = gb + 876103 | 0;
   break;
  }
 case 78:
  {
   i1 = gb + 876024 | 0;
   break;
  }
 case 79:
  {
   i1 = gb + 875945 | 0;
   break;
  }
 case 80:
  {
   i1 = gb + 875837 | 0;
   break;
  }
 case 81:
  {
   i1 = gb + 875793 | 0;
   break;
  }
 case 82:
  {
   i1 = gb + 875735 | 0;
   break;
  }
 case 0:
  {
   i1 = gb + 859847 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 return i1 | 0;
}

function _try_realloc_chunk(i14, i11) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i14 + 4 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = i13 & -8;
 i8 = i14 + i1 | 0;
 i6 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
 i2 = i13 & 3;
 if (!((i2 | 0) != 1 & i14 >>> 0 >= i6 >>> 0 & i14 >>> 0 < i8 >>> 0)) _abort();
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 if (!(i3 & 1)) _abort();
 if (!i2) {
  if (i11 >>> 0 < 256) {
   i14 = 0;
   return i14 | 0;
  }
  if (i1 >>> 0 >= (i11 + 4 | 0) >>> 0) if ((i1 - i11 | 0) >>> 0 <= HEAP32[gb + 1470876 + 8 >> 2] << 1 >>> 0) return i14 | 0;
  i14 = 0;
  return i14 | 0;
 }
 if (i1 >>> 0 >= i11 >>> 0) {
  i1 = i1 - i11 | 0;
  if (i1 >>> 0 <= 15) return i14 | 0;
  i10 = i14 + i11 | 0;
  HEAP32[i12 >> 2] = i13 & 1 | i11 | 2;
  HEAP32[i10 + 4 >> 2] = i1 | 3;
  i13 = i10 + i1 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
  _dispose_chunk(i10, i1);
  return i14 | 0;
 }
 if ((i8 | 0) == (HEAP32[gb + 1470404 + 24 >> 2] | 0)) {
  i1 = (HEAP32[gb + 1470404 + 12 >> 2] | 0) + i1 | 0;
  if (i1 >>> 0 <= i11 >>> 0) {
   i14 = 0;
   return i14 | 0;
  }
  i10 = i1 - i11 | 0;
  i9 = i14 + i11 | 0;
  HEAP32[i12 >> 2] = i13 & 1 | i11 | 2;
  HEAP32[i9 + 4 >> 2] = i10 | 1;
  HEAP32[gb + 1470404 + 24 >> 2] = i9;
  HEAP32[gb + 1470404 + 12 >> 2] = i10;
  return i14 | 0;
 }
 if ((i8 | 0) == (HEAP32[gb + 1470404 + 20 >> 2] | 0)) {
  i2 = (HEAP32[gb + 1470404 + 8 >> 2] | 0) + i1 | 0;
  if (i2 >>> 0 < i11 >>> 0) {
   i14 = 0;
   return i14 | 0;
  }
  i1 = i2 - i11 | 0;
  if (i1 >>> 0 > 15) {
   i2 = i14 + i11 | 0;
   i10 = i2 + i1 | 0;
   HEAP32[i12 >> 2] = i13 & 1 | i11 | 2;
   HEAP32[i2 + 4 >> 2] = i1 | 1;
   HEAP32[i10 >> 2] = i1;
   i13 = i10 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & -2;
  } else {
   HEAP32[i12 >> 2] = i13 & 1 | i2 | 2;
   i2 = i14 + i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
   i2 = 0;
   i1 = 0;
  }
  HEAP32[gb + 1470404 + 8 >> 2] = i1;
  HEAP32[gb + 1470404 + 20 >> 2] = i2;
  return i14 | 0;
 }
 if (i3 & 2 | 0) {
  i14 = 0;
  return i14 | 0;
 }
 i9 = (i3 & -8) + i1 | 0;
 if (i9 >>> 0 < i11 >>> 0) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i9 - i11 | 0;
 i4 = i3 >>> 3;
 do if (i3 >>> 0 < 256) {
  i2 = HEAP32[i8 + 8 >> 2] | 0;
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  i1 = gb + 1470404 + 40 + (i4 << 1 << 2) | 0;
  if ((i2 | 0) != (i1 | 0)) {
   if (i2 >>> 0 < i6 >>> 0) _abort();
   if ((HEAP32[i2 + 12 >> 2] | 0) != (i8 | 0)) _abort();
  }
  if ((i3 | 0) == (i2 | 0)) {
   HEAP32[gb + 1470404 >> 2] = HEAP32[gb + 1470404 >> 2] & ~(1 << i4);
   break;
  }
  if ((i3 | 0) == (i1 | 0)) i5 = i3 + 8 | 0; else {
   if (i3 >>> 0 < i6 >>> 0) _abort();
   i1 = i3 + 8 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) i5 = i1; else _abort();
  }
  HEAP32[i2 + 12 >> 2] = i3;
  HEAP32[i5 >> 2] = i2;
 } else {
  i5 = HEAP32[i8 + 24 >> 2] | 0;
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  do if ((i3 | 0) == (i8 | 0)) {
   i3 = i8 + 16 | 0;
   i2 = i3 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i7 = 0;
     break;
    } else i2 = i3;
   }
   while (1) {
    i3 = i1 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i1 = i4;
     i2 = i3;
     continue;
    }
    i3 = i1 + 16 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) break; else {
     i1 = i4;
     i2 = i3;
    }
   }
   if (i2 >>> 0 < i6 >>> 0) _abort(); else {
    HEAP32[i2 >> 2] = 0;
    i7 = i1;
    break;
   }
  } else {
   i4 = HEAP32[i8 + 8 >> 2] | 0;
   if (i4 >>> 0 < i6 >>> 0) _abort();
   i1 = i4 + 12 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i8 | 0)) _abort();
   i2 = i3 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i2 >> 2] = i4;
    i7 = i3;
    break;
   } else _abort();
  } while (0);
  if (i5 | 0) {
   i1 = HEAP32[i8 + 28 >> 2] | 0;
   i2 = gb + 1470404 + 304 + (i1 << 2) | 0;
   if ((i8 | 0) == (HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = i7;
    if (!i7) {
     HEAP32[gb + 1470404 + 4 >> 2] = HEAP32[gb + 1470404 + 4 >> 2] & ~(1 << i1);
     break;
    }
   } else {
    if (i5 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort();
    i1 = i5 + 16 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) HEAP32[i1 >> 2] = i7; else HEAP32[i5 + 20 >> 2] = i7;
    if (!i7) break;
   }
   i3 = HEAP32[gb + 1470404 + 16 >> 2] | 0;
   if (i7 >>> 0 < i3 >>> 0) _abort();
   HEAP32[i7 + 24 >> 2] = i5;
   i1 = i8 + 16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2 | 0) if (i2 >>> 0 < i3 >>> 0) _abort(); else {
    HEAP32[i7 + 16 >> 2] = i2;
    HEAP32[i2 + 24 >> 2] = i7;
    break;
   } while (0);
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) if (i1 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) _abort(); else {
    HEAP32[i7 + 20 >> 2] = i1;
    HEAP32[i1 + 24 >> 2] = i7;
    break;
   }
  }
 } while (0);
 if (i10 >>> 0 < 16) {
  HEAP32[i12 >> 2] = i9 | i13 & 1 | 2;
  i13 = i14 + i9 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
  return i14 | 0;
 } else {
  i9 = i14 + i11 | 0;
  HEAP32[i12 >> 2] = i13 & 1 | i11 | 2;
  HEAP32[i9 + 4 >> 2] = i10 | 3;
  i13 = i9 + i10 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
  _dispose_chunk(i9, i10);
  return i14 | 0;
 }
 return 0;
}

function __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f11 = f0, f12 = f0, f13 = f0;
 i1 = HEAP32[i8 + 1116 >> 2] | 0;
 if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i8 + 1120 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i8 + 1124 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 HEAPF32[i10 >> 2] = f6;
 HEAPF32[i10 + 4 >> 2] = f5;
 HEAPF32[i10 + 8 >> 2] = f3;
 i1 = HEAP32[i8 + 1128 >> 2] | 0;
 if ((i1 | 0) == -1) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i8 + 1132 >> 2] | 0;
 if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i8 + 1136 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i8 + 1140 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(1.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
 f11 = Math_fround(f6 * f12);
 f5 = Math_fround(f5 * f12);
 f6 = Math_fround(f3 * f12);
 HEAPF32[i10 + 12 >> 2] = Math_fround(f7 * f12);
 HEAPF32[i10 + 16 >> 2] = f11;
 HEAPF32[i10 + 20 >> 2] = f5;
 HEAPF32[i10 + 24 >> 2] = f6;
 HEAP32[i10 + 28 >> 2] = 1065353216;
 HEAP32[i10 + 32 >> 2] = 1065353216;
 HEAP32[i10 + 36 >> 2] = 1065353216;
 i2 = 0;
 i4 = 14;
 while (1) {
  i1 = HEAP32[i8 + 1088 + (i4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  HEAPF32[i10 + 68 + (i2 << 6) >> 2] = f6;
  HEAPF32[i10 + 68 + (i2 << 6) + 4 >> 2] = f5;
  HEAPF32[i10 + 68 + (i2 << 6) + 8 >> 2] = f3;
  i1 = HEAP32[i8 + 1088 + (i4 + 3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f7 = Math_fround(0.0); else f7 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 5 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 6 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(1.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
  f6 = Math_fround(f6 * f13);
  f11 = Math_fround(f5 * f13);
  f12 = Math_fround(f3 * f13);
  HEAPF32[i10 + 68 + (i2 << 6) + 12 >> 2] = Math_fround(f7 * f13);
  HEAPF32[i10 + 68 + (i2 << 6) + 16 >> 2] = f6;
  HEAPF32[i10 + 68 + (i2 << 6) + 20 >> 2] = f11;
  HEAPF32[i10 + 68 + (i2 << 6) + 24 >> 2] = f12;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 4) {
   i1 = 0;
   i2 = 42;
   break;
  } else i4 = i4 + 7 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 596 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 596 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 2) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 52) {
   i1 = 0;
   i2 = 94;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 364 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 364 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 2) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 20) {
   i1 = 0;
   i2 = 114;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i4 = HEAP32[i8 + 1088 + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) == -1) HEAPF32[i10 + 500 + (i1 << 2) >> 2] = Math_fround(0.0); else HEAP32[i10 + 500 + (i1 << 2) >> 2] = HEAP32[i9 + (i4 << 2) >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 20) {
   i2 = 0;
   i4 = 134;
   break;
  } else i2 = i2 + 1 | 0;
 }
 while (1) {
  i1 = HEAP32[i8 + 1088 + (i4 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f6 = Math_fround(0.0); else f6 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  i1 = HEAP32[i8 + 1088 + (i4 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
  HEAPF32[i10 + 804 + (i2 * 12 | 0) >> 2] = f6;
  HEAPF32[i10 + 804 + (i2 * 12 | 0) + 4 >> 2] = f5;
  HEAPF32[i10 + 804 + (i2 * 12 | 0) + 8 >> 2] = f3;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 7) break; else i4 = i4 + 3 | 0;
 }
 return;
}

function __ZN11AudioSource4StopEb(i13, i2) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 32 | 0;
 i10 = i15 + 16 | 0;
 i8 = i15;
 i11 = i15 + 64 | 0;
 i9 = i15 + 60 | 0;
 i14 = i15 + 48 | 0;
 HEAP8[i13 + 498 >> 0] = 0;
 HEAP8[i13 + 499 >> 0] = 0;
 i3 = i13 + 456 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (i1 | 0) {
  if (HEAP32[i1 + 16 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   __ZN20SoundChannelInstance4StopEv(i1);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) break;
  }
  HEAP32[i1 + 16 >> 2] = 0;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 } while (0);
 if (i2) {
  i6 = i13 + 428 | 0;
  i3 = i13 + 432 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i1;
  if ((i1 | 0) == (i6 | 0)) {
   i1 = i4;
   i5 = 0;
  } else {
   i2 = 0;
   do {
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   } while ((i1 | 0) != (i6 | 0));
   if ((i2 | 0) < 1) {
    i1 = i4;
    i5 = 0;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, gb + 64016 | 0, 0, gb + 883367 | 0, 463) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
   }
  }
  i2 = i1;
  if ((i2 | 0) != (i6 | 0)) {
   i4 = 0;
   do {
    i3 = (HEAP32[i1 + 8 >> 2] | 0) + 12 | 0;
    L25 : do if ((i4 | 0) > 0) {
     i1 = 0;
     while (1) {
      if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break L25;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= (i4 | 0)) {
       i7 = 24;
       break;
      }
     }
    } else i7 = 24; while (0);
    if ((i7 | 0) == 24) {
     i7 = 0;
     HEAP32[i5 + (i4 << 2) >> 2] = i3;
     i4 = i4 + 1 | 0;
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i6 | 0));
   if ((i4 | 0) > 0) {
    i2 = 0;
    do {
     i1 = HEAP32[HEAP32[i5 + (i2 << 2) >> 2] >> 2] | 0;
     if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
     __ZN20SoundChannelInstance4StopEv(i1);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i4 | 0));
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 64016 | 0);
 }
 i2 = i13 + 536 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD3DSP6removeEv(i1) | 0;
  if (i1 | 0) {
   i7 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i8 >> 2] = gb + 855390;
   HEAP32[i8 + 4 >> 2] = 725;
   HEAP32[i8 + 8 >> 2] = gb + 855460;
   HEAP32[i8 + 12 >> 2] = i7;
   __Z6FormatPKcz(i11, gb + 883334 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
 }
 HEAP32[i9 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD3DSP11getUserDataEPPv(i1, i9) | 0;
  if (i1 | 0) {
   i8 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i10 >> 2] = gb + 855390;
   HEAP32[i10 + 4 >> 2] = 729;
   HEAP32[i10 + 8 >> 2] = gb + 855483;
   HEAP32[i10 + 12 >> 2] = i8;
   __Z6FormatPKcz(i11, gb + 883334 | 0, i10);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 16 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 if ((HEAP32[i13 + 432 >> 2] | 0) != (i13 + 428 | 0)) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i14 >> 2] = 0;
 i5 = i14 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 if (__ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb(i13, i14, 0) | 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) != (HEAP32[i5 >> 2] | 0)) {
   i4 = i11 + 11 | 0;
   i3 = i1;
   while (1) {
    i1 = __ZN4FMOD3DSP6removeEv(HEAP32[i3 >> 2] | 0) | 0;
    if (i1 | 0) {
     i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
     HEAP32[i12 >> 2] = gb + 855390;
     HEAP32[i12 + 4 >> 2] = 744;
     HEAP32[i12 + 8 >> 2] = gb + 855766;
     HEAP32[i12 + 12 >> 2] = i10;
     __Z6FormatPKcz(i11, gb + 883334 | 0, i12);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    }
    i2 = i3 + 4 | 0;
    if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) break; else i3 = i2;
   }
   i1 = HEAP32[i14 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i3 - i1 | 0) >>> 2) << 2);
  }
 }
 __ZN12AudioManager17RemoveAudioSourceEP11AudioSource(__Z15GetAudioManagerv() | 0, i13);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 883274 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 883139 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 883092 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 883034 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 882997 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 882957 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 882926 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 882885 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 882856 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 882819 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 882757 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 882607 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 882553 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 882416 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 882316 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 882254 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 882069 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 881965 | 0;
   break;
  }
 case 92:
  {
   i1 = gb + 881830 | 0;
   break;
  }
 case 83:
  {
   i1 = gb + 881718 | 0;
   break;
  }
 case 91:
  {
   i1 = gb + 881673 | 0;
   break;
  }
 case 84:
  {
   i1 = gb + 881617 | 0;
   break;
  }
 case 85:
  {
   i1 = gb + 881547 | 0;
   break;
  }
 case 86:
  {
   i1 = gb + 881448 | 0;
   break;
  }
 case 87:
  {
   i1 = gb + 881285 | 0;
   break;
  }
 case 88:
  {
   i1 = gb + 881238 | 0;
   break;
  }
 case 90:
  {
   i1 = gb + 881153 | 0;
   break;
  }
 case 89:
  {
   i1 = gb + 881065 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 881044 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 880938 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 880904 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 880815 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 880798 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 880767 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 880732 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 880650 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 880585 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 880517 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 880486 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 880457 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 880395 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 880349 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 880288 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 880185 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 880130 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 880094 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 880043 | 0;
   break;
  }
 case 38:
  {
   i1 = gb + 879988 | 0;
   break;
  }
 case 39:
  {
   i1 = gb + 879905 | 0;
   break;
  }
 case 40:
  {
   i1 = gb + 879853 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 879791 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 879722 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 879689 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 879565 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 879511 | 0;
   break;
  }
 case 95:
  {
   i1 = gb + 879453 | 0;
   break;
  }
 case 94:
  {
   i1 = gb + 879405 | 0;
   break;
  }
 case 93:
  {
   i1 = gb + 879330 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 879250 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 879170 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 879046 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 878859 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 878818 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 878723 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 878682 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 878614 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 878527 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 878411 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 878372 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 878239 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 878124 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 878024 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 877989 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 877891 | 0;
   break;
  }
 case 62:
  {
   i1 = gb + 877796 | 0;
   break;
  }
 case 63:
  {
   i1 = gb + 877741 | 0;
   break;
  }
 case 64:
  {
   i1 = gb + 877676 | 0;
   break;
  }
 case 65:
  {
   i1 = gb + 877612 | 0;
   break;
  }
 case 66:
  {
   i1 = gb + 877549 | 0;
   break;
  }
 case 67:
  {
   i1 = gb + 877423 | 0;
   break;
  }
 case 68:
  {
   i1 = gb + 877308 | 0;
   break;
  }
 case 69:
  {
   i1 = gb + 877197 | 0;
   break;
  }
 case 70:
  {
   i1 = gb + 877136 | 0;
   break;
  }
 case 71:
  {
   i1 = gb + 876992 | 0;
   break;
  }
 case 75:
  {
   i1 = gb + 876711 | 0;
   break;
  }
 case 72:
  {
   i1 = gb + 876565 | 0;
   break;
  }
 case 73:
  {
   i1 = gb + 876446 | 0;
   break;
  }
 case 74:
  {
   i1 = gb + 876315 | 0;
   break;
  }
 case 76:
  {
   i1 = gb + 876255 | 0;
   break;
  }
 case 77:
  {
   i1 = gb + 876103 | 0;
   break;
  }
 case 78:
  {
   i1 = gb + 876024 | 0;
   break;
  }
 case 79:
  {
   i1 = gb + 875945 | 0;
   break;
  }
 case 80:
  {
   i1 = gb + 875837 | 0;
   break;
  }
 case 81:
  {
   i1 = gb + 875793 | 0;
   break;
  }
 case 82:
  {
   i1 = gb + 875735 | 0;
   break;
  }
 case 0:
  {
   i1 = gb + 859847 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 return i1 | 0;
}

function __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i8);
 __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 80 | 0, i8);
 i12 = i8 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i9 = i8 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 8);
  i6 = i11 + 4 | 0;
  i1 = i11;
  i4 = i6;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i6 = i1;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i6;
  HEAP32[i12 >> 2] = i2;
  i1 = i11;
  i4 = i11 + 4 | 0;
 }
 i7 = _llvm_bswap_i32(i5 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i6 | 0) | 0;
 HEAP32[i4 >> 2] = i7;
 i6 = i11;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i10 + 192 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i12 >> 2] = i1;
 }
 HEAP32[i10 + 156 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
 }
 HEAP32[i10 + 164 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 8 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 8);
  i6 = i11 + 4 | 0;
  i2 = i11;
  i4 = i6;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i6 = i2;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = i11;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i12 >> 2] = i1;
  i2 = i11;
  i4 = i11 + 4 | 0;
  i7 = i1;
 }
 i5 = _llvm_bswap_i32(i5 | 0) | 0;
 HEAP32[i2 >> 2] = _llvm_bswap_i32(i6 | 0) | 0;
 HEAP32[i4 >> 2] = i5;
 i5 = i11;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i10 + 200 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i7 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 1);
  i1 = HEAP8[i11 >> 0] | 0;
 } else {
  i7 = HEAP8[i7 >> 0] | 0;
  HEAP8[i11 >> 0] = i7;
  HEAP32[i12 >> 2] = i1;
  i1 = i7;
 }
 HEAP8[i10 + 180 >> 0] = i1;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 1);
  i1 = HEAP8[i11 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i11 >> 0] = i1;
  HEAP32[i12 >> 2] = i2;
 }
 HEAP8[i10 + 181 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 }
 HEAP32[i10 + 184 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i12 >> 2] = i1;
  i1 = i7;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i10 + 176 >> 2] = i1 >>> 0 > 3 ? 0 : i1;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 32 | 0, i8);
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i8, i10 + 104 | 0, gb + 431911 | 0, 0);
 __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 128 | 0, i8);
 __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 88 | 0, i8);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i10 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i10 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i11, 4);
  i12 = HEAP32[i11 >> 2] | 0;
  i12 = _llvm_bswap_i32(i12 | 0) | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 } else {
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i12 >> 2] = i2;
  i12 = i10;
  i12 = _llvm_bswap_i32(i12 | 0) | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 }
}

function __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_(i10, i11, i12, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f14 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i11 + 28 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i10 + 28 | 0;
 i4 = f14 < Math_fround(HEAPF32[i8 >> 2]);
 i5 = i12 + 28 | 0;
 i1 = Math_fround(HEAPF32[i5 >> 2]) < f14;
 do if (i4) {
  if (i1) {
   i2 = i6;
   i3 = i10;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i10;
   i3 = i12;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i12;
   i3 = i6;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i1 = 1;
   break;
  }
  i2 = i6;
  i3 = i10;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i10;
  i3 = i11;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i11;
  i3 = i6;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  f14 = Math_fround(HEAPF32[i5 >> 2]);
  if (f14 < Math_fround(HEAPF32[i7 >> 2])) {
   i2 = i6;
   i3 = i11;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i11;
   i3 = i12;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i12;
   i3 = i6;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  i2 = i6;
  i3 = i11;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i11;
  i3 = i12;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i12;
  i3 = i6;
  i4 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  f14 = Math_fround(HEAPF32[i7 >> 2]);
  if (f14 < Math_fround(HEAPF32[i8 >> 2])) {
   i2 = i6;
   i3 = i10;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i10;
   i3 = i11;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i2 = i11;
   i3 = i6;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 f14 = Math_fround(HEAPF32[i13 + 28 >> 2]);
 if (!(f14 < Math_fround(HEAPF32[i5 >> 2]))) {
  i13 = i1;
  STACKTOP = i9;
  return i13 | 0;
 }
 i2 = i6;
 i3 = i12;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i12;
 i3 = i13;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i13;
 i3 = i6;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 if (!(f14 < Math_fround(HEAPF32[i7 >> 2]))) {
  i13 = i1 + 1 | 0;
  STACKTOP = i9;
  return i13 | 0;
 }
 i2 = i6;
 i3 = i11;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i11;
 i3 = i12;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i12;
 i3 = i6;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f14 < Math_fround(HEAPF32[i8 >> 2]))) {
  i13 = i1 + 2 | 0;
  STACKTOP = i9;
  return i13 | 0;
 }
 i2 = i6;
 i3 = i10;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i10;
 i3 = i11;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i11;
 i3 = i6;
 i4 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i13 = i1 + 3 | 0;
 STACKTOP = i9;
 return i13 | 0;
}

function __ZL16FMOD_ErrorString11FMOD_RESULT(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 883274 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 883139 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 883092 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 883034 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 882997 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 882957 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 882926 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 882885 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 882856 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 882819 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 882757 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 882607 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 882553 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 882416 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 882316 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 882254 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 882069 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 881965 | 0;
   break;
  }
 case 92:
  {
   i1 = gb + 881830 | 0;
   break;
  }
 case 83:
  {
   i1 = gb + 881718 | 0;
   break;
  }
 case 91:
  {
   i1 = gb + 881673 | 0;
   break;
  }
 case 84:
  {
   i1 = gb + 881617 | 0;
   break;
  }
 case 85:
  {
   i1 = gb + 881547 | 0;
   break;
  }
 case 86:
  {
   i1 = gb + 881448 | 0;
   break;
  }
 case 87:
  {
   i1 = gb + 881285 | 0;
   break;
  }
 case 88:
  {
   i1 = gb + 881238 | 0;
   break;
  }
 case 90:
  {
   i1 = gb + 881153 | 0;
   break;
  }
 case 89:
  {
   i1 = gb + 881065 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 881044 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 880938 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 880904 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 880815 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 880798 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 880767 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 880732 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 880650 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 880585 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 880517 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 880486 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 880457 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 880395 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 880349 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 880288 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 880185 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 880130 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 880094 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 880043 | 0;
   break;
  }
 case 38:
  {
   i1 = gb + 879988 | 0;
   break;
  }
 case 39:
  {
   i1 = gb + 879905 | 0;
   break;
  }
 case 40:
  {
   i1 = gb + 879853 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 879791 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 879722 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 879689 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 879565 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 879511 | 0;
   break;
  }
 case 95:
  {
   i1 = gb + 879453 | 0;
   break;
  }
 case 94:
  {
   i1 = gb + 879405 | 0;
   break;
  }
 case 93:
  {
   i1 = gb + 879330 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 879250 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 879170 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 879046 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 878859 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 878818 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 878723 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 878682 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 878614 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 878527 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 878411 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 878372 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 878239 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 878124 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 878024 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 877989 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 877891 | 0;
   break;
  }
 case 62:
  {
   i1 = gb + 877796 | 0;
   break;
  }
 case 63:
  {
   i1 = gb + 877741 | 0;
   break;
  }
 case 64:
  {
   i1 = gb + 877676 | 0;
   break;
  }
 case 65:
  {
   i1 = gb + 877612 | 0;
   break;
  }
 case 66:
  {
   i1 = gb + 877549 | 0;
   break;
  }
 case 67:
  {
   i1 = gb + 877423 | 0;
   break;
  }
 case 68:
  {
   i1 = gb + 877308 | 0;
   break;
  }
 case 69:
  {
   i1 = gb + 877197 | 0;
   break;
  }
 case 70:
  {
   i1 = gb + 877136 | 0;
   break;
  }
 case 71:
  {
   i1 = gb + 876992 | 0;
   break;
  }
 case 75:
  {
   i1 = gb + 876711 | 0;
   break;
  }
 case 72:
  {
   i1 = gb + 876565 | 0;
   break;
  }
 case 73:
  {
   i1 = gb + 876446 | 0;
   break;
  }
 case 74:
  {
   i1 = gb + 876315 | 0;
   break;
  }
 case 76:
  {
   i1 = gb + 876255 | 0;
   break;
  }
 case 77:
  {
   i1 = gb + 876103 | 0;
   break;
  }
 case 78:
  {
   i1 = gb + 876024 | 0;
   break;
  }
 case 79:
  {
   i1 = gb + 875945 | 0;
   break;
  }
 case 80:
  {
   i1 = gb + 875837 | 0;
   break;
  }
 case 81:
  {
   i1 = gb + 875793 | 0;
   break;
  }
 case 82:
  {
   i1 = gb + 875735 | 0;
   break;
  }
 case 0:
  {
   i1 = gb + 859847 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 return i1 | 0;
}

function runPostSets85() {
 HEAP32[gb + 89012 >> 2] = fb + 898;
 HEAP32[gb + 89016 >> 2] = fb + 235;
 HEAP32[gb + 89020 >> 2] = fb + 526;
 HEAP32[gb + 89024 >> 2] = fb + 1181;
 HEAP32[gb + 89028 >> 2] = fb + 1182;
 HEAP32[gb + 89040 >> 2] = fb + 136;
 HEAP32[gb + 89044 >> 2] = fb + 236;
 HEAP32[gb + 89048 >> 2] = fb + 899;
 HEAP32[gb + 89052 >> 2] = fb + 237;
 HEAP32[gb + 89056 >> 2] = fb + 137;
 HEAP32[gb + 89060 >> 2] = fb + 238;
 HEAP32[gb + 89064 >> 2] = fb + 239;
 HEAP32[gb + 89068 >> 2] = fb + 1183;
 HEAP32[gb + 89072 >> 2] = fb + 1184;
 HEAP32[gb + 89076 >> 2] = fb + 1185;
 HEAP32[gb + 89088 >> 2] = fb + 1186;
 HEAP32[gb + 89092 >> 2] = fb + 900;
 HEAP32[gb + 89096 >> 2] = fb + 137;
 HEAP32[gb + 89100 >> 2] = fb + 72;
 HEAP32[gb + 89104 >> 2] = fb + 1187;
 HEAP32[gb + 89108 >> 2] = fb + 1188;
 HEAP32[gb + 89112 >> 2] = (HEAP32[gb + 89112 >> 2] | 0) + (gb + 669833 | 0);
 HEAP32[gb + 89116 >> 2] = (HEAP32[gb + 89116 >> 2] | 0) + (gb + 669839 | 0);
 HEAP32[gb + 89120 >> 2] = (HEAP32[gb + 89120 >> 2] | 0) + (gb + 669845 | 0);
 HEAP32[gb + 89124 >> 2] = (HEAP32[gb + 89124 >> 2] | 0) + (gb + 669853 | 0);
 HEAP32[gb + 89128 >> 2] = (HEAP32[gb + 89128 >> 2] | 0) + (gb + 669861 | 0);
 HEAP32[gb + 89132 >> 2] = (HEAP32[gb + 89132 >> 2] | 0) + (gb + 669870 | 0);
 HEAP32[gb + 89136 >> 2] = (HEAP32[gb + 89136 >> 2] | 0) + (gb + 669879 | 0);
 HEAP32[gb + 89140 >> 2] = (HEAP32[gb + 89140 >> 2] | 0) + (gb + 669883 | 0);
 HEAP32[gb + 89144 >> 2] = (HEAP32[gb + 89144 >> 2] | 0) + (gb + 669887 | 0);
 HEAP32[gb + 89148 >> 2] = (HEAP32[gb + 89148 >> 2] | 0) + (gb + 669895 | 0);
 HEAP32[gb + 89152 >> 2] = (HEAP32[gb + 89152 >> 2] | 0) + (gb + 669903 | 0);
 HEAP32[gb + 89156 >> 2] = (HEAP32[gb + 89156 >> 2] | 0) + (gb + 669907 | 0);
 HEAP32[gb + 89160 >> 2] = (HEAP32[gb + 89160 >> 2] | 0) + (gb + 669912 | 0);
 HEAP32[gb + 89164 >> 2] = (HEAP32[gb + 89164 >> 2] | 0) + (gb + 669920 | 0);
 HEAP32[gb + 89168 >> 2] = (HEAP32[gb + 89168 >> 2] | 0) + (gb + 669925 | 0);
 HEAP32[gb + 89172 >> 2] = (HEAP32[gb + 89172 >> 2] | 0) + (gb + 669933 | 0);
 HEAP32[gb + 89176 >> 2] = (HEAP32[gb + 89176 >> 2] | 0) + (gb + 669939 | 0);
 HEAP32[gb + 89180 >> 2] = (HEAP32[gb + 89180 >> 2] | 0) + (gb + 669950 | 0);
 HEAP32[gb + 89184 >> 2] = (HEAP32[gb + 89184 >> 2] | 0) + (gb + 669954 | 0);
 HEAP32[gb + 89188 >> 2] = (HEAP32[gb + 89188 >> 2] | 0) + (gb + 669964 | 0);
 HEAP32[gb + 89192 >> 2] = (HEAP32[gb + 89192 >> 2] | 0) + (gb + 669975 | 0);
 HEAP32[gb + 89196 >> 2] = (HEAP32[gb + 89196 >> 2] | 0) + (gb + 669980 | 0);
 HEAP32[gb + 89208 >> 2] = fb + 138;
 HEAP32[gb + 89212 >> 2] = fb + 527;
 HEAP32[gb + 89216 >> 2] = fb + 1189;
 HEAP32[gb + 89220 >> 2] = fb + 1190;
 HEAP32[gb + 89232 >> 2] = fb + 72;
 HEAP32[gb + 89236 >> 2] = fb + 528;
 HEAP32[gb + 89240 >> 2] = fb + 138;
 HEAP32[gb + 89244 >> 2] = fb + 901;
 HEAP32[gb + 89248 >> 2] = fb + 902;
 HEAP32[gb + 89252 >> 2] = fb + 1191;
 HEAP32[gb + 89256 >> 2] = fb + 1192;
 HEAP32[gb + 89260 >> 2] = fb + 529;
 HEAP32[gb + 89272 >> 2] = fb + 1193;
 HEAP32[gb + 89276 >> 2] = fb + 1194;
 HEAP32[gb + 89280 >> 2] = fb + 530;
 HEAP32[gb + 89284 >> 2] = fb + 35;
 HEAP32[gb + 89288 >> 2] = fb + 36;
 HEAP32[gb + 89292 >> 2] = fb + 37;
 HEAP32[gb + 89296 >> 2] = fb + 64;
 HEAP32[gb + 89300 >> 2] = fb + 240;
 HEAP32[gb + 89304 >> 2] = (HEAP32[gb + 89304 >> 2] | 0) + (gb + 757377 | 0);
 HEAP32[gb + 89312 >> 2] = (HEAP32[gb + 89312 >> 2] | 0) + (gb + 672597 | 0);
 HEAP32[gb + 89320 >> 2] = (HEAP32[gb + 89320 >> 2] | 0) + (gb + 672602 | 0);
 HEAP32[gb + 89328 >> 2] = (HEAP32[gb + 89328 >> 2] | 0) + (gb + 672612 | 0);
 HEAP32[gb + 89336 >> 2] = (HEAP32[gb + 89336 >> 2] | 0) + (gb + 672617 | 0);
 HEAP32[gb + 89344 >> 2] = (HEAP32[gb + 89344 >> 2] | 0) + (gb + 672627 | 0);
 HEAP32[gb + 89360 >> 2] = (HEAP32[gb + 89360 >> 2] | 0) + (gb + 672635 | 0);
 HEAP32[gb + 89368 >> 2] = (HEAP32[gb + 89368 >> 2] | 0) + (gb + 672653 | 0);
 HEAP32[gb + 89392 >> 2] = fb + 1193;
 HEAP32[gb + 89396 >> 2] = fb + 1195;
 HEAP32[gb + 89400 >> 2] = fb + 531;
 HEAP32[gb + 89404 >> 2] = fb + 38;
 HEAP32[gb + 89408 >> 2] = fb + 39;
 HEAP32[gb + 89412 >> 2] = fb + 40;
 HEAP32[gb + 89416 >> 2] = fb + 65;
 HEAP32[gb + 89420 >> 2] = fb + 241;
 HEAP32[gb + 89424 >> 2] = (HEAP32[gb + 89424 >> 2] | 0) + (gb + 672767 | 0);
 HEAP32[gb + 89432 >> 2] = (HEAP32[gb + 89432 >> 2] | 0) + (gb + 672785 | 0);
 HEAP32[gb + 89440 >> 2] = (HEAP32[gb + 89440 >> 2] | 0) + (gb + 672804 | 0);
 HEAP32[gb + 89448 >> 2] = (HEAP32[gb + 89448 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 89456 >> 2] = (HEAP32[gb + 89456 >> 2] | 0) + (gb + 672819 | 0);
 HEAP32[gb + 89472 >> 2] = (HEAP32[gb + 89472 >> 2] | 0) + (gb + 673021 | 0);
 HEAP32[gb + 89496 >> 2] = fb + 1193;
 HEAP32[gb + 89500 >> 2] = fb + 1196;
 HEAP32[gb + 89504 >> 2] = fb + 532;
 HEAP32[gb + 89508 >> 2] = fb + 41;
 HEAP32[gb + 89512 >> 2] = fb + 42;
 HEAP32[gb + 89516 >> 2] = fb + 43;
 HEAP32[gb + 89520 >> 2] = fb + 66;
 HEAP32[gb + 89524 >> 2] = fb + 242;
 HEAP32[gb + 89536 >> 2] = fb + 139;
 HEAP32[gb + 89540 >> 2] = fb + 1197;
 HEAP32[gb + 89544 >> 2] = fb + 1198;
 HEAP32[gb + 89548 >> 2] = fb + 140;
 HEAP32[gb + 89560 >> 2] = fb + 141;
 HEAP32[gb + 89564 >> 2] = fb + 1199;
 HEAP32[gb + 89568 >> 2] = fb + 1200;
 runPostSets86();
}

function __ZN26AnimatorControllerPlayable12GetBehaviourEP11Il2CppClass(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 i8 = i1 + 112 | 0;
 i6 = i1 + 124 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 L4 : while (1) {
  i11 = HEAP32[i5 >> 2] | 0;
  do if (i11 | 0) {
   HEAP32[i10 >> 2] = i11;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i4 = HEAP32[i9 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 11;
   }
   if ((i12 | 0) == 9) i12 = 11;
   if ((i12 | 0) == 11) {
    i12 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i11) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = i11;
   if (!i1) i12 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 20;
    }
   }
   if ((i12 | 0) == 18) i12 = 20;
   if ((i12 | 0) == 20) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i11) | 0;
   }
   i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) == (i7 | 0)) {
     i12 = 23;
     break L4;
    }
    if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i7) | 0) {
     i12 = 33;
     break L4;
    }
   }
  } while (0);
  i5 = i5 + 4 | 0;
  if ((i5 | 0) == ((HEAP32[i8 >> 2] | 0) + (HEAP32[i6 >> 2] << 2) | 0)) {
   i1 = 0;
   i12 = 43;
   break;
  }
 }
 if ((i12 | 0) == 23) {
  HEAP32[i10 >> 2] = i11;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 28; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 28; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 30;
   }
  }
  if ((i12 | 0) == 28) i12 = 30;
  if ((i12 | 0) == 30) i1 = __Z31ReadObjectFromPersistentManageri(i11) | 0;
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 } else if ((i12 | 0) == 33) {
  HEAP32[i10 >> 2] = i11;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 38; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 38; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 40;
   }
  }
  if ((i12 | 0) == 38) i12 = 40;
  if ((i12 | 0) == 40) i1 = __Z31ReadObjectFromPersistentManageri(i11) | 0;
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 } else if ((i12 | 0) == 43) {
  STACKTOP = i13;
  return i1 | 0;
 }
 return 0;
}

function __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i11, i5, f12, i2) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 f12 = Math_fround(f12);
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i7 = i13;
 i9 = i5 + 164 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) == 1) {
  i10 = (HEAP32[i5 + 152 >> 2] | 0) + 4 | 0;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  STACKTOP = i13;
  return;
 }
 i10 = (i2 | 0) == 0 ? i5 + 76 | 0 : i2;
 i2 = i10 + 4 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if (f1 <= f12) if (Math_fround(HEAPF32[i10 + 8 >> 2]) > f12) {
  f15 = Math_fround(f12 - f1);
  f14 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f1 = Math_fround(HEAPF32[i10 + 16 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  f14 = Math_fround(f15 * f14);
  f1 = Math_fround(f15 * f1);
  f4 = Math_fround(f15 * f4);
  f12 = Math_fround(f15 * Math_fround(HEAPF32[i10 + 24 >> 2]));
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 28 >> 2]));
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i10 + 32 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 36 >> 2]));
  f14 = Math_fround(f15 * f14);
  f1 = Math_fround(f15 * f1);
  f4 = Math_fround(f15 * f4);
  f12 = Math_fround(f15 * Math_fround(f12 + Math_fround(HEAPF32[i10 + 40 >> 2])));
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 44 >> 2]));
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i10 + 48 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 52 >> 2]));
  f14 = Math_fround(f15 * f14);
  f1 = Math_fround(f15 * f1);
  f4 = Math_fround(f15 * f4);
  f12 = Math_fround(f15 * Math_fround(f12 + Math_fround(HEAPF32[i10 + 56 >> 2])));
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 60 >> 2]));
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i10 + 64 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 68 >> 2]));
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i10 + 72 >> 2]));
  HEAPF32[i11 >> 2] = f14;
  HEAPF32[i11 + 4 >> 2] = f1;
  HEAPF32[i11 + 8 >> 2] = f4;
  HEAPF32[i11 + 12 >> 2] = f12;
  STACKTOP = i13;
  return;
 }
 i8 = i5 + 152 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i16 >> 2]);
 f1 = Math_fround(HEAPF32[i16 + ((i3 + -1 | 0) * 52 | 0) >> 2]);
 do if (f1 < f12) {
  HEAPF32[i2 >> 2] = f1;
  HEAPF32[i10 + 8 >> 2] = Math_fround(inf);
  i2 = i10 + 12 | 0;
  i3 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i16 = i10 + 60 | 0;
  i9 = (HEAP32[i8 >> 2] | 0) + (((HEAP32[i9 >> 2] | 0) + -1 | 0) * 52 | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 } else if (f4 > f12) {
  f1 = Math_fround(f12 + Math_fround(-1.0e3));
  HEAPF32[i2 >> 2] = f1;
  HEAPF32[i10 + 8 >> 2] = f4;
  i2 = i10 + 12 | 0;
  i3 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i16 = i10 + 60 | 0;
  i9 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  break;
 } else {
  __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i5, i10, f12, i6, i7);
  __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i5, i10, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, Math_fround(0.0));
  f1 = Math_fround(HEAPF32[i2 >> 2]);
  break;
 } while (0);
 f1 = Math_fround(f12 - f1);
 f4 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f4 = Math_fround(f4 * f1);
 f12 = Math_fround(f1 * f12);
 f14 = Math_fround(f1 * f14);
 f15 = Math_fround(f1 * Math_fround(HEAPF32[i10 + 24 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 28 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i10 + 32 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 36 >> 2]));
 f4 = Math_fround(f1 * f4);
 f12 = Math_fround(f1 * f12);
 f14 = Math_fround(f1 * f14);
 f15 = Math_fround(f1 * Math_fround(f15 + Math_fround(HEAPF32[i10 + 40 >> 2])));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 44 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i10 + 48 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 52 >> 2]));
 f4 = Math_fround(f1 * f4);
 f12 = Math_fround(f1 * f12);
 f14 = Math_fround(f1 * f14);
 f15 = Math_fround(f1 * Math_fround(f15 + Math_fround(HEAPF32[i10 + 56 >> 2])));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + 60 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i10 + 64 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + 68 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i10 + 72 >> 2]));
 HEAPF32[i11 >> 2] = f4;
 HEAPF32[i11 + 4 >> 2] = f12;
 HEAPF32[i11 + 8 >> 2] = f14;
 HEAPF32[i11 + 12 >> 2] = f15;
 STACKTOP = i13;
 return;
}

function __ZN15RelativeJoint2D8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_(i5, i9);
 i4 = i5 + 76 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802602 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802613 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802625 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802643 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i5 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802665 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802680 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 54; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 54; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 54) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 20 | 0;
 i8 = i12;
 i5 = i12 + 16 | 0;
 i9 = i8 + 8 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(i1 & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i10, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i7 + 16 | 0;
    i5 = HEAP32[i7 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i6 = 33; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 33; else {
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
    if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i7 + 16 | 0;
    i5 = HEAP32[i7 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i6 = 44; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 44; else {
      i4 = HEAP32[i2 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 44) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i7 >> 2] & 512 | 0) {
     i5 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i6 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i5;
    }
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i4 = (i1 & 8388608 | 0) == 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 7; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 7; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 8 | 0;
    if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     i14 = i2;
     i13 = HEAP32[i14 + 4 >> 2] | 0;
     i2 = i9;
     HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i2 + 4 >> 2] = i13;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
   if (HEAP32[i7 >> 2] & 512 | 0) {
    i13 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
    i14 = i9 + 4 | 0;
    HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = i13;
   }
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i5);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i4) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i10, i1, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 32 | 0;
 i7 = i14;
 i9 = i14 + 64 | 0;
 i5 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i8 = (i4 & 1 | 0) == 0 ? i1 + 84 | 0 : i6 + 56 | 0;
 i6 = (i4 & 4 | 0) == 0 ? i1 + 48 | 0 : i6;
 if (!(HEAP8[i12 + ((HEAP32[gb + 1457208 + 68 + ((i5 >>> 24 & 15) << 2) >> 2] | 0) + 10) >> 0] | 0)) {
  i13 = (i5 & 64 | 0) == 0 ? i12 + 32 | 0 : (HEAP32[i12 + 8 >> 2] | 0) + 96 | 0;
  f30 = Math_fround(HEAPF32[i13 + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i13 + 20 >> 2]);
  f19 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  f29 = Math_fround(HEAPF32[i13 >> 2]);
  f24 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f27 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f21 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f23 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  f16 = Math_fround(HEAPF32[i6 >> 2]);
  f26 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f31 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f15 = Math_fround(Math_fround(f25 * f31) - Math_fround(Math_fround(Math_fround(f29 * f16) + Math_fround(f24 * f26)) + Math_fround(f22 * f28)));
  f18 = Math_fround(Math_fround(f29 * f31) + Math_fround(Math_fround(f25 * f16) + Math_fround(Math_fround(f24 * f28) - Math_fround(f22 * f26))));
  f17 = Math_fround(Math_fround(f24 * f31) + Math_fround(Math_fround(f25 * f26) + Math_fround(Math_fround(f22 * f16) - Math_fround(f29 * f28))));
  f16 = Math_fround(Math_fround(f22 * f31) + Math_fround(Math_fround(f25 * f28) + Math_fround(Math_fround(f29 * f26) - Math_fround(f24 * f16))));
  f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
  f28 = Math_fround(Math_fround(Math_fround(f29 * f27) + Math_fround(f24 * f21)) + Math_fround(f22 * f23));
  f20 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f21 * f26) + Math_fround(f25 * Math_fround(Math_fround(f22 * f27) - Math_fround(f29 * f23))))) * Math_fround(2.0)));
  f19 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f25 * Math_fround(Math_fround(f29 * f21) - Math_fround(f24 * f27)))) + Math_fround(f22 * f28)) * Math_fround(2.0)));
  HEAPF32[i11 + 16 >> 2] = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21))))) * Math_fround(2.0)));
  HEAPF32[i11 + 20 >> 2] = f20;
  HEAPF32[i11 + 24 >> 2] = f19;
  HEAPF32[i11 >> 2] = f18;
  HEAPF32[i11 + 4 >> 2] = f17;
  HEAPF32[i11 + 8 >> 2] = f16;
  HEAPF32[i11 + 12 >> 2] = f15;
 } else {
  i3 = i12 + 236 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i12 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if ((HEAP8[((i1 & 4096 | 0) == 0 ? i12 + 60 | 0 : i2 + 268 | 0) >> 0] & 3) == 3) {
   if (i1 & 8192 | 0) {
    HEAP32[i7 >> 2] = HEAP32[i2 + 192 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 196 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 200 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 204 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i2 + 208 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i2 + 212 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i2 + 216 >> 2];
    i1 = i7;
    break;
   }
   if (i5 >>> 0 > 3221225471) i13 = 8; else if (__ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i12 + 16 | 0, i7) | 0) i1 = i7; else i13 = 8;
  } else i13 = 8; while (0);
  if ((i13 | 0) == 8) i1 = i12 + 176 | 0;
  __ZN5physx2Cm27getDynamicGlobalPoseAlignedERKNS_11PxTransformES3_S3_RS1_(i1, i6, (HEAP32[i3 >> 2] & 512 | 0) == 0 ? i12 + 64 | 0 : (HEAP32[i4 >> 2] | 0) + 144 | 0, i11);
 }
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i8, i9, i11, Math_fround(0.0), 0);
 f29 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f25 = Math_fround(HEAPF32[i9 >> 2]);
 f26 = Math_fround(f29 - f25);
 f23 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f30 = Math_fround(f23 - f27);
 f24 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f28 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f26 = Math_fround(Math_fround(f26 * Math_fround(.5)) * Math_fround(.00999999977));
 f30 = Math_fround(Math_fround(f30 * Math_fround(.5)) * Math_fround(.00999999977));
 f31 = Math_fround(Math_fround(Math_fround(f24 - f28) * Math_fround(.5)) * Math_fround(.00999999977));
 f27 = Math_fround(f27 - f30);
 f28 = Math_fround(f28 - f31);
 f29 = Math_fround(f29 + f26);
 f30 = Math_fround(f23 + f30);
 f31 = Math_fround(f24 + f31);
 HEAPF32[i10 >> 2] = Math_fround(f25 - f26);
 HEAPF32[i10 + 4 >> 2] = f27;
 HEAPF32[i10 + 8 >> 2] = f28;
 HEAPF32[i10 + 12 >> 2] = f29;
 HEAPF32[i10 + 16 >> 2] = f30;
 HEAPF32[i10 + 20 >> 2] = f31;
 STACKTOP = i14;
 return;
}

function __ZN12ImmediatePtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 20 | 0;
 i8 = i12;
 i5 = i12 + 16 | 0;
 i9 = i8 + 8 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(i1 & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i10, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i7 + 16 | 0;
    i5 = HEAP32[i7 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i6 = 33; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 33; else {
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
    if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i7 + 16 | 0;
    i5 = HEAP32[i7 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i6 = 44; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 44; else {
      i4 = HEAP32[i2 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 44) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i7 >> 2] & 512 | 0) {
     i5 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i6 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i5;
    }
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i4 = (i1 & 8388608 | 0) == 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 7; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 7; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 8 | 0;
    if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     i14 = i2;
     i13 = HEAP32[i14 + 4 >> 2] | 0;
     i2 = i9;
     HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i2 + 4 >> 2] = i13;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
   if (HEAP32[i7 >> 2] & 512 | 0) {
    i13 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
    i14 = i9 + 4 | 0;
    HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i14 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = i13;
   }
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i5);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i4) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12maybe_shrinkEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i7 = i11 + 24 | 0;
 i9 = i6 + 68 | 0;
 i4 = i6 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i6 + 72 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i6 + 80 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i8 = i6 + 64 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i6 + 80 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i7 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i7 + 8 | 0;
 i24 = i6 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i19;
 i21 = i7 + 9 | 0;
 HEAP8[i21 >> 0] = (i19 & 65535) >>> 8;
 i19 = i7 + 12 | 0;
 i20 = i6 + 12 | 0;
 HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i20 + 20 >> 2];
 i17 = i7 + 36 | 0;
 i18 = i6 + 36 | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 i14 = i7 + 60 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i7 + 64 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i7 + 68 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i7 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i7 + 76 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i7 + 72 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i7 + 80 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j(i7, i6, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i6 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i21 >> 0] = i4;
 HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i7 + 32 >> 2] = i4;
 HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 i4 = HEAP32[i6 + 56 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i7 + 56 >> 2] = i4;
 i4 = i6 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i8 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i8 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i8;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i6 + 76 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 + 80 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i7 + 84 >> 2] | 0;
  HEAP32[i5 >> 2] = 1;
  HEAP32[i5 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i24 = i6 + 80 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab18SerializedProperty8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i8 = i7 + 32 | 0;
 i5 = i7;
 i10 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, i10, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 i9 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i8, 0);
 i6 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471828 | 0, i10, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471842 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
 }
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 44 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471855 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471863 | 0, i10, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471877 | 0, i10, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471891 | 0, i10, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471905 | 0, i10, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471919 | 0, gb + 471932 | 0, i10, 0);
 __ZN9ShaderLab25SerializedTextureProperty8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i7;
 return;
}

function __ZN20SphericalHarmonicsL217AddToCoefficientsEPKN4math7_float4EPKf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = i2 + 4 | 0;
 i23 = i2 + 8 | 0;
 i22 = i2 + 12 | 0;
 i19 = i2 + 16 | 0;
 i18 = i2 + 20 | 0;
 i17 = i2 + 24 | 0;
 i13 = i2 + 28 | 0;
 i7 = i2 + 32 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i8 = i1 + 4 | 0;
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = i1 + 8 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 i4 = i1 + 12 | 0;
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f12 * Math_fround(HEAPF32[i2 >> 2]));
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 f15 = Math_fround(f5 + f15);
 f16 = Math_fround(f9 + f16);
 f12 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f6 + f14);
 HEAPF32[i8 >> 2] = f15;
 HEAPF32[i10 >> 2] = f16;
 HEAPF32[i4 >> 2] = f12;
 i4 = i1 + 16 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 i10 = i1 + 20 | 0;
 f16 = Math_fround(HEAPF32[i10 >> 2]);
 i8 = i1 + 24 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 i21 = i1 + 28 | 0;
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2]));
 f9 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2]));
 f9 = Math_fround(f16 + f9);
 f5 = Math_fround(f15 + f5);
 f6 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i4 >> 2] = Math_fround(f12 + f11);
 HEAPF32[i10 >> 2] = f9;
 HEAPF32[i8 >> 2] = f5;
 HEAPF32[i21 >> 2] = f6;
 i21 = i1 + 32 | 0;
 f6 = Math_fround(HEAPF32[i21 >> 2]);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i21 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2])));
 i21 = i1 + 36 | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 i8 = i1 + 40 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = i1 + 44 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 i4 = i1 + 48 | 0;
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 i20 = i3 + 4 | 0;
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f14 = Math_fround(f12 * Math_fround(HEAPF32[i2 >> 2]));
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 f15 = Math_fround(f6 + f15);
 f16 = Math_fround(f9 + f16);
 f12 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i21 >> 2] = Math_fround(f5 + f14);
 HEAPF32[i8 >> 2] = f15;
 HEAPF32[i10 >> 2] = f16;
 HEAPF32[i4 >> 2] = f12;
 i4 = i1 + 52 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 i10 = i1 + 56 | 0;
 f16 = Math_fround(HEAPF32[i10 >> 2]);
 i8 = i1 + 60 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 i21 = i1 + 64 | 0;
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 f11 = Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2]));
 f9 = Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2]));
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 f9 = Math_fround(f16 + f9);
 f6 = Math_fround(f15 + f6);
 f5 = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i4 >> 2] = Math_fround(f12 + f11);
 HEAPF32[i10 >> 2] = f9;
 HEAPF32[i8 >> 2] = f6;
 HEAPF32[i21 >> 2] = f5;
 i21 = i1 + 68 | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i21 >> 2] = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 i21 = i1 + 72 | 0;
 f6 = Math_fround(HEAPF32[i21 >> 2]);
 i20 = i1 + 76 | 0;
 f5 = Math_fround(HEAPF32[i20 >> 2]);
 i8 = i1 + 80 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = i1 + 84 | 0;
 f11 = Math_fround(HEAPF32[i10 >> 2]);
 i4 = i3 + 8 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(f12 * Math_fround(HEAPF32[i2 >> 2]));
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i23 >> 2]));
 f15 = Math_fround(f5 + f15);
 f16 = Math_fround(f9 + f16);
 f12 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i21 >> 2] = Math_fround(f6 + f14);
 HEAPF32[i20 >> 2] = f15;
 HEAPF32[i8 >> 2] = f16;
 HEAPF32[i10 >> 2] = f12;
 i10 = i1 + 88 | 0;
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 i8 = i1 + 92 | 0;
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 i2 = i1 + 96 | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i1 + 100 | 0;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2]));
 f9 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2]));
 f9 = Math_fround(f16 + f9);
 f5 = Math_fround(f15 + f5);
 f6 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + f11);
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = f6;
 i3 = i1 + 104 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return;
}

function __ZN16GeometryJobTasks20ScheduleGeometryJobsER9GfxDevicePFvP15GeometryJobDataEPK22GeometryJobInstructionjb(i10, i11, i12, i13, i14, i3) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1157668 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157668 | 0, i9);
  i8 = gb + 1157668 | 0;
 } else i8 = 0;
 i2 = i10 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483520) >>> 0 < 128) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = 128;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, 4096, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] << 5 | 0) | 0;
  HEAP32[i2 >> 2] = 128;
  HEAP32[i10 >> 2] = i7;
  break;
 } while (0);
 if (i14 | 0) {
  i7 = i10 + 12 | 0;
  if (i3) {
   i5 = 0;
   do {
    i6 = HEAP32[i13 + (i5 << 5) >> 2] & 16777215;
    i1 = i6 + 1 | 0;
    if (i1 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i9 + 16 >> 2] = 0;
     HEAP32[i9 + 20 >> 2] = 0;
     HEAP32[i9 + 24 >> 2] = 0;
     HEAP32[i9 + 28 >> 2] = 0;
     __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy(i10, i1, i9, 0);
    }
    i4 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i13 + (i5 << 5) + 8 >> 2] | 0;
    if (i1 | 0) {
     i1 = HEAP32[i1 + 40 >> 2] | 0;
     i2 = i13 + (i5 << 5) + 16 | 0;
     i3 = mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 228 >> 2] | 0, i11 | 0, i1 | 0, HEAP32[i13 + (i5 << 5) + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
     if (!i3) i1 = HEAP32[i2 >> 2] | 0; else {
      HEAP32[i4 + (i6 << 5) >> 2] = i1;
      i1 = HEAP32[i2 >> 2] | 0;
      HEAP32[i4 + (i6 << 5) + 8 >> 2] = i1;
     }
     i2 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = i3;
     HEAP32[i2 + 8 >> 2] = i1;
    }
    i1 = HEAP32[i13 + (i5 << 5) + 20 >> 2] | 0;
    if (!i1) i1 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0; else {
     i1 = HEAP32[i1 + 40 >> 2] | 0;
     i2 = i13 + (i5 << 5) + 28 | 0;
     i3 = mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 228 >> 2] | 0, i11 | 0, i1 | 0, HEAP32[i13 + (i5 << 5) + 24 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
     if (!i3) i1 = HEAP32[i2 >> 2] | 0; else {
      HEAP32[i4 + (i6 << 5) + 4 >> 2] = i1;
      i1 = HEAP32[i2 >> 2] | 0;
      HEAP32[i4 + (i6 << 5) + 12 >> 2] = i1;
     }
     i4 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0;
     HEAP32[i4 + 4 >> 2] = i3;
     HEAP32[i4 + 12 >> 2] = i1;
     i1 = i4;
    }
    mftCall_vi(i12 | 0, i1 | 0);
    __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i10, i11, i6);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i14 | 0));
  } else {
   i5 = 0;
   do {
    i6 = HEAP32[i13 + (i5 << 5) >> 2] & 16777215;
    i1 = i6 + 1 | 0;
    if (i1 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i9 + 16 >> 2] = 0;
     HEAP32[i9 + 20 >> 2] = 0;
     HEAP32[i9 + 24 >> 2] = 0;
     HEAP32[i9 + 28 >> 2] = 0;
     __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy(i10, i1, i9, 0);
    }
    i4 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i13 + (i5 << 5) + 8 >> 2] | 0;
    if (i1 | 0) {
     i2 = i13 + (i5 << 5) + 16 | 0;
     i3 = mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 228 >> 2] | 0, i11 | 0, i1 | 0, HEAP32[i13 + (i5 << 5) + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
     if (!i3) i1 = HEAP32[i2 >> 2] | 0; else {
      HEAP32[i4 + (i6 << 5) >> 2] = i1;
      i1 = HEAP32[i2 >> 2] | 0;
      HEAP32[i4 + (i6 << 5) + 8 >> 2] = i1;
     }
     i2 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = i3;
     HEAP32[i2 + 8 >> 2] = i1;
    }
    i1 = HEAP32[i13 + (i5 << 5) + 20 >> 2] | 0;
    if (!i1) i1 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0; else {
     i2 = i13 + (i5 << 5) + 28 | 0;
     i3 = mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 228 >> 2] | 0, i11 | 0, i1 | 0, HEAP32[i13 + (i5 << 5) + 24 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
     if (!i3) i1 = HEAP32[i2 >> 2] | 0; else {
      HEAP32[i4 + (i6 << 5) + 4 >> 2] = i1;
      i1 = HEAP32[i2 >> 2] | 0;
      HEAP32[i4 + (i6 << 5) + 12 >> 2] = i1;
     }
     i4 = HEAP32[i13 + (i5 << 5) + 4 >> 2] | 0;
     HEAP32[i4 + 4 >> 2] = i3;
     HEAP32[i4 + 12 >> 2] = i1;
     i1 = i4;
    }
    mftCall_vi(i12 | 0, i1 | 0);
    __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i10, i11, i6);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i14 | 0));
  }
 }
 if (!i8) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i15;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 451057 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 451077 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 455706 | 0, HEAP32[gb + 37260 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 451094 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 451109 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 45; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 45; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 451123 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z22CullAllPerObjectLightsiRK15RenderNodeQueueRK12ActiveLightsR27PerObjectLightCullingOutput(i13, i14, i1, i19) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i22;
 i12 = i22 + 8 | 0;
 i20 = HEAP32[i14 + 32804 >> 2] | 0;
 if (!i20) {
  STACKTOP = i22;
  return;
 }
 i2 = i1 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 if ((HEAP16[gb + 1114464 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114464 | 0, i11);
  i16 = gb + 1114464 | 0;
 } else i16 = 0;
 i17 = __ZnwjRK10MemLabelIdiPKci(364, gb + 64024 | 0, 16, gb + 385575 | 0, 376) | 0;
 i7 = gb + 63160 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i18 = i17;
 HEAP32[i18 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i18 + 4 >> 2] = i8;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 i18 = i17 + 8 | 0;
 HEAP32[i18 >> 2] = 0;
 i8 = gb + 64024 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i15 = i17;
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = i7;
 HEAP32[i17 + 20 >> 2] = i14;
 HEAP32[i17 + 24 >> 2] = i1;
 HEAP32[i17 + 40 >> 2] = i19;
 HEAP8[i17 + 32 >> 0] = (__ZNK16LightmapSettings23HasLightProbeTetrahedraEv(__Z19GetLightmapSettingsv() | 0) | 0) & 1;
 HEAP8[i17 + 33 >> 0] = (__ZNK16LightmapSettings19AreLightProbesBakedEv(__Z19GetLightmapSettingsv() | 0) | 0) & 1;
 HEAP32[i17 + 28 >> 2] = i13;
 HEAP32[i17 + 36 >> 2] = i20;
 i15 = (i20 >>> 0) / ((((Math_imul(HEAP32[i2 >> 2] | 0, i20) | 0) + 499 | 0) / 500 | 0) >>> 0) | 0;
 i7 = i17 + 172 | 0;
 i15 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i7, i20, (i15 | 0) < 1 ? 1 : i15) | 0;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20 << 2, 16, gb + 64024 | 0, 0, gb + 385575 | 0, 401) | 0;
 if ((i15 | 0) > 0) {
  i9 = i17 + 44 | 0;
  i10 = i17 + 108 | 0;
  i1 = 0;
  do {
   i5 = __ZnwjRK10MemLabelIdiPKci(20, gb + 64024 | 0, 16, gb + 385575 | 0, 404) | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   i2 = i5 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
   i6 = i11;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i9 + (i1 << 2) | 0;
   HEAP32[i3 >> 2] = i5;
   i5 = gb + 64024 | 0;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   i4 = i2 * 5 | 0;
   i5 = i3 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i4;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 * 40 | 0, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 12 >> 2] << 3 | 0) | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i3 >> 2] = i6;
    break;
   } while (0);
   HEAP32[i10 + (i1 << 2) >> 2] = i8 + (HEAP32[i7 + (i1 * 12 | 0) >> 2] << 2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
 }
 if ((HEAP16[gb + 1114488 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114488 | 0, i11);
  i9 = gb + 1114488 | 0;
 } else i9 = 0;
 if ((i13 | 0) > 1) {
  i8 = (i13 | 0) == 2 ? 3 : 4;
  __ZN14dynamic_bitset6resizeEjb(i17, i20, 0);
  i6 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  do {
   i4 = HEAP32[i6 + (i2 * 360 | 0) + 244 >> 2] | 0;
   i5 = HEAP32[i6 + (i2 * 360 | 0) + 324 >> 2] | 0;
   L28 : do if ((i4 | 0) > 0) {
    i3 = 0;
    while (1) {
     i7 = HEAP32[(HEAP32[i5 + (i3 << 3) >> 2] | 0) + 8 >> 2] | 0;
     i1 = HEAP32[i5 + (i3 << 3) + 4 >> 2] | 0;
     if ((i1 | 0) < 0) i1 = HEAP32[(HEAP32[i7 + 32 >> 2] | 0) + 52 >> 2] | 0;
     if ((i1 | 0) > 2500) break;
     i3 = i3 + 1 | 0;
     if ((HEAP32[(HEAP32[i7 + 32 >> 2] | 0) + 24 + (i8 << 2) >> 2] | 0) == -1) break;
     if ((i3 | 0) >= (i4 | 0)) {
      i21 = 18;
      break L28;
     }
    }
    i14 = (HEAP32[i18 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i2 & 31);
   } else i21 = 18; while (0);
   if ((i21 | 0) == 18) {
    i21 = 0;
    i14 = (HEAP32[i18 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & ~(1 << (i2 & 31));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i20 | 0));
 } else __ZN14dynamic_bitset6resizeEjb(i17, i20, 1);
 if (i9 | 0) __Z12profiler_endP19ProfilerInformation(i9);
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i19, fb + 2390 | 0, i17, i15, fb + 3343 | 0, 0);
 if (!i16) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i22;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR17CompareInstanceIDPP6ObjectEEbT0_S6_T_(i14, i13, i1) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 switch (i13 - i14 >> 2 | 0) {
 case 2:
  {
   i1 = i13 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   if ((HEAP32[i2 + 4 >> 2] | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) {
    i14 = 1;
    return i14 | 0;
   }
   HEAP32[i14 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i14 = 1;
   return i14 | 0;
  }
 case 3:
  {
   i7 = i14 + 4 | 0;
   i4 = i13 + -4 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   i13 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i3 + 4 >> 2] | 0) < (i13 | 0);
   if ((i13 | 0) >= (i5 | 0)) {
    if (!i1) {
     i14 = 1;
     return i14 | 0;
    }
    HEAP32[i7 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i1 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[i14 >> 2] | 0;
    if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
     i14 = 1;
     return i14 | 0;
    }
    HEAP32[i14 >> 2] = i1;
    HEAP32[i7 >> 2] = i2;
    i14 = 1;
    return i14 | 0;
   }
   if (i1) {
    HEAP32[i14 >> 2] = i3;
    HEAP32[i4 >> 2] = i6;
    i14 = 1;
    return i14 | 0;
   }
   HEAP32[i14 >> 2] = i2;
   HEAP32[i7 >> 2] = i6;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) >= (i5 | 0)) {
    i14 = 1;
    return i14 | 0;
   }
   HEAP32[i7 >> 2] = i1;
   HEAP32[i4 >> 2] = i6;
   i14 = 1;
   return i14 | 0;
  }
 case 4:
  {
   i12 = i14 + 4 | 0;
   i11 = i14 + 8 | 0;
   i10 = i13 + -4 | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i13 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = (i5 | 0) < (i13 | 0);
   i2 = i7;
   i8 = i4;
   i9 = i3;
   do if ((i13 | 0) < (i1 | 0)) {
    if (i6) {
     HEAP32[i14 >> 2] = i8;
     HEAP32[i11 >> 2] = i9;
     i2 = i9;
     break;
    }
    HEAP32[i14 >> 2] = i2;
    HEAP32[i12 >> 2] = i9;
    if ((i5 | 0) < (i1 | 0)) {
     HEAP32[i12 >> 2] = i8;
     HEAP32[i11 >> 2] = i9;
     i2 = i9;
    } else {
     i3 = i4;
     i2 = i8;
    }
   } else if (i6) {
    HEAP32[i12 >> 2] = i8;
    HEAP32[i11 >> 2] = i2;
    if ((i5 | 0) < (i1 | 0)) {
     HEAP32[i14 >> 2] = i8;
     HEAP32[i12 >> 2] = i9;
     i3 = i7;
     i2 = i7;
    } else i3 = i7;
   } else {
    i3 = i4;
    i2 = i8;
   } while (0);
   i1 = HEAP32[i10 >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i3 + 4 >> 2] | 0)) {
    i14 = 1;
    return i14 | 0;
   }
   HEAP32[i11 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i4 | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
    i14 = 1;
    return i14 | 0;
   }
   i3 = i1;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i11 >> 2] = i2;
   i1 = HEAP32[i14 >> 2] | 0;
   if ((i4 | 0) >= (HEAP32[i1 + 4 >> 2] | 0)) {
    i14 = 1;
    return i14 | 0;
   }
   HEAP32[i14 >> 2] = i3;
   HEAP32[i12 >> 2] = i1;
   i14 = 1;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_(i14, i14 + 4 | 0, i14 + 8 | 0, i14 + 12 | 0, i13 + -4 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   return i14 | 0;
  }
 default:
  {
   i4 = i14 + 8 | 0;
   i9 = i14 + 4 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   i11 = HEAP32[i14 >> 2] | 0;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = (i2 | 0) < (i12 | 0);
   i6 = i10;
   i7 = i3;
   i8 = i11;
   do if ((i12 | 0) < (i1 | 0)) {
    if (i5) {
     HEAP32[i14 >> 2] = i7;
     HEAP32[i4 >> 2] = i8;
     i3 = i11;
     break;
    }
    HEAP32[i14 >> 2] = i6;
    HEAP32[i9 >> 2] = i8;
    if ((i2 | 0) < (i1 | 0)) {
     HEAP32[i9 >> 2] = i7;
     HEAP32[i4 >> 2] = i8;
     i3 = i11;
    }
   } else if (i5) {
    HEAP32[i9 >> 2] = i7;
    HEAP32[i4 >> 2] = i6;
    if ((i2 | 0) < (i1 | 0)) {
     HEAP32[i14 >> 2] = i7;
     HEAP32[i9 >> 2] = i8;
     i3 = i10;
    } else i3 = i10;
   } while (0);
   i1 = i14 + 12 | 0;
   L13 : do if ((i1 | 0) == (i13 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i7 = i1;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i7 >> 2] | 0;
     i6 = i2;
     if ((HEAP32[i2 + 4 >> 2] | 0) < (HEAP32[i3 + 4 >> 2] | 0)) {
      i5 = i2 + 4 | 0;
      i3 = i4;
      i2 = i7;
      while (1) {
       HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
       if ((i3 | 0) == (i14 | 0)) break;
       i2 = i3 + -4 | 0;
       if ((HEAP32[i5 >> 2] | 0) < (HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0)) {
        i12 = i3;
        i3 = i2;
        i2 = i12;
       } else break;
      }
      HEAP32[i3 >> 2] = i6;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i7 + 4 | 0) == (i13 | 0);
       break L13;
      }
     }
     i2 = i7 + 4 | 0;
     if ((i2 | 0) == (i13 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i3 = HEAP32[i7 >> 2] | 0;
     i4 = i7;
     i7 = i2;
    }
   } while (0);
   i14 = i1 | i2;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZNSt3__211__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i(i30, i31, i32, i33, i1, i23, i24, i25, i26, i27, i12, i13, i14, i29, i15) {
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i29 = i29 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i28 = 0, i34 = 0;
 HEAP32[i32 >> 2] = i30;
 i16 = i29 + 8 + 3 | 0;
 i28 = i29 + 4 | 0;
 i17 = i14 + 8 + 3 | 0;
 i18 = i14 + 4 | 0;
 i19 = (i33 & 512 | 0) == 0;
 i20 = (i15 | 0) > 0;
 i21 = i13 + 11 | 0;
 i22 = i13 + 4 | 0;
 i11 = 0;
 while (1) {
  if ((i11 | 0) == 4) break;
  L4 : do switch (HEAP8[i26 + i11 >> 0] | 0) {
  case 0:
   {
    HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
    break;
   }
  case 1:
   {
    HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
    i9 = mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 44 >> 2] | 0, i24 | 0, 32) | 0;
    i10 = HEAP32[i32 >> 2] | 0;
    HEAP32[i32 >> 2] = i10 + 4;
    HEAP32[i10 >> 2] = i9;
    break;
   }
  case 3:
   {
    i10 = HEAP8[i16 >> 0] | 0;
    i2 = i10 << 24 >> 24 < 0;
    if ((i2 ? HEAP32[i28 >> 2] | 0 : i10 & 255) | 0) {
     i9 = HEAP32[(i2 ? HEAP32[i29 >> 2] | 0 : i29) >> 2] | 0;
     i10 = HEAP32[i32 >> 2] | 0;
     HEAP32[i32 >> 2] = i10 + 4;
     HEAP32[i10 >> 2] = i9;
    }
    break;
   }
  case 2:
   {
    i6 = HEAP8[i17 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i6 = i2 ? HEAP32[i18 >> 2] | 0 : i6 & 255;
    if (!(i19 | (i6 | 0) == 0)) {
     i5 = i2 ? HEAP32[i14 >> 2] | 0 : i14;
     i3 = i5 + (i6 << 2) | 0;
     i4 = HEAP32[i32 >> 2] | 0;
     i2 = i4;
     while (1) {
      if ((i5 | 0) == (i3 | 0)) break;
      HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
      i2 = i2 + 4 | 0;
      i5 = i5 + 4 | 0;
     }
     HEAP32[i32 >> 2] = i4 + (i6 << 2);
    }
    break;
   }
  case 4:
   {
    i3 = HEAP32[i32 >> 2] | 0;
    i1 = i25 ? i1 + 4 | 0 : i1;
    i2 = i1;
    while (1) {
     if (i2 >>> 0 >= i23 >>> 0) break;
     if (!(mftCall_iiii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, 2048, HEAP32[i2 >> 2] | 0) | 0)) break;
     i2 = i2 + 4 | 0;
    }
    if (i20) {
     i5 = i15;
     while (1) {
      i4 = (i5 | 0) > 0;
      if (!(i2 >>> 0 > i1 >>> 0 & i4)) break;
      i10 = i2 + -4 | 0;
      i8 = HEAP32[i10 >> 2] | 0;
      i9 = HEAP32[i32 >> 2] | 0;
      HEAP32[i32 >> 2] = i9 + 4;
      HEAP32[i9 >> 2] = i8;
      i5 = i5 + -1 | 0;
      i2 = i10;
     }
     if (i4) i7 = mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 44 >> 2] | 0, i24 | 0, 48) | 0; else i7 = 0;
     i6 = HEAP32[i32 >> 2] | 0;
     while (1) {
      i4 = i6 + 4 | 0;
      if ((i5 | 0) <= 0) break;
      HEAP32[i6 >> 2] = i7;
      i5 = i5 + -1 | 0;
      i6 = i4;
     }
     HEAP32[i32 >> 2] = i4;
     HEAP32[i6 >> 2] = i27;
    }
    if ((i2 | 0) == (i1 | 0)) {
     i9 = mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 44 >> 2] | 0, i24 | 0, 48) | 0;
     i10 = HEAP32[i32 >> 2] | 0;
     i2 = i10 + 4 | 0;
     HEAP32[i32 >> 2] = i2;
     HEAP32[i10 >> 2] = i9;
    } else {
     i10 = HEAP8[i21 >> 0] | 0;
     i9 = i10 << 24 >> 24 < 0;
     i10 = i9 ? HEAP32[i22 >> 2] | 0 : i10 & 255;
     if (!i10) {
      i6 = -1;
      i4 = 0;
      i7 = 0;
     } else {
      i6 = HEAP8[(i9 ? HEAP32[i13 >> 2] | 0 : i13) >> 0] | 0;
      i4 = 0;
      i7 = 0;
     }
     while (1) {
      if ((i2 | 0) == (i1 | 0)) break;
      i5 = HEAP32[i32 >> 2] | 0;
      if ((i7 | 0) == (i6 | 0)) {
       i8 = i5 + 4 | 0;
       HEAP32[i32 >> 2] = i8;
       HEAP32[i5 >> 2] = i12;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 < i10 >>> 0) {
        i6 = HEAP8[(i9 ? HEAP32[i13 >> 2] | 0 : i13) + i4 >> 0] | 0;
        i6 = i6 << 24 >> 24 == 127 ? -1 : i6 << 24 >> 24;
        i7 = 0;
        i5 = i8;
       } else {
        i6 = i7;
        i7 = 0;
        i5 = i8;
       }
      }
      i8 = i2 + -4 | 0;
      i34 = HEAP32[i8 >> 2] | 0;
      HEAP32[i32 >> 2] = i5 + 4;
      HEAP32[i5 >> 2] = i34;
      i7 = i7 + 1 | 0;
      i2 = i8;
     }
     i2 = HEAP32[i32 >> 2] | 0;
    }
    if ((i3 | 0) != (i2 | 0)) while (1) {
     i2 = i2 + -4 | 0;
     if (i3 >>> 0 >= i2 >>> 0) break L4;
     i34 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i34;
     i3 = i3 + 4 | 0;
    }
    break;
   }
  default:
   {}
  } while (0);
  i11 = i11 + 1 | 0;
 }
 i1 = HEAP8[i16 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i28 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 > 1) {
  i2 = i2 ? HEAP32[i29 >> 2] | 0 : i29;
  i5 = i2 + 4 | 0;
  i2 = i2 + (i1 << 2) | 0;
  i3 = HEAP32[i32 >> 2] | 0;
  i4 = i2 - i5 | 0;
  i1 = i3;
  while (1) {
   if ((i5 | 0) == (i2 | 0)) break;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   i1 = i1 + 4 | 0;
   i5 = i5 + 4 | 0;
  }
  HEAP32[i32 >> 2] = i3 + (i4 >>> 2 << 2);
 }
 switch ((i33 & 176) << 24 >> 24) {
 case 32:
  {
   HEAP32[i31 >> 2] = HEAP32[i32 >> 2];
   break;
  }
 case 16:
  break;
 default:
  HEAP32[i31 >> 2] = i30;
 }
 return;
}

function __Z39AudioMixer_CUSTOM_TransitionToSnapshotsP12Il2CppObjectP11Il2CppArrayS2_f(i1, i2, i16, f17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 24 | 0;
 i11 = i20 + 16 | 0;
 i10 = i20 + 8 | 0;
 i8 = i20;
 i9 = i20 + 52 | 0;
 i18 = i20 + 48 | 0;
 i19 = i20 + 28 | 0;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i19 >> 2] = 0;
 i7 = i19 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i15 = i19 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i14 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i4 = i8;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i14;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 __Z32ScriptingArrayToPPtrDynamicArrayI18AudioMixerSnapshotEvP11Il2CppArrayR13dynamic_arrayI4PPtrIT_EXsr11AlignOfTypeIS6_EE5alignEE(i2, i19);
 L1 : do if (HEAP32[i7 >> 2] | 0) {
  i1 = 0;
  while (1) {
   i6 = (HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) {
    i13 = 14;
    break;
   }
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i13 = 10; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i5 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i5 = HEAP32[i8 >> 2] | 0;
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
     i2 = i4;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i13 = 10; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i13 = 12;
   }
   if ((i13 | 0) == 10) i13 = 12;
   if ((i13 | 0) == 12) {
    i13 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
     i13 = 14;
     break;
    }
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   i5 = (HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   if (!i2) i13 = 20; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i6 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i6 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 20; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i13 = 22;
    }
   }
   if ((i13 | 0) == 20) i13 = 22;
   if ((i13 | 0) == 22) {
    i13 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
   i6 = HEAP32[i2 + 32 >> 2] | 0;
   if ((i6 | 0) != (__ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[i18 >> 2] | 0) | 0)) {
    i13 = 24;
    break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break L1;
  }
  if ((i13 | 0) == 14) {
   i13 = __ZNK21ScriptingObjectOfTypeI10AudioMixerEptEv(i18) | 0;
   HEAP32[i10 >> 2] = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
   __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 894069 | 0, i10);
  } else if ((i13 | 0) == 24) {
   i10 = __ZNK4PPtrI18AudioMixerSnapshotEptEv((HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0) | 0;
   i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
   i13 = __ZNK21ScriptingObjectOfTypeI10AudioMixerEptEv(i18) | 0;
   i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
   HEAP32[i11 >> 2] = i10;
   HEAP32[i11 + 4 >> 2] = i13;
   __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 894145 | 0, i11);
  }
 } while (0);
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i16) | 0;
 if ((HEAP32[i7 >> 2] | 0) != (i13 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 894241 | 0, i12);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  i13 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i1) {
  i18 = HEAP32[i18 >> 2] | 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i18);
 }
 __ZN10AudioMixer14SetWeightedMixER13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEPff(i1, i19, __Z27scripting_array_element_ptrP11Il2CppArrayij(i16, 0, 4) | 0, f17);
 if ((HEAP32[i15 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i14);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = i9 + 4 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i8 + 4;
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i6 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i9, i6, 0);
 i5 = i8 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 8 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i4 | 0, i1 << 2);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i8 + 20;
 HEAP32[i6 + 4 >> 2] = i8 + 16;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i9, i6, 0);
 i1 = i8 + 24 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 56 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 60 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 61 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 62 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 63 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_(i13, i14, i12) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i16 = i13 + 12 | 0;
 L1 : do if (HEAP32[i16 >> 2] | 0) {
  i10 = HEAP32[i13 >> 2] | 0;
  i11 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? i10 : i1;
  if (i1 | 0) {
   i10 = i13 + 4 | 0;
   i9 = HEAP32[i14 >> 2] | 0;
   i3 = i9;
   while (1) {
    if ((i3 | 0) == (HEAP32[i12 >> 2] | 0)) break;
    i6 = HEAP32[i3 + 16 >> 2] | 0;
    HEAP32[i1 + 16 >> 2] = i6;
    i8 = i1 + 8 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    do if (!i3) i3 = 0; else {
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == (i1 | 0)) {
      HEAP32[i3 >> 2] = 0;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break;
      while (1) {
       i3 = HEAP32[i2 >> 2] | 0;
       if (i3 | 0) {
        i2 = i3;
        continue;
       }
       i3 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i3) break; else i2 = i3;
      }
      i3 = i2;
      break;
     } else {
      HEAP32[i3 + 4 >> 2] = 0;
      if (!i2) break;
      while (1) {
       i3 = HEAP32[i2 >> 2] | 0;
       if (i3 | 0) {
        i2 = i3;
        continue;
       }
       i3 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i3) break; else i2 = i3;
      }
      i3 = i2;
      break;
     }
    } while (0);
    i2 = HEAP32[i11 >> 2] | 0;
    do if (!i2) {
     i5 = i11;
     i4 = i11;
    } else {
     while (1) if (i6 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i7 = 19;
       break;
      } else i2 = i4;
     } else {
      i4 = i2 + 4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!i5) {
       i7 = 22;
       break;
      } else i2 = i5;
     }
     if ((i7 | 0) == 19) {
      i5 = i2;
      i4 = i2;
      break;
     } else if ((i7 | 0) == 22) {
      i5 = i2;
      break;
     }
    } while (0);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i8 >> 2] = i5;
    HEAP32[i4 >> 2] = i1;
    i2 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i13 >> 2] = i2;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i1);
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    if (!i1) {
     i1 = i9;
     while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     }
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
    HEAP32[i14 >> 2] = i2;
    if (!i3) break L1; else {
     i1 = i3;
     i3 = i2;
     i9 = i2;
    }
   }
   i2 = i1 + 8 | 0;
   if (HEAP32[i2 >> 2] | 0) do {
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = i1 + 8 | 0;
   } while ((HEAP32[i2 >> 2] | 0) != 0);
   __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i13, i1);
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i17;
  return;
 }
 i9 = i13 + 4 | 0;
 i10 = i13 + 8 | 0;
 i11 = i15 + 4 | 0;
 i12 = i13 + 4 | 0;
 i1 = i2;
 while (1) {
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = i2 + 16 | 0;
  do if (!i3) {
   i3 = i9;
   i4 = i9;
  } else {
   i5 = HEAP32[i6 >> 2] | 0;
   i2 = i3;
   while (1) if (i5 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i7 = 37;
     break;
    } else i2 = i3;
   } else {
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i7 = 40;
     break;
    } else i2 = i3;
   }
   if ((i7 | 0) == 37) {
    i3 = i2;
    i4 = i2;
    break;
   } else if ((i7 | 0) == 40) {
    i3 = i2;
    break;
   }
  } while (0);
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP32[i15 >> 2] = 57;
  HEAP32[i11 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(20, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i2 + 16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = i3;
  HEAP32[i4 >> 2] = i2;
  i3 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i13 >> 2] = i3;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i2);
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  HEAP32[i14 >> 2] = i2;
  if ((i2 | 0) == (i8 | 0)) break; else i1 = i2;
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx5cloth8SwSolver14interCollisionEv(i37) {
 i37 = i37 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, f40 = f0, f41 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i38 + 16 | 0;
 i31 = i38 + 313 | 0;
 i32 = i38 + 312 | 0;
 i35 = i38;
 i36 = i38 + 168 | 0;
 i33 = i37 + 88 | 0;
 if (!(HEAP32[i33 >> 2] | 0)) {
  STACKTOP = i38;
  return;
 }
 i34 = i37 + 80 | 0;
 if (Math_fround(HEAPF32[i34 >> 2]) == Math_fround(0.0)) {
  STACKTOP = i38;
  return;
 }
 i7 = i37 + 104 | 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i7, 0, i38 + 92 | 0);
 i9 = i37 + 36 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) i6 = i37 + 108 | 0; else {
  i10 = i37 + 32 | 0;
  i11 = i8 + 4 | 0;
  i12 = i8 + 8 | 0;
  i13 = i8 + 12 | 0;
  i14 = i8 + 16 | 0;
  i15 = i8 + 20 | 0;
  i16 = i8 + 24 | 0;
  i17 = i8 + 28 | 0;
  i18 = i8 + 32 | 0;
  i19 = i8 + 36 | 0;
  i20 = i8 + 40 | 0;
  i21 = i8 + 44 | 0;
  i22 = i8 + 48 | 0;
  i23 = i8 + 52 | 0;
  i24 = i8 + 56 | 0;
  i25 = i8 + 60 | 0;
  i26 = i8 + 64 | 0;
  i27 = i8 + 68 | 0;
  i28 = i8 + 72 | 0;
  i29 = i37 + 112 | 0;
  i6 = i37 + 108 | 0;
  i30 = 0;
  do {
   i4 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i4 + (i30 * 40 | 0) + 20 >> 2] | 0;
   i4 = HEAP32[i4 + (i30 * 40 | 0) + 36 >> 2] | 0;
   i5 = HEAP32[i3 + 20 >> 2] | 0;
   i1 = HEAP32[i3 + 492 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i3 + 12 >> 2] | 0;
    i2 = 0;
   } else i2 = HEAP32[i3 + 488 >> 2] | 0;
   i39 = HEAP32[i3 + 532 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i14 >> 2] = HEAP32[i3 + 148 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i3 + 152 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i3 + 156 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i3 + 160 >> 2];
   HEAP32[i18 >> 2] = HEAP32[i3 + 164 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i3 + 168 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i3 + 172 >> 2];
   HEAP32[i21 >> 2] = HEAP32[i3 + 32 >> 2];
   HEAP32[i22 >> 2] = HEAP32[i3 + 36 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i3 + 40 >> 2];
   HEAP32[i24 >> 2] = HEAP32[i3 + 44 >> 2];
   HEAP32[i25 >> 2] = HEAP32[i3 + 48 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i3 + 52 >> 2];
   HEAP32[i27 >> 2] = i4;
   HEAP32[i28 >> 2] = i39;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i29 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    i39 = HEAP32[i7 >> 2] | 0;
    i4 = i39 + (i1 * 76 | 0) | 0;
    HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 28 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 32 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 36 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 44 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 48 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 52 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 56 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 60 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i39 + (i1 * 76 | 0) + 64 >> 2] = HEAP32[i26 >> 2];
    i4 = i27;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i39 = i39 + (i1 * 76 | 0) + 68 | 0;
    HEAP32[i39 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i39 + 4 >> 2] = i5;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i7, i8) | 0;
   i30 = i30 + 1 | 0;
  } while (i30 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i1 = __ZN5physx5cloth16SwInterCollisionI8Scalar4fE23estimateTemporaryMemoryEPNS0_20SwInterCollisionDataEj(HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i3 = i37 + 100 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = i37 + 96 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < i1 >>> 0) {
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i31, i2);
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i1, gb + 837658 | 0, 239) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
 } else i1 = i5;
 HEAP32[i35 >> 2] = i2;
 HEAP32[i35 + 4 >> 2] = i1;
 HEAP32[i35 + 8 >> 2] = i2;
 HEAP32[i35 + 12 >> 2] = 0;
 f41 = Math_fround(HEAPF32[i34 >> 2]);
 f40 = Math_fround(HEAPF32[i37 + 84 >> 2]);
 __ZN5physx5cloth16SwInterCollisionI8Scalar4fEC2EPKNS0_20SwInterCollisionDataEjffjPFbPvS7_ER14StackAllocatorILj16EEPNS_13PxProfileZoneE(i36, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0, f41, f40, HEAP32[i33 >> 2] | 0, HEAP32[i37 + 92 >> 2] | 0, i35, HEAP32[i37 + 72 >> 2] | 0);
 __ZN5physx5cloth16SwInterCollisionI8Scalar4fEclEv(i36);
 STACKTOP = i38;
 return;
}
function __ZN11UnityEngine9AnimationL23InitializeDefaultValuesERKNS0_30AnimatorGenericBindingConstantEPKN7mecanim9animation14AvatarConstantEb(i24, i1, i3) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27;
 i26 = HEAP32[i24 + 32 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 i1 = i1 + 4 | 0;
 i25 = HEAP32[i1 >> 2] | 0;
 i1 = (i25 | 0) == 0 ? 0 : i25 + i1 | 0;
 i25 = HEAP32[i26 + 24 >> 2] | 0;
 L1 : do if (i3) {
  i13 = HEAP32[i24 + 4 >> 2] | 0;
  i14 = HEAP32[i24 >> 2] | 0;
  i15 = i26 + 4 | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i14) {
   i9 = i23 + 4 | 0;
   i11 = i23 + 8 | 0;
   i16 = i1 + 4 | 0;
   i17 = i16;
   i18 = i23 + 4 | 0;
   i19 = i23 + 8 | 0;
   i20 = i23 + 12 | 0;
   i21 = i1 + 12 | 0;
   i22 = i21;
   i10 = i23 + 4 | 0;
   i12 = i23 + 8 | 0;
   i7 = i1 + 20 | 0;
   i8 = i7;
   i2 = 0;
   i6 = 0;
   i3 = 0;
   i1 = 0;
   while (1) {
    i5 = HEAP32[i13 + (i6 << 4) + 12 >> 2] | 0;
    switch (HEAP32[i13 + (i6 << 4) + 4 >> 2] | 0) {
    case 1:
     {
      if (i5 | 0) {
       __ZNK9Transform16GetLocalPositionEv(i23, i5);
       i29 = HEAP32[i9 >> 2] | 0;
       i28 = HEAP32[i11 >> 2] | 0;
       i5 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
       HEAP32[i5 + (i1 * 12 | 0) >> 2] = HEAP32[i23 >> 2];
       HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = i29;
       HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = i28;
      }
      i1 = i1 + 1 | 0;
      break;
     }
    case 4:
    case 2:
     {
      if (i5 | 0) {
       __ZNK9Transform16GetLocalRotationEv(i23, i5);
       i30 = HEAP32[i18 >> 2] | 0;
       i5 = HEAP32[i19 >> 2] | 0;
       i28 = HEAP32[i20 >> 2] | 0;
       i29 = (HEAP32[i21 >> 2] | 0) + i22 | 0;
       HEAP32[i29 + (i2 << 4) >> 2] = HEAP32[i23 >> 2];
       HEAP32[i29 + (i2 << 4) + 4 >> 2] = i30;
       HEAP32[i29 + (i2 << 4) + 8 >> 2] = i5;
       HEAP32[i29 + (i2 << 4) + 12 >> 2] = i28;
      }
      i2 = i2 + 1 | 0;
      break;
     }
    case 3:
     {
      if (i5 | 0) {
       __ZNK9Transform13GetLocalScaleEv(i23, i5);
       i28 = HEAP32[i10 >> 2] | 0;
       i29 = HEAP32[i12 >> 2] | 0;
       i30 = (HEAP32[i7 >> 2] | 0) + i8 | 0;
       HEAP32[i30 + (i3 * 12 | 0) >> 2] = HEAP32[i23 >> 2];
       HEAP32[i30 + (i3 * 12 | 0) + 4 >> 2] = i28;
       HEAP32[i30 + (i3 * 12 | 0) + 8 >> 2] = i29;
      }
      i3 = i3 + 1 | 0;
      break;
     }
    default:
     {}
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i14 | 0)) break L1;
   }
  }
 } else if ((i2 | 0) != 0 & (i1 | 0) != 0) {
  i15 = i26 + 4 | 0;
  __ZN7mecanim9animation21ValueFromSkeletonPoseERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapERNS_10ValueArrayE(i2, i1, HEAP32[i26 + 8 >> 2] | 0, HEAP32[i15 >> 2] | 0);
  break;
 } else {
  i15 = i26 + 4 | 0;
  break;
 } while (0);
 i7 = i24 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i8 = i24 + 12 | 0;
  i9 = (HEAP32[i15 >> 2] | 0) + 28 | 0;
  i10 = i9;
  i6 = 0;
  do {
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i2 + (i6 << 4) + 4 >> 2] | 0;
   if (i3) {
    i5 = i2 + (i6 << 4) | 0;
    switch (i3 | 0) {
    case 5:
     {
      f4 = Math_fround(HEAPF32[HEAP32[i5 >> 2] >> 2]);
      break;
     }
    case 6:
     {
      f4 = HEAP8[HEAP32[i5 >> 2] >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
      break;
     }
    case 7:
     {
      f4 = HEAP8[(HEAP32[i2 + (i6 << 4) + 12 >> 2] | 0) + 54 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
      break;
     }
    default:
     {
      i1 = HEAP32[i2 + (i6 << 4) + 8 >> 2] | 0;
      f4 = Math_fround(+mftCall_fii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0));
      i1 = HEAP32[i7 >> 2] | 0;
     }
    }
    HEAPF32[(HEAP32[i9 >> 2] | 0) + i10 + (i6 << 2) >> 2] = f4;
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i1 >>> 0);
 }
 i9 = i24 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i6 = i24 + 20 | 0;
  i7 = (HEAP32[i15 >> 2] | 0) + 36 | 0;
  i8 = i7;
  i5 = 0;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i2 + (i5 << 4) + 4 >> 2] | 0;
   if (i3) {
    i1 = i2 + (i5 << 4) | 0;
    if ((i3 | 0) == 9) i1 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0; else {
     i30 = HEAP32[i2 + (i5 << 4) + 8 >> 2] | 0;
     i1 = mftCall_iii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0) | 0;
    }
    HEAP32[(HEAP32[i7 >> 2] | 0) + i8 + (i5 << 2) >> 2] = i1;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 i1 = HEAP32[i26 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 i28 = i1 + 16 | 0;
 i24 = HEAP32[i28 >> 2] | 0;
 i30 = i1 + 20 | 0;
 i29 = HEAP32[i30 >> 2] | 0;
 __ZN7mecanim21ValueArrayReverseCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi((i24 | 0) == 0 ? 0 : i24 + i28 | 0, (i29 | 0) == 0 ? 0 : i29 + i30 | 0, HEAP32[i26 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i25 + 16 >> 2] | 0);
 STACKTOP = i27;
 return;
}

function __ZN22NavMeshProjectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 32 | 0;
 i13 = i15 + 16 | 0;
 i11 = i15;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8);
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i6 = i13 + 8 | 0;
 i7 = i12 + 4 | 0;
 i1 = 0;
 i5 = 0;
 i3 = 0;
 while (1) {
  i2 = i10 + 28 + (i1 * 20 | 0) | 0;
  if ((i5 | 0) == (i3 | 0)) __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i13, i2); else {
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   i16 = i4 << 24 >> 24 < 0;
   i3 = i16 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = i16 ? HEAP32[i10 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i9 = 11;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i5 + 11 >> 0] = i4;
    if (!i4) i2 = i5; else {
     i2 = i5;
     i9 = 13;
    }
   } else i9 = 11;
   if ((i9 | 0) == 11) {
    i16 = i4 + 16 & -16;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i7 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i16 | -2147483648;
    HEAP32[i5 + 4 >> 2] = i4;
    i9 = 13;
   }
   if ((i9 | 0) == 13) {
    i9 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i10 + 28 + (i1 * 20 | 0) + 16 >> 2];
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 20;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i5 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i12 >> 2] = i3;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i12, 4);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i10 + 28 | 0;
 i6 = i1 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i10 + 32 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = i2 & 255;
  i5 = i1;
 }
 i3 = i4 >>> 0 > 7;
 i2 = i3 ? 7 : i4;
 if (!i2) i9 = 23; else if (!(_memcmp(i5, gb + 1012705 | 0, i2) | 0)) i9 = 23;
 if ((i9 | 0) == 23) if (i4 >>> 0 > 6 & (i3 ^ 1)) {
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i11 + 11 | 0;
  HEAP8[i4 >> 0] = 8;
  i16 = i11;
  HEAP32[i16 >> 2] = 1802264919;
  HEAP32[i16 + 4 >> 2] = 1701601889;
  HEAP8[i11 + 8 >> 0] = 0;
  L35 : do if ((i1 | 0) != (i11 | 0)) {
   do if ((HEAP8[i6 >> 0] | 0) < 0) {
    i2 = HEAP32[i10 + 36 >> 2] & 2147483647;
    i3 = i2 + -1 | 0;
    if (i3 >>> 0 < 8) {
     i16 = HEAP32[i10 + 32 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i16, 0, i16, 8, i11);
     break L35;
    } else {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } while (0);
   i9 = i11;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i16 = i1;
   i8 = i16;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i16 = i16 + 4 | 0;
   HEAP8[i16 >> 0] = i9;
   HEAP8[i16 + 1 >> 0] = i9 >> 8;
   HEAP8[i16 + 2 >> 0] = i9 >> 16;
   HEAP8[i16 + 3 >> 0] = i9 >> 24;
   HEAP8[i1 + 8 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i10 + 32 >> 2] = 8;
    break;
   } else {
    HEAP8[i6 >> 0] = 8;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i16 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i16, i12);
  }
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i14 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i12);
    i2 = HEAP32[i14 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i15;
 return;
}

function __ZN9Rigidbody16TransformChangedEi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 72 | 0;
 i8 = i11 + 44 | 0;
 i9 = i11 + 16 | 0;
 i2 = i11;
 i10 = i4 + 52 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = HEAP8[i4 + 84 >> 0] | 0;
 i6 = i3 << 24 >> 24 != 0;
 if (!((HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 58 >> 0] | i3) << 24 >> 24)) {
  i3 = HEAP32[i10 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 256 >> 2] | 0, i3 | 0) | 0)) {
   STACKTOP = i11;
   return;
  }
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 if (!((i5 & 3 | 0) != 3 & (i5 & 8 | 0) == 0)) {
  __ZNK9Transform11GetPositionEv(i7, i1);
  __ZNK9Transform11GetRotationEv(i8, i1);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  i13 = HEAP32[i8 + 4 >> 2] | 0;
  i12 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = i13;
  HEAP32[i9 + 8 >> 2] = i12;
  HEAP32[i9 + 12 >> 2] = i1;
  HEAP32[i9 + 16 >> 2] = i2;
  HEAP32[i9 + 20 >> 2] = i3;
  HEAP32[i9 + 24 >> 2] = i7;
  if (i6) {
   if (!(i5 & 32)) {
    i13 = HEAP32[i10 >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] | 0, i13 | 0, i9 | 0, 1);
   }
   if (HEAP8[i4 + 80 >> 0] | 0) {
    i13 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 224 >> 2] | 0, i13 | 0, i9 | 0);
   }
   i13 = i4 + 104 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i9 | 0, 1);
   i1 = HEAP32[i4 + 108 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 40 >> 2] = 1;
  }
  STACKTOP = i11;
  return;
 }
 if (i5 & 2 | 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i9 | 0, i12 | 0);
  __ZNK9Transform11GetRotationEv(i2, i1);
  i12 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  i13 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  i1 = i9 + 4 | 0;
  HEAP32[i1 >> 2] = i12;
  i2 = i9 + 8 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = i13;
  if (i6) {
   if (!(i5 & 32)) {
    i13 = HEAP32[i10 >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] | 0, i13 | 0, i9 | 0, 1);
   }
   if (HEAP8[i4 + 80 >> 0] | 0) {
    i13 = HEAP32[i10 >> 2] | 0;
    if (!(mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 228 >> 2] | 0, i13 | 0, i8 | 0) | 0)) {
     i12 = HEAP32[i10 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i12 | 0);
     i12 = HEAP32[i7 + 20 >> 2] | 0;
     i13 = HEAP32[i7 + 24 >> 2] | 0;
     HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
     HEAP32[i8 + 20 >> 2] = i12;
     HEAP32[i8 + 24 >> 2] = i13;
    }
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i3 >> 2];
    i13 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 224 >> 2] | 0, i13 | 0, i8 | 0);
   }
   i13 = i4 + 104 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i9 | 0, 1);
   i1 = HEAP32[i4 + 108 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 40 >> 2] = 1;
  }
  STACKTOP = i11;
  return;
 }
 if (!(i5 & 1)) {
  STACKTOP = i11;
  return;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i9 | 0, i3 | 0);
 __ZNK9Transform11GetPositionEv(i2, i1);
 i3 = i9 + 16 | 0;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 i1 = i9 + 20 | 0;
 HEAP32[i1 >> 2] = i12;
 i2 = i9 + 24 | 0;
 HEAP32[i2 >> 2] = i13;
 if (i6) {
  if (!(i5 & 32)) {
   i13 = HEAP32[i10 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] | 0, i13 | 0, i9 | 0, 1);
  }
  if (HEAP8[i4 + 80 >> 0] | 0) {
   i13 = HEAP32[i10 >> 2] | 0;
   if (!(mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 228 >> 2] | 0, i13 | 0, i8 | 0) | 0)) {
    i9 = HEAP32[i10 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i9 | 0);
    i9 = HEAP32[i7 + 4 >> 2] | 0;
    i12 = HEAP32[i7 + 8 >> 2] | 0;
    i13 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = i9;
    HEAP32[i8 + 8 >> 2] = i12;
    HEAP32[i8 + 12 >> 2] = i13;
   }
   HEAP32[i8 + 16 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i2 >> 2];
   i13 = HEAP32[i10 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 224 >> 2] | 0, i13 | 0, i8 | 0);
  }
  i13 = i4 + 104 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
 } else {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i9 | 0, 1);
  i1 = HEAP32[i4 + 108 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 40 >> 2] = 1;
 }
 STACKTOP = i11;
 return;
}

function __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f9 = Math_fround(f4 + f4);
 f15 = Math_fround(f25 + f25);
 f18 = Math_fround(f10 + f10);
 f8 = Math_fround(f25 * f15);
 f24 = Math_fround(f10 * f18);
 f25 = Math_fround(f9 * f25);
 f12 = Math_fround(f9 * f10);
 f14 = Math_fround(f9 * f7);
 f10 = Math_fround(f15 * f10);
 f15 = Math_fround(f15 * f7);
 f7 = Math_fround(f18 * f7);
 f18 = Math_fround(Math_fround(Math_fround(1.0) - f8) - f24);
 f19 = Math_fround(f25 + f7);
 f17 = Math_fround(f12 - f15);
 f7 = Math_fround(f25 - f7);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f4 * f9));
 f24 = Math_fround(f9 - f24);
 f4 = Math_fround(f10 + f14);
 f15 = Math_fround(f12 + f15);
 f14 = Math_fround(f10 - f14);
 f8 = Math_fround(f9 - f8);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(f9 * f18);
 f12 = Math_fround(f9 * f7);
 f9 = Math_fround(f9 * f15);
 f25 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f23 = Math_fround(f19 * f25);
 f20 = Math_fround(f24 * f25);
 f25 = Math_fround(f14 * f25);
 f16 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f17 * f16);
 f5 = Math_fround(f4 * f16);
 f16 = Math_fround(f8 * f16);
 f22 = Math_fround(Math_fround(Math_fround(f18 * f10) + Math_fround(f19 * f23)) + Math_fround(f17 * f6));
 f21 = Math_fround(Math_fround(Math_fround(f18 * f12) + Math_fround(f19 * f20)) + Math_fround(f17 * f5));
 f17 = Math_fround(Math_fround(Math_fround(f18 * f9) + Math_fround(f19 * f25)) + Math_fround(f17 * f16));
 f19 = Math_fround(Math_fround(Math_fround(f7 * f10) + Math_fround(f24 * f23)) + Math_fround(f4 * f6));
 f18 = Math_fround(Math_fround(Math_fround(f7 * f12) + Math_fround(f24 * f20)) + Math_fround(f4 * f5));
 f4 = Math_fround(Math_fround(Math_fround(f7 * f9) + Math_fround(f24 * f25)) + Math_fround(f4 * f16));
 f6 = Math_fround(Math_fround(Math_fround(f15 * f10) + Math_fround(f14 * f23)) + Math_fround(f8 * f6));
 f5 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(f14 * f20)) + Math_fround(f8 * f5));
 f16 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f14 * f25)) + Math_fround(f8 * f16));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f15 = Math_fround(f8 + f8);
 f20 = Math_fround(f25 + f25);
 f12 = Math_fround(f14 + f14);
 f23 = Math_fround(f25 * f20);
 f10 = Math_fround(f14 * f12);
 f25 = Math_fround(f15 * f25);
 f24 = Math_fround(f15 * f14);
 f7 = Math_fround(f15 * f9);
 f14 = Math_fround(f20 * f14);
 f20 = Math_fround(f20 * f9);
 f9 = Math_fround(f12 * f9);
 f12 = Math_fround(Math_fround(Math_fround(1.0) - f23) - f10);
 f13 = Math_fround(f25 + f9);
 f11 = Math_fround(f24 - f20);
 f9 = Math_fround(f25 - f9);
 f15 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f15));
 f10 = Math_fround(f15 - f10);
 f8 = Math_fround(f14 + f7);
 f20 = Math_fround(f24 + f20);
 f7 = Math_fround(f14 - f7);
 f23 = Math_fround(f15 - f23);
 f15 = Math_fround(Math_fround(f6 * f11) + Math_fround(Math_fround(f22 * f12) + Math_fround(f19 * f13)));
 f14 = Math_fround(Math_fround(f5 * f11) + Math_fround(Math_fround(f21 * f12) + Math_fround(f18 * f13)));
 f13 = Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f12) + Math_fround(f4 * f13)));
 f12 = Math_fround(Math_fround(f6 * f8) + Math_fround(Math_fround(f22 * f9) + Math_fround(f19 * f10)));
 f11 = Math_fround(Math_fround(f5 * f8) + Math_fround(Math_fround(f21 * f9) + Math_fround(f18 * f10)));
 f10 = Math_fround(Math_fround(f16 * f8) + Math_fround(Math_fround(f17 * f9) + Math_fround(f4 * f10)));
 f9 = Math_fround(Math_fround(f6 * f23) + Math_fround(Math_fround(f22 * f20) + Math_fround(f19 * f7)));
 f8 = Math_fround(Math_fround(f5 * f23) + Math_fround(Math_fround(f21 * f20) + Math_fround(f18 * f7)));
 f7 = Math_fround(Math_fround(f16 * f23) + Math_fround(Math_fround(f17 * f20) + Math_fround(f4 * f7)));
 f20 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f22 = Math_fround(f22 * f20);
 f21 = Math_fround(f21 * f20);
 f20 = Math_fround(f17 * f20);
 f17 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f19 = Math_fround(f22 + Math_fround(f19 * f17));
 f18 = Math_fround(f21 + Math_fround(f18 * f17));
 f17 = Math_fround(f20 + Math_fround(f4 * f17));
 f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f6 = Math_fround(f19 + Math_fround(f6 * f4));
 f5 = Math_fround(f18 + Math_fround(f5 * f4));
 f4 = Math_fround(f17 + Math_fround(f16 * f4));
 HEAPF32[i1 >> 2] = f15;
 HEAPF32[i1 + 4 >> 2] = f14;
 HEAPF32[i1 + 8 >> 2] = f13;
 HEAPF32[i1 + 12 >> 2] = f12;
 HEAPF32[i1 + 16 >> 2] = f11;
 HEAPF32[i1 + 20 >> 2] = f10;
 HEAPF32[i1 + 24 >> 2] = f9;
 HEAPF32[i1 + 28 >> 2] = f8;
 HEAPF32[i1 + 32 >> 2] = f7;
 HEAPF32[i1 + 36 >> 2] = f6;
 HEAPF32[i1 + 40 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f4;
 return;
}

function __ZN10TagManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 24 | 0;
 i13 = i15 + 12 | 0;
 i10 = i15;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i12);
 i9 = i11 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i11 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i13, i1);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i5 = i13;
  i6 = i14;
  i4 = i2;
 } else {
  do {
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i11, i1, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
  i5 = i13;
  i6 = i14;
  i4 = i1;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if ((i2 | 0) != (i1 | 0)) {
  i2 = 2e4;
  i3 = 0;
  i1 = i4;
  while (1) {
   __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i12, i2, i1 + (i3 << 5) | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i6 >> 2] | 0) - i1 >> 5 >>> 0) break; else i2 = i2 + 1 | 0;
  }
 }
 HEAP32[i10 >> 2] = 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = i10 + 8 | 0;
 i1 = 0;
 do {
  i4 = i12 + 44 + (i1 << 5) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i10, i4); else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i17 = i12 + 44 + (i1 << 5) + 24 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i6 = i2 + 24 | 0;
   HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i6 + 4 >> 2] = i16;
   HEAP8[i2 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i4);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i10, i1);
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i1 = i3; else {
  i1 = i2;
  do {
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i11, i1, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = i2;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i3 - i2 >> 5;
 i3 = (i3 | 0) > 32 ? 32 : i3;
 if ((i3 | 0) > 8) {
  i2 = 8;
  do {
   __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i12, i2, i1 + (i2 << 5) | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i3 | 0));
 }
 if (i1 | 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i12 + 1068 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, 0);
 __ZN10TagManager23AddDefaultLayerIfNeededEv(i12);
 i4 = i12 + 1080 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i17 = (HEAP32[i12 + 1072 >> 2] | 0) - i3 | 0;
 i2 = (i17 | 0) / 40 | 0;
 L48 : do if (i17 | 0) {
  i1 = 0;
  while (1) {
   if (!(HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i2 | 0)) break L48;
  }
  HEAP32[i4 >> 2] = i1;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i14 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i14 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i15;
 return;
}

function _Conic_To(i32, i1, i3, i4, i2) {
 i32 = i32 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0;
 i30 = i32 + 180 | 0;
 i31 = i32 + 52 | 0;
 HEAP32[i31 >> 2] = i30;
 i34 = i32 + 68 | 0;
 HEAP32[i32 + 196 >> 2] = HEAP32[i34 >> 2];
 i33 = i32 + 72 | 0;
 i14 = HEAP32[i33 >> 2] | 0;
 HEAP32[i32 + 200 >> 2] = i14;
 HEAP32[i32 + 188 >> 2] = i1;
 HEAP32[i32 + 192 >> 2] = i3;
 HEAP32[i30 >> 2] = i4;
 HEAP32[i32 + 184 >> 2] = i2;
 i15 = i32 + 100 | 0;
 i16 = i32 + 76 | 0;
 i17 = i32 + 80 | 0;
 i18 = i32 + 86 | 0;
 i19 = i32 + 88 | 0;
 i20 = i32 + 4 | 0;
 i21 = i32 + 8 | 0;
 i22 = i32 + 92 | 0;
 i23 = i32 + 40 | 0;
 i24 = i32 + 36 | 0;
 i25 = i32 + 176 | 0;
 i26 = i32 + 96 | 0;
 i27 = i32 + 87 | 0;
 i28 = i32 + 84 | 0;
 i5 = i30;
 i29 = i2;
 L1 : while (1) {
  i11 = i5 + 20 | 0;
  i12 = i5 + 12 | 0;
  i13 = i5 + 4 | 0;
  i10 = (i14 | 0) > (i29 | 0);
  do if ((i3 | 0) < ((i10 ? i29 : i14) | 0) | (i3 | 0) > ((i10 ? i14 : i29) | 0)) {
   i13 = i5 + 16 | 0;
   i10 = HEAP32[i13 >> 2] | 0;
   HEAP32[i5 + 32 >> 2] = i10;
   i8 = i5 + 8 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   i10 = (i9 + i10 | 0) / 2 | 0;
   HEAP32[i5 + 24 >> 2] = i10;
   i9 = (i4 + i9 | 0) / 2 | 0;
   HEAP32[i8 >> 2] = i9;
   HEAP32[i13 >> 2] = (i9 + i10 | 0) / 2 | 0;
   HEAP32[i5 + 36 >> 2] = i14;
   i14 = (i3 + i14 | 0) / 2 | 0;
   HEAP32[i5 + 28 >> 2] = i14;
   i13 = (i29 + i3 | 0) / 2 | 0;
   HEAP32[i12 >> 2] = i13;
   HEAP32[i11 >> 2] = (i13 + i14 | 0) / 2 | 0;
   HEAP32[i31 >> 2] = i5 + 16;
  } else {
   if ((i14 | 0) == (i29 | 0)) {
    HEAP32[i31 >> 2] = i5 + -16;
    break;
   }
   i10 = (i14 | 0) < (i29 | 0);
   i9 = i10 ? 1 : 2;
   i2 = HEAP32[i15 >> 2] | 0;
   if ((i2 | 0) != (i9 | 0)) {
    i1 = HEAP32[i20 >> 2] | 0;
    if (i10) i8 = ((i14 + -1 + i1 & 0 - i1) - i14 | 0) >= (HEAP32[i21 >> 2] | 0); else i8 = (i1 + -1 & i14 | 0) >= (HEAP32[i21 >> 2] | 0);
    if (i2 | 0) {
     i6 = HEAP32[i23 >> 2] | 0;
     i7 = HEAP32[i19 >> 2] | 0;
     i2 = i6 - (HEAP32[i7 + 8 >> 2] | 0) | 0;
     i1 = i6;
     if ((i2 | 0) < 0) {
      i2 = 12;
      break L1;
     }
     if (i2) {
      HEAP32[i7 + 16 >> 2] = i2 >> 2;
      do if (i8) {
       i2 = i7 + 12 | 0;
       i5 = HEAPU16[i2 >> 1] | 0;
       if (!(i5 & 8)) {
        HEAP16[i2 >> 1] = i5 | 32;
        break;
       } else {
        HEAP16[i2 >> 1] = i5 | 16;
        break;
       }
      } while (0);
      HEAP32[i19 >> 2] = i6;
      i1 = i1 + 32 | 0;
      HEAP32[i23 >> 2] = i1;
      i5 = i6;
      HEAP32[i5 + 16 >> 2] = 0;
      HEAP32[i5 + 8 >> 2] = i1;
      HEAP32[i7 + 28 >> 2] = i6;
      HEAP16[i28 >> 1] = (HEAP16[i28 >> 1] | 0) + 1 << 16 >> 16;
     }
     if (i1 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) {
      i2 = 20;
      break L1;
     }
     HEAP8[i27 >> 0] = 0;
    }
    if (!(HEAP32[i22 >> 2] | 0)) {
     i1 = HEAP32[i23 >> 2] | 0;
     HEAP32[i19 >> 2] = i1;
     HEAP32[i22 >> 2] = i1;
     i1 = i1 + 32 | 0;
     HEAP32[i23 >> 2] = i1;
    } else i1 = HEAP32[i23 >> 2] | 0;
    if (i1 >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) {
     i2 = 26;
     break L1;
    }
    i2 = HEAP32[i19 >> 2] | 0;
    i5 = i2 + 12 | 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    i1 = HEAP8[i25 >> 0] | 0;
    HEAP16[i5 >> 1] = i1 & 255;
    if (i10) {
     i1 = i1 & 255;
     HEAP16[i5 >> 1] = i1 | 8;
     if (i8) HEAP16[i5 >> 1] = i1 | 40;
    } else if (i8) HEAP16[i5 >> 1] = i1 & 255 | 16;
    if (!(HEAP32[i26 >> 2] | 0)) HEAP32[i26 >> 2] = i2;
    HEAP32[i15 >> 2] = i9;
    HEAP8[i18 >> 0] = 1;
    HEAP8[i27 >> 0] = 0;
   }
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   if (i10) if (!((_Bezier_Up(i32, 2, fb + 3857 | 0, i1, i2) | 0) << 24 >> 24)) break; else {
    i1 = 1;
    i2 = 44;
    break L1;
   }
   HEAP32[i13 >> 2] = 0 - i29;
   HEAP32[i12 >> 2] = 0 - i3;
   HEAP32[i11 >> 2] = 0 - i14;
   i14 = HEAP8[i18 >> 0] | 0;
   i1 = _Bezier_Up(i32, 2, fb + 3857 | 0, 0 - i2 | 0, 0 - i1 | 0) | 0;
   if (i14 << 24 >> 24) if (!(HEAP8[i18 >> 0] | 0)) {
    i14 = (HEAP32[i19 >> 2] | 0) + 20 | 0;
    HEAP32[i14 >> 2] = 0 - (HEAP32[i14 >> 2] | 0);
   }
   HEAP32[i13 >> 2] = 0 - (HEAP32[i13 >> 2] | 0);
   if (i1 << 24 >> 24) {
    i1 = 1;
    i2 = 44;
    break L1;
   }
  } while (0);
  i1 = HEAP32[i31 >> 2] | 0;
  if (i1 >>> 0 < i30 >>> 0) {
   i2 = 43;
   break;
  }
  i5 = i1;
  i14 = HEAP32[i1 + 20 >> 2] | 0;
  i29 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) == 12) {
  HEAP32[i32 + 44 >> 2] = 99;
  i34 = 1;
  return i34 | 0;
 } else if ((i2 | 0) == 20) {
  HEAP32[i32 + 44 >> 2] = 98;
  i34 = 1;
  return i34 | 0;
 } else if ((i2 | 0) == 26) {
  HEAP32[i32 + 44 >> 2] = 98;
  i34 = 1;
  return i34 | 0;
 } else if ((i2 | 0) == 43) {
  HEAP32[i34 >> 2] = i4;
  HEAP32[i33 >> 2] = i29;
  i34 = 0;
  return i34 | 0;
 } else if ((i2 | 0) == 44) return i1 | 0;
 return 0;
}

function __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 12 | 0, i9 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 28 | 0, i9 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj293ES3_NS_19PxHeightFieldFormat4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10 + 44 | 0, i9 + 3 | 0);
 i5 = i10 + 76 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i6;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj295ENS_22PxRepXPropertyAccessorILj295ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i10 + 92 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj296ENS_22PxRepXPropertyAccessorILj296ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i10 = i10 + 108 | 0;
  i12 = i9 + 7 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj297ES3_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
  i12 = i9 + 8 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i10 = i10 + 108 | 0;
 i12 = i9 + 7 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj297ES3_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i10, i12);
 i12 = i9 + 8 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 8 | 0;
 i8 = i12;
 i6 = i10 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + -6 | 0;
 if (i2 >>> 0 >= 9) {
  STACKTOP = i12;
  return;
 }
 if (!(385 >>> (i2 & 511) & 1)) {
  STACKTOP = i12;
  return;
 }
 i5 = i10 + 100 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i12;
  return;
 }
 L10 : do if ((i1 | 0) == 13) {
  i4 = i10 + 48 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 11; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 13;
   }
   if ((i9 | 0) == 11) i9 = 13;
   if ((i9 | 0) == 13) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) break;
   i1 = HEAP32[i6 >> 2] | 0;
   i9 = 16;
   break L10;
  } while (0);
  HEAP32[i10 + 72 >> 2] = 0;
  i13 = i10 + 76 | 0;
  HEAP32[i13 >> 2] = HEAP32[gb + 1155204 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 } else i9 = 16; while (0);
 do if ((i9 | 0) == 16) if ((i1 | 0) == 14) {
  i4 = i10 + 52 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 23; else if (HEAP32[i1 + 4 >> 2] | 0) break;
   }
   if (__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0) break;
  }
  HEAP32[i10 + 72 >> 2] = 0;
  i13 = i10 + 76 | 0;
  HEAP32[i13 >> 2] = HEAP32[gb + 1155204 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 } while (0);
 i2 = i10 + 72 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN11ShapeModule16UpdateCachedMeshEv(i10);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i9 = 29;
 } else i9 = 29;
 if ((i9 | 0) == 29) HEAP32[i5 >> 2] = __ZN4Mesh21AcquireSharedMeshDataEv(i1) | 0;
 if ((HEAP32[i6 >> 2] | 0) != 14) {
  STACKTOP = i12;
  return;
 }
 i4 = i10 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 37; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 37; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 39;
  }
 }
 if ((i9 | 0) == 37) i9 = 39;
 if ((i9 | 0) == 39) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i12;
   return;
  }
 }
 HEAP32[i10 + 136 >> 2] = __ZN19SkinnedMeshRenderer17PrepareSkinCustomERK10Matrix4x4f(i1, i11) | 0;
 STACKTOP = i12;
 return;
}

function __ZN9ShaderLab16SerializedShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i6 = i9 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 88 | 0;
 HEAP32[i8 >> 2] = i4;
 i12 = i10 + 16 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i3 = i5 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab18SerializedProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 88 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 12 | 0;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 28 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab19SerializedSubShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = i9 + 24 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 28 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 40 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 44 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 56 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i9 + 60 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i3 = i9 + 72 | 0;
 i7 = i9 + 76 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 5;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab26SerializedShaderDependency8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 84 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
}

function __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf(i1, i55, i56, i57) {
 i1 = i1 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i61 + 16 | 0;
 i60 = i61 + 4 | 0;
 i58 = i61;
 HEAP32[i59 >> 2] = 0;
 HEAP32[i59 + 4 >> 2] = 0;
 i15 = i59 + 8 | 0;
 HEAP32[i15 >> 2] = -1;
 i26 = i59 + 12 | 0;
 HEAP16[i26 >> 1] = 0;
 i52 = i59 + 16 | 0;
 i47 = i59 + 40 | 0;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 HEAP32[i52 + 12 >> 2] = 0;
 HEAP32[i52 + 16 >> 2] = 0;
 HEAP32[i52 + 20 >> 2] = 0;
 HEAPF32[i47 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i52 = i59 + 44 | 0;
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 HEAPF32[i59 + 48 >> 2] = Math_fround(0.0);
 if (!i55) {
  i60 = 1;
  STACKTOP = i61;
  return i60 | 0;
 }
 i53 = i1 + 16 | 0;
 i54 = i1 + 20 | 0;
 i16 = i1 + 24 | 0;
 i17 = i60 + 4 | 0;
 i18 = i60 + 8 | 0;
 i19 = i1 + 181 | 0;
 i20 = i1 + 12 | 0;
 i21 = i1 + 64 | 0;
 i22 = i1 + 108 | 0;
 i23 = i1 + 68 | 0;
 i24 = i1 + 80 | 0;
 i25 = i1 + 84 | 0;
 i27 = i59 + 16 | 0;
 i28 = i59 + 20 | 0;
 i29 = i1 + 88 | 0;
 i30 = i59 + 24 | 0;
 i31 = i1 + 92 | 0;
 i32 = i1 + 96 | 0;
 i33 = i59 + 28 | 0;
 i34 = i59 + 32 | 0;
 i35 = i1 + 100 | 0;
 i36 = i59 + 36 | 0;
 i37 = i1 + 104 | 0;
 i38 = i1 + 112 | 0;
 i39 = i1 + 132 | 0;
 i40 = i1 + 136 | 0;
 i41 = i1 + 140 | 0;
 i42 = i1 + 144 | 0;
 i43 = i1 + 148 | 0;
 i44 = i1 + 152 | 0;
 i45 = i1 + 156 | 0;
 i46 = i1 + 160 | 0;
 i48 = i1 + 164 | 0;
 i49 = i1 + 168 | 0;
 i50 = i1 + 172 | 0;
 i51 = i1 + 176 | 0;
 i10 = i1 + 180 | 0;
 i14 = 0;
 L4 : while (1) {
  i12 = HEAP32[i56 + (i14 << 2) >> 2] | 0;
  i11 = (i12 >>> 1 & 15) + 1 | 0;
  i12 = i12 >>> 5;
  i13 = 0;
  do {
   i2 = i13 + i12 | 0;
   i1 = HEAP32[HEAP32[i54 >> 2] >> 2] | 0;
   if (!(HEAP32[i53 >> 2] | 0)) {
    i9 = i1 + (i2 * 12 | 0) | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i9 + 4 >> 2] | 0;
    i9 = HEAP32[i9 + 8 >> 2] | 0;
   } else {
    i9 = i1 + (i2 * 6 | 0) | 0;
    i5 = HEAPU16[i9 >> 1] | 0;
    i7 = HEAPU16[i9 + 2 >> 1] | 0;
    i9 = HEAPU16[i9 + 4 >> 1] | 0;
   }
   i1 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i4 = i1 + (i5 * 12 | 0) | 0;
   i6 = i1 + (i7 * 12 | 0) | 0;
   i8 = i1 + (i9 * 12 | 0) | 0;
   HEAP32[i60 >> 2] = i5;
   HEAP32[i17 >> 2] = i7;
   HEAP32[i18 >> 2] = i9;
   HEAP32[i15 >> 2] = i2;
   HEAP16[i26 >> 1] = 5;
   if (!(HEAP8[i19 >> 0] | 0)) {
    HEAP32[i58 >> 2] = HEAP32[i57 >> 2];
    i9 = HEAP32[i20 >> 2] | 0;
    if (!(mftCall_iiiiiiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i59 | 0, i4 | 0, i6 | 0, i8 | 0, i58 | 0, i60 | 0) | 0)) {
     i1 = 0;
     i2 = 16;
     break L4;
    }
    f3 = Math_fround(HEAPF32[i58 >> 2]);
    if (f3 < Math_fround(HEAPF32[i57 >> 2])) {
     HEAPF32[i57 >> 2] = f3;
     HEAPF32[i21 >> 2] = f3;
    }
   } else {
    f3 = Math_fround(HEAPF32[i47 >> 2]);
    if (f3 < Math_fround(HEAPF32[i22 >> 2])) {
     HEAP32[i23 >> 2] = HEAP32[i59 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
     HEAP16[i24 >> 1] = 5;
     HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
     HEAPF32[i22 >> 2] = f3;
     HEAP32[i38 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i38 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
     HEAP32[i38 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
     HEAP32[i38 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
     HEAP32[i38 + 16 >> 2] = HEAP32[i52 + 16 >> 2];
     f62 = Math_fround(HEAPF32[i57 >> 2]);
     HEAPF32[i57 >> 2] = f3 < f62 ? f3 : f62;
     HEAP32[i39 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i40 >> 2] = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i41 >> 2] = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2];
     HEAP32[i42 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i43 >> 2] = HEAP32[i1 + (i7 * 12 | 0) + 4 >> 2];
     HEAP32[i44 >> 2] = HEAP32[i1 + (i7 * 12 | 0) + 8 >> 2];
     HEAP32[i45 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i46 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 4 >> 2];
     HEAP32[i48 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 8 >> 2];
     HEAP32[i49 >> 2] = i5;
     HEAP32[i50 >> 2] = i7;
     HEAP32[i51 >> 2] = i9;
     HEAP8[i10 >> 0] = 1;
    }
   }
   i13 = i13 + 1 | 0;
   if (!(HEAP32[(HEAP32[i20 >> 2] | 0) + 4 >> 2] | 0)) {
    i1 = 0;
    i2 = 16;
    break L4;
   }
  } while (i13 >>> 0 < i11 >>> 0);
  i14 = i14 + 1 | 0;
  if (i14 >>> 0 >= i55 >>> 0) {
   i1 = 1;
   i2 = 16;
   break;
  }
 }
 if ((i2 | 0) == 16) {
  STACKTOP = i61;
  return i1 | 0;
 }
 return 0;
}

function __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf(i1, i55, i56, i57) {
 i1 = i1 | 0;
 i55 = i55 | 0;
 i56 = i56 | 0;
 i57 = i57 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, f62 = f0;
 i61 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i59 = i61 + 16 | 0;
 i60 = i61 + 4 | 0;
 i58 = i61;
 HEAP32[i59 >> 2] = 0;
 HEAP32[i59 + 4 >> 2] = 0;
 i15 = i59 + 8 | 0;
 HEAP32[i15 >> 2] = -1;
 i26 = i59 + 12 | 0;
 HEAP16[i26 >> 1] = 0;
 i52 = i59 + 16 | 0;
 i47 = i59 + 40 | 0;
 HEAP32[i52 >> 2] = 0;
 HEAP32[i52 + 4 >> 2] = 0;
 HEAP32[i52 + 8 >> 2] = 0;
 HEAP32[i52 + 12 >> 2] = 0;
 HEAP32[i52 + 16 >> 2] = 0;
 HEAP32[i52 + 20 >> 2] = 0;
 HEAPF32[i47 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i52 = i59 + 44 | 0;
 HEAPF32[i52 >> 2] = Math_fround(0.0);
 HEAPF32[i59 + 48 >> 2] = Math_fround(0.0);
 if (!i55) {
  i60 = 1;
  STACKTOP = i61;
  return i60 | 0;
 }
 i53 = i1 + 16 | 0;
 i54 = i1 + 20 | 0;
 i16 = i1 + 24 | 0;
 i17 = i60 + 4 | 0;
 i18 = i60 + 8 | 0;
 i19 = i1 + 181 | 0;
 i20 = i1 + 12 | 0;
 i21 = i1 + 64 | 0;
 i22 = i1 + 108 | 0;
 i23 = i1 + 68 | 0;
 i24 = i1 + 80 | 0;
 i25 = i1 + 84 | 0;
 i27 = i59 + 16 | 0;
 i28 = i59 + 20 | 0;
 i29 = i1 + 88 | 0;
 i30 = i59 + 24 | 0;
 i31 = i1 + 92 | 0;
 i32 = i1 + 96 | 0;
 i33 = i59 + 28 | 0;
 i34 = i59 + 32 | 0;
 i35 = i1 + 100 | 0;
 i36 = i59 + 36 | 0;
 i37 = i1 + 104 | 0;
 i38 = i1 + 112 | 0;
 i39 = i1 + 132 | 0;
 i40 = i1 + 136 | 0;
 i41 = i1 + 140 | 0;
 i42 = i1 + 144 | 0;
 i43 = i1 + 148 | 0;
 i44 = i1 + 152 | 0;
 i45 = i1 + 156 | 0;
 i46 = i1 + 160 | 0;
 i48 = i1 + 164 | 0;
 i49 = i1 + 168 | 0;
 i50 = i1 + 172 | 0;
 i51 = i1 + 176 | 0;
 i10 = i1 + 180 | 0;
 i14 = 0;
 L4 : while (1) {
  i12 = HEAP32[i56 + (i14 << 2) >> 2] | 0;
  i11 = (i12 >>> 1 & 15) + 1 | 0;
  i12 = i12 >>> 5;
  i13 = 0;
  do {
   i2 = i13 + i12 | 0;
   i1 = HEAP32[HEAP32[i54 >> 2] >> 2] | 0;
   if (!(HEAP32[i53 >> 2] | 0)) {
    i9 = i1 + (i2 * 12 | 0) | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    i7 = HEAP32[i9 + 4 >> 2] | 0;
    i9 = HEAP32[i9 + 8 >> 2] | 0;
   } else {
    i9 = i1 + (i2 * 6 | 0) | 0;
    i5 = HEAPU16[i9 >> 1] | 0;
    i7 = HEAPU16[i9 + 2 >> 1] | 0;
    i9 = HEAPU16[i9 + 4 >> 1] | 0;
   }
   i1 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i4 = i1 + (i5 * 12 | 0) | 0;
   i6 = i1 + (i7 * 12 | 0) | 0;
   i8 = i1 + (i9 * 12 | 0) | 0;
   HEAP32[i60 >> 2] = i5;
   HEAP32[i17 >> 2] = i7;
   HEAP32[i18 >> 2] = i9;
   HEAP32[i15 >> 2] = i2;
   HEAP16[i26 >> 1] = 5;
   if (!(HEAP8[i19 >> 0] | 0)) {
    HEAP32[i58 >> 2] = HEAP32[i57 >> 2];
    i9 = HEAP32[i20 >> 2] | 0;
    if (!(mftCall_iiiiiiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i59 | 0, i4 | 0, i6 | 0, i8 | 0, i58 | 0, i60 | 0) | 0)) {
     i1 = 0;
     i2 = 16;
     break L4;
    }
    f3 = Math_fround(HEAPF32[i58 >> 2]);
    if (f3 < Math_fround(HEAPF32[i57 >> 2])) {
     HEAPF32[i57 >> 2] = f3;
     HEAPF32[i21 >> 2] = f3;
    }
   } else {
    f3 = Math_fround(HEAPF32[i47 >> 2]);
    if (f3 < Math_fround(HEAPF32[i22 >> 2])) {
     HEAP32[i23 >> 2] = HEAP32[i59 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i59 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i59 + 8 >> 2];
     HEAP16[i24 >> 1] = 5;
     HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
     HEAP32[i29 >> 2] = HEAP32[i28 >> 2];
     HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
     HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
     HEAP32[i35 >> 2] = HEAP32[i34 >> 2];
     HEAP32[i37 >> 2] = HEAP32[i36 >> 2];
     HEAPF32[i22 >> 2] = f3;
     HEAP32[i38 >> 2] = HEAP32[i52 >> 2];
     HEAP32[i38 + 4 >> 2] = HEAP32[i52 + 4 >> 2];
     HEAP32[i38 + 8 >> 2] = HEAP32[i52 + 8 >> 2];
     HEAP32[i38 + 12 >> 2] = HEAP32[i52 + 12 >> 2];
     HEAP32[i38 + 16 >> 2] = HEAP32[i52 + 16 >> 2];
     f62 = Math_fround(HEAPF32[i57 >> 2]);
     HEAPF32[i57 >> 2] = f3 < f62 ? f3 : f62;
     HEAP32[i39 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i40 >> 2] = HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2];
     HEAP32[i41 >> 2] = HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2];
     HEAP32[i42 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i43 >> 2] = HEAP32[i1 + (i7 * 12 | 0) + 4 >> 2];
     HEAP32[i44 >> 2] = HEAP32[i1 + (i7 * 12 | 0) + 8 >> 2];
     HEAP32[i45 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i46 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 4 >> 2];
     HEAP32[i48 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 8 >> 2];
     HEAP32[i49 >> 2] = i5;
     HEAP32[i50 >> 2] = i7;
     HEAP32[i51 >> 2] = i9;
     HEAP8[i10 >> 0] = 1;
    }
   }
   i13 = i13 + 1 | 0;
   if (!(HEAP32[(HEAP32[i20 >> 2] | 0) + 4 >> 2] | 0)) {
    i1 = 0;
    i2 = 16;
    break L4;
   }
  } while (i13 >>> 0 < i11 >>> 0);
  i14 = i14 + 1 | 0;
  if (i14 >>> 0 >= i55 >>> 0) {
   i1 = 1;
   i2 = 16;
   break;
  }
 }
 if ((i2 | 0) == 16) {
  STACKTOP = i61;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i21, i15, i16, i1) {
 i21 = i21 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 i14 = i15 + 28 | 0;
 f23 = Math_fround(HEAPF32[i14 >> 2]);
 i7 = i21 + 28 | 0;
 i19 = f23 < Math_fround(HEAPF32[i7 >> 2]);
 i8 = i16 + 28 | 0;
 i1 = Math_fround(HEAPF32[i8 >> 2]) < f23;
 if (!i19) {
  if (!i1) {
   i21 = 0;
   STACKTOP = i22;
   return i21 | 0;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  i9 = i15 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i10 = i15 + 8 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i11 = i15 + 12 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i12 = i15 + 16 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i13 = i15 + 20 | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  i8 = i15 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i17 = i15;
  i18 = i16;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 4 >> 2] = i2;
  HEAP32[i16 + 8 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i4;
  HEAP32[i16 + 16 >> 2] = i5;
  HEAP32[i16 + 20 >> 2] = i6;
  i19 = i16 + 24 | 0;
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  f23 = Math_fround(HEAPF32[i14 >> 2]);
  if (!(f23 < Math_fround(HEAPF32[i7 >> 2]))) {
   i21 = 1;
   STACKTOP = i22;
   return i21 | 0;
  }
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i21 + 20 >> 2] | 0;
  i17 = i21 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i21;
  i18 = i15;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i21 = 2;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (i1) {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i21 + 20 >> 2] | 0;
  i17 = i21 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i21;
  i18 = i16;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 4 >> 2] = i2;
  HEAP32[i16 + 8 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i4;
  HEAP32[i16 + 16 >> 2] = i5;
  HEAP32[i16 + 20 >> 2] = i6;
  i21 = i16 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i2 = HEAP32[i21 >> 2] | 0;
 i3 = HEAP32[i21 + 4 >> 2] | 0;
 i4 = HEAP32[i21 + 8 >> 2] | 0;
 i5 = HEAP32[i21 + 12 >> 2] | 0;
 i6 = HEAP32[i21 + 16 >> 2] | 0;
 i7 = HEAP32[i21 + 20 >> 2] | 0;
 i17 = i21 + 24 | 0;
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i17 = i21;
 i18 = i15;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i15 + 4 >> 2] = i3;
 HEAP32[i15 + 8 >> 2] = i4;
 HEAP32[i15 + 12 >> 2] = i5;
 HEAP32[i15 + 16 >> 2] = i6;
 HEAP32[i15 + 20 >> 2] = i7;
 i1 = i15 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 f23 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(f23 < Math_fround(HEAPF32[i14 >> 2]))) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 };
 HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i17 = i15;
 i18 = i16;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i16 >> 2] = i2;
 HEAP32[i16 + 4 >> 2] = i3;
 HEAP32[i16 + 8 >> 2] = i4;
 HEAP32[i16 + 12 >> 2] = i5;
 HEAP32[i16 + 16 >> 2] = i6;
 HEAP32[i16 + 20 >> 2] = i7;
 i21 = i16 + 24 | 0;
 HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 i21 = 2;
 STACKTOP = i22;
 return i21 | 0;
}

function __Z5SlerpRK8Vector3fS1_f(i13, i1, i6, f14) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 f14 = Math_fround(f14);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 36 | 0;
 i16 = i17;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f8 * f8);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f11 * f11));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9))));
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 f2 = Math_fround(f5 * f5);
 f7 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f7 * f7));
 f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(Math_sqrt(Math_fround(f2 + Math_fround(f3 * f3))));
 if (f10 < Math_fround(9.99999974e-06) | f2 < Math_fround(9.99999974e-06)) {
  f10 = Math_fround(Math_fround(1.0) - f14);
  f11 = Math_fround(Math_fround(f10 * f11) + Math_fround(f7 * f14));
  f12 = Math_fround(Math_fround(f10 * f9) + Math_fround(f3 * f14));
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f10 * f8) + Math_fround(f5 * f14));
  HEAPF32[i13 + 4 >> 2] = f11;
  HEAPF32[i13 + 8 >> 2] = f12;
  STACKTOP = i17;
  return;
 }
 f4 = Math_fround(Math_fround(1.0) - f14);
 f12 = Math_fround(Math_fround(f4 * f10) + Math_fround(f2 * f14));
 f2 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f5) + Math_fround(f11 * f7)) + Math_fround(f9 * f3)) / Math_fround(f10 * f2));
 if (f2 > Math_fround(.999989986)) {
  f11 = Math_fround(Math_fround(f4 * f11) + Math_fround(f7 * f14));
  f12 = Math_fround(Math_fround(f4 * f9) + Math_fround(f3 * f14));
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f4 * f8) + Math_fround(f5 * f14));
  HEAPF32[i13 + 4 >> 2] = f11;
  HEAPF32[i13 + 8 >> 2] = f12;
  STACKTOP = i17;
  return;
 }
 if (!(f2 < Math_fround(-.999989986))) {
  f4 = Math_fround(Math_fround(f11 * f3) - Math_fround(f9 * f7));
  f18 = Math_fround(Math_fround(f9 * f5) - Math_fround(f3 * f8));
  f3 = Math_fround(Math_fround(f7 * f8) - Math_fround(f11 * f5));
  f7 = Math_fround(f8 / f10);
  f8 = Math_fround(f11 / f10);
  f9 = Math_fround(f9 / f10);
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f4 * f4) + Math_fround(f18 * f18)))));
  f11 = Math_fround(f18 / f5);
  f10 = Math_fround(f3 / f5);
  HEAPF32[i15 >> 2] = Math_fround(f4 / f5);
  HEAPF32[i15 + 4 >> 2] = f11;
  HEAPF32[i15 + 8 >> 2] = f10;
  __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff(i16, i15, Math_fround(Math_fround(+Math_acos(+f2)) * f14)) | 0;
  f10 = Math_fround(f7 * Math_fround(HEAPF32[i16 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i16 + 12 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 24 >> 2])));
  f11 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 4 >> 2]));
  f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i16 + 16 >> 2])));
  f11 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 28 >> 2])));
  f14 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 8 >> 2]));
  f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i16 + 20 >> 2])));
  f14 = Math_fround(f14 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 32 >> 2])));
  HEAPF32[i13 >> 2] = Math_fround(f12 * f10);
  HEAPF32[i13 + 4 >> 2] = Math_fround(f12 * f11);
  HEAPF32[i13 + 8 >> 2] = Math_fround(f12 * f14);
  STACKTOP = i17;
  return;
 }
 f8 = Math_fround(f8 / f10);
 f7 = Math_fround(f11 / f10);
 f5 = Math_fround(f9 / f10);
 i6 = f5 < Math_fround(0.0);
 f18 = Math_fround(-f5);
 if ((i6 ? f18 : f5) > Math_fround(.707106769)) {
  f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f7 * f7)))));
  f2 = Math_fround(f7 * f3);
  f3 = Math_fround(-Math_fround(f5 * f3));
  f4 = Math_fround(0.0);
 } else {
  f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)))));
  f2 = Math_fround(0.0);
  f3 = Math_fround(f8 * f4);
  f4 = Math_fround(-Math_fround(f7 * f4));
 }
 HEAPF32[i15 >> 2] = f4;
 HEAPF32[i15 + 4 >> 2] = f3;
 HEAPF32[i15 + 8 >> 2] = f2;
 __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff(i16, i15, Math_fround(f14 * Math_fround(3.14159274))) | 0;
 f11 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 12 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f5 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 f14 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i16 + 28 >> 2])));
 f18 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f18 = Math_fround(f18 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f18 = Math_fround(f18 + Math_fround(f5 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 HEAPF32[i13 >> 2] = Math_fround(f12 * f11);
 HEAPF32[i13 + 4 >> 2] = Math_fround(f12 * f14);
 HEAPF32[i13 + 8 >> 2] = Math_fround(f12 * f18);
 STACKTOP = i17;
 return;
}

function __Z22HumanDescriptionToMonoRK16HumanDescriptionR20MonoHumanDescription(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i4 = i6 + 12 | 0;
 i3 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 60 >> 2] | 0;
 i5 = i6 + 16 | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 48, ((HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 72 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
  i2 = 0;
  do {
   i9 = i1;
   i11 = i9 + (i2 * 72 | 0) | 0;
   i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, i2, 48) | 0;
   i12 = HEAP8[i11 + 11 >> 0] | 0;
   i10 = i12 << 24 >> 24 < 0;
   HEAP32[i8 >> 2] = __Z20scripting_string_newPKcj(i10 ? HEAP32[i11 >> 2] | 0 : i11, i10 ? HEAP32[i9 + (i2 * 72 | 0) + 4 >> 2] | 0 : i12 & 255) | 0;
   i12 = i9 + (i2 * 72 | 0) + 16 | 0;
   i10 = HEAP8[i12 + 11 >> 0] | 0;
   i11 = i10 << 24 >> 24 < 0;
   HEAP32[i8 + 4 >> 2] = __Z20scripting_string_newPKcj(i11 ? HEAP32[i12 >> 2] | 0 : i12, i11 ? HEAP32[i9 + (i2 * 72 | 0) + 20 >> 2] | 0 : i10 & 255) | 0;
   i10 = i8 + 8 | 0;
   i11 = i9 + (i2 * 72 | 0) + 32 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i10 = i8 + 20 | 0;
   i11 = i9 + (i2 * 72 | 0) + 44 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   i8 = i8 + 36 | 0;
   i9 = i9 + (i2 * 72 | 0) + 60 | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i2 >>> 0 < (((HEAP32[i5 >> 2] | 0) - i1 | 0) / 72 | 0) >>> 0);
 }
 HEAP32[i7 + 4 >> 2] = i3;
 i4 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 56 >> 2] | 0;
 i3 = i6 + 4 | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 52, ((HEAP32[i3 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) / 76 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i7 >> 2] = i4;
  i12 = i6 + 24 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i7 + 8 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = i6 + 28 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i7 + 12 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i6 + 32 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i7 + 16 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = i6 + 36 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i7 + 20 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i6 + 40 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i7 + 24 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = i6 + 44 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i7 + 28 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i6 + 48 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i7 + 32 | 0;
  HEAP32[i11 >> 2] = i12;
  i11 = i6 + 84 | 0;
  i11 = HEAP8[i11 >> 0] | 0;
  i12 = i7 + 36 | 0;
  HEAP8[i12 >> 0] = i11;
  return;
 } else i2 = 0;
 do {
  i11 = i1;
  i10 = i11 + (i2 * 76 | 0) | 0;
  i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 52) | 0;
  i8 = HEAP8[i10 + 11 >> 0] | 0;
  i9 = i8 << 24 >> 24 < 0;
  HEAP32[i12 >> 2] = __Z20scripting_string_newPKcj(i9 ? HEAP32[i10 >> 2] | 0 : i10, i9 ? HEAP32[i11 + (i2 * 76 | 0) + 4 >> 2] | 0 : i8 & 255) | 0;
  i8 = i11 + (i2 * 76 | 0) + 16 | 0;
  i9 = HEAP8[i8 + 11 >> 0] | 0;
  i10 = i9 << 24 >> 24 < 0;
  HEAP32[i12 + 4 >> 2] = __Z20scripting_string_newPKcj(i10 ? HEAP32[i8 >> 2] | 0 : i8, i10 ? HEAP32[i11 + (i2 * 76 | 0) + 20 >> 2] | 0 : i9 & 255) | 0;
  i9 = i11 + (i2 * 76 | 0) + 32 | 0;
  i10 = i12 + 8 | 0;
  HEAP32[i12 + 48 >> 2] = (HEAP8[i11 + (i2 * 76 | 0) + 72 >> 0] ^ 1) & 255;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i10 = i12 + 20 | 0;
  i9 = i11 + (i2 * 76 | 0) + 44 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i10 = i12 + 32 | 0;
  i9 = i11 + (i2 * 76 | 0) + 56 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i12 + 44 >> 2] = HEAP32[i11 + (i2 * 76 | 0) + 68 >> 2];
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i3 >> 2] | 0) - i1 | 0) / 76 | 0) >>> 0);
 HEAP32[i7 >> 2] = i4;
 i12 = i6 + 24 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = i6 + 28 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 12 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = i6 + 32 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i7 + 16 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = i6 + 36 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 20 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = i6 + 40 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i7 + 24 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = i6 + 44 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 28 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = i6 + 48 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i7 + 32 | 0;
 HEAP32[i11 >> 2] = i12;
 i11 = i6 + 84 | 0;
 i11 = HEAP8[i11 >> 0] | 0;
 i12 = i7 + 36 | 0;
 HEAP8[i12 >> 0] = i11;
 return;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_(i5, i8, i3, i11, i13, i2, i9, i14) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i10 = i16 + 8 | 0;
 i4 = i3;
 while (1) {
  if ((i4 | 0) == (i11 | 0)) {
   i4 = i11;
   break;
  }
  if (!(HEAP32[i4 >> 2] | 0)) break;
  i4 = i4 + 4 | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i13 >> 2] = i3;
 i7 = i9;
 i12 = i5 + 8 | 0;
 L6 : while (1) {
  if ((i2 | 0) == (i9 | 0) | (i3 | 0) == (i11 | 0)) {
   i1 = i3;
   i5 = 53;
   break;
  }
  i17 = i8;
  i5 = HEAP32[i17 + 4 >> 2] | 0;
  i6 = i15;
  HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i6 = _uselocale(HEAP32[i12 >> 2] | 0) | 0;
  __THREW__ = 0;
  i5 = invoke_iiiiii(fb + 188 | 0, i2 | 0, i13 | 0, i4 - i3 >> 2 | 0, i7 - i2 | 0, i8 | 0) | 0;
  i17 = __THREW__;
  __THREW__ = 0;
  if (i17 & 1) {
   i5 = 11;
   break;
  }
  if (i6 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i6 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 10;
    break;
   }
  }
  switch (i5 | 0) {
  case -1:
   {
    i5 = 16;
    break L6;
   }
  case 0:
   {
    i1 = 1;
    i5 = 50;
    break L6;
   }
  default:
   {}
  }
  i2 = (HEAP32[i14 >> 2] | 0) + i5 | 0;
  HEAP32[i14 >> 2] = i2;
  if ((i2 | 0) == (i9 | 0)) {
   i5 = 51;
   break;
  }
  if ((i4 | 0) == (i11 | 0)) {
   i4 = i11;
   i3 = HEAP32[i13 >> 2] | 0;
  } else {
   i3 = _uselocale(HEAP32[i12 >> 2] | 0) | 0;
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 506 | 0, i10 | 0, 0, i8 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 36;
    break;
   }
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i5 = 35;
     break;
    }
   }
   if ((i2 | 0) == -1) {
    i1 = 2;
    i5 = 49;
    break;
   }
   if (i2 >>> 0 > (i7 - (HEAP32[i14 >> 2] | 0) | 0) >>> 0) {
    i1 = 1;
    i5 = 49;
    break;
   } else i3 = i10;
   while (1) {
    if (!i2) break;
    i6 = HEAP8[i3 >> 0] | 0;
    i17 = HEAP32[i14 >> 2] | 0;
    HEAP32[i14 >> 2] = i17 + 1;
    HEAP8[i17 >> 0] = i6;
    i3 = i3 + 1 | 0;
    i2 = i2 + -1 | 0;
   }
   i3 = (HEAP32[i13 >> 2] | 0) + 4 | 0;
   HEAP32[i13 >> 2] = i3;
   i4 = i3;
   while (1) {
    if ((i4 | 0) == (i11 | 0)) {
     i4 = i11;
     break;
    }
    if (!(HEAP32[i4 >> 2] | 0)) break;
    i4 = i4 + 4 | 0;
   }
   i2 = HEAP32[i14 >> 2] | 0;
  }
 }
 do if ((i5 | 0) == 10) {
  i17 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i17);
 } else if ((i5 | 0) == 11) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i6 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i6 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i17 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i17);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i5 | 0) == 16) {
  HEAP32[i14 >> 2] = i2;
  while (1) {
   if ((i3 | 0) == (HEAP32[i13 >> 2] | 0)) {
    i5 = 28;
    break;
   }
   i17 = HEAP32[i3 >> 2] | 0;
   i4 = _uselocale(HEAP32[i12 >> 2] | 0) | 0;
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 506 | 0, i2 | 0, i17 | 0, i15 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 22;
    break;
   }
   if (i4 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i5 = 21;
     break;
    }
   }
   if ((i2 | 0) == -1) {
    i5 = 28;
    break;
   }
   i2 = (HEAP32[i14 >> 2] | 0) + i2 | 0;
   HEAP32[i14 >> 2] = i2;
   i3 = i3 + 4 | 0;
  }
  if ((i5 | 0) == 21) {
   i17 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i17);
  } else if ((i5 | 0) == 22) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (i4 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i17 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i17);
    }
   }
   ___resumeException(i1 | 0);
  } else if ((i5 | 0) == 28) {
   HEAP32[i13 >> 2] = i3;
   i1 = 2;
   i5 = 50;
   break;
  }
 } else if ((i5 | 0) == 35) {
  i17 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i17);
 } else if ((i5 | 0) == 36) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i17 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i17);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i5 | 0) == 49) i5 = 50; else if ((i5 | 0) == 51) {
  i1 = HEAP32[i13 >> 2] | 0;
  i5 = 53;
 } while (0);
 if ((i5 | 0) != 50) if ((i5 | 0) == 53) i1 = (i1 | 0) != (i11 | 0) & 1;
 STACKTOP = i16;
 return i1 | 0;
}

function __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = ((HEAP32[i15 >> 2] | 0) - i1 | 0) / 60 | 0;
 i7 = i1;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i9 = i7 + (i12 * 60 | 0) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 * 60 | 0;
  i3 = (i2 | 0) / 60 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i13 >> 2] = i2;
   i1 = i2 + (i3 * 60 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i8 = i2;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i5 = i2;
    i3 = i7;
    i7 = i2;
    while (1) {
     i2 = i5;
     i5 = i3;
     i6 = i2 + 60 | 0;
     do {
      HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
      i2 = i2 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i2 | 0) < (i6 | 0));
     i3 = i3 + 60 | 0;
     i2 = i7 + 60 | 0;
     if ((i3 | 0) == (i9 | 0)) break; else {
      i5 = i2;
      i7 = i2;
     }
    }
    HEAP32[i10 >> 2] = i2;
    i5 = i8;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -60 - i3 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if ((((HEAP32[i8 >> 2] | 0) - i1 | 0) / 60 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 * 60 | 0, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (((i2 | 0) / -60 | 0) * 60 | 0) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 * 60 | 0);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = (i1 - i4 | 0) / 60 | 0;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 * 60 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~(((i5 + -60 - i2 | 0) >>> 0) / 60 | 0) * 60 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -60 - i3 | 0) >>> 0) / 60 | 0) * 60 | 0);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function runPostSets232() {
 HEAP32[gb + 211592 >> 2] = (HEAP32[gb + 211592 >> 2] | 0) + (gb + 11568 | 0);
 HEAP32[gb + 211596 >> 2] = fb + 3091;
 HEAP32[gb + 211600 >> 2] = fb + 3092;
 HEAP32[gb + 211604 >> 2] = fb + 3068;
 HEAP32[gb + 211608 >> 2] = fb + 77;
 HEAP32[gb + 11568 >> 2] = (HEAP32[gb + 11568 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11572 >> 2] = (HEAP32[gb + 11572 >> 2] | 0) + (gb + 1079413 | 0);
 HEAP32[gb + 11576 >> 2] = (HEAP32[gb + 11576 >> 2] | 0) + (gb + 11496 | 0);
 HEAP32[gb + 211616 >> 2] = (HEAP32[gb + 211616 >> 2] | 0) + (gb + 11584 | 0);
 HEAP32[gb + 211620 >> 2] = fb + 3093;
 HEAP32[gb + 211624 >> 2] = fb + 3094;
 HEAP32[gb + 211628 >> 2] = fb + 3068;
 HEAP32[gb + 211632 >> 2] = fb + 78;
 HEAP32[gb + 11584 >> 2] = (HEAP32[gb + 11584 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11588 >> 2] = (HEAP32[gb + 11588 >> 2] | 0) + (gb + 1079490 | 0);
 HEAP32[gb + 11592 >> 2] = (HEAP32[gb + 11592 >> 2] | 0) + (gb + 11536 | 0);
 HEAP32[gb + 211640 >> 2] = (HEAP32[gb + 211640 >> 2] | 0) + (gb + 11600 | 0);
 HEAP32[gb + 211644 >> 2] = fb + 3095;
 HEAP32[gb + 211648 >> 2] = fb + 3096;
 HEAP32[gb + 211652 >> 2] = fb + 3068;
 HEAP32[gb + 211656 >> 2] = fb + 1467;
 HEAP32[gb + 211660 >> 2] = fb + 1468;
 HEAP32[gb + 211664 >> 2] = fb + 2300;
 HEAP32[gb + 211668 >> 2] = fb + 2301;
 HEAP32[gb + 211672 >> 2] = fb + 2302;
 HEAP32[gb + 211676 >> 2] = fb + 2303;
 HEAP32[gb + 211680 >> 2] = fb + 1469;
 HEAP32[gb + 211684 >> 2] = fb + 2304;
 HEAP32[gb + 211688 >> 2] = fb + 2305;
 HEAP32[gb + 11600 >> 2] = (HEAP32[gb + 11600 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11604 >> 2] = (HEAP32[gb + 11604 >> 2] | 0) + (gb + 1079567 | 0);
 HEAP32[gb + 11616 >> 2] = (HEAP32[gb + 11616 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11624 >> 2] = (HEAP32[gb + 11624 >> 2] | 0) + (gb + 11632 | 0);
 HEAP32[gb + 11632 >> 2] = (HEAP32[gb + 11632 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11636 >> 2] = (HEAP32[gb + 11636 >> 2] | 0) + (gb + 1079595 | 0);
 HEAP32[gb + 211696 >> 2] = (HEAP32[gb + 211696 >> 2] | 0) + (gb + 11640 | 0);
 HEAP32[gb + 211700 >> 2] = fb + 3097;
 HEAP32[gb + 211704 >> 2] = fb + 3098;
 HEAP32[gb + 211708 >> 2] = fb + 3068;
 HEAP32[gb + 211712 >> 2] = fb + 1470;
 HEAP32[gb + 211716 >> 2] = fb + 1471;
 HEAP32[gb + 211720 >> 2] = fb + 2306;
 HEAP32[gb + 211724 >> 2] = fb + 2307;
 HEAP32[gb + 211728 >> 2] = fb + 2308;
 HEAP32[gb + 211732 >> 2] = fb + 2309;
 HEAP32[gb + 211736 >> 2] = fb + 1472;
 HEAP32[gb + 211740 >> 2] = fb + 2310;
 HEAP32[gb + 211744 >> 2] = fb + 2311;
 HEAP32[gb + 11640 >> 2] = (HEAP32[gb + 11640 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11644 >> 2] = (HEAP32[gb + 11644 >> 2] | 0) + (gb + 1079616 | 0);
 HEAP32[gb + 11656 >> 2] = (HEAP32[gb + 11656 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11664 >> 2] = (HEAP32[gb + 11664 >> 2] | 0) + (gb + 11632 | 0);
 HEAP32[gb + 211752 >> 2] = (HEAP32[gb + 211752 >> 2] | 0) + (gb + 11672 | 0);
 HEAP32[gb + 211756 >> 2] = fb + 3099;
 HEAP32[gb + 211760 >> 2] = fb + 3100;
 HEAP32[gb + 211764 >> 2] = fb + 3068;
 HEAP32[gb + 211768 >> 2] = fb + 1473;
 HEAP32[gb + 211772 >> 2] = fb + 1474;
 HEAP32[gb + 211776 >> 2] = fb + 2312;
 HEAP32[gb + 211780 >> 2] = fb + 2313;
 HEAP32[gb + 211784 >> 2] = fb + 2314;
 HEAP32[gb + 211788 >> 2] = fb + 2315;
 HEAP32[gb + 211792 >> 2] = fb + 1475;
 HEAP32[gb + 211796 >> 2] = fb + 2316;
 HEAP32[gb + 211800 >> 2] = fb + 2317;
 HEAP32[gb + 11672 >> 2] = (HEAP32[gb + 11672 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11676 >> 2] = (HEAP32[gb + 11676 >> 2] | 0) + (gb + 1079645 | 0);
 HEAP32[gb + 11688 >> 2] = (HEAP32[gb + 11688 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11696 >> 2] = (HEAP32[gb + 11696 >> 2] | 0) + (gb + 11632 | 0);
 HEAP32[gb + 211808 >> 2] = (HEAP32[gb + 211808 >> 2] | 0) + (gb + 11704 | 0);
 HEAP32[gb + 211812 >> 2] = fb + 3101;
 HEAP32[gb + 211816 >> 2] = fb + 3102;
 HEAP32[gb + 211820 >> 2] = fb + 3068;
 HEAP32[gb + 211824 >> 2] = fb + 1476;
 HEAP32[gb + 211828 >> 2] = fb + 1477;
 HEAP32[gb + 211832 >> 2] = fb + 2318;
 HEAP32[gb + 211836 >> 2] = fb + 2319;
 HEAP32[gb + 211840 >> 2] = fb + 2320;
 HEAP32[gb + 211844 >> 2] = fb + 2321;
 HEAP32[gb + 211848 >> 2] = fb + 1478;
 HEAP32[gb + 211852 >> 2] = fb + 2322;
 HEAP32[gb + 211856 >> 2] = fb + 2323;
 HEAP32[gb + 11704 >> 2] = (HEAP32[gb + 11704 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11708 >> 2] = (HEAP32[gb + 11708 >> 2] | 0) + (gb + 1079673 | 0);
 HEAP32[gb + 11720 >> 2] = (HEAP32[gb + 11720 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11728 >> 2] = (HEAP32[gb + 11728 >> 2] | 0) + (gb + 11632 | 0);
 HEAP32[gb + 211864 >> 2] = (HEAP32[gb + 211864 >> 2] | 0) + (gb + 11736 | 0);
 HEAP32[gb + 211868 >> 2] = fb + 3103;
 HEAP32[gb + 211872 >> 2] = fb + 3104;
 HEAP32[gb + 211876 >> 2] = fb + 3068;
 HEAP32[gb + 211880 >> 2] = fb + 1479;
 HEAP32[gb + 211884 >> 2] = fb + 1480;
 HEAP32[gb + 211888 >> 2] = fb + 2324;
 HEAP32[gb + 211892 >> 2] = fb + 2325;
 HEAP32[gb + 211896 >> 2] = fb + 2326;
 HEAP32[gb + 211900 >> 2] = fb + 2327;
 HEAP32[gb + 211904 >> 2] = fb + 1481;
 HEAP32[gb + 211908 >> 2] = fb + 2328;
 HEAP32[gb + 211912 >> 2] = fb + 2329;
 HEAP32[gb + 11736 >> 2] = (HEAP32[gb + 11736 >> 2] | 0) + (gb + 216140 | 0);
 runPostSets233();
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i27, i28, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, i30 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i30 + 36 | 0;
 i25 = i30 + 32 | 0;
 i29 = i30 + 16 | 0;
 i26 = i30;
 i1 = i27 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i27 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i25, 4); else {
  HEAP32[i25 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 };
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 i13 = i28 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i28, HEAP32[i13 >> 2] | 0);
 i14 = i28 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i28 >> 2] = i13;
 HEAP32[i13 >> 2] = 0;
 if ((HEAP32[i25 >> 2] | 0) > 0) {
  i15 = i29 + 4 | 0;
  i16 = i26 + 4 | 0;
  i17 = i26 + 8 | 0;
  i18 = i26 + 12 | 0;
  i19 = i29 + 8 | 0;
  i20 = i13;
  i21 = i28 + 4 | 0;
  i22 = i26 + 4 | 0;
  i23 = i26 + 12 | 0;
  i12 = 0;
  do {
   __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i29, i27);
   __ZN23ShaderVariantCollection10ShaderInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i15, i27);
   HEAP32[i26 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   i3 = i2 - i1 | 0;
   i4 = (i3 | 0) / 36 | 0;
   if (!i3) {
    i1 = 0;
    i11 = 0;
    i3 = 0;
   } else {
    if (i4 >>> 0 > 119304647) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i16);
     i5 = HEAP32[i15 >> 2] | 0;
     i2 = HEAP32[i19 >> 2] | 0;
    } else i5 = i1;
    i1 = __Znwj(i3) | 0;
    HEAP32[i17 >> 2] = i1;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i23 >> 2] = i1 + (i4 * 36 | 0);
    i2 = i2 - i5 | 0;
    i3 = i1;
    if ((i2 | 0) > 0) {
     _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
     i11 = i1 + (((i2 >>> 0) / 36 | 0) * 36 | 0) | 0;
     HEAP32[i17 >> 2] = i11;
    } else i11 = i3;
   }
   i2 = HEAP32[i13 >> 2] | 0;
   do if (!i2) {
    HEAP32[i24 >> 2] = i13;
    i10 = i20;
    i5 = i13;
   } else {
    i6 = HEAP32[i26 >> 2] | 0;
    while (1) {
     i4 = HEAP32[i2 + 16 >> 2] | 0;
     if ((i6 | 0) < (i4 | 0)) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i4 = 20;
       break;
      } else i2 = i4;
     } else {
      if ((i4 | 0) >= (i6 | 0)) {
       i4 = 25;
       break;
      }
      i5 = i2 + 4 | 0;
      i4 = HEAP32[i5 >> 2] | 0;
      if (!i4) {
       i4 = 24;
       break;
      } else i2 = i4;
     }
    }
    if ((i4 | 0) == 20) {
     HEAP32[i24 >> 2] = i2;
     i10 = i2;
     i5 = i2;
     break;
    } else if ((i4 | 0) == 24) {
     HEAP32[i24 >> 2] = i2;
     i10 = i2;
     break;
    } else if ((i4 | 0) == 25) {
     HEAP32[i24 >> 2] = i2;
     i10 = i2;
     i5 = i24;
     break;
    }
   } while (0);
   if (!(HEAP32[i5 >> 2] | 0)) {
    i1 = __Znwj(32) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i26 >> 2];
    i6 = i1 + 20 | 0;
    HEAP32[i6 >> 2] = 0;
    i9 = i1 + 24 | 0;
    HEAP32[i9 >> 2] = 0;
    i7 = i1 + 28 | 0;
    HEAP32[i7 >> 2] = 0;
    i4 = i11 - i3 | 0;
    i8 = (i4 | 0) / 36 | 0;
    if (i4 | 0) {
     if (i8 >>> 0 > 119304647) {
      __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
      i3 = HEAP32[i16 >> 2] | 0;
      i2 = HEAP32[i17 >> 2] | 0;
     } else i2 = i11;
     i4 = __Znwj(i4) | 0;
     HEAP32[i9 >> 2] = i4;
     HEAP32[i6 >> 2] = i4;
     HEAP32[i7 >> 2] = i4 + (i8 * 36 | 0);
     i2 = i2 - i3 | 0;
     if ((i2 | 0) > 0) {
      _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
      HEAP32[i9 >> 2] = i4 + (((i2 >>> 0) / 36 | 0) * 36 | 0);
     }
    }
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i10;
    HEAP32[i5 >> 2] = i1;
    i2 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i28 >> 2] = i2;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i1);
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
    i1 = HEAP32[i22 >> 2] | 0;
   }
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i17 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i3 + (~(((i3 + -36 - i2 | 0) >>> 0) / 36 | 0) * 36 | 0);
    __ZdlPv(i1);
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) < (HEAP32[i25 >> 2] | 0));
 }
 i3 = HEAP32[i29 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i30;
  return;
 }
 i1 = i29 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -36 - i3 | 0) >>> 0) / 36 | 0) * 36 | 0);
 __ZdlPv(i3);
 STACKTOP = i30;
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags(i29, i30, i1) {
 i29 = i29 | 0;
 i30 = i30 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i28 + 56 | 0;
 i24 = i28 + 44 | 0;
 i25 = i28 + 40 | 0;
 i26 = i28 + 20 | 0;
 i27 = i28;
 i2 = i29 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > (HEAP32[i29 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i25, 4); else {
  HEAP32[i25 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i1;
 }
 i7 = i26 + 4 | 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP32[i26 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i30 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i30, HEAP32[i8 >> 2] | 0);
 i9 = i30 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i30 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i25 >> 2] | 0) <= 0) {
  STACKTOP = i28;
  return;
 }
 i10 = i27 + 4 | 0;
 i11 = i7 + 11 | 0;
 i12 = i26 + 8 | 0;
 i13 = i27 + 16 | 0;
 i6 = i27 + 16 | 0;
 i14 = i23 + 4 | 0;
 i15 = i27 + 12 | 0;
 i16 = i27 + 8 | 0;
 i17 = i8;
 i18 = i30 + 4 | 0;
 i19 = i27 + 4 | 0;
 i20 = i19 + 11 | 0;
 i21 = i23 + 4 | 0;
 i22 = i10 + 11 | 0;
 i5 = 0;
 do {
  __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i26, i29);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i29, i7, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i29);
  HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
  i3 = HEAP8[i11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
  i3 = i1 ? HEAP32[i12 >> 2] | 0 : i3 & 255;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = 12;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i22 >> 0] = i3;
   if (!i3) i1 = i10; else {
    i1 = i10;
    i4 = 14;
   }
  } else i4 = 12;
  if ((i4 | 0) == 12) {
   i31 = i3 + 16 & -16;
   HEAP32[i23 >> 2] = 66;
   HEAP32[i14 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i31, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i15 >> 2] = i31 | -2147483648;
   HEAP32[i16 >> 2] = i3;
   i4 = 14;
  }
  if ((i4 | 0) == 14) {
   i4 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i23 >> 2] = i8;
   i2 = i17;
   i3 = i8;
  } else {
   i4 = HEAP32[i27 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 19;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i4 = 24;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 23;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 19) {
    i4 = 0;
    HEAP32[i23 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i4 | 0) == 23) {
    i4 = 0;
    HEAP32[i23 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 24) {
    i4 = 0;
    HEAP32[i23 >> 2] = i1;
    i2 = i1;
    i3 = i23;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE(i24, i30, i27);
   i1 = HEAP32[i24 >> 2] | 0;
   HEAP32[i24 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i30 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i30 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i18 >> 2] | 0, i1);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  if ((HEAP8[i20 >> 0] | 0) < 0) {
   i31 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i23 >> 2] = 66;
   HEAP32[i21 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i31, i23);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i25 >> 2] | 0));
 if ((HEAP8[i26 + 4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i28;
  return;
 }
 i31 = HEAP32[i26 + 4 >> 2] | 0;
 i30 = HEAP32[i26 + 16 >> 2] | 0;
 HEAP32[i23 >> 2] = 66;
 HEAP32[i23 + 4 >> 2] = i30;
 __Z19free_alloc_internalPvRK10MemLabelId(i31, i23);
 STACKTOP = i28;
 return;
}

function runPostSets28() {
 HEAP32[gb + 40964 >> 2] = (HEAP32[gb + 40964 >> 2] | 0) + (gb + 422449 | 0);
 HEAP32[gb + 40968 >> 2] = (HEAP32[gb + 40968 >> 2] | 0) + (gb + 422494 | 0);
 HEAP32[gb + 40972 >> 2] = (HEAP32[gb + 40972 >> 2] | 0) + (gb + 394430 | 0);
 HEAP32[gb + 40976 >> 2] = (HEAP32[gb + 40976 >> 2] | 0) + (gb + 394451 | 0);
 HEAP32[gb + 40980 >> 2] = (HEAP32[gb + 40980 >> 2] | 0) + (gb + 394476 | 0);
 HEAP32[gb + 40984 >> 2] = (HEAP32[gb + 40984 >> 2] | 0) + (gb + 394500 | 0);
 HEAP32[gb + 40988 >> 2] = (HEAP32[gb + 40988 >> 2] | 0) + (gb + 604612 | 0);
 HEAP32[gb + 40992 >> 2] = (HEAP32[gb + 40992 >> 2] | 0) + (gb + 396252 | 0);
 HEAP32[gb + 40996 >> 2] = (HEAP32[gb + 40996 >> 2] | 0) + (gb + 396259 | 0);
 HEAP32[gb + 41e3 >> 2] = (HEAP32[gb + 41e3 >> 2] | 0) + (gb + 396265 | 0);
 HEAP32[gb + 41004 >> 2] = (HEAP32[gb + 41004 >> 2] | 0) + (gb + 396274 | 0);
 HEAP32[gb + 41008 >> 2] = (HEAP32[gb + 41008 >> 2] | 0) + (gb + 396284 | 0);
 HEAP32[gb + 41012 >> 2] = (HEAP32[gb + 41012 >> 2] | 0) + (gb + 396294 | 0);
 HEAP32[gb + 41016 >> 2] = (HEAP32[gb + 41016 >> 2] | 0) + (gb + 396304 | 0);
 HEAP32[gb + 41020 >> 2] = (HEAP32[gb + 41020 >> 2] | 0) + (gb + 606238 | 0);
 HEAP32[gb + 41024 >> 2] = (HEAP32[gb + 41024 >> 2] | 0) + (gb + 396427 | 0);
 HEAP32[gb + 41028 >> 2] = (HEAP32[gb + 41028 >> 2] | 0) + (gb + 396438 | 0);
 HEAP32[gb + 41032 >> 2] = (HEAP32[gb + 41032 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41036 >> 2] = (HEAP32[gb + 41036 >> 2] | 0) + (gb + 396450 | 0);
 HEAP32[gb + 41040 >> 2] = (HEAP32[gb + 41040 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41044 >> 2] = (HEAP32[gb + 41044 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41048 >> 2] = (HEAP32[gb + 41048 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41052 >> 2] = (HEAP32[gb + 41052 >> 2] | 0) + (gb + 396455 | 0);
 HEAP32[gb + 41056 >> 2] = (HEAP32[gb + 41056 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41060 >> 2] = (HEAP32[gb + 41060 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 41064 >> 2] = (HEAP32[gb + 41064 >> 2] | 0) + (gb + 396467 | 0);
 HEAP32[gb + 41068 >> 2] = (HEAP32[gb + 41068 >> 2] | 0) + (gb + 396479 | 0);
 HEAP32[gb + 41072 >> 2] = (HEAP32[gb + 41072 >> 2] | 0) + (gb + 396487 | 0);
 HEAP32[gb + 41076 >> 2] = (HEAP32[gb + 41076 >> 2] | 0) + (gb + 396491 | 0);
 HEAP32[gb + 41080 >> 2] = (HEAP32[gb + 41080 >> 2] | 0) + (gb + 396500 | 0);
 HEAP32[gb + 41084 >> 2] = (HEAP32[gb + 41084 >> 2] | 0) + (gb + 396504 | 0);
 HEAP32[gb + 41088 >> 2] = (HEAP32[gb + 41088 >> 2] | 0) + (gb + 396510 | 0);
 HEAP32[gb + 41092 >> 2] = (HEAP32[gb + 41092 >> 2] | 0) + (gb + 396522 | 0);
 HEAP32[gb + 41096 >> 2] = (HEAP32[gb + 41096 >> 2] | 0) + (gb + 396534 | 0);
 HEAP32[gb + 41100 >> 2] = (HEAP32[gb + 41100 >> 2] | 0) + (gb + 396547 | 0);
 HEAP32[gb + 41104 >> 2] = (HEAP32[gb + 41104 >> 2] | 0) + (gb + 396553 | 0);
 HEAP32[gb + 41116 >> 2] = fb + 304;
 HEAP32[gb + 41120 >> 2] = fb + 305;
 HEAP32[gb + 41124 >> 2] = fb + 179;
 HEAP32[gb + 41136 >> 2] = fb + 306;
 HEAP32[gb + 41140 >> 2] = fb + 307;
 HEAP32[gb + 41144 >> 2] = fb + 65;
 HEAP32[gb + 41148 >> 2] = fb + 1;
 HEAP32[gb + 41152 >> 2] = fb + 1;
 HEAP32[gb + 41164 >> 2] = fb + 308;
 HEAP32[gb + 41168 >> 2] = fb + 309;
 HEAP32[gb + 41172 >> 2] = fb + 310;
 HEAP32[gb + 41176 >> 2] = fb + 297;
 HEAP32[gb + 41180 >> 2] = fb + 16;
 HEAP32[gb + 41184 >> 2] = fb + 17;
 HEAP32[gb + 41188 >> 2] = fb + 311;
 HEAP32[gb + 41192 >> 2] = fb + 19;
 HEAP32[gb + 41196 >> 2] = fb + 180;
 HEAP32[gb + 41200 >> 2] = fb + 31;
 HEAP32[gb + 41204 >> 2] = fb + 27;
 HEAP32[gb + 41208 >> 2] = fb + 32;
 HEAP32[gb + 41212 >> 2] = fb + 28;
 HEAP32[gb + 41216 >> 2] = fb + 181;
 HEAP32[gb + 41220 >> 2] = fb + 29;
 HEAP32[gb + 41224 >> 2] = fb + 34;
 HEAP32[gb + 41228 >> 2] = fb + 298;
 HEAP32[gb + 41232 >> 2] = fb + 299;
 HEAP32[gb + 41236 >> 2] = fb + 300;
 HEAP32[gb + 41240 >> 2] = fb + 301;
 HEAP32[gb + 41244 >> 2] = fb + 302;
 HEAP32[gb + 41248 >> 2] = fb + 303;
 HEAP32[gb + 41252 >> 2] = fb + 36;
 HEAP32[gb + 41256 >> 2] = fb + 20;
 HEAP32[gb + 41260 >> 2] = fb + 35;
 HEAP32[gb + 41264 >> 2] = fb + 36;
 HEAP32[gb + 41268 >> 2] = fb + 37;
 HEAP32[gb + 41272 >> 2] = fb + 37;
 HEAP32[gb + 41276 >> 2] = fb + 38;
 HEAP32[gb + 41280 >> 2] = fb + 39;
 HEAP32[gb + 41284 >> 2] = fb + 40;
 HEAP32[gb + 41288 >> 2] = fb + 41;
 HEAP32[gb + 41292 >> 2] = fb + 42;
 HEAP32[gb + 41296 >> 2] = fb + 182;
 HEAP32[gb + 41300 >> 2] = fb + 183;
 HEAP32[gb + 41304 >> 2] = fb + 184;
 HEAP32[gb + 41308 >> 2] = fb + 185;
 HEAP32[gb + 41312 >> 2] = fb + 186;
 HEAP32[gb + 41316 >> 2] = fb + 48;
 HEAP32[gb + 41320 >> 2] = fb + 187;
 HEAP32[gb + 41324 >> 2] = fb + 304;
 HEAP32[gb + 41328 >> 2] = fb + 312;
 HEAP32[gb + 41332 >> 2] = fb + 5;
 HEAP32[gb + 41336 >> 2] = fb + 188;
 HEAP32[gb + 41756 >> 2] = fb + 313;
 HEAP32[gb + 41760 >> 2] = fb + 314;
 HEAP32[gb + 41764 >> 2] = fb + 315;
 HEAP32[gb + 41768 >> 2] = fb + 305;
 HEAP32[gb + 41772 >> 2] = fb + 316;
 HEAP32[gb + 41776 >> 2] = fb + 17;
 HEAP32[gb + 41780 >> 2] = fb + 317;
 HEAP32[gb + 41784 >> 2] = fb + 19;
 HEAP32[gb + 41788 >> 2] = fb + 189;
 HEAP32[gb + 41792 >> 2] = fb + 31;
 HEAP32[gb + 41796 >> 2] = fb + 27;
 HEAP32[gb + 41800 >> 2] = fb + 32;
 runPostSets29();
}

function __ZNSt3__211__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i(i28, i29, i30, i31, i1, i21, i22, i23, i24, i25, i9, i10, i11, i27, i12) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i27 = i27 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i26 = 0, i32 = 0, i33 = 0;
 HEAP32[i30 >> 2] = i28;
 i13 = i27 + 11 | 0;
 i26 = i27 + 4 | 0;
 i14 = i11 + 11 | 0;
 i15 = i11 + 4 | 0;
 i16 = (i31 & 512 | 0) == 0;
 i17 = i22 + 8 | 0;
 i18 = (i12 | 0) > 0;
 i19 = i10 + 11 | 0;
 i20 = i10 + 4 | 0;
 i8 = 0;
 while (1) {
  if ((i8 | 0) == 4) break;
  L4 : do switch (HEAP8[i24 + i8 >> 0] | 0) {
  case 0:
   {
    HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
    break;
   }
  case 1:
   {
    HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
    i6 = mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, 32) | 0;
    i7 = HEAP32[i30 >> 2] | 0;
    HEAP32[i30 >> 2] = i7 + 1;
    HEAP8[i7 >> 0] = i6;
    break;
   }
  case 3:
   {
    i7 = HEAP8[i13 >> 0] | 0;
    i2 = i7 << 24 >> 24 < 0;
    if ((i2 ? HEAP32[i26 >> 2] | 0 : i7 & 255) | 0) {
     i6 = HEAP8[(i2 ? HEAP32[i27 >> 2] | 0 : i27) >> 0] | 0;
     i7 = HEAP32[i30 >> 2] | 0;
     HEAP32[i30 >> 2] = i7 + 1;
     HEAP8[i7 >> 0] = i6;
    }
    break;
   }
  case 2:
   {
    i3 = HEAP8[i14 >> 0] | 0;
    i2 = i3 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i15 >> 2] | 0 : i3 & 255;
    if (!(i16 | (i3 | 0) == 0)) {
     i7 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = i7 + i3 | 0;
     i2 = HEAP32[i30 >> 2] | 0;
     i3 = i7;
     while (1) {
      if ((i3 | 0) == (i4 | 0)) break;
      HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
     HEAP32[i30 >> 2] = i2;
    }
    break;
   }
  case 4:
   {
    i3 = HEAP32[i30 >> 2] | 0;
    i1 = i23 ? i1 + 1 | 0 : i1;
    i4 = i1;
    while (1) {
     if (i4 >>> 0 >= i21 >>> 0) break;
     i2 = HEAP8[i4 >> 0] | 0;
     if (i2 << 24 >> 24 <= -1) break;
     if (!(HEAP16[(HEAP32[i17 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 2048)) break;
     i4 = i4 + 1 | 0;
    }
    if (i18) {
     i5 = i12;
     while (1) {
      i2 = (i5 | 0) > 0;
      if (!(i4 >>> 0 > i1 >>> 0 & i2)) break;
      i7 = i4 + -1 | 0;
      i2 = HEAP8[i7 >> 0] | 0;
      i6 = HEAP32[i30 >> 2] | 0;
      HEAP32[i30 >> 2] = i6 + 1;
      HEAP8[i6 >> 0] = i2;
      i5 = i5 + -1 | 0;
      i4 = i7;
     }
     if (i2) i6 = mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, 48) | 0; else i6 = 0;
     i2 = i5;
     while (1) {
      i5 = HEAP32[i30 >> 2] | 0;
      HEAP32[i30 >> 2] = i5 + 1;
      if ((i2 | 0) <= 0) break;
      HEAP8[i5 >> 0] = i6;
      i2 = i2 + -1 | 0;
     }
     HEAP8[i5 >> 0] = i25;
    }
    L35 : do if ((i4 | 0) == (i1 | 0)) {
     i6 = mftCall_iii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, 48) | 0;
     i7 = HEAP32[i30 >> 2] | 0;
     HEAP32[i30 >> 2] = i7 + 1;
     HEAP8[i7 >> 0] = i6;
    } else {
     i7 = HEAP8[i19 >> 0] | 0;
     i2 = i7 << 24 >> 24 < 0;
     if (!((i2 ? HEAP32[i20 >> 2] | 0 : i7 & 255) | 0)) {
      i6 = -1;
      i5 = 0;
      i7 = 0;
     } else {
      i6 = HEAP8[(i2 ? HEAP32[i10 >> 2] | 0 : i10) >> 0] | 0;
      i5 = 0;
      i7 = 0;
     }
     while (1) {
      if ((i4 | 0) == (i1 | 0)) break L35;
      if ((i7 | 0) == (i6 | 0)) {
       i6 = HEAP32[i30 >> 2] | 0;
       HEAP32[i30 >> 2] = i6 + 1;
       HEAP8[i6 >> 0] = i9;
       i5 = i5 + 1 | 0;
       i6 = HEAP8[i19 >> 0] | 0;
       i2 = i6 << 24 >> 24 < 0;
       if (i5 >>> 0 < (i2 ? HEAP32[i20 >> 2] | 0 : i6 & 255) >>> 0) {
        i6 = HEAP8[(i2 ? HEAP32[i10 >> 2] | 0 : i10) + i5 >> 0] | 0;
        i6 = i6 << 24 >> 24 == 127 ? -1 : i6 << 24 >> 24;
        i2 = 0;
       } else {
        i6 = i7;
        i2 = 0;
       }
      } else i2 = i7;
      i32 = i4 + -1 | 0;
      i33 = HEAP8[i32 >> 0] | 0;
      i7 = HEAP32[i30 >> 2] | 0;
      HEAP32[i30 >> 2] = i7 + 1;
      HEAP8[i7 >> 0] = i33;
      i7 = i2 + 1 | 0;
      i4 = i32;
     }
    } while (0);
    i2 = HEAP32[i30 >> 2] | 0;
    if ((i3 | 0) != (i2 | 0)) while (1) {
     i2 = i2 + -1 | 0;
     if (i3 >>> 0 >= i2 >>> 0) break L4;
     i33 = HEAP8[i3 >> 0] | 0;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i2 >> 0] = i33;
     i3 = i3 + 1 | 0;
    }
    break;
   }
  default:
   {}
  } while (0);
  i8 = i8 + 1 | 0;
 }
 i1 = HEAP8[i13 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i26 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 > 1) {
  i33 = i2 ? HEAP32[i27 >> 2] | 0 : i27;
  i3 = i33 + i1 | 0;
  i2 = HEAP32[i30 >> 2] | 0;
  i1 = i33;
  while (1) {
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break;
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
  }
  HEAP32[i30 >> 2] = i2;
 }
 switch ((i31 & 176) << 24 >> 24) {
 case 32:
  {
   HEAP32[i29 >> 2] = HEAP32[i30 >> 2];
   break;
  }
 case 16:
  break;
 default:
  HEAP32[i29 >> 2] = i28;
 }
 return;
}

function __ZN26PlayerSettingsSplashScreen8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 100 | 0, i10);
 i1 = i9 + 4 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 5 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 36 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i5 = i9 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i5 = i9 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i11 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 20 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i7 = i9 + 28 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i7, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i9 + 32 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i6, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i9 + 40 | 0, gb + 450421 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i9 + 56 | 0, gb + 450458 | 0, 0);
 i4 = i9 + 84 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 72 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + (i8 << 3) | 0;
 if (i8 | 0) do {
  __ZN4PPtrI6SpriteE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 if (Math_fround(HEAPF32[i7 >> 2]) < Math_fround(0.0)) HEAPF32[i7 >> 2] = Math_fround(0.0);
 if (!(Math_fround(HEAPF32[i6 >> 2]) < Math_fround(0.0))) {
  i12 = i9 + 92 | 0;
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  i12 = i9 + 96 | 0;
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  i12 = i9 + 116 | 0;
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  STACKTOP = i13;
  return;
 }
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i12 = i9 + 92 | 0;
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
 i12 = i9 + 96 | 0;
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
 i12 = i9 + 116 | 0;
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
 STACKTOP = i13;
 return;
}

function __ZN6prcore10ClearImageER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE(i16, i15, i2) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 if (!(__Z19IsHalfTextureFormat13TextureFormat(HEAP32[i16 >> 2] | 0) | 0)) if (!(__Z20IsFloatTextureFormat13TextureFormat(HEAP32[i16 >> 2] | 0) | 0)) {
  i4 = __Z20GetTextureFormatInfo13TextureFormat(HEAP32[i16 >> 2] | 0) | 0;
  i17 = HEAP32[gb + 57704 + ((HEAP32[i4 + 4 >> 2] | 0) + -1 << 2) >> 2] | 0;
  i1 = (i2 & 1 | 0) != 0;
  if (!(HEAP32[i4 + 8 >> 2] | 0)) {
   i3 = HEAP32[i4 + 40 >> 2] | 0;
   if (i1) i1 = HEAP32[i4 + 52 >> 2] | i3 | HEAP32[i4 + 64 >> 2]; else i1 = 0;
   i13 = HEAP32[i4 + 28 >> 2] | 0;
   i14 = ((i2 & 2 | 0) == 0 ? 0 : i13) | i1;
   if (!i3) {
    i11 = 0;
    i12 = 0;
    i10 = 0;
   } else {
    i11 = i3 >>> 0 > 65535;
    i9 = i11 ? i3 >>> 16 : i3;
    i11 = i11 ? 16 : 0;
    i10 = (i9 & 65280 | 0) == 0;
    i9 = i10 ? i9 : i9 >>> 8;
    i11 = i10 ? i11 : i11 | 8;
    i10 = (i9 & 240 | 0) == 0;
    i9 = (i10 ? i11 : i11 | 4) + -4 + (HEAP8[(i10 ? i9 : i9 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i10 = i9 + -3 | 0;
    i11 = (i10 | 0) > 0;
    i10 = i11 ? i10 : 0;
    i9 = i11 ? 0 : 3 - i9 | 0;
    i11 = i10;
    i12 = i9;
    i10 = 255 >>> i9 << i10 & i3;
   }
   i1 = HEAP32[i4 + 52 >> 2] | 0;
   if (!i1) {
    i8 = 0;
    i9 = 0;
    i7 = 0;
   } else {
    i8 = i1 >>> 0 > 65535;
    i6 = i8 ? i1 >>> 16 : i1;
    i8 = i8 ? 16 : 0;
    i7 = (i6 & 65280 | 0) == 0;
    i6 = i7 ? i6 : i6 >>> 8;
    i8 = i7 ? i8 : i8 | 8;
    i7 = (i6 & 240 | 0) == 0;
    i6 = (i7 ? i8 : i8 | 4) + -12 + (HEAP8[(i7 ? i6 : i6 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i7 = i6 + -3 | 0;
    i8 = (i7 | 0) > 0;
    i7 = i8 ? i7 : 0;
    i6 = i8 ? 0 : 3 - i6 | 0;
    i8 = i7;
    i9 = i6;
    i7 = 65280 >>> i6 << i7 & i1;
   }
   i1 = HEAP32[i4 + 64 >> 2] | 0;
   if (!i1) {
    i5 = 0;
    i6 = 0;
    i4 = 0;
   } else {
    i5 = i1 >>> 0 > 65535;
    i3 = i5 ? i1 >>> 16 : i1;
    i5 = i5 ? 16 : 0;
    i4 = (i3 & 65280 | 0) == 0;
    i3 = i4 ? i3 : i3 >>> 8;
    i5 = i4 ? i5 : i5 | 8;
    i4 = (i3 & 240 | 0) == 0;
    i3 = (i4 ? i5 : i5 | 4) + -20 + (HEAP8[(i4 ? i3 : i3 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i4 = i3 + -3 | 0;
    i5 = (i4 | 0) > 0;
    i4 = i5 ? i4 : 0;
    i3 = i5 ? 0 : 3 - i3 | 0;
    i5 = i4;
    i6 = i3;
    i4 = 16711680 >>> i3 << i4 & i1;
   }
   if (!i13) {
    i2 = 0;
    i3 = 0;
    i1 = 0;
   } else {
    i2 = i13 >>> 0 > 65535;
    i18 = i2 ? i13 >>> 16 : i13;
    i2 = i2 ? 16 : 0;
    i1 = (i18 & 65280 | 0) == 0;
    i18 = i1 ? i18 : i18 >>> 8;
    i2 = i1 ? i2 : i2 | 8;
    i1 = (i18 & 240 | 0) == 0;
    i18 = (i1 ? i2 : i2 | 4) + -28 + (HEAP8[(i1 ? i18 : i18 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i1 = i18 + -3 | 0;
    i2 = (i1 | 0) > 0;
    i1 = i2 ? i1 : 0;
    i18 = i2 ? 0 : 3 - i18 | 0;
    i2 = i1;
    i3 = i18;
    i1 = -16777216 >>> i18 << i1 & i13;
   }
   i18 = HEAP32[i15 >> 2] | 0;
   i13 = i14;
   i7 = (i18 >>> i12 << i11 & i10 | i18 >>> i9 << i8 & i7 | i18 >>> i6 << i5 & i4 | i18 >>> i3 << i2 & i1) & i14;
  } else {
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   i7 = HEAP32[i4 + 28 >> 2] | 0;
   i8 = ((i2 & 2 | 0) == 0 ? 0 : i7) | (i1 ? i3 : 0);
   if (!i3) {
    i5 = 0;
    i6 = 0;
    i4 = 0;
   } else {
    i5 = i3 >>> 0 > 65535;
    i18 = i5 ? i3 >>> 16 : i3;
    i5 = i5 ? 16 : 0;
    i4 = (i18 & 65280 | 0) == 0;
    i18 = i4 ? i18 : i18 >>> 8;
    i5 = i4 ? i5 : i5 | 8;
    i4 = (i18 & 240 | 0) == 0;
    i18 = (i4 ? i5 : i5 | 4) + -4 + (HEAP8[(i4 ? i18 : i18 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i4 = i18 + -3 | 0;
    i5 = (i4 | 0) > 0;
    i4 = i5 ? i4 : 0;
    i18 = i5 ? 0 : 3 - i18 | 0;
    i5 = i4;
    i6 = i18;
    i4 = 255 >>> i18 << i4 & i3;
   }
   if (!i7) {
    i2 = 0;
    i3 = 0;
    i1 = 0;
   } else {
    i2 = i7 >>> 0 > 65535;
    i18 = i2 ? i7 >>> 16 : i7;
    i2 = i2 ? 16 : 0;
    i1 = (i18 & 65280 | 0) == 0;
    i18 = i1 ? i18 : i18 >>> 8;
    i2 = i1 ? i2 : i2 | 8;
    i1 = (i18 & 240 | 0) == 0;
    i18 = (i1 ? i2 : i2 | 4) + -28 + (HEAP8[(i1 ? i18 : i18 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
    i1 = i18 + -3 | 0;
    i2 = (i1 | 0) > 0;
    i1 = i2 ? i1 : 0;
    i18 = i2 ? 0 : 3 - i18 | 0;
    i2 = i1;
    i3 = i18;
    i1 = -16777216 >>> i18 << i1 & i7;
   }
   i7 = HEAP32[i15 >> 2] | 0;
   i7 = (HEAPU8[gb + 1160176 + ((i7 >>> 8 & 255) << 2) + 1 >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i7 & 255) << 2) >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i7 >>> 16 & 255) << 2) + 2 >> 0] | 0) | 0;
   i13 = i8;
   i7 = (i7 >>> i6 << i5 & i4 | i7 >>> i3 << i2 & i1) & i8;
  }
  i3 = ~i13;
  i4 = i16 + 8 | 0;
  if (!(HEAP32[i4 >> 2] | 0)) return;
  i5 = i16 + 4 | 0;
  i6 = i16 + 12 | 0;
  i2 = 0;
  i1 = HEAP32[i16 + 16 >> 2] | 0;
  while (1) {
   mftCall_viiii(i17 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, i7 | 0, i3 | 0);
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break; else i1 = i1 + (HEAP32[i6 >> 2] | 0) | 0;
  }
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 424683 | 0, 0, gb + 424729 | 0, 772, 1, 0, 0, 0);
 return;
}

function __ZN9Texture2D34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0;
 HEAP32[i12 + 28 >> 2] = 0;
 i10 = i11 + 52 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 HEAP32[i12 + 24 >> 2] = HEAP32[i13 + 40 >> 2];
 i9 = i12 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 + 44 >> 2];
 HEAP32[i12 + 36 >> 2] = HEAP32[i13 + 28 >> 2];
 HEAP32[i12 + 40 >> 2] = HEAP32[i13 + 32 >> 2];
 i13 = i12 + 64 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & -100663297 | HEAP32[i11 + 44 >> 2] << 25 & 100663296;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i5 = HEAP32[i11 + 92 >> 2] | 0;
  i5 = (i5 | 0) == -1 ? 5 : i5;
 } else i5 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = (i5 + -10 | 0) >>> 0 < 3;
 L5 : do if (i4) i1 = 4; else if (((i5 | 1) + -25 | 0) >>> 0 < 5) i1 = 4; else {
  switch (i5 | 0) {
  case 34:
  case 35:
  case 36:
  case 45:
  case 46:
  case 47:
   {
    i1 = 4;
    break L5;
   }
  default:
   {}
  }
  i1 = (i5 + -41 | 0) >>> 0 < 4 ? 4 : 1;
 } while (0);
 i1 = i1 + -1 | 0;
 do if (!((mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0) & i1)) {
  i8 = ((mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0) | 0) & i1 | 0) == 0;
  i1 = (HEAP32[i11 + 56 >> 2] | 0) == 6;
  if (i8) {
   if (!(HEAP8[i11 + 108 >> 0] | 0)) {
    i8 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 128 >> 2] | 0, i11 | 0) | 0;
    i2 = ((i8 & 1) << 29 | HEAP32[i13 >> 2] & -536870913) ^ 536870912;
    HEAP32[i13 >> 2] = i2;
    if (!i8) {
     i3 = i2;
     i14 = 15;
     break;
    }
   } else HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & -536870913;
   f16 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0));
   f15 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0) | 0));
   HEAPF32[i11 + 68 >> 2] = f16;
   HEAPF32[i11 + 72 >> 2] = f15;
   i4 = i1;
  } else i14 = 13;
 } else {
  i1 = (HEAP32[i11 + 56 >> 2] | 0) == 6;
  i14 = 13;
 } while (0);
 if ((i14 | 0) == 13) {
  i3 = HEAP32[i13 >> 2] | 536870912;
  HEAP32[i13 >> 2] = i3;
  i14 = 15;
 }
 if ((i14 | 0) == 15) {
  do if (i4) i14 = 20; else if (((i5 | 1) + -25 | 0) >>> 0 < 5) i14 = 20; else {
   i2 = i5 + -30 | 0;
   if (i2 >>> 0 < 15) if ((i5 + -48 | 0) >>> 0 < 12 | ((i5 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
    i14 = 20;
    break;
   } else {
    i4 = i5;
    break;
   } else if ((i5 + -45 | 0) >>> 0 < 3 | (i5 + -48 | 0) >>> 0 < 12) {
    i14 = 20;
    break;
   } else {
    i4 = i5;
    break;
   }
  } while (0);
  if ((i14 | 0) == 20) i4 = 4;
  HEAP32[i12 + 124 >> 2] = i4;
  i17 = (i3 | 0) < 0;
  i5 = i12 + 44 | 0;
  i6 = i12 + 48 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i7 = i12 + 112 | 0;
  HEAP32[i7 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i5 >> 2] | 0, i17, i4) | 0;
  i2 = __Z25GetNextAllowedTextureSizeib13TextureFormat(i2, i17, i4) | 0;
  i8 = i12 + 116 | 0;
  HEAP32[i8 >> 2] = i2;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i17) i2 = __Z24CalculateImageMipMapSizeii13TextureFormat(i3, i2, i4) | 0; else i2 = __Z18CalculateImageSizeii13TextureFormat(i3, i2, i4) | 0;
  HEAP32[i12 + 108 >> 2] = i2;
  i4 = HEAP32[i12 + 60 >> 2] | 0;
  i17 = (HEAP32[i13 >> 2] | 0) < 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i12 + 84 | 0;
  HEAP32[i3 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(HEAP32[i5 >> 2] | 0, i17, i4) | 0;
  i2 = __Z25GetNextAllowedTextureSizeib13TextureFormat(i2, i17, i4) | 0;
  HEAP32[i12 + 88 >> 2] = i2;
  i3 = HEAP32[i3 >> 2] | 0;
  if (i17) i2 = __Z24CalculateImageMipMapSizeii13TextureFormat(i3, i2, i4) | 0; else i2 = __Z18CalculateImageSizeii13TextureFormat(i3, i2, i4) | 0;
  HEAP32[i12 + 80 >> 2] = i2;
  if (i1) {
   HEAP32[i11 + 96 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i11 + 100 >> 2] = HEAP32[i8 >> 2];
  }
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 + 92 >> 2] = i4;
  HEAP32[i12 + 120 >> 2] = i4;
  i4 = i1;
 }
 i3 = i11 + 96 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 112 >> 2] | 0, i11 | 0) | 0) i1 = __Z22CalculateMipMapCount3Diii(HEAP32[i3 >> 2] | 0, HEAP32[i11 + 100 >> 2] | 0, 1) | 0; else i1 = 1;
 HEAP32[i12 + 100 >> 2] = i1;
 HEAP32[i12 + 128 >> 2] = i1;
 i2 = HEAP32[i13 >> 2] & -256 | i1 & 255;
 HEAP32[i13 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i1 + 28 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[i11 + 100 >> 2] | 0)) {
  HEAP32[i13 >> 2] = i2 & -1073741825;
  if (!i4) return;
 } else i14 = 36; else i14 = 36;
 do if ((i14 | 0) == 36) {
  i17 = (i4 & 1) << 30 ^ 1073741824;
  HEAP32[i13 >> 2] = i2 & -1073741825 | i17;
  if (!i17) {
   if (i4) break;
   return;
  } else {
   HEAP8[i11 + 110 >> 0] = 1;
   HEAP32[i12 + 20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 96 >> 2] | 0, i11 | 0) | 0;
   if (i4) break;
   return;
  }
 } while (0);
 f15 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i3 >> 2] | 0));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i11 + 100 >> 2] | 0));
 HEAPF32[i11 + 68 >> 2] = f15;
 HEAPF32[i11 + 72 >> 2] = f16;
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvPKjtPKtj(i26, i11, i4, i21, i20) {
 i26 = i26 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i27 + 52 | 0;
 i23 = i27 + 32 | 0;
 i24 = i27 + 16 | 0;
 i25 = i27;
 i7 = HEAP32[i26 + 48 >> 2] | 0;
 i19 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i3 = i9 & 65535;
 i3 = i3 >>> 0 > i20 >>> 0 ? i20 : i3;
 i18 = i9 + i20 | 0;
 i6 = i9 | 65535;
 i6 = i18 >>> 0 < i6 >>> 0 ? i18 : i6;
 HEAP32[i22 >> 2] = i11;
 if (i9 >>> 0 < i6 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i6 >>> 0);
  i8 = i1;
 } else {
  i2 = i9;
  i8 = i11;
 }
 i5 = i9 - i3 | 0;
 HEAP32[i23 >> 2] = i8;
 i3 = i5 + 65536 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i1 = i8;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else i1 = i8;
 HEAP32[i22 + 4 >> 2] = i1;
 i3 = i6 + 65536 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i23 + 4 >> 2] = i1;
 i3 = i5 + 16711680 | 0;
 i1 = i11 + ((i4 & 65535) << 2) | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) i1 = i1 + 4 | 0; else break;
 }
 HEAP32[i22 + 8 >> 2] = i1;
 i3 = i6 + 16711680 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i23 + 8 >> 2] = i1;
 i3 = i5 + 16777216 | 0;
 if (i9 >>> 0 < i3 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  i2 = i9;
  i1 = i11;
 }
 HEAP32[i22 + 12 >> 2] = i1;
 i3 = i6 + 16777216 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i23 + 12 >> 2] = i1;
 i3 = i5 + 16842752 | 0;
 if (i9 >>> 0 < i3 >>> 0) {
  i1 = i11;
  do {
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 } else {
  i2 = i9;
  i1 = i11;
 }
 HEAP32[i22 + 16 >> 2] = i1;
 i3 = i6 + 16842752 | 0;
 if (i2 >>> 0 < i3 >>> 0) do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i3 >>> 0);
 HEAP32[i23 + 16 >> 2] = i1;
 i18 = HEAP32[i7 + 232 >> 2] | 0;
 i12 = i21 + (i18 << 1) | 0;
 if (!i18) {
  STACKTOP = i27;
  return;
 }
 i13 = i24 + 4 | 0;
 i14 = i24 + 8 | 0;
 i15 = i24 + 12 | 0;
 i16 = i25 + 4 | 0;
 i17 = i25 + 8 | 0;
 i18 = i25 + 12 | 0;
 i2 = i9;
 i1 = i8;
 i10 = i21;
 while (1) {
  i9 = HEAPU16[i10 >> 1] | 0;
  i6 = HEAP32[i19 + (i9 << 4) >> 2] | 0;
  HEAP32[i24 >> 2] = i6;
  i8 = HEAP32[i19 + (i9 << 4) + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = i8;
  i7 = HEAP32[i19 + (i9 << 4) + 8 >> 2] | 0;
  HEAP32[i14 >> 2] = i7;
  i9 = HEAP32[i19 + (i9 << 4) + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = i9;
  HEAP32[i25 >> 2] = i6;
  HEAP32[i16 >> 2] = i8;
  HEAP32[i17 >> 2] = i7;
  HEAP32[i18 >> 2] = i9;
  i9 = i2 & 65535;
  i9 = i2 - (i9 >>> 0 > i20 >>> 0 ? i20 : i9) | 0;
  i7 = i2 + i20 | 0;
  i8 = i2 | 65535;
  i8 = i7 >>> 0 < i8 >>> 0 ? i7 : i8;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 < i8 >>> 0) {
   do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i8 >>> 0);
   HEAP32[i23 >> 2] = i1;
  }
  i1 = i21 + (i1 - i11 >> 2 << 1) | 0;
  i7 = i10 + 2 | 0;
  if ((i7 | 0) == (i1 | 0)) i6 = 1; else {
   i2 = i7;
   do {
    i6 = i19 + ((HEAPU16[i2 >> 1] | 0) << 4) | 0;
    __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvRS2_S5_RKS2_S7_(i26, i24, i6, i25, i6);
    i2 = i2 + 2 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i6 = 1;
  }
  do {
   i4 = HEAP32[gb + 168536 + (i6 << 2) >> 2] | 0;
   i2 = i9 + i4 | 0;
   i3 = i22 + (i6 << 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i3 >> 2] = i1;
    i5 = i1;
   } else i5 = i1;
   i2 = i4 + i8 | 0;
   i3 = i23 + (i6 << 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0) {
    do i1 = i1 + 4 | 0; while ((HEAP32[i1 >> 2] | 0) >>> 0 < i2 >>> 0);
    HEAP32[i3 >> 2] = i1;
   }
   i4 = i1 - i11 >> 2;
   i2 = i21 + (i4 << 1) | 0;
   i1 = i5 - i11 >> 2;
   if ((i1 | 0) != (i4 | 0)) {
    i1 = i21 + (i1 << 1) | 0;
    do {
     i5 = i19 + ((HEAPU16[i1 >> 1] | 0) << 4) | 0;
     __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvRS2_S5_RKS2_S7_(i26, i24, i5, i25, i5);
     i1 = i1 + 2 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 5);
  i1 = HEAPU16[i10 >> 1] | 0;
  HEAP32[i19 + (i1 << 4) >> 2] = HEAP32[i24 >> 2];
  HEAP32[i19 + (i1 << 4) + 4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i19 + (i1 << 4) + 8 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 + (i1 << 4) + 12 >> 2] = HEAP32[i15 >> 2];
  i1 = (HEAP32[i22 >> 2] | 0) + 4 | 0;
  HEAP32[i22 >> 2] = i1;
  if ((i7 | 0) == (i12 | 0)) break;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i23 >> 2] | 0;
  i10 = i7;
 }
 STACKTOP = i27;
 return;
}

function __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i12, i13, i7, i6, i14, i10) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 424 | 0;
 i1 = i15 + 24 | 0;
 i18 = i15 + 16 | 0;
 i9 = i15 + 8 | 0;
 i16 = i15 + 4 | 0;
 i8 = i15 + 428 | 0;
 i4 = i15;
 HEAP32[i18 >> 2] = i1;
 i20 = i18 + 4 | 0;
 HEAP32[i20 >> 2] = fb + 4003;
 i5 = i1 + 400 | 0;
 __THREW__ = 0;
 i2 = invoke_ii(fb + 2804 | 0, i6 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  HEAP32[i18 >> 2] = 0;
  i19 = 43;
 } else {
  HEAP32[i16 >> 2] = i2;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i16 | 0, gb + 1474588 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   i11 = HEAP32[i13 >> 2] | 0;
   HEAP32[i4 >> 2] = i11;
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   i6 = i11;
   __THREW__ = 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i1 = invoke_iiiiiiiiiiii(fb + 2 | 0, i12 | 0, i3 | 0, i7 | 0, i16 | 0, i1 | 0, i14 | 0, i8 | 0, i2 | 0, i18 | 0, i9 | 0, i5 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   L7 : do if (i7 & 1) i19 = 13; else {
    if (i1) {
     i1 = i10 + 8 + 3 | 0;
     if ((HEAP8[i1 >> 0] | 0) < 0) {
      HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
      HEAP32[i10 + 4 >> 2] = 0;
     } else {
      HEAP32[i10 >> 2] = 0;
      HEAP8[i1 >> 0] = 0;
     }
     if (HEAP8[i8 >> 0] | 0) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, 45) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i19 = 13;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4513 | 0, i10 | 0, i1 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i19 = 13;
       break;
      }
     }
     __THREW__ = 0;
     i4 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, 48) | 0;
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) {
      i19 = 13;
      break;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     i3 = i2 + -4 | 0;
     i1 = HEAP32[i18 >> 2] | 0;
     while (1) {
      if (i1 >>> 0 >= i3 >>> 0) break;
      if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) break;
      i1 = i1 + 4 | 0;
     }
     __THREW__ = 0;
     invoke_iiii(fb + 505 | 0, i10 | 0, i1 | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     }
    }
    i1 = HEAP32[i12 >> 2] | 0;
    do if (!i1) i2 = 1; else {
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i10 = __THREW__;
      __THREW__ = 0;
      if (i10 & 1) {
       i19 = 13;
       break L7;
      }
     } else i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i12 >> 2] = 0;
      i2 = 1;
      break;
     } else {
      i2 = (HEAP32[i12 >> 2] | 0) == 0;
      break;
     }
    } while (0);
    do if (!i11) i19 = 34; else {
     i1 = HEAP32[i6 + 12 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) {
       i19 = 13;
       break L7;
      }
     } else i1 = HEAP32[i1 >> 2] | 0;
     if ((i1 | 0) == -1) {
      HEAP32[i13 >> 2] = 0;
      i19 = 34;
      break;
     } else if (i2) break; else {
      i19 = 36;
      break;
     }
    } while (0);
    if ((i19 | 0) == 34) if (i2) i19 = 36;
    if ((i19 | 0) == 36) HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 2;
    i2 = HEAP32[i12 >> 2] | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i16 >> 2] | 0) | 0;
    i1 = HEAP32[i18 >> 2] | 0;
    HEAP32[i18 >> 2] = 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(HEAP32[i20 >> 2] | 0, i1 | 0);
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i20 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i20);
     }
    }
    STACKTOP = i15;
    return i2 | 0;
   } while (0);
   if ((i19 | 0) == 13) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   i2 = i1;
  }
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i16 >> 2] | 0) | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  if (!i1) i17 = i2; else i19 = 43;
 }
 if ((i19 | 0) == 43) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i20 >> 2] | 0, i1 | 0);
  i20 = __THREW__;
  __THREW__ = 0;
  if (i20 & 1) {
   i20 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i20);
  } else i17 = i2;
 }
 ___resumeException(i17 | 0);
 return 0;
}

function __ZN6Camera25RenderDepthNormalsTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE(i9, i1, i10, i11, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 i4 = (__Z21GetManagerFromContexti(6) | 0) + 68 | 0;
 if (!(HEAP32[i4 + 4 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 10;
  }
 }
 if ((i5 | 0) == 8) i5 = 10;
 if ((i5 | 0) == 10) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
 }
 if ((HEAP16[gb + 1110532 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = i9;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110532 | 0, i6);
  i2 = gb + 1110532 | 0;
 } else i2 = 0;
 i3 = HEAP32[gb + 1110532 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i3 | 0);
 i3 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 3;
 i4 = i9 + 1152 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i12 = __Z22GetRenderBufferManagerv() | 0;
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i12, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i5 = (HEAP8[(__Z17GetPlayerSettingsv() | 0) + 383 >> 0] | 0) != 0;
 i5 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, i5 ? 1 : 2, 0, 0, 1, 0, 1) | 0;
 HEAP32[i4 >> 2] = i5;
 if (i5 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, gb + 376502 | 0);
  __ZN7Texture13SetFilterModeEi(HEAP32[i4 >> 2] | 0, 0);
  i13 = __Z12GetGfxDevicev() | 0;
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i4 >> 2] | 0, 0, -1, 0, 0);
  HEAPF32[i6 >> 2] = Math_fround(.5);
  HEAPF32[i6 + 4 >> 2] = Math_fround(.5);
  HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(7, i6, Math_fround(1.0), 0, i11);
  __Z15gpu_time_samplev();
  __ZNK6Camera28ExtractCameraRenderingParamsEv(i6, i9);
  __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i9, i11, i6, 0);
  __ZN15RenderNodeQueueC2ERK10MemLabelId(i6, gb + 64016 | 0);
  i5 = i9 + 1136 | 0;
  i12 = i9 + 4 | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i5, 2, i11, i6, gb + 1159956 | 0, HEAP32[i12 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i5, 2, i11, i6, gb + 1159956 | 0, HEAP32[i12 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 469949 | 0, 10);
  __Z28RenderSceneShaderReplacementRK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEER17ShaderPassContext(i10, i1, i7, i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i13 | 0, 0);
  i10 = i11 + 36 | 0;
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i10, gb + 1110560 | 0, HEAP32[i4 >> 2] | 0);
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i10, gb + 1110568 | 0, HEAP32[i4 >> 2] | 0);
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i5, 3, i11, i6, gb + 1159956 | 0, HEAP32[i12 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i5, 3, i11, i6, gb + 1159956 | 0, HEAP32[i12 >> 2] | 0);
  __ZN15RenderNodeQueueD2Ev(i6);
 }
 HEAP32[gb + 1163232 >> 2] = i3;
 i13 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 652 >> 2] | 0, i13 | 0);
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return;
}

function __ZN7Cubemap13UploadTextureEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 24 | 0;
 i6 = i21 + 20 | 0;
 i14 = i21 + 16 | 0;
 i5 = i21;
 i15 = i21 + 8 | 0;
 i19 = i21 + 12 | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 100 >> 2] | 0, i18 | 0) | 0;
 i20 = i18 + 52 | 0;
 if ((i16 | 0) == (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 104 >> 2] | 0, i18 | 0) | 0)) {
  i1 = HEAP32[i20 >> 2] | 0;
  if (!i1) i2 = 4; else if ((HEAP32[i1 + 44 >> 2] | 0) != 6) i2 = 4;
 } else i2 = 4;
 if ((i2 | 0) == 4) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397378 | 0, 0, gb + 397213 | 0, 60, 1, 0, 0, 0);
 __ZN9Texture2D18UnshareTextureDataEv(i18);
 i3 = HEAP32[i20 >> 2] | 0;
 if (!i3) {
  i13 = HEAP32[i18 + 92 >> 2] | 0;
  i13 = (i13 | 0) == -1 ? 5 : i13;
  i1 = 0;
  i2 = 0;
  i4 = 0;
 } else {
  i4 = HEAP32[i3 + 8 >> 2] | 0;
  i13 = HEAP32[i3 + 36 >> 2] | 0;
  i1 = i4 + (HEAP32[i3 + 40 >> 2] | 0) | 0;
  i2 = i4;
 }
 i7 = i1 - i2 | 0;
 i1 = i7 * 6 | 0;
 i12 = i3 + 4 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i12 = __Z21GetUncheckedGfxDevicev() | 0;
 i3 = (i13 | 1 | 0) == 29;
 if (i3) {
  i1 = HEAP32[i20 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 40 >> 2] | 0;
 }
 i16 = i18 + 48 | 0;
 i8 = HEAP32[i16 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 100 >> 2] | 0, i18 | 0) | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 104 >> 2] | 0, i18 | 0) | 0;
 i10 = HEAP32[i18 + 76 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i11 = HEAP32[i18 + 60 >> 2] | 0; else i11 = 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i14 >> 2] = i13;
 do if (i3) {
  i7 = gb + 64016 | 0;
  i13 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i1 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i4, i6, i14, i10, i9, i2, 6, i17) | 0;
  if (i1 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = i1;
   i4 = i1;
   i5 = 0;
   i3 = (i2 >>> 0) / 6 | 0;
   i1 = i2;
   i2 = HEAP32[i14 >> 2] | 0;
   break;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397434 | 0, 0, gb + 397213 | 0, 80, 1, HEAP32[i18 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i21;
  return;
 } else {
  i6 = 0;
  i5 = 1;
  i3 = i7;
  i2 = i13;
 } while (0);
 i14 = HEAP32[(HEAP32[i12 >> 2] | 0) + 444 >> 2] | 0;
 HEAP32[i15 >> 2] = i8;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 mftCall_viiiiiiiiii(i14 | 0, i12 | 0, i17 | 0, i4 | 0, i1 | 0, i3 | 0, i9 | 0, i2 | 0, i10 | 0, i5 | 0, i11 | 0);
 if (i6 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 64016 | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 292 >> 2] | 0, i12 | 0, HEAP32[i20 >> 2] | 0);
 i5 = HEAP32[i16 >> 2] | 0;
 i6 = i18;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i17 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 22;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 27;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 26;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 22) {
   HEAP32[i17 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 26) {
   HEAP32[i17 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 27) {
   HEAP32[i17 >> 2] = i1;
   i4 = i1;
   i3 = i17;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i15 = i7 + 8 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 HEAP32[i18 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 92 >> 2] | 0, i18 | 0);
 HEAP8[i18 + 109 >> 0] = 1;
 i15 = __Z12GetGfxDevicev() | 0;
 i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 680 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 i16 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 36 >> 2] | 0, i18 | 0) | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 mftCall_viii(i14 | 0, i15 | 0, i17 | 0, i16 | 0);
 if (HEAP8[i18 + 111 >> 0] | 0) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i19 = i1 + 4 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
 if (!(HEAP32[i19 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
 }
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __Z29FindBrightestDirectionalLightb(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 8 | 0;
 i2 = i16;
 i13 = i16 + 16 | 0;
 if ((HEAP16[gb + 1111136 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111136 | 0, i1);
  i12 = gb + 1111136 | 0;
 } else i12 = 0;
 i10 = HEAP32[gb + 1112264 >> 2] | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i11 = i2;
 HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i11 + 4 >> 2] = i14;
 HEAP32[i13 >> 2] = 0;
 i11 = i13 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i14 = i13 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i8 = i1;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i15;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = HEAP32[i14 >> 2] | 0;
 do if ((i1 & 2147483640) >>> 0 < 8) if ((i1 | 0) > -1) {
  HEAP32[i14 >> 2] = 8;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, 32, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
  HEAP32[i14 >> 2] = 8;
  HEAP32[i13 >> 2] = i9;
  break;
 } while (0);
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i1;
 L10 : do if ((i2 | 0) != (i10 | 0)) {
  if (i3) i9 = i2; else while (1) {
   if ((HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 40 >> 2] | 0) == 1) {
    i3 = i1 + -36 | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = HEAP32[i14 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i7 >>> 0 > i9 >>> 0) {
     i1 = i8 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i13 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i7;
    HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 << 2) >> 2] = i3;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i10 | 0)) break L10;
  }
  do {
   i2 = i1;
   i1 = i2 + -36 | 0;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   i3 = HEAP32[i2 + 40 >> 2] | 0;
   do if ((i3 | 0) != 3) {
    if ((HEAP32[i2 + 88 >> 2] | 0) > -1) if ((HEAP32[i2 + 80 >> 2] | 0) != 1) break;
    if (HEAP32[i2 + 36 >> 2] | 0) if ((i3 | 0) == 1 ? !(Math_fround(HEAPF32[i2 + 44 >> 2]) < Math_fround(.00100000005)) : 0) {
     i3 = HEAP32[i11 >> 2] | 0;
     i6 = i3 + 1 | 0;
     i7 = HEAP32[i14 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i14 >> 2] = i2;
       HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
       HEAP32[i14 >> 2] = i2;
       HEAP32[i13 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i11 >> 2] = i6;
     HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = i1;
    }
   } while (0);
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   i9 = i1;
  } while ((i9 | 0) != (i10 | 0));
 } while (0);
 i7 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (!i3) i1 = 0; else {
  f5 = Math_fround(-1.0);
  i1 = 0;
  i2 = -1;
  while (1) {
   i6 = HEAP32[(HEAP32[i7 + (i1 << 2) >> 2] | 0) + 44 >> 2] | 0;
   f17 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) * Math_fround(.300000012));
   f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(.589999974)));
   f17 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i6 + 28 >> 2]) * Math_fround(.109999999)));
   f17 = Math_fround(Math_fround(HEAPF32[i6 + 44 >> 2]) * f17);
   f4 = Math_fround(f17 * Math_fround(16.0));
   f4 = (HEAP32[i6 + 96 >> 2] | 0) == 0 ? f17 : f4;
   i6 = f4 > f5 ? (HEAP32[i6 + 76 >> 2] | 0) != 2 : 0;
   i2 = i6 ? i1 : i2;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else f5 = i6 ? f4 : f5;
  }
  if ((i2 | 0) == -1) i1 = 0; else i1 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i15);
  HEAP32[i13 >> 2] = 0;
 }
 if (!i12) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return i1 | 0;
}

function runPostSets229() {
 HEAP32[gb + 209404 >> 2] = fb + 143;
 HEAP32[gb + 209408 >> 2] = fb + 176;
 HEAP32[gb + 209412 >> 2] = fb + 1416;
 HEAP32[gb + 209416 >> 2] = fb + 401;
 HEAP32[gb + 209420 >> 2] = fb + 97;
 HEAP32[gb + 209424 >> 2] = fb + 1408;
 HEAP32[gb + 209428 >> 2] = fb + 403;
 HEAP32[gb + 209432 >> 2] = fb + 476;
 HEAP32[gb + 209436 >> 2] = fb + 306;
 HEAP32[gb + 209440 >> 2] = fb + 481;
 HEAP32[gb + 10952 >> 2] = (HEAP32[gb + 10952 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10956 >> 2] = (HEAP32[gb + 10956 >> 2] | 0) + (gb + 1077818 | 0);
 HEAP32[gb + 10960 >> 2] = (HEAP32[gb + 10960 >> 2] | 0) + (gb + 10760 | 0);
 HEAP32[gb + 209448 >> 2] = (HEAP32[gb + 209448 >> 2] | 0) + (gb + 10968 | 0);
 HEAP32[gb + 209452 >> 2] = fb + 3039;
 HEAP32[gb + 209456 >> 2] = fb + 3064;
 HEAP32[gb + 209460 >> 2] = fb + 2298;
 HEAP32[gb + 209464 >> 2] = fb + 302;
 HEAP32[gb + 209468 >> 2] = fb + 144;
 HEAP32[gb + 209472 >> 2] = fb + 177;
 HEAP32[gb + 209476 >> 2] = fb + 1409;
 HEAP32[gb + 209480 >> 2] = fb + 1410;
 HEAP32[gb + 209484 >> 2] = fb + 303;
 HEAP32[gb + 209488 >> 2] = fb + 1417;
 HEAP32[gb + 209492 >> 2] = fb + 1418;
 HEAP32[gb + 209496 >> 2] = fb + 482;
 HEAP32[gb + 209500 >> 2] = fb + 304;
 HEAP32[gb + 209504 >> 2] = fb + 479;
 HEAP32[gb + 10968 >> 2] = (HEAP32[gb + 10968 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10972 >> 2] = (HEAP32[gb + 10972 >> 2] | 0) + (gb + 1077881 | 0);
 HEAP32[gb + 10976 >> 2] = (HEAP32[gb + 10976 >> 2] | 0) + (gb + 10768 | 0);
 HEAP32[gb + 209512 >> 2] = (HEAP32[gb + 209512 >> 2] | 0) + (gb + 10984 | 0);
 HEAP32[gb + 209516 >> 2] = fb + 3037;
 HEAP32[gb + 209520 >> 2] = fb + 3065;
 HEAP32[gb + 209524 >> 2] = fb + 2299;
 HEAP32[gb + 209528 >> 2] = fb + 96;
 HEAP32[gb + 209532 >> 2] = fb + 143;
 HEAP32[gb + 209536 >> 2] = fb + 176;
 HEAP32[gb + 209540 >> 2] = fb + 400;
 HEAP32[gb + 209544 >> 2] = fb + 401;
 HEAP32[gb + 209548 >> 2] = fb + 97;
 HEAP32[gb + 209552 >> 2] = fb + 1419;
 HEAP32[gb + 209556 >> 2] = fb + 1420;
 HEAP32[gb + 209560 >> 2] = fb + 483;
 HEAP32[gb + 209564 >> 2] = fb + 98;
 HEAP32[gb + 209568 >> 2] = fb + 477;
 HEAP32[gb + 10984 >> 2] = (HEAP32[gb + 10984 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 10988 >> 2] = (HEAP32[gb + 10988 >> 2] | 0) + (gb + 1077905 | 0);
 HEAP32[gb + 10992 >> 2] = (HEAP32[gb + 10992 >> 2] | 0) + (gb + 10760 | 0);
 HEAP32[gb + 209576 >> 2] = (HEAP32[gb + 209576 >> 2] | 0) + (gb + 11e3 | 0);
 HEAP32[gb + 209580 >> 2] = fb + 3066;
 HEAP32[gb + 209584 >> 2] = fb + 3067;
 HEAP32[gb + 209588 >> 2] = fb + 3068;
 HEAP32[gb + 209592 >> 2] = fb + 84;
 HEAP32[gb + 209596 >> 2] = fb + 178;
 HEAP32[gb + 209600 >> 2] = fb + 307;
 HEAP32[gb + 11e3 >> 2] = (HEAP32[gb + 11e3 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11004 >> 2] = (HEAP32[gb + 11004 >> 2] | 0) + (gb + 1077929 | 0);
 HEAP32[gb + 11008 >> 2] = (HEAP32[gb + 11008 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11016 >> 2] = (HEAP32[gb + 11016 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11020 >> 2] = (HEAP32[gb + 11020 >> 2] | 0) + (gb + 1077949 | 0);
 HEAP32[gb + 11024 >> 2] = (HEAP32[gb + 11024 >> 2] | 0) + (gb + 12768 | 0);
 HEAP32[gb + 209608 >> 2] = (HEAP32[gb + 209608 >> 2] | 0) + (gb + 11032 | 0);
 HEAP32[gb + 209612 >> 2] = fb + 3069;
 HEAP32[gb + 209616 >> 2] = fb + 3070;
 HEAP32[gb + 209620 >> 2] = fb + 3068;
 HEAP32[gb + 209624 >> 2] = fb + 85;
 HEAP32[gb + 209628 >> 2] = fb + 179;
 HEAP32[gb + 209632 >> 2] = fb + 308;
 HEAP32[gb + 11032 >> 2] = (HEAP32[gb + 11032 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 11036 >> 2] = (HEAP32[gb + 11036 >> 2] | 0) + (gb + 1077971 | 0);
 HEAP32[gb + 11040 >> 2] = (HEAP32[gb + 11040 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 209640 >> 2] = (HEAP32[gb + 209640 >> 2] | 0) + (gb + 11048 | 0);
 HEAP32[gb + 209644 >> 2] = fb + 3071;
 HEAP32[gb + 209648 >> 2] = fb + 3072;
 HEAP32[gb + 209652 >> 2] = fb + 3068;
 HEAP32[gb + 209656 >> 2] = fb + 92;
 HEAP32[gb + 209660 >> 2] = fb + 93;
 HEAP32[gb + 209664 >> 2] = fb + 94;
 HEAP32[gb + 209668 >> 2] = fb + 95;
 HEAP32[gb + 209672 >> 2] = fb + 96;
 HEAP32[gb + 209676 >> 2] = fb + 97;
 HEAP32[gb + 209680 >> 2] = fb + 98;
 HEAP32[gb + 209684 >> 2] = fb + 99;
 HEAP32[gb + 209688 >> 2] = fb + 100;
 HEAP32[gb + 209692 >> 2] = fb + 101;
 HEAP32[gb + 209696 >> 2] = fb + 102;
 HEAP32[gb + 11048 >> 2] = (HEAP32[gb + 11048 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11052 >> 2] = (HEAP32[gb + 11052 >> 2] | 0) + (gb + 1078027 | 0);
 HEAP32[gb + 11064 >> 2] = (HEAP32[gb + 11064 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 11072 >> 2] = (HEAP32[gb + 11072 >> 2] | 0) + (gb + 11080 | 0);
 HEAP32[gb + 11080 >> 2] = (HEAP32[gb + 11080 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 11084 >> 2] = (HEAP32[gb + 11084 >> 2] | 0) + (gb + 1078095 | 0);
 HEAP32[gb + 11096 >> 2] = (HEAP32[gb + 11096 >> 2] | 0) + (gb + 11104 | 0);
 HEAP32[gb + 11104 >> 2] = (HEAP32[gb + 11104 >> 2] | 0) + (gb + 216100 | 0);
 HEAP32[gb + 11108 >> 2] = (HEAP32[gb + 11108 >> 2] | 0) + (gb + 1078117 | 0);
 HEAP32[gb + 209704 >> 2] = (HEAP32[gb + 209704 >> 2] | 0) + (gb + 11112 | 0);
 HEAP32[gb + 209708 >> 2] = fb + 3073;
 HEAP32[gb + 209712 >> 2] = fb + 3074;
 HEAP32[gb + 209716 >> 2] = fb + 3068;
 runPostSets230();
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 16 | 0;
 i20 = i22;
 i2 = i17 + 32 | 0;
 __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_(i17, i17 + 16 | 0, i2, i1) | 0;
 i1 = i17 + 48 | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i22;
  return;
 }
 i16 = i20 + 12 | 0;
 i10 = i20 + 12 | 0;
 i11 = i19 + 4 | 0;
 i12 = i20 + 8 | 0;
 i13 = i20 + 4 | 0;
 i14 = i20 + 11 | 0;
 i15 = i19 + 4 | 0;
 i9 = i1;
 while (1) {
  i7 = HEAP8[i9 + 11 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i9 + 4 >> 2] | 0 : i7 & 255;
  i5 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
  i3 = i5 >>> 0 < i7 >>> 0 ? i5 : i7;
  if (!i3) i21 = 6; else {
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = _memcmp(i6 ? i1 : i9, i4 ? HEAP32[i2 >> 2] | 0 : i2, i3) | 0;
   if (!i3) i21 = 6; else if ((i3 | 0) < 0) {
    i3 = i9;
    i21 = 9;
   }
  }
  if ((i21 | 0) == 6) {
   i21 = 0;
   if (i7 >>> 0 < i5 >>> 0) {
    i3 = i9;
    i1 = HEAP32[i9 >> 2] | 0;
    i21 = 9;
   }
  }
  if ((i21 | 0) == 9) {
   i21 = 0;
   i3 = i6 ? i1 : i3;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i16 >> 2] = i1;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i20);
    i1 = HEAP32[i10 >> 2] | 0;
    i21 = 12;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i14 >> 0] = i7;
    if (!i7) i1 = i20; else {
     i1 = i20;
     i21 = 14;
    }
   } else i21 = 12;
   if ((i21 | 0) == 12) {
    i8 = i7 + 16 & -16;
    HEAP32[i19 >> 2] = 66;
    HEAP32[i11 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i20 >> 2] = i1;
    HEAP32[i12 >> 2] = i8 | -2147483648;
    HEAP32[i13 >> 2] = i7;
    i21 = 14;
   }
   if ((i21 | 0) == 14) {
    i21 = 0;
    _memcpy(i1 | 0, i3 | 0, i7 | 0) | 0;
   }
   HEAP8[i1 + i7 >> 0] = 0;
   i6 = i9;
   while (1) {
    i8 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i8 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255;
    i4 = i6 + 11 | 0;
    i1 = HEAP8[i4 >> 0] | 0;
    i3 = i1 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i6 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    do if (i8 >>> 0 > i5 >>> 0) {
     if (i3) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i5, i8 - i5 | 0, i1, 0, i1, i8, i7);
    } else {
     if (i3) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
     if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
     HEAP8[i1 + i8 >> 0] = 0;
     if ((HEAP8[i4 >> 0] | 0) < 0) {
      HEAP32[i6 + 4 >> 2] = i8;
      break;
     } else {
      HEAP8[i4 >> 0] = i8;
      break;
     }
    } while (0);
    if ((i2 | 0) == (i17 | 0)) {
     i2 = i17;
     break;
    }
    i5 = i2 + -16 | 0;
    i6 = HEAP8[i14 >> 0] | 0;
    i3 = i6 << 24 >> 24 < 0;
    i6 = i3 ? HEAP32[i13 >> 2] | 0 : i6 & 255;
    i7 = HEAP8[i5 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 + -12 >> 2] | 0 : i7 & 255;
    i1 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
    if (i1 | 0) {
     i1 = _memcmp(i3 ? HEAP32[i20 >> 2] | 0 : i20, i4 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
     if (i1 | 0) if ((i1 | 0) < 0) {
      i6 = i2;
      i2 = i5;
      continue;
     } else break;
    }
    if (i6 >>> 0 < i7 >>> 0) {
     i6 = i2;
     i2 = i5;
    } else break;
   }
   do if ((i2 | 0) != (i20 | 0)) {
    i7 = HEAP8[i14 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i20 >> 2] | 0 : i20;
    i7 = i4 ? HEAP32[i13 >> 2] | 0 : i7 & 255;
    i4 = i2 + 11 | 0;
    i1 = HEAP8[i4 >> 0] | 0;
    i3 = i1 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i2 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i5, i7 - i5 | 0, i1, 0, i1, i7, i6);
     break;
    }
    if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i2 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   if ((HEAP8[i14 >> 0] | 0) < 0) {
    i8 = HEAP32[i20 >> 2] | 0;
    i7 = HEAP32[i10 >> 2] | 0;
    HEAP32[i19 >> 2] = 66;
    HEAP32[i15 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i19);
   }
  }
  i1 = i9 + 16 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i2 = i9;
   i9 = i1;
  }
 }
 STACKTOP = i22;
 return;
}
function __ZN4crnd12crn_unpacker22decode_alpha_selectorsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 1920 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28;
 i25 = i28 + 1008 | 0;
 i26 = i28 + 984 | 0;
 i22 = i28 + 80 | 0;
 i23 = i28 + 16 | 0;
 i2 = HEAP32[i5 + 88 >> 2] | 0;
 i20 = (HEAPU8[i2 + 63 >> 0] | 0) << 8 | (HEAPU8[i2 + 64 >> 0] | 0);
 i21 = i5 + 92 | 0;
 i1 = (HEAP32[i5 + 4 >> 2] | 0) + ((HEAPU8[i2 + 58 >> 0] | 0) << 8 | (HEAPU8[i2 + 57 >> 0] | 0) << 16 | (HEAPU8[i2 + 59 >> 0] | 0)) | 0;
 i2 = (HEAPU8[i2 + 61 >> 0] | 0) << 8 | (HEAPU8[i2 + 60 >> 0] | 0) << 16 | (HEAPU8[i2 + 62 >> 0] | 0);
 if (!i2) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 HEAP32[i21 >> 2] = i1;
 HEAP32[i5 + 96 >> 2] = i1;
 HEAP32[i5 + 104 >> 2] = i2;
 HEAP32[i5 + 100 >> 2] = i1 + i2;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 112 >> 2] = 0;
 i24 = i26 + 20 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i26 + 16 >> 0] = 0;
 if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i21, i26) | 0) {
  i1 = 0;
  i2 = -7;
  i3 = -7;
  while (1) {
   HEAP32[i25 + (i1 << 2) >> 2] = i3;
   HEAP32[i22 + (i1 << 2) >> 2] = i2;
   i4 = (i3 | 0) > 6;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 225) break; else {
    i2 = (i4 & 1) + i2 | 0;
    i3 = i4 ? -7 : i3 + 1 | 0;
   }
  }
  i1 = i23;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i19 = i5 + 284 | 0;
  i2 = i20 * 3 | 0;
  i3 = i5 + 288 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  L9 : do if ((i1 | 0) == (i2 | 0)) i6 = 13; else {
   if (i1 >>> 0 <= i2 >>> 0) {
    do if ((HEAP32[i5 + 292 >> 2] | 0) >>> 0 < i2 >>> 0) if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i19, i2, (i1 + 1 | 0) == (i2 | 0), 2, 0) | 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     break;
    } else {
     HEAP8[i5 + 296 >> 0] = 1;
     i1 = 0;
     break L9;
    } while (0);
    _memset((HEAP32[i19 >> 2] | 0) + (i1 << 1) | 0, 0, i2 - i1 << 1 | 0) | 0;
   }
   HEAP32[i3 >> 2] = i2;
   i6 = 13;
  } while (0);
  if ((i6 | 0) == 13) if (!i20) i1 = 1; else {
   i4 = i23 + 4 | 0;
   i5 = i23 + 8 | 0;
   i6 = i23 + 12 | 0;
   i7 = i23 + 16 | 0;
   i8 = i23 + 20 | 0;
   i9 = i23 + 24 | 0;
   i10 = i23 + 28 | 0;
   i11 = i23 + 32 | 0;
   i12 = i23 + 36 | 0;
   i13 = i23 + 40 | 0;
   i14 = i23 + 44 | 0;
   i15 = i23 + 48 | 0;
   i16 = i23 + 52 | 0;
   i17 = i23 + 56 | 0;
   i18 = i23 + 60 | 0;
   i3 = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   while (1) {
    i1 = 0;
    do {
     i29 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i21, i26) | 0;
     i19 = i1 << 1;
     i30 = i23 + (i19 << 2) | 0;
     HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + (HEAP32[i25 + (i29 << 2) >> 2] | 0) & 7;
     i19 = i23 + ((i19 | 1) << 2) | 0;
     HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + (HEAP32[i22 + (i29 << 2) >> 2] | 0) & 7;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 8);
    i29 = HEAPU8[(HEAP32[i8 >> 2] | 0) + (gb + 401152) >> 0] | 0;
    HEAP16[i2 >> 1] = (HEAPU8[(HEAP32[i4 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 3 | (HEAPU8[(HEAP32[i23 >> 2] | 0) + (gb + 401152) >> 0] | 0) | (HEAPU8[(HEAP32[i5 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 6 | (HEAPU8[(HEAP32[i6 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 9 | (HEAPU8[(HEAP32[i7 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 12 | i29 << 15;
    i30 = HEAPU8[(HEAP32[i13 >> 2] | 0) + (gb + 401152) >> 0] | 0;
    HEAP16[i2 + 2 >> 1] = (HEAPU8[(HEAP32[i9 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 2 | i29 >>> 1 | (HEAPU8[(HEAP32[i10 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 5 | (HEAPU8[(HEAP32[i11 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 8 | (HEAPU8[(HEAP32[i12 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 11 | i30 << 14;
    HEAP16[i2 + 4 >> 1] = (HEAPU8[(HEAP32[i14 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 1 | i30 >>> 2 | (HEAPU8[(HEAP32[i15 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 4 | (HEAPU8[(HEAP32[i16 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 7 | (HEAPU8[(HEAP32[i17 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 10 | (HEAPU8[(HEAP32[i18 >> 2] | 0) + (gb + 401152) >> 0] | 0) << 13;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i20 | 0)) {
     i1 = 1;
     break;
    } else i2 = i2 + 6 | 0;
   }
  }
  i3 = i1;
 } else i3 = 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i26 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i27 >> 2] = gb + 401209;
   HEAP32[i27 + 4 >> 2] = 2513;
   HEAP32[i27 + 8 >> 2] = gb + 401349;
   _sprintf(i25, gb + 401176 | 0, i27) | 0;
   _puts(i25) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  HEAP32[i26 + 12 >> 2] = 0;
 }
 i30 = i3;
 STACKTOP = i28;
 return i30 | 0;
}

function __Z19CanReplaceComponentRN5Unity9ComponentEiPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i16, i1, i20) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 16 | 0;
 i15 = i21 + 8 | 0;
 i2 = i21;
 i17 = i21 + 36 | 0;
 i18 = i21 + 24 | 0;
 i3 = HEAP32[i16 + 28 >> 2] | 0;
 if (!i3) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if ((__ZN10GameObject17GetComponentIndexEPN5Unity9ComponentE(i3, i16) | 0) == -1) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i1 = (HEAP32[i16 + 8 >> 2] | 0) >>> 21;
 i14 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + (i1 << 2) >> 2] | 0) + 16 >> 2] | 0;
 if ((i14 | 0) == 4) {
  if (!i20) {
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  }
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  __Z6FormatPKcz(i17, gb + 446793 | 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20, i17) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if ((i1 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) i12 = __ZNK13MonoBehaviour8GetClassEv(i16) | 0; else i12 = 0;
 i13 = i3 + 40 | 0;
 do if ((HEAP32[i13 >> 2] | 0) > 0) {
  i11 = i3 + 28 | 0;
  if (!i20) {
   i3 = 0;
   i10 = 0;
   i1 = 1;
   do {
    i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 3) >> 2] << 2) >> 2] | 0;
    if (!i2) i9 = -1; else i9 = HEAP32[i2 + 16 >> 2] | 0;
    i8 = __Z34FindRequiredComponentsForComponenti(i9) | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i2 = i8 - i4 >> 2;
    if (!i2) i2 = i4; else {
     i7 = i2;
     i2 = i4;
     while (1) {
      i22 = (i7 | 0) / 2 | 0;
      i6 = i4 + (i22 << 2) | 0;
      i5 = (HEAP32[i6 >> 2] | 0) < (i14 | 0);
      i6 = i6 + 4 | 0;
      i2 = i5 ? i6 : i2;
      i7 = i5 ? i7 + -1 - i22 | 0 : i22;
      if (!i7) break; else i4 = i5 ? i6 : i4;
     }
    }
    if ((i2 | 0) != (i8 | 0)) i1 = (i14 | 0) < (HEAP32[i2 >> 2] | 0) & i1;
    if ((i9 | 0) == 114) {
     i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 3) + 4 >> 2] | 0) | 0;
     i2 = (i2 | 0) != 0 & (i12 | 0) == (i2 | 0);
    } else i2 = (i9 | 0) == (i14 | 0);
    i3 = (i2 & 1) + i3 | 0;
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) < (HEAP32[i13 >> 2] | 0));
  } else {
   i3 = 0;
   i10 = 0;
   i1 = 1;
   do {
    i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 3) >> 2] << 2) >> 2] | 0;
    if (!i2) i9 = -1; else i9 = HEAP32[i2 + 16 >> 2] | 0;
    i8 = __Z34FindRequiredComponentsForComponenti(i9) | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i2 = i8 - i4 >> 2;
    if (!i2) i2 = i4; else {
     i7 = i2;
     i2 = i4;
     i5 = i4;
     while (1) {
      i22 = (i7 | 0) / 2 | 0;
      i4 = i5 + (i22 << 2) | 0;
      i6 = (HEAP32[i4 >> 2] | 0) < (i14 | 0);
      i4 = i4 + 4 | 0;
      i2 = i6 ? i4 : i2;
      i7 = i6 ? i7 + -1 - i22 | 0 : i22;
      if (!i7) break; else i5 = i6 ? i4 : i5;
     }
    }
    if ((i2 | 0) != (i8 | 0)) if ((i14 | 0) >= (HEAP32[i2 >> 2] | 0)) {
     if (!i1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i20, gb + 1086385 | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i20, __ZN6Object15ClassIDToStringEi(i9) | 0) | 0;
     i1 = 0;
    }
    if ((i9 | 0) == 114) {
     i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 3) + 4 >> 2] | 0) | 0;
     i2 = (i2 | 0) != 0 & (i12 | 0) == (i2 | 0);
    } else i2 = (i9 | 0) == (i14 | 0);
    i3 = (i2 & 1) + i3 | 0;
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) < (HEAP32[i13 >> 2] | 0));
  }
  i2 = (i20 | 0) != 0;
  if (i1 | (i3 | 0) > 1) {
   if (i2) break; else i1 = 1;
   STACKTOP = i21;
   return i1 | 0;
  }
  if (!i2) {
   i22 = 0;
   STACKTOP = i21;
   return i22 | 0;
  }
  __Z24GetComponentOrScriptNameRN5Unity9ComponentE(i18, i16);
  if ((HEAP8[i20 + 11 >> 0] | 0) < 0) i1 = HEAP32[i20 >> 2] | 0; else i1 = i20;
  HEAP32[i19 >> 2] = (HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18;
  HEAP32[i19 + 4 >> 2] = i1;
  __Z6FormatPKcz(i17, gb + 446977 | 0, i19);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20, i17) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  i22 = 0;
  STACKTOP = i21;
  return i22 | 0;
 } else if (!i20) {
  i22 = 1;
  STACKTOP = i21;
  return i22 | 0;
 } while (0);
 __Z6FormatPKcz(i17, gb + 1576256 | 0, i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i20, i17) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 i22 = 1;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZN2UI14CanvasRenderer13SyncWorldRectENS0_8SyncFlagEb(i5, i4, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i1 = i9;
 if ((HEAP16[gb + 1468060 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468060 | 0, i7);
  i8 = gb + 1468060 | 0;
 } else i8 = 0;
 if (i4 & 1 | 0) {
  i1 = HEAP32[i5 + 204 >> 2] | 0;
  i2 = HEAP32[i5 + 208 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i6) {
   i1 = i1 + 112 | 0;
   HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 2;
  };
  HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f14 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f17 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i19 = i7 + 12 | 0;
  HEAPF32[i19 >> 2] = f14;
  i12 = i7 + 16 | 0;
  HEAPF32[i12 >> 2] = f17;
  i1 = i7 + 20 | 0;
  HEAPF32[i1 >> 2] = f18;
  __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i3 + (i2 * 672 | 0) + 548 | 0, i3 + (i2 * 672 | 0) + 484 | 0, i7);
  f18 = Math_fround(HEAPF32[i7 >> 2]);
  f17 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i19 >> 2]);
  f13 = Math_fround(HEAPF32[i12 >> 2]);
  f16 = Math_fround(-f14);
  f15 = Math_fround(-f13);
  f11 = Math_fround(-f18);
  f10 = Math_fround(-f17);
  HEAPF32[i3 + (i2 * 672 | 0) + 596 >> 2] = f18;
  HEAPF32[i3 + (i2 * 672 | 0) + 600 >> 2] = f17;
  HEAPF32[i3 + (i2 * 672 | 0) + 604 >> 2] = f16;
  HEAPF32[i3 + (i2 * 672 | 0) + 608 >> 2] = f15;
  HEAPF32[i3 + (i2 * 672 | 0) + 612 >> 2] = f14;
  HEAPF32[i3 + (i2 * 672 | 0) + 616 >> 2] = f13;
  HEAPF32[i3 + (i2 * 672 | 0) + 620 >> 2] = f11;
  HEAPF32[i3 + (i2 * 672 | 0) + 624 >> 2] = f10;
  i12 = i3 + (i2 * 672 | 0) + 572 | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i12 = f10 < Math_fround(0.0);
  f11 = Math_fround(-f10);
  if (!((i12 ? f11 : f10) <= Math_fround(.00100000005))) i1 = 0; else {
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   i1 = f18 < Math_fround(0.0);
   f17 = Math_fround(-f18);
   i1 = (i1 ? f17 : f18) <= Math_fround(.00100000005) & 1;
  }
  HEAP8[i3 + (i2 * 672 | 0) + 669 >> 0] = i1;
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (i4 & 2 | 0) {
  i1 = HEAP32[i5 + 220 >> 2] | 0;
  i2 = HEAP32[i5 + 224 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i6) {
   i19 = i1 + 112 | 0;
   HEAP16[i19 >> 1] = HEAPU16[i19 >> 1] | 2;
  };
  HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f15 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  i12 = i7 + 12 | 0;
  HEAPF32[i12 >> 2] = f15;
  i19 = i7 + 16 | 0;
  HEAPF32[i19 >> 2] = f11;
  i1 = i7 + 20 | 0;
  HEAPF32[i1 >> 2] = f10;
  __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i3 + (i2 * 672 | 0) + 548 | 0, i3 + (i2 * 672 | 0) + 484 | 0, i7);
  f10 = Math_fround(HEAPF32[i7 >> 2]);
  f11 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i12 >> 2]);
  f16 = Math_fround(HEAPF32[i19 >> 2]);
  f13 = Math_fround(-f15);
  f14 = Math_fround(-f16);
  f17 = Math_fround(-f10);
  f18 = Math_fround(-f11);
  HEAPF32[i3 + (i2 * 672 | 0) + 596 >> 2] = f10;
  HEAPF32[i3 + (i2 * 672 | 0) + 600 >> 2] = f11;
  HEAPF32[i3 + (i2 * 672 | 0) + 604 >> 2] = f13;
  HEAPF32[i3 + (i2 * 672 | 0) + 608 >> 2] = f14;
  HEAPF32[i3 + (i2 * 672 | 0) + 612 >> 2] = f15;
  HEAPF32[i3 + (i2 * 672 | 0) + 616 >> 2] = f16;
  HEAPF32[i3 + (i2 * 672 | 0) + 620 >> 2] = f17;
  HEAPF32[i3 + (i2 * 672 | 0) + 624 >> 2] = f18;
  i19 = i3 + (i2 * 672 | 0) + 572 | 0;
  HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  f18 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i19 = f18 < Math_fround(0.0);
  f17 = Math_fround(-f18);
  if (!((i19 ? f17 : f18) <= Math_fround(.00100000005))) i1 = 0; else {
   f18 = Math_fround(HEAPF32[i1 >> 2]);
   i1 = f18 < Math_fround(0.0);
   f17 = Math_fround(-f18);
   i1 = (i1 ? f17 : f18) <= Math_fround(.00100000005) & 1;
  }
  HEAP8[i3 + (i2 * 672 | 0) + 669 >> 0] = i1;
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i9;
 return;
}

function _UNITY_TT_Set_Var_Design(i15, i2, i9) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 8 | 0;
 i11 = i18 + 4 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = 0;
 i17 = HEAP32[i15 + 100 >> 2] | 0;
 i10 = i15 + 676 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if (!i1) {
  i14 = _UNITY_TT_Get_MM_Var(i15, 0) | 0;
  HEAP32[i16 >> 2] = i14;
  if (!i14) {
   i1 = HEAP32[i10 >> 2] | 0;
   break;
  } else {
   i15 = 0;
   _UNITY_ft_mem_free(i17, i15);
   i17 = HEAP32[i16 >> 2] | 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 } while (0);
 i13 = HEAP32[i1 + 8 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i7 = i14 >>> 0 < i2 >>> 0 ? i14 : i2;
 i14 = _UNITY_ft_mem_realloc(i17, 4, 0, i14, 0, i16) | 0;
 if (HEAP32[i16 >> 2] | 0) {
  i15 = i14;
  _UNITY_ft_mem_free(i17, i15);
  i17 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 L10 : do if (!i7) i2 = 0; else {
  i8 = HEAP32[i13 + 12 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i9 + (i2 << 2) >> 2] | 0;
   i4 = HEAP32[i8 + 12 >> 2] | 0;
   if ((i3 | 0) > (i4 | 0)) break;
   i5 = HEAP32[i8 + 4 >> 2] | 0;
   if ((i3 | 0) < (i5 | 0)) break;
   i6 = HEAP32[i8 + 8 >> 2] | 0;
   do if ((i3 | 0) < (i6 | 0)) HEAP32[i14 + (i2 << 2) >> 2] = 0 - (_UNITY_FT_DivFix(i3 - i6 | 0, i5 - i6 | 0) | 0); else if ((i4 | 0) == (i6 | 0)) {
    HEAP32[i14 + (i2 << 2) >> 2] = 0;
    break;
   } else {
    HEAP32[i14 + (i2 << 2) >> 2] = _UNITY_FT_DivFix(i3 - i6 | 0, i4 - i6 | 0) | 0;
    break;
   } while (0);
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 < i7 >>> 0) i8 = i8 + 24 | 0; else break L10;
  }
  HEAP32[i16 >> 2] = 6;
  i15 = i14;
  _UNITY_ft_mem_free(i17, i15);
  i17 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i18;
  return i17 | 0;
 } while (0);
 i3 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i9 = i2 << 2;
  i8 = i2 + 1 | 0;
  _memset(i14 + i9 | 0, 0, ((i3 >>> 0 > i8 >>> 0 ? i3 : i8) << 2) - i9 | 0) | 0;
 }
 if (!(HEAP8[i1 + 16 >> 0] | 0)) {
  i8 = HEAP32[i15 + 104 >> 2] | 0;
  i9 = HEAP32[i8 + 28 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP8[i2 + 16 >> 0] = 1;
  i10 = mftCall_iiiii(HEAP32[i15 + 508 >> 2] | 0, i15 | 0, 1635148146, i8 | 0, i11 | 0) | 0;
  HEAP32[i12 >> 2] = i10;
  if (!i10) {
   i11 = _UNITY_FT_Stream_EnterFrame(i8, HEAP32[i11 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = i11;
   if (!i11) {
    i11 = _UNITY_FT_Stream_GetULong(i8) | 0;
    i6 = _UNITY_FT_Stream_GetULong(i8) | 0;
    L34 : do if ((i11 | 0) == 65536) if ((i6 | 0) == (HEAP32[HEAP32[i2 + 8 >> 2] >> 2] | 0)) {
     i4 = _UNITY_ft_mem_realloc(i9, 8, 0, i6, 0, i12) | 0;
     i7 = i2 + 20 | 0;
     HEAP32[i7 >> 2] = i4;
     if ((i6 | 0) > 0 & (HEAP32[i12 >> 2] | 0) == 0) {
      i3 = 0;
      while (1) {
       i11 = _UNITY_FT_Stream_GetUShort(i8) | 0;
       HEAP16[i4 >> 1] = i11;
       i5 = i4 + 4 | 0;
       HEAP32[i5 >> 2] = _UNITY_ft_mem_realloc(i9, 8, 0, i11 & 65535, 0, i12) | 0;
       if (HEAP32[i12 >> 2] | 0) break;
       if (HEAP16[i4 >> 1] | 0) {
        i2 = 0;
        do {
         i11 = (_UNITY_FT_Stream_GetUShort(i8) | 0) << 16 >> 16 << 2;
         HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 3) >> 2] = i11;
         i11 = (_UNITY_FT_Stream_GetUShort(i8) | 0) << 16 >> 16 << 2;
         HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 3) + 4 >> 2] = i11;
         i2 = i2 + 1 | 0;
        } while ((i2 | 0) < (HEAPU16[i4 >> 1] | 0));
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) < (i6 | 0)) i4 = i4 + 8 | 0; else break L34;
      }
      if ((i3 | 0) > 0) {
       i2 = HEAP32[i7 >> 2] | 0;
       do {
        i12 = i3;
        i3 = i3 + -1 | 0;
        _UNITY_ft_mem_free(i9, HEAP32[i2 + (i3 << 3) + 4 >> 2] | 0);
        i2 = HEAP32[i7 >> 2] | 0;
        HEAP32[i2 + (i3 << 3) + 4 >> 2] = 0;
       } while ((i12 | 0) > 1);
      } else i2 = HEAP32[i7 >> 2] | 0;
      _UNITY_ft_mem_free(i9, i2);
      HEAP32[i7 >> 2] = 0;
     }
    } while (0);
    _UNITY_FT_Stream_ExitFrame(i8);
   }
  }
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i2) if (!i1) i1 = 0; else {
  i10 = 0;
  while (1) {
   i3 = HEAP16[i2 >> 1] | 0;
   L60 : do if ((i3 & 65535) > 1) {
    i6 = i14 + (i10 << 2) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i2 + 4 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    i5 = i3 & 65535;
    i3 = 1;
    while (1) {
     i4 = HEAP32[i9 + (i3 << 3) >> 2] | 0;
     if ((i7 | 0) < (i4 | 0)) break;
     i3 = i3 + 1 | 0;
     if (i3 >>> 0 >= i5 >>> 0) break L60;
    }
    i12 = i3 + -1 | 0;
    i1 = HEAP32[i9 + (i12 << 3) >> 2] | 0;
    i1 = _UNITY_FT_MulDiv(i7 - i1 | 0, (HEAP32[i9 + (i3 << 3) + 4 >> 2] | 0) - (HEAP32[i9 + (i12 << 3) + 4 >> 2] | 0) | 0, i4 - i1 | 0) | 0;
    HEAP32[i6 >> 2] = (HEAP32[(HEAP32[i8 >> 2] | 0) + (i12 << 3) + 4 >> 2] | 0) + i1;
    i1 = HEAP32[i13 >> 2] | 0;
   } while (0);
   i10 = i10 + 1 | 0;
   if (i10 >>> 0 >= i1 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 HEAP32[i16 >> 2] = _UNITY_TT_Set_MM_Blend(i15, i1, i14) | 0;
 i15 = i14;
 _UNITY_ft_mem_free(i17, i15);
 i17 = HEAP32[i16 >> 2] | 0;
 STACKTOP = i18;
 return i17 | 0;
}
function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_(i12, i1, i15, i13) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i16 = 0;
 i9 = i12 + 4 | 0;
 i14 = HEAP32[i1 >> 2] | 0;
 i1 = i14;
 L1 : do if ((i14 | 0) != (i9 | 0)) {
  i2 = i14 + 16 | 0;
  i3 = HEAP8[i13 + 11 >> 0] | 0;
  i11 = i3 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i13 >> 2] | 0 : i13;
  i3 = i11 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
  i11 = i10 + i3 | 0;
  i7 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i7 << 24 >> 24 < 0;
  i2 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i7 = i8 ? HEAP32[i14 + 20 >> 2] | 0 : i7 & 255;
  i8 = i2 + i7 | 0;
  L3 : do if (i7 | 0) {
   i4 = i10;
   i5 = i2;
   while (1) {
    if ((i4 | 0) == (i11 | 0)) break L1;
    i7 = HEAP8[i4 >> 0] | 0;
    i16 = HEAP8[i5 >> 0] | 0;
    i6 = i7 & 255;
    i6 = ((i7 + -65 & 255) < 26 ? i6 + 32 | 0 : i6) & 255;
    i7 = i16 & 255;
    i7 = ((i16 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255;
    if ((i6 & 255) < (i7 & 255)) break L1;
    if ((i7 & 255) < (i6 & 255)) break L3;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i8 | 0)) break; else i4 = i4 + 1 | 0;
   }
  } while (0);
  L10 : do if (i3 | 0) {
   i3 = i10;
   while (1) {
    if ((i2 | 0) == (i8 | 0)) break;
    i5 = HEAP8[i2 >> 0] | 0;
    i16 = HEAP8[i3 >> 0] | 0;
    i4 = i5 & 255;
    i4 = ((i5 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
    i5 = i16 & 255;
    i5 = ((i16 + -65 & 255) < 26 ? i5 + 32 | 0 : i5) & 255;
    if ((i4 & 255) < (i5 & 255)) break;
    if ((i5 & 255) < (i4 & 255)) break L10;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i11 | 0)) break L10; else i2 = i2 + 1 | 0;
   }
   i7 = i14 + 4 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i8 = (i1 | 0) == 0;
   if (i8) {
    i2 = i14;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   L23 : do if ((i1 | 0) != (i9 | 0)) {
    i2 = i1 + 16 | 0;
    i16 = HEAP8[i2 + 11 >> 0] | 0;
    i6 = i16 << 24 >> 24 < 0;
    i2 = i6 ? HEAP32[i2 >> 2] | 0 : i2;
    i16 = i6 ? HEAP32[i1 + 20 >> 2] | 0 : i16 & 255;
    i6 = i2 + i16 | 0;
    L25 : do if (i16 | 0) {
     i5 = i10;
     while (1) {
      if ((i5 | 0) == (i11 | 0)) break L23;
      i4 = HEAP8[i5 >> 0] | 0;
      i16 = HEAP8[i2 >> 0] | 0;
      i3 = i4 & 255;
      i3 = ((i4 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255;
      i4 = i16 & 255;
      i4 = ((i16 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
      if ((i3 & 255) < (i4 & 255)) break L23;
      if ((i4 & 255) < (i3 & 255)) break L25;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i6 | 0)) break; else i5 = i5 + 1 | 0;
     }
    } while (0);
    i16 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i12, i15, i13) | 0;
    return i16 | 0;
   } while (0);
   if (i8) {
    HEAP32[i15 >> 2] = i14;
    i16 = i7;
    return i16 | 0;
   } else {
    HEAP32[i15 >> 2] = i1;
    i16 = i1;
    return i16 | 0;
   }
  } while (0);
  HEAP32[i15 >> 2] = i1;
  i16 = i15;
  return i16 | 0;
 } while (0);
 L42 : do if ((i14 | 0) != (HEAP32[i12 >> 2] | 0)) {
  i1 = HEAP32[i14 >> 2] | 0;
  if (!i1) {
   i1 = i14;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i2; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = i2;
  i3 = i2 + 16 | 0;
  i6 = HEAP8[i3 + 11 >> 0] | 0;
  i16 = i6 << 24 >> 24 < 0;
  i3 = i16 ? HEAP32[i3 >> 2] | 0 : i3;
  i6 = i3 + (i16 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255) | 0;
  i16 = HEAP8[i13 + 11 >> 0] | 0;
  i7 = i16 << 24 >> 24 < 0;
  i2 = i7 ? HEAP32[i13 >> 2] | 0 : i13;
  i16 = i7 ? HEAP32[i13 + 4 >> 2] | 0 : i16 & 255;
  i7 = i2 + i16 | 0;
  L50 : do if (i16 | 0) while (1) {
   if ((i3 | 0) == (i6 | 0)) break L42;
   i5 = HEAP8[i3 >> 0] | 0;
   i16 = HEAP8[i2 >> 0] | 0;
   i4 = i5 & 255;
   i4 = ((i5 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
   i5 = i16 & 255;
   i5 = ((i16 + -65 & 255) < 26 ? i5 + 32 | 0 : i5) & 255;
   if ((i4 & 255) < (i5 & 255)) break L42;
   if ((i5 & 255) < (i4 & 255)) break L50;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + 1 | 0;
  } while (0);
  i16 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i12, i15, i13) | 0;
  return i16 | 0;
 } while (0);
 if (!(HEAP32[i14 >> 2] | 0)) {
  HEAP32[i15 >> 2] = i14;
  i16 = i14;
  return i16 | 0;
 } else {
  i16 = i1;
  HEAP32[i15 >> 2] = i16;
  i16 = i16 + 4 | 0;
  return i16 | 0;
 }
 return 0;
}

function __Z50Camera_CUSTOM_INTERNAL_CALL_CalculateObliqueMatrixP12Il2CppObjectRK8Vector4fR10Matrix4x4f(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 88 | 0;
 i3 = i10 + 80 | 0;
 i4 = i10 + 72 | 0;
 i2 = i10 + 64 | 0;
 i8 = i10;
 if (!i5) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i9) {
  i10 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  i27 = __ZNK6Camera19GetProjectionMatrixEv(i9) | 0;
  i30 = i27;
  i26 = HEAP32[i30 >> 2] | 0;
  i30 = HEAP32[i30 + 4 >> 2] | 0;
  i23 = i1;
  HEAP32[i23 >> 2] = i26;
  HEAP32[i23 + 4 >> 2] = i30;
  i23 = HEAP32[i27 + 8 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i27 + 12 >> 2]);
  i29 = i27 + 16 | 0;
  i25 = HEAP32[i29 >> 2] | 0;
  i29 = HEAP32[i29 + 4 >> 2] | 0;
  i21 = i3;
  HEAP32[i21 >> 2] = i25;
  HEAP32[i21 + 4 >> 2] = i29;
  i21 = HEAP32[i27 + 24 >> 2] | 0;
  f15 = Math_fround(HEAPF32[i27 + 28 >> 2]);
  i28 = i27 + 32 | 0;
  i24 = HEAP32[i28 >> 2] | 0;
  i28 = HEAP32[i28 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = i24;
  HEAP32[i5 + 4 >> 2] = i28;
  i5 = HEAP32[i27 + 40 >> 2] | 0;
  f13 = Math_fround(HEAPF32[i27 + 44 >> 2]);
  i31 = i27 + 48 | 0;
  i32 = HEAP32[i31 >> 2] | 0;
  i31 = HEAP32[i31 + 4 >> 2] | 0;
  i9 = i2;
  HEAP32[i9 >> 2] = i32;
  HEAP32[i9 + 4 >> 2] = i31;
  i9 = HEAP32[i27 + 56 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i27 + 60 >> 2]);
  i27 = i8;
  HEAP32[i27 >> 2] = i26;
  HEAP32[i27 + 4 >> 2] = i30;
  i27 = i8 + 8 | 0;
  HEAP32[i27 >> 2] = i23;
  i23 = i8 + 12 | 0;
  HEAPF32[i23 >> 2] = f17;
  i30 = i8 + 16 | 0;
  i26 = i30;
  HEAP32[i26 >> 2] = i25;
  HEAP32[i26 + 4 >> 2] = i29;
  i26 = i8 + 24 | 0;
  HEAP32[i26 >> 2] = i21;
  i21 = i8 + 28 | 0;
  HEAPF32[i21 >> 2] = f15;
  i29 = i8 + 32 | 0;
  i25 = i29;
  HEAP32[i25 >> 2] = i24;
  HEAP32[i25 + 4 >> 2] = i28;
  i25 = i8 + 40 | 0;
  HEAP32[i25 >> 2] = i5;
  i5 = i8 + 44 | 0;
  HEAPF32[i5 >> 2] = f13;
  i28 = i8 + 48 | 0;
  i24 = i28;
  HEAP32[i24 >> 2] = i32;
  HEAP32[i24 + 4 >> 2] = i31;
  i24 = i8 + 56 | 0;
  HEAP32[i24 >> 2] = i9;
  i9 = i8 + 60 | 0;
  HEAPF32[i9 >> 2] = f11;
  __Z20InvertMatrix4x4_FullPKfPf(i8, i8) | 0;
  f18 = Math_fround(HEAPF32[i6 >> 2]);
  f22 = Math_fround((f18 > Math_fround(0.0) & 1) - (f18 < Math_fround(0.0) & 1) | 0);
  f16 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f12 = Math_fround((f16 > Math_fround(0.0) & 1) - (f16 < Math_fround(0.0) & 1) | 0);
  f14 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f22);
  f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i30 >> 2]) * f12));
  f14 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) + f14);
  f14 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) + f14);
  f19 = Math_fround(f22 * Math_fround(HEAPF32[i8 + 4 >> 2]));
  f19 = Math_fround(f19 + Math_fround(f12 * Math_fround(HEAPF32[i8 + 20 >> 2])));
  f19 = Math_fround(Math_fround(HEAPF32[i8 + 36 >> 2]) + f19);
  f19 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f19);
  f20 = Math_fround(f22 * Math_fround(HEAPF32[i27 >> 2]));
  f20 = Math_fround(f20 + Math_fround(f12 * Math_fround(HEAPF32[i26 >> 2])));
  f20 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f20);
  f20 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f20);
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i23 >> 2]));
  f12 = Math_fround(f22 + Math_fround(f12 * Math_fround(HEAPF32[i21 >> 2])));
  f12 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f12);
  f12 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f12);
  f19 = Math_fround(Math_fround(f18 * f14) + Math_fround(f16 * f19));
  f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f20 = Math_fround(f19 + Math_fround(f20 * f14));
  f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f12 = Math_fround(Math_fround(2.0) / Math_fround(f20 + Math_fround(f19 * f12)));
  f18 = Math_fround(Math_fround(f18 * f12) - f17);
  f16 = Math_fround(Math_fround(f16 * f12) - f15);
  f14 = Math_fround(Math_fround(f14 * f12) - f13);
  f12 = Math_fround(Math_fround(f19 * f12) - f11);
  i9 = i1;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i6 = i7;
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i6 + 4 >> 2] = i8;
  HEAPF32[i7 + 8 >> 2] = f18;
  HEAPF32[i7 + 12 >> 2] = f17;
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i7 + 16 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAPF32[i7 + 24 >> 2] = f16;
  HEAPF32[i7 + 28 >> 2] = f15;
  i9 = i4;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i6 = i7 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i6 + 4 >> 2] = i8;
  HEAPF32[i7 + 40 >> 2] = f14;
  HEAPF32[i7 + 44 >> 2] = f13;
  i6 = i2;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i7 + 48 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAPF32[i7 + 56 >> 2] = f12;
  HEAPF32[i7 + 60 >> 2] = f11;
  STACKTOP = i10;
  return;
 }
}

function __ZN14AnimationEvent8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034360 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 4 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898233 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1041891 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898246 | 0, HEAP32[gb + 37176 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898271 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 35; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898286 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 46; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 46; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 46) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898299 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 57; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 57; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine9Animation27CreateAvatarBindingConstantER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 8 | 0;
 i12 = i18;
 i17 = i18 + 24 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = i13;
 HEAP32[i17 >> 2] = 0;
 i10 = i17 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i13 = i17 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i12);
 i12 = i15;
 i16 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i14;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i16;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = (i9 | 0) == 0 ? 0 : i9 + i5 | 0;
 HEAP32[i15 >> 2] = -1;
 __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i1, i15, i17, i5, 1);
 i16 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, 28, 4) | 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i16 + 12 >> 2] = i1;
 if (!i9) {
  HEAP32[i16 >> 2] = 0;
  i1 = 0;
  i11 = i16;
 } else {
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = i2;
  if (!i2) {
   i1 = 0;
   i11 = i16;
  } else {
   i3 = i2 << 2;
   i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
   if ((i1 | 0) == (i1 + (i2 << 2) | 0)) i11 = i16; else {
    _memset(i1 | 0, 0, i3 | 0) | 0;
    i11 = i16;
   }
  }
 }
 i12 = i16 + 4 | 0;
 HEAP32[i12 >> 2] = i1;
 L10 : do if (!(HEAP32[i11 >> 2] | 0)) {
  i7 = i16 + 24 | 0;
  HEAP32[i7 >> 2] = 0;
 } else {
  i8 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i9, i4) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i7 = i16 + 24 | 0;
  HEAP32[i7 >> 2] = i8;
  if (i1) {
   _memset(HEAP32[i12 >> 2] | 0, 0, i1 << 2 | 0) | 0;
   i8 = HEAP32[i5 + 24 >> 2] | 0;
   if (i8) {
    i6 = i5 + 28 | 0;
    i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    if ((i1 | 0) != -1) {
     i5 = HEAP32[gb + 1466992 >> 2] | 0;
     i3 = i9 + 4 | 0;
     i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
     i2 = i1;
     do {
      HEAP32[i4 + (i2 << 2) >> 2] = i5;
      i2 = HEAP32[i3 + (i2 << 3) >> 2] | 0;
     } while ((i2 | 0) != -1);
    }
    i3 = HEAP32[gb + 1466992 >> 2] | 0;
    i2 = 0;
    while (1) {
     if ((i1 | 0) != -1) HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] = i3;
     i1 = i2 + 1 | 0;
     if (i1 >>> 0 >= i8 >>> 0) break L10;
     i2 = i1;
     i1 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    }
   }
  }
 } while (0);
 i5 = HEAP32[i10 >> 2] | 0;
 if (!i5) i4 = 0; else {
  i6 = HEAP32[gb + 1466992 >> 2] | 0;
  i1 = 0;
  i4 = 0;
  do {
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i2 = (HEAP32[i12 >> 2] | 0) + (i2 << 2) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) {
     HEAP32[i2 >> 2] = HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2];
     i1 = i1 | 3;
    }
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i5 >>> 0);
  i4 = i1;
 }
 i10 = HEAP32[i11 >> 2] | 0;
 if (!i10) HEAP32[i16 + 8 >> 2] = i4; else {
  i3 = HEAP32[gb + 1466992 >> 2] | 0;
  i1 = 0;
  do {
   i2 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) HEAP32[i2 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i10 >>> 0);
  HEAP32[i16 + 8 >> 2] = i4;
  if ((i10 | 0) > 0) {
   i4 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
   i5 = i4;
   i2 = i15 + 4 | 0;
   i3 = i15 + 8 | 0;
   i6 = i15 + 4 | 0;
   i7 = i15 + 8 | 0;
   i8 = i15 + 12 | 0;
   i1 = 0;
   do {
    i9 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if (i9 | 0) {
     i11 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
     __ZNK9Transform16GetLocalPositionEv(i15, i9);
     i19 = HEAP32[i2 >> 2] | 0;
     i20 = HEAP32[i3 >> 2] | 0;
     HEAP32[i11 + (i1 * 40 | 0) >> 2] = HEAP32[i15 >> 2];
     HEAP32[i11 + (i1 * 40 | 0) + 4 >> 2] = i19;
     HEAP32[i11 + (i1 * 40 | 0) + 8 >> 2] = i20;
     i11 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
     __ZNK9Transform16GetLocalRotationEv(i15, i9);
     i20 = HEAP32[i6 >> 2] | 0;
     i19 = HEAP32[i7 >> 2] | 0;
     i9 = HEAP32[i8 >> 2] | 0;
     HEAP32[i11 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i11 + (i1 * 40 | 0) + 16 >> 2] = i20;
     HEAP32[i11 + (i1 * 40 | 0) + 20 >> 2] = i19;
     HEAP32[i11 + (i1 * 40 | 0) + 24 >> 2] = i9;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i10 | 0));
  }
 }
 __ZN11UnityEngine9Animation28RegisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE(i16);
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return i16 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i14);
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i18;
 return i16 | 0;
}

function __ZL35LoadMemoryBufferIntoTextureInternalR9Texture2DPKhj20LoadImageCompressionb(i14, i3, i4, i1, i17) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 8 | 0;
 i2 = i20;
 i19 = i20 + 16 | 0;
 i18 = gb + 64016 | 0;
 i16 = HEAP32[i18 + 4 >> 2] | 0;
 i15 = i2;
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i19 >> 2] = 0;
 i15 = i19 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i19 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i2);
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 i5 = i18;
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 i5 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 183 >> 0] | 0) == 0;
 i5 = i5 ? 0 : i1;
 __ZN9Texture2D18UnshareTextureDataEv(i14);
 i2 = (i5 | 0) != 0;
 do if ((i3 | 0) != 0 & (i4 | 0) != 0) {
  i1 = HEAP8[i3 >> 0] | 0;
  if (i1 << 24 >> 24 == -1) {
   if (__Z24LoadImageIntoTextureImplI11JpegDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE(i14, i3, i4, i2, 3, i19) | 0) {
    i13 = 11;
    break;
   }
   i1 = HEAP8[i3 >> 0] | 0;
  }
  if (i1 << 24 >> 24 == -119) if (__Z24LoadImageIntoTextureImplI10PngDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE(i14, i3, i4, i2, 5, i19) | 0) i13 = 11; else i13 = 7; else i13 = 7;
 } else i13 = 7; while (0);
 do if ((i13 | 0) == 7) {
  if (!(mftCall_iiiiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 188 >> 2] | 0, i14 | 0, 8, 8, 3, 0, 1, -1, 0) | 0)) {
   if ((HEAP32[i16 >> 2] | 0) > -1) {
    i1 = 0;
    i13 = 38;
    break;
   } else i1 = 0;
   STACKTOP = i20;
   return i1 | 0;
  }
  __ZN9Texture2D18UnshareTextureDataEv(i14);
  i1 = HEAP32[i14 + 52 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
  _memcpy(i1 | 0, HEAP32[gb + 43076 >> 2] | 0, 192) | 0;
  i13 = 11;
 } while (0);
 if ((i13 | 0) == 11) {
  i12 = i14 + 52 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i14 + 92 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 5 : i1;
  } else i1 = HEAP32[i1 + 36 >> 2] | 0;
  L23 : do if ((i1 + -10 | 0) >>> 0 < 3) {
   i10 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0) | 0;
   i11 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 140 >> 2] | 0, i14 | 0) | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) {
    i6 = HEAP32[i14 + 92 >> 2] | 0;
    i6 = (i6 | 0) == -1 ? 5 : i6;
   } else i6 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
   __ZN9Texture2D18UnshareTextureDataEv(i14);
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
   i9 = (i6 | 0) == 12;
   i8 = (i5 | 0) == 2;
   __Z17FastCompressImageiiPKhPhbb(i10, i11, i2, i1, i9, i8);
   if (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 112 >> 2] | 0, i14 | 0) | 0) {
    __Z12CreateMipMapPhiii13TextureFormat(HEAP32[i19 >> 2] | 0, i10, i11, 1, 4);
    i7 = __ZNK9Texture2D16CountDataMipmapsEv(i14) | 0;
    if ((i7 | 0) > 1) {
     if ((i10 | 0) != 0 & (i11 | 0) != 0) i5 = 1; else {
      i2 = 1;
      while (1) {
       i3 = HEAP32[i19 >> 2] | 0;
       __ZN9Texture2D18UnshareTextureDataEv(i14);
       i1 = HEAP32[i12 >> 2] | 0;
       if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
       i5 = i10 >> i2;
       i6 = i11 >> i2;
       __Z17FastCompressImageiiPKhPhbb((i5 | 0) < 1 ? 1 : i5, (i6 | 0) < 1 ? 1 : i6, i3, i1, i9, i8);
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i7 | 0)) break L23;
      }
     }
     do {
      i3 = HEAP32[i19 >> 2] | 0;
      i1 = 0;
      i2 = 0;
      do {
       i4 = i10 >> i2;
       i21 = i11 >> i2;
       i1 = (Math_imul((i21 | 0) < 1 ? 1 : i21, __Z29GetRowBytesFromWidthAndFormati13TextureFormat((i4 | 0) < 1 ? 1 : i4, 4) | 0) | 0) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
      i4 = i3 + i1 | 0;
      __ZN9Texture2D18UnshareTextureDataEv(i14);
      i1 = HEAP32[i12 >> 2] | 0;
      if (!i1) i3 = 0; else i3 = HEAP32[i1 + 8 >> 2] | 0;
      i1 = 0;
      i2 = 0;
      do {
       i22 = i10 >> i2;
       i21 = i11 >> i2;
       i1 = (__Z18CalculateImageSizeii13TextureFormat((i22 | 0) < 1 ? 1 : i22, (i21 | 0) < 1 ? 1 : i21, i6) | 0) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
      i21 = i10 >> i5;
      i22 = i11 >> i5;
      __Z17FastCompressImageiiPKhPhbb((i21 | 0) < 1 ? 1 : i21, (i22 | 0) < 1 ? 1 : i22, i4, i3 + i1 | 0, i9, i8);
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != (i7 | 0));
    }
   }
  } while (0);
  if ((HEAP32[i16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
   HEAP32[i19 >> 2] = 0;
  }
  HEAP32[i19 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  if (i17) {
   HEAP8[i14 + 111 >> 0] = 0;
   HEAP8[i14 + 112 >> 0] = 1;
   i1 = 1;
   i13 = 38;
  } else {
   i1 = 1;
   i2 = 0;
  }
 }
 if ((i13 | 0) == 38) i2 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i18);
 HEAP32[i19 >> 2] = 0;
 i22 = i1;
 STACKTOP = i20;
 return i22 | 0;
}

function __ZN21EnlightenSceneMapping5EraseEi(i21, i22, i23) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25;
 i12 = i22 + 60 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i16 + (i23 * 28 | 0) + 20 >> 2] | 0;
 i16 = HEAP32[i16 + (i23 * 28 | 0) + 24 >> 2] | 0;
 i14 = i16 + i15 | 0;
 i10 = i14 + -1 | 0;
 i8 = i22 + 20 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i4 + (i15 * 56 | 0) >> 2] | 0;
 i10 = (HEAP32[i4 + (i10 * 56 | 0) >> 2] | 0) - i7 + (HEAP32[i4 + (i10 * 56 | 0) + 4 >> 2] | 0) | 0;
 i6 = i22 + 92 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i16) i18 = 1; else {
  i3 = 0;
  i2 = 0;
  do {
   i20 = HEAP32[i4 + ((i2 + i15 | 0) * 56 | 0) + 8 >> 2] | 0;
   i1 = (i1 | 0) < (i20 | 0) ? i1 : i20;
   i3 = (i3 | 0) > (i20 | 0) ? i3 : i20;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i16 | 0));
  i18 = i3 + 1 | 0;
 }
 i19 = i18 - i1 | 0;
 i9 = HEAP32[i22 >> 2] | 0;
 i3 = i9 + (i7 * 40 | 0) | 0;
 i4 = i3 + (i10 * 40 | 0) | 0;
 i13 = i22 + 12 | 0;
 _memmove(i3 | 0, i4 | 0, i9 + ((HEAP32[i13 >> 2] | 0) * 40 | 0) - i4 | 0) | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) - ((i10 * 40 | 0) / 40 | 0);
 i4 = HEAP32[i8 >> 2] | 0;
 i9 = i4 + (i15 * 56 | 0) | 0;
 i3 = i9 + (i16 * 56 | 0) | 0;
 i5 = i22 + 32 | 0;
 _memmove(i9 | 0, i3 | 0, i4 + ((HEAP32[i5 >> 2] | 0) * 56 | 0) - i3 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - ((i16 * 56 | 0) / 56 | 0);
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + (i23 * 28 | 0) | 0;
 i9 = i4 + 28 | 0;
 i20 = i22 + 72 | 0;
 _memmove(i4 | 0, i9 | 0, i3 + ((HEAP32[i20 >> 2] | 0) * 28 | 0) - i9 | 0) | 0;
 HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
 i9 = i22 + 80 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + (i1 << 5) | 0;
 i11 = i4 + (i19 << 5) | 0;
 _memmove(i4 | 0, i11 | 0, i3 + (HEAP32[i6 >> 2] << 5) - i11 | 0) | 0;
 i11 = (HEAP32[i6 >> 2] | 0) - (i19 << 5 >> 5) | 0;
 HEAP32[i6 >> 2] = i11;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i7 | 0) != (i3 | 0)) {
  i4 = HEAP32[i22 >> 2] | 0;
  i2 = i7;
  do {
   i7 = i4 + (i2 * 40 | 0) + 20 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i16;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i4 = HEAP32[i5 >> 2] | 0;
 if ((i15 | 0) != (i4 | 0)) {
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i15;
  do {
   i8 = i3 + (i2 * 56 | 0) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i10;
   i8 = i3 + (i2 * 56 | 0) + 8 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i19;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i20 >> 2] | 0;
 if ((i4 | 0) != (i23 | 0)) {
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = i23;
  do {
   i12 = i3 + (i2 * 28 | 0) + 20 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) - i16;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 if ((i1 | 0) != (i11 | 0)) {
  i2 = HEAP32[i9 >> 2] | 0;
  do {
   i12 = i2 + (i1 << 5) + 24 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) - i16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 }
 i6 = i22 + 112 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 L26 : do if (i1 | 0) {
  i7 = i22 + 100 | 0;
  i5 = 0;
  do {
   while (1) {
    i2 = HEAP32[i7 >> 2] | 0;
    i3 = i2 + (i5 * 12 | 0) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 >>> 0 < i15 >>> 0) break;
    if (i4 >>> 0 >= i14 >>> 0) {
     i17 = 33;
     break;
    }
    i12 = i3 + 12 | 0;
    _memmove(i3 | 0, i12 | 0, i2 + (i1 * 12 | 0) - i12 | 0) | 0;
    i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
    HEAP32[i6 >> 2] = i1;
    if ((i5 | 0) == (i1 | 0)) break L26;
   }
   if ((i17 | 0) == 33) {
    i17 = 0;
    HEAP32[i3 >> 2] = i4 - i16;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i1 | 0));
 } while (0);
 i6 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i22 + 124 >> 2] | 0;
 i7 = i22 + 128 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i1 = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 L41 : do if (i6 | 0) {
  i3 = i24 + 4 | 0;
  i4 = i22 + 132 | 0;
  i5 = i22 + 124 | 0;
  i2 = 0;
  while (1) {
   HEAP32[i24 >> 2] = HEAP32[(HEAP32[i22 >> 2] | 0) + (i2 * 40 | 0) >> 2];
   HEAP32[i3 >> 2] = i2;
   if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i24); else {
    i15 = i24;
    i16 = HEAP32[i15 + 4 >> 2] | 0;
    i17 = i1;
    HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i17 + 4 >> 2] = i16;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 8;
   }
   i1 = i2 + 1 | 0;
   if ((i1 | 0) == (i6 | 0)) break L41;
   i2 = i1;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 } while (0);
 __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i22 + 120 | 0);
 if ((HEAP32[i20 >> 2] | 0) == (i23 | 0)) {
  HEAP32[i21 >> 2] = -1;
  i23 = 0;
  i24 = i21 + 4 | 0;
  HEAP32[i24 >> 2] = i23;
  STACKTOP = i25;
  return;
 } else {
  HEAP32[i21 >> 2] = i18;
  i23 = 0 - i19 | 0;
  i24 = i21 + 4 | 0;
  HEAP32[i24 >> 2] = i23;
  STACKTOP = i25;
  return;
 }
}

function __Z19MoveFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 1084 | 0;
 i14 = i18 + 1072 | 0;
 i15 = i18 + 12 | 0;
 i16 = i18;
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i13, i12);
 __Z39DeleteLastPathNameComponentWithAnySlashRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i13);
 i10 = HEAP8[i14 + 11 >> 0] | 0;
 i1 = i10 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i14 + 4 >> 2] | 0 : i10 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 } else {
  __ZN15FileSystemEntryC2EPKc(i15, i1 ? HEAP32[i14 >> 2] | 0 : i14);
  i10 = __ZNK15FileSystemEntry12FolderExistsEv(i15) | 0;
  __ZN13FileEntryDataD2Ev(i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  if (!i10) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i11);
 i7 = i13 + 11 | 0;
 i9 = HEAP8[i7 >> 0] | 0;
 i1 = i9 << 24 >> 24 < 0;
 i10 = i13 + 4 | 0;
 if ((i1 ? HEAP32[i10 >> 2] | 0 : i9 & 255) | 0) {
  i1 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
  do {
   i8 = HEAP8[i1 >> 0] | 0;
   i9 = i8 << 24 >> 24;
   HEAP8[i1 >> 0] = (i8 + -65 & 255) < 26 ? i9 + 32 | 0 : i9;
   i1 = i1 + 1 | 0;
   i9 = HEAP8[i7 >> 0] | 0;
   i8 = i9 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i8 ? HEAP32[i13 >> 2] | 0 : i13) + (i8 ? HEAP32[i10 >> 2] | 0 : i9 & 255) | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i12);
 i5 = i14 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i6 = i14 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!((i2 ? i3 : i1 & 255) | 0)) i8 = i4; else {
  i2 = i2 ? i4 : i14;
  do {
   i9 = HEAP8[i2 >> 0] | 0;
   i1 = i9 << 24 >> 24;
   HEAP8[i2 >> 0] = (i9 + -65 & 255) < 26 ? i1 + 32 | 0 : i1;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
   i9 = i1 << 24 >> 24 < 0;
   i4 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != ((i9 ? i4 : i14) + (i9 ? i3 : i1 & 255) | 0));
  i8 = i4;
 }
 i2 = HEAP8[i7 >> 0] | 0;
 i9 = i2 << 24 >> 24 < 0;
 i2 = i2 & 255;
 i7 = i9 ? HEAP32[i10 >> 2] | 0 : i2;
 i4 = i1 << 24 >> 24 < 0;
 L16 : do if ((i7 | 0) == ((i4 ? i3 : i1 & 255) | 0)) {
  i5 = HEAP32[i13 >> 2] | 0;
  i6 = i9 ? i5 : i13;
  i1 = i4 ? i8 : i14;
  i3 = (i7 | 0) == 0;
  if (i9) if (i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   break;
  } else {
   i10 = (_memcmp(i6, i1, i7) | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   if (i10) break; else {
    i17 = 20;
    break;
   }
  }
  if (i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   break;
  }
  L27 : do if ((i5 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
   i3 = i13;
   while (1) {
    i2 = i2 + -1 | 0;
    i3 = i3 + 1 | 0;
    if (!i2) break;
    i1 = i1 + 1 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) break L27;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   break L16;
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i17 = 20;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i17 = 20;
 } while (0);
 if ((i17 | 0) == 20) if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i12) | 0) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i12);
 __ZN15FileSystemEntryC2EPKc(i13, (HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i16, i11);
 __ZN15FileSystemEntryC2EPKc(i15, (HEAP8[i16 + 11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 i17 = __ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags(i15, i13, 2) | 0;
 __ZN13FileEntryDataD2Ev(i15);
 __ZN13FileEntryDataD2Ev(i13);
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN17ArchiveFileSystem12MountArchiveEPKcS1_(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 40 | 0;
 i13 = i16;
 i9 = i16 + 24 | 0;
 if ((HEAP16[gb + 1178992 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178992 | 0, i11);
  i15 = gb + 1178992 | 0;
 } else i15 = 0;
 i14 = __ZnwjRK10MemLabelIdiPKci(2416, gb + 63552 | 0, 16, gb + 489554 | 0, 52) | 0;
 __ZN20ArchiveStorageReaderC2Ev(i14);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i8, _strlen(i8) | 0);
 __ZN15FileSystemEntryC2EPKc(i11, (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13);
 i7 = __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy(i14, i11, 0, 0) | 0;
 __ZN13FileEntryDataD2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if (!i7) {
  i5 = i14 + 2344 | 0;
  i6 = i1 | 0 ? i1 : gb + 1576256 | 0;
  i7 = _strlen(i6) | 0;
  i3 = i14 + 2355 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i14 + 2352 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i14 + 2348 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
  } else {
   if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i14 + 2348 >> 2] = i7;
    break;
   } else {
    HEAP8[i3 >> 0] = i7;
    break;
   }
  } while (0);
  i3 = i14;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 + 12 >> 2] = i1;
  i4 = _strlen(i8) | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
   i1 = HEAP32[i13 + 12 >> 2] | 0;
   i10 = 23;
  } else if (i4 >>> 0 < 11) {
   i2 = i13 + 11 | 0;
   HEAP8[i2 >> 0] = i4;
   if (!i4) i1 = i13; else {
    i1 = i13;
    i10 = 25;
   }
  } else i10 = 23;
  if ((i10 | 0) == 23) {
   i2 = i4 + 16 & -16;
   HEAP32[i11 >> 2] = 54;
   HEAP32[i11 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i13 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i13 + 4 >> 2] = i4;
   i2 = i13 + 11 | 0;
   i10 = 25;
  }
  if ((i10 | 0) == 25) _memcpy(i1 | 0, i8 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i13 + 16 >> 2] = i3;
  i1 = i12 + 40 | 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12resize_deltaEjj(i1, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E15insert_noresizeERKSC_(i9, i1, i13);
  i1 = (HEAP8[i9 + 12 >> 0] | 0) == 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   i10 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 54;
   HEAP32[i11 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
  }
  if (i1) {
   i13 = i14 + 4 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   if (!(HEAP32[i13 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 63552 | 0);
    i1 = 0;
   } else i1 = 0;
  } else {
   __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader(i12, i14);
   i12 = i14 + 2336 | 0;
   i13 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
   HEAP32[i12 >> 2] = i13;
   if (!i13) {
    __ZN12FileAccessor5CloseEv(i14 + 1248 | 0) | 0;
    i2 = i14 + 2376 | 0;
    if (HEAP32[i2 >> 2] | 0) {
     i3 = i14 + 2364 | 0;
     i1 = 0;
     do {
      __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i14, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
    }
    HEAP32[i2 >> 2] = 0;
   }
   i1 = 1;
  }
 } else {
  i13 = i14 + 4 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  if (!(HEAP32[i13 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 63552 | 0);
   i1 = 0;
  } else i1 = 0;
 }
 if (!i15) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb(i2, i8, i7, i4, i5, i1) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if (i1) {
  i1 = i2 * 3 | 0;
  i2 = HEAPU16[i4 + (i1 << 1) >> 1] | 0;
  i3 = HEAPU16[i4 + (i1 + 1 << 1) >> 1] | 0;
  i1 = HEAPU16[i4 + (i1 + 2 << 1) >> 1] | 0;
 } else {
  i1 = i2 * 3 | 0;
  i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  i3 = HEAP32[i4 + (i1 + 1 << 2) >> 2] | 0;
  i1 = HEAP32[i4 + (i1 + 2 << 2) >> 2] | 0;
 }
 i23 = HEAP32[i7 + (i2 * 12 | 0) >> 2] | 0;
 HEAP32[i6 >> 2] = i23;
 i20 = HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = i20;
 i16 = HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = i16;
 i26 = HEAP32[i7 + (i3 * 12 | 0) >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = i26;
 i25 = HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i25;
 i24 = HEAP32[i7 + (i3 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i6 + 20 >> 2] = i24;
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
 i21 = i6 + 28 | 0;
 HEAP32[i21 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
 i17 = i6 + 32 | 0;
 HEAP32[i17 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2];
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i5 >> 2]));
 i23 = i5 + 4 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i5 + 8 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i20 = i5 + 12 | 0;
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i5 + 16 | 0;
 f14 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
 i18 = i5 + 20 | 0;
 f15 = Math_fround(f11 + f15);
 f14 = Math_fround(f12 + f14);
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i16 = i5 + 24 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 i1 = i5 + 28 | 0;
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i1 >> 2]));
 i2 = i5 + 32 | 0;
 f12 = Math_fround(f15 + f12);
 f11 = Math_fround(f14 + f11);
 f10 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2])));
 i3 = i5 + 36 | 0;
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
 i4 = i5 + 40 | 0;
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
 i7 = i5 + 44 | 0;
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i8 >> 2] = f12;
 HEAPF32[i8 + 4 >> 2] = f11;
 HEAPF32[i8 + 8 >> 2] = f10;
 f10 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i5 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(f11 + f14);
 f15 = Math_fround(f12 + f15);
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i1 >> 2]));
 f12 = Math_fround(f14 + f12);
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2])));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i8 + 12 >> 2] = f12;
 HEAPF32[i8 + 16 >> 2] = f11;
 HEAPF32[i8 + 20 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i5 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f13 = Math_fround(HEAPF32[i21 >> 2]);
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
 f15 = Math_fround(f11 + f15);
 f14 = Math_fround(f12 + f14);
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = Math_fround(HEAPF32[i17 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i1 >> 2]));
 f12 = Math_fround(f15 + f12);
 f11 = Math_fround(f14 + f11);
 f10 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2])));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i8 + 24 >> 2] = f12;
 HEAPF32[i8 + 28 >> 2] = f11;
 HEAPF32[i8 + 32 >> 2] = f10;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j(i17, i3, i1, i2, i4) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i2 = i4 << 2;
 i15 = i2 >>> 0 > 1024;
 i16 = i18 + 4 | 0;
 HEAP8[i16 >> 0] = i15 & 1;
 if (i15) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i19 + 8 | 0, i2, gb + 838140 | 0, 51) | 0;
  HEAP32[i18 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i18 >> 2] = i1;
 }
 i3 = i3 + -1 | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  i15 = i4;
  i5 = 0;
  i4 = 0;
  L7 : while (1) {
   i8 = i5;
   while (1) {
    if ((i3 | 0) > (i4 | 0)) {
     if ((i3 - i4 | 0) >>> 0 >= 5) break;
     do {
      i7 = i4;
      i4 = i4 + 1 | 0;
      i6 = i4;
      i5 = i7;
      while (1) {
       i5 = (HEAP32[i17 + (i6 << 2) >> 2] | 0) >>> 0 < (HEAP32[i17 + (i5 << 2) >> 2] | 0) >>> 0 ? i6 : i5;
       if ((i6 | 0) < (i3 | 0)) i6 = i6 + 1 | 0; else break;
      }
      if ((i5 | 0) != (i7 | 0)) {
       i12 = i17 + (i5 << 2) | 0;
       i14 = i17 + (i7 << 2) | 0;
       i13 = HEAP32[i12 >> 2] | 0;
       HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i14 >> 2] = i13;
      }
     } while ((i4 | 0) != (i3 | 0));
    }
    if (!i8) break L7;
    i14 = i8 + -2 | 0;
    i3 = HEAP32[i1 + (i8 + -1 << 2) >> 2] | 0;
    i4 = HEAP32[i1 + (i14 << 2) >> 2] | 0;
    i8 = i14;
   }
   i11 = i17 + (((i3 + i4 | 0) / 2 | 0) << 2) | 0;
   i9 = i17 + (i4 << 2) | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   if (i5 >>> 0 < i6 >>> 0) {
    HEAP32[i9 >> 2] = i5;
    HEAP32[i11 >> 2] = i6;
    i5 = i6;
    i6 = HEAP32[i9 >> 2] | 0;
   }
   i10 = i17 + (i3 << 2) | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   if (i7 >>> 0 < i6 >>> 0) {
    HEAP32[i9 >> 2] = i7;
    HEAP32[i10 >> 2] = i6;
    i5 = HEAP32[i11 >> 2] | 0;
   } else i6 = i7;
   if (i6 >>> 0 < i5 >>> 0) {
    HEAP32[i11 >> 2] = i6;
    HEAP32[i10 >> 2] = i5;
    i5 = HEAP32[i11 >> 2] | 0;
   }
   i7 = i3 + -1 | 0;
   i14 = i17 + (i7 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i5;
   i6 = i4;
   while (1) {
    i11 = i6;
    while (1) {
     i6 = i11 + 1 | 0;
     i9 = i17 + (i6 << 2) | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     if (i10 >>> 0 < i5 >>> 0) i11 = i6; else {
      i12 = i10;
      i13 = i11;
      break;
     }
    }
    do {
     i7 = i7 + -1 | 0;
     i11 = i17 + (i7 << 2) | 0;
     i10 = HEAP32[i11 >> 2] | 0;
    } while (i5 >>> 0 < i10 >>> 0);
    if ((i6 | 0) >= (i7 | 0)) {
     i7 = i12;
     break;
    }
    HEAP32[i9 >> 2] = i10;
    HEAP32[i11 >> 2] = i12;
    i5 = HEAP32[i14 >> 2] | 0;
   }
   HEAP32[i9 >> 2] = i5;
   HEAP32[i14 >> 2] = i7;
   if ((i6 - i4 | 0) < (i3 - i6 | 0)) {
    if (i8 >>> 0 < (i15 + -1 | 0) >>> 0) i5 = i15; else {
     i5 = i15 << 3;
     if (!i5) i6 = 0; else {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i12 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
      i6 = _PxGetFoundation() | 0;
      i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
      i6 = mftCall_iiiiii(i12 | 0, i14 | 0, i5 | 0, (i6 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i6 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
     }
     i2 = 1;
     i5 = i15 << 1;
     i1 = i6;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i4;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i13;
    i4 = i13 + 2 | 0;
   } else {
    i6 = i13 + 2 | 0;
    if (i8 >>> 0 < (i15 + -1 | 0) >>> 0) i5 = i15; else {
     i5 = i15 << 3;
     if (!i5) i5 = 0; else {
      i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
      i14 = _PxGetFoundation() | 0;
      i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
      i5 = mftCall_iiiiii(i11 | 0, i12 | 0, i5 | 0, (i14 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838381 | 0, 137) | 0;
     }
     _memcpy(i5 | 0, i1 | 0, i8 << 2 | 0) | 0;
     if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
      i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
     }
     i1 = i5;
     i2 = 1;
     i5 = i15 << 1;
    }
    HEAP32[i1 + (i8 << 2) >> 2] = i6;
    HEAP32[i1 + (i8 + 1 << 2) >> 2] = i3;
    i3 = i13;
   }
   i15 = i5;
   i5 = i8 + 2 | 0;
  }
  if (!(i2 << 24 >> 24 == 0 | (i1 | 0) == 0)) {
   i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
  }
 }
 if (!(HEAP8[i16 >> 0] | 0)) {
  STACKTOP = i19;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i18, HEAP32[i18 >> 2] | 0);
 STACKTOP = i19;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i21, i20, i16, i22) {
 i21 = i21 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 i22 = i22 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0;
 i15 = HEAP32[i20 + 400 >> 2] | 0;
 L1 : do if (!i15) i1 = 0; else {
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  i1 = 0;
  do {
   f13 = Math_fround(HEAPF32[i20 + 272 + (i1 << 2) >> 2]);
   if (!(f3 > f13 & (f2 > f13 & (f4 > f13 & f5 > f13)))) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i15 >>> 0);
 } while (0);
 L7 : do if (i1 >>> 0 < i15 >>> 0) {
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f4 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  i9 = 0;
  i6 = -1;
  i10 = 0;
  i11 = -1;
  i7 = 0;
  i12 = -1;
  i8 = 0;
  i14 = -1;
  while (1) {
   if ((i8 & i10 & i7 & i9 | 0) <= -1) {
    i19 = i6;
    break L7;
   }
   f2 = Math_fround(HEAPF32[i20 + 272 + (i1 << 2) >> 2]);
   i19 = HEAP32[i20 + 208 + (i1 << 2) >> 2] | 0;
   i6 = i19 & ~i9 | i9 & i6;
   i7 = i19 & ~i7 | i7 & i11;
   i8 = i19 & ~i8 | i8 & i12;
   i14 = i19 & ~i10 | i10 & i14;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) {
    i19 = i6;
    i11 = i7;
    i12 = i8;
    break;
   } else {
    i9 = (f3 < f2) << 31 >> 31;
    i10 = (f13 < f2) << 31 >> 31;
    i11 = i7;
    i7 = (f4 < f2) << 31 >> 31;
    i12 = i8;
    i8 = (f5 < f2) << 31 >> 31;
   }
  }
 } else {
  i19 = -1;
  i11 = -1;
  i12 = -1;
  i14 = -1;
 } while (0);
 i18 = HEAP32[i20 + 192 >> 2] | 0;
 L13 : do if (!i18) i1 = 0; else {
  f2 = Math_fround(HEAPF32[i16 >> 2]);
  f3 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  i1 = 0;
  do {
   f13 = Math_fround(HEAPF32[i20 + 64 + (i1 << 2) >> 2]);
   if (!(f5 > f13 & (f4 > f13 & (f2 > f13 & f3 > f13)))) break L13;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i18 >>> 0);
 } while (0);
 L19 : do if (i1 >>> 0 < i18 >>> 0) {
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
  i15 = i1;
  i16 = 0;
  i8 = -1;
  i17 = 0;
  i7 = -1;
  i10 = 0;
  i6 = -1;
  i1 = -1;
  i9 = 0;
  while (1) {
   if ((i9 & i17 & i10 & i16 | 0) <= -1) break L19;
   f2 = Math_fround(HEAPF32[i20 + 64 + (i15 << 2) >> 2]);
   i23 = HEAP32[i20 + (i15 << 2) >> 2] | 0;
   i8 = i23 & ~i16 | i16 & i8;
   i7 = i23 & ~i10 | i10 & i7;
   i6 = i23 & ~i9 | i9 & i6;
   i1 = i23 & ~i17 | i17 & i1;
   i15 = i15 + 1 | 0;
   if (i15 >>> 0 >= i18 >>> 0) break; else {
    i16 = (f4 < f2) << 31 >> 31;
    i17 = (f3 < f2) << 31 >> 31;
    i10 = (f5 < f2) << 31 >> 31;
    i9 = (f13 < f2) << 31 >> 31;
   }
  }
 } else {
  i8 = -1;
  i7 = -1;
  i6 = -1;
  i1 = -1;
 } while (0);
 f4 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * Math_fround(255.0));
 f5 = Math_fround(Math_fround(HEAPF32[i22 + 4 >> 2]) * Math_fround(255.0));
 f13 = Math_fround(Math_fround(HEAPF32[i22 + 8 >> 2]) * Math_fround(255.0));
 i10 = i19 & 255;
 i17 = ~~f4 & 255;
 i15 = i19 >>> 8 & 255;
 i16 = i19 >>> 16 & 255;
 i18 = i19 >>> 24;
 i24 = i11 & 255;
 i9 = ~~f5 & 255;
 i20 = i11 >>> 8 & 255;
 i23 = i11 >>> 16 & 255;
 i19 = i11 >>> 24;
 i19 = ((Math_imul(i9, (i7 & 255) - i24 | 0) | 0) + 128 >> 8) + i24 | (Math_imul(i9, (i7 >>> 8 & 255) - i20 | 0) | 0) + (i20 << 8 | 128) & -256 | (((Math_imul(i9, (i7 >>> 16 & 255) - i23 | 0) | 0) + 128 | 0) >>> 8) + i23 << 16 | (((Math_imul(i9, (i7 >>> 24) - i19 | 0) | 0) + 128 | 0) >>> 8) + i19 << 24;
 i7 = i12 & 255;
 i9 = ~~f13 & 255;
 i23 = i12 >>> 8 & 255;
 i11 = i12 >>> 16 & 255;
 i20 = i12 >>> 24;
 i20 = ((Math_imul(i9, (i6 & 255) - i7 | 0) | 0) + 128 >> 8) + i7 | (Math_imul(i9, (i6 >>> 8 & 255) - i23 | 0) | 0) + (i23 << 8 | 128) & -256 | (((Math_imul(i9, (i6 >>> 16 & 255) - i11 | 0) | 0) + 128 | 0) >>> 8) + i11 << 16 | (((Math_imul(i9, (i6 >>> 24) - i20 | 0) | 0) + 128 | 0) >>> 8) + i20 << 24;
 i9 = i14 & 255;
 i22 = ~~Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(255.0)) & 255;
 i11 = i14 >>> 8 & 255;
 i12 = i14 >>> 16 & 255;
 i23 = i14 >>> 24;
 i23 = ((Math_imul(i22, (i1 & 255) - i9 | 0) | 0) + 128 >> 8) + i9 | (Math_imul(i22, (i1 >>> 8 & 255) - i11 | 0) | 0) + (i11 << 8 | 128) & -256 | (((Math_imul(i22, (i1 >>> 16 & 255) - i12 | 0) | 0) + 128 | 0) >>> 8) + i12 << 16 | (((Math_imul(i22, (i1 >>> 24) - i23 | 0) | 0) + 128 | 0) >>> 8) + i23 << 24;
 HEAP32[i21 >> 2] = ((Math_imul(i17, (i8 & 255) - i10 | 0) | 0) + 128 >> 8) + i10 | (Math_imul(i17, (i8 >>> 8 & 255) - i15 | 0) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul(i17, (i8 >>> 16 & 255) - i16 | 0) | 0) + 128 | 0) >>> 8) + i16 << 16 | (((Math_imul(i17, (i8 >>> 24) - i18 | 0) | 0) + 128 | 0) >>> 8) + i18 << 24;
 HEAP32[i21 + 4 >> 2] = i19;
 HEAP32[i21 + 8 >> 2] = i20;
 HEAP32[i21 + 12 >> 2] = i23;
 return;
}

function __ZN5Umbra17ImpTomeCollection11deserializeERNS_11InputStreamEPPKNS_7ImpTomeEiPNS_9AllocatorE(i15, i17, i18, i13, i1) {
 i15 = i15 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 32 | 0;
 i5 = i21;
 i19 = i15 + 28 | 0;
 i20 = i15 + 24 | 0;
 if (!(HEAP8[i20 >> 0] | 0)) {
  i1 = i15 + 32 | 0;
  i2 = i19;
 } else {
  i2 = HEAP32[i19 >> 2] | 0;
  i1 = i15 + 32 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) i2 = i19; else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   i2 = i19;
  }
 }
 i12 = i15 + 44 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i9 = i15 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i15 + 40 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i20 >> 0] = 0;
 i11 = i5 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 if ((mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i5 | 0, 32) | 0) != 32) {
  i20 = 6;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = i6 & 65535;
 if ((i6 & -65536 | 0) != -419430400) {
  i20 = (i1 | 0) == 231 ? 11 : 9;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!i1) {
  i20 = 7;
  STACKTOP = i21;
  return i20 | 0;
 }
 if ((i1 | 0) != 1) {
  i20 = 8;
  STACKTOP = i21;
  return i20 | 0;
 }
 i6 = i5 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 if (!((i3 | 0) == (i13 | 0) | (i13 | 0) == 1 & i4)) {
  i20 = 12;
  STACKTOP = i21;
  return i20 | 0;
 }
 L22 : do if ((i13 | 0) > 0) {
  i3 = 0;
  L23 : while (1) {
   i1 = HEAP32[i18 + (i3 << 2) >> 2] | 0;
   if (!i1) {
    i1 = 12;
    break;
   }
   i22 = HEAP32[i1 >> 2] | 0;
   i2 = i22 & 65535;
   if ((i22 & -65536 | 0) == -704643072) if ((i2 | 0) == 18) i1 = (i1 & 15 | 0) == 0 ? 0 : 6; else i1 = i2 >>> 0 > 18 ? 4 : 3; else i1 = (i2 | 0) == 214 ? 5 : 2;
   switch (i1 & 7) {
   case 2:
    {
     i1 = 4;
     break L23;
    }
   case 0:
    break;
   default:
    {
     i1 = 12;
     i14 = 46;
     break L23;
    }
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i13 | 0)) break L22;
  }
  if ((i14 | 0) == 46) {
   STACKTOP = i21;
   return i1 | 0;
  }
  i22 = i1;
  STACKTOP = i21;
  return i22 | 0;
 } while (0);
 if (i4) {
  HEAP32[i15 + 32 >> 2] = HEAP32[i18 >> 2];
  HEAP8[i20 >> 0] = 0;
  i22 = 0;
  STACKTOP = i21;
  return i22 | 0;
 }
 HEAP8[i20 >> 0] = 1;
 HEAP32[i15 + 28 >> 2] = i15;
 i2 = i5 + 8 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, (HEAP32[i2 >> 2] | 0) + 20 | 0, 0) | 0;
 if (!i1) i1 = 0; else {
  i22 = i1 + 4 + 15 & -16;
  HEAP32[i22 + -4 >> 2] = i22 - i1;
  i1 = i22;
 }
 i5 = i15 + 32 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 if (!i1) {
  HEAP8[i20 >> 0] = 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  HEAP32[i19 + 16 >> 2] = 0;
  i22 = 1;
  STACKTOP = i21;
  return i22 | 0;
 }
 if ((HEAP32[i11 >> 2] | 0) >>> 0 > 32) {
  i1 = 32;
  do {
   mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i16 | 0, 4) | 0;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (!(mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0)) {
  if (HEAP8[i20 >> 0] | 0) {
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
  }
  HEAP8[i20 >> 0] = 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  HEAP32[i19 + 16 >> 2] = 0;
  i22 = 6;
  STACKTOP = i21;
  return i22 | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 L62 : do if ((mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i16 | 0, 12) | 0) == 12) {
  i2 = i16 + 8 | 0;
  i3 = i16 + 4 | 0;
  L64 : while (1) {
   i4 = HEAP32[i16 >> 2] | 0;
   switch (i4 | 0) {
   case -2:
    break L64;
   case -1:
    {
     HEAP32[i1 + (HEAP32[i2 >> 2] | 0) >> 2] = i1 + (HEAP32[i3 >> 2] | 0);
     break;
    }
   default:
    HEAP32[i1 + (HEAP32[i2 >> 2] | 0) >> 2] = (HEAP32[i18 + (i4 << 2) >> 2] | 0) + (HEAP32[i3 >> 2] | 0);
   }
   if ((mftCall_iiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i16 | 0, 12) | 0) != 12) break L62;
  }
  i22 = 0;
  STACKTOP = i21;
  return i22 | 0;
 } while (0);
 if (HEAP8[i20 >> 0] | 0) {
  i2 = HEAP32[i19 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 }
 HEAP8[i20 >> 0] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 i22 = 6;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZN22ParticleSystemRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 340 | 0;
 i8 = i6 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 2);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 342 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 2);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 344 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 348 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 352 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 356 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 360 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 364 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 376 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 380 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 384 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 388 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 392 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  i9 = i5 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN22UnityProfilerPerThreadC2EPKcS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 8 | 0;
 i10 = i8;
 HEAP8[i3 >> 0] = 0;
 i6 = gb + 63576 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i5 = i11;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i7 = i11;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i7;
 i4 = i3 + 36 | 0;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = 0;
 i5 = i3 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i3 + 52 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i3 + 40 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i9 = i11;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i7;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 63576 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i9 = i11;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i3 + 60 | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 63576 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i3 + 76 >> 2] = 0;
 HEAP32[i3 + 88 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i9 = i11;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i3 + 80 | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 63576 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 108 >> 2] = 0;
 HEAP32[i3 + 112 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i9 = i11;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i3 + 100 | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 63576 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 128 >> 2] = 0;
 HEAP32[i3 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i9 = i11;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i3 + 120 | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = gb + 63576 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i3 + 136 >> 2] = 0;
 HEAP32[i3 + 148 >> 2] = 0;
 HEAP32[i3 + 152 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i3 + 140 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP8[i3 + 156 >> 0] = 0;
 HEAP8[i3 + 157 >> 0] = 0;
 i9 = i3 + 160 | 0;
 i10 = gb + 63576 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i9;
 HEAP32[i3 + 164 >> 2] = i9;
 HEAP32[i3 + 168 >> 2] = 0;
 HEAP32[i3 + 172 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 176 >> 2] = 131072;
 i9 = i3 + 180 | 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i3 + 192 >> 2] = 0;
 HEAP32[i3 + 196 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 200 >> 2] = 0;
 HEAP32[i3 + 188 >> 2] = i3 + 192;
 HEAP32[i3 + 208 >> 2] = 0;
 HEAP32[i3 + 212 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 204 >> 2] = i3 + 208;
 i9 = i3 + 248 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i3 + 264 >> 2] = i3;
 HEAP32[i3 + 268 >> 2] = i1;
 HEAP32[i3 + 272 >> 2] = i2;
 HEAP32[i3 + 276 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 & 2147483584) >>> 0 >= 64) {
  i13 = i3 + 280 | 0;
  HEAP32[i13 >> 2] = 1;
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i6 >> 2] = 64;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, 1024, 8, i7, 0, gb + 1047584 | 0, 464) | 0;
  i13 = i3 + 280 | 0;
  HEAP32[i13 >> 2] = 1;
  STACKTOP = i8;
  return;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 8, i7, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
  HEAP32[i6 >> 2] = 64;
  HEAP32[i4 >> 2] = i13;
  i13 = i3 + 280 | 0;
  HEAP32[i13 >> 2] = 1;
  STACKTOP = i8;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i8 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i9 = i15 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i15 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i6 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i5 = (Math_imul(i3, i10) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i5;
     HEAP32[i2 + 12 >> 2] = i5;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i5 = i13;
     i7 = HEAP32[i5 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = HEAP32[i11 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i6 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 64, 4) | 0;
      i3 = i2 + 52 | 0;
      i4 = i2;
      i5 = i4 + 52 | 0;
      do {
       HEAP32[i4 >> 2] = 0;
       i4 = i4 + 4 | 0;
      } while ((i4 | 0) < (i5 | 0));
      HEAPF32[i3 >> 2] = Math_fround(1.0);
      HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
      HEAP8[i2 + 60 >> 0] = 1;
      HEAP8[i2 + 61 >> 0] = 1;
      HEAP8[i2 + 62 >> 0] = 0;
      HEAP8[i2 + 63 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 910026 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine13StateConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i6 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i8, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i6 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 64, 4) | 0;
       i3 = i2 + 52 | 0;
       i4 = i2;
       i5 = i4 + 52 | 0;
       do {
        HEAP32[i4 >> 2] = 0;
        i4 = i4 + 4 | 0;
       } while ((i4 | 0) < (i5 | 0));
       HEAPF32[i3 >> 2] = Math_fround(1.0);
       HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
       HEAP8[i2 + 60 >> 0] = 1;
       HEAP8[i2 + 61 >> 0] = 1;
       HEAP8[i2 + 62 >> 0] = 0;
       HEAP8[i2 + 63 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 910026 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine13StateConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i8 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZL21PxcGenerateVFContactsRN5physx2Gu13ContactBufferERKNS0_7SegmentEfRKNS0_3BoxERKNS_6PxVec3Ef(i34, i37, f36, i42, i35, f1) {
 i34 = i34 | 0;
 i37 = i37 | 0;
 f36 = Math_fround(f36);
 i42 = i42 | 0;
 i35 = i35 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i43 = 0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i43 + 44 | 0;
 i33 = i43 + 32 | 0;
 i40 = i43 + 20 | 0;
 i39 = i43 + 8 | 0;
 i41 = i43 + 4 | 0;
 i38 = i43;
 i19 = HEAP32[i42 + 48 >> 2] | 0;
 HEAP32[i32 >> 2] = i19;
 i18 = HEAP32[i42 + 52 >> 2] | 0;
 HEAP32[i32 + 4 >> 2] = i18;
 i17 = HEAP32[i42 + 56 >> 2] | 0;
 HEAP32[i32 + 8 >> 2] = i17;
 f46 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f10 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f44 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i33 >> 2] = f46;
 HEAPF32[i33 + 4 >> 2] = f10;
 HEAPF32[i33 + 8 >> 2] = f44;
 f44 = Math_fround(HEAPF32[i42 >> 2]);
 f10 = Math_fround(HEAPF32[i35 >> 2]);
 f46 = Math_fround(f44 * f10);
 i17 = i42 + 4 | 0;
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i35 + 4 | 0;
 f47 = Math_fround(HEAPF32[i18 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f3 * f47));
 i19 = i42 + 8 | 0;
 f4 = Math_fround(HEAPF32[i19 >> 2]);
 i20 = i35 + 8 | 0;
 f15 = Math_fround(HEAPF32[i20 >> 2]);
 f46 = Math_fround(f46 + Math_fround(f4 * f15));
 i21 = i42 + 12 | 0;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f45 = Math_fround(f10 * f5);
 i22 = i42 + 16 | 0;
 f6 = Math_fround(HEAPF32[i22 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f47 * f6));
 i23 = i42 + 20 | 0;
 f7 = Math_fround(HEAPF32[i23 >> 2]);
 f45 = Math_fround(f45 + Math_fround(f15 * f7));
 i24 = i42 + 24 | 0;
 f8 = Math_fround(HEAPF32[i24 >> 2]);
 f10 = Math_fround(f10 * f8);
 i25 = i42 + 28 | 0;
 f9 = Math_fround(HEAPF32[i25 >> 2]);
 f47 = Math_fround(f10 + Math_fround(f47 * f9));
 i26 = i42 + 32 | 0;
 f10 = Math_fround(HEAPF32[i26 >> 2]);
 f45 = Math_fround(-f45);
 f15 = Math_fround(-Math_fround(f47 + Math_fround(f15 * f10)));
 HEAPF32[i40 >> 2] = Math_fround(-f46);
 HEAPF32[i40 + 4 >> 2] = f45;
 HEAPF32[i40 + 8 >> 2] = f15;
 i27 = i42 + 36 | 0;
 i28 = i42 + 40 | 0;
 i29 = i42 + 44 | 0;
 i30 = i39 + 4 | 0;
 i31 = i39 + 8 | 0;
 f15 = Math_fround(f36 + f1);
 i16 = i34 + 4096 | 0;
 f1 = f44;
 i14 = 0;
 while (1) {
  i11 = i37 + (i14 * 12 | 0) | 0;
  f48 = Math_fround(HEAPF32[i11 >> 2]);
  f48 = Math_fround(f48 - Math_fround(HEAPF32[i27 >> 2]));
  i12 = i37 + (i14 * 12 | 0) + 4 | 0;
  f44 = Math_fround(HEAPF32[i12 >> 2]);
  f44 = Math_fround(f44 - Math_fround(HEAPF32[i28 >> 2]));
  i13 = i37 + (i14 * 12 | 0) + 8 | 0;
  f45 = Math_fround(HEAPF32[i13 >> 2]);
  f45 = Math_fround(f45 - Math_fround(HEAPF32[i29 >> 2]));
  f46 = Math_fround(Math_fround(Math_fround(f48 * f5) + Math_fround(f44 * f6)) + Math_fround(f45 * f7));
  f47 = Math_fround(Math_fround(Math_fround(f48 * f8) + Math_fround(f44 * f9)) + Math_fround(f45 * f10));
  HEAPF32[i39 >> 2] = Math_fround(Math_fround(Math_fround(f48 * f1) + Math_fround(f44 * f3)) + Math_fround(f45 * f4));
  HEAPF32[i30 >> 2] = f46;
  HEAPF32[i31 >> 2] = f47;
  if ((__ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i33, i32, i39, i40, i41, i38) | 0) != -1) {
   f1 = Math_fround(HEAPF32[i41 >> 2]);
   if (f1 < f15) {
    i2 = HEAP32[i16 >> 2] | 0;
    if (i2 >>> 0 <= 63) {
     f48 = Math_fround(f1 - f36);
     f47 = Math_fround(HEAPF32[i13 >> 2]);
     f44 = Math_fround(HEAPF32[i20 >> 2]);
     f47 = Math_fround(f47 - Math_fround(f1 * f44));
     f46 = Math_fround(HEAPF32[i12 >> 2]);
     f10 = Math_fround(HEAPF32[i18 >> 2]);
     f46 = Math_fround(f46 - Math_fround(f1 * f10));
     f45 = Math_fround(HEAPF32[i11 >> 2]);
     f9 = Math_fround(HEAPF32[i35 >> 2]);
     f45 = Math_fround(f45 - Math_fround(f1 * f9));
     HEAP32[i16 >> 2] = i2 + 1;
     HEAPF32[i34 + (i2 << 6) >> 2] = f9;
     HEAPF32[i34 + (i2 << 6) + 4 >> 2] = f10;
     HEAPF32[i34 + (i2 << 6) + 8 >> 2] = f44;
     HEAPF32[i34 + (i2 << 6) + 16 >> 2] = f45;
     HEAPF32[i34 + (i2 << 6) + 20 >> 2] = f46;
     HEAPF32[i34 + (i2 << 6) + 24 >> 2] = f47;
     HEAPF32[i34 + (i2 << 6) + 12 >> 2] = f48;
     HEAP32[i34 + (i2 << 6) + 48 >> 2] = -1;
     HEAP32[i34 + (i2 << 6) + 52 >> 2] = -1;
    }
   }
  }
  i2 = i14 + 1 | 0;
  if ((i2 | 0) == 2) break;
  f1 = Math_fround(HEAPF32[i42 >> 2]);
  f3 = Math_fround(HEAPF32[i17 >> 2]);
  f4 = Math_fround(HEAPF32[i19 >> 2]);
  f5 = Math_fround(HEAPF32[i21 >> 2]);
  f6 = Math_fround(HEAPF32[i22 >> 2]);
  f7 = Math_fround(HEAPF32[i23 >> 2]);
  f8 = Math_fround(HEAPF32[i24 >> 2]);
  f9 = Math_fround(HEAPF32[i25 >> 2]);
  f10 = Math_fround(HEAPF32[i26 >> 2]);
  i14 = i2;
 }
 STACKTOP = i43;
 return;
}

function __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 28 | 0, i4);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 56 | 0, i4);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 104 | 0, i4);
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 + 180 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i4, i3 + 188 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 184 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i4, i3 + 92 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 88 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 + 132 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i4, i3 + 140 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 136 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 152 | 0, i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 + 200 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i4, i3 + 208 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 204 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 + 220 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i4, i3 + 228 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 224 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = i3 + 240 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i7 = i5;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i7 + 344 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 356 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 328 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 340 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 312 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 324 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 296 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 308 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 280 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 292 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 264 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 276 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 248 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 260 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 228 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 240 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 212 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 224 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 188 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 200 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 164 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 176 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 132 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 144 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 116 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 128 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 100 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 112 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i4 = i7 + 88 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i7 + 92 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i8 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i7 + 72 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 84 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 56 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 68 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 44 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 28 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZL22CreateReaderFromStringPKcbRN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE24TransferInstructionFlags(i8, i12, i1) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i13 = i14;
 i9 = __ZnwjRK10MemLabelIdiPKci(176, gb + 64016 | 0, 16, gb + 1036071 | 0, 41) | 0;
 i5 = i1 | 16384;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i1 = i9 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i1 = i13;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 76 >> 2] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i3 = i13;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9 + 68 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i9 + 88 | 0;
 i2 = i9 + 108 | 0;
 i3 = i9 + 112 | 0;
 i4 = i9 + 136 | 0;
 i6 = i1;
 i7 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i4 >> 2] = 1024;
 i7 = i9 + 140 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 144 >> 2] = 0;
 i4 = __Znwj(1) | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i9 + 152 >> 2] = 0;
 HEAP32[i9 + 164 >> 2] = 0;
 HEAP32[i9 + 168 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i3 = i13;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i9 + 156 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 __ZN8JSONRead4InitE24TransferInstructionFlagsRK10MemLabelId(i9, i5, gb + 63160 | 0);
 HEAP32[i13 >> 2] = i8;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = i8;
 __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj1ES2_NS_25GenericInsituStringStreamIS2_EEEERS4_RT1_(i1, i13) | 0;
 HEAP32[i9 + 40 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  if ((HEAP32[i9 + 104 >> 2] & 255 | 0) == 3) {
   i13 = i9;
   STACKTOP = i14;
   return i13 | 0;
  }
  __ZN8JSONReadD2Ev(i9);
  __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64016 | 0);
  __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i12, gb + 1036804 | 0) | 0;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (i9 | 0) __ZN8JSONReadD2Ev(i9);
 __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64016 | 0);
 do switch (i1 | 0) {
 case 17:
  {
   i1 = gb + 1036164 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 1036760 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 1036709 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 1036694 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 1036660 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 1036613 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 1036566 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 1036519 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 1036472 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 1036431 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 1036395 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 1036351 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 1036323 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 1036284 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 1036254 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 1036229 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 1036189 | 0;
   break;
  }
 default:
  i1 = gb + 1036149 | 0;
 } while (0);
 HEAP32[i10 >> 2] = i1;
 __Z6FormatPKcz(i13, gb + 1036783 | 0, i10);
 i8 = HEAP8[i13 + 11 >> 0] | 0;
 i3 = i8 << 24 >> 24 < 0;
 i9 = i3 ? HEAP32[i13 >> 2] | 0 : i13;
 i8 = i3 ? HEAP32[i13 + 4 >> 2] | 0 : i8 & 255;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 i7 = i12 + 4 | 0;
 i6 = i4 ? i7 : i3;
 if (i6 >>> 0 > i9 >>> 0) i11 = 27; else {
  i2 = i12 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i6 + i1 | 0) >>> 0 > i9 >>> 0) {
   i1 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
   if ((i6 | 0) != (i9 | 0)) _memmove(i6 | 0, i9 | 0, i1 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
  } else i11 = 27;
 }
 if ((i11 | 0) == 27) {
  i5 = i12 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = (i1 | 0) == 0;
  if (i2) if (i4) {
   i1 = 15;
   i11 = 30;
  } else i11 = 33; else {
   i1 = i4 ? 15 : i1;
   i11 = 30;
  }
  if ((i11 | 0) == 30) if (i1 >>> 0 < i8 >>> 0) if (i4 | i2) i11 = 33; else {
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i12 + 24 | 0);
   i11 = 33;
  } else i1 = i6;
  if ((i11 | 0) == 33) {
   if (i8 >>> 0 > 15) {
    i1 = i8;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 + 1 | 0, 16, i12 + 24 | 0, 0, gb + 1047486 | 0, 251) | 0;
   } else {
    i1 = 0;
    i2 = 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   i1 = (i2 | 0) == 0 ? i7 : i2;
  }
  _memcpy(i1 | 0, i9 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  HEAP32[i12 + 20 >> 2] = i8;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZL25CalculateCurveRangesValueRKN4math7_float2ERK17AnimationCurveTplIfE(i29, i1, i30) {
 i29 = i29 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, f39 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i33 = i38;
 i34 = i38 + 48 | 0;
 i35 = i38 + 40 | 0;
 i36 = i38 + 32 | 0;
 i37 = i38 + 16 | 0;
 i2 = HEAP32[i30 + 68 >> 2] | 0;
 switch (i2 | 0) {
 case 0:
  {
   i35 = i1;
   i36 = HEAP32[i35 + 4 >> 2] | 0;
   i37 = i29;
   HEAP32[i37 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i37 + 4 >> 2] = i36;
   STACKTOP = i38;
   return;
  }
 case 1:
  {
   i37 = HEAP32[(HEAP32[i30 + 56 >> 2] | 0) + 4 >> 2] | 0;
   HEAP32[i33 + 12 >> 2] = i37;
   HEAP32[i33 + 8 >> 2] = i37;
   HEAP32[i33 + 4 >> 2] = i37;
   HEAP32[i33 >> 2] = i37;
   __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E(i29, i1, i33);
   STACKTOP = i38;
   return;
  }
 default:
  {
   i31 = i2 + -1 | 0;
   i32 = i30 + 56 | 0;
   i23 = HEAP32[(HEAP32[i32 >> 2] | 0) + 4 >> 2] | 0;
   HEAP32[i34 + 12 >> 2] = i23;
   HEAP32[i34 + 8 >> 2] = i23;
   HEAP32[i34 + 4 >> 2] = i23;
   HEAP32[i34 >> 2] = i23;
   __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E(i33, i1, i34);
   if ((i2 | 0) > 1) {
    i8 = i34 + 4 | 0;
    i9 = i34 + 8 | 0;
    i10 = i34 + 12 | 0;
    i11 = i34 + 16 | 0;
    i12 = i34 + 20 | 0;
    i13 = i34 + 24 | 0;
    i14 = i35 + 4 | 0;
    i15 = i37 + 12 | 0;
    i16 = i37 + 8 | 0;
    i17 = i37 + 4 | 0;
    i18 = i36 + 4 | 0;
    i19 = i33 + 4 | 0;
    i20 = i37 + 12 | 0;
    i21 = i37 + 8 | 0;
    i22 = i37 + 4 | 0;
    i23 = i36 + 4 | 0;
    i7 = 0;
    do {
     HEAPF32[i8 >> 2] = Math_fround(inf);
     HEAP32[i34 >> 2] = 0;
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     HEAP32[i9 + 12 >> 2] = 0;
     HEAP32[i9 + 16 >> 2] = 0;
     i6 = i7;
     i7 = i7 + 1 | 0;
     __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i30, i34, i6, i7, Math_fround(0.0));
     f24 = Math_fround(HEAPF32[i10 >> 2]);
     f3 = Math_fround(f24 * Math_fround(3.0));
     f25 = Math_fround(HEAPF32[i11 >> 2]);
     f4 = Math_fround(f25 * Math_fround(2.0));
     f26 = Math_fround(HEAPF32[i12 >> 2]);
     i2 = HEAP32[i32 >> 2] | 0;
     f27 = Math_fround(HEAPF32[i2 + (i6 << 4) >> 2]);
     f28 = Math_fround(HEAPF32[i2 + (i7 << 4) >> 2]);
     i2 = HEAP32[i13 >> 2] | 0;
     i6 = f3 < Math_fround(0.0);
     f5 = Math_fround(-f3);
     if ((i6 ? f5 : f3) < Math_fround(9.99999974e-06)) {
      i6 = f4 < Math_fround(0.0);
      f5 = Math_fround(-f4);
      if ((i6 ? f5 : f4) > Math_fround(9.99999974e-06)) {
       f4 = Math_fround(Math_fround(-f26) / f4);
       HEAPF32[i35 >> 2] = f4;
       i6 = 1;
       i1 = 13;
      } else i1 = 12;
     } else {
      f5 = Math_fround(Math_fround(f4 * f4) - Math_fround(Math_fround(f3 * Math_fround(4.0)) * f26));
      if (f5 < Math_fround(0.0)) i1 = 12; else {
       f39 = Math_fround(Math_fround(.5) / f3);
       f3 = Math_fround(Math_sqrt(Math_fround(f5)));
       f5 = Math_fround(f39 * Math_fround(f3 - f4));
       HEAPF32[i35 >> 2] = f5;
       HEAPF32[i14 >> 2] = Math_fround(f39 * Math_fround(Math_fround(-f3) - f4));
       i6 = 2;
       f4 = f5;
       i1 = 13;
      }
     }
     L12 : do if ((i1 | 0) == 12) f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])); else if ((i1 | 0) == 13) {
      f3 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i2 = 0;
      while (1) {
       if (f4 >= Math_fround(0.0) & Math_fround(f27 + f4) < f28) {
        f39 = Math_fround(f3 + Math_fround(f4 * Math_fround(f26 + Math_fround(f4 * Math_fround(f25 + Math_fround(f24 * f4))))));
        HEAPF32[i20 >> 2] = f39;
        HEAPF32[i21 >> 2] = f39;
        HEAPF32[i22 >> 2] = f39;
        HEAPF32[i37 >> 2] = f39;
        __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E(i36, i33, i37);
        i1 = HEAP32[i23 >> 2] | 0;
        HEAP32[i33 >> 2] = HEAP32[i36 >> 2];
        HEAP32[i19 >> 2] = i1;
       }
       i1 = i2 + 1 | 0;
       if ((i1 | 0) >= (i6 | 0)) break L12;
       i2 = i1;
       f4 = Math_fround(HEAPF32[i35 + (i1 << 2) >> 2]);
      }
     } while (0);
     f39 = Math_fround(f28 - f27);
     f39 = Math_fround(f3 + Math_fround(f39 * Math_fround(f26 + Math_fround(f39 * Math_fround(Math_fround(f39 * f24) + f25)))));
     HEAPF32[i15 >> 2] = f39;
     HEAPF32[i16 >> 2] = f39;
     HEAPF32[i17 >> 2] = f39;
     HEAPF32[i37 >> 2] = f39;
     __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E(i36, i33, i37);
     i6 = HEAP32[i18 >> 2] | 0;
     HEAP32[i33 >> 2] = HEAP32[i36 >> 2];
     HEAP32[i19 >> 2] = i6;
    } while ((i7 | 0) != (i31 | 0));
   }
   i35 = i33;
   i36 = HEAP32[i35 + 4 >> 2] | 0;
   i37 = i29;
   HEAP32[i37 >> 2] = HEAP32[i35 >> 2];
   HEAP32[i37 + 4 >> 2] = i36;
   STACKTOP = i38;
   return;
  }
 }
}

function __Z23CalculateClippedCapsulePfS_PKfS1_S1_ff(i18, i17, i9, i2, i5, f7, f14) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 f7 = Math_fround(f7);
 f14 = Math_fround(f14);
 var f1 = f0, f3 = f0, f4 = f0, i6 = 0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i15 = 0, f16 = f0, f19 = f0, f20 = f0;
 i15 = i2 + 8 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = f3 < Math_fround(HEAPF32[i15 >> 2]);
 i15 = HEAP32[(i6 ? i15 : i2) >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(f3 - f16);
 i6 = f3 > Math_fround(0.0);
 f3 = i6 ? f3 : Math_fround(0.0);
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f1 < Math_fround(0.0)) {
  f11 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f12 = Math_fround(-f1);
  f13 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f19 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f3 * f11);
 f12 = Math_fround(f19 - f13);
 f13 = Math_fround(f19 + f13);
 f19 = Math_fround(HEAPF32[i9 >> 2]);
 f1 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f20 = Math_fround(f3 * (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = Math_fround(f3 * (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(f19 - f20);
 f10 = Math_fround(f1 - f4);
 f3 = Math_fround(f20 + f19);
 f1 = Math_fround(f4 + f1);
 i2 = f11 > Math_fround(.990000009);
 if (f12 > f14) {
  f4 = Math_fround(f12 - f14);
  if (f4 > f16) {
   i18 = 0;
   return i18 | 0;
  }
  HEAPF32[i18 >> 2] = f8;
  HEAPF32[i18 + 4 >> 2] = f10;
  HEAPF32[i17 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) - Math_fround(f4 * f4))));
  if (i2) {
   i18 = 1;
   return i18 | 0;
  }
  if (Math_fround(f13 - f14) < f16) {
   HEAPF32[i18 + 8 >> 2] = f3;
   HEAPF32[i18 + 12 >> 2] = f1;
   i18 = 2;
   return i18 | 0;
  } else {
   f16 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(Math_fround(1.0) - f11)) + f4) / Math_fround(f13 - f12));
   i17 = f16 < Math_fround(0.0);
   i15 = f16 > Math_fround(1.0);
   f16 = i15 ? Math_fround(1.0) : f16;
   f16 = i17 ? Math_fround(0.0) : f16;
   f19 = Math_fround(Math_fround(1.0) - f16);
   f20 = Math_fround(Math_fround(f1 * f16) + Math_fround(f10 * f19));
   HEAPF32[i18 + 8 >> 2] = Math_fround(Math_fround(f3 * f16) + Math_fround(f8 * f19));
   HEAPF32[i18 + 12 >> 2] = f20;
   i18 = 2;
   return i18 | 0;
  }
 }
 if (!(f13 < f7)) {
  if (f12 < f7) {
   f20 = Math_fround(Math_fround(Math_fround(f7 - f12) - Math_fround(f16 * Math_fround(Math_fround(1.0) - f11))) / Math_fround(f13 - f12));
   i9 = f20 < Math_fround(0.0);
   i6 = f20 > Math_fround(1.0);
   f20 = i6 ? Math_fround(1.0) : f20;
   f20 = i9 ? Math_fround(0.0) : f20;
   f7 = Math_fround(Math_fround(1.0) - f20);
   f4 = Math_fround(Math_fround(f3 * f20) + Math_fround(f8 * f7));
   f7 = Math_fround(Math_fround(f1 * f20) + Math_fround(f10 * f7));
  } else {
   f4 = f8;
   f7 = f10;
  }
  if (f13 > f14) {
   f19 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(Math_fround(1.0) - f11)) + Math_fround(f14 - f12)) / Math_fround(f13 - f12));
   i9 = f19 < Math_fround(0.0);
   i6 = f19 > Math_fround(1.0);
   f19 = i6 ? Math_fround(1.0) : f19;
   f19 = i9 ? Math_fround(0.0) : f19;
   f20 = Math_fround(Math_fround(1.0) - f19);
   f3 = Math_fround(Math_fround(f3 * f19) + Math_fround(f8 * f20));
   f1 = Math_fround(Math_fround(f1 * f19) + Math_fround(f10 * f20));
  }
  HEAPF32[i18 >> 2] = f4;
  HEAPF32[i18 + 4 >> 2] = f7;
  HEAPF32[i18 + 8 >> 2] = f3;
  HEAPF32[i18 + 12 >> 2] = f1;
  HEAP32[i17 >> 2] = i15;
  i18 = 2;
  return i18 | 0;
 }
 f4 = Math_fround(f7 - f13);
 if (f4 > f16) {
  i18 = 0;
  return i18 | 0;
 }
 HEAPF32[i18 >> 2] = f3;
 HEAPF32[i18 + 4 >> 2] = f1;
 HEAPF32[i17 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) - Math_fround(f4 * f4))));
 if (i2) {
  i18 = 1;
  return i18 | 0;
 }
 f4 = Math_fround(f7 - f12);
 if (f4 < f16) {
  HEAPF32[i18 + 8 >> 2] = f8;
  HEAPF32[i18 + 12 >> 2] = f10;
  i18 = 2;
  return i18 | 0;
 } else {
  f16 = Math_fround(Math_fround(f4 - Math_fround(f16 * Math_fround(Math_fround(1.0) - f11))) / Math_fround(f13 - f12));
  i17 = f16 < Math_fround(0.0);
  i15 = f16 > Math_fround(1.0);
  f16 = i15 ? Math_fround(1.0) : f16;
  f16 = i17 ? Math_fround(0.0) : f16;
  f19 = Math_fround(Math_fround(1.0) - f16);
  f20 = Math_fround(Math_fround(f1 * f16) + Math_fround(f10 * f19));
  HEAPF32[i18 + 8 >> 2] = Math_fround(Math_fround(f3 * f16) + Math_fround(f8 * f19));
  HEAPF32[i18 + 12 >> 2] = f20;
  i18 = 2;
  return i18 | 0;
 }
 return 0;
}

function __ZN15CollisionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 972 | 0, i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 976 | 0, i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 980 | 0, i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 984 | 0, i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 988 | 0, i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 992 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 144 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 408 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 672 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 936 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 940 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 944 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 956 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 952 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 960 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 964 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 968 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 948 >> 0] = i1;
 i1 = i4 + 949 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim5human15HumanPoseWeightERNS0_9HumanPoseERKS1_f(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i1 = 0;
 do {
  f11 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) >> 2]);
  f10 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 4 >> 2]);
  f11 = Math_fround(f11 * f4);
  f10 = Math_fround(f10 * f4);
  f9 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 8 >> 2]) * f4);
  f8 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 12 >> 2]) * f4);
  f7 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 16 >> 2]) * f4);
  f6 = Math_fround(Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 20 >> 2]) * f4);
  f12 = Math_fround(HEAPF32[i3 + 68 + (i1 << 6) + 24 >> 2]);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f6 * f6) + Math_fround(f12 * f12))))));
  f8 = Math_fround(f8 * f5);
  f7 = Math_fround(f7 * f5);
  f6 = Math_fround(f6 * f5);
  f5 = Math_fround(f12 * f5);
  HEAPF32[i2 + 68 + (i1 << 6) >> 2] = f11;
  HEAPF32[i2 + 68 + (i1 << 6) + 4 >> 2] = f10;
  HEAPF32[i2 + 68 + (i1 << 6) + 8 >> 2] = f9;
  HEAPF32[i2 + 68 + (i1 << 6) + 12 >> 2] = f8;
  HEAPF32[i2 + 68 + (i1 << 6) + 16 >> 2] = f7;
  HEAPF32[i2 + 68 + (i1 << 6) + 20 >> 2] = f6;
  HEAPF32[i2 + 68 + (i1 << 6) + 24 >> 2] = f5;
  HEAP32[i2 + 68 + (i1 << 6) + 28 >> 2] = 1065353216;
  HEAP32[i2 + 68 + (i1 << 6) + 32 >> 2] = 1065353216;
  HEAP32[i2 + 68 + (i1 << 6) + 36 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 i1 = 0;
 do {
  HEAPF32[i2 + 596 + (i1 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 596 + (i1 << 2) >> 2]) * f4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 52);
 i1 = 0;
 do {
  HEAPF32[i2 + 364 + (i1 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 364 + (i1 << 2) >> 2]) * f4);
  HEAPF32[i2 + 500 + (i1 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 500 + (i1 << 2) >> 2]) * f4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(f6 * f4);
 f7 = Math_fround(f7 * f4);
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f4);
 f9 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * f4);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * f4);
 f11 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * f4);
 f5 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f12 * f12)) + Math_fround(Math_fround(f11 * f11) + Math_fround(f5 * f5))))));
 f9 = Math_fround(f9 * f10);
 f12 = Math_fround(f12 * f10);
 f11 = Math_fround(f11 * f10);
 f10 = Math_fround(f5 * f10);
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f9;
 HEAPF32[i2 + 16 >> 2] = f12;
 HEAPF32[i2 + 20 >> 2] = f11;
 HEAPF32[i2 + 24 >> 2] = f10;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i2 + 32 >> 2] = 1065353216;
 HEAP32[i2 + 36 >> 2] = 1065353216;
 f10 = Math_fround(HEAPF32[i3 + 804 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 808 >> 2]);
 f11 = Math_fround(f11 * f4);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 812 >> 2]) * f4);
 HEAPF32[i2 + 804 >> 2] = Math_fround(f10 * f4);
 HEAPF32[i2 + 808 >> 2] = f11;
 HEAPF32[i2 + 812 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i3 + 816 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 820 >> 2]);
 f11 = Math_fround(f11 * f4);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 824 >> 2]) * f4);
 HEAPF32[i2 + 816 >> 2] = Math_fround(f12 * f4);
 HEAPF32[i2 + 820 >> 2] = f11;
 HEAPF32[i2 + 824 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i3 + 828 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 832 >> 2]);
 f11 = Math_fround(f11 * f4);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 836 >> 2]) * f4);
 HEAPF32[i2 + 828 >> 2] = Math_fround(f10 * f4);
 HEAPF32[i2 + 832 >> 2] = f11;
 HEAPF32[i2 + 836 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i3 + 840 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 844 >> 2]);
 f11 = Math_fround(f11 * f4);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 848 >> 2]) * f4);
 HEAPF32[i2 + 840 >> 2] = Math_fround(f12 * f4);
 HEAPF32[i2 + 844 >> 2] = f11;
 HEAPF32[i2 + 848 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i3 + 852 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 856 >> 2]);
 f11 = Math_fround(f11 * f4);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 860 >> 2]) * f4);
 HEAPF32[i2 + 852 >> 2] = Math_fround(f10 * f4);
 HEAPF32[i2 + 856 >> 2] = f11;
 HEAPF32[i2 + 860 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 f11 = Math_fround(f11 * f4);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 872 >> 2]) * f4);
 HEAPF32[i2 + 864 >> 2] = Math_fround(f12 * f4);
 HEAPF32[i2 + 868 >> 2] = f11;
 HEAPF32[i2 + 872 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 880 >> 2]);
 f11 = Math_fround(f11 * f4);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 884 >> 2]) * f4);
 HEAPF32[i2 + 876 >> 2] = Math_fround(f10 * f4);
 HEAPF32[i2 + 880 >> 2] = f11;
 HEAPF32[i2 + 884 >> 2] = f12;
 return;
}

function __ZN5physx19PxsFluidSpatialHash16updatePacketHashERjPjPNS_16PxsFluidParticleERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjPNS_10PxBaseTaskE(i27, i18, i26, i19, i25, i1, i24) {
 i27 = i27 | 0;
 i18 = i18 | 0;
 i26 = i26 | 0;
 i19 = i19 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f28 = f0, f29 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i23 + 1 | 0;
 i22 = i23;
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i1 + (i2 << 4) + 8 >> 2] = -1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 1024);
 HEAP32[i1 + 16392 >> 2] = 0;
 f16 = Math_fround(Math_fround(HEAPF32[i27 + 12 >> 2]) / Math_fround(1 << HEAP32[i27 + 16 >> 2] >>> 0));
 i17 = i25 + 4 | 0;
 i21 = HEAP32[i17 >> 2] << 6;
 HEAP32[i18 >> 2] = 0;
 i21 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i21, gb + 769126 | 0, 93) | 0;
 i5 = HEAP32[i17 >> 2] & 2147483647;
 L4 : do if (!i5) i20 = 11; else {
  i3 = HEAP32[i25 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i20 = 11;
    break L4;
   }
  }
  i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L10 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    break L10;
   }
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i4 | 0) == -1) i20 = 11; else {
   i14 = i27 + 8 | 0;
   i15 = HEAP32[i25 >> 2] | 0;
   i3 = i1;
   i1 = 0;
   do {
    i13 = i3 << 5;
    while (1) {
     i9 = i19 + (i4 << 5) + 28 | 0;
     L20 : do if (!(HEAP16[i9 >> 1] & 16)) {
      f29 = Math_fround(f16 * Math_fround(HEAPF32[i19 + (i4 << 5) >> 2]));
      f28 = Math_fround(f16 * Math_fround(HEAPF32[i19 + (i4 << 5) + 4 >> 2]));
      i10 = ~~Math_fround(Math_floor(Math_fround(f29)));
      i11 = ~~Math_fround(Math_floor(Math_fround(f28)));
      i12 = ~~Math_fround(Math_floor(Math_fround(f16 * Math_fround(HEAPF32[i19 + (i4 << 5) + 8 >> 2]))));
      i5 = HEAP32[i27 >> 2] | 0;
      i8 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
      i7 = ((i11 << 16 >> 16) * 101 | 0) + (i10 << 16 >> 16) + ((i12 << 16 >> 16) * 7919 | 0) & i8;
      i6 = HEAP32[i5 + (i7 << 4) + 8 >> 2] | 0;
      L22 : do if ((i6 | 0) == -1) i20 = 23; else {
       while (1) {
        if (i10 << 16 >> 16 == (HEAP16[i5 + (i7 << 4) >> 1] | 0)) if (i11 << 16 >> 16 == (HEAP16[i5 + (i7 << 4) + 2 >> 1] | 0)) if (i12 << 16 >> 16 == (HEAP16[i5 + (i7 << 4) + 4 >> 1] | 0)) break;
        i7 = i7 + 1 & i8;
        i6 = HEAP32[i5 + (i7 << 4) + 8 >> 2] | 0;
        if ((i6 | 0) == -1) {
         i20 = 23;
         break L22;
        }
       }
       HEAP16[i21 + (i4 << 1) >> 1] = i7;
       i4 = i5 + (i7 << 4) + 8 | 0;
      } while (0);
      do if ((i20 | 0) == 23) {
       i20 = 0;
       i6 = i21 + (i4 << 1) | 0;
       HEAP16[i6 >> 1] = i7;
       i8 = i5 + (i7 << 4) + 8 | 0;
       if (i1 >>> 0 > 923) {
        HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 16;
        i12 = i19 + (i4 << 5) + 30 | 0;
        HEAP16[i12 >> 1] = HEAPU16[i12 >> 1] & 65532;
        i12 = i5 + 16392 | 0;
        HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
        HEAP16[i6 >> 1] = 1024;
        break L20;
       } else {
        HEAP16[i5 + (i7 << 4) >> 1] = i10;
        HEAP16[i5 + (i7 << 4) + 2 >> 1] = i11;
        HEAP16[i5 + (i7 << 4) + 4 >> 1] = i12;
        HEAP32[i8 >> 2] = 0;
        i6 = 0;
        i4 = i8;
        i1 = i1 + 1 | 0;
        break;
       }
      } while (0);
      HEAP32[i4 >> 2] = i6 + 1;
      HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
     } else {
      i5 = HEAP32[i27 >> 2] | 0;
      i12 = i5 + 16392 | 0;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      HEAP16[i21 + (i4 << 1) >> 1] = 1024;
     } while (0);
     if (!i2) break L4;
     i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i13;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i4 | 0) == -1) break L4;
    }
    i6 = HEAP32[i17 >> 2] & 2147483647;
    i2 = i3;
    while (1) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 >= i6 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i15 + (i3 << 2) >> 2] | 0;
     if (!i2) i2 = i3; else break;
    }
   } while ((i4 | 0) != -1);
  }
 } while (0);
 if ((i20 | 0) == 11) {
  i5 = HEAP32[i27 >> 2] | 0;
  i1 = 0;
 }
 HEAP32[i27 + 4 >> 2] = i1;
 i1 = 0;
 i4 = 0;
 do {
  i2 = i5 + (i4 << 4) + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != -1) {
   HEAP32[i5 + (i4 << 4) + 12 >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   i1 = i3 + i1 | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 1025);
 __ZN5physx19PxsFluidSpatialHash31reorderParticleIndicesToPacketsEPjjRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPt(i27, i26, i1, i25, i21);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i21);
 mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] | 0, i24 | 0);
 STACKTOP = i23;
 return;
}

function __ZN10Collider2D16TransformChangedEi(i15, i11) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, f18 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 88 | 0;
 i12 = i17 + 84 | 0;
 i7 = i17 + 80 | 0;
 i13 = i17 + 16 | 0;
 i9 = i17;
 if ((HEAP16[gb + 1457956 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457956 | 0, i10);
  i14 = gb + 1457956 | 0;
 } else i14 = 0;
 L4 : do if (HEAP8[i15 + 33 >> 0] | 0) if (HEAP8[(__Z19GetPhysicsManager2Dv() | 0) + 624 >> 0] | 0) {
  do if (i11 & 64 | 0) {
   if ((HEAP16[gb + 1457968 + 6 >> 1] | 0) > -1) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457968 | 0, i10);
    i8 = gb + 1457968 | 0;
   } else i8 = 0;
   if ((HEAP32[i15 + 72 >> 2] | 0) > 0) {
    i1 = HEAP32[(HEAP32[HEAP32[i15 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 148 >> 2] | 0;
   } else i1 = 0;
   i2 = i15 + 28 | 0;
   if ((__ZN11Rigidbody2D13FindRigidbodyEPK10GameObjectPKS_(HEAP32[i2 >> 2] | 0, 0) | 0) == (i1 | 0)) {
    if (!i8) break;
    __Z12profiler_endP19ProfilerInformation(i8);
    break;
   }
   __ZN10Collider2D19WakeAllBodyContactsEv(i15);
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i16 = 14; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
    i13 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0) | 0;
    __ZN10Collider2D7CleanupEb(i15, i13);
    if (i13) mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 140 >> 2] | 0, i15 | 0, 0);
   } else i16 = 14;
   if ((i16 | 0) == 14) __ZN10Collider2D7CleanupEb(i15, 0);
   if (!i8) break L4;
   __Z12profiler_endP19ProfilerInformation(i8);
   break L4;
  } while (0);
  __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i15, i7, i13, 0);
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0;
  if (!i1) {
   i2 = HEAP32[gb + 62512 >> 2] | 0;
   HEAP32[i9 >> 2] = i2;
   i7 = HEAP32[gb + 62512 + 4 >> 2] | 0;
   HEAP32[i9 + 4 >> 2] = i7;
   i8 = HEAP32[gb + 62512 + 8 >> 2] | 0;
   HEAP32[i9 + 8 >> 2] = i8;
   f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f6 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } else {
   __ZNK9Transform13GetLocalScaleEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f5 = Math_fround(HEAPF32[i9 >> 2]);
   f6 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  }
  f3 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  f18 = Math_fround(f5 - Math_fround(HEAPF32[i15 + 144 >> 2]));
  f5 = Math_fround(f6 - Math_fround(HEAPF32[i15 + 148 >> 2]));
  f6 = Math_fround(f4 - Math_fround(HEAPF32[i15 + 152 >> 2]));
  if (!(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f5 * f5)) + Math_fround(f6 * f6)) <= Math_fround(f3 * f3))) i16 = 26; else if (!(__Z20CompareApproximatelyRK10Matrix4x4fS1_f(i15 + 80 | 0, i13, f3) | 0)) i16 = 26;
  do if ((i16 | 0) == 26) {
   if (i11 & 8 | 0) {
    if ((HEAP16[gb + 1457980 + 6 >> 1] | 0) > -1) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457980 | 0, i10);
     i1 = gb + 1457980 | 0;
    } else i1 = 0;
    __ZN10Collider2D19WakeAllBodyContactsEv(i15);
    i2 = HEAP32[i15 + 28 >> 2] | 0;
    if (!i2) i16 = 31; else if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
     i13 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0) | 0;
     __ZN10Collider2D7CleanupEb(i15, i13);
     if (i13) mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 140 >> 2] | 0, i15 | 0, 0);
    } else i16 = 31;
    if ((i16 | 0) == 31) __ZN10Collider2D7CleanupEb(i15, 0);
    if (!i1) break;
    __Z12profiler_endP19ProfilerInformation(i1);
    break;
   }
   if (i11 & 3 | 0) {
    if ((HEAP16[gb + 1457992 + 6 >> 1] | 0) > -1) {
     HEAP32[i12 >> 2] = 0;
     HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457992 | 0, i10);
     i1 = gb + 1457992 | 0;
    } else i1 = 0;
    __ZN10Collider2D19WakeAllBodyContactsEv(i15);
    i2 = HEAP32[i15 + 28 >> 2] | 0;
    if (!i2) i16 = 41; else if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
     i13 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0) | 0;
     __ZN10Collider2D7CleanupEb(i15, i13);
     if (i13) mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 140 >> 2] | 0, i15 | 0, 0);
    } else i16 = 41;
    if ((i16 | 0) == 41) __ZN10Collider2D7CleanupEb(i15, 0);
    if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   }
  } while (0);
 } while (0);
 if (!i14) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i17;
 return;
}

function __ZN7b2World13DrawDebugDataEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21;
 i18 = i21 + 16 | 0;
 i20 = i17 + 102988 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i16 = __ZNK6b2Draw8GetFlagsEv(i1) | 0;
 if (i16 & 1 | 0) {
  i1 = HEAP32[i17 + 102956 >> 2] | 0;
  if (i1 | 0) {
   i6 = i19 + 4 | 0;
   i7 = i19 + 8 | 0;
   i8 = i19 + 4 | 0;
   i9 = i19 + 8 | 0;
   i10 = i19 + 4 | 0;
   i11 = i19 + 8 | 0;
   i12 = i19 + 4 | 0;
   i13 = i19 + 8 | 0;
   i14 = i19 + 4 | 0;
   i15 = i19 + 8 | 0;
   do {
    i4 = i1 + 12 | 0;
    i2 = HEAP32[i1 + 100 >> 2] | 0;
    if (i2 | 0) {
     i5 = i1 + 4 | 0;
     do {
      i3 = HEAP16[i5 >> 1] | 0;
      L13 : do if (!(i3 & 32)) {
       HEAPF32[i19 >> 2] = Math_fround(.5);
       HEAPF32[i6 >> 2] = Math_fround(.5);
       HEAPF32[i7 >> 2] = Math_fround(.300000012);
       __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i17, i2, i4, i19);
      } else switch (HEAP32[i1 >> 2] | 0) {
      case 0:
       {
        HEAPF32[i19 >> 2] = Math_fround(.5);
        HEAPF32[i12 >> 2] = Math_fround(.899999976);
        HEAPF32[i13 >> 2] = Math_fround(.5);
        __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i17, i2, i4, i19);
        break L13;
       }
      case 1:
       {
        HEAPF32[i19 >> 2] = Math_fround(.5);
        HEAPF32[i14 >> 2] = Math_fround(.5);
        HEAPF32[i15 >> 2] = Math_fround(.899999976);
        __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i17, i2, i4, i19);
        break L13;
       }
      default:
       if (!(i3 & 2)) {
        HEAPF32[i19 >> 2] = Math_fround(.600000024);
        HEAPF32[i8 >> 2] = Math_fround(.600000024);
        HEAPF32[i9 >> 2] = Math_fround(.600000024);
        __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i17, i2, i4, i19);
        break L13;
       } else {
        HEAPF32[i19 >> 2] = Math_fround(.899999976);
        HEAPF32[i10 >> 2] = Math_fround(.699999988);
        HEAPF32[i11 >> 2] = Math_fround(.699999988);
        __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color(i17, i2, i4, i19);
        break L13;
       }
      } while (0);
      i2 = HEAP32[i2 + 24 >> 2] | 0;
     } while ((i2 | 0) != 0);
    }
    i1 = HEAP32[i1 + 96 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
 }
 if (i16 & 2 | 0) {
  i1 = HEAP32[i17 + 102960 >> 2] | 0;
  if (i1 | 0) do {
   __ZN7b2World9DrawJointEP7b2Joint(i17, i1);
   i1 = HEAP32[i1 + 12 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 if (i16 & 8 | 0) {
  i1 = i17 + 102932 | 0;
  while (1) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) break; else i1 = i1 + 12 | 0;
  }
 }
 if (i16 & 4 | 0) {
  HEAPF32[i19 >> 2] = Math_fround(.899999976);
  HEAPF32[i19 + 4 >> 2] = Math_fround(.300000012);
  HEAPF32[i19 + 8 >> 2] = Math_fround(.899999976);
  i1 = HEAP32[i17 + 102956 >> 2] | 0;
  if (i1 | 0) {
   i6 = i17 + 102876 | 0;
   i7 = i18 + 4 | 0;
   i8 = i18 + 8 | 0;
   i9 = i18 + 12 | 0;
   i10 = i18 + 16 | 0;
   i11 = i18 + 20 | 0;
   i12 = i18 + 24 | 0;
   i13 = i18 + 28 | 0;
   do {
    if (HEAP16[i1 + 4 >> 1] & 32) {
     i2 = HEAP32[i1 + 100 >> 2] | 0;
     if (i2 | 0) do {
      i4 = i2 + 48 | 0;
      if ((HEAP32[i4 >> 2] | 0) > 0) {
       i5 = i2 + 44 | 0;
       i3 = 0;
       do {
        i15 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 * 28 | 0) + 24 >> 2] | 0;
        i24 = HEAP32[i6 >> 2] | 0;
        i14 = HEAP32[i24 + (i15 * 36 | 0) >> 2] | 0;
        i23 = HEAP32[i24 + (i15 * 36 | 0) + 4 >> 2] | 0;
        i22 = HEAP32[i24 + (i15 * 36 | 0) + 8 >> 2] | 0;
        i15 = HEAP32[i24 + (i15 * 36 | 0) + 12 >> 2] | 0;
        HEAP32[i18 >> 2] = i14;
        HEAP32[i7 >> 2] = i23;
        HEAP32[i8 >> 2] = i22;
        HEAP32[i9 >> 2] = i23;
        HEAP32[i10 >> 2] = i22;
        HEAP32[i11 >> 2] = i15;
        HEAP32[i12 >> 2] = i14;
        HEAP32[i13 >> 2] = i15;
        i15 = HEAP32[i20 >> 2] | 0;
        mftCall_viiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i18 | 0, 4, i19 | 0);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) < (HEAP32[i4 >> 2] | 0));
      }
      i2 = HEAP32[i2 + 24 >> 2] | 0;
     } while ((i2 | 0) != 0);
    }
    i1 = HEAP32[i1 + 96 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
 }
 if (!(i16 & 16)) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i17 + 102956 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 do {
  i22 = i1 + 12 | 0;
  HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  i22 = i1 + 44 | 0;
  i23 = HEAP32[i22 + 4 >> 2] | 0;
  i24 = i19;
  HEAP32[i24 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i24 + 4 >> 2] = i23;
  i24 = HEAP32[i20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 36 >> 2] | 0, i24 | 0, i19 | 0);
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i21;
 return;
}

function __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i21, i15, i16, i1) {
 i21 = i21 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 i14 = i15 + 28 | 0;
 f23 = Math_fround(HEAPF32[i14 >> 2]);
 i7 = i21 + 28 | 0;
 i19 = f23 < Math_fround(HEAPF32[i7 >> 2]);
 i8 = i16 + 28 | 0;
 i1 = Math_fround(HEAPF32[i8 >> 2]) < f23;
 if (!i19) {
  if (!i1) {
   i21 = 0;
   STACKTOP = i22;
   return i21 | 0;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  i9 = i15 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i10 = i15 + 8 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i11 = i15 + 12 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i12 = i15 + 16 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i13 = i15 + 20 | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  i8 = i15 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i17 = i15;
  i18 = i16;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 4 >> 2] = i2;
  HEAP32[i16 + 8 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i4;
  HEAP32[i16 + 16 >> 2] = i5;
  HEAP32[i16 + 20 >> 2] = i6;
  i19 = i16 + 24 | 0;
  HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  f23 = Math_fround(HEAPF32[i14 >> 2]);
  if (!(f23 < Math_fround(HEAPF32[i7 >> 2]))) {
   i21 = 1;
   STACKTOP = i22;
   return i21 | 0;
  }
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i21 + 20 >> 2] | 0;
  i17 = i21 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i21;
  i18 = i15;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i15 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
  HEAP32[i8 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i21 = 2;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (i1) {
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i21 + 20 >> 2] | 0;
  i17 = i21 + 24 | 0;
  HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  i17 = i21;
  i18 = i16;
  i19 = i17 + 36 | 0;
  do {
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   i17 = i17 + 4 | 0;
   i18 = i18 + 4 | 0;
  } while ((i17 | 0) < (i19 | 0));
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 4 >> 2] = i2;
  HEAP32[i16 + 8 >> 2] = i3;
  HEAP32[i16 + 12 >> 2] = i4;
  HEAP32[i16 + 16 >> 2] = i5;
  HEAP32[i16 + 20 >> 2] = i6;
  i21 = i16 + 24 | 0;
  HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 }
 i2 = HEAP32[i21 >> 2] | 0;
 i3 = HEAP32[i21 + 4 >> 2] | 0;
 i4 = HEAP32[i21 + 8 >> 2] | 0;
 i5 = HEAP32[i21 + 12 >> 2] | 0;
 i6 = HEAP32[i21 + 16 >> 2] | 0;
 i7 = HEAP32[i21 + 20 >> 2] | 0;
 i17 = i21 + 24 | 0;
 HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i17 = i21;
 i18 = i15;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i15 + 4 >> 2] = i3;
 HEAP32[i15 + 8 >> 2] = i4;
 HEAP32[i15 + 12 >> 2] = i5;
 HEAP32[i15 + 16 >> 2] = i6;
 HEAP32[i15 + 20 >> 2] = i7;
 i1 = i15 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 f23 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(f23 < Math_fround(HEAPF32[i14 >> 2]))) {
  i21 = 1;
  STACKTOP = i22;
  return i21 | 0;
 };
 HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i17 = i15;
 i18 = i16;
 i19 = i17 + 36 | 0;
 do {
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i17 = i17 + 4 | 0;
  i18 = i18 + 4 | 0;
 } while ((i17 | 0) < (i19 | 0));
 HEAP32[i16 >> 2] = i2;
 HEAP32[i16 + 4 >> 2] = i3;
 HEAP32[i16 + 8 >> 2] = i4;
 HEAP32[i16 + 12 >> 2] = i5;
 HEAP32[i16 + 16 >> 2] = i6;
 HEAP32[i16 + 20 >> 2] = i7;
 i21 = i16 + 24 | 0;
 HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 i21 = 2;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN7mecanim9animation21SkeletonPoseFromValueIN4math7affineXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTINS2_4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib(i4, i1, i5, i22, i2, i23, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i21 = i1 + 4 | 0;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = (i20 | 0) == 0 ? 0 : i20 + i21 | 0;
 i20 = i2 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i20 = (i1 | 0) == 0 ? 0 : i1 + i20 | 0;
 i1 = i3 & 1;
 i14 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= i14 >>> 0) return;
 i15 = (i23 | 0) == 0;
 i16 = i5 + 20 | 0;
 i17 = i16;
 i18 = i5 + 12 | 0;
 i19 = i18;
 i12 = i5 + 4 | 0;
 i13 = i12;
 do {
  if (i15) i24 = 6; else if ((HEAP32[i23 + (i1 << 2) >> 2] | 0) == -1) i24 = 6;
  if ((i24 | 0) == 6) {
   i24 = 0;
   i2 = HEAP32[i22 + (i1 * 12 | 0) >> 2] | 0;
   if ((i2 | 0) == -1) {
    i4 = i21 + (i1 * 40 | 0) | 0;
    i3 = i21 + (i1 * 40 | 0) + 4 | 0;
    i2 = i21 + (i1 * 40 | 0) + 8 | 0;
   } else {
    i11 = (HEAP32[i12 >> 2] | 0) + i13 | 0;
    i4 = i11 + (i2 * 12 | 0) | 0;
    i3 = i11 + (i2 * 12 | 0) + 4 | 0;
    i2 = i11 + (i2 * 12 | 0) + 8 | 0;
   }
   i11 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i3 >> 2] | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i22 + (i1 * 12 | 0) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i7 = HEAP32[i21 + (i1 * 40 | 0) + 12 >> 2] | 0;
    i8 = HEAP32[i21 + (i1 * 40 | 0) + 16 >> 2] | 0;
    i9 = HEAP32[i21 + (i1 * 40 | 0) + 20 >> 2] | 0;
    i3 = HEAP32[i21 + (i1 * 40 | 0) + 24 >> 2] | 0;
   } else {
    i3 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
    i7 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
    i8 = HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0;
    i9 = HEAP32[i3 + (i2 << 4) + 8 >> 2] | 0;
    i3 = HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0;
   }
   i2 = HEAP32[i22 + (i1 * 12 | 0) + 8 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i4 = HEAP32[i21 + (i1 * 40 | 0) + 28 >> 2] | 0;
    i5 = HEAP32[i21 + (i1 * 40 | 0) + 32 >> 2] | 0;
    i2 = HEAP32[i21 + (i1 * 40 | 0) + 36 >> 2] | 0;
   } else {
    i25 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
    i4 = HEAP32[i25 + (i2 * 12 | 0) >> 2] | 0;
    i5 = HEAP32[i25 + (i2 * 12 | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i25 + (i2 * 12 | 0) + 8 >> 2] | 0;
   }
   f34 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f26 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f42 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f39 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(f42 * Math_fround(-2.0));
   f40 = Math_fround(f42 * Math_fround(2.0));
   f36 = Math_fround(f42 * f30);
   f31 = Math_fround(f39 * Math_fround(-2.0));
   f41 = Math_fround(f39 * Math_fround(2.0));
   f35 = Math_fround(f39 * f31);
   f28 = Math_fround(f32 * Math_fround(2.0));
   f38 = Math_fround(f32 * Math_fround(-2.0));
   f37 = Math_fround(f32 * f38);
   f33 = Math_fround(Math_fround(Math_fround(Math_fround(f32 * f40) + Math_fround(f27 * f41)) + Math_fround(0.0)) * f34);
   f32 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f27) + Math_fround(f32 * f41)) + Math_fround(0.0)) * f34);
   f31 = Math_fround(Math_fround(Math_fround(Math_fround(f42 * f28) + Math_fround(f27 * f31)) + Math_fround(0.0)) * f29);
   f30 = Math_fround(Math_fround(Math_fround(f37 + f35) + Math_fround(1.0)) * f29);
   f29 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) + Math_fround(f42 * f41)) + Math_fround(0.0)) * f29);
   f28 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f39) + Math_fround(f40 * f27)) + Math_fround(0.0)) * f26);
   f27 = Math_fround(Math_fround(Math_fround(Math_fround(f40 * f39) + Math_fround(f38 * f27)) + Math_fround(0.0)) * f26);
   f26 = Math_fround(Math_fround(Math_fround(f37 + f36) + Math_fround(1.0)) * f26);
   HEAPF32[i20 + (i1 * 48 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f36 + f35) + Math_fround(1.0)) * f34);
   HEAPF32[i20 + (i1 * 48 | 0) + 4 >> 2] = f33;
   HEAPF32[i20 + (i1 * 48 | 0) + 8 >> 2] = f32;
   HEAPF32[i20 + (i1 * 48 | 0) + 12 >> 2] = f31;
   HEAPF32[i20 + (i1 * 48 | 0) + 16 >> 2] = f30;
   HEAPF32[i20 + (i1 * 48 | 0) + 20 >> 2] = f29;
   HEAPF32[i20 + (i1 * 48 | 0) + 24 >> 2] = f28;
   HEAPF32[i20 + (i1 * 48 | 0) + 28 >> 2] = f27;
   HEAPF32[i20 + (i1 * 48 | 0) + 32 >> 2] = f26;
   HEAP32[i20 + (i1 * 48 | 0) + 36 >> 2] = i6;
   HEAP32[i20 + (i1 * 48 | 0) + 40 >> 2] = i10;
   HEAP32[i20 + (i1 * 48 | 0) + 44 >> 2] = i11;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i14 >>> 0);
 return;
}

function __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE(i3, i1, i12, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i11 = i16 + 16 | 0;
 i15 = i16;
 i4 = HEAP32[i1 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = i8 + (i3 << 4) | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i7 = i1 << 24 >> 24 < 0;
 i2 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i7 ? HEAP32[i8 + (i3 << 4) + 4 >> 2] | 0 : i1 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i13 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i13 = 6;
  }
 } else i13 = 4;
 if ((i13 | 0) == 4) {
  i8 = i3 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i13 = 6;
 }
 if ((i13 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i11 + 11 | 0;
 L10 : do if ((i4 | 0) == (i9 | 0)) {
  i3 = i4;
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  i5 = i1 & 255;
  i6 = HEAP32[i11 + 4 >> 2] | 0;
  i8 = i3 ? i6 : i5;
  i7 = HEAP32[i11 >> 2] | 0;
  if (i3) {
   i3 = i4;
   while (1) {
    i2 = i3 + 16 | 0;
    i5 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i5 << 24 >> 24 < 0;
    if ((i8 | 0) == ((i4 ? HEAP32[i3 + 20 >> 2] | 0 : i5 & 255) | 0)) if (!(_strncmp(i7, i4 ? HEAP32[i2 >> 2] | 0 : i2, i6) | 0)) break L10;
    i3 = i3 + 76 | 0;
    if ((i3 | 0) == (i9 | 0)) {
     i3 = i9;
     break;
    }
   }
  } else {
   i3 = i4;
   while (1) {
    i2 = i3 + 16 | 0;
    i7 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    if ((i8 | 0) == ((i4 ? HEAP32[i3 + 20 >> 2] | 0 : i7 & 255) | 0)) if (!(_strncmp(i11, i4 ? HEAP32[i2 >> 2] | 0 : i2, i5) | 0)) break L10;
    i3 = i3 + 76 | 0;
    if ((i3 | 0) == (i9 | 0)) {
     i3 = i9;
     break;
    }
   }
  }
 } while (0);
 if (i1 << 24 >> 24 < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
 }
 if ((i3 | 0) == (HEAP32[i10 >> 2] | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i7 = i12 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i12 = i2 << 24 >> 24 < 0;
 i4 = i12 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i12 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i2 = HEAP32[i15 + 12 >> 2] | 0;
  i13 = 22;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i15 + 11 >> 0] = i3;
  if (!i3) i2 = i15; else {
   i2 = i15;
   i13 = 24;
  }
 } else i13 = 22;
 if ((i13 | 0) == 22) {
  i12 = i3 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i15 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i3;
  i13 = 24;
 }
 if ((i13 | 0) == 24) _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i2 + i3 >> 0] = 0;
 i5 = HEAP8[i15 + 11 >> 0] | 0;
 L40 : do if ((i1 | 0) != (i6 | 0)) {
  i3 = i5 & 255;
  if (i5 << 24 >> 24 >= 0) while (1) {
   i13 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i13 << 24 >> 24 < 0;
   if ((i3 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i13 & 255) | 0)) if (!(_strncmp(i15, i2 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0)) break L40;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break L40;
   }
  }
  i3 = HEAP32[i15 + 4 >> 2] | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  while (1) {
   i13 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i13 << 24 >> 24 < 0;
   if ((i3 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i13 & 255) | 0)) if (!(_strncmp(i4, i2 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0)) break L40;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break;
   }
  }
 } while (0);
 if (i5 << 24 >> 24 < 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
 }
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i1 + 32 >> 2] | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx2Sc8ClothSim16addCollisionMeshEPKNS0_8ShapeSimE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 136 | 0;
 i8 = i9 + 88 | 0;
 i5 = i9 + 56 | 0;
 i24 = i9 + 28 | 0;
 i3 = i9;
 i2 = (HEAP32[i7 + 88 >> 2] | 0) + (HEAP32[i7 + 84 >> 2] | 0) + (HEAP32[i7 + 92 >> 2] | 0) + (HEAP32[i7 + 96 >> 2] | 0) + (HEAP32[i7 + 100 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i24, HEAP32[i7 + 52 >> 2] | 0);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i3, i6);
 f20 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[i24 + 4 >> 2]));
 f16 = Math_fround(-Math_fround(HEAPF32[i24 + 8 >> 2]));
 f23 = Math_fround(HEAPF32[i24 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i24 + 16 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i24 + 20 >> 2]));
 f22 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f21 = Math_fround(f21 * Math_fround(2.0));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i24 + 24 >> 2])) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f10 = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f18 * f19)) + Math_fround(f22 * f16));
 f12 = Math_fround(Math_fround(f10 * f20) + Math_fround(Math_fround(f13 * f21) + Math_fround(f23 * Math_fround(Math_fround(f22 * f19) - Math_fround(f18 * f16)))));
 f11 = Math_fround(Math_fround(f10 * f19) + Math_fround(Math_fround(f13 * f18) + Math_fround(f23 * Math_fround(Math_fround(f21 * f16) - Math_fround(f22 * f20)))));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f22) + Math_fround(f23 * Math_fround(Math_fround(f18 * f20) - Math_fround(f21 * f19)))) + Math_fround(f10 * f16));
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(f23 * f21);
 f22 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f22 * f20));
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f13 * f19));
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f21 * f16) + Math_fround(Math_fround(f22 * f19) + Math_fround(f23 * f17))) - Math_fround(f13 * f20));
 f14 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f22 * f16) + Math_fround(f23 * f13))) - Math_fround(f21 * f19));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f17 * f19)) - Math_fround(f13 * f16));
 HEAPF32[i5 >> 2] = Math_fround(f18 - Math_fround(f17 * f16));
 HEAPF32[i5 + 4 >> 2] = f15;
 HEAPF32[i5 + 8 >> 2] = f14;
 HEAPF32[i5 + 12 >> 2] = f13;
 HEAPF32[i5 + 16 >> 2] = f12;
 HEAPF32[i5 + 20 >> 2] = f11;
 HEAPF32[i5 + 24 >> 2] = f10;
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i8, i5, i4 + 72 | 0);
 i4 = i7 + 104 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i5 + 1;
 i5 = i2 + i5 | 0;
 i2 = i7 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i7 + 120 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i7 + 124 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] = 0;
  i24 = i3 + 1 | 0;
  HEAP32[i4 >> 2] = i24;
  i3 = i2;
  i2 = i24;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i2, i1) | 0;
  i3 = i2;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) while (1) {
  i24 = HEAP32[i3 >> 2] | 0;
  HEAP32[i24 + (i1 << 2) >> 2] = HEAP32[i24 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i24 = i1;
   i1 = i2;
   i2 = i24;
  } else break;
 }
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i6;
 i1 = i7 + 128 | 0;
 i2 = i7 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 136 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i24 = HEAP32[i1 >> 2] | 0;
  HEAP32[i24 + (i3 * 48 | 0) >> 2] = HEAP32[i8 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 32 >> 2] = HEAP32[i8 + 32 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 36 >> 2] = HEAP32[i8 + 36 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
  HEAP32[i24 + (i3 * 48 | 0) + 44 >> 2] = HEAP32[i8 + 44 >> 2];
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i9;
  return 1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Cm8Matrix34ENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i8) | 0;
  STACKTOP = i9;
  return 1;
 }
 return 0;
}

function __Z39AvatarBuilder_CUSTOM_BuildGenericAvatarP12Il2CppObjectP12Il2CppString(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 144 | 0;
 i3 = i16 + 8 | 0;
 i4 = i16 + 140 | 0;
 i2 = i16;
 i14 = i16 + 40 | 0;
 i15 = i16 + 16 | 0;
 i10 = i16 + 128 | 0;
 i13 = i16 + 32 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i12) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 930009 | 0, i3);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i12) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 930009 | 0, i3);
 i9 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(100, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 929895 | 0, 88) | 0;
 i1 = gb + 63520 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN6AvatarC2E10MemLabelId18ObjectCreationMode(i9, i11, 0);
 __Z19pop_allocation_rootv();
 i9 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i9) | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0);
 i8 = i14 + 52 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNK11ICallString6ToUTF8Ev(i10, i4);
 i3 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i5 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i15 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i15; else {
   i1 = i15;
   i5 = 9;
  }
 } else i5 = 7;
 if ((i5 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i4;
  i2 = i15 + 11 | 0;
  i5 = 9;
 }
 if ((i5 | 0) == 9) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i15 >> 2] | 0 : i15;
 i6 = i7 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255;
 i7 = i8 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i14 + 60 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  i7 = i3 ? HEAP32[i14 + 56 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i14 + 56 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i8 = HEAP32[i15 >> 2] | 0;
  i7 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i12) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 HEAP32[i13 >> 2] = 2;
 HEAP8[i13 + 4 >> 0] = 0;
 HEAP8[i13 + 5 >> 0] = 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __ZN13AvatarBuilder11BuildAvatarER6AvatarRK10GameObjectRK16HumanDescriptionNS_7OptionsE(i15, i9, i1, i14, i11);
 i13 = HEAP8[i15 + 11 >> 0] | 0;
 i1 = i13 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i15 + 4 >> 2] | 0 : i13 & 255) | 0)) {
  i13 = HEAP32[i9 >> 2] | 0;
  i13 = i13 + 12 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  mftCall_vii(i13 | 0, i9 | 0, 4);
  i13 = __ZN9Scripting19ScriptingWrapperForEP6Object(i9) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  __ZN16HumanDescriptionD2Ev(i14);
  STACKTOP = i16;
  return i13 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i1 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 929895 | 0, 95, 1, 0, 0, 0);
 i13 = HEAP32[i9 >> 2] | 0;
 i13 = i13 + 12 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 mftCall_vii(i13 | 0, i9 | 0, 4);
 i13 = __ZN9Scripting19ScriptingWrapperForEP6Object(i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 __ZN16HumanDescriptionD2Ev(i14);
 STACKTOP = i16;
 return i13 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i17, i12, i16) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 8 | 0;
 i6 = i18;
 i7 = i18 + 40 | 0;
 i11 = i18 + 12 | 0;
 i13 = i18 + 68 | 0;
 i14 = i17 + 48 | 0;
 i15 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i17) | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 i9 = (i1 & 1) != 0;
 i2 = (HEAP8[i16 >> 0] & 1) != 0;
 i10 = i2 ^ 1;
 do if (i9 & i10) {
  i5 = i17 + 20 | 0;
  i2 = HEAP16[i17 + 24 >> 1] | 0;
  i4 = i2 & 65535;
  if (i2 << 16 >> 16 == 1) {
   i2 = i5;
   i8 = 5;
  } else if (i2 << 16 >> 16) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = 5;
  }
  do if ((i8 | 0) == 5) {
   i3 = 0;
   L8 : while (1) {
    i1 = i2 + (i3 << 2) | 0;
    i19 = HEAP32[i1 >> 2] | 0;
    if ((mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 136 >> 2] | 0, i19 | 0) | 0) & 1) switch (HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0) {
    case 6:
    case 1:
    case 5:
     break L8;
    default:
     {}
    }
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i4 >>> 0) {
     i8 = 10;
     break;
    }
   }
   if ((i8 | 0) == 10) {
    i1 = HEAP8[i12 >> 0] | 0;
    break;
   }
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 700849 | 0, 462, gb + 700928 | 0, i6);
   STACKTOP = i18;
   return;
  } while (0);
  do if (i1 & 2) {
   if (!(HEAP32[i17 + 284 >> 2] & 8192)) {
    if ((HEAP32[i17 + 52 >> 2] | 0) >>> 0 > 3221225471) break;
    i1 = __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i17 + 64 | 0, i7) | 0;
   } else {
    i1 = HEAP32[i17 + 56 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i1 + 192 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 196 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 200 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 204 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 208 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 212 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 216 >> 2];
    i1 = 1;
   }
   if ((i15 | 0) != 0 & i1) {
    __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i5, i15 + 3392 | 0);
    i19 = i15 + 3416 | 0;
    HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
   }
  } while (0);
  i1 = i17 + 64 | 0;
  if ((HEAP32[i17 + 52 >> 2] & -1073741824 | 0) == 1073741824) {
   i2 = i17 + 220 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i19 = __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 1) | 0;
    i3 = (HEAP32[i2 >> 2] | 0) == 0;
    if (i19) {
     if (i3) break;
     __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 1);
     break;
    }
    if (!i3) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0) if (HEAP32[i2 >> 2] | 0) __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 0);
   }
  }
 } else if (i2 & (i9 ^ 1)) {
  if ((mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0) == 4) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 700849 | 0, 483, gb + 701010 | 0, i3);
   STACKTOP = i18;
   return;
  }
  i2 = i17 + 64 | 0;
  if ((HEAP32[i17 + 52 >> 2] & -1073741824 | 0) == 1073741824) {
   i1 = i17 + 220 | 0;
   if (HEAP32[i1 >> 2] | 0) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, 0) | 0) if (HEAP32[i1 >> 2] | 0) __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb(i2, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 1, 0) | 0;
  }
 } while (0);
 do if (!(i9 ^ 1 | i10)) if (((HEAPU8[i12 >> 0] | 0) & 2) << 24 >> 24 != ((HEAPU8[i16 >> 0] | 0) & 2) << 24 >> 24) {
  if (!(HEAP32[i17 + 284 >> 2] & 8192)) {
   if ((HEAP32[i17 + 52 >> 2] | 0) >>> 0 > 3221225471) break;
   i1 = __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i17 + 64 | 0, i11) | 0;
  } else {
   i1 = HEAP32[i17 + 56 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 + 192 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 196 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 200 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 204 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 208 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 212 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 216 >> 2];
   i1 = 1;
  }
  if ((i15 | 0) != 0 & i1) {
   __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i17 + 20 | 0, i15 + 3392 | 0);
   i19 = i15 + 3416 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  }
 } while (0);
 HEAP8[i13 >> 0] = HEAP8[i16 >> 0] | 0;
 __ZN5physx3Scb4Body8setFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i14, i13);
 STACKTOP = i18;
 return;
}

function __ZN4gles25InitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadENS_24BlitFramebufferAlphaModeENS_35BlitFramebufferColorSpaceConversionE(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 16 | 0;
 i11 = i12;
 i6 = i12 + 104 | 0;
 i7 = i12 + 100 | 0;
 i8 = i12 + 96 | 0;
 i9 = i12 + 84 | 0;
 i10 = i12 + 116 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1;
  i11 = (i11 | 0) != 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 < 4) {
  i1 = ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -2 | 0) >>> 0 < 3;
  i1 = i1 ? gb + 601110 | 0 : gb + 1576256 | 0;
 } else i1 = gb + 601126 | 0;
 i13 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1;
 i13 = i13 ? gb + 601139 | 0 : gb + 601294 | 0;
 i5 = (i5 | 0) == 1;
 i4 = HEAP32[(i5 ? gb + 75700 | 0 : gb + 75708 | 0) + (i4 << 2) >> 2] | 0;
 i5 = i5 ? gb + 601474 | 0 : gb + 1576256 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i13;
 __Z6FormatPKcz(i6, gb + 601602 | 0, i11);
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i13;
 HEAP32[i2 + 8 >> 2] = i5;
 HEAP32[i2 + 12 >> 2] = i4;
 __Z6FormatPKcz(i11, gb + 601847 | 0, i2);
 i4 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 0, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0;
 HEAP32[i7 >> 2] = i4;
 i5 = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(HEAP32[gb + 1451080 >> 2] | 0, 4, (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11) | 0;
 HEAP32[i8 >> 2] = i5;
 i5 = __ZN7ApiGLES21CreateGraphicsProgramEjjjjj(HEAP32[gb + 1451080 >> 2] | 0, i4, 0, 0, 0, i5) | 0;
 HEAP32[i3 >> 2] = i5;
 mftCall_viii(HEAP32[HEAP32[gb + 1451080 >> 2] >> 2] | 0, i5 | 0, 0, gb + 602071 | 0);
 __ZN7ApiGLES11LinkProgramEj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i7);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i8);
 HEAP32[i3 + 12 >> 2] = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 104 >> 2] | 0, HEAP32[i3 >> 2] | 0, gb + 602078 | 0) | 0;
 HEAP32[i3 + 16 >> 2] = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 104 >> 2] | 0, HEAP32[i3 >> 2] | 0, gb + 602082 | 0) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  HEAP32[i3 + 4 >> 2] = __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj(HEAP32[gb + 1451080 >> 2] | 0, 1, 48, gb + 75716 | 0, 35044) | 0;
  HEAP32[i3 + 8 >> 2] = __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj(HEAP32[gb + 1451080 >> 2] | 0, 0, 6, gb + 222946 | 0, 35044) | 0;
 }
 HEAP32[i9 + 4 >> 2] = 0;
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i9 >> 2] = 0;
 i13 = HEAP32[gb + 1451096 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP8[i10 + 1 >> 0] = 0;
 HEAP8[i2 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP32[i3 + 20 >> 2] = __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i13, i2) | 0;
 i13 = HEAP32[gb + 1451096 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = -1;
 HEAP8[i2 + 2 >> 0] = -1;
 HEAP8[i2 + 3 >> 0] = 0;
 HEAP8[i2 + 4 >> 0] = 8;
 HEAP8[i2 + 5 >> 0] = 0;
 HEAP8[i2 + 6 >> 0] = 0;
 HEAP8[i2 + 7 >> 0] = 0;
 HEAP8[i2 + 8 >> 0] = 8;
 HEAP8[i2 + 9 >> 0] = 0;
 HEAP8[i2 + 10 >> 0] = 0;
 HEAP8[i2 + 11 >> 0] = 0;
 HEAP32[i3 + 24 >> 2] = __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i13, i2) | 0;
 i13 = HEAP32[gb + 1451096 >> 2] | 0;
 HEAP8[i2 >> 0] = 15;
 HEAP8[i2 + 1 >> 0] = 1;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP8[i2 + 8 >> 0] = 15;
 HEAP8[i2 + 9 >> 0] = 1;
 HEAP8[i2 + 10 >> 0] = 0;
 HEAP8[i2 + 11 >> 0] = 1;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 15;
 HEAP8[i2 + 17 >> 0] = 1;
 HEAP8[i2 + 18 >> 0] = 0;
 HEAP8[i2 + 19 >> 0] = 1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i2 + 24 >> 0] = 15;
 HEAP8[i2 + 25 >> 0] = 1;
 HEAP8[i2 + 26 >> 0] = 0;
 HEAP8[i2 + 27 >> 0] = 1;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 15;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 1;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP8[i2 + 40 >> 0] = 15;
 HEAP8[i2 + 41 >> 0] = 1;
 HEAP8[i2 + 42 >> 0] = 0;
 HEAP8[i2 + 43 >> 0] = 1;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP8[i2 + 48 >> 0] = 15;
 HEAP8[i2 + 49 >> 0] = 1;
 HEAP8[i2 + 50 >> 0] = 0;
 HEAP8[i2 + 51 >> 0] = 1;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP8[i2 + 56 >> 0] = 15;
 HEAP8[i2 + 57 >> 0] = 1;
 HEAP8[i2 + 58 >> 0] = 0;
 HEAP8[i2 + 59 >> 0] = 1;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i13, i2) | 0;
 HEAP32[i3 + 32 >> 2] = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(HEAP32[gb + 1451096 >> 2] | 0, i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i13 = HEAP32[i3 >> 2] | 0;
 i13 = (i13 | 0) != 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN16SpriteRenderData14RecalculateUVsER13dynamic_arrayI12SpriteVertexLj4EER9Texture2DRK8Vector2fRK5RectTIfERK8Vector4fSC_S8_21SpritePackingRotation(i17, i1, i4, i5, i18, i6, i7, i10) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 f22 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0);
 f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
 i19 = i18 + 4 | 0;
 f3 = Math_fround(HEAPF32[i19 >> 2]);
 f2 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f2 = Math_fround(f3 - Math_fround(f2 * Math_fround(HEAPF32[i4 >> 2])));
 f16 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(f16 + f2);
 f2 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f2);
 f15 = Math_fround(f2 / f22);
 f16 = Math_fround(Math_fround(f2 - f16) / f22);
 i20 = i18 + 12 | 0;
 f2 = Math_fround(HEAPF32[i20 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(f2 - Math_fround(f12 * Math_fround(HEAPF32[i4 + 4 >> 2])));
 f14 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f12 = Math_fround(f14 + f12);
 f12 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) + f12);
 f13 = Math_fround(f12 / f21);
 f14 = Math_fround(Math_fround(f12 - f14) / f21);
 switch (i10 | 0) {
 case 0:
  {
   i4 = i17 + 12 | 0;
   if (!(HEAP32[i4 >> 2] | 0)) return;
   i5 = i18 + 8 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   while (1) {
    f15 = Math_fround(HEAPF32[i1 >> 2]);
    f15 = Math_fround(Math_fround(Math_fround(f15 * Math_fround(HEAPF32[i18 >> 2])) + f3) / f22);
    f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f16 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(HEAPF32[i5 >> 2])) + f2) / f21);
    HEAPF32[i1 + 12 >> 2] = f15;
    HEAPF32[i1 + 16 >> 2] = f16;
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == ((HEAP32[i17 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0)) break;
    f3 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(HEAPF32[i20 >> 2]);
   }
   return;
  }
 case 1:
  {
   i4 = i17 + 12 | 0;
   if (!(HEAP32[i4 >> 2] | 0)) return;
   i5 = i18 + 8 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   while (1) {
    f14 = Math_fround(HEAPF32[i1 >> 2]);
    f14 = Math_fround(Math_fround(Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2])) + f3) / f22);
    f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(Math_fround(f13 * Math_fround(HEAPF32[i5 >> 2])) + f2) / f21);
    HEAPF32[i1 + 12 >> 2] = Math_fround(f16 + Math_fround(f15 - f14));
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == ((HEAP32[i17 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0)) break;
    f3 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(HEAPF32[i20 >> 2]);
   }
   return;
  }
 case 2:
  {
   i4 = i17 + 12 | 0;
   if (!(HEAP32[i4 >> 2] | 0)) return;
   i5 = i18 + 8 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   while (1) {
    f15 = Math_fround(HEAPF32[i1 >> 2]);
    f15 = Math_fround(Math_fround(Math_fround(f15 * Math_fround(HEAPF32[i18 >> 2])) + f3) / f22);
    f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f16 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(HEAPF32[i5 >> 2])) + f2) / f21);
    HEAPF32[i1 + 12 >> 2] = f15;
    HEAPF32[i1 + 16 >> 2] = Math_fround(f14 + Math_fround(f13 - f16));
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == ((HEAP32[i17 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0)) break;
    f3 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(HEAPF32[i20 >> 2]);
   }
   return;
  }
 case 3:
  {
   i1 = i17 + 12 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) return;
   i17 = HEAP32[i17 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i18 >> 2]);
   f11 = Math_fround(HEAPF32[i18 + 8 >> 2]);
   i4 = i17 + ((HEAP32[i1 >> 2] | 0) * 20 | 0) | 0;
   f9 = Math_fround(HEAPF32[i19 >> 2]);
   f8 = Math_fround(HEAPF32[i20 >> 2]);
   i1 = i17;
   while (1) {
    f23 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f12) + f3) / f22);
    f3 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f11) + f2) / f21);
    HEAPF32[i1 + 12 >> 2] = Math_fround(f16 + Math_fround(f15 - f23));
    HEAPF32[i1 + 16 >> 2] = Math_fround(f14 + Math_fround(f13 - f3));
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else {
     f3 = f9;
     f2 = f8;
    }
   }
   return;
  }
 case 4:
  {
   i4 = i17 + 12 | 0;
   if (!(HEAP32[i4 >> 2] | 0)) return;
   i5 = i18 + 8 | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   while (1) {
    f23 = Math_fround(HEAPF32[i1 >> 2]);
    f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    f16 = Math_fround(Math_fround(Math_fround(f16 * Math_fround(HEAPF32[i18 >> 2])) + f3) / f22);
    f23 = Math_fround(Math_fround(Math_fround(f23 * Math_fround(HEAPF32[i5 >> 2])) + f2) / f21);
    HEAPF32[i1 + 12 >> 2] = f16;
    HEAPF32[i1 + 16 >> 2] = f23;
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == ((HEAP32[i17 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0)) break;
    f3 = Math_fround(HEAPF32[i19 >> 2]);
    f2 = Math_fround(HEAPF32[i20 >> 2]);
   }
   return;
  }
 default:
  return;
 }
}

function __ZN10VertexData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i13 = i14 + 16 | 0;
 i9 = i14 + 40 | 0;
 i7 = i11 + 88 | 0;
 i5 = i12 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i12 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 >> 2] = i3;
 }
 i4 = i11 + 92 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4); else {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i13 >> 2] = 0;
 i3 = i13 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i13 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i15 = i8;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i12, i13, 0);
 switch (HEAP32[i3 >> 2] | 0) {
 case 8:
  {
   _memmove(i11 | 0, HEAP32[i13 >> 2] | 0, 32) | 0;
   break;
  }
 case 6:
  {
   i15 = HEAP32[i13 >> 2] | 0;
   _memmove(i11 | 0, i15 | 0, 20) | 0;
   i3 = i11 + 20 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = HEAP32[i15 + 20 >> 2];
   if ((HEAP8[i11 + 10 >> 0] | 0) == 2) HEAP8[i11 + 11 >> 0] = 4;
   break;
  }
 case 0:
  {
   i15 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i15 << 2 & 128 | i15 & 31;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i11 + 24 >> 2] = 0;
   HEAP32[i11 + 28 >> 2] = 0;
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430681 | 0, 0, gb + 430527 | 0, 118, 1, 0, 0, 0);
   HEAP32[i7 >> 2] = 0;
  }
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 if (!(HEAP8[i11 + 3 >> 0] | 0)) i1 = 0; else {
  i1 = i8 + (HEAPU8[i11 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
  i1 = 1;
 }
 if (HEAP8[i11 + 7 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 4 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
  i1 = i1 | 2;
 }
 if (HEAP8[i11 + 11 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 8 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4;
  i1 = i1 | 4;
 }
 if (HEAP8[i11 + 15 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 12 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 8;
  i1 = i1 | 8;
 }
 if (HEAP8[i11 + 19 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 16 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 16;
  i1 = i1 | 16;
 }
 if (HEAP8[i11 + 23 >> 0] | 0) {
  i15 = i8 + (HEAPU8[i11 + 20 >> 0] << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 32;
  i1 = i1 | 32;
 }
 if (!(HEAP8[i11 + 27 >> 0] | 0)) i2 = i1; else {
  i2 = i8 + (HEAPU8[i11 + 24 >> 0] << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 64;
  i2 = i1 | 64;
 }
 if (!(HEAP8[i11 + 31 >> 0] | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i2) {
   i15 = HEAP32[i7 >> 2] | 0;
   __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i11, i1, i15, ~i15, gb + 59212 | 0, gb + 1546313 | 0);
  } else i10 = 16;
 } else {
  i1 = i8 + (HEAPU8[i11 + 28 >> 0] << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 128;
  i2 = i2 | 128;
  i1 = HEAP32[i4 >> 2] | 0;
  i10 = 16;
 }
 if ((i10 | 0) == 16) {
  HEAP16[i9 >> 1] = HEAP16[i11 + 2 >> 1] | 0;
  HEAP16[i9 + 2 >> 1] = HEAP16[i11 + 6 >> 1] | 0;
  HEAP16[i9 + 4 >> 1] = HEAP16[i11 + 10 >> 1] | 0;
  HEAP16[i9 + 6 >> 1] = HEAP16[i11 + 14 >> 1] | 0;
  HEAP16[i9 + 8 >> 1] = HEAP16[i11 + 18 >> 1] | 0;
  HEAP16[i9 + 10 >> 1] = HEAP16[i11 + 22 >> 1] | 0;
  HEAP16[i9 + 12 >> 1] = HEAP16[i11 + 26 >> 1] | 0;
  HEAP16[i9 + 14 >> 1] = HEAP16[i11 + 30 >> 1] | 0;
  __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i11, i1, i2, ~i2, i8, i9);
 }
 i4 = i11 + 96 | 0;
 __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i12, i4, gb + 430648 | 0, 1);
 i2 = i11 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 i1 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = i3;
  i1 = 0;
 } else {
  _memset(i3 | 0, 0, i1 | 0) | 0;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i12, i1, i3, 0);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i6);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i13, i8, f14, i5) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 f14 = Math_fround(f14);
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 4 | 0;
 i10 = i15;
 i11 = i8 + 132 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 if ((i7 | 0) == 1) {
  i12 = HEAP32[i8 + 120 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 12 >> 2];
  STACKTOP = i15;
  return;
 }
 i12 = (i5 | 0) == 0 ? i8 + 60 | 0 : i5;
 i6 = i12 + 4 | 0;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 if (f1 <= f14) if (Math_fround(HEAPF32[i12 + 8 >> 2]) > f14) {
  f2 = Math_fround(f14 - f1);
  f3 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 12 >> 2]));
  f4 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 16 >> 2]));
  f14 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 20 >> 2]));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i12 + 24 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i12 + 28 >> 2]));
  f3 = Math_fround(f2 * f3);
  f4 = Math_fround(f2 * f4);
  f14 = Math_fround(f2 * Math_fround(f14 + Math_fround(HEAPF32[i12 + 32 >> 2])));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i12 + 36 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i12 + 40 >> 2]));
  f3 = Math_fround(f2 * f3);
  f4 = Math_fround(f2 * f4);
  f14 = Math_fround(f2 * Math_fround(f14 + Math_fround(HEAPF32[i12 + 44 >> 2])));
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i12 + 48 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i12 + 52 >> 2]));
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i12 + 56 >> 2]));
  HEAPF32[i13 >> 2] = f3;
  HEAPF32[i13 + 4 >> 2] = f4;
  HEAPF32[i13 + 8 >> 2] = f14;
  STACKTOP = i15;
  return;
 }
 i5 = i8 + 120 | 0;
 i16 = HEAP32[i5 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f1 = Math_fround(HEAPF32[i16 + ((i7 + -1 | 0) * 40 | 0) >> 2]);
 do if (f1 < f14) {
  HEAPF32[i6 >> 2] = f1;
  HEAPF32[i12 + 8 >> 2] = Math_fround(inf);
  i16 = i12 + 12 | 0;
  i9 = i12 + 24 | 0;
  i10 = i12 + 36 | 0;
  HEAPF32[i12 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i16 = i12 + 48 | 0;
  i11 = (HEAP32[i5 >> 2] | 0) + (((HEAP32[i11 >> 2] | 0) + -1 | 0) * 40 | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else if (f2 > f14) {
  f1 = Math_fround(f14 + Math_fround(-1.0e3));
  HEAPF32[i6 >> 2] = f1;
  HEAPF32[i12 + 8 >> 2] = f2;
  i16 = i12 + 12 | 0;
  i10 = i12 + 24 | 0;
  i11 = i12 + 36 | 0;
  HEAPF32[i12 + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i16 = i12 + 48 | 0;
  i11 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  break;
 } else {
  __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i8, i12, f14, i9, i10);
  __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i8, i12, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, Math_fround(0.0));
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  f2 = Math_fround(HEAPF32[i12 + 36 >> 2]);
  f3 = Math_fround(HEAPF32[i12 + 40 >> 2]);
  f4 = Math_fround(HEAPF32[i12 + 44 >> 2]);
  break;
 } while (0);
 f17 = Math_fround(f14 - f1);
 f1 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) * f17);
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i12 + 16 >> 2]));
 f14 = Math_fround(f17 * Math_fround(HEAPF32[i12 + 20 >> 2]));
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i12 + 24 >> 2]));
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i12 + 28 >> 2]));
 f1 = Math_fround(f17 * Math_fround(Math_fround(f17 * f1) + f2));
 f2 = Math_fround(f17 * Math_fround(Math_fround(f17 * f18) + f3));
 f14 = Math_fround(f17 * Math_fround(Math_fround(f17 * Math_fround(f14 + Math_fround(HEAPF32[i12 + 32 >> 2]))) + f4));
 f3 = Math_fround(f1 + Math_fround(HEAPF32[i12 + 48 >> 2]));
 f4 = Math_fround(f2 + Math_fround(HEAPF32[i12 + 52 >> 2]));
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i12 + 56 >> 2]));
 HEAPF32[i13 >> 2] = f3;
 HEAPF32[i13 + 4 >> 2] = f4;
 HEAPF32[i13 + 8 >> 2] = f14;
 STACKTOP = i15;
 return;
}

function __ZN5physx29PxVehicleUpdateCMassLocalPoseERKNS_11PxTransformES2_jPNS_15PxVehicleWheelsE(i1, i2, i19, i20) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 184 | 0;
 i12 = i26 + 168 | 0;
 i13 = i26 + 24 | 0;
 i14 = i26 + 12 | 0;
 i24 = i26 + 88 | 0;
 i15 = i26;
 i25 = i26 + 40 | 0;
 i22 = i20 + 8 | 0;
 i23 = HEAP32[i20 + 48 >> 2] | 0;
 i16 = (i23 | 0) == 0;
 if (!i16) {
  i17 = i1 + 16 | 0;
  i18 = i1 + 20 | 0;
  i9 = i1 + 24 | 0;
  i10 = i2 + 16 | 0;
  i11 = i2 + 20 | 0;
  i1 = i2 + 24 | 0;
  i2 = i12 + 4 | 0;
  i3 = i12 + 8 | 0;
  i4 = i13 + 4 | 0;
  i5 = i13 + 8 | 0;
  i6 = i14 + 4 | 0;
  i7 = i14 + 8 | 0;
  i8 = 0;
  do {
   i30 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i22, i8) | 0;
   f27 = Math_fround(HEAPF32[i30 >> 2]);
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i17 >> 2]));
   f28 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i18 >> 2]));
   f29 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i9 >> 2]));
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i10 >> 2]));
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i11 >> 2]));
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i21 + (i8 * 12 | 0) >> 2] = f27;
   HEAPF32[i21 + (i8 * 12 | 0) + 4 >> 2] = f28;
   HEAPF32[i21 + (i8 * 12 | 0) + 8 >> 2] = f29;
   i30 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i22, i8) | 0;
   f29 = Math_fround(HEAPF32[i30 >> 2]);
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i17 >> 2]));
   f28 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i18 >> 2]));
   f27 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i9 >> 2]));
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i10 >> 2]));
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i11 >> 2]));
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i12 >> 2] = f29;
   HEAPF32[i2 >> 2] = f28;
   HEAPF32[i3 >> 2] = f27;
   __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i22, i8, i12);
   i30 = __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj(i22, i8) | 0;
   f27 = Math_fround(HEAPF32[i30 >> 2]);
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i17 >> 2]));
   f28 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i18 >> 2]));
   f29 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i9 >> 2]));
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i10 >> 2]));
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i11 >> 2]));
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i13 >> 2] = f27;
   HEAPF32[i4 >> 2] = f28;
   HEAPF32[i5 >> 2] = f29;
   __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i22, i8, i13);
   i30 = __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj(i22, i8) | 0;
   f29 = Math_fround(HEAPF32[i30 >> 2]);
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i17 >> 2]));
   f28 = Math_fround(HEAPF32[i30 + 4 >> 2]);
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i18 >> 2]));
   f27 = Math_fround(HEAPF32[i30 + 8 >> 2]);
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i9 >> 2]));
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i10 >> 2]));
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i11 >> 2]));
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i14 >> 2] = f29;
   HEAPF32[i6 >> 2] = f28;
   HEAPF32[i7 >> 2] = f27;
   __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i22, i8, i14);
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i23 | 0));
 }
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
 i30 = HEAP32[i20 + 104 >> 2] | 0;
 __ZN5physx19computeSprungMassesEjPKNS_6PxVec3ERS1_fjPf(i23, i21, i15, Math_fround(+mftCall_fi(HEAP32[(HEAP32[i30 >> 2] | 0) + 132 >> 2] | 0, i30 | 0)), i19, i24);
 if (i16) {
  STACKTOP = i26;
  return;
 }
 i1 = i25 + 16 | 0;
 i2 = i25 + 4 | 0;
 i3 = 0;
 do {
  i4 = i25;
  i5 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i22, i3) | 0;
  i6 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
  } while ((i4 | 0) < (i6 | 0));
  f28 = Math_fround(HEAPF32[i24 + (i3 << 2) >> 2]);
  f29 = Math_fround(f28 / Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i1 >> 2] = f28;
  HEAPF32[i25 >> 2] = Math_fround(f29 * Math_fround(HEAPF32[i25 >> 2]));
  HEAPF32[i2 >> 2] = Math_fround(f29 * Math_fround(HEAPF32[i2 >> 2]));
  __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i22, i3, i25);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i23 | 0));
 STACKTOP = i26;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i17, i12, i16) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 8 | 0;
 i6 = i18;
 i7 = i18 + 40 | 0;
 i11 = i18 + 12 | 0;
 i13 = i18 + 68 | 0;
 i14 = i17 + 48 | 0;
 i15 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i17) | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 i9 = (i1 & 1) != 0;
 i2 = (HEAP8[i16 >> 0] & 1) != 0;
 i10 = i2 ^ 1;
 do if (i9 & i10) {
  i5 = i17 + 20 | 0;
  i2 = HEAP16[i17 + 24 >> 1] | 0;
  i4 = i2 & 65535;
  if (i2 << 16 >> 16 == 1) {
   i2 = i5;
   i8 = 5;
  } else if (i2 << 16 >> 16) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = 5;
  }
  do if ((i8 | 0) == 5) {
   i3 = 0;
   L8 : while (1) {
    i1 = i2 + (i3 << 2) | 0;
    i19 = HEAP32[i1 >> 2] | 0;
    if ((mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 136 >> 2] | 0, i19 | 0) | 0) & 1) switch (HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0) {
    case 6:
    case 1:
    case 5:
     break L8;
    default:
     {}
    }
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i4 >>> 0) {
     i8 = 10;
     break;
    }
   }
   if ((i8 | 0) == 10) {
    i1 = HEAP8[i12 >> 0] | 0;
    break;
   }
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 700849 | 0, 462, gb + 700928 | 0, i6);
   STACKTOP = i18;
   return;
  } while (0);
  do if (i1 & 2) {
   if (!(HEAP32[i17 + 284 >> 2] & 8192)) {
    if ((HEAP32[i17 + 52 >> 2] | 0) >>> 0 > 3221225471) break;
    i1 = __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i17 + 64 | 0, i7) | 0;
   } else {
    i1 = HEAP32[i17 + 56 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i1 + 192 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 196 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 200 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 204 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 208 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 212 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 216 >> 2];
    i1 = 1;
   }
   if ((i15 | 0) != 0 & i1) {
    __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i5, i15 + 3392 | 0);
    i19 = i15 + 3416 | 0;
    HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
   }
  } while (0);
  i1 = i17 + 64 | 0;
  if ((HEAP32[i17 + 52 >> 2] & -1073741824 | 0) == 1073741824) {
   i2 = i17 + 220 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i19 = __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 1) | 0;
    i3 = (HEAP32[i2 >> 2] | 0) == 0;
    if (i19) {
     if (i3) break;
     __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 1);
     break;
    }
    if (!i3) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0) if (HEAP32[i2 >> 2] | 0) __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 0);
   }
  }
 } else if (i2 & (i9 ^ 1)) {
  if ((mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0) == 4) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 700849 | 0, 483, gb + 701010 | 0, i3);
   STACKTOP = i18;
   return;
  }
  i2 = i17 + 64 | 0;
  if ((HEAP32[i17 + 52 >> 2] & -1073741824 | 0) == 1073741824) {
   i1 = i17 + 220 | 0;
   if (HEAP32[i1 >> 2] | 0) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, 0) | 0) if (HEAP32[i1 >> 2] | 0) __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb(i2, HEAP32[(HEAP32[i14 >> 2] | 0) + 1248 >> 2] | 0, 1, 0) | 0;
  }
 } while (0);
 do if (!(i9 ^ 1 | i10)) if (((HEAPU8[i12 >> 0] | 0) & 2) << 24 >> 24 != ((HEAPU8[i16 >> 0] | 0) & 2) << 24 >> 24) {
  if (!(HEAP32[i17 + 284 >> 2] & 8192)) {
   if ((HEAP32[i17 + 52 >> 2] | 0) >>> 0 > 3221225471) break;
   i1 = __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i17 + 64 | 0, i11) | 0;
  } else {
   i1 = HEAP32[i17 + 56 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 + 192 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 196 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 200 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 204 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 208 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 212 >> 2];
   HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 216 >> 2];
   i1 = 1;
  }
  if ((i15 | 0) != 0 & i1) {
   __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i17 + 20 | 0, i15 + 3392 | 0);
   i19 = i15 + 3416 | 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
  }
 } while (0);
 HEAP8[i13 >> 0] = HEAP8[i16 >> 0] | 0;
 __ZN5physx3Scb4Body8setFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i14, i13);
 STACKTOP = i18;
 return;
}

function __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i2, i14) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = (i14 - i2 | 0) / 52 | 0;
 i9 = i8 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4;
 if (i7 >>> 0 > ((i1 - i4 | 0) / 52 | 0) >>> 0) {
  if (i4) {
   i6 = i8 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
    i4 = i1;
    while (1) {
     i1 = i4 + -52 | 0;
     HEAP32[i6 >> 2] = i1;
     i5 = i4 + -48 | 0;
     if ((HEAP32[i4 + -32 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + -44 | 0);
      HEAP32[i5 >> 2] = 0;
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 | 0)) break; else i4 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 0;
  }
  if (i7 >>> 0 > 82595524) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
  } else i3 = 0;
  i13 = (i1 - i3 | 0) / 52 | 0;
  i3 = i13 << 1;
  i3 = i13 >>> 0 < 41297762 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 82595524;
  if (i3 >>> 0 > 82595524) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i1 = __Znwj(i3 * 52 | 0) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i1 + (i3 * 52 | 0);
  if ((i2 | 0) == (i14 | 0)) return;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i1 + 4 | 0, i2 + 4 | 0);
   i13 = i1 + 24 | 0;
   i12 = i2 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
   i2 = i2 + 52 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 52 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i14 | 0));
  return;
 }
 i13 = i8 + 4 | 0;
 i1 = ((HEAP32[i13 >> 2] | 0) - i4 | 0) / 52 | 0;
 i12 = i7 >>> 0 > i1 >>> 0;
 i1 = i2 + (i1 * 52 | 0) | 0;
 i11 = i12 ? i1 : i14;
 if ((i11 | 0) == (i2 | 0)) i4 = i3; else {
  do {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i5 = i3 + 4 | 0;
   if ((i2 | 0) != (i3 | 0)) {
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = i3 + 16 | 0;
    i4 = (HEAP32[i2 + 16 >> 2] | 0) * 20 | 0;
    i6 = (i4 | 0) / 20 | 0;
    HEAP32[i10 >> 2] = i6;
    i7 = i3 + 20 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    do if ((i8 & 2147483647) >>> 0 < i6 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i6;
     i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4, 4, i3 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i5 >> 2] = i4;
     break;
    } else {
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i3 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 20 | 0) | 0;
     HEAP32[i7 >> 2] = i6;
     HEAP32[i5 >> 2] = i4;
     break;
    } else i4 = HEAP32[i5 >> 2] | 0; while (0);
    _memcpy(i4 | 0, i9 | 0, (HEAP32[i10 >> 2] | 0) * 20 | 0) | 0;
   }
   i10 = i3 + 24 | 0;
   i9 = i2 + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   i2 = i2 + 52 | 0;
   i3 = i3 + 52 | 0;
  } while ((i2 | 0) != (i11 | 0));
  i4 = i3;
 }
 if (i12) {
  if ((i11 | 0) == (i14 | 0)) return;
  i2 = HEAP32[i13 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i2 + 4 | 0, i1 + 4 | 0);
   i12 = i2 + 24 | 0;
   i11 = i1 + 24 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   i1 = i1 + 52 | 0;
   i2 = (HEAP32[i13 >> 2] | 0) + 52 | 0;
   HEAP32[i13 >> 2] = i2;
  } while ((i1 | 0) != (i14 | 0));
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -52 | 0;
  HEAP32[i13 >> 2] = i2;
  i3 = i1 + -48 | 0;
  if ((HEAP32[i1 + -32 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -44 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i13 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx17PxsFluidCollision25updateFluidShapeCollisionEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_9PxBounds3EPKjPKfPKNS_19PxsW2STransformTempERKNS_22PxsParticleStreamShapeE(i29, i24, i20, i30, i17, i18, i22, i32, i19, i26, i31, i3) {
 i29 = i29 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 i30 = i30 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i22 = i22 | 0;
 i32 = i32 | 0;
 i19 = i19 | 0;
 i26 = i26 | 0;
 i31 = i31 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, i23 = 0, i25 = 0, i27 = 0, i28 = 0, i33 = 0, i34 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i34 + 40 | 0;
 i27 = i34 + 48 | 0;
 i28 = i34 + 32 | 0;
 i21 = i34 + 12 | 0;
 i23 = i34;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0;
 i14 = HEAP32[i2 + 8 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i16 = i25 + 4 | 0;
 HEAP8[i16 >> 0] = 1;
 i4 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i34 + 561 | 0, 4096, gb + 769468 | 0, 300) | 0;
 HEAP32[i25 >> 2] = i4;
 i13 = i28 + 4 | 0;
 HEAP8[i13 >> 0] = 1;
 i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i34 + 560 | 0, 4608, gb + 769468 | 0, 307) | 0;
 HEAP32[i28 >> 2] = i1;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 HEAP8[i21 + 16 >> 0] = 0;
 if (!i22) {
  HEAP32[i21 + 4 >> 2] = i1;
  HEAP32[i21 + 12 >> 2] = i1 + 512;
  f38 = Math_fround(HEAP16[i2 >> 1] | 0);
  f36 = Math_fround(HEAP16[i2 + 2 >> 1] | 0);
  f35 = Math_fround(HEAP16[i2 + 4 >> 1] | 0);
  f37 = Math_fround(HEAPF32[i29 + 44 >> 2]);
  f36 = Math_fround(f36 * f37);
  f35 = Math_fround(f35 * f37);
  HEAPF32[i23 >> 2] = Math_fround(f38 * f37);
  HEAPF32[i23 + 4 >> 2] = f36;
  HEAPF32[i23 + 8 >> 2] = f35;
  i1 = 0;
 }
 if (!i14) i33 = 17; else {
  i11 = (i26 | 0) == 0;
  i12 = i3 + 8 | 0;
  i8 = i3 + 4 | 0;
  i9 = i21 + 16 | 0;
  i10 = i29 + 48 | 0;
  i6 = (i14 + 127 & 127) + 1 | 0;
  i7 = 0;
  while (1) {
   i5 = i7 + i15 | 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i19 + (i2 + i5 << 2) >> 2] | 0;
    HEAP32[i4 + (i2 << 5) >> 2] = HEAP32[i24 + (i3 << 5) >> 2];
    HEAP32[i4 + (i2 << 5) + 4 >> 2] = HEAP32[i24 + (i3 << 5) + 4 >> 2];
    HEAP32[i4 + (i2 << 5) + 8 >> 2] = HEAP32[i24 + (i3 << 5) + 8 >> 2];
    HEAP32[i4 + (i2 << 5) + 12 >> 2] = HEAP32[i24 + (i3 << 5) + 12 >> 2];
    HEAP32[i4 + (i2 << 5) + 16 >> 2] = HEAP32[i24 + (i3 << 5) + 16 >> 2];
    HEAP32[i4 + (i2 << 5) + 20 >> 2] = HEAP32[i24 + (i3 << 5) + 20 >> 2];
    HEAP32[i4 + (i2 << 5) + 24 >> 2] = HEAP32[i24 + (i3 << 5) + 24 >> 2];
    i4 = i4 + (i2 << 5) + 28 | 0;
    i3 = i24 + (i3 << 5) + 28 | 0;
    i3 = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
    HEAP16[i4 >> 1] = i3;
    HEAP16[i4 + 2 >> 1] = i3 >>> 16;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i6 >>> 0) break;
    i4 = HEAP32[i25 >> 2] | 0;
   }
   i4 = i19 + (i5 << 2) | 0;
   if (i11) {
    i2 = HEAP32[i10 >> 2] | 0;
    i3 = 0;
    do {
     HEAP32[i27 + (i3 << 2) >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i6 >>> 0);
   } else {
    i2 = 0;
    do {
     HEAP32[i27 + (i2 << 2) >> 2] = HEAP32[i26 + (HEAP32[i19 + (i2 + i5 << 2) >> 2] << 2) >> 2];
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < i6 >>> 0);
   }
   __ZN5physx17PxsFluidCollision15updateSubPacketEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheESA_RNS_21PxsFluidLocalCellHashERNS_9PxBounds3ERKS5_PKjjPKNS_31PxsParticleStreamContactManagerEPKNS_19PxsW2STransformTempEjPKf(i29, HEAP32[i25 >> 2] | 0, i20, i30, i17, i18, i1, i22, i21, i32, i23, i4, i6, HEAP32[i12 >> 2] | 0, i31, HEAP32[i8 >> 2] | 0, i27);
   i4 = HEAP32[i25 >> 2] | 0;
   i2 = 0;
   do {
    i3 = HEAP32[i19 + (i2 + i5 << 2) >> 2] | 0;
    HEAP32[i24 + (i3 << 5) >> 2] = HEAP32[i4 + (i2 << 5) >> 2];
    HEAP32[i24 + (i3 << 5) + 4 >> 2] = HEAP32[i4 + (i2 << 5) + 4 >> 2];
    HEAP32[i24 + (i3 << 5) + 8 >> 2] = HEAP32[i4 + (i2 << 5) + 8 >> 2];
    HEAP32[i24 + (i3 << 5) + 12 >> 2] = HEAP32[i4 + (i2 << 5) + 12 >> 2];
    HEAP32[i24 + (i3 << 5) + 16 >> 2] = HEAP32[i4 + (i2 << 5) + 16 >> 2];
    HEAP32[i24 + (i3 << 5) + 20 >> 2] = HEAP32[i4 + (i2 << 5) + 20 >> 2];
    HEAP32[i24 + (i3 << 5) + 24 >> 2] = HEAP32[i4 + (i2 << 5) + 24 >> 2];
    i3 = i24 + (i3 << 5) + 28 | 0;
    i39 = i4 + (i2 << 5) + 28 | 0;
    i39 = HEAPU16[i39 >> 1] | HEAPU16[i39 + 2 >> 1] << 16;
    HEAP16[i3 >> 1] = i39;
    HEAP16[i3 + 2 >> 1] = i39 >>> 16;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i6 >>> 0);
   HEAP8[i9 >> 0] = 0;
   i7 = i7 + i6 | 0;
   if (i7 >>> 0 >= i14 >>> 0) break; else i6 = 128;
  }
  if (HEAP8[i13 >> 0] | 0) i33 = 17;
 }
 if ((i33 | 0) == 17) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i28, HEAP32[i28 >> 2] | 0);
 if (!(HEAP8[i16 >> 0] | 0)) {
  STACKTOP = i34;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i25, HEAP32[i25 >> 2] | 0);
 STACKTOP = i34;
 return;
}

function __ZN11ShapeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i1 = i7 + 4 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 44 | 0, i5);
 __ZN4PPtrI12MeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 48 | 0, i5);
 __ZN4PPtrI19SkinnedMeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 52 | 0, i5);
 i1 = i7 + 56 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 213 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 214 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 212 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 204 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 208 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f14 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 i2 = HEAP32[i2 + 64 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f20 = Math_fround(f20 * Math_fround(-2.0));
 f22 = Math_fround(f22 * Math_fround(-2.0));
 f24 = Math_fround(Math_fround(HEAPF32[i2 + 56 >> 2]) * Math_fround(-2.0));
 f9 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f23 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
 f21 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f11 = Math_fround(f20 * f21);
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f22 * f4));
 f18 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f24 * f18));
 f10 = Math_fround(-f21);
 f16 = Math_fround(-f4);
 f17 = Math_fround(-f18);
 f15 = Math_fround(Math_fround(Math_fround(f21 * f11) + Math_fround(Math_fround(f20 * f23) - Math_fround(f9 * Math_fround(Math_fround(f24 * f4) - Math_fround(f22 * f18))))) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(Math_fround(f4 * f11) + Math_fround(Math_fround(f22 * f23) - Math_fround(f9 * Math_fround(Math_fround(f20 * f18) - Math_fround(f24 * f21))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f9 * Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f4)))) + Math_fround(f18 * f11)) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(f12 * f11) + Math_fround(Math_fround(f14 * f15) + Math_fround(f7 * f13)));
 f6 = Math_fround(f6 + Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f18 * f15) + Math_fround(f8 * Math_fround(Math_fround(f7 * f11) - Math_fround(f12 * f13))))));
 f5 = Math_fround(f5 + Math_fround(Math_fround(f7 * f4) + Math_fround(Math_fround(f18 * f13) + Math_fround(f8 * Math_fround(Math_fround(f12 * f15) - Math_fround(f14 * f11))))));
 f4 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f18 * f11) + Math_fround(f8 * Math_fround(Math_fround(f14 * f13) - Math_fround(f7 * f15)))) + Math_fround(f12 * f4)));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f9) + Math_fround(f8 * f10)) + Math_fround(f7 * f17)) - Math_fround(f12 * f16));
 f13 = Math_fround(Math_fround(Math_fround(f12 * f10) + Math_fround(Math_fround(f7 * f9) + Math_fround(f8 * f16))) - Math_fround(f14 * f17));
 f11 = Math_fround(Math_fround(Math_fround(f14 * f16) + Math_fround(Math_fround(f12 * f9) + Math_fround(f8 * f17))) - Math_fround(f7 * f10));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f9) - Math_fround(f14 * f10)) - Math_fround(f7 * f16)) - Math_fround(f12 * f17));
 i3 = HEAP32[i3 >> 2] | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f14 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(f13 * f16)) + Math_fround(f11 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f12 * f10) + Math_fround(f17 * Math_fround(Math_fround(f13 * f7) - Math_fround(f16 * f11))))) + f6);
 f5 = Math_fround(Math_fround(Math_fround(f13 * f14) + Math_fround(Math_fround(f16 * f10) + Math_fround(f17 * Math_fround(Math_fround(f12 * f11) - Math_fround(f15 * f7))))) + f5);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f7) + Math_fround(f17 * Math_fround(Math_fround(f15 * f16) - Math_fround(f12 * f13)))) + Math_fround(f11 * f14)) + f4);
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f17 * f14);
 f16 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f15 * f16));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f7));
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f13 * f16) + Math_fround(f17 * f10))) - Math_fround(f15 * f7));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f10) + Math_fround(Math_fround(f11 * f16) + Math_fround(f17 * f7))) - Math_fround(f13 * f14));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)) - Math_fround(f13 * f10)) - Math_fround(f11 * f7));
 HEAPF32[i1 >> 2] = Math_fround(f12 - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 return;
}

function __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i2, i20, i9, i3, f21) {
 i2 = i2 | 0;
 i20 = i20 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 f21 = Math_fround(f21);
 var f1 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22;
 i12 = i22 + 8 | 0;
 i4 = i22 + 4 | 0;
 i19 = HEAP32[i2 + 4 >> 2] | 0;
 i16 = i19 + (i20 * 96 | 0) | 0;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAPF32[i19 + (i20 * 96 | 0) + 12 >> 2] = f21;
 HEAP32[i19 + (i20 * 96 | 0) + 88 >> 2] = i9;
 i16 = i9 + 56 | 0;
 i17 = i9 + 60 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i19 + (i20 * 96 | 0) + 20 >> 2] = (i2 - i15 | 0) / 28 | 0;
 i18 = i19 + (i20 * 96 | 0) + 16 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 do if ((i15 | 0) == (i2 | 0)) i2 = 0; else if ((HEAP32[i2 + -8 >> 2] | 0) == 1) {
  i5 = HEAP32[HEAP32[i2 + -20 >> 2] >> 2] | 0;
  if (!i5) i2 = 0; else {
   HEAP32[i4 >> 2] = i5;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i8 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i2, i4);
     i3 = HEAP32[i12 >> 2] | 0;
     i15 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 9; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i8 = 11;
    }
   }
   if ((i8 | 0) == 9) i8 = 11;
   if ((i8 | 0) == 11) {
    i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i2) {
     i2 = 0;
     break;
    }
   }
   i2 = (((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29752 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29752 + 28 >> 2] | 0) >>> 0;
  }
 } else i2 = 0; while (0);
 i5 = i9 + 48 | 0;
 do if ((HEAP32[i5 >> 2] | 0) == 2) {
  i14 = HEAP32[i16 >> 2] | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i3 = (i15 - i14 | 0) / 28 | 0;
  if ((i14 | 0) != (i15 | 0)) if (i2) {
   i3 = (i3 >>> 0 < 2 ? 2 : i3) + -2 | 0;
   break;
  } else {
   i3 = i3 + -1 | 0;
   break;
  }
 } else i3 = 0; while (0);
 if (!(HEAP8[i9 + 52 >> 0] | 0)) i15 = 0; else if (((HEAP32[i17 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) == 224) {
  HEAP32[i13 >> 2] = 8;
  __Z6FormatPKcz(i12, gb + 424961 | 0, i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 425023 | 0, 632, 512, HEAP32[i9 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i15 = 0;
 } else i15 = 1;
 i4 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i8 = i2;
 if ((i4 | 0) == (i2 | 0)) {
  i20 = 0;
  HEAP32[i18 >> 2] = i20;
  STACKTOP = i22;
  return;
 }
 i12 = f21 < Math_fround(0.0);
 f11 = Math_fround(-f21);
 i12 = !((i12 ? f11 : f21) <= Math_fround(9.99999997e-07));
 i14 = HEAP32[i5 >> 2] | 0;
 i13 = (i14 | 0) == 0;
 i14 = (i14 | 0) == 2;
 if (i12) {
  i12 = 0;
  f1 = Math_fround(0.0);
  while (1) {
   f10 = Math_fround(HEAPF32[i8 + (i12 * 28 | 0) >> 2]);
   f11 = Math_fround(f21 / f10);
   f1 = f11 < f1 ? f1 : f11;
   HEAPF32[i19 + (i20 * 96 | 0) + 24 + (i12 << 2) >> 2] = f11;
   i9 = i19 + (i20 * 96 | 0) + 56 + (i12 << 2) | 0;
   HEAPF32[i9 >> 2] = Math_fround(0.0);
   i5 = i12 >>> 0 < i3 >>> 0;
   do if (i5 | i13) {
    if (i5 & i14) HEAP32[i9 >> 2] = -2147483648;
   } else {
    if (i15) {
     HEAP32[i9 >> 2] = i12 >>> 0 > i3 >>> 0 ? -2147483645 : -2147483647;
     i4 = HEAP32[i17 >> 2] | 0;
     i2 = HEAP32[i16 >> 2] | 0;
     break;
    }
    f7 = Math_fround(HEAPF32[i8 + (i12 * 28 | 0) + 4 >> 2]);
    if (f7 > Math_fround(9.99999974e-06)) {
     if (!i12) f6 = Math_fround(1.0); else f6 = Math_fround(HEAPF32[i8 + ((i12 + -1 | 0) * 28 | 0) >> 2]);
     HEAPF32[i9 >> 2] = Math_fround(f11 - Math_fround(f21 / Math_fround(f10 + Math_fround(f7 * Math_fround(f6 - f10)))));
    }
   } while (0);
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= ((i4 - i2 | 0) / 28 | 0) >>> 0) break; else i8 = i2;
  }
 } else {
  i3 = (i4 - i2 | 0) / 28 | 0;
  i2 = 0;
  f1 = Math_fround(0.0);
  do {
   f11 = Math_fround(f21 / Math_fround(HEAPF32[i8 + (i2 * 28 | 0) >> 2]));
   f1 = f11 < f1 ? f1 : f11;
   HEAPF32[i19 + (i20 * 96 | 0) + 24 + (i2 << 2) >> 2] = f11;
   HEAPF32[i19 + (i20 * 96 | 0) + 56 + (i2 << 2) >> 2] = Math_fround(0.0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 i20 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i18 >> 2] = i20;
 STACKTOP = i22;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl17CreateDynamicFontERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 28 | 0;
 i4 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i11 = i12 + 24 | 0;
 i8 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 944940 | 0, 859) | 0;
 i13 = gb + 63520 | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN13TextRendering4FontC2E10MemLabelId18ObjectCreationMode(i8, i5, 0);
 __Z19pop_allocation_rootv();
 i8 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i8) | 0;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 944940 | 0, 860) | 0;
 i2 = gb + 63520 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i9;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i9 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 944940 | 0, 861) | 0;
 i13 = gb + 63520 | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN8MaterialC2E10MemLabelId18ObjectCreationMode(i9, i5, 0);
 __Z19pop_allocation_rootv();
 i9 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i9) | 0;
 i10 = HEAP32[i8 + 48 >> 2] | 0;
 __Z16SmartResetObjectR6Object(i8);
 __Z16SmartResetObjectR6Object(i4);
 __Z16SmartResetObjectR6Object(i9);
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i6 + 4 >> 2] | 0)) if (!i4) {
  i1 = 0;
  i2 = i4;
 } else {
  i2 = i4;
  i3 = 13;
 } else {
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
  } else {
   i3 = i2;
   i1 = i1 & 255;
  };
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } else {
   i3 = i1;
   i1 = i2 & 255;
  };
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } else {
   i3 = i1;
   i1 = i2 & 255;
  };
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i2 = i4;
  i3 = 13;
 }
 if ((i3 | 0) == 13) i1 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 if (!i9) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i8 + 40 >> 2] = i1;
 HEAP32[i8 + 36 >> 2] = (i7 | 0) > 500 ? 500 : i7;
 HEAP32[i10 + 32 >> 2] = -2;
 __ZN20TextRenderingPrivate8FontImpl12SetFontNamesERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE(i10, i6);
 __ZN20TextRenderingPrivate8FontImpl16SetupDynamicFontEv(i10);
 __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i10) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1008101 | 0, 11);
 __ZN8Material9SetShaderEP6Shader(i9, __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i5) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 HEAP32[i11 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i11, gb + 1046318 | 0);
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i9, i5, i2);
 STACKTOP = i12;
 return i8 | 0;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i20, i10, i11, i1, i12) {
 i20 = i20 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21;
 HEAP32[i20 >> 2] = gb + 114136 + 8;
 i19 = i20 + 4 | 0;
 HEAP32[i19 >> 2] = i10;
 i6 = i20 + 8 | 0;
 HEAP32[i6 >> 2] = i19;
 i2 = i20 + 12 | 0;
 HEAP32[i2 >> 2] = gb + 740687;
 i7 = i20 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i20 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i20 + 24 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i20 + 28 >> 2] = i19;
 i19 = i20 + 32 | 0;
 HEAP32[i19 >> 2] = 0;
 i16 = i20 + 36 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i20 + 40 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i20 + 44 >> 2] = i1;
 i13 = i20 + 72 | 0;
 HEAP32[i13 >> 2] = 0;
 i18 = i20 + 76 | 0;
 HEAP8[i18 >> 0] = 0;
 HEAP32[i20 + 80 >> 2] = i6;
 i1 = i1 + 68 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3;
 i5 = (HEAP32[i8 >> 2] | 0) - i4 | 0;
 if (((HEAP32[i9 >> 2] | 0) - i4 | 0) >>> 0 <= i1 >>> 0) {
  i4 = i1 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i2 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i5 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i6 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
   }
  }
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i2 + i5;
  HEAP32[i9 >> 2] = i2 + i4;
 }
 i1 = i20 + 88 | 0;
 i2 = i1 + 24 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i4 = i20 + 132 | 0;
 HEAP32[i20 >> 2] = gb + 114164 + 8;
 HEAP32[i20 + 116 >> 2] = gb + 114164 + 112;
 HEAP32[i20 + 120 >> 2] = gb + 114164 + 168;
 HEAP32[i20 + 124 >> 2] = gb + 114164 + 188;
 HEAP32[i20 + 128 >> 2] = gb + 114164 + 228;
 HEAP32[i4 >> 2] = gb + 114164 + 248;
 HEAP32[i20 + 136 >> 2] = i11;
 i3 = i20 + 140 | 0;
 HEAP32[i3 >> 2] = i10;
 i1 = i20 + 144 | 0;
 HEAP32[i1 >> 2] = i3;
 i11 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i10 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i11 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i11 | 0, gb + 766896 | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i20 + 148 >> 2] = i11;
 __ZN5physx6shdfnd9MutexImplC2Ev(i11);
 HEAP32[i20 + 152 >> 2] = i3;
 HEAP32[i20 + 156 >> 2] = 0;
 HEAP32[i20 + 160 >> 2] = 0;
 HEAP32[i20 + 164 >> 2] = 0;
 i11 = i20 + 168 | 0;
 HEAP32[i11 >> 2] = i3;
 i10 = i20 + 172 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAPF32[i20 + 196 >> 2] = Math_fround(.75);
 HEAP32[i20 + 200 >> 2] = -1;
 HEAP32[i20 + 204 >> 2] = 0;
 HEAP32[i20 + 208 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, 64);
 i11 = i20 + 212 | 0;
 HEAP32[i11 >> 2] = i3;
 i10 = i20 + 216 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAPF32[i20 + 240 >> 2] = Math_fround(.75);
 HEAP32[i20 + 244 >> 2] = -1;
 HEAP32[i20 + 248 >> 2] = 0;
 HEAP32[i20 + 252 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, 64);
 HEAP32[i20 + 256 >> 2] = 0;
 HEAP32[i20 + 260 >> 2] = i3;
 HEAP32[i20 + 264 >> 2] = 0;
 HEAP32[i20 + 268 >> 2] = 0;
 HEAP32[i20 + 272 >> 2] = 0;
 HEAP8[i20 + 276 >> 0] = 0;
 HEAP32[i20 + 280 >> 2] = 0;
 HEAP32[i13 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 if (!i3) i14 = 13; else {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  i2 = 0;
  do {
   __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb(i20, HEAP32[i1 + (i2 << 3) >> 2] | 0, HEAP16[i1 + (i2 << 3) + 4 >> 1] | 0, (HEAP8[i1 + (i2 << 3) + 6 >> 0] | 0) != 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = 1;
  } else i14 = 13;
 }
 if ((i14 | 0) == 13) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 + 4 >> 2] | 0);
  i3 = 0;
 }
 HEAP32[i15 >> 2] = i4;
 i2 = HEAP32[i16 >> 2] | 0;
 if ((HEAP32[i17 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i16 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i20 + 28 | 0, i15) | 0;
 HEAP8[i18 >> 0] = 1;
 if (i3) {
  STACKTOP = i21;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i21;
 return;
}

function __ZN14PhysicsManager19GetPerformanceStatsER12PhysicsStats(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0, i63 = 0, i64 = 0, i65 = 0, i66 = 0, i67 = 0, i68 = 0, i69 = 0, i70 = 0, i71 = 0, i72 = 0, i73 = 0, i74 = 0, i75 = 0, i76 = 0, i77 = 0, i78 = 0, i79 = 0, i80 = 0, i81 = 0, i82 = 0, i83 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZN5physx22PxSimulationStatisticsC2Ev(i3);
 i4 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 312 >> 2] | 0, i4 | 0, i3 | 0);
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 8 >> 2];
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 48 >> 2];
 i59 = HEAP32[i3 + 88 >> 2] | 0;
 i58 = HEAP32[i3 + 284 >> 2] | 0;
 i57 = HEAP32[i3 + 676 >> 2] | 0;
 i60 = HEAP32[i3 + 92 >> 2] | 0;
 i56 = HEAP32[i3 + 288 >> 2] | 0;
 i55 = HEAP32[i3 + 680 >> 2] | 0;
 i61 = HEAP32[i3 + 96 >> 2] | 0;
 i54 = HEAP32[i3 + 292 >> 2] | 0;
 i53 = HEAP32[i3 + 684 >> 2] | 0;
 i62 = HEAP32[i3 + 100 >> 2] | 0;
 i52 = HEAP32[i3 + 296 >> 2] | 0;
 i51 = HEAP32[i3 + 688 >> 2] | 0;
 i63 = HEAP32[i3 + 104 >> 2] | 0;
 i50 = HEAP32[i3 + 300 >> 2] | 0;
 i49 = HEAP32[i3 + 692 >> 2] | 0;
 i64 = HEAP32[i3 + 108 >> 2] | 0;
 i48 = HEAP32[i3 + 304 >> 2] | 0;
 i47 = HEAP32[i3 + 696 >> 2] | 0;
 i65 = HEAP32[i3 + 112 >> 2] | 0;
 i46 = HEAP32[i3 + 308 >> 2] | 0;
 i45 = HEAP32[i3 + 700 >> 2] | 0;
 i8 = i57 + i55 + i53 + i51 + i49 + i47 + i45 | 0;
 HEAP32[i4 >> 2] = i8;
 i66 = HEAP32[i3 + 120 >> 2] | 0;
 i44 = HEAP32[i3 + 316 >> 2] | 0;
 i43 = HEAP32[i3 + 708 >> 2] | 0;
 i67 = HEAP32[i3 + 124 >> 2] | 0;
 i42 = HEAP32[i3 + 320 >> 2] | 0;
 i41 = HEAP32[i3 + 712 >> 2] | 0;
 i68 = HEAP32[i3 + 128 >> 2] | 0;
 i40 = HEAP32[i3 + 324 >> 2] | 0;
 i39 = HEAP32[i3 + 716 >> 2] | 0;
 i69 = HEAP32[i3 + 132 >> 2] | 0;
 i38 = HEAP32[i3 + 328 >> 2] | 0;
 i37 = HEAP32[i3 + 720 >> 2] | 0;
 i70 = HEAP32[i3 + 136 >> 2] | 0;
 i36 = HEAP32[i3 + 332 >> 2] | 0;
 i35 = HEAP32[i3 + 724 >> 2] | 0;
 i71 = HEAP32[i3 + 140 >> 2] | 0;
 i34 = HEAP32[i3 + 336 >> 2] | 0;
 i33 = HEAP32[i3 + 728 >> 2] | 0;
 i8 = i8 + i43 + i41 + i39 + i37 + i35 + i33 | 0;
 HEAP32[i4 >> 2] = i8;
 i72 = HEAP32[i3 + 152 >> 2] | 0;
 i32 = HEAP32[i3 + 348 >> 2] | 0;
 i31 = HEAP32[i3 + 740 >> 2] | 0;
 i73 = HEAP32[i3 + 156 >> 2] | 0;
 i30 = HEAP32[i3 + 352 >> 2] | 0;
 i29 = HEAP32[i3 + 744 >> 2] | 0;
 i74 = HEAP32[i3 + 160 >> 2] | 0;
 i28 = HEAP32[i3 + 356 >> 2] | 0;
 i27 = HEAP32[i3 + 748 >> 2] | 0;
 i75 = HEAP32[i3 + 164 >> 2] | 0;
 i26 = HEAP32[i3 + 360 >> 2] | 0;
 i25 = HEAP32[i3 + 752 >> 2] | 0;
 i76 = HEAP32[i3 + 168 >> 2] | 0;
 i24 = HEAP32[i3 + 364 >> 2] | 0;
 i23 = HEAP32[i3 + 756 >> 2] | 0;
 i8 = i8 + i31 + i29 + i27 + i25 + i23 | 0;
 HEAP32[i4 >> 2] = i8;
 i77 = HEAP32[i3 + 184 >> 2] | 0;
 i22 = HEAP32[i3 + 380 >> 2] | 0;
 i21 = HEAP32[i3 + 772 >> 2] | 0;
 i78 = HEAP32[i3 + 188 >> 2] | 0;
 i20 = HEAP32[i3 + 384 >> 2] | 0;
 i19 = HEAP32[i3 + 776 >> 2] | 0;
 i79 = HEAP32[i3 + 192 >> 2] | 0;
 i18 = HEAP32[i3 + 388 >> 2] | 0;
 i17 = HEAP32[i3 + 780 >> 2] | 0;
 i80 = HEAP32[i3 + 196 >> 2] | 0;
 i16 = HEAP32[i3 + 392 >> 2] | 0;
 i15 = HEAP32[i3 + 784 >> 2] | 0;
 i8 = i8 + i21 + i19 + i17 + i15 | 0;
 HEAP32[i4 >> 2] = i8;
 i81 = HEAP32[i3 + 216 >> 2] | 0;
 i14 = HEAP32[i3 + 412 >> 2] | 0;
 i13 = HEAP32[i3 + 804 >> 2] | 0;
 i82 = HEAP32[i3 + 220 >> 2] | 0;
 i12 = HEAP32[i3 + 416 >> 2] | 0;
 i11 = HEAP32[i3 + 808 >> 2] | 0;
 i83 = HEAP32[i3 + 224 >> 2] | 0;
 i10 = HEAP32[i3 + 420 >> 2] | 0;
 i9 = HEAP32[i3 + 812 >> 2] | 0;
 i8 = i8 + i13 + i11 + i9 | 0;
 HEAP32[i4 >> 2] = i8;
 i7 = HEAP32[i3 + 836 >> 2] | 0;
 i6 = HEAP32[i3 + 840 >> 2] | 0;
 i5 = HEAP32[i3 + 868 >> 2] | 0;
 i3 = (HEAP32[i3 + 280 >> 2] | 0) + ((HEAP32[i3 + 252 >> 2] | 0) + ((HEAP32[i3 + 248 >> 2] | 0) + (i83 + (i82 + (i81 + (i80 + (i79 + (i78 + (i77 + (i76 + (i75 + (i74 + (i73 + (i72 + (i71 + (i70 + (i69 + (i68 + (i67 + (i66 + (i65 + (i64 + (i63 + (i62 + (i61 + (i60 + (i59 + i58 + i57) + i56 + i55) + i54 + i53) + i52 + i51) + i50 + i49) + i48 + i47) + i46 + i45) + i44 + i43) + i42 + i41) + i40 + i39) + i38 + i37) + i36 + i35) + i34 + i33) + i32 + i31) + i30 + i29) + i28 + i27) + i26 + i25) + i24 + i23) + i22 + i21) + i20 + i19) + i18 + i17) + i16 + i15) + i14 + i13) + i12 + i11) + i10 + i9) + (HEAP32[i3 + 444 >> 2] | 0) + i7) + (HEAP32[i3 + 448 >> 2] | 0) + i6) + (HEAP32[i3 + 476 >> 2] | 0) + i5 | 0;
 HEAP32[i4 >> 2] = i8 + i7 + i6 + i5;
 HEAP32[i2 + 8 >> 2] = i3;
 STACKTOP = i1;
 return;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_(i4, i9, i2, i15, i12, i5, i10, i13) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i3 = i2;
 while (1) {
  if ((i3 | 0) == (i15 | 0)) {
   i3 = i15;
   break;
  }
  if (!(HEAP8[i3 >> 0] | 0)) break;
  i3 = i3 + 1 | 0;
 }
 HEAP32[i13 >> 2] = i5;
 HEAP32[i12 >> 2] = i2;
 i8 = i10;
 i11 = i4 + 8 | 0;
 i4 = i5;
 while (1) {
  if ((i4 | 0) == (i10 | 0) | (i2 | 0) == (i15 | 0)) {
   i1 = i2;
   i5 = 51;
   break;
  }
  i5 = i9;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i14;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i7 = i3;
  i6 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
  __THREW__ = 0;
  i5 = invoke_iiiiii(fb + 189 | 0, i4 | 0, i12 | 0, i7 - i2 | 0, i8 - i4 >> 2 | 0, i9 | 0) | 0;
  i17 = __THREW__;
  __THREW__ = 0;
  if (i17 & 1) {
   i5 = 11;
   break;
  }
  if (i6 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i6 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 10;
    break;
   }
  }
  if ((i5 | 0) == -1) {
   i3 = i4;
   i5 = 16;
   break;
  }
  i4 = (HEAP32[i13 >> 2] | 0) + (i5 << 2) | 0;
  HEAP32[i13 >> 2] = i4;
  if ((i4 | 0) == (i10 | 0)) {
   i5 = 48;
   break;
  }
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i3 | 0) == (i15 | 0)) i3 = i15; else {
   i3 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i2 = invoke_iiiii(fb + 210 | 0, i4 | 0, i2 | 0, 1, i9 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 38;
    break;
   }
   if (i3 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i5 = 37;
     break;
    }
   }
   if (i2 | 0) {
    i1 = 2;
    i5 = 47;
    break;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
   i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
   HEAP32[i12 >> 2] = i2;
   i3 = i2;
   while (1) {
    if ((i3 | 0) == (i15 | 0)) {
     i3 = i15;
     break;
    }
    if (!(HEAP8[i3 >> 0] | 0)) break;
    i3 = i3 + 1 | 0;
   }
   i4 = HEAP32[i13 >> 2] | 0;
  }
 }
 do if ((i5 | 0) == 10) {
  i17 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i17);
 } else if ((i5 | 0) == 11) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i6 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i6 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i17 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i17);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i5 | 0) == 16) {
  L30 : while (1) {
   HEAP32[i13 >> 2] = i3;
   if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) {
    i5 = 31;
    break;
   }
   i4 = _uselocale(HEAP32[i11 >> 2] | 0) | 0;
   __THREW__ = 0;
   i3 = invoke_iiiii(fb + 210 | 0, i3 | 0, i2 | 0, i7 - i2 | 0, i14 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i5 = 21;
    break;
   }
   if (i4 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i5 = 20;
     break;
    }
   }
   switch (i3 | 0) {
   case -1:
    {
     i5 = 27;
     break L30;
    }
   case -2:
    {
     i5 = 28;
     break L30;
    }
   case 0:
    {
     i2 = i2 + 1 | 0;
     break;
    }
   default:
    i2 = i2 + i3 | 0;
   }
   i3 = (HEAP32[i13 >> 2] | 0) + 4 | 0;
   i5 = 16;
  }
  if ((i5 | 0) == 20) {
   i17 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i17);
  } else if ((i5 | 0) == 21) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (i4 | 0) {
    __THREW__ = 0;
    invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i17 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i17);
    }
   }
   ___resumeException(i1 | 0);
  } else if ((i5 | 0) == 27) {
   HEAP32[i12 >> 2] = i2;
   i1 = 2;
   i5 = 47;
   break;
  } else if ((i5 | 0) == 28) {
   HEAP32[i12 >> 2] = i2;
   i1 = 1;
   i5 = 47;
   break;
  } else if ((i5 | 0) == 31) {
   HEAP32[i12 >> 2] = i2;
   i1 = (i2 | 0) != (i15 | 0) & 1;
   i5 = 47;
   break;
  }
 } else if ((i5 | 0) == 37) {
  i17 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i17);
 } else if ((i5 | 0) == 38) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i17 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i17);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i5 | 0) == 48) {
  i1 = HEAP32[i12 >> 2] | 0;
  i5 = 51;
 } while (0);
 if ((i5 | 0) != 47) if ((i5 | 0) == 51) i1 = (i1 | 0) != (i15 | 0) & 1;
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i5, i1, i4, i17) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 32 | 0;
 i18 = i21;
 i14 = i21 + 24 | 0;
 i15 = i21 + 16 | 0;
 i16 = i21 + 8 | 0;
 i7 = i1;
 i6 = i5;
 i3 = i7 - i6 | 0;
 i2 = (i3 | 0) > 6572;
 if ((i4 | 0) > 0 & i2) {
  i11 = i18 + 4 | 0;
  i13 = i17;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i10 = i7;
  do {
   i7 = i14;
   HEAP32[i7 >> 2] = i12;
   HEAP32[i7 + 4 >> 2] = i13;
   HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   __ZN14qsort_internal14_Partition3WayIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEENSt3__24pairIT_S7_EES7_S7_T0_T1_(i18, i5, i1, (i3 | 0) / 212 | 0, i20);
   i4 = ((i4 | 0) / 2 | 0) + ((i4 | 0) / 4 | 0) | 0;
   i7 = (HEAP32[i11 >> 2] | 0) + 212 | 0;
   i3 = (i7 - i6 | 0) / 212 | 0;
   i6 = HEAP32[i18 >> 2] | 0;
   i2 = (i10 - i6 | 0) / 212 | 0;
   if ((i3 | 0) < (i2 | 0)) {
    i19 = i15;
    HEAP32[i19 >> 2] = i12;
    HEAP32[i19 + 4 >> 2] = i13;
    HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i5, i7, i3, i20);
    i5 = HEAP32[i18 >> 2] | 0;
   } else {
    i19 = i16;
    HEAP32[i19 >> 2] = i12;
    HEAP32[i19 + 4 >> 2] = i13;
    HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i6, i1, i2, i20);
    i1 = (HEAP32[i11 >> 2] | 0) + 212 | 0;
   }
   i10 = i1;
   i6 = i5;
   i3 = i10 - i6 | 0;
   i2 = (i3 | 0) > 6572;
  } while ((i4 | 0) > 0 & i2);
  i19 = i5;
 } else i19 = i5;
 if (i2) {
  i5 = i17;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i20;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = (i3 >>> 0) / 212 | 0;
  i3 = (i2 + -2 | 0) / 2 | 0;
  while (1) {
   __ZNSt3__211__sift_downIRN22MotionVectorRenderLoop18RenderObjectSorterEP18RPDataMotionVectorEEvT0_S6_T_NS_15iterator_traitsIS6_E15difference_typeES6_(i19, i1, i20, i2, i19 + (i3 * 212 | 0) | 0);
   if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else break;
  }
  i17 = i18;
  HEAP32[i17 >> 2] = i4;
  HEAP32[i17 + 4 >> 2] = i5;
  do {
   i1 = i1 + -212 | 0;
   _memcpy(i20 | 0, i19 | 0, 212) | 0;
   _memcpy(i19 | 0, i1 | 0, 212) | 0;
   _memcpy(i1 | 0, i20 | 0, 212) | 0;
   i2 = i2 + -1 | 0;
   __ZNSt3__211__sift_downIRN22MotionVectorRenderLoop18RenderObjectSorterEP18RPDataMotionVectorEEvT0_S6_T_NS_15iterator_traitsIS6_E15difference_typeES6_(i19, i1, i18, i2, i19);
  } while ((i2 | 0) > 1);
  STACKTOP = i21;
  return;
 }
 if (!(i19 >>> 0 < i1 >>> 0 & (i3 | 0) > 212)) {
  STACKTOP = i21;
  return;
 }
 i14 = HEAP32[i17 >> 2] | 0;
 i13 = i14 + 12 | 0;
 i14 = i14 + 8 | 0;
 i10 = i19;
 do {
  L25 : do if (i10 >>> 0 > i19 >>> 0) {
   i11 = i10;
   do {
    i12 = i11;
    i11 = i11 + -212 | 0;
    i15 = HEAP32[i12 + 16 >> 2] | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    i16 = HEAP32[i12 + -196 >> 2] | 0;
    i5 = HEAP32[i4 + (i15 << 5) + 8 >> 2] | 0;
    i6 = HEAP32[HEAP32[(HEAP32[i14 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
    i7 = HEAP32[i4 + (i16 << 5) + 8 >> 2] | 0;
    i2 = HEAP32[i6 + (i5 * 360 | 0) + 184 >> 2] | 0;
    i3 = HEAP32[i6 + (i7 * 360 | 0) + 184 >> 2] | 0;
    do if ((i2 | 0) == (i3 | 0)) {
     i2 = HEAP16[i4 + (i15 << 5) + 12 >> 1] | 0;
     i3 = HEAP16[i4 + (i16 << 5) + 12 >> 1] | 0;
     if (i2 << 16 >> 16 != i3 << 16 >> 16) if (i2 << 16 >> 16 < i3 << 16 >> 16) break; else break L25;
     f8 = Math_fround(HEAPF32[i4 + (i15 << 5) + 20 >> 2]);
     i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
     f9 = Math_fround(HEAPF32[i4 + (i16 << 5) + 20 >> 2]);
     i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
     if ((i2 | 0) != (i3 | 0)) if (i2 >>> 0 < i3 >>> 0) break; else break L25;
     i3 = HEAP32[i4 + (i15 << 5) + 28 >> 2] | 0;
     i2 = HEAP32[i4 + (i16 << 5) + 28 >> 2] | 0;
     if ((i3 | 0) != (i2 | 0)) if (i3 >>> 0 > i2 >>> 0) break; else break L25;
     if (f8 != f9) if (f8 > f9) break; else break L25;
     i3 = HEAP16[i6 + (i5 * 360 | 0) + 270 >> 1] | 0;
     i2 = HEAP16[i6 + (i7 * 360 | 0) + 270 >> 1] | 0;
     if (i3 << 16 >> 16 == i2 << 16 >> 16) if ((i15 | 0) < (i16 | 0)) break; else break L25; else if ((i3 & 65535) > (i2 & 65535)) break; else break L25;
    } else if (i2 >>> 0 >= i3 >>> 0) break L25; while (0);
    _memcpy(i20 | 0, i12 | 0, 212) | 0;
    _memcpy(i12 | 0, i11 | 0, 212) | 0;
    _memcpy(i11 | 0, i20 | 0, 212) | 0;
   } while (i11 >>> 0 > i19 >>> 0);
  } while (0);
  i10 = i10 + 212 | 0;
 } while (i10 >>> 0 < i1 >>> 0);
 STACKTOP = i21;
 return;
}

function __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_(i20, i17, i2, i11, i3) {
 i20 = i20 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, f23 = f0;
 i21 = i20 + 60 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i11 + 12 | 0;
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f12 = Math_fround(HEAPF32[i22 >> 2]);
 f15 = Math_fround(f13 * f12);
 f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(f1 * f4));
 f15 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f15);
 f4 = Math_fround(Math_fround(f12 * f1) + Math_fround(f13 * f4));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i2 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f1 = Math_fround(f15 * f13);
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f4 * f12));
 f12 = Math_fround(Math_fround(f13 * f4) - Math_fround(f15 * f12));
 i18 = HEAP32[i17 + 12 >> 2] | 0;
 i19 = HEAP32[i17 + 16 >> 2] | 0;
 i2 = HEAP32[i17 + 20 >> 2] | 0;
 i3 = HEAP32[i17 + 24 >> 2] | 0;
 f15 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f15 - f4);
 f16 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f16 - f5);
 f7 = Math_fround(Math_fround(f13 * Math_fround(f15 - f1)) + Math_fround(f6 * Math_fround(f16 - f12)));
 f8 = Math_fround(f1 - f4);
 f9 = Math_fround(f12 - f5);
 f10 = Math_fround(Math_fround(f8 * f13) + Math_fround(f9 * f6));
 f14 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i11 + 8 >> 2]));
 if (f10 <= Math_fround(0.0)) {
  if (Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) > Math_fround(f14 * f14)) return;
  if (HEAP8[i17 + 44 >> 0] | 0) {
   f16 = Math_fround(HEAPF32[i17 + 28 >> 2]);
   if (Math_fround(Math_fround(Math_fround(f4 - f1) * Math_fround(f4 - f16)) + Math_fround(Math_fround(f5 - f12) * Math_fround(f5 - Math_fround(HEAPF32[i17 + 32 >> 2])))) > Math_fround(0.0)) return;
  }
  HEAP32[i21 >> 2] = 1;
  HEAP32[i20 + 56 >> 2] = 0;
  HEAPF32[i20 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i20 + 48 >> 2] = i18;
  HEAP32[i20 + 52 >> 2] = i19;
  i19 = i20 + 16 | 0;
  HEAP8[i19 >> 0] = 0;
  HEAP8[i19 + 1 >> 0] = 0;
  HEAP8[i19 + 2 >> 0] = 0;
  HEAP8[i19 + 3 >> 0] = 0;
  i19 = i22;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i22 = i20;
  HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i22 + 4 >> 2] = i21;
  return;
 }
 if (!(f7 <= Math_fround(0.0))) {
  f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f13 * f13) + Math_fround(f6 * f6)));
  f15 = Math_fround(f1 - Math_fround(f23 * Math_fround(Math_fround(f4 * f7) + Math_fround(f15 * f10))));
  f16 = Math_fround(f12 - Math_fround(f23 * Math_fround(Math_fround(f5 * f7) + Math_fround(f16 * f10))));
  if (Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) > Math_fround(f14 * f14)) return;
  f4 = Math_fround(-f6);
  i17 = Math_fround(Math_fround(f9 * f13) + Math_fround(f8 * f4)) < Math_fround(0.0);
  f1 = Math_fround(-f13);
  f4 = i17 ? f6 : f4;
  f1 = i17 ? f1 : f13;
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f1 * f1))));
  if (!(f5 < Math_fround(1.1920929e-07))) {
   f23 = Math_fround(Math_fround(1.0) / f5);
   f4 = Math_fround(f4 * f23);
   f1 = Math_fround(f1 * f23);
  }
  HEAP32[i21 >> 2] = 1;
  HEAP32[i20 + 56 >> 2] = 1;
  HEAPF32[i20 + 40 >> 2] = f4;
  HEAPF32[i20 + 44 >> 2] = f1;
  HEAP32[i20 + 48 >> 2] = i18;
  HEAP32[i20 + 52 >> 2] = i19;
  i19 = i20 + 16 | 0;
  HEAP8[i19 >> 0] = 0;
  HEAP8[i19 + 1 >> 0] = 0;
  HEAP8[i19 + 2 >> 0] = 1;
  HEAP8[i19 + 3 >> 0] = 0;
  i19 = i22;
  i21 = HEAP32[i19 + 4 >> 2] | 0;
  i22 = i20;
  HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i22 + 4 >> 2] = i21;
  return;
 }
 f4 = Math_fround(f1 - f15);
 f1 = Math_fround(f12 - f16);
 if (Math_fround(Math_fround(f4 * f4) + Math_fround(f1 * f1)) > Math_fround(f14 * f14)) return;
 if (HEAP8[i17 + 45 >> 0] | 0) {
  f23 = Math_fround(HEAPF32[i17 + 36 >> 2]);
  if (Math_fround(Math_fround(f4 * Math_fround(f23 - f15)) + Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i17 + 40 >> 2]) - f16))) > Math_fround(0.0)) return;
 }
 HEAP32[i21 >> 2] = 1;
 HEAP32[i20 + 56 >> 2] = 0;
 HEAPF32[i20 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i20 + 48 >> 2] = i2;
 HEAP32[i20 + 52 >> 2] = i3;
 i19 = i20 + 16 | 0;
 HEAP8[i19 >> 0] = 1;
 HEAP8[i19 + 1 >> 0] = 0;
 HEAP8[i19 + 2 >> 0] = 0;
 HEAP8[i19 + 3 >> 0] = 0;
 i19 = i22;
 i21 = HEAP32[i19 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 return;
}

function __ZN5physx7NpShape17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i2 + 288 | 0;
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i12 >> 2] = HEAP32[gb + 124516 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 124516 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 124516 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 124516 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[gb + 124516 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[gb + 124516 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[gb + 124516 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[gb + 124516 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i12 | 0, 32) | 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 124548 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 124548 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 124548 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 124548 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 124548 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 124548 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 124548 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 124548 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 754673;
 HEAP32[i10 + 4 >> 2] = gb + 827530;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 208;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 754673;
 HEAP32[i9 + 4 >> 2] = gb + 752142;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 208;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124580 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124580 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124580 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124580 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124580 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124580 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124580 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124580 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 124612 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 124612 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 124612 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 124612 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 124612 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 124612 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 124612 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 124612 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124644 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124644 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124644 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124644 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124644 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124644 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124644 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124644 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 124676 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 124676 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 124676 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 124676 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 124676 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 124676 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 124676 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 124676 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i10, i13, i14, i12, i1) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 * f3);
 i7 = i10 + 32 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 L1 : do if (!(i1 << 24 >> 24)) i1 = 0; else {
  i8 = i10 + 44 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i14 >> 2]);
  f6 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  i1 = i1 & 255;
  i2 = 0;
  do {
   f17 = Math_fround(HEAPF32[i9 + (i2 * 48 | 0) + 16 >> 2]);
   f16 = Math_fround(HEAPF32[i9 + (i2 * 48 | 0) + 20 >> 2]);
   f17 = Math_fround(f17 - f5);
   f16 = Math_fround(f16 - f6);
   f15 = Math_fround(Math_fround(HEAPF32[i9 + (i2 * 48 | 0) + 24 >> 2]) - f4);
   if (f3 > Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f15 * f15))) {
    i1 = i2;
    i11 = 5;
    break;
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  if ((i11 | 0) == 5) {
   i11 = i9 + (i1 * 48 | 0) | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i13 = (HEAP32[i8 >> 2] | 0) + (i1 * 48 | 0) + 16 | 0;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = (HEAP32[i8 >> 2] | 0) + (i1 * 48 | 0) + 32 | 0;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i14 = 0;
   return i14 | 0;
  }
  switch (i1 | 0) {
  case 1:
  case 0:
   break L1;
  case 2:
   break;
  default:
   {
    i14 = 0;
    return i14 | 0;
   }
  }
  f15 = Math_fround(HEAPF32[i14 >> 2]);
  f16 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  i1 = i10 + 44 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f5 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f18 = Math_fround(HEAPF32[i2 + 64 >> 2]);
  f3 = Math_fround(HEAPF32[i2 + 68 >> 2]);
  f4 = Math_fround(f4 - f15);
  f5 = Math_fround(f5 - f16);
  f6 = Math_fround(f6 - f17);
  f15 = Math_fround(f18 - f15);
  f16 = Math_fround(f3 - f16);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) - f17);
  if (Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6)) > Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(f17 * f17))) {
   i11 = i2 + 48 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i13 = (HEAP32[i1 >> 2] | 0) + 64 | 0;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i14 = 0;
   return i14 | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i13 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i14 = 0;
   return i14 | 0;
  }
 } while (0);
 i11 = i10 + 44 | 0;
 i10 = (HEAP32[i11 >> 2] | 0) + (i1 * 48 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i13 = (HEAP32[i11 >> 2] | 0) + ((HEAPU8[i7 >> 0] | 0) * 48 | 0) + 16 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i14 = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = i14 + 1 << 24 >> 24;
 i14 = (HEAP32[i11 >> 2] | 0) + ((i14 & 255) * 48 | 0) + 32 | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_(i12, i11, i1, i3) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(-f8);
 f7 = Math_fround(-f7);
 f6 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(-f2);
 f4 = Math_fround(-f4);
 f5 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 i10 = i12 + ((HEAPU16[i12 + 26 >> 1] | 0) + 144) | 0;
 i3 = i12 + (HEAPU16[i12 + 10 >> 1] | 0) | 0;
 i9 = i12 + 128 + ((HEAPU16[i12 + 8 >> 1] | 0) << 6) | 0;
 if (i11) {
  i1 = i11;
  while (1) {
   f14 = Math_fround(HEAPF32[i3 + (i1 << 5) + 16 >> 2]);
   f21 = Math_fround(HEAPF32[i3 + (i1 << 5) + 20 >> 2]);
   f20 = Math_fround(HEAPF32[i3 + (i1 << 5) + 24 >> 2]);
   f19 = Math_fround(f2 + Math_fround(Math_fround(f7 * f20) - Math_fround(f6 * f21)));
   f20 = Math_fround(f4 + Math_fround(Math_fround(f6 * f14) - Math_fround(f8 * f20)));
   f14 = Math_fround(f5 + Math_fround(Math_fround(f8 * f21) - Math_fround(f7 * f14)));
   f21 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) >> 2]);
   f22 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 32 >> 2]);
   f25 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 36 >> 2]);
   f26 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 40 >> 2]);
   f16 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 64 >> 2]);
   f18 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 68 >> 2]);
   f8 = Math_fround(f8 - Math_fround(Math_fround(f21 * f19) + Math_fround(Math_fround(f20 * f24) + Math_fround(f14 * f16))));
   f7 = Math_fround(f7 - Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f20 * f25) + Math_fround(f14 * f18))));
   f6 = Math_fround(f6 - Math_fround(Math_fround(f23 * f19) + Math_fround(Math_fround(f20 * f26) + Math_fround(f14 * Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 72 >> 2])))));
   f26 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 16 >> 2]);
   f23 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 20 >> 2]);
   f18 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 24 >> 2]);
   f25 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 48 >> 2]);
   f22 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 52 >> 2]);
   f16 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 56 >> 2]);
   f24 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 80 >> 2]);
   f21 = Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 84 >> 2]);
   f2 = Math_fround(f2 - Math_fround(Math_fround(f19 * f26) + Math_fround(Math_fround(f20 * f25) + Math_fround(f14 * f24))));
   f21 = Math_fround(f4 - Math_fround(Math_fround(f19 * f23) + Math_fround(Math_fround(f20 * f22) + Math_fround(f14 * f21))));
   f16 = Math_fround(f5 - Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f20 * f16) + Math_fround(f14 * Math_fround(HEAPF32[i10 + (i1 * 160 | 0) + 88 >> 2])))));
   f18 = Math_fround(HEAPF32[i3 + (i1 << 5) >> 2]);
   f5 = Math_fround(HEAPF32[i3 + (i1 << 5) + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i3 + (i1 << 5) + 8 >> 2]);
   f2 = Math_fround(f2 + Math_fround(Math_fround(f6 * f5) - Math_fround(f7 * f4)));
   f4 = Math_fround(f21 + Math_fround(Math_fround(f8 * f4) - Math_fround(f6 * f18)));
   f5 = Math_fround(f16 + Math_fround(Math_fround(f7 * f18) - Math_fround(f8 * f5)));
   i17 = i9 + (i1 << 4) | 0;
   f18 = Math_fround(HEAPF32[i17 >> 2]);
   i15 = i9 + (i1 << 4) + 4 | 0;
   f16 = Math_fround(HEAPF32[i15 >> 2]);
   i13 = i9 + (i1 << 4) + 8 | 0;
   f16 = Math_fround(f20 + f16);
   f14 = Math_fround(f14 + Math_fround(HEAPF32[i13 >> 2]));
   HEAPF32[i17 >> 2] = Math_fround(f19 + f18);
   HEAPF32[i15 >> 2] = f16;
   HEAPF32[i13 >> 2] = f14;
   HEAPF32[i9 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
   i1 = HEAP8[i12 + 64 + i1 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break; else i1 = i1 & 255;
  }
 }
 i13 = i12 + 32 | 0;
 f26 = Math_fround(HEAPF32[i13 >> 2]);
 i17 = i12 + 36 | 0;
 f25 = Math_fround(HEAPF32[i17 >> 2]);
 i15 = i12 + 40 | 0;
 f25 = Math_fround(f7 + f25);
 f24 = Math_fround(f6 + Math_fround(HEAPF32[i15 >> 2]));
 HEAPF32[i13 >> 2] = Math_fround(f8 + f26);
 HEAPF32[i17 >> 2] = f25;
 HEAPF32[i15 >> 2] = f24;
 HEAPF32[i12 + 44 >> 2] = Math_fround(0.0);
 i15 = i12 + 48 | 0;
 f24 = Math_fround(HEAPF32[i15 >> 2]);
 i17 = i12 + 52 | 0;
 f25 = Math_fround(HEAPF32[i17 >> 2]);
 i13 = i12 + 56 | 0;
 f25 = Math_fround(f4 + f25);
 f26 = Math_fround(f5 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i15 >> 2] = Math_fround(f2 + f24);
 HEAPF32[i17 >> 2] = f25;
 HEAPF32[i13 >> 2] = f26;
 HEAPF32[i12 + 60 >> 2] = Math_fround(0.0);
 i13 = i10 + (i11 * 160 | 0) + 152 | 0;
 i17 = i12 + 16 | 0;
 i12 = i17;
 i15 = HEAP32[i12 + 4 >> 2] | HEAP32[i13 + 4 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i12 >> 2] | HEAP32[i13 >> 2];
 HEAP32[i17 + 4 >> 2] = i15;
 return;
}

function __ZN32PlaneColliderCache_dense_hashmap7ReplaceERK8Vector3fS2_S2_S2_iif(i11, i1, i2, i20, i21, i22, i23, f4) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 f4 = Math_fround(f4);
 var i3 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i24 = 0, f25 = f0, i26 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i24;
 i10 = i24 + 40 | 0;
 f6 = Math_fround(f4 * Math_fround(4.0));
 HEAP32[i9 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 >> 2]) / f4)));
 HEAP32[i9 + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) / f6)));
 HEAP32[i9 + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f4)));
 i3 = __Z13MurmurHash64APKviy(i9, 12, 409413374, -559038737) | 0;
 i19 = getTempRet0() | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(Math_abs(Math_fround(f6)));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(Math_abs(Math_fround(f7)));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(Math_abs(Math_fround(f5)));
 do if (!(f25 >= f8) | !(f25 >= f4)) if (!(f8 >= f4)) {
  i1 = f5 > Math_fround(0.0);
  i1 = i1 ? 4 : 5;
  break;
 } else {
  i1 = f7 > Math_fround(0.0);
  i1 = i1 ? 2 : 3;
  break;
 } else i1 = !(f6 > Math_fround(0.0)) & 1; while (0);
 i17 = i1 ^ i3;
 i1 = i11 + 104 | 0;
 i16 = i11 + 4 | 0;
 i18 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i3 = HEAP32[i20 + 4 >> 2] | 0;
 i12 = HEAP32[i20 + 8 >> 2] | 0;
 i13 = HEAP32[i21 >> 2] | 0;
 i14 = HEAP32[i21 + 4 >> 2] | 0;
 i15 = HEAP32[i21 + 8 >> 2] | 0;
 i26 = i9;
 HEAP32[i26 >> 2] = i17;
 HEAP32[i26 + 4 >> 2] = i19;
 HEAP32[i9 + 8 >> 2] = i2;
 HEAP32[i9 + 12 >> 2] = i3;
 HEAP32[i9 + 16 >> 2] = i12;
 HEAP32[i9 + 20 >> 2] = i13;
 HEAP32[i9 + 24 >> 2] = i14;
 HEAP32[i9 + 28 >> 2] = i15;
 i15 = i9 + 32 | 0;
 HEAP32[i15 >> 2] = i22;
 HEAP32[i15 + 4 >> 2] = i23;
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i11, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E15insert_noresizeERKS4_(i10, i11, i9);
 i1 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i16 >> 2] | 0;
 if ((i18 | 0) < (i1 - i10 | 0)) {
  i26 = 1;
  STACKTOP = i24;
  return i26 | 0;
 }
 if ((i1 | 0) == (i10 | 0)) {
  i2 = HEAP32[i11 + 96 >> 2] | 0;
  i1 = HEAP32[i11 + 100 >> 2] | 0;
  i3 = i2 + (i1 * 40 | 0) | 0;
 } else {
  i18 = HEAP32[i11 + 100 >> 2] | 0;
  i14 = i18 + -1 | 0;
  i1 = i14 & i19;
  i2 = HEAP32[i11 + 96 >> 2] | 0;
  i16 = i11 + 56 | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i3 = i2 + (i1 * 40 | 0) | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  L14 : do if ((i15 | 0) == (i13 | 0) & (i16 | 0) == (i3 | 0)) i1 = -1; else {
   i9 = i11 + 16 | 0;
   if (!(HEAP8[i11 + 8 >> 0] | 0)) {
    i10 = 0;
    i9 = i13;
    while (1) {
     if ((i17 | 0) == (i9 | 0) & (i19 | 0) == (i3 | 0)) break L14;
     i10 = i10 + 1 | 0;
     i1 = i10 + i1 & i14;
     i3 = i2 + (i1 * 40 | 0) | 0;
     i9 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i3 | 0)) {
      i1 = -1;
      break L14;
     }
    }
   }
   if (!i10) {
    i10 = 0;
    i9 = i13;
    while (1) {
     if ((i17 | 0) == (i9 | 0) & (i19 | 0) == (i3 | 0)) break L14;
     i10 = i10 + 1 | 0;
     i1 = i10 + i1 & i14;
     i3 = i2 + (i1 * 40 | 0) | 0;
     i9 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i3 | 0)) {
      i1 = -1;
      break L14;
     }
    }
   }
   i12 = i9;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = 0;
   i9 = i13;
   while (1) {
    if (((i11 | 0) != (i9 | 0) | (i12 | 0) != (i3 | 0)) & ((i17 | 0) == (i9 | 0) & (i19 | 0) == (i3 | 0))) break L14;
    i10 = i10 + 1 | 0;
    i1 = i10 + i1 & i14;
    i3 = i2 + (i1 * 40 | 0) | 0;
    i9 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i3 = (i1 | 0) == -1 ? i2 + (i18 * 40 | 0) | 0 : i2 + (i1 * 40 | 0) | 0;
  i1 = i18;
 }
 if ((i3 | 0) == (i2 + (i1 * 40 | 0) | 0)) {
  i26 = 0;
  STACKTOP = i24;
  return i26 | 0;
 }
 i26 = i3 + 8 | 0;
 HEAP32[i26 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 i26 = i3 + 20 | 0;
 HEAP32[i26 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i3 + 32 >> 2] = i22;
 HEAP32[i3 + 36 >> 2] = i23;
 i26 = 1;
 STACKTOP = i24;
 return i26 | 0;
}

function __ZN17PersistentManager9AddStreamEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 20 | 0;
 i14 = i16;
 i2 = i13 + 4 | 0;
 i3 = i15 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i13 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i13 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 8, i13 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 8, i13 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i9 = (HEAP32[i2 >> 2] | 0) + (i4 * 24 | 0) | 0;
 HEAP32[i9 >> 2] = 0;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 i9 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i14 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = i9;
 i9 = i13 + 28 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i13 + 32 >> 2] | 0)) __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE21__push_back_slow_pathIKS9_EEvRT_(i13 + 24 | 0, i14); else {
  i5 = i4 + 4 | 0;
  i6 = i14 + 4 | 0;
  i1 = HEAP32[i14 + 16 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  i10 = i4 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i2 = i4 + 16 | 0;
  HEAP32[i2 >> 2] = i1;
  i3 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
  i7 = i3 >> 3;
  if (i7 | 0) {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 37;
   HEAP32[i15 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i4 + 12 >> 2] = i3 + (i7 << 3);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i2 >> 3 << 3);
   }
  }
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 20;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i11 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i15 >> 2] = 37;
  HEAP32[i15 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 }
 i10 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i14 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = i10;
 i10 = i13 + 44 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 if ((i7 | 0) == (HEAP32[i13 + 48 >> 2] | 0)) __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE21__push_back_slow_pathIKS9_EEvRT_(i13 + 40 | 0, i14); else {
  i5 = i7 + 4 | 0;
  i6 = i14 + 4 | 0;
  i1 = HEAP32[i14 + 16 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  i8 = i7 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  i2 = i7 + 16 | 0;
  HEAP32[i2 >> 2] = i1;
  i3 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
  i4 = i3 >> 3;
  if (i4 | 0) {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 37;
   HEAP32[i15 + 4 >> 2] = i1;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i7 + 12 >> 2] = i3 + (i4 << 3);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i2 >> 3 << 3);
   }
  }
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 20;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 i14 = HEAP32[i12 >> 2] | 0;
 HEAP32[i15 >> 2] = 37;
 HEAP32[i15 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 STACKTOP = i16;
 return;
}

function __ZN12TreeRenderer10InjectTreeERK12TreeInstance(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 8 | 0;
 i11 = i15;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i13 = (((HEAP32[i1 + 20 >> 2] | 0) - (HEAP32[i1 + 16 >> 2] | 0) | 0) / 40 | 0) + -1 | 0;
 i2 = i14 + 236 | 0;
 i3 = i14 + 248 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i14 + 252 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i14 + 240 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 240 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = -1;
 i5 = i9 + 32 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
 i6 = i8 + (i7 * 156 | 0) + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if ((i1 | 0) == 2) {
  i4 = HEAP32[i8 + (i7 * 156 | 0) + 8 >> 2] | 0;
  if (!i4) {
   STACKTOP = i15;
   return;
  }
  HEAP32[i11 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
    i2 = HEAP32[i10 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 14; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 16;
  }
  if ((i12 | 0) == 14) i12 = 16;
  if ((i12 | 0) == 16) if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
   i1 = HEAP32[i6 >> 2] | 0;
   break;
  }
  __ZN12TreeRenderer25CreateLODRenderersForTreeEi(i14, i13);
  if (!(HEAP32[(HEAP32[i14 + 364 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 44 | 0) + 24 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  }
  i3 = (HEAP32[i14 + 392 >> 2] | 0) + -1 | 0;
  i1 = HEAP32[i14 + 380 >> 2] | 0;
  i2 = HEAP32[i1 + (i3 * 88 | 0) + 80 >> 2] | 0;
  if (i2 | 0) if (!(HEAP32[i2 + 44 >> 2] | 0)) __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i2, 0);
  i1 = HEAP32[i1 + (i3 * 88 | 0) + 84 >> 2] | 0;
  if (!i1) {
   STACKTOP = i15;
   return;
  }
  if (HEAP32[i1 + 44 >> 2] | 0) {
   STACKTOP = i15;
   return;
  }
  __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i1, 1);
  STACKTOP = i15;
  return;
 } while (0);
 if ((i1 | 0) != 1) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i8 + (i7 * 156 | 0) + 16 >> 2] | 0;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i11 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 32; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 32; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 34;
 }
 if ((i12 | 0) == 32) i12 = 34;
 if ((i12 | 0) == 34) if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = i14 + 148 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = i14 + 136 | 0;
 i2 = i14 + 120 | 0;
 if (!i3) i12 = 37; else if (!(__ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i(i3, i1, i2, 500) | 0)) i12 = 37;
 if ((i12 | 0) == 37) {
  i1 = __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i(HEAP32[i14 >> 2] | 0, i1, i2, 500) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) {
   __ZN14TreeBinaryTreeD2Ev(i2);
   __ZdlPv(i2);
  }
  HEAP32[i4 >> 2] = i1;
 }
 __ZN12TreeRenderer29CreateMeshTreeRendererForTreeEi(i14, i13);
 STACKTOP = i15;
 return;
}

function __ZN9ShaderLab16SerializedShader8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 88 | 0;
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470530 | 0, gb + 470541 | 0, i1, 0);
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470562 | 0, i7, i1, 0);
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i5 = i6 + 16 | 0;
 HEAP32[i6 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i6 + 32 | 0;
 i9 = i6 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i6 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i6 + 84 >> 2] = 1;
 i9 = i6 + 52 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 471809 | 0, i6, 0);
 __ZN9ShaderLab18SerializedProperty8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470570 | 0, i7, i9, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, i9, i1 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470583 | 0, i9, i1 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470602 | 0, i9, i1 + 56 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470499 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470617 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5Umbra11TileMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeES9_ii(i10, i1, i2, i11, i12, i13, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 32 | 0;
 i15 = i17 + 16 | 0;
 i16 = i17;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = i10 + 8 | 0;
 HEAP32[i2 >> 2] = i13;
 i3 = i10 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 16 | 0;
 HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i5 = i10 + 20 | 0;
 HEAPF32[i5 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i6 = i10 + 24 | 0;
 HEAPF32[i6 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i7 = i10 + 28 | 0;
 HEAPF32[i7 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i8 = i10 + 32 | 0;
 HEAPF32[i8 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAP32[i10 + 36 >> 2] = i11;
 HEAP32[i10 + 52 >> 2] = i12;
 HEAP32[i10 + 64 >> 2] = i9;
 if (!(HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i30 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP32[i10 + 40 >> 2] = (i30 | 0) == 0 ? 0 : (HEAP32[i11 + 28 >> 2] | 0) + i30 | 0;
 i30 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP32[i10 + 56 >> 2] = (i30 | 0) == 0 ? 0 : (HEAP32[i12 + 28 >> 2] | 0) + i30 | 0;
 i30 = HEAP32[i11 + 52 >> 2] | 0;
 i9 = i10 + 44 | 0;
 HEAP32[i9 >> 2] = i30;
 i31 = HEAP32[i12 + 52 >> 2] | 0;
 i1 = i10 + 60 | 0;
 HEAP32[i1 >> 2] = i31;
 HEAP32[i10 + 48 >> 2] = (1 << i30) + -1;
 HEAP32[i10 + 68 >> 2] = (1 << i31) + -1;
 i31 = i11 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 i30 = i10 + 24 | 0;
 i26 = i11 + 68 | 0;
 HEAP32[i30 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 i30 = i13 >>> 1 & 3;
 i26 = ((i30 + 1 | 0) >>> 0) % 3 | 0;
 i24 = ((i30 + 2 | 0) >>> 0) % 3 | 0;
 HEAP32[i10 + 76 + (i30 << 2) >> 2] = -1;
 HEAP32[i10 + 76 + (i26 << 2) >> 2] = 0;
 HEAP32[i10 + 76 + (i24 << 2) >> 2] = 1;
 i13 = i13 >> 1;
 i30 = (i13 + 1 | 0) % 3 | 0;
 f18 = Math_fround(HEAPF32[i31 + (i30 << 2) >> 2]);
 i13 = (i13 + 2 | 0) % 3 | 0;
 f29 = Math_fround(HEAPF32[i31 + (i13 << 2) >> 2]);
 i11 = i11 + 68 | 0;
 f20 = Math_fround(HEAPF32[i11 + (i30 << 2) >> 2]);
 f25 = Math_fround(HEAPF32[i11 + (i13 << 2) >> 2]);
 f28 = Math_fround(HEAPF32[i6 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i3 >> 2]));
 f27 = Math_fround(HEAPF32[i7 >> 2]);
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i4 >> 2]));
 f22 = Math_fround(HEAPF32[i8 >> 2]);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i14 >> 2] = f28;
 HEAPF32[i14 + 4 >> 2] = f27;
 HEAPF32[i14 + 8 >> 2] = f22;
 f19 = Math_fround(HEAPF32[i3 + (i26 << 2) >> 2]);
 f18 = Math_fround(f18 - f19);
 f21 = Math_fround(HEAPF32[i14 + (i26 << 2) >> 2]);
 f18 = Math_fround(f18 / f21);
 f21 = Math_fround(Math_fround(f20 - f19) / f21);
 f20 = Math_fround(HEAPF32[i3 + (i24 << 2) >> 2]);
 f29 = Math_fround(f29 - f20);
 f23 = Math_fround(HEAPF32[i14 + (i24 << 2) >> 2]);
 i7 = ~~Math_fround(Math_fround(f29 / f23) * Math_fround(65535.0));
 i8 = ~~Math_fround(f21 * Math_fround(65535.0));
 i13 = ~~Math_fround(Math_fround(Math_fround(f25 - f20) / f23) * Math_fround(65535.0));
 i11 = i15;
 HEAP32[i11 >> 2] = ~~Math_fround(f18 * Math_fround(65535.0));
 HEAP32[i11 + 4 >> 2] = i7;
 i11 = i15 + 8 | 0;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i13;
 i11 = HEAP32[i2 >> 2] >> 1;
 i13 = (i11 + 1 | 0) % 3 | 0;
 i8 = i12 + 56 | 0;
 f18 = Math_fround(HEAPF32[i8 + (i13 << 2) >> 2]);
 i11 = (i11 + 2 | 0) % 3 | 0;
 f23 = Math_fround(HEAPF32[i8 + (i11 << 2) >> 2]);
 i12 = i12 + 68 | 0;
 f25 = Math_fround(HEAPF32[i12 + (i13 << 2) >> 2]);
 f21 = Math_fround(HEAPF32[i12 + (i11 << 2) >> 2]);
 HEAPF32[i14 >> 2] = f28;
 HEAPF32[i14 + 4 >> 2] = f27;
 HEAPF32[i14 + 8 >> 2] = f22;
 f18 = Math_fround(f18 - f19);
 f22 = Math_fround(HEAPF32[i14 + (i26 << 2) >> 2]);
 f18 = Math_fround(f18 / f22);
 f22 = Math_fround(Math_fround(f25 - f19) / f22);
 f23 = Math_fround(f23 - f20);
 f19 = Math_fround(HEAPF32[i14 + (i24 << 2) >> 2]);
 i11 = ~~Math_fround(Math_fround(f23 / f19) * Math_fround(65535.0));
 i12 = ~~Math_fround(f22 * Math_fround(65535.0));
 i13 = ~~Math_fround(Math_fround(Math_fround(f21 - f20) / f19) * Math_fround(65535.0));
 i14 = i16;
 HEAP32[i14 >> 2] = ~~Math_fround(f18 * Math_fround(65535.0));
 HEAP32[i14 + 4 >> 2] = i11;
 i14 = i16 + 8 | 0;
 HEAP32[i14 >> 2] = i12;
 HEAP32[i14 + 4 >> 2] = i13;
 if (HEAP32[i9 >> 2] | 0) if (HEAP32[i1 >> 2] | 0) __ZN5Umbra11TileMatcher10matchTilesEiRKNS_8RectBaseINS_8Vector2iEiEEiS5_(i10, 0, i15, 0, i16);
 STACKTOP = i17;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946475 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 32 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946482 | 0, i8, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946492 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946508 | 0, i8, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37240 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946522 | 0, i7, i1 + 58 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034753 | 0, i7, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946531 | 0, i8, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034730 | 0, i8, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034741 | 0, i8, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034776 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034701 | 0, gb + 1034708 | 0, i7, 0);
 i6 = i9 + 8 | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN16ParticleAnimator8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048128 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 112 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = i1 + 88 | 0;
 i10 = HEAP32[gb + 36980 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048148 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048166 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048184 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048202 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 104 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048220 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 1048238 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 1048256 | 0, 0);
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048274 | 0, i9, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1048283 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 68 | 0, gb + 1048292 | 0, 0);
 i7 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048298 | 0, i9, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = f8 < Math_fround(0.0);
 i10 = f8 > Math_fround(1.0);
 f8 = i10 ? Math_fround(1.0) : f8;
 HEAPF32[i7 >> 2] = i9 ? Math_fround(0.0) : f8;
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048306 | 0, i7, i1 + 113 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP8[i6 >> 0] = (HEAP32[i1 + 108 >> 2] | 0) != 0 & 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048321 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL26HullProjectionCB_BigConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_(i2, i17, i23, i1, i21, i19) {
 i2 = i2 | 0;
 i17 = i17 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i19 = i19 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i22 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 32 | 0;
 i20 = i24 + 28 | 0;
 i18 = i24 + 24 | 0;
 i12 = i24 + 12 | 0;
 i13 = i24;
 i15 = HEAP32[i2 + 28 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i23 >> 2]);
 f8 = Math_fround(HEAPF32[i17 >> 2]);
 f7 = Math_fround(f7 * f8);
 f4 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 i16 = i17 + 4 | 0;
 f25 = Math_fround(HEAPF32[i16 >> 2]);
 f4 = Math_fround(f7 + Math_fround(f4 * f25));
 f7 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 i14 = i17 + 8 | 0;
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f7 = Math_fround(f4 + Math_fround(f7 * f9));
 f4 = Math_fround(f8 * Math_fround(HEAPF32[i23 + 12 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f25 * Math_fround(HEAPF32[i23 + 16 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i23 + 20 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i23 + 24 >> 2]));
 f25 = Math_fround(f8 + Math_fround(f25 * Math_fround(HEAPF32[i23 + 28 >> 2])));
 f9 = Math_fround(f25 + Math_fround(f9 * Math_fround(HEAPF32[i23 + 32 >> 2])));
 f25 = Math_fround(f7 * Math_fround(HEAPF32[i1 >> 2]));
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f3 = Math_fround(f4 * Math_fround(HEAPF32[i1 + 16 >> 2]));
 f5 = Math_fround(f25 + f5);
 f3 = Math_fround(f8 + f3);
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f7 = Math_fround(f9 * Math_fround(HEAPF32[i1 + 24 >> 2]));
 f8 = Math_fround(f9 * Math_fround(HEAPF32[i1 + 28 >> 2]));
 f7 = Math_fround(f5 + f7);
 f8 = Math_fround(f3 + f8);
 f9 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i1 + 32 >> 2])));
 HEAPF32[i22 >> 2] = f7;
 i10 = i22 + 4 | 0;
 HEAPF32[i10 >> 2] = f8;
 i11 = i22 + 8 | 0;
 HEAPF32[i11 >> 2] = f9;
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 i6 = HEAPU16[i2 >> 1] | 0;
 f7 = Math_fround(-f7);
 f8 = Math_fround(-f8);
 f9 = Math_fround(-f9);
 HEAPF32[i12 >> 2] = f7;
 HEAPF32[i12 + 4 >> 2] = f8;
 HEAPF32[i12 + 8 >> 2] = f9;
 f4 = Math_fround(Math_abs(Math_fround(f7)));
 f3 = Math_fround(Math_abs(Math_fround(f8)));
 f5 = Math_fround(Math_abs(Math_fround(f9)));
 if (f3 > f4 & f3 > f5) i1 = 1; else {
  i1 = f5 > f4;
  f3 = i1 ? f5 : f4;
  i1 = i1 ? 2 : 0;
 }
 f4 = Math_fround(Math_fround(1.0) / f3);
 i27 = i1 + 1 + (i1 >>> 1) | 0;
 i26 = i27 & 3;
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i12 + (i26 << 2) >> 2]));
 f25 = Math_fround(Math_fround((i6 + -1 | 0) >>> 0) * Math_fround(.5));
 f5 = Math_fround(f25 * Math_fround(f5 + Math_fround(1.0)));
 f4 = Math_fround(f25 * Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i12 + ((i27 + 1 + (i26 >>> 1) & 3) << 2) >> 2])) + Math_fround(1.0)));
 i26 = ~~f5 >>> 0;
 i27 = ~~f4 >>> 0;
 i12 = (Math_fround(f4 - Math_fround(i27 >>> 0)) > Math_fround(.5) & 1) + i27 + (Math_imul(i26 + (Math_imul((HEAP32[i12 + (i1 << 2) >> 2] | 0) >>> 31 | i1 << 1, i6) | 0) + (Math_fround(f5 - Math_fround(i26 >>> 0)) > Math_fround(.5) & 1) | 0, i6) | 0) | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAPU8[i6 + i12 >> 0];
 HEAP32[i18 >> 2] = HEAPU8[i6 + (i12 + (HEAPU16[i2 + 2 >> 1] | 0)) >> 0];
 HEAPF32[i13 >> 2] = f7;
 HEAPF32[i13 + 4 >> 2] = f8;
 HEAPF32[i13 + 8 >> 2] = f9;
 __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE(i20, i13, i15, i2);
 __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE(i18, i22, i15, i2);
 f8 = Math_fround(HEAPF32[i23 + 36 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i17 >> 2]));
 f5 = Math_fround(HEAPF32[i23 + 40 >> 2]);
 f5 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f8 = Math_fround(HEAPF32[i23 + 44 >> 2]);
 f8 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2])));
 i23 = HEAP32[i20 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) >> 2]);
 f7 = Math_fround(HEAPF32[i22 >> 2]);
 f5 = Math_fround(f5 * f7);
 f4 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(f5 + Math_fround(f4 * f9));
 f5 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i11 >> 2]);
 HEAPF32[i21 >> 2] = Math_fround(f8 + Math_fround(f4 + Math_fround(f5 * f25)));
 i23 = HEAP32[i18 >> 2] | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i15 + (i23 * 12 | 0) >> 2]) * f7);
 f9 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 4 >> 2]) * f9));
 HEAPF32[i19 >> 2] = Math_fround(f8 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 8 >> 2]) * f25)));
 STACKTOP = i24;
 return;
}

function __ZN17PersistentManager18ReadObjectThreadedEi(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 16 | 0;
 i17 = i20 + 36 | 0;
 i18 = i20 + 40 | 0;
 i8 = i20;
 i9 = i20 + 32 | 0;
 i13 = i20 + 44 | 0;
 HEAP32[i18 >> 2] = i1;
 if ((HEAP16[gb + 1165944 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165944 | 0, i1);
  i19 = gb + 1165944 | 0;
 } else i19 = 0;
 i14 = i16 + 176 | 0;
 i12 = i16 + 120 | 0;
 if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) {
  i11 = i16 + 168 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i10 = i16 + 172 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = i2 + (i3 * 20 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i15, i16 + 116 | 0, i18);
  i1 = HEAP32[i15 >> 2] | 0;
  i11 = i16 + 168 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i10 = i16 + 172 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 * 20 | 0) | 0 : i2 + (i1 * 20 | 0) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 * 20 | 0) | 0)) i4 = 9; else if (!(HEAP8[i1 + 18 >> 0] | 0)) i4 = 9; else i1 = HEAP32[i1 + 12 >> 2] | 0;
 L11 : do if ((i4 | 0) == 9) {
  i2 = HEAP32[i16 + 56 >> 2] | 0;
  i5 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i2 + 36 >> 2] | 0;
  if ((i1 | 0) == -1) i4 = 13; else {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   if ((i5 | 0) < (i3 | 0)) i4 = 13; else if ((HEAP32[i2 + 32 >> 2] | 0) < (i5 | 0)) i4 = 13; else {
    i6 = (i5 - i3 | 0) / 2 | 0;
    i5 = 0;
    i7 = i6;
    i6 = ((i6 | 0) < 0) << 31 >> 31;
   }
  }
  if ((i4 | 0) == 13) {
   i4 = i2 + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   } else i3 = i4;
   L19 : while (1) {
    i2 = i1;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      break L19;
     } else i2 = i1;
    }
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) break; else i3 = i2;
   }
   if ((i2 | 0) == (i4 | 0)) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i2 + 16 >> 2] | 0) > (i5 | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i2 + 24 >> 2] | 0;
   i3 = i2 + 32 | 0;
   if ((i1 | 0) == -1) {
    i1 = 0;
    break;
   } else {
    i5 = HEAP32[i2 + 24 + 4 >> 2] | 0;
    i7 = HEAP32[i3 >> 2] | 0;
    i6 = HEAP32[i3 + 4 >> 2] | 0;
   }
  }
  i4 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i16, i1) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i1 = 0; else if (__ZNK14SerializedFile11IsAvailableEx(i2, i7, i6) | 0) {
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   L31 : do if (i3 | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    i21 = HEAP32[i3 + 12 >> 2] | 0;
    i3 = i2 + (i21 << 3) | 0;
    L33 : do if (i21) while (1) {
     i21 = i2;
     if ((HEAP32[i21 >> 2] | 0) == (i7 | 0) ? (HEAP32[i21 + 4 >> 2] | 0) == (i6 | 0) : 0) break L33;
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i3 | 0)) break L31;
    } while (0);
    if ((i2 | 0) != (i3 | 0)) {
     i1 = 0;
     break L11;
    }
   } while (0);
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) i1 = 0; else {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i8 + 4 >> 2] = i5;
    i2 = i8 + 8 | 0;
    HEAP32[i2 >> 2] = i7;
    HEAP32[i2 + 4 >> 2] = i6;
    i2 = HEAP32[i18 >> 2] | 0;
    HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    i2 = __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib(i16, i3, i15, i2, 1) | 0;
    if (!i2) i1 = 0; else {
     i4 = i16 + 84 | 0;
     HEAP32[i4 >> 2] = i1;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object(i3, i7, i6, 1, 1, i9, i13, i1);
     HEAP32[i4 >> 2] = -1;
     i4 = HEAP32[i9 >> 2] | 0;
     i3 = HEAP8[i13 >> 0] | 0;
     HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
     if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) i2 = (HEAP32[i11 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 20 | 0) | 0; else {
      __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i15, i16 + 116 | 0, i17);
      i2 = HEAP32[i15 >> 2] | 0;
      i21 = HEAP32[i11 >> 2] | 0;
      i2 = (i2 | 0) == -1 ? i21 + ((HEAP32[i10 >> 2] | 0) * 20 | 0) | 0 : i21 + (i2 * 20 | 0) | 0;
     }
     i21 = HEAP32[i2 + 12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0);
     HEAP32[i2 + 8 >> 2] = i4;
     HEAP8[i2 + 16 >> 0] = i3;
     HEAP8[i2 + 17 >> 0] = 1;
    }
   }
  } else i1 = 0;
 } while (0);
 if (!i19) {
  STACKTOP = i20;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i20;
 return i1 | 0;
}

function _UNITY_tt_size_ready_bytecode(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i14 = i15 + 296 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i11 = HEAP32[i15 >> 2] | 0;
  i9 = HEAP32[i11 + 100 >> 2] | 0;
  i8 = i15 + 124 | 0;
  _UNITY_ft_mem_free(i9, HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = 0;
  i4 = i15 + 136 | 0;
  _UNITY_ft_mem_free(i9, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  i5 = i15 + 244 | 0;
  _UNITY_ft_mem_free(i9, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i6 = i15 + 252 | 0;
  _UNITY_ft_mem_free(i9, HEAP32[i6 >> 2] | 0);
  HEAP32[i6 >> 2] = 0;
  i2 = i15 + 292 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) _UNITY_TT_Done_Context(i1);
  i7 = i15 + 256 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i10 = i7 + 28 | 0;
   _UNITY_ft_mem_free(i1, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = 0;
   i10 = i7 + 24 | 0;
   _UNITY_ft_mem_free(i1, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = 0;
   i10 = i7 + 16 | 0;
   _UNITY_ft_mem_free(i1, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = 0;
   i10 = i7 + 12 | 0;
   _UNITY_ft_mem_free(i1, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = 0;
   i10 = i7 + 20 | 0;
   _UNITY_ft_mem_free(i1, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
  }
  HEAP32[i15 + 296 >> 2] = -1;
  HEAP32[i15 + 300 >> 2] = -1;
  i10 = i11 + 96 | 0;
  HEAP32[i2 >> 2] = _UNITY_TT_New_Context(HEAP32[i10 >> 2] | 0) | 0;
  i2 = HEAP32[i11 + 280 >> 2] | 0;
  i18 = i2 & 65535;
  HEAP32[i15 + 120 >> 2] = i18;
  i1 = i15 + 132 | 0;
  HEAP32[i1 >> 2] = i2 >>> 16;
  HEAP32[i15 + 116 >> 2] = 0;
  HEAP32[i15 + 128 >> 2] = 0;
  HEAP32[i15 + 140 >> 2] = 0;
  HEAP32[i15 + 144 >> 2] = 0;
  i2 = i15 + 240 | 0;
  HEAP32[i2 >> 2] = HEAP32[i11 + 644 >> 2];
  i3 = i15 + 248 | 0;
  HEAP16[i3 >> 1] = HEAP16[i11 + 278 >> 1] | 0;
  i19 = i15 + 72 | 0;
  HEAP8[i19 + 37 >> 0] = 0;
  HEAP8[i19 + 38 >> 0] = 0;
  i19 = i19 + 20 | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  HEAP32[i8 >> 2] = _UNITY_ft_mem_realloc(i9, 24, 0, i18, 0, i12) | 0;
  if (!(HEAP32[i12 >> 2] | 0)) {
   HEAP32[i4 >> 2] = _UNITY_ft_mem_realloc(i9, 24, 0, HEAP32[i1 >> 2] | 0, 0, i12) | 0;
   if (!(HEAP32[i12 >> 2] | 0)) {
    HEAP32[i5 >> 2] = _UNITY_ft_mem_realloc(i9, 4, 0, HEAP32[i2 >> 2] | 0, 0, i12) | 0;
    if (!(HEAP32[i12 >> 2] | 0)) {
     HEAP32[i6 >> 2] = _UNITY_ft_mem_realloc(i9, 4, 0, HEAPU16[i3 >> 1] | 0, 0, i12) | 0;
     if (!(HEAP32[i12 >> 2] | 0)) {
      i1 = (HEAPU16[i11 + 276 >> 1] | 0) + 4 & 65535;
      i19 = _UNITY_tt_glyphzone_new(i9, i1, 0, i7) | 0;
      HEAP32[i12 >> 2] = i19;
      if (!i19) {
       HEAP16[i7 + 8 >> 1] = i1;
       i1 = i15 + 172 | 0;
       i2 = gb + 185760 | 0;
       i3 = i1 + 68 | 0;
       do {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        i1 = i1 + 4 | 0;
        i2 = i2 + 4 | 0;
       } while ((i1 | 0) < (i3 | 0));
       i19 = HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0) + 172 >> 2] | 0;
       HEAP32[i11 + 652 >> 2] = (i19 | 0) == 0 ? fb + 2644 | 0 : i19;
       i19 = _UNITY_tt_size_run_fpgm(i15, i16) | 0;
       HEAP32[i12 >> 2] = i19;
       if (i19) i13 = 13;
      } else i13 = 13;
     } else i13 = 13;
    } else i13 = 13;
   } else i13 = 13;
  } else i13 = 13;
  if ((i13 | 0) == 13) {
   _tt_size_done_bytecode(i15);
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) {
    i19 = i1;
    STACKTOP = i17;
    return i19 | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if (i1 | 0) {
  i19 = 0;
  STACKTOP = i17;
  return i19 | 0;
 }
 if ((HEAP32[i15 + 300 >> 2] | 0) >= 0) {
  i19 = 0;
  STACKTOP = i17;
  return i19 | 0;
 }
 i5 = i15 + 240 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = (HEAP32[i15 >> 2] | 0) + 648 | 0;
  i3 = i15 + 88 | 0;
  i4 = i15 + 244 | 0;
  i1 = 0;
  do {
   i19 = _UNITY_FT_MulFix(HEAP16[(HEAP32[i2 >> 2] | 0) + (i1 << 1) >> 1] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i19;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i1 = HEAP16[i15 + 264 >> 1] | 0;
 if (i1 << 16 >> 16) {
  i3 = HEAP32[i15 + 268 >> 2] | 0;
  i4 = HEAP32[i15 + 272 >> 2] | 0;
  i2 = i1 & 65535;
  i1 = 0;
  do {
   HEAP32[i3 + (i1 << 3) >> 2] = 0;
   HEAP32[i3 + (i1 << 3) + 4 >> 2] = 0;
   HEAP32[i4 + (i1 << 3) >> 2] = 0;
   HEAP32[i4 + (i1 << 3) + 4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = HEAP16[i15 + 248 >> 1] | 0;
 if (i1 << 16 >> 16) {
  i19 = i1 & 65535;
  _memset(HEAP32[i15 + 252 >> 2] | 0, 0, (i19 >>> 0 > 1 ? i19 : 1) << 2 | 0) | 0;
 }
 i1 = i15 + 172 | 0;
 i2 = gb + 185760 | 0;
 i3 = i1 + 68 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i19 = _UNITY_tt_size_run_prep(i15, i16) | 0;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 340 | 0;
 i8 = i6 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 2);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 342 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 2);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 344 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 348 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 352 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 356 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 360 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 364 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 368 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 372 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 376 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 380 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 384 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 388 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 392 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 552 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 556 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 560 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  i9 = i5 + 564 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i8, i9, i12) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i7 = (i3 - i2 | 0) / 20 | 0;
 i10 = i8 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4;
 i11 = i3;
 if (i7 >>> 0 > ((i1 - i4 | 0) / 20 | 0) >>> 0) {
  if (i4) {
   i6 = i8 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) i1 = i4; else {
    i2 = i1;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = HEAP32[i2 + -12 >> 2] | 0;
     i4 = i3;
     if (i3) {
      i1 = i2 + -8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i3);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 0;
  }
  if (i7 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else i2 = 0;
  i11 = (i1 - i2 | 0) / 20 | 0;
  i1 = i11 << 1;
  i1 = i11 >>> 0 < 107374182 ? (i1 >>> 0 < i7 >>> 0 ? i7 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = __Znwj(i1 * 20 | 0) | 0;
  i11 = i8 + 4 | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i10 >> 2] = i2 + (i1 * 20 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == (i10 | 0)) return;
  do {
   i9 = i1;
   i5 = HEAP32[i9 + 4 >> 2] | 0;
   i4 = i2;
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = i2 + 8 | 0;
   i5 = i1 + 8 | 0;
   HEAP32[i4 >> 2] = 0;
   i9 = i2 + 12 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   i7 = i1 + 12 | 0;
   i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
   i6 = (i3 | 0) / 24 | 0;
   if (i3 | 0) {
    if (i6 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i8 = __Znwj(i3) | 0;
    HEAP32[i9 >> 2] = i8;
    HEAP32[i4 >> 2] = i8;
    HEAP32[i2 + 16 >> 2] = i8 + (i6 * 24 | 0);
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i8 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i9 >> 2] = i8 + (((i2 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
   HEAP32[i11 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 } else {
  i10 = i8 + 4 | 0;
  i12 = ((HEAP32[i10 >> 2] | 0) - i4 | 0) / 20 | 0;
  i4 = i7 >>> 0 > i12 >>> 0;
  i3 = i4 ? i2 + (i12 * 20 | 0) | 0 : i3;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i5;
   do {
    i8 = i2;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i12 = i1;
    HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i12 + 4 >> 2] = i9;
    if ((i1 | 0) != (i2 | 0)) __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
    i2 = i2 + 20 | 0;
    i1 = i1 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
   i5 = i1;
  }
  if (!i4) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) return;
   do {
    i2 = i1 + -20 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = HEAP32[i1 + -12 >> 2] | 0;
    i4 = i3;
    if (!i3) i1 = i2; else {
     i1 = i1 + -8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i3);
     i1 = HEAP32[i10 >> 2] | 0;
    }
   } while ((i1 | 0) != (i5 | 0));
   return;
  }
  if ((i3 | 0) == (i11 | 0)) return;
  i2 = HEAP32[i10 >> 2] | 0;
  do {
   i9 = i3;
   i5 = HEAP32[i9 + 4 >> 2] | 0;
   i4 = i2;
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = i2 + 8 | 0;
   i5 = i3 + 8 | 0;
   HEAP32[i4 >> 2] = 0;
   i9 = i2 + 12 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   i7 = i3 + 12 | 0;
   i1 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
   i6 = (i1 | 0) / 24 | 0;
   if (i1 | 0) {
    if (i6 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i8 = __Znwj(i1) | 0;
    HEAP32[i9 >> 2] = i8;
    HEAP32[i4 >> 2] = i8;
    HEAP32[i2 + 16 >> 2] = i8 + (i6 * 24 | 0);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i8 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i9 >> 2] = i8 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i3 = i3 + 20 | 0;
   i2 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
   HEAP32[i10 >> 2] = i2;
  } while ((i3 | 0) != (i11 | 0));
  return;
 }
}

function __ZNK7VRInput16GetLocalPositionERK8UnityStr4PPtrI9TransformE(i10, i5, i1, i2) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 8 | 0;
 i4 = i11;
 i9 = __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_(i5 + 20 | 0, i1) | 0;
 if ((i9 | 0) == (i5 + 24 | 0)) {
  HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i11;
  return;
 }
 i8 = i9 + 32 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i4 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 10;
  }
  if ((i7 | 0) == 8) i7 = 10;
  if ((i7 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  i4 = i5 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i7 = 19; else {
   i1 = i4;
   L20 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i6 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L20; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) == (i4 | 0)) i7 = 19; else if ((i6 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i7 = 19; else i1 = i1 + 20 | 0;
  }
  if ((i7 | 0) == 19) if (!(HEAP8[gb + 1573589 >> 0] | 0)) {
   HEAP32[gb + 1469228 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[gb + 1469228 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[gb + 1469228 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAPF32[gb + 1469228 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 24 >> 2] = Math_fround(1.0);
   i1 = gb + 1469228 + 28 | 0;
   i2 = gb + 1162292 | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP8[gb + 1573589 >> 0] = 1;
   i1 = gb + 1469228 | 0;
  } else i1 = gb + 1469228 | 0;
  f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f18 = Math_fround(f21 * Math_fround(2.0));
  f19 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f20 = Math_fround(f19 * Math_fround(2.0));
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f23 = Math_fround(f13 * Math_fround(2.0));
  f16 = Math_fround(f21 * f18);
  f15 = Math_fround(f19 * f20);
  f13 = Math_fround(f13 * f23);
  f24 = Math_fround(f21 * f20);
  f21 = Math_fround(f21 * f23);
  f19 = Math_fround(f19 * f23);
  f14 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f18 = Math_fround(f18 * f14);
  f20 = Math_fround(f20 * f14);
  f23 = Math_fround(f14 * f23);
  f14 = Math_fround(Math_fround(1.0) - Math_fround(f15 + f13));
  f22 = Math_fround(HEAPF32[i8 >> 2]);
  f14 = Math_fround(f22 * f14);
  f25 = Math_fround(f24 - f23);
  f17 = Math_fround(HEAPF32[i9 + 36 >> 2]);
  f14 = Math_fround(Math_fround(f25 * f17) + f14);
  f25 = Math_fround(f21 + f20);
  f12 = Math_fround(HEAPF32[i9 + 40 >> 2]);
  f14 = Math_fround(Math_fround(f25 * f12) + f14);
  f13 = Math_fround(Math_fround(Math_fround(f19 - f18) * f12) + Math_fround(Math_fround(f22 * Math_fround(f24 + f23)) + Math_fround(f17 * Math_fround(Math_fround(1.0) - Math_fround(f16 + f13)))));
  f12 = Math_fround(Math_fround(Math_fround(f22 * Math_fround(f21 - f20)) + Math_fround(Math_fround(f19 + f18) * f17)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f16 + f15)) * f12));
  f14 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f14);
  f13 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + f13);
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i1 + 8 >> 2]));
  HEAPF32[i10 >> 2] = f14;
  HEAPF32[i10 + 4 >> 2] = f13;
  HEAPF32[i10 + 8 >> 2] = f12;
  STACKTOP = i11;
  return;
 } while (0);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 36 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 40 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i10, i8, i14, i15) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0;
 i16 = i10 + 48 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (i1 >>> 0 < 2) {
  i1 = i10 + 157 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   i18 = 0;
   return i18 | 0;
  }
  HEAP8[i1 >> 0] = 1;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 461634 | 0, 0, gb + 461711 | 0, 294, 1, 0, 0, 0);
  i18 = 0;
  return i18 | 0;
 }
 i17 = i10 + 36 | 0;
 i18 = i10 + 16 | 0;
 i11 = i10 + 248 | 0;
 i12 = i10 + 224 | 0;
 i13 = i10 + 232 | 0;
 if (!i8) {
  i4 = i1 + -1 | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i8 + (i4 << 4) >> 2] | 0;
  i1 = i2 & 16383;
  i2 = HEAP32[HEAP32[(HEAP32[i18 >> 2] | 0) + (i2 >>> 14 << 2) >> 2] >> 2] | 0;
  i4 = i8 + (i4 << 4) + 8 | 0;
  i8 = i4;
  i8 = __Z17TimeToNanosecondsy(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
  i8 = ___udivdi3(i8 | 0, getTempRet0() | 0, 1e3, 0) | 0;
  i9 = getTempRet0() | 0;
  i3 = i2 + (i1 * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i3 + 4 >> 2] = i9;
  i4 = _i64Subtract(i14 | 0, i15 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
  i4 = __Z17TimeToNanosecondsy(i4, getTempRet0() | 0) | 0;
  HEAPF32[i2 + (i1 * 24 | 0) + 8 >> 2] = Math_fround(Math_fround(+(i4 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) / Math_fround(1.0e3));
  i4 = i11;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (!((i3 | 0) == 0 & (i4 | 0) == 0)) {
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i10, gb + 1163364 | 0, 0) | 0;
   i17 = HEAP32[(HEAP32[i17 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) + -1 << 4) >> 2] | 0;
   i18 = HEAP32[HEAP32[(HEAP32[i18 >> 2] | 0) + (i17 >>> 14 << 2) >> 2] >> 2] | 0;
   d19 = +_emscripten_get_now() * 1.0e6;
   i11 = +Math_abs(d19) >= 1.0 ? (d19 > 0.0 ? ~~+Math_min(+Math_floor(d19 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d19 - +(~~d19 >>> 0)) / 4294967296.0) >>> 0) : 0;
   __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i10, gb + 1163364 | 0, ~~d19 >>> 0, i11) | 0;
   i11 = ___udivdi3(i3 | 0, i4 | 0, 1e3, 0) | 0;
   HEAPF32[i18 + ((i17 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
  }
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  i18 = i12;
  HEAP32[i18 >> 2] = i14;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i13 >> 2] = HEAP32[i2 + (i1 * 24 | 0) + 16 >> 2];
  i18 = 1;
  return i18 | 0;
 }
 while (1) {
  i4 = i1 + -1 | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  i3 = HEAP32[i5 + (i4 << 4) >> 2] | 0;
  i2 = i3 & 16383;
  i3 = HEAP32[HEAP32[(HEAP32[i18 >> 2] | 0) + (i3 >>> 14 << 2) >> 2] >> 2] | 0;
  i7 = i3 + (i2 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i8 | 0)) i6 = 0; else if ((HEAP16[i1 + 6 >> 1] | 0) > -1) break; else i6 = 1;
  i1 = i5 + (i4 << 4) + 8 | 0;
  i20 = i1;
  i20 = __Z17TimeToNanosecondsy(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0) | 0;
  i20 = ___udivdi3(i20 | 0, getTempRet0() | 0, 1e3, 0) | 0;
  i4 = getTempRet0() | 0;
  i5 = i3 + (i2 * 24 | 0) | 0;
  HEAP32[i5 >> 2] = i20;
  HEAP32[i5 + 4 >> 2] = i4;
  i1 = _i64Subtract(i14 | 0, i15 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
  i1 = __Z17TimeToNanosecondsy(i1, getTempRet0() | 0) | 0;
  HEAPF32[i3 + (i2 * 24 | 0) + 8 >> 2] = Math_fround(Math_fround(+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) / Math_fround(1.0e3));
  i2 = i11;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
   i20 = i11;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i10, gb + 1163364 | 0, 0) | 0;
   i20 = HEAP32[(HEAP32[i17 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) + -1 << 4) >> 2] | 0;
   i5 = HEAP32[HEAP32[(HEAP32[i18 >> 2] | 0) + (i20 >>> 14 << 2) >> 2] >> 2] | 0;
   d19 = +_emscripten_get_now() * 1.0e6;
   i4 = +Math_abs(d19) >= 1.0 ? (d19 > 0.0 ? ~~+Math_min(+Math_floor(d19 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d19 - +(~~d19 >>> 0)) / 4294967296.0) >>> 0) : 0;
   __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i10, gb + 1163364 | 0, ~~d19 >>> 0, i4) | 0;
   i4 = ___udivdi3(i1 | 0, i2 | 0, 1e3, 0) | 0;
   HEAPF32[i5 + ((i20 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i4 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
  }
  i1 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
  HEAP32[i16 >> 2] = i1;
  i20 = i12;
  HEAP32[i20 >> 2] = i14;
  HEAP32[i20 + 4 >> 2] = i15;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  if (!i6) {
   i1 = 1;
   i9 = 15;
   break;
  }
 }
 if ((i9 | 0) == 15) return i1 | 0;
 i1 = i10 + 157 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i20 = 0;
  return i20 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 461634 | 0, 0, gb + 461711 | 0, 313, 1, 0, 0, 0);
 i20 = 0;
 return i20 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj(i21, i1, i5) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 120 | 0;
 i24 = i27;
 i25 = i21 + 112 | 0;
 if (HEAP8[i25 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv(i21);
 i26 = i21 + 96 | 0;
 i4 = HEAP32[i26 >> 2] | 0;
 i22 = i21 + 100 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if (i4 >>> 0 > i5 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i21 + 108 >> 2] | 0) >>> 0) {
  STACKTOP = i27;
  return;
 }
 i2 = i2 + i1 | 0;
 f3 = Math_fround(i2 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i27;
  return;
 }
 i20 = i21 + 4 | 0;
 f3 = Math_fround((i2 - (HEAP32[i20 >> 2] | 0) | 0) >>> 0);
 i19 = 32;
 while (1) {
  if (i19 >>> 0 >= i5 >>> 0) if (!(f3 >= Math_fround(Math_fround(i19 >>> 0) * Math_fround(.5)))) break;
  i19 = i19 << 1;
 }
 i1 = i24 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i24 + 8 | 0;
 i4 = i21 + 8 | 0;
 i6 = HEAP16[i4 >> 1] | 0;
 HEAP8[i2 >> 0] = i6;
 i5 = i24 + 9 | 0;
 HEAP8[i5 >> 0] = (i6 & 65535) >>> 8;
 i6 = i24 + 12 | 0;
 i7 = i21 + 12 | 0;
 i10 = i6;
 i11 = i7;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i8 = i24 + 52 | 0;
 i9 = i21 + 52 | 0;
 i10 = i8;
 i11 = i9;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i13 = i24 + 92 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i24 + 96 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i24 + 100 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i24 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i16 = i24 + 108 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i24 + 104 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i24 + 112 | 0;
 HEAP8[i18 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i24, i21, i19);
 i11 = HEAP32[i20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i11;
 i11 = HEAP8[i4 >> 0] | 0;
 i12 = HEAP16[i2 >> 1] | 0;
 HEAP8[i4 >> 0] = i12;
 HEAP8[i2 >> 0] = i11;
 i11 = i21 + 9 | 0;
 i10 = HEAP8[i11 >> 0] | 0;
 HEAP8[i11 >> 0] = (i12 & 65535) >>> 8;
 HEAP8[i5 >> 0] = i10;
 i10 = i23;
 i11 = i7;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i7;
 i11 = i6;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i6;
 i11 = i23;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i23;
 i11 = i9;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i9;
 i11 = i8;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i8;
 i11 = i23;
 i12 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i20 = i21 + 92 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i20 = HEAP32[i26 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 HEAP32[i26 >> 2] = i19;
 HEAP32[i14 >> 2] = i20;
 i26 = HEAP32[i22 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i26;
 f3 = Math_fround(i19 >>> 0);
 HEAP32[i21 + 108 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i21 + 104 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i25 >> 0] = 0;
 f3 = Math_fround(i20 >>> 0);
 HEAP32[i16 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i17 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i18 >> 0] = 0;
 if (i1 | 0) {
  i26 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i23 >> 2] = 65;
  HEAP32[i23 + 4 >> 2] = i26;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i23);
 }
 STACKTOP = i27;
 return;
}

function __ZN5physx19NpArticulationJoint13setParentPoseERKNS_11PxTransformE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 28 | 0;
 i1 = i21;
 i2 = HEAP32[i6 + 196 >> 2] | 0;
 if (!i2) {
  STACKTOP = i21;
  return;
 }
 i20 = i6 + 8 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i2 | 0);
 f33 = Math_fround(HEAPF32[i3 >> 2]);
 f35 = Math_fround(f33 * f33);
 f31 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f31 * f31));
 f29 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f29 * f29));
 f28 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f35 + Math_fround(f28 * f28)))));
 f33 = Math_fround(f33 * f35);
 f31 = Math_fround(f31 * f35);
 f29 = Math_fround(f29 * f35);
 f35 = Math_fround(f28 * f35);
 f28 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f32 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f30 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f25 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f34 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f28 = Math_fround(f28 * Math_fround(2.0));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f26 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f22 = Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(f27 * f30)) + Math_fround(f26 * f25));
 f24 = Math_fround(Math_fround(f22 * f32) + Math_fround(Math_fround(f36 * f28) + Math_fround(f34 * Math_fround(Math_fround(f26 * f30) - Math_fround(f27 * f25)))));
 f23 = Math_fround(Math_fround(f22 * f30) + Math_fround(Math_fround(f36 * f27) + Math_fround(f34 * Math_fround(Math_fround(f28 * f25) - Math_fround(f26 * f32)))));
 f22 = Math_fround(Math_fround(Math_fround(f36 * f26) + Math_fround(f34 * Math_fround(Math_fround(f27 * f32) - Math_fround(f28 * f30)))) + Math_fround(f22 * f25));
 f28 = Math_fround(Math_fround(Math_fround(f29 * f30) + Math_fround(Math_fround(f35 * f32) + Math_fround(f33 * f34))) - Math_fround(f31 * f25));
 f27 = Math_fround(Math_fround(Math_fround(f33 * f25) + Math_fround(Math_fround(f35 * f30) + Math_fround(f31 * f34))) - Math_fround(f29 * f32));
 f26 = Math_fround(Math_fround(Math_fround(f31 * f32) + Math_fround(Math_fround(f35 * f25) + Math_fround(f29 * f34))) - Math_fround(f33 * f30));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f34) - Math_fround(f33 * f32)) - Math_fround(f31 * f30)) - Math_fround(f29 * f25));
 HEAPF32[i18 >> 2] = f28;
 i11 = i18 + 4 | 0;
 HEAPF32[i11 >> 2] = f27;
 i12 = i18 + 8 | 0;
 HEAPF32[i12 >> 2] = f26;
 i14 = i18 + 12 | 0;
 HEAPF32[i14 >> 2] = f25;
 HEAPF32[i18 + 16 >> 2] = f24;
 i15 = i18 + 20 | 0;
 HEAPF32[i15 >> 2] = f23;
 i17 = i18 + 24 | 0;
 HEAPF32[i17 >> 2] = f22;
 i5 = i6 + 20 | 0;
 i19 = i6 + 12 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 i9 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 switch (i8 >>> 30 | 0) {
 case 3:
  {
   i16 = i20;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i20 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i16 = i20;
   break;
  }
 default:
  i10 = 5;
 }
 if ((i10 | 0) == 5) {
  __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE(i5, i18);
  STACKTOP = i21;
  return;
 }
 i5 = i6 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  i6 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i16 >> 2] | 0, i8 >>> 24 & 15) | 0;
  HEAP32[i5 >> 2] = i6;
  i9 = HEAP32[i18 >> 2] | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i18 + 16 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i17 >> 2] | 0;
 } else i5 = i13;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i5;
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = i3;
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i16 >> 2] | 0, i20);
 HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 1;
 STACKTOP = i21;
 return;
}

function __ZNK5Umbra4Tome12getStatisticENS0_9StatisticE(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 switch (i7 | 0) {
 case 0:
  {
   i12 = HEAP32[i12 + 8 >> 2] | 0;
   return i12 | 0;
  }
 case 3:
 case 2:
 case 6:
 case 1:
  {
   i6 = (HEAP32[i12 + 44 >> 2] | 0) >>> 5;
   if (!i6) i1 = 0; else {
    i5 = i12 + (HEAP32[i12 + 160 >> 2] | 0) | 0;
    i1 = 0;
    i4 = 0;
    do {
     i11 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
     i3 = i12 + i11 | 0;
     L9 : do if (!((i11 | 0) == 0 | (i3 | 0) == 0)) switch (i7 | 0) {
     case 1:
      {
       i2 = HEAP32[i3 + 56 >> 2] | 0;
       if (!i2) i2 = 0; else {
        i11 = HEAP32[i3 + 52 >> 2] & 65535;
        i10 = i11 + -1 | 0;
        i2 = i3 + i2 | 0;
        i2 = ((HEAP32[i2 + (i10 * 36 | 0) + 4 >> 2] | 0) + (HEAP32[i2 + (i10 * 36 | 0) >> 2] | 0) << 4) + (i11 * 36 | 0) | 0;
       }
       i1 = i2 + i1 | 0;
       break L9;
      }
     case 2:
      {
       i11 = HEAP32[i3 + 24 >> 2] | 0;
       i10 = i11 >>> 5;
       i9 = i11 >>> 21;
       i8 = i11 >>> 13;
       i1 = (3 - i8 + (i11 >>> 9) + (((1 - i9 + i8 | 0) >>> 1) + i9 + (((i10 << 1) + 31 | 0) >>> 5) + (((Math_imul((i10 + 1 | 0) >>> 1, i11 & 31) | 0) + 31 | 0) >>> 5) << 2) & -4) + i1 | 0;
       break L9;
      }
     case 3:
      {
       i1 = (HEAP32[i3 + 68 >> 2] << 3) + i1 + (HEAP32[i3 + 76 >> 2] << 4) | 0;
       break L9;
      }
     default:
      {
       i2 = HEAP32[i3 + 56 >> 2] | 0;
       if (!i2) i2 = 0; else {
        i11 = HEAP32[i3 + 52 >> 2] & 65535;
        i10 = i11 + -1 | 0;
        i2 = i3 + i2 | 0;
        i2 = ((HEAP32[i2 + (i10 * 36 | 0) + 4 >> 2] | 0) + (HEAP32[i2 + (i10 * 36 | 0) >> 2] | 0) << 4) + (i11 * 36 | 0) | 0;
       }
       i11 = HEAP32[i3 + 24 >> 2] | 0;
       i10 = i11 >>> 5;
       i9 = i11 >>> 21;
       i8 = i11 >>> 13;
       i11 = 3 - i8 + (i11 >>> 9) + (((1 - i9 + i8 | 0) >>> 1) + i9 + (((i10 << 1) + 31 | 0) >>> 5) + (((Math_imul((i10 + 1 | 0) >>> 1, i11 & 31) | 0) + 31 | 0) >>> 5) << 2) & -4;
       i1 = ((HEAP32[i3 + 44 >> 2] | 0) >>> 8) + i1 - i2 + (Math_imul(HEAP32[i3 + 68 >> 2] | 0, -8) | 0) + (Math_imul(HEAP32[i3 + 76 >> 2] | 0, -16) | 0) - i11 | 0;
       break L9;
      }
     } while (0);
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i6 | 0));
   }
   if ((i7 | 0) != 1) {
    i12 = i1;
    return i12 | 0;
   }
   i11 = HEAP32[i12 + 84 >> 2] | 0;
   i10 = (Math_imul((i11 >>> 5 & 31) + (i11 & 31) | 0, HEAP32[i12 + 92 >> 2] | 0) | 0) + 31 >> 5 << 2;
   i11 = (Math_imul((i11 >>> 10 & 31) + (i11 >>> 15 & 31) | 0, HEAP32[i12 + 100 >> 2] | 0) | 0) + 31 >> 5 << 2;
   i12 = ((HEAP32[i12 + 88 >> 2] | 0) == 0 ? 0 : i10) + i1 + ((HEAP32[i12 + 96 >> 2] | 0) == 0 ? 0 : i11) | 0;
   return i12 | 0;
  }
 case 7:
  {
   i2 = HEAP32[i12 + 128 >> 2] | 0;
   i3 = HEAP32[i12 + 124 >> 2] | 0;
   if (!(HEAP32[i12 + 180 >> 2] | 0)) {
    i1 = i3 + -1 | 0;
    i11 = i12 + i2 | 0;
    i1 = (HEAP32[i11 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i11 + (i1 * 20 | 0) >> 2] | 0) | 0;
   } else i1 = HEAP32[i12 + (HEAP32[i12 + 184 >> 2] | 0) + (HEAP32[i12 + 176 >> 2] << 2) >> 2] | 0;
   i12 = ((HEAP32[i12 + 132 >> 2] | 0) == 0 ? 0 : i1 << 4) + ((i2 | 0) == 0 ? 0 : i3 * 20 | 0) | 0;
   return i12 | 0;
  }
 case 5:
  {
   i11 = HEAP32[i12 + 64 >> 2] | 0;
   i12 = (i11 << 2) + ((HEAP32[i12 + 68 >> 2] | 0) == 0 ? 0 : i11 * 24 | 0) + ((HEAP32[i12 + 72 >> 2] | 0) == 0 ? 0 : i11 << 5) | 0;
   return i12 | 0;
  }
 case 4:
  {
   i12 = (HEAP32[i12 + 116 >> 2] | 0) * 12 | 0;
   return i12 | 0;
  }
 case 8:
  {
   i2 = HEAP32[i12 + 164 >> 2] | 0;
   i3 = HEAP32[i12 + 168 >> 2] | 0;
   if (!i2) {
    i12 = 0;
    return i12 | 0;
   }
   i1 = (HEAP32[i12 + 140 >> 2] << 4) + ((i3 | 0) == 0 ? 0 : (HEAP32[i12 + 172 >> 2] | 0) * 20 | 0) | 0;
   i10 = (HEAP32[i12 + 44 >> 2] | 0) >>> 5;
   if (!i10) {
    i12 = i1;
    return i12 | 0;
   }
   i11 = i12 + (HEAP32[i12 + 160 >> 2] | 0) | 0;
   i9 = i12 + i2 | 0;
   i8 = i12 + i3 | 0;
   i7 = 0;
   i2 = 0;
   do {
    i6 = HEAP32[i11 + (i7 << 2) >> 2] | 0;
    i3 = i12 + i6 | 0;
    if (!((i6 | 0) == 0 | (i3 | 0) == 0)) if (HEAP32[i3 + 44 >> 2] & 1) {
     i6 = i2 + 1 | 0;
     i4 = HEAP32[i9 + (i2 << 4) >> 2] | 0;
     i5 = Math_imul(HEAP32[i9 + (i2 << 4) + 12 >> 2] | 0, HEAP32[i9 + (i2 << 4) + 8 >> 2] | 0) | 0;
     i1 = ((Math_imul(i5, HEAP32[i3 + 52 >> 2] & 65535) | 0) + 31 >> 5 << 2) + i1 | 0;
     i5 = i4 & 7;
     if (!i5) i2 = i6; else {
      i3 = i4 >> 3;
      i2 = 0;
      do {
       i14 = HEAP32[i8 + ((i2 + i3 | 0) * 20 | 0) >> 2] | 0;
       i15 = i14 >>> 5;
       i4 = i14 >>> 21;
       i13 = i14 >>> 13;
       i1 = (((((Math_imul((i15 + 1 | 0) >>> 1, i14 & 31) | 0) + 31 | 0) >>> 5) + (((i15 << 1) + 31 | 0) >>> 5) << 2) + (3 - i13 + (i14 >>> 9) + (((1 - i4 + i13 | 0) >>> 1) + i4 << 2)) & -4) + i1 | 0;
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i5 | 0));
      i2 = i6;
     }
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i10 | 0));
   return i1 | 0;
  }
 default:
  {
   i15 = 0;
   return i15 | 0;
  }
 }
 return 0;
}

function __ZN5physx18PxsDynamicsContext13solveParallelEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEEPPNS_12PxsRigidBodyEj(i2, i19, i20, i6, i5, i15, i26, i22, i4, i8, i9, i14, i21, i12, i13, i29, i16, i17, i11, i28, i27, i23, i1, i24, i32, i18, i10, i3, i30, i7) {
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i15 = i15 | 0;
 i26 = i26 | 0;
 i22 = i22 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i21 = i21 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i29 = i29 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 i32 = i32 | 0;
 i18 = i18 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i30 = i30 | 0;
 i7 = i7 | 0;
 var i25 = 0, i31 = 0, i33 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i31;
 HEAP32[i1 >> 2] = 0;
 i33 = HEAP32[i2 + 136 >> 2] | 0;
 i25 = i2 + 124 | 0;
 mftCall_vifiiiiiiiiiiiiiiiiiiiiiii(HEAP32[(HEAP32[i33 >> 2] | 0) + 20 >> 2] | 0, i33 | 0, +Math_fround(HEAPF32[i25 >> 2]), i19 | 0, i20 | 0, i6 | 0, i5 | 0, i15 | 0, i26 | 0, i22 | 0, i4 | 0, i8 | 0, i9 | 0, i14 | 0, i21 | 0, i12 | 0, i13 | 0, i16 | 0, i17 | 0, i11 | 0, i18 | 0, i10 | 0, i3 | 0, i28 | 0, i1 | 0, i7 | 0);
 i2 = (__ZN5physx6shdfnd9atomicAddEPVii(i29, 128) | 0) + -128 | 0;
 i3 = Math_imul(HEAP32[i18 + 4 >> 2] | 0, i20 + i19 | 0) | 0;
 if ((HEAP32[i21 >> 2] | 0) < (i3 | 0)) if ((HEAP32[i21 >> 2] | 0) < (i3 | 0)) if ((HEAP32[i21 >> 2] | 0) < (i3 | 0)) {
  i1 = 3e4;
  do {
   i1 = i1 + -1 | 0;
   if (!i1) {
    __ZN5physx6shdfnd10ThreadImpl5yieldEv();
    i1 = 1e4;
   }
  } while ((HEAP32[i21 >> 2] | 0) < (i3 | 0));
 }
 if ((i2 | 0) < (i24 | 0)) {
  i18 = i23 + 4 | 0;
  i19 = i23 + 8 | 0;
  i20 = ~i24;
  i17 = 128;
  i1 = 0;
  while (1) {
   i16 = i24 - i2 | 0;
   i16 = (i16 | 0) < 128 ? i16 : 128;
   i3 = i17 - i16 | 0;
   if ((i16 | 0) > 0) {
    i15 = i2 + i20 | 0;
    i15 = (i15 | 0) > -129 ? i15 : -129;
    i14 = i1 + -1 | 0;
    i11 = ~i15;
    i12 = 0;
    i13 = i2;
    while (1) {
     i1 = HEAP32[gb + 1457376 >> 2] | 0;
     if (i1 | 0) mftCall_vif(i1 | 0, i22 + (i13 * 40 | 0) | 0, +Math_fround(HEAPF32[i25 >> 2]));
     i9 = i22 + (i13 * 40 | 0) + 36 | 0;
     i1 = HEAP16[i9 >> 1] | 0;
     if (i1 << 16 >> 16) {
      i10 = i22 + (i13 * 40 | 0) + 4 | 0;
      i8 = 0;
      do {
       i7 = (HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 5) + 16 >> 2] | 0) + 68 | 0;
       i6 = HEAP32[i7 >> 2] | 0;
       i7 = HEAP32[i7 + 4 >> 2] | 0;
       if ((i7 | 0) != 1073741823) {
        i5 = (i7 + 32 | 0) >>> 5;
        if (i5 >>> 0 > (HEAP32[i18 >> 2] & 2147483647) >>> 0) {
         i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, i5 << 2, gb + 769739 | 0, 329) | 0;
         i1 = HEAP32[i23 >> 2] | 0;
         if (i1 | 0) {
          _memcpy(i4 | 0, i1 | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
          if ((HEAP32[i18 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, HEAP32[i23 >> 2] | 0);
         }
         i1 = HEAP32[i18 >> 2] | 0;
         _memset(i4 + ((i1 & 2147483647) << 2) | 0, 0, i5 - i1 << 2 | 0) | 0;
         HEAP32[i23 >> 2] = i4;
         HEAP32[i18 >> 2] = i5;
         i1 = HEAP16[i9 >> 1] | 0;
        } else i4 = HEAP32[i23 >> 2] | 0;
        i33 = _bitshift64Lshr(i6 | 0, i7 | 0, 37) | 0;
        getTempRet0() | 0;
        i33 = i4 + (i33 << 2) | 0;
        HEAP32[i33 >> 2] = HEAP32[i33 >> 2] | 1 << (i7 & 31);
       }
       i8 = i8 + 1 | 0;
      } while (i8 >>> 0 < (i1 & 65535) >>> 0);
     }
     i12 = i12 + 1 | 0;
     if ((i12 | 0) == (i11 | 0)) break; else i13 = i13 + 1 | 0;
    }
    i2 = i2 + -1 - i15 | 0;
    i1 = i14 - i15 | 0;
   }
   if ((i17 | 0) == (i16 | 0)) {
    i3 = 128;
    i2 = (__ZN5physx6shdfnd9atomicAddEPVii(i29, 128) | 0) + -128 | 0;
   }
   if ((i2 | 0) < (i24 | 0)) i17 = i3; else break;
  }
 } else {
  i3 = 128;
  i1 = 0;
 }
 i2 = i2 - i24 | 0;
 if ((i2 | 0) >= (i26 | 0)) {
  i33 = i1;
  __ZN5physx6shdfnd9atomicAddEPVii(i32, i33) | 0;
  STACKTOP = i31;
  return;
 }
 i6 = -128 - i24 | 0;
 i7 = ~i26;
 while (1) {
  i33 = i26 - i2 | 0;
  if ((((i33 | 0) < (i3 | 0) ? i33 : i3) | 0) > 0) {
   i4 = i2 + i7 | 0;
   i5 = ~i3;
   i5 = (i4 | 0) > (i5 | 0) ? i4 : i5;
   i3 = ~i5;
   i4 = 0;
   while (1) {
    __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf(HEAP32[i27 + (i2 << 2) >> 2] | 0, HEAP32[i30 + (i2 << 2) >> 2] | 0, i28 + (i2 << 5) | 0, Math_fround(HEAPF32[i25 >> 2]));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
   }
   i1 = i1 + -1 - i5 | 0;
  }
  i2 = i6 + (__ZN5physx6shdfnd9atomicAddEPVii(i29, 128) | 0) | 0;
  if ((i2 | 0) >= (i26 | 0)) break; else i3 = 128;
 }
 __ZN5physx6shdfnd9atomicAddEPVii(i32, i1) | 0;
 STACKTOP = i31;
 return;
}

function __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f(i31, i4, i7, f15) {
 i31 = i31 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, f3 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f32 = f0, f33 = f0, i34 = 0;
 i1 = i31;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f30 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(f9 - f30);
 f30 = Math_fround(Math_fround(f15 - f30) / f9);
 if (f30 < Math_fround(-9.99999974e-06)) {
  HEAP32[i31 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAPF32[i31 >> 2] = f15;
  i31 = i31 + 16 | 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = 0;
  HEAP32[i31 + 16 >> 2] = 0;
  HEAP32[i31 + 20 >> 2] = 0;
  return;
 }
 if (f30 > Math_fround(1.00001001)) {
  HEAP32[i31 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i31 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i31 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i31 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAPF32[i31 >> 2] = f15;
  i31 = i31 + 16 | 0;
  HEAP32[i31 >> 2] = 0;
  HEAP32[i31 + 4 >> 2] = 0;
  HEAP32[i31 + 8 >> 2] = 0;
  HEAP32[i31 + 12 >> 2] = 0;
  HEAP32[i31 + 16 >> 2] = 0;
  HEAP32[i31 + 20 >> 2] = 0;
  return;
 }
 f10 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f22 = Math_fround(f9 * f10);
 f11 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f23 = Math_fround(f9 * f11);
 f13 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f24 = Math_fround(f9 * f13);
 f12 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f25 = Math_fround(f9 * f12);
 f26 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f27 = Math_fround(f9 * f26);
 f28 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f29 = Math_fround(f9 * f28);
 i14 = i4 + 4 | 0;
 i16 = i4 + 8 | 0;
 i17 = i4 + 12 | 0;
 i20 = i7 + 4 | 0;
 i21 = i7 + 8 | 0;
 i7 = i7 + 12 | 0;
 f18 = Math_fround(f30 * f30);
 f8 = Math_fround(f18 * Math_fround(6.0));
 f32 = Math_fround(f30 * Math_fround(6.0));
 f3 = Math_fround(f8 - f32);
 f19 = Math_fround(f18 * Math_fround(3.0));
 f5 = Math_fround(Math_fround(f19 - Math_fround(f30 * Math_fround(4.0))) + Math_fround(1.0));
 f6 = Math_fround(f19 - Math_fround(f30 * Math_fround(2.0)));
 f8 = Math_fround(f32 - f8);
 if (f9 > Math_fround(1.74532929e-07)) {
  f33 = Math_fround(Math_fround(f6 * f29) + Math_fround(Math_fround(f5 * f24) + Math_fround(f3 * Math_fround(HEAPF32[i17 >> 2]))));
  f33 = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])) + f33);
  f32 = Math_fround(Math_fround(f6 * f27) + Math_fround(Math_fround(f5 * f23) + Math_fround(f3 * Math_fround(HEAPF32[i16 >> 2]))));
  f32 = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])) + f32);
  f3 = Math_fround(Math_fround(f6 * f25) + Math_fround(Math_fround(f5 * f22) + Math_fround(f3 * Math_fround(HEAPF32[i14 >> 2]))));
  f3 = Math_fround(Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2])) + f3) / f9);
  f6 = Math_fround(f33 / f9);
  f5 = Math_fround(f32 / f9);
 } else {
  f3 = Math_fround(5729578.0);
  f6 = Math_fround(5729578.0);
  f5 = Math_fround(5729578.0);
 }
 i34 = f10 == Math_fround(inf);
 i34 = i34 | f12 == Math_fround(inf);
 f3 = i34 ? Math_fround(inf) : f3;
 i4 = f11 == Math_fround(inf);
 i2 = i4 | f26 == Math_fround(inf);
 f5 = i2 ? Math_fround(inf) : f5;
 i2 = f13 == Math_fround(inf);
 i1 = i2 | f28 == Math_fround(inf);
 f6 = i1 ? Math_fround(inf) : f6;
 HEAPF32[i31 + 16 >> 2] = f3;
 HEAPF32[i31 + 20 >> 2] = f5;
 HEAPF32[i31 + 24 >> 2] = f6;
 HEAPF32[i31 + 28 >> 2] = f3;
 HEAPF32[i31 + 32 >> 2] = f5;
 HEAPF32[i31 + 36 >> 2] = f6;
 HEAPF32[i31 >> 2] = f15;
 i1 = i31 + 4 | 0;
 f6 = Math_fround(HEAPF32[i14 >> 2]);
 f5 = Math_fround(HEAPF32[i16 >> 2]);
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 f15 = Math_fround(HEAPF32[i20 >> 2]);
 f32 = Math_fround(HEAPF32[i21 >> 2]);
 f11 = Math_fround(f30 * f18);
 f33 = Math_fround(f11 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f33 - f19) + Math_fround(1.0));
 f12 = Math_fround(f30 + Math_fround(f11 - Math_fround(f18 * Math_fround(2.0))));
 f18 = Math_fround(f11 - f18);
 f30 = Math_fround(f19 - f33);
 f32 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(Math_fround(f12 * f23) + Math_fround(f13 * f5))) + Math_fround(f30 * f32));
 f33 = Math_fround(Math_fround(Math_fround(f18 * f29) + Math_fround(Math_fround(f12 * f24) + Math_fround(f13 * f3))) + Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i31 + 4 >> 2] = Math_fround(Math_fround(Math_fround(f18 * f25) + Math_fround(Math_fround(f12 * f22) + Math_fround(f13 * f6))) + Math_fround(f30 * f15));
 HEAPF32[i31 + 8 >> 2] = f32;
 HEAPF32[i31 + 12 >> 2] = f33;
 if (i34) HEAPF32[i1 >> 2] = f6;
 if (i4 | f26 == Math_fround(inf)) HEAPF32[i1 + 4 >> 2] = f5;
 if (!(i2 | f28 == Math_fround(inf))) return;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN7mecanim9animation16GetAllBlendValueEjP9OffsetPtrINS0_21BlendTreeNodeConstantEER13dynamic_arrayIiLj4EE(i1, i11, i15) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = i11 + (i1 << 2) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = (i1 | 0) == 0 ? 0 : i1 + i10 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == 4) {
  i9 = i10 + 28 | 0;
  i10 = i9;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + i10 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) return;
  i11 = i15 + 12 | 0;
  i12 = i15 + 16 | 0;
  i13 = i15 + 4 | 0;
  i8 = 0;
  do {
   i6 = i2 + 4 | 0;
   i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i8 << 2) >> 2] | 0;
   do if ((i6 | 0) != -1) {
    i5 = HEAP32[i15 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    i3 = i5 + (i7 << 2) | 0;
    L10 : do if (!i7) {
     i2 = i5;
     i14 = 8;
    } else {
     i2 = i5;
     do {
      if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) {
       i14 = 8;
       break L10;
      }
      i2 = i2 + 4 | 0;
     } while ((i2 | 0) != (i3 | 0));
    } while (0);
    if ((i14 | 0) == 8) {
     i14 = 0;
     if ((i2 | 0) != (i3 | 0)) break;
    }
    i4 = i7 + 1 | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    i3 = i2 & 2147483647;
    do if (i4 >>> 0 > i3 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i12 >> 2] = i1;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i15 >> 2] = i1;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i15 >> 2] = i5;
      i1 = i5;
      break;
     } else i1 = i5;
    } else i1 = i5; while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[i1 + (i7 << 2) >> 2] = i6;
    i1 = HEAP32[i9 >> 2] | 0;
   } while (0);
   i8 = i8 + 1 | 0;
   i2 = i1 + i10 | 0;
  } while (i8 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  return;
 }
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 do if ((i7 | 0) != -1) {
  i6 = HEAP32[i15 >> 2] | 0;
  i8 = i15 + 12 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i3 = i6 + (i9 << 2) | 0;
  L29 : do if (!i9) {
   i2 = i6;
   i14 = 20;
  } else {
   i2 = i6;
   do {
    if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) {
     i14 = 20;
     break L29;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) != (i3 | 0));
  } while (0);
  if ((i14 | 0) == 20) if ((i2 | 0) != (i3 | 0)) break;
  i5 = i9 + 1 | 0;
  i2 = i15 + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i5 >>> 0 > i4 >>> 0) {
   i1 = i3 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i2 >> 2] = i1;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i15 >> 2] = i1;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i15 >> 2] = i13;
    i1 = i13;
    break;
   } else i1 = i6;
  } else i1 = i6; while (0);
  HEAP32[i8 >> 2] = i5;
  HEAP32[i1 + (i9 << 2) >> 2] = i7;
  i1 = HEAP32[i10 >> 2] | 0;
 } while (0);
 do if (i1 | 0) {
  i9 = HEAP32[i10 + 8 >> 2] | 0;
  if ((i9 | 0) != -1) {
   i1 = HEAP32[i15 >> 2] | 0;
   i7 = i15 + 12 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i3 = i1 + (i8 << 2) | 0;
   L47 : do if (!i8) {
    i2 = i1;
    i14 = 32;
   } else {
    i2 = i1;
    do {
     if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
      i14 = 32;
      break L47;
     }
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i3 | 0));
   } while (0);
   if ((i14 | 0) == 32) if ((i2 | 0) != (i3 | 0)) break;
   i6 = i8 + 1 | 0;
   i3 = i15 + 16 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i6 >>> 0 > i5 >>> 0) {
    i2 = i4 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i15 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i15 >> 2] = i1;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i6;
   HEAP32[i1 + (i8 << 2) >> 2] = i9;
  }
 } while (0);
 i4 = i10 + 12 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i2 = i10 + 16 | 0;
 i3 = i2;
 i1 = 0;
 do {
  __ZN7mecanim9animation16GetAllBlendValueEjP9OffsetPtrINS0_21BlendTreeNodeConstantEER13dynamic_arrayIiLj4EE(HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2] | 0, i11, i15);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx14NpRigidDynamic18getKinematicTargetERNS_11PxTransformE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i2 = i12 + 284 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 4096)) i1 = i12 + 108 | 0; else i1 = (HEAP32[i12 + 56 >> 2] | 0) + 268 | 0;
 if (!(HEAP8[i1 >> 0] & 1)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 do if (!(i3 & 8192)) {
  if ((HEAP32[i12 + 52 >> 2] | 0) >>> 0 > 3221225471) {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  if (__ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i12 + 64 | 0, i10) | 0) {
   f6 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   f7 = Math_fround(HEAPF32[i10 >> 2]);
   f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   i4 = i10 + 20 | 0;
   i5 = i10 + 24 | 0;
   f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i12 + 56 >> 2] | 0;
   break;
  } else {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 } else {
  i2 = HEAP32[i12 + 56 >> 2] | 0;
  i15 = HEAP32[i2 + 192 >> 2] | 0;
  HEAP32[i10 >> 2] = i15;
  i14 = HEAP32[i2 + 196 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i14;
  i1 = HEAP32[i2 + 200 >> 2] | 0;
  HEAP32[i10 + 8 >> 2] = i1;
  i16 = HEAP32[i2 + 204 >> 2] | 0;
  HEAP32[i10 + 12 >> 2] = i16;
  HEAP32[i10 + 16 >> 2] = HEAP32[i2 + 208 >> 2];
  i4 = i10 + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 + 212 >> 2];
  i5 = i10 + 24 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 + 216 >> 2];
  f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i3;
 } while (0);
 i16 = (i1 & 512 | 0) == 0 ? i12 + 112 | 0 : i2 + 144 | 0;
 f19 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f28 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f19 = Math_fround(f19 * Math_fround(-2.0));
 f28 = Math_fround(f28 * Math_fround(-2.0));
 f30 = Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) * Math_fround(-2.0));
 f25 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f29 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i16 >> 2]);
 f20 = Math_fround(f19 * f18);
 f17 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f28 * f17));
 f27 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f20 = Math_fround(f20 + Math_fround(f30 * f27));
 f26 = Math_fround(-f18);
 f23 = Math_fround(-f17);
 f24 = Math_fround(-f27);
 f22 = Math_fround(Math_fround(Math_fround(f18 * f20) + Math_fround(Math_fround(f19 * f29) - Math_fround(f25 * Math_fround(Math_fround(f30 * f17) - Math_fround(f28 * f27))))) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f28 * f29) - Math_fround(f25 * Math_fround(Math_fround(f19 * f27) - Math_fround(f30 * f18))))) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f30 * f29) - Math_fround(f25 * Math_fround(Math_fround(f28 * f18) - Math_fround(f19 * f17)))) + Math_fround(f27 * f20)) * Math_fround(2.0));
 f27 = Math_fround(Math_fround(f6 * f6) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(f9 * f20) + Math_fround(Math_fround(f7 * f22) + Math_fround(f8 * f21)));
 f19 = Math_fround(Math_fround(f7 * f17) + Math_fround(Math_fround(f27 * f22) + Math_fround(f6 * Math_fround(Math_fround(f8 * f20) - Math_fround(f9 * f21)))));
 f18 = Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f27 * f21) + Math_fround(f6 * Math_fround(Math_fround(f9 * f22) - Math_fround(f7 * f20)))));
 f17 = Math_fround(Math_fround(Math_fround(f27 * f20) + Math_fround(f6 * Math_fround(Math_fround(f7 * f21) - Math_fround(f8 * f22)))) + Math_fround(f9 * f17));
 f19 = Math_fround(Math_fround(HEAPF32[i10 + 16 >> 2]) + f19);
 f18 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f18);
 f17 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f17);
 f22 = Math_fround(Math_fround(Math_fround(f9 * f26) + Math_fround(Math_fround(f6 * f23) + Math_fround(f25 * f8))) - Math_fround(f7 * f24));
 f21 = Math_fround(Math_fround(Math_fround(f7 * f23) + Math_fround(Math_fround(f6 * f24) + Math_fround(f25 * f9))) - Math_fround(f8 * f26));
 f20 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f6) - Math_fround(f7 * f26)) - Math_fround(f8 * f23)) - Math_fround(f9 * f24));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f6 * f26) + Math_fround(f25 * f7)) + Math_fround(f8 * f24)) - Math_fround(f9 * f23));
 HEAPF32[i11 + 4 >> 2] = f22;
 HEAPF32[i11 + 8 >> 2] = f21;
 HEAPF32[i11 + 12 >> 2] = f20;
 HEAPF32[i11 + 16 >> 2] = f19;
 HEAPF32[i11 + 20 >> 2] = f18;
 HEAPF32[i11 + 24 >> 2] = f17;
 i16 = 1;
 STACKTOP = i13;
 return i16 | 0;
}

function __ZL15TestContainmentRKN5physx6PxVec3EPKfjPKNS_2Gu15HullPolygonDataE(i1, i14, i15, i16) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f17 = f0, f18 = f0;
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!i15) {
  i16 = 1;
  return i16 | 0;
 } else {
  i3 = 0;
  i2 = 0;
  i1 = 0;
  i9 = 0;
 }
 L3 : while (1) {
  switch (i9 | 0) {
  case 0:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f4 + f12);
    f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f13);
    f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 1:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f4 + f12);
    f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f13);
    f6 = Math_fround(f8 - Math_fround(HEAPF32[i11 >> 2]));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 2:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f4 + f12);
    f5 = Math_fround(f13 - Math_fround(HEAPF32[i10 >> 2]));
    f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 3:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f4 + f12);
    f5 = Math_fround(f13 - Math_fround(HEAPF32[i10 >> 2]));
    f6 = Math_fround(f8 - Math_fround(HEAPF32[i11 >> 2]));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 4:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f12 - f4);
    f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f13);
    f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 5:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f12 - f4);
    f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f13);
    f6 = Math_fround(f8 - Math_fround(HEAPF32[i11 >> 2]));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 6:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f12 - f4);
    f5 = Math_fround(f13 - Math_fround(HEAPF32[i10 >> 2]));
    f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  case 7:
   {
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    f4 = Math_fround(f12 - f4);
    f5 = Math_fround(f13 - Math_fround(HEAPF32[i10 >> 2]));
    f6 = Math_fround(f8 - Math_fround(HEAPF32[i11 >> 2]));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  default:
   {}
  }
  f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i7 = 0;
  do {
   f18 = Math_fround(HEAPF32[i16 + (i7 * 20 | 0) >> 2]);
   f17 = Math_fround(HEAPF32[i16 + (i7 * 20 | 0) + 4 >> 2]);
   f17 = Math_fround(Math_fround(Math_fround(f4 * f18) + Math_fround(f5 * f17)) + Math_fround(f6 * Math_fround(HEAPF32[i16 + (i7 * 20 | 0) + 8 >> 2])));
   if (Math_fround(Math_fround(HEAPF32[i16 + (i7 * 20 | 0) + 12 >> 2]) + f17) > Math_fround(0.0)) {
    i1 = 0;
    i2 = 15;
    break L3;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i15 >>> 0);
  i9 = i9 + 1 | 0;
  if (i9 >>> 0 >= 8) {
   i1 = 1;
   i2 = 15;
   break;
  }
 }
 if ((i2 | 0) == 15) return i1 | 0;
 return 0;
}

function __ZNK6Camera26CalculateCullingParametersER17CullingParameters(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16 + 168 | 0;
 i8 = i16 + 72 | 0;
 i12 = i16 + 64 | 0;
 i4 = i16;
 i7 = i16 + 184 | 0;
 i1 = i14 + 680 | 0;
 if (HEAP8[i14 + 1085 >> 0] | 0) {
  i9 = i1;
  i10 = __ZNK6Camera20GetWorldToClipMatrixEv(i14) | 0;
  i11 = i9 + 64 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   i9 = i9 + 4 | 0;
   i10 = i10 + 4 | 0;
  } while ((i9 | 0) < (i11 | 0));
 }
 i9 = i4;
 i10 = i1;
 i11 = i9 + 64 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  i9 = i9 + 4 | 0;
  i10 = i10 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 _memmove(i15 + 544 | 0, i1 | 0, 64) | 0;
 i13 = i15 + 608 | 0;
 i9 = i14 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i13 = i14 + 924 | 0;
 __ZNK6Camera22CalculateFrustumPlanesEP5PlaneRK10Matrix4x4ffRfb(i14, i8, i4, Math_fround(HEAPF32[i13 >> 2]), i12, 0);
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 i9 = i7 + 3 | 0;
 i10 = i6;
 i11 = i9 + 12 | 0;
 do {
  HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
  i9 = i9 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 if (HEAP8[i14 + 1087 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
  i11 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i14) | 0) {
   i10 = __Z14IsWorldPlayingv() | 0;
   i11 = HEAP32[i14 + 1108 >> 2] | 0;
   if ((i11 | 0) == 8 | i10 & (i11 | 0) == 1) {
    i11 = __Z12GetIVRDevicev() | 0;
    HEAPF32[i14 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i11 >> 2] | 0) + 120 >> 2] | 0, i11 | 0));
   }
  }
 }
 i4 = HEAP32[i14 + 292 >> 2] | 0;
 i9 = HEAP8[i14 + 1088 >> 0] | 0;
 i5 = HEAP32[i14 + 916 >> 2] | 0;
 __ZL19GetCameraTargetRectRK6Camerab(i6, i14, 0);
 f3 = Math_fround(HEAPF32[i14 + 868 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + 876 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f3 = Math_fround(f3 * f18);
 f17 = Math_fround(f17 * f18);
 f2 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f3 = Math_fround(f3 + f2);
 f17 = Math_fround(f17 + f3);
 f18 = Math_fround(f18 + f2);
 f3 = Math_fround((f17 > f18 ? f18 : f17) - (f3 < f2 ? f2 : f3));
 i1 = f3 < Math_fround(0.0);
 i1 = ~~(i1 ? Math_fround(0.0) : f3);
 i6 = HEAP32[i14 + 880 >> 2] | 0;
 HEAP8[i15 >> 0] = i9;
 i9 = i15 + 1 | 0;
 i10 = i7;
 i11 = i9 + 15 | 0;
 do {
  HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
  i9 = i9 + 1 | 0;
  i10 = i10 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i15 + 16 >> 2] = i4;
 HEAP32[i15 + 20 >> 2] = i5;
 HEAP32[i15 + 24 >> 2] = i1;
 i4 = i15 + 188 | 0;
 HEAP32[i4 >> 2] = 6;
 i11 = i15 + 28 | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i11 = i15 + 44 | 0;
 i10 = i8 + 16 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i11 = i15 + 60 | 0;
 i10 = i8 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i11 = i15 + 76 | 0;
 i10 = i8 + 48 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i11 = i15 + 92 | 0;
 i10 = i8 + 64 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i11 = i15 + 108 | 0;
 i10 = i8 + 80 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E(i8, 6, i15 + 352 | 0) | 0;
 HEAP32[i4 >> 2] = 6;
 i4 = i15 + 324 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i15 + 192 >> 2] = i6;
 if (HEAP8[i14 + 1090 >> 0] | 0) {
  _memmove(i15 + 196 | 0, i14 + 932 | 0, 128) | 0;
  i15 = 2;
  HEAP32[i4 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 f3 = Math_fround(HEAPF32[i12 >> 2]);
 i1 = 0;
 do {
  f2 = Math_fround(HEAPF32[i14 + 932 + (i1 << 2) >> 2]);
  if (!(f2 != Math_fround(0.0))) f2 = Math_fround(HEAPF32[i13 >> 2]);
  HEAPF32[i15 + 196 + (i1 << 2) >> 2] = Math_fround(f3 + f2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i1 = 1;
 HEAP32[i4 >> 2] = i1;
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLab7ProgramC2Ei10ShaderType(i17, i6, i1) {
 i17 = i17 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i13 = i18 + 40 | 0;
 i15 = i18 + 8 | 0;
 HEAP32[i17 + 4 >> 2] = 1;
 HEAP32[i17 >> 2] = gb + 68900 + 8;
 i2 = i17 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i17 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i17 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i17 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i9 = i16;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i17 + 28 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i17 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i17 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i17 + 32 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i14 = i16;
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP8[i17 + 56 >> 0] = 0;
 i11 = i17 + 57 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = i17 + 60 | 0;
 i14 = i12 + 84 | 0;
 do {
  HEAP32[i12 >> 2] = 0;
  i12 = i12 + 4 | 0;
 } while ((i12 | 0) < (i14 | 0));
 i12 = i17 + 144 | 0;
 HEAP32[i12 >> 2] = 32;
 HEAP32[i17 + 148 >> 2] = 0;
 HEAP32[i17 + 164 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f21 = Math_fround((HEAP32[i12 >> 2] | 0) >>> 0);
 HEAP32[i17 + 156 >> 2] = ~~Math_fround(f21 * Math_fround(.5)) >>> 0;
 HEAP32[i17 + 152 >> 2] = ~~Math_fround(f21 * Math_fround(.200000003)) >>> 0;
 HEAP8[i17 + 160 >> 0] = 0;
 HEAP32[i17 + 172 >> 2] = 0;
 HEAP32[i17 + 184 >> 2] = 0;
 HEAP32[i17 + 188 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i20 = i16;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i14 = i17 + 176 | 0;
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i14 + 4 >> 2] = i19;
 HEAP32[i17 + 196 >> 2] = -1;
 HEAP32[i17 + 200 >> 2] = i1;
 HEAP8[i17 + 204 >> 0] = 0;
 HEAP8[i17 + 205 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6 << 2, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i20 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i2 >> 2] = i20;
  break;
 } while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i6;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i6 << 5, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 5, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i20 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 5 | 0) | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i7 >> 2] = i20;
  break;
 } while (0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 HEAP32[i13 + 28 >> 2] = 0;
 i1 = 0;
 do {
  i20 = i13 + (i1 >>> 5 << 2) | 0;
  HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 1 << (i1 & 31);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
 i1 = _XXH32(i13, 32, -1756908921) | 0;
 HEAP8[i11 >> 0] = 1;
 i4 = i17 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
 HEAP32[i17 + 132 >> 2] = i1;
 HEAP32[i17 + 136 >> 2] = 0;
 i1 = (HEAP32[i12 >> 2] | 0) * 40 | 0;
 i3 = HEAP32[i17 + 164 >> 2] | 0;
 HEAP32[i16 >> 2] = 65;
 HEAP32[i16 + 4 >> 2] = i3;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i17 + 140 >> 2] = i1;
 i3 = i1 + ((HEAP32[i12 >> 2] | 0) * 40 | 0) | 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i18;
  return;
 }
 do {
  i12 = i1;
  i2 = i4;
  i14 = i12 + 40 | 0;
  do {
   HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
   i12 = i12 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i12 | 0) < (i14 | 0));
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i18;
 return;
}

function __ZN11UnityEngine9Animation14GenericBinding8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898362 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898367 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898377 | 0, HEAP32[gb + 37176 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898384 | 0, HEAP32[gb + 37288 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 34; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 34; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 14 | 0;
 i4 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898392 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 15 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898403 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN9shadertag10InitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i3 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63280 | 0, 16, gb + 479994 | 0, 26) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[gb + 1166564 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480075 | 0, 9);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 479733 | 0, 12);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 479746 | 0, 15);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480085 | 0, 6);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480092 | 0, 8);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480101 | 0, 12);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1087447 | 0, 4);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480114 | 0, 5);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480120 | 0, 14);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480135 | 0, 20);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480156 | 0, 15);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480172 | 0, 13);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 480186 | 0, 9);
 __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __Z24CalculateRaycastTexcoordP8ColliderRK8Vector2fRK8Vector3fji(i9, i1, i10, i3, i6, i7) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 do if (i1 | 0) {
  i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
  if ((i2 - (HEAP32[gb + 112968 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 112968 + 28 >> 2] | 0) >>> 0) {
   if ((i2 - (HEAP32[gb + 151564 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 151564 + 28 >> 2] | 0) >>> 0) break;
   f15 = Math_fround(HEAPF32[i1 + 100 >> 2]);
   f14 = Math_fround(HEAPF32[i1 + 108 >> 2]);
   __ZNK9Transform11GetPositionEv(i11, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f13 = Math_fround(HEAPF32[i3 >> 2]);
   HEAPF32[i9 >> 2] = Math_fround(f15 * Math_fround(f13 - Math_fround(HEAPF32[i11 >> 2])));
   f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   HEAPF32[i9 + 4 >> 2] = Math_fround(f14 * Math_fround(f13 - Math_fround(HEAPF32[i11 + 8 >> 2])));
   STACKTOP = i12;
   return;
  }
  i5 = __ZNK12MeshCollider13GetSharedMeshEv(i1) | 0;
  do if (i5 | 0) {
   HEAP32[i4 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i4);
     i2 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 11;
    }
   }
   if ((i8 | 0) == 9) i8 = 11;
   if ((i8 | 0) == 11) {
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) break;
   }
   do if (__ZNK4Mesh15ExtractTriangleEjPj(i1, i6, i11) | 0) {
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    if ((i7 | 0) == 1) {
     i2 = i4 + 8 | 0;
     if (!(HEAP8[i4 + 27 >> 0] | 0)) i8 = 20; else {
      i7 = HEAP16[i4 + 26 >> 1] | 0;
      if ((i7 & 65535) < 512 | (i7 & 255) != 0) {
       i3 = 0;
       i1 = 0;
      } else {
       i1 = HEAP32[i4 + 92 >> 2] | 0;
       if (!i1) {
        i3 = 0;
        i1 = 1;
       } else {
        i3 = HEAP16[i4 + 24 >> 1] | 0;
        i3 = i1 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i2 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
        i1 = HEAP8[i2 + 32 + ((HEAPU8[i4 + 24 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
       }
      }
     }
    } else i8 = 20;
    if ((i8 | 0) == 20) {
     i2 = i4 + 8 | 0;
     if (!(HEAP8[i4 + 23 >> 0] | 0)) {
      HEAP32[i9 >> 2] = HEAP32[gb + 1162356 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
      break;
     }
     i8 = HEAP16[i4 + 22 >> 1] | 0;
     if ((i8 & 65535) < 512 | (i8 & 255) != 0) {
      i3 = 0;
      i1 = 0;
     } else {
      i1 = HEAP32[i4 + 92 >> 2] | 0;
      if (!i1) {
       i3 = 0;
       i1 = 1;
      } else {
       i3 = HEAP16[i4 + 20 >> 1] | 0;
       i3 = i1 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i2 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
       i1 = HEAP8[i2 + 32 + ((HEAPU8[i4 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
      }
     }
    }
    i8 = i1 & 255;
    i7 = i3;
    i6 = i7 + (Math_imul(i8, HEAP32[i11 + 4 >> 2] | 0) | 0) | 0;
    f14 = Math_fround(HEAPF32[i10 >> 2]);
    f17 = Math_fround(f14 * Math_fround(HEAPF32[i6 >> 2]));
    f16 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 4 >> 2]));
    i6 = i7 + (Math_imul(HEAP32[i11 + 8 >> 2] | 0, i8) | 0) | 0;
    f15 = Math_fround(HEAPF32[i10 + 4 >> 2]);
    f13 = Math_fround(f15 * Math_fround(HEAPF32[i6 >> 2]));
    f13 = Math_fround(f17 + f13);
    f16 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i6 + 4 >> 2])));
    i11 = i7 + (Math_imul(HEAP32[i11 >> 2] | 0, i8) | 0) | 0;
    f15 = Math_fround(Math_fround(1.0) - Math_fround(f14 + f15));
    f14 = Math_fround(f15 * Math_fround(HEAPF32[i11 >> 2]));
    f15 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i11 + 4 >> 2])));
    HEAPF32[i9 >> 2] = Math_fround(f13 + f14);
    HEAPF32[i9 + 4 >> 2] = f15;
   } else {
    HEAP32[i9 >> 2] = HEAP32[gb + 1162356 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
   } while (0);
   STACKTOP = i12;
   return;
  } while (0);
  HEAP32[i9 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  STACKTOP = i12;
  return;
 } while (0);
 HEAP32[i9 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 STACKTOP = i12;
 return;
}

function __ZN14EmissionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 272 | 0, i7);
 i9 = i7 + 16 | 0;
 i5 = i7 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 552 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 556 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 560 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i2;
  i1 = i2;
 }
 HEAP32[i6 + 564 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 568 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 572 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 576 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 580 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 536 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 540 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 544 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i1 = i5;
 }
 HEAP32[i6 + 548 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i6 + 584 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i2 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i9 >> 2] = i1;
  i9 = i6;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i2 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 40 | 0;
 i11 = i15 + 24 | 0;
 i10 = i15;
 i4 = i15 + 20 | 0;
 i5 = i15 + 16 | 0;
 i13 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = ((HEAP32[i13 >> 2] | 0) - i2 | 0) / 20 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i9 >>> 0) {
  if (i3 >>> 0 <= i9 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i5 = i1 + (i9 * 20 | 0) | 0;
  i2 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  i7 = i11 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 12 | 0;
  HEAP32[i8 >> 2] = i2;
  i3 = i9 * 20 | 0;
  i4 = (i3 | 0) / 20 | 0;
  if (!i3) {
   i5 = i11 + 8 | 0;
   i3 = 0;
   i4 = 0;
   i2 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
    i2 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = 73;
   HEAP32[i14 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i11 >> 2] = i2;
   i3 = i2 + (i4 * 20 | 0) | 0;
   i4 = i11 + 8 | 0;
   HEAP32[i4 >> 2] = i3;
   i6 = i2;
   if (!i9) {
    i5 = i4;
    i4 = i6;
    i2 = i6;
   } else {
    do {
     __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i2, i1);
     i1 = i1 + 20 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i5 = i4;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i11 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i13 >> 2] = i2;
  i2 = i12 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i3;
  i3 = i1;
  i2 = i10;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i1 >> 2] = 0;
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i13 = HEAP32[i8 >> 2] | 0;
   HEAP32[i14 >> 2] = 73;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  }
  STACKTOP = i15;
  return;
 }
 i6 = i12 + 8 | 0;
 if ((((HEAP32[i6 >> 2] | 0) - i2 | 0) / 20 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i12, i9 - i3 | 0);
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i10, i9);
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i11, i14);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 20 | 0;
 i4 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i10, i9 - i1 | 0);
  i2 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i3 = i3 + (i9 * 20 | 0) | 0;
  if ((i4 | 0) != (i3 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i3;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i3;
 i3 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i13 = HEAP32[i8 >> 2] | 0;
  HEAP32[i14 >> 2] = 73;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 }
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i30, i1, i6, i7, i2) {
 i30 = i30 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, i32 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i31;
 i28 = i31 + 80 | 0;
 i27 = i31 + 48 | 0;
 i29 = i31 + 32 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i30 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i30 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i30 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i30 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i26 >> 2] = i5;
 HEAP8[i26 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i23 = i26;
  i24 = HEAP32[i23 + 4 >> 2] | 0;
  i25 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i25 + 4 >> 2] = i24;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i26) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i24 = i26 + 4 | 0;
  i25 = i30 + 8 | 0;
  i6 = i6 + 12 | 0;
  i8 = i30 + 4 | 0;
  i9 = i30 + 12 | 0;
  i10 = i30 + 16 | 0;
  i11 = i29;
  i12 = i26 + 4 | 0;
  i13 = i26 + 8 | 0;
  i14 = i26 + 12 | 0;
  i15 = i26 + 16 | 0;
  i16 = i26 + 20 | 0;
  i17 = i26 + 24 | 0;
  i18 = i27 + 4 | 0;
  i19 = i27 + 8 | 0;
  i20 = i27 + 12 | 0;
  i21 = i27 + 16 | 0;
  i22 = i27 + 20 | 0;
  i23 = i27 + 24 | 0;
  do {
   i2 = HEAP32[i30 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i4 = i3 + -1 | 0;
    i5 = HEAP32[i2 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i8 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i30 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i30 >> 2] | 0;
     i3 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i26 >> 2] = i1;
   HEAP8[i24 >> 0] = 0;
   i1 = i2 + 8 | 0;
   if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i32 = i26;
    i4 = HEAP32[i32 + 4 >> 2] | 0;
    i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i32 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i26) | 0;
   mftCall_viii(HEAP32[i6 >> 2] | 0, i29 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0);
   i5 = HEAP32[i30 >> 2] | 0;
   i32 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev(i28);
   HEAP32[i26 >> 2] = i5;
   HEAP32[i12 >> 2] = i32;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   __ZNK5physx21PxSpringGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j(i28, i26, 0) | 0;
   HEAP32[i27 >> 2] = i5;
   HEAP32[i18 >> 2] = i32;
   HEAP32[i19 >> 2] = i11;
   HEAP32[i20 >> 2] = i2;
   HEAP32[i21 >> 2] = i1;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i23 >> 2] = 0;
   __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j(i28, i27, 0) | 0;
   i1 = HEAP32[i30 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i8 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i30 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   i7 = i7 + 8 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i30 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i31;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i30 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i30 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i31;
 return;
}

function __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 48 | 0;
 i6 = i16 + 40 | 0;
 i14 = i16 + 8 | 0;
 i7 = i16 + 36 | 0;
 i8 = i16 + 32 | 0;
 i1 = i16 + 28 | 0;
 i2 = i16 + 24 | 0;
 i3 = i16;
 i13 = i11 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = (HEAP32[i13 >> 2] | 0) - i4 >> 4;
 if (i5 >>> 0 >= i9 >>> 0) {
  if (i5 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i2 >> 2] = i4 + (i9 << 4);
  HEAP32[i3 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
  __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEEC2INS_11__wrap_iterIPS7_EEEET_SE_RKS8_PNS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeE(i14, i6, i15, i3, 0);
  i5 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i11 >> 2] = i5;
  i5 = i14 + 4 | 0;
  i12 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i13 >> 2] = i12;
  i12 = i14 + 8 | 0;
  i4 = i11 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i13;
  i4 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i15 + 4 | 0;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i13 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i15 >> 2] = 1;
      HEAP32[i3 >> 2] = i13;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i14 >> 2] | 0;
   }
   i14 = HEAP32[i14 + 12 >> 2] | 0;
   HEAP32[i15 >> 2] = 1;
   HEAP32[i15 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
  }
  STACKTOP = i16;
  return;
 }
 i10 = i11 + 8 | 0;
 if (((HEAP32[i10 >> 2] | 0) - i4 >> 4 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj(i11, i9 - i5 | 0);
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 i5 = i14 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i12 = i14 + 12 | 0;
 HEAP32[i12 >> 2] = i2;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE7reserveEj(i14, i9);
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE6assignINS_11__wrap_iterIPS7_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISF_E9referenceEEE5valueEvE4typeESF_SF_(i14, i6, i15);
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i3 = i2 - i4 >> 4;
 i1 = i2;
 if (i3 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj(i14, i9 - i3 | 0);
  i2 = HEAP32[i5 >> 2] | 0;
 } else if (i3 >>> 0 > i9 >>> 0) {
  i4 = i4 + (i9 << 4) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i2 = i1 + -16 | 0;
    HEAP32[i5 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i9 = HEAP32[i1 + -4 >> 2] | 0;
     HEAP32[i15 >> 2] = 1;
     HEAP32[i3 >> 2] = i9;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
     i2 = HEAP32[i5 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
   }
  }
 }
 i4 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i5 >> 2] = i11;
 HEAP32[i13 >> 2] = i2;
 i2 = i14 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i4;
 i4 = i1;
 i2 = i11;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i13 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i15 >> 2] = 1;
     HEAP32[i3 >> 2] = i13;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
     i1 = HEAP32[i5 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i14 >> 2] | 0;
  }
  i14 = HEAP32[i12 >> 2] | 0;
  HEAP32[i15 >> 2] = 1;
  HEAP32[i15 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 }
 STACKTOP = i16;
 return;
}

function runPostSets236() {
 HEAP32[gb + 212828 >> 2] = (HEAP32[gb + 212828 >> 2] | 0) + (gb + 12384 | 0);
 HEAP32[gb + 212832 >> 2] = fb + 3148;
 HEAP32[gb + 212836 >> 2] = fb + 3149;
 HEAP32[gb + 212840 >> 2] = fb + 3068;
 HEAP32[gb + 212844 >> 2] = fb + 487;
 HEAP32[gb + 212848 >> 2] = fb + 314;
 HEAP32[gb + 212852 >> 2] = fb + 488;
 HEAP32[gb + 212856 >> 2] = fb + 315;
 HEAP32[gb + 212860 >> 2] = fb + 486;
 HEAP32[gb + 212864 >> 2] = fb + 127;
 HEAP32[gb + 212868 >> 2] = fb + 313;
 HEAP32[gb + 212872 >> 2] = fb + 104;
 HEAP32[gb + 12384 >> 2] = (HEAP32[gb + 12384 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12388 >> 2] = (HEAP32[gb + 12388 >> 2] | 0) + (gb + 1080907 | 0);
 HEAP32[gb + 12392 >> 2] = (HEAP32[gb + 12392 >> 2] | 0) + (gb + 12344 | 0);
 HEAP32[gb + 212880 >> 2] = (HEAP32[gb + 212880 >> 2] | 0) + (gb + 12400 | 0);
 HEAP32[gb + 212884 >> 2] = fb + 3150;
 HEAP32[gb + 212888 >> 2] = fb + 3151;
 HEAP32[gb + 212892 >> 2] = fb + 3068;
 HEAP32[gb + 212896 >> 2] = fb + 316;
 HEAP32[gb + 212900 >> 2] = fb + 128;
 HEAP32[gb + 212904 >> 2] = fb + 129;
 HEAP32[gb + 212908 >> 2] = fb + 130;
 HEAP32[gb + 212912 >> 2] = fb + 489;
 HEAP32[gb + 212916 >> 2] = fb + 317;
 HEAP32[gb + 212920 >> 2] = fb + 490;
 HEAP32[gb + 212924 >> 2] = fb + 318;
 HEAP32[gb + 212928 >> 2] = fb + 491;
 HEAP32[gb + 212932 >> 2] = fb + 131;
 HEAP32[gb + 212936 >> 2] = fb + 319;
 HEAP32[gb + 212940 >> 2] = fb + 105;
 HEAP32[gb + 12400 >> 2] = (HEAP32[gb + 12400 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12404 >> 2] = (HEAP32[gb + 12404 >> 2] | 0) + (gb + 1080933 | 0);
 HEAP32[gb + 12408 >> 2] = (HEAP32[gb + 12408 >> 2] | 0) + (gb + 12416 | 0);
 HEAP32[gb + 12416 >> 2] = (HEAP32[gb + 12416 >> 2] | 0) + (gb + 216688 | 0);
 HEAP32[gb + 12420 >> 2] = (HEAP32[gb + 12420 >> 2] | 0) + (gb + 1080959 | 0);
 HEAP32[gb + 12432 >> 2] = (HEAP32[gb + 12432 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 12440 >> 2] = (HEAP32[gb + 12440 >> 2] | 0) + (gb + 12376 | 0);
 HEAP32[gb + 212948 >> 2] = (HEAP32[gb + 212948 >> 2] | 0) + (gb + 12448 | 0);
 HEAP32[gb + 212952 >> 2] = fb + 3152;
 HEAP32[gb + 212956 >> 2] = fb + 3153;
 HEAP32[gb + 212960 >> 2] = fb + 3068;
 HEAP32[gb + 212964 >> 2] = fb + 1503;
 HEAP32[gb + 212968 >> 2] = fb + 1504;
 HEAP32[gb + 212972 >> 2] = fb + 2350;
 HEAP32[gb + 212976 >> 2] = fb + 2351;
 HEAP32[gb + 212980 >> 2] = fb + 2352;
 HEAP32[gb + 12448 >> 2] = (HEAP32[gb + 12448 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12452 >> 2] = (HEAP32[gb + 12452 >> 2] | 0) + (gb + 1080977 | 0);
 HEAP32[gb + 12456 >> 2] = (HEAP32[gb + 12456 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 212988 >> 2] = (HEAP32[gb + 212988 >> 2] | 0) + (gb + 12464 | 0);
 HEAP32[gb + 212992 >> 2] = fb + 3154;
 HEAP32[gb + 212996 >> 2] = fb + 3155;
 HEAP32[gb + 213e3 >> 2] = fb + 3068;
 HEAP32[gb + 213004 >> 2] = fb + 1505;
 HEAP32[gb + 213008 >> 2] = fb + 1506;
 HEAP32[gb + 213012 >> 2] = fb + 2353;
 HEAP32[gb + 213016 >> 2] = fb + 2354;
 HEAP32[gb + 213020 >> 2] = fb + 2355;
 HEAP32[gb + 12464 >> 2] = (HEAP32[gb + 12464 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12468 >> 2] = (HEAP32[gb + 12468 >> 2] | 0) + (gb + 1080998 | 0);
 HEAP32[gb + 12472 >> 2] = (HEAP32[gb + 12472 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 213072 >> 2] = (HEAP32[gb + 213072 >> 2] | 0) + (gb + 12480 | 0);
 HEAP32[gb + 213076 >> 2] = fb + 3152;
 HEAP32[gb + 213080 >> 2] = fb + 3156;
 HEAP32[gb + 213084 >> 2] = fb + 3068;
 HEAP32[gb + 213088 >> 2] = fb + 1503;
 HEAP32[gb + 213092 >> 2] = fb + 1504;
 HEAP32[gb + 213096 >> 2] = fb + 2350;
 HEAP32[gb + 213100 >> 2] = fb + 2351;
 HEAP32[gb + 213104 >> 2] = fb + 2352;
 HEAP32[gb + 12480 >> 2] = (HEAP32[gb + 12480 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12484 >> 2] = (HEAP32[gb + 12484 >> 2] | 0) + (gb + 1081019 | 0);
 HEAP32[gb + 12488 >> 2] = (HEAP32[gb + 12488 >> 2] | 0) + (gb + 12448 | 0);
 HEAP32[gb + 213112 >> 2] = (HEAP32[gb + 213112 >> 2] | 0) + (gb + 12496 | 0);
 HEAP32[gb + 213116 >> 2] = fb + 3154;
 HEAP32[gb + 213120 >> 2] = fb + 3157;
 HEAP32[gb + 213124 >> 2] = fb + 3068;
 HEAP32[gb + 213128 >> 2] = fb + 1505;
 HEAP32[gb + 213132 >> 2] = fb + 1506;
 HEAP32[gb + 213136 >> 2] = fb + 2353;
 HEAP32[gb + 213140 >> 2] = fb + 2354;
 HEAP32[gb + 213144 >> 2] = fb + 2355;
 HEAP32[gb + 12496 >> 2] = (HEAP32[gb + 12496 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12500 >> 2] = (HEAP32[gb + 12500 >> 2] | 0) + (gb + 1081048 | 0);
 HEAP32[gb + 12504 >> 2] = (HEAP32[gb + 12504 >> 2] | 0) + (gb + 12464 | 0);
 HEAP32[gb + 213152 >> 2] = (HEAP32[gb + 213152 >> 2] | 0) + (gb + 11016 | 0);
 HEAP32[gb + 213156 >> 2] = fb + 3123;
 HEAP32[gb + 213160 >> 2] = fb + 3158;
 HEAP32[gb + 213164 >> 2] = fb + 3068;
 HEAP32[gb + 213172 >> 2] = (HEAP32[gb + 213172 >> 2] | 0) + (gb + 12416 | 0);
 HEAP32[gb + 213176 >> 2] = fb + 3123;
 HEAP32[gb + 213180 >> 2] = fb + 3159;
 HEAP32[gb + 213184 >> 2] = fb + 3068;
 HEAP32[gb + 213188 >> 2] = fb + 320;
 HEAP32[gb + 213192 >> 2] = fb + 132;
 HEAP32[gb + 213196 >> 2] = fb + 133;
 HEAP32[gb + 213200 >> 2] = fb + 134;
 HEAP32[gb + 213204 >> 2] = fb + 492;
 HEAP32[gb + 213208 >> 2] = fb + 321;
 runPostSets237();
}

function __ZN12TreeInstance8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932479 | 0, HEAP32[gb + 37324 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932488 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932499 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932511 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i8 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 24 | 0;
 i3 = HEAP32[gb + 36980 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 945665 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932520 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 944884 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 57; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 57; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 57) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN12CubemapArray11InitTextureEiii13TextureFormatb(i13, i2, i3, i8, i10, i9) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 36 | 0;
 i7 = i15 + 24 | 0;
 i6 = i15 + 16 | 0;
 i5 = i15 + 8 | 0;
 i1 = i15;
 i12 = i15 + 32 | 0;
 i4 = __Z15GetGraphicsCapsv() | 0;
 if (!(HEAP8[i4 + 483 >> 0] | 0)) {
  if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400020 | 0, 0, gb + 397053 | 0, 67, 1, i1, 0, 0);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!(i2 + -1 & i2)) if (!(i3 + -1 & i3)) {
  if (!(__Z20IsValidTextureFormat13TextureFormat(i10) | 0)) {
   HEAP32[i1 >> 2] = i10;
   __Z6FormatPKcz(i14, gb + 400118 | 0, i1);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 397053 | 0, 81, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
  i1 = HEAP32[i4 + 124 >> 2] | 0;
  if ((i2 | 0) < 1 | (i1 | 0) < (i2 | 0)) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 + 4 >> 2] = i1;
   __Z6FormatPKcz(i14, gb + 400167 | 0, i5);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 397053 | 0, 87, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
  if ((i3 | 0) < 1 | (i1 | 0) < (i3 | 0)) {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i1;
   __Z6FormatPKcz(i14, gb + 400233 | 0, i6);
   if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 397053 | 0, 92, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
  if ((i8 | 0) < 1) i1 = HEAP32[i4 + 136 >> 2] | 0; else {
   i1 = HEAP32[i4 + 136 >> 2] | 0;
   if ((i8 * 6 | 0) <= (i1 | 0)) {
    i11 = i13 + 80 | 0;
    HEAP32[i11 >> 2] = i2;
    i4 = i13 + 84 | 0;
    HEAP32[i4 >> 2] = i8;
    i1 = i13 + 88 | 0;
    HEAP32[i1 >> 2] = i10;
    if (i9) {
     i3 = __Z22CalculateMipMapCount3Diii(i2, i2, 1) | 0;
     i2 = HEAP32[i11 >> 2] | 0;
     i1 = HEAP32[i1 >> 2] | 0;
    } else {
     i3 = 1;
     i1 = i10;
    }
    HEAP32[i13 + 76 >> 2] = i3;
    i7 = __Z21CalculateMipMapOffsetii13TextureFormati(i2, i2, i1, i3) | 0;
    i3 = (HEAP32[i4 >> 2] | 0) * 6 | 0;
    i3 = ___muldi3(i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0, i7 | 0, 0) | 0;
    i10 = getTempRet0() | 0;
    if (i10 >>> 0 > 0 | (i10 | 0) == 0 & i3 >>> 0 > 2147483647) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400374 | 0, 0, gb + 397053 | 0, 110, 1, HEAP32[i13 + 4 >> 2] | 0, 0, 0);
     i14 = 0;
     STACKTOP = i15;
     return i14 | 0;
    }
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
    if (!i4) {
     i14 = 0;
     STACKTOP = i15;
     return i14 | 0;
    }
    _memset(i4 | 0, -1, i3 | 0) | 0;
    i5 = i13 + 92 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, gb + 63272 | 0);
    HEAP32[i5 >> 2] = 0;
    i6 = i13 + 96 | 0;
    HEAP32[i6 >> 2] = 0;
    i1 = i13 + 100 | 0;
    HEAP32[i1 >> 2] = 0;
    i2 = i13 + 104 | 0;
    if (HEAP8[i2 >> 0] | 0) {
     i10 = __Z12GetGfxDevicev() | 0;
     i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 452 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i13 + 48 >> 2];
     HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
     mftCall_vii(i9 | 0, i10 | 0, i14 | 0);
     HEAP8[i2 >> 0] = 0;
    }
    HEAP32[i5 >> 2] = i4;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i1 >> 2] = i7;
    f16 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i11 >> 2] | 0));
    HEAPF32[i13 + 68 >> 2] = f16;
    HEAPF32[i13 + 72 >> 2] = f16;
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i7 + 4 >> 2] = (i1 | 0) / 6 | 0;
  __Z6FormatPKcz(i14, gb + 400300 | 0, i7);
  if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 397053 | 0, 97, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!i13) i1 = 0; else i1 = HEAP32[i13 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400075 | 0, 0, gb + 397053 | 0, 76, 1, i1, 0, 0);
 i14 = 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN11UnityEngine9AnimationL56CalculateTransformBindingSizeBasedOnConstantOptimizationERKNS0_20AnimationSetBindingsERK13dynamic_arrayINS0_14BoundTransformELj4EEPKiPKN7mecanim9animation14AvatarConstantEb(i3, i23, i24, i1, i25) {
 i3 = i3 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i25 = i25 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29 + 32 | 0;
 i27 = i29 + 16 | 0;
 i28 = i29;
 if (i25) {
  i2 = 0;
  i22 = 0;
 } else {
  i22 = HEAP32[i1 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i21 = HEAP32[i2 >> 2] | 0;
  i2 = (i21 | 0) == 0 ? 0 : i21 + i2 | 0;
  i22 = (i22 | 0) == 0 ? 0 : i22 + i1 | 0;
 }
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i18 = i3 + 20 | 0;
 if (i1 >>> 0 >= (HEAP32[i18 >> 2] | 0) >>> 0) {
  i28 = i1;
  STACKTOP = i29;
  return i28 | 0;
 }
 i19 = i3 + 24 | 0;
 i20 = i27 + 4 | 0;
 i21 = i27 + 8 | 0;
 i16 = i28 + 4 | 0;
 i17 = i28 + 8 | 0;
 i10 = i2 + 4 | 0;
 i11 = i10;
 i12 = i28 + 12 | 0;
 i13 = i26 + 4 | 0;
 i14 = i26 + 8 | 0;
 i9 = i3 + 32 | 0;
 i2 = 0;
 i8 = i1;
 do {
  i3 = HEAP32[i19 >> 2] | 0;
  i5 = i3 + (i8 << 3) + 4 | 0;
  i7 = __ZN11UnityEngine9Animation27GetCurveCountForBindingTypeEj(HEAP32[i5 >> 2] | 0) | 0;
  L9 : do if (i25) {
   i3 = HEAP32[i24 + (i8 << 2) >> 2] | 0;
   if ((i3 | 0) == -1) {
    i2 = i7 + i2 | 0;
    break;
   }
   i3 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 * 12 | 0) + 4 >> 2] | 0;
   switch (HEAP32[i5 >> 2] | 0) {
   case 1:
    {
     __ZNK9Transform16GetLocalPositionEv(i26, i3);
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i28 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     i15 = 20;
     break L9;
    }
   case 2:
    {
     __ZNK9Transform16GetLocalRotationEv(i26, i3);
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i28 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     HEAP32[i28 + 12 >> 2] = HEAP32[i26 + 12 >> 2];
     i15 = 20;
     break L9;
    }
   case 3:
    {
     __ZNK9Transform13GetLocalScaleEv(i26, i3);
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i28 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
     HEAP32[i28 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
     i15 = 20;
     break L9;
    }
   case 4:
    {
     __ZNK9Transform16GetLocalRotationEv(i26, i3);
     __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i27, i26, 4);
     f32 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(57.2957763));
     f31 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * Math_fround(57.2957763));
     f30 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * Math_fround(57.2957763));
     HEAPF32[i28 >> 2] = f32;
     HEAPF32[i16 >> 2] = f31;
     HEAPF32[i17 >> 2] = f30;
     i15 = 20;
     break L9;
    }
   default:
    {
     i15 = 20;
     break L9;
    }
   }
  } else {
   i4 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i22, HEAP32[i3 + (i8 << 3) >> 2] | 0) | 0;
   if ((i4 | 0) == -1) {
    i2 = i7 + i2 | 0;
    break;
   }
   i3 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
   switch (HEAP32[i5 >> 2] | 0) {
   case 1:
    {
     HEAP32[i28 >> 2] = HEAP32[i3 + (i4 * 40 | 0) >> 2];
     HEAP32[i16 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 4 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 8 >> 2];
     i15 = 20;
     break L9;
    }
   case 2:
    {
     HEAP32[i28 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 12 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 16 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 20 >> 2];
     HEAP32[i12 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 24 >> 2];
     i15 = 20;
     break L9;
    }
   case 4:
    {
     __ZN4mathL11quatToEulerERKNS_7_float4ENS_13RotationOrderE(i26, i3 + (i4 * 40 | 0) + 12 | 0);
     HEAP32[i28 >> 2] = HEAP32[i26 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
     i15 = 20;
     break L9;
    }
   case 3:
    {
     HEAP32[i28 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 28 >> 2];
     HEAP32[i16 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 32 >> 2];
     HEAP32[i17 >> 2] = HEAP32[i3 + (i4 * 40 | 0) + 36 >> 2];
     i15 = 20;
     break L9;
    }
   default:
    {
     i15 = 20;
     break L9;
    }
   }
  } while (0);
  if ((i15 | 0) == 20) {
   i15 = 0;
   if ((i7 | 0) > 0) {
    i5 = HEAP32[i9 >> 2] | 0;
    i6 = i8 + 1 | 0;
    i4 = 0;
    i3 = i2;
    while (1) {
     f32 = Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]);
     f32 = Math_fround(f32 - Math_fround(HEAPF32[i28 + (i4 << 2) >> 2]));
     i33 = f32 < Math_fround(0.0);
     f31 = Math_fround(-f32);
     i33 = (i33 ? f31 : f32) <= Math_fround(9.99999974e-06);
     i1 = i33 ? i1 : i6;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i7 | 0)) break; else i3 = i3 + 1 | 0;
    }
    i2 = i7 + i2 | 0;
   }
  }
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
 STACKTOP = i29;
 return i1 | 0;
}

function __ZN11ShapeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i1 = i7 + 4 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 32 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 44 | 0, i5);
 __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 48 | 0, i5);
 __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 52 | 0, i5);
 i1 = i7 + 56 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 213 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 214 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 212 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 204 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 208 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i13 = i15;
 i3 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i8 + (i7 * 24 | 0) + 12 >> 2] | 0) != (HEAP32[i10 + (i9 * 24 | 0) + 12 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP16[i8 + (i7 * 24 | 0) >> 1] | 0) != (HEAP16[i10 + (i9 * 24 | 0) >> 1] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = HEAP32[i8 + (i7 * 24 | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[gb + 36932 >> 2] | 0;
 i1 = ((i1 | 0) < 0 ? i6 : i2) + (i1 & 2147483647) | 0;
 i4 = HEAP32[i10 + (i9 * 24 | 0) + 8 >> 2] | 0;
 i5 = HEAP32[i11 + 20 >> 2] | 0;
 i4 = ((i4 | 0) < 0 ? i6 : i5) + (i4 & 2147483647) | 0;
 do if (!i4) i14 = 5; else if (!i1) {
  i1 = 0;
  i14 = 5;
 } else {
  i16 = HEAP32[gb + 36936 >> 2] | 0;
  if (i16 >>> 0 > i4 >>> 0 & ((i6 >>> 0 > i4 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i16 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i4 | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  } else {
   if (!(_strcmp(i4, i1) | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 if ((i14 | 0) == 5) if ((i1 | 0) != (i4 | 0)) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 i1 = HEAP32[i8 + (i7 * 24 | 0) + 4 >> 2] | 0;
 i1 = ((i1 | 0) < 0 ? i6 : i2) + (i1 & 2147483647) | 0;
 i2 = HEAP32[i10 + (i9 * 24 | 0) + 4 >> 2] | 0;
 i2 = ((i2 | 0) < 0 ? i6 : i5) + (i2 & 2147483647) | 0;
 do if (!i2) i14 = 11; else if (!i1) {
  i1 = 0;
  i14 = 11;
 } else {
  i16 = HEAP32[gb + 36936 >> 2] | 0;
  if (i16 >>> 0 > i2 >>> 0 & ((i6 >>> 0 > i2 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i16 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) break; else i1 = 0;
   STACKTOP = i15;
   return i1 | 0;
  }
 } while (0);
 if ((i14 | 0) == 11) if ((i1 | 0) != (i2 | 0)) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 if ((HEAP32[i10 + (i9 * 24 | 0) + 20 >> 2] ^ HEAP32[i8 + (i7 * 24 | 0) + 20 >> 2]) & 16384 | 0) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 }
 i1 = i8 + (i7 * 24 | 0) | 0;
 if ((i1 + 24 | 0) >>> 0 < (i8 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i1 + 26 >> 0] | 0) == ((HEAPU8[i8 + (i7 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i4 = i7 + 1 | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i4;
 } else i14 = 19; else i14 = 19;
 if ((i14 | 0) == 19) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i4 = 0;
  i3 = 0;
 }
 i1 = i10 + (i9 * 24 | 0) | 0;
 if ((i1 + 24 | 0) >>> 0 < (i10 + ((HEAP32[i11 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i1 + 26 >> 0] | 0) == ((HEAPU8[i10 + (i9 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i2 = i9 + 1 | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i2;
  i1 = i11;
 } else i14 = 23; else i14 = 23;
 if ((i14 | 0) == 23) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
 }
 i10 = i12 + 4 | 0;
 i9 = i13 + 4 | 0;
 i8 = i1;
 while (1) {
  i1 = (i8 | 0) == 0;
  if (!i3) {
   if (i1) {
    i14 = 42;
    break;
   }
   if ((i3 | 0) == 0 | (i8 | 0) == 0) {
    i14 = 41;
    break;
   }
  } else if (i1) {
   i14 = 41;
   break;
  }
  if (!(__Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_(i12, i13) | 0)) {
   i14 = 41;
   break;
  }
  i16 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP8[i16 + (i4 * 24 | 0) + 2 >> 0] | 0;
  i6 = i16 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0;
  i7 = i16;
  i4 = i16 + (i4 * 24 | 0) | 0;
  while (1) {
   i1 = i4;
   i4 = i4 + 24 | 0;
   if (i4 >>> 0 >= i6 >>> 0) {
    i3 = 0;
    i4 = 0;
    break;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
   if ((i1 & 255) <= (i5 & 255)) {
    i14 = 33;
    break;
   }
  }
  if ((i14 | 0) == 33) {
   i14 = 0;
   if (i1 << 24 >> 24 == i5 << 24 >> 24) i4 = (i4 - i7 | 0) / 24 | 0; else {
    i3 = 0;
    i4 = 0;
   }
  }
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i4;
  i16 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP8[i16 + (i2 * 24 | 0) + 2 >> 0] | 0;
  i6 = i16 + ((HEAP32[i8 + 12 >> 2] | 0) * 24 | 0) | 0;
  i7 = i16;
  i2 = i16 + (i2 * 24 | 0) | 0;
  while (1) {
   i1 = i2;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i6 >>> 0) {
    i1 = 0;
    i2 = 0;
    break;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
   if ((i1 & 255) <= (i5 & 255)) {
    i14 = 38;
    break;
   }
  }
  if ((i14 | 0) == 38) {
   i14 = 0;
   if (i1 << 24 >> 24 == i5 << 24 >> 24) {
    i1 = i8;
    i2 = (i2 - i7 | 0) / 24 | 0;
   } else {
    i1 = 0;
    i2 = 0;
   }
  }
  HEAP32[i13 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i8 = i1;
 }
 if ((i14 | 0) == 41) {
  i16 = 0;
  STACKTOP = i15;
  return i16 | 0;
 } else if ((i14 | 0) == 42) {
  i16 = 1;
  STACKTOP = i15;
  return i16 | 0;
 }
 return 0;
}

function __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext(i13, i1, i2, i16, i6, i4, i3, i17) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 20 | 0;
 i18 = i19 + 4 | 0;
 i7 = i19 + 16 | 0;
 i14 = i19 + 12 | 0;
 i5 = i19 + 8 | 0;
 i15 = i19;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i14 >> 2] = i2;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 if (!(HEAP32[i16 + 12 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i10 = HEAP32[i13 + 8 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i10 + 1144 >> 2] | 0) + 136 >> 2] | 0;
 i8 = i3 ? 4 : 36;
 if (!i4) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) if (HEAP32[i10 + 1072 >> 2] & 1 | 0) {
  if ((HEAP16[gb + 1115208 + 6 >> 1] | 0) > -1) {
   HEAP32[i18 >> 2] = i10;
   HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115208 | 0, i12);
   i1 = gb + 1115208 | 0;
  } else i1 = 0;
  i4 = HEAP32[gb + 1115208 >> 2] | 0;
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 648 >> 2] | 0, i3 | 0, i4 | 0);
  if (i6) __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i7 >> 2] | 0, 0, -1, 0, 0); else {
   HEAP32[i18 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + 128 >> 2];
   HEAP32[i5 >> 2] = i9;
   HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
   __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i18, i12, i7, 0, -1, 0, 0) | 0;
  }
  __Z20RenderSceneDepthPassRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext(i16, HEAP32[i13 + 1828 >> 2] | 0, i13 + 1880 | 0, 0, i17);
  __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(i10, i17, i8);
  i7 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 652 >> 2] | 0, i7 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if (!(HEAP32[i14 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 if (!(HEAP32[i10 + 1072 >> 2] & 2)) {
  STACKTOP = i19;
  return;
 }
 i4 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 4) | 0;
 if (!(HEAP32[i4 + 4 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i18 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i18);
   i2 = HEAP32[i12 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 24;
  }
 }
 if ((i11 | 0) == 22) i11 = 24;
 if ((i11 | 0) == 24) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i19;
   return;
  }
 }
 if ((HEAP16[gb + 1115220 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = i10;
  HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115220 | 0, i12);
  i2 = gb + 1115220 | 0;
 } else i2 = 0;
 i11 = HEAP32[gb + 1115220 >> 2] | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 648 >> 2] | 0, i7 | 0, i11 | 0);
 HEAP32[i18 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + 128 >> 2];
 HEAP32[i15 >> 2] = i9;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i18, i12, i14, 0, -1, 0, 0) | 0;
 i18 = HEAP32[i13 + 1828 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 469949 | 0, 10);
 __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEER17ShaderPassContext(i16, i18, i1, i12, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(i10, i17, i8);
 i18 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 652 >> 2] | 0, i18 | 0);
 if (!i2) {
  STACKTOP = i19;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i19;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E13find_positionERS5_(i21, i2, i1) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = (HEAP32[i2 + 104 >> 2] | 0) + -1 | 0;
 i19 = HEAP32[i1 >> 2] | 0;
 i20 = HEAP32[i1 + 4 >> 2] | 0;
 switch (i20 | 0) {
 case 2:
 case 4:
  {
   i3 = 131074;
   break;
  }
 default:
  i3 = i20 * 65537 | 0;
 }
 i29 = HEAP32[i2 + 100 >> 2] | 0;
 i22 = HEAP32[i2 + 56 >> 2] | 0;
 i23 = i2 + 60 | 0;
 i24 = i2 + 64 | 0;
 i25 = i2 + 68 | 0;
 i26 = i2 + 8 | 0;
 i27 = HEAP32[i1 + 8 >> 2] | 0;
 i14 = HEAP32[i1 + 12 >> 2] | 0;
 i12 = i14 & 65535;
 i13 = i14 >>> 24 & 255;
 i14 = i14 >>> 16 & 255;
 i15 = i2 + 4 | 0;
 i16 = i2 + 12 | 0;
 i17 = i2 + 16 | 0;
 i18 = i2 + 20 | 0;
 i11 = i2 + 24 | 0;
 i9 = 0;
 i10 = -1;
 i1 = i3 ^ i19;
 L4 : while (1) {
  i8 = i1 & i28;
  i7 = HEAP32[i29 + (i8 * 44 | 0) >> 2] | 0;
  L6 : do if ((i22 | 0) == (i7 | 0)) {
   i5 = HEAP32[i23 >> 2] | 0;
   switch (i5 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i5;
   }
   i6 = HEAP32[i29 + (i8 * 44 | 0) + 4 >> 2] | 0;
   switch (i6 | 0) {
   case 2:
   case 4:
    {
     i2 = 2;
     break;
    }
   default:
    i2 = i6;
   }
   if ((i1 | 0) == (i2 | 0)) if ((HEAP32[i24 >> 2] | 0) == (HEAP32[i29 + (i8 * 44 | 0) + 8 >> 2] | 0)) {
    i1 = HEAP32[i25 >> 2] | 0;
    i2 = HEAP32[i29 + (i8 * 44 | 0) + 12 >> 2] | 0;
    i3 = i1 >>> 24 & 255;
    i4 = i2 >>> 24 & 255;
    if ((i1 & 65535) << 16 >> 16 == (i2 & 65535) << 16 >> 16) {
     if ((i1 >>> 16 & 255) << 24 >> 24 != (i2 >>> 16 & 255) << 24 >> 24) {
      switch (i5 | 0) {
      case 2:
      case 4:
       break;
      default:
       break L6;
      }
      switch (i6 | 0) {
      case 2:
      case 4:
       break;
      default:
       break L6;
      }
     }
     if (i3 << 24 >> 24 == i4 << 24 >> 24) break L4;
    }
   }
  } while (0);
  L22 : do if (!(HEAP8[i26 >> 0] | 0)) i30 = 34; else if (!(HEAP32[i15 >> 2] | 0)) i30 = 34; else if ((HEAP32[i16 >> 2] | 0) == (i7 | 0)) {
   i5 = HEAP32[i17 >> 2] | 0;
   switch (i5 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i5;
   }
   i6 = HEAP32[i29 + (i8 * 44 | 0) + 4 >> 2] | 0;
   switch (i6 | 0) {
   case 2:
   case 4:
    {
     i2 = 2;
     break;
    }
   default:
    i2 = i6;
   }
   if ((i1 | 0) == (i2 | 0)) if ((HEAP32[i18 >> 2] | 0) == (HEAP32[i29 + (i8 * 44 | 0) + 8 >> 2] | 0)) {
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i29 + (i8 * 44 | 0) + 12 >> 2] | 0;
    i3 = i1 >>> 24 & 255;
    i4 = i2 >>> 24 & 255;
    if ((i1 & 65535) << 16 >> 16 == (i2 & 65535) << 16 >> 16) {
     if ((i1 >>> 16 & 255) << 24 >> 24 != (i2 >>> 16 & 255) << 24 >> 24) {
      switch (i5 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i30 = 34;
        break L22;
       }
      }
      switch (i6 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i30 = 34;
        break L22;
       }
      }
     }
     if (i3 << 24 >> 24 == i4 << 24 >> 24) i1 = (i10 | 0) == -1 ? i8 : i10; else i30 = 34;
    } else i30 = 34;
   } else i30 = 34; else i30 = 34;
  } else i30 = 34; while (0);
  L40 : do if ((i30 | 0) == 34) {
   i30 = 0;
   if ((i19 | 0) == (i7 | 0)) {
    switch (i20 | 0) {
    case 2:
    case 4:
     {
      i1 = 2;
      break;
     }
    default:
     i1 = i20;
    }
    i3 = HEAP32[i29 + (i8 * 44 | 0) + 4 >> 2] | 0;
    switch (i3 | 0) {
    case 2:
    case 4:
     {
      i2 = 2;
      break;
     }
    default:
     i2 = i3;
    }
    if ((i1 | 0) == (i2 | 0)) if ((i27 | 0) == (HEAP32[i29 + (i8 * 44 | 0) + 8 >> 2] | 0)) {
     i2 = HEAP32[i29 + (i8 * 44 | 0) + 12 >> 2] | 0;
     i1 = i2 >>> 24 & 255;
     if (i12 << 16 >> 16 == (i2 & 65535) << 16 >> 16) {
      if (i14 << 24 >> 24 != (i2 >>> 16 & 255) << 24 >> 24) {
       switch (i20 | 0) {
       case 2:
       case 4:
        break;
       default:
        {
         i1 = i10;
         break L40;
        }
       }
       switch (i3 | 0) {
       case 2:
       case 4:
        break;
       default:
        {
         i1 = i10;
         break L40;
        }
       }
      }
      if (i13 << 24 >> 24 == i1 << 24 >> 24) {
       i30 = 46;
       break L4;
      } else i1 = i10;
     } else i1 = i10;
    } else i1 = i10; else i1 = i10;
   } else i1 = i10;
  } while (0);
  i7 = i9 + 1 | 0;
  i9 = i7;
  i10 = i1;
  i1 = i7 + i8 | 0;
 }
 if ((i30 | 0) == 46) {
  HEAP32[i21 >> 2] = i8;
  HEAP32[i21 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i21 >> 2] = -1;
 i1 = i21 + 4 | 0;
 if ((i10 | 0) == -1) {
  HEAP32[i1 >> 2] = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = i10;
  return;
 }
}

function __ZN14ParticleSystem15ThreadedCleanupEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = i11 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 468 | 0;
  if ((HEAP32[i2 + 484 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 472 | 0);
   HEAP32[i3 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i11 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i1 = i3 + 232 | 0;
  if ((HEAP32[i3 + 248 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 236 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + 144 | 0;
  if ((HEAP32[i3 + 160 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 148 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63264 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i11 + 868 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 872 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 876 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 880 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 884 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 904 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 888 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 912 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 916 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i11 + 920 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i11 + 860 | 0;
 i3 = i11 + 900 | 0;
 i4 = i11 + 44 | 0;
 i5 = i11 + 856 | 0;
 i6 = i11 + 896 | 0;
 i7 = i11 + 852 | 0;
 i8 = i11 + 892 | 0;
 i9 = i11 + 864 | 0;
 i10 = i11 + 908 | 0;
 i11 = i11 + 32 | 0;
 i1 = (HEAP32[i11 >> 2] | 0) + 884 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i5 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i6 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i7 >> 2] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i9 >> 2] = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) __ZN23ParticleSystemParticlesD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[i11 >> 2] = 0;
 return;
}

function __ZN8WindZone8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i5, i9);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8WindZone12WindZoneModeEEvRT_RT0_PKc17TransferMetaFlags(i9, i5 + 36 | 0, gb + 1034151 | 0, 0);
 i4 = i5 + 40 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843745 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 486995 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 487006 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 487023 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 487044 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 50; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 50; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 50) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _UNITY_LZ4_decompress_fast_withPrefix64k(i14, i2, i1) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i12 = i2 + i1 | 0;
 i13 = i12 + -12 | 0;
 if (!i1) {
  i15 = (HEAP8[i14 >> 0] | 0) == 0 ? 1 : -1;
  return i15 | 0;
 }
 i9 = i12 + -5 | 0;
 i10 = i12 + -8 | 0;
 i11 = i10;
 i3 = i14;
 L5 : while (1) {
  i1 = i3 + 1 | 0;
  i7 = HEAPU8[i3 >> 0] | 0;
  i3 = i7 >>> 4;
  if ((i3 | 0) == 15) {
   i3 = 15;
   while (1) {
    i4 = i1 + 1 | 0;
    i8 = HEAP8[i1 >> 0] | 0;
    i3 = (i8 & 255) + i3 | 0;
    if (i8 << 24 >> 24 == -1) i1 = i4; else {
     i1 = i4;
     break;
    }
   }
  }
  i8 = i2 + i3 | 0;
  if (i8 >>> 0 > i10 >>> 0) {
   i15 = 7;
   break;
  } else i4 = i1;
  while (1) {
   i5 = i4;
   i17 = i5;
   i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i2;
   i16 = i6;
   HEAP8[i16 >> 0] = i17;
   HEAP8[i16 + 1 >> 0] = i17 >> 8;
   HEAP8[i16 + 2 >> 0] = i17 >> 16;
   HEAP8[i16 + 3 >> 0] = i17 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i8 >>> 0) break; else i4 = i4 + 8 | 0;
  }
  i1 = i1 + i3 | 0;
  i4 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
  i5 = i4 & 65535;
  i6 = i8 + (0 - i4) | 0;
  i1 = i1 + 2 | 0;
  i2 = i7 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   while (1) {
    i3 = i1 + 1 | 0;
    i17 = HEAP8[i1 >> 0] | 0;
    i2 = (i17 & 255) + i2 | 0;
    if (i17 << 24 >> 24 == -1) i1 = i3; else {
     i1 = i3;
     break;
    }
   }
  }
  i2 = i8 + (i2 + 4) | 0;
  if ((i5 & 65535) < 8) {
   i17 = HEAP32[gb + 74112 + (i4 << 2) >> 2] | 0;
   HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
   i4 = i6 + (HEAP32[gb + 74144 + (i4 << 2) >> 2] | 0) | 0;
   i16 = i8 + 4 | 0;
   i7 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   HEAP8[i16 >> 0] = i7;
   HEAP8[i16 + 1 >> 0] = i7 >> 8;
   HEAP8[i16 + 2 >> 0] = i7 >> 16;
   HEAP8[i16 + 3 >> 0] = i7 >> 24;
   i4 = i4 + (0 - i17) | 0;
  } else {
   i17 = i6;
   i7 = i17;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i17 = i17 + 4 | 0;
   i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
   i4 = i8;
   i16 = i4;
   HEAP8[i16 >> 0] = i7;
   HEAP8[i16 + 1 >> 0] = i7 >> 8;
   HEAP8[i16 + 2 >> 0] = i7 >> 16;
   HEAP8[i16 + 3 >> 0] = i7 >> 24;
   i4 = i4 + 4 | 0;
   HEAP8[i4 >> 0] = i17;
   HEAP8[i4 + 1 >> 0] = i17 >> 8;
   HEAP8[i4 + 2 >> 0] = i17 >> 16;
   HEAP8[i4 + 3 >> 0] = i17 >> 24;
   i4 = i6 + 8 | 0;
  }
  i3 = i8 + 8 | 0;
  if (i2 >>> 0 <= i13 >>> 0) while (1) {
   i16 = i4;
   i7 = i16;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i16 = i16 + 4 | 0;
   i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
   i17 = i3;
   i8 = i17;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i17 = i17 + 4 | 0;
   HEAP8[i17 >> 0] = i16;
   HEAP8[i17 + 1 >> 0] = i16 >> 8;
   HEAP8[i17 + 2 >> 0] = i16 >> 16;
   HEAP8[i17 + 3 >> 0] = i16 >> 24;
   i3 = i3 + 8 | 0;
   if (i3 >>> 0 < i2 >>> 0) i4 = i4 + 8 | 0; else {
    i3 = i1;
    continue L5;
   }
  }
  if (i2 >>> 0 > i9 >>> 0) break;
  if (i3 >>> 0 < i10 >>> 0) {
   i5 = i3;
   i6 = i4;
   while (1) {
    i16 = i6;
    i7 = i16;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i16 = i16 + 4 | 0;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i17 = i5;
    i8 = i17;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i17 = i17 + 4 | 0;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i5 = i5 + 8 | 0;
    if (i5 >>> 0 >= i10 >>> 0) break; else i6 = i6 + 8 | 0;
   }
   i4 = i4 + (i11 - i3) | 0;
   i3 = i10;
  }
  if (i3 >>> 0 >= i2 >>> 0) {
   i3 = i1;
   continue;
  }
  while (1) {
   i5 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i4 = i4 + 1 | 0;
    i3 = i5;
   } else {
    i3 = i1;
    continue L5;
   }
  }
 }
 if ((i15 | 0) == 7) if ((i8 | 0) == (i12 | 0)) {
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  i17 = i1 + i3 - i14 | 0;
  return i17 | 0;
 }
 i17 = i14 + -1 - i1 | 0;
 return i17 | 0;
}

function _wordexp(i10, i19, i7) {
 i10 = i10 | 0;
 i19 = i19 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 8 | 0;
 i12 = i21;
 i17 = i21 + 180 | 0;
 i18 = i21 + 176 | 0;
 i14 = i21 + 168 | 0;
 i9 = i21 + 40 | 0;
 i20 = i21 + 32 | 0;
 _pthread_setcancelstate(1, i20 | 0) | 0;
 i11 = i7 & 16 | 0 ? gb + 1576256 | 0 : gb + 1073957 | 0;
 if (i7 & 8 | 0) _wordfree(i19);
 L4 : do if (!(i7 & 4)) i8 = 20; else {
  i2 = HEAP8[i10 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i8 = 20; else {
   i1 = 0;
   i6 = 0;
   i3 = 0;
   i4 = 0;
   while (1) {
    switch (i2 << 24 >> 24 | 0) {
    case 92:
     {
      i1 = ((i6 | 0) == 0 & 1) + i1 | 0;
      i5 = i6;
      break;
     }
    case 39:
     {
      i5 = (i3 | 0) == 0 ^ i6;
      break;
     }
    case 34:
     {
      i5 = i6;
      i3 = (i6 | 0) == 0 ^ i3;
      break;
     }
    case 40:
     {
      if (!i4) i8 = 13; else {
       i5 = i6;
       i4 = i4 + 1 | 0;
      }
      break;
     }
    case 41:
     {
      if (!i4) i8 = 13; else {
       i5 = i6;
       i4 = i4 + -1 | 0;
      }
      break;
     }
    case 125:
    case 123:
    case 62:
    case 60:
    case 59:
    case 38:
    case 124:
    case 10:
     {
      i8 = 13;
      break;
     }
    case 36:
     {
      if (!i6) if ((HEAP8[i10 + (i1 + 1) >> 0] | 0) == 40) {
       i1 = i1 + 2 | 0;
       if ((HEAP8[i10 + i1 >> 0] | 0) != 40) {
        i1 = 4;
        break L4;
       }
       i5 = 0;
       i4 = i4 + 2 | 0;
      } else i5 = 0; else i5 = i6;
      break;
     }
    case 96:
     {
      if (!i6) {
       i1 = 4;
       break L4;
      } else i5 = i6;
      break;
     }
    default:
     i5 = i6;
    }
    if ((i8 | 0) == 13) {
     i8 = 0;
     if (!(i3 | i6 | i4)) {
      i1 = 2;
      break L4;
     } else i5 = i6;
    }
    i1 = i1 + 1 | 0;
    i2 = HEAP8[i10 + i1 >> 0] | 0;
    if (!(i2 << 24 >> 24)) {
     i8 = 20;
     break L4;
    } else i6 = i5;
   }
  }
 } while (0);
 L24 : do if ((i8 | 0) == 20) {
  i2 = (i7 & 2 | 0) != 0;
  if (i2) {
   i3 = HEAP32[i19 + 4 >> 2] | 0;
   i5 = HEAP32[i19 >> 2] | 0;
  } else {
   i3 = 0;
   i5 = 0;
  }
  i15 = (i7 & 1 | 0) != 0;
  i16 = i19 + 8 | 0;
  if (i15) {
   i1 = HEAP32[i16 >> 2] | 0;
   if (i1 >>> 0 <= 268435455) {
    i5 = i1 + i5 | 0;
    i8 = 26;
   }
  } else {
   HEAP32[i16 >> 2] = 0;
   i8 = 26;
  }
  do if ((i8 | 0) == 26) if ((_pipe2(i14, 524288) | 0) >= 0) {
   ___block_all_sigs(i9 | 0);
   i8 = _fork() | 0;
   ___restore_sigs(i9 | 0);
   if ((i8 | 0) < 0) {
    _close(HEAP32[i14 >> 2] | 0) | 0;
    _close(HEAP32[i14 + 4 >> 2] | 0) | 0;
    break;
   }
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   if (!i8) {
    if ((i1 | 0) == 1) {
     HEAP32[i12 >> 2] = 0;
     _fcntl(1, 2, i12) | 0;
    } else _dup2(i1, 1) | 0;
    HEAP32[i13 >> 2] = gb + 1075257;
    HEAP32[i13 + 4 >> 2] = gb + 1073969;
    HEAP32[i13 + 8 >> 2] = gb + 1075254;
    HEAP32[i13 + 12 >> 2] = i10;
    HEAP32[i13 + 16 >> 2] = i11;
    HEAP32[i13 + 20 >> 2] = 0;
    _execl(gb + 1075260 | 0, gb + 1075254 | 0, i13 | 0) | 0;
    __exit(1);
   }
   _close(i1) | 0;
   i7 = mftCall_iii(fb + 513 | 0, HEAP32[i14 >> 2] | 0, gb + 1084155 | 0) | 0;
   if (!i7) {
    _close(HEAP32[i14 >> 2] | 0) | 0;
    _kill(i8 | 0, 9) | 0;
    _reap(i8);
    break;
   }
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i14 = (_getdelim(i17, i18, 0, i7) | 0) < 0;
   _free(i14 ? 0 : HEAP32[i17 >> 2] | 0);
   if (_feof(i7) | 0) {
    _fclose(i7) | 0;
    _reap(i8);
    i1 = 5;
    break L24;
   }
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i14 = (_getdelim(i17, i18, 0, i7) | 0) < 0;
   i1 = HEAP32[i17 >> 2] | 0;
   L52 : do if (!(i14 | (i1 | 0) == 0)) {
    i2 = i3 | 0 ? i5 + 1 | 0 : 0;
    while (1) {
     i6 = i5 + 1 | 0;
     if (i6 >>> 0 >= i2 >>> 0) {
      i2 = i2 + 10 + (i2 >>> 1) | 0;
      i4 = _realloc(i3, i2 << 2) | 0;
      if (!i4) break L52;
      i3 = i4;
     }
     HEAP32[i3 + (i5 << 2) >> 2] = i1;
     HEAP32[i3 + (i6 << 2) >> 2] = 0;
     HEAP32[i17 >> 2] = 0;
     HEAP32[i18 >> 2] = 0;
     i14 = (_getdelim(i17, i18, 0, i7) | 0) < 0;
     i1 = HEAP32[i17 >> 2] | 0;
     if (i14 | (i1 | 0) == 0) {
      i5 = i6;
      break;
     } else i5 = i6;
    }
   } while (0);
   i1 = (_feof(i7) | 0) == 0 & 1;
   _fclose(i7) | 0;
   _reap(i8);
   if (!i3) i3 = _calloc(i5 + 1 | 0, 4) | 0;
   i4 = i19 + 4 | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i19 >> 2] = i5;
   if (!i15) break L24;
   i2 = HEAP32[i16 >> 2] | 0;
   if (i3) if (!i2) i2 = 0; else {
    i18 = i2 + -1 | 0;
    HEAP32[i3 + (i18 << 2) >> 2] = 0;
    if (i18) _memset(HEAP32[i4 >> 2] | 0, 0, (i2 << 2) + -4 | 0) | 0;
   }
   HEAP32[i19 >> 2] = i5 - i2;
   break L24;
  } while (0);
  if (i2) i1 = 1; else {
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   i1 = 1;
  }
 } while (0);
 _pthread_setcancelstate(HEAP32[i20 >> 2] | 0, 0) | 0;
 STACKTOP = i21;
 return i1 | 0;
}

function __ZN5physx19NpArticulationJoint12setChildPoseERKNS_11PxTransformE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 28 | 0;
 i11 = i21;
 i20 = i6 + 8 | 0;
 i12 = HEAP32[i6 + 200 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 124 >> 2] | 0, i11 | 0, i12 | 0);
 f33 = Math_fround(HEAPF32[i1 >> 2]);
 f35 = Math_fround(f33 * f33);
 f31 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f31 * f31));
 f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f35 = Math_fround(f35 + Math_fround(f29 * f29));
 f28 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f35 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f35 + Math_fround(f28 * f28)))));
 f33 = Math_fround(f33 * f35);
 f31 = Math_fround(f31 * f35);
 f29 = Math_fround(f29 * f35);
 f35 = Math_fround(f28 * f35);
 f28 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f27 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f32 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 f30 = Math_fround(-Math_fround(HEAPF32[i11 + 4 >> 2]));
 f25 = Math_fround(-Math_fround(HEAPF32[i11 + 8 >> 2]));
 f34 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i11 + 16 >> 2]));
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i11 + 20 >> 2]));
 f28 = Math_fround(f28 * Math_fround(2.0));
 f27 = Math_fround(f27 * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f26 - Math_fround(HEAPF32[i11 + 24 >> 2])) * Math_fround(2.0));
 f36 = Math_fround(Math_fround(f34 * f34) + Math_fround(-.5));
 f22 = Math_fround(Math_fround(Math_fround(f28 * f32) + Math_fround(f27 * f30)) + Math_fround(f26 * f25));
 f24 = Math_fround(Math_fround(f22 * f32) + Math_fround(Math_fround(f36 * f28) + Math_fround(f34 * Math_fround(Math_fround(f26 * f30) - Math_fround(f27 * f25)))));
 f23 = Math_fround(Math_fround(f22 * f30) + Math_fround(Math_fround(f36 * f27) + Math_fround(f34 * Math_fround(Math_fround(f28 * f25) - Math_fround(f26 * f32)))));
 f22 = Math_fround(Math_fround(Math_fround(f36 * f26) + Math_fround(f34 * Math_fround(Math_fround(f27 * f32) - Math_fround(f28 * f30)))) + Math_fround(f22 * f25));
 f28 = Math_fround(Math_fround(Math_fround(f29 * f30) + Math_fround(Math_fround(f35 * f32) + Math_fround(f33 * f34))) - Math_fround(f31 * f25));
 f27 = Math_fround(Math_fround(Math_fround(f33 * f25) + Math_fround(Math_fround(f35 * f30) + Math_fround(f31 * f34))) - Math_fround(f29 * f32));
 f26 = Math_fround(Math_fround(Math_fround(f31 * f32) + Math_fround(Math_fround(f35 * f25) + Math_fround(f29 * f34))) - Math_fround(f33 * f30));
 f25 = Math_fround(Math_fround(Math_fround(Math_fround(f35 * f34) - Math_fround(f33 * f32)) - Math_fround(f31 * f30)) - Math_fround(f29 * f25));
 HEAPF32[i15 >> 2] = f28;
 i11 = i15 + 4 | 0;
 HEAPF32[i11 >> 2] = f27;
 i12 = i15 + 8 | 0;
 HEAPF32[i12 >> 2] = f26;
 i14 = i15 + 12 | 0;
 HEAPF32[i14 >> 2] = f25;
 HEAPF32[i15 + 16 >> 2] = f24;
 i16 = i15 + 20 | 0;
 HEAPF32[i16 >> 2] = f23;
 i18 = i15 + 24 | 0;
 HEAPF32[i18 >> 2] = f22;
 i5 = i6 + 20 | 0;
 i19 = i6 + 12 | 0;
 i9 = HEAP32[i19 >> 2] | 0;
 i10 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 switch (i9 >>> 30 | 0) {
 case 3:
  {
   i17 = i20;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i20 >> 2] | 0) + 2433 >> 0] | 0)) i8 = 4; else i17 = i20;
   break;
  }
 default:
  i8 = 4;
 }
 if ((i8 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE(i5, i15);
  STACKTOP = i21;
  return;
 }
 i5 = i6 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  i6 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i17 >> 2] | 0, i9 >>> 24 & 15) | 0;
  HEAP32[i5 >> 2] = i6;
  i10 = HEAP32[i15 >> 2] | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i15 + 16 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i18 >> 2] | 0;
 } else i5 = i13;
 HEAP32[i6 + 28 >> 2] = i10;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP32[i6 + 36 >> 2] = i5;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = i3;
 HEAP32[i6 + 48 >> 2] = i2;
 HEAP32[i6 + 52 >> 2] = i1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i17 >> 2] | 0, i20);
 HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
 STACKTOP = i21;
 return;
}

function __ZN11UnityEngine9Analytics16TransactionEventC2ERK8UnityStrdS4_S4_S4_yb(i18, i4, d10, i12, i16, i17, i13, i14, i15) {
 i18 = i18 | 0;
 i4 = i4 | 0;
 d10 = +d10;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i18, gb + 1037891 | 0, 1);
 HEAP32[i18 >> 2] = gb + 188628 + 8;
 i9 = i18 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i18 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = i18 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i18 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i2 = i18 + 84 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i18 + 96 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = i18 + 100 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i18 + 112 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 do if ((i9 | 0) != (i4 | 0)) {
  i8 = HEAP8[i4 + 11 >> 0] | 0;
  i6 = i8 << 24 >> 24 < 0;
  i11 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
  i8 = i6 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
  i6 = i9 + 11 | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  if (i5) i7 = (HEAP32[i18 + 40 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
  if (i8 >>> 0 > i7 >>> 0) {
   if (i5) i4 = HEAP32[i18 + 36 >> 2] | 0; else i4 = i4 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i7, i8 - i7 | 0, i4, 0, i4, i8, i11);
   break;
  }
  if (i5) i4 = HEAP32[i9 >> 2] | 0; else i4 = i9;
  if (i8 | 0) _memmove(i4 | 0, i11 | 0, i8 | 0) | 0;
  HEAP8[i4 + i8 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i18 + 36 >> 2] = i8;
   break;
  } else {
   HEAP8[i6 >> 0] = i8;
   break;
  }
 } while (0);
 HEAPF64[i18 + 48 >> 3] = d10;
 do if ((i3 | 0) != (i12 | 0)) {
  i8 = HEAP8[i12 + 11 >> 0] | 0;
  i6 = i8 << 24 >> 24 < 0;
  i9 = i6 ? HEAP32[i12 >> 2] | 0 : i12;
  i8 = i6 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255;
  i6 = i3 + 11 | 0;
  i4 = HEAP8[i6 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  if (i5) i7 = (HEAP32[i18 + 64 >> 2] & 2147483647) + -1 | 0; else i7 = 10;
  if (i8 >>> 0 > i7 >>> 0) {
   if (i5) i4 = HEAP32[i18 + 60 >> 2] | 0; else i4 = i4 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i3, i7, i8 - i7 | 0, i4, 0, i4, i8, i9);
   break;
  }
  if (i5) i3 = HEAP32[i3 >> 2] | 0;
  if (i8 | 0) _memmove(i3 | 0, i9 | 0, i8 | 0) | 0;
  HEAP8[i3 + i8 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i18 + 60 >> 2] = i8;
   break;
  } else {
   HEAP8[i6 >> 0] = i8;
   break;
  }
 } while (0);
 i12 = i18 + 72 | 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i12 + 4 >> 2] = i14;
 HEAP8[i18 + 80 >> 0] = i15 & 1;
 do if ((i2 | 0) != (i16 | 0)) {
  i7 = HEAP8[i16 + 11 >> 0] | 0;
  i5 = i7 << 24 >> 24 < 0;
  i8 = i5 ? HEAP32[i16 >> 2] | 0 : i16;
  i7 = i5 ? HEAP32[i16 + 4 >> 2] | 0 : i7 & 255;
  i5 = i2 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i6 = (HEAP32[i18 + 92 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i7 >>> 0 > i6 >>> 0) {
   if (i4) i3 = HEAP32[i18 + 88 >> 2] | 0; else i3 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i6, i7 - i6 | 0, i3, 0, i3, i7, i8);
   break;
  }
  if (i4) i2 = HEAP32[i2 >> 2] | 0;
  if (i7 | 0) _memmove(i2 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i2 + i7 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i18 + 88 >> 2] = i7;
   break;
  } else {
   HEAP8[i5 >> 0] = i7;
   break;
  }
 } while (0);
 if ((i1 | 0) == (i17 | 0)) return;
 i6 = HEAP8[i17 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i17 >> 2] | 0 : i17;
 i6 = i4 ? HEAP32[i17 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i18 + 108 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i18 + 104 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i18 + 104 >> 2] = i6;
  return;
 } else {
  HEAP8[i4 >> 0] = i6;
  return;
 }
}

function __ZN10GUITexture10BuildSheetEv(i11) {
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i17 + 36 | 0;
 i4 = i17 + 32 | 0;
 i15 = i17 + 24 | 0;
 i16 = i17 + 16 | 0;
 i13 = i17 + 8 | 0;
 i14 = i17;
 if (!(HEAP32[gb + 1114516 >> 2] | 0)) {
  i10 = __Z15GetScriptMapperv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1046327 | 0, 26);
  i10 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i10 = __ZN8Material14CreateMaterialER6Shaderib(i10, 61, 0) | 0;
  HEAP32[gb + 1114516 >> 2] = i10;
  i10 = __ZN8Material9GetShaderEv(i10) | 0;
  HEAP32[gb + 1114520 >> 2] = i10;
 }
 i6 = i11 + 52 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i4 >> 2] = i3;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i12 = 9; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i4 = HEAP32[i3 + 28 >> 2] | 0;
   i5 = HEAP32[i3 + 32 >> 2] | 0;
   i3 = i4 + (i5 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i3, i4);
   i4 = HEAP32[i7 >> 2] | 0;
   i10 = HEAP32[i3 + 28 >> 2] | 0;
   i5 = HEAP32[gb + 1104264 >> 2] | 0;
   i3 = (i4 | 0) == -1 ? i10 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i10 + (i4 << 3) | 0;
   i4 = HEAP32[i5 + 28 >> 2] | 0;
   i5 = HEAP32[i5 + 32 >> 2] | 0;
  }
  if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i12 = 9; else {
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i3) i12 = 11;
  }
 }
 if ((i12 | 0) == 9) i12 = 11;
 if ((i12 | 0) == 11) {
  i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  if (!i3) {
   STACKTOP = i17;
   return;
  }
 }
 i10 = i11 + 88 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i4 | 0) {
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63280 | 0);
  }
  HEAP32[i10 >> 2] = 0;
 }
 i9 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0) | 0;
 i4 = HEAP32[gb + 1114520 >> 2] | 0;
 __ZNK6Object14GetMemoryLabelEv(i7, i11);
 i4 = __ZNK6Shader19CreatePropertySheetERK10MemLabelId(i4, i7) | 0;
 HEAP32[i10 >> 2] = i4;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i4, gb + 1114544 | 0, i3);
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i4 + 20 >> 2] | 0;
 i8 = HEAP32[i4 + 24 >> 2] | 0;
 if ((i5 | 0) >= (i8 | 0)) {
  STACKTOP = i17;
  return;
 }
 i6 = HEAP32[i4 + 32 >> 2] | 0;
 i7 = HEAP32[gb + 1114544 >> 2] | 0;
 i4 = i5;
 while (1) {
  if ((HEAP32[i6 + (i4 << 2) >> 2] | 0) == (i7 | 0)) break;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (i8 | 0)) {
   i12 = 32;
   break;
  }
 }
 if ((i12 | 0) == 32) {
  STACKTOP = i17;
  return;
 }
 if ((i4 | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 i12 = HEAP32[i11 + 92 >> 2] | 0;
 if (!(i12 + -1 & i12)) {
  i4 = HEAP32[i11 + 96 >> 2] | 0;
  i4 = (i4 + -1 & i4 | 0) == 0;
 } else i4 = 0;
 if (!((i9 | 0) != 2 | i4)) if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0) | 0)) if ((HEAP32[i3 + 56 >> 2] | 0) != 6) {
  i4 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
  i4 = i5 ? i4 : 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
  i7 = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0) >> i4;
  i6 = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0) >> i4;
  i8 = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0, i3 | 0) | 0) >> i4;
  if ((i6 | 0) > 0) f2 = Math_fround(Math_fround(i5 >> i4 | 0) / Math_fround(i6 | 0)); else f2 = Math_fround(1.0);
  if ((i8 | 0) > 0) f1 = Math_fround(Math_fround(i7 | 0) / Math_fround(i8 | 0)); else f1 = Math_fround(1.0);
  i14 = HEAP32[i10 >> 2] | 0;
  HEAPF32[i15 >> 2] = f2;
  HEAPF32[i15 + 4 >> 2] = f1;
  HEAP32[i16 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  __ZN19ShaderPropertySheet18SetTextureUnscaledERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i14, gb + 1114544 | 0, i3, i15, i16);
  STACKTOP = i17;
  return;
 }
 i16 = HEAP32[i10 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 62472 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_(i16, gb + 1114544 | 0, i13, i14);
 STACKTOP = i17;
 return;
}

function __ZN9Animation22UpdateQueuedAnimationsERb(i20, i21) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 8 | 0;
 i19 = i25 + 4 | 0;
 i18 = i25;
 HEAP32[i18 >> 2] = -1082130432;
 HEAP32[i19 >> 2] = -1082130432;
 i23 = i20 + 316 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i24 = i20 + 320 | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i2 | 0)) {
  STACKTOP = i25;
  return;
 }
 i16 = i20 + 104 | 0;
 i17 = i20 + 108 | 0;
 i4 = -1;
 f6 = Math_fround(-1.0);
 f7 = Math_fround(-1.0);
 while (1) {
  f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i15 = HEAP32[i3 + 12 >> 2] | 0;
  i13 = HEAP32[i15 + 32 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == 4) if (f7 < Math_fround(0.0)) {
   i4 = HEAP32[i16 >> 2] | 0;
   i12 = HEAP32[i17 >> 2] | 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   if ((i4 | 0) == (i12 | 0)) {
    i8 = i13;
    i4 = i19;
    f6 = Math_fround(0.0);
    f7 = Math_fround(0.0);
   } else {
    f10 = Math_fround(0.0);
    f6 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f7 = Math_fround(0.0);
    do {
     i5 = HEAP32[i4 >> 2] | 0;
     do if (HEAP16[i5 + 56 >> 1] & 2) {
      i8 = HEAP32[i5 + 32 >> 2] | 0;
      if ((HEAP32[i5 + 68 >> 2] | 0) >>> 0 > 1) {
       HEAP32[i19 >> 2] = 2139095040;
       if ((i8 | 0) != (i13 | 0)) {
        f9 = Math_fround(inf);
        f7 = Math_fround(inf);
        break;
       }
       HEAP32[i18 >> 2] = 2139095040;
       f10 = Math_fround(inf);
       f6 = Math_fround(inf);
       f9 = Math_fround(inf);
       f7 = Math_fround(inf);
       break;
      }
      f7 = Math_fround(HEAPF32[i5 + 92 >> 2]);
      f7 = Math_fround(f7 - Math_fround(+HEAPF64[i5 + 16 >> 3]));
      HEAPF32[i22 >> 2] = f7;
      i5 = HEAP32[(f9 < f7 ? i22 : i19) >> 2] | 0;
      HEAP32[i19 >> 2] = i5;
      f11 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if ((i8 | 0) == (i13 | 0)) {
       i8 = HEAP32[(f10 < f7 ? i22 : i18) >> 2] | 0;
       HEAP32[i18 >> 2] = i8;
       f6 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f7 = f6;
      } else f7 = f10;
      f10 = f7;
      f9 = f11;
      f7 = f11;
     } while (0);
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i12 | 0));
    i8 = i13;
    i4 = i19;
   }
  } else {
   i8 = i4;
   i4 = i19;
  } else if ((i4 | 0) != (i13 | 0) | f6 < Math_fround(0.0)) {
   i4 = HEAP32[i16 >> 2] | 0;
   i12 = HEAP32[i17 >> 2] | 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   if ((i4 | 0) == (i12 | 0)) {
    i8 = i13;
    i4 = i18;
    f6 = Math_fround(0.0);
    f7 = Math_fround(0.0);
   } else {
    f10 = Math_fround(0.0);
    f6 = Math_fround(0.0);
    f9 = Math_fround(0.0);
    f7 = Math_fround(0.0);
    do {
     i5 = HEAP32[i4 >> 2] | 0;
     do if (HEAP16[i5 + 56 >> 1] & 2) {
      i8 = HEAP32[i5 + 32 >> 2] | 0;
      if ((HEAP32[i5 + 68 >> 2] | 0) >>> 0 > 1) {
       HEAP32[i19 >> 2] = 2139095040;
       if ((i8 | 0) != (i13 | 0)) {
        f9 = Math_fround(inf);
        f7 = Math_fround(inf);
        break;
       }
       HEAP32[i18 >> 2] = 2139095040;
       f10 = Math_fround(inf);
       f6 = Math_fround(inf);
       f9 = Math_fround(inf);
       f7 = Math_fround(inf);
       break;
      }
      f7 = Math_fround(HEAPF32[i5 + 92 >> 2]);
      f7 = Math_fround(f7 - Math_fround(+HEAPF64[i5 + 16 >> 3]));
      HEAPF32[i22 >> 2] = f7;
      i5 = HEAP32[(f9 < f7 ? i22 : i19) >> 2] | 0;
      HEAP32[i19 >> 2] = i5;
      f11 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      if ((i8 | 0) == (i13 | 0)) {
       i8 = HEAP32[(f10 < f7 ? i22 : i18) >> 2] | 0;
       HEAP32[i18 >> 2] = i8;
       f6 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
       f7 = f6;
      } else f7 = f10;
      f10 = f7;
      f9 = f11;
      f7 = f11;
     } while (0);
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) != (i12 | 0));
    i8 = i13;
    i4 = i18;
   }
  } else {
   i8 = i4;
   i4 = i18;
  }
  if (!(f14 >= Math_fround(HEAPF32[i4 >> 2]))) i5 = i3 + 16 | 0; else {
   __ZN9Animation9CrossFadeER14AnimationStatefib(i20, i15, f14, HEAP32[i3 >> 2] | 0, 0);
   i5 = HEAP32[i23 >> 2] | 0;
   i5 = i5 + (i1 - i5 >> 4 << 4) | 0;
   i1 = i5 + 16 | 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i3 = i2 - i1 | 0;
   i4 = i3 >> 4;
   if (i4) {
    _memmove(i5 | 0, i1 | 0, i3 | 0) | 0;
    i2 = HEAP32[i24 >> 2] | 0;
   }
   i1 = i5 + (i4 << 4) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i2 = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4) | 0;
    HEAP32[i24 >> 2] = i2;
   }
   HEAP8[i21 >> 0] = 1;
   HEAP32[i18 >> 2] = -1082130432;
   HEAP32[i19 >> 2] = -1082130432;
   f6 = Math_fround(-1.0);
   f7 = Math_fround(-1.0);
  }
  if ((i5 | 0) == (i2 | 0)) break; else {
   i4 = i8;
   i1 = i5;
   i3 = i5;
  }
 }
 STACKTOP = i25;
 return;
}

function __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E(i30, i28) {
 i30 = i30 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i9 = i30 + 4 | 0;
 i10 = i30 + 8 | 0;
 i20 = i30 + 12 | 0;
 i21 = i30 + 16 | 0;
 i22 = i30 + 176 | 0;
 i23 = i30 + 180 | 0;
 i24 = i30 + 184 | 0;
 i25 = i30 + 144 | 0;
 i26 = i30 + 148 | 0;
 i27 = i30 + 152 | 0;
 i11 = i30 + 112 | 0;
 i12 = i30 + 116 | 0;
 i13 = i30 + 120 | 0;
 i14 = i30 + 80 | 0;
 i15 = i30 + 84 | 0;
 i16 = i30 + 88 | 0;
 i17 = i30 + 48 | 0;
 i18 = i30 + 52 | 0;
 i19 = i30 + 56 | 0;
 i29 = 0;
 do {
  i7 = i28 + (i29 * 12 | 0) | 0;
  i1 = HEAP32[i30 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i8 = HEAP32[i21 >> 2] | 0;
  if ((i2 + i1 + i3 + i5 + i8 | 0) >>> 0 < 16) i1 = 18056; else {
   if (!i1) i6 = 2139095032; else {
    f31 = Math_fround(HEAPF32[i17 >> 2]);
    f31 = Math_fround(f31 * Math_fround(HEAPF32[i7 >> 2]));
    f32 = Math_fround(HEAPF32[i18 >> 2]);
    f32 = Math_fround(f31 + Math_fround(f32 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2])));
    f31 = Math_fround(HEAPF32[i19 >> 2]);
    f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2])));
    i6 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0) & 2147483640;
   }
   if (!i2) i4 = 2139095033; else {
    f32 = Math_fround(HEAPF32[i14 >> 2]);
    f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
    f31 = Math_fround(HEAPF32[i15 >> 2]);
    f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2])));
    f32 = Math_fround(HEAPF32[i16 >> 2]);
    f32 = Math_fround(f31 + Math_fround(f32 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2])));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) & 2147483640 | 1;
   }
   if (!i3) i3 = 2139095034; else {
    f32 = Math_fround(HEAPF32[i11 >> 2]);
    f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
    f31 = Math_fround(HEAPF32[i12 >> 2]);
    f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2])));
    f32 = Math_fround(HEAPF32[i13 >> 2]);
    f32 = Math_fround(f31 + Math_fround(f32 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2])));
    i3 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) & 2147483640 | 2;
   }
   if (!i5) i2 = 2139095035; else {
    f32 = Math_fround(HEAPF32[i25 >> 2]);
    f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
    f31 = Math_fround(HEAPF32[i26 >> 2]);
    f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2])));
    f32 = Math_fround(HEAPF32[i27 >> 2]);
    f32 = Math_fround(f31 + Math_fround(f32 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2])));
    i2 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) & 2147483640 | 3;
   }
   if (!i8) i1 = 2139095036; else {
    f32 = Math_fround(HEAPF32[i22 >> 2]);
    f32 = Math_fround(f32 * Math_fround(HEAPF32[i7 >> 2]));
    f31 = Math_fround(HEAPF32[i23 >> 2]);
    f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 4 >> 2])));
    f32 = Math_fround(HEAPF32[i24 >> 2]);
    f32 = Math_fround(f31 + Math_fround(f32 * Math_fround(HEAPF32[i28 + (i29 * 12 | 0) + 8 >> 2])));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0) & 2147483640 | 4;
   }
   i5 = i4 >>> 0 < i6 >>> 0;
   i34 = i5 ? i4 : i6;
   i5 = i5 ? i6 : i4;
   i35 = i3 >>> 0 < i5 >>> 0;
   i33 = i35 ? i3 : i5;
   i5 = i35 ? i5 : i3;
   i35 = i2 >>> 0 < i5 >>> 0;
   i3 = i35 ? i2 : i5;
   i5 = i35 ? i5 : i2;
   i35 = i1 >>> 0 < i5 >>> 0;
   i2 = i35 ? i1 : i5;
   i1 = i35 ? i5 : i1;
   i5 = i33 >>> 0 < i34 >>> 0;
   i35 = i5 ? i33 : i34;
   i33 = i5 ? i34 : i33;
   i34 = i3 >>> 0 < i33 >>> 0;
   i5 = i34 ? i3 : i33;
   i3 = i34 ? i33 : i3;
   i33 = i2 >>> 0 < i3 >>> 0;
   i34 = i33 ? i2 : i3;
   i2 = i33 ? i3 : i2;
   i3 = i1 >>> 0 < i2 >>> 0;
   i33 = i3 ? i1 : i2;
   i1 = i3 ? i2 : i1;
   i2 = i5 >>> 0 < i35 >>> 0;
   i3 = i2 ? i5 : i35;
   i5 = i2 ? i35 : i5;
   i35 = i34 >>> 0 < i5 >>> 0;
   i2 = i35 ? i34 : i5;
   i34 = i35 ? i5 : i34;
   i5 = i33 >>> 0 < i34 >>> 0;
   i35 = i5 ? i33 : i34;
   i33 = i5 ? i34 : i33;
   i34 = i1 >>> 0 < i33 >>> 0;
   i5 = i34 ? i1 : i33;
   i1 = i34 ? i33 : i1;
   i33 = i2 >>> 0 < i3 >>> 0;
   i34 = i33 ? i3 : i2;
   i36 = i35 >>> 0 < i34 >>> 0;
   i6 = i36 ? i34 : i35;
   i4 = i5 >>> 0 < i6 >>> 0;
   i8 = i4 ? i6 : i5;
   i7 = i1 >>> 0 < i8 >>> 0;
   i1 = (i36 ? i35 : i34) << 3 & 56 | (i33 ? i2 : i3) & 7 | (i4 ? i5 : i6) << 6 & 448 | (i7 ? i1 : i8) << 9 & 3584 | (i7 ? i8 : i1) << 12 & 28672;
  }
  HEAP16[i30 + 208 + (i29 << 1) >> 1] = i1;
  i29 = i29 + 1 | 0;
 } while ((i29 | 0) != 8);
 return;
}

function __ZN4crnd12crn_unpacker22decode_color_selectorsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28;
 i25 = i28 + 304 | 0;
 i26 = i28 + 280 | 0;
 i22 = i28 + 80 | 0;
 i23 = i28 + 16 | 0;
 i2 = HEAP32[i5 + 88 >> 2] | 0;
 i20 = (HEAPU8[i2 + 47 >> 0] | 0) << 8 | (HEAPU8[i2 + 48 >> 0] | 0);
 i21 = i5 + 92 | 0;
 i1 = (HEAP32[i5 + 4 >> 2] | 0) + ((HEAPU8[i2 + 42 >> 0] | 0) << 8 | (HEAPU8[i2 + 41 >> 0] | 0) << 16 | (HEAPU8[i2 + 43 >> 0] | 0)) | 0;
 i2 = (HEAPU8[i2 + 45 >> 0] | 0) << 8 | (HEAPU8[i2 + 44 >> 0] | 0) << 16 | (HEAPU8[i2 + 46 >> 0] | 0);
 if (!i2) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 HEAP32[i21 >> 2] = i1;
 HEAP32[i5 + 96 >> 2] = i1;
 HEAP32[i5 + 104 >> 2] = i2;
 HEAP32[i5 + 100 >> 2] = i1 + i2;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 112 >> 2] = 0;
 i24 = i26 + 20 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 HEAP32[i26 + 4 >> 2] = 0;
 HEAP32[i26 + 8 >> 2] = 0;
 HEAP32[i26 + 12 >> 2] = 0;
 HEAP8[i26 + 16 >> 0] = 0;
 if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i21, i26) | 0) {
  i1 = 0;
  i2 = -3;
  i3 = -3;
  while (1) {
   HEAP32[i25 + (i1 << 2) >> 2] = i3;
   HEAP32[i22 + (i1 << 2) >> 2] = i2;
   i4 = (i3 | 0) > 2;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 49) break; else {
    i2 = (i4 & 1) + i2 | 0;
    i3 = i4 ? -3 : i3 + 1 | 0;
   }
  }
  i1 = i23;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i19 = i5 + 252 | 0;
  i2 = i5 + 256 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  L9 : do if ((i1 | 0) == (i20 | 0)) i6 = 13; else {
   if (i1 >>> 0 <= i20 >>> 0) {
    do if ((HEAP32[i5 + 260 >> 2] | 0) >>> 0 < i20 >>> 0) if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i19, i20, (i1 + 1 | 0) == (i20 | 0), 4, 0) | 0) {
     i1 = HEAP32[i2 >> 2] | 0;
     break;
    } else {
     HEAP8[i5 + 264 >> 0] = 1;
     i1 = 0;
     break L9;
    } while (0);
    _memset((HEAP32[i19 >> 2] | 0) + (i1 << 2) | 0, 0, i20 - i1 << 2 | 0) | 0;
   }
   HEAP32[i2 >> 2] = i20;
   i6 = 13;
  } while (0);
  if ((i6 | 0) == 13) if (!i20) i1 = 1; else {
   i4 = i23 + 4 | 0;
   i5 = i23 + 8 | 0;
   i6 = i23 + 12 | 0;
   i7 = i23 + 16 | 0;
   i8 = i23 + 20 | 0;
   i9 = i23 + 24 | 0;
   i10 = i23 + 28 | 0;
   i11 = i23 + 32 | 0;
   i12 = i23 + 36 | 0;
   i13 = i23 + 40 | 0;
   i14 = i23 + 44 | 0;
   i15 = i23 + 48 | 0;
   i16 = i23 + 52 | 0;
   i17 = i23 + 56 | 0;
   i18 = i23 + 60 | 0;
   i3 = 0;
   i2 = HEAP32[i19 >> 2] | 0;
   while (1) {
    i1 = 0;
    do {
     i29 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i21, i26) | 0;
     i19 = i1 << 1;
     i30 = i23 + (i19 << 2) | 0;
     HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + (HEAP32[i25 + (i29 << 2) >> 2] | 0) & 3;
     i19 = i23 + ((i19 | 1) << 2) | 0;
     HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + (HEAP32[i22 + (i29 << 2) >> 2] | 0) & 3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 8);
    HEAP32[i2 >> 2] = (HEAPU8[(HEAP32[i4 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 2 | (HEAPU8[(HEAP32[i23 >> 2] | 0) + (gb + 401140) >> 0] | 0) | (HEAPU8[(HEAP32[i5 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 4 | (HEAPU8[(HEAP32[i6 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 6 | (HEAPU8[(HEAP32[i7 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 8 | (HEAPU8[(HEAP32[i8 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 10 | (HEAPU8[(HEAP32[i9 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 12 | (HEAPU8[(HEAP32[i10 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 14 | (HEAPU8[(HEAP32[i11 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 16 | (HEAPU8[(HEAP32[i12 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 18 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 20 | (HEAPU8[(HEAP32[i14 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 22 | (HEAPU8[(HEAP32[i15 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 24 | (HEAPU8[(HEAP32[i16 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 26 | (HEAPU8[(HEAP32[i17 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 28 | (HEAPU8[(HEAP32[i18 >> 2] | 0) + (gb + 401140) >> 0] | 0) << 30;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i20 | 0)) {
     i1 = 1;
     break;
    } else i2 = i2 + 4 | 0;
   }
  }
  i3 = i1;
 } else i3 = 0;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i26 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i27 >> 2] = gb + 401209;
   HEAP32[i27 + 4 >> 2] = 2513;
   HEAP32[i27 + 8 >> 2] = gb + 401349;
   _sprintf(i25, gb + 401176 | 0, i27) | 0;
   _puts(i25) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i26 + 8 >> 2] = 0;
  HEAP32[i26 + 12 >> 2] = 0;
 }
 i30 = i3;
 STACKTOP = i28;
 return i30 | 0;
}

function _UNITY_LZ4_decompress_fast(i14, i2, i1) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i12 = i2 + i1 | 0;
 i13 = i12 + -12 | 0;
 if (!i1) {
  i15 = (HEAP8[i14 >> 0] | 0) == 0 ? 1 : -1;
  return i15 | 0;
 }
 i9 = i12 + -5 | 0;
 i10 = i12 + -8 | 0;
 i11 = i10;
 i3 = i14;
 L5 : while (1) {
  i1 = i3 + 1 | 0;
  i7 = HEAPU8[i3 >> 0] | 0;
  i3 = i7 >>> 4;
  if ((i3 | 0) == 15) {
   i3 = 15;
   while (1) {
    i4 = i1 + 1 | 0;
    i8 = HEAP8[i1 >> 0] | 0;
    i3 = (i8 & 255) + i3 | 0;
    if (i8 << 24 >> 24 == -1) i1 = i4; else {
     i1 = i4;
     break;
    }
   }
  }
  i8 = i2 + i3 | 0;
  if (i8 >>> 0 > i10 >>> 0) {
   i15 = 7;
   break;
  } else i4 = i1;
  while (1) {
   i5 = i4;
   i17 = i5;
   i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i2;
   i16 = i6;
   HEAP8[i16 >> 0] = i17;
   HEAP8[i16 + 1 >> 0] = i17 >> 8;
   HEAP8[i16 + 2 >> 0] = i17 >> 16;
   HEAP8[i16 + 3 >> 0] = i17 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i8 >>> 0) break; else i4 = i4 + 8 | 0;
  }
  i1 = i1 + i3 | 0;
  i4 = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
  i5 = i4 & 65535;
  i6 = i8 + (0 - i4) | 0;
  i1 = i1 + 2 | 0;
  i2 = i7 & 15;
  if ((i2 | 0) == 15) {
   i2 = 15;
   while (1) {
    i3 = i1 + 1 | 0;
    i17 = HEAP8[i1 >> 0] | 0;
    i2 = (i17 & 255) + i2 | 0;
    if (i17 << 24 >> 24 == -1) i1 = i3; else {
     i1 = i3;
     break;
    }
   }
  }
  i2 = i8 + (i2 + 4) | 0;
  if ((i5 & 65535) < 8) {
   i17 = HEAP32[gb + 74112 + (i4 << 2) >> 2] | 0;
   HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i8 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
   HEAP8[i8 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
   HEAP8[i8 + 3 >> 0] = HEAP8[i6 + 3 >> 0] | 0;
   i4 = i6 + (HEAP32[gb + 74144 + (i4 << 2) >> 2] | 0) | 0;
   i16 = i8 + 4 | 0;
   i7 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
   HEAP8[i16 >> 0] = i7;
   HEAP8[i16 + 1 >> 0] = i7 >> 8;
   HEAP8[i16 + 2 >> 0] = i7 >> 16;
   HEAP8[i16 + 3 >> 0] = i7 >> 24;
   i4 = i4 + (0 - i17) | 0;
  } else {
   i17 = i6;
   i7 = i17;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i17 = i17 + 4 | 0;
   i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
   i4 = i8;
   i16 = i4;
   HEAP8[i16 >> 0] = i7;
   HEAP8[i16 + 1 >> 0] = i7 >> 8;
   HEAP8[i16 + 2 >> 0] = i7 >> 16;
   HEAP8[i16 + 3 >> 0] = i7 >> 24;
   i4 = i4 + 4 | 0;
   HEAP8[i4 >> 0] = i17;
   HEAP8[i4 + 1 >> 0] = i17 >> 8;
   HEAP8[i4 + 2 >> 0] = i17 >> 16;
   HEAP8[i4 + 3 >> 0] = i17 >> 24;
   i4 = i6 + 8 | 0;
  }
  i3 = i8 + 8 | 0;
  if (i2 >>> 0 <= i13 >>> 0) while (1) {
   i16 = i4;
   i7 = i16;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i16 = i16 + 4 | 0;
   i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
   i17 = i3;
   i8 = i17;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i17 = i17 + 4 | 0;
   HEAP8[i17 >> 0] = i16;
   HEAP8[i17 + 1 >> 0] = i16 >> 8;
   HEAP8[i17 + 2 >> 0] = i16 >> 16;
   HEAP8[i17 + 3 >> 0] = i16 >> 24;
   i3 = i3 + 8 | 0;
   if (i3 >>> 0 < i2 >>> 0) i4 = i4 + 8 | 0; else {
    i3 = i1;
    continue L5;
   }
  }
  if (i2 >>> 0 > i9 >>> 0) break;
  if (i3 >>> 0 < i10 >>> 0) {
   i5 = i3;
   i6 = i4;
   while (1) {
    i16 = i6;
    i7 = i16;
    i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
    i16 = i16 + 4 | 0;
    i16 = HEAPU8[i16 >> 0] | HEAPU8[i16 + 1 >> 0] << 8 | HEAPU8[i16 + 2 >> 0] << 16 | HEAPU8[i16 + 3 >> 0] << 24;
    i17 = i5;
    i8 = i17;
    HEAP8[i8 >> 0] = i7;
    HEAP8[i8 + 1 >> 0] = i7 >> 8;
    HEAP8[i8 + 2 >> 0] = i7 >> 16;
    HEAP8[i8 + 3 >> 0] = i7 >> 24;
    i17 = i17 + 4 | 0;
    HEAP8[i17 >> 0] = i16;
    HEAP8[i17 + 1 >> 0] = i16 >> 8;
    HEAP8[i17 + 2 >> 0] = i16 >> 16;
    HEAP8[i17 + 3 >> 0] = i16 >> 24;
    i5 = i5 + 8 | 0;
    if (i5 >>> 0 >= i10 >>> 0) break; else i6 = i6 + 8 | 0;
   }
   i4 = i4 + (i11 - i3) | 0;
   i3 = i10;
  }
  if (i3 >>> 0 >= i2 >>> 0) {
   i3 = i1;
   continue;
  }
  while (1) {
   i5 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i4 = i4 + 1 | 0;
    i3 = i5;
   } else {
    i3 = i1;
    continue L5;
   }
  }
 }
 if ((i15 | 0) == 7) if ((i8 | 0) == (i12 | 0)) {
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  i17 = i1 + i3 - i14 | 0;
  return i17 | 0;
 }
 i17 = i14 + -1 - i1 | 0;
 return i17 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i17, i18, i15, i14, i9, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_(i17, i18, i15, i14, i1) | 0;
 i7 = i9 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i12 = i14 + 4 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 do if ((i8 | 0) == (i6 | 0)) {
  i3 = i9 + 8 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i4 = i14 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) {
   if ((i5 | 0) < (i2 | 0)) {
    i1 = i5;
    break;
   } else i1 = i16;
   return i1 | 0;
  }
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   if ((HEAP32[i9 >> 2] | 0) < (HEAP32[i14 >> 2] | 0)) {
    i2 = i5;
    i1 = i5;
    break;
   } else i1 = i16;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i2 >>> 0) {
    i2 = i5;
    i1 = i5;
    break;
   } else i1 = i16;
   return i1 | 0;
  }
 } else if ((i8 | 0) < (i6 | 0)) {
  i2 = i14 + 8 | 0;
  i1 = i9 + 8 | 0;
  i3 = i1;
  i4 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  break;
 } else {
  i18 = i16;
  return i18 | 0;
 } while (0);
 i11 = HEAP32[i14 >> 2] | 0;
 i10 = i14 + 12 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 >> 2] = i8;
 HEAP32[i4 >> 2] = i1;
 i1 = i9 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 >> 2] = i11;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = i13;
 i1 = i16 + 1 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 4 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 do if ((i7 | 0) == (i8 | 0)) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = i15 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i2 | 0)) {
   if ((i6 | 0) < (i2 | 0)) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i15 + 12 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   if ((HEAP32[i14 >> 2] | 0) < (HEAP32[i15 >> 2] | 0)) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i2 >>> 0 < i3 >>> 0) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } else if ((i7 | 0) < (i8 | 0)) {
  i2 = i15 + 8 | 0;
  i5 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  break;
 } else {
  i18 = i1;
  return i18 | 0;
 } while (0);
 i6 = HEAP32[i15 >> 2] | 0;
 i11 = i15 + 12 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 >> 2] = i7;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 >> 2] = i6;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i10 >> 2] = i9;
 i1 = i16 + 2 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i12 = i18 + 4 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 do if ((i7 | 0) == (i8 | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  i4 = i18 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i6 | 0) != (i2 | 0)) {
   if ((i6 | 0) < (i2 | 0)) {
    i10 = i4;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i18 + 12 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   if ((HEAP32[i15 >> 2] | 0) < (HEAP32[i18 >> 2] | 0)) {
    i10 = i4;
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i2 >>> 0 < i3 >>> 0) {
    i10 = i4;
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } else if ((i7 | 0) < (i8 | 0)) {
  i2 = i18 + 8 | 0;
  i10 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  break;
 } else {
  i18 = i1;
  return i18 | 0;
 } while (0);
 i14 = HEAP32[i18 >> 2] | 0;
 i9 = i18 + 12 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 >> 2] = i7;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 >> 2] = i14;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i11 >> 2] = i6;
 i1 = i16 + 3 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i7 = i17 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 do if ((i6 | 0) == (i8 | 0)) {
  i5 = HEAP32[i10 >> 2] | 0;
  i3 = i17 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) {
   if ((i5 | 0) < (i2 | 0)) {
    i1 = i5;
    break;
   }
   return i1 | 0;
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i17 + 12 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0)) {
   if ((HEAP32[i18 >> 2] | 0) < (HEAP32[i17 >> 2] | 0)) {
    i2 = i5;
    i1 = i5;
    break;
   }
   return i1 | 0;
  } else {
   if (i2 >>> 0 < i4 >>> 0) {
    i2 = i5;
    i1 = i5;
    break;
   }
   return i1 | 0;
  }
 } else if ((i6 | 0) < (i8 | 0)) {
  i2 = i17 + 8 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  break;
 } else {
  i18 = i1;
  return i18 | 0;
 } while (0);
 i14 = HEAP32[i17 >> 2] | 0;
 i13 = i17 + 12 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i7 >> 2] = i6;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i18 >> 2] = i14;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i15;
 i18 = i16 + 4 | 0;
 return i18 | 0;
}

function __Z10FilterRowsP13CImageSurfaceRS_iiiiifbfiiR17PrecomputeContext(i48, i2, i51, i3, i52, i53, i54, f55, i56, f57, i1, i49, i50) {
 i48 = i48 | 0;
 i2 = i2 | 0;
 i51 = i51 | 0;
 i3 = i3 | 0;
 i52 = i52 | 0;
 i53 = i53 | 0;
 i54 = i54 | 0;
 f55 = Math_fround(f55);
 i56 = i56 | 0;
 f57 = Math_fround(f57);
 i1 = i1 | 0;
 i49 = i49 | 0;
 i50 = i50 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i47 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i41 = i47 + 16 | 0;
 i42 = i47;
 HEAP32[i41 >> 2] = 2147483647;
 HEAP32[i41 + 4 >> 2] = 2147483647;
 HEAP32[i41 + 8 >> 2] = 2147483647;
 HEAP32[i41 + 12 >> 2] = -2147483648;
 HEAP32[i41 + 16 >> 2] = -2147483648;
 HEAP32[i41 + 20 >> 2] = -2147483648;
 HEAP32[i41 + 24 >> 2] = 2147483647;
 HEAP32[i41 + 28 >> 2] = 2147483647;
 HEAP32[i41 + 32 >> 2] = 2147483647;
 HEAP32[i41 + 36 >> 2] = -2147483648;
 HEAP32[i41 + 40 >> 2] = -2147483648;
 HEAP32[i41 + 44 >> 2] = -2147483648;
 HEAP32[i41 + 48 >> 2] = 2147483647;
 HEAP32[i41 + 52 >> 2] = 2147483647;
 HEAP32[i41 + 56 >> 2] = 2147483647;
 HEAP32[i41 + 60 >> 2] = -2147483648;
 HEAP32[i41 + 64 >> 2] = -2147483648;
 HEAP32[i41 + 68 >> 2] = -2147483648;
 HEAP32[i41 + 72 >> 2] = 2147483647;
 HEAP32[i41 + 76 >> 2] = 2147483647;
 HEAP32[i41 + 80 >> 2] = 2147483647;
 HEAP32[i41 + 84 >> 2] = -2147483648;
 HEAP32[i41 + 88 >> 2] = -2147483648;
 HEAP32[i41 + 92 >> 2] = -2147483648;
 HEAP32[i41 + 96 >> 2] = 2147483647;
 HEAP32[i41 + 100 >> 2] = 2147483647;
 HEAP32[i41 + 104 >> 2] = 2147483647;
 HEAP32[i41 + 108 >> 2] = -2147483648;
 HEAP32[i41 + 112 >> 2] = -2147483648;
 HEAP32[i41 + 116 >> 2] = -2147483648;
 HEAP32[i41 + 120 >> 2] = 2147483647;
 HEAP32[i41 + 124 >> 2] = 2147483647;
 HEAP32[i41 + 128 >> 2] = 2147483647;
 HEAP32[i41 + 132 >> 2] = -2147483648;
 HEAP32[i41 + 136 >> 2] = -2147483648;
 HEAP32[i41 + 140 >> 2] = -2147483648;
 i43 = HEAP32[i48 >> 2] | 0;
 i44 = HEAP32[i2 >> 2] | 0;
 i45 = HEAP32[i2 + 8 >> 2] | 0;
 i46 = Math_imul(i45, i44) | 0;
 if ((i3 | 0) >= (i52 | 0)) {
  STACKTOP = i47;
  return;
 }
 i5 = i2 + 12 | 0;
 i6 = i41 + 4 | 0;
 i7 = i41 + 8 | 0;
 i8 = i41 + 12 | 0;
 i9 = i41 + 16 | 0;
 i10 = i41 + 20 | 0;
 i11 = i41 + 24 | 0;
 i12 = i41 + 28 | 0;
 i13 = i41 + 32 | 0;
 i14 = i41 + 36 | 0;
 i15 = i41 + 40 | 0;
 i16 = i41 + 44 | 0;
 i17 = i41 + 48 | 0;
 i18 = i41 + 52 | 0;
 i19 = i41 + 56 | 0;
 i20 = i41 + 60 | 0;
 i21 = i41 + 64 | 0;
 i22 = i41 + 68 | 0;
 i23 = i41 + 72 | 0;
 i24 = i41 + 76 | 0;
 i25 = i41 + 80 | 0;
 i26 = i41 + 84 | 0;
 i27 = i41 + 88 | 0;
 i28 = i41 + 92 | 0;
 i29 = i41 + 96 | 0;
 i30 = i41 + 100 | 0;
 i31 = i41 + 104 | 0;
 i32 = i41 + 108 | 0;
 i33 = i41 + 112 | 0;
 i34 = i41 + 116 | 0;
 i35 = i41 + 120 | 0;
 i36 = i41 + 124 | 0;
 i37 = i41 + 128 | 0;
 i38 = i41 + 132 | 0;
 i39 = i41 + 136 | 0;
 i40 = i41 + 140 | 0;
 if ((i44 | 0) <= 0) {
  STACKTOP = i47;
  return;
 }
 do {
  f4 = Math_fround(i3 | 0);
  i1 = (HEAP32[i5 >> 2] | 0) + ((Math_imul(i46, i3) | 0) << 2) | 0;
  i2 = 0;
  while (1) {
   __Z16TexelCoordToVectiffiPfi(i51, Math_fround(i2 | 0), f4, i44, i42, i49);
   HEAP32[i41 >> 2] = 2147483647;
   HEAP32[i6 >> 2] = 2147483647;
   HEAP32[i7 >> 2] = 2147483647;
   HEAP32[i8 >> 2] = -2147483648;
   HEAP32[i9 >> 2] = -2147483648;
   HEAP32[i10 >> 2] = -2147483648;
   HEAP32[i11 >> 2] = 2147483647;
   HEAP32[i12 >> 2] = 2147483647;
   HEAP32[i13 >> 2] = 2147483647;
   HEAP32[i14 >> 2] = -2147483648;
   HEAP32[i15 >> 2] = -2147483648;
   HEAP32[i16 >> 2] = -2147483648;
   HEAP32[i17 >> 2] = 2147483647;
   HEAP32[i18 >> 2] = 2147483647;
   HEAP32[i19 >> 2] = 2147483647;
   HEAP32[i20 >> 2] = -2147483648;
   HEAP32[i21 >> 2] = -2147483648;
   HEAP32[i22 >> 2] = -2147483648;
   HEAP32[i23 >> 2] = 2147483647;
   HEAP32[i24 >> 2] = 2147483647;
   HEAP32[i25 >> 2] = 2147483647;
   HEAP32[i26 >> 2] = -2147483648;
   HEAP32[i27 >> 2] = -2147483648;
   HEAP32[i28 >> 2] = -2147483648;
   HEAP32[i29 >> 2] = 2147483647;
   HEAP32[i30 >> 2] = 2147483647;
   HEAP32[i31 >> 2] = 2147483647;
   HEAP32[i32 >> 2] = -2147483648;
   HEAP32[i33 >> 2] = -2147483648;
   HEAP32[i34 >> 2] = -2147483648;
   HEAP32[i35 >> 2] = 2147483647;
   HEAP32[i36 >> 2] = 2147483647;
   HEAP32[i37 >> 2] = 2147483647;
   HEAP32[i38 >> 2] = -2147483648;
   HEAP32[i39 >> 2] = -2147483648;
   HEAP32[i40 >> 2] = -2147483648;
   __Z22DetermineFilterExtentsPfiiP10CBBoxInt32(i42, i43, i53, i41);
   __Z20ProcessFilterExtentsPffP10CBBoxInt32P13CImageSurfaceS3_S_jbfiR17PrecomputeContext(i42, f55, i41, i50, i48, i1, i54, i56, f57, 0, i50);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i44 | 0)) break; else i1 = i1 + (i45 << 2) | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i52 | 0));
 STACKTOP = i47;
 return;
}

function __ZN9Texture3D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i11);
 i14 = i10 + 80 | 0;
 i7 = i11 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i11 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i14 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i6 = i10 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i10 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i10 + 92 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i10 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
 i3 = i10 + 100 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 32 | 0, i11);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i10 + 105 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i11, i13, gb + 411165 | 0, 1);
 i1 = i10 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i10 + 104 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i3 >> 2] = i12;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = gb + 45784 + (i9 << 2) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i12 = i9 + i12 | 0;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
  HEAP32[i1 >> 2] = i12;
  i14 = HEAP32[i14 >> 2] | 0;
  f17 = Math_fround(i14 | 0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i14 = HEAP32[i6 >> 2] | 0;
  f16 = Math_fround(i14 | 0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  i14 = i10 + 68 | 0;
  HEAPF32[i14 >> 2] = f17;
  i14 = i10 + 72 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i11, i14, i12, 0);
  STACKTOP = i15;
  return;
 }
 i8 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 + 48 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 mftCall_vii(i7 | 0, i8 | 0, i9 | 0);
 HEAP8[i2 >> 0] = 0;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i3 >> 2] = i12;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = gb + 45784 + (i9 << 2) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i12 = i9 + i12 | 0;
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
 HEAP32[i1 >> 2] = i12;
 i14 = HEAP32[i14 >> 2] | 0;
 f16 = Math_fround(i14 | 0);
 f16 = Math_fround(Math_fround(1.0) / f16);
 i14 = HEAP32[i6 >> 2] | 0;
 f17 = Math_fround(i14 | 0);
 f17 = Math_fround(Math_fround(1.0) / f17);
 i14 = i10 + 68 | 0;
 HEAPF32[i14 >> 2] = f16;
 i14 = i10 + 72 | 0;
 HEAPF32[i14 >> 2] = f17;
 i14 = HEAP32[i13 >> 2] | 0;
 __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i11, i14, i12, 0);
 STACKTOP = i15;
 return;
}

function __ZN21ArchiveStorageCreator11StoreStreamEb(i1, i25) {
 i1 = i1 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i26 + 24 | 0;
 i22 = i26 + 16 | 0;
 i16 = i26 + 44 | 0;
 i17 = i26 + 40 | 0;
 i19 = i26;
 i20 = i26 + 28 | 0;
 i21 = i1 + 1280 | 0;
 i24 = HEAP32[i21 >> 2] | 0;
 L1 : do if ((i24 | 0) != 0 | i25) {
  i6 = i1 + 1260 | 0;
  i7 = i1 + 1268 | 0;
  i8 = i1 + 12 | 0;
  i9 = i1 + 1300 | 0;
  i10 = i1 + 1304 | 0;
  i11 = i1 + 1288 | 0;
  i12 = i1 + 1292 | 0;
  i13 = i1 + 1264 | 0;
  i14 = i1 + 1168 | 0;
  i15 = i1 + 1248 | 0;
  i5 = 0;
  i2 = 0;
  while (1) {
   i3 = i24 - i5 | 0;
   HEAP32[i16 >> 2] = i3;
   if (!i3) i3 = 0; else if (!(HEAP32[i14 >> 2] & 128)) {
    HEAP32[i15 >> 2] = __Z7CRCFeedjPKhj(HEAP32[i15 >> 2] | 0, (HEAP32[i7 >> 2] | 0) + i5 | 0, i3) | 0;
    i3 = HEAP32[i16 >> 2] | 0;
   }
   i4 = (i3 | 0) == 0;
   if (!(HEAP32[i6 >> 2] | 0)) {
    if (i4) {
     i18 = 31;
     break;
    }
    i4 = (HEAP32[i7 >> 2] | 0) + i5 | 0;
    HEAP32[i17 >> 2] = i3;
    i18 = 22;
   } else {
    if (i4) i4 = 0; else i4 = (HEAP32[i7 >> 2] | 0) + i5 | 0;
    HEAP32[i9 >> 2] = 131072;
    i3 = HEAP32[i10 >> 2] | 0;
    do if ((i3 & 2147352576) >>> 0 < 131072) if ((i3 | 0) > -1) {
     HEAP32[i10 >> 2] = 131072;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, 131072, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i11 >> 2] = i3;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(131072, 1, i12, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
     HEAP32[i10 >> 2] = 131072;
     HEAP32[i11 >> 2] = i3;
     break;
    } else i3 = HEAP32[i11 >> 2] | 0; while (0);
    HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
    i27 = HEAP32[i6 >> 2] | 0;
    if (!(mftCall_iiiiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 28 >> 2] | 0, i27 | 0, HEAP32[i13 >> 2] | 0, i4 | 0, i16 | 0, i3 | 0, i17 | 0, (HEAP32[i16 >> 2] | 0) == 0 | 0) | 0)) {
     i18 = 17;
     break;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i17 >> 2] | 0;
    if (!i3) {
     i3 = HEAP32[i16 >> 2] | 0;
     if (!i3) {
      i18 = 31;
      break;
     } else i4 = 0;
    } else i18 = 22;
   }
   if ((i18 | 0) == 22) {
    i18 = 0;
    if (!(__ZN12FileAccessor5WriteEyPKvPy(i8, i3, 0, i4, i19) | 0)) {
     i18 = 25;
     break;
    }
    i27 = i19;
    i4 = HEAP32[i17 >> 2] | 0;
    if (!((HEAP32[i27 + 4 >> 2] | 0) == 0 ? (HEAP32[i27 >> 2] | 0) == (i4 | 0) : 0)) {
     i18 = 25;
     break;
    }
    i3 = HEAP32[i16 >> 2] | 0;
   }
   i5 = i3 + i5 | 0;
   i2 = i4 + i2 | 0;
   if (!(i24 >>> 0 > i5 >>> 0 | i25)) break L1;
  }
  if ((i18 | 0) == 17) {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i22 >> 2] = i1;
   __Z6FormatPKcz(i19, gb + 490539 | 0, i22);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i19 + 11 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0, gb + 490375 | 0, 528, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  } else if ((i18 | 0) == 25) {
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i23 >> 2] = i1;
   __Z6FormatPKcz(i20, gb + 490593 | 0, i23);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 + 11 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, 0, gb + 490375 | 0, 541, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  } else if ((i18 | 0) == 31) break;
  i27 = 0;
  STACKTOP = i26;
  return i27 | 0;
 } else i2 = 0; while (0);
 HEAP32[i21 >> 2] = 0;
 i5 = i1 + 1224 | 0;
 i27 = i5;
 i27 = _i64Add(HEAP32[i27 >> 2] | 0, HEAP32[i27 + 4 >> 2] | 0, i24 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 HEAP32[i5 >> 2] = i27;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 1232 | 0;
 i4 = i5;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i2 | 0, 0) | 0;
 i27 = getTempRet0() | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i27;
 i5 = i1 + 1308 | 0;
 i27 = (HEAP32[i5 >> 2] | 0) + i24 | 0;
 HEAP32[i5 >> 2] = i27;
 i4 = i1 + 1312 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i2;
 if ((i27 | 0) == 0 | i25 ^ 1) {
  i27 = 1;
  STACKTOP = i26;
  return i27 | 0;
 }
 i2 = i1 + 1196 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 1200 >> 2] | 0)) __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 1192 | 0, i5); else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 12;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i27 = 1;
 STACKTOP = i26;
 return i27 | 0;
}

function __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(i7, i8, i6, i16) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17;
 i3 = i17 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 180 >> 2] | 0, i7 | 0) | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((i8 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 180 >> 2] | 0, i7 | 0) | 0) i1 = HEAP32[HEAP32[i7 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i8 | 0)) {
   i5 = i7 + 92 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) + (i8 << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = (HEAP32[i7 + 100 >> 2] | 0) + 4 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) + (i4 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i6) if (HEAP8[((i2 | 0) == 0 ? 0 : i1 + i2 | 0) + 80 >> 0] | 0) {
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   }
   i1 = (HEAP32[(HEAP32[(HEAP32[(HEAP32[i7 + 104 >> 2] | 0) + 4 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 4 >> 2] & 2 | 0) == 0 & i6;
   i2 = i1 & 1 ^ 1;
   i14 = i7 + 144 | 0;
   f15 = Math_fround(Math_fround(1.0) - Math_fround(__ZNK8Playable14GetInputWeightEi(HEAP32[(HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 3) >> 2] | 0) + (HEAP32[i3 + 4 >> 2] << 2) >> 2] | 0, 0)));
   f9 = Math_fround(Math_fround(1.0) - f15);
   f15 = i1 ? f9 : f15;
   i1 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) + (i8 << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i14 >> 2] | 0) + (HEAP32[i1 >> 2] << 3) >> 2] | 0) + (HEAP32[i1 + 4 >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0;
   if (i2 >>> 0 >= (HEAP32[i1 + 28 >> 2] | 0) >>> 0) {
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   }
   i12 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if (!i12) {
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   }
   i3 = HEAP32[i12 + 8 >> 2] | 0;
   i13 = i3 + 28 | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   i14 = i16 + 16 | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
    if ((i2 | 0) > -1) {
     HEAP32[i14 >> 2] = i1;
     HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 3, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    } else {
     i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i11 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i16 + 12 >> 2] << 3 | 0) | 0;
     HEAP32[i14 >> 2] = i1;
     HEAP32[i16 >> 2] = i11;
    }
    i1 = HEAP32[i13 >> 2] | 0;
   }
   if ((i1 | 0) == 1) {
    i16 = 1;
    STACKTOP = i17;
    return i16 | 0;
   }
   i8 = i3 + 16 | 0;
   i10 = i16 + 12 | 0;
   i11 = i16 + 4 | 0;
   i7 = 0;
   do {
    i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 3) + 4 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0;
    if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 65780 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 65780 + 28 >> 2] | 0) >>> 0) {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     f9 = Math_fround(f15 * Math_fround(__ZNK8Playable14GetInputWeightEi(i12, i7)));
     if (Math_fround(__ZNK8Playable14GetInputWeightEi(i12, i7)) != Math_fround(0.0)) {
      i3 = HEAP32[i10 >> 2] | 0;
      i4 = i3 + 1 | 0;
      i5 = HEAP32[i14 >> 2] | 0;
      i6 = i5 & 2147483647;
      do if (i4 >>> 0 > i6 >>> 0) {
       i1 = i5 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
        HEAP32[i14 >> 2] = i1;
        HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 3, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i6 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
        HEAP32[i14 >> 2] = i1;
        HEAP32[i16 >> 2] = i6;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = i4;
      i6 = HEAP32[i16 >> 2] | 0;
      HEAP32[i6 + (i3 << 3) >> 2] = i2;
      HEAPF32[i6 + (i3 << 3) + 4 >> 2] = f9;
     }
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < ((HEAP32[i13 >> 2] | 0) + -1 | 0) >>> 0);
   i1 = 1;
   STACKTOP = i17;
   return i1 | 0;
  }
 }
 HEAP32[i2 >> 2] = i8;
 __Z6FormatPKcz(i3, gb + 902210 | 0, i2);
 i1 = HEAP32[i7 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i16 = 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx3Scb11RigidObject13onShapeDetachERNS0_5ShapeEbb(i19, i20, i14, i13) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 8 | 0;
 i16 = i21;
 i17 = i19 + 4 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = i2 >>> 30;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i18 = HEAP32[i19 >> 2] | 0;
 if (!(HEAP8[i18 + 2433 >> 0] | 0)) {
  i18 = HEAP32[i17 >> 2] | 0;
  i1 = (HEAP32[gb + 90260 + 24 + ((i18 >>> 24 & 15) << 2) >> 2] | 0) + i19 | 0;
  if (!(HEAP16[((i18 & 1 | 0) == 0 ? i1 + 8 | 0 : HEAP32[i19 + 8 >> 2] | 0) >> 1] & 8)) {
   __ZN5physx2Sc9RigidCore20removeShapeFromSceneERNS0_9ShapeCoreEb(i1, i20 + 16 | 0, i14);
   __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i20);
  }
  i1 = i20 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) != 16777216) {
   STACKTOP = i21;
   return;
  }
  HEAP32[i1 >> 2] = i2 & 1073741823;
  HEAP32[i20 >> 2] = 0;
  STACKTOP = i21;
  return;
 }
 if ((i1 | 0) == 1) {
  i1 = i20 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) != 16777216) {
   STACKTOP = i21;
   return;
  }
  HEAP32[i1 >> 2] = i2 & 1073741823;
  HEAP32[i20 >> 2] = 0;
  STACKTOP = i21;
  return;
 }
 i1 = i19 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(i18, i2 >>> 24 & 15) | 0;
  HEAP32[i1 >> 2] = i3;
  i2 = HEAP32[i17 >> 2] | 0;
 }
 L24 : do if (i2 & 32) {
  i10 = i3 + 88 | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i11 = i3 + 84 | 0;
  if ((i6 | 0) == 1) {
   if ((HEAP32[i11 >> 2] | 0) != (i20 | 0)) break;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i2 = i2 & -33;
   HEAP32[i17 >> 2] = i2;
   break;
  }
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i18 + 2516 >> 2] | 0;
  i12 = i8 + (i7 << 2) | 0;
  L30 : do if (!i6) HEAP32[i10 >> 2] = 0; else {
   i1 = 0;
   i9 = 0;
   i5 = i6;
   while (1) {
    i4 = i8 + (i1 + i7 << 2) | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i20 | 0)) {
     i5 = i5 + -1 | 0;
     HEAP32[i4 >> 2] = HEAP32[i8 + (i5 + i7 << 2) >> 2];
     i4 = i5;
    } else {
     i1 = i1 + 1 | 0;
     i4 = i5;
    }
    i9 = i9 + 1 | 0;
    if (i9 >>> 0 >= i6 >>> 0) break; else i5 = i4;
   }
   HEAP32[i10 >> 2] = i1;
   switch (i1 | 0) {
   case 0:
    break L30;
   case 1:
    break;
   default:
    break L24;
   }
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   break L24;
  } while (0);
  HEAP32[i11 >> 2] = 0;
  i2 = i2 & -33;
  HEAP32[i17 >> 2] = i2;
 } while (0);
 i5 = i3 + 28 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L42 : do if (!i6) i1 = 0; else {
  i4 = HEAP32[i3 + 24 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i20 | 0)) break L42;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i6 >>> 0);
 } while (0);
 if ((i1 | 0) == (i6 | 0)) {
  do if (!(HEAP16[(HEAP32[gb + 90260 + 24 + ((i2 >>> 24 & 15) << 2) >> 2] | 0) + i19 + 8 >> 1] & 8)) {
   HEAP32[i15 >> 2] = i20;
   HEAP8[i15 + 4 >> 0] = i14 & 1;
   i1 = i3 + 76 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i3 + 80 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i14 = i15;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = (HEAP32[i3 + 72 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i3 + 36 | 0, i15) | 0;
    break;
   }
  } else if (i13) {
   if (HEAP32[i20 + 4 >> 2] & 268435456 | 0) __ZN5physx3Scb13ObjectTracker6removeERNS0_4BaseE(i18 + 2464 | 0, i20);
   break;
  } else {
   HEAP32[i16 >> 2] = i20;
   HEAP8[i16 + 4 >> 0] = 0;
   i1 = i3 + 76 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i3 + 80 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i14 = i16;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = (HEAP32[i3 + 72 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i3 + 36 | 0, i16) | 0;
    break;
   }
  } while (0);
  i1 = i20 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) == 16777216) {
   HEAP32[i1 >> 2] = i2 | -1073741824;
   HEAP32[i20 >> 2] = i18;
  }
 } else {
  i16 = i6 + -1 | 0;
  HEAP32[i5 >> 2] = i16;
  i2 = HEAP32[i3 + 24 >> 2] | 0;
  HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i2 + (i16 << 2) >> 2];
  i1 = i20 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) == 16777216) {
   HEAP32[i1 >> 2] = i2 & 1073741823 | -2147483648;
   HEAP32[i20 >> 2] = i18;
  }
 }
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i19 >> 2] | 0, i19);
 HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 8;
 STACKTOP = i21;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_(i31, i1, i3, i2) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 144 | 0;
 i26 = i30;
 i22 = i30 + 752 | 0;
 i29 = i30 + 352 | 0;
 i20 = i30 + 688 | 0;
 i25 = i30 + 784 | 0;
 i27 = i30 + 288 | 0;
 i23 = i30 + 148 | 0;
 i24 = i31 + 8 | 0;
 i19 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i24 >> 2] | 0) | 0;
 i21 = i29 + 320 | 0;
 i6 = i29 + 324 | 0;
 HEAP32[i29 + 328 >> 2] = 0;
 i7 = i29 + 332 | 0;
 HEAP8[i21 >> 0] = 1;
 HEAP32[i6 >> 2] = i29;
 HEAP32[i7 >> 2] = 5;
 HEAPF32[i20 >> 2] = Math_fround(2.0);
 HEAPF32[i20 + 4 >> 2] = Math_fround(17.9049301);
 HEAPF32[i20 + 8 >> 2] = Math_fround(1.0e3);
 HEAPF32[i20 + 12 >> 2] = Math_fround(5.72957754);
 HEAP32[i20 + 40 >> 2] = 0;
 HEAPF32[i20 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 24 >> 2] = Math_fround(.100000001);
 HEAPF32[i20 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 44 >> 2] = Math_fround(.00100000005);
 HEAPF32[i20 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i20 + 52 >> 2] = Math_fround(1.11111116);
 __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i29, i5, i20);
 if (i5 | 0) {
  i8 = i26 + 4 | 0;
  i9 = i31 + 4 | 0;
  i10 = i31 + 12 | 0;
  i11 = i31 + 16 | 0;
  i12 = i27;
  i13 = i22 + 4 | 0;
  i14 = i22 + 8 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 20 | 0;
  i18 = i22 + 24 | 0;
  i20 = 0;
  do {
   i1 = i25;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i28 >> 2] = i20;
   __ZN5physx6string9sprintf_sEPcjPKcz(i25, 32, gb + 832301 | 0, i28) | 0;
   i1 = HEAP32[i31 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i31 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i31 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i26 >> 2] = i25;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i33 = i26;
    i32 = HEAP32[i33 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i4 + 4 >> 2] = i32;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i26) | 0;
   mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, HEAP32[i24 >> 2] | 0, i20 | 0);
   _memset(i23 | 0, 0, 140) | 0;
   __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev(i23);
   i32 = HEAP32[i31 >> 2] | 0;
   i33 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev(i26);
   HEAP32[i22 >> 2] = i32;
   HEAP32[i13 >> 2] = i33;
   HEAP32[i14 >> 2] = i12;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = i2;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   __ZNK5physx30PxVehicleTireDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEEEEjT_j(i26, i22, 0) | 0;
   i2 = HEAP32[i31 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i31 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i5 | 0));
 }
 i33 = HEAP32[i7 >> 2] | 0;
 if (!((i33 | 0) > -1 & (i33 & 2147483647 | 0) != 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i29 | 0) == (i1 | 0)) {
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i30;
  return;
 }
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i33 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2] | 0, i33 | 0, i1 | 0);
 STACKTOP = i30;
 return;
}

function __ZN13AudioProfiler15CaptureDSPNodesEPN4FMOD3DSPERNS_27AudioProfilerCaptureContextEjjf(i19, i20, i16, i17, f18) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 f18 = Math_fround(f18);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26 + 28 | 0;
 i15 = i26;
 i7 = i26 + 40 | 0;
 i25 = i26 + 24 | 0;
 i1 = i26 + 20 | 0;
 i4 = i26 + 32 | 0;
 i5 = i26 + 35 | 0;
 i6 = i26 + 34 | 0;
 i21 = i26 + 16 | 0;
 i22 = i26 + 12 | 0;
 HEAPF32[i24 >> 2] = f18;
 i23 = i19;
 i2 = i7;
 i3 = i2 + 40 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i25 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN4FMOD3DSP12getNumInputsEPi(i19, i25) | 0;
 __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_(i19, i7, 0, i1, 0, 0) | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i10 = i20 + 12 | 0;
 i14 = HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0;
 HEAP16[i4 >> 1] = 0;
 __ZN4FMOD3DSP11getCPUUsageEPt(i19 | 0, i4 | 0) | 0;
 f12 = Math_fround(HEAPU16[i4 >> 1] | 0);
 __ZN4FMOD3DSP9getActiveEPb(i19, i5) | 0;
 __ZN4FMOD3DSP9getBypassEPb(i19, i6) | 0;
 i11 = (HEAP8[i6 >> 0] | 0 ? 2 : 0) | HEAPU8[i5 >> 0];
 i1 = HEAP32[i10 >> 2] | 0;
 if (HEAP8[i7 >> 0] | 0) do {
  i3 = i1 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i1 + 16 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i5 >>> 0 > i9 >>> 0) {
   i2 = i8 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i1 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = HEAP8[i7 >> 0] | 0;
  i7 = i7 + 1 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } while ((HEAP8[i7 >> 0] | 0) != 0);
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i1 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i1 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = 0;
 i2 = HEAP32[i20 + 4 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 44 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 44 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 44 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + (i4 * 44 | 0) >> 2] = i23;
 HEAP32[i1 + (i4 * 44 | 0) + 4 >> 2] = i16;
 HEAP32[i1 + (i4 * 44 | 0) + 8 >> 2] = i17;
 HEAP32[i1 + (i4 * 44 | 0) + 12 >> 2] = i13;
 HEAP32[i1 + (i4 * 44 | 0) + 16 >> 2] = i14;
 HEAPF32[i1 + (i4 * 44 | 0) + 20 >> 2] = f18;
 HEAPF32[i1 + (i4 * 44 | 0) + 24 >> 2] = f12;
 i17 = i1 + (i4 * 44 | 0) + 28 | 0;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i1 + (i4 * 44 | 0) + 40 >> 2] = i11;
 i1 = HEAP32[i25 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  i25 = i1;
  STACKTOP = i26;
  return i25 | 0;
 }
 i2 = 0;
 do {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i22 >> 2] = 0;
  __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(i19, i2, i21, i22) | 0;
  __ZN4FMOD13DSPConnection6getMixEPf(HEAP32[i22 >> 2] | 0, i24 | 0) | 0;
  __ZN13AudioProfiler15CaptureDSPNodesEPN4FMOD3DSPERNS_27AudioProfilerCaptureContextEjjf(HEAP32[i21 >> 2] | 0, i20, i23, i2, Math_fround(HEAPF32[i24 >> 2])) | 0;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i25 >> 2] | 0;
 } while ((i2 | 0) < (i1 | 0));
 STACKTOP = i26;
 return i1 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12resize_deltaEjj(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i6 + 80 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i3 = (HEAP32[i6 + 68 >> 2] | 0) - (HEAP32[i6 + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 < (HEAP32[i6 + 72 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i6 + 64 >> 2] | 0;
   if (i1 >>> 0 > 32) {
    f2 = Math_fround(i3 >>> 0);
    do {
     i3 = i1;
     i1 = i1 >>> 1;
     if (i3 >>> 0 < 66) break;
    } while (f2 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
    HEAP32[i8 + 4 >> 2] = 0;
    i3 = HEAP16[i6 + 8 >> 1] | 0;
    HEAP8[i8 + 8 >> 0] = i3;
    HEAP8[i8 + 9 >> 0] = (i3 & 65535) >>> 8;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 12 | 0, i6 + 12 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 24 | 0, i6 + 24 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 36 | 0, i6 + 36 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 48 | 0, i6 + 48 | 0);
    HEAP32[i8 + 60 >> 2] = 0;
    i3 = i8 + 64 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i8 + 68 >> 2] = 0;
    HEAP32[i8 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    f2 = Math_fround((HEAP32[i3 >> 2] | 0) >>> 0);
    HEAP32[i8 + 76 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
    HEAP32[i8 + 72 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
    HEAP8[i8 + 80 >> 0] = 0;
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j(i8, i6, i1);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_(i6, i8);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i8);
   }
  }
  HEAP8[i4 >> 0] = 0;
 }
 i4 = HEAP32[i6 + 64 >> 2] | 0;
 i1 = HEAP32[i6 + 68 >> 2] | 0;
 if (i4 >>> 0 > i7 >>> 0) if ((i1 + i5 | 0) >>> 0 <= (HEAP32[i6 + 76 >> 2] | 0) >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + i5 | 0;
 f2 = Math_fround(i3 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround((i3 - (HEAP32[i6 + 4 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 HEAP32[i8 + 4 >> 2] = 0;
 i7 = HEAP16[i6 + 8 >> 1] | 0;
 HEAP8[i8 + 8 >> 0] = i7;
 HEAP8[i8 + 9 >> 0] = (i7 & 65535) >>> 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 12 | 0, i6 + 12 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 24 | 0, i6 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 36 | 0, i6 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8 + 48 | 0, i6 + 48 | 0);
 HEAP32[i8 + 60 >> 2] = 0;
 i7 = i8 + 64 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 0;
 HEAP32[i8 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f2 = Math_fround((HEAP32[i7 >> 2] | 0) >>> 0);
 HEAP32[i8 + 76 >> 2] = ~~Math_fround(f2 * Math_fround(.5)) >>> 0;
 HEAP32[i8 + 72 >> 2] = ~~Math_fround(f2 * Math_fround(.200000003)) >>> 0;
 HEAP8[i8 + 80 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j(i8, i6, i1);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_(i6, i8);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 16 | 0;
 i9 = i11;
 i10 = i9 + 8 | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!(i1 & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i6 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 30; else {
      HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i6 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i9, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i6 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 41; else {
      i4 = HEAP32[i2 + 4 >> 2] | 0;
      i5 = i10;
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i5 + 4 >> 2] = i4;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i5 = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
     i6 = i10 + 4 | 0;
     HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i5;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  HEAP32[i7 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(HEAP32[i9 >> 2] | 0, 0) | 0;
  STACKTOP = i11;
  return;
 } else {
  i4 = (i1 & 8388608 | 0) != 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i6 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 7; else {
      HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
      i13 = i2;
      i12 = HEAP32[i13 + 4 >> 2] | 0;
      i2 = i10;
      HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i2 + 4 >> 2] = i12;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i12 = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
     i13 = i10 + 4 | 0;
     HEAP32[i10 >> 2] = _llvm_bswap_i32(HEAP32[i13 >> 2] | 0) | 0;
     HEAP32[i13 >> 2] = i12;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i9, i5);
  HEAP32[i7 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(HEAP32[i5 >> 2] | 0, i4) | 0;
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_(i6, i7, i8, i4, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i3 = mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0;
 i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0;
 do if (i3) {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP16[i5 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
  if (i1) {
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   i1 = i8 + 4 | 0;
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP16[i3 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
   i2 = 1;
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i1 = i7 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP16[i3 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP16[i5 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   i2 = i8 + 4 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP16[i1 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i2 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
   i2 = 2;
  } else i2 = 1;
 } else if (i1) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP16[i5 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  i3 = i8 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP16[i1 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP16[i3 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i6 + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP16[i5 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP16[i3 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
   i2 = 2;
  } else i2 = 1;
 } else i2 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i8 | 0) | 0)) {
  i9 = i2;
  STACKTOP = i10;
  return i9 | 0;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i3 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0)) {
  i11 = i2 + 1 | 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 i1 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP16[i1 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i3 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i11 = i2 + 2 | 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[i6 >> 2] | 0;
 i9 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i9 + 8 >> 1] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i9 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 i11 = i2 + 3 | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN14RenderSettings17UpdateGlobalStateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i2 = i8;
 i6 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 i1 = __ZN10builtintex21GetAttenuationTextureEv() | 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i6, gb + 1112276 | 0, i1);
 i1 = __ZN10builtintex15GetWhiteTextureEv() | 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i6, gb + 1112280 | 0, i1);
 i1 = __ZN10builtintex15GetWhiteTextureEv() | 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i6, gb + 1112284 | 0, i1);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i6, gb + 1112288 | 0, Math_fround(0.0), 0);
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i6, gb + 1112292 | 0, i5, 0);
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i6, gb + 1112296 | 0, i5, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i6, gb + 1112300 | 0, i5, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i6, gb + 1112304 | 0, i5, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i6, gb + 1112308 | 0, i5, 0);
 i6 = i7 + 348 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) i4 = 10; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i2);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) i4 = 10;
 } while (0);
 if ((i4 | 0) == 10) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 453292 | 0, 8);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 32032 | 0, i5) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i7);
 __ZN14RenderSettings14ApplyFogParamsEv(i7);
 __ZN14RenderSettings16ApplyHaloTextureEv(i7);
 i3 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  i5 = i7 + 368 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i5 = (i5 | 0) == 0;
  i9 = i7 + 384 | 0;
  i6 = i7 + 380 | 0;
  i6 = i5 ? i9 : i6;
  i6 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[gb + 1112272 >> 2] | 0;
  i5 = i7 + 364 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  i6 = i9 + 4 | 0;
  HEAP32[i6 >> 2] = i5;
  __ZN16ReflectionProbes16UpdateSampleDataEv(i9);
  __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i7);
  STACKTOP = i8;
  return;
 }
 do {
  i9 = i1 + -36 | 0;
  __ZN5Light9SetupHaloEv(i9);
  __ZN5Light10SetupFlareEv(i9);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i5 = i7 + 368 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = (i5 | 0) == 0;
 i9 = i7 + 384 | 0;
 i6 = i7 + 380 | 0;
 i6 = i5 ? i9 : i6;
 i6 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[gb + 1112272 >> 2] | 0;
 i5 = i7 + 364 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i5;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i9);
 __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i7);
 STACKTOP = i8;
 return;
}

function __Z15raycast_capsuleRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i10, i9, i18, i17, f4, i19, i7, i21, i1, i6, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 f4 = Math_fround(f4);
 i19 = i19 | 0;
 i7 = i7 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var f2 = f0, f3 = f0, f5 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 16 | 0;
 i1 = i20 + 8 | 0;
 i16 = i20;
 f27 = Math_fround(HEAPF32[i9 >> 2]);
 f24 = Math_fround(f27 * Math_fround(2.0));
 f2 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f22 = Math_fround(f2 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f27 * f24) + Math_fround(Math_fround(f2 * f22) + Math_fround(-1.0)));
 f27 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f3 = Math_fround(f27 * f22);
 f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f24 * f5));
 f5 = Math_fround(Math_fround(f24 * f27) - Math_fround(f22 * f5));
 f22 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f2 = Math_fround(f22 * f2);
 f3 = Math_fround(f22 * f3);
 f5 = Math_fround(f22 * f5);
 f22 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f27 = Math_fround(f22 + f2);
 f24 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f26 = Math_fround(f24 + f3);
 f23 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f25 = Math_fround(f5 + f23);
 HEAPF32[i15 >> 2] = f27;
 i7 = i15 + 4 | 0;
 HEAPF32[i7 >> 2] = f26;
 i11 = i15 + 8 | 0;
 HEAPF32[i11 >> 2] = f25;
 f3 = Math_fround(f24 - f3);
 f5 = Math_fround(f23 - f5);
 i12 = i15 + 12 | 0;
 HEAPF32[i12 >> 2] = Math_fround(f22 - f2);
 i13 = i15 + 16 | 0;
 HEAPF32[i13 >> 2] = f3;
 i14 = i15 + 20 | 0;
 HEAPF32[i14 >> 2] = f5;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i15 + 24 >> 2] = i10;
 i6 = i15 + 12 | 0;
 switch (__ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i18, i17, i15, i6, (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])), i1) | 0) {
 case 1:
  {
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   break;
  }
 case 0:
  {
   i21 = 0;
   STACKTOP = i20;
   return i21 | 0;
  }
 default:
  {
   f3 = Math_fround(HEAPF32[i1 >> 2]);
   i10 = f3 < Math_fround(-9.99999997e-07);
   f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   if (i10 & f2 < Math_fround(-9.99999997e-07)) {
    i21 = 0;
    STACKTOP = i20;
    return i21 | 0;
   }
   f2 = f3 < f2 ? f3 : f2;
   if (f2 < Math_fround(0.0)) f2 = Math_fround(0.0);
  }
 }
 if (f2 > f4) {
  i21 = 0;
  STACKTOP = i20;
  return i21 | 0;
 }
 i9 = i21 + 16 | 0;
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 f25 = Math_fround(f2 * f4);
 f5 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f26 = Math_fround(f2 * f5);
 f3 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f27 = Math_fround(f2 * f3);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i18 >> 2]));
 f26 = Math_fround(f26 + Math_fround(HEAPF32[i18 + 4 >> 2]));
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i18 + 8 >> 2]));
 HEAPF32[i9 >> 2] = f25;
 i8 = i21 + 20 | 0;
 HEAPF32[i8 >> 2] = f26;
 i10 = i21 + 24 | 0;
 HEAPF32[i10 >> 2] = f27;
 HEAPF32[i21 + 40 >> 2] = f2;
 HEAP32[i21 + 8 >> 2] = -1;
 HEAPF32[i21 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i21 + 48 >> 2] = Math_fround(0.0);
 do if (!(HEAP16[i19 >> 1] & 2)) {
  HEAP32[i21 + 28 >> 2] = 0;
  HEAP32[i21 + 32 >> 2] = 0;
  HEAP32[i21 + 36 >> 2] = 0;
  i1 = 5;
 } else {
  if (f2 == Math_fround(0.0)) {
   f26 = Math_fround(-f5);
   f27 = Math_fround(-f3);
   HEAPF32[i21 + 28 >> 2] = Math_fround(-f4);
   HEAPF32[i21 + 32 >> 2] = f26;
   HEAPF32[i21 + 36 >> 2] = f27;
   i1 = 7;
   break;
  }
  Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i15, i6, i9, i16));
  f27 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = Math_fround(HEAPF32[i12 >> 2]);
  f25 = Math_fround(HEAPF32[i15 >> 2]);
  f5 = Math_fround(f5 - f25);
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  f26 = Math_fround(HEAPF32[i7 >> 2]);
  f4 = Math_fround(f4 - f26);
  f3 = Math_fround(HEAPF32[i14 >> 2]);
  f2 = Math_fround(HEAPF32[i11 >> 2]);
  f5 = Math_fround(f25 + Math_fround(f27 * f5));
  f4 = Math_fround(f26 + Math_fround(f27 * f4));
  f2 = Math_fround(f2 + Math_fround(f27 * Math_fround(f3 - f2)));
  i1 = i21 + 28 | 0;
  i6 = i21 + 32 | 0;
  i7 = i21 + 36 | 0;
  f5 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f5);
  f4 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f4);
  f2 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f2);
  HEAPF32[i1 >> 2] = f5;
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 >> 2] = f2;
  f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
  if (f3 > Math_fround(0.0)) {
   f27 = Math_fround(Math_fround(1.0) / f3);
   HEAPF32[i1 >> 2] = Math_fround(f5 * f27);
   HEAPF32[i6 >> 2] = Math_fround(f4 * f27);
   HEAPF32[i7 >> 2] = Math_fround(f2 * f27);
   i1 = 7;
  } else i1 = 7;
 } while (0);
 HEAP16[i21 + 12 >> 1] = i1;
 i21 = 1;
 STACKTOP = i20;
 return i21 | 0;
}

function __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i12, i13, i7, i6, i14, i10) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 24 | 0;
 i1 = i15 + 32 | 0;
 i17 = i15 + 16 | 0;
 i9 = i15 + 8 | 0;
 i16 = i15 + 4 | 0;
 i8 = i15 + 28 | 0;
 i4 = i15;
 HEAP32[i17 >> 2] = i1;
 i20 = i17 + 4 | 0;
 HEAP32[i20 >> 2] = fb + 4003;
 i5 = i1 + 100 | 0;
 __THREW__ = 0;
 i2 = invoke_ii(fb + 2804 | 0, i6 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  HEAP32[i17 >> 2] = 0;
  i19 = 41;
 } else {
  HEAP32[i16 >> 2] = i2;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i16 | 0, gb + 1474556 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   HEAP8[i8 >> 0] = 0;
   i11 = HEAP32[i13 >> 2] | 0;
   HEAP32[i4 >> 2] = i11;
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   i6 = i11;
   __THREW__ = 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i1 = invoke_iiiiiiiiiiii(fb + 1 | 0, i12 | 0, i3 | 0, i7 | 0, i16 | 0, i1 | 0, i14 | 0, i8 | 0, i2 | 0, i17 | 0, i9 | 0, i5 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   L7 : do if (i7 & 1) i19 = 13; else {
    if (i1) {
     i1 = i10 + 11 | 0;
     if ((HEAP8[i1 >> 0] | 0) < 0) {
      HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
      HEAP32[i10 + 4 >> 2] = 0;
     } else {
      HEAP8[i10 >> 0] = 0;
      HEAP8[i1 >> 0] = 0;
     }
     if (HEAP8[i8 >> 0] | 0) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, 45) | 0;
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i19 = 13;
       break;
      }
      __THREW__ = 0;
      invoke_vii(fb + 4511 | 0, i10 | 0, i1 | 0);
      i8 = __THREW__;
      __THREW__ = 0;
      if (i8 & 1) {
       i19 = 13;
       break;
      }
     }
     __THREW__ = 0;
     i4 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, 48) | 0;
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) {
      i19 = 13;
      break;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     i3 = i2 + -1 | 0;
     i1 = HEAP32[i17 >> 2] | 0;
     while (1) {
      if (i1 >>> 0 >= i3 >>> 0) break;
      if ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24) break;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     invoke_iiii(fb + 504 | 0, i10 | 0, i1 | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      break;
     }
    }
    i1 = HEAP32[i12 >> 2] | 0;
    do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i19 = 13;
      break L7;
     }
     if ((i1 | 0) == -1) {
      HEAP32[i12 >> 2] = 0;
      i1 = 0;
      break;
     } else {
      i1 = HEAP32[i12 >> 2] | 0;
      break;
     }
    } while (0);
    i2 = (i1 | 0) == 0;
    do if (!i11) i19 = 33; else {
     if ((HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
      i11 = __THREW__;
      __THREW__ = 0;
      if (i11 & 1) {
       i19 = 13;
       break L7;
      }
      if ((i1 | 0) == -1) {
       HEAP32[i13 >> 2] = 0;
       i19 = 33;
       break;
      }
     }
     if (!i2) i19 = 34;
    } while (0);
    if ((i19 | 0) == 33) if (i2) i19 = 34;
    if ((i19 | 0) == 34) HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 2;
    i2 = HEAP32[i12 >> 2] | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i16 >> 2] | 0) | 0;
    i1 = HEAP32[i17 >> 2] | 0;
    HEAP32[i17 >> 2] = 0;
    if (i1 | 0) {
     __THREW__ = 0;
     invoke_vi(HEAP32[i20 >> 2] | 0, i1 | 0);
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i20 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i20);
     }
    }
    STACKTOP = i15;
    return i2 | 0;
   } while (0);
   if ((i19 | 0) == 13) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
   i2 = i1;
  }
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i16 >> 2] | 0) | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  HEAP32[i17 >> 2] = 0;
  if (!i1) i18 = i2; else i19 = 41;
 }
 if ((i19 | 0) == 41) {
  __THREW__ = 0;
  invoke_vi(HEAP32[i20 >> 2] | 0, i1 | 0);
  i20 = __THREW__;
  __THREW__ = 0;
  if (i20 & 1) {
   i20 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i20);
  } else i18 = i2;
 }
 ___resumeException(i18 | 0);
 return 0;
}

function __ZN6Camera8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i7);
 i1 = i9 + 844 | 0;
 i10 = i7 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i7 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 848 | 0, i7);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i9 + 864 | 0, gb + 373323 | 0, 0);
 i1 = i9 + 920 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 924 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 292 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 1088 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i9 + 916 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 888 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 880 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 928 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 __ZN4PPtrI13RenderTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 744 | 0, i7);
 i1 = i9 + 820 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i5 = i9 + 824 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i9 + 1091 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i9 + 1089 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i9 + 1100 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i9 + 1096 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i3, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 1112 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx3Cct15ObstacleContext11addObstacleERKNS_10PxObstacleE(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 64 | 0;
 i12 = i15;
 switch (HEAP32[i1 >> 2] | 0) {
 case 3:
  {
   i11 = i14 + 4 | 0;
   i12 = i14 + 8 | 0;
   i3 = __ZN5physx3Cct13HandleManager3AddEPv(i14 + 28 | 0, HEAP32[i12 >> 2] << 16 | 4) | 0;
   HEAP32[i13 >> 2] = i3;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i5 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i13 + 40 >> 2] = i5;
   i6 = HEAP32[i1 + 36 >> 2] | 0;
   HEAP32[i13 + 44 >> 2] = i6;
   i7 = HEAP32[i1 + 40 >> 2] | 0;
   HEAP32[i13 + 48 >> 2] = i7;
   i8 = HEAP32[i1 + 44 >> 2] | 0;
   HEAP32[i13 + 52 >> 2] = i8;
   i9 = HEAP32[i1 + 48 >> 2] | 0;
   HEAP32[i13 + 56 >> 2] = i9;
   i10 = HEAP32[i1 + 52 >> 2] | 0;
   HEAP32[i13 + 60 >> 2] = i10;
   i1 = HEAP32[i1 + 56 >> 2] | 0;
   HEAP32[i13 + 64 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   if ((HEAP32[i14 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i13 = HEAP32[i11 >> 2] | 0;
    i11 = i13 + (i2 * 72 | 0) + 8 | 0;
    HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i11 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i11 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i11 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
    HEAP32[i11 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
    HEAP32[i13 + (i2 * 72 | 0) + 40 >> 2] = i5;
    HEAP32[i13 + (i2 * 72 | 0) + 44 >> 2] = i6;
    HEAP32[i13 + (i2 * 72 | 0) + 48 >> 2] = i7;
    HEAP32[i13 + (i2 * 72 | 0) + 52 >> 2] = i8;
    HEAP32[i13 + (i2 * 72 | 0) + 56 >> 2] = i9;
    HEAP32[i13 + (i2 * 72 | 0) + 60 >> 2] = i10;
    HEAP32[i13 + (i2 * 72 | 0) + 64 >> 2] = i1;
    HEAP32[i13 + (i2 * 72 | 0) >> 2] = i3;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext19InternalBoxObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i11, i13) | 0;
   __ZNK5physx3Cct26CharacterControllerManager15onObstacleAddedEjPKNS_17PxObstacleContextE(HEAP32[i14 + 56 >> 2] | 0, i3, i14);
   i14 = i3;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 2:
  {
   i4 = i14 + 16 | 0;
   i5 = i14 + 20 | 0;
   i6 = __ZN5physx3Cct13HandleManager3AddEPv(i14 + 28 | 0, HEAP32[i5 >> 2] << 16 | 3) | 0;
   HEAP32[i12 >> 2] = i6;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i7 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i8 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i12 + 40 >> 2] = i8;
   i9 = HEAP32[i1 + 36 >> 2] | 0;
   HEAP32[i12 + 44 >> 2] = i9;
   i10 = HEAP32[i1 + 40 >> 2] | 0;
   HEAP32[i12 + 48 >> 2] = i10;
   i11 = HEAP32[i1 + 44 >> 2] | 0;
   HEAP32[i12 + 52 >> 2] = i11;
   i2 = i1 + 48 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i12 + 56 | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i14 + 24 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i13 = HEAP32[i4 >> 2] | 0;
    i12 = i13 + (i3 << 6) + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i12 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
    HEAP32[i12 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
    HEAP32[i13 + (i3 << 6) + 40 >> 2] = i8;
    HEAP32[i13 + (i3 << 6) + 44 >> 2] = i9;
    HEAP32[i13 + (i3 << 6) + 48 >> 2] = i10;
    HEAP32[i13 + (i3 << 6) + 52 >> 2] = i11;
    i12 = i13 + (i3 << 6) + 56 | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i2;
    HEAP32[i13 + (i3 << 6) >> 2] = i6;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext23InternalCapsuleObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i4, i12) | 0;
   __ZNK5physx3Cct26CharacterControllerManager15onObstacleAddedEjPKNS_17PxObstacleContextE(HEAP32[i14 + 56 >> 2] | 0, i6, i14);
   i14 = i6;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i14 = -1;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 108 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i1 + 11 >> 0] = 7;
   HEAP8[i1 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
   HEAP8[i1 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
   HEAP8[i1 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
   HEAP8[i1 + 7 >> 0] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 1;
   HEAP32[i1 + 32 >> 2] = 1;
   HEAPF32[i1 + 36 >> 2] = Math_fround(15.0);
   HEAPF32[i1 + 40 >> 2] = Math_fround(3.0);
   HEAPF32[i1 + 44 >> 2] = Math_fround(.333333343);
   HEAPF32[i1 + 48 >> 2] = Math_fround(.0666666701);
   HEAPF32[i1 + 52 >> 2] = Math_fround(.200000003);
   HEAPF32[i1 + 56 >> 2] = Math_fround(.466666669);
   HEAP32[i1 + 60 >> 2] = 1;
   HEAP32[i1 + 64 >> 2] = 1;
   i10 = i1 + 68 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
   HEAP32[i1 + 88 >> 2] = 0;
   HEAP32[i1 + 92 >> 2] = 4;
   HEAPF32[i1 + 96 >> 2] = Math_fround(512.0);
   HEAP32[i1 + 100 >> 2] = 2;
   HEAP32[i1 + 104 >> 2] = 4;
   i1 = (HEAP32[i7 >> 2] | 0) + 108 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 108 | 0) + i2 | 0;
 if (i6 >>> 0 > 39768215) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 108 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 19884107 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 39768215;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 108 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 108 | 0) * 108 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 108 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i1 + 11 >> 0] = 7;
  HEAP8[i1 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
  HEAP8[i1 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
  HEAP8[i1 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
  HEAP8[i1 + 7 >> 0] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 1;
  HEAP32[i1 + 32 >> 2] = 1;
  HEAPF32[i1 + 36 >> 2] = Math_fround(15.0);
  HEAPF32[i1 + 40 >> 2] = Math_fround(3.0);
  HEAPF32[i1 + 44 >> 2] = Math_fround(.333333343);
  HEAPF32[i1 + 48 >> 2] = Math_fround(.0666666701);
  HEAPF32[i1 + 52 >> 2] = Math_fround(.200000003);
  HEAPF32[i1 + 56 >> 2] = Math_fround(.466666669);
  HEAP32[i1 + 60 >> 2] = 1;
  HEAP32[i1 + 64 >> 2] = 1;
  i7 = i1 + 68 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
  HEAP32[i1 + 88 >> 2] = 0;
  HEAP32[i1 + 92 >> 2] = 4;
  HEAPF32[i1 + 96 >> 2] = Math_fround(512.0);
  HEAP32[i1 + 100 >> 2] = 2;
  HEAP32[i1 + 104 >> 2] = 4;
  i1 = (HEAP32[i6 >> 2] | 0) + 108 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i10);
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i3 = i9 + 4 | 0;
  i2 = i1;
  while (1) {
   i1 = i2 + -108 | 0;
   HEAP32[i6 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i2 + -96 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i3 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx13PxsCCDContext12postCCDSweepEPNS_10PxBaseTaskE(i22, i5) {
 i22 = i22 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i8 = HEAP32[i22 + 244 >> 2] | 0;
 if (!i8) return;
 i15 = i22 + 240 | 0;
 i16 = i22 + 256 | 0;
 i17 = i22 + 264 | 0;
 i18 = i22 + 92 | 0;
 i19 = i22 + 260 | 0;
 i20 = i22 + 228 | 0;
 i21 = i22 + 232 | 0;
 i9 = i22 + 100 | 0;
 i10 = i22 + 252 | 0;
 i11 = i22 + 148 | 0;
 i12 = i22 + 160 | 0;
 i13 = i22 + 88 | 0;
 i14 = i22 + 96 | 0;
 if (!i5) {
  i5 = 0;
  i6 = 0;
  while (1) {
   i1 = i5 + 1 | 0;
   i4 = i5;
   i2 = 0;
   while (1) {
    if (i4 >>> 0 >= i8 >>> 0) break;
    i2 = (HEAP32[(HEAP32[i15 >> 2] | 0) + (i4 << 2) >> 2] | 0) + i2 | 0;
    i3 = i4 + 1 | 0;
    if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
     i1 = i3;
     break;
    } else i4 = i3;
   }
   if ((i4 | 0) == (i8 | 0)) if (!i2) {
    i1 = 15;
    break;
   } else i1 = i8;
   i28 = HEAP32[(HEAP32[i17 >> 2] | 0) + 6960 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i28 >> 2] | 0);
   i7 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i28, 80, 16) | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i28 >> 2] | 0);
   i28 = HEAP32[i18 >> 2] | 0;
   i25 = (i28 | 0) == ((HEAP32[i19 >> 2] | 0) + -1 | 0);
   i32 = HEAP32[i20 >> 2] | 0;
   i31 = HEAP32[i21 >> 2] | 0;
   i30 = HEAP32[i17 >> 2] | 0;
   i29 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8752 >> 2] | 0;
   i27 = HEAP32[i11 >> 2] | 0;
   i26 = HEAP32[i12 >> 2] | 0;
   i24 = HEAP8[i13 >> 0] | 0;
   HEAP16[i7 + 4 >> 1] = -1;
   HEAP16[i7 + 6 >> 1] = 0;
   i4 = i7 + 8 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i7 >> 2] = gb + 87404 + 8;
   i3 = i7 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   i23 = i7 + 16 | 0;
   HEAP32[i23 >> 2] = 0;
   HEAP32[i7 >> 2] = gb + 102824 + 8;
   HEAP32[i7 + 20 >> 2] = i32;
   HEAP32[i7 + 24 >> 2] = i31;
   HEAP32[i7 + 28 >> 2] = i30;
   HEAP32[i7 + 32 >> 2] = i22;
   HEAP32[i7 + 36 >> 2] = i29;
   HEAP32[i7 + 40 >> 2] = i28;
   HEAP32[i7 + 44 >> 2] = i9;
   HEAP32[i7 + 48 >> 2] = i5;
   HEAP32[i7 + 52 >> 2] = i1 - i5;
   HEAP32[i7 + 56 >> 2] = i8;
   HEAP32[i7 + 60 >> 2] = i6;
   HEAP32[i7 + 64 >> 2] = i27;
   HEAP32[i7 + 68 >> 2] = i26;
   HEAP32[i7 + 72 >> 2] = i14;
   HEAP8[i7 + 76 >> 0] = i25 & 1;
   HEAP8[i7 + 77 >> 0] = i24;
   i5 = HEAP32[(HEAP32[i17 >> 2] | 0) + 6956 >> 2] | 0;
   HEAP32[i23 >> 2] = 1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 >> 2] = i5;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
   if (i1 >>> 0 < i8 >>> 0) {
    i5 = i1;
    i6 = i2 + i6 | 0;
   } else {
    i1 = 15;
    break;
   }
  }
  if ((i1 | 0) == 15) return;
 } else {
  i6 = 0;
  i7 = 0;
  while (1) {
   i1 = i6 + 1 | 0;
   i4 = i6;
   i2 = 0;
   while (1) {
    if (i4 >>> 0 >= i8 >>> 0) break;
    i2 = (HEAP32[(HEAP32[i15 >> 2] | 0) + (i4 << 2) >> 2] | 0) + i2 | 0;
    i3 = i4 + 1 | 0;
    if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) {
     i1 = i3;
     break;
    } else i4 = i3;
   }
   if ((i4 | 0) == (i8 | 0)) if (!i2) {
    i1 = 15;
    break;
   } else i1 = i8;
   i24 = HEAP32[(HEAP32[i17 >> 2] | 0) + 6960 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i24 >> 2] | 0);
   i32 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i24, 80, 16) | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i24 >> 2] | 0);
   i24 = HEAP32[i18 >> 2] | 0;
   i27 = (i24 | 0) == ((HEAP32[i19 >> 2] | 0) + -1 | 0);
   i33 = HEAP32[i20 >> 2] | 0;
   i3 = HEAP32[i21 >> 2] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i23 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8752 >> 2] | 0;
   i25 = HEAP32[i11 >> 2] | 0;
   i26 = HEAP32[i12 >> 2] | 0;
   i30 = HEAP8[i13 >> 0] | 0;
   HEAP16[i32 + 4 >> 1] = -1;
   HEAP16[i32 + 6 >> 1] = 0;
   i31 = i32 + 8 | 0;
   HEAP32[i31 >> 2] = 0;
   HEAP32[i32 >> 2] = gb + 87404 + 8;
   i29 = i32 + 12 | 0;
   HEAP32[i29 >> 2] = 0;
   i28 = i32 + 16 | 0;
   HEAP32[i28 >> 2] = 0;
   HEAP32[i32 >> 2] = gb + 102824 + 8;
   HEAP32[i32 + 20 >> 2] = i33;
   HEAP32[i32 + 24 >> 2] = i3;
   HEAP32[i32 + 28 >> 2] = i4;
   HEAP32[i32 + 32 >> 2] = i22;
   HEAP32[i32 + 36 >> 2] = i23;
   HEAP32[i32 + 40 >> 2] = i24;
   HEAP32[i32 + 44 >> 2] = i9;
   HEAP32[i32 + 48 >> 2] = i6;
   HEAP32[i32 + 52 >> 2] = i1 - i6;
   HEAP32[i32 + 56 >> 2] = i8;
   HEAP32[i32 + 60 >> 2] = i7;
   HEAP32[i32 + 64 >> 2] = i25;
   HEAP32[i32 + 68 >> 2] = i26;
   HEAP32[i32 + 72 >> 2] = i14;
   HEAP8[i32 + 76 >> 0] = i27 & 1;
   HEAP8[i32 + 77 >> 0] = i30;
   i30 = HEAP32[(HEAP32[i17 >> 2] | 0) + 6956 >> 2] | 0;
   HEAP32[i28 >> 2] = 1;
   HEAP32[i29 >> 2] = i5;
   HEAP32[i31 >> 2] = i30;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
   mftCall_vi(HEAP32[(HEAP32[i32 >> 2] | 0) + 20 >> 2] | 0, i32 | 0);
   if (i1 >>> 0 < i8 >>> 0) {
    i6 = i1;
    i7 = i2 + i7 | 0;
   } else {
    i1 = 15;
    break;
   }
  }
  if ((i1 | 0) == 15) return;
 }
}

function __ZN14DetailDatabase8SetLayerEiiiiiPKi(i35, i28, i31, i32, i2, i33, i34) {
 i35 = i35 | 0;
 i28 = i28 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i2 = i2 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0;
 if ((i33 | 0) >= 0) if ((((HEAP32[i35 + 20 >> 2] | 0) - (HEAP32[i35 + 16 >> 2] | 0) | 0) / 136 | 0 | 0) > (i33 | 0)) {
  i29 = i35 + 36 | 0;
  i1 = HEAP32[i29 >> 2] | 0;
  if ((i1 | 0) < 1) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 936627 | 0, 0, gb + 932993 | 0, 237, 1, 0, 0, 0);
   return;
  }
  i30 = i35 + 40 | 0;
  i21 = HEAP32[i30 >> 2] | 0;
  i25 = (i28 | 0) / (i21 | 0) | 0;
  i24 = i1 + -1 | 0;
  i25 = (i25 | 0) < 0 ? 0 : (i25 | 0) > (i24 | 0) ? i24 : i25;
  i1 = (i31 | 0) / (i21 | 0) | 0;
  i1 = (i1 | 0) < 0 ? 0 : (i1 | 0) > (i24 | 0) ? i24 : i1;
  i27 = i32 + i28 | 0;
  i26 = (i27 | 0) / (i21 | 0) | 0;
  i26 = (i26 | 0) < 0 ? 0 : (i26 | 0) > (i24 | 0) ? i24 : i26;
  i22 = i2 + i31 | 0;
  i21 = (i22 | 0) / (i21 | 0) | 0;
  i21 = (i21 | 0) < 0 ? 0 : (i21 | 0) > (i24 | 0) ? i24 : i21;
  if ((i1 | 0) <= (i21 | 0)) {
   i23 = (i25 | 0) > (i26 | 0);
   i24 = i35 + 4 | 0;
   while (1) {
    if (!i23) {
     i20 = i25;
     while (1) {
      i19 = HEAP32[i30 >> 2] | 0;
      i3 = Math_imul(i19, i20) | 0;
      i12 = i28 - i3 | 0;
      i13 = i19 + -1 | 0;
      i12 = (i12 | 0) < 0 ? 0 : (i12 | 0) > (i13 | 0) ? i13 : i12;
      i2 = Math_imul(i19, i1) | 0;
      i11 = i31 - i2 | 0;
      i11 = (i11 | 0) < 0 ? 0 : (i11 | 0) > (i13 | 0) ? i13 : i11;
      i13 = i27 - i3 | 0;
      i14 = i22 - i2 | 0;
      i13 = ((i13 | 0) < 0 ? 0 : (i13 | 0) > (i19 | 0) ? i19 : i13) - i12 | 0;
      i14 = ((i14 | 0) < 0 ? 0 : (i14 | 0) > (i19 | 0) ? i19 : i14) - i11 | 0;
      do if (!((i13 | 0) == 0 | (i14 | 0) == 0)) {
       i18 = (Math_imul(HEAP32[i29 >> 2] | 0, i1) | 0) + i20 | 0;
       i19 = HEAP32[i24 >> 2] | 0;
       i17 = __ZN14DetailDatabase13AddLayerIndexEiR11DetailPatch(i35, i33, i19 + (i18 * 52 | 0) | 0) | 0;
       i15 = i19 + (i18 * 52 | 0) + 40 | 0;
       i16 = HEAP32[i15 >> 2] | 0;
       if ((i14 | 0) > 0) {
        i10 = i11 - i31 + i2 | 0;
        i6 = i12 - i28 + i3 | 0;
        i7 = i19 + (i18 * 52 | 0) + 24 | 0;
        if ((i13 | 0) > 0) {
         i4 = 0;
         do {
          i8 = i6 + (Math_imul(i10 + i4 | 0, i32) | 0) | 0;
          i9 = i4 + i11 | 0;
          i3 = 0;
          do {
           i2 = HEAP32[i34 + (i8 + i3 << 2) >> 2] | 0;
           i2 = (i2 | 0) < 0 ? 0 : (i2 | 0) > 255 ? 255 : i2;
           i5 = HEAP32[i30 >> 2] | 0;
           i5 = i16 + (i3 + i12 + (Math_imul(i9 + (Math_imul(i5, i17) | 0) | 0, i5) | 0)) | 0;
           if ((i2 | 0) != (HEAPU8[i5 >> 0] | 0 | 0)) {
            HEAP8[i5 >> 0] = i2;
            HEAP8[i7 >> 0] = 1;
           }
           i3 = i3 + 1 | 0;
          } while ((i3 | 0) != (i13 | 0));
          i4 = i4 + 1 | 0;
         } while ((i4 | 0) != (i14 | 0));
        }
       }
       i4 = HEAP32[i30 >> 2] | 0;
       i7 = Math_imul(i4, i4) | 0;
       i8 = (i7 | 0) == 0;
       if (!i8) {
        i5 = Math_imul(i7, i17) | 0;
        i2 = 0;
        i3 = 0;
        do {
         i2 = (HEAPU8[i16 + (i3 + i5) >> 0] | 0) + i2 | 0;
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) < (i7 | 0));
        if (i2 | 0) break;
        i6 = Math_imul(Math_imul(i4, i17) | 0, i4) | 0;
        i6 = (HEAP32[i15 >> 2] | 0) + i6 | 0;
        i3 = i6 + i7 | 0;
        if (!i8) {
         i5 = i19 + (i18 * 52 | 0) + 44 | 0;
         i2 = HEAP32[i5 >> 2] | 0;
         i4 = i2 - i3 | 0;
         if (!i4) i3 = i2; else {
          _memmove(i6 | 0, i3 | 0, i4 | 0) | 0;
          i3 = HEAP32[i5 >> 2] | 0;
         }
         i2 = i6 + i4 | 0;
         if ((i3 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i2;
        }
       }
       i6 = (HEAP32[i19 + (i18 * 52 | 0) + 28 >> 2] | 0) + i17 | 0;
       i3 = i6 + 1 | 0;
       i5 = i19 + (i18 * 52 | 0) + 32 | 0;
       i2 = HEAP32[i5 >> 2] | 0;
       i4 = i2 - i3 | 0;
       if (!i4) i3 = i2; else {
        _memmove(i6 | 0, i3 | 0, i4 | 0) | 0;
        i3 = HEAP32[i5 >> 2] | 0;
       }
       i2 = i6 + i4 | 0;
       if ((i3 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i2;
      } while (0);
      if ((i20 | 0) < (i26 | 0)) i20 = i20 + 1 | 0; else break;
     }
    }
    if ((i1 | 0) < (i21 | 0)) i1 = i1 + 1 | 0; else break;
   }
  }
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(HEAP32[i35 + 28 >> 2] | 0, 16);
  i2 = HEAP32[i35 + 8 >> 2] | 0;
  i1 = HEAP32[i35 + 4 >> 2] | 0;
  i3 = i1;
  if ((i2 | 0) == (i1 | 0)) return;
  i2 = (i2 - i1 | 0) / 52 | 0;
  i1 = 0;
  do {
   HEAP8[i3 + (i1 * 52 | 0) + 24 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 936662 | 0, 0, gb + 932993 | 0, 232, 1, 0, 0, 0);
 return;
}

function __ZN15DetailPrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932534 | 0, gb + 932544 | 0, i1, 0);
 i8 = i10 + 8 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932561 | 0, gb + 1034905 | 0, i8, 0);
 i6 = i10 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932578 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932587 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932596 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932606 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932616 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932628 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 32 | 0;
 i8 = HEAP32[gb + 36980 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932639 | 0, i8, i7, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932652 | 0, i8, i7, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932661 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932676 | 0, i6, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932687 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_123parse_prefix_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_(i1, i2, i4, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 36 | 0;
 i14 = i16 + 24 | 0;
 i17 = i16 + 12 | 0;
 i15 = i16;
 i12 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i3) | 0;
 L1 : do if ((i12 | 0) != (i1 | 0)) {
  i2 = i3 + 4 | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i11 | 0)) {
   i10 = i11 + -24 | 0;
   __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EERKSB_PKS8_(i17, i4, gb + 1086383 | 0);
   __THREW__ = 0;
   invoke_vii(fb + 4619 | 0, i15 | 0, (HEAP32[i2 >> 2] | 0) + -24 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    i2 = HEAP8[i15 + 11 >> 0] | 0;
    i8 = i2 << 24 >> 24 < 0;
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 519 | 0, i17 | 0, (i8 ? HEAP32[i15 >> 2] | 0 : i15) | 0, (i8 ? HEAP32[i15 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    do if (i8 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iii(fb + 1152 | 0, i14 | 0, gb + 1086288 | 0) | 0;
     i8 = __THREW__;
     __THREW__ = 0;
     if (i8 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i14);
      break;
     };
     HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     i7 = i10 + 11 | 0;
     if ((HEAP8[i7 >> 0] | 0) < 0) {
      HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
      HEAP32[i11 + -20 >> 2] = 0;
      i1 = HEAP8[i7 >> 0] | 0;
      if (i1 << 24 >> 24 < 0) {
       i8 = 0;
       i5 = (HEAP32[i11 + -16 >> 2] & 2147483647) + -1 | 0;
       i4 = 1;
      } else i9 = 16;
     } else {
      HEAP8[i10 >> 0] = 0;
      HEAP8[i7 >> 0] = 0;
      i1 = 0;
      i9 = 16;
     }
     if ((i9 | 0) == 16) {
      i8 = i1 & 255;
      i5 = 10;
      i4 = 0;
     }
     i2 = i8 >>> 0 < 11;
     i6 = i2 ? 10 : (i8 + 16 & 496) + -1 | 0;
     L28 : do if ((i6 | 0) != (i5 | 0)) {
      do if (i2) {
       i2 = HEAP32[i10 >> 2] | 0;
       if (i4) {
        i1 = 0;
        i3 = i10;
        i9 = 24;
       } else {
        i4 = 0;
        i5 = 1;
        i3 = i10;
        i9 = 25;
       }
      } else {
       i3 = _malloc(i6 + 1 | 0) | 0;
       if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L28;
       if (i4) {
        i1 = 1;
        i2 = HEAP32[i10 >> 2] | 0;
        i9 = 24;
        break;
       } else {
        i4 = 1;
        i5 = 0;
        i2 = i10;
        i9 = 25;
        break;
       }
      } while (0);
      if ((i9 | 0) == 24) {
       i4 = i1;
       i5 = 1;
       i1 = HEAP32[i11 + -20 >> 2] | 0;
      } else if ((i9 | 0) == 25) i1 = i1 & 255;
      i1 = i1 + 1 | 0;
      if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
      if (i5) _free(i2);
      if (i4) {
       HEAP32[i11 + -16 >> 2] = i6 + 1 | -2147483648;
       HEAP32[i11 + -20 >> 2] = i8;
       HEAP32[i10 >> 2] = i3;
       break;
      } else {
       HEAP8[i7 >> 0] = i8;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i13 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i13);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i14);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
     i1 = i12;
     break L1;
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i15);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i17);
   ___resumeException(i1 | 0);
  }
 } while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_119FixedJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i5, i4, i2, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 28 | 0;
 i6 = i1;
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(f9 * f14);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f15 * f10));
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f21 * f17));
 f11 = Math_fround(Math_fround(f14 * f18) + Math_fround(Math_fround(f9 * f13) + Math_fround(f12 * Math_fround(Math_fround(f21 * f10) - Math_fround(f15 * f17)))));
 f16 = Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f15 * f13) + Math_fround(f12 * Math_fround(Math_fround(f9 * f17) - Math_fround(f21 * f14)))));
 f18 = Math_fround(Math_fround(Math_fround(f21 * f13) + Math_fround(f12 * Math_fround(Math_fround(f15 * f14) - Math_fround(f9 * f10)))) + Math_fround(f17 * f18));
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f11);
 f16 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) + f16);
 f18 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) + f18);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(f12 * f9);
 f13 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f14 * f13));
 f21 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f10 * f21));
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f19 = Math_fround(Math_fround(Math_fround(f17 * f9) + Math_fround(Math_fround(f10 * f13) + Math_fround(f12 * f8))) - Math_fround(f14 * f21));
 f20 = Math_fround(Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(f17 * f13) + Math_fround(f12 * f21))) - Math_fround(f10 * f9));
 f21 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * f9)) - Math_fround(f10 * f8)) - Math_fround(f17 * f21));
 HEAPF32[i7 >> 2] = Math_fround(f15 - Math_fround(f17 * f8));
 HEAPF32[i7 + 4 >> 2] = f19;
 HEAPF32[i7 + 8 >> 2] = f20;
 HEAPF32[i7 + 12 >> 2] = f21;
 HEAPF32[i7 + 16 >> 2] = f11;
 HEAPF32[i7 + 20 >> 2] = f16;
 HEAPF32[i7 + 24 >> 2] = f18;
 f18 = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i4 + 48 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i4 + 52 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(f18 * f19);
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f16 * f17));
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f11 * f15));
 f10 = Math_fround(Math_fround(f19 * f8) + Math_fround(Math_fround(f18 * f20) + Math_fround(f21 * Math_fround(Math_fround(f11 * f17) - Math_fround(f16 * f15)))));
 f9 = Math_fround(Math_fround(f17 * f8) + Math_fround(Math_fround(f16 * f20) + Math_fround(f21 * Math_fround(Math_fround(f18 * f15) - Math_fround(f11 * f19)))));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f20) + Math_fround(f21 * Math_fround(Math_fround(f16 * f19) - Math_fround(f18 * f17)))) + Math_fround(f15 * f8));
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
 f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f8);
 f18 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f16 = Math_fround(f21 * f18);
 f20 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f19 * f20));
 f11 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f17 * f11));
 f14 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f15 * f18) + Math_fround(Math_fround(f17 * f20) + Math_fround(f21 * f14))) - Math_fround(f19 * f11));
 f12 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f15 * f20) + Math_fround(f21 * f11))) - Math_fround(f17 * f18));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f14)) - Math_fround(f15 * f11));
 HEAPF32[i6 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
 HEAPF32[i6 + 4 >> 2] = f13;
 HEAPF32[i6 + 8 >> 2] = f12;
 HEAPF32[i6 + 12 >> 2] = f11;
 HEAPF32[i6 + 16 >> 2] = f10;
 HEAPF32[i6 + 20 >> 2] = f9;
 HEAPF32[i6 + 24 >> 2] = f8;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i7 | 0, i6 | 0);
 STACKTOP = i1;
 return;
}

function __ZN6Camera8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i7);
 i1 = i9 + 844 | 0;
 i10 = i7 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i7 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 848 | 0, i7);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i9 + 864 | 0, gb + 373323 | 0, 0);
 i1 = i9 + 920 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i9 + 924 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 292 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i9 + 1088 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i9 + 916 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 888 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i9 + 880 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 928 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 744 | 0, i7);
 i1 = i9 + 820 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
  i2 = i4;
 }
 i5 = i9 + 824 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i3;
 i1 = i9 + 1091 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i9 + 1089 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i9 + 1100 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i9 + 1096 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 1112 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 }
}

function __ZL12DepthPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i24, i2) {
 i24 = i24 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i32 + 216 | 0;
 i1 = i32 + 208 | 0;
 i31 = i32 + 12 | 0;
 i28 = i32;
 if ((HEAP16[gb + 1115244 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115244 | 0, i23);
  i30 = gb + 1115244 | 0;
 } else i30 = 0;
 i25 = HEAP32[gb + 1115244 >> 2] | 0;
 i26 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 648 >> 2] | 0, i26 | 0, i25 | 0);
 i25 = i24 + 12 | 0;
 i26 = HEAP32[i24 + 8 >> 2] | 0;
 i27 = (HEAP32[i2 + 8 >> 2] | 0) + 8 | 0;
 i22 = HEAP16[i2 + 108 >> 1] | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i31, i1, i27, (i22 & 255) << 24 >> 24 != 0, (i22 & 65535) > 255);
 __ZN12LODFadeCacheC2ER13BatchRenderer(i28, i31);
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 112 >> 2] | 0, i26 | 0, i2 + 40 | 0);
 i22 = i26 + 804 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = 0;
 __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i25, 1, 1, HEAP32[i2 + 104 >> 2] | 0, 0, 1);
 i22 = i24 + 164 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 i22 = (HEAP32[i22 + 4 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 < i22 >>> 0) {
  i19 = i2 + 12 | 0;
  i20 = i31 + 192 | 0;
  i21 = i23 + 4 | 0;
  i5 = 0;
  i4 = -1;
  i3 = 0;
  i2 = 0;
  do {
   i14 = HEAP32[i19 >> 2] | 0;
   i15 = i14 + (i1 * 24 | 0) + 8 | 0;
   i16 = HEAP32[i15 >> 2] | 0;
   i17 = HEAP32[i27 >> 2] | 0;
   i18 = i14 + (i1 * 24 | 0) + 20 | 0;
   i10 = HEAP32[(HEAP32[i17 + (i16 * 360 | 0) + 324 >> 2] | 0) + ((HEAP32[i18 >> 2] & 65535) << 3) >> 2] | 0;
   i13 = HEAP32[i14 + (i1 * 24 | 0) + 16 >> 2] | 0;
   i14 = HEAP32[i14 + (i1 * 24 | 0) + 12 >> 2] | 0;
   i11 = HEAP32[i17 + (i16 * 360 | 0) + 176 >> 2] << 13 & 32768;
   i9 = i17 + (i16 * 360 | 0) + 252 | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i6 = (i6 & 2147483647 | 0) == 0 ? 0 : i6 >> 15 & 131072 | 65536;
   i12 = i11 | i14 & 32767 | i6;
   i7 = i13;
   i14 = __ZNK6Shader24GetShadowCasterPassToUseEiRi(i7, i14, i23) | 0;
   i8 = HEAP32[i23 >> 2] | 0;
   __ZN12LODFadeCache14ApplyValueOnlyEf(i28, Math_fround(HEAPF32[i9 >> 2]));
   i9 = i10;
   if ((i9 | 0) == (i5 | 0) & (i7 | 0) == (i3 | 0) & (i14 | 0) == (i2 | 0) & (i12 | 0) == (i4 | 0)) {
    if ((HEAP32[i17 + (i16 * 360 | 0) + 260 >> 2] | 0) != (HEAP32[i20 >> 2] | 0)) i29 = 20;
   } else i29 = 20;
   if ((i29 | 0) == 20) {
    i29 = 0;
    __ZN13BatchRenderer5FlushEv(i31);
    __Z19SetupLODFadeKeywordR17ShaderPassContexti(i25, i6 << 14 >> 30);
    __Z21SetupOddNegativeScaleR9GfxDeviceb(i26, (i11 | 0) != 0);
    __ZN13BatchRenderer15ApplyShaderPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEi13BatchingFlagsbPKNS7_10GrabPassesE(i31, i25, i9, i7, i14, i8, HEAP32[i17 + (i16 * 360 | 0) + 348 >> 2] | 0, 0, 0);
    i5 = i10;
    i4 = i12;
    i3 = i13;
    i2 = i14;
   }
   HEAP32[i23 >> 2] = HEAP32[i15 >> 2];
   i15 = HEAP32[i18 >> 2] | 0;
   i14 = HEAP16[i17 + (i16 * 360 | 0) + 182 >> 1] | 0;
   i18 = i14 & 65535;
   HEAP32[i21 >> 2] = (i14 << 16 >> 16 == 0 | (i18 | 0) > (i15 | 0) ? i15 : i18 + -1 | 0) + (HEAPU16[i17 + (i16 * 360 | 0) + 180 >> 1] | 0);
   __ZN13BatchRenderer3AddERK17BatchInstanceData(i31, i23);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i22 | 0));
 }
 __ZN13BatchRenderer5FlushEv(i31);
 i1 = i24 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 i1 = i31 + 140 | 0;
 if ((HEAP32[i31 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i31 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i31 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 35824 + 8;
 i2 = i31 + 120 | 0;
 if ((HEAP32[i31 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i31 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i31 + 96 >> 2] | 0) > -1) {
  i29 = i31 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i29 >> 2] | 0, i31 + 84 | 0);
  HEAP32[i29 >> 2] = 0;
 }
 i1 = i31 + 60 | 0;
 if ((HEAP32[i31 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i31 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i31 + 40 | 0;
 if ((HEAP32[i31 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i31 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i31 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i31 >> 2] | 0) + 652 >> 2] | 0, i31 | 0);
 if (!i30) {
  STACKTOP = i32;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i30);
 STACKTOP = i32;
 return;
}

function __Z29Font_Set_Custom_PropFontNamesP12Il2CppObjectP11Il2CppArray(i21, i7) {
 i21 = i21 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 48 | 0;
 i24 = i25 + 32 | 0;
 i18 = i25 + 16 | 0;
 i19 = i25;
 HEAP32[i24 >> 2] = 0;
 i22 = i24 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0) > 0) {
  i8 = i19 + 11 | 0;
  i9 = i19 + 4 | 0;
  i10 = i18 + 12 | 0;
  i6 = i18 + 12 | 0;
  i11 = i23 + 4 | 0;
  i12 = i18 + 8 | 0;
  i13 = i18 + 4 | 0;
  i14 = i24 + 8 | 0;
  i15 = i18 + 11 | 0;
  i16 = i23 + 4 | 0;
  i17 = i23 + 4 | 0;
  i5 = 0;
  do {
   __Z24scripting_cpp_string_forP12Il2CppString(i19, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i7, i5) | 0);
   i3 = HEAP8[i8 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i19 >> 2] | 0 : i19;
   i3 = i1 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
    i1 = HEAP32[i6 >> 2] | 0;
    i20 = 18;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i3;
    if (!i3) i1 = i18; else {
     i1 = i18;
     i20 = 20;
    }
   } else i20 = 18;
   if ((i20 | 0) == 18) {
    i4 = i3 + 16 & -16;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i11 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i18 >> 2] = i1;
    HEAP32[i12 >> 2] = i4 | -2147483648;
    HEAP32[i13 >> 2] = i3;
    i20 = 20;
   }
   if ((i20 | 0) == 20) {
    i20 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i22 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i14 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i24, i18); else {
    i4 = HEAP8[i15 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i18 >> 2] | 0 : i18;
    i4 = i2 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i20 = 25;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i20 = 27;
    } else i20 = 25;
    if ((i20 | 0) == 25) {
     i26 = i4 + 16 & -16;
     HEAP32[i23 >> 2] = 66;
     HEAP32[i17 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i26, 16, i23, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i26 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i2;
     i20 = 27;
    }
    if ((i20 | 0) == 27) {
     i20 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 16;
   }
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i26 = HEAP32[i18 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i16 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i26, i23);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (__Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0));
 }
 if (!i21) {
  i26 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i26);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i21) | 0;
 if (!i1) {
  i26 = i21;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i26);
 }
 __ZN20TextRenderingPrivate8FontImpl12SetFontNamesERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE(HEAP32[i1 + 48 >> 2] | 0, i24);
 i1 = HEAP32[i24 >> 2] | 0;
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i23 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i22 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i26 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i23 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i26, i23);
    i2 = HEAP32[i22 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i24 >> 2] | 0;
 }
 i26 = HEAP32[i24 + 12 >> 2] | 0;
 HEAP32[i23 >> 2] = 34;
 HEAP32[i23 + 4 >> 2] = i26;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i23);
 STACKTOP = i25;
 return;
}

function __ZN15b2ContactSolverC2EP18b2ContactSolverDef(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i2 + 32 | 0;
 HEAP32[i4 >> 2] = i3;
 i13 = HEAP32[i1 + 28 >> 2] | 0;
 i14 = i2 + 48 | 0;
 HEAP32[i14 >> 2] = i13;
 i12 = i2 + 36 | 0;
 HEAP32[i12 >> 2] = __ZN16b2StackAllocator8AllocateEi(i3, i13 * 88 | 0) | 0;
 i4 = __ZN16b2StackAllocator8AllocateEi(HEAP32[i4 >> 2] | 0, (HEAP32[i14 >> 2] | 0) * 156 | 0) | 0;
 i13 = i2 + 40 | 0;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 36 >> 2];
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i10 = i2 + 44 | 0;
 HEAP32[i10 >> 2] = i3;
 if ((HEAP32[i14 >> 2] | 0) <= 0) return;
 i11 = i2 + 20 | 0;
 i9 = i2 + 8 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  i21 = HEAP32[(HEAP32[i3 + 48 >> 2] | 0) + 28 >> 2] | 0;
  i20 = HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + 28 >> 2] | 0;
  i15 = HEAP32[i3 + 128 >> 2] | 0;
  i2 = HEAP32[i3 + 132 >> 2] | 0;
  i7 = HEAP32[i3 + 124 >> 2] | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 136 >> 2] = HEAP32[i3 + 144 >> 2];
  HEAP32[i4 + (i1 * 156 | 0) + 140 >> 2] = HEAP32[i3 + 148 >> 2];
  HEAP32[i4 + (i1 * 156 | 0) + 144 >> 2] = HEAP32[i3 + 152 >> 2];
  i23 = i21 + 8 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 112 >> 2] = HEAP32[i23 >> 2];
  i22 = i20 + 8 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 116 >> 2] = HEAP32[i22 >> 2];
  i19 = i21 + 120 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 120 >> 2] = HEAP32[i19 >> 2];
  i18 = i20 + 120 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 124 >> 2] = HEAP32[i18 >> 2];
  i17 = i21 + 128 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 128 >> 2] = HEAP32[i17 >> 2];
  i16 = i20 + 128 | 0;
  HEAP32[i4 + (i1 * 156 | 0) + 132 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i4 + (i1 * 156 | 0) + 152 >> 2] = i1;
  HEAP32[i4 + (i1 * 156 | 0) + 148 >> 2] = i7;
  i8 = i4 + (i1 * 156 | 0) + 80 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
  HEAP32[i8 + 28 >> 2] = 0;
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 + (i1 * 88 | 0) + 32 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i8 + (i1 * 88 | 0) + 36 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i8 + (i1 * 88 | 0) + 40 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i8 + (i1 * 88 | 0) + 44 >> 2] = HEAP32[i18 >> 2];
  i21 = i21 + 28 | 0;
  i18 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = i8 + (i1 * 88 | 0) + 48 | 0;
  HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i19 + 4 >> 2] = i18;
  i20 = i20 + 28 | 0;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = i8 + (i1 * 88 | 0) + 56 | 0;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  HEAP32[i8 + (i1 * 88 | 0) + 64 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i8 + (i1 * 88 | 0) + 68 >> 2] = HEAP32[i16 >> 2];
  i16 = i3 + 104 | 0;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i18 = i8 + (i1 * 88 | 0) + 16 | 0;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  i18 = i3 + 112 | 0;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i16 = i8 + (i1 * 88 | 0) + 24 | 0;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i8 + (i1 * 88 | 0) + 84 >> 2] = i7;
  HEAP32[i8 + (i1 * 88 | 0) + 76 >> 2] = i15;
  HEAP32[i8 + (i1 * 88 | 0) + 80 >> 2] = i2;
  HEAP32[i8 + (i1 * 88 | 0) + 72 >> 2] = HEAP32[i3 + 120 >> 2];
  if ((i7 | 0) > 0) {
   i2 = 0;
   do {
    if (!(HEAP8[i11 >> 0] | 0)) {
     f5 = Math_fround(0.0);
     f6 = Math_fround(0.0);
    } else {
     f5 = Math_fround(HEAPF32[i9 >> 2]);
     f6 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 64 + (i2 * 20 | 0) + 8 >> 2]));
     f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 64 + (i2 * 20 | 0) + 12 >> 2]));
    }
    HEAPF32[i4 + (i1 * 156 | 0) + (i2 * 36 | 0) + 16 >> 2] = f6;
    HEAPF32[i4 + (i1 * 156 | 0) + (i2 * 36 | 0) + 20 >> 2] = f5;
    i21 = i4 + (i1 * 156 | 0) + (i2 * 36 | 0) | 0;
    HEAPF32[i4 + (i1 * 156 | 0) + (i2 * 36 | 0) + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + (i1 * 156 | 0) + (i2 * 36 | 0) + 28 >> 2] = Math_fround(0.0);
    HEAPF32[i4 + (i1 * 156 | 0) + (i2 * 36 | 0) + 32 >> 2] = Math_fround(0.0);
    HEAP32[i21 >> 2] = 0;
    HEAP32[i21 + 4 >> 2] = 0;
    HEAP32[i21 + 8 >> 2] = 0;
    HEAP32[i21 + 12 >> 2] = 0;
    i21 = i3 + 64 + (i2 * 20 | 0) | 0;
    i22 = HEAP32[i21 + 4 >> 2] | 0;
    i23 = i8 + (i1 * 88 | 0) + (i2 << 3) | 0;
    HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i23 + 4 >> 2] = i22;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i7 | 0));
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i14 >> 2] | 0)) break;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 return;
}

function __ZN5physx2Sq10AABBPruner13removeObjectsEPKjj(i45, i42, i41) {
 i45 = i45 | 0;
 i42 = i42 | 0;
 i41 = i41 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i43 = 0, i44 = 0, i46 = 0;
 i46 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i46 + 8 | 0;
 i11 = i46;
 i12 = i45 + 7809 | 0;
 HEAP8[i12 >> 0] = 1;
 if (i41 | 0) {
  i33 = i45 + 7760 | 0;
  i35 = i45 + 7780 | 0;
  i36 = i45 + 7776 | 0;
  i37 = i45 + 7808 | 0;
  i38 = i45 + 4 | 0;
  i39 = i45 + 7810 | 0;
  i40 = i45 + 7796 | 0;
  i13 = i45 + 7800 | 0;
  i14 = i45 + 76 | 0;
  i15 = i45 + 120 | 0;
  i16 = i45 + 112 | 0;
  i17 = i45 + 104 | 0;
  i18 = i45 + 108 | 0;
  i19 = i45 + 136 | 0;
  i20 = i45 + 132 | 0;
  i21 = i45 + 128 | 0;
  i22 = i45 + 7811 | 0;
  i23 = i45 + 7812 | 0;
  i24 = i11 + 4 | 0;
  i25 = i45 + 7820 | 0;
  i26 = i45 + 7816 | 0;
  i27 = i45 + 144 | 0;
  i28 = i45 + 68 | 0;
  i29 = i45 + 60 | 0;
  i30 = i45 + 64 | 0;
  i31 = i45 + 92 | 0;
  i32 = i45 + 88 | 0;
  i34 = i45 + 84 | 0;
  i43 = 0;
  do {
   i8 = HEAP32[i42 + (i43 << 2) >> 2] | 0;
   i9 = (HEAP32[i35 >> 2] | 0) + (i8 << 2) | 0;
   i6 = (HEAP32[i36 >> 2] | 0) + (HEAP32[i9 >> 2] << 3) | 0;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i10 = i44;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 4 >> 2] = i7;
   i9 = HEAP32[i9 >> 2] | 0;
   i10 = __ZN5physx2Sq11PruningPool12removeObjectEj(i33, i8) | 0;
   do if (HEAP8[i37 >> 0] | 0) {
    i1 = HEAP32[i38 >> 2] | 0;
    if (i1 | 0) {
     HEAP8[i39 >> 0] = 1;
     if ((HEAP32[i13 >> 2] | 0) >>> 0 > i9 >>> 0) {
      i2 = HEAP32[(HEAP32[i40 >> 2] | 0) + (i9 << 2) >> 2] | 0;
      if ((i2 | 0) != -1) __ZN5physx2Sq8AABBTree12markForRefitEj(i1, i2);
     }
     i1 = HEAP32[i14 >> 2] | 0;
     L12 : do if (!i1) i7 = 14; else {
      i2 = i8 + ~(i8 << 15) | 0;
      i2 = (i2 >>> 10 ^ i2) * 9 | 0;
      i2 = i2 >>> 6 ^ i2;
      i2 = i2 + ~(i2 << 11) | 0;
      i2 = (HEAP32[i28 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if ((i1 | 0) == -1) i7 = 14; else {
       i5 = HEAP32[i29 >> 2] | 0;
       i6 = HEAP32[i30 >> 2] | 0;
       i3 = i1;
       i4 = i2;
       while (1) {
        i1 = i4;
        i4 = i6 + (i3 << 2) | 0;
        i2 = i3;
        i3 = HEAP32[i4 >> 2] | 0;
        if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i8 | 0)) break;
        if ((i3 | 0) == -1) {
         i7 = 14;
         break L12;
        }
       }
       HEAP32[i1 >> 2] = i3;
       HEAP32[i31 >> 2] = (HEAP32[i31 >> 2] | 0) + -1;
       HEAP32[i32 >> 2] = (HEAP32[i32 >> 2] | 0) + 1;
       HEAP32[i4 >> 2] = HEAP32[i34 >> 2];
       HEAP32[i34 >> 2] = i2;
       i7 = 20;
      }
     } while (0);
     L19 : do if ((i7 | 0) == 14) {
      i7 = 0;
      i1 = HEAP32[i15 >> 2] | 0;
      if (i1 | 0) {
       i4 = i8 + ~(i8 << 15) | 0;
       i4 = (i4 >>> 10 ^ i4) * 9 | 0;
       i4 = i4 >>> 6 ^ i4;
       i4 = i4 + ~(i4 << 11) | 0;
       i4 = (HEAP32[i16 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if ((i3 | 0) != -1) {
        i5 = HEAP32[i17 >> 2] | 0;
        i6 = HEAP32[i18 >> 2] | 0;
        while (1) {
         i1 = i4;
         i4 = i6 + (i3 << 2) | 0;
         i2 = i3;
         i3 = HEAP32[i4 >> 2] | 0;
         if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i8 | 0)) break;
         if ((i3 | 0) == -1) break L19;
        }
        HEAP32[i1 >> 2] = i3;
        HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
        HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
        HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
        HEAP32[i21 >> 2] = i2;
        i7 = 20;
       }
      }
     } while (0);
     if ((i7 | 0) == 20) __ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE(i27, i44) | 0;
     __ZN5physx2Sq17AABBTreeUpdateMap10invalidateEjjRNS0_8AABBTreeE(i40, i9, i10, HEAP32[i38 >> 2] | 0);
     if (HEAP8[i22 >> 0] | 0) {
      HEAP32[i11 >> 2] = i9;
      HEAP32[i24 >> 2] = i10;
      i1 = HEAP32[i26 >> 2] | 0;
      if ((HEAP32[i25 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
       i8 = i11;
       i9 = HEAP32[i8 + 4 >> 2] | 0;
       i10 = (HEAP32[i23 >> 2] | 0) + (i1 << 3) | 0;
       HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
       HEAP32[i10 + 4 >> 2] = i9;
       HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayINS_2Sq10AABBPruner12NewTreeFixupENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i23, i11) | 0;
       break;
      }
     }
    }
   } while (0);
   i43 = i43 + 1 | 0;
  } while ((i43 | 0) != (i41 | 0));
 }
 if (HEAP32[i45 + 7764 >> 2] | 0) {
  STACKTOP = i46;
  return;
 }
 __ZN5physx2Sq10AABBPruner7releaseEv(i45);
 HEAP8[i12 >> 0] = 1;
 STACKTOP = i46;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i19, i13, i1) {
 i19 = i19 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i7 = i18 + 8 | 0;
 i12 = i13 + 11 | 0;
 i15 = HEAP8[i12 >> 0] | 0;
 i8 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i15 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i15 & 255;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i19, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i6 = i1 & 255;
 i2 = i4 ? i3 : i6;
 do if (i5 >>> 0 > i2 >>> 0) {
  i5 = i5 - i2 | 0;
  if (!i5) i16 = 15; else {
   if (i4) i2 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0; else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i5 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i13, i2, i5 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i12 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   _memset(i2 + i3 | 0, 1, i5 | 0) | 0;
   i1 = i3 + i5 | 0;
   if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i8 >> 2] = i1; else HEAP8[i12 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
   i16 = 15;
  }
 } else if (i4) {
  HEAP8[(HEAP32[i13 >> 2] | 0) + i5 >> 0] = 0;
  HEAP32[i8 >> 2] = i5;
  i16 = 15;
  break;
 } else {
  HEAP8[i13 + i5 >> 0] = 0;
  i2 = i5 & 255;
  HEAP8[i12 >> 0] = i2;
  i3 = i13;
  i1 = i5;
  break;
 } while (0);
 if ((i16 | 0) == 15) {
  i3 = i13;
  i2 = HEAP8[i12 >> 0] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i15 = i2 << 24 >> 24 < 0;
 i15 = (i15 ? HEAP32[i13 >> 2] | 0 : i3) + (i15 ? HEAP32[i8 >> 2] | 0 : i2 & 255) | 0;
 do if (i1 | 0) {
  i8 = HEAP32[gb + 36976 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i19, gb + 1041891 | 0, i8, 0, 0) | 0;
  i14 = i19 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i14 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i19 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i14 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i3;
   L28 : do if ((i1 | 0) != (i15 | 0)) {
    i4 = i19 + 16 | 0;
    i5 = i19 + 20 | 0;
    i6 = i19 + 32 | 0;
    i7 = i19 + 36 | 0;
    i8 = i19 + 24 | 0;
    i3 = 0;
    while (1) {
     i3 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     HEAP32[i2 + 12 >> 2] = i3;
     __ZNK16TypeTreeIterator8ChildrenEv(i17, i2);
     i3 = i17;
     i12 = HEAP32[i3 + 4 >> 2] | 0;
     i13 = i2 + 24 | 0;
     HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = HEAP32[i11 >> 2] | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     i13 = HEAP32[i5 >> 2] | 0;
     i2 = i13 + (HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i13 >>> 0) i16 = 23; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i16 = 23; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i16 | 0) == 23) {
      i16 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i15 | 0)) break L28;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i14 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i19);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i19);
  i1 = (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i3;
  if ((i1 | 0) != (i15 | 0)) {
   i3 = i19 + 16 | 0;
   i4 = i19 + 20 | 0;
   i5 = i19 + 32 | 0;
   i6 = i19 + 36 | 0;
   i7 = i19 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i19, gb + 1041891 | 0, i8, i17, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i16 = HEAP32[i4 >> 2] | 0;
      i2 = i16 + (HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i16 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i17 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i19 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i19);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i15 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i19);
 STACKTOP = i18;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEbT0_SB_T_(i1, i13, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 switch ((i13 - i1 | 0) / 12 | 0 | 0) {
 case 2:
  {
   i2 = i13 + -12 | 0;
   i6 = HEAP8[i2 + 11 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i13 + -8 >> 2] | 0 : i6 & 255;
   i7 = HEAP8[i1 + 11 >> 0] | 0;
   i4 = i7 << 24 >> 24 < 0;
   i7 = i4 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
   i3 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
   if (!i3) i15 = 4; else {
    i3 = _memcmp(i5 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0;
    if (!i3) i15 = 4; else if ((i3 | 0) >= 0) {
     i15 = 1;
     STACKTOP = i16;
     return i15 | 0;
    }
   }
   do if ((i15 | 0) == 4) if (i6 >>> 0 < i7 >>> 0) break; else {
    i15 = 1;
    STACKTOP = i16;
    return i15 | 0;
   } while (0);
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i1, i1 + 12 | 0, i13 + -12 | 0, i2) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i13 + -12 | 0, i2) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_(i1, i1 + 12 | 0, i1 + 24 | 0, i1 + 36 | 0, i13 + -12 | 0, i2) | 0;
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 case 1:
 case 0:
  {
   i15 = 1;
   STACKTOP = i16;
   return i15 | 0;
  }
 default:
  {
   i3 = i1 + 24 | 0;
   __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i1, i1 + 12 | 0, i3, i2) | 0;
   i2 = i1 + 36 | 0;
   L3 : do if ((i2 | 0) == (i13 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i11 = i14 + 11 | 0;
    i12 = i14 + 4 | 0;
    i10 = i2;
    i2 = 0;
    while (1) {
     i7 = HEAP8[i10 + 11 >> 0] | 0;
     i5 = i7 << 24 >> 24 < 0;
     i7 = i5 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255;
     i8 = HEAP8[i3 + 11 >> 0] | 0;
     i6 = i8 << 24 >> 24 < 0;
     i8 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i8 & 255;
     i4 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
     if (!i4) i15 = 15; else {
      i4 = _memcmp(i5 ? HEAP32[i10 >> 2] | 0 : i10, i6 ? HEAP32[i3 >> 2] | 0 : i3, i4) | 0;
      if (!i4) i15 = 15; else if ((i4 | 0) < 0) i15 = 17;
     }
     if ((i15 | 0) == 15) {
      i15 = 0;
      if (i7 >>> 0 < i8 >>> 0) i15 = 17;
     }
     if ((i15 | 0) == 17) {
      i15 = 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i10);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i3) | 0;
      L14 : do if ((i3 | 0) == (i1 | 0)) i3 = i1; else {
       i7 = i3;
       while (1) {
        i3 = i7;
        i7 = i7 + -12 | 0;
        i8 = HEAP8[i11 >> 0] | 0;
        i5 = i8 << 24 >> 24 < 0;
        i8 = i5 ? HEAP32[i12 >> 2] | 0 : i8 & 255;
        i9 = HEAP8[i7 + 11 >> 0] | 0;
        i6 = i9 << 24 >> 24 < 0;
        i9 = i6 ? HEAP32[i3 + -8 >> 2] | 0 : i9 & 255;
        i4 = i9 >>> 0 < i8 >>> 0 ? i9 : i8;
        if (!i4) i15 = 20; else {
         i4 = _memcmp(i5 ? HEAP32[i14 >> 2] | 0 : i14, i6 ? HEAP32[i7 >> 2] | 0 : i7, i4) | 0;
         if (!i4) i15 = 20; else if ((i4 | 0) >= 0) break L14;
        }
        if ((i15 | 0) == 20) {
         i15 = 0;
         if (i8 >>> 0 >= i9 >>> 0) break L14;
        }
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i7) | 0;
        if ((i7 | 0) == (i1 | 0)) {
         i3 = i1;
         break;
        }
       }
      } while (0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i14) | 0;
      i2 = i2 + 1 | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i10 + 12 | 0) == (i13 | 0);
       break L3;
      }
     }
     i3 = i10 + 12 | 0;
     if ((i3 | 0) == (i13 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i9 = i10;
      i10 = i3;
      i3 = i9;
     }
    }
   } while (0);
   i15 = i1 | i2;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Sc17ParticleSystemSim17updateRigidBodiesEv(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i28 + 64 | 0;
 i7 = i28 + 24 | 0;
 i26 = i28 + 16 | 0;
 i19 = i28;
 i20 = i27 + 52 | 0;
 if (!((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i20 >> 2] | 0) | 0) & 1)) {
  STACKTOP = i28;
  return;
 }
 if (!((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i20 >> 2] | 0) | 0) & 2)) {
  STACKTOP = i28;
  return;
 }
 f21 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv(HEAP32[i20 >> 2] | 0));
 i1 = i27 + 56 | 0;
 i25 = HEAP32[i1 >> 2] | 0;
 i25 = mftCall_ii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0) | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i25 >> 2] | 0) + 48 >> 2] | 0, i25 | 0) | 0)) {
  STACKTOP = i28;
  return;
 }
 HEAP32[i6 + 16 >> 2] = 0;
 i22 = i6 + 20 | 0;
 HEAP32[i22 >> 2] = 12;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 12;
 HEAP32[i6 + 32 >> 2] = 0;
 i23 = i6 + 36 | 0;
 HEAP32[i23 >> 2] = 4;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 4;
 i25 = HEAP32[i1 >> 2] | 0;
 i25 = mftCall_ii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i25 >> 2] | 0) + 20 >> 2] | 0, i25 | 0, i6 | 0, 0, 0);
 if (HEAP32[i6 + 8 >> 2] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 4;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 12;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 12;
  HEAP32[i7 + 24 >> 2] = 0;
  i24 = i7 + 28 | 0;
  HEAP32[i24 >> 2] = 12;
  HEAP32[i7 + 32 >> 2] = 0;
  i25 = i7 + 36 | 0;
  HEAP32[i25 >> 2] = 4;
  i17 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i17 >> 2] | 0) + 4 >> 2] | 0, i17 | 0, i7 | 0, 0);
  i17 = HEAP32[i6 + 12 >> 2] | 0;
  i18 = i17 + 4 | 0;
  i5 = HEAP32[i18 >> 2] & 2147483647;
  L12 : do if (i5 | 0) {
   i4 = HEAP32[i17 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
    if (i2 | 0) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break L12;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
   i2 = i2 + -1 & i2;
   L18 : do if (!i2) do {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) {
     i2 = 0;
     break L18;
    }
    i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   } while ((i2 | 0) == 0); while (0);
   if ((i3 | 0) != -1) {
    i15 = i7 + 32 | 0;
    i16 = i6 + 32 | 0;
    i14 = i6 + 16 | 0;
    i11 = i7 + 24 | 0;
    i12 = i19 + 4 | 0;
    i13 = i19 + 8 | 0;
    do {
     i10 = i1 << 5;
     i4 = i3;
     while (1) {
      i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (Math_imul(HEAP32[i25 >> 2] | 0, i4) | 0) >> 2] | 0;
      do if (i3 | 0) {
       i8 = i3 + -16 | 0;
       i9 = i8 + 16 | 0;
       if (!(Math_fround(HEAPF32[i9 + 124 >> 2]) == Math_fround(0.0))) {
        i7 = HEAP16[(HEAP32[i16 >> 2] | 0) + (Math_imul(HEAP32[i23 >> 2] | 0, i4) | 0) >> 1] | 0;
        i6 = __ZNK5physx2Sc8ActorSim8getSceneEv(i27) | 0;
        __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh(i26, i6, HEAP8[(HEAP32[i20 >> 2] | 0) + 12 >> 0] | 0, HEAP8[i8 + 12 >> 0] | 0);
        if ((i7 & 8) == 0 ? Math_fround(HEAPF32[i26 >> 2]) != Math_fround(0.0) : 0) {
         i6 = (HEAP32[i14 >> 2] | 0) + (Math_imul(HEAP32[i22 >> 2] | 0, i4) | 0) | 0;
         i7 = HEAP32[i11 >> 2] | 0;
         i3 = Math_imul(HEAP32[i24 >> 2] | 0, i4) | 0;
         i4 = i7 + i3 | 0;
         i5 = i7 + (i3 + 4) | 0;
         if (Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + (i3 + 8) >> 2]) == Math_fround(0.0)) break;
         __ZN5physx2Sc7BodySim14internalWakeUpEf(__ZNK5physx2Sc8BodyCore6getSimEv(i8) | 0, Math_fround(.399999976));
         f31 = Math_fround(f21 * Math_fround(HEAPF32[i4 >> 2]));
         f30 = Math_fround(f21 * Math_fround(HEAPF32[i5 >> 2]));
         f29 = Math_fround(f21 * Math_fround(HEAPF32[i7 + (i3 + 8) >> 2]));
         HEAPF32[i19 >> 2] = f31;
         HEAPF32[i12 >> 2] = f30;
         HEAPF32[i13 >> 2] = f29;
         __Z15addImpulseAtPosRN5physx11PxsBodyCoreERKNS_6PxVec3ES4_(i9, i19, i6);
        }
       }
      } while (0);
      if (!i2) break L12;
      i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
      i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i10;
      i2 = i2 + -1 & i2;
      if (!i2) {
       i3 = i4;
       break;
      }
      if ((i4 | 0) == -1) break L12;
     }
     i4 = HEAP32[i18 >> 2] & 2147483647;
     do {
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i4 >>> 0) {
       i2 = 0;
       break;
      }
      i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     } while ((i2 | 0) == 0);
    } while ((i3 | 0) != -1);
   }
  } while (0);
 }
 STACKTOP = i28;
 return;
}

function __ZN13MonoBehaviour17RemoveFromManagerEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 256 | 0;
 i4 = i10 + 252 | 0;
 i5 = i10 + 8 | 0;
 i6 = i10;
 i8 = i10 + 248 | 0;
 i1 = i9 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i9 + 76 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i9 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i9 + 88 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i9 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i9 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i9 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i9 + 112 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i9 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i9 + 124 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i9 + 20 | 0;
 if (HEAP32[i3 >> 2] | 0) if (HEAP32[(HEAP32[i9 + 60 >> 2] | 0) + 104 >> 2] | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 29832 | 0) | 0;
  if (i1 | 0) {
   HEAP32[i7 >> 2] = i9;
   HEAP32[i7 + 4 >> 2] = fb + 696;
   HEAP8[i7 + 8 >> 0] = 0;
   HEAP8[i7 + 9 >> 0] = 0;
   __ZN6Camera17RemoveImageFilterERK11ImageFilter(i1, i7);
  }
 }
 i1 = HEAP32[i9 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0) {
  i1 = (HEAP32[i9 + 60 >> 2] | 0) + 72 | 0;
  if (HEAP32[i1 >> 2] | 0) if (HEAP8[i9 + 140 >> 0] | 0) {
   i12 = i1;
   i13 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i11 = i6;
   HEAP32[i11 >> 2] = i13;
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i1, i7);
   HEAP8[i5 + 233 >> 0] = 1;
   HEAP32[i5 + 216 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i5);
   __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i5, i4) | 0;
  }
 }
 if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0) {
  i1 = (HEAP32[i9 + 60 >> 2] | 0) + 80 | 0;
  if (HEAP32[i1 >> 2] | 0) if (HEAP8[i9 + 140 >> 0] | 0) {
   i11 = i1;
   i1 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   i13 = HEAP32[i3 >> 2] | 0;
   i12 = i6;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i13, i7);
   HEAP8[i5 + 233 >> 0] = 1;
   HEAP32[i5 + 216 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i5);
   __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i5, i4) | 0;
  }
 }
 do if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0) {
  i1 = HEAP32[i9 + 60 >> 2] | 0;
  if (!(HEAP32[i1 + 88 >> 2] | 0)) if (!(HEAP32[i1 + 96 >> 2] | 0)) break;
  i13 = __Z21GetDelayedCallManagerv() | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i13, i7, fb + 694 | 0, 0, 0);
 } while (0);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = __Z9GetIAudiov() | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i3 = __Z9GetIAudiov() | 0;
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 i2 = i9 + 144 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[i9 + 60 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  }
  if (!(HEAP32[i1 + 144 >> 2] | 0)) {
   STACKTOP = i10;
   return;
  }
  i1 = HEAP32[i9 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  }
  if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, i9 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   break;
  } else {
   STACKTOP = i10;
   return;
  }
 } while (0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 60 >> 2] | 0, i4 | 0, i1 | 0, 1);
 STACKTOP = i10;
 return;
}

function _tt_cmap4_char_map_binary(i23, i24, i1) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = HEAP32[i23 + 16 >> 2] | 0;
 i20 = (HEAPU8[i3 + 7 >> 0] | 0) & 254 | (HEAPU8[i3 + 6 >> 0] | 0) << 8;
 if (!i20) {
  i24 = 0;
  return i24 | 0;
 }
 i22 = i20 >>> 1;
 i21 = i1 << 24 >> 24 != 0;
 i2 = (HEAP32[i24 >> 2] | 0) + (i21 & 1) | 0;
 i19 = i20 + 2 | 0;
 i18 = i3 + 14 | 0;
 i4 = 65535;
 i1 = i22;
 i6 = 0;
 i3 = i22;
 L4 : while (1) {
  while (1) {
   if (i6 >>> 0 >= i1 >>> 0) {
    i1 = 0;
    break L4;
   }
   i3 = (i1 + i6 | 0) >>> 1;
   i5 = i18 + (i3 << 1) | 0;
   i4 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
   i5 = i5 + i19 | 0;
   i17 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
   if (i2 >>> 0 >= i17 >>> 0) break; else i1 = i3;
  }
  if (i2 >>> 0 <= i4 >>> 0) {
   i7 = 8;
   break;
  }
  i6 = i3 + 1 | 0;
 }
 do if ((i7 | 0) == 8) {
  i9 = i5 + i20 | 0;
  i16 = ((HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0)) << 16 >> 16;
  i9 = i9 + i20 | 0;
  i15 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0);
  if ((i4 | 0) == 65535 & (i3 >>> 0 >= (i22 + -1 | 0) >>> 0 & (i17 | 0) == 65535)) {
   i1 = HEAP32[i23 >> 2] | 0;
   if (!i15) {
    i5 = 0;
    i1 = i16;
   } else {
    i1 = (i9 + i15 + 2 | 0) >>> 0 > ((HEAP32[i1 + 500 >> 2] | 0) + (HEAP32[i1 + 504 >> 2] | 0) | 0) >>> 0;
    i5 = i1 ? 0 : i15;
    i1 = i1 ? 1 : i16;
   }
  } else {
   i5 = i15;
   i1 = i16;
  }
  i7 = (i5 | 0) == 65535;
  if (!(HEAP32[i23 + 20 >> 2] & 2)) if (i7) {
   i1 = 0;
   break;
  } else {
   i7 = i17;
   i6 = i9;
  } else {
   i6 = i3 + 1 | 0;
   i8 = i7 ? i6 : i3;
   L20 : do if (!i3) {
    i7 = i17;
    i10 = 0;
    i12 = i4;
   } else {
    i7 = i17;
    i13 = i3;
    i11 = i9;
    i14 = i4;
    while (1) {
     i10 = i13;
     i13 = i13 + -1 | 0;
     i9 = i18 + (i13 << 1) | 0;
     i12 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0);
     if (i2 >>> 0 > i12 >>> 0) {
      i9 = i11;
      i12 = i14;
      break L20;
     }
     i9 = i9 + i19 | 0;
     i7 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0);
     i9 = i9 + i20 | 0;
     i1 = ((HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0)) << 16 >> 16;
     i9 = i9 + i20 | 0;
     i5 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0);
     i8 = (i5 | 0) == 65535 ? i8 : i13;
     if (!i13) {
      i10 = 0;
      break;
     } else {
      i11 = i9;
      i14 = i12;
     }
    }
   } while (0);
   if ((i8 | 0) == (i6 | 0)) {
    i8 = (i10 | 0) == (i3 | 0);
    i4 = i8 ? i12 : i4;
    if (i6 >>> 0 >= i22 >>> 0) {
     i1 = 0;
     break;
    }
    i11 = i8 ? i7 : i17;
    i5 = i8 ? i5 : i15;
    i1 = i8 ? i1 : i16;
    i7 = i3;
    while (1) {
     i8 = i18 + (i6 << 1) | 0;
     i9 = i8 + i19 | 0;
     i10 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i9 + 1 >> 0] | 0);
     if (i2 >>> 0 < i10 >>> 0) {
      i8 = i9;
      break;
     }
     i4 = (HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0);
     i8 = i9 + i20 | 0;
     i1 = ((HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0)) << 16 >> 16;
     i8 = i8 + i20 | 0;
     i5 = (HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0);
     i7 = (i5 | 0) == 65535 ? i7 : i6;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 < i22 >>> 0) i11 = i10; else {
      i11 = i10;
      break;
     }
    }
    i6 = i6 + -1 | 0;
    if ((i7 | 0) == (i3 | 0)) {
     i1 = 0;
     i3 = i6;
     break;
    } else {
     i3 = i7;
     i10 = i6;
     i7 = i11;
     i6 = i8;
    }
   } else {
    i3 = i8;
    i6 = i9;
    i4 = i12;
   }
   if ((i3 | 0) != (i10 | 0)) {
    i4 = i18 + (i3 << 1) | 0;
    i7 = i4 + i19 | 0;
    i1 = i7 + i20 | 0;
    i5 = i1 + i20 | 0;
    i7 = (HEAPU8[i7 >> 0] | 0) << 8 | (HEAPU8[i7 + 1 >> 0] | 0);
    i6 = i5;
    i4 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
    i5 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
    i1 = ((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0)) << 16 >> 16;
   }
  }
  if (!i5) {
   i1 = i1 + i2 & 65535;
   break;
  } else {
   i20 = i6 + ((i2 - i7 << 1) + i5) | 0;
   i20 = (HEAPU8[i20 >> 0] | 0) << 8 | (HEAPU8[i20 + 1 >> 0] | 0);
   i1 = (i20 | 0) == 0 ? 0 : i20 + i1 & 65535;
   break;
  }
 } while (0);
 if (!i21) {
  i24 = i1;
  return i24 | 0;
 }
 if (i2 >>> 0 > i4 >>> 0) {
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i22 | 0)) {
   i24 = 0;
   return i24 | 0;
  }
 }
 if (_tt_cmap4_set_range(i23, i3) | 0) {
  if (!i1) {
   i24 = 0;
   return i24 | 0;
  }
  HEAP32[i24 >> 2] = i2;
  i24 = i1;
  return i24 | 0;
 }
 i3 = i23 + 24 | 0;
 HEAP32[i3 >> 2] = i2;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  _tt_cmap4_next(i23);
  i1 = HEAP32[i23 + 28 >> 2] | 0;
  if (!i1) {
   i24 = 0;
   return i24 | 0;
  } else {
   i2 = HEAP32[i3 >> 2] | 0;
   break;
  }
 } else HEAP32[i23 + 28 >> 2] = i1; while (0);
 HEAP32[i24 >> 2] = i2;
 i24 = i1;
 return i24 | 0;
}

function __ZN5physx2Sc5Scene12beforeSolverEPNS_10PxBaseTaskE(i4, i20) {
 i4 = i4 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0;
 i1 = i4 + 124 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 120 | 0;
  i3 = 0;
  do {
   __ZNK5physx2Sc15ArticulationSim11checkResizeEv(HEAP32[HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] >> 2] | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i16 = HEAP32[(HEAP32[i4 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i16 + 5868 >> 2] = 0;
 i17 = HEAP32[i16 + 6776 >> 2] | 0;
 i22 = HEAP32[i16 + 6784 >> 2] | 0;
 i23 = HEAP32[i16 + 6760 >> 2] | 0;
 i24 = HEAP32[i16 + 6764 >> 2] | 0;
 i25 = i4 + 60 | 0;
 i26 = (HEAP32[i25 >> 2] | 0) != 0;
 i13 = HEAP16[i4 + 1192 >> 1] & 16;
 i27 = i13 << 16 >> 16 != 0;
 i28 = i4 + 48 | 0;
 i18 = HEAP32[i16 + 6960 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i18 >> 2] | 0);
 i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i18, 176, 16) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i18 >> 2] | 0);
 i29 = i4 + 64 | 0;
 i15 = HEAP32[i29 >> 2] | 0;
 i21 = i4 + 68 | 0;
 i19 = HEAP32[i21 >> 2] | 0;
 HEAP16[i2 + 4 >> 1] = -1;
 HEAP16[i2 + 6 >> 1] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 106444 + 8;
 HEAP32[i2 + 20 >> 2] = i17;
 HEAP32[i2 + 24 >> 2] = i28;
 i13 = (i13 & 65535) >>> 4 & 255;
 HEAP8[i2 + 28 >> 0] = i13;
 i14 = i26 & 1;
 HEAP8[i2 + 29 >> 0] = i14;
 HEAP32[i2 + 32 >> 2] = i15;
 HEAP32[i2 + 36 >> 2] = i19;
 HEAP32[i2 + 40 >> 2] = i16;
 i19 = (i24 | 0) == 0;
 if (!i19) {
  i15 = (i20 | 0) == 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i1 = 0;
  do {
   i6 = i4;
   i4 = i4 + 1 | 0;
   i10 = HEAP32[i23 + (i4 << 4) >> 2] | 0;
   i11 = (HEAP32[i23 + (i6 << 4) + 4 >> 2] | 0) >>> 31 & 255;
   i12 = ~i10;
   i6 = HEAP32[i23 + (i6 << 4) >> 2] | 0;
   L13 : while (1) {
    i9 = -129 - i1 | 0;
    i8 = i6;
    while (1) {
     if (i10 >>> 0 <= i8 >>> 0) break L13;
     i6 = i1 - i3 + 128 | 0;
     i30 = i10 - i8 | 0;
     i30 = i6 >>> 0 < i30 >>> 0 ? i6 : i30;
     i6 = i30 + i8 | 0;
     i7 = i30 + i3 | 0;
     if (i30) {
      i8 = i8 + i12 | 0;
      i30 = i9 + i3 | 0;
      i30 = i8 >>> 0 > i30 >>> 0 ? i8 : i30;
      _memset(i2 + 44 + i5 | 0, i11 | 0, ~i30 | 0) | 0;
      i5 = i5 + -1 - i30 | 0;
     }
     if ((i7 - i1 | 0) == 128) break; else {
      i3 = i7;
      i8 = i6;
     }
    }
    HEAP32[i2 + 172 >> 2] = 128;
    HEAP32[i2 + 16 >> 2] = 1;
    i1 = i2 + 12 | 0;
    HEAP32[i1 >> 2] = i20;
    if (!i15) {
     mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 16 >> 2] | 0, i20 | 0);
     HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
    }
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i18 >> 2] | 0);
    i30 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i18, 176, 16) | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i18 >> 2] | 0);
    i5 = HEAP32[i29 >> 2] | 0;
    i3 = HEAP32[i21 >> 2] | 0;
    HEAP16[i30 + 4 >> 1] = -1;
    HEAP16[i30 + 6 >> 1] = 0;
    HEAP32[i30 + 8 >> 2] = 0;
    HEAP32[i30 >> 2] = gb + 87404 + 8;
    HEAP32[i30 + 12 >> 2] = 0;
    HEAP32[i30 + 16 >> 2] = 0;
    HEAP32[i30 >> 2] = gb + 106444 + 8;
    HEAP32[i30 + 20 >> 2] = i17 + (i7 << 2);
    HEAP32[i30 + 24 >> 2] = i28;
    HEAP8[i30 + 28 >> 0] = i13;
    HEAP8[i30 + 29 >> 0] = i14;
    HEAP32[i30 + 32 >> 2] = i5;
    HEAP32[i30 + 36 >> 2] = i3;
    HEAP32[i30 + 40 >> 2] = i16;
    i3 = i7;
    i5 = 0;
    i1 = i7;
    i2 = i30;
   }
  } while ((i4 | 0) != (i24 | 0));
  if ((i3 | 0) != (i1 | 0)) {
   HEAP32[i2 + 172 >> 2] = i3 - i1;
   HEAP32[i2 + 16 >> 2] = 1;
   i1 = i2 + 12 | 0;
   HEAP32[i1 >> 2] = i20;
   if (i20 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 16 >> 2] | 0, i20 | 0);
    HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  }
 }
 if ((HEAP32[i23 + (i24 << 4) + 4 >> 2] & 2147483647 | 0) == 0 | i19) {
  HEAP32[i25 >> 2] = 0;
  return;
 } else i7 = 0;
 do {
  i3 = HEAP32[i23 + (i7 << 4) + 4 >> 2] | 0;
  i6 = (i3 | 0) < 0;
  i3 = i3 & 2147483647;
  i7 = i7 + 1 | 0;
  i2 = HEAP32[i23 + (i7 << 4) + 4 >> 2] | 0;
  i1 = i2 & 2147483647;
  if (i3 >>> 0 < i1 >>> 0) {
   i5 = i1 + -1 | 0;
   i4 = i2 & 2147483647;
   i1 = i3;
   do {
    i2 = i1;
    i1 = i1 + 1 | 0;
    i30 = HEAP32[i22 + (i2 << 2) >> 2] | 0;
    f31 = Math_fround(HEAPF32[i29 >> 2]);
    __ZN5physx2Sc15ArticulationSim12updateForcesEffbRKNS_6PxVec3Ebb(i30, f31, Math_fround(HEAPF32[i21 >> 2]), i26, i28, i6, i27);
    __ZN5physx2Sc15ArticulationSim20saveLastCCDTransformEv(i30);
   } while ((i1 | 0) != (i4 | 0));
  }
 } while ((i7 | 0) != (i24 | 0));
 HEAP32[i25 >> 2] = 0;
 return;
}

function __ZN22NavMeshProjectSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 32 | 0;
 i13 = i15 + 16 | 0;
 i11 = i15;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i6);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i6, 2);
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i7 = i13 + 8 | 0;
 i8 = i12 + 4 | 0;
 i1 = 0;
 i5 = 0;
 i2 = 0;
 while (1) {
  i3 = i10 + 28 + (i1 * 20 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i13, i3); else {
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
   i4 = i2 ? HEAP32[i10 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0 : i4 & 255;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
    i2 = HEAP32[i5 + 12 >> 2] | 0;
    i9 = 6;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i5 + 11 >> 0] = i4;
    if (!i4) i2 = i5; else {
     i2 = i5;
     i9 = 8;
    }
   } else i9 = 6;
   if ((i9 | 0) == 6) {
    i16 = i4 + 16 & -16;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i16 | -2147483648;
    HEAP32[i5 + 4 >> 2] = i4;
    i9 = 8;
   }
   if ((i9 | 0) == 8) {
    i9 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i10 + 28 + (i1 * 20 | 0) + 16 >> 2];
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 20;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i5 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i6, gb + 844235 | 0, HEAP32[gb + 37316 >> 2] | 0, i13, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i6, i13, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i6);
 i1 = i10 + 28 | 0;
 i6 = i1 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i10 + 32 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = i2 & 255;
  i5 = i1;
 }
 i3 = i4 >>> 0 > 7;
 i2 = i3 ? 7 : i4;
 if (!i2) i9 = 18; else if (!(_memcmp(i5, gb + 1012705 | 0, i2) | 0)) i9 = 18;
 if ((i9 | 0) == 18) if (i4 >>> 0 > 6 & (i3 ^ 1)) {
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = i11 + 11 | 0;
  HEAP8[i4 >> 0] = 8;
  i16 = i11;
  HEAP32[i16 >> 2] = 1802264919;
  HEAP32[i16 + 4 >> 2] = 1701601889;
  HEAP8[i11 + 8 >> 0] = 0;
  L27 : do if ((i1 | 0) != (i11 | 0)) {
   do if ((HEAP8[i6 >> 0] | 0) < 0) {
    i2 = HEAP32[i10 + 36 >> 2] & 2147483647;
    i3 = i2 + -1 | 0;
    if (i3 >>> 0 < 8) {
     i16 = HEAP32[i10 + 32 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, 9 - i2 | 0, i16, 0, i16, 8, i11);
     break L27;
    } else {
     i1 = HEAP32[i1 >> 2] | 0;
     break;
    }
   } while (0);
   i9 = i11;
   i7 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i16 = i1;
   i8 = i16;
   HEAP8[i8 >> 0] = i7;
   HEAP8[i8 + 1 >> 0] = i7 >> 8;
   HEAP8[i8 + 2 >> 0] = i7 >> 16;
   HEAP8[i8 + 3 >> 0] = i7 >> 24;
   i16 = i16 + 4 | 0;
   HEAP8[i16 >> 0] = i9;
   HEAP8[i16 + 1 >> 0] = i9 >> 8;
   HEAP8[i16 + 2 >> 0] = i9 >> 16;
   HEAP8[i16 + 3 >> 0] = i9 >> 24;
   HEAP8[i1 + 8 >> 0] = 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) {
    HEAP32[i10 + 32 >> 2] = 8;
    break;
   } else {
    HEAP8[i6 >> 0] = 8;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i16 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i16, i12);
  }
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i14 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i12);
    i2 = HEAP32[i14 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i15;
 return;
}

function __ZN13WheelCollider10SmartResetEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 16 | 0;
 i3 = i11;
 i1 = i10 + 60 | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 if (f12 != Math_fround(HEAPF32[gb + 1162364 >> 2])) i9 = 4; else {
  f12 = Math_fround(HEAPF32[i10 + 64 >> 2]);
  if (f12 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) i9 = 4; else {
   f12 = Math_fround(HEAPF32[i10 + 68 >> 2]);
   if (f12 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) i9 = 4;
  }
 }
 if ((i9 | 0) == 4) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 i8 = i10 + 148 | 0;
 if ((HEAP32[i8 >> 2] | 0) != -1) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i2 | 0) if (HEAP32[i2 + 52 >> 2] | 0) if (HEAP32[i2 + 56 >> 2] | 0) {
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 168 >> 2] | 0, i10 | 0, 3);
   i6 = HEAP32[i1 + 52 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 284 >> 2] | 0, i6 | 0);
  }
 }
 __ZN13WheelCollider9SetRadiusEf(i10, Math_fround(.5));
 HEAPF32[i3 >> 2] = Math_fround(35.0e3);
 HEAPF32[i3 + 4 >> 2] = Math_fround(4500.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(.5);
 __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring(i10, i3);
 __ZN13WheelCollider21SetSuspensionDistanceEf(i10, Math_fround(.300000012));
 __ZN13WheelCollider24SetForceAppPointDistanceEf(i10, Math_fround(0.0));
 __ZN13WheelCollider7SetMassEf(i10, Math_fround(20.0));
 i6 = i10 + 100 | 0;
 if (Math_fround(HEAPF32[i6 >> 2]) != Math_fround(.25)) HEAP32[i6 >> 2] = 1048576e3;
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i8 >> 2] | 0) != -1) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i2 | 0) if (HEAP32[i2 + 52 >> 2] | 0) if (HEAP32[i2 + 56 >> 2] | 0) {
   i1 = i1 + 56 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
   i3 = i7;
   i4 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i2, HEAP32[i8 >> 2] | 0) | 0;
   i5 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   HEAP32[i7 + 16 >> 2] = HEAP32[i6 >> 2];
   __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i2, HEAP32[i8 >> 2] | 0, i7);
   i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 284 >> 2] | 0, i7 | 0);
  }
 }
 i2 = i10 + 104 | 0;
 i1 = i10 + 108 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) != Math_fround(.400000006)) i9 = 22; else if (Math_fround(HEAPF32[i1 >> 2]) != Math_fround(1.0)) i9 = 22; else if (Math_fround(HEAPF32[i10 + 112 >> 2]) != Math_fround(.800000011)) i9 = 22; else if (Math_fround(HEAPF32[i10 + 116 >> 2]) != Math_fround(.5)) i9 = 22; else if (Math_fround(HEAPF32[i10 + 120 >> 2]) != Math_fround(1.0)) i9 = 22;
 if ((i9 | 0) == 22) {
  HEAPF32[i2 >> 2] = Math_fround(.400000006);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i10 + 112 >> 2] = Math_fround(.800000011);
  HEAPF32[i10 + 116 >> 2] = Math_fround(.5);
  HEAPF32[i10 + 120 >> 2] = Math_fround(1.0);
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i8 >> 2] | 0) != -1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i1 | 0) if (HEAP32[i1 + 52 >> 2] | 0) if (HEAP32[i1 + 56 >> 2] | 0) {
   i7 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 104 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 284 >> 2] | 0, i7 | 0);
  }
 }
 i2 = i10 + 124 | 0;
 i1 = i10 + 128 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) != Math_fround(.200000003)) i9 = 33; else if (Math_fround(HEAPF32[i1 >> 2]) != Math_fround(1.0)) i9 = 33; else if (Math_fround(HEAPF32[i10 + 132 >> 2]) != Math_fround(.5)) i9 = 33; else if (Math_fround(HEAPF32[i10 + 136 >> 2]) != Math_fround(.75)) i9 = 33; else if (Math_fround(HEAPF32[i10 + 140 >> 2]) != Math_fround(1.0)) i9 = 33;
 if ((i9 | 0) == 33) {
  HEAPF32[i2 >> 2] = Math_fround(.200000003);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i10 + 132 >> 2] = Math_fround(.5);
  HEAPF32[i10 + 136 >> 2] = Math_fround(.75);
  HEAPF32[i10 + 140 >> 2] = Math_fround(1.0);
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i8 >> 2] | 0) == -1) {
  STACKTOP = i11;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i10 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 284 >> 2] | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 64 | 0;
 i9 = i3 + 48 | 0;
 i8 = i3 + 32 | 0;
 i7 = i3 + 16 | 0;
 i6 = i3;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(f15 - f18);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f10 = Math_fround(f17 - f12);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f14 = Math_fround(f11 - f13);
 i19 = HEAP32[i2 + 120 >> 2] | 0;
 HEAPF32[i9 >> 2] = f16;
 HEAPF32[i9 + 4 >> 2] = f10;
 HEAPF32[i9 + 8 >> 2] = f14;
 HEAP32[i9 + 12 >> 2] = i19;
 f12 = Math_fround(f17 + f12);
 f13 = Math_fround(f11 + f13);
 HEAPF32[i8 >> 2] = Math_fround(f15 + f18);
 HEAPF32[i8 + 4 >> 2] = f12;
 HEAPF32[i8 + 8 >> 2] = f13;
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 i19 = i2 + 28 | 0;
 i5 = (HEAP32[i1 >> 2] | 0) + 1520 | 0;
 HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 i5 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 1073741919;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i19, 2);
 i19 = (HEAP32[i1 >> 2] | 0) + 1552 | 0;
 HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741921;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i9, 2);
 i9 = (HEAP32[i1 >> 2] | 0) + 1536 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741920;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i8, 2);
 i8 = i2 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + 1568 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741922;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i8, 2);
 f13 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f18 = Math_fround(f13 - f12);
 f15 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f17 = Math_fround(f15 - f11);
 f14 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f16 = Math_fround(f14 - f10);
 HEAPF32[i7 >> 2] = f18;
 HEAPF32[i7 + 4 >> 2] = f17;
 HEAPF32[i7 + 8 >> 2] = f16;
 HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f14 + f10);
 HEAPF32[i6 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i6 + 4 >> 2] = f11;
 HEAPF32[i6 + 8 >> 2] = f10;
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 i8 = i2 + 88 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + 1584 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741923;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i8, 2);
 i8 = (HEAP32[i1 >> 2] | 0) + 1616 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741925;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i7, 2);
 i7 = (HEAP32[i1 >> 2] | 0) + 1600 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741924;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i6, 2);
 i2 = i2 + 104 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + 1632 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741926;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i4, i2, 2);
 STACKTOP = i3;
 return;
}

function __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i5, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i13 + 64 | 0;
 i12 = ~i8;
 i4 = HEAP8[i6 >> 0] | 0;
 HEAP16[i11 >> 1] = i4 & 255;
 i1 = HEAP8[i6 + 1 >> 0] | 0;
 HEAP16[i11 + 2 >> 1] = i1 & 255;
 i2 = i4 & 255;
 i3 = i1 & 255;
 if ((i4 & 255) > (i1 & 255)) {
  HEAP16[i11 + 4 >> 1] = (((i2 * 6 | 0) + 3 + i3 | 0) >>> 0) / 7 | 0;
  i4 = i4 & 255;
  i3 = i1 & 255;
  HEAP16[i11 + 6 >> 1] = (((i4 * 5 | 0) + 3 + (i3 << 1) | 0) >>> 0) / 7 | 0;
  HEAP16[i11 + 8 >> 1] = (((i4 << 2 | 3) + (i3 * 3 | 0) | 0) >>> 0) / 7 | 0;
  i1 = (((i4 + 3 + (i3 * 6 | 0) | 0) >>> 0) / 7 | 0) & 65535;
  i2 = ((((i4 << 1) + 3 + (i3 * 5 | 0) | 0) >>> 0) / 7 | 0) & 65535;
  i3 = (((i4 * 3 | 0) + 3 + (i3 << 2) | 0) >>> 0) / 7 | 0;
 } else {
  HEAP16[i11 + 4 >> 1] = (((i2 << 2 | 2) + i3 | 0) >>> 0) / 5 | 0;
  i4 = i4 & 255;
  i3 = i1 & 255;
  HEAP16[i11 + 6 >> 1] = (((i4 * 3 | 0) + 2 + (i3 << 1) | 0) >>> 0) / 5 | 0;
  HEAP16[i11 + 8 >> 1] = (((i4 << 1) + 2 + (i3 * 3 | 0) | 0) >>> 0) / 5 | 0;
  i1 = 255;
  i2 = 0;
  i3 = ((i4 + 2 + (i3 << 2) | 0) >>> 0) / 5 | 0;
 }
 HEAP16[i11 + 10 >> 1] = i3;
 HEAP16[i11 + 12 >> 1] = i2;
 HEAP16[i11 + 14 >> 1] = i1;
 i18 = HEAPU8[i6 + 2 >> 0] | 0;
 i17 = HEAPU8[i6 + 3 >> 0] | 0;
 i16 = i17 << 8;
 i14 = HEAP8[i6 + 4 >> 0] | 0;
 i15 = i14 & 255;
 i1 = HEAPU8[i6 + 5 >> 0] | 0;
 i2 = HEAPU8[i6 + 6 >> 0] | 0;
 i3 = i2 << 8;
 i6 = HEAP8[i6 + 7 >> 0] | 0;
 i4 = i6 & 255;
 HEAP8[i10 + 3 >> 0] = HEAP16[i11 + ((i18 & 7) << 1) >> 1];
 HEAP8[i10 + 7 >> 0] = HEAP16[i11 + ((i18 >>> 3 & 7) << 1) >> 1];
 HEAP8[i10 + 11 >> 0] = HEAP16[i11 + (((i16 | i18) >>> 6 & 7) << 1) >> 1];
 HEAP8[i10 + 15 >> 0] = HEAP16[i11 + ((i17 >>> 1 & 7) << 1) >> 1];
 HEAP8[i10 + 19 >> 0] = HEAP16[i11 + ((i17 >>> 4 & 7) << 1) >> 1];
 HEAP8[i10 + 23 >> 0] = HEAP16[i11 + (((i15 << 16 | i16) >>> 15 & 7) << 1) >> 1];
 HEAP8[i10 + 27 >> 0] = HEAP16[i11 + ((i15 >>> 2 & 7) << 1) >> 1];
 HEAP8[i10 + 31 >> 0] = HEAP16[i11 + (((i14 & 255) >>> 5 & 255) << 1) >> 1];
 HEAP8[i10 + 35 >> 0] = HEAP16[i11 + ((i1 & 7) << 1) >> 1];
 HEAP8[i10 + 39 >> 0] = HEAP16[i11 + ((i1 >>> 3 & 7) << 1) >> 1];
 HEAP8[i10 + 43 >> 0] = HEAP16[i11 + (((i3 | i1) >>> 6 & 7) << 1) >> 1];
 HEAP8[i10 + 47 >> 0] = HEAP16[i11 + ((i2 >>> 1 & 7) << 1) >> 1];
 HEAP8[i10 + 51 >> 0] = HEAP16[i11 + ((i2 >>> 4 & 7) << 1) >> 1];
 HEAP8[i10 + 55 >> 0] = HEAP16[i11 + (((i4 << 16 | i3) >>> 15 & 7) << 1) >> 1];
 HEAP8[i10 + 59 >> 0] = HEAP16[i11 + ((i4 >>> 2 & 7) << 1) >> 1];
 HEAP8[i10 + 63 >> 0] = HEAP16[i11 + (((i6 & 255) >>> 5 & 255) << 1) >> 1];
 i11 = i7 + -4 | 0;
 i7 = HEAP32[i5 >> 2] & i8;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i5 >> 2] = (HEAP32[i10 >> 2] & i12) >>> i9 | i7;
 i7 = i5 + 4 | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 4 >> 2] & i12) >>> i9 | i6;
 i7 = i5 + 8 | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 8 >> 2] & i12) >>> i9 | i6;
 i7 = i5 + 12 | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 12 >> 2] & i12) >>> i9 | i6;
 i7 = i5 + 16 + (i11 << 2) | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 16 >> 2] & i12) >>> i9 | i6;
 i6 = i7 + 4 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 20 >> 2] & i12) >>> i9 | i5;
 i6 = i7 + 8 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 24 >> 2] & i12) >>> i9 | i5;
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 28 >> 2] & i12) >>> i9 | i5;
 i7 = i7 + 16 + (i11 << 2) | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 32 >> 2] & i12) >>> i9 | i6;
 i6 = i7 + 4 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 36 >> 2] & i12) >>> i9 | i5;
 i6 = i7 + 8 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 40 >> 2] & i12) >>> i9 | i5;
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] & i8;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 >> 2] = (HEAP32[i10 + 44 >> 2] & i12) >>> i9 | i5;
 i11 = i7 + 16 + (i11 << 2) | 0;
 i7 = HEAP32[i11 >> 2] & i8;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 >> 2] = (HEAP32[i10 + 48 >> 2] & i12) >>> i9 | i7;
 i7 = i11 + 4 | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 52 >> 2] & i12) >>> i9 | i6;
 i7 = i11 + 8 | 0;
 i6 = HEAP32[i7 >> 2] & i8;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 >> 2] = (HEAP32[i10 + 56 >> 2] & i12) >>> i9 | i6;
 i11 = i11 + 12 | 0;
 i8 = HEAP32[i11 >> 2] & i8;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 >> 2] = (HEAP32[i10 + 60 >> 2] & i12) >>> i9 | i8;
 STACKTOP = i13;
 return;
}

function __ZN12AudioManager10InitNormalEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i1 = i13 + 28 | 0;
 i3 = i13 + 24 | 0;
 i8 = i13 + 12 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13 + 4 | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0);
 i11 = i12 + 88 | 0;
 if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System13getNumDriversEPi(HEAP32[i11 >> 2] | 0, i1) | 0, gb + 860492 | 0) | 0) {
  if (!(HEAP32[i1 >> 2] | 0)) i2 = 5; else if (HEAP8[i12 + 224 >> 0] | 0) i2 = 5;
 } else {
  HEAP32[i1 >> 2] = 0;
  i2 = 5;
 }
 if ((i2 | 0) == 5) if (!(__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System9setOutputE15FMOD_OUTPUTTYPE(HEAP32[i11 >> 2] | 0, 2) | 0, gb + 860534 | 0) | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 __ZN4FMOD6System9getDriverEPi(HEAP32[i11 >> 2] | 0, i3) | 0;
 i1 = i12 + 116 | 0;
 do if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE(HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] | 0, i12 + 112 | 0, 0, i1) | 0, gb + 860580 | 0) | 0) {
  i5 = i12 + 160 | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 + 124 >> 2];
  i3 = i12 + 128 | 0;
  HEAP32[i12 + 164 >> 2] = HEAP32[i3 >> 2];
  i14 = HEAP32[i12 + 120 >> 2] | 0;
  i2 = i12 + 156 | 0;
  HEAP32[i2 >> 2] = i14;
  i6 = i12 + 132 | 0;
  HEAP32[i12 + 168 >> 2] = HEAP32[i6 >> 2];
  i7 = i12 + 136 | 0;
  HEAP32[i12 + 172 >> 2] = HEAP32[i7 >> 2];
  HEAP8[i12 + 176 >> 0] = HEAP8[i12 + 225 >> 0] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if (!((i1 | 0) >= (i14 | 0) | (i14 | 0) == 7)) HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 860624 | 0, 12);
  __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  if (!(__ZN4FMOD6System14setSpeakerModeE16FMOD_SPEAKERMODE(HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0)) i1 = 0; else {
   __Z6FormatPKcz(i8, gb + 860637 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 856220 | 0, 1019, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = __ZN4FMOD6System14setSpeakerModeE16FMOD_SPEAKERMODE(HEAP32[i11 >> 2] | 0, 2) | 0;
  }
  if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, i1, gb + 860739 | 0) | 0) {
   i2 = i12 + 216 | 0;
   if (!(HEAP32[i2 >> 2] | 0)) __ZN4FMOD6System16getDSPBufferSizeEPjPi(HEAP32[i11 >> 2] | 0, i2, 0) | 0;
   HEAP32[i8 >> 2] = 0;
   if (!(__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System16getDSPBufferSizeEPjPi(HEAP32[i11 >> 2] | 0, 0, i8) | 0, gb + 860776 | 0) | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = HEAP32[i2 >> 2] | 0;
   if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System16setDSPBufferSizeEji(HEAP32[i11 >> 2] | 0, i1, HEAP32[i8 >> 2] | 0) | 0, gb + 860817 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i11 >> 2] | 0, i8, i9, 0, 0, i10, 0) | 0, gb + 860580 | 0) | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = __ZN4FMOD6System17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER(HEAP32[i11 >> 2] | 0, (i1 | 0) == 0 ? HEAP32[i8 >> 2] | 0 : i1, HEAP32[i9 >> 2] | 0, 0, 8, HEAP32[i10 >> 2] | 0) | 0;
    if ((i1 | 0) == 37) i1 = __ZN4FMOD6System17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER(HEAP32[i11 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, 0, 8, HEAP32[i10 >> 2] | 0) | 0;
    if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, i1, gb + 860580 | 0) | 0) if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, __ZN4FMOD6System19setSoftwareChannelsEi(HEAP32[i11 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0, gb + 860857 | 0) | 0) {
     if (!(__ZN4FMOD6System4initEijPv(HEAP32[i11 >> 2] | 0, HEAP32[i6 >> 2] | 0, 0, 0) | 0)) i1 = 0; else {
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 860904 | 0, 0, gb + 856220 | 0, 1091, 1, 0, 0, 0);
      __ZN4FMOD6System9setOutputE15FMOD_OUTPUTTYPE(HEAP32[i11 >> 2] | 0, 2) | 0;
      i1 = __ZN4FMOD6System4initEijPv(HEAP32[i11 >> 2] | 0, HEAP32[i6 >> 2] | 0, 0, 0) | 0;
     }
     if (__ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i12, i1, gb + 860085 | 0) | 0) {
      HEAP8[i12 + 42 >> 0] = 0;
      i1 = 1;
     } else i1 = 0;
    } else i1 = 0; else i1 = 0;
   } else i1 = 0; else i1 = 0;
  } else i1 = 0;
 } else i1 = 0; while (0);
 i14 = i1;
 STACKTOP = i13;
 return i14 | 0;
}

function __Z52StaticBatchingUtility_CUSTOM_InternalCombineVerticesP11Il2CppArrayP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 28 | 0;
 i8 = i15 + 24 | 0;
 i9 = i15 + 20 | 0;
 i13 = i15 + 8 | 0;
 i10 = i15;
 __ZN11ICallStringC2EP12Il2CppString(i9, i1);
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 if (i7) {
  __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj(i13, i7);
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 108) | 0;
  i5 = 0;
  do {
   i4 = HEAP32[i6 + (i5 * 108 | 0) >> 2] | 0;
   if (!i4) i1 = 0; else {
    HEAP32[i8 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 15; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i8);
      i2 = HEAP32[i11 >> 2] | 0;
      i16 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 15; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 17;
     }
    }
    if ((i12 | 0) == 15) i12 = 17;
    if ((i12 | 0) == 17) {
     i12 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
   }
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP32[i2 + (i5 * 112 | 0) >> 2] = i1;
   i4 = HEAP32[i6 + (i5 * 108 | 0) + 8 >> 2] | 0;
   if (!i4) i1 = 0; else {
    HEAP32[i8 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 25; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i8);
      i2 = HEAP32[i11 >> 2] | 0;
      i16 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 25; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 27;
     }
    }
    if ((i12 | 0) == 25) i12 = 27;
    if ((i12 | 0) == 27) {
     i12 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
    i2 = HEAP32[i13 >> 2] | 0;
   }
   HEAP32[i2 + (i5 * 112 | 0) + 4 >> 2] = i1;
   i1 = i2 + (i5 * 112 | 0) + 12 | 0;
   i3 = i6 + (i5 * 108 | 0) + 12 | 0;
   i4 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    i1 = i1 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i1 | 0) < (i4 | 0));
   i16 = i2 + (i5 * 112 | 0) + 76 | 0;
   i4 = i6 + (i5 * 108 | 0) + 76 | 0;
   HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   i16 = i2 + (i5 * 112 | 0) + 92 | 0;
   i4 = i6 + (i5 * 108 | 0) + 92 | 0;
   HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i7 | 0));
 }
 i16 = gb + 63520 | 0;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 i3 = __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId(0, i11) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i11, i9);
 __Z36CombineMeshVerticesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEERKNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEER4Meshb(i13, i11, i3, 1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return i3 | 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i14 >> 2] = i2 + (~(((i2 + -112 - i1 | 0) >>> 0) / 112 | 0) * 112 | 0);
 __ZdlPv(i1);
 STACKTOP = i15;
 return i3 | 0;
}

function __Z11BuildBVTreeRK13dynamic_arrayI8Vector3fLj4EERS_IiLj4EERS_I16HeightMeshBVNodeLj4EEi(i3, i8, i9, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, i31 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15;
 i11 = i15 + 28 | 0;
 i12 = i15 + 8 | 0;
 i13 = i8 + 12 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = (i2 >>> 0) / 3 | 0;
 i1 = i9 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i9 + 4 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i16 = i5;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i14;
 L4 : do if (i2 >>> 0 > 2) {
  HEAP32[i6 >> 2] = i14;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i14 << 5, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i2;
  i1 = 0;
  while (1) {
   i23 = (HEAP32[i8 >> 2] | 0) + (i1 * 3 << 2) | 0;
   i27 = i2 + (i1 << 5) | 0;
   HEAP32[i2 + (i1 << 5) + 24 >> 2] = i1;
   i4 = i2 + (i1 << 5) + 12 | 0;
   i30 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i23 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
   _memmove(i27 | 0, i30 | 0, 12) | 0;
   i30 = i23 + 4 | 0;
   i31 = HEAP32[i30 >> 2] | 0;
   i16 = HEAP32[i3 >> 2] | 0;
   f28 = Math_fround(HEAPF32[i27 >> 2]);
   f18 = Math_fround(HEAPF32[i16 + (i31 * 12 | 0) >> 2]);
   f28 = f18 < f28 ? f18 : f28;
   i25 = i2 + (i1 << 5) + 4 | 0;
   f18 = Math_fround(HEAPF32[i25 >> 2]);
   f22 = Math_fround(HEAPF32[i16 + (i31 * 12 | 0) + 4 >> 2]);
   f18 = f22 < f18 ? f22 : f18;
   i24 = i2 + (i1 << 5) + 8 | 0;
   f22 = Math_fround(HEAPF32[i24 >> 2]);
   f21 = Math_fround(HEAPF32[i16 + (i31 * 12 | 0) + 8 >> 2]);
   f22 = f21 < f22 ? f21 : f22;
   HEAPF32[i27 >> 2] = f28;
   HEAPF32[i25 >> 2] = f18;
   HEAPF32[i24 >> 2] = f22;
   i30 = HEAP32[i30 >> 2] | 0;
   i31 = HEAP32[i3 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i4 >> 2]);
   f19 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) >> 2]);
   f21 = f21 < f19 ? f19 : f21;
   i4 = i2 + (i1 << 5) + 16 | 0;
   f19 = Math_fround(HEAPF32[i4 >> 2]);
   f17 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) + 4 >> 2]);
   f19 = f19 < f17 ? f17 : f19;
   i16 = i2 + (i1 << 5) + 20 | 0;
   f17 = Math_fround(HEAPF32[i16 >> 2]);
   f29 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) + 8 >> 2]);
   f17 = f17 < f29 ? f29 : f17;
   i2 = i2 + (i1 << 5) + 12 | 0;
   HEAPF32[i2 >> 2] = f21;
   HEAPF32[i4 >> 2] = f19;
   HEAPF32[i16 >> 2] = f17;
   i23 = i23 + 8 | 0;
   i30 = HEAP32[i23 >> 2] | 0;
   i31 = HEAP32[i3 >> 2] | 0;
   f29 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) >> 2]);
   f26 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i31 + (i30 * 12 | 0) + 8 >> 2]);
   HEAPF32[i27 >> 2] = f29 < f28 ? f29 : f28;
   HEAPF32[i25 >> 2] = f26 < f18 ? f26 : f18;
   HEAPF32[i24 >> 2] = f20 < f22 ? f20 : f22;
   i23 = HEAP32[i23 >> 2] | 0;
   i24 = HEAP32[i3 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) + 8 >> 2]);
   HEAPF32[i2 >> 2] = f21 < f22 ? f22 : f21;
   HEAPF32[i4 >> 2] = f19 < f20 ? f20 : f19;
   HEAPF32[i16 >> 2] = f17 < f18 ? f18 : f17;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i14 | 0)) break L4;
   i2 = HEAP32[i11 >> 2] | 0;
  }
 } while (0);
 HEAP32[i12 >> 2] = 0;
 i3 = i12 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i30 = i5;
 i31 = HEAP32[i30 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i1 + 4 >> 2] = i31;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i4, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i12 >> 2] = i2;
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 | 0) _memmove(i2 | 0, HEAP32[i8 >> 2] | 0, i1 << 2 | 0) | 0;
 }
 HEAP32[i13 >> 2] = 0;
 __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_(i11, 0, i14, i10, i9, i8, i12);
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i4);
  HEAP32[i12 >> 2] = 0;
 }
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i7);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i15;
 return 1;
}

function __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_(i10, i11, i7, i6, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = (i4 | 0) < (i2 | 0);
 do if ((i2 | 0) < (i3 | 0)) {
  if (i1) {
   HEAP32[i10 >> 2] = i4;
   HEAP32[i7 >> 2] = i3;
   i4 = i10 + 4 | 0;
   i5 = i7 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i5 = 1;
   break;
  }
  HEAP32[i10 >> 2] = i2;
  HEAP32[i11 >> 2] = i3;
  i2 = i10 + 4 | 0;
  i1 = i11 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i11 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   i5 = i7 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i5 = 2;
  } else i5 = 1;
 } else if (i1) {
  HEAP32[i11 >> 2] = i4;
  HEAP32[i7 >> 2] = i2;
  i1 = i11 + 4 | 0;
  i2 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i11 >> 2] = i3;
   i5 = i10 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i5 = 2;
  } else i5 = 1;
 } else i5 = 0; while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i11 = i5;
  STACKTOP = i9;
  return i11 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i4 = i7 + 4 | 0;
 i1 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i11 = i5 + 1 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i3 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i11 = i5 + 2 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 i11 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i11 = i5 + 3 | 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZNSt3__218__time_get_storageIcE4initERKNS_5ctypeIcEE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i4 = i8 + 56 | 0;
 i7 = i8;
 i1 = i3;
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i2 = i3 + 24 | 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 7) break;
  HEAP32[i2 >> 2] = i1;
  _strftime_l(i4 | 0, 100, gb + 1081538 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 4 + (i1 * 12 | 0) | 0, i4) | 0;
  _strftime_l(i4 | 0, 100, gb + 1087547 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 4 + ((i1 + 7 | 0) * 12 | 0) | 0, i4) | 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i3 + 16 | 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 12) break;
  HEAP32[i2 >> 2] = i1;
  _strftime_l(i4 | 0, 100, gb + 1081541 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 172 + (i1 * 12 | 0) | 0, i4) | 0;
  _strftime_l(i4 | 0, 100, gb + 1081544 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 172 + ((i1 + 12 | 0) * 12 | 0) | 0, i4) | 0;
  i1 = i1 + 1 | 0;
 }
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = 1;
 _strftime_l(i4 | 0, 100, gb + 1078024 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 460 | 0, i4) | 0;
 HEAP32[i1 >> 2] = 13;
 _strftime_l(i4 | 0, 100, gb + 1078024 | 0, i3 | 0, HEAP32[i6 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6 + 472 | 0, i4) | 0;
 i1 = i6 + 484 | 0;
 __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE(i7, i6, 99, i5);
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i6 + 488 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i1 | 0, 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i4);
 };
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i1 = i6 + 496 | 0;
 __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE(i7, i6, 114, i5);
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i6 + 500 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i1 | 0, 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i4);
 };
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i1 = i6 + 508 | 0;
 __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE(i7, i6, 120, i5);
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i6 + 512 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i1 | 0, 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i4);
 };
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i2 = i6 + 520 | 0;
 __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE(i7, i6, 88, i5);
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i6 + 524 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i2 | 0, 0);
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i6);
 };
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5physx2Gu23computeMTD_ConvexConvexERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformES6_S9_(i17, i16, i1, i6, i5, i7) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 864 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 792 | 0;
 i13 = i20 + 720 | 0;
 i8 = i20 + 656 | 0;
 i9 = i20 + 592 | 0;
 i23 = i20 + 576 | 0;
 i3 = i20 + 144 | 0;
 i32 = i20 + 128 | 0;
 i10 = i20 + 368 | 0;
 i33 = i20 + 112 | 0;
 i34 = i20 + 96 | 0;
 i11 = i20 + 160 | 0;
 i14 = i20 + 64 | 0;
 i15 = i20 + 32 | 0;
 i18 = i20 + 16 | 0;
 i19 = i20;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 i30 = (HEAP32[i1 + 32 >> 2] | 0) + 16 | 0;
 i22 = i1 + 4 | 0;
 i21 = i1 + 8 | 0;
 i28 = HEAP32[i21 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i31 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i3 + 4 >> 2] = i28;
 HEAP32[i3 + 8 >> 2] = i31;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 i31 = i1 + 16 | 0;
 i28 = HEAP32[i31 + 4 >> 2] | 0;
 i4 = HEAP32[i31 + 8 >> 2] | 0;
 i1 = HEAP32[i31 + 12 >> 2] | 0;
 HEAP32[i32 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i32 + 4 >> 2] = i28;
 HEAP32[i32 + 8 >> 2] = i4;
 HEAP32[i32 + 12 >> 2] = i1;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i10, i30, i23, i3, i32);
 i32 = (HEAP32[i5 + 32 >> 2] | 0) + 16 | 0;
 i1 = i5 + 4 | 0;
 i3 = i5 + 8 | 0;
 i30 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 12 | 0;
 i28 = HEAP32[i4 >> 2] | 0;
 HEAP32[i33 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i33 + 4 >> 2] = i30;
 HEAP32[i33 + 8 >> 2] = i28;
 HEAPF32[i33 + 12 >> 2] = Math_fround(0.0);
 i28 = i5 + 16 | 0;
 i30 = HEAP32[i28 + 4 >> 2] | 0;
 i31 = HEAP32[i28 + 8 >> 2] | 0;
 i29 = HEAP32[i28 + 12 >> 2] | 0;
 HEAP32[i34 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i34 + 4 >> 2] = i30;
 HEAP32[i34 + 8 >> 2] = i31;
 HEAP32[i34 + 12 >> 2] = i29;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i11, i32, i23, i33, i34);
 i34 = HEAP32[i6 + 4 >> 2] | 0;
 i33 = HEAP32[i6 + 8 >> 2] | 0;
 i32 = HEAP32[i6 + 12 >> 2] | 0;
 i29 = i6 + 16 | 0;
 i31 = HEAP32[i29 >> 2] | 0;
 i30 = HEAP32[i29 + 4 >> 2] | 0;
 i29 = HEAP32[i29 + 8 >> 2] | 0;
 i28 = HEAP32[i7 >> 2] | 0;
 i27 = HEAP32[i7 + 4 >> 2] | 0;
 i26 = HEAP32[i7 + 8 >> 2] | 0;
 i25 = HEAP32[i7 + 12 >> 2] | 0;
 i7 = i7 + 16 | 0;
 i24 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i14 + 4 >> 2] = i34;
 HEAP32[i14 + 8 >> 2] = i33;
 HEAP32[i14 + 12 >> 2] = i32;
 HEAP32[i14 + 16 >> 2] = i31;
 HEAP32[i14 + 20 >> 2] = i30;
 HEAP32[i14 + 24 >> 2] = i29;
 HEAPF32[i14 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i15 >> 2] = i28;
 HEAP32[i15 + 4 >> 2] = i27;
 HEAP32[i15 + 8 >> 2] = i26;
 HEAP32[i15 + 12 >> 2] = i25;
 HEAP32[i15 + 16 >> 2] = i24;
 HEAP32[i15 + 20 >> 2] = i5;
 HEAP32[i15 + 24 >> 2] = i7;
 HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i18 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 i7 = Math_fround(HEAPF32[i22 >> 2]) == Math_fround(1.0);
 if (i7 & Math_fround(HEAPF32[i21 >> 2]) == Math_fround(1.0)) i2 = Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0); else i2 = 0;
 i34 = Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0);
 if (i34 & Math_fround(HEAPF32[i3 >> 2]) == Math_fround(1.0)) i1 = Math_fround(HEAPF32[i4 >> 2]) == Math_fround(1.0); else i1 = 0;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i10, i2, i12);
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i11, i1, i13);
 HEAP32[i8 + 32 >> 2] = i14;
 HEAP32[i8 + 36 >> 2] = i10 + 96;
 HEAP32[i8 + 40 >> 2] = i10 + 144;
 HEAP8[i8 + 44 >> 0] = i2 & 1;
 HEAP32[i8 >> 2] = i2 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i8 + 48 >> 2] = i10;
 HEAP32[i9 + 32 >> 2] = i15;
 HEAP32[i9 + 36 >> 2] = i11 + 96;
 HEAP32[i9 + 40 >> 2] = i11 + 144;
 HEAP8[i9 + 44 >> 0] = i1 & 1;
 HEAP32[i9 >> 2] = i1 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i9 + 48 >> 2] = i11;
 i1 = __ZN5physx2Gu10computeMTDERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_RNS_6shdfnd3aos6FloatVERNS6_5Vec3VE(i12, i13, i8, i9, i19, i18) | 0;
 if (!i1) {
  STACKTOP = i20;
  return i1 | 0;
 }
 f35 = Math_fround(HEAPF32[i19 >> 2]);
 i33 = f35 > Math_fround(0.0);
 HEAPF32[i16 >> 2] = i33 ? f35 : Math_fround(0.0);
 i33 = HEAP32[i18 + 4 >> 2] | 0;
 i34 = HEAP32[i18 + 8 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = i33;
 HEAP32[i17 + 8 >> 2] = i34;
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5physx20PxClothGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 HEAP32[i1 + 120 >> 2] = gb + 674663;
 HEAP32[i1 + 124 >> 2] = 138;
 HEAP32[i1 + 128 >> 2] = fb + 2154;
 HEAP32[i1 + 132 >> 2] = gb + 675496;
 HEAP32[i1 + 136 >> 2] = 139;
 HEAP32[i1 + 140 >> 2] = fb + 2155;
 HEAP32[i1 + 144 >> 2] = fb + 3526;
 HEAP32[i1 + 148 >> 2] = gb + 674864;
 HEAP32[i1 + 152 >> 2] = 140;
 HEAP32[i1 + 156 >> 2] = fb + 3527;
 HEAP32[i1 + 160 >> 2] = gb + 673509;
 HEAP32[i1 + 164 >> 2] = 141;
 HEAP32[i1 + 168 >> 2] = fb + 3528;
 HEAP32[i1 + 172 >> 2] = fb + 3529;
 HEAP32[i1 + 176 >> 2] = gb + 674875;
 HEAP32[i1 + 180 >> 2] = 142;
 HEAP32[i1 + 184 >> 2] = fb + 405;
 HEAP32[i1 + 188 >> 2] = fb + 347;
 HEAP32[i1 + 192 >> 2] = gb + 674891;
 HEAP32[i1 + 196 >> 2] = 143;
 HEAP32[i1 + 200 >> 2] = fb + 406;
 HEAP32[i1 + 204 >> 2] = gb + 674908;
 HEAP32[i1 + 208 >> 2] = 144;
 HEAP32[i1 + 212 >> 2] = fb + 407;
 HEAP32[i1 + 216 >> 2] = fb + 348;
 HEAP32[i1 + 220 >> 2] = gb + 674927;
 HEAP32[i1 + 224 >> 2] = 145;
 HEAP32[i1 + 228 >> 2] = fb + 3530;
 HEAP32[i1 + 232 >> 2] = fb + 3531;
 HEAP32[i1 + 236 >> 2] = gb + 674946;
 HEAP32[i1 + 240 >> 2] = 146;
 HEAP32[i1 + 244 >> 2] = fb + 3532;
 HEAP32[i1 + 248 >> 2] = fb + 3533;
 HEAP32[i1 + 252 >> 2] = gb + 674966;
 HEAP32[i1 + 256 >> 2] = 147;
 HEAP32[i1 + 260 >> 2] = fb + 3534;
 HEAP32[i1 + 264 >> 2] = fb + 3535;
 HEAP32[i1 + 268 >> 2] = gb + 674990;
 HEAP32[i1 + 272 >> 2] = 148;
 HEAP32[i1 + 276 >> 2] = fb + 349;
 HEAP32[i1 + 280 >> 2] = gb + 675003;
 HEAP32[i1 + 284 >> 2] = 149;
 HEAP32[i1 + 288 >> 2] = fb + 3536;
 HEAP32[i1 + 292 >> 2] = fb + 3537;
 HEAP32[i1 + 296 >> 2] = gb + 675022;
 HEAP32[i1 + 300 >> 2] = 150;
 HEAP32[i1 + 304 >> 2] = fb + 3538;
 HEAP32[i1 + 308 >> 2] = fb + 3539;
 HEAP32[i1 + 312 >> 2] = gb + 675044;
 HEAP32[i1 + 316 >> 2] = 151;
 HEAP32[i1 + 320 >> 2] = fb + 3540;
 HEAP32[i1 + 324 >> 2] = fb + 3541;
 HEAP32[i1 + 328 >> 2] = gb + 675067;
 HEAP32[i1 + 332 >> 2] = 152;
 HEAP32[i1 + 336 >> 2] = fb + 350;
 HEAP32[i1 + 340 >> 2] = gb + 675083;
 HEAP32[i1 + 344 >> 2] = 153;
 HEAP32[i1 + 348 >> 2] = fb + 3542;
 HEAP32[i1 + 352 >> 2] = fb + 3543;
 HEAP32[i1 + 356 >> 2] = gb + 675104;
 HEAP32[i1 + 360 >> 2] = 154;
 HEAP32[i1 + 364 >> 2] = fb + 3544;
 HEAP32[i1 + 368 >> 2] = fb + 3545;
 HEAP32[i1 + 372 >> 2] = gb + 675127;
 HEAP32[i1 + 376 >> 2] = 155;
 HEAP32[i1 + 380 >> 2] = fb + 775;
 HEAP32[i1 + 384 >> 2] = fb + 776;
 HEAP32[i1 + 388 >> 2] = gb + 675141;
 HEAP32[i1 + 392 >> 2] = 156;
 HEAP32[i1 + 396 >> 2] = fb + 3546;
 HEAP32[i1 + 400 >> 2] = fb + 3547;
 HEAP32[i1 + 404 >> 2] = gb + 675154;
 HEAP32[i1 + 408 >> 2] = 157;
 HEAP32[i1 + 412 >> 2] = fb + 408;
 HEAP32[i1 + 416 >> 2] = fb + 351;
 HEAP32[i1 + 420 >> 2] = gb + 675174;
 HEAP32[i1 + 424 >> 2] = 158;
 HEAP32[i1 + 428 >> 2] = fb + 409;
 HEAP32[i1 + 432 >> 2] = fb + 352;
 HEAP32[i1 + 436 >> 2] = gb + 675193;
 HEAP32[i1 + 440 >> 2] = 159;
 HEAP32[i1 + 444 >> 2] = fb + 410;
 HEAP32[i1 + 448 >> 2] = fb + 353;
 HEAP32[i1 + 452 >> 2] = gb + 675215;
 HEAP32[i1 + 456 >> 2] = 160;
 HEAP32[i1 + 460 >> 2] = fb + 411;
 HEAP32[i1 + 464 >> 2] = fb + 354;
 HEAP32[i1 + 468 >> 2] = gb + 672848;
 HEAP32[i1 + 472 >> 2] = 161;
 HEAP32[i1 + 476 >> 2] = fb + 3548;
 HEAP32[i1 + 480 >> 2] = fb + 3549;
 HEAP32[i1 + 484 >> 2] = gb + 672895;
 HEAP32[i1 + 488 >> 2] = 162;
 HEAP32[i1 + 492 >> 2] = fb + 412;
 HEAP32[i1 + 496 >> 2] = fb + 355;
 HEAP32[i1 + 500 >> 2] = gb + 672909;
 HEAP32[i1 + 504 >> 2] = 163;
 HEAP32[i1 + 508 >> 2] = fb + 413;
 HEAP32[i1 + 512 >> 2] = fb + 356;
 HEAP32[i1 + 516 >> 2] = gb + 675238;
 HEAP32[i1 + 520 >> 2] = 164;
 HEAP32[i1 + 524 >> 2] = fb + 414;
 HEAP32[i1 + 528 >> 2] = fb + 357;
 HEAP32[i1 + 532 >> 2] = gb + 673721;
 HEAP32[i1 + 536 >> 2] = 165;
 HEAP32[i1 + 540 >> 2] = fb + 415;
 HEAP32[i1 + 544 >> 2] = fb + 358;
 HEAP32[i1 + 548 >> 2] = gb + 673687;
 HEAP32[i1 + 552 >> 2] = 166;
 HEAP32[i1 + 556 >> 2] = fb + 2156;
 HEAP32[i1 + 560 >> 2] = gb + 831985;
 HEAP32[i1 + 564 >> 2] = 167;
 HEAP32[i1 + 568 >> 2] = fb + 2157;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc(i1, i2, i16, i18, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 24 | 0;
 i14 = i22 + 12 | 0;
 i15 = i22;
 HEAP32[i20 >> 2] = 0;
 i21 = i20 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi(i2, 10, i20, 0);
 i2 = HEAP32[i20 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) i3 = 0; else {
  i10 = i14 + 11 | 0;
  i11 = i14 + 4 | 0;
  i12 = i14 + 4 | 0;
  i13 = i14 + 8 | 0;
  i1 = 0;
  while (1) {
   i3 = i2 + 11 | 0;
   if (i1) i17 = 14; else if (__Z10BeginsWithPKcS0_((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 1046953 | 0) | 0) {
    HEAP32[i14 >> 2] = 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = 0;
    __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi(i2, 32, i14, 0);
    i9 = HEAP32[i14 >> 2] | 0;
    i1 = i9;
    if ((((HEAP32[i12 >> 2] | 0) - i9 | 0) / 12 | 0) >>> 0 > 1) {
     i1 = i1 + 12 | 0;
     HEAP32[i18 >> 2] = __Z11StringToIntPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    if (i1 | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) {
      do {
       i9 = i3 + -12 | 0;
       HEAP32[i12 >> 2] = i9;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
       i3 = HEAP32[i12 >> 2] | 0;
      } while ((i3 | 0) != (i1 | 0));
      i1 = HEAP32[i14 >> 2] | 0;
     }
     __ZdlPv(i1);
    }
    i1 = 0;
   } else i17 = 14;
   if ((i17 | 0) == 14) {
    i17 = 0;
    i3 = HEAP8[i3 >> 0] | 0;
    if (i3 << 24 >> 24 < 0) {
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     i3 = HEAP32[i2 >> 2] | 0;
    } else {
     i4 = i3 & 255;
     i3 = i2;
    }
    if (i4 >>> 0 >= 2) {
     i9 = i3 + i4 | 0;
     i7 = i9;
     i8 = i3;
     L26 : do if ((i4 | 0) < 2) i3 = i7; else {
      i6 = i9 + -1 | 0;
      if ((i6 | 0) == (i3 | 0)) i3 = i7; else L28 : while (1) {
       while (1) {
        if ((HEAP8[i3 >> 0] | 0) == 58) {
         i4 = gb + 1084762 | 0;
         i5 = i3;
         break;
        }
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i6 | 0)) {
         i3 = i7;
         break L26;
        }
       }
       do {
        i4 = i4 + 1 | 0;
        if ((i4 | 0) == (gb + 1084762 + 2 | 0)) break L28;
        i5 = i5 + 1 | 0;
       } while ((HEAP8[i5 >> 0] | 0) == (HEAP8[i4 >> 0] | 0));
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i6 | 0)) {
        i3 = i7;
        break L26;
       }
      }
     } while (0);
     i4 = i3 - i8 | 0;
     if (!((i3 | 0) == (i9 | 0) | (i4 | 0) == -1)) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i15, i2, 0, i4, i2);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i15);
      i9 = HEAP8[i10 >> 0] | 0;
      i1 = i9 << 24 >> 24 < 0;
      if ((i1 ? HEAP32[i11 >> 2] | 0 : i9 & 255) | 0) {
       i1 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
       do {
        i8 = HEAP8[i1 >> 0] | 0;
        i9 = i8 << 24 >> 24;
        HEAP8[i1 >> 0] = (i8 + -97 & 255) < 26 ? i9 + 224 | 0 : i9;
        i1 = i1 + 1 | 0;
        i9 = HEAP8[i10 >> 0] | 0;
        i8 = i9 << 24 >> 24 < 0;
       } while ((i1 | 0) != ((i8 ? HEAP32[i14 >> 2] | 0 : i14) + (i8 ? HEAP32[i11 >> 2] | 0 : i9 & 255) | 0));
      }
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i15, i2, i4 + 2 | 0, -1, i2);
      __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(i16, i14, i15);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
      i1 = 1;
     }
    }
   }
   i2 = i2 + 12 | 0;
   if ((i2 | 0) == (HEAP32[i21 >> 2] | 0)) {
    i3 = 1;
    break;
   }
  }
 }
 if (!i19) {
  if (!(HEAP32[i18 >> 2] | 0)) HEAP32[i18 >> 2] = 200;
 } else HEAP32[i18 >> 2] = __Z11StringToIntPKc(i19) | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i22;
  return i3 | 0;
 }
 i2 = HEAP32[i21 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i19 = i2 + -12 | 0;
   HEAP32[i21 >> 2] = i19;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
   i2 = HEAP32[i21 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i20 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i22;
 return i3 | 0;
}

function __Z25dtNavMeshHeaderSwapEndianPh(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i1 & 255;
 if ((i1 | 0) < 1447120452) {
  switch (i1 | 0) {
  case 1145979222:
   break;
  default:
   {
    i4 = 0;
    return i4 | 0;
   }
  }
  i1 = i3 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 16) i2 = 16; else {
   i4 = 0;
   return i4 | 0;
  }
 } else {
  switch (i1 | 0) {
  case 1447120452:
   break;
  default:
   {
    i4 = 0;
    return i4 | 0;
   }
  }
  i1 = i3 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 268435456) i2 = 0; else {
   i4 = 0;
   return i4 | 0;
  }
 }
 i6 = i3 + 3 | 0;
 HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i4;
 i6 = i3 + 1 | 0;
 i4 = i3 + 2 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i5;
 i4 = i3 + 7 | 0;
 HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i2;
 i4 = i3 + 5 | 0;
 i1 = i3 + 6 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 8 | 0;
 i2 = i3 + 11 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 9 | 0;
 i4 = i3 + 10 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 12 | 0;
 i1 = i3 + 15 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 13 | 0;
 i2 = i3 + 14 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 16 | 0;
 i4 = i3 + 19 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 17 | 0;
 i1 = i3 + 18 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 20 | 0;
 i2 = i3 + 23 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 21 | 0;
 i4 = i3 + 22 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 24 | 0;
 i1 = i3 + 27 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 25 | 0;
 i2 = i3 + 26 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 28 | 0;
 i4 = i3 + 31 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 29 | 0;
 i1 = i3 + 30 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 32 | 0;
 i2 = i3 + 35 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 33 | 0;
 i4 = i3 + 34 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 36 | 0;
 i1 = i3 + 39 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 37 | 0;
 i2 = i3 + 38 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 40 | 0;
 i4 = i3 + 43 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 41 | 0;
 i1 = i3 + 42 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 44 | 0;
 i2 = i3 + 47 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 45 | 0;
 i4 = i3 + 46 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 48 | 0;
 i1 = i3 + 51 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 49 | 0;
 i2 = i3 + 50 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 52 | 0;
 i4 = i3 + 55 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 53 | 0;
 i1 = i3 + 54 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 56 | 0;
 i2 = i3 + 59 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 57 | 0;
 i4 = i3 + 58 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 60 | 0;
 i1 = i3 + 63 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 61 | 0;
 i2 = i3 + 62 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 64 | 0;
 i4 = i3 + 67 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i3 + 65 | 0;
 i1 = i3 + 66 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i2;
 i1 = i3 + 68 | 0;
 i2 = i3 + 71 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i4;
 i2 = i3 + 69 | 0;
 i4 = i3 + 70 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i3;
 i4 = 1;
 return i4 | 0;
}

function __ZNK8GUIStyle10RenderTextERK5RectTIfERN13TextRendering17TextMeshGeneratorE10ColorRGBAf(i3, i7, i12, i4) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 152 | 0;
 i14 = i15 + 88 | 0;
 i8 = i15 + 24 | 0;
 i9 = i15 + 16 | 0;
 i10 = i15;
 i1 = HEAP32[gb + 1468872 >> 2] | 0;
 if (!i1) {
  i11 = __Z15GetScriptMapperv() | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, gb + 1017501 | 0, 34);
  i11 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11, i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i11 = __ZN8Material14CreateMaterialER6Shaderib(i11, 61, 0) | 0;
  HEAP32[gb + 1468872 >> 2] = i11;
  __Z24InitializeGUIClipTexturev();
  i11 = HEAP32[gb + 1468872 >> 2] | 0;
 } else i11 = i1;
 HEAP32[i4 >> 2] = 1065353216;
 HEAP32[i4 + 4 >> 2] = 1065353216;
 HEAP32[i4 + 8 >> 2] = 1065353216;
 HEAP32[i4 + 12 >> 2] = 1065353216;
 i1 = i11 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 5; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 5;
 if ((i6 | 0) == 5) __ZN8Material15BuildPropertiesEv(i11);
 __ZN8Material19UnshareMaterialDataEv(i11);
 i5 = HEAP32[i1 >> 2] | 0;
 __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i5);
 i5 = i5 + 12 | 0;
 HEAP32[i13 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i13, gb + 1017536 | 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i5, i13, i4, 0);
 i1 = __ZNK8GUIStyle14GetCurrentFontEv(i3) | 0;
 if (i1 | 0) {
  i4 = __ZNK13TextRendering4Font10GetTextureEv(i1) | 0;
  if (!i4) i1 = 0; else {
   HEAP32[i14 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i2 = HEAP32[i13 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 13; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 15;
    }
   }
   if ((i6 | 0) == 13) i6 = 15;
   if ((i6 | 0) == 15) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  }
  HEAP32[i13 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i13, gb + 1046318 | 0);
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i5, i13, i1);
 }
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = i13;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i14;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i9, i12, i7);
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = i2;
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i8, i10) | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, i8 | 0);
 i2 = __ZNK8Material12GetPassCountEv(i11) | 0;
 if ((i2 | 0) <= 0) {
  i16 = HEAP32[i4 >> 2] | 0;
  i16 = i16 + 112 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vii(i16 | 0, i4 | 0, i13 | 0);
  i16 = HEAP32[i4 >> 2] | 0;
  i16 = i16 + 108 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vii(i16 | 0, i4 | 0, i14 | 0);
  STACKTOP = i15;
  return;
 }
 i1 = 0;
 do {
  i10 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i11, i1, i3, 0, 1) | 0;
  i16 = HEAP32[i12 >> 2] | 0;
  __ZN8DrawUtil15DrawTextMeshRawERK14ChannelAssignsR4MeshR23DefaultMeshVertexFormat(i10, i16, __ZN13TextRendering17TextMeshGenerator15GetVertexFormatEv() | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i16 = HEAP32[i4 >> 2] | 0;
 i16 = i16 + 112 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vii(i16 | 0, i4 | 0, i13 | 0);
 i16 = HEAP32[i4 >> 2] | 0;
 i16 = i16 + 108 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vii(i16 | 0, i4 | 0, i14 | 0);
 STACKTOP = i15;
 return;
}

function __ZN19ShaderPropertySheet16SetVectorIndexedERKN9ShaderLab16FastPropertyNameEifRK8Vector4fNS_8SetFlagsE(i13, i2, i14, f15, i12, i10) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16;
 L1 : do if (!(i10 & 2)) {
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i3 = HEAP32[i13 + 16 >> 2] | 0;
  if ((i1 | 0) < (i3 | 0)) {
   i6 = HEAP32[i13 + 32 >> 2] | 0;
   i8 = HEAP32[i2 >> 2] | 0;
   while (1) {
    if ((HEAP32[i6 + (i1 << 2) >> 2] | 0) == (i8 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i11 = 7;
     break L1;
    }
   }
   if ((i1 | 0) < 0) i11 = 7; else {
    i3 = (HEAP32[i13 + 52 >> 2] | 0) + (i1 << 2) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = i1 & 1048575;
    if (i10 & 1) {
     i1 = i1 | 1073741824;
     HEAP32[i3 >> 2] = i1;
    }
   }
  } else i11 = 7;
 } else i11 = 7; while (0);
 if ((i11 | 0) == 7) {
  i11 = i10 & 1;
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i9, i13, i2, 1, 16, 0, i11 << 30);
  i10 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i9 = (HEAP32[i13 + 72 >> 2] | 0) + i2 | 0;
  if (!i11) {
   i3 = HEAP32[i12 >> 2] | 0;
   i8 = HEAP32[i12 + 4 >> 2] | 0;
   i6 = HEAP32[i12 + 8 >> 2] | 0;
   i1 = HEAP32[i12 + 12 >> 2] | 0;
  } else {
   i3 = HEAP32[i12 >> 2] | 0;
   i8 = HEAP32[i12 + 4 >> 2] | 0;
   i6 = HEAP32[i12 + 8 >> 2] | 0;
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   if ((__Z19GetActiveColorSpacev() | 0) == 1) {
    f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f7 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f5 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    do if (!(f4 <= Math_fround(.0404499993))) {
     if (f4 < Math_fround(1.0)) {
      f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
      break;
     }
     if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
    } else f4 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   }
  }
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i9 + 8 >> 2] = i6;
  HEAP32[i9 + 12 >> 2] = i1;
  i1 = HEAP32[(HEAP32[i13 + 52 >> 2] | 0) + (i10 << 2) >> 2] | 0;
 }
 if (!(i1 & 1073741824)) {
  i13 = i13 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + i2 | 0;
  i14 = i13 + (i14 << 2) | 0;
  HEAPF32[i14 >> 2] = f15;
  STACKTOP = i16;
  return;
 }
 if ((__Z19GetActiveColorSpacev() | 0) != 1) {
  i13 = i13 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + i2 | 0;
  i14 = i13 + (i14 << 2) | 0;
  HEAPF32[i14 >> 2] = f15;
  STACKTOP = i16;
  return;
 }
 if (f15 <= Math_fround(.0404499993)) {
  f15 = Math_fround(f15 / Math_fround(12.9200001));
  i13 = i13 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + i2 | 0;
  i14 = i13 + (i14 << 2) | 0;
  HEAPF32[i14 >> 2] = f15;
  STACKTOP = i16;
  return;
 }
 if (f15 < Math_fround(1.0)) {
  f15 = Math_fround(+Math_pow(+Math_fround(Math_fround(f15 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
  i13 = i13 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + i2 | 0;
  i14 = i13 + (i14 << 2) | 0;
  HEAPF32[i14 >> 2] = f15;
  STACKTOP = i16;
  return;
 }
 if (f15 == Math_fround(1.0)) {
  f15 = Math_fround(1.0);
  i13 = i13 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + i2 | 0;
  i14 = i13 + (i14 << 2) | 0;
  HEAPF32[i14 >> 2] = f15;
  STACKTOP = i16;
  return;
 }
 f15 = Math_fround(+Math_pow(+f15, 2.20000005));
 i13 = i13 + 72 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i13 = i13 + i2 | 0;
 i14 = i13 + (i14 << 2) | 0;
 HEAPF32[i14 >> 2] = f15;
 STACKTOP = i16;
 return;
}

function __Z15InitLightMeshesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i4 = i7;
 i1 = HEAP32[gb + 1477012 >> 2] | 0;
 do if (!i1) i5 = 10; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477012 >> 2] | 0) | 0)) i5 = 10;
 } while (0);
 if ((i5 | 0) == 10) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 453386 | 0, 15);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i6) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[gb + 1477012 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i1 = HEAP32[gb + 1477016 >> 2] | 0;
 do if (!i1) i5 = 22; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 19; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477016 >> 2] | 0) | 0)) i5 = 22;
 } while (0);
 if ((i5 | 0) == 22) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 453372 | 0, 13);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i6) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[gb + 1477016 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i1 = HEAP32[gb + 1477020 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 31; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 31; else if (HEAP32[i1 + 4 >> 2] | 0) {
    STACKTOP = i7;
    return;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477020 >> 2] | 0) | 0) {
   STACKTOP = i7;
   return;
  }
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 453402 | 0, 11);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30832 | 0, i6) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[gb + 1477020 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN10AudioMixer14SetWeightedMixER13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEPff(i9, i7, i10, f11) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 8 | 0;
 i13 = i21;
 i14 = i21 + 44 | 0;
 i19 = i21 + 24 | 0;
 i15 = i21 + 12 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i21;
  return;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i9) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 366, 1, 0, 0, 0);
  STACKTOP = i21;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 104 >> 2] | 0, i9 | 0) | 0)) {
  STACKTOP = i21;
  return;
 }
 HEAP32[i19 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i6 = i13;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = i18;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = i8;
 i12 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i19 + 12 >> 2] = i12;
 L11 : do if (!i12) {
  i2 = HEAP32[i9 + 72 >> 2] | 0;
  i1 = 0;
  i20 = 28;
 } else {
  HEAP32[i17 >> 2] = i12;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i12 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i19 >> 2] = i1;
  i8 = i9 + 72 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i12 | 0) > 0) {
   i3 = 0;
   while (1) {
    i6 = (HEAP32[i7 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i20 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i5 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
      i4 = HEAP32[i13 >> 2] | 0;
      i22 = HEAP32[i1 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i4 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i20 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i20 = 16;
     }
    }
    if ((i20 | 0) == 14) i20 = 16;
    if ((i20 | 0) == 16) {
     i20 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    }
    i22 = __ZN5audio5mixer16GetSnapshotIndexERNS0_18AudioMixerConstantEPKc(i2, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) | 0;
    i1 = HEAP32[i19 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i22;
    if ((i22 | 0) == -1) break;
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i3 | 0) >= (i12 | 0)) {
     i20 = 28;
     break L11;
    }
   }
   i4 = (HEAP32[i7 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i20 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i2 = HEAP32[i13 >> 2] | 0;
     i22 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i20 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i20 = 25;
    }
   }
   if ((i20 | 0) == 23) i20 = 25;
   if ((i20 | 0) == 25) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   __Z6FormatPKcz(i15, gb + 861647 | 0, i16);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 861578 | 0, 381, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  } else i20 = 28;
 } while (0);
 if ((i20 | 0) == 28) __ZN5audio5mixer14SetWeightedMixERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEPiPfif(i2, HEAP32[i9 + 76 >> 2] | 0, i1, i10, i12, f11);
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
  HEAP32[i19 >> 2] = 0;
 }
 STACKTOP = i21;
 return;
}

function _UNITY_png_build_gamma_table(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i14 + 488 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  if (HEAP32[i14 + 492 >> 2] | 0) i2 = 3;
 } else i2 = 3;
 if ((i2 | 0) == 3) _UNITY_png_destroy_gamma_table(i14);
 if ((i1 | 0) >= 9) {
  if (!(HEAP8[i14 + 431 >> 0] & 2)) i1 = HEAP8[i14 + 515 >> 0] | 0; else {
   i13 = HEAP32[i14 + 512 >> 2] | 0;
   i1 = i13 & 255;
   i12 = (i13 & 65535) >>> 8 & 255;
   i1 = (i12 & 255) > (i1 & 255) ? i12 : i1;
   i13 = i13 >>> 16 & 255;
   i1 = (i13 & 255) > (i1 & 255) ? i13 : i1;
  }
  i13 = (i1 + -1 & 255) < 15 ? 16 - (i1 & 255) & 255 : 0;
  i11 = i14 + 212 | 0;
  i10 = HEAP32[i11 >> 2] & 67109888;
  i13 = (i10 | 0) != 0 & (i13 & 255) < 5 ? 5 : i13;
  i13 = ((i13 & 255) > 8 ? 8 : i13) & 255;
  HEAP32[i14 + 480 >> 2] = i13;
  i4 = i14 + 492 | 0;
  i12 = i14 + 484 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = (i1 | 0) > 0;
  if (!i10) {
   if (i2) {
    d3 = +Math_floor(+(1.0e15 / +(HEAP32[i14 + 680 >> 2] | 0) / +(i1 | 0) + .5));
    i1 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0;
   } else i1 = 1e5;
   _UNITY_png_build_16bit_table(i14, i4, i13, i1);
  } else {
   if (i2) {
    d3 = +Math_floor(+(+(i1 | 0) * (+(HEAP32[i14 + 680 >> 2] | 0) * 1.0e-05) + .5));
    d3 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? +(~~d3 | 0) * 1.0e-05 : 0.0;
   } else d3 = 1.0;
   i9 = 8 - i13 | 0;
   i8 = 1 << i9;
   i2 = 16 - i13 | 0;
   i10 = _UNITY_png_calloc(i14, i8 << 2) | 0;
   HEAP32[i4 >> 2] = i10;
   i1 = 0;
   do {
    HEAP32[i10 + (i1 << 2) >> 2] = _UNITY_png_malloc(i14, 512) | 0;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i8 >>> 0);
   i6 = (1 << i2) + -1 | 0;
   i7 = 255 >>> i13;
   i1 = 0;
   i5 = 0;
   do {
    i4 = i5 * 257 | 0;
    i2 = i4 & 65535;
    i4 = ((((Math_imul(~~+Math_floor(+(+Math_pow(+(+((i4 + 128 | 0) >>> 0) / 65535.0), +d3) * 65535.0 + .5)) & 65535, i6) | 0) + 32768 | 0) >>> 0) / 65535 | 0) + 1 | 0;
    if (i1 >>> 0 < i4 >>> 0) {
     do {
      HEAP16[(HEAP32[i10 + ((i1 & i7) << 2) >> 2] | 0) + (i1 >>> i9 << 1) >> 1] = i2;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i4 | 0));
     i1 = i4;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != 255);
   i2 = i8 << 8;
   if (i1 >>> 0 < i2 >>> 0) do {
    HEAP16[(HEAP32[i10 + ((i1 & i7) << 2) >> 2] | 0) + (i1 >>> i9 << 1) >> 1] = -1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  if (!(HEAP32[i11 >> 2] & 6291584)) return;
  i2 = i14 + 680 | 0;
  d3 = +Math_floor(+(1.0e10 / +(HEAP32[i2 >> 2] | 0) + .5));
  _UNITY_png_build_16bit_table(i14, i14 + 508 | 0, i13, d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0);
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) > 0) {
   d3 = +Math_floor(+(1.0e10 / +(i1 | 0) + .5));
   i1 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0;
  } else i1 = HEAP32[i2 >> 2] | 0;
  _UNITY_png_build_16bit_table(i14, i14 + 504 | 0, i13, i1);
  return;
 }
 i6 = i14 + 484 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  d3 = +Math_floor(+(1.0e15 / +(HEAP32[i14 + 680 >> 2] | 0) / +(i1 | 0) + .5));
  i1 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0;
 } else i1 = 1e5;
 i5 = _UNITY_png_malloc(i14, 256) | 0;
 HEAP32[i4 >> 2] = i5;
 if ((i1 + -95e3 | 0) >>> 0 > 1e4) {
  d3 = +(i1 | 0) * 1.0e-05;
  i2 = 0;
  do {
   if ((i2 + -1 | 0) >>> 0 < 254) i1 = ~~+Math_floor(+(+Math_pow(+(+(i2 >>> 0) / 255.0), +d3) * 255.0 + .5)) & 255; else i1 = i2 & 255;
   HEAP8[i5 + i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 256);
 } else {
  i1 = 0;
  do {
   HEAP8[i5 + i1 >> 0] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
 }
 if (!(HEAP32[i14 + 212 >> 2] & 6291584)) return;
 i5 = i14 + 680 | 0;
 d3 = +Math_floor(+(1.0e10 / +(HEAP32[i5 >> 2] | 0) + .5));
 i1 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0;
 i4 = _UNITY_png_malloc(i14, 256) | 0;
 HEAP32[i14 + 500 >> 2] = i4;
 if ((i1 + -95e3 | 0) >>> 0 > 1e4) {
  d3 = +(i1 | 0) * 1.0e-05;
  i2 = 0;
  do {
   if ((i2 + -1 | 0) >>> 0 < 254) i1 = ~~+Math_floor(+(+Math_pow(+(+(i2 >>> 0) / 255.0), +d3) * 255.0 + .5)) & 255; else i1 = i2 & 255;
   HEAP8[i4 + i2 >> 0] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 256);
 } else {
  i1 = 0;
  do {
   HEAP8[i4 + i1 >> 0] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  d3 = +Math_floor(+(1.0e10 / +(i1 | 0) + .5));
  i1 = d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0;
 } else i1 = HEAP32[i5 >> 2] | 0;
 i4 = _UNITY_png_malloc(i14, 256) | 0;
 HEAP32[i14 + 496 >> 2] = i4;
 if ((i1 + -95e3 | 0) >>> 0 <= 1e4) {
  i1 = 0;
  do {
   HEAP8[i4 + i1 >> 0] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  return;
 }
 d3 = +(i1 | 0) * 1.0e-05;
 i2 = 0;
 do {
  if ((i2 + -1 | 0) >>> 0 < 254) i1 = ~~+Math_floor(+(+Math_pow(+(+(i2 >>> 0) / 255.0), +d3) * 255.0 + .5)) & 255; else i1 = i2 & 255;
  HEAP8[i4 + i2 >> 0] = i1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 256);
 return;
}

function runPostSets238() {
 HEAP32[gb + 213596 >> 2] = fb + 35;
 HEAP32[gb + 213600 >> 2] = fb + 111;
 HEAP32[gb + 213604 >> 2] = fb + 1513;
 HEAP32[gb + 213608 >> 2] = fb + 1514;
 HEAP32[gb + 213612 >> 2] = fb + 112;
 HEAP32[gb + 213616 >> 2] = fb + 1515;
 HEAP32[gb + 12576 >> 2] = (HEAP32[gb + 12576 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12580 >> 2] = (HEAP32[gb + 12580 >> 2] | 0) + (gb + 1081203 | 0);
 HEAP32[gb + 12584 >> 2] = (HEAP32[gb + 12584 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 213624 >> 2] = (HEAP32[gb + 213624 >> 2] | 0) + (gb + 12592 | 0);
 HEAP32[gb + 213628 >> 2] = fb + 3134;
 HEAP32[gb + 213632 >> 2] = fb + 3168;
 HEAP32[gb + 213636 >> 2] = fb + 3068;
 HEAP32[gb + 213640 >> 2] = fb + 36;
 HEAP32[gb + 213644 >> 2] = fb + 37;
 HEAP32[gb + 213648 >> 2] = fb + 113;
 HEAP32[gb + 213652 >> 2] = fb + 1516;
 HEAP32[gb + 213656 >> 2] = fb + 1517;
 HEAP32[gb + 213660 >> 2] = fb + 114;
 HEAP32[gb + 213664 >> 2] = fb + 1518;
 HEAP32[gb + 12592 >> 2] = (HEAP32[gb + 12592 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12596 >> 2] = (HEAP32[gb + 12596 >> 2] | 0) + (gb + 1081232 | 0);
 HEAP32[gb + 12600 >> 2] = (HEAP32[gb + 12600 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 213672 >> 2] = (HEAP32[gb + 213672 >> 2] | 0) + (gb + 12608 | 0);
 HEAP32[gb + 213676 >> 2] = fb + 3134;
 HEAP32[gb + 213680 >> 2] = fb + 3169;
 HEAP32[gb + 213684 >> 2] = fb + 3068;
 HEAP32[gb + 213688 >> 2] = fb + 38;
 HEAP32[gb + 213692 >> 2] = fb + 39;
 HEAP32[gb + 213696 >> 2] = fb + 115;
 HEAP32[gb + 213700 >> 2] = fb + 1519;
 HEAP32[gb + 213704 >> 2] = fb + 1520;
 HEAP32[gb + 213708 >> 2] = fb + 116;
 HEAP32[gb + 213712 >> 2] = fb + 1521;
 HEAP32[gb + 12608 >> 2] = (HEAP32[gb + 12608 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12612 >> 2] = (HEAP32[gb + 12612 >> 2] | 0) + (gb + 1081265 | 0);
 HEAP32[gb + 12616 >> 2] = (HEAP32[gb + 12616 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 213720 >> 2] = (HEAP32[gb + 213720 >> 2] | 0) + (gb + 12624 | 0);
 HEAP32[gb + 213724 >> 2] = fb + 3123;
 HEAP32[gb + 213728 >> 2] = fb + 3170;
 HEAP32[gb + 213732 >> 2] = fb + 3068;
 HEAP32[gb + 213736 >> 2] = fb + 40;
 HEAP32[gb + 213740 >> 2] = fb + 41;
 HEAP32[gb + 213744 >> 2] = fb + 117;
 HEAP32[gb + 213748 >> 2] = fb + 1522;
 HEAP32[gb + 213752 >> 2] = fb + 1523;
 HEAP32[gb + 213756 >> 2] = fb + 118;
 HEAP32[gb + 213760 >> 2] = fb + 1524;
 HEAP32[gb + 12624 >> 2] = (HEAP32[gb + 12624 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12628 >> 2] = (HEAP32[gb + 12628 >> 2] | 0) + (gb + 1081298 | 0);
 HEAP32[gb + 12632 >> 2] = (HEAP32[gb + 12632 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213768 >> 2] = (HEAP32[gb + 213768 >> 2] | 0) + (gb + 12640 | 0);
 HEAP32[gb + 213772 >> 2] = fb + 3123;
 HEAP32[gb + 213776 >> 2] = fb + 3171;
 HEAP32[gb + 213780 >> 2] = fb + 3068;
 HEAP32[gb + 213784 >> 2] = fb + 42;
 HEAP32[gb + 213788 >> 2] = fb + 43;
 HEAP32[gb + 213792 >> 2] = fb + 119;
 HEAP32[gb + 213796 >> 2] = fb + 1525;
 HEAP32[gb + 213800 >> 2] = fb + 1526;
 HEAP32[gb + 213804 >> 2] = fb + 120;
 HEAP32[gb + 213808 >> 2] = fb + 1527;
 HEAP32[gb + 12640 >> 2] = (HEAP32[gb + 12640 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12644 >> 2] = (HEAP32[gb + 12644 >> 2] | 0) + (gb + 1081332 | 0);
 HEAP32[gb + 12648 >> 2] = (HEAP32[gb + 12648 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213816 >> 2] = (HEAP32[gb + 213816 >> 2] | 0) + (gb + 12656 | 0);
 HEAP32[gb + 213820 >> 2] = fb + 3123;
 HEAP32[gb + 213824 >> 2] = fb + 3172;
 HEAP32[gb + 213828 >> 2] = fb + 3068;
 HEAP32[gb + 213832 >> 2] = fb + 44;
 HEAP32[gb + 213836 >> 2] = fb + 45;
 HEAP32[gb + 213840 >> 2] = fb + 121;
 HEAP32[gb + 213844 >> 2] = fb + 1528;
 HEAP32[gb + 213848 >> 2] = fb + 1529;
 HEAP32[gb + 213852 >> 2] = fb + 122;
 HEAP32[gb + 213856 >> 2] = fb + 1530;
 HEAP32[gb + 12656 >> 2] = (HEAP32[gb + 12656 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12660 >> 2] = (HEAP32[gb + 12660 >> 2] | 0) + (gb + 1081366 | 0);
 HEAP32[gb + 12664 >> 2] = (HEAP32[gb + 12664 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 213864 >> 2] = (HEAP32[gb + 213864 >> 2] | 0) + (gb + 12672 | 0);
 HEAP32[gb + 213868 >> 2] = fb + 3123;
 HEAP32[gb + 213872 >> 2] = fb + 3173;
 HEAP32[gb + 213876 >> 2] = fb + 3068;
 HEAP32[gb + 213880 >> 2] = fb + 46;
 HEAP32[gb + 213884 >> 2] = fb + 47;
 HEAP32[gb + 213888 >> 2] = fb + 123;
 HEAP32[gb + 213892 >> 2] = fb + 1531;
 HEAP32[gb + 213896 >> 2] = fb + 1532;
 HEAP32[gb + 213900 >> 2] = fb + 124;
 HEAP32[gb + 213904 >> 2] = fb + 1533;
 HEAP32[gb + 12672 >> 2] = (HEAP32[gb + 12672 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12676 >> 2] = (HEAP32[gb + 12676 >> 2] | 0) + (gb + 1081400 | 0);
 HEAP32[gb + 12680 >> 2] = (HEAP32[gb + 12680 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 213912 >> 2] = (HEAP32[gb + 213912 >> 2] | 0) + (gb + 12688 | 0);
 HEAP32[gb + 213916 >> 2] = fb + 3134;
 HEAP32[gb + 213920 >> 2] = fb + 3174;
 HEAP32[gb + 213924 >> 2] = fb + 3068;
 HEAP32[gb + 213928 >> 2] = fb + 48;
 HEAP32[gb + 213932 >> 2] = fb + 49;
 HEAP32[gb + 213936 >> 2] = fb + 125;
 runPostSets239();
}

function _fnmatch_internal(i1, i4, i2, i3, i15) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 4 | 0;
 i17 = i18;
 if (!(i15 & 4)) {
  i9 = i1;
  i5 = 4;
 } else if ((HEAP8[i2 >> 0] | 0) == 46) if ((HEAP8[i1 >> 0] | 0) == 46) {
  i9 = i1;
  i5 = 4;
 } else i1 = 1; else {
  i9 = i1;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  L5 : while (1) {
   i5 = 0;
   i6 = _pat_next(i9, i4, i16, i15) | 0;
   switch (i6 | 0) {
   case -2:
    {
     i1 = 1;
     break L4;
    }
   case -5:
    break L5;
   default:
    {}
   }
   i5 = _str_next(i2, i3, i17) | 0;
   if ((i5 | 0) < 1) {
    i5 = 8;
    break;
   }
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = i2 + i1 | 0;
   i1 = i3 - i1 | 0;
   switch (i6 | 0) {
   case -3:
    {
     if (!(_match_bracket(i9, i5) | 0)) {
      i1 = 1;
      break L4;
     }
     break;
    }
   case -4:
    break;
   default:
    if ((i5 | 0) != (i6 | 0)) {
     i1 = 1;
     break L4;
    }
   }
   i5 = HEAP32[i16 >> 2] | 0;
   i9 = i9 + i5 | 0;
   i3 = i1;
   i4 = i4 - i5 | 0;
   i5 = 4;
  }
  if ((i5 | 0) == 8) {
   i1 = (i6 | 0) != 0 & 1;
   break;
  }
  i1 = i9 + 1 | 0;
  i7 = _strnlen(i1, i4 + -1 | 0) | 0;
  i10 = i9 + (i7 + 1) | 0;
  L16 : do if ((i7 | 0) > 0) {
   i8 = i10;
   i5 = 1;
   i6 = 1;
   i4 = 0;
   while (1) {
    i14 = i9 + i6 | 0;
    switch (_pat_next(i14, i8 - i14 | 0, i16, i15) | 0) {
    case -2:
     {
      i1 = 1;
      break L4;
     }
    case -5:
     {
      i4 = 0;
      i5 = i6 + 1 | 0;
      break;
     }
    default:
     i4 = i4 + 1 | 0;
    }
    i6 = i6 + (HEAP32[i16 >> 2] | 0) | 0;
    if ((i6 | 0) > (i7 | 0)) {
     i6 = i4;
     i11 = i5;
     break L16;
    }
   }
  } else {
   i6 = 0;
   i11 = 1;
  } while (0);
  i14 = i9 + i11 | 0;
  i4 = _strnlen(i2, i3) | 0;
  i9 = i2 + i4 | 0;
  if (i4 >>> 0 < i6 >>> 0) i1 = 1; else {
   i3 = (i6 | 0) != 0;
   if ((i4 | 0) > 0 & i3) {
    i4 = i9;
    i7 = i6;
    do {
     i3 = i4 + -1 | 0;
     i6 = HEAP8[i3 >> 0] | 0;
     if (i6 << 24 >> 24 > -1) i4 = i3; else {
      i5 = i4 + -1 | 0;
      if (i5 >>> 0 > i2 >>> 0 & (i6 & -64) << 24 >> 24 == -128) while (1) {
       i3 = i5 + -1 | 0;
       if (i3 >>> 0 > i2 >>> 0 ? (HEAP8[i4 + -2 >> 0] & -64) << 24 >> 24 == -128 : 0) {
        i4 = i5;
        i5 = i3;
       } else {
        i4 = i3;
        break;
       }
      } else i4 = i5;
     }
     i7 = i7 + -1 | 0;
     i3 = (i7 | 0) != 0;
    } while (i4 >>> 0 > i2 >>> 0 & i3);
   } else i4 = i9;
   if (i3) i1 = 1; else {
    i13 = i14;
    i3 = _pat_next(i14, i10 - i13 | 0, i16, i15) | 0;
    i6 = HEAP32[i16 >> 2] | 0;
    i12 = i4;
    i5 = _str_next(i4, i9 - i12 | 0, i17) | 0;
    L36 : do if ((i5 | 0) >= 1) {
     i7 = i6;
     i8 = i14 + i6 | 0;
     while (1) {
      i4 = i4 + (HEAP32[i17 >> 2] | 0) | 0;
      switch (i3 | 0) {
      case -3:
       {
        if (!(_match_bracket(i8 + (0 - i7) | 0, i5) | 0)) {
         i1 = 1;
         break L4;
        }
        break;
       }
      case -4:
       break;
      default:
       if ((i5 | 0) != (i3 | 0)) {
        i1 = 1;
        break L4;
       }
      }
      i3 = _pat_next(i8, i10 - i8 | 0, i16, i15) | 0;
      i6 = HEAP32[i16 >> 2] | 0;
      i5 = _str_next(i4, i9 - i4 | 0, i17) | 0;
      if ((i5 | 0) < 1) break L36; else {
       i7 = i6;
       i8 = i8 + i6 | 0;
      }
     }
    } while (0);
    if (!i3) if ((i11 | 0) > 1) while (1) {
     i8 = i13 - i1 | 0;
     i5 = _pat_next(i1, i8, i16, i15) | 0;
     i4 = HEAP32[i16 >> 2] | 0;
     i3 = i1 + i4 | 0;
     L48 : do if ((i5 | 0) == -5) i1 = i3; else while (1) {
      i6 = i2;
      i7 = i5;
      i5 = i3;
      L51 : while (1) {
       i3 = _str_next(i6, i12 - i6 | 0, i17) | 0;
       if (!i3) {
        i1 = 1;
        break L4;
       }
       switch (i7 | 0) {
       case -3:
        {
         if (!(_match_bracket(i5 + (0 - i4) | 0, i3) | 0)) break L51;
         break;
        }
       case -4:
        break;
       default:
        if ((i3 | 0) != (i7 | 0)) break L51;
       }
       i3 = i6 + (HEAP32[i17 >> 2] | 0) | 0;
       i7 = _pat_next(i5, i13 - i5 | 0, i16, i15) | 0;
       i4 = HEAP32[i16 >> 2] | 0;
       i5 = i5 + i4 | 0;
       if ((i7 | 0) == -5) {
        i2 = i3;
        i1 = i5;
        break L48;
       } else i6 = i3;
      }
      if ((_str_next(i2, i12 - i2 | 0, i17) | 0) > 0) i2 = i2 + (HEAP32[i17 >> 2] | 0) | 0; else do i2 = i2 + 1 | 0; while ((_str_next(i2, i12 - i2 | 0, i17) | 0) < 0);
      i5 = _pat_next(i1, i8, i16, i15) | 0;
      i4 = HEAP32[i16 >> 2] | 0;
      i3 = i1 + i4 | 0;
      if ((i5 | 0) == -5) {
       i1 = i3;
       break;
      }
     } while (0);
     if (i1 >>> 0 >= i14 >>> 0) {
      i1 = 0;
      break;
     }
    } else i1 = 0; else i1 = 1;
   }
  }
 } while (0);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 24 | 0;
 i4 = i6;
 switch (i2 | 0) {
 case 1:
  {
   i7 = __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_10StartEventEEEbRT_(i7, i5) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 case 2:
  {
   i7 = __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_9StopEventEEEbRT_(i7, i5) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 case 3:
  {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = HEAP32[i7 + 8 >> 2] | 0;
   i3 = i2 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 660679 | 0, i4, HEAPU8[i3 >> 0] & 3);
   i1 = (HEAP8[i1 + 8 >> 0] | 0) == 0;
   if (i1) {
    i13 = HEAP32[i7 >> 2] | 0;
    i12 = i13 + 16 | 0;
    i11 = i12;
    i8 = i4;
    i3 = (HEAP8[i3 >> 0] & 3) == 3;
    i8 = _i64Add((i3 ? 0 : HEAP32[i11 >> 2] | 0) | 0, (i3 ? 0 : HEAP32[i11 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
    i3 = getTempRet0() | 0;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i3;
    i12 = i4;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i3;
    i12 = HEAP32[i7 + 12 >> 2] | 0;
    i11 = HEAP32[i13 + 8 >> 2] | 0;
    i9 = i13;
    i10 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i4 = HEAP8[i13 + 13 >> 0] | 0;
    i7 = HEAP8[i13 + 12 >> 0] | 0;
    i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    mftCall_viiiiiiiii(i13 | 0, i12 | 0, i5 | 0, i11 | 0, i10 | 0, i9 | 0, i4 | 0, i7 | 0, i8 | 0, i3 | 0);
   }
   i13 = i1;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 4:
  {
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   i2 = i1 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 660679 | 0, i4, HEAPU8[i2 >> 0] & 3);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i11 = HEAP32[i7 >> 2] | 0;
    i9 = i11 + 16 | 0;
    i13 = i9;
    i12 = i4;
    i8 = (HEAP8[i2 >> 0] & 3) == 3;
    i12 = _i64Add((i8 ? 0 : HEAP32[i13 >> 2] | 0) | 0, (i8 ? 0 : HEAP32[i13 + 4 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
    i13 = getTempRet0() | 0;
    HEAP32[i9 >> 2] = i12;
    HEAP32[i9 + 4 >> 2] = i13;
    HEAP32[i4 >> 2] = i12;
    HEAP32[i4 + 4 >> 2] = i13;
    i4 = HEAP32[i7 + 12 >> 2] | 0;
    i7 = HEAP32[i11 + 8 >> 2] | 0;
    i9 = i11;
    i8 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i10 = HEAP8[i11 + 13 >> 0] | 0;
    i11 = HEAP8[i11 + 12 >> 0] | 0;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    mftCall_viiiiiiiii(i2 | 0, i4 | 0, i5 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
   }
   i13 = i3;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 5:
  {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i4, i2, i1);
   i2 = (HEAP8[i2 + 8 >> 0] | 0) == 0;
   if (i2) {
    i9 = HEAP32[i7 + 12 >> 2] | 0;
    i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    i10 = HEAP32[i4 + 16 >> 2] | 0;
    i12 = i4 + 8 | 0;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i4;
    i13 = _bitshift64Shl(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, 48) | 0;
    i13 = _bitshift64Ashr(i13 | 0, getTempRet0() | 0, 48) | 0;
    mftCall_viiiiiii(i8 | 0, i9 | 0, i5 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, getTempRet0() | 0);
   }
   i13 = i2;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 6:
  {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i5, i1, HEAP32[i7 + 8 >> 2] | 0);
   i1 = (HEAP8[i1 + 8 >> 0] | 0) == 0;
   if (i1) {
    i12 = HEAP32[i7 + 12 >> 2] | 0;
    i13 = i5;
    f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    mftCall_viiifiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, +f14, HEAP32[i5 + 12 >> 2] | 0, HEAP32[i5 + 16 >> 2] | 0, HEAP32[i5 + 20 >> 2] | 0);
   }
   i13 = i1;
   STACKTOP = i6;
   return i13 | 0;
  }
 default:
  {
   i13 = 0;
   STACKTOP = i6;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 24 | 0;
 i4 = i6;
 switch (i2 | 0) {
 case 1:
  {
   i7 = __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_10StartEventEEEbRT_(i7, i5) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 case 2:
  {
   i7 = __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_9StopEventEEEbRT_(i7, i5) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 case 3:
  {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = HEAP32[i7 + 8 >> 2] | 0;
   i3 = i2 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 660679 | 0, i4, HEAPU8[i3 >> 0] & 3);
   i1 = (HEAP8[i1 + 8 >> 0] | 0) == 0;
   if (i1) {
    i13 = HEAP32[i7 >> 2] | 0;
    i12 = i13 + 16 | 0;
    i11 = i12;
    i8 = i4;
    i3 = (HEAP8[i3 >> 0] & 3) == 3;
    i8 = _i64Add((i3 ? 0 : HEAP32[i11 >> 2] | 0) | 0, (i3 ? 0 : HEAP32[i11 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
    i3 = getTempRet0() | 0;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i3;
    i12 = i4;
    HEAP32[i12 >> 2] = i8;
    HEAP32[i12 + 4 >> 2] = i3;
    i12 = HEAP32[i7 + 12 >> 2] | 0;
    i11 = HEAP32[i13 + 8 >> 2] | 0;
    i9 = i13;
    i10 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i4 = HEAP8[i13 + 13 >> 0] | 0;
    i7 = HEAP8[i13 + 12 >> 0] | 0;
    i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    mftCall_viiiiiiiii(i13 | 0, i12 | 0, i5 | 0, i11 | 0, i10 | 0, i9 | 0, i4 | 0, i7 | 0, i8 | 0, i3 | 0);
   }
   i13 = i1;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 4:
  {
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   i2 = i1 + 1 | 0;
   __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 660679 | 0, i4, HEAPU8[i2 >> 0] & 3);
   i3 = (HEAP8[i3 + 8 >> 0] | 0) == 0;
   if (i3) {
    i11 = HEAP32[i7 >> 2] | 0;
    i9 = i11 + 16 | 0;
    i13 = i9;
    i12 = i4;
    i8 = (HEAP8[i2 >> 0] & 3) == 3;
    i12 = _i64Add((i8 ? 0 : HEAP32[i13 >> 2] | 0) | 0, (i8 ? 0 : HEAP32[i13 + 4 >> 2] | 0) | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
    i13 = getTempRet0() | 0;
    HEAP32[i9 >> 2] = i12;
    HEAP32[i9 + 4 >> 2] = i13;
    HEAP32[i4 >> 2] = i12;
    HEAP32[i4 + 4 >> 2] = i13;
    i4 = HEAP32[i7 + 12 >> 2] | 0;
    i7 = HEAP32[i11 + 8 >> 2] | 0;
    i9 = i11;
    i8 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i10 = HEAP8[i11 + 13 >> 0] | 0;
    i11 = HEAP8[i11 + 12 >> 0] | 0;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    mftCall_viiiiiiiii(i2 | 0, i4 | 0, i5 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0);
   }
   i13 = i3;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 5:
  {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i4, i2, i1);
   i2 = (HEAP8[i2 + 8 >> 0] | 0) == 0;
   if (i2) {
    i9 = HEAP32[i7 + 12 >> 2] | 0;
    i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0;
    HEAP16[i5 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
    HEAP8[i5 + 2 >> 0] = 1;
    i10 = HEAP32[i4 + 16 >> 2] | 0;
    i12 = i4 + 8 | 0;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i4;
    i13 = _bitshift64Shl(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, 48) | 0;
    i13 = _bitshift64Ashr(i13 | 0, getTempRet0() | 0, 48) | 0;
    mftCall_viiiiiii(i8 | 0, i9 | 0, i5 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, getTempRet0() | 0);
   }
   i13 = i2;
   STACKTOP = i6;
   return i13 | 0;
  }
 case 6:
  {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i5, i1, HEAP32[i7 + 8 >> 2] | 0);
   i1 = (HEAP8[i1 + 8 >> 0] | 0) == 0;
   if (i1) {
    i12 = HEAP32[i7 + 12 >> 2] | 0;
    i13 = i5;
    f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    mftCall_viiifiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, +f14, HEAP32[i5 + 12 >> 2] | 0, HEAP32[i5 + 16 >> 2] | 0, HEAP32[i5 + 20 >> 2] | 0);
   }
   i13 = i1;
   STACKTOP = i6;
   return i13 | 0;
  }
 default:
  {
   i13 = 0;
   STACKTOP = i6;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN16GeometryJobTasks30ScheduleDynamicVBOGeometryJobsER9GfxDevicePFvP25DynamicVBOGeometryJobDatajEPFvS3_ES3_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle(i13, i9, i15, i16, i17, i18, i10, i11) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i14 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 8 | 0;
 i1 = i20;
 if ((HEAP16[gb + 1157668 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157668 | 0, i12);
  i14 = gb + 1157668 | 0;
 } else i14 = 0;
 i1 = i13 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483520) >>> 0 < 128) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = 128;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, 4096, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] << 5 | 0) | 0;
  HEAP32[i1 >> 2] = 128;
  HEAP32[i13 >> 2] = i8;
  break;
 } while (0);
 i7 = HEAP32[i17 >> 2] | 0;
 i6 = HEAP32[i7 + 16 >> 2] | 0;
 if (i18 >>> 0 > 1) {
  i5 = 1;
  i1 = i6;
  do {
   i4 = HEAP32[i7 + (i5 * 20 | 0) + 16 >> 2] | 0;
   L13 : do if ((i1 | 0) != (i4 | 0)) {
    L15 : do if (!i1) if (!i4) {
     i1 = 0;
     break L13;
    } else i2 = i4; else {
     i3 = i4;
     i2 = i1;
     while (1) {
      i3 = (i3 >>> 0) % (i2 >>> 0) | 0;
      if (!i3) break L15;
      i2 = (i2 >>> 0) % (i3 >>> 0) | 0;
      if (!i2) {
       i2 = i3;
       break;
      }
     }
    } while (0);
    i1 = Math_imul((i1 >>> 0) / (i2 >>> 0) | 0, i4) | 0;
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i18 | 0));
 } else i1 = i6;
 i8 = (i18 | 0) == 0;
 L23 : do if (i8) {
  i2 = -1;
  i6 = 0;
 } else {
  i2 = -1;
  i3 = 0;
  i5 = 0;
  i4 = i6;
  while (1) {
   i21 = i4 + i2 | 0;
   i2 = Math_imul(HEAP32[i7 + (i5 * 20 | 0) + 8 >> 2] | 0, i4) | 0;
   i3 = (HEAP32[i7 + (i5 * 20 | 0) + 12 >> 2] | 0) + i3 | 0;
   i6 = i5 + 1 | 0;
   i2 = i21 + ~((i21 >>> 0) % (i4 >>> 0) | 0) + i2 | 0;
   if ((i6 | 0) == (i18 | 0)) {
    i6 = i3;
    break L23;
   }
   i5 = i6;
   i4 = HEAP32[i7 + (i6 * 20 | 0) + 16 >> 2] | 0;
  }
 } while (0);
 i21 = i2 + i1 | 0;
 i5 = (i21 >>> 0) / (i1 >>> 0) | 0;
 if (i6 | 0 ? 1 : i1 >>> 0 <= (i21 - ((i21 >>> 0) % (i1 >>> 0) | 0) | 0) >>> 0) {
  i3 = i9 + 4512 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 896 >> 2] | 0, i9 | 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i5 | 0, i6 | 0, i10 | 0, i11 | 0) | 0;
 }
 i9 = i13 + 20 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i2 = HEAP32[i17 + 8 >> 2] & 16777215;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > (HEAP32[i13 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy(i13, i1, i12, 0);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  if (HEAP32[i13 + 24 >> 2] | 0) i19 = 28;
 } else i19 = 28;
 if ((i19 | 0) == 28) {
  HEAP32[i1 + (i2 << 5) + 24 >> 2] = i5;
  HEAP32[i1 + (i2 << 5) + 28 >> 2] = i6;
 }
 L45 : do if (!i8) {
  i8 = i13 + 24 | 0;
  i3 = 0;
  i2 = 0;
  i7 = 0;
  i1 = i4;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   if (!i1) {
    if (HEAP32[i8 >> 2] | 0) i19 = 34;
   } else i19 = 34;
   if ((i19 | 0) == 34) {
    i19 = 0;
    i21 = HEAP32[i4 + (i2 * 20 | 0) + 16 >> 2] | 0;
    i3 = i3 + -1 + i21 | 0;
    i3 = i3 - ((i3 >>> 0) % (i21 >>> 0) | 0) | 0;
   }
   i5 = HEAP32[i4 + (i2 * 20 | 0) + 8 >> 2] | 0;
   HEAP32[i4 + (i2 * 20 | 0) >> 2] = (i5 | 0) == 0 ? 0 : i1 + i3 | 0;
   i6 = HEAP32[i4 + (i2 * 20 | 0) + 12 >> 2] | 0;
   if (!i6) i1 = 0; else i1 = (HEAP32[i8 >> 2] | 0) + (i7 << 1) | 0;
   HEAP32[i4 + (i2 * 20 | 0) + 4 >> 2] = i1;
   i1 = HEAP32[i4 + (i2 * 20 | 0) + 16 >> 2] | 0;
   mftCall_vii(i15 | 0, i17 | 0, i2 | 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i18 | 0)) break L45;
   i3 = (Math_imul(i5, i1) | 0) + i3 | 0;
   i7 = i6 + i7 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
 } while (0);
 if (i16 | 0) mftCall_vi(i16 | 0, i17 | 0);
 if (!i14) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i20;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i13, i1, i18, i19, i12, i20) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 32 | 0;
 i22 = i24 + 16 | 0;
 i23 = i24;
 if (i12 >>> 0 >= i20 >>> 0) {
  STACKTOP = i24;
  return;
 }
 i14 = i1 + 520 | 0;
 i15 = i21 + 4 | 0;
 i16 = i21 + 8 | 0;
 i17 = i21 + 12 | 0;
 i2 = i1 + 500 | 0;
 i3 = i22 + 4 | 0;
 i4 = i22 + 8 | 0;
 i5 = i22 + 12 | 0;
 i6 = i19 + 4 | 0;
 i7 = i19 + 8 | 0;
 i8 = i19 + 12 | 0;
 i9 = i23 + 4 | 0;
 i10 = i23 + 8 | 0;
 i11 = i23 + 12 | 0;
 i1 = i12;
 do {
  i38 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i38 >> 2]);
  f34 = Math_fround(HEAPF32[i38 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i38 + 8 >> 2]);
  f34 = Math_fround(f34 * Math_fround(.00999999977));
  f35 = Math_fround(f35 * Math_fround(.00999999977));
  f36 = Math_fround(Math_fround(HEAPF32[i38 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i21 >> 2] = Math_fround(f32 * Math_fround(.00999999977));
  HEAPF32[i15 >> 2] = f34;
  HEAPF32[i16 >> 2] = f35;
  HEAPF32[i17 >> 2] = f36;
  i38 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i12 = HEAP32[i38 >> 2] | 0;
  i28 = HEAP32[i38 + 4 >> 2] | 0;
  i33 = HEAP32[i38 + 8 >> 2] | 0;
  i38 = HEAP32[i38 + 12 >> 2] | 0;
  i30 = i12 + 1793934638 | 0;
  i43 = i28 + 1793934638 | 0;
  i41 = i33 + 1793934638 | 0;
  i39 = i38 + 1793934638 | 0;
  i26 = (Math_imul(i30, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
  i40 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i30 = i30 << 11 ^ i30;
  i43 = i43 << 11 ^ i43;
  i41 = i41 << 11 ^ i41;
  i39 = i39 << 11 ^ i39;
  f36 = Math_fround(Math_fround((i42 ^ i43 ^ i43 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i40 ^ i41 ^ i41 >>> 8) & 8388607 ^ i40 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f34 = Math_fround(Math_fround((i37 ^ i39 ^ i39 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i22 >> 2] = Math_fround(Math_fround((i26 ^ i30 ^ i30 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f36;
  HEAPF32[i4 >> 2] = f35;
  HEAPF32[i5 >> 2] = f34;
  i12 = i12 + -13913692 | 0;
  i28 = i28 + -13913692 | 0;
  i33 = i33 + -13913692 | 0;
  i38 = i38 + -13913692 | 0;
  i26 = (Math_imul(i12, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i39 = (Math_imul(i38, 1790253981) | 0) + 1900727103 | 0;
  i12 = i12 << 11 ^ i12;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i38 = i38 << 11 ^ i38;
  f34 = Math_fround(Math_fround((i26 ^ i12 ^ i12 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f36 = Math_fround(Math_fround((i37 ^ i33 ^ i33 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f32 = Math_fround(Math_fround((i39 ^ i38 ^ i38 >>> 8) & 8388607 ^ i39 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i39 = f34 > Math_fround(HEAPF32[i19 >> 2]);
  i38 = f35 > Math_fround(HEAPF32[i6 >> 2]);
  i37 = f36 > Math_fround(HEAPF32[i7 >> 2]);
  i33 = f32 > Math_fround(HEAPF32[i8 >> 2]);
  i30 = i18 + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i30 + 4 | 0;
  f36 = Math_fround(HEAPF32[i28 >> 2]);
  i26 = i30 + 8 | 0;
  f35 = Math_fround(HEAPF32[i26 >> 2]);
  i12 = i30 + 12 | 0;
  f34 = Math_fround(HEAPF32[i12 >> 2]);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i23, i13, i21, i22);
  f31 = Math_fround(HEAPF32[i23 >> 2]);
  f31 = Math_fround((i39 ? Math_fround(1.0) : Math_fround(-1.0)) * f31);
  f29 = Math_fround(HEAPF32[i9 >> 2]);
  f29 = Math_fround((i38 ? Math_fround(1.0) : Math_fround(-1.0)) * f29);
  f27 = Math_fround(HEAPF32[i10 >> 2]);
  f27 = Math_fround((i37 ? Math_fround(1.0) : Math_fround(-1.0)) * f27);
  f25 = Math_fround(HEAPF32[i11 >> 2]);
  f29 = Math_fround(f36 + f29);
  f27 = Math_fround(f35 + f27);
  f25 = Math_fround(f34 + Math_fround((i33 ? Math_fround(1.0) : Math_fround(-1.0)) * f25));
  HEAPF32[i30 >> 2] = Math_fround(f32 + f31);
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i26 >> 2] = f27;
  HEAPF32[i12 >> 2] = f25;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i20 >>> 0);
 STACKTOP = i24;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i15, i1, i6, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 8 | 0;
 i12 = i17;
 i14 = i15 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i13) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i15 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i11 = HEAP32[i15 + 20 >> 2] | 0;
    i11 = (mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i11;
    i1 = HEAP32[i15 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i11;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i11 = HEAP32[i15 >> 2] | 0;
   HEAP8[(HEAP32[i11 + 4 >> 2] | 0) + ((HEAP32[i11 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i11 = i15 + 36 | 0;
 L12 : do if (HEAP8[i11 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i15, gb + 830924 | 0);
  if (!(HEAP8[i11 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i15 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i11 >> 0] = i1;
  }
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i10 = HEAP32[i15 >> 2] | 0;
  HEAP8[(HEAP32[i10 + 4 >> 2] | 0) + ((HEAP32[i10 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i8 = i15 + 20 | 0;
   i9 = i15 + 40 | 0;
   i10 = i15 + 24 | 0;
   i4 = i6 + 12 | 0;
   i6 = i13 + 255 | 0;
   f5 = Math_fround(0.0);
   i7 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i16 = 24; else {
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) i16 = 24; else {
      do {
       if (!(_isspace(i2 & 255) | 0)) break;
       i1 = i1 + 1 | 0;
       i2 = HEAP8[i1 >> 0] | 0;
      } while (i2 << 24 >> 24 != 0);
      _memset(i13 | 0, 0, 256) | 0;
      HEAP32[i12 >> 2] = i6;
      i2 = HEAP8[i1 >> 0] | 0;
      L27 : do if (!(i2 << 24 >> 24)) i1 = i13; else if (!(_isspace(i2 & 255) | 0)) {
       i3 = i1;
       i2 = i13;
       while (1) {
        i1 = i2 + 1 | 0;
        HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
        i3 = i3 + 1 | 0;
        i2 = HEAP8[i3 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L27;
        i18 = HEAP32[i12 >> 2] | 0;
        if (!(i1 >>> 0 < i18 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
       }
      } else i1 = i13; while (0);
      HEAP8[i1 >> 0] = 0;
      f5 = Math_fround(+_strtod(i13, i12));
     }
    }
    if ((i16 | 0) == 24) {
     i16 = 0;
     HEAP8[HEAP32[i9 >> 2] >> 0] = 1;
    }
    mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i7 | 0, +f5);
    if (!(HEAP8[i11 >> 0] | 0)) break L12;
    i18 = HEAP32[i8 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 24 >> 2] | 0, i18 | 0) | 0) i7 = i7 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i7 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i7 >>> 0) {
  i6 = i15 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i16 = 31;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i11 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i11 >> 0] = 0;
  } while (i1 >>> 0 > i7 >>> 0);
  if ((i16 | 0) == 31) HEAP8[i11 >> 0] = 1;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i17;
 return;
}

function __ZN12TreeRenderer14ClearRenderersEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i7 + 236 | 0;
 i2 = i7 + 252 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 240 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 248 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i7 + 204 | 0;
 HEAP32[gb + 1467256 >> 2] = i8;
 i4 = i7 + 256 | 0;
 i5 = i7 + 268 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 * 24 | 0) >> 2] | 0;
   if (i2) {
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[gb + 1467256 >> 2] = 0;
 i1 = i7 + 272 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i7 + 260 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 276 | 0;
 i2 = i7 + 292 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 280 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 288 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN15LODGroupManager19ClearInternalArraysEv(i7 + 304 | 0);
 HEAP32[gb + 1467256 >> 2] = i8;
 i4 = i7 + 400 | 0;
 i5 = i7 + 412 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 * 24 | 0) >> 2] | 0;
   if (i2) {
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[gb + 1467256 >> 2] = 0;
 i1 = i7 + 416 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i7 + 404 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 420 | 0;
 i2 = i7 + 436 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 424 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 432 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i7 + 380 | 0;
 i6 = i7 + 392 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i4 = 0;
  do {
   i1 = __ZN20SpeedTreeWindManager11GetInstanceEv() | 0;
   __ZN20SpeedTreeWindManager15DeleteLocalWindEP18SpeedTreeLocalWind(i1, HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 * 88 | 0) + 32 >> 2] | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1 + (i4 * 88 | 0) + 80 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    i11 = i3 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    if (!(HEAP32[i11 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
    }
    HEAP32[i2 >> 2] = 0;
   }
   i1 = i1 + (i4 * 88 | 0) + 84 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i11 = i2 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    if (!(HEAP32[i11 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
    }
    HEAP32[i1 >> 2] = 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i1 = i7 + 396 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i7 + 384 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i7 + 364 >> 2] | 0;
 i5 = i7 + 368 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1 + -44 | 0;
  HEAP32[i5 >> 2] = i2;
  i3 = i1 + -40 | 0;
  if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -36 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 i4 = i7 + 212 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[(HEAP32[i7 + 208 >> 2] | 0) + 4 >> 2] | 0;
 i1 = i2;
 if ((i1 | 0) != (i8 | 0)) {
  i3 = i1;
  do {
   i11 = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 + 8 >> 2] | 0, i11 + 20 | 0);
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
  } while ((i3 | 0) != (i8 | 0));
  i2 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
  i2 = i7 + 216 | 0;
  i3 = i9 + 4 | 0;
  do {
   i11 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   i7 = HEAP32[i2 >> 2] | 0;
   HEAP32[i9 >> 2] = 72;
   HEAP32[i3 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
  } while ((i1 | 0) != (i8 | 0));
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 + 12 >> 2] = HEAP32[i11 + 8 >> 2];
 STACKTOP = i10;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i8 = i16 + 36 | 0;
 i12 = i16 + 16 | 0;
 i7 = i16 + 12 | 0;
 i5 = i16 + 32 | 0;
 i6 = i16 + 28 | 0;
 i11 = i16;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 24 | 0;
 i3 = i1;
 if (i4 >>> 0 >= i9 >>> 0) {
  if (i4 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i3 + (i9 * 24 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = i9 * 24 | 0;
  i4 = (i3 | 0) / 24 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i11 + 8 | 0;
   i8 = i11;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if (i4 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i6 = __Znwj(i3) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i11 >> 2] = i6;
   i9 = i11 + 8 | 0;
   HEAP32[i9 >> 2] = i6 + (i4 * 24 | 0);
   HEAP32[i12 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i11, i8, i15, i4);
   i6 = i10;
   i7 = i9;
   i8 = i11;
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  i14 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i4;
  i4 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i15 + 4 | 0;
    while (1) {
     i1 = i2 + -24 | 0;
     HEAP32[i10 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i14 = HEAP32[i2 + -12 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i3 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 24 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE8__appendEj(i13, i9 - i4 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE7reserveEj(i12, i9);
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i12, i8, i15);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 24 | 0;
 i1 = i2;
 if (i3 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE8__appendEj(i12, i9 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i9 >>> 0) {
  i4 = i4 + (i9 * 24 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i2 = i1 + -24 | 0;
    HEAP32[i10 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + -12 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
   }
  }
 }
 i4 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i4;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i12 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i1 = i2 + -24 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i14 = HEAP32[i2 + -12 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN14NavMeshManager6UpdateEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 8 | 0;
 i18 = i21;
 i19 = i21 + 16 | 0;
 if (!(HEAP32[i17 + 112 >> 2] | 0)) {
  STACKTOP = i21;
  return;
 }
 if ((HEAP16[gb + 1459200 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459200 | 0, i15);
  i16 = gb + 1459200 | 0;
 } else i16 = 0;
 i1 = HEAP32[i17 + 104 >> 2] | 0;
 if (i1 | 0) __ZN14NavMeshCarving17ApplyCarveResultsEv(i1);
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i18;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i19 >> 2] = 0;
 i11 = i19 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i19 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i18);
 i4 = i15;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = i3;
 i14 = i17 + 40 | 0;
 i3 = HEAP32[(HEAP32[gb + 1459032 >> 2] | 0) + 108 >> 2] | 0;
 i4 = i17 + 52 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i5 = __ZNK12NavMeshAgent27GetInternalAnimationPolyRefEv(HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i6 = getTempRet0() | 0;
   if (!((i5 | 0) == 0 & (i6 | 0) == 0)) {
    HEAP32[i15 >> 2] = 0;
    __ZNK9dtNavMesh26getOffMeshConnectionUserIdEyPj(i3, i5, i6, i15) | 0;
    if (HEAP32[i15 >> 2] | 0) {
     i7 = HEAP32[i11 >> 2] | 0;
     i8 = i7 + 1 | 0;
     i9 = HEAP32[i12 >> 2] | 0;
     i10 = i9 & 2147483647;
     do if (i8 >>> 0 > i10 >>> 0) {
      i2 = i9 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
       HEAP32[i12 >> 2] = i2;
       HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i2 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i10 | 0, HEAP32[i19 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i12 >> 2] = i2;
       HEAP32[i19 >> 2] = i10;
       break;
      }
     } while (0);
     HEAP32[i11 >> 2] = i8;
     i10 = HEAP32[i19 >> 2] | 0;
     HEAP32[i10 + (i7 * 12 | 0) >> 2] = i1;
     i9 = _bitshift64Lshr(i5 | 0, i6 | 0, 20) | 0;
     getTempRet0() | 0;
     HEAP32[i10 + (i7 * 12 | 0) + 4 >> 2] = i9 & 268435455;
     HEAP32[i10 + (i7 * 12 | 0) + 8 >> 2] = HEAP32[i15 >> 2];
    }
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 __ZN14NavMeshManager18UpdateOffMeshLinksEv(i17);
 if (HEAP32[i11 >> 2] | 0) {
  i5 = 0;
  do {
   i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i5 * 12 | 0) + 8 >> 2] | 0;
   do if (i4 | 0) {
    HEAP32[i18 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i20 = 26; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i18);
      i2 = HEAP32[i15 >> 2] | 0;
      i10 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i20 = 26; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i20 = 28;
     }
    }
    if ((i20 | 0) == 26) i20 = 28;
    if ((i20 | 0) == 28) {
     i20 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
     if (!i1) break;
    }
    if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 169336 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 169336 + 28 >> 2] | 0) >>> 0)) {
     i2 = i1 + 40 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!((i1 | 0) == 0 & (i2 | 0) == 0)) __ZN12NavMeshAgent27SetInternalAnimationPolyRefEy(HEAP32[(HEAP32[i14 >> 2] | 0) + (HEAP32[(HEAP32[i19 >> 2] | 0) + (i5 * 12 | 0) >> 2] << 2) >> 2] | 0, i1, i2);
    }
   } while (0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 __ZN14NavMeshManager17UpdateCrowdSystemEv(i17);
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i13);
  HEAP32[i19 >> 2] = 0;
 }
 if (!i16) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i21;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 88 | 0;
 i2 = i1 + 100 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 116 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 132 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 164 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 188 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 212 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 228 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 248 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 264 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 280 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 292 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 296 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 308 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 312 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 328 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 340 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 344 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService18CloudServiceConfigaSERKS1_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 i6 = i8 + 20 | 0;
 i1 = i9 + 20 | 0;
 if ((i8 | 0) == (i9 | 0)) return i8 | 0;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i3 ? HEAP32[i9 + 24 >> 2] | 0 : i5 & 255;
 i3 = i6 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i8 + 28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i5 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i8 + 24 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i5 - i4 | 0, i1, 0, i1, i5, i7);
 } else {
  if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  if (i5 | 0) _memmove(i1 | 0, i7 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 24 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i8 + 36 | 0;
 i6 = i9 + 36 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 40 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 44 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 40 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 40 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i1 = i8 + 52 | 0;
 i6 = i9 + 52 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 56 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 60 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 56 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 56 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i1 = i8 + 68 | 0;
 i6 = i9 + 68 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 72 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 76 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 72 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 72 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i1 = i8 + 84 | 0;
 i6 = i9 + 84 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 88 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 92 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 88 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 88 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i8 + 100 | 0, HEAP32[i9 + 100 >> 2] | 0, HEAP32[i9 + 104 >> 2] | 0);
 return i8 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = ((HEAP32[i15 >> 2] | 0) - i2 | 0) / 12 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i12 >>> 0) {
  if (i3 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i5 = i1 + (i12 * 12 | 0) | 0;
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i8 = i13 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i9 = i13 + 12 | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i12 * 12 | 0;
  i4 = (i3 | 0) / 12 | 0;
  if (!i3) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i2 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i13 >> 2] = i2;
   i6 = i2 + (i4 * 12 | 0) | 0;
   i7 = i13 + 8 | 0;
   HEAP32[i7 >> 2] = i6;
   i3 = i2;
   if (!i12) {
    i4 = i7;
    i5 = i3;
    i2 = i3;
    i1 = i6;
   } else {
    do {
     HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     i1 = i1 + 12 | 0;
     i2 = (HEAP32[i8 >> 2] | 0) + 12 | 0;
     HEAP32[i8 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i7;
    i5 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
   i15 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if ((((HEAP32[i8 >> 2] | 0) - i2 | 0) / 12 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i14, i12 - i3 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 * 12 | 0, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 * 12 | 0);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = (i1 - i4 | 0) / 12 | 0;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 * 12 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~(((i5 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (i1) i1 = 0; else {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = HEAP32[i3 + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = i5;
  i5 = HEAP32[i3 + 16 >> 2] | 0;
  i1 = HEAP32[i3 + 20 >> 2] | 0;
  i4 = HEAP32[i3 + 24 >> 2] | 0;
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = i5;
  HEAP32[i2 + 20 >> 2] = i1;
  HEAP32[i2 + 24 >> 2] = i4;
  i4 = HEAP32[i3 + 32 >> 2] | 0;
  i1 = HEAP32[i3 + 36 >> 2] | 0;
  HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i2 + 32 >> 2] = i4;
  HEAP32[i2 + 36 >> 2] = i1;
  i1 = 0;
  do {
   i5 = HEAP32[i3 + 68 + (i1 << 6) + 4 >> 2] | 0;
   i6 = HEAP32[i3 + 68 + (i1 << 6) + 8 >> 2] | 0;
   HEAP32[i2 + 68 + (i1 << 6) >> 2] = HEAP32[i3 + 68 + (i1 << 6) >> 2];
   HEAP32[i2 + 68 + (i1 << 6) + 4 >> 2] = i5;
   HEAP32[i2 + 68 + (i1 << 6) + 8 >> 2] = i6;
   i6 = HEAP32[i3 + 68 + (i1 << 6) + 16 >> 2] | 0;
   i5 = HEAP32[i3 + 68 + (i1 << 6) + 20 >> 2] | 0;
   i4 = HEAP32[i3 + 68 + (i1 << 6) + 24 >> 2] | 0;
   HEAP32[i2 + 68 + (i1 << 6) + 12 >> 2] = HEAP32[i3 + 68 + (i1 << 6) + 12 >> 2];
   HEAP32[i2 + 68 + (i1 << 6) + 16 >> 2] = i6;
   HEAP32[i2 + 68 + (i1 << 6) + 20 >> 2] = i5;
   HEAP32[i2 + 68 + (i1 << 6) + 24 >> 2] = i4;
   i4 = HEAP32[i3 + 68 + (i1 << 6) + 32 >> 2] | 0;
   i5 = HEAP32[i3 + 68 + (i1 << 6) + 36 >> 2] | 0;
   HEAP32[i2 + 68 + (i1 << 6) + 28 >> 2] = HEAP32[i3 + 68 + (i1 << 6) + 28 >> 2];
   HEAP32[i2 + 68 + (i1 << 6) + 32 >> 2] = i4;
   HEAP32[i2 + 68 + (i1 << 6) + 36 >> 2] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4);
  i1 = 0;
 }
 do {
  HEAP32[i2 + 596 + (i1 << 2) >> 2] = HEAP32[i3 + 596 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 52);
 HEAP32[i2 + 364 >> 2] = HEAP32[i3 + 364 >> 2];
 HEAP32[i2 + 368 >> 2] = HEAP32[i3 + 368 >> 2];
 HEAP32[i2 + 372 >> 2] = HEAP32[i3 + 372 >> 2];
 HEAP32[i2 + 376 >> 2] = HEAP32[i3 + 376 >> 2];
 HEAP32[i2 + 380 >> 2] = HEAP32[i3 + 380 >> 2];
 HEAP32[i2 + 384 >> 2] = HEAP32[i3 + 384 >> 2];
 HEAP32[i2 + 388 >> 2] = HEAP32[i3 + 388 >> 2];
 HEAP32[i2 + 392 >> 2] = HEAP32[i3 + 392 >> 2];
 HEAP32[i2 + 396 >> 2] = HEAP32[i3 + 396 >> 2];
 HEAP32[i2 + 400 >> 2] = HEAP32[i3 + 400 >> 2];
 HEAP32[i2 + 404 >> 2] = HEAP32[i3 + 404 >> 2];
 HEAP32[i2 + 408 >> 2] = HEAP32[i3 + 408 >> 2];
 HEAP32[i2 + 412 >> 2] = HEAP32[i3 + 412 >> 2];
 HEAP32[i2 + 416 >> 2] = HEAP32[i3 + 416 >> 2];
 HEAP32[i2 + 420 >> 2] = HEAP32[i3 + 420 >> 2];
 HEAP32[i2 + 424 >> 2] = HEAP32[i3 + 424 >> 2];
 HEAP32[i2 + 428 >> 2] = HEAP32[i3 + 428 >> 2];
 HEAP32[i2 + 432 >> 2] = HEAP32[i3 + 432 >> 2];
 HEAP32[i2 + 436 >> 2] = HEAP32[i3 + 436 >> 2];
 HEAP32[i2 + 440 >> 2] = HEAP32[i3 + 440 >> 2];
 HEAP32[i2 + 500 >> 2] = HEAP32[i3 + 500 >> 2];
 HEAP32[i2 + 504 >> 2] = HEAP32[i3 + 504 >> 2];
 HEAP32[i2 + 508 >> 2] = HEAP32[i3 + 508 >> 2];
 HEAP32[i2 + 512 >> 2] = HEAP32[i3 + 512 >> 2];
 HEAP32[i2 + 516 >> 2] = HEAP32[i3 + 516 >> 2];
 HEAP32[i2 + 520 >> 2] = HEAP32[i3 + 520 >> 2];
 HEAP32[i2 + 524 >> 2] = HEAP32[i3 + 524 >> 2];
 HEAP32[i2 + 528 >> 2] = HEAP32[i3 + 528 >> 2];
 HEAP32[i2 + 532 >> 2] = HEAP32[i3 + 532 >> 2];
 HEAP32[i2 + 536 >> 2] = HEAP32[i3 + 536 >> 2];
 HEAP32[i2 + 540 >> 2] = HEAP32[i3 + 540 >> 2];
 HEAP32[i2 + 544 >> 2] = HEAP32[i3 + 544 >> 2];
 HEAP32[i2 + 548 >> 2] = HEAP32[i3 + 548 >> 2];
 HEAP32[i2 + 552 >> 2] = HEAP32[i3 + 552 >> 2];
 HEAP32[i2 + 556 >> 2] = HEAP32[i3 + 556 >> 2];
 HEAP32[i2 + 560 >> 2] = HEAP32[i3 + 560 >> 2];
 HEAP32[i2 + 564 >> 2] = HEAP32[i3 + 564 >> 2];
 HEAP32[i2 + 568 >> 2] = HEAP32[i3 + 568 >> 2];
 HEAP32[i2 + 572 >> 2] = HEAP32[i3 + 572 >> 2];
 HEAP32[i2 + 576 >> 2] = HEAP32[i3 + 576 >> 2];
 i5 = HEAP32[i3 + 808 >> 2] | 0;
 i6 = HEAP32[i3 + 812 >> 2] | 0;
 HEAP32[i2 + 804 >> 2] = HEAP32[i3 + 804 >> 2];
 HEAP32[i2 + 808 >> 2] = i5;
 HEAP32[i2 + 812 >> 2] = i6;
 i6 = HEAP32[i3 + 820 >> 2] | 0;
 i5 = HEAP32[i3 + 824 >> 2] | 0;
 HEAP32[i2 + 816 >> 2] = HEAP32[i3 + 816 >> 2];
 HEAP32[i2 + 820 >> 2] = i6;
 HEAP32[i2 + 824 >> 2] = i5;
 i5 = HEAP32[i3 + 832 >> 2] | 0;
 i6 = HEAP32[i3 + 836 >> 2] | 0;
 HEAP32[i2 + 828 >> 2] = HEAP32[i3 + 828 >> 2];
 HEAP32[i2 + 832 >> 2] = i5;
 HEAP32[i2 + 836 >> 2] = i6;
 i6 = HEAP32[i3 + 844 >> 2] | 0;
 i5 = HEAP32[i3 + 848 >> 2] | 0;
 HEAP32[i2 + 840 >> 2] = HEAP32[i3 + 840 >> 2];
 HEAP32[i2 + 844 >> 2] = i6;
 HEAP32[i2 + 848 >> 2] = i5;
 i5 = HEAP32[i3 + 856 >> 2] | 0;
 i6 = HEAP32[i3 + 860 >> 2] | 0;
 HEAP32[i2 + 852 >> 2] = HEAP32[i3 + 852 >> 2];
 HEAP32[i2 + 856 >> 2] = i5;
 HEAP32[i2 + 860 >> 2] = i6;
 i6 = HEAP32[i3 + 868 >> 2] | 0;
 i5 = HEAP32[i3 + 872 >> 2] | 0;
 HEAP32[i2 + 864 >> 2] = HEAP32[i3 + 864 >> 2];
 HEAP32[i2 + 868 >> 2] = i6;
 HEAP32[i2 + 872 >> 2] = i5;
 i5 = HEAP32[i3 + 880 >> 2] | 0;
 i6 = HEAP32[i3 + 884 >> 2] | 0;
 HEAP32[i2 + 876 >> 2] = HEAP32[i3 + 876 >> 2];
 HEAP32[i2 + 880 >> 2] = i5;
 HEAP32[i2 + 884 >> 2] = i6;
 return;
}

function __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i12, i3, i5, i6, i7, i8) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i1 = i12 + 5912 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i11 = i12 + 5652 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i1 + 1;
 } else {
  i11 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i11;
  i1 = HEAP32[i12 + 5656 + (i11 << 2) >> 2] | 0;
 }
 i11 = i12 + 2320 + (i1 * 48 | 0) | 0;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 38 >> 0] = 0;
 i9 = i12 + 2320 + (i1 * 48 | 0) + 39 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 35 >> 0] = i3;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 36 >> 0] = i5;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 37 >> 0] = i6;
 HEAP32[i12 + 2320 + (i1 * 48 | 0) + 28 >> 2] = 0;
 HEAP32[i12 + 2320 + (i1 * 48 | 0) + 24 >> 2] = 0;
 HEAP32[i12 + 2320 + (i1 * 48 | 0) + 20 >> 2] = 0;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 34 >> 0] = -1;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 33 >> 0] = -1;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 32 >> 0] = -1;
 i10 = i11;
 HEAP8[i12 + 2320 + (i1 * 48 | 0) + 40 >> 0] = i1;
 f28 = Math_fround(HEAPF32[i12 + 272 + (i3 << 4) >> 2]);
 f27 = Math_fround(HEAPF32[i12 + 272 + (i3 << 4) + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i12 + 272 + (i3 << 4) + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i12 + 272 + (i5 << 4) >> 2]);
 f23 = Math_fround(HEAPF32[i12 + 272 + (i5 << 4) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i12 + 272 + (i5 << 4) + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i12 + 272 + (i6 << 4) >> 2]);
 f19 = Math_fround(HEAPF32[i12 + 272 + (i6 << 4) + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i12 + 272 + (i6 << 4) + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i12 + 1296 + (i3 << 4) >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 1296 + (i3 << 4) + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i12 + 1296 + (i3 << 4) + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i12 + 1296 + (i5 << 4) >> 2]);
 f20 = Math_fround(HEAPF32[i12 + 1296 + (i5 << 4) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i12 + 1296 + (i5 << 4) + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i12 + 1296 + (i6 << 4) >> 2]);
 f25 = Math_fround(HEAPF32[i12 + 1296 + (i6 << 4) + 4 >> 2]);
 f16 = Math_fround(f28 - f16);
 f4 = Math_fround(f27 - f4);
 f17 = Math_fround(f15 - f17);
 f18 = Math_fround(f22 - f18);
 f20 = Math_fround(f23 - f20);
 f14 = Math_fround(f21 - f14);
 f26 = Math_fround(f13 - f26);
 f25 = Math_fround(f19 - f25);
 f24 = Math_fround(f24 - Math_fround(HEAPF32[i12 + 1296 + (i6 << 4) + 8 >> 2]));
 f19 = Math_fround(f18 - f16);
 f13 = Math_fround(f20 - f4);
 f21 = Math_fround(f14 - f17);
 f23 = Math_fround(f26 - f16);
 f22 = Math_fround(f25 - f4);
 f15 = Math_fround(f24 - f17);
 f18 = Math_fround(f26 - f18);
 f20 = Math_fround(f25 - f20);
 f14 = Math_fround(f24 - f14);
 i6 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f13 * f13)) + Math_fround(f21 * f21)) > Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)) + Math_fround(f15 * f15));
 f19 = i6 ? f23 : f19;
 f13 = i6 ? f22 : f13;
 f21 = i6 ? f15 : f21;
 f15 = Math_fround(Math_fround(f14 * f13) - Math_fround(f20 * f21));
 f14 = Math_fround(Math_fround(f18 * f21) - Math_fround(f14 * f19));
 f13 = Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f13));
 f18 = Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)));
 i6 = f18 > Math_fround(1.1920929e-07);
 f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(i6 ? f18 : Math_fround(1.0)))));
 f15 = Math_fround(f18 * f15);
 f14 = Math_fround(f18 * f14);
 f13 = Math_fround(f18 * f13);
 f4 = Math_fround(Math_fround(f17 * f13) + Math_fround(Math_fround(f16 * f15) + Math_fround(f4 * f14)));
 HEAPF32[i11 >> 2] = f15;
 HEAPF32[i12 + 2320 + (i1 * 48 | 0) + 4 >> 2] = f14;
 HEAPF32[i12 + 2320 + (i1 * 48 | 0) + 8 >> 2] = f13;
 HEAPF32[i12 + 2320 + (i1 * 48 | 0) + 12 >> 2] = Math_fround(0.0);
 i5 = i12 + 2320 + (i1 * 48 | 0) + 16 | 0;
 HEAPF32[i5 >> 2] = f4;
 i7 = f4 >= Math_fround(HEAPF32[i7 >> 2]);
 if (!(i6 & (i7 & Math_fround(HEAPF32[i8 >> 2]) >= f4))) {
  i12 = 0;
  HEAP8[i9 >> 0] = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 L8 : do if (!i1) i1 = 0; else {
  i2 = (i1 + -1 | 0) >>> 1;
  i3 = HEAP32[i12 + 4 + (i2 << 2) >> 2] | 0;
  if (f4 < Math_fround(HEAPF32[i3 + 16 >> 2])) while (1) {
   HEAP32[i12 + 4 + (i1 << 2) >> 2] = i3;
   if (!i2) {
    i1 = 0;
    break L8;
   }
   f28 = Math_fround(HEAPF32[i5 >> 2]);
   i1 = (i2 + -1 | 0) >>> 1;
   i3 = HEAP32[i12 + 4 + (i1 << 2) >> 2] | 0;
   if (!(f28 < Math_fround(HEAPF32[i3 + 16 >> 2]))) {
    i1 = i2;
    break;
   } else {
    i8 = i2;
    i2 = i1;
    i1 = i8;
   }
  }
 } while (0);
 HEAP32[i12 + 4 + (i1 << 2) >> 2] = i10;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i12 = 1;
 HEAP8[i9 >> 0] = i12;
 return i11 | 0;
}

function __ZN5physx7NpScene9visualizeEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 120 | 0;
 i6 = i20 + 56 | 0;
 i8 = i20 + 28 | 0;
 i18 = i20 + 80 | 0;
 i17 = i20;
 HEAP32[i9 + 3484 >> 2] = 0;
 HEAP32[i9 + 3496 >> 2] = 0;
 HEAP32[i9 + 3508 >> 2] = 0;
 HEAP32[i9 + 3520 >> 2] = 0;
 HEAP32[i9 + 3532 >> 2] = 0;
 if (Math_fround(+mftCall_fii(HEAP32[(HEAP32[i9 >> 2] | 0) + 296 >> 2] | 0, i9 | 0, 0)) == Math_fround(0.0)) {
  STACKTOP = i20;
  return;
 }
 i1 = i9 + 3476 | 0;
 i3 = i19 + 36 | 0;
 i4 = i19;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i16 = i19 + 40 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAPF32[i19 + 56 >> 2] = Math_fround(1.0);
 i16 = i19 + 60 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAPF32[i19 + 76 >> 2] = Math_fround(1.0);
 i16 = i19 + 80 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAPF32[i19 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i19 + 100 >> 2] = i1;
 f2 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i9 >> 2] | 0) + 296 >> 2] | 0, i9 | 0, 1));
 if (f2 != Math_fround(0.0)) {
  HEAPF32[i6 >> 2] = f2;
  HEAPF32[i6 + 4 >> 2] = f2;
  HEAPF32[i6 + 8 >> 2] = f2;
  HEAP32[i6 + 12 >> 2] = -65536;
  HEAP32[i6 + 16 >> 2] = -16711936;
  HEAP32[i6 + 20 >> 2] = -16776961;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i19, i6) | 0;
 }
 i1 = i9 + 3568 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i9 + 3564 | 0;
  i4 = 0;
  do {
   __ZN5physx14NpArticulation9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0, i19, i9);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i3 = HEAP32[i9 + 3552 >> 2] | 0;
 i1 = HEAP32[i9 + 3556 >> 2] | 0;
 i7 = i3 + (i1 << 2) | 0;
 i4 = i9 + 3656 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i9 + 3652 | 0;
  i6 = 0;
  do {
   i16 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 492 >> 2] | 0, i16 | 0, i19 | 0, i9 | 0);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if (i1 | 0) do {
  i16 = HEAP32[i3 >> 2] | 0;
  i16 = (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0) == 1;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i16) __ZN5physx14NpRigidDynamic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i1, i19, i9); else __ZN5physx13NpRigidStatic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i1, i19, i9);
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i7 | 0));
 i16 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i9 >> 2] | 0) + 296 >> 2] | 0, i9 | 0, 18)) != Math_fround(0.0);
 i1 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i9 >> 2] | 0) + 296 >> 2] | 0, i9 | 0, 19)) != Math_fround(0.0);
 if (i16) {
  i3 = HEAP32[i9 + 3404 >> 2] | 0;
  if (i3 | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, i19 | 0, -16776961);
 }
 if (i1) {
  i1 = HEAP32[i9 + 3408 >> 2] | 0;
  if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i19 | 0, -65536);
 }
 if (Math_fround(+mftCall_fii(HEAP32[(HEAP32[i9 >> 2] | 0) + 296 >> 2] | 0, i9 | 0, 36)) != Math_fround(0.0)) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i19, i8) | 0;
  i1 = i9 + 16 | 0;
  i3 = __ZNK5physx3Scb5Scene22getNbBroadPhaseRegionsEv(i1) | 0;
  if (i3 | 0) {
   i4 = i18 + 36 | 0;
   i5 = i17 + 4 | 0;
   i6 = i18 + 4 | 0;
   i7 = i17 + 8 | 0;
   i8 = i18 + 8 | 0;
   i9 = i17 + 12 | 0;
   i10 = i18 + 12 | 0;
   i11 = i17 + 16 | 0;
   i12 = i18 + 16 | 0;
   i13 = i17 + 20 | 0;
   i14 = i18 + 20 | 0;
   i15 = i17 + 24 | 0;
   i16 = 0;
   do {
    __ZNK5physx3Scb5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i1, i18, 1, i16) | 0;
    if (!(HEAP8[i4 >> 0] | 0)) __ZN5physx2Cm12RenderOutputlsEj(i19, -16777216) | 0; else __ZN5physx2Cm12RenderOutputlsEj(i19, -256) | 0;
    HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAP8[i15 >> 0] = 1;
    __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i19, i17) | 0;
    i16 = i16 + 1 | 0;
   } while ((i16 | 0) != (i3 | 0));
  }
 }
 STACKTOP = i20;
 return;
}

function __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 64 | 0;
 i6 = i12 + 16 | 0;
 i8 = i12 + 48 | 0;
 i9 = i12;
 __ZNK16CrashReportEvent12ToJsonStringEv(i6, i1);
 i3 = HEAP32[i6 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? i6 + 4 | 0 : i3;
 HEAP32[i11 >> 2] = 0;
 i4 = i11 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i10 = i11 + 24 | 0;
 i1 = gb + 64016 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 i5 = i11 + 4 | 0;
 HEAP8[i5 >> 0] = 0;
 i2 = _strlen(i3) | 0;
 if (i2 >>> 0 > 15) {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i10, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 4 >> 2] = i2;
  i1 = (i1 | 0) == 0 ? i5 : i1;
 } else i1 = i5;
 _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 HEAP32[i4 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6 + 24 | 0);
 i6 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63160 | 0, 16, gb + 1039560 | 0, 64) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 __ZN16UploadHandlerRawC2EPKvj(i6, (i1 | 0) == 0 ? i5 : i1, HEAP32[i4 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1047160 | 0, 16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6 + 12 | 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i4 = __ZN22UnityWebRequestManager21CreateUnityWebRequestEv() | 0;
 i1 = i7 + 4 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i7 + 8 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, i1);
 i3 = i4 + 108 | 0;
 if ((HEAP32[i3 >> 2] | 0) == 1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4 + 76 | 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((HEAP32[i3 >> 2] | 0) == 1) {
  i1 = i4 + 92 | 0;
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
   HEAP32[i4 + 96 >> 2] = 0;
  } else {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i4 + 88 >> 2] = 1;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1047147 | 0, 12);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1047160 | 0, 16);
 if ((HEAP32[i3 >> 2] | 0) == 1) __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i4 + 44 | 0, i8, i9, 1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 do if ((HEAP32[i3 >> 2] | 0) == 1) {
  i1 = i4 + 72 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN13UploadHandler7ReleaseEv(i2);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = i6;
  if (i6 | 0) __ZN13UploadHandler6RetainEv(i6);
  if ((HEAP32[i3 >> 2] | 0) == 1) {
   i9 = __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE7PrepareEv(i4) | 0;
   i1 = i4 + 104 | 0;
   HEAP32[i1 >> 2] = i9;
   if ((i9 | 0) == 1 | (i9 | 1 | 0) != 1) {
    __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv(i4);
    break;
   }
   i9 = __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE9DoRequestEv(i4) | 0;
   HEAP32[i1 >> 2] = i9;
   if (i9 | 0) __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv(i4);
  }
 } while (0);
 i9 = i4 + 4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (!(HEAP32[i9 >> 2] | 0)) {
  __ZN19TransportJavaScript5AbortEv(i4 + 8 | 0);
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63808 | 0);
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 if (!(HEAP32[i11 + 4 >> 2] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i12;
 return 1;
}

function __ZN11AssetBundle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i7 = i3 + 24 | 0;
 i11 = i3 + 20 | 0;
 i6 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i12 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 365509 | 0, i12, i1 + 48 | 0, 0);
 HEAP32[i11 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37176 >> 2] | 0, i11, 0);
 i10 = i9 + 8 | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i11, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450717 | 0, HEAP32[gb + 37052 >> 2] | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags(i2, i10, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIN11AssetBundle9AssetInfoEEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 365497 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 365534 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 365557 | 0, i10, i1 + 168 | 0, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 i8 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470499 | 0, i12, i1 + 172 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i6);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i11, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN14ConstantStringD2Ev(i6);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 365575 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i1);
 STACKTOP = i3;
 return;
}

function __ZN29ParticleSystemPropertyBindingC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 >> 2] = gb + 83048 + 8;
 i5 = i1 + 4 | 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i1 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i25 = i1 + 20 | 0;
 HEAP32[i25 >> 2] = gb + 80240 + 8;
 i24 = i1 + 24 | 0;
 HEAP32[i24 >> 2] = gb + 82412 + 8;
 i23 = i1 + 28 | 0;
 HEAP32[i23 >> 2] = gb + 82432 + 8;
 i22 = i1 + 32 | 0;
 HEAP32[i22 >> 2] = gb + 82452 + 8;
 i21 = i1 + 36 | 0;
 HEAP32[i21 >> 2] = gb + 82492 + 8;
 i20 = i1 + 40 | 0;
 HEAP32[i20 >> 2] = gb + 82472 + 8;
 i19 = i1 + 44 | 0;
 HEAP32[i19 >> 2] = gb + 82512 + 8;
 i18 = i1 + 48 | 0;
 HEAP32[i18 >> 2] = gb + 82532 + 8;
 i17 = i1 + 52 | 0;
 HEAP32[i17 >> 2] = gb + 82552 + 8;
 i16 = i1 + 56 | 0;
 HEAP32[i16 >> 2] = gb + 82572 + 8;
 i15 = i1 + 60 | 0;
 HEAP32[i15 >> 2] = gb + 82592 + 8;
 i14 = i1 + 64 | 0;
 HEAP32[i14 >> 2] = gb + 82612 + 8;
 i13 = i1 + 68 | 0;
 HEAP32[i13 >> 2] = gb + 82632 + 8;
 i12 = i1 + 72 | 0;
 HEAP32[i12 >> 2] = gb + 82652 + 8;
 i11 = i1 + 76 | 0;
 HEAP32[i11 >> 2] = gb + 82672 + 8;
 i10 = i1 + 80 | 0;
 HEAP32[i10 >> 2] = gb + 82692 + 8;
 i9 = i1 + 84 | 0;
 HEAP32[i9 >> 2] = gb + 82712 + 8;
 i8 = i1 + 88 | 0;
 HEAP32[i8 >> 2] = gb + 82732 + 8;
 i7 = i1 + 92 | 0;
 HEAP32[i7 >> 2] = gb + 82752 + 8;
 i1 = i1 + 96 | 0;
 HEAP32[i1 >> 2] = gb + 82772 + 8;
 __ZN35ClampVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i25, i5);
 __ZN31CollisionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i24, i5);
 __ZN34ColorBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i23, i5);
 __ZN27ColorModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i22, i5);
 __ZN36ExternalForcesModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i21, i5);
 __ZN30EmissionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i20, i5);
 __ZN27ForceModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i19, i5);
 __ZN37InheritVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i18, i5);
 __ZN29InitialModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i17, i5);
 __ZN28LightsModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i16, i5);
 __ZN27NoiseModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i15, i5);
 __ZN37RotationBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i14, i5);
 __ZN30RotationModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i13, i5);
 __ZN27ShapeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i12, i5);
 __ZN33SizeBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i11, i5);
 __ZN26SizeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i10, i5);
 __ZN27TrailModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i9, i5);
 __ZN29TriggerModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i8, i5);
 __ZN24UVModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i7, i5);
 __ZN30VelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i1, i5);
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
 __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i4, i1, i3);
 STACKTOP = i2;
 return;
}

function __ZN6Skybox8SetupSunERK6CameraR9GfxDevice(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i7 = i16 + 256 | 0;
 i15 = i16 + 116 | 0;
 i2 = __ZNK14RenderSettings6GetSunEv(__Z17GetRenderSettingsv() | 0) | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i9 = i7 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i10 = i7 + 8 | 0;
 HEAPF32[i10 >> 2] = Math_fround(-1.0);
 if (!i2) {
  i8 = 0;
  i3 = 0;
  i6 = 0;
  i5 = 0;
  i4 = 0;
  i2 = 0;
  i1 = -1082130432;
 } else {
  if (!(HEAP32[gb + 1113448 >> 2] | 0)) {
   i5 = HEAP32[i2 + 44 >> 2] | 0;
   i1 = HEAP32[i5 + 156 >> 2] | 0;
   i3 = HEAP32[i5 + 160 >> 2] | 0;
   i4 = HEAP32[i5 + 164 >> 2] | 0;
   i5 = HEAP32[i5 + 168 >> 2] | 0;
  } else {
   i1 = 0;
   i3 = 0;
   i4 = 0;
   i5 = 0;
  }
  __ZNK9Transform18TransformDirectionERK8Vector3f(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i7);
  HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  i8 = i1;
  i6 = i4;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i14 + 564 >> 2] = i8;
 HEAP32[i14 + 568 >> 2] = i3;
 HEAP32[i14 + 572 >> 2] = i6;
 HEAP32[i14 + 576 >> 2] = i5;
 HEAP32[i14 + 548 >> 2] = i4;
 HEAP32[i14 + 552 >> 2] = i2;
 HEAP32[i14 + 556 >> 2] = i1;
 HEAPF32[i14 + 560 >> 2] = Math_fround(0.0);
 __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext(0, 0, HEAP32[gb + 1166248 >> 2] | 0);
 i4 = i15 + 8 | 0;
 HEAP32[i15 + 12 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 33952 + 8;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i17 = i13;
 HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i17 + 4 >> 2] = i10;
 HEAP32[i15 + 40 >> 2] = 0;
 i17 = i15 + 52 | 0;
 HEAP32[i17 >> 2] = 0;
 i10 = i15 + 56 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i15 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i8 = i12;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i11;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 i5 = gb + 64016 | 0;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i15 + 60 >> 2] = 0;
 HEAP32[i15 + 72 >> 2] = 0;
 i8 = i15 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i15 + 64 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i5 = i12;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i15 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i15 + 92 >> 2] = 0;
 i6 = i15 + 96 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i15 + 84 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i15 + 100 >> 2] = 0;
 HEAP32[i15 + 104 >> 2] = 0;
 i2 = gb + 64016 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i15 + 108 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP8[i15 + 116 >> 0] = 1;
 i1 = i15 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 35824 + 8;
 i1 = i13;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i15 + 120 >> 2] = 0;
 i1 = i15 + 132 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i15 + 136 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i15 + 124 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i19 = i12;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i13 = i3;
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i13 + 4 >> 2] = i18;
 __ZN28ApplyBuiltinInstanceProperty4InitER9GfxDevice(i15, i14);
 __ZN20SphericalHarmonicsL27SetZeroEv(i12);
 __Z14SetSHConstantsR28ApplyBuiltinInstancePropertyRK20SphericalHarmonicsL2(i15, i12);
 if (HEAP32[i17 >> 2] | HEAP32[i1 >> 2] | 0) __ZN28ApplyBuiltinInstanceProperty22PerformFlushPropertiesEv(i15);
 HEAP32[i4 >> 2] = gb + 35824 + 8;
 i1 = i15 + 120 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i7);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i15 + 60 | 0;
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i15 + 40 | 0;
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i11);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN11Rigidbody2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 4);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 68 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802708 | 0, i9, i8, 8388608);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802719 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802731 | 0, i6, i1 + 50 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802758 | 0, i6, i1 + 49 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827258 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802772 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802447 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802785 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946425 | 0, gb + 801759 | 0, i6, 0);
 i7 = i8 + 8 | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 56 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802800 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 60 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802814 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 64 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802829 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802850 | 0, i6, i1 + 52 | 0, 4194304);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i5 = i1 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP8[i4 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 1 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 2 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 3 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 4 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 5 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 6 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 7 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 8 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 9 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 10 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 11 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 12 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 13 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 14 >> 0] = i1;
 i1 = i4 + 15 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i7 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i5;
  HEAP32[i7 >> 2] = i3;
  i7 = i5;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN20UnityConnectSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i7 = i3 + 4 | 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i6, i1 + 196 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041676 | 0, i6, i1 + 197 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i10 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041687 | 0, i10, i1 + 200 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 i8 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041702 | 0, i10, i1 + 216 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041718 | 0, gb + 1041718 | 0, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041874 | 0, i10, i1 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041741 | 0, gb + 1041741 | 0, i1 + 56 | 0, 0);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041676 | 0, i6, i1 + 65 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041765 | 0, gb + 1041765 | 0, i4, 0);
 __ZN22UnityAnalyticsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 112 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041788 | 0, gb + 1041788 | 0, i1, 0);
 __ZN16UnityAdsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i1, i11, i16, i17, i15) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i18 + 16 | 0;
 i26 = i18;
 i28 = HEAP32[i1 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 i9 = i11 + 4 | 0;
 f21 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i11 + 8 | 0;
 f6 = Math_fround(-f6);
 f21 = Math_fround(-f21);
 f20 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
 i25 = HEAP32[i1 + 12 >> 2] | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f6);
 i22 = i25 + 4 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f21));
 i7 = i25 + 8 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f20));
 i24 = i25 + 16 | 0;
 f19 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f6);
 i2 = i25 + 20 | 0;
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f21));
 i8 = i25 + 24 | 0;
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f20));
 i23 = i25 + 32 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * f6);
 i5 = i25 + 36 | 0;
 f21 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f21));
 i3 = i25 + 40 | 0;
 f20 = Math_fround(f21 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f20));
 HEAPF32[i27 >> 2] = f4;
 HEAPF32[i27 + 4 >> 2] = f19;
 HEAPF32[i27 + 8 >> 2] = f20;
 HEAPF32[i27 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i26, i28, i27);
 f20 = Math_fround(HEAPF32[i25 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i25 + 52 >> 2]);
 f4 = Math_fround(HEAPF32[i25 + 56 >> 2]);
 f21 = Math_fround(HEAPF32[i26 >> 2]);
 f6 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f12 = Math_fround(f21 * Math_fround(HEAPF32[i25 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i24 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i23 >> 2])));
 f13 = Math_fround(f21 * Math_fround(HEAPF32[i22 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i5 >> 2])));
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i7 >> 2]));
 f6 = Math_fround(f21 + Math_fround(f6 * Math_fround(HEAPF32[i8 >> 2])));
 f12 = Math_fround(f20 + f12);
 f13 = Math_fround(f19 + f13);
 f14 = Math_fround(f4 + Math_fround(f6 + Math_fround(f14 * Math_fround(HEAPF32[i3 >> 2]))));
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
   f21 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f21 = Math_fround(f6 + Math_fround(f21 * Math_fround(HEAPF32[i9 >> 2])));
   f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f6 = Math_fround(f21 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f29 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f20 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i11 >> 2]);
    f21 = Math_fround(HEAPF32[i9 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f29 * f19) + Math_fround(f20 * f21)) + Math_fround(f4 * Math_fround(HEAPF32[i10 >> 2])));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i11) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 i26 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i27 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i28 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAPF32[i16 >> 2] = f12;
 HEAPF32[i16 + 4 >> 2] = f13;
 HEAPF32[i16 + 8 >> 2] = f14;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i17 >> 2] = i26;
 HEAP32[i17 + 4 >> 2] = i27;
 HEAP32[i17 + 8 >> 2] = i28;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 f20 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f21 = Math_fround(f13 - (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f29 = Math_fround(f14 - (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i15 >> 2] = f20;
 HEAPF32[i15 + 4 >> 2] = f21;
 HEAPF32[i15 + 8 >> 2] = f29;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i18;
 return;
}

function __ZN5IMGUI10EndWindowsER8GUIStateb(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 116 | 0;
 i15 = i17;
 i16 = HEAP32[i13 + 8 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i1 = i15;
 i2 = i13 + 108 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i9 = HEAP32[i13 + 16 >> 2] | 0;
 i11 = HEAP32[i13 + 20 >> 2] | 0;
 i12 = HEAP32[i13 + 24 >> 2] | 0;
 HEAP32[i15 + 64 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i15 + 68 >> 2] = i9;
 HEAP32[i15 + 72 >> 2] = i11;
 HEAP32[i15 + 76 >> 2] = i12;
 i12 = HEAP32[i13 + 48 >> 2] | 0;
 i11 = HEAP32[i13 + 52 >> 2] | 0;
 i9 = HEAP32[i13 + 56 >> 2] | 0;
 HEAP32[i15 + 80 >> 2] = HEAP32[i13 + 44 >> 2];
 HEAP32[i15 + 84 >> 2] = i12;
 HEAP32[i15 + 88 >> 2] = i11;
 HEAP32[i15 + 92 >> 2] = i9;
 i9 = HEAP32[i13 + 32 >> 2] | 0;
 i11 = HEAP32[i13 + 36 >> 2] | 0;
 i12 = HEAP32[i13 + 40 >> 2] | 0;
 HEAP32[i15 + 96 >> 2] = HEAP32[i13 + 28 >> 2];
 HEAP32[i15 + 100 >> 2] = i9;
 HEAP32[i15 + 104 >> 2] = i11;
 HEAP32[i15 + 108 >> 2] = i12;
 HEAP8[i15 + 112 >> 0] = (HEAP32[i13 + 60 >> 2] | 0) != 0 & 1;
 i12 = HEAP32[i13 + 280 >> 2] | 0;
 L4 : do switch (HEAP32[i12 >> 2] | 0) {
 case 8:
  {
   i11 = i16 + 4 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   i2 = i3 - i5 >> 2;
   L6 : do if (!i2) i1 = 1; else {
    i8 = i16 + 16 | 0;
    i9 = i16 + 12 | 0;
    i1 = 1;
    i4 = i5;
    i6 = i5;
    do {
     i2 = i2 + -1 | 0;
     i5 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
     if (!(HEAP8[i5 + 116 >> 0] | 0)) while (1) {
      if (i5) {
       __ZN5IMGUI9GUIWindowD2Ev(i5);
       __ZdlPv(i5);
       i4 = HEAP32[i16 >> 2] | 0;
       i3 = HEAP32[i11 >> 2] | 0;
      }
      i6 = i4 + (i2 << 2) | 0;
      i4 = i6 + 4 | 0;
      i5 = i3 - i4 | 0;
      i7 = i5 >> 2;
      if (!i7) {
       i5 = i3;
       i4 = i3;
      } else {
       _memmove(i6 | 0, i4 | 0, i5 | 0) | 0;
       i4 = HEAP32[i11 >> 2] | 0;
       i5 = i4;
      }
      i3 = i6 + (i7 << 2) | 0;
      if ((i4 | 0) == (i3 | 0)) i3 = i5; else {
       i3 = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2) | 0;
       HEAP32[i11 >> 2] = i3;
      }
      HEAP8[i8 >> 0] = 1;
      if (!i2) break L6;
      i4 = HEAP32[i16 >> 2] | 0;
      i2 = i2 + -1 | 0;
      i5 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      if (HEAP8[i5 + 116 >> 0] | 0) {
       i6 = i4;
       break;
      }
     }
     i1 = i1 & (HEAP32[i5 >> 2] | 0) != (HEAP32[i9 >> 2] | 0);
    } while ((i2 | 0) != 0);
   } while (0);
   if (!i14) {
    i2 = i16 + 24 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 | 0) if (!(HEAP8[i3 + 116 >> 0] | 0)) {
     __ZN5IMGUI9GUIWindowD2Ev(i3);
     __ZdlPv(i3);
     HEAP32[i2 >> 2] = 0;
    }
   }
   if (i1) HEAP32[i16 + 12 >> 2] = -1;
   if (HEAP8[i16 + 16 >> 0] | 0) {
    i2 = HEAP32[i16 >> 2] | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    HEAP32[i10 >> 2] = fb + 1111;
    __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i2, i1, i10);
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = i2;
    if ((i1 | 0) != (i2 | 0)) {
     i2 = i1 - i2 >> 2;
     i1 = 0;
     do {
      HEAP32[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 68 >> 2] = i1;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
    }
   }
   if (!i14) {
    i1 = HEAP32[i16 + 24 >> 2] | 0;
    if (i1 | 0) __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i1, i13);
   }
   i1 = HEAP32[i16 >> 2] | 0;
   if ((i1 | 0) != (HEAP32[i11 >> 2] | 0)) do {
    __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(HEAP32[i1 >> 2] | 0, i13);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (HEAP32[i11 >> 2] | 0));
   break;
  }
 case 7:
  {
   i6 = i16 + 24 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i16, i13) | 0;
   i3 = HEAP32[i16 >> 2] | 0;
   i2 = (HEAP32[i16 + 4 >> 2] | 0) - i3 >> 2;
   L49 : do if (i2 | 0) {
    i5 = i13 + 276 | 0;
    while (1) {
     i2 = i2 + -1 | 0;
     i3 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
     if ((i3 | 0) == (i1 | 0)) i4 = (HEAP32[i6 >> 2] | 0) == 0; else i4 = 0;
     HEAP8[(HEAP32[i5 >> 2] | 0) + 8 >> 0] = i4 & 1;
     __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i3, i13);
     if (!i2) break L49;
     i3 = HEAP32[i16 >> 2] | 0;
    }
   } while (0);
   if (!i14) if (HEAP32[i6 >> 2] | 0) {
    HEAP8[(HEAP32[i13 + 276 >> 2] | 0) + 8 >> 0] = 0;
    break L4;
   }
   HEAP8[(HEAP32[i13 + 276 >> 2] | 0) + 8 >> 0] = 1;
   break;
  }
 default:
  {}
 } while (0);
 __ZN5IMGUI25RestoreGUIStatePropertiesER8GUIStateR10InputEventRNS_23GUIStatePropertiesCacheE(i13, i12, i15);
 do if ((HEAP32[i12 >> 2] | 0) != 8) {
  if (!i14) if (HEAP32[i16 + 24 >> 2] | 0) break;
  __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i16);
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN12CachedReader16OutOfBoundsErrorEjj(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i6 = i9 + 12 | 0;
 i7 = i9;
 i8 = i3 + 32 | 0;
 if (HEAP8[i8 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 i2 = i1 + i4 | 0;
 i1 = i3 + 12 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0) | 0) >>> 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i11 | 0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i11 = i7 + 11 | 0;
  i10 = HEAP8[i11 >> 0] | 0;
  i10 = i10 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i10 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 468860 | 0, 10, i10 + 10 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i10) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i10 = HEAP8[i6 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i6 + 4 >> 2] | 0 : i10 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i11 ? HEAP32[i6 >> 2] | 0 : i6, i10, i10 + 75 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, gb + 468871 | 0, 75) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 468719 | 0, 214, 32785, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  HEAP8[i8 >> 0] = 1;
 }
 if (i2 >>> 0 > (HEAP32[i3 + 28 >> 2] | 0) >>> 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i10 | 0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i10 = i7 + 11 | 0;
  i11 = HEAP8[i10 >> 0] | 0;
  i11 = i11 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i11 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 468860 | 0, 10, i11 + 10 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i11) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i11 = HEAP8[i6 + 11 >> 0] | 0;
  i10 = i11 << 24 >> 24 < 0;
  i11 = i10 ? HEAP32[i6 + 4 >> 2] | 0 : i11 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i10 ? HEAP32[i6 >> 2] | 0 : i6, i11, i11 + 75 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, gb + 468871 | 0, 75) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 468719 | 0, 220, 32785, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  HEAP8[i8 >> 0] = 1;
 }
 if ((HEAP32[i3 + 24 >> 2] | 0) >>> 0 <= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i10 | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i10 = i7 + 11 | 0;
 i11 = HEAP8[i10 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 468860 | 0, 10, i11 + 10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i11) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i11 = HEAP8[i6 + 11 >> 0] | 0;
 i10 = i11 << 24 >> 24 < 0;
 i11 = i10 ? HEAP32[i6 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i10 ? HEAP32[i6 >> 2] | 0 : i6, i11, i11 + 75 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, gb + 468871 | 0, 75) | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 468719 | 0, 226, 32785, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 HEAP8[i8 >> 0] = 1;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 36 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 36 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 119304647) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 36 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 59652323 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 119304647;
  if (i1 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 36 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 36 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 36 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 36 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP8[i7 + 16 >> 0] = HEAP8[i6 + 16 >> 0] | 0;
   i8 = i8 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 36 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -36 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -24 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 36 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 36 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 119304647) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 36 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 59652323 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 119304647;
  if (i1 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 36 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 36 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 36 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 36 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP8[i7 + 16 >> 0] = HEAP8[i6 + 16 >> 0] | 0;
   i8 = i8 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 36 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -36 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -24 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZN5physx2Gu16getPCMConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i5, i4, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i1 = i5 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 12 >> 2]) == Math_fround(1.0)) i1 = 1; else i6 = 4; else i6 = 4; else i6 = 4;
 if ((i6 | 0) == 4) {
  __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i4, i1, i5 + 16 | 0);
  i1 = 0;
 }
 i5 = i5 + 36 | 0;
 i19 = HEAP32[i5 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i19 >> 2]);
 f31 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f13 = Math_fround(f24 + f31);
 f10 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i19 + 16 >> 2]);
 f32 = Math_fround(f10 + f30);
 f11 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f29 = Math_fround(HEAPF32[i19 + 20 >> 2]);
 f13 = Math_fround(f13 * Math_fround(.5));
 f32 = Math_fround(f32 * Math_fround(.5));
 f21 = Math_fround(Math_fround(f11 + f29) * Math_fround(.5));
 f28 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(f13 * f28);
 i19 = i4 + 4 | 0;
 f26 = Math_fround(HEAPF32[i19 >> 2]);
 f20 = Math_fround(f13 * f26);
 i18 = i4 + 8 | 0;
 f23 = Math_fround(HEAPF32[i18 >> 2]);
 f13 = Math_fround(f13 * f23);
 i17 = i4 + 12 | 0;
 f27 = Math_fround(HEAPF32[i17 >> 2]);
 f34 = Math_fround(f32 * f27);
 i16 = i4 + 16 | 0;
 f25 = Math_fround(HEAPF32[i16 >> 2]);
 f33 = Math_fround(f32 * f25);
 i15 = i4 + 20 | 0;
 f12 = Math_fround(HEAPF32[i15 >> 2]);
 f34 = Math_fround(f9 + f34);
 f33 = Math_fround(f20 + f33);
 f32 = Math_fround(f13 + Math_fround(f32 * f12));
 i14 = i4 + 24 | 0;
 f13 = Math_fround(HEAPF32[i14 >> 2]);
 f20 = Math_fround(f21 * f13);
 i7 = i4 + 28 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f22 = Math_fround(f21 * f9);
 i6 = i4 + 32 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(f34 + f20);
 f22 = Math_fround(f33 + f22);
 f21 = Math_fround(f32 + Math_fround(f21 * f8));
 f24 = Math_fround(Math_fround(f31 - f24) * Math_fround(.5));
 f10 = Math_fround(Math_fround(f30 - f10) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f29 - f11) * Math_fround(.5));
 f13 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f24 * f28))) + Math_fround(Math_abs(Math_fround(f10 * f27)))) + Math_fround(Math_abs(Math_fround(f11 * f13))));
 f9 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f24 * f26))) + Math_fround(Math_abs(Math_fround(f10 * f25)))) + Math_fround(Math_abs(Math_fround(f11 * f9))));
 f8 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f24 * f23))) + Math_fround(Math_abs(Math_fround(f10 * f12)))) + Math_fround(Math_abs(Math_fround(f11 * f8))));
 f11 = Math_fround(f22 - f9);
 f12 = Math_fround(f21 - f8);
 f10 = Math_fround(f20 + f13);
 f9 = Math_fround(f22 + f9);
 f8 = Math_fround(f21 + f8);
 HEAPF32[i2 >> 2] = Math_fround(f20 - f13);
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f12;
 HEAPF32[i2 + 12 >> 2] = f10;
 HEAPF32[i2 + 16 >> 2] = f9;
 HEAPF32[i2 + 20 >> 2] = f8;
 i5 = HEAP32[i5 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i4 >> 2]));
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i19 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i18 >> 2]));
 f12 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 f11 = Math_fround(f12 * Math_fround(HEAPF32[i17 >> 2]));
 f13 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f9 + f11);
 f13 = Math_fround(f10 + f13);
 f12 = Math_fround(f8 + Math_fround(f12 * Math_fround(HEAPF32[i15 >> 2])));
 f8 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2]));
 f9 = Math_fround(f13 + f9);
 f8 = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i6 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f11 + f10);
 HEAPF32[i3 + 4 >> 2] = f9;
 HEAPF32[i3 + 8 >> 2] = f8;
 i6 = HEAPU8[i5 + 38 >> 0] | 0;
 HEAP32[i3 + 12 >> 2] = i6;
 i4 = HEAPU8[i5 + 39 >> 0] | 0;
 HEAP32[i3 + 16 >> 2] = i4;
 i7 = HEAPU16[i5 + 36 >> 1] | 0;
 HEAP32[i3 + 20 >> 2] = i7;
 i2 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = i2;
 i4 = i4 * 20 | 0;
 HEAP32[i3 + 28 >> 2] = i2 + i4;
 HEAP32[i3 + 32 >> 2] = i2 + (i4 + (i6 * 15 | 0) + (i7 << 1));
 HEAP32[i3 + 36 >> 2] = i2 + (i4 + (i6 * 12 | 0));
 HEAP32[i3 + 56 >> 2] = HEAP32[i5 + 44 >> 2];
 i6 = i3 + 40 | 0;
 i5 = i5 + 48 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i3 + 60 >> 2] = fb + 3454;
 return i1 | 0;
}

function __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii(i10, i6, i7, i8) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = HEAP32[i6 + 76 >> 2] | 0;
 if ((i1 | 0) <= (i7 | 0)) {
  HEAP32[i10 + 12 + 20 + 12 >> 2] = 0;
  HEAPF32[i10 + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i2 = i10 + 60 | 0;
  HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i4 = i10 + 64 | 0;
  HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i10 + 68 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i5 = i10 + 72 | 0;
  HEAPF32[i5 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i9 = i10 + 76 | 0;
  HEAPF32[i9 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  i12 = i6 + 200 | 0;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = gb + 1451424 + -4;
  HEAP32[i10 + 32 >> 2] = 4;
  HEAP32[i10 + 36 >> 2] = 4;
  HEAP32[i10 + 40 >> 2] = -1;
  HEAP32[i10 + 44 >> 2] = 0;
  HEAP32[i10 + 48 >> 2] = -1;
  HEAP32[i10 + 52 >> 2] = 1;
  i12 = i7 - i1 | 0;
  i13 = HEAP32[i6 + 164 >> 2] | 0;
  i8 = HEAP32[i13 + (i12 * 40 | 0) + 20 >> 2] | 0;
  i7 = HEAP32[i13 + (i12 * 40 | 0) + 16 >> 2] | 0;
  i6 = HEAP32[i13 + (i12 * 40 | 0) + 12 >> 2] | 0;
  i3 = HEAP32[i13 + (i12 * 40 | 0) + 8 >> 2] | 0;
  i1 = HEAP32[i13 + (i12 * 40 | 0) + 4 >> 2] | 0;
  HEAP32[i10 + 56 >> 2] = HEAP32[i13 + (i12 * 40 | 0) >> 2];
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i10 + 68 >> 2] = i6;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i6 + 68 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i6 + 56 >> 2] | 0) + (HEAP32[(HEAP32[i6 + 460 >> 2] | 0) + (HEAP32[i2 + (i7 << 5) + 4 >> 2] << 5) >> 2] << 2) >> 2] | 0;
 i1 = HEAP32[i3 + 164 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? 0 : i3 + i1 | 0;
 i4 = HEAP32[i3 + 168 >> 2] | 0;
 i4 = (i4 | 0) == 0 ? 0 : i3 + i4 | 0;
 if (i1 | 0) {
  i5 = HEAP32[i2 + (i7 << 5) + 16 >> 2] | 0;
  if (i5 | 0) {
   i13 = (HEAP32[i3 + 44 >> 2] | 0) >>> 5;
   i16 = HEAP32[i3 + 48 >> 2] | 0;
   i16 = (i16 | 0) == 0 ? 0 : i3 + i16 | 0;
   i15 = HEAP32[i3 + 60 >> 2] | 0;
   HEAP32[i9 >> 2] = i13;
   HEAP32[i9 + 4 >> 2] = i16;
   HEAP32[i9 + 8 >> 2] = i16 + (((i13 << 1) + 31 | 0) >>> 5 << 2);
   HEAP32[i9 + 12 >> 2] = i3;
   HEAP32[i9 + 16 >> 2] = i15;
   HEAP32[i9 + 20 >> 2] = 4;
   HEAP32[i9 + 24 >> 2] = i13;
   i13 = HEAP32[i2 + (i7 << 5) + 8 >> 2] | 0;
   i13 = i13 - (__ZNK5Umbra6KDTree4rankEi(i9, i13) | 0) | 0;
   i5 = i8 - (_llvm_ctpop_i32((1 << i8 + 1) + -1 & ~i5 | 0) | 0) | 0;
   i13 = i5 + (HEAP32[i1 + (i13 << 4) >> 2] >> 3) | 0;
   i5 = HEAP32[i4 + (i13 * 20 | 0) >> 2] | 0;
   i15 = i5 >>> 5;
   i16 = HEAP32[i4 + (i13 * 20 | 0) + 4 >> 2] | 0;
   i16 = (i16 | 0) == 0 ? 0 : i3 + i16 | 0;
   i14 = HEAP32[i4 + (i13 * 20 | 0) + 16 >> 2] | 0;
   i1 = HEAP32[i4 + (i13 * 20 | 0) + 12 >> 2] | 0;
   i4 = HEAP32[i4 + (i13 * 20 | 0) + 8 >> 2] | 0;
   i13 = HEAP32[i2 + (i7 << 5) >> 2] | 0;
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = HEAP32[i13 + 8 >> 2] | 0;
   i9 = HEAP32[i13 + 12 >> 2] | 0;
   i12 = HEAP32[i13 + 16 >> 2] | 0;
   i13 = HEAP32[i13 + 20 >> 2] | 0;
   HEAP32[i10 >> 2] = i15;
   HEAP32[i10 + 4 >> 2] = i16;
   HEAP32[i10 + 8 >> 2] = i16 + (((i15 << 1) + 31 | 0) >>> 5 << 2);
   HEAP32[i10 + 12 >> 2] = ((i14 | 0) == 0 ? 0 : i3 + i14 | 0) + -4;
   HEAP32[i10 + 16 >> 2] = 4;
   HEAP32[i10 + 20 >> 2] = 4;
   HEAP32[i10 + 24 >> 2] = i1;
   HEAP32[i10 + 28 >> 2] = i3;
   HEAP32[i10 + 32 >> 2] = i4;
   HEAP32[i10 + 36 >> 2] = 4;
   HEAP32[i10 + 40 >> 2] = -1;
   HEAP32[i10 + 44 >> 2] = 0;
   HEAP32[i10 + 48 >> 2] = -1;
   HEAP32[i10 + 52 >> 2] = i5 & 31;
   HEAP32[i10 + 56 >> 2] = i6;
   HEAP32[i10 + 60 >> 2] = i7;
   HEAP32[i10 + 64 >> 2] = i8;
   HEAP32[i10 + 68 >> 2] = i9;
   HEAP32[i10 + 72 >> 2] = i12;
   HEAP32[i10 + 76 >> 2] = i13;
   STACKTOP = i11;
   return;
  }
 }
 HEAP8[i6 + 196 >> 0] = 1;
 i1 = i10 + 56 | 0;
 i2 = i10;
 i3 = i2 + 76 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i10 + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i10 + 64 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i10 + 68 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i10 + 72 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i10 + 76 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 STACKTOP = i11;
 return;
}

function __ZN18SpeedTreeWindAsset7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i7 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(1904, i1, 16, gb + 1048932 | 0, 0, gb + 487474 | 0, 336) | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i7, i5, i2);
 HEAP32[i7 >> 2] = gb + 69028 + 8;
 HEAPF32[i7 + 32 >> 2] = Math_fround(5.0);
 HEAPF32[i7 + 36 >> 2] = Math_fround(2.5);
 HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 448 >> 2] = Math_fround(50.0);
 HEAPF32[i7 + 452 >> 2] = Math_fround(2.0);
 HEAPF32[i7 + 656 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 660 >> 2] = Math_fround(.75);
 HEAPF32[i7 + 664 >> 2] = Math_fround(.300000012);
 i5 = i7 + 536 | 0;
 i6 = i5 + 120 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 788 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 792 >> 2] = Math_fround(.75);
 HEAPF32[i7 + 796 >> 2] = Math_fround(.300000012);
 i5 = i7 + 668 | 0;
 i6 = i5 + 120 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 1e3 >> 2] = Math_fround(20.0);
 HEAPF32[i7 + 1004 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1008 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1012 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 1016 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1020 >> 2] = Math_fround(1.0);
 _memset(i7 + 800 | 0, 0, 200) | 0;
 HEAPF32[i7 + 1224 >> 2] = Math_fround(20.0);
 HEAPF32[i7 + 1228 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1232 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1236 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 1240 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1244 >> 2] = Math_fround(1.0);
 _memset(i7 + 1024 | 0, 0, 200) | 0;
 HEAPF32[i7 + 1288 >> 2] = Math_fround(10.0);
 HEAPF32[i7 + 1292 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1296 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1300 >> 2] = Math_fround(9.0);
 HEAPF32[i7 + 1304 >> 2] = Math_fround(32.0);
 HEAPF32[i7 + 1308 >> 2] = Math_fround(.400000006);
 HEAPF32[i7 + 1312 >> 2] = Math_fround(.0500000007);
 HEAPF32[i7 + 1316 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1320 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1324 >> 2] = Math_fround(-.5);
 HEAPF32[i7 + 1328 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1332 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1336 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1340 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1344 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1348 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1352 >> 2] = Math_fround(4.0);
 HEAPF32[i7 + 1356 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1360 >> 2] = Math_fround(1.0);
 _memset(i7 + 48 | 0, 0, 400) | 0;
 i1 = i7 + 1248 | 0;
 i5 = i7 + 456 | 0;
 i6 = i5 + 80 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i5 = i1;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 1376 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1408 >> 2] = Math_fround(0.0);
 HEAPF64[i7 + 1424 >> 3] = -1.0;
 HEAP8[i7 + 1432 >> 0] = 0;
 i1 = i7 + 1472 | 0;
 i5 = i7 + 1436 | 0;
 i6 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF64[i1 >> 3] = 1.0;
 HEAPF64[i7 + 1480 >> 3] = 0.0;
 HEAPF32[i7 + 1488 >> 2] = Math_fround(0.0);
 i1 = i7 + 1496 | 0;
 i2 = i7 + 1544 | 0;
 i3 = i7 + 1580 | 0;
 i5 = i7 + 1380 | 0;
 i6 = i5 + 28 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = i7 + 1412 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i5 = i3;
 i6 = i5 + 80 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1528 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1560 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1516 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1416 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1532 >> 2] = Math_fround(0.0);
 i6 = i7 + 1564 | 0;
 HEAPF32[i7 + 1520 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1420 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1536 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1524 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1372 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1368 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1364 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i5 + 32 | 0, gb + 801749 | 0, 0);
 __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 60 | 0, i4);
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i4 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i5 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 i3 = HEAP32[gb + 1457408 >> 2] | 0;
 if (i3 | 0) HEAP32[i5 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[gb + 1457408 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i2 = i3;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 do if (i2 | 0) if (!((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0))) {
  HEAP32[i5 + 48 >> 2] = i1;
  break;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737405 | 0, 0, gb + 662472 | 0, 1179, 1, 0, 0, 0);
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[gb + 1457408 >> 2] | 0;
 if (i3 | 0) HEAP32[i5 + 168 >> 2] = (i1 | 0) < 1 ? 1 : (i1 | 0) > 255 ? 255 : i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[gb + 1457408 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i2 = i3;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (i2 | 0) HEAP32[i5 + 172 >> 2] = (i1 | 0) < 1 ? 1 : (i1 | 0) > 255 ? 255 : i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i5 + 798 >> 0] = i1 << 24 >> 24 != 0 & 1;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i5 + 56 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i5 + 57 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i5 + 797 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i3 = i5 + 724 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i5 + 728 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function runPostSets193() {
 HEAP32[gb + 165524 >> 2] = (HEAP32[gb + 165524 >> 2] | 0) + (gb + 830112 | 0);
 HEAP32[gb + 165552 >> 2] = (HEAP32[gb + 165552 >> 2] | 0) + (gb + 829437 | 0);
 HEAP32[gb + 165556 >> 2] = (HEAP32[gb + 165556 >> 2] | 0) + (gb + 830092 | 0);
 HEAP32[gb + 165584 >> 2] = (HEAP32[gb + 165584 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165588 >> 2] = (HEAP32[gb + 165588 >> 2] | 0) + (gb + 830077 | 0);
 HEAP32[gb + 165616 >> 2] = (HEAP32[gb + 165616 >> 2] | 0) + (gb + 827843 | 0);
 HEAP32[gb + 165620 >> 2] = (HEAP32[gb + 165620 >> 2] | 0) + (gb + 830057 | 0);
 HEAP32[gb + 165648 >> 2] = (HEAP32[gb + 165648 >> 2] | 0) + (gb + 830030 | 0);
 HEAP32[gb + 165652 >> 2] = (HEAP32[gb + 165652 >> 2] | 0) + (gb + 830043 | 0);
 HEAP32[gb + 165680 >> 2] = (HEAP32[gb + 165680 >> 2] | 0) + (gb + 827872 | 0);
 HEAP32[gb + 165684 >> 2] = (HEAP32[gb + 165684 >> 2] | 0) + (gb + 830015 | 0);
 HEAP32[gb + 165712 >> 2] = (HEAP32[gb + 165712 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 165716 >> 2] = (HEAP32[gb + 165716 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 165744 >> 2] = (HEAP32[gb + 165744 >> 2] | 0) + (gb + 835156 | 0);
 HEAP32[gb + 165776 >> 2] = (HEAP32[gb + 165776 >> 2] | 0) + (gb + 828505 | 0);
 HEAP32[gb + 165780 >> 2] = (HEAP32[gb + 165780 >> 2] | 0) + (gb + 830773 | 0);
 HEAP32[gb + 165808 >> 2] = (HEAP32[gb + 165808 >> 2] | 0) + (gb + 834943 | 0);
 HEAP32[gb + 165840 >> 2] = (HEAP32[gb + 165840 >> 2] | 0) + (gb + 828758 | 0);
 HEAP32[gb + 165844 >> 2] = (HEAP32[gb + 165844 >> 2] | 0) + (gb + 830773 | 0);
 HEAP32[gb + 165872 >> 2] = (HEAP32[gb + 165872 >> 2] | 0) + (gb + 834990 | 0);
 HEAP32[gb + 165904 >> 2] = (HEAP32[gb + 165904 >> 2] | 0) + (gb + 827821 | 0);
 HEAP32[gb + 165908 >> 2] = (HEAP32[gb + 165908 >> 2] | 0) + (gb + 830773 | 0);
 HEAP32[gb + 165936 >> 2] = (HEAP32[gb + 165936 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 165940 >> 2] = (HEAP32[gb + 165940 >> 2] | 0) + (gb + 830787 | 0);
 HEAP32[gb + 165968 >> 2] = (HEAP32[gb + 165968 >> 2] | 0) + (gb + 827882 | 0);
 HEAP32[gb + 165972 >> 2] = (HEAP32[gb + 165972 >> 2] | 0) + (gb + 827877 | 0);
 HEAP32[gb + 166008 >> 2] = fb + 1193;
 HEAP32[gb + 166012 >> 2] = fb + 2503;
 HEAP32[gb + 166016 >> 2] = fb + 1123;
 HEAP32[gb + 166020 >> 2] = fb + 131;
 HEAP32[gb + 166024 >> 2] = fb + 132;
 HEAP32[gb + 166028 >> 2] = fb + 133;
 HEAP32[gb + 166032 >> 2] = fb + 87;
 HEAP32[gb + 166036 >> 2] = fb + 425;
 HEAP32[gb + 166048 >> 2] = fb + 1193;
 HEAP32[gb + 166052 >> 2] = fb + 2504;
 HEAP32[gb + 166056 >> 2] = fb + 1124;
 HEAP32[gb + 166060 >> 2] = fb + 134;
 HEAP32[gb + 166064 >> 2] = fb + 135;
 HEAP32[gb + 166068 >> 2] = fb + 136;
 HEAP32[gb + 166072 >> 2] = fb + 88;
 HEAP32[gb + 166076 >> 2] = fb + 426;
 HEAP32[gb + 166088 >> 2] = fb + 1193;
 HEAP32[gb + 166092 >> 2] = fb + 2505;
 HEAP32[gb + 166096 >> 2] = fb + 1125;
 HEAP32[gb + 166100 >> 2] = fb + 137;
 HEAP32[gb + 166104 >> 2] = fb + 138;
 HEAP32[gb + 166108 >> 2] = fb + 139;
 HEAP32[gb + 166112 >> 2] = fb + 89;
 HEAP32[gb + 166116 >> 2] = fb + 427;
 HEAP32[gb + 166128 >> 2] = fb + 1193;
 HEAP32[gb + 166132 >> 2] = fb + 2506;
 HEAP32[gb + 166136 >> 2] = fb + 1126;
 HEAP32[gb + 166140 >> 2] = fb + 140;
 HEAP32[gb + 166144 >> 2] = fb + 141;
 HEAP32[gb + 166148 >> 2] = fb + 142;
 HEAP32[gb + 166152 >> 2] = fb + 90;
 HEAP32[gb + 166156 >> 2] = fb + 428;
 HEAP32[gb + 166168 >> 2] = fb + 1127;
 HEAP32[gb + 166172 >> 2] = fb + 420;
 HEAP32[gb + 166176 >> 2] = fb + 1128;
 HEAP32[gb + 166180 >> 2] = fb + 421;
 HEAP32[gb + 166184 >> 2] = fb + 422;
 HEAP32[gb + 166188 >> 2] = fb + 423;
 HEAP32[gb + 166192 >> 2] = fb + 1129;
 HEAP32[gb + 166196 >> 2] = fb + 257;
 HEAP32[gb + 166200 >> 2] = fb + 1863;
 HEAP32[gb + 166204 >> 2] = fb + 2507;
 HEAP32[gb + 166216 >> 2] = fb + 1130;
 HEAP32[gb + 166220 >> 2] = fb + 424;
 HEAP32[gb + 166224 >> 2] = fb + 1131;
 HEAP32[gb + 166228 >> 2] = fb + 425;
 HEAP32[gb + 166232 >> 2] = fb + 426;
 HEAP32[gb + 166236 >> 2] = fb + 427;
 HEAP32[gb + 166240 >> 2] = fb + 1132;
 HEAP32[gb + 166244 >> 2] = fb + 258;
 HEAP32[gb + 166248 >> 2] = fb + 1863;
 HEAP32[gb + 166252 >> 2] = fb + 2508;
 HEAP32[gb + 166264 >> 2] = fb + 1133;
 HEAP32[gb + 166268 >> 2] = fb + 428;
 HEAP32[gb + 166272 >> 2] = fb + 1134;
 HEAP32[gb + 166276 >> 2] = fb + 429;
 HEAP32[gb + 166280 >> 2] = fb + 430;
 HEAP32[gb + 166284 >> 2] = fb + 431;
 HEAP32[gb + 166288 >> 2] = fb + 1135;
 HEAP32[gb + 166292 >> 2] = fb + 259;
 HEAP32[gb + 166296 >> 2] = fb + 1863;
 HEAP32[gb + 166300 >> 2] = fb + 2509;
 HEAP32[gb + 166312 >> 2] = fb + 1136;
 HEAP32[gb + 166316 >> 2] = fb + 432;
 HEAP32[gb + 166320 >> 2] = fb + 1137;
 HEAP32[gb + 166324 >> 2] = fb + 433;
 HEAP32[gb + 166328 >> 2] = fb + 434;
 HEAP32[gb + 166332 >> 2] = fb + 435;
 HEAP32[gb + 166336 >> 2] = fb + 1138;
 HEAP32[gb + 166340 >> 2] = fb + 260;
 HEAP32[gb + 166344 >> 2] = fb + 1863;
 HEAP32[gb + 166348 >> 2] = fb + 2510;
 HEAP32[gb + 166360 >> 2] = fb + 1870;
 HEAP32[gb + 166364 >> 2] = fb + 2511;
 runPostSets194();
}

function __Z23SetupStereoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK10Matrix4x4fRK8Vector3fb(i1, i2, i5, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 60 | 0;
 i14 = i15 + 24 | 0;
 i3 = i15 + 12 | 0;
 i4 = i15;
 f18 = Math_fround(HEAPF32[i10 + 48 >> 2]);
 f17 = Math_fround(HEAPF32[i10 + 52 >> 2]);
 f16 = Math_fround(HEAPF32[i10 + 56 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i11 >> 2]));
 i6 = i11 + 4 | 0;
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i6 >> 2]));
 i7 = i11 + 8 | 0;
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i13 >> 2] = f18;
 HEAPF32[i13 + 4 >> 2] = f17;
 HEAPF32[i13 + 8 >> 2] = f16;
 if (i12) {
  HEAP32[i3 >> 2] = HEAP32[gb + 62536 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[gb + 62524 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 } else {
  i20 = HEAP32[i10 + 16 >> 2] | 0;
  i19 = HEAP32[i10 + 20 >> 2] | 0;
  i12 = HEAP32[i10 + 24 >> 2] | 0;
  HEAP32[i3 >> 2] = i20;
  HEAP32[i3 + 4 >> 2] = i19;
  HEAP32[i3 + 8 >> 2] = i12;
  HEAP32[i4 >> 2] = i20;
  HEAP32[i4 + 4 >> 2] = i19;
  HEAP32[i4 + 8 >> 2] = i12;
 }
 if (!(__Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i13, i3, i14) | 0)) __Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i13, i4, i14) | 0;
 f22 = Math_fround(HEAPF32[i14 >> 2]);
 f24 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f18 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(f22 * f23);
 f26 = Math_fround(f24 * f23);
 f23 = Math_fround(f16 * f23);
 f25 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f25);
 f26 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f26);
 f23 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f23);
 i19 = i2 + 4 | 0;
 f27 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(f26 - Math_fround(f17 * f27));
 f23 = Math_fround(f23 - Math_fround(f18 * f27));
 HEAPF32[i1 >> 2] = Math_fround(f25 - Math_fround(f21 * f27));
 HEAPF32[i1 + 4 >> 2] = f26;
 HEAPF32[i1 + 8 >> 2] = f23;
 i20 = i5 + 4 | 0;
 i14 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 20 >> 2] = i14;
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 >> 2];
 f23 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(f22 * f23);
 f27 = Math_fround(f24 * f23);
 f23 = Math_fround(f16 * f23);
 f26 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f26);
 f27 = Math_fround(f27 + Math_fround(HEAPF32[i6 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2]));
 f25 = Math_fround(HEAPF32[i2 >> 2]);
 f27 = Math_fround(f27 - Math_fround(f17 * f25));
 f23 = Math_fround(f23 - Math_fround(f18 * f25));
 HEAPF32[i1 + 24 >> 2] = Math_fround(f26 - Math_fround(f21 * f25));
 HEAPF32[i1 + 28 >> 2] = f27;
 HEAPF32[i1 + 32 >> 2] = f23;
 i20 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 44 >> 2] = i20;
 HEAP32[i1 + 36 >> 2] = HEAP32[i9 >> 2];
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f27 = Math_fround(f22 * f23);
 f25 = Math_fround(f24 * f23);
 f23 = Math_fround(f16 * f23);
 f27 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f27);
 f25 = Math_fround(f25 + Math_fround(HEAPF32[i6 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2]));
 f26 = Math_fround(HEAPF32[i19 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f17 * f26));
 f23 = Math_fround(f23 + Math_fround(f18 * f26));
 HEAPF32[i1 + 48 >> 2] = Math_fround(f27 + Math_fround(f21 * f26));
 HEAPF32[i1 + 52 >> 2] = f25;
 HEAPF32[i1 + 56 >> 2] = f23;
 i20 = i8 + 4 | 0;
 i14 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 68 >> 2] = i14;
 HEAP32[i1 + 60 >> 2] = HEAP32[i9 >> 2];
 f23 = Math_fround(HEAPF32[i19 >> 2]);
 f22 = Math_fround(f22 * f23);
 f24 = Math_fround(f24 * f23);
 f23 = Math_fround(f16 * f23);
 f22 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f22);
 f24 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f24);
 f23 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f23);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f24 + Math_fround(f17 * f16));
 f18 = Math_fround(f23 + Math_fround(f18 * f16));
 HEAPF32[i1 + 72 >> 2] = Math_fround(f22 + Math_fround(f21 * f16));
 HEAPF32[i1 + 76 >> 2] = f17;
 HEAPF32[i1 + 80 >> 2] = f18;
 i20 = HEAP32[i20 >> 2] | 0;
 HEAP32[i1 + 88 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 92 >> 2] = i20;
 HEAP32[i1 + 84 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i15;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i13, i1, i18, i19, i12, i20) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, i28 = 0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 32 | 0;
 i22 = i24 + 16 | 0;
 i23 = i24;
 if (i12 >>> 0 >= i20 >>> 0) {
  STACKTOP = i24;
  return;
 }
 i14 = i1 + 520 | 0;
 i15 = i21 + 4 | 0;
 i16 = i21 + 8 | 0;
 i17 = i21 + 12 | 0;
 i2 = i1 + 500 | 0;
 i3 = i22 + 4 | 0;
 i4 = i22 + 8 | 0;
 i5 = i22 + 12 | 0;
 i6 = i19 + 4 | 0;
 i7 = i19 + 8 | 0;
 i8 = i19 + 12 | 0;
 i9 = i23 + 4 | 0;
 i10 = i23 + 8 | 0;
 i11 = i23 + 12 | 0;
 i1 = i12;
 do {
  i38 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i38 >> 2]);
  f34 = Math_fround(HEAPF32[i38 + 4 >> 2]);
  f35 = Math_fround(HEAPF32[i38 + 8 >> 2]);
  f34 = Math_fround(f34 * Math_fround(.00999999977));
  f35 = Math_fround(f35 * Math_fround(.00999999977));
  f36 = Math_fround(Math_fround(HEAPF32[i38 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i21 >> 2] = Math_fround(f32 * Math_fround(.00999999977));
  HEAPF32[i15 >> 2] = f34;
  HEAPF32[i16 >> 2] = f35;
  HEAPF32[i17 >> 2] = f36;
  i38 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i12 = HEAP32[i38 >> 2] | 0;
  i28 = HEAP32[i38 + 4 >> 2] | 0;
  i33 = HEAP32[i38 + 8 >> 2] | 0;
  i38 = HEAP32[i38 + 12 >> 2] | 0;
  i30 = i12 + 1793934638 | 0;
  i43 = i28 + 1793934638 | 0;
  i41 = i33 + 1793934638 | 0;
  i39 = i38 + 1793934638 | 0;
  i26 = (Math_imul(i30, 1790253981) | 0) + 1900727103 | 0;
  i42 = (Math_imul(i43, 1790253981) | 0) + 1900727103 | 0;
  i40 = (Math_imul(i41, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i39, 1790253981) | 0) + 1900727103 | 0;
  i30 = i30 << 11 ^ i30;
  i43 = i43 << 11 ^ i43;
  i41 = i41 << 11 ^ i41;
  i39 = i39 << 11 ^ i39;
  f36 = Math_fround(Math_fround((i42 ^ i43 ^ i43 >>> 8) & 8388607 ^ i42 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i40 ^ i41 ^ i41 >>> 8) & 8388607 ^ i40 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f34 = Math_fround(Math_fround((i37 ^ i39 ^ i39 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i22 >> 2] = Math_fround(Math_fround((i26 ^ i30 ^ i30 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f36;
  HEAPF32[i4 >> 2] = f35;
  HEAPF32[i5 >> 2] = f34;
  i12 = i12 + -13913692 | 0;
  i28 = i28 + -13913692 | 0;
  i33 = i33 + -13913692 | 0;
  i38 = i38 + -13913692 | 0;
  i26 = (Math_imul(i12, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i37 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i39 = (Math_imul(i38, 1790253981) | 0) + 1900727103 | 0;
  i12 = i12 << 11 ^ i12;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i38 = i38 << 11 ^ i38;
  f34 = Math_fround(Math_fround((i26 ^ i12 ^ i12 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f35 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f36 = Math_fround(Math_fround((i37 ^ i33 ^ i33 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f32 = Math_fround(Math_fround((i39 ^ i38 ^ i38 >>> 8) & 8388607 ^ i39 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i39 = f34 > Math_fround(HEAPF32[i19 >> 2]);
  i38 = f35 > Math_fround(HEAPF32[i6 >> 2]);
  i37 = f36 > Math_fround(HEAPF32[i7 >> 2]);
  i33 = f32 > Math_fround(HEAPF32[i8 >> 2]);
  i30 = i18 + (i1 << 2) | 0;
  f32 = Math_fround(HEAPF32[i30 >> 2]);
  i28 = i30 + 4 | 0;
  f36 = Math_fround(HEAPF32[i28 >> 2]);
  i26 = i30 + 8 | 0;
  f35 = Math_fround(HEAPF32[i26 >> 2]);
  i12 = i30 + 12 | 0;
  f34 = Math_fround(HEAPF32[i12 >> 2]);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i23, i13, i21, i22);
  f31 = Math_fround(HEAPF32[i23 >> 2]);
  f31 = Math_fround((i39 ? Math_fround(1.0) : Math_fround(-1.0)) * f31);
  f29 = Math_fround(HEAPF32[i9 >> 2]);
  f29 = Math_fround((i38 ? Math_fround(1.0) : Math_fround(-1.0)) * f29);
  f27 = Math_fround(HEAPF32[i10 >> 2]);
  f27 = Math_fround((i37 ? Math_fround(1.0) : Math_fround(-1.0)) * f27);
  f25 = Math_fround(HEAPF32[i11 >> 2]);
  f29 = Math_fround(f36 + f29);
  f27 = Math_fround(f35 + f27);
  f25 = Math_fround(f34 + Math_fround((i33 ? Math_fround(1.0) : Math_fround(-1.0)) * f25));
  HEAPF32[i30 >> 2] = Math_fround(f32 + f31);
  HEAPF32[i28 >> 2] = f29;
  HEAPF32[i26 >> 2] = f27;
  HEAPF32[i12 >> 2] = f25;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i20 >>> 0);
 STACKTOP = i24;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 40 | 0;
 i11 = i15 + 24 | 0;
 i9 = i15;
 i3 = i15 + 20 | 0;
 i4 = i15 + 16 | 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 52 | 0;
 i5 = i1;
 if (i2 >>> 0 < i10 >>> 0) {
  i6 = i12 + 8 | 0;
  if ((((HEAP32[i6 >> 2] | 0) - i1 | 0) / 52 | 0 | 0) == (i10 | 0)) {
   __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj(i12, i10 - i2 | 0);
   STACKTOP = i15;
   return;
  }
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  i7 = i9 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE7reserveEj(i9, i10);
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i11, i14);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = (i1 - i4 | 0) / 52 | 0;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i10 >>> 0) {
   __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj(i9, i10 - i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } else if (i2 >>> 0 > i10 >>> 0) {
   i2 = i3 + (i10 * 52 | 0) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~(((i5 + -52 - i2 | 0) >>> 0) / 52 | 0) * 52 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i12 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i12 >> 2] = i2;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i13 >> 2] = i1;
  i13 = i9 + 8 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = i2 + (~(((i2 + -52 - i3 | 0) >>> 0) / 52 | 0) * 52 | 0);
   i13 = HEAP32[i8 >> 2] | 0;
   HEAP32[i14 >> 2] = 16;
   HEAP32[i14 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
  }
  STACKTOP = i15;
  return;
 }
 if (i2 >>> 0 <= i10 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i4 = i5 + (i10 * 52 | 0) | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i10 * 52 | 0;
 i3 = (i2 | 0) / 52 | 0;
 if (!i2) {
  i4 = i11 + 8 | 0;
  i5 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = 16;
  HEAP32[i14 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  i1 = i2 + (i3 * 52 | 0) | 0;
  i6 = i11 + 8 | 0;
  HEAP32[i6 >> 2] = i1;
  i3 = i2;
  if (!i10) {
   i4 = i6;
   i5 = i3;
   i2 = i3;
  } else {
   i1 = i5;
   do {
    i5 = i1;
    i9 = HEAP32[i5 + 4 >> 2] | 0;
    i10 = i2;
    HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
    HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
    i10 = i2 + 32 | 0;
    i9 = i1 + 32 | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    i1 = i1 + 52 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 52 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i4 | 0));
   i4 = i6;
   i5 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
 }
 i3 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i12 >> 2] = i5;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i13 >> 2] = i2;
 i2 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 i1 = i3;
 i2 = i11;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = i2 + (~(((i2 + -52 - i3 | 0) >>> 0) / 52 | 0) * 52 | 0);
  i13 = HEAP32[i8 >> 2] | 0;
  HEAP32[i14 >> 2] = 16;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 }
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i8, i9, i12) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i7 = (i12 - i9 | 0) / 20 | 0;
 i11 = i8 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i2;
 if (i7 >>> 0 > ((i1 - i2 | 0) / 20 | 0) >>> 0) {
  if (i2) {
   i5 = i8 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) i1 = i2; else {
    do {
     i2 = i1 + -20 | 0;
     HEAP32[i5 >> 2] = i2;
     i3 = HEAP32[i1 + -12 >> 2] | 0;
     i4 = i3;
     if (!i3) i1 = i2; else {
      i1 = i1 + -8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i3);
      i1 = HEAP32[i5 >> 2] | 0;
     }
    } while ((i1 | 0) != (i6 | 0));
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 0;
  }
  if (i7 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else i2 = 0;
  i10 = (i1 - i2 | 0) / 20 | 0;
  i1 = i10 << 1;
  i1 = i10 >>> 0 < 107374182 ? (i1 >>> 0 < i7 >>> 0 ? i7 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = __Znwj(i1 * 20 | 0) | 0;
  i10 = i8 + 4 | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i11 >> 2] = i2 + (i1 * 20 | 0);
  if ((i9 | 0) == (i12 | 0)) return;
  do {
   i8 = i9;
   i4 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i2 + 8 | 0;
   i4 = i9 + 8 | 0;
   HEAP32[i3 >> 2] = 0;
   i8 = i2 + 12 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   i6 = i9 + 12 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
   i5 = (i1 | 0) / 24 | 0;
   if (i1 | 0) {
    if (i5 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
    i7 = __Znwj(i1) | 0;
    HEAP32[i8 >> 2] = i7;
    HEAP32[i3 >> 2] = i7;
    HEAP32[i2 + 16 >> 2] = i7 + (i5 * 24 | 0);
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i7 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i8 >> 2] = i7 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i9 = i9 + 20 | 0;
   i2 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
   HEAP32[i10 >> 2] = i2;
  } while ((i9 | 0) != (i12 | 0));
  return;
 } else {
  i10 = i8 + 4 | 0;
  i5 = ((HEAP32[i10 >> 2] | 0) - i2 | 0) / 20 | 0;
  i4 = i7 >>> 0 > i5 >>> 0;
  i5 = i9 + (i5 * 20 | 0) | 0;
  i3 = i4 ? i5 : i12;
  if ((i3 | 0) != (i9 | 0)) {
   i2 = i9;
   i1 = i6;
   do {
    i8 = i2;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i11 = i1;
    HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i11 + 4 >> 2] = i9;
    if ((i1 | 0) != (i2 | 0)) __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
    i2 = i2 + 20 | 0;
    i1 = i1 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
   i6 = i1;
  }
  if (!i4) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) return;
   do {
    i2 = i1 + -20 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = HEAP32[i1 + -12 >> 2] | 0;
    i4 = i3;
    if (!i3) i1 = i2; else {
     i1 = i1 + -8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i3);
     i1 = HEAP32[i10 >> 2] | 0;
    }
   } while ((i1 | 0) != (i6 | 0));
   return;
  }
  if ((i3 | 0) == (i12 | 0)) return;
  i2 = HEAP32[i10 >> 2] | 0;
  do {
   i9 = i5;
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i2 + 8 | 0;
   i4 = i5 + 8 | 0;
   HEAP32[i3 >> 2] = 0;
   i9 = i2 + 12 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   i7 = i5 + 12 | 0;
   i1 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
   i6 = (i1 | 0) / 24 | 0;
   if (i1 | 0) {
    if (i6 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
    i8 = __Znwj(i1) | 0;
    HEAP32[i9 >> 2] = i8;
    HEAP32[i3 >> 2] = i8;
    HEAP32[i2 + 16 >> 2] = i8 + (i6 * 24 | 0);
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i8 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i9 >> 2] = i8 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i5 = i5 + 20 | 0;
   i2 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
   HEAP32[i10 >> 2] = i2;
  } while ((i5 | 0) != (i12 | 0));
  return;
 }
}

function __ZN23ArchiveStorageConverter23InitializeTargetArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15CompressionTypej(i5, i9, i7, i8) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 16 | 0;
 i10 = i14;
 i11 = i5 + 64 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i12 = i5 + 60 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i6 = i5 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i2 = HEAP32[i1 + 108 >> 2] | 0;
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 i4 = i1;
 L10 : do if ((i2 | 0) != (i1 | 0)) {
  i3 = (i2 - i1 | 0) / 12 | 0;
  L12 : do if ((i7 | 0) == 2) {
   i1 = 0;
   while (1) {
    i2 = HEAP16[i4 + (i1 * 12 | 0) + 8 >> 1] | 0;
    if (!((i2 & 64) == 0 | (i2 & 63) == 0)) break L12;
    i1 = i1 + 1 | 0;
    if ((i2 & 62 | 1 | 0) != 3) break L12;
    if (i1 >>> 0 >= i3 >>> 0) break L10;
   }
  } else {
   i1 = 0;
   while (1) {
    i2 = HEAP16[i4 + (i1 * 12 | 0) + 8 >> 1] | 0;
    if (!((i2 & 64) == 0 | (i2 & 63) == 0)) break L12;
    i1 = i1 + 1 | 0;
    if ((i2 & 63 | 0) != (i7 | 0)) break L12;
    if (i1 >>> 0 >= i3 >>> 0) break L10;
   }
  } while (0);
  HEAP32[i5 + 88 >> 2] = i8;
  i13 = __ZnwjRK10MemLabelIdiPKci(1328, gb + 63552 | 0, 16, gb + 490147 | 0, 93) | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZN12FileAccessorC2Ev(i13 + 12 | 0);
  i5 = i13 + 1084 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i13 + 1088 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 + 1092 >> 2] = 0;
  HEAP32[i13 + 1080 >> 2] = i5;
  __ZN20ArchiveStorageHeader6HeaderC2Ev(i13 + 1096 | 0);
  HEAP32[i13 + 1192 >> 2] = 0;
  HEAP32[i13 + 1196 >> 2] = 0;
  HEAP32[i13 + 1200 >> 2] = 0;
  HEAP32[i13 + 1204 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 + 1208 >> 2] = 0;
  HEAP32[i13 + 1212 >> 2] = 0;
  HEAP32[i13 + 1216 >> 2] = 0;
  HEAP32[i13 + 1220 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 + 1248 >> 2] = 0;
  HEAP32[i13 + 1252 >> 2] = 5;
  i5 = i13 + 1256 | 0;
  HEAP32[i13 + 1280 >> 2] = 0;
  HEAP32[i13 + 1284 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i5 = i10;
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i13 + 1272 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i12;
  HEAP32[i13 + 1288 >> 2] = 0;
  HEAP32[i13 + 1300 >> 2] = 0;
  HEAP32[i13 + 1304 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i6 = i10;
  i10 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = i13 + 1292 | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP8[i13 + 1320 >> 0] = 0;
  HEAP32[i11 >> 2] = i13;
  do if (__ZN21ArchiveStorageCreator10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i13, i9, 0) | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i7) {
    if (__ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj(i1, 1, 0, 1, -1) | 0) i1 = 1; else break;
    STACKTOP = i14;
    return i1 | 0;
   } else {
    if (__ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj(i1, 0, i7, 1, i8) | 0) i1 = 1; else break;
    STACKTOP = i14;
    return i1 | 0;
   }
  } while (0);
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN21ArchiveStorageCreatorD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i11 >> 2] = 0;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 i11 = __ZnwjRK10MemLabelIdiPKci(1068, gb + 63552 | 0, 16, gb + 490147 | 0, 75) | 0;
 __ZN12FileAccessorC2Ev(i11);
 HEAP32[i12 >> 2] = i11;
 i2 = i9 + 11 | 0;
 if (__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i11, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 1, 0) | 0) {
  i11 = (HEAP32[i6 >> 2] | 0) + 64 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i5 + 48 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 >> 2] = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 __Z6FormatPKcz(i10, gb + 490259 | 0, i13);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 490147 | 0, 81, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5Unity5ClothC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 168556 + 8;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 132 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 172 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + 192 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 212 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i1 + 236 >> 2] = 0;
 i7 = gb + 63232 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 252 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63232 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 272 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63232 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 292 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63232 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 308 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 312 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = i1;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 44 >> 0] = 1;
 HEAP8[i1 + 45 >> 0] = 1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 92 >> 0] = 1;
 HEAP8[i1 + 93 >> 0] = 1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(120.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.100000001);
 HEAP32[i1 + 228 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 i3 = i1 + 328 | 0;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(.100000001);
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP8[i1 + 356 >> 0] = 0;
 HEAP8[i1 + 357 >> 0] = 0;
 HEAP8[i1 + 358 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __Z15UnloadGameScenev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16 + 8 | 0;
 i15 = i16;
 i7 = i16 + 36 | 0;
 i10 = i16 + 16 | 0;
 d17 = +_emscripten_get_now() * 1.0e6;
 i12 = ~~d17 >>> 0;
 i13 = +Math_abs(d17) >= 1.0 ? (d17 > 0.0 ? ~~+Math_min(+Math_floor(d17 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d17 - +(~~d17 >>> 0)) / 4294967296.0) >>> 0) : 0;
 if ((HEAP16[gb + 1162860 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162860 | 0, i6);
  i9 = gb + 1162860 | 0;
 } else i9 = 0;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i14 = i10 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i11 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = i6;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i11;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE(i10);
 if (HEAP32[i8 >> 2] | 0) {
  i4 = HEAP32[i10 >> 2] | 0;
  do {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i18 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if (!(HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0)) __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
    }
   }
   if ((i5 | 0) == 12) i5 = 0;
   i4 = i4 + 4 | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } while ((i4 | 0) != (i2 + (i1 << 2) | 0));
  if (i1 | 0) {
   i4 = i2;
   do {
    HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i1 = 0; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
      i2 = HEAP32[i6 >> 2] | 0;
      i18 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != ((HEAP32[i10 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
  }
 }
 __ZN19RuntimeSceneManager43UnloadAllScenesWithoutDestroyingGameObjectsEv(__Z15GetSceneManagerv() | 0);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 3084 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 2316 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 d17 = +_emscripten_get_now() * 1.0e6;
 i18 = _i64Subtract(~~d17 >>> 0 | 0, (+Math_abs(d17) >= 1.0 ? (d17 > 0.0 ? ~~+Math_min(+Math_floor(d17 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d17 - +(~~d17 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i12 | 0, i13 | 0) | 0;
 i18 = __Z17TimeToNanosecondsy(i18, getTempRet0() | 0) | 0;
 HEAPF64[i15 >> 3] = +Math_fround(Math_fround((+(i18 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
 _printf_console(gb + 454731 | 0, i15);
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i11);
  HEAP32[i10 >> 2] = 0;
 }
 if (!i9) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i16;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i8 = i16 + 36 | 0;
 i12 = i16 + 16 | 0;
 i7 = i16 + 12 | 0;
 i5 = i16 + 32 | 0;
 i6 = i16 + 28 | 0;
 i11 = i16;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 i3 = i1;
 if (i4 >>> 0 >= i9 >>> 0) {
  if (i4 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i3 + (i9 * 20 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = i9 * 20 | 0;
  i4 = (i3 | 0) / 20 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i11 + 8 | 0;
   i8 = i11;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i6 = __Znwj(i3) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i11 >> 2] = i6;
   i9 = i11 + 8 | 0;
   HEAP32[i9 >> 2] = i6 + (i4 * 20 | 0);
   HEAP32[i12 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i11, i8, i15, i4);
   i6 = i10;
   i7 = i9;
   i8 = i11;
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  i14 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i4;
  i4 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i15 + 4 | 0;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i10 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i14 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i3 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 20 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE8__appendEj(i13, i9 - i4 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE7reserveEj(i12, i9);
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, i8, i15);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 20 | 0;
 i1 = i2;
 if (i3 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE8__appendEj(i12, i9 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i9 >>> 0) {
  i4 = i4 + (i9 * 20 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i2 = i1 + -20 | 0;
    HEAP32[i10 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + -8 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
   }
  }
 }
 i4 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i4;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i12 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i14 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx2Gu33generateSphereFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalEPNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERNSC_5Vec3VEb(i5, i7, i4, i25, i27, i1, i26, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 var f3 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28;
 if (i2) if (!(__ZN5physx2Gu16testPolyDataAxisERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i5, i7, i4, i1, i28 + 16 | 0, i26) | 0)) {
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 f21 = Math_fround(HEAPF32[i5 + 128 >> 2]);
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i1 >> 2]));
 f18 = Math_fround(HEAPF32[i26 >> 2]);
 i22 = i26 + 4 | 0;
 f19 = Math_fround(HEAPF32[i22 >> 2]);
 i23 = i26 + 8 | 0;
 f18 = Math_fround(-f18);
 f19 = Math_fround(-f19);
 f20 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 i16 = HEAP32[i4 + 40 >> 2] | 0;
 f33 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = Math_fround(f33 * f18);
 f32 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f32 * f19));
 f10 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f10 * f20));
 f31 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f14 = Math_fround(f31 * f18);
 f30 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f30 * f19));
 f11 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f11 * f20));
 f29 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f15 = Math_fround(f29 * f18);
 f6 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f6 * f19));
 f9 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f9 * f20));
 i16 = i5 + 96 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i5 + 100 | 0;
 f8 = Math_fround(HEAPF32[i17 >> 2]);
 i5 = i5 + 104 | 0;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f33 * f3) + Math_fround(f32 * f8)) + Math_fround(f10 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f31 * f3) + Math_fround(f30 * f8)) + Math_fround(f11 * f12));
 f12 = Math_fround(Math_fround(Math_fround(f29 * f3) + Math_fround(f6 * f8)) + Math_fround(f9 * f12));
 i4 = HEAP32[i7 + 16 >> 2] | 0;
 L5 : do if (!i4) f3 = Math_fround(0.0); else {
  i1 = HEAP32[i7 + 24 >> 2] | 0;
  f3 = Math_fround(0.0);
  f6 = Math_fround(1.0);
  i2 = 0;
  while (1) {
   f32 = Math_fround(HEAPF32[i1 + (i2 * 20 | 0) >> 2]);
   f33 = Math_fround(HEAPF32[i1 + (i2 * 20 | 0) + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i1 + (i2 * 20 | 0) + 8 >> 2]);
   f8 = Math_fround(Math_fround(Math_fround(f13 * f32) + Math_fround(f14 * f33)) + Math_fround(f15 * f9));
   f9 = Math_fround(Math_fround(HEAPF32[i1 + (i2 * 20 | 0) + 12 >> 2]) + Math_fround(Math_fround(Math_fround(f10 * f32) + Math_fround(f11 * f33)) + Math_fround(f12 * f9)));
   if (Math_fround(Math_abs(Math_fround(f8))) < Math_fround(1.00000001e-07)) {
    if (f9 > Math_fround(0.0)) {
     i1 = 1;
     i2 = 12;
     break;
    }
   } else {
    f33 = Math_fround(-Math_fround(f9 / f8));
    i7 = f8 < Math_fround(0.0);
    f3 = i7 & f3 < f33 ? f33 : f3;
    f6 = f6 > f33 & (i7 ^ 1) ? f33 : f6;
   }
   i2 = i2 + 1 | 0;
   if (f3 > f6) {
    i1 = 1;
    i2 = 12;
    break;
   }
   if (i2 >>> 0 >= i4 >>> 0) break L5;
  }
  if ((i2 | 0) == 12) {
   STACKTOP = i28;
   return i1 | 0;
  }
 } while (0);
 if (!(f21 >= f3)) {
  i27 = 1;
  STACKTOP = i28;
  return i27 | 0;
 }
 i7 = i25 + ((HEAP32[i27 >> 2] | 0) * 48 | 0) | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 HEAP32[i24 + 8 >> 2] = 0;
 HEAP32[i24 + 12 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i24 + 12 >> 2];
 i24 = HEAP32[i27 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i16 >> 2]);
 f32 = Math_fround(HEAPF32[i17 >> 2]);
 f32 = Math_fround(Math_fround(f3 * f19) + f32);
 f33 = Math_fround(Math_fround(f3 * f20) + Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i25 + (i24 * 48 | 0) + 16 >> 2] = Math_fround(Math_fround(f3 * f18) + f31);
 HEAPF32[i25 + (i24 * 48 | 0) + 20 >> 2] = f32;
 HEAPF32[i25 + (i24 * 48 | 0) + 24 >> 2] = f33;
 HEAPF32[i25 + (i24 * 48 | 0) + 28 >> 2] = Math_fround(0.0);
 i24 = HEAP32[i27 >> 2] | 0;
 HEAP32[i27 >> 2] = i24 + 1;
 i22 = HEAP32[i22 >> 2] | 0;
 i27 = HEAP32[i23 >> 2] | 0;
 HEAP32[i25 + (i24 * 48 | 0) + 32 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i25 + (i24 * 48 | 0) + 36 >> 2] = i22;
 HEAP32[i25 + (i24 * 48 | 0) + 40 >> 2] = i27;
 HEAPF32[i25 + (i24 * 48 | 0) + 44 >> 2] = f3;
 i27 = 1;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN5physx2Sc7BodySim12updateForcesEffbRKNS_6PxVec3Ebb(i16, f11, f4, i1, i12, i13, i14) {
 i16 = i16 | 0;
 f11 = Math_fround(f11);
 f4 = Math_fround(f4);
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i17 = 0, i18 = 0, f19 = f0;
 i17 = i16 + 146 | 0;
 i8 = HEAPU8[i17 >> 0] | 0;
 i9 = (i8 & 4 | 0) == 0;
 i10 = i16 + 144 | 0;
 i15 = HEAPU16[i10 >> 1] | 0;
 HEAP16[i10 >> 1] = i13 ? i15 | 2 : i15 & 65533;
 i15 = i16 + 52 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!(i8 & 6)) {
  i6 = 0;
  i7 = 0;
  i8 = 0;
  i5 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i1 + 156 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i6 = 0;
   i7 = 0;
   i8 = 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i6 = 0;
    i7 = 0;
    i8 = 0;
    i5 = 0;
    i2 = 0;
    i1 = 0;
   } else {
    i5 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    i6 = HEAP32[i3 + 16 >> 2] | 0;
    i7 = HEAP32[i3 + 20 >> 2] | 0;
    i8 = HEAP32[i3 + 24 >> 2] | 0;
    if (!i9) {
     i9 = HEAP32[i15 >> 2] | 0;
     f4 = Math_fround(HEAPF32[i3 + 32 >> 2]);
     i18 = i9 + 80 | 0;
     HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
     f4 = Math_fround(HEAPF32[i3 + 36 >> 2]);
     i18 = i9 + 84 | 0;
     HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
     f4 = Math_fround(HEAPF32[i3 + 40 >> 2]);
     i18 = i9 + 88 | 0;
     HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
     f4 = Math_fround(HEAPF32[i3 + 48 >> 2]);
     i18 = i9 + 96 | 0;
     HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
     f4 = Math_fround(HEAPF32[i3 + 52 >> 2]);
     i18 = i9 + 100 | 0;
     HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
     f4 = Math_fround(HEAPF32[i3 + 56 >> 2]);
     i9 = i9 + 104 | 0;
     HEAPF32[i9 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i9 >> 2]));
    }
   }
  } else {
   i6 = 0;
   i7 = 0;
   i8 = 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  }
 }
 if (!(HEAP16[i10 >> 1] & 1)) {
  f11 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(HEAPF32[i16 + 184 >> 2]) * f11));
  i18 = f11 > Math_fround(0.0);
  f11 = i18 ? f11 : Math_fround(0.0);
  f19 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f11);
  f4 = Math_fround(Math_fround(HEAPF32[i12 + 4 >> 2]) * f11);
  f11 = Math_fround(Math_fround(HEAPF32[i12 + 8 >> 2]) * f11);
  f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f4);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f11);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (i13 & i14) {
  i3 = HEAP16[i16 + 148 >> 1] | 0;
  if ((i3 & 65535) > 1) {
   f19 = Math_fround(Math_fround(1.0) / Math_fround(i3 & 65535));
   f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f19);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f19);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f19);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  } else i3 = i5;
 } else i3 = i5;
 HEAP32[i16 + 64 >> 2] = i3;
 HEAP32[i16 + 68 >> 2] = i2;
 HEAP32[i16 + 72 >> 2] = i1;
 HEAPF32[i16 + 76 >> 2] = Math_fround(0.0);
 HEAP32[i16 + 80 >> 2] = i6;
 HEAP32[i16 + 84 >> 2] = i7;
 HEAP32[i16 + 88 >> 2] = i8;
 HEAPF32[i16 + 92 >> 2] = Math_fround(0.0);
 i3 = HEAP8[i17 >> 0] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + 156 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i18 = (i3 & 255) >>> 1;
  i18 = i18 & 1;
  HEAP8[i17 >> 0] = i18;
  return;
 }
 if (!(__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0)) {
  i18 = (i3 & 255) >>> 1;
  i18 = i18 & 1;
  HEAP8[i17 >> 0] = i18;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i18 = (i3 & 255) >>> 1;
  i18 = i18 & 1;
  HEAP8[i17 >> 0] = i18;
  return;
 }
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i18 = (i3 & 255) >>> 1;
 i18 = i18 & 1;
 HEAP8[i17 >> 0] = i18;
 return;
}

function __Z23RecalculateSplineSlopeTI11QuaternionfEvR17AnimationCurveTplIT_Eif(i16, i17, f18) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 f18 = Math_fround(f18);
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i19 = 0, i20 = 0, i21 = 0;
 i4 = HEAP32[i16 + 164 >> 2] | 0;
 if ((i4 | 0) < 2) return;
 do if (!i17) {
  i20 = i16 + 152 | 0;
  i19 = HEAP32[i20 >> 2] | 0;
  f18 = Math_fround(HEAPF32[i19 + 52 >> 2]);
  f18 = Math_fround(f18 - Math_fround(HEAPF32[i19 >> 2]));
  f13 = Math_fround(HEAPF32[i19 + 56 >> 2]);
  f14 = Math_fround(HEAPF32[i19 + 60 >> 2]);
  f15 = Math_fround(HEAPF32[i19 + 64 >> 2]);
  f12 = Math_fround(HEAPF32[i19 + 68 >> 2]);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i19 + 4 >> 2]));
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i19 + 8 >> 2]));
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i19 + 12 >> 2]));
  f13 = Math_fround(f13 / f18);
  f14 = Math_fround(f14 / f18);
  f15 = Math_fround(f15 / f18);
  f18 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i19 + 16 >> 2])) / f18);
  HEAPF32[i19 + 20 >> 2] = f13;
  HEAPF32[i19 + 24 >> 2] = f14;
  HEAPF32[i19 + 28 >> 2] = f15;
  HEAPF32[i19 + 32 >> 2] = f18;
  i20 = HEAP32[i20 >> 2] | 0;
  HEAPF32[i20 + 36 >> 2] = f13;
  HEAPF32[i20 + 40 >> 2] = f14;
  HEAPF32[i20 + 44 >> 2] = f15;
  HEAPF32[i20 + 48 >> 2] = f18;
 } else {
  i19 = i16 + 152 | 0;
  i20 = HEAP32[i19 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i20 + (i17 * 52 | 0) >> 2]);
  i21 = i17 + -1 | 0;
  f13 = Math_fround(f1 - Math_fround(HEAPF32[i20 + (i21 * 52 | 0) >> 2]));
  f2 = Math_fround(HEAPF32[i20 + (i17 * 52 | 0) + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i20 + (i17 * 52 | 0) + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i20 + (i17 * 52 | 0) + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i20 + (i17 * 52 | 0) + 16 >> 2]);
  f7 = Math_fround(f2 - Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 4 >> 2]));
  f8 = Math_fround(f3 - Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 8 >> 2]));
  f12 = Math_fround(f5 - Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 12 >> 2]));
  f14 = Math_fround(f6 - Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 16 >> 2]));
  if ((i4 + -1 | 0) == (i17 | 0)) {
   f10 = Math_fround(f7 / f13);
   f11 = Math_fround(f8 / f13);
   f15 = Math_fround(f12 / f13);
   f18 = Math_fround(f14 / f13);
   HEAPF32[i20 + (i17 * 52 | 0) + 20 >> 2] = f10;
   HEAPF32[i20 + (i17 * 52 | 0) + 24 >> 2] = f11;
   HEAPF32[i20 + (i17 * 52 | 0) + 28 >> 2] = f15;
   HEAPF32[i20 + (i17 * 52 | 0) + 32 >> 2] = f18;
   i21 = HEAP32[i19 >> 2] | 0;
   HEAPF32[i21 + (i17 * 52 | 0) + 36 >> 2] = f10;
   HEAPF32[i21 + (i17 * 52 | 0) + 40 >> 2] = f11;
   HEAPF32[i21 + (i17 * 52 | 0) + 44 >> 2] = f15;
   HEAPF32[i21 + (i17 * 52 | 0) + 48 >> 2] = f18;
   break;
  }
  i21 = i17 + 1 | 0;
  f15 = Math_fround(Math_fround(HEAPF32[i20 + (i21 * 52 | 0) >> 2]) - f1);
  f1 = Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 12 >> 2]);
  f1 = Math_fround(f1 - f2);
  f2 = Math_fround(f11 - f3);
  f10 = Math_fround(f10 - f5);
  f11 = Math_fround(Math_fround(HEAPF32[i20 + (i21 * 52 | 0) + 16 >> 2]) - f6);
  i21 = f13 < Math_fround(0.0);
  f9 = Math_fround(-f13);
  if ((i21 ? f9 : f13) > Math_fround(9.99999974e-06)) {
   f9 = Math_fround(f7 / f13);
   f8 = Math_fround(f8 / f13);
   f7 = Math_fround(f12 / f13);
   f6 = Math_fround(f14 / f13);
  } else {
   f9 = Math_fround(0.0);
   f8 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f6 = Math_fround(0.0);
  }
  i21 = f15 < Math_fround(0.0);
  f14 = Math_fround(-f15);
  if ((i21 ? f14 : f15) > Math_fround(9.99999974e-06)) {
   f5 = Math_fround(f1 / f15);
   f3 = Math_fround(f2 / f15);
   f2 = Math_fround(f10 / f15);
   f1 = Math_fround(f11 / f15);
  } else {
   f5 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
  f12 = Math_fround(Math_fround(f18 + Math_fround(1.0)) * Math_fround(.5));
  f18 = Math_fround(Math_fround(Math_fround(1.0) - f18) * Math_fround(.5));
  f13 = Math_fround(Math_fround(f12 * f9) + Math_fround(f18 * f5));
  f14 = Math_fround(Math_fround(f12 * f8) + Math_fround(f18 * f3));
  f15 = Math_fround(Math_fround(f12 * f7) + Math_fround(f18 * f2));
  f18 = Math_fround(Math_fround(f12 * f6) + Math_fround(f18 * f1));
  HEAPF32[i20 + (i17 * 52 | 0) + 20 >> 2] = f13;
  HEAPF32[i20 + (i17 * 52 | 0) + 24 >> 2] = f14;
  HEAPF32[i20 + (i17 * 52 | 0) + 28 >> 2] = f15;
  HEAPF32[i20 + (i17 * 52 | 0) + 32 >> 2] = f18;
  i21 = HEAP32[i19 >> 2] | 0;
  HEAPF32[i21 + (i17 * 52 | 0) + 36 >> 2] = f13;
  HEAPF32[i21 + (i17 * 52 | 0) + 40 >> 2] = f14;
  HEAPF32[i21 + (i17 * 52 | 0) + 44 >> 2] = f15;
  HEAPF32[i21 + (i17 * 52 | 0) + 48 >> 2] = f18;
 } while (0);
 HEAPF32[i16 + 4 >> 2] = Math_fround(inf);
 HEAP32[i16 >> 2] = 0;
 HEAPF32[i16 + 80 >> 2] = Math_fround(inf);
 HEAP32[i16 + 76 >> 2] = 0;
 return;
}

function __ZN24CompressedAnimationCurve17CompressQuatCurveERN13AnimationClip15QuaternionCurveE(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i17;
 i14 = i17 + 28 | 0;
 i15 = i17 + 8 | 0;
 __ZN24CompressedAnimationCurve16CompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E(i12, i9 + 16 | 0);
 i7 = HEAP32[i9 + 180 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = i7;
 i16 = i14 + 16 | 0;
 HEAP32[i16 >> 2] = i7;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i11 = i4;
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i14 >> 2] = i1;
 i6 = (i7 | 0) > 0;
 if (i6) {
  i3 = i9 + 168 | 0;
  i2 = 0;
  do {
   i11 = i1 + (i2 << 4) | 0;
   i10 = (HEAP32[i3 >> 2] | 0) + (i2 * 52 | 0) + 4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i14 >> 2] | 0;
  } while ((i2 | 0) != (i7 | 0));
  __ZN16PackedQuatVector9PackQuatsEP11Quaternionfi(i12 + 20 | 0, i1, i7);
  if (i6) {
   i3 = HEAP32[i9 + 168 >> 2] | 0;
   i1 = 0;
   do {
    f20 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 20 >> 2]);
    f19 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 24 >> 2]);
    f18 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 28 >> 2]);
    i2 = f20 == f20 & f19 == f19 & (f18 == f18 & Math_fround(0.0) == Math_fround(0.0));
    f18 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 32 >> 2]);
    i2 = i2 & (f18 == f18 & Math_fround(0.0) == Math_fround(0.0));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i7 | 0) & i2);
  } else i2 = 1;
 } else {
  __ZN16PackedQuatVector9PackQuatsEP11Quaternionfi(i12 + 20 | 0, i1, i7);
  i2 = 1;
 }
 i5 = i7 << 3;
 HEAP32[i15 + 12 >> 2] = i5;
 i10 = i15 + 16 | 0;
 HEAP32[i10 >> 2] = i5;
 i11 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i3 = i4;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i11;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 5, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i15 >> 2] = i4;
 if (i6) {
  i3 = HEAP32[i9 + 168 >> 2] | 0;
  i1 = 0;
  do {
   i8 = HEAP32[i3 + (i1 * 52 | 0) + 24 >> 2] | 0;
   i6 = HEAP32[i3 + (i1 * 52 | 0) + 28 >> 2] | 0;
   i21 = HEAP32[i3 + (i1 * 52 | 0) + 32 >> 2] | 0;
   i22 = i1 << 2;
   HEAP32[i4 + (i22 << 2) >> 2] = HEAP32[i3 + (i1 * 52 | 0) + 20 >> 2];
   HEAP32[i4 + ((i22 | 1) << 2) >> 2] = i8;
   HEAP32[i4 + ((i22 | 2) << 2) >> 2] = i6;
   HEAP32[i4 + ((i22 | 3) << 2) >> 2] = i21;
   i22 = HEAP32[i3 + (i1 * 52 | 0) + 40 >> 2] | 0;
   i21 = HEAP32[i3 + (i1 * 52 | 0) + 44 >> 2] | 0;
   i6 = HEAP32[i3 + (i1 * 52 | 0) + 48 >> 2] | 0;
   i8 = i1 + i7 << 2;
   HEAP32[i4 + (i8 << 2) >> 2] = HEAP32[i3 + (i1 * 52 | 0) + 36 >> 2];
   HEAP32[i4 + ((i8 | 1) << 2) >> 2] = i22;
   HEAP32[i4 + ((i8 | 2) << 2) >> 2] = i21;
   HEAP32[i4 + ((i8 | 3) << 2) >> 2] = i6;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  i8 = i15;
 } else i8 = i15;
 i1 = i12 + 36 | 0;
 if (i2) __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i1, i4, 1, 4, i7 << 2, 6, 0); else __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i1, i4, 1, 4, i5, 6, 0);
 HEAP32[i12 + 64 >> 2] = HEAP32[i9 + 188 >> 2];
 HEAP32[i12 + 68 >> 2] = HEAP32[i9 + 192 >> 2];
 i1 = i12 + 72 | 0;
 do if ((i1 | 0) != (i9 | 0)) {
  i6 = HEAP8[i9 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
  i6 = i4 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 80 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 76 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i12 + 76 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11);
  HEAP32[i8 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZL14MakeNiceFloat3RKN4math7_float3E(i9, f1, f6, f8) {
 i9 = i9 | 0;
 f1 = Math_fround(f1);
 f6 = Math_fround(f6);
 f8 = Math_fround(f8);
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, f7 = f0;
 f5 = Math_fround((f1 > Math_fround(0.0) & 1) - (f1 < Math_fround(0.0) & 1) | 0);
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (i4 >>> 23 & 255) + -127 | 0;
 do if ((i2 | 0) > 23) f7 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2])); else if ((i2 | 0) < -23) f7 = Math_fround(0.0); else {
  i2 = ~~f1 >>> 0;
  f3 = Math_fround(i2 >>> 0);
  f1 = Math_fround(f1 - f3);
  if (f1 < Math_fround(9.99999974e-06)) {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
  if (f1 > Math_fround(.999989986)) {
   f7 = Math_fround((i2 + 1 | 0) >>> 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   f7 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  } else {
   f7 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 } while (0);
 f5 = Math_fround((f6 > Math_fround(0.0) & 1) - (f6 < Math_fround(0.0) & 1) | 0);
 f1 = Math_fround(Math_abs(Math_fround(f6)));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (i4 >>> 23 & 255) + -127 | 0;
 do if ((i2 | 0) > 23) f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2])); else if ((i2 | 0) < -23) f5 = Math_fround(0.0); else {
  i2 = ~~f1 >>> 0;
  f3 = Math_fround(i2 >>> 0);
  f1 = Math_fround(f1 - f3);
  if (f1 < Math_fround(9.99999974e-06)) {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
  if (f1 > Math_fround(.999989986)) {
   f6 = Math_fround((i2 + 1 | 0) >>> 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  } else {
   f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 } while (0);
 f6 = Math_fround((f8 > Math_fround(0.0) & 1) - (f8 < Math_fround(0.0) & 1) | 0);
 f1 = Math_fround(Math_abs(Math_fround(f8)));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (i4 >>> 23 & 255) + -127 | 0;
 if ((i2 | 0) > 23) {
  f8 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i9 >> 2] = f7;
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = f8;
  return;
 }
 if ((i2 | 0) < -23) {
  f8 = Math_fround(0.0);
  HEAPF32[i9 >> 2] = f7;
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = f8;
  return;
 }
 i2 = ~~f1 >>> 0;
 f3 = Math_fround(i2 >>> 0);
 f1 = Math_fround(f1 - f3);
 if (f1 < Math_fround(9.99999974e-06)) {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i9 >> 2] = f7;
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = f8;
  return;
 }
 if (f1 > Math_fround(.999989986)) {
  f8 = Math_fround((i2 + 1 | 0) >>> 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i9 >> 2] = f7;
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = f8;
  return;
 } else {
  f8 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i9 >> 2] = f7;
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = f8;
  return;
 }
}

function __ZN18AwakeFromLoadQueueC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 104 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 124 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 144 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 164 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 184 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 204 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i5 = i4;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 224 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i7 = i4;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 244 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i4 = i2;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 124 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 164 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 184 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 204 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 224 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 244 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 264 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i29, i28) {
 i29 = i29 | 0;
 i28 = i28 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i30 + 84 | 0;
 i12 = i30 + 72 | 0;
 i19 = i30 + 60 | 0;
 i21 = i30 + 48 | 0;
 i22 = i30 + 36 | 0;
 i23 = i30 + 24 | 0;
 i24 = i30 + 12 | 0;
 i25 = i30;
 i26 = i28 + 12 | 0;
 f27 = Math_fround(HEAPF32[i26 >> 2]);
 f13 = Math_fround(HEAPF32[i28 >> 2]);
 f3 = Math_fround(f27 - f13);
 i14 = i28 + 16 | 0;
 f15 = Math_fround(HEAPF32[i14 >> 2]);
 f16 = Math_fround(HEAPF32[i28 + 4 >> 2]);
 f1 = Math_fround(f15 - f16);
 i17 = i28 + 20 | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 f20 = Math_fround(HEAPF32[i28 + 8 >> 2]);
 f4 = Math_fround(f18 - f20);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f1 * f1)) + Math_fround(f4 * f4))));
 if (f2 > Math_fround(0.0)) {
  f9 = Math_fround(Math_fround(1.0) / f2);
  f1 = Math_fround(f1 * f9);
  f3 = Math_fround(f3 * f9);
  f4 = Math_fround(f4 * f9);
 }
 i5 = Math_fround(Math_abs(Math_fround(f3))) < Math_fround(.707106769);
 f2 = Math_fround(-f1);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 f2 = Math_fround(-f4);
 i10 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 f9 = i5 ? f2 : f3;
 i6 = i5 ? 0 : i6;
 f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8));
 f2 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + f7)));
 if (f7 > Math_fround(0.0)) {
  f31 = Math_fround(Math_fround(1.0) / f7);
  f7 = Math_fround(f8 * f31);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f9 = Math_fround(f9 * f31);
  f8 = Math_fround(f2 * f31);
  f2 = f8;
  i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  f7 = f8;
  i5 = i10;
 }
 f36 = Math_fround(Math_fround(f1 * f2) - Math_fround(f4 * f9));
 f35 = Math_fround(Math_fround(f4 * f7) - Math_fround(f3 * f2));
 f34 = Math_fround(Math_fround(f3 * f9) - Math_fround(f1 * f7));
 f31 = Math_fround(HEAPF32[i28 + 24 >> 2]);
 f8 = Math_fround(f31 * Math_fround(.25));
 f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
 f32 = Math_fround(f9 * f8);
 f2 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
 f8 = Math_fround(f8 * Math_fround(1.73205078));
 f9 = Math_fround(f36 * f8);
 f7 = Math_fround(f35 * f8);
 f8 = Math_fround(f34 * f8);
 f34 = Math_fround(f27 - Math_fround(f3 * f31));
 f3 = Math_fround(f15 - Math_fround(f1 * f31));
 f18 = Math_fround(f18 - Math_fround(f4 * f31));
 HEAP32[i29 >> 2] = 1;
 i28 = i29 + 32 | 0;
 HEAP32[i28 >> 2] = 0;
 HEAPF32[i11 >> 2] = f13;
 HEAPF32[i11 + 4 >> 2] = f16;
 HEAPF32[i11 + 8 >> 2] = f20;
 i11 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i11) | 0;
 HEAP32[i12 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i17 >> 2];
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i11, i12) | 0;
 HEAP32[i29 >> 2] = 4;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i19 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i17 >> 2];
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i19) | 0;
 f20 = Math_fround(f33 + Math_fround(f34 + f33));
 f27 = Math_fround(f32 + Math_fround(f32 + f3));
 f31 = Math_fround(f2 + Math_fround(f2 + f18));
 HEAPF32[i21 >> 2] = f20;
 HEAPF32[i21 + 4 >> 2] = f27;
 HEAPF32[i21 + 8 >> 2] = f31;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i21) | 0;
 f15 = Math_fround(f34 - f33);
 f16 = Math_fround(f3 - f32);
 f18 = Math_fround(f18 - f2);
 f4 = Math_fround(f16 - f7);
 f13 = Math_fround(f18 - f8);
 HEAPF32[i22 >> 2] = Math_fround(f15 - f9);
 HEAPF32[i22 + 4 >> 2] = f4;
 HEAPF32[i22 + 8 >> 2] = f13;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i22) | 0;
 f16 = Math_fround(f7 + f16);
 f18 = Math_fround(f8 + f18);
 HEAPF32[i23 >> 2] = Math_fround(f15 + f9);
 HEAPF32[i23 + 4 >> 2] = f16;
 HEAPF32[i23 + 8 >> 2] = f18;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i23) | 0;
 HEAP32[i24 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i17 >> 2];
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i24) | 0;
 HEAPF32[i25 >> 2] = f20;
 HEAPF32[i25 + 4 >> 2] = f27;
 HEAPF32[i25 + 8 >> 2] = f31;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i29, i25) | 0;
 STACKTOP = i30;
 return i29 | 0;
}

function __ZN20TextRenderingPrivate17TextMeshGenerator8GenerateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 8 | 0;
 i11 = i17;
 i12 = i17 + 484 | 0;
 i15 = i17 + 40 | 0;
 i5 = i17 + 504 | 0;
 i16 = i17 + 24 | 0;
 i6 = i10 + 68 | 0;
 i1 = (HEAP32[i10 + 72 >> 2] << 2) + 4 | 0;
 i3 = gb + 64016 | 0;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i12 >> 2] = 0;
 i13 = i12 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i11);
 i3 = i9;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i14;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i4;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 60 | 0, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
 }
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i11);
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 10;
  }
 }
 if ((i7 | 0) == 8) i7 = 10;
 if ((i7 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i20 = HEAP32[i1 + 48 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 + 64 >> 2];
 i2 = HEAP32[i10 + 52 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAPF32[i11 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i3 = (HEAP8[i10 + 49 >> 0] | 0) != 0;
 i4 = HEAP32[i10 + 60 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i10 + 40 >> 2]);
 i8 = HEAP32[i10 + 36 >> 2] | 0;
 i7 = ~~Math_fround(HEAPF32[i10 + 44 >> 2]);
 i1 = (HEAP8[i10 + 28 >> 0] | 0) != 0;
 f18 = Math_fround(HEAPF32[i10 + 56 >> 2]);
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE(i15, i6, i20, i9, i2, Math_fround(1.0), i11, i3, i4, f19, i8, i7, i1, f18, Math_fround(1.0), 1, 0, 0, i12);
 __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv(i15) | 0;
 i1 = HEAP32[i15 + 280 >> 2] | 0;
 i7 = i1 * 6 | 0;
 HEAP32[i9 >> 2] = 0;
 i8 = i9 + 4 | 0;
 i4 = gb + 63160 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 i1 = i1 * 12 | 0;
 do if (!i1) {
  i1 = 0;
  i6 = 0;
 } else {
  i2 = (i1 | 2) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i6 = 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, gb + 64016 | 0, 0, gb + 945083 | 0, 317) | 0;
   i20 = gb + 64016 | 0;
   i5 = HEAP32[i20 >> 2] | 0;
   i20 = HEAP32[i20 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = i6;
   i1 = i8;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i20;
   i1 = i6;
   break;
  }
 } while (0);
 i2 = i1 + 1 & -2;
 i3 = i2;
 i4 = i15 + 20 | 0;
 i5 = i15 + 36 | 0;
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i15 + 24 | 0);
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else i1 = i6;
 HEAP32[i5 >> 2] = (i3 + (i7 << 1) - i2 | 0) >>> 1 | -2147483648;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i15 + 32 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj(i15, i11) | 0;
 i20 = i10 + 8 | 0;
 __ZN20TextRenderingPrivate19NativeTextGenerator9GetBoundsEv(i16, i15);
 HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 __ZN20TextRenderingPrivate19NativeTextGenerator11SetMeshDataERNS_17TextMeshGeneratorE(i15, i10);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev(i15);
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i14);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx15PxVehicleWheels17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx22PxVehicleWheelsSimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx22PxVehicleWheelsDynData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i11 >> 2] = HEAP32[gb + 161968 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 161968 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 161968 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 161968 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 161968 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 161968 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 161968 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 161968 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 828315;
 HEAP32[i10 + 4 >> 2] = gb + 827530;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 128;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 162e3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 162e3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 162e3 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 162e3 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 162e3 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 162e3 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 162e3 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 162e3 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 162032 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 162032 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 162032 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 162032 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 162032 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 162032 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 162032 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 162032 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 162064 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 162064 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 162064 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 162064 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 162064 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 162064 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 162064 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 162064 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 162096 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 162096 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 162096 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 162096 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 162096 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 162096 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 162096 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 162096 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 162128 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 162128 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 162128 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 162128 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 162128 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 162128 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 162128 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 162128 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 162160 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 162160 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 162160 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 162160 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 162160 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 162160 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 162160 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 162160 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 162192 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 162192 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 162192 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 162192 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 162192 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 162192 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 162192 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 162192 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb(i5, i17, i6, i1) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 816 | 0;
 i11 = i18 + 544 | 0;
 i15 = i18 + 272 | 0;
 i14 = i18;
 i3 = i5 + 2540 | 0;
 if (i1) {
  __ZN5physx3Scb5Scene16removeRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE(i5, i17, i3);
  i17 = i17 + 4 | 0;
  i16 = HEAP32[i17 >> 2] | 0;
  i16 = i16 & -33;
  HEAP32[i17 >> 2] = i16;
  STACKTOP = i18;
  return;
 }
 i4 = i5 + 2433 | 0;
 L5 : do if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6removeERNS0_2Sc5SceneERS2_b(i5 + 16 | 0, i17, i6);
  i13 = i17 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 268435455;
  HEAP32[i17 >> 2] = 0;
 } else {
  i1 = i17 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  switch (i2 >>> 30 | 0) {
  case 1:
   {
    HEAP32[i1 >> 2] = i2 & 1073741823;
    HEAP32[i16 >> 2] = i17;
    __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i16) | 0;
    break L5;
   }
  case 2:
   break;
  default:
   break L5;
  }
  HEAP32[i1 >> 2] = i2 | -1073741824;
  if (!(i2 & 268435456)) {
   HEAP32[i11 >> 2] = i17;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i11, i16) | 0;
   if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i17;
  }
 } while (0);
 if (!(HEAP8[i4 >> 0] | 0)) {
  i17 = i17 + 4 | 0;
  i16 = HEAP32[i17 >> 2] | 0;
  i16 = i16 & -33;
  HEAP32[i17 >> 2] = i16;
  STACKTOP = i18;
  return;
 }
 if (i6) {
  i13 = i17 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 16;
 }
 i1 = HEAP32[i5 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i6 = i1 + -16 | 0;
  i7 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i17, i16) | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i9 = HEAP32[i17 + 4 >> 2] & -1073741824;
  if (i7 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i9;
     HEAP32[i2 + i6 >> 2] = i8;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i6 = i1 + -16 | 0;
  i7 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i17, i16) | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i9 = HEAP32[i17 + 4 >> 2] & -1073741824;
  if (i7 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i9;
     HEAP32[i2 + i6 >> 2] = i8;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 i17 = i17 + 4 | 0;
 i16 = HEAP32[i17 >> 2] | 0;
 i16 = i16 & -33;
 HEAP32[i17 >> 2] = i16;
 STACKTOP = i18;
 return;
}

function __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii(i15, i16, i27, i37) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i27 = i27 | 0;
 i37 = i37 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0;
 if ((i27 | 0) <= 0) return;
 i43 = i15 + 869 | 0;
 i44 = i15 + 868 | 0;
 i45 = i15 + 872 | 0;
 i17 = i15 + 420 | 0;
 i18 = i15 + 480 | 0;
 i19 = i15 + 500 | 0;
 i20 = i15 + 520 | 0;
 i21 = i15 + 540 | 0;
 i22 = i15 + 880 | 0;
 i23 = i15 + 876 | 0;
 i24 = i15 + 728 | 0;
 i25 = i15 + 440 | 0;
 i26 = i15 + 460 | 0;
 i28 = i15 + 400 | 0;
 i29 = i15 + 360 | 0;
 i30 = i15 + 380 | 0;
 i31 = i15 + 300 | 0;
 i32 = i15 + 320 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i6 = HEAP32[i15 + 60 >> 2] | 0;
 i7 = HEAP32[i15 + 120 >> 2] | 0;
 i8 = HEAP32[i15 + 20 >> 2] | 0;
 i9 = HEAP32[i15 + 80 >> 2] | 0;
 i10 = HEAP32[i15 + 140 >> 2] | 0;
 i11 = HEAP32[i15 + 40 >> 2] | 0;
 i12 = HEAP32[i15 + 100 >> 2] | 0;
 i13 = HEAP32[i15 + 160 >> 2] | 0;
 i14 = HEAP32[i15 + 340 >> 2] | 0;
 i42 = HEAP16[i15 + 870 >> 1] | 0;
 i33 = (i42 & 65535) < 256;
 i34 = i15 + 180 | 0;
 i35 = i15 + 200 | 0;
 i36 = i15 + 220 | 0;
 i38 = i15 + 240 | 0;
 i39 = i15 + 260 | 0;
 i40 = i15 + 280 | 0;
 i4 = 0;
 i42 = i42 & 255;
 do {
  i41 = i4 + i37 | 0;
  i46 = i16 + (i4 * 120 | 0) | 0;
  i1 = i16 + (i4 * 120 | 0) + 12 | 0;
  i3 = i16 + (i4 * 120 | 0) + 24 | 0;
  HEAP32[i5 + (i41 << 2) >> 2] = HEAP32[i46 >> 2];
  HEAP32[i6 + (i41 << 2) >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + (i41 << 2) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + (i41 << 2) >> 2] = HEAP32[i46 + 4 >> 2];
  HEAP32[i9 + (i41 << 2) >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + (i41 << 2) >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i11 + (i41 << 2) >> 2] = HEAP32[i46 + 8 >> 2];
  HEAP32[i12 + (i41 << 2) >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i13 + (i41 << 2) >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i14 + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 68 >> 2];
  if (i42 << 24 >> 24) {
   HEAP32[(HEAP32[i31 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 60 >> 2];
   HEAP32[(HEAP32[i32 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 64 >> 2];
  }
  if (HEAP8[i43 >> 0] | 0) {
   HEAP32[(HEAP32[i28 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 80 >> 2];
   if (i42 << 24 >> 24) {
    HEAP32[(HEAP32[i29 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 72 >> 2];
    HEAP32[(HEAP32[i30 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 76 >> 2];
   }
  }
  i46 = HEAP32[i44 >> 2] | 0;
  i42 = i46 >>> 16 & 255;
  if ((i46 & 255) << 24 >> 24) {
   i46 = i16 + (i4 * 120 | 0) + 48 | 0;
   HEAP32[(HEAP32[i38 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 >> 2];
   HEAP32[(HEAP32[i39 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[(HEAP32[i40 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 + 8 >> 2];
  }
  if (HEAP8[i45 >> 0] | 0) {
   i46 = i16 + (i4 * 120 | 0) + 36 | 0;
   HEAP32[(HEAP32[i34 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 >> 2];
   HEAP32[(HEAP32[i35 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 + 4 >> 2];
   HEAP32[(HEAP32[i36 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i46 + 8 >> 2];
  }
  HEAP32[(HEAP32[i17 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 84 >> 2];
  if (!i33) {
   HEAP32[(HEAP32[i25 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 88 >> 2];
   HEAP32[(HEAP32[i26 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 92 >> 2];
  }
  HEAP32[(HEAP32[i18 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 96 >> 2];
  HEAP32[(HEAP32[i19 >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 100 >> 2];
  i1 = i16 + (i4 * 120 | 0) + 108 | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  i46 = f2 == Math_fround(0.0);
  if (i46 | f2 == Math_fround(inf)) HEAPF32[(HEAP32[i20 >> 2] | 0) + (i41 << 2) >> 2] = Math_fround(0.0); else {
   f2 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i16 + (i4 * 120 | 0) + 104 >> 2])) / f2) * Math_fround(100.0));
   HEAPF32[(HEAP32[i20 >> 2] | 0) + (i41 << 2) >> 2] = f2;
  }
  f2 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[(HEAP32[i21 >> 2] | 0) + (i41 << 2) >> 2] = f2;
  i3 = HEAP32[i22 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[(HEAP32[i15 + 560 + (i1 * 20 | 0) >> 2] | 0) + (i41 << 2) >> 2] = HEAP32[i16 + (i4 * 120 | 0) + 112 + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
  if (HEAP8[i23 >> 0] | 0) {
   i46 = (HEAP32[i24 >> 2] | 0) + (i41 >>> 5 << 2) | 0;
   HEAP32[i46 >> 2] = HEAP32[i46 >> 2] & ~(1 << (i41 & 31));
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i27 | 0));
 return;
}

function __ZN20GpuProgramParameters21UpdateParamBufferSizeEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i7 = i15 + 16 | 0;
 i4 = i15 + 4 | 0;
 i5 = i15 + 8 | 0;
 i8 = HEAP32[i15 + 28 >> 2] | 0;
 if (i8 >>> 0 > 1) {
  i1 = HEAP32[i7 >> 2] | 0;
  __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i1, i1 + (i8 * 20 | 0) | 0, i13);
  i1 = i7;
  i14 = 5;
 } else if (!i8) i2 = 0; else {
  i1 = i7;
  i14 = 5;
 }
 L5 : do if ((i14 | 0) == 5) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP8[i2 + (i1 * 20 | 0) + 17 >> 0] | 0) != 1) {
    i2 = i1;
    break L5;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i8 >>> 0) {
    i2 = i1;
    break;
   }
  }
 } while (0);
 HEAP32[i15 >> 2] = i2;
 L11 : do if (i8 >>> 0 > i2 >>> 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = i2;
  while (1) {
   if (HEAP8[i3 + (i1 * 20 | 0) + 18 >> 0] & 1) {
    i6 = i1;
    break L11;
   }
   i1 = i1 + 1 | 0;
   if (i8 >>> 0 <= i1 >>> 0) {
    i6 = i1;
    break;
   }
  }
 } else i6 = i2; while (0);
 HEAP32[i4 >> 2] = i6 - i2;
 HEAP32[i5 >> 2] = i8 - i6;
 if (!i2) {
  i1 = 0;
  i2 = 0;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = 0;
  i1 = 0;
  do {
   i12 = HEAP32[i4 + (i3 * 20 | 0) + 8 >> 2] | 0;
   i1 = ((i12 | 0) == 0 ? 8 : (i12 << 2) + 4 | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 if ((i2 | 0) != (i6 | 0)) {
  i3 = HEAP32[i7 >> 2] | 0;
  do {
   i12 = HEAP32[i3 + (i2 * 20 | 0) + 8 >> 2] | 0;
   i1 = ((i12 | 0) == 0 ? 20 : i12 << 4 | 4) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
 }
 if ((i8 | 0) != (i6 | 0)) {
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = i6;
  do {
   i12 = HEAP32[i3 + (i2 * 20 | 0) + 8 >> 2] | 0;
   i1 = ((i12 | 0) == 0 ? 68 : i12 << 6 | 4) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
 }
 i1 = i1 + 4 | 0;
 i11 = i15 + 80 | 0;
 i12 = i15 + 84 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i12 >> 2] | 0) == (i2 | 0)) {
  i12 = i1;
  i14 = i15 + 36 | 0;
  i13 = i15 + 40 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i14 = i13 - i14 | 0;
  i14 = i14 >> 4;
  i14 = i14 * 12 | 0;
  i13 = i15 + 72 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 * 20 | 0;
  i12 = i12 + 8 | 0;
  i13 = i12 + i13 | 0;
  i14 = i13 + i14 | 0;
  i15 = i15 + 12 | 0;
  HEAP32[i15 >> 2] = i14;
  STACKTOP = i16;
  return;
 }
 i10 = 0;
 do {
  i9 = i2;
  i8 = i9 + (i10 * 52 | 0) + 4 | 0;
  i4 = i9 + (i10 * 52 | 0) + 36 | 0;
  i5 = i9 + (i10 * 52 | 0) + 40 | 0;
  i6 = i9 + (i10 * 52 | 0) + 44 | 0;
  i9 = HEAP32[i9 + (i10 * 52 | 0) + 16 >> 2] | 0;
  if (i9 >>> 0 > 1) {
   i2 = HEAP32[i8 >> 2] | 0;
   __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i2, i2 + (i9 * 20 | 0) | 0, i13);
   i2 = i8;
   i14 = 28;
  } else if (!i9) i3 = 0; else {
   i2 = i8;
   i14 = 28;
  }
  L41 : do if ((i14 | 0) == 28) {
   i14 = 0;
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = 0;
   do {
    if ((HEAP8[i2 + (i3 * 20 | 0) + 17 >> 0] | 0) != 1) break L41;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i9 >>> 0);
  } while (0);
  HEAP32[i4 >> 2] = i3;
  L47 : do if (i9 >>> 0 > i3 >>> 0) {
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = i3;
   while (1) {
    if (HEAP8[i4 + (i2 * 20 | 0) + 18 >> 0] & 1) {
     i7 = i2;
     break L47;
    }
    i2 = i2 + 1 | 0;
    if (i9 >>> 0 <= i2 >>> 0) {
     i7 = i2;
     break;
    }
   }
  } else i7 = i3; while (0);
  HEAP32[i5 >> 2] = i7 - i3;
  HEAP32[i6 >> 2] = i9 - i7;
  if (!i3) {
   i2 = 0;
   i3 = 0;
  } else {
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = 0;
   i2 = 0;
   do {
    i6 = HEAP32[i5 + (i4 * 20 | 0) + 8 >> 2] | 0;
    i2 = ((i6 | 0) == 0 ? 8 : (i6 << 2) + 4 | 0) + i2 | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i3 | 0));
  }
  if ((i3 | 0) != (i7 | 0)) {
   i4 = HEAP32[i8 >> 2] | 0;
   do {
    i6 = HEAP32[i4 + (i3 * 20 | 0) + 8 >> 2] | 0;
    i2 = ((i6 | 0) == 0 ? 20 : i6 << 4 | 4) + i2 | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i7 | 0));
  }
  if ((i9 | 0) != (i7 | 0)) {
   i4 = HEAP32[i8 >> 2] | 0;
   i3 = i7;
   do {
    i8 = HEAP32[i4 + (i3 * 20 | 0) + 8 >> 2] | 0;
    i2 = ((i8 | 0) == 0 ? 68 : i8 << 6 | 4) + i2 | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i9 | 0));
  }
  i1 = i1 + 4 + i2 | 0;
  i10 = i10 + 1 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } while (i10 >>> 0 < (((HEAP32[i12 >> 2] | 0) - i2 | 0) / 52 | 0) >>> 0);
 i14 = i15 + 36 | 0;
 i13 = i15 + 40 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i14 = i13 - i14 | 0;
 i14 = i14 >> 4;
 i14 = i14 * 12 | 0;
 i13 = i15 + 72 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i13 = i13 * 20 | 0;
 i12 = i1 + 8 | 0;
 i13 = i12 + i13 | 0;
 i14 = i13 + i14 | 0;
 i15 = i15 + 12 | 0;
 HEAP32[i15 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __Z28tessMeshTessellateMonoRegionP8TESSmeshP8TESSface(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = i1 + 8 | 0;
 while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 16 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  i4 = HEAP32[i3 + 16 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  if (!(f6 < f5)) {
   if (!(f6 == f5)) break;
   f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (!(f9 <= Math_fround(HEAPF32[i4 + 28 >> 2]))) break;
  }
  i1 = (HEAP32[i3 + 8 >> 2] | 0) + 4 | 0;
 }
 while (1) {
  if (!(f5 < f6)) {
   if (!(f5 == f6)) break;
   f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
   if (!(f9 <= Math_fround(HEAPF32[i1 + 28 >> 2]))) break;
  }
  i12 = HEAP32[i3 + 12 >> 2] | 0;
  i4 = HEAP32[i12 + 16 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  i1 = HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 16 >> 2] | 0;
  i3 = i12;
  f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 }
 i1 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 4 >> 2] | 0;
 L14 : do if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) {
  i2 = i1;
  i13 = i3;
 } else {
  L15 : while (1) {
   i11 = i1 + 16 | 0;
   i12 = i1 + 12 | 0;
   while (1) {
    i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 16 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i4 + 24 >> 2]);
    i7 = HEAP32[i11 >> 2] | 0;
    f6 = Math_fround(HEAPF32[i7 + 24 >> 2]);
    if (f5 < f6) break;
    if (f5 == f6) {
     f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
     if (f9 <= Math_fround(HEAPF32[i7 + 28 >> 2])) break;
    }
    L23 : do if ((HEAP32[i12 >> 2] | 0) != (i3 | 0)) do {
     i8 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 4 >> 2] | 0;
     i10 = HEAP32[i8 + 16 >> 2] | 0;
     f9 = Math_fround(HEAPF32[i10 + 24 >> 2]);
     i4 = HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + 16 >> 2] | 0;
     f5 = Math_fround(HEAPF32[i4 + 24 >> 2]);
     do if (!(f9 < f5)) {
      if (f9 == f5) {
       f6 = Math_fround(HEAPF32[i10 + 28 >> 2]);
       if (f6 <= Math_fround(HEAPF32[i4 + 28 >> 2])) break;
      }
      i4 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 16 >> 2] | 0;
      i7 = HEAP32[i3 + 16 >> 2] | 0;
      f5 = Math_fround(HEAPF32[i7 + 24 >> 2]);
      f6 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 24 >> 2]));
      f5 = Math_fround(f9 - f5);
      if (Math_fround(f6 + f5) > Math_fround(0.0)) {
       f9 = Math_fround(HEAPF32[i7 + 28 >> 2]);
       f6 = Math_fround(f6 * Math_fround(f9 - Math_fround(HEAPF32[i10 + 28 >> 2])));
       if (!(Math_fround(f6 + Math_fround(f5 * Math_fround(f9 - Math_fround(HEAPF32[i4 + 28 >> 2])))) >= Math_fround(0.0))) break L23;
      }
     } while (0);
     i3 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i14, i3, i8) | 0;
     if (!i3) {
      i1 = 0;
      i3 = 36;
      break L15;
     }
     i3 = HEAP32[i3 + 4 >> 2] | 0;
    } while ((HEAP32[i12 >> 2] | 0) != (i3 | 0)); while (0);
    i3 = HEAP32[i3 + 12 >> 2] | 0;
    if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) {
     i2 = i1;
     i13 = i3;
     break L14;
    }
   }
   i4 = HEAP32[i12 >> 2] | 0;
   L36 : do if ((i4 | 0) != (i3 | 0)) do {
    i10 = HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 16 >> 2] | 0;
    f9 = Math_fround(HEAPF32[i10 + 24 >> 2]);
    i7 = HEAP32[i4 + 16 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i7 + 24 >> 2]);
    do if (!(f9 < f5)) {
     if (f9 == f5) {
      f6 = Math_fround(HEAPF32[i10 + 28 >> 2]);
      if (f6 <= Math_fround(HEAPF32[i7 + 28 >> 2])) break;
     }
     i7 = HEAP32[i1 + 16 >> 2] | 0;
     i8 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 16 >> 2] | 0;
     f5 = Math_fround(HEAPF32[i8 + 24 >> 2]);
     f6 = Math_fround(f5 - Math_fround(HEAPF32[i7 + 24 >> 2]));
     f5 = Math_fround(f9 - f5);
     if (Math_fround(f6 + f5) > Math_fround(0.0)) {
      f9 = Math_fround(HEAPF32[i8 + 28 >> 2]);
      f6 = Math_fround(f6 * Math_fround(f9 - Math_fround(HEAPF32[i10 + 28 >> 2])));
      if (!(Math_fround(f6 + Math_fround(f5 * Math_fround(f9 - Math_fround(HEAPF32[i7 + 28 >> 2])))) <= Math_fround(0.0))) break L36;
     }
    } while (0);
    i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i14, i4, i1) | 0;
    if (!i1) {
     i1 = 0;
     i3 = 36;
     break L15;
    }
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = HEAP32[i1 + 12 >> 2] | 0;
   } while ((i4 | 0) != (i3 | 0)); while (0);
   i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 4 >> 2] | 0;
   if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) {
    i2 = i1;
    i13 = i3;
    break L14;
   }
  }
  if ((i3 | 0) == 36) return i1 | 0;
 } while (0);
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) == (i13 | 0)) {
  i14 = 1;
  return i14 | 0;
 }
 while (1) {
  i1 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i14, i1, i2) | 0;
  if (!i1) {
   i1 = 0;
   i3 = 36;
   break;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] | 0) == (i13 | 0)) {
   i1 = 1;
   i3 = 36;
   break;
  }
 }
 if ((i3 | 0) == 36) return i1 | 0;
 return 0;
}

function __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i4 = HEAP32[gb + 36980 >> 2] | 0;
 i2 = 0;
 do {
  i3 = i14 + (i2 << 2) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, HEAP32[gb + 43960 + (i2 << 2) >> 2] | 0, i4, i13, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i3, i15); else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 8);
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i12 = i15 + 16 | 0;
 i7 = i15 + 80 | 0;
 i8 = i15 + 20 | 0;
 i9 = i15 + 32 | 0;
 i10 = i15 + 36 | 0;
 i11 = i15 + 24 | 0;
 i3 = 0;
 do {
  i4 = i14 + 32 + (i3 << 1) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, HEAP32[gb + 43992 + (i3 << 2) >> 2] | 0, i5, i13, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i2 = HEAP32[i8 >> 2] | 0;
    i1 = i2 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i12 >> 2] = i1;
    if (i1 >>> 0 < i2 >>> 0) i6 = 16; else {
     i2 = i1 + 2 | 0;
     if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) i6 = 16; else {
      HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
      HEAP32[i12 >> 2] = i2;
     }
    }
    if ((i6 | 0) == 16) {
     i6 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i12, i4, 2);
    }
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
   } else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 8);
 i3 = 0;
 do {
  i4 = i14 + 48 + (i3 << 1) | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, HEAP32[gb + 44024 + (i3 << 2) >> 2] | 0, i5, i13, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i2 = HEAP32[i8 >> 2] | 0;
    i1 = i2 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i12 >> 2] = i1;
    if (i1 >>> 0 < i2 >>> 0) i6 = 46; else {
     i2 = i1 + 2 | 0;
     if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) i6 = 46; else {
      HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
      HEAP32[i12 >> 2] = i2;
     }
    }
    if ((i6 | 0) == 46) {
     i6 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i12, i4, 2);
    }
    if (HEAP32[i15 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
   } else {
    i1 = HEAP32[i13 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i15 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i15);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 8);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead12GradientModeEvRT_RT0_PKc17TransferMetaFlags(i15, i14 + 68 | 0, gb + 1034151 | 0, 1);
 i2 = i14 + 64 | 0;
 i3 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1034158 | 0, i3, i13, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i6 = HEAP32[i8 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i12 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i12, i2, 1);
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i15);
 }
 i2 = i14 + 65 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1034173 | 0, i3, i13, 0) | 0;
 if (!i1) {
  __ZN8Gradient17ValidateColorKeysEv(i14);
  __ZN8Gradient17ValidateAlphaKeysEv(i14);
  STACKTOP = i16;
  return;
 }
 do if ((i1 | 0) > 0) {
  i13 = HEAP32[i8 >> 2] | 0;
  i1 = i13 + (HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 >> 2] | 0, 0 - (HEAP32[i9 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  if (i1 >>> 0 >= i13 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i2, 1);
 } else {
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i15 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i15);
 __ZN8Gradient17ValidateColorKeysEv(i14);
 __ZN8Gradient17ValidateAlphaKeysEv(i14);
 STACKTOP = i16;
 return;
}

function __ZNK5Unity10HingeJoint11GetVelocityEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 40 | 0;
 i6 = i11 + 28 | 0;
 i10 = i11;
 if (!(HEAP32[i7 + 32 >> 2] | 0)) {
  f12 = Math_fround(0.0);
  STACKTOP = i11;
  return Math_fround(f12);
 }
 i9 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
 i4 = i7 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i6);
    i2 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 10;
  }
  if ((i5 | 0) == 8) i5 = 10;
  if ((i5 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i6);
    i2 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 18;
   }
  }
  if ((i5 | 0) == 16) i5 = 18;
  if ((i5 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 52 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 160 >> 2] | 0, i8 | 0, i9 | 0);
 if (!i1) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i2 = i6 + 4 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  i3 = i6 + 8 | 0;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i1 = i6;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i6 | 0, i1 | 0);
  i2 = i6 + 4 | 0;
  i3 = i6 + 8 | 0;
  i1 = i6;
 }
 f12 = Math_fround(HEAPF32[i7 + 64 >> 2]);
 f20 = Math_fround(HEAPF32[i7 + 68 >> 2]);
 f23 = Math_fround(HEAPF32[i7 + 72 >> 2]);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i10 | 0, i9 | 0);
 f12 = Math_fround(f12 * Math_fround(2.0));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f23 = Math_fround(f23 * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i10 >> 2]);
 f14 = Math_fround(f12 * f19);
 f15 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f20 * f15));
 f18 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f23 * f18));
 f17 = Math_fround(Math_fround(f19 * f14) + Math_fround(Math_fround(f12 * f22) + Math_fround(f21 * Math_fround(Math_fround(f23 * f15) - Math_fround(f20 * f18)))));
 f16 = Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f20 * f22) + Math_fround(f21 * Math_fround(Math_fround(f12 * f18) - Math_fround(f23 * f19)))));
 f14 = Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * Math_fround(Math_fround(f20 * f19) - Math_fround(f12 * f15)))) + Math_fround(f18 * f14));
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i8 >> 2]));
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i8 + 4 >> 2]));
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f15)) + Math_fround(f14 * Math_fround(f12 - Math_fround(HEAPF32[i8 + 8 >> 2])))) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0)));
 STACKTOP = i11;
 return Math_fround(f12);
}

function __ZN5physx2Sc8ShapeSim17onTransformChangeEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 28 | 0;
 i13 = i15;
 i10 = i14 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i1 + 36 >> 2] | 0;
 i8 = HEAP32[i14 + 12 + 4 >> 2] | 0;
 i9 = i8 & 1073741823;
 if ((i9 | 0) != 1073741823) {
  i7 = i11 + 1e3 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = i1 + 5912 | 0;
  i5 = (i9 + 32 | 0) >>> 5;
  i6 = i1 + 5916 | 0;
  if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
   i1 = i1 + 5920 | 0;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i5 << 2, gb + 769739 | 0, 329) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    _memcpy(i2 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i4 >> 2] | 0);
   }
   i1 = HEAP32[i6 >> 2] | 0;
   _memset(i2 + ((i1 & 2147483647) << 2) | 0, 0, i5 - i1 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i6 >> 2] = i5;
   i1 = HEAP32[i7 >> 2] | 0;
  } else i2 = HEAP32[i4 >> 2] | 0;
  i7 = i2 + (i9 >>> 5 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i8 & 31);
  __ZN5physx14PxsAABBManager13setActorDirtyEj(HEAP32[i1 + 8 >> 2] | 0, i9);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = HEAP8[i1 + 51 >> 0] | 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i9 + (HEAP32[i1 + 28 >> 2] << 2) | 0;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i12 + 4 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i14;
 i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i12) | 0;
 L13 : do if (i1 | 0) {
  if (i2 & 1) while (1) {
   switch (HEAPU8[i1 + 20 >> 0] | 0 | 0) {
   case 0:
    {
     i1 = HEAP32[i1 + -8 + 56 >> 2] | 0;
     if (i1 | 0) __ZN5physx17PxsContactManager16resetCachedStateEv(i1);
     break;
    }
   case 2:
    {
     i1 = i1 + -8 | 0;
     i9 = i1 + 56 | 0;
     HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 32;
     i1 = i1 + 8 | 0;
     if (!(__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(i11, i1) | 0)) __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE(i11, i1);
     break;
    }
   case 4:
    {
     i9 = i1 + -8 | 0;
     i8 = i9 + 32 | 0;
     __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i8 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 + 36 >> 2] | 0);
     break;
    }
   default:
    {}
   }
   i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i12) | 0;
   if (!i1) break L13;
  }
  while (1) {
   switch (HEAPU8[i1 + 20 >> 0] | 0 | 0) {
   case 0:
    {
     i1 = i1 + -8 | 0;
     i2 = HEAP32[i1 + 56 >> 2] | 0;
     if (i2 | 0) __ZN5physx17PxsContactManager16resetCachedStateEv(i2);
     __ZN5physx2Sc19ShapeInstancePairLL26onPoseChangedWhileSleepingEv(i1);
     break;
    }
   case 2:
    {
     i1 = i1 + -8 | 0;
     i9 = i1 + 56 | 0;
     HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 32;
     i1 = i1 + 8 | 0;
     if (!(__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(i11, i1) | 0)) __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE(i11, i1);
     break;
    }
   case 4:
    {
     i9 = i1 + -8 | 0;
     i8 = i9 + 32 | 0;
     __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i8 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 + 36 >> 2] | 0);
     break;
    }
   default:
    {}
   }
   i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i12) | 0;
   if (!i1) break L13;
  }
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 1e3 >> 2] | 0;
 i2 = (HEAP32[i14 + 28 >> 2] | 0) + 32 | 0;
 i3 = HEAP8[i1 + 50 >> 0] | 0;
 switch (i3 << 24 >> 24) {
 case 1:
 case 4:
  {
   i1 = (HEAP32[i1 + 52 >> 2] | 0) + 16 | 0;
   break;
  }
 default:
  i1 = (HEAP32[i1 + 52 >> 2] | 0) + 16 | 0;
 }
 __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb(i4, i2, i1, i3 << 24 >> 24 == 1 | i3 << 24 >> 24 == 4);
 i1 = i14 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  STACKTOP = i15;
  return;
 }
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i13, i14);
 i14 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i4 + 7628 >> 2] | 0;
 HEAP32[i12 + (i14 * 28 | 0) >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i12 + (i14 * 28 | 0) + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 STACKTOP = i15;
 return;
}

function __Z26ApplyMaterialPassWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i4, i13, i5, i6, i7, i1, i8, i10) {
 i4 = i4 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 64 | 0;
 i3 = i18 + 60 | 0;
 i11 = i18 + 56 | 0;
 i16 = i18 + 24 | 0;
 i17 = i18;
 i9 = __Z12GetGfxDevicev() | 0;
 i15 = ((HEAP8[i13 + 149 >> 0] ^ 1) & 255 & (i1 & 1) | 0) != 0;
 do if (i15) {
  i1 = __ZN24MaterialDisplayListCache24GetCachedPassForMaterialERK18SharedMaterialDataPN9ShaderLab4PassE(i4, i6) | 0;
  i2 = __ZN24MaterialDisplayListCache16CachedShaderPass9FindEntryERK16ShaderKeywordSet(i1, i13 + 4 | 0) | 0;
  if (!i2) {
   HEAP32[i3 >> 2] = i5;
   HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166300 | 0, i12);
   if ((HEAP32[i6 + 744 >> 2] | 0) == 2) {
    i14 = i1;
    i1 = 0;
    break;
   }
   if (HEAP8[i6 + 80 >> 0] | 0) {
    i14 = i1;
    i1 = 0;
    break;
   }
   i14 = i1;
   i1 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 588 >> 2] | 0, i9 | 0) | 0;
   break;
  }
  i17 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i13 + 36 | 0);
  if (i10 | 0) {
   i17 = i2 + 36 | 0;
   HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  }
  i17 = HEAP32[i2 + 40 >> 2] | 0;
  i17 = (i17 | 0) == 0 ? 0 : i17 + 4 | 0;
  STACKTOP = i18;
  return i17 | 0;
 } else {
  i14 = 0;
  i1 = 0;
 } while (0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 i7 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(i6, HEAP32[i4 + 160 >> 2] | 0, i4 + 12 | 0, i13, i5, i7, i8, i12) | 0;
 if (i10 | 0) {
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 }
 HEAP32[i11 >> 2] = 0;
 if (i1) if (mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 592 >> 2] | 0, i9 | 0, i11 | 0, i13 + 36 | 0) | 0) {
  i6 = HEAP32[i11 >> 2] | 0;
  i1 = i13 + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i16 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i16 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i16 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  i1 = i14 + 243 | 0;
  i2 = HEAPU8[i1 >> 0] | 0;
  i3 = i2 & 127;
  i4 = i14 + (i3 * 60 | 0) | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i13 = i5 + 4 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   if (!(HEAP32[i13 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63304 | 0);
   }
   HEAP32[i4 >> 2] = 0;
  }
  i13 = i14 + (i3 * 60 | 0) + 36 | 0;
  HEAP32[i4 >> 2] = i6;
  i12 = i14 + (i3 * 60 | 0) + 4 | 0;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
  HEAP32[i12 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  i17 = i14 + 242 | 0;
  HEAP8[i1 >> 0] = HEAP8[i17 >> 0] | 0;
  i16 = i14 + 241 | 0;
  HEAP8[i17 >> 0] = HEAP8[i16 >> 0] | 0;
  i17 = i14 + 240 | 0;
  HEAP8[i16 >> 0] = HEAP8[i17 >> 0] | 0;
  HEAP8[i17 >> 0] = i2 | 128;
 }
 if (i15) __Z12profiler_endP19ProfilerInformation(gb + 1166300 | 0);
 i17 = i7;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN7Striper7ComputeER13STRIPERRESULT(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i5 = __Znwj(12) | 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i7 = __Znwj(16) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 4096;
 HEAP32[i7 + 4 >> 2] = __Znaj(4096) | 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i5 + 4 >> 2] = i7;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = i5;
 i5 = __Znwj(12) | 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i9 = __Znwj(16) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 4096;
 HEAP32[i9 + 4 >> 2] = __Znaj(4096) | 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = i9;
 i9 = i10 + 16 | 0;
 HEAP32[i9 >> 2] = i5;
 i5 = i1 + 12 | 0;
 i4 = __Znaj(HEAP32[i5 >> 2] | 0) | 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = i4;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = __Znaj(i6 >>> 0 > 1073741823 ? -1 : i6 << 2) | 0;
 _memset(i4 | 0, 0, HEAP32[i5 >> 2] | 0) | 0;
 _memset(i6 | 0, 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = 0;
  do {
   i3 = i6 + (i1 << 2) | 0;
   if ((HEAP32[i2 + (i1 * 24 | 0) + 12 >> 2] | 0) != -1) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   if ((HEAP32[i2 + (i1 * 24 | 0) + 16 >> 2] | 0) != -1) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   if ((HEAP32[i2 + (i1 * 24 | 0) + 20 >> 2] | 0) != -1) HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i3 = i12 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 >> 2] = __Znaj(4096) | 0;
 i2 = i12 + 4 | 0;
 HEAP32[i2 >> 2] = __Znaj(1024) | 0;
 i1 = HEAP32[(__ZN11RadixSorter4SortEPjjb(i12, i6, HEAP32[i5 >> 2] | 0, 1) | 0) + 12 >> 2] | 0;
 _memcpy(i6 | 0, i1 | 0, HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 i5 = i10 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = i12;
 i2 = i1 + 84 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0) {
  i1 = 0;
  i3 = 0;
  do {
   i4 = HEAP32[i8 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    if (!(HEAP8[i4 + i2 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   }
   i3 = (__ZN7Striper16ComputeBestStripEjR14BestStripCache(i10, i2, i12) | 0) + i3 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  } while ((i3 | 0) != (HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0));
 }
 __ZdaPv(i6);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i4 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = i3; else {
  __ZdaPv(i2);
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i2 = 0;
 do {
  i8 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = (HEAP32[i8 + 8 >> 2] | 0) + i2 | 0;
 } while ((i1 | 0) != 0);
 if (!i2) {
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 } else {
  i1 = __Znaj(i2) | 0;
  HEAP32[i4 >> 2] = i1;
  i8 = (HEAP32[i3 >> 2] | 0) == 0;
  i2 = i3 + 8 | 0;
  _memcpy(i1 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  if (!i8) {
   i4 = i1;
   do {
    i4 = i4 + (HEAP32[i2 >> 2] | 0) | 0;
    i3 = HEAP32[i3 >> 2] | 0;
    i8 = (HEAP32[i3 >> 2] | 0) == 0;
    i2 = i3 + 8 | 0;
    _memcpy(i4 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
   } while (!i8);
  }
 }
 HEAP32[i11 + 4 >> 2] = i1;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i4 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = i3; else {
  __ZdaPv(i2);
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i2 = 0;
 do {
  i9 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = (HEAP32[i9 + 8 >> 2] | 0) + i2 | 0;
 } while ((i1 | 0) != 0);
 if (!i2) {
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 } else {
  i1 = __Znaj(i2) | 0;
  HEAP32[i4 >> 2] = i1;
  i9 = (HEAP32[i3 >> 2] | 0) == 0;
  i2 = i3 + 8 | 0;
  _memcpy(i1 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  if (!i9) {
   i4 = i1;
   do {
    i4 = i4 + (HEAP32[i2 >> 2] | 0) | 0;
    i3 = HEAP32[i3 >> 2] | 0;
    i9 = (HEAP32[i3 >> 2] | 0) == 0;
    i2 = i3 + 8 | 0;
    _memcpy(i4 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
   } while (!i9);
  }
 }
 HEAP32[i11 + 8 >> 2] = i1;
 __ZN7Striper16ConnectAllStripsER13STRIPERRESULT(i10, i11) | 0;
 __ZN14BestStripCacheD2Ev(i12);
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx20PxSceneGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 743223;
 HEAP32[i1 + 4 >> 2] = 212;
 HEAP32[i1 + 8 >> 2] = fb + 2195;
 HEAP32[i1 + 12 >> 2] = gb + 771701;
 HEAP32[i1 + 16 >> 2] = 213;
 HEAP32[i1 + 20 >> 2] = fb + 3589;
 HEAP32[i1 + 24 >> 2] = fb + 3590;
 HEAP32[i1 + 28 >> 2] = gb + 771708;
 HEAP32[i1 + 32 >> 2] = 214;
 HEAP32[i1 + 36 >> 2] = fb + 2196;
 HEAP32[i1 + 40 >> 2] = gb + 756565;
 HEAP32[i1 + 44 >> 2] = 215;
 HEAP32[i1 + 48 >> 2] = fb + 162;
 HEAP32[i1 + 52 >> 2] = fb + 836;
 HEAP32[i1 + 56 >> 2] = gb + 771718;
 HEAP32[i1 + 60 >> 2] = 216;
 HEAP32[i1 + 64 >> 2] = fb + 416;
 HEAP32[i1 + 68 >> 2] = fb + 2197;
 HEAP32[i1 + 72 >> 2] = gb + 673527;
 HEAP32[i1 + 76 >> 2] = 217;
 HEAP32[i1 + 80 >> 2] = fb + 417;
 HEAP32[i1 + 84 >> 2] = fb + 2198;
 HEAP32[i1 + 88 >> 2] = gb + 771732;
 HEAP32[i1 + 92 >> 2] = 218;
 HEAP32[i1 + 96 >> 2] = fb + 418;
 HEAP32[i1 + 100 >> 2] = fb + 2199;
 HEAP32[i1 + 104 >> 2] = gb + 771743;
 HEAP32[i1 + 108 >> 2] = 219;
 HEAP32[i1 + 112 >> 2] = fb + 2200;
 HEAP32[i1 + 116 >> 2] = gb + 771757;
 HEAP32[i1 + 120 >> 2] = 220;
 HEAP32[i1 + 124 >> 2] = fb + 2201;
 HEAP32[i1 + 128 >> 2] = gb + 771771;
 HEAP32[i1 + 132 >> 2] = 221;
 HEAP32[i1 + 136 >> 2] = fb + 2202;
 HEAP32[i1 + 140 >> 2] = gb + 771785;
 HEAP32[i1 + 144 >> 2] = 222;
 HEAP32[i1 + 148 >> 2] = fb + 476;
 HEAP32[i1 + 152 >> 2] = fb + 412;
 HEAP32[i1 + 156 >> 2] = gb + 771813;
 HEAP32[i1 + 160 >> 2] = 223;
 HEAP32[i1 + 164 >> 2] = fb + 477;
 HEAP32[i1 + 168 >> 2] = fb + 413;
 HEAP32[i1 + 172 >> 2] = gb + 771842;
 HEAP32[i1 + 176 >> 2] = 224;
 HEAP32[i1 + 180 >> 2] = fb + 2203;
 HEAP32[i1 + 184 >> 2] = fb + 3591;
 HEAP32[i1 + 188 >> 2] = gb + 771874;
 HEAP32[i1 + 192 >> 2] = 225;
 HEAP32[i1 + 196 >> 2] = fb + 2204;
 HEAP32[i1 + 200 >> 2] = fb + 3592;
 HEAP32[i1 + 204 >> 2] = gb + 771896;
 HEAP32[i1 + 208 >> 2] = 226;
 HEAP32[i1 + 212 >> 2] = fb + 2205;
 HEAP32[i1 + 216 >> 2] = fb + 3593;
 HEAP32[i1 + 220 >> 2] = gb + 771921;
 HEAP32[i1 + 224 >> 2] = 227;
 HEAP32[i1 + 228 >> 2] = fb + 2206;
 HEAP32[i1 + 232 >> 2] = gb + 771938;
 HEAP32[i1 + 236 >> 2] = 228;
 HEAP32[i1 + 240 >> 2] = fb + 2207;
 HEAP32[i1 + 244 >> 2] = gb + 771959;
 HEAP32[i1 + 248 >> 2] = 229;
 HEAP32[i1 + 252 >> 2] = fb + 2208;
 HEAP32[i1 + 256 >> 2] = gb + 771972;
 HEAP32[i1 + 260 >> 2] = 230;
 HEAP32[i1 + 264 >> 2] = fb + 2209;
 HEAP32[i1 + 268 >> 2] = gb + 771987;
 HEAP32[i1 + 272 >> 2] = 231;
 HEAP32[i1 + 276 >> 2] = fb + 3594;
 HEAP32[i1 + 280 >> 2] = fb + 3595;
 HEAP32[i1 + 284 >> 2] = gb + 771995;
 HEAP32[i1 + 288 >> 2] = 232;
 HEAP32[i1 + 292 >> 2] = fb + 478;
 HEAP32[i1 + 296 >> 2] = fb + 414;
 HEAP32[i1 + 300 >> 2] = gb + 772019;
 HEAP32[i1 + 304 >> 2] = 233;
 HEAP32[i1 + 308 >> 2] = fb + 2210;
 HEAP32[i1 + 312 >> 2] = fb + 3596;
 HEAP32[i1 + 316 >> 2] = gb + 772032;
 HEAP32[i1 + 320 >> 2] = 234;
 HEAP32[i1 + 324 >> 2] = fb + 479;
 HEAP32[i1 + 328 >> 2] = gb + 772059;
 HEAP32[i1 + 332 >> 2] = 235;
 HEAP32[i1 + 336 >> 2] = fb + 480;
 HEAP32[i1 + 340 >> 2] = gb + 772083;
 HEAP32[i1 + 344 >> 2] = 236;
 HEAP32[i1 + 348 >> 2] = fb + 481;
 HEAP32[i1 + 352 >> 2] = gb + 772101;
 HEAP32[i1 + 356 >> 2] = 237;
 HEAP32[i1 + 360 >> 2] = fb + 2211;
 HEAP32[i1 + 364 >> 2] = fb + 3597;
 HEAP32[i1 + 368 >> 2] = gb + 772114;
 HEAP32[i1 + 372 >> 2] = 238;
 HEAP32[i1 + 376 >> 2] = fb + 2212;
 HEAP32[i1 + 380 >> 2] = fb + 3598;
 HEAP32[i1 + 384 >> 2] = gb + 772138;
 HEAP32[i1 + 388 >> 2] = 239;
 HEAP32[i1 + 392 >> 2] = fb + 2213;
 HEAP32[i1 + 396 >> 2] = gb + 772154;
 HEAP32[i1 + 400 >> 2] = 240;
 HEAP32[i1 + 404 >> 2] = fb + 2214;
 HEAP32[i1 + 408 >> 2] = gb + 772171;
 HEAP32[i1 + 412 >> 2] = 241;
 HEAP32[i1 + 416 >> 2] = fb + 2215;
 HEAP32[i1 + 420 >> 2] = fb + 3599;
 HEAP32[i1 + 424 >> 2] = gb + 772198;
 HEAP32[i1 + 428 >> 2] = 242;
 HEAP32[i1 + 432 >> 2] = fb + 2216;
 HEAP32[i1 + 436 >> 2] = gb + 772224;
 HEAP32[i1 + 440 >> 2] = 243;
 HEAP32[i1 + 444 >> 2] = fb + 2217;
 HEAP32[i1 + 448 >> 2] = gb + 772239;
 HEAP32[i1 + 452 >> 2] = 244;
 HEAP32[i1 + 456 >> 2] = fb + 419;
 HEAP32[i1 + 460 >> 2] = fb + 2218;
 HEAP32[i1 + 464 >> 2] = gb + 772257;
 HEAP32[i1 + 468 >> 2] = 245;
 HEAP32[i1 + 472 >> 2] = fb + 2219;
 HEAP32[i1 + 476 >> 2] = gb + 772269;
 HEAP32[i1 + 480 >> 2] = 246;
 HEAP32[i1 + 484 >> 2] = fb + 3600;
 HEAP32[i1 + 488 >> 2] = gb + 772289;
 HEAP32[i1 + 492 >> 2] = 247;
 HEAP32[i1 + 496 >> 2] = fb + 2220;
 HEAP32[i1 + 500 >> 2] = gb + 772316;
 HEAP32[i1 + 504 >> 2] = 248;
 HEAP32[i1 + 508 >> 2] = fb + 2221;
 HEAP32[i1 + 512 >> 2] = gb + 772346;
 HEAP32[i1 + 516 >> 2] = 249;
 HEAP32[i1 + 520 >> 2] = fb + 2222;
 HEAP32[i1 + 524 >> 2] = fb + 3601;
 HEAP32[i1 + 528 >> 2] = gb + 772362;
 HEAP32[i1 + 532 >> 2] = 250;
 HEAP32[i1 + 536 >> 2] = fb + 482;
 HEAP32[i1 + 540 >> 2] = gb + 741613;
 HEAP32[i1 + 544 >> 2] = 251;
 HEAP32[i1 + 548 >> 2] = fb + 2223;
 HEAP32[i1 + 552 >> 2] = fb + 3602;
 __ZN5physx28SimulationStatisticsPropertyC2Ev(i1 + 556 | 0);
 return;
}

function __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i2, i13, i3, i8) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 160 | 0;
 i9 = i14 + 144 | 0;
 i10 = i14 + 80 | 0;
 i11 = i14 + 64 | 0;
 i12 = i14;
 i2 = i2 + 28 | 0;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 67088 | 0) | 0;
 if (!((i2 | 0) == 0 | (i2 | 0) == (i8 | 0))) {
  i4 = HEAP32[i2 + 28 >> 2] | 0;
  if (i4 | 0) if (__ZNK10GameObject8IsActiveEv(i4) | 0) {
   i2 = i2 + 92 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    __ZNK9Transform21GetLocalToWorldMatrixEv(i1, i7);
    HEAP32[i1 + 48 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i1 + 52 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i1 + 56 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    __ZNK9Transform11GetRotationEv(i10, i7);
    f16 = Math_fround(HEAPF32[i10 + 12 >> 2]);
    i12 = f16 < Math_fround(0.0);
    f17 = Math_fround(HEAPF32[i10 + 8 >> 2]);
    f18 = Math_fround(-f17);
    f15 = Math_fround(-f16);
    f16 = i12 ? f15 : f16;
    f17 = i12 ? f18 : f17;
    i12 = f16 < Math_fround(0.0);
    f18 = Math_fround(-f17);
    f15 = Math_fround(-f16);
    f16 = Math_fround(Math_fround(Math_fround(+Math_atan2(+(i12 ? f18 : f17), +(i12 ? f15 : f16))) * Math_fround(2.0)) * Math_fround(.5));
    f15 = Math_fround(+Math_cos(+f16));
    f16 = Math_fround(-Math_fround(+Math_sin(+f16)));
    HEAPF32[i9 >> 2] = Math_fround(-0.0);
    HEAPF32[i9 + 4 >> 2] = Math_fround(-0.0);
    HEAPF32[i9 + 8 >> 2] = f16;
    HEAPF32[i9 + 12 >> 2] = f15;
    __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i10, gb + 1162364 | 0, i9);
    __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i1, i3);
    HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
    STACKTOP = i14;
    return;
   }
  }
 }
 i2 = HEAP32[i7 + 100 >> 2] | 0;
 L8 : do if (i2 | 0) {
  while (1) {
   i6 = HEAP32[i2 + 100 >> 2] | 0;
   i4 = HEAP32[i2 + 28 >> 2] | 0;
   if (i4 | 0) {
    i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 67088 | 0) | 0;
    if (!((i4 | 0) == 0 | (i4 | 0) == (i8 | 0))) {
     i5 = HEAP32[i4 + 28 >> 2] | 0;
     if (i5 | 0) if (__ZNK10GameObject8IsActiveEv(i5) | 0) {
      i4 = i4 + 92 | 0;
      if (HEAP32[i4 >> 2] | 0) break;
     }
    }
   }
   if (!i6) break L8; else i2 = i6;
  }
  __ZNK9Transform21GetLocalToWorldMatrixEv(i1, i7);
  __ZNK9Transform11GetRotationEv(i10, i2);
  f21 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  i8 = f21 < Math_fround(0.0);
  f20 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f15 = Math_fround(-f20);
  f16 = Math_fround(-f21);
  f21 = i8 ? f16 : f21;
  f20 = i8 ? f15 : f20;
  i8 = f21 < Math_fround(0.0);
  f15 = Math_fround(-f20);
  f16 = Math_fround(-f21);
  f21 = Math_fround(Math_fround(Math_fround(+Math_atan2(+(i8 ? f15 : f20), +(i8 ? f16 : f21))) * Math_fround(2.0)) * Math_fround(.5));
  f16 = Math_fround(+Math_sin(+f21));
  f21 = Math_fround(+Math_cos(+f21));
  f20 = Math_fround(-f16);
  HEAPF32[i9 >> 2] = Math_fround(-0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(-0.0);
  HEAPF32[i9 + 8 >> 2] = f20;
  HEAPF32[i9 + 12 >> 2] = f21;
  __ZNK9Transform11GetPositionEv(i11, i2);
  f15 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
  f17 = Math_fround(-Math_fround(HEAPF32[i11 + 4 >> 2]));
  f18 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f22 = Math_fround(-f18);
  f16 = Math_fround(f16 * Math_fround(-2.0));
  f23 = Math_fround(f16 * Math_fround(-0.0));
  f19 = Math_fround(f21 * Math_fround(-0.0));
  f21 = Math_fround(f21 * f16);
  f20 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f16 * f20) + Math_fround(0.0)));
  f16 = Math_fround(f23 + f19);
  HEAPF32[i10 >> 2] = Math_fround(Math_fround(f16 * f22) + Math_fround(Math_fround(Math_fround(Math_fround(0.0) - f21) * f17) + Math_fround(f20 * f15)));
  f19 = Math_fround(f23 - f19);
  HEAPF32[i10 + 4 >> 2] = Math_fround(Math_fround(f19 * f22) + Math_fround(Math_fround(Math_fround(f21 + Math_fround(0.0)) * f15) + Math_fround(f20 * f17)));
  HEAPF32[i10 + 8 >> 2] = Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(f16 * f17)) - f18);
  __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i12, i10, i9);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i12, i1, i3);
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  STACKTOP = i14;
  return;
 } while (0);
 __ZNK9Transform21GetLocalToWorldMatrixEv(i1, i7);
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i13 >> 2] = __Z22GetPhysicsGroundBody2Dv() | 0;
 STACKTOP = i14;
 return;
}

function __ZN14DetailRendererC2E4PPtrI11TerrainDataE8Vector3f(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i6 = i7;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = i5 + 68;
 HEAP32[i5 + 80 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 HEAP32[i5 + 76 >> 2] = i5 + 80;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 96 >> 2] = 0;
 HEAP32[i5 + 88 >> 2] = i5 + 92;
 i3 = i5 + 100 | 0;
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i3 = i5 + 28 | 0;
 HEAP16[i3 + 2 >> 1] = -1;
 HEAP16[i3 >> 1] = -1;
 HEAPF32[i5 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 60 >> 2] = Math_fround(0.0);
 i3 = __Z15GetScriptMapperv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 934967 | 0, 54);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 935336 | 0, 7);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i2 = 1;
 } else i2 = 0;
 i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[gb + 1467656 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i4, Math_fround(.375));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 935022 | 0, 38);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 935336 | 0, 7);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i2 = 1;
 }
 i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[gb + 1467656 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i4, Math_fround(.375));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 935136 | 0, 45);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 935336 | 0, 7);
  i3 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i3 = __ZN8Material14CreateMaterialER6Shaderib(i3, 61, 0) | 0;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[i6 >> 2] = HEAP32[gb + 1467656 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i3, i4, Math_fround(.375));
 } else {
  i3 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[i6 >> 2] = HEAP32[gb + 1467656 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i3, i4, Math_fround(.375));
  if (!i2) {
   i6 = i5 + 112 | 0;
   HEAP32[i6 >> 2] = 0;
   i6 = i5 + 116 | 0;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   STACKTOP = i7;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 935217 | 0, 0, gb + 935061 | 0, 65, 1, 0, 0, 0);
 i6 = i5 + 112 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i5 + 116 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 STACKTOP = i7;
 return;
}

function __ZN10TagManager7GetTagsEv(i28, i1) {
 i28 = i28 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i37 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i37 + 112 | 0;
 i32 = i37 + 104 | 0;
 i33 = i37 + 68 | 0;
 i34 = i37 + 32 | 0;
 i35 = i37;
 i36 = i28 + 4 | 0;
 HEAP32[i36 >> 2] = 0;
 HEAP32[i28 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i29 = i28 + 12 | 0;
 HEAP32[i29 >> 2] = 0;
 i30 = i28 + 4 | 0;
 HEAP32[i28 >> 2] = i30;
 i6 = i1 + 32 | 0;
 i27 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 if ((i1 | 0) == (i27 + 4 | 0)) {
  STACKTOP = i37;
  return;
 }
 i7 = i35 + 20 | 0;
 i8 = i35 + 24 | 0;
 i9 = i35 + 4 | 0;
 i10 = i34 + 4 | 0;
 i11 = i34 + 24 | 0;
 i12 = i34 + 28 | 0;
 i13 = i34 + 8 | 0;
 i14 = i33 + 4 | 0;
 i15 = i33 + 24 | 0;
 i16 = i33 + 28 | 0;
 i17 = i33 + 8 | 0;
 i18 = i34 + 4 | 0;
 i19 = i30;
 i20 = i28 + 8 | 0;
 i21 = i31 + 4 | 0;
 i22 = i33 + 4 | 0;
 i23 = i33 + 4 | 0;
 i24 = i34 + 4 | 0;
 i25 = i35 + 4 | 0;
 i26 = i34 + 8 | 0;
 i27 = i33 + 8 | 0;
 i2 = i1;
 while (1) {
  if (HEAP32[i2 + 40 >> 2] | 0) {
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   HEAP32[i35 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i3 = i2 + 44 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i8;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = i4;
   HEAP8[i9 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i35, i2 + 20 | 0);
   HEAP32[i34 >> 2] = i1;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = i8;
   i5 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = i12;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + 4 >> 2] = i5;
   HEAP8[i13 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i10, i35);
   HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   i4 = i12;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i16;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP8[i17 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i14, i18);
   i1 = HEAP32[i30 >> 2] | 0;
   do if (!i1) {
    HEAP32[i32 >> 2] = i30;
    i5 = i19;
    i4 = i30;
   } else {
    i5 = HEAP32[i33 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i3 >>> 0) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) {
       i3 = 9;
       break;
      } else i1 = i3;
     } else {
      if (i3 >>> 0 >= i5 >>> 0) {
       i3 = 14;
       break;
      }
      i4 = i1 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i3 = 13;
       break;
      } else i1 = i3;
     }
    }
    if ((i3 | 0) == 9) {
     HEAP32[i32 >> 2] = i1;
     i5 = i1;
     i4 = i1;
     break;
    } else if ((i3 | 0) == 13) {
     HEAP32[i32 >> 2] = i1;
     i5 = i1;
     break;
    } else if ((i3 | 0) == 14) {
     HEAP32[i32 >> 2] = i1;
     i5 = i1;
     i4 = i32;
     break;
    }
   } while (0);
   if (!(HEAP32[i4 >> 2] | 0)) {
    i1 = HEAP32[i20 >> 2] | 0;
    HEAP32[i31 >> 2] = 6;
    HEAP32[i21 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i31, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i33 >> 2];
    i3 = i1 + 20 | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i1 + 40 >> 2] = 0;
    i40 = i16;
    i39 = HEAP32[i40 + 4 >> 2] | 0;
    i38 = i1 + 44 | 0;
    HEAP32[i38 >> 2] = HEAP32[i40 >> 2];
    HEAP32[i38 + 4 >> 2] = i39;
    HEAP8[i1 + 24 >> 0] = 0;
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i3, i22);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i5;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i28 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i28 >> 2] = i3;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i36 >> 2] | 0, i1);
    HEAP32[i29 >> 2] = (HEAP32[i29 >> 2] | 0) + 1;
   }
   i1 = HEAP32[i23 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i27 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
   i1 = HEAP32[i24 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i26 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
   i1 = HEAP32[i35 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i25 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == ((HEAP32[i6 >> 2] | 0) + 4 | 0)) break; else i2 = i1;
 }
 STACKTOP = i37;
 return;
}

function __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj(i20, i19) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i21 + 13 | 0;
 i5 = i21 + 12 | 0;
 i6 = i21 + 11 | 0;
 i7 = i21 + 10 | 0;
 i8 = i21 + 9 | 0;
 i9 = i21 + 8 | 0;
 i10 = i21 + 7 | 0;
 i16 = i21 + 6 | 0;
 i17 = i21 + 5 | 0;
 i18 = i21 + 4 | 0;
 i11 = i21 + 3 | 0;
 i12 = i21 + 2 | 0;
 i13 = i21 + 1 | 0;
 i14 = i21;
 i15 = i20 + 156 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 >>> 0 > i19 >>> 0) {
  i3 = i19;
  do {
   i1 = i20 + 160 + (i3 * 44 | 0) + 32 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) + 40 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i1 = i20 + 160 + (i3 * 44 | 0) + 16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
    HEAP32[i1 >> 2] = 0;
   }
   i2 = i20 + 160 + (i3 * 44 | 0) + 28 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
    if (i1 | 0) {
     i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
    }
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i20 + 160 + (i3 * 44 | 0) + 12 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
    if (i1 | 0) {
     i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
    }
    HEAP32[i2 >> 2] = 0;
   }
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i15 >> 2] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 if (i1 >>> 0 >= i19 >>> 0) {
  HEAP32[i15 >> 2] = i19;
  STACKTOP = i21;
  return;
 }
 do {
  i22 = i20 + 160 + (i1 * 44 | 0) + 24 | 0;
  HEAP32[i22 >> 2] = 1024;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 16 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, 16384, gb + 768860 | 0, 240) | 0;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 20 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, HEAP32[i22 >> 2] << 4, gb + 768860 | 0, 241) | 0;
  HEAP32[i20 + 160 + (i1 * 44 | 0) >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18, 2048, gb + 768860 | 0, 244) | 0;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11, 2048, gb + 768860 | 0, 245) | 0;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 8 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, 2048, gb + 768860 | 0, 246) | 0;
  i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i10 = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = mftCall_iiiiii(i10 | 0, i22 | 0, 16403, (i2 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 768860 | 0, 247) | 0;
  if (!i2) i2 = 0; else {
   i22 = i2 + 19 & -16;
   HEAP32[i22 + -4 >> 2] = i22 - i2;
   i2 = i22;
  }
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 12 >> 2] = i2;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 40 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, 1024, gb + 768860 | 0, 249) | 0;
  i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i10 = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = mftCall_iiiiii(i10 | 0, i22 | 0, 6211, (i2 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 768860 | 0, 255) | 0;
  if (!i2) i2 = 0; else {
   i22 = i2 + 19 & -16;
   HEAP32[i22 + -4 >> 2] = i22 - i2;
   i2 = i22;
  }
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 28 >> 2] = i2;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 32 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, 512, gb + 768860 | 0, 257) | 0;
  HEAP32[i20 + 160 + (i1 * 44 | 0) + 36 >> 2] = gb + 1454972;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i19 | 0));
 HEAP32[i15 >> 2] = i19;
 STACKTOP = i21;
 return;
}

function __ZL25CullLocalShadowCastersJobP25LocalShadowCullingJobDataj(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 208 | 0;
 i17 = i25 + 144 | 0;
 i12 = i25 + 80 | 0;
 i18 = i25 + 16 | 0;
 i20 = i25;
 if ((HEAP16[gb + 1112864 + 6 >> 1] | 0) > -1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112864 | 0, i21);
  i22 = gb + 1112864 | 0;
 } else i22 = 0;
 i7 = i11 + 28 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i3 + 752 + (i5 * 12 | 0) >> 2] | 0;
 i5 = HEAP32[i3 + 752 + (i5 * 12 | 0) + 4 >> 2] | 0;
 i23 = i11 + 32 | 0;
 i6 = HEAP32[i23 >> 2] | 0;
 if ((HEAP16[gb + 1112960 + 6 >> 1] | 0) > -1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112960 | 0, i21);
  i2 = gb + 1112960 | 0;
 } else i2 = 0;
 i24 = i11 + 36 + (i1 * 12 | 0) | 0;
 i15 = HEAP32[i24 >> 2] | 0;
 i19 = i11 + 36 + (i1 * 12 | 0) + 4 | 0;
 i14 = HEAP32[i19 >> 2] | 0;
 HEAP32[i21 >> 2] = (HEAP32[i6 >> 2] | 0) + (i15 << 2);
 i16 = i21 + 4 | 0;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i21 + 8 >> 2] = i14;
 __Z29CullShadowCastersWithoutUmbraR9IndexListRK22SceneCullingParametersPK4AABBjj(i21, i3, i4, i15, i14 + i15 | 0);
 __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(i3, i5, i4, i21);
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 if ((HEAP16[gb + 1112876 + 6 >> 1] | 0) > -1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112876 | 0, i21);
  i16 = gb + 1112876 | 0;
 } else i16 = 0;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i8 + 952 >> 2] | 0;
 i15 = i14 + 752 + (i13 * 12 | 0) | 0;
 i7 = HEAP8[i14 + 816 >> 0] | 0;
 i9 = HEAP32[i11 + 8 >> 2] | 0;
 i6 = HEAP32[i8 + 512 >> 2] & HEAP32[i9 + 36 >> 2];
 i10 = i9 + 40 | 0;
 switch (HEAP32[i10 >> 2] | 0) {
 case 2:
  {
   i20 = HEAP32[i11 + 24 >> 2] | 0;
   i18 = HEAP32[i11 + 20 >> 2] | 0;
   i12 = HEAP32[i11 + 16 >> 2] | 0;
   HEAP32[i21 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i21 + 16 >> 2] = i12;
   HEAP32[i21 + 20 >> 2] = i18;
   HEAP32[i21 + 24 >> 2] = i20;
   HEAP32[i21 >> 2] = i8;
   HEAP32[i21 + 8 >> 2] = i6;
   if ((HEAP32[i9 + 88 >> 2] | 0) > -1) i1 = (HEAP32[i9 + 80 >> 2] | 0) == 1; else i1 = 0;
   HEAP8[i21 + 4 >> 0] = i7 << 24 >> 24 != 0 & i1 & 1;
   i20 = HEAP32[i19 >> 2] | 0;
   HEAP32[i17 >> 2] = (HEAP32[HEAP32[i23 >> 2] >> 2] | 0) + (HEAP32[i24 >> 2] << 2);
   i24 = i17 + 4 | 0;
   HEAP32[i24 >> 2] = i20;
   HEAP32[i17 + 8 >> 2] = i20;
   __Z16CullPointShadowsR9IndexListPK9SceneNodePK4AABBR16PointCullContext(i17, HEAP32[i14 + 752 + (i13 * 12 | 0) + 4 >> 2] | 0, HEAP32[i15 >> 2] | 0, i21);
   HEAP32[i19 >> 2] = HEAP32[i24 >> 2];
   break;
  }
 case 0:
  {
   HEAPF32[i18 >> 2] = Math_fround(1.0);
   HEAPF32[i18 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i18 + 8 >> 2] = Math_fround(-1.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i17, i18) | 0;
   __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i12, Math_fround(HEAPF32[i9 + 68 >> 2]), Math_fround(.0000999999974), Math_fround(HEAPF32[((HEAP32[i10 >> 2] | 0) == 3 ? i9 + 204 | 0 : i9 + 48 | 0) >> 2])) | 0;
   i5 = i21 + 76 | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i12, i17, i5);
   i1 = i21 + 12 | 0;
   i2 = i1;
   i3 = i9 + 280 | 0;
   i4 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i5, i1, i18);
   __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i18, i21 + 140 | 0);
   HEAP32[i21 >> 2] = i8;
   HEAP32[i21 + 8 >> 2] = i6;
   i2 = i7 << 24 >> 24 != 0;
   if ((HEAP32[i10 >> 2] | 0) == 3) i1 = 0; else if ((HEAP32[i9 + 88 >> 2] | 0) > -1) i1 = (HEAP32[i9 + 80 >> 2] | 0) == 1; else i1 = 0;
   HEAP8[i21 + 4 >> 0] = i2 & i1 & 1;
   i18 = HEAP32[i19 >> 2] | 0;
   HEAP32[i20 >> 2] = (HEAP32[HEAP32[i23 >> 2] >> 2] | 0) + (HEAP32[i24 >> 2] << 2);
   i24 = i20 + 4 | 0;
   HEAP32[i24 >> 2] = i18;
   HEAP32[i20 + 8 >> 2] = i18;
   __Z15CullSpotShadowsR9IndexListPK9SceneNodePK4AABBR15SpotCullContext(i20, HEAP32[i14 + 752 + (i13 * 12 | 0) + 4 >> 2] | 0, HEAP32[i15 >> 2] | 0, i21);
   HEAP32[i19 >> 2] = HEAP32[i24 >> 2];
   break;
  }
 default:
  {}
 }
 if (i16 | 0) __Z12profiler_endP19ProfilerInformation(i16);
 if (!i22) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i22);
 STACKTOP = i25;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i8 = i16 + 36 | 0;
 i12 = i16 + 16 | 0;
 i7 = i16 + 12 | 0;
 i5 = i16 + 32 | 0;
 i6 = i16 + 28 | 0;
 i11 = i16;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 108 | 0;
 i3 = i1;
 if (i4 >>> 0 >= i9 >>> 0) {
  if (i4 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i3 + (i9 * 108 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = i9 * 108 | 0;
  i4 = (i3 | 0) / 108 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i11 + 8 | 0;
   i8 = i11;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if (i4 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i6 = __Znwj(i3) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i11 >> 2] = i6;
   i9 = i11 + 8 | 0;
   HEAP32[i9 >> 2] = i6 + (i4 * 108 | 0);
   HEAP32[i12 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i11, i8, i15, i4);
   i6 = i10;
   i7 = i9;
   i8 = i11;
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  i14 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i4;
  i4 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    i3 = i15 + 4 | 0;
    while (1) {
     i1 = i2 + -108 | 0;
     HEAP32[i10 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i14 = HEAP32[i2 + -96 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i3 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 108 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE8__appendEj(i13, i9 - i4 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE7reserveEj(i12, i9);
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, i8, i15);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 108 | 0;
 i1 = i2;
 if (i3 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE8__appendEj(i12, i9 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i9 >>> 0) {
  i4 = i4 + (i9 * 108 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i2 = i1 + -108 | 0;
    HEAP32[i10 >> 2] = i2;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + -96 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
   }
  }
 }
 i4 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i4;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i12 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i15 + 4 | 0;
   while (1) {
    i1 = i2 + -108 | 0;
    HEAP32[i10 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i14 = HEAP32[i2 + -96 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i3 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i1, i19) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i1, i19) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i1, i19) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i1, i19) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __ZN14SerializedFile4Type8ReadTypeILb0EEEbibRPKhS3_Pi(i5, i6, i4, i7, i8, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i9 = 0;
 if ((i6 | 0) < 16) {
  i9 = HEAP32[i7 >> 2] | 0;
  i2 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
  HEAP32[i7 >> 2] = i9 + 4;
  if (i1 | 0) HEAP32[i1 >> 2] = i2;
  i2 = (i2 | 0) > -1 ? i2 : -1;
  HEAP32[i5 >> 2] = i2;
  HEAP8[i5 + 40 >> 0] = 0;
  HEAP16[i5 + 42 >> 1] = -1;
  i1 = i5;
 } else {
  i2 = HEAP32[i7 >> 2] | 0;
  i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
  HEAP8[i5 >> 0] = i2;
  HEAP8[i5 + 1 >> 0] = i2 >> 8;
  HEAP8[i5 + 2 >> 0] = i2 >> 16;
  HEAP8[i5 + 3 >> 0] = i2 >> 24;
  i1 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP8[i5 + 40 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  i1 = i5;
 }
 HEAP32[i5 + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i2) | 0;
 if ((i6 | 0) > 16) {
  i3 = i5 + 42 | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8;
  HEAP8[i3 >> 0] = i9;
  HEAP8[i3 + 1 >> 0] = i9 >> 8;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 2;
  i3 = 9;
 } else if ((i6 | 0) > 12) i3 = 9;
 if ((i3 | 0) == 9) {
  switch (HEAP32[i1 >> 2] | 0) {
  case -1:
  case 114:
   {
    i1 = i5 + 8 | 0;
    i9 = HEAP32[i7 >> 2] | 0;
    i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
    HEAP8[i1 >> 0] = i9;
    HEAP8[i1 + 1 >> 0] = i9 >> 8;
    HEAP8[i1 + 2 >> 0] = i9 >> 16;
    HEAP8[i1 + 3 >> 0] = i9 >> 24;
    i9 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
    HEAP32[i7 >> 2] = i9;
    i3 = i1 + 4 | 0;
    i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
    HEAP8[i3 >> 0] = i9;
    HEAP8[i3 + 1 >> 0] = i9 >> 8;
    HEAP8[i3 + 2 >> 0] = i9 >> 16;
    HEAP8[i3 + 3 >> 0] = i9 >> 24;
    i3 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
    HEAP32[i7 >> 2] = i3;
    i9 = i5 + 16 | 0;
    i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i9 >> 0] = i3;
    HEAP8[i9 + 1 >> 0] = i3 >> 8;
    HEAP8[i9 + 2 >> 0] = i3 >> 16;
    HEAP8[i9 + 3 >> 0] = i3 >> 24;
    i9 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
    HEAP32[i7 >> 2] = i9;
    i1 = i1 + 12 | 0;
    i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
    HEAP8[i1 >> 0] = i9;
    HEAP8[i1 + 1 >> 0] = i9 >> 8;
    HEAP8[i1 + 2 >> 0] = i9 >> 16;
    HEAP8[i1 + 3 >> 0] = i9 >> 24;
    i1 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
    HEAP32[i7 >> 2] = i1;
    break;
   }
  default:
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i9 = i5 + 24 | 0;
  i3 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  HEAP8[i9 >> 0] = i3;
  HEAP8[i9 + 1 >> 0] = i3 >> 8;
  HEAP8[i9 + 2 >> 0] = i3 >> 16;
  HEAP8[i9 + 3 >> 0] = i3 >> 24;
  i3 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i3;
  i2 = i9 + 4 | 0;
  i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i5 + 32 | 0;
  i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
  HEAP8[i3 >> 0] = i2;
  HEAP8[i3 + 1 >> 0] = i2 >> 8;
  HEAP8[i3 + 2 >> 0] = i2 >> 16;
  HEAP8[i3 + 3 >> 0] = i2 >> 24;
  i3 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i3;
  i9 = i9 + 12 | 0;
  i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
  HEAP8[i9 >> 0] = i3;
  HEAP8[i9 + 1 >> 0] = i3 >> 8;
  HEAP8[i9 + 2 >> 0] = i3 >> 16;
  HEAP8[i9 + 3 >> 0] = i3 >> 24;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
 }
 if (!i4) {
  i9 = 1;
  return i9 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63720 | 0, 16, gb + 588245 | 0, 312) | 0;
 __ZN8TypeTreeC2ERK10MemLabelId(i2, gb + 63720 | 0);
 if (__Z12ReadTypeTreeR8TypeTreeRPKhS2_ib(i2, i7, i8, i6, 0) | 0) {
  HEAP32[i5 + 44 >> 2] = i2;
  i9 = 1;
  return i9 | 0;
 }
 if (i2 | 0) {
  i1 = i2 + 40 | 0;
  if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
   i9 = i2 + 20 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i2 + 24 | 0);
   HEAP32[i9 >> 2] = 0;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63720 | 0);
 i9 = 0;
 return i9 | 0;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplC2ERN5physx19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 148336 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 i4 = i2 + 8 | 0;
 i3 = i1;
 HEAP32[i2 + 12 >> 2] = i3;
 HEAP32[i2 + 16 >> 2] = gb + 774622;
 HEAP32[i4 >> 2] = gb + 148460 + 8;
 i5 = i2 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(.75);
 HEAP32[i2 + 48 >> 2] = -1;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i4, 64);
 i4 = i2 + 60 | 0;
 HEAP32[i2 + 64 >> 2] = i3;
 HEAP32[i2 + 68 >> 2] = gb + 774653;
 HEAP32[i4 >> 2] = gb + 148476 + 8;
 i5 = i2 + 72 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i2 + 96 >> 2] = Math_fround(.75);
 HEAP32[i2 + 100 >> 2] = -1;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i4, 64);
 HEAP32[i2 + 116 >> 2] = i3;
 HEAP32[i2 + 120 >> 2] = gb + 774686;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = gb + 148492 + 8;
 HEAP32[i2 + 140 >> 2] = i3;
 HEAP32[i2 + 144 >> 2] = gb + 774548;
 HEAP32[i2 + 148 >> 2] = 0;
 HEAP32[i2 + 152 >> 2] = 0;
 HEAP32[i2 + 156 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = gb + 148272 + 8;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 168, gb + 774701 | 0, gb + 774188 | 0, 410) | 0;
 HEAP32[i4 >> 2] = gb + 148508 + 8;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i4 + 8 | 0;
 HEAP32[i4 + 12 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = gb + 774717;
 HEAP32[i1 >> 2] = gb + 148548 + 8;
 i5 = i4 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i4 + 44 >> 2] = Math_fround(.75);
 HEAP32[i4 + 48 >> 2] = -1;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i4 + 60 >> 2] = 1;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 68 >> 2] = i3;
 HEAP32[i4 + 72 >> 2] = gb + 774743;
 HEAP32[i1 >> 2] = gb + 148564 + 8;
 i5 = i4 + 76 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i4 + 100 >> 2] = Math_fround(.75);
 HEAP32[i4 + 104 >> 2] = -1;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i4 + 116 | 0;
 HEAP32[i4 + 120 >> 2] = i3;
 HEAP32[i4 + 124 >> 2] = gb + 774773;
 HEAP32[i1 >> 2] = gb + 148580 + 8;
 i5 = i4 + 128 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i4 + 152 >> 2] = Math_fround(.75);
 HEAP32[i4 + 156 >> 2] = -1;
 HEAP32[i4 + 160 >> 2] = 0;
 HEAP32[i4 + 164 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i2 + 160 >> 2] = i4;
 i1 = i2 + 164 | 0;
 HEAP32[i2 + 168 >> 2] = i3;
 HEAP32[i2 + 172 >> 2] = gb + 774803;
 HEAP32[i1 >> 2] = gb + 148596 + 8;
 i4 = i2 + 176 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 200 >> 2] = Math_fround(.75);
 HEAP32[i2 + 204 >> 2] = -1;
 HEAP32[i2 + 208 >> 2] = 0;
 HEAP32[i2 + 212 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i2 + 220 >> 2] = i3;
 HEAP32[i2 + 224 >> 2] = gb + 774822;
 HEAP32[i2 + 228 >> 2] = 0;
 HEAP32[i2 + 232 >> 2] = 0;
 HEAP32[i2 + 236 >> 2] = 0;
 HEAP32[i2 + 216 >> 2] = gb + 148612 + 8;
 HEAP32[i2 + 240 >> 2] = 1;
 HEAP32[i2 + 244 >> 2] = 0;
 return;
}

function __ZN5physx2Gu12OBBAABBTestsILb1EEC2ERKNS_11PxTransformERKNS_13PxBoxGeometryEf(i4, i3, i1, f2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0;
 i19 = HEAP32[i3 + 20 >> 2] | 0;
 i18 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = i19;
 HEAP32[i4 + 24 >> 2] = i18;
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 f16 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f2);
 f17 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f2);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * f2);
 HEAPF32[i4 >> 2] = f16;
 i18 = i4 + 4 | 0;
 HEAPF32[i18 >> 2] = f17;
 i1 = i4 + 8 | 0;
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f11 = Math_fround(f7 + f7);
 f5 = Math_fround(f17 + f17);
 f12 = Math_fround(f16 + f16);
 f2 = Math_fround(f17 * f5);
 f8 = Math_fround(f16 * f12);
 f17 = Math_fround(f11 * f17);
 f15 = Math_fround(f11 * f16);
 f10 = Math_fround(f11 * f13);
 f16 = Math_fround(f5 * f16);
 f5 = Math_fround(f5 * f13);
 f13 = Math_fround(f12 * f13);
 f12 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f8);
 f6 = Math_fround(f17 + f13);
 f9 = Math_fround(f15 - f5);
 f13 = Math_fround(f17 - f13);
 f11 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f11));
 f8 = Math_fround(f11 - f8);
 f7 = Math_fround(f16 + f10);
 f5 = Math_fround(f15 + f5);
 f10 = Math_fround(f16 - f10);
 f2 = Math_fround(f11 - f2);
 HEAPF32[i4 + 32 >> 2] = f12;
 HEAPF32[i4 + 36 >> 2] = f13;
 HEAPF32[i4 + 40 >> 2] = f5;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = f6;
 HEAPF32[i4 + 52 >> 2] = f8;
 HEAPF32[i4 + 56 >> 2] = f10;
 HEAPF32[i4 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 64 >> 2] = f9;
 HEAPF32[i4 + 68 >> 2] = f7;
 HEAPF32[i4 + 72 >> 2] = f2;
 HEAPF32[i4 + 76 >> 2] = Math_fround(0.0);
 f11 = Math_fround(-f12);
 f16 = Math_fround(-f13);
 f15 = Math_fround(-f5);
 f11 = Math_fround((f12 > f11 ? f12 : f11) + Math_fround(9.99999997e-07));
 f16 = Math_fround((f13 > f16 ? f13 : f16) + Math_fround(9.99999997e-07));
 f15 = Math_fround((f5 > f15 ? f5 : f15) + Math_fround(9.99999997e-07));
 f5 = Math_fround(-f6);
 f13 = Math_fround(-f8);
 f12 = Math_fround(-f10);
 f5 = Math_fround((f6 > f5 ? f6 : f5) + Math_fround(9.99999997e-07));
 f13 = Math_fround((f8 > f13 ? f8 : f13) + Math_fround(9.99999997e-07));
 f12 = Math_fround((f10 > f12 ? f10 : f12) + Math_fround(9.99999997e-07));
 f10 = Math_fround(-f9);
 f8 = Math_fround(-f7);
 f6 = Math_fround(-f2);
 f10 = Math_fround((f9 > f10 ? f9 : f10) + Math_fround(9.99999997e-07));
 f8 = Math_fround((f7 > f8 ? f7 : f8) + Math_fround(9.99999997e-07));
 f6 = Math_fround((f2 > f6 ? f2 : f6) + Math_fround(9.99999997e-07));
 HEAPF32[i4 + 80 >> 2] = f11;
 HEAPF32[i4 + 84 >> 2] = f16;
 HEAPF32[i4 + 88 >> 2] = f15;
 HEAPF32[i4 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 96 >> 2] = f5;
 HEAPF32[i4 + 100 >> 2] = f13;
 HEAPF32[i4 + 104 >> 2] = f12;
 HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 112 >> 2] = f10;
 HEAPF32[i4 + 116 >> 2] = f8;
 HEAPF32[i4 + 120 >> 2] = f6;
 HEAPF32[i4 + 124 >> 2] = Math_fround(0.0);
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(Math_fround(Math_fround(f2 * f5) + Math_fround(f7 * f13)) + Math_fround(f9 * f12));
 f14 = Math_fround(Math_fround(Math_fround(f2 * f10) + Math_fround(f7 * f8)) + Math_fround(f9 * f6));
 HEAPF32[i4 + 128 >> 2] = Math_fround(Math_fround(Math_fround(f2 * f11) + Math_fround(f7 * f16)) + Math_fround(f9 * f15));
 HEAPF32[i4 + 132 >> 2] = f17;
 HEAPF32[i4 + 136 >> 2] = f14;
 HEAPF32[i4 + 140 >> 2] = Math_fround(0.0);
 f14 = Math_fround(Math_fround(f9 * f11) + Math_fround(f2 * f15));
 f11 = Math_fround(Math_fround(f7 * f11) + Math_fround(f2 * f16));
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_fround(f9 * f16) + Math_fround(f7 * f15));
 HEAPF32[i4 + 148 >> 2] = f14;
 HEAPF32[i4 + 152 >> 2] = f11;
 HEAPF32[i4 + 156 >> 2] = Math_fround(0.0);
 f11 = Math_fround(Math_fround(f9 * f5) + Math_fround(f2 * f12));
 f5 = Math_fround(Math_fround(f7 * f5) + Math_fround(f2 * f13));
 HEAPF32[i4 + 160 >> 2] = Math_fround(Math_fround(f9 * f13) + Math_fround(f7 * f12));
 HEAPF32[i4 + 164 >> 2] = f11;
 HEAPF32[i4 + 168 >> 2] = f5;
 HEAPF32[i4 + 172 >> 2] = Math_fround(0.0);
 f5 = Math_fround(Math_fround(f9 * f10) + Math_fround(f2 * f6));
 f2 = Math_fround(Math_fround(f7 * f10) + Math_fround(f2 * f8));
 HEAPF32[i4 + 176 >> 2] = Math_fround(Math_fround(f9 * f8) + Math_fround(f7 * f6));
 HEAPF32[i4 + 180 >> 2] = f5;
 HEAPF32[i4 + 184 >> 2] = f2;
 HEAPF32[i4 + 188 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i10);
 i1 = i6 + 32 | 0;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i8 = i10 + 24 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i5 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 60 | 0, i10);
 i1 = i6 + 52 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i5 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i5;
 }
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4); else {
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i1 = HEAP32[gb + 1457408 >> 2] | 0;
 if (i1 | 0) HEAP32[i6 + 44 >> 2] = HEAP32[i9 >> 2];
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  i1 = HEAP32[gb + 1457408 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  f3 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 do if (i1 | 0) if (!(f3 <= Math_fround(0.0))) {
  HEAPF32[i6 + 48 >> 2] = f3;
  break;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737405 | 0, 0, gb + 662472 | 0, 1179, 1, 0, 0, 0);
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i4 = HEAP32[gb + 1457408 >> 2] | 0;
 if (i4 | 0) HEAP32[i6 + 168 >> 2] = (i1 | 0) < 1 ? 1 : (i1 | 0) > 255 ? 255 : i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[gb + 1457408 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i2;
  i1 = i4;
  i2 = i5;
 }
 if (i1 | 0) HEAP32[i6 + 172 >> 2] = (i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i6 + 798 >> 0] = i1;
 i1 = i6 + 56 | 0;
 if ((i2 + 1 | 0) >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 57 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 797 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i4 = i6 + 724 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j(i4, i1);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, HEAP32[i4 >> 2] | 0, i1 << 2);
 STACKTOP = i11;
 return;
}

function _jpeg_idct_ifast(i1, i2, i3, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i7 = HEAP32[i1 + 288 >> 2] | 0;
 i6 = i8;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i2 = 8;
 while (1) {
  i4 = HEAP16[i3 + 16 >> 1] | 0;
  i1 = HEAP16[i3 + 32 >> 1] | 0;
  if (!((i4 | i1) << 16 >> 16)) if (!(HEAP16[i3 + 48 >> 1] | 0)) if (!(HEAP16[i3 + 64 >> 1] | 0)) if (!(HEAP16[i3 + 80 >> 1] | 0)) if (!(HEAP16[i3 + 96 >> 1] | 0)) if (!(HEAP16[i3 + 112 >> 1] | 0)) {
   i4 = Math_imul(HEAP16[i3 >> 1] | 0, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 32 >> 2] = i4;
   HEAP32[i6 + 64 >> 2] = i4;
   HEAP32[i6 + 96 >> 2] = i4;
   HEAP32[i6 + 128 >> 2] = i4;
   HEAP32[i6 + 160 >> 2] = i4;
   HEAP32[i6 + 192 >> 2] = i4;
   HEAP32[i6 + 224 >> 2] = i4;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else {
   i1 = 0;
   i11 = 9;
  } else i11 = 9;
  if ((i11 | 0) == 9) {
   i11 = 0;
   i15 = Math_imul(HEAP16[i3 >> 1] | 0, HEAP32[i5 >> 2] | 0) | 0;
   i18 = Math_imul(i1 << 16 >> 16, HEAP32[i5 + 64 >> 2] | 0) | 0;
   i17 = Math_imul(HEAP16[i3 + 64 >> 1] | 0, HEAP32[i5 + 128 >> 2] | 0) | 0;
   i14 = Math_imul(HEAP16[i3 + 96 >> 1] | 0, HEAP32[i5 + 192 >> 2] | 0) | 0;
   i16 = i17 + i15 | 0;
   i17 = i15 - i17 | 0;
   i1 = i14 + i18 | 0;
   i14 = ((i18 - i14 | 0) * 362 >> 8) - i1 | 0;
   i18 = i1 + i16 | 0;
   i1 = i16 - i1 | 0;
   i16 = i14 + i17 | 0;
   i14 = i17 - i14 | 0;
   i17 = Math_imul(i4 << 16 >> 16, HEAP32[i5 + 32 >> 2] | 0) | 0;
   i15 = Math_imul(HEAP16[i3 + 48 >> 1] | 0, HEAP32[i5 + 96 >> 2] | 0) | 0;
   i20 = Math_imul(HEAP16[i3 + 80 >> 1] | 0, HEAP32[i5 + 160 >> 2] | 0) | 0;
   i19 = Math_imul(HEAP16[i3 + 112 >> 1] | 0, HEAP32[i5 + 224 >> 2] | 0) | 0;
   i13 = i20 + i15 | 0;
   i15 = i20 - i15 | 0;
   i20 = i19 + i17 | 0;
   i19 = i17 - i19 | 0;
   i17 = i20 + i13 | 0;
   i4 = (i19 + i15 | 0) * 473 >> 8;
   i15 = ((Math_imul(i15, -669) | 0) >> 8) - i17 + i4 | 0;
   i13 = ((i20 - i13 | 0) * 362 >> 8) - i15 | 0;
   i4 = i13 + ((i19 * 277 >> 8) - i4) | 0;
   HEAP32[i6 >> 2] = i17 + i18;
   HEAP32[i6 + 224 >> 2] = i18 - i17;
   HEAP32[i6 + 32 >> 2] = i15 + i16;
   HEAP32[i6 + 192 >> 2] = i16 - i15;
   HEAP32[i6 + 64 >> 2] = i13 + i14;
   HEAP32[i6 + 160 >> 2] = i14 - i13;
   HEAP32[i6 + 128 >> 2] = i4 + i1;
   HEAP32[i6 + 96 >> 2] = i1 - i4;
  }
  if ((i2 | 0) > 1) {
   i6 = i6 + 4 | 0;
   i5 = i5 + 4 | 0;
   i3 = i3 + 2 | 0;
   i2 = i2 + -1 | 0;
  } else break;
 }
 i6 = i7 + 128 | 0;
 i5 = 0;
 i2 = i8;
 while (1) {
  i3 = (HEAP32[i9 + (i5 << 2) >> 2] | 0) + i10 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!(i4 | i1)) if (!(HEAP32[i2 + 12 >> 2] | 0)) if (!(HEAP32[i2 + 16 >> 2] | 0)) if (!(HEAP32[i2 + 20 >> 2] | 0)) if (!(HEAP32[i2 + 24 >> 2] | 0)) if (!(HEAP32[i2 + 28 >> 2] | 0)) {
   i20 = HEAP8[i6 + ((HEAP32[i2 >> 2] | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 >> 0] = i20;
   _memset(i3 + 1 | 0, i20 | 0, 7) | 0;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else {
   i1 = 0;
   i11 = 19;
  } else i11 = 19;
  if ((i11 | 0) == 19) {
   i11 = 0;
   i17 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i2 + 16 >> 2] | 0;
   i15 = i8 + i17 | 0;
   i8 = i17 - i8 | 0;
   i17 = HEAP32[i2 + 24 >> 2] | 0;
   i19 = i17 + i1 | 0;
   i17 = ((i1 - i17 | 0) * 362 >> 8) - i19 | 0;
   i13 = i19 + i15 | 0;
   i19 = i15 - i19 | 0;
   i15 = i17 + i8 | 0;
   i17 = i8 - i17 | 0;
   i8 = HEAP32[i2 + 20 >> 2] | 0;
   i16 = HEAP32[i2 + 12 >> 2] | 0;
   i18 = i16 + i8 | 0;
   i16 = i8 - i16 | 0;
   i8 = HEAP32[i2 + 28 >> 2] | 0;
   i7 = i8 + i4 | 0;
   i8 = i4 - i8 | 0;
   i14 = i7 + i18 | 0;
   i20 = (i8 + i16 | 0) * 473 >> 8;
   i16 = ((Math_imul(i16, -669) | 0) >> 8) - i14 + i20 | 0;
   i18 = ((i7 - i18 | 0) * 362 >> 8) - i16 | 0;
   i20 = i18 + ((i8 * 277 >> 8) - i20) | 0;
   HEAP8[i3 >> 0] = HEAP8[i6 + ((i14 + i13 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 7 >> 0] = HEAP8[i6 + ((i13 - i14 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 1 >> 0] = HEAP8[i6 + ((i16 + i15 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 6 >> 0] = HEAP8[i6 + ((i15 - i16 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 2 >> 0] = HEAP8[i6 + ((i18 + i17 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 5 >> 0] = HEAP8[i6 + ((i17 - i18 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 4 >> 0] = HEAP8[i6 + ((i20 + i19 | 0) >>> 5 & 1023) >> 0] | 0;
   HEAP8[i3 + 3 >> 0] = HEAP8[i6 + ((i19 - i20 | 0) >>> 5 & 1023) >> 0] | 0;
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 8) break; else i2 = i2 + 32 | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i11 + 4 | 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471202 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 899057 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471313 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i7 >> 0] = i1;
 i5 = HEAP32[gb + 37252 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 913271 | 0, i5, i9, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 HEAP32[i4 >> 2] = i1 << 24 >> 24;
 i3 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471291 | 0, i5, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i11 + 4 | 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471202 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i10 + 16 | 0;
   i2 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 899057 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471313 | 0, i5, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i7 >> 0] = i1;
 i5 = HEAP32[gb + 37252 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 913271 | 0, i5, i9, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i6 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i7 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i10);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 HEAP32[i4 >> 2] = i1 << 24 >> 24;
 i3 = i8 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 471325 | 0, i5, i9, 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i10 + 16 | 0;
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i10 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj(i8, i1, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 76 | 0;
 i10 = i13;
 i11 = i8 + 72 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv(i8);
 i12 = i8 + 56 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i9 = i8 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i8 + 68 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i8 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i17 = i10 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i10 + 8 | 0;
 i19 = i8 + 8 | 0;
 i14 = HEAP16[i19 >> 1] | 0;
 HEAP8[i18 >> 0] = i14;
 i16 = i10 + 9 | 0;
 HEAP8[i16 >> 0] = (i14 & 65535) >>> 8;
 i14 = i10 + 12 | 0;
 i15 = i8 + 12 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 i6 = i10 + 32 | 0;
 i4 = i8 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 i5 = i10 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP8[i5 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i10, i8, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i1;
 i2 = HEAP8[i19 >> 0] | 0;
 i17 = HEAP16[i18 >> 1] | 0;
 HEAP8[i19 >> 0] = i17;
 HEAP8[i18 >> 0] = i2;
 i2 = i8 + 9 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = (i17 & 65535) >>> 8;
 HEAP8[i16 >> 0] = i1;
 HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i1;
 i5 = i10 + 56 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i5 >> 2] = i7;
 i12 = i10 + 60 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i5;
 f3 = Math_fround(i6 >>> 0);
 HEAP32[i8 + 68 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i8 + 64 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i7 >>> 0);
 HEAP32[i10 + 68 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 + 64 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i10 + 72 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns(i5, i6, i8, i3, i1, i4, i15) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 var i2 = 0, f7 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 68 | 0;
 i12 = i16 + 64 | 0;
 i14 = i16;
 i9 = HEAP32[i8 >> 2] | 0;
 i2 = i9 + 40 | 0;
 f10 = Math_fround(HEAPF32[((HEAP32[i2 >> 2] | 0) == 3 ? i9 + 204 | 0 : i9 + 48 | 0) >> 2]);
 f7 = Math_fround(Math_fround(__ZNK6Camera17GetProjectionNearEv(i6)) * Math_fround(1.00100005));
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) != 2 | i4) {
  if ((i2 | 0) != 0 | i4) {
   i2 = HEAP32[i5 + 4212 >> 2] | 0 ? 2 : 1;
   i1 = 0;
   do {
    __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i5, i6, i15, i8 + 48 + (i1 << 4) | 0, f7, 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   STACKTOP = i16;
   return;
  }
  i3 = i14;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  f7 = Math_fround(f10 / Math_fround(HEAPF32[i9 + 68 >> 2]));
  HEAPF32[i11 >> 2] = f7;
  HEAPF32[i11 + 4 >> 2] = f7;
  HEAPF32[i11 + 8 >> 2] = f10;
  __ZN10Matrix4x4f5ScaleERK8Vector3f(i14, i11) | 0;
  HEAP32[i12 >> 2] = HEAP32[gb + 1477020 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 26; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 28;
   }
  }
  if ((i13 | 0) == 26) i13 = 28;
  if ((i13 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477020 >> 2] | 0) | 0;
  __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(i15, i1, i14, -1);
  STACKTOP = i16;
  return;
 }
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i14, i3) | 0;
 HEAPF32[i14 >> 2] = f10;
 HEAPF32[i14 + 20 >> 2] = f10;
 HEAPF32[i14 + 40 >> 2] = f10;
 do if (Math_fround(HEAPF32[i8 + 60 >> 2]) > Math_fround(.25)) {
  HEAP32[i12 >> 2] = HEAP32[gb + 1477016 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477016 >> 2] | 0) | 0;
 } else {
  HEAP32[i12 >> 2] = HEAP32[gb + 1477012 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1477012 >> 2] | 0) | 0;
 } while (0);
 __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(i15, i1, i14, -1);
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i19, i1, i14) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 24 | 0;
 i18 = i21 + 16 | 0;
 i15 = i21 + 12 | 0;
 i16 = i21 + 8 | 0;
 i10 = i21 + 4 | 0;
 i11 = i21;
 i9 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i6 = i12 - i9 | 0;
 i17 = i6 >> 4;
 i7 = i19 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i8 = i9;
 i4 = i2;
 if (i17 >>> 0 > i1 - i2 >> 4 >>> 0) {
  if (i2) {
   i5 = i19 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i20 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i16 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i20 >> 2] = 66;
      HEAP32[i3 >> 2] = i16;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i19 >> 2] | 0;
   }
   i16 = HEAP32[i19 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 34;
   HEAP32[i20 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
  } else i2 = 0;
  i16 = i1 - i2 | 0;
  i1 = i16 >> 3;
  i1 = i16 >> 4 >>> 0 < 1073741823 ? (i1 >>> 0 < i17 >>> 0 ? i17 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
  i16 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i20 >> 2] = 34;
  HEAP32[i20 + 4 >> 2] = i16;
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i19 + 4 >> 2] = i16;
  HEAP32[i19 >> 2] = i16;
  HEAP32[i7 >> 2] = i16 + (i1 << 4);
  HEAP32[i10 >> 2] = i9;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i13 = i19 + 4 | 0;
 i10 = (HEAP32[i13 >> 2] | 0) - i2 >> 4;
 i11 = i17 >>> 0 > i10 >>> 0;
 i10 = i11 ? i8 + (i10 << 4) | 0 : i12;
 i9 = i10;
 if ((i8 | 0) != (i9 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = i8 + 16 | 0;
   i1 = i1 + 16 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i15 >> 2] = i10;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  i17 = i17 - ((HEAP32[i13 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) >> 4) | 0;
  HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i21;
  return;
 }
 i3 = i20 + 4 | 0;
 do {
  i2 = i1 + -16 | 0;
  HEAP32[i13 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i19 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
   i1 = HEAP32[i13 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i19, i1, i14) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 24 | 0;
 i18 = i21 + 16 | 0;
 i15 = i21 + 12 | 0;
 i16 = i21 + 8 | 0;
 i10 = i21 + 4 | 0;
 i11 = i21;
 i9 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i6 = i12 - i9 | 0;
 i17 = i6 >> 4;
 i7 = i19 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i8 = i9;
 i4 = i2;
 if (i17 >>> 0 > i1 - i2 >> 4 >>> 0) {
  if (i2) {
   i5 = i19 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i20 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i16 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i20 >> 2] = 66;
      HEAP32[i3 >> 2] = i16;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i19 >> 2] | 0;
   }
   i16 = HEAP32[i19 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = 12;
   HEAP32[i20 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
  } else i2 = 0;
  i16 = i1 - i2 | 0;
  i1 = i16 >> 3;
  i1 = i16 >> 4 >>> 0 < 1073741823 ? (i1 >>> 0 < i17 >>> 0 ? i17 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
  i16 = HEAP32[i19 + 12 >> 2] | 0;
  HEAP32[i20 >> 2] = 12;
  HEAP32[i20 + 4 >> 2] = i16;
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i19 + 4 >> 2] = i16;
  HEAP32[i19 >> 2] = i16;
  HEAP32[i7 >> 2] = i16 + (i1 << 4);
  HEAP32[i10 >> 2] = i9;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i13 = i19 + 4 | 0;
 i10 = (HEAP32[i13 >> 2] | 0) - i2 >> 4;
 i11 = i17 >>> 0 > i10 >>> 0;
 i10 = i11 ? i8 + (i10 << 4) | 0 : i12;
 i9 = i10;
 if ((i8 | 0) != (i9 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = i8 + 16 | 0;
   i1 = i1 + 16 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i15 >> 2] = i10;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  i17 = i17 - ((HEAP32[i13 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) >> 4) | 0;
  HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i21;
  return;
 }
 i3 = i20 + 4 | 0;
 do {
  i2 = i1 + -16 | 0;
  HEAP32[i13 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i19 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
   i1 = HEAP32[i13 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i21;
 return;
}

function _match_in_dir(i21, i2, i22, i23, i16) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i16 = i16 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i25 + 80 | 0;
 i18 = i25 + 76 | 0;
 i19 = i25;
 i15 = (_strlen(i2) | 0) + 1 | 0;
 i24 = _llvm_stacksave() | 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i15 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = _strlen(i21) | 0;
 i4 = i22 & 64;
 i15 = (i22 >>> 5 & 4 | i4 >>> 5) ^ 4;
 i1 = _strchr(i2, 47) | 0;
 if (!i1) {
  i3 = i2;
  i14 = 0;
 } else {
  _strcpy(i3, i2) | 0;
  HEAP8[i3 + (i1 - i2) >> 0] = 0;
  while (1) if ((HEAP8[i1 >> 0] | 0) == 47) i1 = i1 + 1 | 0; else {
   i14 = i1;
   break;
  }
 }
 i2 = HEAP8[i3 >> 0] | 0;
 L6 : do if (!(i2 << 24 >> 24)) i4 = 1; else {
  i5 = (i4 | 0) == 0;
  i4 = i3;
  i1 = 0;
  while (1) {
   switch (i2 << 24 >> 24 | 0) {
   case 42:
   case 63:
    {
     i4 = 0;
     break L6;
    }
   case 92:
    {
     if (i5) {
      i4 = 0;
      break L6;
     }
     break;
    }
   case 91:
    {
     i1 = 1;
     break;
    }
   case 93:
    {
     if (!i1) i1 = 0; else {
      i4 = 0;
      break L6;
     }
     break;
    }
   default:
    {}
   }
   i4 = i4 + 1 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) {
    i4 = 1;
    break L6;
   }
  }
 } while (0);
 i1 = HEAP8[i21 >> 0] | 0;
 if (i1 << 24 >> 24 == 47) i6 = (HEAP8[i21 + 1 >> 0] | 0) == 0 ? 0 : i6;
 i13 = _opendir(i1 << 24 >> 24 ? i21 : gb + 1087625 | 0) | 0;
 i1 = HEAP32[(___errno_location() | 0) >> 2] | 0;
 L19 : do if (!i13) {
  switch (i1 | 0) {
  case 20:
   {
    i1 = 0;
    break L19;
   }
  case 13:
   {
    if (!(HEAP8[i3 >> 0] | 0)) if (!(_stat(i21, i19) | 0)) if ((HEAP32[i19 + 12 >> 2] & 61440 | 0) == 16384) {
     i1 = (_append(i16, i21, i6, i6) | 0) != 0 & 1;
     break L19;
    }
    break;
   }
  default:
   {}
  }
  i1 = (mftCall_iii(i23 | 0, i21 | 0, i1 | 0) | 0 | i22 & 1 | 0) == 0;
  i1 = i1 ? 0 : 2;
 } else {
  if (!(HEAP8[i3 >> 0] | 0)) {
   i1 = (_append(i16, i21, i6, i6) | 0) != 0 & 1;
   _closedir(i13) | 0;
   break;
  }
  i1 = _readdir_r(i13, i17, i18) | 0;
  i2 = (i1 | 0) != 0;
  i5 = HEAP32[i18 >> 2] | 0;
  L33 : do if ((i5 | 0) != 0 & (i2 ^ 1)) {
   i12 = i6 + 2 | 0;
   i7 = (i4 | 0) == 0;
   i8 = (i14 | 0) != 0;
   i9 = (i22 & 2 | 0) == 0;
   i10 = i6 + 1 | 0;
   i11 = i19 + 12 | 0;
   i4 = i5;
   L35 : while (1) {
    i5 = i12 + (HEAPU16[i4 + 8 >> 1] | 0) | 0;
    i4 = _llvm_stacksave() | 0;
    i2 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    i1 = (HEAP32[i18 >> 2] | 0) + 11 | 0;
    if (i7) {
     if (!(_fnmatch(i3, i1, i15) | 0)) i20 = 28;
    } else if (!(_strcmp(i3, i1) | 0)) i20 = 28;
    L40 : do if ((i20 | 0) == 28) {
     i20 = 0;
     L42 : do if (i8) {
      i1 = HEAP8[(HEAP32[i18 >> 2] | 0) + 10 >> 0] | 0;
      if (i1 << 24 >> 24) {
       i1 = (i1 & 255) << 12 & 65535;
       if (i1 << 16 >> 16 < 16384) switch (i1 << 16 >> 16) {
       case -24576:
        break L42;
       default:
        break L40;
       } else switch (i1 << 16 >> 16) {
       case 16384:
        break L42;
       default:
        break L40;
       }
      }
     } while (0);
     if (!(HEAP8[i21 >> 0] | 0)) i2 = (HEAP32[i18 >> 2] | 0) + 11 | 0; else {
      _memcpy(i2 | 0, i21 | 0, i6 | 0) | 0;
      i5 = i2 + i6 | 0;
      HEAP8[i5 >> 0] = 47;
      _strcpy(i5 + 1 | 0, (HEAP32[i18 >> 2] | 0) + 11 | 0) | 0;
     }
     if (i8) {
      i1 = _match_in_dir(i2, i14, i22, i23, i16) | 0;
      if (!i1) break; else {
       i20 = 36;
       break L35;
      }
     }
     do if (i9) i1 = 0; else {
      i1 = HEAP8[(HEAP32[i18 >> 2] | 0) + 10 >> 0] | 0;
      if (i1 << 24 >> 24) {
       i1 = (i1 & 255) << 12 & 61440;
       if ((i1 | 0) != 40960) {
        i1 = (i1 | 0) == 16384;
        break;
       }
      }
      _stat(i2, i19) | 0;
      i1 = (HEAP32[i11 >> 2] & 61440 | 0) == 16384;
     } while (0);
     if (_append(i16, i2, i10 + (HEAPU16[(HEAP32[i18 >> 2] | 0) + 8 >> 1] | 0) | 0, i1 & 1) | 0) {
      i20 = 43;
      break L35;
     }
    } while (0);
    _llvm_stackrestore(i4 | 0);
    i1 = _readdir_r(i13, i17, i18) | 0;
    i2 = (i1 | 0) != 0;
    i4 = HEAP32[i18 >> 2] | 0;
    if (!((i4 | 0) != 0 & (i2 ^ 1))) break L33;
   }
   if ((i20 | 0) == 36) _closedir(i13) | 0; else if ((i20 | 0) == 43) {
    _closedir(i13) | 0;
    i1 = 1;
   }
   _llvm_stackrestore(i4 | 0);
   break L19;
  } while (0);
  _closedir(i13) | 0;
  if (i2) if (mftCall_iii(i23 | 0, i21 | 0, i1 | 0) | 0 | i22 & 1 | 0) {
   i1 = 2;
   break;
  }
  i1 = 0;
 } while (0);
 _llvm_stackrestore(i24 | 0);
 STACKTOP = i25;
 return i1 | 0;
}

function __ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i31;
 i26 = i31 + 36 | 0;
 i27 = i31 + 32 | 0;
 i28 = i31 + 28 | 0;
 i29 = i31 + 24 | 0;
 i30 = i31 + 20 | 0;
 i25 = i31 + 16 | 0;
 if (HEAP8[i3 + 325 >> 0] | 0) {
  STACKTOP = i31;
  return;
 }
 i19 = i2 + 16 | 0;
 if ((HEAP32[i19 >> 2] | 0) <= 0) {
  STACKTOP = i31;
  return;
 }
 i20 = i3 + 316 | 0;
 i21 = i3 + 356 | 0;
 i22 = i3 + 344 | 0;
 i23 = i3 + 360 | 0;
 i17 = i3 + 308 | 0;
 i18 = i3 + 324 | 0;
 i14 = i2 + 4 | 0;
 i15 = i3 + 320 | 0;
 i16 = i3 + 304 | 0;
 i10 = i3 + 312 | 0;
 i11 = i25 + 3 | 0;
 i12 = i25 + 1 | 0;
 i13 = i25 + 2 | 0;
 i1 = i4;
 i9 = 0;
 do {
  if ((HEAP32[i20 >> 2] | 0) == 4) {
   i8 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = i2 & 255;
   i1 = i2 >>> 8 & 255;
   i7 = i2 >>> 16 & 255;
   i4 = i2 >>> 24;
   i6 = i4 & 255;
   i5 = HEAP32[i21 >> 2] | 0;
   do if (!i5) {
    if (__ZNK5physx2Sn12PointerRemap12getObjectRefEyRj(i22, i2, 0, i27) | 0) {
     i1 = HEAP32[i27 >> 2] | 0;
     i4 = i1 >>> 24 & 255;
     i3 = i1 & 255;
     i2 = i1 >>> 16 & 255;
     i1 = i1 >>> 8 & 255;
     break;
    }
    i2 = i2 & 16777215 | i4 << 24;
    if (!i2) {
     i4 = i6;
     i2 = i7;
    } else {
     i1 = (HEAP32[i23 >> 2] | 0) + 1 | 0;
     HEAP32[i23 >> 2] = i1;
     i4 = i1 | -2147483648;
     __ZN5physx2Sn12PointerRemap12setObjectRefEyj(i22, i2, 0, i4);
     i4 = i4 >>> 24 & 255;
     i3 = i1 & 255;
     i2 = i1 >>> 16 & 255;
     i1 = i1 >>> 8 & 255;
    }
   } else {
    if (__ZNK5physx2Sn12PointerRemap12getObjectRefEyRj(i5, i2, 0, i26) | 0) {
     i1 = HEAP32[i26 >> 2] | 0;
     i4 = i1 >>> 24 & 255;
     i3 = i1 & 255;
     i2 = i1 >>> 16 & 255;
     i1 = i1 >>> 8 & 255;
     break;
    }
    if (!(i2 & 16777215 | i4 << 24)) {
     i4 = i6;
     i2 = i7;
    } else {
     i2 = HEAP32[i14 >> 2] | 0;
     if (i2 | 0) if (!(_strcmp(i2, gb + 747335 | 0) | 0)) {
      i4 = i6;
      i2 = i7;
      break;
     }
     i4 = 18;
     i3 = 120;
     i2 = 52;
     i1 = 86;
    }
   } while (0);
   i7 = (HEAP8[i17 >> 0] | 0) == 0;
   HEAP32[i24 >> 2] = (HEAP8[i18 >> 0] | 0) == 0 ? ((i7 ? i2 : i1) & 255) << 16 | (i7 ? i3 : i4) & 255 | ((i7 ? i4 : i3) & 255) << 24 | ((i7 ? i1 : i2) & 255) << 8 : 0;
   i1 = i8;
   i4 = 0;
  } else {
   i4 = i1 + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = HEAP32[i21 >> 2] | 0;
   do if (!i2) {
    if (__ZNK5physx2Sn12PointerRemap12getObjectRefEyRj(i22, i3, i1, i29) | 0) {
     i2 = HEAP32[i29 >> 2] | 0;
     i1 = 0;
     break;
    }
    if ((i3 | 0) == 0 & (i1 | 0) == 0) {
     i2 = 0;
     i1 = 0;
    } else {
     i2 = (HEAP32[i23 >> 2] | 0) + 1 | 0;
     HEAP32[i23 >> 2] = i2;
     i2 = i2 | -2147483648;
     __ZN5physx2Sn12PointerRemap12setObjectRefEyj(i22, i3, i1, i2);
     i1 = 0;
    }
   } else {
    if (__ZNK5physx2Sn12PointerRemap12getObjectRefEyRj(i2, i3, i1, i28) | 0) {
     i2 = HEAP32[i28 >> 2] | 0;
     i1 = 0;
     break;
    }
    if ((i3 | 0) == 0 & (i1 | 0) == 0) {
     i2 = 0;
     i1 = 0;
    } else {
     i2 = HEAP32[i14 >> 2] | 0;
     if (i2 | 0) if (!(_strcmp(i2, gb + 747335 | 0) | 0)) {
      i2 = i3;
      break;
     }
     i2 = 305419896;
     i1 = 0;
    }
   } while (0);
   i6 = (HEAP8[i18 >> 0] | 0) == 0;
   i8 = i6 ? i2 : 0;
   i7 = i24;
   HEAP32[i7 >> 2] = i8;
   HEAP32[i7 + 4 >> 2] = i6 ? i1 : 0;
   i1 = i4;
   i4 = i8;
  }
  i2 = HEAP32[i20 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  do if ((i2 | 0) == (i3 | 0)) {
   i8 = HEAP32[i16 >> 2] | 0;
   i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i24 | 0, i2 | 0) | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i8;
  } else {
   if ((i3 | 0) > (i2 | 0)) {
    i8 = HEAP32[i16 >> 2] | 0;
    i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i24 | 0, i2 | 0) | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i8;
    HEAP32[i30 >> 2] = 0;
    i8 = HEAP32[i16 >> 2] | 0;
    i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i30 | 0, 4) | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i8;
    break;
   }
   HEAP32[i25 >> 2] = i4;
   if (HEAP8[i17 >> 0] | 0) {
    HEAP8[i25 >> 0] = i4 >>> 24;
    HEAP8[i11 >> 0] = i4;
    HEAP8[i12 >> 0] = i4 >>> 16;
    HEAP8[i13 >> 0] = i4 >>> 8;
   }
   i8 = HEAP32[i16 >> 2] | 0;
   i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i25 | 0, 4) | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i8;
  } while (0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (HEAP32[i19 >> 2] | 0));
 STACKTOP = i31;
 return;
}

function __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_(i39, i40, i34, i24, i12, i1) {
 i39 = i39 | 0;
 i40 = i40 | 0;
 i34 = i34 | 0;
 i24 = i24 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i35 = __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_(i39, i40, i34, i24, i1) | 0;
 i13 = i24 + 40 | 0;
 if ((HEAP32[i12 + 40 >> 2] | 0) >= (HEAP32[i13 >> 2] | 0)) {
  i40 = i35;
  return i40 | 0;
 }
 i1 = HEAP32[i24 >> 2] | 0;
 i15 = i24 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = i24 + 8 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i17 = i24 + 12 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i18 = i24 + 16 | 0;
 i5 = HEAP32[i18 >> 2] | 0;
 i19 = i24 + 20 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i20 = i24 + 24 | 0;
 i7 = HEAP32[i20 >> 2] | 0;
 i21 = i24 + 28 | 0;
 i8 = HEAP32[i21 >> 2] | 0;
 i22 = i24 + 32 | 0;
 i9 = HEAP32[i22 >> 2] | 0;
 i23 = i24 + 36 | 0;
 i11 = i23;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i36 = i24;
 i37 = i12;
 i38 = i36 + 44 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i12 >> 2] = i1;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i3;
 HEAP32[i12 + 12 >> 2] = i4;
 HEAP32[i12 + 16 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i6;
 HEAP32[i12 + 24 >> 2] = i7;
 HEAP32[i12 + 28 >> 2] = i8;
 HEAP32[i12 + 32 >> 2] = i9;
 i14 = i12 + 36 | 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i11;
 i14 = i34 + 40 | 0;
 if ((HEAP32[i13 >> 2] | 0) >= (HEAP32[i14 >> 2] | 0)) {
  i40 = i35 + 1 | 0;
  return i40 | 0;
 }
 i1 = HEAP32[i34 >> 2] | 0;
 i25 = i34 + 4 | 0;
 i2 = HEAP32[i25 >> 2] | 0;
 i26 = i34 + 8 | 0;
 i3 = HEAP32[i26 >> 2] | 0;
 i27 = i34 + 12 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i28 = i34 + 16 | 0;
 i5 = HEAP32[i28 >> 2] | 0;
 i29 = i34 + 20 | 0;
 i6 = HEAP32[i29 >> 2] | 0;
 i30 = i34 + 24 | 0;
 i7 = HEAP32[i30 >> 2] | 0;
 i31 = i34 + 28 | 0;
 i8 = HEAP32[i31 >> 2] | 0;
 i32 = i34 + 32 | 0;
 i9 = HEAP32[i32 >> 2] | 0;
 i33 = i34 + 36 | 0;
 i11 = i33;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i36 = i34;
 i37 = i24;
 i38 = i36 + 44 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i24 >> 2] = i1;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i16 >> 2] = i3;
 HEAP32[i17 >> 2] = i4;
 HEAP32[i18 >> 2] = i5;
 HEAP32[i19 >> 2] = i6;
 HEAP32[i20 >> 2] = i7;
 HEAP32[i21 >> 2] = i8;
 HEAP32[i22 >> 2] = i9;
 i12 = i23;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i40 + 40 | 0;
 if ((HEAP32[i14 >> 2] | 0) >= (HEAP32[i12 >> 2] | 0)) {
  i40 = i35 + 2 | 0;
  return i40 | 0;
 }
 i2 = HEAP32[i40 >> 2] | 0;
 i13 = i40 + 4 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i14 = i40 + 8 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i15 = i40 + 12 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i16 = i40 + 16 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i17 = i40 + 20 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 i18 = i40 + 24 | 0;
 i8 = HEAP32[i18 >> 2] | 0;
 i19 = i40 + 28 | 0;
 i9 = HEAP32[i19 >> 2] | 0;
 i20 = i40 + 32 | 0;
 i10 = HEAP32[i20 >> 2] | 0;
 i21 = i40 + 36 | 0;
 i1 = i21;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i36 = i40;
 i37 = i34;
 i38 = i36 + 44 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i34 >> 2] = i2;
 HEAP32[i25 >> 2] = i3;
 HEAP32[i26 >> 2] = i4;
 HEAP32[i27 >> 2] = i5;
 HEAP32[i28 >> 2] = i6;
 HEAP32[i29 >> 2] = i7;
 HEAP32[i30 >> 2] = i8;
 HEAP32[i31 >> 2] = i9;
 HEAP32[i32 >> 2] = i10;
 i38 = i33;
 HEAP32[i38 >> 2] = i11;
 HEAP32[i38 + 4 >> 2] = i1;
 if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i39 + 40 >> 2] | 0)) {
  i40 = i35 + 3 | 0;
  return i40 | 0;
 }
 i1 = HEAP32[i39 >> 2] | 0;
 i2 = HEAP32[i39 + 4 >> 2] | 0;
 i3 = HEAP32[i39 + 8 >> 2] | 0;
 i4 = HEAP32[i39 + 12 >> 2] | 0;
 i5 = HEAP32[i39 + 16 >> 2] | 0;
 i6 = HEAP32[i39 + 20 >> 2] | 0;
 i7 = HEAP32[i39 + 24 >> 2] | 0;
 i8 = HEAP32[i39 + 28 >> 2] | 0;
 i9 = HEAP32[i39 + 32 >> 2] | 0;
 i11 = i39 + 36 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i36 = i39;
 i37 = i40;
 i38 = i36 + 44 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i40 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i14 >> 2] = i3;
 HEAP32[i15 >> 2] = i4;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i17 >> 2] = i6;
 HEAP32[i18 >> 2] = i7;
 HEAP32[i19 >> 2] = i8;
 HEAP32[i20 >> 2] = i9;
 i40 = i21;
 HEAP32[i40 >> 2] = i10;
 HEAP32[i40 + 4 >> 2] = i11;
 i40 = i35 + 4 | 0;
 return i40 | 0;
}

function __ZN8GUIStyleaSERKS_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 do if ((i5 | 0) != (i6 | 0)) {
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i8 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i3 ? HEAP32[i6 + 4 >> 2] | 0 : i7 & 255;
  i3 = i5 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i5 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i5 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i8);
   break;
  }
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i5 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 i8 = HEAP32[i6 + 24 >> 2] | 0;
 i7 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = i8;
 HEAP32[i5 + 28 >> 2] = i7;
 HEAP32[i5 + 32 >> 2] = i4;
 HEAP32[i5 + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 i4 = HEAP32[i6 + 44 >> 2] | 0;
 i7 = HEAP32[i6 + 48 >> 2] | 0;
 i8 = HEAP32[i6 + 52 >> 2] | 0;
 HEAP32[i5 + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i5 + 44 >> 2] = i4;
 HEAP32[i5 + 48 >> 2] = i7;
 HEAP32[i5 + 52 >> 2] = i8;
 HEAP32[i5 + 56 >> 2] = HEAP32[i6 + 56 >> 2];
 i8 = HEAP32[i6 + 64 >> 2] | 0;
 i7 = HEAP32[i6 + 68 >> 2] | 0;
 i4 = HEAP32[i6 + 72 >> 2] | 0;
 HEAP32[i5 + 60 >> 2] = HEAP32[i6 + 60 >> 2];
 HEAP32[i5 + 64 >> 2] = i8;
 HEAP32[i5 + 68 >> 2] = i7;
 HEAP32[i5 + 72 >> 2] = i4;
 HEAP32[i5 + 76 >> 2] = HEAP32[i6 + 76 >> 2];
 i4 = HEAP32[i6 + 84 >> 2] | 0;
 i7 = HEAP32[i6 + 88 >> 2] | 0;
 i8 = HEAP32[i6 + 92 >> 2] | 0;
 HEAP32[i5 + 80 >> 2] = HEAP32[i6 + 80 >> 2];
 HEAP32[i5 + 84 >> 2] = i4;
 HEAP32[i5 + 88 >> 2] = i7;
 HEAP32[i5 + 92 >> 2] = i8;
 HEAP32[i5 + 96 >> 2] = HEAP32[i6 + 96 >> 2];
 i8 = HEAP32[i6 + 104 >> 2] | 0;
 i7 = HEAP32[i6 + 108 >> 2] | 0;
 i4 = HEAP32[i6 + 112 >> 2] | 0;
 HEAP32[i5 + 100 >> 2] = HEAP32[i6 + 100 >> 2];
 HEAP32[i5 + 104 >> 2] = i8;
 HEAP32[i5 + 108 >> 2] = i7;
 HEAP32[i5 + 112 >> 2] = i4;
 HEAP32[i5 + 116 >> 2] = HEAP32[i6 + 116 >> 2];
 i4 = HEAP32[i6 + 124 >> 2] | 0;
 i7 = HEAP32[i6 + 128 >> 2] | 0;
 i8 = HEAP32[i6 + 132 >> 2] | 0;
 HEAP32[i5 + 120 >> 2] = HEAP32[i6 + 120 >> 2];
 HEAP32[i5 + 124 >> 2] = i4;
 HEAP32[i5 + 128 >> 2] = i7;
 HEAP32[i5 + 132 >> 2] = i8;
 HEAP32[i5 + 136 >> 2] = HEAP32[i6 + 136 >> 2];
 i8 = HEAP32[i6 + 144 >> 2] | 0;
 i7 = HEAP32[i6 + 148 >> 2] | 0;
 i4 = HEAP32[i6 + 152 >> 2] | 0;
 HEAP32[i5 + 140 >> 2] = HEAP32[i6 + 140 >> 2];
 HEAP32[i5 + 144 >> 2] = i8;
 HEAP32[i5 + 148 >> 2] = i7;
 HEAP32[i5 + 152 >> 2] = i4;
 HEAP32[i5 + 156 >> 2] = HEAP32[i6 + 156 >> 2];
 i4 = HEAP32[i6 + 164 >> 2] | 0;
 i7 = HEAP32[i6 + 168 >> 2] | 0;
 i8 = HEAP32[i6 + 172 >> 2] | 0;
 HEAP32[i5 + 160 >> 2] = HEAP32[i6 + 160 >> 2];
 HEAP32[i5 + 164 >> 2] = i4;
 HEAP32[i5 + 168 >> 2] = i7;
 HEAP32[i5 + 172 >> 2] = i8;
 i8 = i5 + 176 | 0;
 i7 = i6 + 176 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = i5 + 192 | 0;
 i7 = i6 + 192 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = i5 + 208 | 0;
 i7 = i6 + 208 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = i5 + 224 | 0;
 i7 = i6 + 224 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 240 >> 2] = HEAP32[i6 + 240 >> 2];
 HEAP32[i5 + 244 >> 2] = HEAP32[i6 + 244 >> 2];
 HEAP8[i5 + 249 >> 0] = HEAP8[i6 + 249 >> 0] | 0;
 HEAP8[i5 + 248 >> 0] = HEAP8[i6 + 248 >> 0] | 0;
 HEAP32[i5 + 252 >> 2] = HEAP32[i6 + 252 >> 2];
 HEAP32[i5 + 256 >> 2] = HEAP32[i6 + 256 >> 2];
 i8 = i6 + 260 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i5 + 260 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 i4 = i6 + 268 | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5 + 268 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i5 + 276 >> 2] = HEAP32[i6 + 276 >> 2];
 HEAP32[i5 + 280 >> 2] = HEAP32[i6 + 280 >> 2];
 HEAP32[i5 + 284 >> 2] = HEAP32[i6 + 284 >> 2];
 HEAP32[i5 + 288 >> 2] = HEAP32[i6 + 288 >> 2];
 i8 = HEAP16[i6 + 292 >> 1] | 0;
 HEAP8[i5 + 292 >> 0] = i8;
 HEAP8[i5 + 293 >> 0] = (i8 & 65535) >>> 8;
 return i5 | 0;
}

function __Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_(i16, i3, i15) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19;
 i2 = HEAP32[i16 >> 2] | 0;
 i18 = i16 + 4 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i14 = i1 + -12 | 0;
  HEAP32[i18 >> 2] = i14;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i1 = HEAP32[i18 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i14 = i15 + 11 | 0;
 i1 = HEAP8[i14 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 } else {
  i4 = i1 & 255;
  i2 = i15;
 }
 i12 = HEAP8[i3 + 11 >> 0] | 0;
 i13 = i12 << 24 >> 24 < 0;
 i8 = i13 ? HEAP32[i3 >> 2] | 0 : i3;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i12 = i12 & 255;
 i1 = i13 ? i11 : i12;
 if (i4 >>> 0 < i1 >>> 0) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (!i1) i1 = 0; else {
  i10 = i2 + i4 | 0;
  i6 = i8 + i1 | 0;
  i7 = i10;
  i9 = i2;
  L14 : do if ((i4 | 0) < (i1 | 0)) i2 = i7; else {
   i4 = i10 + (1 - i1) | 0;
   if ((i4 | 0) == (i2 | 0)) i2 = i7; else {
    i5 = HEAP8[i8 >> 0] | 0;
    L17 : while (1) {
     while (1) {
      if ((HEAP8[i2 >> 0] | 0) == i5 << 24 >> 24) {
       i1 = i8;
       i3 = i2;
       break;
      }
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i4 | 0)) {
       i2 = i7;
       break L14;
      }
     }
     do {
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i6 | 0)) break L17;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i4 | 0)) {
      i2 = i7;
      break L14;
     }
    }
   }
  } while (0);
  i1 = i2 - i9 | 0;
  if ((i2 | 0) == (i10 | 0) | (i1 | 0) == -1) {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i17, i15, (i13 ? i11 : i12) + i1 | 0, -1, i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i15, i17) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 i1 = HEAP8[i14 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i1 = HEAP32[i15 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (i1 >>> 0 < 3) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (i2) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
 if ((HEAP8[i1 >> 0] | 0) != 61) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (i2) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
 if ((HEAP8[i1 + 1 >> 0] | 0) != 34) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i17, i15, 2, -1, i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i15, i17) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i4 = i15 + 4 | 0;
 i5 = i16 + 8 | 0;
 i3 = 0;
 while (1) {
  i1 = HEAP8[i14 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i1 = HEAP32[i4 >> 2] | 0; else i1 = i1 & 255;
  if (i3 >>> 0 >= i1 >>> 0) break;
  if (i2) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
  if ((HEAP8[i1 + i3 >> 0] | 0) == 34) break;
  if (i2) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
  if ((HEAP8[i1 + i3 >> 0] | 0) == 44) {
   i1 = HEAP32[i18 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i16, i17); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i17);
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i17, gb + 1576256 | 0) | 0;
  } else {
   if (i2) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i17, HEAP8[i1 + i3 >> 0] | 0);
  }
  i3 = i3 + 1 | 0;
 }
 i15 = HEAP8[i17 + 11 >> 0] | 0;
 do if ((i15 << 24 >> 24 < 0 ? HEAP32[i17 + 4 >> 2] | 0 : i15 & 255) | 0) {
  i1 = HEAP32[i18 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
   __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i16, i17);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i17);
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 12;
   break;
  }
 } while (0);
 i18 = ((HEAP32[i18 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) / 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN9Scripting42GetScriptingWrapperOfComponentOfGameObjectER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i25, i19) {
 i25 = i25 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i27 + 32 | 0;
 i22 = i27 + 16 | 0;
 i23 = i27;
 i24 = i19 + 11 | 0;
 i1 = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE((HEAP8[i24 >> 0] | 0) < 0 ? HEAP32[i19 >> 2] | 0 : i19, 0) | 0;
 if (i1 | 0) if (((HEAP32[i1 + 24 >> 2] | 0) - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
  i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i25, i1) | 0;
  if (!i3) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  i1 = HEAP32[i3 + 20 >> 2] | 0;
  if (i1 | 0) {
   i26 = i1;
   STACKTOP = i27;
   return i26 | 0;
  }
  i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
  if ((i1 | 0) == (gb + 27592 | 0)) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  while (1) {
   i2 = __Z21GetManagerFromContexti(5) | 0;
   i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) == (gb + 28304 | 0)) {
    i4 = 0;
    i26 = 30;
    break;
   }
  }
  if ((i26 | 0) == 30) {
   STACKTOP = i27;
   return i4 | 0;
  }
  i26 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i1 = __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE((__Z21GetManagerFromContexti(5) | 0) + 28 | 0, i19) | 0;
 if (!i1) {
  i18 = HEAP8[i24 >> 0] | 0;
  i10 = i19 + 4 | 0;
  if (!((i18 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i18 & 255) | 0)) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  i11 = HEAP32[i25 + 40 >> 2] | 0;
  if ((i11 | 0) <= 0) {
   i26 = 0;
   STACKTOP = i27;
   return i26 | 0;
  }
  i12 = i25 + 28 | 0;
  i13 = i23 + 11 | 0;
  i14 = i23 + 4 | 0;
  i15 = i22 + 11 | 0;
  i16 = i22 + 4 | 0;
  i17 = i23 + 12 | 0;
  i18 = i21 + 4 | 0;
  i4 = 0;
  i9 = 0;
  do {
   i1 = HEAP32[i12 >> 2] | 0;
   if (((HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i1 + (i9 << 3) >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
    i5 = HEAP32[i1 + (i9 << 3) + 4 >> 2] | 0;
    __ZN13MonoBehaviour22GetScriptFullClassNameEv(i23, i5);
    i6 = HEAP8[i13 >> 0] | 0;
    i7 = i6 << 24 >> 24 < 0;
    i2 = i7 ? HEAP32[i23 >> 2] | 0 : i23;
    i6 = i7 ? HEAP32[i14 >> 2] | 0 : i6 & 255;
    HEAP32[i22 >> 2] = 0;
    HEAP32[i22 + 4 >> 2] = 0;
    HEAP32[i22 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i22, i2, i6);
    i6 = HEAP8[i24 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    i6 = i2 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
    i7 = HEAP8[i15 >> 0] | 0;
    i3 = i7 << 24 >> 24 < 0;
    i7 = i3 ? HEAP32[i16 >> 2] | 0 : i7 & 255;
    i8 = i7 >>> 0 < i6 >>> 0;
    i1 = i8 ? i7 : i6;
    if (!i1) i26 = 17; else {
     i1 = _memcmp(i2 ? HEAP32[i19 >> 2] | 0 : i19, i3 ? HEAP32[i22 >> 2] | 0 : i22, i1) | 0;
     if (!i1) i26 = 17; else i20 = i1;
    }
    if ((i26 | 0) == 17) {
     i26 = 0;
     i20 = i6 >>> 0 < i7 >>> 0 ? -1 : i8 & 1;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i22);
    if ((HEAP8[i13 >> 0] | 0) < 0) {
     i8 = HEAP32[i23 >> 2] | 0;
     i7 = HEAP32[i17 >> 2] | 0;
     HEAP32[i21 >> 2] = 66;
     HEAP32[i18 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i21);
    }
    if (!i20) i4 = __ZNK13MonoBehaviour8GetClassEv(i5) | 0;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i11 | 0));
 } else i4 = __ZN10MonoScript8GetClassEv(i1) | 0;
 if (!i4) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i5 = HEAP32[i25 + 40 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i3 = i25 + 28 | 0;
 i2 = 0;
 while (1) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (((HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i1 + (i2 << 3) >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
   i1 = HEAP32[(HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0) + 20 >> 2] | 0;
   if (i1 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i4) | 0) {
    i4 = i1;
    i26 = 30;
    break;
   }
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i5 | 0)) {
   i4 = 0;
   i26 = 30;
   break;
  }
 }
 if ((i26 | 0) == 30) {
  STACKTOP = i27;
  return i4 | 0;
 }
 return 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEbT0_SA_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 2:
  {
   i1 = i7 + -4 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   i4 = i8 + 4 | 0;
   i1 = i7 + -4 | 0;
   i7 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (!i7) {
    if (!i2) {
     i9 = 1;
     return i9 | 0;
    }
    i7 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i7;
    if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
     i9 = 1;
     return i9 | 0;
    }
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i9;
    i9 = 1;
    return i9 | 0;
   }
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i3;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   i2 = i8 + 4 | 0;
   i3 = i8 + 8 | 0;
   i4 = i8 + 12 | 0;
   i1 = i7 + -4 | 0;
   __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i8, i2, i3, i4, i9) | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i7;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i4 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i3 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i4 = i8 + 8 | 0;
   i1 = i8 + 4 | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   do if (i6) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (i2) {
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     break;
    }
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0) {
     i6 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i6;
    }
   } else if (i2) {
    i5 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i5;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, HEAP32[i8 >> 2] | 0) | 0) {
     i6 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i1 >> 2] = i6;
    }
   } while (0);
   i1 = i8 + 12 | 0;
   L13 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    i2 = i4;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
      i4 = HEAP32[i6 >> 2] | 0;
      i5 = i4;
      i3 = i6;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
       if ((i2 | 0) == (i8 | 0)) break;
       i3 = i2 + -4 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
        i10 = i2;
        i2 = i3;
        i3 = i10;
       } else break;
      }
      HEAP32[i2 >> 2] = i4;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i7 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i6;
      i6 = i2;
      i2 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 2368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 2360 | 0;
 i8 = i14 + 2348 | 0;
 i5 = i14 + 1576 | 0;
 i12 = i14 + 788 | 0;
 i13 = i14;
 i1 = __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE4findIS2_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i9, i10) | 0;
 if ((i1 | 0) != (i9 + 4 | 0)) {
  i13 = i1;
  i13 = i13 + 32 | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = 0;
 do {
  HEAP32[i5 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i5 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[i5 + 768 >> 2] = 0;
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i7 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i13 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i13;
   i6 = i2;
  } else {
   i1 = i13;
   i7 = 9;
  }
 } else i7 = 7;
 if ((i7 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i4;
  i2 = i13 + 11 | 0;
  i7 = 9;
 }
 if ((i7 | 0) == 9) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i6 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 i4 = i13 + 16 | 0;
 _memcpy(i4 | 0, i5 | 0, 772) | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i7 = 13;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i7 = 15;
  }
 } else i7 = 13;
 if ((i7 | 0) == 13) {
  i5 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i7 = 15;
 }
 if ((i7 | 0) == 15) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 _memcpy(i12 + 16 | 0, i4 | 0, 772) | 0;
 i3 = __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESN_RKT_(i9, i11, i12) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIS4_S8_EE(i8, i9, i12);
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i1);
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 if ((HEAP8[i12 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i11);
 }
 i13 = __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE4findIS2_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i9, i10) | 0;
 i13 = i13 + 32 | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = (i3 | 0) == 0 ? 0 : i3 + i5 | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i4 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = (i4 | 0) == 0 ? 0 : i4 + i1 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i4;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = i4;
 HEAP32[i1 + 32 >> 2] = i2;
 i2 = HEAP32[i3 + 40 >> 2] | 0;
 i4 = HEAP32[i3 + 44 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i4;
 if (i6 >>> 0 > 1) i2 = 1; else return;
 do {
  i4 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
  f22 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 36 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 40 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 44 >> 2]);
  f27 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) >> 2]);
  f25 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 4 >> 2]);
  f23 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 8 >> 2]);
  f18 = Math_fround(f22 * f27);
  f16 = Math_fround(f22 * f25);
  f22 = Math_fround(f22 * f23);
  f12 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 24 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 28 >> 2]);
  f19 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 32 >> 2]);
  f9 = Math_fround(f20 * f12);
  f8 = Math_fround(f20 * f11);
  f20 = Math_fround(f20 * f19);
  f26 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 12 >> 2]);
  f24 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 16 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 20 >> 2]);
  f9 = Math_fround(f18 + Math_fround(f9 + Math_fround(f7 * f26)));
  f8 = Math_fround(f16 + Math_fround(f8 + Math_fround(f7 * f24)));
  f7 = Math_fround(f22 + Math_fround(f20 + Math_fround(f7 * f21)));
  f20 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 36 >> 2]);
  f22 = Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 40 >> 2]);
  f9 = Math_fround(f20 + f9);
  f8 = Math_fround(f22 + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + (i4 * 48 | 0) + 44 >> 2]) + f7);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 8 >> 2]);
  f18 = Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f26 * f20) + Math_fround(f12 * f16)));
  f17 = Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f24 * f20) + Math_fround(f11 * f16)));
  f16 = Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f16)));
  f20 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 12 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 20 >> 2]);
  f15 = Math_fround(Math_fround(f27 * f20) + Math_fround(Math_fround(f26 * f22) + Math_fround(f12 * f13)));
  f14 = Math_fround(Math_fround(f25 * f20) + Math_fround(Math_fround(f24 * f22) + Math_fround(f11 * f13)));
  f13 = Math_fround(Math_fround(f23 * f20) + Math_fround(Math_fround(f21 * f22) + Math_fround(f19 * f13)));
  f22 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 24 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 28 >> 2]);
  f10 = Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 32 >> 2]);
  f12 = Math_fround(Math_fround(f27 * f22) + Math_fround(Math_fround(f26 * f20) + Math_fround(f12 * f10)));
  f11 = Math_fround(Math_fround(f25 * f22) + Math_fround(Math_fround(f24 * f20) + Math_fround(f11 * f10)));
  f10 = Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f10)));
  HEAPF32[i1 + (i2 * 48 | 0) >> 2] = f18;
  HEAPF32[i1 + (i2 * 48 | 0) + 4 >> 2] = f17;
  HEAPF32[i1 + (i2 * 48 | 0) + 8 >> 2] = f16;
  HEAPF32[i1 + (i2 * 48 | 0) + 12 >> 2] = f15;
  HEAPF32[i1 + (i2 * 48 | 0) + 16 >> 2] = f14;
  HEAPF32[i1 + (i2 * 48 | 0) + 20 >> 2] = f13;
  HEAPF32[i1 + (i2 * 48 | 0) + 24 >> 2] = f12;
  HEAPF32[i1 + (i2 * 48 | 0) + 28 >> 2] = f11;
  HEAPF32[i1 + (i2 * 48 | 0) + 32 >> 2] = f10;
  HEAPF32[i1 + (i2 * 48 | 0) + 36 >> 2] = f9;
  HEAPF32[i1 + (i2 * 48 | 0) + 40 >> 2] = f8;
  HEAPF32[i1 + (i2 * 48 | 0) + 44 >> 2] = f7;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 24 | 0;
 i15 = i19 + 12 | 0;
 i16 = i19;
 i2 = HEAP32[i13 >> 2] | 0;
 i17 = i13 + 4 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i12 = i1 + -12 | 0;
  HEAP32[i17 >> 2] = i12;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i1 = HEAP32[i17 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[gb + 1467888 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i14 + 4 | 0;
  while (1) {
   i1 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i3 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
  i1 = HEAP32[gb + 1467888 >> 2] | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i7 = i14 + 4 | 0;
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 i10 = i15 + 11 | 0;
 i11 = i15 + 4 | 0;
 i12 = i13 + 8 | 0;
 i6 = 0;
 do {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i14 >> 2] = i9;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = i2 + (i6 << 4) | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + (i6 << 4) + 4 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i4, i1);
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  i5 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i15, i14, 0, i16) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  if (i5) {
   i1 = HEAP32[i14 >> 2] | 0;
   if ((i1 | 0) != (i9 | 0)) {
    i2 = i1;
    while (1) {
     i5 = i2 + 16 | 0;
     __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i15, i5);
     i3 = HEAP8[i10 >> 0] | 0;
     i4 = i3 << 24 >> 24 < 0;
     i1 = HEAP32[i15 >> 2] | 0;
     if ((i4 ? HEAP32[i11 >> 2] | 0 : i3 & 255) | 0) {
      i3 = i4 ? i1 : i15;
      do {
       i20 = HEAP8[i3 >> 0] | 0;
       i4 = i20 << 24 >> 24;
       HEAP8[i3 >> 0] = (i20 + -65 & 255) < 26 ? i4 + 32 | 0 : i4;
       i3 = i3 + 1 | 0;
       i4 = HEAP8[i10 >> 0] | 0;
       i20 = i4 << 24 >> 24 < 0;
       i1 = HEAP32[i15 >> 2] | 0;
      } while ((i3 | 0) != ((i20 ? i1 : i15) + (i20 ? HEAP32[i11 >> 2] | 0 : i4 & 255) | 0));
      i3 = i4;
     }
     if (!(__Z6StrCmpPKcS0_(i3 << 24 >> 24 < 0 ? i1 : i15, gb + 945647 | 0) | 0)) i18 = 24; else if (!(__Z6StrCmpPKcS0_((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, gb + 945651 | 0) | 0)) i18 = 24; else if (!(__Z6StrCmpPKcS0_((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, gb + 945655 | 0) | 0)) i18 = 24; else if (!(__Z6StrCmpPKcS0_((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, gb + 945659 | 0) | 0)) i18 = 24;
     do if ((i18 | 0) == 24) {
      i18 = 0;
      i1 = HEAP32[i17 >> 2] | 0;
      if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
       __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i13, i5);
       break;
      } else {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5);
       HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 12;
       break;
      }
     } while (0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
    }
   }
  }
  __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i14, HEAP32[i9 >> 2] | 0);
  i6 = i6 + 1 | 0;
  i1 = HEAP32[gb + 1467888 >> 2] | 0;
 } while (i6 >>> 0 < (HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 4 >>> 0);
 STACKTOP = i19;
 return;
}

function __ZN14CompressedMesh8TransferI14SafeBinaryReadEEvRT_(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 843803 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i3, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 425891 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 425913 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 425902 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426158 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426168 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426182 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426197 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 200 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426211 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 220 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426225 | 0, gb + 899432 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i3 + 240 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426237 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 66; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 66; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 66) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_(i8, i9, i6, i5, i4, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_(i8, i9, i6, i5, i1) | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i7;
   STACKTOP = i11;
   return i10 | 0;
  }
 } else if ((HEAP32[i4 + 4 >> 2] | 0) >= (HEAP32[i5 + 4 >> 2] | 0)) {
  i10 = i7;
  STACKTOP = i11;
  return i10 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i1 = i7 + 1 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
 } else if ((HEAP32[i5 + 4 >> 2] | 0) >= (HEAP32[i6 + 4 >> 2] | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i1 = i7 + 2 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
 } else if ((HEAP32[i6 + 4 >> 2] | 0) >= (HEAP32[i9 + 4 >> 2] | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i1 = i7 + 3 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 if (f2 != f3) {
  if (!(f2 < f3)) {
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
 } else if ((HEAP32[i9 + 4 >> 2] | 0) >= (HEAP32[i8 + 4 >> 2] | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 };
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i10 = i7 + 4 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN12TreeDatabase13ValidateTreesEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 24 | 0;
 i13 = i19 + 8 | 0;
 i9 = i19;
 i15 = i19 + 28 | 0;
 i10 = (HEAP32[i12 + 8 >> 2] | 0) - (HEAP32[i12 + 4 >> 2] | 0) >> 3;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i14 = i9;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 HEAP32[i15 >> 2] = 0;
 i14 = i15 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i15 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i9);
 i9 = i13;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i17;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i12 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 20 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i4 | 0)) {
  i3 = 0;
  while (1) {
   f20 = Math_fround(HEAPF32[i2 >> 2]);
   i7 = f20 < Math_fround(0.0);
   i6 = f20 > Math_fround(1.0);
   f20 = i6 ? Math_fround(1.0) : f20;
   HEAPF32[i2 >> 2] = i7 ? Math_fround(0.0) : f20;
   i7 = i2 + 4 | 0;
   f20 = Math_fround(HEAPF32[i7 >> 2]);
   i6 = f20 < Math_fround(0.0);
   i5 = f20 > Math_fround(1.0);
   f20 = i5 ? Math_fround(1.0) : f20;
   HEAPF32[i7 >> 2] = i6 ? Math_fround(0.0) : f20;
   i7 = i2 + 8 | 0;
   f20 = Math_fround(HEAPF32[i7 >> 2]);
   i6 = f20 < Math_fround(0.0);
   i5 = f20 > Math_fround(1.0);
   f20 = i5 ? Math_fround(1.0) : f20;
   HEAPF32[i7 >> 2] = i6 ? Math_fround(0.0) : f20;
   i7 = HEAP32[i2 + 32 >> 2] | 0;
   if ((i7 | 0) > -1 & (i7 | 0) < (i10 | 0)) i2 = i2 + 40 | 0; else {
    i7 = HEAP32[i8 >> 2] | 0;
    i6 = (i1 - i7 | 0) / 40 | 0;
    i2 = i7 + (i6 * 40 | 0) | 0;
    i1 = i2 + 40 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i2;
     i11 = 8;
    } else {
     i5 = i2;
     do {
      HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i5 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
      HEAP32[i5 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
      i23 = i1 + 32 | 0;
      i22 = HEAP32[i23 + 4 >> 2] | 0;
      i21 = i5 + 32 | 0;
      HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
      HEAP32[i21 + 4 >> 2] = i22;
      i1 = i1 + 40 | 0;
      i5 = i5 + 40 | 0;
     } while ((i1 | 0) != (i4 | 0));
     i4 = HEAP32[i9 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      i1 = i5;
      i11 = 8;
     }
    }
    if ((i11 | 0) == 8) {
     i11 = 0;
     HEAP32[i9 >> 2] = i4 + (~(((i4 + -40 - i1 | 0) >>> 0) / 40 | 0) * 40 | 0);
    }
    i6 = i7 + (i6 * 40 | 0) + 32 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if (i1 >>> 0 >= i5 >>> 0) {
     i4 = i1 + 1 | 0;
     HEAP32[i14 >> 2] = i4;
     i1 = HEAP32[i16 >> 2] | 0;
     do if ((i1 & 2147483647) >>> 0 < i4 >>> 0) if ((i1 | 0) > -1) {
      HEAP32[i16 >> 2] = i4;
      i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4, 1, i17, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i15 >> 2] = i3;
      break;
     } else {
      i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i3 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
      HEAP32[i16 >> 2] = i4;
      HEAP32[i15 >> 2] = i3;
      break;
     } while (0);
     if (i4 >>> 0 > i5 >>> 0) {
      i1 = i4 - i5 | 0;
      if (i1) {
       _memset(i3 + i5 | 0, 0, i1 | 0) | 0;
       i3 = HEAP32[i15 >> 2] | 0;
      }
     }
    }
    HEAP8[i3 + (HEAP32[i6 >> 2] | 0) >> 0] = 1;
    i4 = HEAP32[i9 >> 2] | 0;
   }
   if ((i2 | 0) == (i4 | 0)) break; else i1 = i2;
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if (i1 | 0) {
   i5 = i13 + 11 | 0;
   i4 = 0;
   while (1) {
    if (!(HEAP8[i3 + i4 >> 0] | 0)) i2 = i1; else {
     HEAP32[i18 >> 2] = i4;
     __Z6FormatPKcz(i13, gb + 933068 | 0, i18);
     i1 = HEAP32[i12 >> 2] | 0;
     if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 933103 | 0, 333, 1, i1, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
     i2 = HEAP32[i14 >> 2] | 0;
    }
    i1 = i4 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
    i4 = i1;
    i3 = HEAP32[i15 >> 2] | 0;
    i1 = i2;
   }
  }
 } while (0);
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i17);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 120 | 0, i8);
 i2 = i6 + 136 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 152 | 0, i8 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 168 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 184 | 0, i8 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 200 | 0, i8 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 216 | 0, i8 + 6 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 256 | 0, i8 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 272 | 0, i8 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 288 | 0, i8 + 11 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 304 | 0, i8 + 12 | 0);
 i2 = i6 + 332 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 15 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN20GlobalCachingManager16ReadCacheIndicesERNSt3__26vectorIP5CacheNS0_9allocatorIS3_EEEEb(i1, i13, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 36 | 0;
 i8 = i12 + 24 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12;
 i1 = HEAP32[i13 >> 2] | 0;
 i11 = i13 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1576256 | 0, 0);
 __Z20GetPlatformCachePathv(i7);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i7); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i7, i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!(__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i12;
  return;
 }
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i3 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i6 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i9, i7, 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if (i6) {
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i4 = i8 + 11 | 0;
   i5 = i8 + 4 | 0;
   i6 = i13 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i2 + 16 | 0;
    if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0) {
     __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8, i1);
     i15 = HEAP8[i4 >> 0] | 0;
     if (((i15 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i15 & 255) | 0) == 4) {
      if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, gb + 444379 | 0, 4) | 0) i14 = 13;
     } else i14 = 13;
     if ((i14 | 0) == 13) {
      i14 = 0;
      i15 = __Znwj(80) | 0;
      i16 = i15 + 4 | 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i16 + 4 >> 2] = 0;
      HEAP32[i16 + 8 >> 2] = 0;
      i16 = i15 + 60 | 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i15 + 64 >> 2] = 0;
      HEAP32[i15 + 56 >> 2] = i16;
      i16 = i15 + 72 | 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i15 + 76 >> 2] = 0;
      HEAP32[i15 + 68 >> 2] = i16;
      i16 = i15 + 24 | 0;
      HEAP32[i16 >> 2] = 0;
      HEAP32[i16 + 4 >> 2] = 0;
      HEAP32[i15 + 16 >> 2] = 2147483647;
      HEAP8[i15 + 52 >> 0] = 0;
      HEAP8[i15 >> 0] = 1;
      HEAP32[i15 + 48 >> 2] = 1296e4;
      HEAP32[i10 >> 2] = i15;
      __ZN5Cache14ReadCacheIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i15, i8, 0) | 0;
      i15 = HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0;
      do if ((i15 | 0) < (_time(0) | 0)) {
       __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        __ZN5CacheD2Ev(i1);
        __ZdlPv(i1);
       }
      } else {
       i1 = HEAP32[i11 >> 2] | 0;
       if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
        __ZNSt3__26vectorIP5CacheNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i13, i10);
        break;
       } else {
        HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
        HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
        break;
       }
      } while (0);
     }
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
  }
 }
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i7, HEAP32[i3 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i12;
 return;
}

function _UNITY_png_icc_check_header(i7, i8, i9, i2, i5, i4) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i1 = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
 if ((i1 | 0) != (i2 | 0)) {
  _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351247 | 0);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = (HEAPU8[i5 + 129 >> 0] | 0) << 16 | (HEAPU8[i5 + 128 >> 0] | 0) << 24 | (HEAPU8[i5 + 130 >> 0] | 0) << 8 | (HEAPU8[i5 + 131 >> 0] | 0);
 if (i1 >>> 0 <= 357913930) if (((i1 * 12 | 0) + 132 | 0) >>> 0 <= i2 >>> 0) {
  i1 = (HEAPU8[i5 + 65 >> 0] | 0) << 16 | (HEAPU8[i5 + 64 >> 0] | 0) << 24 | (HEAPU8[i5 + 66 >> 0] | 0) << 8 | (HEAPU8[i5 + 67 >> 0] | 0);
  if (i1 >>> 0 > 65534) {
   _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351297 | 0);
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
  if (i1 >>> 0 > 3) _UNITY_png_icc_profile_error(i7, 0, i9, i1, gb + 351322 | 0);
  i1 = (HEAPU8[i5 + 37 >> 0] | 0) << 16 | (HEAPU8[i5 + 36 >> 0] | 0) << 24 | (HEAPU8[i5 + 38 >> 0] | 0) << 8 | (HEAPU8[i5 + 39 >> 0] | 0);
  if ((i1 | 0) != 1633907568) {
   _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351351 | 0);
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
  if (_memcmp(i5 + 68 | 0, gb + 351369 | 0, 12) | 0) {
   i2 = _UNITY_png_safecat(i3, 196, 0, gb + 351218 | 0) | 0;
   _UNITY_png_safecat(i3, 196, _UNITY_png_safecat(i3, 196, _UNITY_png_safecat(i3, i2 + 79 | 0, i2, i9) | 0, gb + 351228 | 0) | 0, gb + 351381 | 0) | 0;
   _UNITY_png_chunk_report(i7, i3, 1);
  }
  i1 = (HEAPU8[i5 + 17 >> 0] | 0) << 16 | (HEAPU8[i5 + 16 >> 0] | 0) << 24 | (HEAPU8[i5 + 18 >> 0] | 0) << 8 | (HEAPU8[i5 + 19 >> 0] | 0);
  L22 : do if ((i1 | 0) < 1380401696) {
   switch (i1 | 0) {
   case 1196573017:
    break;
   default:
    {
     i6 = 19;
     break L22;
    }
   }
   if (i4 & 2 | 0) {
    _UNITY_png_icc_profile_error(i7, i8, i9, 1196573017, gb + 351454 | 0);
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  } else {
   switch (i1 | 0) {
   case 1380401696:
    break;
   default:
    {
     i6 = 19;
     break L22;
    }
   }
   if (!(i4 & 2)) {
    _UNITY_png_icc_profile_error(i7, i8, i9, 1380401696, gb + 351407 | 0);
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  } while (0);
  if ((i6 | 0) == 19) {
   _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351496 | 0);
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
  i1 = (HEAPU8[i5 + 13 >> 0] | 0) << 16 | (HEAPU8[i5 + 12 >> 0] | 0) << 24 | (HEAPU8[i5 + 14 >> 0] | 0) << 8 | (HEAPU8[i5 + 15 >> 0] | 0);
  L35 : do if ((i1 | 0) < 1852662636) {
   if ((i1 | 0) < 1818848875) {
    switch (i1 | 0) {
    case 1633842036:
     break;
    default:
     {
      i6 = 24;
      break L35;
     }
    }
    _UNITY_png_icc_profile_error(i7, i8, i9, 1633842036, gb + 351528 | 0);
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
   if ((i1 | 0) >= 1835955314) switch (i1 | 0) {
   case 1835955314:
    break L35;
   default:
    {
     i6 = 24;
     break L35;
    }
   }
   switch (i1 | 0) {
   case 1818848875:
    break;
   default:
    {
     i6 = 24;
     break L35;
    }
   }
   _UNITY_png_icc_profile_error(i7, i8, i9, 1818848875, gb + 351566 | 0);
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  } else {
   if ((i1 | 0) >= 1935896178) if ((i1 | 0) < 1936744803) switch (i1 | 0) {
   case 1935896178:
    break L35;
   default:
    {
     i6 = 24;
     break L35;
    }
   } else switch (i1 | 0) {
   case 1936744803:
    break L35;
   default:
    {
     i6 = 24;
     break L35;
    }
   }
   if ((i1 | 0) >= 1886549106) switch (i1 | 0) {
   case 1886549106:
    break L35;
   default:
    {
     i6 = 24;
     break L35;
    }
   }
   switch (i1 | 0) {
   case 1852662636:
    break;
   default:
    {
     i6 = 24;
     break L35;
    }
   }
   _UNITY_png_icc_profile_error(i7, 0, i9, 1852662636, gb + 351606 | 0);
  } while (0);
  if ((i6 | 0) == 24) _UNITY_png_icc_profile_error(i7, 0, i9, i1, gb + 351646 | 0);
  i1 = (HEAPU8[i5 + 21 >> 0] | 0) << 16 | (HEAPU8[i5 + 20 >> 0] | 0) << 24 | (HEAPU8[i5 + 22 >> 0] | 0) << 8 | (HEAPU8[i5 + 23 >> 0] | 0);
  L61 : do if ((i1 | 0) < 1482250784) {
   switch (i1 | 0) {
   case 1281450528:
    {
     i1 = 1;
     break;
    }
   default:
    break L61;
   }
   STACKTOP = i10;
   return i1 | 0;
  } else {
   switch (i1 | 0) {
   case 1482250784:
    {
     i1 = 1;
     break;
    }
   default:
    break L61;
   }
   STACKTOP = i10;
   return i1 | 0;
  } while (0);
  _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351677 | 0);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 _UNITY_png_icc_profile_error(i7, i8, i9, i1, gb + 351277 | 0);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 112 | 0;
 i10 = i8 + 96 | 0;
 i1 = i8 + 80 | 0;
 i13 = i8 + 32 | 0;
 i12 = i8 + 16 | 0;
 i2 = i8;
 i26 = HEAP32[i6 + 16 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i26 >> 2]));
 i25 = i26 + 4 | 0;
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 i24 = i26 + 8 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i23 = i26 + 12 | 0;
 f16 = Math_fround(f17 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i26 + 16 | 0;
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i22 >> 2]));
 i21 = i26 + 20 | 0;
 f16 = Math_fround(f14 + f16);
 f18 = Math_fround(f15 + f18);
 f17 = Math_fround(f9 + Math_fround(f17 * Math_fround(HEAPF32[i21 >> 2])));
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i20 = i26 + 24 | 0;
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i26 + 28 | 0;
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 i3 = i26 + 32 | 0;
 f14 = Math_fround(f18 + f14);
 f9 = Math_fround(f17 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i11 >> 2] = Math_fround(f16 + f15);
 HEAPF32[i11 + 4 >> 2] = f14;
 HEAPF32[i11 + 8 >> 2] = f9;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i26 >> 2]));
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f17 = Math_fround(f16 * Math_fround(HEAPF32[i23 >> 2]));
 f18 = Math_fround(f16 * Math_fround(HEAPF32[i22 >> 2]));
 f17 = Math_fround(f14 + f17);
 f18 = Math_fround(f15 + f18);
 f16 = Math_fround(f9 + Math_fround(f16 * Math_fround(HEAPF32[i21 >> 2])));
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(f18 + f14);
 f9 = Math_fround(f16 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f17 + f15);
 HEAPF32[i10 + 4 >> 2] = f14;
 HEAPF32[i10 + 8 >> 2] = f9;
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i26 >> 2]));
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(f17 * Math_fround(HEAPF32[i23 >> 2]));
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i22 >> 2]));
 f16 = Math_fround(f14 + f16);
 f18 = Math_fround(f15 + f18);
 f17 = Math_fround(f9 + Math_fround(f17 * Math_fround(HEAPF32[i21 >> 2])));
 f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(f18 + f14);
 f9 = Math_fround(f17 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f16 + f15);
 HEAPF32[i1 + 4 >> 2] = f14;
 HEAPF32[i1 + 8 >> 2] = f9;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i6 + 92 >> 2] | 0;
 i4 = HEAP32[i6 + 96 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 + 88 >> 2];
 HEAP32[i13 + 4 >> 2] = i5;
 HEAP32[i13 + 8 >> 2] = i4;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 i4 = HEAP32[i6 + 104 >> 2] | 0;
 i5 = HEAP32[i6 + 108 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 + 100 >> 2];
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i5;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_(i2, i13, i12, i11, i10, i1, i8 + 64 | 0, i8 + 48 | 0);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f9 <= Math_fround(HEAPF32[i6 + 72 >> 2]))) {
  i26 = 1;
  STACKTOP = i8;
  return i26 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i26 = 0;
  STACKTOP = i8;
  return i26 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i26 = 1;
  STACKTOP = i8;
  return i26 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i26 = 1;
  STACKTOP = i8;
  return i26 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i26 = 1;
  STACKTOP = i8;
  return i26 | 0;
 }
 return 0;
}

function __ZN9GfxDevice8OnCreateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i5 + 3736 | 0;
 i2 = i5 + 3740 | 0;
 i7 = i5 + 3620 | 0;
 i9 = i7 + 116 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i5 + 3748 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 + 3752 >> 2] = 0;
 i7 = i5 + 3760 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i5 + 3888 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 3892 >> 2] = Math_fround(0.0);
 i7 = i5 + 3816 | 0;
 i9 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 i1 = i5 + 4024 | 0;
 i2 = i5 + 4028 | 0;
 i7 = i5 + 3908 | 0;
 i9 = i7 + 116 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i5 + 4036 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 + 4040 >> 2] = 0;
 i7 = i5 + 4048 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i5 + 4176 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4180 >> 2] = Math_fround(0.0);
 i7 = i5 + 4104 | 0;
 i9 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAPF32[i5 + 4372 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4368 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 4376 >> 2] = 0;
 HEAP32[i5 + 4196 >> 2] = -1;
 i2 = i5 + 4200 | 0;
 HEAP8[i5 + 4192 >> 0] = 0;
 HEAP8[i5 + 4193 >> 0] = 0;
 HEAP8[i5 + 4194 >> 0] = 0;
 HEAP8[i5 + 4380 >> 0] = 0;
 HEAP8[i5 + 4381 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i5 + 4384 >> 2] = -1;
 HEAP32[i5 + 4396 >> 2] = 0;
 i2 = i5 + 4248 | 0;
 HEAP32[i5 + 4224 >> 2] = i2;
 HEAP32[i5 + 4228 >> 2] = i2;
 HEAP32[i5 + 4232 >> 2] = i2;
 HEAP32[i5 + 4236 >> 2] = i2;
 HEAP32[i5 + 4240 >> 2] = i2;
 HEAP32[i5 + 4244 >> 2] = i2;
 HEAP32[i5 + 4512 >> 2] = 0;
 i2 = i5 + 4216 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(220, gb + 63304 | 0, 16, gb + 392043 | 0, 325) | 0;
 HEAP32[i2 >> 2] = i5;
 i1 = i2 + 4 | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = -1;
 i1 = i2 + 60 | 0;
 i7 = i2 + 32 | 0;
 i9 = i7 + 92 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 72 >> 2] = Math_fround(1.0);
 i7 = i2 + 124 | 0;
 i9 = i7 + 88 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAPF32[i2 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 160 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 212 >> 2] = 0;
 HEAP32[i2 + 216 >> 2] = 0;
 HEAP32[i3 >> 2] = 127;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP8[i6 + 3 >> 0] = 3;
 HEAP8[i6 + 5 >> 0] = 12;
 HEAP8[i6 + 6 >> 0] = 0;
 HEAP8[i6 + 7 >> 0] = 3;
 HEAP8[i6 + 9 >> 0] = 24;
 HEAP8[i6 + 10 >> 0] = 0;
 HEAP8[i6 + 11 >> 0] = 4;
 HEAP8[i6 + 13 >> 0] = 40;
 HEAP8[i6 + 14 >> 0] = 0;
 HEAP8[i6 + 15 >> 0] = 3;
 HEAP8[i6 + 17 >> 0] = 52;
 HEAP8[i6 + 18 >> 0] = 0;
 HEAP8[i6 + 19 >> 0] = 3;
 HEAP8[i6 + 21 >> 0] = 64;
 HEAP8[i6 + 22 >> 0] = 0;
 HEAP8[i6 + 23 >> 0] = 3;
 HEAP8[i6 + 25 >> 0] = 76;
 HEAP8[i6 + 26 >> 0] = 0;
 HEAP8[i6 + 27 >> 0] = 3;
 i7 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63304 | 0, 16, gb + 396312 | 0, 152) | 0;
 __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob(i7, 1, i6, 1);
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 + 4408 >> 2] = i2;
 i7 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63304 | 0, 16, gb + 392043 | 0, 328) | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i7 + 4 >> 2] = i7;
 HEAP32[i5 + 4516 >> 2] = i7;
 i7 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63304 | 0, 16, gb + 392043 | 0, 328) | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i7 + 4 >> 2] = i7;
 HEAP32[i5 + 4520 >> 2] = i7;
 i7 = i5 + 4536 | 0;
 i9 = i7 + 80 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 STACKTOP = i8;
 return;
}

function __ZN5Unity12PhysicsQuery21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction(i17, i3, i9, f4, i10, i11) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 2192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 2144 | 0;
 i12 = i20 + 2120 | 0;
 i13 = i20 + 72 | 0;
 i14 = i20 + 24 | 0;
 i5 = i20 + 20 | 0;
 i6 = i20;
 i7 = i20 + 2186 | 0;
 i8 = i20 + 2184 | 0;
 i18 = i17 + 48 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i15 = i17 + 52 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i2 + (~(((i2 + -44 - i1 | 0) >>> 0) / 44 | 0) * 44 | 0);
 if (!i3) {
  STACKTOP = i20;
  return i18 | 0;
 }
 i16 = f4 == Math_fround(inf);
 f4 = i16 ? Math_fround(3402823469999999843913219.0e14) : f4;
 HEAP32[i12 >> 2] = gb + 114012 + 8;
 HEAP32[i12 + 4 >> 2] = 1;
 HEAP32[i12 + 8 >> 2] = i3;
 HEAP32[i12 + 12 >> 2] = i10;
 switch (i11 | 0) {
 case 0:
  {
   HEAP8[i12 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i12 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i12 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = -1;
 HEAP16[i14 + 12 >> 1] = 0;
 i2 = i14 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i2 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP16[i6 + 16 >> 1] = 15;
 HEAP8[i6 + 18 >> 0] = 0;
 i16 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP16[i8 >> 1] = i2 ? 143 : 15;
 i16 = __ZN5physx14PxRigidBodyExt19linearSweepMultipleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEPNS_10PxSweepHitEPjjRSC_RiRbRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf(i3, i16, i9, f4, i8, HEAP32[i17 >> 2] | 0, i13, 128, i14, i5, i7, i6, i12, 0, Math_fround(0.0)) | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = (i3 - i2 | 0) / 44 | 0;
 if (i16 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE8__appendEj(i18, i16 - i1 | 0); else if (i16 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i16 * 44 | 0) | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i3 + (~(((i3 + -44 - i1 | 0) >>> 0) / 44 | 0) * 44 | 0);
 }
 if (i16 | 0) {
  i3 = i19 + 4 | 0;
  i5 = i19 + 8 | 0;
  i6 = i19 + 12 | 0;
  i7 = i19 + 16 | 0;
  i8 = i19 + 20 | 0;
  i9 = i19 + 24 | 0;
  i10 = i19 + 28 | 0;
  i11 = i19 + 32 | 0;
  i12 = i19 + 36 | 0;
  i1 = 0;
  do {
   i13 = HEAP32[i17 >> 2] | 0;
   i14 = HEAP32[i18 >> 2] | 0;
   i15 = i14 + (i1 * 44 | 0) | 0;
   i2 = i13 + (i1 * 48 | 0) + 4 | 0;
   HEAP32[i14 + (i1 * 44 | 0) + 40 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
   i21 = i13 + (i1 * 48 | 0) + 16 | 0;
   HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
   i21 = i14 + (i1 * 44 | 0) + 12 | 0;
   i22 = i13 + (i1 * 48 | 0) + 28 | 0;
   HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i19 >> 2] = 5;
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAPF32[i5 >> 2] = Math_fround(1.0);
   HEAPF32[i6 >> 2] = Math_fround(1.0);
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAPF32[i9 >> 2] = Math_fround(0.0);
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   i21 = i11;
   HEAP32[i21 >> 2] = 0;
   HEAP32[i21 + 4 >> 2] = 0;
   i2 = HEAP32[i2 >> 2] | 0;
   if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i19 | 0) | 0) {
    i2 = HEAP32[i12 >> 2] | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
    i2 = HEAP32[i2 + (HEAP32[i13 + (i1 * 48 | 0) + 8 >> 2] << 2) >> 2] | 0;
   } else i2 = -1;
   HEAP32[i14 + (i1 * 44 | 0) + 24 >> 2] = i2;
   i22 = HEAP32[i13 + (i1 * 48 | 0) + 40 >> 2] | 0;
   HEAP32[i14 + (i1 * 44 | 0) + 28 >> 2] = i22;
   HEAPF32[i14 + (i1 * 44 | 0) + 32 >> 2] = Math_fround(0.0);
   HEAPF32[i14 + (i1 * 44 | 0) + 36 >> 2] = Math_fround(0.0);
   if ((HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) {
    HEAP32[i15 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
 }
 STACKTOP = i20;
 return i18 | 0;
}

function __ZN13MonoBehaviour19HandleNotificationsEPviR11MessageData(i11, i2, i4) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 296 | 0;
 i9 = i17 + 280 | 0;
 i12 = i17 + 272 | 0;
 i13 = i17 + 248 | 0;
 i14 = i17 + 240 | 0;
 i8 = i17;
 i3 = i17 + 264 | 0;
 i15 = i17 + 292 | 0;
 i1 = HEAP32[i11 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) {
  STACKTOP = i17;
  return;
 }
 i1 = i11 + 20 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i7 = i2 + 27 | 0;
 i5 = HEAP32[i11 + 60 >> 2] | 0;
 i6 = HEAP32[i5 + (i7 << 3) >> 2] | 0;
 i7 = HEAP32[i5 + (i7 << 3) + 4 >> 2] | 0;
 if (!i6) {
  STACKTOP = i17;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 112 >> 2] | 0, i11 | 0) | 0)) {
  __ZN14MessageHandler28MessageIDToMessageIdentifierEi(i16, __ZN14MessageHandler3GetEv() | 0, i2);
  if (HEAP32[i16 + 16 >> 2] & 4 | 0) {
   STACKTOP = i17;
   return;
  }
 }
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i8, i5, i16);
 i5 = i11 + 4 | 0;
 HEAP32[i8 + 216 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 L15 : do if (!i1) i10 = 26; else {
  do if ((i1 | 0) == (gb + 29192 | 0)) __ZN18ScriptingArguments6AddIntEi(i8, HEAP32[i4 + 4 >> 2] | 0); else {
   if ((i1 | 0) == (gb + 29272 | 0)) {
    __ZN18ScriptingArguments8AddFloatEf(i8, Math_fround(HEAPF32[i4 + 4 >> 2]));
    break;
   }
   if ((i1 | 0) == (gb + 29232 | 0)) {
    __ZN18ScriptingArguments10AddBooleanEb(i8, (HEAP32[i4 + 4 >> 2] | 0) != 0);
    break;
   }
   if ((i1 | 0) == (gb + 29512 | 0)) {
    i10 = __Z11GetIPhysicsv() | 0;
    __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i8, mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0, HEAP32[i4 + 4 >> 2] | 0) | 0);
    break;
   }
   if ((i1 | 0) == (gb + 29552 | 0)) {
    i10 = __Z13GetIPhysics2Dv() | 0;
    __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i8, mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0, HEAP32[i4 + 4 >> 2] | 0) | 0);
    break;
   }
   if ((i1 | 0) != (gb + 29592 | 0)) {
    __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i8, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i4 + 4 >> 2] | 0) | 0);
    break;
   }
   i2 = HEAP32[i4 + 8 >> 2] | 0;
   __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i8, i2);
   if (i2 | 0) {
    i1 = i12;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i1 + 4 >> 2] = i7;
    HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    i1 = __Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi(i16, 0) | 0;
    if (i1 | 0) {
     i3 = __Z25scripting_class_from_typePK10Il2CppType(i1) | 0;
     if (i3 | 0) {
      i1 = __Z26scripting_object_get_classP12Il2CppObject(i2) | 0;
      if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i3) | 0)) {
       i15 = i14;
       HEAP32[i15 >> 2] = i6;
       HEAP32[i15 + 4 >> 2] = i7;
       HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       i14 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i16) | 0;
       i15 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
       i16 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
       HEAP32[i9 >> 2] = i14;
       HEAP32[i9 + 4 >> 2] = i15;
       HEAP32[i9 + 8 >> 2] = i16;
       __Z6FormatPKcz(i13, gb + 587125 | 0, i9);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 587199 | 0, 1191, 1, HEAP32[i5 >> 2] | 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
       break L15;
      }
     }
    }
   }
  } while (0);
  i10 = 26;
 } while (0);
 if ((i10 | 0) == 26) {
  HEAP32[i15 >> 2] = 0;
  i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i8, i15, 0) | 0;
  if ((i1 | 0) != 0 & (HEAP32[i15 >> 2] | 0) == 0) {
   i15 = i14;
   HEAP32[i15 >> 2] = i6;
   HEAP32[i15 + 4 >> 2] = i7;
   i15 = (__Z14GetMonoManagerv() | 0) + 44 | 0;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   if (__Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses(i16, i15) | 0) {
    HEAP32[i12 >> 2] = 0;
    i15 = i13;
    HEAP32[i15 >> 2] = i6;
    HEAP32[i15 + 4 >> 2] = i7;
    HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i11, i1, i16, i12) | 0;
   }
  }
 }
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i19, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i19, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i19, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i18, i19, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 32 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i16 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 520 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 12 | 0;
 i2 = i2 + 500 | 0;
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 i1 = 0;
 do {
  i22 = (HEAP32[i9 >> 2] | 0) + (i1 << 2) | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f41 = Math_fround(HEAPF32[i22 + 4 >> 2]);
  f42 = Math_fround(HEAPF32[i22 + 8 >> 2]);
  f41 = Math_fround(f41 * Math_fround(.00999999977));
  f42 = Math_fround(f42 * Math_fround(.00999999977));
  f43 = Math_fround(Math_fround(HEAPF32[i22 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i13 >> 2] = Math_fround(f44 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f41;
  HEAPF32[i11 >> 2] = f42;
  HEAPF32[i12 >> 2] = f43;
  i22 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i32 = (HEAP32[i22 >> 2] | 0) + 1494990940 | 0;
  i28 = (HEAP32[i22 + 4 >> 2] | 0) + 1494990940 | 0;
  i33 = (HEAP32[i22 + 8 >> 2] | 0) + 1494990940 | 0;
  i22 = (HEAP32[i22 + 12 >> 2] | 0) + 1494990940 | 0;
  i37 = (Math_imul(i32, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i28, 1790253981) | 0) + 1900727103 | 0;
  i35 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i27 = (Math_imul(i22, 1790253981) | 0) + 1900727103 | 0;
  i32 = i32 << 11 ^ i32;
  i28 = i28 << 11 ^ i28;
  i33 = i33 << 11 ^ i33;
  i22 = i22 << 11 ^ i22;
  f43 = Math_fround(Math_fround((i30 ^ i28 ^ i28 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f42 = Math_fround(Math_fround((i35 ^ i33 ^ i33 >>> 8) & 8388607 ^ i35 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f41 = Math_fround(Math_fround((i27 ^ i22 ^ i22 >>> 8) & 8388607 ^ i27 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i14 >> 2] = Math_fround(Math_fround((i37 ^ i32 ^ i32 >>> 8) & 8388607 ^ i37 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f43;
  HEAPF32[i4 >> 2] = f42;
  HEAPF32[i5 >> 2] = f41;
  __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i15, i19, i13, i14);
  i37 = HEAP32[i15 >> 2] | 0;
  i32 = HEAP32[i6 >> 2] | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i22 = HEAP32[i8 >> 2] | 0;
  i35 = i18 + (i1 << 2) | 0;
  i33 = HEAP32[i35 >> 2] | 0;
  i30 = i35 + 4 | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i35 + 8 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i35 + 12 | 0;
  i40 = HEAP32[i20 >> 2] | 0;
  i38 = (Math_imul(i33 & 255, i37 & 255) | 0) + 128 | 0;
  i39 = (Math_imul(i33 >>> 8 & 255, i37 >>> 8 & 255) | 0) + 128 | 0;
  i36 = (Math_imul(i33 >>> 16 & 255, i37 >>> 16 & 255) | 0) + 128 | 0;
  i37 = (Math_imul(i33 >>> 24, i37 >>> 24) | 0) + 128 | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i40 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i40 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i40 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i40 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  HEAP32[i35 >> 2] = (i39 >>> 8) + i39 & 261888 | ((i38 >>> 8) + i38 | 0) >>> 8 | ((i37 >>> 8) + i37 | 0) >>> 8 << 24 | ((i36 >>> 8) + i36 | 0) >>> 8 << 16;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i16 >>> 0);
 STACKTOP = i17;
 return;
}

function __Z14resize_trimmedINSt3__26vectorINS0_4pairIifEE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = (HEAP32[i15 >> 2] | 0) - i2 >> 3;
 i1 = i2;
 if (i3 >>> 0 >= i12 >>> 0) {
  if (i3 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i5 = i1 + (i12 << 3) | 0;
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i8 = i13 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i9 = i13 + 12 | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i12 << 3;
  i4 = i3 >> 3;
  if (!i4) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i3 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i2 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i13 >> 2] = i2;
   i6 = i2 + (i4 << 3) | 0;
   i7 = i13 + 8 | 0;
   HEAP32[i7 >> 2] = i6;
   i3 = i2;
   if (!i12) {
    i4 = i7;
    i5 = i3;
    i2 = i3;
    i1 = i6;
   } else {
    do {
     i10 = i1;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i2;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     i1 = i1 + 8 | 0;
     i2 = (HEAP32[i8 >> 2] | 0) + 8 | 0;
     HEAP32[i8 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i7;
    i5 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
   i15 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i2 >> 3 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE8__appendEj(i14, i12 - i3 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 3) << 3) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 3);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 3;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 3) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -8 - i2 | 0) >>> 3) << 3) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx21PxProfileEventHandler16parseEventBufferEPKhjRS0_b(i4, i2, i17, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 80 | 0;
 i16 = i21 + 64 | 0;
 i15 = i21 + 24 | 0;
 i19 = i21 + 96 | 0;
 i18 = i21;
 i14 = i21 + 48 | 0;
 if (i1) {
  HEAP32[i16 >> 2] = i4;
  i11 = i16 + 4 | 0;
  HEAP32[i11 >> 2] = i2;
  i12 = i16 + 8 | 0;
  HEAP8[i12 >> 0] = 0;
  if (!i4) {
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
  }
  HEAP8[i19 >> 0] = 0;
  i5 = i19 + 1 | 0;
  HEAP8[i5 >> 0] = -1;
  i6 = i19 + 2 | 0;
  HEAP16[i6 >> 1] = 0;
  i10 = i18 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  L6 : do if (i2 | 0) {
   i7 = i6 + 1 | 0;
   i8 = i14 + 4 | 0;
   i9 = i14 + 8 | 0;
   i10 = i14 + 12 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   HEAP8[i19 >> 0] = i3;
   i1 = i4 + 1 | 0;
   HEAP32[i16 >> 2] = i1;
   i22 = i2 + -1 | 0;
   HEAP32[i11 >> 2] = i22;
   L8 : do if (!i22) i20 = 16; else while (1) {
    HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i4 + 2 | 0;
    HEAP32[i16 >> 2] = i1;
    i22 = i2 + -2 | 0;
    HEAP32[i11 >> 2] = i22;
    if (i22 >>> 0 < 2) break L8;
    i22 = HEAP8[i1 >> 0] | 0;
    HEAP8[i6 >> 0] = i22;
    i1 = i4 + 3 | 0;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i11 >> 2] = i2 + -3;
    i1 = HEAP8[i1 >> 0] | 0;
    HEAP32[i16 >> 2] = i4 + 4;
    HEAP32[i11 >> 2] = i2 + -4;
    HEAP8[i6 >> 0] = i1;
    HEAP8[i7 >> 0] = i22;
    HEAP32[i14 >> 2] = i18;
    HEAP32[i8 >> 2] = i16;
    HEAP32[i9 >> 2] = i19;
    HEAP32[i10 >> 2] = i17;
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i3 & 255, i15, i13) | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    if (!((i2 | 0) != 0 & (HEAP8[i12 >> 0] | 0) == 0)) break L6;
    i4 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP8[i4 >> 0] | 0;
    HEAP8[i19 >> 0] = i3;
    i1 = i4 + 1 | 0;
    HEAP32[i16 >> 2] = i1;
    i22 = i2 + -1 | 0;
    HEAP32[i11 >> 2] = i22;
    if (!i22) {
     i20 = 16;
     break;
    }
   } while (0);
   if ((i20 | 0) == 16) HEAP8[i12 >> 0] = 1;
   HEAP8[i12 >> 0] = 1;
  } while (0);
  STACKTOP = i21;
  return;
 } else {
  HEAP32[i16 >> 2] = i4;
  i11 = i16 + 4 | 0;
  HEAP32[i11 >> 2] = i2;
  i12 = i16 + 8 | 0;
  HEAP8[i12 >> 0] = 0;
  if (!i4) {
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
  }
  HEAP8[i19 >> 0] = 0;
  i9 = i19 + 1 | 0;
  HEAP8[i9 >> 0] = -1;
  i10 = i19 + 2 | 0;
  HEAP16[i10 >> 1] = 0;
  i5 = i18 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = i10 + 1 | 0;
  i6 = i14 + 4 | 0;
  i7 = i14 + 8 | 0;
  i8 = i14 + 12 | 0;
  L22 : do if (i2 | 0) {
   i3 = HEAP8[i4 >> 0] | 0;
   HEAP8[i19 >> 0] = i3;
   i1 = i4 + 1 | 0;
   HEAP32[i16 >> 2] = i1;
   i22 = i2 + -1 | 0;
   HEAP32[i11 >> 2] = i22;
   L24 : do if (!i22) i20 = 6; else while (1) {
    HEAP8[i9 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i4 + 2 | 0;
    HEAP32[i16 >> 2] = i1;
    i22 = i2 + -2 | 0;
    HEAP32[i11 >> 2] = i22;
    if (i22 >>> 0 < 2) break L24;
    HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
    i22 = i4 + 3 | 0;
    HEAP32[i16 >> 2] = i22;
    HEAP32[i11 >> 2] = i2 + -3;
    HEAP8[i5 >> 0] = HEAP8[i22 >> 0] | 0;
    HEAP32[i16 >> 2] = i4 + 4;
    HEAP32[i11 >> 2] = i2 + -4;
    HEAP32[i14 >> 2] = i18;
    HEAP32[i6 >> 2] = i16;
    HEAP32[i7 >> 2] = i19;
    HEAP32[i8 >> 2] = i17;
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_(i3 & 255, i15, i13) | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    if (!((HEAP8[i12 >> 0] | 0) == 0 & (i2 | 0) != 0)) break L22;
    i4 = HEAP32[i16 >> 2] | 0;
    i3 = HEAP8[i4 >> 0] | 0;
    HEAP8[i19 >> 0] = i3;
    i1 = i4 + 1 | 0;
    HEAP32[i16 >> 2] = i1;
    i22 = i2 + -1 | 0;
    HEAP32[i11 >> 2] = i22;
    if (!i22) {
     i20 = 6;
     break;
    }
   } while (0);
   if ((i20 | 0) == 6) HEAP8[i12 >> 0] = 1;
   HEAP8[i12 >> 0] = 1;
  } while (0);
  STACKTOP = i21;
  return;
 }
}

function __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, i2 = 0;
 do switch (HEAP32[i3 + 24 >> 2] | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i4 >> 2]);
   if (!(HEAP8[i3 + 28 >> 0] | 0)) {
    HEAPF32[i5 >> 2] = f1;
    f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   } else {
    HEAPF32[i5 >> 2] = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
    f1 = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(.5))));
   }
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 1:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(.5)));
   if (!(HEAP8[i3 + 28 >> 0] | 0)) {
    HEAPF32[i5 >> 2] = f1;
    f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   } else {
    HEAPF32[i5 >> 2] = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
    f1 = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(.5))));
   }
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 2:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(HEAPF32[i4 + 8 >> 2]));
   if (!(HEAP8[i3 + 28 >> 0] | 0)) {
    HEAPF32[i5 >> 2] = f1;
    f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   } else {
    HEAPF32[i5 >> 2] = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
    f1 = Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(.5))));
   }
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[i4 >> 2]);
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f1 = Math_fround(Math_fround(Math_fround(f1 + Math_fround(f1 + Math_fround(HEAPF32[i4 + 12 >> 2]))) - Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 4:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(.5)));
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f1 = Math_fround(Math_fround(Math_fround(f1 + Math_fround(f1 + Math_fround(HEAPF32[i4 + 12 >> 2]))) - Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 5:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(HEAPF32[i4 + 8 >> 2]));
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f1 = Math_fround(Math_fround(Math_fround(f1 + Math_fround(f1 + Math_fround(HEAPF32[i4 + 12 >> 2]))) - Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[i4 >> 2]);
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(HEAPF32[i4 + 12 >> 2])) - Math_fround(HEAPF32[i3 + 20 >> 2]));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 7:
  {
   f1 = Math_fround(HEAPF32[i4 >> 2]);
   f1 = Math_fround(Math_fround(f1 + Math_fround(f1 + Math_fround(HEAPF32[i4 + 8 >> 2]))) * Math_fround(.5));
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(HEAPF32[i4 + 12 >> 2])) - Math_fround(HEAPF32[i3 + 20 >> 2]));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 case 8:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(HEAPF32[i4 + 8 >> 2]));
   i2 = (HEAP8[i3 + 28 >> 0] | 0) == 0;
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 >> 2] = f1;
   f1 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) + Math_fround(HEAPF32[i4 + 12 >> 2])) - Math_fround(HEAPF32[i3 + 20 >> 2]));
   if (!i2) f1 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
   HEAPF32[i5 + 4 >> 2] = f1;
   return;
  }
 default:
  {
   HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   return;
  }
 } while (0);
}

function __Z9InitInputv() {
 var i1 = 0;
 __Z33SetCaptureAllKeyboardInputEnabledb(1);
 _emscripten_set_mouseup_callback(0, 0, 0, fb + 339 | 0) | 0;
 _emscripten_set_mousedown_callback(gb + 363711 | 0, 0, 0, fb + 339 | 0) | 0;
 _emscripten_set_mousemove_callback(0, 0, 0, fb + 340 | 0) | 0;
 _emscripten_set_wheel_callback(gb + 363711 | 0, 0, 0, fb + 341 | 0) | 0;
 _emscripten_set_touchstart_callback(gb + 363711 | 0, 0, 0, fb + 342 | 0) | 0;
 _emscripten_set_touchend_callback(gb + 363711 | 0, 0, 0, fb + 342 | 0) | 0;
 _emscripten_set_touchmove_callback(gb + 363711 | 0, 0, 0, fb + 342 | 0) | 0;
 _emscripten_set_touchcancel_callback(gb + 363711 | 0, 0, 0, fb + 342 | 0) | 0;
 _emscripten_set_devicemotion_callback(0, 0, fb + 343 | 0) | 0;
 _emscripten_set_deviceorientation_callback(0, 0, fb + 344 | 0) | 0;
 i1 = 0;
 do {
  HEAP32[gb + 1100524 + (i1 << 2) >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 225);
 HEAP32[gb + 1100524 + 260 >> 2] = 97;
 HEAP32[gb + 1100524 + 264 >> 2] = 98;
 HEAP32[gb + 1100524 + 268 >> 2] = 99;
 HEAP32[gb + 1100524 + 272 >> 2] = 100;
 HEAP32[gb + 1100524 + 276 >> 2] = 101;
 HEAP32[gb + 1100524 + 280 >> 2] = 102;
 HEAP32[gb + 1100524 + 284 >> 2] = 103;
 HEAP32[gb + 1100524 + 288 >> 2] = 104;
 HEAP32[gb + 1100524 + 292 >> 2] = 105;
 HEAP32[gb + 1100524 + 296 >> 2] = 106;
 HEAP32[gb + 1100524 + 300 >> 2] = 107;
 HEAP32[gb + 1100524 + 304 >> 2] = 108;
 HEAP32[gb + 1100524 + 308 >> 2] = 109;
 HEAP32[gb + 1100524 + 312 >> 2] = 110;
 HEAP32[gb + 1100524 + 316 >> 2] = 111;
 HEAP32[gb + 1100524 + 320 >> 2] = 112;
 HEAP32[gb + 1100524 + 324 >> 2] = 113;
 HEAP32[gb + 1100524 + 328 >> 2] = 114;
 HEAP32[gb + 1100524 + 332 >> 2] = 115;
 HEAP32[gb + 1100524 + 336 >> 2] = 116;
 HEAP32[gb + 1100524 + 340 >> 2] = 117;
 HEAP32[gb + 1100524 + 344 >> 2] = 118;
 HEAP32[gb + 1100524 + 348 >> 2] = 119;
 HEAP32[gb + 1100524 + 352 >> 2] = 120;
 HEAP32[gb + 1100524 + 356 >> 2] = 121;
 HEAP32[gb + 1100524 + 360 >> 2] = 122;
 HEAP32[gb + 1100524 + 64 >> 2] = 304;
 HEAP32[gb + 1100524 + 68 >> 2] = 306;
 HEAP32[gb + 1100524 + 72 >> 2] = 308;
 HEAP32[gb + 1100524 + 80 >> 2] = 301;
 HEAP32[gb + 1100524 + 132 >> 2] = 280;
 HEAP32[gb + 1100524 + 136 >> 2] = 281;
 HEAP32[gb + 1100524 + 140 >> 2] = 279;
 HEAP32[gb + 1100524 + 144 >> 2] = 278;
 HEAP32[gb + 1100524 + 148 >> 2] = 276;
 HEAP32[gb + 1100524 + 152 >> 2] = 273;
 HEAP32[gb + 1100524 + 156 >> 2] = 275;
 HEAP32[gb + 1100524 + 160 >> 2] = 274;
 HEAP32[gb + 1100524 + 176 >> 2] = 316;
 HEAP32[gb + 1100524 + 180 >> 2] = 277;
 HEAP32[gb + 1100524 + 184 >> 2] = 127;
 HEAP32[gb + 1100524 + 364 >> 2] = 310;
 HEAP32[gb + 1100524 + 384 >> 2] = 256;
 HEAP32[gb + 1100524 + 388 >> 2] = 257;
 HEAP32[gb + 1100524 + 392 >> 2] = 258;
 HEAP32[gb + 1100524 + 396 >> 2] = 259;
 HEAP32[gb + 1100524 + 400 >> 2] = 260;
 HEAP32[gb + 1100524 + 404 >> 2] = 261;
 HEAP32[gb + 1100524 + 408 >> 2] = 262;
 HEAP32[gb + 1100524 + 412 >> 2] = 263;
 HEAP32[gb + 1100524 + 416 >> 2] = 264;
 HEAP32[gb + 1100524 + 420 >> 2] = 265;
 HEAP32[gb + 1100524 + 424 >> 2] = 268;
 HEAP32[gb + 1100524 + 428 >> 2] = 270;
 HEAP32[gb + 1100524 + 436 >> 2] = 269;
 HEAP32[gb + 1100524 + 440 >> 2] = 266;
 HEAP32[gb + 1100524 + 444 >> 2] = 267;
 HEAP32[gb + 1100524 + 448 >> 2] = 282;
 HEAP32[gb + 1100524 + 452 >> 2] = 283;
 HEAP32[gb + 1100524 + 456 >> 2] = 284;
 HEAP32[gb + 1100524 + 460 >> 2] = 285;
 HEAP32[gb + 1100524 + 464 >> 2] = 286;
 HEAP32[gb + 1100524 + 468 >> 2] = 287;
 HEAP32[gb + 1100524 + 472 >> 2] = 288;
 HEAP32[gb + 1100524 + 476 >> 2] = 289;
 HEAP32[gb + 1100524 + 480 >> 2] = 290;
 HEAP32[gb + 1100524 + 484 >> 2] = 291;
 HEAP32[gb + 1100524 + 488 >> 2] = 292;
 HEAP32[gb + 1100524 + 492 >> 2] = 293;
 HEAP32[gb + 1100524 + 496 >> 2] = 294;
 HEAP32[gb + 1100524 + 500 >> 2] = 295;
 HEAP32[gb + 1100524 + 504 >> 2] = 296;
 HEAP32[gb + 1100524 + 576 >> 2] = 300;
 HEAP32[gb + 1100524 + 640 >> 2] = 94;
 HEAP32[gb + 1100524 + 644 >> 2] = 33;
 HEAP32[gb + 1100524 + 648 >> 2] = 34;
 HEAP32[gb + 1100524 + 652 >> 2] = 35;
 HEAP32[gb + 1100524 + 656 >> 2] = 36;
 HEAP32[gb + 1100524 + 660 >> 2] = 37;
 HEAP32[gb + 1100524 + 664 >> 2] = 38;
 HEAP32[gb + 1100524 + 668 >> 2] = 95;
 HEAP32[gb + 1100524 + 672 >> 2] = 40;
 HEAP32[gb + 1100524 + 676 >> 2] = 41;
 HEAP32[gb + 1100524 + 680 >> 2] = 42;
 HEAP32[gb + 1100524 + 684 >> 2] = 43;
 HEAP32[gb + 1100524 + 692 >> 2] = 45;
 HEAP32[gb + 1100524 + 696 >> 2] = 91;
 HEAP32[gb + 1100524 + 700 >> 2] = 93;
 HEAP32[gb + 1100524 + 744 >> 2] = 59;
 HEAP32[gb + 1100524 + 748 >> 2] = 61;
 HEAP32[gb + 1100524 + 752 >> 2] = 44;
 HEAP32[gb + 1100524 + 756 >> 2] = 45;
 HEAP32[gb + 1100524 + 760 >> 2] = 46;
 HEAP32[gb + 1100524 + 764 >> 2] = 47;
 HEAP32[gb + 1100524 + 768 >> 2] = 96;
 HEAP32[gb + 1100524 + 876 >> 2] = 91;
 HEAP32[gb + 1100524 + 880 >> 2] = 92;
 HEAP32[gb + 1100524 + 884 >> 2] = 93;
 HEAP32[gb + 1100524 + 888 >> 2] = 39;
 HEAP32[gb + 1100524 + 896 >> 2] = 310;
 return;
}

function __Z11SkinGenericILi2ELb1ELb1EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i7 = HEAP32[i1 + 68 >> 2] | 0;
 i8 = HEAP32[i1 + 40 >> 2] | 0;
 i9 = HEAP32[i1 + 44 >> 2] | 0;
 i10 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 if ((i10 | 0) <= 0) return;
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 while (1) {
  f18 = Math_fround(HEAPF32[i3 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i12 = HEAP32[i3 + 8 >> 2] | 0;
  i11 = HEAP32[i3 + 12 >> 2] | 0;
  f13 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) >> 2]));
  f13 = Math_fround(f13 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) >> 2])));
  f28 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 4 >> 2]));
  f28 = Math_fround(f28 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 4 >> 2])));
  f26 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 8 >> 2]));
  f26 = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 8 >> 2])));
  f29 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 16 >> 2]));
  f29 = Math_fround(f29 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 16 >> 2])));
  f27 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 20 >> 2]));
  f27 = Math_fround(f27 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 20 >> 2])));
  f24 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 24 >> 2]));
  f24 = Math_fround(f24 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 24 >> 2])));
  f15 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 32 >> 2]));
  f15 = Math_fround(f15 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 32 >> 2])));
  f14 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 36 >> 2]));
  f14 = Math_fround(f14 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 36 >> 2])));
  f22 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 40 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 40 >> 2])));
  f16 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 48 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 48 >> 2])));
  f20 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 52 >> 2]));
  f20 = Math_fround(f20 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 52 >> 2])));
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i7 + (i12 << 6) + 56 >> 2]));
  f25 = Math_fround(f18 + Math_fround(f25 * Math_fround(HEAPF32[i7 + (i11 << 6) + 56 >> 2])));
  i11 = i4 + i5 | 0;
  i12 = i4 + i6 | 0;
  f18 = Math_fround(HEAPF32[i4 >> 2]);
  f21 = Math_fround(f13 * f18);
  f23 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f29 * f23));
  f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(f16 + Math_fround(f21 + Math_fround(f15 * f19)));
  f20 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f28 * f18) + Math_fround(f27 * f23)) + Math_fround(f14 * f19)));
  f19 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f26 * f18) + Math_fround(f24 * f23)) + Math_fround(f22 * f19)));
  f23 = Math_fround(HEAPF32[i11 >> 2]);
  f18 = Math_fround(f13 * f23);
  f25 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f29 * f25));
  f16 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f15 * f16));
  f17 = Math_fround(Math_fround(Math_fround(f28 * f23) + Math_fround(f27 * f25)) + Math_fround(f14 * f16));
  f16 = Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f24 * f25)) + Math_fround(f22 * f16));
  f25 = Math_fround(HEAPF32[i12 >> 2]);
  f13 = Math_fround(f13 * f25);
  f23 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f29 = Math_fround(f13 + Math_fround(f29 * f23));
  f13 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f15 = Math_fround(f29 + Math_fround(f15 * f13));
  f14 = Math_fround(Math_fround(Math_fround(f28 * f25) + Math_fround(f27 * f23)) + Math_fround(f14 * f13));
  f13 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f24 * f23)) + Math_fround(f22 * f13));
  HEAPF32[i1 >> 2] = f21;
  HEAPF32[i1 + 4 >> 2] = f20;
  HEAPF32[i1 + 8 >> 2] = f19;
  i11 = i1 + i5 | 0;
  HEAPF32[i11 >> 2] = f18;
  HEAPF32[i11 + 4 >> 2] = f17;
  HEAPF32[i11 + 8 >> 2] = f16;
  i11 = i1 + i6 | 0;
  HEAPF32[i11 >> 2] = f15;
  HEAPF32[i11 + 4 >> 2] = f14;
  HEAPF32[i11 + 8 >> 2] = f13;
  HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i10 | 0)) break; else {
   i3 = i3 + 16 | 0;
   i4 = i4 + i8 | 0;
   i1 = i1 + i9 | 0;
  }
 }
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_(i15, i16, i13, i9, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i15, i16, i13, i1) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i8 = i2;
 i7 = i1;
 do if (i1 >>> 0 < i2 >>> 0) {
  i2 = i9 + 8 | 0;
  i1 = i2;
  i12 = i13 + 8 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i2 >>> 0 < i1 >>> 0) {
   i16 = i14;
   return i16 | 0;
  }
  i2 = i9 + 8 | 0;
  i1 = i2;
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i13 + 8 | 0;
  i4 = i5;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i6 | 0) == (i3 | 0) & (i1 | 0) == (i4 | 0)) {
   i11 = i9 + 16 | 0;
   i4 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i13 + 16 | 0;
   i10 = HEAP32[i12 + 4 >> 2] | 0;
   if (i4 >>> 0 < i10 >>> 0 | ((i4 | 0) == (i10 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 : 0)) {
    i12 = i5;
    i3 = i6;
    break;
   } else i1 = i14;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i4 >>> 0 | (i1 | 0) == (i4 | 0) & i6 >>> 0 < i3 >>> 0) {
    i12 = i5;
    i3 = i6;
    break;
   } else i1 = i14;
   return i1 | 0;
  }
 } while (0);
 HEAP32[i13 >> 2] = i7;
 HEAP32[i9 >> 2] = i8;
 i11 = i12;
 i6 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i13 + 16 | 0;
 i7 = i10;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = i9 + 16 | 0;
 i5 = i1;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i11;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i14 + 1 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i7 = i3;
 i8 = i2;
 do if (i2 >>> 0 < i3 >>> 0) {
  i1 = i12;
  i11 = i16 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i3 >>> 0 < i2 >>> 0) {
   i16 = i1;
   return i16 | 0;
  }
  i6 = i12;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i16 + 8 | 0;
  i5 = i3;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i6 | 0) == (i5 | 0)) {
   i9 = i10;
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i16 + 16 | 0;
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   if (i4 >>> 0 < i5 >>> 0 | ((i4 | 0) == (i5 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0 : 0)) {
    i11 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i11 = i3;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 HEAP32[i16 >> 2] = i8;
 HEAP32[i13 >> 2] = i7;
 i8 = i11;
 i13 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i16 + 16 | 0;
 i3 = i9;
 i7 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i10;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i10;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i14 + 2 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i7 = i3;
 i8 = i2;
 do if (i2 >>> 0 < i3 >>> 0) {
  i1 = i11;
  i3 = i15 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  if (i3 >>> 0 < i2 >>> 0) {
   i16 = i1;
   return i16 | 0;
  }
  i6 = i11;
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i15 + 8 | 0;
  i5 = i3;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i6 | 0) == (i5 | 0)) {
   i12 = i9;
   i5 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = i15 + 16 | 0;
   i10 = HEAP32[i13 + 4 >> 2] | 0;
   if (i5 >>> 0 < i10 >>> 0 | ((i5 | 0) == (i10 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 HEAP32[i15 >> 2] = i8;
 HEAP32[i16 >> 2] = i7;
 i12 = i3;
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i15 + 16 | 0;
 i15 = i16;
 i13 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = i9;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i16 + 4 >> 2] = i8;
 i16 = i11;
 HEAP32[i16 >> 2] = i10;
 HEAP32[i16 + 4 >> 2] = i12;
 i16 = i9;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i16 + 4 >> 2] = i15;
 i16 = i14 + 3 | 0;
 return i16 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 40 | 0;
 i8 = i16 + 36 | 0;
 i12 = i16 + 16 | 0;
 i7 = i16 + 12 | 0;
 i5 = i16 + 32 | 0;
 i6 = i16 + 28 | 0;
 i11 = i16;
 i14 = i13 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 i3 = i1;
 if (i4 >>> 0 >= i9 >>> 0) {
  if (i4 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i3 + (i9 * 20 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i3 = i9 * 20 | 0;
  i4 = (i3 | 0) / 20 | 0;
  if (!i3) {
   i6 = i10;
   i7 = i11 + 8 | 0;
   i8 = i11;
   i5 = 0;
   i3 = 0;
   i4 = 0;
  } else {
   if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i6 = __Znwj(i3) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i11 >> 2] = i6;
   i9 = i11 + 8 | 0;
   HEAP32[i9 >> 2] = i6 + (i4 * 20 | 0);
   HEAP32[i12 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i11, i8, i15, i4);
   i6 = i10;
   i7 = i9;
   i8 = i11;
   i1 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  i5 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i5 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    i4 = i15 + 4 | 0;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i2 + -16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i14 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i4 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i10 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i7 = i13 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i1 | 0) / 20 | 0 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE8__appendEj(i13, i9 - i4 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE7reserveEj(i12, i9);
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i15);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 20 | 0;
 i4 = i2;
 if (i1 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE8__appendEj(i12, i9 - i1 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i1 >>> 0 > i9 >>> 0) {
  i6 = i3 + (i9 * 20 | 0) | 0;
  if ((i4 | 0) != (i6 | 0)) {
   i5 = i15 + 4 | 0;
   i1 = i4;
   while (1) {
    i2 = i1 + -20 | 0;
    HEAP32[i10 >> 2] = i2;
    i3 = i1 + -16 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i3 >> 2] | 0;
     i11 = HEAP32[i1 + -4 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i5 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
     i2 = HEAP32[i10 >> 2] | 0;
    }
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i2;
   }
  }
 }
 i5 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i5;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = i12 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i5 = i1;
 i2 = i13;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   i4 = i15 + 4 | 0;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i10 >> 2] = i1;
    i3 = i2 + -16 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i3 >> 2] | 0;
     i14 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i15 >> 2] = 66;
     HEAP32[i4 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
     i1 = HEAP32[i10 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CB10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ESF_SF_RfPKj(i14, i5, i1, i2, i3, i13, i4) {
 i14 = i14 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 56 | 0;
 i27 = i12 + 36 | 0;
 i8 = i12 + 24 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12;
 i1 = HEAP32[i14 + 20 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = i5 + 8;
 HEAP32[i11 + 12 >> 2] = 1;
 HEAP32[i11 + 16 >> 2] = i12 + 48;
 i1 = i11 + 40 | 0;
 HEAP32[i1 >> 2] = 2122317823;
 i2 = i11 + 44 | 0;
 HEAP32[i2 >> 2] = 2122317823;
 i3 = i11 + 48 | 0;
 HEAP32[i3 >> 2] = 2122317823;
 i4 = i11 + 52 | 0;
 HEAP32[i4 >> 2] = -25165825;
 i5 = i11 + 56 | 0;
 HEAP32[i5 >> 2] = -25165825;
 i6 = i11 + 60 | 0;
 HEAP32[i6 >> 2] = -25165825;
 i7 = i11 + 64 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP8[i7 + 12 >> 0] = 0;
 i7 = i14 + 36 | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj(i27, i11, 0);
 f21 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i27 + 4 >> 2]) * Math_fround(2.0));
 f26 = Math_fround(Math_fround(HEAPF32[i27 + 8 >> 2]) * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f25 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f15 = Math_fround(f21 * f22);
 f20 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f23 * f20));
 f19 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f26 * f19));
 f17 = Math_fround(Math_fround(f22 * f15) + Math_fround(Math_fround(f21 * f25) + Math_fround(f24 * Math_fround(Math_fround(f26 * f20) - Math_fround(f23 * f19)))));
 f18 = Math_fround(Math_fround(f20 * f15) + Math_fround(Math_fround(f23 * f25) + Math_fround(f24 * Math_fround(Math_fround(f21 * f19) - Math_fround(f26 * f22)))));
 f15 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f24 * Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)))) + Math_fround(f19 * f15));
 i16 = HEAP32[i14 + 24 >> 2] | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f17);
 f17 = Math_fround(Math_fround(-Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) * f18)) - f17);
 f15 = Math_fround(f17 - Math_fround(f15 * Math_fround(HEAPF32[i16 + 8 >> 2])));
 if (!(f15 >= Math_fround(HEAPF32[i14 + 12 >> 2]))) {
  i27 = i14 + 8 | 0;
  f26 = Math_fround(HEAPF32[i27 >> 2]);
  i27 = f26 > Math_fround(0.0);
  STACKTOP = i12;
  return i27 | 0;
 } else {
  __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE(i11, HEAP32[i7 >> 2] | 0);
  f24 = Math_fround(HEAPF32[i1 >> 2]);
  f25 = Math_fround(HEAPF32[i2 >> 2]);
  f26 = Math_fround(HEAPF32[i3 >> 2]);
  f23 = Math_fround(HEAPF32[i4 >> 2]);
  f21 = Math_fround(HEAPF32[i5 >> 2]);
  f22 = Math_fround(HEAPF32[i6 >> 2]);
  i27 = HEAP32[i14 + 40 >> 2] | 0;
  i16 = HEAP32[i14 + 44 >> 2] | 0;
  f18 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * Math_fround(1.10000002));
  f20 = Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) * Math_fround(1.10000002));
  f19 = Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) * Math_fround(1.10000002));
  HEAPF32[i8 >> 2] = f18;
  HEAPF32[i8 + 4 >> 2] = f20;
  HEAPF32[i8 + 8 >> 2] = f19;
  f19 = Math_fround(Math_fround(f25 + f21) * Math_fround(.5));
  f20 = Math_fround(Math_fround(f26 + f22) * Math_fround(.5));
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(f24 + f23) * Math_fround(.5));
  HEAPF32[i9 + 4 >> 2] = f19;
  HEAPF32[i9 + 8 >> 2] = f20;
  f25 = Math_fround(Math_fround(Math_fround(Math_fround(f21 - f25) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
  f26 = Math_fround(Math_fround(Math_fround(Math_fround(f22 - f26) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
  HEAPF32[i10 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f23 - f24) * Math_fround(.5)) + Math_fround(.00999999977)) * Math_fround(1.10000002));
  HEAPF32[i10 + 4 >> 2] = f25;
  HEAPF32[i10 + 8 >> 2] = f26;
  f26 = Math_fround(__Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i27, i8, i9, i10, HEAP32[i14 + 28 >> 2] | 0, HEAP32[i14 + 32 >> 2] | 0));
  i27 = i14 + 8 | 0;
  f25 = Math_fround(HEAPF32[i27 >> 2]);
  f26 = f25 < f26 ? f25 : f26;
  HEAPF32[i27 >> 2] = f26;
  HEAPF32[i13 >> 2] = f26;
  f26 = Math_fround(HEAPF32[i27 >> 2]);
  i27 = f26 > Math_fround(0.0);
  STACKTOP = i12;
  return i27 | 0;
 }
 return 0;
}

function __ZN5Umbra9Matrix4x4mLERKNS_9Matrix4x3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i11 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 i18 = i1 + 32 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 i21 = i2 + 4 | 0;
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2])));
 i20 = i2 + 8 | 0;
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2])));
 i19 = i2 + 12 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i19 >> 2])));
 i17 = i2 + 16 | 0;
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 i16 = i2 + 20 | 0;
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
 i15 = i2 + 24 | 0;
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
 i13 = i2 + 28 | 0;
 HEAPF32[i11 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2])));
 i11 = i2 + 32 | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2]));
 i9 = i2 + 36 | 0;
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 i7 = i2 + 40 | 0;
 f8 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])));
 i4 = i2 + 44 | 0;
 HEAPF32[i18 >> 2] = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])));
 i18 = i1 + 4 | 0;
 f10 = Math_fround(HEAPF32[i18 >> 2]);
 i12 = i1 + 20 | 0;
 f8 = Math_fround(HEAPF32[i12 >> 2]);
 i3 = i1 + 36 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f8 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 i3 = i1 + 8 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i12 = i1 + 24 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i18 = i1 + 40 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2]));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 f8 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i4 >> 2])));
 i18 = i1 + 12 | 0;
 f10 = Math_fround(HEAPF32[i18 >> 2]);
 i12 = i1 + 28 | 0;
 f8 = Math_fround(HEAPF32[i12 >> 2]);
 i3 = i1 + 44 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i21 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 HEAPF32[i18 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i19 >> 2])));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i12 >> 2] = Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2]));
 f8 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff(i19, i20, i17, f7, f9, f12) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i17 = i17 | 0;
 f7 = Math_fround(f7);
 f9 = Math_fround(f9);
 f12 = Math_fround(f12);
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i21 = 0, i22 = 0;
 i18 = i19 + 8 | 0;
 i11 = HEAP32[i18 >> 2] | 0;
 i11 = i11 << 11 ^ i11;
 i14 = i19 + 12 | 0;
 HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
 i15 = i19 + 16 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 i16 = i19 + 20 | 0;
 i13 = HEAP32[i16 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 i13 = i11 >>> 8 ^ i11 ^ i13 ^ i13 >>> 19;
 HEAP32[i16 >> 2] = i13;
 f6 = Math_fround(Math_fround((i13 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 if (Math_fround(HEAPF32[i17 + 80 >> 2]) > Math_fround(0.0)) {
  i13 = f7 > Math_fround(0.0);
  f5 = i13 ? f7 : Math_fround(0.0);
  i13 = f9 > Math_fround(0.0);
  f2 = i13 ? f9 : Math_fround(0.0);
  if (f2 < f5) {
   f4 = f12;
   f2 = Math_fround(Math_fround(__ZL20AccumulateContinuousRK11MinMaxCurveffff(i17, f12, f2, f2, f6)) + Math_fround(0.0));
  } else {
   f4 = f2;
   f2 = Math_fround(0.0);
  }
  f5 = Math_fround(f2 + Math_fround(__ZL20AccumulateContinuousRK11MinMaxCurveffff(i17, f12, f4, Math_fround(f4 - f5), f6)));
 } else f5 = Math_fround(0.0);
 i13 = f7 > Math_fround(0.0);
 f4 = i13 ? f7 : Math_fround(0.0);
 i13 = f9 > Math_fround(0.0);
 f2 = i13 ? f9 : Math_fround(0.0);
 i13 = HEAP32[i17 + 576 >> 2] | 0;
 if (f2 < f4) {
  if (!i13) i1 = 0; else {
   i1 = 0;
   i10 = 0;
   do {
    f9 = Math_fround(HEAPF32[i17 + 528 + (i10 << 2) >> 2]);
    if (f9 >= Math_fround(0.0) & f9 < f2) {
     i3 = HEAP32[i17 + 544 + (i10 << 2) >> 2] | 0;
     i11 = HEAP32[i17 + 560 + (i10 << 2) >> 2] | 0;
     i8 = i11 + 1 | 0;
     if ((i3 | 0) > (i11 | 0)) {
      if ((i8 | 0) < (i3 | 0)) {
       i21 = HEAP32[i18 >> 2] | 0;
       i21 = i21 << 11 ^ i21;
       HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
       i11 = HEAP32[i16 >> 2] | 0;
       HEAP32[i15 >> 2] = i11;
       i11 = i21 >>> 8 ^ i21 ^ i11 ^ i11 >>> 19;
       HEAP32[i16 >> 2] = i11;
       i3 = i3 - ((i11 >>> 0) % ((i3 - i8 | 0) >>> 0) | 0) | 0;
      }
     } else {
      i11 = HEAP32[i18 >> 2] | 0;
      i11 = i11 << 11 ^ i11;
      HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
      i21 = HEAP32[i16 >> 2] | 0;
      HEAP32[i15 >> 2] = i21;
      i21 = i11 >>> 8 ^ i11 ^ i21 ^ i21 >>> 19;
      HEAP32[i16 >> 2] = i21;
      i3 = ((i21 >>> 0) % ((i8 - i3 | 0) >>> 0) | 0) + i3 | 0;
     }
     i1 = i3 + i1 | 0;
    }
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i13 | 0));
  }
  f2 = Math_fround(f12 + Math_fround(.0000999999974));
  i11 = i1;
 } else i11 = 0;
 if (!i13) {
  i18 = 0;
  i18 = i18 + i11 | 0;
  i21 = i19 + 4 | 0;
  f9 = Math_fround(HEAPF32[i21 >> 2]);
  f9 = Math_fround(f5 + f9);
  i17 = ~~f9 >>> 0;
  HEAP32[i20 >> 2] = i17;
  f12 = Math_fround(i17 >>> 0);
  f12 = Math_fround(f9 - f12);
  HEAPF32[i21 >> 2] = f12;
  i21 = !(f5 >= Math_fround(.0000999999974));
  f12 = Math_fround(Math_fround(1.0) / f5);
  f12 = i21 ? Math_fround(1.0) : f12;
  HEAPF32[i19 >> 2] = f12;
  i21 = HEAP32[i20 >> 2] | 0;
  i21 = i18 + i21 | 0;
  return i21 | 0;
 } else {
  i1 = 0;
  i10 = 0;
 }
 do {
  f12 = Math_fround(HEAPF32[i17 + 528 + (i10 << 2) >> 2]);
  if (f12 >= f4 & f12 < f2) {
   i3 = HEAP32[i17 + 544 + (i10 << 2) >> 2] | 0;
   i21 = HEAP32[i17 + 560 + (i10 << 2) >> 2] | 0;
   i8 = i21 + 1 | 0;
   if ((i3 | 0) > (i21 | 0)) {
    if ((i8 | 0) < (i3 | 0)) {
     i22 = HEAP32[i18 >> 2] | 0;
     i22 = i22 << 11 ^ i22;
     HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
     i21 = HEAP32[i16 >> 2] | 0;
     HEAP32[i15 >> 2] = i21;
     i21 = i22 >>> 8 ^ i22 ^ i21 ^ i21 >>> 19;
     HEAP32[i16 >> 2] = i21;
     i3 = i3 - ((i21 >>> 0) % ((i3 - i8 | 0) >>> 0) | 0) | 0;
    }
   } else {
    i21 = HEAP32[i18 >> 2] | 0;
    i21 = i21 << 11 ^ i21;
    HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    i22 = HEAP32[i16 >> 2] | 0;
    HEAP32[i15 >> 2] = i22;
    i22 = i21 >>> 8 ^ i21 ^ i22 ^ i22 >>> 19;
    HEAP32[i16 >> 2] = i22;
    i3 = ((i22 >>> 0) % ((i8 - i3 | 0) >>> 0) | 0) + i3 | 0;
   }
   i1 = i3 + i1 | 0;
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i13 | 0));
 i21 = i1 + i11 | 0;
 i22 = i19 + 4 | 0;
 f9 = Math_fround(HEAPF32[i22 >> 2]);
 f9 = Math_fround(f5 + f9);
 i18 = ~~f9 >>> 0;
 HEAP32[i20 >> 2] = i18;
 f12 = Math_fround(i18 >>> 0);
 f12 = Math_fround(f9 - f12);
 HEAPF32[i22 >> 2] = f12;
 i22 = !(f5 >= Math_fround(.0000999999974));
 f12 = Math_fround(Math_fround(1.0) / f5);
 f12 = i22 ? Math_fround(1.0) : f12;
 HEAPF32[i19 >> 2] = f12;
 i22 = HEAP32[i20 >> 2] | 0;
 i22 = i21 + i22 | 0;
 return i22 | 0;
}

function __ZN12TreeRenderer29CreateMeshTreeRendererForTreeEi(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 92 | 0;
 i7 = i11 + 88 | 0;
 i6 = i11 + 24 | 0;
 i5 = i11;
 i14 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i14 + 16 >> 2] | 0;
 i4 = i3 + (i1 * 40 | 0) + 32 | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 i14 = HEAP32[i14 + 28 >> 2] | 0;
 i8 = HEAP32[i9 + 364 >> 2] | 0;
 HEAP32[(HEAP32[i9 + 236 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i9 + 268 >> 2];
 f19 = Math_fround(HEAPF32[i3 + (i1 * 40 | 0) >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i9 + 120 >> 2]));
 f20 = Math_fround(HEAPF32[i3 + (i1 * 40 | 0) + 4 >> 2]);
 f20 = Math_fround(f20 * Math_fround(HEAPF32[i9 + 124 >> 2]));
 f21 = Math_fround(HEAPF32[i3 + (i1 * 40 | 0) + 8 >> 2]);
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i9 + 128 >> 2]));
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i9 + 136 >> 2]));
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i9 + 140 >> 2]));
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i9 + 144 >> 2]));
 HEAPF32[i2 >> 2] = f19;
 HEAPF32[i2 + 4 >> 2] = f20;
 HEAPF32[i2 + 8 >> 2] = f21;
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i6, i2) | 0;
 i10 = i9 + 204 | 0;
 HEAP32[gb + 1467256 >> 2] = i10;
 i10 = __ZN22ForwardLinearAllocator8allocateEjj(i10, 284, 4) | 0;
 i8 = HEAP32[i8 + (i13 * 44 | 0) >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i22 = HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 20 >> 2]);
 f20 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 24 >> 2]);
 f19 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 28 >> 2]);
 f18 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 32 >> 2]);
 f17 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i22 + (i4 * 156 | 0) + 40 >> 2]);
 i4 = i3 + (i1 * 40 | 0) + 12 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i3 + (i1 * 40 | 0) + 16 | 0;
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i5 >> 2] = Math_fround(f21 * f12);
 HEAPF32[i5 + 4 >> 2] = Math_fround(f20 * f16);
 HEAPF32[i5 + 8 >> 2] = Math_fround(f19 * f12);
 HEAPF32[i5 + 12 >> 2] = Math_fround(f18 * f12);
 HEAPF32[i5 + 16 >> 2] = Math_fround(f17 * f16);
 HEAPF32[i5 + 20 >> 2] = Math_fround(f15 * f12);
 __ZN20IntermediateRendererC2Ev(i10);
 HEAP32[i10 + 264 >> 2] = 0;
 HEAP32[i10 + 268 >> 2] = i9;
 HEAP32[i10 + 272 >> 2] = i1;
 HEAP32[i10 >> 2] = gb + 184592 + 8;
 HEAP32[i10 + 276 >> 2] = i14 + (i13 * 156 | 0) + 76;
 HEAP32[i10 + 280 >> 2] = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i10, i6, i5, i2, 0, 1, 1);
 __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i10, __ZN20IntermediateRenderer27GetWritableSharedPropertiesEv(i10) | 0);
 HEAP32[gb + 1467256 >> 2] = 0;
 i2 = __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv(i9 + 256 | 0) | 0;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i2 + 20 | 0;
 i3 = (f12 == Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) & 1;
 HEAP8[i2 >> 0] = i3 << 2 & 255 | HEAP8[i2 >> 0] & -5;
 i2 = i9 + 276 | 0;
 i3 = i9 + 288 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 292 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i22 = HEAP32[i2 >> 2] | 0;
  i22 = i22 + (i4 * 24 | 0) | 0;
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i10, i22);
  STACKTOP = i11;
  return;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i22 = HEAP32[i2 >> 2] | 0;
  i22 = i22 + (i4 * 24 | 0) | 0;
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i10, i22);
  STACKTOP = i11;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i9 + 280 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i22 = HEAP32[i2 >> 2] | 0;
  i22 = i22 + (i4 * 24 | 0) | 0;
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i10, i22);
  STACKTOP = i11;
  return;
 } else {
  i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i9 + 280 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i22 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i22;
  HEAP32[i3 >> 2] = i5;
  i22 = HEAP32[i2 >> 2] | 0;
  i22 = i22 + (i4 * 24 | 0) | 0;
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i10, i22);
  STACKTOP = i11;
  return;
 }
}

function __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 120 | 0, i8);
 i2 = i6 + 136 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 152 | 0, i8 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 168 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 184 | 0, i8 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 200 | 0, i8 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 216 | 0, i8 + 6 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 256 | 0, i8 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 272 | 0, i8 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 288 | 0, i8 + 11 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 304 | 0, i8 + 12 | 0);
 i2 = i6 + 332 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 15 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 15 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 52;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 52;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbPN2UI6CanvasES3_EPS3_EEbT0_S8_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 2:
  {
   i1 = i7 + -4 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   i4 = i8 + 4 | 0;
   i1 = i7 + -4 | 0;
   i7 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (!i7) {
    if (!i2) {
     i9 = 1;
     return i9 | 0;
    }
    i7 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i7;
    if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
     i9 = 1;
     return i9 | 0;
    }
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i9;
    i9 = 1;
    return i9 | 0;
   }
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i3;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   i2 = i8 + 4 | 0;
   i3 = i8 + 8 | 0;
   i4 = i8 + 12 | 0;
   i1 = i7 + -4 | 0;
   __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i8, i2, i3, i4, i9) | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i7;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i4 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i3 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i4 = i8 + 8 | 0;
   i1 = i8 + 4 | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   do if (i6) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (i2) {
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     break;
    }
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0) {
     i6 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i6;
    }
   } else if (i2) {
    i5 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i5;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, HEAP32[i8 >> 2] | 0) | 0) {
     i6 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i1 >> 2] = i6;
    }
   } while (0);
   i1 = i8 + 12 | 0;
   L13 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    i2 = i4;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
      i4 = HEAP32[i6 >> 2] | 0;
      i5 = i4;
      i3 = i6;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
       if ((i2 | 0) == (i8 | 0)) break;
       i3 = i2 + -4 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
        i10 = i2;
        i2 = i3;
        i3 = i10;
       } else break;
      }
      HEAP32[i2 >> 2] = i4;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i7 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i6;
      i6 = i2;
      i2 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbP10GUIElementS2_EPS2_EEbT0_S7_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 2:
  {
   i1 = i7 + -4 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   i4 = i8 + 4 | 0;
   i1 = i7 + -4 | 0;
   i7 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (!i7) {
    if (!i2) {
     i9 = 1;
     return i9 | 0;
    }
    i7 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i7;
    if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) {
     i9 = 1;
     return i9 | 0;
    }
    i9 = HEAP32[i8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i4 >> 2] = i9;
    i9 = 1;
    return i9 | 0;
   }
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2) {
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i3;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   i2 = i8 + 4 | 0;
   i3 = i8 + 8 | 0;
   i4 = i8 + 12 | 0;
   i1 = i7 + -4 | 0;
   __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i8, i2, i3, i4, i9) | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i7;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i4 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i3 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i4 = i8 + 8 | 0;
   i1 = i8 + 4 | 0;
   i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   do if (i6) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (i2) {
     HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
     break;
    }
    HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i3;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0) {
     i6 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i6;
    }
   } else if (i2) {
    i5 = HEAP32[i1 >> 2] | 0;
    i6 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i5;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, HEAP32[i8 >> 2] | 0) | 0) {
     i6 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i1 >> 2] = i6;
    }
   } while (0);
   i1 = i8 + 12 | 0;
   L13 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    i2 = i4;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
      i4 = HEAP32[i6 >> 2] | 0;
      i5 = i4;
      i3 = i6;
      while (1) {
       HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
       if ((i2 | 0) == (i8 | 0)) break;
       i3 = i2 + -4 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
        i10 = i2;
        i2 = i3;
        i3 = i10;
       } else break;
      }
      HEAP32[i2 >> 2] = i4;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i7 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i6;
      i6 = i2;
      i2 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(i1, i2, i3, f4, i5, i6, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i19 = i19 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, f21 = f0, f22 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 60 | 0;
 i16 = i18 + 48 | 0;
 i17 = i18 + 20 | 0;
 i14 = i18;
 HEAP32[i15 >> 2] = gb + 114012 + 8;
 HEAP32[i15 + 4 >> 2] = 1;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = i5;
 switch (i6 | 0) {
 case 0:
  {
   HEAP8[i15 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i15 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i15 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i16 >> 2] = 2;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i16 + 4 >> 2] = f4;
 f20 = Math_fround(f11 - f10);
 f22 = Math_fround(f12 - f8);
 f9 = Math_fround(f13 - f7);
 f21 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f22 * f22)) + Math_fround(f9 * f9))));
 HEAPF32[i16 + 8 >> 2] = Math_fround(f21 * Math_fround(.5));
 f11 = Math_fround(Math_fround(f10 + f11) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f8 + f12) * Math_fround(.5));
 f13 = Math_fround(Math_fround(f7 + f13) * Math_fround(.5));
 f7 = Math_fround(f22 * Math_fround(0.0));
 f4 = Math_fround(f9 * Math_fround(0.0));
 f8 = Math_fround(f4 - f7);
 f10 = Math_fround(f20 * Math_fround(0.0));
 f9 = Math_fround(f10 - f9);
 f10 = Math_fround(f22 - f10);
 f4 = Math_fround(f21 + Math_fround(Math_fround(f20 + f7) + f4));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 if (f4 < Math_fround(.0000999999974)) {
  i1 = -2147483648;
  i2 = 1065353216;
  i5 = 0;
  i3 = 0;
 } else i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f4 * f4);
 f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 + Math_fround(f7 * f7));
 f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 + Math_fround(f8 * f8));
 f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9))));
 if (!(f10 != Math_fround(0.0))) {
  i6 = i1;
  HEAP32[i17 >> 2] = i6;
  i6 = i17 + 4 | 0;
  HEAP32[i6 >> 2] = i3;
  i6 = i17 + 8 | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i17 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i17 + 16 | 0;
  HEAPF32[i6 >> 2] = f11;
  i6 = i17 + 20 | 0;
  HEAPF32[i6 >> 2] = f12;
  i6 = i17 + 24 | 0;
  HEAPF32[i6 >> 2] = f13;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  i6 = i14 + 16 | 0;
  HEAP16[i6 >> 1] = 7;
  i6 = i14 + 18 | 0;
  HEAP8[i6 >> 0] = 0;
  i6 = HEAP32[gb + 1457404 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 356 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_iiiiiii(i5 | 0, i6 | 0, i16 | 0, i17 | 0, i19 | 0, i14 | 0, i15 | 0) | 0;
  STACKTOP = i18;
  return;
 }
 f22 = Math_fround(Math_fround(1.0) / f10);
 f21 = Math_fround(f4 * f22);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 f21 = Math_fround(f7 * f22);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 f21 = Math_fround(f8 * f22);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 f22 = Math_fround(f9 * f22);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i17 >> 2] = i6;
 i6 = i17 + 4 | 0;
 HEAP32[i6 >> 2] = i2;
 i6 = i17 + 8 | 0;
 HEAP32[i6 >> 2] = i3;
 i6 = i17 + 12 | 0;
 HEAP32[i6 >> 2] = i5;
 i6 = i17 + 16 | 0;
 HEAPF32[i6 >> 2] = f11;
 i6 = i17 + 20 | 0;
 HEAPF32[i6 >> 2] = f12;
 i6 = i17 + 24 | 0;
 HEAPF32[i6 >> 2] = f13;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i6 = i14 + 16 | 0;
 HEAP16[i6 >> 1] = 7;
 i6 = i14 + 18 | 0;
 HEAP8[i6 >> 0] = 0;
 i6 = HEAP32[gb + 1457404 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + 356 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_iiiiiii(i5 | 0, i6 | 0, i16 | 0, i17 | 0, i19 | 0, i14 | 0, i15 | 0) | 0;
 STACKTOP = i18;
 return;
}

function __ZN5physx6shdfnd10SocketImpl7connectEPKctj(i25, i14, i15, i8) {
 i25 = i25 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i26 + 72 | 0;
 i16 = i26 + 64 | 0;
 i23 = i26 + 56 | 0;
 i22 = i26 + 48 | 0;
 i21 = i26 + 40 | 0;
 i20 = i26 + 32 | 0;
 i11 = i26 + 24 | 0;
 i10 = i26 + 16 | 0;
 i7 = i26 + 8 | 0;
 i6 = i26;
 i3 = i26 + 224 | 0;
 i2 = i26 + 88 | 0;
 i18 = i26 + 240 | 0;
 i13 = i26 + 96 | 0;
 i9 = i26 + 80 | 0;
 i12 = i26 + 368 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 >> 1] = 2;
 HEAP16[i3 + 2 >> 1] = _htons(i15) | 0;
 i1 = _gethostbyname(i14 | 0) | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = _inet_addr(i14 | 0) | 0;
  i1 = _gethostbyaddr(i2 | 0, 4, 2) | 0;
  if (!i1) {
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  }
 }
 _memcpy(i3 + 4 | 0, HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
 i1 = _socket(2, 1, 0) | 0;
 i24 = i25 + 4 | 0;
 HEAP32[i24 >> 2] = i1;
 if ((i1 | 0) == -1) {
  i25 = 0;
  STACKTOP = i26;
  return i25 | 0;
 }
 i19 = i25 + 15 | 0;
 i4 = HEAP8[i19 >> 0] | 0;
 i5 = i4 << 24 >> 24 != 0;
 if (i4 << 24 >> 24) {
  HEAP32[i6 >> 2] = 0;
  i2 = _fcntl(i1, 3, i6) | 0 | 2048;
  i6 = HEAP32[i24 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  if ((_fcntl(i6, 4, i7) | 0) != -1) HEAP8[i19 >> 0] = 0;
 }
 if ((_connect(HEAP32[i24 >> 2] | 0, i3, 16) | 0) < 0) {
  i3 = ___errno_location() | 0;
  if ((HEAP32[i3 >> 2] | 0) != 115) {
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = i25 + 14 | 0;
   if ((i1 | 0) != -1) {
    if (HEAP8[i2 >> 0] | 0) {
     if ((HEAP8[i19 >> 0] | 0) != 1) {
      HEAP32[i10 >> 2] = 0;
      i22 = (_fcntl(i1, 3, i10) | 0) & -2049;
      i23 = HEAP32[i24 >> 2] | 0;
      HEAP32[i11 >> 2] = i22;
      if ((_fcntl(i23, 4, i11) | 0) != -1) HEAP8[i19 >> 0] = 1;
     }
     _shutdown(HEAP32[i24 >> 2] | 0, 2) | 0;
     i1 = HEAP32[i24 >> 2] | 0;
    }
    _close(i1) | 0;
    HEAP32[i24 >> 2] = -1;
   }
   HEAP8[i2 >> 0] = 0;
   HEAP16[i25 + 12 >> 1] = 0;
   HEAP32[i25 + 8 >> 2] = 0;
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  }
  i1 = i18;
  i2 = i1 + 128 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i1 = i13;
  i2 = i1 + 128 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i1 = HEAP32[i24 >> 2] | 0;
  i10 = 1 << (i1 & 31);
  i11 = i1 >>> 5;
  i7 = i18 + (i11 << 2) | 0;
  HEAP32[i7 >> 2] = i10 | HEAP32[i7 >> 2];
  i11 = i13 + (i11 << 2) | 0;
  HEAP32[i11 >> 2] = i10 | HEAP32[i11 >> 2];
  HEAP32[i9 >> 2] = (i8 >>> 0) / 1e3 | 0;
  HEAP32[i9 + 4 >> 2] = ((i8 >>> 0) % 1e3 | 0) * 1e3;
  i9 = _select(i1 + 1 | 0, 0, i18, i13, i9) | 0;
  i1 = HEAP32[i24 >> 2] | 0;
  i11 = i1 >>> 5;
  i10 = 1 << (i1 & 31);
  if (!((HEAP32[i18 + (i11 << 2) >> 2] & i10 | 0) != 0 & ((i9 | 0) == 1 ? (i10 & HEAP32[i13 + (i11 << 2) >> 2] | 0) == 0 : 0))) {
   i2 = i25 + 14 | 0;
   if ((i1 | 0) != -1) {
    if (HEAP8[i2 >> 0] | 0) {
     if ((HEAP8[i19 >> 0] | 0) != 1) {
      HEAP32[i20 >> 2] = 0;
      i22 = (_fcntl(i1, 3, i20) | 0) & -2049;
      i23 = HEAP32[i24 >> 2] | 0;
      HEAP32[i21 >> 2] = i22;
      if ((_fcntl(i23, 4, i21) | 0) != -1) HEAP8[i19 >> 0] = 1;
     }
     _shutdown(HEAP32[i24 >> 2] | 0, 2) | 0;
     i1 = HEAP32[i24 >> 2] | 0;
    }
    _close(i1) | 0;
    HEAP32[i24 >> 2] = -1;
   }
   HEAP8[i2 >> 0] = 0;
   HEAP16[i25 + 12 >> 1] = 0;
   HEAP32[i25 + 8 >> 2] = 0;
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  }
  if ((_recv(i1, i12, 0, 0) | 0) < 0) if ((HEAP32[i3 >> 2] | 0) != 11) {
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = i25 + 14 | 0;
   if ((i1 | 0) != -1) {
    if (HEAP8[i2 >> 0] | 0) {
     if ((HEAP8[i19 >> 0] | 0) != 1) {
      HEAP32[i22 >> 2] = 0;
      i21 = (_fcntl(i1, 3, i22) | 0) & -2049;
      i22 = HEAP32[i24 >> 2] | 0;
      HEAP32[i23 >> 2] = i21;
      if ((_fcntl(i22, 4, i23) | 0) != -1) HEAP8[i19 >> 0] = 1;
     }
     _shutdown(HEAP32[i24 >> 2] | 0, 2) | 0;
     i1 = HEAP32[i24 >> 2] | 0;
    }
    _close(i1) | 0;
    HEAP32[i24 >> 2] = -1;
   }
   HEAP8[i2 >> 0] = 0;
   HEAP16[i25 + 12 >> 1] = 0;
   HEAP32[i25 + 8 >> 2] = 0;
   i25 = 0;
   STACKTOP = i26;
   return i25 | 0;
  }
 }
 if (i4 << 24 >> 24 != (HEAP8[i19 >> 0] | 0)) {
  i23 = HEAP32[i24 >> 2] | 0;
  HEAP32[i16 >> 2] = 0;
  i23 = _fcntl(i23, 3, i16) | 0;
  i24 = HEAP32[i24 >> 2] | 0;
  HEAP32[i17 >> 2] = i5 ? i23 & -2049 : i23 | 2048;
  if ((_fcntl(i24, 4, i17) | 0) != -1) HEAP8[i19 >> 0] = i4;
 }
 HEAP8[i25 + 14 >> 0] = 1;
 HEAP16[i25 + 12 >> 1] = i15;
 HEAP32[i25 + 8 >> 2] = i14;
 i25 = 1;
 STACKTOP = i26;
 return i25 | 0;
}

function __Z27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i5, i7, i3, i9, f4, i8, i6, f1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 i8 = i8 | 0;
 i6 = i6 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 108 | 0;
 i13 = i2 + 48 | 0;
 i11 = i2 + 24 | 0;
 i12 = i2;
 i14 = i3 + 48 | 0;
 i15 = i3 + 36 | 0;
 __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i13, i14, i15, i3, i9, f4);
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i10, i13);
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 f30 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i13 + 36 >> 2]);
 f23 = Math_fround(HEAPF32[i13 + 40 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + 44 >> 2]);
 f17 = Math_fround(f1 + f1);
 f20 = Math_fround(f30 + f30);
 f27 = Math_fround(f28 + f28);
 f19 = Math_fround(f30 * f20);
 f24 = Math_fround(f28 * f27);
 f30 = Math_fround(f17 * f30);
 f29 = Math_fround(f17 * f28);
 f16 = Math_fround(f17 * f26);
 f28 = Math_fround(f20 * f28);
 f20 = Math_fround(f20 * f26);
 f26 = Math_fround(f27 * f26);
 f27 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f24);
 f25 = Math_fround(f30 + f26);
 f18 = Math_fround(f29 - f20);
 f26 = Math_fround(f30 - f26);
 f17 = Math_fround(Math_fround(1.0) - Math_fround(f1 * f17));
 f24 = Math_fround(f17 - f24);
 f1 = Math_fround(f28 + f16);
 f20 = Math_fround(f29 + f20);
 f16 = Math_fround(f28 - f16);
 f19 = Math_fround(f17 - f19);
 f17 = Math_fround(HEAPF32[i13 + 48 >> 2]);
 f27 = Math_fround(f27 * f17);
 f25 = Math_fround(f25 * f17);
 f17 = Math_fround(f18 * f17);
 f18 = Math_fround(HEAPF32[i13 + 52 >> 2]);
 f26 = Math_fround(f26 * f18);
 f24 = Math_fround(f24 * f18);
 f18 = Math_fround(f1 * f18);
 f1 = Math_fround(HEAPF32[i13 + 56 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f27))) + Math_fround(Math_abs(Math_fround(f26)))) + Math_fround(Math_abs(Math_fround(f20 * f1))));
 f16 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f25))) + Math_fround(Math_abs(Math_fround(f24)))) + Math_fround(Math_abs(Math_fround(f16 * f1))));
 f1 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f17))) + Math_fround(Math_abs(Math_fround(f18)))) + Math_fround(Math_abs(Math_fround(f19 * f1))));
 f19 = Math_fround(f23 - f16);
 f18 = Math_fround(f22 - f1);
 f17 = Math_fround(f21 + f20);
 f16 = Math_fround(f23 + f16);
 f1 = Math_fround(f22 + f1);
 HEAPF32[i11 >> 2] = Math_fround(f21 - f20);
 HEAPF32[i11 + 4 >> 2] = f19;
 HEAPF32[i11 + 8 >> 2] = f18;
 HEAPF32[i11 + 12 >> 2] = f17;
 HEAPF32[i11 + 16 >> 2] = f16;
 HEAPF32[i11 + 20 >> 2] = f1;
 HEAPF32[i8 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i10 >> 2] = gb + 84860 + 8;
 i13 = i10 + 96 | 0;
 HEAP16[i13 >> 1] = 0;
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 16 >> 2] = i5;
 HEAPF32[i12 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 8 >> 2]));
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 12 >> 2]));
 HEAPF32[i12 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAP32[i10 + 20 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i10 + 36 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i10 + 40 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i10 + 44 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i10 + 48 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i10 + 52 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i10 + 56 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 60 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i10 + 64 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i10 + 68 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 72 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i10 + 76 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i10 + 80 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 84 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 88 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAPF32[i10 + 92 >> 2] = f4;
 i6 = HEAP16[i6 >> 1] | 0;
 HEAP16[i13 >> 1] = i6;
 HEAP32[i10 + 4 >> 2] = i12;
 i9 = i10 + 16 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i10 + 8 >> 2] = i7;
 HEAP32[i10 + 12 >> 2] = i8;
 HEAP8[i10 + 98 >> 0] = ((HEAPU8[i5 + 20 >> 0] | 0) >>> 1 | (i6 & 65535) >>> 7 & 255) & 1;
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i12, i7, i11, 1, i10) | 0;
 STACKTOP = i2;
 return (HEAP8[i9 >> 0] | 0) != 0 | 0;
}

function __ZN15NavMeshObstacle10FitExtentsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch (HEAP32[i2 + 40 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (!i1) i4 = 5; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i3) | 0) {
    f6 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f7 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f10 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f6 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround((f6 < f10 ? f10 : f6) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f7 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f7 / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f10 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f9 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f8 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    HEAPF32[i2 + 44 >> 2] = f10;
    HEAPF32[i2 + 48 >> 2] = f9;
    HEAPF32[i2 + 52 >> 2] = f8;
    i3 = i2 + 136 | 0;
    i1 = HEAP32[i3 >> 2] | 8;
    HEAPF32[i2 + 56 >> 2] = f6;
    HEAPF32[i2 + 60 >> 2] = f7;
    HEAPF32[i2 + 64 >> 2] = f6;
    HEAP32[i3 >> 2] = i1;
   } else i4 = 5;
   if ((i4 | 0) == 5) {
    i4 = i2 + 44 | 0;
    HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    i4 = i2 + 136 | 0;
    i3 = HEAP32[i4 >> 2] | 8;
    i2 = i2 + 56 | 0;
    HEAP32[i2 >> 2] = HEAP32[gb + 169016 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[gb + 169016 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[gb + 169016 + 8 >> 2];
    HEAP32[i4 >> 2] = i3;
   }
   STACKTOP = i5;
   return;
  }
 case 1:
  {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (!i1) i4 = 10; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i3) | 0) {
    f10 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f9 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f8 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    HEAPF32[i2 + 44 >> 2] = f10;
    HEAPF32[i2 + 48 >> 2] = f9;
    HEAPF32[i2 + 52 >> 2] = f8;
    i1 = i2 + 136 | 0;
    i11 = HEAP32[i1 >> 2] | 8;
    f8 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f9 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    f10 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) / Math_fround(.00100000005)) + Math_fround(.5)))) * Math_fround(.00100000005));
    HEAPF32[i2 + 56 >> 2] = f8;
    HEAPF32[i2 + 60 >> 2] = f9;
    HEAPF32[i2 + 64 >> 2] = f10;
    HEAP32[i1 >> 2] = i11;
   } else i4 = 10;
   if ((i4 | 0) == 10) {
    i11 = i2 + 44 | 0;
    HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    i11 = i2 + 136 | 0;
    i4 = HEAP32[i11 >> 2] | 8;
    i3 = i2 + 56 | 0;
    HEAP32[i3 >> 2] = HEAP32[gb + 169028 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[gb + 169028 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[gb + 169028 + 8 >> 2];
    HEAP32[i11 >> 2] = i4;
   }
   STACKTOP = i5;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 842542 | 0, 0, gb + 842572 | 0, 169, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
   STACKTOP = i5;
   return;
  }
 }
}

function _jinit_color_converter(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i4 + 4 >> 2] >> 2] | 0, i4 | 0, 1, 12) | 0;
 HEAP32[i4 + 336 >> 2] = i5;
 HEAP32[i5 >> 2] = fb + 3258;
 i2 = i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   if ((HEAP32[i4 + 36 >> 2] | 0) != 1) {
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = 9;
    mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
   }
   break;
  }
 case 15:
 case 14:
 case 13:
 case 12:
 case 11:
 case 10:
 case 9:
 case 8:
 case 7:
 case 6:
 case 2:
  {
   if ((HEAP32[i4 + 36 >> 2] | 0) != (HEAP32[gb + 16264 + (i1 << 2) >> 2] | 0)) {
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = 9;
    mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
   }
   break;
  }
 case 3:
  {
   if ((HEAP32[i4 + 36 >> 2] | 0) != 3) {
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = 9;
    mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
   }
   break;
  }
 case 5:
 case 4:
  {
   if ((HEAP32[i4 + 36 >> 2] | 0) != 4) {
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = 9;
    mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
   }
   break;
  }
 default:
  if ((HEAP32[i4 + 36 >> 2] | 0) < 1) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 9;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
  }
 }
 i1 = HEAP32[i4 + 64 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   if ((HEAP32[i4 + 60 >> 2] | 0) != 1) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   switch (HEAP32[i2 >> 2] | 0) {
   case 1:
    {
     HEAP32[i5 + 4 >> 2] = fb + 97;
     return;
    }
   case 15:
   case 14:
   case 13:
   case 12:
   case 11:
   case 10:
   case 9:
   case 8:
   case 7:
   case 6:
   case 2:
    if (!(_jsimd_can_rgb_gray() | 0)) {
     HEAP32[i5 >> 2] = fb + 3259;
     HEAP32[i5 + 4 >> 2] = fb + 99;
     return;
    } else {
     HEAP32[i5 + 4 >> 2] = fb + 98;
     return;
    }
   case 3:
    {
     HEAP32[i5 + 4 >> 2] = fb + 97;
     return;
    }
   default:
    {
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i5 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
     return;
    }
   }
  }
 case 2:
  {
   if ((HEAP32[i4 + 60 >> 2] | 0) != 3) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   i1 = HEAP32[i2 >> 2] | 0;
   if (4292 >>> i1 & 1 | 0) if (13252 >>> i1 & 1 | 0) if (324 >>> i1 & 1 | 0) {
    HEAP32[i5 + 4 >> 2] = fb + 100;
    return;
   }
   switch (i1 | 0) {
   case 15:
   case 14:
   case 13:
   case 12:
   case 11:
   case 10:
   case 9:
   case 8:
   case 7:
   case 6:
   case 2:
    {
     HEAP32[i5 + 4 >> 2] = fb + 101;
     return;
    }
   default:
    {
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i5 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
     return;
    }
   }
  }
 case 3:
  {
   if ((HEAP32[i4 + 60 >> 2] | 0) != 3) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   switch (HEAP32[i2 >> 2] | 0) {
   case 15:
   case 14:
   case 13:
   case 12:
   case 11:
   case 10:
   case 9:
   case 8:
   case 7:
   case 6:
   case 2:
    if (!(_jsimd_can_rgb_ycc() | 0)) {
     HEAP32[i5 >> 2] = fb + 3259;
     HEAP32[i5 + 4 >> 2] = fb + 103;
     return;
    } else {
     HEAP32[i5 + 4 >> 2] = fb + 102;
     return;
    }
   case 3:
    {
     HEAP32[i5 + 4 >> 2] = fb + 100;
     return;
    }
   default:
    {
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i5 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
     return;
    }
   }
  }
 case 4:
  {
   if ((HEAP32[i4 + 60 >> 2] | 0) != 4) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   if ((HEAP32[i2 >> 2] | 0) == 4) {
    HEAP32[i5 + 4 >> 2] = fb + 100;
    return;
   } else {
    i5 = HEAP32[i4 >> 2] | 0;
    HEAP32[i5 + 20 >> 2] = 27;
    mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
    return;
   }
  }
 case 5:
  {
   if ((HEAP32[i4 + 60 >> 2] | 0) != 4) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   switch (HEAP32[i2 >> 2] | 0) {
   case 4:
    {
     HEAP32[i5 >> 2] = fb + 3259;
     HEAP32[i5 + 4 >> 2] = fb + 104;
     return;
    }
   case 5:
    {
     HEAP32[i5 + 4 >> 2] = fb + 100;
     return;
    }
   default:
    {
     i5 = HEAP32[i4 >> 2] | 0;
     HEAP32[i5 + 20 >> 2] = 27;
     mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
     return;
    }
   }
  }
 default:
  {
   if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
    if ((HEAP32[i4 + 60 >> 2] | 0) != (HEAP32[i4 + 36 >> 2] | 0)) i3 = 52;
   } else i3 = 52;
   if ((i3 | 0) == 52) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 27;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   }
   HEAP32[i5 + 4 >> 2] = fb + 100;
   return;
  }
 }
}

function __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb(i19, i1, i15, i10, i16, i13, i18, i20) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 24 | 0;
 i21 = i25 + 12 | 0;
 i14 = i25;
 i11 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0;
 i11 = (i11 | 0) > (i1 | 0) ? i1 : i11;
 HEAP32[i23 >> 2] = 0;
 i24 = i23 + 4 | 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 if (i15 | 0) __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i23, i15);
 HEAP32[i21 >> 2] = 0;
 i22 = i21 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i12 = (i15 | 0) > 0;
 do if (i12) {
  i4 = i21 + 8 | 0;
  i3 = 0;
  do {
   i5 = i10 + (i3 << 2) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i2;
   do if (!i2) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i16 + 4 >> 2] = 0;
    HEAP32[i16 + 8 >> 2] = 0;
    HEAP32[i16 + 12 >> 2] = 0;
    HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] = -1;
   } else {
    i1 = HEAP32[i21 >> 2] | 0;
    i7 = HEAP32[i22 >> 2] | 0;
    i8 = i1;
    i9 = i7;
    L11 : do if ((i1 | 0) == (i7 | 0)) i17 = 11; else do {
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
      i17 = 11;
      break L11;
     }
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i7 | 0)); while (0);
    if ((i17 | 0) == 11) {
     i17 = 0;
     if ((i1 | 0) != (i7 | 0)) {
      HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] = i1 - i8 >> 2;
      break;
     }
    }
    HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 << 2) >> 2] = i9 - i8 >> 2;
    if ((i7 | 0) == (HEAP32[i4 >> 2] | 0)) {
     __ZNSt3__26vectorIP9Texture2DNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i21, i5);
     break;
    } else {
     HEAP32[i7 >> 2] = i6;
     HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 4;
     break;
    }
   } while (0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i15 | 0));
  i9 = HEAP32[i21 >> 2] | 0;
  i10 = HEAP32[i22 >> 2] | 0;
  i1 = i10;
  i3 = i9;
  if ((i9 | 0) == (i10 | 0)) i17 = 31; else {
   HEAP32[i14 >> 2] = 0;
   i5 = i14 + 4 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   i2 = i1 - i3 >> 2;
   if (!i2) {
    i2 = i3;
    i3 = 0;
   } else {
    __ZNSt3__26vectorI5RectTIfENS_9allocatorIS2_EEE8__appendEj(i14, i2);
    i1 = HEAP32[i22 >> 2] | 0;
    i2 = HEAP32[i21 >> 2] | 0;
    i3 = HEAP32[i14 >> 2] | 0;
   }
   if (!(__Z16PackTextureAtlasP9Texture2DiiPS0_P5RectTIfEiNS_10EInitFlagsE(i19, i11, i1 - i2 >> 2, i2, i3, i13, 0) | 0)) {
    i1 = HEAP32[i14 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = HEAP32[i5 >> 2] | 0;
     if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -16 - i2 | 0) >>> 4) << 4);
     __ZdlPv(i1);
    }
    i4 = 0;
    break;
   }
   if (i12) {
    i4 = HEAP32[i23 >> 2] | 0;
    i1 = HEAP32[i14 >> 2] | 0;
    i2 = 0;
    do {
     i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
     if ((i3 | 0) != -1) {
      i17 = i16 + (i2 << 4) | 0;
      i14 = i1 + (i3 << 4) | 0;
      HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i15 | 0));
   } else i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i5 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -16 - i2 | 0) >>> 4) << 4);
    __ZdlPv(i1);
   }
   i17 = 31;
  }
 } else i17 = 31; while (0);
 if ((i17 | 0) == 31) if (i18) {
  i1 = HEAP32[i19 + 52 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i19 + 92 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 5 : i1;
  } else i1 = HEAP32[i1 + 36 >> 2] | 0;
  do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
   i2 = i1 + -30 | 0;
   if (i2 >>> 0 < 15) {
    if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
   } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break;
   mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 200 >> 2] | 0, i19 | 0);
  } while (0);
  if (i20) {
   HEAP8[i19 + 111 >> 0] = 0;
   HEAP8[i19 + 112 >> 0] = 0;
  }
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, 0);
  i4 = 1;
 } else i4 = 1;
 i1 = HEAP32[i21 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i22 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i22 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i23 >> 2] | 0;
 if (!i1) {
  STACKTOP = i25;
  return i4 | 0;
 }
 i2 = HEAP32[i24 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i24 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i25;
 return i4 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i17, i11, i1) {
 i17 = i17 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i5 = i16 + 8 | 0;
 i7 = i11 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i5) | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) i2 = 15; else {
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? i4 : i2;
 }
 if (i2 >>> 0 < i3 >>> 0) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i11, i3);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i6 = i11 + 4 | 0;
 HEAP8[((i1 | 0) == 0 ? i6 : i1) + i3 >> 0] = 0;
 if (i3 >>> 0 > i4 >>> 0) {
  i14 = HEAP32[i11 >> 2] | 0;
  _memset(((i14 | 0) == 0 ? i6 : i14) + i4 | 0, 1, i3 - i4 | 0) | 0;
 }
 i4 = i11 + 4 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) if (!(HEAP32[i11 >> 2] | 0)) i1 = 0; else {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i11, HEAP32[i7 >> 2] | 0);
  i12 = 11;
 } else i12 = 11;
 if ((i12 | 0) == 11) i1 = HEAP32[i11 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i14 = (i2 ? i6 : i1) + i3 | 0;
 do if (HEAP32[i5 >> 2] | 0) {
  if (!(i2 | (HEAP32[i4 >> 2] | 0) != 0)) __ZN4core20StringStorageDefaultIcE10reallocateEj(i11, i3);
  i8 = HEAP32[gb + 36976 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i17 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   if (!((HEAP32[i4 >> 2] | 0) != 0 | (i1 | 0) == 0)) {
    __ZN4core20StringStorageDefaultIcE10reallocateEj(i11, HEAP32[i7 >> 2] | 0);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i1 = (i1 | 0) == 0 ? i6 : i1;
   if ((i1 | 0) != (i14 | 0)) {
    i3 = i17 + 16 | 0;
    i4 = i17 + 20 | 0;
    i5 = i17 + 32 | 0;
    i6 = i17 + 36 | 0;
    i7 = i17 + 24 | 0;
    do {
     i18 = (Math_imul(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i9) | 0) + i8 | 0;
     i11 = HEAP32[i13 >> 2] | 0;
     HEAP32[i11 + 20 >> 2] = i18;
     HEAP32[i11 + 12 >> 2] = i18;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i11);
     i18 = i15;
     i2 = HEAP32[i18 + 4 >> 2] | 0;
     i11 = i11 + 24 | 0;
     HEAP32[i11 >> 2] = HEAP32[i18 >> 2];
     HEAP32[i11 + 4 >> 2] = i2;
     i11 = HEAP32[i10 >> 2] | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i11 = HEAP32[i4 >> 2] | 0;
     i2 = i11 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i3 >> 2] = i2;
     if (i2 >>> 0 < i11 >>> 0) i12 = 23; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) i12 = 23; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 23) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i14 | 0));
   }
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i11 >> 2] | 0;
  if (!((HEAP32[i4 >> 2] | 0) != 0 | (i1 | 0) == 0)) {
   __ZN4core20StringStorageDefaultIcE10reallocateEj(i11, HEAP32[i7 >> 2] | 0);
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i1 = (i1 | 0) == 0 ? i6 : i1;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i18 = HEAP32[i4 >> 2] | 0;
      i2 = i18 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i18 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN8VRDevice11EarlyUpdateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 32 | 0;
 i13 = i14 + 16 | 0;
 i11 = i14;
 i5 = i10 + 297 | 0;
 i4 = (HEAP8[i5 >> 0] | 0) != 0;
 i2 = i10 + 8 | 0;
 i1 = HEAP32[i10 + 272 >> 2] | 0;
 if (i1 | 0) if (mftCall_i(i1 | 0) | 0) {
  __ZN8VRDevice21StopRenderingToDeviceEv(i10);
  __ZN8VRDevice22StartRenderingToDeviceEv(i10);
 }
 if ((HEAP16[gb + 1469372 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469372 | 0, i12);
  i3 = gb + 1469372 | 0;
 } else i3 = 0;
 HEAP8[i5 >> 0] = 0;
 i6 = i10 + 4 | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 268 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = (mftCall_i(i1 | 0) | 0) & 1;
  HEAP8[i5 >> 0] = i1;
 }
 if (i3) {
  __Z12profiler_endP19ProfilerInformation(i3);
  i1 = HEAP8[i5 >> 0] | 0;
 }
 do if (i4 ^ i1 << 24 >> 24 != 0) {
  if (i4) {
   i3 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   break;
  }
  i3 = HEAP32[i10 + 216 >> 2] | 0;
  if (i3) {
   mftCall_vi(i3 | 0, i2 | 0);
   i1 = HEAP8[i5 >> 0] | 0;
  }
 } while (0);
 if (!(i1 << 24 >> 24)) {
  if (HEAP8[i10 + 299 >> 0] | 0) __ZN8VRDevice21StopRenderingToDeviceEv(i10);
  if (!(HEAP8[i10 + 296 >> 0] | 0)) {
   STACKTOP = i14;
   return;
  }
  HEAP8[i10 + 298 >> 0] = 1;
  STACKTOP = i14;
  return;
 }
 i7 = i10 + 298 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i13 >> 2] = 0;
 i8 = i13 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i9 = 24;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i9 = 26;
  }
 } else i9 = 24;
 if ((i9 | 0) == 24) {
  i6 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i9 = 26;
 }
 if ((i9 | 0) == 26) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i13 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i13, i11);
  i1 = i11 + 11 | 0;
 } else {
  i1 = i11 + 11 | 0;
  i5 = HEAP8[i1 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i5 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i9 = 31;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (i5) i9 = 33;
  } else i9 = 31;
  if ((i9 | 0) == 31) {
   i15 = i5 + 16 & -16;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i12 + 4 >> 2] = i3;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i6;
   HEAP32[i2 + 8 >> 2] = i15 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i6;
   i9 = 33;
  }
  if ((i9 | 0) == 33) _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i2 + i5 >> 0] = 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 16;
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i15 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
 }
 __ZN8VRDevice21RequestReloadVRDeviceERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i13, (HEAP8[i10 + 296 >> 0] | 0) != 0);
 HEAP8[i7 >> 0] = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i4 = i12 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i8 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i15 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i4 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
     i2 = HEAP32[i8 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i13 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i14;
 return;
}

function _jnf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, i4 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = i7 >>> 31;
 i9 = i7 & 2147483647;
 do if (i9 >>> 0 <= 2139095040) {
  if (!i5) {
   f1 = Math_fround(_j0f(f1));
   break;
  }
  if ((i5 | 0) < 0) {
   f1 = Math_fround(-f1);
   i4 = i4 ^ 1;
   i12 = ~i5;
  } else i12 = i5 + -1 | 0;
  if (!i12) {
   f1 = Math_fround(_j1f(f1));
   break;
  }
  i14 = i4 & i5;
  f13 = Math_fround(Math_abs(Math_fround(f1)));
  L13 : do if ((i7 | 0) < 0) if ((i7 | 0) < -8388608) switch (i7 | 0) {
  case -2147483648:
   {
    f1 = Math_fround(0.0);
    break L13;
   }
  default:
   {
    i11 = 10;
    break L13;
   }
  } else switch (i7 | 0) {
  case -8388608:
   {
    f1 = Math_fround(0.0);
    break L13;
   }
  default:
   {
    i11 = 10;
    break L13;
   }
  } else if ((i7 | 0) < 2139095040) switch (i7 | 0) {
  case 0:
   {
    f1 = Math_fround(0.0);
    break L13;
   }
  default:
   {
    i11 = 10;
    break L13;
   }
  } else switch (i7 | 0) {
  case 2139095040:
   {
    f1 = Math_fround(0.0);
    break L13;
   }
  default:
   {
    i11 = 10;
    break L13;
   }
  } while (0);
  L22 : do if ((i11 | 0) == 10) {
   f1 = Math_fround(i12 | 0);
   if (f1 < f13) {
    f2 = Math_fround(_j0f(f13));
    f1 = Math_fround(_j1f(f13));
    if ((i12 | 0) > 0) i4 = 0; else break;
    while (1) {
     i4 = i4 + 1 | 0;
     f2 = Math_fround(Math_fround(f1 * Math_fround(Math_fround(Math_fround(i4 | 0) * Math_fround(2.0)) / f13)) - f2);
     if ((i4 | 0) == (i12 | 0)) {
      f1 = f2;
      break L22;
     } else {
      f10 = f1;
      f1 = f2;
      f2 = f10;
     }
    }
   }
   if (i9 >>> 0 < 897581056) {
    i5 = (i12 | 0) > 8 ? 8 : i12;
    f2 = Math_fround(f13 * Math_fround(.5));
    if ((i5 + 1 | 0) < 2) f1 = Math_fround(1.0); else {
     f3 = f2;
     f1 = Math_fround(1.0);
     i4 = 2;
     while (1) {
      f1 = Math_fround(f1 * Math_fround(i4 | 0));
      f3 = Math_fround(f2 * f3);
      if ((i4 | 0) > (i5 | 0)) {
       f2 = f3;
       break;
      } else i4 = i4 + 1 | 0;
     }
    }
    f1 = Math_fround(f2 / f1);
    break;
   }
   f8 = Math_fround(f1 + Math_fround(1.0));
   f10 = Math_fround(Math_fround(f8 * Math_fround(2.0)) / f13);
   f6 = Math_fround(Math_fround(2.0) / f13);
   f1 = Math_fround(f10 + f6);
   f2 = Math_fround(Math_fround(f10 * f1) + Math_fround(-1.0));
   if (f2 < Math_fround(1.0e4)) {
    f3 = f10;
    i5 = 1;
    while (1) {
     i4 = i5 + 1 | 0;
     f1 = Math_fround(f6 + f1);
     f3 = Math_fround(Math_fround(f2 * f1) - f3);
     if (!(f3 < Math_fround(1.0e4))) break; else {
      f15 = f2;
      f2 = f3;
      i5 = i4;
      f3 = f15;
     }
    }
    if ((i5 | 0) > -2) {
     f1 = Math_fround(0.0);
     i11 = 20;
    } else f3 = Math_fround(0.0);
   } else {
    f1 = Math_fround(0.0);
    i4 = 1;
    i11 = 20;
   }
   if ((i11 | 0) == 20) while (1) {
    f1 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_fround(f8 + Math_fround(i4 | 0)) * Math_fround(2.0)) / f13) - f1));
    if ((i4 | 0) > 0) {
     i4 = i4 + -1 | 0;
     i11 = 20;
    } else {
     f3 = f1;
     break;
    }
   }
   i4 = (i12 | 0) > 0;
   if (Math_fround(f8 * Math_fround(+Math_log(+Math_fround(Math_abs(Math_fround(f10)))))) < Math_fround(88.7216796)) if (i4) {
    f2 = Math_fround(1.0);
    f1 = f3;
    i4 = i12;
    while (1) {
     f1 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i4 | 0) * Math_fround(2.0)) * f2) / f13) - f1);
     if ((i4 | 0) > 1) {
      f15 = f2;
      f2 = f1;
      i4 = i4 + -1 | 0;
      f1 = f15;
     } else {
      f8 = f3;
      f6 = f1;
      break;
     }
    }
   } else {
    f8 = f3;
    f6 = Math_fround(1.0);
    f2 = f3;
   } else if (i4) {
    f2 = f3;
    f6 = Math_fround(1.0);
    f1 = f3;
    i4 = i12;
    while (1) {
     f1 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(i4 | 0) * Math_fround(2.0)) * f6) / f13) - f1);
     if (f1 > Math_fround(11529215.0e11)) {
      f2 = Math_fround(f2 / f1);
      f3 = Math_fround(1.0);
      f1 = Math_fround(f6 / f1);
     } else {
      f3 = f1;
      f1 = f6;
     }
     if ((i4 | 0) > 1) {
      f6 = f3;
      i4 = i4 + -1 | 0;
     } else {
      f8 = f2;
      f6 = f3;
      f2 = f1;
      break;
     }
    }
   } else {
    f8 = f3;
    f6 = Math_fround(1.0);
    f2 = f3;
   }
   f3 = Math_fround(_j0f(f13));
   f1 = Math_fround(_j1f(f13));
   if (!(Math_fround(Math_abs(Math_fround(f3))) >= Math_fround(Math_abs(Math_fround(f1))))) {
    f1 = Math_fround(Math_fround(f8 * f1) / f2);
    break;
   } else {
    f1 = Math_fround(Math_fround(f8 * f3) / f6);
    break;
   }
  } while (0);
  f15 = Math_fround(-f1);
  f1 = i14 | 0 ? f15 : f1;
 } while (0);
 return Math_fround(f1);
}

function __ZN13SliderJoint2D8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i10 = i7 + 118 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802905 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i10, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i6 = i7 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803298 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i4 = 15; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i4 = 15; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 15) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803251 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803262 | 0, gb + 803270 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_(i4, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 117 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802926 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802938 | 0, gb + 802958 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN24JointTranslationLimits2D8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0) {
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(-90.0));
  STACKTOP = i11;
  return;
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 3) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i10 >> 0] = 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.0174532924));
 STACKTOP = i11;
 return;
}

function __Z20ParseImageParametersR11UTF16StringRiRN20TextRenderingPrivate16TextFormatChangeE(i10, i11, i2) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i34 = i36 + 24 | 0;
 i33 = i36 + 16 | 0;
 i32 = i36 + 8 | 0;
 i31 = i36;
 i25 = i36 + 76 | 0;
 i26 = i36 + 64 | 0;
 i27 = i36 + 52 | 0;
 i28 = i36 + 40 | 0;
 i29 = i36 + 28 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i30 = i10 + 4 | 0;
 i3 = HEAP32[i30 >> 2] | 0;
 if ((i1 | 0) >= (i3 | 0)) {
  STACKTOP = i36;
  return;
 }
 i12 = i2 + 40 | 0;
 i13 = i25 + 11 | 0;
 i14 = i2 + 20 | 0;
 i15 = i25 + 11 | 0;
 i16 = i2 + 16 | 0;
 i17 = i2 + 12 | 0;
 i18 = i26 + 11 | 0;
 i19 = i2 + 24 | 0;
 i20 = i27 + 11 | 0;
 i21 = i2 + 28 | 0;
 i22 = i28 + 11 | 0;
 i23 = i2 + 32 | 0;
 i24 = i29 + 11 | 0;
 i9 = i2 + 36 | 0;
 while (1) {
  i8 = HEAP32[i10 >> 2] | 0;
  if ((HEAP16[i8 + (i1 << 1) >> 1] | 0) == 62) {
   i35 = 21;
   break;
  } else i2 = 0;
  while (1) {
   i7 = HEAP32[gb + 185396 + (i2 << 2) >> 2] | 0;
   i4 = HEAP8[i7 >> 0] | 0;
   L8 : do if (!(i4 << 24 >> 24)) i35 = 8; else {
    i6 = 0;
    while (1) {
     i5 = i6 + i1 | 0;
     if ((i5 | 0) == (i3 | 0)) break L8;
     i37 = HEAP16[i8 + (i5 << 1) >> 1] & 255;
     i5 = i37 << 24 >> 24;
     i6 = i6 + 1 | 0;
     if ((((i37 + -65 & 255) < 26 ? i5 + 32 | 0 : i5) & 255) << 24 >> 24 != i4 << 24 >> 24) break L8;
     i4 = HEAP8[i7 + i6 >> 0] | 0;
     if (!(i4 << 24 >> 24)) {
      i35 = 8;
      break;
     }
    }
   } while (0);
   if ((i35 | 0) == 8) {
    i35 = 0;
    i4 = (_strlen(i7) | 0) + i1 | 0;
    if ((HEAP16[i8 + (i4 << 1) >> 1] | 0) == 61) {
     i35 = 10;
     break;
    }
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= 10) {
    i35 = 20;
    break;
   }
  }
  L16 : do if ((i35 | 0) == 10) {
   i35 = 0;
   HEAP32[i11 >> 2] = i4;
   switch (i2 | 0) {
   case -1:
    {
     i1 = i4;
     i35 = 20;
     break L16;
    }
   case 4:
    {
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 16;
     __Z12GetParameterR11UTF16StringRib(i25, i10, i11, 1);
     HEAP32[i14 >> 2] = __Z11StringToIntPKc((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
     break L16;
    }
   case 3:
    {
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 8;
     __Z12GetParameterR11UTF16StringRib(i25, i10, i11, 1);
     HEAP32[i16 >> 2] = __Z11StringToIntPKc((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i25 >> 2] | 0 : i25) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
     break L16;
    }
   case 2:
    {
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 4;
     __Z12GetParameterR11UTF16StringRib(i25, i10, i11, 1);
     i37 = __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32(i25, i17) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
     if (i37) break L16;
     HEAP32[i17 >> 2] = -1;
     break L16;
    }
   case 6:
    {
     __Z12GetParameterR11UTF16StringRib(i26, i10, i11, 1);
     i37 = (HEAP8[i18 >> 0] | 0) < 0 ? HEAP32[i26 >> 2] | 0 : i26;
     HEAP32[i31 >> 2] = i19;
     _sscanf(i37, gb + 1084516 | 0, i31) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i26);
     break L16;
    }
   case 7:
    {
     __Z12GetParameterR11UTF16StringRib(i27, i10, i11, 1);
     i37 = (HEAP8[i20 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27;
     HEAP32[i32 >> 2] = i21;
     _sscanf(i37, gb + 1084516 | 0, i32) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
     break L16;
    }
   case 8:
    {
     __Z12GetParameterR11UTF16StringRib(i28, i10, i11, 1);
     i37 = (HEAP8[i22 >> 0] | 0) < 0 ? HEAP32[i28 >> 2] | 0 : i28;
     HEAP32[i33 >> 2] = i23;
     _sscanf(i37, gb + 1084516 | 0, i33) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i28);
     break L16;
    }
   case 9:
    {
     __Z12GetParameterR11UTF16StringRib(i29, i10, i11, 1);
     i37 = (HEAP8[i24 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29;
     HEAP32[i34 >> 2] = i9;
     _sscanf(i37, gb + 1084516 | 0, i34) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
     break L16;
    }
   default:
    break L16;
   }
  } while (0);
  if ((i35 | 0) == 20) {
   i35 = 0;
   HEAP32[i11 >> 2] = i1 + 1;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i30 >> 2] | 0;
  if ((i1 | 0) >= (i3 | 0)) {
   i35 = 21;
   break;
  }
 }
 if ((i35 | 0) == 21) {
  STACKTOP = i36;
  return;
 }
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 34;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS4_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 34;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN22MotionVectorRenderLoop16PerformRenderingER8JobFence(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i21 + 8 | 0;
 i15 = i21;
 i10 = i5 + 8 | 0;
 if ((HEAP16[gb + 1114948 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114948 | 0, i3);
  i19 = gb + 1114948 | 0;
 } else i19 = 0;
 i7 = HEAP32[gb + 1114948 >> 2] | 0;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 648 >> 2] | 0, i8 | 0, i7 | 0);
 i7 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[gb + 1166248 >> 2] | 0;
 i20 = __Z22GetJobQueueThreadCountv() | 0;
 i20 = (i20 | 0) > 1 ? i20 : 1;
 i9 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = ((i9 >>> 0) / (i20 >>> 0) | 0) + 1 | 0;
 i4 = i4 >>> 0 > 128 ? i4 : 128;
 i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i20 << 2, 16, gb + 64024 | 0, 0, gb + 388055 | 0, 314) | 0;
 i18 = 0;
 i1 = 0;
 do {
  i11 = i1 + i4 | 0;
  i2 = i1;
  i1 = i9 >>> 0 < i11 >>> 0 ? i9 : i11;
  i11 = __ZnwjRK10MemLabelIdiPKci(184, gb + 64024 | 0, 16, gb + 388055 | 0, 321) | 0;
  HEAP32[i11 + 4 >> 2] = 1;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 >> 2] = gb + 36828 + 8;
  i12 = i11 + 12 | 0;
  i13 = i11 + 48 | 0;
  i14 = i11 + 52 | 0;
  i16 = i12;
  i17 = i16 + 36 | 0;
  do {
   HEAP32[i16 >> 2] = 0;
   i16 = i16 + 4 | 0;
  } while ((i16 | 0) < (i17 | 0));
  HEAP32[i14 >> 2] = 1;
  HEAP32[i13 >> 2] = gb + 33952 + 8;
  i14 = gb + 64024 | 0;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i15;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i11 + 80 >> 2] = 0;
  HEAP32[i11 + 92 >> 2] = 0;
  HEAP32[i11 + 96 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i15);
  i16 = i3;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i11 + 84 | 0;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i17;
  i14 = gb + 64024 | 0;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i15;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i11 + 100 >> 2] = 0;
  HEAP32[i11 + 112 >> 2] = 0;
  HEAP32[i11 + 116 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i15);
  i16 = i3;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i11 + 104 | 0;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i17;
  i14 = gb + 64024 | 0;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i15;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i11 + 120 >> 2] = 0;
  HEAP32[i11 + 132 >> 2] = 0;
  HEAP32[i11 + 136 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i15);
  i16 = i3;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i11 + 124 | 0;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i17;
  HEAP32[i11 + 140 >> 2] = 0;
  HEAP32[i11 + 144 >> 2] = 0;
  i14 = gb + 64024 | 0;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i11 + 148 | 0;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  i16 = i11 + 156 | 0;
  HEAP8[i16 >> 0] = 1;
  i17 = i11 + 56 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i17 + 16 >> 2] = 0;
  HEAP32[i17 + 20 >> 2] = 0;
  HEAP8[i11 + 160 >> 0] = 1;
  HEAP8[i11 + 161 >> 0] = 0;
  i17 = i11 + 164 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i17 + 16 >> 2] = 0;
  i14 = i18;
  i18 = i18 + 1 | 0;
  HEAP32[i20 + (i14 << 2) >> 2] = i11;
  __ZN17ShaderPassContext8CopyFromERKS_(i12, i8);
  HEAP8[i16 >> 0] = 0;
  i16 = HEAP32[i10 >> 2] | 0;
  i14 = i16 + 4 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  HEAP32[i11 + 168 >> 2] = i2;
  HEAP32[i11 + 172 >> 2] = i1;
  HEAP32[i17 >> 2] = i16;
  HEAP32[i11 + 176 >> 2] = 0;
  HEAP32[i11 + 180 >> 2] = 2501;
 } while (i1 >>> 0 < i9 >>> 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 892 >> 2] | 0, i7 | 0, i18 | 0, fb + 2393 | 0, i20 | 0, i5 | 0, i6 | 0);
 if (i18 | 0) {
  i1 = 0;
  do {
   i2 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
   i17 = i2 + 4 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
   if (!(HEAP32[i17 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i18 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
 i20 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 652 >> 2] | 0, i20 | 0);
 if (!i19) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i21;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i16, i8, i1) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i7 = i15 + 8 | 0;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i16 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 1, 2, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 1) | 0, 0, i5 - i4 << 1 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 1) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i9 = HEAP32[gb + 37240 >> 2] | 0;
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 17; else {
      i3 = i2 + 2 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 17; else {
       HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 17) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 2);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
     i1 = i1 + 2 | 0;
     if ((i1 | 0) == (i13 | 0)) break L20;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 30; else {
       i3 = i2 + 2 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 30; else {
        HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 30) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 2);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 2 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __Z26TransformVerticesInnerLoopILb1ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i5, i10, i18, i6, i3, i33, i34, i35, i4, i36, i2, i1) {
 i5 = i5 | 0;
 i10 = i10 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i35 = i35 | 0;
 i4 = i4 | 0;
 i36 = i36 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i11 = (i2 | 0) / 4 | 0;
 if (!i6) return;
 i12 = i10 + 16 | 0;
 i13 = i10 + 32 | 0;
 i14 = i10 + 48 | 0;
 i15 = i10 + 4 | 0;
 i16 = i10 + 20 | 0;
 i17 = i10 + 36 | 0;
 i19 = i10 + 52 | 0;
 i20 = i10 + 8 | 0;
 i21 = i10 + 24 | 0;
 i22 = i10 + 40 | 0;
 i23 = i10 + 56 | 0;
 i24 = i18 + 12 | 0;
 i25 = i18 + 24 | 0;
 i26 = i18 + 4 | 0;
 i27 = i18 + 16 | 0;
 i28 = i18 + 28 | 0;
 i29 = i18 + 8 | 0;
 i30 = i18 + 20 | 0;
 i31 = i18 + 32 | 0;
 i32 = (i1 & 2 | 0) == 0;
 i9 = (i1 & 4 | 0) == 0;
 i8 = (i2 | 0) > 3;
 i7 = i4;
 i2 = i5;
 while (1) {
  i6 = i6 + -1 | 0;
  f37 = Math_fround(HEAPF32[i10 >> 2]);
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i3 >> 2]));
  f38 = Math_fround(HEAPF32[i12 >> 2]);
  i5 = i3 + 4 | 0;
  f39 = Math_fround(HEAPF32[i5 >> 2]);
  f38 = Math_fround(f37 + Math_fround(f38 * f39));
  f37 = Math_fround(HEAPF32[i13 >> 2]);
  f40 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f37 = Math_fround(f38 + Math_fround(f37 * f40));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f37);
  f37 = Math_fround(HEAPF32[i15 >> 2]);
  f38 = Math_fround(HEAPF32[i3 >> 2]);
  f37 = Math_fround(f37 * f38);
  f39 = Math_fround(f37 + Math_fround(f39 * Math_fround(HEAPF32[i16 >> 2])));
  f39 = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i17 >> 2])));
  HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f39);
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i20 >> 2]));
  f39 = Math_fround(HEAPF32[i21 >> 2]);
  f39 = Math_fround(f38 + Math_fround(f39 * Math_fround(HEAPF32[i5 >> 2])));
  f40 = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i22 >> 2])));
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f40);
  i5 = i3 + i33 | 0;
  f40 = Math_fround(HEAPF32[i18 >> 2]);
  f40 = Math_fround(f40 * Math_fround(HEAPF32[i5 >> 2]));
  f39 = Math_fround(HEAPF32[i24 >> 2]);
  i1 = i5 + 4 | 0;
  f38 = Math_fround(HEAPF32[i1 >> 2]);
  f39 = Math_fround(f40 + Math_fround(f39 * f38));
  f40 = Math_fround(HEAPF32[i25 >> 2]);
  f37 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  HEAPF32[i2 + 12 >> 2] = Math_fround(f39 + Math_fround(f40 * f37));
  f40 = Math_fround(HEAPF32[i26 >> 2]);
  f39 = Math_fround(HEAPF32[i5 >> 2]);
  f40 = Math_fround(f40 * f39);
  f38 = Math_fround(f40 + Math_fround(f38 * Math_fround(HEAPF32[i27 >> 2])));
  HEAPF32[i2 + 16 >> 2] = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i28 >> 2])));
  f39 = Math_fround(f39 * Math_fround(HEAPF32[i29 >> 2]));
  f38 = Math_fround(HEAPF32[i30 >> 2]);
  f38 = Math_fround(f39 + Math_fround(f38 * Math_fround(HEAPF32[i1 >> 2])));
  HEAPF32[i2 + 20 >> 2] = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i31 >> 2])));
  i1 = i2 + 24 | 0;
  if (!i32) {
   HEAP32[i1 >> 2] = -1;
   i1 = i2 + 28 | 0;
  }
  if (!i9) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = i1 + 8 | 0;
  }
  if (!i7) i2 = 0; else {
   if (i8) {
    i5 = 0;
    i2 = i1;
    i4 = i7;
    while (1) {
     i1 = i2 + 4 | 0;
     HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
     i5 = i5 + 1 | 0;
     if ((i5 | 0) >= (i11 | 0)) break; else {
      i2 = i1;
      i4 = i4 + 4 | 0;
     }
    }
   }
   i2 = i7 + i36 | 0;
  }
  i7 = i3 + i34 | 0;
  f37 = Math_fround(HEAPF32[i10 >> 2]);
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i7 >> 2]));
  f38 = Math_fround(HEAPF32[i12 >> 2]);
  i5 = i7 + 4 | 0;
  f39 = Math_fround(HEAPF32[i5 >> 2]);
  f38 = Math_fround(f37 + Math_fround(f38 * f39));
  f37 = Math_fround(HEAPF32[i13 >> 2]);
  f40 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f38 + Math_fround(f37 * f40));
  f37 = Math_fround(HEAPF32[i15 >> 2]);
  f38 = Math_fround(HEAPF32[i7 >> 2]);
  f37 = Math_fround(f37 * f38);
  f39 = Math_fround(f37 + Math_fround(f39 * Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i1 + 4 >> 2] = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i17 >> 2])));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i20 >> 2]));
  f39 = Math_fround(HEAPF32[i21 >> 2]);
  f39 = Math_fround(f38 + Math_fround(f39 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i1 + 8 >> 2] = Math_fround(f39 + Math_fround(f40 * Math_fround(HEAPF32[i22 >> 2])));
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  if (!i6) break; else {
   i3 = i3 + i35 | 0;
   i7 = i2;
   i2 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN7mecanim9animation19Blend2dDataConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 24 | 0;
 i6 = i3 + 16 | 0;
 i8 = i3;
 i9 = i2 + 4 | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 4;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i13;
 i13 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903889 | 0, i13, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 i12 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 i11 = i2 + 20 | 0;
 i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i11) | 0) + 20 >> 2] | 2097152;
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i10;
 i10 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i10, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 12;
 HEAP32[i8 + 4 >> 2] = i1 + 8;
 HEAP32[i8 + 8 >> 2] = i14;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903910 | 0, i13, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 20;
 HEAP32[i8 + 4 >> 2] = i1 + 16;
 HEAP32[i8 + 8 >> 2] = i14;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903932 | 0, i13, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i12, i6, 0);
 i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i11) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i11;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i10, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i10, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 28;
 HEAP32[i8 + 4 >> 2] = i1 + 24;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903955 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim9animation18MotionNeighborListEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_(i1 + 36 | 0, gb + 903981 | 0, i1 + 32 | 0, i2);
 STACKTOP = i3;
 return;
}

function __ZNK10FileSystem10CreatePathEPKc(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 1100 | 0;
 i11 = i13 + 1088 | 0;
 i10 = i13 + 1076 | 0;
 i8 = i13 + 12 | 0;
 i6 = i13 + 1072 | 0;
 i7 = i13;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __Z27FindSeparatedPathComponentsPKcjc(i9, i5, _strlen(i5) | 0, 47);
 i3 = i9 + 4 | 0;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i14 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i14;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i2 = i4 + 16 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 while (1) {
  if (!i1) {
   i3 = 9;
   break;
  }
  i1 = i1 + -1 | 0;
  i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] | 0, i14 | 0, i5 | 0) | 0) {
   i3 = 13;
   break;
  }
 }
 if ((i3 | 0) == 9) {
  i14 = HEAP32[i4 + 4 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] | 0, i14 | 0, i5 | 0) | 0) i3 = 13; else {
   i8 = i11;
   i3 = 11;
  }
 }
 do if ((i3 | 0) == 13) {
  i2 = i8 + 1040 | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  __ZN15FileSystemEntry3SetEPKc(i8, i5);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, i8 | 0) | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i8 | 0);
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1087627 | 0, 1);
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertENS_11__wrap_iterIPKS6_EERSA_(i11, i9, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i8 | 0);
  i8 = i11;
  i3 = 11;
 } while (0);
 if ((i3 | 0) == 11) {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
   i5 = i10 + 11 | 0;
   i6 = i10 + 4 | 0;
   i7 = i9 + 1040 | 0;
   i4 = 0;
   do {
    i3 = HEAP8[i5 >> 0] | 0;
    i2 = i3 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i6 >> 2] | 0 : i3 & 255;
    if (i3) if ((HEAP8[(i2 ? HEAP32[i10 >> 2] | 0 : i10) + (i3 + -1) >> 0] | 0) != 47) {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, gb + 1087627 | 0) | 0;
     i1 = HEAP32[i11 >> 2] | 0;
    }
    i2 = i1 + (i4 * 12 | 0) | 0;
    i14 = HEAP8[i2 + 11 >> 0] | 0;
    i3 = i14 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i3 ? HEAP32[i2 >> 2] | 0 : i2, i3 ? HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] | 0 : i14 & 255) | 0;
    i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
    HEAP8[i9 >> 0] = 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = 0;
    __ZN15FileSystemEntry3SetEPKc(i9, i1);
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) {
     mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, i9 | 0) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i9 | 0);
    }
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while (i4 >>> 0 < (((HEAP32[i12 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0);
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return 1;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i14 = i2 + -12 | 0;
   HEAP32[i12 >> 2] = i14;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i2 = HEAP32[i12 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return 1;
}

function __ZN5physx2Sc5Scene21fireCallBacksPostSyncEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i18 + 1 | 0;
 i16 = i18;
 i17 = i15 + 1149 | 0;
 if (!(HEAP8[i17 >> 0] | 0)) {
  i1 = i15 + 1128 | 0;
  L3 : do if (HEAP32[i1 >> 2] | 0) {
   i2 = i15 + 1124 | 0;
   i3 = 0;
   do {
    while (1) {
     if (!(HEAP16[(__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) + 144 >> 1] & 128)) break;
     i14 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
     HEAP32[i1 >> 2] = i14;
     i13 = HEAP32[i2 >> 2] | 0;
     HEAP32[i13 + (i3 << 2) >> 2] = HEAP32[i13 + (i14 << 2) >> 2];
     if (i3 >>> 0 >= i14 >>> 0) break L3;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
  } while (0);
  HEAP8[i17 >> 0] = 1;
 }
 i13 = i15 + 1148 | 0;
 i14 = i15 + 1140 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!(HEAP8[i13 >> 0] | 0)) {
  L15 : do if (!i1) i1 = 0; else {
   i2 = i15 + 1136 | 0;
   i3 = 0;
   do {
    while (1) {
     if (!(HEAP16[(__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) + 144 >> 1] & 64)) break;
     i1 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
     HEAP32[i14 >> 2] = i1;
     i12 = HEAP32[i2 >> 2] | 0;
     HEAP32[i12 + (i3 << 2) >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
     if (i3 >>> 0 >= i1 >>> 0) break L15;
    }
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i14 >> 2] | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  } while (0);
  HEAP8[i13 >> 0] = 1;
 }
 i12 = i15 + 1128 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i2 = i9 >>> 0 < i1 >>> 0 ? i1 : i9;
 if (!i2) {
  i1 = i9;
  i3 = 0;
 } else {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i2 << 2, gb + 680241 | 0, 2815) | 0;
  i11 = (i3 | 0) != 0;
  if ((i9 | 0) != 0 & i11) {
   i7 = i15 + 1124 | 0;
   i10 = i15 + 1152 | 0;
   i4 = 0;
   i8 = 0;
   i5 = -1;
   while (1) {
    i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i2 = HEAP8[i6 + 13 >> 0] | 0;
    if (i5 << 24 >> 24 == i2 << 24 >> 24) i2 = i5; else {
     i5 = HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + ((i2 & 255) << 2) >> 2] | 0) + 16 >> 2] | 0;
     if ((i4 | 0) != 0 & (i5 | 0) != 0) {
      mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i3 | 0, i4 | 0);
      i4 = 0;
     } else i4 = 0;
    }
    if (HEAP16[i6 + 8 >> 1] & 4) {
     HEAP32[i3 + (i4 << 2) >> 2] = __ZNK5physx2Sc9RigidCore10getPxActorEv(i6) | 0;
     i4 = i4 + 1 | 0;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i9 | 0)) break; else i5 = i2;
   }
   i2 = HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + ((i2 & 255) << 2) >> 2] | 0) + 16 >> 2] | 0;
   if ((i4 | 0) != 0 & (i2 | 0) != 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0);
  }
  if ((i1 | 0) != 0 & i11) {
   i7 = i15 + 1136 | 0;
   i9 = i15 + 1152 | 0;
   i2 = 0;
   i8 = 0;
   i4 = -1;
   do {
    i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP8[i6 + 13 >> 0] | 0;
    if (i4 << 24 >> 24 != i5 << 24 >> 24) {
     i4 = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + ((i5 & 255) << 2) >> 2] | 0) + 16 >> 2] | 0;
     if ((i2 | 0) != 0 & (i4 | 0) != 0) {
      mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0, i2 | 0);
      i2 = 0;
      i4 = i5;
     } else {
      i2 = 0;
      i4 = i5;
     }
    }
    if (HEAP16[i6 + 8 >> 1] & 4) {
     HEAP32[i3 + (i2 << 2) >> 2] = __ZNK5physx2Sc9RigidCore10getPxActorEv(i6) | 0;
     i2 = i2 + 1 | 0;
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != (i1 | 0));
   i1 = i4;
   i1 = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 16 >> 2] | 0;
   if ((i2 | 0) != 0 & (i1 | 0) != 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
  }
  i1 = HEAP32[i12 >> 2] | 0;
 }
 if (i1 | 0) {
  i1 = i15 + 1124 | 0;
  i2 = 0;
  do {
   i11 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0) + 144 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] & 65423;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 }
 if (!(HEAP32[i14 >> 2] | 0)) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP8[i13 >> 0] = 1;
  HEAP8[i17 >> 0] = 1;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i3);
  STACKTOP = i18;
  return;
 }
 i1 = i15 + 1136 | 0;
 i2 = 0;
 do {
  i15 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0) + 144 | 0;
  HEAP16[i15 >> 1] = HEAPU16[i15 >> 1] & 65359;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP8[i13 >> 0] = 1;
 HEAP8[i17 >> 0] = 1;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i3);
 STACKTOP = i18;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 40, 4) | 0;
      i3 = i2 + 8 | 0;
      HEAP32[i2 + 28 >> 2] = 0;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i3 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = 0;
      HEAP32[i3 + 12 >> 2] = 0;
      HEAP8[i2 + 36 >> 0] = 1;
      HEAP8[i2 + 37 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 904061 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim9animation13LayerConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 40, 4) | 0;
       i3 = i2 + 8 | 0;
       HEAP32[i2 + 28 >> 2] = 0;
       HEAP32[i3 >> 2] = 0;
       HEAP32[i3 + 4 >> 2] = 0;
       HEAP32[i3 + 8 >> 2] = 0;
       HEAP32[i3 + 12 >> 2] = 0;
       HEAP8[i2 + 36 >> 0] = 1;
       HEAP8[i2 + 37 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 904061 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim9animation13LayerConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i2 = i15;
 i14 = i15 + 16 | 0;
 i3 = i1 + 92 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!(HEAP32[i1 + 104 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i2);
 i7 = i9;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i14 >> 2] = i7;
  break;
 } while (0);
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0;
 if (!i1) i1 = HEAP32[i8 >> 2] | 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i3 = HEAP32[i1 + 60 >> 2] | 0;
   i4 = i5 + 1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i14 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i8 >> 2] = i4;
   HEAP32[(HEAP32[i14 >> 2] | 0) + (i5 << 2) >> 2] = i3;
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   if (!i1) {
    i1 = i4;
    break;
   } else i5 = i4;
  }
 }
 i7 = HEAP32[i14 >> 2] | 0;
 __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_(i7, i7 + (i1 << 2) | 0, i9);
 i7 = HEAP32[i14 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i3 = i7 + (i9 << 2) | 0;
 i2 = i7;
 if (!i9) {
  i3 = i7;
  i1 = i7;
 } else {
  i6 = i7;
  while (1) {
   i5 = i6 + 4 | 0;
   if ((i5 | 0) == (i3 | 0)) {
    i1 = i7;
    i4 = i7;
    break;
   }
   i4 = HEAP32[i6 >> 2] | 0;
   i8 = HEAP32[i5 >> 2] | 0;
   if (i4 >>> 0 < i8 >>> 0) i6 = i5; else {
    i10 = 13;
    break;
   }
  }
  if ((i10 | 0) == 13) if ((i6 | 0) == (i3 | 0)) {
   i1 = i7;
   i4 = i7;
  } else {
   i1 = i5;
   i7 = i5;
   i2 = i8;
   while (1) {
    if (i4 >>> 0 < i2 >>> 0) {
     HEAP32[i1 >> 2] = i2;
     i1 = i1 + 4 | 0;
    }
    i5 = i7 + 4 | 0;
    i2 = i6 + 4 | 0;
    if ((i5 | 0) == (i3 | 0)) break;
    i7 = i5;
    i6 = i2;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = HEAP32[i14 >> 2] | 0;
   i3 = i1;
   i1 = i4;
   i2 = i4;
  }
  if ((i4 | 0) != (i3 | 0)) {
   i8 = i11 + 12 | 0;
   i9 = i11 + 16 | 0;
   i10 = i11 + 4 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   do {
    i5 = i2;
    i2 = i2 + 1 | 0;
    i6 = HEAP32[i9 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i2 >>> 0 > i7 >>> 0) {
     i1 = i6 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i9 >> 2] = i1;
      HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i11 >> 2] = i7;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i2;
    HEAP32[(HEAP32[i11 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i4 >> 2];
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i3 | 0));
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
  }
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  HEAP32[i14 >> 2] = 0;
 }
 i14 = i3 - i2 >> 2;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx24PxD6JointGeneratedValuesC2EPKNS_9PxD6JointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 HEAPF32[i2 + 184 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 188 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 192 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i2 + 196 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i2 + 220 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i2 + 248 | 0, i1 | 0);
 i7 = i2 + 276 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 280 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 284 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 288 >> 2] = 0;
 HEAPF32[i2 + 292 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 296 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 300 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 304 >> 2] = 0;
 HEAPF32[i2 + 308 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 312 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 316 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 320 >> 2] = 0;
 HEAPF32[i2 + 324 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 328 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 332 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 336 >> 2] = 0;
 HEAPF32[i2 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 348 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 352 >> 2] = 0;
 HEAPF32[i2 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 360 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 364 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 368 >> 2] = 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i2 + 372 | 0, i1 | 0);
 HEAPF32[i2 + 424 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 428 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 432 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 160 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 0) | 0;
 HEAP32[i2 + 164 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 1) | 0;
 HEAP32[i2 + 168 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 2) | 0;
 HEAP32[i2 + 172 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 3) | 0;
 HEAP32[i2 + 176 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 4) | 0;
 HEAP32[i2 + 180 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, 5) | 0;
 i5 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 0);
 i9 = i8;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i2 + 284 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 288 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 1);
 i7 = i8;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i2 + 292 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i2 + 300 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 304 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 2);
 i9 = i8;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i2 + 308 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i2 + 316 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 320 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 3);
 i7 = i8;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i2 + 324 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i2 + 332 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 336 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 4);
 i9 = i8;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i2 + 340 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i2 + 348 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 352 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i8 | 0, i1 | 0, 5);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i2 + 356 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i2 + 364 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 368 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 + 400 | 0, i2 + 412 | 0);
 STACKTOP = i3;
 return;
}

function __ZN13GfxDeviceGLES15InitCommonStateER15DeviceStateGLES(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i43;
 i39 = i43 + 68 | 0;
 HEAP8[i39 >> 0] = 0;
 HEAP8[i39 + 1 >> 0] = 0;
 HEAP8[i1 >> 0] = HEAP8[i39 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i39 + 1 >> 0] | 0;
 HEAP32[i3 + 524 >> 2] = __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i3, i1) | 0;
 HEAP8[i1 >> 0] = 15;
 i39 = i1 + 1 | 0;
 HEAP8[i39 >> 0] = 1;
 i40 = i1 + 2 | 0;
 HEAP8[i40 >> 0] = 0;
 i41 = i1 + 3 | 0;
 HEAP8[i41 >> 0] = 1;
 i42 = i1 + 4 | 0;
 HEAP32[i42 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP8[i4 >> 0] = 15;
 i5 = i1 + 9 | 0;
 HEAP8[i5 >> 0] = 1;
 i6 = i1 + 10 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i1 + 11 | 0;
 HEAP8[i7 >> 0] = 1;
 i8 = i1 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 HEAP8[i9 >> 0] = 15;
 i10 = i1 + 17 | 0;
 HEAP8[i10 >> 0] = 1;
 i11 = i1 + 18 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = i1 + 19 | 0;
 HEAP8[i12 >> 0] = 1;
 i13 = i1 + 20 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i1 + 24 | 0;
 HEAP8[i14 >> 0] = 15;
 i15 = i1 + 25 | 0;
 HEAP8[i15 >> 0] = 1;
 i16 = i1 + 26 | 0;
 HEAP8[i16 >> 0] = 0;
 i17 = i1 + 27 | 0;
 HEAP8[i17 >> 0] = 1;
 i18 = i1 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i1 + 32 | 0;
 HEAP8[i19 >> 0] = 15;
 i20 = i1 + 33 | 0;
 HEAP8[i20 >> 0] = 1;
 i21 = i1 + 34 | 0;
 HEAP8[i21 >> 0] = 0;
 i22 = i1 + 35 | 0;
 HEAP8[i22 >> 0] = 1;
 i23 = i1 + 36 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i1 + 40 | 0;
 HEAP8[i24 >> 0] = 15;
 i25 = i1 + 41 | 0;
 HEAP8[i25 >> 0] = 1;
 i26 = i1 + 42 | 0;
 HEAP8[i26 >> 0] = 0;
 i27 = i1 + 43 | 0;
 HEAP8[i27 >> 0] = 1;
 i28 = i1 + 44 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i1 + 48 | 0;
 HEAP8[i29 >> 0] = 15;
 i30 = i1 + 49 | 0;
 HEAP8[i30 >> 0] = 1;
 i31 = i1 + 50 | 0;
 HEAP8[i31 >> 0] = 0;
 i32 = i1 + 51 | 0;
 HEAP8[i32 >> 0] = 1;
 i33 = i1 + 52 | 0;
 HEAP32[i33 >> 2] = 0;
 i34 = i1 + 56 | 0;
 HEAP8[i34 >> 0] = 15;
 i35 = i1 + 57 | 0;
 HEAP8[i35 >> 0] = 1;
 i36 = i1 + 58 | 0;
 HEAP8[i36 >> 0] = 0;
 i37 = i1 + 59 | 0;
 HEAP8[i37 >> 0] = 1;
 i38 = i1 + 60 | 0;
 HEAP32[i38 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 168 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i4 >> 0] = 0;
  HEAP8[i9 >> 0] = 0;
  HEAP8[i14 >> 0] = 0;
  HEAP8[i19 >> 0] = 0;
  HEAP8[i24 >> 0] = 0;
  HEAP8[i29 >> 0] = 0;
  HEAP8[i34 >> 0] = 0;
  i42 = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i3, i1) | 0;
  i41 = i3 + 528 | 0;
  HEAP32[i41 >> 2] = i42;
  i41 = i2 + 4616 | 0;
  i41 = HEAP32[i41 >> 2] | 0;
  __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES(i41, i3);
  i41 = i3 + 428 | 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i41 + 4 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  HEAP32[i41 + 12 >> 2] = 0;
  i41 = i3 + 580 | 0;
  HEAP32[i41 >> 2] = -1;
  i41 = i3 + 584 | 0;
  i42 = i3 + 752 | 0;
  _memset(i41 | 0, 0, 168) | 0;
  i41 = i42;
  HEAP32[i41 >> 2] = 1;
  i42 = i42 + 4 | 0;
  HEAP32[i42 >> 2] = 0;
  i42 = i3 + 760 | 0;
  HEAP32[i42 >> 2] = 0;
  STACKTOP = i43;
  return;
 } else {
  HEAP8[i41 >> 0] = 0;
  HEAP8[i39 >> 0] = 0;
  HEAP8[i42 >> 0] = 1;
  HEAP8[i40 >> 0] = 1;
  HEAP8[i7 >> 0] = 0;
  HEAP8[i5 >> 0] = 0;
  HEAP8[i8 >> 0] = 1;
  HEAP8[i6 >> 0] = 1;
  HEAP8[i12 >> 0] = 0;
  HEAP8[i10 >> 0] = 0;
  HEAP8[i13 >> 0] = 1;
  HEAP8[i11 >> 0] = 1;
  HEAP8[i17 >> 0] = 0;
  HEAP8[i15 >> 0] = 0;
  HEAP8[i18 >> 0] = 1;
  HEAP8[i16 >> 0] = 1;
  HEAP8[i22 >> 0] = 0;
  HEAP8[i20 >> 0] = 0;
  HEAP8[i23 >> 0] = 1;
  HEAP8[i21 >> 0] = 1;
  HEAP8[i27 >> 0] = 0;
  HEAP8[i25 >> 0] = 0;
  HEAP8[i28 >> 0] = 1;
  HEAP8[i26 >> 0] = 1;
  HEAP8[i32 >> 0] = 0;
  HEAP8[i30 >> 0] = 0;
  HEAP8[i33 >> 0] = 1;
  HEAP8[i31 >> 0] = 1;
  HEAP8[i37 >> 0] = 0;
  HEAP8[i35 >> 0] = 0;
  HEAP8[i38 >> 0] = 1;
  HEAP8[i36 >> 0] = 1;
  i42 = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i3, i1) | 0;
  i41 = i3 + 528 | 0;
  HEAP32[i41 >> 2] = i42;
  i41 = i2 + 4616 | 0;
  i41 = HEAP32[i41 >> 2] | 0;
  __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES(i41, i3);
  i41 = i3 + 428 | 0;
  HEAP32[i41 >> 2] = 0;
  HEAP32[i41 + 4 >> 2] = 0;
  HEAP32[i41 + 8 >> 2] = 0;
  HEAP32[i41 + 12 >> 2] = 0;
  i41 = i3 + 580 | 0;
  HEAP32[i41 >> 2] = -1;
  i41 = i3 + 584 | 0;
  i42 = i3 + 752 | 0;
  _memset(i41 | 0, 0, 168) | 0;
  i41 = i42;
  HEAP32[i41 >> 2] = 1;
  i42 = i42 + 4 | 0;
  HEAP32[i42 >> 2] = 0;
  i42 = i3 + 760 | 0;
  HEAP32[i42 >> 2] = 0;
  STACKTOP = i43;
  return;
 }
}

function __Z17GetFrustumPortionPK8Vector3fffPS_(i1, f2, f3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0;
 i32 = i1 + 48 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * f2);
 i31 = i1 + 52 | 0;
 f33 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * f2);
 i30 = i1 + 56 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * f2);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f16 = Math_fround(f6 * Math_fround(HEAPF32[i1 >> 2]));
 i29 = i1 + 4 | 0;
 f9 = Math_fround(f6 * Math_fround(HEAPF32[i29 >> 2]));
 i28 = i1 + 8 | 0;
 f9 = Math_fround(f33 + f9);
 f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i28 >> 2])));
 HEAPF32[i4 >> 2] = Math_fround(f8 + f16);
 HEAPF32[i4 + 4 >> 2] = f9;
 HEAPF32[i4 + 8 >> 2] = f5;
 i27 = i1 + 60 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f2);
 i26 = i1 + 64 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f2);
 i25 = i1 + 68 | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f2);
 i24 = i1 + 12 | 0;
 f8 = Math_fround(f6 * Math_fround(HEAPF32[i24 >> 2]));
 i23 = i1 + 16 | 0;
 f33 = Math_fround(f6 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i1 + 20 | 0;
 f33 = Math_fround(f9 + f33);
 f16 = Math_fround(f16 + Math_fround(f6 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i4 + 12 >> 2] = Math_fround(f5 + f8);
 HEAPF32[i4 + 16 >> 2] = f33;
 HEAPF32[i4 + 20 >> 2] = f16;
 i21 = i1 + 72 | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f2);
 i20 = i1 + 76 | 0;
 f33 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f2);
 i19 = i1 + 80 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f2);
 i18 = i1 + 24 | 0;
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 i17 = i1 + 28 | 0;
 f9 = Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2]));
 i15 = i1 + 32 | 0;
 f9 = Math_fround(f33 + f9);
 f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i4 + 24 >> 2] = Math_fround(f16 + f5);
 HEAPF32[i4 + 28 >> 2] = f9;
 HEAPF32[i4 + 32 >> 2] = f8;
 i14 = i1 + 84 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f2);
 i13 = i1 + 88 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f2);
 i12 = i1 + 92 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f2);
 i11 = i1 + 36 | 0;
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
 i10 = i1 + 40 | 0;
 f16 = Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2]));
 i7 = i1 + 44 | 0;
 f16 = Math_fround(f9 + f16);
 f6 = Math_fround(f2 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i4 + 36 >> 2] = Math_fround(f8 + f5);
 HEAPF32[i4 + 40 >> 2] = f16;
 HEAPF32[i4 + 44 >> 2] = f6;
 f6 = Math_fround(Math_fround(HEAPF32[i32 >> 2]) * f3);
 f16 = Math_fround(Math_fround(HEAPF32[i31 >> 2]) * f3);
 f5 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) * f3);
 f8 = Math_fround(Math_fround(1.0) - f3);
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i1 >> 2]));
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i29 >> 2]));
 f9 = Math_fround(f16 + f9);
 f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i28 >> 2])));
 HEAPF32[i4 + 48 >> 2] = Math_fround(f6 + f2);
 HEAPF32[i4 + 52 >> 2] = f9;
 HEAPF32[i4 + 56 >> 2] = f5;
 f5 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) * f3);
 f9 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) * f3);
 f2 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) * f3);
 f6 = Math_fround(f8 * Math_fround(HEAPF32[i24 >> 2]));
 f16 = Math_fround(f8 * Math_fround(HEAPF32[i23 >> 2]));
 f16 = Math_fround(f9 + f16);
 f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(HEAPF32[i22 >> 2])));
 HEAPF32[i4 + 60 >> 2] = Math_fround(f5 + f6);
 HEAPF32[i4 + 64 >> 2] = f16;
 HEAPF32[i4 + 68 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f3);
 f16 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f3);
 f6 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f3);
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i18 >> 2]));
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i17 >> 2]));
 f9 = Math_fround(f16 + f9);
 f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i4 + 72 >> 2] = Math_fround(f2 + f5);
 HEAPF32[i4 + 76 >> 2] = f9;
 HEAPF32[i4 + 80 >> 2] = f6;
 f6 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f3);
 f9 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f3);
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2]));
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i10 >> 2]));
 f2 = Math_fround(f9 + f2);
 f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i4 + 84 >> 2] = Math_fround(f6 + f5);
 HEAPF32[i4 + 88 >> 2] = f2;
 HEAPF32[i4 + 92 >> 2] = f3;
 return;
}

function __ZN5physx2Sq10AABBPruner6commitEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 33 | 0;
 i2 = i14 + 32 | 0;
 i7 = i14;
 i1 = i13 + 7809 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i13 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i3 | 0) if (HEAP8[i13 + 7808 >> 0] | 0) {
  i1 = i13 + 7744 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 3) {
   i12 = i13 + 44 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i12 >> 2] | 0);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i13 + 52 >> 2] | 0;
   i2 = HEAP32[i13 + 7748 >> 2] | 0;
   if (i1 >>> 0 > i2 >>> 0) {
    i12 = i13 + 7756 | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   } else if (i1 >>> 0 < i2 >>> 0) {
    i12 = i13 + 7756 | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   }
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    __ZN5physx2Sq8AABBTreeD2Ev(i1);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
   }
   i1 = i13 + 40 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   i1 = i13 + 7796 | 0;
   i2 = i13 + 7764 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i12 = HEAP32[i13 + 48 >> 2] | 0;
   __ZN5physx2Sq17AABBTreeUpdateMap7initMapEjRKNS0_8AABBTreeE(i1, i4 >>> 0 < i12 >>> 0 ? i12 : i4, i3);
   i3 = i13 + 7812 | 0;
   i4 = i13 + 7816 | 0;
   if ((HEAP32[i4 >> 2] | 0) > 0) {
    i5 = HEAP32[i3 >> 2] | 0;
    do {
     __ZN5physx2Sq17AABBTreeUpdateMap10invalidateEjjRNS0_8AABBTreeE(i1, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i6 >> 2] | 0);
     i5 = i5 + 8 | 0;
    } while (i5 >>> 0 < ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 3) | 0) >>> 0);
   }
   HEAP32[i4 >> 2] = 0;
   HEAP8[i13 + 7811 >> 0] = 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i12 = i7 + 8 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 + 20 >> 2] = HEAP32[i13 + 7772 >> 2];
   HEAP32[i7 + 4 >> 2] = 2;
   HEAP32[i7 >> 2] = 1;
   i12 = HEAP32[i6 >> 2] | 0;
   __ZN5physx2Sq8AABBTree6refit2EPNS0_15AABBTreeBuilderEPj(i12, i7, HEAP32[i12 >> 2] | 0) | 0;
   i12 = i13 + 140 | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i11 = i5 + 12 | 0;
   L22 : do if (!(HEAP32[i5 + 16 >> 2] | 0)) {
    i1 = -1;
    i2 = 0;
   } else {
    i4 = HEAP32[i11 >> 2] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) == -1) {
     i3 = HEAP32[i5 + 20 >> 2] | 0;
     i1 = 0;
     while (1) {
      i2 = i1 + 1 | 0;
      if ((i2 | 0) == (i3 | 0)) {
       i1 = -1;
       i2 = i3;
       break L22;
      }
      i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      if ((i1 | 0) == -1) i1 = i2; else break;
     }
    } else i2 = 0;
   } while (0);
   i6 = i5 + 4 | 0;
   i7 = i13 + 144 | 0;
   i8 = i13 + 7780 | 0;
   i9 = i13 + 7776 | 0;
   i10 = i5 + 8 | 0;
   i4 = i5 + 20 | 0;
   L29 : while (1) {
    do {
     if ((i1 | 0) == -1) break L29;
     __ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE(i7, (HEAP32[i9 >> 2] | 0) + (HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] << 3) | 0) | 0;
     i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    } while ((i1 | 0) != -1);
    i3 = HEAP32[i4 >> 2] | 0;
    while (1) {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) {
      i1 = -1;
      i2 = i3;
      continue L29;
     }
     i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     if ((i1 | 0) != -1) continue L29;
    }
   }
   HEAP8[i13 + 7810 >> 0] = (HEAP32[(HEAP32[i13 + 96 >> 2] | 0) + 36 >> 2] | 0) != 0 & 1;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   if (i1 | 0) {
    i8 = i7 + 36 | 0;
    if (HEAP32[i8 >> 2] | 0) {
     _memset(HEAP32[i7 + 12 >> 2] | 0, -1, i1 << 2 | 0) | 0;
     i6 = i7 + 16 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     i5 = i2 + -1 | 0;
     i4 = i7 + 8 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     if (i5) {
      i3 = 0;
      while (1) {
       i2 = i3 + 1 | 0;
       i1 = HEAP32[i4 >> 2] | 0;
       HEAP32[i1 + (i3 << 2) >> 2] = i2;
       if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
      }
      i2 = HEAP32[i6 >> 2] | 0;
     }
     HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
     HEAP32[i7 + 28 >> 2] = 0;
     HEAP32[i8 >> 2] = 0;
    }
   }
  } else {
   i1 = HEAP32[i13 + 7764 >> 2] | 0;
   if (i1 | 0) __ZN5physx2Sq8AABBTree11refitMarkedEjPKNS_9PxBounds3EPj(i3, i1, HEAP32[i13 + 7772 >> 2] | 0, HEAP32[i3 >> 2] | 0);
  }
  __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv(i13 + 144 | 0);
  STACKTOP = i14;
  return;
 }
 __ZN5physx2Sq10AABBPruner19fullRebuildAABBTreeEv(i13) | 0;
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_(i2, i1, i4, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(f18 + f18);
 f23 = Math_fround(f8 + f8);
 f16 = Math_fround(f11 + f11);
 f19 = Math_fround(f8 * f23);
 f7 = Math_fround(f11 * f16);
 f8 = Math_fround(f9 * f8);
 f29 = Math_fround(f9 * f11);
 f21 = Math_fround(f9 * f26);
 f11 = Math_fround(f23 * f11);
 f23 = Math_fround(f23 * f26);
 f26 = Math_fround(f16 * f26);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f9));
 f18 = Math_fround(Math_fround(Math_fround(1.0) - f19) - f7);
 f16 = Math_fround(f8 + f26);
 f14 = Math_fround(f29 - f23);
 f26 = Math_fround(f8 - f26);
 f7 = Math_fround(f9 - f7);
 f8 = Math_fround(f11 + f21);
 f23 = Math_fround(f29 + f23);
 f21 = Math_fround(f11 - f21);
 f19 = Math_fround(f9 - f19);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 i27 = i2 + 4 | 0;
 f11 = Math_fround(f9 * f18);
 f29 = Math_fround(f9 * f26);
 f9 = Math_fround(f9 * f23);
 f10 = Math_fround(HEAPF32[i27 >> 2]);
 i1 = i2 + 8 | 0;
 f12 = Math_fround(f16 * f10);
 f28 = Math_fround(f10 * f7);
 f10 = Math_fround(f10 * f21);
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f14 * f22);
 f20 = Math_fround(f8 * f22);
 f22 = Math_fround(f19 * f22);
 f13 = Math_fround(Math_fround(Math_fround(f18 * f29) + Math_fround(f16 * f28)) + Math_fround(f14 * f20));
 f24 = Math_fround(Math_fround(Math_fround(f18 * f9) + Math_fround(f16 * f10)) + Math_fround(f14 * f22));
 f15 = Math_fround(Math_fround(Math_fround(f26 * f11) + Math_fround(f7 * f12)) + Math_fround(f8 * f6));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f29) + Math_fround(f7 * f28)) + Math_fround(f8 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f26 * f9) + Math_fround(f7 * f10)) + Math_fround(f8 * f22));
 f5 = Math_fround(Math_fround(Math_fround(f23 * f11) + Math_fround(f21 * f12)) + Math_fround(f19 * f6));
 f20 = Math_fround(Math_fround(Math_fround(f23 * f29) + Math_fround(f21 * f28)) + Math_fround(f19 * f20));
 f22 = Math_fround(Math_fround(Math_fround(f23 * f9) + Math_fround(f21 * f10)) + Math_fround(f19 * f22));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f18 * f11) + Math_fround(f16 * f12)) + Math_fround(f14 * f6));
 HEAPF32[i4 + 4 >> 2] = f13;
 HEAPF32[i4 + 8 >> 2] = f24;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 16 >> 2] = f15;
 HEAPF32[i4 + 20 >> 2] = f25;
 HEAPF32[i4 + 24 >> 2] = f17;
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 32 >> 2] = f5;
 HEAPF32[i4 + 36 >> 2] = f20;
 HEAPF32[i4 + 40 >> 2] = f22;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(HEAPF32[i27 >> 2]);
 f22 = Math_fround(Math_fround(1.0) / f22);
 f20 = Math_fround(Math_fround(1.0) / f20);
 f5 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 >> 2]));
 f17 = Math_fround(f18 * f22);
 f25 = Math_fround(f26 * f22);
 f22 = Math_fround(f23 * f22);
 f15 = Math_fround(f16 * f20);
 f24 = Math_fround(f7 * f20);
 f20 = Math_fround(f21 * f20);
 f13 = Math_fround(f14 * f5);
 f6 = Math_fround(f8 * f5);
 f5 = Math_fround(f19 * f5);
 f12 = Math_fround(Math_fround(Math_fround(f18 * f25) + Math_fround(f16 * f24)) + Math_fround(f14 * f6));
 f11 = Math_fround(Math_fround(Math_fround(f18 * f22) + Math_fround(f16 * f20)) + Math_fround(f14 * f5));
 f10 = Math_fround(Math_fround(Math_fround(f26 * f17) + Math_fround(f7 * f15)) + Math_fround(f8 * f13));
 f9 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f7 * f24)) + Math_fround(f8 * f6));
 f8 = Math_fround(Math_fround(Math_fround(f26 * f22) + Math_fround(f7 * f20)) + Math_fround(f8 * f5));
 f7 = Math_fround(Math_fround(Math_fround(f23 * f17) + Math_fround(f21 * f15)) + Math_fround(f19 * f13));
 f6 = Math_fround(Math_fround(Math_fround(f23 * f25) + Math_fround(f21 * f24)) + Math_fround(f19 * f6));
 f5 = Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * f20)) + Math_fround(f19 * f5));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f15)) + Math_fround(f14 * f13));
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f11;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 16 >> 2] = f10;
 HEAPF32[i3 + 20 >> 2] = f9;
 HEAPF32[i3 + 24 >> 2] = f8;
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 32 >> 2] = f7;
 HEAPF32[i3 + 36 >> 2] = f6;
 HEAPF32[i3 + 40 >> 2] = f5;
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15AudioReverbZone8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864216 | 0, i6, i1 + 48 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864230 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864185 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864003 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864010 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864033 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864045 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864244 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864166 | 0, i6, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864258 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864093 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864129 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864267 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864107 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864119 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864152 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864143 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i16, i8, i1) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i7 = i15 + 8 | 0;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i16 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 17; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 17; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 17) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L20;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 30; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 30; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 30) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __Z38Font_CUSTOM_Internal_CreateDynamicFontP12Il2CppObjectP11Il2CppArrayi(i7, i8, i16) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26 + 48 | 0;
 i25 = i26 + 32 | 0;
 i20 = i26 + 16 | 0;
 i21 = i26;
 HEAP32[i25 >> 2] = 0;
 i23 = i25 + 4 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0) > 0) {
  i9 = i21 + 11 | 0;
  i10 = i21 + 4 | 0;
  i11 = i20 + 12 | 0;
  i6 = i20 + 12 | 0;
  i12 = i24 + 4 | 0;
  i13 = i20 + 8 | 0;
  i14 = i20 + 4 | 0;
  i15 = i25 + 8 | 0;
  i17 = i20 + 11 | 0;
  i18 = i24 + 4 | 0;
  i19 = i24 + 4 | 0;
  i5 = 0;
  do {
   __Z24scripting_cpp_string_forP12Il2CppString(i21, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i8, i5) | 0);
   i3 = HEAP8[i9 >> 0] | 0;
   i1 = i3 << 24 >> 24 < 0;
   i2 = i1 ? HEAP32[i21 >> 2] | 0 : i21;
   i3 = i1 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i1;
   if (i3 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i20);
    i1 = HEAP32[i6 >> 2] | 0;
    i22 = 15;
   } else if (i3 >>> 0 < 11) {
    HEAP8[i17 >> 0] = i3;
    if (!i3) i1 = i20; else {
     i1 = i20;
     i22 = 17;
    }
   } else i22 = 15;
   if ((i22 | 0) == 15) {
    i4 = i3 + 16 & -16;
    HEAP32[i24 >> 2] = 66;
    HEAP32[i12 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i20 >> 2] = i1;
    HEAP32[i13 >> 2] = i4 | -2147483648;
    HEAP32[i14 >> 2] = i3;
    i22 = 17;
   }
   if ((i22 | 0) == 17) {
    i22 = 0;
    _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
   }
   HEAP8[i1 + i3 >> 0] = 0;
   i1 = HEAP32[i23 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i25, i20); else {
    i4 = HEAP8[i17 >> 0] | 0;
    i2 = i4 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
    i4 = i2 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i1 + 12 >> 2] = i2;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     i22 = 22;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i4;
     if (i4) i22 = 24;
    } else i22 = 22;
    if ((i22 | 0) == 22) {
     i27 = i4 + 16 & -16;
     HEAP32[i24 >> 2] = 66;
     HEAP32[i19 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i27, 16, i24, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i27 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i2;
     i22 = 24;
    }
    if ((i22 | 0) == 24) {
     i22 = 0;
     _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
    }
    HEAP8[i1 + i4 >> 0] = 0;
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 16;
   }
   if ((HEAP8[i17 >> 0] | 0) < 0) {
    i27 = HEAP32[i20 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    HEAP32[i24 >> 2] = 66;
    HEAP32[i18 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i27, i24);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (__Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0));
 }
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i7, __ZN20TextRenderingPrivate8FontImpl17CreateDynamicFontERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEi(i25, i16) | 0) | 0;
 i1 = HEAP32[i25 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i2 = HEAP32[i23 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i24 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i23 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i27 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i24 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i27, i24);
    i2 = HEAP32[i23 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i25 >> 2] | 0;
 }
 i27 = HEAP32[i25 + 12 >> 2] | 0;
 HEAP32[i24 >> 2] = 34;
 HEAP32[i24 + 4 >> 2] = i27;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i24);
 STACKTOP = i26;
 return;
}

function __ZN9Rigidbody22UpdateMassDistributionEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 84 | 0;
 i8 = i14 + 56 | 0;
 i10 = i14 + 28 | 0;
 i11 = i14;
 if (HEAP8[i13 + 84 >> 0] | 0) {
  i12 = HEAP32[i13 + 52 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i12 >> 2] | 0) + 128 >> 2] | 0, i12 | 0, +Math_fround(HEAPF32[i13 + 68 >> 2]));
  STACKTOP = i14;
  return;
 }
 i7 = i13 + 81 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  if (HEAP8[i13 + 82 >> 0] | 0) i1 = 5;
 } else i1 = 5;
 if ((i1 | 0) == 5) {
  i6 = i13 + 52 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0, i3 | 0) | 0;
  HEAP32[i12 >> 2] = 0;
  i9 = i12 + 4 | 0;
  i4 = gb + 63160 | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i3 << 2;
  do if (!i1) i1 = 0; else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 636) | 0;
    i4 = gb + 64016 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    HEAP32[i12 >> 2] = i1;
    i5 = i9;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 + 4 >> 2] = i4;
    break;
   }
  } while (0);
  i2 = i1 + 3 & -4;
  i5 = HEAP32[i6 >> 2] | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 108 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0, 0) | 0;
  L15 : do if ((i3 | 0) > 0) {
   i1 = 0;
   while (1) {
    i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
    i1 = i1 + 1 | 0;
    if (!((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0) & 4)) break;
    if ((i1 | 0) >= (i3 | 0)) break L15;
   }
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i10 | 0, i1 | 0);
   HEAP32[i8 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 20 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 24 >> 2];
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i10 | 0, i1 | 0);
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i11 | 0, i1 | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = HEAP32[i11 + 8 >> 2] | 0;
   i4 = HEAP32[i11 + 12 >> 2] | 0;
   i5 = i13 + 68 | 0;
   f15 = Math_fround(HEAPF32[i5 >> 2]);
   __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(HEAP32[i6 >> 2] | 0, f15, HEAP8[i13 + 82 >> 0] | 0 ? 0 : i8, 0) | 0;
   if (!(HEAP8[i7 >> 0] | 0)) {
    i8 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i11 | 0, i8 | 0);
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 4 >> 2] = i2;
    HEAP32[i11 + 8 >> 2] = i3;
    HEAP32[i11 + 12 >> 2] = i4;
    i8 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, i8 | 0, i11 | 0);
    i11 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0, i10 | 0);
   }
   i1 = i13 + 56 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i11 = __Z12GetIVehiclesv() | 0;
    mftCall_viif(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i5 >> 2]));
   }
   if (HEAP32[i13 + 88 >> 2] | 0) __ZN9Rigidbody16ApplyConstraintsEv(i13);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i9);
   STACKTOP = i14;
   return;
  } while (0);
  if (HEAP8[i13 + 82 >> 0] | 0) {
   i10 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 124 >> 2] | 0, i8 | 0, i10 | 0);
   i10 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i11 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
   HEAP32[i8 + 16 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i8 + 20 >> 2] = i10;
   HEAP32[i8 + 24 >> 2] = i11;
   i11 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 120 >> 2] | 0, i11 | 0, i8 | 0);
  }
  if (HEAP8[i7 >> 0] | 0) {
   i11 = HEAP32[i6 >> 2] | 0;
   mftCall_vif(HEAP32[(HEAP32[i11 >> 2] | 0) + 128 >> 2] | 0, i11 | 0, +Math_fround(HEAPF32[i13 + 68 >> 2]));
   i11 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 140 >> 2] | 0, i11 | 0, gb + 62512 | 0);
   if (HEAP32[i13 + 88 >> 2] | 0) __ZN9Rigidbody16ApplyConstraintsEv(i13);
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i9);
 }
 i1 = i13 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i12 = __Z12GetIVehiclesv() | 0;
 mftCall_viif(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i13 + 68 >> 2]));
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = i10 - i7 >> 5;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > i1 - i2 >> 5 >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -32 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -20 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = i1 - i2 | 0;
  i1 = i15 >> 4;
  i1 = i15 >> 5 >>> 0 < 67108863 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 134217727;
  if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 << 5) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 << 5);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = (HEAP32[i12 >> 2] | 0) - i2 >> 5;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 << 5) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i8 = i8 + 32 | 0;
   i1 = i1 + 32 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - ((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) >> 5) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -32 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -20 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 28 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 28 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -28 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -16 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 153391689) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 28 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 76695844 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 153391689;
  if (i1 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 28 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 28 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 28 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 28 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i8 = i8 + 28 | 0;
   i1 = i1 + 28 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 28 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -28 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -16 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZN18UnityPropertySheet25AssignDefinedPropertiesToER19ShaderPropertySheet(i12, i14) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 24 | 0;
 i16 = i20 + 16 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20;
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 i11 = i12 + 16 | 0;
 i1 = i2;
 if ((i1 | 0) != (i11 | 0)) {
  i8 = i14 + 8 | 0;
  i9 = i14 + 12 | 0;
  i10 = i14 + 32 | 0;
  while (1) {
   i4 = i1 + 16 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   L5 : do if ((i3 | 0) < (i5 | 0)) {
    i6 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i4 >> 2] | 0;
    while (1) {
     if ((HEAP32[i6 + (i3 << 2) >> 2] | 0) == (i7 | 0)) break;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) >= (i5 | 0)) break L5;
    }
    if ((i3 | 0) > -1) __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i14, i4, Math_fround(HEAPF32[i1 + 20 >> 2]), 0);
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i11 | 0)) break; else i2 = i1;
  }
 }
 i2 = HEAP32[i12 + 24 >> 2] | 0;
 i8 = i12 + 28 | 0;
 i1 = i2;
 if ((i1 | 0) != (i8 | 0)) {
  i9 = i14 + 12 | 0;
  i10 = i14 + 16 | 0;
  i11 = i14 + 32 | 0;
  while (1) {
   i4 = i1 + 16 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   L24 : do if ((i3 | 0) < (i5 | 0)) {
    i6 = HEAP32[i11 >> 2] | 0;
    i7 = HEAP32[i4 >> 2] | 0;
    while (1) {
     if ((HEAP32[i6 + (i3 << 2) >> 2] | 0) == (i7 | 0)) break;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) >= (i5 | 0)) break L24;
    }
    if ((i3 | 0) > -1) __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i14, i4, i1 + 20 | 0, 0);
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i8 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i8 = i12 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i20;
  return;
 }
 i9 = i14 + 20 | 0;
 i10 = i14 + 24 | 0;
 i11 = i14 + 32 | 0;
 i12 = i17 + 4 | 0;
 i13 = i18 + 4 | 0;
 while (1) {
  i7 = i2 + 16 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  L44 : do if ((i3 | 0) < (i4 | 0)) {
   i5 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   while (1) {
    if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i6 | 0)) break;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i4 | 0)) break L44;
   }
   if ((i3 | 0) > -1) {
    i6 = i2 + 36 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (!i3) i3 = 0; else {
     HEAP32[i16 >> 2] = i3;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i3) i19 = 39; else {
      if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
       i4 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[i3 + 32 >> 2] | 0;
       i3 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i3, i16);
       i4 = HEAP32[i15 >> 2] | 0;
       i21 = HEAP32[i3 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i3 = (i4 | 0) == -1 ? i21 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i21 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i19 = 39; else {
       i3 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i3) i19 = 41;
      }
     }
     if ((i19 | 0) == 39) i19 = 41;
     if ((i19 | 0) == 41) {
      i19 = 0;
      i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
     }
    }
    HEAP32[i17 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i13 >> 2] = HEAP32[i2 + 32 >> 2];
    __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i14, i7, i3, i17, i18);
   }
  } while (0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i8 | 0)) break; else i1 = i2;
 }
 STACKTOP = i20;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 77;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 77;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 77;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 77;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 77;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sq10AABBPruner9buildStepEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i8 + 7810 >> 0] | 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i7 = i8 + 7744 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L4 : do switch (i1 | 0) {
 case 0:
  {
   i6 = HEAP32[i8 + 7764 >> 2] | 0;
   if (!i6) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   i1 = i8 + 40 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx2Sq8AABBTreeD2Ev(i2);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i9 + 1 | 0, i2);
   }
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i2 = _PxGetFoundation() | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
   i2 = mftCall_iiiiii(i4 | 0, i3 | 0, 548, (i2 ? gb + 706631 | 0 : gb + 837976 | 0) | 0, gb + 706743 | 0, 663) | 0;
   __ZN5physx2Sq8AABBTreeC2Ev(i2);
   HEAP32[i1 >> 2] = i2;
   i1 = i8 + 48 | 0;
   HEAP32[i1 >> 2] = i6;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 * 24 | 0, gb + 706743 | 0, 666) | 0;
   HEAP32[i8 + 44 >> 2] = i2;
   i3 = HEAP32[i8 + 7772 >> 2] | 0;
   i4 = i2;
   i5 = 0;
   do {
    HEAP32[i2 + (i5 * 24 | 0) >> 2] = HEAP32[i3 + (i5 * 24 | 0) >> 2];
    HEAP32[i2 + (i5 * 24 | 0) + 4 >> 2] = HEAP32[i3 + (i5 * 24 | 0) + 4 >> 2];
    HEAP32[i2 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i3 + (i5 * 24 | 0) + 8 >> 2];
    HEAP32[i2 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i3 + (i5 * 24 | 0) + 12 >> 2];
    HEAP32[i2 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i3 + (i5 * 24 | 0) + 16 >> 2];
    HEAP32[i2 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i3 + (i5 * 24 | 0) + 20 >> 2];
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
   i3 = i8 + 96 | 0;
   i6 = i8 + 140 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i5;
   HEAP32[i8 + 24 >> 2] = 0;
   HEAP32[i8 + 20 >> 2] = 0;
   HEAP32[i8 + 32 >> 2] = 0;
   HEAP32[i8 + 36 >> 2] = 0;
   HEAP32[i8 + 16 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 28 >> 2] = i4;
   HEAP32[i8 + 12 >> 2] = 2;
   HEAP32[i8 + 8 >> 2] = 1;
   HEAP8[i8 + 7811 >> 0] = 1;
   HEAP32[i7 >> 2] = 1;
   i1 = 1;
   break;
  }
 case 1:
  {
   __ZN5physx2Sq8AABBTree16progressiveBuildEPNS0_15AABBTreeBuilderEjj(HEAP32[i8 + 40 >> 2] | 0, i8 + 8 | 0, 0, 0) | 0;
   HEAP32[i7 >> 2] = 2;
   HEAP32[i8 + 52 >> 2] = 0;
   i4 = HEAP32[i8 + 16 >> 2] | 0;
   do if (i4 >>> 0 < 2) i1 = 0; else if (i4 >>> 0 < 4) i1 = 1; else if (i4 >>> 0 < 8) i1 = 2; else if (i4 >>> 0 < 16) i1 = 3; else if (i4 >>> 0 < 32) i1 = 4; else if (i4 >>> 0 < 64) i1 = 5; else if (i4 >>> 0 < 128) i1 = 6; else if (i4 >>> 0 < 256) i1 = 7; else if (i4 >>> 0 < 512) i1 = 8; else if (i4 >>> 0 < 1024) i1 = 9; else if (i4 >>> 0 < 2048) i1 = 10; else if (i4 >>> 0 < 4096) i1 = 11; else if (i4 >>> 0 < 8192) i1 = 12; else if (i4 >>> 0 < 16384) i1 = 13; else if (i4 >>> 0 < 32768) i1 = 14; else if (i4 >>> 0 < 65536) i1 = 15; else if (i4 >>> 0 < 131072) i1 = 16; else {
    if (i4 >>> 0 < 262144) {
     i1 = 17;
     break;
    }
    if (i4 >>> 0 < 524288) {
     i1 = 18;
     break;
    }
    if (i4 >>> 0 < 1048576) {
     i1 = 19;
     break;
    }
    if (i4 >>> 0 < 2097152) {
     i1 = 20;
     break;
    }
    if (i4 >>> 0 < 4194304) {
     i1 = 21;
     break;
    }
    if (i4 >>> 0 < 8388608) {
     i1 = 22;
     break;
    }
    if (i4 >>> 0 < 16777216) {
     i1 = 23;
     break;
    }
    if (i4 >>> 0 < 33554432) {
     i1 = 24;
     break;
    }
    if (i4 >>> 0 < 67108864) {
     i1 = 25;
     break;
    }
    if (i4 >>> 0 < 134217728) {
     i1 = 26;
     break;
    }
    if (i4 >>> 0 < 268435456) {
     i1 = 27;
     break;
    }
    if (i4 >>> 0 < 536870912) {
     i1 = 28;
     break;
    }
    if (i4 >>> 0 < 1073741824) {
     i1 = 29;
     break;
    }
    i1 = i4 >>> 31 | 30;
   } while (0);
   i2 = Math_imul(i4, i1) | 0;
   i1 = HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + 540 >> 2] | 0;
   i3 = i8 + 7756 | 0;
   if (i2 >>> 0 > i1 << 1 >>> 0 | i2 >>> 0 < i1 >>> 1 >>> 0) {
    HEAP32[i3 >> 2] = 0;
    i1 = 0;
   } else {
    i2 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i1 = (Math_imul(i4, i1) | 0) + i2 | 0;
   HEAP32[i8 + 7752 >> 2] = (i1 | 0) < 0 ? 0 : i1;
   i1 = 2;
   break;
  }
 case 2:
  {
   i6 = i8 + 52 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   if (!(__ZN5physx2Sq8AABBTree16progressiveBuildEPNS0_15AABBTreeBuilderEjj(HEAP32[i8 + 40 >> 2] | 0, i8 + 8 | 0, 1, (((HEAP32[i8 + 7752 >> 2] | 0) >>> 0) / ((HEAP32[i8 + 7748 >> 2] | 0) >>> 0) | 0) + 1 | 0) | 0)) {
    HEAP32[i7 >> 2] = 3;
    i1 = 3;
    break L4;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    break L4;
   }
  }
 default:
  {}
 } while (0);
 HEAP8[i8 + 7809 >> 0] = 1;
 i8 = (i1 | 0) == 3;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i8, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i8 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i8 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i8 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i3 = i8 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i1 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 68 | 0, i9);
 i3 = i8 + 88 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = i8 + 92 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
  i2 = i4;
 }
 i4 = i8 + 104 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i8 + 108 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 116 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 120 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 124 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i10 = i8 + 144 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i9, i10, 0);
  i10 = i8 + 128 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i10, 0);
  i10 = HEAP32[i1 >> 2] | 0;
  i10 = i10 & -13;
  i10 = i10 | 8;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
  i10 = i8 + 144 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i9, i10, 0);
  i10 = i8 + 128 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i10, 0);
  i10 = HEAP32[i1 >> 2] | 0;
  i10 = i10 & -13;
  i10 = i10 | 8;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 32, 4) | 0;
      HEAP32[i2 + 20 >> 2] = 0;
      HEAP32[i2 + 24 >> 2] = 0;
      HEAP32[i2 + 28 >> 2] = 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP32[i2 + 12 >> 2] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 902839 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine20StateMachineConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 32, 4) | 0;
       HEAP32[i2 + 20 >> 2] = 0;
       HEAP32[i2 + 24 >> 2] = 0;
       HEAP32[i2 + 28 >> 2] = 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP32[i2 + 12 >> 2] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 902839 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine20StateMachineConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZN14NavMeshManager17UpdateCrowdSystemEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i20 + 8 | 0;
 i12 = i20;
 i14 = i20 + 36 | 0;
 i15 = i20 + 16 | 0;
 i10 = i20 + 56 | 0;
 f11 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (f11 == Math_fround(0.0)) {
  STACKTOP = i20;
  return;
 }
 i13 = i4 + 52 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN7dtCrowd6updateEfP21dtCrowdAgentDebugInfoi(HEAP32[i4 + 100 >> 2] | 0, f11, 0, 0);
 i3 = gb + 64016 | 0;
 i17 = HEAP32[i3 + 4 >> 2] | 0;
 i16 = i12;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i14 >> 2] = 0;
 i16 = i14 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i3 = i9;
 i18 = HEAP32[i3 + 4 >> 2] | 0;
 i19 = i17;
 HEAP32[i19 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i3 = i12;
 HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i3 + 4 >> 2] = i18;
 HEAP32[i15 >> 2] = 0;
 i3 = i15 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i18 = i15 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i7 = i9;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  HEAP32[i16 >> 2] = i1;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i18 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i18 >> 2] = i1;
  i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i15 >> 2] = i8;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i15 >> 2] = i8;
  break;
 } else i8 = HEAP32[i15 >> 2] | 0; while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 i7 = ((i1 | 0) / 10 | 0) + 1 | 0;
 i7 = (i7 | 0) > 16 ? 16 : i7;
 i5 = HEAP32[i4 + 40 >> 2] | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) > -10) {
  i4 = 0;
  i2 = 0;
  while (1) {
   i3 = (i1 | 0) / (i7 - i2 | 0) | 0;
   HEAP32[gb + 1459548 + (i2 * 20 | 0) >> 2] = i5 + (i4 << 2);
   HEAP32[gb + 1459548 + (i2 * 20 | 0) + 4 >> 2] = i6 + (i4 << 2);
   HEAP32[gb + 1459548 + (i2 * 20 | 0) + 8 >> 2] = i8 + (i4 << 2);
   HEAP32[gb + 1459548 + (i2 * 20 | 0) + 12 >> 2] = i3;
   HEAPF32[gb + 1459548 + (i2 * 20 | 0) + 16 >> 2] = f11;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else {
    i4 = i3 + i4 | 0;
    i1 = i1 - i3 | 0;
   }
  }
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i12, fb + 4005 | 0, gb + 1459548 | 0, i7, 0, 1);
 if (HEAP32[i12 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i12);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459260 | 0, i9);
 i1 = __ZN14MessageHandler3GetEv() | 0;
 i2 = HEAP32[gb + 168976 + 24 >> 2] | 0;
 if ((i2 | 0) != -2147483648) {
  i10 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
  i12 = (HEAP32[i1 + 16 >> 2] | 0) + (i10 >>> 5 << 2) | 0;
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~(1 << (i10 & 31));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) {
    __ZN9Transform20SendTransformChangedEi(HEAP32[(HEAP32[i14 >> 2] | 0) + (i3 << 2) >> 2] | 0, i2);
    i1 = HEAP32[i13 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = __ZN14MessageHandler3GetEv() | 0;
 i2 = HEAP32[gb + 168976 + 24 >> 2] | 0;
 if ((i2 | 0) != -2147483648) {
  i12 = (Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
  i13 = (HEAP32[i1 + 16 >> 2] | 0) + (i12 >>> 5 << 2) | 0;
  HEAP32[i13 >> 2] = 1 << (i12 & 31) | HEAP32[i13 >> 2];
 }
 __Z12profiler_endP19ProfilerInformation(gb + 1459260 | 0);
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i19);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i17);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager9setCameraEPKcRKN5physx6PxVec3ES6_S6_(i22, i12, i24, i26, i25) {
 i22 = i22 | 0;
 i12 = i12 | 0;
 i24 = i24 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i27;
 i18 = i27 + 4 | 0;
 i23 = i22 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i23 >> 2] | 0);
 i17 = i22 + 128 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 L1 : do if (!i4) i13 = 10; else {
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i12;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i22 + 120 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i13 = 10; else {
   i3 = HEAP32[i22 + 112 >> 2] | 0;
   i4 = i22 + 116 | 0;
   while (1) {
    i2 = i3 + (i1 * 48 | 0) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i12) | 0)) break;
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i13 = 10;
     break L1;
    }
   }
   if (!i2) i13 = 10; else {
    i11 = i24 + 4 | 0;
    i9 = i24 + 8 | 0;
    i10 = i26;
    i8 = i26 + 4 | 0;
    i6 = i26 + 8 | 0;
    i7 = i25;
    i5 = i25 + 4 | 0;
    i1 = i25 + 8 | 0;
    i4 = i24;
    i3 = i12;
   }
  }
 } while (0);
 if ((i13 | 0) == 10) {
  i21 = HEAP32[i22 + 40 >> 2] | 0;
  i21 = mftCall_iiii(HEAP32[(HEAP32[i21 >> 2] | 0) + 16 >> 2] | 0, i21 | 0, i12 | 0, i16 | 0) | 0;
  i2 = i21;
  i3 = HEAP32[i24 >> 2] | 0;
  i15 = i24 + 4 | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i9 = i24 + 8 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i26 >> 2] | 0;
  i8 = i26 + 4 | 0;
  i10 = HEAP32[i8 >> 2] | 0;
  i6 = i26 + 8 | 0;
  i11 = HEAP32[i6 >> 2] | 0;
  i12 = HEAP32[i25 >> 2] | 0;
  i19 = i25 + 4 | 0;
  i13 = HEAP32[i19 >> 2] | 0;
  i20 = i25 + 8 | 0;
  i14 = HEAP32[i20 >> 2] | 0;
  HEAP32[i16 >> 2] = i21;
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb(i22 + 96 | 0, i16, i18) | 0;
  if (!(HEAP8[i18 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = gb + 150368 + 8;
   HEAP32[i1 + 12 >> 2] = i3;
   HEAP32[i1 + 16 >> 2] = i4;
   HEAP32[i1 + 20 >> 2] = i5;
   HEAP32[i1 + 24 >> 2] = i7;
   HEAP32[i1 + 28 >> 2] = i10;
   HEAP32[i1 + 32 >> 2] = i11;
   HEAP32[i1 + 36 >> 2] = i12;
   HEAP32[i1 + 40 >> 2] = i13;
   HEAP32[i1 + 44 >> 2] = i14;
   HEAP32[i1 + 8 >> 2] = i2;
  }
  i4 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP8[i21 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i21;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i5 = HEAP32[i22 + 112 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i22 + 120 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  i2 = i5 + (i1 * 48 | 0) | 0;
  if (!(_strcmp(HEAP32[i2 >> 2] | 0, i21) | 0)) {
   i11 = i15;
   i10 = i26;
   i7 = i25;
   i5 = i19;
   i1 = i20;
   i4 = i24;
   i3 = i21;
  } else {
   i3 = HEAP32[i22 + 116 >> 2] | 0;
   do {
    i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    i2 = i5 + (i1 * 48 | 0) | 0;
   } while ((_strcmp(HEAP32[i2 >> 2] | 0, i21) | 0) != 0);
   i11 = i15;
   i10 = i26;
   i7 = i25;
   i5 = i19;
   i1 = i20;
   i4 = i24;
   i3 = i21;
  }
 }
 i13 = i2 + 8 | 0;
 i14 = HEAP32[i4 >> 2] | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i17 = HEAP32[i10 >> 2] | 0;
 i18 = HEAP32[i8 >> 2] | 0;
 i19 = HEAP32[i6 >> 2] | 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 12 >> 2] = i14;
 HEAP32[i2 + 16 >> 2] = i15;
 HEAP32[i2 + 20 >> 2] = i16;
 HEAP32[i2 + 24 >> 2] = i17;
 HEAP32[i2 + 28 >> 2] = i18;
 HEAP32[i2 + 32 >> 2] = i19;
 HEAP32[i2 + 36 >> 2] = i20;
 HEAP32[i2 + 40 >> 2] = i21;
 HEAP32[i2 + 44 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i23 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i23 >> 2] | 0);
 i1 = i22 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i23 >> 2] | 0);
  STACKTOP = i27;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i23 >> 2] | 0);
 if (!i1) {
  STACKTOP = i27;
  return;
 }
 mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i3 | 0, i24 | 0, i26 | 0, i25 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 STACKTOP = i27;
 return;
}

function __Z35CombineMeshIndicesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb(i12, i15, i10, i14) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 16 | 0;
 i18 = i19;
 if ((HEAP16[gb + 1161496 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = i15;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161496 | 0, i16);
  i17 = gb + 1161496 | 0;
 } else i17 = 0;
 i11 = i12 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = (HEAP32[i11 >> 2] | 0) - i7 | 0;
 i13 = (i9 | 0) / 112 | 0;
 i9 = (i9 | 0) == 0;
 if (i9) i1 = 0; else if (i10) {
  i1 = 0;
  i6 = 0;
  do {
   i2 = HEAP32[i7 + (i6 * 112 | 0) >> 2] | 0;
   i4 = HEAP32[i7 + (i6 * 112 | 0) + 4 >> 2] | 0;
   i5 = HEAP32[i7 + (i6 * 112 | 0) + 8 >> 2] | 0;
   do if (i2) {
    i2 = HEAP32[i2 + 32 >> 2] | 0;
    if (!((i5 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0)) {
     i8 = HEAP32[i2 + 128 >> 2] | 0;
     i3 = i8;
     if ((((HEAP32[i2 + 132 >> 2] | 0) - i8 | 0) / 52 | 0 | 0) > (i5 | 0)) {
      if (i4 | 0) if ((HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) break;
      i8 = HEAP32[i3 + (i5 * 52 | 0) + 4 >> 2] | 0;
      i5 = HEAP32[i3 + (i5 * 52 | 0) + 36 >> 2] | 0;
      i1 = (i8 >>> 0 < i5 >>> 0 ? i5 : i8) + i1 | 0;
     }
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i13 | 0));
 } else {
  i1 = 0;
  i6 = 0;
  do {
   i2 = HEAP32[i7 + (i6 * 112 | 0) >> 2] | 0;
   i4 = HEAP32[i7 + (i6 * 112 | 0) + 4 >> 2] | 0;
   i5 = HEAP32[i7 + (i6 * 112 | 0) + 8 >> 2] | 0;
   do if (i2) {
    i2 = HEAP32[i2 + 32 >> 2] | 0;
    if (!((i5 | 0) < 0 | (HEAP32[i2 + 92 >> 2] | 0) == 0)) {
     i8 = HEAP32[i2 + 128 >> 2] | 0;
     i3 = i8;
     if ((((HEAP32[i2 + 132 >> 2] | 0) - i8 | 0) / 52 | 0 | 0) > (i5 | 0)) {
      if (i4 | 0) if ((HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 100 >> 2] | 0) != (HEAP32[i2 + 100 >> 2] | 0)) break;
      i8 = HEAP32[i3 + (i5 * 52 | 0) + 4 >> 2] | 0;
      i5 = HEAP32[i3 + (i5 * 52 | 0) + 36 >> 2] | 0;
      i8 = i8 >>> 0 < i5 >>> 0 ? i5 : i8;
      i1 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
     }
    }
   } while (0);
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i13 | 0));
 }
 i5 = i1 + 1 | 0;
 i7 = __Znaj(i5 >>> 0 > 2147483647 ? -1 : i5 << 1) | 0;
 HEAP32[i18 >> 2] = 0;
 i8 = i18 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 i6 = i18 + 8 | 0;
 if (i5 | 0) {
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i18 >> 2] | 0;
  }
  HEAP32[i18 >> 2] = i4;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i6 >> 2] = i3 + (i5 << 2);
  if (i1 | 0) {
   i6 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 1;
   HEAP32[i16 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i16 >> 2] = 0;
 if (i10) {
  __ZN4Mesh15SetSubMeshCountEjb(i15, 1, 1);
  if (i9) i1 = 0; else {
   i1 = 0;
   i3 = 0;
   do {
    i2 = (HEAP32[i12 >> 2] | 0) + (i3 * 112 | 0) | 0;
    if (HEAP32[i2 >> 2] | 0) i1 = (__Z18ExtractMeshIndicesRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEERK15CombineInstancebRjPt(i18, i2, i14, i16, i7 + (i1 << 1) | 0) | 0) + i1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i13 | 0));
  }
  __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i15, i7, i1, 0, 0, 1) | 0;
 } else {
  __ZN4Mesh15SetSubMeshCountEjb(i15, ((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 112 | 0, 1);
  if (!i9) {
   i1 = 0;
   do {
    i2 = (HEAP32[i12 >> 2] | 0) + (i1 * 112 | 0) | 0;
    if (HEAP32[i2 >> 2] | 0) __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i15, i7, __Z18ExtractMeshIndicesRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEERK15CombineInstancebRjPt(i18, i2, i14, i16, i7) | 0, i1, 0, 1) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 }
 __ZdaPv(i7);
 i1 = HEAP32[i18 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i18 = HEAP32[i18 + 12 >> 2] | 0;
  HEAP32[i16 >> 2] = 1;
  HEAP32[i16 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 if (!i17) {
  STACKTOP = i19;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i19;
 return;
}

function __ZNSt3__29__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE(i2, i14, i15, i16, i17, i12, i1) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i18;
 i11 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474588 | 0) | 0;
 i5 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474596 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i19 | 0, i5 | 0);
 i9 = i19 + 11 | 0;
 i8 = HEAP8[i9 >> 0] | 0;
 i10 = i19 + 4 | 0;
 L1 : do if (!((i8 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i8 & 255) | 0)) {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, i2 | 0, i15 | 0, i16 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i13 = 30;
   break;
  } else {
   i1 = i16 + (i15 - i2 << 2) | 0;
   HEAP32[i12 >> 2] = i1;
   i13 = 29;
   break;
  }
 } else {
  HEAP32[i12 >> 2] = i16;
  i1 = HEAP8[i2 >> 0] | 0;
  switch (i1 << 24 >> 24) {
  case 43:
  case 45:
   {
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, i1 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) {
     i4 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i4 + 4;
     HEAP32[i4 >> 2] = i1;
     i4 = i2 + 1 | 0;
     i13 = 9;
    }
    break;
   }
  default:
   {
    i4 = i2;
    i13 = 9;
   }
  }
  L10 : do if ((i13 | 0) == 9) {
   L12 : do if ((i15 - i4 | 0) > 1) if ((HEAP8[i4 >> 0] | 0) == 48) {
    i1 = i4 + 1 | 0;
    switch (HEAP8[i1 >> 0] | 0) {
    case 88:
    case 120:
     break;
    default:
     {
      i8 = i4;
      break L12;
     }
    }
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, 48) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) break L10;
    i8 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i8 + 4;
    HEAP32[i8 >> 2] = i3;
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, HEAP8[i1 >> 0] | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) break L10;
    i8 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i8 + 4;
    HEAP32[i8 >> 2] = i1;
    i8 = i4 + 2 | 0;
   } else i8 = i4; else i8 = i4; while (0);
   L19 : do if ((i8 | 0) != (i15 | 0)) {
    i1 = i15;
    i3 = i8;
    while (1) {
     i1 = i1 + -1 | 0;
     if (i3 >>> 0 >= i1 >>> 0) break L19;
     i7 = HEAP8[i3 >> 0] | 0;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = i7;
     i3 = i3 + 1 | 0;
    }
   } while (0);
   __THREW__ = 0;
   i7 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    i6 = i8;
    i3 = 0;
    i4 = 0;
    while (1) {
     if (i6 >>> 0 >= i15 >>> 0) break;
     i1 = HEAP8[i9 >> 0] | 0;
     i5 = i1 << 24 >> 24 < 0;
     i20 = HEAP8[(i5 ? HEAP32[i19 >> 2] | 0 : i19) + i3 >> 0] | 0;
     if (i20 << 24 >> 24 != 0 & (i4 | 0) == (i20 << 24 >> 24 | 0)) {
      i4 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i4 + 4;
      HEAP32[i4 >> 2] = i7;
      i3 = (i3 >>> 0 < ((i5 ? HEAP32[i10 >> 2] | 0 : i1 & 255) + -1 | 0) >>> 0 & 1) + i3 | 0;
      i4 = 0;
     }
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0, i11 | 0, HEAP8[i6 >> 0] | 0) | 0;
     i20 = __THREW__;
     __THREW__ = 0;
     if (i20 & 1) {
      i13 = 26;
      break;
     }
     i20 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i20 + 4;
     HEAP32[i20 >> 2] = i1;
     i6 = i6 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
    if ((i13 | 0) == 26) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     i13 = 30;
     break L1;
    }
    i4 = i2;
    i1 = i16 + (i8 - i4 << 2) | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = i4;
     i13 = 29;
     break L1;
    } else i2 = i3;
    while (1) {
     i2 = i2 + -4 | 0;
     if (i1 >>> 0 >= i2 >>> 0) {
      i2 = i4;
      i1 = i3;
      i13 = 29;
      break L1;
     }
     i20 = HEAP32[i1 >> 2] | 0;
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i20;
     i1 = i1 + 4 | 0;
    }
   }
  } while (0);
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i13 = 30;
 } while (0);
 if ((i13 | 0) == 29) {
  HEAP32[i17 >> 2] = (i14 | 0) == (i15 | 0) ? i1 : i16 + (i14 - i2 << 2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  STACKTOP = i18;
  return;
 } else if ((i13 | 0) == 30) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i19);
  ___resumeException(i1 | 0);
 }
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_(i31, i1, i3, i2) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 168 | 0;
 i26 = i30;
 i22 = i30 + 688 | 0;
 i29 = i30 + 384 | 0;
 i20 = i30 + 640 | 0;
 i25 = i30 + 720 | 0;
 i27 = i30 + 336 | 0;
 i23 = i30 + 172 | 0;
 i24 = i31 + 8 | 0;
 i19 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i24 >> 2] | 0) | 0;
 i21 = i29 + 240 | 0;
 i6 = i29 + 244 | 0;
 HEAP32[i29 + 248 >> 2] = 0;
 i7 = i29 + 252 | 0;
 HEAP8[i21 >> 0] = 1;
 HEAP32[i6 >> 2] = i29;
 HEAP32[i7 >> 2] = 5;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 8 >> 2] = Math_fround(.300000012);
 HEAPF32[i20 + 12 >> 2] = Math_fround(.100000001);
 i18 = i20 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAPF32[i20 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 36 >> 2] = Math_fround(1.0);
 __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i29, i5, i20);
 if (i5 | 0) {
  i8 = i26 + 4 | 0;
  i9 = i31 + 4 | 0;
  i10 = i31 + 12 | 0;
  i11 = i31 + 16 | 0;
  i12 = i27;
  i13 = i22 + 4 | 0;
  i14 = i22 + 8 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 20 | 0;
  i18 = i22 + 24 | 0;
  i20 = 0;
  do {
   i1 = i25;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i28 >> 2] = i20;
   __ZN5physx6string9sprintf_sEPcjPKcz(i25, 32, gb + 832301 | 0, i28) | 0;
   i1 = HEAP32[i31 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i31 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i31 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i26 >> 2] = i25;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i33 = i26;
    i32 = HEAP32[i33 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i4 + 4 >> 2] = i32;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i26) | 0;
   mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, HEAP32[i24 >> 2] | 0, i20 | 0);
   _memset(i23 | 0, 0, 164) | 0;
   __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev(i23);
   i32 = HEAP32[i31 >> 2] | 0;
   i33 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev(i26);
   HEAP32[i22 >> 2] = i32;
   HEAP32[i13 >> 2] = i33;
   HEAP32[i14 >> 2] = i12;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = i2;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   __ZNK5physx36PxVehicleSuspensionDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEEEEEjT_j(i26, i22, 0) | 0;
   i2 = HEAP32[i31 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i31 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i5 | 0));
 }
 i33 = HEAP32[i7 >> 2] | 0;
 if (!((i33 | 0) > -1 & (i33 & 2147483647 | 0) != 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i29 | 0) == (i1 | 0)) {
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i30;
  return;
 }
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i33 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2] | 0, i33 | 0, i1 | 0);
 STACKTOP = i30;
 return;
}

function __ZN16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i24, i7, i5) {
 i24 = i24 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26 + 64 | 0;
 i23 = i26;
 i13 = i24 + 28 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 190576 | 0) | 0;
 if (!i1) {
  i25 = -1;
  STACKTOP = i26;
  return i25 | 0;
 }
 i25 = i1 + 56 | 0;
 i2 = HEAP32[i25 >> 2] | 0;
 i3 = HEAP32[i25 + 4 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i25 = -1;
  STACKTOP = i26;
  return i25 | 0;
 }
 i14 = i1 + 72 | 0;
 i15 = i3 - i2 | 0;
 i16 = (i15 | 0) / 48 | 0;
 i17 = i24 + 372 | 0;
 i18 = HEAP32[i17 >> 2] << 4;
 i19 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i7, i5) | 0;
 i20 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, gb + 64024 | 0, 0, gb + 1048339 | 0, 226) | 0;
 i21 = (i18 | 0) == 0;
 i6 = i5 + 12 | 0;
 if (i21) i12 = 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 + i18 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
   __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, i18 >>> 0 < 32768 ? 32768 : i18);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i12 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
  HEAP32[i3 >> 2] = i1 + i18;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i19 * 360 | 0) + 332 >> 2] = fb + 331;
 HEAP32[i5 + (i19 * 360 | 0) + 344 >> 2] = fb + 4434;
 HEAP32[i5 + (i19 * 360 | 0) + 248 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 204 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i6 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 204;
 i11 = i5 + (i19 * 360 | 0) + 328 | 0;
 HEAP32[i11 >> 2] = i6;
 i6 = __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
 i7 = HEAP32[i6 + 892 >> 2] | 0;
 HEAP32[i22 >> 2] = i7;
 i8 = HEAP32[i6 + 896 >> 2] | 0;
 HEAP32[i22 + 4 >> 2] = i8;
 i9 = HEAP32[i6 + 900 >> 2] | 0;
 HEAP32[i22 + 8 >> 2] = i9;
 i10 = (HEAP8[i6 + 1088 >> 0] | 0) == 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i23, i5);
 i1 = i11;
 i2 = i23;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i11 + 64 | 0;
 i2 = __ZNK6Camera22GetWorldToCameraMatrixEv(i6) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i11 + 128 | 0;
 i2 = i14 + 36 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i23, i5, i22); else {
  HEAP32[i23 >> 2] = i7;
  HEAP32[i23 + 4 >> 2] = i8;
  HEAP32[i23 + 8 >> 2] = i9;
 };
 HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 i22 = i11 + 140 | 0;
 __ZNK9Transform11GetRotationEv(i23, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 if (i10) {
  f4 = Math_fround(__ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv(i6));
  f4 = Math_fround(-Math_fround(f4 * Math_fround(HEAPF32[i24 + 352 >> 2])));
  HEAPF32[i11 + 156 >> 2] = Math_fround(f4 / Math_fround(__ZNK6Camera6GetFarEv(i6)));
  f4 = Math_fround(0.0);
 } else {
  HEAPF32[i11 + 156 >> 2] = Math_fround(0.0);
  f4 = Math_fround(__ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv(i6));
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i24 + 352 >> 2]));
 }
 HEAPF32[i11 + 160 >> 2] = f4;
 HEAP32[i11 + 164 >> 2] = HEAP32[i24 + 368 >> 2];
 HEAP32[i11 + 168 >> 2] = HEAP32[i24 + 348 >> 2];
 HEAP32[i11 + 172 >> 2] = HEAP32[i24 + 344 >> 2];
 f4 = Math_fround(HEAP32[i17 >> 2] | 0);
 HEAP32[i11 + 180 >> 2] = ~~Math_fround(f4 * Math_fround(HEAPF32[i24 + 364 >> 2]));
 HEAP32[i11 + 176 >> 2] = HEAP32[i24 + 340 >> 2];
 HEAP8[i11 + 184 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP32[i11 + 192 >> 2] = i20;
 HEAP32[i11 + 188 >> 2] = i16;
 _memcpy(i20 | 0, HEAP32[i25 >> 2] | 0, i15 | 0) | 0;
 HEAP32[i11 + 196 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i11 + 200 >> 2] = i12;
 if (!i21) _memcpy(i12 | 0, HEAP32[i24 + 376 >> 2] | 0, i18 | 0) | 0;
 i25 = i19;
 STACKTOP = i26;
 return i25 | 0;
}

function __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i8 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i8 + 64 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 104 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 105 >> 0] = i1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 106 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i1 = i7;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i8 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN13RenderManager13RenderCamerasEiPFvvE(i8, i9, i16) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 1392 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i23;
 i17 = i23 + 1376 | 0;
 i18 = i23 + 1384 | 0;
 i19 = i8 + 52 | 0;
 HEAP8[i19 >> 0] = 1;
 i20 = HEAP32[gb + 1112704 >> 2] | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i21 = i8 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) == (i21 | 0)) {
  HEAP8[i19 >> 0] = 0;
  __ZN13RenderManager23AddRemoveCamerasDelayedEv(i8);
  STACKTOP = i23;
  return;
 }
 i10 = i20 + 152 | 0;
 i7 = i18 + 4 | 0;
 i11 = i20 + 40 | 0;
 i12 = i20 + 52 | 0;
 i13 = (i16 | 0) == 0;
 i14 = i20 + 56 | 0;
 i15 = i20 + 44 | 0;
 do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i17 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i22 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i17);
     i3 = HEAP32[i6 >> 2] | 0;
     i24 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i24 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i24 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i22 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i22 = 12;
    }
   }
   if ((i22 | 0) == 10) i22 = 12;
   if ((i22 | 0) == 12) {
    i22 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  if ((HEAP16[gb + 1112340 + 6 >> 1] | 0) > -1) {
   HEAP32[i17 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112340 | 0, i6);
   i3 = gb + 1112340 | 0;
  } else i3 = 0;
  i24 = HEAP32[gb + 1112340 >> 2] | 0;
  i5 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 648 >> 2] | 0, i5 | 0, i24 | 0);
  i24 = HEAP32[i1 + 820 >> 2] | 0;
  if ((i24 | 0) == (i9 | 0) & (i24 | 0) == 0) {
   if (HEAP8[i10 >> 0] | 0) {
    HEAP8[i10 >> 0] = 0;
    __ZN13RendererScene15InitializeUmbraEv(i20);
   }
   HEAP32[i8 >> 2] = HEAP32[i1 + 4 >> 2];
   if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) if (__Z14IsWorldPlayingv() | 0) {
    if (__Z12GetIVRDevicev() | 0) {
     i24 = __Z12GetIVRDevicev() | 0;
     if (mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 88 >> 2] | 0, i24 | 0) | 0) {
      HEAP32[i18 >> 2] = fb + 151;
      HEAP32[i7 >> 2] = 0;
      HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
      HEAP32[i6 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
      __ZN6Camera12RenderStereoENS_10RenderFlagE8CullFlagMS_FvR11CullResultsR17ShaderPassContextPK21CameraRenderingParamsS0_PvES9_(i1, 4, 0, i6, 0);
     }
    }
   } else i22 = 25; else i22 = 25; else i22 = 25;
   if ((i22 | 0) == 25) {
    i22 = 0;
    __ZN11CullResultsC2Ev(i6);
    if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) __ZN6Camera4CullER11CullResults8CullFlag(i1, i6, 0);
    if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) {
     __ZN6Camera14UpdateVelocityEv(i1);
     __ZN6Camera6RenderER11CullResultsR17ShaderPassContextNS_10RenderFlagE(i1, i6, HEAP32[gb + 1166248 >> 2] | 0, 4);
    }
    __ZN11CullResultsD2Ev(i6);
   }
   __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) {
    i24 = HEAP32[i11 >> 2] | 0;
    __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i24, i24 + (i1 << 2) | 0, i6);
    i1 = (HEAP32[i12 >> 2] | 0) + -1 | 0;
    if ((i1 | 0) > -1) do {
     __ZN13RendererScene14RemoveRendererEi(i20, HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
     i1 = i1 + -1 | 0;
    } while ((i1 | 0) > -1);
    if ((HEAP32[i14 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i15);
     HEAP32[i11 >> 2] = 0;
    }
    HEAP32[i11 >> 2] = 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i14 >> 2] = 0;
   }
   if (!i13) mftCall_v(i16 | 0);
  }
  i24 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i24 >> 2] | 0) + 652 >> 2] | 0, i24 | 0);
  if (i3 | 0) __Z12profiler_endP19ProfilerInformation(i3);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i21 | 0));
 HEAP8[i19 >> 0] = 0;
 __ZN13RenderManager23AddRemoveCamerasDelayedEv(i8);
 STACKTOP = i23;
 return;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 108 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 108 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -108 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -96 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 39768215) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 108 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 19884107 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 39768215;
  if (i1 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 108 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 108 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 108 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 108 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i2 = i1 + 16 | 0;
   i3 = i8 + 16 | 0;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i8 = i8 + 108 | 0;
   i1 = i1 + 108 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 108 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -108 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -96 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZN13MemoryManager10ReallocateEPvjiRK10MemLabelId15AllocateOptionsPKci(i12, i9, i13, i1, i7, i14, i10, i11) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 8 | 0;
 i2 = i15;
 i8 = i15 + 12 | 0;
 if (!i9) {
  i14 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i12, i13, i1, i7, i14, i10, i11) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!i13) {
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i12, i9, i7);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i5 = i1 + -1 | 15;
 i6 = i5 + 1 | 0;
 if ((i5 + 65537 | 0) >>> 0 > ~i13 >>> 0) if (!(i14 & 1)) {
  __Z6FormatPKcz(i8, gb + 581944 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 581974 | 0, 1166, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 } else {
  __Z6FormatPKcz(i8, gb + 581944 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 581974 | 0, 1170, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!(HEAP8[i12 + 1550 >> 0] | 0)) {
  i14 = HEAP32[i12 + 1560 >> 2] | 0;
  i14 = mftCall_iiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i9 | 0, i13 | 0, i6 | 0) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 4) {
  if ((i1 | 0) == 1) i1 = __ZN12TLSAllocatorI14StackAllocatorE10ReallocateEPvji(HEAP32[i12 + 1552 >> 2] | 0, i9, i13, i6) | 0; else {
   i1 = HEAP32[i12 + 3824 + (i1 * 24 | 0) >> 2] | 0;
   i1 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i9 | 0, i13 | 0, i6 | 0) | 0;
  }
  if (i1 | 0) {
   i14 = i1;
   STACKTOP = i15;
   return i14 | 0;
  }
  i14 = __ZN13MemoryManager10ReallocateEPvjiRK10MemLabelId15AllocateOptionsPKci(i12, i9, i13, i6, gb + 64032 | 0, i14, i10, i11) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((i1 + -57 | 0) >>> 0 < 2) i5 = 0; else if (!(__Z31profiler_get_memory_record_modev() | 0)) i5 = 0; else {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1188372 | 0, 0);
  i5 = gb + 1188372 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 128) i3 = HEAP32[i12 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
  i3 = HEAP32[i12 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i3 = i3 >>> 0 > 512 >>> 0 ? i3 : 0;
 }
 if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i9 | 0) | 0) {
  i1 = HEAP32[gb + 1188408 >> 2] | 0;
  do if (!i1) {
   i1 = HEAP32[gb + 73344 >> 2] | 0;
   i2 = i1 + 6960 | 0;
   HEAP32[gb + 73344 >> 2] = i2;
   if (i2 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
    __ZN13MemoryManagerC2Ev(i1);
    HEAP32[gb + 1188408 >> 2] = i1;
    i4 = i1;
    break;
   }
  } else i4 = i1; while (0);
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) < 128) i1 = HEAP32[i4 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
   i1 = HEAP32[i4 + 1764 + (i1 + -128 << 2) >> 2] | 0;
   i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
  }
  if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i9 | 0) | 0)) i2 = 0; else {
   i1 = __Z18get_root_referencePvRK10MemLabelId(i9, i7) | 0;
   if (!i1) i2 = 0; else {
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i2 = i1;
   }
  }
  __ZN13MemoryManager20RegisterDeallocationEPvRK10MemLabelIdPKc(i12, i9, i7, gb + 582480 | 0);
  i1 = mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i9 | 0, i13 | 0, i6 | 0) | 0;
  if ((i14 & 1 | 0) == 0 | (i1 | 0) != 0) {
   if (!i1) __ZL16OutOfMemoryErrorjiRK10MemLabelIdiPKc(i13, i6, i7, i11, i10);
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN13MemoryManager18RegisterAllocationEPvjRK10MemLabelIdPKcS5_i(i12, i1, i13, i8, gb + 582480 | 0, i10, i11);
   if (i2) __ZN23AllocationRootReference7ReleaseEv(i2);
  } else i1 = 0;
 } else {
  i1 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i12, i13, i6, i7, i14, i10, i11) | 0;
  if ((i14 & 1 | 0) == 0 | (i1 | 0) != 0) {
   i14 = __ZN13MemoryManager25GetAllocatorContainingPtrEPKv(i12, i9) | 0;
   i14 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0, i9 | 0) | 0;
   _memcpy(i1 | 0, i9 | 0, (i14 >>> 0 < i13 >>> 0 ? i14 : i13) | 0) | 0;
   __ZN13MemoryManager10DeallocateEPv(i12, i9);
  } else i1 = 0;
 }
 if (!i5) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 25;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 25;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 25;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 25;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 25;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E(i16, i3) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, f22 = f0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f7 * f7);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f7 + Math_fround(f5 * f5));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f5 + Math_fround(f7 * f7));
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f5 * f5);
 f22 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f22 = Math_fround(f5 + Math_fround(f22 * f22));
 f5 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f5 = Math_fround(f22 + Math_fround(f5 * f5));
 f22 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f22 = Math_fround(f22 * f22);
 f4 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f4 = Math_fround(f22 + Math_fround(f4 * f4));
 f22 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f22 = Math_fround(f4 + Math_fround(f22 * f22));
 HEAPF32[i16 >> 2] = f7;
 HEAPF32[i16 + 4 >> 2] = f5;
 HEAPF32[i16 + 8 >> 2] = f22;
 i21 = f5 > f7 & 1;
 i12 = i21 ^ 1;
 i13 = f22 > Math_fround(HEAPF32[i16 + (i12 << 2) >> 2]);
 i12 = i13 ? 2 : i12;
 i13 = (i21 ^ 3) - i12 | 0;
 f22 = Math_fround(HEAPF32[i16 + (i21 << 2) >> 2]);
 i19 = f22 < Math_fround(HEAPF32[i16 + (i12 << 2) >> 2]);
 i17 = i19 ? i12 : i21;
 i12 = i19 ? i21 : i12;
 i21 = i16 + (i17 << 2) | 0;
 f22 = Math_fround(HEAPF32[i21 >> 2]);
 f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f22))));
 f22 = Math_fround(f22 * f7);
 i19 = i3 + (i17 * 12 | 0) | 0;
 f5 = Math_fround(f7 * Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i19 >> 2] = f5;
 i18 = i3 + (i17 * 12 | 0) + 4 | 0;
 f4 = Math_fround(f7 * Math_fround(HEAPF32[i18 >> 2]));
 HEAPF32[i18 >> 2] = f4;
 i17 = i3 + (i17 * 12 | 0) + 8 | 0;
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i17 >> 2] = f7;
 i8 = i3 + (i12 * 12 | 0) | 0;
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f5 * f20);
 i9 = i3 + (i12 * 12 | 0) + 4 | 0;
 f11 = Math_fround(HEAPF32[i9 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f4 * f11));
 i10 = i3 + (i12 * 12 | 0) + 8 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f7 * f6));
 i14 = i3 + (i13 * 12 | 0) | 0;
 f2 = Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2]));
 i15 = i3 + (i13 * 12 | 0) + 4 | 0;
 f2 = Math_fround(f2 + Math_fround(f4 * Math_fround(HEAPF32[i15 >> 2])));
 i3 = i3 + (i13 * 12 | 0) + 8 | 0;
 f2 = Math_fround(f2 + Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i21 >> 2] = Math_fround(f22 + Math_fround(Math_fround(Math_abs(Math_fround(f1))) + Math_fround(Math_abs(Math_fround(f2)))));
 f4 = Math_fround(f1 * f4);
 f7 = Math_fround(f1 * f7);
 HEAPF32[i8 >> 2] = Math_fround(f20 - Math_fround(f1 * f5));
 HEAPF32[i9 >> 2] = Math_fround(f11 - f4);
 HEAPF32[i10 >> 2] = Math_fround(f6 - f7);
 f7 = Math_fround(f2 * Math_fround(HEAPF32[i19 >> 2]));
 f6 = Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2]));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i17 >> 2]));
 f7 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f7);
 HEAPF32[i14 >> 2] = f7;
 f6 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f6);
 HEAPF32[i15 >> 2] = f6;
 f2 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f2);
 HEAPF32[i3 >> 2] = f2;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f11 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f5 * f5));
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 f11 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f1 * f1))));
 if (f11 > Math_fround(0.0)) {
  f7 = Math_fround(Math_fround(1.0) / f11);
  f4 = Math_fround(f4 * f7);
  HEAPF32[i8 >> 2] = f4;
  f5 = Math_fround(f5 * f7);
  HEAPF32[i9 >> 2] = f5;
  f1 = Math_fround(f1 * f7);
  HEAPF32[i10 >> 2] = f1;
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f6 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i3 >> 2]);
 }
 f20 = Math_fround(Math_fround(Math_fround(f4 * f7) + Math_fround(f5 * f6)) + Math_fround(f1 * f2));
 HEAPF32[i16 + (i12 << 2) >> 2] = Math_fround(f11 + Math_fround(Math_abs(Math_fround(f20))));
 f22 = Math_fround(f20 * f5);
 f1 = Math_fround(f20 * f1);
 f5 = Math_fround(f7 - Math_fround(f4 * f20));
 HEAPF32[i14 >> 2] = f5;
 f4 = Math_fround(f6 - f22);
 HEAPF32[i15 >> 2] = f4;
 f1 = Math_fround(f2 - f1);
 HEAPF32[i3 >> 2] = f1;
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)))));
 if (!(f2 > Math_fround(0.0))) {
  i21 = i16 + (i13 << 2) | 0;
  HEAPF32[i21 >> 2] = f2;
  return;
 }
 f22 = Math_fround(Math_fround(1.0) / f2);
 HEAPF32[i14 >> 2] = Math_fround(f5 * f22);
 HEAPF32[i15 >> 2] = Math_fround(f4 * f22);
 HEAPF32[i3 >> 2] = Math_fround(f1 * f22);
 i21 = i16 + (i13 << 2) | 0;
 HEAPF32[i21 >> 2] = f2;
 return;
}

function __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef(i11, i12, i13, i14, f15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 32 | 0;
 i9 = i17 + 16 | 0;
 i5 = i17;
 i16 = i17 + 4 | 0;
 i6 = i11 + 64 + (i14 * 12 | 0) | 0;
 i10 = i11 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 8;
  }
 }
 if ((i7 | 0) == 6) i7 = 8;
 if ((i7 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0;
 i4 = (Math_imul(HEAP32[i1 + 128 + 36 >> 2] | 0, i13) | 0) + i12 | 0;
 HEAP32[i5 >> 2] = i4;
 i2 = i11 + 64 + (i14 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i7 = 19;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i7 = 12;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i7 = 18;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i7 = 16;
     break;
    } else i1 = i2;
   }
  }
  if ((i7 | 0) == 12) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   i7 = 19;
   break;
  } else if ((i7 | 0) == 16) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i3;
   i7 = 19;
   break;
  } else if ((i7 | 0) == 18) {
   HEAP32[i8 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i2 = i8;
    i7 = 19;
    break;
   } else {
    i4 = i1;
    break;
   }
  }
 } while (0);
 if ((i7 | 0) == 19) {
  __ZNSt3__23mapIj17DetailPatchRenderNS_4lessIjEE11memory_poolINS_4pairIKjS1_EEEE25__construct_node_with_keyERS6_(i9, i6, i5);
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = i4;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (!i1) i1 = i3; else {
   HEAP32[i6 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 64 + (i14 * 12 | 0) + 4 >> 2] | 0, i1);
  i4 = i11 + 64 + (i14 * 12 | 0) + 8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = i3;
 }
 i5 = i4 + 20 | 0;
 i6 = i4 + 26 | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i14 = i11 + 112 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i16 = i4 + 28 | 0;
  HEAP32[i16 >> 2] = i14;
  STACKTOP = i17;
  return i5 | 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 28; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 28; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 30;
  }
 }
 if ((i7 | 0) == 28) i7 = 30;
 if ((i7 | 0) == 30) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i11 + 24 >> 2];
 i14 = __ZN14DetailDatabase9BuildMeshEii8Vector3f16DetailRenderModef(i1 + 128 | 0, i12, i13, i16, i14, f15) | 0;
 HEAP32[i5 >> 2] = i14;
 HEAP8[i4 + 25 >> 0] = (i14 | 0) == 0 & 1;
 HEAP32[i4 + 32 >> 2] = i12;
 HEAP32[i4 + 36 >> 2] = i13;
 HEAP8[i6 >> 0] = 1;
 i14 = i11 + 112 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i16 = i4 + 28 | 0;
 HEAP32[i16 >> 2] = i14;
 STACKTOP = i17;
 return i5 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i17, i1, i5, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 16 | 0;
 i14 = i19;
 i16 = i17 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i13) | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i17 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i15 = HEAP32[i17 + 20 >> 2] | 0;
    i15 = (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i15;
    i1 = HEAP32[i17 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i15;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i15 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i15 + 4 >> 2] | 0) + ((HEAP32[i15 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i15 = i17 + 36 | 0;
 L12 : do if (HEAP8[i15 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i17, gb + 830924 | 0);
  if (!(HEAP8[i15 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i17 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i15 >> 0] = i1;
  }
  i12 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i12 = HEAP32[i17 >> 2] | 0;
  HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i7 = i17 + 20 | 0;
   i8 = i17 + 40 | 0;
   i9 = i17 + 24 | 0;
   i10 = i14 + 4 | 0;
   i11 = i14 + 8 | 0;
   i12 = i14 + 12 | 0;
   i5 = i5 + 12 | 0;
   i6 = 0;
   while (1) {
    i1 = HEAP32[i7 >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i18 = 17; else if (!(HEAP8[i1 >> 0] | 0)) i18 = 17; else {
     HEAP32[i13 >> 2] = i1;
     i1 = _strtoul(i1, i13, 10) | 0;
     i2 = _strtoul(HEAP32[i13 >> 2] | 0, i13, 10) | 0;
     i3 = _strtoul(HEAP32[i13 >> 2] | 0, i13, 10) | 0;
     i4 = _strtoul(HEAP32[i13 >> 2] | 0, 0, 10) | 0;
    }
    if ((i18 | 0) == 17) {
     i18 = 0;
     HEAP8[HEAP32[i8 >> 2] >> 0] = 1;
     i1 = 0;
     i2 = 0;
     i3 = 0;
     i4 = 0;
    }
    i20 = HEAP32[i9 >> 2] | 0;
    HEAP32[i14 >> 2] = i1;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i11 >> 2] = i3;
    HEAP32[i12 >> 2] = i4;
    i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
    mftCall_viii(i4 | 0, i20 | 0, i6 | 0, i13 | 0);
    if (!(HEAP8[i15 >> 0] | 0)) break L12;
    i20 = HEAP32[i7 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 24 >> 2] | 0, i20 | 0) | 0) i6 = i6 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i17 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i18 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i17 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i17 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i15 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i18 | 0) == 24) HEAP8[i15 >> 0] = 1;
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i19;
 return;
}

function __Z19MurmurHash3_x86_128PKvijPv(i1, i8, i4, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = (i8 | 0) / 16 | 0;
 i7 = i1 + (i2 << 4) | 0;
 if ((i8 + 15 | 0) >>> 0 < 31) {
  i6 = i4;
  i3 = i4;
  i1 = i4;
  i5 = i4;
 } else {
  i6 = i4;
  i3 = i4;
  i1 = i4;
  i5 = 0 - i2 | 0;
  while (1) {
   i11 = i5 << 2;
   i2 = HEAP32[i7 + (i11 << 2) >> 2] | 0;
   i13 = HEAP32[i7 + ((i11 | 1) << 2) >> 2] | 0;
   i12 = HEAP32[i7 + ((i11 | 2) << 2) >> 2] | 0;
   i11 = HEAP32[i7 + ((i11 | 3) << 2) >> 2] | 0;
   i2 = (Math_imul((Math_imul(i2, 597399067) | 0) >>> 17 | (Math_imul(i2, -888307712) | 0), -1425107063) | 0) ^ i6;
   i2 = (((i2 >>> 13 | i2 << 19) + i3 | 0) * 5 | 0) + 1444728091 | 0;
   i3 = (Math_imul((Math_imul(i13, -1425107063) | 0) >>> 16 | (Math_imul(i13, -1752629248) | 0), 951274213) | 0) ^ i3;
   i3 = (((i3 >>> 15 | i3 << 17) + i1 | 0) * 5 | 0) + 197830471 | 0;
   i1 = (Math_imul((Math_imul(i12, 951274213) | 0) >>> 15 | (Math_imul(i12, -1781923840) | 0), -1578923117) | 0) ^ i1;
   i1 = (((i1 >>> 17 | i1 << 15) + i4 | 0) * 5 | 0) + -1764942795 | 0;
   i4 = (Math_imul((Math_imul(i11, -1578923117) | 0) >>> 14 | (Math_imul(i11, 776732672) | 0), 597399067) | 0) ^ i4;
   i4 = (((i4 >>> 19 | i4 << 13) + i2 | 0) * 5 | 0) + 850148119 | 0;
   i5 = i5 + 1 | 0;
   if (!i5) {
    i6 = i2;
    i5 = i4;
    break;
   } else i6 = i2;
  }
 }
 switch (i8 & 15) {
 case 15:
  {
   i2 = (HEAPU8[i7 + 14 >> 0] | 0) << 16;
   i10 = 6;
   break;
  }
 case 14:
  {
   i2 = 0;
   i10 = 6;
   break;
  }
 case 13:
  {
   i2 = 0;
   i10 = 7;
   break;
  }
 case 12:
  {
   i2 = i5;
   i10 = 8;
   break;
  }
 case 11:
  {
   i4 = 0;
   i2 = i5;
   i10 = 9;
   break;
  }
 case 10:
  {
   i4 = 0;
   i2 = i5;
   i10 = 10;
   break;
  }
 case 9:
  {
   i4 = 0;
   i2 = i5;
   i10 = 11;
   break;
  }
 case 8:
  {
   i2 = i5;
   i10 = 12;
   break;
  }
 case 7:
  {
   i4 = 0;
   i2 = i5;
   i10 = 13;
   break;
  }
 case 6:
  {
   i4 = 0;
   i2 = i5;
   i10 = 14;
   break;
  }
 case 5:
  {
   i4 = 0;
   i2 = i5;
   i10 = 15;
   break;
  }
 case 4:
  {
   i2 = i5;
   i10 = 16;
   break;
  }
 case 3:
  {
   i4 = 0;
   i2 = i5;
   i10 = 17;
   break;
  }
 case 2:
  {
   i2 = i5;
   i4 = 0;
   i10 = 18;
   break;
  }
 case 1:
  {
   i2 = i5;
   i4 = 0;
   i10 = 19;
   break;
  }
 default:
  {
   i4 = i6;
   i2 = i5;
  }
 }
 if ((i10 | 0) == 6) {
  i2 = (HEAPU8[i7 + 13 >> 0] | 0) << 8 | i2;
  i10 = 7;
 }
 if ((i10 | 0) == 7) {
  i2 = (HEAPU8[i7 + 12 >> 0] | 0) ^ i2;
  i2 = (Math_imul((Math_imul(i2, -1578923117) | 0) >>> 14 | (Math_imul(i2, 776732672) | 0), 597399067) | 0) ^ i5;
  i10 = 8;
 }
 if ((i10 | 0) == 8) {
  i4 = (HEAPU8[i7 + 11 >> 0] | 0) << 24;
  i10 = 9;
 }
 if ((i10 | 0) == 9) {
  i4 = (HEAPU8[i7 + 10 >> 0] | 0) << 16 | i4;
  i10 = 10;
 }
 if ((i10 | 0) == 10) {
  i4 = (HEAPU8[i7 + 9 >> 0] | 0) << 8 ^ i4;
  i10 = 11;
 }
 if ((i10 | 0) == 11) {
  i13 = (HEAPU8[i7 + 8 >> 0] | 0) ^ i4;
  i1 = (Math_imul((Math_imul(i13, 951274213) | 0) >>> 15 | (Math_imul(i13, -1781923840) | 0), -1578923117) | 0) ^ i1;
  i10 = 12;
 }
 if ((i10 | 0) == 12) {
  i4 = (HEAPU8[i7 + 7 >> 0] | 0) << 24;
  i10 = 13;
 }
 if ((i10 | 0) == 13) {
  i4 = (HEAPU8[i7 + 6 >> 0] | 0) << 16 | i4;
  i10 = 14;
 }
 if ((i10 | 0) == 14) {
  i4 = (HEAPU8[i7 + 5 >> 0] | 0) << 8 ^ i4;
  i10 = 15;
 }
 if ((i10 | 0) == 15) {
  i13 = (HEAPU8[i7 + 4 >> 0] | 0) ^ i4;
  i3 = (Math_imul((Math_imul(i13, -1425107063) | 0) >>> 16 | (Math_imul(i13, -1752629248) | 0), 951274213) | 0) ^ i3;
  i10 = 16;
 }
 if ((i10 | 0) == 16) {
  i4 = (HEAPU8[i7 + 3 >> 0] | 0) << 24;
  i10 = 17;
 }
 if ((i10 | 0) == 17) {
  i4 = (HEAPU8[i7 + 2 >> 0] | 0) << 16 | i4;
  i10 = 18;
 }
 if ((i10 | 0) == 18) {
  i4 = (HEAPU8[i7 + 1 >> 0] | 0) << 8 ^ i4;
  i10 = 19;
 }
 if ((i10 | 0) == 19) {
  i4 = (HEAPU8[i7 >> 0] | 0) ^ i4;
  i4 = (Math_imul((Math_imul(i4, 597399067) | 0) >>> 17 | (Math_imul(i4, -888307712) | 0), -1425107063) | 0) ^ i6;
 }
 i10 = i3 ^ i8;
 i11 = i1 ^ i8;
 i13 = i2 ^ i8;
 i12 = i11 + i13 + i10 + (i4 ^ i8) | 0;
 i10 = i12 + i10 | 0;
 i11 = i12 + i11 | 0;
 i13 = i12 + i13 | 0;
 i12 = Math_imul(i12 >>> 16 ^ i12, -2048144789) | 0;
 i12 = Math_imul(i12 >>> 13 ^ i12, -1028477387) | 0;
 i10 = Math_imul(i10 >>> 16 ^ i10, -2048144789) | 0;
 i10 = Math_imul(i10 >>> 13 ^ i10, -1028477387) | 0;
 i10 = i10 >>> 16 ^ i10;
 i11 = Math_imul(i11 >>> 16 ^ i11, -2048144789) | 0;
 i11 = Math_imul(i11 >>> 13 ^ i11, -1028477387) | 0;
 i11 = i11 >>> 16 ^ i11;
 i13 = Math_imul(i13 >>> 16 ^ i13, -2048144789) | 0;
 i13 = Math_imul(i13 >>> 13 ^ i13, -1028477387) | 0;
 i13 = i13 >>> 16 ^ i13;
 i12 = i10 + (i12 >>> 16 ^ i12) + i11 + i13 | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i12 + i10;
 HEAP32[i9 + 8 >> 2] = i12 + i11;
 HEAP32[i9 + 12 >> 2] = i12 + i13;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl18GetCharacterBitmapERjS1_S1_R5RectTIfERfjifj(i8, i9, i10, i11, i12, i13, i6, i1, f14, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 f14 = Math_fround(f14);
 i7 = i7 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15;
 if (!i1) i1 = HEAP32[(HEAP32[i8 + 76 >> 2] | 0) + 36 >> 2] | 0;
 i2 = __ZN20TextRenderingPrivate15DynamicFontData19GetFaceForCharacterERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEERKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEjj(HEAP32[i8 + 204 >> 2] | 0, i8 + 100 | 0, i8 + 116 | 0, i7, i6) | 0;
 if (!i2) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1017543 | 0, 9);
  i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  if (!i2) {
   i13 = 0;
   STACKTOP = i15;
   return i13 | 0;
  }
  i2 = HEAP32[i2 + 48 >> 2] | 0;
  i2 = __ZN20TextRenderingPrivate15DynamicFontData19GetFaceForCharacterERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEERKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEjj(HEAP32[i2 + 204 >> 2] | 0, i2 + 100 | 0, i2 + 116 | 0, i7, i6) | 0;
  if (!i2) {
   i13 = 0;
   STACKTOP = i15;
   return i13 | 0;
  } else i4 = i2;
 } else i4 = i2;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = (i7 & 1 | 0) == 0 | (i2 & 2 | 0) != 0 ? 65536 : 81920;
 HEAP32[i5 + 4 >> 2] = (i7 & 2 | 0) == 0 | (i2 & 1 | 0) != 0 ? 0 : 16384;
 HEAP32[i5 + 12 >> 2] = 65536;
 HEAP32[i5 + 8 >> 2] = 0;
 _UNITY_FT_Set_Transform(i4, i5, 0);
 _UNITY_FT_Set_Char_Size(i4, 0, ~~Math_fround(Math_fround(Math_fround(i1 | 0) * f14) * Math_fround(64.0)), 72, 72) | 0;
 i1 = _UNITY_FT_Get_Char_Index(i4, i6) | 0;
 do if (!i1) i1 = 0; else {
  switch (HEAP32[i8 + 200 >> 2] | 0) {
  case 3:
  case 0:
   {
    i2 = 2;
    break;
   }
  case 1:
   {
    i2 = 0;
    break;
   }
  case 2:
   {
    i2 = 131072;
    break;
   }
  default:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 945354 | 0, 0, gb + 945383 | 0, 672, 1, 0, 0, 0);
    i2 = 2;
   }
  }
  if (!(_UNITY_FT_Load_Glyph(i4, i1, i2) | 0)) {
   i4 = i4 + 84 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i1 + 72 >> 2] | 0) == 1651078259) i2 = i1; else {
    if (_UNITY_FT_Render_Glyph(i1, i2 >>> 16) | 0) {
     i1 = 0;
     break;
    }
    i2 = HEAP32[i4 >> 2] | 0;
   }
   i1 = i2 + 76 | 0;
   if ((HEAP8[i2 + 94 >> 0] | 0) != 2) {
    if (!(HEAP8[gb + 1573585 >> 0] | 0)) {
     _UNITY_FT_Bitmap_New(gb + 1467852 | 0);
     HEAP8[gb + 1573585 >> 0] = 1;
    }
    _UNITY_FT_Bitmap_Convert(HEAP32[gb + 1467876 >> 2] | 0, i1, gb + 1467852 | 0, 4) | 0;
    i1 = HEAP16[gb + 1467852 + 16 >> 1] | 0;
    if (i1 << 16 >> 16 == 256) i1 = gb + 1467852 | 0; else {
     f3 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround((i1 & 65535) + -1 | 0)) * Math_fround(255.0));
     if (!(Math_imul(HEAP32[gb + 1467852 >> 2] | 0, HEAP32[gb + 1467852 + 8 >> 2] | 0) | 0)) i1 = gb + 1467852 | 0; else {
      i1 = 0;
      do {
       i8 = (HEAP32[gb + 1467852 + 12 >> 2] | 0) + i1 | 0;
       HEAP8[i8 >> 0] = ~~Math_fround(f3 * Math_fround(HEAPU8[i8 >> 0] | 0));
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < (Math_imul(HEAP32[gb + 1467852 >> 2] | 0, HEAP32[gb + 1467852 + 8 >> 2] | 0) | 0) >>> 0);
      i1 = gb + 1467852 | 0;
     }
    }
   }
   f14 = Math_fround(Math_fround(1.0) / f14);
   i8 = i1 + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i1 + 8 >> 2];
   i11 = HEAP32[i4 >> 2] | 0;
   f18 = Math_fround(f14 * Math_fround(HEAP32[i11 + 100 >> 2] | 0));
   f17 = Math_fround(f14 * Math_fround(HEAP32[i11 + 104 >> 2] | 0));
   f16 = Math_fround(f14 * Math_fround((HEAP32[i9 >> 2] | 0) >>> 0));
   f3 = Math_fround(-Math_fround(f14 * Math_fround((HEAP32[i10 >> 2] | 0) >>> 0)));
   HEAPF32[i12 >> 2] = f18;
   HEAPF32[i12 + 4 >> 2] = f17;
   HEAPF32[i12 + 8 >> 2] = f16;
   HEAPF32[i12 + 12 >> 2] = f3;
   HEAPF32[i13 >> 2] = Math_fround(Math_floor(Math_fround(Math_fround(f14 * Math_fround(Math_fround(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0) * Math_fround(.015625))) + Math_fround(.5))));
   if (!(Math_imul(HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0)) i1 = 0; else i1 = HEAP32[i1 + 12 >> 2] | 0;
  } else i1 = 0;
 } while (0);
 i13 = i1;
 STACKTOP = i15;
 return i13 | 0;
}

function __ZN20GpuProgramParametersaSERKS_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i4 = i10 + 16 | 0;
 i8 = (i9 | 0) == (i10 | 0);
 if (i8) {
  i1 = i10 + 124 | 0;
  i2 = i9 + 124 | 0;
  i3 = i1 + 120 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return i10 | 0;
 }
 i6 = HEAP32[i9 + 16 >> 2] | 0;
 i7 = i10 + 28 | 0;
 i1 = (HEAP32[i9 + 28 >> 2] | 0) * 20 | 0;
 i5 = (i1 | 0) / 20 | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = i10 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1, 4, i10 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i4 >> 2] = i1;
  break;
 } else i1 = HEAP32[i4 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 20 | 0) | 0;
 __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + 36 | 0, HEAP32[i9 + 36 >> 2] | 0, HEAP32[i9 + 40 >> 2] | 0);
 if (i8) {
  i1 = i10 + 124 | 0;
  i2 = i9 + 124 | 0;
  i3 = i1 + 120 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return i10 | 0;
 }
 __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + 48 | 0, HEAP32[i9 + 48 >> 2] | 0, HEAP32[i9 + 52 >> 2] | 0);
 i2 = i10 + 60 | 0;
 i6 = HEAP32[i9 + 60 >> 2] | 0;
 i7 = i10 + 72 | 0;
 i1 = HEAP32[i9 + 72 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i7 >> 2] = i3;
 i4 = i10 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + 80 | 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0);
 i5 = i10 + 92 | 0;
 if (i8) {
  i1 = i10 + 124 | 0;
  i2 = i9 + 124 | 0;
  i3 = i1 + 120 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return i10 | 0;
 }
 i6 = HEAP32[i9 + 92 >> 2] | 0;
 i7 = i10 + 104 | 0;
 i1 = HEAP32[i9 + 104 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 i3 = i10 + 108 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i10 + 96 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 96 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10 + 112 | 0, HEAP32[i9 + 112 >> 2] | 0, HEAP32[i9 + 116 >> 2] | 0);
 i1 = i10 + 124 | 0;
 i2 = i9 + 124 | 0;
 i3 = i1 + 120 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return i10 | 0;
}

function __ZL30InitializeSpeedTreeWindManagerPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 16 | 0;
 i13 = i8;
 i6 = i8 + 8 | 0;
 i3 = i8 + 32 | 0;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63696 | 0, 16, gb + 936496 | 0, gb + 481728 | 0, gb + 487374 | 0, 56) | 0;
 i7 = HEAP32[gb + 69128 >> 2] | 0;
 i9 = gb + 63616 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i4, 1, gb + 487455 | 0, 1904, i7, i11, 16);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1170604 >> 2] = i4;
 i4 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63616 | 0, 16, gb + 487374 | 0, 59) | 0;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i13);
 i5 = i11;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = i7;
 HEAPF32[i4 + 52 >> 2] = Math_fround(0.0);
 HEAP32[gb + 1115296 + 196 >> 2] = fb + 83;
 HEAP32[gb + 1170600 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 33952 + 8;
 i4 = gb + 64016 | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i13;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 i6 = i3 + 48 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i3 + 36 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i13);
 i4 = i11;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = gb + 64016 | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i13;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 i4 = i3 + 68 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i3 + 56 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i13);
 i1 = i11;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = gb + 64016 | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = i3 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 i9 = i3 + 88 | 0;
 HEAP32[i9 >> 2] = 0;
 i2 = i3 + 76 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i13);
 i13 = i11;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = i14;
 i10 = i3 + 92 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i3 + 100 | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP8[i3 + 108 >> 0] = 1;
 i12 = i3 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i3, 0);
 __ZN19ShaderPropertySheet11ComputeHashEv(i3);
 HEAP32[gb + 1170756 >> 2] = HEAP32[i10 >> 2];
 __ZN19ShaderPropertySheet5ClearEb(i3, 1);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i3, 4);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i3, gb + 1170752 | 0, Math_fround(0.0), 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i3, gb + 1170688 | 0, i11, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i3, gb + 1170692 | 0, i11, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i3, gb + 1170712 | 0, i11, 0);
 __ZN19ShaderPropertySheet11ComputeHashEv(i3);
 HEAP32[gb + 1170756 + 4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 52 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 32 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZL25MotionVectorRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, i30 = 0, f31 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i26 + 196 | 0;
 i25 = i26;
 if ((HEAP16[gb + 1114960 + 6 >> 1] | 0) > -1) {
  HEAP32[i25 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114960 | 0, i1);
  i22 = gb + 1114960 | 0;
 } else i22 = 0;
 i23 = HEAP32[gb + 1114960 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i23 | 0);
 i23 = i3 + 12 | 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 i24 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 1832 >> 2] | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i25, i1, i24, 0, 0);
 if (HEAP32[i25 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i25);
 i1 = HEAP32[i3 + 168 >> 2] | 0;
 i20 = i3 + 172 | 0;
 L7 : do if (i1 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0) {
  i21 = i2 + 32 | 0;
  i19 = i2 + 12 | 0;
  i15 = i4 + 964 | 0;
  i16 = i4 + 968 | 0;
  i17 = i4 + 972 | 0;
  i18 = i4 + 976 | 0;
  i14 = i3 + 16 | 0;
  i12 = i4 + 608 | 0;
  i13 = i25 + 8 | 0;
  while (1) {
   i2 = HEAP32[i21 >> 2] | 0;
   i3 = HEAP32[i2 + (i1 * 212 | 0) + 16 >> 2] | 0;
   i4 = HEAP32[i19 >> 2] | 0;
   i5 = i4 + (i3 << 5) + 8 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i24 >> 2] | 0;
   __ZN13BatchRenderer5FlushEv(i25);
   i8 = HEAP32[i7 + (i6 * 360 | 0) + 176 >> 2] & 4;
   i27 = HEAP32[i7 + (i6 * 360 | 0) + 252 >> 2] | 0;
   i9 = i2 + (i1 * 212 | 0) | 0;
   i10 = i2 + (i1 * 212 | 0) + 4 | 0;
   i11 = i2 + (i1 * 212 | 0) + 8 | 0;
   f29 = Math_fround(i27 >> 30 | 1 | 0);
   f29 = (i27 & 2147483647 | 0) == 0 ? Math_fround(0.0) : f29;
   i27 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   f29 = Math_fround(Math_abs(Math_fround(f29)));
   f31 = Math_fround(f29 * Math_fround(16.0));
   i30 = f31 >= Math_fround(0.0);
   f28 = Math_fround(f31 + Math_fround(-.99999994));
   i30 = ~~(i30 ? f31 : f28);
   f28 = Math_fround(Math_fround(((i30 | 0) > 15 ? 15 : i30) | 0) * Math_fround(.0625));
   HEAPF32[i15 >> 2] = f29;
   HEAPF32[i16 >> 2] = f28;
   HEAPF32[i17 >> 2] = Math_fround(0.0);
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   switch (((i27 & 2147483647 | 0) == 0 ? 0 : i27 >> 31 | 1) | 0) {
   case 1:
    {
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -12582913 | 8388608;
     break;
    }
   case -1:
    {
     HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -12582913 | 4194304;
     break;
    }
   default:
    HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -12582913;
   }
   HEAPF32[i12 >> 2] = i8 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
   i30 = i7 + (i6 * 360 | 0) + 232 | 0;
   f31 = (HEAPU16[i30 >> 1] | HEAPU8[i30 + 2 >> 0] << 16) & 512 | 0 ? Math_fround(1.0) : Math_fround(0.0);
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1114972 | 0, f31, 0);
   f31 = ((HEAPU16[i30 >> 1] | HEAPU8[i30 + 2 >> 0] << 16) & 3072 | 0) == 2048 ? Math_fround(1.0) : Math_fround(0.0);
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1114976 | 0, f31, 0);
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i13, gb + 1114992 | 0, Math_fround(-.00100000005), 0);
   __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i13, gb + 1114988 | 0, i2 + (i1 * 212 | 0) + 148 | 0, 0);
   __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i13, gb + 1114984 | 0, i2 + (i1 * 212 | 0) + 20 | 0, 0);
   __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i13, gb + 1114980 | 0, i2 + (i1 * 212 | 0) + 84 | 0, 0);
   __ZN13BatchRenderer20RenderSingleWithPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEiPKNS7_10GrabPassesEjib(i25, i23, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 + (i1 * 212 | 0) + 12 >> 2] | 0, 0, HEAP32[i5 >> 2] | 0, HEAPU16[i4 + (i3 << 5) + 14 >> 1] | 0, ((HEAPU16[i30 >> 1] | HEAPU8[i30 + 2 >> 0] << 16) & 512 | 0) != 0);
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i20 >> 2] | 0) >>> 0) break L7;
  }
 } while (0);
 __ZN13BatchRenderer5FlushEv(i25);
 __ZN13BatchRendererD2Ev(i25);
 i30 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i30 >> 2] | 0) + 652 >> 2] | 0, i30 | 0);
 if (!i22) {
  STACKTOP = i26;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i22);
 STACKTOP = i26;
 return;
}

function __ZN7mecanim4hand8HandPose8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i2 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899224 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 HEAP32[i2 >> 2] = 20;
 HEAP32[i2 + 4 >> 2] = i6 + 40;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899201 | 0, HEAP32[gb + 37256 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi20EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 120 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899232 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899243 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899255 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 40; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 40; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899263 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 51; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 51; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 51) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i19, i13, i1) {
 i19 = i19 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i9 = i18 + 8 | 0;
 i12 = i13 + 11 | 0;
 i15 = HEAP8[i12 >> 0] | 0;
 i8 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = i15 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i15 & 255;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i19, gb + 1041885 | 0, gb + 1041885 | 0, i9) | 0)) {
  STACKTOP = i18;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 & 255;
 i3 = i4 ? i5 : i6;
 do if (i2 >>> 0 > i3 >>> 0) {
  i7 = i2 - i3 | 0;
  if (i7 | 0) {
   if (i4) {
    i2 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0;
    i3 = i5;
   } else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i7 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i13, i2, i7 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i12 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   _memset(i2 + i3 | 0, 1, i7 | 0) | 0;
   i1 = i3 + i7 | 0;
   if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i8 >> 2] = i1; else HEAP8[i12 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } else if (i4) {
  HEAP8[(HEAP32[i13 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i8 >> 2] = i2;
  break;
 } else {
  HEAP8[i13 + i2 >> 0] = 0;
  HEAP8[i12 >> 0] = i2;
  break;
 } while (0);
 i15 = HEAP8[i12 >> 0] | 0;
 i14 = i15 << 24 >> 24 < 0;
 i15 = (i14 ? HEAP32[i13 >> 2] | 0 : i13) + (i14 ? HEAP32[i8 >> 2] | 0 : i15 & 255) | 0;
 do if (HEAP32[i9 >> 2] | 0) {
  i8 = HEAP32[gb + 36976 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i19, gb + 1041891 | 0, i8, 0, 0) | 0;
  i14 = i19 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i14 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i19 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i14 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   L26 : do if ((i1 | 0) != (i15 | 0)) {
    i4 = i19 + 16 | 0;
    i5 = i19 + 20 | 0;
    i6 = i19 + 32 | 0;
    i7 = i19 + 36 | 0;
    i8 = i19 + 24 | 0;
    i3 = 0;
    while (1) {
     i3 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     HEAP32[i2 + 12 >> 2] = i3;
     __ZNK16TypeTreeIterator8ChildrenEv(i17, i2);
     i3 = i17;
     i12 = HEAP32[i3 + 4 >> 2] | 0;
     i13 = i2 + 24 | 0;
     HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     i13 = HEAP32[i11 >> 2] | 0;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     i13 = HEAP32[i5 >> 2] | 0;
     i2 = i13 + (HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i13 >>> 0) i16 = 22; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i16 = 22; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i16 | 0) == 22) {
      i16 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i15 | 0)) break L26;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i14 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i19);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i19);
  i1 = (HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
  if ((i1 | 0) != (i15 | 0)) {
   i3 = i19 + 16 | 0;
   i4 = i19 + 20 | 0;
   i5 = i19 + 32 | 0;
   i6 = i19 + 36 | 0;
   i7 = i19 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i19, gb + 1041891 | 0, i8, i17, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i16 = HEAP32[i4 >> 2] | 0;
      i2 = i16 + (HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i16 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i17 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i19 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i19);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i15 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i19);
 STACKTOP = i18;
 return;
}

function __ZN5Umbra12RegionFinderC2EPNS_12QueryContextEiRKNS_7Vector3Efb(i23, i17, i18, i19, f20, i22) {
 i23 = i23 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 f20 = Math_fround(f20);
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0;
 i15 = HEAP32[i17 >> 2] | 0;
 i9 = HEAP32[i15 + 100 >> 2] | 0;
 i10 = i9 + 128 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i9 + 124 >> 2] | 0;
 i16 = i17 + 4 | 0;
 HEAP32[i23 >> 2] = i16;
 i12 = i17 + 44 | 0;
 HEAP32[i23 + 12 >> 2] = i12;
 i13 = i17 + 48 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i5 = i14 + 1 | 0;
 HEAP32[i13 >> 2] = i5;
 HEAP32[i23 + 16 >> 2] = i14;
 HEAP32[i23 + 20 >> 2] = 20;
 HEAP32[i23 + 32 >> 2] = i7;
 HEAP32[i23 + 4 >> 2] = (i11 | 0) == 0 ? 0 : i9 + i11 | 0;
 i11 = HEAP32[i15 + 96 >> 2] | 0;
 i8 = (i11 | 0) == 0;
 if (i8) {
  i4 = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
 } else {
  i1 = HEAP32[i11 + 20 >> 2] | 0;
  if (!i1) {
   i4 = 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
  } else {
   i4 = HEAP32[i15 + 104 >> 2] | 0;
   i2 = 8;
   i3 = i7;
  }
 }
 HEAP32[i23 + 36 >> 2] = i16;
 HEAP32[i23 + 48 >> 2] = i12;
 i6 = i14 + 2 | 0;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i23 + 52 >> 2] = i5;
 HEAP32[i23 + 56 >> 2] = i2;
 HEAP32[i23 + 68 >> 2] = i3;
 HEAP32[i23 + 40 >> 2] = (i1 | 0) == 0 ? 0 : i4 + i1 | 0;
 i2 = HEAP32[i9 + 132 >> 2] | 0;
 i3 = (HEAP32[i9 + 180 >> 2] | 0) == 0;
 if (i3) {
  i1 = i7 + -1 | 0;
  i5 = i9 + (HEAP32[i10 >> 2] | 0) | 0;
  i1 = (HEAP32[i5 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i5 + (i1 * 20 | 0) >> 2] | 0) | 0;
 } else i1 = HEAP32[i9 + (HEAP32[i9 + 184 >> 2] | 0) + (HEAP32[i9 + 176 >> 2] << 2) >> 2] | 0;
 HEAP32[i23 + 72 >> 2] = i16;
 HEAP32[i23 + 84 >> 2] = i12;
 i5 = i14 + 3 | 0;
 HEAP32[i13 >> 2] = i5;
 HEAP32[i23 + 88 >> 2] = i6;
 HEAP32[i23 + 92 >> 2] = 16;
 HEAP32[i23 + 104 >> 2] = i1;
 HEAP32[i23 + 76 >> 2] = (i2 | 0) == 0 ? 0 : i9 + i2 | 0;
 if (i8) {
  i4 = 0;
  i2 = 0;
  i3 = 0;
  i1 = 0;
 } else {
  if (i3) {
   i1 = i7 + -1 | 0;
   i10 = i9 + (HEAP32[i10 >> 2] | 0) | 0;
   i1 = (HEAP32[i10 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i10 + (i1 * 20 | 0) >> 2] | 0) | 0;
  } else i1 = HEAP32[i9 + (HEAP32[i9 + 184 >> 2] | 0) + (HEAP32[i9 + 176 >> 2] << 2) >> 2] | 0;
  i4 = HEAP32[i15 + 104 >> 2] | 0;
  i2 = HEAP32[i11 + 24 >> 2] | 0;
  i3 = 16;
  i1 = (HEAP32[i15 + 116 >> 2] | 0) - i1 | 0;
 }
 HEAP32[i23 + 108 >> 2] = i16;
 HEAP32[i23 + 120 >> 2] = i12;
 HEAP32[i13 >> 2] = i14 + 4;
 HEAP32[i23 + 124 >> 2] = i5;
 HEAP32[i23 + 128 >> 2] = i3;
 HEAP32[i23 + 140 >> 2] = i1;
 HEAP32[i23 + 112 >> 2] = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
 i5 = i23 + 144 | 0;
 HEAP32[i5 >> 2] = i17;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  i3 = (HEAP32[i1 + 124 >> 2] | 0) + -1 | 0;
  i15 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
  i3 = (HEAP32[i15 + (i3 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i15 + (i3 * 20 | 0) >> 2] | 0) | 0;
 } else i3 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
 HEAP32[i23 + 148 >> 2] = i16;
 i7 = i23 + 160 | 0;
 HEAP32[i7 >> 2] = i3 + 1;
 HEAP32[i23 + 164 >> 2] = 0;
 i1 = i23 + 24168 | 0;
 i2 = i23 + 8168 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 32 >> 5;
 i2 = i1 << 1;
 i8 = i17 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + ((i1 << 3) + 31 & -16) | 0;
 i9 = i17 + 12 | 0;
 if (i4 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) i21 = 19; else {
  HEAP32[i8 >> 2] = i4;
  if (!i3) i21 = 19; else {
   HEAP32[i3 >> 2] = i2;
   i2 = i3 + 16 | 0;
   HEAP32[i23 + 152 >> 2] = i2;
   HEAP32[i23 + 156 >> 2] = i2 + (i1 << 2);
   _memset(i2 | 0, 0, (HEAP32[i7 >> 2] | 0) + 31 >> 5 << 3 | 0) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = i2;
   i2 = (HEAP32[i2 + 28 >> 2] | 0) == 2;
  }
 }
 if ((i21 | 0) == 19) {
  HEAP32[i23 + 152 >> 2] = 0;
  HEAP32[i17 + 28 >> 2] = 2;
  i1 = i17;
  i2 = 1;
 }
 HEAP32[i23 + 24168 >> 2] = i18;
 HEAP32[i23 + 24172 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i23 + 24176 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i23 + 24180 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAPF32[i23 + 24188 >> 2] = f20;
 i6 = i23 + 24192 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP8[i23 + 24196 >> 0] = i22 & 1;
 i5 = i1 + 28 | 0;
 if (i2) {
  HEAP32[i5 >> 2] = 2;
  return;
 }
 HEAP32[i23 + 24184 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 i1 = (HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + 124 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 31 >> 5;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + ((i2 << 2) + 31 & -16) | 0;
 if (i4 >>> 0 <= (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i8 >> 2] = i4;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = i2;
   i23 = i3 + 16 | 0;
   HEAP32[i6 >> 2] = i23;
   _memset(i23 | 0, 0, (HEAP32[i1 >> 2] | 0) + 31 >> 5 << 2 | 0) | 0;
   return;
  }
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 2;
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl11deriveClassERKN5physx8debugger14NamespacedNameES5_(i11, i2, i3) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 12 | 0;
 i13 = i14;
 i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i11, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i1) {
  i10 = i11 + 240 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i1 + 1;
  i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i11, i2, i1) | 0;
 }
 i2 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i11, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
 if (!i2) {
  i9 = i11 + 240 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 + 1;
  i10 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i11, i3, i10) | 0;
 } else i10 = i2;
 i2 = i10 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP8[i1 + 68 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[i1 + 12 >> 2];
 i2 = i10 + 28 | 0;
 i5 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i10 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 i2 = i10 + 48 | 0;
 i5 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i10 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP8[i10 + 69 >> 0] = HEAP8[i1 + 69 >> 0] | 0;
 i2 = i10 + 96 | 0;
 i5 = (i1 | 0) == (i10 | 0);
 do if (!i5) {
  i6 = i10 + 112 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i1 + 112 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i10 + 116 >> 2] & 2147483647) >>> 0 < i3 >>> 0) {
   __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj(i2, i3);
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i2 = HEAP32[i10 + 108 >> 2] | 0;
  i4 = i2 + (i3 << 3) | 0;
  if ((i3 | 0) > 0) {
   i3 = HEAP32[i1 + 108 >> 2] | 0;
   while (1) {
    i15 = i3;
    i8 = HEAP32[i15 + 4 >> 2] | 0;
    i9 = i2;
    HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
   }
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   if (i5) break;
  } else HEAP32[i6 >> 2] = i3;
  i6 = i10 + 136 | 0;
  HEAP32[i6 >> 2] = 0;
  i5 = i1 + 136 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i10 + 140 >> 2] & 2147483647) >>> 0 < i2 >>> 0) {
   __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj(i10 + 120 | 0, i2);
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i3 = HEAP32[i10 + 132 >> 2] | 0;
  i4 = i3 + (i2 << 3) | 0;
  if ((i2 | 0) > 0) {
   i2 = i3;
   i3 = HEAP32[i1 + 132 >> 2] | 0;
   while (1) {
    i8 = i3;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i15 = i2;
    HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i15 + 4 >> 2] = i9;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
   }
   i2 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = i2;
 } while (0);
 i8 = i11 + 128 | 0;
 i9 = i11 + 124 | 0;
 i7 = i11 + 60 | 0;
 i5 = i10 + 4 | 0;
 i6 = i13 + 8 | 0;
 while (1) {
  i2 = i1 + 88 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i1 + 84 | 0;
   i4 = 0;
   do {
    i15 = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 16 >> 2] | 0;
    i16 = i5;
    i10 = HEAP32[i16 + 4 >> 2] | 0;
    i11 = i13;
    HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i11 + 4 >> 2] = i10;
    HEAP32[i6 >> 2] = i15;
    i15 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_(i7, i12, i15);
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i1 | 0) <= -1) {
   i1 = 1;
   i2 = 28;
   break;
  }
  if ((HEAP32[i8 >> 2] | 0) <= (i1 | 0)) {
   i1 = 1;
   i2 = 28;
   break;
  }
  i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i1 = 1;
   i2 = 28;
   break;
  }
 }
 if ((i2 | 0) == 28) {
  STACKTOP = i14;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_(i31, i1, i3, i2) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 168 | 0;
 i26 = i30;
 i22 = i30 + 696 | 0;
 i29 = i30 + 392 | 0;
 i20 = i30 + 648 | 0;
 i25 = i30 + 728 | 0;
 i27 = i30 + 344 | 0;
 i23 = i30 + 176 | 0;
 i24 = i31 + 8 | 0;
 i19 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i24 >> 2] | 0) | 0;
 i21 = i29 + 240 | 0;
 i6 = i29 + 244 | 0;
 HEAP32[i29 + 248 >> 2] = 0;
 i7 = i29 + 252 | 0;
 HEAP8[i21 >> 0] = 1;
 HEAP32[i6 >> 2] = i29;
 HEAP32[i7 >> 2] = 5;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 8 >> 2] = Math_fround(20.0);
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i20 + 16 >> 2] = Math_fround(.25);
 HEAPF32[i20 + 20 >> 2] = Math_fround(1500.0);
 i18 = i20 + 24 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i29, i5, i20);
 if (i5 | 0) {
  i8 = i26 + 4 | 0;
  i9 = i31 + 4 | 0;
  i10 = i31 + 12 | 0;
  i11 = i31 + 16 | 0;
  i12 = i27;
  i13 = i22 + 4 | 0;
  i14 = i22 + 8 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 20 | 0;
  i18 = i22 + 24 | 0;
  i20 = 0;
  do {
   i1 = i25;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i28 >> 2] = i20;
   __ZN5physx6string9sprintf_sEPcjPKcz(i25, 32, gb + 832301 | 0, i28) | 0;
   i1 = HEAP32[i31 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i31 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i31 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i26 >> 2] = i25;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i33 = i26;
    i32 = HEAP32[i33 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i33 >> 2];
    HEAP32[i4 + 4 >> 2] = i32;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i26) | 0;
   mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i27 | 0, HEAP32[i24 >> 2] | 0, i20 | 0);
   _memset(i23 | 0, 0, 168) | 0;
   __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev(i23);
   i32 = HEAP32[i31 >> 2] | 0;
   i33 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev(i26);
   HEAP32[i22 >> 2] = i32;
   HEAP32[i13 >> 2] = i33;
   HEAP32[i14 >> 2] = i12;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = i2;
   HEAP32[i17 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   __ZNK5physx31PxVehicleWheelDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEEEEEjT_j(i26, i22, 0) | 0;
   i2 = HEAP32[i31 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i31 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i20 = i20 + 1 | 0;
  } while ((i20 | 0) != (i5 | 0));
 }
 i33 = HEAP32[i7 >> 2] | 0;
 if (!((i33 | 0) > -1 & (i33 & 2147483647 | 0) != 0)) {
  STACKTOP = i30;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i29 | 0) == (i1 | 0)) {
  HEAP8[i21 >> 0] = 0;
  STACKTOP = i30;
  return;
 }
 if (!i1) {
  STACKTOP = i30;
  return;
 }
 i33 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i33 >> 2] | 0) + 12 >> 2] | 0, i33 | 0, i1 | 0);
 STACKTOP = i30;
 return;
}

function __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f26 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f22 * f21);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(f22 * f19);
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f11 = Math_fround(f22 * f17);
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f22 = Math_fround(f22 * f15);
 f10 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f9 = Math_fround(f21 * Math_fround(f9 + f10));
 f12 = Math_fround(f19 * Math_fround(f12 + f10));
 f11 = Math_fround(f17 * Math_fround(f11 + f10));
 f10 = Math_fround(f15 * Math_fround(f22 + f10));
 f22 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f9 = Math_fround(f21 * Math_fround(f22 + f9));
 f12 = Math_fround(f19 * Math_fround(f22 + f12));
 f11 = Math_fround(f17 * Math_fround(f22 + f11));
 f10 = Math_fround(f15 * Math_fround(f22 + f10));
 f22 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f9 = Math_fround(f22 + f9);
 f12 = Math_fround(f22 + f12);
 f11 = Math_fround(f22 + f11);
 f10 = Math_fround(f22 + f10);
 f22 = Math_fround(f21 - f26);
 f23 = Math_fround(f19 - f26);
 f24 = Math_fround(f17 - f26);
 f25 = Math_fround(f15 - f26);
 f5 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f6 = Math_fround(f22 * f5);
 f7 = Math_fround(f23 * f5);
 f8 = Math_fround(f24 * f5);
 f5 = Math_fround(f25 * f5);
 f14 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 f6 = Math_fround(f22 * Math_fround(f6 + f14));
 f7 = Math_fround(f23 * Math_fround(f7 + f14));
 f8 = Math_fround(f24 * Math_fround(f8 + f14));
 f14 = Math_fround(f25 * Math_fround(f5 + f14));
 f5 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f6 = Math_fround(f22 * Math_fround(f5 + f6));
 f7 = Math_fround(f23 * Math_fround(f5 + f7));
 f8 = Math_fround(f24 * Math_fround(f5 + f8));
 f14 = Math_fround(f25 * Math_fround(f5 + f14));
 f5 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f6 = Math_fround(f5 + f6);
 f7 = Math_fround(f5 + f7);
 f8 = Math_fround(f5 + f8);
 f14 = Math_fround(f5 + f14);
 f9 = f21 > f26 ? f6 : f9;
 f12 = f19 > f26 ? f7 : f12;
 f11 = f17 > f26 ? f8 : f11;
 f10 = f15 > f26 ? f14 : f10;
 f14 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f21 * f26);
 f7 = Math_fround(f19 * f26);
 f6 = Math_fround(f17 * f26);
 f26 = Math_fround(f15 * f26);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f21 * Math_fround(f8 + f5));
 f7 = Math_fround(f19 * Math_fround(f7 + f5));
 f6 = Math_fround(f17 * Math_fround(f6 + f5));
 f5 = Math_fround(f15 * Math_fround(f26 + f5));
 f26 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(f21 * Math_fround(f26 + f8));
 f7 = Math_fround(f19 * Math_fround(f26 + f7));
 f6 = Math_fround(f17 * Math_fround(f26 + f6));
 f5 = Math_fround(f15 * Math_fround(f26 + f5));
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(f26 + f8);
 f7 = Math_fround(f26 + f7);
 f6 = Math_fround(f26 + f6);
 f5 = Math_fround(f26 + f5);
 f26 = Math_fround(f21 - f14);
 f25 = Math_fround(f19 - f14);
 f24 = Math_fround(f17 - f14);
 f23 = Math_fround(f15 - f14);
 f22 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f20 = Math_fround(f26 * f22);
 f18 = Math_fround(f25 * f22);
 f16 = Math_fround(f24 * f22);
 f22 = Math_fround(f23 * f22);
 f13 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f20 = Math_fround(f26 * Math_fround(f20 + f13));
 f18 = Math_fround(f25 * Math_fround(f18 + f13));
 f16 = Math_fround(f24 * Math_fround(f16 + f13));
 f13 = Math_fround(f23 * Math_fround(f22 + f13));
 f22 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f20 = Math_fround(f26 * Math_fround(f22 + f20));
 f18 = Math_fround(f25 * Math_fround(f22 + f18));
 f16 = Math_fround(f24 * Math_fround(f22 + f16));
 f13 = Math_fround(f23 * Math_fround(f22 + f13));
 f22 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f20 = Math_fround(f22 + f20);
 f18 = Math_fround(f22 + f18);
 f16 = Math_fround(f22 + f16);
 f13 = Math_fround(f22 + f13);
 f8 = Math_fround((f21 > f14 ? f20 : f8) - f9);
 f7 = Math_fround((f19 > f14 ? f18 : f7) - f12);
 f6 = Math_fround((f17 > f14 ? f16 : f6) - f11);
 f5 = Math_fround((f15 > f14 ? f13 : f5) - f10);
 f8 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f8);
 f7 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f7);
 f6 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * f6);
 f7 = Math_fround(f12 + f7);
 f6 = Math_fround(f11 + f6);
 f5 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * f5));
 HEAPF32[i1 >> 2] = Math_fround(f9 + f8);
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f6;
 HEAPF32[i1 + 12 >> 2] = f5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i9, i10, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, d8 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 128 | 0;
 i15 = i18;
 i6 = i18 + 136 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 HEAP32[i6 >> 2] = 538;
 i14 = HEAP32[i17 + 20 >> 2] | 0;
 i14 = (i14 | 0) == 0 ? i6 : i14;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i12 = i15 + 4 | 0;
  i13 = i17 + 8 | 0;
  i6 = i9 + 12 | 0;
  i9 = i17 + 4 | 0;
  i11 = i17 + 12 | 0;
  do {
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i17 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i15 >> 2] = i1;
   HEAP8[i12 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i19 = i15;
    i4 = HEAP32[i19 + 4 >> 2] | 0;
    i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
   f7 = Math_fround(+mftCall_fii(HEAP32[i6 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0));
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d8 = +f7;
   i1 = i15;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i16 >> 3] = d8;
   __ZN5physx6string9sprintf_sEPcjPKcz(i15, 128, gb + 832323 | 0, i16) | 0;
   if (HEAP8[i15 >> 0] | 0) {
    i19 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_iiii(i19 | 0, i5 | 0, i15 | 0, _strlen(i15) | 0) | 0;
   }
   HEAP8[i15 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i15 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i5 + 20 >> 2] | 0);
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i10 = i10 + 8 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i9, i10, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, d8 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 128 | 0;
 i15 = i18;
 i6 = i18 + 136 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 HEAP32[i6 >> 2] = 537;
 i14 = HEAP32[i17 + 20 >> 2] | 0;
 i14 = (i14 | 0) == 0 ? i6 : i14;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i12 = i15 + 4 | 0;
  i13 = i17 + 8 | 0;
  i6 = i9 + 12 | 0;
  i9 = i17 + 4 | 0;
  i11 = i17 + 12 | 0;
  do {
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i17 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i15 >> 2] = i1;
   HEAP8[i12 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i19 = i15;
    i4 = HEAP32[i19 + 4 >> 2] | 0;
    i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
   f7 = Math_fround(+mftCall_fii(HEAP32[i6 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0));
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d8 = +f7;
   i1 = i15;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i16 >> 3] = d8;
   __ZN5physx6string9sprintf_sEPcjPKcz(i15, 128, gb + 832323 | 0, i16) | 0;
   if (HEAP8[i15 >> 0] | 0) {
    i19 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_iiii(i19 | 0, i5 | 0, i15 | 0, _strlen(i15) | 0) | 0;
   }
   HEAP8[i15 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i15 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i5 + 20 >> 2] | 0);
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i10 = i10 + 8 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN18SpeedTreeWindAssetC2E10MemLabelId18ObjectCreationMode(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i7, i5, i2);
 HEAP32[i7 >> 2] = gb + 69028 + 8;
 HEAPF32[i7 + 32 >> 2] = Math_fround(5.0);
 HEAPF32[i7 + 36 >> 2] = Math_fround(2.5);
 HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 448 >> 2] = Math_fround(50.0);
 HEAPF32[i7 + 452 >> 2] = Math_fround(2.0);
 HEAPF32[i7 + 656 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 660 >> 2] = Math_fround(.75);
 HEAPF32[i7 + 664 >> 2] = Math_fround(.300000012);
 i5 = i7 + 536 | 0;
 i6 = i5 + 120 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 788 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 792 >> 2] = Math_fround(.75);
 HEAPF32[i7 + 796 >> 2] = Math_fround(.300000012);
 i5 = i7 + 668 | 0;
 i6 = i5 + 120 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 1e3 >> 2] = Math_fround(20.0);
 HEAPF32[i7 + 1004 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1008 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1012 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 1016 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1020 >> 2] = Math_fround(1.0);
 _memset(i7 + 800 | 0, 0, 200) | 0;
 HEAPF32[i7 + 1224 >> 2] = Math_fround(20.0);
 HEAPF32[i7 + 1228 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1232 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1236 >> 2] = Math_fround(.300000012);
 HEAPF32[i7 + 1240 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1244 >> 2] = Math_fround(1.0);
 _memset(i7 + 1024 | 0, 0, 200) | 0;
 HEAPF32[i7 + 1288 >> 2] = Math_fround(10.0);
 HEAPF32[i7 + 1292 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1296 >> 2] = Math_fround(.00499999989);
 HEAPF32[i7 + 1300 >> 2] = Math_fround(9.0);
 HEAPF32[i7 + 1304 >> 2] = Math_fround(32.0);
 HEAPF32[i7 + 1308 >> 2] = Math_fround(.400000006);
 HEAPF32[i7 + 1312 >> 2] = Math_fround(.0500000007);
 HEAPF32[i7 + 1316 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1320 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1324 >> 2] = Math_fround(-.5);
 HEAPF32[i7 + 1328 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1332 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1336 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1340 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 1344 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1348 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1352 >> 2] = Math_fround(4.0);
 HEAPF32[i7 + 1356 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1360 >> 2] = Math_fround(1.0);
 _memset(i7 + 48 | 0, 0, 400) | 0;
 i1 = i7 + 1248 | 0;
 i5 = i7 + 456 | 0;
 i6 = i5 + 80 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i5 = i1;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i7 + 1376 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1408 >> 2] = Math_fround(0.0);
 HEAPF64[i7 + 1424 >> 3] = -1.0;
 HEAP8[i7 + 1432 >> 0] = 0;
 i1 = i7 + 1472 | 0;
 i5 = i7 + 1436 | 0;
 i6 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF64[i1 >> 3] = 1.0;
 HEAPF64[i7 + 1480 >> 3] = 0.0;
 HEAPF32[i7 + 1488 >> 2] = Math_fround(0.0);
 i1 = i7 + 1496 | 0;
 i2 = i7 + 1544 | 0;
 i3 = i7 + 1580 | 0;
 i5 = i7 + 1380 | 0;
 i6 = i5 + 28 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = i7 + 1412 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i5 = i3;
 i6 = i5 + 80 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1528 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1560 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1516 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 1416 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1532 >> 2] = Math_fround(0.0);
 i6 = i7 + 1564 | 0;
 HEAPF32[i7 + 1520 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1420 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1536 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1524 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1372 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1368 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 1364 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx10PxsCCDPair12updateShapesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 132 | 0;
 i5 = i13 + 104 | 0;
 i6 = i13 + 92 | 0;
 i4 = i13 + 80 | 0;
 i12 = i13 + 52 | 0;
 i10 = i13 + 24 | 0;
 i11 = i13 + 12 | 0;
 i9 = i13;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i2 = i8 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[(HEAP32[i1 + 60 >> 2] | 0) + 16 >> 2] | 0) != (HEAP32[i3 + 92 >> 2] | 0)) {
   __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE(i7, i3, i1);
   __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE(i5, HEAP32[i2 >> 2] | 0, HEAP32[i8 >> 2] | 0);
   i15 = i7 + 16 | 0;
   f21 = Math_fround(HEAPF32[i15 >> 2]);
   f18 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f21 = Math_fround(f21 - f18);
   i14 = i7 + 20 | 0;
   f20 = Math_fround(HEAPF32[i14 >> 2]);
   f17 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f20 = Math_fround(f20 - f17);
   i1 = i7 + 24 | 0;
   f19 = Math_fround(HEAPF32[i1 >> 2]);
   f16 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f19 = Math_fround(f19 - f16);
   Math_fround(__ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E((HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + 36 | 0, i6, i4, i7, 0));
   i3 = HEAP32[i2 >> 2] | 0;
   f21 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f21);
   f20 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f20);
   f19 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f19);
   HEAPF32[i3 + 80 >> 2] = f21;
   HEAPF32[i3 + 84 >> 2] = f20;
   HEAPF32[i3 + 88 >> 2] = f19;
   HEAP32[i3 + 68 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 72 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 76 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAPF32[i3 + 28 >> 2] = f18;
   HEAPF32[i3 + 32 >> 2] = f17;
   HEAPF32[i3 + 36 >> 2] = f16;
   HEAP32[i3 + 40 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 + 44 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i3 + 48 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i3 + 52 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i3 + 56 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i3 + 60 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i3 + 64 >> 2] = HEAP32[i1 >> 2];
   HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + 60 >> 2] | 0) + 16 >> 2];
  }
 }
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i1 = i8 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[(HEAP32[i4 + 60 >> 2] | 0) + 16 >> 2] | 0) == (HEAP32[i2 + 92 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE(i12, i2, i4);
 __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE(i10, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 i7 = i12 + 16 | 0;
 f16 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f16 = Math_fround(f16 - f19);
 i8 = i12 + 20 | 0;
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f20 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f17 = Math_fround(f17 - f20);
 i14 = i12 + 24 | 0;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f18 = Math_fround(f18 - f21);
 Math_fround(__ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E((HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + 36 | 0, i11, i9, i12, 0));
 i15 = HEAP32[i1 >> 2] | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f16);
 f17 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) - f17);
 f18 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f18);
 HEAPF32[i15 + 80 >> 2] = f16;
 HEAPF32[i15 + 84 >> 2] = f17;
 HEAPF32[i15 + 88 >> 2] = f18;
 HEAP32[i15 + 68 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i15 + 72 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i15 + 76 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAPF32[i15 + 28 >> 2] = f19;
 HEAPF32[i15 + 32 >> 2] = f20;
 HEAPF32[i15 + 36 >> 2] = f21;
 HEAP32[i15 + 40 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 + 44 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i15 + 48 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i15 + 52 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i15 + 56 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i15 + 60 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 64 >> 2] = HEAP32[i14 >> 2];
 HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0) + 16 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 100 | 0, i9);
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i4 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i8 + 4 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i8 + 5 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i8 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i8 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i8 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i8 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i8 + 24 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i5 = i8 + 28 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i8 + 32 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 40 | 0, i9);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 56 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i9, i8 + 72 | 0, 0);
 if (Math_fround(HEAPF32[i5 >> 2]) < Math_fround(0.0)) HEAPF32[i5 >> 2] = Math_fround(0.0);
 if (!(Math_fround(HEAPF32[i4 >> 2]) < Math_fround(0.0))) {
  i7 = i8 + 92 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i9);
  i7 = i8 + 96 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i9);
  i8 = i8 + 116 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9);
  STACKTOP = i10;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i7 = i8 + 92 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i9);
 i7 = i8 + 96 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i9);
 i8 = i8 + 116 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20;
 i17 = i13 + 76 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 HEAP32[i16 >> 2] = 54;
 HEAP32[i16 + 4 >> 2] = i18;
 i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 20 | 0, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
 i19 = i13 + 52 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 i14 = i13 + 56 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i12 = i1 >>> 0 > i2 >>> 0 ? i2 : i1;
 i9 = i3 + (i12 * 20 | 0) | 0;
 if (i12) {
  i8 = i16 + 4 | 0;
  i6 = i18;
  while (1) {
   i1 = HEAP32[i3 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i4 = i6 + 12 | 0;
   HEAP32[i4 >> 2] = i1;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i5 = HEAP32[i3 >> 2] | 0;
    i7 = HEAP32[i3 + 4 >> 2] | 0;
    if (i7 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
     i1 = HEAP32[i4 >> 2] | 0;
     i15 = 8;
    } else if (i7 >>> 0 < 11) {
     HEAP8[i6 + 11 >> 0] = i7;
     if (!i7) i1 = i6; else {
      i1 = i6;
      i15 = 10;
     }
    } else i15 = 8;
    if ((i15 | 0) == 8) {
     i12 = i7 + 16 & -16;
     HEAP32[i16 >> 2] = 54;
     HEAP32[i8 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i6 + 8 >> 2] = i12 | -2147483648;
     HEAP32[i6 + 4 >> 2] = i7;
     i15 = 10;
    }
    if ((i15 | 0) == 10) {
     i15 = 0;
     _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
    }
    HEAP8[i1 + i7 >> 0] = 0;
   } else {
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   }
   HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i3 = i3 + 20 | 0;
   if ((i3 | 0) == (i9 | 0)) break; else i6 = i6 + 20 | 0;
  }
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i11 = i18 + (i2 * 20 | 0) | 0;
 i12 = i13 + 32 | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i7 = i13 + 44 | 0;
  i8 = i12 + 11 | 0;
  i9 = i13 + 36 | 0;
  i10 = i16 + 4 | 0;
  i6 = i13 + 48 | 0;
  i4 = i18 + (i1 * 20 | 0) | 0;
  do {
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i2 = i4 + 12 | 0;
   HEAP32[i2 >> 2] = i1;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    i3 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
     i1 = HEAP32[i2 >> 2] | 0;
     i15 = 21;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i4 + 11 >> 0] = i5;
     if (!i5) i1 = i4; else {
      i1 = i4;
      i15 = 23;
     }
    } else i15 = 21;
    if ((i15 | 0) == 21) {
     i13 = i5 + 16 & -16;
     HEAP32[i16 >> 2] = 54;
     HEAP32[i10 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i4 >> 2] = i1;
     HEAP32[i4 + 8 >> 2] = i13 | -2147483648;
     HEAP32[i4 + 4 >> 2] = i5;
     i15 = 23;
    }
    if ((i15 | 0) == 23) {
     i15 = 0;
     _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
    }
    HEAP8[i1 + i5 >> 0] = 0;
   } else {
    HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   }
   HEAP32[i4 + 16 >> 2] = HEAP32[i6 >> 2];
   i4 = i4 + 20 | 0;
  } while ((i4 | 0) != (i11 | 0));
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if (!i2) {
  i15 = HEAP32[i19 >> 2] | 0;
  i14 = HEAP32[i17 >> 2] | 0;
  HEAP32[i16 >> 2] = 54;
  i17 = i16 + 4 | 0;
  HEAP32[i17 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
  HEAP32[i19 >> 2] = i18;
  STACKTOP = i20;
  return;
 }
 i3 = i16 + 4 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i19 >> 2] | 0;
  i5 = i4 + (i1 * 20 | 0) | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i5 >> 2] | 0;
   i14 = HEAP32[i4 + (i1 * 20 | 0) + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 54;
   HEAP32[i3 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i15 = HEAP32[i19 >> 2] | 0;
 i14 = HEAP32[i17 >> 2] | 0;
 HEAP32[i16 >> 2] = 54;
 i17 = i16 + 4 | 0;
 HEAP32[i17 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
 HEAP32[i19 >> 2] = i18;
 STACKTOP = i20;
 return;
}

function __ZL16OutOfMemoryErrorjiRK10MemLabelIdiPKc(i4, i5, i3, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 288 | 0;
 i14 = i18 + 280 | 0;
 i15 = i18 + 264 | 0;
 i10 = i18 + 256 | 0;
 i13 = i18;
 i8 = i18 + 296 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i16 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i16;
  if (i16 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i2 = i1;
   break;
  }
 } else i2 = i1; while (0);
 i16 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i2, 32768, 16, gb + 64016 | 0, 1, gb + 581974 | 0, 962) | 0;
 i2 = (i16 | 0) == 0;
 i16 = i2 ? i8 : i16;
 i2 = i2 ? 512 : 32768;
 do if (!(HEAP32[gb + 1188408 >> 2] | 0)) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i19 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i19;
  if (i19 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) < 128) i1 = HEAP32[gb + 62648 + (i1 << 2) >> 2] | 0; else i1 = gb + 582059 | 0;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i13 + 4 >> 2] = i5;
 HEAP32[i13 + 8 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 i19 = __Z13VFormatBufferPciPKcz(i16, i2, gb + 582066 | 0, i13) | 0;
 if (!((i19 | 0) > -1 & i19 >>> 0 < i2 >>> 0)) {
  _printf_console(gb + 582213 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 582213 | 0, 0, gb + 581974 | 0, 980, 32785, 0, 0, 0);
  if ((i16 | 0) == (i8 | 0)) {
   STACKTOP = i18;
   return;
  }
  i1 = HEAP32[gb + 1188408 >> 2] | 0;
  do if (!i1) {
   i1 = HEAP32[gb + 73344 >> 2] | 0;
   i19 = i1 + 6960 | 0;
   HEAP32[gb + 73344 >> 2] = i19;
   if (i19 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
    __ZN13MemoryManagerC2Ev(i1);
    HEAP32[gb + 1188408 >> 2] = i1;
    i11 = i1;
    break;
   }
  } else i11 = i1; while (0);
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i11, i16, gb + 64016 | 0);
  STACKTOP = i18;
  return;
 }
 if ((i16 | 0) == (i8 | 0)) {
  _printf_console(i8, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i8, 0, gb + 581974 | 0, 996, 32785, 0, 0, 0);
  STACKTOP = i18;
  return;
 }
 i4 = _strlen(i16) | 0;
 i5 = i16 + i4 | 0;
 i4 = i2 - i4 | 0;
 i2 = i4 + -1 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i19 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i19;
  if (i19 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i12 = i1;
   break;
  }
 } else i12 = i1; while (0);
 L39 : do if (i2 >>> 0 >= 17) {
  i1 = i5;
  i2 = gb + 582263 | 0;
  i3 = i1 + 18 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i7 = i12 + 1544 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i1 = i4 + -18 | 0;
   i6 = 0;
   i3 = i5 + 17 | 0;
   i4 = i2;
   while (1) {
    i2 = HEAP32[i12 + 1568 + (i6 << 2) >> 2] | 0;
    if (!i2) i2 = i4; else {
     i9 = HEAP32[i2 + 4 >> 2] | 0;
     i10 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
     i11 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0) | 0;
     i19 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
     HEAP32[i15 >> 2] = i9;
     HEAP32[i15 + 4 >> 2] = i10;
     HEAP32[i15 + 8 >> 2] = i11;
     HEAP32[i15 + 12 >> 2] = i19;
     if ((__Z13VFormatBufferPciPKcz(i13, 256, gb + 582281 | 0, i15) | 0) >>> 0 <= 255) {
      i2 = _strlen(i13) | 0;
      if (i1 >>> 0 < i2 >>> 0) break;
      _strcpy(i3, i13) | 0;
      i3 = i3 + i2 | 0;
      i1 = i1 - i2 | 0;
     }
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) >= (i2 | 0)) break L39; else i4 = i2;
   }
  }
 } while (0);
 _printf_console(i16, i14);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i16, 0, gb + 581974 | 0, 996, 32785, 0, 0, 0);
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i19 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i19;
  if (i19 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i17 = i1;
   break;
  }
 } else i17 = i1; while (0);
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i17, i16, gb + 64016 | 0);
 STACKTOP = i18;
 return;
}

function __ZNK5physx2Gu12TriangleMesh20computeWorldTriangleERNS_10PxTriangleEjRKNS_2Cm8Matrix34EPjS8_(i2, i7, i9, i6, i3, i8) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!(HEAP8[i2 + 172 >> 0] & 2)) {
  i4 = HEAP32[i1 + (i9 * 12 | 0) >> 2] | 0;
  i5 = HEAP32[i1 + (i9 * 12 | 0) + 4 >> 2] | 0;
  i1 = HEAP32[i1 + (i9 * 12 | 0) + 8 >> 2] | 0;
 } else {
  i4 = HEAPU16[i1 + (i9 * 6 | 0) >> 1] | 0;
  i5 = HEAPU16[i1 + (i9 * 6 | 0) + 2 >> 1] | 0;
  i1 = HEAPU16[i1 + (i9 * 6 | 0) + 4 >> 1] | 0;
 }
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i22 + (i4 * 12 | 0) >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i6 >> 2]));
 i27 = i6 + 4 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
 i26 = i6 + 8 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i26 >> 2]));
 f17 = Math_fround(HEAPF32[i22 + (i4 * 12 | 0) + 4 >> 2]);
 i25 = i6 + 12 | 0;
 f19 = Math_fround(f17 * Math_fround(HEAPF32[i25 >> 2]));
 i24 = i6 + 16 | 0;
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2]));
 i23 = i6 + 20 | 0;
 f19 = Math_fround(f11 + f19);
 f18 = Math_fround(f12 + f18);
 f17 = Math_fround(f10 + Math_fround(f17 * Math_fround(HEAPF32[i23 >> 2])));
 f10 = Math_fround(HEAPF32[i22 + (i4 * 12 | 0) + 8 >> 2]);
 i21 = i6 + 24 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 i20 = i6 + 28 | 0;
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i20 >> 2]));
 i16 = i6 + 32 | 0;
 f12 = Math_fround(f19 + f12);
 f11 = Math_fround(f18 + f11);
 f10 = Math_fround(f17 + Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2])));
 i15 = i6 + 36 | 0;
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i15 >> 2]));
 i14 = i6 + 40 | 0;
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i14 >> 2]));
 i13 = i6 + 44 | 0;
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i7 >> 2] = f12;
 HEAPF32[i7 + 4 >> 2] = f11;
 HEAPF32[i7 + 8 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i22 + (i5 * 12 | 0) >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i6 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i26 >> 2]));
 f17 = Math_fround(HEAPF32[i22 + (i5 * 12 | 0) + 4 >> 2]);
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i25 >> 2]));
 f19 = Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2]));
 f18 = Math_fround(f11 + f18);
 f19 = Math_fround(f12 + f19);
 f17 = Math_fround(f10 + Math_fround(f17 * Math_fround(HEAPF32[i23 >> 2])));
 f10 = Math_fround(HEAPF32[i22 + (i5 * 12 | 0) + 8 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i20 >> 2]));
 f12 = Math_fround(f18 + f12);
 f11 = Math_fround(f19 + f11);
 f10 = Math_fround(f17 + Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i15 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i14 >> 2]));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i7 + 12 >> 2] = f12;
 HEAPF32[i7 + 16 >> 2] = f11;
 HEAPF32[i7 + 20 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i6 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i27 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i26 >> 2]));
 f17 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 4 >> 2]);
 f19 = Math_fround(f17 * Math_fround(HEAPF32[i25 >> 2]));
 f18 = Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2]));
 f19 = Math_fround(f11 + f19);
 f18 = Math_fround(f12 + f18);
 f17 = Math_fround(f10 + Math_fround(f17 * Math_fround(HEAPF32[i23 >> 2])));
 f10 = Math_fround(HEAPF32[i22 + (i1 * 12 | 0) + 8 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i20 >> 2]));
 f12 = Math_fround(f19 + f12);
 f11 = Math_fround(f18 + f11);
 f10 = Math_fround(f17 + Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i15 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i14 >> 2]));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i7 + 24 >> 2] = f12;
 HEAPF32[i7 + 28 >> 2] = f11;
 HEAPF32[i7 + 32 >> 2] = f10;
 if (i3 | 0) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
 }
 if (!i8) return;
 i1 = HEAP32[i2 + 184 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = -1;
  HEAP32[i8 + 8 >> 2] = -1;
  return;
 } else {
  i27 = i9 * 3 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 + (i27 << 2) >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + (i27 + 1 << 2) >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + (i27 + 2 << 2) >> 2];
  return;
 }
}

function __ZN8GUIStyleC2ERKS_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i6 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i6 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i4 + 11 >> 0] = i6;
  if (!i6) i1 = i4; else {
   i1 = i4;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i6 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i4 + 4 >> 2] = i6;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 i9 = i4 + 20 | 0;
 i7 = i5 + 20 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i5 + 36 >> 2];
 i9 = i4 + 40 | 0;
 i7 = i5 + 40 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 56 >> 2] = HEAP32[i5 + 56 >> 2];
 i9 = i4 + 60 | 0;
 i7 = i5 + 60 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 76 >> 2] = HEAP32[i5 + 76 >> 2];
 i9 = i4 + 80 | 0;
 i7 = i5 + 80 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 96 >> 2] = HEAP32[i5 + 96 >> 2];
 i9 = i4 + 100 | 0;
 i7 = i5 + 100 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 116 >> 2] = HEAP32[i5 + 116 >> 2];
 i9 = i4 + 120 | 0;
 i7 = i5 + 120 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 136 >> 2] = HEAP32[i5 + 136 >> 2];
 i9 = i4 + 140 | 0;
 i7 = i5 + 140 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 156 >> 2] = HEAP32[i5 + 156 >> 2];
 i9 = i4 + 160 | 0;
 i7 = i5 + 160 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 176 >> 2] = HEAP32[i5 + 176 >> 2];
 HEAP32[i4 + 180 >> 2] = HEAP32[i5 + 180 >> 2];
 HEAP32[i4 + 184 >> 2] = HEAP32[i5 + 184 >> 2];
 HEAP32[i4 + 188 >> 2] = HEAP32[i5 + 188 >> 2];
 HEAP32[i4 + 192 >> 2] = HEAP32[i5 + 192 >> 2];
 HEAP32[i4 + 196 >> 2] = HEAP32[i5 + 196 >> 2];
 HEAP32[i4 + 200 >> 2] = HEAP32[i5 + 200 >> 2];
 HEAP32[i4 + 204 >> 2] = HEAP32[i5 + 204 >> 2];
 HEAP32[i4 + 208 >> 2] = HEAP32[i5 + 208 >> 2];
 HEAP32[i4 + 212 >> 2] = HEAP32[i5 + 212 >> 2];
 HEAP32[i4 + 216 >> 2] = HEAP32[i5 + 216 >> 2];
 HEAP32[i4 + 220 >> 2] = HEAP32[i5 + 220 >> 2];
 HEAP32[i4 + 224 >> 2] = HEAP32[i5 + 224 >> 2];
 HEAP32[i4 + 228 >> 2] = HEAP32[i5 + 228 >> 2];
 HEAP32[i4 + 232 >> 2] = HEAP32[i5 + 232 >> 2];
 HEAP32[i4 + 236 >> 2] = HEAP32[i5 + 236 >> 2];
 HEAP32[i4 + 240 >> 2] = HEAP32[i5 + 240 >> 2];
 HEAP32[i4 + 244 >> 2] = HEAP32[i5 + 244 >> 2];
 i9 = HEAP16[i5 + 248 >> 1] | 0;
 HEAP8[i4 + 248 >> 0] = i9;
 HEAP8[i4 + 249 >> 0] = (i9 & 65535) >>> 8;
 HEAP32[i4 + 252 >> 2] = HEAP32[i5 + 252 >> 2];
 HEAP32[i4 + 256 >> 2] = HEAP32[i5 + 256 >> 2];
 HEAP32[i4 + 260 >> 2] = HEAP32[i5 + 260 >> 2];
 HEAP32[i4 + 264 >> 2] = HEAP32[i5 + 264 >> 2];
 HEAP32[i4 + 268 >> 2] = HEAP32[i5 + 268 >> 2];
 HEAP32[i4 + 272 >> 2] = HEAP32[i5 + 272 >> 2];
 HEAP32[i4 + 276 >> 2] = HEAP32[i5 + 276 >> 2];
 HEAP32[i4 + 280 >> 2] = HEAP32[i5 + 280 >> 2];
 HEAP32[i4 + 284 >> 2] = HEAP32[i5 + 284 >> 2];
 HEAP32[i4 + 288 >> 2] = HEAP32[i5 + 288 >> 2];
 i9 = HEAP16[i5 + 292 >> 1] | 0;
 HEAP8[i4 + 292 >> 0] = i9;
 HEAP8[i4 + 293 >> 0] = (i9 & 65535) >>> 8;
 STACKTOP = i8;
 return;
}

function __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i3, i4, i5, i14) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i7 = i4;
 i6 = i3;
 i1 = i7 - i6 | 0;
 i2 = (i1 | 0) > 124;
 L1 : do if ((i5 | 0) > 0 & i2) while (1) {
  i13 = i4 + -4 | 0;
  while (1) {
   i12 = (i1 >> 2) + -1 | 0;
   __ZN14qsort_internal31_FindAndMovePivotToLastPositionIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i3, i13, i12, i14);
   i1 = -1;
   i2 = i12;
   while (1) {
    while (1) {
     i10 = i1 + 1 | 0;
     i11 = i3 + (i10 << 2) | 0;
     if ((i10 | 0) == (i12 | 0) | (mftCall_iii(i14 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0) ^ 1) break; else i1 = i10;
    }
    do {
     i2 = i2 + -1 | 0;
     i8 = i3 + (i2 << 2) | 0;
    } while (!((i2 | 0) == 0 | (mftCall_iii(i14 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0) ^ 1));
    i9 = HEAP32[i11 >> 2] | 0;
    if ((i10 | 0) >= (i2 | 0)) break;
    HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i9;
    i1 = i10;
   }
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i13 >> 2] = i9;
   i9 = i3 + (i1 + 2 << 2) | 0;
   i5 = ((i5 | 0) / 2 | 0) + ((i5 | 0) / 4 | 0) | 0;
   i10 = i3 + (i1 << 2) + 4 | 0;
   i11 = i10;
   i2 = i11 - i6 >> 2;
   i6 = i9;
   i1 = i7 - i6 | 0;
   i8 = i1 >> 2;
   if ((i2 | 0) >= (i8 | 0)) break;
   __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i3, i10, i2, i14);
   i2 = (i1 | 0) > 124;
   if (!((i5 | 0) > 0 & i2)) {
    i10 = i4;
    break L1;
   } else i3 = i9;
  }
  __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i9, i4, i8, i14);
  i6 = i3;
  i1 = i11 - i6 | 0;
  i2 = (i1 | 0) > 124;
  if ((i5 | 0) > 0 & i2) {
   i4 = i10;
   i7 = i11;
  } else {
   i9 = i3;
   break;
  }
 } else {
  i9 = i3;
  i10 = i4;
 } while (0);
 if (!i2) {
  if (i9 >>> 0 < i10 >>> 0 & (i1 | 0) > 4) i1 = i9; else return;
  do {
   L24 : do if (i1 >>> 0 > i9 >>> 0) {
    i2 = i1;
    i4 = HEAP32[i1 >> 2] | 0;
    do {
     i3 = i2;
     i2 = i2 + -4 | 0;
     if (!(mftCall_iii(i14 | 0, i4 | 0, HEAP32[i2 >> 2] | 0) | 0)) break L24;
     i4 = HEAP32[i3 >> 2] | 0;
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i4;
    } while (i2 >>> 0 > i9 >>> 0);
   } while (0);
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i10 >>> 0);
  return;
 }
 i8 = i1 >> 2;
 i11 = (i8 + -2 | 0) / 2 | 0;
 i7 = i11;
 while (1) {
  i4 = i9 + (i7 << 2) | 0;
  i1 = i7 << 2;
  if ((i11 | 0) >= (i1 >> 2 | 0)) {
   i3 = i1 >> 1;
   i2 = i3 | 1;
   i1 = i9 + (i2 << 2) | 0;
   i3 = i3 + 2 | 0;
   if ((i3 | 0) < (i8 | 0)) {
    i12 = i1 + 4 | 0;
    i13 = mftCall_iii(i14 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
    i1 = i13 ? i12 : i1;
    i2 = i13 ? i3 : i2;
   }
   if (!(mftCall_iii(i14 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i5;
    i3 = i4;
    while (1) {
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     if ((i11 | 0) < (i2 | 0)) break;
     i2 = i2 << 1 | 1;
     i3 = i9 + (i2 << 2) | 0;
     i4 = i2 + 1 | 0;
     if ((i4 | 0) < (i8 | 0)) {
      i12 = i3 + 4 | 0;
      i13 = mftCall_iii(i14 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
      i3 = i13 ? i12 : i3;
      i2 = i13 ? i4 : i2;
     }
     if (mftCall_iii(i14 | 0, HEAP32[i3 >> 2] | 0, i6 | 0) | 0) break; else {
      i13 = i1;
      i1 = i3;
      i3 = i13;
     }
    }
    HEAP32[i1 >> 2] = i5;
   }
  }
  if ((i7 | 0) > 0) i7 = i7 + -1 | 0; else break;
 }
 i11 = i9 + 4 | 0;
 i12 = i9 + 8 | 0;
 do {
  i10 = i10 + -4 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i1;
  i1 = i8;
  i8 = i8 + -1 | 0;
  if ((i1 | 0) != 2) {
   i13 = i1 + -3 | 0;
   i7 = (i13 | 0) / 2 | 0;
   if ((i13 | 0) >= -1) {
    if ((i8 | 0) > 2) {
     i2 = mftCall_iii(i14 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
     i1 = i2 ? i12 : i11;
     i2 = i2 ? 2 : 1;
    } else {
     i1 = i11;
     i2 = 1;
    }
    if (!(mftCall_iii(i14 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0)) {
     i5 = HEAP32[i9 >> 2] | 0;
     i6 = i5;
     i3 = i9;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
      if ((i7 | 0) < (i2 | 0)) break;
      i2 = i2 << 1 | 1;
      i3 = i9 + (i2 << 2) | 0;
      i4 = i2 + 1 | 0;
      if ((i4 | 0) < (i8 | 0)) {
       i15 = i3 + 4 | 0;
       i13 = mftCall_iii(i14 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
       i3 = i13 ? i15 : i3;
       i2 = i13 ? i4 : i2;
      }
      if (mftCall_iii(i14 | 0, HEAP32[i3 >> 2] | 0, i6 | 0) | 0) break; else {
       i15 = i1;
       i1 = i3;
       i3 = i15;
      }
     }
     HEAP32[i1 >> 2] = i5;
    }
   }
  }
 } while ((i8 | 0) > 1);
 return;
}

function __ZN11Rigidbody2D7CleanupE19DeactivateOperation(i14, i11) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 8 | 0;
 i6 = i15;
 i12 = i15 + 16 | 0;
 i13 = i14 + 92 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if ((HEAP32[i1 + 104 >> 2] | 0) > 0) {
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i12 >> 2] = 0;
  i2 = i12 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = i12 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i12 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
  i8 = i5;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i4;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  L6 : do if ((__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i14, i12) | 0) > 0) {
   i1 = HEAP32[i14 + 28 >> 2] | 0;
   if (!i1) i1 = HEAP32[i12 >> 2] | 0; else {
    i10 = __ZNK10GameObject8IsActiveEv(i1) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    if (i10) {
     if (!(HEAP32[i2 >> 2] | 0)) break;
     while (1) {
      __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(HEAP32[i1 >> 2] | 0, 0, i14);
      i1 = i1 + 4 | 0;
      if ((i1 | 0) == ((HEAP32[i12 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0)) break L6;
     }
    }
   }
   if (HEAP32[i2 >> 2] | 0) do {
    __ZN10Collider2D7CleanupEb(HEAP32[i1 >> 2] | 0, 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i12 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
  } while (0);
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i4);
   HEAP32[i12 >> 2] = 0;
  }
 }
 __ZN19CollisionListener2D26DestroyRigidbodyCollisionsEP11Rigidbody2D((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i14);
 __ZN11Rigidbody2D17UpdateConstraintsEb(i14, 1);
 i1 = HEAP32[i13 >> 2] | 0;
 if (HEAP32[i1 + 108 >> 2] | 0) {
  i10 = gb + 64016 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i6;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i12 >> 2] = 0;
  i8 = i12 + 12 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i12 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i12 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
  i6 = i5;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i10;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + 108 >> 2] | 0;
  if (i1 | 0) {
   i4 = 0;
   i6 = 0;
   while (1) {
    i5 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 64 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i3 = i4 & 2147483647;
    do if (i7 >>> 0 > i3 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i3 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i9 >> 2] = i2;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i4 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = i2;
      HEAP32[i12 >> 2] = i4;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i7;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i6 << 2) >> 2] = i5;
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    if (!i1) break;
    i4 = HEAP32[i9 >> 2] | 0;
    i6 = i7;
   }
   if (i7 | 0) {
    i2 = (i11 + -1 | 0) >>> 0 < 2;
    i1 = HEAP32[i12 >> 2] | 0;
    do {
     i11 = HEAP32[i1 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 144 >> 2] | 0, i11 | 0, i2 | 0);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != ((HEAP32[i12 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
   }
  }
  if ((HEAP32[i9 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i10);
   HEAP32[i12 >> 2] = 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZN7b2World11DestroyBodyEP6b2Body(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i1);
 HEAP32[i13 >> 2] = 0;
 if (!(__Z14IsWorldPlayingv() | 0)) __ZN16b2ContactManager20FlushPendingContactsEv((HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102872 | 0);
 i3 = HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
 i1 = i14 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i13 = i14 + 108 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[HEAP32[i13 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
 }
 i1 = i14 + 116 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i14 = i14 + 120 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[HEAP32[i14 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
 }
 HEAP8[i3 + 625 >> 0] = 1;
 STACKTOP = i15;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i11, i13, i5, i14) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 8 | 0;
 i2 = i15;
 i4 = HEAP32[i13 + 8 >> 2] | 0;
 do if (!i4) i6 = 11; else {
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i6 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i12 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
    i2 = HEAP32[i12 + 28 >> 2] | 0;
    i3 = HEAP32[i12 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 9;
   }
  }
  if ((i6 | 0) == 7) i6 = 9;
  if ((i6 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) {
    i6 = 11;
    break;
   }
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) i6 = 11;
 } while (0);
 if ((i6 | 0) == 11) i1 = 0;
 i8 = __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(HEAP32[i5 + 28 >> 2] | 0, 114, i1) | 0;
 if (i8 | 0) {
  i12 = HEAP32[i8 + 20 >> 2] | 0;
  if (i12 | 0) {
   i3 = __ZNK13MonoBehaviour8GetClassEv(i8) | 0;
   i9 = i11 + 60 | 0;
   i10 = i11 + 72 | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   L21 : do if (!i4) i6 = 21; else {
    i5 = HEAP32[i9 >> 2] | 0;
    i2 = 0;
    while (1) {
     i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
     i2 = i2 + 1 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break;
     if (i2 >>> 0 >= i4 >>> 0) {
      i6 = 21;
      break L21;
     }
    }
    if (!i1) i6 = 21; else i7 = i8;
   } while (0);
   if ((i6 | 0) == 21) {
    i1 = __ZN11UnityEngine9AnimationL24GenerateComponentBindingEiP12Il2CppObjectP11Il2CppClassP6Object(HEAPU16[i13 + 12 >> 1] | 0, i12, i3, i8) | 0;
    i3 = HEAP32[i10 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = i11 + 76 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i4 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i11 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
      HEAP32[i5 >> 2] = i2;
      HEAP32[i9 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i1;
    i7 = i8;
   }
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   i5 = HEAP32[i13 + 4 >> 2] | 0;
   i6 = HEAP8[i13 + 15 >> 0] | 0;
   i3 = i1 + (i2 << 4) | 0;
   i2 = i2 << 4 >> 4;
   if (!i2) i4 = i1; else {
    do {
     i10 = (i2 | 0) / 2 | 0;
     i13 = i1 + (i10 << 4) | 0;
     i11 = (HEAP32[i13 >> 2] | 0) >>> 0 < i5 >>> 0;
     i2 = i11 ? i2 + -1 - i10 | 0 : i10;
     i1 = i11 ? i13 + 16 | 0 : i1;
    } while ((i2 | 0) != 0);
    i4 = i1;
   }
   if ((i4 | 0) != (i3 | 0)) if ((HEAP32[i4 >> 2] | 0) >>> 0 <= i5 >>> 0) {
    i3 = i14 + 12 | 0;
    HEAP32[i3 >> 2] = i7;
    HEAP32[i14 >> 2] = i12 + (HEAP32[i4 + 4 >> 2] | 0);
    i1 = HEAP32[i4 + 8 >> 2] | 0;
    i2 = i14 + 4 | 0;
    HEAP32[i2 >> 2] = i1;
    L45 : do if (!(i6 << 24 >> 24)) {
     switch (i1 | 0) {
     case 5:
      break;
     case 6:
      {
       i14 = 100001;
       STACKTOP = i15;
       return i14 | 0;
      }
     default:
      break L45;
     }
     i14 = 100002;
     STACKTOP = i15;
     return i14 | 0;
    } else if ((i1 | 0) == 9) {
     i14 = HEAP32[i4 + 12 >> 2] | 0;
     STACKTOP = i15;
     return i14 | 0;
    } while (0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    i14 = -1;
    STACKTOP = i15;
    return i14 | 0;
   }
   HEAP32[i14 + 4 >> 2] = 0;
   i14 = -1;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 HEAP32[i14 + 4 >> 2] = 0;
 i14 = -1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEj(i17, i19, i4) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i20 + 84 | 0;
 i2 = i20 + 56 | 0;
 i14 = i20 + 28 | 0;
 i18 = i20;
 i3 = HEAP32[i17 + 4 >> 2] | 0;
 if (i3 | 0) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
  __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i19, i1) | 0;
  __ZN5physx2Cm12RenderOutputlsEj(i19, i4) | 0;
  i16 = HEAP32[i3 + 4 >> 2] | 0;
  __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_(i16, i16, i19);
 }
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i19, i2) | 0;
 __ZN5physx2Cm12RenderOutputlsEj(i19, -1) | 0;
 i13 = i17 + 68 | 0;
 L4 : do if (!(HEAP32[i17 + 72 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i17 + 76 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L4;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i17 + 60 | 0;
 i15 = i17 + 7780 | 0;
 i16 = i17 + 7772 | 0;
 i6 = i14 + 4 | 0;
 i7 = i14 + 8 | 0;
 i8 = i14 + 12 | 0;
 i9 = i14 + 16 | 0;
 i10 = i14 + 20 | 0;
 i11 = i14 + 24 | 0;
 i12 = i17 + 64 | 0;
 i4 = i17 + 76 | 0;
 L11 : while (1) {
  do {
   if ((i1 | 0) == -1) break L11;
   i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] | 0;
   i21 = HEAP32[i16 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i21 + (i3 * 24 | 0) >> 2];
   HEAP32[i6 >> 2] = HEAP32[i21 + (i3 * 24 | 0) + 4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i21 + (i3 * 24 | 0) + 8 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i21 + (i3 * 24 | 0) + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i21 + (i3 * 24 | 0) + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i21 + (i3 * 24 | 0) + 20 >> 2];
   HEAP8[i11 >> 0] = 1;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i19, i14) | 0;
   i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L11;
   }
   i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L11;
  }
 }
 i13 = i17 + 112 | 0;
 L21 : do if (!(HEAP32[i17 + 116 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i17 + 120 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L21;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i17 + 104 | 0;
 i6 = i18 + 4 | 0;
 i7 = i18 + 8 | 0;
 i8 = i18 + 12 | 0;
 i9 = i18 + 16 | 0;
 i10 = i18 + 20 | 0;
 i11 = i18 + 24 | 0;
 i12 = i17 + 108 | 0;
 i4 = i17 + 120 | 0;
 L28 : while (1) {
  do {
   if ((i1 | 0) == -1) break L28;
   i21 = HEAP32[(HEAP32[i15 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] << 2) >> 2] | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i17 + (i21 * 24 | 0) >> 2];
   HEAP32[i6 >> 2] = HEAP32[i17 + (i21 * 24 | 0) + 4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i17 + (i21 * 24 | 0) + 8 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i17 + (i21 * 24 | 0) + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i17 + (i21 * 24 | 0) + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i17 + (i21 * 24 | 0) + 20 >> 2];
   HEAP8[i11 >> 0] = 1;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i19, i18) | 0;
   i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L28;
   }
   i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L28;
  }
 }
 STACKTOP = i20;
 return;
}

function __ZN5physx2Sc16InteractionSceneD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i5 + 1e3 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx10PxsContextD2Ev(i1);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1);
 }
 if (HEAP32[i5 + 984 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i5 + 704 | 0);
 i4 = i5 + 968 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 + 972 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i7 = HEAP32[i5 + 976 >> 2] | 0;
 do if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i5 + 708 | 0) == (i1 | 0)) {
   HEAP8[i5 + 964 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i5 + 688 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i5 + 408 | 0);
 i3 = i5 + 672 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i5 + 676 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i7 = HEAP32[i5 + 680 >> 2] | 0;
 do if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 412 | 0) == (i1 | 0)) {
   HEAP8[i5 + 668 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i5 + 392 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i5 + 112 | 0);
 i3 = i5 + 376 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i5 + 380 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i7 = HEAP32[i5 + 384 >> 2] | 0;
 do if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 116 | 0) == (i1 | 0)) {
   HEAP8[i5 + 372 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 } while (0);
 i7 = HEAP32[i5 + 84 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 76 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 72 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 64 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 60 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 52 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 48 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 40 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 36 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 24 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 16 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i7 = HEAP32[i5 + 8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 STACKTOP = i6;
 return;
}

function __Z50CanvasRenderer_CUSTOM_CreateUIVertexStreamInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_S0_(i14, i1, i2, i3, i4, i5, i6, i7) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i16;
 i15 = i16 + 8 | 0;
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i1 + 8 >> 2] | 0, 0, 12) | 0;
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 + 8 >> 2] | 0, 0, 4) | 0;
 i10 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 8) | 0;
 i9 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i4 + 8 >> 2] | 0, 0, 8) | 0;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i5 + 8 >> 2] | 0, 0, 12) | 0;
 i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i6 + 8 >> 2] | 0, 0, 16) | 0;
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i7 + 8 >> 2] | 0, 0, 4) | 0;
 i3 = HEAP32[i7 + 12 >> 2] | 0;
 i6 = i15 + 12 | 0;
 HEAP32[i6 >> 2] = i3;
 i7 = i15 + 16 | 0;
 HEAP32[i7 >> 2] = i3;
 i13 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, gb + 64016 | 0);
 i2 = HEAP32[i17 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 60 | 0, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i15 >> 2] = i1;
 if (i3 | 0) {
  i2 = 0;
  do {
   i18 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   i17 = i1 + (i2 * 60 | 0) | 0;
   i19 = i12 + (i18 * 12 | 0) | 0;
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   i1 = HEAP32[i15 >> 2] | 0;
   i17 = i1 + (i2 * 60 | 0) + 12 | 0;
   i19 = i8 + (i18 * 12 | 0) | 0;
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i1 + (i2 * 60 | 0) + 24 >> 2] = HEAP32[i11 + (i18 << 2) >> 2];
   i17 = i10 + (i18 << 3) | 0;
   i19 = HEAP32[i17 + 4 >> 2] | 0;
   i20 = i1 + (i2 * 60 | 0) + 28 | 0;
   HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i20 = i9 + (i18 << 3) | 0;
   i19 = HEAP32[i20 + 4 >> 2] | 0;
   i17 = i1 + (i2 * 60 | 0) + 36 | 0;
   HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i17 + 4 >> 2] = i19;
   i17 = i1 + (i2 * 60 | 0) + 44 | 0;
   i18 = i4 + (i18 << 4) | 0;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i1 = HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 24 >> 2] | 0;
 i2 = i14 + 8 | 0;
 i20 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i20 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 60, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = 0;
  while (1) {
   i26 = HEAP32[i1 >> 2] | 0;
   i25 = HEAP32[i1 + 4 >> 2] | 0;
   i24 = HEAP32[i1 + 8 >> 2] | 0;
   i23 = HEAP32[i1 + 12 >> 2] | 0;
   i22 = HEAP32[i1 + 16 >> 2] | 0;
   i21 = HEAP32[i1 + 20 >> 2] | 0;
   i5 = HEAP32[i1 + 24 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i9 = HEAP32[i1 + 32 >> 2] | 0;
   i10 = HEAP32[i1 + 36 >> 2] | 0;
   i11 = HEAP32[i1 + 40 >> 2] | 0;
   i12 = HEAP32[i1 + 44 >> 2] | 0;
   i17 = HEAP32[i1 + 48 >> 2] | 0;
   i18 = HEAP32[i1 + 52 >> 2] | 0;
   i19 = HEAP32[i1 + 56 >> 2] | 0;
   i20 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 60) | 0;
   HEAP32[i20 >> 2] = i26;
   HEAP32[i20 + 4 >> 2] = i25;
   HEAP32[i20 + 8 >> 2] = i24;
   HEAP32[i20 + 12 >> 2] = i23;
   HEAP32[i20 + 16 >> 2] = i22;
   HEAP32[i20 + 20 >> 2] = i21;
   HEAP32[i20 + 24 >> 2] = i5;
   HEAP32[i20 + 28 >> 2] = i8;
   HEAP32[i20 + 32 >> 2] = i9;
   HEAP32[i20 + 36 >> 2] = i10;
   HEAP32[i20 + 40 >> 2] = i11;
   HEAP32[i20 + 44 >> 2] = i12;
   HEAP32[i20 + 48 >> 2] = i17;
   HEAP32[i20 + 52 >> 2] = i18;
   HEAP32[i20 + 56 >> 2] = i19;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
  }
 }
 HEAP32[i14 + 12 >> 2] = HEAP32[i6 >> 2];
 i26 = i14 + 16 | 0;
 HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i13);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_(i12, i2) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i13 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i13;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, gb + 470740 | 0, HEAP32[gb + 37052 >> 2] | 0, i14, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i15, 0); else {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i15 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (!(HEAP8[i2 + 128 >> 0] | 0)) {
  i17 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i17 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
  STACKTOP = i18;
  return;
 }
 i8 = i12 + 4 | 0;
 i9 = i8;
 i10 = i12 + 4 | 0;
 i11 = i12 + 8 | 0;
 i2 = i1;
 while (1) {
  i1 = i2 + 32 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i1, i3);
  i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16) | 0;
  i1 = i2 + 16 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 20 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, i3);
  i6 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i8;
   i3 = i9;
   i4 = i8;
   i5 = 26;
  } else {
   while (1) {
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i6 | 0) < (i3 | 0)) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) {
      i5 = 19;
      break;
     } else i1 = i3;
    } else {
     if ((i3 | 0) >= (i6 | 0)) {
      i5 = 25;
      break;
     }
     i4 = i1 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i5 = 23;
      break;
     } else i1 = i3;
    }
   }
   if ((i5 | 0) == 19) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i4 = i1;
    i5 = 26;
    break;
   } else if ((i5 | 0) == 23) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i5 = 26;
    break;
   } else if ((i5 | 0) == 25) {
    i5 = 0;
    HEAP32[i14 >> 2] = i1;
    if (!i1) {
     i3 = i1;
     i4 = i14;
     i5 = 26;
     break;
    } else break;
   }
  } while (0);
  if ((i5 | 0) == 26) {
   i1 = __Znwj(24) | 0;
   HEAP32[i1 + 16 >> 2] = i6;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
   if (!i3) i3 = i1; else {
    HEAP32[i12 >> 2] = i3;
    i3 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i3);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 20 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i1;
 }
 i17 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
 STACKTOP = i18;
 return;
}

function __ZN4Mesh11SetTangentsEPK8Vector4fj(i9, i2, i5) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i10 = i11 + 24 | 0;
 i7 = i11 + 8 | 0;
 i6 = i9 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i3 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i6 >> 2] | 0);
  i3 = HEAP32[i6 >> 2] | 0;
  i12 = i3 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i6 >> 2] = i1;
  i3 = i1;
 }
 if (!((i2 | 0) != 0 & (i5 | 0) != 0)) {
  i1 = i3 + 8 | 0;
  i2 = HEAP32[i3 + 100 >> 2] | 0;
  if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  } else i8 = 8; else i8 = 8;
  if ((i8 | 0) == 8) {
   HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i2, 0, 128, i7, gb + 1546313 | 0);
  i2 = i9 + 44 | 0;
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
  HEAP32[i10 >> 2] = gb + 30832;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = i9;
  i2 = HEAP32[i9 + 236 >> 2] | 0;
  i3 = i9 + 232 | 0;
  i1 = i2;
  if ((i1 | 0) != (i3 | 0)) do {
   i12 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
   i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i3 + 100 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[gb + 58184 + 28 >> 2];
  __Z6FormatPKcz(i10, gb + 427581 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 869, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return;
 }
 i1 = i3 + 8 | 0;
 if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
  HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 } else i8 = 17; else i8 = 17;
 if ((i8 | 0) == 17) {
  HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i5, 128, 0, i7, gb + 1546313 | 0);
 i5 = i2 + (i5 << 4) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i12 = HEAP16[i3 + 38 >> 1] | 0;
 if ((i12 & 65535) < 1024 | (i12 & 255) != 0) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = 1;
  } else if (!(HEAP8[i3 + 39 >> 0] | 0)) {
   i1 = 0;
   i3 = 1;
  } else {
   i12 = HEAP16[i3 + 36 >> 1] | 0;
   i1 = i1 + (((i12 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i12 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 36 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 while (1) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
 }
 i2 = i9 + 44 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
 HEAP32[i10 >> 2] = gb + 30832;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = i9;
 i2 = HEAP32[i9 + 236 >> 2] | 0;
 i3 = i9 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i12 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f32 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f25 = Math_fround(f18 + f18);
 f17 = Math_fround(f32 + f32);
 f15 = Math_fround(f10 + f10);
 f22 = Math_fround(f32 * f17);
 f5 = Math_fround(f10 * f15);
 f32 = Math_fround(f25 * f32);
 f30 = Math_fround(f25 * f10);
 f24 = Math_fround(f25 * f13);
 f10 = Math_fround(f17 * f10);
 f17 = Math_fround(f17 * f13);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(Math_fround(Math_fround(1.0) - f22) - f5);
 f23 = Math_fround(f32 + f13);
 f20 = Math_fround(f30 - f17);
 f13 = Math_fround(f32 - f13);
 f25 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f25));
 f5 = Math_fround(f25 - f5);
 f18 = Math_fround(f10 + f24);
 f17 = Math_fround(f30 + f17);
 f24 = Math_fround(f10 - f24);
 f22 = Math_fround(f25 - f22);
 f25 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f8 = Math_fround(f25 + f25);
 f26 = Math_fround(f10 + f10);
 f7 = Math_fround(f30 + f30);
 f11 = Math_fround(f10 * f26);
 f31 = Math_fround(f30 * f7);
 f10 = Math_fround(f8 * f10);
 f28 = Math_fround(f8 * f30);
 f9 = Math_fround(f8 * f32);
 f30 = Math_fround(f26 * f30);
 f26 = Math_fround(f26 * f32);
 f32 = Math_fround(f7 * f32);
 f7 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f31);
 f6 = Math_fround(f10 + f32);
 f16 = Math_fround(f28 - f26);
 f32 = Math_fround(f10 - f32);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f25 * f8));
 f31 = Math_fround(f8 - f31);
 f25 = Math_fround(f30 + f9);
 f26 = Math_fround(f28 + f26);
 f9 = Math_fround(f30 - f9);
 f11 = Math_fround(f8 - f11);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f30 = Math_fround(f8 * f7);
 f28 = Math_fround(f8 * f32);
 f8 = Math_fround(f8 * f26);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f29 = Math_fround(f6 * f10);
 f27 = Math_fround(f31 * f10);
 f10 = Math_fround(f9 * f10);
 f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f19 = Math_fround(f16 * f21);
 f4 = Math_fround(f25 * f21);
 f21 = Math_fround(f11 * f21);
 f14 = Math_fround(Math_fround(Math_fround(f7 * f30) + Math_fround(f6 * f29)) + Math_fround(f16 * f19));
 f12 = Math_fround(Math_fround(Math_fround(f7 * f28) + Math_fround(f6 * f27)) + Math_fround(f16 * f4));
 f16 = Math_fround(Math_fround(Math_fround(f7 * f8) + Math_fround(f6 * f10)) + Math_fround(f16 * f21));
 f6 = Math_fround(Math_fround(Math_fround(f32 * f30) + Math_fround(f31 * f29)) + Math_fround(f25 * f19));
 f7 = Math_fround(Math_fround(Math_fround(f32 * f28) + Math_fround(f31 * f27)) + Math_fround(f25 * f4));
 f25 = Math_fround(Math_fround(Math_fround(f32 * f8) + Math_fround(f31 * f10)) + Math_fround(f25 * f21));
 f19 = Math_fround(Math_fround(Math_fround(f26 * f30) + Math_fround(f9 * f29)) + Math_fround(f11 * f19));
 f4 = Math_fround(Math_fround(Math_fround(f26 * f28) + Math_fround(f9 * f27)) + Math_fround(f11 * f4));
 f21 = Math_fround(Math_fround(Math_fround(f26 * f8) + Math_fround(f9 * f10)) + Math_fround(f11 * f21));
 f11 = Math_fround(Math_fround(f24 * f16) + Math_fround(Math_fround(f23 * f14) + Math_fround(f5 * f12)));
 f10 = Math_fround(Math_fround(f22 * f16) + Math_fround(Math_fround(f20 * f14) + Math_fround(f18 * f12)));
 f9 = Math_fround(Math_fround(f17 * f25) + Math_fround(Math_fround(f15 * f6) + Math_fround(f13 * f7)));
 f8 = Math_fround(Math_fround(f24 * f25) + Math_fround(Math_fround(f23 * f6) + Math_fround(f5 * f7)));
 f7 = Math_fround(Math_fround(f22 * f25) + Math_fround(Math_fround(f20 * f6) + Math_fround(f18 * f7)));
 f6 = Math_fround(Math_fround(f17 * f21) + Math_fround(Math_fround(f15 * f19) + Math_fround(f13 * f4)));
 f5 = Math_fround(Math_fround(f24 * f21) + Math_fround(Math_fround(f23 * f19) + Math_fround(f5 * f4)));
 f4 = Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f4)));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f17 * f16) + Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12)));
 HEAPF32[i1 + 4 >> 2] = f11;
 HEAPF32[i1 + 8 >> 2] = f10;
 HEAPF32[i1 + 12 >> 2] = f9;
 HEAPF32[i1 + 16 >> 2] = f8;
 HEAPF32[i1 + 20 >> 2] = f7;
 HEAPF32[i1 + 24 >> 2] = f6;
 HEAPF32[i1 + 28 >> 2] = f5;
 HEAPF32[i1 + 32 >> 2] = f4;
 HEAP32[i1 + 36 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i3 + 24 >> 2];
 return;
}

function __ZN18PlayableController4BindEP8PlayableP14DirectorPlayeriP12Il2CppObject(i15, i13, i1, i8, i12) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i11 = i13;
 i10 = i1;
 if (!i13) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 390071 | 0, 0, gb + 390116 | 0, 68, 1, 0, 0, 0);
  STACKTOP = i16;
  return;
 }
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 390201 | 0, 0, gb + 390116 | 0, 74, 1, 0, 0, 0);
  STACKTOP = i16;
  return;
 }
 i2 = i15 + 4 | 0;
 i3 = i15 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i15 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i9 = i7 & 2147483647;
 do if (i5 >>> 0 > i9 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i15 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i10;
 i9 = i15 + 64 | 0;
 if ((i8 | 0) <= -1) i8 = (HEAP32[(HEAP32[i13 + 8 >> 2] | 0) + 48 >> 2] | 0) + -1 | 0;
 i2 = i15 + 76 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i15 + 80 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i15 + 68 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 68 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i8;
 i2 = i15 + 24 | 0;
 i3 = i15 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i15 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i15 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
 i2 = i15 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 if (!i12) i1 = 0; else i1 = __Z22scripting_gchandle_newP12Il2CppObject(i12) | 0;
 HEAP32[i15 + 168 >> 2] = i1;
 HEAP32[i14 >> 2] = fb + 152;
 HEAP8[i14 + 24 >> 0] = 1;
 i9 = i14 + 16 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i14 + 8 | 0;
 HEAP8[i3 >> 0] = 1;
 __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf(i14, i2, i13, 0, 0, 0, 0, Math_fround(1.0));
 HEAP8[i15 + 148 >> 0] = HEAP8[i3 >> 0] | 0;
 i2 = i15 + 44 | 0;
 i3 = i15 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i15 + 60 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 8, i15 + 48 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i15 + 48 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i15 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i15;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i13 = i9;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = (HEAP32[i2 >> 2] | 0) + (i4 << 3) | 0;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __Z14CalcHullBoundsPK8Vector3fPKhhRK5PlaneRK10Matrix4x4fR10MinMaxAABB(i1, i2, i8, i9, i33, i35) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i33 = i33 | 0;
 i35 = i35 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i36 = 0, f37 = f0, f38 = f0, f39 = f0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 3200 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i36 + 1536 | 0;
 i10 = i36;
 i32 = i36 + 3136 | 0;
 i11 = i36 + 3072 | 0;
 HEAP8[i11 >> 0] = 0;
 i30 = i8 & 255;
 i7 = i8 << 24 >> 24 == 0;
 if (i7) i34 = 3; else {
  i3 = 0;
  i4 = i32;
  i5 = i31;
  while (1) {
   i6 = HEAP8[i2 >> 0] | 0;
   __Z16ClipPolysByPlanehPK8Vector3fRK5PlanePhPS_S5_S6_(i6, i1, i9, i4, i5, i11, i10) | 0;
   i5 = i5 + ((HEAPU8[i4 >> 0] | 0) * 12 | 0) | 0;
   i3 = i3 + 1 << 24 >> 24;
   if (i3 << 24 >> 24 == i8 << 24 >> 24) break; else {
    i1 = i1 + ((i6 & 255) * 12 | 0) | 0;
    i2 = i2 + 1 | 0;
    i4 = i4 + 1 | 0;
   }
  }
  if (i7) i34 = 3; else {
   i6 = i33 + 12 | 0;
   i7 = i33 + 28 | 0;
   i8 = i33 + 44 | 0;
   i9 = i33 + 60 | 0;
   i10 = i33 + 8 | 0;
   i11 = i33 + 24 | 0;
   i16 = i33 + 40 | 0;
   i17 = i33 + 56 | 0;
   i18 = i33 + 4 | 0;
   i19 = i33 + 20 | 0;
   i20 = i33 + 36 | 0;
   i21 = i33 + 52 | 0;
   i22 = i33 + 16 | 0;
   i23 = i33 + 32 | 0;
   i24 = i33 + 48 | 0;
   i25 = i35 + 4 | 0;
   i26 = i35 + 8 | 0;
   i27 = i35 + 12 | 0;
   i28 = i35 + 16 | 0;
   i29 = i35 + 20 | 0;
   i5 = i32 + i30 | 0;
   i4 = i31;
   i2 = i32;
   while (1) {
    i32 = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i32 & 255;
    if (i32 << 24 >> 24) {
     i1 = 0;
     do {
      f12 = Math_fround(HEAPF32[i4 + (i1 * 12 | 0) >> 2]);
      f13 = Math_fround(HEAPF32[i4 + (i1 * 12 | 0) + 4 >> 2]);
      f14 = Math_fround(HEAPF32[i4 + (i1 * 12 | 0) + 8 >> 2]);
      f15 = Math_fround(f12 * Math_fround(HEAPF32[i6 >> 2]));
      f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i7 >> 2])));
      f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i8 >> 2])));
      f15 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f15);
      i32 = f15 < Math_fround(0.0);
      f37 = Math_fround(-f15);
      if ((i32 ? f37 : f15) > Math_fround(1.00000001e-07)) {
       f39 = Math_fround(f12 * Math_fround(HEAPF32[i10 >> 2]));
       f39 = Math_fround(f39 + Math_fround(f13 * Math_fround(HEAPF32[i11 >> 2])));
       f39 = Math_fround(f39 + Math_fround(f14 * Math_fround(HEAPF32[i16 >> 2])));
       f39 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f39);
       f38 = Math_fround(f12 * Math_fround(HEAPF32[i18 >> 2]));
       f38 = Math_fround(f38 + Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2])));
       f38 = Math_fround(f38 + Math_fround(f14 * Math_fround(HEAPF32[i20 >> 2])));
       f38 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f38);
       f37 = Math_fround(f12 * Math_fround(HEAPF32[i33 >> 2]));
       f37 = Math_fround(f37 + Math_fround(f13 * Math_fround(HEAPF32[i22 >> 2])));
       f14 = Math_fround(f37 + Math_fround(f14 * Math_fround(HEAPF32[i23 >> 2])));
       f37 = Math_fround(Math_fround(1.0) / f15);
       f12 = Math_fround(f37 * f39);
       f13 = Math_fround(f37 * f38);
       f14 = Math_fround(f37 * Math_fround(Math_fround(HEAPF32[i24 >> 2]) + f14));
      } else {
       f12 = Math_fround(0.0);
       f13 = Math_fround(0.0);
       f14 = Math_fround(0.0);
      }
      f39 = Math_fround(HEAPF32[i35 >> 2]);
      f38 = Math_fround(HEAPF32[i25 >> 2]);
      f37 = Math_fround(HEAPF32[i26 >> 2]);
      HEAPF32[i35 >> 2] = f14 < f39 ? f14 : f39;
      HEAPF32[i25 >> 2] = f13 < f38 ? f13 : f38;
      HEAPF32[i26 >> 2] = f12 < f37 ? f12 : f37;
      f37 = Math_fround(HEAPF32[i27 >> 2]);
      f38 = Math_fround(HEAPF32[i28 >> 2]);
      f39 = Math_fround(HEAPF32[i29 >> 2]);
      HEAPF32[i27 >> 2] = f37 < f14 ? f14 : f37;
      HEAPF32[i28 >> 2] = f38 < f13 ? f13 : f38;
      HEAPF32[i29 >> 2] = f39 < f12 ? f12 : f39;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
    }
    if ((i2 | 0) == (i5 | 0)) {
     i1 = i35;
     break;
    } else i4 = i4 + (i3 * 12 | 0) | 0;
   }
  }
 }
 if ((i34 | 0) == 3) i1 = i35;
 if (Math_fround(HEAPF32[i1 >> 2]) < Math_fround(-1.0)) HEAPF32[i1 >> 2] = Math_fround(-1.0);
 i1 = i35 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) < Math_fround(-1.0)) HEAPF32[i1 >> 2] = Math_fround(-1.0);
 i1 = i35 + 12 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) > Math_fround(1.0)) HEAPF32[i1 >> 2] = Math_fround(1.0);
 i1 = i35 + 16 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) > Math_fround(1.0))) {
  STACKTOP = i36;
  return;
 }
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 STACKTOP = i36;
 return;
}

function __ZN19TransportJavaScript9DoRequestERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEm21UnityWebRequestMethodS8_bbP12HeaderHelperP13UploadHandlerP15DownloadHandlerP14ResponseHelperP15UnityWebRequest(i8, i5, i6, i3, i4, i1, i2, i7, i17, i11, i9, i10) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i15 = i16 + 16 | 0;
 if (HEAP8[i8 + 16 >> 0] | 0) {
  i18 = 17;
  STACKTOP = i16;
  return i18 | 0;
 }
 switch (i3 | 0) {
 case 0:
  {
   i1 = gb + 1030905 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 1030900 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 1030896 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 1030891 | 0;
   break;
  }
 case 4:
  {
   i1 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   break;
  }
 default:
  i1 = gb + 1030883 | 0;
 }
 i5 = _JS_WebRequest_Create(((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0, i1 | 0) | 0;
 i14 = i8 + 12 | 0;
 HEAP32[i14 >> 2] = i5;
 _JS_WebRequest_SetTimeout(i5 | 0, i6 * 1e3 | 0);
 _JS_WebRequest_SetResponseHandler(HEAP32[i14 >> 2] | 0, i8 | 0, fb + 166 | 0);
 _JS_WebRequest_SetProgressHandler(HEAP32[i14 >> 2] | 0, i8 | 0, fb + 996 | 0);
 if (i7 | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = i7 + 4 | 0;
  if ((i2 | 0) != (i4 | 0)) while (1) {
   i1 = i2 + 16 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i3 = i2 + 28 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
   _JS_WebRequest_SetRequestHeader(HEAP32[i14 >> 2] | 0, i1 | 0, i3 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 HEAP32[i8 >> 2] = i11;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i13;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i15 >> 2] = 0;
 i4 = i15 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i15 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i11 = i12;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i6;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 L32 : do if (!i17) i18 = 37; else {
  i1 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1, 1, i6, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i15 >> 2] = i13;
   break;
  } while (0);
  i3 = HEAP32[gb + 187872 >> 2] | 0;
  i1 = 0;
  L40 : while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 >>> 0 <= i1 >>> 0) {
    i18 = 37;
    break L32;
   }
   i2 = mftCall_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, (HEAP32[i15 >> 2] | 0) + i1 | 0, 1, i2 - i1 | 0) | 0;
   do if ((i2 | 0) == (i3 | 0)) i2 = 1; else {
    i1 = i2 + i1 | 0;
    if (!i2) {
     HEAP32[i4 >> 2] = i1;
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i5 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1, 1, i6, 0, gb + 1047584 | 0, 464) | 0;
      i2 = 6;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i5 >> 2] = i1;
      HEAP32[i15 >> 2] = i2;
      i2 = 6;
      break;
     } else i2 = 6;
    } else i2 = 0;
   } while (0);
   switch (i2 & 7) {
   case 6:
    {
     i18 = 37;
     break L32;
    }
   case 0:
    break;
   default:
    break L40;
   }
  }
  if (!i2) i18 = 37; else i1 = 17;
 } while (0);
 if ((i18 | 0) == 37) {
  _JS_WebRequest_Send(HEAP32[i14 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  i1 = 0;
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i6);
  HEAP32[i15 >> 2] = 0;
 }
 i18 = i1;
 STACKTOP = i16;
 return i18 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_19base_nameINSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEEEET_RS9_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i8 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L1 : do switch ((i2 ? i1 : i3 & 255) | 0) {
 case 0:
  {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i4, i8);
   break;
  }
 case 11:
  if (!(__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i8 >> 2] | 0 : i8, gb + 1086515 | 0, 11) | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i8, gb + 1087119 | 0, 70);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i4, gb + 1087190 | 0, 12);
   break L1;
  } else {
   i3 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i6 = 6;
   break L1;
  }
 default:
  i6 = 6;
 } while (0);
 L7 : do if ((i6 | 0) == 6) {
  i2 = i3 << 24 >> 24 < 0;
  do if (((i2 ? i1 : i3 & 255) | 0) == 12) if (!(__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i8 >> 2] | 0 : i8, gb + 1086527 | 0, 12) | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i8, gb + 1087203 | 0, 49);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i4, gb + 1087253 | 0, 13);
   break L7;
  } else {
   i3 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  } while (0);
  i2 = i3 << 24 >> 24 < 0;
  do if (((i2 ? i1 : i3 & 255) | 0) == 12) if (!(__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i8 >> 2] | 0 : i8, gb + 1086540 | 0, 12) | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i8, gb + 1087267 | 0, 49);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i4, gb + 1087317 | 0, 13);
   break L7;
  } else {
   i3 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  } while (0);
  i2 = i3 << 24 >> 24 < 0;
  do if (((i2 ? i1 : i3 & 255) | 0) == 13) if (!(__ZNSt3__211char_traitsIcE7compareEPKcS3_j(i2 ? HEAP32[i8 >> 2] | 0 : i8, gb + 1086553 | 0, 13) | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i8, gb + 1087331 | 0, 50);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i4, gb + 1087382 | 0, 14);
   break L7;
  } else {
   i2 = i8;
   i3 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  } else i2 = i8; while (0);
  i7 = i3 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i8 >> 2] | 0 : i2;
  i1 = i5 + (i7 ? i1 : i3 & 255) | 0;
  L28 : do if ((HEAP8[i1 + -1 >> 0] | 0) == 62) {
   i2 = 1;
   L29 : while (1) {
    L31 : while (1) {
     i3 = i1 + -1 | 0;
     if ((i3 | 0) == (i5 | 0)) break L29;
     i1 = i1 + -2 | 0;
     switch (HEAP8[i1 >> 0] | 0) {
     case 60:
      {
       i6 = 26;
       break L31;
      }
     case 62:
      {
       i6 = 27;
       break L31;
      }
     default:
      i1 = i3;
     }
    }
    if ((i6 | 0) == 26) {
     i2 = i2 + -1 | 0;
     if (!i2) break L28; else {
      i1 = i3;
      continue;
     }
    } else if ((i6 | 0) == 27) {
     i2 = i2 + 1 | 0;
     i1 = i3;
     continue;
    }
   }
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break L7;
    HEAP32[i4 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
  } while (0);
  i3 = i1;
  while (1) {
   i2 = i3 + -1 | 0;
   if ((i2 | 0) == (i5 | 0)) {
    i2 = i5;
    break;
   }
   if ((HEAP8[i2 >> 0] | 0) == 58) {
    i2 = i3;
    break;
   } else i3 = i2;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i5 = i1 - i2 | 0;
  if (i5 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  if (i5 >>> 0 < 11) HEAP8[i4 + 11 >> 0] = i5; else {
   i7 = i5 + 16 & -16;
   i8 = _malloc(i7) | 0;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i4 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = i8;
  }
  i3 = i4;
  while (1) {
   if ((i2 | 0) == (i1 | 0)) break;
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  }
  HEAP8[i4 + i5 >> 0] = 0;
 } while (0);
 return;
}

function __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6insertINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueESA_E4typeENS8_IPKS2_EESC_SC_(i13, i1, i2, i3) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4;
 i1 = i4 + ((((HEAP32[i1 >> 2] | 0) - i5 | 0) / 40 | 0) * 40 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i15 = i4 - i2 | 0;
 i7 = (i15 | 0) / 40 | 0;
 i10 = i4;
 if ((i15 | 0) <= 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = i13 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i15 = i13 + 4 | 0;
 i9 = HEAP32[i15 >> 2] | 0;
 i6 = i9;
 if ((i7 | 0) <= ((i3 - i6 | 0) / 40 | 0 | 0)) {
  i6 = i6 - i1 | 0;
  i3 = (i6 | 0) / 40 | 0;
  if ((i7 | 0) > (i3 | 0)) {
   i5 = i2 + (i3 * 40 | 0) | 0;
   i4 = i5;
   if ((i5 | 0) == (i10 | 0)) i3 = i9; else {
    i3 = i9;
    do {
     __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i3, i5);
     __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i3 + 20 | 0, i5 + 20 | 0);
     i5 = i5 + 40 | 0;
     i3 = (HEAP32[i15 >> 2] | 0) + 40 | 0;
     HEAP32[i15 >> 2] = i3;
    } while ((i5 | 0) != (i10 | 0));
   }
   if ((i6 | 0) <= 0) {
    i15 = i1;
    STACKTOP = i16;
    return i15 | 0;
   }
  } else i3 = i9;
  i7 = i3 - (i1 + (i7 * 40 | 0)) | 0;
  i5 = i1 + (((i7 | 0) / 40 | 0) * 40 | 0) | 0;
  if (i5 >>> 0 < i9 >>> 0) {
   i6 = i5;
   i8 = i3;
   do {
    __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i8, i6);
    __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i8 + 20 | 0, i6 + 20 | 0);
    i6 = i6 + 40 | 0;
    i8 = (HEAP32[i15 >> 2] | 0) + 40 | 0;
    HEAP32[i15 >> 2] = i8;
   } while (i6 >>> 0 < i9 >>> 0);
  }
  if (i7 | 0) do {
   i3 = i3 + -40 | 0;
   i5 = i5 + -40 | 0;
   __ZN11DynamicMesh10DetailHullaSERKS0_(i3, i5) | 0;
  } while ((i5 | 0) != (i1 | 0));
  if ((i2 | 0) == (i4 | 0)) {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  } else i3 = i1;
  while (1) {
   __ZN11DynamicMesh10DetailHullaSERKS0_(i3, i2) | 0;
   i2 = i2 + 40 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 40 | 0;
  }
  STACKTOP = i16;
  return i1 | 0;
 }
 i12 = i13 + 12 | 0;
 i4 = ((i6 - i5 | 0) / 40 | 0) + i7 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i3 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i13 >> 2] | 0;
 }
 i9 = (i3 - i5 | 0) / 40 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 40 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i9 = i4 + (((i1 - i5 | 0) / 40 | 0) * 40 | 0) | 0;
 i5 = i9;
 i8 = i4 + (i3 * 40 | 0) | 0;
 if ((i2 | 0) == (i10 | 0)) i7 = i5; else {
  i3 = i5;
  i4 = i9;
  do {
   __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i4, i2);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i4 + 20 | 0, i2 + 20 | 0);
   i4 = i3 + 40 | 0;
   i3 = i4;
   i2 = i2 + 40 | 0;
  } while ((i2 | 0) != (i10 | 0));
  i7 = i3;
 }
 i6 = HEAP32[i13 >> 2] | 0;
 if ((i6 | 0) == (i1 | 0)) i2 = i9; else {
  i4 = i1;
  i3 = i5;
  i2 = i9;
  do {
   i10 = i4;
   i4 = i4 + -40 | 0;
   __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i2 + -40 | 0, i4);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + -20 | 0, i10 + -20 | 0);
   i2 = i3 + -40 | 0;
   i3 = i2;
  } while ((i4 | 0) != (i6 | 0));
  i5 = i3;
 }
 i4 = HEAP32[i15 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) i3 = i7; else {
  i3 = i7;
  i2 = i7;
  do {
   __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i2, i1);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + 20 | 0, i1 + 20 | 0);
   i1 = i1 + 40 | 0;
   i2 = i3 + 40 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i5;
  i1 = HEAP32[i15 >> 2] | 0;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i11 >> 2] = i8;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = i2 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -36 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i4 | 0));
 if (!i4) {
  i15 = i9;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i12 >> 2] | 0;
 HEAP32[i14 >> 2] = 1;
 HEAP32[i14 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i14);
 i15 = i9;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i9, i10, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, d8 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 128 | 0;
 i15 = i18;
 i6 = i18 + 136 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i5;
 HEAP8[i15 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i15;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
 HEAP32[i6 >> 2] = 530;
 i14 = HEAP32[i17 + 20 >> 2] | 0;
 i14 = (i14 | 0) == 0 ? i6 : i14;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i12 = i15 + 4 | 0;
  i13 = i17 + 8 | 0;
  i6 = i9 + 12 | 0;
  i9 = i17 + 4 | 0;
  i11 = i17 + 12 | 0;
  do {
   i3 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i17 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i15 >> 2] = i1;
   HEAP8[i12 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i19 = i15;
    i4 = HEAP32[i19 + 4 >> 2] | 0;
    i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i15) | 0;
   f7 = Math_fround(+mftCall_fii(HEAP32[i6 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0));
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d8 = +f7;
   i1 = i15;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i16 >> 3] = d8;
   __ZN5physx6string9sprintf_sEPcjPKcz(i15, 128, gb + 832323 | 0, i16) | 0;
   if (HEAP8[i15 >> 0] | 0) {
    i19 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_iiii(i19 | 0, i5 | 0, i15 | 0, _strlen(i15) | 0) | 0;
   }
   HEAP8[i15 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i15 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i5 + 20 >> 2] | 0);
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i17 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i10 = i10 + 8 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPNS_15basic_streambufIwS2_EE(i16, i14) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i15 | 0, i16 | 0);
 i13 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i13 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i16;
  i3 = i16;
  i4 = 33;
 } else {
  L4 : do if (HEAP8[i15 >> 0] | 0) {
   i1 = i16 + (HEAP32[(HEAP32[i16 >> 2] | 0) + -12 >> 2] | 0) | 0;
   do if (!i14) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i1 | 0, HEAP32[i1 + 16 >> 2] | 1 | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) i4 = 18; else break L4;
   } else {
    i12 = HEAP32[i1 + 24 >> 2] | 0;
    i6 = i14 + 12 | 0;
    i7 = i14 + 16 | 0;
    i8 = i12;
    i9 = (i12 | 0) == 0;
    i10 = i8 + 24 | 0;
    i11 = i8 + 28 | 0;
    i13 = 0;
    while (1) {
     i1 = HEAP32[i6 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0) | 0;
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i4 = 19;
       break;
      }
     } else i1 = HEAP32[i1 >> 2] | 0;
     i5 = (i1 | 0) == -1;
     i3 = i5 ? 0 : i14;
     if (i5) {
      i4 = 27;
      break;
     }
     i4 = i3 + 12 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     i5 = i3 + 16 | 0;
     if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i4 = 19;
       break;
      }
     } else i1 = HEAP32[i1 >> 2] | 0;
     if (i9) {
      i4 = 27;
      break;
     }
     i2 = HEAP32[i10 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i8 | 0, i1 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (i2 & 1) {
       i4 = 19;
       break;
      }
     } else {
      HEAP32[i10 >> 2] = i2 + 4;
      HEAP32[i2 >> 2] = i1;
     }
     if ((i1 | 0) == -1) {
      i4 = 27;
      break;
     }
     i1 = HEAP32[i4 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
      i5 = __THREW__;
      __THREW__ = 0;
      if (i5 & 1) {
       i4 = 19;
       break;
      }
     } else HEAP32[i4 >> 2] = i1 + 4;
     i13 = i13 + 1 | 0;
    }
    if ((i4 | 0) == 19) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i4 | 0) == 27) {
     if (i13 | 0) break L4;
     i14 = i16 + (HEAP32[(HEAP32[i16 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 4 | 0);
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) break L4;
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
    ___cxa_begin_catch(i1 | 0) | 0;
    __THREW__ = 0;
    invoke_vi(fb + 3999 | 0, i16 + (HEAP32[(HEAP32[i16 >> 2] | 0) + -12 >> 2] | 0) | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __THREW__ = 0;
     invoke_v(fb + 458 | 0);
     i14 = __THREW__;
     __THREW__ = 0;
     if (i14 & 1) {
      i4 = 38;
      break L1;
     } else break;
    } else {
     __THREW__ = 0;
     invoke_v(fb + 458 | 0);
     i14 = __THREW__;
     __THREW__ = 0;
     if (i14 & 1) {
      i4 = 18;
      break;
     } else break L4;
    }
   } while (0);
   if ((i4 | 0) == 18) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i15);
   i2 = i16;
   i3 = i16;
   i4 = 33;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i15);
  i4 = 35;
 } while (0);
 do if ((i4 | 0) == 33) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i15 = __THREW__;
  __THREW__ = 0;
  if (!(i15 & 1)) {
   ___cxa_end_catch();
   i4 = 35;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i17 = __THREW__;
  __THREW__ = 0;
  if (i17 & 1) i4 = 38; else ___resumeException(i1 | 0);
 } while (0);
 if ((i4 | 0) == 35) {
  STACKTOP = i17;
  return i16 | 0;
 } else if ((i4 | 0) == 38) {
  i17 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i17);
 }
 return 0;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 52;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 52;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 52;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 51;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 51;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_(i1, i13, i12, i11, i7, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i14 = __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_(i1, i13, i12, i11, i2) | 0;
 i5 = HEAP8[i7 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255;
 i8 = i11 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i9 = i11 + 4 | 0;
 i6 = i3 ? HEAP32[i9 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 3; else {
  i2 = _memcmp(i4 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i11 >> 2] | 0 : i11, i2) | 0;
  if (!i2) i16 = 3; else if ((i2 | 0) < 0) {
   i2 = i7;
   i10 = i11;
  } else {
   i16 = i14;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 3) if (i5 >>> 0 < i6 >>> 0) {
  i2 = i7;
  i10 = i11;
  break;
 } else {
  i16 = i14;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i7 = i14 + 1 | 0;
 i5 = HEAP8[i8 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
 i8 = i12 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i9 = i12 + 4 | 0;
 i6 = i3 ? HEAP32[i9 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 8; else {
  i2 = _memcmp(i4 ? HEAP32[i11 >> 2] | 0 : i10, i3 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
  if (!i2) i16 = 8; else if ((i2 | 0) < 0) i11 = i12; else {
   i16 = i7;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 8) if (i5 >>> 0 < i6 >>> 0) {
  i11 = i12;
  break;
 } else {
  i16 = i7;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i7 = i14 + 2 | 0;
 i5 = HEAP8[i8 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
 i9 = i13 + 11 | 0;
 i6 = HEAP8[i9 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i10 = i13 + 4 | 0;
 i6 = i3 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 13; else {
  i2 = _memcmp(i4 ? HEAP32[i12 >> 2] | 0 : i11, i3 ? HEAP32[i13 >> 2] | 0 : i13, i2) | 0;
  if (!i2) i16 = 13; else if ((i2 | 0) < 0) i8 = i13; else {
   i16 = i7;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 13) if (i5 >>> 0 < i6 >>> 0) {
  i8 = i13;
  break;
 } else {
  i16 = i7;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i7 = i14 + 3 | 0;
 i5 = HEAP8[i9 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i10 >> 2] | 0 : i5 & 255;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 18; else {
  i2 = _memcmp(i4 ? HEAP32[i13 >> 2] | 0 : i8, i3 ? HEAP32[i1 >> 2] | 0 : i1, i2) | 0;
  if (!i2) i16 = 18; else if ((i2 | 0) >= 0) {
   i16 = i7;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 18) if (i5 >>> 0 < i6 >>> 0) break; else {
  i16 = i7;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i16 = i14 + 4 | 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN2UI13RectTransform8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN9Transform8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i8 = i1 + 136 | 0;
 i7 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405998 | 0, i7, i8, 0);
 i5 = i2 + 20 | 0;
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 144 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406010 | 0, i7, i8, 0);
 i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 148 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 152 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406022 | 0, i7, i8, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 160 | 0;
 i7 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406041 | 0, i7, i8, 0);
 i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 168 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902162 | 0, i7, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 172 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 24 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 24 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    do {
     i2 = i1 + -24 | 0;
     HEAP32[i5 >> 2] = i2;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
      i15 = HEAP32[i2 >> 2] | 0;
      i1 = HEAP32[i1 + -12 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i1;
      __Z19free_alloc_internalPvRK10MemLabelId(i15, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     } else i1 = i2;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 178956970) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 24 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 89478485 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 178956970;
  if (i1 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 24 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 24 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 24 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 24 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i5 = i8 + 16 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i1 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   i8 = i8 + 24 | 0;
   i1 = i1 + 24 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 24 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -24 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -12 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZN5Umbra9intersectERKNS_11LineSegmentERKNS_4QuadE(i2, i17) {
 i2 = i2 | 0;
 i17 = i17 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0;
 f3 = Math_fround(HEAPF32[i17 >> 2]);
 f4 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i17 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i17 + 28 >> 2]);
 f11 = Math_fround(HEAPF32[i17 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(f4 - f13);
 f16 = Math_fround(f5 - f14);
 f21 = Math_fround(f7 - f13);
 f20 = Math_fround(f8 - f14);
 f1 = Math_fround(f10 - f13);
 f19 = Math_fround(f11 - f14);
 f19 = Math_fround(Math_fround(Math_fround(f9 - f12) * Math_fround(Math_fround(f15 * f20) - Math_fround(f21 * f16))) + Math_fround(Math_fround(Math_fround(f3 - f12) * Math_fround(Math_fround(f21 * f19) - Math_fround(f1 * f20))) + Math_fround(Math_fround(f6 - f12) * Math_fround(Math_fround(f1 * f16) - Math_fround(f15 * f19)))));
 f15 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f20 = Math_fround(f4 - f16);
 f21 = Math_fround(f5 - f1);
 f24 = Math_fround(f7 - f16);
 f23 = Math_fround(f8 - f1);
 f22 = Math_fround(f10 - f16);
 f18 = Math_fround(f11 - f1);
 f18 = Math_fround(Math_fround(Math_fround(f9 - f15) * Math_fround(Math_fround(f20 * f23) - Math_fround(f24 * f21))) + Math_fround(Math_fround(Math_fround(f3 - f15) * Math_fround(Math_fround(f24 * f18) - Math_fround(f22 * f23))) + Math_fround(Math_fround(f6 - f15) * Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f18)))));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 if (((HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0) ^ i2 | 0) > -1) return 0; else {
  f22 = Math_fround(f13 - f7);
  f21 = Math_fround(f14 - f8);
  f24 = Math_fround(f16 - f7);
  f19 = Math_fround(f1 - f8);
  f20 = Math_fround(f4 - f7);
  f18 = Math_fround(f5 - f8);
  f19 = Math_fround(Math_fround(Math_fround(f3 - f6) * Math_fround(Math_fround(f22 * f19) - Math_fround(f21 * f24))) + Math_fround(Math_fround(Math_fround(f15 - f6) * Math_fround(Math_fround(f20 * f21) - Math_fround(f18 * f22))) + Math_fround(Math_fround(f12 - f6) * Math_fround(Math_fround(f18 * f24) - Math_fround(f20 * f19)))));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  f19 = Math_fround(f13 - f10);
  f20 = Math_fround(f14 - f11);
  f24 = Math_fround(f16 - f10);
  f18 = Math_fround(f1 - f11);
  f22 = Math_fround(f7 - f10);
  f21 = Math_fround(f8 - f11);
  f18 = Math_fround(Math_fround(Math_fround(f6 - f9) * Math_fround(Math_fround(f19 * f18) - Math_fround(f20 * f24))) + Math_fround(Math_fround(Math_fround(f15 - f9) * Math_fround(Math_fround(f22 * f20) - Math_fround(f21 * f19))) + Math_fround(Math_fround(f12 - f9) * Math_fround(Math_fround(f21 * f24) - Math_fround(f22 * f18)))));
  i25 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  f18 = Math_fround(HEAPF32[i17 + 36 >> 2]);
  f22 = Math_fround(HEAPF32[i17 + 40 >> 2]);
  f24 = Math_fround(HEAPF32[i17 + 44 >> 2]);
  f21 = Math_fround(f13 - f22);
  f19 = Math_fround(f14 - f24);
  f7 = Math_fround(f16 - f22);
  f8 = Math_fround(f1 - f24);
  f20 = Math_fround(f10 - f22);
  f23 = Math_fround(f11 - f24);
  f23 = Math_fround(Math_fround(Math_fround(f9 - f18) * Math_fround(Math_fround(f21 * f8) - Math_fround(f7 * f19))) + Math_fround(Math_fround(Math_fround(f12 - f18) * Math_fround(Math_fround(f7 * f23) - Math_fround(f20 * f8))) + Math_fround(Math_fround(f15 - f18) * Math_fround(Math_fround(f20 * f19) - Math_fround(f21 * f23)))));
  i17 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f23 = Math_fround(f13 - f4);
  f21 = Math_fround(f14 - f5);
  f19 = Math_fround(f16 - f4);
  f20 = Math_fround(f1 - f5);
  f22 = Math_fround(f22 - f4);
  f24 = Math_fround(f24 - f5);
  f24 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) - Math_fround(f21 * f19)) * Math_fround(f18 - f3)) + Math_fround(Math_fround(Math_fround(f12 - f3) * Math_fround(Math_fround(f19 * f24) - Math_fround(f20 * f22))) + Math_fround(Math_fround(f15 - f3) * Math_fround(Math_fround(f21 * f22) - Math_fround(f23 * f24)))));
  i2 = i2 >>> 31;
  return (i2 | 0) == ((HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0) >>> 31 | 0) & ((i2 | 0) == (i25 >>> 31 | 0) & (i2 | 0) == (i17 >>> 31 | 0)) | 0;
 }
 return 0;
}

function _UNITY_png_write_iTXt(i17, i6, i3, i7, i8, i11) {
 i17 = i17 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 1120 | 0;
 i14 = i19 + 1036 | 0;
 i16 = i19;
 if (!i3) {
  HEAP8[i14 >> 0] = 0;
  _UNITY_png_error(i17, gb + 355451 | 0);
 }
 i4 = HEAP8[i3 >> 0] | 0;
 L5 : do if (!(i4 << 24 >> 24)) {
  i3 = 1;
  i1 = 0;
  i2 = i14;
 } else {
  i5 = 1;
  i1 = 0;
  i2 = i14;
  while (1) {
   L8 : do if (!i5) {
    i10 = (i4 & 255) > 160 | (i4 + -33 & 255) < 94;
    i5 = i10 & 1 ^ 1;
    i3 = i3 + 1 | 0;
    i4 = i10 ? i4 : 32;
   } else while (1) {
    i3 = i3 + 1 | 0;
    if ((i4 & 255) > 160 | (i4 + -33 & 255) < 94) {
     i5 = 0;
     break L8;
    }
    i4 = HEAP8[i3 >> 0] | 0;
    if (!(i4 << 24 >> 24)) {
     i3 = i5;
     break L5;
    }
   } while (0);
   HEAP8[i2 >> 0] = i4;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   if (!(i1 >>> 0 < 79 & i4 << 24 >> 24 != 0)) {
    i3 = i5;
    break;
   }
  }
 } while (0);
 i10 = (i1 | 0) != 0 & (i3 | 0) != 0;
 i1 = (i10 << 31 >> 31) + i1 | 0;
 HEAP8[(i10 ? i2 + -1 | 0 : i2) >> 0] = 0;
 if (!i1) _UNITY_png_error(i17, gb + 355451 | 0);
 switch (i6 | 0) {
 case -1:
 case 1:
  {
   i12 = i1 + 1 | 0;
   HEAP8[i14 + i12 >> 0] = 0;
   i15 = 0;
   break;
  }
 case 2:
 case 0:
  {
   i12 = i1 + 1 | 0;
   HEAP8[i14 + i12 >> 0] = 1;
   i15 = 1;
   break;
  }
 default:
  _UNITY_png_error(i17, gb + 355473 | 0);
 }
 HEAP8[i14 + (i12 + 1) >> 0] = 0;
 i10 = i12 + 2 | 0;
 i7 = (i7 | 0) == 0 ? gb + 1576256 | 0 : i7;
 i9 = (_strlen(i7) | 0) + 1 | 0;
 i5 = (i8 | 0) == 0 ? gb + 1576256 | 0 : i8;
 i6 = (_strlen(i5) | 0) + 1 | 0;
 i8 = (i11 | 0) == 0 ? gb + 1576256 | 0 : i11;
 i1 = i9 >>> 0 > (2147483645 - i12 | 0) >>> 0 ? 2147483647 : i9 + i10 | 0;
 i1 = i6 >>> 0 > (2147483647 - i1 | 0) >>> 0 ? 2147483647 : i1 + i6 | 0;
 i2 = _strlen(i8) | 0;
 HEAP32[i16 >> 2] = i8;
 i3 = i16 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i16 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 do if (i15) if (!(_UNITY_png_text_compress(i17, 1767135348, i16, i1) | 0)) {
  i13 = HEAP32[i4 >> 2] | 0;
  break;
 } else _UNITY_png_error(i17, HEAP32[i17 + 244 >> 2] | 0); else if (i2 >>> 0 > (2147483647 - i1 | 0) >>> 0) _UNITY_png_error(i17, gb + 355499 | 0); else {
  HEAP32[i4 >> 2] = i2;
  i13 = i2;
  break;
 } while (0);
 i1 = i13 + i1 | 0;
 i11 = (i17 | 0) == 0;
 if (i11) i2 = 0; else {
  i13 = i17 + 656 | 0;
  HEAP32[i13 >> 2] = 34;
  HEAP8[i18 >> 0] = i1 >>> 24;
  HEAP8[i18 + 1 >> 0] = i1 >>> 16;
  HEAP8[i18 + 2 >> 0] = i1 >>> 8;
  HEAP8[i18 + 3 >> 0] = i1;
  i12 = i18 + 4 | 0;
  HEAP8[i12 >> 0] = 105;
  HEAP8[i18 + 5 >> 0] = 84;
  HEAP8[i18 + 6 >> 0] = 88;
  HEAP8[i18 + 7 >> 0] = 116;
  _UNITY_png_write_data(i17, i18, 8);
  HEAP32[i17 + 372 >> 2] = 1767135348;
  _UNITY_png_reset_crc(i17);
  _UNITY_png_calculate_crc(i17, i12, 4);
  HEAP32[i13 >> 2] = 66;
  if (i10 | 0) {
   _UNITY_png_write_data(i17, i14, i10);
   _UNITY_png_calculate_crc(i17, i14, i10);
  }
  if ((i9 | 0) != 0 & (i7 | 0) != 0) {
   _UNITY_png_write_data(i17, i7, i9);
   _UNITY_png_calculate_crc(i17, i7, i9);
  }
  if ((i6 | 0) != 0 & (i5 | 0) != 0) {
   _UNITY_png_write_data(i17, i5, i6);
   _UNITY_png_calculate_crc(i17, i5, i6);
   i2 = 1;
  } else i2 = 1;
 }
 if (i15) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i17 + 276 | 0;
  i6 = i17 + 280 | 0;
  L46 : do if (i11) {
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = i2 - (i2 >>> 0 < 1024 ? i2 : 1024) | 0;
   i1 = (i2 | 0) == 0;
   if (!((i3 | 0) == 0 | i1)) {
    i4 = HEAP32[i6 >> 2] | 0;
    do {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = i2 - (i4 >>> 0 > i2 >>> 0 ? i2 : i4) | 0;
     i1 = (i2 | 0) == 0;
    } while (!((i3 | 0) == 0 | i1));
   }
  } else {
   i4 = 1024;
   i5 = i16 + 12 | 0;
   while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
    if (i1 | 0) {
     _UNITY_png_write_data(i17, i5, i1);
     _UNITY_png_calculate_crc(i17, i5, i1);
    }
    i2 = i2 - i1 | 0;
    i1 = (i2 | 0) == 0;
    if ((i3 | 0) == 0 | i1) break L46;
    i1 = i3;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = i3 + 4 | 0;
   }
  } while (0);
  if (!i1) _UNITY_png_error(i17, gb + 354991 | 0);
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i8 | 0) != 0 & i2 & (i1 | 0) != 0) {
   _UNITY_png_write_data(i17, i8, i1);
   _UNITY_png_calculate_crc(i17, i8, i1);
  }
 }
 if (i11) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i17 + 656 >> 2] = 130;
 i16 = HEAP32[i17 + 408 >> 2] | 0;
 HEAP8[i18 >> 0] = i16 >>> 24;
 HEAP8[i18 + 1 >> 0] = i16 >>> 16;
 HEAP8[i18 + 2 >> 0] = i16 >>> 8;
 HEAP8[i18 + 3 >> 0] = i16;
 _UNITY_png_write_data(i17, i18, 4);
 STACKTOP = i19;
 return;
}

function __GLOBAL__sub_I_runtime_animation_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1465188 | 0, gb + 904466 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1465200 | 0, gb + 904497 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1465212 | 0, gb + 904514 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466560 | 0, gb + 904531 | 0, 4, 2);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467040 | 0, gb + 904594 | 0, 4, 2);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467052 | 0, gb + 904644 | 0, 4, 2);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1465176 | 0, gb + 904697 | 0, 4, 2);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1465164 | 0, gb + 904745 | 0, 4, 2);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466548 | 0, gb + 904798 | 0, 4, 0);
 HEAP32[gb + 1465224 >> 2] = 0;
 i3 = gb + 63320 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1465224 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1465224 + 12 >> 2] = 16;
 i1 = gb + 1465224 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3799 | 0, fb + 3800 | 0, 0, gb + 1465224 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467064 | 0, gb + 904818 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467076 | 0, gb + 904879 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467088 | 0, gb + 904943 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467100 | 0, gb + 905005 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466800 | 0, gb + 905032 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466836 | 0, gb + 905049 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466824 | 0, gb + 905079 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466860 | 0, gb + 905122 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466812 | 0, gb + 905150 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466848 | 0, gb + 905177 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467112 | 0, gb + 905205 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467124 | 0, gb + 905236 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467136 | 0, gb + 905260 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467148 | 0, gb + 905276 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466968 | 0, gb + 905295 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466980 | 0, gb + 905315 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466784 | 0, gb + 905343 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466956 | 0, gb + 905375 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466896 | 0, gb + 905402 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466884 | 0, gb + 905430 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466872 | 0, gb + 905450 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466944 | 0, gb + 905479 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466932 | 0, gb + 905508 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466920 | 0, gb + 905544 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466908 | 0, gb + 905576 | 0, 4, 0);
 return;
}

function __ZNK5physx17ConvexHullBuilder4SaveERNS_14PxOutputStreamEb(i26, i25, i21) {
 i26 = i26 | 0;
 i25 = i25 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27;
 if (!(__ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(67, 76, 72, 76, 7, i21, i25) | 0)) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 if (!(__ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(67, 86, 72, 76, 7, i21, i25) | 0)) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 if (!(__ZN5physx17ConvexHullBuilder14CreateEdgeListEv(i26) | 0)) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i24 = i26 + 20 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAPU8[(HEAP32[i24 >> 2] | 0) + 38 >> 0] | 0, i21, i25);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAPU16[(HEAP32[i24 >> 2] | 0) + 36 >> 1] | 0, i21, i25);
 i1 = HEAP8[(HEAP32[i24 >> 2] | 0) + 39 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  __ZN5physx17ConvexHullBuilder17CreatePolygonDataEv(i26) | 0;
  i1 = HEAP8[(HEAP32[i24 >> 2] | 0) + 39 >> 0] | 0;
 }
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i1 & 255, i21, i25);
 i1 = HEAP8[(HEAP32[i24 >> 2] | 0) + 39 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i22 = 0; else {
  i4 = HEAP32[i26 + 4 >> 2] | 0;
  i2 = i1 & 255;
  i1 = 0;
  i3 = 0;
  do {
   i1 = (HEAPU8[i4 + (i3 * 20 | 0) + 18 >> 0] | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
  i22 = i1;
 }
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i22, i21, i25);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(HEAP32[i26 >> 2] | 0, (HEAPU8[(HEAP32[i24 >> 2] | 0) + 38 >> 0] | 0) * 3 | 0, i21, i25);
 i2 = HEAP32[i24 >> 2] | 0;
 if (!(HEAP8[i2 + 39 >> 0] | 0)) i4 = i25; else {
  i16 = i26 + 4 | 0;
  i17 = i23 + 4 | 0;
  i18 = i23 + 8 | 0;
  i19 = i23 + 12 | 0;
  i20 = i23 + 16 | 0;
  i3 = i23 + 3 | 0;
  i4 = i23 + 1 | 0;
  i5 = i23 + 2 | 0;
  i6 = i17 + 3 | 0;
  i7 = i17 + 1 | 0;
  i8 = i17 + 2 | 0;
  i9 = i18 + 3 | 0;
  i10 = i18 + 1 | 0;
  i11 = i18 + 2 | 0;
  i12 = i19 + 3 | 0;
  i13 = i19 + 1 | 0;
  i14 = i19 + 2 | 0;
  i15 = i20 + 1 | 0;
  if (i21) {
   i1 = 0;
   do {
    i2 = HEAP32[i16 >> 2] | 0;
    i30 = HEAP32[i2 + (i1 * 20 | 0) >> 2] | 0;
    HEAP32[i23 >> 2] = i30;
    i29 = HEAP32[i2 + (i1 * 20 | 0) + 4 >> 2] | 0;
    HEAP32[i17 >> 2] = i29;
    i28 = HEAP32[i2 + (i1 * 20 | 0) + 8 >> 2] | 0;
    HEAP32[i18 >> 2] = i28;
    i21 = HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] | 0;
    HEAP32[i19 >> 2] = i21;
    i2 = i2 + (i1 * 20 | 0) + 16 | 0;
    i2 = HEAPU16[i2 >> 1] | HEAPU16[i2 + 2 >> 1] << 16;
    HEAP32[i20 >> 2] = i2;
    HEAP8[i23 >> 0] = i30 >>> 24;
    HEAP8[i3 >> 0] = i30;
    HEAP8[i4 >> 0] = i30 >>> 16;
    HEAP8[i5 >> 0] = i30 >>> 8;
    HEAP8[i17 >> 0] = i29 >>> 24;
    HEAP8[i6 >> 0] = i29;
    HEAP8[i7 >> 0] = i29 >>> 16;
    HEAP8[i8 >> 0] = i29 >>> 8;
    HEAP8[i18 >> 0] = i28 >>> 24;
    HEAP8[i9 >> 0] = i28;
    HEAP8[i10 >> 0] = i28 >>> 16;
    HEAP8[i11 >> 0] = i28 >>> 8;
    HEAP8[i19 >> 0] = i21 >>> 24;
    HEAP8[i12 >> 0] = i21;
    HEAP8[i13 >> 0] = i21 >>> 16;
    HEAP8[i14 >> 0] = i21 >>> 8;
    HEAP8[i20 >> 0] = i2 >>> 8;
    HEAP8[i15 >> 0] = i2;
    mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i23 | 0, 20) | 0;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i24 >> 2] | 0;
   } while (i1 >>> 0 < (HEAPU8[i2 + 39 >> 0] | 0) >>> 0);
   i4 = i25;
  } else {
   i1 = 0;
   do {
    i2 = HEAP32[i16 >> 2] | 0;
    HEAP32[i23 >> 2] = HEAP32[i2 + (i1 * 20 | 0) >> 2];
    HEAP32[i17 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 4 >> 2];
    HEAP32[i18 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 8 >> 2];
    HEAP32[i19 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2];
    i2 = i2 + (i1 * 20 | 0) + 16 | 0;
    HEAP32[i20 >> 2] = HEAPU16[i2 >> 1] | HEAPU16[i2 + 2 >> 1] << 16;
    mftCall_iiii(HEAP32[HEAP32[i25 >> 2] >> 2] | 0, i25 | 0, i23 | 0, 20) | 0;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i24 >> 2] | 0;
   } while (i1 >>> 0 < (HEAPU8[i2 + 39 >> 0] | 0) >>> 0);
   i4 = i25;
  }
 }
 i1 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 if (i22) {
  i3 = i26 + 8 | 0;
  i2 = 0;
  do {
   mftCall_iiii(i1 | 0, i25 | 0, (HEAP32[i3 >> 2] | 0) + i2 | 0, 1) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  } while ((i2 | 0) != (i22 | 0));
  i2 = HEAP32[i24 >> 2] | 0;
 }
 mftCall_iiii(i1 | 0, i25 | 0, HEAP32[i26 + 12 >> 2] | 0, HEAPU16[i2 + 36 >> 1] << 1 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i25 | 0, HEAP32[i26 + 16 >> 2] | 0, (HEAPU8[(HEAP32[i24 >> 2] | 0) + 38 >> 0] | 0) * 3 | 0) | 0;
 i30 = 1;
 STACKTOP = i27;
 return i30 | 0;
}

function __ZNK20b2SeparationFunction8EvaluateEiif(i5, i6, i7, f1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f4 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0;
 f2 = Math_fround(Math_fround(1.0) - f1);
 f9 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 16 >> 2]));
 f13 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 20 >> 2]));
 f14 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * f1);
 f14 = Math_fround(f9 + f14);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i5 + 28 >> 2]) * f1));
 f9 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 32 >> 2]));
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i5 + 36 >> 2]) * f1));
 f8 = Math_fround(+Math_sin(+f9));
 f9 = Math_fround(+Math_cos(+f9));
 f12 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f9 * f12);
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f10 = Math_fround(f14 - Math_fround(f10 - Math_fround(f8 * f11)));
 f11 = Math_fround(f13 - Math_fround(Math_fround(f8 * f12) + Math_fround(f9 * f11)));
 f12 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 52 >> 2]));
 f13 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 56 >> 2]));
 f14 = Math_fround(Math_fround(HEAPF32[i5 + 60 >> 2]) * f1);
 f14 = Math_fround(f12 + f14);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i5 + 64 >> 2]) * f1));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 68 >> 2]));
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i5 + 72 >> 2]) * f1));
 f1 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 f12 = Math_fround(HEAPF32[i5 + 44 >> 2]);
 f3 = Math_fround(f2 * f12);
 f4 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 f3 = Math_fround(f14 - Math_fround(f3 - Math_fround(f1 * f4)));
 f4 = Math_fround(f13 - Math_fround(Math_fround(f1 * f12) + Math_fround(f2 * f4)));
 switch (HEAP32[i5 + 80 >> 2] | 0) {
 case 0:
  {
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i17 + (i6 << 3) >> 2]);
   f13 = Math_fround(HEAPF32[i17 + (i6 << 3) + 4 >> 2]);
   i6 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 16 >> 2] | 0;
   f16 = Math_fround(HEAPF32[i6 + (i7 << 3) >> 2]);
   f15 = Math_fround(HEAPF32[i6 + (i7 << 3) + 4 >> 2]);
   f14 = Math_fround(Math_fround(f4 + Math_fround(Math_fround(f1 * f16) + Math_fround(f2 * f15))) - Math_fround(f11 + Math_fround(Math_fround(f8 * f12) + Math_fround(f9 * f13))));
   f14 = Math_fround(Math_fround(Math_fround(Math_fround(f3 + Math_fround(Math_fround(f2 * f16) - Math_fround(f1 * f15))) - Math_fround(f10 + Math_fround(Math_fround(f9 * f12) - Math_fround(f8 * f13)))) * Math_fround(HEAPF32[i5 + 92 >> 2])) + Math_fround(Math_fround(HEAPF32[i5 + 96 >> 2]) * f14));
   return Math_fround(f14);
  }
 case 1:
  {
   f14 = Math_fround(HEAPF32[i5 + 92 >> 2]);
   f18 = Math_fround(f9 * f14);
   f13 = Math_fround(HEAPF32[i5 + 96 >> 2]);
   f18 = Math_fround(f18 - Math_fround(f8 * f13));
   f13 = Math_fround(Math_fround(f8 * f14) + Math_fround(f9 * f13));
   f14 = Math_fround(HEAPF32[i5 + 84 >> 2]);
   f12 = Math_fround(f9 * f14);
   f16 = Math_fround(HEAPF32[i5 + 88 >> 2]);
   f12 = Math_fround(f10 + Math_fround(f12 - Math_fround(f8 * f16)));
   f16 = Math_fround(f11 + Math_fround(Math_fround(f8 * f14) + Math_fround(f9 * f16)));
   i17 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 16 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i17 + (i7 << 3) >> 2]);
   f15 = Math_fround(HEAPF32[i17 + (i7 << 3) + 4 >> 2]);
   f16 = Math_fround(Math_fround(f18 * Math_fround(Math_fround(f3 + Math_fround(Math_fround(f2 * f14) - Math_fround(f1 * f15))) - f12)) + Math_fround(f13 * Math_fround(Math_fround(f4 + Math_fround(Math_fround(f1 * f14) + Math_fround(f2 * f15))) - f16)));
   return Math_fround(f16);
  }
 case 2:
  {
   f15 = Math_fround(HEAPF32[i5 + 92 >> 2]);
   f12 = Math_fround(f2 * f15);
   f14 = Math_fround(HEAPF32[i5 + 96 >> 2]);
   f12 = Math_fround(f12 - Math_fround(f1 * f14));
   f14 = Math_fround(Math_fround(f1 * f15) + Math_fround(f2 * f14));
   f15 = Math_fround(HEAPF32[i5 + 84 >> 2]);
   f13 = Math_fround(f2 * f15);
   f18 = Math_fround(HEAPF32[i5 + 88 >> 2]);
   f13 = Math_fround(f3 + Math_fround(f13 - Math_fround(f1 * f18)));
   f18 = Math_fround(f4 + Math_fround(Math_fround(f1 * f15) + Math_fround(f2 * f18)));
   i17 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
   f15 = Math_fround(HEAPF32[i17 + (i6 << 3) >> 2]);
   f16 = Math_fround(HEAPF32[i17 + (i6 << 3) + 4 >> 2]);
   f18 = Math_fround(Math_fround(f12 * Math_fround(Math_fround(f10 + Math_fround(Math_fround(f9 * f15) - Math_fround(f8 * f16))) - f13)) + Math_fround(f14 * Math_fround(Math_fround(f11 + Math_fround(Math_fround(f8 * f15) + Math_fround(f9 * f16))) - f18)));
   return Math_fround(f18);
  }
 default:
  {
   f18 = Math_fround(0.0);
   return Math_fround(f18);
  }
 }
 return f0;
}

function __ZN19RuntimeSceneManager32LoadSceneAsyncByNameOrBuildIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiNS_11LoadingModeEb(i1, i16, i17, i12, i13) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 16 | 0;
 i14 = i20 + 8 | 0;
 i9 = i20;
 i18 = i20 + 92 | 0;
 i19 = i20 + 40 | 0;
 i8 = i20 + 24 | 0;
 HEAP32[i19 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 i5 = i19 + 16 | 0;
 HEAP32[i19 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i6 = i19 + 32 | 0;
 HEAP32[i19 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i7 = i16 + 11 | 0;
 i4 = HEAP8[i7 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
 i11 = i16 + 4 | 0;
 i4 = i1 ? HEAP32[i11 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo(i8, i17, i19) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i10 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i18);
 }
 do if (i1) {
  HEAP32[i18 >> 2] = 0;
  i2 = HEAP32[gb + 1164172 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i2 = __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene(i2, i19, i5, i6, i8, HEAP32[i19 + 48 >> 2] | 0, i12, i13, i18) | 0;
 } else {
  if ((i17 | 0) > -1) {
   HEAP32[i9 >> 2] = i17;
   __Z6FormatPKcz(i18, gb + 462879 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 462762 | 0, 122, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   i2 = 0;
   break;
  }
  i13 = HEAP8[i7 >> 0] | 0;
  i1 = i13 << 24 >> 24 < 0;
  if (!((i1 ? HEAP32[i11 >> 2] | 0 : i13 & 255) | 0)) {
   HEAP32[i15 >> 2] = i17;
   __Z6FormatPKcz(i18, gb + 463248 | 0, i15);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 462762 | 0, 131, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   i2 = 0;
   break;
  } else {
   HEAP32[i14 >> 2] = i1 ? HEAP32[i16 >> 2] | 0 : i16;
   __Z6FormatPKcz(i18, gb + 463052 | 0, i14);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 462762 | 0, 127, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   i2 = 0;
   break;
  }
 } while (0);
 i1 = i19 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i17 = HEAP32[i1 >> 2] | 0;
  i16 = HEAP32[i19 + 44 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
 }
 i1 = i19 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i17 = HEAP32[i1 >> 2] | 0;
  i16 = HEAP32[i19 + 28 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
 }
 if ((HEAP8[i19 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i20;
  return i2 | 0;
 }
 i17 = HEAP32[i19 >> 2] | 0;
 i19 = HEAP32[i19 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = 66;
 HEAP32[i18 + 4 >> 2] = i19;
 __Z19free_alloc_internalPvRK10MemLabelId(i17, i18);
 STACKTOP = i20;
 return i2 | 0;
}

function __Z6pqInitP9TESSallocP9PriorityQ(i1, i19) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i2 = i19 + 12 | 0;
 i4 = mftCall_iii(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, (HEAP32[i2 >> 2] << 2) + 4 | 0) | 0;
 HEAP32[i19 + 8 >> 2] = i4;
 if (!i4) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i18 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + (i18 << 2) + -4 | 0;
 if (i4 >>> 0 <= i3 >>> 0) {
  i1 = HEAP32[i19 + 4 >> 2] | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 > i3 >>> 0) break; else i1 = i1 + 4 | 0;
  }
 }
 HEAP32[i20 >> 2] = i4;
 HEAP32[i20 + 4 >> 2] = i3;
 i3 = 2016473283;
 i4 = 0;
 i1 = 1;
 while (1) {
  i2 = HEAP32[i20 + (i4 << 3) >> 2] | 0;
  i1 = HEAP32[i20 + (i1 << 3) + -4 >> 2] | 0;
  L11 : do if (i1 >>> 0 > (i2 + 40 | 0) >>> 0) {
   i12 = i1;
   i1 = i4;
   while (1) {
    i16 = i12;
    i17 = i12 + 4 | 0;
    while (1) {
     i3 = (Math_imul(i3, 1539415821) | 0) + 1 | 0;
     i5 = i2 + (((i3 >>> 0) % (((i16 - i2 >> 2) + 1 | 0) >>> 0) | 0) << 2) | 0;
     i15 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i15;
     i5 = i17;
     i4 = -1;
     while (1) {
      i8 = i4 + 1 | 0;
      i7 = HEAP32[HEAP32[i2 + (i8 << 2) >> 2] >> 2] | 0;
      f6 = Math_fround(HEAPF32[i7 + 24 >> 2]);
      i13 = HEAP32[i15 >> 2] | 0;
      f9 = Math_fround(HEAPF32[i13 + 24 >> 2]);
      L18 : do if (f6 < f9) i14 = i4; else {
       i10 = i13 + 28 | 0;
       while (1) {
        if (f6 == f9) {
         f6 = Math_fround(HEAPF32[i7 + 28 >> 2]);
         if (f6 <= Math_fround(HEAPF32[i10 >> 2])) {
          i14 = i4;
          break L18;
         }
        }
        i4 = i8 + 1 | 0;
        i7 = HEAP32[HEAP32[i2 + (i4 << 2) >> 2] >> 2] | 0;
        f6 = Math_fround(HEAPF32[i7 + 24 >> 2]);
        if (f6 < f9) {
         i14 = i8;
         i8 = i4;
         break;
        } else {
         i14 = i8;
         i8 = i4;
         i4 = i14;
        }
       }
      } while (0);
      i11 = i2 + (i8 << 2) | 0;
      i7 = i5 + -4 | 0;
      i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
      f6 = Math_fround(HEAPF32[i4 + 24 >> 2]);
      L26 : do if (f9 < f6) {
       i10 = i5;
       i5 = i7;
      } else {
       i10 = i13 + 28 | 0;
       while (1) {
        if (f9 == f6) {
         f6 = Math_fround(HEAPF32[i10 >> 2]);
         if (f6 <= Math_fround(HEAPF32[i4 + 28 >> 2])) {
          i10 = i5;
          i5 = i7;
          break L26;
         }
        }
        i5 = i7 + -4 | 0;
        i4 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
        f6 = Math_fround(HEAPF32[i4 + 24 >> 2]);
        if (f9 < f6) {
         i10 = i7;
         break;
        } else {
         i13 = i7;
         i7 = i5;
         i5 = i13;
        }
       }
      } while (0);
      i4 = HEAP32[i11 >> 2] | 0;
      HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i5 >> 2] = i4;
      if (i11 >>> 0 < i5 >>> 0) i4 = i8; else break;
     }
     i7 = i2 + (i14 << 2) | 0;
     i15 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = i4;
     HEAP32[i5 >> 2] = i15;
     i4 = i20 + (i1 << 3) | 0;
     if ((i8 << 2 | 0) < (i16 - i5 | 0)) break;
     HEAP32[i4 >> 2] = i2;
     HEAP32[i20 + (i1 << 3) + 4 >> 2] = i7;
     i1 = i1 + 1 | 0;
     if (i12 >>> 0 > (i10 + 40 | 0) >>> 0) i2 = i10; else {
      i13 = i10;
      break L11;
     }
    }
    HEAP32[i4 >> 2] = i10;
    HEAP32[i20 + (i1 << 3) + 4 >> 2] = i12;
    i1 = i1 + 1 | 0;
    if ((i14 | 0) > 10) i12 = i7; else {
     i13 = i2;
     i12 = i7;
     break;
    }
   }
  } else {
   i13 = i2;
   i12 = i1;
   i1 = i4;
  } while (0);
  i2 = i13 + 4 | 0;
  if (i2 >>> 0 <= i12 >>> 0) do {
   i11 = HEAP32[i2 >> 2] | 0;
   L41 : do if (i2 >>> 0 > i13 >>> 0) {
    i4 = i2;
    while (1) {
     i5 = HEAP32[i11 >> 2] | 0;
     f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
     i7 = i4 + -4 | 0;
     i10 = HEAP32[i7 >> 2] | 0;
     i8 = HEAP32[i10 >> 2] | 0;
     f9 = Math_fround(HEAPF32[i8 + 24 >> 2]);
     if (f6 < f9) break L41;
     if (f6 == f9) {
      f9 = Math_fround(HEAPF32[i5 + 28 >> 2]);
      if (f9 <= Math_fround(HEAPF32[i8 + 28 >> 2])) break L41;
     }
     HEAP32[i4 >> 2] = i10;
     if (i7 >>> 0 > i13 >>> 0) i4 = i7; else {
      i4 = i7;
      break;
     }
    }
   } else i4 = i2; while (0);
   HEAP32[i4 >> 2] = i11;
   i2 = i2 + 4 | 0;
  } while (i2 >>> 0 <= i12 >>> 0);
  if ((i1 | 0) < 1) break; else i4 = i1 + -1 | 0;
 }
 HEAP32[i19 + 16 >> 2] = i18;
 HEAP32[i19 + 20 >> 2] = 1;
 __Z10pqHeapInitP13PriorityQHeap(HEAP32[i19 >> 2] | 0);
 i20 = 1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN23LODTreeInstanceRendererC2ER12TreeRendereriR12MeshRendererRK10Matrix4x4fi(i14, i1, i2, i7, i8, i9) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 8 | 0;
 i12 = i15;
 i10 = i15 + 4 | 0;
 __ZN20IntermediateRendererC2Ev(i14);
 HEAP32[i14 + 264 >> 2] = 1;
 HEAP32[i14 + 268 >> 2] = i1;
 HEAP32[i14 + 272 >> 2] = i2;
 HEAP32[i14 >> 2] = gb + 184728 + 8;
 i5 = i14 + 276 | 0;
 HEAP32[i5 >> 2] = i7 + 288;
 i6 = i14 + 280 | 0;
 i4 = __ZNK12MeshRenderer13GetSharedMeshEv(i7) | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i12 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
    i2 = HEAP32[i11 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 9;
   }
  }
  if ((i13 | 0) == 7) i13 = 9;
  if ((i13 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i14 + 284 >> 2] = i9;
 HEAP8[i14 + 288 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 i16 = i7 + 268 | 0;
 i9 = HEAPU16[i16 >> 1] | 0 | (HEAPU8[i16 + 2 >> 0] | 0) << 16;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i14, i8, i1 + 48 | 0, i11, 0, (i9 & 16777215) >>> 6 & 3, (i9 & 256 | 0) != 0);
 i1 = i14 + 236 | 0;
 i10 = (((HEAPU16[i16 >> 1] | 0 | (HEAPU8[i16 + 2 >> 0] | 0) << 16) & 196608 | 0) != 0 & 1) << 16 | (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16580607;
 HEAP16[i1 >> 1] = i10;
 HEAP8[i1 + 2 >> 0] = i10 >>> 16;
 i16 = i10 & 16596991 | (HEAPU16[i16 >> 1] | 0 | (HEAPU8[i16 + 2 >> 0] | 0) << 16) & 49152;
 HEAP16[i1 >> 1] = i16;
 HEAP8[i1 + 2 >> 0] = i16 >>> 16;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP32[i1 + 12 >> 2] | 0)) {
  i13 = 1;
  i16 = i14 + 289 | 0;
  HEAP8[i16 >> 0] = i13;
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i13 = 1;
  i16 = i14 + 289 | 0;
  HEAP8[i16 >> 0] = i13;
  STACKTOP = i15;
  return;
 }
 HEAP32[i12 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
   i2 = HEAP32[i11 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 20;
  }
 }
 if ((i13 | 0) == 18) i13 = 20;
 if ((i13 | 0) == 20) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i13 = 1;
   i16 = i14 + 289 | 0;
   HEAP8[i16 >> 0] = i13;
   STACKTOP = i15;
   return;
  }
 }
 i4 = i1 + 60 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i13 = 1;
  i16 = i14 + 289 | 0;
  HEAP8[i16 >> 0] = i13;
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[gb + 1467612 >> 2] | 0;
 i1 = i4;
 L38 : while (1) {
  i3 = i2;
  while (1) {
   if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) break L38; else i3 = i2;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i1 = i3;
   break;
  } else i1 = i3;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i13 = 1;
  i16 = i14 + 289 | 0;
  HEAP8[i16 >> 0] = i13;
  STACKTOP = i15;
  return;
 }
 if ((i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
  i13 = 1;
  i16 = i14 + 289 | 0;
  HEAP8[i16 >> 0] = i13;
  STACKTOP = i15;
  return;
 }
 i13 = Math_fround(HEAPF32[i1 + 20 >> 2]) == Math_fround(0.0) & 1;
 i16 = i14 + 289 | 0;
 HEAP8[i16 >> 0] = i13;
 STACKTOP = i15;
 return;
}

function _start_pass_phuff_decoder(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = HEAP32[i14 + 408 >> 2] | 0;
 i9 = i14 + 364 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i12 = (i3 | 0) == 0;
 i10 = i14 + 368 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i12) i1 = (i1 | 0) != 0 & 1; else i1 = (HEAP32[i14 + 292 >> 2] | 0) == 1 ? ((i3 | 0) > (i1 | 0) | (i1 | 0) > 63) & 1 : 1;
 i13 = i14 + 372 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i2 = i14 + 376 | 0;
  i8 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i8 = i14 + 376 | 0;
  i11 = HEAP32[i8 >> 2] | 0;
  i1 = (i11 | 0) == (i2 + -1 | 0) ? i1 : 1;
  i2 = i11;
 }
 if (!(i1 << 24 >> 24 == 0 & (i2 | 0) < 14)) {
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 + 20 >> 2] = 16;
  HEAP32[i11 + 24 >> 2] = i3;
  HEAP32[i11 + 28 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 32 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 36 >> 2] = HEAP32[i8 >> 2];
  mftCall_vi(HEAP32[i11 >> 2] | 0, i14 | 0);
 }
 i11 = i14 + 292 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i7 = i14 + 140 | 0;
  if (i12) {
   i6 = 0;
   i1 = HEAP32[i10 >> 2] | 0;
   do {
    i4 = HEAP32[(HEAP32[i14 + 296 + (i6 << 2) >> 2] | 0) + 4 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) <= (i1 | 0)) {
     while (1) {
      i1 = i5 + (i4 << 8) + (i2 << 2) | 0;
      i3 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i13 >> 2] | 0) != (((i3 | 0) < 0 ? 0 : i3) | 0)) {
       i3 = HEAP32[i14 >> 2] | 0;
       HEAP32[i3 + 20 >> 2] = 115;
       HEAP32[i3 + 24 >> 2] = i4;
       HEAP32[i3 + 28 >> 2] = i2;
       mftCall_vii(HEAP32[i3 + 4 >> 2] | 0, i14 | 0, -1);
      }
      HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
      i1 = HEAP32[i10 >> 2] | 0;
      if ((i2 | 0) < (i1 | 0)) i2 = i2 + 1 | 0; else break;
     }
     i3 = HEAP32[i11 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) < (i3 | 0));
  } else {
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i14 + 296 + (i5 << 2) >> 2] | 0) + 4 >> 2] | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i4 + (i3 << 8) >> 2] | 0) < 0) {
     i6 = HEAP32[i14 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 115;
     HEAP32[i6 + 24 >> 2] = i3;
     HEAP32[i6 + 28 >> 2] = 0;
     mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i14 | 0, -1);
    }
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) <= (HEAP32[i10 >> 2] | 0)) while (1) {
     i2 = i4 + (i3 << 8) + (i1 << 2) | 0;
     i6 = HEAP32[i2 >> 2] | 0;
     if ((HEAP32[i13 >> 2] | 0) != (((i6 | 0) < 0 ? 0 : i6) | 0)) {
      i6 = HEAP32[i14 >> 2] | 0;
      HEAP32[i6 + 20 >> 2] = 115;
      HEAP32[i6 + 24 >> 2] = i3;
      HEAP32[i6 + 28 >> 2] = i1;
      mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i14 | 0, -1);
     }
     HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
     if ((i1 | 0) < (HEAP32[i10 >> 2] | 0)) i1 = i1 + 1 | 0; else break;
    }
    i5 = i5 + 1 | 0;
    i3 = HEAP32[i11 >> 2] | 0;
   } while ((i5 | 0) < (i3 | 0));
  }
 }
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = i15 + 4 | 0;
 do if (!i2) if (i12) {
  HEAP32[i1 >> 2] = fb + 508;
  break;
 } else {
  HEAP32[i1 >> 2] = fb + 509;
  break;
 } else if (i12) {
  HEAP32[i1 >> 2] = fb + 510;
  break;
 } else {
  HEAP32[i1 >> 2] = fb + 511;
  break;
 } while (0);
 if ((i3 | 0) <= 0) {
  i13 = i15 + 16 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i15 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i15 + 8 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i15 + 20 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i14 + 252 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = i15 + 40 | 0;
  HEAP32[i15 >> 2] = i14;
  return;
 }
 i3 = i15 + 60 | 0;
 if (i12) i1 = 0; else {
  i1 = 0;
  do {
   i12 = HEAP32[(HEAP32[i14 + 296 + (i1 << 2) >> 2] | 0) + 24 >> 2] | 0;
   i13 = i15 + 44 + (i12 << 2) | 0;
   _jpeg_make_d_derived_tbl(i14, 0, i12, i13);
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 24 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i11 >> 2] | 0));
  i13 = i15 + 16 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i15 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i15 + 8 | 0;
  HEAP8[i13 >> 0] = 0;
  i13 = i15 + 20 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i14 + 252 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = i15 + 40 | 0;
  HEAP32[i15 >> 2] = i14;
  return;
 }
 while (1) {
  if (!i2) {
   i12 = HEAP32[(HEAP32[i14 + 296 + (i1 << 2) >> 2] | 0) + 20 >> 2] | 0;
   _jpeg_make_d_derived_tbl(i14, 1, i12, i15 + 44 + (i12 << 2) | 0);
  }
  HEAP32[i15 + 24 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i11 >> 2] | 0)) break;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i13 = i15 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i13 = i15 + 8 | 0;
 HEAP8[i13 >> 0] = 0;
 i13 = i15 + 20 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i14 + 252 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = i15 + 40 | 0;
 HEAP32[i15 >> 2] = i14;
 return;
}

function __ZN4PPtrI23ShaderVariantCollectionE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj467ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 136 | 0;
 i17 = i20 + 188 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 84 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 28 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj497ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj498ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 96 | 0, 1);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i1 >> 2]));
 i24 = i1 + 4 | 0;
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 i7 = i1 + 8 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i7 >> 2]));
 i22 = i4 + 36 | 0;
 f15 = Math_fround(f11 * Math_fround(HEAPF32[i22 >> 2]));
 i21 = i4 + 40 | 0;
 f13 = Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2]));
 i10 = i4 + 44 | 0;
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i10 >> 2]));
 i20 = i4 + 48 | 0;
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i4 + 52 | 0;
 f26 = Math_fround(f12 * Math_fround(HEAPF32[i19 >> 2]));
 i8 = i4 + 56 | 0;
 f16 = Math_fround(f15 + f16);
 f26 = Math_fround(f13 + f26);
 f12 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i8 >> 2])));
 i18 = i4 + 60 | 0;
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 i17 = i4 + 64 | 0;
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 i14 = i4 + 68 | 0;
 f13 = Math_fround(f26 + f13);
 f9 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f16 + f11);
 HEAPF32[i24 >> 2] = f13;
 HEAPF32[i7 >> 2] = f9;
 i7 = i3 + 4 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 i24 = i1 + 12 | 0;
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 i25 = i1 + 16 | 0;
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 i4 = i1 + 20 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i4 >> 2]));
 f16 = Math_fround(f13 * Math_fround(HEAPF32[i22 >> 2]));
 f12 = Math_fround(f13 * Math_fround(HEAPF32[i21 >> 2]));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i10 >> 2]));
 f26 = Math_fround(f11 * Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(f11 * Math_fround(HEAPF32[i19 >> 2]));
 f26 = Math_fround(f16 + f26);
 f15 = Math_fround(f12 + f15);
 f11 = Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i8 >> 2])));
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 f12 = Math_fround(f15 + f12);
 f9 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 HEAPF32[i24 >> 2] = Math_fround(f26 + f13);
 HEAPF32[i25 >> 2] = f12;
 HEAPF32[i4 >> 2] = f9;
 i4 = i3 + 8 | 0;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 i25 = i1 + 24 | 0;
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 i24 = i1 + 28 | 0;
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 i23 = i1 + 32 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2]));
 f26 = Math_fround(f12 * Math_fround(HEAPF32[i22 >> 2]));
 f11 = Math_fround(f12 * Math_fround(HEAPF32[i21 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i10 >> 2]));
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 f16 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
 f15 = Math_fround(f26 + f15);
 f16 = Math_fround(f11 + f16);
 f13 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i8 >> 2])));
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f16 + f11);
 f9 = Math_fround(f13 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 HEAPF32[i25 >> 2] = Math_fround(f15 + f12);
 HEAPF32[i24 >> 2] = f11;
 HEAPF32[i23 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i22 >> 2]));
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i21 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i10 >> 2]));
 i10 = i2 + 4 | 0;
 f15 = Math_fround(HEAPF32[i10 >> 2]);
 f13 = Math_fround(f15 * Math_fround(HEAPF32[i20 >> 2]));
 f16 = Math_fround(f15 * Math_fround(HEAPF32[i19 >> 2]));
 f13 = Math_fround(f11 + f13);
 f16 = Math_fround(f12 + f16);
 f15 = Math_fround(f9 + Math_fround(f15 * Math_fround(HEAPF32[i8 >> 2])));
 i8 = i2 + 8 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f16 + f11);
 f9 = Math_fround(f15 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 HEAPF32[i2 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i10 >> 2] = f11;
 HEAPF32[i8 >> 2] = f9;
 __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E(i6, i1);
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI20OcclusionCullingDataE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI19SkinnedMeshRendererE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i1, i2, i3, i4, i5, i23, i24, i25) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, f40 = f0, i41 = 0, f42 = f0, i43 = 0, f44 = f0, i45 = 0, f46 = f0, i47 = 0, f48 = f0, i49 = 0, f50 = f0, i51 = 0, f52 = f0, f53 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 16 | 0;
 i27 = i28;
 if (i5 >>> 0 >= i23 >>> 0) {
  STACKTOP = i28;
  return;
 }
 i19 = i4 + 500 | 0;
 i20 = i27 + 4 | 0;
 i21 = i27 + 8 | 0;
 i22 = i27 + 12 | 0;
 i18 = i1 + 80 | 0;
 i17 = i2 + 80 | 0;
 i6 = i3 + 80 | 0;
 i7 = i25 + 12 | 0;
 i8 = i25 + 24 | 0;
 i9 = i25 + 4 | 0;
 i10 = i25 + 16 | 0;
 i11 = i25 + 28 | 0;
 i12 = i25 + 8 | 0;
 i13 = i25 + 20 | 0;
 i14 = i25 + 32 | 0;
 i15 = i4 + 120 | 0;
 i16 = i4 + 140 | 0;
 i4 = i4 + 160 | 0;
 do {
  i29 = (HEAP32[i19 >> 2] | 0) + (i5 << 2) | 0;
  i1 = (HEAP32[i29 + 4 >> 2] | 0) + -520366028 | 0;
  i3 = (HEAP32[i29 + 8 >> 2] | 0) + -520366028 | 0;
  i2 = (HEAP32[i29 + 12 >> 2] | 0) + -520366028 | 0;
  HEAP32[i27 >> 2] = (HEAP32[i29 >> 2] | 0) + -520366028;
  HEAP32[i20 >> 2] = i1;
  HEAP32[i21 >> 2] = i3;
  HEAP32[i22 >> 2] = i2;
  __Z17GenerateRandomNx3RKN4math5_int4E(i26, i27);
  i2 = HEAP32[i18 >> 2] | 0;
  i3 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i24) {
   f33 = Math_fround(HEAPF32[i25 >> 2]);
   f32 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f32 * f33);
   f34 = Math_fround(HEAPF32[i7 >> 2]);
   f31 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f34 = Math_fround(f33 + Math_fround(f31 * f34));
   f33 = Math_fround(HEAPF32[i8 >> 2]);
   f30 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f34 + Math_fround(f30 * f33));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   f33 = Math_fround(f32 * Math_fround(HEAPF32[i9 >> 2]));
   f33 = Math_fround(f33 + Math_fround(f31 * Math_fround(HEAPF32[i10 >> 2])));
   f33 = Math_fround(f33 + Math_fround(f30 * Math_fround(HEAPF32[i11 >> 2])));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   f32 = Math_fround(f32 * Math_fround(HEAPF32[i12 >> 2]));
   f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i13 >> 2])));
   f30 = Math_fround(f31 + Math_fround(f30 * Math_fround(HEAPF32[i14 >> 2])));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
  }
  i51 = (HEAP32[i15 >> 2] | 0) + (i5 << 2) | 0;
  f52 = Math_fround(HEAPF32[i51 >> 2]);
  i49 = i51 + 4 | 0;
  f50 = Math_fround(HEAPF32[i49 >> 2]);
  i47 = i51 + 8 | 0;
  f48 = Math_fround(HEAPF32[i47 >> 2]);
  i45 = i51 + 12 | 0;
  f46 = Math_fround(HEAPF32[i45 >> 2]);
  i43 = (HEAP32[i16 >> 2] | 0) + (i5 << 2) | 0;
  f44 = Math_fround(HEAPF32[i43 >> 2]);
  i41 = i43 + 4 | 0;
  f42 = Math_fround(HEAPF32[i41 >> 2]);
  i39 = i43 + 8 | 0;
  f40 = Math_fround(HEAPF32[i39 >> 2]);
  i38 = i43 + 12 | 0;
  f30 = Math_fround(HEAPF32[i38 >> 2]);
  i37 = (HEAP32[i4 >> 2] | 0) + (i5 << 2) | 0;
  f31 = Math_fround(HEAPF32[i37 >> 2]);
  i36 = i37 + 4 | 0;
  f32 = Math_fround(HEAPF32[i36 >> 2]);
  i35 = i37 + 8 | 0;
  f33 = Math_fround(HEAPF32[i35 >> 2]);
  i29 = i37 + 12 | 0;
  f34 = Math_fround(HEAPF32[i29 >> 2]);
  f53 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f52 = Math_fround(f53 + f52);
  f50 = Math_fround(f53 + f50);
  f48 = Math_fround(f53 + f48);
  f46 = Math_fround(f53 + f46);
  f53 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f44 = Math_fround(f53 + f44);
  f42 = Math_fround(f53 + f42);
  f40 = Math_fround(f53 + f40);
  f30 = Math_fround(f53 + f30);
  f53 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f53 + f31);
  f32 = Math_fround(f53 + f32);
  f33 = Math_fround(f53 + f33);
  f34 = Math_fround(f53 + f34);
  HEAPF32[i51 >> 2] = f52;
  HEAPF32[i49 >> 2] = f50;
  HEAPF32[i47 >> 2] = f48;
  HEAPF32[i45 >> 2] = f46;
  HEAPF32[i43 >> 2] = f44;
  HEAPF32[i41 >> 2] = f42;
  HEAPF32[i39 >> 2] = f40;
  HEAPF32[i38 >> 2] = f30;
  HEAPF32[i37 >> 2] = f31;
  HEAPF32[i36 >> 2] = f32;
  HEAPF32[i35 >> 2] = f33;
  HEAPF32[i29 >> 2] = f34;
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < i23 >>> 0);
 STACKTOP = i28;
 return;
}

function __ZN4PPtrI18SpeedTreeWindAssetE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18ProceduralMaterialE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18AnimatorControllerE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_(i28, i29, i22, i15, i8, i1) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i22 = i22 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, f31 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30;
 i23 = __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_(i28, i29, i22, i15, i1) | 0;
 f31 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 i7 = i15 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i7 >> 2]))) {
  i29 = i23;
  STACKTOP = i30;
  return i29 | 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 i10 = i15 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 20 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i9 = i15 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i24 = i15;
 i25 = i8;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = i6;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i22 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i1 >> 2]))) {
  i29 = i23 + 1 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 i17 = i22 + 4 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i19 = i22 + 12 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 16 | 0;
 i6 = HEAP32[i20 >> 2] | 0;
 i21 = i22 + 20 | 0;
 i7 = HEAP32[i21 >> 2] | 0;
 i16 = i22 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i24 = i22;
 i25 = i15;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i9 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i29 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i1 >> 2]))) {
  i29 = i23 + 2 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i2 = HEAP32[i29 >> 2] | 0;
 i9 = i29 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i29 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i29 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i29 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i29 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i29 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i24 = i29;
 i25 = i22;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i22 >> 2] = i2;
 HEAP32[i17 >> 2] = i3;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i19 >> 2] = i5;
 HEAP32[i20 >> 2] = i6;
 HEAP32[i21 >> 2] = i7;
 HEAP32[i16 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f31 < Math_fround(HEAPF32[i28 + 28 >> 2]))) {
  i29 = i23 + 3 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i1 = HEAP32[i28 >> 2] | 0;
 i2 = HEAP32[i28 + 4 >> 2] | 0;
 i3 = HEAP32[i28 + 8 >> 2] | 0;
 i4 = HEAP32[i28 + 12 >> 2] | 0;
 i5 = HEAP32[i28 + 16 >> 2] | 0;
 i6 = HEAP32[i28 + 20 >> 2] | 0;
 i24 = i28 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i24 = i28;
 i25 = i29;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i29 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 i29 = i23 + 4 | 0;
 STACKTOP = i30;
 return i29 | 0;
}

function __ZN4PPtrI17ProceduralTextureE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI16SubstanceArchiveE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __Z16ApplySHConstantsI28ApplyBuiltinInstancePropertyEvRT_RK20SphericalHarmonicsL2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 112 | 0;
 i11 = i3;
 HEAP32[i11 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 HEAPF32[i11 + 12 >> 2] = Math_fround(f15 - f14);
 i10 = i11 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i2 + 44 >> 2];
 f15 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 HEAPF32[i11 + 28 >> 2] = Math_fround(f15 - f13);
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i11 + 36 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAP32[i11 + 40 >> 2] = HEAP32[i2 + 80 >> 2];
 f15 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 HEAPF32[i11 + 44 >> 2] = Math_fround(f15 - f12);
 i8 = i11 + 48 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i11 + 52 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAPF32[i11 + 56 >> 2] = Math_fround(f14 * Math_fround(3.0));
 HEAP32[i11 + 60 >> 2] = HEAP32[i2 + 28 >> 2];
 i7 = i11 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i11 + 68 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAPF32[i11 + 72 >> 2] = Math_fround(f13 * Math_fround(3.0));
 HEAP32[i11 + 76 >> 2] = HEAP32[i2 + 64 >> 2];
 i6 = i11 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 88 >> 2];
 HEAP32[i11 + 84 >> 2] = HEAP32[i2 + 92 >> 2];
 HEAPF32[i11 + 88 >> 2] = Math_fround(f12 * Math_fround(3.0));
 HEAP32[i11 + 92 >> 2] = HEAP32[i2 + 100 >> 2];
 i4 = i11 + 96 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i11 + 100 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i11 + 104 >> 2] = HEAP32[i2 + 104 >> 2];
 HEAPF32[i11 + 108 >> 2] = Math_fround(1.0);
 i2 = (HEAP32[i1 >> 2] | 0) + 1008 | 0;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i2 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = 1073741887;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i11, 2);
 i11 = (HEAP32[i1 >> 2] | 0) + 1024 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741888;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i10, 2);
 i10 = (HEAP32[i1 >> 2] | 0) + 1040 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741889;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i9, 2);
 i9 = (HEAP32[i1 >> 2] | 0) + 1056 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741890;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i8, 2);
 i8 = (HEAP32[i1 >> 2] | 0) + 1072 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741891;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i7, 2);
 i7 = (HEAP32[i1 >> 2] | 0) + 1088 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741892;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i6, 2);
 i1 = (HEAP32[i1 >> 2] | 0) + 1104 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 >> 2] = 1073741893;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i5, i4, 2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i15, i18, i1, i2) {
 i15 = i15 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i12 = i18 + 11 | 0;
 i10 = HEAP8[i12 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i14 = i18 + 4 | 0;
 i10 = i9 ? HEAP32[i14 >> 2] | 0 : i10 & 255;
 i11 = i15 + 11 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i13 = i15 + 4 | 0;
 i4 = i3 ? HEAP32[i13 >> 2] | 0 : i4 & 255;
 i5 = i4 >>> 0 < i10 >>> 0;
 i2 = i5 ? i4 : i10;
 if (!i2) i19 = 3; else {
  i2 = _memcmp(i9 ? HEAP32[i18 >> 2] | 0 : i18, i3 ? HEAP32[i15 >> 2] | 0 : i15, i2) | 0;
  if (!i2) i19 = 3;
 }
 if ((i19 | 0) == 3) i2 = i10 >>> 0 < i4 >>> 0 ? -1 : i5 & 1;
 i6 = (i2 | 0) < 0;
 i7 = i1 + 11 | 0;
 i4 = HEAP8[i7 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i8 = i1 + 4 | 0;
 i4 = i3 ? HEAP32[i8 >> 2] | 0 : i4 & 255;
 i5 = i10 >>> 0 < i4 >>> 0;
 i2 = i5 ? i10 : i4;
 if (!i2) i19 = 6; else {
  i2 = _memcmp(i3 ? HEAP32[i1 >> 2] | 0 : i1, i9 ? HEAP32[i18 >> 2] | 0 : i18, i2) | 0;
  if (!i2) i19 = 6;
 }
 if ((i19 | 0) == 6) i2 = i4 >>> 0 < i10 >>> 0 ? -1 : i5 & 1;
 i2 = (i2 | 0) < 0;
 if (!i6) {
  if (!i2) {
   i19 = 0;
   STACKTOP = i17;
   return i19 | 0;
  };
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i5 = HEAP8[i12 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i14 >> 2] | 0 : i5 & 255;
  i3 = HEAP8[i11 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i13 >> 2] | 0 : i3 & 255;
  i1 = i3 >>> 0 < i5 >>> 0 ? i3 : i5;
  if (!i1) i19 = 11; else {
   i1 = _memcmp(i4 ? HEAP32[i18 >> 2] | 0 : i18, i2 ? HEAP32[i15 >> 2] | 0 : i15, i1) | 0;
   if (!i1) i19 = 11; else if ((i1 | 0) < 0) i1 = i15; else {
    i19 = 1;
    STACKTOP = i17;
    return i19 | 0;
   }
  }
  do if ((i19 | 0) == 11) if (i5 >>> 0 < i3 >>> 0) {
   i1 = i15;
   break;
  } else {
   i19 = 1;
   STACKTOP = i17;
   return i19 | 0;
  } while (0);
  HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i19 = 2;
  STACKTOP = i17;
  return i19 | 0;
 }
 if (i2) {
  HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  i19 = 1;
  STACKTOP = i17;
  return i19 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i6 = HEAP8[i7 >> 0] | 0;
 i5 = i6 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i8 >> 2] | 0 : i6 & 255;
 i4 = HEAP8[i12 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i14 >> 2] | 0 : i4 & 255;
 i2 = i4 >>> 0 < i6 >>> 0 ? i4 : i6;
 if (!i2) i19 = 19; else {
  i2 = _memcmp(i5 ? HEAP32[i1 >> 2] | 0 : i1, i3 ? HEAP32[i18 >> 2] | 0 : i18, i2) | 0;
  if (!i2) i19 = 19; else if ((i2 | 0) >= 0) {
   i19 = 1;
   STACKTOP = i17;
   return i19 | 0;
  }
 }
 do if ((i19 | 0) == 19) if (i6 >>> 0 < i4 >>> 0) break; else {
  i19 = 1;
  STACKTOP = i17;
  return i19 | 0;
 } while (0);
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i19 = 2;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj431ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 136 | 0;
 i17 = i20 + 188 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 84 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 28 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj497ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj498ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 96 | 0, 1);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __ZN4PPtrI15OcclusionPortalE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI15CapsuleColliderE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj458ES2_RKNS_22PxJointLinearLimitPairES6_EEKNS_35PxJointLinearLimitPairGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 136 | 0;
 i17 = i20 + 188 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 84 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 28 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj493ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj494ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 96 | 0, 1);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx2Sc15ClothFabricCore15exportExtraDataERNS_22PxSerializationContextE(i27, i26) {
 i27 = i27 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i28 + 112 | 0;
 i17 = i28 + 104 | 0;
 i16 = i28 + 96 | 0;
 i15 = i28 + 88 | 0;
 i14 = i28 + 80 | 0;
 i13 = i28 + 72 | 0;
 i25 = i28 + 64 | 0;
 i4 = i28 + 60 | 0;
 i5 = i28 + 56 | 0;
 i7 = i28 + 52 | 0;
 i9 = i28 + 48 | 0;
 i19 = i28 + 40 | 0;
 i20 = i28 + 32 | 0;
 i21 = i28 + 24 | 0;
 i22 = i28 + 16 | 0;
 i23 = i28 + 8 | 0;
 i24 = i28;
 i1 = HEAP32[i27 + 8 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i27 + 16 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i27 + 12 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, i1 | 0, i2 << 2 | 0);
 }
 i3 = HEAP32[i27 >> 2] | 0;
 if (!i3) {
  STACKTOP = i28;
  return;
 }
 i11 = i25 + 4 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i25 >> 2] = i12;
 i1 = i12 + 4 | 0;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i10 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0;
 i8 = i12 + 4 | 0;
 i6 = HEAP32[i27 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i8, i6, i4);
 i6 = i12 + 16 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i6, i4, i5);
 i5 = i12 + 28 | 0;
 i4 = HEAP32[i27 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i5, i4, i7);
 i4 = i12 + 40 | 0;
 i3 = HEAP32[i27 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i9 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i4, i3, i9);
 i3 = i12 + 52 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 if ((HEAP32[i12 + 60 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i3, i1);
 i1 = i12 + 64 | 0;
 i2 = HEAP32[i27 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0;
 if ((HEAP32[i12 + 72 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj(i1, i2);
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0;
 i27 = HEAP32[i27 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = i8 + (HEAP32[i12 + 8 >> 2] << 2) | 0;
 HEAP32[i19 >> 2] = i8;
 HEAP32[i19 + 4 >> 2] = i7;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + (HEAP32[i12 + 20 >> 2] << 2) | 0;
 HEAP32[i20 >> 2] = i7;
 HEAP32[i20 + 4 >> 2] = i8;
 i8 = HEAP32[i5 >> 2] | 0;
 i7 = i8 + (HEAP32[i12 + 32 >> 2] << 2) | 0;
 HEAP32[i21 >> 2] = i8;
 HEAP32[i21 + 4 >> 2] = i7;
 i7 = HEAP32[i4 >> 2] | 0;
 i8 = i7 + (HEAP32[i12 + 44 >> 2] << 2) | 0;
 HEAP32[i22 >> 2] = i7;
 HEAP32[i22 + 4 >> 2] = i8;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + (HEAP32[i12 + 56 >> 2] << 2) | 0;
 HEAP32[i23 >> 2] = i8;
 HEAP32[i23 + 4 >> 2] = i7;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i7 + (HEAP32[i12 + 68 >> 2] << 2) | 0;
 HEAP32[i24 >> 2] = i7;
 HEAP32[i24 + 4 >> 2] = i8;
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 mftCall_viiiiiiii(i9 | 0, i10 | 0, i27 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0);
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i26 | 0, i12 | 0, 76);
 __ZN5physx2Sc19ClothFabricBulkData15exportExtraDataERNS_22PxSerializationContextE(i12, i26);
 __ZN5physx2Sc19ClothFabricBulkDataD2Ev(i12);
 if (!(HEAP8[i11 >> 0] | 0)) {
  STACKTOP = i28;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i25, HEAP32[i25 >> 2] | 0);
 STACKTOP = i28;
 return;
}

function __ZN4PPtrI14SphereColliderE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14PhysicMaterialE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14BillboardAssetE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN11DynamicMesh13MergePolygonsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i25;
 i10 = i25 + 68 | 0;
 i13 = i25 + 48 | 0;
 i16 = i25 + 28 | 0;
 i18 = i10 + 12 | 0;
 HEAP32[i18 >> 2] = 6;
 i23 = i10 + 16 | 0;
 HEAP32[i23 >> 2] = 6;
 i24 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 64016 | 0);
 i12 = i8;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i24;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i10 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
 i9 = i13 + 12 | 0;
 HEAP32[i9 >> 2] = 6;
 i11 = i13 + 16 | 0;
 HEAP32[i11 >> 2] = 6;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 64016 | 0);
 i21 = i8;
 i15 = HEAP32[i21 + 4 >> 2] | 0;
 i14 = i12;
 HEAP32[i14 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i13 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i16 + 12 >> 2] = 6;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 6;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 64016 | 0);
 i21 = i8;
 i22 = HEAP32[i21 + 4 >> 2] | 0;
 i17 = i15;
 HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i17 + 4 >> 2] = i22;
 HEAP32[i16 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(72, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
 i17 = i7 + 12 | 0;
 if (HEAP32[i17 >> 2] | 0) {
  i19 = i8 + 24 | 0;
  i20 = i8 + 25 | 0;
  i21 = i7 + 60 | 0;
  i22 = i7 + 40 | 0;
  i6 = 0;
  do {
   __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i7, i13, (HEAP32[i7 >> 2] | 0) + (i6 * 26 | 0) | 0);
   i1 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
   L5 : do if (i1 >>> 0 > i6 >>> 0) do {
    i5 = HEAP32[i22 >> 2] | 0;
    if ((HEAP32[i5 + (i6 << 2) >> 2] | 0) == (HEAP32[i5 + (i1 << 2) >> 2] | 0)) {
     __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i7, i16, (HEAP32[i7 >> 2] | 0) + (i1 * 26 | 0) | 0);
     if (__ZNK11DynamicMesh13MergePolygonsER13dynamic_arrayI8Vector3fLj4EERKS2_S5_(0, i10, i13, i16) | 0) {
      i5 = HEAP32[i10 >> 2] | 0;
      i2 = (HEAP32[i18 >> 2] | 0) * 12 | 0;
      i3 = (i2 | 0) / 12 | 0;
      HEAP32[i9 >> 2] = i3;
      i4 = HEAP32[i11 >> 2] | 0;
      do if ((i4 & 2147483647) >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i11 >> 2] = i3;
       i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i13 >> 2] = i2;
       break;
      } else {
       i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i2 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
       HEAP32[i11 >> 2] = i3;
       HEAP32[i13 >> 2] = i2;
       break;
      } else i2 = HEAP32[i13 >> 2] | 0; while (0);
      _memcpy(i2 | 0, i5 | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
      i4 = HEAP32[i7 >> 2] | 0;
      i3 = i4 + (i1 * 26 | 0) | 0;
      i5 = i3 + 26 | 0;
      _memmove(i3 | 0, i5 | 0, i4 + ((HEAP32[i17 >> 2] | 0) * 26 | 0) - i5 | 0) | 0;
      HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
     }
     if ((HEAP32[i9 >> 2] | 0) == 6) break L5;
    }
    i1 = i1 + -1 | 0;
   } while (i1 >>> 0 > i6 >>> 0); while (0);
   i2 = (HEAP32[i7 >> 2] | 0) + (i6 * 26 | 0) | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = i8;
   i5 = i4 + 26 | 0;
   do {
    HEAP16[i4 >> 1] = 0;
    i4 = i4 + 2 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAP8[i19 >> 0] = i3;
   HEAP8[i20 >> 0] = 1;
   if (i3 | 0) {
    i1 = 0;
    do {
     HEAP16[i8 + 12 + (i1 << 1) >> 1] = __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f(i21, (HEAP32[i13 >> 2] | 0) + (i1 * 12 | 0) | 0) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i4 = i2;
   i1 = i8;
   i5 = i4 + 26 | 0;
   do {
    HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
    i4 = i4 + 2 | 0;
    i1 = i1 + 2 | 0;
   } while ((i4 | 0) < (i5 | 0));
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
  HEAP32[i16 >> 2] = 0;
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i12);
  HEAP32[i13 >> 2] = 0;
 }
 if ((HEAP32[i23 >> 2] | 0) <= -1) {
  STACKTOP = i25;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i24);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZN4PPtrI13RenderTextureE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI13MonoBehaviourE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN12MeshCollider19ExtractMeshGeometryER8Vector3f(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 40 | 0;
 i9 = i11;
 i4 = i6 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i10 = 9;
  }
 }
 if ((i10 | 0) == 7) i10 = 9;
 if ((i10 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 if (!(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(__ZNK4Mesh17GetPrimitiveCountEv(i1) | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i4 = __ZNK9Transform16GetTransformTypeEv(i5) | 0;
 __ZNK9Transform13GetWorldScaleEv(i9, i5);
 i5 = i6 + 121 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i6 + 128 >> 2] = HEAP32[i6 + 124 >> 2];
 i2 = i6 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if (!i3) i2 = 0; else if (!(HEAP8[i6 + 61 >> 0] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) == 4) {
  HEAP32[i8 >> 2] = 4;
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 28 >> 2] = Math_fround(1.0);
  i10 = i8 + 32 | 0;
  HEAP32[i10 >> 2] = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i8 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  break;
 } else {
  HEAP32[i8 >> 2] = 5;
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 28 >> 2] = Math_fround(1.0);
  i10 = i8 + 32 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i8 | 0) | 0;
  i2 = HEAP32[i8 + 36 >> 2] | 0;
  break;
 } else i2 = 0; while (0);
 do if (!(HEAP8[i5 >> 0] | 0)) if (__ZN12MeshCollider21IsScaleBakingRequiredEv(i6) | 0) i10 = 25; else if (!(HEAP8[i1 + 220 >> 0] | 0)) {
  i8 = HEAP32[i9 + 16 >> 2] | 0;
  i10 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP32[i7 + 8 >> 2] = i10;
  HEAP8[i6 + 61 >> 0] = 1;
  if (!(HEAP8[i6 + 60 >> 0] | 0)) {
   i1 = __ZN4Mesh15GetSharedPxMeshEv(i1) | 0;
   i10 = 30;
   break;
  } else {
   i1 = __ZN4Mesh21GetSharedPxConvexMeshEv(i1) | 0;
   i10 = 30;
   break;
  }
 } else i10 = 25; else i10 = 25; while (0);
 do if ((i10 | 0) == 25) {
  if (HEAP8[i1 + 41 >> 0] | 0) {
   HEAP8[i6 + 61 >> 0] = 0;
   i12 = __Z11GetIPhysicsv() | 0;
   i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0;
   i3 = (HEAP8[i6 + 60 >> 0] | 0) != 0;
   i10 = (HEAP8[i5 >> 0] | 0) != 0;
   __ZN10Matrix4x4fC2ERK10Matrix3x3f(i8, i9);
   i1 = mftCall_iiiiiiif(i13 | 0, i12 | 0, i1 | 0, i3 | 0, i10 | 0, i8 | 0, i4 | 0, +Math_fround(HEAPF32[i6 + 124 >> 2])) | 0;
   HEAPF32[i7 >> 2] = Math_fround(1.0);
   HEAPF32[i7 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i7 + 8 >> 2] = Math_fround(1.0);
   i10 = 30;
   break;
  }
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 736566 | 0, 0, gb + 736492 | 0, 317, 1, i1, 0, 0);
  i1 = 0;
 } while (0);
 if ((i10 | 0) == 30) if ((i2 | 0) != 0 & (i1 | 0) != 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 i13 = i1;
 STACKTOP = i11;
 return i13 | 0;
}

function __ZN9Animation15UpdateAnimationEd(i17, d14) {
 i17 = i17 | 0;
 d14 = +d14;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 12 | 0;
 i19 = i21;
 if ((HEAP16[gb + 1465200 + 6 >> 1] | 0) > -1) {
  HEAP32[i19 >> 2] = i17;
  HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465200 | 0, i16);
  i18 = gb + 1465200 | 0;
 } else i18 = 0;
 HEAP8[i16 >> 0] = 0;
 i1 = HEAP32[i17 + 268 >> 2] | 0;
 i2 = i17 + 272 | 0;
 if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
  __ZN9Animation13SyncLayerTimeEi(i17, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 HEAP32[i19 >> 2] = 0;
 i15 = i19 + 4 | 0;
 i5 = gb + 63160 | 0;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i15;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i17 + 104 | 0;
 i13 = i17 + 108 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = i5 - i2 | 0;
 i4 = i2;
 do if (!i1) {
  i1 = 0;
  i3 = i5;
 } else {
  i3 = i1 + 3 | 0;
  if (i3 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i3 = i5;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 896407 | 0, 1910) | 0;
   i4 = gb + 64016 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i2 = i15;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = HEAP32[i12 >> 2] | 0;
   i4 = i2;
   i3 = HEAP32[i13 >> 2] | 0;
   break;
  }
 } while (0);
 i11 = i1 + 3 & -4;
 if ((i3 | 0) == (i2 | 0)) {
  __ZN9Animation22UpdateQueuedAnimationsERb(i17, i16);
  i20 = 30;
 } else {
  i9 = i17 + 252 | 0;
  i10 = i17 + 248 | 0;
  i1 = 0;
  i7 = 0;
  L17 : while (1) {
   while (1) {
    i2 = HEAP32[i4 + (i7 << 2) >> 2] | 0;
    i3 = i2 + 56 | 0;
    if (!(HEAP16[i3 >> 1] & 2)) i8 = i1; else if (__ZN14AnimationState20UpdateAnimationStateEdRN5Unity9ComponentE(i2, d14, i17) | 0) if (!(HEAP16[i3 >> 1] & 64)) {
     HEAP32[i11 + (i1 << 2) >> 2] = i2;
     i8 = i1 + 1 | 0;
    } else i8 = i1; else i8 = i1;
    if (HEAP32[i2 + 96 >> 2] | 0) if (HEAP16[i3 >> 1] & 2) if (Math_fround(HEAPF32[i2 + 8 >> 2]) > Math_fround(.0000999999974)) HEAP8[i16 >> 0] = 1;
    i6 = i2 + 64 | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = 0;
    if (!(HEAP16[i3 >> 1] & 64)) break;
    __ZN14AnimationStateD2Ev(i2);
    __ZdlPv(i2);
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2;
    i5 = (HEAP32[i12 >> 2] | 0) + (i7 << 2) | 0;
    i1 = i5 + 4 | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    i2 = i4 - i1 | 0;
    i6 = i2 >> 2;
    if (!i6) {
     i3 = i4;
     i1 = i4;
    } else {
     _memmove(i5 | 0, i1 | 0, i2 | 0) | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     i3 = i1;
    }
    i2 = i5 + (i6 << 2) | 0;
    if ((i3 | 0) != (i2 | 0)) {
     i1 = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2) | 0;
     HEAP32[i13 >> 2] = i1;
    }
    HEAP32[i10 >> 2] = 0;
    i4 = HEAP32[i12 >> 2] | 0;
    if (i7 >>> 0 >= i1 - i4 >> 2 >>> 0) break L17; else i1 = i8;
   }
   i7 = i7 + 1 | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   if (i7 >>> 0 >= (HEAP32[i13 >> 2] | 0) - i4 >> 2 >>> 0) break; else i1 = i8;
  }
  __ZN9Animation22UpdateQueuedAnimationsERb(i17, i16);
  i2 = (i8 | 0) > 0;
  if (i2) {
   i1 = 0;
   do {
    i13 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
    i9 = i13 + 12 | 0;
    i12 = i13 + 80 | 0;
    i10 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i12 >> 2] = i10;
    i12 = i13 + 8 | 0;
    HEAP32[i13 + 84 >> 2] = HEAP32[i12 >> 2];
    HEAPF32[i12 >> 2] = Math_fround(.000100100006);
    i13 = i13 + 56 | 0;
    HEAP16[i13 >> 1] = HEAP16[i13 >> 1] | 2;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   HEAP8[i16 >> 0] = 1;
   __ZN9Animation14SampleInternalEv(i17);
   if (i2) {
    i1 = 0;
    do {
     i17 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
     i12 = i17 + 12 | 0;
     i16 = i17 + 80 | 0;
     i13 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i16 >> 2] = i13;
     HEAP32[i17 + 8 >> 2] = HEAP32[i17 + 84 >> 2];
     i17 = i17 + 56 | 0;
     HEAP16[i17 >> 1] = HEAP16[i17 >> 1] & -3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i8 | 0));
   }
  } else i20 = 30;
 }
 if ((i20 | 0) == 30) if (HEAP8[i16 >> 0] | 0) __ZN9Animation14SampleInternalEv(i17);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i15);
 if (!i18) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i21;
 return;
}

function __ZN4PPtrI12MeshRendererE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11TerrainDataE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11Rigidbody2DE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11NavMeshDataE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11LightProbesE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZNK5physx13PxContactPair15extractContactsEPNS_18PxContactPairPointEj(i2, i19, i22) {
 i2 = i2 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i23 = 0, f24 = f0, f25 = f0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i21 = HEAP32[i2 + 16 >> 2] | 0;
 i20 = i21 >>> 16;
 if (!((i22 | 0) != 0 & (i21 & 65535) << 16 >> 16 != 0)) {
  i22 = 0;
  return i22 | 0;
 }
 i21 = i1;
 if (!i20) {
  i3 = 0;
  i15 = 0;
  i16 = 0;
  i17 = 0;
  i18 = 0;
 } else {
  i17 = HEAPU16[i1 + 2 >> 1] | 0;
  i3 = i17 & 2;
  i18 = (i3 | 0) != 0;
  i17 = i17 & 1;
  i3 = i1 + (i3 << 3 | 4) | 0;
  i15 = i18 ? 4 : 32;
  i16 = i18 ? 72 : i17 << 3 | 16;
  i17 = (i17 | 0) != 0;
 }
 i14 = i1 + (i20 + 15 & 131056) | 0;
 i1 = HEAPU16[i2 + 20 >> 1] | 0;
 if ((i3 - i21 | 0) >>> 0 >= i20 >>> 0) {
  i22 = 0;
  return i22 | 0;
 }
 i13 = (i1 & 64 | 0) == 0;
 i12 = (i1 & 32 | 0) == 0;
 i1 = 0;
 i9 = i3;
 i4 = 0;
 i5 = 0;
 i2 = i3;
 L10 : while (1) {
  if ((i9 - i21 | 0) >>> 0 < i20 >>> 0) {
   i4 = HEAPU16[i9 >> 1] | 0;
   i2 = i9 + i15 | 0;
   i11 = i2 + (Math_imul(i4, i16) | 0) | 0;
   i5 = 0;
  } else i11 = i9;
  i10 = i9 + 4 | 0;
  L15 : do if (i13) while (1) {
   if (i5 >>> 0 >= i4 >>> 0) break L15;
   i9 = i2;
   HEAP32[i19 + (i1 * 48 | 0) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i9 = i18 ? i2 + 24 | 0 : i10;
   i23 = HEAP32[i9 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 16 >> 2] = i23;
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 20 >> 2] = i3;
   i9 = HEAP32[i9 + 8 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 24 >> 2] = i9;
   f6 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i17) {
    i9 = i2;
    i3 = HEAP32[i9 + 16 >> 2] | 0;
    i9 = HEAP32[i9 + 20 >> 2] | 0;
   } else {
    i3 = -1;
    i9 = -1;
   }
   HEAP32[i19 + (i1 * 48 | 0) + 28 >> 2] = i3;
   HEAP32[i19 + (i1 * 48 | 0) + 44 >> 2] = i9;
   if (i12) {
    HEAP32[i19 + (i1 * 48 | 0) + 32 >> 2] = 0;
    HEAP32[i19 + (i1 * 48 | 0) + 36 >> 2] = 0;
    HEAP32[i19 + (i1 * 48 | 0) + 40 >> 2] = 0;
   } else {
    f24 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
    f7 = Math_fround(f24 * f7);
    f8 = Math_fround(f24 * f8);
    HEAPF32[i19 + (i1 * 48 | 0) + 32 >> 2] = Math_fround(f24 * f6);
    HEAPF32[i19 + (i1 * 48 | 0) + 36 >> 2] = f7;
    HEAPF32[i19 + (i1 * 48 | 0) + 40 >> 2] = f8;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i22 | 0)) {
    i2 = 24;
    break L10;
   } else {
    i5 = i5 + 1 | 0;
    i2 = i2 + i16 | 0;
   }
  } else while (1) {
   if (i5 >>> 0 >= i4 >>> 0) break L15;
   i23 = i2;
   HEAP32[i19 + (i1 * 48 | 0) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i23 + 4 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 8 >> 2] = HEAP32[i23 + 8 >> 2];
   HEAP32[i19 + (i1 * 48 | 0) + 12 >> 2] = HEAP32[i23 + 12 >> 2];
   i23 = i18 ? i2 + 24 | 0 : i10;
   i3 = HEAP32[i23 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 16 >> 2] = i3;
   i9 = HEAP32[i23 + 4 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 20 >> 2] = i9;
   i23 = HEAP32[i23 + 8 >> 2] | 0;
   HEAP32[i19 + (i1 * 48 | 0) + 24 >> 2] = i23;
   f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i17) {
    i9 = i2;
    i3 = HEAP32[i9 + 20 >> 2] | 0;
    i9 = HEAP32[i9 + 16 >> 2] | 0;
   } else {
    i3 = -1;
    i9 = -1;
   }
   HEAP32[i19 + (i1 * 48 | 0) + 28 >> 2] = i3;
   HEAP32[i19 + (i1 * 48 | 0) + 44 >> 2] = i9;
   if (i12) {
    HEAP32[i19 + (i1 * 48 | 0) + 32 >> 2] = 0;
    HEAP32[i19 + (i1 * 48 | 0) + 36 >> 2] = 0;
    HEAP32[i19 + (i1 * 48 | 0) + 40 >> 2] = 0;
   } else {
    f25 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
    f7 = Math_fround(f25 * f7);
    f24 = Math_fround(f25 * f8);
    HEAPF32[i19 + (i1 * 48 | 0) + 32 >> 2] = Math_fround(f25 * f6);
    HEAPF32[i19 + (i1 * 48 | 0) + 36 >> 2] = f7;
    HEAPF32[i19 + (i1 * 48 | 0) + 40 >> 2] = f24;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i22 | 0)) {
    i2 = 24;
    break L10;
   } else {
    i5 = i5 + 1 | 0;
    i2 = i2 + i16 | 0;
   }
  } while (0);
  if ((i11 - i21 | 0) >>> 0 < i20 >>> 0) i9 = i11; else {
   i2 = 24;
   break;
  }
 }
 if ((i2 | 0) == 24) return i1 | 0;
 return 0;
}

function __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI10AudioMixerE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZNKSt3__218__time_get_storageIwE15__do_date_orderEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i2 + 508 | 0;
 i4 = HEAP8[i2 + 516 + 3 >> 0] | 0;
 i6 = i4 << 24 >> 24 < 0;
 i5 = i2 + 512 | 0;
 i2 = i4 & 255;
 i4 = 0;
 while (1) {
  if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
  if (i4 >>> 0 >= i3 >>> 0) break;
  if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
  i4 = i4 + 1 | 0;
 }
 if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 L15 : do switch (HEAP32[i3 + (i4 + 1 << 2) >> 2] | 0) {
 case 89:
 case 121:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    switch (HEAP32[i3 + (i4 + 1 << 2) >> 2] | 0) {
    case 109:
     {
      i4 = i4 + 2 | 0;
      while (1) {
       if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
       if (i4 >>> 0 >= i3 >>> 0) break;
       if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
       if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
       i4 = i4 + 1 | 0;
      }
      if (i6) i2 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) == (i2 | 0)) {
       i7 = 116;
       break L15;
      }
      if (i6) i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i1 + (i4 + 1 << 2) >> 2] | 0) == 100) {
       i1 = 3;
       break L15;
      } else {
       i7 = 116;
       break L15;
      }
     }
    case 100:
     {
      i4 = i4 + 2 | 0;
      while (1) {
       if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
       if (i4 >>> 0 >= i3 >>> 0) break;
       if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
       if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
       i4 = i4 + 1 | 0;
      }
      if (i6) i2 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) == (i2 | 0)) {
       i7 = 116;
       break L15;
      }
      if (i6) i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP32[i1 + (i4 + 1 << 2) >> 2] | 0) == 109) {
       i1 = 4;
       break L15;
      } else {
       i7 = 116;
       break L15;
      }
     }
    default:
     {
      i7 = 116;
      break L15;
     }
    }
   }
   break;
  }
 case 109:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP32[i3 + (i4 + 1 << 2) >> 2] | 0) == 100) {
     i4 = i4 + 2 | 0;
     while (1) {
      if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
      if (i4 >>> 0 >= i3 >>> 0) break;
      if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
      if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
      i4 = i4 + 1 | 0;
     }
     if (i6) i2 = HEAP32[i5 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i7 = 116; else {
      i3 = i4 + 1 | 0;
      if (i6) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
      if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == 121) i1 = 2; else {
       if (i6) i1 = HEAP32[i1 >> 2] | 0;
       if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) == 89) i1 = 2; else i7 = 116;
      }
     }
    } else i7 = 116;
   }
   break;
  }
 case 100:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP32[i3 + (i4 + 1 << 2) >> 2] | 0) == 109) {
     i4 = i4 + 2 | 0;
     while (1) {
      if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
      if (i4 >>> 0 >= i3 >>> 0) break;
      if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
      if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == 37) break;
      i4 = i4 + 1 | 0;
     }
     if (i6) i2 = HEAP32[i5 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i7 = 116; else {
      i3 = i4 + 1 | 0;
      if (i6) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
      if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == 121) i1 = 1; else {
       if (i6) i1 = HEAP32[i1 >> 2] | 0;
       if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) == 89) i1 = 1; else i7 = 116;
      }
     }
    } else i7 = 116;
   }
   break;
  }
 default:
  i7 = 116;
 } while (0);
 if ((i7 | 0) == 116) i1 = 0;
 return i1 | 0;
}

function _ps_unicodes_init(i14, i3, i15, i7, i8, i9) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 80 | 0;
 i12 = i18 + 40 | 0;
 i13 = i18;
 i1 = i12;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i16 = i3 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i11 = i3 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 i2 = _UNITY_ft_mem_realloc(i14, 8, 0, i15 + 10 | 0, 0, i17) | 0;
 HEAP32[i11 >> 2] = i2;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 | 0) {
  i17 = i1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (i15) {
  i6 = (i8 | 0) == 0;
  i5 = 0;
  do {
   i4 = mftCall_iii(i7 | 0, i9 | 0, i5 | 0) | 0;
   if (i4) {
    if (!(_strcmp(gb + 950818 | 0, i4) | 0)) {
     i1 = 0;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 6 | 0, i4) | 0)) {
     i1 = 1;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 12 | 0, i4) | 0)) {
     i1 = 2;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 21 | 0, i4) | 0)) {
     i1 = 3;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 28 | 0, i4) | 0)) {
     i1 = 4;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 35 | 0, i4) | 0)) {
     i1 = 5;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 38 | 0, i4) | 0)) {
     i1 = 6;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 53 | 0, i4) | 0)) {
     i1 = 7;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 59 | 0, i4) | 0)) {
     i1 = 8;
     i10 = 6;
    } else if (!(_strcmp(gb + 950818 + 72 | 0, i4) | 0)) {
     i1 = 9;
     i10 = 6;
    }
    if ((i10 | 0) == 6) {
     i10 = 0;
     i3 = i12 + (i1 << 2) | 0;
     if (!(HEAP32[i3 >> 2] | 0)) {
      HEAP32[i3 >> 2] = 1;
      HEAP32[i13 + (i1 << 2) >> 2] = i5;
     }
    }
    i3 = _ps_unicode_value(i4) | 0;
    if (i3 & 2147483647) {
     if ((i3 | 0) == 916) {
      i1 = 0;
      i10 = 19;
     } else if ((i3 | 0) == 937) {
      i1 = 1;
      i10 = 19;
     } else if ((i3 | 0) == 8725) {
      i1 = 2;
      i10 = 19;
     } else if ((i3 | 0) == 173) {
      i1 = 3;
      i10 = 19;
     } else if ((i3 | 0) == 713) {
      i1 = 4;
      i10 = 19;
     } else if ((i3 | 0) == 956) {
      i1 = 5;
      i10 = 19;
     } else if ((i3 | 0) == 8729) {
      i1 = 6;
      i10 = 19;
     } else if ((i3 | 0) == 160) {
      i1 = 7;
      i10 = 19;
     } else if ((i3 | 0) == 538) {
      i1 = 8;
      i10 = 19;
     } else if ((i3 | 0) == 539) {
      i1 = 9;
      i10 = 19;
     }
     if ((i10 | 0) == 19) {
      i10 = 0;
      HEAP32[i12 + (i1 << 2) >> 2] = 2;
     }
     HEAP32[i2 >> 2] = i3;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i2 + 8 | 0;
    }
    if (!i6) mftCall_vii(i8 | 0, i9 | 0, i4 | 0);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
  if ((HEAP32[i12 >> 2] | 0) == 1) {
   HEAP32[i2 >> 2] = 916;
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 >> 2];
   i2 = i2 + 8 | 0;
  }
 }
 if ((HEAP32[i12 + 4 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 937;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 8 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 8725;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 8 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 12 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 173;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 12 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 16 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 713;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 16 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 20 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 956;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 20 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 24 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 8729;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 24 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 28 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 160;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 28 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 32 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 538;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 32 >> 2];
  i2 = i2 + 8 | 0;
 }
 if ((HEAP32[i12 + 36 >> 2] | 0) == 1) {
  HEAP32[i2 >> 2] = 539;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 36 >> 2];
  i2 = i2 + 8 | 0;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i2 - i1 >> 3;
 if (!i2) {
  _UNITY_ft_mem_free(i14, i1);
  HEAP32[i11 >> 2] = 0;
  i1 = HEAP32[i17 >> 2] | 0;
  if (!i1) {
   HEAP32[i17 >> 2] = 163;
   i1 = 163;
  }
 } else {
  if (i2 >>> 0 < i15 >>> 1 >>> 0) {
   i1 = _UNITY_ft_mem_realloc(i14, 8, i15, i2, i1, i17) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i17 >> 2] = 0;
  }
  _qsort(i1, i2, 8, fb + 1085 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
 }
 HEAP32[i16 >> 2] = i2;
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_10MemLabelId17TransferMetaFlags(i28, i5, i1, i2) {
 i28 = i28 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27 + 60 | 0;
 i24 = i27;
 i25 = i28 + 40 | 0;
 i26 = HEAP32[i25 >> 2] | 0;
 i1 = HEAP32[i26 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0)) {
   STACKTOP = i27;
   return;
  }
  i28 = i5 + 4 | 0;
  i26 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i28 >> 2] | 0) | 0;
  i26 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i28 >> 2] | 0, i26, 0) | 0;
  i28 = HEAP32[i5 >> 2] | 0;
  HEAP32[i28 >> 2] = i26;
  HEAP32[i28 + 4 >> 2] = 0;
  STACKTOP = i27;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  STACKTOP = i27;
  return;
 }
 i2 = HEAP32[i26 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i5 + 4 | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0)) i3 = i26; else {
  i3 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i4 >> 2] | 0) | 0;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i4 >> 2] | 0, i3, i2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i2;
  i2 = HEAP32[i25 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 i17 = i6 + (i2 * 24 | 0) | 0;
 i18 = i24 + 24 | 0;
 HEAP8[i18 >> 0] = 1;
 i19 = i24 + 28 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 32 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i24 + 36 | 0;
 HEAP32[i21 >> 2] = -1;
 i22 = i24 + 44 | 0;
 HEAP32[i24 >> 2] = i1;
 i13 = i24 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i24 + 4 | 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i4 >> 2] | 0) | 0) & 1;
 HEAP8[i14 >> 0] = i3;
 i15 = i24 + 8 | 0;
 HEAP32[i15 >> 2] = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) | 0) | 0;
 i16 = i24 + 16 | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 i12 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 8 >> 2] | 0;
 HEAP32[i22 >> 2] = i1;
 HEAP32[i24 + 40 >> 2] = i1;
 HEAP32[i24 + 48 >> 2] = i12;
 i12 = i12 - i1 >> 6;
 HEAP32[i24 + 56 >> 2] = i12;
 HEAP32[i24 + 52 >> 2] = i12;
 L15 : do if (i2 | 0) {
  i8 = i24 + 40 | 0;
  i9 = i24 + 20 | 0;
  i10 = i28 + 20 | 0;
  i11 = i23 + 20 | 0;
  i12 = i23 + 16 | 0;
  i4 = i1;
  i1 = 0;
  while (1) {
   HEAP32[i25 >> 2] = i6;
   HEAP32[i22 >> 2] = i4;
   HEAP32[i9 >> 2] = i8;
   if (!(i3 << 24 >> 24)) {
    i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i24 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
    if (!i1) {
     i1 = _il2cpp_object_new(HEAP32[i16 >> 2] | 0) | 0;
     __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
     __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i24 >> 2] >> 2] | 0, HEAP32[i13 >> 2] | 0, i1);
    }
    i2 = HEAP32[i16 >> 2] | 0;
    HEAP8[i18 >> 0] = 1;
    HEAP32[i19 >> 2] = i1;
    i1 = -1;
   } else {
    i7 = HEAP32[HEAP32[i24 >> 2] >> 2] | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    i1 = (Math_imul(HEAP32[i15 >> 2] | 0, i1) | 0) + 16 | 0;
    HEAP8[i18 >> 0] = 0;
    HEAP32[i19 >> 2] = i7;
   }
   HEAP32[i20 >> 2] = i2;
   HEAP32[i21 >> 2] = i1;
   if (!i2) i1 = gb + 1033805 | 0; else i1 = __Z24scripting_class_get_nameP11Il2CppClass(i2) | 0;
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i11 >> 2] = i28;
   HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   HEAP32[i12 >> 2] = i1;
   i5 = i1 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i7 = i1 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i4 = i1 + 12 | 0;
    i1 = i3;
    do {
     i3 = i1 + 64 | 0;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 >> 2] = i2 - i3 >> 6;
     mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i23 | 0);
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
   HEAP32[i13 >> 2] = i2;
   i1 = i6 + 24 | 0;
   if ((i1 | 0) == (i17 | 0)) break L15;
   i6 = i1;
   i4 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP8[i14 >> 0] | 0;
   i1 = i2;
  }
 } while (0);
 HEAP32[i25 >> 2] = i26;
 STACKTOP = i27;
 return;
}

function __ZN5physx3Scb4Body17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i11 >> 2] = HEAP32[gb + 125732 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 125732 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 125732 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 125732 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 125732 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 125732 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 125732 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 125732 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 747941;
 HEAP32[i10 + 4 >> 2] = gb + 747951;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 240;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 125764 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 125764 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 125764 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 125764 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 125764 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 125764 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 125764 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 125764 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 125796 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 125796 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 125796 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 125796 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 125796 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 125796 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 125796 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 125796 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 125828 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 125828 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 125828 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 125828 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 125828 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 125828 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 125828 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 125828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 125860 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 125860 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 125860 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 125860 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 125860 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 125860 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 125860 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 125860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 125892 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125892 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125892 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125892 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125892 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125892 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125892 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 125924 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 125924 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 125924 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 125924 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 125924 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 125924 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 125924 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 125924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125956 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125956 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125956 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125956 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125956 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125956 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125956 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9AudioClipE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_(i8, i10, i9, i1, f2, f3, f4, f5, f6, f7) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i27;
 f17 = Math_fround(f2 - Math_fround(f5 * Math_fround(.00999999977)));
 f15 = Math_fround(f3 - Math_fround(f6 * Math_fround(.00999999977)));
 f12 = Math_fround(f4 - Math_fround(f7 * Math_fround(.00999999977)));
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f17 = Math_fround(f17 * Math_fround(2.0));
 f15 = Math_fround(f15 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f26 = Math_fround(f17 * f16);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f15 * f18));
 f19 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f12 * f19));
 f24 = Math_fround(Math_fround(f16 * f26) + Math_fround(Math_fround(f17 * f13) - Math_fround(f14 * Math_fround(Math_fround(f12 * f18) - Math_fround(f15 * f19)))));
 f25 = Math_fround(Math_fround(f18 * f26) + Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * Math_fround(Math_fround(f17 * f19) - Math_fround(f12 * f16)))));
 f26 = Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f18)))) + Math_fround(f19 * f26));
 f17 = Math_fround(f5 * Math_fround(2.0));
 f15 = Math_fround(f6 * Math_fround(2.0));
 f12 = Math_fround(f7 * Math_fround(2.0));
 f23 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f18)) + Math_fround(f12 * f19));
 f21 = Math_fround(Math_fround(f16 * f23) + Math_fround(Math_fround(f17 * f13) - Math_fround(f14 * Math_fround(Math_fround(f12 * f18) - Math_fround(f15 * f19)))));
 f22 = Math_fround(Math_fround(f18 * f23) + Math_fround(Math_fround(f15 * f13) - Math_fround(f14 * Math_fround(Math_fround(f17 * f19) - Math_fround(f12 * f16)))));
 f23 = Math_fround(Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f18)))) + Math_fround(f19 * f23));
 __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i11, i8 + 4 | 0, i8 + 16 | 0);
 i20 = HEAP32[i9 >> 2] | 0;
 if (!i20) {
  i20 = 0;
  STACKTOP = i27;
  return i20 | 0;
 }
 i9 = HEAP32[i10 + 40 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f18 = Math_fround(HEAPF32[i11 + 40 >> 2]);
 f19 = Math_fround(HEAPF32[i11 + 44 >> 2]);
 f12 = Math_fround(HEAPF32[i11 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 f14 = Math_fround(HEAPF32[i11 + 56 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 60 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + 64 >> 2]);
 f7 = Math_fround(HEAPF32[i11 + 68 >> 2]);
 i8 = 0;
 f6 = Math_fround(3402823469999999843913219.0e14);
 i1 = 0;
 while (1) {
  f28 = Math_fround(HEAPF32[i9 + (i8 * 20 | 0) + 12 >> 2]);
  f29 = Math_fround(HEAPF32[i9 + (i8 * 20 | 0) >> 2]);
  f2 = Math_fround(f17 * f29);
  f5 = Math_fround(HEAPF32[i9 + (i8 * 20 | 0) + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f18 * f5));
  f4 = Math_fround(HEAPF32[i9 + (i8 * 20 | 0) + 8 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f19 * f4));
  f3 = Math_fround(Math_fround(Math_fround(f29 * f12) + Math_fround(f5 * f13)) + Math_fround(f4 * f14));
  f4 = Math_fround(Math_fround(Math_fround(f29 * f15) + Math_fround(f5 * f16)) + Math_fround(f4 * f7));
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4)))));
  f2 = Math_fround(f2 * f5);
  f3 = Math_fround(f3 * f5);
  f4 = Math_fround(f4 * f5);
  f5 = Math_fround(Math_fround(f28 * f5) + Math_fround(Math_fround(f26 * f4) + Math_fround(Math_fround(f24 * f2) + Math_fround(f25 * f3))));
  if (f5 < Math_fround(0.0)) f2 = f6; else {
   f2 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f23 * f4) + Math_fround(Math_fround(f21 * f2) + Math_fround(f22 * f3))) * Math_fround(.00999999977)));
   if (f2 < f6) i1 = i8; else f2 = f6;
  }
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 >= i20 >>> 0) break; else f6 = f2;
 }
 STACKTOP = i27;
 return i1 | 0;
}

function __ZN5physx7NpSceneC2ERKNS_11PxSceneDescE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 100104 + 8;
 i1 = i6 + 16 | 0;
 i3 = HEAP32[gb + 1457324 >> 2] | 0;
 i3 = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 176 >> 2] | 0, i3 | 0) | 0) + 8 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i3;
 __ZN5physx3Scb5SceneC2ERKNS_11PxSceneDescENS_2Cm13EventProfilerE(i1, i5, i2);
 __ZN5physx2Sq17SceneQueryManagerC2ERNS_3Scb5SceneERKNS_11PxSceneDescE(i6 + 3392 | 0, i1, i5);
 HEAP32[i6 >> 2] = gb + 100552 + 8;
 HEAP32[i6 + 3476 >> 2] = gb + 86472 + 8;
 _memset(i6 + 3480 | 0, 0, 132) | 0;
 HEAPF32[i6 + 3612 >> 2] = Math_fround(.75);
 HEAP32[i6 + 3616 >> 2] = -1;
 HEAP32[i6 + 3620 >> 2] = 0;
 HEAP32[i6 + 3624 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i6 + 3588 | 0, 64);
 i1 = i6 + 3664 | 0;
 i2 = i5 + 160 | 0;
 i3 = i6 + 3628 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 3668 >> 2] = HEAP32[i5 + 164 >> 2];
 HEAP32[i6 + 3672 >> 2] = HEAP32[i5 + 168 >> 2];
 HEAP32[i6 + 3676 >> 2] = HEAP32[i5 + 172 >> 2];
 HEAP32[i6 + 3680 >> 2] = HEAP32[i5 + 176 >> 2];
 HEAP32[i6 + 3684 >> 2] = HEAP32[i5 + 180 >> 2];
 i3 = i6 + 3688 | 0;
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i1 = mftCall_iiiiii(i8 | 0, i2 | 0, i1 | 0, (i4 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 i2 = i6 + 3692 | 0;
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i8 = _PxGetFoundation() | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
  i1 = mftCall_iiiiii(i9 | 0, i4 | 0, i1 | 0, (i8 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 HEAP8[i6 + 3696 >> 0] = 0;
 HEAP8[i6 + 3697 >> 0] = (HEAP32[i5 + 152 >> 2] | 0) == 1 & 1;
 HEAP8[i6 + 3698 >> 0] = 0;
 HEAP32[i6 + 3704 >> 2] = 1;
 HEAP32[i6 + 3708 >> 2] = 0;
 HEAP32[i6 + 3712 >> 2] = 0;
 HEAP32[i6 + 3716 >> 2] = 0;
 i5 = i6 + 3724 | 0;
 HEAP16[i6 + 3728 >> 1] = -1;
 HEAP16[i6 + 3730 >> 1] = 0;
 HEAP32[i6 + 3732 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 3736 >> 2] = 0;
 HEAP32[i6 + 3740 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 101008 + 8;
 HEAP32[i6 + 3744 >> 2] = i3;
 i5 = i6 + 3748 | 0;
 HEAP16[i6 + 3752 >> 1] = -1;
 HEAP16[i6 + 3754 >> 1] = 0;
 HEAP32[i6 + 3756 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 3760 >> 2] = 0;
 HEAP32[i6 + 3764 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 101008 + 8;
 HEAP32[i6 + 3768 >> 2] = i2;
 i5 = i6 + 3772 | 0;
 HEAP16[i6 + 3776 >> 1] = -1;
 HEAP16[i6 + 3778 >> 1] = 0;
 HEAP32[i6 + 3780 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 3784 >> 2] = 0;
 HEAP32[i6 + 3788 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 101052 + 8;
 i5 = i6 + 3792 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 3796 >> 2] = gb + 701674;
 i8 = i6 + 3800 | 0;
 HEAP16[i6 + 3804 >> 1] = -1;
 HEAP16[i6 + 3806 >> 1] = 0;
 HEAP32[i6 + 3808 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 3812 >> 2] = 0;
 HEAP32[i6 + 3816 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 101096 + 8;
 i8 = i6 + 3820 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 + 3824 >> 2] = gb + 701692;
 i9 = i6 + 3828 | 0;
 HEAP16[i6 + 3832 >> 1] = -1;
 HEAP16[i6 + 3834 >> 1] = 0;
 HEAP32[i6 + 3836 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 87404 + 8;
 HEAP32[i6 + 3840 >> 2] = 0;
 HEAP32[i6 + 3844 >> 2] = 0;
 HEAP32[i9 >> 2] = gb + 101140 + 8;
 i9 = i6 + 3848 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i6 + 3852 >> 2] = gb + 701708;
 HEAP8[i6 + 3856 >> 0] = 0;
 HEAP32[i6 + 3860 >> 2] = 0;
 HEAP32[i6 + 3864 >> 2] = 0;
 HEAP32[i6 + 3868 >> 2] = 0;
 HEAP32[i6 + 3872 >> 2] = 0;
 HEAP32[i6 + 3880 >> 2] = 0;
 __ZN5physx6shdfnd13ReadWriteLockC2Ev(i6 + 3884 | 0);
 HEAP8[i6 + 3888 >> 0] = 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i6 + 3720 >> 2] = HEAP32[i6 + 2420 >> 2];
 HEAP32[i6 + 3876 >> 2] = __ZN5physx6shdfnd8TlsAllocEv() | 0;
 STACKTOP = i7;
 return;
}

function __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI7CubemapE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6SpriteE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6CameraE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6AvatarE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI5LightE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI5FlareE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i4 = i10;
 i9 = i4 + 8 | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i8 >> 2] & 1)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i3 = i8 + 16 | 0;
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i1 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    if (i1 >>> 0 < i4 >>> 0) i7 = 30; else {
     i2 = i1 + 4 | 0;
     if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i3 >> 2] = i2;
     }
    }
    if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i6 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
      i4 = i2;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i9;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i7 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i7 >> 2] = i6;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  STACKTOP = i10;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i3 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i7 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 7; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i5 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i5 >>> 0) i7 = 18; else {
     i3 = i2 + 8 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 18; else {
      i11 = i2;
      i2 = HEAP32[i11 + 4 >> 2] | 0;
      i5 = i9;
      HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i5 + 4 >> 2] = i2;
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 8);
    if (HEAP32[i8 >> 2] & 512 | 0) {
     i7 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
     i11 = i9 + 4 | 0;
     HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i11 >> 2] = i7;
    }
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i4, i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN4Mesh10SetNormalsEPK8Vector3fj(i9, i2, i5) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i10 = i11 + 24 | 0;
 i7 = i11 + 8 | 0;
 i6 = i9 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i3 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i6 >> 2] | 0);
  i3 = HEAP32[i6 >> 2] | 0;
  i12 = i3 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i6 >> 2] = i1;
  i3 = i1;
 }
 if (!((i2 | 0) != 0 & (i5 | 0) != 0)) {
  i1 = i3 + 8 | 0;
  i2 = HEAP32[i3 + 100 >> 2] | 0;
  if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  } else i8 = 8; else i8 = 8;
  if ((i8 | 0) == 8) {
   HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i2, 0, 2, i7, gb + 1546313 | 0);
  i2 = i9 + 44 | 0;
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
  HEAP32[i10 >> 2] = gb + 30832;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = i9;
  i2 = HEAP32[i9 + 236 >> 2] | 0;
  i3 = i9 + 232 | 0;
  i1 = i2;
  if ((i1 | 0) != (i3 | 0)) do {
   i12 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
   i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i3 + 100 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[gb + 58184 + 4 >> 2];
  __Z6FormatPKcz(i10, gb + 427581 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 846, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return;
 }
 i1 = i3 + 8 | 0;
 if (!(HEAP32[i3 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
  HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 } else i8 = 17; else i8 = 17;
 if ((i8 | 0) == 17) {
  HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i5, 2, 0, i7, gb + 1546313 | 0);
 i5 = i2 + (i5 * 12 | 0) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i12 = HEAP16[i3 + 14 >> 1] | 0;
 if ((i12 & 65535) < 768 | (i12 & 255) != 0) {
  i1 = 0;
  i3 = 0;
 } else {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = 1;
  } else if (!(HEAP8[i3 + 15 >> 0] | 0)) {
   i1 = 0;
   i3 = 1;
  } else {
   i12 = HEAP16[i3 + 12 >> 1] | 0;
   i1 = i1 + (((i12 & 65535) >>> 8 & 65535) + (HEAP32[i4 + 32 + ((i12 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i3 = HEAPU8[i4 + 32 + ((HEAPU8[i3 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 while (1) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i2 + 12 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
 }
 i2 = i9 + 44 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
 HEAP32[i10 >> 2] = gb + 30832;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = i9;
 i2 = HEAP32[i9 + 236 >> 2] | 0;
 i3 = i9 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i12 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105196 | 0, i10);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_18PxArticulationLinkEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i25, i3) {
 i25 = i25 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 192 | 0;
 i19 = i28;
 i20 = i28 + 428 | 0;
 i27 = i28 + 196 | 0;
 i1 = i28 + 424 | 0;
 __ZN5physx20PxShapeGeneratedInfoC2Ev(i28 + 232 | 0);
 i2 = i25 + 8 | 0;
 i23 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i23) {
  STACKTOP = i28;
  return;
 }
 i26 = i27 + 20 | 0;
 i21 = i27 + 24 | 0;
 HEAP32[i27 + 28 >> 2] = 0;
 i22 = i27 + 32 | 0;
 HEAP8[i26 >> 0] = 1;
 HEAP32[i21 >> 2] = i27;
 HEAP32[i22 >> 2] = 5;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i27, i23, i1);
 mftCall_iiii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, i23 | 0) | 0;
 i6 = i19 + 4 | 0;
 i7 = i25 + 4 | 0;
 i8 = i25 + 12 | 0;
 i9 = i25 + 16 | 0;
 i10 = i20 + 4 | 0;
 i11 = i20 + 8 | 0;
 i12 = i20 + 12 | 0;
 i13 = i20 + 16 | 0;
 i14 = i20 + 20 | 0;
 i15 = i20 + 24 | 0;
 i16 = i19 + 4 | 0;
 i17 = i19 + 8 | 0;
 i18 = 0;
 do {
  i5 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   i2 = 0;
  } else {
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i2 = HEAP32[i25 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   } else i3 = i1;
  }
  HEAP32[i19 >> 2] = gb + 690295;
  HEAP8[i6 >> 0] = 0;
  i1 = i3 + 8 | 0;
  if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i30 = i19;
   i29 = HEAP32[i30 + 4 >> 2] | 0;
   i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i4 + 4 >> 2] = i29;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0) {
   i3 = HEAP32[i25 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i29 = HEAP32[i8 >> 2] | 0;
   i30 = HEAP32[i9 >> 2] | 0;
   __ZN5physx20PxShapeGeneratedInfoC2Ev(i19);
   HEAP32[i20 >> 2] = i3;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = i29;
   HEAP32[i13 >> 2] = i30;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j(i19, i20, 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0) | 0)) {
    i30 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i24 >> 2] = gb + 673430;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i30, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i24);
   }
   i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i5 | 0) | 0;
   i4 = getTempRet0() | 0;
   i3 = (i2 | 0) == 0 & (i4 | 0) == 0;
   i30 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i19 >> 2] = gb + 690295;
   HEAP32[i16 >> 2] = i5;
   i29 = i17;
   HEAP32[i29 >> 2] = i3 ? i5 : i2;
   HEAP32[i29 + 4 >> 2] = i3 ? 0 : i4;
   mftCall_viii(i30 | 0, i1 | 0, gb + 673430 | 0, i19 | 0);
  }
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    i1 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   }
   HEAP32[i1 + 8 >> 2] = i2 + -1;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i23 | 0));
 i30 = HEAP32[i22 >> 2] | 0;
 do if ((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if ((i27 | 0) == (i1 | 0)) {
   HEAP8[i26 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i28;
 return;
}

function __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback(i18, i2, i1, i19, i17, i3, i16) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i14 = i15 + 40 | 0;
 i13 = i15;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i1, i2, i3);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f4 = Math_fround(Math_fround(f7 + f22) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f8 + f21) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f9 + f20) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f22 - f7) * Math_fround(.5));
 f8 = Math_fround(Math_fround(f21 - f8) * Math_fround(.5));
 f9 = Math_fround(Math_fround(f20 - f9) * Math_fround(.5));
 HEAP32[i14 >> 2] = 1065353216;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 1065353216;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP32[i14 + 32 >> 2] = 1065353216;
 i1 = i14 + 36 | 0;
 HEAPF32[i1 >> 2] = f4;
 i2 = i14 + 40 | 0;
 HEAPF32[i2 >> 2] = f5;
 i3 = i14 + 44 | 0;
 HEAPF32[i3 >> 2] = f6;
 i10 = i14 + 48 | 0;
 HEAPF32[i10 >> 2] = f7;
 i11 = i14 + 52 | 0;
 HEAPF32[i11 >> 2] = f8;
 i12 = i14 + 56 | 0;
 HEAPF32[i12 >> 2] = f9;
 if (i17) {
  i17 = i18 + 16 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  HEAP32[i13 >> 2] = i17;
  i17 = i18 + 32 | 0;
  i19 = i13 + 4 | 0;
  HEAP32[i19 >> 2] = i17;
  i18 = i18 + 20 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i19 = i13 + 8 | 0;
  HEAP32[i19 >> 2] = i18;
  __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i14, 1, i13, i16, 1);
  STACKTOP = i15;
  return;
 }
 f29 = Math_fround(HEAPF32[i19 + 36 >> 2]);
 f25 = Math_fround(f4 * f29);
 f27 = Math_fround(HEAPF32[i19 + 40 >> 2]);
 f24 = Math_fround(f4 * f27);
 f22 = Math_fround(HEAPF32[i19 + 44 >> 2]);
 f23 = Math_fround(f4 * f22);
 f28 = Math_fround(HEAPF32[i19 + 48 >> 2]);
 f31 = Math_fround(f5 * f28);
 f26 = Math_fround(HEAPF32[i19 + 52 >> 2]);
 f30 = Math_fround(f5 * f26);
 f21 = Math_fround(HEAPF32[i19 + 56 >> 2]);
 f31 = Math_fround(f25 + f31);
 f30 = Math_fround(f24 + f30);
 f5 = Math_fround(f23 + Math_fround(f5 * f21));
 f23 = Math_fround(HEAPF32[i19 + 60 >> 2]);
 f24 = Math_fround(f6 * f23);
 f25 = Math_fround(HEAPF32[i19 + 64 >> 2]);
 f4 = Math_fround(f6 * f25);
 f20 = Math_fround(HEAPF32[i19 + 68 >> 2]);
 f24 = Math_fround(f31 + f24);
 f4 = Math_fround(f30 + f4);
 f5 = Math_fround(f5 + Math_fround(f6 * f20));
 f23 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f29 * f7))) + Math_fround(Math_abs(Math_fround(f28 * f8)))) + Math_fround(Math_abs(Math_fround(f23 * f9))));
 f6 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f27 * f7))) + Math_fround(Math_abs(Math_fround(f26 * f8)))) + Math_fround(Math_abs(Math_fround(f25 * f9))));
 f8 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f22 * f7))) + Math_fround(Math_abs(Math_fround(f21 * f8)))) + Math_fround(Math_abs(Math_fround(f20 * f9))));
 f20 = Math_fround(f24 - f23);
 f21 = Math_fround(f4 - f6);
 f22 = Math_fround(f5 - f8);
 f9 = Math_fround(f24 + f23);
 f7 = Math_fround(f4 + f6);
 f8 = Math_fround(f5 + f8);
 f5 = Math_fround(Math_fround(f21 + f7) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f22 + f8) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f20 + f9) * Math_fround(.5));
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = f6;
 f21 = Math_fround(Math_fround(f7 - f21) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f8 - f22) * Math_fround(.5));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(f9 - f20) * Math_fround(.5));
 HEAPF32[i11 >> 2] = f21;
 HEAPF32[i12 >> 2] = f22;
 i17 = i18 + 16 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i13 >> 2] = i17;
 i17 = i18 + 32 | 0;
 i19 = i13 + 4 | 0;
 HEAP32[i19 >> 2] = i17;
 i18 = i18 + 20 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = i13 + 8 | 0;
 HEAP32[i19 >> 2] = i18;
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i14, 1, i13, i16, 1);
 STACKTOP = i15;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags(i26, i27, i1) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 56 | 0;
 i21 = i25 + 40 | 0;
 i22 = i25 + 20 | 0;
 i23 = i25;
 i24 = i26 + 16 | 0;
 i1 = HEAP32[i24 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i19 = i26 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i19 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i24, i20, 4);
  i1 = HEAP32[i20 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i20 >> 2] = i1;
  HEAP32[i24 >> 2] = i2;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i7 = i22 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i18 = i27 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i27, HEAP32[i18 >> 2] | 0);
 i8 = i27 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i27 >> 2] = i18;
 HEAP32[i18 >> 2] = 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i25;
  return;
 }
 i9 = i22 + 11 | 0;
 i10 = i22 + 4 | 0;
 i11 = i23 + 12 | 0;
 i5 = i23 + 12 | 0;
 i12 = i20 + 4 | 0;
 i13 = i23 + 8 | 0;
 i14 = i23 + 4 | 0;
 i15 = i23 + 16 | 0;
 i16 = i27 + 4 | 0;
 i17 = i23 + 11 | 0;
 i18 = i20 + 4 | 0;
 i4 = 0;
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i26, i22, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i26);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i19 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i24, i20, 4);
   i1 = HEAP32[i20 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   HEAP32[i24 >> 2] = i2;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = HEAP8[i9 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i22 >> 2] | 0 : i22;
  i3 = i1 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i11 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
   i1 = HEAP32[i5 >> 2] | 0;
   i28 = 15;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i17 >> 0] = i3;
   if (!i3) i1 = i23; else {
    i1 = i23;
    i28 = 17;
   }
  } else i28 = 15;
  if ((i28 | 0) == 15) {
   i29 = i3 + 16 & -16;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i12 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i20, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i13 >> 2] = i29 | -2147483648;
   HEAP32[i14 >> 2] = i3;
   i28 = 17;
  }
  if ((i28 | 0) == 17) {
   i28 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  i2 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i27, i20, i23) | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i21, i27, i23);
   i1 = HEAP32[i21 >> 2] | 0;
   HEAP32[i21 >> 2] = 0;
   i3 = HEAP32[i20 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i27 >> 2] = i3;
    i1 = HEAP32[i2 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i16 >> 2] | 0, i1);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  }
  if ((HEAP8[i17 >> 0] | 0) < 0) {
   i29 = HEAP32[i23 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i18 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i29, i20);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i6 | 0));
 if ((HEAP8[i9 >> 0] | 0) >= 0) {
  STACKTOP = i25;
  return;
 }
 i29 = HEAP32[i22 >> 2] | 0;
 i28 = HEAP32[i22 + 12 >> 2] | 0;
 HEAP32[i20 >> 2] = 66;
 HEAP32[i20 + 4 >> 2] = i28;
 __Z19free_alloc_internalPvRK10MemLabelId(i29, i20);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_14PxRigidDynamicEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i25, i3) {
 i25 = i25 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 192 | 0;
 i19 = i28;
 i20 = i28 + 428 | 0;
 i27 = i28 + 196 | 0;
 i1 = i28 + 424 | 0;
 __ZN5physx20PxShapeGeneratedInfoC2Ev(i28 + 232 | 0);
 i2 = i25 + 8 | 0;
 i23 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i23) {
  STACKTOP = i28;
  return;
 }
 i26 = i27 + 20 | 0;
 i21 = i27 + 24 | 0;
 HEAP32[i27 + 28 >> 2] = 0;
 i22 = i27 + 32 | 0;
 HEAP8[i26 >> 0] = 1;
 HEAP32[i21 >> 2] = i27;
 HEAP32[i22 >> 2] = 5;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i27, i23, i1);
 mftCall_iiii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, i23 | 0) | 0;
 i6 = i19 + 4 | 0;
 i7 = i25 + 4 | 0;
 i8 = i25 + 12 | 0;
 i9 = i25 + 16 | 0;
 i10 = i20 + 4 | 0;
 i11 = i20 + 8 | 0;
 i12 = i20 + 12 | 0;
 i13 = i20 + 16 | 0;
 i14 = i20 + 20 | 0;
 i15 = i20 + 24 | 0;
 i16 = i19 + 4 | 0;
 i17 = i19 + 8 | 0;
 i18 = 0;
 do {
  i5 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   i2 = 0;
  } else {
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i2 = HEAP32[i25 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   } else i3 = i1;
  }
  HEAP32[i19 >> 2] = gb + 690295;
  HEAP8[i6 >> 0] = 0;
  i1 = i3 + 8 | 0;
  if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i30 = i19;
   i29 = HEAP32[i30 + 4 >> 2] | 0;
   i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i4 + 4 >> 2] = i29;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0) {
   i3 = HEAP32[i25 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i29 = HEAP32[i8 >> 2] | 0;
   i30 = HEAP32[i9 >> 2] | 0;
   __ZN5physx20PxShapeGeneratedInfoC2Ev(i19);
   HEAP32[i20 >> 2] = i3;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = i29;
   HEAP32[i13 >> 2] = i30;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j(i19, i20, 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0) | 0)) {
    i30 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i24 >> 2] = gb + 673430;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i30, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i24);
   }
   i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i5 | 0) | 0;
   i4 = getTempRet0() | 0;
   i3 = (i2 | 0) == 0 & (i4 | 0) == 0;
   i30 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i19 >> 2] = gb + 690295;
   HEAP32[i16 >> 2] = i5;
   i29 = i17;
   HEAP32[i29 >> 2] = i3 ? i5 : i2;
   HEAP32[i29 + 4 >> 2] = i3 ? 0 : i4;
   mftCall_viii(i30 | 0, i1 | 0, gb + 673430 | 0, i19 | 0);
  }
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    i1 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   }
   HEAP32[i1 + 8 >> 2] = i2 + -1;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i23 | 0));
 i30 = HEAP32[i22 >> 2] | 0;
 do if ((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if ((i27 | 0) == (i1 | 0)) {
   HEAP8[i26 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i28;
 return;
}

function __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_13PxRigidStaticEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i25, i3) {
 i25 = i25 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 192 | 0;
 i19 = i28;
 i20 = i28 + 428 | 0;
 i27 = i28 + 196 | 0;
 i1 = i28 + 424 | 0;
 __ZN5physx20PxShapeGeneratedInfoC2Ev(i28 + 232 | 0);
 i2 = i25 + 8 | 0;
 i23 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i23) {
  STACKTOP = i28;
  return;
 }
 i26 = i27 + 20 | 0;
 i21 = i27 + 24 | 0;
 HEAP32[i27 + 28 >> 2] = 0;
 i22 = i27 + 32 | 0;
 HEAP8[i26 >> 0] = 1;
 HEAP32[i21 >> 2] = i27;
 HEAP32[i22 >> 2] = 5;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i27, i23, i1);
 mftCall_iiii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i21 >> 2] | 0, i23 | 0) | 0;
 i6 = i19 + 4 | 0;
 i7 = i25 + 4 | 0;
 i8 = i25 + 12 | 0;
 i9 = i25 + 16 | 0;
 i10 = i20 + 4 | 0;
 i11 = i20 + 8 | 0;
 i12 = i20 + 12 | 0;
 i13 = i20 + 16 | 0;
 i14 = i20 + 20 | 0;
 i15 = i20 + 24 | 0;
 i16 = i19 + 4 | 0;
 i17 = i19 + 8 | 0;
 i18 = 0;
 do {
  i5 = HEAP32[(HEAP32[i21 >> 2] | 0) + (i18 << 2) >> 2] | 0;
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   i2 = 0;
  } else {
   i3 = i2 + -1 | 0;
   i4 = HEAP32[i1 + 4 >> 2] | 0;
   if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
    i2 = HEAP32[i25 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   } else i3 = i1;
  }
  HEAP32[i19 >> 2] = gb + 690295;
  HEAP8[i6 >> 0] = 0;
  i1 = i3 + 8 | 0;
  if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i30 = i19;
   i29 = HEAP32[i30 + 4 >> 2] | 0;
   i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i30 >> 2];
   HEAP32[i4 + 4 >> 2] = i29;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0) {
   i3 = HEAP32[i25 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i29 = HEAP32[i8 >> 2] | 0;
   i30 = HEAP32[i9 >> 2] | 0;
   __ZN5physx20PxShapeGeneratedInfoC2Ev(i19);
   HEAP32[i20 >> 2] = i3;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = i29;
   HEAP32[i13 >> 2] = i30;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j(i19, i20, 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0) | 0)) {
    i30 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i24 >> 2] = gb + 673430;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i30, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i24);
   }
   i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i5 | 0) | 0;
   i4 = getTempRet0() | 0;
   i3 = (i2 | 0) == 0 & (i4 | 0) == 0;
   i30 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i19 >> 2] = gb + 690295;
   HEAP32[i16 >> 2] = i5;
   i29 = i17;
   HEAP32[i29 >> 2] = i3 ? i5 : i2;
   HEAP32[i29 + 4 >> 2] = i3 ? 0 : i4;
   mftCall_viii(i30 | 0, i1 | 0, gb + 673430 | 0, i19 | 0);
  }
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
    i2 = HEAP32[i7 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
    i2 = HEAP32[i25 >> 2] | 0;
    i1 = i2;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
   }
   HEAP32[i1 + 8 >> 2] = i2 + -1;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i23 | 0));
 i30 = HEAP32[i22 >> 2] | 0;
 do if ((i30 | 0) > -1 & (i30 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if ((i27 | 0) == (i1 | 0)) {
   HEAP8[i26 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i30 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i30 >> 2] | 0) + 12 >> 2] | 0, i30 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i28;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContaineraSERKS1_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = (i10 | 0) == (i9 | 0);
 do if (!i8) {
  i5 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
  i5 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
  i3 = i10 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
  } else {
   if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i10 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i3 >> 0] = i5;
    break;
   }
  } while (0);
  i1 = i10 + 16 | 0;
  i6 = i9 + 16 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i9 + 20 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 20 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i10 + 32 >> 2] = HEAP32[i9 + 32 >> 2];
 i7 = i10 + 36 | 0;
 i1 = i9 + 36 | 0;
 if (i8) {
  i1 = i9 + 84 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = i10 + 84 | 0;
  HEAP32[i5 >> 2] = i1;
  i5 = i10 + 88 | 0;
  i1 = i9 + 88 | 0;
  i2 = i5;
  i3 = i1;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i5 + 36 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
  return i10 | 0;
 }
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i9 + 40 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i10 + 44 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i10 + 40 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 40 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 i1 = i10 + 52 | 0;
 i6 = i9 + 52 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 56 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i10 + 60 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i10 + 56 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 56 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10 + 68 | 0, HEAP32[i9 + 68 >> 2] | 0, HEAP32[i9 + 72 >> 2] | 0);
 i1 = i9 + 84 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = i10 + 84 | 0;
 HEAP32[i5 >> 2] = i1;
 i5 = i10 + 88 | 0;
 i1 = i9 + 88 | 0;
 i2 = i5;
 i3 = i1;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i5 + 36 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
 return i10 | 0;
}

function __ZNSt3__29__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE(i2, i13, i14, i15, i16, i12, i1) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i17;
 i10 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474556 | 0) | 0;
 i5 = __ZNKSt3__26locale9use_facetERNS0_2idE(i1, gb + 1474572 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i18 | 0, i5 | 0);
 i8 = i18 + 11 | 0;
 i7 = HEAP8[i8 >> 0] | 0;
 i9 = i18 + 4 | 0;
 L1 : do if (!((i7 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i7 & 255) | 0)) {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i2 | 0, i14 | 0, i15 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i11 = 31;
   break;
  } else {
   i1 = i15 + (i14 - i2) | 0;
   HEAP32[i12 >> 2] = i1;
   i11 = 30;
   break;
  }
 } else {
  HEAP32[i12 >> 2] = i15;
  i1 = HEAP8[i2 >> 0] | 0;
  switch (i1 << 24 >> 24) {
  case 43:
  case 45:
   {
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) {
     i4 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i1;
     i4 = i2 + 1 | 0;
     i11 = 9;
    }
    break;
   }
  default:
   {
    i4 = i2;
    i11 = 9;
   }
  }
  L10 : do if ((i11 | 0) == 9) {
   L12 : do if ((i14 - i4 | 0) > 1) if ((HEAP8[i4 >> 0] | 0) == 48) {
    i1 = i4 + 1 | 0;
    switch (HEAP8[i1 >> 0] | 0) {
    case 88:
    case 120:
     break;
    default:
     break L12;
    }
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, 48) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) break L10;
    i7 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i7 + 1;
    HEAP8[i7 >> 0] = i3;
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i1 >> 0] | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) break L10;
    i7 = HEAP32[i12 >> 2] | 0;
    HEAP32[i12 >> 2] = i7 + 1;
    HEAP8[i7 >> 0] = i1;
    i4 = i4 + 2 | 0;
   } while (0);
   L19 : do if ((i4 | 0) != (i14 | 0)) {
    i1 = i14;
    i3 = i4;
    while (1) {
     i1 = i1 + -1 | 0;
     if (i3 >>> 0 >= i1 >>> 0) break L19;
     i7 = HEAP8[i3 >> 0] | 0;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = i7;
     i3 = i3 + 1 | 0;
    }
   } while (0);
   __THREW__ = 0;
   i7 = invoke_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    i6 = i4;
    i1 = 0;
    i3 = 0;
    while (1) {
     if (i6 >>> 0 >= i14 >>> 0) break;
     i5 = HEAP8[((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18) + i1 >> 0] | 0;
     if (i5 << 24 >> 24 != 0 & (i3 | 0) == (i5 << 24 >> 24 | 0)) {
      i3 = HEAP32[i12 >> 2] | 0;
      HEAP32[i12 >> 2] = i3 + 1;
      HEAP8[i3 >> 0] = i7;
      i3 = HEAP8[i8 >> 0] | 0;
      i1 = (i1 >>> 0 < ((i3 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i3 & 255) + -1 | 0) >>> 0 & 1) + i1 | 0;
      i3 = 0;
     }
     __THREW__ = 0;
     i5 = invoke_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, HEAP8[i6 >> 0] | 0) | 0;
     i19 = __THREW__;
     __THREW__ = 0;
     if (i19 & 1) {
      i11 = 26;
      break;
     }
     i19 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i19 + 1;
     HEAP8[i19 >> 0] = i5;
     i6 = i6 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
    if ((i11 | 0) == 26) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     i11 = 31;
     break L1;
    }
    i3 = i2;
    i1 = i15 + (i4 - i3) | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i2 = i3;
     i11 = 30;
     break L1;
    }
    while (1) {
     i2 = i2 + -1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break;
     i19 = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP8[i2 >> 0] = i19;
     i1 = i1 + 1 | 0;
    }
    i2 = i3;
    i1 = HEAP32[i12 >> 2] | 0;
    i11 = 30;
    break L1;
   }
  } while (0);
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i11 = 31;
 } while (0);
 if ((i11 | 0) == 30) {
  HEAP32[i16 >> 2] = (i13 | 0) == (i14 | 0) ? i1 : i15 + (i13 - i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  STACKTOP = i17;
  return;
 } else if ((i11 | 0) == 31) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  ___resumeException(i1 | 0);
 }
}

function __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, f22 = f0;
 f18 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f19 = Math_fround(Math_fround(1.0) - f18);
 i20 = HEAP32[i1 + 4 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i17 = i1 + 20 | 0;
 i16 = HEAP32[i1 + 16 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 while (1) {
  i11 = i16 >>> 16 << 2;
  f12 = Math_fround(Math_fround((i16 & 65535) >>> 0) * Math_fround(.0000152587891));
  f13 = Math_fround(Math_fround(1.0) - f12);
  i14 = i11 + 4 | 0;
  i10 = 0;
  do {
   i6 = i10 + i11 | 0;
   i4 = HEAPU16[i20 + (i6 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L8 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L10 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L10;
     }
     f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     break L8;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L10;
     }
     i1 = i1 | 1879048192;
     break L8;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f9 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = i14 + i10 | 0;
   i4 = HEAPU16[i20 + (i7 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L17 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L19 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L19;
     }
     f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     break L17;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L19;
     }
     i1 = i1 | 1879048192;
     break L17;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f8 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAPU16[i21 + (i6 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L26 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L28 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L28;
     }
     f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     break L26;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L28;
     }
     i1 = i1 | 1879048192;
     break L26;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f5 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAPU16[i21 + (i7 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L35 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L37 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L37;
     }
     f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     break L35;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L37;
     }
     i1 = i1 | 1879048192;
     break L35;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f22 = Math_fround(Math_fround(f19 * Math_fround(Math_fround(f13 * f9) + Math_fround(f12 * f8))) + Math_fround(f18 * Math_fround(Math_fround(f13 * f5) + Math_fround(f12 * (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = i6 >>> 23 & 255;
   HEAP16[i15 + (i10 << 1) >> 1] = i6 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i7 << 1) >> 1] | 0) | (i6 & 8388607) >>> (HEAPU8[gb + 1546331 + i7 >> 0] | 0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != 4);
  i2 = i2 + -1 | 0;
  if (!i2) break; else {
   i16 = (HEAP32[i17 >> 2] | 0) + i16 | 0;
   i15 = i15 + 8 | 0;
  }
 }
 return;
}

function __ZN21ArchiveStorageCreator18AppendDataFromFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_N20ArchiveStorageHeader9NodeFlagsE(i16, i20, i3, i5) {
 i16 = i16 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 2176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 16 | 0;
 i2 = i25 + 8 | 0;
 i24 = i25 + 1104 | 0;
 i23 = i25 + 36 | 0;
 i18 = i25;
 i21 = i25 + 24 | 0;
 if (!(HEAP8[i16 + 1320 >> 0] | 0)) {
  if ((HEAP8[i16 + 11 >> 0] | 0) < 0) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
  HEAP32[i2 >> 2] = i1;
  __Z6FormatPKcz(i24, gb + 490305 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i24 + 11 >> 0] | 0) < 0 ? HEAP32[i24 >> 2] | 0 : i24, 0, gb + 490375 | 0, 655, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i24);
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 i17 = i20 + 11 | 0;
 __ZN15FileSystemEntryC2EPKc(i24, (HEAP8[i17 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20);
 i4 = __ZNK15FileSystemEntry5IsDirEv(i24) | 0;
 if (i4) {
  i14 = 0;
  i15 = 0;
 } else {
  i14 = __ZNK15FileSystemEntry4SizeEv(i24) | 0;
  i15 = getTempRet0() | 0;
 }
 i13 = HEAP32[i16 + 1212 >> 2] | 0;
 i1 = i13;
 if ((i13 | 0) == (HEAP32[i16 + 1208 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i1 + -40 | 0;
  i1 = i1 + -32 | 0;
  i1 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i2 = getTempRet0() | 0;
 }
 i1 = __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy(i16, i3, i4 & 1 | i5, i1, i2, i14, i15) | 0;
 if (!(i4 | i1 ^ 1)) {
  __ZN12FileAccessorC2Ev(i23);
  L17 : do if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i23, i24, 0, 0) | 0) {
   i3 = i16 + 1316 | 0;
   if (!(HEAP16[i3 >> 1] & 64)) i9 = HEAP32[i16 + 1256 >> 2] | 0; else i9 = 131072;
   if ((i14 | 0) == 0 & (i15 | 0) == 0) i1 = 1; else {
    i4 = i16 + 1280 | 0;
    i5 = i16 + 1284 | 0;
    i6 = i16 + 1268 | 0;
    i7 = i16 + 1272 | 0;
    i10 = 0;
    i11 = 0;
    while (1) {
     i8 = HEAP32[i4 >> 2] | 0;
     i12 = i9 - i8 | 0;
     i2 = _i64Subtract(i14 | 0, i15 | 0, i10 | 0, i11 | 0) | 0;
     i13 = getTempRet0() | 0;
     i1 = i13 >>> 0 < 0 | (i13 | 0) == 0 & i2 >>> 0 < i12 >>> 0;
     i12 = i1 ? i2 : i12;
     i13 = i1 ? i13 : 0;
     i1 = _i64Add(i12 | 0, i13 | 0, i8 | 0, 0) | 0;
     getTempRet0() | 0;
     HEAP32[i4 >> 2] = i1;
     i2 = HEAP32[i5 >> 2] | 0;
     do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i5 >> 2] = i1;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 1, i7, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i6 >> 2] = i1;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i7, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i5 >> 2] = i1;
      HEAP32[i6 >> 2] = i2;
      i1 = i2;
      break;
     } else i1 = HEAP32[i6 >> 2] | 0; while (0);
     i2 = __ZN12FileAccessor4ReadEyPvPy(i23, i12, i13, i1 + i8 | 0, i18) | 0;
     i8 = i18;
     if (!(i2 & ((i12 | 0) == (HEAP32[i8 >> 2] | 0) ? (i13 | 0) == (HEAP32[i8 + 4 >> 2] | 0) : 0))) {
      i19 = 22;
      break;
     }
     if (!(HEAP16[i3 >> 1] & 64)) {
      if ((HEAP32[i4 >> 2] | 0) == (i9 | 0)) i19 = 28;
     } else i19 = 28;
     if ((i19 | 0) == 28) {
      i19 = 0;
      if (!(__ZN21ArchiveStorageCreator17StoreCurrentBlockEb(i16, 0) | 0)) break;
     }
     i10 = _i64Add(i12 | 0, i13 | 0, i10 | 0, i11 | 0) | 0;
     i11 = getTempRet0() | 0;
     if (!(i15 >>> 0 > i11 >>> 0 | (i15 | 0) == (i11 | 0) & i14 >>> 0 > i10 >>> 0)) {
      i1 = 1;
      break L17;
     }
    }
    if ((i19 | 0) == 22) {
     if ((HEAP8[i16 + 11 >> 0] | 0) < 0) i1 = HEAP32[i16 >> 2] | 0; else i1 = i16;
     HEAP32[i22 >> 2] = (HEAP8[i17 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20;
     HEAP32[i22 + 4 >> 2] = i1;
     __Z6FormatPKcz(i21, gb + 491380 | 0, i22);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 490375 | 0, 393, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
    }
    i1 = 0;
   }
  } else i1 = 0; while (0);
  __ZN12FileAccessorD2Ev(i23);
 }
 __ZN13FileEntryDataD2Ev(i24);
 i24 = i1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN5physx6shdfnd7FastIPCC2ERNS0_5PxIPC9ErrorCodeENS2_14ConnectionTypeEPKcjjbbj(i21, i15, i14, i4, i20, i19, i12, i13, i16) {
 i21 = i21 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0, i18 = 0, i22 = 0, i23 = 0;
 HEAP32[i21 >> 2] = gb + 151112 + 8;
 i1 = i21 + 20 | 0;
 i5 = i21 + 64 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i21 + 60 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i21 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP16[i8 + 12 >> 1] = 0;
 i18 = i21 + 72 | 0;
 i9 = i21 + 116 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i21 + 112 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i21 + 96 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP16[i11 + 12 >> 1] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i15 >> 2] = 7;
 i6 = i21 + 12 | 0;
 HEAP8[i6 >> 0] = 0;
 i2 = i21 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i23 | 0, i22 | 0, 4, (i3 ? gb + 777710 | 0 : gb + 837976 | 0) | 0, gb + 777634 | 0, 72) | 0;
 __ZN5physx6shdfnd16MemoryMappedFileC2EPKcj(i3, i4, i20 + 28 + i19 | 0);
 HEAP32[i21 + 132 >> 2] = i3;
 if (!i3) {
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = i3;
 } else {
  i3 = __ZN5physx6shdfnd16MemoryMappedFile14getBaseAddressEv(i3) | 0;
  HEAP32[i2 >> 2] = i3;
  i2 = i3;
 }
 if (!i2) {
  HEAP32[i15 >> 2] = 8;
  return;
 }
 i23 = i2 + 28 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i12 = i12 & 1;
 HEAP8[i21 + 56 >> 0] = i12;
 i22 = i13 & 1;
 HEAP8[i21 + 57 >> 0] = i22;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i8 >> 2] = (i20 >>> 1) + -9;
 HEAP32[i21 + 24 >> 2] = i20;
 HEAP32[i1 >> 2] = i23;
 HEAP8[i21 + 68 >> 0] = 0;
 HEAP32[i21 + 28 >> 2] = 0;
 HEAP32[i21 + 32 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 HEAP32[i21 + 52 >> 2] = 0;
 HEAP32[i21 + 36 >> 2] = i3 + 8;
 HEAP32[i21 + 40 >> 2] = i3 + 12;
 HEAP32[i9 >> 2] = 0;
 HEAP8[i21 + 108 >> 0] = i12;
 HEAP8[i21 + 109 >> 0] = i22;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i11 >> 2] = (i19 >>> 1) + -9;
 HEAP32[i21 + 76 >> 2] = i19;
 HEAP32[i18 >> 2] = i23 + i20;
 HEAP8[i21 + 120 >> 0] = 0;
 HEAP32[i21 + 80 >> 2] = 0;
 HEAP32[i21 + 84 >> 2] = 0;
 HEAP32[i21 + 100 >> 2] = 0;
 HEAP32[i21 + 104 >> 2] = 0;
 HEAP32[i21 + 88 >> 2] = i3 + 20;
 HEAP32[i21 + 92 >> 2] = i3 + 24;
 switch (i14 | 0) {
 case 1:
 case 0:
  {
   if (HEAP8[i3 + 1 >> 0] | 0) {
    HEAP32[i15 >> 2] = 3;
    return;
   }
   do if (!(HEAP8[i3 >> 0] | 0)) {
    if ((i14 | 0) == 1) {
     HEAP32[i15 >> 2] = 5;
     return;
    }
   } else {
    if ((HEAP32[i3 + 16 >> 2] | 0) == (i19 | 0)) if ((HEAP32[i3 + 4 >> 2] | 0) == (i20 | 0)) break;
    HEAP32[i15 >> 2] = 6;
    return;
   } while (0);
   if (HEAP32[i15 >> 2] | 0) return;
   HEAP8[i3 + 1 >> 0] = 1;
   HEAP32[i3 + 16 >> 2] = i19;
   if (!(HEAP8[i3 >> 0] | 0)) HEAP32[i3 + 4 >> 2] = i20;
   HEAP32[i21 + 128 >> 2] = i1;
   HEAP32[i21 + 124 >> 2] = i18;
   return;
  }
 case 2:
  {
   if (HEAP8[i3 >> 0] | 0) {
    HEAP32[i15 >> 2] = 2;
    return;
   }
   do if (HEAP8[i3 + 1 >> 0] | 0) {
    if ((HEAP32[i3 + 16 >> 2] | 0) == (i19 | 0)) if ((HEAP32[i3 + 4 >> 2] | 0) == (i20 | 0)) break;
    HEAP32[i15 >> 2] = 6;
    return;
   } while (0);
   if (HEAP32[i15 >> 2] | 0) return;
   HEAP8[i3 >> 0] = 1;
   HEAP32[i3 + 16 >> 2] = i19;
   if (!(HEAP8[i3 + 1 >> 0] | 0)) HEAP32[i3 + 4 >> 2] = i20;
   HEAP32[i21 + 124 >> 2] = i1;
   HEAP32[i21 + 128 >> 2] = i18;
   HEAP8[i6 >> 0] = 1;
   return;
  }
 case 3:
  {
   if (HEAP8[i3 + 1 >> 0] | 0) if (HEAP8[i3 >> 0] | 0) {
    HEAP32[i15 >> 2] = 4;
    return;
   }
   if (!(HEAP8[i3 >> 0] | 0)) {
    if (HEAP8[i3 + 1 >> 0] | 0) i17 = 33;
   } else i17 = 33;
   do if ((i17 | 0) == 33) {
    if ((HEAP32[i3 + 16 >> 2] | 0) == (i19 | 0)) if ((HEAP32[i3 + 4 >> 2] | 0) == (i20 | 0)) break;
    HEAP32[i15 >> 2] = 6;
    return;
   } while (0);
   if (HEAP32[i15 >> 2] | 0) return;
   if (!(HEAP8[i3 >> 0] | 0)) {
    HEAP8[i3 >> 0] = 1;
    HEAP32[i3 + 16 >> 2] = i19;
    HEAP8[i6 >> 0] = 1;
    i2 = i18;
   } else {
    HEAP8[i3 + 1 >> 0] = 1;
    HEAP32[i3 + 4 >> 2] = i19;
    i2 = i1;
    i1 = i18;
   }
   HEAP32[i21 + 124 >> 2] = i1;
   HEAP32[i21 + 128 >> 2] = i2;
   HEAP32[i3 + 16 >> 2] = i19;
   HEAP32[i3 + 4 >> 2] = i20;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx18PxcArticulationRef16propagateImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE(i3, i6, i5, i1, i2, i4) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 * f11);
 f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 i21 = i2 + 4 | 0;
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f12 = Math_fround(f7 + Math_fround(f12 * f10));
 f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i20 = i2 + 8 | 0;
 f15 = Math_fround(HEAPF32[i20 >> 2]);
 f7 = Math_fround(f12 + Math_fround(f7 * f15));
 f12 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 i19 = i2 + 16 | 0;
 f16 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(f12 * f16);
 f23 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 i18 = i2 + 20 | 0;
 f24 = Math_fround(HEAPF32[i18 >> 2]);
 f23 = Math_fround(f12 + Math_fround(f23 * f24));
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 i17 = i2 + 24 | 0;
 f14 = Math_fround(HEAPF32[i17 >> 2]);
 f12 = Math_fround(f7 + Math_fround(f23 + Math_fround(f12 * f14)));
 f23 = Math_fround(f11 * Math_fround(HEAPF32[i4 + 32 >> 2]));
 f23 = Math_fround(f23 + Math_fround(f10 * Math_fround(HEAPF32[i4 + 36 >> 2])));
 f23 = Math_fround(f23 + Math_fround(f15 * Math_fround(HEAPF32[i4 + 40 >> 2])));
 f7 = Math_fround(f16 * Math_fround(HEAPF32[i4 + 48 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f24 * Math_fround(HEAPF32[i4 + 52 >> 2])));
 f7 = Math_fround(f23 + Math_fround(f7 + Math_fround(f14 * Math_fround(HEAPF32[i4 + 56 >> 2]))));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i4 + 64 >> 2]));
 f10 = Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i4 + 68 >> 2])));
 f15 = Math_fround(f10 + Math_fround(f15 * Math_fround(HEAPF32[i4 + 72 >> 2])));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i4 + 80 >> 2]));
 f24 = Math_fround(f16 + Math_fround(f24 * Math_fround(HEAPF32[i4 + 84 >> 2])));
 f14 = Math_fround(f15 + Math_fround(f24 + Math_fround(f14 * Math_fround(HEAPF32[i4 + 88 >> 2]))));
 HEAPF32[i1 >> 2] = f12;
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f14;
 f24 = Math_fround(f12 * Math_fround(HEAPF32[i6 >> 2]));
 f15 = Math_fround(f12 * Math_fround(HEAPF32[i6 + 4 >> 2]));
 f16 = Math_fround(f12 * Math_fround(HEAPF32[i6 + 8 >> 2]));
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i6 + 16 >> 2]));
 f11 = Math_fround(f12 * Math_fround(HEAPF32[i6 + 20 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i6 + 24 >> 2]));
 f23 = Math_fround(f7 * Math_fround(HEAPF32[i6 + 32 >> 2]));
 f22 = Math_fround(f7 * Math_fround(HEAPF32[i6 + 36 >> 2]));
 f13 = Math_fround(f7 * Math_fround(HEAPF32[i6 + 40 >> 2]));
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i6 + 48 >> 2]));
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i6 + 52 >> 2]));
 f23 = Math_fround(f24 + f23);
 f22 = Math_fround(f15 + f22);
 f13 = Math_fround(f16 + f13);
 f8 = Math_fround(f10 + f8);
 f9 = Math_fround(f11 + f9);
 f7 = Math_fround(f12 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 56 >> 2])));
 f12 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 64 >> 2]));
 f11 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 68 >> 2]));
 f10 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 72 >> 2]));
 f16 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 80 >> 2]));
 f15 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 84 >> 2]));
 f12 = Math_fround(f23 + f12);
 f11 = Math_fround(f22 + f11);
 f10 = Math_fround(f13 + f10);
 f16 = Math_fround(f8 + f16);
 f15 = Math_fround(f9 + f15);
 f14 = Math_fround(f7 + Math_fround(f14 * Math_fround(HEAPF32[i6 + 88 >> 2])));
 f12 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f12);
 f11 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f11);
 f10 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f10);
 f16 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f16);
 f15 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f15);
 f14 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f14);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f9 = Math_fround(f10 * f7);
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f11 * f8));
 f8 = Math_fround(f12 * f8);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f16 + f9);
 f8 = Math_fround(f15 + Math_fround(f8 - Math_fround(f10 * f13)));
 f7 = Math_fround(f14 + Math_fround(Math_fround(f11 * f13) - Math_fround(f12 * f7)));
 HEAPF32[i3 >> 2] = f12;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 16 >> 2] = f9;
 HEAPF32[i3 + 20 >> 2] = f8;
 HEAPF32[i3 + 24 >> 2] = f7;
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i17, i1, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 20 | 0;
 i15 = i18 + 16 | 0;
 i7 = i18 + 12 | 0;
 i8 = i18 + 8 | 0;
 i11 = i18 + 4 | 0;
 i12 = i18;
 i10 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 i13 = (i14 - i10 | 0) / 28 | 0;
 i9 = i17 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = i10;
 i6 = i3;
 if (i13 >>> 0 > ((i1 - i3 | 0) / 28 | 0) >>> 0) {
  if (i3) {
   i5 = i17 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) i1 = i3; else {
    i2 = i1;
    do {
     i4 = i2 + -28 | 0;
     HEAP32[i5 >> 2] = i4;
     __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + -16 | 0, HEAP32[i2 + -12 >> 2] | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) {
      i3 = i2 + -24 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if ((i2 | 0) != (i1 | 0)) {
       do {
        i8 = i2 + -872 | 0;
        HEAP32[i3 >> 2] = i8;
        __ZN9ShaderLab14SerializedPassD2Ev(i8);
        i2 = HEAP32[i3 >> 2] | 0;
       } while ((i2 | 0) != (i1 | 0));
       i1 = HEAP32[i4 >> 2] | 0;
      }
      __ZdlPv(i1);
     }
     i2 = HEAP32[i5 >> 2] | 0;
    } while ((i2 | 0) != (i6 | 0));
    i1 = HEAP32[i17 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   i1 = 0;
  }
  if (i13 >>> 0 > 153391689) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i17);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
  } else i2 = 0;
  i8 = (i1 - i2 | 0) / 28 | 0;
  i1 = i8 << 1;
  i1 = i8 >>> 0 < 76695844 ? (i1 >>> 0 < i13 >>> 0 ? i13 : i1) : 153391689;
  if (i1 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i17);
  i8 = __Znwj(i1 * 28 | 0) | 0;
  HEAP32[i17 + 4 >> 2] = i8;
  HEAP32[i17 >> 2] = i8;
  HEAP32[i9 >> 2] = i8 + (i1 * 28 | 0);
  HEAP32[i11 >> 2] = i10;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
  __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i17, i15, i16, i13);
  STACKTOP = i18;
  return;
 } else {
  i9 = i17 + 4 | 0;
  i4 = ((HEAP32[i9 >> 2] | 0) - i3 | 0) / 28 | 0;
  i5 = i13 >>> 0 > i4 >>> 0;
  i4 = i5 ? i2 + (i4 * 28 | 0) | 0 : i14;
  i3 = i4;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i6;
   do {
    if ((i1 | 0) != (i2 | 0)) __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
    __ZN9ShaderLab16SerializedTagMapaSERKS0_(i1 + 12 | 0, i2 + 12 | 0) | 0;
    HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    i2 = i2 + 28 | 0;
    i1 = i1 + 28 | 0;
   } while ((i2 | 0) != (i3 | 0));
   i6 = i1;
  }
  if (i5) {
   HEAP32[i7 >> 2] = i4;
   HEAP32[i8 >> 2] = i14;
   i14 = i13 - (((HEAP32[i9 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0) / 28 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
   __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i17, i15, i16, i14);
   STACKTOP = i18;
   return;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i6 | 0)) {
   STACKTOP = i18;
   return;
  }
  do {
   i3 = i1 + -28 | 0;
   HEAP32[i9 >> 2] = i3;
   __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + -16 | 0, HEAP32[i1 + -12 >> 2] | 0);
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) {
    i2 = i1 + -24 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
     do {
      i17 = i1 + -872 | 0;
      HEAP32[i2 >> 2] = i17;
      __ZN9ShaderLab14SerializedPassD2Ev(i17);
      i1 = HEAP32[i2 >> 2] | 0;
     } while ((i1 | 0) != (i4 | 0));
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZdlPv(i1);
   }
   i1 = HEAP32[i9 >> 2] | 0;
  } while ((i1 | 0) != (i6 | 0));
  STACKTOP = i18;
  return;
 }
}

function __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRGHalfEEvPKNS_9InnerInfoE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, f22 = f0;
 f18 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f19 = Math_fround(Math_fround(1.0) - f18);
 i20 = HEAP32[i1 + 4 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i17 = i1 + 20 | 0;
 i16 = HEAP32[i1 + 16 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 while (1) {
  i11 = i16 >>> 16 << 1;
  f12 = Math_fround(Math_fround((i16 & 65535) >>> 0) * Math_fround(.0000152587891));
  f13 = Math_fround(Math_fround(1.0) - f12);
  i14 = i11 + 2 | 0;
  i10 = 0;
  do {
   i6 = i10 + i11 | 0;
   i4 = HEAPU16[i20 + (i6 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L8 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L10 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L10;
     }
     f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
     break L8;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L10;
     }
     i1 = i1 | 1879048192;
     break L8;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f9 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i7 = i14 + i10 | 0;
   i4 = HEAPU16[i20 + (i7 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L17 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L19 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L19;
     }
     f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
     break L17;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L19;
     }
     i1 = i1 | 1879048192;
     break L17;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f8 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAPU16[i21 + (i6 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L26 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L28 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L28;
     }
     f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
     break L26;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L28;
     }
     i1 = i1 | 1879048192;
     break L26;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f5 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAPU16[i21 + (i7 << 1) >> 1] | 0;
   i1 = i4 & 32767;
   L35 : do if (!i1) i1 = 0; else {
    i1 = i1 << 13;
    i3 = i1 & 260046848;
    L37 : do if ((i3 | 0) < 260046848) {
     switch (i3 | 0) {
     case 0:
      break;
     default:
      break L37;
     }
     f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
     i1 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
     break L35;
    } else {
     switch (i3 | 0) {
     case 260046848:
      break;
     default:
      break L37;
     }
     i1 = i1 | 1879048192;
     break L35;
    } while (0);
    i1 = i1 + 939524096 | 0;
   } while (0);
   f22 = Math_fround(Math_fround(f19 * Math_fround(Math_fround(f13 * f9) + Math_fround(f12 * f8))) + Math_fround(f18 * Math_fround(Math_fround(f13 * f5) + Math_fround(f12 * (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
   i6 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = i6 >>> 23 & 255;
   HEAP16[i15 + (i10 << 1) >> 1] = i6 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i7 << 1) >> 1] | 0) | (i6 & 8388607) >>> (HEAPU8[gb + 1546331 + i7 >> 0] | 0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != 2);
  i2 = i2 + -1 | 0;
  if (!i2) break; else {
   i16 = (HEAP32[i17 >> 2] | 0) + i16 | 0;
   i15 = i15 + 4 | 0;
  }
 }
 return;
}

function __ZN9Scripting25BroadcastScriptingMessageER10GameObjectPKcP12Il2CppObject(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i15 = i16 + 16 | 0;
 i3 = __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(i1, i8, i9) | 0;
 i2 = i3 & 1;
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if (!i4) {
  i15 = i3;
  STACKTOP = i16;
  return i15 | 0;
 }
 i5 = HEAP32[i4 + 92 >> 2] | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i13;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i15 >> 2] = 0;
 i7 = i15 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i10 = i15 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i13);
 i6 = i12;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 i3 = HEAP32[i10 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i10 >> 2] = i5;
  HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i5 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i15 >> 2] = i6;
  break;
 } while (0);
 if (i5 >>> 0 > i1 >>> 0) _memset((HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0, 0, i5 - i1 << 2 | 0) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i5 | 0) > 0) {
  i4 = HEAP32[i4 + 80 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i4 + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0) + 4 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 }
 if (HEAP32[i7 >> 2] | 0) {
  i6 = i1;
  do {
   i1 = HEAP32[i6 >> 2] | 0;
   do if (i1) {
    HEAP32[i13 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i14 = 22; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i5 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
      i5 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
      i1 = i4;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i14 = 22; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i14 = 24;
    }
    if ((i14 | 0) == 22) i14 = 24;
    if ((i14 | 0) == 24) {
     i14 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
    if (!i1) i14 = 31; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
      i3 = HEAP32[i12 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 31; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i14 = 33;
     }
    }
    if ((i14 | 0) == 31) i14 = 33;
    if ((i14 | 0) == 33) {
     i14 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    }
    i2 = ((__ZN9Scripting25BroadcastScriptingMessageER10GameObjectPKcP12Il2CppObject(i1, i8, i9) | 0) & 1 | i2 & 1) & 255;
   } while (0);
   i6 = i6 + 4 | 0;
   i1 = HEAP32[i15 >> 2] | 0;
  } while ((i6 | 0) != (i1 + (HEAP32[i7 >> 2] << 2) | 0));
 }
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
  HEAP32[i15 >> 2] = 0;
 }
 i15 = (i2 & 1) != 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN7mecanim9animation21SkeletonPoseFromValueIN4math4trsXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTIS3_EERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib(i4, i1, i5, i22, i2, i12, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i21 = i1 + 4 | 0;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = (i20 | 0) == 0 ? 0 : i20 + i21 | 0;
 i20 = i2 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i20 = (i1 | 0) == 0 ? 0 : i1 + i20 | 0;
 i1 = i3 & 1;
 i15 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= i15 >>> 0) return;
 i16 = i5 + 20 | 0;
 i17 = i16;
 i18 = i5 + 12 | 0;
 i19 = i18;
 i13 = i5 + 4 | 0;
 i14 = i13;
 if (!i12) {
  i10 = i1;
  do {
   i1 = HEAP32[i22 + (i10 * 12 | 0) >> 2] | 0;
   if ((i1 | 0) == -1) {
    i11 = i21 + (i10 * 40 | 0) | 0;
    i2 = i21 + (i10 * 40 | 0) + 4 | 0;
    i1 = i21 + (i10 * 40 | 0) + 8 | 0;
   } else {
    i12 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
    i11 = i12 + (i1 * 12 | 0) | 0;
    i2 = i12 + (i1 * 12 | 0) + 4 | 0;
    i1 = i12 + (i1 * 12 | 0) + 8 | 0;
   }
   i9 = HEAP32[i1 >> 2] | 0;
   i8 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i22 + (i10 * 12 | 0) + 4 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i5 = HEAP32[i21 + (i10 * 40 | 0) + 12 >> 2] | 0;
    i6 = HEAP32[i21 + (i10 * 40 | 0) + 16 >> 2] | 0;
    i7 = HEAP32[i21 + (i10 * 40 | 0) + 20 >> 2] | 0;
    i2 = HEAP32[i21 + (i10 * 40 | 0) + 24 >> 2] | 0;
   } else {
    i2 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
    i5 = HEAP32[i2 + (i1 << 4) >> 2] | 0;
    i6 = HEAP32[i2 + (i1 << 4) + 4 >> 2] | 0;
    i7 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
    i2 = HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0;
   }
   i1 = HEAP32[i22 + (i10 * 12 | 0) + 8 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i3 = HEAP32[i21 + (i10 * 40 | 0) + 28 >> 2] | 0;
    i4 = HEAP32[i21 + (i10 * 40 | 0) + 32 >> 2] | 0;
    i1 = HEAP32[i21 + (i10 * 40 | 0) + 36 >> 2] | 0;
   } else {
    i12 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
    i3 = HEAP32[i12 + (i1 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i12 + (i1 * 12 | 0) + 4 >> 2] | 0;
    i1 = HEAP32[i12 + (i1 * 12 | 0) + 8 >> 2] | 0;
   }
   HEAP32[i20 + (i10 * 40 | 0) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i20 + (i10 * 40 | 0) + 4 >> 2] = i8;
   HEAP32[i20 + (i10 * 40 | 0) + 8 >> 2] = i9;
   HEAP32[i20 + (i10 * 40 | 0) + 12 >> 2] = i5;
   HEAP32[i20 + (i10 * 40 | 0) + 16 >> 2] = i6;
   HEAP32[i20 + (i10 * 40 | 0) + 20 >> 2] = i7;
   HEAP32[i20 + (i10 * 40 | 0) + 24 >> 2] = i2;
   HEAP32[i20 + (i10 * 40 | 0) + 28 >> 2] = i3;
   HEAP32[i20 + (i10 * 40 | 0) + 32 >> 2] = i4;
   HEAP32[i20 + (i10 * 40 | 0) + 36 >> 2] = i1;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < i15 >>> 0);
  return;
 }
 do {
  if ((HEAP32[i12 + (i1 << 2) >> 2] | 0) == -1) {
   i2 = HEAP32[i22 + (i1 * 12 | 0) >> 2] | 0;
   if ((i2 | 0) == -1) {
    i11 = i21 + (i1 * 40 | 0) | 0;
    i3 = i21 + (i1 * 40 | 0) + 4 | 0;
    i2 = i21 + (i1 * 40 | 0) + 8 | 0;
   } else {
    i10 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
    i11 = i10 + (i2 * 12 | 0) | 0;
    i3 = i10 + (i2 * 12 | 0) + 4 | 0;
    i2 = i10 + (i2 * 12 | 0) + 8 | 0;
   }
   i10 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i22 + (i1 * 12 | 0) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i6 = HEAP32[i21 + (i1 * 40 | 0) + 12 >> 2] | 0;
    i7 = HEAP32[i21 + (i1 * 40 | 0) + 16 >> 2] | 0;
    i8 = HEAP32[i21 + (i1 * 40 | 0) + 20 >> 2] | 0;
    i3 = HEAP32[i21 + (i1 * 40 | 0) + 24 >> 2] | 0;
   } else {
    i3 = (HEAP32[i18 >> 2] | 0) + i19 | 0;
    i6 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
    i7 = HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0;
    i8 = HEAP32[i3 + (i2 << 4) + 8 >> 2] | 0;
    i3 = HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0;
   }
   i2 = HEAP32[i22 + (i1 * 12 | 0) + 8 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i4 = HEAP32[i21 + (i1 * 40 | 0) + 28 >> 2] | 0;
    i5 = HEAP32[i21 + (i1 * 40 | 0) + 32 >> 2] | 0;
    i2 = HEAP32[i21 + (i1 * 40 | 0) + 36 >> 2] | 0;
   } else {
    i23 = (HEAP32[i16 >> 2] | 0) + i17 | 0;
    i4 = HEAP32[i23 + (i2 * 12 | 0) >> 2] | 0;
    i5 = HEAP32[i23 + (i2 * 12 | 0) + 4 >> 2] | 0;
    i2 = HEAP32[i23 + (i2 * 12 | 0) + 8 >> 2] | 0;
   }
   HEAP32[i20 + (i1 * 40 | 0) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i20 + (i1 * 40 | 0) + 4 >> 2] = i9;
   HEAP32[i20 + (i1 * 40 | 0) + 8 >> 2] = i10;
   HEAP32[i20 + (i1 * 40 | 0) + 12 >> 2] = i6;
   HEAP32[i20 + (i1 * 40 | 0) + 16 >> 2] = i7;
   HEAP32[i20 + (i1 * 40 | 0) + 20 >> 2] = i8;
   HEAP32[i20 + (i1 * 40 | 0) + 24 >> 2] = i3;
   HEAP32[i20 + (i1 * 40 | 0) + 28 >> 2] = i4;
   HEAP32[i20 + (i1 * 40 | 0) + 32 >> 2] = i5;
   HEAP32[i20 + (i1 * 40 | 0) + 36 >> 2] = i2;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i15 >>> 0);
 return;
}

function __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j(i3, i1, i2, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i10 = i11;
 switch (i7 | 0) {
 case 1:
  {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   STACKTOP = i11;
   return;
  }
 case 2:
  {
   __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVE(i4, i3, i3 + 16 | 0, i8);
   f22 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f24 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   f23 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f21 = Math_fround(HEAPF32[i1 >> 2]);
   f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f22 = Math_fround(f22 - f21);
   f24 = Math_fround(f24 - f20);
   f23 = Math_fround(f23 - f19);
   f16 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f18 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f17 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f14 = Math_fround(HEAPF32[i2 >> 2]);
   f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f16 = Math_fround(f16 - f14);
   f18 = Math_fround(f18 - f13);
   f17 = Math_fround(f17 - f12);
   f15 = Math_fround(HEAPF32[i8 >> 2]);
   f20 = Math_fround(Math_fround(f24 * f15) + f20);
   f19 = Math_fround(Math_fround(f23 * f15) + f19);
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(f22 * f15) + f21);
   HEAPF32[i5 + 4 >> 2] = f20;
   HEAPF32[i5 + 8 >> 2] = f19;
   HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
   f13 = Math_fround(Math_fround(f18 * f15) + f13);
   f12 = Math_fround(Math_fround(f17 * f15) + f12);
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(f16 * f15) + f14);
   HEAPF32[i6 + 4 >> 2] = f13;
   HEAPF32[i6 + 8 >> 2] = f12;
   HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
   STACKTOP = i11;
   return;
  }
 case 3:
  {
   __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_(i4, i3, i3 + 16 | 0, i3 + 32 | 0, i9, i10);
   f26 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f30 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   f28 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f27 = Math_fround(HEAPF32[i1 >> 2]);
   f31 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f29 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f26 = Math_fround(f26 - f27);
   f30 = Math_fround(f30 - f31);
   f28 = Math_fround(f28 - f29);
   f25 = Math_fround(HEAPF32[i1 + 32 >> 2]);
   f25 = Math_fround(f25 - f27);
   f12 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) - f31);
   f13 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) - f29);
   f19 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f15 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   f17 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   f18 = Math_fround(HEAPF32[i2 >> 2]);
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f16 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f19 = Math_fround(f19 - f18);
   f15 = Math_fround(f15 - f14);
   f17 = Math_fround(f17 - f16);
   f21 = Math_fround(HEAPF32[i2 + 32 >> 2]);
   f21 = Math_fround(f21 - f18);
   f23 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) - f14);
   f24 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) - f16);
   f20 = Math_fround(HEAPF32[i9 >> 2]);
   f26 = Math_fround(f26 * f20);
   f30 = Math_fround(f30 * f20);
   f28 = Math_fround(f28 * f20);
   f22 = Math_fround(HEAPF32[i10 >> 2]);
   f12 = Math_fround(f31 + Math_fround(f30 + Math_fround(f12 * f22)));
   f13 = Math_fround(f29 + Math_fround(f28 + Math_fround(f13 * f22)));
   HEAPF32[i5 >> 2] = Math_fround(f27 + Math_fround(f26 + Math_fround(f25 * f22)));
   HEAPF32[i5 + 4 >> 2] = f12;
   HEAPF32[i5 + 8 >> 2] = f13;
   HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
   f23 = Math_fround(f14 + Math_fround(Math_fround(f15 * f20) + Math_fround(f23 * f22)));
   f24 = Math_fround(f16 + Math_fround(Math_fround(f17 * f20) + Math_fround(f24 * f22)));
   HEAPF32[i6 >> 2] = Math_fround(f18 + Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * f22)));
   HEAPF32[i6 + 4 >> 2] = f23;
   HEAPF32[i6 + 8 >> 2] = f24;
   HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
   STACKTOP = i11;
   return;
  }
 default:
  {
   STACKTOP = i11;
   return;
  }
 }
}

function __ZN13AnimationClip11ClearCurvesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = HEAP32[i8 + 100 >> 2] | 0;
 i5 = i8 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  do {
   i3 = i1 + -204 | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -192 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i8 + 116 >> 2] | 0;
 i5 = i8 + 120 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  do {
   i2 = i1 + -172 | 0;
   HEAP32[i5 >> 2] = i2;
   i3 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + -160 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i8 + 132 >> 2] | 0;
 i5 = i8 + 136 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  do {
   i2 = i1 + -172 | 0;
   HEAP32[i5 >> 2] = i2;
   i3 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + -160 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i8 + 148 >> 2] | 0;
 i5 = i8 + 152 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  do {
   i2 = i1 + -172 | 0;
   HEAP32[i5 >> 2] = i2;
   i3 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + -160 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i8 + 164 >> 2] | 0;
 i5 = i8 + 168 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  i7 = i9 + 4 | 0;
  do {
   i3 = i1 + -132 | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i1 + -116 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -104 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -120 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i7 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i4 = HEAP32[i8 + 180 >> 2] | 0;
 i5 = i8 + 184 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  __ZN13AnimationClip15ClipWasModifiedEb(i8, 1);
  STACKTOP = i10;
  return;
 }
 i6 = i9 + 4 | 0;
 i7 = i9 + 4 | 0;
 do {
  i3 = i1 + -60 | 0;
  HEAP32[i5 >> 2] = i3;
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -44 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i11 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i1 + -32 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
  }
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i11 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i1 + -48 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN13AnimationClip15ClipWasModifiedEb(i8, 1);
 STACKTOP = i10;
 return;
}

function _compress_output_20(i32, i1) {
 i32 = i32 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i34 + 40 | 0;
 i25 = i34;
 i31 = i32 + 328 | 0;
 i26 = HEAP32[i31 >> 2] | 0;
 i27 = i32 + 248 | 0;
 i28 = (HEAP32[i27 >> 2] | 0) + -1 | 0;
 i33 = i32 + 224 | 0;
 i23 = (HEAP32[i33 >> 2] | 0) + -1 | 0;
 i29 = i32 + 228 | 0;
 i1 = HEAP32[i29 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i3 = i32 + 4 | 0;
  i4 = i26 + 24 | 0;
  i5 = i26 + 8 | 0;
  i2 = 0;
  do {
   i22 = HEAP32[i32 + 232 + (i2 << 2) >> 2] | 0;
   i1 = HEAP32[i22 + 12 >> 2] | 0;
   HEAP32[i24 + (i2 << 2) >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i32 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (HEAP32[i22 + 4 >> 2] << 2) >> 2] | 0, Math_imul(i1, HEAP32[i5 >> 2] | 0) | 0, i1 | 0, 0) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i29 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 i21 = i26 + 16 | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 i22 = i26 + 20 | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 do if ((i3 | 0) < (i4 | 0)) {
  i19 = i26 + 12 | 0;
  i20 = i32 + 348 | 0;
  i2 = i26 + 8 | 0;
  i5 = i4;
  i1 = HEAP32[i19 >> 2] | 0;
  i4 = HEAP32[i27 >> 2] | 0;
  L8 : while (1) {
   if (i1 >>> 0 < i4 >>> 0) {
    do {
     i17 = HEAP32[i29 >> 2] | 0;
     if ((i17 | 0) > 0) {
      i18 = i1 >>> 0 < i28 >>> 0;
      i4 = 0;
      i16 = 0;
      do {
       i5 = HEAP32[i32 + 232 + (i16 << 2) >> 2] | 0;
       i14 = HEAP32[i5 + 52 >> 2] | 0;
       i11 = Math_imul(i14, i1) | 0;
       if (i18) i13 = i14; else i13 = HEAP32[i5 + 68 >> 2] | 0;
       i15 = HEAP32[i5 + 56 >> 2] | 0;
       L20 : do if ((i15 | 0) > 0) {
        i12 = i24 + (i16 << 2) | 0;
        i9 = i5 + 72 | 0;
        i10 = (HEAP32[i2 >> 2] | 0) >>> 0 < i23 >>> 0;
        if ((i13 | 0) > 0) i8 = 0; else {
         i7 = (i14 | 0) > 0;
         i6 = 0;
         while (1) {
          if (i7) {
           i5 = 0;
           do {
            i13 = HEAP32[i26 + 28 + (i4 << 2) >> 2] | 0;
            HEAP32[i25 + (i4 << 2) >> 2] = i13;
            HEAP16[i13 >> 1] = HEAP16[HEAP32[i25 + (i4 + -1 << 2) >> 2] >> 1] | 0;
            i4 = i4 + 1 | 0;
            i5 = i5 + 1 | 0;
           } while ((i5 | 0) < (i14 | 0));
          }
          i6 = i6 + 1 | 0;
          if ((i6 | 0) >= (i15 | 0)) break L20;
         }
        }
        do {
         i5 = i8 + i3 | 0;
         if (i10) i30 = 17; else if ((i5 | 0) < (HEAP32[i9 >> 2] | 0)) i30 = 17; else i5 = 0;
         if ((i30 | 0) == 17) {
          i30 = 0;
          i5 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (i5 << 2) >> 2] | 0) + (i11 << 7) | 0;
          i6 = 0;
          i7 = i4;
          while (1) {
           HEAP32[i25 + (i7 << 2) >> 2] = i5;
           i6 = i6 + 1 | 0;
           if ((i6 | 0) == (i13 | 0)) break; else {
            i5 = i5 + 128 | 0;
            i7 = i7 + 1 | 0;
           }
          }
          i5 = i13;
          i4 = i13 + i4 | 0;
         }
         if ((i5 | 0) < (i14 | 0)) do {
          i7 = HEAP32[i26 + 28 + (i4 << 2) >> 2] | 0;
          HEAP32[i25 + (i4 << 2) >> 2] = i7;
          HEAP16[i7 >> 1] = HEAP16[HEAP32[i25 + (i4 + -1 << 2) >> 2] >> 1] | 0;
          i4 = i4 + 1 | 0;
          i5 = i5 + 1 | 0;
         } while ((i5 | 0) < (i14 | 0));
         i8 = i8 + 1 | 0;
        } while ((i8 | 0) < (i15 | 0));
       } while (0);
       i16 = i16 + 1 | 0;
      } while ((i16 | 0) < (i17 | 0));
     }
     if (!((mftCall_iii(HEAP32[(HEAP32[i20 >> 2] | 0) + 4 >> 2] | 0, i32 | 0, i25 | 0) | 0) << 24 >> 24)) break L8;
     i1 = i1 + 1 | 0;
     i4 = HEAP32[i27 >> 2] | 0;
    } while (i1 >>> 0 < i4 >>> 0);
    i5 = HEAP32[i22 >> 2] | 0;
   }
   HEAP32[i19 >> 2] = 0;
   i1 = i3 + 1 | 0;
   if ((i1 | 0) < (i5 | 0)) {
    i3 = i1;
    i1 = 0;
   } else {
    i30 = 32;
    break;
   }
  }
  if ((i30 | 0) == 32) {
   i1 = HEAP32[i29 >> 2] | 0;
   break;
  }
  HEAP32[i21 >> 2] = i3;
  HEAP32[i19 >> 2] = i1;
  i33 = 0;
  STACKTOP = i34;
  return i33 | 0;
 } else i2 = i26 + 8 | 0; while (0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = HEAP32[i31 >> 2] | 0;
 do if ((i1 | 0) > 1) HEAP32[i2 + 20 >> 2] = 1; else {
  i1 = HEAP32[i32 + 232 >> 2] | 0;
  if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 < ((HEAP32[i33 >> 2] | 0) + -1 | 0) >>> 0) {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i33 = 1;
 STACKTOP = i34;
 return i33 | 0;
}

function runPostSets220() {
 HEAP32[gb + 188040 >> 2] = fb + 1355;
 HEAP32[gb + 188052 >> 2] = fb + 2878;
 HEAP32[gb + 188056 >> 2] = fb + 2879;
 HEAP32[gb + 188060 >> 2] = fb + 1356;
 HEAP32[gb + 188064 >> 2] = fb + 194;
 HEAP32[gb + 188068 >> 2] = fb + 288;
 HEAP32[gb + 188072 >> 2] = fb + 522;
 HEAP32[gb + 188076 >> 2] = fb + 88;
 HEAP32[gb + 188080 >> 2] = fb + 69;
 HEAP32[gb + 188084 >> 2] = fb + 2880;
 HEAP32[gb + 188096 >> 2] = fb + 2881;
 HEAP32[gb + 188100 >> 2] = fb + 2882;
 HEAP32[gb + 188104 >> 2] = fb + 1357;
 HEAP32[gb + 188108 >> 2] = fb + 2883;
 HEAP32[gb + 188112 >> 2] = fb + 2884;
 HEAP32[gb + 188116 >> 2] = fb + 1358;
 HEAP32[gb + 188120 >> 2] = fb + 1359;
 HEAP32[gb + 188124 >> 2] = fb + 1360;
 HEAP32[gb + 188128 >> 2] = (HEAP32[gb + 188128 >> 2] | 0) + (gb + 1027091 | 0);
 HEAP32[gb + 188132 >> 2] = (HEAP32[gb + 188132 >> 2] | 0) + (gb + 1027106 | 0);
 HEAP32[gb + 188136 >> 2] = (HEAP32[gb + 188136 >> 2] | 0) + (gb + 1027137 | 0);
 HEAP32[gb + 188140 >> 2] = (HEAP32[gb + 188140 >> 2] | 0) + (gb + 1027167 | 0);
 HEAP32[gb + 188144 >> 2] = (HEAP32[gb + 188144 >> 2] | 0) + (gb + 1027178 | 0);
 HEAP32[gb + 188148 >> 2] = (HEAP32[gb + 188148 >> 2] | 0) + (gb + 1027193 | 0);
 HEAP32[gb + 188152 >> 2] = (HEAP32[gb + 188152 >> 2] | 0) + (gb + 1027198 | 0);
 HEAP32[gb + 188156 >> 2] = (HEAP32[gb + 188156 >> 2] | 0) + (gb + 1027202 | 0);
 HEAP32[gb + 188160 >> 2] = (HEAP32[gb + 188160 >> 2] | 0) + (gb + 1027209 | 0);
 HEAP32[gb + 188164 >> 2] = (HEAP32[gb + 188164 >> 2] | 0) + (gb + 1027214 | 0);
 HEAP32[gb + 188168 >> 2] = (HEAP32[gb + 188168 >> 2] | 0) + (gb + 1027225 | 0);
 HEAP32[gb + 188172 >> 2] = (HEAP32[gb + 188172 >> 2] | 0) + (gb + 1027232 | 0);
 HEAP32[gb + 188176 >> 2] = (HEAP32[gb + 188176 >> 2] | 0) + (gb + 1027240 | 0);
 HEAP32[gb + 188180 >> 2] = (HEAP32[gb + 188180 >> 2] | 0) + (gb + 1027243 | 0);
 HEAP32[gb + 188184 >> 2] = (HEAP32[gb + 188184 >> 2] | 0) + (gb + 1027251 | 0);
 HEAP32[gb + 188188 >> 2] = (HEAP32[gb + 188188 >> 2] | 0) + (gb + 1027269 | 0);
 HEAP32[gb + 188192 >> 2] = (HEAP32[gb + 188192 >> 2] | 0) + (gb + 1026939 | 0);
 HEAP32[gb + 188196 >> 2] = (HEAP32[gb + 188196 >> 2] | 0) + (gb + 1027277 | 0);
 HEAP32[gb + 188200 >> 2] = (HEAP32[gb + 188200 >> 2] | 0) + (gb + 1027281 | 0);
 HEAP32[gb + 188252 >> 2] = fb + 2885;
 HEAP32[gb + 188256 >> 2] = fb + 2886;
 HEAP32[gb + 188260 >> 2] = fb + 80;
 HEAP32[gb + 188264 >> 2] = fb + 39;
 HEAP32[gb + 188268 >> 2] = fb + 16;
 HEAP32[gb + 188272 >> 2] = fb + 2887;
 HEAP32[gb + 188276 >> 2] = fb + 2888;
 HEAP32[gb + 188280 >> 2] = fb + 19;
 HEAP32[gb + 188284 >> 2] = fb + 1361;
 HEAP32[gb + 188288 >> 2] = fb + 99;
 HEAP32[gb + 188292 >> 2] = fb + 40;
 HEAP32[gb + 188296 >> 2] = fb + 62;
 HEAP32[gb + 188300 >> 2] = fb + 28;
 HEAP32[gb + 188304 >> 2] = fb + 63;
 HEAP32[gb + 188308 >> 2] = fb + 29;
 HEAP32[gb + 188312 >> 2] = fb + 34;
 HEAP32[gb + 188316 >> 2] = fb + 2197;
 HEAP32[gb + 188320 >> 2] = fb + 2198;
 HEAP32[gb + 188324 >> 2] = fb + 2199;
 HEAP32[gb + 188328 >> 2] = fb + 2200;
 HEAP32[gb + 188332 >> 2] = fb + 2201;
 HEAP32[gb + 188336 >> 2] = fb + 2202;
 HEAP32[gb + 188340 >> 2] = fb + 36;
 HEAP32[gb + 188344 >> 2] = fb + 96;
 HEAP32[gb + 188348 >> 2] = fb + 81;
 HEAP32[gb + 188352 >> 2] = fb + 82;
 HEAP32[gb + 188364 >> 2] = (HEAP32[gb + 188364 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 188368 >> 2] = (HEAP32[gb + 188368 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 188404 >> 2] = fb + 2889;
 HEAP32[gb + 188408 >> 2] = fb + 2890;
 HEAP32[gb + 188412 >> 2] = fb + 1;
 HEAP32[gb + 188424 >> 2] = fb + 2891;
 HEAP32[gb + 188428 >> 2] = fb + 2892;
 HEAP32[gb + 188432 >> 2] = fb + 1362;
 HEAP32[gb + 188444 >> 2] = fb + 2893;
 HEAP32[gb + 188448 >> 2] = fb + 2894;
 HEAP32[gb + 188452 >> 2] = fb + 2203;
 HEAP32[gb + 188464 >> 2] = fb + 2895;
 HEAP32[gb + 188468 >> 2] = fb + 2896;
 HEAP32[gb + 188472 >> 2] = fb + 2204;
 HEAP32[gb + 188484 >> 2] = fb + 2897;
 HEAP32[gb + 188488 >> 2] = fb + 2898;
 HEAP32[gb + 188492 >> 2] = fb + 80;
 HEAP32[gb + 188496 >> 2] = fb + 39;
 HEAP32[gb + 188500 >> 2] = fb + 16;
 HEAP32[gb + 188504 >> 2] = fb + 39;
 HEAP32[gb + 188508 >> 2] = fb + 40;
 HEAP32[gb + 188512 >> 2] = fb + 19;
 HEAP32[gb + 188516 >> 2] = fb + 1363;
 HEAP32[gb + 188520 >> 2] = fb + 99;
 HEAP32[gb + 188524 >> 2] = fb + 40;
 HEAP32[gb + 188528 >> 2] = fb + 62;
 HEAP32[gb + 188532 >> 2] = fb + 28;
 HEAP32[gb + 188536 >> 2] = fb + 63;
 HEAP32[gb + 188540 >> 2] = fb + 29;
 HEAP32[gb + 188544 >> 2] = fb + 34;
 HEAP32[gb + 188548 >> 2] = fb + 2205;
 HEAP32[gb + 188552 >> 2] = fb + 2206;
 HEAP32[gb + 188556 >> 2] = fb + 2207;
 HEAP32[gb + 188560 >> 2] = fb + 2208;
 HEAP32[gb + 188564 >> 2] = fb + 2209;
 HEAP32[gb + 188568 >> 2] = fb + 2210;
 HEAP32[gb + 188572 >> 2] = fb + 36;
 runPostSets221();
}

function __Z13GetImagePixelI11ColorRGBA32ET_PKhii13TextureFormat15TextureWrapModeii(i11, i1, i8, i9, i10, i4, i2, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i5 = (i2 | 0) < 0;
 if (i5) i6 = 3; else if ((i3 | 0) < (i9 | 0) & ((i2 | 0) < (i8 | 0) & (i3 | 0) > -1)) i5 = i2; else i6 = 3;
 do if ((i6 | 0) == 3) {
  if (i4 | 0) {
   if ((i8 | 0) < 1) i2 = 0; else {
    i4 = i8 + -1 | 0;
    if (i5) i2 = 0; else i2 = (i4 | 0) < (i2 | 0) ? i4 : i2;
   }
   if ((i9 | 0) < 1) {
    i5 = i2;
    i3 = 0;
    break;
   }
   i4 = i9 + -1 | 0;
   if ((i3 | 0) < 0) {
    i5 = i2;
    i3 = 0;
    break;
   }
   i5 = i2;
   i3 = (i4 | 0) < (i3 | 0) ? i4 : i3;
   break;
  }
  if (!i8) i2 = 0; else {
   if (i5) i2 = (Math_imul(1 - ((i2 | 0) / (i8 | 0) | 0) | 0, i8) | 0) + i2 | 0;
   i2 = (i2 | 0) % (i8 | 0) | 0;
  }
  if (!i9) {
   i5 = i2;
   i3 = 0;
  } else {
   if ((i3 | 0) < 0) i3 = (Math_imul(1 - ((i3 | 0) / (i9 | 0) | 0) | 0, i9) | 0) + i3 | 0;
   i5 = i2;
   i3 = (i3 | 0) % (i9 | 0) | 0;
  }
 } while (0);
 i4 = (i10 + -10 | 0) >>> 0 < 3;
 do if (i4) i6 = 23; else if (((i10 | 1) + -25 | 0) >>> 0 < 5) i6 = 23; else {
  i2 = i10 + -30 | 0;
  if (i2 >>> 0 < 15) if ((i10 + -48 | 0) >>> 0 < 12 | ((i10 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
   i6 = 23;
   break;
  } else {
   i6 = 30;
   break;
  } else if ((i10 + -45 | 0) >>> 0 < 3 | (i10 + -48 | 0) >>> 0 < 12) {
   i6 = 23;
   break;
  } else {
   i6 = 30;
   break;
  }
 } while (0);
 L31 : do if ((i6 | 0) == 23) {
  switch (i10 | 0) {
  case 10:
  case 11:
  case 12:
  case 26:
  case 27:
   break;
  default:
   {
    i2 = i10 | 1;
    if ((i2 | 0) != 25) if (i4 | (i2 + -25 | 0) >>> 0 < 5) break L31; else {
     i6 = 30;
     break L31;
    }
   }
  }
  __ZL19HandleDecompressionPKhii13TextureFormatiiii(i7, i1, i8, i9, i10, i5, i3, 1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i2 + (((i5 | 0) % (i1 | 0) | 0) << 2) + ((Math_imul((i3 | 0) % (i1 | 0) | 0, i1) | 0) << 2) | 0;
  if (!(HEAP8[i7 + 12 >> 0] | 0)) {
   i4 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP8[i1 + 1 >> 0] | 0;
   i10 = HEAP8[i1 + 2 >> 0] | 0;
   i1 = HEAP8[i1 + 3 >> 0] | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
   i2 = i10;
  } else {
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
   i4 = f16 < Math_fround(0.0);
   f16 = i4 ? Math_fround(0.0) : f16;
   i4 = f16 > Math_fround(1.0);
   i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   i3 = f15 < Math_fround(0.0);
   f15 = i3 ? Math_fround(0.0) : f15;
   i3 = f15 > Math_fround(1.0);
   i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   i2 = f14 < Math_fround(0.0);
   f14 = i2 ? Math_fround(0.0) : f14;
   i2 = f14 > Math_fround(1.0);
   i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
   i1 = f13 < Math_fround(0.0);
   f13 = i1 ? Math_fround(0.0) : f13;
   i1 = f13 > Math_fround(1.0);
   i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
  }
  HEAP8[i11 >> 0] = i4;
  HEAP8[i11 + 1 >> 0] = i3;
  HEAP8[i11 + 2 >> 0] = i2;
  HEAP8[i11 + 3 >> 0] = i1;
  STACKTOP = i12;
  return;
 } while (0);
 do if ((i6 | 0) == 30) {
  i2 = i10 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i10 + -48 | 0) >>> 0 < 12 | ((i10 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
  } else if ((i10 + -45 | 0) >>> 0 < 3 | (i10 + -48 | 0) >>> 0 < 12) break;
  i4 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i8, i10) | 0;
  if (!i1) i6 = 38; else {
   if ((i10 | 0) < 9) i2 = 1; else i2 = (i10 | 0) == 1e3 | ((i10 | 0) == 23 | (i10 + -13 | 0) >>> 0 < 9);
   if (!((i8 | 0) > 0 & (i9 | 0) > 0 & (i10 | 0) > 0 & i2)) i6 = 38;
  }
  if ((i6 | 0) == 38) i1 = 0;
  i9 = i1 + (Math_imul(i4, i3) | 0) | 0;
  __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32(i9 + (Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i10) | 0, i5) | 0) | 0, i10, i11);
  STACKTOP = i12;
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1649, 1, 0, 0, 0);
 HEAP32[i11 >> 2] = -1;
 STACKTOP = i12;
 return;
}

function __Z21SetBlendShapeVerticesPK8Vector3fS1_S1_R13dynamic_arrayI16BlendShapeVertexLj4EER10BlendShapei(i21, i22, i23, i24, i25, i26) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i27 = 0, i28 = 0, f29 = f0;
 i27 = i24 + 12 | 0;
 i2 = HEAP32[i27 >> 2] | 0;
 HEAP32[i25 >> 2] = i2;
 i2 = i2 + i26 | 0;
 i28 = i24 + 16 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i28 >> 2] = i2;
  HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i2 * 40 | 0, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i24 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i17 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i28 >> 2] = i2;
  HEAP32[i24 >> 2] = i17;
  break;
 } while (0);
 i13 = i25 + 9 | 0;
 HEAP8[i13 >> 0] = 0;
 i14 = i25 + 8 | 0;
 HEAP8[i14 >> 0] = 0;
 if (!i26) {
  i28 = HEAP32[i27 >> 2] | 0;
  i27 = HEAP32[i25 >> 2] | 0;
  i27 = i28 - i27 | 0;
  i28 = i25 + 4 | 0;
  HEAP32[i28 >> 2] = i27;
  return;
 }
 i15 = (i22 | 0) != 0;
 i16 = (i23 | 0) != 0;
 i17 = i24 + 4 | 0;
 i12 = 0;
 do {
  if (i15) {
   f20 = Math_fround(HEAPF32[i22 + (i12 * 12 | 0) >> 2]);
   f20 = Math_fround(f20 * f20);
   f19 = Math_fround(HEAPF32[i22 + (i12 * 12 | 0) + 4 >> 2]);
   f19 = Math_fround(f20 + Math_fround(f19 * f19));
   f20 = Math_fround(HEAPF32[i22 + (i12 * 12 | 0) + 8 >> 2]);
   i1 = Math_fround(Math_sqrt(Math_fround(f19 + Math_fround(f20 * f20)))) > Math_fround(9.99999974e-06);
  } else i1 = 0;
  if (i16) {
   f20 = Math_fround(HEAPF32[i23 + (i12 * 12 | 0) >> 2]);
   f20 = Math_fround(f20 * f20);
   f19 = Math_fround(HEAPF32[i23 + (i12 * 12 | 0) + 4 >> 2]);
   f19 = Math_fround(f20 + Math_fround(f19 * f19));
   f20 = Math_fround(HEAPF32[i23 + (i12 * 12 | 0) + 8 >> 2]);
   i2 = Math_fround(Math_sqrt(Math_fround(f19 + Math_fround(f20 * f20)))) > Math_fround(9.99999974e-06);
  } else i2 = 0;
  i11 = HEAP16[i14 >> 1] | 0;
  HEAP8[i14 >> 0] = (i1 | (i11 & 255) << 24 >> 24 != 0) & 1;
  HEAP8[i13 >> 0] = (i2 | (i11 & 65535) > 255) & 1;
  f18 = Math_fround(HEAPF32[i21 + (i12 * 12 | 0) >> 2]);
  f29 = Math_fround(f18 * f18);
  f19 = Math_fround(HEAPF32[i21 + (i12 * 12 | 0) + 4 >> 2]);
  f29 = Math_fround(f29 + Math_fround(f19 * f19));
  f20 = Math_fround(HEAPF32[i21 + (i12 * 12 | 0) + 8 >> 2]);
  if (i2 | (i1 | Math_fround(Math_sqrt(Math_fround(f29 + Math_fround(f20 * f20)))) > Math_fround(9.99999974e-06))) {
   i1 = HEAP32[gb + 1162364 >> 2] | 0;
   i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
   if (i15) {
    i9 = HEAP32[i22 + (i12 * 12 | 0) + 4 >> 2] | 0;
    i10 = HEAP32[i22 + (i12 * 12 | 0) + 8 >> 2] | 0;
    i11 = HEAP32[i22 + (i12 * 12 | 0) >> 2] | 0;
   } else {
    i9 = i2;
    i10 = i3;
    i11 = i1;
   }
   if (i16) {
    i1 = HEAP32[i23 + (i12 * 12 | 0) >> 2] | 0;
    i2 = HEAP32[i23 + (i12 * 12 | 0) + 4 >> 2] | 0;
    i3 = HEAP32[i23 + (i12 * 12 | 0) + 8 >> 2] | 0;
   }
   i5 = HEAP32[i27 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i7 = HEAP32[i28 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i6 >>> 0 > i8 >>> 0) {
    i4 = i7 << 1;
    i4 = (i4 | 0) == 0 ? 1 : i4;
    if (i8 >>> 0 < i4 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i28 >> 2] = i4;
     HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i4 * 40 | 0, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 40 | 0, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i24 >> 2] | 0, (HEAP32[i27 >> 2] | 0) * 40 | 0) | 0;
     HEAP32[i28 >> 2] = i4;
     HEAP32[i24 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i27 >> 2] = i6;
   i8 = HEAP32[i24 >> 2] | 0;
   HEAPF32[i8 + (i5 * 40 | 0) >> 2] = f18;
   HEAPF32[i8 + (i5 * 40 | 0) + 4 >> 2] = f19;
   HEAPF32[i8 + (i5 * 40 | 0) + 8 >> 2] = f20;
   HEAP32[i8 + (i5 * 40 | 0) + 12 >> 2] = i11;
   HEAP32[i8 + (i5 * 40 | 0) + 16 >> 2] = i9;
   HEAP32[i8 + (i5 * 40 | 0) + 20 >> 2] = i10;
   HEAP32[i8 + (i5 * 40 | 0) + 24 >> 2] = i1;
   HEAP32[i8 + (i5 * 40 | 0) + 28 >> 2] = i2;
   HEAP32[i8 + (i5 * 40 | 0) + 32 >> 2] = i3;
   HEAP32[i8 + (i5 * 40 | 0) + 36 >> 2] = i12;
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i26 | 0));
 i28 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i25 >> 2] | 0;
 i27 = i28 - i27 | 0;
 i28 = i25 + 4 | 0;
 HEAP32[i28 >> 2] = i27;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 24 | 0;
 i3 = i13 + 20 | 0;
 i9 = i13 + 8 | 0;
 i4 = i13 + 4 | 0;
 i5 = i13;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = ((HEAP32[i12 >> 2] | 0) - i1 | 0) / 40 | 0;
 i7 = i1;
 if (i2 >>> 0 >= i8 >>> 0) {
  if (i2 >>> 0 <= i8 >>> 0) {
   STACKTOP = i13;
   return;
  }
  i4 = i7 + (i8 * 40 | 0) | 0;
  HEAP32[i10 >> 2] = 0;
  i9 = i10 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = i8 * 40 | 0;
  i2 = (i1 | 0) / 40 | 0;
  if (!i1) {
   i4 = i10 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i2 >>> 0 > 107374182) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i3 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i10 >> 2] = i3;
   i2 = i3 + (i2 * 40 | 0) | 0;
   i6 = i10 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i1 = i3;
   if (!i8) {
    i4 = i6;
    i5 = i1;
    i3 = i1;
   } else {
    i1 = i7;
    i2 = i3;
    do {
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 20 >> 2] = 0;
     i5 = i1 + 24 | 0;
     i7 = HEAP32[i5 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i8 + 4 >> 2] = i7;
     HEAP8[i2 + 4 >> 0] = 0;
     __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i1);
     i8 = i2 + 32 | 0;
     i7 = i1 + 32 | 0;
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP8[i8 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
     i1 = i1 + 40 | 0;
     i2 = (HEAP32[i9 >> 2] | 0) + 40 | 0;
     HEAP32[i9 >> 2] = i2;
    } while ((i1 | 0) != (i4 | 0));
    i4 = i6;
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = i5;
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i12 >> 2] = i3;
  i12 = i11 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i2;
  i4 = i1;
  i2 = i8;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    while (1) {
     i1 = i2 + -40 | 0;
     HEAP32[i9 >> 2] = i1;
     i3 = HEAP32[i1 >> 2] | 0;
     if (i3) if (HEAP32[i2 + -36 >> 2] | 0) {
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
      i1 = HEAP32[i9 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 8 | 0;
 if ((((HEAP32[i6 >> 2] | 0) - i1 | 0) / 40 | 0 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE8__appendEj(i11, i8 - i2 | 0);
  STACKTOP = i13;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE7reserveEj(i9, i8);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i3, i10);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 40 | 0;
 i4 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE8__appendEj(i9, i8 - i1 | 0);
  i2 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i5 = i3 + (i8 * 40 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i3 = i4;
   while (1) {
    i1 = i3 + -40 | 0;
    HEAP32[i7 >> 2] = i1;
    i4 = HEAP32[i1 >> 2] | 0;
    i2 = i1;
    if (i4) if (HEAP32[i3 + -36 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i3 + -16 | 0);
     i1 = HEAP32[i7 >> 2] | 0;
     i2 = i1;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i3 = i1;
   }
  }
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i12 >> 2] = i2;
 i2 = i9 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i1;
 i2 = i11;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   while (1) {
    i1 = i2 + -40 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = HEAP32[i1 >> 2] | 0;
    if (i3) if (HEAP32[i2 + -36 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i13;
 return;
}

function __Z24MergeTransformComponentsR9TransformS0_b(i16, i17, i18) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23 + 48 | 0;
 i20 = i23 + 32 | 0;
 i21 = i23 + 16 | 0;
 i22 = i23;
 __ZN9Transform30EnsureTransformHierarchyExistsEv(i16);
 __ZN9Transform30EnsureTransformHierarchyExistsEv(i17);
 __ZNK9Transform16GetLocalPositionEv(i19, i16);
 __ZNK9Transform16GetLocalRotationEv(i20, i16);
 __ZNK9Transform13GetLocalScaleEv(i21, i16);
 __ZN9Transform47ClearTransformHierarchyAndApplyToSerializedDataEv(i16);
 i1 = __ZN9Transform8GetSceneEv(i16) | 0;
 i2 = __ZN9Transform8GetSceneEv(i17) | 0;
 if (!((i1 | 0) == 0 | (i2 | 0) == (i1 | 0))) {
  if (i2 | 0) __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i17, 1);
  __ZN10UnityScene14AddRootToSceneERS_R9Transform(i1, i17);
 }
 i1 = i16 + 100 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 L7 : do if (i5 | 0) {
  HEAP32[i1 >> 2] = 0;
  i7 = i5 + 92 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i3 | 0) {
   i6 = i5 + 80 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = 0;
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i16 | 0)) break;
    i1 = i2 + 1 | 0;
    if (i1 >>> 0 < i3 >>> 0) i2 = i1; else break L7;
   }
   i1 = i17 + 100 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i17, 1);
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] = i17;
    HEAP32[i1 >> 2] = i5;
    break;
   }
   i2 = __ZN9Transform4FindEPKS_(i5, i16) | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i15 = i2 + 4 | 0;
    _memmove(i2 | 0, i15 | 0, i1 - i15 | 0) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   }
  }
 } while (0);
 i14 = i16 + 80 | 0;
 i15 = i16 + 92 | 0;
 if (HEAP32[i15 >> 2] | 0) {
  i8 = i17 + 80 | 0;
  i9 = i17 + 92 | 0;
  i10 = i17 + 80 | 0;
  i11 = i17 + 96 | 0;
  i12 = i17 + 84 | 0;
  i7 = 0;
  do {
   i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   if (i1 | 0) {
    i6 = __ZN9Transform4FindEPKS_(i17, i1) | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i9 >> 2] | 0;
    if ((i6 | 0) == (i2 + (i13 << 2) | 0)) {
     HEAP32[i1 + 100 >> 2] = i17;
     i6 = i13 + 1 | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i6 >>> 0 > i5 >>> 0) {
      i3 = i4 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i11 >> 2] = i3;
       i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i10 >> 2] = i2;
       break;
      } else {
       i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
       HEAP32[i11 >> 2] = i3;
       HEAP32[i10 >> 2] = i2;
       break;
      }
     } while (0);
     HEAP32[i9 >> 2] = i6;
     HEAP32[i2 + (i13 << 2) >> 2] = i1;
    }
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 i1 = i16 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i16 + 84 | 0);
  HEAP32[i14 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN9Transform25RebuildTransformHierarchyEv(i17);
 if (!i18) {
  STACKTOP = i23;
  return;
 }
 i16 = HEAP32[i19 + 4 >> 2] | 0;
 i15 = HEAP32[i19 + 8 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = i16;
 HEAP32[i22 + 8 >> 2] = i15;
 __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i17, i22);
 i15 = HEAP32[i20 + 4 >> 2] | 0;
 i16 = HEAP32[i20 + 8 >> 2] | 0;
 i18 = HEAP32[i20 + 12 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i22 + 4 >> 2] = i15;
 HEAP32[i22 + 8 >> 2] = i16;
 HEAP32[i22 + 12 >> 2] = i18;
 __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i17, i22);
 i18 = HEAP32[i21 + 4 >> 2] | 0;
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = i18;
 HEAP32[i22 + 8 >> 2] = i20;
 __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i17, i22);
 if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i17 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) != (gb + 28980 | 0)) {
  STACKTOP = i23;
  return;
 }
 i21 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 __ZN2UI13RectTransform38SetAnchoredPositionWithoutNotificationERK8Vector2f(i17, i22);
 STACKTOP = i23;
 return;
}

function __ZL32AddMappedPPtrCurveToStreamedClipP19StreamedClipBuilderiRN11UnityEngine9Animation28AnimationClipBindingConstantERK13dynamic_arrayI12PPtrKeyframeLj4EE(i18, i19, i7, i15) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 24 | 0;
 i21 = i25 + 12 | 0;
 i22 = i25;
 i23 = HEAP32[i15 + 12 >> 2] | 0;
 HEAP32[i21 >> 2] = 0;
 i24 = i21 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i24;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i23 << 2;
 i5 = (i6 | 0) != 0;
 do if (i5) {
  i1 = i6 | 3;
  if (i1 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = i4;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 913410 | 0, 223) | 0;
   i3 = gb + 64016 | 0;
   i17 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i21 >> 2] = i2;
   i1 = i24;
   HEAP32[i1 >> 2] = i17;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = gb + 63160 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } else {
  i2 = 0;
  i1 = i4;
 } while (0);
 i16 = i2 + 3 & -4;
 HEAP32[i22 >> 2] = 0;
 i17 = i22 + 4 | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = i3;
 HEAP32[i14 + 4 >> 2] = i1;
 do if (i5) {
  i2 = i6 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, gb + 64016 | 0, 0, gb + 913410 | 0, 224) | 0;
   i13 = gb + 64016 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i22 >> 2] = i1;
   i14 = i17;
   HEAP32[i14 >> 2] = i12;
   HEAP32[i14 + 4 >> 2] = i13;
   break;
  }
 } else i1 = 0; while (0);
 i14 = i1 + 3 & -4;
 i10 = i7 + 20 | 0;
 i11 = i7 + 32 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 if (!i23) {
  i23 = HEAP32[i22 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i17);
  i23 = HEAP32[i21 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i24);
  STACKTOP = i25;
  return;
 }
 i13 = i7 + 36 | 0;
 i7 = i7 + 24 | 0;
 i1 = 0;
 do {
  i9 = HEAP32[i15 >> 2] | 0;
  HEAP32[i16 + (i1 << 2) >> 2] = HEAP32[i9 + (i1 << 3) >> 2];
  HEAP32[i14 + (i1 << 2) >> 2] = i1 + i12;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i13 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i13 >> 2] = i2;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 2, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
    HEAP32[i13 >> 2] = i2;
    HEAP32[i10 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i11 >> 2] = i4;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i9 + (i1 << 3) + 4 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 if ((i23 | 0) <= 0) {
  i23 = HEAP32[i22 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i17);
  i23 = HEAP32[i21 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i24);
  STACKTOP = i25;
  return;
 }
 i2 = i20 + 4 | 0;
 i3 = i20 + 8 | 0;
 i4 = i20 + 20 | 0;
 i5 = i20 + 16 | 0;
 i6 = i20 + 12 | 0;
 i7 = i20 + 24 | 0;
 i1 = 0;
 do {
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAP32[i20 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  if (!i1) f8 = Math_fround(-3402823469999999843913219.0e14); else f8 = Math_fround(HEAPF32[i16 + (i1 << 2) >> 2]);
  HEAPF32[i2 >> 2] = f8;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(HEAP32[i14 + (i1 << 2) >> 2] | 0);
  __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i20, i19, i18);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 i23 = HEAP32[i22 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i23, i17);
 i23 = HEAP32[i21 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i23, i24);
 STACKTOP = i25;
 return;
}

function __Z24dtClosestPtPointTrianglePfPKfS1_S1_S1_(i23, i7, i2, i1, i4) {
 i23 = i23 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var f3 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0;
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f27 = Math_fround(HEAPF32[i2 >> 2]);
 f28 = Math_fround(f26 - f27);
 i29 = i1 + 4 | 0;
 f10 = Math_fround(HEAPF32[i29 >> 2]);
 i24 = i2 + 4 | 0;
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f25 = Math_fround(f10 - f15);
 i22 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i22 >> 2]);
 i2 = i2 + 8 | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f3 - f14);
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f19 = Math_fround(f18 - f27);
 i20 = i4 + 4 | 0;
 f11 = Math_fround(HEAPF32[i20 >> 2]);
 f21 = Math_fround(f11 - f15);
 i1 = i4 + 8 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(f6 - f14);
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f13 = Math_fround(f8 - f27);
 f9 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f15 = Math_fround(f9 - f15);
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f14 = Math_fround(f5 - f14);
 f12 = Math_fround(Math_fround(Math_fround(f28 * f13) + Math_fround(f25 * f15)) + Math_fround(f17 * f14));
 f14 = Math_fround(Math_fround(Math_fround(f19 * f13) + Math_fround(f21 * f15)) + Math_fround(f16 * f14));
 if (f12 <= Math_fround(0.0) & f14 <= Math_fround(0.0)) {
  HEAPF32[i23 >> 2] = f27;
  HEAP32[i23 + 4 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i2 >> 2];
  return;
 }
 f30 = Math_fround(f8 - f26);
 f15 = Math_fround(f9 - f10);
 f13 = Math_fround(f5 - f3);
 f10 = Math_fround(Math_fround(Math_fround(f28 * f30) + Math_fround(f25 * f15)) + Math_fround(f17 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f19 * f30) + Math_fround(f21 * f15)) + Math_fround(f16 * f13));
 if (!(!(f10 >= Math_fround(0.0)) | !(f13 <= f10))) {
  HEAPF32[i23 >> 2] = f26;
  HEAP32[i23 + 4 >> 2] = HEAP32[i29 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i22 >> 2];
  return;
 }
 f15 = Math_fround(Math_fround(f12 * f13) - Math_fround(f10 * f14));
 if (f10 <= Math_fround(0.0) & (f12 >= Math_fround(0.0) & f15 <= Math_fround(0.0))) {
  f30 = Math_fround(f12 / Math_fround(f12 - f10));
  HEAPF32[i23 >> 2] = Math_fround(f27 + Math_fround(f28 * f30));
  HEAPF32[i23 + 4 >> 2] = Math_fround(Math_fround(f25 * f30) + Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i23 + 8 >> 2] = Math_fround(Math_fround(f17 * f30) + Math_fround(HEAPF32[i2 >> 2]));
  return;
 }
 f8 = Math_fround(f8 - f18);
 f30 = Math_fround(f9 - f11);
 f9 = Math_fround(f5 - f6);
 f3 = Math_fround(Math_fround(Math_fround(f28 * f8) + Math_fround(f25 * f30)) + Math_fround(f17 * f9));
 f9 = Math_fround(Math_fround(Math_fround(f19 * f8) + Math_fround(f21 * f30)) + Math_fround(f16 * f9));
 if (!(!(f9 >= Math_fround(0.0)) | !(f3 <= f9))) {
  HEAPF32[i23 >> 2] = f18;
  HEAP32[i23 + 4 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i1 >> 2];
  return;
 }
 f8 = Math_fround(Math_fround(f3 * f14) - Math_fround(f12 * f9));
 if (f9 <= Math_fround(0.0) & (f14 >= Math_fround(0.0) & f8 <= Math_fround(0.0))) {
  f30 = Math_fround(f14 / Math_fround(f14 - f9));
  HEAPF32[i23 >> 2] = Math_fround(f27 + Math_fround(f19 * f30));
  HEAPF32[i23 + 4 >> 2] = Math_fround(Math_fround(f21 * f30) + Math_fround(HEAPF32[i24 >> 2]));
  HEAPF32[i23 + 8 >> 2] = Math_fround(Math_fround(f16 * f30) + Math_fround(HEAPF32[i2 >> 2]));
  return;
 }
 f6 = Math_fround(Math_fround(f10 * f9) - Math_fround(f3 * f13));
 if (f6 <= Math_fround(0.0)) {
  f5 = Math_fround(f13 - f10);
  if (f5 >= Math_fround(0.0)) {
   f3 = Math_fround(f3 - f9);
   if (f3 >= Math_fround(0.0)) {
    f28 = Math_fround(f5 / Math_fround(f5 + f3));
    HEAPF32[i23 >> 2] = Math_fround(f26 + Math_fround(Math_fround(f18 - f26) * f28));
    f30 = Math_fround(HEAPF32[i29 >> 2]);
    HEAPF32[i23 + 4 >> 2] = Math_fround(f30 + Math_fround(f28 * Math_fround(Math_fround(HEAPF32[i20 >> 2]) - f30)));
    f30 = Math_fround(HEAPF32[i22 >> 2]);
    HEAPF32[i23 + 8 >> 2] = Math_fround(f30 + Math_fround(f28 * Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f30)));
    return;
   }
  }
 }
 f26 = Math_fround(Math_fround(1.0) / Math_fround(f15 + Math_fround(f6 + f8)));
 f30 = Math_fround(f8 * f26);
 f26 = Math_fround(f15 * f26);
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(f19 * f26) + Math_fround(Math_fround(f28 * f30) + f27));
 HEAPF32[i23 + 4 >> 2] = Math_fround(Math_fround(f21 * f26) + Math_fround(Math_fround(f25 * f30) + Math_fround(HEAPF32[i24 >> 2])));
 HEAPF32[i23 + 8 >> 2] = Math_fround(Math_fround(f16 * f26) + Math_fround(Math_fround(f17 * f30) + Math_fround(HEAPF32[i2 >> 2])));
 return;
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i11 = i14 + 8 | 0;
 i12 = i10 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (((i1 - i2 | 0) / 84 | 0) >>> 0 >= i3 >>> 0) {
  do {
   i1 = i2 + 4 | 0;
   i4 = i2;
   i5 = i4 + 84 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i10 = i9;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i1;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 32 >> 2] = 0;
   HEAP32[i2 + 36 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i12 = i9;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i2 + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAP32[i2 + 52 >> 2] = 0;
   HEAP32[i2 + 56 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i10 = i9;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2 + 44 | 0;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i2 = (HEAP32[i13 >> 2] | 0) + 84 | 0;
   HEAP32[i13 >> 2] = i2;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i6 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i2 - i4 | 0) / 84 | 0) + i3 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i7 = (i1 - i4 | 0) / 84 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i6;
 if (!i5) i1 = 0; else {
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = 73;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 84 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i1;
 i2 = i1 + (((i2 - i4 | 0) / 84 | 0) * 84 | 0) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 i6 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = i2;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i1 + (i5 * 84 | 0);
 do {
  i1 = i2 + 4 | 0;
  i4 = i2;
  i5 = i4 + 84 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i5 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i15 = i9;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 32 >> 2] = 0;
  HEAP32[i2 + 36 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i5 = i9;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i2 + 24 | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  HEAP32[i2 + 40 >> 2] = 0;
  HEAP32[i2 + 52 >> 2] = 0;
  HEAP32[i2 + 56 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i1 = i9;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i2 + 44 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  i2 = (HEAP32[i7 >> 2] | 0) + 84 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i4 = i6;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i15 = i1;
   i1 = i1 + -84 | 0;
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2 + -84 | 0, i1);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + -64 | 0, i15 + -64 | 0);
   __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i2 + -44 | 0, i15 + -44 | 0);
   HEAP32[i2 + -24 >> 2] = HEAP32[i15 + -24 >> 2];
   HEAP32[i2 + -20 >> 2] = HEAP32[i15 + -20 >> 2];
   HEAP32[i2 + -16 >> 2] = HEAP32[i15 + -16 >> 2];
   HEAP32[i2 + -12 >> 2] = HEAP32[i15 + -12 >> 2];
   HEAP32[i2 + -8 >> 2] = HEAP32[i15 + -8 >> 2];
   HEAP32[i2 + -4 >> 2] = HEAP32[i15 + -4 >> 2];
   i2 = (HEAP32[i6 >> 2] | 0) + -84 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  i4 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i15 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i15;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 __ZNSt3__214__split_bufferI14HeightMeshDataR13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesEPKS2_PS2_RNS3_18ImpulseAccumulatorE(i1, i49, i26, i40) {
 i1 = i1 | 0;
 i49 = i49 | 0;
 i26 = i26 | 0;
 i40 = i40 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i50 = 0, i51 = 0;
 i51 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i50 = i51 + 568 | 0;
 i43 = i51 + 552 | 0;
 i17 = i51 + 536 | 0;
 i19 = i51 + 520 | 0;
 i20 = i51 + 504 | 0;
 i21 = i51 + 488 | 0;
 i22 = i51 + 472 | 0;
 i23 = i51 + 456 | 0;
 i24 = i51 + 440 | 0;
 i25 = i51 + 424 | 0;
 i7 = i51 + 408 | 0;
 i8 = i51 + 392 | 0;
 i9 = i51 + 376 | 0;
 i10 = i51 + 360 | 0;
 i11 = i51 + 344 | 0;
 i12 = i51 + 328 | 0;
 i13 = i51 + 312 | 0;
 i14 = i51 + 585 | 0;
 i15 = i51 + 296 | 0;
 i16 = i51 + 280 | 0;
 i18 = i51 + 584 | 0;
 i28 = i51 + 264 | 0;
 i29 = i51 + 260 | 0;
 i30 = i51 + 256 | 0;
 i31 = i51 + 240 | 0;
 i44 = i51 + 224 | 0;
 i46 = i51 + 208 | 0;
 i47 = i51 + 192 | 0;
 i48 = i51 + 176 | 0;
 i45 = i51 + 160 | 0;
 i42 = i51 + 144 | 0;
 i41 = i51 + 128 | 0;
 i32 = i51 + 112 | 0;
 i33 = i51 + 96 | 0;
 i34 = i51 + 80 | 0;
 i35 = i51 + 64 | 0;
 i36 = i51 + 48 | 0;
 i37 = i51 + 32 | 0;
 i38 = i51 + 16 | 0;
 i39 = i51;
 __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i50, i51 + 587 | 0);
 __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i43, i51 + 586 | 0);
 i1 = i1 + 432 | 0;
 i27 = HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0;
 i2 = i49 + (i27 << 4) | 0;
 if (i27 | 0) {
  i3 = i26 + 32 | 0;
  i4 = i26 + 16 | 0;
  i5 = i2;
  i6 = i49;
  while (1) {
   __Z5splatILj3EE8Scalar4fRKS0_(i21, i6);
   __Z5splatILj2EE8Scalar4fRKS0_(i23, i6);
   __ZmlRK8Scalar4fS1_(i22, i3, i23);
   __ZplRK8Scalar4fS1_(i20, i21, i22);
   __Z5splatILj1EE8Scalar4fRKS0_(i25, i6);
   __ZmlRK8Scalar4fS1_(i24, i4, i25);
   __ZplRK8Scalar4fS1_(i19, i20, i24);
   __Z5splatILj0EE8Scalar4fRKS0_(i8, i6);
   __ZmlRK8Scalar4fS1_(i7, i26, i8);
   __ZplRK8Scalar4fS1_(i17, i19, i7);
   __ZN8Scalar4faSERKS_(i5, i17) | 0;
   __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i13, i14);
   __ZltRK8Scalar4fS1_(i12, i5, i13);
   __Z6simd4iRK8Scalar4f(i11, i12);
   __ZanRK8Scalar4fS1_(i10, i43, i11);
   __ZorRK8Scalar4fS1_(i9, i50, i10);
   __ZN8Scalar4faSERKS_(i50, i9) | 0;
   __ZlsRK8Scalar4fi(i15, i43, 1);
   __ZN8Scalar4faSERKS_(i43, i15) | 0;
   i6 = i6 + 16 | 0;
   if ((i6 | 0) == (i2 | 0)) break; else i5 = i5 + 16 | 0;
  }
 }
 __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i16, i18);
 if (__ZN5simdi8allEqualERK8Scalar4fS2_(i50, i16) | 0) {
  STACKTOP = i51;
  return;
 }
 i26 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i26 + 176 >> 2] | 0;
 i26 = HEAP32[i26 + 180 >> 2] | 0;
 i3 = i1 + (i26 << 2) | 0;
 if (!i26) {
  STACKTOP = i51;
  return;
 }
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i29 >> 2] = i2;
  HEAP32[i30 >> 2] = __Z6simd4iRKi(i29) | 0;
  __ZNK13Simd4iFactoryIRKiEcv8Scalar4fEv(i28, i30);
  __ZN8Scalar4faSERKS_(i43, i28) | 0;
  __ZanRK8Scalar4fS1_(i31, i43, i50);
  if (__ZN5simdi8anyEqualERK8Scalar4fS2_RS0_(i31, i43, i43) | 0) {
   i26 = __ZN5physx5cloth10findBitSetEj(i2 & 0 - i2) | 0;
   __ZN8Scalar4fC2ERKS_(i44, i49 + (i26 << 4) | 0);
   __Z5splatILj0EE8Scalar4fRKS0_(i46, i44);
   __Z5splatILj1EE8Scalar4fRKS0_(i47, i44);
   __Z5splatILj2EE8Scalar4fRKS0_(i48, i44);
   __ZN8Scalar4fC2ERKS_(i45, i49 + (i26 + i27 << 4) | 0);
   i2 = i2 + -1 & i2;
   if (i2 | 0) do {
    i26 = __ZN5physx5cloth10findBitSetEj(i2 & 0 - i2) | 0;
    __ZN8Scalar4faSERKS_(i44, i49 + (i26 << 4) | 0) | 0;
    __ZN8Scalar4fC2ERKS_(i42, i49 + (i26 + i27 << 4) | 0);
    __ZgtRK8Scalar4fS1_(i41, i42, i45);
    __Z5splatILj0EE8Scalar4fRKS0_(i33, i44);
    __Z6selectRK8Scalar4fS1_S1_(i32, i41, i33, i46);
    __ZN8Scalar4faSERKS_(i46, i32) | 0;
    __Z5splatILj1EE8Scalar4fRKS0_(i35, i44);
    __Z6selectRK8Scalar4fS1_S1_(i34, i41, i35, i47);
    __ZN8Scalar4faSERKS_(i47, i34) | 0;
    __Z5splatILj2EE8Scalar4fRKS0_(i37, i44);
    __Z6selectRK8Scalar4fS1_S1_(i36, i41, i37, i48);
    __ZN8Scalar4faSERKS_(i48, i36) | 0;
    __Z3maxRK8Scalar4fS1_(i38, i42, i45);
    __ZN8Scalar4faSERKS_(i45, i38) | 0;
    i2 = i2 + -1 & i2;
   } while ((i2 | 0) != 0);
   __Z6simd4fRK8Scalar4f(i39, i43);
   __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_(i40, i46, i47, i48, i45, i39);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i51;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i9 >> 2;
 i4 = i9;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i8 = i4 + (i12 << 2) | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i11 = i13 + 12 | 0;
  HEAP32[i11 >> 2] = i1;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if ((i2 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i1;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i3 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i7 = i6;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i5 = i8 + -4 | 0;
    i2 = i4;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i9 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i7;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i15 = HEAP32[i11 >> 2] | 0;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i8 = i14 + 8 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i9 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + (i12 << 2);
  if (i1 | 0) {
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i16 >> 2] = 12;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i13, i16);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i1 - i4 >> 2;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 << 2) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i15 = HEAP32[i10 >> 2] | 0;
  HEAP32[i16 >> 2] = 12;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE(i1, i26) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i32 + 36 | 0;
 i29 = i32;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 if (!(HEAP8[i1 + 426 >> 0] | 0)) {
  i31 = 0;
  STACKTOP = i32;
  return i31 | 0;
 }
 if ((HEAP16[gb + 1466932 + 6 >> 1] | 0) > -1) {
  HEAP32[i29 >> 2] = i1;
  HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466932 | 0, i30);
  i31 = gb + 1466932 | 0;
 } else i31 = 0;
 __ZN13dynamic_arrayIP26AnimatorControllerPlayableLj4EEC2ERKS2_RK10MemLabelId(i30, i1 + 584 | 0, gb + 64016 | 0);
 i27 = i30 + 12 | 0;
 if (!(HEAP32[i27 >> 2] | 0)) i1 = 0; else {
  i28 = i1 + 168 | 0;
  i25 = i1 + 153 | 0;
  i1 = 0;
  i24 = HEAP32[i30 >> 2] | 0;
  do {
   i2 = HEAP32[i24 >> 2] | 0;
   i21 = HEAP32[i2 + 92 >> 2] | 0;
   i4 = HEAP32[i2 + 100 >> 2] | 0;
   i3 = HEAP32[i2 + 104 >> 2] | 0;
   L14 : do if (i21) {
    i22 = i2 + 132 | 0;
    i20 = HEAP32[i2 + 140 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 4 >> 2] | 0, i20 | 0) | 0) if (HEAP32[i4 + 20 >> 2] | 0) {
     i20 = i21 + 8 | 0;
     if (HEAP8[i25 >> 0] | 0) {
      i19 = i3 + 4 | 0;
      i15 = i4 + 4 | 0;
      i16 = i15;
      i17 = i21 + 4 | 0;
      i18 = i17;
      i3 = HEAP32[i28 >> 2] | 0;
      if (i3) {
       i14 = 0;
       i2 = 1;
       while (1) {
        if (i14 >>> 0 >= (HEAP32[i20 >> 2] | 0) >>> 0) break L14;
        i12 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i14 << 2) >> 2] | 0;
        i13 = (HEAP32[i15 >> 2] | 0) + i16 + (i14 << 2) | 0;
        i13 = i13 + (HEAP32[i13 >> 2] | 0) | 0;
        i9 = i12 + 4 | 0;
        i10 = i13 + 8 | 0;
        i11 = i13 + 12 | 0;
        i12 = i12 + 8 | 0;
        i13 = i13 + 16 | 0;
        L22 : do if (i3) {
         i8 = 0;
         while (1) {
          if (i8 >>> 0 >= (HEAP32[i21 >> 2] | 0) >>> 0) break L22;
          i7 = (HEAP32[i17 >> 2] | 0) + i18 + (i8 << 2) | 0;
          do if ((HEAP32[i7 + (HEAP32[i7 >> 2] | 0) >> 2] | 0) == (i14 | 0)) {
           i4 = HEAP32[i9 >> 2] | 0;
           i3 = (i4 & 2 | 0) != 0;
           i7 = HEAP32[(i3 ? i10 : i11) >> 2] | 0;
           i4 = i4 & i26;
           if (i4) {
            i2 = HEAP32[(i3 ? i13 : i10) >> 2] | 0;
            i5 = i29;
            i6 = i5 + 36 | 0;
            do {
             HEAP32[i5 >> 2] = 0;
             i5 = i5 + 4 | 0;
            } while ((i5 | 0) < (i6 | 0));
            if (__ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo(HEAP32[i24 >> 2] | 0, i8, i2, i29) | 0) i1 = i1 | (__ZNK27StateMachineBehaviourPlayer18FireStateBehaviourER17AnimatorStateInfoiN7mecanim12statemachine19StateMachineMessageE(i22, i29, i8, i4) | 0);
            i2 = HEAP8[i25 >> 0] | 0;
           }
           if (!(i2 << 24 >> 24)) break L14;
           if (!(HEAP32[i28 >> 2] | 0)) break;
           i3 = HEAP32[i12 >> 2] & i26;
           if (!i3) {
            i23 = 30;
            break;
           }
           i5 = i29;
           i6 = i5 + 36 | 0;
           do {
            HEAP32[i5 >> 2] = 0;
            i5 = i5 + 4 | 0;
           } while ((i5 | 0) < (i6 | 0));
           if (__ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo(HEAP32[i24 >> 2] | 0, i8, i7, i29) | 0) i1 = i1 | (__ZNK27StateMachineBehaviourPlayer18FireStateBehaviourER17AnimatorStateInfoiN7mecanim12statemachine19StateMachineMessageE(i22, i29, i8, i3) | 0);
           i2 = HEAP8[i25 >> 0] | 0;
           i23 = 30;
          } else i23 = 30; while (0);
          if ((i23 | 0) == 30) {
           i23 = 0;
           if (!(i2 << 24 >> 24)) break L14;
          }
          if (!(HEAP32[i28 >> 2] | 0)) break; else i8 = i8 + 1 | 0;
         }
        } while (0);
        i3 = HEAP32[i28 >> 2] | 0;
        if (!i3) break; else i14 = i14 + 1 | 0;
       }
      }
     }
    }
   } while (0);
   i24 = i24 + 4 | 0;
  } while ((i24 | 0) != ((HEAP32[i30 >> 2] | 0) + (HEAP32[i27 >> 2] << 2) | 0));
 }
 if ((HEAP32[i30 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i30 >> 2] | 0, i30 + 4 | 0);
  HEAP32[i30 >> 2] = 0;
 }
 if (!i31) {
  i31 = i1;
  STACKTOP = i32;
  return i31 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i31);
 i31 = i1;
 STACKTOP = i32;
 return i31 | 0;
}

function __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i21, i22, i19, i12, i5, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, f23 = f0, i24 = 0, i25 = 0;
 i20 = __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i21, i22, i19, i12, i1) | 0;
 i1 = i5 + 8 | 0;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 20 | 0;
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i6 = i12 + 8 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i12 + 20 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20;
  return i22 | 0;
 }
 i16 = HEAP32[i12 >> 2] | 0;
 i8 = i12 + 4 | 0;
 i17 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 12 | 0;
 i18 = HEAP32[i9 >> 2] | 0;
 i10 = i12 + 16 | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 24 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i5 >> 2] = i16;
 HEAP32[i5 + 4 >> 2] = i17;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 12 >> 2] = i18;
 HEAP32[i5 + 16 >> 2] = i14;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 24 >> 2] = i13;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2])) * Math_fround(.5));
 i13 = i19 + 8 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i19 + 20 | 0;
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20 + 1 | 0;
  return i22 | 0;
 }
 i25 = HEAP32[i19 >> 2] | 0;
 i15 = i19 + 4 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i16 = i19 + 12 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i17 = i19 + 16 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i18 = i19 + 24 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i12 >> 2] = i25;
 HEAP32[i8 >> 2] = i24;
 HEAPF32[i6 >> 2] = f2;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i10 >> 2] = i4;
 HEAPF32[i7 >> 2] = f3;
 HEAP32[i11 >> 2] = i1;
 f23 = Math_fround(HEAPF32[i13 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
 i1 = i22 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i22 + 20 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i20 + 2 | 0;
  return i25 | 0;
 }
 i10 = HEAP32[i22 >> 2] | 0;
 i5 = i22 + 4 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i22 + 12 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i7 = i22 + 16 | 0;
 i24 = HEAP32[i7 >> 2] | 0;
 i8 = i22 + 24 | 0;
 i25 = HEAP32[i8 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i19 >> 2] = i10;
 HEAP32[i15 >> 2] = i11;
 HEAPF32[i13 >> 2] = f2;
 HEAP32[i16 >> 2] = i12;
 HEAP32[i17 >> 2] = i24;
 HEAPF32[i14 >> 2] = f3;
 HEAP32[i18 >> 2] = i25;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i20 + 3 | 0;
  return i25 | 0;
 }
 i17 = HEAP32[i21 >> 2] | 0;
 i18 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = HEAP32[i21 + 12 >> 2] | 0;
 i24 = HEAP32[i21 + 16 >> 2] | 0;
 i25 = HEAP32[i21 + 24 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
 HEAP32[i22 >> 2] = i17;
 HEAP32[i5 >> 2] = i18;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i6 >> 2] = i19;
 HEAP32[i7 >> 2] = i24;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i8 >> 2] = i25;
 i25 = i20 + 4 | 0;
 return i25 | 0;
}

function __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i21, i22, i19, i12, i5, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, f23 = f0, i24 = 0, i25 = 0;
 i20 = __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i21, i22, i19, i12, i1) | 0;
 i1 = i5 + 4 | 0;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 16 | 0;
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i6 = i12 + 4 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i12 + 16 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20;
  return i22 | 0;
 }
 i16 = HEAP32[i12 >> 2] | 0;
 i8 = i12 + 8 | 0;
 i17 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 12 | 0;
 i18 = HEAP32[i9 >> 2] | 0;
 i10 = i12 + 20 | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 24 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i5 >> 2] = i16;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 8 >> 2] = i17;
 HEAP32[i5 + 12 >> 2] = i18;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 20 >> 2] = i14;
 HEAP32[i5 + 24 >> 2] = i13;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i7 >> 2])) * Math_fround(.5));
 i13 = i19 + 4 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i19 + 16 | 0;
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i20 + 1 | 0;
  return i22 | 0;
 }
 i25 = HEAP32[i19 >> 2] | 0;
 i15 = i19 + 8 | 0;
 i24 = HEAP32[i15 >> 2] | 0;
 i16 = i19 + 12 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i17 = i19 + 20 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i18 = i19 + 24 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i12 >> 2] = i25;
 HEAPF32[i6 >> 2] = f2;
 HEAP32[i8 >> 2] = i24;
 HEAP32[i9 >> 2] = i5;
 HEAPF32[i7 >> 2] = f3;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i11 >> 2] = i1;
 f23 = Math_fround(HEAPF32[i13 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i14 >> 2])) * Math_fround(.5));
 i1 = i22 + 4 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i22 + 16 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i20 + 2 | 0;
  return i25 | 0;
 }
 i10 = HEAP32[i22 >> 2] | 0;
 i5 = i22 + 8 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i22 + 12 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i7 = i22 + 20 | 0;
 i24 = HEAP32[i7 >> 2] | 0;
 i8 = i22 + 24 | 0;
 i25 = HEAP32[i8 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i22 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i22 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i22 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i22 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i19 >> 2] = i10;
 HEAPF32[i13 >> 2] = f2;
 HEAP32[i15 >> 2] = i11;
 HEAP32[i16 >> 2] = i12;
 HEAPF32[i14 >> 2] = f3;
 HEAP32[i17 >> 2] = i24;
 HEAP32[i18 >> 2] = i25;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 if (!(f23 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i20 + 3 | 0;
  return i25 | 0;
 }
 i17 = HEAP32[i21 >> 2] | 0;
 i18 = HEAP32[i21 + 8 >> 2] | 0;
 i19 = HEAP32[i21 + 12 >> 2] | 0;
 i24 = HEAP32[i21 + 20 >> 2] | 0;
 i25 = HEAP32[i21 + 24 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i21 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i21 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
 HEAP32[i22 >> 2] = i17;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 >> 2] = i18;
 HEAP32[i6 >> 2] = i19;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i7 >> 2] = i24;
 HEAP32[i8 >> 2] = i25;
 i25 = i20 + 4 | 0;
 return i25 | 0;
}

function __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = i10 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i2 - i1 | 0) / 204 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAPF32[i1 + 20 >> 2] = Math_fround(inf);
   HEAP32[i1 + 16 >> 2] = 0;
   i7 = i1 + 24 | 0;
   i8 = i7 + 68 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i8 | 0));
   HEAPF32[i1 + 96 >> 2] = Math_fround(inf);
   HEAP32[i1 + 92 >> 2] = 0;
   HEAP32[i1 + 180 >> 2] = 0;
   HEAP32[i1 + 184 >> 2] = 0;
   i2 = i1 + 172 | 0;
   i7 = i1 + 100 | 0;
   i8 = i7 + 72 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i8 | 0));
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
   i10 = i14;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i2;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i11;
   HEAP32[i1 + 192 >> 2] = 2;
   HEAP32[i1 + 188 >> 2] = 2;
   HEAP32[i1 + 196 >> 2] = 4;
   HEAP32[i1 + 200 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 204 | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 204 | 0) + i3 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 204 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 1073741823 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = 25;
  HEAP32[i14 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 204 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i1 = i6 + (((i1 - i4 | 0) / 204 | 0) * 204 | 0) | 0;
 i2 = i1;
 i6 = i6 + (i5 * 204 | 0) | 0;
 i9 = i2;
 i4 = i1;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAPF32[i4 + 20 >> 2] = Math_fround(inf);
  HEAP32[i4 + 16 >> 2] = 0;
  i7 = i4 + 24 | 0;
  i8 = i7 + 68 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  HEAPF32[i4 + 96 >> 2] = Math_fround(inf);
  HEAP32[i4 + 92 >> 2] = 0;
  HEAP32[i4 + 180 >> 2] = 0;
  HEAP32[i4 + 184 >> 2] = 0;
  i5 = i4 + 172 | 0;
  i7 = i4 + 100 | 0;
  i8 = i7 + 72 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
  i16 = i14;
  i7 = HEAP32[i16 + 4 >> 2] | 0;
  i8 = i5;
  HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 + 192 >> 2] = 2;
  HEAP32[i4 + 188 >> 2] = 2;
  HEAP32[i4 + 196 >> 2] = 4;
  HEAP32[i4 + 200 >> 2] = 0;
  i4 = i9 + 204 | 0;
  i9 = i4;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i7 = i4;
  i1 = i4;
 } else {
  do {
   i3 = i3 + -204 | 0;
   __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1 + -204 | 0, i3);
   i1 = i2 + -204 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i4 | 0));
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i11 >> 2] = i6;
 i4 = i7;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i14 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -204 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i2 + -192 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i5 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i14);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = 25;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE(i17, i16, i15) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i12 = i18 + 4 | 0;
 i13 = i16 + 116 | 0;
 HEAP8[i13 >> 0] = HEAPU8[i13 >> 0] & 254;
 i13 = i16 + 108 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 60 >> 2] | 0)) {
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  i11 = HEAP32[i1 + 28 >> 2] | 0;
  i9 = i2 + (i11 << 2) | 0;
  if ((i11 | 0) > 0) {
   i10 = i15 + 8 | 0;
   do {
    i1 = HEAP32[i2 >> 2] | 0;
    do if ((HEAP8[i1 + 20 >> 0] | 0) == 1) {
     i1 = HEAP32[i1 + 32 >> 2] | 0;
     i8 = i1;
     if ((i1 | 0) != (i16 | 0)) if (!(HEAP8[i1 + 116 >> 0] & 1)) {
      i1 = HEAP32[i10 >> 2] | 0;
      if (i1 | 0) {
       i3 = HEAP32[i1 + 4 >> 2] | 0;
       if (i3 >>> 0 < 64) {
        HEAP32[i1 + 8 + (i3 << 2) >> 2] = i8;
        i11 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
        HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
        break;
       }
       i7 = HEAP32[i15 >> 2] | 0;
       __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
       i3 = i7 + 4 | 0;
       i4 = i7 + 8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       i6 = HEAP32[i3 >> 2] | 0;
       i1 = HEAP32[i6 + (i5 + -1 << 2) >> 2] | 0;
       do if ((i1 - (HEAP32[i7 + 16 >> 2] | 0) | 0) < 272) i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, 272, gb + 717976 | 0, 82) | 0; else {
        i1 = i1 + -272 | 0;
        HEAP32[i14 >> 2] = i1;
        if ((HEAP32[i7 + 12 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
         HEAP32[i6 + (i5 << 2) >> 2] = i1;
         HEAP32[i4 >> 2] = i5 + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i3, i14) | 0;
         break;
        }
       } while (0);
       __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
       if (i1 | 0) {
        HEAP32[i1 >> 2] = 0;
        HEAP32[i1 + 4 >> 2] = 1;
        HEAP32[i1 + 8 >> 2] = i8;
        HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
        HEAP32[i10 >> 2] = i1;
       }
      }
     }
    } while (0);
    i2 = i2 + 4 | 0;
   } while (i2 >>> 0 < i9 >>> 0);
  }
 }
 i11 = i16 + 112 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 60 >> 2] | 0)) {
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  i10 = HEAP32[i1 + 28 >> 2] | 0;
  i9 = i2 + (i10 << 2) | 0;
  if ((i10 | 0) > 0) {
   i10 = i15 + 8 | 0;
   do {
    i1 = HEAP32[i2 >> 2] | 0;
    do if ((HEAP8[i1 + 20 >> 0] | 0) == 1) {
     i1 = HEAP32[i1 + 32 >> 2] | 0;
     i8 = i1;
     if ((i1 | 0) != (i16 | 0)) if (!(HEAP8[i1 + 116 >> 0] & 1)) {
      i3 = HEAP32[i10 >> 2] | 0;
      if (i3 | 0) {
       i1 = HEAP32[i3 + 4 >> 2] | 0;
       if (i1 >>> 0 < 64) {
        HEAP32[i3 + 8 + (i1 << 2) >> 2] = i8;
        i8 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
        HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
        break;
       }
       i7 = HEAP32[i15 >> 2] | 0;
       __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
       i3 = i7 + 4 | 0;
       i4 = i7 + 8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       i6 = HEAP32[i3 >> 2] | 0;
       i1 = HEAP32[i6 + (i5 + -1 << 2) >> 2] | 0;
       do if ((i1 - (HEAP32[i7 + 16 >> 2] | 0) | 0) < 272) i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, 272, gb + 717976 | 0, 82) | 0; else {
        i1 = i1 + -272 | 0;
        HEAP32[i14 >> 2] = i1;
        if ((HEAP32[i7 + 12 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
         HEAP32[i6 + (i5 << 2) >> 2] = i1;
         HEAP32[i4 >> 2] = i5 + 1;
         break;
        } else {
         __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i3, i14) | 0;
         break;
        }
       } while (0);
       __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
       if (i1 | 0) {
        HEAP32[i1 >> 2] = 0;
        HEAP32[i1 + 4 >> 2] = 1;
        HEAP32[i1 + 8 >> 2] = i8;
        HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
        HEAP32[i10 >> 2] = i1;
       }
      }
     }
    } while (0);
    i2 = i2 + 4 | 0;
   } while (i2 >>> 0 < i9 >>> 0);
  }
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) i1 = HEAP32[i11 >> 2] | 0; else i1 = i2;
 if ((i2 | 0) != (i1 | 0)) {
  i15 = i2;
  __ZN5physx2Sc27ConstraintProjectionManager10addToGroupERNS0_7BodySimEPS2_RNS0_13ConstraintSimE(i17, i1, i15, i16);
  STACKTOP = i18;
  return;
 }
 i15 = HEAP32[i11 >> 2] | 0;
 __ZN5physx2Sc27ConstraintProjectionManager10addToGroupERNS0_7BodySimEPS2_RNS0_13ConstraintSimE(i17, i1, i15, i16);
 STACKTOP = i18;
 return;
}

function __ZN11Rigidbody2D11SetBodyTypeENS_8BodyTypeEb(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i5 = i12;
 i11 = i12 + 16 | 0;
 i6 = i10 + 68 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i7 = i10 + 92 | 0;
 if (!(((i9 | 0) != (i1 | 0) | i2) & (HEAP32[i7 >> 2] | 0) != 0)) {
  STACKTOP = i12;
  return;
 }
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i5);
 i1 = i3;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 i5 = (__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i10, i11) | 0) < 1;
 if (!(i5 | (HEAP32[i2 >> 2] | 0) == 0)) {
  i1 = HEAP32[i11 >> 2] | 0;
  do {
   __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(HEAP32[i1 >> 2] | 0, 1, 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
 }
 i5 = HEAP32[i6 >> 2] | 0;
 __ZN6b2Body7SetTypeE10b2BodyType(HEAP32[i7 >> 2] | 0, (i5 | 0) == 0 ? 2 : (i5 | 0) == 1 & 1);
 if ((HEAP32[i6 >> 2] | 0) == 2) {
  i1 = HEAP32[i7 >> 2] | 0;
  if (HEAP32[i1 >> 2] | 0) {
   f13 = Math_fround(HEAPF32[gb + 1457504 >> 2]);
   f13 = Math_fround(f13 * f13);
   f4 = Math_fround(HEAPF32[gb + 1457504 + 4 >> 2]);
   if (Math_fround(f13 + Math_fround(f4 * f4)) > Math_fround(0.0)) {
    i2 = i1 + 4 | 0;
    i3 = HEAPU16[i2 >> 1] | 0;
    if (!(i3 & 2)) {
     HEAP16[i2 >> 1] = i3 | 2;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    }
   }
   i5 = gb + 1457504 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i1 = i1 + 64 | 0;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = i6;
   i1 = HEAP32[i7 >> 2] | 0;
   if (HEAP32[i1 >> 2] | 0) if (!(HEAP16[i1 + 4 >> 1] & 16)) HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
  }
 }
 HEAP8[i10 + 225 >> 0] = 0;
 i2 = i10 + 128 | 0;
 i7 = i10 + 184 | 0;
 i1 = i10 + 156 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i2 = i10 + 140 | 0;
 i1 = i10 + 196 | 0;
 i7 = i10 + 168 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i2 = i10 + 226 | 0;
 i7 = HEAP16[i2 >> 1] | 0;
 i1 = (i7 & 65535) >>> 8 & 255;
 if ((i7 & 255) << 24 >> 24) {
  HEAP8[i2 >> 0] = 0;
  i6 = i10 + 124 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i2 + 92 >> 2] | 0;
  if (i7) {
   i3 = HEAP32[i10 + 212 >> 2] | 0;
   i5 = HEAP32[i10 + 216 >> 2] | 0;
   if (!(HEAP32[i7 >> 2] | 0)) i1 = i2; else {
    f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f4 = Math_fround(f4 * f4);
    f13 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (Math_fround(f4 + Math_fround(f13 * f13)) > Math_fround(0.0)) {
     i1 = i7 + 4 | 0;
     i2 = HEAPU16[i1 >> 1] | 0;
     if (!(i2 & 2)) {
      HEAP16[i1 >> 1] = i2 | 2;
      HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
     }
    }
    HEAP32[i7 + 64 >> 2] = i3;
    HEAP32[i7 + 68 >> 2] = i5;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i7 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
   i1 = HEAP8[i10 + 227 >> 0] | 0;
  }
 }
 if (i1 << 24 >> 24) {
  HEAP8[i10 + 227 >> 0] = 0;
  i2 = HEAP32[i10 + 124 >> 2] | 0;
  i3 = HEAP32[i2 + 92 >> 2] | 0;
  if (i3 | 0) {
   f4 = Math_fround(HEAPF32[i10 + 220 >> 2]);
   if (HEAP32[i3 >> 2] | 0) {
    i5 = i3 + 4 | 0;
    i1 = HEAP16[i5 >> 1] | 0;
    if (!(i1 & 16)) {
     if (Math_fround(f4 * f4) > Math_fround(0.0)) {
      i1 = i1 & 65535;
      if (!(i1 & 2)) {
       HEAP16[i5 >> 1] = i1 | 2;
       HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
      }
     }
     HEAPF32[i3 + 72 >> 2] = f4;
    }
   }
   HEAP32[i3 + 136 >> 2] = HEAP32[i2 + 40 >> 2];
  }
 }
 __ZN11Rigidbody2D17UpdateConstraintsEb(i10, 0);
 __ZN11Rigidbody2D19RecalculateContactsEv(i10);
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i9);
  HEAP32[i11 >> 2] = 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN9b2Simplex9ReadCacheEPK14b2SimplexCachePK15b2DistanceProxyRK11b2TransformS5_S8_(i14, i13, i15, i16, i17, i18) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0;
 i12 = HEAP16[i13 + 4 >> 1] | 0;
 i2 = i12 & 65535;
 i19 = i14 + 108 | 0;
 HEAP32[i19 >> 2] = i2;
 if (i12 << 16 >> 16) {
  i5 = i15 + 16 | 0;
  i6 = i17 + 16 | 0;
  i7 = i16 + 12 | 0;
  i8 = i16 + 8 | 0;
  i9 = i16 + 4 | 0;
  i10 = i18 + 12 | 0;
  i11 = i18 + 8 | 0;
  i12 = i18 + 4 | 0;
  i4 = 0;
  do {
   i25 = HEAPU8[i13 + 6 + i4 >> 0] | 0;
   HEAP32[i14 + (i4 * 36 | 0) + 28 >> 2] = i25;
   i2 = HEAPU8[i13 + 9 + i4 >> 0] | 0;
   HEAP32[i14 + (i4 * 36 | 0) + 32 >> 2] = i2;
   i26 = HEAP32[i5 >> 2] | 0;
   f23 = Math_fround(HEAPF32[i26 + (i25 << 3) >> 2]);
   f21 = Math_fround(HEAPF32[i26 + (i25 << 3) + 4 >> 2]);
   i25 = HEAP32[i6 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i25 + (i2 << 3) >> 2]);
   f24 = Math_fround(HEAPF32[i25 + (i2 << 3) + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i7 >> 2]);
   f1 = Math_fround(f23 * f20);
   f3 = Math_fround(HEAPF32[i8 >> 2]);
   f1 = Math_fround(f1 - Math_fround(f21 * f3));
   f1 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f1);
   f3 = Math_fround(Math_fround(f21 * f20) + Math_fround(f23 * f3));
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i9 >> 2]));
   HEAPF32[i14 + (i4 * 36 | 0) >> 2] = f1;
   HEAPF32[i14 + (i4 * 36 | 0) + 4 >> 2] = f3;
   f23 = Math_fround(HEAPF32[i10 >> 2]);
   f20 = Math_fround(f22 * f23);
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   f20 = Math_fround(f20 - Math_fround(f24 * f21));
   f20 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f20);
   f21 = Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * f21));
   f21 = Math_fround(f21 + Math_fround(HEAPF32[i12 >> 2]));
   HEAPF32[i14 + (i4 * 36 | 0) + 8 >> 2] = f20;
   HEAPF32[i14 + (i4 * 36 | 0) + 12 >> 2] = f21;
   f3 = Math_fround(f21 - f3);
   HEAPF32[i14 + (i4 * 36 | 0) + 16 >> 2] = Math_fround(f20 - f1);
   HEAPF32[i14 + (i4 * 36 | 0) + 20 >> 2] = f3;
   HEAPF32[i14 + (i4 * 36 | 0) + 24 >> 2] = Math_fround(0.0);
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i19 >> 2] | 0;
  } while ((i4 | 0) < (i2 | 0));
 }
 if ((i2 | 0) > 1) {
  f3 = Math_fround(HEAPF32[i13 >> 2]);
  switch (i2 | 0) {
  case 3:
   {
    f22 = Math_fround(HEAPF32[i14 + 52 >> 2]);
    f1 = Math_fround(HEAPF32[i14 + 16 >> 2]);
    f22 = Math_fround(f22 - f1);
    f24 = Math_fround(HEAPF32[i14 + 56 >> 2]);
    f23 = Math_fround(HEAPF32[i14 + 20 >> 2]);
    f24 = Math_fround(f24 - f23);
    f1 = Math_fround(Math_fround(HEAPF32[i14 + 88 >> 2]) - f1);
    f1 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(HEAPF32[i14 + 92 >> 2]) - f23)) - Math_fround(f24 * f1));
    break;
   }
  case 2:
   {
    f24 = Math_fround(Math_fround(HEAPF32[i14 + 16 >> 2]) - Math_fround(HEAPF32[i14 + 52 >> 2]));
    f1 = Math_fround(Math_fround(HEAPF32[i14 + 20 >> 2]) - Math_fround(HEAPF32[i14 + 56 >> 2]));
    f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f24 * f24) + Math_fround(f1 * f1))));
    break;
   }
  default:
   f1 = Math_fround(0.0);
  }
  if (!(f1 < Math_fround(f3 * Math_fround(.5)))) if (!(Math_fround(f3 * Math_fround(2.0)) < f1 | f1 < Math_fround(1.1920929e-07))) return;
  HEAP32[i19 >> 2] = 0;
 } else if (i2 | 0) return;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP32[i14 + 32 >> 2] = 0;
 i26 = HEAP32[i15 + 16 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i26 >> 2]);
 f21 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 i26 = HEAP32[i17 + 16 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f1 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f23 = Math_fround(f3 * f22);
 f24 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f23 = Math_fround(f23 - Math_fround(f21 * f24));
 f23 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f23);
 f24 = Math_fround(Math_fround(f21 * f22) + Math_fround(f3 * f24));
 f24 = Math_fround(f24 + Math_fround(HEAPF32[i16 + 4 >> 2]));
 HEAPF32[i14 >> 2] = f23;
 HEAPF32[i14 + 4 >> 2] = f24;
 f3 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f22 = Math_fround(f20 * f3);
 f21 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f22 = Math_fround(f22 - Math_fround(f1 * f21));
 f22 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f22);
 f21 = Math_fround(Math_fround(f1 * f3) + Math_fround(f20 * f21));
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i18 + 4 >> 2]));
 HEAPF32[i14 + 8 >> 2] = f22;
 HEAPF32[i14 + 12 >> 2] = f21;
 f24 = Math_fround(f21 - f24);
 HEAPF32[i14 + 16 >> 2] = Math_fround(f22 - f23);
 HEAPF32[i14 + 20 >> 2] = f24;
 HEAPF32[i14 + 24 >> 2] = Math_fround(1.0);
 HEAP32[i19 >> 2] = 1;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i12, i17, i6) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = i12 + 52 | 0;
 i21 = i12 + 56 | 0;
 HEAP32[i21 >> 2] = 32;
 i7 = i12 + 68 | 0;
 HEAP32[i7 >> 2] = 16;
 i10 = i12 + 64 | 0;
 HEAP32[i10 >> 2] = 6;
 i11 = i12 + 72 | 0;
 HEAP8[i11 >> 0] = 0;
 i4 = __Znwj(640) | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 32; else {
  __ZdlPv(i1);
  i1 = HEAP32[i21 >> 2] | 0;
 }
 HEAP32[i20 >> 2] = i4;
 i2 = i4 + (i1 * 20 | 0) | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i3 = i12 + 32 | 0;
  i1 = i4;
  do {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i18 = i12 + 60 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i19 = i17 + 4 | 0;
 f5 = Math_fround(((HEAP32[i17 + 60 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i3 = HEAP32[i21 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  i6 = __Znwj(i2 * 20 | 0) | 0;
  i1 = HEAP32[i20 >> 2] | 0;
  i4 = i1 + (i3 * 20 | 0) | 0;
  if (!i3) i1 = 0; else {
   i3 = i6;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 20 | 0;
   }
   i1 = HEAP32[i21 >> 2] | 0;
  }
  i3 = i6 + (i2 * 20 | 0) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i4 = i12 + 32 | 0;
   i1 = i6 + (i1 * 20 | 0) | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  __ZdlPv(HEAP32[i20 >> 2] | 0);
  HEAP32[i20 >> 2] = i6;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i7 >> 2] = ~~f9 >>> 0;
  HEAP32[i10 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i11 >> 0] = 0;
 } else i2 = i3;
 i14 = i17 + 52 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i17 + 56 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i13 * 20 | 0) | 0;
 L28 : do if (i13) {
  i4 = HEAP32[i17 + 32 >> 2] | 0;
  i6 = i17 + 8 | 0;
  i7 = i17 + 12 | 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break L28;
    if (!(HEAP32[i19 >> 2] | 0)) break L28;
    if ((HEAP32[i7 >> 2] | 0) != (i3 | 0)) break L28;
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i16 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i16 | 0)) return;
 i11 = i12 + 32 | 0;
 i12 = i17 + 32 | 0;
 i13 = i17 + 8 | 0;
 i10 = i17 + 12 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 2127912214 + (i2 << 12) | 0;
  i2 = i2 ^ -949894596 ^ i2 >>> 19;
  i2 = i2 + 374761393 + (i2 << 5) | 0;
  i2 = i2 + -744332180 ^ i2 << 9;
  i2 = i2 + -42973499 + (i2 << 3) | 0;
  i2 = (i2 ^ -1252372727 ^ i2 >>> 16) & i4;
  i7 = HEAP32[i20 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 * 20 | 0) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 * 20 | 0) >> 2] | 0));
  }
  i17 = i7 + (i2 * 20 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  i1 = i1 + 20 | 0;
  L48 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i12 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) != (i2 | 0)) {
     if (!(HEAP8[i13 >> 0] | 0)) break L48;
     if (!(HEAP32[i19 >> 2] | 0)) break L48;
     if ((HEAP32[i10 >> 2] | 0) != (i2 | 0)) break L48;
    }
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + ((HEAP32[i15 >> 2] | 0) * 20 | 0) | 0)) break;
  i2 = HEAP32[i21 >> 2] | 0;
 }
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i19, i1, i14) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 24 | 0;
 i18 = i21 + 16 | 0;
 i15 = i21 + 12 | 0;
 i16 = i21 + 8 | 0;
 i9 = i21 + 4 | 0;
 i10 = i21;
 i8 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i17 = (i11 - i8 | 0) / 20 | 0;
 i7 = i19 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i3 = i8;
 i5 = i2;
 if (i17 >>> 0 > ((i1 - i2 | 0) / 20 | 0) >>> 0) {
  if (i2) {
   i6 = i19 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) i1 = i2; else {
    i4 = i20 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i2 + -16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i16 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i20 >> 2] = 66;
      HEAP32[i4 >> 2] = i16;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i19 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i1 = 0;
  }
  if (i17 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i19 >> 2] | 0;
  } else i2 = 0;
  i16 = (i1 - i2 | 0) / 20 | 0;
  i1 = i16 << 1;
  i1 = i16 >>> 0 < 107374182 ? (i1 >>> 0 < i17 >>> 0 ? i17 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i19);
  i16 = __Znwj(i1 * 20 | 0) | 0;
  HEAP32[i19 + 4 >> 2] = i16;
  HEAP32[i19 >> 2] = i16;
  HEAP32[i7 >> 2] = i16 + (i1 * 20 | 0);
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i18 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i13 = i19 + 4 | 0;
 i10 = ((HEAP32[i13 >> 2] | 0) - i2 | 0) / 20 | 0;
 i12 = i17 >>> 0 > i10 >>> 0;
 i11 = i12 ? i3 + (i10 * 20 | 0) | 0 : i11;
 i10 = i11;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i5;
  i9 = i3;
  do {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   i6 = i1 + 4 | 0;
   i2 = i9 + 4 | 0;
   do if ((i1 | 0) != (i9 | 0)) {
    i8 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i8 = i4 ? HEAP32[i9 + 8 >> 2] | 0 : i8 & 255;
    i4 = i6 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i8 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 8 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
     break;
    }
    if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
    if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
    HEAP8[i2 + i8 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 8 >> 2] = i8;
     break;
    } else {
     HEAP8[i4 >> 0] = i8;
     break;
    }
   } while (0);
   i9 = i9 + 20 | 0;
   i1 = i1 + 20 | 0;
  } while ((i9 | 0) != (i10 | 0));
  i5 = i1;
 }
 if (i12) {
  HEAP32[i15 >> 2] = i11;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  i17 = i17 - (((HEAP32[i13 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0) / 20 | 0) | 0;
  HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i16 >> 2];
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i19, i18, i20, i17);
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i21;
  return;
 }
 i4 = i20 + 4 | 0;
 do {
  i2 = i1 + -20 | 0;
  HEAP32[i13 >> 2] = i2;
  i3 = i1 + -16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i19 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i20 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i19, i20);
   i1 = HEAP32[i13 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i21;
 return;
}

function __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 f37 = Math_fround(HEAPF32[i2 >> 2]);
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 f32 = Math_fround(f37 * f31);
 i17 = i1 + 4 | 0;
 f40 = Math_fround(HEAPF32[i17 >> 2]);
 f27 = Math_fround(f37 * f40);
 i16 = i1 + 8 | 0;
 f36 = Math_fround(HEAPF32[i16 >> 2]);
 f37 = Math_fround(f37 * f36);
 i25 = i2 + 4 | 0;
 f35 = Math_fround(HEAPF32[i25 >> 2]);
 i15 = i1 + 12 | 0;
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f38 = Math_fround(f35 * f29);
 i14 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i14 >> 2]);
 f30 = Math_fround(f35 * f6);
 i13 = i1 + 20 | 0;
 f34 = Math_fround(HEAPF32[i13 >> 2]);
 f38 = Math_fround(f32 + f38);
 f30 = Math_fround(f27 + f30);
 f35 = Math_fround(f37 + Math_fround(f35 * f34));
 i23 = i2 + 8 | 0;
 f37 = Math_fround(HEAPF32[i23 >> 2]);
 i12 = i1 + 24 | 0;
 f27 = Math_fround(HEAPF32[i12 >> 2]);
 f32 = Math_fround(f37 * f27);
 i11 = i1 + 28 | 0;
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f39 = Math_fround(f37 * f9);
 i8 = i1 + 32 | 0;
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f32 = Math_fround(f38 + f32);
 f39 = Math_fround(f30 + f39);
 f37 = Math_fround(f35 + Math_fround(f37 * f3));
 i22 = i2 + 12 | 0;
 f35 = Math_fround(HEAPF32[i22 >> 2]);
 f30 = Math_fround(f31 * f35);
 f38 = Math_fround(f40 * f35);
 f35 = Math_fround(f36 * f35);
 i21 = i2 + 16 | 0;
 f33 = Math_fround(HEAPF32[i21 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f29 * f33));
 f38 = Math_fround(f38 + Math_fround(f6 * f33));
 f33 = Math_fround(f35 + Math_fround(f34 * f33));
 i20 = i2 + 20 | 0;
 f35 = Math_fround(HEAPF32[i20 >> 2]);
 f30 = Math_fround(f30 + Math_fround(f27 * f35));
 f38 = Math_fround(f38 + Math_fround(f9 * f35));
 f35 = Math_fround(f33 + Math_fround(f3 * f35));
 i19 = i2 + 24 | 0;
 f33 = Math_fround(HEAPF32[i19 >> 2]);
 f28 = Math_fround(f31 * f33);
 f4 = Math_fround(f40 * f33);
 f33 = Math_fround(f36 * f33);
 i18 = i2 + 28 | 0;
 f26 = Math_fround(HEAPF32[i18 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f29 * f26));
 f4 = Math_fround(f4 + Math_fround(f6 * f26));
 f26 = Math_fround(f33 + Math_fround(f34 * f26));
 i5 = i2 + 32 | 0;
 f33 = Math_fround(HEAPF32[i5 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f27 * f33));
 f4 = Math_fround(f4 + Math_fround(f9 * f33));
 f33 = Math_fround(f26 + Math_fround(f3 * f33));
 f26 = Math_fround(Math_fround(Math_fround(f39 * f31) + Math_fround(f38 * f29)) + Math_fround(f4 * f27));
 f24 = Math_fround(Math_fround(Math_fround(f37 * f31) + Math_fround(f35 * f29)) + Math_fround(f33 * f27));
 f10 = Math_fround(Math_fround(Math_fround(f32 * f40) + Math_fround(f30 * f6)) + Math_fround(f28 * f9));
 f7 = Math_fround(Math_fround(Math_fround(f39 * f40) + Math_fround(f38 * f6)) + Math_fround(f4 * f9));
 f9 = Math_fround(Math_fround(Math_fround(f37 * f40) + Math_fround(f35 * f6)) + Math_fround(f33 * f9));
 f6 = Math_fround(Math_fround(Math_fround(f32 * f36) + Math_fround(f30 * f34)) + Math_fround(f28 * f3));
 f4 = Math_fround(Math_fround(Math_fround(f39 * f36) + Math_fround(f38 * f34)) + Math_fround(f4 * f3));
 f3 = Math_fround(Math_fround(Math_fround(f37 * f36) + Math_fround(f35 * f34)) + Math_fround(f33 * f3));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(f30 * f29)) + Math_fround(f28 * f27));
 HEAPF32[i25 >> 2] = f26;
 HEAPF32[i23 >> 2] = f24;
 HEAPF32[i22 >> 2] = f10;
 HEAPF32[i21 >> 2] = f7;
 HEAPF32[i20 >> 2] = f9;
 HEAPF32[i19 >> 2] = f6;
 HEAPF32[i18 >> 2] = f4;
 HEAPF32[i5 >> 2] = f3;
 i5 = i2 + 36 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f6 = Math_fround(f3 * Math_fround(HEAPF32[i17 >> 2]));
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i16 >> 2]));
 i1 = i2 + 40 | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2]));
 f7 = Math_fround(f4 + f7);
 f10 = Math_fround(f6 + f10);
 f9 = Math_fround(f3 + Math_fround(f9 * Math_fround(HEAPF32[i13 >> 2])));
 i2 = i2 + 44 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]));
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i11 >> 2]));
 f4 = Math_fround(f10 + f4);
 f3 = Math_fround(f9 + Math_fround(f3 * Math_fround(HEAPF32[i8 >> 2])));
 HEAPF32[i5 >> 2] = Math_fround(f7 + f6);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i2 >> 2] = f3;
 return;
}

function __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i26 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i26 >> 2] | 0;
 i28 = i26 + 4 | 0;
 i5 = HEAP32[i28 >> 2] | 0;
 i29 = i26 + 8 | 0;
 i6 = HEAP32[i29 >> 2] | 0;
 i30 = i26 + 16 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 i31 = i26 + 20 | 0;
 i2 = HEAP32[i31 >> 2] | 0;
 i27 = i26 + 24 | 0;
 i3 = HEAP32[i27 >> 2] | 0;
 i9 = HEAP32[i4 + 16 >> 2] | 0;
 i4 = HEAP16[i9 + 2 >> 1] | 0;
 i25 = i9 + (i4 & 65535) | 0;
 if (!(i4 << 16 >> 16)) {
  i16 = i6;
  i15 = i5;
  i10 = i8;
  i25 = i3;
  i24 = i2;
  i23 = i1;
  HEAP32[i26 >> 2] = i10;
  HEAP32[i28 >> 2] = i15;
  HEAP32[i29 >> 2] = i16;
  HEAP32[i30 >> 2] = i23;
  HEAP32[i31 >> 2] = i24;
  HEAP32[i27 >> 2] = i25;
  return;
 } else {
  i10 = i4;
  i4 = i8;
 }
 while (1) {
  i15 = i9 + 48 | 0;
  i32 = HEAP8[i9 + 1 >> 0] | 0;
  i16 = i32 & 255;
  i23 = i16 * 80 | 0;
  i24 = i9 + (i23 + 48) | 0;
  i8 = i9 + ((i10 & 65535) + 32) | 0;
  f11 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f12 = Math_fround(HEAPF32[i9 + 20 >> 2]);
  f13 = Math_fround(HEAPF32[i9 + 24 >> 2]);
  f14 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f22 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = Math_fround(f11 * f14);
  f19 = Math_fround(f12 * f14);
  f20 = Math_fround(f13 * f14);
  if (!(i32 << 24 >> 24)) f7 = Math_fround(0.0); else {
   f7 = Math_fround(0.0);
   f11 = Math_fround(Math_fround(Math_fround(f22 * f11) + Math_fround(f21 * f12)) + Math_fround(f17 * f13));
   i5 = 0;
   while (1) {
    i4 = i5 + 1 | 0;
    f36 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) >> 2]);
    f13 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 4 >> 2]);
    f40 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 8 >> 2]);
    i32 = i15 + (i5 * 80 | 0) + 12 | 0;
    f12 = Math_fround(HEAPF32[i32 >> 2]);
    f41 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 28 >> 2]);
    f35 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 48 >> 2]);
    f34 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 52 >> 2]);
    f33 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 56 >> 2]);
    f43 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 36 >> 2]);
    f42 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 32 >> 2]);
    f39 = Math_fround(HEAPF32[i15 + (i5 * 80 | 0) + 40 >> 2]);
    f38 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f36 = Math_fround(f38 * f36);
    f37 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f13 = Math_fround(f36 + Math_fround(f37 * f13));
    f36 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f40 = Math_fround(Math_fround(Math_fround(f41 * f43) - f42) - Math_fround(f41 * Math_fround(f11 + Math_fround(f13 + Math_fround(f36 * f40)))));
    f13 = Math_fround(-f12);
    f13 = Math_fround(f12 + (f40 > f13 ? f40 : f13));
    f13 = f13 > f39 ? f39 : f13;
    f12 = Math_fround(f13 - f12);
    f11 = Math_fround(f11 + Math_fround(f14 * f12));
    f35 = Math_fround(f38 + Math_fround(f35 * f12));
    f34 = Math_fround(f37 + Math_fround(f34 * f12));
    f33 = Math_fround(f36 + Math_fround(f33 * f12));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f35, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround(f7 + f12);
    HEAPF32[i32 >> 2] = f13;
    HEAPF32[i8 + (i5 << 2) >> 2] = f13;
    if ((i4 | 0) == (i16 | 0)) break; else i5 = i4;
   }
  }
  f41 = Math_fround(f22 + Math_fround(f18 * f7));
  f42 = Math_fround(f21 + Math_fround(f19 * f7));
  f43 = Math_fround(f17 + Math_fround(f20 * f7));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f41, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f43, HEAP32[tempDoublePtr >> 2] | 0);
  if (i24 >>> 0 >= i25 >>> 0) break;
  i10 = HEAP16[i9 + (i23 + 50) >> 1] | 0;
  i9 = i24;
 }
 HEAP32[i26 >> 2] = i4;
 HEAP32[i28 >> 2] = i5;
 HEAP32[i29 >> 2] = i6;
 HEAP32[i30 >> 2] = i1;
 HEAP32[i31 >> 2] = i2;
 HEAP32[i27 >> 2] = i3;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = i10 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i2 - i1 | 0) / 172 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAPF32[i1 + 20 >> 2] = Math_fround(inf);
   HEAP32[i1 + 16 >> 2] = 0;
   i7 = i1 + 24 | 0;
   i8 = i7 + 52 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i8 | 0));
   HEAPF32[i1 + 80 >> 2] = Math_fround(inf);
   HEAP32[i1 + 76 >> 2] = 0;
   HEAP32[i1 + 148 >> 2] = 0;
   HEAP32[i1 + 152 >> 2] = 0;
   i2 = i1 + 140 | 0;
   i7 = i1 + 84 | 0;
   i8 = i7 + 56 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    i7 = i7 + 4 | 0;
   } while ((i7 | 0) < (i8 | 0));
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
   i10 = i14;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i2;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i11;
   HEAP32[i1 + 160 >> 2] = 2;
   HEAP32[i1 + 156 >> 2] = 2;
   HEAP32[i1 + 164 >> 2] = 4;
   HEAP32[i1 + 168 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 172 | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 172 | 0) + i3 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 172 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 1073741823 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = 25;
  HEAP32[i14 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 172 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i1 = i6 + (((i1 - i4 | 0) / 172 | 0) * 172 | 0) | 0;
 i2 = i1;
 i6 = i6 + (i5 * 172 | 0) | 0;
 i9 = i2;
 i4 = i1;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAPF32[i4 + 20 >> 2] = Math_fround(inf);
  HEAP32[i4 + 16 >> 2] = 0;
  i7 = i4 + 24 | 0;
  i8 = i7 + 52 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
  HEAP32[i4 + 76 >> 2] = 0;
  HEAP32[i4 + 148 >> 2] = 0;
  HEAP32[i4 + 152 >> 2] = 0;
  i5 = i4 + 140 | 0;
  i7 = i4 + 84 | 0;
  i8 = i7 + 56 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
  i16 = i14;
  i7 = HEAP32[i16 + 4 >> 2] | 0;
  i8 = i5;
  HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 + 160 >> 2] = 2;
  HEAP32[i4 + 156 >> 2] = 2;
  HEAP32[i4 + 164 >> 2] = 4;
  HEAP32[i4 + 168 >> 2] = 0;
  i4 = i9 + 172 | 0;
  i9 = i4;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i7 = i4;
  i1 = i4;
 } else {
  do {
   i3 = i3 + -172 | 0;
   __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1 + -172 | 0, i3);
   i1 = i2 + -172 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i4 | 0));
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i11 >> 2] = i6;
 i4 = i7;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i14 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -172 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i2 + -160 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i5 >> 2] = i12;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i14);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = 25;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i14);
 STACKTOP = i15;
 return;
}

function __ZN9BoxPruner10staticSortEv(i25) {
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 8240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26 + 8233 | 0;
 i21 = i26 + 40 | 0;
 i1 = i26 + 8232 | 0;
 i23 = i26;
 i10 = i26 + 38 | 0;
 i19 = i26 + 37 | 0;
 i22 = i26 + 36 | 0;
 HEAP8[i25 + 168 >> 0] = 0;
 i20 = HEAP32[i25 + 84 >> 2] | 0;
 if (!i20) {
  i2 = i25 + 124 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i1);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i2 >> 2] = 0;
  HEAP32[i25 + 128 >> 2] = 0;
  STACKTOP = i26;
  return;
 }
 i2 = i20 << 4;
 if (i2 >>> 0 < 8193) i16 = i21; else i16 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i2, gb + 717183 | 0, 1180) | 0;
 i15 = i16 + (i20 << 2) | 0;
 i17 = i16 + (i20 << 3) | 0;
 i18 = i16 + (i20 * 12 | 0) | 0;
 i5 = i25 + 128 | 0;
 i6 = i25 + 124 | 0;
 i7 = i25 + 96 | 0;
 i8 = 0;
 i3 = 0;
 i4 = 0;
 while (1) {
  i2 = i8 >>> 5;
  if (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 * 24 | 0) >> 2] | 0;
   if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] & 1 << (i8 & 31))) i9 = 12; else {
    HEAP32[i16 + (i4 << 2) >> 2] = i1;
    HEAP32[i17 + (i4 << 2) >> 2] = i8;
    i1 = i3;
    i2 = i4 + 1 | 0;
   }
  } else {
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 * 24 | 0) >> 2] | 0;
   i9 = 12;
  }
  if ((i9 | 0) == 12) {
   i9 = 0;
   HEAP32[i15 + (i3 << 2) >> 2] = i1;
   HEAP32[i18 + (i3 << 2) >> 2] = i8;
   i1 = i3 + 1 | 0;
   i2 = i4;
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == (i20 | 0)) {
   i13 = i1;
   break;
  } else {
   i3 = i1;
   i4 = i2;
  }
 }
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i23);
 if (i2 >>> 0 < 1024) i1 = __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i25 + 132 | 0, i16, i2, 1) | 0; else i1 = __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i23, i16, i2, 1) | 0;
 i11 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = i25 + 80 | 0;
 i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, HEAP32[i9 >> 2] << 1, gb + 717183 | 0, 1228) | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + 2 | 0;
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
 i12 = _PxGetFoundation() | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0) | 0;
 i12 = mftCall_iiiiii(i8 | 0, i9 | 0, (i10 >>> 0 > 178956970 ? -1 : i10 * 24 | 0) | 0, (i12 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1233) | 0;
 HEAP32[i12 + (i20 * 24 | 0) >> 2] = -1;
 HEAP32[i12 + ((i20 + 1 | 0) * 24 | 0) >> 2] = -1;
 if (!i2) i1 = -1; else i1 = HEAP32[i16 + (HEAP32[i11 >> 2] << 2) >> 2] | 0;
 if (!i13) i3 = -1; else i3 = HEAP32[i15 >> 2] | 0;
 i7 = i25 + 104 | 0;
 i8 = i25 + 96 | 0;
 i9 = i25 + 76 | 0;
 i10 = 0;
 i4 = 0;
 i5 = 0;
 do {
  if (i1 >>> 0 < i3 >>> 0) {
   i1 = HEAP32[i17 + (HEAP32[i11 + (i4 << 2) >> 2] << 2) >> 2] | 0;
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i6 = i1;
    i1 = HEAP32[i16 + (HEAP32[i11 + (i4 << 2) >> 2] << 2) >> 2] | 0;
   } else {
    i6 = i1;
    i1 = -1;
   }
  } else {
   i3 = HEAP32[i18 + (i5 << 2) >> 2] | 0;
   i5 = i5 + 1 | 0;
   if (i5 >>> 0 < i13 >>> 0) {
    i6 = i3;
    i3 = HEAP32[i15 + (i5 << 2) >> 2] | 0;
   } else {
    i6 = i3;
    i3 = -1;
   }
  }
  i27 = HEAP16[(HEAP32[i7 >> 2] | 0) + (i6 << 1) >> 1] | 0;
  i28 = i12 + (i10 * 24 | 0) | 0;
  i6 = (HEAP32[i8 >> 2] | 0) + (i6 * 24 | 0) | 0;
  HEAP32[i28 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i28 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i28 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i28 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP16[i14 + (i10 << 1) >> 1] = i27;
  HEAP32[(HEAP32[i9 >> 2] | 0) + ((i27 & 65535) << 3) >> 2] = i10;
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i20 | 0));
 if ((i16 | 0) != (i21 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, i16);
 i1 = i25 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i12;
 i1 = i25 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i14;
 i1 = i25 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i25 + 128 >> 2] = 0;
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i23);
 STACKTOP = i26;
 return;
}

function __ZN4Mesh25RecalculateBoundsInternalEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i17 = 0, i18 = 0;
 i17 = i16 + 32 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i17 >> 2] | 0);
  i2 = HEAP32[i17 >> 2] | 0;
  i15 = i2 + 4 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  if (!(HEAP32[i15 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i17 >> 2] = i1;
 }
 f6 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f13 = Math_fround(-f6);
 f4 = Math_fround(-f3);
 f12 = Math_fround(-f8);
 i5 = i1 + 8 | 0;
 i15 = HEAP16[i1 + 10 >> 1] | 0;
 if ((i15 & 65535) < 768 | (i15 & 255) != 0) {
  i11 = 0;
  i15 = 0;
 } else {
  i2 = HEAP32[i1 + 92 >> 2] | 0;
  if (!i2) {
   i11 = 0;
   i15 = 1;
  } else if (!(HEAP8[i1 + 11 >> 0] | 0)) {
   i11 = 0;
   i15 = 1;
  } else {
   i11 = HEAP16[i5 >> 1] | 0;
   i11 = i2 + (((i11 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i11 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i15 = HEAPU8[i5 + 32 + ((HEAPU8[i5 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 i2 = i1 + 8 | 0;
 i7 = HEAP16[i1 + 10 >> 1] | 0;
 if ((i7 & 65535) < 768 | (i7 & 255) != 0) i2 = 0; else {
  i5 = HEAP32[i1 + 100 >> 2] | 0;
  i7 = HEAP32[i1 + 92 >> 2] | 0;
  if (!i7) i2 = 0; else if (!(HEAP8[i1 + 11 >> 0] | 0)) i2 = 0; else {
   i18 = HEAP16[i2 >> 1] | 0;
   i2 = i7 + ((Math_imul(HEAPU8[i2 + 32 + ((HEAPU8[i2 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i5) | 0) + (HEAP32[i2 + 32 + ((i18 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i18 & 65535) >>> 8 & 65535)) | 0;
  }
 }
 if ((i11 | 0) != (i2 | 0)) do {
  f9 = Math_fround(HEAPF32[i11 >> 2]);
  f6 = f9 < f6 ? f9 : f6;
  f10 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f3 = f10 < f3 ? f10 : f3;
  f14 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f8 = f14 < f8 ? f14 : f8;
  f13 = f13 < f9 ? f9 : f13;
  f4 = f4 < f10 ? f10 : f4;
  f12 = f12 < f14 ? f14 : f12;
  i11 = i11 + i15 | 0;
 } while ((i11 | 0) != (i2 | 0));
 i15 = HEAP32[i16 + 84 >> 2] | 0;
 if (!i15) f14 = f8; else {
  i5 = i1 + 8 | 0;
  i18 = HEAP16[i1 + 10 >> 1] | 0;
  if ((i18 & 65535) < 768 | (i18 & 255) != 0) {
   i11 = 0;
   i5 = 0;
  } else {
   i2 = HEAP32[i1 + 92 >> 2] | 0;
   if (!i2) {
    i11 = 0;
    i5 = 1;
   } else if (!(HEAP8[i1 + 11 >> 0] | 0)) {
    i11 = 0;
    i5 = 1;
   } else {
    i11 = HEAP16[i5 >> 1] | 0;
    i11 = i2 + (((i11 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i11 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i5 + 32 + ((HEAPU8[i5 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  i7 = HEAP32[i16 + 72 >> 2] | 0;
  i2 = 0;
  do {
   i18 = i11 + (Math_imul(HEAP32[i7 + (i2 * 40 | 0) + 36 >> 2] | 0, i5) | 0) | 0;
   f9 = Math_fround(HEAPF32[i18 >> 2]);
   f9 = Math_fround(f9 + Math_fround(HEAPF32[i7 + (i2 * 40 | 0) >> 2]));
   f10 = Math_fround(HEAPF32[i18 + 4 >> 2]);
   f10 = Math_fround(f10 + Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 4 >> 2]));
   f14 = Math_fround(HEAPF32[i18 + 8 >> 2]);
   f14 = Math_fround(f14 + Math_fround(HEAPF32[i7 + (i2 * 40 | 0) + 8 >> 2]));
   f6 = f9 < f6 ? f9 : f6;
   f3 = f10 < f3 ? f10 : f3;
   f8 = f14 < f8 ? f14 : f8;
   f13 = f13 < f9 ? f9 : f13;
   f4 = f4 < f10 ? f10 : f4;
   f12 = f12 < f14 ? f14 : f12;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i15 >>> 0);
  f14 = f8;
 }
 if (!(HEAP32[i1 + 100 >> 2] | 0)) {
  f6 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
  f4 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
  f8 = f6;
  f9 = f4;
  f10 = f3;
 } else {
  f8 = Math_fround(Math_fround(f6 + f13) * Math_fround(.5));
  f9 = Math_fround(Math_fround(f3 + f4) * Math_fround(.5));
  f10 = Math_fround(Math_fround(f14 + f12) * Math_fround(.5));
  f6 = Math_fround(Math_fround(f13 - f6) * Math_fround(.5));
  f4 = Math_fround(Math_fround(f4 - f3) * Math_fround(.5));
  f3 = Math_fround(Math_fround(f12 - f14) * Math_fround(.5));
 }
 HEAPF32[i16 + 48 >> 2] = f8;
 HEAPF32[i16 + 52 >> 2] = f9;
 HEAPF32[i16 + 56 >> 2] = f10;
 HEAPF32[i16 + 60 >> 2] = f6;
 HEAPF32[i16 + 64 >> 2] = f4;
 HEAPF32[i16 + 68 >> 2] = f3;
 if ((HEAP32[i1 + 132 >> 2] | 0) == (HEAP32[i1 + 128 >> 2] | 0)) return; else i1 = 0;
 do {
  __ZN4Mesh32RecalculateSubmeshBoundsInternalEj(i16, i1);
  i1 = i1 + 1 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
 } while (i1 >>> 0 < (((HEAP32[i18 + 132 >> 2] | 0) - (HEAP32[i18 + 128 >> 2] | 0) | 0) / 52 | 0) >>> 0);
 return;
}

function __Z23ClipPolygonAgainstPlaneiPK8Vector3fRK5PlanePaPS_(i12, i13, i10, i11, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i6 = (i12 | 0) > 0;
 if (!i6) {
  i14 = i12;
  return i14 | 0;
 }
 i7 = i10 + 4 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 12 | 0;
 i5 = 0;
 i1 = 0;
 i2 = 0;
 do {
  f4 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i13 + (i5 * 12 | 0) >> 2]));
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  f15 = Math_fround(f4 + Math_fround(f15 * Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 4 >> 2])));
  f4 = Math_fround(HEAPF32[i8 >> 2]);
  f4 = Math_fround(f15 + Math_fround(f4 * Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 8 >> 2])));
  f4 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f4);
  do if (f4 > Math_fround(.00100000005)) {
   HEAP8[i11 + i5 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } else {
   i3 = i11 + i5 | 0;
   if (f4 < Math_fround(-.00100000005)) {
    HEAP8[i3 >> 0] = -1;
    i2 = i2 + 1 | 0;
    break;
   } else {
    HEAP8[i3 >> 0] = 0;
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i12 | 0));
 if (!i2) {
  if (i6) i1 = 0; else {
   i14 = i12;
   return i14 | 0;
  }
  do {
   i11 = i14 + (i1 * 12 | 0) | 0;
   i10 = i13 + (i1 * 12 | 0) | 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  i1 = i12;
  return i1 | 0;
 }
 if ((i1 | 0) == 0 | i6 ^ 1) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = i10 + 4 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 12 | 0;
 i1 = 0;
 i6 = 0;
 i2 = i12 + -1 | 0;
 while (1) {
  i3 = HEAP8[i11 + i6 >> 0] | 0;
  if (i3 << 24 >> 24 == -1) {
   if ((HEAP8[i11 + i2 >> 0] | 0) == 1) {
    f18 = Math_fround(HEAPF32[i13 + (i6 * 12 | 0) >> 2]);
    f17 = Math_fround(f18 - Math_fround(HEAPF32[i13 + (i2 * 12 | 0) >> 2]));
    f20 = Math_fround(HEAPF32[i13 + (i6 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(f20 - Math_fround(HEAPF32[i13 + (i2 * 12 | 0) + 4 >> 2]));
    f19 = Math_fround(HEAPF32[i13 + (i6 * 12 | 0) + 8 >> 2]);
    f15 = Math_fround(f19 - Math_fround(HEAPF32[i13 + (i2 * 12 | 0) + 8 >> 2]));
    f22 = Math_fround(HEAPF32[i10 >> 2]);
    f24 = Math_fround(f18 * f22);
    f21 = Math_fround(HEAPF32[i7 >> 2]);
    f24 = Math_fround(f24 + Math_fround(f20 * f21));
    f16 = Math_fround(HEAPF32[i8 >> 2]);
    f24 = Math_fround(f24 + Math_fround(f19 * f16));
    f23 = Math_fround(HEAPF32[i9 >> 2]);
    f16 = Math_fround(Math_fround(f23 + f24) / Math_fround(f23 + Math_fround(Math_fround(Math_fround(f17 * f22) + Math_fround(f4 * f21)) + Math_fround(f15 * f16))));
    f4 = Math_fround(f20 - Math_fround(f4 * f16));
    f15 = Math_fround(f19 - Math_fround(f15 * f16));
    HEAPF32[i14 + (i1 * 12 | 0) >> 2] = Math_fround(f18 - Math_fround(f17 * f16));
    HEAPF32[i14 + (i1 * 12 | 0) + 4 >> 2] = f4;
    HEAPF32[i14 + (i1 * 12 | 0) + 8 >> 2] = f15;
    i1 = i1 + 1 | 0;
   }
  } else {
   i5 = i13 + (i6 * 12 | 0) | 0;
   if (i3 << 24 >> 24 == 1) if ((HEAP8[i11 + i2 >> 0] | 0) == -1) {
    f20 = Math_fround(HEAPF32[i13 + (i2 * 12 | 0) >> 2]);
    f21 = Math_fround(f20 - Math_fround(HEAPF32[i5 >> 2]));
    f18 = Math_fround(HEAPF32[i13 + (i2 * 12 | 0) + 4 >> 2]);
    f23 = Math_fround(f18 - Math_fround(HEAPF32[i13 + (i6 * 12 | 0) + 4 >> 2]));
    f19 = Math_fround(HEAPF32[i13 + (i2 * 12 | 0) + 8 >> 2]);
    f24 = Math_fround(f19 - Math_fround(HEAPF32[i13 + (i6 * 12 | 0) + 8 >> 2]));
    f16 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(f20 * f16);
    f17 = Math_fround(HEAPF32[i7 >> 2]);
    f4 = Math_fround(f4 + Math_fround(f18 * f17));
    f22 = Math_fround(HEAPF32[i8 >> 2]);
    f4 = Math_fround(f4 + Math_fround(f19 * f22));
    f15 = Math_fround(HEAPF32[i9 >> 2]);
    f22 = Math_fround(Math_fround(f15 + f4) / Math_fround(f15 + Math_fround(Math_fround(Math_fround(f21 * f16) + Math_fround(f23 * f17)) + Math_fround(f24 * f22))));
    f23 = Math_fround(f18 - Math_fround(f23 * f22));
    f24 = Math_fround(f19 - Math_fround(f24 * f22));
    HEAPF32[i14 + (i1 * 12 | 0) >> 2] = Math_fround(f20 - Math_fround(f21 * f22));
    HEAPF32[i14 + (i1 * 12 | 0) + 4 >> 2] = f23;
    HEAPF32[i14 + (i1 * 12 | 0) + 8 >> 2] = f24;
    i1 = i1 + 1 | 0;
   }
   i3 = i14 + (i1 * 12 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   i1 = i1 + 1 | 0;
  }
  i2 = i6 + 1 | 0;
  if ((i2 | 0) == (i12 | 0)) break; else {
   i5 = i6;
   i6 = i2;
   i2 = i5;
  }
 }
 return i1 | 0;
}

function __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i7, i8, i3, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 64 | 0;
 i6 = i11;
 i10 = i8 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if ((i4 | 0) != 2) {
  i1 = i8 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) == 1) {
   if ((i2 | 0) == 2) __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i7, i8);
   __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 0) | 0, i3, i9);
   __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 1) | 0, i3, i9);
   __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 2) | 0, i3, i9);
   __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 3) | 0, i3, i9);
   i9 = i1;
   i10 = HEAP32[i10 >> 2] | 0;
   HEAP32[i9 >> 2] = i10;
   STACKTOP = i11;
   return;
  }
  switch (i2 | 0) {
  case 1:
   {
    __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 0) | 0);
    __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 1) | 0);
    __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 2) | 0);
    __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 3) | 0);
    i9 = i1;
    i10 = HEAP32[i10 >> 2] | 0;
    HEAP32[i9 >> 2] = i10;
    STACKTOP = i11;
    return;
   }
  case 2:
   {
    __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i7, i8);
    i9 = i1;
    i10 = HEAP32[i10 >> 2] | 0;
    HEAP32[i9 >> 2] = i10;
    STACKTOP = i11;
    return;
   }
  default:
   {
    i9 = i1;
    i10 = HEAP32[i10 >> 2] | 0;
    HEAP32[i9 >> 2] = i10;
    STACKTOP = i11;
    return;
   }
  }
 }
 i4 = i8 + 20 | 0;
 if ((HEAP32[i4 >> 2] | 0) == 2) {
  i3 = Math_fround(HEAPF32[i8 + 12 >> 2]) == Math_fround(inf);
  i1 = __ZN15TerrainRenderer17CalculateEdgeMaskER12QuadTreeNode(i7, i8) | 0;
  if (i3) i2 = 5;
 } else {
  i1 = __ZN15TerrainRenderer17CalculateEdgeMaskER12QuadTreeNode(i7, i8) | 0;
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  i3 = i8 + 60 | 0;
  HEAP8[i3 >> 0] = HEAP8[i3 >> 0] | 2;
 }
 i2 = i8 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i8 + 60 | 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = i8 + 60 | 0;
  HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 4;
 }
 f14 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
 f13 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
 HEAPF32[i5 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i7 + 32 >> 2]));
 HEAPF32[i5 + 4 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i7 + 36 >> 2]));
 HEAPF32[i5 + 8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i7 + 40 >> 2]));
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i6, i5) | 0;
 if (!(HEAP8[i1 >> 0] & 1)) __ZN15TerrainRenderer26CreateQuadTreeNodeRendererER12QuadTreeNodeRK10Matrix4x4fP8MaterialRKNS_22QuadTreeNodeParametersE(i7, i8, i6, HEAP32[i9 + 24 >> 2] | 0, i9); else {
  i3 = i9 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (HEAP32[i1 + 12 >> 2] | 0) {
   i2 = 0;
   do {
    __ZN15TerrainRenderer26CreateQuadTreeNodeRendererER12QuadTreeNodeRK10Matrix4x4fP8MaterialRKNS_22QuadTreeNodeParametersE(i7, i8, i6, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, i9);
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
   } while (i2 >>> 0 < (HEAP32[i1 + 12 >> 2] | 0) >>> 0);
  }
 }
 if ((HEAP32[i4 >> 2] | 0) == 1) {
  __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 0) | 0);
  __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 1) | 0);
  __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 2) | 0);
  __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i7, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i7, i8, 3) | 0);
 }
 i9 = i4;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPNS_15basic_streambufIcS2_EE(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i13 | 0, i14 | 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i14;
  i3 = i14;
  i4 = 32;
 } else {
  L4 : do if (HEAP8[i13 >> 0] | 0) {
   i1 = i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0;
   do if (!i2) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i1 | 0, HEAP32[i1 + 16 >> 2] | 1 | 0);
    i12 = __THREW__;
    __THREW__ = 0;
    if (i12 & 1) i4 = 17; else break L4;
   } else {
    i11 = HEAP32[i1 + 24 >> 2] | 0;
    i7 = i11;
    i8 = (i11 | 0) == 0;
    i9 = i7 + 24 | 0;
    i10 = i7 + 28 | 0;
    i12 = 0;
    i1 = i2;
    while (1) {
     if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i6 = __THREW__;
      __THREW__ = 0;
      if (i6 & 1) {
       i4 = 18;
       break;
      }
      i1 = (i2 | 0) == -1 ? 0 : i1;
      if (!i1) {
       i4 = 26;
       break;
      }
     }
     i5 = i1 + 12 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     i6 = i1 + 16 | 0;
     if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
      __THREW__ = 0;
      i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i4 = 18;
       break;
      }
     } else i2 = HEAPU8[i2 >> 0] | 0;
     i3 = i2 & 255;
     if (i8) {
      i4 = 26;
      break;
     }
     i4 = HEAP32[i9 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i10 >> 2] | 0)) {
      __THREW__ = 0;
      i2 = invoke_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i7 | 0, i2 & 255 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i4 = 18;
       break;
      }
      if ((i2 | 0) == -1) {
       i4 = 26;
       break;
      }
     } else {
      HEAP32[i9 >> 2] = i4 + 1;
      HEAP8[i4 >> 0] = i3;
     }
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i6 = __THREW__;
      __THREW__ = 0;
      if (i6 & 1) {
       i4 = 18;
       break;
      }
     } else HEAP32[i5 >> 2] = i2 + 1;
     i12 = i12 + 1 | 0;
    }
    if ((i4 | 0) == 18) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i4 | 0) == 26) {
     if (i12 | 0) break L4;
     i12 = i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i12 | 0, HEAP32[i12 + 16 >> 2] | 4 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (!(i12 & 1)) break L4;
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
    ___cxa_begin_catch(i1 | 0) | 0;
    __THREW__ = 0;
    invoke_vi(fb + 3999 | 0, i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0);
    i12 = __THREW__;
    __THREW__ = 0;
    if (i12 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __THREW__ = 0;
     invoke_v(fb + 458 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (i12 & 1) {
      i4 = 37;
      break L1;
     } else break;
    } else {
     __THREW__ = 0;
     invoke_v(fb + 458 | 0);
     i12 = __THREW__;
     __THREW__ = 0;
     if (i12 & 1) {
      i4 = 17;
      break;
     } else break L4;
    }
   } while (0);
   if ((i4 | 0) == 17) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i13);
   i2 = i14;
   i3 = i14;
   i4 = 32;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i13);
  i4 = 34;
 } while (0);
 do if ((i4 | 0) == 32) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   i4 = 34;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i15 = __THREW__;
  __THREW__ = 0;
  if (i15 & 1) i4 = 37; else ___resumeException(i1 | 0);
 } while (0);
 if ((i4 | 0) == 34) {
  STACKTOP = i15;
  return i14 | 0;
 } else if ((i4 | 0) == 37) {
  i15 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i15);
 }
 return 0;
}

function __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i9, i12, i13) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i14 + 728 | 0;
 i8 = i14 + 664 | 0;
 i6 = i14 + 332 | 0;
 i7 = HEAP32[i9 + 44 >> 2] | 0;
 i5 = HEAP32[i9 + 36 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i10;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i12 + 8 >> 2] | 0);
 i6 = i12 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i10);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i11 + 16 >> 2] = i3;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i10, i11, 0) | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i9 + 52 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i15 = i11 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i12, i11);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i15 = i13 + 5 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i15 = i13 + 5 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 24 | 0;
 i3 = i13 + 20 | 0;
 i9 = i13 + 8 | 0;
 i4 = i13 + 4 | 0;
 i5 = i13;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 >> 5;
 i7 = i1;
 if (i2 >>> 0 >= i8 >>> 0) {
  if (i2 >>> 0 <= i8 >>> 0) {
   STACKTOP = i13;
   return;
  }
  i4 = i7 + (i8 << 5) | 0;
  HEAP32[i10 >> 2] = 0;
  i9 = i10 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = i8 << 5;
  i2 = i1 >> 5;
  if (!i2) {
   i4 = i10 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i2 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i3 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i10 >> 2] = i3;
   i2 = i3 + (i2 << 5) | 0;
   i6 = i10 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i1 = i3;
   if (!i8) {
    i4 = i6;
    i5 = i1;
    i3 = i1;
   } else {
    i1 = i7;
    i2 = i3;
    do {
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 20 >> 2] = 0;
     i5 = i1 + 24 | 0;
     i7 = HEAP32[i5 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i8 + 4 >> 2] = i7;
     HEAP8[i2 + 4 >> 0] = 0;
     __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i1);
     i1 = i1 + 32 | 0;
     i2 = (HEAP32[i9 >> 2] | 0) + 32 | 0;
     HEAP32[i9 >> 2] = i2;
    } while ((i1 | 0) != (i4 | 0));
    i4 = i6;
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = i5;
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i12 >> 2] = i3;
  i12 = i11 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i2;
  i4 = i1;
  i2 = i8;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    while (1) {
     i1 = i2 + -32 | 0;
     HEAP32[i9 >> 2] = i1;
     i3 = HEAP32[i1 >> 2] | 0;
     if (i3) if (HEAP32[i2 + -28 >> 2] | 0) {
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
      i1 = HEAP32[i9 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 8 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i1 >> 5 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE8__appendEj(i11, i8 - i2 | 0);
  STACKTOP = i13;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE7reserveEj(i9, i8);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE6assignINS_11__wrap_iterIPS5_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS5_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_(i9, i3, i10);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = i2 - i3 >> 5;
 i4 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE8__appendEj(i9, i8 - i1 | 0);
  i2 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i5 = i3 + (i8 << 5) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i3 = i4;
   while (1) {
    i1 = i3 + -32 | 0;
    HEAP32[i7 >> 2] = i1;
    i4 = HEAP32[i1 >> 2] | 0;
    i2 = i1;
    if (i4) if (HEAP32[i3 + -28 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i3 + -8 | 0);
     i1 = HEAP32[i7 >> 2] | 0;
     i2 = i1;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i3 = i1;
   }
  }
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i7 >> 2] = i11;
 HEAP32[i12 >> 2] = i2;
 i2 = i9 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i1;
 i2 = i11;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   while (1) {
    i1 = i2 + -32 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = HEAP32[i1 >> 2] | 0;
    if (i3) if (HEAP32[i2 + -28 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i13;
 return;
}

function _cff_index_get_pointers(i14, i15, i16) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19 + 4 | 0;
 i17 = i19;
 HEAP32[i17 >> 2] = 0;
 i10 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 i18 = i14 + 24 | 0;
 L1 : do if (!(HEAP32[i18 >> 2] | 0)) {
  HEAP32[i9 >> 2] = 0;
  i6 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = i14 + 8 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (i1 | 0) {
   i4 = HEAP8[i14 + 12 >> 0] | 0;
   i13 = i1 + 1 | 0;
   i3 = Math_imul(i4 & 255, i13) | 0;
   HEAP32[i18 >> 2] = _UNITY_ft_mem_realloc(i7, 4, 0, i13, 0, i9) | 0;
   if (!(HEAP32[i9 >> 2] | 0)) {
    i13 = _UNITY_FT_Stream_Seek(i6, (HEAP32[i14 + 4 >> 2] | 0) + 3 | 0) | 0;
    HEAP32[i9 >> 2] = i13;
    if (!i13) {
     i13 = _UNITY_FT_Stream_EnterFrame(i6, i3) | 0;
     HEAP32[i9 >> 2] = i13;
     if (!i13) {
      i2 = HEAP32[i18 >> 2] | 0;
      i1 = HEAP32[i6 + 32 >> 2] | 0;
      i5 = i1 + i3 | 0;
      switch (i4 << 24 >> 24) {
      case 1:
       {
        if ((i3 | 0) > 0) while (1) {
         HEAP32[i2 >> 2] = HEAPU8[i1 >> 0];
         i1 = i1 + 1 | 0;
         if (i1 >>> 0 >= i5 >>> 0) break; else i2 = i2 + 4 | 0;
        }
        break;
       }
      case 2:
       {
        if ((i3 | 0) > 0) while (1) {
         HEAP32[i2 >> 2] = (HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0);
         i1 = i1 + 2 | 0;
         if (i1 >>> 0 >= i5 >>> 0) break; else i2 = i2 + 4 | 0;
        }
        break;
       }
      case 3:
       {
        if ((i3 | 0) > 0) while (1) {
         HEAP32[i2 >> 2] = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0);
         i1 = i1 + 3 | 0;
         if (i1 >>> 0 >= i5 >>> 0) break; else i2 = i2 + 4 | 0;
        }
        break;
       }
      default:
       if ((i3 | 0) > 0) while (1) {
        HEAP32[i2 >> 2] = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
        i1 = i1 + 4 | 0;
        if (i1 >>> 0 >= i5 >>> 0) break; else i2 = i2 + 4 | 0;
       }
      }
      _UNITY_FT_Stream_ExitFrame(i6);
      if (!(HEAP32[i9 >> 2] | 0)) break;
     }
    }
   }
   _UNITY_ft_mem_free(i7, HEAP32[i18 >> 2] | 0);
   HEAP32[i18 >> 2] = 0;
   i13 = HEAP32[i9 >> 2] | 0;
   HEAP32[i17 >> 2] = i13;
   if (!i13) {
    i9 = i8;
    break L1;
   }
   i18 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i19;
   return i18 | 0;
  } while (0);
  HEAP32[i17 >> 2] = 0;
  i9 = i8;
 } else i9 = i14 + 8 | 0; while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i18 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i12 = _UNITY_ft_mem_realloc(i10, 4, 0, i1 + 1 | 0, 0, i17) | 0;
 if (HEAP32[i17 >> 2] | 0) {
  i18 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i13 = (i16 | 0) != 0;
 if (i13) {
  i1 = _UNITY_ft_mem_alloc(i10, (HEAP32[i9 >> 2] | 0) + (HEAP32[i14 + 20 >> 2] | 0) | 0, i17) | 0;
  if (HEAP32[i17 >> 2] | 0) {
   i18 = HEAP32[i17 >> 2] | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 } else i1 = 0;
 i11 = HEAP32[i14 + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = i13 ? i1 : i11;
 i5 = HEAP32[i9 >> 2] | 0;
 L38 : do if (i5 | 0) {
  i10 = i14 + 20 | 0;
  if (i13) {
   i2 = 0;
   i7 = 0;
   i8 = 1;
   i4 = i5;
  } else {
   i2 = 0;
   i4 = 1;
   while (1) {
    i3 = (HEAP32[(HEAP32[i18 >> 2] | 0) + (i4 << 2) >> 2] | 0) + -1 | 0;
    if (i3 >>> 0 >= i2 >>> 0) {
     i2 = HEAP32[i10 >> 2] | 0;
     i2 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
    }
    HEAP32[i12 + (i4 << 2) >> 2] = i11 + i2;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 > i5 >>> 0) break L38;
   }
  }
  while (1) {
   i3 = (HEAP32[(HEAP32[i18 >> 2] | 0) + (i8 << 2) >> 2] | 0) + -1 | 0;
   if (i3 >>> 0 < i7 >>> 0) {
    HEAP32[i12 + (i8 << 2) >> 2] = i1 + i7 + i2;
    i3 = i7;
   } else {
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = i3 >>> 0 > i5 >>> 0 ? i5 : i3;
    i5 = i1 + i3 + i2 | 0;
    i6 = i12 + (i8 << 2) | 0;
    HEAP32[i6 >> 2] = i5;
    if ((i3 | 0) != (i7 | 0)) {
     i4 = HEAP32[i12 + (i8 + -1 << 2) >> 2] | 0;
     _memcpy(i4 | 0, i11 + i7 | 0, i5 - i4 | 0) | 0;
     HEAP8[HEAP32[i6 >> 2] >> 0] = 0;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i2 = i2 + 1 | 0;
     i4 = HEAP32[i9 >> 2] | 0;
    }
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 > i4 >>> 0) break; else i7 = i3;
  }
 } while (0);
 HEAP32[i15 >> 2] = i12;
 if (!i13) {
  i18 = HEAP32[i17 >> 2] | 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i18 = HEAP32[i17 >> 2] | 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i3, i1, i10, i9, i11) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i12 = i3 + 36 | 0;
 i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0;
 do if (i2 | 0) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
   i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0;
   if (!i2) break;
   if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
    i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0;
    if (!i2) break;
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
     i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0;
     if (!i2) break;
     if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) break;
    }
   }
  }
  i8 = i3 + 44 | 0;
  HEAP8[i8 >> 0] = HEAP8[i8 >> 0] | 1;
 } while (0);
 i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0) {
  i8 = i3 + 44 | 0;
  HEAP8[i8 >> 0] = HEAP8[i8 >> 0] | 2;
 }
 __ZN4Mesh18CreateMeshIfNeededEv(i3);
 i8 = i3 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i2 + 96 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (HEAP32[i4 + 44 >> 2] | 0) if (HEAP32[i2 + 100 >> 2] | 0) {
  if (i11) i7 = i1 + 4 | 0; else {
   HEAP32[i1 >> 2] = HEAP32[i4 + 8 >> 2];
   i7 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = 0;
  }
  if (HEAP32[i4 + 12 >> 2] | 0) {
   i6 = i4 + 12 | 0;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i1 + 8 + (HEAP32[i7 >> 2] << 3) | 0;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   HEAP32[i7 >> 2] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   if (HEAP32[i4 + 20 >> 2] | 0) {
    i6 = i4 + 20 | 0;
    i4 = HEAP32[i6 + 4 >> 2] | 0;
    i2 = i1 + 8 + (i2 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i2 + 4 >> 2] = i4;
    i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
    HEAP32[i7 >> 2] = i2;
    i4 = HEAP32[i12 >> 2] | 0;
    if (HEAP32[i4 + 28 >> 2] | 0) {
     i6 = i4 + 28 | 0;
     i4 = HEAP32[i6 + 4 >> 2] | 0;
     i2 = i1 + 8 + (i2 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i2 + 4 >> 2] = i4;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
     i4 = HEAP32[i12 >> 2] | 0;
     if (HEAP32[i4 + 36 >> 2] | 0) {
      i4 = i4 + 36 | 0;
      i5 = HEAP32[i4 + 4 >> 2] | 0;
      i6 = i1 + 8 + (i2 << 3) | 0;
      HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     }
    }
   }
  }
  if (!i9) i2 = 0; else {
   i5 = HEAP32[i7 >> 2] | 0;
   i6 = i9 + 36 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (!(HEAP32[i2 + 12 >> 2] | 0)) i2 = i5; else {
    i13 = i2 + 12 | 0;
    i4 = HEAP32[i13 + 4 >> 2] | 0;
    i2 = i1 + 8 + (i5 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i2 + 4 >> 2] = i4;
    i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
    HEAP32[i7 >> 2] = i2;
    i4 = HEAP32[i6 >> 2] | 0;
    if (HEAP32[i4 + 20 >> 2] | 0) {
     i13 = i4 + 20 | 0;
     i4 = HEAP32[i13 + 4 >> 2] | 0;
     i2 = i1 + 8 + (i5 + 1 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i2 + 4 >> 2] = i4;
     i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i2;
     i4 = HEAP32[i6 >> 2] | 0;
     if (HEAP32[i4 + 28 >> 2] | 0) {
      i13 = i4 + 28 | 0;
      i4 = HEAP32[i13 + 4 >> 2] | 0;
      i2 = i1 + 8 + (i5 + 2 << 3) | 0;
      HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i2 + 4 >> 2] = i4;
      i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
      HEAP32[i7 >> 2] = i2;
      i4 = HEAP32[i6 >> 2] | 0;
      if (HEAP32[i4 + 36 >> 2] | 0) {
       i4 = i4 + 36 | 0;
       i13 = HEAP32[i4 + 4 >> 2] | 0;
       i2 = i1 + 8 + (i5 + 3 << 3) | 0;
       HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i2 + 4 >> 2] = i13;
       i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
       HEAP32[i7 >> 2] = i2;
      }
     }
    }
   }
   if ((i5 | 0) == (i2 | 0)) i2 = 0; else {
    i3 = HEAP32[(HEAP32[i9 + 32 >> 2] | 0) + 96 >> 2] | i3;
    i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0;
   }
  }
  if (!i11) {
   i13 = __Z12GetGfxDevicev() | 0;
   __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj(i13, i1, HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0, i10, i3);
   HEAP32[i1 + 40 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(HEAP32[(HEAP32[i12 >> 2] | 0) + 44 >> 2] | 0, i10, i2) | 0;
  }
  if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i7 >> 2] | 0)) {
   i13 = 0;
   return i13 | 0;
  }
  i13 = 1;
  return i13 | 0;
 }
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i13 = 0;
 return i13 | 0;
}

function _access_virt_barray(i14, i18, i19, i1, i20) {
 i14 = i14 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0;
 i16 = i1 + i19 | 0;
 i13 = i18 + 4 | 0;
 if (i16 >>> 0 > (HEAP32[i13 >> 2] | 0) >>> 0) i15 = 4; else if ((HEAP32[i18 + 12 >> 2] | 0) >>> 0 < i1 >>> 0) i15 = 4; else if (!(HEAP32[i18 >> 2] | 0)) i15 = 4;
 if ((i15 | 0) == 4) {
  i17 = HEAP32[i14 >> 2] | 0;
  HEAP32[i17 + 20 >> 2] = 22;
  mftCall_vi(HEAP32[i17 >> 2] | 0, i14 | 0);
 }
 i17 = i18 + 24 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 >>> 0 > i19 >>> 0) i15 = 7; else if (i16 >>> 0 > ((HEAP32[i18 + 16 >> 2] | 0) + i1 | 0) >>> 0) i15 = 7;
 L9 : do if ((i15 | 0) == 7) {
  if (!(HEAP8[i18 + 34 >> 0] | 0)) {
   i12 = HEAP32[i14 >> 2] | 0;
   HEAP32[i12 + 20 >> 2] = 69;
   mftCall_vi(HEAP32[i12 >> 2] | 0, i14 | 0);
  }
  i6 = i18 + 33 | 0;
  if (HEAP8[i6 >> 0] | 0) {
   i7 = HEAP32[i18 + 8 >> 2] << 7;
   i2 = HEAP32[i17 >> 2] | 0;
   i8 = i18 + 20 | 0;
   i9 = i18 + 16 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L16 : do if ((i1 | 0) > 0) {
    i10 = i18 + 28 | 0;
    i11 = i18 + 40 | 0;
    i12 = i18 + 44 | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i1 = (i5 | 0) < (i1 | 0) ? i5 : i1;
    i5 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
    i5 = (i1 | 0) < (i5 | 0) ? i1 : i5;
    i1 = (HEAP32[i13 >> 2] | 0) - i2 | 0;
    i1 = (i5 | 0) < (i1 | 0) ? i5 : i1;
    if ((i1 | 0) >= 1) {
     i4 = Math_imul(i2, i7) | 0;
     i5 = 0;
     while (1) {
      i3 = Math_imul(i1, i7) | 0;
      mftCall_viiiii(HEAP32[i12 >> 2] | 0, i14 | 0, i11 | 0, HEAP32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2] | 0, i4 | 0, i3 | 0);
      i1 = HEAP32[i8 >> 2] | 0;
      i5 = i1 + i5 | 0;
      i2 = HEAP32[i9 >> 2] | 0;
      if ((i2 | 0) <= (i5 | 0)) break L16;
      i21 = i2 - i5 | 0;
      i21 = (i1 | 0) < (i21 | 0) ? i1 : i21;
      i1 = i5 + (HEAP32[i17 >> 2] | 0) | 0;
      i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
      i2 = (i21 | 0) < (i2 | 0) ? i21 : i2;
      i1 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
      i1 = (i2 | 0) < (i1 | 0) ? i2 : i1;
      if ((i1 | 0) < 1) break; else i4 = i3 + i4 | 0;
     }
    }
   } while (0);
   HEAP8[i6 >> 0] = 0;
  }
  i6 = i18 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i17 >> 2] | 0) >>> 0 < i19 >>> 0) i2 = i19; else {
   i2 = i16 - i1 | 0;
   i2 = (i2 | 0) < 0 ? 0 : i2;
  }
  HEAP32[i17 >> 2] = i2;
  i7 = HEAP32[i18 + 8 >> 2] << 7;
  i8 = i18 + 20 | 0;
  if ((i1 | 0) > 0) {
   i9 = i18 + 28 | 0;
   i10 = i18 + 40 | 0;
   i21 = HEAP32[i8 >> 2] | 0;
   i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
   i21 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
   i21 = (i1 | 0) < (i21 | 0) ? i1 : i21;
   i1 = (HEAP32[i13 >> 2] | 0) - i2 | 0;
   i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
   if ((i1 | 0) >= 1) {
    i4 = Math_imul(i7, i2) | 0;
    i5 = 0;
    while (1) {
     i3 = Math_imul(i1, i7) | 0;
     mftCall_viiiii(HEAP32[i10 >> 2] | 0, i14 | 0, i10 | 0, HEAP32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2] | 0, i4 | 0, i3 | 0);
     i1 = HEAP32[i8 >> 2] | 0;
     i5 = i1 + i5 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     if ((i2 | 0) <= (i5 | 0)) break L9;
     i12 = i2 - i5 | 0;
     i12 = (i1 | 0) < (i12 | 0) ? i1 : i12;
     i1 = i5 + (HEAP32[i17 >> 2] | 0) | 0;
     i21 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
     i21 = (i12 | 0) < (i21 | 0) ? i12 : i21;
     i1 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
     i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
     if ((i1 | 0) < 1) break; else i4 = i3 + i4 | 0;
    }
   }
  }
 } while (0);
 i3 = i18 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (i1 >>> 0 < i16 >>> 0) {
  i2 = i20 << 24 >> 24 == 0;
  if (i1 >>> 0 < i19 >>> 0) if (i2) {
   i1 = i19;
   i2 = 0;
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 22;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i14 | 0);
   i1 = i19;
   i15 = 28;
  } else if (i2) i2 = 0; else i15 = 28;
  if ((i15 | 0) == 28) {
   HEAP32[i3 >> 2] = i16;
   i2 = 1;
  }
  if (!(HEAP8[i18 + 32 >> 0] | 0)) {
   if (i2) break;
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i21 + 20 >> 2] = 22;
   mftCall_vi(HEAP32[i21 >> 2] | 0, i14 | 0);
   break;
  }
  i3 = HEAP32[i18 + 8 >> 2] << 7;
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = i1 - i2 | 0;
  i2 = i16 - i2 | 0;
  if (i1 >>> 0 < i2 >>> 0) do {
   _jzero_far(HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0, i3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 } while (0);
 if (!(i20 << 24 >> 24)) {
  i20 = HEAP32[i18 >> 2] | 0;
  i21 = HEAP32[i17 >> 2] | 0;
  i21 = i19 - i21 | 0;
  i21 = i20 + (i21 << 2) | 0;
  return i21 | 0;
 }
 HEAP8[i18 + 33 >> 0] = 1;
 i20 = HEAP32[i18 >> 2] | 0;
 i21 = HEAP32[i17 >> 2] | 0;
 i21 = i19 - i21 | 0;
 i21 = i20 + (i21 << 2) | 0;
 return i21 | 0;
}

function __ZNK18ProceduralMaterial9GetPresetEv(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i12 = i14 + 16 | 0;
 i11 = i14 + 8 | 0;
 i10 = i14;
 i8 = i14 + 48 | 0;
 i9 = i14 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 434043 | 0, 43);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434087 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 1087627 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434114 | 0) | 0;
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 i4 = i1 + 180 | 0;
 if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434166 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434181 | 0) | 0;
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 11 | 0;
 i6 = i9 + 4 | 0;
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434196 | 0) | 0;
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
  } else {
   i3 = i2;
   i1 = i1 & 255;
  };
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i3, i1);
  i3 = HEAP8[i5 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i1 ? HEAP32[i9 >> 2] | 0 : i9, i1 ? HEAP32[i6 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434223 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i2 + 96 >> 2];
  _snprintf(i8, 256, gb + 1084495 | 0, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434231 | 0) | 0;
  i3 = i2 + 88 | 0;
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  _snprintf(i8, 256, gb + 1084492 | 0, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434240 | 0) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  L10 : do if ((i3 | 0) != 5) {
   i1 = i3 + -4 | 0;
   if (i1 >>> 0 < 7) i1 = (113 >>> (i1 & 127) & 1) != 0; else i1 = 0;
   switch (i3 | 0) {
   case 4:
   case 0:
    {
     i3 = 1;
     break;
    }
   case 8:
   case 1:
    {
     i3 = 2;
     break;
    }
   case 9:
   case 2:
    {
     i3 = 3;
     break;
    }
   case 10:
   case 3:
    {
     i3 = 4;
     break;
    }
   default:
    break L10;
   }
   if (i1) {
    i1 = 0;
    do {
     if ((i1 | 0) > 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 1087585 | 0) | 0;
     HEAP32[i12 >> 2] = ~~Math_fround(HEAPF32[i2 + 68 + (i1 << 2) >> 2]);
     _snprintf(i8, 256, gb + 1084492 | 0, i12) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, i8) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   } else {
    i1 = 0;
    do {
     if ((i1 | 0) > 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 1087585 | 0) | 0;
     HEAPF64[i13 >> 3] = +Math_fround(HEAPF32[i2 + 68 + (i1 << 2) >> 2]);
     _snprintf(i8, 256, gb + 1084516 | 0, i13) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, i8) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434250 | 0) | 0;
  i2 = i2 + 156 | 0;
 } while ((i2 | 0) != (HEAP32[i4 >> 2] | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434166 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 434181 | 0) | 0;
 STACKTOP = i14;
 return;
}

function __ZN5physx50solveDriveNWInternalDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 4544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i35 + 2408 | 0;
 i24 = i35 + 2312 | 0;
 i34 = i35 + 2216 | 0;
 i25 = i35;
 i26 = i35 + 4528 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 i21 = HEAP32[i1 + 20 >> 2] | 0;
 i22 = HEAP32[i1 + 24 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 i11 = HEAP32[i1 + 36 >> 2] | 0;
 i16 = HEAP32[i1 + 40 >> 2] | 0;
 i12 = HEAP32[i1 + 44 >> 2] | 0;
 i29 = HEAP32[i1 + 48 >> 2] | 0;
 i13 = HEAP32[i1 + 52 >> 2] | 0;
 i33 = HEAP32[i1 + 60 >> 2] | 0;
 i14 = HEAP32[i1 + 64 >> 2] | 0;
 i27 = HEAP32[i1 + 68 >> 2] | 0;
 i31 = HEAP32[i3 + 4 >> 2] | 0;
 i30 = HEAP32[i3 >> 2] | 0;
 f2 = Math_fround(f20 * f15);
 f4 = Math_fround(f15 * f2);
 i28 = i33 + 1 | 0;
 HEAP32[i23 + 2116 >> 2] = i28;
 HEAP32[i24 + 92 >> 2] = i28;
 HEAP32[i34 + 92 >> 2] = i28;
 i31 = i31 + 76 | 0;
 f17 = Math_fround(HEAPF32[i31 >> 2]);
 i28 = (i33 | 0) == 0;
 if (i28) f2 = Math_fround(f10 * Math_fround(HEAPF32[i27 + 104 >> 2])); else {
  i5 = 0;
  do {
   i1 = i5 >>> 2;
   i3 = i5 & 3;
   f7 = Math_fround(f10 * Math_fround(HEAPF32[i14 + (i1 * 944 | 0) + 192 + (i3 * 48 | 0) + 40 >> 2]));
   f8 = Math_fround(HEAPF32[i11 + (i5 << 2) >> 2]);
   f6 = Math_fround(f8 * Math_fround(f4 * f7));
   i9 = 0;
   do {
    HEAPF32[i23 + (i5 * 92 | 0) + (i9 << 2) >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i16 + (i9 << 2) >> 2]));
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i33 | 0));
   f6 = Math_fround(Math_fround(f6 * Math_fround(HEAPF32[i16 + (i5 << 2) >> 2])) + Math_fround(1.0));
   HEAPF32[i23 + (i5 * 92 | 0) + (i5 << 2) >> 2] = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i14 + (i1 * 944 | 0) + 192 + (i3 * 48 | 0) + 16 >> 2])));
   HEAPF32[i23 + (i5 * 92 | 0) + (i33 << 2) >> 2] = Math_fround(-Math_fround(f8 * Math_fround(f2 * f7)));
   f8 = Math_fround(HEAPF32[i30 + (i1 * 224 | 0) + (i3 << 2) >> 2]);
   f6 = Math_fround(HEAPF32[i12 + (i5 << 2) >> 2]);
   HEAPF32[i24 + (i5 << 2) >> 2] = Math_fround(f8 + Math_fround(f7 * Math_fround(f6 + Math_fround(HEAPF32[i13 + (i5 << 2) >> 2]))));
   HEAPF32[i34 + (i5 << 2) >> 2] = f8;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i33 | 0));
  f2 = Math_fround(f10 * Math_fround(HEAPF32[i27 + 104 >> 2]));
  f4 = Math_fround(f15 * Math_fround(f20 * f2));
  if (!i28) {
   i1 = 0;
   do {
    HEAPF32[i23 + (i33 * 92 | 0) + (i1 << 2) >> 2] = Math_fround(-Math_fround(f4 * Math_fround(HEAPF32[i16 + (i1 << 2) >> 2])));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i33 | 0));
  }
 }
 HEAPF32[i23 + (i33 * 92 | 0) + (i33 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f20 + f19) * f2) + Math_fround(1.0));
 HEAPF32[i24 + (i33 << 2) >> 2] = Math_fround(f17 + Math_fround(f18 * f2));
 i5 = i34 + (i33 << 2) | 0;
 HEAPF32[i5 >> 2] = f17;
 if ((i21 | 0) == 1) {
  HEAP32[i25 + 2208 >> 2] = 0;
  __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i25, i23);
  __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i25, i24, i34);
 } else __ZNK5physx24MatrixNGaussSeidelSolver5solveEjfRKNS_8MatrixNNERKNS_7VectorNERS4_(i26, i22, Math_fround(1.00000001e-10), i23, i24, i34);
 if (!i28) {
  i3 = 0;
  do {
   if (!(HEAP8[i29 + i3 >> 0] | 0)) {
    i32 = i34 + (i3 << 2) | 0;
    i1 = i32;
    f2 = Math_fround(HEAPF32[i32 >> 2]);
    i32 = 15;
   } else {
    f20 = Math_fround(HEAPF32[i30 + ((i3 >>> 2) * 224 | 0) + ((i3 & 3) << 2) >> 2]);
    i1 = i34 + (i3 << 2) | 0;
    f2 = Math_fround(HEAPF32[i1 >> 2]);
    if (!(Math_fround(f20 * f2) <= Math_fround(0.0))) i32 = 15; else f2 = Math_fround(0.0);
   }
   if ((i32 | 0) == 15) i32 = 0;
   HEAPF32[i1 >> 2] = f2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i33 | 0));
 }
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f20 = Math_fround(HEAPF32[i27 + 88 >> 2]);
 i32 = f2 < Math_fround(0.0);
 f2 = i32 ? Math_fround(0.0) : f2;
 f2 = f2 > f20 ? f20 : f2;
 HEAPF32[i5 >> 2] = f2;
 if (i28) {
  HEAPF32[i31 >> 2] = f2;
  STACKTOP = i35;
  return;
 } else i1 = 0;
 do {
  HEAP32[i30 + ((i1 >>> 2) * 224 | 0) + ((i1 & 3) << 2) >> 2] = HEAP32[i34 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i33 | 0));
 HEAPF32[i31 >> 2] = f2;
 STACKTOP = i35;
 return;
}

function __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEEEEEjT_j(i9, i12, i13) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i14 + 728 | 0;
 i8 = i14 + 664 | 0;
 i6 = i14 + 332 | 0;
 i7 = HEAP32[i9 + 44 >> 2] | 0;
 i5 = HEAP32[i9 + 36 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i10;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i12 + 8 >> 2] | 0);
 i6 = i12 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i10);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i11 + 16 >> 2] = i3;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i10, i11, 0) | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i9 + 52 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i15 = i11 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i12, i11);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i15 = i13 + 5 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i15 = i13 + 5 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i9, i12, i13) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i14 + 728 | 0;
 i8 = i14 + 664 | 0;
 i6 = i14 + 332 | 0;
 i7 = HEAP32[i9 + 44 >> 2] | 0;
 i5 = HEAP32[i9 + 36 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i10;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i12 + 8 >> 2] | 0);
 i6 = i12 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i10);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i11 + 16 >> 2] = i3;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i10, i11, 0) | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i9 + 52 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i15 = i11 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i12, i11);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i15 = i13 + 5 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i15 = i13 + 5 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i9, i12, i13) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i14 + 728 | 0;
 i8 = i14 + 664 | 0;
 i6 = i14 + 332 | 0;
 i7 = HEAP32[i9 + 44 >> 2] | 0;
 i5 = HEAP32[i9 + 36 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i10;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i12 + 8 >> 2] | 0);
 i6 = i12 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i10);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i1;
 HEAP32[i11 + 16 >> 2] = i3;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i10, i11, 0) | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i9 + 52 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i15 = i11 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i5;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i10;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i12, i11);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i15 = i13 + 5 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i15 = i13 + 5 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZNK11DynamicMesh13MergePolygonsER13dynamic_arrayI8Vector3fLj4EERKS2_S5_(i1, i24, i22, i25) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0;
 i26 = i24 + 12 | 0;
 HEAP32[i26 >> 2] = 0;
 i20 = HEAP32[i22 + 12 >> 2] | 0;
 i23 = HEAP32[i25 + 12 >> 2] | 0;
 if (i20 >>> 0 < 3 | i23 >>> 0 < 3) return 0;
 if ((i20 + -2 + i23 | 0) >>> 0 > 6) return 0;
 if (!i20) {
  i25 = 0;
  i26 = 0;
  i26 = i25 & i26;
  return i26 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 i3 = HEAP32[i25 >> 2] | 0;
 if (!i23) {
  i25 = 0;
  i26 = 0;
  i26 = i25 & i26;
  return i26 | 0;
 } else i19 = 0;
 L12 : while (1) {
  i4 = i19 + 1 | 0;
  i5 = (i4 | 0) == (i20 | 0) ? 0 : i4;
  f6 = Math_fround(HEAPF32[i2 + (i19 * 12 | 0) >> 2]);
  i7 = i2 + (i19 * 12 | 0) + 4 | 0;
  i8 = i2 + (i19 * 12 | 0) + 8 | 0;
  i9 = i2 + (i5 * 12 | 0) | 0;
  i10 = i2 + (i5 * 12 | 0) + 4 | 0;
  i11 = i2 + (i5 * 12 | 0) + 8 | 0;
  i21 = 0;
  while (1) {
   i12 = i21 + 1 | 0;
   i1 = (i12 | 0) == (i23 | 0) ? 0 : i12;
   if (f6 == Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2])) {
    f27 = Math_fround(HEAPF32[i7 >> 2]);
    if (f27 == Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2])) {
     f15 = Math_fround(HEAPF32[i8 >> 2]);
     if (f15 == Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2])) {
      f16 = Math_fround(HEAPF32[i9 >> 2]);
      if (f16 == Math_fround(HEAPF32[i3 + (i21 * 12 | 0) >> 2])) {
       f27 = Math_fround(HEAPF32[i10 >> 2]);
       if (f27 == Math_fround(HEAPF32[i3 + (i21 * 12 | 0) + 4 >> 2])) {
        f17 = Math_fround(HEAPF32[i11 >> 2]);
        if (f17 == Math_fround(HEAPF32[i3 + (i21 * 12 | 0) + 8 >> 2])) break L12;
       }
      }
     }
    }
   }
   if (i12 >>> 0 < i23 >>> 0) i21 = i12; else break;
  }
  if (i4 >>> 0 < i20 >>> 0) i19 = i4; else {
   i13 = 0;
   i14 = 0;
   i18 = 24;
   break;
  }
 }
 if ((i18 | 0) == 24) {
  i26 = i13 & i14;
  return i26 | 0;
 }
 i18 = i1 + 1 | 0;
 i14 = i2 + ((((i19 | 0) == 0 ? i20 : i19) + -1 | 0) * 12 | 0) | 0;
 i18 = i3 + (((i18 | 0) == (i23 | 0) ? 0 : i18) * 12 | 0) | 0;
 f29 = Math_fround(HEAPF32[i14 >> 2]);
 f6 = Math_fround(f6 - f29);
 f27 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f28 = Math_fround(f15 - f27);
 f15 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f29);
 if (Math_fround(Math_fround(f28 * f15) - Math_fround(f6 * Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) - f27))) <= Math_fround(0.0)) {
  i25 = 1;
  i26 = 0;
  i26 = i25 & i26;
  return i26 | 0;
 }
 i14 = i5 + 1 | 0;
 i14 = i2 + (((i14 | 0) == (i20 | 0) ? 0 : i14) * 12 | 0) | 0;
 i18 = i3 + ((((i21 | 0) == 0 ? i23 : i21) + -1 | 0) * 12 | 0) | 0;
 f29 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f16);
 f27 = Math_fround(Math_fround(HEAPF32[i14 + 8 >> 2]) - f17);
 f28 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f16);
 if (Math_fround(Math_fround(f27 * f28) - Math_fround(f29 * Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) - f17))) <= Math_fround(0.0)) {
  i25 = 1;
  i26 = 0;
  i26 = i25 & i26;
  return i26 | 0;
 }
 if ((i5 | 0) != (i19 | 0)) {
  __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i24, i2 + (i5 * 12 | 0) | 0);
  i2 = i5 + 1 | 0;
  i2 = (i2 | 0) == (i20 | 0) ? 0 : i2;
  if ((i2 | 0) != (i19 | 0)) do {
   __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i24, (HEAP32[i22 >> 2] | 0) + (i2 * 12 | 0) | 0);
   i18 = i2 + 1 | 0;
   i2 = (i18 | 0) == (i20 | 0) ? 0 : i18;
  } while ((i2 | 0) != (i19 | 0));
 }
 if ((i1 | 0) != (i21 | 0)) do {
  __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i24, (HEAP32[i25 >> 2] | 0) + (i1 * 12 | 0) | 0);
  i22 = i1 + 1 | 0;
  i1 = (i22 | 0) == (i23 | 0) ? 0 : i22;
 } while ((i1 | 0) != (i21 | 0));
 i3 = HEAP32[i24 >> 2] | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (i1 >>> 0 >= i2 >>> 0) {
   i13 = 1;
   i14 = 1;
   i18 = 24;
   break;
  }
  i25 = i3 + ((((i1 | 0) == 0 ? i2 : i1) + -1 | 0) * 12 | 0) | 0;
  i24 = i3 + (i1 * 12 | 0) | 0;
  i1 = i1 + 1 | 0;
  i26 = i3 + (((i1 | 0) == (i2 | 0) ? 0 : i1) * 12 | 0) | 0;
  f28 = Math_fround(HEAPF32[i24 >> 2]);
  f27 = Math_fround(HEAPF32[i25 >> 2]);
  f28 = Math_fround(f28 - f27);
  f17 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  f29 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  f17 = Math_fround(f17 - f29);
  f27 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f27);
  if (Math_fround(Math_fround(f17 * f27) - Math_fround(f28 * Math_fround(Math_fround(HEAPF32[i26 + 8 >> 2]) - f29))) <= Math_fround(.00999999977)) {
   i13 = 1;
   i14 = 0;
   i18 = 24;
   break;
  }
 }
 if ((i18 | 0) == 24) {
  i26 = i13 & i14;
  return i26 | 0;
 }
 return 0;
}

function _access_virt_sarray(i14, i18, i19, i1, i20) {
 i14 = i14 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0;
 i16 = i1 + i19 | 0;
 i13 = i18 + 4 | 0;
 if (i16 >>> 0 > (HEAP32[i13 >> 2] | 0) >>> 0) i15 = 4; else if ((HEAP32[i18 + 12 >> 2] | 0) >>> 0 < i1 >>> 0) i15 = 4; else if (!(HEAP32[i18 >> 2] | 0)) i15 = 4;
 if ((i15 | 0) == 4) {
  i17 = HEAP32[i14 >> 2] | 0;
  HEAP32[i17 + 20 >> 2] = 22;
  mftCall_vi(HEAP32[i17 >> 2] | 0, i14 | 0);
 }
 i17 = i18 + 24 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 >>> 0 > i19 >>> 0) i15 = 7; else if (i16 >>> 0 > ((HEAP32[i18 + 16 >> 2] | 0) + i1 | 0) >>> 0) i15 = 7;
 L9 : do if ((i15 | 0) == 7) {
  if (!(HEAP8[i18 + 34 >> 0] | 0)) {
   i12 = HEAP32[i14 >> 2] | 0;
   HEAP32[i12 + 20 >> 2] = 69;
   mftCall_vi(HEAP32[i12 >> 2] | 0, i14 | 0);
  }
  i6 = i18 + 33 | 0;
  if (HEAP8[i6 >> 0] | 0) {
   i7 = HEAP32[i18 + 8 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   i8 = i18 + 20 | 0;
   i9 = i18 + 16 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L16 : do if ((i1 | 0) > 0) {
    i10 = i18 + 28 | 0;
    i11 = i18 + 40 | 0;
    i12 = i18 + 44 | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i1 = (i5 | 0) < (i1 | 0) ? i5 : i1;
    i5 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
    i5 = (i1 | 0) < (i5 | 0) ? i1 : i5;
    i1 = (HEAP32[i13 >> 2] | 0) - i2 | 0;
    i1 = (i5 | 0) < (i1 | 0) ? i5 : i1;
    if ((i1 | 0) >= 1) {
     i4 = Math_imul(i2, i7) | 0;
     i5 = 0;
     while (1) {
      i3 = Math_imul(i1, i7) | 0;
      mftCall_viiiii(HEAP32[i12 >> 2] | 0, i14 | 0, i11 | 0, HEAP32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2] | 0, i4 | 0, i3 | 0);
      i1 = HEAP32[i8 >> 2] | 0;
      i5 = i1 + i5 | 0;
      i2 = HEAP32[i9 >> 2] | 0;
      if ((i2 | 0) <= (i5 | 0)) break L16;
      i21 = i2 - i5 | 0;
      i21 = (i1 | 0) < (i21 | 0) ? i1 : i21;
      i1 = i5 + (HEAP32[i17 >> 2] | 0) | 0;
      i2 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
      i2 = (i21 | 0) < (i2 | 0) ? i21 : i2;
      i1 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
      i1 = (i2 | 0) < (i1 | 0) ? i2 : i1;
      if ((i1 | 0) < 1) break; else i4 = i3 + i4 | 0;
     }
    }
   } while (0);
   HEAP8[i6 >> 0] = 0;
  }
  i6 = i18 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i17 >> 2] | 0) >>> 0 < i19 >>> 0) i2 = i19; else {
   i2 = i16 - i1 | 0;
   i2 = (i2 | 0) < 0 ? 0 : i2;
  }
  HEAP32[i17 >> 2] = i2;
  i7 = HEAP32[i18 + 8 >> 2] | 0;
  i8 = i18 + 20 | 0;
  if ((i1 | 0) > 0) {
   i9 = i18 + 28 | 0;
   i10 = i18 + 40 | 0;
   i21 = HEAP32[i8 >> 2] | 0;
   i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
   i21 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
   i21 = (i1 | 0) < (i21 | 0) ? i1 : i21;
   i1 = (HEAP32[i13 >> 2] | 0) - i2 | 0;
   i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
   if ((i1 | 0) >= 1) {
    i4 = Math_imul(i7, i2) | 0;
    i5 = 0;
    while (1) {
     i3 = Math_imul(i1, i7) | 0;
     mftCall_viiiii(HEAP32[i10 >> 2] | 0, i14 | 0, i10 | 0, HEAP32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2] | 0, i4 | 0, i3 | 0);
     i2 = HEAP32[i8 >> 2] | 0;
     i5 = i2 + i5 | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if ((i1 | 0) <= (i5 | 0)) break L9;
     i12 = i1 - i5 | 0;
     i12 = (i2 | 0) < (i12 | 0) ? i2 : i12;
     i1 = i5 + (HEAP32[i17 >> 2] | 0) | 0;
     i21 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
     i21 = (i12 | 0) < (i21 | 0) ? i12 : i21;
     i1 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
     i1 = (i21 | 0) < (i1 | 0) ? i21 : i1;
     if ((i1 | 0) < 1) break; else i4 = i3 + i4 | 0;
    }
   }
  }
 } while (0);
 i3 = i18 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (i1 >>> 0 < i16 >>> 0) {
  i2 = i20 << 24 >> 24 == 0;
  if (i1 >>> 0 < i19 >>> 0) if (i2) {
   i1 = i19;
   i2 = 0;
  } else {
   i1 = HEAP32[i14 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 22;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i14 | 0);
   i1 = i19;
   i15 = 28;
  } else if (i2) i2 = 0; else i15 = 28;
  if ((i15 | 0) == 28) {
   HEAP32[i3 >> 2] = i16;
   i2 = 1;
  }
  if (!(HEAP8[i18 + 32 >> 0] | 0)) {
   if (i2) break;
   i21 = HEAP32[i14 >> 2] | 0;
   HEAP32[i21 + 20 >> 2] = 22;
   mftCall_vi(HEAP32[i21 >> 2] | 0, i14 | 0);
   break;
  }
  i3 = HEAP32[i18 + 8 >> 2] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = i1 - i2 | 0;
  i2 = i16 - i2 | 0;
  if (i1 >>> 0 < i2 >>> 0) do {
   _jzero_far(HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0, i3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 } while (0);
 if (!(i20 << 24 >> 24)) {
  i20 = HEAP32[i18 >> 2] | 0;
  i21 = HEAP32[i17 >> 2] | 0;
  i21 = i19 - i21 | 0;
  i21 = i20 + (i21 << 2) | 0;
  return i21 | 0;
 }
 HEAP8[i18 + 33 >> 0] = 1;
 i20 = HEAP32[i18 >> 2] | 0;
 i21 = HEAP32[i17 >> 2] | 0;
 i21 = i19 - i21 | 0;
 i21 = i20 + (i21 << 2) | 0;
 return i21 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj477ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 136 | 0;
 i17 = i20 + 188 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 84 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 28 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj501ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj502ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 96 | 0, 1);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __ZN20TextRenderingPrivate7GUIText13GetScreenRectERK5RectTIfE(i17, i15, i1) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 56 | 0;
 i7 = i16 + 48 | 0;
 i13 = i16 + 24 | 0;
 i10 = i16;
 i11 = i16 + 20 | 0;
 i14 = i16 + 8 | 0;
 i1 = i15 + 36 | 0;
 i9 = i1 + 11 | 0;
 i6 = HEAP8[i9 >> 0] | 0;
 if (i6 << 24 >> 24 < 0) i6 = HEAP32[i15 + 40 >> 2] | 0; else i6 = i6 & 255;
 if (!i6) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  STACKTOP = i16;
  return;
 }
 __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv(i7, i15);
 i6 = HEAP32[i7 >> 2] | 0;
 if (!i6) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  STACKTOP = i16;
  return;
 }
 i6 = HEAP32[i6 + 48 >> 2] | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i18 = gb + 63672 | 0;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i20 = i10;
 HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i13, i1, i12);
 i20 = HEAP16[i15 + 54 >> 1] | 0;
 i19 = HEAP16[i15 + 52 >> 1] | 0;
 f8 = Math_fround(HEAPF32[i15 + 60 >> 2]);
 f3 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 i18 = (HEAP8[i15 + 65 >> 0] | 0) != 0;
 i10 = i15 + 64 | 0;
 i7 = (HEAP8[i10 >> 0] | 0) != 0;
 HEAP32[i11 >> 2] = HEAP32[i15 + 84 >> 2];
 i9 = HEAP32[i15 + 76 >> 2] | 0;
 i1 = HEAP32[i15 + 80 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 i1 = __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i13, i6, i20, i19, Math_fround(0.0), f8, f3, i18, i7, i12, Math_fround(1.0), i9, i1) | 0;
 __ZN11UTF16StringD2Ev(i13);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f4 = Math_fround(-f3);
 f2 = Math_fround(f8 * Math_fround(2.0));
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 8 >> 2] = f4;
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 12 >> 2] = f2;
 __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i12, i1, i13);
 f2 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i15 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  __ZNK9Transform11GetPositionEv(i13, i1);
  HEAPF32[i13 + 8 >> 2] = Math_fround(0.0);
  __ZNK9Transform18GetWorldScaleLossyEv(i14, i1);
  f5 = Math_fround(HEAPF32[i6 + 36 >> 2]);
  f21 = Math_fround(f5 * Math_fround(.0500000007));
  f21 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f21);
  HEAPF32[i14 >> 2] = f21;
  f5 = Math_fround(f5 * Math_fround(-.0500000007));
  i20 = i14 + 4 | 0;
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i20 >> 2]));
  HEAPF32[i20 >> 2] = f5;
  HEAPF32[i14 + 8 >> 2] = Math_fround(1.0);
  f2 = Math_fround(f2 * f21);
  f21 = Math_fround(f3 * f21);
  f4 = Math_fround(f4 * f5);
  f8 = Math_fround(f8 * f5);
  f5 = Math_fround(HEAPF32[i13 >> 2]);
  f5 = Math_fround(f2 + f5);
  f4 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) - f4);
  i20 = __Z16GetScreenManagerv() | 0;
  f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 80 >> 2] | 0, i20 | 0) | 0);
  f2 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 84 >> 2] | 0, i20 | 0) | 0);
  f5 = Math_fround(f5 * f3);
  f4 = Math_fround(f4 * f2);
  f3 = Math_fround(f21 * f3);
  f2 = Math_fround(f8 * f2);
 } else {
  i20 = __Z16GetScreenManagerv() | 0;
  f5 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 80 >> 2] | 0, i20 | 0) | 0);
  f21 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 84 >> 2] | 0, i20 | 0) | 0);
  __ZNK9Transform11GetPositionEv(i13, i1);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2]));
  f5 = Math_fround(Math_floor(Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i15 + 68 >> 2])) + Math_fround(.5))));
  HEAPF32[i13 >> 2] = f5;
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i13 + 4 >> 2]));
  f5 = Math_fround(f2 + f5);
  f4 = Math_fround(f4 + Math_fround(Math_floor(Math_fround(Math_fround(f21 + Math_fround(HEAPF32[i15 + 72 >> 2])) + Math_fround(.5)))));
  f2 = Math_fround(-f8);
 }
 i20 = f2 < Math_fround(0.0);
 f21 = Math_fround(-f2);
 f8 = Math_fround(f4 + f2);
 HEAPF32[i17 >> 2] = f5;
 HEAPF32[i17 + 4 >> 2] = i20 ? f8 : f4;
 HEAPF32[i17 + 8 >> 2] = f3;
 HEAPF32[i17 + 12 >> 2] = i20 ? f21 : f2;
 STACKTOP = i16;
 return;
}

function __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode0EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf(f18, i3, i20, i1, i24) {
 f18 = Math_fround(f18);
 i3 = i3 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 32 | 0;
 i22 = i26 + 16 | 0;
 i23 = i26;
 i25 = HEAP32[i1 + 12 >> 2] | 0;
 i19 = i20 + 84 | 0;
 if (!(HEAP16[i19 >> 1] | 0)) {
  f2 = Math_fround(HEAPF32[i20 + 80 >> 2]);
  f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i3 + 80 >> 2]) * f18));
  f2 = Math_fround(f2 - Math_fround(Math_floor(Math_fround(f2))));
  if (!i25) {
   STACKTOP = i26;
   return;
  } else i1 = 0;
  do {
   i23 = i24 + (i1 << 2) | 0;
   HEAPF32[i23 >> 2] = f2;
   HEAPF32[i23 + 4 >> 2] = f2;
   HEAPF32[i23 + 8 >> 2] = f2;
   HEAPF32[i23 + 12 >> 2] = f2;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i25 >>> 0);
  STACKTOP = i26;
  return;
 }
 if (!i25) {
  STACKTOP = i26;
  return;
 }
 i14 = i1 + 500 | 0;
 i15 = i23 + 4 | 0;
 i16 = i23 + 8 | 0;
 i17 = i23 + 12 | 0;
 i3 = i3 + 80 | 0;
 i4 = i21 + 4 | 0;
 i5 = i21 + 8 | 0;
 i6 = i21 + 12 | 0;
 i7 = i20 + 80 | 0;
 i8 = i20 + 232 | 0;
 i9 = i20 + 144 | 0;
 i1 = 0;
 do {
  i27 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
  i33 = HEAP32[i27 >> 2] | 0;
  i31 = HEAP32[i27 + 4 >> 2] | 0;
  i29 = HEAP32[i27 + 8 >> 2] | 0;
  i27 = HEAP32[i27 + 12 >> 2] | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  HEAP32[i22 + 8 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  i33 = i33 + 1454627760 | 0;
  i31 = i31 + 1454627760 | 0;
  i29 = i29 + 1454627760 | 0;
  i27 = i27 + 1454627760 | 0;
  i32 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i30 = (Math_imul(i31, 1790253981) | 0) + 1900727103 | 0;
  i28 = (Math_imul(i29, 1790253981) | 0) + 1900727103 | 0;
  i13 = (Math_imul(i27, 1790253981) | 0) + 1900727103 | 0;
  i33 = i33 << 11 ^ i33;
  i31 = i31 << 11 ^ i31;
  i29 = i29 << 11 ^ i29;
  i27 = i27 << 11 ^ i27;
  f2 = Math_fround(Math_fround((i32 ^ i33 ^ i33 >>> 8) & 8388607 ^ i32 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f10 = Math_fround(Math_fround((i30 ^ i31 ^ i31 >>> 8) & 8388607 ^ i30 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f11 = Math_fround(Math_fround((i28 ^ i29 ^ i29 >>> 8) & 8388607 ^ i28 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f12 = Math_fround(Math_fround((i13 ^ i27 ^ i27 >>> 8) & 8388607 ^ i13 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i23 >> 2] = f2;
  HEAPF32[i15 >> 2] = f10;
  HEAPF32[i16 >> 2] = f11;
  HEAPF32[i17 >> 2] = f12;
  i13 = HEAP32[i19 >> 2] | 0;
  L14 : do switch ((i13 & 65535) << 16 >> 16) {
  case 0:
   {
    i33 = HEAP32[i7 >> 2] | 0;
    HEAP32[i6 >> 2] = i33;
    HEAP32[i5 >> 2] = i33;
    HEAP32[i4 >> 2] = i33;
    HEAP32[i21 >> 2] = i33;
    break;
   }
  case 3:
   {
    f35 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + 4 >> 2]);
    f34 = Math_fround(HEAPF32[i7 >> 2]);
    f35 = Math_fround(f35 * f34);
    f34 = Math_fround(Math_fround(f34 * Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 4 >> 2])) - f35);
    f10 = Math_fround(f35 + Math_fround(f34 * f10));
    f11 = Math_fround(f35 + Math_fround(f34 * f11));
    f12 = Math_fround(f35 + Math_fround(f12 * f34));
    HEAPF32[i21 >> 2] = Math_fround(f35 + Math_fround(f2 * f34));
    HEAPF32[i4 >> 2] = f10;
    HEAPF32[i5 >> 2] = f11;
    HEAPF32[i6 >> 2] = f12;
    break;
   }
  default:
   if (!(i13 & 16711680)) {
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i21, i20, i22, i23);
    break L14;
   } else {
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i21, i20, i22, i23);
    break L14;
   }
  } while (0);
  f35 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f18);
  i33 = i24 + (i1 << 2) | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f35);
  f12 = Math_fround(f35 + Math_fround(HEAPF32[i4 >> 2]));
  f34 = Math_fround(f35 + Math_fround(HEAPF32[i5 >> 2]));
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i6 >> 2]));
  f12 = Math_fround(f12 - Math_fround(Math_floor(Math_fround(f12))));
  f34 = Math_fround(f34 - Math_fround(Math_floor(Math_fround(f34))));
  f35 = Math_fround(f35 - Math_fround(Math_floor(Math_fround(f35))));
  HEAPF32[i33 >> 2] = Math_fround(f11 - Math_fround(Math_floor(Math_fround(f11))));
  HEAPF32[i33 + 4 >> 2] = f12;
  HEAPF32[i33 + 8 >> 2] = f34;
  HEAPF32[i33 + 12 >> 2] = f35;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i25 >>> 0);
 STACKTOP = i26;
 return;
}

function __crypt_extended_r_uut(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 140 | 0;
 i15 = i21 + 136 | 0;
 i18 = i21 + 8 | 0;
 i16 = i21 + 144 | 0;
 i19 = i21 + 4 | 0;
 i20 = i21;
 i17 = i16 + 7 | 0;
 i4 = i16;
 do {
  HEAP8[i4 >> 0] = HEAPU8[i3 >> 0] << 1;
  i4 = i4 + 1 | 0;
  i3 = (HEAP8[i3 >> 0] | 0) == 0 ? i3 : i3 + 1 | 0;
 } while (i4 >>> 0 <= i17 >>> 0);
 ___des_setkey(i16, i18);
 i4 = HEAP8[i2 >> 0] | 0;
 L4 : do switch (i4 << 24 >> 24) {
 case 95:
  {
   i4 = 1;
   i6 = 0;
   do {
    i13 = HEAP8[i2 + i4 >> 0] | 0;
    i5 = i13 & 255;
    i5 = i13 << 24 >> 24 > -1 ? i5 : i5 | -256;
    i5 = ((i5 | 0) > 64 ? ((i5 | 0) > 96 ? 5 : 11) : 18) + i5 & 63;
    if ((HEAP8[gb + 1060052 + i5 >> 0] | 0) != i13 << 24 >> 24) {
     i1 = 0;
     break L4;
    }
    i6 = i5 << (i4 * 6 | 0) + -6 | i6;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < 5);
   if (!i6) i1 = 0; else {
    i7 = 0;
    i4 = 5;
    do {
     i13 = HEAP8[i2 + i4 >> 0] | 0;
     i5 = i13 & 255;
     i5 = i13 << 24 >> 24 > -1 ? i5 : i5 | -256;
     i5 = ((i5 | 0) > 64 ? ((i5 | 0) > 96 ? 5 : 11) : 18) + i5 & 63;
     if ((HEAP8[gb + 1060052 + i5 >> 0] | 0) != i13 << 24 >> 24) {
      i1 = 0;
      break L4;
     }
     i7 = i5 << (i4 * 6 | 0) + -30 | i7;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < 9);
    if (HEAP8[i3 >> 0] | 0) {
     i8 = i16 + 3 | 0;
     i9 = i16 + 2 | 0;
     i10 = i16 + 1 | 0;
     i11 = i16 + 6 | 0;
     i12 = i16 + 5 | 0;
     i13 = i16 + 4 | 0;
     do {
      ___do_des(HEAPU8[i9 >> 0] << 8 | HEAPU8[i8 >> 0] | HEAPU8[i10 >> 0] << 16 | HEAPU8[i16 >> 0] << 24, HEAPU8[i11 >> 0] << 8 | HEAPU8[i17 >> 0] | HEAPU8[i12 >> 0] << 16 | HEAPU8[i13 >> 0] << 24, i14, i15, 1, 0, i18);
      i5 = HEAP32[i14 >> 2] | 0;
      HEAP8[i16 >> 0] = i5 >>> 24;
      HEAP8[i10 >> 0] = i5 >>> 16;
      HEAP8[i9 >> 0] = i5 >>> 8;
      HEAP8[i8 >> 0] = i5;
      i5 = HEAP32[i15 >> 2] | 0;
      HEAP8[i13 >> 0] = i5 >>> 24;
      HEAP8[i12 >> 0] = i5 >>> 16;
      HEAP8[i11 >> 0] = i5 >>> 8;
      HEAP8[i17 >> 0] = i5;
      i5 = i16;
      do {
       i4 = HEAP8[i3 >> 0] | 0;
       if (!(i4 << 24 >> 24)) break;
       i3 = i3 + 1 | 0;
       HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] ^ (i4 & 255) << 1;
       i5 = i5 + 1 | 0;
      } while (i5 >>> 0 <= i17 >>> 0);
      ___des_setkey(i16, i18);
     } while ((HEAP8[i3 >> 0] | 0) != 0);
    }
    i4 = i1;
    i3 = i4 + 9 | 0;
    do {
     HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
     i4 = i4 + 1 | 0;
     i2 = i2 + 1 | 0;
    } while ((i4 | 0) < (i3 | 0));
    i8 = i1 + 9 | 0;
    HEAP8[i8 >> 0] = 0;
    i9 = 18;
   }
   break;
  }
 case 58:
 case 10:
 case 0:
  {
   i1 = 0;
   break;
  }
 default:
  {
   i2 = i2 + 1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
   switch (i3 << 24 >> 24) {
   case 58:
   case 10:
   case 0:
    {
     i1 = 0;
     break L4;
    }
   default:
    {}
   }
   i6 = i3 & 255;
   i6 = i3 << 24 >> 24 > -1 ? i6 : i6 | -256;
   i7 = i4 & 255;
   i7 = i4 << 24 >> 24 > -1 ? i7 : i7 | -256;
   HEAP8[i1 >> 0] = i4;
   HEAP8[i1 + 1 >> 0] = HEAP8[i2 >> 0] | 0;
   i8 = i1 + 2 | 0;
   i7 = ((i6 | 0) > 64 ? ((i6 | 0) > 96 ? 5 : 11) : 18) + i6 << 6 & 4032 | ((i7 | 0) > 64 ? ((i7 | 0) > 96 ? 5 : 11) : 18) + i7 & 63;
   i6 = 25;
   i9 = 18;
  }
 } while (0);
 if ((i9 | 0) == 18) {
  i2 = 0;
  i3 = 1;
  i4 = 8388608;
  i5 = 0;
  while (1) {
   i2 = ((i3 & i7 | 0) == 0 ? 0 : i4) | i2;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == 24) break; else {
    i3 = i3 << 1;
    i4 = i4 >>> 1;
   }
  }
  ___do_des(0, 0, i19, i20, i6, i2, i18);
  i18 = HEAP32[i19 >> 2] | 0;
  HEAP8[i8 >> 0] = HEAP8[(i18 >>> 26) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 1 >> 0] = HEAP8[(i18 >>> 20 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 2 >> 0] = HEAP8[(i18 >>> 14 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 3 >> 0] = HEAP8[(i18 >>> 8 & 63) + (gb + 1060052) >> 0] | 0;
  i20 = HEAP32[i20 >> 2] | 0;
  i19 = i20 >>> 16;
  HEAP8[i8 + 4 >> 0] = HEAP8[(i18 >>> 2 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 5 >> 0] = HEAP8[((i19 | i18 << 16) >>> 12 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 6 >> 0] = HEAP8[(i20 >>> 22 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 7 >> 0] = HEAP8[(i19 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 8 >> 0] = HEAP8[(i20 >>> 10 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 9 >> 0] = HEAP8[(i20 >>> 4 & 63) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 10 >> 0] = HEAP8[(i20 << 2 & 60) + (gb + 1060052) >> 0] | 0;
  HEAP8[i8 + 11 >> 0] = 0;
 }
 STACKTOP = i21;
 return i1 | 0;
}

function __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i18, i19, i16, i10, i4, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i17 = __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i18, i19, i16, i10, i1) | 0;
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i4 + 12 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 i1 = i10 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i19 = i17;
  return i19 | 0;
 }
 i5 = i10 + 4 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i7 = i10 + 16 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 i8 = i10 + 20 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i9 = i10 + 24 | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = i12;
 HEAPF32[i4 + 12 >> 2] = f3;
 HEAP32[i4 + 16 >> 2] = i13;
 HEAP32[i4 + 20 >> 2] = i14;
 HEAP32[i4 + 24 >> 2] = i15;
 f20 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 i1 = i16 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i19 = i17 + 1 | 0;
  return i19 | 0;
 }
 i11 = i16 + 4 | 0;
 i24 = HEAP32[i11 >> 2] | 0;
 i12 = i16 + 8 | 0;
 i23 = HEAP32[i12 >> 2] | 0;
 i13 = i16 + 16 | 0;
 i22 = HEAP32[i13 >> 2] | 0;
 i14 = i16 + 20 | 0;
 i21 = HEAP32[i14 >> 2] | 0;
 i15 = i16 + 24 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAPF32[i10 >> 2] = f2;
 HEAP32[i5 >> 2] = i24;
 HEAP32[i6 >> 2] = i23;
 HEAPF32[i10 + 12 >> 2] = f3;
 HEAP32[i7 >> 2] = i22;
 HEAP32[i8 >> 2] = i21;
 HEAP32[i9 >> 2] = i4;
 f20 = Math_fround(HEAPF32[i16 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i19 >> 2]);
 i1 = i19 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i24 = i17 + 2 | 0;
  return i24 | 0;
 }
 i4 = i19 + 4 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = i19 + 8 | 0;
 i21 = HEAP32[i5 >> 2] | 0;
 i6 = i19 + 16 | 0;
 i22 = HEAP32[i6 >> 2] | 0;
 i7 = i19 + 20 | 0;
 i23 = HEAP32[i7 >> 2] | 0;
 i8 = i19 + 24 | 0;
 i24 = HEAP32[i8 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i19 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i19 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i19 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAPF32[i16 >> 2] = f2;
 HEAP32[i11 >> 2] = i10;
 HEAP32[i12 >> 2] = i21;
 HEAPF32[i16 + 12 >> 2] = f3;
 HEAP32[i13 >> 2] = i22;
 HEAP32[i14 >> 2] = i23;
 HEAP32[i15 >> 2] = i24;
 f20 = Math_fround(HEAPF32[i19 >> 2]);
 f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 if (!(f20 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i24 = i17 + 3 | 0;
  return i24 | 0;
 }
 i16 = HEAP32[i18 + 4 >> 2] | 0;
 i21 = HEAP32[i18 + 8 >> 2] | 0;
 i22 = HEAP32[i18 + 16 >> 2] | 0;
 i23 = HEAP32[i18 + 20 >> 2] | 0;
 i24 = HEAP32[i18 + 24 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAPF32[i19 >> 2] = f2;
 HEAP32[i4 >> 2] = i16;
 HEAP32[i5 >> 2] = i21;
 HEAPF32[i19 + 12 >> 2] = f3;
 HEAP32[i6 >> 2] = i22;
 HEAP32[i7 >> 2] = i23;
 HEAP32[i8 >> 2] = i24;
 i24 = i17 + 4 | 0;
 return i24 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E14squash_deletedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i4 = i5 + 24 | 0;
 i1 = i3 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i19 = i4 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i18 = i4 + 8 | 0;
 i20 = i3 + 8 | 0;
 i16 = HEAP16[i20 >> 1] | 0;
 HEAP8[i18 >> 0] = i16;
 i10 = i4 + 9 | 0;
 HEAP8[i10 >> 0] = (i16 & 65535) >>> 8;
 i16 = i4 + 12 | 0;
 i17 = i3 + 12 | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 i11 = i4 + 36 | 0;
 i15 = i3 + 36 | 0;
 HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 i13 = i4 + 60 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 64 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 68 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 76 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 72 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 80 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j(i4, i3, 0);
 i21 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i19 >> 2] = i21;
 i1 = HEAP8[i20 >> 0] | 0;
 i19 = HEAP16[i18 >> 1] | 0;
 HEAP8[i20 >> 0] = i19;
 HEAP8[i18 >> 0] = i1;
 i18 = i3 + 9 | 0;
 i1 = HEAP8[i18 >> 0] | 0;
 HEAP8[i18 >> 0] = (i19 & 65535) >>> 8;
 HEAP8[i10 >> 0] = i1;
 HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 i10 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 32 >> 2] = i10;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 i10 = HEAP32[i3 + 56 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 56 >> 2] = i10;
 i10 = i3 + 60 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i3 + 64 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i3 + 68 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i3 + 76 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i3 + 72 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i3 + 80 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 84 >> 2] | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 }
 STACKTOP = i5;
 return;
}

function __ZNK8GUIStyle14GetCurrentFontEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i4 = i1 + 240 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) break;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 18;
   }
  }
  if ((i7 | 0) == 16) i7 = 18;
  if ((i7 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i9 = i1;
  STACKTOP = i8;
  return i9 | 0;
 } while (0);
 i1 = HEAP32[gb + 1468160 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 26; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 28;
  }
  if ((i7 | 0) == 26) i7 = 28;
  if ((i7 | 0) == 28) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468160 >> 2] | 0) | 0)) break;
  i1 = HEAP32[gb + 1468160 >> 2] | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 35; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 35; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 37;
   }
  }
  if ((i7 | 0) == 35) i7 = 37;
  if ((i7 | 0) == 37) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468160 >> 2] | 0) | 0;
  i9 = i1;
  STACKTOP = i8;
  return i9 | 0;
 } while (0);
 i9 = __ZN8GUIStyle14GetBuiltinFontEv() | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN5Unity5Cloth10LateUpdateEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 12 | 0;
 i1 = i10;
 i8 = i9 + 228 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  f14 = Math_fround(HEAPF32[i9 + 52 >> 2]);
  f13 = Math_fround(HEAPF32[i9 + 56 >> 2]);
  f12 = Math_fround(HEAPF32[i9 + 60 >> 2]);
  f11 = Math_fround(HEAPF32[i9 + 64 >> 2]);
  i2 = HEAP32[gb + 1458904 >> 2] | 0;
  i2 = i2 << 11 ^ i2;
  i6 = HEAP32[gb + 1458904 + 4 >> 2] | 0;
  i15 = HEAP32[gb + 1458904 + 8 >> 2] | 0;
  i17 = HEAP32[gb + 1458904 + 12 >> 2] | 0;
  i2 = i2 >>> 8 ^ i2 ^ i17;
  i16 = i2 ^ i17 >>> 19;
  f4 = Math_fround(Math_fround((i16 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(Math_fround(f11 * Math_fround(Math_fround(1.0) - f4)) - Math_fround(f11 * f4));
  f11 = Math_fround(HEAPF32[i9 + 68 >> 2]);
  i6 = i6 << 11 ^ i6;
  i6 = i6 >>> 8 ^ i6 ^ i16;
  i2 = i6 ^ i2 >>> 19;
  f3 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f3 = Math_fround(Math_fround(f11 * Math_fround(Math_fround(1.0) - f3)) - Math_fround(f11 * f3));
  f11 = Math_fround(HEAPF32[i9 + 72 >> 2]);
  i15 = i15 << 11 ^ i15;
  HEAP32[gb + 1458904 >> 2] = i17;
  HEAP32[gb + 1458904 + 4 >> 2] = i16;
  HEAP32[gb + 1458904 + 8 >> 2] = i2;
  i6 = i15 >>> 8 ^ i15 ^ i2 ^ i6 >>> 19;
  HEAP32[gb + 1458904 + 12 >> 2] = i6;
  f5 = Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
  f4 = Math_fround(f14 + f4);
  f3 = Math_fround(f13 + f3);
  f5 = Math_fround(f12 + Math_fround(Math_fround(f11 * Math_fround(Math_fround(1.0) - f5)) - Math_fround(f11 * f5)));
  __ZNK9Transform11GetPositionEv(i7, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 31632 | 0) | 0) | 0);
  if (HEAP8[i9 + 359 >> 0] | 0) {
   f11 = Math_fround(HEAPF32[i9 + 360 >> 2]);
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i7 >> 2]));
   f13 = Math_fround(HEAPF32[i9 + 364 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i7 + 4 >> 2]));
   f12 = Math_fround(HEAPF32[i9 + 368 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i7 + 8 >> 2]));
   f14 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
   f11 = Math_fround(f11 * f14);
   f13 = Math_fround(f13 * f14);
   f14 = Math_fround(f12 * f14);
   f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f11 * f11) + Math_fround(f13 * f13)))));
   f11 = Math_fround(f11 * f12);
   f13 = Math_fround(f13 * f12);
   f12 = Math_fround(f14 * f12);
   f14 = Math_fround(HEAPF32[i9 + 76 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f11 * f14));
   f5 = Math_fround(f5 + Math_fround(f12 * f14));
   f3 = Math_fround(f3 + Math_fround(f13 * f14));
  }
  i17 = i9 + 360 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i17 = HEAP32[i8 >> 2] | 0;
  i16 = HEAP32[(HEAP32[i17 >> 2] | 0) + 204 >> 2] | 0;
  HEAPF32[i1 >> 2] = f4;
  HEAPF32[i1 + 4 >> 2] = f3;
  HEAPF32[i1 + 8 >> 2] = f5;
  mftCall_vii(i16 | 0, i17 | 0, i1 | 0);
 }
 i1 = i9 + 340 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i9 + 344 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 do if (f3 != f4) {
  if (f3 == Math_fround(0.0) & f4 == Math_fround(0.0)) {
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 116 >> 2] | 0, i9 | 0, 0);
   break;
  }
  i6 = i9 + 348 | 0;
  if (Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0)) {
   HEAPF32[i1 >> 2] = f4;
   break;
  }
  if (f3 > f4) {
   f14 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
   f14 = Math_fround(f3 - Math_fround(f14 / Math_fround(HEAPF32[i6 >> 2])));
   HEAPF32[i7 >> 2] = f14;
   i17 = f14 < Math_fround(HEAPF32[i2 >> 2]);
   HEAP32[i1 >> 2] = HEAP32[(i17 ? i2 : i7) >> 2];
   break;
  }
  if (f3 < f4) {
   f14 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
   f14 = Math_fround(f3 + Math_fround(f14 / Math_fround(HEAPF32[i6 >> 2])));
   HEAPF32[i7 >> 2] = f14;
   i17 = Math_fround(HEAPF32[i2 >> 2]) < f14;
   HEAP32[i1 >> 2] = HEAP32[(i17 ? i2 : i7) >> 2];
  }
 } while (0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = i9 + 357 | 0;
 if (!i2) {
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 if (HEAP8[i9 + 356 >> 0] | 0) {
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 468 >> 2] | 0, i2 | 0);
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 12 | 0;
 i12 = i18 + 8 | 0;
 i14 = i18;
 i15 = __Z17GetManagerContextv() | 0;
 i10 = i13 + 84 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i10 = i9 + 12 | 0;
 i11 = i16 + 11 | 0;
 i8 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do {
  i7 = HEAP32[i15 + 112 + (i8 + 24 << 2) >> 2] | 0;
  if (!i1) i1 = 0; else {
   i5 = i13 + 84 + (i8 << 2) | 0;
   i6 = i7 + 8 | 0;
   i1 = 0;
   do {
    i2 = HEAP32[i9 >> 2] | 0;
    L7 : do if ((HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) == (i7 | 0)) {
     i3 = HEAP32[i5 >> 2] | 0;
     do if (i3) {
      HEAP32[i14 >> 2] = i3;
      i2 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i2) i17 = 13; else {
       if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
        i3 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[i2 + 32 >> 2] | 0;
        i2 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i2, i14);
        i3 = HEAP32[i16 >> 2] | 0;
        i19 = HEAP32[i2 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i17 = 13; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i17 = 15;
      }
      if ((i17 | 0) == 13) i17 = 15;
      if ((i17 | 0) == 15) {
       i17 = 0;
       if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
        i2 = HEAP32[i9 >> 2] | 0;
        break;
       }
      }
      HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
      __Z6FormatPKcz(i16, gb + 463364 | 0, i12);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16, 0, gb + 463405 | 0, 130, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
      break L7;
     } while (0);
     i2 = __Z17dynamic_pptr_castIP16LevelGameManager6ObjectET_RK4PPtrIT0_E(i2 + (i1 * 12 | 0) + 4 | 0) | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
     HEAP32[i5 >> 2] = i2;
    } while (0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (HEAP32[i10 >> 2] | 0));
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 4);
 i5 = 0;
 do {
  i4 = HEAP32[i15 + 112 + (i5 + 24 << 2) >> 2] | 0;
  do if (i4 | 0) {
   i6 = i13 + 84 + (i5 << 2) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i14 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i17 = 30; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i14);
      i2 = HEAP32[i16 >> 2] | 0;
      i19 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 30; else if (HEAP32[i1 + 4 >> 2] | 0) break;
    }
    if ((i17 | 0) == 30) i17 = 0;
    if (__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0) break;
   }
   i12 = gb + 63520 | 0;
   i19 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i14;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i19;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   i1 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i4, 0, i16, 0) | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, HEAP32[i4 + 8 >> 2] | 0);
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 4);
 STACKTOP = i18;
 return;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER14SafeBinaryRead(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i1 = i11;
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, HEAP32[gb + 67408 >> 2] | 0, gb + 855573 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i6, i9);
   i4 = i6 + 44 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853458 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i5 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i8 = 8; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 48 | 0;
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855589 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 56 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855602 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 30; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 52 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853419 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i7 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 41; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i11;
 return;
}

function __ZN17ProceduralTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i9);
 __ZN4PPtrI18ProceduralMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 80 | 0, i9);
 i1 = i11 + 192 | 0;
 i12 = i9 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i10 = i9 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  i5 = i1;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 8);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i11 + 156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i5 = i11 + 164 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i11 + 200 | 0;
 i3 = i4 + 8 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  i5 = i1;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i4;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 8);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i11 + 180 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i11 + 181 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i11 + 184 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i11 + 176 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 >> 2] = i7;
 if (i7 >>> 0 > 3) HEAP32[i1 >> 2] = 0;
 __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 32 | 0, i9);
 i2 = i11 + 104 | 0;
 i7 = i11 + 108 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i3 - i1 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 __ZN17ProceduralTexture17TextureParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 128 | 0, i9);
 __ZN17ProceduralTexture17TextureParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11 + 88 | 0, i9);
 i1 = i11 + 56 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i11 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  STACKTOP = i13;
  return;
 }
}

function __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_(i39, i41, i42, i40, f1, f3, f5, f2, f4, f6) {
 i39 = i39 | 0;
 i41 = i41 | 0;
 i42 = i42 | 0;
 i40 = i40 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 f2 = Math_fround(f2);
 f4 = Math_fround(f4);
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i43 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i43 + 72 | 0;
 i33 = i43 + 60 | 0;
 i34 = i43 + 48 | 0;
 i35 = i43 + 36 | 0;
 i36 = i43 + 24 | 0;
 i37 = i43 + 12 | 0;
 i38 = i43;
 if (!i40) {
  STACKTOP = i43;
  return;
 }
 f31 = Math_fround(Math_fround(f2 * Math_fround(.00999999977)) - f1);
 f2 = Math_fround(Math_fround(f4 * Math_fround(.00999999977)) - f3);
 f1 = Math_fround(Math_fround(f6 * Math_fround(.00999999977)) - f5);
 if (!i39) {
  STACKTOP = i43;
  return;
 }
 i7 = i32 + 36 | 0;
 i8 = i32 + 40 | 0;
 i9 = i32 + 56 | 0;
 i10 = i32 + 60 | 0;
 i11 = i32 + 76 | 0;
 i12 = i32 + 80 | 0;
 i13 = i32 + 96 | 0;
 i14 = i32 + 100 | 0;
 i15 = i33 + 4 | 0;
 i16 = i33 + 8 | 0;
 i17 = i34 + 4 | 0;
 i18 = i34 + 8 | 0;
 i19 = i35 + 4 | 0;
 i20 = i35 + 8 | 0;
 i21 = i36 + 4 | 0;
 i22 = i36 + 8 | 0;
 i23 = i37 + 4 | 0;
 i24 = i37 + 8 | 0;
 i25 = i38 + 4 | 0;
 i26 = i38 + 8 | 0;
 i28 = 0;
 do {
  i27 = i28 + i41 | 0;
  i29 = i32;
  i30 = i29 + 36 | 0;
  do {
   HEAP32[i29 >> 2] = 0;
   i29 = i29 + 4 | 0;
  } while ((i29 | 0) < (i30 | 0));
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAPF32[i11 >> 2] = Math_fround(1.0);
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  HEAP32[i14 >> 2] = i40;
  i30 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(i32, -16711936) | 0, 1) | 0;
  i45 = i42 + (i27 * 36 | 0) | 0;
  f6 = Math_fround(f31 + Math_fround(HEAPF32[i45 >> 2]));
  i44 = i42 + (i27 * 36 | 0) + 4 | 0;
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i44 >> 2]));
  i29 = i42 + (i27 * 36 | 0) + 8 | 0;
  f4 = Math_fround(f1 + Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i33 >> 2] = f6;
  HEAPF32[i15 >> 2] = f5;
  HEAPF32[i16 >> 2] = f4;
  i30 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i33) | 0;
  i48 = i42 + (i27 * 36 | 0) + 12 | 0;
  f4 = Math_fround(f31 + Math_fround(HEAPF32[i48 >> 2]));
  i46 = i42 + (i27 * 36 | 0) + 16 | 0;
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i46 >> 2]));
  i47 = i42 + (i27 * 36 | 0) + 20 | 0;
  f6 = Math_fround(f1 + Math_fround(HEAPF32[i47 >> 2]));
  HEAPF32[i34 >> 2] = f4;
  HEAPF32[i17 >> 2] = f5;
  HEAPF32[i18 >> 2] = f6;
  i30 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i34) | 0;
  f6 = Math_fround(f31 + Math_fround(HEAPF32[i48 >> 2]));
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i46 >> 2]));
  f4 = Math_fround(f1 + Math_fround(HEAPF32[i47 >> 2]));
  HEAPF32[i35 >> 2] = f6;
  HEAPF32[i19 >> 2] = f5;
  HEAPF32[i20 >> 2] = f4;
  i30 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i35) | 0;
  i47 = i42 + (i27 * 36 | 0) + 24 | 0;
  f4 = Math_fround(f31 + Math_fround(HEAPF32[i47 >> 2]));
  i46 = i42 + (i27 * 36 | 0) + 28 | 0;
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i46 >> 2]));
  i27 = i42 + (i27 * 36 | 0) + 32 | 0;
  f6 = Math_fround(f1 + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i36 >> 2] = f4;
  HEAPF32[i21 >> 2] = f5;
  HEAPF32[i22 >> 2] = f6;
  i30 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i36) | 0;
  f6 = Math_fround(f31 + Math_fround(HEAPF32[i47 >> 2]));
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i46 >> 2]));
  f4 = Math_fround(f1 + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i37 >> 2] = f6;
  HEAPF32[i23 >> 2] = f5;
  HEAPF32[i24 >> 2] = f4;
  i30 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i37) | 0;
  f4 = Math_fround(f31 + Math_fround(HEAPF32[i45 >> 2]));
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i44 >> 2]));
  f6 = Math_fround(f1 + Math_fround(HEAPF32[i29 >> 2]));
  HEAPF32[i38 >> 2] = f4;
  HEAPF32[i25 >> 2] = f5;
  HEAPF32[i26 >> 2] = f6;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i30, i38) | 0;
  i28 = i28 + 1 | 0;
 } while ((i28 | 0) != (i39 | 0));
 STACKTOP = i43;
 return;
}

function __Z21CreateShadowCullerJobP30CreateUmbraShadowCullerJobData(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i25 + 8 | 0;
 i1 = i25;
 i18 = i25 + 20 | 0;
 if ((HEAP16[gb + 1112924 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112924 | 0, i15);
  i16 = gb + 1112924 | 0;
 } else i16 = 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i22 = i17 + 4 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 i24 = HEAP32[i17 + 8 >> 2] | 0;
 if (HEAP8[i2 + 76 >> 0] | 0) {
  i21 = gb + 64016 | 0;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = i1;
  HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  HEAP32[i18 >> 2] = 0;
  i19 = i18 + 12 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i18 + 16 | 0;
  HEAP32[i20 >> 2] = 0;
  i21 = i18 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i1);
  i12 = i15;
  i14 = HEAP32[i12 + 4 >> 2] | 0;
  i13 = i21;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = i14;
  i13 = i2 + 1332 | 0;
  L6 : do if (HEAP32[i13 >> 2] | 0) {
   i14 = i2 + 1320 | 0;
   i12 = i2 + 1340 | 0;
   i1 = 0;
   i10 = 0;
   i9 = 0;
   i4 = 0;
   i5 = 0;
   while (1) {
    i6 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] << 1;
    i7 = HEAP32[i12 >> 2] | 0;
    i8 = i7 + (i6 * 12 | 0) | 0;
    i11 = i9 | 1;
    i3 = i4 & 2147483647;
    do if (i11 >>> 0 > i3 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i3 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i20 >> 2] = i2;
      i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i2 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i18 >> 2] = i10;
      i4 = HEAP32[i20 >> 2] | 0;
      i5 = i10;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i20 >> 2] = i2;
      HEAP32[i18 >> 2] = i10;
      i4 = i2;
      i5 = i10;
      break;
     }
    } while (0);
    HEAP32[i19 >> 2] = i11;
    HEAP32[i10 + (i9 * 12 | 0) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2];
    HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] = HEAP32[i7 + (i6 * 12 | 0) + 8 >> 2];
    i7 = i6 | 1;
    i8 = HEAP32[i12 >> 2] | 0;
    i6 = i8 + (i7 * 12 | 0) | 0;
    i9 = i9 + 2 | 0;
    i3 = i4 & 2147483647;
    do if (i9 >>> 0 > i3 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i3 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i20 >> 2] = i2;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i2 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i18 >> 2] = i2;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i19 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i20 >> 2] = i2;
      HEAP32[i18 >> 2] = i10;
      i2 = i10;
      break;
     } else i2 = i10;
    } else i2 = i10; while (0);
    HEAP32[i19 >> 2] = i9;
    HEAP32[i2 + (i11 * 12 | 0) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i2 + (i11 * 12 | 0) + 4 >> 2] = HEAP32[i8 + (i7 * 12 | 0) + 4 >> 2];
    HEAP32[i2 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2];
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break L6;
    i10 = i2;
    i4 = HEAP32[i20 >> 2] | 0;
    i5 = i2;
   }
  } while (0);
  f28 = Math_fround(-Math_fround(HEAPF32[i23 + 328 >> 2]));
  f27 = Math_fround(-Math_fround(HEAPF32[i23 + 332 >> 2]));
  f26 = Math_fround(-Math_fround(HEAPF32[i23 + 336 >> 2]));
  HEAPF32[i15 >> 2] = f28;
  HEAPF32[i15 + 4 >> 2] = f27;
  HEAPF32[i15 + 8 >> 2] = f26;
  i14 = __Z9GetIUmbrav() | 0;
  mftCall_iiiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 64 >> 2] | 0, i14 | 0, i24 | 0, HEAP32[(HEAP32[i23 + 832 >> 2] | 0) + 64 >> 2] | 0, HEAP32[i22 >> 2] | 0, i15 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i19 >> 2] | 0) >>> 1 | 0) | 0;
  if ((HEAP32[i20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i21);
   HEAP32[i18 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i17, gb + 64024 | 0);
 if (!i16) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i25;
 return;
}

function __ZN7mecanim9animation15EvaluateAvatarXEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(i1, i2, i4, i12, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i2 = i1 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i1 = i3 + i2 + 40 | 0;
  i1 = (HEAP32[(HEAP32[i1 >> 2] | 0) + i1 >> 2] | 0) != 0;
 }
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f7 = Math_fround(f14 * f7);
 f5 = Math_fround(f14 * f5);
 f6 = Math_fround(f14 * Math_fround(HEAPF32[i4 + 12 >> 2]));
 f9 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f9 = Math_fround(f14 * f9);
 f10 = Math_fround(f14 * f10);
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i4 + 24 >> 2]));
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f14 * f14) + Math_fround(0.0)))));
 f8 = Math_fround(f13 * Math_fround(.5));
 f11 = Math_fround(+Math_sin(+f8));
 f8 = Math_fround(+Math_cos(+f8));
 f9 = Math_fround(Math_fround(f9 * f11) / f13);
 f10 = Math_fround(Math_fround(f10 * f11) / f13);
 f11 = Math_fround(Math_fround(f14 * f11) / f13);
 i4 = f13 == Math_fround(0.0);
 if (i1) {
  f14 = Math_fround(HEAPF32[i3 + i2 + 360 >> 2]);
  f7 = Math_fround(f7 * f14);
  f6 = Math_fround(f6 * f14);
  f5 = Math_fround(f5 * f14);
 }
 f28 = Math_fround(HEAPF32[i12 + 28 >> 2]);
 f22 = Math_fround(HEAPF32[i12 + 32 >> 2]);
 f28 = Math_fround(f7 * f28);
 f22 = Math_fround(f5 * f22);
 f25 = Math_fround(f6 * Math_fround(HEAPF32[i12 + 36 >> 2]));
 i1 = i12 + 16 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 i3 = i12 + 24 | 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i12 + 20 | 0;
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f29 = Math_fround(f5 * Math_fround(-2.0));
 f20 = Math_fround(f5 * Math_fround(2.0));
 f27 = Math_fround(f29 * f19);
 f14 = Math_fround(f21 * Math_fround(2.0));
 f26 = Math_fround(f21 * Math_fround(-2.0));
 f30 = Math_fround(f19 * f26);
 f24 = Math_fround(f23 * Math_fround(-2.0));
 f7 = Math_fround(f23 * Math_fround(2.0));
 f13 = Math_fround(f19 * f24);
 f6 = Math_fround(Math_fround(f28 + Math_fround(f28 * Math_fround(Math_fround(f5 * f29) - Math_fround(f21 * f14)))) + Math_fround(Math_fround(f25 * Math_fround(Math_fround(f7 * f21) - f27)) + Math_fround(f22 * Math_fround(f30 - Math_fround(f5 * f24)))));
 f7 = Math_fround(Math_fround(f22 + Math_fround(f28 * Math_fround(Math_fround(f23 * f20) - f30))) + Math_fround(Math_fround(f25 * Math_fround(f13 - Math_fround(f29 * f21))) + Math_fround(f22 * Math_fround(Math_fround(f21 * f26) - Math_fround(f23 * f7)))));
 f13 = Math_fround(Math_fround(f25 + Math_fround(f28 * Math_fround(f27 - Math_fround(f23 * f26)))) + Math_fround(Math_fround(f25 * Math_fround(Math_fround(f23 * f24) - Math_fround(f5 * f20))) + Math_fround(f22 * Math_fround(Math_fround(f5 * f14) - f13))));
 f14 = Math_fround(HEAPF32[i12 >> 2]);
 i18 = i12 + 4 | 0;
 f22 = Math_fround(HEAPF32[i18 >> 2]);
 i17 = i12 + 8 | 0;
 f6 = Math_fround(f14 + f6);
 f7 = Math_fround(f22 + f7);
 f13 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f13);
 f22 = i4 ? Math_fround(0.0) : f9;
 f9 = Math_fround(f22 * f5);
 f8 = i4 ? Math_fround(1.0) : f8;
 f14 = Math_fround(f8 * f19);
 f20 = i4 ? Math_fround(0.0) : f10;
 f10 = Math_fround(f20 * f21);
 f11 = i4 ? Math_fround(0.0) : f11;
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f11 * f19)) - Math_fround(f8 * f21)) - Math_fround(f20 * f23));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f22 * f23)) - Math_fround(f11 * f21)) - Math_fround(f20 * f5));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f11 * f5)) - Math_fround(f22 * f19)) - Math_fround(f8 * f23));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f23) - Math_fround(f22 * f21)) - Math_fround(f20 * f19)) - Math_fround(f8 * f5));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAPF32[i12 >> 2] = f6;
 HEAPF32[i18 >> 2] = f7;
 HEAPF32[i17 >> 2] = f13;
 HEAP32[i12 + 12 >> 2] = i16 ^ -2147483648;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i2 >> 2] = i4 ^ -2147483648;
 HEAPF32[i3 >> 2] = f14;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i12, i9) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i6 = i9 + 28 | 0;
 i10 = i9 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i9 + 44 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i5;
 i7 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i2 = __Znwj(1) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i9 + 32 >> 2] = i2;
   }
   i1 = HEAP32[i9 + 48 >> 2] | 0;
  } else {
   i1 = i2 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i7 - i5 | 0;
  i7 = i5 + 24 | 0;
  i7 = i1 >>> 0 < i7 >>> 0 ? i7 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i7, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i6 + i7;
 }
 HEAP32[i10 >> 2] = i1 + 24;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 3;
 i1 = HEAP32[i12 >> 2] | 0;
 L11 : while (1) {
  i2 = i1;
  switch (HEAP8[i2 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L11;
  }
  i1 = i2 + 1 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 L15 : do switch (HEAP8[i2 >> 0] | 0) {
 case 125:
  {
   HEAP32[i12 >> 2] = i2 + 1;
   i12 = HEAP32[i10 >> 2] | 0;
   HEAP32[i12 + -8 >> 2] = 3;
   HEAP32[i12 + -24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
   HEAP32[i12 + -16 >> 2] = 0;
   HEAP32[i12 + -20 >> 2] = 0;
   return;
  }
 case 34:
  {
   i2 = i11 + 24 | 0;
   i5 = 0;
   L20 : while (1) {
    __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i11, i12, i9, 1);
    if (HEAP32[i2 >> 2] | 0) {
     i4 = 34;
     break;
    }
    i1 = HEAP32[i12 >> 2] | 0;
    L23 : while (1) {
     switch (HEAP8[i1 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L23;
     }
     i1 = i1 + 1 | 0;
    }
    i3 = i1 + 1 | 0;
    HEAP32[i12 >> 2] = i3;
    if ((HEAP8[i1 >> 0] | 0) == 58) i1 = i3; else {
     i4 = 21;
     break;
    }
    L27 : while (1) {
     i3 = i1;
     switch (HEAP8[i3 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L27;
     }
     i1 = i3 + 1 | 0;
    }
    HEAP32[i12 >> 2] = i1;
    __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i12, i9);
    if (HEAP32[i2 >> 2] | 0) {
     i4 = 34;
     break;
    }
    i1 = HEAP32[i12 >> 2] | 0;
    L32 : while (1) {
     i3 = i1;
     switch (HEAP8[i3 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L32;
     }
     i1 = i3 + 1 | 0;
    }
    i5 = i5 + 1 | 0;
    i1 = i3 + 1 | 0;
    HEAP32[i12 >> 2] = i1;
    switch (HEAP8[i3 >> 0] | 0) {
    case 125:
     {
      i4 = 32;
      break L20;
     }
    case 44:
     break;
    default:
     {
      i4 = 33;
      break L20;
     }
    }
    L36 : while (1) {
     i3 = i1;
     switch (HEAP8[i3 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L36;
     }
     i1 = i3 + 1 | 0;
    }
    HEAP32[i12 >> 2] = i1;
    if ((HEAP8[i3 >> 0] | 0) != 34) break L15;
   }
   if ((i4 | 0) == 21) {
    i12 = i3 - (HEAP32[i12 + 4 >> 2] | 0) | 0;
    HEAP32[i2 >> 2] = 5;
    HEAP32[i11 + 28 >> 2] = i12;
    return;
   } else if ((i4 | 0) == 32) {
    i9 = (HEAP32[i10 >> 2] | 0) + (Math_imul(i5, -48) | 0) | 0;
    HEAP32[i10 >> 2] = i9;
    i12 = i9 + -24 | 0;
    HEAP32[i12 + 16 >> 2] = 3;
    i11 = i5 * 48 | 0;
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
    HEAP32[i12 >> 2] = i10;
    _memcpy(i10 | 0, i9 | 0, i11 | 0) | 0;
    HEAP32[i12 + 8 >> 2] = i5;
    HEAP32[i12 + 4 >> 2] = i5;
    return;
   } else if ((i4 | 0) == 33) {
    i12 = i1 - (HEAP32[i12 + 4 >> 2] | 0) | 0;
    HEAP32[i2 >> 2] = 6;
    HEAP32[i11 + 28 >> 2] = i12;
    return;
   } else if ((i4 | 0) == 34) return;
   break;
  }
 default:
  i2 = i11 + 24 | 0;
 } while (0);
 i12 = i1 - (HEAP32[i12 + 4 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 4;
 HEAP32[i11 + 28 >> 2] = i12;
 return;
}

function __ZN5physx13PxsCCDContextD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = HEAP32[i7 + 248 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i7 + 240 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i5 = HEAP32[i7 + 236 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i7 + 228 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i4 = i7 + 212 | 0;
 i5 = i7 + 216 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i7 + 224 >> 2] = 0;
 i5 = HEAP32[i7 + 220 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i1 = i7 + 172 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i5 = HEAP32[i7 + 168 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i7 + 160 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i5 = HEAP32[i7 + 156 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i7 + 148 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i4 = i7 + 132 | 0;
 i5 = i7 + 136 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i7 + 144 >> 2] = 0;
 i5 = HEAP32[i7 + 140 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i4 = i7 + 116 | 0;
 i5 = i7 + 120 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i7 + 128 >> 2] = 0;
 i5 = HEAP32[i7 + 124 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i4 = i7 + 100 | 0;
 i5 = i7 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i7 + 112 >> 2] = 0;
 i6 = HEAP32[i7 + 108 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) {
  i6 = i7 + 56 | 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i6 = i7 + 64 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i7 + 28 | 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i6 = i7 + 36 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = gb + 87404 + 8;
  i7 = i7 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = i7 + 56 | 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i6 = i7 + 64 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i7 + 28 | 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i6 = i7 + 36 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = gb + 87404 + 8;
  i7 = i7 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 i6 = i7 + 56 | 0;
 HEAP32[i6 >> 2] = gb + 87404 + 8;
 i6 = i7 + 64 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i7 + 28 | 0;
 HEAP32[i6 >> 2] = gb + 87404 + 8;
 i6 = i7 + 36 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 87404 + 8;
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN7mecanim12statemachine18TransitionConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i7 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i9 = i8 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) {
  i5 = i8 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
    HEAP32[i2 >> 2] = 1;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags(i8, i2 + i3 | 0, gb + 1041891 | 0, 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i7 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 37 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i5 = i7 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i7 + 44 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 45 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj432ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 136 | 0;
 i17 = i20 + 188 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 84 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 28 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj501ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj502ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 96 | 0, 1);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __ZN21TreeBinaryTreeBuilder15CalculateBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERKNS1_IN12TreeDatabase9PrototypeENS3_ISD_EEEERK8Vector3fSK_(i23, i5, i3, i8, i24, i7) {
 i23 = i23 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i24 = i24 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, f4 = f0, f6 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i9 = HEAP32[gb + 62500 >> 2] | 0;
 i1 = HEAP32[gb + 62500 + 4 >> 2] | 0;
 i10 = HEAP32[gb + 62500 + 8 >> 2] | 0;
 f20 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(-f20);
 f21 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(-f21);
 f22 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = Math_fround(-f22);
 i19 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i19) {
  i5 = i9;
  i3 = i10;
  f6 = f25;
  f4 = f26;
  f2 = f27;
 } else {
  i18 = HEAP32[i3 >> 2] | 0;
  i15 = HEAP32[i5 >> 2] | 0;
  f16 = Math_fround(HEAPF32[i7 >> 2]);
  f17 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i24 >> 2]);
  f13 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  i8 = HEAP32[i8 >> 2] | 0;
  i7 = 0;
  i5 = i9;
  i3 = i10;
  f6 = f25;
  f4 = f26;
  f2 = f27;
  do {
   i10 = HEAP32[i18 + (i7 << 2) >> 2] | 0;
   f41 = Math_fround(Math_fround(HEAPF32[i15 + (i10 * 40 | 0) >> 2]) * f16);
   f39 = Math_fround(Math_fround(HEAPF32[i15 + (i10 * 40 | 0) + 4 >> 2]) * f17);
   f41 = Math_fround(f41 + f12);
   f39 = Math_fround(f39 + f13);
   f36 = Math_fround(Math_fround(Math_fround(HEAPF32[i15 + (i10 * 40 | 0) + 8 >> 2]) * f11) + f14);
   f35 = Math_fround(HEAPF32[i15 + (i10 * 40 | 0) + 12 >> 2]);
   f38 = Math_fround(HEAPF32[i15 + (i10 * 40 | 0) + 16 >> 2]);
   i10 = HEAP32[i15 + (i10 * 40 | 0) + 32 >> 2] | 0;
   f40 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 20 >> 2]);
   f30 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 32 >> 2]);
   f44 = Math_fround(f40 - f30);
   f37 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 24 >> 2]);
   f29 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 36 >> 2]);
   f43 = Math_fround(f37 - f29);
   f34 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 28 >> 2]);
   f28 = Math_fround(HEAPF32[i8 + (i10 * 156 | 0) + 40 >> 2]);
   f44 = Math_fround(f41 + Math_fround(f35 * f44));
   f43 = Math_fround(f39 + Math_fround(f38 * f43));
   f42 = Math_fround(f36 + Math_fround(f35 * Math_fround(f34 - f28)));
   f33 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = f44 < f33 ? f44 : f33;
   f32 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f32 = f43 < f32 ? f43 : f32;
   f31 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f31 = f42 < f31 ? f42 : f31;
   f6 = f6 < f44 ? f44 : f6;
   f4 = f4 < f43 ? f43 : f4;
   f2 = f2 < f42 ? f42 : f2;
   f30 = Math_fround(f41 + Math_fround(f35 * Math_fround(f40 + f30)));
   f29 = Math_fround(f39 + Math_fround(f38 * Math_fround(f37 + f29)));
   f28 = Math_fround(f36 + Math_fround(f35 * Math_fround(f34 + f28)));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f30 < f33 ? f30 : f33, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f29 < f32 ? f29 : f32, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f28 < f31 ? f28 : f31, HEAP32[tempDoublePtr >> 2] | 0);
   f6 = f6 < f30 ? f30 : f6;
   f4 = f4 < f29 ? f29 : f4;
   f2 = f2 < f28 ? f28 : f2;
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i19 >>> 0);
 }
 i19 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) == f20;
 i19 = i19 & (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) == f21;
 do if (!(i19 & (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) == f22)) {
  if (f6 == f25) if (!(f2 != f27 | f4 != f26)) break;
  HEAP32[i23 >> 2] = i5;
  HEAP32[i23 + 4 >> 2] = i1;
  HEAP32[i23 + 8 >> 2] = i3;
  HEAPF32[i23 + 12 >> 2] = f6;
  HEAPF32[i23 + 16 >> 2] = f4;
  HEAPF32[i23 + 20 >> 2] = f2;
  return;
 } while (0);
 i18 = HEAP32[i24 >> 2] | 0;
 HEAP32[i23 >> 2] = i18;
 i19 = HEAP32[i24 + 4 >> 2] | 0;
 HEAP32[i23 + 4 >> 2] = i19;
 i24 = HEAP32[i24 + 8 >> 2] | 0;
 HEAP32[i23 + 8 >> 2] = i24;
 HEAP32[i23 + 12 >> 2] = i18;
 HEAP32[i23 + 16 >> 2] = i19;
 HEAP32[i23 + 20 >> 2] = i24;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i15, i11) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 40 | 0;
 i14 = i18 + 24 | 0;
 i9 = i18;
 i3 = i18 + 20 | 0;
 i4 = i18 + 16 | 0;
 i16 = i15 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = (HEAP32[i16 >> 2] | 0) - i1 >> 5;
 i10 = i1;
 if (i2 >>> 0 < i11 >>> 0) {
  i6 = i15 + 8 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i1 >> 5 | 0) == (i11 | 0)) {
   __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i15, i11 - i2 | 0);
   STACKTOP = i18;
   return;
  }
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  i7 = i9 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i9, i11);
  HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i14, i17);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = i1 - i4 >> 5;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i11 >>> 0) {
   __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i9, i11 - i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } else if (i2 >>> 0 > i11 >>> 0) {
   i2 = i3 + (i11 << 5) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -32 - i2 | 0) >>> 5) << 5) | 0;
    HEAP32[i7 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i15 >> 2] = i2;
  i2 = HEAP32[i16 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i16 >> 2] = i1;
  i16 = i9 + 8 | 0;
  i1 = HEAP32[i16 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -32 - i3 | 0) >>> 5) << 5);
   i16 = HEAP32[i8 >> 2] | 0;
   HEAP32[i17 >> 2] = 73;
   HEAP32[i17 + 4 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
  }
  STACKTOP = i18;
  return;
 }
 if (i2 >>> 0 <= i11 >>> 0) {
  STACKTOP = i18;
  return;
 }
 i9 = i10 + (i11 << 5) | 0;
 i1 = HEAP32[i15 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i14 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i13 = i14 + 12 | 0;
 HEAP32[i13 >> 2] = i1;
 i4 = i11 << 5;
 i2 = i4 >> 5;
 if (!i2) {
  i3 = i14 + 8 | 0;
  i5 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i17 >> 2] = 73;
  HEAP32[i17 + 4 >> 2] = i1;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i14 >> 2] = i7;
  i1 = i7 + (i2 << 5) | 0;
  i3 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
  i8 = i7;
  if (!i11) {
   i5 = i8;
   i2 = i8;
  } else {
   i6 = ((i4 + -32 | 0) >>> 5) + 1 | 0;
   i5 = i7;
   i2 = i10;
   i4 = i7;
   while (1) {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    i10 = i2 + 24 | 0;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i4 = i4 + 24 | 0;
    HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i4 + 4 >> 2] = i11;
    i2 = i2 + 32 | 0;
    i4 = i5 + 32 | 0;
    if ((i2 | 0) == (i9 | 0)) break; else i5 = i4;
   }
   i2 = i7 + (i6 << 5) | 0;
   HEAP32[i12 >> 2] = i2;
   i5 = i8;
  }
 }
 i4 = HEAP32[i15 >> 2] | 0;
 HEAP32[i14 >> 2] = i4;
 HEAP32[i15 >> 2] = i5;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i2 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 i1 = i4;
 i2 = i14;
 if (i4 | 0) {
  if ((i2 | 0) != (i4 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -32 - i4 | 0) >>> 5) << 5);
  i16 = HEAP32[i13 >> 2] | 0;
  HEAP32[i17 >> 2] = 73;
  HEAP32[i17 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i17);
 }
 STACKTOP = i18;
 return;
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = (i10 - i7 | 0) / 20 | 0;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > ((i1 - i2 | 0) / 20 | 0) >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = (i1 - i2 | 0) / 20 | 0;
  i1 = i15 << 1;
  i1 = i15 >>> 0 < 107374182 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 * 20 | 0) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 * 20 | 0);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 20 | 0;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 * 20 | 0) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i8 = i8 + 20 | 0;
   i1 = i1 + 20 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) | 0) / 20 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -20 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -8 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZNK8GUIStyle15CalcMinMaxWidthER10GUIContentPfS2_(i14, i10, i15, i16) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 16 | 0;
 i11 = i18 + 8 | 0;
 i8 = i18 + 12 | 0;
 i9 = i18 + 4 | 0;
 i17 = i18;
 f1 = Math_fround(HEAPF32[i14 + 276 >> 2]);
 if (f1 != Math_fround(0.0)) {
  HEAPF32[i16 >> 2] = f1;
  HEAPF32[i15 >> 2] = f1;
  STACKTOP = i18;
  return;
 }
 i3 = __ZN13TextRendering17GetITextRenderingEv() | 0;
 if (!i3) {
  STACKTOP = i18;
  return;
 }
 i4 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
 i5 = __ZNK8GUIStyle14GetCurrentFontEv(i14) | 0;
 i6 = HEAP32[i14 + 244 >> 2] | 0;
 i7 = (HEAP8[i14 + 249 >> 0] | 0) != 0;
 HEAP32[i8 >> 2] = -1;
 i2 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i2 | 0) > -1) i2 = HEAP32[gb + 1468320 + (i2 << 2) >> 2] | 0; else i2 = 0;
 f1 = Math_fround(HEAPF32[(HEAP32[gb + 1468832 + (i2 << 2) >> 2] | 0) + 344 >> 2]);
 i19 = HEAP32[i14 + 284 >> 2] | 0;
 i2 = HEAP32[i14 + 288 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 i2 = HEAP32[(mftCall_iiiiiifffiiifii(i4 | 0, i3 | 0, i10 | 0, i5 | 0, i6 | 0, 3, 0.0, 16.0, 1.0, i7 | 0, 1, i12 | 0, +f1, i19 | 0, i2 | 0) | 0) + 16 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i16 >> 2] = i2;
 if (!(HEAP8[i14 + 248 >> 0] | 0)) HEAP32[i15 >> 2] = i2; else {
  f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i12 >> 2] = Math_fround(32.0);
  i19 = f1 < Math_fround(32.0);
  HEAP32[i15 >> 2] = HEAP32[(i19 ? i9 : i12) >> 2];
 }
 i5 = i10 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if (i2 | 0) {
  HEAP32[i11 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i13 = 15; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i2, i11);
    i3 = HEAP32[i12 >> 2] | 0;
    i19 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 15; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i13 = 17;
  }
  if ((i13 | 0) == 15) i13 = 17;
  if ((i13 | 0) == 17) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
  HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i13 = 23; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i2, i11);
    i3 = HEAP32[i12 >> 2] | 0;
    i19 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i19 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 23; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i13 = 25;
   }
  }
  if ((i13 | 0) == 23) i13 = 25;
  if ((i13 | 0) == 25) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  f1 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0);
  HEAPF32[i17 >> 2] = f1;
  switch (HEAP32[i14 + 256 >> 2] | 0) {
  case 0:
   {
    HEAPF32[i15 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i15 >> 2]));
    HEAPF32[i16 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i16 >> 2]));
    break;
   }
  case 2:
   {
    HEAPF32[i16 >> 2] = f1;
    HEAPF32[i15 >> 2] = f1;
    break;
   }
  case 1:
   {
    i19 = f1 < Math_fround(HEAPF32[i15 >> 2]);
    HEAP32[i15 >> 2] = HEAP32[(i19 ? i15 : i17) >> 2];
    i19 = f1 < Math_fround(HEAPF32[i16 >> 2]);
    HEAP32[i16 >> 2] = HEAP32[(i19 ? i16 : i17) >> 2];
    break;
   }
  default:
   {}
  }
 } while (0);
 f1 = Math_fround((HEAP32[i14 + 212 >> 2] | 0) + (HEAP32[i14 + 208 >> 2] | 0) | 0);
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f1);
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f1);
 STACKTOP = i18;
 return;
}

function __ZN5physx24PxSceneDescGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 772555;
 HEAP32[i1 + 4 >> 2] = 318;
 HEAP32[i1 + 8 >> 2] = fb + 3616;
 HEAP32[i1 + 12 >> 2] = gb + 673134;
 HEAP32[i1 + 16 >> 2] = 319;
 HEAP32[i1 + 20 >> 2] = fb + 2234;
 HEAP32[i1 + 24 >> 2] = gb + 771987;
 HEAP32[i1 + 28 >> 2] = 320;
 HEAP32[i1 + 32 >> 2] = fb + 3617;
 HEAP32[i1 + 36 >> 2] = fb + 3618;
 HEAP32[i1 + 40 >> 2] = gb + 772565;
 HEAP32[i1 + 44 >> 2] = 321;
 HEAP32[i1 + 48 >> 2] = fb + 2235;
 HEAP32[i1 + 52 >> 2] = fb + 3619;
 HEAP32[i1 + 56 >> 2] = gb + 771874;
 HEAP32[i1 + 60 >> 2] = 322;
 HEAP32[i1 + 64 >> 2] = fb + 2236;
 HEAP32[i1 + 68 >> 2] = fb + 3620;
 HEAP32[i1 + 72 >> 2] = gb + 772589;
 HEAP32[i1 + 76 >> 2] = 323;
 HEAP32[i1 + 80 >> 2] = fb + 2237;
 HEAP32[i1 + 84 >> 2] = fb + 3621;
 HEAP32[i1 + 88 >> 2] = gb + 771921;
 HEAP32[i1 + 92 >> 2] = 324;
 HEAP32[i1 + 96 >> 2] = fb + 2238;
 HEAP32[i1 + 100 >> 2] = fb + 3622;
 HEAP32[i1 + 104 >> 2] = gb + 771938;
 HEAP32[i1 + 108 >> 2] = 325;
 HEAP32[i1 + 112 >> 2] = fb + 2239;
 HEAP32[i1 + 116 >> 2] = fb + 3623;
 HEAP32[i1 + 120 >> 2] = gb + 771959;
 HEAP32[i1 + 124 >> 2] = 326;
 HEAP32[i1 + 128 >> 2] = fb + 2240;
 HEAP32[i1 + 132 >> 2] = fb + 3624;
 HEAP32[i1 + 136 >> 2] = gb + 771972;
 HEAP32[i1 + 140 >> 2] = 327;
 HEAP32[i1 + 144 >> 2] = fb + 2241;
 HEAP32[i1 + 148 >> 2] = fb + 3625;
 HEAP32[i1 + 152 >> 2] = gb + 772224;
 HEAP32[i1 + 156 >> 2] = 328;
 HEAP32[i1 + 160 >> 2] = fb + 2242;
 HEAP32[i1 + 164 >> 2] = fb + 3626;
 HEAP32[i1 + 168 >> 2] = gb + 772614;
 HEAP32[i1 + 172 >> 2] = 329;
 HEAP32[i1 + 176 >> 2] = fb + 2243;
 HEAP32[i1 + 180 >> 2] = fb + 3627;
 HEAP32[i1 + 184 >> 2] = gb + 771701;
 HEAP32[i1 + 188 >> 2] = 330;
 HEAP32[i1 + 192 >> 2] = fb + 3628;
 HEAP32[i1 + 196 >> 2] = fb + 3629;
 HEAP32[i1 + 200 >> 2] = gb + 772083;
 HEAP32[i1 + 204 >> 2] = 331;
 HEAP32[i1 + 208 >> 2] = fb + 484;
 HEAP32[i1 + 212 >> 2] = fb + 416;
 HEAP32[i1 + 216 >> 2] = gb + 772101;
 HEAP32[i1 + 220 >> 2] = 332;
 HEAP32[i1 + 224 >> 2] = fb + 2244;
 HEAP32[i1 + 228 >> 2] = fb + 3630;
 HEAP32[i1 + 232 >> 2] = gb + 772032;
 HEAP32[i1 + 236 >> 2] = 333;
 HEAP32[i1 + 240 >> 2] = fb + 485;
 HEAP32[i1 + 244 >> 2] = fb + 417;
 HEAP32[i1 + 248 >> 2] = gb + 771995;
 HEAP32[i1 + 252 >> 2] = 334;
 HEAP32[i1 + 256 >> 2] = fb + 486;
 HEAP32[i1 + 260 >> 2] = fb + 418;
 HEAP32[i1 + 264 >> 2] = gb + 772059;
 HEAP32[i1 + 268 >> 2] = 335;
 HEAP32[i1 + 272 >> 2] = fb + 487;
 HEAP32[i1 + 276 >> 2] = fb + 419;
 HEAP32[i1 + 280 >> 2] = gb + 743223;
 HEAP32[i1 + 284 >> 2] = 336;
 HEAP32[i1 + 288 >> 2] = fb + 2245;
 HEAP32[i1 + 292 >> 2] = fb + 3631;
 HEAP32[i1 + 296 >> 2] = gb + 771743;
 HEAP32[i1 + 300 >> 2] = 337;
 HEAP32[i1 + 304 >> 2] = fb + 2246;
 HEAP32[i1 + 308 >> 2] = fb + 3632;
 HEAP32[i1 + 312 >> 2] = gb + 771757;
 HEAP32[i1 + 316 >> 2] = 338;
 HEAP32[i1 + 320 >> 2] = fb + 2247;
 HEAP32[i1 + 324 >> 2] = fb + 3633;
 HEAP32[i1 + 328 >> 2] = gb + 771771;
 HEAP32[i1 + 332 >> 2] = 339;
 HEAP32[i1 + 336 >> 2] = fb + 2248;
 HEAP32[i1 + 340 >> 2] = fb + 3634;
 HEAP32[i1 + 344 >> 2] = gb + 772138;
 HEAP32[i1 + 348 >> 2] = 340;
 HEAP32[i1 + 352 >> 2] = fb + 2249;
 HEAP32[i1 + 356 >> 2] = fb + 3635;
 HEAP32[i1 + 360 >> 2] = gb + 772154;
 HEAP32[i1 + 364 >> 2] = 341;
 HEAP32[i1 + 368 >> 2] = fb + 2250;
 HEAP32[i1 + 372 >> 2] = fb + 3636;
 HEAP32[i1 + 376 >> 2] = gb + 772171;
 HEAP32[i1 + 380 >> 2] = 342;
 HEAP32[i1 + 384 >> 2] = fb + 2251;
 HEAP32[i1 + 388 >> 2] = fb + 3637;
 HEAP32[i1 + 392 >> 2] = gb + 741613;
 HEAP32[i1 + 396 >> 2] = 343;
 HEAP32[i1 + 400 >> 2] = fb + 2252;
 HEAP32[i1 + 404 >> 2] = fb + 3638;
 HEAP32[i1 + 408 >> 2] = gb + 772346;
 HEAP32[i1 + 412 >> 2] = 344;
 HEAP32[i1 + 416 >> 2] = fb + 2253;
 HEAP32[i1 + 420 >> 2] = fb + 3639;
 HEAP32[i1 + 424 >> 2] = gb + 772269;
 HEAP32[i1 + 428 >> 2] = 345;
 HEAP32[i1 + 432 >> 2] = fb + 2254;
 HEAP32[i1 + 436 >> 2] = fb + 3640;
 HEAP32[i1 + 440 >> 2] = gb + 772633;
 HEAP32[i1 + 444 >> 2] = 346;
 HEAP32[i1 + 448 >> 2] = fb + 2255;
 HEAP32[i1 + 452 >> 2] = fb + 3641;
 HEAP32[i1 + 456 >> 2] = gb + 772316;
 HEAP32[i1 + 460 >> 2] = 347;
 HEAP32[i1 + 464 >> 2] = fb + 2256;
 HEAP32[i1 + 468 >> 2] = fb + 3642;
 HEAP32[i1 + 472 >> 2] = gb + 772656;
 HEAP32[i1 + 476 >> 2] = 348;
 HEAP32[i1 + 480 >> 2] = fb + 2257;
 HEAP32[i1 + 484 >> 2] = fb + 3643;
 HEAP32[i1 + 488 >> 2] = gb + 772669;
 HEAP32[i1 + 492 >> 2] = 349;
 HEAP32[i1 + 496 >> 2] = fb + 2258;
 HEAP32[i1 + 500 >> 2] = fb + 3644;
 HEAP32[i1 + 504 >> 2] = gb + 772362;
 HEAP32[i1 + 508 >> 2] = 350;
 HEAP32[i1 + 512 >> 2] = fb + 488;
 HEAP32[i1 + 516 >> 2] = fb + 420;
 HEAP32[i1 + 520 >> 2] = gb + 772685;
 HEAP32[i1 + 524 >> 2] = 351;
 HEAP32[i1 + 528 >> 2] = fb + 3645;
 HEAP32[i1 + 532 >> 2] = fb + 3646;
 return;
}

function __Z27CreatePxStreamFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypeR12MemoryStream(i10, i2, i7, i3, i4, i8) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i25 + 72 | 0;
 i9 = i25 + 16 | 0;
 i12 = i25;
 i20 = i25 + 136 | 0;
 i21 = i25 + 116 | 0;
 i22 = i25 + 96 | 0;
 i13 = i25 + 76 | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 HEAP32[i20 >> 2] = 0;
 i1 = i20 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i14 = i20 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i16 = i9;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i5 = i15;
 HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i5 + 4 >> 2] = i17;
 i5 = gb + 64016 | 0;
 i17 = HEAP32[i5 + 4 >> 2] | 0;
 i16 = i12;
 HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 i16 = i21 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i5 = i9;
 i18 = HEAP32[i5 + 4 >> 2] | 0;
 i19 = i17;
 HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i19 + 4 >> 2] = i18;
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i5 + 4 >> 2] = i18;
 HEAP32[i22 >> 2] = 0;
 i5 = i22 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i18 = i22 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i22 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i23 = i9;
 i24 = HEAP32[i23 + 4 >> 2] | 0;
 i27 = i19;
 HEAP32[i27 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i27 + 4 >> 2] = i24;
 i27 = gb + 64016 | 0;
 i24 = HEAP32[i27 + 4 >> 2] | 0;
 i23 = i12;
 HEAP32[i23 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i23 + 4 >> 2] = i24;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i23 = i13 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i12);
 i27 = i9;
 i26 = HEAP32[i27 + 4 >> 2] | 0;
 i6 = i24;
 HEAP32[i6 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i6 + 4 >> 2] = i26;
 do if (__Z19ExtractDataFromMeshR4MeshR13dynamic_arrayI8Vector3fLj4EERS1_ItLj2EES6_(i10, i20, i22, i13) | 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  if (i4 | 0) {
   i27 = HEAP32[i20 >> 2] | 0;
   __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fjPS2_ji(i3, i27, 12, i27, 12, i6);
  }
  if (!i2) {
   HEAP32[i9 + 28 >> 2] = 0;
   HEAP32[i9 + 32 >> 2] = 0;
   HEAPF32[i9 + 36 >> 2] = Math_fround(.00100000005);
   HEAP32[i9 + 8 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i9 >> 2] = 12;
   HEAP32[i9 + 20 >> 2] = ((HEAP32[i5 >> 2] | 0) >>> 0) / 3 | 0;
   HEAP32[i9 + 16 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i9 + 12 >> 2] = 6;
   HEAP16[i9 + 24 >> 1] = (i4 & 4) >>> 2 | 2;
   i1 = __Z10GetCookingv() | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i9 | 0, i8 | 0) | 0;
   break;
  }
  i1 = i9 + 50 | 0;
  i2 = i9 + 4 | 0;
  i3 = i2 + 44 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP16[i1 >> 1] = 256;
  i1 = i9 + 48 | 0;
  HEAP16[i1 >> 1] = 4;
  HEAP32[i9 + 8 >> 2] = i6;
  HEAP32[i9 + 4 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i9 >> 2] = 12;
  if (i7) HEAP16[i1 >> 1] = 12;
  i1 = __Z10GetCookingv() | 0;
  i1 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i9 | 0, i8 | 0, 0) | 0;
  if (!i1) {
   HEAP32[i11 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
   __Z6FormatPKcz(i12, gb + 780916 | 0, i11);
   if (!i10) i2 = 0; else i2 = HEAP32[i10 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 781176 | 0, 54, 1, i2, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  }
 } else i1 = 0; while (0);
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i24);
  HEAP32[i13 >> 2] = 0;
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i19);
  HEAP32[i22 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i17);
  HEAP32[i21 >> 2] = 0;
 }
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i25;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i15);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i25;
 return i1 | 0;
}

function runPostSets31() {
 HEAP32[gb + 43748 >> 2] = fb + 339;
 HEAP32[gb + 43752 >> 2] = fb + 16;
 HEAP32[gb + 43756 >> 2] = fb + 364;
 HEAP32[gb + 43760 >> 2] = fb + 40;
 HEAP32[gb + 43764 >> 2] = fb + 349;
 HEAP32[gb + 43768 >> 2] = fb + 211;
 HEAP32[gb + 43772 >> 2] = fb + 103;
 HEAP32[gb + 43776 >> 2] = fb + 101;
 HEAP32[gb + 43780 >> 2] = fb + 62;
 HEAP32[gb + 43784 >> 2] = fb + 28;
 HEAP32[gb + 43788 >> 2] = fb + 63;
 HEAP32[gb + 43792 >> 2] = fb + 29;
 HEAP32[gb + 43796 >> 2] = fb + 34;
 HEAP32[gb + 43800 >> 2] = fb + 340;
 HEAP32[gb + 43804 >> 2] = fb + 341;
 HEAP32[gb + 43808 >> 2] = fb + 342;
 HEAP32[gb + 43812 >> 2] = fb + 343;
 HEAP32[gb + 43816 >> 2] = fb + 344;
 HEAP32[gb + 43820 >> 2] = fb + 345;
 HEAP32[gb + 43824 >> 2] = fb + 36;
 HEAP32[gb + 43828 >> 2] = fb + 104;
 HEAP32[gb + 43832 >> 2] = fb + 336;
 HEAP32[gb + 43836 >> 2] = fb + 94;
 HEAP32[gb + 43840 >> 2] = fb + 337;
 HEAP32[gb + 43844 >> 2] = fb + 205;
 HEAP32[gb + 43848 >> 2] = fb + 206;
 HEAP32[gb + 43852 >> 2] = fb + 338;
 HEAP32[gb + 43856 >> 2] = fb + 350;
 HEAP32[gb + 43860 >> 2] = fb + 351;
 HEAP32[gb + 43864 >> 2] = fb + 207;
 HEAP32[gb + 43868 >> 2] = fb + 365;
 HEAP32[gb + 43872 >> 2] = fb + 353;
 HEAP32[gb + 43876 >> 2] = fb + 208;
 HEAP32[gb + 43880 >> 2] = fb + 68;
 HEAP32[gb + 43884 >> 2] = fb + 69;
 HEAP32[gb + 43888 >> 2] = fb + 366;
 HEAP32[gb + 43892 >> 2] = fb + 355;
 HEAP32[gb + 43896 >> 2] = fb + 356;
 HEAP32[gb + 43908 >> 2] = fb + 367;
 HEAP32[gb + 43912 >> 2] = fb + 368;
 HEAP32[gb + 43916 >> 2] = fb + 20;
 HEAP32[gb + 43920 >> 2] = fb + 102;
 HEAP32[gb + 43924 >> 2] = fb + 359;
 HEAP32[gb + 43928 >> 2] = fb + 360;
 HEAP32[gb + 43932 >> 2] = fb + 209;
 HEAP32[gb + 43936 >> 2] = fb + 210;
 HEAP32[gb + 43940 >> 2] = fb + 70;
 HEAP32[gb + 43944 >> 2] = fb + 71;
 HEAP32[gb + 43948 >> 2] = fb + 110;
 HEAP32[gb + 43952 >> 2] = fb + 105;
 HEAP32[gb + 43956 >> 2] = fb + 369;
 HEAP32[gb + 43960 >> 2] = (HEAP32[gb + 43960 >> 2] | 0) + (gb + 1033999 | 0);
 HEAP32[gb + 43964 >> 2] = (HEAP32[gb + 43964 >> 2] | 0) + (gb + 1034004 | 0);
 HEAP32[gb + 43968 >> 2] = (HEAP32[gb + 43968 >> 2] | 0) + (gb + 1034009 | 0);
 HEAP32[gb + 43972 >> 2] = (HEAP32[gb + 43972 >> 2] | 0) + (gb + 1034014 | 0);
 HEAP32[gb + 43976 >> 2] = (HEAP32[gb + 43976 >> 2] | 0) + (gb + 1034019 | 0);
 HEAP32[gb + 43980 >> 2] = (HEAP32[gb + 43980 >> 2] | 0) + (gb + 1034024 | 0);
 HEAP32[gb + 43984 >> 2] = (HEAP32[gb + 43984 >> 2] | 0) + (gb + 1034029 | 0);
 HEAP32[gb + 43988 >> 2] = (HEAP32[gb + 43988 >> 2] | 0) + (gb + 1034034 | 0);
 HEAP32[gb + 43992 >> 2] = (HEAP32[gb + 43992 >> 2] | 0) + (gb + 1034039 | 0);
 HEAP32[gb + 43996 >> 2] = (HEAP32[gb + 43996 >> 2] | 0) + (gb + 1034046 | 0);
 HEAP32[gb + 44e3 >> 2] = (HEAP32[gb + 44e3 >> 2] | 0) + (gb + 1034053 | 0);
 HEAP32[gb + 44004 >> 2] = (HEAP32[gb + 44004 >> 2] | 0) + (gb + 1034060 | 0);
 HEAP32[gb + 44008 >> 2] = (HEAP32[gb + 44008 >> 2] | 0) + (gb + 1034067 | 0);
 HEAP32[gb + 44012 >> 2] = (HEAP32[gb + 44012 >> 2] | 0) + (gb + 1034074 | 0);
 HEAP32[gb + 44016 >> 2] = (HEAP32[gb + 44016 >> 2] | 0) + (gb + 1034081 | 0);
 HEAP32[gb + 44020 >> 2] = (HEAP32[gb + 44020 >> 2] | 0) + (gb + 1034088 | 0);
 HEAP32[gb + 44024 >> 2] = (HEAP32[gb + 44024 >> 2] | 0) + (gb + 1034095 | 0);
 HEAP32[gb + 44028 >> 2] = (HEAP32[gb + 44028 >> 2] | 0) + (gb + 1034102 | 0);
 HEAP32[gb + 44032 >> 2] = (HEAP32[gb + 44032 >> 2] | 0) + (gb + 1034109 | 0);
 HEAP32[gb + 44036 >> 2] = (HEAP32[gb + 44036 >> 2] | 0) + (gb + 1034116 | 0);
 HEAP32[gb + 44040 >> 2] = (HEAP32[gb + 44040 >> 2] | 0) + (gb + 1034123 | 0);
 HEAP32[gb + 44044 >> 2] = (HEAP32[gb + 44044 >> 2] | 0) + (gb + 1034130 | 0);
 HEAP32[gb + 44048 >> 2] = (HEAP32[gb + 44048 >> 2] | 0) + (gb + 1034137 | 0);
 HEAP32[gb + 44052 >> 2] = (HEAP32[gb + 44052 >> 2] | 0) + (gb + 1034144 | 0);
 HEAP32[gb + 44064 >> 2] = fb + 370;
 HEAP32[gb + 44068 >> 2] = fb + 371;
 HEAP32[gb + 44072 >> 2] = fb + 80;
 HEAP32[gb + 44076 >> 2] = fb + 346;
 HEAP32[gb + 44080 >> 2] = fb + 16;
 HEAP32[gb + 44084 >> 2] = fb + 372;
 HEAP32[gb + 44088 >> 2] = fb + 373;
 HEAP32[gb + 44092 >> 2] = fb + 19;
 HEAP32[gb + 44096 >> 2] = fb + 212;
 HEAP32[gb + 44100 >> 2] = fb + 99;
 HEAP32[gb + 44104 >> 2] = fb + 40;
 HEAP32[gb + 44108 >> 2] = fb + 62;
 HEAP32[gb + 44112 >> 2] = fb + 28;
 HEAP32[gb + 44116 >> 2] = fb + 63;
 HEAP32[gb + 44120 >> 2] = fb + 29;
 HEAP32[gb + 44124 >> 2] = fb + 34;
 HEAP32[gb + 44128 >> 2] = fb + 347;
 HEAP32[gb + 44132 >> 2] = fb + 348;
 HEAP32[gb + 44136 >> 2] = fb + 349;
 HEAP32[gb + 44140 >> 2] = fb + 350;
 HEAP32[gb + 44144 >> 2] = fb + 351;
 HEAP32[gb + 44148 >> 2] = fb + 352;
 HEAP32[gb + 44152 >> 2] = fb + 36;
 HEAP32[gb + 44156 >> 2] = fb + 96;
 HEAP32[gb + 44160 >> 2] = fb + 81;
 runPostSets32();
}

function __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 64 | 0;
 i11 = i16 + 48 | 0;
 i12 = i16;
 i13 = i16 + 32 | 0;
 i14 = i16 + 16 | 0;
 if ((__ZNK2UI6Canvas13GetRenderModeEv(i7) | 0) != 1) {
  STACKTOP = i16;
  return;
 }
 if (HEAP32[i7 + 344 >> 2] | 0) {
  STACKTOP = i16;
  return;
 }
 i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
 i6 = i7 + 40 | 0;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i15 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i5 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i11);
   i2 = HEAP32[i8 >> 2] | 0;
   i17 = HEAP32[i1 + 28 >> 2] | 0;
   i5 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
   i2 = HEAP32[i5 + 28 >> 2] | 0;
   i5 = HEAP32[i5 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i5 << 3) | 0)) i15 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i15 = 10;
  }
 }
 if ((i15 | 0) == 8) i15 = 10;
 if ((i15 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i2 = __ZNK10GameObject23QueryComponentTransformEv(HEAP32[i1 + 28 >> 2] | 0) | 0;
 i1 = i2;
 while (1) {
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) break;
  if ((i1 | 0) == (i10 | 0)) {
   i15 = 24;
   break;
  }
 }
 if ((i15 | 0) == 24) {
  STACKTOP = i16;
  return;
 }
 __ZNK9Transform11GetPositionEv(i8, i2);
 __ZNK9Transform11GetRotationEv(i11, i2);
 f24 = Math_fround(HEAPF32[i7 + 364 >> 2]);
 f21 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(f21 * Math_fround(2.0));
 i1 = i11 + 4 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(f19 * Math_fround(2.0));
 i2 = i11 + 8 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f25 = Math_fround(f4 * Math_fround(2.0));
 f23 = Math_fround(f21 * f3);
 f22 = Math_fround(f19 * f20);
 f4 = Math_fround(f4 * f25);
 f26 = Math_fround(f21 * f20);
 f21 = Math_fround(f21 * f25);
 f19 = Math_fround(f19 * f25);
 i5 = i11 + 12 | 0;
 f18 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(f3 * f18);
 f20 = Math_fround(f20 * f18);
 f25 = Math_fround(f18 * f25);
 f18 = Math_fround(Math_fround(f24 * Math_fround(f21 + f20)) + Math_fround(Math_fround(Math_fround(f26 - f25) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f22 + f4)) * Math_fround(0.0))));
 f4 = Math_fround(Math_fround(f24 * Math_fround(f19 - f3)) + Math_fround(Math_fround(Math_fround(f26 + f25) * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f23 + f4)) * Math_fround(0.0))));
 f3 = Math_fround(Math_fround(f24 * Math_fround(Math_fround(1.0) - Math_fround(f23 + f22))) + Math_fround(Math_fround(Math_fround(f21 - f20) * Math_fround(0.0)) + Math_fround(Math_fround(f19 + f3) * Math_fround(0.0))));
 f18 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f18);
 f4 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) + f4);
 f3 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) + f3);
 HEAPF32[i12 >> 2] = f18;
 HEAPF32[i12 + 4 >> 2] = f4;
 HEAPF32[i12 + 8 >> 2] = f3;
 __ZNK9Transform11GetPositionEv(i13, i10);
 if (Math_fround(HEAPF32[i13 >> 2]) != f18) i15 = 17; else if (Math_fround(HEAPF32[i13 + 4 >> 2]) != f4) i15 = 17; else if (Math_fround(HEAPF32[i13 + 8 >> 2]) != f3) i15 = 17;
 if ((i15 | 0) == 17) {
  __ZN9Transform30SetPositionWithoutNotificationERK8Vector3f(i10, i12);
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 }
 __ZNK9Transform11GetRotationEv(i14, i10);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 if (f26 != Math_fround(HEAPF32[i11 >> 2])) i15 = 22; else {
  f26 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  if (f26 != Math_fround(HEAPF32[i1 >> 2])) i15 = 22; else {
   f26 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   if (f26 != Math_fround(HEAPF32[i2 >> 2])) i15 = 22; else {
    f26 = Math_fround(HEAPF32[i14 + 12 >> 2]);
    if (f26 != Math_fround(HEAPF32[i5 >> 2])) i15 = 22;
   }
  }
 }
 if ((i15 | 0) == 22) {
  __ZN9Transform30SetRotationWithoutNotificationERK11Quaternionf(i10, i11);
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2;
 }
 STACKTOP = i16;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 24 | 0;
 i4 = i14 + 20 | 0;
 i10 = i14 + 8 | 0;
 i5 = i14 + 4 | 0;
 i6 = i14;
 i13 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = ((HEAP32[i13 >> 2] | 0) - i2 | 0) / 52 | 0;
 i1 = i2;
 if (i3 >>> 0 >= i8 >>> 0) {
  if (i3 >>> 0 <= i8 >>> 0) {
   STACKTOP = i14;
   return;
  }
  i5 = i1 + (i8 * 52 | 0) | 0;
  HEAP32[i11 >> 2] = 0;
  i7 = i11 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i2 = i8 * 52 | 0;
  i3 = (i2 | 0) / 52 | 0;
  if (!i2) {
   i4 = i11 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 82595524) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i11 >> 2] = i4;
   i2 = i4 + (i3 * 52 | 0) | 0;
   i6 = i11 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i8) {
    i4 = i6;
    i5 = i3;
   } else {
    i3 = i4;
    do {
     __ZN11DetailPatchC2ERKS_(i3, i1);
     i1 = i1 + 52 | 0;
     i3 = (HEAP32[i7 >> 2] | 0) + 52 | 0;
     HEAP32[i7 >> 2] = i3;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i5;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i13 >> 2] = i3;
  i13 = i12 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i2;
  i4 = i1;
  i2 = i10;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    do {
     HEAP32[i7 >> 2] = i2 + -52;
     i1 = HEAP32[i2 + -12 >> 2] | 0;
     if (i1 | 0) {
      i3 = i2 + -8 | 0;
      if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
      __ZdlPv(i1);
     }
     i3 = HEAP32[i2 + -24 >> 2] | 0;
     if (i3 | 0) {
      i1 = i2 + -20 | 0;
      if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i3;
      __ZdlPv(i3);
     }
     i2 = HEAP32[i7 >> 2] | 0;
    } while ((i2 | 0) != (i4 | 0));
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i14;
  return;
 }
 i7 = i12 + 8 | 0;
 if ((((HEAP32[i7 >> 2] | 0) - i2 | 0) / 52 | 0 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj(i12, i8 - i3 | 0);
  STACKTOP = i14;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE7reserveEj(i10, i8);
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i10, i4, i11);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 52 | 0;
 i4 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj(i10, i8 - i1 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i5 = i3 + (i8 * 52 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   do {
    HEAP32[i9 >> 2] = i2 + -52;
    i1 = HEAP32[i2 + -12 >> 2] | 0;
    if (i1 | 0) {
     i3 = i2 + -8 | 0;
     if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
     __ZdlPv(i1);
    }
    i3 = HEAP32[i2 + -24 >> 2] | 0;
    if (i3 | 0) {
     i1 = i2 + -20 | 0;
     if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i3;
     __ZdlPv(i3);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
  }
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   do {
    HEAP32[i9 >> 2] = i2 + -52;
    i1 = HEAP32[i2 + -12 >> 2] | 0;
    if (i1 | 0) {
     i3 = i2 + -8 | 0;
     if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
     __ZdlPv(i1);
    }
    i3 = HEAP32[i2 + -24 >> 2] | 0;
    if (i3 | 0) {
     i1 = i2 + -20 | 0;
     if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i3;
     __ZdlPv(i3);
    }
    i2 = HEAP32[i9 >> 2] | 0;
   } while ((i2 | 0) != (i4 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i14;
 return;
}

function __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i1 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i7 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 }
 i3 = i5 + 4 | 0;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i4, i5 + 28 | 0, 0);
 i3 = i5 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 44 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i5 + 64 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i3 >>> 0 > 3 ? 3 : i3;
 i4 = i5 + 84 + (i3 << 2) | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i3 = i5 + 84 | 0;
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i6 >> 2] = i2;
  }
  HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
      HEAP32[i2 >> 2] = 1;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
      HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903113 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine17ConditionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
       HEAP32[i2 >> 2] = 1;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
       HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903113 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine17ConditionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 48 | 0;
 i12 = i18 + 24 | 0;
 i10 = i18 + 16 | 0;
 i7 = i18 + 8 | 0;
 i6 = i18;
 i15 = i18 + 64 | 0;
 i16 = i18 + 52 | 0;
 i11 = i18 + 80 | 0;
 i17 = i14 + 24 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (!(i1 & 131072)) if (!(i1 & 1059153)) if (!(i1 & 2097154)) i8 = (i1 & 4736 | 0) == 0 ? 3 : 2; else i8 = 1; else i8 = 0; else i8 = 4;
 if ((HEAP32[gb + 1450768 >> 2] | 0) == 1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[gb + 1450768 >> 2] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i5, _strlen(i5) | 0);
 i5 = i14 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i3, _strlen(i3) | 0);
 i3 = i2 + 36280 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 35512 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 35512 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiii(HEAP32[i4 >> 2] | 0, i15 | 0, i16 | 0, i8 | 0, 1); else mftCall_viiiii(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 35512 + (i1 * 12 | 0) + 4 >> 2] | 0, i15 | 0, i16 | 0, i8 | 0, 1);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i1, _strlen(i1) | 0);
 i1 = i14 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i15, gb + 1074320 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i15, HEAP32[i1 >> 2] | 0) | 0;
 }
 i4 = HEAP32[i14 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i4, _strlen(i4) | 0);
 if (HEAP32[i5 >> 2] | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, gb + 1074320 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i16, HEAP32[i5 >> 2] | 0) | 0;
 }
 i4 = i14 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = i2;
  __Z15CleanLogHandler7LogTypePKcz(i8, gb + 583024 | 0, i7);
 } else {
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i1;
  __Z15CleanLogHandler7LogTypePKcz(i8, gb + 583007 | 0, i6);
 }
 i1 = HEAP32[i17 >> 2] | 0;
 if (!(i1 & 1028)) if (!(i1 & 640)) i3 = (i1 & 2097154 | 0) == 0 ? fb + 3165 | 0 : fb + 3166 | 0; else i3 = fb + 3168 | 0; else i3 = fb + 3167 | 0;
 if (!(HEAP32[gb + 73464 + (i8 << 2) >> 2] | i1 & 768)) {
  HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
  mftCall_vii(i3 | 0, gb + 1076431 | 0, i9 | 0);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) HEAP8[i11 >> 0] = 0; else {
   HEAP32[i10 >> 2] = i1;
   _sprintf(i11, gb + 583029 | 0, i10) | 0;
  }
  i2 = (HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15;
  i1 = i2;
  L38 : while (1) {
   switch (HEAP8[i1 >> 0] | 0) {
   case 0:
    {
     i13 = 28;
     break L38;
    }
   case 10:
    {
     i1 = 1;
     break L38;
    }
   default:
    {}
   }
   i1 = i1 + 1 | 0;
  }
  if ((i13 | 0) == 28) i1 = 0;
  i10 = HEAP32[i14 + 16 >> 2] | 0;
  i13 = HEAP32[i14 + 20 >> 2] | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i12 + 4 >> 2] = i1 ? gb + 1074320 | 0 : gb + 1576256 | 0;
  HEAP32[i12 + 8 >> 2] = i11;
  HEAP32[i12 + 12 >> 2] = i10;
  HEAP32[i12 + 16 >> 2] = i13;
  HEAP32[i12 + 20 >> 2] = i1 ? gb + 583040 | 0 : gb + 1074320 | 0;
  mftCall_vii(i3 | 0, gb + 583043 | 0, i12 | 0);
 }
 i1 = HEAP32[gb + 1450796 >> 2] | 0;
 if (i1 | 0) mftCall_viiiiiiii(i1 | 0, i16 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i14 + 16 >> 2] | 0, HEAP32[i14 + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0, HEAP32[i14 + 28 >> 2] | 0, HEAP32[i14 + 32 >> 2] | 0, HEAP32[i14 + 36 >> 2] | 0);
 HEAP32[gb + 1450768 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 STACKTOP = i18;
 return;
}

function __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy(i12, i1, i3, i4) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i5 = i13 + 4 | 0;
 i6 = i12 + 188 | 0;
 __ZN15FileSystemEntryaSERKS_(i6, i1) | 0;
 if (!(__ZN20ArchiveStorageReader15MakeStorageUsedEv(i12) | 0)) {
  i12 = -1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i7 = __ZN20ArchiveStorageReader10ReadHeaderEy(i12, i3, i4) | 0;
 switch (i7 | 0) {
 case 0:
  {
   i7 = i12 + 136 | 0;
   i9 = i12 + 104 | 0;
   i8 = i12 + 108 | 0;
   i1 = (((HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
   i3 = i12 + 148 | 0;
   HEAP32[i3 >> 2] = i1;
   i4 = i12 + 152 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   do if ((i5 & 2147483647) >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i1;
    HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 3, 8, i12 + 140 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i12 + 140 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i7 >> 2] = i11;
    break;
   } while (0);
   i1 = i12 + 156 | 0;
   i3 = (((HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 12 | 0) + 1 | 0;
   i4 = i12 + 168 | 0;
   HEAP32[i4 >> 2] = i3;
   i5 = i12 + 172 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   do if ((i6 & 2147483647) >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i3;
    i11 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3 << 3, 8, i12 + 160 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i1 >> 2] = i11;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 8, i12 + 160 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i1 >> 2] = i11;
    break;
   } else i11 = HEAP32[i1 >> 2] | 0; while (0);
   i10 = HEAP32[i7 >> 2] | 0;
   i3 = i10;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i3 = i11;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i12 = i12 + 176 | 0;
   HEAP32[i12 >> 2] = 65536;
   i3 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i7 = i1;
   if ((i3 | 0) == (i1 | 0)) {
    f2 = Math_fround(3402823469999999843913219.0e14);
    i1 = 65536;
   } else {
    i6 = (i3 - i1 | 0) / 12 | 0;
    i5 = 0;
    f2 = Math_fround(3402823469999999843913219.0e14);
    i1 = 65536;
    do {
     i14 = i10 + (i5 << 3) | 0;
     i3 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
     i14 = _i64Add(i3 | 0, 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
     i4 = getTempRet0() | 0;
     i9 = i5;
     i5 = i5 + 1 | 0;
     i15 = i10 + (i5 << 3) | 0;
     HEAP32[i15 >> 2] = i14;
     HEAP32[i15 + 4 >> 2] = i4;
     i15 = i11 + (i9 << 3) | 0;
     i4 = HEAP32[i7 + (i9 * 12 | 0) + 4 >> 2] | 0;
     i15 = _i64Add(i4 | 0, 0, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0) | 0;
     i14 = getTempRet0() | 0;
     i8 = i11 + (i5 << 3) | 0;
     HEAP32[i8 >> 2] = i15;
     HEAP32[i8 + 4 >> 2] = i14;
     if (i1 >>> 0 < i4 >>> 0 ? (HEAP16[i7 + (i9 * 12 | 0) + 8 >> 1] & 64) == 0 : 0) {
      HEAP32[i12 >> 2] = i4;
      i1 = i4;
     }
     f16 = Math_fround(Math_fround(i4 >>> 0) / Math_fround(i3 >>> 0));
     f2 = f2 > f16 ? f16 : f2;
    } while (i5 >>> 0 < i6 >>> 0);
   }
   HEAP32[i12 >> 2] = ~~Math_fround(Math_fround(i1 >>> 0) / f2) >>> 0;
   i15 = 0;
   STACKTOP = i13;
   return i15 | 0;
  }
 case -1:
  {
   HEAP32[i8 >> 2] = __ZNK15FileSystemEntry4PathEv(i6) | 0;
   __Z6FormatPKcz(i5, gb + 490084 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 489692 | 0, 64, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   break;
  }
 default:
  {}
 }
 i14 = i12 + 2336 | 0;
 i15 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
 HEAP32[i14 >> 2] = i15;
 if (!i15) {
  __ZN12FileAccessor5CloseEv(i12 + 1248 | 0) | 0;
  i3 = i12 + 2376 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = i12 + 2364 | 0;
   i1 = 0;
   do {
    __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i12, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i15 = i7;
 STACKTOP = i13;
 return i15 | 0;
}

function __ZN18ProceduralMaterial22CloneMaterialForExportEbb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i7 = __ZN18ProceduralMaterial5CloneEv(i2) | 0;
 i1 = HEAP32[i7 + 204 >> 2] | 0;
 i8 = i7 + 208 | 0;
 if ((i1 | 0) == (HEAP32[i8 >> 2] | 0)) {
  i12 = i7 + 172 | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i10 = i10 & -4105;
  i10 = i10 | 4096;
  HEAP32[i12 >> 2] = i10;
  STACKTOP = i11;
  return i7 | 0;
 }
 if (i3) {
  i5 = i1;
  do {
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i10 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 10;
    }
   }
   if ((i12 | 0) == 9) i12 = 10;
   if ((i12 | 0) == 10) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   }
   HEAP32[i1 + 152 + 20 >> 2] = 4;
   i5 = i5 + 72 | 0;
  } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
  i12 = i7 + 172 | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i10 = i10 & -4105;
  i10 = i10 | 4096;
  HEAP32[i12 >> 2] = i10;
  STACKTOP = i11;
  return i7 | 0;
 } else i6 = i1;
 do {
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i4 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 18; else {
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) i12 = 20;
   }
  }
  if ((i12 | 0) == 18) i12 = 20;
  if ((i12 | 0) == 20) {
   i12 = 0;
   i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i2 + 152 + 20 >> 2] = 4;
  HEAP32[i10 >> 2] = i5;
  if (!i1) i12 = 26; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 26; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 28;
   }
  }
  if ((i12 | 0) == 26) i12 = 28;
  if ((i12 | 0) == 28) {
   i12 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
  }
  i3 = HEAP32[i1 + 192 + 4 >> 2] | 0;
  i5 = HEAP32[i1 + 84 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  i5 = HEAP8[(__ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_(i5 + 272 | 0, i9) | 0) >> 0] | 0;
  i2 = i1 + 200 | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i1 + 180 >> 0] = i5;
  HEAP32[i1 + 164 >> 2] = 0;
  HEAP8[i1 + 181 >> 0] = 0;
  i6 = i6 + 72 | 0;
 } while ((i6 | 0) != (HEAP32[i8 >> 2] | 0));
 i12 = i7 + 172 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 i10 = i10 & -4105;
 i10 = i10 | 4096;
 HEAP32[i12 >> 2] = i10;
 STACKTOP = i11;
 return i7 | 0;
}

function __Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_(i2, i10, i8, i11, i21, i22) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i28 + 48 | 0;
 i23 = i28 + 36 | 0;
 i24 = i28 + 24 | 0;
 i25 = i28 + 12 | 0;
 i26 = i28;
 f19 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 f4 = Math_fround(f19 - f20);
 i12 = i2 + 4 | 0;
 i13 = i8 + 4 | 0;
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f7 = Math_fround(f18 - f17);
 f15 = Math_fround(HEAPF32[i10 >> 2]);
 f16 = Math_fround(HEAPF32[i11 >> 2]);
 f5 = Math_fround(f15 + f16);
 i2 = i10 + 4 | 0;
 i8 = i11 + 4 | 0;
 f14 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f6 = Math_fround(f14 + f9);
 if (!(Math_fround(Math_abs(Math_fround(f4))) <= f5)) {
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  f3 = Math_fround(HEAPF32[i13 >> 2]);
  f1 = Math_fround(HEAPF32[i8 >> 2]);
 } else {
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  f1 = Math_fround(HEAPF32[i8 >> 2]);
  f29 = Math_fround(f5 + f1);
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f3 = Math_fround(HEAPF32[i13 >> 2]);
  if (Math_fround(Math_abs(Math_fround(f4 - f3))) <= f29) if (Math_fround(Math_abs(Math_fround(f7))) <= f6) {
   f29 = Math_fround(0.0);
   STACKTOP = i28;
   return Math_fround(f29);
  }
 }
 f29 = Math_fround(HEAPF32[i22 >> 2]);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i21 >> 2]));
 f7 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i21 + 4 >> 2]));
 f6 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i21 + 8 >> 2]));
 HEAPF32[i27 >> 2] = f29;
 HEAPF32[i27 + 4 >> 2] = f7;
 HEAPF32[i27 + 8 >> 2] = f6;
 f6 = Math_fround(f4 + f5);
 f7 = Math_fround(f18 + f14);
 HEAPF32[i23 >> 2] = Math_fround(f19 + f15);
 HEAPF32[i23 + 4 >> 2] = f6;
 HEAPF32[i23 + 8 >> 2] = f7;
 f7 = Math_fround(f4 - f5);
 f18 = Math_fround(f18 - f14);
 HEAPF32[i24 >> 2] = Math_fround(f19 - f15);
 HEAPF32[i24 + 4 >> 2] = f7;
 HEAPF32[i24 + 8 >> 2] = f18;
 f18 = Math_fround(f3 + f1);
 f19 = Math_fround(f17 + f9);
 HEAPF32[i25 >> 2] = Math_fround(f20 + f16);
 HEAPF32[i25 + 4 >> 2] = f18;
 HEAPF32[i25 + 8 >> 2] = f19;
 f1 = Math_fround(f3 - f1);
 f9 = Math_fround(f17 - f9);
 HEAPF32[i26 >> 2] = Math_fround(f20 - f16);
 HEAPF32[i26 + 4 >> 2] = f1;
 HEAPF32[i26 + 8 >> 2] = f9;
 f9 = f29;
 i2 = 0;
 f1 = Math_fround(0.0);
 f3 = Math_fround(1.0);
 L7 : while (1) {
  do if (f9 < Math_fround(-9.99999997e-07)) {
   f6 = Math_fround(HEAPF32[i25 + (i2 << 2) >> 2]);
   f7 = Math_fround(HEAPF32[i24 + (i2 << 2) >> 2]);
   if (f6 < f7) {
    f1 = Math_fround(3402823469999999843913219.0e14);
    i2 = 23;
    break L7;
   }
   f4 = Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
   f5 = Math_fround(HEAPF32[i26 + (i2 << 2) >> 2]);
   if (f4 < f5) {
    f29 = Math_fround(Math_fround(f4 - f5) / f9);
    f1 = f29 > f1 ? f29 : f1;
   }
   if (f6 > f7) {
    f29 = Math_fround(Math_fround(f7 - f6) / f9);
    f3 = f29 < f3 ? f29 : f3;
   }
  } else {
   if (!(f9 > Math_fround(9.99999997e-07))) {
    f29 = Math_fround(HEAPF32[i25 + (i2 << 2) >> 2]);
    if (f29 < Math_fround(HEAPF32[i24 + (i2 << 2) >> 2])) {
     f1 = Math_fround(3402823469999999843913219.0e14);
     i2 = 23;
     break L7;
    }
    f29 = Math_fround(HEAPF32[i26 + (i2 << 2) >> 2]);
    if (f29 > Math_fround(HEAPF32[i23 + (i2 << 2) >> 2])) {
     f1 = Math_fround(3402823469999999843913219.0e14);
     i2 = 23;
     break L7;
    } else break;
   }
   f6 = Math_fround(HEAPF32[i26 + (i2 << 2) >> 2]);
   f7 = Math_fround(HEAPF32[i23 + (i2 << 2) >> 2]);
   if (f6 > f7) {
    f1 = Math_fround(3402823469999999843913219.0e14);
    i2 = 23;
    break L7;
   }
   f5 = Math_fround(HEAPF32[i25 + (i2 << 2) >> 2]);
   f4 = Math_fround(HEAPF32[i24 + (i2 << 2) >> 2]);
   if (f5 < f4) {
    f29 = Math_fround(Math_fround(f4 - f5) / f9);
    f1 = f29 > f1 ? f29 : f1;
   }
   if (f7 > f6) {
    f29 = Math_fround(Math_fround(f7 - f6) / f9);
    f3 = f29 < f3 ? f29 : f3;
   }
  } while (0);
  i2 = i2 + 1 | 0;
  if (f1 > f3) {
   f1 = Math_fround(3402823469999999843913219.0e14);
   i2 = 23;
   break;
  }
  if (i2 >>> 0 >= 3) {
   i2 = 23;
   break;
  }
  f9 = Math_fround(HEAPF32[i27 + (i2 << 2) >> 2]);
 }
 if ((i2 | 0) == 23) {
  STACKTOP = i28;
  return Math_fround(f1);
 }
 return Math_fround(0.0);
}

function __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i14, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i15 = i18 + 8 | 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i18 + 20 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(Math_fround(f2 + f3) * Math_fround(.5));
 i7 = i17 + 8 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i17 + 20 | 0;
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 i6 = f19 < Math_fround(Math_fround(f8 + f10) * Math_fround(.5));
 i12 = i14 + 8 | 0;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 20 | 0;
 i11 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < f19;
 if (!i6) {
  if (!i11) {
   i18 = 0;
   return i18 | 0;
  }
  i24 = HEAP32[i18 >> 2] | 0;
  i1 = i18 + 4 | 0;
  i23 = HEAP32[i1 >> 2] | 0;
  i4 = i18 + 12 | 0;
  i22 = HEAP32[i4 >> 2] | 0;
  i5 = i18 + 16 | 0;
  i21 = HEAP32[i5 >> 2] | 0;
  i6 = i18 + 24 | 0;
  i11 = HEAP32[i6 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i14 >> 2] = i24;
  HEAP32[i14 + 4 >> 2] = i23;
  HEAPF32[i12 >> 2] = f2;
  HEAP32[i14 + 12 >> 2] = i22;
  HEAP32[i14 + 16 >> 2] = i21;
  HEAPF32[i13 >> 2] = f3;
  HEAP32[i14 + 24 >> 2] = i11;
  f20 = Math_fround(HEAPF32[i15 >> 2]);
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i9 >> 2]);
  if (!(f20 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i24 = 1;
   return i24 | 0;
  }
  i14 = HEAP32[i17 >> 2] | 0;
  i21 = HEAP32[i17 + 4 >> 2] | 0;
  i22 = HEAP32[i17 + 12 >> 2] | 0;
  i23 = HEAP32[i17 + 16 >> 2] | 0;
  i24 = HEAP32[i17 + 24 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
  HEAP32[i18 >> 2] = i14;
  HEAP32[i1 >> 2] = i21;
  HEAPF32[i15 >> 2] = f3;
  HEAP32[i4 >> 2] = i22;
  HEAP32[i5 >> 2] = i23;
  HEAPF32[i16 >> 2] = f2;
  HEAP32[i6 >> 2] = i24;
  i24 = 2;
  return i24 | 0;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i17 + 4 >> 2] | 0;
 i5 = HEAP32[i17 + 12 >> 2] | 0;
 i6 = HEAP32[i17 + 16 >> 2] | 0;
 i7 = HEAP32[i17 + 24 >> 2] | 0;
 if (i11) {
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 4 >> 2] = i4;
  HEAPF32[i12 >> 2] = f8;
  HEAP32[i14 + 12 >> 2] = i5;
  HEAP32[i14 + 16 >> 2] = i6;
  HEAPF32[i13 >> 2] = f10;
  HEAP32[i14 + 24 >> 2] = i7;
  i24 = 1;
  return i24 | 0;
 };
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i18 >> 2] = i1;
 HEAP32[i18 + 4 >> 2] = i4;
 HEAPF32[i15 >> 2] = f8;
 HEAP32[i18 + 12 >> 2] = i5;
 HEAP32[i18 + 16 >> 2] = i6;
 HEAPF32[i16 >> 2] = f10;
 HEAP32[i18 + 24 >> 2] = i7;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f8 + f10) * Math_fround(.5)))) {
  i24 = 1;
  return i24 | 0;
 };
 HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i4;
 HEAPF32[i12 >> 2] = f8;
 HEAP32[i14 + 12 >> 2] = i5;
 HEAP32[i14 + 16 >> 2] = i6;
 HEAPF32[i13 >> 2] = f10;
 HEAP32[i14 + 24 >> 2] = i7;
 i24 = 2;
 return i24 | 0;
}

function __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i14, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i15 = i18 + 4 | 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i18 + 16 | 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(Math_fround(f2 + f3) * Math_fround(.5));
 i7 = i17 + 4 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i17 + 16 | 0;
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 i6 = f19 < Math_fround(Math_fround(f8 + f10) * Math_fround(.5));
 i12 = i14 + 4 | 0;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 16 | 0;
 i11 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < f19;
 if (!i6) {
  if (!i11) {
   i18 = 0;
   return i18 | 0;
  }
  i24 = HEAP32[i18 >> 2] | 0;
  i1 = i18 + 8 | 0;
  i23 = HEAP32[i1 >> 2] | 0;
  i4 = i18 + 12 | 0;
  i22 = HEAP32[i4 >> 2] | 0;
  i5 = i18 + 20 | 0;
  i21 = HEAP32[i5 >> 2] | 0;
  i6 = i18 + 24 | 0;
  i11 = HEAP32[i6 >> 2] | 0;
  HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i14 >> 2] = i24;
  HEAPF32[i12 >> 2] = f2;
  HEAP32[i14 + 8 >> 2] = i23;
  HEAP32[i14 + 12 >> 2] = i22;
  HEAPF32[i13 >> 2] = f3;
  HEAP32[i14 + 20 >> 2] = i21;
  HEAP32[i14 + 24 >> 2] = i11;
  f20 = Math_fround(HEAPF32[i15 >> 2]);
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i16 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i9 >> 2]);
  if (!(f20 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i24 = 1;
   return i24 | 0;
  }
  i14 = HEAP32[i17 >> 2] | 0;
  i21 = HEAP32[i17 + 8 >> 2] | 0;
  i22 = HEAP32[i17 + 12 >> 2] | 0;
  i23 = HEAP32[i17 + 20 >> 2] | 0;
  i24 = HEAP32[i17 + 24 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
  HEAP32[i18 >> 2] = i14;
  HEAPF32[i15 >> 2] = f3;
  HEAP32[i1 >> 2] = i21;
  HEAP32[i4 >> 2] = i22;
  HEAPF32[i16 >> 2] = f2;
  HEAP32[i5 >> 2] = i23;
  HEAP32[i6 >> 2] = i24;
  i24 = 2;
  return i24 | 0;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i17 + 8 >> 2] | 0;
 i5 = HEAP32[i17 + 12 >> 2] | 0;
 i6 = HEAP32[i17 + 20 >> 2] | 0;
 i7 = HEAP32[i17 + 24 >> 2] | 0;
 if (i11) {
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAP32[i14 >> 2] = i1;
  HEAPF32[i12 >> 2] = f8;
  HEAP32[i14 + 8 >> 2] = i4;
  HEAP32[i14 + 12 >> 2] = i5;
  HEAPF32[i13 >> 2] = f10;
  HEAP32[i14 + 20 >> 2] = i6;
  HEAP32[i14 + 24 >> 2] = i7;
  i24 = 1;
  return i24 | 0;
 };
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i18 >> 2] = i1;
 HEAPF32[i15 >> 2] = f8;
 HEAP32[i18 + 8 >> 2] = i4;
 HEAP32[i18 + 12 >> 2] = i5;
 HEAPF32[i16 >> 2] = f10;
 HEAP32[i18 + 20 >> 2] = i6;
 HEAP32[i18 + 24 >> 2] = i7;
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f8 + f10) * Math_fround(.5)))) {
  i24 = 1;
  return i24 | 0;
 };
 HEAP32[i18 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i14 >> 2] = i1;
 HEAPF32[i12 >> 2] = f8;
 HEAP32[i14 + 8 >> 2] = i4;
 HEAP32[i14 + 12 >> 2] = i5;
 HEAPF32[i13 >> 2] = f10;
 HEAP32[i14 + 20 >> 2] = i6;
 HEAP32[i14 + 24 >> 2] = i7;
 i24 = 2;
 return i24 | 0;
}

function __ZN4Mesh20GetCachedBonesBoundsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21;
 i17 = i19 + 32 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i14 = HEAP32[i2 + 156 >> 2] | 0;
 i20 = i19 + 164 | 0;
 i16 = i19 + 176 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 if ((i14 | 0) == (i15 | 0)) {
  STACKTOP = i21;
  return i20 | 0;
 }
 i12 = i19 + 188 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 L4 : do switch (i1 | 0) {
 case -2:
  {
   i13 = 13;
   break;
  }
 case -1:
  {
   HEAP32[i12 >> 2] = -2;
   i11 = HEAP32[i2 + 176 >> 2] | 0;
   L7 : do if (!i11) i1 = 0; else {
    i7 = HEAP32[i2 + 164 >> 2] | 0;
    i6 = 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i7 + (i6 << 5) + 16 >> 2] | 0;
     if ((i2 | 0) < 0) break;
     i3 = HEAP32[i7 + (i6 << 5) + 20 >> 2] | 0;
     if ((i3 | 0) < 0) break;
     i4 = HEAP32[i7 + (i6 << 5) + 24 >> 2] | 0;
     if ((i4 | 0) < 0) break;
     i5 = HEAP32[i7 + (i6 << 5) + 28 >> 2] | 0;
     if ((i5 | 0) < 0) break;
     i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
     i1 = (i1 | 0) < (i3 | 0) ? i3 : i1;
     i1 = (i1 | 0) < (i4 | 0) ? i4 : i1;
     i1 = (i1 | 0) < (i5 | 0) ? i5 : i1;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= i11 >>> 0) break L7;
    }
    if (!i19) {
     i1 = 0;
     break L4;
    } else {
     i13 = 13;
     break L4;
    }
   } while (0);
   HEAP32[i12 >> 2] = i1;
   if ((i1 | 0) < (i14 | 0)) i13 = 17; else i13 = 13;
   break;
  }
 default:
  if ((i1 | 0) < (i14 | 0)) i13 = 17; else i13 = 13;
 } while (0);
 if ((i13 | 0) == 13) i1 = HEAP32[i19 + 4 >> 2] | 0; else if ((i13 | 0) == 17) {
  i4 = HEAP32[gb + 62500 >> 2] | 0;
  i5 = HEAP32[gb + 62500 + 4 >> 2] | 0;
  i6 = HEAP32[gb + 62500 + 8 >> 2] | 0;
  f8 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f9 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f10 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  HEAP32[i16 >> 2] = i14;
  i1 = i19 + 180 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i14 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i1 >> 2] = i14;
   HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i14 * 24 | 0, 4, i19 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14 * 24 | 0, 4, i19 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i20 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i1 >> 2] = i14;
   HEAP32[i20 >> 2] = i13;
   break;
  } while (0);
  if (i14 >>> 0 > i15 >>> 0) {
   i3 = (HEAP32[i20 >> 2] | 0) + (i15 * 24 | 0) | 0;
   i2 = i14 - i15 | 0;
   if (i2 | 0) {
    i1 = 0;
    do {
     HEAP32[i3 + (i1 * 24 | 0) >> 2] = i4;
     HEAP32[i3 + (i1 * 24 | 0) + 4 >> 2] = i5;
     HEAP32[i3 + (i1 * 24 | 0) + 8 >> 2] = i6;
     HEAPF32[i3 + (i1 * 24 | 0) + 12 >> 2] = f8;
     HEAPF32[i3 + (i1 * 24 | 0) + 16 >> 2] = f9;
     HEAPF32[i3 + (i1 * 24 | 0) + 20 >> 2] = f10;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = (HEAP32[i1 + 156 >> 2] | 0) == 0 ? 0 : HEAP32[i1 + 144 >> 2] | 0;
  i3 = i1 + 8 | 0;
  i17 = HEAP16[i1 + 10 >> 1] | 0;
  do if ((i17 & 65535) < 768 | (i17 & 255) != 0) {
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
  } else {
   i4 = HEAP32[i1 + 92 >> 2] | 0;
   if (i4 | 0) if (HEAP8[i1 + 11 >> 0] | 0) {
    i17 = HEAPU8[i3 + 32 + ((HEAPU8[i3 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i16 = HEAP16[i3 >> 1] | 0;
    HEAP32[i18 >> 2] = i4 + (((i16 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i16 & 255) * 12 | 0) + 4 >> 2] | 0));
    HEAP32[i18 + 4 >> 2] = i17;
    break;
   }
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 1;
  } while (0);
  __ZL23ComputeBoneBindPoseAABBPK10Matrix4x4fj14StrideIteratorI8Vector3fEPK13BoneInfluencejRK13dynamic_arrayI16BlendShapeVertexLj4EEP10MinMaxAABB(i2, i18, HEAP32[i1 + 164 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0, i19 + 72 | 0, HEAP32[i20 >> 2] | 0);
  STACKTOP = i21;
  return i20 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 428298 | 0, 0, gb + 425656 | 0, 1957, 1, i1, 0, 0);
 i1 = i19 + 180 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i19 + 168 | 0);
  HEAP32[i20 >> 2] = 0;
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i21;
 return i20 | 0;
}

function __Z23LODGroup_CUSTOM_SetLODsP12Il2CppObjectP11Il2CppArray(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17;
 i16 = i17 + 4 | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i12) | 0;
 if ((i1 | 0) > 8) {
  HEAP32[i2 >> 2] = 8;
  __Z6FormatPKcz(i16, gb + 539686 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i16 + 11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16, 0, gb + 539764 | 0, 206, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  i1 = 8;
 }
 HEAP32[i16 >> 2] = 0;
 i15 = i16 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 L4 : do if (!i1) i13 = 19; else {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj(i16, i1);
  if ((i1 | 0) > 0) {
   i11 = 0;
   while (1) {
    i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i12, i11, 12) | 0;
    i10 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    HEAP32[i3 + (i11 * 28 | 0) >> 2] = i10;
    f5 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i10 = f5 < Math_fround(0.0);
    i9 = f5 > Math_fround(1.0);
    f5 = i9 ? Math_fround(1.0) : f5;
    f5 = i10 ? Math_fround(0.0) : f5;
    HEAPF32[i3 + (i11 * 28 | 0) >> 2] = f5;
    if ((i11 | 0) > 0) if (f5 >= Math_fround(HEAPF32[i3 + ((i11 + -1 | 0) * 28 | 0) >> 2])) break;
    f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
    i9 = f5 < Math_fround(0.0);
    i10 = f5 > Math_fround(1.0);
    f5 = i10 ? Math_fround(1.0) : f5;
    HEAPF32[i3 + (i11 * 28 | 0) + 4 >> 2] = i9 ? Math_fround(0.0) : f5;
    i9 = i2 + 8 | 0;
    i10 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i9 >> 2] | 0) | 0;
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = i2 + (i11 * 28 | 0) + 8 | 0;
    i4 = i2 + (i11 * 28 | 0) + 20 | 0;
    i6 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i10;
    i7 = i2 + (i11 * 28 | 0) + 24 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    do if ((i8 & 2147483647) >>> 0 < i10 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i10;
     HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10 << 2, 4, i2 + (i11 * 28 | 0) + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 << 2, 4, i2 + (i11 * 28 | 0) + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
     HEAP32[i7 >> 2] = i10;
     HEAP32[i3 >> 2] = i8;
     break;
    } while (0);
    if (i10 >>> 0 > i6 >>> 0) _memset((HEAP32[i3 >> 2] | 0) + (i6 << 2) | 0, 0, i10 - i6 << 2 | 0) | 0;
    if ((i10 | 0) > 0) {
     i3 = 0;
     do {
      i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(HEAP32[i9 >> 2] | 0, i3) | 0;
      i4 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i11 * 28 | 0) + 8 >> 2] | 0;
      i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
      if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
      HEAP32[i4 + (i3 << 2) >> 2] = i2;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i10 | 0));
    }
    i11 = i11 + 1 | 0;
    if ((i11 | 0) >= (i1 | 0)) {
     i13 = 19;
     break L4;
    }
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 539858 | 0, 0, gb + 539764 | 0, 228, 1, 0, 0, 0);
  } else i13 = 19;
 } while (0);
 do if ((i13 | 0) == 19) {
  if (!i14) {
   i13 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i14) | 0;
  if (!i1) {
   i13 = i14;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
  }
  __ZN8LODGroup11SetLODArrayERKNSt3__26vectorINS_3LODENS0_9allocatorIS2_EEEE(i1, i16);
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i14) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i14); else {
   __Z25UpdateLODGroupBoundingBoxR8LODGroup(i1);
   break;
  }
 } while (0);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -28 | 0;
   HEAP32[i15 >> 2] = i3;
   i4 = i2 + -20 | 0;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i15 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i16 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i27, i28, i20, i8, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, f30 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29;
 i21 = i29 + 12 | 0;
 i22 = __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i27, i28, i20, i1) | 0;
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 i1 = i20 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 > Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22;
  STACKTOP = i29;
  return i28 | 0;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 i15 = i20 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i16 = i20 + 8 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i17 = i20 + 12 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i18 = i20 + 16 | 0;
 i6 = HEAP32[i18 >> 2] | 0;
 i19 = i20 + 20 | 0;
 i7 = HEAP32[i19 >> 2] | 0;
 i14 = i20 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i23 = i20;
 i24 = i8;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i5;
 HEAP32[i8 + 16 >> 2] = i6;
 HEAP32[i8 + 20 >> 2] = i7;
 i25 = i8 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 i1 = i28 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 > Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22 + 1 | 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i2 = HEAP32[i28 >> 2] | 0;
 i9 = i28 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i28 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i28 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i28 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i28 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i28 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i23 = i28;
 i24 = i20;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i20 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i16 >> 2] = i4;
 HEAP32[i17 >> 2] = i5;
 HEAP32[i18 >> 2] = i6;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i27 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 > Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22 + 2 | 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i27 + 4 >> 2] | 0;
 i3 = HEAP32[i27 + 8 >> 2] | 0;
 i4 = HEAP32[i27 + 12 >> 2] | 0;
 i5 = HEAP32[i27 + 16 >> 2] | 0;
 i6 = HEAP32[i27 + 20 >> 2] | 0;
 i23 = i27 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 i23 = i27;
 i24 = i28;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i28 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 i28 = i22 + 3 | 0;
 STACKTOP = i29;
 return i28 | 0;
}

function __Z27ConvertSubMeshesToTrianglesRNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEER13dynamic_arrayItLj2EE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = i13 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i15 >> 2] | 0) == (i1 | 0)) return;
 i16 = i14 + 12 | 0;
 i17 = i14 + 16 | 0;
 i18 = i14 + 4 | 0;
 i12 = 0;
 do {
  i11 = i1 + (i12 * 52 | 0) | 0;
  i6 = (HEAP32[i1 + (i12 * 52 | 0) + 32 >> 2] | 0) >>> 1;
  switch (HEAP32[i1 + (i12 * 52 | 0) + 40 >> 2] | 0) {
  case 2:
   {
    i2 = HEAP32[i1 + (i12 * 52 | 0) + 36 >> 2] | 0;
    if (i2 >>> 0 >= 4) {
     i7 = i2 >>> 2;
     i8 = HEAP32[i16 >> 2] | 0;
     i9 = i7 * 6 | 0;
     i2 = i8 + i9 | 0;
     HEAP32[i16 >> 2] = i2;
     i3 = HEAP32[i17 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 1, 2, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] << 1 | 0) | 0;
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = i10;
      break;
     } while (0);
     i5 = HEAP32[i14 >> 2] | 0;
     i2 = i6;
     i3 = i8;
     i4 = 0;
     while (1) {
      i6 = i5 + (i2 << 1) | 0;
      HEAP16[i5 + (i3 << 1) >> 1] = HEAP16[i6 >> 1] | 0;
      HEAP16[i5 + (i3 + 1 << 1) >> 1] = HEAP16[i5 + (i2 + 1 << 1) >> 1] | 0;
      i10 = i5 + (i2 + 2 << 1) | 0;
      HEAP16[i5 + (i3 + 2 << 1) >> 1] = HEAP16[i10 >> 1] | 0;
      HEAP16[i5 + (i3 + 3 << 1) >> 1] = HEAP16[i6 >> 1] | 0;
      HEAP16[i5 + (i3 + 4 << 1) >> 1] = HEAP16[i10 >> 1] | 0;
      HEAP16[i5 + (i3 + 5 << 1) >> 1] = HEAP16[i5 + (i2 + 3 << 1) >> 1] | 0;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i7 | 0)) break; else {
       i2 = i2 + 4 | 0;
       i3 = i3 + 6 | 0;
      }
     }
     HEAP32[i11 >> 2] = i8 << 1;
     HEAP32[i1 + (i12 * 52 | 0) + 4 >> 2] = i9;
    }
    break;
   }
  case 1:
   {
    i4 = i1 + (i12 * 52 | 0) + 36 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (i2 >>> 0 >= 3) {
     i10 = HEAP32[i16 >> 2] | 0;
     i2 = (i2 * 3 | 0) + -6 + i10 | 0;
     HEAP32[i16 >> 2] = i2;
     i3 = HEAP32[i17 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 1, 2, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] << 1 | 0) | 0;
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = i9;
      break;
     } while (0);
     i2 = HEAP32[i4 >> 2] | 0;
     if ((i2 | 0) == 2) i2 = i10; else {
      i9 = HEAP32[i14 >> 2] | 0;
      i8 = i2 + -2 | 0;
      i7 = 0;
      i2 = i10;
      do {
       i3 = HEAP16[i9 + (i6 << 1) >> 1] | 0;
       i5 = i6;
       i6 = i6 + 1 | 0;
       i4 = HEAP16[i9 + (i6 << 1) >> 1] | 0;
       i5 = HEAP16[i9 + (i5 + 2 << 1) >> 1] | 0;
       if (!(i4 << 16 >> 16 == i5 << 16 >> 16 | (i3 << 16 >> 16 == i4 << 16 >> 16 ? 1 : i3 << 16 >> 16 == i5 << 16 >> 16))) {
        i19 = (i7 & 1 | 0) != 0;
        HEAP16[i9 + (i2 << 1) >> 1] = i19 ? i4 : i3;
        HEAP16[i9 + (i2 + 1 << 1) >> 1] = i19 ? i3 : i4;
        HEAP16[i9 + (i2 + 2 << 1) >> 1] = i5;
        i2 = i2 + 3 | 0;
       }
       i7 = i7 + 1 | 0;
      } while (i7 >>> 0 < i8 >>> 0);
     }
     HEAP32[i16 >> 2] = i2;
     i3 = HEAP32[i17 >> 2] | 0;
     do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 1, 2, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i19 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] << 1 | 0) | 0;
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = i19;
      break;
     } while (0);
     HEAP32[i11 >> 2] = i10 << 1;
     HEAP32[i1 + (i12 * 52 | 0) + 4 >> 2] = i2 - i10;
    }
    break;
   }
  default:
   {}
  }
  i12 = i12 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while (i12 >>> 0 < (((HEAP32[i15 >> 2] | 0) - i1 | 0) / 52 | 0) >>> 0);
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_(i22, i5, i4) {
 i22 = i22 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i20 = (HEAP32[i5 + 88 >> 2] | 0) + -1 | 0;
 i21 = HEAP32[i4 >> 2] | 0;
 i21 = (i21 | 0) == 0 ? i4 + 4 | 0 : i21;
 i1 = HEAP8[i21 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i3 = i21;
  i2 = 5381;
  do {
   i3 = i3 + 1 | 0;
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i19 = HEAP32[i5 + 84 >> 2] | 0;
 i9 = HEAP32[i5 + 68 >> 2] | 0;
 i10 = i5 + 48 | 0;
 i11 = i5 + 52 | 0;
 i12 = i5 + 8 | 0;
 i14 = HEAP32[i4 + 20 >> 2] | 0;
 i15 = (i14 | 0) == 0;
 i16 = i5 + 4 | 0;
 i17 = i5 + 32 | 0;
 i18 = i5 + 12 | 0;
 i13 = i5 + 16 | 0;
 L5 : do if (!i9) {
  i1 = i2 & i20;
  i2 = HEAP32[i19 + (i1 * 36 | 0) + 20 >> 2] | 0;
  if (!i2) {
   i3 = -1;
   i2 = i1;
  } else {
   i8 = (HEAP8[i12 >> 0] | 0) == 0;
   i7 = 0;
   i3 = -1;
   while (1) {
    L10 : do if (i8) i23 = 13; else if (!(HEAP32[i16 >> 2] | 0)) i23 = 13; else if ((HEAP32[i17 >> 2] | 0) == (i2 | 0)) {
     i5 = HEAP32[i19 + (i1 * 36 | 0) >> 2] | 0;
     i6 = HEAP32[i18 >> 2] | 0;
     i4 = i2;
     i5 = (i5 | 0) == 0 ? i19 + (i1 * 36 | 0) + 4 | 0 : i5;
     i6 = (i6 | 0) == 0 ? i13 : i6;
     while (1) {
      if ((HEAP8[i6 >> 0] | 0) != (HEAP8[i5 >> 0] | 0)) {
       i23 = 13;
       break L10;
      }
      i4 = i4 + -1 | 0;
      if (!i4) break; else {
       i5 = i5 + 1 | 0;
       i6 = i6 + 1 | 0;
      }
     }
     i3 = (i3 | 0) == -1 ? i1 : i3;
    } else i23 = 13; while (0);
    L18 : do if ((i23 | 0) == 13) {
     i23 = 0;
     if ((i14 | 0) == (i2 | 0)) {
      i2 = HEAP32[i19 + (i1 * 36 | 0) >> 2] | 0;
      if (i15) {
       i23 = 39;
       break L5;
      }
      i5 = i14;
      i2 = (i2 | 0) == 0 ? i19 + (i1 * 36 | 0) + 4 | 0 : i2;
      i4 = i21;
      while (1) {
       if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L18;
       i5 = i5 + -1 | 0;
       if (!i5) {
        i23 = 39;
        break L5;
       } else {
        i2 = i2 + 1 | 0;
        i4 = i4 + 1 | 0;
       }
      }
     }
    } while (0);
    i7 = i7 + 1 | 0;
    i1 = i7 + i1 & i20;
    i2 = HEAP32[i19 + (i1 * 36 | 0) + 20 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    }
   }
  }
 } else {
  i8 = 0;
  i3 = -1;
  while (1) {
   i1 = i2 & i20;
   i7 = HEAP32[i19 + (i1 * 36 | 0) + 20 >> 2] | 0;
   L28 : do if ((i9 | 0) == (i7 | 0)) {
    i4 = HEAP32[i19 + (i1 * 36 | 0) >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i2 = i9;
    i4 = (i4 | 0) == 0 ? i19 + (i1 * 36 | 0) + 4 | 0 : i4;
    i5 = (i5 | 0) == 0 ? i11 : i5;
    while (1) {
     if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i4 >> 0] | 0)) break L28;
     i2 = i2 + -1 | 0;
     if (!i2) {
      i2 = i1;
      break L5;
     } else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 1 | 0;
     }
    }
   } while (0);
   L34 : do if (!(HEAP8[i12 >> 0] | 0)) i23 = 34; else if (!(HEAP32[i16 >> 2] | 0)) i23 = 34; else if ((HEAP32[i17 >> 2] | 0) == (i7 | 0)) {
    i2 = HEAP32[i19 + (i1 * 36 | 0) >> 2] | 0;
    i5 = HEAP32[i18 >> 2] | 0;
    if (i7 | 0) {
     i6 = i7;
     i4 = (i2 | 0) == 0 ? i19 + (i1 * 36 | 0) + 4 | 0 : i2;
     i2 = (i5 | 0) == 0 ? i13 : i5;
     while (1) {
      if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i4 >> 0] | 0)) {
       i23 = 34;
       break L34;
      }
      i6 = i6 + -1 | 0;
      if (!i6) break; else {
       i4 = i4 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    }
    i3 = (i3 | 0) == -1 ? i1 : i3;
   } else i23 = 34; while (0);
   L44 : do if ((i23 | 0) == 34) {
    i23 = 0;
    if ((i14 | 0) == (i7 | 0)) {
     i2 = HEAP32[i19 + (i1 * 36 | 0) >> 2] | 0;
     if (i15) {
      i23 = 39;
      break L5;
     }
     i5 = i14;
     i2 = (i2 | 0) == 0 ? i19 + (i1 * 36 | 0) + 4 | 0 : i2;
     i4 = i21;
     while (1) {
      if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L44;
      i5 = i5 + -1 | 0;
      if (!i5) {
       i23 = 39;
       break L5;
      } else {
       i2 = i2 + 1 | 0;
       i4 = i4 + 1 | 0;
      }
     }
    }
   } while (0);
   i2 = i8 + 1 | 0;
   i8 = i2;
   i2 = i2 + i1 | 0;
  }
 } while (0);
 if ((i23 | 0) == 39) {
  HEAP32[i22 >> 2] = i1;
  HEAP32[i22 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i22 >> 2] = -1;
 i1 = i22 + 4 | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i1 >> 2] = i2;
  return;
 } else {
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE14__assign_multiINS_21__tree_const_iteratorIjPNS_11__tree_nodeIjPvEEiEEEEvT_SD_(i12, i13, i11) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = i12 + 8 | 0;
 L1 : do if (HEAP32[i14 >> 2] | 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i10 = i12 + 4 | 0;
  HEAP32[i12 >> 2] = i10;
  HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? i9 : i1;
  if (i1 | 0) {
   i9 = i12 + 4 | 0;
   i8 = HEAP32[i13 >> 2] | 0;
   i3 = i8;
   while (1) {
    if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) break;
    i6 = HEAP32[i3 + 16 >> 2] | 0;
    HEAP32[i1 + 16 >> 2] = i6;
    i7 = i1 + 8 | 0;
    i3 = HEAP32[i7 >> 2] | 0;
    do if (!i3) i3 = 0; else {
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == (i1 | 0)) {
      HEAP32[i3 >> 2] = 0;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break;
      while (1) {
       i3 = HEAP32[i2 >> 2] | 0;
       if (i3 | 0) {
        i2 = i3;
        continue;
       }
       i3 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i3) break; else i2 = i3;
      }
      i3 = i2;
      break;
     } else {
      HEAP32[i3 + 4 >> 2] = 0;
      if (!i2) break;
      while (1) {
       i3 = HEAP32[i2 >> 2] | 0;
       if (i3 | 0) {
        i2 = i3;
        continue;
       }
       i3 = HEAP32[i2 + 4 >> 2] | 0;
       if (!i3) break; else i2 = i3;
      }
      i3 = i2;
      break;
     }
    } while (0);
    i2 = HEAP32[i10 >> 2] | 0;
    do if (!i2) {
     i5 = i10;
     i4 = i10;
    } else {
     while (1) if (i6 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) {
       i6 = 19;
       break;
      } else i2 = i4;
     } else {
      i4 = i2 + 4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      if (!i5) {
       i6 = 22;
       break;
      } else i2 = i5;
     }
     if ((i6 | 0) == 19) {
      i5 = i2;
      i4 = i2;
      break;
     } else if ((i6 | 0) == 22) {
      i5 = i2;
      break;
     }
    } while (0);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i7 >> 2] = i5;
    HEAP32[i4 >> 2] = i1;
    i2 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i12 >> 2] = i2;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
    i1 = HEAP32[i8 + 4 >> 2] | 0;
    if (!i1) {
     i1 = i8;
     while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     }
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
    HEAP32[i13 >> 2] = i2;
    if (!i3) break L1; else {
     i1 = i3;
     i3 = i2;
     i8 = i2;
    }
   }
   i2 = i1 + 8 | 0;
   if (HEAP32[i2 >> 2] | 0) do {
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = i1 + 8 | 0;
   } while ((HEAP32[i2 >> 2] | 0) != 0);
   __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i12, i1);
  }
 } while (0);
 i2 = HEAP32[i13 >> 2] | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) == (i7 | 0)) return;
 i8 = i12 + 4 | 0;
 i9 = i12 + 4 | 0;
 i1 = i2;
 i3 = i2;
 while (1) {
  i2 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i3 + 16 >> 2] | 0;
  do if (!i2) {
   i3 = i8;
   i4 = i8;
  } else {
   while (1) if (i5 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i6 = 36;
     break;
    } else i2 = i3;
   } else {
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i6 = 39;
     break;
    } else i2 = i3;
   }
   if ((i6 | 0) == 36) {
    i3 = i2;
    i4 = i2;
    break;
   } else if ((i6 | 0) == 39) {
    i3 = i2;
    break;
   }
  } while (0);
  i2 = __Znwj(20) | 0;
  HEAP32[i2 + 16 >> 2] = i5;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = i3;
  HEAP32[i4 >> 2] = i2;
  i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  if (i3) {
   HEAP32[i12 >> 2] = i3;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i2);
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  HEAP32[i13 >> 2] = i2;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 return;
}

function __ZN11UnityEngine15PlatformWrapper28GetCleanGraphicsFixedVersionEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 16 | 0;
 i18 = i19;
 i1 = __Z15GetGraphicsCapsv() | 0;
 i2 = i1 + 48 | 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i15 = i3 << 24 >> 24 < 0;
 i2 = i15 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i15 ? HEAP32[i1 + 52 >> 2] | 0 : i3 & 255;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
  i1 = HEAP32[i16 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i16 + 11 >> 0] = i3;
  if (!i3) i1 = i16; else {
   i1 = i16;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i15 = i3 + 16 & -16;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i16 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i16 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = __Z15GetGraphicsCapsv() | 0;
 i2 = i1 + 64 | 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i15 = i3 << 24 >> 24 < 0;
 i2 = i15 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i15 ? HEAP32[i1 + 68 >> 2] | 0 : i3 & 255;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i18 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  i4 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i18 + 11 >> 0] = i3;
  if (!i3) i1 = i18; else {
   i1 = i18;
   i4 = 12;
  }
 } else i4 = 10;
 if ((i4 | 0) == 10) {
  i15 = i3 + 16 & -16;
  HEAP32[i17 >> 2] = 66;
  HEAP32[i17 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i18 + 8 >> 2] = i15 | -2147483648;
  HEAP32[i18 + 4 >> 2] = i3;
  i4 = 12;
 }
 if ((i4 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i14 = i16 + 11 | 0;
 i12 = HEAP8[i14 >> 0] | 0;
 i13 = i12 << 24 >> 24 < 0;
 if (i13) {
  i2 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 } else {
  i2 = i12 & 255;
  i1 = i16;
 }
 i15 = i18 + 11 | 0;
 i11 = HEAP8[i15 >> 0] | 0;
 i10 = i11 << 24 >> 24 < 0;
 i6 = i10 ? HEAP32[i18 >> 2] | 0 : i18;
 i11 = i10 ? HEAP32[i18 + 4 >> 2] | 0 : i11 & 255;
 L23 : do if ((i11 + -1 | 0) >>> 0 < i2 >>> 0) {
  i9 = i1 + i2 | 0;
  i7 = i6 + i11 | 0;
  i8 = i9;
  i10 = i1;
  L25 : do if ((i2 | 0) < (i11 | 0)) i1 = i8; else {
   i4 = i9 + (1 - i11) | 0;
   if ((i4 | 0) == (i1 | 0)) i1 = i8; else {
    i5 = HEAP8[i6 >> 0] | 0;
    L28 : while (1) {
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) == i5 << 24 >> 24) {
       i2 = i6;
       i3 = i1;
       break;
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == (i4 | 0)) {
       i1 = i8;
       break L25;
      }
     }
     do {
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i7 | 0)) break L28;
      i3 = i3 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i8;
      break L25;
     }
    }
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i10 | 0;
  switch (i1 | 0) {
  case 0:
  case 1:
  case -1:
   break L23;
  default:
   {}
  }
  i6 = i1 + -1 | 0;
  i1 = i11 + 1 | 0;
  if (i13) i4 = HEAP32[i16 + 4 >> 2] | 0; else i4 = i12 & 255;
  if (i4 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i16);
  if (i1 | 0) {
   i2 = HEAP8[i14 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i5 = HEAP32[i16 >> 2] | 0; else i5 = i16;
   i13 = i4 - i6 | 0;
   i3 = i13 >>> 0 < i1 >>> 0 ? i13 : i1;
   i1 = i13 - i3 | 0;
   if (i1) {
    i2 = i5 + i6 | 0;
    _memmove(i2 | 0, i2 + i3 | 0, i1 | 0) | 0;
    i2 = HEAP8[i14 >> 0] | 0;
   }
   i1 = i4 - i3 | 0;
   if (i2 << 24 >> 24 < 0) HEAP32[i16 + 4 >> 2] = i1; else HEAP8[i14 >> 0] = i1;
   HEAP8[i5 + i1 >> 0] = 0;
  }
 } while (0);
 if ((HEAP8[i15 >> 0] | 0) >= 0) {
  STACKTOP = i19;
  return;
 }
 i16 = HEAP32[i18 >> 2] | 0;
 i18 = HEAP32[i18 + 12 >> 2] | 0;
 HEAP32[i17 >> 2] = 66;
 HEAP32[i17 + 4 >> 2] = i18;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i17);
 STACKTOP = i19;
 return;
}

function __Z25InverseTransformDirection23TransformAccessReadOnlyRKN4math7_float3Eb(i1, i2, i3, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 24 | 0;
 i4 = i11 + 8 | 0;
 i5 = i11;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 if (!(HEAP32[i2 + 4 >> 2] | 0)) {
  i5 = i2;
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i1 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i1 + 8 | 0;
  i3 = i4;
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
 } else {
  i12 = i2;
  i13 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i13 + 12 >> 2] | 0) + (i12 << 2) >> 2] | 0;
  i2 = i5;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __Z25InverseTransformDirection23TransformAccessReadOnlyRKN4math7_float3Eb(i4, i6, i1, 1);
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = i5;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = i4;
  f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = i13;
  i5 = i12;
 }
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i6 + (i5 * 40 | 0) + 24 >> 2]);
 f18 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + (i5 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + (i5 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i6 + (i5 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f18 * Math_fround(-2.0));
 f19 = Math_fround(f18 * Math_fround(2.0));
 f23 = Math_fround(f16 * f25);
 f17 = Math_fround(f24 * Math_fround(2.0));
 f22 = Math_fround(f24 * Math_fround(-2.0));
 f26 = Math_fround(f16 * f22);
 f20 = Math_fround(f21 * Math_fround(-2.0));
 f14 = Math_fround(f21 * Math_fround(2.0));
 f16 = Math_fround(f16 * f20);
 f15 = Math_fround(Math_fround(f7 + Math_fround(f7 * Math_fround(Math_fround(f18 * f25) - Math_fround(f24 * f17)))) + Math_fround(Math_fround(f9 * Math_fround(Math_fround(f14 * f24) - f23)) + Math_fround(f8 * Math_fround(f26 - Math_fround(f18 * f20)))));
 f14 = Math_fround(Math_fround(f8 + Math_fround(f7 * Math_fround(Math_fround(f21 * f19) - f26))) + Math_fround(Math_fround(f9 * Math_fround(f16 - Math_fround(f24 * f25))) + Math_fround(f8 * Math_fround(Math_fround(f24 * f22) - Math_fround(f21 * f14)))));
 f9 = Math_fround(Math_fround(f9 + Math_fround(f7 * Math_fround(f23 - Math_fround(f21 * f22)))) + Math_fround(Math_fround(f9 * Math_fround(Math_fround(f21 * f20) - Math_fround(f18 * f19))) + Math_fround(f8 * Math_fround(Math_fround(f18 * f17) - f16))));
 f8 = Math_fround(HEAPF32[i6 + (i5 * 40 | 0) + 28 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + (i5 * 40 | 0) + 32 >> 2]);
 f16 = Math_fround(HEAPF32[i6 + (i5 * 40 | 0) + 36 >> 2]);
 f8 = Math_fround((f8 > Math_fround(0.0) & 1) - (f8 < Math_fround(0.0) & 1) | 0);
 f7 = Math_fround((f7 > Math_fround(0.0) & 1) - (f7 < Math_fround(0.0) & 1) | 0);
 f16 = Math_fround((f16 > Math_fround(0.0) & 1) - (f16 < Math_fround(0.0) & 1) | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i6;
 i12 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i12;
 i13 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i13;
 f16 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i1 >> 2] = i10 ? f16 : f15;
 HEAPF32[i2 >> 2] = i10 ? f7 : f14;
 HEAPF32[i3 >> 2] = i10 ? f8 : f9;
 STACKTOP = i11;
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE20EvaluateWithoutCacheEfRS0_(i3, f2, i16) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i16 = i16 | 0;
 var i1 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18 + 4 | 0;
 i4 = i18;
 if ((HEAP32[i3 + 164 >> 2] | 0) == 1) {
  i17 = (HEAP32[i3 + 152 >> 2] | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  STACKTOP = i18;
  return;
 }
 f5 = Math_fround(__ZNK17AnimationCurveTplI11QuaternionfE8WrapTimeEf(i3, f2));
 __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i3, i3, f5, i1, i4);
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i3 + 152 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i14 + (i3 * 52 | 0) >> 2]);
 f2 = Math_fround(HEAPF32[i14 + (i15 * 52 | 0) >> 2]);
 f13 = Math_fround(f13 - f2);
 if (f13 != Math_fround(0.0)) {
  f6 = Math_fround(Math_fround(f5 - f2) / f13);
  i1 = i14 + (i15 * 52 | 0) + 36 | 0;
  f8 = Math_fround(f13 * Math_fround(HEAPF32[i1 >> 2]));
  f10 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 40 >> 2]));
  f11 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 44 >> 2]));
  f5 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 48 >> 2]));
  f7 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 20 >> 2]));
  f9 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 24 >> 2]));
  f12 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 28 >> 2]));
  f2 = Math_fround(f13 * Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 32 >> 2]));
 } else {
  f6 = Math_fround(0.0);
  i1 = i14 + (i15 * 52 | 0) + 36 | 0;
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f12 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 }
 f20 = Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 12 >> 2]);
 f21 = Math_fround(f6 * f6);
 f29 = Math_fround(f6 * f21);
 f23 = Math_fround(f29 * Math_fround(2.0));
 f28 = Math_fround(f21 * Math_fround(3.0));
 f19 = Math_fround(Math_fround(f23 - f28) + Math_fround(1.0));
 f6 = Math_fround(f6 + Math_fround(f29 - Math_fround(f21 * Math_fround(2.0))));
 f21 = Math_fround(f29 - f21);
 f23 = Math_fround(f28 - f23);
 f10 = Math_fround(Math_fround(f23 * f27) + Math_fround(Math_fround(f9 * f21) + Math_fround(Math_fround(f10 * f6) + Math_fround(f26 * f19))));
 f12 = Math_fround(Math_fround(Math_fround(f12 * f21) + Math_fround(Math_fround(f11 * f6) + Math_fround(f25 * f19))) + Math_fround(f23 * f24));
 f13 = Math_fround(Math_fround(Math_fround(f2 * f21) + Math_fround(Math_fround(f5 * f6) + Math_fround(f13 * f19))) + Math_fround(f23 * Math_fround(HEAPF32[i14 + (i3 * 52 | 0) + 16 >> 2])));
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f7 * f21) + Math_fround(Math_fround(f8 * f6) + Math_fround(f20 * f19))));
 HEAPF32[i16 + 4 >> 2] = f10;
 HEAPF32[i16 + 8 >> 2] = f12;
 HEAPF32[i16 + 12 >> 2] = f13;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) i17 = 14; else {
  i1 = i14 + (i3 * 52 | 0) + 20 | 0;
  if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 36 + 4 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 36 + 8 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i14 + (i15 * 52 | 0) + 36 + 12 >> 2]) == Math_fround(inf)) i17 = 14; else if (Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf)) i17 = 14;
 }
 if ((i17 | 0) == 14) {
  i17 = i14 + (i15 * 52 | 0) + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 }
 STACKTOP = i18;
 return;
}

function __ZN11TimeManager23VirtualRedirectTransferER14SafeBinaryRead(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i1 = i11;
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, HEAP32[gb + 67408 >> 2] | 0, gb + 441051 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i6, i9);
   i4 = i6 + 48 | 0;
   i5 = HEAP32[gb + 37012 >> 2] | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 441063 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 8; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 200 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 441078 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 196 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 441103 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i3 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i8 = 30; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
   i4 = i6 + 204 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 441115 | 0, i5, i7, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i9 + 16 | 0;
     i7 = HEAP32[i9 + 20 >> 2] | 0;
     i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i7 >>> 0) i8 = 41; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i9);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i11;
 return;
}

function __ZN7Texture9ReloadAllEbbb(i1, i7, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 8 | 0;
 i11 = i16;
 i14 = i16 + 36 | 0;
 i15 = i16 + 16 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i15 >> 2] = 0;
 i8 = i15 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i15 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
 i3 = i10;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 26572 | 0, i15, 1);
 if (HEAP32[i8 >> 2] | 0) if (i1) {
  i5 = 0;
  do {
   i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   if (!i1) i4 = 0; else i4 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i17 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 12;
    }
   }
   if ((i9 | 0) == 11) i9 = 12;
   if ((i9 | 0) == 12) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   }
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i6 | 0);
   if (i7) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 } else {
  i5 = 0;
  do {
   i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   if (!i1) i4 = 0; else i4 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 31; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i17 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 31; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 33;
    }
   }
   if ((i9 | 0) == 31) i9 = 33;
   if ((i9 | 0) == 33) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   }
   if (i7) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i14 >> 2] = 0;
 i3 = i14 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i14 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i17 = i5;
 HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i17 + 4 >> 2] = i11;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31832 | 0, i14, 1);
 i3 = HEAP32[i3 >> 2] | 0;
 if (i3 | 0) {
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = 0;
  do {
   HEAP8[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 132 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i5);
  HEAP32[i14 >> 2] = 0;
 }
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i13);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN5physx5cloth7SwClothD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = (HEAP32[i4 + 4 >> 2] | 0) + 8 | 0;
 HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + -1 << 16 >> 16;
 i2 = i4 + 500 | 0;
 i3 = HEAP32[i4 + 508 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 488 | 0;
 i3 = HEAP32[i4 + 496 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 464 | 0;
 i3 = HEAP32[i4 + 472 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 452 | 0;
 i3 = HEAP32[i4 + 460 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 428 | 0;
 i3 = HEAP32[i4 + 436 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 416 | 0;
 i3 = HEAP32[i4 + 424 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 404 | 0;
 i3 = HEAP32[i4 + 412 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 392 | 0;
 i3 = HEAP32[i4 + 400 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 380 | 0;
 i3 = HEAP32[i4 + 388 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 368 | 0;
 i3 = HEAP32[i4 + 376 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 356 | 0;
 i3 = HEAP32[i4 + 364 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 344 | 0;
 i3 = HEAP32[i4 + 352 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 332 | 0;
 i3 = HEAP32[i4 + 340 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i3 = i4 + 308 | 0;
 i1 = i4 + 320 | 0;
 i2 = HEAP32[i4 + 328 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i2 = HEAP32[i4 + 316 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 }
 i3 = i4 + 272 | 0;
 i1 = i4 + 284 | 0;
 i2 = HEAP32[i4 + 292 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i2 = HEAP32[i4 + 280 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 }
 i1 = i4 + 252 | 0;
 i3 = HEAP32[i4 + 260 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 232 | 0;
 i3 = HEAP32[i4 + 240 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 20 | 0;
 i3 = HEAP32[i4 + 28 >> 2] | 0;
 do if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 } while (0);
 i2 = i4 + 8 | 0;
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 if (!((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 return;
}

function _open_face_PS_from_sfnt_stream(i15, i19, i3, i1, i2, i16) {
 i15 = i15 | 0;
 i19 = i19 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 4 | 0;
 i17 = i18;
 i13 = HEAP32[i15 >> 2] | 0;
 i12 = (i3 | 0) > 0 ? i3 & 65535 : i3;
 i14 = _UNITY_FT_Stream_Pos(i19) | 0;
 i2 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 L1 : do if (!i1) if ((i2 | 0) == 1954115633) {
  i2 = _UNITY_FT_Stream_ReadUShort(i19, i10) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) {
   i1 = _UNITY_FT_Stream_Skip(i19, 6) | 0;
   HEAP32[i10 >> 2] = i1;
   if (!i1) {
    i8 = i2 & 65535;
    if (!(i2 << 16 >> 16)) {
     i1 = 142;
     i11 = 24;
    } else {
     i9 = (i12 | 0) < 0;
     L7 : do if (i9) {
      i3 = 0;
      L8 : while (1) {
       i4 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i1 = _UNITY_FT_Stream_Skip(i19, 4) | 0;
       HEAP32[i10 >> 2] = i1;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i5 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i2 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       if ((i4 | 0) < 1415139377) switch (i4 | 0) {
       case 1128875040:
        {
         i11 = 23;
         break L8;
        }
       default:
        {}
       } else switch (i4 | 0) {
       case 1415139377:
        {
         i11 = 22;
         break L8;
        }
       default:
        {}
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) >= (i8 | 0)) {
        i1 = 142;
        i11 = 24;
        break L1;
       }
      }
      if ((i11 | 0) == 22) {
       i4 = 0;
       i3 = i2 + -24 | 0;
       i1 = i5 + 24 | 0;
       break;
      } else if ((i11 | 0) == 23) {
       i4 = 1;
       i3 = i2 + -22 | 0;
       i1 = i5 + 22 | 0;
       break;
      }
     } else {
      i2 = -1;
      i7 = 0;
      i4 = 0;
      while (1) {
       i5 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i1 = _UNITY_FT_Stream_Skip(i19, 4) | 0;
       HEAP32[i10 >> 2] = i1;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i6 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       i3 = _UNITY_FT_Stream_ReadULong(i19, i10) | 0;
       i1 = HEAP32[i10 >> 2] | 0;
       if (i1 | 0) {
        i11 = 24;
        break L1;
       }
       L27 : do if ((i5 | 0) < 1415139377) {
        switch (i5 | 0) {
        case 1128875040:
         break;
        default:
         {
          i1 = i6;
          break L27;
         }
        }
        i2 = i2 + 1 | 0;
        i4 = 1;
        i3 = i3 + -22 | 0;
        i1 = i6 + 22 | 0;
       } else {
        switch (i5 | 0) {
        case 1415139377:
         break;
        default:
         {
          i1 = i6;
          break L27;
         }
        }
        i2 = i2 + 1 | 0;
        i4 = 0;
        i3 = i3 + -24 | 0;
        i1 = i6 + 24 | 0;
       } while (0);
       i7 = i7 + 1 | 0;
       if ((i2 | 0) == (i12 | 0)) break L7;
       if ((i7 | 0) >= (i8 | 0)) {
        i1 = 142;
        i11 = 24;
        break L1;
       }
      }
     } while (0);
     HEAP32[i17 >> 2] = 0;
     if (_UNITY_FT_Stream_Seek(i19, i1 + i14 | 0) | 0) {
      i19 = 0;
      STACKTOP = i18;
      return i19 | 0;
     }
     i2 = _UNITY_ft_mem_alloc(i13, i3, i17) | 0;
     i1 = HEAP32[i17 >> 2] | 0;
     if (!i1) {
      i10 = _UNITY_FT_Stream_Read(i19, i2, i3) | 0;
      HEAP32[i17 >> 2] = i10;
      if (!i10) {
       i1 = _open_face_from_buffer(i15, i2, i3, i9 ? i12 : 0, i4 << 24 >> 24 ? gb + 945621 | 0 : gb + 945610 | 0, i16) | 0;
       HEAP32[i17 >> 2] = i1;
       break;
      } else {
       _UNITY_ft_mem_free(i13, i2);
       i1 = HEAP32[i17 >> 2] | 0;
       break;
      }
     }
    }
   } else i11 = 24;
  } else i11 = 24;
 } else {
  i1 = 2;
  i11 = 24;
 } else i11 = 24; while (0);
 if ((i11 | 0) == 24) HEAP32[i17 >> 2] = i1;
 if ((i1 & 255 | 0) != 2) {
  i19 = i1;
  STACKTOP = i18;
  return i19 | 0;
 }
 i19 = _UNITY_FT_Stream_Seek(i19, i14) | 0;
 i19 = (i19 | 0) == 0 ? HEAP32[i17 >> 2] | 0 : i19;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN5physx10PxsContext20updateContactManagerEfPNS_10PxBaseTaskE(i21, f20, i2) {
 i21 = i21 | 0;
 f20 = Math_fround(f20);
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0;
 _memset(HEAP32[i21 + 1344 >> 2] | 0, 0, HEAP32[i21 + 1348 >> 2] << 2 | 0) | 0;
 HEAP32[i21 + 1356 >> 2] = 0;
 HEAP32[i21 + 1360 >> 2] = 0;
 HEAP32[i21 + 1364 >> 2] = 0;
 HEAP32[i21 + 6944 >> 2] = 1;
 i1 = i21 + 6940 | 0;
 HEAP32[i1 >> 2] = i2;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  HEAP32[i21 + 6936 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 i19 = i21 + 6900 | 0;
 i18 = i21 + 6928 | 0;
 HEAP32[i21 + 6916 >> 2] = 1;
 i17 = i21 + 6912 | 0;
 HEAP32[i17 >> 2] = i18;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
 HEAP32[i21 + 6908 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2];
 HEAP32[i21 + 1372 >> 2] = 0;
 HEAP32[i21 + 1384 >> 2] = 0;
 HEAP32[i21 + 1396 >> 2] = 0;
 HEAP32[i21 + 1408 >> 2] = 0;
 HEAP32[i21 + 1420 >> 2] = 0;
 HEAP32[i21 + 1432 >> 2] = 0;
 i17 = i21 + 1332 | 0;
 i18 = i21 + 1336 | 0;
 i5 = HEAP32[i18 >> 2] & 2147483647;
 L4 : do if (!i5) {
  i3 = -1;
  i4 = 0;
  i2 = 0;
 } else {
  i4 = HEAP32[i17 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i3 = -1;
    i4 = i1;
    i2 = 0;
    break L4;
   }
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  if (!i2) while (1) {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i4 = i1;
    i2 = 0;
    break L4;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2) {
    i4 = i1;
    break;
   }
  } else i4 = i1;
 } while (0);
 i13 = i21 + 6960 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[HEAP32[i13 >> 2] >> 2] | 0);
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) == -1) {
  i22 = i1;
  i22 = HEAP32[i22 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i22);
  i22 = HEAP32[i19 >> 2] | 0;
  i22 = i22 + 20 | 0;
  i22 = HEAP32[i22 >> 2] | 0;
  mftCall_vi(i22 | 0, i19 | 0);
  return;
 }
 i14 = i21 + 708 | 0;
 i15 = i21 + 720 | 0;
 i16 = i21 + 696 | 0;
 do {
  i12 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1, 160, 16) | 0;
  HEAP16[i12 + 4 >> 1] = -1;
  HEAP16[i12 + 6 >> 1] = 0;
  i9 = i12 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i12 >> 2] = gb + 87404 + 8;
  i10 = i12 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i12 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  i8 = i12 + 148 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAPF32[i12 + 152 >> 2] = f20;
  HEAP32[i12 + 156 >> 2] = i21;
  i1 = i12 + 20 | 0;
  i5 = i1 + 128 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i5 | 0));
  HEAP32[i12 >> 2] = gb + 105764 + 8;
  if ((i3 | 0) == -1) {
   i3 = -1;
   i22 = 21;
  } else {
   i6 = HEAP32[i14 >> 2] | 0;
   i7 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
   i5 = (HEAP32[(HEAP32[i15 >> 2] | 0) + (i3 >>> i6 << 2) >> 2] | 0) + ((i7 & i3) << 7) | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i12 + 20 >> 2] = i5;
   L21 : do if (!i2) {
    i2 = 0;
    i1 = 1;
    i3 = -1;
   } else {
    i1 = 1;
    while (1) {
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4 << 5;
     i2 = i2 + -1 & i2;
     i5 = HEAP32[i18 >> 2] & 2147483647;
     L24 : do if (!i2) do {
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= i5 >>> 0) {
       i2 = 0;
       break L24;
      }
      i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i2 | 0) == 0); while (0);
     if (!(i1 >>> 0 < 32 & (i3 | 0) != -1)) break L21;
     i5 = HEAP32[i8 >> 2] | 0;
     i3 = (HEAP32[(HEAP32[i15 >> 2] | 0) + (i3 >>> i6 << 2) >> 2] | 0) + ((i7 & i3) << 7) | 0;
     HEAP32[i8 >> 2] = i5 + 1;
     HEAP32[i12 + 20 + (i5 << 2) >> 2] = i3;
     i1 = i1 + 1 | 0;
     if (!i2) {
      i2 = 0;
      i3 = -1;
      break;
     }
    }
   } while (0);
   if (!i1) i22 = 21; else {
    HEAP32[i11 >> 2] = 1;
    HEAP32[i10 >> 2] = i19;
    mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 16 >> 2] | 0, i19 | 0);
    HEAP32[i9 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0);
   }
  }
  if ((i22 | 0) == 21) {
   i22 = 0;
   mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0);
  }
  i1 = HEAP32[i13 >> 2] | 0;
 } while ((i3 | 0) != -1);
 i22 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i22);
 i22 = HEAP32[i19 >> 2] | 0;
 i22 = i22 + 20 | 0;
 i22 = HEAP32[i22 >> 2] | 0;
 mftCall_vi(i22 | 0, i19 | 0);
 return;
}

function __ZNK13WebCamTexture25GetDeviceIdFromDeviceListERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 32 | 0;
 i17 = i19 + 16 | 0;
 i13 = i19;
 HEAP32[i17 >> 2] = 0;
 i18 = i17 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb(i17, 0);
 i14 = i11 + 11 | 0;
 i2 = HEAP8[i14 >> 0] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 L1 : do if (!((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0)) {
  i2 = HEAP32[i17 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i18 >> 2] | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 364001 | 0, 0, gb + 363932 | 0, 147, 1, 0, 0, 0);
   i1 = -1;
   i15 = 20;
  } else i1 = 0;
 } else {
  i3 = HEAP32[i17 >> 2] | 0;
  do if ((HEAP32[i18 >> 2] | 0) == (i3 | 0)) {
   i4 = i11;
   i3 = i11;
  } else {
   i9 = i16 + 11 | 0;
   i10 = i16 + 4 | 0;
   i1 = 0;
   i2 = i3;
   L8 : while (1) {
    __Z24scripting_cpp_string_forP12Il2CppString(i16, HEAP32[i2 + (i1 << 3) >> 2] | 0);
    i3 = HEAP8[i9 >> 0] | 0;
    i5 = i3 << 24 >> 24 < 0;
    i3 = i3 & 255;
    i6 = i5 ? HEAP32[i10 >> 2] | 0 : i3;
    i8 = HEAP8[i14 >> 0] | 0;
    i2 = i8 << 24 >> 24 < 0;
    do if ((i6 | 0) == ((i2 ? HEAP32[i12 >> 2] | 0 : i8 & 255) | 0)) {
     i7 = HEAP32[i16 >> 2] | 0;
     i8 = i5 ? i7 : i16;
     i2 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = (i6 | 0) == 0;
     if (i5) {
      if (i4) {
       i15 = 12;
       break L8;
      }
      i8 = (_memcmp(i8, i2, i6) | 0) == 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
      if (i8) {
       i15 = 20;
       break L1;
      } else break;
     }
     if (i4) {
      i15 = 12;
      break L8;
     }
     if ((i7 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
      i4 = i16;
      while (1) {
       i3 = i3 + -1 | 0;
       i4 = i4 + 1 | 0;
       if (!i3) {
        i15 = 12;
        break L8;
       }
       i2 = i2 + 1 | 0;
       if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
        i15 = 13;
        break;
       }
      }
     } else i15 = 13;
    } else i15 = 13; while (0);
    if ((i15 | 0) == 13) {
     i15 = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    }
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i17 >> 2] | 0;
    if (i1 >>> 0 >= (HEAP32[i18 >> 2] | 0) - i2 >> 3 >>> 0) {
     i15 = 16;
     break;
    }
   }
   if ((i15 | 0) == 12) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    i15 = 20;
    break L1;
   } else if ((i15 | 0) == 16) {
    i4 = i11;
    i3 = i11;
    i2 = HEAP8[i14 >> 0] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    break;
   }
  } while (0);
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, gb + 363905 | 0, 26, i1 + 26 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, (HEAP8[i14 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i4, i1) | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  i1 = HEAP8[i13 + 11 >> 0] | 0;
  i15 = i1 << 24 >> 24 < 0;
  i1 = i15 ? HEAP32[i13 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i15 ? HEAP32[i13 >> 2] | 0 : i13, i1, i1 + 1 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, gb + 1087625 | 0, 1) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i16 + 11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16, 0, gb + 363932 | 0, 137, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i1 = -1;
  i15 = 20;
 } while (0);
 if ((i15 | 0) == 20) i2 = HEAP32[i17 >> 2] | 0;
 if (!i2) {
  STACKTOP = i19;
  return i1 | 0;
 }
 i3 = HEAP32[i18 >> 2] | 0;
 if ((i3 | 0) != (i2 | 0)) HEAP32[i18 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
 i18 = HEAP32[i17 + 12 >> 2] | 0;
 HEAP32[i16 >> 2] = 56;
 HEAP32[i16 + 4 >> 2] = i18;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i16);
 STACKTOP = i19;
 return i1 | 0;
}

function __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_(i27, i28, i20, i8, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0, f30 = f0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i29;
 i21 = i29 + 12 | 0;
 i22 = __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i27, i28, i20, i1) | 0;
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 i1 = i20 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 < Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22;
  STACKTOP = i29;
  return i28 | 0;
 }
 i2 = HEAP32[i20 >> 2] | 0;
 i15 = i20 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i16 = i20 + 8 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i17 = i20 + 12 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i18 = i20 + 16 | 0;
 i6 = HEAP32[i18 >> 2] | 0;
 i19 = i20 + 20 | 0;
 i7 = HEAP32[i19 >> 2] | 0;
 i14 = i20 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i23 = i20;
 i24 = i8;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i5;
 HEAP32[i8 + 16 >> 2] = i6;
 HEAP32[i8 + 20 >> 2] = i7;
 i25 = i8 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 i1 = i28 + 32 | 0;
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 < Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22 + 1 | 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i2 = HEAP32[i28 >> 2] | 0;
 i9 = i28 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i28 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i28 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i28 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i28 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i28 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i23 = i28;
 i24 = i20;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i20 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i16 >> 2] = i4;
 HEAP32[i17 >> 2] = i5;
 HEAP32[i18 >> 2] = i6;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 __ZNK9Transform11GetPositionEv(i26, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f30 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i27 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f30 < Math_fround(HEAPF32[i21 + 8 >> 2]))) {
  i28 = i22 + 2 | 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i1 = HEAP32[i27 >> 2] | 0;
 i2 = HEAP32[i27 + 4 >> 2] | 0;
 i3 = HEAP32[i27 + 8 >> 2] | 0;
 i4 = HEAP32[i27 + 12 >> 2] | 0;
 i5 = HEAP32[i27 + 16 >> 2] | 0;
 i6 = HEAP32[i27 + 20 >> 2] | 0;
 i23 = i27 + 24 | 0;
 HEAP32[i26 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 i23 = i27;
 i24 = i28;
 i25 = i23 + 36 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i28 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
 i28 = i22 + 3 | 0;
 STACKTOP = i29;
 return i28 | 0;
}

function __ZN18GfxFramebufferGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i11 + 212 | 0;
 i6 = i11 + 248 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i11 + 212 + (i7 << 2) | 0;
 L1 : do if (!i7) {
  i1 = i5;
  i8 = 4;
 } else {
  i1 = i5;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
    i8 = 4;
    break L1;
   }
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i4;
    break;
   }
  }
 } while (0);
 L5 : do if ((i8 | 0) == 4) if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
  i2 = i1;
  while (1) {
   do {
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i4 | 0)) break L5;
    i3 = HEAP32[i2 >> 2] | 0;
   } while ((i3 | 0) == (i10 | 0));
   HEAP32[i1 >> 2] = i3;
   i1 = i1 + 4 | 0;
  }
 } while (0);
 i2 = i1 - i5 >> 2;
 HEAP32[i6 >> 2] = i2;
 i1 = i11 + 244 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = 1;
 } else i1 = (i7 | 0) != (i2 | 0);
 HEAP8[i11 + 328 >> 0] = i1 & 1 ^ 1;
 i5 = i11 + 92 | 0;
 i6 = i11 + 128 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i11 + 92 + (i7 << 2) | 0;
 L17 : do if (!i7) {
  i1 = i5;
  i8 = 14;
 } else {
  i1 = i5;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
    i8 = 14;
    break L17;
   }
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i4;
    break;
   }
  }
 } while (0);
 L21 : do if ((i8 | 0) == 14) if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
  i2 = i1;
  while (1) {
   do {
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i4 | 0)) break L21;
    i3 = HEAP32[i2 >> 2] | 0;
   } while ((i3 | 0) == (i10 | 0));
   HEAP32[i1 >> 2] = i3;
   i1 = i1 + 4 | 0;
  }
 } while (0);
 i2 = i1 - i5 >> 2;
 HEAP32[i6 >> 2] = i2;
 i1 = i11 + 124 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = 1;
 } else i1 = (i7 | 0) != (i2 | 0);
 HEAP8[i11 + 208 >> 0] = i1 & 1 ^ 1;
 if (HEAP32[i10 >> 2] | 0) {
  i2 = i11 + 480 | 0;
  i3 = i11 + 492 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i11 + 496 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i11 + 484 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 484 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i10 >> 2];
 }
 i2 = i10 + 36 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i11 + 500 | 0;
  i4 = i11 + 512 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i11 + 516 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i6 >>> 0 > i9 >>> 0) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i11 + 504 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 504 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i2 >> 2];
 }
 i2 = i10 + 44 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = i11 + 500 | 0;
 i4 = i11 + 512 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i11 + 516 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i11 + 504 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 504 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN17ArchiveFileSystemD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 12 | 0;
 i5 = i12;
 HEAP32[i10 >> 2] = gb + 70492 + 8;
 i9 = i10 + 40 | 0;
 i6 = i10 + 92 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i10 + 96 | 0;
 i1 = i3 + ((HEAP32[i7 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i11 >> 2] = i9;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i11 + 8 >> 2] = i1;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i11);
 i1 = (HEAP32[i6 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i5 >> 2] = i9;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i5);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i3 >> 2] | 0)) do {
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  i13 = i2 + 4 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  if (!(HEAP32[i13 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i1 + 20;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i11);
  i1 = (HEAP32[i6 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i5 >> 2] = i9;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i1;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i5);
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 i3 = i10 + 120 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i10 + 124 | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 + 24 >> 2] | 0;
   i13 = i1 + 4 | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   if (!(HEAP32[i13 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 i1 = i10 + 152 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i10 + 136 | 0, HEAP32[i10 + 140 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i3, HEAP32[i4 >> 2] | 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev(i9);
 i1 = i10 + 20 | 0;
 if ((HEAP32[i10 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i11 >> 2] = 54;
 HEAP32[i11 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i11);
 STACKTOP = i12;
 return;
}

function __ZN5Umbra13DebugRenderer12addAABBLinesEPS0_RKNS_7Vector3ES4_RKNS_7Vector4E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 12 | 0;
 i6 = i5;
 i8 = i2 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i2 + 8 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i7 + 8 >> 2] = i11;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i11;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i11 = i3 + 4 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i7 + 8 >> 2] = i14;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i14;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i14 = HEAP32[i8 >> 2] | 0;
 i9 = i3 + 8 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i14;
 HEAP32[i7 + 8 >> 2] = i12;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i14;
 HEAP32[i6 + 8 >> 2] = i12;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i12 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i14;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i14;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i14 = HEAP32[i2 >> 2] | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i13;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i13;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i13 = HEAP32[i2 >> 2] | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i14;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i14;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i14 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i13;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i13;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i14;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i14;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i14 = HEAP32[i2 >> 2] | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i13;
 i13 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i13;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i13 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i12;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i12;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i12 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i8;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i8;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 i8 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN10AudioMixer8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 i2 = i6 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 862996 | 0, gb + 863920 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863010 | 0, gb + 863920 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863024 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863036 | 0, gb + 863052 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863077 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863096 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20AudioMixerUpdateModeEvRT_RT0_PKc17TransferMetaFlags(i8, i6 + 104 | 0, gb + 902271 | 0, 0);
 i1 = i6 + 32 | 0;
 HEAP32[i8 + 4 >> 2] = i1;
 i4 = i6 + 72 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i2 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 80, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  i1 = i2 + 28 | 0;
  i3 = i1 + 52 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP32[i4 >> 2] = i2;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 863112 | 0, gb + 863128 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN5audio5mixer18AudioMixerConstant8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function runPostSets74() {
 HEAP32[gb + 82808 >> 2] = fb + 919;
 HEAP32[gb + 82812 >> 2] = fb + 757;
 HEAP32[gb + 82816 >> 2] = fb + 16;
 HEAP32[gb + 82820 >> 2] = fb + 93;
 HEAP32[gb + 82824 >> 2] = fb + 40;
 HEAP32[gb + 82828 >> 2] = fb + 920;
 HEAP32[gb + 82832 >> 2] = fb + 421;
 HEAP32[gb + 82836 >> 2] = fb + 103;
 HEAP32[gb + 82840 >> 2] = fb + 101;
 HEAP32[gb + 82844 >> 2] = fb + 62;
 HEAP32[gb + 82848 >> 2] = fb + 28;
 HEAP32[gb + 82852 >> 2] = fb + 63;
 HEAP32[gb + 82856 >> 2] = fb + 29;
 HEAP32[gb + 82860 >> 2] = fb + 34;
 HEAP32[gb + 82864 >> 2] = fb + 758;
 HEAP32[gb + 82868 >> 2] = fb + 759;
 HEAP32[gb + 82872 >> 2] = fb + 760;
 HEAP32[gb + 82876 >> 2] = fb + 761;
 HEAP32[gb + 82880 >> 2] = fb + 762;
 HEAP32[gb + 82884 >> 2] = fb + 763;
 HEAP32[gb + 82888 >> 2] = fb + 36;
 HEAP32[gb + 82892 >> 2] = fb + 104;
 HEAP32[gb + 82896 >> 2] = fb + 108;
 HEAP32[gb + 82900 >> 2] = fb + 94;
 HEAP32[gb + 82904 >> 2] = fb + 764;
 HEAP32[gb + 82908 >> 2] = fb + 105;
 HEAP32[gb + 82912 >> 2] = fb + 106;
 HEAP32[gb + 82916 >> 2] = fb + 110;
 HEAP32[gb + 82920 >> 2] = (HEAP32[gb + 82920 >> 2] | 0) + (gb + 619797 | 0);
 HEAP32[gb + 82924 >> 2] = (HEAP32[gb + 82924 >> 2] | 0) + (gb + 619813 | 0);
 HEAP32[gb + 82928 >> 2] = (HEAP32[gb + 82928 >> 2] | 0) + (gb + 619829 | 0);
 HEAP32[gb + 82932 >> 2] = (HEAP32[gb + 82932 >> 2] | 0) + (gb + 619845 | 0);
 HEAP32[gb + 82936 >> 2] = (HEAP32[gb + 82936 >> 2] | 0) + (gb + 619861 | 0);
 HEAP32[gb + 82940 >> 2] = (HEAP32[gb + 82940 >> 2] | 0) + (gb + 619877 | 0);
 HEAP32[gb + 82944 >> 2] = (HEAP32[gb + 82944 >> 2] | 0) + (gb + 620122 | 0);
 HEAP32[gb + 82948 >> 2] = (HEAP32[gb + 82948 >> 2] | 0) + (gb + 620129 | 0);
 HEAP32[gb + 82952 >> 2] = (HEAP32[gb + 82952 >> 2] | 0) + (gb + 620136 | 0);
 HEAP32[gb + 82956 >> 2] = (HEAP32[gb + 82956 >> 2] | 0) + (gb + 620143 | 0);
 HEAP32[gb + 82960 >> 2] = (HEAP32[gb + 82960 >> 2] | 0) + (gb + 620150 | 0);
 HEAP32[gb + 82964 >> 2] = (HEAP32[gb + 82964 >> 2] | 0) + (gb + 620157 | 0);
 HEAP32[gb + 82968 >> 2] = (HEAP32[gb + 82968 >> 2] | 0) + (gb + 620600 | 0);
 HEAP32[gb + 82972 >> 2] = (HEAP32[gb + 82972 >> 2] | 0) + (gb + 620605 | 0);
 HEAP32[gb + 82976 >> 2] = (HEAP32[gb + 82976 >> 2] | 0) + (gb + 620610 | 0);
 HEAP32[gb + 82980 >> 2] = (HEAP32[gb + 82980 >> 2] | 0) + (gb + 620615 | 0);
 HEAP32[gb + 82984 >> 2] = (HEAP32[gb + 82984 >> 2] | 0) + (gb + 620568 | 0);
 HEAP32[gb + 82988 >> 2] = (HEAP32[gb + 82988 >> 2] | 0) + (gb + 620576 | 0);
 HEAP32[gb + 82992 >> 2] = (HEAP32[gb + 82992 >> 2] | 0) + (gb + 620584 | 0);
 HEAP32[gb + 82996 >> 2] = (HEAP32[gb + 82996 >> 2] | 0) + (gb + 620592 | 0);
 HEAP32[gb + 83e3 >> 2] = (HEAP32[gb + 83e3 >> 2] | 0) + (gb + 620544 | 0);
 HEAP32[gb + 83004 >> 2] = (HEAP32[gb + 83004 >> 2] | 0) + (gb + 620550 | 0);
 HEAP32[gb + 83008 >> 2] = (HEAP32[gb + 83008 >> 2] | 0) + (gb + 620556 | 0);
 HEAP32[gb + 83012 >> 2] = (HEAP32[gb + 83012 >> 2] | 0) + (gb + 620562 | 0);
 HEAP32[gb + 83024 >> 2] = fb + 921;
 HEAP32[gb + 83028 >> 2] = fb + 922;
 HEAP32[gb + 83040 >> 2] = fb + 923;
 HEAP32[gb + 83044 >> 2] = fb + 924;
 HEAP32[gb + 83056 >> 2] = fb + 10;
 HEAP32[gb + 83060 >> 2] = fb + 10;
 HEAP32[gb + 83064 >> 2] = fb + 84;
 HEAP32[gb + 83068 >> 2] = fb + 200;
 HEAP32[gb + 83072 >> 2] = fb + 53;
 HEAP32[gb + 83076 >> 2] = fb + 54;
 HEAP32[gb + 83080 >> 2] = fb + 60;
 HEAP32[gb + 83084 >> 2] = fb + 9;
 HEAP32[gb + 83096 >> 2] = fb + 925;
 HEAP32[gb + 83100 >> 2] = fb + 926;
 HEAP32[gb + 83104 >> 2] = fb + 927;
 HEAP32[gb + 83108 >> 2] = fb + 765;
 HEAP32[gb + 83112 >> 2] = fb + 16;
 HEAP32[gb + 83116 >> 2] = fb + 928;
 HEAP32[gb + 83120 >> 2] = fb + 929;
 HEAP32[gb + 83124 >> 2] = fb + 349;
 HEAP32[gb + 83128 >> 2] = fb + 422;
 HEAP32[gb + 83132 >> 2] = fb + 103;
 HEAP32[gb + 83136 >> 2] = fb + 101;
 HEAP32[gb + 83140 >> 2] = fb + 62;
 HEAP32[gb + 83144 >> 2] = fb + 28;
 HEAP32[gb + 83148 >> 2] = fb + 63;
 HEAP32[gb + 83152 >> 2] = fb + 29;
 HEAP32[gb + 83156 >> 2] = fb + 34;
 HEAP32[gb + 83160 >> 2] = fb + 766;
 HEAP32[gb + 83164 >> 2] = fb + 767;
 HEAP32[gb + 83168 >> 2] = fb + 768;
 HEAP32[gb + 83172 >> 2] = fb + 769;
 HEAP32[gb + 83176 >> 2] = fb + 770;
 HEAP32[gb + 83180 >> 2] = fb + 771;
 HEAP32[gb + 83184 >> 2] = fb + 36;
 HEAP32[gb + 83188 >> 2] = fb + 104;
 HEAP32[gb + 83192 >> 2] = fb + 336;
 HEAP32[gb + 83196 >> 2] = fb + 94;
 HEAP32[gb + 83200 >> 2] = fb + 337;
 HEAP32[gb + 83204 >> 2] = fb + 205;
 HEAP32[gb + 83208 >> 2] = fb + 206;
 HEAP32[gb + 83212 >> 2] = fb + 338;
 HEAP32[gb + 83216 >> 2] = fb + 930;
 HEAP32[gb + 83220 >> 2] = fb + 931;
 HEAP32[gb + 83224 >> 2] = fb + 207;
 HEAP32[gb + 83228 >> 2] = fb + 932;
 HEAP32[gb + 83232 >> 2] = fb + 933;
 HEAP32[gb + 83236 >> 2] = fb + 208;
 runPostSets75();
}

function __ZNK18PlatformEffector2D21CalculateContactStateERN10Effector2D15EffectorContactE(i17, i12) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i19 + 32 | 0;
 i13 = i19;
 i15 = i17 + 76 | 0;
 i18 = HEAP32[i15 >> 2] | 0;
 i7 = (i18 & 255) << 24 >> 24 == 0;
 if (!((i18 & 16711680 | 0) == 0 | i7 ^ 1 | i18 >>> 0 < 16777216)) {
  STACKTOP = i19;
  return;
 }
 i18 = HEAP32[i12 + 32 >> 2] | 0;
 L4 : do if ((HEAPU16[i15 >> 1] | 0) >= 256) {
  i1 = HEAP32[(HEAP32[i12 + 16 >> 2] | 0) + 112 >> 2] | 0;
  if (i1 | 0) {
   while (1) {
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    if (HEAP32[i3 + 4 >> 2] & 64 | 0) {
     i6 = HEAP32[(HEAP32[i3 + 48 >> 2] | 0) + 60 >> 2] | 0;
     i3 = HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + 60 >> 2] | 0;
     if (HEAP8[i6 + 53 >> 0] | 0) if ((HEAP32[i6 + 156 >> 2] | 0) == (i17 | 0)) break;
     if (HEAP8[i3 + 53 >> 0] | 0) if ((HEAP32[i3 + 156 >> 2] | 0) == (i17 | 0)) break;
    }
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    if (!i1) break L4;
   }
   i14 = i18 + 4 | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -69 | 64;
  }
 } while (0);
 i14 = i18 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 & 64 | 0) {
  STACKTOP = i19;
  return;
 }
 if (!i7) if (Math_fround(HEAPF32[i17 + 80 >> 2]) < Math_fround(1.1920929e-07)) {
  HEAP32[i14 >> 2] = i1 & -69 | 64;
  STACKTOP = i19;
  return;
 }
 f4 = Math_fround(Math_fround(HEAPF32[i17 + 88 >> 2]) * Math_fround(.0174532924));
 f5 = Math_fround(-f4);
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f4 = Math_fround(+Math_cos(+f4));
 HEAPF32[i13 >> 2] = Math_fround(+Math_sin(+f5));
 HEAPF32[i13 + 4 >> 2] = f4;
 HEAPF32[i13 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform15TransformVectorERK8Vector3f(i8, i7, i13);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5))));
 if (!(f2 < Math_fround(1.1920929e-07))) {
  f10 = Math_fround(Math_fround(1.0) / f2);
  f11 = Math_fround(f4 * f10);
  f10 = Math_fround(f5 * f10);
  i6 = i18 + 48 | 0;
  i7 = i18 + 52 | 0;
  f9 = Math_fround(HEAPF32[i18 + 128 >> 2]);
  __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i13, i18 + 64 | 0, (HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, f9, (HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, Math_fround(HEAPF32[i18 + 132 >> 2]));
  if (!(HEAP8[i12 + 36 >> 0] | 0)) {
   f5 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
   f9 = Math_fround(-Math_fround(HEAPF32[i13 + 4 >> 2]));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i13 + 4 >> 2] | 0;
  }
  f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(f11 * f9);
  f5 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = Math_fround(Math_fround(f10 * f5) + f2);
  f4 = Math_fround(+Math_cos(+Math_fround(Math_fround(Math_fround(HEAPF32[i17 + 80 >> 2]) * Math_fround(.5)) * Math_fround(.0174532924))));
  i1 = HEAP32[i15 >> 2] | 0;
  i3 = i1 >>> 24 & 255;
  if (!((i1 & 255) << 24 >> 24)) i16 = 23; else {
   f20 = Math_fround(f2 - f4);
   i15 = f20 < Math_fround(0.0);
   f21 = Math_fround(-f20);
   if (f2 < f4 & !((i15 ? f21 : f20) <= Math_fround(9.99999997e-07))) HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -69 | 64; else i16 = 23;
  }
  do if ((i16 | 0) == 23) {
   i1 = (i1 & 16711680 | 0) == 0;
   if (i1 | i3 << 24 >> 24 == 0) {
    f20 = Math_fround(Math_fround(f10 * f9) - Math_fround(f11 * f5));
    f21 = Math_fround(+Math_cos(+Math_fround(Math_fround(Math_fround(HEAPF32[i17 + 84 >> 2]) * Math_fround(.5)) * Math_fround(.0174532924))));
    if (!(f20 < Math_fround(-f21) | f20 > f21)) {
     i16 = HEAP32[i6 >> 2] | 0;
     f20 = Math_fround(HEAPF32[i16 + 36 >> 2]);
     i17 = HEAP32[i7 >> 2] | 0;
     HEAPF32[i18 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f20 * Math_fround(HEAPF32[i17 + 36 >> 2]))));
     f20 = Math_fround(HEAPF32[i16 + 40 >> 2]);
     f21 = Math_fround(HEAPF32[i17 + 40 >> 2]);
     HEAPF32[i18 + 148 >> 2] = f20 > f21 ? f20 : f21;
     break;
    }
    if (i1) HEAPF32[i18 + 144 >> 2] = Math_fround(0.0);
    if (!(i3 << 24 >> 24)) HEAPF32[i18 + 148 >> 2] = Math_fround(0.0);
   }
  } while (0);
 }
 STACKTOP = i19;
 return;
}

function __ZN16SpriteRenderData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932887 | 0, gb + 1034905 | 0, i1, 0);
 i9 = i7 + 8 | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i10 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410538 | 0, gb + 1034905 | 0, i9, 0);
 i6 = i7 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i10, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i8, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_PKc17TransferMetaFlags(i2, (HEAP32[i6 >> 2] | 0) + 8 | 0, gb + 500490 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 753990 | 0, HEAP32[gb + 37316 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37288 >> 2] | 0, i3 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410551 | 0, HEAP32[gb + 37212 >> 2] | 0, i7, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410563 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 0);
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410581 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410593 | 0, HEAP32[gb + 37328 >> 2] | 0, i1, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil30clipShapeNormalToVertexVoronoiERNS_6PxVec3Ejjj(i16, i18, i17, i11, i15) {
 i16 = i16 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i12 = 0, i13 = 0, f14 = f0, f19 = f0, f20 = f0;
 i12 = HEAP32[i16 + 12 >> 2] | 0;
 i13 = HEAP32[i12 + 36 >> 2] | 0;
 f14 = Math_fround(HEAP16[i13 + (i17 << 2) >> 1] | 0);
 if (!i11) i9 = 0; else {
  i4 = HEAP32[i16 + 16 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f2 = Math_fround(-f1);
  f3 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f3 = Math_fround(f3 * Math_fround(Math_fround(HEAP16[i13 + (i17 - (HEAP32[i12 + 20 >> 2] | 0) << 2) >> 1] | 0) - f14));
  f5 = Math_fround(HEAPF32[i18 >> 2]);
  f10 = Math_fround(f5 * f2);
  i4 = i18 + 4 | 0;
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f7 * f3));
  i6 = i18 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  f10 = Math_fround(Math_fround(f8 * Math_fround(0.0)) + f10);
  if (f10 > Math_fround(0.0)) {
   f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3)) + Math_fround(0.0)));
   f1 = Math_fround(Math_fround(f3 * f10) * f19);
   f3 = Math_fround(Math_fround(f10 * Math_fround(0.0)) * f19);
   HEAPF32[i18 >> 2] = Math_fround(f5 - Math_fround(Math_fround(f10 * f2) * f19));
   HEAPF32[i4 >> 2] = Math_fround(f7 - f1);
   HEAPF32[i6 >> 2] = Math_fround(f8 - f3);
   i9 = 1;
  } else i9 = 0;
 }
 if (((HEAP32[i12 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i11 >>> 0) {
  i4 = HEAP32[i16 + 16 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f2 = Math_fround(f2 * Math_fround(Math_fround(HEAP16[i13 + ((HEAP32[i12 + 20 >> 2] | 0) + i17 << 2) >> 1] | 0) - f14));
  f3 = Math_fround(HEAPF32[i18 >> 2]);
  f8 = Math_fround(f1 * f3);
  i4 = i18 + 4 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f5 * f2));
  i6 = i18 + 8 | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  f8 = Math_fround(Math_fround(f7 * Math_fround(0.0)) + f8);
  if (f8 > Math_fround(0.0)) {
   f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(0.0)));
   f10 = Math_fround(Math_fround(f2 * f8) * f20);
   f19 = Math_fround(Math_fround(f8 * Math_fround(0.0)) * f20);
   HEAPF32[i18 >> 2] = Math_fround(f3 - Math_fround(Math_fround(f1 * f8) * f20));
   HEAPF32[i4 >> 2] = Math_fround(f5 - f10);
   HEAPF32[i6 >> 2] = Math_fround(f7 - f19);
   i9 = 1;
  }
 }
 if (i15) {
  i4 = HEAP32[i16 + 16 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f1 = Math_fround(f1 * Math_fround(Math_fround(HEAP16[i13 + (i17 + -1 << 2) >> 1] | 0) - f14));
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f3 = Math_fround(-f2);
  f5 = Math_fround(HEAPF32[i18 >> 2]);
  f10 = Math_fround(f5 * Math_fround(0.0));
  i4 = i18 + 4 | 0;
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f1 * f7));
  i6 = i18 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f8 * f3));
  if (f10 > Math_fround(0.0)) {
   f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f1 * f1) + Math_fround(0.0))));
   f19 = Math_fround(Math_fround(f1 * f10) * f2);
   f20 = Math_fround(Math_fround(f10 * f3) * f2);
   HEAPF32[i18 >> 2] = Math_fround(f5 - Math_fround(Math_fround(f10 * Math_fround(0.0)) * f2));
   HEAPF32[i4 >> 2] = Math_fround(f7 - f19);
   HEAPF32[i6 >> 2] = Math_fround(f8 - f20);
   i9 = 1;
  }
 }
 if (((HEAP32[i12 + 20 >> 2] | 0) + -1 | 0) >>> 0 <= i15 >>> 0) {
  i18 = i9;
  return i18 | 0;
 }
 i4 = HEAP32[i16 + 16 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f1 = Math_fround(f1 * Math_fround(Math_fround(HEAP16[i13 + (i17 + 1 << 2) >> 1] | 0) - f14));
 f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 f8 = Math_fround(f3 * Math_fround(0.0));
 i4 = i18 + 4 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f1 * f5));
 i6 = i18 + 8 | 0;
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f2 * f7));
 if (!(f8 > Math_fround(0.0))) {
  i18 = i9;
  return i18 | 0;
 }
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f1 * f1) + Math_fround(0.0))));
 f19 = Math_fround(Math_fround(f1 * f8) * f14);
 f20 = Math_fround(Math_fround(f2 * f8) * f14);
 HEAPF32[i18 >> 2] = Math_fround(f3 - Math_fround(Math_fround(f8 * Math_fround(0.0)) * f14));
 HEAPF32[i4 >> 2] = Math_fround(f5 - f19);
 HEAPF32[i6 >> 2] = Math_fround(f7 - f20);
 i18 = 1;
 return i18 | 0;
}

function __ZN4Mesh5ClearEb(i16, i11) {
 i16 = i16 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i13 = i17 + 104 | 0;
 i14 = i16 + 32 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i14 >> 2] | 0);
  i2 = HEAP32[i14 >> 2] | 0;
  i10 = i2 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  if (!(HEAP32[i10 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i14 >> 2] = i1;
 }
 i2 = HEAP32[i1 + 128 >> 2] | 0;
 i3 = i1 + 132 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -52 - i2 | 0) >>> 0) / 52 | 0) * 52 | 0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i2 = i12 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1155204 >> 2];
 i3 = i12 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
 i4 = i12 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
 i5 = i12 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 i6 = i12 + 24 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 i7 = i12 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 i8 = i12 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 i9 = i1 + 132 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i10 | 0) == (HEAP32[i1 + 136 >> 2] | 0)) __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i1 + 128 | 0, i12); else {
  i19 = i12;
  i18 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i10;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = i18;
  HEAP32[i10 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i7 >> 2];
  i10 = i10 + 32 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 52;
 }
 __Z16ClearBlendShapesR14BlendShapeData(i16 + 72 | 0);
 i3 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 i2 = i3 + 116 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
 i5 = HEAP32[i3 + 96 >> 2] | 0;
 do if (HEAP32[i3 + 100 >> 2] | 0) {
  if (!i11) {
   __ZN14VertexDataInfoC2Ev(i12);
   __Z4swapR10VertexDataS0_(i12, (HEAP32[i14 >> 2] | 0) + 8 | 0);
   i19 = i16 + 44 | 0;
   HEAP8[i19 >> 0] = HEAP8[i19 >> 0] | 1;
   __ZN10VertexDataD2Ev(i12);
   break;
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if (!(HEAP32[i1 + 176 >> 2] | 0)) if ((HEAP32[i16 + 116 >> 2] | 0) == (HEAP32[i16 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i12, i1 + 8 | 0);
   HEAP32[i12 >> 2] = (HEAP32[i12 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i12 + 8 >> 2] & ~HEAP32[i12 + 12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  } else i15 = 16; else i15 = 16;
  if ((i15 | 0) == 16) {
   HEAP32[i13 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i16, 0, i5, 0, gb + 1546313 | 0, i13);
 } while (0);
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + 164 | 0;
 i3 = i1 + 176 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i19 = i16 + 44 | 0;
  i18 = HEAP8[i19 >> 0] | 0;
  i18 = i18 & -17;
  HEAP8[i19 >> 0] = i18;
  __ZN4Mesh14ClearSkinCacheEv(i16);
  __ZN4Mesh16SetChannelsDirtyEjb(i16, i5, 1);
  STACKTOP = i17;
  return;
 }
 i4 = i1 + 180 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 168 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i19 = i16 + 44 | 0;
 i18 = HEAP8[i19 >> 0] | 0;
 i18 = i18 & -17;
 HEAP8[i19 >> 0] = i18;
 __ZN4Mesh14ClearSkinCacheEv(i16);
 __ZN4Mesh16SetChannelsDirtyEjb(i16, i5, 1);
 STACKTOP = i17;
 return;
}

function __ZN12LightsModule15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType(i8, i21, i6, i22, i23, i7) {
 i8 = i8 | 0;
 i21 = i21 | 0;
 i6 = i6 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 24 | 0;
 i24 = i26 + 16 | 0;
 i25 = i26;
 i4 = i8 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 HEAP32[i24 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i24);
   i2 = HEAP32[i20 >> 2] | 0;
   i19 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i26;
   return;
  }
 }
 if ((HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 40 >> 2] | 0) != (i7 | 0)) {
  STACKTOP = i26;
  return;
 }
 i19 = HEAP32[i6 + 1308 >> 2] | 0;
 if (!(__Z21IsValidRenderingLightRK5Light9LightTypej(i1, i7, HEAP32[i19 + 512 >> 2] | 0) | 0)) {
  STACKTOP = i26;
  return;
 }
 if ((HEAP16[gb + 1451716 + 6 >> 1] | 0) > -1) {
  HEAP32[i24 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i24 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451716 | 0, i20);
  i10 = gb + 1451716 | 0;
 } else i10 = 0;
 i2 = HEAP32[i8 + 580 >> 2] | 0;
 i11 = i8 + 576 | 0;
 i3 = i2;
 L26 : do if ((i3 | 0) != (i11 | 0)) {
  i12 = i25 + 4 | 0;
  i13 = i25 + 8 | 0;
  i14 = i25 + 12 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 4 | 0;
  i18 = i19 + 548 | 0;
  i9 = i8 + 552 | 0;
  i1 = 0;
  do {
   i8 = i2 + -344 | 0;
   __ZN15SharedLightData7PrecalcEv(i8);
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   HEAP32[i20 + 12 >> 2] = 0;
   HEAP32[i20 + 16 >> 2] = 0;
   HEAP32[i20 + 20 >> 2] = 0;
   HEAP32[i20 + 24 >> 2] = 0;
   HEAP32[i20 + 28 >> 2] = 0;
   __Z26CalculateLightScreenBoundsRK13ShadowJobDataRK15SharedLightDataP5RectTIfER13TargetEyeMask(i19, i8, i20, i24);
   if (HEAP32[i24 >> 2] | 0) {
    i4 = i2 + -340 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    i4 = HEAP32[((HEAP32[i2 + -304 >> 2] | 0) == 3 ? i2 + -140 | 0 : i2 + -296 | 0) >> 2] | 0;
    i6 = HEAP32[i2 + -76 >> 2] | 0;
    i5 = HEAP32[i2 + -72 >> 2] | 0;
    HEAP32[i25 >> 2] = HEAP32[i2 + -80 >> 2];
    HEAP32[i12 >> 2] = i6;
    HEAP32[i13 >> 2] = i5;
    HEAP32[i14 >> 2] = i4;
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i16 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i16 >> 2] = i2;
      HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i2 * 180 | 0, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 180 | 0, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i15 >> 2] | 0) * 180 | 0) | 0;
      HEAP32[i16 >> 2] = i2;
      HEAP32[i22 >> 2] = i7;
      break;
     }
    } while (0);
    HEAP32[i15 >> 2] = i5;
    i7 = (HEAP32[i22 >> 2] | 0) + (i4 * 180 | 0) | 0;
    HEAP32[i7 >> 2] = i8;
    __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight(i21, i19, i25, i20, (HEAP8[i18 >> 0] | 0) != 0, 1, Math_fround(1.0), i7);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) break L26;
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
  } while ((i3 | 0) != (i11 | 0));
 } while (0);
 if (!i10) {
  STACKTOP = i26;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i26;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i12, i9) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i6 = i9 + 28 | 0;
 i10 = i9 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i9 + 44 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i5;
 i7 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i2 = __Znwj(1) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i9 + 32 >> 2] = i2;
   }
   i1 = HEAP32[i9 + 48 >> 2] | 0;
  } else {
   i1 = i2 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i7 - i5 | 0;
  i7 = i5 + 24 | 0;
  i7 = i1 >>> 0 < i7 >>> 0 ? i7 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i7, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i6 + i7;
 }
 HEAP32[i10 >> 2] = i1 + 24;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 3;
 i1 = HEAP32[i12 >> 2] | 0;
 L11 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L11;
  }
  i1 = i1 + 1 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 L15 : do switch (HEAP8[i1 >> 0] | 0) {
 case 125:
  {
   HEAP32[i12 >> 2] = i1 + 1;
   i12 = HEAP32[i10 >> 2] | 0;
   HEAP32[i12 + -8 >> 2] = 3;
   HEAP32[i12 + -24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
   HEAP32[i12 + -16 >> 2] = 0;
   HEAP32[i12 + -20 >> 2] = 0;
   return;
  }
 case 34:
  {
   i1 = i11 + 24 | 0;
   i4 = 0;
   L20 : while (1) {
    __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i11, i12, i9, 1);
    if (HEAP32[i1 >> 2] | 0) {
     i3 = 34;
     break;
    }
    i3 = HEAP32[i12 >> 2] | 0;
    L23 : while (1) {
     switch (HEAP8[i3 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L23;
     }
     i3 = i3 + 1 | 0;
    }
    i2 = i3 + 1 | 0;
    HEAP32[i12 >> 2] = i2;
    if ((HEAP8[i3 >> 0] | 0) != 58) {
     i3 = 21;
     break;
    }
    L27 : while (1) {
     switch (HEAP8[i2 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L27;
     }
     i2 = i2 + 1 | 0;
    }
    HEAP32[i12 >> 2] = i2;
    __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i11, i12, i9);
    if (HEAP32[i1 >> 2] | 0) {
     i3 = 34;
     break;
    }
    i3 = HEAP32[i12 >> 2] | 0;
    L32 : while (1) {
     switch (HEAP8[i3 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L32;
     }
     i3 = i3 + 1 | 0;
    }
    i4 = i4 + 1 | 0;
    i2 = i3 + 1 | 0;
    HEAP32[i12 >> 2] = i2;
    switch (HEAP8[i3 >> 0] | 0) {
    case 125:
     {
      i3 = 32;
      break L20;
     }
    case 44:
     break;
    default:
     {
      i3 = 33;
      break L20;
     }
    }
    L36 : while (1) {
     switch (HEAP8[i2 >> 0] | 0) {
     case 9:
     case 13:
     case 10:
     case 32:
      break;
     default:
      break L36;
     }
     i2 = i2 + 1 | 0;
    }
    HEAP32[i12 >> 2] = i2;
    if ((HEAP8[i2 >> 0] | 0) != 34) break L15;
   }
   if ((i3 | 0) == 21) {
    i12 = i2 - (HEAP32[i12 + 8 >> 2] | 0) | 0;
    HEAP32[i1 >> 2] = 5;
    HEAP32[i11 + 28 >> 2] = i12;
    return;
   } else if ((i3 | 0) == 32) {
    i9 = (HEAP32[i10 >> 2] | 0) + (Math_imul(i4, -48) | 0) | 0;
    HEAP32[i10 >> 2] = i9;
    i12 = i9 + -24 | 0;
    HEAP32[i12 + 16 >> 2] = 3;
    i11 = i4 * 48 | 0;
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
    HEAP32[i12 >> 2] = i10;
    _memcpy(i10 | 0, i9 | 0, i11 | 0) | 0;
    HEAP32[i12 + 8 >> 2] = i4;
    HEAP32[i12 + 4 >> 2] = i4;
    return;
   } else if ((i3 | 0) == 33) {
    i12 = i2 - (HEAP32[i12 + 8 >> 2] | 0) | 0;
    HEAP32[i1 >> 2] = 6;
    HEAP32[i11 + 28 >> 2] = i12;
    return;
   } else if ((i3 | 0) == 34) return;
   break;
  }
 default:
  {
   i2 = i1;
   i1 = i11 + 24 | 0;
  }
 } while (0);
 i12 = i2 - (HEAP32[i12 + 8 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAP32[i11 + 28 >> 2] = i12;
 return;
}

function __ZN5physx2Sq8AABBTree11shiftOriginERKNS_6PxVec3E(i1, i18) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i17 = i1 + 536 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if (!i2) return;
 i14 = i1 + 4 | 0;
 i15 = i18 + 4 | 0;
 i16 = i18 + 8 | 0;
 i13 = 0;
 do {
  i1 = HEAP32[i14 >> 2] | 0;
  i12 = i1 + (i13 * 24 | 0) | 0;
  i3 = i13;
  i13 = i13 + 1 | 0;
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(HEAPF32[i15 >> 2]);
  f22 = Math_fround(HEAPF32[i16 >> 2]);
  i4 = HEAP32[i12 >> 2] | 0;
  i10 = i1 + (i3 * 24 | 0) + 4 | 0;
  i20 = HEAP32[i10 >> 2] | 0;
  i11 = i1 + (i3 * 24 | 0) + 8 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i8 = i1 + (i3 * 24 | 0) + 16 | 0;
  f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f24 = Math_fround(Math_fround(i4 & 255 | 0) * f30);
  f28 = Math_fround(Math_fround(i20 & 255 | 0) * f30);
  f30 = Math_fround(Math_fround(i2 & 255 | 0) * f30);
  f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
  f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f21);
  f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f22);
  f31 = Math_fround(f9 - f24);
  f29 = Math_fround(f21 - f28);
  f27 = Math_fround(f22 - f30);
  f24 = Math_fround(f9 + f24);
  f28 = Math_fround(f21 + f28);
  f30 = Math_fround(f22 + f30);
  i1 = f31 > Math_fround(-9999999940000000065998519.0e8);
  f31 = i1 ? f31 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f29 > Math_fround(-9999999940000000065998519.0e8);
  f29 = i1 ? f29 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f27 > Math_fround(-9999999940000000065998519.0e8);
  f27 = i1 ? f27 : Math_fround(-9999999940000000065998519.0e8);
  i1 = f24 < Math_fround(9999999940000000065998519.0e8);
  f24 = i1 ? f24 : Math_fround(9999999940000000065998519.0e8);
  i1 = f28 < Math_fround(9999999940000000065998519.0e8);
  f28 = i1 ? f28 : Math_fround(9999999940000000065998519.0e8);
  i1 = f30 < Math_fround(9999999940000000065998519.0e8);
  f30 = i1 ? f30 : Math_fround(9999999940000000065998519.0e8);
  f22 = Math_fround(Math_fround(f31 + f24) * Math_fround(.5));
  f21 = Math_fround(Math_fround(f29 + f28) * Math_fround(.5));
  f9 = Math_fround(Math_fround(f27 + f30) * Math_fround(.5));
  f31 = Math_fround(Math_fround(f24 - f31) * Math_fround(.5));
  f29 = Math_fround(Math_fround(f28 - f29) * Math_fround(.5));
  f27 = Math_fround(Math_fround(f30 - f27) * Math_fround(.5));
  f30 = Math_fround(f22 * Math_fround(.0000999999974));
  f28 = Math_fround(f21 * Math_fround(.0000999999974));
  f24 = Math_fround(f9 * Math_fround(.0000999999974));
  f26 = Math_fround(-f30);
  f25 = Math_fround(-f28);
  f23 = Math_fround(-f24);
  f26 = Math_fround(f31 + Math_fround((f30 > f26 ? f30 : f26) + Math_fround(.0000999999974)));
  f25 = Math_fround(f29 + Math_fround((f28 > f25 ? f28 : f25) + Math_fround(.0000999999974)));
  f23 = Math_fround(f27 + Math_fround((f24 > f23 ? f24 : f23) + Math_fround(.0000999999974)));
  f24 = f25 > f23 ? f25 : f23;
  f24 = Math_fround((f26 > f24 ? f26 : f24) * Math_fround(.00392158423));
  f27 = Math_fround(Math_fround(f24 + Math_fround(f24 * Math_fround(.0000999999974))) * Math_fround(1.0e4));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  f24 = Math_fround(Math_fround(1.0) / f24);
  i2 = ~~Math_fround(Math_fround(f24 * f26) + Math_fround(1.0));
  i3 = ~~Math_fround(Math_fround(f24 * f25) + Math_fround(1.0));
  i20 = ~~Math_fround(Math_fround(f24 * f23) + Math_fround(1.0));
  i4 = f22 == Math_fround(0.0);
  i5 = f21 == Math_fround(0.0);
  i19 = f9 == Math_fround(0.0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = i20 | (i19 ? 16777216 : (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) & -256);
  HEAP32[i12 >> 2] = i2 | (i4 ? 16777216 : i6 & -256);
  HEAP32[i10 >> 2] = i3 | (i5 ? 16777216 : i7 & -256);
  HEAP32[i11 >> 2] = i20;
  i20 = i8;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] & 255;
  i12 = _bitshift64Shl(i1 >>> 8 | 0, 0, 40) | 0;
  i20 = getTempRet0() | 0 | i20;
  i2 = i8;
  HEAP32[i2 >> 2] = i12 | i19;
  HEAP32[i2 + 4 >> 2] = i20;
  i2 = HEAP32[i17 >> 2] | 0;
 } while (i13 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx21PxcArticulationHelper16prepareDataBlockERNS_9PxcFsDataEPKNS_19PxsArticulationLinkEtPNS_11PxTransformEPNS_12PxcFsInertiaEPNS_30PxcArticulationJointTransformsEj(i12, i9, i5, i14, i8, i13, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i10 = i5 & 65535;
 i7 = (i10 << 4) + 128 + ((i10 << 2) + 60 & 524224) + (i10 << 6) | 0;
 i3 = i7 + (i10 << 5) | 0;
 _memset(i12 | 0, 0, i7 | 0) | 0;
 i6 = i12 + 10 | 0;
 HEAP16[i6 >> 1] = i7;
 HEAP16[i12 + 26 >> 1] = i3;
 HEAP16[i12 + 24 >> 1] = (i10 * 160 | 0) + 144 + i3;
 i3 = i12 + 8 | 0;
 HEAP16[i3 >> 1] = i5;
 i7 = (i5 & 65535) > 1;
 if (i7) {
  i2 = 1;
  do {
   HEAP8[i12 + 64 + i2 >> 0] = HEAP32[i9 + (i2 << 5) + 28 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
 }
 i4 = i12 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i4 = i12 + 48 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i4 = i12 + 128 | 0;
 _memset(i8 | 0, 0, i10 * 144 | 0) | 0;
 i3 = i4 + ((HEAPU16[i3 >> 1] | 0) * 80 | 0) | 0;
 if (i5 << 16 >> 16) {
  i2 = 0;
  do {
   i1 = HEAP32[i9 + (i2 << 5) + 20 >> 2] | 0;
   HEAP32[i14 + (i2 * 28 | 0) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i14 + (i2 * 28 | 0) + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   i18 = HEAP32[i1 + 68 >> 2] | 0;
   i17 = HEAP32[i1 + 72 >> 2] | 0;
   i16 = HEAP32[i1 + 80 >> 2] | 0;
   i15 = HEAP32[i1 + 84 >> 2] | 0;
   i5 = HEAP32[i1 + 88 >> 2] | 0;
   HEAP32[i4 + (i2 << 5) >> 2] = HEAP32[i1 + 64 >> 2];
   HEAP32[i4 + (i2 << 5) + 4 >> 2] = i18;
   HEAP32[i4 + (i2 << 5) + 8 >> 2] = i17;
   HEAPF32[i4 + (i2 << 5) + 12 >> 2] = Math_fround(0.0);
   HEAP32[i4 + (i2 << 5) + 16 >> 2] = i16;
   HEAP32[i4 + (i2 << 5) + 20 >> 2] = i15;
   HEAP32[i4 + (i2 << 5) + 24 >> 2] = i5;
   HEAPF32[i4 + (i2 << 5) + 28 >> 2] = Math_fround(0.0);
   __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE(i8 + (i2 * 144 | 0) | 0, i1, i1);
   HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i1 + 76 >> 2];
   if (i2 | 0) __ZN5physx21PxcArticulationHelper18setJointTransformsERNS_30PxcArticulationJointTransformsERKNS_11PxTransformES5_RKNS_24PxsArticulationJointCoreE(i13 + (i2 * 84 | 0) | 0, i14 + ((HEAP32[i9 + (i2 << 5) + 28 >> 2] | 0) * 28 | 0) | 0, i1, HEAP32[i9 + (i2 << 5) + 24 >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
 }
 i2 = i12 + (HEAPU16[i6 >> 1] | 0) | 0;
 if (i7) i1 = 1; else {
  STACKTOP = i11;
  return;
 }
 do {
  i15 = HEAPU8[i12 + 64 + i1 >> 0] | 0;
  i16 = i14 + (i1 * 28 | 0) + 16 | 0;
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  f19 = Math_fround(f19 - Math_fround(HEAPF32[i14 + (i15 * 28 | 0) + 16 >> 2]));
  i17 = i14 + (i1 * 28 | 0) + 20 | 0;
  f20 = Math_fround(HEAPF32[i17 >> 2]);
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i14 + (i15 * 28 | 0) + 20 >> 2]));
  i18 = i14 + (i1 * 28 | 0) + 24 | 0;
  f21 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i14 + (i15 * 28 | 0) + 24 >> 2]));
  HEAPF32[i2 + (i1 << 5) >> 2] = f19;
  HEAPF32[i2 + (i1 << 5) + 4 >> 2] = f20;
  HEAPF32[i2 + (i1 << 5) + 8 >> 2] = f21;
  f21 = Math_fround(HEAPF32[i13 + (i1 * 84 | 0) + 44 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i16 >> 2]));
  f20 = Math_fround(HEAPF32[i13 + (i1 * 84 | 0) + 48 >> 2]);
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i17 >> 2]));
  f19 = Math_fround(HEAPF32[i13 + (i1 * 84 | 0) + 52 >> 2]);
  f19 = Math_fround(f19 - Math_fround(HEAPF32[i18 >> 2]));
  HEAPF32[i2 + (i1 << 5) + 16 >> 2] = f21;
  HEAPF32[i2 + (i1 << 5) + 20 >> 2] = f20;
  HEAPF32[i2 + (i1 << 5) + 24 >> 2] = f19;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 STACKTOP = i11;
 return;
}

function __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i15, i16, i14, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0;
 f3 = Math_fround(HEAPF32[i16 >> 2]);
 i10 = i16 + 12 | 0;
 f11 = Math_fround(HEAPF32[i10 >> 2]);
 f17 = Math_fround(Math_fround(f3 + f11) * Math_fround(.5));
 f12 = Math_fround(HEAPF32[i15 >> 2]);
 i13 = i15 + 12 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 i7 = f17 < Math_fround(Math_fround(f12 + f2) * Math_fround(.5));
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 i8 = i14 + 12 | 0;
 i9 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5)) < f17;
 if (!i7) {
  if (!i9) {
   i16 = 0;
   return i16 | 0;
  }
  i1 = i16 + 4 | 0;
  i21 = HEAP32[i1 >> 2] | 0;
  i4 = i16 + 8 | 0;
  i20 = HEAP32[i4 >> 2] | 0;
  i5 = i16 + 16 | 0;
  i19 = HEAP32[i5 >> 2] | 0;
  i6 = i16 + 20 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i7 = i16 + 24 | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAPF32[i14 >> 2] = f3;
  HEAP32[i14 + 4 >> 2] = i21;
  HEAP32[i14 + 8 >> 2] = i20;
  HEAPF32[i14 + 12 >> 2] = f11;
  HEAP32[i14 + 16 >> 2] = i19;
  HEAP32[i14 + 20 >> 2] = i8;
  HEAP32[i14 + 24 >> 2] = i9;
  f18 = Math_fround(HEAPF32[i16 >> 2]);
  f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
  f3 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  if (!(f18 < Math_fround(Math_fround(f3 + f2) * Math_fround(.5)))) {
   i21 = 1;
   return i21 | 0;
  }
  i13 = HEAP32[i15 + 4 >> 2] | 0;
  i14 = HEAP32[i15 + 8 >> 2] | 0;
  i19 = HEAP32[i15 + 16 >> 2] | 0;
  i20 = HEAP32[i15 + 20 >> 2] | 0;
  i21 = HEAP32[i15 + 24 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP32[i15 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
  HEAPF32[i16 >> 2] = f3;
  HEAP32[i1 >> 2] = i13;
  HEAP32[i4 >> 2] = i14;
  HEAPF32[i16 + 12 >> 2] = f2;
  HEAP32[i5 >> 2] = i19;
  HEAP32[i6 >> 2] = i20;
  HEAP32[i7 >> 2] = i21;
  i21 = 2;
  return i21 | 0;
 }
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i4 = HEAP32[i15 + 8 >> 2] | 0;
 i5 = HEAP32[i15 + 16 >> 2] | 0;
 i6 = HEAP32[i15 + 20 >> 2] | 0;
 i7 = HEAP32[i15 + 24 >> 2] | 0;
 if (i9) {
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
  HEAP32[i15 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
  HEAPF32[i14 >> 2] = f12;
  HEAP32[i14 + 4 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i4;
  HEAPF32[i14 + 12 >> 2] = f2;
  HEAP32[i14 + 16 >> 2] = i5;
  HEAP32[i14 + 20 >> 2] = i6;
  HEAP32[i14 + 24 >> 2] = i7;
  i21 = 1;
  return i21 | 0;
 };
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAPF32[i16 >> 2] = f12;
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = i4;
 HEAPF32[i16 + 12 >> 2] = f2;
 HEAP32[i16 + 16 >> 2] = i5;
 HEAP32[i16 + 20 >> 2] = i6;
 HEAP32[i16 + 24 >> 2] = i7;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5)) < Math_fround(Math_fround(f12 + f2) * Math_fround(.5)))) {
  i21 = 1;
  return i21 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAPF32[i14 >> 2] = f12;
 HEAP32[i14 + 4 >> 2] = i1;
 HEAP32[i14 + 8 >> 2] = i4;
 HEAPF32[i14 + 12 >> 2] = f2;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = i6;
 HEAP32[i14 + 24 >> 2] = i7;
 i21 = 2;
 return i21 | 0;
}

function __ZN5physx23PxsBroadPhaseContextSap11batchCreateEv(i33) {
 i33 = i33 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i34 + 540 | 0;
 i32 = i34 + 396 | 0;
 i29 = i34 + 264 | 0;
 i27 = i34 + 132 | 0;
 i26 = i34;
 i31 = i34 + 528 | 0;
 i20 = i33 + 80 | 0;
 i21 = HEAP32[i20 >> 2] | 0;
 if (!i21) {
  STACKTOP = i34;
  return;
 }
 i22 = HEAP32[i33 + 76 >> 2] | 0;
 i23 = HEAP32[i33 + 100 >> 2] | 0;
 i24 = i21 << 1;
 i28 = i32 + 128 | 0;
 i2 = i24 >>> 0 < 33;
 if (i2) i1 = i32; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i21 << 3, gb + 716893 | 0, 39) | 0;
 HEAP32[i28 >> 2] = i1;
 i25 = i29 + 128 | 0;
 if (i2) i1 = i29; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i21 << 3, gb + 716893 | 0, 39) | 0;
 HEAP32[i25 >> 2] = i1;
 i19 = i27 + 128 | 0;
 if (i2) i1 = i27; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i21 << 3, gb + 716893 | 0, 39) | 0;
 HEAP32[i19 >> 2] = i1;
 i18 = i26 + 128 | 0;
 if (i2) i17 = i26; else {
  i17 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i30, i21 << 3, gb + 716893 | 0, 39) | 0;
  i1 = HEAP32[i19 >> 2] | 0;
 }
 HEAP32[i18 >> 2] = i17;
 i10 = HEAP32[i28 >> 2] | 0;
 i11 = HEAP32[i25 >> 2] | 0;
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i30);
 i12 = (i24 | 0) == 0;
 i13 = i33 + 168 | 0;
 i14 = i24 + -1 | 0;
 i15 = i21 << 1;
 i16 = 0;
 do {
  i2 = i16 + 3 | 0;
  i3 = 0;
  do {
   i8 = HEAP32[i22 + (i3 << 2) >> 2] | 0;
   i7 = HEAP32[i23 + (i8 * 24 | 0) + (i2 << 2) >> 2] | 0;
   i9 = i3 << 1;
   HEAP32[i10 + (i9 << 2) >> 2] = HEAP32[i23 + (i8 * 24 | 0) + (i16 << 2) >> 2];
   i8 = i8 << 1;
   HEAP32[i1 + (i9 << 2) >> 2] = i8;
   i9 = i9 | 1;
   HEAP32[i10 + (i9 << 2) >> 2] = i7;
   HEAP32[i1 + (i9 << 2) >> 2] = i8 | 1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i21 | 0));
  if (i12) __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i30, i11, i24, 1) | 0; else {
   i2 = 0;
   do {
    HEAP32[i11 + (i2 << 2) >> 2] = HEAP32[i10 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i15 | 0));
   i2 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i30, i11, i24, 1) | 0) + 8 >> 2] | 0;
   if (!i12) {
    i3 = 0;
    do {
     i9 = i2 + (i14 - i3 << 2) | 0;
     HEAP32[i11 + (i3 << 2) >> 2] = HEAP32[i10 + (HEAP32[i9 >> 2] << 2) >> 2];
     HEAP32[i17 + (i3 << 2) >> 2] = HEAP32[i1 + (HEAP32[i9 >> 2] << 2) >> 2];
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i15 | 0));
   }
  }
  i7 = HEAP32[i33 + 124 + (i16 << 2) >> 2] | 0;
  i8 = HEAP32[i33 + 136 + (i16 << 2) >> 2] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) << 1;
  i9 = HEAP32[i33 + 112 + (i16 << 2) >> 2] | 0;
  i4 = i2 + i24 | 0;
  i5 = i2 | 1;
  i6 = i4 | 1;
  HEAP32[i7 + (i6 << 2) >> 2] = HEAP32[i7 + (i5 << 2) >> 2];
  HEAP32[i8 + (i6 << 2) >> 2] = HEAP32[i8 + (i5 << 2) >> 2];
  L33 : do if ((i2 | 0) >= 0) {
   i5 = 0;
   i3 = i8 + (i2 << 2) | 0;
   i6 = i7 + (i2 << 2) | 0;
   i2 = i4;
   while (1) {
    i4 = i5;
    while (1) {
     i35 = i17 + (i4 << 2) | 0;
     i36 = HEAP32[i6 >> 2] | 0;
     i37 = HEAP32[i11 + (i4 << 2) >> 2] | 0;
     i5 = HEAP32[i35 >> 2] & 1 | 0 ? i36 >>> 0 <= i37 >>> 0 : i36 >>> 0 < i37 >>> 0;
     i35 = i5 ? i35 : i3;
     HEAP32[i7 + (i2 << 2) >> 2] = i5 ? i37 : i36;
     HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i35 >> 2];
     i35 = HEAP32[i35 >> 2] | 0;
     HEAP32[i9 + (i35 >>> 1 << 3) + ((i35 & 1) << 2) >> 2] = i2;
     i2 = i2 + -1 | 0;
     if (!i5) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i24 >>> 0) break L33;
    }
    i3 = i3 + -4 | 0;
    if (i3 >>> 0 < i8 >>> 0) break; else {
     i5 = i4;
     i6 = i6 + -4 | 0;
    }
   }
  } while (0);
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) != 3);
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i30);
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (i26 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, i1);
 i1 = HEAP32[i19 >> 2] | 0;
 if ((i1 | 0) != (i27 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, i1);
 i1 = HEAP32[i25 >> 2] | 0;
 if ((i1 | 0) != (i29 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, i1);
 i1 = HEAP32[i28 >> 2] | 0;
 if ((i1 | 0) != (i32 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i30, i1);
 HEAP32[i31 >> 2] = 0;
 HEAP32[i31 + 4 >> 2] = 1;
 HEAP32[i31 + 8 >> 2] = 2;
 __ZN5physx23PxsBroadPhaseContextSap17performBoxPruningENS_2Gu4AxesE(i33, i31);
 STACKTOP = i34;
 return;
}

function __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_(i28, i29, i22, i15, i8, i1) {
 i28 = i28 | 0;
 i29 = i29 | 0;
 i22 = i22 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, f31 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30;
 i23 = __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_(i28, i29, i22, i15, i1) | 0;
 f31 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 i7 = i15 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i7 >> 2]))) {
  i29 = i23;
  STACKTOP = i30;
  return i29 | 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 i10 = i15 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 20 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i9 = i15 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i24 = i15;
 i25 = i8;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = i6;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i22 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i1 >> 2]))) {
  i29 = i23 + 1 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i2 = HEAP32[i22 >> 2] | 0;
 i17 = i22 + 4 | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i18 = i22 + 8 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i19 = i22 + 12 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i20 = i22 + 16 | 0;
 i6 = HEAP32[i20 >> 2] | 0;
 i21 = i22 + 20 | 0;
 i7 = HEAP32[i21 >> 2] | 0;
 i16 = i22 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 i24 = i22;
 i25 = i15;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i15 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i9 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i29 + 28 | 0;
 if (!(f31 < Math_fround(HEAPF32[i1 >> 2]))) {
  i29 = i23 + 2 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i2 = HEAP32[i29 >> 2] | 0;
 i9 = i29 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i29 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i29 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i29 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i29 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i29 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i24 = i29;
 i25 = i22;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i22 >> 2] = i2;
 HEAP32[i17 >> 2] = i3;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i19 >> 2] = i5;
 HEAP32[i20 >> 2] = i6;
 HEAP32[i21 >> 2] = i7;
 HEAP32[i16 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f31 < Math_fround(HEAPF32[i28 + 28 >> 2]))) {
  i29 = i23 + 3 | 0;
  STACKTOP = i30;
  return i29 | 0;
 }
 i1 = HEAP32[i28 >> 2] | 0;
 i2 = HEAP32[i28 + 4 >> 2] | 0;
 i3 = HEAP32[i28 + 8 >> 2] | 0;
 i4 = HEAP32[i28 + 12 >> 2] | 0;
 i5 = HEAP32[i28 + 16 >> 2] | 0;
 i6 = HEAP32[i28 + 20 >> 2] | 0;
 i24 = i28 + 24 | 0;
 HEAP32[i27 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i27 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i24 = i28;
 i25 = i29;
 i26 = i24 + 36 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i29 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i27 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i27 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i27 + 8 >> 2];
 i29 = i23 + 4 | 0;
 STACKTOP = i30;
 return i29 | 0;
}

function __ZN5physx3Scb5Scene20processPendingRemoveEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 2576 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i1 = i9 + 2544 | 0;
  i2 = 0;
  do {
   __ZN5physx3Scb11RigidObject19processShapeRemovesEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 i8 = i9 + 2616 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i1 = i9 + 2584 | 0;
  i2 = 0;
  do {
   __ZN5physx3Scb11RigidObject19processShapeRemovesEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 i6 = i9 + 2696 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i5 = i9 + 2664 | 0;
  i3 = i9 + 16 | 0;
  i4 = 0;
  do {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i2 = i1 + 4 | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 > 3221225471) {
    __ZN5physx2Sc5Scene16removeConstraintERNS0_14ConstraintCoreE(i3, i1 + 12 | 0);
    if (!(HEAP32[i2 >> 2] & 268435456)) __ZN5physx3Scb10Constraint9syncStateEv(i1);
   }
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  i4 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i3 = 0;
   do {
    i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    if ((HEAP32[i2 + 4 >> 2] & 268435457 | 0) == 268435457) {
     __ZN5physx2Sc14ConstraintCore19prepareForSetBodiesEv(i2 + 12 | 0);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
 }
 i4 = i9 + 2776 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i9 + 2744 | 0;
  i6 = i9 + 16 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 > 3221225471) {
    __ZN5physx2Sc5Scene23removeArticulationJointERNS0_21ArticulationJointCoreE(i6, i2 + 12 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i5 = i9 + 2544 | 0;
  i6 = i9 + 16 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3 >>> 0 > 3221225471) {
    __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6removeERNS0_2Sc5SceneERS2_b(i6, i2, (i3 & 16 | 0) != 0);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 if (HEAP32[i8 >> 2] | 0) {
  i1 = i9 + 2584 | 0;
  i2 = i9 + 16 | 0;
  i6 = 0;
  do {
   i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i4 = i3 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 >>> 0 > 3221225471) {
    __ZN10ScSceneFnsIN5physx3Scb4BodyEE6removeERNS0_2Sc5SceneERS2_b(i2, i3, (i5 & 16 | 0) != 0);
    if (!(HEAP32[i4 >> 2] & 268435456)) __ZN5physx3Scb4Body9syncStateEv(i3);
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 i6 = i9 + 2736 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i1 = i9 + 2704 | 0;
  i2 = i9 + 16 | 0;
  i7 = 0;
  do {
   i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   i4 = i3 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 >>> 0 > 3221225471) {
    HEAP32[i4 >> 2] = i5 & -769;
    __ZN5physx2Sc5Scene18removeArticulationERNS0_16ArticulationCoreE(i2, i3 + 12 | 0);
    if (!(HEAP32[i4 >> 2] & 268435456)) __ZN5physx3Scb12Articulation9syncStateEv(i3);
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i5 = i9 + 2656 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i9 + 2624 | 0;
  i7 = i9 + 16 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3 >>> 0 > 3221225471) {
    __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb(i7, i2 + 12 | 0, (i3 & 536870912 | 0) != 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i4 = i9 + 2856 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i9 + 2824 | 0;
  i6 = i9 + 16 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 > 3221225471) {
    __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE(i6, i2 + 12 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i4 = i9 + 2816 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i5 = i9 + 2784 | 0;
 i6 = i9 + 16 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 > 3221225471) {
   __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE(i2, i9);
   __ZN5physx2Sc5Scene15deleteAggregateEj(i6, HEAP32[i2 + 16 >> 2] | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return;
}

function __ZN9ShaderLab32FindBestMatchingShaderKeywordSetERK16ShaderKeywordSetRK13dynamic_arrayIS0_Lj4EEPS5_(i2, i1, i34) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i34 = i34 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0;
 i35 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i35) {
  i35 = -1;
  return i35 | 0;
 }
 i31 = HEAP32[i1 >> 2] | 0;
 i32 = HEAP32[i2 >> 2] | 0;
 i33 = ~i32;
 i19 = HEAP32[i2 + 4 >> 2] | 0;
 i20 = ~i19;
 i21 = HEAP32[i2 + 8 >> 2] | 0;
 i22 = ~i21;
 i23 = HEAP32[i2 + 12 >> 2] | 0;
 i24 = ~i23;
 i25 = HEAP32[i2 + 16 >> 2] | 0;
 i26 = ~i25;
 i27 = HEAP32[i2 + 20 >> 2] | 0;
 i28 = ~i27;
 i29 = HEAP32[i2 + 24 >> 2] | 0;
 i30 = ~i29;
 i15 = HEAP32[i2 + 28 >> 2] | 0;
 i16 = ~i15;
 i17 = (i34 | 0) == 0;
 i18 = i34 + 12 | 0;
 i1 = -1;
 i2 = -2147483648;
 i14 = 0;
 do {
  i5 = HEAP32[i31 + (i14 << 5) >> 2] | 0;
  i4 = i32 & i5;
  i41 = i5 & i33;
  i6 = HEAP32[i31 + (i14 << 5) + 4 >> 2] | 0;
  i46 = i19 & i6;
  i42 = i6 & i20;
  i7 = HEAP32[i31 + (i14 << 5) + 8 >> 2] | 0;
  i49 = i21 & i7;
  i45 = i7 & i22;
  i8 = HEAP32[i31 + (i14 << 5) + 12 >> 2] | 0;
  i37 = i23 & i8;
  i13 = i8 & i24;
  i9 = HEAP32[i31 + (i14 << 5) + 16 >> 2] | 0;
  i48 = i25 & i9;
  i44 = i9 & i26;
  i10 = HEAP32[i31 + (i14 << 5) + 20 >> 2] | 0;
  i39 = i27 & i10;
  i3 = i10 & i28;
  i11 = HEAP32[i31 + (i14 << 5) + 24 >> 2] | 0;
  i47 = i29 & i11;
  i43 = i11 & i30;
  i12 = HEAP32[i31 + (i14 << 5) + 28 >> 2] | 0;
  i40 = i15 & i12;
  i36 = i12 & i16;
  i38 = i46 & i4;
  i4 = i46 ^ i4;
  i46 = i49 ^ i4;
  i4 = i37 & i46 | i49 & i4;
  i46 = i37 ^ i46;
  i37 = i4 & i38;
  i38 = i4 ^ i38;
  i37 = i37 - (i37 >>> 1 & 1431655765) | 0;
  i37 = (i37 >>> 2 & 858993459) + (i37 & 858993459) | 0;
  i4 = i48 ^ i46;
  i46 = i39 & i4 | i48 & i46;
  i4 = i39 ^ i4;
  i39 = i47 ^ i4;
  i4 = i40 & i39 | i47 & i4;
  i39 = i40 ^ i39;
  i40 = i46 ^ i38;
  i38 = i4 & i40 | i46 & i38;
  i40 = i4 ^ i40;
  i38 = i38 - (i38 >>> 1 & 1431655765) | 0;
  i38 = (i38 >>> 2 & 858993459) + (i38 & 858993459) | 0;
  i40 = i40 - (i40 >>> 1 & 1431655765) | 0;
  i40 = (i40 >>> 2 & 858993459) + (i40 & 858993459) | 0;
  i39 = i39 - (i39 >>> 1 & 1431655765) | 0;
  i39 = (i39 >>> 2 & 858993459) + (i39 & 858993459) | 0;
  i4 = i42 & i41;
  i41 = i42 ^ i41;
  i42 = i45 ^ i41;
  i41 = i13 & i42 | i45 & i41;
  i42 = i13 ^ i42;
  i13 = i41 & i4;
  i4 = i41 ^ i4;
  i13 = i13 - (i13 >>> 1 & 1431655765) | 0;
  i13 = (i13 >>> 2 & 858993459) + (i13 & 858993459) | 0;
  i41 = i44 ^ i42;
  i42 = i3 & i41 | i44 & i42;
  i41 = i3 ^ i41;
  i3 = i43 ^ i41;
  i41 = i36 & i3 | i43 & i41;
  i3 = i36 ^ i3;
  i36 = i42 ^ i4;
  i4 = i41 & i36 | i42 & i4;
  i36 = i41 ^ i36;
  i4 = i4 - (i4 >>> 1 & 1431655765) | 0;
  i4 = (i4 >>> 2 & 858993459) + (i4 & 858993459) | 0;
  i36 = i36 - (i36 >>> 1 & 1431655765) | 0;
  i36 = (i36 >>> 2 & 858993459) + (i36 & 858993459) | 0;
  i3 = i3 - (i3 >>> 1 & 1431655765) | 0;
  i3 = (i3 >>> 2 & 858993459) + (i3 & 858993459) | 0;
  i13 = ((Math_imul((i40 >>> 4) + i40 & 252645135, 16843009) | 0) >>> 24 << 1) + ((Math_imul((i39 >>> 4) + i39 & 252645135, 16843009) | 0) >>> 24) + (((Math_imul((i38 >>> 4) + i38 & 252645135, 16843009) | 0) >>> 24) + ((Math_imul((i37 >>> 4) + i37 & 252645135, 16843009) | 0) >>> 24) << 2) - (((Math_imul((i36 >>> 4) + i36 & 252645135, 16843009) | 0) >>> 24 << 1) + ((Math_imul((i3 >>> 4) + i3 & 252645135, 16843009) | 0) >>> 24) + (((Math_imul((i4 >>> 4) + i4 & 252645135, 16843009) | 0) >>> 24) + ((Math_imul((i13 >>> 4) + i13 & 252645135, 16843009) | 0) >>> 24) << 2) << 4) | 0;
  if ((i13 | 0) > (i2 | 0)) {
   if (i17) i3 = 0; else {
    i3 = HEAP32[i18 >> 2] | 0;
    if (!i3) i3 = 0; else {
     i49 = HEAP32[i34 >> 2] | 0;
     i4 = i49 + (i3 << 5) | 0;
     i3 = i49;
     while (1) {
      if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i3 + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + 8 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) == (i9 | 0)) if ((HEAP32[i3 + 20 >> 2] | 0) == (i10 | 0)) if ((HEAP32[i3 + 24 >> 2] | 0) == (i11 | 0)) if ((HEAP32[i3 + 28 >> 2] | 0) == (i12 | 0)) break;
      i3 = i3 + 32 | 0;
      if ((i3 | 0) == (i4 | 0)) {
       i3 = i4;
       break;
      }
     }
     i3 = (i3 | 0) != (i4 | 0);
    }
   }
   i1 = i3 ? i1 : i14;
   i2 = i3 ? i2 : i13;
  }
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != (i35 | 0));
 return i1 | 0;
}

function __ZN15MBP_PairManager17removeMarkedPairsEPK10MBP_ObjectPN5physx16PxsBroadPhaseMBPERK8BitArrayS8_(i30, i26, i1, i28, i27) {
 i30 = i30 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i31 + 8 | 0;
 i13 = i31;
 i20 = i30 + 8 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i21 = i30 + 20 | 0;
  i22 = i28 + 4 | 0;
  i23 = i1 + 120 | 0;
  i24 = i1 + 96 | 0;
  i25 = i12 + 4 | 0;
  i14 = i1 + 104 | 0;
  i15 = i1 + 100 | 0;
  i16 = i27 + 4 | 0;
  i17 = i1 + 108 | 0;
  i18 = i13 + 4 | 0;
  i19 = i1 + 116 | 0;
  i10 = i1 + 112 | 0;
  i11 = i30 + 4 | 0;
  i1 = 0;
  do {
   L5 : while (1) {
    i6 = HEAP32[i21 >> 2] | 0;
    i4 = i6 + (i1 * 12 | 0) | 0;
    i5 = i6 + (i1 * 12 | 0) + 8 | 0;
    do if (!(HEAP8[i5 >> 0] | 0)) {
     i3 = i6 + (i1 * 12 | 0) + 9 | 0;
     if (HEAP8[i3 >> 0] | 0) {
      HEAP8[i3 >> 0] = 0;
      break;
     }
     i7 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] | 0;
     i8 = i7 >>> 2;
     i9 = i6 >>> 2;
     i3 = i7 >>> 7;
     i4 = HEAP32[i22 >> 2] | 0;
     if (i3 >>> 0 < i4 >>> 0) if (HEAP32[(HEAP32[i28 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i8 & 31) | 0) {
      i5 = i9;
      break L5;
     }
     i5 = i6 >>> 7;
     if (i5 >>> 0 < i4 >>> 0) if (HEAP32[(HEAP32[i28 >> 2] | 0) + (i5 << 2) >> 2] & 1 << (i9 & 31) | 0) {
      i5 = i9;
      break L5;
     }
    } else {
     i3 = HEAP32[i26 + (((HEAP32[i4 >> 2] | 0) >>> 2) * 12 | 0) >> 2] | 0;
     i4 = HEAP32[i26 + (((HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] | 0) >>> 2) * 12 | 0) >> 2] | 0;
     i9 = HEAP32[i23 >> 2] | 0;
     do if ((HEAP32[i9 + (i3 << 2) >> 2] | 0) != (HEAP32[i9 + (i4 << 2) >> 2] | 0)) {
      i9 = i3 >>> 0 < i4 >>> 0;
      HEAP32[i12 >> 2] = i9 ? i3 : i4;
      HEAP32[i25 >> 2] = i9 ? i4 : i3;
      i3 = HEAP32[i15 >> 2] | 0;
      if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       i7 = i12;
       i8 = HEAP32[i7 + 4 >> 2] | 0;
       i9 = (HEAP32[i24 >> 2] | 0) + (i3 << 3) | 0;
       HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i9 + 4 >> 2] = i8;
       HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i24, i12) | 0;
       break;
      }
     } while (0);
     HEAP8[i5 >> 0] = 0;
     HEAP8[i6 + (i1 * 12 | 0) + 9 >> 0] = 0;
    } while (0);
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
   }
   i4 = HEAP32[i16 >> 2] | 0;
   if (i3 >>> 0 < i4 >>> 0) {
    if (!(HEAP32[(HEAP32[i27 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i8 & 31))) i29 = 19;
   } else i29 = 19;
   do if ((i29 | 0) == 19) {
    i29 = 0;
    i3 = i6 >>> 7;
    if (i3 >>> 0 < i4 >>> 0) if (HEAP32[(HEAP32[i27 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i5 & 31) | 0) break;
    i4 = HEAP32[i26 + (i8 * 12 | 0) >> 2] | 0;
    i3 = HEAP32[i26 + (i5 * 12 | 0) >> 2] | 0;
    i9 = HEAP32[i23 >> 2] | 0;
    if ((HEAP32[i9 + (i4 << 2) >> 2] | 0) != (HEAP32[i9 + (i3 << 2) >> 2] | 0)) {
     i9 = i4 >>> 0 < i3 >>> 0;
     HEAP32[i13 >> 2] = i9 ? i4 : i3;
     HEAP32[i18 >> 2] = i9 ? i3 : i4;
     i3 = HEAP32[i10 >> 2] | 0;
     if ((HEAP32[i19 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
      i5 = i13;
      i8 = HEAP32[i5 + 4 >> 2] | 0;
      i9 = (HEAP32[i17 >> 2] | 0) + (i3 << 3) | 0;
      HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i9 + 4 >> 2] = i8;
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i17, i13) | 0;
      break;
     }
    }
   } while (0);
   i9 = i6 << 16 | i7 & 65535;
   i9 = i9 + ~(i9 << 15) | 0;
   i9 = (i9 >> 10 ^ i9) * 9 | 0;
   i9 = i9 >> 6 ^ i9;
   i9 = i9 + ~(i9 << 11) | 0;
   __ZN15MBP_PairManager10removePairEjjjj(i30, 0, 0, HEAP32[i11 >> 2] & (i9 >> 16 ^ i9), i1);
   i2 = i2 + -1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 } while (0);
 i1 = HEAP32[i20 >> 2] | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 16 | i1;
 i2 = i1 + 1 | 0;
 if ((HEAP32[i30 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i31;
  return 1;
 }
 if (i2 >>> 0 < (HEAP32[i30 + 24 >> 2] | 0) >>> 0) {
  STACKTOP = i31;
  return 1;
 }
 HEAP32[i30 >> 2] = i2;
 HEAP32[i30 + 4 >> 2] = i1;
 __ZN15MBP_PairManager12reallocPairsEv(i30);
 STACKTOP = i31;
 return 1;
}

function _UNITY_png_write_sPLT(i22, i8) {
 i22 = i22 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 96 | 0;
 i7 = i25 + 16 | 0;
 i24 = i25;
 i19 = i8 + 4 | 0;
 i20 = (HEAP8[i19 >> 0] | 0) == 8 ? 6 : 10;
 i21 = i8 + 12 | 0;
 i6 = HEAP32[i21 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  HEAP8[i7 >> 0] = 0;
  _UNITY_png_error(i22, gb + 355532 | 0);
 }
 i4 = HEAP8[i3 >> 0] | 0;
 L5 : do if (!(i4 << 24 >> 24)) {
  i3 = 1;
  i2 = 0;
  i1 = i7;
 } else {
  i5 = 1;
  i2 = 0;
  i1 = i7;
  while (1) {
   L8 : do if (!i5) {
    i18 = (i4 & 255) > 160 | (i4 + -33 & 255) < 94;
    i5 = i18 & 1 ^ 1;
    i3 = i3 + 1 | 0;
    i4 = i18 ? i4 : 32;
   } else while (1) {
    i3 = i3 + 1 | 0;
    if ((i4 & 255) > 160 | (i4 + -33 & 255) < 94) {
     i5 = 0;
     break L8;
    }
    i4 = HEAP8[i3 >> 0] | 0;
    if (!(i4 << 24 >> 24)) {
     i3 = i5;
     break L5;
    }
   } while (0);
   HEAP8[i1 >> 0] = i4;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   if (!(i2 >>> 0 < 79 & i4 << 24 >> 24 != 0)) {
    i3 = i5;
    break;
   }
  }
 } while (0);
 i18 = (i2 | 0) != 0 & (i3 | 0) != 0;
 i2 = (i18 << 31 >> 31) + i2 | 0;
 HEAP8[(i18 ? i1 + -1 | 0 : i1) >> 0] = 0;
 if (!i2) _UNITY_png_error(i22, gb + 355532 | 0);
 i1 = (Math_imul(i20, i6) | 0) + 2 + i2 | 0;
 i18 = (i22 | 0) == 0;
 if (i18) i2 = 0; else {
  i17 = i22 + 656 | 0;
  HEAP32[i17 >> 2] = 34;
  HEAP8[i23 >> 0] = i1 >>> 24;
  HEAP8[i23 + 1 >> 0] = i1 >>> 16;
  HEAP8[i23 + 2 >> 0] = i1 >>> 8;
  HEAP8[i23 + 3 >> 0] = i1;
  i1 = i23 + 4 | 0;
  HEAP8[i1 >> 0] = 115;
  HEAP8[i23 + 5 >> 0] = 80;
  HEAP8[i23 + 6 >> 0] = 76;
  HEAP8[i23 + 7 >> 0] = 84;
  _UNITY_png_write_data(i22, i23, 8);
  HEAP32[i22 + 372 >> 2] = 1934642260;
  _UNITY_png_reset_crc(i22);
  _UNITY_png_calculate_crc(i22, i1, 4);
  HEAP32[i17 >> 2] = 66;
  i1 = i2 + 1 | 0;
  if (i1 | 0) {
   _UNITY_png_write_data(i22, i7, i1);
   _UNITY_png_calculate_crc(i22, i7, i1);
  }
  _UNITY_png_write_data(i22, i19, 1);
  _UNITY_png_calculate_crc(i22, i19, 1);
  i2 = 1;
 }
 i7 = i8 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 L25 : do if ((i3 | 0) > 0) {
  i9 = i24 + 1 | 0;
  i10 = i24 + 2 | 0;
  i11 = i24 + 3 | 0;
  i12 = i24 + 4 | 0;
  i13 = i24 + 5 | 0;
  i14 = i24 + 6 | 0;
  i15 = i24 + 7 | 0;
  i16 = i24 + 8 | 0;
  i17 = i24 + 9 | 0;
  if (i2) while (1) {
   i2 = HEAP16[i1 >> 1] | 0;
   i3 = HEAP16[i1 + 2 >> 1] | 0;
   i4 = HEAP16[i1 + 4 >> 1] | 0;
   i5 = HEAP16[i1 + 6 >> 1] | 0;
   i6 = HEAP16[i1 + 8 >> 1] | 0;
   if ((HEAP8[i19 >> 0] | 0) == 8) {
    HEAP8[i24 >> 0] = i2;
    HEAP8[i9 >> 0] = i3;
    HEAP8[i10 >> 0] = i4;
    HEAP8[i11 >> 0] = i5;
    HEAP8[i12 >> 0] = (i6 & 65535) >>> 8;
    HEAP8[i13 >> 0] = i6;
   } else {
    HEAP8[i24 >> 0] = (i2 & 65535) >>> 8;
    HEAP8[i9 >> 0] = i2;
    HEAP8[i10 >> 0] = (i3 & 65535) >>> 8;
    HEAP8[i11 >> 0] = i3;
    HEAP8[i12 >> 0] = (i4 & 65535) >>> 8;
    HEAP8[i13 >> 0] = i4;
    HEAP8[i14 >> 0] = (i5 & 65535) >>> 8;
    HEAP8[i15 >> 0] = i5;
    HEAP8[i16 >> 0] = (i6 & 65535) >>> 8;
    HEAP8[i17 >> 0] = i6;
   }
   _UNITY_png_write_data(i22, i24, i20);
   _UNITY_png_calculate_crc(i22, i24, i20);
   i1 = i1 + 10 | 0;
   if (i1 >>> 0 >= ((HEAP32[i7 >> 2] | 0) + ((HEAP32[i21 >> 2] | 0) * 10 | 0) | 0) >>> 0) break L25;
  }
  i8 = (HEAP8[i19 >> 0] | 0) == 8;
  i7 = i1 + (i3 * 10 | 0) | 0;
  do {
   i2 = HEAP16[i1 >> 1] | 0;
   i3 = HEAP16[i1 + 2 >> 1] | 0;
   i4 = HEAP16[i1 + 4 >> 1] | 0;
   i5 = HEAP16[i1 + 6 >> 1] | 0;
   i6 = HEAP16[i1 + 8 >> 1] | 0;
   if (i8) {
    HEAP8[i24 >> 0] = i2;
    HEAP8[i9 >> 0] = i3;
    HEAP8[i10 >> 0] = i4;
    HEAP8[i11 >> 0] = i5;
    HEAP8[i12 >> 0] = (i6 & 65535) >>> 8;
    HEAP8[i13 >> 0] = i6;
   } else {
    HEAP8[i24 >> 0] = (i2 & 65535) >>> 8;
    HEAP8[i9 >> 0] = i2;
    HEAP8[i10 >> 0] = (i3 & 65535) >>> 8;
    HEAP8[i11 >> 0] = i3;
    HEAP8[i12 >> 0] = (i4 & 65535) >>> 8;
    HEAP8[i13 >> 0] = i4;
    HEAP8[i14 >> 0] = (i5 & 65535) >>> 8;
    HEAP8[i15 >> 0] = i5;
    HEAP8[i16 >> 0] = (i6 & 65535) >>> 8;
    HEAP8[i17 >> 0] = i6;
   }
   i1 = i1 + 10 | 0;
  } while (i1 >>> 0 < i7 >>> 0);
 } while (0);
 if (i18) {
  STACKTOP = i25;
  return;
 }
 HEAP32[i22 + 656 >> 2] = 130;
 i24 = HEAP32[i22 + 408 >> 2] | 0;
 HEAP8[i23 >> 0] = i24 >>> 24;
 HEAP8[i23 + 1 >> 0] = i24 >>> 16;
 HEAP8[i23 + 2 >> 0] = i24 >>> 8;
 HEAP8[i23 + 3 >> 0] = i24;
 _UNITY_png_write_data(i22, i23, 4);
 STACKTOP = i25;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer21GetJsonArrayDataBlockEjRK8UnityStrS4_RS2_Pj(i2, i3, i1, i5, i12, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 152 | 0;
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAP32[i4 >> 2] = 0;
 if (!i3) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = gb + 77468 + 12;
 i10 = i14 + 56 | 0;
 HEAP32[i10 >> 2] = gb + 77468 + 32;
 __ZNSt3__28ios_base4initEPv(i14 + 56 | 0, i9);
 HEAP32[i14 + 128 >> 2] = 0;
 HEAP32[i14 + 132 >> 2] = -1;
 HEAP32[i14 >> 2] = gb + 77508 + 12;
 HEAP32[i14 + 56 >> 2] = gb + 77508 + 32;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i9);
 HEAP32[i9 >> 2] = gb + 77548 + 8;
 i11 = i14 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i14 + 52 >> 2] = 16;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i9, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, gb + 1046777 | 0, 1) | 0;
 i1 = __ZN11UnityEngine15CloudWebService16SessionContainer25GetSessionHeaderJsonArrayERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i1, i14) | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i7 = __ZN11UnityEngine15CloudWebService17SessionEventQueue20GetEventsAsJsonArrayEjR8UnityStrPj(i2 + 68 | 0, i3, i15, i4) | 0;
 i8 = i15 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 if ((i6 << 24 >> 24 < 0 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255) | 0) {
  if (i1) __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, gb + 1087585 | 0, 1) | 0;
  __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, gb + 1046779 | 0, 1) | 0;
  i6 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i6, _strlen(i6) | 0) | 0;
  __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, gb + 1046923 | 0, 2) | 0;
  i6 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15;
  __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i6, _strlen(i6) | 0) | 0;
 }
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, gb + 1046932 | 0, 1) | 0;
 __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i13, i9);
 i5 = HEAP8[i13 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i4 = i6 ? HEAP32[i13 >> 2] | 0 : i13;
 i5 = i6 ? HEAP32[i13 + 4 >> 2] | 0 : i5 & 255;
 i6 = i12 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i6 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i6, 0, i6, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i12 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 }
 HEAP32[i14 >> 2] = gb + 77508 + 12;
 HEAP32[i10 >> 2] = gb + 77508 + 32;
 HEAP32[i9 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i9);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i14, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i10);
 i15 = i7;
 STACKTOP = i16;
 return i15 | 0;
}

function _UNITY_png_read_end(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i1) return;
 if (!(_UNITY_png_chunk_unknown_handling(i1, 1229209940) | 0)) _UNITY_png_read_finish_IDAT(i1);
 if ((HEAP8[i1 + 431 >> 0] | 0) == 3) if ((HEAP32[i1 + 420 >> 2] | 0) > (HEAPU16[i1 + 416 >> 1] | 0)) _UNITY_png_benign_error(i1, gb + 353795 | 0);
 i3 = i1 + 372 | 0;
 i4 = (i2 | 0) == 0;
 i5 = i1 + 204 | 0;
 do {
  i6 = _UNITY_png_read_chunk_header(i1) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  L13 : do if ((i7 | 0) < 1229472850) {
   switch (i7 | 0) {
   case 1229278788:
    break;
   default:
    {
     i10 = 11;
     break L13;
    }
   }
   _UNITY_png_handle_IEND(i1, i2, i6);
  } else {
   switch (i7 | 0) {
   case 1229472850:
    break;
   default:
    {
     i10 = 11;
     break L13;
    }
   }
   _UNITY_png_handle_IHDR(i1, i2, i6);
  } while (0);
  L18 : do if ((i10 | 0) == 11) {
   i10 = 0;
   if (i4) {
    _UNITY_png_crc_finish(i1, i6) | 0;
    break;
   }
   i8 = _UNITY_png_chunk_unknown_handling(i1, i7) | 0;
   i9 = (i7 | 0) == 1229209940;
   if (i8 | 0) {
    if (!i9) {
     _UNITY_png_handle_unknown(i1, i2, i6, i8);
     if ((i7 | 0) != 1347179589) break;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
     break;
    }
    if (!i6) {
     if (HEAP32[i5 >> 2] & 8192 | 0) i10 = 17;
    } else i10 = 17;
    if ((i10 | 0) == 17) {
     i10 = 0;
     _UNITY_png_benign_error(i1, gb + 352160 | 0);
    }
    _UNITY_png_handle_unknown(i1, i2, i6, i8);
    break;
   }
   if (i9) {
    if (!i6) {
     if (HEAP32[i5 >> 2] & 8192 | 0) i10 = 24;
    } else i10 = 24;
    if ((i10 | 0) == 24) {
     i10 = 0;
     _UNITY_png_benign_error(i1, gb + 352160 | 0);
    }
    _UNITY_png_crc_finish(i1, i6) | 0;
    break;
   }
   L43 : do if ((i7 | 0) < 1883455820) {
    if ((i7 | 0) < 1732332865) {
     if ((i7 | 0) < 1649100612) {
      switch (i7 | 0) {
      case 1347179589:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_PLTE(i1, i2, i6);
      break L18;
     }
     if ((i7 | 0) < 1665684045) {
      switch (i7 | 0) {
      case 1649100612:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_bKGD(i1, i2, i6);
      break L18;
     } else {
      switch (i7 | 0) {
      case 1665684045:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_cHRM(i1, i2, i6);
      break L18;
     }
    }
    if ((i7 | 0) < 1767135348) if ((i7 | 0) < 1766015824) {
     switch (i7 | 0) {
     case 1732332865:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_gAMA(i1, i2, i6);
     break L18;
    } else {
     switch (i7 | 0) {
     case 1766015824:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_iCCP(i1, i2, i6);
     break L18;
    } else if ((i7 | 0) < 1866876531) {
     switch (i7 | 0) {
     case 1767135348:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_iTXt(i1, i2, i6);
     break L18;
    } else {
     switch (i7 | 0) {
     case 1866876531:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_oFFs(i1, i2, i6);
     break L18;
    }
   } else {
    if ((i7 | 0) < 1933787468) {
     if ((i7 | 0) < 1883789683) {
      switch (i7 | 0) {
      case 1883455820:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_pCAL(i1, i2, i6);
      break L18;
     }
     if ((i7 | 0) < 1933723988) {
      switch (i7 | 0) {
      case 1883789683:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_pHYs(i1, i2, i6);
      break L18;
     } else {
      switch (i7 | 0) {
      case 1933723988:
       break;
      default:
       break L43;
      }
      _UNITY_png_handle_sBIT(i1, i2, i6);
      break L18;
     }
    }
    if ((i7 | 0) < 1934772034) if ((i7 | 0) < 1934642260) {
     switch (i7 | 0) {
     case 1933787468:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_sCAL(i1, i2, i6);
     break L18;
    } else {
     switch (i7 | 0) {
     case 1934642260:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_sPLT(i1, i2, i6);
     break L18;
    } else if ((i7 | 0) < 1951551059) {
     switch (i7 | 0) {
     case 1934772034:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_sRGB(i1, i2, i6);
     break L18;
    } else {
     switch (i7 | 0) {
     case 1951551059:
      break;
     default:
      break L43;
     }
     _UNITY_png_handle_tRNS(i1, i2, i6);
     break L18;
    }
   } while (0);
   _UNITY_png_handle_unknown(i1, i2, i6, 0);
  } while (0);
 } while (!(HEAP32[i5 >> 2] & 16 | 0));
 return;
}

function __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i13, i14, i15, i11, i8) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if (!i1) i3 = 1; else {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i13 >> 2] = 0;
   i3 = 1;
   break;
  } else {
   i3 = (HEAP32[i13 >> 2] | 0) == 0;
   break;
  }
 } while (0);
 i2 = HEAP32[i14 >> 2] | 0;
 do if (!i2) i12 = 14; else {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i14 >> 2] = 0;
   i12 = 14;
   break;
  } else if (i3) {
   i12 = 17;
   break;
  } else {
   i12 = 16;
   break;
  }
 } while (0);
 if ((i12 | 0) == 14) if (i3) i12 = 16; else {
  i2 = 0;
  i12 = 17;
 }
 L22 : do if ((i12 | 0) == 16) {
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 6;
  i1 = 0;
 } else if ((i12 | 0) == 17) {
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i3 >> 2] | 0;
  if (!(mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, 2048, i1 | 0) | 0)) {
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4;
   i1 = 0;
   break;
  }
  i1 = (mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i1 | 0, 0) | 0) << 24 >> 24;
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
   mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
   i6 = i2;
   i4 = i2;
  } else {
   HEAP32[i4 >> 2] = i5 + 4;
   i6 = i2;
   i4 = i2;
  }
  while (1) {
   i1 = i1 + -48 | 0;
   i10 = i8 + -1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   do if (!i2) i5 = 1; else {
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) == -1) {
     HEAP32[i13 >> 2] = 0;
     i5 = 1;
     break;
    } else {
     i5 = (HEAP32[i13 >> 2] | 0) == 0;
     break;
    }
   } while (0);
   do if (!i4) {
    i9 = i6;
    i7 = 0;
    i2 = 1;
   } else {
    i2 = HEAP32[i4 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i4 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
    if ((i2 | 0) == -1) {
     HEAP32[i14 >> 2] = 0;
     i9 = 0;
     i7 = 0;
     i2 = 1;
     break;
    } else {
     i9 = i6;
     i7 = i6;
     i2 = (i6 | 0) == 0;
     break;
    }
   } while (0);
   i3 = HEAP32[i13 >> 2] | 0;
   if (!((i8 | 0) > 1 & (i5 ^ i2))) break;
   i2 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
   if (!(mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, 2048, i2 | 0) | 0)) break L22;
   i1 = ((mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i2 | 0, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
    mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
    i8 = i10;
    i6 = i9;
    i4 = i7;
    continue;
   } else {
    HEAP32[i3 >> 2] = i4 + 4;
    i8 = i10;
    i6 = i9;
    i4 = i7;
    continue;
   }
  }
  do if (!i3) i3 = 1; else {
   i2 = HEAP32[i3 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) == -1) {
    HEAP32[i13 >> 2] = 0;
    i3 = 1;
    break;
   } else {
    i3 = (HEAP32[i13 >> 2] | 0) == 0;
    break;
   }
  } while (0);
  do if (!i9) i12 = 60; else {
   i2 = HEAP32[i9 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i9 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) == -1) {
    HEAP32[i14 >> 2] = 0;
    i12 = 60;
    break;
   } else if (i3) break L22; else break;
  } while (0);
  if ((i12 | 0) == 60) if (!i3) break;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
 } while (0);
 return i1 | 0;
}

function __ZN10GameObject8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 32 | 0;
 i5 = i12 + 16 | 0;
 i6 = i12;
 i7 = i12 + 8 | 0;
 __ZN14SafeBinaryRead10SetVersionEi(i11, 5);
 __ZN10GameObject18TransferComponentsI14SafeBinaryReadEEvRT_(i10, i11);
 i4 = i10 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 368700 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i2 = i10 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i5, 1);
   i7 = i5 + 11 | 0;
   i4 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
   i13 = gb + 63648 | 0;
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   i3 = i6;
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN14ConstantString6assignEPKc10MemLabelId(i2, i4, i9);
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    i13 = HEAP32[i5 >> 2] | 0;
    i7 = HEAP32[i5 + 12 >> 2] | 0;
    HEAP32[i9 >> 2] = 1;
    HEAP32[i9 + 4 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i9);
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i4 = i10 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 368708 | 0, HEAP32[gb + 37288 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i13 >>> 0) i8 = 25; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i8 = 25; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 54 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 896826 | 0, HEAP32[gb + 36972 >> 2] | 0, i9, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i13 = HEAP32[i11 + 20 >> 2] | 0;
   i2 = i13 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i13 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i11, 3) | 0)) {
  STACKTOP = i12;
  return;
 }
 if (!(HEAP32[i10 + 8 >> 2] & 1048576)) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i3 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i27 + 120 | 0;
 i24 = i27;
 i25 = i21 + 100 | 0;
 i20 = i21 + 4 | 0;
 i1 = (HEAP32[i25 >> 2] | 0) - (HEAP32[i20 >> 2] | 0) | 0;
 i26 = i21 + 104 | 0;
 if (i1 >>> 0 >= (HEAP32[i26 >> 2] | 0) >>> 0) {
  i26 = i21 + 112 | 0;
  HEAP8[i26 >> 0] = 0;
  STACKTOP = i27;
  return;
 }
 i23 = i21 + 96 | 0;
 i2 = HEAP32[i23 >> 2] | 0;
 if (i2 >>> 0 <= 32) {
  i26 = i21 + 112 | 0;
  HEAP8[i26 >> 0] = 0;
  STACKTOP = i27;
  return;
 }
 f3 = Math_fround(i1 >>> 0);
 do {
  i19 = i2;
  i2 = i2 >>> 1;
  if (i19 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i2 >>> 0) * Math_fround(.200000003)));
 i1 = i24 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i24 + 8 | 0;
 i5 = i21 + 8 | 0;
 i7 = HEAP16[i5 >> 1] | 0;
 HEAP8[i4 >> 0] = i7;
 i6 = i24 + 9 | 0;
 HEAP8[i6 >> 0] = (i7 & 65535) >>> 8;
 i7 = i24 + 12 | 0;
 i8 = i21 + 12 | 0;
 i11 = i7;
 i12 = i8;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i9 = i24 + 52 | 0;
 i10 = i21 + 52 | 0;
 i11 = i9;
 i12 = i10;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i14 = i24 + 92 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i24 + 96 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i24 + 100 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i24 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i17 = i24 + 108 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i24 + 104 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i24 + 112 | 0;
 HEAP8[i19 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i24, i21, i2);
 i12 = HEAP32[i20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i12;
 i12 = HEAP8[i5 >> 0] | 0;
 i13 = HEAP16[i4 >> 1] | 0;
 HEAP8[i5 >> 0] = i13;
 HEAP8[i4 >> 0] = i12;
 i12 = i21 + 9 | 0;
 i11 = HEAP8[i12 >> 0] | 0;
 HEAP8[i12 >> 0] = (i13 & 65535) >>> 8;
 HEAP8[i6 >> 0] = i11;
 i11 = i22;
 i12 = i8;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i11 = i8;
 i12 = i7;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i11 = i7;
 i12 = i22;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i11 = i22;
 i12 = i10;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i11 = i10;
 i12 = i9;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i11 = i9;
 i12 = i22;
 i13 = i11 + 40 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i11 + 4 | 0;
  i12 = i12 + 4 | 0;
 } while ((i11 | 0) < (i13 | 0));
 i20 = i21 + 92 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i20 = HEAP32[i23 >> 2] | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i23 >> 2] = i14;
 HEAP32[i15 >> 2] = i20;
 i23 = HEAP32[i25 >> 2] | 0;
 HEAP32[i25 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i23;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i21 + 108 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i26 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i21 + 112 >> 0] = 0;
 f3 = Math_fround(i20 >>> 0);
 HEAP32[i17 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i18 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i19 >> 0] = 0;
 if (i1 | 0) {
  i26 = HEAP32[i24 + 116 >> 2] | 0;
  HEAP32[i22 >> 2] = 65;
  HEAP32[i22 + 4 >> 2] = i26;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i22);
 }
 i26 = i21 + 112 | 0;
 HEAP8[i26 >> 0] = 0;
 STACKTOP = i27;
 return;
}

function runPostSets237() {
 HEAP32[gb + 213212 >> 2] = fb + 493;
 HEAP32[gb + 213216 >> 2] = fb + 322;
 HEAP32[gb + 213220 >> 2] = fb + 494;
 HEAP32[gb + 213224 >> 2] = fb + 135;
 HEAP32[gb + 213228 >> 2] = fb + 323;
 HEAP32[gb + 213232 >> 2] = fb + 106;
 HEAP32[gb + 213240 >> 2] = (HEAP32[gb + 213240 >> 2] | 0) + (gb + 12152 | 0);
 HEAP32[gb + 213244 >> 2] = fb + 3123;
 HEAP32[gb + 213248 >> 2] = fb + 3160;
 HEAP32[gb + 213252 >> 2] = fb + 3068;
 HEAP32[gb + 213256 >> 2] = fb + 24;
 HEAP32[gb + 213260 >> 2] = fb + 25;
 HEAP32[gb + 213264 >> 2] = fb + 96;
 HEAP32[gb + 213268 >> 2] = fb + 1494;
 HEAP32[gb + 213272 >> 2] = fb + 1495;
 HEAP32[gb + 213276 >> 2] = fb + 97;
 HEAP32[gb + 213280 >> 2] = fb + 1496;
 HEAP32[gb + 213288 >> 2] = (HEAP32[gb + 213288 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213292 >> 2] = fb + 3123;
 HEAP32[gb + 213296 >> 2] = fb + 3161;
 HEAP32[gb + 213300 >> 2] = fb + 3068;
 HEAP32[gb + 213304 >> 2] = fb + 28;
 HEAP32[gb + 213308 >> 2] = fb + 29;
 HEAP32[gb + 213312 >> 2] = fb + 100;
 HEAP32[gb + 213316 >> 2] = fb + 1500;
 HEAP32[gb + 213320 >> 2] = fb + 1501;
 HEAP32[gb + 213324 >> 2] = fb + 101;
 HEAP32[gb + 213328 >> 2] = fb + 1502;
 HEAP32[gb + 213336 >> 2] = (HEAP32[gb + 213336 >> 2] | 0) + (gb + 12048 | 0);
 HEAP32[gb + 213340 >> 2] = fb + 3123;
 HEAP32[gb + 213344 >> 2] = fb + 3162;
 HEAP32[gb + 213348 >> 2] = fb + 3068;
 HEAP32[gb + 213352 >> 2] = fb + 22;
 HEAP32[gb + 213356 >> 2] = fb + 23;
 HEAP32[gb + 213360 >> 2] = fb + 94;
 HEAP32[gb + 213364 >> 2] = fb + 1491;
 HEAP32[gb + 213368 >> 2] = fb + 1492;
 HEAP32[gb + 213372 >> 2] = fb + 95;
 HEAP32[gb + 213376 >> 2] = fb + 1493;
 HEAP32[gb + 213384 >> 2] = (HEAP32[gb + 213384 >> 2] | 0) + (gb + 12512 | 0);
 HEAP32[gb + 213388 >> 2] = fb + 3123;
 HEAP32[gb + 213392 >> 2] = fb + 3163;
 HEAP32[gb + 213396 >> 2] = fb + 3068;
 HEAP32[gb + 213400 >> 2] = fb + 28;
 HEAP32[gb + 213404 >> 2] = fb + 29;
 HEAP32[gb + 213408 >> 2] = fb + 100;
 HEAP32[gb + 213412 >> 2] = fb + 1500;
 HEAP32[gb + 213416 >> 2] = fb + 1501;
 HEAP32[gb + 213420 >> 2] = fb + 101;
 HEAP32[gb + 213424 >> 2] = fb + 1502;
 HEAP32[gb + 12512 >> 2] = (HEAP32[gb + 12512 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12516 >> 2] = (HEAP32[gb + 12516 >> 2] | 0) + (gb + 1081077 | 0);
 HEAP32[gb + 12520 >> 2] = (HEAP32[gb + 12520 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213432 >> 2] = (HEAP32[gb + 213432 >> 2] | 0) + (gb + 12528 | 0);
 HEAP32[gb + 213436 >> 2] = fb + 3123;
 HEAP32[gb + 213440 >> 2] = fb + 3164;
 HEAP32[gb + 213444 >> 2] = fb + 3068;
 HEAP32[gb + 213448 >> 2] = fb + 28;
 HEAP32[gb + 213452 >> 2] = fb + 29;
 HEAP32[gb + 213456 >> 2] = fb + 100;
 HEAP32[gb + 213460 >> 2] = fb + 1500;
 HEAP32[gb + 213464 >> 2] = fb + 1501;
 HEAP32[gb + 213468 >> 2] = fb + 101;
 HEAP32[gb + 213472 >> 2] = fb + 1502;
 HEAP32[gb + 12528 >> 2] = (HEAP32[gb + 12528 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12532 >> 2] = (HEAP32[gb + 12532 >> 2] | 0) + (gb + 1081111 | 0);
 HEAP32[gb + 12536 >> 2] = (HEAP32[gb + 12536 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213480 >> 2] = (HEAP32[gb + 213480 >> 2] | 0) + (gb + 12544 | 0);
 HEAP32[gb + 213484 >> 2] = fb + 3134;
 HEAP32[gb + 213488 >> 2] = fb + 3165;
 HEAP32[gb + 213492 >> 2] = fb + 3068;
 HEAP32[gb + 213496 >> 2] = fb + 30;
 HEAP32[gb + 213500 >> 2] = fb + 31;
 HEAP32[gb + 213504 >> 2] = fb + 107;
 HEAP32[gb + 213508 >> 2] = fb + 1507;
 HEAP32[gb + 213512 >> 2] = fb + 1508;
 HEAP32[gb + 213516 >> 2] = fb + 108;
 HEAP32[gb + 213520 >> 2] = fb + 1509;
 HEAP32[gb + 12544 >> 2] = (HEAP32[gb + 12544 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12548 >> 2] = (HEAP32[gb + 12548 >> 2] | 0) + (gb + 1081146 | 0);
 HEAP32[gb + 12552 >> 2] = (HEAP32[gb + 12552 >> 2] | 0) + (gb + 12200 | 0);
 HEAP32[gb + 213528 >> 2] = (HEAP32[gb + 213528 >> 2] | 0) + (gb + 12560 | 0);
 HEAP32[gb + 213532 >> 2] = fb + 3123;
 HEAP32[gb + 213536 >> 2] = fb + 3166;
 HEAP32[gb + 213540 >> 2] = fb + 3068;
 HEAP32[gb + 213544 >> 2] = fb + 32;
 HEAP32[gb + 213548 >> 2] = fb + 33;
 HEAP32[gb + 213552 >> 2] = fb + 109;
 HEAP32[gb + 213556 >> 2] = fb + 1510;
 HEAP32[gb + 213560 >> 2] = fb + 1511;
 HEAP32[gb + 213564 >> 2] = fb + 110;
 HEAP32[gb + 213568 >> 2] = fb + 1512;
 HEAP32[gb + 12560 >> 2] = (HEAP32[gb + 12560 >> 2] | 0) + (gb + 216140 | 0);
 HEAP32[gb + 12564 >> 2] = (HEAP32[gb + 12564 >> 2] | 0) + (gb + 1081174 | 0);
 HEAP32[gb + 12568 >> 2] = (HEAP32[gb + 12568 >> 2] | 0) + (gb + 12248 | 0);
 HEAP32[gb + 213576 >> 2] = (HEAP32[gb + 213576 >> 2] | 0) + (gb + 12576 | 0);
 HEAP32[gb + 213580 >> 2] = fb + 3123;
 HEAP32[gb + 213584 >> 2] = fb + 3167;
 HEAP32[gb + 213588 >> 2] = fb + 3068;
 HEAP32[gb + 213592 >> 2] = fb + 34;
 runPostSets238();
}

function __ZNK5physx27PxsFluidParticleOpcodeCache4readERtRjPjRKNS_9PxBounds3ERKNS0_18QuantizationParamsEPKNS_2Gu13GeometryUnionEb(i13, i15, i12, i16, i2, i10, i1, i11) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i14 = 0, f17 = f0, f18 = f0;
 i14 = HEAP16[i15 >> 1] | 0;
 do if (i14 & 16) if ((HEAP32[i13 + 28 >> 2] | 0) == (i1 | 0)) {
  i3 = HEAP8[i13 >> 0] | 0;
  i9 = i3 & 255;
  HEAP32[i12 >> 2] = i9;
  if ((i3 & 255) < 2 & i11) {
   HEAP32[i16 >> 2] = HEAPU16[i13 + 2 >> 1];
   f17 = Math_fround(HEAPF32[i2 >> 2]);
   f17 = Math_fround(f17 - Math_fround(HEAPF32[i13 + 4 >> 2]));
   f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i13 + 8 >> 2]));
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i13 + 12 >> 2]));
   i16 = f17 < Math_fround(0.0);
   f17 = i16 ? f17 : Math_fround(0.0);
   i16 = f4 < Math_fround(0.0);
   f4 = i16 ? f4 : Math_fround(0.0);
   i16 = f5 < Math_fround(0.0);
   f5 = i16 ? f5 : Math_fround(0.0);
   f6 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 12 >> 2]));
   f7 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 16 >> 2]));
   f8 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f8 = Math_fround(f8 - Math_fround(HEAPF32[i2 + 20 >> 2]));
   i16 = f6 < Math_fround(0.0);
   f6 = i16 ? f6 : Math_fround(0.0);
   i16 = f7 < Math_fround(0.0);
   f7 = i16 ? f7 : Math_fround(0.0);
   i16 = f8 < Math_fround(0.0);
   if (!(Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f17 + f4) + f5) + f6) + f7) + (i16 ? f8 : Math_fround(0.0))) == Math_fround(0.0))) break;
   HEAP16[i15 >> 1] = i14 & 65535 | 48;
   i16 = 1;
   return i16 | 0;
  }
  i1 = i13 + 16 | 0;
  f18 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f18 = Math_fround(f18 - f17);
  f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f8 = Math_fround(f8 - f7);
  f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  f6 = Math_fround(f6 - f5);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) - f17);
  f7 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) - f7);
  f5 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) - f5);
  f18 = Math_fround(Math_abs(Math_fround(f18)));
  f17 = Math_fround(Math_abs(Math_fround(f17)));
  f8 = Math_fround(Math_abs(Math_fround(f8)));
  f7 = Math_fround(Math_abs(Math_fround(f7)));
  f6 = Math_fround(Math_abs(Math_fround(f6)));
  f5 = Math_fround(Math_abs(Math_fround(f5)));
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  if ((~~Math_fround((f18 > f17 ? f18 : f17) * f4) & 255) < (HEAPU8[i13 + 1 >> 0] | 0)) {
   i10 = ~~Math_fround(f4 * (f6 > f5 ? f6 : f5)) & 255;
   if ((i10 & 255) < (HEAPU8[i13 + 3 >> 0] | 0) ? (~~Math_fround((f8 > f7 ? f8 : f7) * f4) & 255) < (HEAPU8[i13 + 2 >> 0] | 0) : 0) {
    if (!i11) {
     if ((i3 & 255) >= 4) break;
     i2 = i1 + (i9 << 2) | 0;
     if ((i1 | 0) != (i2 | 0)) {
      i3 = 0;
      while (1) {
       HEAP32[i16 + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
       i1 = i1 + 4 | 0;
       if ((i1 | 0) == (i2 | 0)) break; else i3 = i3 + 1 | 0;
      }
     }
     HEAP16[i15 >> 1] = i14 & 65535 | 48;
     i16 = 1;
     return i16 | 0;
    }
    if ((i3 & 255) >= 7) {
     if ((i3 & 255) >= 10) break;
     i12 = HEAPU16[i1 >> 1] | 0;
     HEAP32[i16 >> 2] = i12;
     i10 = HEAPU16[i13 + 18 >> 1] | 0;
     HEAP32[i16 + 4 >> 2] = (i10 >>> 6) + i12;
     i11 = HEAPU16[i13 + 20 >> 1] | 0;
     HEAP32[i16 + 8 >> 2] = (i10 << 4 & 1008 | i11 >>> 12) + i12;
     HEAP32[i16 + 12 >> 2] = (i11 >>> 2 & 1023) + i12;
     i10 = HEAPU16[i13 + 22 >> 1] | 0;
     HEAP32[i16 + 16 >> 2] = (i11 << 8 & 768 | i10 >>> 8) + i12;
     i11 = HEAPU16[i13 + 24 >> 1] | 0;
     HEAP32[i16 + 20 >> 2] = (i10 << 2 & 1020 | i11 >>> 14) + i12;
     HEAP32[i16 + 24 >> 2] = (i11 >>> 4 & 1023) + i12;
     i13 = HEAPU16[i13 + 26 >> 1] | 0;
     HEAP32[i16 + 28 >> 2] = (i11 << 6 & 960 | i13 >>> 10) + i12;
     HEAP32[i16 + 32 >> 2] = (i13 & 1023) + i12;
     HEAP16[i15 >> 1] = i14 & 65535 | 48;
     i16 = 1;
     return i16 | 0;
    }
    i2 = i1 + (i9 << 1) | 0;
    if ((i1 | 0) != (i2 | 0)) {
     i3 = 0;
     while (1) {
      HEAP32[i16 + (i3 << 2) >> 2] = HEAPU16[i1 >> 1];
      i1 = i1 + 2 | 0;
      if ((i1 | 0) == (i2 | 0)) break; else i3 = i3 + 1 | 0;
     }
    }
    HEAP16[i15 >> 1] = i14 & 65535 | 48;
    i16 = 1;
    return i16 | 0;
   }
  }
 } while (0);
 HEAP32[i12 >> 2] = 0;
 i16 = 0;
 return i16 | 0;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 112 | 0;
 i10 = i8 + 96 | 0;
 i1 = i8 + 80 | 0;
 i2 = i8 + 16 | 0;
 i12 = i8;
 i25 = HEAP32[i6 + 16 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 i24 = i25 + 4 | 0;
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 i23 = i25 + 8 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2]));
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i22 = i25 + 12 | 0;
 f15 = Math_fround(f16 * Math_fround(HEAPF32[i22 >> 2]));
 i21 = i25 + 16 | 0;
 f17 = Math_fround(f16 * Math_fround(HEAPF32[i21 >> 2]));
 i20 = i25 + 20 | 0;
 f15 = Math_fround(f13 + f15);
 f17 = Math_fround(f14 + f17);
 f16 = Math_fround(f9 + Math_fround(f16 * Math_fround(HEAPF32[i20 >> 2])));
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i19 = i25 + 24 | 0;
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 i18 = i25 + 28 | 0;
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 i3 = i25 + 32 | 0;
 f13 = Math_fround(f17 + f13);
 f9 = Math_fround(f16 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i11 >> 2] = Math_fround(f15 + f14);
 HEAPF32[i11 + 4 >> 2] = f13;
 HEAPF32[i11 + 8 >> 2] = f9;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2]));
 f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f16 = Math_fround(f15 * Math_fround(HEAPF32[i22 >> 2]));
 f17 = Math_fround(f15 * Math_fround(HEAPF32[i21 >> 2]));
 f16 = Math_fround(f13 + f16);
 f17 = Math_fround(f14 + f17);
 f15 = Math_fround(f9 + Math_fround(f15 * Math_fround(HEAPF32[i20 >> 2])));
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f13 = Math_fround(f17 + f13);
 f9 = Math_fround(f15 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f16 + f14);
 HEAPF32[i10 + 4 >> 2] = f13;
 HEAPF32[i10 + 8 >> 2] = f9;
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i25 >> 2]));
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i24 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2]));
 f16 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(f16 * Math_fround(HEAPF32[i22 >> 2]));
 f17 = Math_fround(f16 * Math_fround(HEAPF32[i21 >> 2]));
 f15 = Math_fround(f13 + f15);
 f17 = Math_fround(f14 + f17);
 f16 = Math_fround(f9 + Math_fround(f16 * Math_fround(HEAPF32[i20 >> 2])));
 f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 f13 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f13 = Math_fround(f17 + f13);
 f9 = Math_fround(f16 + Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f15 + f14);
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f9;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 i4 = HEAP32[i6 + 80 >> 2] | 0;
 i5 = HEAP32[i6 + 84 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 + 76 >> 2];
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i5;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu28distancePointTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_RS3_(i2, i12, i11, i10, i1, i8 + 64 | 0, i8 + 48 | 0, i8 + 32 | 0);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f9 <= Math_fround(HEAPF32[i6 + 72 >> 2]))) {
  i25 = 1;
  STACKTOP = i8;
  return i25 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i25 = 0;
  STACKTOP = i8;
  return i25 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i25 = 1;
  STACKTOP = i8;
  return i25 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i25 = 1;
  STACKTOP = i8;
  return i25 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i25 = 1;
  STACKTOP = i8;
  return i25 | 0;
 }
 return 0;
}

function __ZN2UI6Canvas19SyncTransformParentEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  while (1) {
   i1 = __Z34FindAncestorComponentExactTypeImplR10GameObjecti(HEAP32[i1 + 28 >> 2] | 0, 223) | 0;
   if (!i1) {
    i1 = 0;
    break L1;
   }
   i2 = i1 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
    i11 = 8;
    break;
   }
   if (HEAP8[i1 + 33 >> 0] | 0) {
    i11 = 7;
    break;
   }
   i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break L1;
   }
  }
  if ((i11 | 0) == 7) break; else if ((i11 | 0) == 8) break;
 } while (0);
 i10 = i13 + 344 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 if ((i8 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 i3 = (i8 | 0) == 0;
 if (!i3) {
  HEAP8[i13 + 400 >> 0] = 1;
  i2 = i8;
  do {
   i9 = i2;
   i2 = HEAP32[i2 + 344 >> 2] | 0;
   HEAP8[i9 + 400 >> 0] = 1;
  } while ((i2 | 0) != 0);
 }
 i9 = (i1 | 0) != 0;
 if (i9) {
  i2 = i1;
  do {
   HEAP8[i2 + 400 >> 0] = 1;
   i2 = HEAP32[i2 + 344 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 L25 : do if (i3) i11 = 27; else if (!(HEAP8[i13 + 375 >> 0] | 0)) {
  i7 = i8 + 428 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = i3;
  i6 = HEAP32[i8 + 424 >> 2] | 0;
  while (1) {
   if ((i6 | 0) == (i3 | 0)) break L25;
   i4 = i6 + 4 | 0;
   if ((HEAP32[i6 >> 2] | 0) == (i13 | 0)) break; else i6 = i4;
  }
  i2 = i2 - i4 | 0;
  i5 = i2 >> 2;
  if (i5) {
   _memmove(i6 | 0, i4 | 0, i2 | 0) | 0;
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i2 = i6 + (i5 << 2) | 0;
  if ((i3 | 0) != (i2 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i2 = i8 + 224 | 0;
  HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 4;
  i2 = HEAP32[gb + 1467948 >> 2] | 0;
  HEAP32[i12 >> 2] = i13;
  if (i13 | 0) __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i2 + 12 | 0, i12) | 0;
 } else i11 = 27; while (0);
 if ((i11 | 0) == 27) {
  i7 = HEAP32[gb + 1467948 >> 2] | 0;
  HEAP32[i12 >> 2] = i13;
  i8 = i7 + 4 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i3;
  i6 = HEAP32[i7 >> 2] | 0;
  while (1) {
   if ((i6 | 0) == (i3 | 0)) break;
   i4 = i6 + 4 | 0;
   if ((HEAP32[i6 >> 2] | 0) == (i13 | 0)) {
    i11 = 30;
    break;
   } else i6 = i4;
  }
  if ((i11 | 0) == 30) {
   i2 = i2 - i4 | 0;
   i5 = i2 >> 2;
   if (i5) {
    _memmove(i6 | 0, i4 | 0, i2 | 0) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   i2 = i6 + (i5 << 2) | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i7 + 12 | 0, i12) | 0;
  }
 }
 if (i9) if (!(HEAP8[i13 + 375 >> 0] | 0)) {
  HEAP32[i12 >> 2] = i13;
  i2 = HEAP32[i1 + 424 >> 2] | 0;
  i3 = i1 + 428 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i13;
  L59 : do if ((i2 | 0) == (i4 | 0)) i11 = 42; else while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i13 | 0)) break L59;
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i11 = 42;
    break;
   }
  } while (0);
  if ((i11 | 0) == 42) {
   if ((i4 | 0) == (HEAP32[i1 + 432 >> 2] | 0)) __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1 + 424 | 0, i12); else {
    HEAP32[i4 >> 2] = i5;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
   }
   i9 = i1 + 224 | 0;
   HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 4;
  }
 } else i11 = 38; else i11 = 38;
 if ((i11 | 0) == 38) __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE(HEAP32[gb + 1467948 >> 2] | 0, i13);
 HEAP32[i10 >> 2] = i1;
 if (!i1) i1 = i13; else while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i3 = i13 + 112 | 0;
 i1 = i12;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i13 = i13 + 224 | 0;
 HEAP16[i13 >> 1] = HEAPU16[i13 >> 1] | 6;
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i27, i28, i23, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i23 = i23 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0;
 i12 = i28 + 40 | 0;
 i26 = HEAP32[i12 >> 2] | 0;
 i14 = i27 + 40 | 0;
 i13 = i23 + 40 | 0;
 i1 = (HEAP32[i13 >> 2] | 0) < (i26 | 0);
 if ((i26 | 0) >= (HEAP32[i14 >> 2] | 0)) {
  if (!i1) {
   i28 = 0;
   return i28 | 0;
  }
  i1 = HEAP32[i28 >> 2] | 0;
  i13 = i28 + 4 | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i15 = i28 + 8 | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  i16 = i28 + 12 | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  i17 = i28 + 16 | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  i18 = i28 + 20 | 0;
  i6 = HEAP32[i18 >> 2] | 0;
  i19 = i28 + 24 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  i20 = i28 + 28 | 0;
  i8 = HEAP32[i20 >> 2] | 0;
  i21 = i28 + 32 | 0;
  i9 = HEAP32[i21 >> 2] | 0;
  i22 = i28 + 36 | 0;
  i11 = i22;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i24 = i28;
  i25 = i23;
  i26 = i24 + 44 | 0;
  do {
   HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
   i24 = i24 + 4 | 0;
   i25 = i25 + 4 | 0;
  } while ((i24 | 0) < (i26 | 0));
  HEAP32[i23 >> 2] = i1;
  HEAP32[i23 + 4 >> 2] = i2;
  HEAP32[i23 + 8 >> 2] = i3;
  HEAP32[i23 + 12 >> 2] = i4;
  HEAP32[i23 + 16 >> 2] = i5;
  HEAP32[i23 + 20 >> 2] = i6;
  HEAP32[i23 + 24 >> 2] = i7;
  HEAP32[i23 + 28 >> 2] = i8;
  HEAP32[i23 + 32 >> 2] = i9;
  i26 = i23 + 36 | 0;
  HEAP32[i26 >> 2] = i10;
  HEAP32[i26 + 4 >> 2] = i11;
  if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i14 >> 2] | 0)) {
   i28 = 1;
   return i28 | 0;
  }
  i1 = HEAP32[i27 >> 2] | 0;
  i2 = HEAP32[i27 + 4 >> 2] | 0;
  i3 = HEAP32[i27 + 8 >> 2] | 0;
  i4 = HEAP32[i27 + 12 >> 2] | 0;
  i5 = HEAP32[i27 + 16 >> 2] | 0;
  i6 = HEAP32[i27 + 20 >> 2] | 0;
  i7 = HEAP32[i27 + 24 >> 2] | 0;
  i8 = HEAP32[i27 + 28 >> 2] | 0;
  i9 = HEAP32[i27 + 32 >> 2] | 0;
  i11 = i27 + 36 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i24 = i27;
  i25 = i28;
  i26 = i24 + 44 | 0;
  do {
   HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
   i24 = i24 + 4 | 0;
   i25 = i25 + 4 | 0;
  } while ((i24 | 0) < (i26 | 0));
  HEAP32[i28 >> 2] = i1;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i17 >> 2] = i5;
  HEAP32[i18 >> 2] = i6;
  HEAP32[i19 >> 2] = i7;
  HEAP32[i20 >> 2] = i8;
  HEAP32[i21 >> 2] = i9;
  i28 = i22;
  HEAP32[i28 >> 2] = i10;
  HEAP32[i28 + 4 >> 2] = i11;
  i28 = 2;
  return i28 | 0;
 }
 i2 = HEAP32[i27 >> 2] | 0;
 i3 = HEAP32[i27 + 4 >> 2] | 0;
 i4 = HEAP32[i27 + 8 >> 2] | 0;
 i5 = HEAP32[i27 + 12 >> 2] | 0;
 i6 = HEAP32[i27 + 16 >> 2] | 0;
 i7 = HEAP32[i27 + 20 >> 2] | 0;
 i8 = HEAP32[i27 + 24 >> 2] | 0;
 i9 = HEAP32[i27 + 28 >> 2] | 0;
 i10 = HEAP32[i27 + 32 >> 2] | 0;
 i12 = i27 + 36 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 if (i1) {
  i24 = i27;
  i25 = i23;
  i26 = i24 + 44 | 0;
  do {
   HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
   i24 = i24 + 4 | 0;
   i25 = i25 + 4 | 0;
  } while ((i24 | 0) < (i26 | 0));
  HEAP32[i23 >> 2] = i2;
  HEAP32[i23 + 4 >> 2] = i3;
  HEAP32[i23 + 8 >> 2] = i4;
  HEAP32[i23 + 12 >> 2] = i5;
  HEAP32[i23 + 16 >> 2] = i6;
  HEAP32[i23 + 20 >> 2] = i7;
  HEAP32[i23 + 24 >> 2] = i8;
  HEAP32[i23 + 28 >> 2] = i9;
  HEAP32[i23 + 32 >> 2] = i10;
  i28 = i23 + 36 | 0;
  HEAP32[i28 >> 2] = i11;
  HEAP32[i28 + 4 >> 2] = i12;
  i28 = 1;
  return i28 | 0;
 }
 i24 = i27;
 i25 = i28;
 i26 = i24 + 44 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i28 >> 2] = i2;
 HEAP32[i28 + 4 >> 2] = i3;
 HEAP32[i28 + 8 >> 2] = i4;
 HEAP32[i28 + 12 >> 2] = i5;
 HEAP32[i28 + 16 >> 2] = i6;
 HEAP32[i28 + 20 >> 2] = i7;
 HEAP32[i28 + 24 >> 2] = i8;
 HEAP32[i28 + 28 >> 2] = i9;
 HEAP32[i28 + 32 >> 2] = i10;
 i27 = i28 + 36 | 0;
 HEAP32[i27 >> 2] = i11;
 HEAP32[i27 + 4 >> 2] = i12;
 if ((HEAP32[i13 >> 2] | 0) >= (i12 | 0)) {
  i28 = 1;
  return i28 | 0;
 }
 i24 = i28;
 i25 = i23;
 i26 = i24 + 44 | 0;
 do {
  HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
  i24 = i24 + 4 | 0;
  i25 = i25 + 4 | 0;
 } while ((i24 | 0) < (i26 | 0));
 HEAP32[i23 >> 2] = i2;
 HEAP32[i23 + 4 >> 2] = i3;
 HEAP32[i23 + 8 >> 2] = i4;
 HEAP32[i23 + 12 >> 2] = i5;
 HEAP32[i23 + 16 >> 2] = i6;
 HEAP32[i23 + 20 >> 2] = i7;
 HEAP32[i23 + 24 >> 2] = i8;
 HEAP32[i23 + 28 >> 2] = i9;
 HEAP32[i23 + 32 >> 2] = i10;
 i28 = i23 + 36 | 0;
 HEAP32[i28 >> 2] = i11;
 HEAP32[i28 + 4 >> 2] = i12;
 i28 = 2;
 return i28 | 0;
}

function __ZN13TargetJoint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i2 = i6 + 76 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946522 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803176 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803185 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 92 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802602 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 27; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 27; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 27) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803283 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 38; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 38; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 38) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853582 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 49; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 49; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 49) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function runPostSets86() {
 HEAP32[gb + 89580 >> 2] = fb + 139;
 HEAP32[gb + 89584 >> 2] = fb + 1197;
 HEAP32[gb + 89588 >> 2] = fb + 1201;
 HEAP32[gb + 89592 >> 2] = fb + 140;
 HEAP32[gb + 89604 >> 2] = fb + 141;
 HEAP32[gb + 89608 >> 2] = fb + 1202;
 HEAP32[gb + 89612 >> 2] = fb + 1203;
 HEAP32[gb + 89624 >> 2] = fb + 1193;
 HEAP32[gb + 89628 >> 2] = fb + 1204;
 HEAP32[gb + 89632 >> 2] = fb + 533;
 HEAP32[gb + 89636 >> 2] = fb + 44;
 HEAP32[gb + 89640 >> 2] = fb + 45;
 HEAP32[gb + 89644 >> 2] = fb + 46;
 HEAP32[gb + 89648 >> 2] = fb + 67;
 HEAP32[gb + 89652 >> 2] = fb + 243;
 HEAP32[gb + 89656 >> 2] = (HEAP32[gb + 89656 >> 2] | 0) + (gb + 673341 | 0);
 HEAP32[gb + 89672 >> 2] = (HEAP32[gb + 89672 >> 2] | 0) + (gb + 673360 | 0);
 HEAP32[gb + 89696 >> 2] = fb + 1193;
 HEAP32[gb + 89700 >> 2] = fb + 1205;
 HEAP32[gb + 89704 >> 2] = fb + 534;
 HEAP32[gb + 89708 >> 2] = fb + 47;
 HEAP32[gb + 89712 >> 2] = fb + 48;
 HEAP32[gb + 89716 >> 2] = fb + 49;
 HEAP32[gb + 89720 >> 2] = fb + 68;
 HEAP32[gb + 89724 >> 2] = fb + 244;
 HEAP32[gb + 89736 >> 2] = fb + 1193;
 HEAP32[gb + 89740 >> 2] = fb + 1206;
 HEAP32[gb + 89744 >> 2] = fb + 535;
 HEAP32[gb + 89748 >> 2] = fb + 50;
 HEAP32[gb + 89752 >> 2] = fb + 51;
 HEAP32[gb + 89756 >> 2] = fb + 52;
 HEAP32[gb + 89760 >> 2] = fb + 69;
 HEAP32[gb + 89764 >> 2] = fb + 245;
 HEAP32[gb + 89768 >> 2] = (HEAP32[gb + 89768 >> 2] | 0) + (gb + 742920 | 0);
 HEAP32[gb + 89776 >> 2] = (HEAP32[gb + 89776 >> 2] | 0) + (gb + 742962 | 0);
 HEAP32[gb + 89784 >> 2] = (HEAP32[gb + 89784 >> 2] | 0) + (gb + 743004 | 0);
 HEAP32[gb + 89792 >> 2] = (HEAP32[gb + 89792 >> 2] | 0) + (gb + 743055 | 0);
 HEAP32[gb + 89808 >> 2] = (HEAP32[gb + 89808 >> 2] | 0) + (gb + 757719 | 0);
 HEAP32[gb + 89816 >> 2] = (HEAP32[gb + 89816 >> 2] | 0) + (gb + 743094 | 0);
 HEAP32[gb + 89824 >> 2] = (HEAP32[gb + 89824 >> 2] | 0) + (gb + 743111 | 0);
 HEAP32[gb + 89832 >> 2] = (HEAP32[gb + 89832 >> 2] | 0) + (gb + 743132 | 0);
 HEAP32[gb + 89856 >> 2] = fb + 1193;
 HEAP32[gb + 89860 >> 2] = fb + 1207;
 HEAP32[gb + 89864 >> 2] = fb + 536;
 HEAP32[gb + 89868 >> 2] = fb + 53;
 HEAP32[gb + 89872 >> 2] = fb + 54;
 HEAP32[gb + 89876 >> 2] = fb + 55;
 HEAP32[gb + 89880 >> 2] = fb + 70;
 HEAP32[gb + 89884 >> 2] = fb + 246;
 HEAP32[gb + 89888 >> 2] = (HEAP32[gb + 89888 >> 2] | 0) + (gb + 673539 | 0);
 HEAP32[gb + 89896 >> 2] = (HEAP32[gb + 89896 >> 2] | 0) + (gb + 673550 | 0);
 HEAP32[gb + 89904 >> 2] = (HEAP32[gb + 89904 >> 2] | 0) + (gb + 673590 | 0);
 HEAP32[gb + 89912 >> 2] = (HEAP32[gb + 89912 >> 2] | 0) + (gb + 673602 | 0);
 HEAP32[gb + 89936 >> 2] = fb + 1193;
 HEAP32[gb + 89940 >> 2] = fb + 1208;
 HEAP32[gb + 89944 >> 2] = fb + 537;
 HEAP32[gb + 89948 >> 2] = fb + 56;
 HEAP32[gb + 89952 >> 2] = fb + 57;
 HEAP32[gb + 89956 >> 2] = fb + 58;
 HEAP32[gb + 89960 >> 2] = fb + 71;
 HEAP32[gb + 89964 >> 2] = fb + 247;
 HEAP32[gb + 89968 >> 2] = (HEAP32[gb + 89968 >> 2] | 0) + (gb + 673987 | 0);
 HEAP32[gb + 89976 >> 2] = (HEAP32[gb + 89976 >> 2] | 0) + (gb + 673995 | 0);
 HEAP32[gb + 9e4 >> 2] = fb + 1193;
 HEAP32[gb + 90004 >> 2] = fb + 1209;
 HEAP32[gb + 90008 >> 2] = fb + 538;
 HEAP32[gb + 90012 >> 2] = fb + 59;
 HEAP32[gb + 90016 >> 2] = fb + 60;
 HEAP32[gb + 90020 >> 2] = fb + 61;
 HEAP32[gb + 90024 >> 2] = fb + 72;
 HEAP32[gb + 90028 >> 2] = fb + 248;
 HEAP32[gb + 90040 >> 2] = fb + 1193;
 HEAP32[gb + 90044 >> 2] = fb + 1210;
 HEAP32[gb + 90048 >> 2] = fb + 539;
 HEAP32[gb + 90052 >> 2] = fb + 62;
 HEAP32[gb + 90056 >> 2] = fb + 63;
 HEAP32[gb + 90060 >> 2] = fb + 64;
 HEAP32[gb + 90064 >> 2] = fb + 73;
 HEAP32[gb + 90068 >> 2] = fb + 249;
 HEAP32[gb + 90072 >> 2] = (HEAP32[gb + 90072 >> 2] | 0) + (gb + 674731 | 0);
 HEAP32[gb + 90080 >> 2] = (HEAP32[gb + 90080 >> 2] | 0) + (gb + 674741 | 0);
 HEAP32[gb + 90088 >> 2] = (HEAP32[gb + 90088 >> 2] | 0) + (gb + 674753 | 0);
 HEAP32[gb + 90096 >> 2] = (HEAP32[gb + 90096 >> 2] | 0) + (gb + 674762 | 0);
 HEAP32[gb + 90120 >> 2] = fb + 1193;
 HEAP32[gb + 90124 >> 2] = fb + 1211;
 HEAP32[gb + 90128 >> 2] = fb + 540;
 HEAP32[gb + 90132 >> 2] = fb + 65;
 HEAP32[gb + 90136 >> 2] = fb + 66;
 HEAP32[gb + 90140 >> 2] = fb + 67;
 HEAP32[gb + 90144 >> 2] = fb + 74;
 HEAP32[gb + 90148 >> 2] = fb + 250;
 HEAP32[gb + 90152 >> 2] = (HEAP32[gb + 90152 >> 2] | 0) + (gb + 674827 | 0);
 HEAP32[gb + 90160 >> 2] = (HEAP32[gb + 90160 >> 2] | 0) + (gb + 674832 | 0);
 HEAP32[gb + 90168 >> 2] = (HEAP32[gb + 90168 >> 2] | 0) + (gb + 674847 | 0);
 HEAP32[gb + 90192 >> 2] = fb + 1212;
 HEAP32[gb + 90196 >> 2] = fb + 541;
 HEAP32[gb + 90200 >> 2] = fb + 456;
 HEAP32[gb + 90204 >> 2] = fb + 1213;
 HEAP32[gb + 90208 >> 2] = fb + 1214;
 HEAP32[gb + 90212 >> 2] = fb + 251;
 runPostSets87();
}

function __ZN11NoiseModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, i5, i1 + 4 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620191 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620200 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620210 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620483 | 0, i5, i1 + 804 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620220 | 0, i6, i1 + 800 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048298 | 0, i5, i1 + 805 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620230 | 0, i5, i1 + 808 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620238 | 0, i6, i1 + 812 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620255 | 0, i6, i1 + 816 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620267 | 0, i5, i1 + 820 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 824 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620275 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 1092 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620287 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 1356 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620293 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 1620 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620300 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620307 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 1884 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx19PxsFluidSpatialHash19buildPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEjPNS_16PxsFluidParticleEPj(i4, i2, i24, i1, i15, i22) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i22 = i22 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i26 + 8 | 0;
 i25 = i26;
 i16 = i26 + 16 | 0;
 i14 = 1 << i1;
 i5 = HEAP16[i2 >> 1] << i1;
 i7 = HEAP16[i2 + 2 >> 1] << i1;
 i6 = HEAP16[i2 + 4 >> 1] << i1;
 _memset(i24 | 0, 0, 216) | 0;
 i21 = i2 + 8 | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 i8 = i3 & 511;
 i8 = (i8 | 0) == 0 ? 512 : i8;
 i18 = i2 + 12 | 0;
 i19 = HEAP32[i18 >> 2] | 0;
 i17 = i22 + (i19 << 2) | 0;
 i1 = i3 << 2;
 i13 = i1 >>> 0 > 1024;
 i20 = i23 + 4 | 0;
 HEAP8[i20 >> 0] = i13 & 1;
 if (i13) {
  i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i26 + 17 | 0, i1, gb + 769126 | 0, 252) | 0;
  HEAP32[i23 >> 2] = i2;
  i3 = HEAP32[i21 >> 2] | 0;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i23 >> 2] = i2;
 }
 if (i8 >>> 0 <= i3 >>> 0) {
  i13 = i4 + 12 | 0;
  i12 = i5 & 65535;
  i11 = i7 & 65535;
  i10 = i6 & 65535;
  i1 = 0;
  while (1) {
   if (i8 >>> 0 > i1 >>> 0) {
    f9 = Math_fround(HEAPF32[i13 >> 2]);
    i7 = i8 - i1 | 0;
    i6 = i2;
    while (1) {
     i5 = HEAP32[i22 + (i1 + i19 << 2) >> 2] | 0;
     f28 = Math_fround(f9 * Math_fround(HEAPF32[i15 + (i5 << 5) >> 2]));
     f27 = Math_fround(f9 * Math_fround(HEAPF32[i15 + (i5 << 5) + 4 >> 2]));
     i4 = (~~Math_fround(Math_floor(Math_fround(f28))) & 65535) - i12 | 0;
     i3 = (~~Math_fround(Math_floor(Math_fround(f27))) & 65535) - i11 | 0;
     i5 = (~~Math_fround(Math_floor(Math_fround(f9 * Math_fround(HEAPF32[i15 + (i5 << 5) + 8 >> 2])))) & 65535) - i10 | 0;
     i4 = ((i4 << 16 >> 16) + 1 | 0) == (i14 | 0) ? 9 : (i4 & 65535) << 16 >> 16 == 0 ? 0 : 18;
     if (((i3 << 16 >> 16) + 1 | 0) == (i14 | 0)) i3 = i4 + 3 | 0; else i3 = (i3 & 65535) << 16 >> 16 == 0 ? i4 : i4 + 6 | 0;
     if (((i5 << 16 >> 16) + 1 | 0) == (i14 | 0)) i3 = i3 + 1 | 0; else i3 = (i5 & 65535) << 16 >> 16 == 0 ? i3 : i3 + 2 | 0;
     HEAP16[i6 >> 1] = i3;
     i5 = i24 + (i3 << 2) | 0;
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i8 | 0)) break; else i6 = i6 + 2 | 0;
    }
    i3 = HEAP32[i21 >> 2] | 0;
    i2 = i2 + (i7 << 1) | 0;
   }
   i1 = i8 + 512 | 0;
   if (i1 >>> 0 > i3 >>> 0) break; else {
    i7 = i8;
    i8 = i1;
    i1 = i7;
   }
  }
 }
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = 0;
 while (1) {
  HEAP32[i24 + 108 + (i3 << 2) >> 2] = i2;
  i1 = i3 + 1 | 0;
  if ((i1 | 0) == 27) break; else {
   i2 = (HEAP32[i24 + (i3 << 2) >> 2] | 0) + i2 | 0;
   i3 = i1;
  }
 }
 i2 = HEAP32[i21 >> 2] | 0;
 i3 = i2 << 4;
 i15 = i3 >>> 0 > 1024;
 i7 = i25 + 4 | 0;
 HEAP8[i7 >> 0] = i15 & 1;
 if (i15) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i16, i3, gb + 769126 | 0, 290) | 0;
  HEAP32[i25 >> 2] = i1;
  i2 = HEAP32[i21 >> 2] | 0;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i25 >> 2] = i1;
 }
 _memcpy(i1 | 0, i17 | 0, i2 << 2 | 0) | 0;
 i6 = HEAP32[i25 >> 2] | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i4 = HEAP32[i21 >> 2] & 511;
 i4 = (i4 | 0) == 0 ? 512 : i4;
 i1 = i24;
 i2 = i1 + 108 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = HEAP32[i21 >> 2] | 0;
 if (i4 >>> 0 <= i1 >>> 0) {
  i2 = i3;
  i5 = i4;
  i4 = 0;
  while (1) {
   if (i5 >>> 0 > i4 >>> 0) {
    i1 = i2;
    i3 = i4;
    while (1) {
     i16 = HEAPU16[i1 >> 1] | 0;
     i17 = i24 + (i16 << 2) | 0;
     HEAP32[i22 + ((HEAP32[i24 + 108 + (i16 << 2) >> 2] | 0) + i19 + (HEAP32[i17 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) << 2) >> 2] = HEAP32[i6 + (i3 << 2) >> 2];
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i5 | 0)) break; else i1 = i1 + 2 | 0;
    }
    i2 = i2 + (i5 - i4 << 1) | 0;
    i1 = HEAP32[i21 >> 2] | 0;
   }
   i3 = i5 + 512 | 0;
   if (i3 >>> 0 > i1 >>> 0) break; else {
    i4 = i5;
    i5 = i3;
   }
  }
 }
 if (HEAP8[i7 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i25, i6);
 if (!(HEAP8[i20 >> 0] | 0)) {
  STACKTOP = i26;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i23, HEAP32[i23 >> 2] | 0);
 STACKTOP = i26;
 return;
}

function __Z14tessAddContourP14TESStesselatoriPKvii(i9, i2, i3, i7, i8) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i1 = __Z15tessMeshNewMeshP9TESSalloc(i9 + 104 | 0) | 0;
  HEAP32[i9 >> 2] = i1;
  if (!i1) {
   HEAP32[i9 + 4 >> 2] = 1;
   return;
  }
 }
 if ((i8 | 0) <= 0) return;
 i6 = i9 + 80 | 0;
 L9 : do if ((i2 | 0) > 2) {
  i5 = 0;
  i2 = 0;
  while (1) {
   i4 = i3 + i7 | 0;
   if (!i2) {
    i1 = __Z16tessMeshMakeEdgeP8TESSmesh(i1) | 0;
    if (!i1) {
     i1 = 16;
     break L9;
    }
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i9 >> 2] | 0, i1, HEAP32[i1 + 4 >> 2] | 0) | 0)) {
     i1 = 18;
     break L9;
    } else i2 = i1;
   } else {
    i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(i1, i2) | 0;
    if (!i1) {
     i1 = 21;
     break L9;
    }
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i11 = HEAP32[i2 + 4 >> 2] | 0;
    i15 = HEAP32[(HEAP32[i11 + 4 >> 2] | 0) + 12 >> 2] | 0;
    i13 = i11 + 8 | 0;
    i10 = HEAP32[i13 >> 2] | 0;
    i12 = i15 + 8 | 0;
    i14 = HEAP32[i12 >> 2] | 0;
    HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i15;
    HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 12 >> 2] = i11;
    HEAP32[i13 >> 2] = i14;
    HEAP32[i12 >> 2] = i10;
    i12 = HEAP32[i13 >> 2] | 0;
    i10 = i1 + 8 | 0;
    i14 = HEAP32[i10 >> 2] | 0;
    HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i1;
    HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 12 >> 2] = i11;
    HEAP32[i13 >> 2] = i14;
    HEAP32[i10 >> 2] = i12;
    HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    i10 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + 8 >> 2] = i10;
    HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
    if (!i1) {
     i1 = 21;
     break L9;
    }
    i2 = HEAP32[i2 + 12 >> 2] | 0;
   }
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 8 >> 2];
   i15 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i15 + 1;
   HEAP32[i1 + 40 >> 2] = i15;
   HEAP32[i2 + 28 >> 2] = 1;
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 28 >> 2] = -1;
   i1 = i5 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) break;
   i5 = i1;
   i3 = i4;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  return;
 } else {
  i5 = 0;
  i2 = 0;
  while (1) {
   i4 = i3 + i7 | 0;
   if (!i2) {
    i1 = __Z16tessMeshMakeEdgeP8TESSmesh(i1) | 0;
    if (!i1) {
     i1 = 16;
     break L9;
    }
    if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i9 >> 2] | 0, i1, HEAP32[i1 + 4 >> 2] | 0) | 0)) {
     i1 = 18;
     break L9;
    } else i2 = i1;
   } else {
    i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(i1, i2) | 0;
    if (!i1) {
     i1 = 21;
     break L9;
    }
    i15 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = HEAP32[i2 + 4 >> 2] | 0;
    i1 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 12 >> 2] | 0;
    i11 = i13 + 8 | 0;
    i14 = HEAP32[i11 >> 2] | 0;
    i12 = i1 + 8 | 0;
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[(HEAP32[i14 + 4 >> 2] | 0) + 12 >> 2] = i1;
    HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
    HEAP32[i11 >> 2] = i10;
    HEAP32[i12 >> 2] = i14;
    i12 = HEAP32[i11 >> 2] | 0;
    i14 = i15 + 8 | 0;
    i10 = HEAP32[i14 >> 2] | 0;
    HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] = i15;
    HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i13;
    HEAP32[i11 >> 2] = i10;
    HEAP32[i14 >> 2] = i12;
    HEAP32[i13 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    i14 = HEAP32[i15 + 4 >> 2] | 0;
    HEAP32[(HEAP32[i14 + 16 >> 2] | 0) + 8 >> 2] = i14;
    HEAP32[i14 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
    HEAP32[i15 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i14 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
    if (!i15) {
     i1 = 21;
     break L9;
    }
    i2 = HEAP32[i2 + 12 >> 2] | 0;
   }
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
   i15 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i15 + 1;
   HEAP32[i1 + 40 >> 2] = i15;
   HEAP32[i2 + 28 >> 2] = 1;
   HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 28 >> 2] = -1;
   i1 = i5 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) break;
   i5 = i1;
   i3 = i4;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  return;
 } while (0);
 if ((i1 | 0) == 16) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 } else if ((i1 | 0) == 18) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 } else if ((i1 | 0) == 21) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 }
}

function __ZN19CollisionListener2D12BeginContactEP9b2Contact(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i18 + 176 | 0;
 i9 = i18 + 64 | 0;
 i7 = i18 + 8 | 0;
 i10 = i18 + 160 | 0;
 i6 = i18;
 i3 = i18 + 144 | 0;
 if ((HEAP16[gb + 1458040 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458040 | 0, i4);
  i17 = gb + 1458040 | 0;
 } else i17 = 0;
 i13 = i1 + 48 | 0;
 i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 60 >> 2] | 0;
 i14 = i1 + 52 | 0;
 i15 = HEAP32[(HEAP32[i14 >> 2] | 0) + 60 >> 2] | 0;
 __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact(0, i12, i15, i1);
 __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact(1, i15, i12, i1);
 i12 = HEAP32[i1 + 4 >> 2] & 4;
 i13 = HEAP32[i13 >> 2] | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i15 = HEAP32[i13 + 60 >> 2] | 0;
 i16 = HEAP32[i14 + 60 >> 2] | 0;
 i5 = i15;
 i8 = i16;
 i1 = (HEAP32[i15 + 4 >> 2] | 0) > (HEAP32[i16 + 4 >> 2] | 0);
 HEAP32[i6 >> 2] = i1 ? i8 : i5;
 HEAP32[i6 + 4 >> 2] = i1 ? i5 : i8;
 i8 = i2 + 4 | 0;
 __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_(i3, i8, i6);
 i5 = i2 + 176 | 0;
 i2 = i2 + 180 | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 L4 : do if ((i3 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 80 | 0) | 0)) {
  __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_(i4, i8, i6);
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 80 | 0) | 0)) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 20 >> 2] = 0;
   i2 = i6;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i9;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   i3 = i9 + 8 | 0;
   i1 = i7;
   i2 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i1 = i9 + 72 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj(i8, 1, 0);
   __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_(i10, i8, i9);
   i1 = HEAP32[i10 + 4 >> 2] | 0;
  }
  i4 = i1 + 8 | 0;
  i3 = 0;
  i11 = 10;
 } else {
  i1 = i3 + 8 | 0;
  HEAP8[i3 + 79 >> 0] = i12 >>> 2;
  i2 = HEAP32[i3 + 72 >> 2] | 0;
  switch (i2 | 0) {
  case 5:
   {
    i4 = i1;
    i3 = 1;
    i11 = 10;
    break L4;
   }
  case 1:
   break;
  default:
   if ((i2 | 0) != 4) {
    i4 = i1;
    i3 = 0;
    i11 = 10;
    break L4;
   }
  }
  i16 = i3 + 28 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 } while (0);
 if ((i11 | 0) == 10) {
  if (!i15) i2 = 0; else if ((HEAP32[i15 + 72 >> 2] | 0) > 0) {
   i1 = HEAP32[(HEAP32[HEAP32[i15 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
   if (!i1) i2 = 0; else i2 = HEAP32[i1 + 148 >> 2] | 0;
  } else i2 = 0;
  if (!i16) i1 = 0; else if ((HEAP32[i16 + 72 >> 2] | 0) > 0) {
   i1 = HEAP32[(HEAP32[HEAP32[i16 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 148 >> 2] | 0;
  } else i1 = 0;
  if (!i3) HEAP8[i4 + 70 >> 0] = 0;
  HEAP8[i4 + 71 >> 0] = i12 >>> 2;
  HEAP32[i4 + 20 >> 2] = 1;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i15;
  HEAP32[i4 + 12 >> 2] = i16;
  HEAP8[i4 + 68 >> 0] = 0;
  HEAP32[i4 + 64 >> 2] = i3 ? 4 : 1;
  if (!(HEAP8[i13 + 58 >> 0] | 0)) i1 = HEAP8[i14 + 58 >> 0] | 0; else i1 = 1;
  HEAP8[i4 + 69 >> 0] = i1;
  HEAP32[i4 + 16 >> 2] = 0;
  i14 = gb + 1162356 | 0;
  i15 = HEAP32[i14 + 4 >> 2] | 0;
  i16 = i4 + 56 | 0;
  HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i16 + 4 >> 2] = i15;
 }
 if (!i17) {
  STACKTOP = i18;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i18;
 return;
}

function __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i25, i13, i9, i20, i22, i23) {
 i25 = i25 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26;
 __ZL8Perlin3DRKN4math8floatNx3ERKf(i24, i13, Math_fround(HEAPF32[i9 >> 2]));
 i8 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i7 = HEAP32[i24 + 8 >> 2] | 0;
 i6 = HEAP32[i24 + 12 >> 2] | 0;
 i5 = HEAP32[i24 + 16 >> 2] | 0;
 i4 = HEAP32[i24 + 20 >> 2] | 0;
 i3 = HEAP32[i24 + 24 >> 2] | 0;
 i2 = HEAP32[i24 + 28 >> 2] | 0;
 if ((i20 | 0) > 1) {
  i14 = i24 + 4 | 0;
  i15 = i24 + 8 | 0;
  i16 = i24 + 12 | 0;
  i17 = i24 + 16 | 0;
  i18 = i24 + 20 | 0;
  i19 = i24 + 24 | 0;
  i21 = i24 + 28 | 0;
  f10 = Math_fround(1.0);
  f11 = Math_fround(1.0);
  i12 = 1;
  i9 = HEAP32[i9 >> 2] | 0;
  do {
   f34 = Math_fround(HEAPF32[i22 >> 2]);
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f34);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i23 >> 2]));
   f10 = Math_fround(f10 + f11);
   __ZL8Perlin3DRKN4math8floatNx3ERKf(i24, i13, f34);
   f34 = Math_fround(f11 * Math_fround(HEAPF32[i24 >> 2]));
   f33 = Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2]));
   f32 = Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2]));
   f31 = Math_fround(f11 * Math_fround(HEAPF32[i16 >> 2]));
   f30 = Math_fround(f11 * Math_fround(HEAPF32[i17 >> 2]));
   f29 = Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2]));
   f28 = Math_fround(f11 * Math_fround(HEAPF32[i19 >> 2]));
   f27 = Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2]));
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
   f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f27);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i20 | 0));
 } else f10 = Math_fround(1.0);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 HEAPF32[i25 >> 2] = f27;
 HEAPF32[i25 + 4 >> 2] = f28;
 HEAPF32[i25 + 8 >> 2] = f29;
 HEAPF32[i25 + 12 >> 2] = f30;
 HEAPF32[i25 + 16 >> 2] = f31;
 HEAPF32[i25 + 20 >> 2] = f32;
 HEAPF32[i25 + 24 >> 2] = f33;
 HEAPF32[i25 + 28 >> 2] = f34;
 STACKTOP = i26;
 return;
}

function __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i25, i13, i9, i20, i22, i23) {
 i25 = i25 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26;
 __ZL8Perlin2DRKN4math8floatNx3ERKf(i24, i13, Math_fround(HEAPF32[i9 >> 2]));
 i8 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i7 = HEAP32[i24 + 8 >> 2] | 0;
 i6 = HEAP32[i24 + 12 >> 2] | 0;
 i5 = HEAP32[i24 + 16 >> 2] | 0;
 i4 = HEAP32[i24 + 20 >> 2] | 0;
 i3 = HEAP32[i24 + 24 >> 2] | 0;
 i2 = HEAP32[i24 + 28 >> 2] | 0;
 if ((i20 | 0) > 1) {
  i14 = i24 + 4 | 0;
  i15 = i24 + 8 | 0;
  i16 = i24 + 12 | 0;
  i17 = i24 + 16 | 0;
  i18 = i24 + 20 | 0;
  i19 = i24 + 24 | 0;
  i21 = i24 + 28 | 0;
  f10 = Math_fround(1.0);
  f11 = Math_fround(1.0);
  i12 = 1;
  i9 = HEAP32[i9 >> 2] | 0;
  do {
   f34 = Math_fround(HEAPF32[i22 >> 2]);
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f34);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i23 >> 2]));
   f10 = Math_fround(f10 + f11);
   __ZL8Perlin2DRKN4math8floatNx3ERKf(i24, i13, f34);
   f34 = Math_fround(f11 * Math_fround(HEAPF32[i24 >> 2]));
   f33 = Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2]));
   f32 = Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2]));
   f31 = Math_fround(f11 * Math_fround(HEAPF32[i16 >> 2]));
   f30 = Math_fround(f11 * Math_fround(HEAPF32[i17 >> 2]));
   f29 = Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2]));
   f28 = Math_fround(f11 * Math_fround(HEAPF32[i19 >> 2]));
   f27 = Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2]));
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
   f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f27);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i20 | 0));
 } else f10 = Math_fround(1.0);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 HEAPF32[i25 >> 2] = f27;
 HEAPF32[i25 + 4 >> 2] = f28;
 HEAPF32[i25 + 8 >> 2] = f29;
 HEAPF32[i25 + 12 >> 2] = f30;
 HEAPF32[i25 + 16 >> 2] = f31;
 HEAPF32[i25 + 20 >> 2] = f32;
 HEAPF32[i25 + 24 >> 2] = f33;
 HEAPF32[i25 + 28 >> 2] = f34;
 STACKTOP = i26;
 return;
}

function __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_(i25, i13, i9, i20, i22, i23) {
 i25 = i25 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i24 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26;
 __ZL8Perlin1DRKN4math8floatNx3ERKf(i24, i13, Math_fround(HEAPF32[i9 >> 2]));
 i8 = HEAP32[i24 >> 2] | 0;
 i1 = HEAP32[i24 + 4 >> 2] | 0;
 i7 = HEAP32[i24 + 8 >> 2] | 0;
 i6 = HEAP32[i24 + 12 >> 2] | 0;
 i5 = HEAP32[i24 + 16 >> 2] | 0;
 i4 = HEAP32[i24 + 20 >> 2] | 0;
 i3 = HEAP32[i24 + 24 >> 2] | 0;
 i2 = HEAP32[i24 + 28 >> 2] | 0;
 if ((i20 | 0) > 1) {
  i14 = i24 + 4 | 0;
  i15 = i24 + 8 | 0;
  i16 = i24 + 12 | 0;
  i17 = i24 + 16 | 0;
  i18 = i24 + 20 | 0;
  i19 = i24 + 24 | 0;
  i21 = i24 + 28 | 0;
  f10 = Math_fround(1.0);
  f11 = Math_fround(1.0);
  i12 = 1;
  i9 = HEAP32[i9 >> 2] | 0;
  do {
   f34 = Math_fround(HEAPF32[i22 >> 2]);
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f34);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround(f11 * Math_fround(HEAPF32[i23 >> 2]));
   f10 = Math_fround(f10 + f11);
   __ZL8Perlin1DRKN4math8floatNx3ERKf(i24, i13, f34);
   f34 = Math_fround(f11 * Math_fround(HEAPF32[i24 >> 2]));
   f33 = Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2]));
   f32 = Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2]));
   f31 = Math_fround(f11 * Math_fround(HEAPF32[i16 >> 2]));
   f30 = Math_fround(f11 * Math_fround(HEAPF32[i17 >> 2]));
   f29 = Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2]));
   f28 = Math_fround(f11 * Math_fround(HEAPF32[i19 >> 2]));
   f27 = Math_fround(f11 * Math_fround(HEAPF32[i21 >> 2]));
   f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f34);
   f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f33);
   f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f32);
   f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f31);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f34, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f33, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f30);
   f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f29);
   f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f28);
   f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f27);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i20 | 0));
 } else f10 = Math_fround(1.0);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f30 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f31 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f32 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f33 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 f34 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) / f10);
 HEAPF32[i25 >> 2] = f27;
 HEAPF32[i25 + 4 >> 2] = f28;
 HEAPF32[i25 + 8 >> 2] = f29;
 HEAPF32[i25 + 12 >> 2] = f30;
 HEAPF32[i25 + 16 >> 2] = f31;
 HEAPF32[i25 + 20 >> 2] = f32;
 HEAPF32[i25 + 24 >> 2] = f33;
 HEAPF32[i25 + 28 >> 2] = f34;
 STACKTOP = i26;
 return;
}

function __ZN14ParticleSystem20EmitParticleExternalER22ParticleSystemParticle(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, f13 = f0, f14 = f0, d15 = 0.0;
 i10 = i11 + 40 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP8[i2 + 26 >> 0] = 1;
 i6 = i9 + 104 | 0;
 i5 = i9 + 108 | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = f13 < Math_fround(HEAPF32[i6 >> 2]);
 i5 = HEAP32[(i1 ? i5 : i6) >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i2 = i2 + 392 | 0;
 i6 = i9 + 84 | 0;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 i1 = f13 < Math_fround(HEAPF32[i6 >> 2]);
 i1 = HEAP32[(i1 ? i6 : i2) >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i7 = i9 + 88 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f13 < Math_fround(HEAPF32[i7 >> 2]);
 i1 = HEAP32[(i1 ? i7 : i2) >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i8 = i9 + 92 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f13 < Math_fround(HEAPF32[i8 >> 2]);
 HEAP32[i2 >> 2] = HEAP32[(i1 ? i8 : i2) >> 2];
 if ((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) return;
 i1 = HEAP32[i11 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1 + 8 | 0;
  if ((HEAP32[i2 >> 2] | 0) != 1) {
   HEAP32[i2 >> 2] = 1;
   HEAP8[i1 + 13 >> 0] = 1;
  }
  __ZN14ParticleSystem12AddToManagerEv(i11);
 }
 i1 = i9 + 72 | 0;
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f13 * f13);
 i2 = i9 + 76 | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(f13 + Math_fround(f14 * f14));
 f13 = Math_fround(HEAPF32[i9 + 80 >> 2]);
 if (Math_fround(f14 + Math_fround(f13 * f13)) != Math_fround(0.0)) {
  i5 = HEAP32[i11 + 32 >> 2] | 0;
  if (!(HEAP8[i5 + 869 >> 0] | 0)) __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i5);
 }
 if (Math_fround(HEAPF32[i9 + 60 >> 2]) != Math_fround(0.0)) i12 = 12; else {
  i5 = Math_fround(HEAPF32[i9 + 64 >> 2]) != Math_fround(0.0);
  i5 = i5 | Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0);
  if (i5 | Math_fround(HEAPF32[i2 >> 2]) != Math_fround(0.0)) i12 = 12;
 }
 if ((i12 | 0) == 12) {
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 870 >> 0] | 0)) __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
  HEAP8[(HEAP32[i10 >> 2] | 0) + 28 >> 0] = 1;
 }
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = f14 != Math_fround(HEAPF32[i7 >> 2]);
 if (i7 | f14 != Math_fround(HEAPF32[i8 >> 2])) {
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 871 >> 0] | 0)) __ZN23ParticleSystemParticles13SetUses3DSizeEv(i1);
  HEAP8[(HEAP32[i10 >> 2] | 0) + 29 >> 0] = 1;
 }
 f14 = Math_fround(HEAPF32[i9 + 48 >> 2]);
 f14 = Math_fround(f14 * f14);
 f13 = Math_fround(HEAPF32[i9 + 52 >> 2]);
 f13 = Math_fround(f14 + Math_fround(f13 * f13));
 f14 = Math_fround(HEAPF32[i9 + 56 >> 2]);
 i1 = i11 + 32 | 0;
 if (Math_fround(f13 + Math_fround(f14 * f14)) != Math_fround(0.0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i2 + 868 >> 0] | 0)) __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i2);
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i8 = i1 + 1 | 0;
 i5 = i11 + 44 | 0;
 i7 = HEAP32[(HEAP32[i5 >> 2] | 0) + 2548 >> 2] | 0;
 i8 = i7 >>> 0 < i8 >>> 0 ? i7 : i8;
 i7 = ((i8 | 0) != (i1 | 0) & 1) + (i1 + 3 | 3) & -4;
 __ZN23ParticleSystemParticles13array_reserveEj(i6, i7 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i6, i7);
 i7 = i9 + 36 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) + 292 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii(i6, i9, 1, i1);
 __ZN23ParticleSystemParticles12array_resizeEj(i6, (i8 >>> 0 < i1 >>> 0 ? i8 : i1) + 1 | 0);
 i1 = HEAP32[i10 >> 2] | 0;
 do if (!(HEAP8[i1 + 30 >> 0] | 0)) i12 = 27; else {
  d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i10 >> 2] | 0;
  d3 = +HEAPF64[i1 + 40 >> 3];
  i2 = HEAP32[i11 + 36 >> 2] | 0;
  if (!(HEAP8[i2 + 277 >> 0] | 0)) {
   d15 = d4 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f14 = Math_fround(HEAPF32[i2 + 264 >> 2]);
   if (d15 > +Math_fround(f14 + Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + 88 >> 2]))) break;
  }
  if (!(HEAP8[i1 + 13 >> 0] | 0)) i12 = 27; else if (!(d4 - d3 > +Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + 88 >> 2]))) i12 = 27;
 } while (0);
 if ((i12 | 0) == 27) if ((HEAP32[i1 + 8 >> 2] | 0) == 1) return;
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i11, i6, i1);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIssEEPsEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -2 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 1;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 62) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 1) | 0;
    if ((i3 | 0) > 1998) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 1) | 0, i8, i8 + (i3 << 1) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP16[i1 >> 1] | 0;
    i5 = HEAP16[i8 >> 1] | 0;
    if (i7 << 16 >> 16 < i5 << 16 >> 16) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -2 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP16[i4 >> 1] | 0;
     if (i6 << 16 >> 16 < i5 << 16 >> 16) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 2 | 0;
    i5 = HEAP16[i14 >> 1] | 0;
    if (i7 << 16 >> 16 >= i5 << 16 >> 16) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP16[i3 >> 1] | 0;
      if (i7 << 16 >> 16 < i4 << 16 >> 16) break;
      i3 = i3 + 2 | 0;
     }
     HEAP16[i3 >> 1] = i5;
     HEAP16[i14 >> 1] = i4;
     i3 = i3 + 2 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP16[i1 >> 1] | 0;
     while (1) {
      i6 = HEAP16[i3 >> 1] | 0;
      i7 = i3 + 2 | 0;
      if (i8 << 16 >> 16 < i6 << 16 >> 16) break; else i3 = i7;
     }
     do {
      i4 = i4 + -2 | 0;
      i5 = HEAP16[i4 >> 1] | 0;
     } while (i8 << 16 >> 16 < i5 << 16 >> 16);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP16[i3 >> 1] = i5;
     HEAP16[i4 >> 1] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP16[i1 >> 1] = i6;
    HEAP16[i4 >> 1] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 2 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP16[i10 >> 1] | 0;
     while (1) {
      i7 = HEAP16[i5 >> 1] | 0;
      i8 = i5 + 2 | 0;
      if (i7 << 16 >> 16 < i9 << 16 >> 16) i5 = i8; else break;
     }
     do {
      i4 = i4 + -2 | 0;
      i6 = HEAP16[i4 >> 1] | 0;
     } while (i6 << 16 >> 16 >= i9 << 16 >> 16);
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP16[i5 >> 1] = i6;
     HEAP16[i4 >> 1] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP16[i6 >> 1] | 0;
    i5 = HEAP16[i7 >> 1] | 0;
    if (i4 << 16 >> 16 < i5 << 16 >> 16) {
     HEAP16[i7 >> 1] = i4;
     HEAP16[i6 >> 1] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIssEEPsEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 2 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIssEEPsEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIssEEPsEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 2 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIssEEPsEEvT0_S5_T_(i7 + 2 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP16[i14 >> 1] | 0;
  i3 = HEAP16[i1 >> 1] | 0;
  if (i2 << 16 >> 16 < i3 << 16 >> 16) {
   HEAP16[i1 >> 1] = i2;
   HEAP16[i14 >> 1] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i1, i1 + 2 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_(i1, i1 + 2 | 0, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_(i1, i1 + 2 | 0, i1 + 4 | 0, i1 + 6 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIssEEPsEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      HEAP8[i2 + 12 >> 0] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 902976 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine21SelectorStateConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       HEAP8[i2 + 12 >> 0] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 902976 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine21SelectorStateConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i21, i26, i22, i20) {
 i21 = i21 | 0;
 i26 = i26 | 0;
 i22 = i22 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = mftCall_iii(HEAP32[i20 >> 2] | 0, i26 | 0, i21 | 0) | 0;
 i1 = mftCall_iii(HEAP32[i20 >> 2] | 0, i22 | 0, i26 | 0) | 0;
 if (!i25) {
  if (!i1) {
   i26 = 0;
   return i26 | 0;
  }
  i10 = HEAP32[i26 >> 2] | 0;
  i19 = i26 + 4 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  i11 = i26 + 8 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i12 = i26 + 12 | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i13 = i26 + 16 | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  i14 = i26 + 20 | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i15 = i26 + 24 | 0;
  i6 = HEAP32[i15 >> 2] | 0;
  i16 = i26 + 28 | 0;
  i7 = HEAP32[i16 >> 2] | 0;
  i17 = i26 + 32 | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i18 = i26 + 36 | 0;
  i9 = HEAP32[i18 >> 2] | 0;
  i23 = i26;
  i24 = i22;
  i25 = i23 + 40 | 0;
  do {
   HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
   i23 = i23 + 4 | 0;
   i24 = i24 + 4 | 0;
  } while ((i23 | 0) < (i25 | 0));
  HEAP32[i22 >> 2] = i10;
  HEAP32[i22 + 4 >> 2] = i1;
  HEAP32[i22 + 8 >> 2] = i2;
  HEAP32[i22 + 12 >> 2] = i3;
  HEAP32[i22 + 16 >> 2] = i4;
  HEAP32[i22 + 20 >> 2] = i5;
  HEAP32[i22 + 24 >> 2] = i6;
  HEAP32[i22 + 28 >> 2] = i7;
  HEAP32[i22 + 32 >> 2] = i8;
  HEAP32[i22 + 36 >> 2] = i9;
  if (!(mftCall_iii(HEAP32[i20 >> 2] | 0, i26 | 0, i21 | 0) | 0)) {
   i26 = 1;
   return i26 | 0;
  }
  i1 = HEAP32[i21 >> 2] | 0;
  i2 = HEAP32[i21 + 4 >> 2] | 0;
  i3 = HEAP32[i21 + 8 >> 2] | 0;
  i4 = HEAP32[i21 + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i21 + 20 >> 2] | 0;
  i7 = HEAP32[i21 + 24 >> 2] | 0;
  i8 = HEAP32[i21 + 28 >> 2] | 0;
  i9 = HEAP32[i21 + 32 >> 2] | 0;
  i10 = HEAP32[i21 + 36 >> 2] | 0;
  i23 = i21;
  i24 = i26;
  i25 = i23 + 40 | 0;
  do {
   HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
   i23 = i23 + 4 | 0;
   i24 = i24 + 4 | 0;
  } while ((i23 | 0) < (i25 | 0));
  HEAP32[i26 >> 2] = i1;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i12 >> 2] = i4;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i14 >> 2] = i6;
  HEAP32[i15 >> 2] = i7;
  HEAP32[i16 >> 2] = i8;
  HEAP32[i17 >> 2] = i9;
  HEAP32[i18 >> 2] = i10;
  i26 = 2;
  return i26 | 0;
 }
 i2 = HEAP32[i21 >> 2] | 0;
 i3 = HEAP32[i21 + 4 >> 2] | 0;
 i4 = HEAP32[i21 + 8 >> 2] | 0;
 i5 = HEAP32[i21 + 12 >> 2] | 0;
 i7 = HEAP32[i21 + 16 >> 2] | 0;
 i8 = HEAP32[i21 + 20 >> 2] | 0;
 i11 = HEAP32[i21 + 24 >> 2] | 0;
 i12 = HEAP32[i21 + 28 >> 2] | 0;
 i13 = HEAP32[i21 + 32 >> 2] | 0;
 i14 = HEAP32[i21 + 36 >> 2] | 0;
 if (i1) {
  i23 = i21;
  i24 = i22;
  i25 = i23 + 40 | 0;
  do {
   HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
   i23 = i23 + 4 | 0;
   i24 = i24 + 4 | 0;
  } while ((i23 | 0) < (i25 | 0));
  HEAP32[i22 >> 2] = i2;
  HEAP32[i22 + 4 >> 2] = i3;
  HEAP32[i22 + 8 >> 2] = i4;
  HEAP32[i22 + 12 >> 2] = i5;
  HEAP32[i22 + 16 >> 2] = i7;
  HEAP32[i22 + 20 >> 2] = i8;
  HEAP32[i22 + 24 >> 2] = i11;
  HEAP32[i22 + 28 >> 2] = i12;
  HEAP32[i22 + 32 >> 2] = i13;
  HEAP32[i22 + 36 >> 2] = i14;
  i26 = 1;
  return i26 | 0;
 }
 i23 = i21;
 i24 = i26;
 i25 = i23 + 40 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i26 >> 2] = i2;
 i6 = i26 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 i3 = i26 + 8 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = i26 + 12 | 0;
 HEAP32[i4 >> 2] = i5;
 i5 = i26 + 16 | 0;
 HEAP32[i5 >> 2] = i7;
 i9 = i26 + 20 | 0;
 HEAP32[i9 >> 2] = i8;
 i10 = i26 + 24 | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = i26 + 28 | 0;
 HEAP32[i1 >> 2] = i12;
 i2 = i26 + 32 | 0;
 HEAP32[i2 >> 2] = i13;
 i8 = i26 + 36 | 0;
 HEAP32[i8 >> 2] = i14;
 if (!(mftCall_iii(HEAP32[i20 >> 2] | 0, i22 | 0, i26 | 0) | 0)) {
  i26 = 1;
  return i26 | 0;
 }
 i13 = HEAP32[i26 >> 2] | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i23 = i26;
 i24 = i22;
 i25 = i23 + 40 | 0;
 do {
  HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
  i23 = i23 + 4 | 0;
  i24 = i24 + 4 | 0;
 } while ((i23 | 0) < (i25 | 0));
 HEAP32[i22 >> 2] = i13;
 HEAP32[i22 + 4 >> 2] = i12;
 HEAP32[i22 + 8 >> 2] = i11;
 HEAP32[i22 + 12 >> 2] = i7;
 HEAP32[i22 + 16 >> 2] = i6;
 HEAP32[i22 + 20 >> 2] = i5;
 HEAP32[i22 + 24 >> 2] = i4;
 HEAP32[i22 + 28 >> 2] = i3;
 HEAP32[i22 + 32 >> 2] = i2;
 HEAP32[i22 + 36 >> 2] = i1;
 i26 = 2;
 return i26 | 0;
}

function __ZN7mecanim10ValueArray8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 32 | 0;
 i6 = i3 + 16 | 0;
 i8 = i3;
 i10 = i2 + 4 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 4;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i5;
 i5 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902750 | 0, i5, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 12;
 HEAP32[i8 + 4 >> 2] = i1 + 8;
 HEAP32[i8 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902767 | 0, i5, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 906539 | 0, i6, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 20;
 HEAP32[i8 + 4 >> 2] = i1 + 16;
 HEAP32[i8 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902786 | 0, i5, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 28;
 HEAP32[i8 + 4 >> 2] = i1 + 24;
 HEAP32[i8 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902800 | 0, i5, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 36;
 HEAP32[i8 + 4 >> 2] = i1 + 32;
 HEAP32[i8 + 8 >> 2] = i9;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902814 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 44;
 HEAP32[i8 + 4 >> 2] = i1 + 40;
 HEAP32[i8 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902826 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim12statemachine20StateMachineConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 24 | 0;
 i6 = i11 + 16 | 0;
 i7 = i11 + 12 | 0;
 i8 = i11;
 i9 = i2 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 4;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i3;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902860 | 0, i3, i8, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i7, 0);
 i4 = i5 + 52 | 0;
 i10 = i5;
 i12 = i10 + 52 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 56 >> 2] = Math_fround(0.0);
 HEAP8[i5 + 60 >> 0] = 1;
 HEAP8[i5 + 61 >> 0] = 1;
 HEAP8[i5 + 62 >> 0] = 0;
 HEAP8[i5 + 63 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 910026 | 0, i5, 0);
 __ZN7mecanim12statemachine13StateConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 12;
 HEAP32[i8 + 4 >> 2] = i1 + 8;
 HEAP32[i8 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902881 | 0, i3, i8, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i7, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAPF32[i5 + 32 >> 2] = Math_fround(.899999976);
 HEAP8[i5 + 36 >> 0] = 0;
 HEAP8[i5 + 37 >> 0] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP8[i5 + 44 >> 0] = 1;
 HEAP8[i5 + 45 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903185 | 0, i5, 0);
 __ZN7mecanim12statemachine18TransitionConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 20;
 HEAP32[i8 + 4 >> 2] = i1 + 16;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902915 | 0, i3, i8, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i7, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 902976 | 0, i5, 0);
 __ZN7mecanim12statemachine21SelectorStateConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902944 | 0, i9, i1 + 24 | 0, 0);
 i10 = i2 + 16 | 0;
 i12 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902959 | 0, i9, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i11;
 return;
}

function __ZN7mecanim12statemachine18TransitionConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i6 = i3 + 12 | 0;
 i5 = i3;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 4;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903088 | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i6, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903204 | 0, i6, i1 + 8 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903024 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 910040 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903223 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903232 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903253 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903174 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903272 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903286 | 0, i6, i1 + 37 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 40 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903305 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903326 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903348 | 0, i6, i1 + 45 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN18ProceduralMaterial17AwakeDependenciesEb(i15, i1) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i12 = i14;
 i7 = i15 + 124 | 0;
 i13 = i15 + 128 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i1 - i2 >> 2;
 if (!i8) {
  i16 = i15 + 172 | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 2048;
  STACKTOP = i14;
  return;
 }
 i10 = i15 + 204 | 0;
 i9 = i15 + 208 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = (i3 - i4 | 0) / 72 | 0;
 do if ((i8 | 0) != (i5 | 0)) {
  i6 = i3;
  if (i8 >>> 0 > i5 >>> 0) {
   __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE8__appendEj(i10, i8 - i5 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   break;
  }
  if (i8 >>> 0 < i5 >>> 0) {
   i3 = i4 + (i8 * 72 | 0) | 0;
   if ((i6 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i6 + (~(((i6 + -72 - i3 | 0) >>> 0) / 72 | 0) * 72 | 0);
  }
 } while (0);
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 i6 = 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (!i1) {
   i1 = 0;
   i16 = 21;
  } else {
   HEAP32[i12 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i16 = 17; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i3 = HEAP32[i11 >> 2] | 0;
     i9 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i16 = 17; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) break;
    }
   }
   if ((i16 | 0) == 17) i16 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
   if (!i1) i16 = 21;
  } while (0);
  if ((i16 | 0) == 21) {
   i16 = 0;
   HEAP32[i2 >> 2] = 0;
  }
  i5 = HEAP32[i10 >> 2] | 0;
  i3 = i5 + (i6 * 72 | 0) | 0;
  if (!i1) break;
  HEAP32[i3 >> 2] = HEAP32[i1 + 152 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 4 >> 2] = HEAP32[i1 + 156 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 8 >> 2] = HEAP32[i1 + 160 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 16 >> 2] = HEAP32[i1 + 168 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 20 >> 2] = HEAP32[i1 + 172 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 24 >> 2] = HEAP32[i1 + 176 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 12 >> 2] = HEAP32[i1 + 164 >> 2];
  i4 = i1 + 192 | 0;
  i9 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i5 + (i6 * 72 | 0) + 40 | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  i8 = i1 + 200 | 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = i5 + (i6 * 72 | 0) + 48 | 0;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + 4 >> 2] = i9;
  i4 = HEAP16[i1 + 180 >> 1] | 0;
  HEAP8[i5 + (i6 * 72 | 0) + 28 >> 0] = i4;
  HEAP8[i5 + (i6 * 72 | 0) + 29 >> 0] = (i4 & 65535) >>> 8;
  HEAP32[i5 + (i6 * 72 | 0) + 32 >> 2] = HEAP32[i1 + 184 >> 2];
  HEAP32[i5 + (i6 * 72 | 0) + 56 >> 2] = HEAP32[i1 + 208 >> 2];
  i4 = i5 + (i6 * 72 | 0) + 60 | 0;
  HEAP8[i4 >> 0] = HEAP8[i1 + 212 >> 0] | 0;
  HEAP32[i5 + (i6 * 72 | 0) + 64 >> 2] = HEAP32[i1 + 56 >> 2];
  if (!(HEAP8[i1 + 224 >> 0] | 0)) i3 = 0; else i3 = (HEAP32[i1 + 88 >> 2] | 0) != 0 & 1;
  HEAP8[i4 >> 0] = i3;
  i1 = i1 + 84 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i15;
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (HEAP32[i13 >> 2] | 0)) {
   i16 = 29;
   break;
  } else i6 = i6 + 1 | 0;
 }
 if ((i16 | 0) == 29) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i5 + (i6 * 72 | 0) + 24 >> 2] = 0;
 i16 = i5 + (i6 * 72 | 0) + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP8[i5 + (i6 * 72 | 0) + 28 >> 0] = 1;
 HEAP8[i5 + (i6 * 72 | 0) + 29 >> 0] = 0;
 HEAP32[i5 + (i6 * 72 | 0) + 32 >> 2] = 0;
 HEAP32[i5 + (i6 * 72 | 0) + 56 >> 2] = 0;
 HEAP8[i5 + (i6 * 72 | 0) + 60 >> 0] = 0;
 HEAP32[i5 + (i6 * 72 | 0) + 64 >> 2] = 0;
 i16 = i15 + 172 | 0;
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 2048;
 STACKTOP = i14;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i24 + 1 | 0;
 i7 = i24;
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E5clearEv(i12);
 i23 = i13 + 4 | 0;
 f2 = Math_fround(((HEAP32[i13 + 104 >> 2] | 0) - (HEAP32[i23 >> 2] | 0) | 0) >>> 0);
 i3 = 32;
 while (1) {
  if (i3 >>> 0 >= i1 >>> 0) {
   f5 = Math_fround(i3 >>> 0);
   f6 = Math_fround(f5 * Math_fround(.5));
   if (!(f2 >= f6)) break;
  }
  i3 = i3 << 1;
 }
 i22 = i12 + 100 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (i3 >>> 0 > i1 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i7 >> 0] | 0;
  __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i12, i3, i4);
  HEAP32[i22 >> 2] = i3;
  HEAP32[i12 + 112 >> 2] = ~~f6 >>> 0;
  HEAP32[i12 + 108 >> 2] = ~~Math_fround(f5 * Math_fround(.200000003)) >>> 0;
  HEAP8[i12 + 116 >> 0] = 0;
  i1 = i3;
 }
 i19 = i13 + 96 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 i20 = i13 + 100 | 0;
 i18 = HEAP32[i20 >> 2] | 0;
 i21 = i3 + (i18 * 40 | 0) | 0;
 L10 : do if (i18) {
  i9 = i13 + 56 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i10 = i13 + 8 | 0;
  i11 = i13 + 16 | 0;
  do {
   i7 = i3;
   i4 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   if (!((i8 | 0) == (i4 | 0) & (i9 | 0) == (i7 | 0))) {
    if (!(HEAP8[i10 >> 0] | 0)) break L10;
    if (!(HEAP32[i23 >> 2] | 0)) break L10;
    i18 = i11;
    if (!((HEAP32[i18 >> 2] | 0) == (i4 | 0) ? (HEAP32[i18 + 4 >> 2] | 0) == (i7 | 0) : 0)) break L10;
   }
   i3 = i3 + 40 | 0;
  } while ((i3 | 0) != (i21 | 0));
  STACKTOP = i24;
  return;
 } while (0);
 if ((i3 | 0) == (i21 | 0)) {
  STACKTOP = i24;
  return;
 }
 i17 = i12 + 56 | 0;
 i18 = i12 + 96 | 0;
 i14 = i12 + 104 | 0;
 i15 = i13 + 56 | 0;
 i16 = i13 + 8 | 0;
 i13 = i13 + 16 | 0;
 while (1) {
  i7 = i1 + -1 | 0;
  i11 = i3;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = i11 & i7;
  i12 = HEAP32[i18 >> 2] | 0;
  i9 = i17;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = i12 + (i1 * 40 | 0) | 0;
  if (!((i8 | 0) == (HEAP32[i4 >> 2] | 0) ? (i9 | 0) == (HEAP32[i4 + 4 >> 2] | 0) : 0)) {
   i4 = 0;
   do {
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i7;
    i25 = i12 + (i1 * 40 | 0) | 0;
   } while (!((i8 | 0) == (HEAP32[i25 >> 2] | 0) ? (i9 | 0) == (HEAP32[i25 + 4 >> 2] | 0) : 0));
  }
  i25 = i12 + (i1 * 40 | 0) | 0;
  HEAP32[i25 >> 2] = i10;
  HEAP32[i25 + 4 >> 2] = i11;
  HEAP32[i12 + (i1 * 40 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i12 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i12 + (i1 * 40 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i12 + (i1 * 40 | 0) + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i12 + (i1 * 40 | 0) + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i12 + (i1 * 40 | 0) + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  i11 = i3 + 32 | 0;
  i25 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = i12 + (i1 * 40 | 0) + 32 | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = i25;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  i1 = i3 + 40 | 0;
  L30 : do if ((i1 | 0) == (i21 | 0)) i1 = i21; else {
   i8 = i15;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   while (1) {
    i4 = i1;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (!((i7 | 0) == (i3 | 0) & (i8 | 0) == (i4 | 0))) {
     if (!(HEAP8[i16 >> 0] | 0)) break L30;
     if (!(HEAP32[i23 >> 2] | 0)) break L30;
     i25 = i13;
     if (!((HEAP32[i25 >> 2] | 0) == (i3 | 0) ? (HEAP32[i25 + 4 >> 2] | 0) == (i4 | 0) : 0)) break L30;
    }
    i1 = i1 + 40 | 0;
    if ((i1 | 0) == (i21 | 0)) {
     i1 = i21;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i19 >> 2] | 0) + ((HEAP32[i20 >> 2] | 0) * 40 | 0) | 0)) break;
  i3 = i1;
  i1 = HEAP32[i22 >> 2] | 0;
 }
 STACKTOP = i24;
 return;
}

function _cff_font_done(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i8 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = i8 + 112 | 0;
  if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
  _UNITY_ft_mem_free(i3, HEAP32[i8 + 108 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
 }
 i1 = i8 + 1208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = i8 + 1236 | 0;
  if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
  _UNITY_ft_mem_free(i3, HEAP32[i8 + 1232 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
 }
 i1 = i8 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = i8 + 48 | 0;
  if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
  _UNITY_ft_mem_free(i3, HEAP32[i8 + 44 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
 }
 i1 = i8 + 1176 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = i8 + 1204 | 0;
  if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
  _UNITY_ft_mem_free(i3, HEAP32[i8 + 1200 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
 }
 i7 = i8 + 1896 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i6 = 0;
  do {
   i5 = HEAP32[i8 + 1900 + (i6 << 2) >> 2] | 0;
   if (i5) {
    i1 = i5 + 536 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = i5 + 564 | 0;
     if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
     _UNITY_ft_mem_free(i3, HEAP32[i5 + 560 >> 2] | 0);
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i1 + 12 >> 2] = 0;
     HEAP32[i1 + 16 >> 2] = 0;
     HEAP32[i1 + 20 >> 2] = 0;
     HEAP32[i1 + 24 >> 2] = 0;
     HEAP32[i1 + 28 >> 2] = 0;
    }
    i1 = i5 + 568 | 0;
    _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i1 >>> 0);
  i7 = i8 + 1900 | 0;
  _UNITY_ft_mem_free(i9, HEAP32[i7 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
 }
 HEAP32[i8 + 116 >> 2] = 0;
 HEAP32[i8 + 120 >> 2] = 0;
 HEAP32[i8 + 124 >> 2] = 0;
 i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0;
 i1 = i8 + 1164 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i8 + 1168 >> 2] = 0;
 i1 = i8 + 1160 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i8 + 1152 >> 2] = 0;
 HEAP32[i8 + 1156 >> 2] = 0;
 i1 = i8 + 1860 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i4 = i8 + 1888 | 0;
  if (HEAP32[i4 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i2, i4);
  _UNITY_ft_mem_free(i3, HEAP32[i8 + 1884 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
 }
 i1 = i8 + 1892 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 2932 | 0;
 if (HEAP32[i1 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(HEAP32[i8 >> 2] | 0, i1);
 HEAP32[i8 + 2936 >> 2] = 0;
 HEAP8[i8 + 2924 >> 0] = 0;
 HEAP32[i8 + 2928 >> 2] = 0;
 i1 = i8 + 2960 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 1304 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 1308 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 1316 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 1320 | 0;
 _UNITY_ft_mem_free(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i8 + 2976 >> 2] | 0;
 if (!i1) return;
 i8 = i8 + 2972 | 0;
 mftCall_vi(i1 | 0, HEAP32[i8 >> 2] | 0);
 _UNITY_ft_mem_free(i9, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(i25, i2, i1, i26) {
 i25 = i25 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i30 + 32 | 0;
 i28 = i30 + 16 | 0;
 i29 = i30;
 i22 = i1 ? 3 : 1;
 i23 = i25 + 800 | 0;
 i24 = i2 + 108 | 0;
 i21 = i2 + 104 | 0;
 i7 = i2 + 100 | 0;
 i8 = i28 + 12 | 0;
 i9 = i28 + 8 | 0;
 i10 = i28 + 4 | 0;
 i11 = i29 + 12 | 0;
 i12 = i29 + 8 | 0;
 i13 = i29 + 4 | 0;
 i14 = i28 + 12 | 0;
 i15 = i28 + 8 | 0;
 i16 = i28 + 4 | 0;
 i17 = i29 + 12 | 0;
 i18 = i29 + 8 | 0;
 i19 = i29 + 4 | 0;
 i6 = 0;
 do {
  i4 = HEAP8[i23 >> 0] | 0 ? i6 : 0;
  i20 = i25 + 8 + (i4 * 264 | 0) | 0;
  i1 = HEAP16[i25 + 8 + (i4 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i1 << 16 >> 16)) {
   i20 = i26 + (i6 << 2) | 0;
   f3 = Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 80 >> 2]);
   i5 = f3 > Math_fround(0.0);
   f3 = i5 ? f3 : Math_fround(0.0);
   HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f3);
  } else {
   if (!(HEAP8[i25 + 8 + (i4 * 264 | 0) + 86 >> 0] | 0)) {
    i1 = i26 + (i6 << 2) | 0;
    f3 = Math_fround(HEAPF32[i24 >> 2]);
    if (f3 != Math_fround(0.0)) f3 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i21 >> 2])) / f3); else f3 = Math_fround(0.0);
    i4 = (HEAP32[i7 >> 2] | 0) + -1926462415 | 0;
    i5 = (Math_imul(i4, 1790253981) | 0) + 1900727103 | 0;
    i4 = i4 << 11 ^ i4;
    f31 = Math_fround(Math_fround(((i5 ^ i4 ^ i4 >>> 8) & 8388607 ^ i5 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    HEAPF32[i8 >> 2] = f3;
    HEAPF32[i9 >> 2] = f3;
    HEAPF32[i10 >> 2] = f3;
    HEAPF32[i28 >> 2] = f3;
    HEAPF32[i11 >> 2] = f31;
    HEAPF32[i12 >> 2] = f31;
    HEAPF32[i13 >> 2] = f31;
    HEAPF32[i29 >> 2] = f31;
    __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i27, i20, i28, i29);
    f3 = Math_fround(HEAPF32[i27 >> 2]);
    i20 = f3 > Math_fround(0.0);
    f3 = i20 ? f3 : Math_fround(0.0);
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f3);
    break;
   }
   i5 = i26 + (i6 << 2) | 0;
   f3 = Math_fround(HEAPF32[i24 >> 2]);
   i2 = f3 != Math_fround(0.0);
   if ((i1 | 1) << 16 >> 16 == 3) {
    if (i2) f3 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i21 >> 2])) / f3); else f3 = Math_fround(0.0);
    i2 = (HEAP32[i7 >> 2] | 0) + -1926462415 | 0;
    i4 = (Math_imul(i2, 1790253981) | 0) + 1900727103 | 0;
    i2 = i2 << 11 ^ i2;
    f31 = Math_fround(Math_fround(((i4 ^ i2 ^ i2 >>> 8) & 8388607 ^ i4 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
    HEAPF32[i14 >> 2] = f3;
    HEAPF32[i15 >> 2] = f3;
    HEAPF32[i16 >> 2] = f3;
    HEAPF32[i28 >> 2] = f3;
    HEAPF32[i17 >> 2] = f31;
    HEAPF32[i18 >> 2] = f31;
    HEAPF32[i19 >> 2] = f31;
    HEAPF32[i29 >> 2] = f31;
    __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i27, i20, i28, i29);
    f31 = Math_fround(HEAPF32[i27 >> 2]);
    i20 = f31 > Math_fround(0.0);
    f31 = i20 ? f31 : Math_fround(0.0);
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f31);
    break;
   } else {
    if (i2) f3 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i21 >> 2])) / f3); else f3 = Math_fround(0.0);
    f33 = Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 32 >> 2]);
    f31 = Math_fround(f3 * Math_fround(HEAPF32[i20 >> 2]));
    f31 = Math_fround(f3 * Math_fround(f31 + Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 4 >> 2])));
    f31 = Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 8 >> 2]) + f31));
    f31 = Math_fround(Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 12 >> 2]) + f31);
    f34 = Math_fround(f3 - f33);
    f32 = Math_fround(f34 * Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 16 >> 2]));
    f32 = Math_fround(f34 * Math_fround(f32 + Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 20 >> 2])));
    f32 = Math_fround(f34 * Math_fround(Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 24 >> 2]) + f32));
    f32 = Math_fround(Math_fround(HEAPF32[i25 + 8 + (i4 * 264 | 0) + 28 >> 2]) + f32);
    f31 = f3 > f33 ? f32 : f31;
    i20 = f31 > Math_fround(0.0);
    f31 = i20 ? f31 : Math_fround(0.0);
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f31);
    break;
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i22 | 0));
 STACKTOP = i30;
 return;
}

function __ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb(i5, i21, i20, i19, i10) {
 i5 = i5 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f22 = f0, f23 = f0;
 if (!((i5 | 0) != 0 & (i21 | 0) != 0 & (i20 | 0) != 0 & (i19 | 0) != 0)) {
  i21 = 0;
  return i21 | 0;
 }
 f6 = Math_fround(Math_fround(1.0) / Math_fround(i5 >>> 0));
 f2 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 i1 = 0;
 do {
  f2 = Math_fround(f2 + Math_fround(f6 * Math_fround(HEAPF32[i21 + (i1 * 12 | 0) >> 2])));
  f3 = Math_fround(f3 + Math_fround(f6 * Math_fround(HEAPF32[i21 + (i1 * 12 | 0) + 4 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i21 + (i1 * 12 | 0) + 8 >> 2])));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 if (i10) {
  i1 = 1;
  i18 = 0;
 } else {
  i1 = 1;
  i5 = 0;
  do {
   i17 = HEAP32[i19 + (i5 * 12 | 0) >> 2] | 0;
   i16 = HEAP32[i19 + (i5 * 12 | 0) + 4 >> 2] | 0;
   i18 = HEAP32[i19 + (i5 * 12 | 0) + 8 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i21 + (i16 * 12 | 0) >> 2]);
   f14 = Math_fround(HEAPF32[i21 + (i17 * 12 | 0) >> 2]);
   f22 = Math_fround(f22 - f14);
   f7 = Math_fround(HEAPF32[i21 + (i16 * 12 | 0) + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i21 + (i17 * 12 | 0) + 4 >> 2]);
   f7 = Math_fround(f7 - f12);
   f23 = Math_fround(HEAPF32[i21 + (i16 * 12 | 0) + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i21 + (i17 * 12 | 0) + 8 >> 2]);
   f23 = Math_fround(f23 - f13);
   f6 = Math_fround(Math_fround(HEAPF32[i21 + (i18 * 12 | 0) >> 2]) - f14);
   f8 = Math_fround(Math_fround(HEAPF32[i21 + (i18 * 12 | 0) + 4 >> 2]) - f12);
   f9 = Math_fround(Math_fround(HEAPF32[i21 + (i18 * 12 | 0) + 8 >> 2]) - f13);
   f11 = Math_fround(Math_fround(f7 * f9) - Math_fround(f23 * f8));
   f9 = Math_fround(Math_fround(f23 * f6) - Math_fround(f22 * f9));
   f6 = Math_fround(Math_fround(f22 * f8) - Math_fround(f7 * f6));
   f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9)));
   if (f7 > Math_fround(0.0)) {
    f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
    f8 = Math_fround(f6 * f23);
    f7 = Math_fround(f9 * f23);
    f6 = Math_fround(f11 * f23);
   } else {
    f8 = Math_fround(0.0);
    f7 = Math_fround(0.0);
    f6 = Math_fround(0.0);
   }
   i1 = i1 & !(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f6) + Math_fround(f3 * f7)) + Math_fround(f4 * f8)) - Math_fround(Math_fround(Math_fround(f14 * f6) + Math_fround(f12 * f7)) + Math_fround(f13 * f8))) > Math_fround(0.0));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i20 | 0));
  return i1 | 0;
 }
 do {
  i5 = HEAP32[i19 + (i18 * 12 | 0) >> 2] | 0;
  i10 = i19 + (i18 * 12 | 0) + 4 | 0;
  i15 = HEAP32[i10 >> 2] | 0;
  i16 = i19 + (i18 * 12 | 0) + 8 | 0;
  i17 = HEAP32[i16 >> 2] | 0;
  f22 = Math_fround(HEAPF32[i21 + (i15 * 12 | 0) >> 2]);
  f12 = Math_fround(HEAPF32[i21 + (i5 * 12 | 0) >> 2]);
  f22 = Math_fround(f22 - f12);
  f7 = Math_fround(HEAPF32[i21 + (i15 * 12 | 0) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i21 + (i5 * 12 | 0) + 4 >> 2]);
  f7 = Math_fround(f7 - f13);
  f8 = Math_fround(HEAPF32[i21 + (i15 * 12 | 0) + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i21 + (i5 * 12 | 0) + 8 >> 2]);
  f8 = Math_fround(f8 - f14);
  f6 = Math_fround(Math_fround(HEAPF32[i21 + (i17 * 12 | 0) >> 2]) - f12);
  f23 = Math_fround(Math_fround(HEAPF32[i21 + (i17 * 12 | 0) + 4 >> 2]) - f13);
  f9 = Math_fround(Math_fround(HEAPF32[i21 + (i17 * 12 | 0) + 8 >> 2]) - f14);
  f11 = Math_fround(Math_fround(f7 * f9) - Math_fround(f8 * f23));
  f9 = Math_fround(Math_fround(f8 * f6) - Math_fround(f22 * f9));
  f6 = Math_fround(Math_fround(f22 * f23) - Math_fround(f7 * f6));
  f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9)));
  if (f7 > Math_fround(0.0)) {
   f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
   f8 = Math_fround(f6 * f23);
   f7 = Math_fround(f9 * f23);
   f6 = Math_fround(f11 * f23);
  } else {
   f8 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f6 = Math_fround(0.0);
  }
  i5 = !(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f6) + Math_fround(f3 * f7)) + Math_fround(f4 * f8)) - Math_fround(Math_fround(Math_fround(f12 * f6) + Math_fround(f13 * f7)) + Math_fround(f14 * f8))) > Math_fround(0.0));
  if (i5) i1 = i1 & i5; else {
   HEAP32[i10 >> 2] = i17;
   HEAP32[i16 >> 2] = i15;
   i1 = 0;
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i20 | 0));
 return i1 | 0;
}

function __ZN13WheelCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034411 | 0, HEAP32[gb + 37324 >> 2] | 0, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827182 | 0, gb + 827201 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827430 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827213 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827234 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827258 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827265 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 104 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827284 | 0, gb + 827321 | 0, i5, 0);
 __ZN18WheelFrictionCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 124 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827302 | 0, gb + 827321 | 0, i5, 0);
 __ZN18WheelFrictionCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 41 | 0, 257);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZNK14MemoryProfiler21ReportAllocatedMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 96 | 0;
 i11 = i21 + 64 | 0;
 i13 = i21 + 32 | 0;
 i3 = i21;
 i16 = i21 + 132 | 0;
 i17 = i21 + 112 | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i3;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i14;
 HEAP32[i16 >> 2] = 0;
 i19 = i16 + 12 | 0;
 i14 = i16 + 16 | 0;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i3);
 i20 = i13;
 i8 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i15;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i8;
 HEAP32[i19 >> 2] = 6;
 HEAP32[i14 >> 2] = 6;
 i18 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 24, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i16 >> 2] = i18;
 _memcpy(i18 | 0, gb + 66288 | 0, HEAP32[i19 >> 2] << 2 | 0) | 0;
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i8 + 4 >> 2] = i18;
 HEAP32[i17 >> 2] = 0;
 i8 = i17 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i18 = i17 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i3);
 i20 = i13;
 i9 = HEAP32[i20 + 4 >> 2] | 0;
 i1 = i19;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = __ZNK14MemoryProfiler22GetMemLabelAllocationsER13dynamic_arrayINSt3__24pairIijEELj4EEPKS0_IiLj4EE(0, i17, i16) | 0;
 HEAP32[i13 >> 2] = 0;
 i9 = i13 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 i20 = i13 + 24 | 0;
 i7 = gb + 64016 | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i20;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i2;
 i10 = i13 + 4 | 0;
 HEAP8[i10 >> 0] = 0;
 i2 = (HEAP32[i8 >> 2] << 7) + 256 | 0;
 if (i2 >>> 0 >= 15) __ZN4core20StringStorageDefaultIcE10reallocateEj(i13, i2);
 __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i13, gb + 462017 | 0) | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = 0;
 __Z12FormatStringPKcz(i3, gb + 462066 | 0, i11);
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i13, HEAP32[i9 >> 2] | 0, 0, (i1 | 0) == 0 ? i3 + 4 | 0 : i1, HEAP32[i3 + 20 >> 2] | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 24 | 0);
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i13, HEAP32[i9 >> 2] | 0, 0, gb + 462090 | 0, 16);
 if (HEAP32[i8 >> 2] | 0) {
  i3 = i11 + 4 | 0;
  i4 = i11 + 4 | 0;
  i5 = i11 + 20 | 0;
  i6 = i11 + 4 | 0;
  i7 = i11 + 24 | 0;
  i2 = 0;
  do {
   i1 = __Z16GetMemoryManagerv() | 0;
   HEAP32[i11 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + (i2 << 3) >> 2];
   HEAP32[i3 >> 2] = 0;
   i1 = __ZN13MemoryManager13GetMemcatNameERK10MemLabelId(i1, i11) | 0;
   i22 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   i1 = i12 + 8 | 0;
   HEAP32[i1 >> 2] = i22;
   HEAP32[i1 + 4 >> 2] = 0;
   __Z12FormatStringPKcz(i11, gb + 462107 | 0, i12);
   i1 = HEAP32[i11 >> 2] | 0;
   __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i13, HEAP32[i9 >> 2] | 0, 0, (i1 | 0) == 0 ? i4 : i1, HEAP32[i5 >> 2] | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   if (!((i1 | 0) == 0 | (HEAP32[i6 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (HEAP32[i8 >> 2] | 0)) i1 = i2; else {
    __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i13, HEAP32[i9 >> 2] | 0, 0, gb + 1087585 | 0, 1);
    i1 = HEAP32[i8 >> 2] | 0;
   }
  } while (i2 >>> 0 < i1 >>> 0);
 }
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i13, HEAP32[i9 >> 2] | 0, 0, gb + 1046920 | 0, 2);
 i1 = __Z20GetStackTraceLogType7LogType(3) | 0;
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(3, 0);
 i22 = HEAP32[i13 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i22 | 0) == 0 ? i10 : i22, 0, gb + 461921 | 0, 806, 262148, 0, 0, 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(3, i1);
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i13 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i20);
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i19);
  HEAP32[i17 >> 2] = 0;
 }
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i21;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(i4, i1, i5, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i1;
 i2 = i2 + i3 + 40 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) return;
 i8 = i7 + 4 | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim5human10TwistSolveEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_((i2 | 0) == 0 ? 0 : i2 + i3 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 + 8 >> 2] | 0);
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i4 + 28 | 0;
 i7 = i2;
 i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + i7 >> 2] | 0;
 i11 = i4 + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i10 | 0) == 0 ? 0 : i10 + i11 | 0, i5);
 i11 = i5 + 4 | 0;
 i10 = i11;
 i12 = (HEAP32[i11 >> 2] | 0) + i10 | 0;
 i14 = i12;
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 i13 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i14 + 8 >> 2] = i13;
 i13 = HEAP32[i6 + 16 >> 2] | 0;
 i15 = HEAP32[i6 + 20 >> 2] | 0;
 i12 = HEAP32[i6 + 24 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = i13;
 HEAP32[i14 + 20 >> 2] = i15;
 HEAP32[i14 + 24 >> 2] = i12;
 i12 = HEAP32[i6 + 32 >> 2] | 0;
 i15 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i14 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i14 + 32 >> 2] = i12;
 HEAP32[i14 + 36 >> 2] = i15;
 i14 = (HEAP32[i1 >> 2] | 0) + i3 + 40 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i6 | 0) == 0 ? 0 : i14 + i6 | 0, i15, i15, 1, 1);
 i15 = HEAP32[i4 >> 2] | 0;
 i6 = i4;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i15 | 0) == 0 ? 0 : i15 + i6 | 0, i5, i5, i9, 0);
 i15 = (HEAP32[i11 >> 2] | 0) + i10 | 0;
 i14 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
 i14 = i14 + (HEAP32[i14 >> 2] | 0) | 0;
 i12 = i14;
 i13 = HEAP32[i15 + (i9 * 40 | 0) + 4 >> 2] | 0;
 i16 = HEAP32[i15 + (i9 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 + (i9 * 40 | 0) >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i12 + 8 >> 2] = i16;
 i16 = HEAP32[i15 + (i9 * 40 | 0) + 16 >> 2] | 0;
 i13 = HEAP32[i15 + (i9 * 40 | 0) + 20 >> 2] | 0;
 i14 = HEAP32[i15 + (i9 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = HEAP32[i15 + (i9 * 40 | 0) + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i13;
 HEAP32[i12 + 24 >> 2] = i14;
 i14 = HEAP32[i15 + (i9 * 40 | 0) + 32 >> 2] | 0;
 i13 = HEAP32[i15 + (i9 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i12 + 28 >> 2] = HEAP32[i15 + (i9 * 40 | 0) + 28 >> 2];
 HEAP32[i12 + 32 >> 2] = i14;
 HEAP32[i12 + 36 >> 2] = i13;
 i12 = HEAP32[i4 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i12 | 0) == 0 ? 0 : i12 + i6 | 0, i5, i5, i9, 0);
 i1 = (HEAP32[i1 >> 2] | 0) + i3 + 40 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i6 | 0) == 0 ? 0 : i1 + i6 | 0, i3, i3, 1, 1);
 i10 = (HEAP32[i11 >> 2] | 0) + i10 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + 4 | 0;
 i8 = i8 + (HEAP32[i8 >> 2] | 0) | 0;
 i6 = i8;
 i1 = HEAP32[i10 + (i9 * 40 | 0) + 4 >> 2] | 0;
 i11 = HEAP32[i10 + (i9 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 + (i9 * 40 | 0) >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i11;
 i11 = HEAP32[i10 + (i9 * 40 | 0) + 16 >> 2] | 0;
 i1 = HEAP32[i10 + (i9 * 40 | 0) + 20 >> 2] | 0;
 i8 = HEAP32[i10 + (i9 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = HEAP32[i10 + (i9 * 40 | 0) + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = i11;
 HEAP32[i6 + 20 >> 2] = i1;
 HEAP32[i6 + 24 >> 2] = i8;
 i8 = HEAP32[i10 + (i9 * 40 | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i10 + (i9 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i6 + 28 >> 2] = HEAP32[i10 + (i9 * 40 | 0) + 28 >> 2];
 HEAP32[i6 + 32 >> 2] = i8;
 HEAP32[i6 + 36 >> 2] = i1;
 i6 = HEAP32[i2 >> 2] | 0;
 __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EEjPKi(i3, i5, HEAP32[i4 + 24 >> 2] | 0, (i6 | 0) == 0 ? 0 : i6 + i7 | 0);
 return;
}

function __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 4;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i7 + 8 >> 2] = i8;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i5, i7, 0);
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i5 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i4 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i4 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i4 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i4 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i4 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i4 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i4 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 36 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i4 + 37 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 44 >> 0] = i1;
 i1 = i4 + 45 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i6;
  HEAP32[i8 >> 2] = i3;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __Z26TransformVerticesInnerLoopILb1ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i5, i29, i30, i6, i4, i31, i32, i33, i2, i34, i3, i1) {
 i5 = i5 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i2 = i2 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i9 = (i3 | 0) / 4 | 0;
 if (!i6) return;
 i10 = i29 + 16 | 0;
 i11 = i29 + 32 | 0;
 i12 = i29 + 48 | 0;
 i13 = i29 + 4 | 0;
 i14 = i29 + 20 | 0;
 i15 = i29 + 36 | 0;
 i16 = i29 + 52 | 0;
 i17 = i29 + 8 | 0;
 i18 = i29 + 24 | 0;
 i19 = i29 + 40 | 0;
 i20 = i29 + 56 | 0;
 i21 = i30 + 12 | 0;
 i22 = i30 + 24 | 0;
 i23 = i30 + 4 | 0;
 i24 = i30 + 16 | 0;
 i25 = i30 + 28 | 0;
 i26 = i30 + 8 | 0;
 i27 = i30 + 20 | 0;
 i28 = i30 + 32 | 0;
 i8 = (i3 | 0) > 3;
 i1 = i5;
 i7 = i6;
 while (1) {
  i7 = i7 + -1 | 0;
  f35 = Math_fround(HEAPF32[i29 >> 2]);
  f35 = Math_fround(f35 * Math_fround(HEAPF32[i4 >> 2]));
  f36 = Math_fround(HEAPF32[i10 >> 2]);
  i5 = i4 + 4 | 0;
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f36 = Math_fround(f35 + Math_fround(f36 * f37));
  f35 = Math_fround(HEAPF32[i11 >> 2]);
  f38 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f35 = Math_fround(f36 + Math_fround(f35 * f38));
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f35);
  f35 = Math_fround(HEAPF32[i13 >> 2]);
  f36 = Math_fround(HEAPF32[i4 >> 2]);
  f35 = Math_fround(f35 * f36);
  f37 = Math_fround(f35 + Math_fround(f37 * Math_fround(HEAPF32[i14 >> 2])));
  f37 = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i15 >> 2])));
  HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f37);
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i17 >> 2]));
  f37 = Math_fround(HEAPF32[i18 >> 2]);
  f37 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i5 >> 2])));
  f38 = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i19 >> 2])));
  HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f38);
  i5 = i4 + i31 | 0;
  f38 = Math_fround(HEAPF32[i30 >> 2]);
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i5 >> 2]));
  f37 = Math_fround(HEAPF32[i21 >> 2]);
  i6 = i5 + 4 | 0;
  f36 = Math_fround(HEAPF32[i6 >> 2]);
  f37 = Math_fround(f38 + Math_fround(f37 * f36));
  f38 = Math_fround(HEAPF32[i22 >> 2]);
  f35 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  HEAPF32[i1 + 12 >> 2] = Math_fround(f37 + Math_fround(f38 * f35));
  f38 = Math_fround(HEAPF32[i23 >> 2]);
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f38 = Math_fround(f38 * f37);
  f36 = Math_fround(f38 + Math_fround(f36 * Math_fround(HEAPF32[i24 >> 2])));
  HEAPF32[i1 + 16 >> 2] = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i25 >> 2])));
  f37 = Math_fround(f37 * Math_fround(HEAPF32[i26 >> 2]));
  f36 = Math_fround(HEAPF32[i27 >> 2]);
  f36 = Math_fround(f37 + Math_fround(f36 * Math_fround(HEAPF32[i6 >> 2])));
  HEAPF32[i1 + 20 >> 2] = Math_fround(f36 + Math_fround(f35 * Math_fround(HEAPF32[i28 >> 2])));
  i1 = i1 + 24 | 0;
  if (!i2) i2 = 0; else {
   if (i8) {
    i6 = 0;
    i3 = i2;
    while (1) {
     i5 = i1 + 4 | 0;
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     i6 = i6 + 1 | 0;
     if ((i6 | 0) >= (i9 | 0)) {
      i1 = i5;
      break;
     } else {
      i1 = i5;
      i3 = i3 + 4 | 0;
     }
    }
   }
   i2 = i2 + i34 | 0;
  }
  i6 = i4 + i32 | 0;
  f35 = Math_fround(HEAPF32[i29 >> 2]);
  f35 = Math_fround(f35 * Math_fround(HEAPF32[i6 >> 2]));
  f36 = Math_fround(HEAPF32[i10 >> 2]);
  i5 = i6 + 4 | 0;
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f36 = Math_fround(f35 + Math_fround(f36 * f37));
  f35 = Math_fround(HEAPF32[i11 >> 2]);
  f38 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f36 + Math_fround(f35 * f38));
  f35 = Math_fround(HEAPF32[i13 >> 2]);
  f36 = Math_fround(HEAPF32[i6 >> 2]);
  f35 = Math_fround(f35 * f36);
  f37 = Math_fround(f35 + Math_fround(f37 * Math_fround(HEAPF32[i14 >> 2])));
  HEAPF32[i1 + 4 >> 2] = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i15 >> 2])));
  f36 = Math_fround(f36 * Math_fround(HEAPF32[i17 >> 2]));
  f37 = Math_fround(HEAPF32[i18 >> 2]);
  f37 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i1 + 8 >> 2] = Math_fround(f37 + Math_fround(f38 * Math_fround(HEAPF32[i19 >> 2])));
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  if (!i7) break; else {
   i4 = i4 + i33 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, f35 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i33;
 i28 = i8 + 260 | 0;
 HEAP32[i28 >> 2] = 0;
 i29 = i8 + 280 | 0;
 L1 : do if ((HEAP32[i29 >> 2] | 0) < 0) i1 = i8 + 352 | 0; else {
  i30 = i8 + 196 | 0;
  i31 = i8 + 356 | 0;
  i32 = i8 + 320 | 0;
  i10 = i8 + 324 | 0;
  i11 = i8 + 184 | 0;
  i12 = i8 + 344 | 0;
  i13 = i8 + 332 | 0;
  i14 = i8 + 229 | 0;
  i15 = i8 + 436 | 0;
  i16 = i8 + 320 | 0;
  i17 = i8 + 376 | 0;
  i18 = i8 + 272 | 0;
  i19 = i8 + 316 | 0;
  i21 = i8 + 300 | 0;
  i22 = i8 + 312 | 0;
  i23 = i8 + 276 | 0;
  i24 = i8 + 268 | 0;
  i25 = i8 + 352 | 0;
  i26 = i8 + 253 | 0;
  i27 = i8 + 248 | 0;
  L4 : while (1) {
   if (!(__ZN20TextRenderingPrivate19NativeTextGenerator24ProcessFormatForPositionEv(i8) | 0)) {
    i1 = 0;
    i2 = 22;
    break;
   }
   i5 = HEAP32[i28 >> 2] | 0;
   if ((i5 | 0) < (HEAP32[i29 >> 2] | 0)) i4 = HEAPU16[(HEAP32[i30 >> 2] | 0) + (i5 << 1) >> 1] | 0; else i4 = 10;
   i6 = HEAP32[i31 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i10 >> 2]);
   i34 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) + 8 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i34 + 76 >> 2] | 0) + 36 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i34 + 192 >> 2]);
   if (!((i1 | 0) == 0 | (i2 | 0) == 0)) {
    f35 = Math_fround(i2 | 0);
    f3 = Math_fround(Math_fround(Math_fround(((i1 | 0) > 500 ? 500 : i1) | 0) * f3) / f35);
   }
   if (HEAP8[i14 >> 0] | 0) {
    f35 = Math_fround(HEAPF32[i27 >> 2]);
    f3 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f3 * f35) + Math_fround(.5)))) / f35);
   }
   f35 = Math_fround(f7 - f3);
   HEAP32[i6 + (i5 << 3) >> 2] = HEAP32[i32 >> 2];
   HEAPF32[i6 + (i5 << 3) + 4 >> 2] = f35;
   L16 : do switch ((i4 & 65535) << 16 >> 16) {
   case 10:
    {
     i34 = HEAP32[i15 >> 2] | 0;
     i5 = i34 + 60 | 0;
     i6 = i34 + 120 | 0;
     i4 = i34 + 180 | 0;
     HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     _memmove(i6 | 0, i16 | 0, 12) | 0;
     HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i34 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i34 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i34 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 240;
     i34 = HEAP32[i28 >> 2] | 0;
     HEAPF32[(HEAP32[i17 >> 2] | 0) + (i34 << 2) >> 2] = Math_fround(0.0);
     __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii(i8, HEAP32[i18 >> 2] | 0, i34 + -1 | 0, i34);
     i34 = Math_fround(HEAPF32[i19 >> 2]) < Math_fround(HEAPF32[i21 >> 2]);
     HEAP32[i19 >> 2] = HEAP32[(i34 ? i21 : i19) >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     if (__ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf(i8, HEAP32[i18 >> 2] | 0, (HEAP32[i28 >> 2] | 0) + 1 | 0, i20) | 0) {
      HEAPF32[i16 >> 2] = Math_fround(0.0);
      HEAPF32[i21 >> 2] = Math_fround(0.0);
      HEAP32[i22 >> 2] = 0;
      i34 = (HEAP32[i28 >> 2] | 0) + 1 | 0;
      HEAP32[i23 >> 2] = i34;
      HEAP32[i24 >> 2] = i34;
      HEAP32[i18 >> 2] = i34;
      break L16;
     }
     if (!(HEAP8[i25 >> 0] | 0)) i1 = 0; else i1 = (HEAP32[i28 >> 2] | 0) == (HEAP32[i29 >> 2] | 0);
     HEAP8[i25 >> 0] = i1 & 1;
     if (!(HEAP8[i26 >> 0] | 0)) {
      i2 = 22;
      break L4;
     }
     break;
    }
   case 32:
    {
     __ZN20TextRenderingPrivate19NativeTextGenerator11InsertSpaceEv(i8);
     break;
    }
   case 9:
    {
     if (!(__ZN20TextRenderingPrivate19NativeTextGenerator9InsertTabEv(i8) | 0)) {
      i1 = 0;
      i2 = 22;
      break L4;
     }
     break;
    }
   default:
    if (!(__ZN20TextRenderingPrivate19NativeTextGenerator15InsertCharacterEiPj(i8, i4, i9) | 0)) {
     i1 = 0;
     i2 = 22;
     break L4;
    }
   } while (0);
   i34 = HEAP32[i28 >> 2] | 0;
   HEAP32[i28 >> 2] = i34 + 1;
   if ((i34 | 0) >= (HEAP32[i29 >> 2] | 0)) {
    i1 = i25;
    break L1;
   }
  }
  if ((i2 | 0) == 22) {
   STACKTOP = i33;
   return i1 | 0;
  }
 } while (0);
 i34 = (HEAP8[i1 >> 0] | 0) != 0;
 STACKTOP = i33;
 return i34 | 0;
}

function __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPhjRKNS0_8RigidSimES5_jjj(i10, i4, i6, i7, i8, i1, i2, i9) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i5 = 0, i11 = 0;
 HEAP16[i4 >> 1] = i1;
 i5 = i4 + i9 | 0;
 i3 = (i1 | 0) != 0;
 HEAP8[i5 >> 0] = 3;
 HEAP16[i4 + (i9 + 2) >> 1] = i2;
 i2 = i9 + 4 | 0;
 i1 = i4 + i2 | 0;
 do if (i6 & 8192) {
  HEAP8[i1 >> 0] = 1;
  i2 = i9 + 56 | 0;
  i1 = i4 + i2 | 0;
  if (!i3) {
   i11 = i10 + 10 | 0;
   HEAP16[i11 >> 1] = HEAP16[i11 >> 1] | 8;
   break;
  }
  if (!(HEAP8[i7 + 50 >> 0] | 0)) {
   HEAP32[i4 + (i9 + 8) >> 2] = 0;
   HEAP32[i4 + (i9 + 12) >> 2] = 0;
   HEAP32[i4 + (i9 + 16) >> 2] = 0;
   HEAP32[i4 + (i9 + 32) >> 2] = 0;
   HEAP32[i4 + (i9 + 36) >> 2] = 0;
   HEAP32[i4 + (i9 + 40) >> 2] = 0;
  } else {
   i11 = HEAP32[i7 + 52 >> 2] | 0;
   HEAP32[i4 + (i9 + 8) >> 2] = HEAP32[i11 + 80 >> 2];
   HEAP32[i4 + (i9 + 12) >> 2] = HEAP32[i11 + 84 >> 2];
   HEAP32[i4 + (i9 + 16) >> 2] = HEAP32[i11 + 88 >> 2];
   HEAP32[i4 + (i9 + 32) >> 2] = HEAP32[i11 + 96 >> 2];
   HEAP32[i4 + (i9 + 36) >> 2] = HEAP32[i11 + 100 >> 2];
   HEAP32[i4 + (i9 + 40) >> 2] = HEAP32[i11 + 104 >> 2];
  }
  if (!(HEAP8[i8 + 50 >> 0] | 0)) {
   HEAP32[i4 + (i9 + 20) >> 2] = 0;
   HEAP32[i4 + (i9 + 24) >> 2] = 0;
   HEAP32[i4 + (i9 + 28) >> 2] = 0;
   HEAP32[i4 + (i9 + 44) >> 2] = 0;
   HEAP32[i4 + (i9 + 48) >> 2] = 0;
   HEAP32[i4 + (i9 + 52) >> 2] = 0;
   break;
  } else {
   i11 = HEAP32[i8 + 52 >> 2] | 0;
   HEAP32[i4 + (i9 + 20) >> 2] = HEAP32[i11 + 80 >> 2];
   HEAP32[i4 + (i9 + 24) >> 2] = HEAP32[i11 + 84 >> 2];
   HEAP32[i4 + (i9 + 28) >> 2] = HEAP32[i11 + 88 >> 2];
   HEAP32[i4 + (i9 + 44) >> 2] = HEAP32[i11 + 96 >> 2];
   HEAP32[i4 + (i9 + 48) >> 2] = HEAP32[i11 + 100 >> 2];
   HEAP32[i4 + (i9 + 52) >> 2] = HEAP32[i11 + 104 >> 2];
   break;
  }
 } while (0);
 if (i6 & 4096) {
  HEAP8[i1 >> 0] = 0;
  do if (!(HEAP8[i7 + 50 >> 0] | 0)) {
   HEAP32[i4 + (i2 + 4) >> 2] = 0;
   HEAP32[i4 + (i2 + 8) >> 2] = 0;
   HEAP32[i4 + (i2 + 12) >> 2] = 0;
   HEAP32[i4 + (i2 + 28) >> 2] = 0;
   HEAP32[i4 + (i2 + 32) >> 2] = 0;
   HEAP32[i4 + (i2 + 36) >> 2] = 0;
  } else if (i3) {
   i11 = i7 + 64 | 0;
   HEAP32[i4 + (i2 + 4) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + (i2 + 8) >> 2] = HEAP32[i7 + 68 >> 2];
   HEAP32[i4 + (i2 + 12) >> 2] = HEAP32[i7 + 72 >> 2];
   HEAP32[i4 + (i2 + 28) >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i4 + (i2 + 32) >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i4 + (i2 + 36) >> 2] = HEAP32[i11 + 24 >> 2];
   break;
  } else {
   i11 = HEAP32[i7 + 52 >> 2] | 0;
   HEAP32[i4 + (i2 + 4) >> 2] = HEAP32[i11 + 80 >> 2];
   HEAP32[i4 + (i2 + 8) >> 2] = HEAP32[i11 + 84 >> 2];
   HEAP32[i4 + (i2 + 12) >> 2] = HEAP32[i11 + 88 >> 2];
   HEAP32[i4 + (i2 + 28) >> 2] = HEAP32[i11 + 96 >> 2];
   HEAP32[i4 + (i2 + 32) >> 2] = HEAP32[i11 + 100 >> 2];
   HEAP32[i4 + (i2 + 36) >> 2] = HEAP32[i11 + 104 >> 2];
   break;
  } while (0);
  do if (!(HEAP8[i8 + 50 >> 0] | 0)) {
   HEAP32[i4 + (i2 + 16) >> 2] = 0;
   HEAP32[i4 + (i2 + 20) >> 2] = 0;
   HEAP32[i4 + (i2 + 24) >> 2] = 0;
   HEAP32[i4 + (i2 + 40) >> 2] = 0;
   HEAP32[i4 + (i2 + 44) >> 2] = 0;
   HEAP32[i4 + (i2 + 48) >> 2] = 0;
  } else if (i3) {
   i11 = i8 + 64 | 0;
   HEAP32[i4 + (i2 + 16) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + (i2 + 20) >> 2] = HEAP32[i8 + 68 >> 2];
   HEAP32[i4 + (i2 + 24) >> 2] = HEAP32[i8 + 72 >> 2];
   HEAP32[i4 + (i2 + 40) >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i4 + (i2 + 44) >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i4 + (i2 + 48) >> 2] = HEAP32[i11 + 24 >> 2];
   break;
  } else {
   i11 = HEAP32[i8 + 52 >> 2] | 0;
   HEAP32[i4 + (i2 + 16) >> 2] = HEAP32[i11 + 80 >> 2];
   HEAP32[i4 + (i2 + 20) >> 2] = HEAP32[i11 + 84 >> 2];
   HEAP32[i4 + (i2 + 24) >> 2] = HEAP32[i11 + 88 >> 2];
   HEAP32[i4 + (i2 + 40) >> 2] = HEAP32[i11 + 96 >> 2];
   HEAP32[i4 + (i2 + 44) >> 2] = HEAP32[i11 + 100 >> 2];
   HEAP32[i4 + (i2 + 48) >> 2] = HEAP32[i11 + 104 >> 2];
   break;
  } while (0);
  i1 = i4 + (i2 + 52) | 0;
 }
 if (!(i6 & 16384)) {
  i11 = i1;
  i8 = i5;
  i9 = i9 - i8 | 0;
  i9 = i9 + i11 | 0;
  i9 = i9 & 65535;
  i11 = i10 + 8 | 0;
  HEAP16[i11 >> 1] = i9;
  return;
 }
 HEAP8[i1 >> 0] = 2;
 __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPNS_17PxContactPairPoseEjRKNS0_8RigidSimEb(i1, 0, i7, i3);
 __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPNS_17PxContactPairPoseEjRKNS0_8RigidSimEb(i1, 1, i8, i3);
 i11 = i1 + 60 | 0;
 i8 = i5;
 i9 = i9 - i8 | 0;
 i9 = i9 + i11 | 0;
 i9 = i9 & 65535;
 i11 = i10 + 8 | 0;
 HEAP16[i11 >> 1] = i9;
 return;
}

function _jinit_master_decompress(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 4 | 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i9 | 0, 1, 28) | 0;
 HEAP32[i9 + 384 >> 2] = i7;
 HEAP32[i7 >> 2] = fb + 3272;
 HEAP32[i7 + 4 >> 2] = fb + 3273;
 HEAP8[i7 + 8 >> 0] = 0;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if ((i1 | 0) != 202) {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 20;
  HEAP32[i6 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i9 | 0);
 }
 i1 = HEAP32[i9 + 32 >> 2] | 0;
 HEAP32[i9 + 92 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i9 + 96 >> 2] = i1;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i9 + 100 >> 2] = 1;
   i1 = 1;
   break;
  }
 case 15:
 case 14:
 case 13:
 case 12:
 case 11:
 case 10:
 case 9:
 case 8:
 case 7:
 case 6:
 case 2:
  {
   i1 = HEAP32[gb + 16264 + (i1 << 2) >> 2] | 0;
   HEAP32[i9 + 100 >> 2] = i1;
   break;
  }
 case 3:
  {
   HEAP32[i9 + 100 >> 2] = 3;
   i1 = 3;
   break;
  }
 case 5:
 case 4:
  {
   HEAP32[i9 + 100 >> 2] = 4;
   i1 = 4;
   break;
  }
 default:
  {
   i1 = HEAP32[i9 + 36 >> 2] | 0;
   HEAP32[i9 + 100 >> 2] = i1;
  }
 }
 i5 = i9 + 74 | 0;
 HEAP32[i9 + 104 >> 2] = (HEAP8[i5 >> 0] | 0) == 0 ? i1 : 1;
 HEAP32[i9 + 108 >> 2] = 1;
 i2 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i9 | 0, 1, 1408) | 0;
 i3 = i2 + 256 | 0;
 i4 = i9 + 288 | 0;
 HEAP32[i4 >> 2] = i3;
 _memset(i2 | 0, 0, 256) | 0;
 i1 = 0;
 do {
  HEAP8[i3 + i1 >> 0] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 _memset(i2 + 512 | 0, -1, 384) | 0;
 _memset(i2 + 896 | 0, 0, 384) | 0;
 i3 = i2 + 1280 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i3 + 128 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i3 = i9 + 100 | 0;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 16 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 do if (!(HEAP8[i5 >> 0] | 0)) {
  HEAP8[i9 + 88 >> 0] = 0;
  HEAP8[i9 + 89 >> 0] = 0;
  HEAP8[i9 + 90 >> 0] = 0;
  i2 = i9 + 65 | 0;
 } else {
  i1 = HEAP16[i9 + 64 >> 1] | 0;
  if (!((i1 & 255) << 24 >> 24)) {
   HEAP8[i9 + 88 >> 0] = 0;
   HEAP8[i9 + 89 >> 0] = 0;
   HEAP8[i9 + 90 >> 0] = 0;
  }
  i2 = i9 + 65 | 0;
  if ((i1 & 65535) >= 256) {
   i7 = HEAP32[i9 >> 2] | 0;
   HEAP32[i7 + 20 >> 2] = 47;
   mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
  }
  do if ((HEAP32[i3 >> 2] | 0) == 3) {
   if (HEAP32[i9 + 116 >> 2] | 0) {
    HEAP8[i9 + 89 >> 0] = 1;
    break;
   }
   if (!(HEAP8[i9 + 80 >> 0] | 0)) {
    HEAP8[i9 + 88 >> 0] = 1;
    break;
   } else {
    HEAP8[i9 + 90 >> 0] = 1;
    break;
   }
  } else {
   HEAP8[i9 + 88 >> 0] = 1;
   HEAP8[i9 + 89 >> 0] = 0;
   HEAP8[i9 + 90 >> 0] = 0;
   HEAP32[i9 + 116 >> 2] = 0;
  } while (0);
  i1 = HEAP32[i9 + 88 >> 2] | 0;
  if (!((i1 & 255) << 24 >> 24)) i1 = i1 >>> 16 & 255; else {
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 48;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i9 | 0);
   i1 = HEAP8[i9 + 90 >> 0] | 0;
  }
  if (!(i1 << 24 >> 24)) if (!(HEAP8[i9 + 89 >> 0] | 0)) break;
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
 } while (0);
 if (!(HEAP8[i2 >> 0] | 0)) {
  if (!(HEAP8[i4 >> 0] | 0)) {
   _jinit_color_deconverter(i9);
   _jinit_upsampler(i9);
  } else {
   i7 = HEAP32[i9 >> 2] | 0;
   HEAP32[i7 + 20 >> 2] = 48;
   mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
  }
  _jinit_d_post_controller(i9, HEAP8[i9 + 90 >> 0] | 0);
 }
 _jinit_inverse_dct(i9);
 do if (!(HEAP8[i9 + 201 >> 0] | 0)) if (!(HEAP8[i9 + 200 >> 0] | 0)) {
  _jinit_huff_decoder(i9);
  break;
 } else {
  _jinit_phuff_decoder(i9);
  break;
 } else {
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 1;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
 } while (0);
 i3 = i9 + 400 | 0;
 if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 16 >> 0] | 0)) i1 = (HEAP8[i9 + 64 >> 0] | 0) != 0 & 1; else i1 = 1;
 _jinit_d_coef_controller(i9, i1);
 if (!(HEAP8[i2 >> 0] | 0)) _jinit_d_main_controller(i9, 0);
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i9 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i9 | 0);
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 if (!i1) return;
 if (HEAP8[i9 + 64 >> 0] | 0) return;
 if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 16 >> 0] | 0)) return;
 i8 = HEAP32[i9 + 36 >> 2] | 0;
 i8 = (HEAP8[i9 + 200 >> 0] | 0) == 0 ? i8 : (i8 * 3 | 0) + 2 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = Math_imul(i8, HEAP32[i9 + 284 >> 2] | 0) | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = HEAP8[i9 + 90 >> 0] | 0 ? 3 : 2;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 + 16;
 HEAP32[i8 + 4 >> 2] = i6 + 12;
 HEAP32[i8 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0);
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
 }
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + 4;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i7, i8, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend2dDataConstantEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i6 + 24 | 0, i7);
 i1 = i6 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP8[i2 + 8 >> 0] = 0;
  i3 = i1;
  i2 = i2 | 0 ? i2 - i3 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i3;
 }
 i3 = i2 + i1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i3 + 4;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i3 + 8 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 44 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN8LODGroup23RegisterCachedRenderersEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26;
 i15 = i26 + 16 | 0;
 i20 = i26 + 12 | 0;
 i1 = __Z16GetRendererScenev() | 0;
 i21 = i14 + 56 | 0;
 i22 = i14 + 60 | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 if ((HEAP32[i22 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i26;
  return;
 }
 i23 = i14 + 76 | 0;
 i16 = i14 + 88 | 0;
 i17 = i14 + 92 | 0;
 i18 = i14 + 80 | 0;
 i19 = i14 + 68 | 0;
 i12 = i1 + 60 | 0;
 i13 = i15 + 11 | 0;
 i11 = 0;
 i1 = i2;
 do {
  i10 = i1 + (i11 * 28 | 0) + 20 | 0;
  if (HEAP32[i10 >> 2] | 0) {
   i8 = i1 + (i11 * 28 | 0) + 8 | 0;
   i9 = 1 << i11;
   i7 = 0;
   do {
    i4 = (HEAP32[i8 >> 2] | 0) + (i7 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i20 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i25 = 13; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i20);
       i2 = HEAP32[i15 >> 2] | 0;
       i6 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i25 = 13; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i25 = 15;
      }
     }
     if ((i25 | 0) == 13) i25 = 15;
     if ((i25 | 0) == 15) {
      i25 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     i6 = i1;
     i2 = HEAP32[i1 + 284 >> 2] | 0;
     i3 = i1 + 312 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if (i4 | 0) {
      if ((i4 | 0) != (i14 | 0)) {
       i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
       i5 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0) | 0;
       i6 = HEAP32[i3 >> 2] | 0;
       i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
       HEAP32[i24 >> 2] = i4;
       HEAP32[i24 + 4 >> 2] = i5;
       HEAP32[i24 + 8 >> 2] = i6;
       __Z6FormatPKcz(i15, gb + 424814 | 0, i24);
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, 0, gb + 424887 | 0, 184, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
       break;
      }
      if ((i2 | 0) == -1) break;
      i6 = HEAP32[(HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 16 >> 2] | i9;
      HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 * 24 | 0) + 16 >> 2] = i6;
      break;
     }
     HEAP32[i3 >> 2] = i14;
     if ((i2 | 0) != -1) {
      i4 = HEAP32[i19 >> 2] | 0;
      i5 = HEAP32[i12 >> 2] | 0;
      HEAP16[i5 + (i2 * 24 | 0) + 12 >> 1] = 0;
      HEAP16[i5 + (i2 * 24 | 0) + 14 >> 1] = i4;
      HEAP32[i5 + (i2 * 24 | 0) + 16 >> 2] = i9;
     }
     i2 = HEAP32[i16 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i17 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i17 >> 2] = i1;
       HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
       HEAP32[i17 >> 2] = i1;
       HEAP32[i23 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i16 >> 2] = i3;
     HEAP32[(HEAP32[i23 >> 2] | 0) + (i2 << 2) >> 2] = i6;
    } while (0);
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  }
  i11 = i11 + 1 | 0;
  i1 = HEAP32[i21 >> 2] | 0;
 } while (i11 >>> 0 < (((HEAP32[i22 >> 2] | 0) - i1 | 0) / 28 | 0) >>> 0);
 STACKTOP = i26;
 return;
}

function __ZN18CrashReportHandler9HandleLogERK8UnityStrS2_7LogType(i19, i9, i10, i1) {
 i19 = i19 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 416 | 0;
 i17 = i21 + 408 | 0;
 i14 = i21 + 404 | 0;
 i11 = i21 + 272 | 0;
 i20 = i21 + 288 | 0;
 i18 = i21 + 136 | 0;
 i13 = i21;
 if ((i1 | 0) != 4) {
  STACKTOP = i21;
  return;
 }
 i16 = HEAP16[i19 >> 1] | 0;
 if ((i16 & 255) << 24 >> 24 == 0 | (i16 & 65535) < 256) {
  STACKTOP = i21;
  return;
 }
 __ZN16CrashReportEvent14GetCacheKeyForERK8UnityStrS2_(i11, i9, i10);
 i16 = i19 + 40 | 0;
 i12 = i19 + 44 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if (!i1) i1 = 16; else {
  i6 = i11;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i11 + 8 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = i12;
  L9 : while (1) {
   i3 = i1;
   while (1) {
    i2 = i3 + 16 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if ((i1 | 0) == (i5 | 0) & (i2 | 0) == (i6 | 0)) {
     i2 = i3 + 24 | 0;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!(i1 >>> 0 < i8 >>> 0 | ((i1 | 0) == (i8 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) break;
    } else if (!(i2 >>> 0 < i6 >>> 0 | (i2 | 0) == (i6 | 0) & i1 >>> 0 < i5 >>> 0)) break;
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i1) {
     i1 = i4;
     break L9;
    } else i3 = i1;
   }
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = i3;
    break;
   } else i4 = i3;
  }
  if ((i1 | 0) == (i12 | 0)) i1 = 16; else {
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i5 | 0) == (i2 | 0) & (i6 | 0) == (i3 | 0)) {
    i6 = i1 + 24 | 0;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    if (i8 >>> 0 < i5 >>> 0 | ((i8 | 0) == (i5 | 0) ? i7 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0 : 0) | (i1 | 0) == (i12 | 0)) {
     i1 = 16;
     break;
    }
   } else if (i6 >>> 0 < i3 >>> 0 | (i6 | 0) == (i3 | 0) & i5 >>> 0 < i2 >>> 0 | (i1 | 0) == (i12 | 0)) {
    i1 = 16;
    break;
   }
   i18 = i1 + 144 | 0;
   i20 = (HEAP32[i18 >> 2] | 0) + 1 | 0;
   HEAP32[i18 >> 2] = i20;
   if (i20 >>> 0 > 1e4) i1 = 22; else i1 = 21;
  }
 } while (0);
 if ((i1 | 0) == 16) {
  __ZN16CrashReportEventC2ERK8UnityStrS2_S2_(i20, i19 + 20 | 0, i9, i10);
  __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i19, i20) | 0;
  HEAP32[i20 + 112 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i5 = i13 + 16 | 0;
  __ZN16CrashReportEventC2ERKS_(i5, i20);
  HEAP32[i18 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  i4 = i18 + 16 | 0;
  __ZN16CrashReportEventC2ERKS_(i4, i5);
  HEAP32[i14 >> 2] = i12;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  i3 = __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i16, i15, i17, i18) | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = HEAP32[i19 + 48 >> 2] | 0;
   HEAP32[i15 >> 2] = 5;
   HEAP32[i15 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(152, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   __ZN16CrashReportEventC2ERKS_(i1 + 32 | 0, i4);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i16 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 + 44 >> 2] | 0, i1);
   i18 = i19 + 52 | 0;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  }
  __ZN16CrashReportEventD2Ev(i4);
  __ZN16CrashReportEventD2Ev(i5);
  __ZN16CrashReportEventD2Ev(i20);
  i1 = 21;
 }
 if ((i1 | 0) == 21) if ((HEAP32[i19 + 52 >> 2] | 0) >>> 0 > 100) i1 = 22;
 if ((i1 | 0) == 22) __ZN18CrashReportHandler12CloseServiceEv(i19);
 STACKTOP = i21;
 return;
}

function __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i5, i1 + 204 | 0, 1);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047723 | 0, i5, i1 + 205 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047730 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047738 | 0, i5, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047746 | 0, i5, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047756 | 0, i5, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047766 | 0, i5, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047778 | 0, i5, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 144 | 0, gb + 1047790 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 156 | 0, gb + 1047804 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 180 | 0, gb + 1047818 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047830 | 0, i5, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 168 | 0, gb + 1047851 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047867 | 0, i5, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047883 | 0, i5, i1 + 196 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047902 | 0, i5, i1 + 193 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047914 | 0, i5, i1 + 192 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047938 | 0, i5, i1 + 206 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvRS2_S5_RKS2_S7_(i26, i24, i25, i2, i3) {
 i26 = i26 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0;
 f4 = Math_fround(HEAPF32[i25 >> 2]);
 f5 = Math_fround(HEAPF32[i24 >> 2]);
 f14 = Math_fround(f4 - f5);
 i17 = i25 + 4 | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 i19 = i24 + 4 | 0;
 f20 = Math_fround(HEAPF32[i19 >> 2]);
 f21 = Math_fround(f18 - f20);
 i22 = i25 + 8 | 0;
 f23 = Math_fround(HEAPF32[i22 >> 2]);
 i6 = i24 + 8 | 0;
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(f23 - f7);
 i9 = i25 + 12 | 0;
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 i11 = i24 + 12 | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f10 - f12);
 f15 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f21 * f21)) + Math_fround(f8 * f8));
 f16 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 if (f15 > f16) if (f15 > Math_fround(HEAPF32[i26 + 20 >> 2])) if (f15 > Math_fround(HEAPF32[i26 + 24 >> 2])) if (f15 > Math_fround(HEAPF32[i26 + 28 >> 2])) return;
 f28 = Math_fround(HEAPF32[i3 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i2 >> 2]));
 f27 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f27 = Math_fround(f27 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f1 = Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)) + Math_fround(f1 * f1));
 if (f16 > f1) if (Math_fround(HEAPF32[i26 + 20 >> 2]) > f1) if (Math_fround(HEAPF32[i26 + 24 >> 2]) > f1) if (Math_fround(HEAPF32[i26 + 28 >> 2]) > f1) return;
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f15))));
 f32 = Math_fround(f15 * Math_fround(HEAPF32[i26 >> 2]));
 f31 = Math_fround(f15 * Math_fround(HEAPF32[i26 + 4 >> 2]));
 f1 = Math_fround(f15 * Math_fround(HEAPF32[i26 + 8 >> 2]));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i26 + 12 >> 2]));
 f27 = Math_fround(HEAPF32[gb + 1097584 >> 2]);
 f30 = Math_fround(HEAPF32[gb + 1097584 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[gb + 1097584 + 8 >> 2]);
 f27 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(f12 + f27)));
 f30 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(f12 + f30)));
 f28 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(f12 + f28)));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(f10 + Math_fround(f12 + Math_fround(HEAPF32[gb + 1097584 + 12 >> 2]))));
 f27 = Math_fround(f27 * Math_fround(HEAPF32[i26 + 32 >> 2]));
 f30 = Math_fround(f30 * Math_fround(HEAPF32[i26 + 36 >> 2]));
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i26 + 40 >> 2]));
 f27 = Math_fround(Math_fround(f14 - Math_fround(f14 * f32)) * f27);
 f14 = Math_fround(Math_fround(f21 - Math_fround(f21 * f31)) * f30);
 f21 = Math_fround(Math_fround(f8 - Math_fround(f8 * f1)) * f28);
 f16 = Math_fround(Math_fround(f13 - Math_fround(f13 * f15)) * Math_fround(f16 * Math_fround(HEAPF32[i26 + 44 >> 2])));
 i29 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = HEAP32[gb + 1097568 + 4 >> 2] & i2;
 i3 = HEAP32[gb + 1097568 + 8 >> 2] & i3;
 i26 = HEAP32[gb + 1097568 + 12 >> 2] & (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 f16 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097568 >> 2] & i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f12 * f16);
 f21 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f12 * f21);
 f27 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f12 * f27);
 f28 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 + f20);
 f15 = Math_fround(f15 + f7);
 f20 = Math_fround(Math_fround(f12 * f28) + f12);
 HEAPF32[i24 >> 2] = Math_fround(f13 + f5);
 HEAPF32[i19 >> 2] = f14;
 HEAPF32[i6 >> 2] = f15;
 HEAPF32[i11 >> 2] = f20;
 f21 = Math_fround(f18 - Math_fround(f10 * f21));
 f27 = Math_fround(f23 - Math_fround(f10 * f27));
 f28 = Math_fround(f10 - Math_fround(f10 * f28));
 HEAPF32[i25 >> 2] = Math_fround(f4 - Math_fround(f10 * f16));
 HEAPF32[i17 >> 2] = f21;
 HEAPF32[i22 >> 2] = f27;
 HEAPF32[i9 >> 2] = f28;
 return;
}

function __ZN6Sprite8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i9, i7 + 32 | 0, gb + 410471 | 0, 0);
 i2 = i7 + 48 | 0;
 i5 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800947 | 0, i5, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034662 | 0, HEAP32[gb + 37328 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 410478 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902162 | 0, i5, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 410494 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 35; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 410504 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 410516 | 0, gb + 410521 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN16SpriteRenderData8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10systeminfo24GetRuntimePlatformStringE15RuntimePlatform(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do switch (i2 | 0) {
 case 0:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454766 | 0, 9);
   return;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454776 | 0, 9);
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454786 | 0, 13);
   return;
  }
 case 3:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454800 | 0, 12);
   return;
  }
 case 4:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454813 | 0, 18);
   return;
  }
 case 5:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454832 | 0, 16);
   return;
  }
 case 7:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454849 | 0, 13);
   return;
  }
 case 8:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454863 | 0, 12);
   return;
  }
 case 31:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454876 | 0, 10);
   return;
  }
 case 30:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454887 | 0, 10);
   return;
  }
 case 11:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454898 | 0, 13);
   return;
  }
 case 13:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454912 | 0, 11);
   return;
  }
 case 14:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454924 | 0, 14);
   return;
  }
 case 16:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454939 | 0, 11);
   return;
  }
 case 17:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454760 | 0, 5);
   return;
  }
 case 18:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454951 | 0, 14);
   return;
  }
 case 19:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454966 | 0, 14);
   return;
  }
 case 20:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454981 | 0, 14);
   return;
  }
 case 23:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454996 | 0, 11);
   return;
  }
 case 28:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 455008 | 0, 15);
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 585672 | 0, 7);
   return;
  }
 } while (0);
}

function __ZNKSt3__218__time_get_storageIcE15__do_date_orderEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i2 + 508 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i6 = i4 << 24 >> 24 < 0;
 i5 = i2 + 512 | 0;
 i2 = i4 & 255;
 i4 = 0;
 while (1) {
  if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
  if (i4 >>> 0 >= i3 >>> 0) break;
  if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
  i4 = i4 + 1 | 0;
 }
 if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 L15 : do switch (HEAP8[i3 + (i4 + 1) >> 0] | 0) {
 case 89:
 case 121:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    switch (HEAP8[i3 + (i4 + 1) >> 0] | 0) {
    case 109:
     {
      i4 = i4 + 2 | 0;
      while (1) {
       if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
       if (i4 >>> 0 >= i3 >>> 0) break;
       if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
       if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
       i4 = i4 + 1 | 0;
      }
      if (i6) i2 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) == (i2 | 0)) {
       i7 = 116;
       break L15;
      }
      if (i6) i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP8[i1 + (i4 + 1) >> 0] | 0) == 100) {
       i1 = 3;
       break L15;
      } else {
       i7 = 116;
       break L15;
      }
     }
    case 100:
     {
      i4 = i4 + 2 | 0;
      while (1) {
       if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
       if (i4 >>> 0 >= i3 >>> 0) break;
       if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
       if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
       i4 = i4 + 1 | 0;
      }
      if (i6) i2 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) == (i2 | 0)) {
       i7 = 116;
       break L15;
      }
      if (i6) i1 = HEAP32[i1 >> 2] | 0;
      if ((HEAP8[i1 + (i4 + 1) >> 0] | 0) == 109) {
       i1 = 4;
       break L15;
      } else {
       i7 = 116;
       break L15;
      }
     }
    default:
     {
      i7 = 116;
      break L15;
     }
    }
   }
   break;
  }
 case 109:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP8[i3 + (i4 + 1) >> 0] | 0) == 100) {
     i4 = i4 + 2 | 0;
     while (1) {
      if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
      if (i4 >>> 0 >= i3 >>> 0) break;
      if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
      if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
      i4 = i4 + 1 | 0;
     }
     if (i6) i2 = HEAP32[i5 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i7 = 116; else {
      i3 = i4 + 1 | 0;
      if (i6) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
      if ((HEAP8[i2 + i3 >> 0] | 0) == 121) i1 = 2; else {
       if (i6) i1 = HEAP32[i1 >> 2] | 0;
       if ((HEAP8[i1 + i3 >> 0] | 0) == 89) i1 = 2; else i7 = 116;
      }
     }
    } else i7 = 116;
   }
   break;
  }
 case 100:
  {
   i4 = i4 + 2 | 0;
   while (1) {
    if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
    if (i4 >>> 0 >= i3 >>> 0) break;
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
    i4 = i4 + 1 | 0;
   }
   if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
   if ((i4 | 0) == (i3 | 0)) i7 = 116; else {
    if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
    if ((HEAP8[i3 + (i4 + 1) >> 0] | 0) == 109) {
     i4 = i4 + 2 | 0;
     while (1) {
      if (i6) i3 = HEAP32[i5 >> 2] | 0; else i3 = i2;
      if (i4 >>> 0 >= i3 >>> 0) break;
      if (i6) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
      if ((HEAP8[i3 + i4 >> 0] | 0) == 37) break;
      i4 = i4 + 1 | 0;
     }
     if (i6) i2 = HEAP32[i5 >> 2] | 0;
     if ((i4 | 0) == (i2 | 0)) i7 = 116; else {
      i3 = i4 + 1 | 0;
      if (i6) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
      if ((HEAP8[i2 + i3 >> 0] | 0) == 121) i1 = 1; else {
       if (i6) i1 = HEAP32[i1 >> 2] | 0;
       if ((HEAP8[i1 + i3 >> 0] | 0) == 89) i1 = 1; else i7 = 116;
      }
     }
    } else i7 = 116;
   }
   break;
  }
 default:
  i7 = 116;
 } while (0);
 if ((i7 | 0) == 116) i1 = 0;
 return i1 | 0;
}

function __ZN5Unity12PhysicsQuery7BoxCastERK8Vector3fS3_S3_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction(i1, i6, i7, i8, i9, f10, i15, i11, i12) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i15 = i15 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 84 | 0;
 i5 = i16 + 64 | 0;
 i1 = i16 + 152 | 0;
 i2 = i16 + 48 | 0;
 i3 = i16 + 20 | 0;
 i4 = i16;
 if ((HEAP16[gb + 1452704 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452704 | 0, i13);
  i14 = gb + 1452704 | 0;
 } else i14 = 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i17 = HEAP32[i7 + 4 >> 2] | 0;
 i18 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = 3;
 HEAP32[i2 + 4 >> 2] = i20;
 HEAP32[i2 + 8 >> 2] = i17;
 HEAP32[i2 + 12 >> 2] = i18;
 i18 = HEAP32[i6 >> 2] | 0;
 i17 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = HEAP32[i6 + 8 >> 2] | 0;
 i20 = HEAP32[i9 + 4 >> 2] | 0;
 i19 = HEAP32[i9 + 8 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i20;
 HEAP32[i3 + 8 >> 2] = i19;
 HEAP32[i3 + 12 >> 2] = i6;
 HEAP32[i3 + 16 >> 2] = i18;
 HEAP32[i3 + 20 >> 2] = i17;
 HEAP32[i3 + 24 >> 2] = i7;
 HEAP32[i4 >> 2] = gb + 114012 + 8;
 HEAP32[i4 + 4 >> 2] = 2;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i11;
 switch (i12 | 0) {
 case 0:
  {
   HEAP8[i4 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i4 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i4 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i17 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i19 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i7 = i13 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i13 + 12 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP16[i13 + 16 >> 1] = 0;
 i20 = i13 + 20 | 0;
 i9 = i13 + 44 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAP32[i20 + 16 >> 2] = 0;
 HEAP32[i20 + 20 >> 2] = 0;
 HEAPF32[i9 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i20 = i13 + 52 | 0;
 HEAP8[i20 >> 0] = 0;
 HEAP32[i13 + 56 >> 2] = 0;
 HEAP32[i13 + 60 >> 2] = 0;
 HEAP32[i13 + 64 >> 2] = 0;
 HEAP32[i13 >> 2] = gb + 93084 + 8;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP16[i5 + 16 >> 1] = 15;
 HEAP8[i5 + 18 >> 0] = 0;
 i18 = HEAP32[(HEAP32[i19 >> 2] | 0) + 352 >> 2] | 0;
 HEAP16[i1 >> 1] = i17 ? 143 : 15;
 mftCall_iiiiifiiiiif(i18 | 0, i19 | 0, i2 | 0, i3 | 0, i8 | 0, +f10, i13 | 0, i1 | 0, i5 | 0, i4 | 0, 0, 0.0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i13 + 20 >> 2] | 0;
 i4 = HEAP32[i13 + 24 >> 2] | 0;
 i5 = HEAP32[i13 + 28 >> 2] | 0;
 i6 = HEAP32[i13 + 32 >> 2] | 0;
 i7 = HEAP32[i13 + 36 >> 2] | 0;
 i8 = HEAP32[i13 + 40 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 if (!(HEAP8[i20 >> 0] | 0)) i1 = 0; else {
  HEAP32[i15 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 >> 2] = i3;
  HEAP32[i15 + 4 >> 2] = i4;
  HEAP32[i15 + 8 >> 2] = i5;
  HEAP32[i15 + 12 >> 2] = i6;
  HEAP32[i15 + 16 >> 2] = i7;
  HEAP32[i15 + 20 >> 2] = i8;
  HEAP32[i13 >> 2] = 5;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  i20 = i13 + 32 | 0;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i13 | 0) | 0) {
   i1 = HEAP32[i13 + 36 >> 2] | 0;
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) + (i2 << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i15 + 24 >> 2] = i1;
  HEAP32[i15 + 28 >> 2] = i9;
  HEAPF32[i15 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 36 >> 2] = Math_fround(0.0);
  if (!((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0))) i1 = 1; else {
   HEAP32[i15 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   i1 = 1;
  }
 }
 if (!i14) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i16;
 return i1 | 0;
}

function _tre_make_trans(i2, i22, i19, i4, i20) {
 i2 = i2 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 i4 = i4 | 0;
 i20 = i20 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = (i1 | 0) > -1;
 L1 : do if (!i19) if (i3) {
  i3 = i22 + 32 | 0;
  do {
   if ((HEAP32[i22 >> 2] | 0) > -1) {
    i21 = i4 + (i1 << 2) | 0;
    HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
    if ((HEAP32[i3 >> 2] | 0) > -1) {
     i1 = i3;
     do {
      i21 = i4 + (HEAP32[i2 >> 2] << 2) | 0;
      HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
      i1 = i1 + 32 | 0;
     } while ((HEAP32[i1 >> 2] | 0) > -1);
    }
   }
   i2 = i2 + 32 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } while ((i1 | 0) > -1);
  i1 = 0;
 } else i1 = 0; else if (i3) while (1) {
  i3 = HEAP32[i22 >> 2] | 0;
  L15 : do if ((i3 | 0) > -1) {
   i12 = i2 + 4 | 0;
   i13 = i2 + 8 | 0;
   i14 = i2 + 16 | 0;
   i15 = i2 + 20 | 0;
   i16 = i2 + 24 | 0;
   i17 = i2 + 28 | 0;
   i18 = i2 + 12 | 0;
   i4 = -1;
   i1 = i22;
   while (1) {
    i11 = i3;
    while (1) {
     if ((i11 | 0) != (i4 | 0)) break;
     i1 = i1 + 32 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) > -1) i11 = i3; else break L15;
    }
    i8 = i19 + (HEAP32[i20 + (HEAP32[i2 >> 2] << 2) >> 2] << 5) | 0;
    while (1) {
     i3 = i8 + 8 | 0;
     if (!(HEAP32[i3 >> 2] | 0)) break; else i8 = i8 + 32 | 0;
    }
    HEAP32[i8 + 40 >> 2] = 0;
    HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i3 >> 2] = i19 + (HEAP32[i20 + (i11 << 2) >> 2] << 5);
    HEAP32[i8 + 12 >> 2] = i11;
    i3 = HEAP32[i15 >> 2] | 0;
    i4 = HEAP32[i1 + 16 >> 2] | HEAP32[i14 >> 2] | (i3 | 0 ? 4 : 0) | (HEAP32[i16 >> 2] | 0 ? 8 : 0);
    i5 = i8 + 20 | 0;
    HEAP32[i5 >> 2] = i4;
    i6 = HEAP32[i17 >> 2] | 0;
    if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i4 | 256;
     i3 = i6;
    }
    HEAP32[i8 + 24 >> 2] = i3;
    i4 = HEAP32[i16 >> 2] | 0;
    if (!i4) HEAP32[i8 + 28 >> 2] = 0; else {
     i3 = 0;
     do {
      i10 = i3;
      i3 = i3 + 1 | 0;
     } while ((HEAP32[i4 + (i10 << 2) >> 2] | 0) != 0);
     i3 = _malloc(i3 << 2) | 0;
     HEAP32[i8 + 28 >> 2] = i3;
     if (!i3) {
      i1 = 12;
      break L1;
     }
     i7 = HEAP32[i16 >> 2] | 0;
     i4 = HEAP32[i7 >> 2] | 0;
     if (i4) {
      i6 = 0;
      i5 = i3;
      do {
       HEAP32[i5 >> 2] = i4;
       i6 = i6 + 1 | 0;
       i4 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
       i5 = i3 + (i6 << 2) | 0;
      } while ((i4 | 0) != 0);
      i3 = i5;
     }
     HEAP32[i3 >> 2] = 0;
    }
    i4 = HEAP32[i18 >> 2] | 0;
    if (!i4) i3 = 0; else {
     i3 = 0;
     while (1) if ((HEAP32[i4 + (i3 << 2) >> 2] | 0) > -1) i3 = i3 + 1 | 0; else break;
    }
    i7 = i1 + 12 | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if (!i5) i4 = 0; else {
     i4 = 0;
     while (1) if ((HEAP32[i5 + (i4 << 2) >> 2] | 0) > -1) i4 = i4 + 1 | 0; else break;
    }
    i6 = i8 + 16 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    if (i5 | 0) _free(i5);
    HEAP32[i6 >> 2] = 0;
    i3 = i4 + i3 | 0;
    if ((i3 | 0) > 0) {
     i10 = _malloc((i3 << 2) + 4 | 0) | 0;
     HEAP32[i6 >> 2] = i10;
     if (!i10) {
      i1 = 12;
      break L1;
     }
     i5 = HEAP32[i18 >> 2] | 0;
     if (!i5) i4 = 0; else {
      i3 = HEAP32[i5 >> 2] | 0;
      if ((i3 | 0) > -1) {
       i4 = 0;
       do {
        HEAP32[i10 + (i4 << 2) >> 2] = i3;
        i4 = i4 + 1 | 0;
        i3 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
       } while ((i3 | 0) > -1);
      } else i4 = 0;
     }
     i8 = HEAP32[i7 >> 2] | 0;
     if (!i8) i3 = i4; else {
      i5 = HEAP32[i8 >> 2] | 0;
      if ((i5 | 0) > -1) {
       i9 = (i4 | 0) > 0;
       i3 = i4;
       i7 = 0;
       do {
        L64 : do if (i9) {
         i6 = 0;
         while (1) {
          if ((HEAP32[i10 + (i6 << 2) >> 2] | 0) == (i5 | 0)) break L64;
          i6 = i6 + 1 | 0;
          if ((i6 | 0) >= (i4 | 0)) {
           i21 = 39;
           break;
          }
         }
        } else i21 = 39; while (0);
        if ((i21 | 0) == 39) {
         i21 = 0;
         HEAP32[i10 + (i3 << 2) >> 2] = i5;
         i3 = i3 + 1 | 0;
        }
        i7 = i7 + 1 | 0;
        i5 = HEAP32[i8 + (i7 << 2) >> 2] | 0;
       } while ((i5 | 0) > -1);
      } else i3 = i4;
     }
     HEAP32[i10 + (i3 << 2) >> 2] = -1;
    }
    i1 = i1 + 32 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) <= -1) break; else i4 = i11;
   }
  } while (0);
  i2 = i2 + 32 | 0;
  if ((HEAP32[i2 >> 2] | 0) <= -1) {
   i1 = 0;
   break;
  }
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR26ColliderIdentityComparitorPP10Collider2DEEbT0_S6_T_(i12, i11, i1) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 switch (i11 - i12 >> 2 | 0) {
 case 2:
  {
   i1 = i11 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   if (i2 >>> 0 >= i3 >>> 0) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i12 = 1;
   return i12 | 0;
  }
 case 3:
  {
   i7 = i12 + 4 | 0;
   i4 = i11 + -4 | 0;
   i11 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i1 = i3 >>> 0 < i11 >>> 0;
   i2 = i11;
   i6 = i5;
   if (i11 >>> 0 >= i5 >>> 0) {
    if (!i1) {
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i7 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i1 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    if (i1 >>> 0 >= i2 >>> 0) {
     i12 = 1;
     return i12 | 0;
    }
    HEAP32[i12 >> 2] = i1;
    HEAP32[i7 >> 2] = i2;
    i12 = 1;
    return i12 | 0;
   }
   if (i1) {
    HEAP32[i12 >> 2] = i3;
    HEAP32[i4 >> 2] = i6;
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i7 >> 2] = i6;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i7 >> 2] = i1;
   HEAP32[i4 >> 2] = i6;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   i10 = i12 + 4 | 0;
   i9 = i12 + 8 | 0;
   i8 = i11 + -4 | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = i3 >>> 0 < i5 >>> 0;
   i2 = i5;
   i6 = i3;
   i7 = i1;
   do if (i5 >>> 0 < i1 >>> 0) {
    if (i4) {
     HEAP32[i12 >> 2] = i6;
     HEAP32[i9 >> 2] = i7;
     i3 = i1;
     i2 = i7;
     break;
    }
    HEAP32[i12 >> 2] = i2;
    HEAP32[i10 >> 2] = i7;
    if (i3 >>> 0 < i1 >>> 0) {
     HEAP32[i10 >> 2] = i6;
     HEAP32[i9 >> 2] = i7;
     i3 = i1;
     i2 = i7;
    } else i2 = i6;
   } else if (i4) {
    HEAP32[i10 >> 2] = i6;
    HEAP32[i9 >> 2] = i2;
    if (i3 >>> 0 < i1 >>> 0) {
     HEAP32[i12 >> 2] = i6;
     HEAP32[i10 >> 2] = i7;
     i3 = i5;
     i2 = i5;
    } else i3 = i5;
   } else i2 = i6; while (0);
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i8 >> 2] = i2;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    i12 = 1;
    return i12 | 0;
   }
   i3 = i2;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[i12 >> 2] | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    i12 = 1;
    return i12 | 0;
   }
   HEAP32[i12 >> 2] = i3;
   HEAP32[i10 >> 2] = i1;
   i12 = 1;
   return i12 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i12, i12 + 4 | 0, i12 + 8 | 0, i12 + 12 | 0, i11 + -4 | 0, i1) | 0;
   i12 = 1;
   return i12 | 0;
  }
 case 1:
 case 0:
  {
   i12 = 1;
   return i12 | 0;
  }
 default:
  {
   i3 = i12 + 8 | 0;
   i1 = i12 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i6 = i5 >>> 0 < i2 >>> 0;
   i7 = i2;
   i8 = i5;
   i9 = i4;
   do if (i2 >>> 0 < i4 >>> 0) {
    if (i6) {
     HEAP32[i12 >> 2] = i8;
     HEAP32[i3 >> 2] = i9;
     i2 = i4;
     break;
    }
    HEAP32[i12 >> 2] = i7;
    HEAP32[i1 >> 2] = i9;
    if (i5 >>> 0 < i4 >>> 0) {
     HEAP32[i1 >> 2] = i8;
     HEAP32[i3 >> 2] = i9;
     i2 = i4;
    } else i2 = i5;
   } else if (i6) {
    HEAP32[i1 >> 2] = i8;
    HEAP32[i3 >> 2] = i7;
    if (i5 >>> 0 < i4 >>> 0) {
     HEAP32[i12 >> 2] = i8;
     HEAP32[i1 >> 2] = i9;
    }
   } else i2 = i5; while (0);
   i1 = i12 + 12 | 0;
   L13 : do if ((i1 | 0) == (i11 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    while (1) {
     i4 = HEAP32[i6 >> 2] | 0;
     i5 = i4;
     if (i4 >>> 0 < i2 >>> 0) {
      i2 = i6;
      while (1) {
       HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
       if ((i3 | 0) == (i12 | 0)) break;
       i2 = i3 + -4 | 0;
       if (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) {
        i10 = i3;
        i3 = i2;
        i2 = i10;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i11 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i11 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i10 = HEAP32[i6 >> 2] | 0;
     i3 = i6;
     i6 = i2;
     i2 = i10;
    }
   } while (0);
   i12 = i1 | i2;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj3ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj4ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 28 | 0, i8 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj5ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 i2 = i6 + 60 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj6ENS_22PxRepXPropertyAccessorILj6ES4_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESC_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj7ENS_22PxRepXPropertyAccessorILj7ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i6 + 92 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj8ENS_22PxRepXPropertyAccessorILj8ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 9 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 9 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 9 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 9 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function runPostSets60() {
 HEAP32[gb + 68500 >> 2] = fb + 765;
 HEAP32[gb + 68504 >> 2] = fb + 766;
 HEAP32[gb + 68508 >> 2] = fb + 80;
 HEAP32[gb + 68512 >> 2] = fb + 39;
 HEAP32[gb + 68516 >> 2] = fb + 16;
 HEAP32[gb + 68520 >> 2] = fb + 39;
 HEAP32[gb + 68524 >> 2] = fb + 40;
 HEAP32[gb + 68528 >> 2] = fb + 19;
 HEAP32[gb + 68532 >> 2] = fb + 335;
 HEAP32[gb + 68536 >> 2] = fb + 99;
 HEAP32[gb + 68540 >> 2] = fb + 40;
 HEAP32[gb + 68544 >> 2] = fb + 62;
 HEAP32[gb + 68548 >> 2] = fb + 28;
 HEAP32[gb + 68552 >> 2] = fb + 63;
 HEAP32[gb + 68556 >> 2] = fb + 29;
 HEAP32[gb + 68560 >> 2] = fb + 34;
 HEAP32[gb + 68564 >> 2] = fb + 622;
 HEAP32[gb + 68568 >> 2] = fb + 623;
 HEAP32[gb + 68572 >> 2] = fb + 624;
 HEAP32[gb + 68576 >> 2] = fb + 625;
 HEAP32[gb + 68580 >> 2] = fb + 626;
 HEAP32[gb + 68584 >> 2] = fb + 627;
 HEAP32[gb + 68588 >> 2] = fb + 36;
 HEAP32[gb + 68592 >> 2] = fb + 96;
 HEAP32[gb + 68596 >> 2] = fb + 81;
 HEAP32[gb + 68600 >> 2] = fb + 82;
 HEAP32[gb + 68604 >> 2] = (HEAP32[gb + 68604 >> 2] | 0) + (gb + 478905 | 0);
 HEAP32[gb + 68608 >> 2] = (HEAP32[gb + 68608 >> 2] | 0) + (gb + 478910 | 0);
 HEAP32[gb + 68612 >> 2] = (HEAP32[gb + 68612 >> 2] | 0) + (gb + 478914 | 0);
 HEAP32[gb + 68616 >> 2] = (HEAP32[gb + 68616 >> 2] | 0) + (gb + 478917 | 0);
 HEAP32[gb + 68620 >> 2] = (HEAP32[gb + 68620 >> 2] | 0) + (gb + 478920 | 0);
 HEAP32[gb + 68624 >> 2] = (HEAP32[gb + 68624 >> 2] | 0) + (gb + 478928 | 0);
 HEAP32[gb + 68628 >> 2] = (HEAP32[gb + 68628 >> 2] | 0) + (gb + 478937 | 0);
 HEAP32[gb + 68640 >> 2] = fb + 767;
 HEAP32[gb + 68644 >> 2] = fb + 768;
 HEAP32[gb + 68648 >> 2] = fb + 38;
 HEAP32[gb + 68652 >> 2] = fb + 587;
 HEAP32[gb + 68656 >> 2] = fb + 16;
 HEAP32[gb + 68660 >> 2] = fb + 39;
 HEAP32[gb + 68664 >> 2] = fb + 40;
 HEAP32[gb + 68668 >> 2] = fb + 19;
 HEAP32[gb + 68672 >> 2] = fb + 336;
 HEAP32[gb + 68676 >> 2] = fb + 31;
 HEAP32[gb + 68680 >> 2] = fb + 27;
 HEAP32[gb + 68684 >> 2] = fb + 62;
 HEAP32[gb + 68688 >> 2] = fb + 28;
 HEAP32[gb + 68692 >> 2] = fb + 63;
 HEAP32[gb + 68696 >> 2] = fb + 29;
 HEAP32[gb + 68700 >> 2] = fb + 34;
 HEAP32[gb + 68704 >> 2] = fb + 588;
 HEAP32[gb + 68708 >> 2] = fb + 589;
 HEAP32[gb + 68712 >> 2] = fb + 590;
 HEAP32[gb + 68716 >> 2] = fb + 591;
 HEAP32[gb + 68720 >> 2] = fb + 592;
 HEAP32[gb + 68724 >> 2] = fb + 593;
 HEAP32[gb + 68728 >> 2] = fb + 36;
 HEAP32[gb + 68732 >> 2] = fb + 45;
 HEAP32[gb + 68736 >> 2] = fb + 82;
 HEAP32[gb + 68740 >> 2] = fb + 337;
 HEAP32[gb + 68744 >> 2] = (HEAP32[gb + 68744 >> 2] | 0) + (gb + 479331 | 0);
 HEAP32[gb + 68756 >> 2] = fb + 769;
 HEAP32[gb + 68760 >> 2] = fb + 770;
 HEAP32[gb + 68764 >> 2] = fb + 38;
 HEAP32[gb + 68768 >> 2] = fb + 628;
 HEAP32[gb + 68772 >> 2] = fb + 16;
 HEAP32[gb + 68776 >> 2] = fb + 39;
 HEAP32[gb + 68780 >> 2] = fb + 40;
 HEAP32[gb + 68784 >> 2] = fb + 19;
 HEAP32[gb + 68788 >> 2] = fb + 338;
 HEAP32[gb + 68792 >> 2] = fb + 31;
 HEAP32[gb + 68796 >> 2] = fb + 27;
 HEAP32[gb + 68800 >> 2] = fb + 62;
 HEAP32[gb + 68804 >> 2] = fb + 28;
 HEAP32[gb + 68808 >> 2] = fb + 63;
 HEAP32[gb + 68812 >> 2] = fb + 29;
 HEAP32[gb + 68816 >> 2] = fb + 34;
 HEAP32[gb + 68820 >> 2] = fb + 629;
 HEAP32[gb + 68824 >> 2] = fb + 630;
 HEAP32[gb + 68828 >> 2] = fb + 631;
 HEAP32[gb + 68832 >> 2] = fb + 632;
 HEAP32[gb + 68836 >> 2] = fb + 633;
 HEAP32[gb + 68840 >> 2] = fb + 634;
 HEAP32[gb + 68844 >> 2] = fb + 36;
 HEAP32[gb + 68848 >> 2] = (HEAP32[gb + 68848 >> 2] | 0) + (gb + 479656 | 0);
 HEAP32[gb + 68852 >> 2] = (HEAP32[gb + 68852 >> 2] | 0) + (gb + 604612 | 0);
 HEAP32[gb + 68856 >> 2] = (HEAP32[gb + 68856 >> 2] | 0) + (gb + 479663 | 0);
 HEAP32[gb + 68860 >> 2] = (HEAP32[gb + 68860 >> 2] | 0) + (gb + 479672 | 0);
 HEAP32[gb + 68864 >> 2] = (HEAP32[gb + 68864 >> 2] | 0) + (gb + 479685 | 0);
 HEAP32[gb + 68868 >> 2] = (HEAP32[gb + 68868 >> 2] | 0) + (gb + 479697 | 0);
 HEAP32[gb + 68872 >> 2] = (HEAP32[gb + 68872 >> 2] | 0) + (gb + 479708 | 0);
 HEAP32[gb + 68876 >> 2] = (HEAP32[gb + 68876 >> 2] | 0) + (gb + 479720 | 0);
 HEAP32[gb + 68880 >> 2] = (HEAP32[gb + 68880 >> 2] | 0) + (gb + 479733 | 0);
 HEAP32[gb + 68884 >> 2] = (HEAP32[gb + 68884 >> 2] | 0) + (gb + 479746 | 0);
 HEAP32[gb + 68888 >> 2] = (HEAP32[gb + 68888 >> 2] | 0) + (gb + 479762 | 0);
 HEAP32[gb + 68892 >> 2] = (HEAP32[gb + 68892 >> 2] | 0) + (gb + 479771 | 0);
 HEAP32[gb + 68896 >> 2] = (HEAP32[gb + 68896 >> 2] | 0) + (gb + 479776 | 0);
 HEAP32[gb + 68908 >> 2] = fb + 771;
 HEAP32[gb + 68912 >> 2] = fb + 772;
 HEAP32[gb + 68968 >> 2] = (HEAP32[gb + 68968 >> 2] | 0) + (gb + 481241 | 0);
 HEAP32[gb + 68980 >> 2] = (HEAP32[gb + 68980 >> 2] | 0) + (gb + 604628 | 0);
 runPostSets61();
}

function __ZN6Avatar15SetMuscleMinMaxEiff(i2, i13, f14, f15) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 if ((i13 | 0) < 0) return;
 do if ((i13 | 0) < 52) i8 = __ZN7mecanim5human14BoneFromMuscleEi(i13) | 0; else {
  if ((i13 | 0) < 72) {
   i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i13 + -52 | 0) | 0;
   if ((i1 | 0) != -1) {
    i8 = i1 + 24 | 0;
    break;
   }
   return;
  }
  if ((i13 | 0) >= 92) return;
  i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i13 + -72 | 0) | 0;
  if ((i1 | 0) == -1) return; else i8 = i1 + 39 | 0;
 } while (0);
 i6 = HEAP32[i2 + 56 >> 2] | 0;
 if ((i8 | 0) < 0) return;
 i7 = (i8 | 0) < 24;
 do if (i7) {
  i1 = i6 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return;
  i3 = i2 + i1 | 0;
  i12 = i3 + 40 | 0;
  if (!(HEAP32[(HEAP32[i12 >> 2] | 0) + i12 >> 2] | 0)) i5 = 15; else i1 = i3 + 72 + (i8 << 2) | 0;
 } else {
  if ((i8 | 0) < 39) {
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i5 = 15;
    break;
   }
   return;
  }
  if ((i8 | 0) >= 54) return;
  i1 = i6 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return; else i5 = 20;
 } while (0);
 if ((i5 | 0) == 15) {
  i3 = i1 + i2 | 0;
  i12 = i3 + 40 | 0;
  if (!(HEAP32[i12 + (HEAP32[i12 >> 2] | 0) >> 2] | 0)) i5 = 20; else {
   i3 = i3 + 48 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i5 = 20; else i1 = i4 + i3 + (i8 + -24 << 2) | 0;
  }
 }
 do if ((i5 | 0) == 20) {
  i1 = i1 + i2 | 0;
  i12 = i1 + 40 | 0;
  if (!(HEAP32[i12 + (HEAP32[i12 >> 2] | 0) >> 2] | 0)) return;
  i1 = i1 + 52 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) return; else {
   i1 = i3 + i1 + (i8 + -39 << 2) | 0;
   break;
  }
 } while (0);
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == -1) return;
 i11 = i6 + 20 | 0;
 i12 = i11;
 i1 = i2 + i12 + 40 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 i10 = i1 + 4 | 0;
 i10 = HEAP32[i10 + (HEAP32[i10 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
 if ((i10 | 0) == -1) return;
 i2 = i1 + 16 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i5 = HEAP32[i2 + (i10 * 76 | 0) + 56 >> 2] | 0;
 i3 = HEAP32[i2 + (i10 * 76 | 0) + 60 >> 2] | 0;
 i1 = HEAP32[i2 + (i10 * 76 | 0) + 64 >> 2] | 0;
 i6 = HEAP32[i2 + (i10 * 76 | 0) + 44 >> 2] | 0;
 i4 = HEAP32[i2 + (i10 * 76 | 0) + 48 >> 2] | 0;
 i2 = HEAP32[i2 + (i10 * 76 | 0) + 52 >> 2] | 0;
 do if (i7) {
  i9 = __ZN7mecanim5human14MuscleFromBoneEii(i8, 0) | 0;
  i16 = __ZN7mecanim5human14MuscleFromBoneEii(i8, 1) | 0;
  i7 = __ZN7mecanim5human14MuscleFromBoneEii(i8, 2) | 0;
  i8 = i16;
 } else if ((i8 | 0) < 39) {
  i7 = i8 + -24 | 0;
  i9 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 0) | 0;
  i8 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 1) | 0;
  i7 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 2) | 0;
  i7 = (i7 | 0) != -1 ? i7 + 52 | 0 : -1;
  i8 = (i8 | 0) != -1 ? i8 + 52 | 0 : -1;
  i9 = (i9 | 0) != -1 ? i9 + 52 | 0 : -1;
  break;
 } else {
  i7 = i8 + -39 | 0;
  i9 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 0) | 0;
  i8 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 1) | 0;
  i7 = __ZN7mecanim4hand14MuscleFromBoneEii(i7, 2) | 0;
  i7 = (i7 | 0) != -1 ? i7 + 72 | 0 : -1;
  i8 = (i8 | 0) != -1 ? i8 + 72 | 0 : -1;
  i9 = (i9 | 0) != -1 ? i9 + 72 | 0 : -1;
  break;
 } while (0);
 do if ((i9 | 0) == (i13 | 0)) {
  f14 = Math_fround(f14 * Math_fround(.0174532924));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  f15 = Math_fround(f15 * Math_fround(.0174532924));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  if ((i8 | 0) == (i13 | 0)) {
   f14 = Math_fround(f14 * Math_fround(.0174532924));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   f15 = Math_fround(f15 * Math_fround(.0174532924));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
  if ((i7 | 0) == (i13 | 0)) {
   f14 = Math_fround(f14 * Math_fround(.0174532924));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   f15 = Math_fround(f15 * Math_fround(.0174532924));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  }
 } while (0);
 i16 = (HEAP32[i11 >> 2] | 0) + i12 + 40 | 0;
 i16 = i16 + (HEAP32[i16 >> 2] | 0) + 16 | 0;
 i16 = i16 + (HEAP32[i16 >> 2] | 0) | 0;
 HEAP32[i16 + (i10 * 76 | 0) + 56 >> 2] = i5;
 HEAP32[i16 + (i10 * 76 | 0) + 60 >> 2] = i3;
 HEAP32[i16 + (i10 * 76 | 0) + 64 >> 2] = i1;
 HEAP32[i16 + (i10 * 76 | 0) + 44 >> 2] = i6;
 HEAP32[i16 + (i10 * 76 | 0) + 48 >> 2] = i4;
 HEAP32[i16 + (i10 * 76 | 0) + 52 >> 2] = i2;
 return;
}

function __ZN5physx23transformBoxOrthonormalERKNS_2Gu3BoxERKNS_11PxTransformE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 f12 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(2.0));
 i17 = i3 + 12 | 0;
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 f8 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f12 * f5);
 i16 = i3 + 4 | 0;
 f13 = Math_fround(HEAPF32[i16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f6 * f13));
 i15 = i3 + 8 | 0;
 f14 = Math_fround(HEAPF32[i15 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * f14));
 f10 = Math_fround(Math_fround(f13 * f7) + Math_fround(Math_fround(f6 * f8) + Math_fround(f4 * Math_fround(Math_fround(f12 * f14) - Math_fround(f9 * f5)))));
 f11 = Math_fround(Math_fround(Math_fround(f9 * f8) + Math_fround(f4 * Math_fround(Math_fround(f6 * f5) - Math_fround(f12 * f13)))) + Math_fround(f14 * f7));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f5 * f7) + Math_fround(Math_fround(f12 * f8) + Math_fround(f4 * Math_fround(Math_fround(f9 * f13) - Math_fround(f6 * f14)))));
 HEAPF32[i1 + 4 >> 2] = f10;
 HEAPF32[i1 + 8 >> 2] = f11;
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f11 * f5) + Math_fround(f10 * f13)) + Math_fround(f6 * f14));
 f12 = Math_fround(Math_fround(f13 * f9) + Math_fround(Math_fround(f10 * f8) + Math_fround(f4 * Math_fround(Math_fround(f11 * f14) - Math_fround(f6 * f5)))));
 f7 = Math_fround(Math_fround(Math_fround(f6 * f8) + Math_fround(f4 * Math_fround(Math_fround(f10 * f5) - Math_fround(f11 * f13)))) + Math_fround(f14 * f9));
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f5 * f9) + Math_fround(Math_fround(f11 * f8) + Math_fround(f4 * Math_fround(Math_fround(f6 * f13) - Math_fround(f10 * f14)))));
 HEAPF32[i1 + 16 >> 2] = f12;
 HEAPF32[i1 + 20 >> 2] = f7;
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i2 + 32 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(f7 * f5) + Math_fround(f12 * f13)) + Math_fround(f10 * f14));
 f11 = Math_fround(Math_fround(f13 * f6) + Math_fround(Math_fround(f12 * f8) + Math_fround(f4 * Math_fround(Math_fround(f7 * f14) - Math_fround(f10 * f5)))));
 f9 = Math_fround(Math_fround(Math_fround(f10 * f8) + Math_fround(f4 * Math_fround(Math_fround(f12 * f5) - Math_fround(f7 * f13)))) + Math_fround(f14 * f6));
 HEAPF32[i1 + 24 >> 2] = Math_fround(Math_fround(f5 * f6) + Math_fround(Math_fround(f7 * f8) + Math_fround(f4 * Math_fround(Math_fround(f10 * f13) - Math_fround(f12 * f14)))));
 HEAPF32[i1 + 28 >> 2] = f11;
 HEAPF32[i1 + 32 >> 2] = f9;
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(f9 * f10);
 f8 = Math_fround(HEAPF32[i16 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f11 * f8));
 f7 = Math_fround(HEAPF32[i15 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f14 * f7));
 f6 = Math_fround(Math_fround(f10 * f4) + Math_fround(Math_fround(f9 * f13) + Math_fround(f12 * Math_fround(Math_fround(f14 * f8) - Math_fround(f11 * f7)))));
 f5 = Math_fround(Math_fround(f8 * f4) + Math_fround(Math_fround(f11 * f13) + Math_fround(f12 * Math_fround(Math_fround(f9 * f7) - Math_fround(f14 * f10)))));
 f4 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f8)))) + Math_fround(f7 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f4);
 HEAPF32[i1 + 36 >> 2] = f6;
 HEAPF32[i1 + 40 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f4;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR12GreaterLayerPP14AnimationStateEEbT0_S6_T_(i19, i18, i1) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 switch (i18 - i19 >> 2 | 0) {
 case 2:
  {
   i11 = i18 + -4 | 0;
   i8 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i8 + 32 >> 2] | 0;
   i2 = HEAP32[i3 + 32 >> 2] | 0;
   i9 = i3;
   i10 = i8;
   do if ((i1 | 0) == (i2 | 0)) {
    i4 = i8 + 112 | 0;
    i5 = i3 + 112 | 0;
    i7 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i7 << 24 >> 24 < 0;
    i7 = i6 ? HEAP32[i3 + 116 >> 2] | 0 : i7 & 255;
    i3 = HEAP8[i4 + 11 >> 0] | 0;
    i2 = i3 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i8 + 116 >> 2] | 0 : i3 & 255;
    i1 = i3 >>> 0 < i7 >>> 0 ? i3 : i7;
    if (i1 | 0) {
     i1 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i2 ? HEAP32[i4 >> 2] | 0 : i4, i1) | 0;
     if (i1 | 0) {
      if ((i1 | 0) < 0) break; else i1 = 1;
      return i1 | 0;
     }
    }
    if (i7 >>> 0 >= i3 >>> 0) {
     i19 = 1;
     return i19 | 0;
    }
   } else if ((i1 | 0) <= (i2 | 0)) {
    i19 = 1;
    return i19 | 0;
   } while (0);
   HEAP32[i19 >> 2] = i10;
   HEAP32[i11 >> 2] = i9;
   i19 = 1;
   return i19 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i19, i19 + 4 | 0, i18 + -4 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_(i19, i19 + 4 | 0, i19 + 8 | 0, i18 + -4 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_(i19, i19 + 4 | 0, i19 + 8 | 0, i19 + 12 | 0, i18 + -4 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 1:
 case 0:
  {
   i19 = 1;
   return i19 | 0;
  }
 default:
  {
   i2 = i19 + 8 | 0;
   __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i19, i19 + 4 | 0, i2, i1) | 0;
   i1 = i19 + 12 | 0;
   L3 : do if ((i1 | 0) == (i18 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i16 = i1;
    i1 = 0;
    while (1) {
     i11 = HEAP32[i16 >> 2] | 0;
     i5 = HEAP32[i2 >> 2] | 0;
     i3 = HEAP32[i11 + 32 >> 2] | 0;
     i4 = HEAP32[i5 + 32 >> 2] | 0;
     i15 = i11;
     i10 = i5;
     do if ((i3 | 0) == (i4 | 0)) {
      i6 = i11 + 112 | 0;
      i7 = i5 + 112 | 0;
      i9 = HEAP8[i7 + 11 >> 0] | 0;
      i8 = i9 << 24 >> 24 < 0;
      i5 = i8 ? HEAP32[i5 + 116 >> 2] | 0 : i9 & 255;
      i9 = HEAP8[i6 + 11 >> 0] | 0;
      i4 = i9 << 24 >> 24 < 0;
      i9 = i4 ? HEAP32[i11 + 116 >> 2] | 0 : i9 & 255;
      i3 = i9 >>> 0 < i5 >>> 0 ? i9 : i5;
      if (i3 | 0) {
       i3 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i4 ? HEAP32[i6 >> 2] | 0 : i6, i3) | 0;
       if (i3 | 0) if ((i3 | 0) < 0) {
        i17 = 19;
        break;
       } else break;
      }
      if (i5 >>> 0 < i9 >>> 0) i17 = 19;
     } else if ((i3 | 0) > (i4 | 0)) i17 = 19; while (0);
     if ((i17 | 0) == 19) {
      i17 = 0;
      HEAP32[i16 >> 2] = i10;
      L15 : do if ((i2 | 0) != (i19 | 0)) {
       i12 = i11 + 112 | 0;
       i13 = i12 + 11 | 0;
       i14 = i11 + 116 | 0;
       i11 = HEAP32[i11 + 32 >> 2] | 0;
       while (1) {
        i10 = i2 + -4 | 0;
        i4 = HEAP32[i10 >> 2] | 0;
        i3 = HEAP32[i4 + 32 >> 2] | 0;
        i9 = i4;
        do if ((i11 | 0) == (i3 | 0)) {
         i5 = i4 + 112 | 0;
         i7 = HEAP8[i5 + 11 >> 0] | 0;
         i6 = i7 << 24 >> 24 < 0;
         i7 = i6 ? HEAP32[i4 + 116 >> 2] | 0 : i7 & 255;
         i8 = HEAP8[i13 >> 0] | 0;
         i4 = i8 << 24 >> 24 < 0;
         i8 = i4 ? HEAP32[i14 >> 2] | 0 : i8 & 255;
         i3 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
         if (i3 | 0) {
          i3 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i12 >> 2] | 0 : i12, i3) | 0;
          if (i3 | 0) if ((i3 | 0) < 0) break; else break L15;
         }
         if (i7 >>> 0 >= i8 >>> 0) break L15;
        } else if ((i11 | 0) <= (i3 | 0)) break L15; while (0);
        HEAP32[i2 >> 2] = i9;
        if ((i10 | 0) == (i19 | 0)) {
         i2 = i10;
         break;
        } else i2 = i10;
       }
      } while (0);
      HEAP32[i2 >> 2] = i15;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i16 + 4 | 0) == (i18 | 0);
       break L3;
      }
     }
     i2 = i16 + 4 | 0;
     if ((i2 | 0) == (i18 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i15 = i16;
      i16 = i2;
      i2 = i15;
     }
    }
   } while (0);
   i19 = i1 | i2;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i17, i19, i18, i1, i7) {
 i17 = i17 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20 + 24 | 0;
 i13 = i20 + 12 | 0;
 i16 = i20;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _memset(i14 | 0, 0, i1 | 0) | 0;
 HEAP32[i17 >> 2] = 2139095039;
 i15 = i17 + 4 | 0;
 i2 = 2139095039;
 i5 = i7;
 i1 = -1;
 do {
  i3 = HEAP32[i5 + 48 >> 2] | 0;
  i4 = HEAP32[i5 + 52 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) do {
   i22 = HEAP32[i18 + (i3 << 6) + 44 >> 2] | 0;
   f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i21 = f12 > (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i2 = i21 ? i22 : i2;
   i1 = i21 ? i3 : i1;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
  i5 = HEAP32[i5 + 16 >> 2] | 0;
 } while ((i5 | 0) != 0);
 HEAP8[i14 + i1 >> 0] = 1;
 i2 = i19;
 i3 = i18 + (i1 << 6) | 0;
 i4 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 f12 = Math_fround(HEAPF32[i18 + (i1 << 6) + 44 >> 2]);
 i1 = f12 < Math_fround(3402823469999999843913219.0e14);
 f12 = i1 ? f12 : Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i17 >> 2] = f12;
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i18 + (i1 << 6) + 16 >> 2]);
 f23 = Math_fround(HEAPF32[i18 + (i1 << 6) + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i18 + (i1 << 6) + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i19 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 24 >> 2]);
 f24 = Math_fround(f24 - f9);
 f23 = Math_fround(f23 - f10);
 f6 = Math_fround(f6 - f11);
 f6 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f23 * f23)) + Math_fround(f6 * f6));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = i1;
 i2 = i7;
 while (1) {
  i8 = HEAP32[i2 + 52 >> 2] | 0;
  if (i4 >>> 0 < i8 >>> 0) do {
   f23 = Math_fround(HEAPF32[i18 + (i4 << 6) + 16 >> 2]);
   f24 = Math_fround(HEAPF32[i18 + (i4 << 6) + 20 >> 2]);
   f23 = Math_fround(f23 - f9);
   f24 = Math_fround(f24 - f10);
   f6 = Math_fround(Math_fround(HEAPF32[i18 + (i4 << 6) + 24 >> 2]) - f11);
   f6 = Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f24 * f24)) + Math_fround(f6 * f6));
   i5 = f6 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i3 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : i3;
   i1 = i5 ? i4 : i1;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i8 >>> 0);
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  if (!i2) break;
  i4 = HEAP32[i2 + 48 >> 2] | 0;
 }
 HEAP8[i14 + i1 >> 0] = 1;
 i2 = i19 + 64 | 0;
 i3 = i18 + (i1 << 6) | 0;
 i4 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 f6 = Math_fround(HEAPF32[i18 + (i1 << 6) + 44 >> 2]);
 f6 = f12 > f6 ? f6 : f12;
 HEAPF32[i17 >> 2] = f6;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i2 = 2139095039;
 do {
  i3 = HEAP32[i7 + 48 >> 2] | 0;
  i5 = HEAP32[i7 + 52 >> 2] | 0;
  if (i3 >>> 0 < i5 >>> 0) do {
   if (!(HEAP8[i14 + i3 >> 0] | 0)) {
    i4 = HEAP32[i18 + (i3 << 6) + 44 >> 2] | 0;
    f24 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f24 > (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i2 = i4;
     i1 = i3;
    }
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i5 >>> 0);
  i7 = HEAP32[i7 + 16 >> 2] | 0;
 } while ((i7 | 0) != 0);
 i2 = i19 + 128 | 0;
 i3 = i18 + (i1 << 6) | 0;
 i4 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 f24 = Math_fround(HEAPF32[i18 + (i1 << 6) + 44 >> 2]);
 HEAPF32[i17 >> 2] = f6 > f24 ? f24 : f6;
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 STACKTOP = i20;
 return;
}

function __ZN13WheelCollider25AddWheelToExistingVehicleEP9RigidbodyPN5physx16PxVehicleNoDriveEi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i5 + 144 | 0;
 i11 = i5 + 96 | 0;
 i10 = i5 + 32 | 0;
 i6 = i5 + 16 | 0;
 i7 = i5;
 i8 = i3 + 8 | 0;
 __ZN5physx22PxVehicleWheelsSimData11enableWheelEj(i8, i4);
 __ZN5physx22PxVehicleWheelsSimData15setSubStepCountEfjj(i8, Math_fround(5.0), 5, 1);
 i9 = i1 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 i16 = f14 < Math_fround(0.0);
 f13 = Math_fround(-f14);
 f14 = i16 ? f13 : f14;
 i16 = f14 < Math_fround(9.99999974e-06);
 f14 = i16 ? Math_fround(9.99999974e-06) : f14;
 __ZNK9Transform18GetWorldScaleLossyEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 f13 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 i16 = f13 < Math_fround(0.0);
 f12 = Math_fround(-f13);
 f13 = i16 ? f12 : f13;
 i16 = f13 < Math_fround(9.99999974e-06);
 f13 = i16 ? Math_fround(9.99999974e-06) : f13;
 f12 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 HEAP32[i1 + 148 >> 2] = i4;
 i16 = i15 + 16 | 0;
 i17 = i16 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAPF32[i15 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i15 + 36 >> 2] = Math_fround(1.0);
 HEAP32[i15 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAPF32[i15 + 8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f12) * f13);
 HEAPF32[i15 + 12 >> 2] = Math_fround(f12 * f13);
 HEAPF32[i16 >> 2] = Math_fround(__ZNK9Rigidbody7GetMassEv(i2));
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i8, i4, i15);
 f13 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 i15 = f13 < Math_fround(9.99999974e-06);
 f13 = i15 ? Math_fround(9.99999974e-06) : f13;
 f12 = Math_fround(f14 * Math_fround(f14 * Math_fround(f13 * Math_fround(.5))));
 HEAPF32[i11 + 16 >> 2] = Math_fround(.25);
 HEAPF32[i11 + 20 >> 2] = Math_fround(1500.0);
 i15 = i11 + 24 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAPF32[i11 >> 2] = f14;
 HEAPF32[i11 + 8 >> 2] = f13;
 HEAPF32[i11 + 12 >> 2] = f12;
 HEAPF32[i11 + 4 >> 2] = Math_fround(.100000001);
 __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i8, i4, i11);
 HEAPF32[i10 >> 2] = Math_fround(2.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(17.9049301);
 HEAPF32[i10 + 8 >> 2] = Math_fround(1.0e3);
 HEAPF32[i10 + 12 >> 2] = Math_fround(5.72957754);
 HEAP32[i10 + 40 >> 2] = 0;
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(.100000001);
 HEAPF32[i10 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 44 >> 2] = Math_fround(.00100000005);
 HEAPF32[i10 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i10 + 52 >> 2] = Math_fround(1.11111116);
 __ZN5physx22PxVehicleWheelsSimData11setTireDataEjRKNS_17PxVehicleTireDataE(i8, i4, i10);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx22PxVehicleWheelsSimData22setSuspTravelDirectionEjRKNS_6PxVec3E(i8, i4, i6);
 __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i1);
 i6 = i3 + 72 | 0;
 __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv(i6, i4, i1);
 __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji(i8, i4, -1);
 i10 = i7 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2];
 __ZN8Collider18SelfPointerToWordsERjS0_(i1, i7 + 4 | 0, i7 + 12 | 0);
 HEAP32[i7 + 8 >> 2] = (HEAP32[i2 + 64 >> 2] << 16) + 65536;
 __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i8, i4, i7);
 __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf(i3, Math_fround(__ZNK9Rigidbody7GetMassEv(i2)));
 __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv(i6, i4, i1 + 104 | 0);
 STACKTOP = i5;
 return;
}

function __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 24 | 0;
 i17 = i19 + 12 | 0;
 i18 = i19;
 i1 = HEAP32[gb + 1469348 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1469348 + 4 >> 2] | 0)) {
  i18 = i1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i13 = i16 + 11 | 0;
 i14 = i16 + 4 | 0;
 i15 = i18 + 11 | 0;
 i12 = i18 + 4 | 0;
 L4 : while (1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, _strlen(i1) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i16, i17);
  i10 = HEAP8[i13 >> 0] | 0;
  i2 = i10 << 24 >> 24 < 0;
  if ((i2 ? HEAP32[i14 >> 2] | 0 : i10 & 255) | 0) {
   i2 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
   do {
    i9 = HEAP8[i2 >> 0] | 0;
    i10 = i9 << 24 >> 24;
    HEAP8[i2 >> 0] = (i9 + -65 & 255) < 26 ? i10 + 32 | 0 : i10;
    i2 = i2 + 1 | 0;
    i10 = HEAP8[i13 >> 0] | 0;
    i9 = i10 << 24 >> 24 < 0;
   } while ((i2 | 0) != ((i9 ? HEAP32[i16 >> 2] | 0 : i16) + (i9 ? HEAP32[i14 >> 2] | 0 : i10 & 255) | 0));
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i18, i11);
  i2 = HEAP8[i15 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  i5 = HEAP32[i18 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  if ((i3 ? i4 : i2 & 255) | 0) {
   i3 = i3 ? i5 : i18;
   do {
    i10 = HEAP8[i3 >> 0] | 0;
    i2 = i10 << 24 >> 24;
    HEAP8[i3 >> 0] = (i10 + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
    i3 = i3 + 1 | 0;
    i2 = HEAP8[i15 >> 0] | 0;
    i10 = i2 << 24 >> 24 < 0;
    i5 = HEAP32[i18 >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
   } while ((i3 | 0) != ((i10 ? i5 : i18) + (i10 ? i4 : i2 & 255) | 0));
  }
  i3 = HEAP8[i13 >> 0] | 0;
  i9 = i3 << 24 >> 24 < 0;
  i3 = i3 & 255;
  i10 = i9 ? HEAP32[i14 >> 2] | 0 : i3;
  i6 = i2 << 24 >> 24 < 0;
  do if ((i10 | 0) == ((i6 ? i4 : i2 & 255) | 0)) {
   i7 = HEAP32[i16 >> 2] | 0;
   i8 = i9 ? i7 : i16;
   i2 = i6 ? i5 : i18;
   i4 = (i10 | 0) == 0;
   if (i9) {
    if (i4) {
     i2 = 20;
     break L4;
    }
    i10 = (_memcmp(i8, i2, i10) | 0) == 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    if (i10) {
     i2 = 23;
     break L4;
    } else break;
   }
   if (i4) {
    i2 = 21;
    break L4;
   }
   if ((i7 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
    i4 = i16;
    do {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) {
      i2 = 22;
      break L4;
     }
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  } while (0);
  i1 = i1 + 668 | 0;
  if ((i1 | 0) == (HEAP32[gb + 1469348 + 4 >> 2] | 0)) {
   i2 = 23;
   break;
  }
 }
 if ((i2 | 0) == 20) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i18 = i1;
  STACKTOP = i19;
  return i18 | 0;
 } else if ((i2 | 0) == 21) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i18 = i1;
  STACKTOP = i19;
  return i18 | 0;
 } else if ((i2 | 0) == 22) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  i18 = i1;
  STACKTOP = i19;
  return i18 | 0;
 } else if ((i2 | 0) == 23) {
  STACKTOP = i19;
  return i1 | 0;
 }
 return 0;
}

function __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i30, i26, i1) {
 i30 = i30 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0, i29 = 0;
 i27 = i30 + 4 | 0;
 i28 = i30 + 8 | 0;
 i29 = i30 + 12 | 0;
 HEAP32[i30 >> 2] = -1;
 HEAP32[i30 + 4 >> 2] = -1;
 HEAP32[i30 + 8 >> 2] = -1;
 HEAP32[i30 + 12 >> 2] = -1;
 f18 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(65535.0));
 f19 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(65535.0));
 f21 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(65535.0));
 f18 = Math_fround(f18 + Math_fround(.5));
 f19 = Math_fround(f19 + Math_fround(.5));
 f21 = Math_fround(f21 + Math_fround(.5));
 f22 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(65535.0)) + Math_fround(.5));
 i25 = HEAP16[i26 + 64 >> 1] | 0;
 i14 = i25 & 255;
 i16 = (i25 & 65535) >>> 8;
 i17 = i16 & 255;
 L1 : do if ((i25 & 255) > 1) {
  i25 = HEAP16[i26 + 32 >> 1] | 0;
  f10 = Math_fround(i25 & 65535);
  f15 = Math_fround(HEAPU16[i26 + 32 + (i14 + -1 << 1) >> 1] | 0);
  f11 = Math_fround(_fminf(Math_fround(_fmaxf(f18, f10)), f15));
  f12 = Math_fround(_fminf(Math_fround(_fmaxf(f19, f10)), f15));
  f13 = Math_fround(_fminf(Math_fround(_fmaxf(f21, f10)), f15));
  f15 = Math_fround(_fminf(Math_fround(_fmaxf(f22, f10)), f15));
  f10 = Math_fround(i25 & 65535);
  L3 : do if (f15 > f10 & (f13 > f10 & (f12 > f10 & f11 > f10))) {
   i1 = 0;
   do {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i14 >>> 0) break L3;
    f10 = Math_fround(HEAPU16[i26 + 32 + (i1 << 1) >> 1] | 0);
   } while (f15 > f10 & (f13 > f10 & (f12 > f10 & f11 > f10)));
  } else i1 = 0; while (0);
  if (i1 >>> 0 < i14 >>> 0) {
   i4 = -1;
   i5 = 0;
   i6 = 0;
   i7 = -1;
   i9 = -1;
   i8 = -1;
   i2 = 0;
   i3 = 0;
   while (1) {
    if ((i2 & i5 & i3 & i6 | 0) <= -1) {
     i25 = i4;
     i24 = i7;
     i23 = i9;
     i20 = i8;
     break L1;
    }
    f10 = Math_fround(HEAPU16[i26 + 32 + (i1 << 1) >> 1] | 0);
    i25 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
    i4 = i4 & i5 | i25 & ~i5;
    i2 = i7 & i2 | i25 & ~i2;
    i3 = i9 & i3 | i25 & ~i3;
    i8 = i8 & i6 | i25 & ~i6;
    HEAP32[i30 >> 2] = i4;
    HEAP32[i27 >> 2] = i2;
    HEAP32[i28 >> 2] = i3;
    HEAP32[i29 >> 2] = i8;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i14 >>> 0) {
     i25 = i4;
     i24 = i2;
     i23 = i3;
     i20 = i8;
     break;
    } else {
     i5 = (f11 <= f10) << 31 >> 31;
     i6 = (f15 <= f10) << 31 >> 31;
     i7 = i2;
     i9 = i3;
     i2 = (f12 <= f10) << 31 >> 31;
     i3 = (f13 <= f10) << 31 >> 31;
    }
   }
  } else {
   i25 = -1;
   i24 = -1;
   i23 = -1;
   i20 = -1;
  }
 } else {
  i25 = -1;
  i24 = -1;
  i23 = -1;
  i20 = -1;
 } while (0);
 i14 = i16 & 65535;
 if ((i17 & 255) <= 1) return;
 i17 = HEAP16[i26 + 48 >> 1] | 0;
 f10 = Math_fround(i17 & 65535);
 f11 = Math_fround(HEAPU16[i26 + 48 + (i14 + -1 << 1) >> 1] | 0);
 f15 = Math_fround(_fminf(Math_fround(_fmaxf(f18, f10)), f11));
 f13 = Math_fround(_fminf(Math_fround(_fmaxf(f19, f10)), f11));
 f12 = Math_fround(_fminf(Math_fround(_fmaxf(f21, f10)), f11));
 f11 = Math_fround(_fminf(Math_fround(_fmaxf(f22, f10)), f11));
 f22 = Math_fround(i17 & 65535);
 L15 : do if (f11 > f22 & (f12 > f22 & (f13 > f22 & f15 > f22))) {
  i1 = 0;
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i14 >>> 0) break L15;
   f22 = Math_fround(HEAPU16[i26 + 48 + (i1 << 1) >> 1] | 0);
  } while (f11 > f22 & (f12 > f22 & (f13 > f22 & f15 > f22)));
 } else i1 = 0; while (0);
 L20 : do if (i1 >>> 0 < i14 >>> 0) {
  i8 = i1;
  i4 = -1;
  i7 = 0;
  i3 = -1;
  i9 = 0;
  i2 = -1;
  i1 = -1;
  i5 = 0;
  i6 = 0;
  while (1) {
   if ((i5 & i7 & i6 & i9 | 0) <= -1) break L20;
   f10 = Math_fround(HEAPU16[i26 + 48 + (i8 << 1) >> 1] | 0);
   i17 = HEAP32[i26 + (i8 << 2) >> 2] | 0;
   i4 = i17 & ~i7 | i7 & i4;
   i1 = i17 & ~i5 | i5 & i1;
   i3 = i17 & ~i6 | i6 & i3;
   i2 = i17 & ~i9 | i9 & i2;
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= i14 >>> 0) break; else {
    i7 = (f15 <= f10) << 31 >> 31;
    i9 = (f11 <= f10) << 31 >> 31;
    i5 = (f13 <= f10) << 31 >> 31;
    i6 = (f12 <= f10) << 31 >> 31;
   }
  }
 } else {
  i4 = -1;
  i3 = -1;
  i2 = -1;
  i1 = -1;
 } while (0);
 HEAP32[i30 >> 2] = i25 & 16777215 | i4 & -16777216;
 HEAP32[i27 >> 2] = i24 & 16777215 | i1 & -16777216;
 HEAP32[i28 >> 2] = i23 & 16777215 | i3 & -16777216;
 HEAP32[i29 >> 2] = i20 & 16777215 | i2 & -16777216;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 256 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 64 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_(i8, i9, i12, i13) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 88 | 0;
 i14 = i16 + 80 | 0;
 i18 = i16 + 72 | 0;
 i3 = i16 + 64 | 0;
 i4 = i16 + 56 | 0;
 i5 = i16 + 48 | 0;
 i6 = i16 + 40 | 0;
 i7 = i16 + 32 | 0;
 i1 = i16 + 24 | 0;
 i2 = i16 + 16 | 0;
 i10 = i16 + 8 | 0;
 i11 = i16;
 i17 = HEAP32[i13 >> 2] | 0;
 i19 = i9;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = i18;
 HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 i21 = i8;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = i3;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 4 >> 2] = i20;
 HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i17 = mftCall_iii(i17 | 0, i14 | 0, i15 | 0) | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if (!i17) {
  i21 = i12;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = i4;
  HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  i19 = i9;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i5;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  if (!(mftCall_iii(i3 | 0, i14 | 0, i15 | 0) | 0)) {
   i21 = 0;
   STACKTOP = i16;
   return i21 | 0;
  }
  i20 = i9;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i17 = i12;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i21 = i9;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i21 + 4 >> 2] = i18;
  i21 = i12;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  i21 = HEAP32[i13 >> 2] | 0;
  i20 = i9;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = i6;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  i18 = i8;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i20 = i7;
  HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i20 + 4 >> 2] = i19;
  HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  if (!(mftCall_iii(i21 | 0, i14 | 0, i15 | 0) | 0)) {
   i21 = 1;
   STACKTOP = i16;
   return i21 | 0;
  }
  i20 = i8;
  i19 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i17 = i9;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i21 = i8;
  HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i21 + 4 >> 2] = i18;
  i21 = i9;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i21 + 4 >> 2] = i20;
  i21 = 2;
  STACKTOP = i16;
  return i21 | 0;
 }
 i21 = i12;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i19 = i1;
 HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i19 + 4 >> 2] = i20;
 i19 = i9;
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = i2;
 HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i21 + 4 >> 2] = i20;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i21 = mftCall_iii(i3 | 0, i14 | 0, i15 | 0) | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i21) {
  i19 = i12;
  i20 = HEAP32[i19 + 4 >> 2] | 0;
  i21 = i8;
  HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i21 + 4 >> 2] = i20;
  i21 = i12;
  HEAP32[i21 >> 2] = i1;
  HEAP32[i21 + 4 >> 2] = i2;
  i21 = 1;
  STACKTOP = i16;
  return i21 | 0;
 }
 i19 = i9;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = i8;
 HEAP32[i21 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i21 + 4 >> 2] = i18;
 i21 = i9;
 HEAP32[i21 >> 2] = i1;
 HEAP32[i21 + 4 >> 2] = i2;
 i21 = HEAP32[i13 >> 2] | 0;
 i18 = i12;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i20 = i10;
 HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 i20 = i11;
 HEAP32[i20 >> 2] = i1;
 HEAP32[i20 + 4 >> 2] = i2;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 if (!(mftCall_iii(i21 | 0, i14 | 0, i15 | 0) | 0)) {
  i21 = 1;
  STACKTOP = i16;
  return i21 | 0;
 }
 i20 = i9;
 i19 = HEAP32[i20 >> 2] | 0;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 i17 = i12;
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i21 = i9;
 HEAP32[i21 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i21 + 4 >> 2] = i18;
 i21 = i12;
 HEAP32[i21 >> 2] = i19;
 HEAP32[i21 + 4 >> 2] = i20;
 i21 = 2;
 STACKTOP = i16;
 return i21 | 0;
}

function __ZZL16BuildDetailHullsRNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEERK13dynamic_arrayI5PlaneLj4EERK10MinMaxAABBRK10DetailMeshPK10dtMeshTileEN12ClipCallback7processESI_RK14DetailMeshPolyPKii(i1, i16, i18, i19, i20) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 if ((i20 | 0) <= 0) return;
 i21 = i16 + 20 | 0;
 i22 = i1 + 12 | 0;
 i23 = i1 + 4 | 0;
 i24 = i1 + 16 | 0;
 i17 = i1 + 20 | 0;
 i15 = i1 + 8 | 0;
 i14 = 0;
 do {
  i1 = (HEAP32[i21 >> 2] | 0) + (HEAP32[i19 + (i14 << 2) >> 2] << 2 << 1) | 0;
  i2 = HEAP32[i22 >> 2] | 0;
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = 3;
  i4 = i2 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < 3) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = 3;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 36, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = 3;
   HEAP32[i2 >> 2] = i13;
   break;
  } while (0);
  i10 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
  i11 = (HEAP32[i16 >> 2] | 0) + (((HEAPU16[i1 >> 1] | 0) + (HEAP32[i18 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + 12 | 0;
  i11 = (HEAP32[i16 >> 2] | 0) + (((HEAPU16[i1 + 2 >> 1] | 0) + (HEAP32[i18 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + 24 | 0;
  i11 = (HEAP32[i16 >> 2] | 0) + (((HEAPU16[i1 + 4 >> 1] | 0) + (HEAP32[i18 >> 2] | 0) | 0) * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i10 = HEAP32[i22 >> 2] | 0;
  i11 = HEAP32[i23 >> 2] | 0;
  i5 = HEAP32[i24 >> 2] | 0;
  i12 = HEAP32[i11 + 12 >> 2] | 0;
  L12 : do if (i12 | 0) {
   i6 = i5 + 12 | 0;
   i13 = i10 + 12 | 0;
   i7 = i10 + 16 | 0;
   i8 = i10 + 4 | 0;
   L14 : do if ((i5 | 0) == (i10 | 0)) {
    i1 = 0;
    while (1) {
     if ((__ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i10, i10, (HEAP32[i11 >> 2] | 0) + (i1 << 4) | 0) | 0) == 1) break L14;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i12 >>> 0) break L12;
    }
   } else {
    i4 = 0;
    while (1) {
     switch (__ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane(i5, i10, (HEAP32[i11 >> 2] | 0) + (i4 << 4) | 0) | 0) {
     case 1:
      break L14;
     case 0:
      {
       i9 = HEAP32[i5 >> 2] | 0;
       i1 = (HEAP32[i6 >> 2] | 0) * 12 | 0;
       i2 = (i1 | 0) / 12 | 0;
       HEAP32[i13 >> 2] = i2;
       i3 = HEAP32[i7 >> 2] | 0;
       do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
        HEAP32[i7 >> 2] = i2;
        i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
        HEAP32[i10 >> 2] = i1;
        break;
       } else {
        i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
        HEAP32[i7 >> 2] = i2;
        HEAP32[i10 >> 2] = i1;
        break;
       } else i1 = HEAP32[i10 >> 2] | 0; while (0);
       _memcpy(i1 | 0, i9 | 0, (HEAP32[i13 >> 2] | 0) * 12 | 0) | 0;
       break;
      }
     default:
      {}
     }
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i12 >>> 0) break L12;
    }
   } while (0);
   HEAP32[i13 >> 2] = 0;
  } while (0);
  i1 = HEAP32[i22 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  i2 = (i3 | 0) > 0;
  if (i2) {
   __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(HEAP32[i15 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
   if ((i3 | 0) != 1) {
    i1 = 1;
    do {
     __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(HEAP32[i15 >> 2] | 0, (HEAP32[HEAP32[i22 >> 2] >> 2] | 0) + (i1 * 12 | 0) | 0) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  }
  HEAP8[i17 >> 0] = HEAPU8[i17 >> 0] | 0 | i2 & 1;
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != (i20 | 0));
 return;
}

function __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, i40 = 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i16 = i14 + 4 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 i17 = i14 + 8 | 0;
 i6 = HEAP32[i17 >> 2] | 0;
 i18 = i14 + 16 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i19 = i14 + 20 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i15 = i14 + 24 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i8 = HEAP32[i5 + 16 >> 2] | 0;
 i11 = HEAP16[i5 + 26 >> 1] | 0;
 i13 = i8 + ((i11 & 65535) << 4) | 0;
 if (!(i11 << 16 >> 16)) {
  i9 = i6;
  i8 = i7;
  i7 = i4;
  i13 = i3;
  i11 = i2;
  i10 = i1;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i16 >> 2] = i8;
  HEAP32[i17 >> 2] = i9;
  HEAP32[i18 >> 2] = i10;
  HEAP32[i19 >> 2] = i11;
  HEAP32[i15 >> 2] = i13;
  return;
 } else i5 = i7;
 do {
  i7 = HEAP8[i8 + 2 >> 0] | 0;
  i9 = i7 & 255;
  i10 = i8 + 32 | 0;
  i20 = (((HEAPU8[i8 + 1 >> 0] | 0) << 2) + 12 & 2032) + 32 | 0;
  i11 = i8 + i20 | 0;
  f12 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  i8 = i8 + (i20 + (i9 * 96 | 0)) | 0;
  if (i7 << 24 >> 24) {
   i7 = 0;
   do {
    i40 = i7;
    i7 = i7 + 1 | 0;
    f31 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) >> 2]);
    f30 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 4 >> 2]);
    f39 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 8 >> 2]);
    i20 = i11 + (i40 * 96 | 0) + 12 | 0;
    f26 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 16 >> 2]);
    f24 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 20 >> 2]);
    f38 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 24 >> 2]);
    f22 = Math_fround(HEAPF32[i20 >> 2]);
    f37 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 28 >> 2]);
    f35 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 44 >> 2]);
    f36 = Math_fround(f12 * Math_fround(HEAPF32[i10 + (HEAP32[i11 + (i40 * 96 | 0) + 80 >> 2] << 2) >> 2]));
    f21 = Math_fround(-f36);
    f34 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f34 * f31);
    f33 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f23 + Math_fround(f33 * f30));
    f32 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f23 = Math_fround(f23 + Math_fround(f32 * f39));
    f28 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f26 = Math_fround(f28 * f26);
    f27 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f24 = Math_fround(f26 + Math_fround(f27 * f24));
    f26 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f38 = Math_fround(f23 + Math_fround(f24 + Math_fround(f26 * f38)));
    f24 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 48 >> 2]);
    f23 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 52 >> 2]);
    f25 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 56 >> 2]);
    f29 = Math_fround(HEAPF32[i11 + (i40 * 96 | 0) + 60 >> 2]);
    f31 = Math_fround(f31 * f29);
    f30 = Math_fround(f30 * f29);
    f29 = Math_fround(f39 * f29);
    f35 = Math_fround(Math_fround(f37 * f38) + Math_fround(f22 - Math_fround(f37 * f35)));
    f35 = f35 > f36 ? f36 : f35;
    f21 = f35 > f21 ? f35 : f21;
    f22 = Math_fround(f21 - f22);
    f31 = Math_fround(f34 + Math_fround(f31 * f22));
    f30 = Math_fround(f33 + Math_fround(f30 * f22));
    f29 = Math_fround(f32 + Math_fround(f29 * f22));
    i4 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
    f24 = Math_fround(f28 + Math_fround(f24 * f22));
    f23 = Math_fround(f27 + Math_fround(f23 * f22));
    f22 = Math_fround(f26 + Math_fround(f25 * f22));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
    HEAPF32[i20 >> 2] = f21;
   } while ((i7 | 0) != (i9 | 0));
  }
 } while (i8 >>> 0 < i13 >>> 0);
 HEAP32[i14 >> 2] = i4;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i17 >> 2] = i6;
 HEAP32[i18 >> 2] = i1;
 HEAP32[i19 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i19, i1, i5, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 16 | 0;
 i17 = i21;
 i16 = i21 + 4 | 0;
 i18 = i19 + 4 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i14) | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i19 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i15 = HEAP32[i19 + 20 >> 2] | 0;
    i15 = (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i15;
    i1 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i15;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP8[(HEAP32[i15 + 4 >> 2] | 0) + ((HEAP32[i15 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i15 = i19 + 36 | 0;
 L12 : do if (HEAP8[i15 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i19, gb + 830924 | 0);
  if (!(HEAP8[i15 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i19 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i15 >> 0] = i1;
  }
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i9 = i19 + 20 | 0;
   i10 = i19 + 40 | 0;
   i11 = i19 + 24 | 0;
   i12 = i16 + 4 | 0;
   i13 = i16 + 8 | 0;
   i5 = i5 + 12 | 0;
   i6 = i14 + 4 | 0;
   i7 = i14 + 8 | 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i8 = 0;
   while (1) {
    i4 = HEAP32[i9 >> 2] | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    if (!i4) i20 = 17; else if (!(HEAP8[i4 >> 0] | 0)) i20 = 17; else {
     HEAP32[i17 >> 2] = i4;
     __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i14, i16, i17);
     i3 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if ((i20 | 0) == 17) {
     i20 = 0;
     HEAP8[HEAP32[i10 >> 2] >> 0] = 1;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i22 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    mftCall_viii(i22 | 0, i4 | 0, i8 | 0, i14 | 0);
    if (!(HEAP8[i15 >> 0] | 0)) break L12;
    i22 = HEAP32[i9 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0) i8 = i8 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i19 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i20 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i15 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i20 | 0) == 24) HEAP8[i15 >> 0] = 1;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i21;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i19, i1, i5, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 16 | 0;
 i17 = i21;
 i16 = i21 + 4 | 0;
 i18 = i19 + 4 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i14) | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i19 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i15 = HEAP32[i19 + 20 >> 2] | 0;
    i15 = (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i15;
    i1 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i15;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP8[(HEAP32[i15 + 4 >> 2] | 0) + ((HEAP32[i15 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i15 = i19 + 36 | 0;
 L12 : do if (HEAP8[i15 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i19, gb + 830924 | 0);
  if (!(HEAP8[i15 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i19 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i15 >> 0] = i1;
  }
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i9 = i19 + 20 | 0;
   i10 = i19 + 40 | 0;
   i11 = i19 + 24 | 0;
   i12 = i16 + 4 | 0;
   i13 = i16 + 8 | 0;
   i5 = i5 + 12 | 0;
   i6 = i14 + 4 | 0;
   i7 = i14 + 8 | 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i8 = 0;
   while (1) {
    i4 = HEAP32[i9 >> 2] | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    if (!i4) i20 = 17; else if (!(HEAP8[i4 >> 0] | 0)) i20 = 17; else {
     HEAP32[i17 >> 2] = i4;
     __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i14, i16, i17);
     i3 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if ((i20 | 0) == 17) {
     i20 = 0;
     HEAP8[HEAP32[i10 >> 2] >> 0] = 1;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i22 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    mftCall_viii(i22 | 0, i4 | 0, i8 | 0, i14 | 0);
    if (!(HEAP8[i15 >> 0] | 0)) break L12;
    i22 = HEAP32[i9 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0) i8 = i8 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i19 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i20 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i15 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i20 | 0) == 24) HEAP8[i15 >> 0] = 1;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i21;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i19, i1, i5, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 16 | 0;
 i17 = i21;
 i16 = i21 + 4 | 0;
 i18 = i19 + 4 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i14) | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i19 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i15 = HEAP32[i19 + 20 >> 2] | 0;
    i15 = (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i15;
    i1 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i15;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP8[(HEAP32[i15 + 4 >> 2] | 0) + ((HEAP32[i15 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i15 = i19 + 36 | 0;
 L12 : do if (HEAP8[i15 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i19, gb + 830924 | 0);
  if (!(HEAP8[i15 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i19 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i15 >> 0] = i1;
  }
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i9 = i19 + 20 | 0;
   i10 = i19 + 40 | 0;
   i11 = i19 + 24 | 0;
   i12 = i16 + 4 | 0;
   i13 = i16 + 8 | 0;
   i5 = i5 + 12 | 0;
   i6 = i14 + 4 | 0;
   i7 = i14 + 8 | 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i8 = 0;
   while (1) {
    i4 = HEAP32[i9 >> 2] | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    if (!i4) i20 = 17; else if (!(HEAP8[i4 >> 0] | 0)) i20 = 17; else {
     HEAP32[i17 >> 2] = i4;
     __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i14, i16, i17);
     i3 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if ((i20 | 0) == 17) {
     i20 = 0;
     HEAP8[HEAP32[i10 >> 2] >> 0] = 1;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i22 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    mftCall_viii(i22 | 0, i4 | 0, i8 | 0, i14 | 0);
    if (!(HEAP8[i15 >> 0] | 0)) break L12;
    i22 = HEAP32[i9 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0) i8 = i8 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i19 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i20 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i15 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i20 | 0) == 24) HEAP8[i15 >> 0] = 1;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i21;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i19, i1, i5, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 16 | 0;
 i17 = i21;
 i16 = i21 + 4 | 0;
 i18 = i19 + 4 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = i4;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i2 << 2) >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i14) | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i19 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i15 = HEAP32[i19 + 20 >> 2] | 0;
    i15 = (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i15;
    i1 = HEAP32[i19 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i15;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i15 = HEAP32[i19 >> 2] | 0;
   HEAP8[(HEAP32[i15 + 4 >> 2] | 0) + ((HEAP32[i15 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i15 = i19 + 36 | 0;
 L12 : do if (HEAP8[i15 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i19, gb + 830924 | 0);
  if (!(HEAP8[i15 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i19 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i15 >> 0] = i1;
  }
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i13 = HEAP32[i19 >> 2] | 0;
  HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + ((HEAP32[i13 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i9 = i19 + 20 | 0;
   i10 = i19 + 40 | 0;
   i11 = i19 + 24 | 0;
   i12 = i16 + 4 | 0;
   i13 = i16 + 8 | 0;
   i5 = i5 + 12 | 0;
   i6 = i14 + 4 | 0;
   i7 = i14 + 8 | 0;
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i8 = 0;
   while (1) {
    i4 = HEAP32[i9 >> 2] | 0;
    i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
    if (!i4) i20 = 17; else if (!(HEAP8[i4 >> 0] | 0)) i20 = 17; else {
     HEAP32[i17 >> 2] = i4;
     __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i14, i16, i17);
     i3 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    }
    if ((i20 | 0) == 17) {
     i20 = 0;
     HEAP8[HEAP32[i10 >> 2] >> 0] = 1;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i22 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    mftCall_viii(i22 | 0, i4 | 0, i8 | 0, i14 | 0);
    if (!(HEAP8[i15 >> 0] | 0)) break L12;
    i22 = HEAP32[i9 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i22 >> 2] | 0) + 24 >> 2] | 0, i22 | 0) | 0) i8 = i8 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i19 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i20 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i19 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i19 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i15 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i20 | 0) == 24) HEAP8[i15 >> 0] = 1;
  i1 = HEAP32[i18 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i21;
 return;
}

function __ZN15SharedLightData16CheckConsistencyEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i2 = i9;
 i5 = i6 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) i1 = i6 + 40 | 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i2);
    i2 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 10; else i2 = i1;
   }
  }
  if ((i8 | 0) == 8) i8 = 10;
  if ((i8 | 0) == 10) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i1 = i6 + 40 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = (i2 | 0) != 0;
  if (i4 & (i3 | 0) == 2) if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) != (gb + 29912 | 0)) {
   HEAP32[i5 >> 2] = 0;
   break;
  }
  if (i4 & (i3 | 0) != 2) if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 29912 | 0)) {
   HEAP32[i5 >> 2] = 0;
   break;
  }
  if (i4 & (i3 | 0) == 0) {
   i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
   if ((i4 | 0) != (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 384586 | 0, 0, gb + 384652 | 0, 81, 1, HEAP32[i6 + 16 >> 2] | 0, 0, 0);
    HEAP32[i5 >> 2] = 0;
   }
  }
 } while (0);
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 3 ? 3 : i2;
 i1 = i6 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 7)) i8 = 22; else {
  i5 = i2 - (i2 >>> 1 & 1431655765) | 0;
  i5 = (i5 >>> 2 & 858993459) + (i5 & 858993459) | 0;
  if (((Math_imul((i5 >>> 4) + i5 & 252645135, 16843009) | 0) & -16777216 | 0) != 16777216) i8 = 22;
 }
 if ((i8 | 0) == 22) HEAP32[i1 >> 2] = 4;
 i8 = i6 + 48 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i5 = Math_fround(HEAPF32[i8 >> 2]) < Math_fround(0.0);
 i5 = HEAP32[(i5 ? i7 : i8) >> 2] | 0;
 HEAP32[i8 >> 2] = i5;
 i8 = i6 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i4 = Math_fround(HEAPF32[i8 >> 2]) < Math_fround(0.0);
 HEAP32[i8 >> 2] = HEAP32[(i4 ? i7 : i8) >> 2];
 i8 = i6 + 56 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i4 = Math_fround(HEAPF32[i8 >> 2]) < Math_fround(0.0);
 HEAP32[i8 >> 2] = HEAP32[(i4 ? i7 : i8) >> 2];
 i8 = i6 + 60 | 0;
 HEAPF32[i7 >> 2] = Math_fround(179.0);
 i4 = Math_fround(HEAPF32[i8 >> 2]) > Math_fround(179.0);
 i4 = HEAP32[(i4 ? i7 : i8) >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i4 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(1.0);
 HEAP32[i8 >> 2] = HEAP32[(i4 ? i7 : i8) >> 2];
 i8 = i6 + 64 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i4 = Math_fround(HEAPF32[i8 >> 2]) < Math_fround(0.0);
 HEAP32[i8 >> 2] = HEAP32[(i4 ? i7 : i8) >> 2];
 i8 = i6 + 112 | 0;
 f11 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f11 < Math_fround(0.0);
 i4 = f11 > Math_fround(10.0);
 f11 = i4 ? Math_fround(10.0) : f11;
 HEAPF32[i8 >> 2] = i7 ? Math_fround(0.0) : f11;
 i8 = i6 + 116 | 0;
 f11 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f11 < Math_fround(0.0);
 i4 = f11 > Math_fround(3.0);
 f11 = i4 ? Math_fround(3.0) : f11;
 HEAPF32[i8 >> 2] = i7 ? Math_fround(0.0) : f11;
 i8 = i6 + 120 | 0;
 f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.00999999977));
 i7 = f11 > Math_fround(.100000001);
 f11 = i7 ? Math_fround(.100000001) : f11;
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f12 > Math_fround(10.0);
 f10 = i7 ? Math_fround(10.0) : f12;
 HEAPF32[i8 >> 2] = f12 < f11 ? f11 : f10;
 i8 = i6 + 108 | 0;
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f10 < Math_fround(0.0);
 i6 = f10 > Math_fround(1.0);
 f10 = i6 ? Math_fround(1.0) : f10;
 HEAPF32[i8 >> 2] = i7 ? Math_fround(0.0) : f10;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 16 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5Unity5Cloth13UpdateNormalsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i13 = i11 + 308 | 0;
 i14 = i11 + 240 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i11 + 320 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i11 + 324 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 * 12 | 0, 4, i11 + 312 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i11 + 312 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  break;
 } while (0);
 if (!(HEAP32[i14 >> 2] | 0)) i2 = 0; else {
  i1 = 0;
  do {
   i2 = (HEAP32[i13 >> 2] | 0) + (i1 * 12 | 0) | 0;
   HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i14 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i5 = HEAP32[i11 + 280 >> 2] | 0;
 if (i5 | 0) {
  i6 = HEAP32[i11 + 268 >> 2] | 0;
  i3 = HEAP32[i11 + 288 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  i1 = 0;
  do {
   i16 = HEAPU16[i6 + (i1 << 1) >> 1] | 0;
   i15 = HEAPU16[i6 + (i1 + 1 << 1) >> 1] | 0;
   i11 = HEAPU16[i6 + (i1 + 2 << 1) >> 1] | 0;
   f12 = Math_fround(HEAPF32[i3 + (i16 * 12 | 0) >> 2]);
   f7 = Math_fround(HEAPF32[i3 + (i16 * 12 | 0) + 4 >> 2]);
   f10 = Math_fround(HEAPF32[i3 + (i16 * 12 | 0) + 8 >> 2]);
   f18 = Math_fround(Math_fround(HEAPF32[i3 + (i15 * 12 | 0) >> 2]) - f12);
   f8 = Math_fround(Math_fround(HEAPF32[i3 + (i15 * 12 | 0) + 4 >> 2]) - f7);
   f19 = Math_fround(Math_fround(HEAPF32[i3 + (i15 * 12 | 0) + 8 >> 2]) - f10);
   f12 = Math_fround(Math_fround(HEAPF32[i3 + (i11 * 12 | 0) >> 2]) - f12);
   f7 = Math_fround(Math_fround(HEAPF32[i3 + (i11 * 12 | 0) + 4 >> 2]) - f7);
   f10 = Math_fround(Math_fround(HEAPF32[i3 + (i11 * 12 | 0) + 8 >> 2]) - f10);
   f9 = Math_fround(Math_fround(f8 * f10) - Math_fround(f19 * f7));
   f10 = Math_fround(Math_fround(f19 * f12) - Math_fround(f18 * f10));
   f12 = Math_fround(Math_fround(f18 * f7) - Math_fround(f8 * f12));
   i17 = i4 + (i16 * 12 | 0) | 0;
   HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f9);
   i17 = i4 + (i16 * 12 | 0) + 4 | 0;
   HEAPF32[i17 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i17 >> 2]));
   i16 = i4 + (i16 * 12 | 0) + 8 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i16 >> 2]));
   i16 = i4 + (i15 * 12 | 0) | 0;
   HEAPF32[i16 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i16 >> 2]));
   i16 = i4 + (i15 * 12 | 0) + 4 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i16 >> 2]));
   i15 = i4 + (i15 * 12 | 0) + 8 | 0;
   HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i15 >> 2]));
   i15 = i4 + (i11 * 12 | 0) | 0;
   HEAPF32[i15 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i15 >> 2]));
   i15 = i4 + (i11 * 12 | 0) + 4 | 0;
   HEAPF32[i15 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i15 >> 2]));
   i11 = i4 + (i11 * 12 | 0) + 8 | 0;
   HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i11 >> 2]));
   i1 = i1 + 3 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 }
 if (!i2) return;
 f12 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i4 = 0;
 do {
  i11 = HEAP32[i13 >> 2] | 0;
  i5 = i11 + (i4 * 12 | 0) | 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  f10 = Math_fround(f7 * f7);
  i6 = i11 + (i4 * 12 | 0) + 4 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f8 * f8));
  i11 = i11 + (i4 * 12 | 0) + 8 | 0;
  f9 = Math_fround(HEAPF32[i11 >> 2]);
  f10 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9))));
  if (f10 > f12) {
   f19 = Math_fround(f7 / f10);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   f19 = Math_fround(f8 / f10);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   f19 = Math_fround(f9 / f10);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = HEAP32[gb + 1162364 >> 2] | 0;
   i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i11 >> 2] = i3;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector3Ei(i41, i1, i30, i36) {
 i41 = i41 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 i36 = i36 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, i42 = 0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, d48 = 0.0;
 i42 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i42 + 32 | 0;
 i23 = i42 + 28 | 0;
 i19 = i42 + 24 | 0;
 i16 = i42 + 20 | 0;
 i22 = i42 + 16 | 0;
 i18 = i42 + 12 | 0;
 i15 = i42 + 8 | 0;
 i21 = i42 + 4 | 0;
 i20 = i42;
 HEAP32[i17 >> 2] = 2139095039;
 HEAP32[i23 >> 2] = 2139095039;
 HEAP32[i19 >> 2] = 2139095039;
 HEAP32[i16 >> 2] = -8388609;
 HEAP32[i22 >> 2] = -8388609;
 HEAP32[i18 >> 2] = -8388609;
 if ((i36 | 0) <= 0) {
  i22 = -8388609;
  i30 = 2139095039;
  i36 = -8388609;
  i21 = 2139095039;
  i23 = -8388609;
  i20 = 2139095039;
  HEAP32[i41 >> 2] = i30;
  i30 = i41 + 4 | 0;
  HEAP32[i30 >> 2] = i20;
  i30 = i41 + 8 | 0;
  HEAP32[i30 >> 2] = i21;
  i30 = i41 + 12 | 0;
  HEAP32[i30 >> 2] = i22;
  i30 = i41 + 16 | 0;
  HEAP32[i30 >> 2] = i23;
  i41 = i41 + 20 | 0;
  HEAP32[i41 >> 2] = i36;
  STACKTOP = i42;
  return;
 }
 f39 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f40 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f27 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f29 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f31 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f32 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f33 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f34 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f35 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f37 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f38 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 i7 = 0;
 f8 = Math_fround(-3402823469999999843913219.0e14);
 f9 = Math_fround(3402823469999999843913219.0e14);
 f10 = Math_fround(-3402823469999999843913219.0e14);
 f11 = Math_fround(3402823469999999843913219.0e14);
 f12 = Math_fround(-3402823469999999843913219.0e14);
 f13 = Math_fround(3402823469999999843913219.0e14);
 do {
  f47 = Math_fround(HEAPF32[i30 + (i7 * 12 | 0) >> 2]);
  f45 = Math_fround(f47 * f39);
  f46 = Math_fround(HEAPF32[i30 + (i7 * 12 | 0) + 4 >> 2]);
  f45 = Math_fround(f45 + Math_fround(f46 * f40));
  f43 = Math_fround(HEAPF32[i30 + (i7 * 12 | 0) + 8 >> 2]);
  d48 = 1.0 / +Math_fround(f25 + Math_fround(f45 + Math_fround(f43 * f24)));
  f45 = Math_fround(d48 * +Math_fround(f29 + Math_fround(Math_fround(Math_fround(f47 * f26) + Math_fround(f46 * f27)) + Math_fround(f43 * f28))));
  f44 = Math_fround(d48 * +Math_fround(f34 + Math_fround(Math_fround(Math_fround(f47 * f31) + Math_fround(f46 * f32)) + Math_fround(f43 * f33))));
  f43 = Math_fround(d48 * +Math_fround(f14 + Math_fround(Math_fround(Math_fround(f47 * f35) + Math_fround(f46 * f37)) + Math_fround(f43 * f38))));
  HEAPF32[i15 >> 2] = f45;
  HEAPF32[i21 >> 2] = f44;
  HEAPF32[i20 >> 2] = f43;
  i5 = HEAP32[(f45 <= f9 ? i15 : i17) >> 2] | 0;
  i1 = HEAP32[(f44 <= f13 ? i21 : i23) >> 2] | 0;
  i3 = HEAP32[(f43 <= f11 ? i20 : i19) >> 2] | 0;
  HEAP32[i17 >> 2] = i5;
  HEAP32[i23 >> 2] = i1;
  HEAP32[i19 >> 2] = i3;
  i6 = HEAP32[(f45 >= f8 ? i15 : i16) >> 2] | 0;
  i2 = HEAP32[(f44 >= f12 ? i21 : i22) >> 2] | 0;
  i4 = HEAP32[(f43 >= f10 ? i20 : i18) >> 2] | 0;
  HEAP32[i16 >> 2] = i6;
  HEAP32[i22 >> 2] = i2;
  HEAP32[i18 >> 2] = i4;
  i7 = i7 + 1 | 0;
  f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i7 | 0) != (i36 | 0));
 HEAP32[i41 >> 2] = i5;
 i36 = i41 + 4 | 0;
 HEAP32[i36 >> 2] = i1;
 i36 = i41 + 8 | 0;
 HEAP32[i36 >> 2] = i3;
 i36 = i41 + 12 | 0;
 HEAP32[i36 >> 2] = i6;
 i36 = i41 + 16 | 0;
 HEAP32[i36 >> 2] = i2;
 i41 = i41 + 20 | 0;
 HEAP32[i41 >> 2] = i4;
 STACKTOP = i42;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_14PxRigidDynamicENS_27PxRigidDynamicGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i2, i6, i4, i8, i7, i1, i3, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i9 + 184 | 0;
 i18 = i9 + 132 | 0;
 i16 = i9 + 80 | 0;
 i10 = i9 + 236 | 0;
 i13 = i9 + 16 | 0;
 i17 = i9;
 i11 = i9 + 28 | 0;
 HEAP8[i10 >> 0] = 0;
 i15 = i6;
 i14 = i4;
 i12 = i8;
 i4 = i7;
 i6 = i1;
 i7 = i3;
 i8 = i10;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i19 >> 2] = i15;
 HEAP32[i19 + 4 >> 2] = i14;
 i3 = i19 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i19 + 20 >> 2] = i12;
 HEAP32[i19 + 24 >> 2] = i4;
 HEAP32[i19 + 28 >> 2] = i6;
 HEAP32[i19 + 32 >> 2] = i7;
 HEAP8[i19 + 36 >> 0] = 1;
 HEAP32[i19 + 40 >> 2] = i8;
 HEAP32[i19 + 44 >> 2] = 0;
 HEAP32[i19 + 48 >> 2] = 0;
 i3 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i5, i19, 0) | 0;
 HEAP32[i18 >> 2] = i15;
 HEAP32[i18 + 4 >> 2] = i14;
 i1 = i18 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i18 + 20 >> 2] = i12;
 HEAP32[i18 + 24 >> 2] = i4;
 HEAP32[i18 + 28 >> 2] = i6;
 HEAP32[i18 + 32 >> 2] = i7;
 HEAP8[i18 + 36 >> 0] = 1;
 HEAP32[i18 + 40 >> 2] = i8;
 HEAP32[i18 + 44 >> 2] = 0;
 HEAP32[i18 + 48 >> 2] = 0;
 i3 = __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i5, i18, i3) | 0;
 HEAP32[i16 >> 2] = i15;
 HEAP32[i16 + 4 >> 2] = i14;
 i2 = i16 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 20 >> 2] = i12;
 HEAP32[i16 + 24 >> 2] = i4;
 HEAP32[i16 + 28 >> 2] = i6;
 HEAP32[i16 + 32 >> 2] = i7;
 HEAP8[i16 + 36 >> 0] = 1;
 HEAP32[i16 + 40 >> 2] = i8;
 HEAP32[i16 + 44 >> 2] = 0;
 HEAP32[i16 + 48 >> 2] = 0;
 __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i5, i16, i3) | 0;
 HEAP32[i11 >> 2] = i15;
 HEAP32[i11 + 4 >> 2] = i14;
 i3 = i11 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i11 + 20 >> 2] = i12;
 HEAP32[i11 + 24 >> 2] = i4;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i7;
 HEAP8[i11 + 36 >> 0] = 1;
 HEAP32[i11 + 40 >> 2] = i8;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj42ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 348 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj43ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 364 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj44ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 380 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj46ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 408 | 0, 5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj47ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 424 | 0, 6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj48ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 440 | 0, 7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i5 + 456 | 0, 8);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj50ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i5 + 480 | 0, 9);
 STACKTOP = i9;
 return (HEAP8[i10 >> 0] | 0) == 0 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessIttEEPtEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -2 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 1;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 62) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 1) | 0;
    if ((i3 | 0) > 1998) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 1) | 0, i8, i8 + (i3 << 1) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP16[i1 >> 1] | 0;
    i5 = HEAP16[i8 >> 1] | 0;
    if ((i7 & 65535) < (i5 & 65535)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -2 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP16[i4 >> 1] | 0;
     if ((i6 & 65535) < (i5 & 65535)) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 2 | 0;
    i5 = HEAP16[i14 >> 1] | 0;
    if ((i7 & 65535) >= (i5 & 65535)) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP16[i3 >> 1] | 0;
      if ((i7 & 65535) < (i4 & 65535)) break;
      i3 = i3 + 2 | 0;
     }
     HEAP16[i3 >> 1] = i5;
     HEAP16[i14 >> 1] = i4;
     i3 = i3 + 2 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP16[i1 >> 1] | 0;
     while (1) {
      i6 = HEAP16[i3 >> 1] | 0;
      i7 = i3 + 2 | 0;
      if ((i8 & 65535) < (i6 & 65535)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -2 | 0;
      i5 = HEAP16[i4 >> 1] | 0;
     } while ((i8 & 65535) < (i5 & 65535));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP16[i3 >> 1] = i5;
     HEAP16[i4 >> 1] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP16[i1 >> 1] = i6;
    HEAP16[i4 >> 1] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 2 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP16[i10 >> 1] | 0;
     while (1) {
      i7 = HEAP16[i5 >> 1] | 0;
      i8 = i5 + 2 | 0;
      if ((i7 & 65535) < (i9 & 65535)) i5 = i8; else break;
     }
     do {
      i4 = i4 + -2 | 0;
      i6 = HEAP16[i4 >> 1] | 0;
     } while ((i6 & 65535) >= (i9 & 65535));
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP16[i5 >> 1] = i6;
     HEAP16[i4 >> 1] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP16[i6 >> 1] | 0;
    i5 = HEAP16[i7 >> 1] | 0;
    if ((i4 & 65535) < (i5 & 65535)) {
     HEAP16[i7 >> 1] = i4;
     HEAP16[i6 >> 1] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIttEEPtEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 2 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIttEEPtEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIttEEPtEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 2 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIttEEPtEEvT0_S5_T_(i7 + 2 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP16[i14 >> 1] | 0;
  i3 = HEAP16[i1 >> 1] | 0;
  if ((i2 & 65535) < (i3 & 65535)) {
   HEAP16[i1 >> 1] = i2;
   HEAP16[i14 >> 1] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i1, i1 + 2 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_(i1, i1 + 2 | 0, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_(i1, i1 + 2 | 0, i1 + 4 | 0, i1 + 6 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIttEEPtEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags(i26, i27, i1) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25 + 56 | 0;
 i20 = i25 + 44 | 0;
 i21 = i25 + 40 | 0;
 i22 = i25 + 20 | 0;
 i23 = i25;
 i24 = i26 + 16 | 0;
 i2 = HEAP32[i24 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i18 = i26 + 24 | 0;
 if (i1 >>> 0 > (HEAP32[i18 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i24, i21, 4); else {
  HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i24 >> 2] = i1;
 };
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 HEAP32[i22 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i22 + 4 >> 2] = 0;
 HEAP32[i22 + 8 >> 2] = 0;
 i6 = i22 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i17 = i27 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i27, HEAP32[i17 >> 2] | 0);
 i7 = i27 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i27 >> 2] = i17;
 HEAP32[i17 >> 2] = 0;
 if ((HEAP32[i21 >> 2] | 0) <= 0) {
  STACKTOP = i25;
  return;
 }
 i8 = i22 + 11 | 0;
 i9 = i22 + 4 | 0;
 i10 = i23 + 12 | 0;
 i5 = i23 + 12 | 0;
 i11 = i19 + 4 | 0;
 i12 = i23 + 8 | 0;
 i13 = i23 + 4 | 0;
 i14 = i23 + 16 | 0;
 i15 = i27 + 4 | 0;
 i16 = i23 + 11 | 0;
 i17 = i19 + 4 | 0;
 i4 = 0;
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i26, i22, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i26);
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i18 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i24, i6, 4); else {
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i24 >> 2] = i2;
  }
  i3 = HEAP8[i8 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i22 >> 2] | 0 : i22;
  i3 = i1 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 4 >> 2] = 0;
  HEAP32[i23 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 >> 2] = i1;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i23);
   i1 = HEAP32[i5 >> 2] | 0;
   i28 = 15;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i16 >> 0] = i3;
   if (!i3) i1 = i23; else {
    i1 = i23;
    i28 = 17;
   }
  } else i28 = 15;
  if ((i28 | 0) == 15) {
   i29 = i3 + 16 & -16;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i11 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i29, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i23 >> 2] = i1;
   HEAP32[i12 >> 2] = i29 | -2147483648;
   HEAP32[i13 >> 2] = i3;
   i28 = 17;
  }
  if ((i28 | 0) == 17) {
   i28 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
  i2 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i27, i19, i23) | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i20, i27, i23);
   i1 = HEAP32[i20 >> 2] | 0;
   HEAP32[i20 >> 2] = 0;
   i3 = HEAP32[i19 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i27 >> 2] = i3;
    i1 = HEAP32[i2 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 >> 2] | 0, i1);
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  }
  if ((HEAP8[i16 >> 0] | 0) < 0) {
   i29 = HEAP32[i23 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i17 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i29, i19);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (HEAP32[i21 >> 2] | 0));
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i25;
  return;
 }
 i29 = HEAP32[i22 >> 2] | 0;
 i28 = HEAP32[i22 + 12 >> 2] | 0;
 HEAP32[i19 >> 2] = 66;
 HEAP32[i19 + 4 >> 2] = i28;
 __Z19free_alloc_internalPvRK10MemLabelId(i29, i19);
 STACKTOP = i25;
 return;
}

function __ZN4Mesh15SetSubMeshCountEjb(i11, i12, i7) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 56 | 0;
 i6 = i13;
 i8 = i11 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i9 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i8 >> 2] | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i8 >> 2] = i1;
  i9 = i1;
 }
 if (!i12) {
  i1 = HEAP32[i9 + 112 >> 2] | 0;
  i2 = i9 + 116 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  i3 = HEAP32[i9 + 128 >> 2] | 0;
  i1 = i9 + 132 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   STACKTOP = i13;
   return;
  }
  HEAP32[i1 >> 2] = i2 + (~(((i2 + -52 - i3 | 0) >>> 0) / 52 | 0) * 52 | 0);
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i9 + 128 >> 2] | 0;
 i1 = ((HEAP32[i9 + 132 >> 2] | 0) - i2 | 0) / 52 | 0;
 if (i1 >>> 0 > i12 >>> 0) {
  i4 = i9 + 112 | 0;
  i1 = HEAP32[i2 + (i12 * 52 | 0) + 32 >> 2] | 0;
  i5 = i9 + 116 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i6 - i3 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i4, i1 - i2 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  } else if (i1 >>> 0 < i2 >>> 0) {
   i1 = i3 + i1 | 0;
   if ((i6 | 0) == (i1 | 0)) i1 = i9; else {
    HEAP32[i5 >> 2] = i1;
    i1 = i9;
   }
  } else i1 = i9;
  i3 = i1 + 128 | 0;
  i4 = i1 + 132 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = (i5 - i1 | 0) / 52 | 0;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj(i3, i12 - i2 | 0);
   STACKTOP = i13;
   return;
  }
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i13;
   return;
  }
  i1 = i1 + (i12 * 52 | 0) | 0;
  if ((i5 | 0) == (i1 | 0)) {
   STACKTOP = i13;
   return;
  }
  HEAP32[i4 >> 2] = i5 + (~(((i5 + -52 - i1 | 0) >>> 0) / 52 | 0) * 52 | 0);
  STACKTOP = i13;
  return;
 } else {
  if (i1 >>> 0 >= i12 >>> 0) {
   STACKTOP = i13;
   return;
  }
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i3 = i6 + 8 | 0;
  HEAP32[i6 + 32 >> 2] = (HEAP32[i9 + 116 >> 2] | 0) - (HEAP32[i9 + 112 >> 2] | 0);
  i4 = i6 + 36 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i4 = i10 + 12 | 0;
  HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  i3 = i9 + 128 | 0;
  i4 = i9 + 132 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (i5 - i2 | 0) / 52 | 0;
  if (i1 >>> 0 < i12 >>> 0) __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEjRKS1_(i3, i12 - i1 | 0, i6); else if (i1 >>> 0 > i12 >>> 0) {
   i1 = i2 + (i12 * 52 | 0) | 0;
   if ((i5 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -52 - i1 | 0) >>> 0) / 52 | 0) * 52 | 0);
  }
  if (i7) {
   __ZN4Mesh25RecalculateBoundsInternalEv(i11);
   HEAP32[i10 >> 2] = gb + 30832;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = HEAP32[i11 + 236 >> 2] | 0;
   i3 = i11 + 232 | 0;
   i2 = i1;
   if ((i2 | 0) != (i3 | 0)) do {
    i12 = i1;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i12 + 8 >> 2] | 0, gb + 1105176 | 0, i10);
    i2 = i1;
   } while ((i2 | 0) != (i3 | 0));
   i3 = i11 + 240 | 0;
   i1 = HEAP32[i11 + 244 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) != (i3 | 0)) do {
    i12 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i3 | 0));
  }
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 48 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN25b2CapsuleAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i16, i17, i18) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i20 + 152 | 0;
 i19 = i20;
 i5 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i6 = (HEAP32[i5 + 176 >> 2] | 0) == 0;
 f3 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f2 = Math_fround(f3 * f8);
 f7 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f7 * f4));
 f2 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f2);
 f4 = Math_fround(Math_fround(f8 * f7) + Math_fround(f3 * f4));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i18 + 4 >> 2]));
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i17 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i17 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f7 = Math_fround(f2 * f3);
 f8 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f4 * f8));
 f8 = Math_fround(Math_fround(f3 * f4) - Math_fround(f2 * f8));
 i14 = i5 + 12 | 0;
 i15 = i5 + 20 | 0;
 f2 = Math_fround(HEAPF32[i14 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i15 >> 2]));
 f4 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i15 + 4 >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4))));
 if (f3 < Math_fround(1.1920929e-07)) {
  f12 = f2;
  f10 = f4;
 } else {
  f10 = Math_fround(Math_fround(1.0) / f3);
  f12 = Math_fround(f2 * f10);
  f10 = Math_fround(f4 * f10);
 }
 HEAP32[i11 >> 2] = gb + 151824 + 8;
 i1 = i11 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i5 = i5 + 8 | 0;
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 >> 2];
 i1 = i11 + 12 | 0;
 i22 = i14;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i9 + 4 >> 2] = i21;
 __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i16, i11, i17, i13, i18);
 i9 = i16 + 60 | 0;
 do if ((HEAP32[i9 >> 2] | 0) > 0) {
  if (i6) {
   STACKTOP = i20;
   return;
  }
  f3 = Math_fround(f7 - Math_fround(HEAPF32[i1 >> 2]));
  f2 = Math_fround(f8 - Math_fround(HEAPF32[i11 + 16 >> 2]));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
  if (!(f4 < Math_fround(1.1920929e-07))) {
   f4 = Math_fround(Math_fround(1.0) / f4);
   f3 = Math_fround(f3 * f4);
   f2 = Math_fround(f2 * f4);
  }
  if (!(Math_fround(Math_fround(f12 * f3) + Math_fround(f10 * f2)) >= Math_fround(0.0))) {
   HEAP32[i9 >> 2] = 0;
   break;
  } else {
   STACKTOP = i20;
   return;
  }
 } while (0);
 if (i6) {
  STACKTOP = i20;
  return;
 }
 i6 = i15;
 i21 = HEAP32[i6 + 4 >> 2] | 0;
 i22 = i1;
 HEAP32[i22 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i22 + 4 >> 2] = i21;
 __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i16, i11, i17, i13, i18);
 do if ((HEAP32[i9 >> 2] | 0) > 0) {
  f3 = Math_fround(f7 - Math_fround(HEAPF32[i1 >> 2]));
  f2 = Math_fround(f8 - Math_fround(HEAPF32[i11 + 16 >> 2]));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
  if (!(f4 < Math_fround(1.1920929e-07))) {
   f8 = Math_fround(Math_fround(1.0) / f4);
   f3 = Math_fround(f3 * f8);
   f2 = Math_fround(f2 * f8);
  }
  if (!(Math_fround(Math_fround(-Math_fround(f10 * f2)) - Math_fround(f12 * f3)) >= Math_fround(0.0))) {
   HEAP32[i9 >> 2] = 0;
   break;
  } else {
   STACKTOP = i20;
   return;
  }
 } while (0);
 HEAP32[i19 >> 2] = gb + 151728 + 8;
 HEAP32[i19 + 4 >> 2] = 2;
 i22 = i19 + 8 | 0;
 HEAP32[i22 >> 2] = HEAP32[gb + 151644 >> 2];
 HEAP32[i19 + 148 >> 2] = 0;
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i22 >> 2] = HEAP32[i5 >> 2];
 __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i19, i14, i15);
 __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i16, i19, i17, i13, i18, 0);
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i16 + 40 >> 2]));
  f12 = Math_fround(Math_fround(f12 * Math_fround(HEAPF32[i16 + 44 >> 2])) - f10);
  if (!(f12 >= Math_fround(.99999988) | f12 <= Math_fround(-.99999988))) HEAP32[i9 >> 2] = 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEvent12ToJsonStringER9JSONWrite(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i3, i4);
 i2 = i3 + 476 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 480 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) {
  __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1040160 | 0, 0);
  __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i4, i3 + 492 | 0, gb + 1040166 | 0, 0);
  return;
 }
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 32 | 0, gb + 1040179 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 48 | 0, gb + 1041407 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 64 | 0, gb + 1041396 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i4, i3 + 80 | 0, gb + 1040186 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i4, i3 + 81 | 0, gb + 1040204 | 0, 0);
 i2 = i3 + 88 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 92 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1040216 | 0, 0);
 i2 = i3 + 104 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 108 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1040231 | 0, 0);
 i1 = i3 + 120 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i3 + 124 >> 2] | 0)) __ZN9JSONWrite8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1040247 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 84 | 0, gb + 1040258 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 132 | 0, gb + 1040275 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 148 | 0, gb + 1040280 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 164 | 0, gb + 1040286 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 180 | 0, gb + 1040290 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 184 | 0, gb + 1040300 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 188 | 0, gb + 1040309 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 192 | 0, gb + 1040313 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 196 | 0, gb + 1040318 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 212 | 0, gb + 1040325 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 216 | 0, gb + 1040667 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 220 | 0, gb + 1040329 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 236 | 0, gb + 1040334 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 240 | 0, gb + 1040342 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 244 | 0, gb + 1040766 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 280 | 0, gb + 1040348 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 296 | 0, gb + 1040357 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 312 | 0, gb + 1040374 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 328 | 0, gb + 1040392 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 360 | 0, gb + 1040406 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 392 | 0, gb + 1040419 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 408 | 0, gb + 1040428 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 424 | 0, gb + 1040439 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i3 + 440 | 0, gb + 1040447 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 456 | 0, gb + 1040458 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 460 | 0, gb + 1040469 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 464 | 0, gb + 1040477 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 468 | 0, gb + 1040485 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i3 + 472 | 0, gb + 1040492 | 0, 0);
 return;
}

function __ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB(i2, i25, i26, i30) {
 i2 = i2 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i30 = i30 | 0;
 var f1 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, i38 = 0, i39 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31 + 24 | 0;
 i28 = i31;
 i2 = i2 + 356 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i30 = 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 if (!(__ZN4Mesh17VerifyBoneIndicesEj(i3, i26) | 0)) {
  i30 = 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 i19 = __ZN4Mesh20GetCachedBonesBoundsEv(HEAP32[i2 >> 2] | 0) | 0;
 if ((HEAP32[i19 + 12 >> 2] | 0) >>> 0 < i26 >>> 0) {
  i30 = 0;
  STACKTOP = i31;
  return i30 | 0;
 }
 f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f1 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f6 = Math_fround(-f8);
 f5 = Math_fround(-f1);
 f4 = Math_fround(-f7);
 L10 : do if (i26) {
  i16 = i28 + 4 | 0;
  i18 = i28 + 8 | 0;
  i14 = i28 + 12 | 0;
  i15 = i28 + 16 | 0;
  i17 = i28 + 20 | 0;
  i20 = i27 + 12 | 0;
  i21 = i27 + 4 | 0;
  i22 = i27 + 16 | 0;
  i23 = i27 + 8 | 0;
  i24 = i27 + 20 | 0;
  i2 = 0;
  f13 = f8;
  while (1) {
   i3 = HEAP32[i19 >> 2] | 0;
   i11 = i3 + (i2 * 24 | 0) | 0;
   f12 = Math_fround(HEAPF32[i11 >> 2]);
   if (f12 == f8) {
    f10 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 4 >> 2]);
    if (f10 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
     f10 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 8 >> 2]);
     if (f10 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) f8 = f13; else i29 = 10;
    } else i29 = 10;
   } else i29 = 10;
   do if ((i29 | 0) == 10) {
    i29 = 0;
    f8 = Math_fround(-f8);
    f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
    f10 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 12 >> 2]);
    if (f10 == f8) {
     f32 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
     f8 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 16 >> 2]);
     if (f8 == f32) if (!(Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 20 >> 2]) != f9)) {
      f8 = f13;
      break;
     }
    } else f8 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 16 >> 2]);
    f33 = Math_fround(f12 + f10);
    i39 = i3 + (i2 * 24 | 0) + 4 | 0;
    f12 = Math_fround(Math_fround(HEAPF32[i39 >> 2]) + f8);
    i38 = i3 + (i2 * 24 | 0) + 8 | 0;
    f37 = Math_fround(HEAPF32[i38 >> 2]);
    f34 = Math_fround(HEAPF32[i3 + (i2 * 24 | 0) + 20 >> 2]);
    f12 = Math_fround(f12 * Math_fround(.5));
    f37 = Math_fround(Math_fround(f37 + f34) * Math_fround(.5));
    HEAPF32[i28 >> 2] = Math_fround(f33 * Math_fround(.5));
    HEAPF32[i16 >> 2] = f12;
    HEAPF32[i18 >> 2] = f37;
    f37 = Math_fround(f10 - Math_fround(HEAPF32[i11 >> 2]));
    f12 = Math_fround(f8 - Math_fround(HEAPF32[i39 >> 2]));
    f12 = Math_fround(f12 * Math_fround(.5));
    f34 = Math_fround(Math_fround(f34 - Math_fround(HEAPF32[i38 >> 2])) * Math_fround(.5));
    HEAPF32[i14 >> 2] = Math_fround(f37 * Math_fround(.5));
    HEAPF32[i15 >> 2] = f12;
    HEAPF32[i17 >> 2] = f34;
    __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i28, i25 + (i2 << 6) | 0, i27);
    f34 = Math_fround(HEAPF32[i27 >> 2]);
    f12 = Math_fround(HEAPF32[i20 >> 2]);
    f37 = Math_fround(f34 - f12);
    f33 = Math_fround(HEAPF32[i21 >> 2]);
    f32 = Math_fround(HEAPF32[i22 >> 2]);
    f36 = Math_fround(f33 - f32);
    f9 = Math_fround(HEAPF32[i23 >> 2]);
    f10 = Math_fround(HEAPF32[i24 >> 2]);
    f35 = Math_fround(f9 - f10);
    f8 = f37 < f13 ? f37 : f13;
    f1 = f36 < f1 ? f36 : f1;
    f7 = f35 < f7 ? f35 : f7;
    f6 = f6 < f37 ? f37 : f6;
    f5 = f5 < f36 ? f36 : f5;
    f4 = f4 < f35 ? f35 : f4;
    f12 = Math_fround(f34 + f12);
    f32 = Math_fround(f33 + f32);
    f13 = Math_fround(f9 + f10);
    f8 = f12 < f8 ? f12 : f8;
    f7 = f13 < f7 ? f13 : f7;
    f6 = f6 < f12 ? f12 : f6;
    f5 = f5 < f32 ? f32 : f5;
    f4 = f4 < f13 ? f13 : f4;
    f1 = f32 < f1 ? f32 : f1;
   } while (0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i26 | 0)) break L10;
   f13 = f8;
   f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
  }
 } while (0);
 HEAPF32[i30 >> 2] = f8;
 HEAPF32[i30 + 4 >> 2] = f1;
 HEAPF32[i30 + 8 >> 2] = f7;
 HEAPF32[i30 + 12 >> 2] = f6;
 HEAPF32[i30 + 16 >> 2] = f5;
 HEAPF32[i30 + 20 >> 2] = f4;
 i39 = 1;
 STACKTOP = i31;
 return i39 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i14 + 12 | 0;
 i6 = i14 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i15, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i8 = i15 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i15 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i5 = i15 + 4 | 0;
    i3 = 0;
    while (1) {
     i7 = (Math_imul(i3, i9) | 0) + i6 | 0;
     HEAP32[i2 + 20 >> 2] = i7;
     HEAP32[i2 + 12 >> 2] = i7;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i7 = i13;
     i11 = HEAP32[i7 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i5 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      HEAP32[i2 + 8 >> 2] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     i4 = i2 + i3 | 0;
     i2 = i4;
     i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903047 | 0, i13, 1) | 0;
     if (i3 | 0) {
      if ((i3 | 0) > 0) __ZN7mecanim12statemachine26SelectorTransitionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i15);
     }
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i15);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i15);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i5 = i15 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i5 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       HEAP32[i2 + 8 >> 2] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      i4 = i2 + i3 | 0;
      i2 = i4;
      i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i15, gb + 1041891 | 0, gb + 903047 | 0, i13, 1) | 0;
      if (i3 | 0) {
       if ((i3 | 0) > 0) __ZN7mecanim12statemachine26SelectorTransitionConstant8TransferI14SafeBinaryReadEEvRT_(i2, i15); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i15 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i15);
      }
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i15 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i15);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i15);
 STACKTOP = i14;
 return;
}

function __ZN5Unity12PhysicsQuery11CapsuleTestE8Vector3fS1_fi23QueryTriggerInteraction(i1, i2, i3, f4, i19, i20) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 96 | 0;
 i14 = i21 + 60 | 0;
 i15 = i21 + 48 | 0;
 i16 = i21 + 20 | 0;
 i17 = i21;
 if ((HEAP16[gb + 1452620 + 6 >> 1] | 0) > -1) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452620 | 0, i13);
  i18 = gb + 1452620 | 0;
 } else i18 = 0;
 HEAP32[i15 >> 2] = 2;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i15 + 4 >> 2] = f4;
 f22 = Math_fround(f10 - f9);
 f24 = Math_fround(f11 - f7);
 f8 = Math_fround(f12 - f6);
 f23 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f24 * f24)) + Math_fround(f8 * f8))));
 HEAPF32[i15 + 8 >> 2] = Math_fround(f23 * Math_fround(.5));
 f10 = Math_fround(Math_fround(f9 + f10) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f7 + f11) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f6 + f12) * Math_fround(.5));
 f6 = Math_fround(f24 * Math_fround(0.0));
 f4 = Math_fround(f8 * Math_fround(0.0));
 f7 = Math_fround(f4 - f6);
 f9 = Math_fround(f22 * Math_fround(0.0));
 f8 = Math_fround(f9 - f8);
 f9 = Math_fround(f24 - f9);
 f4 = Math_fround(f23 + Math_fround(Math_fround(f22 + f6) + f4));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 if (f4 < Math_fround(.0000999999974)) {
  i2 = -2147483648;
  i5 = 1065353216;
  i3 = 0;
  i1 = 0;
 } else {
  i5 = i3;
  i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f4 * f4);
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(f6 * f6));
 f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(f7 * f7));
 f8 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f8 * f8))));
 if (f9 != Math_fround(0.0)) {
  f24 = Math_fround(Math_fround(1.0) / f9);
  f23 = Math_fround(f4 * f24);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f23 = Math_fround(f6 * f24);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f23 = Math_fround(f7 * f24);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  f24 = Math_fround(f8 * f24);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP32[i16 >> 2] = i2;
 HEAP32[i16 + 4 >> 2] = i1;
 HEAP32[i16 + 8 >> 2] = i5;
 HEAP32[i16 + 12 >> 2] = i3;
 HEAPF32[i16 + 16 >> 2] = f10;
 HEAPF32[i16 + 20 >> 2] = f11;
 HEAPF32[i16 + 24 >> 2] = f12;
 HEAP32[i17 >> 2] = gb + 114012 + 8;
 HEAP32[i17 + 4 >> 2] = 2;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = i19;
 switch (i20 | 0) {
 case 0:
  {
   HEAP8[i17 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i17 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i17 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i20 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP16[i13 + 16 >> 1] = 55;
 HEAP8[i13 + 18 >> 0] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = -1;
 i1 = i14 + 20 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP32[i14 + 32 >> 2] = 0;
 HEAP32[i14 >> 2] = gb + 85608 + 8;
 mftCall_iiiiiii(HEAP32[(HEAP32[i20 >> 2] | 0) + 356 >> 2] | 0, i20 | 0, i15 | 0, i16 | 0, i14 | 0, i13 | 0, i17 | 0) | 0;
 i1 = (HEAP8[i1 >> 0] | 0) != 0;
 if (!i18) {
  STACKTOP = i21;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i21;
 return i1 | 0;
}

function __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i7, i9, i3, i5, i19, i16, i18, i14, f2, i4) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 96 | 0;
 i17 = i24 + 80 | 0;
 i1 = i24 + 64 | 0;
 i23 = i24 + 136 | 0;
 i15 = i24 + 48 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 16 | 0;
 i20 = i24;
 i8 = i24 + 156 | 0;
 i10 = i24 + 152 | 0;
 i21 = i24 + 148 | 0;
 i22 = i24 + 124 | 0;
 i6 = i24 + 112 | 0;
 if (!(__ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i7, i9, i3, i5, i19, i1, i17, i11, f2) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) | i4 ^ 1)) {
  f2 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(100.0));
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i1 = i20 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP8[i21 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i7, i9, i15, i12, i13, i17, i20, i8, i10, i21, 0) | 0) {
  case 1:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i22 >> 2] = gb + 84724 + 8;
    HEAP32[i22 + 4 >> 2] = i7;
    HEAP32[i22 + 8 >> 2] = i9;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i7, i9, i22, i8, i10, HEAP8[i21 >> 0] | 0, i12, i13, i17, i20, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break L6;
    } else {
     f27 = Math_fround(HEAPF32[i19 >> 2]);
     f25 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f2 * f2)))));
     f25 = Math_fround(-Math_fround(f25 * f26));
     f2 = Math_fround(-Math_fround(f2 * f26));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f27 * f26));
     HEAPF32[i17 + 4 >> 2] = f25;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   }
  } while (0);
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i23 = f27 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i23 ? f27 : Math_fround(0.0);
  i23 = i16 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 };
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function _UNITY_png_read_IDAT_data(i20, i2, i1) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i21;
 i16 = i20 + 220 | 0;
 i17 = i20 + 232 | 0;
 HEAP32[i17 >> 2] = i2;
 i18 = i20 + 236 | 0;
 HEAP32[i18 >> 2] = 0;
 i1 = (i2 | 0) == 0 ? 0 : i1;
 i12 = i20 + 224 | 0;
 i13 = (i2 | 0) != 0;
 i7 = i20 + 404 | 0;
 i8 = i20 + 372 | 0;
 i9 = i20 + 652 | 0;
 i10 = i20 + 644 | 0;
 i11 = i20 + 648 | 0;
 L1 : do if (i13) {
  i3 = i1;
  L2 : while (1) {
   if (!(HEAP32[i12 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    while (1) {
     if (i1 | 0) break;
     _UNITY_png_crc_finish(i20, 0) | 0;
     i1 = _UNITY_png_read_chunk_header(i20) | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP32[i8 >> 2] | 0) != 1229209940) {
      i19 = 18;
      break L2;
     }
    }
    i2 = HEAP32[i9 >> 2] | 0;
    i2 = i2 >>> 0 > i1 >>> 0 ? i1 : i2;
    i1 = HEAP32[i10 >> 2] | 0;
    if (!i1) i19 = 8; else if ((HEAP32[i11 >> 2] | 0) >>> 0 < i2 >>> 0) {
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     _UNITY_png_free(i20, i1);
     i19 = 8;
    } else i5 = i1;
    if ((i19 | 0) == 8) {
     i19 = 0;
     i1 = _UNITY_png_malloc_base(i20, i2) | 0;
     if (!i1) {
      i19 = 24;
      break;
     }
     HEAP32[i10 >> 2] = i1;
     HEAP32[i11 >> 2] = i2;
     i5 = i1;
    }
    _UNITY_png_read_data(i20, i5, i2);
    _UNITY_png_calculate_crc(i20, i5, i2);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i2;
    HEAP32[i16 >> 2] = i5;
    HEAP32[i12 >> 2] = i2;
   }
   HEAP32[i18 >> 2] = i3;
   i1 = _unity_z_inflate(i16, 4096) | 0;
   i3 = HEAP32[i18 >> 2] | 0;
   HEAP32[i18 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i14 = i3;
     break L1;
    }
   case 0:
    break;
   default:
    {
     i15 = i1;
     i19 = 30;
     break L1;
    }
   }
   if (!i3) {
    i19 = 38;
    break;
   }
  }
  if ((i19 | 0) == 18) _UNITY_png_error(i20, gb + 353562 | 0); else if ((i19 | 0) == 24) _UNITY_png_chunk_error(i20, gb + 353584 | 0); else if ((i19 | 0) == 38) {
   STACKTOP = i21;
   return;
  }
 } else {
  i3 = i1;
  L23 : while (1) {
   if (!(HEAP32[i12 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    while (1) {
     if (i1 | 0) break;
     _UNITY_png_crc_finish(i20, 0) | 0;
     i1 = _UNITY_png_read_chunk_header(i20) | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP32[i8 >> 2] | 0) != 1229209940) {
      i19 = 18;
      break L23;
     }
    }
    i2 = HEAP32[i9 >> 2] | 0;
    i2 = i2 >>> 0 > i1 >>> 0 ? i1 : i2;
    i1 = HEAP32[i10 >> 2] | 0;
    if (!i1) i19 = 22; else if ((HEAP32[i11 >> 2] | 0) >>> 0 < i2 >>> 0) {
     HEAP32[i10 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     _UNITY_png_free(i20, i1);
     i19 = 22;
    } else i4 = i1;
    if ((i19 | 0) == 22) {
     i19 = 0;
     i1 = _UNITY_png_malloc_base(i20, i2) | 0;
     if (!i1) {
      i19 = 24;
      break;
     }
     HEAP32[i10 >> 2] = i1;
     HEAP32[i11 >> 2] = i2;
     i4 = i1;
    }
    _UNITY_png_read_data(i20, i4, i2);
    _UNITY_png_calculate_crc(i20, i4, i2);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i2;
    HEAP32[i16 >> 2] = i4;
    HEAP32[i12 >> 2] = i2;
   }
   HEAP32[i17 >> 2] = i6;
   HEAP32[i18 >> 2] = 1024;
   i1 = _unity_z_inflate(i16, 4096) | 0;
   i3 = 1024 - (HEAP32[i18 >> 2] | 0) + i3 | 0;
   HEAP32[i18 >> 2] = 0;
   switch (i1 | 0) {
   case 1:
    {
     i14 = i3;
     break L1;
    }
   case 0:
    break;
   default:
    {
     i15 = i1;
     i19 = 30;
     break L1;
    }
   }
   if (!i3) {
    i19 = 38;
    break;
   }
  }
  if ((i19 | 0) == 18) _UNITY_png_error(i20, gb + 353562 | 0); else if ((i19 | 0) == 24) _UNITY_png_chunk_error(i20, gb + 353584 | 0); else if ((i19 | 0) == 38) {
   STACKTOP = i21;
   return;
  }
 } while (0);
 if ((i19 | 0) == 30) {
  _UNITY_png_zstream_error(i20, i15);
  i1 = HEAP32[i20 + 244 >> 2] | 0;
  if (i13) _UNITY_png_chunk_error(i20, i1);
  _UNITY_png_chunk_benign_error(i20, i1);
  STACKTOP = i21;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 i18 = i20 + 204 | 0;
 HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 8;
 i18 = i20 + 208 | 0;
 HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | 8;
 if (!(HEAP32[i12 >> 2] | 0)) {
  if (HEAP32[i7 >> 2] | 0) i19 = 29;
 } else i19 = 29;
 if ((i19 | 0) == 29) _UNITY_png_chunk_benign_error(i20, gb + 353618 | 0);
 if (!i14) {
  STACKTOP = i21;
  return;
 }
 if (i13) _UNITY_png_error(i20, gb + 353562 | 0);
 _UNITY_png_chunk_benign_error(i20, gb + 353640 | 0);
 STACKTOP = i21;
 return;
}

function __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i7, i9, i3, i5, i19, i16, i18, i14, f2, i4) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 96 | 0;
 i17 = i24 + 80 | 0;
 i1 = i24 + 64 | 0;
 i23 = i24 + 136 | 0;
 i15 = i24 + 48 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 16 | 0;
 i20 = i24;
 i8 = i24 + 156 | 0;
 i10 = i24 + 152 | 0;
 i21 = i24 + 148 | 0;
 i22 = i24 + 124 | 0;
 i6 = i24 + 112 | 0;
 if (!(__ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i7, i9, i3, i5, i19, i1, i17, i11, f2) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) | i4 ^ 1)) {
  f2 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(100.0));
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i1 = i20 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP8[i21 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i7, i9, i15, i12, i13, i17, i20, i8, i10, i21, 0) | 0) {
  case 1:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i22 >> 2] = gb + 84832 + 8;
    HEAP32[i22 + 4 >> 2] = i7;
    HEAP32[i22 + 8 >> 2] = i9;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i7, i9, i22, i8, i10, HEAP8[i21 >> 0] | 0, i12, i13, i17, i20, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break L6;
    } else {
     f27 = Math_fround(HEAPF32[i19 >> 2]);
     f25 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f2 * f2)))));
     f25 = Math_fround(-Math_fround(f25 * f26));
     f2 = Math_fround(-Math_fround(f2 * f26));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f27 * f26));
     HEAPF32[i17 + 4 >> 2] = f25;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   }
  } while (0);
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i23 = f27 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i23 ? f27 : Math_fround(0.0);
  i23 = i16 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 };
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 40 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function runPostSets53() {
 HEAP32[gb + 64920 >> 2] = fb + 294;
 HEAP32[gb + 64924 >> 2] = fb + 295;
 HEAP32[gb + 64928 >> 2] = fb + 296;
 HEAP32[gb + 64932 >> 2] = fb + 297;
 HEAP32[gb + 64936 >> 2] = fb + 5;
 HEAP32[gb + 64940 >> 2] = fb + 677;
 HEAP32[gb + 64944 >> 2] = fb + 678;
 HEAP32[gb + 64948 >> 2] = fb + 679;
 HEAP32[gb + 64952 >> 2] = fb + 5;
 HEAP32[gb + 64956 >> 2] = fb + 6;
 HEAP32[gb + 64960 >> 2] = fb + 7;
 HEAP32[gb + 64964 >> 2] = fb + 298;
 HEAP32[gb + 64968 >> 2] = fb + 2;
 HEAP32[gb + 64972 >> 2] = fb + 299;
 HEAP32[gb + 64976 >> 2] = fb + 3;
 HEAP32[gb + 64980 >> 2] = fb + 300;
 HEAP32[gb + 64984 >> 2] = fb + 680;
 HEAP32[gb + 64988 >> 2] = fb + 301;
 HEAP32[gb + 64992 >> 2] = fb + 10;
 HEAP32[gb + 64996 >> 2] = fb + 11;
 HEAP32[gb + 65e3 >> 2] = fb + 12;
 HEAP32[gb + 65004 >> 2] = fb + 550;
 HEAP32[gb + 65008 >> 2] = fb + 13;
 HEAP32[gb + 65012 >> 2] = fb + 5;
 HEAP32[gb + 65016 >> 2] = fb + 302;
 HEAP32[gb + 65020 >> 2] = fb + 681;
 HEAP32[gb + 65024 >> 2] = fb + 682;
 HEAP32[gb + 65040 >> 2] = fb + 683;
 HEAP32[gb + 65044 >> 2] = fb + 684;
 HEAP32[gb + 65048 >> 2] = fb + 685;
 HEAP32[gb + 65052 >> 2] = fb + 551;
 HEAP32[gb + 65056 >> 2] = fb + 686;
 HEAP32[gb + 65060 >> 2] = fb + 39;
 HEAP32[gb + 65064 >> 2] = fb + 40;
 HEAP32[gb + 65068 >> 2] = fb + 19;
 HEAP32[gb + 65072 >> 2] = fb + 303;
 HEAP32[gb + 65076 >> 2] = fb + 31;
 HEAP32[gb + 65080 >> 2] = fb + 27;
 HEAP32[gb + 65084 >> 2] = fb + 304;
 HEAP32[gb + 65088 >> 2] = fb + 28;
 HEAP32[gb + 65092 >> 2] = fb + 63;
 HEAP32[gb + 65096 >> 2] = fb + 29;
 HEAP32[gb + 65100 >> 2] = fb + 34;
 HEAP32[gb + 65104 >> 2] = fb + 552;
 HEAP32[gb + 65108 >> 2] = fb + 553;
 HEAP32[gb + 65112 >> 2] = fb + 554;
 HEAP32[gb + 65116 >> 2] = fb + 555;
 HEAP32[gb + 65120 >> 2] = fb + 556;
 HEAP32[gb + 65124 >> 2] = fb + 557;
 HEAP32[gb + 65128 >> 2] = fb + 36;
 HEAP32[gb + 65132 >> 2] = fb + 45;
 HEAP32[gb + 65136 >> 2] = fb + 82;
 HEAP32[gb + 65140 >> 2] = fb + 305;
 HEAP32[gb + 65144 >> 2] = (HEAP32[gb + 65144 >> 2] | 0) + (gb + 456575 | 0);
 HEAP32[gb + 65148 >> 2] = (HEAP32[gb + 65148 >> 2] | 0) + (gb + 456582 | 0);
 HEAP32[gb + 65152 >> 2] = (HEAP32[gb + 65152 >> 2] | 0) + (gb + 456593 | 0);
 HEAP32[gb + 65156 >> 2] = (HEAP32[gb + 65156 >> 2] | 0) + (gb + 456605 | 0);
 HEAP32[gb + 65160 >> 2] = (HEAP32[gb + 65160 >> 2] | 0) + (gb + 456611 | 0);
 HEAP32[gb + 65164 >> 2] = (HEAP32[gb + 65164 >> 2] | 0) + (gb + 456627 | 0);
 HEAP32[gb + 65168 >> 2] = (HEAP32[gb + 65168 >> 2] | 0) + (gb + 456633 | 0);
 HEAP32[gb + 65172 >> 2] = (HEAP32[gb + 65172 >> 2] | 0) + (gb + 456638 | 0);
 HEAP32[gb + 65176 >> 2] = (HEAP32[gb + 65176 >> 2] | 0) + (gb + 456653 | 0);
 HEAP32[gb + 65180 >> 2] = (HEAP32[gb + 65180 >> 2] | 0) + (gb + 456662 | 0);
 HEAP32[gb + 65184 >> 2] = (HEAP32[gb + 65184 >> 2] | 0) + (gb + 456672 | 0);
 HEAP32[gb + 65188 >> 2] = (HEAP32[gb + 65188 >> 2] | 0) + (gb + 456627 | 0);
 HEAP32[gb + 65192 >> 2] = (HEAP32[gb + 65192 >> 2] | 0) + (gb + 456633 | 0);
 HEAP32[gb + 65196 >> 2] = (HEAP32[gb + 65196 >> 2] | 0) + (gb + 456690 | 0);
 HEAP32[gb + 65200 >> 2] = (HEAP32[gb + 65200 >> 2] | 0) + (gb + 456704 | 0);
 HEAP32[gb + 65204 >> 2] = (HEAP32[gb + 65204 >> 2] | 0) + (gb + 1019051 | 0);
 HEAP32[gb + 65208 >> 2] = (HEAP32[gb + 65208 >> 2] | 0) + (gb + 456717 | 0);
 HEAP32[gb + 65212 >> 2] = (HEAP32[gb + 65212 >> 2] | 0) + (gb + 582814 | 0);
 HEAP32[gb + 65216 >> 2] = (HEAP32[gb + 65216 >> 2] | 0) + (gb + 456728 | 0);
 HEAP32[gb + 65220 >> 2] = (HEAP32[gb + 65220 >> 2] | 0) + (gb + 456746 | 0);
 HEAP32[gb + 65308 >> 2] = fb + 32;
 HEAP32[gb + 65328 >> 2] = fb + 33;
 HEAP32[gb + 65364 >> 2] = (HEAP32[gb + 65364 >> 2] | 0) + (gb + 456191 | 0);
 HEAP32[gb + 65368 >> 2] = (HEAP32[gb + 65368 >> 2] | 0) + (gb + 456208 | 0);
 HEAP32[gb + 65380 >> 2] = fb + 687;
 HEAP32[gb + 65384 >> 2] = fb + 688;
 HEAP32[gb + 65388 >> 2] = fb + 689;
 HEAP32[gb + 65392 >> 2] = fb + 558;
 HEAP32[gb + 65396 >> 2] = fb + 16;
 HEAP32[gb + 65400 >> 2] = fb + 93;
 HEAP32[gb + 65404 >> 2] = fb + 40;
 HEAP32[gb + 65408 >> 2] = fb + 690;
 HEAP32[gb + 65412 >> 2] = fb + 306;
 HEAP32[gb + 65416 >> 2] = fb + 307;
 HEAP32[gb + 65420 >> 2] = fb + 559;
 HEAP32[gb + 65424 >> 2] = fb + 62;
 HEAP32[gb + 65428 >> 2] = fb + 28;
 HEAP32[gb + 65432 >> 2] = fb + 63;
 HEAP32[gb + 65436 >> 2] = fb + 29;
 HEAP32[gb + 65440 >> 2] = fb + 308;
 HEAP32[gb + 65444 >> 2] = fb + 560;
 HEAP32[gb + 65448 >> 2] = fb + 561;
 HEAP32[gb + 65452 >> 2] = fb + 562;
 HEAP32[gb + 65456 >> 2] = fb + 563;
 HEAP32[gb + 65460 >> 2] = fb + 564;
 HEAP32[gb + 65464 >> 2] = fb + 565;
 HEAP32[gb + 65468 >> 2] = fb + 36;
 runPostSets54();
}

function __ZN18AnimatorController19TransferRuntimeDataI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 i6 = i3 + 28 | 0;
 i8 = i3 + 24 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + 104;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902410 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 132 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905632 | 0, gb + 910060 | 0, i10, 0);
 __ZN7mecanim9animation18ControllerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i1 + 140 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905786 | 0, HEAP32[gb + 37052 >> 2] | 0, i11, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i2, i11, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902427 | 0, i11, i1 + 80 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905722 | 0, i8, 0);
 i12 = i10 + 8 | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i12, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i12 = i1 + 156 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902444 | 0, gb + 902485 | 0, i12, 0);
 __ZN38StateMachineBehaviourVectorDescription8TransferI24GenerateTypeTreeTransferEEvRT_(i12, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902524 | 0, i11, i1 + 192 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 902577 | 0, i8, 0);
 i6 = i10 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902549 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 152 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx5cloth14IterationStateI8Scalar4fE6updateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 if (HEAP8[i6 + 204 >> 0] | 0) {
  i5 = i6 + 48 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  f19 = Math_fround(HEAPF32[i6 >> 2]);
  f9 = Math_fround(f11 * f19);
  f18 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f22 = Math_fround(f11 * f18);
  f17 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f10 = Math_fround(f11 * f17);
  f16 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  f11 = Math_fround(f11 * f16);
  i4 = i6 + 52 | 0;
  f24 = Math_fround(HEAPF32[i4 >> 2]);
  f12 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f23 = Math_fround(f24 * f12);
  f15 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f26 = Math_fround(f24 * f15);
  f14 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  f25 = Math_fround(f24 * f14);
  f13 = Math_fround(HEAPF32[i6 + 28 >> 2]);
  f23 = Math_fround(f9 + f23);
  f26 = Math_fround(f22 + f26);
  f25 = Math_fround(f10 + f25);
  f24 = Math_fround(f11 + Math_fround(f24 * f13));
  i3 = i6 + 56 | 0;
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(HEAPF32[i6 + 32 >> 2]);
  f22 = Math_fround(f11 * f10);
  f9 = Math_fround(HEAPF32[i6 + 36 >> 2]);
  f21 = Math_fround(f11 * f9);
  f8 = Math_fround(HEAPF32[i6 + 40 >> 2]);
  f20 = Math_fround(f11 * f8);
  f7 = Math_fround(HEAPF32[i6 + 44 >> 2]);
  f21 = Math_fround(f26 + f21);
  f20 = Math_fround(f25 + f20);
  f11 = Math_fround(f24 + Math_fround(f11 * f7));
  HEAPF32[i5 >> 2] = Math_fround(f23 + f22);
  HEAPF32[i4 >> 2] = f21;
  HEAPF32[i3 >> 2] = f20;
  HEAPF32[i6 + 60 >> 2] = f11;
  i3 = i6 + 64 | 0;
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f19 = Math_fround(f11 * f19);
  f18 = Math_fround(f11 * f18);
  f17 = Math_fround(f11 * f17);
  f16 = Math_fround(f11 * f16);
  i4 = i6 + 68 | 0;
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f12 = Math_fround(f19 + Math_fround(f11 * f12));
  f15 = Math_fround(f18 + Math_fround(f11 * f15));
  f14 = Math_fround(f17 + Math_fround(f11 * f14));
  f13 = Math_fround(f16 + Math_fround(f11 * f13));
  i5 = i6 + 72 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(f15 + Math_fround(f11 * f9));
  f8 = Math_fround(f14 + Math_fround(f11 * f8));
  f7 = Math_fround(f13 + Math_fround(f11 * f7));
  HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(f11 * f10));
  HEAPF32[i4 >> 2] = f9;
  HEAPF32[i5 >> 2] = f8;
  HEAPF32[i6 + 76 >> 2] = f7;
 }
 i1 = i6 + 176 | 0;
 i2 = i6 + 180 | 0;
 i3 = i6 + 184 | 0;
 i4 = i6 + 188 | 0;
 i5 = 0;
 do {
  f23 = Math_fround(HEAPF32[i6 + (i5 << 4) >> 2]);
  f19 = Math_fround(f23 * Math_fround(HEAPF32[i1 >> 2]));
  f24 = Math_fround(HEAPF32[i6 + (i5 << 4) + 4 >> 2]);
  f20 = Math_fround(f24 * Math_fround(HEAPF32[i2 >> 2]));
  f25 = Math_fround(HEAPF32[i6 + (i5 << 4) + 8 >> 2]);
  f21 = Math_fround(f25 * Math_fround(HEAPF32[i3 >> 2]));
  f26 = Math_fround(HEAPF32[i6 + (i5 << 4) + 12 >> 2]);
  f22 = Math_fround(f26 * Math_fround(HEAPF32[i4 >> 2]));
  i27 = i6 + 80 + (i5 << 4) | 0;
  f19 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f19);
  i28 = i6 + 80 + (i5 << 4) + 4 | 0;
  f20 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f20);
  i29 = i6 + 80 + (i5 << 4) + 8 | 0;
  f21 = Math_fround(Math_fround(HEAPF32[i29 >> 2]) - f21);
  i30 = i6 + 80 + (i5 << 4) + 12 | 0;
  f22 = Math_fround(Math_fround(HEAPF32[i30 >> 2]) - f22);
  HEAPF32[i27 >> 2] = f19;
  HEAPF32[i28 >> 2] = f20;
  HEAPF32[i29 >> 2] = f21;
  HEAPF32[i30 >> 2] = f22;
  f23 = Math_fround(f23 * Math_fround(HEAPF32[i1 >> 2]));
  f24 = Math_fround(f24 * Math_fround(HEAPF32[i2 >> 2]));
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i3 >> 2]));
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i4 >> 2]));
  i30 = i6 + 128 + (i5 << 4) | 0;
  f23 = Math_fround(f23 + Math_fround(HEAPF32[i30 >> 2]));
  i29 = i6 + 128 + (i5 << 4) + 4 | 0;
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i29 >> 2]));
  i28 = i6 + 128 + (i5 << 4) + 8 | 0;
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i28 >> 2]));
  i27 = i6 + 128 + (i5 << 4) + 12 | 0;
  f26 = Math_fround(f26 + Math_fround(HEAPF32[i27 >> 2]));
  HEAPF32[i30 >> 2] = f23;
  HEAPF32[i29 >> 2] = f24;
  HEAPF32[i28 >> 2] = f25;
  HEAPF32[i27 >> 2] = f26;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 3);
 i29 = i6 + 176 | 0;
 i30 = i6 + 192 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAP32[i30 >> 2] = (HEAP32[i30 >> 2] | 0) + -1;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN8LODGroup11LODStruct50ENS0_9allocatorIS3_EEEEEvRT_j(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 24 | 0;
 i4 = i14 + 20 | 0;
 i10 = i14 + 8 | 0;
 i5 = i14 + 4 | 0;
 i6 = i14;
 i13 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = (HEAP32[i13 >> 2] | 0) - i2 >> 5;
 i1 = i2;
 if (i3 >>> 0 >= i8 >>> 0) {
  if (i3 >>> 0 <= i8 >>> 0) {
   STACKTOP = i14;
   return;
  }
  i5 = i1 + (i8 << 5) | 0;
  HEAP32[i11 >> 2] = 0;
  i7 = i11 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i2 = i8 << 5;
  i3 = i2 >> 5;
  if (!i3) {
   i4 = i11 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i11 >> 2] = i4;
   i2 = i4 + (i3 << 5) | 0;
   i6 = i11 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i8) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 12 | 0, i1 + 12 | 0);
     i1 = i1 + 32 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 32 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i12 >> 2] = i5;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i13 >> 2] = i3;
  i13 = i12 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i2;
  i4 = i1;
  i2 = i10;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    while (1) {
     i1 = i2 + -32 | 0;
     HEAP32[i7 >> 2] = i1;
     i3 = i2 + -20 | 0;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i14;
  return;
 }
 i7 = i12 + 8 | 0;
 if (((HEAP32[i7 >> 2] | 0) - i2 >> 5 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE8__appendEj(i12, i8 - i3 | 0);
  STACKTOP = i14;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE7reserveEj(i10, i8);
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i4, i11);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = i2 - i3 >> 5;
 i4 = i2;
 if (i1 >>> 0 < i8 >>> 0) {
  __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE8__appendEj(i10, i8 - i1 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 } else if (i1 >>> 0 > i8 >>> 0) {
  i5 = i3 + (i8 << 5) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -32 | 0;
    HEAP32[i9 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i9 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i10 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   while (1) {
    i1 = i2 + -32 | 0;
    HEAP32[i9 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i9 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i10 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i14;
 return;
}

function __ZN9ShaderLab20SerializedSubProgramD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i4 = i8 + 180 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 184 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -24 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -12 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i8 + 168 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i8 + 172 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i6 = i2 + -48 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 160 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -24 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -12 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 144 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 148 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -28 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -16 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 132 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 136 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -20 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 120 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 124 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 112 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i8 + 56 | 0;
 if ((HEAP32[i8 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 32 | 0;
 if ((HEAP32[i8 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 + 24 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 8 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 12 | 0);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN22BaseUnityConnectClient17InitializeSessionERK8UnityStrS2_N19CloudServiceHandler13InitModeFlagsE(i15, i12, i13, i14) {
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16;
 i10 = i16 + 4 | 0;
 i1 = i15 + 16 | 0;
 i11 = i12 + 11 | 0;
 do if ((i1 | 0) == (i12 | 0)) i8 = i12 + 4 | 0; else {
  i8 = HEAP8[i11 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i12 + 4 | 0;
  i8 = i4 ? HEAP32[i7 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i15 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i15 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i6);
   i8 = i7;
   break;
  }
  if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  if (i8 | 0) _memmove(i2 | 0, i6 | 0, i8 | 0) | 0;
  HEAP8[i2 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i15 + 20 >> 2] = i8;
   i8 = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   i8 = i7;
   break;
  }
 } while (0);
 i7 = HEAP8[i11 >> 0] | 0;
 if (!((i7 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i7 & 255) | 0)) {
  HEAP32[i9 >> 2] = (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13;
  __Z6FormatPKcz(i10, gb + 1041421 | 0, i9);
  i7 = HEAP8[i10 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i10 >> 2] | 0 : i10;
  i7 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i15 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i15 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i15 + 20 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i1 = i15 + 32 | 0;
 do if ((i1 | 0) != (i12 | 0)) {
  i6 = HEAP8[i11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i6 = i4 ? HEAP32[i8 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i15 + 40 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i15 + 36 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i15 + 36 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 i1 = i15 + 48 | 0;
 do if ((i1 | 0) != (i13 | 0)) {
  i6 = HEAP8[i13 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
  i6 = i4 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i15 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i15 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i15 + 52 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i15 + 292 >> 2] = i14;
 i1 = i15 + 113 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i16;
  return 1;
 }
 HEAP8[i1 >> 0] = 1;
 if ((HEAP32[i15 + 4 >> 2] | 0) != 1) mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, i15 | 0);
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i16;
 return 1;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 96 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN13SliderJoint2D6CreateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i6 = i12;
 i9 = i10 + 28 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i12;
  return;
 }
 i7 = i10 + 36 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i5 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i6);
    i5 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
    i1 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i8 = 9; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i8 = 11;
  }
  if ((i8 | 0) == 9) i8 = 11;
  if ((i8 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i8 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i6);
    i3 = HEAP32[i11 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i8 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 20;
   }
  }
  if ((i8 | 0) == 18) i8 = 20;
  if ((i8 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i12;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i12;
   return;
  }
 } while (0);
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i11 >> 2] = 2;
 i8 = i11 + 20 | 0;
 i7 = i11 + 36 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i8 = i11 + 40 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 i6 = i11 + 44 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i1 = i11 + 52 | 0;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i10 + 116 >> 2] | 0;
 HEAP8[i11 + 60 >> 0] = i4;
 HEAP8[i11 + 48 >> 0] = (i4 & 65535) >>> 8;
 HEAP32[i11 + 68 >> 2] = HEAP32[i10 + 100 >> 2];
 HEAP32[i11 + 64 >> 2] = HEAP32[i10 + 104 >> 2];
 i5 = HEAP32[i10 + 108 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 f2 = Math_fround(HEAPF32[i10 + 112 >> 2]);
 HEAPF32[i3 >> 2] = f2;
 if ((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f2) {
  HEAPF32[i1 >> 2] = f2;
  HEAP32[i3 >> 2] = i5;
 }
 if (i4 >>> 0 < 16777216) {
  f2 = Math_fround(HEAPF32[(__ZNK7Joint2D10FetchBodyBEv(i10) | 0) + 56 >> 2]);
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 67088 | 0) | 0;
  if (i1 | 0) __ZN11Rigidbody2D6CreateEv(i1);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[(HEAP32[i1 + 92 >> 2] | 0) + 56 >> 2]));
 } else f2 = Math_fround(HEAPF32[i10 + 120 >> 2]);
 HEAPF32[i6 >> 2] = f2;
 i1 = i11 + 20 | 0;
 i3 = i11 + 28 | 0;
 __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i10, i1, i3);
 if (HEAP8[i10 + 118 >> 0] | 0) if (!(HEAP8[i10 + 52 >> 0] | 0)) __ZN13SliderJoint2D14ConfigureAngleERK6b2Vec2S2_(i10, i1, i3);
 f13 = Math_fround(Math_fround(HEAPF32[i10 + 96 >> 2]) * Math_fround(.0174532924));
 f2 = Math_fround(+Math_sin(+f13));
 HEAPF32[i7 >> 2] = Math_fround(+Math_cos(+f13));
 HEAPF32[i8 >> 2] = f2;
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i10, i11);
 STACKTOP = i12;
 return;
}

function _consume_markers(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = i18 + 400 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i2 = i4 + 17 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i18 = 2;
  return i18 | 0;
 }
 i3 = i18 + 404 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i18 | 0) | 0;
 switch (i1 | 0) {
 case 1:
  {
   i15 = i4 + 20 | 0;
   if (!(HEAP8[i15 >> 0] | 0)) {
    if (!(HEAP8[i4 + 16 >> 0] | 0)) {
     i17 = HEAP32[i18 >> 2] | 0;
     HEAP32[i17 + 20 >> 2] = 35;
     mftCall_vi(HEAP32[i17 >> 2] | 0, i18 | 0);
    }
    _start_input_pass_28(i18);
    i18 = 1;
    return i18 | 0;
   }
   i14 = i18 + 32 | 0;
   if ((HEAP32[i14 >> 2] | 0) > 65500) i17 = 6; else if ((HEAP32[i18 + 28 >> 2] | 0) > 65500) i17 = 6;
   if ((i17 | 0) == 6) {
    i13 = HEAP32[i18 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 41;
    HEAP32[i13 + 24 >> 2] = 65500;
    mftCall_vi(HEAP32[i13 >> 2] | 0, i18 | 0);
   }
   i1 = HEAP32[i18 + 192 >> 2] | 0;
   if ((i1 | 0) != 8) {
    i13 = HEAP32[i18 >> 2] | 0;
    HEAP32[i13 + 20 >> 2] = 15;
    HEAP32[i13 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i13 >> 2] | 0, i18 | 0);
   }
   i13 = i18 + 36 | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 | 0) > 10) {
    i12 = HEAP32[i18 >> 2] | 0;
    HEAP32[i12 + 20 >> 2] = 26;
    HEAP32[i12 + 24 >> 2] = i1;
    HEAP32[i12 + 28 >> 2] = 10;
    mftCall_vi(HEAP32[i12 >> 2] | 0, i18 | 0);
    i1 = HEAP32[i13 >> 2] | 0;
   }
   i11 = i18 + 272 | 0;
   HEAP32[i11 >> 2] = 1;
   i12 = i18 + 276 | 0;
   HEAP32[i12 >> 2] = 1;
   i10 = i18 + 196 | 0;
   if ((i1 | 0) > 0) {
    i8 = 0;
    i9 = HEAP32[i10 >> 2] | 0;
    i4 = i1;
    i1 = 1;
    i2 = 1;
    while (1) {
     i5 = i9 + 8 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i7 = i9 + 12 | 0;
     if ((i6 + -1 | 0) >>> 0 > 3) i17 = 16; else {
      i3 = HEAP32[i7 >> 2] | 0;
      if ((i3 + -1 | 0) >>> 0 > 3) i17 = 16;
     }
     if ((i17 | 0) == 16) {
      i17 = 0;
      i2 = HEAP32[i18 >> 2] | 0;
      HEAP32[i2 + 20 >> 2] = 18;
      mftCall_vi(HEAP32[i2 >> 2] | 0, i18 | 0);
      i2 = HEAP32[i11 >> 2] | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      i1 = HEAP32[i12 >> 2] | 0;
      i3 = HEAP32[i7 >> 2] | 0;
      i4 = HEAP32[i13 >> 2] | 0;
     }
     i2 = (i2 | 0) > (i6 | 0) ? i2 : i6;
     HEAP32[i11 >> 2] = i2;
     i1 = (i1 | 0) > (i3 | 0) ? i1 : i3;
     HEAP32[i12 >> 2] = i1;
     i8 = i8 + 1 | 0;
     if ((i8 | 0) >= (i4 | 0)) break; else i9 = i9 + 84 | 0;
    }
    HEAP32[i18 + 280 >> 2] = 8;
    if ((i4 | 0) > 0) {
     i4 = i18 + 28 | 0;
     i1 = 0;
     i3 = HEAP32[i10 >> 2] | 0;
     while (1) {
      HEAP32[i3 + 36 >> 2] = 8;
      i9 = i3 + 8 | 0;
      HEAP32[i3 + 28 >> 2] = _jdiv_round_up(Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0, i2 << 3) | 0;
      i10 = i3 + 12 | 0;
      i8 = Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
      HEAP32[i3 + 32 >> 2] = _jdiv_round_up(i8, HEAP32[i12 >> 2] << 3) | 0;
      i9 = Math_imul(HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
      HEAP32[i3 + 40 >> 2] = _jdiv_round_up(i9, HEAP32[i11 >> 2] | 0) | 0;
      i10 = Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
      HEAP32[i3 + 44 >> 2] = _jdiv_round_up(i10, HEAP32[i12 >> 2] | 0) | 0;
      HEAP8[i3 + 48 >> 0] = 1;
      HEAP32[i3 + 76 >> 2] = 0;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= (HEAP32[i13 >> 2] | 0)) break;
      i3 = i3 + 84 | 0;
      i2 = HEAP32[i11 >> 2] | 0;
     }
     i1 = HEAP32[i12 >> 2] | 0;
    }
   } else {
    HEAP32[i18 + 280 >> 2] = 8;
    i1 = 1;
   }
   HEAP32[i18 + 284 >> 2] = _jdiv_round_up(HEAP32[i14 >> 2] | 0, i1 << 3) | 0;
   if ((HEAP32[i18 + 292 >> 2] | 0) < (HEAP32[i13 >> 2] | 0)) i17 = 25; else if (!(HEAP8[i18 + 200 >> 0] | 0)) HEAP8[(HEAP32[i16 >> 2] | 0) + 16 >> 0] = 0; else i17 = 25;
   if ((i17 | 0) == 25) HEAP8[(HEAP32[i16 >> 2] | 0) + 16 >> 0] = 1;
   HEAP8[i15 >> 0] = 0;
   i18 = 1;
   return i18 | 0;
  }
 case 2:
  {
   HEAP8[i2 >> 0] = 1;
   if (!(HEAP8[i4 + 20 >> 0] | 0)) {
    i2 = i18 + 132 | 0;
    i1 = HEAP32[i18 + 124 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) <= (i1 | 0)) {
     i18 = 2;
     return i18 | 0;
    }
    HEAP32[i2 >> 2] = i1;
    i18 = 2;
    return i18 | 0;
   } else {
    if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 13 >> 0] | 0)) {
     i18 = 2;
     return i18 | 0;
    }
    i17 = HEAP32[i18 >> 2] | 0;
    HEAP32[i17 + 20 >> 2] = 59;
    mftCall_vi(HEAP32[i17 >> 2] | 0, i18 | 0);
    i18 = 2;
    return i18 | 0;
   }
  }
 default:
  {
   i18 = i1;
   return i18 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSG_5Vec3VE(i3, i16, i14, i10, i2, i12, i4, i8, i1, i9) {
 i3 = i3 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i11 = 0, i13 = 0, i15 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 72 | 0;
 i6 = i17 + 48 | 0;
 i5 = i17 + 32 | 0;
 i15 = i17 + 16 | 0;
 i7 = i17;
 HEAP32[i13 >> 2] = 0;
 HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 if (!(__ZN5physxL22testTriangleFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(i3, i2, i12, i1, i6, i17 + 68 | 0, i5, i13) | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i11 = i10 + 24 | 0;
 if (!(__ZN5physxL18testPolyFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(HEAP32[i10 + 16 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i10 + 28 >> 2] | 0, i2, i12, i1, i6, i17 + 64 | 0, i5, i13) | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if (!(__ZN5physxL18testPolyEdgeNormalERKNS_2Gu9TriangleVEhRKNS0_15HullPolygonDataERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSH_RNSG_5Vec3VENS0_13FeatureStatusERSN_(i3, i14, i10, i2, i12, i1, i6, i5, i13) | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 f23 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 f23 = Math_fround(f23 - f20);
 f18 = Math_fround(f18 - f19);
 f24 = Math_fround(f24 - f21);
 f25 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f20 = Math_fround(f25 - f20);
 f19 = Math_fround(f22 - f19);
 f21 = Math_fround(Math_fround(HEAPF32[i3 + 136 >> 2]) - f21);
 f22 = Math_fround(Math_fround(f18 * f21) - Math_fround(f24 * f19));
 f21 = Math_fround(Math_fround(f24 * f20) - Math_fround(f23 * f21));
 f20 = Math_fround(Math_fround(f23 * f19) - Math_fround(f18 * f20));
 f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f22 * f22) + Math_fround(f21 * f21))))));
 f22 = Math_fround(f18 * f22);
 f21 = Math_fround(f18 * f21);
 f18 = Math_fround(f20 * f18);
 HEAPF32[i15 >> 2] = f22;
 HEAPF32[i15 + 4 >> 2] = f21;
 HEAPF32[i15 + 8 >> 2] = f18;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i13 = HEAP32[i12 + 36 >> 2] | 0;
 f20 = Math_fround(f22 * Math_fround(HEAPF32[i13 >> 2]));
 f20 = Math_fround(f20 + Math_fround(f21 * Math_fround(HEAPF32[i13 + 4 >> 2])));
 f20 = Math_fround(f20 + Math_fround(f18 * Math_fround(HEAPF32[i13 + 8 >> 2])));
 f19 = Math_fround(f22 * Math_fround(HEAPF32[i13 + 16 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f21 * Math_fround(HEAPF32[i13 + 20 >> 2])));
 f19 = Math_fround(f19 + Math_fround(f18 * Math_fround(HEAPF32[i13 + 24 >> 2])));
 f22 = Math_fround(f22 * Math_fround(HEAPF32[i13 + 32 >> 2]));
 f21 = Math_fround(f22 + Math_fround(f21 * Math_fround(HEAPF32[i13 + 36 >> 2])));
 f18 = Math_fround(f21 + Math_fround(f18 * Math_fround(HEAPF32[i13 + 40 >> 2])));
 HEAPF32[i7 >> 2] = f20;
 HEAPF32[i7 + 4 >> 2] = f19;
 HEAPF32[i7 + 8 >> 2] = f18;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 i13 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i10, i12, i7) | 0;
 __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(i3, i16, i14, i10, (HEAP32[i11 >> 2] | 0) + (i13 * 20 | 0) | 0, i12, i4, i8, i1, i15);
 i16 = 1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i23, i1, i6, i7, i2) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24;
 i20 = i24 + 80 | 0;
 i22 = i24 + 64 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i23 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i23 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i21 >> 2] = i5;
 HEAP8[i21 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i17 = i21;
  i18 = HEAP32[i17 + 4 >> 2] | 0;
  i19 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = i18;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i18 = i21 + 4 | 0;
  i19 = i23 + 8 | 0;
  i6 = i6 + 12 | 0;
  i8 = i23 + 4 | 0;
  i9 = i23 + 12 | 0;
  i10 = i23 + 16 | 0;
  i11 = i22;
  i12 = i20 + 4 | 0;
  i13 = i20 + 8 | 0;
  i14 = i20 + 12 | 0;
  i15 = i20 + 16 | 0;
  i16 = i20 + 20 | 0;
  i17 = i20 + 24 | 0;
  do {
   i3 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i8 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i23 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i23 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i21 >> 2] = i1;
   HEAP8[i18 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i21;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
   mftCall_viii(HEAP32[i6 >> 2] | 0, i22 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0);
   i5 = HEAP32[i23 >> 2] | 0;
   i25 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev(i21);
   HEAP32[i20 >> 2] = i5;
   HEAP32[i12 >> 2] = i25;
   HEAP32[i13 >> 2] = i11;
   HEAP32[i14 >> 2] = i2;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i17 >> 2] = 0;
   __ZNK5physx33PxClothStretchConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEEEEEjT_j(i21, i20, 0) | 0;
   i1 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i8 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i23 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   i7 = i7 + 8 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i23 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i23 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i23 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i24;
 return;
}

function __Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i11 + 4 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i8 = i11 + 20 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 20 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) i1 = 0; else {
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = i2;
  do {
   HEAP32[i1 + 20 >> 2] = i4;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = i1;
  HEAP32[i1 >> 2] = i5;
  i1 = HEAP32[i10 + 140 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i3;
  i1 = 1;
 }
 i2 = i11 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i11 | 0)) {
  i2 = HEAP32[i11 + 16 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = i3;
  do {
   HEAP32[i1 + 16 >> 2] = 0;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i6 >> 2] = i5;
  i6 = HEAP32[i10 + 136 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else {
  i5 = HEAP32[i12 >> 2] | 0;
  i13 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[(HEAP32[i5 + 20 >> 2] | 0) + 8 >> 2] = i13;
  HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + 8 >> 2] = i3;
  i5 = i13 + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i13;
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i11;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i5 >> 2] = i3;
  if (!i1) {
   i5 = HEAP32[i10 + 140 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i6 = 13; else {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) i6 = 13; else HEAP32[i5 >> 2] = i1;
   }
   if ((i6 | 0) == 13) {
    i1 = i5 + 8 | 0;
    i2 = i5 + 12 | 0;
    i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
    i13 = HEAP32[i5 + 20 >> 2] | 0;
    i4 = mftCall_iii(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] | 0, i4 | 0) | 0;
    if (!i4) {
     i13 = 0;
     return i13 | 0;
    }
    i3 = i5 + 4 | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i3 >> 2] = i4;
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    do {
     i1 = i1 - i3 | 0;
     i13 = i2;
     i2 = i4 + i1 | 0;
     HEAP32[i2 >> 2] = i13;
    } while ((i1 | 0) != 4);
    HEAP32[i5 >> 2] = i2;
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    if (!i2) {
     i13 = 0;
     return i13 | 0;
    }
   }
   i1 = HEAP32[i8 >> 2] | 0;
   i13 = i1 + 4 | 0;
   i6 = HEAP32[i13 >> 2] | 0;
   HEAP32[i2 + 4 >> 2] = i6;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i2 + 8 >> 2] = i11;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP8[i2 + 20 >> 0] = 0;
   HEAP8[i2 + 21 >> 0] = HEAP8[i1 + 21 >> 0] | 0;
   i1 = i11;
   do {
    HEAP32[i1 + 20 >> 2] = i2;
    i1 = HEAP32[i1 + 12 >> 2] | 0;
   } while ((i1 | 0) != (i11 | 0));
  }
 }
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i7 | 0)) {
  i2 = HEAP32[i7 + 16 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = i3;
  do {
   HEAP32[i1 + 16 >> 2] = 0;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i3 >> 2] = i1;
  i3 = HEAP32[i10 + 136 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = i3;
  do {
   HEAP32[i1 + 20 >> 2] = 0;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  i13 = HEAP32[i2 + 4 >> 2] | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 + 4 >> 2] = i13;
  HEAP32[i13 >> 2] = i9;
  i13 = HEAP32[i10 + 140 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i2;
 } else {
  i13 = HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] | 0;
  HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] = i13;
  HEAP32[(HEAP32[i7 + 16 >> 2] | 0) + 8 >> 2] = i2;
  i8 = i13;
  i13 = i8 + 8 | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 12 >> 2] = i8;
  HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + 12 >> 2] = i7;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i13 >> 2] = i2;
 }
 i13 = HEAP32[i10 + 132 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = i12 >>> 0 < i11 >>> 0 ? i12 : i11;
 i10 = HEAP32[i12 >> 2] | 0;
 i11 = HEAP32[HEAP32[i12 + 4 >> 2] >> 2] | 0;
 HEAP32[HEAP32[i10 + 4 >> 2] >> 2] = i11;
 HEAP32[HEAP32[i11 + 4 >> 2] >> 2] = i10;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i12;
 i13 = 1;
 return i13 | 0;
}

function __ZNK11UnityEngine9Animation28GenericAnimationBindingCache30CurveAttributeToSerializedPathER10GameObjectRK18EditorCurveBinding(i15, i7, i1, i8) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 56 | 0;
 i9 = i16 + 32 | 0;
 i10 = i16 + 16 | 0;
 i11 = i16 + 48 | 0;
 i12 = i16;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 i3 = i8 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
 i6 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i2, i1, 0) | 0;
 if (!i6) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  STACKTOP = i16;
  return;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i3 = HEAP8[i3 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i13 = 9;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i13 = 11;
  }
 } else i13 = 9;
 if ((i13 | 0) == 9) {
  i5 = i3 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i13 = 11;
 }
 if ((i13 | 0) == 11) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 + 28 >> 2];
 i3 = i8 + 12 | 0;
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i5 = i1 ? HEAP32[i8 + 16 >> 2] | 0 : i5 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i13 = 15;
 } else if (i5 >>> 0 < 11) {
  i1 = i12 + 11 | 0;
  HEAP8[i1 >> 0] = i5;
  if (!i5) i2 = i12; else {
   i2 = i12;
   i13 = 17;
  }
 } else i13 = 15;
 if ((i13 | 0) == 15) {
  i17 = i5 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i12 + 8 >> 2] = i17 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i5;
  i1 = i12 + 11 | 0;
  i13 = 17;
 }
 if ((i13 | 0) == 17) _memcpy(i2 | 0, i3 | 0, i5 | 0) | 0;
 HEAP8[i2 + i5 >> 0] = 0;
 i17 = (HEAP8[i8 + 32 >> 0] | 0) != 0;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 __ZNK11UnityEngine9Animation28GenericAnimationBindingCache20CreateGenericBindingERK8UnityStri4PPtrI10MonoScriptES4_bRNS0_14GenericBindingE(i7, i10, i4, i14, i12, i17, i9);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i17 = HEAP32[i12 >> 2] | 0;
  i13 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i14);
 }
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i17 = HEAP32[i10 >> 2] | 0;
  i13 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i14);
 }
 if (!(HEAP8[i9 + 14 >> 0] | 0)) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
 } else {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  do if ((__ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i7, i9, i6, i14) | 0) == -1) {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
  } else {
   i1 = HEAP32[i14 + 8 >> 2] | 0;
   if (!i1) {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i15 + 4 >> 2] = 0;
    HEAP32[i15 + 8 >> 2] = 0;
    break;
   } else {
    mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i1 | 0, i14 | 0);
    break;
   }
  } while (0);
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx14PxsAABBManager21processAggregatePairsEPKNS_19AggregateSortedDataE(i19, i17) {
 i19 = i19 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i12 = i19 + 49824 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) return;
 i13 = i19 + 49812 | 0;
 i14 = i19 + 49856 | 0;
 i15 = i19 + 24 | 0;
 i16 = i19 + 180 | 0;
 i18 = 0;
 do {
  i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i18 << 2) >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i6 = HEAP32[i3 + (i5 * 12 | 0) >> 2] | 0;
  i7 = HEAP32[i3 + (i5 * 12 | 0) + 4 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
  if (!(i1 & 1)) {
   i8 = 0;
   i10 = 1073741823;
  } else {
   i10 = i1 >>> 1;
   i8 = (HEAP32[i16 >> 2] | 0) + (i10 * 1048 | 0) | 0;
  }
  i1 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
  if (!(i1 & 1)) {
   i9 = 0;
   i11 = 1073741823;
  } else {
   i11 = i1 >>> 1;
   i9 = (HEAP32[i16 >> 2] | 0) + (i11 * 1048 | 0) | 0;
  }
  i4 = (i9 | 0) != 0;
  do if (!i8) {
   if (i4) {
    i4 = i3 + (i5 * 12 | 0) + 8 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) {
     i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
     i1 = _PxGetFoundation() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 12, (i1 ? gb + 699407 | 0 : gb + 837976 | 0) | 0, gb + 676016 | 0, 2349) | 0;
     HEAP32[i1 >> 2] = 0;
     i2 = i1 + 4 | 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i4 >> 2] = i1;
     i3 = ((HEAPU8[i9 + 1025 >> 0] | 0) + 31 | 0) >>> 5;
     if (!i3) {
      i1 = 0;
      i2 = 0;
     } else {
      HEAP32[i2 >> 2] = i3;
      i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1 + 8 | 0, i3 << 2, gb + 769739 | 0, 352) | 0;
      HEAP32[i1 >> 2] = i10;
      i1 = HEAP32[i2 >> 2] | 0;
      i2 = i10;
     }
     _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZN5physx14PxsAABBManager22processAggregateSingleERKNS_19AggregateSortedDataERKNS_9AggregateEjPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i19, i17 + (i11 << 3) | 0, i9, i6, i1);
   }
  } else {
   i5 = i3 + (i5 * 12 | 0) + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = (i1 | 0) != 0;
   if (i4) {
    if (!i2) {
     i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
     i1 = _PxGetFoundation() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 12, (i1 ? gb + 699407 | 0 : gb + 837976 | 0) | 0, gb + 676016 | 0, 2322) | 0;
     HEAP32[i1 >> 2] = 0;
     i2 = i1 + 4 | 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i5 >> 2] = i1;
     i3 = ((Math_imul(HEAPU8[i9 + 1025 >> 0] | 0, HEAPU8[i8 + 1025 >> 0] | 0) | 0) + 31 | 0) >>> 5;
     if (!i3) {
      i1 = 0;
      i2 = 0;
     } else {
      HEAP32[i2 >> 2] = i3;
      i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1 + 8 | 0, i3 << 2, gb + 769739 | 0, 352) | 0;
      HEAP32[i1 >> 2] = i7;
      i1 = HEAP32[i2 >> 2] | 0;
      i2 = i7;
     }
     _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZN5physx14PxsAABBManager25processAggregateAggregateERKNS_19AggregateSortedDataERKNS_9AggregateES3_S6_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i19, i17 + (i10 << 3) | 0, i8, i17 + (i11 << 3) | 0, i9, i1);
    break;
   } else {
    if (!i2) {
     i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
     i1 = _PxGetFoundation() | 0;
     i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
     i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 12, (i1 ? gb + 699407 | 0 : gb + 837976 | 0) | 0, gb + 676016 | 0, 2334) | 0;
     HEAP32[i1 >> 2] = 0;
     i2 = i1 + 4 | 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i5 >> 2] = i1;
     i3 = ((HEAPU8[i8 + 1025 >> 0] | 0) + 31 | 0) >>> 5;
     if (!i3) {
      i1 = 0;
      i2 = 0;
     } else {
      HEAP32[i2 >> 2] = i3;
      i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1 + 8 | 0, i3 << 2, gb + 769739 | 0, 352) | 0;
      HEAP32[i1 >> 2] = i11;
      i1 = HEAP32[i2 >> 2] | 0;
      i2 = i11;
     }
     _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    __ZN5physx14PxsAABBManager22processAggregateSingleERKNS_19AggregateSortedDataERKNS_9AggregateEjPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i19, i17 + (i10 << 3) | 0, i8, i7, i1);
    break;
   }
  } while (0);
  i18 = i18 + 1 | 0;
 } while (i18 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 240 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj683ES2_NS_21PxVehicleDriveSimDataES6_EEKNS_34PxVehicleDriveSimDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 2112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 1584 | 0;
 i6 = i9 + 1056 | 0;
 i8 = i9;
 i7 = i9 + 528 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj663ES3_RKNS_19PxVehicleEngineDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj664ES3_RKNS_18PxVehicleGearsDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj665ES3_RKNS_19PxVehicleClutchDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj666ES3_RKNS_20PxVehicleAutoBoxDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 48 | 0, 3);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i8 + 64 >> 2] | 0;
 i4 = i12 << 3;
 _memcpy(i7 | 0, i8 | 0, i4 | 0) | 0;
 HEAP32[i7 + 64 >> 2] = i12;
 i13 = i7 + 80 | 0;
 i10 = i8 + 80 | 0;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 i13 = i8 + 112 | 0;
 _memcpy(i7 + 112 | 0, i13 | 0, 416) | 0;
 _memcpy(i6 | 0, i7 | 0, i4 | 0) | 0;
 HEAP32[i6 + 64 >> 2] = i12;
 i14 = i6 + 80 | 0;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 _memcpy(i6 + 112 | 0, i13 | 0, 416) | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 _memcpy(i5 | 0, i6 | 0, i4 | 0) | 0;
 HEAP32[i5 + 64 >> 2] = i12;
 i12 = i5 + 80 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 _memcpy(i5 + 112 | 0, i13 | 0, 416) | 0;
 mftCall_vii(i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx14NpRigidDynamic17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i11 >> 2] = HEAP32[gb + 124772 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 124772 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 124772 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 124772 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 124772 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 124772 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 124772 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 124772 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 754644;
 HEAP32[i10 + 4 >> 2] = gb + 827530;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 288;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 754644;
 HEAP32[i9 + 4 >> 2] = gb + 747076;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 288;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124260 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124260 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124260 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124260 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124260 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124260 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124260 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 124292 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 124292 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 124292 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 124292 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 124292 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 124292 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 124292 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 124292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124324 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124324 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124324 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124324 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124324 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124324 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124324 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 124484 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 124484 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 124484 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 124484 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 124484 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 124484 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 124484 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 124484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN7mecanim9animation9DenseClip8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 12 | 0;
 i10 = i11;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899065 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899078 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898090 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899091 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i7 + 20;
 HEAP32[i10 + 4 >> 2] = i7 + 16;
 HEAP32[i10 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899103 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i9, i10, 0); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i11;
 return;
}

function __ZN5physx13NpRigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i2 + 256 | 0;
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i11 >> 2] = HEAP32[gb + 124708 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 124708 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 124708 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[gb + 124708 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[gb + 124708 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[gb + 124708 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[gb + 124708 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[gb + 124708 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i11 | 0, 32) | 0;
 HEAP32[i10 >> 2] = gb + 754659;
 HEAP32[i10 + 4 >> 2] = gb + 827530;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 112;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 754659;
 HEAP32[i9 + 4 >> 2] = gb + 747076;
 HEAP32[i9 + 8 >> 2] = 12;
 HEAP32[i9 + 12 >> 2] = 112;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 124260 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124260 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124260 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124260 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124260 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124260 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124260 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 124292 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 124292 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 124292 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 124292 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 124292 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 124292 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 124292 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 124292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124740 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124740 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124740 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124740 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124740 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124740 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124740 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124740 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 124484 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 124484 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 124484 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 124484 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 124484 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 124484 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 124484 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 124484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyIyEEvPKcRT_(i15, gb + 771708 | 0, i14);
 i1 = i14 + 8 | 0;
 i13 = i15 + 8 | 0;
 if (!(HEAP8[i13 >> 0] | 0)) {
  i2 = i15 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < 4) i12 = 3; else {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i15 >> 2] >> 0] | 0;
   i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i11 = i1 + 1 | 0;
   HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
   i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i3 = i1 + 2 | 0;
   HEAP8[i3 >> 0] = HEAP8[i10 >> 0] | 0;
   i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i4 = i1 + 3 | 0;
   HEAP8[i4 >> 0] = HEAP8[i10 >> 0] | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i10 = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP8[i4 >> 0] = i10;
   i4 = HEAP8[i11 >> 0] | 0;
   HEAP8[i11 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = i4;
   i3 = i14 + 12 | 0;
   i4 = i14 + 16 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((HEAP8[i13 >> 0] | 0) != 0 | i1 >>> 0 < 4) i12 = 6; else {
    i6 = HEAP32[i15 >> 2] | 0;
    i7 = HEAP8[i6 >> 0] | 0;
    i8 = i6 + 1 | 0;
    HEAP32[i15 >> 2] = i8;
    HEAP32[i2 >> 2] = i1 + -1;
    i8 = HEAP8[i8 >> 0] | 0;
    i9 = i6 + 2 | 0;
    HEAP32[i15 >> 2] = i9;
    HEAP32[i2 >> 2] = i1 + -2;
    i9 = HEAP8[i9 >> 0] | 0;
    i10 = i6 + 3 | 0;
    HEAP32[i15 >> 2] = i10;
    HEAP32[i2 >> 2] = i1 + -3;
    i10 = HEAP8[i10 >> 0] | 0;
    i6 = i6 + 4 | 0;
    HEAP32[i15 >> 2] = i6;
    i1 = i1 + -4 | 0;
    HEAP32[i2 >> 2] = i1;
    i11 = i15;
    i5 = 0;
   }
  }
 } else i12 = 3;
 if ((i12 | 0) == 3) {
  HEAP8[i13 >> 0] = 1;
  i1 = i15 + 4 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i4 = i14 + 16 | 0;
  i3 = i14 + 12 | 0;
  i12 = 6;
 }
 if ((i12 | 0) == 6) {
  HEAP8[i13 >> 0] = 1;
  i11 = i15;
  i7 = 0;
  i8 = 0;
  i9 = 0;
  i10 = 0;
  i6 = HEAP32[i15 >> 2] | 0;
  i5 = 1;
 }
 i12 = (i8 & 255) << 16 | (i7 & 255) << 24 | (i9 & 255) << 8 | i10 & 255;
 i12 = i12 >>> 0 < i1 >>> 0 ? i12 : i1;
 HEAP32[i4 >> 2] = i12;
 HEAP32[i3 >> 2] = i6;
 i1 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
 HEAP32[i11 >> 2] = i1;
 i12 = (HEAP32[i2 >> 2] | 0) - i12 | 0;
 HEAP32[i2 >> 2] = i12;
 if (i5 | i12 >>> 0 < 4) HEAP8[i13 >> 0] = 1; else {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i10;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i11 = i4 + 1 | 0;
  HEAP8[i11 >> 0] = HEAP8[i10 >> 0] | 0;
  i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i10;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i1 = i4 + 2 | 0;
  HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
  i10 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i10;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i12 = i4 + 3 | 0;
  HEAP8[i12 >> 0] = HEAP8[i10 >> 0] | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i10 = HEAP8[i4 >> 0] | 0;
  HEAP8[i4 >> 0] = HEAP8[i12 >> 0] | 0;
  HEAP8[i12 >> 0] = i10;
  i12 = HEAP8[i11 >> 0] | 0;
  HEAP8[i11 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP8[i1 >> 0] = i12;
  i1 = i14 + 20 | 0;
  if (!((HEAP8[i13 >> 0] | 0) != 0 | (HEAP32[i2 >> 2] | 0) >>> 0 < 4)) {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i15 >> 2] >> 0] | 0;
   i11 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i13 = i1 + 1 | 0;
   HEAP8[i13 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i14 = i1 + 2 | 0;
   HEAP8[i14 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i12 = i1 + 3 | 0;
   HEAP8[i12 >> 0] = HEAP8[i11 >> 0] | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i15 = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = HEAP8[i12 >> 0] | 0;
   HEAP8[i12 >> 0] = i15;
   i15 = HEAP8[i13 >> 0] | 0;
   HEAP8[i13 >> 0] = HEAP8[i14 >> 0] | 0;
   HEAP8[i14 >> 0] = i15;
   return;
  }
 }
 HEAP8[i13 >> 0] = 1;
 return;
}

function __ZN19AssetBundleManifest25CollectDirectDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE(i7, i3, i17) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22;
 i5 = i22 + 24 | 0;
 i19 = i22 + 8 | 0;
 i6 = HEAP32[i17 >> 2] | 0;
 i20 = i17 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i4 = i18 + 4 | 0;
  i2 = i1;
  while (1) {
   i1 = i2 + -16 | 0;
   HEAP32[i20 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i16 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i4 >> 2] = i16;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
    i1 = HEAP32[i20 >> 2] | 0;
   }
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
  }
 }
 i16 = __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr(i7, i3) | 0;
 HEAP32[i5 >> 2] = i16;
 if ((i16 | 0) == -1) {
  STACKTOP = i22;
  return;
 }
 __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_(i7 + 32 | 0, i18, i5);
 i16 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i16 + 16 >> 2] | 0;
 i16 = i16 + 20 | 0;
 if ((i1 | 0) != (HEAP32[i16 >> 2] | 0)) {
  i7 = i7 + 48 | 0;
  i8 = i19 + 12 | 0;
  i6 = i19 + 12 | 0;
  i9 = i18 + 4 | 0;
  i10 = i19 + 8 | 0;
  i11 = i19 + 4 | 0;
  i12 = i17 + 8 | 0;
  i13 = i19 + 11 | 0;
  i14 = i18 + 4 | 0;
  i15 = i18 + 4 | 0;
  do {
   __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_(i7, i18, i1);
   i3 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP32[i19 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 >> 2] = i2;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i19);
    i2 = HEAP32[i6 >> 2] | 0;
    i21 = 13;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i13 >> 0] = i4;
    if (!i4) i2 = i19; else {
     i2 = i19;
     i21 = 15;
    }
   } else i21 = 13;
   if ((i21 | 0) == 13) {
    i5 = i4 + 16 & -16;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i9 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i10 >> 2] = i5 | -2147483648;
    HEAP32[i11 >> 2] = i4;
    i21 = 15;
   }
   if ((i21 | 0) == 15) {
    i21 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   i2 = HEAP32[i20 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i17, i19); else {
    i5 = HEAP8[i13 >> 0] | 0;
    i3 = i5 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i19 >> 2] | 0 : i19;
    i5 = i3 ? HEAP32[i11 >> 2] | 0 : i5 & 255;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i2 + 12 >> 2] = i3;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     i21 = 20;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i2 + 11 >> 0] = i5;
     if (i5) i21 = 22;
    } else i21 = 20;
    if ((i21 | 0) == 20) {
     i23 = i5 + 16 & -16;
     HEAP32[i18 >> 2] = 66;
     HEAP32[i15 >> 2] = i3;
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i23, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i2 >> 2] = i3;
     HEAP32[i2 + 8 >> 2] = i23 | -2147483648;
     HEAP32[i2 + 4 >> 2] = i5;
     i2 = i3;
     i21 = 22;
    }
    if ((i21 | 0) == 22) {
     i21 = 0;
     _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 16;
   }
   if ((HEAP8[i13 >> 0] | 0) < 0) {
    i23 = HEAP32[i19 >> 2] | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i14 >> 2] = i5;
    __Z19free_alloc_internalPvRK10MemLabelId(i23, i18);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i16 >> 2] | 0));
 }
 __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(HEAP32[i17 >> 2] | 0, HEAP32[i20 >> 2] | 0, i18);
 STACKTOP = i22;
 return;
}

function __ZL20CalculateCapsuleHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i3, i4, i8, f11, f16) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 f11 = Math_fround(f11);
 f16 = Math_fround(f16);
 var i1 = 0, i2 = 0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, i31 = 0, f32 = f0, f33 = f0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i30;
 i1 = i4 + 16 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = f7 < f5 ? f5 : f7;
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) - f7);
 i1 = f5 > Math_fround(0.0);
 f5 = i1 ? f5 : Math_fround(0.0);
 f6 = Math_fround(Math_fround(f7 * Math_fround(.707106769)) * Math_fround(1.08239222));
 f7 = Math_fround(f7 * Math_fround(1.08239222));
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i8 >> 2]));
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i8 + 4 >> 2]));
 f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i8 + 8 >> 2]));
 f13 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f17 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 60 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 f21 = Math_fround(f5 * f20);
 f23 = Math_fround(HEAPF32[i4 + 44 >> 2]);
 f24 = Math_fround(f5 * f23);
 f25 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f26 = Math_fround(f5 * f25);
 f29 = Math_fround(f6 + f5);
 f27 = Math_fround(f29 * f20);
 f28 = Math_fround(f29 * f23);
 f29 = Math_fround(f29 * f25);
 i1 = 0;
 i2 = 0;
 while (1) {
  f32 = Math_fround(Math_fround(Math_fround(Math_fround(i2 | 0) * Math_fround(.125)) * Math_fround(3.14159274)) * Math_fround(2.0));
  f37 = Math_fround(+Math_cos(+f32));
  f32 = Math_fround(+Math_sin(+f32));
  f38 = Math_fround(f37 * f13);
  f36 = Math_fround(f37 * f14);
  f37 = Math_fround(f37 * f15);
  f34 = Math_fround(f32 * f17);
  f33 = Math_fround(f32 * f18);
  f32 = Math_fround(f32 * f19);
  i31 = i1 | 1;
  f41 = Math_fround(Math_fround(f9 + Math_fround(f7 * f38)) + Math_fround(f7 * f34));
  f40 = Math_fround(Math_fround(f10 + Math_fround(f7 * f36)) + Math_fround(f7 * f33));
  f39 = Math_fround(Math_fround(f12 + Math_fround(f7 * f37)) + Math_fround(f7 * f32));
  f43 = Math_fround(f40 - f24);
  f42 = Math_fround(f39 - f26);
  HEAPF32[i22 + (i1 * 12 | 0) >> 2] = Math_fround(f41 - f21);
  HEAPF32[i22 + (i1 * 12 | 0) + 4 >> 2] = f43;
  HEAPF32[i22 + (i1 * 12 | 0) + 8 >> 2] = f42;
  i35 = i1 | 2;
  f40 = Math_fround(f40 + f24);
  f39 = Math_fround(f39 + f26);
  HEAPF32[i22 + (i31 * 12 | 0) >> 2] = Math_fround(f41 + f21);
  HEAPF32[i22 + (i31 * 12 | 0) + 4 >> 2] = f40;
  HEAPF32[i22 + (i31 * 12 | 0) + 8 >> 2] = f39;
  i31 = i1 | 3;
  f34 = Math_fround(Math_fround(f9 + Math_fround(f6 * f38)) + Math_fround(f6 * f34));
  f33 = Math_fround(Math_fround(f10 + Math_fround(f6 * f36)) + Math_fround(f6 * f33));
  f32 = Math_fround(Math_fround(f12 + Math_fround(f6 * f37)) + Math_fround(f6 * f32));
  f37 = Math_fround(f33 - f28);
  f36 = Math_fround(f32 - f29);
  HEAPF32[i22 + (i35 * 12 | 0) >> 2] = Math_fround(f34 - f27);
  HEAPF32[i22 + (i35 * 12 | 0) + 4 >> 2] = f37;
  HEAPF32[i22 + (i35 * 12 | 0) + 8 >> 2] = f36;
  f33 = Math_fround(f33 + f28);
  f32 = Math_fround(f32 + f29);
  HEAPF32[i22 + (i31 * 12 | 0) >> 2] = Math_fround(f34 + f27);
  HEAPF32[i22 + (i31 * 12 | 0) + 4 >> 2] = f33;
  HEAPF32[i22 + (i31 * 12 | 0) + 8 >> 2] = f32;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 8) break; else i1 = i1 + 4 | 0;
 }
 f43 = Math_fround(f7 + f5);
 f41 = Math_fround(f43 * f20);
 f42 = Math_fround(f43 * f23);
 f43 = Math_fround(f43 * f25);
 f39 = Math_fround(f10 - f42);
 f40 = Math_fround(f12 - f43);
 HEAPF32[i22 + 384 >> 2] = Math_fround(f9 - f41);
 HEAPF32[i22 + 388 >> 2] = f39;
 HEAPF32[i22 + 392 >> 2] = f40;
 f42 = Math_fround(f10 + f42);
 f43 = Math_fround(f12 + f43);
 HEAPF32[i22 + 396 >> 2] = Math_fround(f9 + f41);
 HEAPF32[i22 + 400 >> 2] = f42;
 HEAPF32[i22 + 404 >> 2] = f43;
 i35 = __ZL28CalculateCarveHullFromPointsR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fffPS7_i(i3, i4, i8, f11, f16, i22, 34) | 0;
 STACKTOP = i30;
 return i35 | 0;
}

function __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf(i1, i17) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0;
 i19 = HEAP32[i1 + 20 >> 2] | 0;
 i20 = HEAP32[i1 + 64 >> 2] | 0;
 i21 = (HEAP32[i1 + 120 >> 2] | 0) + ((Math_imul(HEAP32[i1 + 144 >> 2] | 0, i20) | 0) << 2) | 0;
 i22 = HEAP32[i1 + 100 >> 2] | 0;
 i18 = HEAP32[i1 + 104 >> 2] | 0;
 i14 = HEAP32[i1 + 128 >> 2] | 0;
 if ((i19 | 0) <= 0) return;
 i13 = (i20 | 0) < 1;
 i12 = 0;
 do {
  i1 = HEAP32[i22 + (i12 << 3) >> 2] | 0;
  i15 = HEAP32[i22 + (i12 << 3) + 4 >> 2] | 0;
  i11 = Math_imul(i12, i20) | 0;
  i16 = Math_imul(i12, i14) | 0;
  switch (i20 | 0) {
  case 1:
   {
    if ((i1 | 0) <= (i15 | 0)) {
     i4 = i17 + (i11 << 2) | 0;
     i2 = 0;
     f3 = Math_fround(HEAPF32[i4 >> 2]);
     while (1) {
      f8 = Math_fround(HEAPF32[i18 + (i2 + i16 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i21 + (i1 << 2) >> 2])));
      HEAPF32[i4 >> 2] = f3;
      if ((i1 | 0) >= (i15 | 0)) break; else {
       i1 = i1 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    }
    break;
   }
  case 2:
   {
    if ((i1 | 0) <= (i15 | 0)) {
     i6 = i17 + (i11 << 2) | 0;
     i4 = i17 + (i11 + 1 << 2) | 0;
     f3 = Math_fround(HEAPF32[i6 >> 2]);
     i2 = 0;
     f5 = Math_fround(HEAPF32[i4 >> 2]);
     while (1) {
      i11 = i1 << 1;
      f8 = Math_fround(HEAPF32[i18 + (i2 + i16 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i21 + (i11 << 2) >> 2])));
      HEAPF32[i6 >> 2] = f3;
      f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i21 + ((i11 | 1) << 2) >> 2])));
      HEAPF32[i4 >> 2] = f5;
      if ((i1 | 0) >= (i15 | 0)) break; else {
       i1 = i1 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    }
    break;
   }
  case 3:
   {
    if ((i1 | 0) <= (i15 | 0)) {
     i6 = i17 + (i11 << 2) | 0;
     i9 = i17 + (i11 + 1 << 2) | 0;
     i4 = i17 + (i11 + 2 << 2) | 0;
     f7 = Math_fround(HEAPF32[i6 >> 2]);
     f3 = Math_fround(HEAPF32[i9 >> 2]);
     i2 = 0;
     f5 = Math_fround(HEAPF32[i4 >> 2]);
     while (1) {
      i11 = i1 * 3 | 0;
      f8 = Math_fround(HEAPF32[i18 + (i2 + i16 << 2) >> 2]);
      f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i21 + (i11 << 2) >> 2])));
      HEAPF32[i6 >> 2] = f7;
      f3 = Math_fround(f3 + Math_fround(f8 * Math_fround(HEAPF32[i21 + (i11 + 1 << 2) >> 2])));
      HEAPF32[i9 >> 2] = f3;
      f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i21 + (i11 + 2 << 2) >> 2])));
      HEAPF32[i4 >> 2] = f5;
      if ((i1 | 0) >= (i15 | 0)) break; else {
       i1 = i1 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    }
    break;
   }
  case 4:
   {
    if ((i1 | 0) <= (i15 | 0)) {
     i6 = i17 + (i11 << 2) | 0;
     i9 = i17 + (i11 + 1 << 2) | 0;
     i10 = i17 + (i11 + 2 << 2) | 0;
     i4 = i17 + (i11 + 3 << 2) | 0;
     f3 = Math_fround(HEAPF32[i6 >> 2]);
     f5 = Math_fround(HEAPF32[i9 >> 2]);
     f7 = Math_fround(HEAPF32[i10 >> 2]);
     i2 = 0;
     f8 = Math_fround(HEAPF32[i4 >> 2]);
     while (1) {
      i11 = i1 << 2;
      f23 = Math_fround(HEAPF32[i18 + (i2 + i16 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f23 * Math_fround(HEAPF32[i21 + (i11 << 2) >> 2])));
      HEAPF32[i6 >> 2] = f3;
      f5 = Math_fround(f5 + Math_fround(f23 * Math_fround(HEAPF32[i21 + ((i11 | 1) << 2) >> 2])));
      HEAPF32[i9 >> 2] = f5;
      f7 = Math_fround(f7 + Math_fround(f23 * Math_fround(HEAPF32[i21 + ((i11 | 2) << 2) >> 2])));
      HEAPF32[i10 >> 2] = f7;
      f8 = Math_fround(f8 + Math_fround(f23 * Math_fround(HEAPF32[i21 + ((i11 | 3) << 2) >> 2])));
      HEAPF32[i4 >> 2] = f8;
      if ((i1 | 0) >= (i15 | 0)) break; else {
       i1 = i1 + 1 | 0;
       i2 = i2 + 1 | 0;
      }
     }
    }
    break;
   }
  default:
   if (!((i1 | 0) > (i15 | 0) | i13)) {
    i6 = 0;
    while (1) {
     i4 = Math_imul(i1, i20) | 0;
     f3 = Math_fround(HEAPF32[i18 + (i6 + i16 << 2) >> 2]);
     i2 = 0;
     do {
      f23 = Math_fround(f3 * Math_fround(HEAPF32[i21 + (i2 + i4 << 2) >> 2]));
      i10 = i17 + (i2 + i11 << 2) | 0;
      HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f23);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i20 | 0));
     if ((i1 | 0) < (i15 | 0)) {
      i6 = i6 + 1 | 0;
      i1 = i1 + 1 | 0;
     } else break;
    }
   }
  }
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i19 | 0));
 return;
}

function __ZN13SplatDatabase12SetAlphamapsEiiiiPf(i19, i20, i23, i26, i27, i28) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i23 = i23 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i34;
 i29 = i34 + 20 | 0;
 i30 = i34 + 16 | 0;
 i31 = i34 + 4 | 0;
 i21 = ((HEAP32[i19 + 4 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0) / 44 | 0;
 HEAP32[i31 >> 2] = 0;
 i22 = i31 + 4 | 0;
 i18 = gb + 63160 | 0;
 i25 = HEAP32[i18 + 4 >> 2] | 0;
 i24 = i22;
 HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i24 + 4 >> 2] = i25;
 i24 = Math_imul(i27, i26) | 0;
 i25 = i24 << 4;
 do if (!i25) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = (i25 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i25, 4, gb + 64016 | 0, 0, gb + 930755 | 0, 601) | 0;
   i18 = gb + 64016 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   HEAP32[i31 >> 2] = i2;
   i1 = i22;
   HEAP32[i1 >> 2] = i17;
   HEAP32[i1 + 4 >> 2] = i18;
   i1 = i2;
   break;
  }
 } while (0);
 i1 = i1 + 3 & -4;
 i16 = i1;
 i17 = i19 + 12 | 0;
 i15 = (HEAP32[i19 + 16 >> 2] | 0) - (HEAP32[i17 >> 2] | 0) | 0;
 i18 = i15 >> 2;
 if ((i15 | 0) <= 0) {
  i33 = i2;
  i32 = i19 + 50 | 0;
  HEAP8[i32 >> 0] = 1;
  __Z19free_alloc_internalPvRK10MemLabelId(i33, i22);
  STACKTOP = i34;
  return;
 }
 i12 = (i27 | 0) > 0;
 i13 = (i26 | 0) > 0;
 i14 = i19 + 32 | 0;
 i15 = i29 + 11 | 0;
 i11 = 0;
 do {
  _memset(i1 | 0, 0, i25 | 0) | 0;
  i10 = i11 << 2;
  i2 = i21 - i10 | 0;
  i9 = (i2 | 0) > 4 ? 4 : i2;
  if (i12) {
   i5 = (i2 | 0) > 0;
   if (i13) {
    i4 = 0;
    do {
     i6 = Math_imul(i4, i26) | 0;
     if (i5) {
      i3 = 0;
      do {
       i8 = i3 + i6 | 0;
       i7 = i16 + (i8 << 4) | 0;
       i8 = (Math_imul(i8, i21) | 0) + i10 | 0;
       i2 = 0;
       do {
        HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[i28 + (i8 + i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i9 | 0));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i26 | 0));
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i27 | 0));
   }
  }
  i5 = (HEAP32[i17 >> 2] | 0) + (i11 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (!i2) i33 = 25; else {
   HEAP32[i30 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i33 = 22; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i29, i2, i30);
     i3 = HEAP32[i29 >> 2] | 0;
     i10 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i33 = 22; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i33 = 24;
    }
   }
   if ((i33 | 0) == 22) i33 = 24;
   if ((i33 | 0) == 24) {
    i33 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) {
     i33 = 25;
     break;
    }
   }
   __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii(i2, i20, i23, i26, i27, i24, i16, 0, 0);
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0, i2 | 0);
  } while (0);
  if ((i33 | 0) == 25) {
   i33 = 0;
   HEAP32[i32 >> 2] = i11;
   __Z6FormatPKcz(i29, gb + 930934 | 0, i32);
   i2 = HEAP32[i14 >> 2] | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i29 >> 2] | 0 : i29, 0, gb + 930755 | 0, 622, 1, i2, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i29);
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) < (i18 | 0));
 i33 = HEAP32[i31 >> 2] | 0;
 i32 = i19 + 50 | 0;
 HEAP8[i32 >> 0] = 1;
 __Z19free_alloc_internalPvRK10MemLabelId(i33, i22);
 STACKTOP = i34;
 return;
}

function __ZN13AnimationClip9PPtrCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i7 = i3 + 24 | 0;
 i6 = i3 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 40 | 0, 0);
 HEAP32[i6 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899355 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i6 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034365 | 0, HEAP32[gb + 37176 >> 2] | 0, i6, 0);
 i11 = i9 + 8 | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i11, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898367 | 0, i11, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 i10 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898362 | 0, i11, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898384 | 0, i8, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898377 | 0, gb + 899338 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN8VRDevice21SetStereoRenderTargetEP6Camera15StereoscopicEye16SinglePassStereo(i14, i15, i9, i10) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 16 | 0;
 i16 = i17;
 if (!(mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 if ((HEAP16[gb + 1469336 + 6 >> 1] | 0) > -1) {
  HEAP32[i16 >> 2] = i15;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469336 | 0, i12);
  i13 = gb + 1469336 | 0;
 } else i13 = 0;
 i7 = i14 + 330 | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i8 = i14 + 312 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i12);
   i2 = gb + 1469204 | 0;
  } else i2 = 0;
  i6 = i14 + 204 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4 | 0) mftCall_vii(i4 | 0, 3, i3 | 0);
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  i4 = i14 + 320 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i12);
   i3 = gb + 1469204 | 0;
  } else i3 = 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) mftCall_vii(i2 | 0, 4, i5 | 0);
  if (i3 | 0) __Z12profiler_endP19ProfilerInformation(i3);
  i6 = __Z12GetGfxDevicev() | 0;
  __ZN9GfxDevice17SendVRDeviceEventEjf(i6, 7, Math_fround(HEAPF32[i8 >> 2]));
  i8 = __Z12GetGfxDevicev() | 0;
  mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 860 >> 2] | 0, i8 | 0, 8, HEAP32[i4 >> 2] | 0);
  HEAP8[i7 >> 0] = 0;
 }
 HEAP32[i14 + 316 >> 2] = i9;
 i2 = __Z12GetGfxDevicev() | 0;
 __ZN9GfxDevice18SetStereoActiveEyeE15StereoscopicEye(i2, i9);
 if ((i15 | 0) != 0 & (HEAP32[i14 + 132 >> 2] | 0) > 0) __ZN6Camera16SetTargetTextureEP13RenderTexture(i15, __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye(HEAP32[i14 + 288 >> 2] | 0, i9) | 0); else if (HEAP8[(HEAP32[i14 + 4 >> 2] | 0) + 262 >> 0] | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 852 >> 2] | 0, i2 | 0, i9 | 0);
 i2 = i15 + 864 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = HEAP32[i14 + 288 >> 2] | 0;
 if (!i2) i11 = 25; else if (!((__ZNK19VREyeTextureManager21GetUnityTextureFormatEv(i2) | 0) & 2)) i11 = 25; else {
  i16 = (i10 | 0) == 1;
  f20 = i16 ? Math_fround(1.0) : Math_fround(.5);
  f18 = Math_fround(Math_fround(i9 | 0) * Math_fround(.5));
  f18 = i16 ? Math_fround(0.0) : f18;
  f19 = Math_fround(HEAPF32[i14 + 312 >> 2]);
  f20 = Math_fround(f20 * f19);
  f1 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * f20);
  i16 = i12 + 8 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i16 >> 2]));
  i16 = i12 + 4 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f19 * Math_fround(HEAPF32[i16 >> 2]));
  i16 = i12 + 12 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f19 * Math_fround(HEAPF32[i16 >> 2]));
  HEAPF32[i12 >> 2] = Math_fround(f18 + f1);
  __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i15, i12);
 }
 do if ((i11 | 0) == 25) {
  f1 = Math_fround(HEAPF32[i14 + 312 >> 2]);
  if (!(HEAP8[i14 + 170 >> 0] | 0)) {
   HEAPF32[i12 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i12 >> 2]));
   i16 = i12 + 8 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i16 >> 2]));
   i16 = i12 + 4 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i16 >> 2]));
   i16 = i12 + 12 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i16 >> 2]));
   __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i15, i12);
   break;
  } else {
   i12 = HEAP32[i14 + 84 >> 2] | 0;
   f19 = Math_fround(Math_fround(HEAPF32[i14 + 88 >> 2]) * f1);
   f20 = Math_fround(f1 * Math_fround(HEAPF32[i14 + 92 >> 2]));
   HEAP32[i16 >> 2] = HEAP32[i14 + 80 >> 2];
   HEAPF32[i16 + 8 >> 2] = f19;
   HEAP32[i16 + 4 >> 2] = i12;
   HEAPF32[i16 + 12 >> 2] = f20;
   __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i15, i16);
   break;
  }
 } while (0);
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i7, i9, i3, i5, i19, i16, i18, i14, f2, i4) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 96 | 0;
 i17 = i24 + 80 | 0;
 i1 = i24 + 64 | 0;
 i23 = i24 + 136 | 0;
 i15 = i24 + 48 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 16 | 0;
 i20 = i24;
 i8 = i24 + 156 | 0;
 i10 = i24 + 152 | 0;
 i21 = i24 + 148 | 0;
 i22 = i24 + 124 | 0;
 i6 = i24 + 112 | 0;
 if (!(__ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i7, i9, i3, i5, i19, i1, i17, i11, f2) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) | i4 ^ 1)) {
  f2 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(100.0));
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i1 = i20 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP8[i21 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i7, i9, i15, i12, i13, i17, i20, i8, i10, i21, 0) | 0) {
  case 1:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i22 >> 2] = gb + 85340 + 8;
    HEAP32[i22 + 4 >> 2] = i7;
    HEAP32[i22 + 8 >> 2] = i9;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i7, i9, i22, i8, i10, HEAP8[i21 >> 0] | 0, i12, i13, i17, i20, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break L6;
    } else {
     f27 = Math_fround(HEAPF32[i19 >> 2]);
     f25 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f2 * f2)))));
     f25 = Math_fround(-Math_fround(f25 * f26));
     f2 = Math_fround(-Math_fround(f2 * f26));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f27 * f26));
     HEAPF32[i17 + 4 >> 2] = f25;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   }
  } while (0);
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i23 = f27 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i23 ? f27 : Math_fround(0.0);
  i23 = i16 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 };
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 76 | 0;
 i8 = i11;
 i9 = i6 + 60 | 0;
 i5 = i6 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i10 = i6 + 64 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i6 + 72 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i6 + 56 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i6 + 72 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i17 = i8 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i8 + 8 | 0;
 i19 = i6 + 8 | 0;
 i14 = HEAP16[i19 >> 1] | 0;
 HEAP8[i18 >> 0] = i14;
 i16 = i8 + 9 | 0;
 HEAP8[i16 >> 0] = (i14 & 65535) >>> 8;
 i14 = i8 + 12 | 0;
 i15 = i6 + 12 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 i12 = i8 + 32 | 0;
 i13 = i6 + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 i2 = i8 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i8, i6, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i1;
 i1 = HEAP8[i19 >> 0] | 0;
 i17 = HEAP16[i18 >> 1] | 0;
 HEAP8[i19 >> 0] = i17;
 HEAP8[i18 >> 0] = i1;
 i1 = i6 + 9 | 0;
 i5 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i17 & 65535) >>> 8;
 HEAP8[i16 >> 0] = i5;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 i5 = i6 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 i2 = i8 + 56 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 i7 = i8 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i2;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i6 + 68 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 + 72 >> 0] = 0;
 f3 = Math_fround(i5 >>> 0);
 HEAP32[i8 + 68 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i8 + 64 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i8 + 72 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 i19 = i6 + 72 | 0;
 HEAP8[i19 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIccEEPcEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -1 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    switch (i3 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 31) {
     i15 = 11;
     break L1;
    }
    i7 = i1 + (i3 >>> 1) | 0;
    if ((i3 | 0) > 999) {
     i3 = i3 >>> 2;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_(i1, i1 + i3 | 0, i7, i7 + i3 | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i1, i7, i14, i13) | 0;
    i8 = HEAP8[i1 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if (i8 << 24 >> 24 < i5 << 24 >> 24) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -1 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP8[i4 >> 0] | 0;
     if (i6 << 24 >> 24 < i5 << 24 >> 24) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 1 | 0;
    i5 = HEAP8[i14 >> 0] | 0;
    if (i8 << 24 >> 24 >= i5 << 24 >> 24) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP8[i3 >> 0] | 0;
      if (i8 << 24 >> 24 < i4 << 24 >> 24) break;
      i3 = i3 + 1 | 0;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i14 >> 0] = i4;
     i3 = i3 + 1 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP8[i1 >> 0] | 0;
     while (1) {
      i6 = HEAP8[i3 >> 0] | 0;
      i7 = i3 + 1 | 0;
      if (i8 << 24 >> 24 < i6 << 24 >> 24) break; else i3 = i7;
     }
     do {
      i4 = i4 + -1 | 0;
      i5 = HEAP8[i4 >> 0] | 0;
     } while (i8 << 24 >> 24 < i5 << 24 >> 24);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i4 >> 0] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP8[i1 >> 0] = i6;
    HEAP8[i4 >> 0] = i8;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 1 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i7;
    while (1) {
     i9 = HEAP8[i10 >> 0] | 0;
     while (1) {
      i7 = HEAP8[i5 >> 0] | 0;
      i8 = i5 + 1 | 0;
      if (i7 << 24 >> 24 < i9 << 24 >> 24) i5 = i8; else break;
     }
     do {
      i4 = i4 + -1 | 0;
      i6 = HEAP8[i4 >> 0] | 0;
     } while (i6 << 24 >> 24 >= i9 << 24 >> 24);
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP8[i5 >> 0] = i6;
     HEAP8[i4 >> 0] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i7;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP8[i6 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if (i4 << 24 >> 24 < i5 << 24 >> 24) {
     HEAP8[i7 >> 0] = i4;
     HEAP8[i6 >> 0] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIccEEPcEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 1 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIccEEPcEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIccEEPcEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 1 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIccEEPcEEvT0_S5_T_(i7 + 1 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP8[i14 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i1 >> 0] = i2;
   HEAP8[i14 >> 0] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i1, i1 + 1 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i1 + 3 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIccEEPcEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIaaEEPaEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -1 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    switch (i3 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 31) {
     i15 = 11;
     break L1;
    }
    i7 = i1 + (i3 >>> 1) | 0;
    if ((i3 | 0) > 999) {
     i3 = i3 >>> 2;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_(i1, i1 + i3 | 0, i7, i7 + i3 | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i1, i7, i14, i13) | 0;
    i8 = HEAP8[i1 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if (i8 << 24 >> 24 < i5 << 24 >> 24) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -1 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP8[i4 >> 0] | 0;
     if (i6 << 24 >> 24 < i5 << 24 >> 24) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 1 | 0;
    i5 = HEAP8[i14 >> 0] | 0;
    if (i8 << 24 >> 24 >= i5 << 24 >> 24) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP8[i3 >> 0] | 0;
      if (i8 << 24 >> 24 < i4 << 24 >> 24) break;
      i3 = i3 + 1 | 0;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i14 >> 0] = i4;
     i3 = i3 + 1 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP8[i1 >> 0] | 0;
     while (1) {
      i6 = HEAP8[i3 >> 0] | 0;
      i7 = i3 + 1 | 0;
      if (i8 << 24 >> 24 < i6 << 24 >> 24) break; else i3 = i7;
     }
     do {
      i4 = i4 + -1 | 0;
      i5 = HEAP8[i4 >> 0] | 0;
     } while (i8 << 24 >> 24 < i5 << 24 >> 24);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i4 >> 0] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP8[i1 >> 0] = i6;
    HEAP8[i4 >> 0] = i8;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 1 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i7;
    while (1) {
     i9 = HEAP8[i10 >> 0] | 0;
     while (1) {
      i7 = HEAP8[i5 >> 0] | 0;
      i8 = i5 + 1 | 0;
      if (i7 << 24 >> 24 < i9 << 24 >> 24) i5 = i8; else break;
     }
     do {
      i4 = i4 + -1 | 0;
      i6 = HEAP8[i4 >> 0] | 0;
     } while (i6 << 24 >> 24 >= i9 << 24 >> 24);
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP8[i5 >> 0] = i6;
     HEAP8[i4 >> 0] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i7;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP8[i6 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if (i4 << 24 >> 24 < i5 << 24 >> 24) {
     HEAP8[i7 >> 0] = i4;
     HEAP8[i6 >> 0] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIaaEEPaEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 1 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIaaEEPaEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIaaEEPaEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 1 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIaaEEPaEEvT0_S5_T_(i7 + 1 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP8[i14 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i1 >> 0] = i2;
   HEAP8[i14 >> 0] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i1, i1 + 1 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i1 + 3 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIaaEEPaEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNK15dtProximityGrid10queryItemsEPKfPti(i8, i1, i25, i27) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0;
 i19 = HEAP32[i8 + 28 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i1 >> 2]);
 f30 = Math_fround(HEAPF32[i8 >> 2]);
 i24 = ~~Math_fround(Math_floor(Math_fround(f31 * f30)));
 i24 = (i19 | 0) > (i24 | 0) ? i19 : i24;
 i19 = HEAP32[i8 + 32 >> 2] | 0;
 f31 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 i26 = ~~Math_fround(Math_floor(Math_fround(f31 * f29)));
 i26 = (i19 | 0) > (i26 | 0) ? i19 : i26;
 i19 = HEAP32[i8 + 36 >> 2] | 0;
 i28 = ~~Math_fround(Math_floor(Math_fround(f30 * Math_fround(HEAPF32[i1 + 8 >> 2]))));
 i28 = (i19 | 0) < (i28 | 0) ? i19 : i28;
 i19 = HEAP32[i8 + 40 >> 2] | 0;
 i21 = ~~Math_fround(Math_floor(Math_fround(f29 * Math_fround(HEAPF32[i1 + 12 >> 2]))));
 i21 = (i19 | 0) < (i21 | 0) ? i19 : i21;
 if ((i28 | 0) == (i24 | 0) & (i21 | 0) == (i26 | 0)) {
  i4 = i24 << 16 >> 16;
  i5 = i26 << 16 >> 16;
  i2 = (HEAP32[i8 + 24 >> 2] | 0) + -1 & ((Math_imul(i5, 19349663) | 0) ^ (Math_imul(i4, 73856093) | 0));
  i6 = i8 + 8 | 0;
  i1 = 0;
  i2 = HEAP16[(HEAP32[i8 + 20 >> 2] | 0) + (i2 << 1) >> 1] | 0;
  L3 : while (1) {
   if (i2 << 16 >> 16 == -1) {
    i20 = 34;
    break;
   }
   i7 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i3 = i2 & 65535;
    i2 = HEAP16[i7 + (i3 << 3) + 2 >> 1] | 0;
    if ((HEAP16[i7 + (i3 << 3) + 4 >> 1] | 0) == (i4 | 0)) if ((HEAP16[i7 + (i3 << 3) + 6 >> 1] | 0) == (i5 | 0)) break;
    if (i2 << 16 >> 16 == -1) {
     i20 = 34;
     break L3;
    }
   }
   HEAP16[i25 + (i1 << 1) >> 1] = HEAP16[i7 + (i3 << 3) >> 1] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i27 | 0)) {
    i1 = i27;
    i20 = 34;
    break;
   }
  }
  if ((i20 | 0) == 34) return i1 | 0;
 }
 i15 = (i28 + i24 | 0) / 2 | 0;
 i16 = (i21 + i26 | 0) / 2 | 0;
 i18 = 1 - i24 + i28 | 1;
 i17 = 1 - i26 + i21 | 1;
 i17 = (i18 | 0) > (i17 | 0) ? i18 : i17;
 i17 = Math_imul(i17, i17) | 0;
 i18 = i8 + 24 | 0;
 i19 = i8 + 20 | 0;
 i14 = i8 + 8 | 0;
 i9 = 0;
 i10 = 0;
 i11 = 0;
 i12 = 0;
 i13 = -1;
 i1 = 0;
 L17 : while (1) {
  i7 = i9 + i15 | 0;
  i8 = i10 + i16 | 0;
  L19 : do if (!((i8 | 0) > (i21 | 0) | ((i8 | 0) < (i26 | 0) | ((i7 | 0) < (i24 | 0) | (i7 | 0) > (i28 | 0))))) {
   i2 = (HEAP32[i18 >> 2] | 0) + -1 & ((Math_imul(i7, 73856093) | 0) ^ (Math_imul(i8, 19349663) | 0));
   i2 = HEAP16[(HEAP32[i19 >> 2] | 0) + (i2 << 1) >> 1] | 0;
   if ((i1 | 0) > 0) i5 = i1; else {
    i5 = (i1 | 0) != 0;
    while (1) {
     if (i2 << 16 >> 16 == -1) break L19;
     i4 = HEAP32[i14 >> 2] | 0;
     while (1) {
      i3 = i2 & 65535;
      i2 = HEAP16[i4 + (i3 << 3) + 2 >> 1] | 0;
      if ((HEAP16[i4 + (i3 << 3) + 4 >> 1] | 0) == (i7 | 0)) if (!((HEAP16[i4 + (i3 << 3) + 6 >> 1] | 0) != (i8 | 0) | i5)) break;
      if (i2 << 16 >> 16 == -1) break L19;
     }
     HEAP16[i25 + (i1 << 1) >> 1] = HEAP16[i4 + (i3 << 3) >> 1] | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i27 | 0)) {
      i1 = i27;
      i20 = 34;
      break L17;
     }
    }
   }
   while (1) {
    if (i2 << 16 >> 16 == -1) {
     i1 = i5;
     break L19;
    }
    i6 = HEAP32[i14 >> 2] | 0;
    while (1) {
     i3 = i2 & 65535;
     i2 = HEAP16[i6 + (i3 << 3) + 2 >> 1] | 0;
     if ((HEAP16[i6 + (i3 << 3) + 4 >> 1] | 0) == (i7 | 0)) if ((HEAP16[i6 + (i3 << 3) + 6 >> 1] | 0) == (i8 | 0)) {
      i4 = HEAP16[i6 + (i3 << 3) >> 1] | 0;
      i3 = 0;
      do {
       if ((HEAP16[i25 + (i3 << 1) >> 1] | 0) == i4 << 16 >> 16) break;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (i1 | 0));
      if ((i3 | 0) == (i1 | 0)) break;
     }
     if (i2 << 16 >> 16 == -1) {
      i1 = i5;
      break L19;
     }
    }
    HEAP16[i25 + (i5 << 1) >> 1] = i4;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i27 | 0)) {
     i1 = i27;
     i20 = 34;
     break L17;
    }
   }
  } while (0);
  if ((i9 | 0) == (i10 | 0)) i20 = 32; else if ((i9 | 0) < 0 & (i9 | 0) == (0 - i10 | 0)) i20 = 32; else if ((i9 | 0) > 0 & (i9 | 0) == (1 - i10 | 0)) i20 = 32; else {
   i22 = i11;
   i23 = i13;
  }
  if ((i20 | 0) == 32) {
   i20 = 0;
   i22 = 0 - i13 | 0;
   i23 = i11;
  }
  i12 = i12 + 1 | 0;
  if ((i12 | 0) >= (i17 | 0)) {
   i20 = 34;
   break;
  } else {
   i9 = i22 + i9 | 0;
   i10 = i23 + i10 | 0;
   i11 = i22;
   i13 = i23;
  }
 }
 if ((i20 | 0) == 34) return i1 | 0;
 return 0;
}

function __ZN5physx2Gu24pcmContactBoxHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i8 + 320 | 0;
 i10 = i8 + 688 | 0;
 i9 = i8 + 616 | 0;
 i11 = i8 + 144 | 0;
 i14 = i8 + 160 | 0;
 i16 = i8 + 64 | 0;
 i17 = i8 + 392 | 0;
 i15 = i8 + 96 | 0;
 i12 = i8;
 i1 = HEAP32[i1 >> 2] & -16;
 i18 = i4 + 4 | 0;
 f26 = Math_fround(HEAPF32[i3 >> 2]);
 f31 = Math_fround(f26 + Math_fround(HEAPF32[i18 >> 2]));
 i28 = i4 + 8 | 0;
 f25 = Math_fround(f26 + Math_fround(HEAPF32[i28 >> 2]));
 f27 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f26 = Math_fround(f26 + f27);
 f33 = Math_fround(-f25);
 f32 = Math_fround(-f26);
 HEAPF32[i10 >> 2] = Math_fround(-f31);
 HEAPF32[i10 + 4 >> 2] = f33;
 HEAPF32[i10 + 8 >> 2] = f32;
 HEAPF32[i10 + 12 >> 2] = f31;
 HEAPF32[i10 + 16 >> 2] = f25;
 HEAPF32[i10 + 20 >> 2] = f26;
 HEAP32[i9 >> 2] = 1065353216;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 1065353216;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 1065353216;
 HEAP32[i9 + 36 >> 2] = 1065353216;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 1065353216;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 68 >> 2] = 1065353216;
 i24 = HEAP32[i6 >> 2] | 0;
 i23 = HEAP32[i6 + 4 >> 2] | 0;
 i22 = HEAP32[i6 + 8 >> 2] | 0;
 i21 = HEAP32[i6 + 12 >> 2] | 0;
 i4 = i6 + 16 | 0;
 i20 = HEAP32[i4 >> 2] | 0;
 i19 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 i29 = HEAP32[i18 >> 2] | 0;
 i28 = HEAP32[i28 >> 2] | 0;
 f26 = (HEAP32[tempDoublePtr >> 2] = i29, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = f26 <= f25 ? f26 : f25;
 f25 = f25 <= f27 ? f25 : f27;
 f26 = Math_fround(f25 * Math_fround(.150000006));
 HEAPF32[i11 >> 2] = f26;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i30 = i14 + 64 | 0;
 HEAP32[i14 + 80 >> 2] = 3;
 HEAPF32[i14 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i30 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i30 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i14 + 144 >> 2] = i29;
 HEAP32[i14 + 148 >> 2] = i28;
 HEAPF32[i14 + 152 >> 2] = f27;
 HEAPF32[i14 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 16 >> 2] = f26;
 HEAPF32[i14 + 32 >> 2] = Math_fround(f25 * Math_fround(.0500000007));
 HEAP32[i16 >> 2] = i24;
 HEAP32[i16 + 4 >> 2] = i23;
 HEAP32[i16 + 8 >> 2] = i22;
 HEAP32[i16 + 12 >> 2] = i21;
 HEAP32[i16 + 16 >> 2] = i20;
 HEAP32[i16 + 20 >> 2] = i19;
 HEAP32[i16 + 24 >> 2] = i4;
 HEAPF32[i16 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i17, i18);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i17, i13);
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i4 = i15 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i15 + 20 >> 2] = Math_fround(1.0);
 i4 = i15 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i15 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i15 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 32 >> 2] = i16;
 HEAP32[i12 + 36 >> 2] = i15;
 HEAP32[i12 + 40 >> 2] = i15;
 HEAP8[i12 + 44 >> 0] = 1;
 HEAP32[i12 >> 2] = gb + 147004 + 8;
 HEAP32[i12 + 48 >> 2] = i14;
 HEAP32[i12 + 52 >> 2] = i14;
 i7 = __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE(i13, i12, i11, i10, i5, i6, i7, Math_fround(HEAPF32[i3 >> 2]), i2, i9, 1, i1) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z15GetLODGroupAABBR10MinMaxAABBRK8LODGroup(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, i30 = 0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 216 | 0;
 i21 = i26 + 152 | 0;
 i22 = i26 + 88 | 0;
 i23 = i26 + 24 | 0;
 i24 = i26;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i18 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f29 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f28 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f27 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i15 = i18 + 12 | 0;
 HEAPF32[i15 >> 2] = f29;
 i16 = i18 + 16 | 0;
 HEAPF32[i16 >> 2] = f28;
 i17 = i18 + 20 | 0;
 HEAPF32[i17 >> 2] = f27;
 i19 = i1 + 60 | 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (((HEAP32[i19 >> 2] | 0) - i2 | 0) <= 0) {
  STACKTOP = i26;
  return;
 }
 i7 = i1 + 56 | 0;
 i8 = i24 + 12 | 0;
 i9 = i24 + 4 | 0;
 i10 = i24 + 16 | 0;
 i11 = i24 + 8 | 0;
 i12 = i24 + 20 | 0;
 i13 = i18 + 4 | 0;
 i14 = i18 + 8 | 0;
 i6 = 0;
 i1 = i2;
 do {
  i2 = i1;
  if (HEAP32[i2 + (i6 * 28 | 0) + 20 >> 2] | 0) {
   i5 = 0;
   i1 = i2;
   do {
    i4 = (HEAP32[i1 + (i6 * 28 | 0) + 8 >> 2] | 0) + (i5 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    do if (i1 | 0) {
     HEAP32[i21 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i25 = 13; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i21);
       i2 = HEAP32[i20 >> 2] | 0;
       i30 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i30 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i30 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i25 = 13; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i25 = 15;
      }
     }
     if ((i25 | 0) == 13) i25 = 15;
     if ((i25 | 0) == 15) {
      i25 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
      if (!i1) break;
     }
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     if (i2 | 0) if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i2, i20) | 0) {
      __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(__ZN8Renderer12GetTransformEv(i1) | 0, i23);
      __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i22, i23, i21);
      __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i20, i21, i24);
      f29 = Math_fround(HEAPF32[i24 >> 2]);
      f33 = Math_fround(HEAPF32[i8 >> 2]);
      f39 = Math_fround(f29 - f33);
      f27 = Math_fround(HEAPF32[i9 >> 2]);
      f31 = Math_fround(HEAPF32[i10 >> 2]);
      f37 = Math_fround(f27 - f31);
      f32 = Math_fround(HEAPF32[i11 >> 2]);
      f28 = Math_fround(HEAPF32[i12 >> 2]);
      f35 = Math_fround(f32 - f28);
      f38 = Math_fround(HEAPF32[i18 >> 2]);
      f36 = Math_fround(HEAPF32[i13 >> 2]);
      f34 = Math_fround(HEAPF32[i14 >> 2]);
      HEAPF32[i18 >> 2] = f39 < f38 ? f39 : f38;
      HEAPF32[i13 >> 2] = f37 < f36 ? f37 : f36;
      HEAPF32[i14 >> 2] = f35 < f34 ? f35 : f34;
      f33 = Math_fround(f29 + f33);
      f31 = Math_fround(f27 + f31);
      f28 = Math_fround(f32 + f28);
      f32 = Math_fround(HEAPF32[i15 >> 2]);
      f27 = Math_fround(HEAPF32[i16 >> 2]);
      f29 = Math_fround(HEAPF32[i17 >> 2]);
      HEAPF32[i15 >> 2] = f32 < f33 ? f33 : f32;
      HEAPF32[i16 >> 2] = f27 < f31 ? f31 : f27;
      HEAPF32[i17 >> 2] = f29 < f28 ? f28 : f29;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   } while (i5 >>> 0 < (HEAP32[i1 + (i6 * 28 | 0) + 20 >> 2] | 0) >>> 0);
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (((HEAP32[i19 >> 2] | 0) - i1 | 0) / 28 | 0 | 0));
 STACKTOP = i26;
 return;
}

function _XXH32(i2, i11, i3) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = i2 + i11 | 0;
 i1 = i11 >>> 0 > 15;
 if (!(i2 & 3)) {
  if (i1) {
   i10 = i12 + -16 | 0;
   i7 = i3 + 1640531535 | 0;
   i8 = i3;
   i9 = i3 + -2048144777 | 0;
   i6 = i3 + 606290984 | 0;
   do {
    i1 = (Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, -2048144777) | 0) + i6 | 0;
    i1 = i1 << 13 | i1 >>> 19;
    i6 = Math_imul(i1, -1640531535) | 0;
    i3 = i2 + 4 | 0;
    i3 = (Math_imul(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24, -2048144777) | 0) + i9 | 0;
    i3 = i3 << 13 | i3 >>> 19;
    i9 = Math_imul(i3, -1640531535) | 0;
    i4 = i2 + 8 | 0;
    i4 = (Math_imul(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24, -2048144777) | 0) + i8 | 0;
    i4 = i4 << 13 | i4 >>> 19;
    i8 = Math_imul(i4, -1640531535) | 0;
    i5 = i2 + 12 | 0;
    i5 = (Math_imul(HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24, -2048144777) | 0) + i7 | 0;
    i5 = i5 << 13 | i5 >>> 19;
    i7 = Math_imul(i5, -1640531535) | 0;
    i2 = i2 + 16 | 0;
   } while (i2 >>> 0 <= i10 >>> 0);
   i1 = (i9 >>> 25 | (Math_imul(i3, 465361024) | 0)) + (i6 >>> 31 | (Math_imul(i1, 1013904226) | 0)) + (i8 >>> 20 | (Math_imul(i4, 2006650880) | 0)) + (i7 >>> 14 | (Math_imul(i5, -423362560) | 0)) | 0;
  } else i1 = i3 + 374761393 | 0;
  i1 = i1 + i11 | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 <= i12 >>> 0) while (1) {
   i1 = (Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, -1028477379) | 0) + i1 | 0;
   i1 = Math_imul(i1 << 17 | i1 >>> 15, 668265263) | 0;
   i2 = i3 + 4 | 0;
   if (i2 >>> 0 > i12 >>> 0) {
    i2 = i3;
    break;
   } else {
    i11 = i3;
    i3 = i2;
    i2 = i11;
   }
  }
  if (i2 >>> 0 < i12 >>> 0) do {
   i1 = (Math_imul(HEAPU8[i2 >> 0] | 0, 374761393) | 0) + i1 | 0;
   i1 = Math_imul(i1 << 11 | i1 >>> 21, -1640531535) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  i12 = Math_imul(i1 >>> 15 ^ i1, -2048144777) | 0;
  i12 = Math_imul(i12 >>> 13 ^ i12, -1028477379) | 0;
  i12 = i12 >>> 16 ^ i12;
  return i12 | 0;
 } else {
  if (i1) {
   i10 = i12 + -16 | 0;
   i7 = i3 + 1640531535 | 0;
   i8 = i3;
   i9 = i3 + -2048144777 | 0;
   i6 = i3 + 606290984 | 0;
   do {
    i5 = (Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, -2048144777) | 0) + i6 | 0;
    i5 = i5 << 13 | i5 >>> 19;
    i6 = Math_imul(i5, -1640531535) | 0;
    i1 = i2 + 4 | 0;
    i1 = (Math_imul(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24, -2048144777) | 0) + i9 | 0;
    i1 = i1 << 13 | i1 >>> 19;
    i9 = Math_imul(i1, -1640531535) | 0;
    i3 = i2 + 8 | 0;
    i3 = (Math_imul(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24, -2048144777) | 0) + i8 | 0;
    i3 = i3 << 13 | i3 >>> 19;
    i8 = Math_imul(i3, -1640531535) | 0;
    i4 = i2 + 12 | 0;
    i4 = (Math_imul(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24, -2048144777) | 0) + i7 | 0;
    i4 = i4 << 13 | i4 >>> 19;
    i7 = Math_imul(i4, -1640531535) | 0;
    i2 = i2 + 16 | 0;
   } while (i2 >>> 0 <= i10 >>> 0);
   i1 = (i9 >>> 25 | (Math_imul(i1, 465361024) | 0)) + (i6 >>> 31 | (Math_imul(i5, 1013904226) | 0)) + (i8 >>> 20 | (Math_imul(i3, 2006650880) | 0)) + (i7 >>> 14 | (Math_imul(i4, -423362560) | 0)) | 0;
  } else i1 = i3 + 374761393 | 0;
  i1 = i1 + i11 | 0;
  i4 = i2 + 4 | 0;
  if (i4 >>> 0 <= i12 >>> 0) {
   i3 = i2;
   i2 = i4;
   while (1) {
    i1 = (Math_imul(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24, -1028477379) | 0) + i1 | 0;
    i1 = Math_imul(i1 << 17 | i1 >>> 15, 668265263) | 0;
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > i12 >>> 0) break; else {
     i11 = i2;
     i2 = i3;
     i3 = i11;
    }
   }
  }
  if (i2 >>> 0 < i12 >>> 0) do {
   i1 = (Math_imul(HEAPU8[i2 >> 0] | 0, 374761393) | 0) + i1 | 0;
   i1 = Math_imul(i1 << 11 | i1 >>> 21, -1640531535) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  i12 = Math_imul(i1 >>> 15 ^ i1, -2048144777) | 0;
  i12 = Math_imul(i12 >>> 13 ^ i12, -1028477379) | 0;
  i12 = i12 >>> 16 ^ i12;
  return i12 | 0;
 }
 return 0;
}

function __ZN8Collider19CreateShapeInternalERN5physx10PxGeometryEPNS0_12PxRigidActorEib(i11, i7, i10, i9, i15) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i5 = i17 + 16 | 0;
 i6 = i17 + 57 | 0;
 i14 = i17;
 i12 = i17 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 do if (!i4) i8 = 11; else {
  HEAP32[i13 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i13);
    i2 = HEAP32[i16 >> 2] | 0;
    i18 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 9;
   }
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) {
    i8 = 11;
    break;
   }
  }
  HEAP32[i5 >> 2] = HEAP32[i1 + 52 >> 2];
 } while (0);
 if ((i8 | 0) == 11) {
  i18 = __Z14GetDynamicsSDKv() | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 152 >> 2] | 0, i18 | 0, i5 | 0, 1, 0) | 0;
 }
 i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 92 >> 2] | 0;
 HEAP8[i6 >> 0] = 11;
 i1 = mftCall_iiiiii(i1 | 0, i10 | 0, i7 | 0, i5 | 0, 1, i6 | 0) | 0;
 i5 = i11 + 36 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i1 + 8 >> 2] = i11;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 if (!(HEAP8[i11 + 40 >> 0] | 0)) {
  if ((HEAP16[i10 + 4 >> 1] | 0) == 5) {
   i18 = (HEAP32[i7 >> 2] | 0) + -5 | 0;
   if (i18 >>> 0 > 1 | ((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 200 >> 2] | 0, i10 | 0) | 0) & 1) != 0) i8 = 17; else i1 = i1 & -2;
  } else i8 = 17;
  if ((i8 | 0) == 17) i1 = (i1 & 255 | 1) & 255;
  i3 = (i1 & 255 | 2) & 255 & -5;
 } else i3 = (i1 & -8 & 255 | 6) & 255;
 i4 = i11;
 HEAP32[i13 + 4 >> 2] = i4;
 HEAP32[i13 + 12 >> 2] = 0;
 switch (i9 | 0) {
 case 1:
  {
   i1 = i13 + 8 | 0;
   HEAP32[i1 >> 2] = 4;
   i2 = 4;
   break;
  }
 case 2:
  {
   i1 = i13 + 8 | 0;
   HEAP32[i1 >> 2] = 12;
   i2 = 12;
   break;
  }
 case 0:
  {
   i1 = i13 + 8 | 0;
   HEAP32[i1 >> 2] = 0;
   i2 = 0;
   break;
  }
 default:
  {
   i1 = i13 + 8 | 0;
   HEAP32[i1 >> 2] = 0;
   i2 = 0;
  }
 }
 i2 = ((HEAP16[i10 + 4 >> 1] | 0) != 5 ? 1 : 2) | i2;
 HEAP32[i1 >> 2] = i15 ? i2 | 16 : i2;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 i2 = HEAP32[i11 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 60 >> 2] | 0;
 i1 = i1 | HEAP32[i2 + 60 >> 2];
 if (!(i1 & 1)) i1 = (i1 & 3 | 0) == 0 ? 0 : 136192; else i1 = 138240;
 i1 = HEAP32[i2 + 48 >> 2] | i1;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i4;
 HEAP32[i14 + 12 >> 2] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i13 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i14 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0;
 HEAP8[i12 >> 0] = i3;
 mftCall_vii(i18 | 0, i1 | 0, i12 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 0.0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i11 + 56 >> 2]));
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i16 | 0, i1 | 0);
 i18 = i16 + 8 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = i15 ? i14 | 16 : i14 & -17;
 i18 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 76 >> 2] | 0, i18 | 0, i16 | 0);
 STACKTOP = i17;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 24 | 0;
 i3 = i13 + 20 | 0;
 i9 = i13 + 8 | 0;
 i4 = i13 + 4 | 0;
 i5 = i13;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = ((HEAP32[i12 >> 2] | 0) - i1 | 0) / 28 | 0;
 i6 = i1;
 if (i2 >>> 0 >= i7 >>> 0) {
  if (i2 >>> 0 <= i7 >>> 0) {
   STACKTOP = i13;
   return;
  }
  i5 = i6 + (i7 * 28 | 0) | 0;
  HEAP32[i10 >> 2] = 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i1 = i7 * 28 | 0;
  i3 = (i1 | 0) / 28 | 0;
  if (!i1) {
   i5 = i10 + 8 | 0;
   i2 = 0;
   i4 = 0;
   i3 = 0;
  } else {
   if (i3 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i2 = __Znwj(i1) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i10 >> 2] = i2;
   i4 = i2 + (i3 * 28 | 0) | 0;
   i3 = i10 + 8 | 0;
   HEAP32[i3 >> 2] = i4;
   i1 = i2;
   if (!i7) {
    i5 = i3;
    i2 = i1;
    i3 = i1;
   } else {
    i1 = i6;
    do {
     i6 = i1;
     i7 = HEAP32[i6 + 4 >> 2] | 0;
     i9 = i2;
     HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i9 + 4 >> 2] = i7;
     __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 8 | 0, i1 + 8 | 0);
     i1 = i1 + 28 | 0;
     i2 = (HEAP32[i8 >> 2] | 0) + 28 | 0;
     HEAP32[i8 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i5 = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i10 >> 2] | 0;
   }
  }
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
  i9 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i12 >> 2] = i2;
  i2 = i11 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
  i4 = i1;
  i2 = i9;
  if (i1 | 0) {
   if ((i2 | 0) != (i4 | 0)) {
    while (1) {
     i1 = i2 + -28 | 0;
     HEAP32[i8 >> 2] = i1;
     i3 = i2 + -20 | 0;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i8 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 8 | 0;
 if ((((HEAP32[i6 >> 2] | 0) - i1 | 0) / 28 | 0 | 0) == (i7 | 0)) {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj(i11, i7 - i2 | 0);
  STACKTOP = i13;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE7reserveEj(i9, i7);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i3, i10);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 28 | 0;
 i4 = i2;
 if (i1 >>> 0 < i7 >>> 0) {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj(i9, i7 - i1 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
 } else if (i1 >>> 0 > i7 >>> 0) {
  i5 = i3 + (i7 * 28 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -28 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i12 >> 2] = i2;
 i2 = i9 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i1;
 i2 = i11;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   while (1) {
    i1 = i2 + -28 | 0;
    HEAP32[i8 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i7, i9, i3, i5, i19, i16, i18, i14, f2, i4) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 96 | 0;
 i17 = i24 + 80 | 0;
 i1 = i24 + 64 | 0;
 i23 = i24 + 136 | 0;
 i15 = i24 + 48 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 16 | 0;
 i20 = i24;
 i8 = i24 + 156 | 0;
 i10 = i24 + 152 | 0;
 i21 = i24 + 148 | 0;
 i22 = i24 + 124 | 0;
 i6 = i24 + 112 | 0;
 if (!(__ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i7, i9, i3, i5, i19, i1, i17, i11, f2) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) | i4 ^ 1)) {
  f2 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(100.0));
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i1 = i20 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP8[i21 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i7, i9, i15, i12, i13, i17, i20, i8, i10, i21, 0) | 0) {
  case 1:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i22 >> 2] = gb + 85540 + 8;
    HEAP32[i22 + 4 >> 2] = i7;
    HEAP32[i22 + 8 >> 2] = i9;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i7, i9, i22, i8, i10, HEAP8[i21 >> 0] | 0, i12, i13, i17, i20, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break L6;
    } else {
     f27 = Math_fround(HEAPF32[i19 >> 2]);
     f25 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f2 * f2)))));
     f25 = Math_fround(-Math_fround(f25 * f26));
     f2 = Math_fround(-Math_fround(f2 * f26));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f27 * f26));
     HEAPF32[i17 + 4 >> 2] = f25;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   }
  } while (0);
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i23 = f27 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i23 ? f27 : Math_fround(0.0);
  i23 = i16 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 };
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN13SparseTexture8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 80 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932215 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932223 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 410444 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags(i9, i7 + 96 | 0, gb + 410455 | 0, 0);
 i4 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932818 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431875 | 0, gb + 431893 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 8 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Gu23computeMTD_SphereConvexERNS_6PxVec3ERfRKNS0_6SphereERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i20, i22, i21, i3, i5) {
 i20 = i20 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i23 + 12 | 0;
 i6 = HEAP32[i3 + 32 >> 2] | 0;
 if (!(__Z19pointConvexDistanceRN5physx6PxVec3ES1_RfRKS0_PKNS_2Gu10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformE(i20, i23, i4, i21, i6, i3 + 4 | 0, i5) | 0)) {
  f2 = Math_fround(HEAPF32[i4 >> 2]);
  f1 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  if (f2 > Math_fround(f1 * f1)) {
   i22 = 0;
   STACKTOP = i23;
   return i22 | 0;
  }
  f15 = Math_fround(f1 - Math_fround(Math_sqrt(Math_fround(f2))));
  i21 = f15 > Math_fround(0.0);
  HEAPF32[i22 >> 2] = i21 ? f15 : Math_fround(0.0);
  f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
  i21 = i20 + 4 | 0;
  f18 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
  i22 = i20 + 8 | 0;
  f19 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
  HEAPF32[i20 >> 2] = f15;
  HEAPF32[i21 >> 2] = f18;
  HEAPF32[i22 >> 2] = f19;
  i22 = 1;
  STACKTOP = i23;
  return i22 | 0;
 }
 f10 = Math_fround(HEAPF32[i21 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i5 + 16 >> 2]));
 f12 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i5 + 20 >> 2]));
 f8 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f10 = Math_fround(f10 * Math_fround(2.0));
 f12 = Math_fround(f12 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f8 - Math_fround(HEAPF32[i5 + 24 >> 2])) * Math_fround(2.0));
 i24 = i5 + 12 | 0;
 f1 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(Math_fround(f1 * f1) + Math_fround(-.5));
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f10 * f11);
 i3 = i5 + 4 | 0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f12 * f19));
 i4 = i5 + 8 | 0;
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f8 * f18));
 f13 = Math_fround(Math_fround(f11 * f15) + Math_fround(Math_fround(f10 * f9) - Math_fround(f1 * Math_fround(Math_fround(f8 * f19) - Math_fround(f12 * f18)))));
 f14 = Math_fround(Math_fround(f19 * f15) + Math_fround(Math_fround(f12 * f9) - Math_fround(f1 * Math_fround(Math_fround(f10 * f18) - Math_fround(f8 * f11)))));
 f15 = Math_fround(Math_fround(Math_fround(f8 * f9) - Math_fround(f1 * Math_fround(Math_fround(f12 * f11) - Math_fround(f10 * f19)))) + Math_fround(f18 * f15));
 i16 = i20 + 4 | 0;
 i17 = i20 + 8 | 0;
 f18 = Math_fround(HEAPF32[i24 >> 2]);
 f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f1 = Math_fround(-3402823469999999843913219.0e14);
 i4 = HEAPU8[i6 + 55 >> 0] | 0;
 i3 = HEAP32[i6 + 56 >> 2] | 0;
 L8 : while (1) {
  i5 = i4;
  i6 = i3;
  while (1) {
   i4 = i5 + -1 | 0;
   if (!i5) break L8;
   i3 = i6 + 20 | 0;
   f8 = Math_fround(HEAPF32[i6 >> 2]);
   f9 = Math_fround(f13 * f8);
   f7 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f14 * f7));
   f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   f9 = Math_fround(f9 + Math_fround(f15 * f2));
   f9 = Math_fround(Math_fround(HEAPF32[i6 + 12 >> 2]) + f9);
   if (f9 > f1) {
    f1 = f9;
    break;
   } else {
    i5 = i4;
    i6 = i3;
   }
  }
  f25 = Math_fround(f8 * Math_fround(2.0));
  f7 = Math_fround(f7 * Math_fround(2.0));
  f2 = Math_fround(f2 * Math_fround(2.0));
  f26 = Math_fround(Math_fround(Math_fround(f25 * f10) + Math_fround(f7 * f11)) + Math_fround(f2 * f12));
  f8 = Math_fround(Math_fround(f11 * f26) + Math_fround(Math_fround(f7 * f19) + Math_fround(f18 * Math_fround(Math_fround(f25 * f12) - Math_fround(f2 * f10)))));
  f9 = Math_fround(Math_fround(Math_fround(f2 * f19) + Math_fround(f18 * Math_fround(Math_fround(f7 * f10) - Math_fround(f25 * f11)))) + Math_fround(f12 * f26));
  HEAPF32[i20 >> 2] = Math_fround(Math_fround(f10 * f26) + Math_fround(Math_fround(f25 * f19) + Math_fround(f18 * Math_fround(Math_fround(f2 * f11) - Math_fround(f7 * f12)))));
  HEAPF32[i16 >> 2] = f8;
  HEAPF32[i17 >> 2] = f9;
 }
 f26 = Math_fround(Math_fround(HEAPF32[i21 + 12 >> 2]) - f1);
 i24 = f26 > Math_fround(0.0);
 HEAPF32[i22 >> 2] = i24 ? f26 : Math_fround(0.0);
 i24 = 1;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZN11UnityEngine7Connect17DeviceInfoUpdater17LookForAppChangesERNS0_15DeviceInfoEventEj(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i6 = i16 + 32 | 0;
 i9 = i15 + 11 | 0;
 i7 = HEAP8[i9 >> 0] | 0;
 i8 = i7 << 24 >> 24 < 0;
 if (i8) i4 = HEAP32[i15 + 4 >> 2] | 0; else i4 = i7 & 255;
 i10 = HEAP8[i6 + 11 >> 0] | 0;
 i5 = i10 << 24 >> 24 < 0;
 i10 = i5 ? HEAP32[i16 + 36 >> 2] | 0 : i10 & 255;
 if (i8) i2 = HEAP32[i15 >> 2] | 0; else i2 = i15;
 i3 = i10 >>> 0 < i4 >>> 0;
 i1 = i3 ? i10 : i4;
 if (!i1) i14 = 9; else {
  i1 = _memcmp(i2, i5 ? HEAP32[i6 >> 2] | 0 : i6, i1) | 0;
  if (!i1) i14 = 9; else i13 = i1;
 }
 if ((i14 | 0) == 9) i13 = i4 >>> 0 < i10 >>> 0 ? -1 : i3 & 1;
 do if ((i15 | 0) != (i6 | 0)) {
  i3 = i5 ? HEAP32[i6 >> 2] | 0 : i6;
  if (i8) i2 = (HEAP32[i15 + 8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
  if (i10 >>> 0 > i2 >>> 0) {
   if (i8) i1 = HEAP32[i15 + 4 >> 2] | 0; else i1 = i7 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i2, i10 - i2 | 0, i1, 0, i1, i10, i3);
   break;
  }
  if (i8) i1 = HEAP32[i15 >> 2] | 0; else i1 = i15;
  if (i10 | 0) _memmove(i1 | 0, i3 | 0, i10 | 0) | 0;
  HEAP8[i1 + i10 >> 0] = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   HEAP32[i15 + 4 >> 2] = i10;
   break;
  } else {
   HEAP8[i9 >> 0] = i10;
   break;
  }
 } while (0);
 i1 = i15 + 16 | 0;
 i6 = i16 + 48 | 0;
 i10 = i1 + 11 | 0;
 i8 = HEAP8[i10 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 if (i9) i5 = HEAP32[i15 + 20 >> 2] | 0; else i5 = i8 & 255;
 i11 = HEAP8[i6 + 11 >> 0] | 0;
 i7 = i11 << 24 >> 24 < 0;
 i11 = i7 ? HEAP32[i16 + 52 >> 2] | 0 : i11 & 255;
 if (i9) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i4 = i11 >>> 0 < i5 >>> 0;
 i2 = i4 ? i11 : i5;
 if (!i2) i14 = 34; else {
  i2 = _memcmp(i3, i7 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
  if (!i2) i14 = 34; else i12 = i2;
 }
 if ((i14 | 0) == 34) i12 = i5 >>> 0 < i11 >>> 0 ? -1 : i4 & 1;
 do if ((i1 | 0) != (i6 | 0)) {
  i4 = i7 ? HEAP32[i6 >> 2] | 0 : i6;
  if (i9) i3 = (HEAP32[i15 + 24 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i11 >>> 0 > i3 >>> 0) {
   if (i9) i2 = HEAP32[i15 + 20 >> 2] | 0; else i2 = i8 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, i11 - i3 | 0, i2, 0, i2, i11, i4);
   break;
  }
  if (i9) i1 = HEAP32[i1 >> 2] | 0;
  if (i11 | 0) _memmove(i1 | 0, i4 | 0, i11 | 0) | 0;
  HEAP8[i1 + i11 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i15 + 20 >> 2] = i11;
   break;
  } else {
   HEAP8[i10 >> 0] = i11;
   break;
  }
 } while (0);
 i1 = i15 + 32 | 0;
 i7 = i16 + 64 | 0;
 i10 = i1 + 11 | 0;
 i8 = HEAP8[i10 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 if (i9) i5 = HEAP32[i15 + 36 >> 2] | 0; else i5 = i8 & 255;
 i11 = HEAP8[i7 + 11 >> 0] | 0;
 i6 = i11 << 24 >> 24 < 0;
 i11 = i6 ? HEAP32[i16 + 68 >> 2] | 0 : i11 & 255;
 if (i9) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i4 = i11 >>> 0 < i5 >>> 0;
 i2 = i4 ? i11 : i5;
 if (!i2) i14 = 59; else {
  i2 = _memcmp(i3, i6 ? HEAP32[i7 >> 2] | 0 : i7, i2) | 0;
  if (!i2) i14 = 59; else i5 = i2;
 }
 if ((i14 | 0) == 59) i5 = i5 >>> 0 < i11 >>> 0 ? -1 : i4 & 1;
 do if ((i1 | 0) != (i7 | 0)) {
  i4 = i6 ? HEAP32[i7 >> 2] | 0 : i7;
  if (i9) i3 = (HEAP32[i15 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i11 >>> 0 > i3 >>> 0) {
   if (i9) i2 = HEAP32[i15 + 36 >> 2] | 0; else i2 = i8 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, i11 - i3 | 0, i2, 0, i2, i11, i4);
   break;
  }
  if (i9) i1 = HEAP32[i1 >> 2] | 0;
  if (i11 | 0) _memmove(i1 | 0, i4 | 0, i11 | 0) | 0;
  HEAP8[i1 + i11 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i15 + 36 >> 2] = i11;
   break;
  } else {
   HEAP8[i10 >> 0] = i11;
   break;
  }
 } while (0);
 i11 = HEAP16[i16 + 80 >> 1] | 0;
 i10 = i11 & 255;
 i9 = i15 + 48 | 0;
 i14 = HEAP16[i9 >> 1] | 0;
 HEAP8[i9 >> 0] = i10;
 i11 = (i11 & 65535) >>> 8 & 255;
 HEAP8[i15 + 49 >> 0] = i11;
 if (!((i12 | i13 | i5 | 0 ? 1 : i10 << 24 >> 24 != (i14 & 255) << 24 >> 24) | i11 << 24 >> 24 != ((i14 & 65535) >>> 8 & 255) << 24 >> 24)) return i17 | 0;
 i1 = i16 + 84 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i17 | 0)) return i17 | 0;
 __ZN11UnityEngine7Connect15DeviceInfoEvent16CollectExtraInfoEv(i16);
 i17 = HEAP32[i1 >> 2] | 0;
 return i17 | 0;
}

function __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii(i16, i17, i18, i19) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25;
 i21 = i19 - i18 | 0;
 i22 = i16 + 12 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 i24 = i23 + 1 | 0;
 i4 = i16 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i24 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 * 28 | 0, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i15 | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i22 >> 2] | 0) * 28 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i16 >> 2] = i15;
   break;
  }
 } while (0);
 HEAP32[i22 >> 2] = i24;
 i3 = HEAP32[i16 >> 2] | 0;
 i4 = i3 + (i23 * 28 | 0) | 0;
 i11 = (HEAP32[i17 >> 2] | 0) + (i18 * 28 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i11 = i3 + (i23 * 28 | 0) + 12 | 0;
 i1 = (HEAP32[i17 >> 2] | 0) + (i18 * 28 | 0) + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = i18 + 1 | 0;
 if ((i1 | 0) < (i19 | 0)) {
  i12 = i3 + (i23 * 28 | 0) + 4 | 0;
  i13 = i3 + (i23 * 28 | 0) + 8 | 0;
  i14 = i3 + (i23 * 28 | 0) + 16 | 0;
  i15 = i3 + (i23 * 28 | 0) + 20 | 0;
  i2 = i3 + (i23 * 28 | 0) + 12 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  f6 = Math_fround(HEAPF32[i12 >> 2]);
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  f8 = Math_fround(HEAPF32[i11 >> 2]);
  f9 = Math_fround(HEAPF32[i14 >> 2]);
  f10 = Math_fround(HEAPF32[i15 >> 2]);
  do {
   i27 = HEAP32[i17 >> 2] | 0;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) >> 2]);
   f5 = f26 < f5 ? f26 : f5;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) + 4 >> 2]);
   f6 = f26 < f6 ? f26 : f6;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) + 8 >> 2]);
   f7 = f26 < f7 ? f26 : f7;
   HEAPF32[i4 >> 2] = f5;
   HEAPF32[i12 >> 2] = f6;
   HEAPF32[i13 >> 2] = f7;
   i27 = HEAP32[i17 >> 2] | 0;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) + 12 >> 2]);
   f8 = f8 < f26 ? f26 : f8;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) + 16 >> 2]);
   f9 = f9 < f26 ? f26 : f9;
   f26 = Math_fround(HEAPF32[i27 + (i1 * 28 | 0) + 20 >> 2]);
   f10 = f10 < f26 ? f26 : f10;
   HEAPF32[i2 >> 2] = f8;
   HEAPF32[i14 >> 2] = f9;
   HEAPF32[i15 >> 2] = f10;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i19 | 0));
 }
 if ((i21 | 0) < 2) {
  HEAP32[i3 + (i23 * 28 | 0) + 24 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + (i18 * 28 | 0) + 24 >> 2];
  STACKTOP = i25;
  return;
 }
 f10 = Math_fround(HEAPF32[i11 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i4 >> 2]));
 f9 = Math_fround(HEAPF32[i3 + (i23 * 28 | 0) + 16 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + (i23 * 28 | 0) + 4 >> 2]));
 f26 = Math_fround(HEAPF32[i3 + (i23 * 28 | 0) + 20 >> 2]);
 f26 = Math_fround(f26 - Math_fround(HEAPF32[i3 + (i23 * 28 | 0) + 8 >> 2]));
 HEAPF32[i20 >> 2] = f10;
 HEAPF32[i20 + 4 >> 2] = f9;
 HEAPF32[i20 + 8 >> 2] = f26;
 i1 = f9 > f10 & 1;
 i27 = f26 > Math_fround(HEAPF32[i20 + (i1 << 2) >> 2]);
 i1 = i27 ? 2 : i1;
 do if (!i1) {
  i27 = HEAP32[i17 >> 2] | 0;
  __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_(i27 + (i18 * 28 | 0) | 0, i27 + (i19 * 28 | 0) | 0, i20);
 } else {
  i3 = HEAP32[i17 >> 2] | 0;
  i2 = i3 + (i18 * 28 | 0) | 0;
  i3 = i3 + (i19 * 28 | 0) | 0;
  if ((i1 | 0) == 1) {
   __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_(i2, i3, i20);
   break;
  } else {
   __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_(i2, i3, i20);
   break;
  }
 } while (0);
 i27 = (i21 >>> 1) + i18 | 0;
 __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii(i16, i17, i18, i27);
 __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii(i16, i17, i27, i19);
 HEAP32[(HEAP32[i16 >> 2] | 0) + (i23 * 28 | 0) + 24 >> 2] = i24 - (HEAP32[i22 >> 2] | 0);
 STACKTOP = i25;
 return;
}

function _UNITY_FT_Create_Class_tt_cmap_classes(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 508, i2) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i1 + 44 >> 2] = fb + 1021;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = fb + 1022;
 HEAP32[i1 + 56 >> 2] = fb + 1023;
 i5 = i1 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = fb + 1024;
 HEAP32[i1 + 88 >> 2] = fb + 1025;
 HEAP32[i1 >> 2] = i2;
 i2 = i1 + 92 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i1 + 96 >> 2] = fb + 1021;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = fb + 1026;
 HEAP32[i1 + 108 >> 2] = fb + 1027;
 i5 = i1 + 112 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 2;
 HEAP32[i1 + 136 >> 2] = fb + 1028;
 HEAP32[i1 + 140 >> 2] = fb + 1029;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = 56;
 HEAP32[i1 + 148 >> 2] = fb + 1030;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = fb + 1031;
 HEAP32[i1 + 160 >> 2] = fb + 1032;
 i5 = i1 + 164 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 4;
 HEAP32[i1 + 188 >> 2] = fb + 1033;
 HEAP32[i1 + 192 >> 2] = fb + 1034;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 196 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i1 + 200 >> 2] = fb + 1021;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = fb + 1035;
 HEAP32[i1 + 212 >> 2] = fb + 1036;
 i5 = i1 + 216 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 6;
 HEAP32[i1 + 240 >> 2] = fb + 1037;
 HEAP32[i1 + 244 >> 2] = fb + 1038;
 HEAP32[i1 + 12 >> 2] = i2;
 i2 = i1 + 248 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i1 + 252 >> 2] = fb + 1021;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = fb + 1039;
 HEAP32[i1 + 264 >> 2] = fb + 1040;
 i5 = i1 + 268 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 8;
 HEAP32[i1 + 292 >> 2] = fb + 1041;
 HEAP32[i1 + 296 >> 2] = fb + 1042;
 HEAP32[i1 + 16 >> 2] = i2;
 i2 = i1 + 300 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i1 + 304 >> 2] = fb + 1021;
 HEAP32[i1 + 308 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = fb + 1043;
 HEAP32[i1 + 316 >> 2] = fb + 1044;
 i5 = i1 + 320 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 340 >> 2] = 10;
 HEAP32[i1 + 344 >> 2] = fb + 1045;
 HEAP32[i1 + 348 >> 2] = fb + 1046;
 HEAP32[i1 + 20 >> 2] = i2;
 i2 = i1 + 352 | 0;
 HEAP32[i2 >> 2] = 44;
 HEAP32[i1 + 356 >> 2] = fb + 1047;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 364 >> 2] = fb + 1048;
 HEAP32[i1 + 368 >> 2] = fb + 1049;
 i5 = i1 + 372 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 392 >> 2] = 12;
 HEAP32[i1 + 396 >> 2] = fb + 1050;
 HEAP32[i1 + 400 >> 2] = fb + 1051;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 404 | 0;
 HEAP32[i2 >> 2] = 44;
 HEAP32[i1 + 408 >> 2] = fb + 1052;
 HEAP32[i1 + 412 >> 2] = 0;
 HEAP32[i1 + 416 >> 2] = fb + 1053;
 HEAP32[i1 + 420 >> 2] = fb + 1054;
 i5 = i1 + 424 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i1 + 444 >> 2] = 13;
 HEAP32[i1 + 448 >> 2] = fb + 1055;
 HEAP32[i1 + 452 >> 2] = fb + 1056;
 HEAP32[i1 + 28 >> 2] = i2;
 i2 = i1 + 456 | 0;
 HEAP32[i2 >> 2] = 40;
 HEAP32[i1 + 460 >> 2] = fb + 1057;
 HEAP32[i1 + 464 >> 2] = fb + 3848;
 HEAP32[i1 + 468 >> 2] = fb + 1058;
 HEAP32[i1 + 472 >> 2] = fb + 1059;
 HEAP32[i1 + 476 >> 2] = fb + 185;
 HEAP32[i1 + 480 >> 2] = fb + 444;
 HEAP32[i1 + 484 >> 2] = fb + 1060;
 HEAP32[i1 + 488 >> 2] = fb + 445;
 HEAP32[i1 + 492 >> 2] = fb + 446;
 HEAP32[i1 + 496 >> 2] = 14;
 HEAP32[i1 + 500 >> 2] = fb + 1061;
 HEAP32[i1 + 504 >> 2] = fb + 1062;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 i3 = 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVENS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERKNSB_5Vec3VESK_RSF_RSI_SM_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 85484 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_fb(i7, i9, i3, i5, i19, i16, i18, i14, f2, i4) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i24 + 96 | 0;
 i17 = i24 + 80 | 0;
 i1 = i24 + 64 | 0;
 i23 = i24 + 136 | 0;
 i15 = i24 + 48 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 16 | 0;
 i20 = i24;
 i8 = i24 + 156 | 0;
 i10 = i24 + 152 | 0;
 i21 = i24 + 148 | 0;
 i22 = i24 + 124 | 0;
 i6 = i24 + 112 | 0;
 if (!(__ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f(i7, i9, i3, i5, i19, i1, i17, i11, f2) | 0)) {
  i23 = 0;
  STACKTOP = i24;
  return i23 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) | i4 ^ 1)) {
  f2 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i9 + 16 >> 2])) * Math_fround(100.0));
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  i1 = i20 + 4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP8[i21 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i7, i9, i15, i12, i13, i17, i20, i8, i10, i21, 0) | 0) {
  case 1:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i22 >> 2] = gb + 151244 + 8;
    HEAP32[i22 + 4 >> 2] = i7;
    HEAP32[i22 + 8 >> 2] = i9;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i7, i9, i22, i8, i10, HEAP8[i21 >> 0] | 0, i12, i13, i17, i20, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     break L6;
    } else {
     f27 = Math_fround(HEAPF32[i19 >> 2]);
     f25 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f27 * f27) + Math_fround(f25 * f25)) + Math_fround(f2 * f2)))));
     f25 = Math_fround(-Math_fround(f25 * f26));
     f2 = Math_fround(-Math_fround(f2 * f26));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f27 * f26));
     HEAPF32[i17 + 4 >> 2] = f25;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAPF32[i20 >> 2] = Math_fround(0.0);
     HEAP32[i1 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   }
  } while (0);
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  i23 = f27 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i23 ? f27 : Math_fround(0.0);
  i23 = i16 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 };
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZN5physx12_GLOBAL__N_120copyStaticPropertiesERNS_12PxRigidActorERKS1_(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 672 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 392 | 0;
 i3 = i21 + 384 | 0;
 i18 = i21 + 112 | 0;
 i1 = i21 + 104 | 0;
 i2 = i21 + 64 | 0;
 i6 = i21 + 667 | 0;
 i7 = i21 + 32 | 0;
 i8 = i21 + 16 | 0;
 i9 = i21;
 i10 = i21 + 664 | 0;
 i11 = i21 + 666 | 0;
 i19 = i20 + 256 | 0;
 i15 = i20 + 260 | 0;
 HEAP32[i20 + 264 >> 2] = 0;
 i16 = i20 + 268 | 0;
 HEAP8[i19 >> 0] = 1;
 HEAP32[i15 >> 2] = i20;
 HEAP32[i16 >> 2] = 64;
 i17 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 104 >> 2] | 0, i12 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i20, i17, i3);
 i3 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 104 >> 2] | 0, i12 | 0) | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 108 >> 2] | 0, i12 | 0, HEAP32[i15 >> 2] | 0, i3 | 0, 0) | 0;
 i17 = i18 + 256 | 0;
 i4 = i18 + 260 | 0;
 HEAP32[i18 + 264 >> 2] = 0;
 i5 = i18 + 268 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i4 >> 2] = i18;
 HEAP32[i5 >> 2] = 64;
 if (i3 | 0) {
  i13 = 0;
  do {
   i24 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i13 << 2) >> 2] | 0;
   i22 = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 100 >> 2] | 0, i24 | 0) | 0;
   i25 = i22 & 65535;
   HEAP32[i1 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i18, i25, i1);
   mftCall_iiii(HEAP32[(HEAP32[i24 >> 2] | 0) + 104 >> 2] | 0, i24 | 0, HEAP32[i4 >> 2] | 0, i25 | 0) | 0;
   i25 = HEAP32[(HEAP32[i14 >> 2] | 0) + 92 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i24 | 0);
   i23 = HEAP32[i4 >> 2] | 0;
   HEAP8[i6 >> 0] = mftCall_ii(HEAP32[(HEAP32[i24 >> 2] | 0) + 136 >> 2] | 0, i24 | 0) | 0;
   i22 = mftCall_iiiiii(i25 | 0, i14 | 0, i2 | 0, i23 | 0, i22 | 0, i6 | 0) | 0;
   i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 68 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 72 >> 2] | 0, i7 | 0, i24 | 0);
   mftCall_vii(i23 | 0, i22 | 0, i7 | 0);
   i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 112 >> 2] | 0;
   mftCall_vif(i23 | 0, i22 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i24 >> 2] | 0) + 116 >> 2] | 0, i24 | 0)));
   i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 120 >> 2] | 0;
   mftCall_vif(i23 | 0, i22 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i24 >> 2] | 0) + 124 >> 2] | 0, i24 | 0)));
   i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 76 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 80 >> 2] | 0, i8 | 0, i24 | 0);
   mftCall_vii(i23 | 0, i22 | 0, i8 | 0);
   i23 = HEAP32[(HEAP32[i22 >> 2] | 0) + 88 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 92 >> 2] | 0, i9 | 0, i24 | 0);
   mftCall_vii(i23 | 0, i22 | 0, i9 | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i3 | 0));
 }
 i25 = HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] | 0;
 HEAP16[i10 >> 1] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i12 | 0) | 0;
 mftCall_vii(i25 | 0, i14 | 0, i10 | 0);
 i25 = HEAP32[(HEAP32[i14 >> 2] | 0) + 64 >> 2] | 0;
 mftCall_vii(i25 | 0, i14 | 0, mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 68 >> 2] | 0, i12 | 0) | 0);
 i25 = HEAP32[(HEAP32[i14 >> 2] | 0) + 72 >> 2] | 0;
 HEAP8[i11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 76 >> 2] | 0, i12 | 0) | 0;
 mftCall_vii(i25 | 0, i14 | 0, i11 | 0);
 i25 = HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] | 0;
 mftCall_vii(i25 | 0, i14 | 0, mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 60 >> 2] | 0, i12 | 0) | 0);
 i25 = HEAP32[i5 >> 2] | 0;
 do if ((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i18 | 0) == (i1 | 0)) {
   HEAP8[i17 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
  }
 } while (0);
 i25 = HEAP32[i16 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i20 | 0) == (i1 | 0)) {
  HEAP8[i19 >> 0] = 0;
  STACKTOP = i21;
  return;
 }
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i21;
 return;
}

function __ZN24TextDOMTransferWriteBaseI9JSONWriteEC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i7 = i3 + 16 | 0;
 i8 = i3 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i3 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i3 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i13 = i2;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = i3 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i3 + 48 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i3 + 52 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i3 + 40 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i14;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i3 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 do if (i1 | 0) {
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  i16 = i2 << 24 >> 24 < 0;
  i6 = i16 ? HEAP32[i1 >> 2] | 0 : i1;
  i1 = i16 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255;
  i2 = i5 + 11 | 0;
  if (i1 >>> 0 > 10) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, 10, i1 + -10 | 0, 0, 0, 0, i1, i6);
   break;
  }
  if (i1 | 0) _memmove(i5 | 0, i6 | 0, i1 | 0) | 0;
  HEAP8[i5 + i1 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i3 + 64 >> 2] = i1;
   break;
  } else {
   HEAP8[i2 >> 0] = i1;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 56 >> 2] = 0;
 i16 = gb + 64016 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i16;
 i1 = i10;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i16;
 i1 = HEAP32[i9 >> 2] | 0;
 do if ((i1 & 2147483584) >>> 0 < 64) if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = 64;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 2560, 8, i10, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2560, 8, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i9 >> 2] = 64;
  HEAP32[i7 >> 2] = i16;
  break;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 do if ((i1 & 2147483584) >>> 0 < 64) if ((i1 | 0) > -1) {
  HEAP32[i13 >> 2] = 64;
  HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, 256, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
  HEAP32[i13 >> 2] = 64;
  HEAP32[i11 >> 2] = i1;
  i1 = 64;
  break;
 } while (0);
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i1 & 2147483647;
 if (i4 >>> 0 <= i5 >>> 0) {
  HEAP32[i12 >> 2] = i4;
  i16 = HEAP32[i11 >> 2] | 0;
  i16 = i16 + (i3 << 2) | 0;
  HEAP32[i16 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
 i2 = i1 << 1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 if (i5 >>> 0 >= i2 >>> 0) {
  HEAP32[i12 >> 2] = i4;
  i16 = HEAP32[i11 >> 2] | 0;
  i16 = i16 + (i3 << 2) | 0;
  HEAP32[i16 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i13 >> 2] = i2;
  HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i12 >> 2] = i4;
  i16 = HEAP32[i11 >> 2] | 0;
  i16 = i16 + (i3 << 2) | 0;
  HEAP32[i16 >> 2] = 0;
  STACKTOP = i15;
  return;
 } else {
  i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i16 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i11 >> 2] = i16;
  HEAP32[i12 >> 2] = i4;
  i16 = HEAP32[i11 >> 2] | 0;
  i16 = i16 + (i3 << 2) | 0;
  HEAP32[i16 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
}

function __ZN11UnityEngine9Animation31CreateControllerBindingConstantEPKN7mecanim9animation18ControllerConstantEPKNS2_12AnimationSetEPNS1_18ValueArrayConstantEjPKNS2_14AvatarConstantERNS1_6memory9AllocatorE(i22, i8, i4, i5, i7, i6) {
 i22 = i22 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i23 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 28, 4) | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = i7;
 HEAP32[i23 + 20 >> 2] = i22;
 HEAP32[i23 + 24 >> 2] = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + i7 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i2 = i1 * 12 | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
   if ((i3 | 0) != (i3 + (i1 * 12 | 0) | 0)) {
    i21 = i2 + -12 | 0;
    _memset(i3 | 0, -1, i21 - ((i21 >>> 0) % 12 | 0) + 12 | 0) | 0;
   }
   HEAP32[i23 + 8 >> 2] = i3;
  }
 }
 i21 = __ZN7mecanim28CreateValueArrayConstantCopyEPKNS_18ValueArrayConstantEjRNS_6memory9AllocatorE(i4, i5, i6) | 0;
 HEAP32[i23 >> 2] = i21;
 HEAP32[i23 + 4 >> 2] = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i21, i6) | 0;
 if (!i22) return i23 | 0;
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) i21 = 0; else {
  i21 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i1 | 0, 1) | 0;
  _memset(i21 | 0, 0, i1 | 0) | 0;
 }
 HEAP32[i23 + 12 >> 2] = i21;
 i1 = HEAP32[i7 + 40 >> 2] | 0;
 if ((i1 | 0) == -1) i15 = 0; else {
  i15 = (HEAP32[i7 >> 2] | 0) + i7 + 8 | 0;
  i15 = HEAP32[i15 + (HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 }
 i1 = HEAP32[i22 >> 2] | 0;
 if (!i1) return i23 | 0;
 i16 = i22 + 4 | 0;
 i17 = i16;
 i18 = i22 + 8 | 0;
 i19 = i22 + 12 | 0;
 i20 = i19;
 i14 = i8 + 8 | 0;
 i13 = 0;
 do {
  i6 = (i13 | 0) == 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i2 = i3 + i17 + (i13 << 2) | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  L22 : do if (!i4) i24 = 16; else {
   i2 = i2 + i4 | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   if (!i5) i24 = 16; else {
    i4 = i2 + 4 | 0;
    i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
    i2 = 0;
    while (1) {
     if ((HEAP32[i4 + (i2 << 3) >> 2] | 0) == (i15 | 0)) break;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 >= i5 >>> 0) {
      i24 = 16;
      break L22;
     }
    }
    if (Math_fround(HEAPF32[i4 + (i2 << 3) + 4 >> 2]) > Math_fround(0.0)) i2 = 1; else i24 = 17;
   }
  } while (0);
  if ((i24 | 0) == 16) {
   i24 = 0;
   if (i6) i2 = 1; else i24 = 17;
  }
  if ((i24 | 0) == 17) {
   i24 = 0;
   i4 = HEAP32[i18 >> 2] | 0;
   if (!i4) i2 = 0; else {
    i1 = 0;
    i2 = 0;
    while (1) {
     i12 = i3 + i17 + (i13 << 2) | 0;
     i12 = i12 + (HEAP32[i12 >> 2] | 0) | 0;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
      i12 = (HEAP32[i19 >> 2] | 0) + i20 + (i1 << 2) | 0;
      i3 = HEAP32[i12 >> 2] | 0;
      i3 = (i3 | 0) == 0 ? 0 : i12 + i3 | 0;
      i12 = HEAP32[i3 >> 2] | 0;
      if (!i12) i3 = i4; else {
       i9 = i3 + 4 | 0;
       i10 = i9;
       i8 = 0;
       do {
        i5 = (HEAP32[i9 >> 2] | 0) + i10 + (i8 << 2) | 0;
        i5 = __ZN7mecanim12statemachine20GetBlendTreeConstantERKNS0_13StateConstantEi(i5 + (HEAP32[i5 >> 2] | 0) | 0, i11) | 0;
        if (i5) if (HEAP32[i5 >> 2] | 0) {
         i6 = i5 + 4 | 0;
         i7 = i6;
         i4 = 0;
         do {
          i3 = (HEAP32[i6 >> 2] | 0) + i7 + (i4 << 2) | 0;
          i3 = HEAP32[i3 + (HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0;
          do if ((i3 | 0) != -1) {
           i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i3 * 40 | 0) >> 2] | 0;
           if (!i3) break;
           i3 = __ZN13AnimationClip15GetRuntimeAssetEv(i3) | 0;
           if (!i3) break;
           i2 = i2 | (__ZN7mecanim9animation15HasMotionCurvesERKNS0_18ClipMuscleConstantE(i3) | 0);
          } while (0);
          i4 = i4 + 1 | 0;
         } while (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
        }
        i8 = i8 + 1 | 0;
       } while ((i8 | 0) != (i12 | 0));
       i3 = HEAP32[i18 >> 2] | 0;
      }
     } else i3 = i4;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i3 >>> 0) break;
     i4 = i3;
     i3 = HEAP32[i16 >> 2] | 0;
    }
    i1 = HEAP32[i22 >> 2] | 0;
   }
  }
  HEAP8[i21 + i13 >> 0] = i2 & 1;
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < i1 >>> 0);
 return i23 | 0;
}

function __ZNK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_(i2, i1, i6, i7, i8, i9, i20, i22) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i23 = 0, f24 = f0;
 i21 = i1 + -4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  i5 = HEAP32[i21 + 20 >> 2] | 0;
  i2 = i4 + 4 | 0;
  i1 = (((i1 >>> 0 > i2 >>> 0 ? i1 : i2) + ~i4 | 0) >>> 2) + 1 | 0;
  i2 = i4;
  i3 = 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i6 >> 2] = i4 + (i1 << 2);
 }
 i1 = HEAP32[i21 + 32 >> 2] | 0;
 i18 = i1 + (HEAP32[i21 + 36 >> 2] << 2) | 0;
 i19 = HEAP32[i21 + 44 >> 2] | 0;
 i14 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i16 = i14 >>> 0 < (HEAP32[i7 + 4 >> 2] | 0) >>> 0;
 i17 = i21 + 16 | 0;
 i15 = i5 >>> 0 < (HEAP32[i8 + 4 >> 2] | 0) >>> 0;
 i13 = i2 >>> 0 < (HEAP32[i9 + 4 >> 2] | 0) >>> 0;
 i3 = HEAP32[i21 + 56 >> 2] | 0;
 i4 = 0;
 i6 = i19;
 L7 : while (1) {
  i9 = i2;
  while (1) {
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i18 | 0)) break L7;
   i2 = HEAP32[i1 >> 2] | 0;
   i11 = i19 + (i2 << 2) | 0;
   if ((i6 | 0) == (i11 | 0)) i2 = i9; else {
    i12 = (i19 + (i2 + -1 << 2) - i6 | 0) >>> 2;
    L14 : do if (i15) {
     if (i13) {
      i2 = i9;
      i10 = i3;
      i9 = i6;
      while (1) {
       i7 = HEAP16[i10 >> 1] | 0;
       i8 = HEAP16[i10 + 2 >> 1] | 0;
       if ((((i7 & 65535) < (i8 & 65535) ? i8 : i7) & 65535) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
        HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
        HEAP32[i2 >> 2] = i7 & 65535;
        HEAP32[i2 + 4 >> 2] = i8 & 65535;
        i2 = i2 + 8 | 0;
        i4 = i4 + 1 | 0;
        i5 = i5 + 4 | 0;
       }
       i9 = i9 + 4 | 0;
       if ((i9 | 0) == (i11 | 0)) break L14; else i10 = i10 + 4 | 0;
      }
     }
     i7 = HEAP32[i17 >> 2] | 0;
     i8 = i3;
     i2 = i6;
     while (1) {
      i10 = HEAP16[i8 >> 1] | 0;
      i23 = HEAP16[i8 + 2 >> 1] | 0;
      if ((((i10 & 65535) < (i23 & 65535) ? i23 : i10) & 65535) >>> 0 < i7 >>> 0) {
       HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
       i4 = i4 + 1 | 0;
       i5 = i5 + 4 | 0;
      }
      i2 = i2 + 4 | 0;
      if ((i2 | 0) == (i11 | 0)) {
       i2 = i9;
       break;
      } else i8 = i8 + 4 | 0;
     }
    } else {
     if (i13) {
      i2 = i9;
      i10 = i3;
      i9 = i6;
     } else {
      i7 = HEAP32[i17 >> 2] | 0;
      i8 = i3;
      i2 = i6;
      while (1) {
       i23 = HEAP16[i8 >> 1] | 0;
       i10 = HEAP16[i8 + 2 >> 1] | 0;
       i4 = i4 + ((((i23 & 65535) < (i10 & 65535) ? i10 : i23) & 65535) >>> 0 < i7 >>> 0 & 1) | 0;
       i2 = i2 + 4 | 0;
       if ((i2 | 0) == (i11 | 0)) {
        i2 = i9;
        break L14;
       } else i8 = i8 + 4 | 0;
      }
     }
     while (1) {
      i7 = HEAP16[i10 >> 1] | 0;
      i8 = HEAP16[i10 + 2 >> 1] | 0;
      if ((((i7 & 65535) < (i8 & 65535) ? i8 : i7) & 65535) >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0) {
       HEAP32[i2 >> 2] = i7 & 65535;
       HEAP32[i2 + 4 >> 2] = i8 & 65535;
       i2 = i2 + 8 | 0;
       i4 = i4 + 1 | 0;
      }
      i9 = i9 + 4 | 0;
      if ((i9 | 0) == (i11 | 0)) break; else i10 = i10 + 4 | 0;
     }
    } while (0);
    i3 = i3 + ((i12 << 1) + 2 << 1) | 0;
    i6 = i6 + (i12 + 1 << 2) | 0;
   }
   if (i16) break; else i9 = i2;
  }
  HEAP32[i14 >> 2] = i4;
  i14 = i14 + 4 | 0;
 }
 i4 = HEAP32[i20 >> 2] | 0;
 i1 = HEAP32[i20 + 4 >> 2] | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  i5 = HEAP32[i21 + 68 >> 2] | 0;
  i2 = i4 + 4 | 0;
  i2 = (((i1 >>> 0 > i2 >>> 0 ? i1 : i2) + ~i4 | 0) >>> 2) + 1 | 0;
  i1 = i4;
  i3 = 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAPU16[i5 + (i3 << 3) >> 1];
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i2 | 0)) break; else i1 = i1 + 4 | 0;
  }
  HEAP32[i20 >> 2] = i4 + (i2 << 2);
 }
 i5 = HEAP32[i22 >> 2] | 0;
 i1 = HEAP32[i22 + 4 >> 2] | 0;
 if (i5 >>> 0 >= i1 >>> 0) return;
 i6 = HEAP32[i21 + 68 >> 2] | 0;
 i4 = i21 + 80 | 0;
 i2 = i5 + 4 | 0;
 i1 = (((i1 >>> 0 > i2 >>> 0 ? i1 : i2) + ~i5 | 0) >>> 2) + 1 | 0;
 i2 = i5;
 i3 = 0;
 while (1) {
  f24 = Math_fround(HEAPF32[i6 + (i3 << 3) + 4 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(f24 * Math_fround(HEAPF32[i4 >> 2]));
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i22 >> 2] = i5 + (i1 << 2);
 return;
}

function __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i13 = i15;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i12);
 i14 = i11 + 80 | 0;
 i7 = i12 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i12 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i14 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i8 = i11 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i8 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i6 = i11 + 88 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i11 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i11 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i11 + 100 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11 + 32 | 0, i12);
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i11 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i4 = HEAP8[i3 >> 0] | 0;
  HEAP8[i9 >> 0] = i4;
  HEAP32[i7 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i11 + 109 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i12, i13, gb + 411165 | 0, 1);
 i3 = i11 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i11 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i11 + 108 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i7 = __Z12GetGfxDevicev() | 0;
  i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 + 48 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  mftCall_vii(i2 | 0, i7 | 0, i9 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) i1 = 0; else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = (i2 >>> 0) / (i1 >>> 0) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
 HEAP32[i3 >> 2] = i10;
 f17 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i14 >> 2] | 0));
 f16 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i8 >> 2] | 0));
 HEAPF32[i11 + 68 >> 2] = f17;
 HEAPF32[i11 + 72 >> 2] = f16;
 __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i12, HEAP32[i13 >> 2] | 0, i10, 0);
 STACKTOP = i15;
 return;
}

function __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 20 | 0;
 i13 = i15;
 i10 = HEAP32[i12 >> 2] | 0;
 if ((i10 | 0) == -1) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i9 = HEAP32[i14 + 36 >> 2] | 0;
 if ((i9 | 0) != -1 & (i9 | 0) == (i10 | 0)) {
  i12 = i12 + 8 | 0;
  i12 = _bitshift64Shl(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, 1) | 0;
  i13 = getTempRet0() | 0;
  i14 = _i64Add(HEAP32[i14 + 28 >> 2] | 0, 0, i12 | 0, i13 | 0) | 0;
  getTempRet0() | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i7 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i12 + 8 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i14 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i6 = i2;
  i5 = i2;
 } else {
  L10 : while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   do if ((i10 | 0) < (i2 | 0)) i11 = 8; else {
    if ((i10 | 0) <= (i2 | 0)) {
     i4 = i1 + 24 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i9 | 0) < (i4 | 0) | (i9 | 0) == (i4 | 0) & i8 >>> 0 < i2 >>> 0) {
      i11 = 8;
      break;
     }
     if (!((i4 | 0) < (i9 | 0) | (i4 | 0) == (i9 | 0) & i2 >>> 0 < i8 >>> 0)) {
      i11 = 14;
      break L10;
     }
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i11 = 13;
     break L10;
    } else i1 = i2;
   } while (0);
   if ((i11 | 0) == 8) {
    i11 = 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i11 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i11 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i6 = i1;
   i5 = i1;
   break;
  } else if ((i11 | 0) == 13) {
   HEAP32[i3 >> 2] = i1;
   i6 = i1;
   i5 = i4;
   break;
  } else if ((i11 | 0) == 14) {
   HEAP32[i3 >> 2] = i1;
   i6 = i1;
   i5 = i3;
   break;
  }
 } while (0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i14 = HEAP32[i1 + 32 >> 2] | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = __Znwj(40) | 0;
 HEAP32[i1 + 16 >> 2] = i10;
 HEAP32[i1 + 20 >> 2] = i7;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i4 + 4 >> 2] = i9;
 i4 = i1 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i6;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i14 >> 2] = i2;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 + 4 >> 2] | 0, i1);
 i6 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i6 = i14 + 24 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + 2 | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i4 >> 2] = i7;
 i6 = i14 + 12 | 0;
 i2 = i13 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i2 = i14 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i7 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i11 = 22;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i7 | 0)) {
     i11 = 27;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i11 = 26;
     break;
    } else i1 = i2;
   }
  }
  if ((i11 | 0) == 22) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i11 | 0) == 26) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i11 | 0) == 27) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(40) | 0;
  HEAP32[i1 + 16 >> 2] = i7;
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i6 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 + 16 >> 2] | 0, i1);
  i14 = i14 + 20 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 }
 i14 = i7;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN4Mesh18RecalculateNormalsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i10 = i14;
 i8 = i14 + 24 | 0;
 i9 = i14 + 16 | 0;
 i4 = i11 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i4 >> 2] | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i12 = i2 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i4 >> 2] = i1;
 }
 if ((HEAP16[gb + 1161448 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = i11;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161448 | 0, i13);
  i12 = gb + 1161448 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i12 = 0;
 i6 = HEAP32[i1 + 100 >> 2] | 0;
 if (i6 | 0) {
  i2 = i1 + 8 | 0;
  if (!(HEAP32[i1 + 176 >> 2] | 0)) if ((HEAP32[i11 + 116 >> 2] | 0) == (HEAP32[i11 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i13, i1 + 8 | 0);
   HEAP32[i13 >> 2] = (HEAP32[i13 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i13 + 8 >> 2] & ~HEAP32[i13 + 12 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  } else i3 = 10; else i3 = 10;
  if ((i3 | 0) == 10) {
   HEAP32[i10 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i2, i6, 3, 0, i10, gb + 1546313 | 0);
  HEAP32[i10 >> 2] = 0;
  i7 = i10 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i11, i10);
  i4 = HEAP32[i4 >> 2] | 0;
  i5 = i4 + 8 | 0;
  i3 = HEAP16[i4 + 10 >> 1] | 0;
  do if ((i3 & 65535) < 768 | (i3 & 255) != 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
  } else {
   i1 = HEAP32[i4 + 92 >> 2] | 0;
   if (i1 | 0) if (HEAP8[i4 + 11 >> 0] | 0) {
    i3 = HEAPU8[i5 + 32 + ((HEAPU8[i5 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i2 = HEAP16[i5 >> 1] | 0;
    HEAP32[i8 >> 2] = i1 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0));
    HEAP32[i8 + 4 >> 2] = i3;
    break;
   }
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 1;
  } while (0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = ((HEAP32[i7 >> 2] | 0) - i1 >> 2 >>> 0) / 3 | 0;
  i3 = HEAP16[i4 + 14 >> 1] | 0;
  do if ((i3 & 65535) < 768 | (i3 & 255) != 0) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
  } else {
   i3 = HEAP32[i4 + 92 >> 2] | 0;
   if (i3 | 0) if (HEAP8[i4 + 15 >> 0] | 0) {
    i15 = HEAPU8[i5 + 32 + ((HEAPU8[i4 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i4 = HEAP16[i4 + 12 >> 1] | 0;
    HEAP32[i9 >> 2] = i3 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i5 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0));
    HEAP32[i9 + 4 >> 2] = i15;
    break;
   }
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 1;
  } while (0);
  __Z16CalculateNormals14StrideIteratorI8Vector3fEPKjiiS1_(i8, i1, i6, i2, i9);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i15 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = 1;
   HEAP32[i13 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  }
 }
 i2 = i11 + 44 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
 HEAP32[i13 >> 2] = gb + 30832;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = i11;
 i2 = HEAP32[i11 + 236 >> 2] | 0;
 i3 = i11 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i15 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i15 + 8 >> 2] | 0, gb + 1105196 | 0, i13);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 if (!i12) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i18, i10, i1) {
 i18 = i18 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i7 = i17 + 8 | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i18, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i12 = i18 + 8 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i10 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i2 = i10 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  i2 = i4 - i5 | 0;
  if (i2) {
   _memset(i1 + i5 | 0, 0, i2 | 0) | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
 }
 i14 = i1 + (HEAP32[i6 >> 2] | 0) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i8 = HEAP32[gb + 36976 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i18 + 80 | 0;
  i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i12 = i18 + 84 | 0;
  HEAP32[HEAP32[i12 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   L21 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i18 + 16 | 0;
    i5 = i18 + 20 | 0;
    i6 = i18 + 32 | 0;
    i7 = i18 + 36 | 0;
    i8 = i18 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i11) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i16, i2);
     i19 = i16;
     i3 = HEAP32[i19 + 4 >> 2] | 0;
     i10 = i2 + 24 | 0;
     HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i10 + 4 >> 2] = i3;
     i10 = HEAP32[i12 >> 2] | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i10 = HEAP32[i5 >> 2] | 0;
     i2 = i10 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i10 >>> 0) i15 = 18; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i15 = 18; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i15 | 0) == 18) {
      i15 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L21;
     i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i18);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i18 + 16 | 0;
   i4 = i18 + 20 | 0;
   i5 = i18 + 32 | 0;
   i6 = i18 + 36 | 0;
   i7 = i18 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i8, i16, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i16 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i18 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i18);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i18);
 STACKTOP = i17;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i18, i10, i1) {
 i18 = i18 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i7 = i17 + 8 | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i18, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i12 = i18 + 8 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i10 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i2 = i10 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  i2 = i4 - i5 | 0;
  if (i2) {
   _memset(i1 + i5 | 0, 0, i2 | 0) | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
 }
 i14 = i1 + (HEAP32[i6 >> 2] | 0) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i8 = HEAP32[gb + 37252 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i18 + 80 | 0;
  i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i12 = i18 + 84 | 0;
  HEAP32[HEAP32[i12 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   L21 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i18 + 16 | 0;
    i5 = i18 + 20 | 0;
    i6 = i18 + 32 | 0;
    i7 = i18 + 36 | 0;
    i8 = i18 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i11) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i16, i2);
     i19 = i16;
     i3 = HEAP32[i19 + 4 >> 2] | 0;
     i10 = i2 + 24 | 0;
     HEAP32[i10 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i10 + 4 >> 2] = i3;
     i10 = HEAP32[i12 >> 2] | 0;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i10 = HEAP32[i5 >> 2] | 0;
     i2 = i10 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i10 >>> 0) i15 = 18; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i15 = 18; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i15 | 0) == 18) {
      i15 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L21;
     i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i18);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i18);
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i18 + 16 | 0;
   i4 = i18 + 20 | 0;
   i5 = i18 + 32 | 0;
   i6 = i18 + 36 | 0;
   i7 = i18 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i8, i16, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i16 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i18 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i18);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i18);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103188 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN5physx19TriangleMeshBuilder12loadFromDescERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb(i12, i5, i11, i9) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 8 | 0;
 i3 = i14;
 i8 = i14 + 32 | 0;
 i7 = i14 + 72 | 0;
 i10 = i14 + 16 | 0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 do if (i1 >>> 0 >= 3) {
  i2 = HEAP32[i5 + 16 >> 2] | 0;
  if ((i2 | 0) != 0 | ((i1 >>> 0) % 3 | 0 | 0) == 0) {
   if (HEAP32[i5 + 32 >> 2] | 0) if ((HEAP32[i5 + 28 >> 2] | 0) >>> 0 < 2) break;
   if (i1 >>> 0 > 65535) if (HEAP16[i5 + 24 >> 1] & 2) break;
   if (HEAP32[i5 + 4 >> 2] | 0) if ((HEAP32[i5 >> 2] | 0) >>> 0 >= 12) {
    i4 = HEAP16[i5 + 24 >> 1] | 0;
    if (i2 | 0) if ((HEAP32[i5 + 12 >> 2] | 0) >>> 0 < (i4 & 2 ? 6 : 12) >>> 0) break;
    HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    i1 = i8 + 24 | 0;
    HEAP16[i1 >> 1] = i4;
    i6 = i8 + 28 | 0;
    i3 = i5 + 28 | 0;
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    i6 = i12 + 16 | 0;
    HEAP32[i12 + 192 >> 2] = HEAP32[i5 + 36 >> 2];
    i5 = i8 + 16 | 0;
    if (!(HEAP32[i5 >> 2] | 0)) {
     HEAP16[i1 >> 1] = i4 & -3;
     HEAP32[i8 + 12 >> 2] = 12;
     i3 = HEAP32[i8 + 8 >> 2] | 0;
     HEAP32[i8 + 20 >> 2] = (i3 >>> 0) / 3 | 0;
     i1 = i3 >>> 0 > 1073741823 ? -1 : i3 << 2;
     if (!i1) i1 = 0; else {
      i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      i15 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
      i4 = _PxGetFoundation() | 0;
      i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
      i1 = mftCall_iiiiii(i15 | 0, i2 | 0, i1 | 0, (i4 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730694 | 0, 56) | 0;
     }
     if (i3 | 0) {
      i2 = 0;
      do {
       HEAP32[i1 + (i2 << 2) >> 2] = i2;
       i2 = i2 + 1 | 0;
      } while (i2 >>> 0 < i3 >>> 0);
     }
     HEAP32[i5 >> 2] = i1;
    } else i1 = 0;
    if (__ZN5physx19TriangleMeshBuilder10importMeshERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb(i12, i8, i11, i9) | 0) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i1);
     i1 = i11 + 40 | 0;
     f16 = Math_fround(HEAPF32[i1 >> 2]);
     if (f16 < Math_fround(0.0) | f16 > Math_fround(1.0)) {
      i15 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
      HEAPF64[i13 >> 3] = +Math_fround(HEAPF32[i1 >> 2]);
      __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i15, 2, gb + 730694 | 0, 75, gb + 730838 | 0, i13);
     }
     __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE(i10, i6, i11);
     __ZN5physx27InternalTriangleMeshBuilder11createRTreeEv(i10) | 0;
     i1 = i12 + 144 | 0;
     __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E(i1, HEAP32[i12 + 16 >> 2] | 0, HEAP32[i12 + 24 >> 2] | 0);
     i15 = i12 + 156 | 0;
     f16 = Math_fround(Math_abs(Math_fround(HEAPF32[i15 >> 2])));
     f18 = Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2])));
     f18 = f16 > f18 ? f16 : f18;
     i13 = f18 < Math_fround(0.0);
     f18 = i13 ? Math_fround(0.0) : f18;
     f16 = Math_fround(Math_abs(Math_fround(HEAPF32[i15 + 4 >> 2])));
     f17 = Math_fround(Math_abs(Math_fround(HEAPF32[i1 + 4 >> 2])));
     f17 = f16 > f17 ? f16 : f17;
     f17 = f18 > f17 ? f18 : f17;
     f18 = Math_fround(Math_abs(Math_fround(HEAPF32[i15 + 8 >> 2])));
     f16 = Math_fround(Math_abs(Math_fround(HEAPF32[i1 + 8 >> 2])));
     f16 = f18 > f16 ? f18 : f16;
     HEAPF32[i12 + 36 >> 2] = Math_fround((f17 > f16 ? f17 : f16) * Math_fround(2.38418579e-07));
     __ZN5physx27InternalTriangleMeshBuilder20createSharedEdgeDataEbb(i10, (HEAP8[i11 + 13 >> 0] | 0) != 0, (HEAP32[i11 + 28 >> 2] & 16 | 0) == 0);
     __ZN5physx27InternalTriangleMeshBuilderD2Ev(i10);
     i1 = 1;
    } else i1 = 0;
    i15 = i1;
    STACKTOP = i14;
    return i15 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 730694 | 0, 34, gb + 730787 | 0, i3);
 i15 = 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN16Physics2DManager11CapsuleCastERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP12RaycastHit2Di(i1, i5, i13, i14, f15, i3, f11, i16, f17, f18, i6, i7, i2, i12) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 i3 = i3 | 0;
 f11 = Math_fround(f11);
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 f18 = Math_fround(f18);
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i4 = 0, f8 = f0, f9 = f0, f10 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 8 | 0;
 i4 = i25;
 i1 = i25 + 592 | 0;
 i23 = i25 + 572 | 0;
 if ((HEAP16[gb + 1457704 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i22 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457704 | 0, i22);
  i24 = gb + 1457704 | 0;
 } else i24 = 0;
 if (!(Math_fround(HEAPF32[i13 >> 2]) <= Math_fround(.0000999999974))) if ((i12 | 0) == 0 ? 1 : Math_fround(HEAPF32[i13 + 4 >> 2]) <= Math_fround(.0000999999974)) i1 = 0; else {
  i19 = f11 == Math_fround(inf);
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(f10 * f10);
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f9 * f9));
  if (!(f8 == Math_fround(0.0))) f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
  f10 = Math_fround(f10 * f8);
  f9 = Math_fround(f9 * f8);
  f11 = i19 ? Math_fround(1.0e5) : f11;
  f10 = Math_fround(f11 * f10);
  f11 = Math_fround(f11 * f9);
  f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f10);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i5 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f11;
  i26 = gb + 64016 | 0;
  i21 = HEAP32[i26 + 4 >> 2] | 0;
  i20 = i4;
  HEAP32[i20 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i20 + 4 >> 2] = i21;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i23 + 12 >> 2] = 0;
  i20 = i23 + 16 | 0;
  HEAP32[i20 >> 2] = 0;
  i21 = i23 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i22, i4);
  i26 = i22;
  i3 = HEAP32[i26 + 4 >> 2] | 0;
  i4 = i21;
  HEAP32[i4 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i22, i5, i1, Math_fround(f15 * Math_fround(.0174532924)), i16, f17, f18, i6, i7, i23);
  HEAP32[i22 >> 2] = gb + 158712 + 8;
  HEAP32[i22 + 372 >> 2] = gb + 151688 + 8;
  HEAP32[i22 + 400 >> 2] = gb + 151728 + 8;
  HEAP32[i22 + 404 >> 2] = 2;
  i16 = HEAP32[gb + 151644 >> 2] | 0;
  HEAP32[i22 + 408 >> 2] = i16;
  HEAP32[i22 + 548 >> 2] = 0;
  HEAPF32[i22 + 412 >> 2] = Math_fround(0.0);
  HEAPF32[i22 + 416 >> 2] = Math_fround(0.0);
  HEAP32[i22 + 376 >> 2] = 4;
  HEAP32[i22 + 380 >> 2] = i16;
  i16 = i22 + 384 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  i16 = HEAP32[i13 + 4 >> 2] | 0;
  i1 = i22 + 552 | 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = i16;
  HEAP32[i22 + 560 >> 2] = i14;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i22, 0) | 0;
  i1 = (i1 | 0) > (i12 | 0) ? i12 : i1;
  if ((i1 | 0) > 0) {
   i7 = HEAP32[i23 >> 2] | 0;
   if (i19) {
    i3 = 0;
    do {
     i4 = i7 + (i3 * 36 | 0) + 28 | 0;
     HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(1.0e5));
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else {
    i3 = 0;
    do {
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   }
  }
  HEAP32[i22 >> 2] = gb + 156124 + 8;
  i2 = i22 + 340 | 0;
  if ((HEAP32[i22 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i22 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i22 + 268 | 0);
  if ((HEAP32[i20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i21);
   HEAP32[i23 >> 2] = 0;
  }
 } else i1 = 0;
 if (!i24) {
  STACKTOP = i25;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i25;
 return i1 | 0;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103292 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN15AudioReverbZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 112 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZNK5physx2Gu11ConvexHullV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(i8, i4, i7, i6) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i3 = i9;
 i2 = i9 + 44 | 0;
 i1 = i9 + 32 | 0;
 if (!(HEAP32[i8 + 196 >> 2] | 0)) {
  __ZNK5physx2Gu11ConvexHullV22BruteForceSearchMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(i8, i4, i7, i6);
  STACKTOP = i9;
  return;
 } else {
  f15 = Math_fround(HEAPF32[i4 >> 2]);
  i16 = i4 + 4 | 0;
  f26 = Math_fround(HEAPF32[i16 >> 2]);
  i10 = i4 + 8 | 0;
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  i35 = i8 + 96 | 0;
  f11 = Math_fround(f15 * Math_fround(HEAPF32[i35 >> 2]));
  i32 = i8 + 100 | 0;
  f11 = Math_fround(f11 + Math_fround(f26 * Math_fround(HEAPF32[i32 >> 2])));
  i29 = i8 + 104 | 0;
  f11 = Math_fround(f11 + Math_fround(f19 * Math_fround(HEAPF32[i29 >> 2])));
  i34 = i8 + 112 | 0;
  f21 = Math_fround(f15 * Math_fround(HEAPF32[i34 >> 2]));
  i31 = i8 + 116 | 0;
  f21 = Math_fround(f21 + Math_fround(f26 * Math_fround(HEAPF32[i31 >> 2])));
  i28 = i8 + 120 | 0;
  f21 = Math_fround(f21 + Math_fround(f19 * Math_fround(HEAPF32[i28 >> 2])));
  i33 = i8 + 128 | 0;
  f15 = Math_fround(f15 * Math_fround(HEAPF32[i33 >> 2]));
  i30 = i8 + 132 | 0;
  f26 = Math_fround(f15 + Math_fround(f26 * Math_fround(HEAPF32[i30 >> 2])));
  i27 = i8 + 136 | 0;
  f19 = Math_fround(f26 + Math_fround(f19 * Math_fround(HEAPF32[i27 >> 2])));
  HEAPF32[i5 >> 2] = f11;
  HEAPF32[i5 + 4 >> 2] = f21;
  HEAPF32[i5 + 8 >> 2] = f19;
  HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
  i36 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i8, i5) | 0;
  f21 = Math_fround(-f21);
  f19 = Math_fround(-f19);
  HEAPF32[i3 >> 2] = Math_fround(-f11);
  HEAPF32[i3 + 4 >> 2] = f21;
  HEAPF32[i3 + 8 >> 2] = f19;
  HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
  i5 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i8, i3) | 0;
  i8 = HEAP32[i8 + 200 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i8 + (i36 * 12 | 0) >> 2]);
  f21 = Math_fround(HEAPF32[i8 + (i36 * 12 | 0) + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i36 * 12 | 0) + 8 >> 2]);
  f26 = Math_fround(HEAPF32[i35 >> 2]);
  f15 = Math_fround(f19 * f26);
  f25 = Math_fround(HEAPF32[i34 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f21 * f25));
  f18 = Math_fround(HEAPF32[i33 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f11 * f18));
  f24 = Math_fround(HEAPF32[i32 >> 2]);
  f13 = Math_fround(f19 * f24);
  f23 = Math_fround(HEAPF32[i31 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f21 * f23));
  f12 = Math_fround(HEAPF32[i30 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f11 * f12));
  f22 = Math_fround(HEAPF32[i29 >> 2]);
  f19 = Math_fround(f19 * f22);
  f20 = Math_fround(HEAPF32[i28 >> 2]);
  f21 = Math_fround(f19 + Math_fround(f21 * f20));
  f19 = Math_fround(HEAPF32[i27 >> 2]);
  f11 = Math_fround(f21 + Math_fround(f11 * f19));
  f21 = Math_fround(HEAPF32[i8 + (i5 * 12 | 0) >> 2]);
  f17 = Math_fround(HEAPF32[i8 + (i5 * 12 | 0) + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i5 * 12 | 0) + 8 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(f25 * f17)) + Math_fround(f18 * f14));
  f12 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * f17)) + Math_fround(f12 * f14));
  f14 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f17)) + Math_fround(f19 * f14));
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * f12)) + Math_fround(f14 * Math_fround(HEAPF32[i10 >> 2])));
  i8 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  f14 = Math_fround(HEAPF32[i4 >> 2]);
  f12 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12)) + Math_fround(f11 * Math_fround(HEAPF32[i10 >> 2])));
  i8 = i6 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  STACKTOP = i9;
  return;
 }
}

function __ZN9Rigidbody15CleanupInternalEb(i16, i8) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 92 | 0;
 i15 = i17 + 80 | 0;
 i12 = i17;
 i10 = i16 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i14 >> 2] = 0;
  i13 = i14 + 4 | 0;
  i11 = gb + 63160 | 0;
  i3 = HEAP32[i11 + 4 >> 2] | 0;
  i4 = i13;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i9 << 2;
  i3 = (i4 | 0) != 0;
  do if (i3) {
   i2 = i4 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 246) | 0;
    i7 = gb + 64016 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    HEAP32[i14 >> 2] = i1;
    i11 = i13;
    HEAP32[i11 >> 2] = i6;
    HEAP32[i11 + 4 >> 2] = i7;
    break;
   }
  } else i1 = 0; while (0);
  i5 = i1 + 3 & -4;
  i11 = HEAP32[i10 >> 2] | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0, i11 | 0, i5 | 0, i9 | 0, 0) | 0;
  HEAP32[i15 >> 2] = 0;
  i11 = i15 + 4 | 0;
  i2 = gb + 63160 | 0;
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  do if (i3) {
   i2 = i4 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 250) | 0;
    i6 = gb + 64016 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i6 = HEAP32[i6 + 4 >> 2] | 0;
    HEAP32[i15 >> 2] = i1;
    i7 = i11;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i7 + 4 >> 2] = i6;
    break;
   }
  } else i1 = 0; while (0);
  i7 = i1 + 3 & -4;
  i6 = (i9 | 0) > 0;
  if (i6) {
   i1 = 0;
   do {
    i4 = HEAP32[(HEAP32[i5 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i7 + (i1 << 2) >> 2] = i4;
    mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i9 | 0));
  }
  i4 = i16 + 56 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i2 = 0; else {
   i2 = HEAP32[i1 + 48 >> 2] | 0;
   i3 = (i2 | 0) == 0;
   if (i3) i2 = 0; else {
    i1 = 0;
    do {
     i5 = __Z12GetIVehiclesv() | 0;
     HEAP32[i12 + (i1 << 2) >> 2] = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, HEAP32[i4 >> 2] | 0, i1 | 0) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
    if (i3) i2 = 0; else {
     i1 = 0;
     do {
      i5 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
      mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0, i5 | 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
  }
  if (HEAP8[i16 + 80 >> 0] | 0) {
   i5 = HEAP32[gb + 1457404 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, HEAP32[i10 >> 2] | 0, 1);
  }
  i5 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
  HEAP32[i10 >> 2] = 0;
  if (i8) {
   if (i6) {
    i1 = 0;
    do {
     __ZN8Collider16RecreateColliderEPK9Rigidbody(HEAP32[i7 + (i1 << 2) >> 2] | 0, i16);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   }
   if (i2 | 0) {
    i1 = 0;
    do {
     __ZN8Collider16RecreateColliderEPK9Rigidbody(HEAP32[i12 + (i1 << 2) >> 2] | 0, i16);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i1 = i16 + 108 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    i12 = i2 + 4 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i12 >> 2];
    HEAP32[HEAP32[i12 >> 2] >> 2] = i3;
   }
   __ZdlPv(i2);
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i16 + 96 >> 2] = HEAP32[i16 + 92 >> 2];
  HEAP8[i16 + 101 >> 0] = HEAP8[i16 + 100 >> 0] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 }
 i1 = i16 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i17;
  return;
 }
 i16 = i16 + 36 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[HEAP32[i16 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 36 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __Z48SceneManager_CUSTOM_UnloadSceneNameIndexInternalP12Il2CppStringihPh(i1, i3, i2, i14) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 8 | 0;
 i4 = i15;
 i11 = i15 + 68 | 0;
 i5 = i15 + 64 | 0;
 i12 = i15 + 48 | 0;
 i8 = i15 + 32 | 0;
 i7 = i15 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i9 = i2 << 24 >> 24 != 0;
 if (i9) if ((__Z24GetExecutionRestrictionsv() | 0) & 1 | 0) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 561931 | 0, i4);
 if ((i3 | 0) == -1) {
  __ZNK11ICallStringcv8UnityStrEv(i12, i5);
  i6 = i12 + 11 | 0;
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i1 = i12 + 4 | 0;
  i2 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
  i3 = i4 ? HEAP32[i1 >> 2] | 0 : i3 & 255;
  if (!i3) i10 = 17; else {
   i4 = _memchr(i2, 47, i3) | 0;
   if ((i4 | 0) == 0 | (i4 - i2 | 0) == -1) i10 = 17; else {
    i4 = __Z16GetBuildSettingsv() | 0;
    i5 = HEAP8[i6 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    i3 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
    i5 = i2 ? HEAP32[i1 >> 2] | 0 : i5 & 255;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i3, i5);
    __ZN13BuildSettings34ConvertDisplayScenePathToScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i4, i11);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    i4 = __Z15GetSceneManagerv() | 0;
    i5 = HEAP8[i8 + 11 >> 0] | 0;
    i1 = i5 << 24 >> 24 < 0;
    i3 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
    i5 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i7 + 12 >> 2] = i1;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
     i1 = HEAP32[i7 + 12 >> 2] | 0;
     i10 = 11;
    } else if (i5 >>> 0 < 11) {
     i2 = i7 + 11 | 0;
     HEAP8[i2 >> 0] = i5;
     if (!i5) i1 = i7; else {
      i1 = i7;
      i10 = 13;
     }
    } else i10 = 11;
    if ((i10 | 0) == 11) {
     i2 = i5 + 16 & -16;
     HEAP32[i11 >> 2] = 66;
     HEAP32[i11 + 4 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i7 >> 2] = i1;
     HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
     HEAP32[i7 + 4 >> 2] = i5;
     i2 = i7 + 11 | 0;
     i10 = 13;
    }
    if ((i10 | 0) == 13) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
    HEAP8[i1 + i5 >> 0] = 0;
    i1 = __ZN19RuntimeSceneManager15FindSceneByPathERK8UnityStr(i4, i7) | 0;
    if ((HEAP8[i2 >> 0] | 0) < 0) {
     i5 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i7 + 12 >> 2] | 0;
     HEAP32[i11 >> 2] = 66;
     HEAP32[i11 + 4 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   }
  }
  if ((i10 | 0) == 17) {
   i1 = __Z15GetSceneManagerv() | 0;
   __ZNK11ICallStringcv8UnityStrEv(i8, i5);
   i1 = __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr(i1, i8) | 0;
   if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i11 + 4 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
   }
  }
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   i10 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i12;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
  }
 } else i1 = __ZN19RuntimeSceneManager21FindSceneByBuildIndexEi(__Z15GetSceneManagerv() | 0, i3) | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562020 | 0, i13);
 if (i9) {
  HEAP8[i14 >> 0] = (__ZN19RuntimeSceneManager11UnloadSceneEP10UnityScene(__Z15GetSceneManagerv() | 0, i1) | 0) & 1;
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP8[i14 >> 0] = 0;
 i1 = __ZN19RuntimeSceneManager16UnloadSceneAsyncEP10UnityScene(__Z15GetSceneManagerv() | 0, i1) | 0;
 if (!i1) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP8[i14 >> 0] = 1;
 i14 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 36 >> 2] | 0) | 0;
 HEAP32[i14 + 8 >> 2] = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN9Texture3D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i11);
 i14 = i10 + 80 | 0;
 i7 = i11 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i11 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i14, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i6 = i10 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i10 + 88 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i5 = i10 + 92 | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i2 = i10 + 76 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
 i3 = i10 + 100 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4); else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10 + 32 | 0, i11);
 i1 = i10 + 105 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i11, i13, gb + 411165 | 0, 1);
 i1 = i10 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i10 + 104 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i12 = HEAP32[i13 >> 2] | 0;
  HEAP32[i3 >> 2] = i12;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = gb + 45784 + (i9 << 2) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i12 = i9 + i12 | 0;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
  HEAP32[i1 >> 2] = i12;
  i14 = HEAP32[i14 >> 2] | 0;
  f17 = Math_fround(i14 | 0);
  f17 = Math_fround(Math_fround(1.0) / f17);
  i14 = HEAP32[i6 >> 2] | 0;
  f16 = Math_fround(i14 | 0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  i14 = i10 + 68 | 0;
  HEAPF32[i14 >> 2] = f17;
  i14 = i10 + 72 | 0;
  HEAPF32[i14 >> 2] = f16;
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i11, i14, i12, 0);
  STACKTOP = i15;
  return;
 }
 i8 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 + 48 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 mftCall_vii(i7 | 0, i8 | 0, i9 | 0);
 HEAP8[i2 >> 0] = 0;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i3 >> 2] = i12;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = gb + 45784 + (i9 << 2) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i12 = i9 + i12 | 0;
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
 HEAP32[i1 >> 2] = i12;
 i14 = HEAP32[i14 >> 2] | 0;
 f16 = Math_fround(i14 | 0);
 f16 = Math_fround(Math_fround(1.0) / f16);
 i14 = HEAP32[i6 >> 2] | 0;
 f17 = Math_fround(i14 | 0);
 f17 = Math_fround(Math_fround(1.0) / f17);
 i14 = i10 + 68 | 0;
 HEAPF32[i14 >> 2] = f16;
 i14 = i10 + 72 | 0;
 HEAPF32[i14 >> 2] = f17;
 i14 = HEAP32[i13 >> 2] | 0;
 __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i11, i14, i12, 0);
 STACKTOP = i15;
 return;
}

function __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_(i11, i12, i9, i8, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i10 = __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i11, i12, i9, i1) | 0;
 i6 = HEAP32[i8 + 16 >> 2] | 0;
 i1 = i6 & 255;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 & 255;
 i4 = (i6 & 65535) >>> 8 & 255;
 i5 = (i2 & 65535) >>> 8 & 255;
 do if (i1 << 24 >> 24 == i3 << 24 >> 24) if (i4 << 24 >> 24 == i5 << 24 >> 24) {
  if ((i6 & 65536 | 0) == 0 & (i2 & 65536 | 0) != 0) break; else i1 = i10;
  STACKTOP = i14;
  return i1 | 0;
 } else {
  if ((i4 & 255) < (i5 & 255)) break; else i1 = i10;
  STACKTOP = i14;
  return i1 | 0;
 } else if ((i1 & 255) >= (i3 & 255)) {
  i13 = i10;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP16[i9 + 16 >> 1] = HEAP16[i8 + 16 >> 1] | 0;
 HEAP8[i9 + 18 >> 0] = HEAP8[i8 + 18 >> 0] | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i8 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i8 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 i1 = i10 + 1 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 & 255;
 i8 = i12 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 & 255;
 i6 = (i2 & 65535) >>> 8 & 255;
 i7 = (i4 & 65535) >>> 8 & 255;
 do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
  if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
  STACKTOP = i14;
  return i1 | 0;
 } else {
  if ((i6 & 255) < (i7 & 255)) break;
  STACKTOP = i14;
  return i1 | 0;
 } else if ((i3 & 255) >= (i5 & 255)) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP16[i12 + 16 >> 1] = HEAP16[i9 + 16 >> 1] | 0;
 HEAP8[i12 + 18 >> 0] = HEAP8[i9 + 18 >> 0] | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i9 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i9 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 i1 = i10 + 2 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 & 255;
 i4 = HEAP32[i11 + 16 >> 2] | 0;
 i5 = i4 & 255;
 i6 = (i2 & 65535) >>> 8 & 255;
 i7 = (i4 & 65535) >>> 8 & 255;
 do if (i3 << 24 >> 24 == i5 << 24 >> 24) if (i6 << 24 >> 24 == i7 << 24 >> 24) {
  if ((i2 & 65536 | 0) == 0 & (i4 & 65536 | 0) != 0) break;
  STACKTOP = i14;
  return i1 | 0;
 } else {
  if ((i6 & 255) < (i7 & 255)) break;
  STACKTOP = i14;
  return i1 | 0;
 } else if ((i3 & 255) >= (i5 & 255)) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP16[i11 + 16 >> 1] = HEAP16[i12 + 16 >> 1] | 0;
 HEAP8[i11 + 18 >> 0] = HEAP8[i12 + 18 >> 0] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP16[i12 + 16 >> 1] = HEAP16[i13 + 16 >> 1] | 0;
 HEAP8[i12 + 18 >> 0] = HEAP8[i13 + 18 >> 0] | 0;
 i13 = i10 + 3 | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z14ClipAnimationsI11QuaternionfN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1, f32, f33, f2, i34, i35) {
 i1 = i1 | 0;
 f32 = Math_fround(f32);
 f33 = Math_fround(f33);
 f2 = Math_fround(f2);
 i34 = i34 | 0;
 i35 = i35 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i38;
 i37 = i38 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i31 = i1 + 4 | 0;
 if ((i3 | 0) == (HEAP32[i31 >> 2] | 0)) {
  STACKTOP = i38;
  return;
 }
 i16 = i37 + 12 | 0;
 i17 = i37 + 20 | 0;
 i18 = i37 + 16 | 0;
 i19 = i37 + 24 | 0;
 i20 = i37 + 96 | 0;
 i21 = i37 + 92 | 0;
 i22 = i37 + 100 | 0;
 i23 = i37 + 180 | 0;
 i24 = i37 + 184 | 0;
 i25 = i37 + 172 | 0;
 i26 = i37 + 192 | 0;
 i27 = i37 + 188 | 0;
 i28 = i37 + 196 | 0;
 i29 = i37 + 200 | 0;
 i30 = i37 + 16 | 0;
 f2 = Math_fround(Math_fround(f33 - f32) + Math_fround(Math_fround(1.0) / f2));
 i8 = i35 + 4 | 0;
 i9 = i35 + 8 | 0;
 i10 = i37 + 11 | 0;
 i11 = i37 + 8 | 0;
 i12 = i37 + 4 | 0;
 i13 = i37 + 168 | 0;
 i14 = i37 + 12 | 0;
 i15 = i36 + 4 | 0;
 do {
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  HEAP32[i16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  HEAPF32[i17 >> 2] = Math_fround(inf);
  HEAP32[i18 >> 2] = 0;
  i1 = i19;
  i4 = i1 + 68 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  HEAPF32[i20 >> 2] = Math_fround(inf);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i24 >> 2] = 0;
  i1 = i22;
  i4 = i1 + 72 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i36, gb + 63664 | 0);
  i5 = i36;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i25;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i26 >> 2] = 2;
  HEAP32[i27 >> 2] = 2;
  HEAP32[i28 >> 2] = 4;
  HEAP32[i29 >> 2] = 0;
  do if (__Z18ClipAnimationCurveI11QuaternionfEbRK17AnimationCurveTplIT_ERS3_ff(i3 + 16 | 0, i30, f32, f33) | 0) {
   do if ((i37 | 0) != (i3 | 0)) {
    i7 = HEAP8[i3 + 11 >> 0] | 0;
    i1 = i7 << 24 >> 24 < 0;
    i6 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
    i7 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
    i1 = HEAP8[i10 >> 0] | 0;
    i4 = i1 << 24 >> 24 < 0;
    if (i4) i5 = (HEAP32[i11 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     i4 = i4 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i37, i5, i7 - i5 | 0, i4, 0, i4, i7, i6);
     break;
    }
    i1 = i4 ? HEAP32[i37 >> 2] | 0 : i37;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i10 >> 0] | 0) < 0) {
     HEAP32[i12 >> 2] = i7;
     break;
    } else {
     HEAP8[i10 >> 0] = i7;
     break;
    }
   } while (0);
   HEAP32[i29 >> 2] = HEAP32[i3 + 200 >> 2];
   __ZN17AnimationCurveTplI11QuaternionfE15SetPostInfinityEi(i30, 1);
   __ZN17AnimationCurveTplI11QuaternionfE14SetPreInfinityEi(i30, 1);
   HEAP32[i28 >> 2] = HEAP32[i3 + 196 >> 2];
   if (i34) {
    __Z15AddLoopingFrameI11QuaternionfEvR17AnimationCurveTplIT_Ef(i30, f2);
    __Z35EnsureQuaternionContinuityLoopFrameR17AnimationCurveTplI11QuaternionfE(i30);
   }
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
    __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i35, i37);
    break;
   } else {
    __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1, i37);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 204;
    break;
   }
  } while (0);
  if ((HEAP32[i24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i25);
   HEAP32[i13 >> 2] = 0;
  }
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i7 = HEAP32[i37 >> 2] | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   HEAP32[i36 >> 2] = 66;
   HEAP32[i15 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i36);
  }
  i3 = i3 + 204 | 0;
 } while ((i3 | 0) != (HEAP32[i31 >> 2] | 0));
 STACKTOP = i38;
 return;
}

function __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 100 | 0, i9);
 i1 = i8 + 4 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 5 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i3 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 i3 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i1 = i8 + 20 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i5 = i8 + 28 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i5, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i1;
 }
 i2 = i8 + 32 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i9, i8 + 40 | 0, gb + 450421 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i9, i8 + 56 | 0, gb + 450458 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i9, i8 + 72 | 0, 0);
 if (Math_fround(HEAPF32[i5 >> 2]) < Math_fround(0.0)) HEAPF32[i5 >> 2] = Math_fround(0.0);
 if (!(Math_fround(HEAPF32[i2 >> 2]) < Math_fround(0.0))) {
  i10 = i8 + 92 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  i10 = i8 + 96 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  i10 = i8 + 116 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 }
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i10 = i8 + 92 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
 i10 = i8 + 96 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
 i10 = i8 + 116 | 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
 STACKTOP = i11;
 return;
}

function __ZN4gles30InitRenderTextureFormatSupportEP7ApiGLESP12GraphicsCaps(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i10 + 540 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 544 | 0;
 if ((i1 + -5 | 0) >>> 0 < 8) i1 = 1; else {
  i1 = (i1 + -2 | 0) >>> 0 < 3;
  if (!(i1 | (HEAP8[i6 >> 0] | 0) != 0)) if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605914 | 0) | 0) i1 = 1; else i1 = __ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605932 | 0) | 0;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + -5 | 0) >>> 0 < 8) i2 = 1; else {
  i2 = (i2 + -2 | 0) >>> 0 < 3;
  if (!(i2 | (HEAP8[i6 >> 0] | 0) != 0)) if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605950 | 0) | 0) i2 = 1; else if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605976 | 0) | 0) i2 = 1; else if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605997 | 0) | 0) i2 = 1; else i2 = __ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606018 | 0) | 0;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 + -5 | 0) >>> 0 < 8) i3 = 1; else {
  i3 = (i3 + -2 | 0) >>> 0 < 3;
  if (!(i3 | (HEAP8[i6 >> 0] | 0) != 0)) if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606043 | 0) | 0) i3 = 1; else if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 605976 | 0) | 0) i3 = 1; else i3 = __ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606074 | 0) | 0;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 if ((i5 + -5 | 0) >>> 0 < 8) {
  i4 = 1;
  i8 = 1;
 } else {
  i4 = (i5 + -2 | 0) >>> 0 < 3;
  do if (!(i4 | (HEAP8[i6 >> 0] | 0) != 0)) {
   if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606100 | 0) | 0) if (__ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606135 | 0) | 0) {
    i4 = 1;
    break;
   }
   i4 = __ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606165 | 0) | 0;
  } while (0);
  i5 = HEAP32[i7 >> 2] | 0;
  if ((i5 | 0) == 1) {
   i8 = __ZNK7ApiGLES14QueryExtensionEPKc(i9, gb + 606185 | 0) | 0;
   i5 = HEAP32[i7 >> 2] | 0;
  } else i8 = 1;
 }
 HEAP8[i10 + 233 >> 0] = 1;
 HEAP8[i10 + 234 >> 0] = HEAP8[i10 + 505 >> 0] | 0;
 HEAP8[i10 + 236 >> 0] = HEAP8[i10 + 507 >> 0] | 0;
 HEAP8[i10 + 237 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 4) | 0) & 1;
 HEAP8[i10 + 238 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 5) | 0) & 1;
 HEAP8[i10 + 239 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 6) | 0) & 1;
 i7 = i1 ^ 1;
 if (i7 | i2 ^ 1) {
  HEAP8[i10 + 247 >> 0] = 0;
  i6 = 0;
 } else {
  HEAP8[i10 + 247 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 14) | 0) & 1;
  i6 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 12) | 0) & 1;
 }
 HEAP8[i10 + 245 >> 0] = i6;
 if (i2) i2 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 11) | 0) & 1; else i2 = 0;
 HEAP8[i10 + 244 >> 0] = i2;
 if (i7 | i3 ^ 1) {
  HEAP8[i10 + 248 >> 0] = 0;
  i2 = 0;
 } else {
  HEAP8[i10 + 248 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 15) | 0) & 1;
  i2 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 13) | 0) & 1;
 }
 HEAP8[i10 + 246 >> 0] = i2;
 if (i3) i2 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 2) | 0) & 1; else i2 = 0;
 HEAP8[i10 + 235 >> 0] = i2;
 if (i8) i2 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 8) | 0) & 1; else i2 = 0;
 HEAP8[i10 + 241 >> 0] = i2;
 if ((i5 | 0) == 1) {
  HEAP8[i10 + 250 >> 0] = 0;
  HEAP8[i10 + 251 >> 0] = 0;
  i2 = 0;
 } else {
  HEAP8[i10 + 250 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 17) | 0) & 1;
  HEAP8[i10 + 251 >> 0] = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 18) | 0) & 1;
  i2 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 19) | 0) & 1;
 }
 HEAP8[i10 + 252 >> 0] = i2;
 HEAP8[i10 + 249 >> 0] = i1 & 1;
 HEAP8[i10 + 243 >> 0] = 0;
 if (!i4) {
  i9 = 0;
  i10 = i10 + 255 | 0;
  HEAP8[i10 >> 0] = i9;
  return;
 }
 i9 = (__ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i9, i10, 22) | 0) & 1;
 i10 = i10 + 255 | 0;
 HEAP8[i10 >> 0] = i9;
 return;
}

function __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf(i11, i3, i4, f12) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f12 = Math_fround(f12);
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f2 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f12);
 i13 = i4 + 4 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f12);
 i7 = i4 + 8 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f12);
 i9 = i4 + 16 | 0;
 f1 = Math_fround(HEAPF32[i9 >> 2]);
 f1 = Math_fround(f1 * f1);
 i8 = i4 + 20 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 f15 = Math_fround(f1 + Math_fround(f15 * f15));
 i10 = i4 + 24 | 0;
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 f1 = Math_fround(f15 + Math_fround(f1 * f1));
 i14 = i11 + 16 | 0;
 HEAPF32[i14 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i14 >> 2]));
 i14 = i11 + 20 | 0;
 HEAPF32[i14 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i14 >> 2]));
 i14 = i11 + 24 | 0;
 HEAPF32[i14 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i14 >> 2]));
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 >> 2];
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 16 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i10 >> 2];
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 f1 = Math_fround(Math_sqrt(Math_fround(f1)));
 do if (f1 > Math_fround(1.0e7)) {
  f1 = Math_fround(HEAPF32[i9 >> 2]);
  f6 = Math_fround(f1 * f1);
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f2 * f2));
  f5 = Math_fround(HEAPF32[i10 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f5 * f5));
  if (f6 > Math_fround(0.0)) {
   f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
   f1 = Math_fround(Math_fround(f1 * f15) * Math_fround(1.0e7));
   f6 = Math_fround(Math_fround(f2 * f15) * Math_fround(1.0e7));
   f15 = Math_fround(Math_fround(f5 * f15) * Math_fround(1.0e7));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i7 = 0;
   i3 = 0;
   i4 = 0;
  }
  HEAP32[i9 >> 2] = i4;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i10 >> 2] = i7;
  f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(1.0e7);
 } else if (f1 != Math_fround(0.0)) {
  f5 = Math_fround(HEAPF32[i9 >> 2]);
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  break;
 } else return; while (0);
 f17 = Math_fround(Math_fround(f1 * f12) * Math_fround(.5));
 f20 = Math_fround(+Math_cos(+f17));
 f17 = Math_fround(Math_fround(+Math_sin(+f17)) / f1);
 f18 = Math_fround(f17 * f5);
 f16 = Math_fround(f17 * f6);
 f2 = Math_fround(f17 * f2);
 f17 = Math_fround(HEAPF32[i11 >> 2]);
 f5 = Math_fround(f17 * Math_fround(0.0));
 i14 = i11 + 12 | 0;
 f19 = Math_fround(HEAPF32[i14 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f18 * f19));
 i13 = i11 + 8 | 0;
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f16 * f15));
 i10 = i11 + 4 | 0;
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(Math_fround(f20 * f17) + Math_fround(f5 - Math_fround(f2 * f1)));
 f6 = Math_fround(Math_fround(f20 * f1) + Math_fround(Math_fround(Math_fround(f17 * f2) + Math_fround(Math_fround(f16 * f19) + Math_fround(f1 * Math_fround(0.0)))) - Math_fround(f18 * f15)));
 f12 = Math_fround(Math_fround(f20 * f15) + Math_fround(Math_fround(Math_fround(f18 * f1) + Math_fround(Math_fround(f2 * f19) + Math_fround(f15 * Math_fround(0.0)))) - Math_fround(f16 * f17)));
 f15 = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(Math_fround(Math_fround(f19 * Math_fround(0.0)) - Math_fround(f18 * f17)) - Math_fround(f16 * f1)) - Math_fround(f2 * f15)));
 f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)))))));
 f6 = Math_fround(f2 * f6);
 f12 = Math_fround(f2 * f12);
 f15 = Math_fround(f2 * f15);
 HEAPF32[i11 >> 2] = Math_fround(f2 * f5);
 HEAPF32[i10 >> 2] = f6;
 HEAPF32[i13 >> 2] = f12;
 HEAPF32[i14 >> 2] = f15;
 return;
}

function __ZN5physx2Sq17SceneQueryManager17processSimUpdatesEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 48 | 0;
 i10 = i12 + 24 | 0;
 i7 = i12 + 16 | 0;
 i8 = i12;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN5physx2Sc5Scene24initActiveBodiesIteratorERNS0_12BodyIteratorE((HEAP32[i11 + 76 >> 2] | 0) + 16 | 0, i7);
 i1 = __ZN5physx2Sc12BodyIterator7getNextEv(i7) | 0;
 L1 : do if (!i1) i2 = 0; else {
  i2 = 0;
  do {
   while (1) {
    i1 = __ZNK5physx2Sc9RigidCore10getPxActorEv(i1) | 0;
    if (!(HEAP8[i1 + 64 + 45 >> 0] & 1)) {
     i4 = i1 + 20 | 0;
     i1 = HEAP16[i4 + 4 >> 1] | 0;
     i3 = i4 + 8 | 0;
     if ((HEAP16[i4 + 12 >> 1] | 0) != 1) i3 = HEAP32[i3 >> 2] | 0;
     if (i1 << 16 >> 16) break;
    }
    i1 = __ZN5physx2Sc12BodyIterator7getNextEv(i7) | 0;
    if (!i1) break L1;
   }
   i6 = i1 & 65535;
   i1 = 0;
   do {
    i4 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (i4) {
     HEAP32[i8 + (i2 << 2) >> 2] = i4;
     i2 = i2 + 1 | 0;
    }
    if ((i2 | 0) == 4) {
     i5 = 0;
     do {
      i13 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
      i2 = i13 & 1;
      i4 = i13 >>> 2;
      if (!(1 << (i4 & 31) & HEAP32[(HEAP32[i11 + 28 + (i2 * 12 | 0) >> 2] | 0) + (i13 >>> 7 << 2) >> 2])) {
       HEAP32[i9 >> 2] = i4;
       i13 = i11 + 12 + (i2 << 2) | 0;
       i4 = HEAP32[i13 >> 2] | 0;
       i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0, i9 | 0) | 0;
       __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i10, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
       i4 = i11 + 20 + (i2 << 2) | 0;
       HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
       i13 = HEAP32[i13 >> 2] | 0;
       mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i9 | 0, i10 | 0, 1);
      }
      i5 = i5 + 1 | 0;
     } while ((i5 | 0) != 4);
     i2 = 0;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
   i1 = __ZN5physx2Sc12BodyIterator7getNextEv(i7) | 0;
  } while ((i1 | 0) != 0);
 } while (0);
 if (i2 | 0) {
  i4 = 0;
  do {
   i13 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
   i1 = i13 & 1;
   i3 = i13 >>> 2;
   if (!(1 << (i3 & 31) & HEAP32[(HEAP32[i11 + 28 + (i1 * 12 | 0) >> 2] | 0) + (i13 >>> 7 << 2) >> 2])) {
    HEAP32[i9 >> 2] = i3;
    i13 = i11 + 12 + (i1 << 2) | 0;
    i7 = HEAP32[i13 >> 2] | 0;
    i7 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i9 | 0) | 0;
    __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i10, HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0);
    i7 = i11 + 20 + (i1 << 2) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i13 = HEAP32[i13 >> 2] | 0;
    mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i9 | 0, i10 | 0, 1);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 i1 = i11 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i11 + 52 | 0;
  i4 = 0;
  do {
   i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i8 = i7 & 1;
   i13 = i7 >>> 2;
   i7 = (HEAP32[i11 + 28 + (i8 * 12 | 0) >> 2] | 0) + (i7 >>> 7 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << (i13 & 31));
   HEAP32[i9 >> 2] = i13;
   i13 = i11 + 12 + (i8 << 2) | 0;
   i7 = HEAP32[i13 >> 2] | 0;
   i7 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i9 | 0) | 0;
   __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i10, HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0);
   i8 = i11 + 20 + (i8 << 2) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i13 = HEAP32[i13 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i9 | 0, i10 | 0, 1);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 HEAP32[i1 >> 2] = 0;
 i2 = i11 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i11 + 64 >> 2] | 0) == 1) {
  __ZN5physx2Sq10AABBPruner9buildStepEv(i1) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i1 = i11 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i11 + 68 >> 2] | 0) != 1) {
  i13 = i2;
  i11 = HEAP32[i13 >> 2] | 0;
  i11 = i11 + 12 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i13 | 0);
  STACKTOP = i12;
  return;
 }
 __ZN5physx2Sq10AABBPruner9buildStepEv(i2) | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i13 >> 2] | 0;
 i11 = i11 + 12 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vi(i11 | 0, i13 | 0);
 STACKTOP = i12;
 return;
}

function __ZN17AudioReverbFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863992 | 0, i5, i1 + 44 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864003 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864010 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864019 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864033 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864045 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864060 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864079 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864093 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864107 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864119 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864129 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864143 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864152 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864166 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864185 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIffEEPfEEvT0_S5_T_(i1, i4, i13) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i4;
  i14 = i4 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i5 = i12 - i11 | 0;
    i6 = i5 >> 2;
    switch (i6 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i5 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i9 = i1 + (((i6 | 0) / 2 | 0) << 2) | 0;
    if ((i5 | 0) > 3996) {
     i5 = (i6 | 0) / 4 | 0;
     i5 = __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i5 << 2) | 0, i9, i9 + (i5 << 2) | 0, i14, i13) | 0;
    } else i5 = __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i1, i9, i14, i13) | 0;
    f8 = Math_fround(HEAPF32[i1 >> 2]);
    f2 = Math_fround(HEAPF32[i9 >> 2]);
    if (f8 < f2) {
     i6 = i14;
     break;
    } else i6 = i14;
    while (1) {
     i6 = i6 + -4 | 0;
     if ((i1 | 0) == (i6 | 0)) break;
     f3 = Math_fround(HEAPF32[i6 >> 2]);
     if (f3 < f2) {
      i15 = 29;
      break L5;
     }
    }
    i5 = i1 + 4 | 0;
    f3 = Math_fround(HEAPF32[i14 >> 2]);
    if (!(f8 < f3)) {
     while (1) {
      if ((i5 | 0) == (i14 | 0)) break L1;
      f2 = Math_fround(HEAPF32[i5 >> 2]);
      if (f8 < f2) break;
      i5 = i5 + 4 | 0;
     }
     HEAPF32[i5 >> 2] = f3;
     HEAPF32[i14 >> 2] = f2;
     i5 = i5 + 4 | 0;
    }
    if ((i5 | 0) == (i14 | 0)) break L1; else i6 = i14;
    while (1) {
     f8 = Math_fround(HEAPF32[i1 >> 2]);
     while (1) {
      f3 = Math_fround(HEAPF32[i5 >> 2]);
      i7 = i5 + 4 | 0;
      if (f8 < f3) break; else i5 = i7;
     }
     do {
      i6 = i6 + -4 | 0;
      f2 = Math_fround(HEAPF32[i6 >> 2]);
     } while (f8 < f2);
     if (i5 >>> 0 >= i6 >>> 0) {
      i1 = i5;
      continue L5;
     }
     HEAPF32[i5 >> 2] = f2;
     HEAPF32[i6 >> 2] = f3;
     i5 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAPF32[i1 >> 2] = f3;
    HEAPF32[i6 >> 2] = f8;
    i5 = i5 + 1 | 0;
   }
   i7 = i1 + 4 | 0;
   L35 : do if (i7 >>> 0 < i6 >>> 0) {
    i10 = i9;
    while (1) {
     f8 = Math_fround(HEAPF32[i10 >> 2]);
     while (1) {
      f3 = Math_fround(HEAPF32[i7 >> 2]);
      i9 = i7 + 4 | 0;
      if (f3 < f8) i7 = i9; else break;
     }
     do {
      i6 = i6 + -4 | 0;
      f2 = Math_fround(HEAPF32[i6 >> 2]);
     } while (!(f2 < f8));
     if (i7 >>> 0 > i6 >>> 0) {
      i6 = i10;
      break L35;
     }
     HEAPF32[i7 >> 2] = f2;
     HEAPF32[i6 >> 2] = f3;
     i10 = (i10 | 0) == (i7 | 0) ? i6 : i10;
     i7 = i9;
     i5 = i5 + 1 | 0;
    }
   } else i6 = i9; while (0);
   if ((i7 | 0) != (i6 | 0)) {
    f2 = Math_fround(HEAPF32[i6 >> 2]);
    f3 = Math_fround(HEAPF32[i7 >> 2]);
    if (f2 < f3) {
     HEAPF32[i7 >> 2] = f2;
     HEAPF32[i6 >> 2] = f3;
     i5 = i5 + 1 | 0;
    }
   }
   if (!i5) {
    i5 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIffEEPfEEbT0_S5_T_(i1, i7, i13) | 0;
    i6 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIffEEPfEEbT0_S5_T_(i6, i4, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i5) {
     i1 = i6;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIffEEPfEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIffEEPfEEvT0_S5_T_(i7 + 4 | 0, i4, i13);
   i4 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i5) break; else {
    i4 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  f2 = Math_fround(HEAPF32[i14 >> 2]);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  if (f2 < f3) {
   HEAPF32[i1 >> 2] = f2;
   HEAPF32[i14 >> 2] = f3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIffEEPfEEvT0_S5_T_(i1, i4, i13);
 return;
}

function __ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_(i27, i28, i24, i2, i3, i25, i26) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var f1 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i29;
 f10 = Math_fround(HEAPF32[i28 >> 2]);
 f11 = Math_fround(HEAPF32[i27 >> 2]);
 f10 = Math_fround(f10 - f11);
 i21 = i28 + 4 | 0;
 f13 = Math_fround(HEAPF32[i21 >> 2]);
 i22 = i27 + 4 | 0;
 f12 = Math_fround(HEAPF32[i22 >> 2]);
 f13 = Math_fround(f13 - f12);
 i23 = i28 + 8 | 0;
 f8 = Math_fround(HEAPF32[i23 >> 2]);
 i18 = i27 + 8 | 0;
 f9 = Math_fround(HEAPF32[i18 >> 2]);
 f8 = Math_fround(f8 - f9);
 HEAPF32[i17 >> 2] = f10;
 HEAPF32[i17 + 4 >> 2] = f13;
 HEAPF32[i17 + 8 >> 2] = f8;
 i19 = i24 + 8 | 0;
 f15 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(f13 * f15);
 i20 = i24 + 4 | 0;
 f1 = Math_fround(HEAPF32[i20 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f8 * f1));
 f16 = Math_fround(HEAPF32[i24 >> 2]);
 f15 = Math_fround(Math_fround(f8 * f16) - Math_fround(f15 * f10));
 f16 = Math_fround(Math_fround(f1 * f10) - Math_fround(f13 * f16));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f15 * f12)) + Math_fround(f16 * f9));
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f14 * f12);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f15 * f13));
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(Math_fround(f11 + Math_fround(f16 * f10)) - f9);
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(f14 * f1);
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f15 * f4));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 if (Math_fround(f11 * Math_fround(Math_fround(f8 + Math_fround(f16 * f7)) - f9)) > Math_fround(0.0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 f9 = Math_fround(f1 - f12);
 f8 = Math_fround(f4 - f13);
 f1 = Math_fround(f7 - f10);
 f4 = Math_fround(Math_fround(Math_fround(f14 * f9) + Math_fround(f15 * f8)) + Math_fround(f16 * f1));
 if (f4 == Math_fround(0.0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 f11 = Math_fround(f11 / f4);
 f13 = Math_fround(f13 - Math_fround(f8 * f11));
 f4 = Math_fround(f10 - Math_fround(f1 * f11));
 HEAPF32[i26 >> 2] = Math_fround(f12 - Math_fround(f9 * f11));
 i5 = i26 + 4 | 0;
 HEAPF32[i5 >> 2] = f13;
 i6 = i26 + 8 | 0;
 HEAPF32[i6 >> 2] = f4;
 f4 = Math_fround(Math_abs(Math_fround(f14)));
 f15 = Math_fround(Math_abs(Math_fround(f15)));
 f1 = Math_fround(Math_abs(Math_fround(f16)));
 if (f15 > f4 & f15 > f1) {
  i2 = 2;
  i3 = 0;
 } else if (f1 > f4) {
  i2 = 0;
  i3 = 1;
 } else {
  i2 = 1;
  i3 = 2;
 }
 f16 = Math_fround(HEAPF32[i17 + (i2 << 2) >> 2]);
 f14 = Math_fround(HEAPF32[i26 + (i3 << 2) >> 2]);
 f14 = Math_fround(f16 * Math_fround(f14 - Math_fround(HEAPF32[i27 + (i3 << 2) >> 2])));
 f1 = Math_fround(HEAPF32[i17 + (i3 << 2) >> 2]);
 f15 = Math_fround(HEAPF32[i26 + (i2 << 2) >> 2]);
 f15 = Math_fround(f14 - Math_fround(f1 * Math_fround(f15 - Math_fround(HEAPF32[i27 + (i2 << 2) >> 2]))));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i24 + (i3 << 2) >> 2]));
 f1 = Math_fround(f15 / Math_fround(f16 - Math_fround(f1 * Math_fround(HEAPF32[i24 + (i2 << 2) >> 2]))));
 HEAPF32[i25 >> 2] = f1;
 if (f1 < Math_fround(0.0)) {
  i28 = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 f13 = Math_fround(HEAPF32[i24 >> 2]);
 f14 = Math_fround(HEAPF32[i20 >> 2]);
 f13 = Math_fround(f1 * f13);
 f14 = Math_fround(f1 * f14);
 f16 = Math_fround(f1 * Math_fround(HEAPF32[i19 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i26 >> 2]) - f13);
 HEAPF32[i26 >> 2] = f13;
 f14 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f14);
 HEAPF32[i5 >> 2] = f14;
 f16 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f16);
 HEAPF32[i6 >> 2] = f16;
 f15 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) - f13);
 f13 = Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f13));
 f15 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f14);
 f14 = Math_fround(f13 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f14)));
 f15 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f16);
 i28 = Math_fround(f14 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f16))) < Math_fround(.00100000005);
 STACKTOP = i29;
 return i28 | 0;
}

function __ZN5physx22PxcDiscreteNarrowPhaseERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 32 | 0;
 i12 = i17;
 i10 = i17 + 60 | 0;
 i14 = i17 + 64 | 0;
 i1 = HEAP16[i16 + 22 >> 1] | 0;
 if (!(i1 & 512)) {
  STACKTOP = i17;
  return;
 }
 i1 = i1 & 65535;
 if (!(i1 & 32)) i4 = 0; else i4 = (HEAP8[(HEAP32[i16 + 64 >> 2] | 0) + 29 >> 0] & 1) == 0;
 if (!(i1 & 64)) i3 = 0; else i3 = (HEAP8[(HEAP32[i16 + 68 >> 2] | 0) + 29 >> 0] & 1) == 0;
 i1 = HEAP8[i16 + 96 >> 0] | 0;
 i6 = i1 & 255;
 i2 = HEAP8[i16 + 97 >> 0] | 0;
 i7 = i2 & 255;
 if (!(i4 | i3)) {
  i1 = (i2 & 255) < (i1 & 255);
  if (!(HEAP8[i15 + 8757 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(i1 ? i6 : i7) + (gb + 718441 + ((i1 ? i7 : i6) * 7 | 0)) >> 0] | 0) != 0;
  __Z11CopyBuffersRN5physx13PxcNpWorkUnitERNS_18PxcNpThreadContextEb(i16, i15, i1);
  STACKTOP = i17;
  return;
 }
 i18 = HEAP32[i16 + 72 >> 2] | 0;
 i3 = HEAP32[i16 + 76 >> 2] | 0;
 i20 = HEAP32[i16 + 100 >> 2] | 0;
 i4 = HEAP32[i16 + 104 >> 2] | 0;
 i9 = (i2 & 255) < (i1 & 255);
 i8 = i9 ? i7 : i6;
 i1 = i9 ? i6 : i7;
 i19 = i9 ? i4 : i20;
 i2 = i9 ? i20 : i4;
 i4 = i15 + 104 + (i8 * 28 | 0) + (i1 << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = HEAP32[gb + 104632 + (i8 * 28 | 0) + (i1 << 2) >> 2] | 0;
 i6 = i15 + 4480 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP16[i16 + 98 >> 1] = 0;
 HEAP16[i16 + 20 >> 1] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP16[i16 + 16 >> 1] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 0;
 HEAP32[i16 + 32 >> 2] = 0;
 i7 = HEAP32[(HEAP32[i15 + 8752 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 + (i19 * 28 | 0) >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i7 + (i19 * 28 | 0) + 24 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i7 + (i2 * 28 | 0) >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i7 + (i2 * 28 | 0) + 24 >> 2];
 i2 = i9 ? i3 : i18;
 f5 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 i3 = i9 ? i18 : i3;
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 + 28 >> 2]));
 HEAPF32[i10 >> 2] = f5;
 if (!(HEAP8[i15 + 8757 >> 0] | 0)) i13 = 13; else if (!(HEAP8[gb + 718441 + (i8 * 7 | 0) + i1 >> 0] | 0)) i13 = 13; else __ZN5physx21PxcCacheLocalContactsENS_14PxGeometryType4EnumES1_RNS_18PxcNpThreadContextERNS_10PxcNpCacheERKNS_11PxTransformES8_fPFbRKNS_2Gu13GeometryUnionESC_S8_S8_RKfS5_RNS9_13ContactBufferEESC_SC_(i8, i1, i15, i16 + 44 | 0, i11, i12, f5, i4, i2 + 36 | 0, i3 + 36 | 0);
 if ((i13 | 0) == 13) mftCall_iiiiiiii(i4 | 0, i2 + 36 | 0, i3 + 36 | 0, i11 | 0, i12 | 0, i10 | 0, i16 + 44 | 0, i15 + 384 | 0) | 0;
 mftCall_iiiii(HEAP32[gb + 104828 + (i8 * 28 | 0) + (i1 << 2) >> 2] | 0, i2 | 0, i3 | 0, i15 | 0, i14 | 0) | 0;
 if (!((HEAP32[i6 >> 2] | 0) == 0 | i9 ^ 1)) {
  i1 = 0;
  do {
   i20 = i15 + 384 + (i1 << 6) | 0;
   f22 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
   i18 = i15 + 384 + (i1 << 6) + 4 | 0;
   f21 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
   i19 = i15 + 384 + (i1 << 6) + 8 | 0;
   f5 = Math_fround(-Math_fround(HEAPF32[i19 >> 2]));
   HEAPF32[i20 >> 2] = f22;
   HEAPF32[i18 >> 2] = f21;
   HEAPF32[i19 >> 2] = f5;
   i19 = i15 + 384 + (i1 << 6) + 48 | 0;
   i18 = i15 + 384 + (i1 << 6) + 52 | 0;
   i20 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i18 >> 2] = i20;
   i18 = i14 + (i1 << 2) | 0;
   i20 = i14 + (i1 << 2) + 2 | 0;
   i19 = HEAP16[i18 >> 1] | 0;
   HEAP16[i18 >> 1] = HEAP16[i20 >> 1] | 0;
   HEAP16[i20 >> 1] = i19;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i16, i15, i14) | 0;
 STACKTOP = i17;
 return;
}

function __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i9, i10, i6, gb + 166696 | 0, i7);
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj531ENS_22PxRepXPropertyAccessorILj531ES4_ffEEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 32 | 0, i10 + 2 | 0);
 i5 = i6 + 48 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj533ENS_22PxRepXPropertyAccessorILj533ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 40 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 32 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 16 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx58PxVehicleDriveTankSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE(i2, i5, f3, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var f1 = f0, i6 = 0, i7 = 0;
 i7 = (HEAP8[i5 + 24 >> 0] | 0) == 0;
 i6 = i4 + 128 | 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 0));
 if (i7) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) * f3)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f3));
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 i7 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 0, i7 ? Math_fround(1.0) : f1);
 i7 = (HEAP8[i5 + 27 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 3));
 if (i7) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 76 >> 2]) * f3)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * f3));
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 i7 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 3, i7 ? Math_fround(1.0) : f1);
 i7 = (HEAP8[i5 + 28 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 4));
 if (i7) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 80 >> 2]) * f3)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f3));
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 i7 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 4, i7 ? Math_fround(1.0) : f1);
 i7 = (HEAP8[i5 + 25 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 1));
 if (i7) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 68 >> 2]) * f3)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f3));
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 i7 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 1, i7 ? Math_fround(1.0) : f1);
 i7 = (HEAP8[i5 + 26 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 2));
 if (i7) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * f3)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f3));
 i7 = f1 < Math_fround(0.0);
 f3 = i7 ? Math_fround(0.0) : f1;
 i7 = f3 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 2, i7 ? Math_fround(1.0) : f3);
 HEAP8[i4 + 193 >> 0] = HEAP8[i5 + 29 >> 0] | 0;
 HEAP8[i4 + 194 >> 0] = HEAP8[i5 + 30 >> 0] | 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case 1:
  {
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 3, Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 3)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 1))));
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 1, Math_fround(0.0));
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 4, Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 4)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 2))));
   __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 2, Math_fround(0.0));
   return;
  }
 case 0:
  {
   f1 = Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 3)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 1)));
   if (f1 > Math_fround(0.0)) {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 3, f1);
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 1, Math_fround(0.0));
   } else {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 3, Math_fround(0.0));
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 1, Math_fround(-f1));
   }
   f1 = Math_fround(Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 4)) - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i6, 2)));
   if (f1 > Math_fround(0.0)) {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 4, f1);
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 2, Math_fround(0.0));
    return;
   } else {
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 4, Math_fround(0.0));
    __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i6, 2, Math_fround(-f1));
    return;
   }
  }
 default:
  return;
 }
}

function __ZN7mecanim9animation27GetWeightsFreeformCartesianERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb(i21, i19, i13, i22, f2, f4, i5) {
 i21 = i21 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i22 = i22 | 0;
 f2 = Math_fround(f2);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 4 | 0;
 i23 = i25;
 i1 = i21 + 4 | 0;
 i24 = HEAP32[i1 >> 2] | 0;
 i1 = (i24 | 0) == 0 ? 0 : i24 + i1 | 0;
 i24 = HEAP32[i21 >> 2] | 0;
 i17 = i21 + 36 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i17 = (i18 | 0) == 0 ? 0 : i18 + i17 | 0;
 i18 = (i24 | 0) == 0;
 if (!i18) {
  i3 = 0;
  do {
   f11 = Math_fround(f2 - Math_fround(HEAPF32[i1 + (i3 << 3) >> 2]));
   f12 = Math_fround(f4 - Math_fround(HEAPF32[i1 + (i3 << 3) + 4 >> 2]));
   HEAPF32[i22 + (i3 << 3) >> 2] = f11;
   HEAPF32[i22 + (i3 << 3) + 4 >> 2] = f12;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i24 | 0));
 }
 i1 = (i24 | 0) != 0;
 if (i5) {
  if (!i1) {
   STACKTOP = i25;
   return;
  }
  i5 = i21 + 20 | 0;
  i7 = i5;
  i8 = i21 + 28 | 0;
  i9 = i8;
  i1 = 0;
  do {
   i10 = i13 + (i1 << 2) | 0;
   HEAP32[i10 >> 2] = -1;
   f11 = Math_fround(HEAPF32[i22 + (i1 << 3) >> 2]);
   f12 = Math_fround(HEAPF32[i22 + (i1 << 3) + 4 >> 2]);
   HEAP32[i20 >> 2] = 1065353216;
   i3 = 0;
   f2 = Math_fround(1.0);
   f4 = Math_fround(1.0);
   do {
    if ((i1 | 0) != (i3 | 0)) {
     i19 = (Math_imul(HEAP32[i21 >> 2] | 0, i3) | 0) + i1 | 0;
     i18 = (HEAP32[i5 >> 2] | 0) + i7 | 0;
     f6 = Math_fround(HEAPF32[i18 + (i19 << 3) >> 2]);
     f6 = Math_fround(Math_fround(f11 * f6) + Math_fround(f12 * Math_fround(HEAPF32[i18 + (i19 << 3) + 4 >> 2])));
     f6 = Math_fround(Math_fround(1.0) - Math_fround(f6 * Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + i9 + (i19 << 2) >> 2])));
     HEAPF32[i23 >> 2] = f6;
     if (f6 <= Math_fround(0.0)) {
      i14 = 10;
      break;
     }
     if (f6 < f4) HEAP32[i10 >> 2] = i3;
     i19 = HEAP32[(f6 < f2 ? i23 : i20) >> 2] | 0;
     HEAP32[i20 >> 2] = i19;
     f4 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f2 = f4;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i24 >>> 0);
   if ((i14 | 0) == 10) {
    i14 = 0;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i10 >> 2] = -1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i24 | 0));
  STACKTOP = i25;
  return;
 }
 if (i1) {
  i13 = i21 + 20 | 0;
  i14 = i13;
  i15 = i21 + 28 | 0;
  i16 = i15;
  i10 = 0;
  do {
   f6 = Math_fround(HEAPF32[i22 + (i10 << 3) >> 2]);
   f11 = Math_fround(HEAPF32[i22 + (i10 << 3) + 4 >> 2]);
   HEAP32[i20 >> 2] = 1065353216;
   i8 = i17 + (i10 << 3) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   L30 : do if (!i3) i1 = 1065353216; else {
    i9 = i17 + (i10 << 3) + 4 | 0;
    i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
    i7 = 0;
    i1 = 1065353216;
    f4 = Math_fround(1.0);
    while (1) {
     i5 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
     if ((i10 | 0) == (i5 | 0)) f2 = f4; else {
      i5 = (Math_imul(HEAP32[i21 >> 2] | 0, i5) | 0) + i10 | 0;
      i3 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
      f2 = Math_fround(HEAPF32[i3 + (i5 << 3) >> 2]);
      f2 = Math_fround(Math_fround(f6 * f2) + Math_fround(f11 * Math_fround(HEAPF32[i3 + (i5 << 3) + 4 >> 2])));
      f2 = Math_fround(Math_fround(1.0) - Math_fround(f2 * Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + i16 + (i5 << 2) >> 2])));
      HEAPF32[i23 >> 2] = f2;
      if (f2 < Math_fround(0.0)) break;
      i1 = HEAP32[(f2 < f4 ? i23 : i20) >> 2] | 0;
      HEAP32[i20 >> 2] = i1;
      f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
      i3 = HEAP32[i8 >> 2] | 0;
     }
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 >= i3 >>> 0) break L30; else f4 = f2;
    }
    HEAP32[i20 >> 2] = 0;
    i1 = 0;
   } while (0);
   HEAP32[i19 + (i10 << 2) >> 2] = i1;
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i24 | 0));
 }
 if (i18) {
  STACKTOP = i25;
  return;
 } else {
  i1 = 0;
  f2 = Math_fround(0.0);
 }
 do {
  f2 = Math_fround(f2 + Math_fround(HEAPF32[i19 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i24 | 0));
 f2 = Math_fround(Math_fround(1.0) / f2);
 if (i18) {
  STACKTOP = i25;
  return;
 } else i1 = 0;
 do {
  i23 = i19 + (i1 << 2) | 0;
  HEAPF32[i23 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i23 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i24 | 0));
 STACKTOP = i25;
 return;
}

function __ZN6Shader20CreateFromParsedFormEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 56 | 0;
 i16 = i21 + 48 | 0;
 i15 = i21 + 40 | 0;
 i12 = i21 + 32 | 0;
 i17 = i21 + 24 | 0;
 i11 = i21 + 16 | 0;
 i10 = i21 + 8 | 0;
 i9 = i21;
 i1 = i21 + 52 | 0;
 if ((HEAP16[gb + 1166256 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i14;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166256 | 0, i13);
  i18 = gb + 1166256 | 0;
 } else i18 = 0;
 i19 = __Z20push_allocation_rootPvP13BaseAllocatorb(i14, 0, 0) | 0;
 HEAP8[i14 + 93 >> 0] = 0;
 i20 = i14 + 32 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[gb + 1166244 >> 2] | 0)) {
  if ((HEAP32[i14 + 4 >> 2] | 0) == (HEAP32[gb + 1188344 >> 2] | 0)) HEAP32[gb + 1188348 >> 2] = 0;
  if (i1 | 0) __ZN9ShaderLab9IntShaderD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  HEAP32[i20 >> 2] = 0;
 }
 i8 = i14 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP8[i3 + 24 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) i1 = HEAP32[i3 + 28 >> 2] | 0; else i1 = i4 & 255;
 do if (i1 | 0) {
  i1 = i14 + 44 | 0;
  i2 = i3 + 24 | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i7 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
   i6 = i5 ? HEAP32[i3 + 28 >> 2] | 0 : i4 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i14 + 52 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i6 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i14 + 48 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
    break;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i14 + 48 >> 2] = i6;
    break;
   } else {
    HEAP8[i4 >> 0] = i6;
    break;
   }
  }
 } while (0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = __ZN9ShaderLab9IntShader26CreateFromSerializedShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_(i2, i14 + 80 | 0, (HEAP8[i14 + 92 >> 0] | 0) != 0, i14) | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  if (!(HEAP8[i2 + 84 >> 0] | 0)) {
   _printf_console(gb + 471981 | 0, i9);
   HEAP32[i10 >> 2] = gb + 471996;
   _printf_console(gb + 1074693 | 0, i10);
  }
  __ZN9ShaderLab9IntShaderD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  i1 = 0;
 }
 HEAP32[i20 >> 2] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) __ZN9ShaderLab16SerializedShaderD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[i8 >> 2] = 0;
 i1 = i14 + 76 | 0;
 i2 = i14 + 60 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i14 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i14 + 72 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i14 + 36 >> 2] = 0;
 HEAP32[i14 + 40 >> 2] = 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) {
  _printf_console(gb + 480440 | 0, i11);
  i1 = i14 + 44 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i17 >> 2] = i1;
  _printf_console(gb + 472076 | 0, i17);
  HEAP32[i20 >> 2] = HEAP32[gb + 1166244 >> 2];
 } else if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  _printf_console(gb + 471981 | 0, i12);
  i1 = i14 + 44 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  _printf_console(gb + 472124 | 0, i15);
  i1 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 92 >> 2] | 0, i14 | 0) | 0;
  HEAP32[i16 >> 2] = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  _snprintf(i13, 255, gb + 472177 | 0, i16) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i13, 0, gb + 470432 | 0, 606, 1, HEAP32[i14 + 4 >> 2] | 0, 0, 0);
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1 | 0) __ZN9ShaderLab9IntShaderD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  HEAP32[i20 >> 2] = HEAP32[gb + 1166244 >> 2];
 }
 if (i19) __Z19pop_allocation_rootv();
 if (!i18) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i21;
 return;
}

function __ZN13AnimationClip18AddQuaternionCurveERK17AnimationCurveTplI11QuaternionfERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i10, i12) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14;
 i6 = i14 + 8 | 0;
 i13 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAPF32[i6 + 20 >> 2] = Math_fround(inf);
 HEAP32[i6 + 16 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i8 = i7 + 68 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAPF32[i6 + 96 >> 2] = Math_fround(inf);
 HEAP32[i6 + 92 >> 2] = 0;
 HEAP32[i6 + 180 >> 2] = 0;
 i3 = i6 + 184 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 172 | 0;
 i7 = i6 + 100 | 0;
 i8 = i7 + 72 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i6 + 192 >> 2] = 2;
 HEAP32[i6 + 188 >> 2] = 2;
 HEAP32[i6 + 196 >> 2] = 4;
 HEAP32[i6 + 200 >> 2] = 0;
 i11 = i2 + 104 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 108 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i2 + 100 | 0, i6); else {
  __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1, i6);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 204;
 }
 i1 = i6 + 168 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i2 = i9 + -188 | 0;
 i7 = i2;
 i1 = i10;
 i8 = i7 + 76 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i7 = i9 + -112 | 0;
 i1 = i10 + 76 | 0;
 i8 = i7 + 76 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i5 = i9 + -36 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  i6 = HEAP32[i10 + 152 >> 2] | 0;
  i7 = i9 + -24 | 0;
  i1 = (HEAP32[i10 + 164 >> 2] | 0) * 52 | 0;
  i2 = (i1 | 0) / 52 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i9 + -20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
 }
 i6 = i9 + -16 | 0;
 i1 = i10 + 172 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = i6 + -204 | 0;
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i8 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + -196 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + -200 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + -200 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i14;
 return;
}

function runPostSets55() {
 HEAP32[gb + 65992 >> 2] = fb + 68;
 HEAP32[gb + 65996 >> 2] = fb + 88;
 HEAP32[gb + 66e3 >> 2] = fb + 69;
 HEAP32[gb + 66004 >> 2] = fb + 60;
 HEAP32[gb + 66008 >> 2] = fb + 1;
 HEAP32[gb + 66012 >> 2] = fb + 719;
 HEAP32[gb + 66016 >> 2] = fb + 51;
 HEAP32[gb + 66020 >> 2] = fb + 720;
 HEAP32[gb + 66024 >> 2] = fb + 89;
 HEAP32[gb + 66028 >> 2] = fb + 90;
 HEAP32[gb + 66032 >> 2] = fb + 572;
 HEAP32[gb + 66044 >> 2] = fb + 721;
 HEAP32[gb + 66048 >> 2] = fb + 722;
 HEAP32[gb + 66052 >> 2] = fb + 38;
 HEAP32[gb + 66056 >> 2] = fb + 39;
 HEAP32[gb + 66060 >> 2] = fb + 16;
 HEAP32[gb + 66064 >> 2] = fb + 39;
 HEAP32[gb + 66068 >> 2] = fb + 40;
 HEAP32[gb + 66072 >> 2] = fb + 19;
 HEAP32[gb + 66076 >> 2] = fb + 315;
 HEAP32[gb + 66080 >> 2] = fb + 31;
 HEAP32[gb + 66084 >> 2] = fb + 27;
 HEAP32[gb + 66088 >> 2] = fb + 316;
 HEAP32[gb + 66092 >> 2] = fb + 28;
 HEAP32[gb + 66096 >> 2] = fb + 63;
 HEAP32[gb + 66100 >> 2] = fb + 29;
 HEAP32[gb + 66104 >> 2] = fb + 34;
 HEAP32[gb + 66108 >> 2] = fb + 573;
 HEAP32[gb + 66112 >> 2] = fb + 574;
 HEAP32[gb + 66116 >> 2] = fb + 575;
 HEAP32[gb + 66120 >> 2] = fb + 576;
 HEAP32[gb + 66124 >> 2] = fb + 577;
 HEAP32[gb + 66128 >> 2] = fb + 578;
 HEAP32[gb + 66132 >> 2] = fb + 36;
 HEAP32[gb + 66144 >> 2] = fb + 659;
 HEAP32[gb + 66148 >> 2] = fb + 723;
 HEAP32[gb + 66152 >> 2] = fb + 86;
 HEAP32[gb + 66156 >> 2] = fb + 4;
 HEAP32[gb + 66160 >> 2] = fb + 87;
 HEAP32[gb + 66164 >> 2] = fb + 68;
 HEAP32[gb + 66168 >> 2] = fb + 88;
 HEAP32[gb + 66172 >> 2] = fb + 69;
 HEAP32[gb + 66176 >> 2] = fb + 60;
 HEAP32[gb + 66180 >> 2] = fb + 1;
 HEAP32[gb + 66184 >> 2] = fb + 724;
 HEAP32[gb + 66188 >> 2] = fb + 51;
 HEAP32[gb + 66192 >> 2] = fb + 725;
 HEAP32[gb + 66196 >> 2] = fb + 89;
 HEAP32[gb + 66200 >> 2] = fb + 317;
 HEAP32[gb + 66204 >> 2] = fb + 579;
 HEAP32[gb + 66216 >> 2] = fb + 708;
 HEAP32[gb + 66220 >> 2] = fb + 726;
 HEAP32[gb + 66224 >> 2] = fb + 86;
 HEAP32[gb + 66228 >> 2] = fb + 4;
 HEAP32[gb + 66232 >> 2] = fb + 87;
 HEAP32[gb + 66236 >> 2] = fb + 68;
 HEAP32[gb + 66240 >> 2] = fb + 88;
 HEAP32[gb + 66244 >> 2] = fb + 69;
 HEAP32[gb + 66248 >> 2] = fb + 60;
 HEAP32[gb + 66252 >> 2] = fb + 1;
 HEAP32[gb + 66256 >> 2] = fb + 710;
 HEAP32[gb + 66260 >> 2] = fb + 50;
 HEAP32[gb + 66264 >> 2] = fb + 62;
 HEAP32[gb + 66268 >> 2] = fb + 89;
 HEAP32[gb + 66272 >> 2] = fb + 90;
 HEAP32[gb + 66276 >> 2] = fb + 70;
 HEAP32[gb + 66352 >> 2] = (HEAP32[gb + 66352 >> 2] | 0) + (gb + 462502 | 0);
 HEAP32[gb + 66356 >> 2] = (HEAP32[gb + 66356 >> 2] | 0) + (gb + 462509 | 0);
 HEAP32[gb + 66360 >> 2] = (HEAP32[gb + 66360 >> 2] | 0) + (gb + 1018413 | 0);
 HEAP32[gb + 66364 >> 2] = (HEAP32[gb + 66364 >> 2] | 0) + (gb + 779352 | 0);
 HEAP32[gb + 66368 >> 2] = (HEAP32[gb + 66368 >> 2] | 0) + (gb + 896226 | 0);
 HEAP32[gb + 66372 >> 2] = (HEAP32[gb + 66372 >> 2] | 0) + (gb + 462517 | 0);
 HEAP32[gb + 66376 >> 2] = (HEAP32[gb + 66376 >> 2] | 0) + (gb + 462520 | 0);
 HEAP32[gb + 66380 >> 2] = (HEAP32[gb + 66380 >> 2] | 0) + (gb + 773288 | 0);
 HEAP32[gb + 66384 >> 2] = (HEAP32[gb + 66384 >> 2] | 0) + (gb + 462526 | 0);
 HEAP32[gb + 66388 >> 2] = (HEAP32[gb + 66388 >> 2] | 0) + (gb + 462529 | 0);
 HEAP32[gb + 66392 >> 2] = (HEAP32[gb + 66392 >> 2] | 0) + (gb + 462537 | 0);
 HEAP32[gb + 66396 >> 2] = (HEAP32[gb + 66396 >> 2] | 0) + (gb + 597819 | 0);
 HEAP32[gb + 66400 >> 2] = (HEAP32[gb + 66400 >> 2] | 0) + (gb + 462545 | 0);
 HEAP32[gb + 66404 >> 2] = (HEAP32[gb + 66404 >> 2] | 0) + (gb + 462548 | 0);
 HEAP32[gb + 66408 >> 2] = (HEAP32[gb + 66408 >> 2] | 0) + (gb + 461517 | 0);
 HEAP32[gb + 66412 >> 2] = (HEAP32[gb + 66412 >> 2] | 0) + (gb + 462554 | 0);
 HEAP32[gb + 66416 >> 2] = (HEAP32[gb + 66416 >> 2] | 0) + (gb + 462565 | 0);
 HEAP32[gb + 66420 >> 2] = (HEAP32[gb + 66420 >> 2] | 0) + (gb + 462574 | 0);
 HEAP32[gb + 66424 >> 2] = (HEAP32[gb + 66424 >> 2] | 0) + (gb + 462577 | 0);
 HEAP32[gb + 66428 >> 2] = (HEAP32[gb + 66428 >> 2] | 0) + (gb + 462587 | 0);
 HEAP32[gb + 66440 >> 2] = fb + 727;
 HEAP32[gb + 66444 >> 2] = fb + 728;
 HEAP32[gb + 66448 >> 2] = fb + 86;
 HEAP32[gb + 66452 >> 2] = fb + 44;
 HEAP32[gb + 66464 >> 2] = fb + 729;
 HEAP32[gb + 66468 >> 2] = fb + 730;
 HEAP32[gb + 66472 >> 2] = fb + 731;
 HEAP32[gb + 66476 >> 2] = (HEAP32[gb + 66476 >> 2] | 0) + (gb + 463968 | 0);
 HEAP32[gb + 66488 >> 2] = fb + 732;
 HEAP32[gb + 66492 >> 2] = fb + 733;
 HEAP32[gb + 66496 >> 2] = fb + 80;
 HEAP32[gb + 66500 >> 2] = fb + 580;
 HEAP32[gb + 66504 >> 2] = fb + 16;
 HEAP32[gb + 66508 >> 2] = fb + 39;
 runPostSets56();
}

function __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i13, i15, i11, i1) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = i15 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i12 = i13 + 4 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 do if ((i5 | 0) == (i10 | 0)) {
  i1 = HEAP32[i15 + 8 >> 2] | 0;
  i2 = HEAP32[i13 + 8 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i3 = (i1 | 0) < (i2 | 0);
   break;
  }
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i3 = (HEAP32[i15 >> 2] | 0) < (HEAP32[i13 >> 2] | 0);
   break;
  } else {
   i3 = i1 >>> 0 < i2 >>> 0;
   break;
  }
 } else i3 = (i5 | 0) < (i10 | 0); while (0);
 i9 = i11 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 do if ((i4 | 0) == (i5 | 0)) {
  i1 = HEAP32[i11 + 8 >> 2] | 0;
  i2 = HEAP32[i15 + 8 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i1 = (i1 | 0) < (i2 | 0);
   break;
  }
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i2 = HEAP32[i15 + 12 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = (HEAP32[i11 >> 2] | 0) < (HEAP32[i15 >> 2] | 0);
   break;
  } else {
   i1 = i1 >>> 0 < i2 >>> 0;
   break;
  }
 } else i1 = (i4 | 0) < (i5 | 0); while (0);
 if (!i3) {
  if (!i1) {
   i15 = 0;
   return i15 | 0;
  }
  i2 = HEAP32[i15 >> 2] | 0;
  i7 = i15 + 8 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = i15 + 12 | 0;
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i14 >> 2] = i4;
  i4 = i11 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  i6 = i11 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 >> 2] = i2;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i10;
  i5 = HEAP32[i14 >> 2] | 0;
  i6 = HEAP32[i12 >> 2] | 0;
  do if ((i5 | 0) == (i6 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   i4 = i13 + 8 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    if ((i1 | 0) < (i2 | 0)) {
     i3 = i4;
     break;
    } else i1 = 1;
    return i1 | 0;
   }
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i13 + 12 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) {
    if ((HEAP32[i15 >> 2] | 0) < (HEAP32[i13 >> 2] | 0)) {
     i3 = i4;
     i2 = i1;
     break;
    } else i1 = 1;
    return i1 | 0;
   } else {
    if (i2 >>> 0 < i3 >>> 0) {
     i3 = i4;
     i2 = i1;
     break;
    } else i1 = 1;
    return i1 | 0;
   }
  } else if ((i5 | 0) < (i6 | 0)) {
   i2 = i13 + 8 | 0;
   i3 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  } else {
   i15 = 1;
   return i15 | 0;
  } while (0);
  i10 = HEAP32[i13 >> 2] | 0;
  i9 = i13 + 12 | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i12 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i15 >> 2] = i10;
  HEAP32[i14 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i11;
  i15 = 2;
  return i15 | 0;
 }
 i6 = HEAP32[i13 >> 2] | 0;
 i2 = i13 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i3 = i13 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 if (i1) {
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 >> 2] = i4;
  i14 = i11 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  i15 = i11 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i11 >> 2] = i6;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i15 >> 2] = i8;
  i15 = 1;
  return i15 | 0;
 }
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 >> 2] = i5;
 i5 = i15 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 i4 = i15 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 >> 2] = i6;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i4 >> 2] = i8;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 | 0) == (i10 | 0)) {
  i2 = i11 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i7 | 0)) {
   if ((i1 | 0) < (i7 | 0)) break; else i1 = 1;
   return i1 | 0;
  }
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  if ((i1 | 0) == (i8 | 0)) {
   if ((HEAP32[i11 >> 2] | 0) < (i6 | 0)) {
    i1 = i7;
    break;
   } else i1 = 1;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i8 >>> 0) {
    i1 = i7;
    break;
   } else i1 = 1;
   return i1 | 0;
  }
 } else if ((i3 | 0) < (i10 | 0)) {
  i1 = i11 + 8 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  break;
 } else {
  i15 = 1;
  return i15 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 >> 2] = i3;
 HEAP32[i5 >> 2] = i1;
 i15 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i11 >> 2] = i6;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i15 >> 2] = i8;
 i15 = 2;
 return i15 | 0;
}

function __ZNSt3__26__sortIRNS_6__lessIwwEEPwEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if ((i7 | 0) < (i5 | 0)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if ((i6 | 0) < (i5 | 0)) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if ((i7 | 0) >= (i5 | 0)) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i7 | 0) < (i4 | 0)) break;
      i3 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if ((i8 | 0) < (i6 | 0)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while ((i8 | 0) < (i5 | 0));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP32[i10 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i5 >> 2] | 0;
      i8 = i5 + 4 | 0;
      if ((i7 | 0) < (i9 | 0)) i5 = i8; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
     } while ((i6 | 0) >= (i9 | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 >> 2] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) < (i5 | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIwwEEPwEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIwwEEPwEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIwwEEPwEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIwwEEPwEEvT0_S5_T_(i7 + 4 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIwwEEPwEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessImmEEPmEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if (i7 >>> 0 < i5 >>> 0) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if (i6 >>> 0 < i5 >>> 0) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if (i7 >>> 0 >= i5 >>> 0) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i7 >>> 0 < i4 >>> 0) break;
      i3 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if (i8 >>> 0 < i6 >>> 0) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while (i8 >>> 0 < i5 >>> 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP32[i10 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i5 >> 2] | 0;
      i8 = i5 + 4 | 0;
      if (i7 >>> 0 < i9 >>> 0) i5 = i8; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
     } while (i6 >>> 0 >= i9 >>> 0);
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 >> 2] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if (i4 >>> 0 < i5 >>> 0) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessImmEEPmEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessImmEEPmEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessImmEEPmEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessImmEEPmEEvT0_S5_T_(i7 + 4 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessImmEEPmEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIllEEPlEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if ((i7 | 0) < (i5 | 0)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if ((i6 | 0) < (i5 | 0)) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if ((i7 | 0) >= (i5 | 0)) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i7 | 0) < (i4 | 0)) break;
      i3 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if ((i8 | 0) < (i6 | 0)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while ((i8 | 0) < (i5 | 0));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP32[i10 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i5 >> 2] | 0;
      i8 = i5 + 4 | 0;
      if ((i7 | 0) < (i9 | 0)) i5 = i8; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
     } while ((i6 | 0) >= (i9 | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 >> 2] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) < (i5 | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIllEEPlEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIllEEPlEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIllEEPlEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIllEEPlEEvT0_S5_T_(i7 + 4 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIllEEPlEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIjjEEPjEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if (i7 >>> 0 < i5 >>> 0) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if (i6 >>> 0 < i5 >>> 0) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if (i7 >>> 0 >= i5 >>> 0) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i7 >>> 0 < i4 >>> 0) break;
      i3 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if (i8 >>> 0 < i6 >>> 0) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while (i8 >>> 0 < i5 >>> 0);
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP32[i10 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i5 >> 2] | 0;
      i8 = i5 + 4 | 0;
      if (i7 >>> 0 < i9 >>> 0) i5 = i8; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
     } while (i6 >>> 0 >= i9 >>> 0);
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 >> 2] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if (i4 >>> 0 < i5 >>> 0) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIjjEEPjEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIjjEEPjEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIjjEEPjEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIjjEEPjEEvT0_S5_T_(i7 + 4 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIjjEEPjEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -4 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    i4 = i3 >> 2;
    switch (i4 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 124) {
     i15 = 11;
     break L1;
    }
    i8 = i1 + (((i4 | 0) / 2 | 0) << 2) | 0;
    if ((i3 | 0) > 3996) {
     i3 = (i4 | 0) / 4 | 0;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i3 << 2) | 0, i8, i8 + (i3 << 2) | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i1, i8, i14, i13) | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if ((i7 | 0) < (i5 | 0)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -4 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP32[i4 >> 2] | 0;
     if ((i6 | 0) < (i5 | 0)) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 4 | 0;
    i5 = HEAP32[i14 >> 2] | 0;
    if ((i7 | 0) >= (i5 | 0)) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i7 | 0) < (i4 | 0)) break;
      i3 = i3 + 4 | 0;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i14 >> 2] = i4;
     i3 = i3 + 4 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP32[i1 >> 2] | 0;
     while (1) {
      i6 = HEAP32[i3 >> 2] | 0;
      i7 = i3 + 4 | 0;
      if ((i8 | 0) < (i6 | 0)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -4 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
     } while ((i8 | 0) < (i5 | 0));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP32[i3 >> 2] = i5;
     HEAP32[i4 >> 2] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i4 >> 2] = i7;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 4 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i8;
    while (1) {
     i9 = HEAP32[i10 >> 2] | 0;
     while (1) {
      i7 = HEAP32[i5 >> 2] | 0;
      i8 = i5 + 4 | 0;
      if ((i7 | 0) < (i9 | 0)) i5 = i8; else break;
     }
     do {
      i4 = i4 + -4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
     } while ((i6 | 0) >= (i9 | 0));
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP32[i5 >> 2] = i6;
     HEAP32[i4 >> 2] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i8;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) < (i5 | 0)) {
     HEAP32[i7 >> 2] = i4;
     HEAP32[i6 >> 2] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIiiEEPiEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 4 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIiiEEPiEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 4 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i7 + 4 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i1, i1 + 4 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_(i1, i1 + 4 | 0, i1 + 8 | 0, i1 + 12 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIiiEEPiEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZN24PrepareSceneNodesJobDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 84 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 104 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 124 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 144 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 184 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 204 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 224 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 244 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 264 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 284 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = 0;
 HEAP32[i1 + 316 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 304 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 324 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i13, i14, i15, i11, i9) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i10 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18;
 i12 = i18 + 32 | 0;
 i16 = i18 + 16 | 0;
 i17 = i13 + 72 | 0;
 i2 = (HEAP32[i17 >> 2] | 0) + i14 | 0;
 if (!i11) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i12, 0, 0);
  HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  i8 = 1065353216;
  i6 = 1065353216;
  f7 = Math_fround(1.0);
  f3 = Math_fround(1.0);
 } else {
  if (i9) {
   i10 = i11;
   i1 = HEAP32[i11 + 48 >> 2] | 0;
  } else {
   i10 = i11;
   i1 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 96 >> 2] | 0, i11 | 0) | 0;
  }
  i4 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 148 >> 2] | 0, i11 | 0) | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 152 >> 2] | 0, i11 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = i4;
  if (i4 | i1 | 0) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!((i1 | 0) == 1 | (i1 | 0) == (i4 | 0))) {
    i19 = HEAP32[gb + 68604 + (i4 << 2) >> 2] | 0;
    i4 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
    i8 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i15) | 0;
    HEAP32[i6 >> 2] = i19;
    HEAP32[i6 + 4 >> 2] = i4;
    HEAP32[i6 + 8 >> 2] = i8;
    __Z6FormatPKcz(i12, gb + 478736 | 0, i6);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   }
  }
  HEAP32[i2 + 12 >> 2] = i5;
  i8 = HEAP32[i11 + 68 >> 2] | 0;
  i6 = HEAP32[i11 + 72 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i9) {
   i1 = mftCall_ii(HEAP32[i1 + 100 >> 2] | 0, i11 | 0) | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0;
  } else {
   i1 = mftCall_ii(HEAP32[i1 + 136 >> 2] | 0, i11 | 0) | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i11 | 0) | 0;
  }
  f7 = Math_fround(i1 | 0);
  f3 = Math_fround(i2 | 0);
  i2 = HEAP32[i11 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i11 + 60 >> 2] | 0; else i1 = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i12, i2, i1);
  HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + i14 + 24 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i13, i15, gb + 478720 | 0) | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  HEAP32[i2 + i14 + 24 >> 2] = i1;
 }
 i4 = i13 + 12 | 0;
 i5 = i13 + 52 | 0;
 i1 = i2 + (HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) + i1 << 2) >> 2] & 1048575) | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f3;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i1 + i14 + 28 >> 2] | 0;
 if ((i2 | 0) >= 0) {
  i19 = i2;
  i17 = i1;
  i15 = HEAP32[i4 >> 2] | 0;
  i19 = i15 + i19 | 0;
  i15 = HEAP32[i5 >> 2] | 0;
  i19 = i15 + (i19 << 2) | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i19 = i19 & 1048575;
  i19 = i17 + i19 | 0;
  HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  STACKTOP = i18;
  return;
 }
 i19 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i13, i15, gb + 478731 | 0) | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i17 + i14 + 28 >> 2] = i19;
 i15 = HEAP32[i4 >> 2] | 0;
 i19 = i15 + i19 | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 i19 = i15 + (i19 << 2) | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i19 = i19 & 1048575;
 i19 = i17 + i19 | 0;
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN14NavMeshManager20CalculatePolygonPathEP11NavMeshPathRK8Vector3fS4_RK13dtQueryFilter(i7, i11, i1, i2, i5) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 44 | 0;
 i8 = i14 + 32 | 0;
 i6 = i14 + 8 | 0;
 i4 = i14;
 i13 = i14 + 28 | 0;
 i12 = i14 + 16 | 0;
 i9 = HEAP32[i7 + 112 >> 2] | 0;
 if (!i9) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 4 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i1 + 8 >> 2] & 2139095040 | 0) != 2139095040)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 4 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + 8 >> 2] & 2139095040 | 0) != 2139095040)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i3 = i7 + 20 | 0;
 __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i9, i2, i3, i5, i6, i10) | 0;
 i2 = i6;
 if ((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0) i1 = 0; else {
  __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i9, i1, i3, i5, i4, i8) | 0;
  i2 = i4;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if ((i1 | 0) == 0 & (i2 | 0) == 0) i1 = 0; else {
   HEAP32[i13 >> 2] = 0;
   i1 = __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter(i9, i1, i2, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i8, i10, i5) | 0;
   if ((i1 | 0) >= 0) {
    i1 = __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi(i9, 65535, 0) | 0;
    if ((i1 | 0) >= 0) i1 = __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi(i9, i13) | 0;
   }
   i2 = ((HEAP32[i13 >> 2] | 0) + 31 | 0) / 32 | 0;
   i3 = i2 << 5;
   i5 = i11 + 8 | 0;
   i6 = i11 + 24 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i6 >> 2] = i3;
    HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2 << 8, 8, i11 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 8, 8, i11 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i11 + 20 >> 2] << 3 | 0) | 0;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i5 >> 2] = i4;
    break;
   } while (0);
   if ((i1 | 0) < 0) i4 = i1; else i4 = __ZN14dtNavMeshQuery7getPathEPyPii(i9, HEAP32[i11 + 8 >> 2] | 0, i13, HEAP32[i6 >> 2] & 2147483647) | 0;
   HEAP32[i11 >> 2] = HEAP32[(HEAP32[i7 + 108 >> 2] | 0) + 56 >> 2];
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i11 + 20 | 0;
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[i6 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 3, 8, i11 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i11 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i5 >> 2] = i7;
    break;
   } while (0);
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   i1 = HEAP32[i8 + 8 >> 2] | 0;
   HEAP32[i11 + 28 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 32 >> 2] = i3;
   HEAP32[i11 + 36 >> 2] = i1;
   i8 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = HEAP32[i10 + 8 >> 2] | 0;
   i3 = i11 + 40 | 0;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 44 >> 2] = i8;
   HEAP32[i11 + 48 >> 2] = i1;
   i1 = HEAP32[i13 >> 2] | 0;
   do if ((i4 | 0) < 0 | (i1 | 0) == 0) {
    HEAP32[i11 + 4 >> 2] = 2;
    i1 = 0;
   } else {
    if (!(i4 & 64)) {
     HEAP32[i11 + 4 >> 2] = 0;
     break;
    }
    i1 = (HEAP32[i11 + 8 >> 2] | 0) + (i1 + -1 << 3) | 0;
    i1 = __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf(i9, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i10, i12) | 0;
    i2 = i11 + 4 | 0;
    if ((i1 | 0) < 0) {
     HEAP32[i2 >> 2] = 2;
     i1 = 0;
     break;
    }
    HEAP32[i2 >> 2] = 1;
    HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    if (i1 & 32 | 0) HEAP32[i11 >> 2] = 0;
    i1 = HEAP32[i13 >> 2] | 0;
   } while (0);
  }
 }
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN23PxsCMDiscreteUpdateTask11runInternalEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = i15 + 156 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i14 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i13 | 0, i14 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i14 = i1 + 19 & -16;
   HEAP32[i14 + -4 >> 2] = i14 - i1;
   i1 = i14;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
 }
 i10 = i1 + 16 | 0;
 HEAP32[i1 + 8752 >> 2] = HEAP32[i15 + 152 >> 2];
 i11 = i1 + 9136 | 0;
 i12 = HEAP32[i16 >> 2] | 0;
 i9 = HEAP8[i12 + 7604 >> 0] | 0;
 HEAP8[i1 + 8772 >> 0] = i9;
 HEAP8[i1 + 8775 >> 0] = HEAP8[i12 + 7606 >> 0] | 0;
 HEAP8[i1 + 8773 >> 0] = HEAP8[i12 + 7605 >> 0] | 0;
 HEAP32[i1 + 8764 >> 2] = HEAP32[i12 + 7600 >> 2];
 HEAP32[i1 + 8768 >> 2] = i12 + 7612;
 i12 = HEAP32[i15 + 148 >> 2] | 0;
 i13 = i1 + 9140 | 0;
 i14 = i1 + 9144 | 0;
 if (!(i9 << 24 >> 24)) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
  L8 : while (1) {
   while (1) {
    i5 = i4;
    while (1) {
     if (i5 >>> 0 >= i12 >>> 0) break L8;
     i4 = i5 + 1 | 0;
     i5 = i15 + 20 + (i5 << 2) | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i9 = (HEAPU16[i6 + 114 >> 1] | 0) & 2;
     __ZN5physx22PxcDiscreteNarrowPhaseERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE(i10, i6 + 16 | 0);
     i5 = HEAP32[i5 >> 2] | 0;
     i6 = (HEAPU16[i5 + 114 >> 1] | 0) & 2;
     if (i6 << 16 >> 16 == i9 << 16 >> 16) i5 = i4; else break;
    }
    i9 = HEAP32[i5 + 76 >> 2] | 0;
    i7 = (i9 + 32 | 0) >>> 5;
    if (i7 >>> 0 > (HEAP32[i13 >> 2] & 2147483647) >>> 0) {
     i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, i7 << 2, gb + 769739 | 0, 329) | 0;
     i8 = HEAP32[i11 >> 2] | 0;
     if (i8 | 0) {
      _memcpy(i5 | 0, i8 | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      if ((HEAP32[i13 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, HEAP32[i11 >> 2] | 0);
     }
     i8 = HEAP32[i13 >> 2] | 0;
     _memset(i5 + ((i8 & 2147483647) << 2) | 0, 0, i7 - i8 << 2 | 0) | 0;
     HEAP32[i11 >> 2] = i5;
     HEAP32[i13 >> 2] = i7;
    } else i5 = HEAP32[i11 >> 2] | 0;
    i8 = i5 + (i9 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i9 & 31);
    if (!(i6 << 16 >> 16)) break;
    i2 = i2 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  }
  i15 = i1 + 9148 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i2;
  i15 = i1 + 9152 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i3;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[(HEAP32[i16 >> 2] | 0) + 224 >> 2] | 0, i1);
  return;
 } else {
  i4 = 0;
  i3 = 0;
  i2 = 0;
  L28 : while (1) {
   while (1) {
    i5 = i4;
    while (1) {
     if (i5 >>> 0 >= i12 >>> 0) break L28;
     i4 = i5 + 1 | 0;
     i5 = i15 + 20 + (i5 << 2) | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i9 = (HEAPU16[i6 + 114 >> 1] | 0) & 2;
     __ZN5physx25PxcDiscreteNarrowPhasePCMERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE(i10, i6 + 16 | 0);
     i5 = HEAP32[i5 >> 2] | 0;
     i6 = (HEAPU16[i5 + 114 >> 1] | 0) & 2;
     if (i6 << 16 >> 16 == i9 << 16 >> 16) i5 = i4; else break;
    }
    i9 = HEAP32[i5 + 76 >> 2] | 0;
    i7 = (i9 + 32 | 0) >>> 5;
    if (i7 >>> 0 > (HEAP32[i13 >> 2] & 2147483647) >>> 0) {
     i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14, i7 << 2, gb + 769739 | 0, 329) | 0;
     i8 = HEAP32[i11 >> 2] | 0;
     if (i8 | 0) {
      _memcpy(i5 | 0, i8 | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      if ((HEAP32[i13 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, HEAP32[i11 >> 2] | 0);
     }
     i8 = HEAP32[i13 >> 2] | 0;
     _memset(i5 + ((i8 & 2147483647) << 2) | 0, 0, i7 - i8 << 2 | 0) | 0;
     HEAP32[i11 >> 2] = i5;
     HEAP32[i13 >> 2] = i7;
    } else i5 = HEAP32[i11 >> 2] | 0;
    i8 = i5 + (i9 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i9 & 31);
    if (!(i6 << 16 >> 16)) break;
    i2 = i2 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  }
  i15 = i1 + 9148 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i2;
  i15 = i1 + 9152 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i3;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[(HEAP32[i16 >> 2] | 0) + 224 >> 2] | 0, i1);
  return;
 }
}

function __ZN14PhysicsManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 801749 | 0, 0);
 i5 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944562 | 0, gb + 737343 | 0, i5, 0);
 i8 = i6 + 8 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737364 | 0, i8, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839280 | 0, i8, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737382 | 0, i8, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737458 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737484 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737518 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802114 | 0, i7, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737540 | 0, i7, i1 + 57 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737562 | 0, i7, i1 + 797 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802184 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 724 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i3 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManager13RecreateSceneEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 8 | 0;
 i6 = i13;
 i3 = i13 + 38 | 0;
 i4 = i13 + 36 | 0;
 i12 = i13 + 16 | 0;
 if ((HEAP16[gb + 1452416 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452416 | 0, i5);
  i11 = gb + 1452416 | 0;
 } else i11 = 0;
 if (HEAP32[gb + 1457408 >> 2] | 0) {
  i2 = i10 + 104 | 0;
  i1 = i10 + 108 | 0;
  __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i1 >> 2] | 0);
  HEAP32[i10 + 112 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  i1 = i10 + 116 | 0;
  i2 = i10 + 132 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 120 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 + 128 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i2 = i10 + 136 | 0;
  i1 = i10 + 140 | 0;
  __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i1 >> 2] | 0);
  HEAP32[i10 + 144 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  i1 = i10 + 148 | 0;
  i2 = i10 + 164 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 152 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 + 160 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i9 = HEAP32[gb + 1457404 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 236 >> 2] | 0, i9 | 0, 1, 0) | 0;
  i9 = HEAP32[gb + 1457404 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 72 >> 2] | 0;
  HEAP16[i3 >> 1] = 2;
  if (!(mftCall_iii(i8 | 0, i9 | 0, i3 | 0) | 0)) {
   i9 = HEAP32[gb + 1457404 >> 2] | 0;
   i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 72 >> 2] | 0;
   HEAP16[i4 >> 1] = 1;
   if (!(mftCall_iii(i8 | 0, i9 | 0, i4 | 0) | 0)) {
    i9 = gb + 64016 | 0;
    i8 = HEAP32[i9 + 4 >> 2] | 0;
    i7 = i6;
    HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i7 + 4 >> 2] = i8;
    HEAP32[i12 >> 2] = 0;
    i7 = i12 + 12 | 0;
    HEAP32[i7 >> 2] = 0;
    i8 = i12 + 16 | 0;
    HEAP32[i8 >> 2] = 0;
    i9 = i12 + 4 | 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i1 = i9;
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i1 + 4 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
    HEAP32[i12 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 113108 | 0, i12, 0);
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) {
     i4 = 0;
     do {
      i2 = (HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 52 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if (i3) {
       mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
       HEAP32[i2 >> 2] = 0;
       i1 = HEAP32[i7 >> 2] | 0;
      }
      i4 = i4 + 1 | 0;
     } while (i4 >>> 0 < i1 >>> 0);
    }
    i6 = HEAP32[gb + 1457404 >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, 0, 0);
    __ZN14PhysicsManager20CleanupDynamicsSceneEv();
    __ZN14PhysicsManager19CreateDynamicsSceneEbb((HEAP8[i10 + 57 >> 0] | 0) != 0, (HEAP8[i10 + 797 >> 0] | 0) != 0);
    i6 = HEAP32[gb + 1457404 >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, 0, 0);
    i6 = HEAP32[gb + 1457404 >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, i10 + 28 | 0, 0);
    if (HEAP32[i7 >> 2] | 0) {
     i1 = 0;
     do {
      i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, 0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
    }
    i10 = __Z21GetManagerFromContexti(9) | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, 0);
    if ((HEAP32[i8 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i9);
     HEAP32[i12 >> 2] = 0;
    }
   }
  }
 }
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i13;
 return;
}

function __ZNK7VRInput16GetLocalRotationERK8UnityStr4PPtrI9TransformE(i9, i5, i1, i2) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i4 = i10;
 i8 = __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_(i5 + 20 | 0, i1) | 0;
 if ((i8 | 0) == (i5 + 24 | 0)) {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i4 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 10;
  }
  if ((i7 | 0) == 8) i7 = 10;
  if ((i7 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  i4 = i5 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i7 = 19; else {
   i1 = i4;
   L20 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i6 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L20; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) == (i4 | 0)) i7 = 19; else if ((i6 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i7 = 19; else i1 = i1 + 20 | 0;
  }
  if ((i7 | 0) == 19) if (!(HEAP8[gb + 1573589 >> 0] | 0)) {
   HEAP32[gb + 1469228 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[gb + 1469228 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[gb + 1469228 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAPF32[gb + 1469228 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[gb + 1469228 + 24 >> 2] = Math_fround(1.0);
   i1 = gb + 1469228 + 28 | 0;
   i2 = gb + 1162292 | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP8[gb + 1573589 >> 0] = 1;
   i1 = gb + 1469228 | 0;
  } else i1 = gb + 1469228 | 0;
  f21 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f19 = Math_fround(HEAPF32[i8 + 44 >> 2]);
  f16 = Math_fround(f21 * f19);
  f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i8 + 56 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f18 * f20));
  f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i8 + 52 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f17 * f11));
  f15 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f14 = Math_fround(HEAPF32[i8 + 48 >> 2]);
  f13 = Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(Math_fround(f20 * f17) + Math_fround(f21 * f14))) - Math_fround(f18 * f11));
  f12 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f11) + Math_fround(f20 * f15)) + Math_fround(f18 * f14)) - Math_fround(f19 * f17));
  f11 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f14)) - Math_fround(f11 * f15));
  HEAPF32[i9 >> 2] = Math_fround(f16 - Math_fround(f15 * f14));
  HEAPF32[i9 + 4 >> 2] = f13;
  HEAPF32[i9 + 8 >> 2] = f12;
  HEAPF32[i9 + 12 >> 2] = f11;
  STACKTOP = i10;
  return;
 } while (0);
 i8 = i8 + 44 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 8 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103216 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN5physx2Gu27pcmContactConvexHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i11, i12, i13, i14, i3, i1, i2) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, i30 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 336 | 0;
 i7 = i15 + 464 | 0;
 i9 = i15 + 368 | 0;
 i10 = i15 + 392 | 0;
 i18 = i15 + 48 | 0;
 i6 = i15 + 32 | 0;
 i17 = i15 + 16 | 0;
 i4 = i15 + 128 | 0;
 i19 = i15;
 i5 = i15 + 64 | 0;
 i20 = HEAP32[i11 + 36 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] & -16;
 i30 = HEAP32[i13 + 4 >> 2] | 0;
 i29 = HEAP32[i13 + 8 >> 2] | 0;
 i23 = HEAP32[i13 + 12 >> 2] | 0;
 i16 = i13 + 16 | 0;
 i22 = HEAP32[i16 >> 2] | 0;
 i21 = HEAP32[i16 + 4 >> 2] | 0;
 i16 = HEAP32[i16 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = i30;
 HEAP32[i8 + 8 >> 2] = i29;
 HEAP32[i8 + 12 >> 2] = i23;
 HEAP32[i8 + 16 >> 2] = i22;
 HEAP32[i8 + 20 >> 2] = i21;
 HEAP32[i8 + 24 >> 2] = i16;
 HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i7 >> 2] = 1065353216;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 1065353216;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 1065353216;
 HEAP32[i7 + 36 >> 2] = 1065353216;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP32[i7 + 44 >> 2] = 0;
 HEAP32[i7 + 48 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 1065353216;
 HEAP32[i7 + 56 >> 2] = 0;
 HEAP32[i7 + 60 >> 2] = 0;
 HEAP32[i7 + 64 >> 2] = 0;
 HEAP32[i7 + 68 >> 2] = 1065353216;
 i16 = __ZN5physx2Gu16getPCMConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i11, i7, i9, i10) | 0;
 i21 = HEAP32[i11 + 4 >> 2] | 0;
 i22 = HEAP32[i11 + 8 >> 2] | 0;
 i23 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = i21;
 HEAP32[i18 + 4 >> 2] = i22;
 HEAP32[i18 + 8 >> 2] = i23;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f28 = Math_fround(HEAPF32[i20 + 52 >> 2]);
 f27 = Math_fround(HEAPF32[i20 + 56 >> 2]);
 f24 = Math_fround(HEAPF32[i20 + 60 >> 2]);
 f26 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f28 * f26);
 f25 = Math_fround(f27 * f25);
 f24 = Math_fround(f24 * (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f25 = f26 <= f25 ? f26 : f25;
 HEAPF32[i6 >> 2] = Math_fround((f25 <= f24 ? f25 : f24) * Math_fround(.25));
 i23 = HEAP32[i11 + 20 >> 2] | 0;
 i22 = HEAP32[i11 + 24 >> 2] | 0;
 i21 = HEAP32[i11 + 28 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i17 + 4 >> 2] = i23;
 HEAP32[i17 + 8 >> 2] = i22;
 HEAP32[i17 + 12 >> 2] = i21;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i4, i20, i19, i18, i17);
 if (i16) {
  HEAP32[i5 + 32 >> 2] = i8;
  HEAP32[i5 + 36 >> 2] = i4 + 96;
  HEAP32[i5 + 40 >> 2] = i4 + 144;
  HEAP8[i5 + 44 >> 0] = 1;
  HEAP32[i5 >> 2] = gb + 146928 + 8;
  HEAP32[i5 + 48 >> 2] = i4;
  HEAP32[i5 + 52 >> 2] = i4;
  i30 = __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE(i10, i5, i6, i9, i12, i13, i14, Math_fround(HEAPF32[i3 >> 2]), i2, i7, 1, i1) | 0;
  STACKTOP = i15;
  return i30 | 0;
 } else {
  HEAP32[i5 + 32 >> 2] = i8;
  HEAP32[i5 + 36 >> 2] = i4 + 96;
  HEAP32[i5 + 40 >> 2] = i4 + 144;
  HEAP8[i5 + 44 >> 0] = 0;
  HEAP32[i5 >> 2] = gb + 146956 + 8;
  HEAP32[i5 + 48 >> 2] = i4;
  HEAP32[i5 + 52 >> 2] = i4;
  i30 = __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE(i10, i5, i6, i9, i12, i13, i14, Math_fround(HEAPF32[i3 >> 2]), i2, i7, 0, i1) | 0;
  STACKTOP = i15;
  return i30 | 0;
 }
 return 0;
}

function __ZN14qsort_internal14_Partition3WayIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEENSt3__24pairIT_S7_EES7_S7_T0_T1_(i22, i23, i3, i1, i2) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26 + 8 | 0;
 i20 = i26;
 i24 = i3 + -212 | 0;
 i21 = i1 + -1 | 0;
 i1 = i2;
 i19 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i18 = i20;
 HEAP32[i18 >> 2] = i19;
 HEAP32[i18 + 4 >> 2] = i1;
 HEAP32[i25 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i23, i24, i21, i25);
 i20 = i19 + 12 | 0;
 i18 = i3 + -196 | 0;
 i19 = i19 + 8 | 0;
 i1 = -1;
 i7 = i21;
 while (1) {
  i9 = HEAP32[i20 >> 2] | 0;
  i10 = HEAP32[i18 >> 2] | 0;
  i11 = HEAP32[HEAP32[(HEAP32[i19 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
  i16 = HEAP32[i9 + (i10 << 5) + 8 >> 2] | 0;
  i12 = HEAP32[i11 + (i16 * 360 | 0) + 184 >> 2] | 0;
  i13 = i9 + (i10 << 5) + 12 | 0;
  i14 = i9 + (i10 << 5) + 20 | 0;
  i15 = i9 + (i10 << 5) + 28 | 0;
  i16 = i11 + (i16 * 360 | 0) + 270 | 0;
  i8 = i1;
  while (1) {
   i17 = i8 + 1 | 0;
   i6 = HEAP32[i23 + (i17 * 212 | 0) + 16 >> 2] | 0;
   i3 = HEAP32[i9 + (i6 << 5) + 8 >> 2] | 0;
   i1 = HEAP32[i11 + (i3 * 360 | 0) + 184 >> 2] | 0;
   do if ((i1 | 0) == (i12 | 0)) {
    i1 = HEAP16[i9 + (i6 << 5) + 12 >> 1] | 0;
    i2 = HEAP16[i13 >> 1] | 0;
    if (i1 << 16 >> 16 != i2 << 16 >> 16) {
     i1 = i1 << 16 >> 16 < i2 << 16 >> 16;
     break;
    }
    f4 = Math_fround(HEAPF32[i9 + (i6 << 5) + 20 >> 2]);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    f5 = Math_fround(HEAPF32[i14 >> 2]);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    if ((i1 | 0) != (i2 | 0)) {
     i1 = i1 >>> 0 < i2 >>> 0;
     break;
    }
    i1 = HEAP32[i9 + (i6 << 5) + 28 >> 2] | 0;
    i2 = HEAP32[i15 >> 2] | 0;
    if ((i1 | 0) != (i2 | 0)) {
     i1 = i1 >>> 0 > i2 >>> 0;
     break;
    }
    if (f4 != f5) {
     i1 = f4 > f5;
     break;
    }
    i1 = HEAP16[i11 + (i3 * 360 | 0) + 270 >> 1] | 0;
    i2 = HEAP16[i16 >> 1] | 0;
    if (i1 << 16 >> 16 == i2 << 16 >> 16) {
     i1 = (i6 | 0) < (i10 | 0);
     break;
    } else {
     i1 = (i1 & 65535) > (i2 & 65535);
     break;
    }
   } else i1 = i1 >>> 0 < i12 >>> 0; while (0);
   if ((i17 | 0) == (i21 | 0) | i1 ^ 1) break; else i8 = i17;
  }
  do {
   i7 = i7 + -1 | 0;
   i6 = HEAP32[i23 + (i7 * 212 | 0) + 16 >> 2] | 0;
   i3 = HEAP32[i9 + (i6 << 5) + 8 >> 2] | 0;
   i1 = HEAP32[i11 + (i3 * 360 | 0) + 184 >> 2] | 0;
   do if ((i12 | 0) == (i1 | 0)) {
    i1 = HEAP16[i13 >> 1] | 0;
    i2 = HEAP16[i9 + (i6 << 5) + 12 >> 1] | 0;
    if (i1 << 16 >> 16 != i2 << 16 >> 16) {
     i1 = i1 << 16 >> 16 < i2 << 16 >> 16;
     break;
    }
    f4 = Math_fround(HEAPF32[i14 >> 2]);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    f5 = Math_fround(HEAPF32[i9 + (i6 << 5) + 20 >> 2]);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
    if ((i1 | 0) != (i2 | 0)) {
     i1 = i1 >>> 0 < i2 >>> 0;
     break;
    }
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i9 + (i6 << 5) + 28 >> 2] | 0;
    if ((i1 | 0) != (i2 | 0)) {
     i1 = i1 >>> 0 > i2 >>> 0;
     break;
    }
    if (f4 != f5) {
     i1 = f4 > f5;
     break;
    }
    i2 = HEAP16[i16 >> 1] | 0;
    i1 = HEAP16[i11 + (i3 * 360 | 0) + 270 >> 1] | 0;
    if (i2 << 16 >> 16 == i1 << 16 >> 16) {
     i1 = (i10 | 0) < (i6 | 0);
     break;
    } else {
     i1 = (i2 & 65535) > (i1 & 65535);
     break;
    }
   } else i1 = i12 >>> 0 < i1 >>> 0; while (0);
  } while (!((i7 | 0) == 0 | i1 ^ 1));
  i1 = i23 + (i17 * 212 | 0) | 0;
  if ((i17 | 0) >= (i7 | 0)) break;
  i16 = i23 + (i7 * 212 | 0) | 0;
  _memcpy(i25 | 0, i1 | 0, 212) | 0;
  _memcpy(i1 | 0, i16 | 0, 212) | 0;
  _memcpy(i16 | 0, i25 | 0, 212) | 0;
  i1 = i17;
 }
 _memcpy(i25 | 0, i1 | 0, 212) | 0;
 _memcpy(i1 | 0, i24 | 0, 212) | 0;
 _memcpy(i24 | 0, i25 | 0, 212) | 0;
 HEAP32[i22 >> 2] = i23 + ((i8 + 2 | 0) * 212 | 0);
 HEAP32[i22 + 4 >> 2] = i23 + (i8 * 212 | 0);
 STACKTOP = i26;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103132 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function runPostSets43() {
 HEAP32[gb + 59428 >> 2] = fb + 34;
 HEAP32[gb + 59432 >> 2] = fb + 495;
 HEAP32[gb + 59436 >> 2] = fb + 496;
 HEAP32[gb + 59440 >> 2] = fb + 497;
 HEAP32[gb + 59444 >> 2] = fb + 498;
 HEAP32[gb + 59448 >> 2] = fb + 499;
 HEAP32[gb + 59452 >> 2] = fb + 500;
 HEAP32[gb + 59456 >> 2] = fb + 36;
 HEAP32[gb + 59460 >> 2] = fb + 20;
 HEAP32[gb + 59464 >> 2] = fb + 35;
 HEAP32[gb + 59468 >> 2] = fb + 36;
 HEAP32[gb + 59472 >> 2] = fb + 37;
 HEAP32[gb + 59476 >> 2] = fb + 37;
 HEAP32[gb + 59480 >> 2] = fb + 279;
 HEAP32[gb + 59484 >> 2] = fb + 280;
 HEAP32[gb + 59488 >> 2] = fb + 40;
 HEAP32[gb + 59492 >> 2] = fb + 41;
 HEAP32[gb + 59496 >> 2] = fb + 42;
 HEAP32[gb + 59500 >> 2] = fb + 43;
 HEAP32[gb + 59504 >> 2] = fb + 281;
 HEAP32[gb + 59508 >> 2] = fb + 282;
 HEAP32[gb + 59512 >> 2] = fb + 46;
 HEAP32[gb + 59516 >> 2] = fb + 283;
 HEAP32[gb + 59520 >> 2] = fb + 48;
 HEAP32[gb + 59524 >> 2] = fb + 284;
 HEAP32[gb + 59528 >> 2] = fb + 501;
 HEAP32[gb + 59532 >> 2] = fb + 642;
 HEAP32[gb + 59536 >> 2] = fb + 14;
 HEAP32[gb + 59548 >> 2] = fb + 643;
 HEAP32[gb + 59552 >> 2] = fb + 644;
 HEAP32[gb + 59564 >> 2] = fb + 645;
 HEAP32[gb + 59568 >> 2] = fb + 646;
 HEAP32[gb + 59572 >> 2] = fb + 38;
 HEAP32[gb + 59576 >> 2] = fb + 502;
 HEAP32[gb + 59580 >> 2] = fb + 16;
 HEAP32[gb + 59584 >> 2] = fb + 39;
 HEAP32[gb + 59588 >> 2] = fb + 40;
 HEAP32[gb + 59592 >> 2] = fb + 19;
 HEAP32[gb + 59596 >> 2] = fb + 285;
 HEAP32[gb + 59600 >> 2] = fb + 31;
 HEAP32[gb + 59604 >> 2] = fb + 27;
 HEAP32[gb + 59608 >> 2] = fb + 62;
 HEAP32[gb + 59612 >> 2] = fb + 28;
 HEAP32[gb + 59616 >> 2] = fb + 63;
 HEAP32[gb + 59620 >> 2] = fb + 29;
 HEAP32[gb + 59624 >> 2] = fb + 34;
 HEAP32[gb + 59628 >> 2] = fb + 503;
 HEAP32[gb + 59632 >> 2] = fb + 504;
 HEAP32[gb + 59636 >> 2] = fb + 505;
 HEAP32[gb + 59640 >> 2] = fb + 506;
 HEAP32[gb + 59644 >> 2] = fb + 507;
 HEAP32[gb + 59648 >> 2] = fb + 508;
 HEAP32[gb + 59652 >> 2] = fb + 36;
 HEAP32[gb + 59748 >> 2] = fb + 647;
 HEAP32[gb + 59760 >> 2] = fb + 648;
 HEAP32[gb + 59764 >> 2] = fb + 649;
 HEAP32[gb + 59768 >> 2] = fb + 80;
 HEAP32[gb + 59772 >> 2] = fb + 39;
 HEAP32[gb + 59776 >> 2] = fb + 16;
 HEAP32[gb + 59780 >> 2] = fb + 650;
 HEAP32[gb + 59784 >> 2] = fb + 651;
 HEAP32[gb + 59788 >> 2] = fb + 19;
 HEAP32[gb + 59792 >> 2] = fb + 286;
 HEAP32[gb + 59796 >> 2] = fb + 99;
 HEAP32[gb + 59800 >> 2] = fb + 40;
 HEAP32[gb + 59804 >> 2] = fb + 62;
 HEAP32[gb + 59808 >> 2] = fb + 28;
 HEAP32[gb + 59812 >> 2] = fb + 63;
 HEAP32[gb + 59816 >> 2] = fb + 29;
 HEAP32[gb + 59820 >> 2] = fb + 34;
 HEAP32[gb + 59824 >> 2] = fb + 509;
 HEAP32[gb + 59828 >> 2] = fb + 510;
 HEAP32[gb + 59832 >> 2] = fb + 511;
 HEAP32[gb + 59836 >> 2] = fb + 512;
 HEAP32[gb + 59840 >> 2] = fb + 513;
 HEAP32[gb + 59844 >> 2] = fb + 514;
 HEAP32[gb + 59848 >> 2] = fb + 36;
 HEAP32[gb + 59852 >> 2] = fb + 96;
 HEAP32[gb + 59856 >> 2] = fb + 81;
 HEAP32[gb + 59860 >> 2] = fb + 82;
 HEAP32[gb + 59864 >> 2] = (HEAP32[gb + 59864 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59868 >> 2] = (HEAP32[gb + 59868 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59872 >> 2] = (HEAP32[gb + 59872 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59876 >> 2] = (HEAP32[gb + 59876 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59880 >> 2] = (HEAP32[gb + 59880 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59884 >> 2] = (HEAP32[gb + 59884 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59888 >> 2] = (HEAP32[gb + 59888 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59892 >> 2] = (HEAP32[gb + 59892 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59896 >> 2] = (HEAP32[gb + 59896 >> 2] | 0) + (gb + 1083761 | 0);
 HEAP32[gb + 59900 >> 2] = (HEAP32[gb + 59900 >> 2] | 0) + (gb + 1084284 | 0);
 HEAP32[gb + 59904 >> 2] = (HEAP32[gb + 59904 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59908 >> 2] = (HEAP32[gb + 59908 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59912 >> 2] = (HEAP32[gb + 59912 >> 2] | 0) + (gb + 434765 | 0);
 HEAP32[gb + 59916 >> 2] = (HEAP32[gb + 59916 >> 2] | 0) + (gb + 434543 | 0);
 HEAP32[gb + 59920 >> 2] = (HEAP32[gb + 59920 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59924 >> 2] = (HEAP32[gb + 59924 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59928 >> 2] = (HEAP32[gb + 59928 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59932 >> 2] = (HEAP32[gb + 59932 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59936 >> 2] = (HEAP32[gb + 59936 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 59940 >> 2] = (HEAP32[gb + 59940 >> 2] | 0) + (gb + 434771 | 0);
 runPostSets44();
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 40 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i3 = i8;
 i5 = i8 + 32 | 0;
 i6 = i8 + 28 | 0;
 __ZN16ReflectionSampleC2Ev(i4);
 HEAP32[i4 + 124 >> 2] = i2;
 HEAP32[i4 + 128 >> 2] = i1;
 i1 = __Z12GetGfxDevicev() | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f13 = Math_fround(f12 - f14);
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f10 = Math_fround(f9 - f11);
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f17 = Math_fround(f16 - f18);
 i2 = HEAP32[i4 + 120 >> 2] | 0;
 f14 = Math_fround(f12 + f14);
 f11 = Math_fround(f9 + f11);
 f18 = Math_fround(f16 + f18);
 i19 = i4 + 28 | 0;
 i15 = i1 + 1524 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAPF32[i1 + 1556 >> 2] = f13;
 HEAPF32[i1 + 1560 >> 2] = f10;
 HEAPF32[i1 + 1564 >> 2] = f17;
 HEAP32[i1 + 1568 >> 2] = i2;
 HEAPF32[i1 + 1540 >> 2] = f14;
 HEAPF32[i1 + 1544 >> 2] = f11;
 HEAPF32[i1 + 1548 >> 2] = f18;
 HEAPF32[i1 + 1552 >> 2] = Math_fround(1.0);
 i2 = i4 + 44 | 0;
 i15 = i1 + 1572 | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f18 = Math_fround(HEAPF32[i4 + 60 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 72 >> 2]);
 f14 = Math_fround(f18 - f11);
 f17 = Math_fround(HEAPF32[i4 + 64 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 76 >> 2]);
 f13 = Math_fround(f17 - f10);
 f16 = Math_fround(HEAPF32[i4 + 68 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 80 >> 2]);
 f12 = Math_fround(f16 - f9);
 f11 = Math_fround(f18 + f11);
 f10 = Math_fround(f17 + f10);
 f9 = Math_fround(f16 + f9);
 i15 = i4 + 88 | 0;
 i2 = i1 + 1588 | 0;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAPF32[i1 + 1620 >> 2] = f14;
 HEAPF32[i1 + 1624 >> 2] = f13;
 HEAPF32[i1 + 1628 >> 2] = f12;
 HEAPF32[i1 + 1632 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1604 >> 2] = f11;
 HEAPF32[i1 + 1608 >> 2] = f10;
 HEAPF32[i1 + 1612 >> 2] = f9;
 HEAPF32[i1 + 1616 >> 2] = Math_fround(1.0);
 i2 = i4 + 104 | 0;
 i1 = i1 + 1636 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i1 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 HEAP32[i6 >> 2] = -1073741805;
 HEAP32[i1 + 3360 >> 2] = i2;
 HEAP32[i1 + 3364 >> 2] = 4;
 i2 = HEAP32[i1 + 3368 >> 2] | 0;
 switch (i2 | 0) {
 case 1:
 case 4:
  break;
 default:
  {
   i15 = HEAP32[gb + 68604 + (i2 << 2) >> 2] | 0;
   i19 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i6) | 0;
   HEAP32[i3 >> 2] = gb + 478920;
   HEAP32[i3 + 4 >> 2] = i15;
   HEAP32[i3 + 8 >> 2] = i19;
   __Z6FormatPKcz(i5, gb + 478736 | 0, i3);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
 }
 HEAP32[i1 + 3372 >> 2] = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 HEAP32[i6 >> 2] = -1073741804;
 HEAP32[i2 + 3380 >> 2] = i1;
 HEAP32[i2 + 3384 >> 2] = 4;
 i1 = HEAP32[i2 + 3388 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
 case 4:
  {
   i19 = i2 + 3392 | 0;
   HEAP32[i19 >> 2] = 0;
   STACKTOP = i8;
   return;
  }
 default:
  {}
 }
 i15 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
 i19 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i6) | 0;
 HEAP32[i7 >> 2] = gb + 478920;
 HEAP32[i7 + 4 >> 2] = i15;
 HEAP32[i7 + 8 >> 2] = i19;
 __Z6FormatPKcz(i5, gb + 478736 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i19 = i2 + 3392 | 0;
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13AnimationClip16AddPositionCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i10, i12) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14;
 i6 = i14 + 8 | 0;
 i13 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAPF32[i6 + 20 >> 2] = Math_fround(inf);
 HEAP32[i6 + 16 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i8 = i7 + 52 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAPF32[i6 + 80 >> 2] = Math_fround(inf);
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 148 >> 2] = 0;
 i3 = i6 + 152 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 140 | 0;
 i7 = i6 + 84 | 0;
 i8 = i7 + 56 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i6 + 160 >> 2] = 2;
 HEAP32[i6 + 156 >> 2] = 2;
 HEAP32[i6 + 164 >> 2] = 4;
 HEAP32[i6 + 168 >> 2] = 0;
 i11 = i2 + 136 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 140 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i2 + 132 | 0, i6); else {
  __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i6);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 172;
 }
 i1 = i6 + 136 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i2 = i9 + -156 | 0;
 i7 = i2;
 i1 = i10;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i7 = i9 + -96 | 0;
 i1 = i10 + 60 | 0;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i5 = i9 + -36 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  i6 = HEAP32[i10 + 120 >> 2] | 0;
  i7 = i9 + -24 | 0;
  i1 = (HEAP32[i10 + 132 >> 2] | 0) * 40 | 0;
  i2 = (i1 | 0) / 40 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i9 + -20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 }
 i6 = i9 + -16 | 0;
 i1 = i10 + 140 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = i6 + -172 | 0;
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i8 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + -168 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 84804 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN13AnimationClip13AddScaleCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i10, i12) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14;
 i6 = i14 + 8 | 0;
 i13 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAPF32[i6 + 20 >> 2] = Math_fround(inf);
 HEAP32[i6 + 16 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i8 = i7 + 52 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAPF32[i6 + 80 >> 2] = Math_fround(inf);
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 148 >> 2] = 0;
 i3 = i6 + 152 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 140 | 0;
 i7 = i6 + 84 | 0;
 i8 = i7 + 56 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i6 + 160 >> 2] = 2;
 HEAP32[i6 + 156 >> 2] = 2;
 HEAP32[i6 + 164 >> 2] = 4;
 HEAP32[i6 + 168 >> 2] = 0;
 i11 = i2 + 152 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 156 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i2 + 148 | 0, i6); else {
  __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i6);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 172;
 }
 i1 = i6 + 136 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i2 = i9 + -156 | 0;
 i7 = i2;
 i1 = i10;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i7 = i9 + -96 | 0;
 i1 = i10 + 60 | 0;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i5 = i9 + -36 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  i6 = HEAP32[i10 + 120 >> 2] | 0;
  i7 = i9 + -24 | 0;
  i1 = (HEAP32[i10 + 132 >> 2] | 0) * 40 | 0;
  i2 = (i1 | 0) / 40 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i9 + -20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 }
 i6 = i9 + -16 | 0;
 i1 = i10 + 140 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = i6 + -172 | 0;
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i8 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + -168 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i14;
 return;
}

function __ZN13AnimationClip13AddEulerCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i10, i12) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14;
 i6 = i14 + 8 | 0;
 i13 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAPF32[i6 + 20 >> 2] = Math_fround(inf);
 HEAP32[i6 + 16 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i8 = i7 + 52 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAPF32[i6 + 80 >> 2] = Math_fround(inf);
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 148 >> 2] = 0;
 i3 = i6 + 152 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 140 | 0;
 i7 = i6 + 84 | 0;
 i8 = i7 + 56 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i6 + 160 >> 2] = 2;
 HEAP32[i6 + 156 >> 2] = 2;
 HEAP32[i6 + 164 >> 2] = 4;
 HEAP32[i6 + 168 >> 2] = 0;
 i11 = i2 + 120 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 124 >> 2] | 0)) __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i2 + 116 | 0, i6); else {
  __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i6);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 172;
 }
 i1 = i6 + 136 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i2 = i9 + -156 | 0;
 i7 = i2;
 i1 = i10;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i7 = i9 + -96 | 0;
 i1 = i10 + 60 | 0;
 i8 = i7 + 60 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 i5 = i9 + -36 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  i6 = HEAP32[i10 + 120 >> 2] | 0;
  i7 = i9 + -24 | 0;
  i1 = (HEAP32[i10 + 132 >> 2] | 0) * 40 | 0;
  i2 = (i1 | 0) / 40 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i9 + -20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + -32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 }
 i6 = i9 + -16 | 0;
 i1 = i10 + 140 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = i6 + -172 | 0;
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i8 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i4 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + -164 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + -168 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i8);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + -168 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103244 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 92 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 104 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 112 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZL27PrepareSceneNodesJobCombineP25ScheduleSceneNodesJobData(i26) {
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i28 + 4 | 0;
 i2 = i28;
 if ((HEAP16[gb + 1110728 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110728 | 0, i1);
  i19 = gb + 1110728 | 0;
 } else i19 = 0;
 i23 = HEAP32[i26 + 2736 >> 2] | 0;
 i24 = i23 + 92 | 0;
 i25 = HEAP32[i26 + 2732 >> 2] | 0;
 if ((i25 | 0) > 0) {
  i20 = i23 + 104 | 0;
  i21 = i23 + 108 | 0;
  i22 = i23 + 96 | 0;
  i18 = 0;
  do {
   i1 = i26 + 2660 + (i18 << 3) | 0;
   if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
   i12 = HEAP32[i26 + (i18 * 532 | 0) + 4 >> 2] | 0;
   i13 = HEAP32[i26 + (i18 * 532 | 0) + 348 >> 2] | 0;
   if ((i13 | 0) > 0) {
    i14 = HEAP32[i26 + (i18 * 532 | 0) >> 2] | 0;
    i11 = 0;
    do {
     i15 = HEAP32[i26 + (i18 * 532 | 0) + 20 + (i11 * 20 | 0) + 12 >> 2] | 0;
     if ((i15 | 0) > 0) {
      i16 = i26 + (i18 * 532 | 0) + 20 + (i11 * 20 | 0) | 0;
      i10 = 0;
      do {
       i9 = HEAP32[(HEAP32[i14 >> 2] | 0) + (HEAP32[(HEAP32[i16 >> 2] | 0) + (i10 << 2) >> 2] << 2) >> 2] | 0;
       i17 = i12 + (i9 * 24 | 0) | 0;
       if (HEAP8[i12 + (i9 * 24 | 0) + 20 >> 0] & 1) {
        i2 = HEAP32[i20 >> 2] | 0;
        i3 = i2 + 1 | 0;
        i4 = HEAP32[i21 >> 2] | 0;
        i5 = i4 & 2147483647;
        do if (i3 >>> 0 > i5 >>> 0) {
         i1 = i4 << 1;
         i1 = (i1 | 0) == 0 ? 1 : i1;
         if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
          HEAP32[i21 >> 2] = i1;
          HEAP32[i24 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i24 >> 2] | 0, i1 << 2, 4, i22, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i22, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i9 | 0, HEAP32[i24 >> 2] | 0, HEAP32[i20 >> 2] << 2 | 0) | 0;
          HEAP32[i21 >> 2] = i1;
          HEAP32[i24 >> 2] = i9;
          break;
         }
        } while (0);
        HEAP32[i20 >> 2] = i3;
        HEAP32[(HEAP32[i24 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i17 >> 2];
       }
       i2 = (HEAP32[i17 >> 2] | 0) + 236 | 0;
       i2 = (HEAPU16[i2 >> 1] | HEAPU8[i2 + 2 >> 0] << 16) & 63;
       if (HEAP8[i26 + 2720 + i2 >> 0] | 0) {
        i3 = i23 + 112 + (i2 * 20 | 0) | 0;
        i4 = i23 + 112 + (i2 * 20 | 0) + 12 | 0;
        i5 = HEAP32[i4 >> 2] | 0;
        i6 = i5 + 1 | 0;
        i7 = i23 + 112 + (i2 * 20 | 0) + 16 | 0;
        i8 = HEAP32[i7 >> 2] | 0;
        i9 = i8 & 2147483647;
        do if (i6 >>> 0 > i9 >>> 0) {
         i1 = i8 << 1;
         i1 = (i1 | 0) == 0 ? 1 : i1;
         if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
          HEAP32[i7 >> 2] = i1;
          HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i23 + 112 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
          break;
         } else {
          i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i23 + 112 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
          _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
          HEAP32[i7 >> 2] = i1;
          HEAP32[i3 >> 2] = i9;
          break;
         }
        } while (0);
        HEAP32[i4 >> 2] = i6;
        HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i17 >> 2];
       }
       i10 = i10 + 1 | 0;
      } while ((i10 | 0) != (i15 | 0));
     }
     i11 = i11 + 1 | 0;
    } while ((i11 | 0) != (i13 | 0));
   }
   i18 = i18 + 1 | 0;
  } while ((i18 | 0) != (i25 | 0));
  if (i26 | 0) i27 = 6;
 } else i27 = 6;
 if ((i27 | 0) == 6) {
  __ZN24PrepareSceneNodesJobDataD2Ev(i26 + 2128 | 0);
  __ZN24PrepareSceneNodesJobDataD2Ev(i26 + 1596 | 0);
  __ZN24PrepareSceneNodesJobDataD2Ev(i26 + 1064 | 0);
  __ZN24PrepareSceneNodesJobDataD2Ev(i26 + 532 | 0);
  __ZN24PrepareSceneNodesJobDataD2Ev(i26);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i26, gb + 64024 | 0);
 if (!i19) {
  STACKTOP = i28;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i28;
 return;
}

function __ZN13SplatDatabase18SetSplatPrototypesERKNSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEE(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 48 | 0;
 i10 = i19 + 8 | 0;
 i11 = i19;
 i7 = i19 + 32 | 0;
 i8 = i19 + 16 | 0;
 i9 = i19 + 12 | 0;
 i18 = i16 + 4 | 0;
 i13 = ((HEAP32[i18 >> 2] | 0) - (HEAP32[i16 >> 2] | 0) | 0) / 44 | 0;
 i13 = ((i13 & 3 | 0) != 0 & 1) + (i13 >>> 2) | 0;
 i14 = i15 + 12 | 0;
 i17 = i15 + 16 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i1 = i2 - i3 >> 2;
 L1 : do if (i1 >>> 0 < i13 >>> 0) {
  i4 = i15 + 36 | 0;
  i5 = i7 + 11 | 0;
  i6 = i15 + 20 | 0;
  while (1) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   if ((i3 | 0) == (i2 | 0)) HEAPF32[i8 >> 2] = Math_fround(1.0);
   i20 = gb + 63520 | 0;
   i3 = HEAP32[i20 + 4 >> 2] | 0;
   i2 = i11;
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i2 + 4 >> 2] = i3;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   i2 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(0, i12) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i2, i3, i3, 5, 1) | 0;
   __ZN7Texture11SetWrapModeEi(i2, 1);
   __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf(i2, i8);
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i17 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) >> 2;
   __Z6FormatPKcz(i7, gb + 934259 | 0, i10);
   mftCall_vii(i3 | 0, i2 | 0, ((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = i2;
   i3 = HEAP32[i17 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i14, i9); else {
    HEAP32[i3 >> 2] = i2;
    HEAP32[i17 >> 2] = i3 + 4;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i13 | 0)) break L1;
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
  }
 } else if (i1 >>> 0 > i13 >>> 0) {
  i5 = i13;
  do {
   i4 = i3 + (i5 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i11 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i6 = 25; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i11);
      i2 = HEAP32[i12 >> 2] | 0;
      i20 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 25; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i6 = 27;
     }
    }
    if ((i6 | 0) == 25) i6 = 27;
    if ((i6 | 0) == 27) {
     i6 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    }
   }
   __Z19DestroySingleObjectP6Object(i1);
   i5 = i5 + 1 | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i1 = i2 - i3 >> 2;
  } while (i5 >>> 0 < i1 >>> 0);
  if (i13 >>> 0 > i1 >>> 0) {
   __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i14, i13 - i1 | 0);
   break;
  }
  if (i13 >>> 0 < i1 >>> 0) {
   i1 = i3 + (i13 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  }
 } while (0);
 if ((i15 | 0) == (i16 | 0)) {
  __ZN13SplatDatabase18RecalculateBasemapEb(i15, 0);
  STACKTOP = i19;
  return;
 }
 __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i15, HEAP32[i16 >> 2] | 0, HEAP32[i18 >> 2] | 0);
 __ZN13SplatDatabase18RecalculateBasemapEb(i15, 0);
 STACKTOP = i19;
 return;
}

function __ZN13BuildSettingsC2E10MemLabelId18ObjectCreationMode(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i9 = i10 + 8 | 0;
 i3 = i10;
 i7 = i10 + 16 | 0;
 i4 = i1;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i6, i8, i2);
 HEAP32[i6 >> 2] = gb + 64212 + 8;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 + 84 >> 2] = 0;
 HEAP32[i6 + 88 >> 2] = 0;
 HEAP32[i6 + 96 >> 2] = 0;
 HEAP32[i6 + 100 >> 2] = 0;
 HEAP32[i6 + 104 >> 2] = 0;
 i1 = i6 + 124 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i6 + 28 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i6 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i5 = i6 + 140 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 + 152 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 + 156 >> 2] = 0;
 HEAP32[i6 + 168 >> 2] = 0;
 HEAP32[i6 + 172 >> 2] = 0;
 i3 = HEAP32[gb + 63664 >> 2] | 0;
 i1 = HEAP32[gb + 63664 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i6 + 160 >> 2] = i3;
 HEAP32[i6 + 164 >> 2] = i1;
 HEAP8[i6 + 108 >> 0] = 1;
 HEAP8[i6 + 109 >> 0] = 1;
 HEAP8[i6 + 116 >> 0] = 1;
 HEAP8[i6 + 117 >> 0] = 1;
 HEAP8[i6 + 118 >> 0] = 1;
 i3 = i6 + 111 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP8[i6 + 115 >> 0] = 1;
 HEAP8[i6 + 119 >> 0] = 1;
 HEAP8[i6 + 120 >> 0] = 1;
 HEAP8[i6 + 110 >> 0] = 1;
 HEAP8[i6 + 121 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 11 | 0;
 HEAP8[i3 >> 0] = 5;
 HEAP8[i7 >> 0] = HEAP8[gb + 443926 >> 0] | 0;
 HEAP8[i7 + 1 >> 0] = HEAP8[gb + 443926 + 1 >> 0] | 0;
 HEAP8[i7 + 2 >> 0] = HEAP8[gb + 443926 + 2 >> 0] | 0;
 HEAP8[i7 + 3 >> 0] = HEAP8[gb + 443926 + 3 >> 0] | 0;
 HEAP8[i7 + 4 >> 0] = HEAP8[gb + 443926 + 4 >> 0] | 0;
 HEAP8[i7 + 5 >> 0] = 0;
 L4 : do if ((i5 | 0) != (i7 | 0)) {
  i4 = i5 + 11 | 0;
  do if ((HEAP8[i4 >> 0] | 0) < 0) {
   i1 = HEAP32[i6 + 148 >> 2] & 2147483647;
   i2 = i1 + -1 | 0;
   if (i2 >>> 0 < 5) {
    i6 = HEAP32[i6 + 144 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i2, 6 - i1 | 0, i6, 0, i6, 5, i7);
    break L4;
   } else {
    i1 = HEAP32[i5 >> 2] | 0;
    break;
   }
  } else i1 = i5; while (0);
  _memmove(i1 | 0, i7 | 0, 5) | 0;
  HEAP8[i1 + 5 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + 144 >> 2] = 5;
   break;
  } else {
   HEAP8[i4 >> 0] = 5;
   break;
  }
 } while (0);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 8488 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i9 = i3;
  i8 = i9 + 1 | 0;
  HEAP32[i2 >> 2] = i8;
  i8 = i1 + 7720 + (i9 * 12 | 0) + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  i8 = i1 + 7720 + (i9 * 12 | 0) + 8 | 0;
  HEAP8[i8 >> 0] = 0;
  i9 = i1 + 7720 + (i9 * 12 | 0) | 0;
  HEAP32[i9 >> 2] = fb + 72;
  STACKTOP = i10;
  return;
 }
 __Z6FormatPKcz(i8, gb + 1048800 | 0, i9);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i2 >> 2] = i8;
 i8 = i1 + 7720 + (i9 * 12 | 0) + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i8 = i1 + 7720 + (i9 * 12 | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i9 = i1 + 7720 + (i9 * 12 | 0) | 0;
 HEAP32[i9 >> 2] = fb + 72;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj430ES2_RKNS_18PxJointLinearLimitES6_EEKNS_31PxJointLinearLimitGeneratedInfoEEEvPjRKT_RT0_(i23, i1, i22, i21) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20 + 132 | 0;
 i17 = i20 + 184 | 0;
 i19 = i20 + 16 | 0;
 i14 = i20 + 80 | 0;
 i15 = i20;
 i18 = i20 + 56 | 0;
 i16 = i20 + 32 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i23 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i12 = HEAP32[i23 + 20 >> 2] | 0;
    i12 = (mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i12;
    i1 = HEAP32[i23 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i12;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i12 = HEAP32[i23 >> 2] | 0;
   HEAP8[(HEAP32[i12 + 4 >> 2] | 0) + ((HEAP32[i12 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i23 + 36 >> 0] | 0)) {
  STACKTOP = i20;
  return;
 }
 i8 = i23 + 24 | 0;
 mftCall_vii(HEAP32[i22 + 16 >> 2] | 0, i18 | 0, HEAP32[i8 >> 2] | 0);
 i9 = i23 + 8 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i2 = HEAP32[i23 + 4 >> 2] | 0;
 i3 = HEAP32[i23 + 20 >> 2] | 0;
 i6 = HEAP32[i23 + 28 >> 2] | 0;
 i4 = HEAP32[i23 + 32 >> 2] | 0;
 i10 = i15;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP8[i17 >> 0] = 0;
 i7 = i18;
 i5 = i17;
 i10 = i19;
 i11 = i9;
 i12 = i10 + 12 | 0;
 do {
  HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
  i10 = i10 + 1 | 0;
  i11 = i11 + 1 | 0;
 } while ((i10 | 0) < (i12 | 0));
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i13 + 20 >> 2] = i3;
 HEAP32[i13 + 24 >> 2] = i7;
 HEAP32[i13 + 28 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i4;
 HEAP8[i13 + 36 >> 0] = 1;
 HEAP32[i13 + 40 >> 2] = i5;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 48 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i13, i21 + 64 | 0, 4);
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i3;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 28 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj490ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i21 + 80 | 0, 0);
 if (HEAP8[i17 >> 0] | 0) HEAP8[HEAP32[i23 + 40 >> 2] >> 0] = 1;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 mftCall_vii(HEAP32[i22 + 20 >> 2] | 0, i23 | 0, i16 | 0);
 STACKTOP = i20;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i12 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 20 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i10 >>> 0) {
  if (i2 >>> 0 <= i10 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i10 * 20 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i10 * 20 | 0;
  i3 = (i2 | 0) / 20 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 20 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i10) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i2, i1);
     i1 = i1 + 20 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i7 >> 2] = i1;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i1 >> 2] = 0;
      i1 = HEAP32[i7 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 20 | 0 | 0) == (i10 | 0)) {
  __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i14, i10 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i11 = i12 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i8 = i12 + 8 | 0;
 if (i10 | 0) {
  i2 = __Znwj(i10 * 20 | 0) | 0;
  i1 = i2;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i10 * 20 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i12, i3, i13);
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 20 | 0;
 i4 = i2;
 if (i1 >>> 0 < i10 >>> 0) {
  __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i12, i10 - i1 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
 } else if (i1 >>> 0 > i10 >>> 0) {
  i3 = i3 + (i10 * 20 | 0) | 0;
  if ((i4 | 0) != (i3 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i11 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i11 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i11 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i11 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i11 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i3, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 1 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 5 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 6 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 7 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 8 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 10 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 11 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i3 + 12 | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i2, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 13 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 14 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 15 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  return;
 }
}

function __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i7);
 __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 80 | 0, i7);
 i1 = i9 + 192 | 0;
 i10 = i7 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i8 = i7 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 8);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i12 = i3;
  i3 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i10 >> 2] = i4;
 }
 i5 = i9 + 156 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i3;
 i4 = i9 + 164 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
  i5 = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i9 + 200 | 0;
 i3 = i5 + 8 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 8);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = i5;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = i1;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 180 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i9 + 181 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i9 + 184 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
  i2 = i4;
 }
 i4 = i9 + 176 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i12 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i12;
  HEAP32[i10 >> 2] = i1;
  i1 = i12;
 }
 HEAP32[i4 >> 2] = i1;
 if (i1 >>> 0 > 3) HEAP32[i4 >> 2] = 0;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 32 | 0, i7);
 i3 = i9 + 104 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i3, i1);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, HEAP32[i3 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 128 | 0, i7);
 __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 88 | 0, i7);
 i1 = i9 + 56 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i9 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 68 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 52 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 48 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN14SplatMaterials22UpdateBaseMapMaterialsEP8Materialb(i12, i6, i10) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 48 | 0;
 i13 = i18 + 40 | 0;
 i14 = i18 + 32 | 0;
 i15 = i18 + 16 | 0;
 i16 = i18 + 8 | 0;
 i17 = i18 + 4 | 0;
 i8 = i18;
 i7 = i18 + 36 | 0;
 i9 = i18 + 12 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i13 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i13);
    i3 = HEAP32[i11 >> 2] | 0;
    i19 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0;
 }
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i5 = i12 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == 0 | (i3 | 0) == 0) {
  __Z19DestroySingleObjectP6Object(i4);
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i18;
  return;
 }
 if (!i4) HEAP32[i5 >> 2] = __ZN8Material14CreateMaterialER6Shaderib(i3, 61, 0) | 0;
 i19 = __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i12 + 40 | 0, gb + 1467288 | 0) | 0;
 HEAP32[i8 >> 2] = i19 ? HEAP32[gb + 1467304 >> 2] | 0 : HEAP32[gb + 1467308 >> 2] | 0;
 if (i6 | 0) {
  __ZN8Material26CopyPropertiesFromMaterialERS_(HEAP32[i5 >> 2] | 0, i6);
  __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_((HEAP32[i5 >> 2] | 0) + 44 | 0, gb + 1467248 | 0) | 0;
  __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_((HEAP32[i5 >> 2] | 0) + 44 | 0, i8) | 0;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1467248 >> 2];
 i19 = HEAP32[i1 + 76 >> 2] | 0;
 if ((i19 | 0) != (__Z19GetActiveColorSpacev() | 0)) __ZN13SplatDatabase18RecalculateBasemapEb(i1 + 32 | 0, 0);
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0 ? i3 : 0;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i4, i11, i3);
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0 ? i1 : 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i3, i11, i1);
 if (i10) {
  i1 = HEAP32[i5 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i12 + 24 >> 2]);
  HEAP32[i13 >> 2] = HEAP32[gb + 1467312 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i11) | 0) {
   HEAP32[i14 >> 2] = HEAP32[gb + 1467312 >> 2];
   i19 = HEAP32[i12 + 20 >> 2] | 0;
   f22 = Math_fround(Math_fround((i19 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f21 = Math_fround(Math_fround(i19 >>> 16 & 255) / Math_fround(255.0));
   f20 = Math_fround(Math_fround(i19 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i15 >> 2] = Math_fround(Math_fround(i19 & 255) / Math_fround(255.0));
   HEAPF32[i15 + 4 >> 2] = f22;
   HEAPF32[i15 + 8 >> 2] = f21;
   HEAPF32[i15 + 12 >> 2] = f20;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i1, i11, i15);
  }
  HEAP32[i16 >> 2] = HEAP32[gb + 1467316 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
  if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i11) | 0) {
   HEAP32[i17 >> 2] = HEAP32[gb + 1467316 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i11, f2);
  }
 }
 STACKTOP = i18;
 return;
}

function __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i12, i1, i11, i3, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 280 | 0;
 i13 = i15;
 i4 = i15 + 264 | 0;
 i5 = i15 + 252 | 0;
 i8 = i15 + 240 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i16 + 16 >> 2] | 0;
 i6 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = gb + 84176 + 8;
 HEAP32[i6 >> 2] = gb + 84176 + 32;
 HEAP32[i13 + 8 >> 2] = i11;
 i7 = i13 + 12 | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i13 + 16 >> 2] = i2;
 HEAP32[i13 + 20 >> 2] = i16 + 8;
 HEAP32[i13 + 24 >> 2] = i16 + 12;
 HEAP32[i13 + 28 >> 2] = 0;
 i16 = i13 + 32 | 0;
 i2 = HEAP32[i11 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP8[i13 + 56 >> 0] = i1 & 1;
 HEAP32[i13 + 60 >> 2] = i2;
 i2 = i13 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAP32[i13 + 68 >> 2] = 0;
 HEAP32[i13 + 72 >> 2] = 0;
 HEAP32[i13 + 76 >> 2] = -1;
 HEAP16[i13 + 80 >> 1] = 0;
 i1 = i13 + 84 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i13 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i13 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 116 >> 2] = Math_fround(0.0);
 HEAP8[i13 + 181 >> 0] = (HEAP32[i3 + 4 >> 2] | 0) == 1 & 1;
 i1 = i13 + 180 | 0;
 HEAP8[i1 >> 0] = 0;
 i3 = i13 + 208 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 if (i10) {
  __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i4, i12);
  if (Math_fround(Math_abs(Math_fround(HEAPF32[i4 + 12 >> 2]))) > Math_fround(.999899983)) {
   f28 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 >> 2])));
   f26 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 + 4 >> 2])));
   f17 = Math_fround(Math_abs(Math_fround(HEAPF32[i12 + 8 >> 2])));
   i16 = i12 + 12 | 0;
   f27 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 >> 2])));
   f23 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 + 4 >> 2])));
   f18 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 + 8 >> 2])));
   i16 = i12 + 24 | 0;
   f20 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 >> 2])));
   f22 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 + 4 >> 2])));
   f19 = Math_fround(Math_abs(Math_fround(HEAPF32[i16 + 8 >> 2])));
   f24 = Math_fround(HEAPF32[i12 + 48 >> 2]);
   f25 = Math_fround(HEAPF32[i12 + 52 >> 2]);
   f21 = Math_fround(HEAPF32[i12 + 56 >> 2]);
   f20 = Math_fround(Math_fround(Math_fround(f28 * f24) + Math_fround(f27 * f25)) + Math_fround(f20 * f21));
   f22 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f23 * f25)) + Math_fround(f22 * f21));
   f21 = Math_fround(Math_fround(Math_fround(f17 * f24) + Math_fround(f18 * f25)) + Math_fround(f19 * f21));
   i16 = HEAP32[i11 + 4 >> 2] | 0;
   f19 = Math_fround(HEAPF32[i12 + 36 >> 2]);
   f25 = Math_fround(f19 - f20);
   f18 = Math_fround(HEAPF32[i12 + 40 >> 2]);
   f24 = Math_fround(f18 - f22);
   f17 = Math_fround(HEAPF32[i12 + 44 >> 2]);
   f23 = Math_fround(f17 - f21);
   HEAPF32[i5 >> 2] = f25;
   HEAPF32[i5 + 4 >> 2] = f24;
   HEAPF32[i5 + 8 >> 2] = f23;
   f18 = Math_fround(f22 + f18);
   f17 = Math_fround(f21 + f17);
   HEAPF32[i8 >> 2] = Math_fround(f20 + f19);
   HEAPF32[i8 + 4 >> 2] = f18;
   HEAPF32[i8 + 8 >> 2] = f17;
   __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE(i16, i5, i8, 4, i9, i13 + 4 | 0);
  } else i14 = 4;
 } else i14 = 4;
 if ((i14 | 0) == 4) __ZNK5physx2Gu5RTree11traverseOBBERKNS0_3BoxEjPjPNS1_8CallbackE(HEAP32[i11 + 4 >> 2] | 0, i12, 4, i9, i13 + 4 | 0);
 HEAP32[i13 >> 2] = gb + 84176 + 8;
 HEAP32[i6 >> 2] = gb + 84176 + 32;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[i7 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i13 + 68 | 0, i13 + 132 | 0, i13 + 144 | 0, i13 + 156 | 0, i2 | 0, i13 + 168 | 0) | 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i12, i13, i15, i14, i1) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 288 | 0;
 i8 = i11 + 136 | 0;
 i2 = i11 + 128 | 0;
 i7 = i11;
 i10 = i11 + 320 | 0;
 i3 = HEAP32[i12 + 104 >> 2] | 0;
 i1 = i3;
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i3 | 0) | 0)) {
   i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i2 >> 2] = gb + 832239;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i2);
  }
  i5 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 52 >> 2] | 0, i13 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = (i5 | 0) == 0 & (i2 | 0) == 0;
  i1 = i6 ? i1 : i5;
  i2 = i6 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = gb + 832257;
 HEAP32[i7 + 4 >> 2] = i3;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i15 | 0, gb + 832239 | 0, i7 | 0);
 i1 = HEAP32[i12 + 48 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i14 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i8 | 0, 1) | 0;
 i1 = i14 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 832272 | 0, HEAP32[i1 >> 2] | 0);
 i2 = i14 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i14 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i12 + 108 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i9 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i9) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i14 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 832282 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i14 + 8 >> 2];
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i6 = i10 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i10;
 i5 = i15;
 i15 = i13;
 __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i9 + 8 >> 2] = i12;
 HEAP32[i9 + 12 >> 2] = i14;
 HEAP32[i9 + 16 >> 2] = i15;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEEEEEjT_j(i8, i9, 0) | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = i12;
 HEAP32[i7 + 12 >> 2] = i14;
 HEAP32[i7 + 16 >> 2] = i15;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i7, 0, i8 + 68 | 0, i9);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i7, 1, i8 + 92 | 0, i9);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i7, 2, i8 + 116 | 0, i9);
 i15 = HEAP32[i6 >> 2] | 0;
 if (!((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i15 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i11;
 return;
}

function __ZN9JSONWrite14BeginMetaGroupEPKc(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 16 | 0;
 i14 = i17;
 i15 = i12 + 16 | 0;
 i16 = i12 + 28 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i3 = i6 + 1 | 0;
 i4 = i12 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i5 & 2147483647;
 do if (i3 >>> 0 > i2 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i2 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 40 | 0, 8, i12 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 40 | 0, 8, i12 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i15 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i16 >> 2] = i3;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1 + (i6 * 40 | 0) + 24 | 0;
 i3 = i1 + (i6 * 40 | 0) | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 + (i6 * 40 | 0) + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 if (!i7) {
  i16 = HEAP32[i16 >> 2] | 0;
  i16 = i16 + -1 | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  i15 = i14 + (i16 * 40 | 0) | 0;
  i13 = i12 + 56 | 0;
  HEAP32[i13 >> 2] = i15;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
  i16 = i14 + (i16 * 40 | 0) + 16 | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  HEAP32[i16 >> 2] = 3;
  STACKTOP = i17;
  return;
 }
 i8 = (HEAP32[i16 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i15 >> 2] | 0;
 i10 = i9 + (i8 * 40 | 0) + 24 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 i2 = _strlen(i7) | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  i11 = 10;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i14 + 11 >> 0] = i2;
  if (!i2) i1 = i14; else {
   i1 = i14;
   i11 = 12;
  }
 } else i11 = 10;
 if ((i11 | 0) == 10) {
  i6 = i2 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i2;
  i11 = 12;
 }
 if ((i11 | 0) == 12) _memcpy(i1 | 0, i7 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 i5 = i14 + 11 | 0;
 do if ((i10 | 0) != (i14 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i14 >> 2] | 0 : i14;
  i7 = i3 ? HEAP32[i14 + 4 >> 2] | 0 : i7 & 255;
  i3 = i10 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + (i8 * 40 | 0) + 32 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + (i8 * 40 | 0) + 28 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i10;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + (i8 * 40 | 0) + 28 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i11 = HEAP32[i14 >> 2] | 0;
  i14 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i13);
 }
 i16 = HEAP32[i16 >> 2] | 0;
 i16 = i16 + -1 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 i15 = i14 + (i16 * 40 | 0) | 0;
 i13 = i12 + 56 | 0;
 HEAP32[i13 >> 2] = i15;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 i16 = i14 + (i16 * 40 | 0) + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i16 >> 2] = 3;
 STACKTOP = i17;
 return;
}

function __ZN14PhysicsManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5);
 i1 = i6 + 32 | 0;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i5 + 24 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN4PPtrI14PhysicMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 60 | 0, i5);
 i1 = i6 + 52 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = HEAP32[i6 + 168 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = HEAP32[i6 + 172 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = HEAP8[i6 + 798 >> 0] | 0;
 HEAP8[i8 >> 0] = i1;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = i1;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 57 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 797 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i7 = i6 + 724 | 0;
 i2 = i6 + 728 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 HEAP32[i8 >> 2] = i3;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i9 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN15dtPathQueryInfo3setEyyPKfS1_PK14dtNavMeshQuery(i14, i4, i5, i6, i7, i8, i9, i10) {
 i14 = i14 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) i3 = 0; else {
  i3 = HEAP32[i1 >> 2] | 0;
  __Z6dtFreePv(HEAP32[i1 + 48 >> 2] | 0);
  __Z6dtFreePv(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i14 >> 2] | 0);
 }
 HEAP32[i14 >> 2] = 0;
 i1 = __Z7dtAlloci(64) | 0;
 HEAP32[i14 >> 2] = i1;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = i11 + 8 | 0;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i5;
 i12 = i11 + 16 | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i12 + 4 >> 2] = i7;
 HEAP32[i11 + 24 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i11 + 36 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 40 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 44 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 >> 2] = i3;
 i12 = HEAP32[i10 + 76 >> 2] | 0;
 if (!i12) return;
 i13 = i12 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 if ((i6 | 0) <= 0) return;
 i7 = HEAP32[i12 + 4 >> 2] | 0;
 i8 = i12 + 8 | 0;
 i1 = 0;
 i5 = 0;
 while (1) {
  i2 = HEAP16[i7 + (i5 << 1) >> 1] | 0;
  if (i2 << 16 >> 16 == -1) i10 = i1; else {
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = i2 & 65535;
   while (1) {
    i1 = ((i3 + (i2 << 5) | 0) != 0 & 1) + i1 | 0;
    i2 = HEAP16[i4 + (i2 << 1) >> 1] | 0;
    if (i2 << 16 >> 16 == -1) {
     i10 = i1;
     break;
    } else i2 = i2 & 65535;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (i6 | 0)) break; else i1 = i10;
 }
 if (!i10) return;
 HEAP32[i11 + 56 >> 2] = i10;
 i11 = i10 << 2;
 i9 = __Z7dtAlloci(i11) | 0;
 HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] = i9;
 i9 = __Z7dtAlloci(i10 * 12 | 0) | 0;
 HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] = i9;
 i11 = __Z7dtAlloci(i11) | 0;
 L21 : do if ((HEAP32[i13 >> 2] | 0) > 0) {
  i8 = i12 + 8 | 0;
  i7 = HEAP32[i12 + 4 >> 2] | 0;
  i6 = 0;
  i1 = 0;
  do {
   i2 = HEAP16[i7 + (i6 << 1) >> 1] | 0;
   if (i2 << 16 >> 16 != -1) {
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i3 = i2 & 65535;
    while (1) {
     i2 = i4 + (i3 << 5) | 0;
     if (i2) {
      HEAP32[i11 + (i1 << 2) >> 2] = i3 + 1;
      i9 = (HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0) + (i1 * 3 << 2) | 0;
      HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i4 + (i3 << 5) + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i4 + (i3 << 5) + 8 >> 2];
      i1 = i1 + 1 | 0;
     }
     i2 = HEAP16[i5 + (i3 << 1) >> 1] | 0;
     if (i2 << 16 >> 16 == -1) break; else i3 = i2 & 65535;
    }
   }
   i6 = i6 + 1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } while ((i6 | 0) < (i2 | 0));
  if ((i2 | 0) > 0) {
   i9 = i12 + 8 | 0;
   i8 = HEAP32[i12 + 4 >> 2] | 0;
   if ((i10 | 0) > 0) {
    i7 = 0;
    i1 = 0;
   } else {
    i5 = 0;
    i1 = 0;
    while (1) {
     i2 = HEAP16[i8 + (i5 << 1) >> 1] | 0;
     if (i2 << 16 >> 16 != -1) {
      i3 = HEAP32[i12 >> 2] | 0;
      i4 = HEAP32[i9 >> 2] | 0;
      i2 = i2 & 65535;
      while (1) {
       if (i3 + (i2 << 5) | 0) {
        HEAP32[(HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] | 0) + (i1 << 2) >> 2] = -1;
        i1 = i1 + 1 | 0;
       }
       i2 = HEAP16[i4 + (i2 << 1) >> 1] | 0;
       if (i2 << 16 >> 16 == -1) break; else i2 = i2 & 65535;
      }
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) >= (HEAP32[i13 >> 2] | 0)) break L21;
    }
   }
   do {
    i2 = HEAP16[i8 + (i7 << 1) >> 1] | 0;
    if (i2 << 16 >> 16 != -1) {
     i6 = HEAP32[i12 >> 2] | 0;
     i5 = i2 & 65535;
     while (1) {
      if (i6 + (i5 << 5) | 0) {
       i3 = (HEAP32[(HEAP32[i14 >> 2] | 0) + 48 >> 2] | 0) + (i1 << 2) | 0;
       HEAP32[i3 >> 2] = -1;
       i4 = HEAP32[i6 + (i5 << 5) + 20 >> 2] & 1073741823;
       L54 : do if (i4 | 0) {
        i2 = 0;
        while (1) {
         if ((HEAP32[i11 + (i2 << 2) >> 2] | 0) == (i4 | 0)) break;
         i2 = i2 + 1 | 0;
         if ((i2 | 0) >= (i10 | 0)) break L54;
        }
        HEAP32[i3 >> 2] = i2;
       } while (0);
       i1 = i1 + 1 | 0;
      }
      i2 = HEAP16[(HEAP32[i9 >> 2] | 0) + (i5 << 1) >> 1] | 0;
      if (i2 << 16 >> 16 == -1) break; else i5 = i2 & 65535;
     }
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (HEAP32[i13 >> 2] | 0));
  }
 } while (0);
 __Z6dtFreePv(i11);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 60 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN9profiling14SamplerManager15RegisterSamplerEP19ProfilerInformation(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 120 | 0;
 i19 = i24 + 104 | 0;
 i15 = i24 + 68 | 0;
 i16 = i24 + 32 | 0;
 i17 = i24;
 i23 = i21 + 24 | 0;
 i3 = gb + 63648 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i23;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = HEAP32[i1 >> 2] | 0;
 i13 = _strlen(i6) | 0;
 i22 = i21 + 4 | 0;
 HEAP32[i21 >> 2] = i6;
 HEAP32[i21 + 20 >> 2] = i13;
 HEAP32[i22 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 i4 = i17 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i18 = i17 + 24 | 0;
 i7 = i18;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i17 + 4 | 0;
 HEAP8[i7 >> 0] = 0;
 i12 = (i6 | 0) == 0;
 i5 = i12 ? i21 + 4 | 0 : i6;
 i20 = i17 + 4 | 0;
 if (i12) {
  if (i13 >>> 0 > 15) {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 + 1 | 0, 16, i18, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i17 >> 2] = i2;
   HEAP32[i20 >> 2] = i13;
   i2 = (i2 | 0) == 0 ? i7 : i2;
  } else i2 = i7;
  _memcpy(i2 | 0, i5 | 0, i13 | 0) | 0;
  HEAP8[i2 + i13 >> 0] = 0;
  HEAP32[i4 >> 2] = i13;
  i3 = i18;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = HEAP32[i17 >> 2] | 0;
  i5 = (HEAP32[i20 >> 2] | 0) != 0;
 } else {
  HEAP32[i17 >> 2] = i5;
  HEAP32[i4 >> 2] = i13;
  HEAP32[i20 >> 2] = 0;
  i5 = 0;
 }
 HEAP32[i16 >> 2] = 0;
 i4 = i16 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i12 = i16 + 24 | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i3;
 i10 = i16 + 4 | 0;
 HEAP8[i10 >> 0] = 0;
 i9 = (i6 | 0) == 0;
 i6 = i9 ? i7 : i6;
 i11 = i16 + 4 | 0;
 if (i5 | i9) {
  if (i13 >>> 0 > 15) {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 + 1 | 0, 16, i12, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i16 >> 2] = i2;
   HEAP32[i11 >> 2] = i13;
   i2 = (i2 | 0) == 0 ? i10 : i2;
  } else i2 = i10;
  _memcpy(i2 | 0, i6 | 0, i13 | 0) | 0;
  HEAP8[i2 + i13 >> 0] = 0;
  HEAP32[i4 >> 2] = i13;
  i3 = i12;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = HEAP32[i16 >> 2] | 0;
  i5 = (HEAP32[i11 >> 2] | 0) != 0;
 } else {
  HEAP32[i16 >> 2] = i6;
  HEAP32[i4 >> 2] = i13;
  HEAP32[i11 >> 2] = 0;
  i5 = 0;
 }
 i7 = i16 + 32 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i15 >> 2] = 0;
 i8 = i15 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i15 + 24 | 0;
 i25 = i9;
 HEAP32[i25 >> 2] = i2;
 HEAP32[i25 + 4 >> 2] = i3;
 i3 = i15 + 4 | 0;
 HEAP8[i3 >> 0] = 0;
 i25 = (i6 | 0) == 0;
 i2 = i25 ? i10 : i6;
 i4 = i15 + 4 | 0;
 if (i5 | i25) {
  if (i13 >>> 0 > 15) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 + 1 | 0, 16, i9, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i4 >> 2] = i13;
   i1 = (i1 | 0) == 0 ? i3 : i1;
  } else i1 = i3;
  _memcpy(i1 | 0, i2 | 0, i13 | 0) | 0;
  HEAP8[i1 + i13 >> 0] = 0;
  HEAP32[i8 >> 2] = i13;
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i15 >> 2] = i2;
  HEAP32[i8 >> 2] = i13;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i15 + 32 >> 2] = i1;
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12resize_deltaEjj(i14, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E15insert_noresizeERKSA_(i19, i14, i15);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i4 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i11 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 i1 = HEAP32[i17 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i20 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i18);
 i2 = (HEAP8[i19 + 12 >> 0] | 0) != 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if ((i1 | 0) == 0 | (HEAP32[i22 >> 2] | 0) == 0) {
  STACKTOP = i24;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i23);
 STACKTOP = i24;
 return i2 | 0;
}

function __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf(i9, i2, f6) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i11 = i13;
 i1 = i9 + 132 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i12 = -1;
  STACKTOP = i13;
  return i12 | 0;
 }
 __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i10, i9);
 if ((HEAP32[i10 >> 2] & 2139095040 | 0) == 2139095040) {
  i12 = -1;
  STACKTOP = i13;
  return i12 | 0;
 }
 __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i11, i9);
 if ((HEAP32[i11 + 4 >> 2] & 2139095040 | 0) == 2139095040) {
  i12 = -1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i7 = i9 + 120 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 if ((i12 | 0) <= 0) {
  i12 = 2;
  STACKTOP = i13;
  return i12 | 0;
 }
 f14 = Math_fround(f3 - f3);
 f15 = Math_fround(f4 - f4);
 f16 = Math_fround(f5 - f5);
 L14 : do if (Math_fround(Math_fround(f16 * f16) + Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14))) <= Math_fround(9.99999996e-13)) {
  i1 = 0;
  while (1) {
   f14 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 16 >> 2]));
   f15 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 20 >> 2]));
   f16 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 24 >> 2]));
   if (!(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16)) <= Math_fround(9.99999996e-13))) break L14;
   f14 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 28 >> 2]));
   f15 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 32 >> 2]));
   f16 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 36 >> 2]));
   i1 = i1 + 1 | 0;
   if (!(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)) + Math_fround(f16 * f16)) <= Math_fround(9.99999996e-13))) break L14;
   if ((i1 | 0) >= (i12 | 0)) {
    i1 = 2;
    break;
   }
   f16 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 8 >> 2]);
   f16 = Math_fround(f3 - f16);
   f15 = Math_fround(f4 - f15);
   f14 = Math_fround(f5 - Math_fround(HEAPF32[i8 + (i1 * 40 | 0) + 12 >> 2]));
   if (!(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16))) <= Math_fround(9.99999996e-13))) break L14;
  }
  STACKTOP = i13;
  return i1 | 0;
 } while (0);
 if (i2) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 f3 = Math_fround(Math_fround(1.0) / f6);
 L25 : do if (((HEAP32[i8 + 16 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i8 + 20 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i8 + 24 >> 2] & 2139095040 | 0) != 2139095040) if (((HEAP32[i8 + 28 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i8 + 32 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i8 + 36 >> 2] & 2139095040 | 0) != 2139095040) {
  __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i10, i9);
  f16 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i11, i9);
  if (!(Math_fround((i12 * 60 | 0) >>> 0) < Math_fround(Math_fround(Math_fround(f16 - Math_fround(HEAPF32[i11 >> 2])) / f3) * Math_fround(12.0)))) {
   if ((i12 | 0) > 1) {
    i2 = HEAP32[i7 >> 2] | 0;
    i1 = 1;
    do {
     if (!(((HEAP32[i2 + (i1 * 40 | 0) + 16 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + (i1 * 40 | 0) + 20 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + (i1 * 40 | 0) + 24 >> 2] & 2139095040 | 0) != 2139095040)) break L25;
     if (!(((HEAP32[i2 + (i1 * 40 | 0) + 28 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + (i1 * 40 | 0) + 32 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + (i1 * 40 | 0) + 36 >> 2] & 2139095040 | 0) != 2139095040)) break L25;
     f16 = Math_fround(HEAPF32[i2 + (i1 * 40 | 0) >> 2]);
     if (Math_fround(Math_fround(Math_abs(Math_fround(f16 - Math_fround(HEAPF32[i2 + ((i1 + -1 | 0) * 40 | 0) >> 2])))) - f3) < Math_fround(-.000500000024)) break L25;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i12 | 0));
   }
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 } while (0);
 i12 = 0;
 STACKTOP = i13;
 return i12 | 0;
}

function _fma(d2, d5, d1) {
 d2 = +d2;
 d5 = +d5;
 d1 = +d1;
 var i3 = 0, i4 = 0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16 + 16 | 0;
 i4 = i16 + 12 | 0;
 i7 = i16 + 8 | 0;
 i12 = i16;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i14 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
 L1 : do if (i14 >>> 0 < 2146435072 | (i14 | 0) == 2146435072 & 0 < 0) {
  HEAPF64[tempDoublePtr >> 3] = d5;
  i14 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
  if (i14 >>> 0 < 2146435072 | (i14 | 0) == 2146435072 & 0 < 0) {
   HEAPF64[tempDoublePtr >> 3] = d1;
   i8 = HEAP32[tempDoublePtr >> 2] | 0;
   i9 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
   i14 = i9 & 2146435072;
   if (i14 >>> 0 < 2146435072 | (i14 | 0) == 2146435072 & 0 < 0) {
    if (d2 == 0.0 | d5 == 0.0) {
     d1 = d2 * d5 + d1;
     break;
    }
    if (d1 == 0.0) {
     d1 = d2 * d5;
     break;
    }
    d10 = +_frexp(d2, i3);
    d11 = +_frexp(d5, i4);
    d6 = +_frexp(d1, i7);
    i13 = _fegetround() | 0;
    i14 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
    i3 = i14 - (HEAP32[i7 >> 2] | 0) | 0;
    if ((i3 | 0) < -53) {
     _i64Add(i8 | 0, i9 | 0, 0, 1048576) | 0;
     0 == 0 & ((getTempRet0() | 0) & 2145386496 | 0) == 0;
     switch (i13 | 0) {
     case 3072:
      {
       if (d2 > 0.0 ^ d5 < 0.0 ^ d1 < 0.0) break L1;
       d1 = +_nextafter(d1, 0.0);
       break L1;
      }
     case 1024:
      {
       if (d2 > 0.0 ^ d5 < 0.0) break L1;
       d1 = +_nextafter(d1, -inf);
       break L1;
      }
     case 2048:
      {
       if (!(d2 > 0.0 ^ d5 < 0.0)) break L1;
       d1 = +_nextafter(d1, inf);
       break L1;
      }
     default:
      break L1;
     }
    }
    if ((i3 | 0) < 107) d2 = +_scalbn(d6, 0 - i3 | 0); else d2 = +_copysign(2.2250738585072014e-308, d6);
    _fesetround(0) | 0;
    d1 = d10 * 134217729.0;
    d1 = d1 + (d10 - d1);
    d17 = d10 - d1;
    d10 = d11 * 134217729.0;
    d10 = d10 + (d11 - d10);
    d6 = d11 - d10;
    d5 = d1 * d10;
    d10 = d17 * d10 + d1 * d6;
    d1 = d5 + d10;
    d5 = d17 * d6 + (d10 + (d5 - d1));
    d10 = d1 + d2;
    d6 = d10 - d1;
    d6 = d2 - d6 + (d1 - (d10 - d6));
    if (d10 == 0.0) {
     _fesetround(i13) | 0;
     HEAPF64[i12 >> 3] = d2;
     d1 = d1 + +HEAPF64[i12 >> 3];
     d1 = d1 + +_scalbn(d5, i14);
     break;
    }
    if (i13 | 0) {
     i3 = _fetestexcept(32) | 0;
     _fesetround(i13) | 0;
     d1 = +_scalbn(d10 + (d5 + d6), i14);
     if ((_ilogb(d1) | 0) < -1022) if (_fetestexcept(32) | 0) break;
     if (!i3) break;
     break;
    }
    d2 = d5 + d6;
    d1 = d2 - d6;
    d1 = d5 - d1 + (d6 - (d2 - d1));
    if (d1 != 0.0) {
     HEAPF64[tempDoublePtr >> 3] = d2;
     i3 = HEAP32[tempDoublePtr >> 2] | 0;
     i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
     if ((i3 & 1 | 0) == 0 & 0 == 0) {
      HEAPF64[tempDoublePtr >> 3] = d1;
      i13 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] ^ i3 | 0, HEAP32[tempDoublePtr + 4 >> 2] ^ i4 | 0, 62) | 0;
      i12 = getTempRet0() | 0;
      i9 = _i64Add(i3 | 0, i4 | 0, 1, 0) | 0;
      i12 = _i64Subtract(i9 | 0, getTempRet0() | 0, i13 | 0, i12 | 0) | 0;
      i13 = getTempRet0() | 0;
      HEAP32[tempDoublePtr >> 2] = i12;
      HEAP32[tempDoublePtr + 4 >> 2] = i13;
      d2 = +HEAPF64[tempDoublePtr >> 3];
     }
    }
    d1 = d10 + d2;
    if (((_ilogb(d10) | 0) + i14 | 0) > -1023) {
     d1 = +_scalbn(d1, i14);
     break;
    }
    d17 = d1 - d10;
    d2 = d2 - d17 + (d10 - (d1 - d17));
    if (d2 != 0.0) {
     HEAPF64[tempDoublePtr >> 3] = d1;
     i3 = HEAP32[tempDoublePtr >> 2] | 0;
     i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
     i13 = _bitshift64Lshr(i3 | 0, i4 | 0, 52) | 0;
     getTempRet0() | 0;
     if (((i3 & 1 | 0) != 0 | 0 != 0) ^ (i14 | 0) != (0 - (i13 & 2047) | 0)) {
      HEAPF64[tempDoublePtr >> 3] = d2;
      i12 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] ^ i3 | 0, HEAP32[tempDoublePtr + 4 >> 2] ^ i4 | 0, 62) | 0;
      getTempRet0() | 0;
      i13 = _i64Add(i3 | 0, i4 | 0, 1, 0) | 0;
      i12 = _i64Subtract(i13 | 0, getTempRet0() | 0, i12 & 2 | 0, 0) | 0;
      i13 = getTempRet0() | 0;
      HEAP32[tempDoublePtr >> 2] = i12;
      HEAP32[tempDoublePtr + 4 >> 2] = i13;
      d1 = +HEAPF64[tempDoublePtr >> 3];
     }
    }
    d1 = +_scalbn(d1, i14);
   }
  } else i15 = 3;
 } else i15 = 3; while (0);
 if ((i15 | 0) == 3) d1 = d2 * d5 + d1;
 STACKTOP = i16;
 return +d1;
}

function __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignINS_21__tree_const_iteratorIiPNS_11__tree_nodeIiPvEEiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i2 = i11;
 i7 = i10;
 do if ((i10 | 0) == (i11 | 0)) {
  i8 = 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i7 = i9 + 4 | 0;
 } else {
  i8 = 0;
  i3 = i10;
  while (1) {
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break; else i3 = i1;
   } else while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
   if ((i1 | 0) == (i11 | 0)) break; else i3 = i1;
  }
  i6 = i9 + 8 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i3 = i5;
  if (i8 >>> 0 > i1 - i5 >> 2 >>> 0) {
   i4 = i5;
   if (i5) {
    i1 = i9 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i5 | 0) >>> 2) << 2);
    __ZdlPv(i4);
    HEAP32[i6 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = 0;
   }
   if (i8 >>> 0 > 1073741823) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   } else i2 = 0;
   i7 = i1 - i2 | 0;
   i1 = i7 >> 1;
   i1 = i7 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 1073741823;
   if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i4 = __Znwj(i1 << 2) | 0;
   i5 = i9 + 4 | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i6 >> 2] = i4 + (i1 << 2);
   i3 = i10;
   i2 = i10;
   while (1) {
    HEAP32[i4 >> 2] = HEAP32[i3 + 16 >> 2];
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    i4 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = i4;
    if ((i1 | 0) == (i11 | 0)) break; else {
     i3 = i1;
     i2 = i1;
    }
   }
   return;
  }
  i6 = i9 + 4 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i5 | 0;
  i4 = i1 >> 2;
  if (i8 >>> 0 > i4 >>> 0) {
   if ((i1 | 0) <= -4) {
    i1 = i10;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i2; else break;
     } else while (1) {
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) break; else i2 = i1;
     }
     if ((i4 | 0) < -1) {
      i1 = i2;
      i4 = i4 + 1 | 0;
     } else break;
    }
    i8 = 1;
    i7 = i6;
    break;
   }
   if (!i4) {
    i8 = 1;
    i2 = i7;
    i7 = i6;
   } else {
    i1 = i10;
    while (1) {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else while (1) {
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break; else i2 = i1;
     }
     if ((i4 | 0) > 1) {
      i4 = i4 + -1 | 0;
      i1 = i2;
     } else break;
    }
    i8 = 1;
    i7 = i6;
   }
  } else {
   i8 = 0;
   i7 = i6;
  }
 } while (0);
 i6 = i2;
 if ((i10 | 0) != (i6 | 0)) {
  i5 = i10;
  i4 = i10;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i5 + 16 >> 2];
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break; else i4 = i1;
   } else while (1) {
    i4 = HEAP32[i1 >> 2] | 0;
    if (!i4) break; else i1 = i4;
   }
   i3 = i3 + 4 | 0;
   if ((i1 | 0) == (i6 | 0)) break; else {
    i5 = i1;
    i4 = i1;
   }
  }
 }
 if (!i8) {
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i3 | 0) >>> 2) << 2);
  return;
 }
 if ((i6 | 0) == (i11 | 0)) return;
 i3 = i6;
 i4 = HEAP32[i7 >> 2] | 0;
 while (1) {
  HEAP32[i4 >> 2] = HEAP32[i3 + 16 >> 2];
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = i4 + 4 | 0;
  HEAP32[i7 >> 2] = i4;
  if ((i1 | 0) == (i11 | 0)) break; else {
   i3 = i1;
   i2 = i1;
  }
 }
 return;
}

function __ZN10GUIManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 636 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 640 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 616 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 620 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 596 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 600 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 576 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 580 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 556 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 560 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 536 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 540 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 516 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 520 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 496 >> 2] | 0;
 if (i1 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 500 >> 2] | 0;
 if (!i1) {
  i1 = i2 + 436 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 384 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 332 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 280 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 228 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 176 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 124 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 72 | 0;
  __ZN10InputEventD2Ev(i1);
  i1 = i2 + 28 | 0;
  __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv(i1);
  i1 = i2 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 i1 = i2 + 436 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 384 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 332 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 280 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 228 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 176 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 124 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 72 | 0;
 __ZN10InputEventD2Ev(i1);
 i1 = i2 + 28 | 0;
 __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv(i1);
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i12, i10, i5, i11, i14) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i13 = i12 + 12 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 L1 : do if (i3 | 0) {
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = i4 + (i14 * 56 | 0) | 0;
  if ((i14 | 0) < 0) {
   i1 = 0;
   while (1) {
    if ((HEAP32[i4 + (i1 * 56 | 0) >> 2] | 0) == (i10 | 0)) if (!((HEAP8[i4 + (i1 * 56 | 0) + 40 >> 0] | 0) != 0 ^ i5)) if ((HEAP16[i4 + (i1 * 56 | 0) + 42 >> 1] | 0) == i11 << 16 >> 16) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i3 >>> 0) break L1;
   }
   STACKTOP = i15;
   return i1 | 0;
  } else i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 * 56 | 0) >> 2] | 0) == (i10 | 0)) if (!((HEAP8[i4 + (i1 * 56 | 0) + 40 >> 0] | 0) != 0 ^ i5)) if ((HEAP16[i4 + (i1 * 56 | 0) + 42 >> 1] | 0) == i11 << 16 >> 16) if ((HEAP32[i2 >> 2] | 0) == (i10 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L1;
  }
  STACKTOP = i15;
  return i1 | 0;
 } while (0);
 i8 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i10) | 0;
 i2 = i5 & 1;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i12 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 * 56 | 0, 8, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 56 | 0, 8, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 56 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = i4;
 i7 = HEAP32[i12 >> 2] | 0;
 HEAP32[i7 + (i3 * 56 | 0) >> 2] = i10;
 HEAP32[i7 + (i3 * 56 | 0) + 4 >> 2] = i8;
 i10 = i7 + (i3 * 56 | 0) + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP8[i7 + (i3 * 56 | 0) + 40 >> 0] = i2;
 HEAP8[i7 + (i3 * 56 | 0) + 41 >> 0] = 1;
 HEAP16[i7 + (i3 * 56 | 0) + 42 >> 1] = i11;
 HEAP32[i7 + (i3 * 56 | 0) + 44 >> 2] = 0;
 HEAP32[i7 + (i3 * 56 | 0) + 48 >> 2] = -1;
 do if ((i14 | 0) > -1) {
  i4 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i5 = i1 + -1 | 0;
  i2 = i4 + (i14 * 56 | 0) + 24 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i11 = i4 + (i5 * 56 | 0) + 24 | 0;
  if ((i3 | 0) == (HEAP32[i11 >> 2] | 0) ? (i2 | 0) == (HEAP32[i11 + 4 >> 2] | 0) : 0) {
   i10 = i4 + (i14 * 56 | 0) + 32 | 0;
   i11 = i4 + (i5 * 56 | 0) + 32 | 0;
   if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i11 >> 2] | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (HEAP32[i11 + 4 >> 2] | 0) : 0) break;
  }
  if (HEAP32[i4 + (i14 * 56 | 0) + 44 >> 2] | 0) {
   i2 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63720 | 0, 16, gb + 588245 | 0, 93) | 0;
   __ZN8TypeTreeC2ERK10MemLabelId(i2, gb + 63720 | 0);
   __ZN8TypeTreeaSERKS_(i2, HEAP32[(HEAP32[i12 >> 2] | 0) + (i14 * 56 | 0) + 44 >> 2] | 0) | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP32[i4 + ((i1 + -1 | 0) * 56 | 0) + 44 >> 2] = i2;
   i2 = i4 + (i14 * 56 | 0) + 24 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
  i11 = i1 + -1 | 0;
  i12 = i4 + (i11 * 56 | 0) + 24 | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i2;
  i12 = i4 + (i14 * 56 | 0) + 32 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i4 + (i11 * 56 | 0) + 32 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
 } else i1 = HEAP32[i13 >> 2] | 0; while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(0, gb + 63720 | 0);
 i14 = i1 + -1 | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i18, i1, i13) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i17 = i20 + 16 | 0;
 i14 = i20 + 12 | 0;
 i15 = i20 + 8 | 0;
 i8 = i20 + 4 | 0;
 i9 = i20;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i16 = i10 - i7 >> 4;
 i6 = i18 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i7;
 i4 = i2;
 if (i16 >>> 0 > i1 - i2 >> 4 >>> 0) {
  if (i2) {
   i5 = i18 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i19 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i15 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i19 >> 2] = 66;
      HEAP32[i3 >> 2] = i15;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i18 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i18 >> 2] = 0;
   i1 = 0;
  }
  if (i16 >>> 0 > 268435455) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i18 >> 2] | 0;
  } else i2 = 0;
  i15 = i1 - i2 | 0;
  i1 = i15 >> 3;
  i1 = i15 >> 4 >>> 0 < 134217727 ? (i1 >>> 0 < i16 >>> 0 ? i16 : i1) : 268435455;
  if (i1 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i18);
  i15 = __Znwj(i1 << 4) | 0;
  HEAP32[i18 + 4 >> 2] = i15;
  HEAP32[i18 >> 2] = i15;
  HEAP32[i6 >> 2] = i15 + (i1 << 4);
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i9 >> 2];
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i12 = i18 + 4 | 0;
 i9 = (HEAP32[i12 >> 2] | 0) - i2 >> 4;
 i11 = i16 >>> 0 > i9 >>> 0;
 i10 = i11 ? i3 + (i9 << 4) | 0 : i10;
 i9 = i10;
 if ((i3 | 0) != (i9 | 0)) {
  i1 = i4;
  i8 = i3;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = i8 + 16 | 0;
   i1 = i1 + 16 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i11) {
  HEAP32[i14 >> 2] = i10;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  i16 = i16 - ((HEAP32[i12 >> 2] | 0) - (HEAP32[i18 >> 2] | 0) >> 4) | 0;
  HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i18, i17, i19, i16);
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i20;
  return;
 }
 i3 = i19 + 4 | 0;
 do {
  i2 = i1 + -16 | 0;
  HEAP32[i12 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i18 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i19 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i19);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i20;
 return;
}

function __ZN7Terrain33ApplyDelayedHeightmapModificationEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 8 | 0;
 i6 = i13;
 i12 = i13 + 16 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i3 = i5;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = i9 + 48 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 8;
  }
 }
 if ((i8 | 0) == 6) i8 = 8;
 if ((i8 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 __ZN9Heightmap23RecomputeInvalidPatchesER13dynamic_arrayIiLj4EE(i1 + 248 | 0, i12);
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i14 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 17;
   }
  }
  if ((i8 | 0) == 15) i8 = 17;
  if ((i8 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  __ZN12TreeDatabase24RecalculateTreePositionsEv(i1 + 84 | 0);
  i3 = i9 + 228 | 0;
  i2 = i9 + 240 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   do {
    i8 = i1 + 4 | 0;
    __ZN15TerrainRenderer22ReloadPrecomputedErrorEv(HEAP32[i8 >> 2] | 0);
    __ZN15TerrainRenderer12ReloadBoundsEv(HEAP32[i8 >> 2] | 0);
    i8 = HEAP32[i1 + 12 >> 2] | 0;
    i9 = i8 + 64 | 0;
    i14 = i8 + 68 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i9, HEAP32[i14 >> 2] | 0);
    HEAP32[i8 + 72 >> 2] = 0;
    HEAP32[i9 >> 2] = i14;
    HEAP32[i14 >> 2] = 0;
    i14 = i8 + 76 | 0;
    i9 = i8 + 80 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i14, HEAP32[i9 >> 2] | 0);
    HEAP32[i8 + 84 >> 2] = 0;
    HEAP32[i14 >> 2] = i9;
    HEAP32[i9 >> 2] = 0;
    i9 = i8 + 88 | 0;
    i14 = i8 + 92 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i9, HEAP32[i14 >> 2] | 0);
    HEAP32[i8 + 96 >> 2] = 0;
    HEAP32[i9 >> 2] = i14;
    HEAP32[i14 >> 2] = 0;
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8internal9partitionINS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEiPT_iiRT0_(i6, i1, i2, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 20 | 0;
 i8 = i9;
 __ZN5physx6shdfnd8internal7median3INS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEvPT_iiRT0_(i6, i1, i2, i5);
 i4 = i2 + -1 | 0;
 i3 = i6 + (i4 * 40 | 0) | 0;
 i2 = i4;
 while (1) {
  do i1 = i1 + 1 | 0; while (mftCall_iii(HEAP32[i5 >> 2] | 0, i6 + (i1 * 40 | 0) | 0, i3 | 0) | 0);
  do i2 = i2 + -1 | 0; while (mftCall_iii(HEAP32[i5 >> 2] | 0, i3 | 0, i6 + (i2 * 40 | 0) | 0) | 0);
  if ((i1 | 0) >= (i2 | 0)) break;
  i12 = i6 + (i1 * 40 | 0) + 4 | 0;
  i16 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
  i15 = i6 + (i1 * 40 | 0) + 8 | 0;
  i15 = HEAPU16[i15 >> 1] | HEAPU16[i15 + 2 >> 1] << 16;
  i11 = i6 + (i1 * 40 | 0) + 12 | 0;
  i10 = i6 + (i1 * 40 | 0) + 16 | 0;
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  i13 = HEAP32[i11 >> 2] | 0;
  i17 = i6 + (i1 * 40 | 0) + 20 | 0;
  HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  i14 = i6 + (i2 * 40 | 0) + 4 | 0;
  i18 = i14;
  i20 = i18;
  i20 = HEAPU16[i20 >> 1] | HEAPU16[i20 + 2 >> 1] << 16;
  i18 = i18 + 4 | 0;
  i18 = HEAPU16[i18 >> 1] | HEAPU16[i18 + 2 >> 1] << 16;
  i19 = i12;
  HEAP16[i19 >> 1] = i20;
  HEAP16[i19 + 2 >> 1] = i20 >>> 16;
  i12 = i12 + 4 | 0;
  HEAP16[i12 >> 1] = i18;
  HEAP16[i12 + 2 >> 1] = i18 >>> 16;
  i12 = i6 + (i2 * 40 | 0) + 12 | 0;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  i11 = i6 + (i2 * 40 | 0) + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i6 + (i2 * 40 | 0) + 20 | 0;
  HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP16[i14 >> 1] = i16;
  HEAP16[i14 + 2 >> 1] = i16 >>> 16;
  i14 = i6 + (i2 * 40 | 0) + 8 | 0;
  HEAP16[i14 >> 1] = i15;
  HEAP16[i14 + 2 >> 1] = i15 >>> 16;
  HEAP32[i12 >> 2] = i13;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 }
 i18 = i6 + (i1 * 40 | 0) + 4 | 0;
 i14 = HEAPU16[i18 >> 1] | HEAPU16[i18 + 2 >> 1] << 16;
 i15 = i6 + (i1 * 40 | 0) + 8 | 0;
 i15 = HEAPU16[i15 >> 1] | HEAPU16[i15 + 2 >> 1] << 16;
 i19 = i6 + (i1 * 40 | 0) + 12 | 0;
 i20 = i6 + (i1 * 40 | 0) + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
 i17 = HEAP32[i19 >> 2] | 0;
 i13 = i6 + (i1 * 40 | 0) + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 i16 = i6 + (i4 * 40 | 0) + 4 | 0;
 i12 = i16;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i11 = i18;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i18 = i18 + 4 | 0;
 HEAP16[i18 >> 1] = i12;
 HEAP16[i18 + 2 >> 1] = i12 >>> 16;
 i18 = i6 + (i4 * 40 | 0) + 12 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 i19 = i6 + (i4 * 40 | 0) + 16 | 0;
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 i20 = i6 + (i4 * 40 | 0) + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
 HEAP16[i16 >> 1] = i14;
 HEAP16[i16 + 2 >> 1] = i14 >>> 16;
 i16 = i6 + (i4 * 40 | 0) + 8 | 0;
 HEAP16[i16 >> 1] = i15;
 HEAP16[i16 + 2 >> 1] = i15 >>> 16;
 HEAP32[i18 >> 2] = i17;
 HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 STACKTOP = i9;
 return i1 | 0;
}

function __Z28CullDirectionalShadowCastersiRK22SceneCullingParametersR11CullResults(i18, i2, i19) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 8 | 0;
 i1 = i20;
 if (!i18) {
  STACKTOP = i20;
  return;
 }
 if (!(HEAP32[i2 + 820 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 if ((HEAP16[gb + 1112936 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112936 | 0, i17);
  i10 = gb + 1112936 | 0;
 } else i10 = 0;
 i11 = i19 + 1312 | 0;
 i12 = i19 + 76 | 0;
 if (HEAP8[i12 >> 0] | 0) __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i11, fb + 3336 | 0, i19, i19 + 8 | 0, 1);
 if ((i18 | 0) > 0) {
  i13 = i19 + 360 | 0;
  i14 = i19 + 312 | 0;
  i15 = i19 + 1308 | 0;
  i16 = i17 + 4 | 0;
  i7 = i2 + 192 | 0;
  i6 = 0;
  do {
   i8 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i8 + (i6 * 960 | 0) >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i9 = i8 + (i6 * 960 | 0) + 80 | 0;
   i4 = HEAP32[(HEAP32[i15 >> 2] | 0) + 952 >> 2] | 0;
   _memcpy(i9 | 0, i4 | 0, 340) | 0;
   i1 = 0;
   do {
    i22 = HEAP32[i4 + 352 + (i1 << 4) + 4 >> 2] | 0;
    i21 = HEAP32[i4 + 352 + (i1 << 4) + 8 >> 2] | 0;
    i5 = HEAP32[i4 + 352 + (i1 << 4) + 12 >> 2] | 0;
    HEAP32[i8 + (i6 * 960 | 0) + 432 + (i1 << 4) >> 2] = HEAP32[i4 + 352 + (i1 << 4) >> 2];
    HEAP32[i8 + (i6 * 960 | 0) + 432 + (i1 << 4) + 4 >> 2] = i22;
    HEAP32[i8 + (i6 * 960 | 0) + 432 + (i1 << 4) + 8 >> 2] = i21;
    HEAP32[i8 + (i6 * 960 | 0) + 432 + (i1 << 4) + 12 >> 2] = i5;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 12);
   i5 = i3 + (i2 * 180 | 0) | 0;
   _memcpy(i8 + (i6 * 960 | 0) + 624 | 0, i4 + 544 | 0, 208) | 0;
   i3 = i8 + (i6 * 960 | 0) + 832 | 0;
   i1 = i4 + 752 | 0;
   i2 = i3 + 108 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   __Z34PrepareParametersCullShadowCastersRK11ActiveLightRK14ShadowCullDataR22SceneCullingParametersR13ShadowedLight(i5, HEAP32[i15 >> 2] | 0, i9, (HEAP32[i13 >> 2] | 0) + (i6 * 960 | 0) | 0);
   if (((HEAP32[i8 + (i6 * 960 | 0) + 852 >> 2] | 0) != 0 & 1) + ((HEAP32[i8 + (i6 * 960 | 0) + 840 >> 2] | 0) != 0 & 1) + ((HEAP32[i8 + (i6 * 960 | 0) + 864 >> 2] | 0) != 0 & 1) + ((HEAP32[i8 + (i6 * 960 | 0) + 876 >> 2] | 0) != 0 & 1) + ((HEAP32[i8 + (i6 * 960 | 0) + 888 >> 2] | 0) != 0 & 1) | 0) {
    HEAP32[i17 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    if (!(HEAP8[i12 >> 0] | 0)) i2 = 0; else {
     i2 = __Z9GetIUmbrav() | 0;
     i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
     HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 * 960 | 0) + 944 >> 2] = i2;
     i22 = __ZnwjRK10MemLabelIdiPKci(12, gb + 64024 | 0, 16, gb + 384212 | 0, 714) | 0;
     HEAP32[i22 >> 2] = i19;
     HEAP32[i22 + 4 >> 2] = i9;
     HEAP32[i22 + 8 >> 2] = i2;
     __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i17, fb + 3337 | 0, i22, i11, 1);
    }
    i3 = (HEAP32[i13 >> 2] | 0) + (i6 * 960 | 0) + 72 | 0;
    i1 = 0;
    do {
     i4 = i8 + (i6 * 960 | 0) + 832 + (i1 * 12 | 0) + 8 | 0;
     if (HEAP32[i4 >> 2] | 0) {
      i21 = __ZnwjRK10MemLabelIdiPKci(224, gb + 64024 | 0, 16, gb + 384212 | 0, 732) | 0;
      HEAP32[i21 >> 2] = i9;
      HEAP32[i21 + 8 >> 2] = i2;
      HEAP32[i21 + 4 >> 2] = HEAP32[i15 >> 2];
      i22 = HEAP32[i5 >> 2] | 0;
      HEAP32[i21 + 12 >> 2] = i22;
      HEAP32[i21 + 16 >> 2] = HEAP32[i7 >> 2] & HEAP32[i22 + 36 >> 2];
      HEAP32[i21 + 20 >> 2] = i1;
      HEAP32[i21 + 24 >> 2] = (HEAP32[i13 >> 2] | 0) + (i6 * 960 | 0) + 4 + (i1 * 12 | 0);
      i22 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i21 + 28 | 0, HEAP32[i4 >> 2] | 0, 4096) | 0;
      HEAP32[i21 + 220 >> 2] = i22;
      __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i3, fb + 2387 | 0, i21, i22, i17, fb + 3338 | 0, 0);
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 5);
    __Z21ClearFenceWithoutSyncR8JobFence(i17);
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i18 | 0));
 }
 __Z21ClearFenceWithoutSyncR8JobFence(i11);
 if (!i10) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i20;
 return;
}

function __Z22sweepCCTBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i3, i1, i2, i23, f14, i22, i19, f5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 f14 = Math_fround(f14);
 i22 = i22 | 0;
 i19 = i19 | 0;
 f5 = Math_fround(f5);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 48 | 0;
 i27 = i24 + 36 | 0;
 i26 = i24 + 24 | 0;
 i25 = i24 + 108 | 0;
 i20 = i24 + 12 | 0;
 i18 = i24;
 i16 = i2 + 36 | 0;
 f28 = Math_fround(HEAPF32[i16 >> 2]);
 f28 = Math_fround(f28 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 i17 = i2 + 40 | 0;
 f29 = Math_fround(HEAPF32[i17 >> 2]);
 f29 = Math_fround(f29 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 i15 = i2 + 44 | 0;
 f30 = Math_fround(HEAPF32[i15 >> 2]);
 f30 = Math_fround(f30 - Math_fround(HEAPF32[i1 + 24 >> 2]));
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 i6 = i21 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
 i7 = i21 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i21 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i8 = i21 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 + 16 >> 2];
 i9 = i21 + 20 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i21 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 i10 = i21 + 28 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 + 28 >> 2];
 i11 = i21 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 + 32 >> 2];
 i12 = i21 + 36 | 0;
 HEAPF32[i12 >> 2] = f28;
 HEAPF32[i21 + 40 >> 2] = f29;
 HEAPF32[i21 + 44 >> 2] = f30;
 i13 = i21 + 48 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i21 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i21 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) + f5);
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i27 + 8 >> 2] = Math_fround(0.0);
 f30 = Math_fround(-Math_fround(HEAPF32[i23 >> 2]));
 i2 = i23 + 4 | 0;
 f29 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 i3 = i23 + 8 | 0;
 f28 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i26 >> 2] = f30;
 HEAPF32[i26 + 4 >> 2] = f29;
 HEAPF32[i26 + 8 >> 2] = f28;
 i4 = i22 + 40 | 0;
 HEAP16[i25 >> 1] = HEAP16[i19 >> 1] | 0;
 if (!(__ZN5physx2Gu14sweepBoxSphereERKNS0_3BoxEfRKNS_6PxVec3ES6_fRfRS4_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i21, f5, i27, i26, f14, i4, i22 + 28 | 0, i25) | 0)) {
  i27 = 0;
  STACKTOP = i24;
  return i27 | 0;
 }
 i1 = i22 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 if (!(HEAP16[i19 >> 1] & 1)) {
  i27 = 1;
  STACKTOP = i24;
  return i27 | 0;
 }
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(HEAPF32[i23 >> 2]);
 f31 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(f5 * f14);
 f31 = Math_fround(f5 * f31);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f29 = Math_fround(-f31);
 f30 = Math_fround(-f5);
 HEAPF32[i20 >> 2] = Math_fround(-f14);
 HEAPF32[i20 + 4 >> 2] = f29;
 HEAPF32[i20 + 8 >> 2] = f30;
 Math_fround(__ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i20, i12, i13, i21, i18));
 f30 = Math_fround(HEAPF32[i18 >> 2]);
 f29 = Math_fround(f30 * Math_fround(HEAPF32[i21 >> 2]));
 f28 = Math_fround(f30 * Math_fround(HEAPF32[i6 >> 2]));
 f30 = Math_fround(f30 * Math_fround(HEAPF32[i7 >> 2]));
 f32 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f34 = Math_fround(f32 * Math_fround(HEAPF32[i21 + 12 >> 2]));
 f33 = Math_fround(f32 * Math_fround(HEAPF32[i8 >> 2]));
 f34 = Math_fround(f29 + f34);
 f33 = Math_fround(f28 + f33);
 f32 = Math_fround(f30 + Math_fround(f32 * Math_fround(HEAPF32[i9 >> 2])));
 f30 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f28 = Math_fround(f30 * Math_fround(HEAPF32[i21 + 24 >> 2]));
 f29 = Math_fround(f30 * Math_fround(HEAPF32[i10 >> 2]));
 f28 = Math_fround(f34 + f28);
 f29 = Math_fround(f33 + f29);
 f30 = Math_fround(f32 + Math_fround(f30 * Math_fround(HEAPF32[i11 >> 2])));
 f28 = Math_fround(f28 + Math_fround(HEAPF32[i16 >> 2]));
 f29 = Math_fround(f29 + Math_fround(HEAPF32[i17 >> 2]));
 f29 = Math_fround(f31 + f29);
 f30 = Math_fround(f5 + Math_fround(f30 + Math_fround(HEAPF32[i15 >> 2])));
 HEAPF32[i22 + 16 >> 2] = Math_fround(f14 + f28);
 HEAPF32[i22 + 20 >> 2] = f29;
 HEAPF32[i22 + 24 >> 2] = f30;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 1;
 i27 = 1;
 STACKTOP = i24;
 return i27 | 0;
}

function runPostSets52() {
 HEAP32[gb + 64436 >> 2] = fb + 34;
 HEAP32[gb + 64440 >> 2] = fb + 531;
 HEAP32[gb + 64444 >> 2] = fb + 532;
 HEAP32[gb + 64448 >> 2] = fb + 533;
 HEAP32[gb + 64452 >> 2] = fb + 534;
 HEAP32[gb + 64456 >> 2] = fb + 535;
 HEAP32[gb + 64460 >> 2] = fb + 536;
 HEAP32[gb + 64464 >> 2] = fb + 36;
 HEAP32[gb + 64468 >> 2] = fb + 96;
 HEAP32[gb + 64472 >> 2] = fb + 81;
 HEAP32[gb + 64476 >> 2] = fb + 82;
 HEAP32[gb + 64480 >> 2] = (HEAP32[gb + 64480 >> 2] | 0) + (gb + 450669 | 0);
 HEAP32[gb + 64492 >> 2] = fb + 668;
 HEAP32[gb + 64496 >> 2] = fb + 669;
 HEAP32[gb + 64500 >> 2] = fb + 80;
 HEAP32[gb + 64504 >> 2] = fb + 39;
 HEAP32[gb + 64508 >> 2] = fb + 16;
 HEAP32[gb + 64512 >> 2] = fb + 39;
 HEAP32[gb + 64516 >> 2] = fb + 40;
 HEAP32[gb + 64520 >> 2] = fb + 19;
 HEAP32[gb + 64524 >> 2] = fb + 291;
 HEAP32[gb + 64528 >> 2] = fb + 99;
 HEAP32[gb + 64532 >> 2] = fb + 40;
 HEAP32[gb + 64536 >> 2] = fb + 292;
 HEAP32[gb + 64540 >> 2] = fb + 28;
 HEAP32[gb + 64544 >> 2] = fb + 63;
 HEAP32[gb + 64548 >> 2] = fb + 29;
 HEAP32[gb + 64552 >> 2] = fb + 34;
 HEAP32[gb + 64556 >> 2] = fb + 537;
 HEAP32[gb + 64560 >> 2] = fb + 538;
 HEAP32[gb + 64564 >> 2] = fb + 539;
 HEAP32[gb + 64568 >> 2] = fb + 540;
 HEAP32[gb + 64572 >> 2] = fb + 541;
 HEAP32[gb + 64576 >> 2] = fb + 542;
 HEAP32[gb + 64580 >> 2] = fb + 36;
 HEAP32[gb + 64584 >> 2] = fb + 96;
 HEAP32[gb + 64588 >> 2] = fb + 81;
 HEAP32[gb + 64592 >> 2] = fb + 82;
 HEAP32[gb + 64604 >> 2] = fb + 670;
 HEAP32[gb + 64608 >> 2] = fb + 671;
 HEAP32[gb + 64612 >> 2] = fb + 80;
 HEAP32[gb + 64616 >> 2] = fb + 543;
 HEAP32[gb + 64620 >> 2] = fb + 16;
 HEAP32[gb + 64624 >> 2] = fb + 39;
 HEAP32[gb + 64628 >> 2] = fb + 40;
 HEAP32[gb + 64632 >> 2] = fb + 19;
 HEAP32[gb + 64636 >> 2] = fb + 293;
 HEAP32[gb + 64640 >> 2] = fb + 99;
 HEAP32[gb + 64644 >> 2] = fb + 40;
 HEAP32[gb + 64648 >> 2] = fb + 62;
 HEAP32[gb + 64652 >> 2] = fb + 28;
 HEAP32[gb + 64656 >> 2] = fb + 63;
 HEAP32[gb + 64660 >> 2] = fb + 29;
 HEAP32[gb + 64664 >> 2] = fb + 34;
 HEAP32[gb + 64668 >> 2] = fb + 544;
 HEAP32[gb + 64672 >> 2] = fb + 545;
 HEAP32[gb + 64676 >> 2] = fb + 546;
 HEAP32[gb + 64680 >> 2] = fb + 547;
 HEAP32[gb + 64684 >> 2] = fb + 548;
 HEAP32[gb + 64688 >> 2] = fb + 549;
 HEAP32[gb + 64692 >> 2] = fb + 36;
 HEAP32[gb + 64696 >> 2] = fb + 96;
 HEAP32[gb + 64700 >> 2] = fb + 81;
 HEAP32[gb + 64704 >> 2] = fb + 82;
 HEAP32[gb + 64708 >> 2] = fb + 672;
 HEAP32[gb + 64720 >> 2] = fb + 44;
 HEAP32[gb + 64724 >> 2] = fb + 673;
 HEAP32[gb + 64728 >> 2] = fb + 674;
 HEAP32[gb + 64740 >> 2] = fb + 8;
 HEAP32[gb + 64744 >> 2] = fb + 8;
 HEAP32[gb + 64748 >> 2] = fb + 42;
 HEAP32[gb + 64752 >> 2] = fb + 79;
 HEAP32[gb + 64756 >> 2] = fb + 26;
 HEAP32[gb + 64760 >> 2] = fb + 27;
 HEAP32[gb + 64764 >> 2] = fb + 24;
 HEAP32[gb + 64768 >> 2] = fb + 9;
 HEAP32[gb + 64780 >> 2] = fb + 675;
 HEAP32[gb + 64784 >> 2] = fb + 676;
 HEAP32[gb + 64788 >> 2] = fb + 1;
 HEAP32[gb + 64792 >> 2] = fb + 80;
 HEAP32[gb + 64796 >> 2] = fb + 81;
 HEAP32[gb + 64800 >> 2] = (HEAP32[gb + 64800 >> 2] | 0) + (gb + 452265 | 0);
 HEAP32[gb + 64804 >> 2] = (HEAP32[gb + 64804 >> 2] | 0) + (gb + 452276 | 0);
 HEAP32[gb + 64808 >> 2] = (HEAP32[gb + 64808 >> 2] | 0) + (gb + 452285 | 0);
 HEAP32[gb + 64812 >> 2] = (HEAP32[gb + 64812 >> 2] | 0) + (gb + 452296 | 0);
 HEAP32[gb + 64816 >> 2] = (HEAP32[gb + 64816 >> 2] | 0) + (gb + 452307 | 0);
 HEAP32[gb + 64820 >> 2] = (HEAP32[gb + 64820 >> 2] | 0) + (gb + 452316 | 0);
 HEAP32[gb + 64824 >> 2] = (HEAP32[gb + 64824 >> 2] | 0) + (gb + 452323 | 0);
 HEAP32[gb + 64828 >> 2] = (HEAP32[gb + 64828 >> 2] | 0) + (gb + 452336 | 0);
 HEAP32[gb + 64832 >> 2] = (HEAP32[gb + 64832 >> 2] | 0) + (gb + 452345 | 0);
 HEAP32[gb + 64836 >> 2] = (HEAP32[gb + 64836 >> 2] | 0) + (gb + 452353 | 0);
 HEAP32[gb + 64840 >> 2] = (HEAP32[gb + 64840 >> 2] | 0) + (gb + 452366 | 0);
 HEAP32[gb + 64844 >> 2] = (HEAP32[gb + 64844 >> 2] | 0) + (gb + 452379 | 0);
 HEAP32[gb + 64848 >> 2] = (HEAP32[gb + 64848 >> 2] | 0) + (gb + 452387 | 0);
 HEAP32[gb + 64852 >> 2] = (HEAP32[gb + 64852 >> 2] | 0) + (gb + 452393 | 0);
 HEAP32[gb + 64856 >> 2] = (HEAP32[gb + 64856 >> 2] | 0) + (gb + 452410 | 0);
 HEAP32[gb + 64860 >> 2] = (HEAP32[gb + 64860 >> 2] | 0) + (gb + 452426 | 0);
 HEAP32[gb + 64876 >> 2] = (HEAP32[gb + 64876 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 64880 >> 2] = (HEAP32[gb + 64880 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 64908 >> 2] = (HEAP32[gb + 64908 >> 2] | 0) + (gb + 606234 | 0);
 runPostSets53();
}

function _jpeg_set_colorspace(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if ((i1 | 0) != 100) {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 20;
  HEAP32[i2 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i4 | 0);
 }
 HEAP32[i4 + 64 >> 2] = i3;
 i1 = i4 + 196 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = i4 + 204 | 0;
 HEAP8[i2 >> 0] = 0;
 switch (i3 | 0) {
 case 1:
  {
   HEAP8[i1 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 1;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 1;
   HEAP32[i4 + 12 >> 2] = 1;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   return;
  }
 case 2:
  {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 3;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 82;
   HEAP32[i4 + 8 >> 2] = 1;
   HEAP32[i4 + 12 >> 2] = 1;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 71;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 0;
   HEAP32[i4 + 104 >> 2] = 0;
   HEAP32[i4 + 108 >> 2] = 0;
   HEAP32[i4 + 168 >> 2] = 66;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 0;
   HEAP32[i4 + 188 >> 2] = 0;
   HEAP32[i4 + 192 >> 2] = 0;
   return;
  }
 case 3:
  {
   HEAP8[i1 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 3;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 2;
   HEAP32[i4 + 12 >> 2] = 2;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 2;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 1;
   HEAP32[i4 + 104 >> 2] = 1;
   HEAP32[i4 + 108 >> 2] = 1;
   HEAP32[i4 + 168 >> 2] = 3;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 1;
   HEAP32[i4 + 188 >> 2] = 1;
   HEAP32[i4 + 192 >> 2] = 1;
   return;
  }
 case 4:
  {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 4;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 67;
   HEAP32[i4 + 8 >> 2] = 1;
   HEAP32[i4 + 12 >> 2] = 1;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 77;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 0;
   HEAP32[i4 + 104 >> 2] = 0;
   HEAP32[i4 + 108 >> 2] = 0;
   HEAP32[i4 + 168 >> 2] = 89;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 0;
   HEAP32[i4 + 188 >> 2] = 0;
   HEAP32[i4 + 192 >> 2] = 0;
   HEAP32[i4 + 252 >> 2] = 75;
   HEAP32[i4 + 260 >> 2] = 1;
   HEAP32[i4 + 264 >> 2] = 1;
   HEAP32[i4 + 268 >> 2] = 0;
   HEAP32[i4 + 272 >> 2] = 0;
   HEAP32[i4 + 276 >> 2] = 0;
   return;
  }
 case 5:
  {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i4 + 60 >> 2] = 4;
   i4 = HEAP32[i4 + 68 >> 2] | 0;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i4 + 8 >> 2] = 2;
   HEAP32[i4 + 12 >> 2] = 2;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 84 >> 2] = 2;
   HEAP32[i4 + 92 >> 2] = 1;
   HEAP32[i4 + 96 >> 2] = 1;
   HEAP32[i4 + 100 >> 2] = 1;
   HEAP32[i4 + 104 >> 2] = 1;
   HEAP32[i4 + 108 >> 2] = 1;
   HEAP32[i4 + 168 >> 2] = 3;
   HEAP32[i4 + 176 >> 2] = 1;
   HEAP32[i4 + 180 >> 2] = 1;
   HEAP32[i4 + 184 >> 2] = 1;
   HEAP32[i4 + 188 >> 2] = 1;
   HEAP32[i4 + 192 >> 2] = 1;
   HEAP32[i4 + 252 >> 2] = 4;
   HEAP32[i4 + 260 >> 2] = 2;
   HEAP32[i4 + 264 >> 2] = 2;
   HEAP32[i4 + 268 >> 2] = 0;
   HEAP32[i4 + 272 >> 2] = 0;
   HEAP32[i4 + 276 >> 2] = 0;
   return;
  }
 case 0:
  {
   i1 = HEAP32[i4 + 36 >> 2] | 0;
   i2 = i4 + 60 | 0;
   HEAP32[i2 >> 2] = i1;
   if ((i1 + -1 | 0) >>> 0 > 9) {
    i3 = HEAP32[i4 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 26;
    HEAP32[i3 + 24 >> 2] = i1;
    HEAP32[i3 + 28 >> 2] = 10;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
    i3 = HEAP32[i2 >> 2] | 0;
   } else i3 = i1;
   if ((i3 | 0) <= 0) return;
   i2 = HEAP32[i4 + 68 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i2 + (i1 * 84 | 0) >> 2] = i1;
    HEAP32[i2 + (i1 * 84 | 0) + 8 >> 2] = 1;
    HEAP32[i2 + (i1 * 84 | 0) + 12 >> 2] = 1;
    HEAP32[i2 + (i1 * 84 | 0) + 16 >> 2] = 0;
    HEAP32[i2 + (i1 * 84 | 0) + 20 >> 2] = 0;
    HEAP32[i2 + (i1 * 84 | 0) + 24 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   return;
  }
 default:
  {
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 10;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
   return;
  }
 }
}

function _save_marker(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i7 = HEAP32[i13 + 404 >> 2] | 0;
 i12 = i7 + 160 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i14 = i13 + 24 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = i15 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i5) {
  do if (!i1) if (!((mftCall_ii(HEAP32[i15 + 12 >> 2] | 0, i13 | 0) | 0) << 24 >> 24)) {
   i16 = 0;
   return i16 | 0;
  } else {
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   break;
  } while (0);
  i1 = i1 + -1 | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAPU8[i2 >> 0] << 8;
  do if (!i1) if (!((mftCall_ii(HEAP32[i15 + 12 >> 2] | 0, i13 | 0) | 0) << 24 >> 24)) {
   i16 = 0;
   return i16 | 0;
  } else {
   i1 = HEAP32[i16 >> 2] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   break;
  } while (0);
  i1 = i1 + -1 | 0;
  i2 = i3 + 1 | 0;
  i3 = (HEAPU8[i3 >> 0] | i4) + -2 | 0;
  if ((i3 | 0) > -1) {
   i4 = i13 + 380 | 0;
   i10 = HEAP32[i4 >> 2] | 0;
   i10 = HEAP32[((i10 | 0) == 254 ? i7 + 92 | 0 : i7 + 96 + (i10 + -224 << 2) | 0) >> 2] | 0;
   i10 = i3 >>> 0 < i10 >>> 0 ? i3 : i10;
   i11 = mftCall_iiii(HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 4 >> 2] | 0, i13 | 0, 1, i10 + 20 | 0) | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP8[i11 + 4 >> 0] = HEAP32[i4 >> 2];
   HEAP32[i11 + 8 >> 2] = i3;
   HEAP32[i11 + 12 >> 2] = i10;
   i4 = i11 + 20 | 0;
   HEAP32[i11 + 16 >> 2] = i4;
   HEAP32[i12 >> 2] = i11;
   HEAP32[i7 + 164 >> 2] = 0;
   i6 = 0;
   i8 = 11;
  } else {
   i6 = 0;
   i5 = i2;
   i4 = 0;
  }
 } else {
  i6 = HEAP32[i7 + 164 >> 2] | 0;
  i3 = 0;
  i4 = (HEAP32[i5 + 16 >> 2] | 0) + i6 | 0;
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  i11 = i5;
  i8 = 11;
 }
 if ((i8 | 0) == 11) {
  L19 : do if (i6 >>> 0 < i10 >>> 0) {
   i8 = i7 + 164 | 0;
   i9 = i15 + 12 | 0;
   i5 = i6;
   while (1) {
    HEAP32[i15 >> 2] = i2;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i8 >> 2] = i5;
    if (!i1) {
     if (!((mftCall_ii(HEAP32[i9 >> 2] | 0, i13 | 0) | 0) << 24 >> 24)) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[i15 >> 2] | 0;
    }
    if (i5 >>> 0 < i10 >>> 0 & (i1 | 0) != 0) {
     i6 = i4;
     while (1) {
      i7 = i2 + 1 | 0;
      i4 = i6 + 1 | 0;
      HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
      i1 = i1 + -1 | 0;
      i2 = i5 + 1 | 0;
      if (i2 >>> 0 < i10 >>> 0 & (i1 | 0) != 0) {
       i6 = i4;
       i5 = i2;
       i2 = i7;
      } else {
       i5 = i2;
       i2 = i7;
       break;
      }
     }
    }
    if (i5 >>> 0 >= i10 >>> 0) {
     i5 = i2;
     break L19;
    }
   }
   return i1 | 0;
  } else i5 = i2; while (0);
  if (!i11) i6 = i10; else {
   i3 = i13 + 268 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) HEAP32[i3 >> 2] = i11; else {
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    HEAP32[i2 >> 2] = i11;
   }
   i6 = i10;
   i3 = (HEAP32[i11 + 8 >> 2] | 0) - i10 | 0;
   i4 = HEAP32[i11 + 16 >> 2] | 0;
  }
 }
 HEAP32[i12 >> 2] = 0;
 i2 = HEAP32[i13 + 380 >> 2] | 0;
 L41 : do switch (i2 | 0) {
 case 224:
  {
   _examine_app0(i13, i4, i6, i3);
   break;
  }
 case 238:
  {
   if (i6 >>> 0 > 11) if ((HEAP8[i4 >> 0] | 0) == 65) if ((HEAP8[i4 + 1 >> 0] | 0) == 100) if ((HEAP8[i4 + 2 >> 0] | 0) == 111) if ((HEAP8[i4 + 3 >> 0] | 0) == 98) if ((HEAP8[i4 + 4 >> 0] | 0) == 101) {
    i9 = HEAPU8[i4 + 7 >> 0] << 8 | HEAPU8[i4 + 8 >> 0];
    i10 = HEAPU8[i4 + 9 >> 0] << 8 | HEAPU8[i4 + 10 >> 0];
    i12 = HEAP8[i4 + 11 >> 0] | 0;
    i11 = HEAP32[i13 >> 2] | 0;
    HEAP32[i11 + 24 >> 2] = HEAPU8[i4 + 5 >> 0] << 8 | HEAPU8[i4 + 6 >> 0];
    HEAP32[i11 + 28 >> 2] = i9;
    HEAP32[i11 + 32 >> 2] = i10;
    HEAP32[i11 + 36 >> 2] = i12 & 255;
    HEAP32[i11 + 20 >> 2] = 76;
    mftCall_vii(HEAP32[i11 + 4 >> 2] | 0, i13 | 0, 1);
    HEAP8[i13 + 264 >> 0] = 1;
    HEAP8[i13 + 265 >> 0] = i12;
    break L41;
   }
   i12 = HEAP32[i13 >> 2] | 0;
   HEAP32[i12 + 20 >> 2] = 78;
   HEAP32[i12 + 24 >> 2] = i3 + i6;
   mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i13 | 0, 1);
   break;
  }
 default:
  {
   i12 = HEAP32[i13 >> 2] | 0;
   HEAP32[i12 + 20 >> 2] = 91;
   HEAP32[i12 + 24 >> 2] = i2;
   HEAP32[i12 + 28 >> 2] = i3 + i6;
   mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i13 | 0, 1);
  }
 } while (0);
 HEAP32[i15 >> 2] = i5;
 HEAP32[i16 >> 2] = i1;
 if ((i3 | 0) <= 0) {
  i16 = 1;
  return i16 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 | 0);
 i16 = 1;
 return i16 | 0;
}

function __ZN19AutoOffMeshLinkData8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i2 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898897 | 0, i2, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843739 | 0, i2, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843754 | 0, HEAP32[gb + 37288 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 29; else {
    i3 = i2 + 2 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 29; else {
     HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 30 | 0;
 i4 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843765 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 31 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843772 | 0, i4, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 204 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 24 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVES2_NS0_10ShrunkBoxVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 85512 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function runPostSets56() {
 HEAP32[gb + 66512 >> 2] = fb + 40;
 HEAP32[gb + 66516 >> 2] = fb + 19;
 HEAP32[gb + 66520 >> 2] = fb + 318;
 HEAP32[gb + 66524 >> 2] = fb + 99;
 HEAP32[gb + 66528 >> 2] = fb + 40;
 HEAP32[gb + 66532 >> 2] = fb + 62;
 HEAP32[gb + 66536 >> 2] = fb + 28;
 HEAP32[gb + 66540 >> 2] = fb + 63;
 HEAP32[gb + 66544 >> 2] = fb + 29;
 HEAP32[gb + 66548 >> 2] = fb + 34;
 HEAP32[gb + 66552 >> 2] = fb + 581;
 HEAP32[gb + 66556 >> 2] = fb + 582;
 HEAP32[gb + 66560 >> 2] = fb + 583;
 HEAP32[gb + 66564 >> 2] = fb + 584;
 HEAP32[gb + 66568 >> 2] = fb + 585;
 HEAP32[gb + 66572 >> 2] = fb + 586;
 HEAP32[gb + 66576 >> 2] = fb + 36;
 HEAP32[gb + 66580 >> 2] = fb + 96;
 HEAP32[gb + 66584 >> 2] = fb + 81;
 HEAP32[gb + 66588 >> 2] = fb + 82;
 HEAP32[gb + 66592 >> 2] = fb + 87;
 HEAP32[gb + 66596 >> 2] = (HEAP32[gb + 66596 >> 2] | 0) + (gb + 1049781 | 0);
 HEAP32[gb + 66600 >> 2] = (HEAP32[gb + 66600 >> 2] | 0) + (gb + 1049797 | 0);
 HEAP32[gb + 66604 >> 2] = (HEAP32[gb + 66604 >> 2] | 0) + (gb + 464034 | 0);
 HEAP32[gb + 66608 >> 2] = (HEAP32[gb + 66608 >> 2] | 0) + (gb + 897582 | 0);
 HEAP32[gb + 66612 >> 2] = (HEAP32[gb + 66612 >> 2] | 0) + (gb + 850049 | 0);
 HEAP32[gb + 66616 >> 2] = (HEAP32[gb + 66616 >> 2] | 0) + (gb + 590158 | 0);
 HEAP32[gb + 66620 >> 2] = (HEAP32[gb + 66620 >> 2] | 0) + (gb + 464019 | 0);
 HEAP32[gb + 66632 >> 2] = fb + 734;
 HEAP32[gb + 66636 >> 2] = fb + 735;
 HEAP32[gb + 66640 >> 2] = fb + 80;
 HEAP32[gb + 66644 >> 2] = fb + 39;
 HEAP32[gb + 66648 >> 2] = fb + 16;
 HEAP32[gb + 66652 >> 2] = fb + 39;
 HEAP32[gb + 66656 >> 2] = fb + 40;
 HEAP32[gb + 66660 >> 2] = fb + 19;
 HEAP32[gb + 66664 >> 2] = fb + 98;
 HEAP32[gb + 66668 >> 2] = fb + 99;
 HEAP32[gb + 66672 >> 2] = fb + 40;
 HEAP32[gb + 66676 >> 2] = fb + 62;
 HEAP32[gb + 66680 >> 2] = fb + 28;
 HEAP32[gb + 66684 >> 2] = fb + 63;
 HEAP32[gb + 66688 >> 2] = fb + 29;
 HEAP32[gb + 66692 >> 2] = fb + 34;
 HEAP32[gb + 66696 >> 2] = fb + 85;
 HEAP32[gb + 66700 >> 2] = fb + 86;
 HEAP32[gb + 66704 >> 2] = fb + 87;
 HEAP32[gb + 66708 >> 2] = fb + 88;
 HEAP32[gb + 66712 >> 2] = fb + 89;
 HEAP32[gb + 66716 >> 2] = fb + 90;
 HEAP32[gb + 66720 >> 2] = fb + 36;
 HEAP32[gb + 66724 >> 2] = fb + 96;
 HEAP32[gb + 66728 >> 2] = fb + 81;
 HEAP32[gb + 66732 >> 2] = fb + 82;
 HEAP32[gb + 66736 >> 2] = fb + 87;
 HEAP32[gb + 66740 >> 2] = (HEAP32[gb + 66740 >> 2] | 0) + (gb + 464431 | 0);
 HEAP32[gb + 66744 >> 2] = (HEAP32[gb + 66744 >> 2] | 0) + (gb + 464447 | 0);
 HEAP32[gb + 66748 >> 2] = (HEAP32[gb + 66748 >> 2] | 0) + (gb + 464470 | 0);
 HEAP32[gb + 66752 >> 2] = (HEAP32[gb + 66752 >> 2] | 0) + (gb + 590238 | 0);
 HEAP32[gb + 66756 >> 2] = (HEAP32[gb + 66756 >> 2] | 0) + (gb + 1026738 | 0);
 HEAP32[gb + 66760 >> 2] = (HEAP32[gb + 66760 >> 2] | 0) + (gb + 464497 | 0);
 HEAP32[gb + 66764 >> 2] = (HEAP32[gb + 66764 >> 2] | 0) + (gb + 464516 | 0);
 HEAP32[gb + 66768 >> 2] = (HEAP32[gb + 66768 >> 2] | 0) + (gb + 464535 | 0);
 HEAP32[gb + 66772 >> 2] = (HEAP32[gb + 66772 >> 2] | 0) + (gb + 464547 | 0);
 HEAP32[gb + 66776 >> 2] = (HEAP32[gb + 66776 >> 2] | 0) + (gb + 464567 | 0);
 HEAP32[gb + 66780 >> 2] = (HEAP32[gb + 66780 >> 2] | 0) + (gb + 464582 | 0);
 HEAP32[gb + 66784 >> 2] = (HEAP32[gb + 66784 >> 2] | 0) + (gb + 464605 | 0);
 HEAP32[gb + 66788 >> 2] = (HEAP32[gb + 66788 >> 2] | 0) + (gb + 464623 | 0);
 HEAP32[gb + 66800 >> 2] = fb + 736;
 HEAP32[gb + 66804 >> 2] = fb + 737;
 HEAP32[gb + 66808 >> 2] = fb + 38;
 HEAP32[gb + 66812 >> 2] = fb + 587;
 HEAP32[gb + 66816 >> 2] = fb + 16;
 HEAP32[gb + 66820 >> 2] = fb + 39;
 HEAP32[gb + 66824 >> 2] = fb + 40;
 HEAP32[gb + 66828 >> 2] = fb + 19;
 HEAP32[gb + 66832 >> 2] = fb + 319;
 HEAP32[gb + 66836 >> 2] = fb + 31;
 HEAP32[gb + 66840 >> 2] = fb + 27;
 HEAP32[gb + 66844 >> 2] = fb + 62;
 HEAP32[gb + 66848 >> 2] = fb + 28;
 HEAP32[gb + 66852 >> 2] = fb + 63;
 HEAP32[gb + 66856 >> 2] = fb + 29;
 HEAP32[gb + 66860 >> 2] = fb + 34;
 HEAP32[gb + 66864 >> 2] = fb + 588;
 HEAP32[gb + 66868 >> 2] = fb + 589;
 HEAP32[gb + 66872 >> 2] = fb + 590;
 HEAP32[gb + 66876 >> 2] = fb + 591;
 HEAP32[gb + 66880 >> 2] = fb + 592;
 HEAP32[gb + 66884 >> 2] = fb + 593;
 HEAP32[gb + 66888 >> 2] = fb + 36;
 HEAP32[gb + 66892 >> 2] = fb + 45;
 HEAP32[gb + 66896 >> 2] = fb + 82;
 HEAP32[gb + 66900 >> 2] = fb + 320;
 HEAP32[gb + 66912 >> 2] = fb + 738;
 HEAP32[gb + 66916 >> 2] = fb + 739;
 HEAP32[gb + 66920 >> 2] = fb + 1;
 HEAP32[gb + 66924 >> 2] = fb + 1;
 HEAP32[gb + 66928 >> 2] = fb + 1;
 HEAP32[gb + 66932 >> 2] = fb + 1;
 runPostSets57();
}

function __ZNSt3__26__sortIRNS_6__lessIhhEEPhEEvT0_S5_T_(i1, i2, i13) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i2;
  i14 = i2 + -1 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i3 = i12 - i11 | 0;
    switch (i3 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i3 | 0) < 31) {
     i15 = 11;
     break L1;
    }
    i7 = i1 + (i3 >>> 1) | 0;
    if ((i3 | 0) > 999) {
     i3 = i3 >>> 2;
     i3 = __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_(i1, i1 + i3 | 0, i7, i7 + i3 | 0, i14, i13) | 0;
    } else i3 = __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i1, i7, i14, i13) | 0;
    i8 = HEAP8[i1 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if ((i8 & 255) < (i5 & 255)) {
     i4 = i14;
     break;
    } else i4 = i14;
    while (1) {
     i4 = i4 + -1 | 0;
     if ((i1 | 0) == (i4 | 0)) break;
     i6 = HEAP8[i4 >> 0] | 0;
     if ((i6 & 255) < (i5 & 255)) {
      i15 = 29;
      break L5;
     }
    }
    i3 = i1 + 1 | 0;
    i5 = HEAP8[i14 >> 0] | 0;
    if ((i8 & 255) >= (i5 & 255)) {
     while (1) {
      if ((i3 | 0) == (i14 | 0)) break L1;
      i4 = HEAP8[i3 >> 0] | 0;
      if ((i8 & 255) < (i4 & 255)) break;
      i3 = i3 + 1 | 0;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i14 >> 0] = i4;
     i3 = i3 + 1 | 0;
    }
    if ((i3 | 0) == (i14 | 0)) break L1; else i4 = i14;
    while (1) {
     i8 = HEAP8[i1 >> 0] | 0;
     while (1) {
      i6 = HEAP8[i3 >> 0] | 0;
      i7 = i3 + 1 | 0;
      if ((i8 & 255) < (i6 & 255)) break; else i3 = i7;
     }
     do {
      i4 = i4 + -1 | 0;
      i5 = HEAP8[i4 >> 0] | 0;
     } while ((i8 & 255) < (i5 & 255));
     if (i3 >>> 0 >= i4 >>> 0) {
      i1 = i3;
      continue L5;
     }
     HEAP8[i3 >> 0] = i5;
     HEAP8[i4 >> 0] = i6;
     i3 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAP8[i1 >> 0] = i6;
    HEAP8[i4 >> 0] = i8;
    i3 = i3 + 1 | 0;
   }
   i5 = i1 + 1 | 0;
   L35 : do if (i5 >>> 0 < i4 >>> 0) {
    i10 = i7;
    while (1) {
     i9 = HEAP8[i10 >> 0] | 0;
     while (1) {
      i7 = HEAP8[i5 >> 0] | 0;
      i8 = i5 + 1 | 0;
      if ((i7 & 255) < (i9 & 255)) i5 = i8; else break;
     }
     do {
      i4 = i4 + -1 | 0;
      i6 = HEAP8[i4 >> 0] | 0;
     } while ((i6 & 255) >= (i9 & 255));
     if (i5 >>> 0 > i4 >>> 0) {
      i6 = i10;
      i7 = i5;
      break L35;
     }
     HEAP8[i5 >> 0] = i6;
     HEAP8[i4 >> 0] = i7;
     i10 = (i10 | 0) == (i5 | 0) ? i4 : i10;
     i5 = i8;
     i3 = i3 + 1 | 0;
    }
   } else {
    i6 = i7;
    i7 = i5;
   } while (0);
   if ((i7 | 0) != (i6 | 0)) {
    i4 = HEAP8[i6 >> 0] | 0;
    i5 = HEAP8[i7 >> 0] | 0;
    if ((i4 & 255) < (i5 & 255)) {
     HEAP8[i7 >> 0] = i4;
     HEAP8[i6 >> 0] = i5;
     i3 = i3 + 1 | 0;
    }
   }
   if (!i3) {
    i3 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIhhEEPhEEbT0_S5_T_(i1, i7, i13) | 0;
    i4 = i7 + 1 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIhhEEPhEEbT0_S5_T_(i4, i2, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i3) {
     i1 = i4;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIhhEEPhEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 1 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIhhEEPhEEvT0_S5_T_(i7 + 1 | 0, i2, i13);
   i2 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i3) break; else {
    i2 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  i2 = HEAP8[i14 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if ((i2 & 255) < (i3 & 255)) {
   HEAP8[i1 >> 0] = i2;
   HEAP8[i14 >> 0] = i3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i1, i1 + 1 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_(i1, i1 + 1 | 0, i1 + 2 | 0, i1 + 3 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIhhEEPhEEvT0_S5_T_(i1, i2, i13);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 336 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx25PxVehicleConstraintShader21VehicleConstraintDataaSERKS1_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i2 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i2 + 88 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i2 + 92 >> 2] = HEAP32[i1 + 92 >> 2];
 i3 = i2 + 96 | 0;
 i4 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 116 >> 2] = HEAP32[i1 + 116 >> 2];
 HEAP32[i2 + 120 >> 2] = HEAP32[i1 + 120 >> 2];
 HEAP32[i2 + 124 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i2 + 128 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[i1 + 132 >> 2];
 HEAP32[i2 + 136 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i2 + 140 >> 2] = HEAP32[i1 + 140 >> 2];
 HEAP32[i2 + 144 >> 2] = HEAP32[i1 + 144 >> 2];
 HEAP32[i2 + 148 >> 2] = HEAP32[i1 + 148 >> 2];
 HEAP32[i2 + 152 >> 2] = HEAP32[i1 + 152 >> 2];
 HEAP32[i2 + 156 >> 2] = HEAP32[i1 + 156 >> 2];
 HEAP32[i2 + 160 >> 2] = HEAP32[i1 + 160 >> 2];
 HEAP32[i2 + 164 >> 2] = HEAP32[i1 + 164 >> 2];
 HEAP32[i2 + 168 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP32[i2 + 172 >> 2] = HEAP32[i1 + 172 >> 2];
 HEAP32[i2 + 176 >> 2] = HEAP32[i1 + 176 >> 2];
 HEAP32[i2 + 180 >> 2] = HEAP32[i1 + 180 >> 2];
 HEAP32[i2 + 184 >> 2] = HEAP32[i1 + 184 >> 2];
 HEAP32[i2 + 188 >> 2] = HEAP32[i1 + 188 >> 2];
 HEAP32[i2 + 192 >> 2] = HEAP32[i1 + 192 >> 2];
 HEAP32[i2 + 196 >> 2] = HEAP32[i1 + 196 >> 2];
 HEAP32[i2 + 200 >> 2] = HEAP32[i1 + 200 >> 2];
 HEAP32[i2 + 204 >> 2] = HEAP32[i1 + 204 >> 2];
 HEAP32[i2 + 208 >> 2] = HEAP32[i1 + 208 >> 2];
 i3 = i2 + 212 | 0;
 i4 = i1 + 212 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 232 >> 2] = HEAP32[i1 + 232 >> 2];
 HEAP32[i2 + 236 >> 2] = HEAP32[i1 + 236 >> 2];
 HEAP32[i2 + 240 >> 2] = HEAP32[i1 + 240 >> 2];
 HEAP32[i2 + 244 >> 2] = HEAP32[i1 + 244 >> 2];
 HEAP32[i2 + 248 >> 2] = HEAP32[i1 + 248 >> 2];
 HEAP32[i2 + 252 >> 2] = HEAP32[i1 + 252 >> 2];
 HEAP32[i2 + 256 >> 2] = HEAP32[i1 + 256 >> 2];
 HEAP32[i2 + 260 >> 2] = HEAP32[i1 + 260 >> 2];
 HEAP32[i2 + 264 >> 2] = HEAP32[i1 + 264 >> 2];
 HEAP32[i2 + 268 >> 2] = HEAP32[i1 + 268 >> 2];
 HEAP32[i2 + 272 >> 2] = HEAP32[i1 + 272 >> 2];
 HEAP32[i2 + 276 >> 2] = HEAP32[i1 + 276 >> 2];
 HEAP32[i2 + 280 >> 2] = HEAP32[i1 + 280 >> 2];
 HEAP32[i2 + 284 >> 2] = HEAP32[i1 + 284 >> 2];
 HEAP32[i2 + 288 >> 2] = HEAP32[i1 + 288 >> 2];
 HEAP32[i2 + 292 >> 2] = HEAP32[i1 + 292 >> 2];
 HEAP32[i2 + 296 >> 2] = HEAP32[i1 + 296 >> 2];
 HEAP32[i2 + 300 >> 2] = HEAP32[i1 + 300 >> 2];
 HEAP32[i2 + 304 >> 2] = HEAP32[i1 + 304 >> 2];
 HEAP32[i2 + 308 >> 2] = HEAP32[i1 + 308 >> 2];
 HEAP32[i2 + 312 >> 2] = HEAP32[i1 + 312 >> 2];
 HEAP32[i2 + 316 >> 2] = HEAP32[i1 + 316 >> 2];
 HEAP32[i2 + 320 >> 2] = HEAP32[i1 + 320 >> 2];
 HEAP32[i2 + 324 >> 2] = HEAP32[i1 + 324 >> 2];
 i3 = i2 + 328 | 0;
 i4 = i1 + 328 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 348 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i2 + 352 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i2 + 356 >> 2] = HEAP32[i1 + 356 >> 2];
 HEAP32[i2 + 360 >> 2] = HEAP32[i1 + 360 >> 2];
 return i2 | 0;
}

function __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i6 + 48 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 50 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 49 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 72 | 0, i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i8 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 72 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP8[i1 + 28 >> 0] = 1;
   HEAP8[i1 + 29 >> 0] = 0;
   HEAP32[i1 + 32 >> 2] = 0;
   i11 = i1 + 40 | 0;
   HEAP32[i1 + 64 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP8[i11 + 20 >> 0] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 72 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i10 = i8 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 72 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 72 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 1073741823 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = 77;
  HEAP32[i9 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 72 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (((i1 - i4 | 0) / 72 | 0) * 72 | 0) | 0;
 i7 = i3;
 i4 = i6 + (i5 * 72 | 0) | 0;
 i6 = i7;
 i1 = i3;
 do {
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 28 >> 0] = 1;
  HEAP8[i1 + 29 >> 0] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  i5 = i1 + 40 | 0;
  HEAP32[i1 + 64 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP8[i5 + 20 >> 0] = 0;
  i1 = i6 + 72 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i19 = i3 + -72 | 0;
   i14 = i5;
   i5 = i5 + -72 | 0;
   i17 = i3 + -48 | 0;
   HEAP32[i17 >> 2] = 0;
   i18 = i3 + -44 | 0;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP32[i19 + 8 >> 2] = 0;
   HEAP32[i19 + 12 >> 2] = 0;
   HEAP32[i19 + 16 >> 2] = 0;
   HEAP8[i18 >> 0] = 1;
   i16 = i3 + -43 | 0;
   HEAP8[i16 >> 0] = 0;
   i15 = i3 + -40 | 0;
   HEAP32[i15 >> 2] = 0;
   i20 = i3 + -32 | 0;
   i7 = i3 + -8 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i20 >> 2] = 0;
   HEAP32[i20 + 4 >> 2] = 0;
   HEAP32[i20 + 8 >> 2] = 0;
   HEAP32[i20 + 12 >> 2] = 0;
   HEAP32[i20 + 16 >> 2] = 0;
   HEAP8[i20 + 20 >> 0] = 0;
   HEAP32[i19 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + -68 >> 2] = HEAP32[i14 + -68 >> 2];
   HEAP32[i3 + -64 >> 2] = HEAP32[i14 + -64 >> 2];
   HEAP32[i3 + -56 >> 2] = HEAP32[i14 + -56 >> 2];
   HEAP32[i3 + -52 >> 2] = HEAP32[i14 + -52 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i14 + -48 >> 2];
   HEAP32[i3 + -60 >> 2] = HEAP32[i14 + -60 >> 2];
   i17 = i14 + -32 | 0;
   i19 = HEAP32[i17 + 4 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i20 = i14 + -24 | 0;
   i19 = HEAP32[i20 + 4 >> 2] | 0;
   i17 = i3 + -24 | 0;
   HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i17 + 4 >> 2] = i19;
   i17 = HEAP16[i14 + -44 >> 1] | 0;
   HEAP8[i18 >> 0] = i17;
   HEAP8[i16 >> 0] = (i17 & 65535) >>> 8;
   HEAP32[i15 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i14 + -16 >> 2];
   HEAP8[i3 + -12 >> 0] = HEAP8[i14 + -12 >> 0] | 0;
   HEAP32[i7 >> 2] = HEAP32[i14 + -8 >> 2];
   i3 = i2 + -72 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i11 >> 2] = i4;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i20 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = 77;
 HEAP32[i9 + 4 >> 2] = i20;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i13;
 return;
}

function __ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i1, i9, i10, i11) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + 4 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i2;
 do {
  if (i1 >>> 0 >= i10 >>> 0) {
   i13 = 4;
   break;
  }
  i4 = (HEAP8[i1 >> 0] | 0) == 0;
  i1 = i1 + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 } while (!i4);
 if ((i13 | 0) == 4) HEAP32[i9 >> 2] = i1 + 1;
 if (!i2) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = i8 + 20 | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i8 >> 2] | 0) + (i5 * 24 | 0) + 4 | 0, i4, i2);
 i3 = i6 + (i5 * 24 | 0) + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) <= -1) {
  i2 = HEAP32[gb + 36932 >> 2] | 0;
  i1 = i2 + (i1 & 2147483647) | 0;
  if ((i1 | 0) == (HEAP32[gb + 37244 >> 2] | 0)) {
   HEAP32[i3 >> 2] = (HEAP32[gb + 37040 >> 2] | 0) - i2 | -2147483648;
   break;
  }
  if ((i1 | 0) == (HEAP32[gb + 37292 >> 2] | 0)) HEAP32[i3 >> 2] = (HEAP32[gb + 37304 >> 2] | 0) - i2 | -2147483648;
 } while (0);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i2;
 do {
  if (i1 >>> 0 >= i10 >>> 0) {
   i13 = 14;
   break;
  }
  i3 = (HEAP8[i1 >> 0] | 0) == 0;
  i1 = i1 + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 } while (!i3);
 if ((i13 | 0) == 14) HEAP32[i9 >> 2] = i1 + 1;
 if (!i2) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i8 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 8 | 0, i4, i2);
 i2 = i6 + (i5 * 24 | 0) + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 HEAP8[i2 >> 0] = i1;
 HEAP8[i2 + 1 >> 0] = i1 >> 8;
 HEAP8[i2 + 2 >> 0] = i1 >> 16;
 HEAP8[i2 + 3 >> 0] = i1 >> 24;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 switch (i11 | 0) {
 case 2:
  {
   i1 = i2 + 8 | 0;
   HEAP32[i9 >> 2] = i1;
   i13 = 18;
   break;
  }
 case 3:
  {
   i2 = 0;
   break;
  }
 default:
  i13 = 18;
 }
 if ((i13 | 0) == 18) {
  i2 = i6 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  HEAP8[i2 >> 0] = i1;
  HEAP8[i2 + 1 >> 0] = i1 >> 8;
  HEAP8[i2 + 2 >> 0] = i1 >> 16;
  HEAP8[i2 + 3 >> 0] = i1 >> 24;
  i1 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = 1;
 }
 i3 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 i4 = i1 + 4 | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP8[i6 + (i5 * 24 | 0) + 3 >> 0] = i3;
 i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 i1 = i1 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP16[i6 + (i5 * 24 | 0) >> 1] = i4;
 if (i2) {
  i6 = i6 + (i5 * 24 | 0) + 20 | 0;
  i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  HEAP8[i6 >> 0] = i1;
  HEAP8[i6 + 1 >> 0] = i1 >> 8;
  HEAP8[i6 + 2 >> 0] = i1 >> 16;
  HEAP8[i6 + 3 >> 0] = i1 >> 24;
  i1 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i1;
 }
 i4 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 HEAP32[i9 >> 2] = i1 + 4;
 i2 = HEAP32[gb + 1166044 >> 2] | 0;
 i1 = i2 + 1 | 0;
 HEAP32[gb + 1166044 >> 2] = i1;
 if (i4 >>> 0 > 5e3 | (i2 | 0) > 49) {
  HEAP32[gb + 1166044 >> 2] = i2;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468112 | 0, 0, gb + 468163 | 0, 540, 1, 0, 0, 0);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 do if ((i4 | 0) > 0) {
  i2 = i8 + 12 | 0;
  i3 = i12 + 4 | 0;
  i1 = 0;
  while (1) {
   __ZN8TypeTree8AddChildEj(i8, HEAP32[i7 >> 2] | 0);
   i6 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i12 >> 2] = i8;
   HEAP32[i3 >> 2] = i6;
   i1 = i1 + 1 | 0;
   if (!(__ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i12, i9, i10, i11) | 0)) break;
   if ((i1 | 0) >= (i4 | 0)) {
    i13 = 28;
    break;
   }
  }
  if ((i13 | 0) == 28) {
   i1 = HEAP32[gb + 1166044 >> 2] | 0;
   break;
  }
  HEAP32[gb + 1166044 >> 2] = (HEAP32[gb + 1166044 >> 2] | 0) + -1;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[gb + 1166044 >> 2] = i1 + -1;
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i3 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i3 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i8 + 11 >> 0] = i3;
  if (!i3) i1 = i8; else {
   i1 = i8;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i6 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i3;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i8 + 16 | 0;
 i3 = i9 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i9 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i8 + 28 >> 2] | 0;
  i10 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 12;
 } else i10 = 10;
 if ((i10 | 0) == 10) {
  i5 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 + 24 >> 2] = i5 | -2147483648;
  HEAP32[i8 + 20 >> 2] = i4;
  i1 = i6;
  i10 = 12;
 }
 if ((i10 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i8 + 32 | 0;
 i2 = i9 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 + 40 >> 2] = 0;
 i4 = i9 + 36 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 >> 4;
 if (i6 | 0) {
  if (i6 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + 40 >> 2] = i5 + (i6 << 4);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i8 + 44 | 0;
 i3 = i9 + 44 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 i1 = i8 + 68 | 0;
 i3 = i9 + 68 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i9 + 72 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 80 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i8 + 80 >> 2] | 0;
  i10 = 20;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i10 = i1;
   i10 = i10 + i4 | 0;
   HEAP8[i10 >> 0] = 0;
   i10 = i8 + 84 | 0;
   i9 = i9 + 84 | 0;
   i9 = HEAP32[i9 >> 2] | 0;
   HEAP32[i10 >> 2] = i9;
   STACKTOP = i11;
   return;
  }
 } else i10 = 20;
 if ((i10 | 0) == 20) {
  i6 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i8 + 76 >> 2] = i6 | -2147483648;
  HEAP32[i8 + 72 >> 2] = i4;
  i1 = i10;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i10 = i1;
 i10 = i10 + i4 | 0;
 HEAP8[i10 >> 0] = 0;
 i10 = i8 + 84 | 0;
 i9 = i9 + 84 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj(i14, i15, i18) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i19 = i14 + 12 | 0;
 i20 = i14 + 40 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i23 = 0;
  return i23 | 0;
 }
 i21 = i14 + 1644 | 0;
 i22 = i14 + 36 | 0;
 i23 = i14 + 24 | 0;
 i16 = i14 + 28 | 0;
 i17 = i14 + 8 | 0;
 while (1) {
  do if (!(HEAP8[i21 >> 0] | 0)) {
   i12 = i14 + 44 + (i1 * 40 | 0) + 36 | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) >> 2]);
   f7 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 16 >> 2]);
   f10 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 20 >> 2]);
   f11 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 24 >> 2]);
   if (!i3) i3 = 27; else {
    i13 = HEAP32[i14 >> 2] | 0;
    i5 = 0;
    i4 = 0;
    do {
     i6 = _llvm_cttz_i32(i3 | 0) | 0;
     i5 = i6 + i5 | 0;
     f24 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) >> 2]);
     if (!(!(f24 >= f2) | !(f24 <= f9))) {
      f24 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 4 >> 2]);
      if (!(!(f24 >= f7) | !(f24 <= f10))) {
       f24 = Math_fround(HEAPF32[i13 + (i5 * 12 | 0) + 8 >> 2]);
       i4 = (!(f24 >= f8) | !(f24 <= f11) ? 0 : 1 << i5) | i4;
      }
     }
     i3 = i3 >>> (i6 + 1 | 0);
     i5 = i5 + 1 | 0;
    } while ((i3 | 0) != 0 & (i5 | 0) < 32);
    if (!i4) i3 = 27; else {
     HEAP32[i12 >> 2] = i4;
     i3 = 21;
    }
   }
  } else {
   i3 = HEAP32[i17 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) >> 2]);
   f7 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 16 >> 2]);
   f10 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 20 >> 2]);
   f11 = Math_fround(HEAPF32[i14 + 44 + (i1 * 40 | 0) + 24 >> 2]);
   if (i3 | 0) {
    i12 = HEAP32[i14 >> 2] | 0;
    i5 = 0;
    i4 = 0;
    do {
     i6 = _llvm_cttz_i32(i3 | 0) | 0;
     i5 = i6 + i5 | 0;
     f24 = Math_fround(HEAPF32[i12 + (i5 * 12 | 0) >> 2]);
     if (!(!(f24 >= f2) | !(f24 <= f9))) {
      f24 = Math_fround(HEAPF32[i12 + (i5 * 12 | 0) + 4 >> 2]);
      if (!(!(f24 >= f7) | !(f24 <= f10))) {
       f24 = Math_fround(HEAPF32[i12 + (i5 * 12 | 0) + 8 >> 2]);
       i4 = (!(f24 >= f8) | !(f24 <= f11) ? 0 : 1 << i5) | i4;
      }
     }
     i3 = i3 >>> (i6 + 1 | 0);
     i5 = i5 + 1 | 0;
    } while ((i3 | 0) != 0 & (i5 | 0) < 32);
    if (i4 | 0) {
     HEAP32[i14 + 44 + (i1 * 40 | 0) + 36 >> 2] = i4;
     HEAP8[i21 >> 0] = 0;
     i3 = 21;
     break;
    }
   }
   HEAP8[i21 >> 0] = 0;
   i3 = 27;
  } while (0);
  if ((i3 | 0) == 21) {
   i3 = 0;
   i4 = HEAP32[i20 >> 2] | 0;
   i1 = HEAP8[i14 + 44 + (i4 * 40 | 0) + 29 >> 0] | 0;
   if (i1 << 24 >> 24 == 3) break;
   i1 = i1 & 255;
   i3 = HEAP32[i14 + 44 + (i4 * 40 | 0) + 12 >> 2] | 0;
   if ((HEAP32[i22 >> 2] | 0) > (i3 | 0)) f2 = Math_fround(HEAPF32[(HEAP32[i23 >> 2] | 0) + (HEAP32[i16 >> 2] | 0) + (i3 << 2) >> 2]); else {
    f2 = Math_fround(HEAPF32[i14 + 44 + (i4 * 40 | 0) + (i1 << 2) >> 2]);
    f2 = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i14 + 44 + (i4 * 40 | 0) + 16 + (i1 << 2) >> 2])) * Math_fround(.5));
   }
   i1 = HEAP32[i14 + 44 + (i4 * 40 | 0) + 36 >> 2] | 0;
   __ZN5Umbra15KDTraverseStackIjE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbjj(i19, 3, f2, 1, i1, i1);
   i1 = HEAP32[i20 >> 2] | 0;
  } else if ((i3 | 0) == 27) {
   i1 = i1 + -1 | 0;
   HEAP32[i20 >> 2] = i1;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i3 = 29;
   break;
  }
 }
 if ((i3 | 0) == 29) return i1 | 0;
 i23 = i14 + 44 + (i4 * 40 | 0) | 0;
 HEAP32[i15 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i23 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i23 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i23 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i23 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i23 + 28 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i14 + 44 + ((HEAP32[i20 >> 2] | 0) * 40 | 0) + 36 >> 2];
 HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
 i23 = 1;
 return i23 | 0;
}

function ___rem_pio2(d2, i13) {
 d2 = +d2;
 i13 = i13 | 0;
 var i1 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 16 | 0;
 i9 = i14;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i1 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i10 = _bitshift64Lshr(i1 | 0, i5 | 0, 63) | 0;
 getTempRet0() | 0;
 i12 = i5 & 2147483647;
 do if (i12 >>> 0 < 1074752123) if ((i5 & 1048575 | 0) == 598523) i11 = 21; else {
  i1 = (i10 | 0) != 0;
  if (i12 >>> 0 < 1073928573) if (i1) {
   d6 = d2 + 1.5707963267341256;
   d7 = d6 + 6.077100506506192e-11;
   HEAPF64[i13 >> 3] = d7;
   HEAPF64[i13 + 8 >> 3] = d6 - d7 + 6.077100506506192e-11;
   i1 = -1;
   break;
  } else {
   d6 = d2 + -1.5707963267341256;
   d7 = d6 + -6.077100506506192e-11;
   HEAPF64[i13 >> 3] = d7;
   HEAPF64[i13 + 8 >> 3] = d6 - d7 + -6.077100506506192e-11;
   i1 = 1;
   break;
  } else if (i1) {
   d6 = d2 + 3.1415926534682512;
   d7 = d6 + 1.2154201013012384e-10;
   HEAPF64[i13 >> 3] = d7;
   HEAPF64[i13 + 8 >> 3] = d6 - d7 + 1.2154201013012384e-10;
   i1 = -2;
   break;
  } else {
   d6 = d2 + -3.1415926534682512;
   d7 = d6 + -1.2154201013012384e-10;
   HEAPF64[i13 >> 3] = d7;
   HEAPF64[i13 + 8 >> 3] = d6 - d7 + -1.2154201013012384e-10;
   i1 = 2;
   break;
  }
 } else {
  if (i12 >>> 0 < 1075594812) if (i12 >>> 0 < 1075183037) {
   if ((i12 | 0) == 1074977148) {
    i11 = 21;
    break;
   }
   if (!i10) {
    d6 = d2 + -4.712388980202377;
    d7 = d6 + -1.8231301519518578e-10;
    HEAPF64[i13 >> 3] = d7;
    HEAPF64[i13 + 8 >> 3] = d6 - d7 + -1.8231301519518578e-10;
    i1 = 3;
    break;
   } else {
    d6 = d2 + 4.712388980202377;
    d7 = d6 + 1.8231301519518578e-10;
    HEAPF64[i13 >> 3] = d7;
    HEAPF64[i13 + 8 >> 3] = d6 - d7 + 1.8231301519518578e-10;
    i1 = -3;
    break;
   }
  } else {
   if ((i12 | 0) == 1075388923) {
    i11 = 21;
    break;
   }
   if (!i10) {
    d6 = d2 + -6.2831853069365025;
    d7 = d6 + -2.430840202602477e-10;
    HEAPF64[i13 >> 3] = d7;
    HEAPF64[i13 + 8 >> 3] = d6 - d7 + -2.430840202602477e-10;
    i1 = 4;
    break;
   } else {
    d6 = d2 + 6.2831853069365025;
    d7 = d6 + 2.430840202602477e-10;
    HEAPF64[i13 >> 3] = d7;
    HEAPF64[i13 + 8 >> 3] = d6 - d7 + 2.430840202602477e-10;
    i1 = -4;
    break;
   }
  }
  if (i12 >>> 0 < 1094263291) i11 = 21; else {
   if (i12 >>> 0 > 2146435071) {
    d7 = d2 - d2;
    HEAPF64[i13 + 8 >> 3] = d7;
    HEAPF64[i13 >> 3] = d7;
    i1 = 0;
    break;
   }
   HEAP32[tempDoublePtr >> 2] = i1;
   HEAP32[tempDoublePtr + 4 >> 2] = i5 & 1048575 | 1096810496;
   d2 = +HEAPF64[tempDoublePtr >> 3];
   i1 = 0;
   do {
    d7 = +(~~d2 | 0);
    HEAPF64[i8 + (i1 << 3) >> 3] = d7;
    d2 = (d2 - d7) * 16777216.0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 2);
   HEAPF64[i8 + 16 >> 3] = d2;
   if (d2 == 0.0) {
    i1 = 1;
    while (1) if (+HEAPF64[i8 + (i1 << 3) >> 3] == 0.0) i1 = i1 + -1 | 0; else break;
   } else i1 = 2;
   i1 = ___rem_pio2_large(i8, i9, (i12 >>> 20) + -1046 | 0, i1 + 1 | 0, 1) | 0;
   d3 = +HEAPF64[i9 >> 3];
   d2 = +HEAPF64[i9 + 8 >> 3];
   if (!i10) {
    HEAPF64[i13 >> 3] = d3;
    HEAPF64[i13 + 8 >> 3] = d2;
    break;
   } else {
    HEAPF64[i13 >> 3] = -d3;
    HEAPF64[i13 + 8 >> 3] = -d2;
    i1 = 0 - i1 | 0;
    break;
   }
  }
 } while (0);
 if ((i11 | 0) == 21) {
  d7 = d2 * .6366197723675814 + 6755399441055744.0 + -6755399441055744.0;
  i1 = ~~d7;
  d6 = d2 - d7 * 1.5707963267341256;
  d3 = d7 * 6.077100506506192e-11;
  d2 = d6 - d3;
  HEAPF64[i13 >> 3] = d2;
  HEAPF64[tempDoublePtr >> 3] = d2;
  i11 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 52) | 0;
  getTempRet0() | 0;
  i5 = i12 >>> 20;
  if ((i5 - (i11 & 2047) | 0) > 16) {
   d3 = d7 * 6.077100506303966e-11;
   d4 = d6 - d3;
   d3 = d7 * 2.0222662487959506e-21 - (d6 - d4 - d3);
   d2 = d4 - d3;
   HEAPF64[i13 >> 3] = d2;
   HEAPF64[tempDoublePtr >> 3] = d2;
   i12 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 52) | 0;
   getTempRet0() | 0;
   if ((i5 - (i12 & 2047) | 0) > 49) {
    d3 = d7 * 2.0222662487111665e-21;
    d6 = d4 - d3;
    d3 = d7 * 8.4784276603689e-32 - (d4 - d6 - d3);
    d2 = d6 - d3;
    HEAPF64[i13 >> 3] = d2;
    d4 = d6;
   }
  } else d4 = d6;
  HEAPF64[i13 + 8 >> 3] = d4 - d2 - d3;
 }
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVES2_S2_S2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_fb(i4, i7, i6, i14, i20, i19, i16, i18, i12, f2, i15) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i25 + 96 | 0;
 i17 = i25 + 80 | 0;
 i3 = i25 + 64 | 0;
 i24 = i25 + 144 | 0;
 i13 = i25 + 48 | 0;
 i10 = i25 + 32 | 0;
 i11 = i25 + 16 | 0;
 i21 = i25;
 i5 = i25 + 164 | 0;
 i8 = i25 + 160 | 0;
 i22 = i25 + 156 | 0;
 i23 = i25 + 128 | 0;
 i1 = i25 + 112 | 0;
 if (!(__ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f(i4, i7, i6, i14, i20, i19, i3, i17, i9, f2) | 0)) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 };
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (!(Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0) | i15 ^ 1)) {
  f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i7 + 16 >> 2])) * Math_fround(100.0));
  HEAP8[i22 >> 0] = 0;
  L6 : do switch (__ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i4, i7, i6, i13, i10, i11, i17, i21, i5, i8, i22) | 0) {
  case 1:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    break;
   }
  case 6:
   {
    HEAP32[i23 >> 2] = gb + 103320 + 8;
    HEAP32[i23 + 4 >> 2] = i4;
    HEAP32[i23 + 8 >> 2] = i7;
    HEAP32[i23 + 12 >> 2] = i6;
    if (((__ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i4, i7, i23, i5, i8, HEAP8[i22 >> 0] | 0, i10, i11, i17, i21, 0) | 0) + -5 | 0) >>> 0 < 2) {
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     break L6;
    } else {
     f28 = Math_fround(HEAPF32[i19 >> 2]);
     f26 = Math_fround(HEAPF32[i19 + 4 >> 2]);
     f2 = Math_fround(HEAPF32[i19 + 8 >> 2]);
     f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f26 * f26)) + Math_fround(f2 * f2)))));
     f26 = Math_fround(-Math_fround(f26 * f27));
     f2 = Math_fround(-Math_fround(f2 * f27));
     HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f28 * f27));
     HEAPF32[i17 + 4 >> 2] = f26;
     HEAPF32[i17 + 8 >> 2] = f2;
     HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
     HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAPF32[i21 >> 2] = Math_fround(0.0);
     i23 = i21 + 4 | 0;
     HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
     HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
     HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
     break L6;
    }
   }
  default:
   {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   }
  } while (0);
  f28 = Math_fround(HEAPF32[i21 >> 2]);
  i24 = f28 < Math_fround(0.0);
  HEAPF32[i16 >> 2] = i24 ? f28 : Math_fround(0.0);
  i24 = i16 + 4 | 0;
  HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 };
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_(i14, i13, i8, i10) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 20 | 0;
 i6 = i15 + 16 | 0;
 i4 = i15 + 12 | 0;
 i5 = i15 + 8 | 0;
 i11 = i15 + 4 | 0;
 i12 = i15;
 switch (i8 | 0) {
 case 1:
 case 0:
  {
   i14 = HEAP32[i14 >> 2] | 0;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 2:
  {
   i3 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i3;
   if ((HEAP32[i3 + 8 >> 2] | 0) >= (HEAP32[i1 + 8 >> 2] | 0)) {
    i14 = i1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i14 = i2 + 4 | 0;
   i12 = HEAP32[i2 >> 2] | 0;
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 >> 2];
   HEAP32[HEAP32[i14 >> 2] >> 2] = i12;
   i12 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 + 4 >> 2] = i2;
   HEAP32[i3 >> 2] = i12;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i14 >> 2] = i1;
   i14 = HEAP32[i13 >> 2] | 0;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i9 = i8 >>> 1;
   i1 = HEAP32[i14 >> 2] | 0;
   i3 = i1;
   if (i9) {
    i2 = i9;
    while (1) {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if ((i2 | 0) > 1) i2 = i2 + -1 | 0; else break;
    }
   }
   HEAP32[i4 >> 2] = i3;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   i5 = __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_(i6, i7, i9, i10) | 0;
   HEAP32[i14 >> 2] = i5;
   HEAP32[i11 >> 2] = i1;
   i13 = HEAP32[i13 >> 2] | 0;
   HEAP32[i12 >> 2] = i13;
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
   i1 = __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_(i6, i7, i8 - i9 | 0, i10) | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   i11 = i13;
   if ((HEAP32[i1 + 8 >> 2] | 0) < (i4 | 0)) {
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i3;
    L9 : do if ((i3 | 0) == (i11 | 0)) i3 = i11; else while (1) {
     if ((HEAP32[i2 + 8 >> 2] | 0) >= (i4 | 0)) break L9;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i3 = i2;
     if ((i3 | 0) == (i11 | 0)) {
      i3 = i11;
      break;
     }
    } while (0);
    i10 = HEAP32[i3 >> 2] | 0;
    i12 = i10 + 4 | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    HEAP32[i13 + 4 >> 2] = HEAP32[i12 >> 2];
    HEAP32[HEAP32[i12 >> 2] >> 2] = i13;
    i13 = HEAP32[i5 + 4 >> 2] | 0;
    i9 = HEAP32[i5 >> 2] | 0;
    HEAP32[i9 + 4 >> 2] = i1;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i5 >> 2] = i10;
    HEAP32[i12 >> 2] = i5;
    i5 = i13;
   } else {
    i2 = i1;
    i1 = i5;
    i5 = HEAP32[i5 + 4 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i5;
   i4 = i5;
   i3 = i2;
   if ((i4 | 0) == (i3 | 0)) {
    i14 = i1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i9 = i2;
   i10 = i2;
   i2 = i3;
   i3 = i5;
   L19 : while (1) {
    i8 = i10;
    if ((i8 | 0) == (i11 | 0)) {
     i2 = 24;
     break;
    }
    i5 = HEAP32[i10 + 8 >> 2] | 0;
    while (1) {
     if ((i5 | 0) < (HEAP32[i3 + 8 >> 2] | 0)) break;
     i3 = HEAP32[i4 + 4 >> 2] | 0;
     HEAP32[i14 >> 2] = i3;
     i4 = i3;
     if ((i4 | 0) == (i2 | 0)) {
      i2 = 24;
      break L19;
     }
    }
    i6 = HEAP32[i8 + 4 >> 2] | 0;
    i5 = i6;
    L26 : do if ((i6 | 0) == (i11 | 0)) i3 = i11; else {
     i7 = HEAP32[i3 + 8 >> 2] | 0;
     i3 = i6;
     while (1) {
      if ((HEAP32[i5 + 8 >> 2] | 0) >= (i7 | 0)) break L26;
      i5 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = i5;
      if ((i3 | 0) == (i11 | 0)) {
       i3 = i11;
       break;
      }
     }
    } while (0);
    i12 = HEAP32[i3 >> 2] | 0;
    i13 = i12 + 4 | 0;
    i6 = HEAP32[i8 >> 2] | 0;
    HEAP32[i6 + 4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[HEAP32[i13 >> 2] >> 2] = i6;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    i3 = (i2 | 0) == (i8 | 0) ? i5 : i9;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i4 >> 2] = i12;
    HEAP32[i13 >> 2] = i4;
    HEAP32[i14 >> 2] = i6;
    i2 = i3;
    if ((i6 | 0) == (i2 | 0)) {
     i2 = 24;
     break;
    } else {
     i9 = i3;
     i10 = i5;
     i4 = i6;
     i3 = i6;
    }
   }
   if ((i2 | 0) == 24) {
    STACKTOP = i15;
    return i1 | 0;
   }
  }
 }
 return 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 128 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i3 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, i2, HEAP32[gb + 37212 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  __ZN14SafeBinaryRead10SetVersionEi(i10, 2);
  i5 = HEAP32[gb + 37012 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1085989 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i4 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i8 = 8; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 4 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1085998 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 8 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034504 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 30; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 12 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1034510 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i7 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i7 >>> 0) i8 = 41; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i9;
 return;
}

function __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 1 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 4 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 5 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 6 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 7 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 8 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 10 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 11 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i1;
 }
 i2 = i3 + 12 | 0;
 if ((i1 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i2, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 13 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 14 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 15 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 64 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __Z18RenderImageFiltersR10RenderLoopP13RenderTextureb(i3, i7, i12) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32848 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 32832 | 0;
 i5 = i17 + 32816 | 0;
 i13 = i17;
 i14 = HEAP32[gb + 1166248 >> 2] | 0;
 i15 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 __ZN15RenderNodeQueueC2ERK10MemLabelId(i13, gb + 64016 | 0);
 i10 = i12 ? 12 : 18;
 i8 = i15 + 1136 | 0;
 i9 = i15 + 4 | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i8, i10, i14, i13, gb + 1159956 | 0, HEAP32[i9 >> 2] | 0);
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i8, i10, i14, i13, gb + 1159956 | 0, HEAP32[i9 >> 2] | 0);
 i10 = __ZNK6Camera28CalculateNeedsToRenderIntoRTEv(i15) | 0;
 i11 = i3 + 68 | 0;
 i4 = i3 + 72 | 0;
 if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
  if ((HEAP32[i3 + 80 >> 2] | 0) != (HEAP32[i3 + 84 >> 2] | 0)) i16 = 3;
 } else i16 = 3;
 do if ((i16 | 0) == 3) if (__ZNK6Camera27GetUsesScreenForCompositingEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i10) | 0) {
  if (i12) {
   if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) break;
   i6 = __ZN12ImageFilters21GetTargetBeforeOpaqueEv(i11) | 0;
  } else {
   if ((HEAP32[i3 + 80 >> 2] | 0) == (HEAP32[i3 + 84 >> 2] | 0)) break;
   i6 = __ZN12ImageFilters20GetTargetAfterOpaqueEbb(i11, i10, 1) | 0;
  }
  if (i6 | 0) {
   if ((HEAP16[gb + 1115232 + 6 >> 1] | 0) > -1) {
    HEAP32[i5 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115232 | 0, i1);
    i2 = gb + 1115232 | 0;
   } else i2 = 0;
   i18 = HEAP32[gb + 1115232 >> 2] | 0;
   i21 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 648 >> 2] | 0, i21 | 0, i18 | 0);
   i18 = HEAP32[gb + 1163232 >> 2] | 0;
   HEAP32[gb + 1163232 >> 2] = 7;
   i21 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i21 >> 2] | 0) + 340 >> 2] | 0, i21 | 0);
   __ZNK6Camera13GetCameraRectEb(i1, HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, 0);
   __Z14RectfToRectIntRK5RectTIfE(i5, i1);
   i21 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0, i6 | 0) | 0;
   i20 = HEAP32[i5 + 8 >> 2] | 0;
   i19 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 104 >> 2] | 0, i6 | 0) | 0;
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   __ZN13RenderTexture10GrabPixelsEiiii(i6, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, (i21 | 0) < (i20 | 0) ? i21 : i20, (i19 | 0) < (i1 | 0) ? i19 : i1);
   __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i6, 0);
   HEAP32[gb + 1163232 >> 2] = i18;
   i6 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 652 >> 2] | 0, i6 | 0);
   if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  }
 } while (0);
 if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if ((HEAP32[i3 + 80 >> 2] | 0) == (HEAP32[i3 + 84 >> 2] | 0)) i1 = 0; else i16 = 16; else i16 = 16;
 if ((i16 | 0) == 16) i1 = __ZNK6Camera27GetUsesScreenForCompositingEb(i15, i10) | 0;
 __ZN12ImageFilters8DoRenderER17ShaderPassContextP13RenderTexturebbbb(i11, i14, i7, i10, i12, i1, (HEAP8[i15 + 1092 >> 0] | 0) != 0);
 if (i1 | i12 ^ 1) {
  i20 = i12 ? 13 : 19;
  i21 = HEAP32[i9 >> 2] | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i8, i20, i14, i13, gb + 1159956 | 0, i21);
  i21 = HEAP32[i9 >> 2] | 0;
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i8, i20, i14, i13, gb + 1159956 | 0, i21);
  __ZN15RenderNodeQueueD2Ev(i13);
  STACKTOP = i17;
  return;
 }
 HEAP32[i15 + 1144 >> 2] = __ZN12ImageFilters20GetTargetAfterOpaqueEbb(i11, i10, 0) | 0;
 i20 = i12 ? 13 : 19;
 i21 = HEAP32[i9 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i8, i20, i14, i13, gb + 1159956 | 0, i21);
 i21 = HEAP32[i9 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i8, i20, i14, i13, gb + 1159956 | 0, i21);
 __ZN15RenderNodeQueueD2Ev(i13);
 STACKTOP = i17;
 return;
}

function __ZN7dtCrowd4initEi(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN7dtCrowd5purgeEv(i7);
 i1 = __Z7dtAlloci(10464) | 0;
 if (!i1) {
  HEAP32[i7 + 364 >> 2] = 0;
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i1 + 10452 >> 2] = 0;
 HEAP32[i1 + 10456 >> 2] = 0;
 HEAP32[i1 + 10460 >> 2] = 0;
 i2 = i1 + 10420 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i7 + 364 >> 2] = i1;
 i1 = i7 + 264 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i7 + 264 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 268 >> 2] = Math_fround(.200000003);
 HEAPF32[i7 + 272 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 276 >> 2] = Math_fround(2.0);
 HEAP8[i7 + 280 >> 0] = 7;
 HEAP8[i7 + 281 >> 0] = 3;
 HEAP8[i7 + 282 >> 0] = 3;
 HEAPF32[i7 + 284 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 288 >> 2] = Math_fround(.200000003);
 HEAPF32[i7 + 292 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 296 >> 2] = Math_fround(2.0);
 HEAP8[i7 + 300 >> 0] = 7;
 HEAP8[i7 + 301 >> 0] = 3;
 HEAP8[i7 + 302 >> 0] = 3;
 HEAPF32[i7 + 304 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 308 >> 2] = Math_fround(.200000003);
 HEAPF32[i7 + 312 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 316 >> 2] = Math_fround(2.0);
 HEAP8[i7 + 320 >> 0] = 7;
 HEAP8[i7 + 321 >> 0] = 3;
 HEAP8[i7 + 322 >> 0] = 3;
 HEAPF32[i7 + 324 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 328 >> 2] = Math_fround(.200000003);
 HEAPF32[i7 + 332 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 336 >> 2] = Math_fround(2.0);
 HEAP8[i7 + 340 >> 0] = 7;
 HEAP8[i7 + 341 >> 0] = 3;
 HEAP8[i7 + 342 >> 0] = 3;
 HEAPF32[i7 + 344 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 348 >> 2] = Math_fround(.200000003);
 HEAPF32[i7 + 352 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 356 >> 2] = Math_fround(2.0);
 HEAP8[i7 + 360 >> 0] = 7;
 HEAP8[i7 + 361 >> 0] = 3;
 HEAP8[i7 + 362 >> 0] = 3;
 i5 = __Z7dtAlloci(132) | 0;
 HEAP32[i5 + 128 >> 2] = -1;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 12 >> 2] = i5;
 if (!(__ZN7dtCrowd13ReserveAgentsEi(i7, i6) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = i7 + 408 | 0;
 if ((HEAP32[i5 >> 2] | 0) < (i6 | 0)) {
  i4 = i7 + 416 | 0;
  i1 = __Z9dtReallocPvi(HEAP32[i4 >> 2] | 0, i6 * 92 | 0) | 0;
  if (!i1) {
   i7 = 0;
   return i7 | 0;
  }
  HEAP32[i4 >> 2] = i1;
  i1 = i7 + 396 | 0;
  i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i6 << 2) | 0;
  if (!i2) {
   i7 = 0;
   return i7 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) < (i6 | 0)) {
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = i3;
   do {
    HEAP32[i2 + (i1 * 92 | 0) + 84 >> 2] = 0;
    i4 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i2 + (i4 * 92 | 0) + 88 >> 2] = i1;
   } while ((i1 | 0) != (i6 | 0));
  }
  HEAP32[i7 + 412 >> 2] = i3;
  HEAP32[i5 >> 2] = i6;
  __ZN7dtCrowd19ResizeProximityGridEv(i7);
 }
 i1 = i7 + 372 | 0;
 i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, 256) | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 HEAP32[i7 + 376 >> 2] = 32;
 i7 = 1;
 return i7 | 0;
}

function __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i9 = HEAP32[i1 >> 2] | 0;
 L1 : do if (!i9) {
  i13 = 0;
  i11 = 0;
  i9 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
 } else {
  i8 = i1 + 4 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i7 = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
  while (1) {
   switch (HEAP32[i8 + (i7 * 12 | 0) + 4 >> 2] | 0) {
   case 6:
    {
     i1 = i1 + 1 | 0;
     break;
    }
   case 7:
    {
     i6 = i6 + 1 | 0;
     break;
    }
   case 8:
    {
     i5 = i5 + 1 | 0;
     break;
    }
   case 1:
    {
     i4 = i4 + 1 | 0;
     break;
    }
   case 3:
    {
     i3 = i3 + 1 | 0;
     break;
    }
   case 4:
   case 9:
    {
     i2 = i2 + 1 | 0;
     break;
    }
   default:
    {}
   }
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i9 | 0)) {
    i13 = i1;
    i11 = i2;
    i9 = i3;
    break L1;
   }
  }
 } while (0);
 i8 = (i13 | 0) == 0;
 i12 = i13 * 12 | 0;
 i15 = (i5 * 12 | 0) + (i6 << 4) + i11 + (i9 + i4 << 2) + (i8 ? 48 : i12 + 48 | 0) | 0;
 i18 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i15 | 0, 64) | 0;
 HEAP32[i19 >> 2] = gb + 177508 + 8;
 i14 = i19 + 4 | 0;
 HEAP32[i14 >> 2] = i18;
 HEAP32[i19 + 8 >> 2] = i18;
 HEAP32[i19 + 12 >> 2] = i15;
 i1 = i18;
 i2 = (0 - i1 & 3) + i1 | 0;
 i3 = i2 + 48 | 0;
 i15 = i18 + i15 | 0;
 if (i3 >>> 0 > i15 >>> 0) i18 = 0; else {
  HEAP32[i14 >> 2] = i3;
  i18 = i2;
  i1 = i3;
 }
 i10 = i18 + 4 | 0;
 i2 = i10;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i18 >> 2] = i13;
 i7 = i18 + 8 | 0;
 HEAP32[i7 >> 2] = i6;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = i5;
 i5 = i18 + 24 | 0;
 HEAP32[i5 >> 2] = i4;
 i17 = i18 + 32 | 0;
 HEAP32[i17 >> 2] = i9;
 i9 = i18 + 40 | 0;
 HEAP32[i9 >> 2] = i11;
 if (i8) i2 = 0; else {
  i2 = (0 - i1 & 3) + i1 | 0;
  i3 = i2 + i12 | 0;
  if (i3 >>> 0 > i15 >>> 0) i2 = 0; else {
   HEAP32[i14 >> 2] = i3;
   i1 = i3;
  }
  if ((i2 | 0) != (i2 + (i13 * 12 | 0) | 0)) {
   _memset(i2 | 0, 0, i12 - (((i12 + -12 | 0) >>> 0) % 12 | 0) | 0) | 0;
   i6 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i2 | 0 ? i2 - i10 | 0 : 0;
 i4 = i18 + 12 | 0;
 if (!i6) i1 = 0; else {
  i1 = (0 - i1 & 3) + i1 | 0;
  i2 = i1 + (i6 << 4) | 0;
  if (i2 >>> 0 > i15 >>> 0) i1 = 0; else HEAP32[i14 >> 2] = i2;
  i3 = i1 + (i6 << 4) | 0;
  i2 = i1;
  do {
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
   i2 = i2 + 16 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i4 = i18 + 20 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i2 * 12 | 0, 4) | 0;
  i3 = i1 + (i2 * 12 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAPF32[i2 >> 2] = Math_fround(1.0);
    HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
    HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i4 = i18 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i4 = i18 + 36 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i2 = i18 + 44 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i16 = 0;
  i17 = (i16 | 0) != 0;
  i19 = i2;
  i19 = i16 - i19 | 0;
  i19 = i17 ? i19 : 0;
  HEAP32[i2 >> 2] = i19;
  STACKTOP = i20;
  return i18 | 0;
 }
 i16 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i1 | 0, 1) | 0;
 _memset(i16 | 0, 0, i1 | 0) | 0;
 i17 = (i16 | 0) != 0;
 i19 = i2;
 i19 = i16 - i19 | 0;
 i19 = i17 ? i19 : 0;
 HEAP32[i2 >> 2] = i19;
 STACKTOP = i20;
 return i18 | 0;
}

function _psh_globals_set_scale(i10, i5, i11, i1, i9) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i10 + 200 | 0;
 i3 = i10 + 204 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
  if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) i4 = 3;
 } else i4 = 3;
 if ((i4 | 0) == 3) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  if (i1 | 0) {
   i8 = _UNITY_FT_MulFix(HEAP32[i10 + 8 >> 2] | 0, i5) | 0;
   i3 = i10 + 12 | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i10 + 16 >> 2] = i8 + 32 & -64;
   i1 = i1 + -1 | 0;
   if (i1 | 0) {
    i2 = i10 + 20 | 0;
    while (1) {
     i8 = _UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i5) | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     i6 = i8 - i7 | 0;
     i8 = (((i6 | 0) < 0 ? 0 - i6 | 0 : i6) | 0) < 128 ? i7 : i8;
     HEAP32[i2 + 4 >> 2] = i8;
     HEAP32[i2 + 8 >> 2] = i8 + 32 & -64;
     i1 = i1 + -1 | 0;
     if (!i1) break; else i2 = i2 + 12 | 0;
    }
   }
  }
 }
 i1 = i10 + 404 | 0;
 i2 = i10 + 408 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) return;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i2 >> 2] = i9;
 i1 = HEAP32[i10 + 208 >> 2] | 0;
 if (i1 | 0) {
  i8 = _UNITY_FT_MulFix(HEAP32[i10 + 212 >> 2] | 0, i11) | 0;
  i3 = i10 + 216 | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i10 + 220 >> 2] = i8 + 32 & -64;
  i1 = i1 + -1 | 0;
  if (i1 | 0) {
   i2 = i10 + 224 | 0;
   while (1) {
    i8 = _UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i11) | 0;
    i7 = HEAP32[i3 >> 2] | 0;
    i6 = i8 - i7 | 0;
    i8 = (((i6 | 0) < 0 ? 0 - i6 | 0 : i6) | 0) < 128 ? i7 : i8;
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i2 + 8 >> 2] = i8 + 32 & -64;
    i1 = i1 + -1 | 0;
    if (!i1) break; else i2 = i2 + 12 | 0;
   }
  }
 }
 i5 = i10 + 412 | 0;
 i1 = HEAP32[i10 + 2476 >> 2] | 0;
 if ((i11 | 0) > 34359737) i1 = ((i1 << 3 | 0) / 125 | 0 | 0) > (i11 | 0); else i1 = (i11 * 125 | 0) < (i1 << 3 | 0);
 HEAP8[i10 + 2492 >> 0] = i1 & 1;
 i1 = HEAP32[i10 + 2480 >> 2] | 0;
 L24 : do if ((i1 | 0) > 0) while (1) {
  if ((_UNITY_FT_MulFix(i1, i11) | 0) <= 32) break L24;
  i2 = i1 + -1 | 0;
  if ((i1 | 0) > 1) i1 = i2; else {
   i1 = i2;
   break;
  }
 } while (0);
 HEAP32[i10 + 2484 >> 2] = i1;
 i8 = i10 + 1960 | 0;
 i6 = i10 + 928 | 0;
 i7 = i10 + 1444 | 0;
 i4 = 0;
 do {
  switch (i4 | 0) {
  case 0:
   {
    i1 = i5;
    break;
   }
  case 1:
   {
    i1 = i6;
    break;
   }
  case 2:
   {
    i1 = i7;
    break;
   }
  default:
   i1 = i8;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i2 = i1 + 4 | 0;
   i1 = i3;
   while (1) {
    HEAP32[i2 + 28 >> 2] = (_UNITY_FT_MulFix(HEAP32[i2 + 8 >> 2] | 0, i11) | 0) + i9;
    HEAP32[i2 + 24 >> 2] = (_UNITY_FT_MulFix(HEAP32[i2 + 12 >> 2] | 0, i11) | 0) + i9;
    i3 = i2 + 16 | 0;
    HEAP32[i3 >> 2] = (_UNITY_FT_MulFix(HEAP32[i2 >> 2] | 0, i11) | 0) + i9;
    HEAP32[i2 + 20 >> 2] = _UNITY_FT_MulFix(HEAP32[i2 + 4 >> 2] | 0, i11) | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 32 & -64;
    i1 = i1 + -1 | 0;
    if (!i1) break; else i2 = i2 + 32 | 0;
   }
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 4);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i5 = i10 + 1448 | 0;
  i4 = i10 + 416 | 0;
  while (1) {
   i2 = HEAP32[i7 >> 2] | 0;
   L46 : do if (i2 | 0) {
    i3 = i5;
    while (1) {
     i9 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
     if ((_UNITY_FT_MulFix((i9 | 0) < 0 ? 0 - i9 | 0 : i9, i11) | 0) < 64) break;
     i2 = i2 + -1 | 0;
     if (!i2) break L46; else i3 = i3 + 32 | 0;
    }
    HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   } while (0);
   i1 = i1 + -1 | 0;
   if (!i1) break; else i4 = i4 + 32 | 0;
  }
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i5 = i10 + 1964 | 0;
 i4 = i10 + 932 | 0;
 while (1) {
  i2 = HEAP32[i8 >> 2] | 0;
  L59 : do if (i2 | 0) {
   i3 = i5;
   while (1) {
    i10 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
    if ((_UNITY_FT_MulFix((i10 | 0) < 0 ? 0 - i10 | 0 : i10, i11) | 0) < 64) break;
    i2 = i2 + -1 | 0;
    if (!i2) break L59; else i3 = i3 + 32 | 0;
   }
   HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  } while (0);
  i1 = i1 + -1 | 0;
  if (!i1) break; else i4 = i4 + 32 | 0;
 }
 return;
}

function __ZNKSt3__28messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE(i20, i1, i11, i12, i13, i2) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i19 + 184 | 0;
 i8 = i19 + 192 | 0;
 i9 = i19 + 180 | 0;
 i10 = i19 + 176 | 0;
 i14 = i19 + 168 | 0;
 i15 = i19 + 40 | 0;
 i16 = i19 + 32 | 0;
 i17 = i19 + 28 | 0;
 i21 = i19 + 16 | 0;
 i6 = i19 + 8 | 0;
 i18 = i19;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i21 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 212260 + 8;
 i4 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i1 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i1 + ((i5 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) << 2) | 0;
 i5 = i8 + 32 | 0;
 i2 = i1;
 i1 = 0;
 L5 : while (1) {
  if (!((i1 | 0) != 2 & i2 >>> 0 < i4 >>> 0)) {
   i3 = 13;
   break;
  }
  HEAP32[i10 >> 2] = i2;
  __THREW__ = 0;
  i3 = invoke_iiiiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i7 | 0, i2 | 0, i4 | 0, i10 | 0, i8 | 0, i5 | 0, i9 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i3 = 15;
   break;
  }
  if ((i3 | 0) == 2 ? 1 : (HEAP32[i10 >> 2] | 0) == (i2 | 0)) {
   i3 = 8;
   break;
  } else i1 = i8;
  while (1) {
   if (i1 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break;
   __THREW__ = 0;
   invoke_vii(fb + 4511 | 0, i21 | 0, HEAP8[i1 >> 0] | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) {
    i3 = 14;
    break L5;
   }
   i1 = i1 + 1 | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = i3;
 }
 do if ((i3 | 0) == 8) {
  __THREW__ = 0;
  invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i3 = 16;
 } else if ((i3 | 0) == 13) {
  __THREW__ = 0;
  i2 = invoke_iiiii(fb + 209 | 0, ((i11 | 0) == -1 ? -1 : i11 << 1) | 0, i12 | 0, i13 | 0, ((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21) | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i20 >> 2] = 0;
  HEAP32[i20 + 4 >> 2] = 0;
  HEAP32[i20 + 8 >> 2] = 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i20 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 >> 2] = gb + 212308 + 8;
  i4 = i2 + (_strlen(i2) | 0) | 0;
  i5 = i4;
  i6 = i15 + 128 | 0;
  i1 = 0;
  L23 : while (1) {
   if (!((i1 | 0) != 2 & i2 >>> 0 < i4 >>> 0)) {
    i3 = 29;
    break;
   }
   HEAP32[i17 >> 2] = i2;
   __THREW__ = 0;
   i3 = invoke_iiiiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0, i14 | 0, i2 | 0, ((i5 - i2 | 0) > 32 ? i2 + 32 | 0 : i4) | 0, i17 | 0, i15 | 0, i6 | 0, i16 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i3 = 32;
    break;
   }
   if ((i3 | 0) == 2 ? 1 : (HEAP32[i17 >> 2] | 0) == (i2 | 0)) {
    i3 = 24;
    break;
   } else i1 = i15;
   while (1) {
    if (i1 >>> 0 >= (HEAP32[i16 >> 2] | 0) >>> 0) break;
    __THREW__ = 0;
    invoke_vii(fb + 4513 | 0, i20 | 0, HEAP32[i1 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i3 = 31;
     break L23;
    }
    i1 = i1 + 4 | 0;
   }
   i2 = HEAP32[i17 >> 2] | 0;
   i1 = i3;
  }
  if ((i3 | 0) == 24) {
   __THREW__ = 0;
   invoke_vi(fb + 4004 | 0, gb + 1079323 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i3 | 0) == 29) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
   STACKTOP = i19;
   return;
  } else if ((i3 | 0) == 31) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i3 | 0) == 32) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i20);
 } else if ((i3 | 0) == 14) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i3 = 16;
 } else if ((i3 | 0) == 15) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i3 = 16;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 128 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 384 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 256 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 128 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 200 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i24 + 16 | 0;
 i22 = i24 + 4 | 0;
 i2 = i24;
 i6 = i24 + 29 | 0;
 i7 = i24 + 28 | 0;
 HEAP32[i23 >> 2] = 0;
 i5 = i23 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i21 = i23 + 8 | 0;
 HEAP32[i21 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i22, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i23 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i5 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i23, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i21 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
  }
  i15 = HEAP32[i23 >> 2] | 0;
  i14 = HEAP32[i5 >> 2] | 0;
  i16 = i15 + (i14 << 2) | 0;
  i12 = i19 + 276 | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i13 = i15 + (i14 - i11 << 2) | 0;
  if (i14 >>> 0 > i11 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j(i15, i14, i6, i19, 32);
   i11 = i22 + 4 | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j(HEAP32[i22 >> 2] | 0, HEAP32[i11 >> 2] | 0, i7, i19, 32);
   i6 = i19 + 268 | 0;
   HEAP32[i6 >> 2] = 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   i7 = i2 + (i11 << 2) | 0;
   if (!i11) i1 = i15; else {
    i8 = i19 + 288 | 0;
    i9 = i19 + 272 | 0;
    i10 = i19 + 264 | 0;
    i11 = i19 + 284 | 0;
    i1 = i15;
    do {
     i3 = HEAP32[i2 >> 2] | 0;
     i4 = i3;
     L16 : do if (i1 >>> 0 < i13 >>> 0) while (1) {
      i5 = HEAP32[i1 >> 2] | 0;
      if (i3 >>> 0 <= i5 >>> 0) {
       i5 = i3;
       break L16;
      }
      HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i5;
      HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      i4 = i3;
      if (i1 >>> 0 >= i13 >>> 0) {
       i5 = i3;
       break;
      }
     } else i5 = i3; while (0);
     if ((i5 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i3 = HEAP32[i12 >> 2] | 0;
      if (((HEAP32[i1 + (i3 + -1 << 2) >> 2] | 0) + 64 | 0) == ((HEAP32[i8 >> 2] | 0) + i5 | 0)) {
       if (i5) {
        __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, i5 + (0 - (HEAP32[i5 + -4 >> 2] | 0)) | 0);
        i3 = HEAP32[i12 >> 2] | 0;
       }
       i1 = i1 + (i3 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i3 = HEAP32[i6 >> 2] | 0;
      if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
       HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i4;
       HEAP32[i6 >> 2] = i3 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEE15growAndPushBackERKS2_(i17, i2) | 0;
       break;
      }
     } while (0);
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != (i7 | 0));
   }
  } else i1 = i15;
  if ((i1 | 0) != (i16 | 0)) {
   i4 = i19 + 284 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + ((i15 + (i14 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i3 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i3;
    i3 = HEAP32[i1 >> 2] | 0;
    HEAP32[i3 >> 2] = i19;
    HEAP32[i20 >> 2] = i3;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i4 >> 2] = i2 + 1;
  }
 }
 i20 = HEAP32[i22 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i22 >> 2] | 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i22, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 }
 i22 = HEAP32[i21 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i24;
  return;
 }
 i1 = HEAP32[i23 >> 2] | 0;
 if (!i1) {
  STACKTOP = i24;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i23, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 STACKTOP = i24;
 return;
}

function __ZN16UnityAdsSettings8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = i6 + 8 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1047713 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i10 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1041805 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 17 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1041676 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1041827 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i10 >>> 0) i5 = 33; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 33; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i5 | 0) == 33) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 20 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1041846 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1041858 | 0, i3, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i2, 1); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 48 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function _cff_parse_real(i1, i13, i14, i16) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i17 = 0;
 i15 = (i16 | 0) != 0;
 if (i15) {
  HEAP32[i16 >> 2] = 0;
  i3 = i1;
  i8 = 0;
  i2 = 0;
  i1 = 0;
  i4 = 4;
 } else {
  i3 = i1;
  i8 = 0;
  i2 = 0;
  i1 = 0;
  i4 = 4;
 }
 L3 : while (1) {
  while (1) {
   if (i4) {
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i13 >>> 0) {
     i1 = 0;
     break L3;
    }
   }
   i5 = HEAP8[i3 >> 0] | 0;
   i6 = (i5 & 255) >>> i4 & 15;
   i4 = 4 - i4 | 0;
   if ((i6 | 0) != 14) break; else i2 = 1;
  }
  if (i6 >>> 0 > 9) {
   i12 = i8;
   i7 = 0;
   i9 = 15;
   break;
  }
  i12 = (i6 | i1 | 0) == 0;
  i1 = i12 ? i1 : i6 + (i1 * 10 | 0) | 0;
  i8 = (i12 & 1 ^ 1) + i8 | 0;
  if ((i1 | 0) > 214748363) {
   i5 = 0;
   i9 = 4;
   break;
  }
 }
 L12 : do if ((i9 | 0) == 4) L13 : while (1) {
  i9 = 0;
  i7 = i5;
  while (1) {
   if (i4) {
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 >= i13 >>> 0) {
     i1 = 0;
     break L12;
    }
   }
   i5 = HEAP8[i3 >> 0] | 0;
   i6 = (i5 & 255) >>> i4 & 15;
   i4 = 4 - i4 | 0;
   if ((i6 | 0) == 14) {
    i5 = i7;
    i2 = 1;
    i9 = 4;
    continue L13;
   }
   if (i6 >>> 0 > 9) {
    i12 = i8;
    i9 = 15;
    break L12;
   }
   i7 = i7 + 1 | 0;
  }
 } while (0);
 L22 : do if ((i9 | 0) == 15) {
  L24 : do if ((i6 | 0) == 10) {
   i8 = 0;
   while (1) {
    while (1) {
     if (i4) {
      i5 = i3 + 1 | 0;
      if (i5 >>> 0 >= i13 >>> 0) {
       i1 = 0;
       break L22;
      }
      i3 = i5;
      i5 = HEAP8[i5 >> 0] | 0;
     }
     i6 = (i5 & 255) >>> i4 & 15;
     i4 = 4 - i4 | 0;
     if (i6 >>> 0 > 9) {
      i11 = i8;
      break L24;
     }
     if (i6 | i1 | 0) break;
     i7 = i7 + -1 | 0;
    }
    i11 = (i1 | 0) < 214748364 & (i8 | 0) < 9;
    i8 = (i11 & 1) + i8 | 0;
    i1 = i11 ? i6 + (i1 * 10 | 0) | 0 : i1;
   }
  } else i11 = 0; while (0);
  i10 = (i6 | 0) == 12;
  if ((i6 + -11 | 0) >>> 0 < 2) {
   i8 = 0;
   i9 = 0;
   while (1) {
    if (i4) {
     i5 = i3 + 1 | 0;
     if (i5 >>> 0 >= i13 >>> 0) {
      i1 = 0;
      break L22;
     }
     i3 = i5;
     i5 = HEAP8[i5 >> 0] | 0;
    }
    i6 = (i5 & 255) >>> i4 & 15;
    if (i6 >>> 0 > 9) break;
    i17 = (i9 | 0) > 1e3;
    i8 = i17 ? 1 : i8;
    i9 = i17 ? i9 : i6 + (i9 * 10 | 0) | 0;
    i4 = 4 - i4 | 0;
   }
   i4 = i8;
   i3 = i10 ? 0 - i9 | 0 : i9;
  } else {
   i4 = 0;
   i3 = 0;
  }
  if (!i1) i1 = 0; else {
   do if (!i4) {
    i3 = i7 + i14 + i3 | 0;
    if (!i15) {
     i4 = i3 + i12 | 0;
     if ((i4 | 0) > 5) {
      i1 = 2147483647;
      break L22;
     }
     if ((i4 | 0) < -5) break;
     if ((i4 | 0) < 0) {
      i3 = i11 + i12 | 0;
      i1 = (i1 | 0) / (HEAP32[gb + 186012 + (0 - i4 << 2) >> 2] | 0) | 0;
     } else i3 = i11 - i3 | 0;
     i17 = (i3 | 0) == 10;
     i4 = i17 ? (i1 | 0) / 10 | 0 : i1;
     i1 = (i17 << 31 >> 31) + i3 | 0;
     if ((i1 | 0) <= 0) {
      i1 = Math_imul(HEAP32[gb + 186012 + (0 - i1 << 2) >> 2] | 0, i4) | 0;
      i1 = (i1 | 0) > 32767 ? 2147483647 : i1 << 16;
      break L22;
     }
     i1 = HEAP32[gb + 186012 + (i1 << 2) >> 2] | 0;
     if (((i4 | 0) / (i1 | 0) | 0 | 0) > 32767) {
      i1 = 0;
      break L22;
     }
     i1 = _UNITY_FT_DivFix(i4, i1) | 0;
     break L22;
    }
    i6 = i11 + i12 | 0;
    i4 = i3 + i12 | 0;
    if ((i6 | 0) >= 6) {
     i3 = HEAP32[gb + 186012 + (i6 + -5 << 2) >> 2] | 0;
     if (((i1 | 0) / (i3 | 0) | 0 | 0) > 32767) {
      i1 = _UNITY_FT_DivFix(i1, HEAP32[gb + 186012 + (i6 + -4 << 2) >> 2] | 0) | 0;
      HEAP32[i16 >> 2] = i4 + -4;
      break L22;
     } else {
      i1 = _UNITY_FT_DivFix(i1, i3) | 0;
      HEAP32[i16 >> 2] = i4 + -5;
      break L22;
     }
    }
    if ((i1 | 0) > 32767) {
     i1 = _UNITY_FT_DivFix(i1, 10) | 0;
     HEAP32[i16 >> 2] = 1 - i6 + i4;
     break L22;
    }
    do if ((i4 | 0) > 0) {
     i3 = (i4 | 0) < 5 ? i4 : 5;
     i5 = i3 - i6 | 0;
     if ((i5 | 0) <= 0) {
      i3 = i4 - i6 | 0;
      break;
     }
     i3 = i4 - i3 | 0;
     i1 = Math_imul(HEAP32[gb + 186012 + (i5 << 2) >> 2] | 0, i1) | 0;
     if ((i1 | 0) > 32767) {
      i3 = i3 + 1 | 0;
      i1 = (i1 >>> 0) / 10 | 0;
     }
    } else i3 = i4 - i6 | 0; while (0);
    HEAP32[i16 >> 2] = i3;
    i1 = i1 << 16;
    break L22;
   } else if (!i10) {
    i1 = 2147483647;
    break L22;
   } while (0);
   i1 = 0;
  }
 } while (0);
 return ((i2 | 0) == 0 ? i1 : 0 - i1 | 0) | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 32 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i7 + 32 | 0;
 i20 = i7 + 28 | 0;
 i16 = i7 + 24 | 0;
 i11 = i7 + 20 | 0;
 i18 = i7 + 16 | 0;
 i14 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i10 = i7;
 f23 = Math_fround(HEAPF32[i6 >> 2]);
 i28 = f23 < Math_fround(0.0);
 f22 = Math_fround(HEAPF32[(i28 ? i2 : i3) >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i28 = f13 < Math_fround(0.0);
 f24 = Math_fround(HEAPF32[(i28 ? i2 : i3) + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i28 = f26 < Math_fround(0.0);
 f17 = Math_fround(HEAPF32[(i28 ? i2 : i3) + 8 >> 2]);
 i28 = HEAP32[i1 + 16 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i28 + 1184 >> 2]);
 f15 = Math_fround(HEAPF32[i28 + 1188 >> 2]);
 f21 = Math_fround(HEAPF32[i28 + 1192 >> 2]);
 f26 = Math_fround(Math_fround(Math_fround(Math_fround(f22 - f19) * f23) + Math_fround(Math_fround(f24 - f15) * f13)) + Math_fround(Math_fround(f17 - f21) * f26));
 f26 = Math_fround(Math_fround(HEAPF32[i1 + 232 >> 2]) * f26);
 HEAPF32[i29 >> 2] = f26;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 i28 = f26 >= Math_fround(0.0);
 i28 = HEAP32[(i28 ? i29 : i20) >> 2] | 0;
 HEAP32[i29 >> 2] = i28;
 f26 = Math_fround(HEAPF32[i1 + 192 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i28, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f26 = Math_fround(f17 * f26);
 f13 = Math_fround(f17 * Math_fround(HEAPF32[i1 + 196 >> 2]));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i1 + 200 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f26);
 i28 = i2 + 4 | 0;
 HEAPF32[i28 >> 2] = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f13);
 i6 = i2 + 8 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f17);
 f26 = Math_fround(f26 + Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i3 >> 2] = f26;
 i29 = i3 + 4 | 0;
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i29 >> 2]));
 HEAPF32[i29 >> 2] = f13;
 i3 = i3 + 8 | 0;
 f17 = Math_fround(f17 + Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i3 >> 2] = f17;
 f24 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f19);
 f23 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f15);
 f22 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f21);
 f27 = Math_fround(HEAPF32[i1 + 220 >> 2]);
 f24 = Math_fround(f24 * f27);
 f25 = Math_fround(HEAPF32[i1 + 224 >> 2]);
 f23 = Math_fround(f23 * f25);
 f8 = Math_fround(HEAPF32[i1 + 228 >> 2]);
 f22 = Math_fround(f22 * f8);
 f19 = Math_fround(f27 * Math_fround(f26 - f19));
 f15 = Math_fround(f25 * Math_fround(f13 - f15));
 f8 = Math_fround(Math_fround(f17 - f21) * f8);
 f21 = f24 <= f19 ? f24 : f19;
 f17 = f23 <= f15 ? f23 : f15;
 f13 = f22 <= f8 ? f22 : f8;
 HEAPF32[i20 >> 2] = f21;
 HEAPF32[i16 >> 2] = f17;
 HEAPF32[i11 >> 2] = f13;
 f19 = f24 >= f19 ? f24 : f19;
 f15 = f23 >= f15 ? f23 : f15;
 f8 = f22 >= f8 ? f22 : f8;
 HEAPF32[i18 >> 2] = f19;
 HEAPF32[i14 >> 2] = f15;
 HEAPF32[i9 >> 2] = f8;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i10 >> 2] = 2139095039;
 i3 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f21;
 i3 = HEAP32[(i3 ? i12 : i20) >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 i6 = f19 >= Math_fround(3402823469999999843913219.0e14);
 i6 = HEAP32[(i6 ? i10 : i18) >> 2] | 0;
 HEAP32[i10 >> 2] = i6;
 i3 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f17;
 i3 = HEAP32[(i3 ? i12 : i16) >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 i6 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= f15;
 i6 = HEAP32[(i6 ? i10 : i14) >> 2] | 0;
 HEAP32[i10 >> 2] = i6;
 i3 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f13;
 i3 = HEAP32[(i3 ? i12 : i11) >> 2] | 0;
 i6 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= f8;
 i6 = HEAP32[(i6 ? i10 : i9) >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i5 >> 2] = i6;
 f8 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = f8 <= (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13TrailRenderer19UpdateTransformInfoEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 56 | 0;
 i14 = i13 + 8 | 0;
 i6 = i13;
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i11 = i10 + 36 | 0;
 i7 = i3 + 32 | 0;
 i16 = i7;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z21CalculateGlobalMatrix23TransformAccessReadOnly(i14, i12);
 i6 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = HEAP32[i14 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 40 >> 2] = i6;
 HEAP32[i10 + 44 >> 2] = i1;
 HEAP32[i10 + 48 >> 2] = 0;
 i1 = HEAP32[i14 + 16 >> 2] | 0;
 i6 = HEAP32[i14 + 20 >> 2] | 0;
 HEAP32[i10 + 52 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i10 + 56 >> 2] = i1;
 HEAP32[i10 + 60 >> 2] = i6;
 HEAP32[i10 + 64 >> 2] = 0;
 i6 = HEAP32[i14 + 28 >> 2] | 0;
 i1 = HEAP32[i14 + 32 >> 2] | 0;
 HEAP32[i10 + 68 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i10 + 72 >> 2] = i6;
 HEAP32[i10 + 76 >> 2] = i1;
 HEAP32[i10 + 80 >> 2] = 0;
 i1 = HEAP32[i14 + 40 >> 2] | 0;
 i6 = HEAP32[i14 + 44 >> 2] | 0;
 HEAP32[i10 + 84 >> 2] = HEAP32[i14 + 36 >> 2];
 HEAP32[i10 + 88 >> 2] = i1;
 HEAP32[i10 + 92 >> 2] = i6;
 HEAP32[i10 + 96 >> 2] = 1065353216;
 i7 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i3 + 36 >> 2] | 0;
 i6 = HEAP32[i7 + 64 >> 2] | 0;
 i1 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 i3 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
 if ((i3 | 0) != -1) do {
  i16 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
  i1 = (i16 | i1) & -5 | (i16 ^ i1) & 4;
  i3 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
 } while ((i3 | 0) != -1);
 HEAP32[i10 + 212 >> 2] = ((i1 >>> 1 | -2) ^ 1) & i1;
 i1 = i10 + 164 | 0;
 f8 = Math_fround(HEAPF32[i10 + 360 >> 2]);
 f2 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f8 == f2) {
  f5 = Math_fround(HEAPF32[i10 + 364 >> 2]);
  if (f5 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f5 = Math_fround(HEAPF32[i10 + 368 >> 2]);
   if (!(f5 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2]))) i9 = 6;
  } else i9 = 6;
 } else i9 = 6;
 do if ((i9 | 0) == 6) {
  f2 = Math_fround(-f2);
  f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  f5 = Math_fround(HEAPF32[i10 + 372 >> 2]);
  if (f5 == f2) {
   f17 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f2 = Math_fround(HEAPF32[i10 + 376 >> 2]);
   if (f2 == f17) if (!(Math_fround(HEAPF32[i10 + 380 >> 2]) != f4)) break;
  } else f2 = Math_fround(HEAPF32[i10 + 376 >> 2]);
  f19 = Math_fround(f8 + f5);
  f20 = Math_fround(HEAPF32[i10 + 364 >> 2]);
  f18 = Math_fround(f20 + f2);
  f21 = Math_fround(HEAPF32[i10 + 368 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 380 >> 2]);
  f19 = Math_fround(f19 * Math_fround(.5));
  f17 = Math_fround(Math_fround(f4 - f21) * Math_fround(.5));
  f18 = Math_fround(f18 * Math_fround(.5));
  f4 = Math_fround(Math_fround(f21 + f4) * Math_fround(.5));
  f5 = Math_fround(Math_fround(f5 - f8) * Math_fround(.5));
  f8 = Math_fround(Math_fround(f2 - f20) * Math_fround(.5));
  i16 = i10 + 164 | 0;
  HEAPF32[i16 >> 2] = f19;
  i16 = i10 + 168 | 0;
  HEAPF32[i16 >> 2] = f18;
  i16 = i10 + 172 | 0;
  HEAPF32[i16 >> 2] = f4;
  i16 = i10 + 176 | 0;
  HEAPF32[i16 >> 2] = f5;
  i16 = i10 + 180 | 0;
  HEAPF32[i16 >> 2] = f8;
  i16 = i10 + 184 | 0;
  HEAPF32[i16 >> 2] = f17;
  __Z25InvertMatrix4x4_General3DPKfPf(i11, i12) | 0;
  i16 = i10 + 188 | 0;
  __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i1, i12, i16);
  STACKTOP = i13;
  return;
 } while (0);
 f19 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
 f20 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
 f8 = f19;
 f21 = f18;
 f17 = f20;
 i16 = i10 + 164 | 0;
 HEAPF32[i16 >> 2] = f8;
 i16 = i10 + 168 | 0;
 HEAPF32[i16 >> 2] = f17;
 i16 = i10 + 172 | 0;
 HEAPF32[i16 >> 2] = f18;
 i16 = i10 + 176 | 0;
 HEAPF32[i16 >> 2] = f19;
 i16 = i10 + 180 | 0;
 HEAPF32[i16 >> 2] = f20;
 i16 = i10 + 184 | 0;
 HEAPF32[i16 >> 2] = f21;
 __Z25InvertMatrix4x4_General3DPKfPf(i11, i12) | 0;
 i16 = i10 + 188 | 0;
 __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i1, i12, i16);
 STACKTOP = i13;
 return;
}

function __ZN18ComputeShaderParam8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1037646 | 0, gb + 469407 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15ShaderParamTypeEvRT_RT0_PKc17TransferMetaFlags(i9, i6 + 4 | 0, gb + 1047471 | 0, 0);
 i4 = i6 + 8 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 744923 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 469459 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 469469 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 34; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 34; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 469478 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 45; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 45; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 45) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function runPostSets216() {
 HEAP32[gb + 185316 >> 2] = fb + 36;
 HEAP32[gb + 185328 >> 2] = (HEAP32[gb + 185328 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 185332 >> 2] = (HEAP32[gb + 185332 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 185396 >> 2] = (HEAP32[gb + 185396 >> 2] | 0) + (gb + 1085890 | 0);
 HEAP32[gb + 185400 >> 2] = (HEAP32[gb + 185400 >> 2] | 0) + (gb + 1085953 | 0);
 HEAP32[gb + 185404 >> 2] = (HEAP32[gb + 185404 >> 2] | 0) + (gb + 945665 | 0);
 HEAP32[gb + 185408 >> 2] = (HEAP32[gb + 185408 >> 2] | 0) + (gb + 945671 | 0);
 HEAP32[gb + 185412 >> 2] = (HEAP32[gb + 185412 >> 2] | 0) + (gb + 945676 | 0);
 HEAP32[gb + 185416 >> 2] = (HEAP32[gb + 185416 >> 2] | 0) + (gb + 945685 | 0);
 HEAP32[gb + 185420 >> 2] = (HEAP32[gb + 185420 >> 2] | 0) + (gb + 1085989 | 0);
 HEAP32[gb + 185424 >> 2] = (HEAP32[gb + 185424 >> 2] | 0) + (gb + 1085998 | 0);
 HEAP32[gb + 185428 >> 2] = (HEAP32[gb + 185428 >> 2] | 0) + (gb + 1034504 | 0);
 HEAP32[gb + 185432 >> 2] = (HEAP32[gb + 185432 >> 2] | 0) + (gb + 1034510 | 0);
 HEAP32[gb + 185444 >> 2] = fb + 2812;
 HEAP32[gb + 185448 >> 2] = fb + 2813;
 HEAP32[gb + 185452 >> 2] = fb + 38;
 HEAP32[gb + 185456 >> 2] = fb + 145;
 HEAP32[gb + 185460 >> 2] = fb + 16;
 HEAP32[gb + 185464 >> 2] = fb + 93;
 HEAP32[gb + 185468 >> 2] = fb + 2814;
 HEAP32[gb + 185472 >> 2] = fb + 19;
 HEAP32[gb + 185476 >> 2] = fb + 1310;
 HEAP32[gb + 185480 >> 2] = fb + 103;
 HEAP32[gb + 185484 >> 2] = fb + 101;
 HEAP32[gb + 185488 >> 2] = fb + 62;
 HEAP32[gb + 185492 >> 2] = fb + 28;
 HEAP32[gb + 185496 >> 2] = fb + 63;
 HEAP32[gb + 185500 >> 2] = fb + 29;
 HEAP32[gb + 185504 >> 2] = fb + 34;
 HEAP32[gb + 185508 >> 2] = fb + 2141;
 HEAP32[gb + 185512 >> 2] = fb + 2142;
 HEAP32[gb + 185516 >> 2] = fb + 2143;
 HEAP32[gb + 185520 >> 2] = fb + 2144;
 HEAP32[gb + 185524 >> 2] = fb + 2145;
 HEAP32[gb + 185528 >> 2] = fb + 2146;
 HEAP32[gb + 185532 >> 2] = fb + 36;
 HEAP32[gb + 185536 >> 2] = fb + 104;
 HEAP32[gb + 185540 >> 2] = fb + 108;
 HEAP32[gb + 185544 >> 2] = fb + 94;
 HEAP32[gb + 185548 >> 2] = fb + 130;
 HEAP32[gb + 185552 >> 2] = fb + 112;
 HEAP32[gb + 185556 >> 2] = fb + 113;
 HEAP32[gb + 185560 >> 2] = fb + 131;
 HEAP32[gb + 185564 >> 2] = fb + 111;
 HEAP32[gb + 185568 >> 2] = fb + 112;
 HEAP32[gb + 185572 >> 2] = fb + 113;
 HEAP32[gb + 185576 >> 2] = fb + 215;
 HEAP32[gb + 185580 >> 2] = fb + 216;
 HEAP32[gb + 185584 >> 2] = fb + 463;
 HEAP32[gb + 185588 >> 2] = fb + 464;
 HEAP32[gb + 185600 >> 2] = (HEAP32[gb + 185600 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 185604 >> 2] = (HEAP32[gb + 185604 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 185640 >> 2] = fb + 2815;
 HEAP32[gb + 185644 >> 2] = fb + 2816;
 HEAP32[gb + 185648 >> 2] = fb + 2817;
 HEAP32[gb + 185652 >> 2] = fb + 2147;
 HEAP32[gb + 185656 >> 2] = fb + 16;
 HEAP32[gb + 185660 >> 2] = fb + 93;
 HEAP32[gb + 185664 >> 2] = fb + 2818;
 HEAP32[gb + 185668 >> 2] = fb + 19;
 HEAP32[gb + 185672 >> 2] = fb + 1311;
 HEAP32[gb + 185676 >> 2] = fb + 103;
 HEAP32[gb + 185680 >> 2] = fb + 101;
 HEAP32[gb + 185684 >> 2] = fb + 62;
 HEAP32[gb + 185688 >> 2] = fb + 28;
 HEAP32[gb + 185692 >> 2] = fb + 63;
 HEAP32[gb + 185696 >> 2] = fb + 29;
 HEAP32[gb + 185700 >> 2] = fb + 34;
 HEAP32[gb + 185704 >> 2] = fb + 2148;
 HEAP32[gb + 185708 >> 2] = fb + 2149;
 HEAP32[gb + 185712 >> 2] = fb + 2150;
 HEAP32[gb + 185716 >> 2] = fb + 2151;
 HEAP32[gb + 185720 >> 2] = fb + 2152;
 HEAP32[gb + 185724 >> 2] = fb + 2153;
 HEAP32[gb + 185728 >> 2] = fb + 36;
 HEAP32[gb + 185732 >> 2] = fb + 104;
 HEAP32[gb + 185736 >> 2] = fb + 108;
 HEAP32[gb + 185740 >> 2] = fb + 94;
 HEAP32[gb + 185744 >> 2] = fb + 109;
 HEAP32[gb + 185748 >> 2] = fb + 105;
 HEAP32[gb + 185752 >> 2] = fb + 106;
 HEAP32[gb + 185756 >> 2] = fb + 110;
 HEAP32[gb + 185836 >> 2] = fb + 1;
 HEAP32[gb + 185840 >> 2] = fb + 89;
 HEAP32[gb + 185844 >> 2] = fb + 123;
 HEAP32[gb + 185848 >> 2] = fb + 2819;
 HEAP32[gb + 185852 >> 2] = fb + 1;
 HEAP32[gb + 185856 >> 2] = (HEAP32[gb + 185856 >> 2] | 0) + (gb + 946844 | 0);
 HEAP32[gb + 185868 >> 2] = fb + 468;
 HEAP32[gb + 185872 >> 2] = fb + 2154;
 HEAP32[gb + 185876 >> 2] = fb + 124;
 HEAP32[gb + 186560 >> 2] = fb + 2820;
 HEAP32[gb + 186564 >> 2] = fb + 2821;
 HEAP32[gb + 186568 >> 2] = fb + 2822;
 HEAP32[gb + 186572 >> 2] = fb + 2155;
 HEAP32[gb + 186576 >> 2] = fb + 16;
 HEAP32[gb + 186580 >> 2] = fb + 2823;
 HEAP32[gb + 186584 >> 2] = fb + 40;
 HEAP32[gb + 186588 >> 2] = fb + 19;
 HEAP32[gb + 186592 >> 2] = fb + 1312;
 runPostSets217();
}

function __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 200 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN13GfxDeviceGLES11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns(i19, i20, i26, i27, i21, i22, i23, i24) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i25 = 0, i28 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28;
 if (!i23) {
  STACKTOP = i28;
  return;
 }
 i3 = (i22 | 0) > 0;
 if (i3) {
  i1 = 0;
  i2 = 0;
  do {
   i18 = HEAP32[i21 + (i2 << 5) + 20 >> 2] | 0;
   i1 = i18 >>> 0 > i1 >>> 0 ? i18 : i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i22 | 0));
 } else i1 = 0;
 i18 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 698 >> 0] | 0) != 0;
 if (i18) __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj(i24, i23, i26, 0, i27, i1);
 mftCall_vi(HEAP32[(HEAP32[i19 >> 2] | 0) + 608 >> 2] | 0, i19 | 0);
 L11 : do if (i3) {
  i8 = i19 + 7060 | 0;
  i9 = (i20 | 0) != 0;
  i10 = i19 + 4620 | 0;
  i11 = i20 + 28 | 0;
  i12 = i19 + 3896 | 0;
  i13 = i19 + 3644 | 0;
  i14 = i19 + 3648 | 0;
  i15 = i19 + 3656 | 0;
  i16 = i19 + 3652 | 0;
  i17 = i19 + 3640 | 0;
  i7 = 0;
  i3 = -1;
  while (1) {
   i4 = i21 + (i7 << 5) + 12 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!(i18 | (i3 | 0) == (i2 | 0))) {
    __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj(i24, i23, i26, i2, i27, i1);
    i2 = 0;
    i3 = HEAP32[i4 >> 2] | 0;
   }
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = i21 + (i7 << 5) | 0;
   if (HEAP8[i4 + 83 >> 0] | 0) if ((HEAP32[i4 + 92 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
    HEAP32[i25 >> 2] = 0;
    HEAP32[i25 + 4 >> 2] = 0;
    HEAP32[i25 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i25, gb + 604241 | 0, 93);
    __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i25, 256, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i25);
   }
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 701 >> 0] | 0) if ((HEAP32[i5 >> 2] | 0) == 5) __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i10, 16);
   if (i9) {
    __ZN7ApiGLES22BindElementArrayBufferEj(i10, HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0);
    __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj(i10, HEAP32[i5 >> 2] | 0, HEAP32[i21 + (i7 << 5) + 4 >> 2] | 0, HEAP32[i21 + (i7 << 5) + 8 >> 2] | 0, i2, HEAP32[i21 + (i7 << 5) + 24 >> 2] | 0);
   } else __ZN7ApiGLES10DrawArraysE16GfxPrimitiveTypejjj(i10, HEAP32[i5 >> 2] | 0, HEAP32[i21 + (i7 << 5) + 16 >> 2] | 0, HEAP32[i21 + (i7 << 5) + 20 >> 2] | 0, HEAP32[i21 + (i7 << 5) + 24 >> 2] | 0);
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 701 >> 0] | 0) if ((HEAP32[i5 >> 2] | 0) == 5) __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i10, 16);
   i4 = HEAP32[i21 + (i7 << 5) + 24 >> 2] | 0;
   i4 = (i4 | 0) == 0 ? 1 : i4;
   i6 = i21 + (i7 << 5) + 20 | 0;
   i2 = HEAP32[(i9 ? i21 + (i7 << 5) + 8 | 0 : i6) >> 2] | 0;
   switch (HEAP32[i5 >> 2] | 0) {
   case 0:
    {
     i2 = (i2 | 0) / 3 | 0;
     break;
    }
   case 1:
    {
     i2 = i2 + -2 | 0;
     break;
    }
   case 2:
    {
     i2 = ((i2 | 0) / 4 | 0) << 1;
     break;
    }
   case 3:
    {
     i2 = (i2 | 0) / 2 | 0;
     break;
    }
   case 4:
    {
     i2 = i2 + -1 | 0;
     break;
    }
   case 5:
    break;
   default:
    i2 = 0;
   }
   i2 = Math_imul(i2, i4) | 0;
   if (HEAP8[i12 >> 0] | 0) {
    i6 = Math_imul(HEAP32[i6 >> 2] | 0, i4) | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i2;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i6;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i2;
    if ((i7 | 0) <= 0) HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
   }
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i22 | 0)) break L11;
  }
 } while (0);
 if (i20 | 0) __ZN14DataBufferGLES12RecordRenderEv(HEAP32[i20 + 28 >> 2] | 0);
 __ZN19ConstantBuffersGLES12RecordRenderEv(i19 + 6624 | 0);
 if ((i27 | 0) > 0) i1 = 0; else {
  STACKTOP = i28;
  return;
 }
 do {
  i2 = HEAP32[i26 + (i1 << 3) >> 2] | 0;
  if (i2 | 0) __ZN14DataBufferGLES12RecordRenderEv(HEAP32[i2 + 28 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 STACKTOP = i28;
 return;
}

function _unzReadCurrentFile(i13, i1, i4) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 if (!i13) {
  i16 = -102;
  return i16 | 0;
 }
 i16 = HEAP32[i13 + 156 >> 2] | 0;
 if (!i16) {
  i16 = -102;
  return i16 | 0;
 }
 if (!(HEAP32[i16 >> 2] | 0)) {
  i16 = -100;
  return i16 | 0;
 }
 if (!i4) {
  i16 = 0;
  return i16 | 0;
 }
 i14 = i16 + 4 | 0;
 i15 = i16 + 16 | 0;
 HEAP32[i15 >> 2] = i1;
 i11 = i16 + 20 | 0;
 HEAP32[i11 >> 2] = i4;
 i12 = i16 + 92 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 >>> 0 < i4 >>> 0) if (!(HEAP32[i16 + 140 >> 2] | 0)) {
  HEAP32[i11 >> 2] = i1;
  i2 = i1;
 } else i2 = i4; else i2 = i4;
 i9 = i16 + 88 | 0;
 i10 = i16 + 8 | 0;
 i3 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
 if (i3 >>> 0 < i4 >>> 0) if (!(HEAP32[i16 + 140 >> 2] | 0)) {
  i1 = 0;
  i5 = 11;
 } else {
  HEAP32[i11 >> 2] = i3;
  i1 = 0;
  i2 = i3;
 } else {
  i1 = 0;
  i5 = 11;
 }
 L20 : while (1) {
  if (!i2) {
   i2 = 0;
   i5 = 33;
   break;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i2 = i2 >>> 0 < 16384 ? i2 : 16384;
    if (!i2) {
     i1 = 0;
     i5 = 34;
     break;
    }
    i3 = i16 + 124 | 0;
    i4 = i16 + 128 | 0;
    i8 = i16 + 60 | 0;
    if (mftCall_iiiii(HEAP32[i16 + 112 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i16 + 136 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0, 0) | 0) {
     i1 = -1;
     i5 = 34;
     break;
    }
    if ((mftCall_iiiii(HEAP32[i16 + 100 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i16 >> 2] | 0, i2 | 0) | 0) != (i2 | 0)) {
     i1 = -1;
     i5 = 34;
     break;
    }
    if (HEAP32[i13 + 160 >> 2] | 0) {
     i5 = i13 + 164 | 0;
     i6 = i13 + 176 | 0;
     i4 = i13 + 172 | 0;
     i7 = i13 + 168 | 0;
     i3 = 0;
     do {
      i20 = HEAP32[i6 >> 2] | 0;
      i17 = HEAP32[i4 >> 2] & 65533;
      i17 = (Math_imul(i17 | 2, i17 ^ 3) | 0) >>> 8 & 255;
      i19 = (HEAP32[i16 >> 2] | 0) + i3 | 0;
      i17 = i17 ^ (HEAPU8[i19 >> 0] | 0);
      HEAP8[i19 >> 0] = i17;
      i17 = i17 << 24 >> 24;
      i19 = HEAP32[i5 >> 2] | 0;
      i19 = HEAP32[i20 + (((i17 ^ i19) & 255) << 2) >> 2] ^ i19 >>> 8;
      HEAP32[i5 >> 2] = i19;
      i19 = (Math_imul((HEAP32[i7 >> 2] | 0) + (i19 & 255) | 0, 134775813) | 0) + 1 | 0;
      HEAP32[i7 >> 2] = i19;
      i18 = HEAP32[i4 >> 2] | 0;
      HEAP32[i4 >> 2] = HEAP32[i20 + ((i19 >>> 24 ^ i18 & 255) << 2) >> 2] ^ i18 >>> 8;
      HEAP8[(HEAP32[i16 >> 2] | 0) + i3 >> 0] = i17;
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
    }
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i2;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i2;
    HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i10 >> 2] = i2;
   }
  }
  if (HEAP32[i16 + 132 >> 2] | 0) if (!(HEAP32[i16 + 140 >> 2] | 0)) {
   i3 = i16 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i15 >> 2] | 0;
   i2 = _unity_z_inflate(i14, 2) | 0;
   if ((i2 | 0) > -1) i2 = (HEAP32[i16 + 28 >> 2] | 0) == 0 ? i2 : -3;
   i20 = (HEAP32[i3 >> 2] | 0) - i4 | 0;
   i19 = i16 + 80 | 0;
   HEAP32[i19 >> 2] = _unity_z_crc32(HEAP32[i19 >> 2] | 0, i5, i20) | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) - i20;
   i1 = i20 + i1 | 0;
   switch (i2 | 0) {
   case 1:
    {
     i5 = 34;
     break L20;
    }
   case 0:
    break;
   default:
    {
     i5 = 33;
     break L20;
    }
   }
   i2 = HEAP32[i11 >> 2] | 0;
   i5 = 11;
   continue;
  }
  if (!i2) if (!(HEAP32[i9 >> 2] | 0)) {
   i5 = 34;
   break;
  }
  i3 = HEAP32[i11 >> 2] | 0;
  i3 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
  if (i3 | 0) {
   i2 = 0;
   do {
    HEAP8[(HEAP32[i15 >> 2] | 0) + i2 >> 0] = HEAP8[(HEAP32[i14 >> 2] | 0) + i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
  }
  i2 = i16 + 80 | 0;
  HEAP32[i2 >> 2] = _unity_z_crc32(HEAP32[i2 >> 2] | 0, HEAP32[i15 >> 2] | 0, i3) | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) - i3;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) - i3;
  i2 = (HEAP32[i11 >> 2] | 0) - i3 | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i3;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i3;
  i5 = i16 + 24 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
  i1 = i3 + i1 | 0;
  i5 = 11;
 }
 if ((i5 | 0) == 33) {
  i20 = (i2 | 0) == 0 ? i1 : i2;
  return i20 | 0;
 } else if ((i5 | 0) == 34) return i1 | 0;
 return 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 64 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN8Animator9WriteStepEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 4 | 0;
 i3 = i15;
 i4 = i14 + 140 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[i1 + 54 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 if ((HEAP16[gb + 1466872 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466872 | 0, i2);
  i12 = gb + 1466872 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i12 = 0;
 HEAP8[i1 + 54 >> 0] = 0;
 i11 = i14 + 124 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 if (!(HEAP8[i14 + 561 >> 0] | 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1 + i8 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i4 = (i1 | 0) == 0 ? 0 : i2;
   i3 = i8 + 4 | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i3 = (i9 | 0) == 0 ? 0 : i9 + i3 | 0;
   i9 = i14 + 132 | 0;
   i7 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i10 = i14 + 168 | 0;
   i6 = HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0) + 8 >> 2] | 0;
   i7 = HEAP32[i7 + 8 >> 2] | 0;
   i1 = i8 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i1 = 0; else {
    i2 = i2 + i1 + 40 | 0;
    if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) i1 = 0; else {
     i8 = i8 + 36 | 0;
     i1 = HEAP32[i8 >> 2] | 0;
     i1 = (i1 | 0) == 0 ? 0 : i8 + i1 | 0;
    }
   }
   __ZN7mecanim9animation21SkeletonPoseFromValueIN4math4trsXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTIS3_EERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib(i4, i3, i5, i6, i7, i1, 1);
   i1 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i13 = 16; else {
    i8 = i1 + i2 + 40 | 0;
    if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + i8 >> 2] | 0)) i13 = 16; else {
     i3 = HEAP32[i9 >> 2] | 0;
     i1 = i14 + 136 | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   if ((i13 | 0) == 16) {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    i7 = i3 + 4 | 0;
    i7 = i7 + (HEAP32[i7 >> 2] | 0) | 0;
    i13 = i7;
    i1 = i14 + 136 | 0;
    i6 = HEAP32[i1 >> 2] | 0;
    i8 = HEAP32[i6 + 4 >> 2] | 0;
    i5 = HEAP32[i6 + 8 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i13 + 4 >> 2] = i8;
    HEAP32[i13 + 8 >> 2] = i5;
    i5 = HEAP32[i6 + 16 >> 2] | 0;
    i8 = HEAP32[i6 + 20 >> 2] | 0;
    i7 = HEAP32[i6 + 24 >> 2] | 0;
    HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i13 + 16 >> 2] = i5;
    HEAP32[i13 + 20 >> 2] = i8;
    HEAP32[i13 + 24 >> 2] = i7;
    i7 = HEAP32[i6 + 32 >> 2] | 0;
    i8 = HEAP32[i6 + 36 >> 2] | 0;
    HEAP32[i13 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
    HEAP32[i13 + 32 >> 2] = i7;
    HEAP32[i13 + 36 >> 2] = i8;
   }
   __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EE(i3, HEAP32[i2 + 12 >> 2] | 0);
   i11 = HEAP32[i11 >> 2] | 0;
   i8 = HEAP32[i11 >> 2] | 0;
   i13 = HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0;
   __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i8 | 0) == 0 ? 0 : i8 + i11 | 0, i13, i13);
   i13 = HEAP32[i9 >> 2] | 0;
   __Z28SetExposedSkeletonTransformsRKN11UnityEngine9Animation30AnimatorGenericBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNS6_INS7_7affineXEEERNS0_21AvatarBindingConstantE(HEAP32[i10 >> 2] | 0, HEAP32[i13 + 8 >> 2] | 0, HEAP32[i13 + 12 >> 2] | 0, HEAP32[i14 + 144 >> 2] | 0);
   HEAP8[(HEAP32[i1 >> 2] | 0) + 137 >> 0] = 1;
  }
 } else {
  i1 = i8 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i13 = i2 + i1 + 40 | 0;
   if (HEAP32[(HEAP32[i13 >> 2] | 0) + i13 >> 2] | 0) __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb(HEAP32[i14 + 144 >> 2] | 0, HEAP32[(HEAP32[i14 + 132 >> 2] | 0) + 8 >> 2] | 0, 1);
  }
  i11 = HEAP32[i14 + 168 >> 2] | 0;
  i13 = HEAP32[HEAP32[i14 + 132 >> 2] >> 2] | 0;
  __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform(i11, i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i14 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 }
 if (!i12) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i15;
 return;
}

function __ZN6prcoreL27StretchGenericFloatBilinearI14TexFormatRHalfEEvPKNS_9InnerInfoE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0;
 f15 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f16 = Math_fround(Math_fround(1.0) - f15);
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i18 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i14 = i1 + 20 | 0;
 i13 = HEAP32[i1 + 16 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 while (1) {
  i6 = i13 >>> 16;
  f10 = Math_fround(Math_fround((i13 & 65535) >>> 0) * Math_fround(.0000152587891));
  f11 = Math_fround(Math_fround(1.0) - f10);
  i8 = i6 + 1 | 0;
  i4 = HEAPU16[i17 + (i6 << 1) >> 1] | 0;
  i1 = i4 & 32767;
  L6 : do if (!i1) i1 = 0; else {
   i1 = i1 << 13;
   i3 = i1 & 260046848;
   L8 : do if ((i3 | 0) < 260046848) {
    switch (i3 | 0) {
    case 0:
     break;
    default:
     break L8;
    }
    f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
    break L6;
   } else {
    switch (i3 | 0) {
    case 260046848:
     break;
    default:
     break L8;
    }
    i1 = i1 | 1879048192;
    break L6;
   } while (0);
   i1 = i1 + 939524096 | 0;
  } while (0);
  f9 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = HEAPU16[i17 + (i8 << 1) >> 1] | 0;
  i1 = i4 & 32767;
  L15 : do if (!i1) i1 = 0; else {
   i1 = i1 << 13;
   i3 = i1 & 260046848;
   L17 : do if ((i3 | 0) < 260046848) {
    switch (i3 | 0) {
    case 0:
     break;
    default:
     break L17;
    }
    f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
    break L15;
   } else {
    switch (i3 | 0) {
    case 260046848:
     break;
    default:
     break L17;
    }
    i1 = i1 | 1879048192;
    break L15;
   } while (0);
   i1 = i1 + 939524096 | 0;
  } while (0);
  f7 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = HEAPU16[i18 + (i6 << 1) >> 1] | 0;
  i1 = i4 & 32767;
  L24 : do if (!i1) i1 = 0; else {
   i1 = i1 << 13;
   i3 = i1 & 260046848;
   L26 : do if ((i3 | 0) < 260046848) {
    switch (i3 | 0) {
    case 0:
     break;
    default:
     break L26;
    }
    f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    break L24;
   } else {
    switch (i3 | 0) {
    case 260046848:
     break;
    default:
     break L26;
    }
    i1 = i1 | 1879048192;
    break L24;
   } while (0);
   i1 = i1 + 939524096 | 0;
  } while (0);
  f5 = (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i4 = HEAPU16[i18 + (i8 << 1) >> 1] | 0;
  i1 = i4 & 32767;
  L33 : do if (!i1) i1 = 0; else {
   i1 = i1 << 13;
   i3 = i1 & 260046848;
   L35 : do if ((i3 | 0) < 260046848) {
    switch (i3 | 0) {
    case 0:
     break;
    default:
     break L35;
    }
    f19 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    break L33;
   } else {
    switch (i3 | 0) {
    case 260046848:
     break;
    default:
     break L35;
    }
    i1 = i1 | 1879048192;
    break L33;
   } while (0);
   i1 = i1 + 939524096 | 0;
  } while (0);
  f19 = Math_fround(Math_fround(f16 * Math_fround(Math_fround(f11 * f9) + Math_fround(f10 * f7))) + Math_fround(f15 * Math_fround(Math_fround(f11 * f5) + Math_fround(f10 * (HEAP32[tempDoublePtr >> 2] = i1 | i4 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]))))));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = i6 >>> 23 & 255;
  HEAP16[i12 >> 1] = i6 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i8 << 1) >> 1] | 0) | (i6 & 8388607) >>> (HEAPU8[gb + 1546331 + i8 >> 0] | 0);
  i2 = i2 + -1 | 0;
  if (!i2) break; else {
   i13 = (HEAP32[i14 >> 2] | 0) + i13 | 0;
   i12 = i12 + 2 | 0;
  }
 }
 return;
}

function __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(i12, i10, i11) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i5 = HEAP32[i12 + 132 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i14 = 4; else {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i14 = 4; else HEAP32[i5 >> 2] = i2;
 }
 if ((i14 | 0) == 4) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i13 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i14 = 0;
   return i14 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   i2 = i2 - i3 | 0;
   i13 = i1;
   i1 = i4 + i2 | 0;
   HEAP32[i1 >> 2] = i13;
  } while ((i2 | 0) != 4);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  if (!i1) {
   i14 = 0;
   return i14 | 0;
  }
 }
 i9 = i1 + 32 | 0;
 i7 = i10 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = i8 >>> 0 < i10 >>> 0 ? i8 : i10;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP32[HEAP32[i4 + 4 >> 2] >> 2] = i1;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i1 + 4 >> 2] = i9;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i1 + 12 >> 2] = i9;
 i8 = i1 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = i1;
 HEAP32[i1 + 40 >> 2] = i9;
 HEAP32[i1 + 44 >> 2] = i1;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i4 = HEAP32[i11 + 20 >> 2] | 0;
 i13 = i10 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) {
  i5 = 0;
  i4 = i6;
  i3 = i1;
 } else {
  i5 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = i5;
  do {
   HEAP32[i3 + 20 >> 2] = i2;
   i3 = HEAP32[i3 + 12 >> 2] | 0;
  } while ((i3 | 0) != (i5 | 0));
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i5 >> 2] = i3;
  i5 = HEAP32[i12 + 140 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i4;
  i5 = 1;
  i4 = i6;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i15 = HEAP32[i10 + 12 >> 2] | 0;
 i6 = i15 + 8 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i15;
 HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i1;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i6 >> 2] = i3;
 i4 = i1 + 40 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i10 = i11 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 12 >> 2] = i11;
 HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i9;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i1 + 52 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i9;
 if (i5) {
  i15 = i1;
  return i15 | 0;
 }
 i6 = HEAP32[i12 + 140 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) i14 = 17; else {
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) i14 = 17; else HEAP32[i6 >> 2] = i4;
 }
 do if ((i14 | 0) == 17) {
  i2 = i6 + 8 | 0;
  i3 = i6 + 12 | 0;
  i5 = (Math_imul(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) + 4 | 0;
  i15 = HEAP32[i6 + 20 >> 2] | 0;
  i5 = mftCall_iii(HEAP32[i15 >> 2] | 0, HEAP32[i15 + 12 >> 2] | 0, i5 | 0) | 0;
  if (!i5) {
   i15 = 0;
   return i15 | 0;
  }
  i4 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i5;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i3 >> 2] | 0, i4) | 0) + 4 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = i2 - i4 | 0;
   i15 = i3;
   i3 = i5 + i2 | 0;
   HEAP32[i3 >> 2] = i15;
  } while ((i2 | 0) != 4);
  HEAP32[i6 >> 2] = i3;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  if (!i3) {
   i15 = 0;
   return i15 | 0;
  } else {
   i2 = HEAP32[i13 >> 2] | 0;
   break;
  }
 } while (0);
 i15 = i2 + 4 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i14;
 HEAP32[i14 >> 2] = i3;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 20 >> 0] = 0;
 HEAP8[i3 + 21 >> 0] = HEAP8[i2 + 21 >> 0] | 0;
 i2 = i1;
 do {
  HEAP32[i2 + 20 >> 2] = i3;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i1 | 0;
}

function runPostSets204() {
 HEAP32[gb + 171760 >> 2] = fb + 29;
 HEAP32[gb + 171764 >> 2] = fb + 34;
 HEAP32[gb + 171768 >> 2] = fb + 1980;
 HEAP32[gb + 171772 >> 2] = fb + 1981;
 HEAP32[gb + 171776 >> 2] = fb + 1982;
 HEAP32[gb + 171780 >> 2] = fb + 1983;
 HEAP32[gb + 171784 >> 2] = fb + 1984;
 HEAP32[gb + 171788 >> 2] = fb + 1985;
 HEAP32[gb + 171792 >> 2] = fb + 36;
 HEAP32[gb + 171796 >> 2] = fb + 96;
 HEAP32[gb + 171800 >> 2] = fb + 81;
 HEAP32[gb + 171804 >> 2] = fb + 82;
 HEAP32[gb + 171816 >> 2] = (HEAP32[gb + 171816 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171820 >> 2] = (HEAP32[gb + 171820 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 174096 >> 2] = (HEAP32[gb + 174096 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 174100 >> 2] = (HEAP32[gb + 174100 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 174136 >> 2] = (HEAP32[gb + 174136 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 174140 >> 2] = (HEAP32[gb + 174140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 174176 >> 2] = fb + 2663;
 HEAP32[gb + 174180 >> 2] = fb + 2664;
 HEAP32[gb + 174184 >> 2] = fb + 2665;
 HEAP32[gb + 174188 >> 2] = fb + 1986;
 HEAP32[gb + 174192 >> 2] = fb + 16;
 HEAP32[gb + 174196 >> 2] = fb + 2666;
 HEAP32[gb + 174200 >> 2] = fb + 2667;
 HEAP32[gb + 174204 >> 2] = fb + 19;
 HEAP32[gb + 174208 >> 2] = fb + 1235;
 HEAP32[gb + 174212 >> 2] = fb + 31;
 HEAP32[gb + 174216 >> 2] = fb + 27;
 HEAP32[gb + 174220 >> 2] = fb + 62;
 HEAP32[gb + 174224 >> 2] = fb + 28;
 HEAP32[gb + 174228 >> 2] = fb + 63;
 HEAP32[gb + 174232 >> 2] = fb + 29;
 HEAP32[gb + 174236 >> 2] = fb + 34;
 HEAP32[gb + 174240 >> 2] = fb + 1987;
 HEAP32[gb + 174244 >> 2] = fb + 1988;
 HEAP32[gb + 174248 >> 2] = fb + 1989;
 HEAP32[gb + 174252 >> 2] = fb + 1990;
 HEAP32[gb + 174256 >> 2] = fb + 1991;
 HEAP32[gb + 174260 >> 2] = fb + 1992;
 HEAP32[gb + 174264 >> 2] = fb + 36;
 HEAP32[gb + 174268 >> 2] = fb + 1993;
 HEAP32[gb + 174272 >> 2] = fb + 2;
 HEAP32[gb + 174276 >> 2] = fb + 433;
 HEAP32[gb + 174280 >> 2] = fb + 1236;
 HEAP32[gb + 174284 >> 2] = fb + 2668;
 HEAP32[gb + 174288 >> 2] = fb + 1237;
 HEAP32[gb + 174292 >> 2] = fb + 2669;
 HEAP32[gb + 174296 >> 2] = fb + 2670;
 HEAP32[gb + 174300 >> 2] = fb + 2671;
 HEAP32[gb + 174304 >> 2] = fb + 1238;
 HEAP32[gb + 174340 >> 2] = (HEAP32[gb + 174340 >> 2] | 0) + (gb + 862576 | 0);
 HEAP32[gb + 174396 >> 2] = (HEAP32[gb + 174396 >> 2] | 0) + (gb + 862627 | 0);
 HEAP32[gb + 174452 >> 2] = (HEAP32[gb + 174452 >> 2] | 0) + (gb + 862641 | 0);
 HEAP32[gb + 174508 >> 2] = (HEAP32[gb + 174508 >> 2] | 0) + (gb + 862682 | 0);
 HEAP32[gb + 174564 >> 2] = (HEAP32[gb + 174564 >> 2] | 0) + (gb + 862724 | 0);
 HEAP32[gb + 174620 >> 2] = (HEAP32[gb + 174620 >> 2] | 0) + (gb + 862737 | 0);
 HEAP32[gb + 174676 >> 2] = (HEAP32[gb + 174676 >> 2] | 0) + (gb + 862773 | 0);
 HEAP32[gb + 174708 >> 2] = fb + 2672;
 HEAP32[gb + 174712 >> 2] = fb + 2673;
 HEAP32[gb + 174716 >> 2] = fb + 38;
 HEAP32[gb + 174720 >> 2] = fb + 1994;
 HEAP32[gb + 174724 >> 2] = fb + 16;
 HEAP32[gb + 174728 >> 2] = fb + 39;
 HEAP32[gb + 174732 >> 2] = fb + 40;
 HEAP32[gb + 174736 >> 2] = fb + 19;
 HEAP32[gb + 174740 >> 2] = fb + 1239;
 HEAP32[gb + 174744 >> 2] = fb + 31;
 HEAP32[gb + 174748 >> 2] = fb + 27;
 HEAP32[gb + 174752 >> 2] = fb + 62;
 HEAP32[gb + 174756 >> 2] = fb + 28;
 HEAP32[gb + 174760 >> 2] = fb + 63;
 HEAP32[gb + 174764 >> 2] = fb + 29;
 HEAP32[gb + 174768 >> 2] = fb + 34;
 HEAP32[gb + 174772 >> 2] = fb + 1995;
 HEAP32[gb + 174776 >> 2] = fb + 1996;
 HEAP32[gb + 174780 >> 2] = fb + 1997;
 HEAP32[gb + 174784 >> 2] = fb + 1998;
 HEAP32[gb + 174788 >> 2] = fb + 1999;
 HEAP32[gb + 174792 >> 2] = fb + 2e3;
 HEAP32[gb + 174796 >> 2] = fb + 36;
 HEAP32[gb + 174808 >> 2] = (HEAP32[gb + 174808 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 174812 >> 2] = (HEAP32[gb + 174812 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 174848 >> 2] = fb + 2674;
 HEAP32[gb + 174852 >> 2] = fb + 2675;
 HEAP32[gb + 174856 >> 2] = fb + 38;
 HEAP32[gb + 174860 >> 2] = fb + 2001;
 HEAP32[gb + 174864 >> 2] = fb + 16;
 HEAP32[gb + 174868 >> 2] = fb + 39;
 HEAP32[gb + 174872 >> 2] = fb + 40;
 HEAP32[gb + 174876 >> 2] = fb + 19;
 HEAP32[gb + 174880 >> 2] = fb + 1240;
 HEAP32[gb + 174884 >> 2] = fb + 31;
 HEAP32[gb + 174888 >> 2] = fb + 27;
 HEAP32[gb + 174892 >> 2] = fb + 62;
 HEAP32[gb + 174896 >> 2] = fb + 28;
 HEAP32[gb + 174900 >> 2] = fb + 63;
 HEAP32[gb + 174904 >> 2] = fb + 29;
 HEAP32[gb + 174908 >> 2] = fb + 34;
 HEAP32[gb + 174912 >> 2] = fb + 2002;
 runPostSets205();
}

function __ZN5physx10PxsContext21destroyContactManagerEPNS_17PxsContactManagerE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = i10 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  do if (!(i1 & 1)) {
   if (HEAP8[i10 + 112 >> 0] | 0) if (HEAP8[i10 + 113 >> 0] | 0) {
    i9 = i11 + 1020 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
    i9 = i11 + 1032 | 0;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i1;
    i1 = i11 + 1024 | 0;
    i9 = HEAP32[i1 >> 2] | 0;
    HEAP32[i1 >> 2] = i9 + 1;
    if ((i9 | 0) < ((HEAP32[i11 + 1016 >> 2] | 0) * 50 | 0)) break;
    __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i11 + 740 | 0);
    HEAP32[i1 >> 2] = 0;
    break;
   }
   i9 = i11 + 1316 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   i9 = i11 + 1328 | 0;
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i1;
   i1 = i11 + 1320 | 0;
   i9 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i9 + 1;
   if ((i9 | 0) >= ((HEAP32[i11 + 1312 >> 2] | 0) * 50 | 0)) {
    __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i11 + 1036 | 0);
    HEAP32[i1 >> 2] = 0;
   }
  } while (0);
  HEAP32[i2 >> 2] = 0;
 }
 i8 = i10 + 76 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i11 + 1332 | 0;
 i9 = (i6 + 32 | 0) >>> 5;
 i3 = i11 + 1336 | 0;
 if (i9 >>> 0 > (HEAP32[i3 >> 2] & 2147483647) >>> 0) {
  i4 = i11 + 1340 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i9 << 2, gb + 769739 | 0, 329) | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if (i5 | 0) {
   _memcpy(i1 | 0, i5 | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i2 >> 2] | 0);
  }
  i7 = HEAP32[i3 >> 2] | 0;
  _memset(i1 + ((i7 & 2147483647) << 2) | 0, 0, i9 - i7 << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i9;
 } else i1 = HEAP32[i2 >> 2] | 0;
 i7 = ~(1 << (i6 & 31));
 i6 = i6 >>> 5;
 i2 = i1 + (i6 << 2) | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & i7;
 i2 = i11 + 5840 | 0;
 i3 = i11 + 5844 | 0;
 if (i9 >>> 0 > (HEAP32[i3 >> 2] & 2147483647) >>> 0) {
  i4 = i11 + 5848 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i9 << 2, gb + 769739 | 0, 329) | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if (i5 | 0) {
   _memcpy(i1 | 0, i5 | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i2 >> 2] | 0);
  }
  i5 = HEAP32[i3 >> 2] | 0;
  _memset(i1 + ((i5 & 2147483647) << 2) | 0, 0, i9 - i5 << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i9;
 } else i1 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & i7;
 i4 = i11 + 1344 | 0;
 i5 = i11 + 1348 | 0;
 if (i9 >>> 0 <= (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i9 = HEAP32[i4 >> 2] | 0;
  i9 = i9 + (i6 << 2) | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i7 = i6 & i7;
  HEAP32[i9 >> 2] = i7;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i8 & 31;
  i9 = 1 << i9;
  i9 = ~i9;
  i8 = i8 >>> 5;
  i7 = i11 + 728 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = i7 + (i8 << 2) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i9 = i7 & i9;
  HEAP32[i8 >> 2] = i9;
  i8 = i11 + 716 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i7 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  i11 = i11 + 712 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i9 << 2) | 0;
  HEAP32[i11 >> 2] = i10;
  return;
 }
 i1 = i11 + 1352 | 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i9 << 2, gb + 769739 | 0, 329) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 | 0) {
  _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i4 >> 2] | 0);
 }
 i3 = HEAP32[i5 >> 2] | 0;
 _memset(i2 + ((i3 & 2147483647) << 2) | 0, 0, i9 - i3 << 2 | 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i5 >> 2] = i9;
 i9 = i2;
 i9 = i9 + (i6 << 2) | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i7 = i6 & i7;
 HEAP32[i9 >> 2] = i7;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i8 & 31;
 i9 = 1 << i9;
 i9 = ~i9;
 i8 = i8 >>> 5;
 i7 = i11 + 728 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i7 + (i8 << 2) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i9 = i7 & i9;
 HEAP32[i8 >> 2] = i9;
 i8 = i11 + 716 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i7 = i9 + 1 | 0;
 HEAP32[i8 >> 2] = i7;
 i11 = i11 + 712 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i11 = i11 + (i9 << 2) | 0;
 HEAP32[i11 >> 2] = i10;
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i14, i1, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 20 | 0;
 i12 = i17 + 16 | 0;
 i10 = i17 + 12 | 0;
 i11 = i17 + 8 | 0;
 i6 = i17 + 4 | 0;
 i7 = i17;
 i5 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = (i9 - i5 | 0) / 36 | 0;
 i3 = i14 + 8 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i2 = i5;
 i1 = i4;
 if (i8 >>> 0 > (((HEAP32[i3 >> 2] | 0) - i4 | 0) / 36 | 0) >>> 0) {
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE10deallocateEv(i14);
  if (i8 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i16 = ((HEAP32[i3 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0) / 36 | 0;
  i1 = i16 << 1;
  i1 = i16 >>> 0 < 59652323 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 119304647;
  if (i1 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i16 = __Znwj(i1 * 36 | 0) | 0;
  HEAP32[i14 + 4 >> 2] = i16;
  HEAP32[i14 >> 2] = i16;
  HEAP32[i3 >> 2] = i16 + (i1 * 36 | 0);
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i14, i12, i13, i8);
  STACKTOP = i17;
  return;
 }
 i16 = i14 + 4 | 0;
 i4 = ((HEAP32[i16 >> 2] | 0) - i4 | 0) / 36 | 0;
 i5 = i8 >>> 0 > i4 >>> 0;
 i4 = i5 ? i2 + (i4 * 36 | 0) | 0 : i9;
 i3 = i4;
 if ((i2 | 0) == (i3 | 0)) i15 = i1; else {
  do {
   i6 = i2;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i15 = i1;
   HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i15 + 4 >> 2] = i7;
   if ((i1 | 0) != (i2 | 0)) {
    __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
    __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 20 | 0, HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0);
   }
   HEAP8[i1 + 32 >> 0] = HEAP8[i2 + 32 >> 0] | 0;
   i2 = i2 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i15 = i1;
 }
 if (i5) {
  HEAP32[i10 >> 2] = i4;
  HEAP32[i11 >> 2] = i9;
  i16 = i8 - (((HEAP32[i16 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0) / 36 | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i14, i12, i13, i16);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i17;
  return;
 }
 do {
  HEAP32[i16 >> 2] = i1 + -36;
  i7 = i1 + -16 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (i2 | 0) {
   i8 = i1 + -12 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    do {
     i4 = i3 + -20 | 0;
     HEAP32[i8 >> 2] = i4;
     i5 = HEAP32[i3 + -12 >> 2] | 0;
     i6 = i5;
     if (!i5) i3 = i4; else {
      i3 = i3 + -8 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i6 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i5);
      i3 = HEAP32[i8 >> 2] | 0;
     }
    } while ((i3 | 0) != (i2 | 0));
    i2 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i2);
  }
  i3 = i1 + -28 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i2 = i1 + -24 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
    do {
     i14 = i1 + -96 | 0;
     HEAP32[i2 >> 2] = i14;
     __ZN19ComputeShaderKernelD2Ev(i14);
     i1 = HEAP32[i2 >> 2] | 0;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[i16 >> 2] | 0;
 } while ((i1 | 0) != (i15 | 0));
 STACKTOP = i17;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 64 | 0;
 i10 = i13;
 i11 = i7 + 56 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv(i7);
 i12 = i7 + 40 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 44 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 52 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i17 = i10 + 9 | 0;
 HEAP8[i17 >> 0] = (i21 & 65535) >>> 8;
 i21 = i10 + 12 | 0;
 i20 = i7 + 12 | 0;
 HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 i19 = i10 + 24 | 0;
 i18 = i7 + 24 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 i14 = i10 + 36 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 40 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 44 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 52 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 56 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i2;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i17 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 HEAP32[i10 + 20 >> 2] = i17;
 i17 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i2 = HEAP32[i7 + 32 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i10 + 24 >> 2] = i17;
 HEAP32[i10 + 28 >> 2] = i1;
 HEAP32[i10 + 32 >> 2] = i2;
 i2 = i7 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 48 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 60 >> 2] | 0;
  HEAP32[i9 >> 2] = 65;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 288 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 108 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN13b2PulleyJoint24SolvePositionConstraintsERK12b2SolverData(i23, i1) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i24 = i23 + 120 | 0;
 i9 = HEAP32[i24 >> 2] | 0;
 i15 = i1 + 24 | 0;
 i26 = HEAP32[i15 >> 2] | 0;
 i18 = i26 + (i9 * 12 | 0) | 0;
 f19 = Math_fround(HEAPF32[i18 >> 2]);
 i1 = i26 + (i9 * 12 | 0) + 4 | 0;
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i26 + (i9 * 12 | 0) + 8 >> 2]);
 i9 = i23 + 124 | 0;
 i25 = HEAP32[i9 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i26 + (i25 * 12 | 0) >> 2]);
 f11 = Math_fround(HEAPF32[i26 + (i25 * 12 | 0) + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i26 + (i25 * 12 | 0) + 8 >> 2]);
 f16 = Math_fround(+Math_sin(+f8));
 f3 = Math_fround(+Math_cos(+f8));
 f5 = Math_fround(+Math_sin(+f12));
 f2 = Math_fround(+Math_cos(+f12));
 f17 = Math_fround(HEAPF32[i23 + 92 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i23 + 160 >> 2]));
 f14 = Math_fround(HEAPF32[i23 + 96 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i23 + 164 >> 2]));
 f13 = Math_fround(Math_fround(f3 * f17) - Math_fround(f16 * f14));
 f14 = Math_fround(Math_fround(f16 * f17) + Math_fround(f3 * f14));
 f3 = Math_fround(HEAPF32[i23 + 100 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i23 + 168 >> 2]));
 f17 = Math_fround(HEAPF32[i23 + 104 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i23 + 172 >> 2]));
 f16 = Math_fround(Math_fround(f2 * f3) - Math_fround(f5 * f17));
 f17 = Math_fround(Math_fround(f5 * f3) + Math_fround(f2 * f17));
 f2 = Math_fround(f19 + f13);
 f3 = Math_fround(f22 + f14);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i23 + 68 >> 2]));
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i23 + 72 >> 2]));
 f5 = Math_fround(f10 + f16);
 f7 = Math_fround(f11 + f17);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i23 + 76 >> 2]));
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i23 + 80 >> 2]));
 f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3))));
 f21 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f7 * f7))));
 if (f20 > Math_fround(.049999997)) {
  f4 = Math_fround(Math_fround(1.0) / f20);
  f6 = Math_fround(f2 * f4);
  f4 = Math_fround(f3 * f4);
 } else {
  f6 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 if (f21 > Math_fround(.049999997)) {
  f2 = Math_fround(Math_fround(1.0) / f21);
  f3 = Math_fround(f5 * f2);
  f2 = Math_fround(f7 * f2);
 } else {
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f29 = Math_fround(Math_fround(f13 * f4) - Math_fround(f14 * f6));
 f7 = Math_fround(Math_fround(f16 * f2) - Math_fround(f17 * f3));
 f5 = Math_fround(HEAPF32[i23 + 176 >> 2]);
 f30 = Math_fround(HEAPF32[i23 + 184 >> 2]);
 f29 = Math_fround(f5 + Math_fround(f29 * Math_fround(f29 * f30)));
 f28 = Math_fround(HEAPF32[i23 + 180 >> 2]);
 f27 = Math_fround(HEAPF32[i23 + 188 >> 2]);
 f7 = Math_fround(f28 + Math_fround(f7 * Math_fround(f7 * f27)));
 f31 = Math_fround(HEAPF32[i23 + 112 >> 2]);
 f7 = Math_fround(f29 + Math_fround(Math_fround(f31 * f31) * f7));
 i25 = f7 > Math_fround(0.0);
 f29 = Math_fround(Math_fround(1.0) / f7);
 f20 = Math_fround(Math_fround(Math_fround(HEAPF32[i23 + 108 >> 2]) - f20) - Math_fround(f21 * f31));
 i26 = f20 > Math_fround(0.0);
 f21 = Math_fround(-f20);
 f7 = Math_fround(f20 * (i25 ? f29 : f7));
 f6 = Math_fround(f6 * f7);
 f29 = Math_fround(f4 * f7);
 f7 = Math_fround(f31 * f7);
 f4 = Math_fround(f3 * f7);
 f3 = Math_fround(f2 * f7);
 f7 = Math_fround(f22 + Math_fround(f5 * f29));
 f8 = Math_fround(f8 + Math_fround(f30 * Math_fround(Math_fround(f13 * f29) - Math_fround(f14 * f6))));
 f13 = Math_fround(f10 + Math_fround(f28 * f4));
 f14 = Math_fround(f11 + Math_fround(f28 * f3));
 f22 = Math_fround(f12 + Math_fround(f27 * Math_fround(Math_fround(f16 * f3) - Math_fround(f17 * f4))));
 HEAPF32[i18 >> 2] = Math_fround(f19 + Math_fround(f5 * f6));
 HEAPF32[i1 >> 2] = f7;
 i23 = HEAP32[i15 >> 2] | 0;
 HEAPF32[i23 + ((HEAP32[i24 >> 2] | 0) * 12 | 0) + 8 >> 2] = f8;
 i25 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i23 + (i25 * 12 | 0) >> 2] = f13;
 HEAPF32[i23 + (i25 * 12 | 0) + 4 >> 2] = f14;
 HEAPF32[(HEAP32[i15 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 12 | 0) + 8 >> 2] = f22;
 return (i26 ? f20 : f21) < Math_fround(.00499999989) | 0;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_22PxTriangleMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i11, i6, i5) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i8 = i12 + 136 | 0;
 i10 = i12 + 96 | 0;
 i7 = i12 + 48 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = gb + 673012;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i9;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i9;
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 HEAP32[i10 >> 2] = 5;
 HEAPF32[i10 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 28 >> 2] = Math_fround(1.0);
 i3 = i10 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_22PxTriangleMeshGeometryE(i6, HEAP32[i11 + 8 >> 2] | 0, i10) | 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i7);
 i3 = i11 + 4 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i9);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i9, i8, 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i12;
 return;
}

function __ZL19BlendLightProbesJobP19BlendProbesJobInputj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, f41 = f0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i40 + 72 | 0;
 i13 = i40 + 24 | 0;
 i24 = i40;
 if ((HEAP16[gb + 1111208 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111208 | 0, i4);
  i5 = gb + 1111208 | 0;
 } else i5 = 0;
 i38 = i1 + (i2 * 160 | 0) + 136 | 0;
 i39 = i1 + (i2 * 160 | 0) + 148 | 0;
 if (HEAP32[i39 >> 2] | 0) {
  i6 = i1 + (i2 * 160 | 0) | 0;
  i7 = i24 + 20 | 0;
  i8 = i4 + 24 | 0;
  i9 = i4 + 12 | 0;
  i10 = i13 + 4 | 0;
  i11 = i4 + 4 | 0;
  i12 = i13 + 8 | 0;
  i14 = i4 + 8 | 0;
  i15 = i13 + 12 | 0;
  i16 = i4 + 36 | 0;
  i17 = i4 + 60 | 0;
  i18 = i13 + 16 | 0;
  i19 = i4 + 48 | 0;
  i20 = i13 + 20 | 0;
  i21 = i4 + 40 | 0;
  i22 = i13 + 24 | 0;
  i23 = i4 + 44 | 0;
  i25 = i13 + 28 | 0;
  i26 = i4 + 72 | 0;
  i27 = i4 + 96 | 0;
  i28 = i13 + 32 | 0;
  i29 = i4 + 84 | 0;
  i30 = i13 + 36 | 0;
  i31 = i4 + 76 | 0;
  i32 = i13 + 40 | 0;
  i33 = i4 + 80 | 0;
  i34 = i13 + 44 | 0;
  i35 = i1 + (i2 * 160 | 0) + 156 | 0;
  i36 = i13 + 16 | 0;
  i37 = i13 + 32 | 0;
  i3 = HEAP32[i38 >> 2] | 0;
  i1 = HEAP32[i1 + (i2 * 160 | 0) + 132 >> 2] | 0;
  do {
   __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates(i6, i3, i1, i24) | 0;
   __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i6, i24, i4);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 177 >> 0] | 0)) {
    f41 = Math_fround(HEAPF32[i4 >> 2]);
    HEAPF32[i13 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i8 >> 2]));
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
    f41 = Math_fround(HEAPF32[i16 >> 2]);
    HEAPF32[i18 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i17 >> 2]));
    HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
    f41 = Math_fround(HEAPF32[i26 >> 2]);
    HEAPF32[i28 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i27 >> 2]));
    HEAP32[i30 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i32 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i34 >> 2] = HEAP32[i33 >> 2];
   } else {
    HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    f41 = Math_fround(HEAPF32[i4 >> 2]);
    HEAPF32[i15 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i8 >> 2]));
    HEAP32[i36 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
    f41 = Math_fround(HEAPF32[i16 >> 2]);
    HEAPF32[i25 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i17 >> 2]));
    HEAP32[i37 >> 2] = HEAP32[i29 >> 2];
    HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
    HEAP32[i32 >> 2] = HEAP32[i33 >> 2];
    f41 = Math_fround(HEAPF32[i26 >> 2]);
    HEAPF32[i34 >> 2] = Math_fround(f41 - Math_fround(HEAPF32[i27 >> 2]));
   }
   i2 = (HEAP32[i35 >> 2] | 0) + (HEAP32[i3 + 12 >> 2] << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i2 = (HEAP32[i35 >> 2] | 0) + (HEAP32[i3 + 16 >> 2] << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i36 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i36 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i36 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i36 + 12 >> 2];
   i2 = (HEAP32[i35 >> 2] | 0) + (HEAP32[i3 + 20 >> 2] << 4) | 0;
   HEAP32[i2 >> 2] = HEAP32[i37 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i37 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i37 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i37 + 12 >> 2];
   i3 = i3 + 24 | 0;
  } while ((i3 | 0) != ((HEAP32[i38 >> 2] | 0) + ((HEAP32[i39 >> 2] | 0) * 24 | 0) | 0));
 }
 if (!i5) {
  STACKTOP = i40;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i40;
 return;
}

function __ZN2UI14CanvasRenderer17SyncDirtyElementsER8JobFence(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = i9 + 204 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) return;
 i10 = i9 + 162 | 0;
 i1 = HEAP16[i10 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i2 = HEAP32[i9 + 28 >> 2] | 0;
 if (!i2) i3 = 5; else {
  i7 = __ZNK10GameObject8IsActiveEv(i2) | 0;
  i1 = HEAP16[i10 >> 1] | 0;
  if (!i7) i3 = 5;
 }
 if ((i3 | 0) == 5) if (!(i1 & 1024)) return;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = (i2 | 0) != 0;
 i7 = i4 & 1;
 i5 = i9 + 220 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i11 = (i3 | 0) != 0;
 i7 = i4 ? (i11 ? 3 : i7) : i11 ? 2 : i7;
 i11 = i1 & 65535;
 i4 = i11 >>> 11 & 1 ^ 1;
 if (i11 & 256 | 0) {
  if (i7 & 1 | 0) {
   i11 = i2 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 208 >> 2] | 0;
   i2 = HEAP32[i2 + 84 >> 2] | 0;
   HEAP32[i2 + (i11 * 672 | 0) + 480 >> 2] = i11;
   HEAP16[i2 + (i11 * 672 | 0) + 664 >> 1] = 2;
  }
  if (i7 & 2 | 0) {
   i11 = i3 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 224 >> 2] | 0;
   i3 = HEAP32[i3 + 84 >> 2] | 0;
   HEAP32[i3 + (i11 * 672 | 0) + 480 >> 2] = i11;
   HEAP16[i3 + (i11 * 672 | 0) + 664 >> 1] = 2;
  }
 }
 if (i1 & 2) {
  __ZN2UI14CanvasRenderer13SyncTransformENS0_8SyncFlagEb(i9, i7, (i4 | 0) != 0);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 512) {
  __ZN2UI14CanvasRenderer11SyncCullingENS0_8SyncFlagE(i9, i7);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 32) {
  __ZN2UI14CanvasRenderer13SyncVertexPtrER8JobFenceNS0_8SyncFlagE(i9, i6, i7);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 4) {
  if (i7 & 1 | 0) {
   i6 = HEAP32[i8 >> 2] | 0;
   i11 = i6 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 208 >> 2] | 0;
   i6 = HEAP32[i6 + 84 >> 2] | 0;
   i2 = i9 + 52 | 0;
   i3 = i6 + (i11 * 672 | 0) + 548 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP16[i6 + (i11 * 672 | 0) + 664 >> 1] = 2;
  }
  if (i7 & 2 | 0) {
   i6 = HEAP32[i5 >> 2] | 0;
   i11 = i6 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 224 >> 2] | 0;
   i6 = HEAP32[i6 + 84 >> 2] | 0;
   i2 = i9 + 52 | 0;
   i3 = i6 + (i11 * 672 | 0) + 548 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP16[i6 + (i11 * 672 | 0) + 664 >> 1] = 2;
  }
 }
 i1 = HEAP16[i10 >> 1] | 0;
 if (i1 & 1) {
  __ZN2UI14CanvasRenderer13SyncWorldRectENS0_8SyncFlagEb(i9, i7, (i4 | 0) != 0);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 16) {
  __ZN2UI14CanvasRenderer12SyncClipRectENS0_8SyncFlagEb(i9, i7, (i4 | 0) != 0);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 64) {
  if (i7 & 1 | 0) {
   i8 = HEAP32[i8 >> 2] | 0;
   i11 = i8 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 208 >> 2] | 0;
   i8 = HEAP32[i8 + 84 >> 2] | 0;
   i3 = HEAP32[i9 + 36 >> 2] | 0;
   i4 = HEAP32[i9 + 40 >> 2] | 0;
   i6 = HEAP32[i9 + 44 >> 2] | 0;
   HEAP32[i8 + (i11 * 672 | 0) + 628 >> 2] = HEAP32[i9 + 32 >> 2];
   HEAP32[i8 + (i11 * 672 | 0) + 632 >> 2] = i3;
   HEAP32[i8 + (i11 * 672 | 0) + 636 >> 2] = i4;
   HEAP32[i8 + (i11 * 672 | 0) + 640 >> 2] = i6;
   HEAP16[i8 + (i11 * 672 | 0) + 664 >> 1] = 4;
  }
  if (i7 & 2 | 0) {
   i8 = HEAP32[i5 >> 2] | 0;
   i11 = i8 + 112 | 0;
   HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 2;
   i11 = HEAP32[i9 + 224 >> 2] | 0;
   i8 = HEAP32[i8 + 84 >> 2] | 0;
   i4 = HEAP32[i9 + 36 >> 2] | 0;
   i5 = HEAP32[i9 + 40 >> 2] | 0;
   i6 = HEAP32[i9 + 44 >> 2] | 0;
   HEAP32[i8 + (i11 * 672 | 0) + 628 >> 2] = HEAP32[i9 + 32 >> 2];
   HEAP32[i8 + (i11 * 672 | 0) + 632 >> 2] = i4;
   HEAP32[i8 + (i11 * 672 | 0) + 636 >> 2] = i5;
   HEAP32[i8 + (i11 * 672 | 0) + 640 >> 2] = i6;
   HEAP16[i8 + (i11 * 672 | 0) + 664 >> 1] = 4;
  }
 }
 if (i1 & 128) {
  __ZN2UI14CanvasRenderer18SyncInheritedAlphaENS0_8SyncFlagE(i9, i7);
  i1 = HEAP16[i10 >> 1] | 0;
 }
 if (i1 & 8) __ZN2UI14CanvasRenderer12SyncMaterialENS0_8SyncFlagE(i9, i7);
 HEAP16[i10 >> 1] = 0;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 112 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 36 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN22BaseUnityConnectClient17RestoreValuesFileEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 64 | 0;
 i12 = i14 + 32 | 0;
 i13 = i14 + 16 | 0;
 i8 = i14;
 i9 = i14 + 48 | 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 if (!(HEAP8[i10 + 109 >> 0] | 0)) {
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i8 + 12 >> 2] = i1;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = -2147483616;
  HEAP32[i8 + 4 >> 2] = 22;
  i2 = i1;
  i3 = gb + 1040123 | 0;
  i4 = i2 + 22 | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP8[i1 + 22 >> 0] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsStringERK8UnityStrS1_(i13, i8, i9);
  i4 = i13 + 11 | 0;
  i6 = HEAP8[i4 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i13 >> 2] | 0 : i13;
  i6 = i7 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
  i7 = i12 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i6 >>> 0 > i3 >>> 0) {
   i2 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i6 - i3 | 0, i2, 0, i2, i6, i5);
  } else {
   i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) {
    HEAP32[i12 + 4 >> 2] = i6;
    break;
   } else {
    HEAP8[i7 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i6 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i11);
  }
  if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
   i13 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i11);
  }
  if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
   i13 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i13, i11);
  }
  i13 = HEAP8[i7 >> 0] | 0;
  if ((i13 << 24 >> 24 < 0 ? HEAP32[i12 + 4 >> 2] | 0 : i13 & 255) | 0) __ZN11UnityEngine7Connect20BasePersistentValues7RestoreERK8UnityStr(HEAP32[i10 + 660 >> 2] | 0, i12) | 0;
 } else {
  i1 = HEAP32[i10 + 280 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i9 = i13 + 11 | 0;
  HEAP8[i9 >> 0] = 6;
  HEAP8[i13 >> 0] = HEAP8[gb + 1041262 >> 0] | 0;
  HEAP8[i13 + 1 >> 0] = HEAP8[gb + 1041262 + 1 >> 0] | 0;
  HEAP8[i13 + 2 >> 0] = HEAP8[gb + 1041262 + 2 >> 0] | 0;
  HEAP8[i13 + 3 >> 0] = HEAP8[gb + 1041262 + 3 >> 0] | 0;
  HEAP8[i13 + 4 >> 0] = HEAP8[gb + 1041262 + 4 >> 0] | 0;
  HEAP8[i13 + 5 >> 0] = HEAP8[gb + 1041262 + 5 >> 0] | 0;
  HEAP8[i13 + 6 >> 0] = 0;
  i1 = __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_(i1, i13, i12) | 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i9 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
  }
  if (i1) __ZN11UnityEngine7Connect20BasePersistentValues7RestoreERK8UnityStr(HEAP32[i10 + 660 >> 2] | 0, i12) | 0;
 }
 if ((HEAP8[i12 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 816 | 0;
 i11 = i18 + 544 | 0;
 i16 = i18 + 272 | 0;
 i15 = i18;
 i3 = i5 + 2540 | 0;
 if (i1) {
  __ZN5physx3Scb5Scene13addRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE(i5, i6, i3);
  STACKTOP = i18;
  return;
 }
 HEAP32[i6 >> 2] = i5;
 i4 = i5 + 2433 | 0;
 i14 = i6 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 do if (!(HEAP8[i4 >> 0] | 0)) {
  HEAP32[i14 >> 2] = i2 & 268435455 | -2147483648;
  __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6insertERNS0_2Sc5SceneERS2_(i5 + 16 | 0, i6);
 } else {
  i1 = i2 & 1073741823;
  if (i2 >>> 0 > 3221225471) {
   HEAP32[i14 >> 2] = i1 | -2147483648;
   if (i2 & 268435456 | 0) break;
   HEAP32[i17 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i17) | 0;
   break;
  }
  HEAP32[i14 >> 2] = i1 | 1073741824;
  HEAP32[i11 >> 2] = i6;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i11, i17) | 0;
  if (!(HEAP8[i17 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
 } while (0);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i5 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i16 + 256 | 0;
  i10 = i16 + 260 | 0;
  HEAP32[i16 + 264 >> 2] = 0;
  i11 = i16 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i16;
  HEAP32[i11 >> 2] = 64;
  i12 = i15 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i15, i16);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i6, i17) | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i17 = HEAP32[i15 + 268 >> 2] | 0;
  do if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i15 + 260 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  } while (0);
  i17 = HEAP32[i11 >> 2] | 0;
  do if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i16 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i6, i17) | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i14 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i17 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i17 | 0) > -1 & (i17 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i17 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i18;
 return;
}

function __ZNSt3__218__insertion_sort_3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i23, i24, i1) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i25 = 0;
 i2 = i23 + 80 | 0;
 __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_(i23, i23 + 40 | 0, i2, i1) | 0;
 i1 = i23 + 120 | 0;
 if ((i1 | 0) == (i24 | 0)) return; else i22 = i1;
 while (1) {
  i20 = i22;
  i21 = HEAP32[i20 >> 2] | 0;
  i20 = HEAP32[i20 + 4 >> 2] | 0;
  i7 = i2;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  if ((i21 | 0) == (i6 | 0) & (i20 | 0) == (i7 | 0)) {
   i3 = i22 + 8 | 0;
   i4 = i3;
   i5 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i2 + 8 | 0;
   i19 = i1;
   i18 = HEAP32[i19 + 4 >> 2] | 0;
   if (i4 >>> 0 < i18 >>> 0 | ((i4 | 0) == (i18 | 0) ? i5 >>> 0 < (HEAP32[i19 >> 2] | 0) >>> 0 : 0)) i25 = 7;
  } else if (i20 >>> 0 < i7 >>> 0 | (i20 | 0) == (i7 | 0) & i21 >>> 0 < i6 >>> 0) {
   i3 = i22 + 8 | 0;
   i5 = i3;
   i1 = i2 + 8 | 0;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i25 = 7;
  }
  if ((i25 | 0) == 7) {
   i25 = 0;
   i9 = i22 + 16 | 0;
   i15 = i9;
   i14 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 4 >> 2] | 0;
   i10 = i22 + 24 | 0;
   i17 = i10;
   i16 = HEAP32[i17 >> 2] | 0;
   i17 = HEAP32[i17 + 4 >> 2] | 0;
   i13 = i22 + 32 | 0;
   i19 = i13;
   i18 = HEAP32[i19 >> 2] | 0;
   i19 = HEAP32[i19 + 4 >> 2] | 0;
   i12 = i22;
   HEAP32[i12 >> 2] = i6;
   HEAP32[i12 + 4 >> 2] = i7;
   i12 = i1;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i7 + 4 >> 2] = i11;
   i7 = i2 + 16 | 0;
   i11 = i7;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i6 = i9;
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i6 + 4 >> 2] = i12;
   i6 = i2 + 24 | 0;
   i12 = i6;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i10;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = i11;
   i3 = i2 + 32 | 0;
   i11 = i3;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   L11 : do if ((i2 | 0) != (i23 | 0)) {
    i13 = i2;
    i12 = i6;
    i11 = i1;
    while (1) {
     i2 = i13 + -40 | 0;
     i10 = i2;
     i9 = HEAP32[i10 >> 2] | 0;
     i10 = HEAP32[i10 + 4 >> 2] | 0;
     if ((i21 | 0) == (i9 | 0) & (i20 | 0) == (i10 | 0)) {
      i1 = i13 + -32 | 0;
      i8 = i1;
      i6 = HEAP32[i8 >> 2] | 0;
      i8 = HEAP32[i8 + 4 >> 2] | 0;
      if (i4 >>> 0 < i8 >>> 0 | (i4 | 0) == (i8 | 0) & i5 >>> 0 < i6 >>> 0) i3 = i8; else {
       i6 = i12;
       i1 = i11;
       i2 = i13;
       break L11;
      }
     } else {
      if (!(i20 >>> 0 < i10 >>> 0 | (i20 | 0) == (i10 | 0) & i21 >>> 0 < i9 >>> 0)) {
       i6 = i12;
       i1 = i11;
       i2 = i13;
       break L11;
      }
      i1 = i13 + -32 | 0;
      i3 = i1;
      i6 = HEAP32[i3 >> 2] | 0;
      i3 = HEAP32[i3 + 4 >> 2] | 0;
     }
     i7 = i13;
     HEAP32[i7 >> 2] = i9;
     HEAP32[i7 + 4 >> 2] = i10;
     i7 = i13 + 8 | 0;
     HEAP32[i7 >> 2] = i6;
     HEAP32[i7 + 4 >> 2] = i3;
     i7 = i13 + -24 | 0;
     i11 = i7;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i6 = i13 + 16 | 0;
     HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i6 + 4 >> 2] = i12;
     i6 = i13 + -16 | 0;
     i12 = i6;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     i3 = i13 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i3 + 4 >> 2] = i11;
     i3 = i13 + -8 | 0;
     i11 = i3;
     i12 = HEAP32[i11 + 4 >> 2] | 0;
     i13 = i13 + 32 | 0;
     HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i13 + 4 >> 2] = i12;
     if ((i2 | 0) == (i23 | 0)) break; else {
      i13 = i2;
      i12 = i6;
      i11 = i1;
     }
    }
   } while (0);
   i13 = i2;
   HEAP32[i13 >> 2] = i21;
   HEAP32[i13 + 4 >> 2] = i20;
   i21 = i1;
   HEAP32[i21 >> 2] = i5;
   HEAP32[i21 + 4 >> 2] = i4;
   i21 = i7;
   HEAP32[i21 >> 2] = i14;
   HEAP32[i21 + 4 >> 2] = i15;
   i21 = i6;
   HEAP32[i21 >> 2] = i16;
   HEAP32[i21 + 4 >> 2] = i17;
   i21 = i3;
   HEAP32[i21 >> 2] = i18;
   HEAP32[i21 + 4 >> 2] = i19;
  }
  i1 = i22 + 40 | 0;
  if ((i1 | 0) == (i24 | 0)) break; else {
   i2 = i22;
   i22 = i1;
  }
 }
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR11NodeXSorterP16HeightMeshBVNodeEEbT0_S5_T_(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f16 = f0, i17 = 0;
 switch (i15 - i14 >> 5 | 0) {
 case 2:
  {
   i1 = i15 + -32 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(HEAPF32[i15 + -20 >> 2])) * Math_fround(.5));
   f3 = Math_fround(HEAPF32[i14 >> 2]);
   f4 = Math_fround(HEAPF32[i14 + 12 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f3 + f4) * Math_fround(.5)))) {
    i15 = 1;
    return i15 | 0;
   }
   i8 = HEAP32[i14 + 4 >> 2] | 0;
   i9 = HEAP32[i14 + 8 >> 2] | 0;
   i10 = HEAP32[i14 + 16 >> 2] | 0;
   i11 = HEAP32[i14 + 20 >> 2] | 0;
   i13 = i14 + 24 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i14 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i14 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAPF32[i1 >> 2] = f3;
   HEAP32[i15 + -28 >> 2] = i8;
   HEAP32[i15 + -24 >> 2] = i9;
   HEAPF32[i15 + -20 >> 2] = f4;
   HEAP32[i15 + -16 >> 2] = i10;
   HEAP32[i15 + -12 >> 2] = i11;
   i15 = i15 + -8 | 0;
   HEAP32[i15 >> 2] = i12;
   HEAP32[i15 + 4 >> 2] = i13;
   i15 = 1;
   return i15 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i14 + 96 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 1:
 case 0:
  {
   i15 = 1;
   return i15 | 0;
  }
 default:
  {
   i5 = i14 + 64 | 0;
   __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i5, i1) | 0;
   i1 = i14 + 96 | 0;
   L3 : do if ((i1 | 0) == (i15 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i1 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     f16 = Math_fround(Math_fround(f4 + f7) * Math_fround(.5));
     f3 = Math_fround(HEAPF32[i5 >> 2]);
     if (f16 < Math_fround(Math_fround(f3 + Math_fround(HEAPF32[i5 + 12 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 + 4 >> 2] | 0;
      i9 = HEAP32[i1 + 8 >> 2] | 0;
      i10 = HEAP32[i1 + 16 >> 2] | 0;
      i11 = HEAP32[i1 + 20 >> 2] | 0;
      i13 = i1 + 24 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      f3 = Math_fround(Math_fround(f4 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
       HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
       if ((i5 | 0) == (i14 | 0)) {
        i5 = i14;
        break;
       }
       i6 = i5 + -32 | 0;
       f16 = Math_fround(HEAPF32[i6 >> 2]);
       if (f3 < Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i5 + -20 >> 2])) * Math_fround(.5))) {
        i17 = i5;
        i5 = i6;
        i6 = i17;
       } else break;
      }
      HEAPF32[i5 >> 2] = f4;
      HEAP32[i5 + 4 >> 2] = i8;
      HEAP32[i5 + 8 >> 2] = i9;
      HEAPF32[i5 + 12 >> 2] = f7;
      HEAP32[i5 + 16 >> 2] = i10;
      HEAP32[i5 + 20 >> 2] = i11;
      i17 = i5 + 24 | 0;
      HEAP32[i17 >> 2] = i12;
      HEAP32[i17 + 4 >> 2] = i13;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 32 | 0) == (i15 | 0);
       break L3;
      }
     }
     i5 = i1 + 32 | 0;
     if ((i5 | 0) == (i15 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i17 = i1;
      i1 = i5;
      i5 = i17;
     }
    }
   } while (0);
   i17 = i1 | i2;
   return i17 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 132 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN19RuntimeSceneManager43UnloadAllScenesWithoutDestroyingGameObjectsEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18;
 i16 = i18 + 8 | 0;
 i14 = i15 + 4 | 0;
 i17 = i15 + 16 | 0;
 if (HEAP32[i17 >> 2] | 0) {
  i7 = i15 + 4 | 0;
  i5 = 0;
  do {
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   if ((HEAP32[i1 + 80 >> 2] | 0) == 2) {
    i6 = __ZN15GlobalCallbacks3GetEv() | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    i3 = i6 + 2312 | 0;
    if (HEAP32[i3 >> 2] | 0) {
     i1 = 0;
     do {
      i4 = i6 + 1544 + (i1 * 12 | 0) | 0;
      if (!(HEAP8[i6 + 1544 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i4 >> 2] | 0, i2 | 0); else mftCall_vii(HEAP32[i4 >> 2] | 0, HEAP32[i6 + 1544 + (i1 * 12 | 0) + 4 >> 2] | 0, i2 | 0);
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
 }
 HEAP32[i16 >> 2] = 0;
 i11 = i16 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i16 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i7 = i8;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 L15 : do if (HEAP32[i17 >> 2] | 0) {
  i9 = i15 + 4 | 0;
  i8 = 0;
  while (1) {
   i7 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i6 = i7;
   switch (HEAP32[i7 + 80 >> 2] | 0) {
   case 1:
    {
     i2 = HEAP32[i11 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i13 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i13 >> 2] = i1;
       HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
       HEAP32[i13 >> 2] = i1;
       HEAP32[i16 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i11 >> 2] = i3;
     HEAP32[(HEAP32[i16 >> 2] | 0) + (i2 << 2) >> 2] = i6;
     break;
    }
   case 2:
    {
     __ZN10UnityScene23UnloadLevelGameManagersEv(i7);
     i6 = i7 + 104 | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     i5 = i7 + 100 | 0;
     if ((i1 | 0) == (i5 | 0)) i10 = 33; else {
      do {
       i4 = HEAP32[i1 + 8 >> 2] | 0;
       i2 = i4 + 104 | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       if (i3) {
        i1 = i4 + 108 | 0;
        HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
        HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
        HEAP32[i2 >> 2] = 0;
        HEAP32[i1 >> 2] = 0;
        i1 = HEAP32[i6 >> 2] | 0;
       }
       HEAP32[i4 + 116 >> 2] = 0;
      } while ((i1 | 0) != (i5 | 0));
      i10 = 33;
     }
     break;
    }
   default:
    i10 = 33;
   }
   if ((i10 | 0) == 33) {
    i10 = 0;
    mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0);
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= (HEAP32[i17 >> 2] | 0) >>> 0) break L15;
  }
 } while (0);
 if ((i16 | 0) != (i14 | 0)) {
  i5 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] << 2;
  i2 = i1 >> 2;
  HEAP32[i17 >> 2] = i2;
  i3 = i15 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1, 4, i15 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i14 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i15 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i14 >> 2] = i1;
   break;
  } else i1 = HEAP32[i14 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i5 | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
 }
 HEAP32[i15 + 44 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i12);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZL22PrepareMeshRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i14 = HEAP32[i16 + 32 >> 2] | 0;
 i15 = HEAP32[i16 + 36 >> 2] | 0;
 i21 = HEAP32[i16 + 48 >> 2] | 0;
 i24 = i16 + 76 | 0;
 i18 = HEAP32[i24 >> 2] | 0;
 i25 = HEAP32[i18 + 16 >> 2] | 0;
 i18 = HEAP32[i18 + 1504 >> 2] | 0;
 i26 = i16 + 16 | 0;
 i27 = i16 + 4 | 0;
 i1 = HEAP32[i27 >> 2] | 0;
 i17 = (i18 & 2 | 0) == 0;
 i18 = (i18 & 4 | 0) != 0;
 i19 = i16 + 12 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 if (i2 >>> 0 >= i15 >>> 0) {
  i26 = i1;
  HEAP32[i27 >> 2] = i26;
  return;
 }
 f20 = Math_fround(HEAPF32[gb + 1161204 >> 2]);
 i22 = i16 + 20 | 0;
 i23 = i16 + 24 | 0;
 while (1) {
  i6 = HEAP32[i14 + (i2 << 2) >> 2] | 0;
  i12 = HEAP32[i21 + (i6 * 24 | 0) >> 2] | 0;
  i12 = (i12 | 0) == 0 ? 0 : i12 + -32 | 0;
  i8 = i12 + 32 | 0;
  i2 = i12 + 268 | 0;
  i2 = HEAPU16[i2 >> 1] | HEAPU8[i2 + 2 >> 0] << 16;
  if ((i2 & 63 | 0) != 1) {
   i2 = 26;
   break;
  }
  do if (!(i18 & (i2 & 192 | 0) == 0)) {
   i9 = HEAP32[i12 + 340 >> 2] | 0;
   if (i9) {
    __ZN4Mesh18CreateMeshIfNeededEv(i9);
    i10 = HEAP32[i12 + 344 >> 2] | 0;
    i11 = (i10 | 0) == 0;
    if (!i11) __ZN4Mesh18CreateMeshIfNeededEv(i10);
    i13 = HEAP32[i16 >> 2] | 0;
    i7 = i13 + (i1 * 360 | 0) | 0;
    i2 = i12 + 272 | 0;
    i5 = HEAP16[i2 >> 1] | 0;
    if ((i5 & 65535) > 255 | (i5 & 255) << 24 >> 24 != 0) {
     mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 48 >> 2] | 0, i8 | 0);
     HEAP8[i2 >> 0] = 0;
     HEAP8[i12 + 273 >> 0] = 0;
    }
    i5 = i12 + 36 | 0;
    i3 = HEAP16[i21 + (i6 * 24 | 0) + 14 >> 1] | 0;
    i2 = i3 & 65535;
    if (!(i3 << 16 >> 16)) f4 = f20; else {
     i3 = HEAP32[i21 + (i6 * 24 | 0) + 16 >> 2] | 0;
     if (!i3) f4 = f20; else {
      i6 = HEAPU16[i21 + (i6 * 24 | 0) + 12 >> 1] | 0;
      f4 = Math_fround(__ZN15LODGroupManager16CalculateLODFadeEjhf(i3, HEAP8[(HEAP32[i25 + (i6 * 12 | 0) >> 2] | 0) + i2 >> 0] | 0, Math_fround(HEAPF32[(HEAP32[i25 + (i6 * 12 | 0) + 4 >> 2] | 0) + (i2 << 2) >> 2])));
     }
    }
    __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode(i8, i5, f4, i7);
    if (!i17) __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode(i8, i5, (HEAP32[i24 >> 2] | 0) + 1572 | 0, i7);
    if (!(__ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i8, i26, i7) | 0)) {
     __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i16);
     break;
    }
    HEAP32[i13 + (i1 * 360 | 0) + 248 >> 2] = HEAP32[i9 + 228 >> 2];
    i2 = HEAP32[i22 >> 2] | 0;
    if ((i2 + 28 | 0) >>> 0 > (HEAP32[i23 >> 2] | 0) >>> 0) {
     __ZN22PerThreadPageAllocator14AcquireNewPageEj(i26, 32768);
     i2 = HEAP32[i22 >> 2] | 0;
    }
    i5 = (HEAP32[i26 >> 2] | 0) + i2 | 0;
    HEAP32[i22 >> 2] = i2 + 28;
    HEAP32[i13 + (i1 * 360 | 0) + 328 >> 2] = i5;
    i3 = HEAP32[i12 + 4 >> 2] | 0;
    i8 = HEAP32[i9 + 32 >> 2] | 0;
    i7 = i8 + 4 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    HEAP32[i5 >> 2] = i8;
    i9 = HEAP32[i9 + 36 >> 2] | 0;
    i8 = i9 + 4 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    HEAP32[i5 + 8 >> 2] = i9;
    if (i11) {
     HEAP32[i5 + 4 >> 2] = 0;
     i2 = 0;
    } else {
     i2 = HEAP32[i10 + 32 >> 2] | 0;
     i11 = i2 + 4 | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     HEAP32[i5 + 4 >> 2] = i2;
     i2 = HEAP32[i10 + 36 >> 2] | 0;
     i11 = i2 + 4 | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    }
    HEAP32[i5 + 12 >> 2] = i2;
    HEAP32[i5 + 16 >> 2] = i3;
    HEAP32[i5 + 20 >> 2] = 0;
    HEAP32[i5 + 24 >> 2] = 0;
    i2 = HEAPU8[i12 + 348 >> 0] ^ 1;
    i3 = i13 + (i1 * 360 | 0) + 348 | 0;
    HEAP32[i3 >> 2] = i2;
    if (!(HEAP16[i13 + (i1 * 360 | 0) + 182 >> 1] | 0)) HEAP32[i3 >> 2] = i2 | 2;
    HEAP32[i13 + (i1 * 360 | 0) + 340 >> 2] = fb + 492;
    HEAP32[i13 + (i1 * 360 | 0) + 332 >> 2] = fb + 211;
    HEAP32[i13 + (i1 * 360 | 0) + 344 >> 2] = fb + 2371;
    i1 = i1 + 1 | 0;
   }
  } while (0);
  i2 = (HEAP32[i19 >> 2] | 0) + 1 | 0;
  HEAP32[i19 >> 2] = i2;
  if (i2 >>> 0 >= i15 >>> 0) {
   i2 = 26;
   break;
  }
 }
 if ((i2 | 0) == 26) {
  HEAP32[i27 >> 2] = i1;
  return;
 }
}

function __ZN6HelperI19StreamedBinaryWriteILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2616 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2617 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2618 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2619 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2620 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2621 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2622 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2623 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2624 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2625 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2626 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2620 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2618 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2627 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2628 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2629 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2630 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2631 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2632 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2633 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2634 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2635 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2636 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2637 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2638 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2639 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2640 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2641 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2616 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2617 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2618 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2619 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2620 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2621 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2622 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2623 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2624 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2625 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2626 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2620 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2618 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN4crnd12crn_unpacker12unpack_dxt5aEPPhjjjjjj(i4, i37, i1, i38, i2, i3, i39, i40) {
 i4 = i4 | 0;
 i37 = i37 | 0;
 i1 = i1 | 0;
 i38 = i38 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i39 = i39 | 0;
 i40 = i40 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i41 = 0, i42 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i36;
 i22 = HEAP32[i4 + 272 >> 2] | 0;
 i34 = HEAP32[i4 + 88 >> 2] | 0;
 i23 = (HEAPU8[i34 + 63 >> 0] | 0) << 8 | (HEAPU8[i34 + 64 >> 0] | 0);
 i34 = HEAP8[i34 + 17 >> 0] | 0;
 i24 = i34 & 255;
 if (!(i34 << 24 >> 24)) {
  STACKTOP = i36;
  return 1;
 }
 i25 = (i40 | 0) == 0;
 i26 = i39 + -1 | 0;
 i27 = i26 << 4;
 i28 = i40 + -1 | 0;
 i29 = i38 << 1;
 i30 = i4 + 92 | 0;
 i31 = i4 + 116 | 0;
 i32 = i4 + 164 | 0;
 i33 = i4 + 268 | 0;
 i34 = i4 + 212 | 0;
 i21 = (i2 & 1 | 0) == 0;
 i20 = (i3 & 1 | 0) == 0;
 i19 = i4 + 284 | 0;
 i18 = 0;
 i2 = 0;
 i1 = 0;
 i3 = 1;
 do {
  if (!i25) {
   i16 = HEAP32[i37 + (i18 << 2) >> 2] | 0;
   i17 = 0;
   while (1) {
    i15 = i17 & 1;
    i5 = (i15 | 0) == 0;
    i14 = (i15 << 5 ^ 32) + -16 | 0;
    i15 = (i15 << 1 ^ 2) + -1 | 0;
    i12 = i5 ? i39 : -1;
    i4 = i5 ? 0 : i26;
    if ((i4 | 0) != (i12 | 0)) {
     i13 = i20 | (i17 | 0) != (i28 | 0);
     i11 = i5 ? i16 : i16 + i27 | 0;
     while (1) {
      if ((i3 | 0) == 1) i3 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i31) | 0 | 512;
      i10 = i3 & 7;
      i3 = i3 >>> 3;
      i6 = HEAPU8[gb + 401462 + i10 >> 0] | 0;
      i5 = 0;
      do {
       i7 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i32) | 0) + i1 | 0;
       i8 = i7 - i22 | 0;
       i9 = i8 >> 31;
       i1 = i9 & i7 | i8 & ~i9;
       HEAP32[i35 + (i5 << 2) >> 2] = HEAPU16[(HEAP32[i33 >> 2] | 0) + (i1 << 1) >> 1];
       i5 = i5 + 1 | 0;
      } while (i5 >>> 0 < i6 >>> 0);
      i9 = i21 | (i4 | 0) != (i26 | 0);
      i7 = 0;
      i8 = i11;
      while (1) {
       i6 = i13 | (i7 | 0) == 0;
       i5 = i7 << 1;
       i42 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i34) | 0) + i2 | 0;
       i41 = i42 - i23 | 0;
       i2 = i41 >> 31;
       i2 = i2 & i42 | i41 & ~i2;
       do if (i9) {
        if (i6) {
         i42 = (HEAP32[i19 >> 2] | 0) + (i2 * 3 << 1) | 0;
         HEAP32[i8 >> 2] = (HEAPU16[i42 >> 1] | 0) << 16 | HEAP32[i35 + ((HEAPU8[gb + 401470 + (i10 << 2) + i5 >> 0] | 0) << 2) >> 2];
         HEAP32[i8 + 4 >> 2] = (HEAPU16[i42 + 4 >> 1] | 0) << 16 | (HEAPU16[i42 + 2 >> 1] | 0);
        }
        i41 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i34) | 0) + i2 | 0;
        i42 = i41 - i23 | 0;
        i2 = i42 >> 31;
        i2 = i2 & i41 | i42 & ~i2;
        if (i6) {
         i42 = (HEAP32[i19 >> 2] | 0) + (i2 * 3 << 1) | 0;
         HEAP32[i8 + 8 >> 2] = (HEAPU16[i42 >> 1] | 0) << 16 | HEAP32[i35 + ((HEAPU8[(i5 | 1) + (gb + 401470 + (i10 << 2)) >> 0] | 0) << 2) >> 2];
         HEAP32[i8 + 12 >> 2] = (HEAPU16[i42 + 4 >> 1] | 0) << 16 | (HEAPU16[i42 + 2 >> 1] | 0);
        }
       } else if (i6) {
        i41 = (HEAP32[i19 >> 2] | 0) + (i2 * 3 << 1) | 0;
        HEAP32[i8 >> 2] = (HEAPU16[i41 >> 1] | 0) << 16 | HEAP32[i35 + ((HEAPU8[gb + 401470 + (i10 << 2) + i5 >> 0] | 0) << 2) >> 2];
        HEAP32[i8 + 4 >> 2] = (HEAPU16[i41 + 4 >> 1] | 0) << 16 | (HEAPU16[i41 + 2 >> 1] | 0);
        i41 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i34) | 0) + i2 | 0;
        i42 = i41 - i23 | 0;
        i2 = i42 >> 31;
        i2 = i2 & i41 | i42 & ~i2;
        break;
       } else {
        i41 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i30, i34) | 0) + i2 | 0;
        i42 = i41 - i23 | 0;
        i2 = i42 >> 31;
        i2 = i2 & i41 | i42 & ~i2;
        break;
       } while (0);
       i7 = i7 + 1 | 0;
       if ((i7 | 0) == 2) break; else i8 = i8 + i38 | 0;
      }
      i4 = i15 + i4 | 0;
      if ((i4 | 0) == (i12 | 0)) break; else i11 = i11 + i14 | 0;
     }
    }
    i17 = i17 + 1 | 0;
    if ((i17 | 0) == (i40 | 0)) break; else i16 = i16 + i29 | 0;
   }
  }
  i18 = i18 + 1 | 0;
 } while ((i18 | 0) != (i24 | 0));
 STACKTOP = i36;
 return 1;
}

function __ZNK9ShaderLab11ShaderState22IsShaderStateSupportedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 72 | 0;
 i19 = i21 + 64 | 0;
 i18 = i21 + 56 | 0;
 i12 = i21 + 48 | 0;
 i17 = i21 + 40 | 0;
 i11 = i21 + 32 | 0;
 i20 = i21 + 24 | 0;
 i14 = i21 + 16 | 0;
 i10 = i21 + 8 | 0;
 i3 = i21;
 if (HEAP8[i1 + 52 >> 0] | 0) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i5 = __Z15GetGraphicsCapsv() | 0;
 i15 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
 i2 = HEAP32[i15 + 64 >> 2] & 1;
 do if (!i2) i1 = HEAP8[i5 + 163 >> 0] | 0; else {
  i1 = HEAP16[i5 + 162 >> 1] | 0;
  if ((i1 & 255) << 24 >> 24) {
   i1 = (i1 & 65535) >>> 8 & 255;
   break;
  }
  HEAP32[i3 >> 2] = gb + 480646;
  _printf_console(gb + 480617 | 0, i3);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 } while (0);
 i9 = i2 | 0 ? 8 : 1;
 i8 = HEAP32[i5 + 164 >> 2] | 0;
 i4 = (i8 & 16711680 | 0) == 0;
 i6 = i1 << 24 >> 24 != 0;
 i7 = (i8 & 255) << 24 >> 24 != 0;
 i8 = (i8 & 65280 | 0) != 0;
 L12 : do if (!(HEAP8[i5 + 161 >> 0] | 0)) {
  i2 = i4 ^ 1;
  i1 = 0;
  while (1) {
   i3 = HEAP8[i15 + (i1 << 3) + 5 >> 0] | 0;
   if ((HEAP8[i15 + (i1 << 3) + 1 >> 0] | 0) != (HEAP8[i15 + (i1 << 3) + 3 >> 0] | 0)) {
    i1 = 19;
    break;
   }
   if ((HEAP8[i15 + (i1 << 3) + 2 >> 0] | 0) != (HEAP8[i15 + (i1 << 3) + 4 >> 0] | 0)) {
    i1 = 19;
    break;
   }
   if (i3 << 24 >> 24 != (HEAP8[i15 + (i1 << 3) + 6 >> 0] | 0)) {
    i1 = 20;
    break;
   }
   if (!((i3 + -1 & 255) > 1 | i6)) {
    i1 = 21;
    break L12;
   }
   if (!((i3 + -3 & 255) > 1 | i7)) {
    i1 = 25;
    break L12;
   }
   if (!((i3 + -5 & 255) > 15 | i8)) {
    i1 = 29;
    break L12;
   }
   if (!((i3 + -21 & 255) > 14 | i2)) {
    i1 = 32;
    break L12;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i9 | 0)) {
    i16 = 1;
    i1 = 36;
    break;
   }
  }
  if ((i1 | 0) == 19) {
   HEAP32[i10 >> 2] = gb + 480692;
   _printf_console(gb + 480617 | 0, i10);
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  } else if ((i1 | 0) == 20) {
   HEAP32[i14 >> 2] = gb + 480692;
   _printf_console(gb + 480617 | 0, i14);
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  } else if ((i1 | 0) == 36) {
   STACKTOP = i21;
   return i16 | 0;
  }
 } else {
  i1 = 0;
  while (1) {
   i2 = HEAP8[i15 + (i1 << 3) + 5 >> 0] | 0;
   i3 = HEAP8[i15 + (i1 << 3) + 6 >> 0] | 0;
   if (!((i2 + -1 & 255) > 1 | i6)) {
    i1 = 21;
    break L12;
   }
   if (!((i3 + -1 & 255) > 1 | i6)) {
    i1 = 23;
    break;
   }
   if (!((i2 + -3 & 255) > 1 | i7)) {
    i1 = 25;
    break L12;
   }
   if (!((i3 + -3 & 255) > 1 | i7)) {
    i1 = 27;
    break;
   }
   if (!((i2 + -5 & 255) > 15 | i8)) {
    i1 = 29;
    break L12;
   }
   if ((i2 + -21 & 255) < 15) {
    if (i4) {
     i1 = 32;
     break L12;
    }
    if (i2 << 24 >> 24 != i3 << 24 >> 24) {
     i1 = 35;
     break;
    }
   }
   i1 = i1 + 1 | 0;
   if (!((i3 + -21 & 255) > 14 ? 1 : i2 << 24 >> 24 == i3 << 24 >> 24)) {
    i1 = 35;
    break;
   }
   if ((i1 | 0) >= (i9 | 0)) {
    i16 = 1;
    i1 = 36;
    break;
   }
  }
  if ((i1 | 0) == 23) {
   HEAP32[i11 >> 2] = gb + 480737;
   _printf_console(gb + 480617 | 0, i11);
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  } else if ((i1 | 0) == 27) {
   HEAP32[i12 >> 2] = gb + 480776;
   _printf_console(gb + 480617 | 0, i12);
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  } else if ((i1 | 0) == 35) {
   HEAP32[i13 >> 2] = gb + 480907;
   _printf_console(gb + 480617 | 0, i13);
   i20 = 0;
   STACKTOP = i21;
   return i20 | 0;
  } else if ((i1 | 0) == 36) {
   STACKTOP = i21;
   return i16 | 0;
  }
 } while (0);
 if ((i1 | 0) == 21) {
  HEAP32[i20 >> 2] = gb + 480737;
  _printf_console(gb + 480617 | 0, i20);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 } else if ((i1 | 0) == 25) {
  HEAP32[i17 >> 2] = gb + 480776;
  _printf_console(gb + 480617 | 0, i17);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 } else if ((i1 | 0) == 29) {
  HEAP32[i18 >> 2] = gb + 480814;
  _printf_console(gb + 480617 | 0, i18);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 } else if ((i1 | 0) == 32) {
  HEAP32[i19 >> 2] = gb + 480860;
  _printf_console(gb + 480617 | 0, i19);
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 return 0;
}

function __ZN6HelperI24GenerateTypeTreeTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2561 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2562 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2563 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2564 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2565 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2566 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2567 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2568 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2569 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2570 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2571 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2565 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2563 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2572 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2573 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2574 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2575 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2576 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2577 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2578 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2579 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2580 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2581 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2582 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2583 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2584 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2585 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2586 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2561 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2562 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2563 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2564 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2565 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2566 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2567 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2568 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2569 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2570 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2571 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2565 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2563 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI18StreamedBinaryReadILb1EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2727 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2728 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2729 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2730 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2731 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2732 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2733 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2734 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2735 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2736 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2737 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2731 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2729 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2738 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2739 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2740 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2741 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2742 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2743 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2744 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2745 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2746 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2747 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2748 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2749 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2750 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2751 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2752 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2727 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2728 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2729 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2730 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2731 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2732 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2733 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2734 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2735 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2736 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2737 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2731 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2729 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI18StreamedBinaryReadILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2671 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2672 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2673 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2674 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2675 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2676 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2677 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2678 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2679 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2680 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2681 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2675 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2673 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2682 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2683 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2684 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2685 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2686 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2687 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2688 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2689 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2690 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2691 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2692 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2693 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2694 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2695 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2696 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2671 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2672 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2673 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2674 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2675 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2676 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2677 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2678 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2679 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2680 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2681 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2675 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2673 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034440 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034444 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034448 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034452 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034456 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034460 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034464 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034468 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034472 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034476 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034480 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034484 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034488 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034492 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034496 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034500 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZL16NavMeshLoadSceneiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 if ((i1 | 4 | 0) != 5) {
  i5 = HEAP32[gb + 1459032 >> 2] | 0;
  i4 = (__Z21GetManagerFromContexti(27) | 0) + 28 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i9 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 10;
    }
   }
   if ((i10 | 0) == 8) i10 = 10;
   if ((i10 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
  __ZN14NavMeshManager15LoadNavMeshDataEiPK11NavMeshData(i5, i11, i1);
  STACKTOP = i12;
  return;
 }
 i6 = i7 + 12 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i5 = 0;
 L23 : while (1) {
  i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 * 12 | 0) + 4 >> 2] | 0;
  do if (i4 | 0) {
   HEAP32[i9 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 22; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 22; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 24;
    }
   }
   if ((i10 | 0) == 22) i10 = 24;
   if ((i10 | 0) == 24) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 169816 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 169816 + 28 >> 2] | 0) >>> 0)) break L23;
  } while (0);
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
   i10 = 37;
   break;
  }
 }
 if ((i10 | 0) == 37) {
  STACKTOP = i12;
  return;
 }
 i5 = HEAP32[gb + 1459032 >> 2] | 0;
 i4 = i1 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 32; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 32; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 34;
   }
  }
  if ((i10 | 0) == 32) i10 = 34;
  if ((i10 | 0) == 34) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 __ZN14NavMeshManager15LoadNavMeshDataEiPK11NavMeshData(i5, i11, i1);
 STACKTOP = i12;
 return;
}

function __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i33, i34, i31, i21, i10, i32) {
 i33 = i33 | 0;
 i34 = i34 | 0;
 i31 = i31 | 0;
 i21 = i21 | 0;
 i10 = i10 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i35 = __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_(i33, i34, i31, i21, i32) | 0;
 if (!(mftCall_iii(HEAP32[i32 >> 2] | 0, i10 | 0, i21 | 0) | 0)) {
  i38 = i35;
  return i38 | 0;
 }
 i11 = HEAP32[i21 >> 2] | 0;
 i12 = i21 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i21 + 8 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = i21 + 12 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i15 = i21 + 16 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i16 = i21 + 20 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i17 = i21 + 24 | 0;
 i6 = HEAP32[i17 >> 2] | 0;
 i18 = i21 + 28 | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 i19 = i21 + 32 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 i20 = i21 + 36 | 0;
 i9 = HEAP32[i20 >> 2] | 0;
 i36 = i21;
 i37 = i10;
 i38 = i36 + 40 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = i2;
 HEAP32[i10 + 12 >> 2] = i3;
 HEAP32[i10 + 16 >> 2] = i4;
 HEAP32[i10 + 20 >> 2] = i5;
 HEAP32[i10 + 24 >> 2] = i6;
 HEAP32[i10 + 28 >> 2] = i7;
 HEAP32[i10 + 32 >> 2] = i8;
 HEAP32[i10 + 36 >> 2] = i9;
 if (!(mftCall_iii(HEAP32[i32 >> 2] | 0, i21 | 0, i31 | 0) | 0)) {
  i38 = i35 + 1 | 0;
  return i38 | 0;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 i22 = i31 + 4 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i23 = i31 + 8 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i24 = i31 + 12 | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i25 = i31 + 16 | 0;
 i5 = HEAP32[i25 >> 2] | 0;
 i26 = i31 + 20 | 0;
 i6 = HEAP32[i26 >> 2] | 0;
 i27 = i31 + 24 | 0;
 i7 = HEAP32[i27 >> 2] | 0;
 i28 = i31 + 28 | 0;
 i8 = HEAP32[i28 >> 2] | 0;
 i29 = i31 + 32 | 0;
 i9 = HEAP32[i29 >> 2] | 0;
 i30 = i31 + 36 | 0;
 i10 = HEAP32[i30 >> 2] | 0;
 i36 = i31;
 i37 = i21;
 i38 = i36 + 40 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i21 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i3;
 HEAP32[i14 >> 2] = i4;
 HEAP32[i15 >> 2] = i5;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i17 >> 2] = i7;
 HEAP32[i18 >> 2] = i8;
 HEAP32[i19 >> 2] = i9;
 HEAP32[i20 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i32 >> 2] | 0, i31 | 0, i34 | 0) | 0)) {
  i38 = i35 + 2 | 0;
  return i38 | 0;
 }
 i1 = HEAP32[i34 >> 2] | 0;
 i11 = i34 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i34 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i34 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i14 = i34 + 16 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i15 = i34 + 20 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i16 = i34 + 24 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 i17 = i34 + 28 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i18 = i34 + 32 | 0;
 i9 = HEAP32[i18 >> 2] | 0;
 i19 = i34 + 36 | 0;
 i10 = HEAP32[i19 >> 2] | 0;
 i36 = i34;
 i37 = i31;
 i38 = i36 + 40 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i31 >> 2] = i1;
 HEAP32[i22 >> 2] = i2;
 HEAP32[i23 >> 2] = i3;
 HEAP32[i24 >> 2] = i4;
 HEAP32[i25 >> 2] = i5;
 HEAP32[i26 >> 2] = i6;
 HEAP32[i27 >> 2] = i7;
 HEAP32[i28 >> 2] = i8;
 HEAP32[i29 >> 2] = i9;
 HEAP32[i30 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i32 >> 2] | 0, i34 | 0, i33 | 0) | 0)) {
  i38 = i35 + 3 | 0;
  return i38 | 0;
 }
 i1 = HEAP32[i33 >> 2] | 0;
 i2 = HEAP32[i33 + 4 >> 2] | 0;
 i3 = HEAP32[i33 + 8 >> 2] | 0;
 i4 = HEAP32[i33 + 12 >> 2] | 0;
 i5 = HEAP32[i33 + 16 >> 2] | 0;
 i6 = HEAP32[i33 + 20 >> 2] | 0;
 i7 = HEAP32[i33 + 24 >> 2] | 0;
 i8 = HEAP32[i33 + 28 >> 2] | 0;
 i9 = HEAP32[i33 + 32 >> 2] | 0;
 i10 = HEAP32[i33 + 36 >> 2] | 0;
 i36 = i33;
 i37 = i34;
 i38 = i36 + 40 | 0;
 do {
  HEAP32[i36 >> 2] = HEAP32[i37 >> 2];
  i36 = i36 + 4 | 0;
  i37 = i37 + 4 | 0;
 } while ((i36 | 0) < (i38 | 0));
 HEAP32[i34 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i15 >> 2] = i6;
 HEAP32[i16 >> 2] = i7;
 HEAP32[i17 >> 2] = i8;
 HEAP32[i18 >> 2] = i9;
 HEAP32[i19 >> 2] = i10;
 i38 = i35 + 4 | 0;
 return i38 | 0;
}

function __ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i(i11, i12, i15, i3) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 i13 = HEAP32[i11 >> 2] | 0;
 i5 = i13 + 16 | 0;
 i6 = i13 + 20 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = i2 + -40 | 0;
 i13 = i13 + 28 | 0;
 i14 = i11 + 24 | 0;
 __ZN21TreeBinaryTreeBuilder17EncapsulateBoundsER10MinMaxAABBRK12TreeInstanceRKNSt3__26vectorIN12TreeDatabase9PrototypeENS5_9allocatorIS8_EEEERK8Vector3fSG_(i14, i10, i13, i12, i15);
 i1 = HEAP32[i11 + 80 >> 2] | 0;
 if (i1 | 0) {
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i15 >> 2]));
  f18 = Math_fround(HEAPF32[i2 + -36 >> 2]);
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i15 + 4 >> 2]));
  f17 = Math_fround(HEAPF32[i2 + -32 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i15 + 8 >> 2]));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i11 + 64 >> 2]));
  f18 = Math_fround(f19 + Math_fround(f18 * Math_fround(HEAPF32[i11 + 68 >> 2])));
  f17 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i11 + 72 >> 2])));
  if (Math_fround(Math_fround(HEAPF32[i11 + 76 >> 2]) + f17) > Math_fround(0.0)) {
   i15 = __ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i(i1, i12, i15, i3) | 0;
   STACKTOP = i16;
   return i15 | 0;
  } else {
   i15 = __ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i(HEAP32[i11 + 84 >> 2] | 0, i12, i15, i3) | 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 HEAP32[i11 + 52 >> 2] = -1;
 i1 = i11 + 60 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  i9 = i11 + 48 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i9 >> 2] | 0);
  HEAP32[i9 >> 2] = 0;
 }
 i9 = i11 + 4 | 0;
 i8 = i11 + 16 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!i7) {
  HEAP32[i8 >> 2] = 1;
  i1 = i11 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  do if (!(i2 & 2147483647)) if ((i2 | 0) > -1) {
   HEAP32[i1 >> 2] = 1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, 4, 4, i11 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i9 >> 2] = i1;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4, 4, i11 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i1 >> 2] = 1;
   HEAP32[i9 >> 2] = i11;
   i1 = i11;
   break;
  } else i1 = HEAP32[i9 >> 2] | 0; while (0);
  HEAP32[i1 >> 2] = (((HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 40 | 0) + -1;
  __ZN21TreeBinaryTreeBuilder15CalculateBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERKNS1_IN12TreeDatabase9PrototypeENS3_ISD_EEEERK8Vector3fSK_(i4, i5, i9, i13, i12, i15);
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i14 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i15 = 1;
  STACKTOP = i16;
  return i15 | 0;
 }
 if ((i7 | 0) >= (i3 << 1 | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i2 = (((HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 40 | 0) + -1 | 0;
 i3 = i7 + 1 | 0;
 i4 = i11 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i11 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i9 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i3;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i7 << 2) >> 2] = i2;
 __ZN21TreeBinaryTreeBuilder17EncapsulateBoundsER10MinMaxAABBRK12TreeInstanceRKNSt3__26vectorIN12TreeDatabase9PrototypeENS5_9allocatorIS8_EEEERK8Vector3fSG_(i14, i10, i13, i12, i15);
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 24 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 44 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE(i1, i2, i3, f4, i20, f21, i22, i23, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i20 = i20 | 0;
 f21 = Math_fround(f21);
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f25 = f0, f26 = f0, f27 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 80 | 0;
 i13 = i19 + 52 | 0;
 i14 = i19 + 32 | 0;
 i15 = i19 + 12 | 0;
 i16 = i19;
 i17 = i19 + 92 | 0;
 HEAP32[i18 >> 2] = 2;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i18 + 4 >> 2] = f4;
 f25 = Math_fround(f10 - f9);
 f27 = Math_fround(f11 - f7);
 f8 = Math_fround(f12 - f6);
 f26 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f27 * f27)) + Math_fround(f8 * f8))));
 HEAPF32[i18 + 8 >> 2] = Math_fround(f26 * Math_fround(.5));
 f10 = Math_fround(Math_fround(f9 + f10) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f7 + f11) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f6 + f12) * Math_fround(.5));
 f6 = Math_fround(f27 * Math_fround(0.0));
 f4 = Math_fround(f8 * Math_fround(0.0));
 f7 = Math_fround(f4 - f6);
 f9 = Math_fround(f25 * Math_fround(0.0));
 f8 = Math_fround(f9 - f8);
 f9 = Math_fround(f27 - f9);
 f4 = Math_fround(f26 + Math_fround(Math_fround(f25 + f6) + f4));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 if (f4 < Math_fround(.0000999999974)) {
  i2 = -2147483648;
  i5 = 1065353216;
  i3 = 0;
  i1 = 0;
 } else {
  i5 = i3;
  i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f4 * f4);
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(f6 * f6));
 f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f9 + Math_fround(f7 * f7));
 f8 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f8 * f8))));
 if (f9 != Math_fround(0.0)) {
  f27 = Math_fround(Math_fround(1.0) / f9);
  f26 = Math_fround(f4 * f27);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(f6 * f27);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f26 = Math_fround(f7 * f27);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  f27 = Math_fround(f8 * f27);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i3;
 HEAPF32[i13 + 16 >> 2] = f10;
 HEAPF32[i13 + 20 >> 2] = f11;
 HEAPF32[i13 + 24 >> 2] = f12;
 HEAP32[i14 >> 2] = gb + 114012 + 8;
 HEAP32[i14 + 4 >> 2] = 1;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = i22;
 switch (i23 | 0) {
 case 0:
  {
   HEAP8[i14 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i14 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i14 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP16[i15 + 16 >> 1] = 7;
 HEAP8[i15 + 18 >> 0] = 0;
 i5 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i23 = HEAP32[gb + 1457404 >> 2] | 0;
 i22 = HEAP32[(HEAP32[i23 >> 2] | 0) + 352 >> 2] | 0;
 i2 = HEAP32[i20 + 4 >> 2] | 0;
 i3 = HEAP32[i20 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i16 + 4 >> 2] = i2;
 HEAP32[i16 + 8 >> 2] = i3;
 HEAP16[i17 >> 1] = i5 ? 143 : 15;
 mftCall_iiiiifiiiiif(i22 | 0, i23 | 0, i18 | 0, i13 | 0, i16 | 0, +f21, i24 | 0, i17 | 0, i15 | 0, i14 | 0, 0, 0.0) | 0;
 STACKTOP = i19;
 return;
}

function __ZN20TextRenderingPrivate8FontImplC2E10MemLabelIdPN13TextRendering4FontE(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i8 = i13;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i10 = i1;
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i10;
 HEAP32[i12 + 40 >> 2] = 0;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i12 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i1 = i9;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i12 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 60 >> 2] = 0;
 HEAP32[i12 + 64 >> 2] = 0;
 HEAP32[i12 + 68 >> 2] = 0;
 HEAP32[i12 + 72 >> 2] = i6;
 HEAP32[i12 + 76 >> 2] = i2;
 i6 = i8;
 HEAP32[i6 >> 2] = i11;
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i12 + 80 >> 2] = 0;
 HEAP32[i12 + 92 >> 2] = 0;
 HEAP32[i12 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i6 = i9;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i12 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i12 + 100 >> 2] = 0;
 HEAP32[i12 + 104 >> 2] = 0;
 HEAP32[i12 + 108 >> 2] = 0;
 HEAP32[i12 + 112 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 116 >> 2] = 0;
 HEAP32[i12 + 120 >> 2] = 0;
 HEAP32[i12 + 124 >> 2] = 0;
 HEAP32[i12 + 128 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 132 >> 2] = 0;
 HEAP32[i12 + 136 >> 2] = 0;
 HEAP32[i12 + 140 >> 2] = 0;
 HEAP32[i12 + 144 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i12 + 148 | 0;
 i10 = i12 + 152 | 0;
 HEAP32[i10 >> 2] = 0;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 156 >> 2] = i6;
 i11 = i12 + 160 | 0;
 HEAP32[i11 >> 2] = 0;
 i3 = i12 + 152 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i12 + 168 >> 2] = 256;
 HEAP32[i12 + 172 >> 2] = 256;
 HEAP32[i12 + 180 >> 2] = 1;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 1;
 i1 = i12 + 188 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 36 >> 2] = Math_fround(.100000001);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = i3;
 do if (!i1) {
  HEAP32[i8 >> 2] = i3;
  i5 = i7;
  i4 = i3;
 } else {
  while (1) {
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   i4 = (HEAP32[i1 + 20 >> 2] | 0) + i3 | 0;
   i5 = (i4 | 0) == 0;
   if (i5 ? (i3 | 0) > 0 : (i4 | 0) > 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i3 = 4;
     break;
    } else i1 = i3;
   } else {
    if (!(i5 ? (i3 | 0) < 0 : (i4 | 0) < 0)) {
     i3 = 9;
     break;
    }
    i4 = i1 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i3 = 8;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 4) {
   HEAP32[i8 >> 2] = i1;
   i5 = i1;
   i4 = i1;
   break;
  } else if ((i3 | 0) == 8) {
   HEAP32[i8 >> 2] = i1;
   i5 = i1;
   break;
  } else if ((i3 | 0) == 9) {
   HEAP32[i8 >> 2] = i1;
   i5 = i1;
   i4 = i8;
   break;
  }
 } while (0);
 if (HEAP32[i4 >> 2] | 0) {
  i10 = i7;
  i11 = i12 + 164 | 0;
  HEAP32[i11 >> 2] = i10;
  i11 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63392 | 0, 16, gb + 944940 | 0, 56) | 0;
  __ZN20TextRenderingPrivate15DynamicFontDataC2Ev(i11);
  i12 = i12 + 204 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 HEAP32[i9 >> 2] = 34;
 HEAP32[i9 + 4 >> 2] = i6;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i4 >> 2] = i1;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 if (i3) {
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i1);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i10 = HEAP32[i2 >> 2] | 0;
 i11 = i12 + 164 | 0;
 HEAP32[i11 >> 2] = i10;
 i11 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63392 | 0, 16, gb + 944940 | 0, 56) | 0;
 __ZN20TextRenderingPrivate15DynamicFontDataC2Ev(i11);
 i12 = i12 + 204 | 0;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i12 = i11 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i3 - i1 | 0) / 88 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
   HEAP32[i1 >> 2] = 0;
   i11 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
   HEAP32[i1 + 28 >> 2] = 0;
   i11 = i1 + 36 | 0;
   HEAP32[i1 + 68 >> 2] = 0;
   HEAP32[i1 + 72 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
   i11 = i15;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i14 = i1 + 60 | 0;
   HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + 4 >> 2] = i12;
   HEAP32[i1 + 80 >> 2] = 2;
   HEAP32[i1 + 76 >> 2] = 2;
   HEAP32[i1 + 84 >> 2] = 4;
   i1 = (HEAP32[i13 >> 2] | 0) + 88 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i16;
  return;
 }
 i14 = i11 + 12 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 88 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i10 = (i3 - i4 | 0) / 88 | 0;
 i3 = i10 << 1;
 i3 = i10 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 >> 2] = 1;
  HEAP32[i15 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 88 | 0, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (((i1 - i4 | 0) / 88 | 0) * 88 | 0) | 0;
 i4 = i6;
 i3 = i5 + (i3 * 88 | 0) | 0;
 i10 = i4;
 i1 = i6;
 do {
  HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
  HEAP32[i1 >> 2] = 0;
  i7 = i1 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
  HEAP32[i1 + 28 >> 2] = 0;
  i7 = i1 + 36 | 0;
  HEAP32[i1 + 68 >> 2] = 0;
  HEAP32[i1 + 72 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
  i7 = i15;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1 + 60 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 + 80 >> 2] = 2;
  HEAP32[i1 + 76 >> 2] = 2;
  HEAP32[i1 + 84 >> 2] = 4;
  i1 = i10 + 88 | 0;
  i10 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i9 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) {
  i2 = i4;
  i4 = i9;
  i1 = i9;
 } else {
  i2 = i4;
  i5 = i6;
  do {
   i4 = i1;
   i1 = i1 + -88 | 0;
   i6 = i5 + -88 | 0;
   i7 = i1;
   i8 = i6 + 56 | 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
    i6 = i6 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i6 | 0) < (i8 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i5 + -32 | 0, i4 + -32 | 0);
   i8 = i5 + -12 | 0;
   i7 = i4 + -12 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i5 = i2 + -88 | 0;
   i2 = i5;
  } while ((i1 | 0) != (i9 | 0));
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i12 >> 2] = i3;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -32 | 0;
  if ((HEAP32[i1 + -16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -28 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -88 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i16;
  return;
 }
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = 1;
 HEAP32[i15 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i15);
 STACKTOP = i16;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR11NodeZSorterP16HeightMeshBVNodeEEbT0_S5_T_(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f16 = f0;
 switch (i15 - i14 >> 5 | 0) {
 case 2:
  {
   i2 = i15 + -32 | 0;
   i3 = i15 + -24 | 0;
   i1 = i15 + -12 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
   f4 = Math_fround(HEAPF32[i14 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i14 + 20 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) {
    i15 = 1;
    return i15 | 0;
   }
   i8 = HEAP32[i14 >> 2] | 0;
   i9 = HEAP32[i14 + 4 >> 2] | 0;
   i10 = HEAP32[i14 + 12 >> 2] | 0;
   i11 = HEAP32[i14 + 16 >> 2] | 0;
   i13 = i14 + 24 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i14 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i14 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i2 >> 2] = i8;
   HEAP32[i15 + -28 >> 2] = i9;
   HEAPF32[i3 >> 2] = f4;
   HEAP32[i15 + -20 >> 2] = i10;
   HEAP32[i15 + -16 >> 2] = i11;
   HEAPF32[i1 >> 2] = f5;
   i15 = i15 + -8 | 0;
   HEAP32[i15 >> 2] = i12;
   HEAP32[i15 + 4 >> 2] = i13;
   i15 = 1;
   return i15 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i14 + 96 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 1:
 case 0:
  {
   i15 = 1;
   return i15 | 0;
  }
 default:
  {
   i3 = i14 + 64 | 0;
   __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i3, i1) | 0;
   i1 = i14 + 96 | 0;
   L3 : do if ((i1 | 0) == (i15 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
     f16 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
     f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     if (f16 < Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 >> 2] | 0;
      i9 = HEAP32[i1 + 4 >> 2] | 0;
      i10 = HEAP32[i1 + 12 >> 2] | 0;
      i11 = HEAP32[i1 + 16 >> 2] | 0;
      i13 = i1 + 24 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       if ((i3 | 0) == (i14 | 0)) {
        i3 = i14;
        break;
       }
       f16 = Math_fround(HEAPF32[i3 + -24 >> 2]);
       if (f4 < Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i3 + -12 >> 2])) * Math_fround(.5))) {
        i6 = i3;
        i3 = i3 + -32 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i8;
      HEAP32[i3 + 4 >> 2] = i9;
      HEAPF32[i3 + 8 >> 2] = f5;
      HEAP32[i3 + 12 >> 2] = i10;
      HEAP32[i3 + 16 >> 2] = i11;
      HEAPF32[i3 + 20 >> 2] = f7;
      i11 = i3 + 24 | 0;
      HEAP32[i11 >> 2] = i12;
      HEAP32[i11 + 4 >> 2] = i13;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 32 | 0) == (i15 | 0);
       break L3;
      }
     }
     i3 = i1 + 32 | 0;
     if ((i3 | 0) == (i15 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i13 = i1;
      i1 = i3;
      i3 = i13;
     }
    }
   } while (0);
   i15 = i1 | i2;
   return i15 | 0;
  }
 }
 return 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR11NodeYSorterP16HeightMeshBVNodeEEbT0_S5_T_(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f16 = f0;
 switch (i15 - i14 >> 5 | 0) {
 case 2:
  {
   i2 = i15 + -32 | 0;
   i3 = i15 + -28 | 0;
   i1 = i15 + -16 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
   f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i14 + 16 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) {
    i15 = 1;
    return i15 | 0;
   }
   i8 = HEAP32[i14 >> 2] | 0;
   i9 = HEAP32[i14 + 8 >> 2] | 0;
   i10 = HEAP32[i14 + 12 >> 2] | 0;
   i11 = HEAP32[i14 + 20 >> 2] | 0;
   i13 = i14 + 24 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i14 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i14 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i2 >> 2] = i8;
   HEAPF32[i3 >> 2] = f4;
   HEAP32[i15 + -24 >> 2] = i9;
   HEAP32[i15 + -20 >> 2] = i10;
   HEAPF32[i1 >> 2] = f5;
   HEAP32[i15 + -12 >> 2] = i11;
   i15 = i15 + -8 | 0;
   HEAP32[i15 >> 2] = i12;
   HEAP32[i15 + 4 >> 2] = i13;
   i15 = 1;
   return i15 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i14, i14 + 32 | 0, i14 + 64 | 0, i14 + 96 | 0, i15 + -32 | 0, i1) | 0;
   i15 = 1;
   return i15 | 0;
  }
 case 1:
 case 0:
  {
   i15 = 1;
   return i15 | 0;
  }
 default:
  {
   i3 = i14 + 64 | 0;
   __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i14, i14 + 32 | 0, i3, i1) | 0;
   i1 = i14 + 96 | 0;
   L3 : do if ((i1 | 0) == (i15 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
     f16 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
     f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     if (f16 < Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i3 + 16 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 >> 2] | 0;
      i9 = HEAP32[i1 + 8 >> 2] | 0;
      i10 = HEAP32[i1 + 12 >> 2] | 0;
      i11 = HEAP32[i1 + 20 >> 2] | 0;
      i13 = i1 + 24 | 0;
      i12 = HEAP32[i13 >> 2] | 0;
      i13 = HEAP32[i13 + 4 >> 2] | 0;
      f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
       if ((i3 | 0) == (i14 | 0)) {
        i3 = i14;
        break;
       }
       f16 = Math_fround(HEAPF32[i3 + -28 >> 2]);
       if (f4 < Math_fround(Math_fround(f16 + Math_fround(HEAPF32[i3 + -16 >> 2])) * Math_fround(.5))) {
        i6 = i3;
        i3 = i3 + -32 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i8;
      HEAPF32[i3 + 4 >> 2] = f5;
      HEAP32[i3 + 8 >> 2] = i9;
      HEAP32[i3 + 12 >> 2] = i10;
      HEAPF32[i3 + 16 >> 2] = f7;
      HEAP32[i3 + 20 >> 2] = i11;
      i11 = i3 + 24 | 0;
      HEAP32[i11 >> 2] = i12;
      HEAP32[i11 + 4 >> 2] = i13;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 32 | 0) == (i15 | 0);
       break L3;
      }
     }
     i3 = i1 + 32 | 0;
     if ((i3 | 0) == (i15 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i13 = i1;
      i1 = i3;
      i3 = i13;
     }
    }
   } while (0);
   i15 = i1 | i2;
   return i15 | 0;
  }
 }
 return 0;
}

function __ZN6HelperI19StreamedBinaryWriteILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2589 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2590 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2591 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2592 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2593 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2594 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2595 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2596 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2597 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2598 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2599 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2593 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2591 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2600 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2601 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2602 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2603 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2604 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2605 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2606 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2607 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2608 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2609 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2610 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2611 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2612 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2613 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2614 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2589 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2590 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2591 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2592 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2593 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2594 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2595 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2596 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2597 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2598 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2599 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2593 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2591 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i16) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 24 | 0;
 i18 = i20 + 12 | 0;
 i12 = i20;
 i10 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i16, 47, 0) | 0) == -1;
 i19 = i1 + 28 | 0;
 i15 = i1 + 32 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i11 = (HEAP32[i15 >> 2] | 0) != (i5 | 0);
 if (i10) {
  if (!i11) {
   i19 = -1;
   STACKTOP = i20;
   return i19 | 0;
  }
  i7 = i16 + 11 | 0;
  i8 = i16 + 4 | 0;
  i9 = i17 + 11 | 0;
  i10 = i17 + 4 | 0;
  i3 = 0;
  i2 = i5;
  while (1) {
   i1 = i2 + (i3 << 4) | 0;
   i4 = HEAP8[i1 + 11 >> 0] | 0;
   if (i4 << 24 >> 24 < 0) {
    i6 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i2 + (i3 << 4) + 4 >> 2] | 0;
   } else {
    i6 = i1;
    i1 = i4 & 255;
   };
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i6, i1);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i18, i12);
   __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i17, i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   i4 = HEAP8[i7 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i6 = HEAP8[i9 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   if (((i2 ? HEAP32[i8 >> 2] | 0 : i4 & 255) | 0) == ((i1 ? HEAP32[i10 >> 2] | 0 : i6 & 255) | 0)) i1 = (__Z7StrICmpPKcS0_(i2 ? HEAP32[i16 >> 2] | 0 : i16, i1 ? HEAP32[i17 >> 2] | 0 : i17) | 0) == 0; else i1 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   if (i1) {
    i4 = 24;
    break;
   }
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i19 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i15 >> 2] | 0) - i2 >> 4 >>> 0) {
    i3 = -1;
    i4 = 24;
    break;
   }
  }
  if ((i4 | 0) == 24) {
   STACKTOP = i20;
   return i3 | 0;
  }
 }
 if (!i11) {
  i19 = -1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i2 = i16 + 11 | 0;
 i1 = 0;
 do {
  i12 = i5 + (i1 << 4) | 0;
  if (!(__Z7StrICmpPKcS0_((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16) | 0)) {
   i3 = i1;
   i4 = 24;
   break;
  }
  i1 = i1 + 1 | 0;
  i13 = HEAP32[i15 >> 2] | 0;
  i14 = HEAP32[i19 >> 2] | 0;
  i5 = i14;
 } while (i1 >>> 0 < i13 - i14 >> 4 >>> 0);
 if ((i4 | 0) == 24) {
  STACKTOP = i20;
  return i3 | 0;
 }
 if ((i13 | 0) == (i14 | 0)) {
  i19 = -1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i7 = i16 + 11 | 0;
 i8 = i16 + 4 | 0;
 i9 = i17 + 11 | 0;
 i10 = i17 + 4 | 0;
 i6 = 0;
 i2 = i5;
 while (1) {
  i1 = i2 + (i6 << 4) | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + (i6 << 4) + 4 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i4, i1);
  __ZN13BuildSettings34ConvertScenePathToDisplayScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17, 0, i18);
  i13 = HEAP8[i7 >> 0] | 0;
  i1 = i13 << 24 >> 24 < 0;
  i14 = HEAP8[i9 >> 0] | 0;
  i2 = i14 << 24 >> 24 < 0;
  if (((i1 ? HEAP32[i8 >> 2] | 0 : i13 & 255) | 0) == ((i2 ? HEAP32[i10 >> 2] | 0 : i14 & 255) | 0)) {
   i14 = (__Z7StrICmpPKcS0_(i1 ? HEAP32[i16 >> 2] | 0 : i16, i2 ? HEAP32[i17 >> 2] | 0 : i17) | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   if (i14) {
    i3 = i6;
    i4 = 24;
    break;
   }
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  }
  i6 = i6 + 1 | 0;
  i2 = HEAP32[i19 >> 2] | 0;
  if (i6 >>> 0 >= (HEAP32[i15 >> 2] | 0) - i2 >> 4 >>> 0) {
   i3 = -1;
   i4 = 24;
   break;
  }
 }
 if ((i4 | 0) == 24) {
  STACKTOP = i20;
  return i3 | 0;
 }
 return 0;
}

function __Z24PlayerLoadGlobalManagersPKcS0_j(i9, i4, i10, i5) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 16 | 0;
 i8 = i14;
 i12 = i14 + 64 | 0;
 i7 = i14 + 28 | 0;
 i13 = __Z20GetPersistentManagerv() | 0;
 i2 = 0;
 i3 = 1;
 while (1) {
  if (i3 & i5 | 0) if (HEAP32[gb + 1104348 + 112 + (i2 << 2) >> 2] | 0) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, _strlen(i4) | 0);
   i1 = i2 + 1 | 0;
   HEAP32[i11 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i8, i1, ((i1 | 0) < 0) << 31 >> 31) | 0;
   i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i11) | 0;
   if (!i1) i6 = 10; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28304 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28304 + 28 >> 2] | 0) >>> 0) i6 = 10;
   if ((i6 | 0) == 10) {
    i6 = 0;
    i1 = 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   HEAP32[gb + 1104348 + (i2 << 2) >> 2] = i1;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 24) break; else i3 = i3 << 1;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i10, _strlen(i10) | 0);
 HEAP32[i11 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i13, i8, 1, 0) | 0;
 i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i11) | 0;
 if (!i1) i6 = 4; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31112 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31112 + 28 >> 2] | 0) >>> 0) i6 = 4;
 if ((i6 | 0) == 4) i1 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if (!i1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 370293 | 0, 50);
  STACKTOP = i14;
  return;
 }
 i4 = gb + 64024 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i12 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i8);
 i6 = i11;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i15 = i4;
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i15 + 4 >> 2] = i2;
 __ZNK11PreloadData18GetInstanceIDArrayER13dynamic_arrayIiLj4EE(i1, i12);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i15 = gb + 63416 | 0;
 i2 = HEAP32[i15 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i7 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i8);
 i15 = i11;
 i8 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress(i13, HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, i7);
 i1 = i7 + 16 | 0;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i4);
  HEAP32[i12 >> 2] = 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i10, _strlen(i10) | 0);
 i15 = (__ZN17PersistentManager18LoadFileCompletelyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i13, i11) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 if (i15) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  STACKTOP = i14;
  return;
 } else {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 370344 | 0, 60);
  STACKTOP = i14;
  return;
 }
}

function __ZN6HelperI24GenerateTypeTreeTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2534 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2535 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2536 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2537 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2538 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2539 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2540 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2541 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2542 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2543 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2544 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2538 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2536 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2545 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2546 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2547 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2548 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2549 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2550 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2551 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2552 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2553 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2554 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2555 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2556 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2557 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2558 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2559 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2534 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2535 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2536 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2537 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2538 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2539 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2540 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2541 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2542 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2543 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2544 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2538 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2536 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI18StreamedBinaryReadILb1EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2700 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2701 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2702 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2703 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2704 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2705 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2706 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2707 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2708 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2709 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2710 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2704 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2702 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2711 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2712 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2713 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2714 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2715 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2716 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2717 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2718 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2719 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2720 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2721 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2722 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2723 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2724 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2725 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2700 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2701 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2702 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2703 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2704 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2705 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2706 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2707 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2708 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2709 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2710 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2704 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2702 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI18StreamedBinaryReadILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2644 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2645 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2646 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2647 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2648 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2649 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2650 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2651 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2652 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2653 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2654 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2648 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2646 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2655 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2656 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2657 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2658 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2659 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2660 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2661 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2662 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2663 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2664 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2665 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2666 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2667 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2668 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2669 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2644 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2645 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2646 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2647 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2648 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2649 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2650 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2651 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2652 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2653 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2654 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2648 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2646 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI17RemapPPtrTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2506 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2507 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2508 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2509 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2510 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2511 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2512 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2513 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2514 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2515 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2516 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2510 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2508 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2517 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2518 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2519 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2520 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2521 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2522 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2523 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2524 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2525 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2526 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2527 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2528 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2529 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2530 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2531 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2506 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2507 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2508 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2509 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2510 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2511 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2512 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2513 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2514 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2515 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2516 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2510 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2508 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf(i12, i3, i1, i2, i8, f10, f5, f6, f4, i13) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 f10 = Math_fround(f10);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f4 = Math_fround(f4);
 i13 = i13 | 0;
 var f7 = f0, i9 = 0, i11 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 if (f10 > f4) {
  f14 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
  f16 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(2.0));
  f19 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(2.0));
  f17 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
  f15 = Math_fround(HEAPF32[i8 >> 2]);
  f6 = Math_fround(f14 * f15);
  f10 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f16 * f10));
  f7 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f19 * f7));
  f4 = Math_fround(Math_fround(f15 * f6) + Math_fround(Math_fround(f14 * f18) + Math_fround(f17 * Math_fround(Math_fround(f19 * f10) - Math_fround(f16 * f7)))));
  f5 = Math_fround(Math_fround(f10 * f6) + Math_fround(Math_fround(f16 * f18) + Math_fround(f17 * Math_fround(Math_fround(f14 * f7) - Math_fround(f19 * f15)))));
  f6 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f10)))) + Math_fround(f7 * f6));
  HEAPF32[i12 >> 2] = f4;
  i1 = i12 + 4 | 0;
  HEAPF32[i1 >> 2] = f5;
  i2 = i12 + 8 | 0;
  HEAPF32[i2 >> 2] = f6;
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
  if (!(f7 > Math_fround(0.0))) {
   f19 = f7;
   HEAPF32[i13 >> 2] = f19;
   STACKTOP = i11;
   return;
  }
  f19 = Math_fround(Math_fround(1.0) / f7);
  HEAPF32[i12 >> 2] = Math_fround(f4 * f19);
  HEAPF32[i1 >> 2] = Math_fround(f5 * f19);
  HEAPF32[i2 >> 2] = Math_fround(f6 * f19);
  f19 = f7;
  HEAPF32[i13 >> 2] = f19;
  STACKTOP = i11;
  return;
 } else {
  f16 = Math_fround(HEAPF32[i3 >> 2]);
  f15 = Math_fround(f16 * f5);
  f18 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f20 = Math_fround(f18 * f6);
  __ZNK5physx2Gu11HeightField10getNormal_Efffff(i1, HEAP32[i3 + 12 >> 2] | 0, f15, f20, f16, Math_fround(HEAPF32[i3 + 4 >> 2]), f18);
  f18 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(2.0));
  f16 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i8 >> 2]);
  f5 = Math_fround(f18 * f17);
  f19 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f16 * f19));
  f6 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f20 * f6));
  f7 = Math_fround(Math_fround(f17 * f5) + Math_fround(Math_fround(f18 * f14) + Math_fround(f15 * Math_fround(Math_fround(f20 * f19) - Math_fround(f16 * f6)))));
  f4 = Math_fround(Math_fround(f19 * f5) + Math_fround(Math_fround(f16 * f14) + Math_fround(f15 * Math_fround(Math_fround(f18 * f6) - Math_fround(f20 * f17)))));
  f5 = Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(f15 * Math_fround(Math_fround(f16 * f17) - Math_fround(f18 * f19)))) + Math_fround(f6 * f5));
  HEAPF32[i12 >> 2] = f7;
  i8 = i12 + 4 | 0;
  HEAPF32[i8 >> 2] = f4;
  i9 = i12 + 8 | 0;
  HEAPF32[i9 >> 2] = f5;
  f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)) + Math_fround(f5 * f5));
  if (f6 > Math_fround(0.0)) {
   f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
   f18 = Math_fround(f7 * f20);
   f19 = Math_fround(f4 * f20);
   f20 = Math_fround(f5 * f20);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = 0;
   i2 = 0;
   i3 = 0;
  }
  HEAP32[i12 >> 2] = i3;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  f20 = Math_fround(Math_sqrt(Math_fround(f10)));
  HEAPF32[i13 >> 2] = f20;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 64 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN6HelperI14SafeBinaryRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2451 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2452 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2453 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2454 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2455 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2456 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2457 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2458 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2459 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2460 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2461 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2455 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2453 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2462 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2463 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2464 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2465 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2466 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2467 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2468 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2469 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2470 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2471 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2472 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2473 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2474 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2475 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2476 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2451 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2452 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2453 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2454 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2455 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2456 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2457 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2458 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2459 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2460 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2461 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2455 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2453 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx23NpArticulationLinkArray17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i10 >> 2] = HEAP32[gb + 123428 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 123428 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 123428 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 123428 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 123428 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 123428 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 123428 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 123428 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 123460 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 123460 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 123460 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 123460 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 123460 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 123460 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 123460 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 123460 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 123492 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 123492 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 123492 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 123492 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 123492 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 123492 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 123492 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 123492 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123524 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123524 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123524 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123524 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123524 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123524 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123524 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123524 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 123556 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123556 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123556 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123556 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123556 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123556 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123556 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123556 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123588 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123588 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123588 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123588 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123588 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123588 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123588 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123588 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123620 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123620 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123620 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123620 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123620 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123620 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123620 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123620 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123652 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123652 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123652 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123652 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123652 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123652 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123652 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123652 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj(i5, i14) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 16 | 0;
 i12 = i15;
 i6 = i5 & 15;
 i13 = gb + 1467184 + (i6 << 2) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) {
  i12 = i1;
  i13 = i2;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  STACKTOP = i15;
  return i13 | 0;
 }
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(6936, 16, gb + 63232 | 0, 0, gb + 930529 | 0, 47) | 0;
 if (!(i5 & 1)) {
  i8 = 1;
  i1 = __ZL18AddSliverTrianglesPjjii(i10, 0, 0, i6) | 0;
 } else {
  i8 = 0;
  i1 = 0;
 }
 if (!(i5 & 2)) {
  i9 = 15;
  i1 = __ZL18AddSliverTrianglesPjjii(i10, i1, 1, i6) | 0;
 } else i9 = 16;
 if (!(i5 & 4)) {
  i2 = 2;
  i3 = i1;
  while (1) {
   i4 = i2 * 17 | 0;
   i16 = i4 + 16 | 0;
   HEAP32[i10 + (i3 << 2) >> 2] = i16;
   i7 = ((i2 | 1) * 17 | 0) + 15 | 0;
   HEAP32[i10 + (i3 + 1 << 2) >> 2] = i7;
   HEAP32[i10 + (i3 + 2 << 2) >> 2] = i4 + 15;
   HEAP32[i10 + (i3 + 3 << 2) >> 2] = i7;
   HEAP32[i10 + (i3 + 4 << 2) >> 2] = i16;
   i16 = i4 + 50 | 0;
   HEAP32[i10 + (i3 + 5 << 2) >> 2] = i16;
   HEAP32[i10 + (i3 + 6 << 2) >> 2] = i16;
   HEAP32[i10 + (i3 + 7 << 2) >> 2] = i4 + 49;
   HEAP32[i10 + (i3 + 8 << 2) >> 2] = i7;
   i2 = i2 + 2 | 0;
   if ((i2 | 0) >= 14) break; else i3 = i3 + 9 | 0;
  }
  i7 = 15;
  i1 = i1 + 54 | 0;
 } else i7 = 16;
 if (!(i5 & 8)) {
  i2 = 2;
  i3 = i1;
  while (1) {
   i16 = i2 * 17 | 0;
   HEAP32[i10 + (i3 << 2) >> 2] = i16;
   HEAP32[i10 + (i3 + 1 << 2) >> 2] = i16 | 1;
   i4 = ((i2 | 1) * 17 | 0) + 1 | 0;
   HEAP32[i10 + (i3 + 2 << 2) >> 2] = i4;
   HEAP32[i10 + (i3 + 3 << 2) >> 2] = i4;
   i17 = i16 + 34 | 0;
   HEAP32[i10 + (i3 + 4 << 2) >> 2] = i17;
   HEAP32[i10 + (i3 + 5 << 2) >> 2] = i16;
   HEAP32[i10 + (i3 + 6 << 2) >> 2] = i17;
   HEAP32[i10 + (i3 + 7 << 2) >> 2] = i4;
   HEAP32[i10 + (i3 + 8 << 2) >> 2] = i16 + 35;
   i2 = i2 + 2 | 0;
   if ((i2 | 0) >= 14) break; else i3 = i3 + 9 | 0;
  }
  i4 = 1;
  i1 = i1 + 54 | 0;
 } else i4 = 0;
 if ((i5 & 5 | 0) != 5) i1 = __ZL15AddSliverCornerPjjii(i10, i1, 0, i6) | 0;
 if ((i5 & 6 | 0) != 6) i1 = __ZL15AddSliverCornerPjjii(i10, i1, 1, i6) | 0;
 if ((i5 & 9 | 0) != 9) i1 = __ZL15AddSliverCornerPjjii(i10, i1, 2, i6) | 0;
 if ((i5 & 10 | 0) != 10) i1 = __ZL15AddSliverCornerPjjii(i10, i1, 3, i6) | 0;
 if (i8 >>> 0 < i9 >>> 0) do {
  i3 = i4;
  i4 = i4 + 1 | 0;
  i2 = i8;
  do {
   i16 = i2 * 17 | 0;
   i6 = i16 + i3 | 0;
   HEAP32[i10 + (i1 << 2) >> 2] = i6;
   HEAP32[i10 + (i1 + 1 << 2) >> 2] = i16 + i4;
   i2 = i2 + 1 | 0;
   i16 = i2 * 17 | 0;
   i17 = i16 + i4 | 0;
   HEAP32[i10 + (i1 + 2 << 2) >> 2] = i17;
   HEAP32[i10 + (i1 + 3 << 2) >> 2] = i6;
   HEAP32[i10 + (i1 + 4 << 2) >> 2] = i17;
   i17 = i1;
   i1 = i1 + 6 | 0;
   HEAP32[i10 + (i17 + 5 << 2) >> 2] = i16 + i3;
  } while ((i2 | 0) < (i9 | 0));
 } while ((i4 | 0) < (i7 | 0));
 HEAP32[i14 >> 2] = i1;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z8StripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i10, HEAP32[i14 >> 2] | 0, i12) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 63232 | 0);
 i3 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i14 >> 2] = i3 >> 2;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 >> 1, 16, gb + 63232 | 0, 0, gb + 930529 | 0, 119) | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = 0;
  do {
   HEAP16[i3 + (i1 << 1) >> 1] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 i2 = i4;
 if (i4) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) HEAP32[i5 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i16 = i1;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 HEAP32[i14 >> 2] = i16;
 STACKTOP = i15;
 return i17 | 0;
}

function __Z12RangedRandomR5RandNRKiS2_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) < (i1 | 0)) {
  i6 = i1 - i5 | 0;
  i15 = HEAP32[i3 >> 2] | 0;
  i12 = i3 + 4 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i9 = i3 + 8 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i19 = i3 + 12 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  i15 = i15 << 11 ^ i15;
  i13 = i13 << 11 ^ i13;
  i10 = i10 << 11 ^ i10;
  i7 = i7 << 11 ^ i7;
  i5 = i3 + 16 | 0;
  i8 = i3 + 20 | 0;
  i16 = HEAP32[i8 >> 2] | 0;
  i11 = i3 + 24 | 0;
  i17 = HEAP32[i11 >> 2] | 0;
  i1 = i3 + 28 | 0;
  i18 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 >> 2] = i16;
  HEAP32[i9 >> 2] = i17;
  HEAP32[i19 >> 2] = i18;
  i19 = i3 + 32 | 0;
  i18 = i3 + 36 | 0;
  i9 = HEAP32[i18 >> 2] | 0;
  i17 = i3 + 40 | 0;
  i12 = HEAP32[i17 >> 2] | 0;
  i16 = i3 + 44 | 0;
  i14 = HEAP32[i16 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i8 >> 2] = i9;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i1 >> 2] = i14;
  i1 = i3 + 48 | 0;
  i14 = HEAP32[i1 >> 2] | 0;
  i11 = i3 + 52 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i8 = i3 + 56 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i3 = i3 + 60 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i19 >> 2] = i14;
  HEAP32[i18 >> 2] = i12;
  HEAP32[i17 >> 2] = i9;
  HEAP32[i16 >> 2] = i5;
  HEAP32[i1 >> 2] = i15 >>> 8 ^ i15 ^ i14 ^ i14 >>> 19;
  HEAP32[i11 >> 2] = i13 >>> 8 ^ i13 ^ i12 ^ i12 >>> 19;
  HEAP32[i8 >> 2] = i10 >>> 8 ^ i10 ^ i9 ^ i9 >>> 19;
  HEAP32[i3 >> 2] = i7 >>> 8 ^ i7 ^ i5 ^ i5 >>> 19;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = (((HEAP32[i2 + 4 >> 2] | 0) >>> 0) % (i6 >>> 0) | 0) + i1 | 0;
  i4 = (((HEAP32[i2 + 8 >> 2] | 0) >>> 0) % (i6 >>> 0) | 0) + i1 | 0;
  i5 = (((HEAP32[i2 + 12 >> 2] | 0) >>> 0) % (i6 >>> 0) | 0) + i1 | 0;
  HEAP32[i2 >> 2] = (((HEAP32[i2 >> 2] | 0) >>> 0) % (i6 >>> 0) | 0) + i1;
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i5;
  return;
 }
 if ((i1 | 0) < (i5 | 0)) {
  i16 = i5 - i1 | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  i10 = i3 + 4 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i13 = i3 + 8 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i20 = i3 + 12 | 0;
  i19 = HEAP32[i20 >> 2] | 0;
  i7 = i7 << 11 ^ i7;
  i9 = i9 << 11 ^ i9;
  i12 = i12 << 11 ^ i12;
  i19 = i19 << 11 ^ i19;
  i17 = i3 + 16 | 0;
  i14 = i3 + 20 | 0;
  i6 = HEAP32[i14 >> 2] | 0;
  i11 = i3 + 24 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i15 = i3 + 28 | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i10 >> 2] = i6;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i20 >> 2] = i1;
  i20 = i3 + 32 | 0;
  i1 = i3 + 36 | 0;
  i13 = HEAP32[i1 >> 2] | 0;
  i5 = i3 + 40 | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  i6 = i3 + 44 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i14 >> 2] = i13;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i15 >> 2] = i8;
  i15 = i3 + 48 | 0;
  i8 = HEAP32[i15 >> 2] | 0;
  i11 = i3 + 52 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i14 = i3 + 56 | 0;
  i13 = HEAP32[i14 >> 2] | 0;
  i17 = i3 + 60 | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  HEAP32[i20 >> 2] = i8;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i5 >> 2] = i13;
  HEAP32[i6 >> 2] = i18;
  HEAP32[i15 >> 2] = i7 >>> 8 ^ i7 ^ i8 ^ i8 >>> 19;
  HEAP32[i11 >> 2] = i9 >>> 8 ^ i9 ^ i10 ^ i10 >>> 19;
  HEAP32[i14 >> 2] = i12 >>> 8 ^ i12 ^ i13 ^ i13 >>> 19;
  HEAP32[i17 >> 2] = i19 >>> 8 ^ i19 ^ i18 ^ i18 >>> 19;
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i15 = HEAP32[i4 >> 2] | 0;
  i17 = i15 - (((HEAP32[i2 + 4 >> 2] | 0) >>> 0) % (i16 >>> 0) | 0) | 0;
  i18 = i15 - (((HEAP32[i2 + 8 >> 2] | 0) >>> 0) % (i16 >>> 0) | 0) | 0;
  i19 = i15 - (((HEAP32[i2 + 12 >> 2] | 0) >>> 0) % (i16 >>> 0) | 0) | 0;
  HEAP32[i2 >> 2] = i15 - (((HEAP32[i2 >> 2] | 0) >>> 0) % (i16 >>> 0) | 0);
  HEAP32[i2 + 4 >> 2] = i17;
  HEAP32[i2 + 8 >> 2] = i18;
  HEAP32[i2 + 12 >> 2] = i19;
  return;
 } else {
  HEAP32[i2 + 12 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 >> 2] = i5;
  return;
 }
}

function __ZN6HelperI17RemapPPtrTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2479 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2480 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2481 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2482 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2483 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2484 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2485 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2486 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2487 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2488 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2489 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2483 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2481 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2490 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2491 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2492 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2493 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2494 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2495 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2496 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2497 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2498 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2499 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2500 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2501 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2502 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2503 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2504 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2479 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2480 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2481 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2482 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2483 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2484 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2485 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2486 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2487 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2488 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2489 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2483 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2481 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx53PxVehicleDriveSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i6, i14, i12, f15, i13, i5, i16) {
 i6 = i6 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 f15 = Math_fround(f15);
 i13 = i13 | 0;
 i5 = i5 | 0;
 i16 = i16 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i17 = 0;
 i17 = HEAP8[i12 + 33 >> 0] | 0;
 HEAP8[i16 + 65 >> 0] = HEAP8[i12 + 32 >> 0] | 0;
 HEAP8[i16 + 66 >> 0] = i17;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f4 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i16, 0));
 f1 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 if (f4 < f1) {
  f11 = Math_fround(Math_fround(f2 * f15) + f4);
  f1 = f11 < f1 ? f11 : f1;
 } else {
  f11 = Math_fround(f4 - Math_fround(f3 * f15));
  f1 = f11 > f1 ? f11 : f1;
 }
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i16, 0, f1);
 f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 68 >> 2]);
 f3 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i16, 1));
 f4 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 if (f3 < f4) {
  f1 = Math_fround(Math_fround(f1 * f15) + f3);
  f1 = f1 < f4 ? f1 : f4;
 } else {
  f1 = Math_fround(f3 - Math_fround(f2 * f15));
  f1 = f1 > f4 ? f1 : f4;
 }
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i16, 1, f1);
 f1 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 72 >> 2]);
 f3 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i16, 2));
 f4 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 if (f3 < f4) {
  f1 = Math_fround(Math_fround(f1 * f15) + f3);
  f1 = f1 < f4 ? f1 : f4;
 } else {
  f1 = Math_fround(f3 - Math_fround(f2 * f15));
  f1 = f1 > f4 ? f1 : f4;
 }
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i16, 2, f1);
 f8 = Math_fround(Math_abs(Math_fround(__ZNK5physx15PxVehicleWheels19computeForwardSpeedEv(i5))));
 f11 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 80 >> 2]);
 f10 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i16, 4));
 f10 = Math_fround(f10 - Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i16, 3)));
 f7 = Math_fround(HEAPF32[i12 + 28 >> 2]);
 L13 : do if (i13) f1 = Math_fround(1.0); else {
  i6 = HEAP32[i14 + 64 >> 2] | 0;
  switch (i6 | 0) {
  case 0:
   {
    f1 = Math_fround(0.0);
    break L13;
   }
  case 1:
   break;
  default:
   {
    f1 = Math_fround(HEAPF32[i14 >> 2]);
    if (!(f1 > f8)) {
     i5 = 1;
     f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
     while (1) {
      i17 = i5 << 1;
      f3 = f1;
      f1 = Math_fround(HEAPF32[i14 + (i17 << 2) >> 2]);
      f2 = f4;
      f4 = Math_fround(HEAPF32[i14 + ((i17 | 1) << 2) >> 2]);
      i5 = i5 + 1 | 0;
      if (f3 <= f8 & f1 > f8) {
       i5 = 17;
       break;
      }
      if (i5 >>> 0 >= i6 >>> 0) {
       i5 = 18;
       break;
      }
     }
     if ((i5 | 0) == 17) {
      f1 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f8 - f3) * Math_fround(f4 - f2)) / Math_fround(f1 - f3)));
      break L13;
     } else if ((i5 | 0) == 18) {
      f1 = Math_fround(HEAPF32[i14 + (((i6 << 1) + -2 | 1) << 2) >> 2]);
      break L13;
     }
    }
   }
  }
  f1 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 } while (0);
 f1 = Math_fround(f7 * f1);
 do if (f1 == Math_fround(0.0)) {
  if (f10 > Math_fround(0.0)) {
   f1 = Math_fround(f10 - Math_fround(f9 * f15));
   i17 = f1 > Math_fround(0.0);
   f1 = i17 ? f1 : Math_fround(0.0);
   break;
  }
  if (f10 < Math_fround(0.0)) {
   f1 = Math_fround(Math_fround(f9 * f15) + f10);
   i17 = f1 < Math_fround(0.0);
   f1 = i17 ? f1 : Math_fround(0.0);
  } else f1 = Math_fround(0.0);
 } else if (f10 < f1) if (f10 < Math_fround(0.0)) {
  f15 = Math_fround(Math_fround(f9 * f15) + f10);
  f1 = f15 < f1 ? f15 : f1;
  break;
 } else {
  f15 = Math_fround(Math_fround(f11 * f15) + f10);
  f1 = f15 < f1 ? f15 : f1;
  break;
 } else if (f10 > Math_fround(0.0)) {
  f15 = Math_fround(f10 - Math_fround(f9 * f15));
  f1 = f15 > f1 ? f15 : f1;
  break;
 } else {
  f15 = Math_fround(f10 - Math_fround(f11 * f15));
  f1 = f15 > f1 ? f15 : f1;
  break;
 } while (0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i16, 3, Math_fround(0.0));
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i16, 4, f1);
 return;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_S5_(i1, i4, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 752 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 720 | 0;
 i6 = i5 + 704 | 0;
 i43 = i5 + 688 | 0;
 i40 = i5 + 672 | 0;
 i37 = i5 + 656 | 0;
 i41 = i5 + 640 | 0;
 i38 = i5 + 624 | 0;
 i35 = i5 + 608 | 0;
 i23 = i5 + 592 | 0;
 i46 = i5 + 576 | 0;
 i20 = i5 + 560 | 0;
 i45 = i5 + 544 | 0;
 i17 = i5 + 528 | 0;
 i44 = i5 + 512 | 0;
 i22 = i5 + 496 | 0;
 i42 = i5 + 480 | 0;
 i19 = i5 + 464 | 0;
 i39 = i5 + 448 | 0;
 i16 = i5 + 432 | 0;
 i36 = i5 + 416 | 0;
 i28 = i5 + 400 | 0;
 i34 = i5 + 384 | 0;
 i33 = i5 + 368 | 0;
 i27 = i5 + 352 | 0;
 i32 = i5 + 336 | 0;
 i31 = i5 + 320 | 0;
 i25 = i5 + 304 | 0;
 i30 = i5 + 288 | 0;
 i29 = i5 + 272 | 0;
 i26 = i5 + 240 | 0;
 i24 = i5 + 208 | 0;
 i14 = i5 + 192 | 0;
 i13 = i5 + 176 | 0;
 i21 = i5 + 160 | 0;
 i11 = i5 + 144 | 0;
 i18 = i5 + 128 | 0;
 i9 = i5 + 112 | 0;
 i15 = i5 + 96 | 0;
 i12 = i5 + 64 | 0;
 i10 = i5 + 32 | 0;
 i7 = i5;
 i47 = i4 + 384 | 0;
 __Z5splatILj0EE8Scalar4fRKS0_(i43, i47);
 __Z5splatILj1EE8Scalar4fRKS0_(i40, i47);
 __Z5splatILj2EE8Scalar4fRKS0_(i37, i47);
 i47 = i4 + 400 | 0;
 __Z5splatILj0EE8Scalar4fRKS0_(i41, i47);
 __Z5splatILj1EE8Scalar4fRKS0_(i38, i47);
 __Z5splatILj2EE8Scalar4fRKS0_(i35, i47);
 __ZmlRK8Scalar4fS1_(i46, i3, i43);
 __ZplRK8Scalar4fS1_(i23, i46, i41);
 __ZmlRK8Scalar4fS1_(i45, i3 + 16 | 0, i40);
 __ZplRK8Scalar4fS1_(i20, i45, i38);
 __ZmlRK8Scalar4fS1_(i44, i3 + 32 | 0, i37);
 __ZplRK8Scalar4fS1_(i17, i44, i35);
 __ZmlRK8Scalar4fS1_(i42, i2, i43);
 __ZplRK8Scalar4fS1_(i22, i42, i41);
 __ZmlRK8Scalar4fS1_(i39, i2 + 16 | 0, i40);
 __ZplRK8Scalar4fS1_(i19, i39, i38);
 __ZmlRK8Scalar4fS1_(i36, i2 + 32 | 0, i37);
 __ZplRK8Scalar4fS1_(i16, i36, i35);
 __Z3maxRK8Scalar4fS1_(i34, i23, i22);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i33, gb + 1097696 | 0);
 __Z3minRK8Scalar4fS1_(i28, i34, i33);
 __Z3maxRK8Scalar4fS1_(i32, i20, i19);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i31, gb + 1097696 | 0);
 __Z3minRK8Scalar4fS1_(i27, i32, i31);
 __Z3maxRK8Scalar4fS1_(i30, i17, i16);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i29, gb + 1097696 | 0);
 __Z3minRK8Scalar4fS1_(i25, i30, i29);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i1, i28, i4, i4 + 192 | 0);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i26, i27, i4 + 32 | 0, i4 + 224 | 0);
 __ZanRK8Scalar4fS1_(i8, i1, i26);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 i3 = i1 + 16 | 0;
 __ZanRK8Scalar4fS1_(i6, i3, i26 + 16 | 0);
 __ZN8Scalar4faSERKS_(i3, i6) | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i24, i25, i4 + 64 | 0, i4 + 256 | 0);
 __ZanRK8Scalar4fS1_(i8, i1, i24);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 __ZanRK8Scalar4fS1_(i6, i3, i24 + 16 | 0);
 __ZN8Scalar4faSERKS_(i3, i6) | 0;
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i14, i5 + 736 | 0);
 __Z3minRK8Scalar4fS1_(i21, i23, i22);
 __Z3maxRK8Scalar4fS1_(i13, i21, i14);
 __Z3minRK8Scalar4fS1_(i18, i20, i19);
 __Z3maxRK8Scalar4fS1_(i11, i18, i14);
 __Z3minRK8Scalar4fS1_(i15, i17, i16);
 __Z3maxRK8Scalar4fS1_(i9, i15, i14);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i12, i13, i4 + 96 | 0, i4 + 288 | 0);
 __ZanRK8Scalar4fS1_(i8, i1, i12);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 __ZanRK8Scalar4fS1_(i6, i3, i12 + 16 | 0);
 __ZN8Scalar4faSERKS_(i3, i6) | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i10, i11, i4 + 128 | 0, i4 + 320 | 0);
 __ZanRK8Scalar4fS1_(i8, i1, i10);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 __ZanRK8Scalar4fS1_(i6, i3, i10 + 16 | 0);
 __ZN8Scalar4faSERKS_(i3, i6) | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i7, i9, i4 + 160 | 0, i4 + 352 | 0);
 __ZanRK8Scalar4fS1_(i8, i1, i7);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 __ZanRK8Scalar4fS1_(i6, i3, i7 + 16 | 0);
 __ZN8Scalar4faSERKS_(i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN6HelperI9JSONWrite23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 4400 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 4401 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 4402 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 4403 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 4404 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 4405 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 4406 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 4407 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 4408 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 4409 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 4410 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 4404 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 4402 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 4411 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 4412 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 4413 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 4414 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 4415 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 4416 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 4417 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 4418 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 4419 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 4420 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 4421 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 4422 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 4423 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 4424 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 4425 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 4400 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 4401 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 4402 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 4403 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 4404 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 4405 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 4406 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 4407 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 4408 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 4409 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 4410 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 4404 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 4402 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN6HelperI14SafeBinaryRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 2424 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 2425 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 2426 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 2427 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 2428 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 2429 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 2430 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 2431 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 2432 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 2433 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 2434 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 2428 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 2426 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 2435 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 2436 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 2437 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 2438 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 2439 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 2440 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 2441 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 2442 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 2443 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 2444 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 2445 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 2446 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 2447 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 2448 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 2449 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 2424 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 2425 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 2426 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 2427 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 2428 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 2429 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 2430 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 2431 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 2432 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 2433 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 2434 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 2428 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 2426 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx23PxcContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i7, i11, i19, i2, i14, i1, i24) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i23 + 8 | 0;
 i16 = i23;
 i12 = i19 + 16 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f3 * Math_fround(2.0));
 f21 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(f21 * Math_fround(2.0));
 f21 = Math_fround(Math_fround(f3 * f6) + Math_fround(Math_fround(f21 * f17) + Math_fround(-1.0)));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f3 * f17);
 f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f6 * f22));
 f22 = Math_fround(Math_fround(f6 * f3) - Math_fround(f17 * f22));
 f17 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f21 = Math_fround(f17 * f21);
 f18 = Math_fround(f17 * f18);
 f22 = Math_fround(f17 * f22);
 f17 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f3 = Math_fround(f17 + f21);
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f4 = Math_fround(f6 + f18);
 f13 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f5 = Math_fround(f22 + f13);
 HEAPF32[i15 >> 2] = f3;
 i1 = i15 + 4 | 0;
 HEAPF32[i1 >> 2] = f4;
 i2 = i15 + 8 | 0;
 HEAPF32[i2 >> 2] = f5;
 f18 = Math_fround(f6 - f18);
 f22 = Math_fround(f13 - f22);
 i8 = i15 + 12 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f17 - f21);
 i9 = i15 + 16 | 0;
 HEAPF32[i9 >> 2] = f18;
 i10 = i15 + 20 | 0;
 HEAPF32[i10 >> 2] = f22;
 i20 = i7 + 4 | 0;
 f22 = Math_fround(HEAPF32[i20 >> 2]);
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i11 + 4 >> 2]));
 f18 = Math_fround(f22 + Math_fround(HEAPF32[i14 >> 2]));
 f21 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i15, i15 + 12 | 0, i12, i16));
 if (!(f21 < Math_fround(f18 * f18))) {
  i24 = 0;
  STACKTOP = i23;
  return i24 | 0;
 }
 f18 = Math_fround(HEAPF32[i16 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f5 = Math_fround(f5 - f4);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f6 - f13);
 f17 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f4 + Math_fround(f18 * f5));
 f6 = Math_fround(f13 + Math_fround(f18 * f6));
 f3 = Math_fround(f3 + Math_fround(f18 * Math_fround(f17 - f3)));
 f17 = Math_fround(HEAPF32[i12 >> 2]);
 f5 = Math_fround(f17 - f5);
 f18 = Math_fround(HEAPF32[i19 + 20 >> 2]);
 f6 = Math_fround(f18 - f6);
 f13 = Math_fround(HEAPF32[i19 + 24 >> 2]);
 f3 = Math_fround(f13 - f3);
 f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f3 * f3));
 if (f4 == Math_fround(0.0)) {
  i7 = 0;
  i8 = 1065353216;
  i9 = 0;
 } else {
  f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f5 = Math_fround(f5 * f4);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  f6 = Math_fround(f6 * f4);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  f6 = Math_fround(f3 * f4);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f3 = Math_fround(HEAPF32[i20 >> 2]);
 i1 = i24 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i24 = 1;
  STACKTOP = i23;
  return i24 | 0;
 }
 f22 = Math_fround(Math_fround(Math_sqrt(Math_fround(f21))) - f22);
 f21 = Math_fround(f13 - Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3));
 f18 = Math_fround(f18 - Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3));
 f17 = Math_fround(f17 - Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3));
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i24 + (i2 << 6) >> 2] = i8;
 HEAP32[i24 + (i2 << 6) + 4 >> 2] = i7;
 HEAP32[i24 + (i2 << 6) + 8 >> 2] = i9;
 HEAPF32[i24 + (i2 << 6) + 16 >> 2] = f17;
 HEAPF32[i24 + (i2 << 6) + 20 >> 2] = f18;
 HEAPF32[i24 + (i2 << 6) + 24 >> 2] = f21;
 HEAPF32[i24 + (i2 << 6) + 12 >> 2] = f22;
 HEAP32[i24 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i24 + (i2 << 6) + 52 >> 2] = -1;
 i24 = 1;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZN9Scripting26DestroyObjectFromScriptingE4PPtrI6ObjectEf(i12, f14) {
 i12 = i12 | 0;
 f14 = Math_fround(f14);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 8 | 0;
 i11 = i15;
 if (!(__Z14IsWorldPlayingv() | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 465401 | 0, 0, gb + 465174 | 0, 463, 1, 0, 0, 0);
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i11 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i13 = 11;
 }
 if ((i13 | 0) == 9) i13 = 11;
 if ((i13 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 if (f14 <= Math_fround(0.0)) {
  i1 = __Z17dynamic_pptr_castIP9Behaviour6ObjectET_RK4PPtrIT0_E(i12) | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 0);
  i4 = __Z17dynamic_pptr_castIP10GameObject6ObjectET_RK4PPtrIT0_E(i12) | 0;
  if (i4 | 0) {
   i5 = i4 + 40 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    i6 = i4 + 28 | 0;
    i3 = 0;
    do {
     i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
     if (i2) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29672 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29672 + 28 >> 2] | 0) >>> 0) {
      mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, 0);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
   i9 = i1 + 92 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i8 = i1 + 80 | 0;
    i7 = 0;
    i1 = i2;
    do {
     i2 = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0) + 28 >> 2] | 0;
     i6 = i2 + 40 | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     if (i3) {
      i5 = i2 + 28 | 0;
      i4 = 0;
      i1 = i3;
      do {
       i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
       if (i2) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29672 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29672 + 28 >> 2] | 0) >>> 0) {
        mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, 0);
        i1 = HEAP32[i6 >> 2] | 0;
       }
       i4 = i4 + 1 | 0;
      } while (i4 >>> 0 < i1 >>> 0);
      i1 = HEAP32[i9 >> 2] | 0;
     }
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) < (i1 | 0));
   }
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i11 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 38; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
    i2 = HEAP32[i10 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 38; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0;
 } while (0);
 __Z20DestroyObjectDelayedP6Objectf(i1, f14);
 STACKTOP = i15;
 return;
}

function __ZN6HelperI8JSONRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 4344 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 4345 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 4346 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 4347 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 4348 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 4349 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 4350 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 4351 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 4352 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 4353 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 4354 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 4348 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 4346 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 4355 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 4356 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 4357 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 4358 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 4359 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 4360 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 4361 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 4362 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 4363 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 4364 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 4365 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 4366 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 4367 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 4368 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 4369 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 4344 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 4345 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 4346 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 4347 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 4348 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 4349 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 4350 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 4351 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 4352 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 4353 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 4354 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 4348 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 4346 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx16NpConnectorArray17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i10 >> 2] = HEAP32[gb + 122468 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 122468 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 122468 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 122468 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 122468 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 122468 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 122468 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 122468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 122500 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 122500 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 122500 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 122500 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 122500 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 122500 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 122500 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 122500 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122532 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122532 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122532 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122532 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122532 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122532 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122532 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122532 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 122564 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122564 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122564 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122564 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122564 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122564 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122564 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122564 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122596 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122596 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122596 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122596 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122596 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122596 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122596 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122596 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122628 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122628 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122628 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122628 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122628 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122628 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122628 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122628 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122660 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122660 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122660 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122660 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122660 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122660 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122660 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122660 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122692 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122692 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122692 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122692 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122692 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122692 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122692 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122692 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx54PxVehicleDriveSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i6, i12, i5, f2, i9, i8, i13) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 i9 = i9 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f7 = f0, f10 = f0, f11 = f0, i14 = 0;
 i14 = HEAP8[i5 + 32 >> 0] | 0;
 HEAP8[i13 + 66 >> 0] = HEAP8[i5 + 33 >> 0] | 0;
 HEAP8[i13 + 65 >> 0] = i14;
 i14 = (HEAP8[i5 + 4 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i13, 0));
 if (i14) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i6 + 64 >> 2]) * f2)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f2));
 i14 = f1 < Math_fround(0.0);
 f1 = i14 ? Math_fround(0.0) : f1;
 i14 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 0, i14 ? Math_fround(1.0) : f1);
 i14 = (HEAP8[i5 + 5 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i13, 1));
 if (i14) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i6 + 68 >> 2]) * f2)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * f2));
 i14 = f1 < Math_fround(0.0);
 f1 = i14 ? Math_fround(0.0) : f1;
 i14 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 1, i14 ? Math_fround(1.0) : f1);
 i14 = (HEAP8[i5 + 6 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i13, 2));
 if (i14) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i6 + 72 >> 2]) * f2)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) * f2));
 i14 = f1 < Math_fround(0.0);
 f1 = i14 ? Math_fround(0.0) : f1;
 i14 = f1 > Math_fround(1.0);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 2, i14 ? Math_fround(1.0) : f1);
 i14 = (HEAP8[i5 + 7 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i13, 3));
 if (i14) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i6 + 76 >> 2]) * f2)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i6 + 12 >> 2]) * f2));
 i14 = f1 < Math_fround(0.0);
 f11 = i14 ? Math_fround(0.0) : f1;
 i14 = f11 > Math_fround(1.0);
 f11 = i14 ? Math_fround(1.0) : f11;
 i14 = (HEAP8[i5 + 8 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i13, 4));
 if (i14) f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i6 + 80 >> 2]) * f2)); else f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i6 + 16 >> 2]) * f2));
 i14 = f1 < Math_fround(0.0);
 f10 = i14 ? Math_fround(0.0) : f1;
 i14 = f10 > Math_fround(1.0);
 f10 = i14 ? Math_fround(1.0) : f10;
 f7 = Math_fround(Math_abs(Math_fround(__ZNK5physx15PxVehicleWheels19computeForwardSpeedEv(i8))));
 L21 : do if (i9) f1 = Math_fround(1.0); else {
  i6 = HEAP32[i12 + 64 >> 2] | 0;
  switch (i6 | 0) {
  case 0:
   {
    f1 = Math_fround(0.0);
    break L21;
   }
  case 1:
   break;
  default:
   {
    f1 = Math_fround(HEAPF32[i12 >> 2]);
    if (!(f1 > f7)) {
     i5 = 1;
     f4 = Math_fround(HEAPF32[i12 + 4 >> 2]);
     while (1) {
      i14 = i5 << 1;
      f3 = f1;
      f1 = Math_fround(HEAPF32[i12 + (i14 << 2) >> 2]);
      f2 = f4;
      f4 = Math_fround(HEAPF32[i12 + ((i14 | 1) << 2) >> 2]);
      i5 = i5 + 1 | 0;
      if (f3 <= f7 & f1 > f7) {
       i5 = 23;
       break;
      }
      if (i5 >>> 0 >= i6 >>> 0) {
       i5 = 24;
       break;
      }
     }
     if ((i5 | 0) == 23) {
      f1 = Math_fround(f2 + Math_fround(Math_fround(Math_fround(f7 - f3) * Math_fround(f4 - f2)) / Math_fround(f1 - f3)));
      break L21;
     } else if ((i5 | 0) == 24) {
      f1 = Math_fround(HEAPF32[i12 + (((i6 << 1) + -2 | 1) << 2) >> 2]);
      break L21;
     }
    }
   }
  }
  f1 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 } while (0);
 f2 = Math_fround(Math_abs(Math_fround(f10 - f11)));
 if (!(f2 > f1)) {
  f7 = f11;
  f11 = f10;
  __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 3, f7);
  __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 4, f11);
  return;
 }
 f4 = Math_fround(f1 / f2);
 f7 = Math_fround(f11 * f4);
 f11 = Math_fround(f10 * f4);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 3, f7);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i13, 4, f11);
 return;
}

function __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i11, i14, i15, i12, i6) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
  break;
 } else {
  i1 = HEAP32[i11 >> 2] | 0;
  break;
 } while (0);
 i2 = (i1 | 0) == 0;
 i1 = HEAP32[i14 >> 2] | 0;
 do if (!i1) i13 = 11; else {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
   HEAP32[i14 >> 2] = 0;
   i13 = 11;
   break;
  }
  if (i2) i13 = 13; else i13 = 12;
 } while (0);
 if ((i13 | 0) == 11) if (i2) i13 = 12; else {
  i1 = 0;
  i13 = 13;
 }
 L16 : do if ((i13 | 0) == 12) {
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 6;
  i1 = 0;
 } else if ((i13 | 0) == 13) {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i2 = HEAPU8[i3 >> 0] | 0;
  i3 = i2 & 255;
  if (i3 << 24 >> 24 > -1) {
   i10 = i12 + 8 | 0;
   if (HEAP16[(HEAP32[i10 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 2048) {
    i2 = (mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, i3 | 0, 0) | 0) << 24 >> 24;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 12 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) {
     mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
     i5 = i1;
     i4 = i1;
    } else {
     HEAP32[i4 >> 2] = i5 + 1;
     i5 = i1;
     i4 = i1;
    }
    while (1) {
     i1 = i2 + -48 | 0;
     i8 = i6 + -1 | 0;
     i2 = HEAP32[i11 >> 2] | 0;
     do if (!i2) i2 = 0; else if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) == -1) {
      HEAP32[i11 >> 2] = 0;
      i2 = 0;
      break;
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      break;
     } while (0);
     i3 = (i2 | 0) == 0;
     if (!i4) {
      i9 = i5;
      i7 = 0;
     } else if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0) == -1) {
      HEAP32[i14 >> 2] = 0;
      i9 = 0;
      i7 = 0;
     } else {
      i9 = i5;
      i7 = i5;
     } else {
      i9 = i5;
      i7 = i4;
     }
     i2 = HEAP32[i11 >> 2] | 0;
     if (!((i6 | 0) > 1 & (i3 ^ (i7 | 0) == 0))) break;
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i2 = HEAPU8[i3 >> 0] | 0;
     i3 = i2 & 255;
     if (i3 << 24 >> 24 <= -1) break L16;
     if (!(HEAP16[(HEAP32[i10 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 2048)) break L16;
     i2 = ((mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, i3 | 0, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
     i1 = HEAP32[i11 >> 2] | 0;
     i3 = i1 + 12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i6 = i8;
      i5 = i9;
      i4 = i7;
      continue;
     } else {
      HEAP32[i3 >> 2] = i4 + 1;
      i6 = i8;
      i5 = i9;
      i4 = i7;
      continue;
     }
    }
    do if (!i2) i2 = 0; else if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) == -1) {
     HEAP32[i11 >> 2] = 0;
     i2 = 0;
     break;
    } else {
     i2 = HEAP32[i11 >> 2] | 0;
     break;
    } while (0);
    i2 = (i2 | 0) == 0;
    do if (!i9) i13 = 50; else {
     if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i9 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0) == -1) {
      HEAP32[i14 >> 2] = 0;
      i13 = 50;
      break;
     }
     if (i2) break L16;
    } while (0);
    if ((i13 | 0) == 50) if (!i2) break;
    HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 2;
    break;
   }
  }
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 4;
  i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZN5physx15PxCollectionExt16createCollectionERNS_7PxSceneE(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 56 | 0;
 i1 = i15 + 70 | 0;
 i2 = i15 + 52 | 0;
 i5 = i15 + 68 | 0;
 i7 = i15 + 40 | 0;
 i6 = i15 + 36 | 0;
 i8 = i15 + 32 | 0;
 i10 = i15 + 20 | 0;
 i9 = i15 + 16 | 0;
 i12 = i15 + 4 | 0;
 i11 = i15;
 i14 = __Z18PxCreateCollectionv() | 0;
 if (!i14) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i16 = HEAP32[(HEAP32[i13 >> 2] | 0) + 72 >> 2] | 0;
 HEAP16[i1 >> 1] = 47;
 i1 = mftCall_iii(i16 | 0, i13 | 0, i1 | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i16 = i3 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i4 = i3 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i3, i1, i2);
 i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + 76 >> 2] | 0;
 HEAP16[i5 >> 1] = 47;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 mftCall_iiiiii(i1 | 0, i13 | 0, i5 | 0, i2 | 0, i3 | 0, 0) | 0;
 if (i3 | 0) {
  i1 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, HEAP32[i2 + (i1 << 2) >> 2] | 0, 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i16 = HEAP32[i4 >> 2] | 0;
 if (!((i16 & 2147483647 | 0) == 0 | (i16 | 0) < 0 | (i2 | 0) == 0)) {
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 92 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i7, i1, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 96 >> 2] | 0, i13 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0, i3 | 0, i8 | 0) | 0;
   if (!(HEAP32[i8 >> 2] | 0)) mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i3 | 0, 0, 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 i16 = HEAP32[i5 >> 2] | 0;
 if (!((i16 & 2147483647 | 0) == 0 | (i16 | 0) < 0 | (i1 | 0) == 0)) {
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 84 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i2 = i10 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i10, i1, i9);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 88 >> 2] | 0, i13 | 0, i1 | 0, i2 | 0, 0) | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, HEAP32[i1 + (i3 << 2) >> 2] | 0, 0, 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 i16 = HEAP32[i4 >> 2] | 0;
 if (!((i16 & 2147483647 | 0) == 0 | (i16 | 0) < 0 | (i1 | 0) == 0)) {
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i3 = i12 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i12, i2, i11);
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 104 >> 2] | 0, i13 | 0, i2 | 0, i3 | 0, 0) | 0;
 if (i3 | 0) {
  i1 = 0;
  do {
   mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, HEAP32[i2 + (i1 << 2) >> 2] | 0, 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i16 = HEAP32[i4 >> 2] | 0;
 if ((i16 & 2147483647 | 0) == 0 | (i16 | 0) < 0 | (i2 | 0) == 0) {
  i16 = i14;
  STACKTOP = i15;
  return i16 | 0;
 }
 i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 | 0);
 i16 = i14;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPNS_15basic_streambufIcS2_EE(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i8 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i8;
  i3 = 29;
 } else {
  L4 : do if (HEAP8[i1 >> 0] | 0) {
   do if (!i6) {
    i7 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 4 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i3 = 10; else break L4;
   } else {
    i5 = i6 + 24 | 0;
    i4 = i6 + 28 | 0;
    while (1) {
     i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 11;
       break;
      }
      if ((i1 | 0) == -1) {
       i1 = 2;
       i3 = 21;
       break;
      }
     } else i1 = HEAPU8[i2 >> 0] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i1 & 255 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 17;
       break;
      }
      if ((i1 | 0) == -1) {
       i1 = 0;
       i3 = 21;
       break;
      }
     } else {
      HEAP32[i5 >> 2] = i2 + 1;
      HEAP8[i2 >> 0] = i1;
     }
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
     i2 = i1 + 12 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 17;
       break;
      } else continue;
     } else {
      HEAP32[i2 >> 2] = i3 + 1;
      continue;
     }
    }
    if ((i3 | 0) == 11) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 17) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 21) {
     i6 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | ((HEAP32[i7 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (!(i6 & 1)) break L4;
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
    ___cxa_begin_catch(i1 | 0) | 0;
    if (!(HEAP32[i7 >> 2] | 0)) {
     __THREW__ = 0;
     invoke_vi(fb + 3999 | 0, i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i1 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      __THREW__ = 0;
      invoke_v(fb + 458 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i3 = 34;
       break L1;
      } else break;
     }
    }
    __THREW__ = 0;
    invoke_v(fb + 458 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i3 = 10; else break L4;
   } while (0);
   if ((i3 | 0) == 10) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i2 = i8;
   i3 = 29;
   break L1;
  } while (0);
  i3 = 31;
 } while (0);
 do if ((i3 | 0) == 29) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i8 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   i3 = 31;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i3 = 34; else ___resumeException(i1 | 0);
 } while (0);
 if ((i3 | 0) == 31) {
  STACKTOP = i9;
  return i8 | 0;
 } else if ((i3 | 0) == 34) {
  i9 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i9);
 }
 return 0;
}

function __ZN6HelperI9JSONWrite18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 4373 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 4374 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 4375 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 4376 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 4377 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 4378 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 4379 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 4380 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 4381 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 4382 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 4383 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 4377 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 4375 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 4384 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 4385 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 4386 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 4387 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 4388 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 4389 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 4390 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 4391 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 4392 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 4393 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 4394 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 4395 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 4396 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 4397 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 4398 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 4373 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 4374 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 4375 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 4376 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 4377 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 4378 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 4379 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 4380 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 4381 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 4382 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 4383 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 4377 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 4375 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx2Gu17computeMTD_BoxBoxERNS_6PxVec3ERfRKNS0_3BoxES6_(i19, i18, i11, i12) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 16 | 0;
 i20 = i21 + 12 | 0;
 i13 = i21;
 HEAPF32[i20 >> 2] = Math_fround(3402823469999999843913219.0e14);
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i11, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i11 + 12 | 0, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i11 + 24 | 0, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i12, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i12 + 12 | 0, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i12 + 24 | 0, i11, i12) | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i1 = i13 + 4 | 0;
 i5 = i13 + 8 | 0;
 i15 = 0;
 L19 : do {
  i8 = i12 + (i15 * 12 | 0) + 8 | 0;
  i9 = i12 + (i15 * 12 | 0) + 4 | 0;
  i10 = i12 + (i15 * 12 | 0) | 0;
  i14 = 0;
  do {
   f4 = Math_fround(HEAPF32[i11 + (i14 * 12 | 0) + 4 >> 2]);
   f6 = Math_fround(HEAPF32[i8 >> 2]);
   f7 = Math_fround(f4 * f6);
   f23 = Math_fround(HEAPF32[i11 + (i14 * 12 | 0) + 8 >> 2]);
   f22 = Math_fround(HEAPF32[i9 >> 2]);
   f7 = Math_fround(f7 - Math_fround(f23 * f22));
   f2 = Math_fround(HEAPF32[i10 >> 2]);
   f23 = Math_fround(f23 * f2);
   f3 = Math_fround(HEAPF32[i11 + (i14 * 12 | 0) >> 2]);
   f6 = Math_fround(f23 - Math_fround(f6 * f3));
   f2 = Math_fround(Math_fround(f22 * f3) - Math_fround(f4 * f2));
   HEAPF32[i13 >> 2] = f7;
   HEAPF32[i1 >> 2] = f6;
   HEAPF32[i5 >> 2] = f2;
   if (+Math_fround(Math_abs(Math_fround(f7))) > 1.0e-06) i16 = 12; else if (+Math_fround(Math_abs(Math_fround(f6))) > 1.0e-06) i16 = 12; else if (+Math_fround(Math_abs(Math_fround(f2))) > 1.0e-06) i16 = 12;
   if ((i16 | 0) == 12) {
    i16 = 0;
    f3 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f2 * f2));
    if (f3 > Math_fround(0.0)) {
     f23 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
     f4 = Math_fround(f2 * f23);
     f3 = Math_fround(f6 * f23);
     f2 = Math_fround(f7 * f23);
    } else {
     f4 = Math_fround(0.0);
     f3 = Math_fround(0.0);
     f2 = Math_fround(0.0);
    }
    HEAPF32[i13 >> 2] = f2;
    HEAPF32[i1 >> 2] = f3;
    HEAPF32[i5 >> 2] = f4;
    if (!(__ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i17, i20, i13, i11, i12) | 0)) {
     i1 = 0;
     i16 = 20;
     break L19;
    }
   }
   i14 = i14 + 1 | 0;
  } while (i14 >>> 0 < 3);
  i15 = i15 + 1 | 0;
 } while (i15 >>> 0 < 3);
 if ((i16 | 0) == 20) {
  STACKTOP = i21;
  return i1 | 0;
 }
 f3 = Math_fround(HEAPF32[i12 + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 40 >> 2]);
 f23 = Math_fround(HEAPF32[i12 + 44 >> 2]);
 f2 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f22 = Math_fround(HEAPF32[i11 + 40 >> 2]);
 f2 = Math_fround(f3 - f2);
 f22 = Math_fround(f4 - f22);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i11 + 44 >> 2]));
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 f2 = Math_fround(f2 * f4);
 i1 = i17 + 4 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(f2 + Math_fround(f22 * f3));
 i5 = i17 + 8 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 if (Math_fround(f22 + Math_fround(f23 * f2)) < Math_fround(0.0)) {
  f4 = Math_fround(-f4);
  f3 = Math_fround(-f3);
  f2 = Math_fround(-f2);
  HEAPF32[i17 >> 2] = f4;
  HEAPF32[i1 >> 2] = f3;
  HEAPF32[i5 >> 2] = f2;
 }
 f22 = Math_fround(-f3);
 f23 = Math_fround(-f2);
 HEAPF32[i19 >> 2] = Math_fround(-f4);
 HEAPF32[i19 + 4 >> 2] = f22;
 HEAPF32[i19 + 8 >> 2] = f23;
 f23 = Math_fround(HEAPF32[i20 >> 2]);
 i20 = f23 > Math_fround(0.0);
 HEAPF32[i18 >> 2] = i20 ? f23 : Math_fround(0.0);
 i20 = 1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN9ShaderLab16FastPropertyName4InitEPKc(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 4 | 0;
 i6 = i12;
 i1 = HEAP32[gb + 1166568 >> 2] | 0;
 if (!i1) {
  i11 = HEAP32[gb + 1166572 >> 2] | 0;
  HEAP32[gb + 1166572 >> 2] = i11 + 1;
  HEAP32[gb + 1166576 + (i11 << 3) >> 2] = i2;
  HEAP32[gb + 1166576 + (i11 << 3) + 4 >> 2] = i7;
  STACKTOP = i12;
  return;
 }
 if (!(_strcmp(i7, gb + 480196 | 0) | 0)) {
  HEAP32[i2 >> 2] = -1;
  STACKTOP = i12;
  return;
 }
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i1 = i5;
  L10 : while (1) {
   i4 = i3;
   while (1) {
    if ((_strcmp(HEAP32[i4 + 16 >> 2] | 0, i7) | 0) >= 0) break;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i3) break L10; else i4 = i3;
   }
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) {
    i1 = i4;
    break;
   } else i1 = i4;
  }
  if ((i1 | 0) != (i5 | 0)) if (!((_strcmp(i7, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0 | (i1 | 0) == (i5 | 0))) {
   HEAP32[i2 >> 2] = HEAP32[i1 + 20 >> 2];
   STACKTOP = i12;
   return;
  }
 }
 HEAP32[i6 >> 2] = -1;
 do if (__Z20IsVectorBuiltinParamPKcPi(i7, i6) | 0) HEAP32[i2 >> 2] = HEAP32[i6 >> 2] | 1073741824; else {
  if (__Z20IsMatrixBuiltinParamPKcPi(i7, i6) | 0) {
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2] | -2147483648;
   break;
  }
  if (__Z20IsTexEnvBuiltinParamPKcPi(i7, i6) | 0) {
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2] | -1073741824;
   break;
  } else break;
 } while (0);
 i11 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1166404 >> 2] | 0, 0, 0) | 0;
 i1 = (_strlen(i7) | 0) + 1 | 0;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63280 | 0, 0, gb + 480206 | 0, 175) | 0;
 _memcpy(i6 | 0, i7 | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = (i1 | 0) != -1 & i1 >>> 0 > 1073741823;
 if (i8) i5 = i1; else {
  i5 = HEAP32[gb + 1170576 >> 2] | 0;
  HEAP32[gb + 1170576 >> 2] = i5 + 1;
  HEAP32[i2 >> 2] = i5;
 }
 i7 = HEAP32[gb + 1166568 >> 2] | 0;
 i9 = i6;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((_strcmp(i6, i2) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 25;
     break;
    } else i1 = i2;
   } else {
    if ((_strcmp(i2, i6) | 0) >= 0) {
     i2 = 30;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 29;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 25) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 29) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 30) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i10;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  HEAP32[i1 + 16 >> 2] = i9;
  HEAP32[i1 + 20 >> 2] = i5;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i10 = i7 + 8 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  if (!i8) {
   i2 = HEAP32[gb + 1170580 >> 2] | 0;
   i3 = i2 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i2 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i2 >> 2] = i10;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i9;
  }
 } else __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63280 | 0);
 if (i11) __Z19pop_allocation_rootv();
 STACKTOP = i12;
 return;
}

function __ZN6HelperI8JSONRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i5, i6, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 L1 : do switch (i4 | 0) {
 case 14:
  {
   i1 = fb + 4317 | 0;
   break;
  }
 case 4:
  {
   i1 = fb + 4318 | 0;
   break;
  }
 case 5:
  {
   i1 = fb + 4319 | 0;
   break;
  }
 case 6:
  {
   i1 = fb + 4320 | 0;
   break;
  }
 case 7:
  {
   i1 = fb + 4321 | 0;
   break;
  }
 case 8:
  {
   i1 = fb + 4322 | 0;
   break;
  }
 case 9:
  {
   i1 = fb + 4323 | 0;
   break;
  }
 case 10:
  {
   i1 = fb + 4324 | 0;
   break;
  }
 case 11:
  {
   i1 = fb + 4325 | 0;
   break;
  }
 case 12:
  {
   i1 = fb + 4326 | 0;
   break;
  }
 case 13:
  {
   i1 = fb + 4327 | 0;
   break;
  }
 case 3:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
   i1 = fb + 4321 | 0;
   break;
  }
 case 2:
  {
   i1 = i6 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   i1 = fb + 4319 | 0;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 456 >> 2] | 0)) i1 = fb + 4328 | 0; else if ((i3 | 0) == (HEAP32[i1 + 452 >> 2] | 0)) i1 = fb + 4329 | 0; else if ((i3 | 0) == (HEAP32[i1 + 460 >> 2] | 0)) i1 = fb + 4330 | 0; else if ((i3 | 0) == (HEAP32[i1 + 284 >> 2] | 0)) i1 = fb + 4331 | 0; else if ((i3 | 0) == (HEAP32[i1 + 280 >> 2] | 0)) i1 = fb + 4332 | 0; else if ((i3 | 0) == (HEAP32[i1 + 260 >> 2] | 0)) i1 = fb + 4333 | 0; else if ((i3 | 0) == (HEAP32[i1 + 84 >> 2] | 0)) i1 = fb + 4334 | 0; else if ((i3 | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = fb + 4335 | 0; else if ((i3 | 0) == (HEAP32[i1 + 124 >> 2] | 0)) i1 = fb + 4336 | 0; else if ((i3 | 0) == (HEAP32[i1 + 248 >> 2] | 0)) i1 = fb + 4337 | 0; else if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) i1 = fb + 4338 | 0; else if ((i3 | 0) == (HEAP32[i1 + 200 >> 2] | 0)) i1 = fb + 4339 | 0; else if ((i3 | 0) == (HEAP32[i1 + 288 >> 2] | 0)) i1 = fb + 4340 | 0; else {
    if (__Z9GetIIMGUIv() | 0) {
     i9 = __Z9GetIIMGUIv() | 0;
     if ((i3 | 0) == (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0)) {
      HEAP8[i2 >> 0] = 1;
      i1 = fb + 4341 | 0;
      break L1;
     }
    }
    if (!(__Z23scripting_class_is_enumP11Il2CppClass(i3) | 0)) {
     if ((i4 | 0) != 18) {
      i1 = 0;
      break L1;
     }
     if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[i1 + 268 >> 2] | 0) | 0)) {
      i1 = 0;
      break L1;
     }
     HEAP8[i2 >> 0] = 1;
     i1 = fb + 4342 | 0;
     break L1;
    }
    i1 = __Z23scripting_type_get_typePK10Il2CppType(__Z29scripting_class_enum_basetypeP11Il2CppClass(i3) | 0) | 0;
    L25 : do if ((i1 & -2 | 0) != 10) do switch (i1 | 0) {
    case 14:
     {
      i1 = fb + 4317 | 0;
      break L1;
     }
    case 4:
     {
      i1 = fb + 4318 | 0;
      break L1;
     }
    case 5:
     {
      i1 = fb + 4319 | 0;
      break L1;
     }
    case 6:
     {
      i1 = fb + 4320 | 0;
      break L1;
     }
    case 7:
     {
      i1 = fb + 4321 | 0;
      break L1;
     }
    case 8:
     {
      i1 = fb + 4322 | 0;
      break L1;
     }
    case 9:
     {
      i1 = fb + 4323 | 0;
      break L1;
     }
    case 10:
     {
      i1 = fb + 4324 | 0;
      break L1;
     }
    case 11:
     {
      i1 = fb + 4325 | 0;
      break L1;
     }
    case 12:
     {
      i1 = fb + 4326 | 0;
      break L1;
     }
    case 13:
     {
      i1 = fb + 4327 | 0;
      break L1;
     }
    case 3:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 33554432;
      i1 = fb + 4321 | 0;
      break L1;
     }
    case 2:
     {
      i1 = i6 + 24 | 0;
      HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
      i1 = fb + 4319 | 0;
      break L1;
     }
    default:
     break L25;
    } while (0); while (0);
    __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i7, HEAP32[i5 >> 2] | 0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1033818 | 0, 165, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN17ArchiveFileSystem22MountArchiveFromMemoryEPKvjb(i12, i5, i2, i3) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 1072 | 0;
 i13 = i16;
 i15 = i16 + 1060 | 0;
 if ((HEAP16[gb + 1179004 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179004 | 0, i9);
  i14 = gb + 1179004 | 0;
 } else i14 = 0;
 i4 = i12 + 152 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i11 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 489554 | 0, 93) | 0;
  __ZN16MemoryFileSystemC2EPKc(i11, gb + 1576256 | 0);
  HEAP32[i4 >> 2] = i11;
 }
 i1 = i12 + 156 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + 1;
 HEAP32[i13 >> 2] = i10;
 __Z6FormatPKcz(i15, gb + 490134 | 0, i13);
 i1 = i15 + 11 | 0;
 if (__ZN16MemoryFileSystem18CreateFileFromDataEPKcPvjb(HEAP32[i4 >> 2] | 0, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, i5, i2, i3) | 0) {
  __ZN15FileSystemEntryC2EPKcR17FileSystemHandler(i13, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, HEAP32[i4 >> 2] | 0);
  i11 = __ZnwjRK10MemLabelIdiPKci(2416, gb + 63552 | 0, 16, gb + 489554 | 0, 102) | 0;
  __ZN20ArchiveStorageReaderC2Ev(i11);
  if (!(__ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy(i11, i13, 0, 0) | 0)) {
   i8 = i12 + 120 | 0;
   i6 = i11;
   i7 = i5;
   i2 = i12 + 124 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   do if (!i1) {
    HEAP32[i9 >> 2] = i2;
    i4 = i2;
    i3 = i2;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i2 >>> 0 > i5 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 12;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i2 = 17;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 16;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 12) {
     HEAP32[i9 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 16) {
     HEAP32[i9 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i2 | 0) == 17) {
     HEAP32[i9 >> 2] = i1;
     i4 = i1;
     i3 = i9;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(28) | 0;
    HEAP32[i1 + 16 >> 2] = i7;
    i2 = i1 + 20 | 0;
    HEAP32[i2 >> 2] = i10;
    HEAP32[i2 + 4 >> 2] = i6;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i8 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 124 >> 2] | 0, i1);
    i10 = i12 + 128 | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader(i12, i11);
    i10 = i11 + 2336 | 0;
    i12 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
    HEAP32[i10 >> 2] = i12;
    if (!i12) {
     __ZN12FileAccessor5CloseEv(i11 + 1248 | 0) | 0;
     i2 = i11 + 2376 | 0;
     if (HEAP32[i2 >> 2] | 0) {
      i3 = i11 + 2364 | 0;
      i1 = 0;
      do {
       __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i11, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
     }
     HEAP32[i2 >> 2] = 0;
    }
    i1 = 1;
   } else {
    i12 = i11 + 4 | 0;
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
    if (!(HEAP32[i12 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 63552 | 0);
     i1 = 0;
    } else i1 = 0;
   }
  } else {
   i12 = i11 + 4 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   if (!(HEAP32[i12 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 63552 | 0);
    i1 = 0;
   } else i1 = 0;
  }
  __ZN13FileEntryDataD2Ev(i13);
 } else i1 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 if (!i14) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN11TypeManager7Builder5BuildERK14dense_hash_mapIiP4RTTINS_27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS5_4pairIKiS3_EEL18MemLabelIdentifier6ELi16EEE(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 if ((HEAP32[gb + 28304 + 24 >> 2] | 0) == -2147483648) __ZN11TypeManager7Builder3AddEP4RTTI(i11, gb + 28304 | 0) | 0;
 i5 = i9 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i10 = i9 + 32 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i6 = i1 + (i8 << 3) | 0;
 L4 : do if (!i8) {
  i8 = i1;
  i7 = i1;
  i4 = 0;
 } else {
  i3 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   if (!((i3 | 0) == (i8 | 0) | (i2 | 0) == (i8 | 0))) {
    i2 = 9;
    break L4;
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    i2 = 9;
    break;
   }
  } else while (1) {
   if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i2 = 9;
    break L4;
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    i2 = 9;
    break;
   }
  }
 } while (0);
 L13 : while (1) {
  if ((i2 | 0) == 9) {
   i8 = i1;
   i7 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  if ((i8 | 0) == (i7 + (i4 << 3) | 0)) break;
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + 36 >> 0] | 0)) if ((HEAP32[i1 + 24 >> 2] | 0) == -2147483648) __ZN11TypeManager7Builder3AddEP4RTTI(i11, i1) | 0;
  i1 = i8 + 8 | 0;
  if ((i1 | 0) == (i6 | 0)) {
   i1 = i6;
   i2 = 9;
   continue;
  }
  i3 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   if (!((i3 | 0) == (i8 | 0) | (i2 | 0) == (i8 | 0))) {
    i2 = 9;
    continue L13;
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    i2 = 9;
    continue L13;
   }
  } else while (1) {
   if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i2 = 9;
    continue L13;
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    i2 = 9;
    continue L13;
   }
  }
 }
 L31 : do if (!i4) i1 = i7; else {
  i3 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  if ((HEAP8[i9 + 8 >> 0] | 0) != 0 & (HEAP32[i9 + 4 >> 2] | 0) != 0) {
   i1 = i7;
   while (1) {
    i6 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i6 | 0) | (i2 | 0) == (i6 | 0))) break L31;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i8 | 0)) {
     i1 = i8;
     break;
    }
   }
  } else {
   i1 = i7;
   while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L31;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i8 | 0)) {
     i1 = i8;
     break;
    }
   }
  }
 } while (0);
 L41 : do if ((i1 | 0) != (i7 + (i4 << 3) | 0)) {
  i6 = i9 + 20 | 0;
  i4 = i9 + 4 | 0;
  i5 = i9 + 12 | 0;
  if (!(HEAP8[i9 + 8 >> 0] | 0)) while (1) {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 24 >> 2] = -2147483648;
   i1 = i1 + 8 | 0;
   L46 : do if ((i1 | 0) == (i8 | 0)) i1 = i8; else {
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) break L46;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) {
      i1 = i8;
      break;
     }
    }
   } while (0);
   if ((i1 | 0) == (i7 + (HEAP32[i10 >> 2] << 3) | 0)) break L41;
  }
  do {
   HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 24 >> 2] = -2147483648;
   i1 = i1 + 8 | 0;
   L54 : do if ((i1 | 0) == (i8 | 0)) i1 = i8; else {
    i3 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!(HEAP32[i4 >> 2] | 0)) while (1) {
     if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L54;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) {
      i1 = i8;
      break;
     }
    } else while (1) {
     i9 = HEAP32[i1 >> 2] | 0;
     if (!((i3 | 0) == (i9 | 0) | (i2 | 0) == (i9 | 0))) break L54;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) {
      i1 = i8;
      break;
     }
    }
   } while (0);
  } while ((i1 | 0) != (i7 + (HEAP32[i10 >> 2] << 3) | 0));
 } while (0);
 i5 = HEAP32[i11 + 12 >> 2] | 0;
 if (!i5) {
  i11 = 0;
  return i11 | 0;
 }
 i4 = 0;
 i1 = 0;
 do {
  i2 = (HEAP32[i11 >> 2] | 0) + (i4 * 12 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[i3 + 36 >> 0] | 0)) if ((HEAP32[i3 + 24 >> 2] | 0) == -2147483648) i1 = (__ZN11TypeManager7Builder18TraverseDepthFirstERKNS0_4NodeEj(i11, i2, i1) | 0) + i1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i10, i11, i13, i1, i14) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 80 | 0;
 i16 = i18 + 28 | 0;
 i3 = i18;
 i15 = i18 + 8 | 0;
 i4 = HEAP32[i10 + 28 >> 2] | 0;
 i5 = HEAP32[i10 + 32 >> 2] | 0;
 i12 = i10 + 36 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 1 | 0) == 29) {
  i9 = gb + 64016 | 0;
  i12 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = i3;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i12;
  HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN17SharedTextureDataC2E10MemLabelId(i16, i17);
  if (__ZN17SharedTextureData32GetCrunchDecompressedTextureDataIS_EEbRKT_(i16, i10) | 0) i1 = __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i16, i11, i13, i1, i14) | 0; else i1 = 0;
  HEAP32[i16 >> 2] = gb + 41960 + 8;
  if ((HEAP32[i16 + 24 >> 2] | 0) > -1) {
   i17 = i16 + 8 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16 + 12 | 0);
   HEAP32[i17 >> 2] = 0;
  }
  i17 = i1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (i1) {
  i1 = __Z21SourceMipLevelForBlitiiii(i4, i5, HEAP32[i11 + 4 >> 2] | 0, HEAP32[i11 + 8 >> 2] | 0) | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 } else i1 = 0;
 i9 = (HEAP32[i10 + 48 >> 2] | 0) + -1 | 0;
 i9 = (i9 | 0) < (i1 | 0) ? i9 : i1;
 i8 = __Z21CalculateMipMapOffsetii13TextureFormati(i4, i5, i2, i9) | 0;
 i7 = i4 >> i9;
 i7 = (i7 | 0) < 1 ? 1 : i7;
 i5 = i5 >> i9;
 i5 = (i5 | 0) < 1 ? 1 : i5;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 + -10 | 0) >>> 0 < 3) i6 = 14; else if (((i2 | 1) + -25 | 0) >>> 0 < 5) i6 = 14; else {
  i1 = i2 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i2 + -48 | 0) >>> 0 < 12 | ((i2 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
    i6 = 14;
    break;
   }
  } else if ((i2 + -45 | 0) >>> 0 < 3 | (i2 + -48 | 0) >>> 0 < 12) {
   i6 = 14;
   break;
  }
  i6 = (Math_imul(HEAP32[i10 + 40 >> 2] | 0, i14) | 0) + i8 | 0;
  i6 = (HEAP32[i10 + 8 >> 2] | 0) + i6 | 0;
  i14 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0, i7) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i15, i7, i5, i14, HEAP32[i12 >> 2] | 0, i6);
  HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  i6 = 20;
 } while (0);
 if ((i6 | 0) == 14) {
  i3 = ((i7 + 3 | 0) / 4 | 0) << 2;
  i4 = ((i5 + 3 | 0) / 4 | 0) << 2;
  if ((i2 | 0) == 24) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0)) i6 = 16; else i1 = 17; else i6 = 16;
  if ((i6 | 0) == 16) i1 = 4;
  __ZN5ImageC2Eii13TextureFormat(i15, i3, i4, i1);
  __ZN5Image8SetImageERK14ImageReferenceb(i17, i15, 1);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 + 16 >> 2] | 0, gb + 63184 | 0);
  i14 = (Math_imul(HEAP32[i10 + 40 >> 2] | 0, i14) | 0) + i8 | 0;
  if (__Z41DecompressNativeTextureFormatWithMipLevel13TextureFormatS_iiiPKjiiPj(HEAP32[i12 >> 2] | 0, i1, i7, i5, i9, (HEAP32[i10 + 8 >> 2] | 0) + i14 | 0, i3, i4, HEAP32[i17 + 16 >> 2] | 0) | 0) {
   __ZNK14ImageReference9ClipImageEiiii(i15, i17, 0, 0, i7, i5);
   HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   i6 = 20;
  } else i1 = 0;
 }
 do if ((i6 | 0) == 20) if (!i13) {
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i16, 0);
  __Z14PadImageBorderR14ImageReferenceii(i11, i7, i5);
  i1 = 1;
  break;
 } else {
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i16, i13);
  i1 = 1;
  break;
 } while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 + 16 >> 2] | 0, gb + 63184 | 0);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN7ApiGLES12DeleteBufferERj(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 switch (HEAP32[i7 >> 2] | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) {
  i1 = i6 + 904 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
   mftCall_vii(HEAP32[i6 + 644 >> 2] | 0, 36662, 0);
   HEAP32[i1 >> 2] = 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i1 = i6 + 900 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
   mftCall_vii(HEAP32[i6 + 644 >> 2] | 0, 36663, 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  i1 = i6 + 908 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
   mftCall_vii(HEAP32[i6 + 644 >> 2] | 0, 37102, 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 697 >> 0] | 0) {
  i1 = i6 + 912 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
   mftCall_vii(HEAP32[i6 + 644 >> 2] | 0, 36671, 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 i4 = i6 + 1992 | 0;
 i5 = i6 + 652 | 0;
 i1 = 0;
 do {
  i2 = i6 + 916 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i3 | 0) == 0)) {
   HEAP32[i2 >> 2] = 0;
   mftCall_viii(HEAP32[i5 >> 2] | 0, 35345, i1 | 0, 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 i1 = i6 + 1172 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) if ((HEAP8[i4 >> 0] | 0) != 0 & (i3 | 0) == 0) i2 = 0; else {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 35982, 0, 0);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1176 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) if ((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0) i2 = 0; else {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 35982, 1, 0);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1180 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) if ((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0) i2 = 0; else {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 35982, 2, 0);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 1184 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) if ((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0) i1 = 0; else {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 35982, 3, 0);
  i1 = 0;
 } else i1 = 0;
 do {
  i2 = i6 + 1188 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i3 | 0) == 0)) {
   HEAP32[i2 >> 2] = 0;
   mftCall_viii(HEAP32[i5 >> 2] | 0, 37074, i1 | 0, 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i1 = i6 + 1284 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 0, 0);
 }
 i1 = i6 + 1288 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 1, 0);
 }
 i1 = i6 + 1292 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 2, 0);
 }
 i1 = i6 + 1296 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 3, 0);
 }
 i1 = i6 + 1300 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 4, 0);
 }
 i1 = i6 + 1304 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 5, 0);
 }
 i1 = i6 + 1308 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 6, 0);
 }
 i1 = i6 + 1312 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) if (!((HEAP8[i4 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  mftCall_viii(HEAP32[i5 >> 2] | 0, 37568, 7, 0);
 }
 mftCall_vii(HEAP32[i6 + 640 >> 2] | 0, 1, i7 | 0);
 HEAP32[i7 >> 2] = -1;
 return;
}

function __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1, f32, f33, f2, i34, i35) {
 i1 = i1 | 0;
 f32 = Math_fround(f32);
 f33 = Math_fround(f33);
 f2 = Math_fround(f2);
 i34 = i34 | 0;
 i35 = i35 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i36 = 0, i37 = 0, i38 = 0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i36 = i38;
 i37 = i38 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i31 = i1 + 4 | 0;
 if ((i3 | 0) == (HEAP32[i31 >> 2] | 0)) {
  STACKTOP = i38;
  return;
 }
 i16 = i37 + 12 | 0;
 i17 = i37 + 20 | 0;
 i18 = i37 + 16 | 0;
 i19 = i37 + 24 | 0;
 i20 = i37 + 80 | 0;
 i21 = i37 + 76 | 0;
 i22 = i37 + 84 | 0;
 i23 = i37 + 148 | 0;
 i24 = i37 + 152 | 0;
 i25 = i37 + 140 | 0;
 i26 = i37 + 160 | 0;
 i27 = i37 + 156 | 0;
 i28 = i37 + 164 | 0;
 i29 = i37 + 168 | 0;
 i30 = i37 + 16 | 0;
 f2 = Math_fround(Math_fround(f33 - f32) + Math_fround(Math_fround(1.0) / f2));
 i8 = i35 + 4 | 0;
 i9 = i35 + 8 | 0;
 i10 = i37 + 11 | 0;
 i11 = i37 + 8 | 0;
 i12 = i37 + 4 | 0;
 i13 = i37 + 136 | 0;
 i14 = i37 + 12 | 0;
 i15 = i36 + 4 | 0;
 do {
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  HEAP32[i16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i37 >> 2] = 0;
  HEAP32[i37 + 4 >> 2] = 0;
  HEAP32[i37 + 8 >> 2] = 0;
  HEAPF32[i17 >> 2] = Math_fround(inf);
  HEAP32[i18 >> 2] = 0;
  i1 = i19;
  i4 = i1 + 52 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  HEAPF32[i20 >> 2] = Math_fround(inf);
  HEAP32[i21 >> 2] = 0;
  HEAP32[i23 >> 2] = 0;
  HEAP32[i24 >> 2] = 0;
  i1 = i22;
  i4 = i1 + 56 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i36, gb + 63664 | 0);
  i5 = i36;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i25;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i26 >> 2] = 2;
  HEAP32[i27 >> 2] = 2;
  HEAP32[i28 >> 2] = 4;
  HEAP32[i29 >> 2] = 0;
  do if (__Z18ClipAnimationCurveI8Vector3fEbRK17AnimationCurveTplIT_ERS3_ff(i3 + 16 | 0, i30, f32, f33) | 0) {
   do if ((i37 | 0) != (i3 | 0)) {
    i7 = HEAP8[i3 + 11 >> 0] | 0;
    i1 = i7 << 24 >> 24 < 0;
    i6 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
    i7 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
    i1 = HEAP8[i10 >> 0] | 0;
    i4 = i1 << 24 >> 24 < 0;
    if (i4) i5 = (HEAP32[i11 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     i4 = i4 ? HEAP32[i12 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i37, i5, i7 - i5 | 0, i4, 0, i4, i7, i6);
     break;
    }
    i1 = i4 ? HEAP32[i37 >> 2] | 0 : i37;
    if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    if ((HEAP8[i10 >> 0] | 0) < 0) {
     HEAP32[i12 >> 2] = i7;
     break;
    } else {
     HEAP8[i10 >> 0] = i7;
     break;
    }
   } while (0);
   HEAP32[i29 >> 2] = HEAP32[i3 + 168 >> 2];
   __ZN17AnimationCurveTplI8Vector3fE15SetPostInfinityEi(i30, 1);
   __ZN17AnimationCurveTplI8Vector3fE14SetPreInfinityEi(i30, 1);
   HEAP32[i28 >> 2] = HEAP32[i3 + 164 >> 2];
   if (i34) __Z15AddLoopingFrameI8Vector3fEvR17AnimationCurveTplIT_Ef(i30, f2);
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
    __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i35, i37);
    break;
   } else {
    __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i37);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 172;
    break;
   }
  } while (0);
  if ((HEAP32[i24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i25);
   HEAP32[i13 >> 2] = 0;
  }
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i7 = HEAP32[i37 >> 2] | 0;
   i6 = HEAP32[i14 >> 2] | 0;
   HEAP32[i36 >> 2] = 66;
   HEAP32[i15 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i36);
  }
  i3 = i3 + 172 | 0;
 } while ((i3 | 0) != (HEAP32[i31 >> 2] | 0));
 STACKTOP = i38;
 return;
}

function __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367306 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367315 | 0, i5, i1 + 1 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367324 | 0, i5, i1 + 2 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367333 | 0, i5, i1 + 3 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367342 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367351 | 0, i5, i1 + 5 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367360 | 0, i5, i1 + 6 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367369 | 0, i5, i1 + 7 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367378 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367387 | 0, i5, i1 + 9 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367396 | 0, i5, i1 + 10 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367406 | 0, i5, i1 + 11 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367416 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367426 | 0, i5, i1 + 13 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367436 | 0, i5, i1 + 14 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 367446 | 0, i5, i1 + 15 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN4crnd18crnd_validate_fileEPKvjPNS_13crn_file_infoE(i15, i3, i16) {
 i15 = i15 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = (i16 | 0) != 0;
 do if (i10) if ((HEAP32[i16 >> 2] | 0) == 104) {
  i1 = i16 + 4 | 0;
  i2 = i1 + 100 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  break;
 } else {
  i16 = 0;
  return i16 | 0;
 } while (0);
 if ((i15 | 0) == 0 | i3 >>> 0 < 74) {
  i16 = 0;
  return i16 | 0;
 }
 if ((HEAPU8[i15 >> 0] << 8 | HEAPU8[i15 + 1 >> 0] | 0) != 18552) {
  i16 = 0;
  return i16 | 0;
 }
 i7 = i15 + 2 | 0;
 i8 = i15 + 3 | 0;
 i6 = HEAPU8[i7 >> 0] << 8 | HEAPU8[i8 >> 0];
 if (i6 >>> 0 < 74) {
  i16 = 0;
  return i16 | 0;
 }
 i11 = i15 + 6 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 i12 = i15 + 7 | 0;
 i13 = i15 + 8 | 0;
 i14 = i15 + 9 | 0;
 i9 = HEAPU8[i12 >> 0] << 16 | (i4 & 255) << 24 | HEAPU8[i13 >> 0] << 8 | HEAPU8[i14 >> 0];
 if (i9 >>> 0 > i3 >>> 0) {
  i16 = 0;
  return i16 | 0;
 }
 i1 = i6 + -6 | 0;
 if (!i1) i1 = 0; else {
  i2 = 65535;
  i5 = i11;
  i3 = i4;
  while (1) {
   i4 = i5 + 1 | 0;
   i5 = i2 & 65535;
   i2 = i3 & 255 ^ i5 >>> 8;
   i2 = i2 >>> 4 ^ i2;
   i2 = (i2 | i5 << 8 & 65280) ^ i2 << 5 ^ i2 << 12 & 61440;
   i1 = i1 + -1 | 0;
   if (!i1) break;
   i5 = i4;
   i3 = HEAP8[i4 >> 0] | 0;
  }
  i1 = i2 & 65535 ^ 65535;
 }
 if ((i1 | 0) != (HEAPU8[i15 + 4 >> 0] << 8 | HEAPU8[i15 + 5 >> 0] | 0)) {
  i16 = 0;
  return i16 | 0;
 }
 i1 = i9 - i6 | 0;
 if (!i1) i1 = 0; else {
  i3 = 65535;
  i2 = i15 + i6 | 0;
  while (1) {
   i5 = i3 & 65535;
   i6 = HEAPU8[i2 >> 0] ^ i5 >>> 8;
   i6 = i6 >>> 4 ^ i6;
   i3 = (i6 | i5 << 8 & 65280) ^ i6 << 5 ^ i6 << 12 & 61440;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 1 | 0;
  }
  i1 = i3 & 65535 ^ 65535;
 }
 if ((i1 | 0) != (HEAPU8[i15 + 10 >> 0] << 8 | HEAPU8[i15 + 11 >> 0] | 0)) {
  i16 = 0;
  return i16 | 0;
 }
 switch (HEAP8[i15 + 17 >> 0] | 0) {
 case 6:
 case 1:
  break;
 default:
  {
   i16 = 0;
   return i16 | 0;
  }
 }
 i3 = HEAPU8[i15 + 12 >> 0] << 8 | HEAPU8[i15 + 13 >> 0];
 if ((i3 + -1 | 0) >>> 0 > 8191) {
  i16 = 0;
  return i16 | 0;
 }
 i1 = HEAPU8[i15 + 14 >> 0] << 8 | HEAPU8[i15 + 15 >> 0];
 if ((i1 + -1 | 0) >>> 0 > 8191) {
  i16 = 0;
  return i16 | 0;
 }
 i6 = i15 + 16 | 0;
 i4 = HEAP8[i6 >> 0] | 0;
 i5 = i4 & 255;
 if (!(i4 << 24 >> 24)) {
  i16 = 0;
  return i16 | 0;
 }
 i2 = i1 | i3;
 if (!i2) i1 = 0; else if ((i2 | 0) == 1) i1 = 1; else {
  i4 = i1;
  i2 = i3;
  i1 = 1;
  do {
   i2 = i2 >>> 1;
   i4 = i4 >>> 1;
   i1 = i1 + 1 | 0;
  } while ((i2 | i4) >>> 0 > 1);
 }
 if (i5 >>> 0 > i1 >>> 0) {
  i16 = 0;
  return i16 | 0;
 }
 i1 = (HEAPU8[i15 + 18 >> 0] | 0) > 10;
 if (i1 | i10 ^ 1) {
  i16 = i1 ^ 1;
  return i16 | 0;
 }
 HEAP32[i16 + 4 >> 2] = i9;
 HEAP32[i16 + 8 >> 2] = HEAPU8[i7 >> 0] << 8 | HEAPU8[i8 >> 0];
 HEAP32[i16 + 12 >> 2] = (HEAPU8[i15 + 45 >> 0] << 8 | HEAPU8[i15 + 44 >> 0] << 16 | HEAPU8[i15 + 46 >> 0]) + (HEAPU8[i15 + 37 >> 0] << 8 | HEAPU8[i15 + 36 >> 0] << 16 | HEAPU8[i15 + 38 >> 0]) + (HEAPU8[i15 + 53 >> 0] << 8 | HEAPU8[i15 + 52 >> 0] << 16 | HEAPU8[i15 + 54 >> 0]) + (HEAPU8[i15 + 61 >> 0] << 8 | HEAPU8[i15 + 60 >> 0] << 16 | HEAPU8[i15 + 62 >> 0]);
 HEAP32[i16 + 16 >> 2] = HEAPU8[i15 + 65 >> 0] << 8 | HEAPU8[i15 + 66 >> 0];
 HEAP32[i16 + 20 >> 2] = HEAPU8[i6 >> 0];
 i1 = HEAP8[i6 >> 0] | 0;
 if (i1 << 24 >> 24) {
  i3 = 0;
  i1 = i1 & 255;
  do {
   i2 = i3;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 < i1 >>> 0) i1 = HEAPU8[i15 + 70 + (i3 << 2) + 1 >> 0] << 16 | HEAPU8[i15 + 70 + (i3 << 2) >> 0] << 24 | HEAPU8[i15 + 70 + (i3 << 2) + 2 >> 0] << 8 | HEAPU8[i15 + 70 + (i3 << 2) + 3 >> 0]; else i1 = HEAPU8[i12 >> 0] << 16 | HEAPU8[i11 >> 0] << 24 | HEAPU8[i13 >> 0] << 8 | HEAPU8[i14 >> 0];
   HEAP32[i16 + 24 + (i2 << 2) >> 2] = i1 - (HEAPU8[i15 + 70 + (i2 << 2) + 1 >> 0] << 16 | HEAPU8[i15 + 70 + (i2 << 2) >> 0] << 24 | HEAPU8[i15 + 70 + (i2 << 2) + 2 >> 0] << 8 | HEAPU8[i15 + 70 + (i2 << 2) + 3 >> 0]);
   i1 = HEAPU8[i6 >> 0] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i16 + 88 >> 2] = HEAPU8[i15 + 39 >> 0] << 8 | HEAPU8[i15 + 40 >> 0];
 HEAP32[i16 + 92 >> 2] = HEAPU8[i15 + 47 >> 0] << 8 | HEAPU8[i15 + 48 >> 0];
 HEAP32[i16 + 96 >> 2] = HEAPU8[i15 + 55 >> 0] << 8 | HEAPU8[i15 + 56 >> 0];
 HEAP32[i16 + 100 >> 2] = HEAPU8[i15 + 63 >> 0] << 8 | HEAPU8[i15 + 64 >> 0];
 i16 = 1;
 return i16 | 0;
}

function __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E(i1, i15, i17, i16, i10) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 36 | 0;
 i9 = i18;
 i7 = i18 + 32 | 0;
 i1 = i15 + 28 | 0;
 L1 : do if (HEAP32[i1 >> 2] | 0) {
  i2 = i9 + 4 | 0;
  i3 = i9 + 8 | 0;
  i4 = i9 + 16 | 0;
  i5 = i9 + 20 | 0;
  i6 = i9 + 24 | 0;
  i8 = 0;
  while (1) {
   f22 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) >> 2]);
   f23 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) + 12 >> 2]);
   f28 = Math_fround(f22 + f23);
   f21 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) + 16 >> 2]);
   f27 = Math_fround(f21 + f25);
   f20 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i15 + 160 + (i8 * 24 | 0) + 20 >> 2]);
   f27 = Math_fround(f27 * Math_fround(.5));
   f26 = Math_fround(Math_fround(f20 + f24) * Math_fround(.5));
   HEAPF32[i9 >> 2] = Math_fround(f28 * Math_fround(.5));
   HEAPF32[i2 >> 2] = f27;
   HEAPF32[i3 >> 2] = f26;
   f21 = Math_fround(Math_fround(f25 - f21) * Math_fround(.5));
   f20 = Math_fround(Math_fround(f24 - f20) * Math_fround(.5));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(f23 - f22) * Math_fround(.5));
   HEAPF32[i5 >> 2] = f21;
   HEAPF32[i6 >> 2] = f20;
   if (__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i9) | 0) {
    HEAPF32[i7 >> 2] = Math_fround(-1.0);
    if (!(mftCall_iiiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i7 | 0, i15 + 32 + (i8 << 3) | 0, 1) | 0)) {
     i1 = 0;
     break;
    }
   }
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) break L1;
  }
  STACKTOP = i18;
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i15 + 584 >> 2] | 0)) {
  i19 = 1;
  STACKTOP = i18;
  return i19 | 0;
 }
 if (!(__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i15 + 608 | 0) | 0)) {
  i19 = 1;
  STACKTOP = i18;
  return i19 | 0;
 }
 i5 = HEAP32[i15 + 592 >> 2] | 0;
 i6 = HEAP32[i10 + (i5 << 2) >> 2] | 0;
 i5 = HEAP32[i10 + 12 + (i5 << 2) >> 2] | 0;
 i6 = (i6 | 0) < 0 ? ~i6 : i6 | -2147483648;
 i5 = (i5 | 0) < 0 ? ~i5 : i5 | -2147483648;
 i7 = i15 + 20 | 0;
 i8 = i15 + 24 | 0;
 i11 = 0;
 L16 : while (1) {
  if (HEAP32[i15 + 640 + (i11 << 2) >> 2] | 0) if (__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i15 + 688 + (i11 << 5) | 0) | 0) {
   i9 = i15 + 660 + (i11 << 2) | 0;
   i12 = 0;
   do {
    if (HEAP32[i15 + 864 + (i11 * 224 | 0) + (i12 << 2) >> 2] | 0) if (__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i15 + 864 + (i11 * 224 | 0) + 48 + (i12 << 5) | 0) | 0) {
     i10 = i15 + 864 + (i11 * 224 | 0) + 20 + (i12 << 2) | 0;
     i13 = 0;
     do {
      i1 = HEAP32[i15 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + (i13 << 2) >> 2] | 0;
      if (i1 | 0) if (__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i15 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 48 + (i13 << 5) | 0) | 0) {
       i4 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i15 + 1984 + (i11 * 1120 | 0) + (i12 * 224 | 0) + 20 + (i13 << 2) >> 2] | 0) | 0;
       i2 = (HEAP32[i7 >> 2] | 0) + (i4 << 5) | 0;
       i4 = (HEAP32[i8 >> 2] | 0) + (i4 << 3) | 0;
       do {
        i1 = i1 + -1 | 0;
        i3 = i2;
        i2 = i2 + 32 | 0;
        if ((HEAP32[i3 + 28 >> 2] | 0) >>> 0 >= i6 >>> 0) {
         if ((HEAP32[i3 + 12 >> 2] | 0) >>> 0 > i5 >>> 0) break;
         if (__ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i17, i3) | 0) {
          HEAPF32[i14 >> 2] = Math_fround(-1.0);
          if (!(mftCall_iiiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i14 | 0, i4 | 0, 1) | 0)) break L16;
         }
        }
        i4 = i4 + 8 | 0;
       } while ((i1 | 0) != 0);
      }
      i13 = i13 + 1 | 0;
     } while (i13 >>> 0 < 5);
    }
    i12 = i12 + 1 | 0;
   } while (i12 >>> 0 < 5);
  }
  i11 = i11 + 1 | 0;
  if (i11 >>> 0 >= 5) {
   i1 = 1;
   i19 = 28;
   break;
  }
 }
 if ((i19 | 0) == 28) {
  STACKTOP = i18;
  return i1 | 0;
 }
 i19 = 0;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN9BoxPruner14preparePruningER16MBPOS_TmpBuffers(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 i3 = i14 + 116 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i14 + 120 | 0;
 if ((HEAP32[i5 >> 2] | 0) != (i13 | 0)) HEAP8[i14 + 169 >> 0] = 1;
 i6 = HEAP32[i14 + 92 >> 2] | 0;
 if (!i6) {
  HEAP8[i14 + 28 >> 0] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP8[i14 + 169 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i14 + 100 >> 2] | 0;
 i8 = HEAP32[i14 + 112 >> 2] | 0;
 i12 = i6 - i13 | 0;
 i4 = (i13 | 0) == 0;
 if (!i4) {
  i1 = 0;
  do {
   HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i11 + (i1 * 24 | 0) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 i7 = i14 + 169 | 0;
 i1 = (HEAP8[i7 >> 0] | 0) == 0;
 if (!(i1 | (i6 | 0) == (i13 | 0))) {
  i2 = 0;
  do {
   i16 = i2 + i13 | 0;
   HEAP32[i8 + (i16 << 2) >> 2] = HEAP32[i11 + (i16 * 24 | 0) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
 }
 HEAP32[i3 >> 2] = i13;
 if (i4) {
  HEAP8[i14 + 28 >> 0] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 HEAP32[i5 >> 2] = i13;
 do if ((i6 | 0) == (i13 | 0)) {
  HEAP8[i7 >> 0] = 1;
  i7 = 0;
  i5 = 0;
 } else {
  if (i1) {
   i7 = HEAP32[i9 + 12808 >> 2] | 0;
   i5 = HEAP32[i9 + 12812 >> 2] | 0;
   break;
  }
  i1 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i14 + 132 | 0, i8 + (i13 << 2) | 0, i12, 1) | 0) + 8 >> 2] | 0;
  __ZN16MBPOS_TmpBuffers16allocateSleepingEjj(i9, i12, 2);
  i5 = HEAP32[i9 + 12812 >> 2] | 0;
  i2 = HEAP32[i9 + 12808 >> 2] | 0;
  i3 = i14 + 108 | 0;
  i4 = 0;
  do {
   i16 = (HEAP32[i1 + (i4 << 2) >> 2] | 0) + i13 | 0;
   i6 = i5 + (i4 * 24 | 0) | 0;
   i17 = i11 + (i16 * 24 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
   HEAP16[i2 + (i4 << 1) >> 1] = HEAP16[(HEAP32[i3 >> 2] | 0) + (i16 << 1) >> 1] | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i12 | 0));
  HEAP32[i5 + (i12 * 24 | 0) >> 2] = -1;
  HEAP32[i5 + ((i12 + 1 | 0) * 24 | 0) >> 2] = -1;
  HEAP8[i7 >> 0] = 0;
  i7 = i2;
 } while (0);
 i6 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i14 + 132 | 0, i8, i13, 1) | 0) + 8 >> 2] | 0;
 i4 = i9 + 12804 | 0;
 i3 = i9 + 12816 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < i13 >>> 0) {
  i1 = i9 + 6144 | 0;
  if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
   HEAP32[i3 >> 2] = 0;
  }
  i2 = i13 + 2 | 0;
  if (i2 >>> 0 < 257) HEAP32[i3 >> 2] = i1; else {
   i1 = i2 >>> 0 > 178956970 ? -1 : i2 * 24 | 0;
   if (!i1) i1 = 0; else {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    i10 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
    i17 = _PxGetFoundation() | 0;
    i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
    i1 = mftCall_iiiiii(i10 | 0, i16 | 0, i1 | 0, (i17 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1904) | 0;
   }
   HEAP32[i3 >> 2] = i1;
  }
  HEAP32[i4 >> 2] = i13;
 } else i1 = i2;
 i2 = HEAP32[i14 + 144 >> 2] | 0;
 i3 = i14 + 108 | 0;
 i4 = 0;
 do {
  i17 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
  i16 = i1 + (i4 * 24 | 0) | 0;
  i10 = i11 + (i17 * 24 | 0) | 0;
  HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i16 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP16[i2 + (i4 << 1) >> 1] = HEAP16[(HEAP32[i3 >> 2] | 0) + (i17 << 1) >> 1] | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i13 | 0));
 HEAP32[i1 + (i13 * 24 | 0) >> 2] = -1;
 HEAP32[i1 + ((i13 + 1 | 0) * 24 | 0) >> 2] = -1;
 HEAP32[i14 >> 2] = HEAP32[i14 + 76 >> 2];
 HEAP32[i14 + 4 >> 2] = i1;
 HEAP32[i14 + 8 >> 2] = i5;
 HEAP32[i14 + 12 >> 2] = i2;
 HEAP32[i14 + 16 >> 2] = i7;
 HEAP32[i14 + 20 >> 2] = i13;
 HEAP32[i14 + 24 >> 2] = i12;
 HEAP8[i14 + 28 >> 0] = 1;
 STACKTOP = i15;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPNS_15basic_streambufIwS2_EE(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i8 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i8;
  i3 = 29;
 } else {
  L4 : do if (HEAP8[i1 >> 0] | 0) {
   do if (!i6) {
    i7 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 4 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i3 = 10; else break L4;
   } else {
    i5 = i6 + 24 | 0;
    i4 = i6 + 28 | 0;
    while (1) {
     i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
     i2 = HEAP32[i1 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 11;
       break;
      }
     } else i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) == -1) {
      i1 = 2;
      i3 = 21;
      break;
     }
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i1 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 17;
       break;
      }
      if ((i1 | 0) == -1) {
       i1 = 0;
       i3 = 21;
       break;
      }
     } else {
      HEAP32[i5 >> 2] = i2 + 4;
      HEAP32[i2 >> 2] = i1;
     }
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
     i2 = i1 + 12 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
      __THREW__ = 0;
      invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i3 = 17;
       break;
      } else continue;
     } else {
      HEAP32[i2 >> 2] = i3 + 4;
      continue;
     }
    }
    if ((i3 | 0) == 11) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 17) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    } else if ((i3 | 0) == 21) {
     i6 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | ((HEAP32[i7 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (!(i6 & 1)) break L4;
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
    ___cxa_begin_catch(i1 | 0) | 0;
    if (!(HEAP32[i7 >> 2] | 0)) {
     __THREW__ = 0;
     invoke_vi(fb + 3999 | 0, i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i1 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      __THREW__ = 0;
      invoke_v(fb + 458 | 0);
      i7 = __THREW__;
      __THREW__ = 0;
      if (i7 & 1) {
       i3 = 34;
       break L1;
      } else break;
     }
    }
    __THREW__ = 0;
    invoke_v(fb + 458 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i3 = 10; else break L4;
   } while (0);
   if ((i3 | 0) == 10) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i2 = i8;
   i3 = 29;
   break L1;
  } while (0);
  i3 = 31;
 } while (0);
 do if ((i3 | 0) == 29) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i8 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   i3 = 31;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i3 = 34; else ___resumeException(i1 | 0);
 } while (0);
 if ((i3 | 0) == 31) {
  STACKTOP = i9;
  return i8 | 0;
 } else if ((i3 | 0) == 34) {
  i9 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i9);
 }
 return 0;
}

function __ZN9TextureOpI11TextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i10, i11, i13, i1, i14) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 80 | 0;
 i16 = i18 + 28 | 0;
 i3 = i18;
 i15 = i18 + 8 | 0;
 i4 = HEAP32[i10 + 8 >> 2] | 0;
 i5 = HEAP32[i10 + 12 >> 2] | 0;
 i12 = i10 + 20 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 1 | 0) == 29) {
  i9 = gb + 64016 | 0;
  i12 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = i3;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = i12;
  HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN17SharedTextureDataC2E10MemLabelId(i16, i17);
  if (__ZN17SharedTextureData32GetCrunchDecompressedTextureDataI11TextureDataEEbRKT_(i16, i10) | 0) i1 = __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i16, i11, i13, i1, i14) | 0; else i1 = 0;
  HEAP32[i16 >> 2] = gb + 41960 + 8;
  if ((HEAP32[i16 + 24 >> 2] | 0) > -1) {
   i17 = i16 + 8 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16 + 12 | 0);
   HEAP32[i17 >> 2] = 0;
  }
  i17 = i1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (i1) {
  i1 = __Z21SourceMipLevelForBlitiiii(i4, i5, HEAP32[i11 + 4 >> 2] | 0, HEAP32[i11 + 8 >> 2] | 0) | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 } else i1 = 0;
 i9 = (HEAP32[i10 + 24 >> 2] | 0) + -1 | 0;
 i9 = (i9 | 0) < (i1 | 0) ? i9 : i1;
 i8 = __Z21CalculateMipMapOffsetii13TextureFormati(i4, i5, i2, i9) | 0;
 i7 = i4 >> i9;
 i7 = (i7 | 0) < 1 ? 1 : i7;
 i5 = i5 >> i9;
 i5 = (i5 | 0) < 1 ? 1 : i5;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 + -10 | 0) >>> 0 < 3) i6 = 14; else if (((i2 | 1) + -25 | 0) >>> 0 < 5) i6 = 14; else {
  i1 = i2 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i2 + -48 | 0) >>> 0 < 12 | ((i2 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
    i6 = 14;
    break;
   }
  } else if ((i2 + -45 | 0) >>> 0 < 3 | (i2 + -48 | 0) >>> 0 < 12) {
   i6 = 14;
   break;
  }
  i6 = (Math_imul(HEAP32[i10 + 4 >> 2] | 0, i14) | 0) + i8 | 0;
  i6 = (HEAP32[i10 >> 2] | 0) + i6 | 0;
  i14 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0, i7) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i15, i7, i5, i14, HEAP32[i12 >> 2] | 0, i6);
  HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
  i6 = 20;
 } while (0);
 if ((i6 | 0) == 14) {
  i3 = ((i7 + 3 | 0) / 4 | 0) << 2;
  i4 = ((i5 + 3 | 0) / 4 | 0) << 2;
  if ((i2 | 0) == 24) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0)) i6 = 16; else i1 = 17; else i6 = 16;
  if ((i6 | 0) == 16) i1 = 4;
  __ZN5ImageC2Eii13TextureFormat(i15, i3, i4, i1);
  __ZN5Image8SetImageERK14ImageReferenceb(i17, i15, 1);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 + 16 >> 2] | 0, gb + 63184 | 0);
  i14 = (Math_imul(HEAP32[i10 + 4 >> 2] | 0, i14) | 0) + i8 | 0;
  if (__Z41DecompressNativeTextureFormatWithMipLevel13TextureFormatS_iiiPKjiiPj(HEAP32[i12 >> 2] | 0, i1, i7, i5, i9, (HEAP32[i10 >> 2] | 0) + i14 | 0, i3, i4, HEAP32[i17 + 16 >> 2] | 0) | 0) {
   __ZNK14ImageReference9ClipImageEiiii(i15, i17, 0, 0, i7, i5);
   HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   i6 = 20;
  } else i1 = 0;
 }
 do if ((i6 | 0) == 20) if (!i13) {
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i16, 0);
  __Z14PadImageBorderR14ImageReferenceii(i11, i7, i5);
  i1 = 1;
  break;
 } else {
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i16, i13);
  i1 = 1;
  break;
 } while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 + 16 >> 2] | 0, gb + 63184 | 0);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags(i11, i12, i5) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 16 | 0;
 i8 = i15;
 i14 = i15 + 60 | 0;
 i13 = i15 + 48 | 0;
 i2 = i15 + 36 | 0;
 i3 = i15 + 24 | 0;
 i1 = HEAP32[i11 + 1040 >> 2] | 0;
 i7 = i12 + 1040 | 0;
 L1 : do if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) if ((HEAP32[i11 + 1044 >> 2] | 0) == (HEAP32[i12 + 1044 >> 2] | 0)) {
  if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, i11 | 0, i12 | 0) | 0) {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
  switch (HEAP32[i11 + 1056 >> 2] | 0) {
  case 10:
  case 15:
   break L1;
  default:
   i1 = 0;
  }
  STACKTOP = i15;
  return i1 | 0;
 } else i10 = 3; else i10 = 3; while (0);
 if ((i10 | 0) == 3) HEAP32[i11 + 1056 >> 2] = 10;
 if ((i5 & 3 | 0) == 2) {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) i4 = 0; else i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i12 | 0) | 0;
 } else i4 = 0;
 i6 = i14 + 1040 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 do if (i4) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i12, _strlen(i12) | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 491785 | 0, 3);
  __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i13, i2, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZN15FileSystemEntry3SetEPKc(i14, (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13);
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) if ((HEAP32[i12 + 1044 >> 2] | 0) == (HEAP32[i14 + 1044 >> 2] | 0)) {
   if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, i12 | 0, i14 | 0) | 0) {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i14 | 0, 11, 3) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    i10 = 18;
    break;
   }
  } else i10 = 12; else i10 = 12;
  if ((i10 | 0) == 12) HEAP32[i12 + 1056 >> 2] = 10;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i2 = 0;
 } else i10 = 18; while (0);
 do if ((i10 | 0) == 18) {
  if (__ZN15FileSystemEntry13MoveByCopyingERS_23FileSystemCopyMoveFlags(i11, i12, i5) | 0) {
   if (!i4) {
    i2 = 1;
    break;
   }
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i14 | 0, 1) | 0) {
    i2 = 1;
    break;
   }
   HEAP32[i9 >> 2] = i11;
   HEAP32[i9 + 4 >> 2] = i12;
   __Z6FormatPKcz(i13, gb + 491897 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 491603 | 0, 621, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i2 = 1;
   break;
  }
  if (i4) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) if ((HEAP32[i14 + 1044 >> 2] | 0) == (HEAP32[i12 + 1044 >> 2] | 0)) {
    if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, i14 | 0, i12 | 0) | 0) {
     i2 = 0;
     break;
    }
   } else i10 = 22; else i10 = 22;
   if ((i10 | 0) == 22) HEAP32[i14 + 1056 >> 2] = 10;
   HEAP32[i8 >> 2] = i11;
   HEAP32[i8 + 4 >> 2] = i12;
   HEAP32[i8 + 8 >> 2] = i14;
   __Z6FormatPKcz(i13, gb + 491789 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 491603 | 0, 611, 17, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i2 = 0;
  } else i2 = 0;
 } while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i14 | 0);
 i14 = i2;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 208 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpShapeEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i19) {
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i23 + 16 | 0;
 i21 = i23 + 4 | 0;
 i2 = i23;
 i7 = i23 + 29 | 0;
 i8 = i23 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i22 = i5 + 8 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i19 + 4 | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i21, i17);
 i20 = i19 + 292 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE15growAndPushBackERKS2_(i5, i2) | 0;
   i1 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
   HEAP32[i20 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i16 = i2 + (i15 << 2) | 0;
  i13 = i19 + 276 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = i2 + (i15 - i12 << 2) | 0;
  if (i15 >>> 0 > i12 >>> 0) {
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j(i2, i15, i7, i19, 32);
   i3 = HEAP32[i21 >> 2] | 0;
   i12 = HEAP32[i21 + 4 >> 2] | 0;
   __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j(i3, i12, i8, i19, 32);
   i7 = i19 + 268 | 0;
   HEAP32[i7 >> 2] = 0;
   i8 = i3 + (i12 << 2) | 0;
   if (!i12) i1 = i2; else {
    i9 = i19 + 288 | 0;
    i10 = i19 + 272 | 0;
    i11 = i19 + 264 | 0;
    i12 = i19 + 284 | 0;
    i1 = i2;
    do {
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4;
     L16 : do if (i1 >>> 0 < i14 >>> 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (i4 >>> 0 <= i6 >>> 0) {
       i6 = i4;
       break L16;
      }
      HEAP32[i6 >> 2] = HEAP32[i20 >> 2];
      HEAP32[i20 >> 2] = i6;
      HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
      i1 = i1 + 4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4;
      if (i1 >>> 0 >= i14 >>> 0) {
       i6 = i4;
       break;
      }
     } else i6 = i4; while (0);
     if ((i6 | 0) == (HEAP32[i1 >> 2] | 0)) {
      i4 = HEAP32[i13 >> 2] | 0;
      if (((HEAP32[i1 + (i4 + -1 << 2) >> 2] | 0) + 152 | 0) == ((HEAP32[i9 >> 2] | 0) + i6 | 0)) {
       if (i6) {
        i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
        mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
        i4 = HEAP32[i13 >> 2] | 0;
       }
       i1 = i1 + (i4 << 2) | 0;
      } else i18 = 21;
     } else i18 = 21;
     do if ((i18 | 0) == 21) {
      i18 = 0;
      i4 = HEAP32[i7 >> 2] | 0;
      if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
       HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] = i5;
       HEAP32[i7 >> 2] = i4 + 1;
       break;
      } else {
       __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpClothEEEEEE15growAndPushBackERKS2_(i17, i3) | 0;
       break;
      }
     } while (0);
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) != (i8 | 0));
   }
  } else i1 = i2;
  if ((i1 | 0) != (i16 | 0)) {
   i5 = i19 + 284 | 0;
   i3 = (HEAP32[i5 >> 2] | 0) + ((i2 + (i15 + -1 << 2) - i1 | 0) >>> 2) | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i19 = i4;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i19;
    HEAP32[i20 >> 2] = i4;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i16 | 0));
   HEAP32[i5 >> 2] = i3 + 1;
  }
 }
 i20 = HEAP32[i21 + 8 >> 2] | 0;
 if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i22 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i23;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i2 | 0);
 STACKTOP = i23;
 return;
}

function __GLOBAL__sub_I_runtime_particlesystem_modules2_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451716 | 0, gb + 615839 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451824 | 0, gb + 615867 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451836 | 0, gb + 615894 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452304 | 0, gb + 615918 | 0, 7, 0);
 HEAPF32[gb + 1452040 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1452040 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1452040 + 8 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1452040 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1452040 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1452040 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1452040 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1452040 + 28 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1452040 + 32 >> 2] = Math_fround(.707106769);
 HEAPF32[gb + 1452040 + 36 >> 2] = Math_fround(.707106769);
 HEAPF32[gb + 1452040 + 40 >> 2] = Math_fround(-.707106769);
 HEAPF32[gb + 1452040 + 44 >> 2] = Math_fround(.707106769);
 HEAPF32[gb + 1452040 + 48 >> 2] = Math_fround(.707106769);
 HEAPF32[gb + 1452040 + 52 >> 2] = Math_fround(-.707106769);
 HEAPF32[gb + 1452040 + 56 >> 2] = Math_fround(-.707106769);
 HEAPF32[gb + 1452040 + 60 >> 2] = Math_fround(-.707106769);
 HEAPF32[gb + 1451848 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 12 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 28 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 36 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 40 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 60 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 80 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 84 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 92 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 112 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 128 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 136 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 140 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 152 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 156 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 172 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451848 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451848 + 184 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1451848 + 188 >> 2] = Math_fround(-1.0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451764 | 0, gb + 615949 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452116 | 0, gb + 615989 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452128 | 0, gb + 616031 | 0, 7, 0);
 return;
}

function __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(i10, i2, i13, i14, i1, i15, i16, i17, i18, i5, i11) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = i10 + 860 | 0;
 i3 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i12 >> 2] | 0, i1) | 0;
 i6 = i10 + 1600 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i10 + 1604 + (i8 << 2) >> 2] | 0;
 i8 = HEAP32[i10 + 1732 + (i8 << 2) >> 2] | 0;
 i9 = i10 + 1992 | 0;
 if (!((HEAP8[i9 >> 0] | 0) != 0 & (i7 | 0) == (i2 | 0))) {
  i4 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i13) | 0;
  mftCall_vii(HEAP32[i10 + 812 >> 2] | 0, i4 | 0, i2 | 0);
  HEAP32[i10 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] = i2;
  HEAP32[i10 + 1732 + (HEAP32[i6 >> 2] << 2) >> 2] = i13;
 }
 if ((i13 | 0) == 4) i4 = i14 + 34069 | 0; else i4 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i13) | 0;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = (i2 & 1 | 0) != 0;
 L8 : do if (!(i2 & 4)) {
  if (i1) {
   i1 = i10 + 184 | 0;
   mftCall_viiiiiiii(HEAP32[i1 >> 2] | 0, i4 | 0, i15 | 0, HEAP32[i3 >> 2] | 0, i16 | 0, i17 | 0, 0, i5 | 0, i11 | 0);
   switch (i13 | 0) {
   case 5:
    {
     mftCall_viiiiiiiiiii(HEAP32[i10 + 600 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i3 >> 2] | 0, i5 | 0, i11 | 0);
     break L8;
    }
   case 6:
    {
     mftCall_viiiiiiiiiii(HEAP32[i10 + 600 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i3 >> 2] | 0, i5 | 0, i11 | 0);
     break L8;
    }
   default:
    {
     mftCall_viiiiiiii(HEAP32[i1 >> 2] | 0, i4 | 0, i15 | 0, HEAP32[i3 >> 2] | 0, i16 | 0, i17 | 0, 0, i5 | 0, i11 | 0);
     break L8;
    }
   }
  }
  i2 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = i2 ? i1 : HEAP32[i3 >> 2] | 0;
  switch (i13 | 0) {
  case 3:
   {
    mftCall_viiiiiiiiii(HEAP32[i10 + 572 >> 2] | 0, i4 | 0, i15 | 0, i2 | 0, i16 | 0, i17 | 0, i18 | 0, 0, i1 | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  case 5:
   {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 580 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, i1 | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  case 6:
   {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 580 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, i1 | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  default:
   {
    mftCall_viiiiiiiii(HEAP32[i10 + 176 >> 2] | 0, i4 | 0, i15 | 0, i2 | 0, i16 | 0, i17 | 0, 0, i1 | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  }
 } else {
  if (i1) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i13 + -5 | 0) >>> 0 < 2) {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 600 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, i1 | 0, i5 | 0, i11 | 0);
    break;
   } else {
    mftCall_viiiiiiiii(HEAP32[i10 + 596 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i16 | 0, i17 | 0, i1 | 0, i5 | 0, i11 | 0);
    break;
   }
  }
  switch (i13 | 0) {
  case 3:
   {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 580 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  case 5:
   {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 580 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  case 6:
   {
    mftCall_viiiiiiiiiii(HEAP32[i10 + 580 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i14 | 0, i16 | 0, i17 | 0, i18 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  default:
   {
    mftCall_viiiiiiiii(HEAP32[i10 + 576 >> 2] | 0, i4 | 0, i15 | 0, 0, 0, i16 | 0, i17 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i11 | 0);
    break L8;
   }
  }
 } while (0);
 if (HEAP8[i9 >> 0] | 0) if ((HEAP32[i10 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] | 0) == (i7 | 0)) return;
 i18 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i8) | 0;
 mftCall_vii(HEAP32[i10 + 812 >> 2] | 0, i18 | 0, i7 | 0);
 HEAP32[i10 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] = i7;
 HEAP32[i10 + 1732 + (HEAP32[i6 >> 2] << 2) >> 2] = i8;
 return;
}

function __ZN13SplatDatabase12GetAlphamapsEjjjjPf(i3, i19, i22, i24, i25, i26) {
 i3 = i3 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i23 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i30 = i32;
 i27 = i32 + 20 | 0;
 i28 = i32 + 16 | 0;
 i29 = i32 + 4 | 0;
 i20 = ((HEAP32[i3 + 4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 44 | 0;
 HEAP32[i29 >> 2] = 0;
 i21 = i29 + 4 | 0;
 i17 = gb + 63160 | 0;
 i18 = HEAP32[i17 + 4 >> 2] | 0;
 i23 = i21;
 HEAP32[i23 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i23 + 4 >> 2] = i18;
 i23 = Math_imul(i24 << 4, i25) | 0;
 do if (!i23) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = (i23 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i23, 4, gb + 64016 | 0, 0, gb + 930755 | 0, 491) | 0;
   i18 = gb + 64016 | 0;
   i17 = HEAP32[i18 >> 2] | 0;
   i18 = HEAP32[i18 + 4 >> 2] | 0;
   HEAP32[i29 >> 2] = i2;
   i1 = i21;
   HEAP32[i1 >> 2] = i17;
   HEAP32[i1 + 4 >> 2] = i18;
   i1 = i2;
   break;
  }
 } while (0);
 i1 = i1 + 3 & -4;
 i16 = i1;
 i17 = i3 + 12 | 0;
 i18 = i3 + 16 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 if ((HEAP32[i18 >> 2] | 0) == (i4 | 0)) {
  i31 = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i31, i21);
  STACKTOP = i32;
  return;
 }
 i14 = i3 + 32 | 0;
 i15 = i27 + 11 | 0;
 i12 = (i25 | 0) == 0;
 i13 = (i24 | 0) == 0;
 i11 = 0;
 i2 = i4;
 do {
  i10 = i11 << 2;
  i6 = i20 - i10 | 0;
  i9 = (i6 | 0) > 4 ? 4 : i6;
  i5 = i2 + (i11 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (!i2) i31 = 19; else {
   HEAP32[i28 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i31 = 15; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i27, i2, i28);
     i3 = HEAP32[i27 >> 2] | 0;
     i8 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i8 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i31 = 15; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i31 = 17;
    }
   }
   if ((i31 | 0) == 15) i31 = 17;
   if ((i31 | 0) == 17) {
    i31 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) {
     i31 = 19;
     break;
    }
   }
   __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi(i2, i19, i22, i24, i25, 0, i16, 0) | 0;
  } while (0);
  if ((i31 | 0) == 19) {
   i31 = 0;
   HEAP32[i30 >> 2] = i11;
   __Z6FormatPKcz(i27, gb + 930934 | 0, i30);
   i2 = HEAP32[i14 >> 2] | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i27 >> 2] | 0 : i27, 0, gb + 930755 | 0, 502, 1, i2, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i27);
   _memset(i1 | 0, 0, i23 | 0) | 0;
  }
  if (!i12) {
   i5 = (i6 | 0) > 0;
   if (!i13) {
    i4 = 0;
    do {
     i6 = Math_imul(i4, i24) | 0;
     if (i5) {
      i3 = 0;
      do {
       i8 = i3 + i6 | 0;
       i7 = i16 + (i8 << 4) | 0;
       i8 = (Math_imul(i8, i20) | 0) + i10 | 0;
       i2 = 0;
       do {
        HEAP32[i26 + (i8 + i2 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) < (i9 | 0));
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i24 | 0));
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i25 | 0));
   }
  }
  i11 = i11 + 1 | 0;
  i2 = HEAP32[i17 >> 2] | 0;
 } while (i11 >>> 0 < (HEAP32[i18 >> 2] | 0) - i2 >> 2 >>> 0);
 i31 = HEAP32[i29 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i31, i21);
 STACKTOP = i32;
 return;
}

function __Z37CalculateExpandedClippedBoxConvexHullPfS_PKffff(i16, i17, i1, f3, f5, f18) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 f18 = Math_fround(f18);
 var i2 = 0, i4 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i28;
 i25 = i28 + 136 | 0;
 i26 = i28 + 116 | 0;
 i27 = i28 + 96 | 0;
 HEAP32[i25 >> 2] = 0;
 i13 = i25 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i19 = i25 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i22 = i6;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i2 = i20;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i2 + 4 >> 2] = i21;
 HEAP32[i26 >> 2] = 0;
 i2 = i26 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i21 = i26 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i26 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i24 = i6;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i4 = i22;
 HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i4 + 4 >> 2] = i23;
 HEAP32[i27 >> 2] = 0;
 i4 = i27 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i23 = i27 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i27 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i29 = i6;
 i9 = HEAP32[i29 + 4 >> 2] | 0;
 i14 = i24;
 HEAP32[i14 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i14 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i20);
 i14 = (HEAP32[i21 >> 2] | 0) > -1;
 HEAP32[i13 >> 2] = 8;
 HEAP32[i19 >> 2] = -2147483640;
 HEAP32[i25 >> 2] = i1;
 if (i14) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i22);
  HEAP32[i26 >> 2] = 0;
 }
 HEAP32[i21 >> 2] = -2147483636;
 HEAP32[i26 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i24);
  HEAP32[i27 >> 2] = 0;
 }
 HEAP32[i23 >> 2] = -2147483635;
 HEAP32[i27 >> 2] = i28 + 160;
 HEAP32[i4 >> 2] = 0;
 __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff(i26, i25, f3, f5);
 __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i27, i26);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < 3) i1 = 0; else {
  i14 = HEAP32[i27 >> 2] | 0;
  f15 = Math_fround(HEAPF32[gb + 62456 >> 2]);
  i13 = 0;
  i6 = i1 + -1 | 0;
  while (1) {
   f8 = Math_fround(HEAPF32[i14 + (i6 << 3) >> 2]);
   i9 = i14 + (i6 << 3) + 4 | 0;
   f10 = Math_fround(HEAPF32[i9 >> 2]);
   f11 = Math_fround(HEAPF32[i14 + (i13 << 3) >> 2]);
   f12 = Math_fround(HEAPF32[i14 + (i13 << 3) + 4 >> 2]);
   f3 = Math_fround(f11 - f8);
   f5 = Math_fround(f12 - f10);
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5))));
   if (f7 > f15) {
    f5 = Math_fround(Math_fround(-f5) / f7);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround(f3 / f7);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i2 = HEAP32[gb + 1162356 >> 2] | 0;
    i4 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
   }
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f18);
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f18);
   f10 = Math_fround(f10 + f5);
   f11 = Math_fround(f11 + f7);
   f12 = Math_fround(f12 + f5);
   i2 = i6 << 2;
   i29 = i16 + (i2 << 2) | 0;
   i2 = i16 + ((i2 | 2) << 2) | 0;
   HEAPF32[i29 >> 2] = Math_fround(f8 + f7);
   HEAPF32[i29 + 4 >> 2] = f10;
   HEAPF32[i2 >> 2] = f11;
   HEAPF32[i2 + 4 >> 2] = f12;
   i2 = i17 + (i6 << 1 << 2) | 0;
   HEAP32[i2 >> 2] = HEAP32[i14 + (i6 << 3) >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i9 >> 2];
   i2 = i13 + 1 | 0;
   if (i2 >>> 0 < i1 >>> 0) {
    i6 = i13;
    i13 = i2;
   } else break;
  }
 }
 if ((HEAP32[i23 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i27 >> 2] | 0, i24);
  HEAP32[i27 >> 2] = 0;
 }
 if ((HEAP32[i21 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i26 >> 2] | 0, i22);
  HEAP32[i26 >> 2] = 0;
 }
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i28;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i25 >> 2] | 0, i20);
 HEAP32[i25 >> 2] = 0;
 STACKTOP = i28;
 return i1 | 0;
}

function __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i9, i10, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i6 = i13;
 i12 = i13 + 4 | 0;
 i4 = i9 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = i4;
  i3 = i1;
  L3 : while (1) {
   i1 = i3;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    i2 = i1;
    break;
   } else i2 = i1;
  }
  if ((i2 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i2 + 16 >> 2] | 0)) {
   if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i2 + 36 >> 2] = i1;
  }
 }
 i4 = i9 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i9, i8);
  STACKTOP = i13;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i6);
   i2 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 20;
 }
 if ((i7 | 0) == 18) i7 = 20;
 if ((i7 | 0) == 20) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i9, i8);
  STACKTOP = i13;
  return;
 }
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 26; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i6);
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 26; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 28;
  }
 }
 if ((i7 | 0) == 26) i7 = 28;
 if ((i7 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 if (!(HEAP32[i1 + 32 >> 2] | 0)) {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i9, i8);
  STACKTOP = i13;
  return;
 }
 i1 = i9 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i7 = 32; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i7 = 32;
 if ((i7 | 0) == 32) {
  __ZN8Material15BuildPropertiesEv(i9);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i2 + 12 | 0, i10, i11);
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i9, i8);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_20PxConvexMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i11, i6, i5) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i8 = i12 + 104 | 0;
 i10 = i12 + 32 | 0;
 i7 = i12 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = gb + 673012;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i9;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i9;
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 HEAP32[i10 >> 2] = 4;
 HEAPF32[i10 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 32 >> 2] = 0;
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_20PxConvexMeshGeometryE(i6, HEAP32[i11 + 8 >> 2] | 0, i10) | 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i7);
 i3 = i11 + 4 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i9);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx33PxConvexMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEEEEjT_j(i9, i8, 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i12;
 return;
}

function __ZN11RadixSorter4SortEPfj(i18, i19, i20) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0;
 i2 = i18 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 < i20 >>> 0) {
  i4 = i18 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  HEAP32[i4 >> 2] = 0;
  i5 = i18 + 12 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  i17 = i20 >>> 0 > 1073741823 ? -1 : i20 << 2;
  i3 = __Znaj(i17) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = __Znaj(i17) | 0;
  HEAP32[i2 >> 2] = i20;
  if (i20) {
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i3 + (i1 << 2) >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
 } else i5 = i18 + 12 | 0;
 _memset(HEAP32[i18 >> 2] | 0, 0, 4096) | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i19 + (HEAP32[i14 >> 2] << 2) >> 2]);
 i9 = i19 + (i20 << 2) | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 i10 = i17 + 1024 | 0;
 i11 = i17 + 2048 | 0;
 i12 = i17 + 3072 | 0;
 i13 = i14;
 if ((i9 | 0) == (i19 | 0)) return i18 | 0; else {
  f8 = f6;
  i1 = 1;
  i3 = i14;
  i7 = i19;
 }
 while (1) {
  i4 = i3 + 4 | 0;
  i1 = i1 & !(f6 < f8);
  i2 = i17 + ((HEAPU8[i7 >> 0] | 0) << 2) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i10 + ((HEAPU8[i7 + 1 >> 0] | 0) << 2) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i11 + ((HEAPU8[i7 + 2 >> 0] | 0) << 2) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i7 + 4 | 0;
  i16 = i12 + ((HEAPU8[i7 + 3 >> 0] | 0) << 2) | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  if ((i2 | 0) == (i9 | 0)) break;
  f8 = f6;
  i3 = i4;
  i7 = i2;
  f6 = Math_fround(HEAPF32[i19 + (HEAP32[i4 >> 2] << 2) >> 2]);
 }
 if (i1) return i18 | 0; else {
  i1 = 128;
  i16 = 0;
 }
 do {
  i16 = (HEAP32[i12 + (i1 << 2) >> 2] | 0) + i16 | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 i11 = i18 + 4 | 0;
 i12 = (i20 | 0) == 0;
 i15 = i18 + 16 | 0;
 i10 = 0;
 i1 = i14;
 i3 = i14;
 while (1) {
  i7 = i17 + (i10 << 8 << 2) | 0;
  i2 = 0;
  while (1) {
   i4 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
   if ((i4 | 0) == (i20 | 0)) {
    i2 = i13;
    break;
   }
   i2 = i2 + 1 | 0;
   if (!((i4 | 0) == 0 & i2 >>> 0 < 256)) {
    i21 = 19;
    break;
   }
  }
  if ((i21 | 0) == 19) {
   i21 = 0;
   i9 = HEAP32[i11 >> 2] | 0;
   if ((i10 | 0) == 3) {
    HEAP32[i9 >> 2] = i16;
    i2 = 1;
    i3 = i16;
    do {
     i3 = (HEAP32[i7 + (i2 + -1 << 2) >> 2] | 0) + i3 | 0;
     HEAP32[i9 + (i2 << 2) >> 2] = i3;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 128);
    HEAP32[i9 + 1020 >> 2] = 0;
    i2 = 0;
    do {
     i14 = 255 - i2 | 0;
     HEAP32[i9 + (254 - i2 << 2) >> 2] = (HEAP32[i7 + (i14 << 2) >> 2] | 0) + (HEAP32[i9 + (i14 << 2) >> 2] | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 127);
    i2 = 128;
    do {
     i14 = i9 + (i2 << 2) | 0;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP32[i7 + (i2 << 2) >> 2] | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != 256);
    if (!i12) {
     i2 = 0;
     do {
      i3 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
      i14 = HEAP32[i19 + (i3 << 2) >> 2] | 0;
      i4 = i9 + (i14 >>> 24 << 2) | 0;
      i7 = HEAP32[i4 >> 2] | 0;
      if ((i14 | 0) > -1) {
       HEAP32[i4 >> 2] = i7 + 1;
       HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 << 2) >> 2] = i3;
      } else {
       i14 = i7 + -1 | 0;
       HEAP32[i4 >> 2] = i14;
       HEAP32[(HEAP32[i15 >> 2] | 0) + (i14 << 2) >> 2] = i3;
      }
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i20 | 0));
    }
   } else {
    HEAP32[i9 >> 2] = 0;
    i1 = 1;
    i2 = 0;
    do {
     i2 = (HEAP32[i7 + (i1 + -1 << 2) >> 2] | 0) + i2 | 0;
     HEAP32[i9 + (i1 << 2) >> 2] = i2;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 256);
    i2 = i3 + (i20 << 2) | 0;
    i4 = i19 + i10 | 0;
    if (!i12) {
     i1 = i3;
     do {
      i7 = HEAP32[i1 >> 2] | 0;
      i1 = i1 + 4 | 0;
      i3 = i9 + ((HEAPU8[i4 + (i7 << 2) >> 0] | 0) << 2) | 0;
      i14 = HEAP32[i3 >> 2] | 0;
      HEAP32[i3 >> 2] = i14 + 1;
      HEAP32[(HEAP32[i15 >> 2] | 0) + (i14 << 2) >> 2] = i7;
     } while ((i1 | 0) != (i2 | 0));
    }
   }
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i15 >> 2] = i13;
   i3 = i2;
   i1 = i3;
  }
  i10 = i10 + 1 | 0;
  if ((i10 | 0) == 4) break; else i13 = i2;
 }
 return i18 | 0;
}

function __Z11SetLocalTRS15TransformAccessRKN4math7_float3ERKNS0_7_float4ES3_(i11, i1, i2, i6) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i8 = i12;
 i5 = i11;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i13 = i5 + (i4 * 40 | 0) | 0;
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 i3 = i5 + (i4 * 40 | 0) + 4 | 0;
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = i5 + (i4 * 40 | 0) + 8 | 0;
 i7 = f16 != f15 | f19 != f9 | f17 != Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i13 >> 2] = f16;
 HEAPF32[i3 >> 2] = f19;
 HEAPF32[i1 >> 2] = f17;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(f17 * f17);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(f16 * f16);
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f14 = Math_fround(f15 * f15);
 f18 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f14 = Math_fround(Math_fround(f19 + f9) + Math_fround(f14 + Math_fround(f18 * f18)));
 f9 = Math_fround(Math_sqrt(Math_fround(f14)));
 f17 = Math_fround(f17 / f9);
 f16 = Math_fround(f16 / f9);
 f15 = Math_fround(f15 / f9);
 f9 = Math_fround(f18 / f9);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = f14 > Math_fround(1.0e-30);
 i1 = i13 ? i1 : 0;
 i2 = i13 ? i2 : 0;
 i3 = i13 ? i3 : 0;
 i21 = i13 ? (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i24 = i5 + (i4 * 40 | 0) + 12 | 0;
 f17 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i13 = f17 != Math_fround(HEAPF32[i24 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i23 = i5 + (i4 * 40 | 0) + 16 | 0;
 i25 = f17 != Math_fround(HEAPF32[i23 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i22 = i5 + (i4 * 40 | 0) + 20 | 0;
 i26 = f17 != Math_fround(HEAPF32[i22 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i20 = i5 + (i4 * 40 | 0) + 24 | 0;
 i13 = f17 != Math_fround(HEAPF32[i20 >> 2]) | (i26 | (i25 | i13));
 HEAP32[i24 >> 2] = i1;
 HEAP32[i23 >> 2] = i2;
 HEAP32[i22 >> 2] = i3;
 HEAP32[i20 >> 2] = i21;
 f17 = Math_fround(HEAPF32[i6 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i2 = i5 + (i4 * 40 | 0) + 28 | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i5 + (i4 * 40 | 0) + 32 | 0;
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i5 + (i4 * 40 | 0) + 36 | 0;
 i3 = f17 != f15 | f18 != f16 | f19 != Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i2 >> 2] = f17;
 HEAPF32[i6 >> 2] = f18;
 HEAPF32[i4 >> 2] = f19;
 i4 = i13 | i3;
 if (!(i7 | i4)) {
  i26 = 0;
  STACKTOP = i12;
  return i26 | 0;
 }
 if (i3) {
  i26 = i11;
  i1 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 4 >> 2] | 0;
  i2 = i8;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = i26;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  __ZN17TransformInternal36OnScaleChangedCalculateTransformTypeE15TransformAccess(i10);
  i2 = i1;
  i10 = i26;
 } else {
  i10 = i11;
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i4 ? HEAP32[i1 + 44 >> 2] | 0 : 0) | HEAP32[i1 + 40 >> 2] | (i3 ? HEAP32[i1 + 48 >> 2] | 0 : 0);
 i1 = i2;
 i4 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i10 << 2) >> 2] | 0;
 if (!i4) {
  i26 = 1;
  STACKTOP = i12;
  return i26 | 0;
 }
 i5 = HEAP32[i1 + 60 >> 2] | 0;
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i10;
 while (1) {
  i26 = HEAP32[i5 + (i1 << 2) >> 2] & i8;
  i25 = i6 + (i1 << 2) | 0;
  HEAP32[i25 >> 2] = HEAP32[i25 >> 2] | i26;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i26;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN5physx11PxMeshQuery23findOverlapTriangleMeshERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_PjjjRb(i4, i5, i7, i8, i10, i6, i11, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 44 | 0;
 i3 = i12 + 16 | 0;
 i1 = i12;
 switch (HEAP32[i4 >> 2] | 0) {
 case 3:
  {
   HEAP32[i2 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i2 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i2 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
   HEAP32[i2 + 48 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 52 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i2 + 56 >> 2] = HEAP32[i4 + 12 >> 2];
   f17 = Math_fround(HEAPF32[i5 >> 2]);
   f16 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f23 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f13 = Math_fround(f17 + f17);
   f15 = Math_fround(f16 + f16);
   f20 = Math_fround(f23 + f23);
   f22 = Math_fround(f16 * f15);
   f21 = Math_fround(f23 * f20);
   f16 = Math_fround(f13 * f16);
   f24 = Math_fround(f13 * f23);
   f14 = Math_fround(f13 * f18);
   f23 = Math_fround(f15 * f23);
   f15 = Math_fround(f15 * f18);
   f18 = Math_fround(f20 * f18);
   f20 = Math_fround(f16 + f18);
   f19 = Math_fround(f24 - f15);
   f18 = Math_fround(f16 - f18);
   f13 = Math_fround(Math_fround(1.0) - Math_fround(f17 * f13));
   f17 = Math_fround(f13 - f21);
   f16 = Math_fround(f23 + f14);
   f15 = Math_fround(f24 + f15);
   f14 = Math_fround(f23 - f14);
   f13 = Math_fround(f13 - f22);
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f22) - f21);
   HEAPF32[i2 + 4 >> 2] = f20;
   HEAPF32[i2 + 8 >> 2] = f19;
   HEAPF32[i2 + 12 >> 2] = f18;
   HEAPF32[i2 + 16 >> 2] = f17;
   HEAPF32[i2 + 20 >> 2] = f16;
   HEAPF32[i2 + 24 >> 2] = f15;
   HEAPF32[i2 + 28 >> 2] = f14;
   HEAPF32[i2 + 32 >> 2] = f13;
   i11 = __ZN5physx2Gu18findOverlapOBBMeshERKNS0_3BoxERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i2, (HEAP32[i7 + 36 >> 2] | 0) + 32 | 0, i8, i7 + 4 | 0, i10, i6, i11, i9) | 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 case 2:
  {
   f16 = Math_fround(HEAPF32[i5 >> 2]);
   f19 = Math_fround(f16 * Math_fround(2.0));
   f22 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f21 = Math_fround(f22 * Math_fround(2.0));
   f22 = Math_fround(Math_fround(f16 * f19) + Math_fround(Math_fround(f22 * f21) + Math_fround(-1.0)));
   f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f23 = Math_fround(f16 * f21);
   f24 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f23 = Math_fround(f23 + Math_fround(f19 * f24));
   f24 = Math_fround(Math_fround(f19 * f16) - Math_fround(f21 * f24));
   f21 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f22 = Math_fround(f21 * f22);
   f23 = Math_fround(f21 * f23);
   f24 = Math_fround(f21 * f24);
   f21 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f16 = Math_fround(f21 + f22);
   f19 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f17 = Math_fround(f19 + f23);
   f20 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   f18 = Math_fround(f24 + f20);
   HEAPF32[i3 >> 2] = f16;
   HEAPF32[i3 + 4 >> 2] = f17;
   HEAPF32[i3 + 8 >> 2] = f18;
   f23 = Math_fround(f19 - f23);
   f24 = Math_fround(f20 - f24);
   HEAPF32[i3 + 12 >> 2] = Math_fround(f21 - f22);
   HEAPF32[i3 + 16 >> 2] = f23;
   HEAPF32[i3 + 20 >> 2] = f24;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 4 >> 2];
   i11 = __ZN5physx2Gu22findOverlapCapsuleMeshERKNS0_7CapsuleERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i3, (HEAP32[i7 + 36 >> 2] | 0) + 32 | 0, i8, i7 + 4 | 0, i10, i6, i11, i9) | 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 case 0:
  {
   i3 = HEAP32[i7 + 36 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
   HEAP32[i1 + 12 >> 2] = i4;
   i11 = __ZN5physx2Gu21findOverlapSphereMeshERKNS0_6SphereERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i1, i3 + 32 | 0, i8, i7 + 4 | 0, i10, i6, i11, i9) | 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 default:
  {
   HEAP8[i9 >> 0] = 0;
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZN23AnimationOffsetPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i9, i4, i5, i6) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i7 = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i7 | 0) > 0) {
  i2 = 0;
  do {
   i3 = i2;
   i1 = i9;
   while (1) {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
    i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
    if (!i1) break;
    if (!(HEAP32[i1 + 16 >> 2] | 0)) {
     i8 = 7;
     break;
    } else i3 = 0;
   }
   if ((i8 | 0) == 7) {
    i8 = 0;
    mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
 }
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 if (!i1) return;
 i3 = i9 + 96 | 0;
 f21 = Math_fround(HEAPF32[i3 >> 2]);
 i8 = i9 + 92 | 0;
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = i9 + 104 | 0;
 f23 = Math_fround(HEAPF32[i7 >> 2]);
 i6 = i9 + 100 | 0;
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f22 = Math_fround(f21 * Math_fround(-2.0));
 f16 = Math_fround(f21 * Math_fround(2.0));
 f13 = Math_fround(f22 * f23);
 f11 = Math_fround(f18 * Math_fround(2.0));
 f15 = Math_fround(f18 * Math_fround(-2.0));
 f20 = Math_fround(f23 * f15);
 f19 = Math_fround(Math_fround(f21 * f22) - Math_fround(f18 * f11));
 f12 = Math_fround(Math_fround(f14 * f16) - f20);
 f17 = Math_fround(f13 - Math_fround(f14 * f15));
 f10 = Math_fround(f14 * Math_fround(-2.0));
 f24 = Math_fround(f14 * Math_fround(2.0));
 f23 = Math_fround(f23 * f10);
 f20 = Math_fround(f20 - Math_fround(f21 * f10));
 f15 = Math_fround(Math_fround(f18 * f15) - Math_fround(f14 * f24));
 f11 = Math_fround(Math_fround(f21 * f11) - f23);
 f13 = Math_fround(Math_fround(f24 * f18) - f13);
 f18 = Math_fround(f23 - Math_fround(f22 * f18));
 f16 = Math_fround(Math_fround(f14 * f10) - Math_fround(f21 * f16));
 i2 = i1 + 68 | 0;
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(f21 * f19);
 f12 = Math_fround(f21 * f12);
 f17 = Math_fround(f21 * f17);
 i5 = i1 + 72 | 0;
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i1 + 76 | 0;
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(Math_fround(f21 + f19) + Math_fround(Math_fround(f10 * f20) + Math_fround(f13 * f14)));
 f18 = Math_fround(Math_fround(f10 + f12) + Math_fround(Math_fround(f10 * f15) + Math_fround(f18 * f14)));
 f14 = Math_fround(Math_fround(f14 + f17) + Math_fround(Math_fround(f10 * f11) + Math_fround(f16 * f14)));
 f16 = Math_fround(HEAPF32[i9 + 80 >> 2]);
 f11 = Math_fround(HEAPF32[i9 + 84 >> 2]);
 f18 = Math_fround(f11 + f18);
 f14 = Math_fround(Math_fround(HEAPF32[i9 + 88 >> 2]) + f14);
 HEAPF32[i2 >> 2] = Math_fround(f16 + f13);
 HEAPF32[i5 >> 2] = f18;
 HEAPF32[i4 >> 2] = f14;
 i4 = i1 + 80 | 0;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(f14 * f18);
 f16 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i1 + 92 | 0;
 f11 = Math_fround(HEAPF32[i9 >> 2]);
 f10 = Math_fround(f16 * f11);
 f17 = Math_fround(HEAPF32[i6 >> 2]);
 i6 = i1 + 84 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(f17 * f15);
 f20 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = i1 + 88 | 0;
 f19 = Math_fround(HEAPF32[i8 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f16 * f19)) - Math_fround(f11 * f17)) - Math_fround(f15 * f20));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f18 * f20)) - Math_fround(f17 * f19)) - Math_fround(f14 * f15));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f14 * f19)) - Math_fround(f18 * f16)) - Math_fround(f11 * f20));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f15)) - Math_fround(f14 * f11));
 i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAP32[i4 >> 2] = i3 ^ -2147483648;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i7 ^ -2147483648;
 HEAPF32[i9 >> 2] = f10;
 return;
}

function __ZN20TextRenderingPrivate7GUIText8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9);
 i7 = i10 + 36 | 0;
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i10 + 40 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i11 = i9 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i12 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i10 + 54 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 2 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 2);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 52 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 2);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 68 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 60 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10 + 88 | 0, i9);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10 + 92 | 0, i9);
 i1 = i10 + 76 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i10 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  STACKTOP = i13;
  return;
 }
}

function __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE(i8, i9, i5) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i11 = i13;
 i4 = i8 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = i4;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i2 + 16 | 0, i9) | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i9, i1 + 16 | 0) | 0)) {
   i12 = HEAP32[i1 + 32 >> 2] | 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 L13 : do if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) {
  i6 = i1;
  L15 : while (1) {
   i1 = HEAP32[i6 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i11 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 17; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
      i4 = HEAP32[i10 >> 2] | 0;
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
      i1 = i3;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 17; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 19;
    }
    if ((i12 | 0) == 17) i12 = 19;
    if ((i12 | 0) == 19) {
     i12 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
    if (!i1) i12 = 26; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
      i2 = HEAP32[i10 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 26; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 28;
     }
    }
    if ((i12 | 0) == 26) i12 = 28;
    if ((i12 | 0) == 28) {
     i12 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
    }
    i5 = (HEAP32[i1 + 48 >> 2] | 0) + 204 | 0;
    i4 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) i12 = 36; else {
     i1 = i4;
     L45 : while (1) {
      i3 = i2;
      while (1) {
       if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i3 + 16 | 0, i9) | 0)) break;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       if (!i2) break L45; else i3 = i2;
      }
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i1 = i3;
       break;
      } else i1 = i3;
     }
     if ((i1 | 0) == (i4 | 0)) i12 = 36; else if (__ZNK20TextRenderingPrivate7FontRefltERKS0_(i9, i1 + 16 | 0) | 0) i12 = 36;
    }
    if ((i12 | 0) == 36) {
     i12 = 0;
     i1 = i4;
    }
    if ((i1 | 0) != ((HEAP32[i5 >> 2] | 0) + 4 | 0)) break L15;
   } while (0);
   i6 = i6 + 4 | 0;
   if ((i6 | 0) == (HEAP32[i7 >> 2] | 0)) break L13;
  }
  i12 = HEAP32[i1 + 32 >> 2] | 0;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 i12 = __ZN20TextRenderingPrivate15DynamicFontData28GetFaceForFontRefFromOSFontsERKNS_7FontRefE(i8, i9) | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN13GfxDeviceGLES22CopyComputeBufferCountE15ComputeBufferIDS0_j(i8, i1, i6, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) i7 = 0; else {
  i5 = i8 + 8456 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i7 = 0; else {
   i1 = i5;
   i3 = i2;
   L3 : while (1) {
    i2 = i3;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) break L3;
    }
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) i7 = 0; else if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) i7 = 0; else i7 = HEAP32[i1 + 20 >> 2] | 0;
  }
 }
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i4) return;
 i5 = i8 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else i1 = i5;
 L18 : while (1) {
  i3 = i2;
  while (1) {
   if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) break L18; else i3 = i2;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i1 = i3;
   break;
  } else i1 = i3;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i7 | 0) != 0 & (i4 | 0) != 0)) return;
 if ((HEAP32[i7 + 28 >> 2] | 0) < 0) return;
 i6 = i8 + 7424 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i1 = i7 + 16 | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8 + 7328 | 0;
 i10 = i5;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 if (i11 >>> 0 < i3 >>> 0 | ((i11 | 0) == (i3 | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  i2 = HEAP32[i8 + 4860 >> 2] | 0;
  i3 = i8 + 5480 | 0;
  mftCall_vi(i2 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i3 >> 2] | 0, 8) | 0);
  i2 = i8 + 7368 | 0;
  i11 = i2;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = _i64Add(i10 | 0, i11 | 0, 1, 0) | 0;
  i12 = getTempRet0() | 0;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i2 + 4 >> 2] = i12;
  i2 = i5;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i2 + 4 >> 2] = i11;
  i3 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i3 >> 2] | 0, 8) | 0);
  i2 = i8 + 7376 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & i3;
  i2 = i1;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i1 = i8 + 7352 | 0;
 i13 = i1;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 if (i12 >>> 0 < i3 >>> 0 | ((i12 | 0) == (i3 | 0) ? (HEAP32[i13 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  i13 = HEAP32[i8 + 4860 >> 2] | 0;
  i12 = i8 + 5480 | 0;
  mftCall_vi(i13 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 11) | 0);
  i13 = i8 + 7368 | 0;
  i11 = i13;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = _i64Add(i10 | 0, i11 | 0, 1, 0) | 0;
  i3 = getTempRet0() | 0;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i13 + 4 >> 2] = i3;
  i13 = i1;
  HEAP32[i13 >> 2] = i10;
  HEAP32[i13 + 4 >> 2] = i11;
  i12 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 11) | 0);
  i13 = i8 + 7376 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & i12;
 }
 i13 = i4 + 16 | 0;
 i11 = HEAP32[i13 + 4 >> 2] | 0;
 i12 = i5;
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 if (i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
  i13 = HEAP32[i8 + 4860 >> 2] | 0;
  i12 = i8 + 5480 | 0;
  mftCall_vi(i13 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 8) | 0);
  i13 = i8 + 7368 | 0;
  i11 = i13;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = _i64Add(i10 | 0, i11 | 0, 1, 0) | 0;
  i3 = getTempRet0() | 0;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i13 + 4 >> 2] = i3;
  i13 = i5;
  HEAP32[i13 >> 2] = i10;
  HEAP32[i13 + 4 >> 2] = i11;
  i12 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 8) | 0);
  i13 = i8 + 7376 | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & i12;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i8 + 7428 + (HEAP32[i7 + 36 >> 2] << 2) >> 2] | 0) == (i7 | 0)) {
  __ZN14DataBufferGLES11CopySubDataEPKS_iii(i1, HEAP32[i6 >> 2] | 0, HEAP32[i7 + 32 >> 2] | 0, i9, 4);
  return;
 } else {
  __ZN14DataBufferGLES11CopySubDataEPKS_iii(i1, HEAP32[i7 + 24 >> 2] | 0, 0, i9, 4);
  return;
 }
}

function __ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE(i9, f17, i5) {
 i9 = i9 | 0;
 f17 = Math_fround(f17);
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 12 | 0;
 i14 = i18 + 8 | 0;
 i11 = i18 + 4 | 0;
 i12 = i18;
 i8 = HEAP32[i9 + 68 >> 2] | 0;
 if ((i8 | 0) == 1) {
  f17 = Math_fround(HEAPF32[(HEAP32[i9 + 56 >> 2] | 0) + 4 >> 2]);
  STACKTOP = i18;
  return Math_fround(f17);
 }
 i15 = (i5 | 0) == 0 ? i9 + 28 | 0 : i5;
 i10 = i15 + 4 | 0;
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 if (f1 <= f17) if (Math_fround(HEAPF32[i15 + 8 >> 2]) > f17) {
  f4 = Math_fround(f17 - f1);
  f17 = Math_fround(f4 * Math_fround(HEAPF32[i15 + 12 >> 2]));
  f17 = Math_fround(f4 * Math_fround(f17 + Math_fround(HEAPF32[i15 + 16 >> 2])));
  f17 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i15 + 20 >> 2]) + f17));
  f17 = Math_fround(Math_fround(HEAPF32[i15 + 24 >> 2]) + f17);
  STACKTOP = i18;
  return Math_fround(f17);
 }
 i6 = i9 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 i5 = i8 + -1 | 0;
 f4 = Math_fround(HEAPF32[i7 + (i5 << 4) >> 2]);
 do if (f4 < f17) {
  HEAPF32[i10 >> 2] = f4;
  HEAPF32[i15 + 8 >> 2] = Math_fround(inf);
  HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
  i5 = HEAP32[i7 + (i5 << 4) + 4 >> 2] | 0;
  HEAP32[i15 + 24 >> 2] = i5;
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  if (f1 > f17) {
   f4 = Math_fround(f17 + Math_fround(-1.0e3));
   HEAPF32[i10 >> 2] = f4;
   HEAPF32[i15 + 8 >> 2] = f1;
   HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i15 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
   i5 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i15 + 24 >> 2] = i5;
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f1 = Math_fround(0.0);
   break;
  }
  __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i9, i15, f17, i11, i12);
  i7 = HEAP32[i11 >> 2] | 0;
  i9 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i6 >> 2] | 0;
  f20 = Math_fround(HEAPF32[i11 + (i7 << 4) >> 2]);
  f4 = Math_fround(f20 + Math_fround(0.0));
  HEAPF32[i10 >> 2] = f4;
  f3 = Math_fround(HEAPF32[i11 + (i9 << 4) >> 2]);
  HEAPF32[i15 + 8 >> 2] = Math_fround(f3 + Math_fround(0.0));
  HEAP32[i15 >> 2] = i7;
  f20 = Math_fround(f3 - f20);
  HEAPF32[i13 >> 2] = f20;
  HEAPF32[i14 >> 2] = Math_fround(.0000999999974);
  i8 = f20 < Math_fround(.0000999999974);
  i14 = HEAP32[(i8 ? i14 : i13) >> 2] | 0;
  HEAP32[i13 >> 2] = i14;
  f20 = Math_fround(HEAPF32[i11 + (i9 << 4) + 4 >> 2]);
  i8 = i11 + (i7 << 4) + 4 | 0;
  f20 = Math_fround(f20 - Math_fround(HEAPF32[i8 >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(Math_fround(1.0) / Math_fround(f3 * f3));
  i14 = i11 + (i7 << 4) + 12 | 0;
  f1 = Math_fround(HEAPF32[i14 >> 2]);
  i9 = i11 + (i9 << 4) + 8 | 0;
  f19 = Math_fround(f3 * f1);
  f2 = Math_fround(f3 * Math_fround(HEAPF32[i9 >> 2]));
  f3 = Math_fround(Math_fround(f21 * Math_fround(Math_fround(Math_fround(f19 + f2) - f20) - f20)) / f3);
  i10 = i15 + 12 | 0;
  HEAPF32[i10 >> 2] = f3;
  f2 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(Math_fround(f20 + Math_fround(f20 + f20)) - f19) - f19) - f2));
  i11 = i15 + 16 | 0;
  HEAPF32[i11 >> 2] = f2;
  i7 = i15 + 20 | 0;
  HEAPF32[i7 >> 2] = f1;
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = i15 + 24 | 0;
  HEAP32[i6 >> 2] = i5;
  if (Math_fround(HEAPF32[i14 >> 2]) == Math_fround(inf)) i16 = 12; else if (Math_fround(HEAPF32[i9 >> 2]) == Math_fround(inf)) i16 = 12;
  if ((i16 | 0) == 12) {
   HEAPF32[i10 >> 2] = Math_fround(0.0);
   HEAPF32[i11 >> 2] = Math_fround(0.0);
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP32[i6 >> 2] = i5;
   f1 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
  }
 } while (0);
 f21 = Math_fround(f17 - f4);
 f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(f21 * Math_fround(f1 + Math_fround(f21 * Math_fround(Math_fround(f21 * f3) + f2)))));
 STACKTOP = i18;
 return Math_fround(f21);
}

function _psh_hint_table_init(i5, i4, i6, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23;
 i22 = HEAP32[i4 >> 2] | 0;
 i2 = i22 << 1;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i1, 4, 0, i2, 0, i21) | 0;
 if (HEAP32[i21 >> 2] | 0) {
  i22 = HEAP32[i21 >> 2] | 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i20 = i5 + 8 | 0;
 HEAP32[i20 >> 2] = _UNITY_ft_mem_realloc(i1, 28, 0, i22, 0, i21) | 0;
 if (HEAP32[i21 >> 2] | 0) {
  i22 = HEAP32[i21 >> 2] | 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP32[i5 + 24 >> 2] = _UNITY_ft_mem_realloc(i1, 16, 0, i2 | 1, 0, i21) | 0;
 if (HEAP32[i21 >> 2] | 0) {
  i22 = HEAP32[i21 >> 2] | 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP32[i5 >> 2] = i22;
 i19 = i5 + 16 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i3 >> 2] | 0) + (i22 << 2);
 i18 = i5 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 if (i22 | 0) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  i2 = HEAP32[i20 >> 2] | 0;
  i3 = i22;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 8 >> 2];
   i3 = i3 + -1 | 0;
   if (!i3) break; else {
    i1 = i1 + 12 | 0;
    i2 = i2 + 28 | 0;
   }
  }
 }
 if (!i6) i1 = 0; else {
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 32 >> 2] = i6;
  if (!i2) i1 = 0; else {
   i17 = i1;
   i1 = 0;
   while (1) {
    i16 = HEAP32[i17 >> 2] | 0;
    if (i16) {
     i15 = 0;
     i5 = HEAP32[i17 + 8 >> 2] | 0;
     i4 = 0;
     i3 = 0;
     while (1) {
      if (!i3) {
       i3 = 128;
       i14 = i5 + 1 | 0;
       i4 = HEAPU8[i5 >> 0] | 0;
      } else i14 = i5;
      if (i3 & i4) {
       i7 = HEAP32[i20 >> 2] | 0;
       i13 = i7 + (i15 * 28 | 0) | 0;
       if (i22 >>> 0 > i15 >>> 0) {
        i5 = i7 + (i15 * 28 | 0) + 16 | 0;
        i6 = HEAP32[i5 >> 2] | 0;
        if (!(i6 & 4)) {
         HEAP32[i5 >> 2] = i6 | 4;
         i11 = HEAP32[i19 >> 2] | 0;
         i12 = i7 + (i15 * 28 | 0) + 20 | 0;
         HEAP32[i12 >> 2] = 0;
         L30 : do if (i1 | 0) {
          i10 = HEAP32[i13 >> 2] | 0;
          i7 = (HEAP32[i7 + (i15 * 28 | 0) + 4 >> 2] | 0) + i10 | 0;
          i5 = i11;
          i6 = i1;
          while (1) {
           i8 = HEAP32[i5 >> 2] | 0;
           i9 = HEAP32[i8 >> 2] | 0;
           if ((i7 | 0) >= (i9 | 0)) if (((HEAP32[i8 + 4 >> 2] | 0) + i9 | 0) >= (i10 | 0)) break;
           i6 = i6 + -1 | 0;
           if (!i6) break L30; else i5 = i5 + 4 | 0;
          }
          HEAP32[i12 >> 2] = i8;
         } while (0);
         if (i1 >>> 0 < i22 >>> 0) {
          i12 = i1 + 1 | 0;
          HEAP32[i18 >> 2] = i12;
          HEAP32[i11 + (i1 << 2) >> 2] = i13;
          i1 = i12;
         }
        }
       }
      }
      i15 = i15 + 1 | 0;
      if ((i15 | 0) == (i16 | 0)) break; else {
       i5 = i14;
       i3 = i3 >> 1;
      }
     }
    }
    i2 = i2 + -1 | 0;
    if (!i2) break; else i17 = i17 + 16 | 0;
   }
  }
 }
 if ((i1 | 0) != (i22 | 0) & (i22 | 0) != 0) i11 = 0; else {
  i22 = HEAP32[i21 >> 2] | 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 do {
  i4 = HEAP32[i20 >> 2] | 0;
  i10 = i4 + (i11 * 28 | 0) | 0;
  if (i22 >>> 0 > i11 >>> 0) {
   i2 = i4 + (i11 * 28 | 0) + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!(i3 & 4)) {
    HEAP32[i2 >> 2] = i3 | 4;
    i8 = HEAP32[i19 >> 2] | 0;
    i9 = i4 + (i11 * 28 | 0) + 20 | 0;
    HEAP32[i9 >> 2] = 0;
    L50 : do if (i1 | 0) {
     i7 = HEAP32[i10 >> 2] | 0;
     i4 = (HEAP32[i4 + (i11 * 28 | 0) + 4 >> 2] | 0) + i7 | 0;
     i2 = i8;
     i3 = i1;
     while (1) {
      i5 = HEAP32[i2 >> 2] | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i4 | 0) >= (i6 | 0)) if (((HEAP32[i5 + 4 >> 2] | 0) + i6 | 0) >= (i7 | 0)) break;
      i3 = i3 + -1 | 0;
      if (!i3) break L50; else i2 = i2 + 4 | 0;
     }
     HEAP32[i9 >> 2] = i5;
    } while (0);
    if (i1 >>> 0 < i22 >>> 0) {
     i17 = i1 + 1 | 0;
     HEAP32[i18 >> 2] = i17;
     HEAP32[i8 + (i1 << 2) >> 2] = i10;
     i1 = i17;
    }
   }
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i22 | 0));
 i22 = HEAP32[i21 >> 2] | 0;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN12PhysXRaycast10RaycastAllERK3Rayfi23QueryTriggerInteractionR13dynamic_arrayI10RaycastHitLj4EE(i1, i6, f7, i8, i9, i16) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 8 | 0;
 i1 = i15;
 i5 = __Z21GetManagerFromContexti(9) | 0;
 if ((HEAP16[gb + 1452608 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452608 | 0, i4);
  i1 = gb + 1452608 | 0;
 } else i1 = 0;
 i13 = i5 + 784 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = i5 + 788 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 if ((i3 | 0) != (i2 | 0)) HEAP32[i14 >> 2] = i3 + (~(((i3 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i12 = HEAP32[i5 + 748 >> 2] | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP16[i4 + 16 >> 1] = 0;
 i11 = i4 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAPF32[i4 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 68 >> 0] = 0;
 HEAP32[i4 + 72 >> 2] = i12;
 HEAP32[i4 + 76 >> 2] = 128;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 113988 + 8;
 HEAP32[i4 + 84 >> 2] = i13;
 __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(0, i6, f7, i8, i9, i4);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i1 = (HEAP32[i14 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
 i2 = (i1 | 0) / 44 | 0;
 i12 = i16 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i1, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i16 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i16 + 12 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i16 >> 2] = i11;
  break;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i14 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = i16 + 12 | 0;
 i11 = i16 + 4 | 0;
 i9 = 0;
 do {
  i3 = i1 + (i9 * 44 | 0) | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i12 >> 2] | 0;
  i8 = i6 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i12 >> 2] = i2;
    HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 * 44 | 0, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 44 | 0, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i16 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 44 | 0) | 0;
    HEAP32[i12 >> 2] = i2;
    HEAP32[i16 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i5;
  i8 = HEAP32[i16 >> 2] | 0;
  HEAP32[i8 + (i4 * 44 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 4 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 4 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 8 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 8 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 12 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 12 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 16 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 16 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 20 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 20 >> 2];
  i3 = i1 + (i9 * 44 | 0) + 24 | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i8 + (i4 * 44 | 0) + 24 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i8 + (i4 * 44 | 0) + 32 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 32 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 36 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 36 >> 2];
  HEAP32[i8 + (i4 * 44 | 0) + 40 >> 2] = HEAP32[i1 + (i9 * 44 | 0) + 40 >> 2];
  i9 = i9 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while ((i9 | 0) != (((HEAP32[i14 >> 2] | 0) - i1 | 0) / 44 | 0 | 0));
 STACKTOP = i15;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteNullEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i8;
  break;
 } while (0);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 110;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 117;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = 108;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 108;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 108;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 108;
  return 1;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 108;
  return 1;
 }
 return 0;
}

function __ZN17BlendShapeChannel8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i1 = i10 + 16 | 0;
 i2 = i10;
 i3 = i10 + 8 | 0;
 i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 1) | 0;
 if (i4 | 0) {
  if ((i4 | 0) > 0) {
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i9, i1, 1);
   i5 = i1 + 11 | 0;
   i4 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
   i12 = gb + 63648 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = i11;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   __ZN14ConstantString6assignEPKc10MemLabelId(i6, i4, i7);
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    i12 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i1 + 12 >> 2] | 0;
    HEAP32[i7 >> 2] = 1;
    HEAP32[i7 + 4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
   }
  } else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 863350 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i12 >>> 0) i8 = 14; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 14; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 14) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426420 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i12 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i12 >>> 0) i8 = 25; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 25; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426431 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i12 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i12 >>> 0) i8 = 36; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 36; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN19ClampVelocityModule8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i5, i8);
 i2 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1085989 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1085998 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1084342 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 620320 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 1065 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 620330 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i5 + 1064 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 620372 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i5 + 1068 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 620086 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i8 + 16 | 0;
  i10 = HEAP32[i8 + 20 >> 2] | 0;
  i1 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i10 >>> 0) i7 = 48; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 48; else {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i7 | 0) == 48) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN10ScSceneFnsIN5physx3Scb4BodyEE6removeERNS0_2Sc5SceneERS2_b(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 i12 = i4 + 236 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -25165825;
 if (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i4 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i4 + 8 >> 1] & 8) {
  __ZL22addOrRemoveRigidObjectILb0ELb0ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(HEAP32[i2 + 1236 >> 2] | 0, i4);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i2 + 1236 >> 2] | 0;
 do if (!i1) {
  i12 = i14 + 256 | 0;
  i9 = i14 + 260 | 0;
  HEAP32[i14 + 264 >> 2] = 0;
  i10 = i14 + 268 | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP32[i9 >> 2] = i14;
  HEAP32[i10 >> 2] = 64;
  i11 = i13 + 256 | 0;
  HEAP8[i11 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
  __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i2, i4 + 16 | 0, i13, i3);
  i6 = i13 + 260 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i13 + 264 >> 2] | 0;
  if (i8 | 0) {
   i2 = (HEAP32[i4 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
    i3 = i4 + -16 | 0;
    i4 = i4 + -12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i3);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i13 + 268 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i13 | 0) == (i1 | 0)) {
    HEAP8[i11 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
  i15 = HEAP32[i10 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i2, i4 + 16 | 0, i10, i3);
  i6 = i10 + 260 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i10 + 264 >> 2] | 0;
  if (i8 | 0) {
   i2 = (HEAP32[i4 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
    i3 = i4 + -16 | 0;
    i4 = i4 + -12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i3);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i10 | 0) == (i1 | 0)) {
    HEAP8[i9 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZN14EmissionModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620496 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620509 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620600 | 0, i5, i1 + 552 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620605 | 0, i5, i1 + 556 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620610 | 0, i5, i1 + 560 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620615 | 0, i5, i1 + 564 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620568 | 0, i5, i1 + 568 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620576 | 0, i5, i1 + 572 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620584 | 0, i5, i1 + 576 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620592 | 0, i5, i1 + 580 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620544 | 0, i5, i1 + 536 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620550 | 0, i5, i1 + 540 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620556 | 0, i5, i1 + 544 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620562 | 0, i5, i1 + 548 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620526 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 584 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN13AvatarBuilder11BuildAvatarER6AvatarRK10GameObjectRK16HumanDescriptionNS_7OptionsE(i3, i4, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 64 | 0;
 i10 = i18 + 16 | 0;
 i1 = i18 + 8 | 0;
 i17 = i18 + 48 | 0;
 i14 = i18 + 36 | 0;
 i12 = i18 + 24 | 0;
 i9 = i18;
 if ((HEAP16[gb + 1467016 + 6 >> 1] | 0) > -1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467016 | 0, i15);
  i16 = gb + 1467016 | 0;
 } else i16 = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if ((i5 | 0) == 3) if (__ZN13AvatarBuilder23IsValidHumanDescriptionERK16HumanDescriptionRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEEb(i7, i17, 0) | 0) i2 = 6; else {
  i14 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
  i15 = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
  HEAP32[i1 >> 2] = i14;
  HEAP32[i1 + 4 >> 2] = i15;
  __Z6FormatPKcz(i3, gb + 912475 | 0, i1);
 } else i2 = 6;
 if ((i2 | 0) == 6) {
  HEAP32[i14 >> 2] = 0;
  i13 = i14 + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i11 = i12 + 4 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  if (__ZN13AvatarBuilder17GenerateAvatarMapERK10GameObjectRNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEES9_RK16HumanDescription10AvatarTypebRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE(i6, i14, i12, i7, i5, (HEAP8[i8 + 5 >> 0] | 0) != 0, i17) | 0) {
   i6 = i8;
   i8 = HEAP32[i6 + 4 >> 2] | 0;
   i10 = i9;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN13AvatarBuilder19BuildAvatarInternalER6AvatarRKNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERK10GameObjectRK16HumanDescriptionNS_7OptionsEb(i4, i14, 0, i7, i15, 0);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
  } else {
   i8 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0;
   i9 = (HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17;
   HEAP32[i10 >> 2] = i8;
   HEAP32[i10 + 4 >> 2] = i9;
   __Z6FormatPKcz(i3, gb + 912475 | 0, i10);
  }
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i15 + 4 | 0;
    i6 = i15 + 4 | 0;
    do {
     i3 = i2 + -36 | 0;
     HEAP32[i11 >> 2] = i3;
     i4 = i2 + -20 | 0;
     if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
      i10 = HEAP32[i4 >> 2] | 0;
      i9 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i5 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i15);
     }
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i10 = HEAP32[i3 >> 2] | 0;
      i9 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i6 >> 2] = i9;
      __Z19free_alloc_internalPvRK10MemLabelId(i10, i15);
     }
     i2 = HEAP32[i11 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[i14 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i13 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i15 + 4 | 0;
    i6 = i15 + 4 | 0;
    do {
     i3 = i2 + -36 | 0;
     HEAP32[i13 >> 2] = i3;
     i4 = i2 + -20 | 0;
     if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
      i12 = HEAP32[i4 >> 2] | 0;
      i11 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i5 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
     }
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i12 = HEAP32[i3 >> 2] | 0;
      i11 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i6 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
     }
     i2 = HEAP32[i13 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i14 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 if (!i16) {
  STACKTOP = i18;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i18;
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i11 + 308 | 0;
 i21 = i11 + 256 | 0;
 i13 = i11 + 360 | 0;
 i22 = i11 + 32 | 0;
 i15 = i11 + 204 | 0;
 i24 = i11 + 16 | 0;
 i1 = i11 + 200 | 0;
 i10 = i11 + 184 | 0;
 i9 = i11 + 168 | 0;
 i14 = i11 + 44 | 0;
 i18 = i11;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev(i14);
 HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i20 = i10;
 i19 = i9;
 i17 = i8;
 i16 = i7;
 i7 = i5;
 i8 = i6;
 i2 = i13;
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 >> 2] = i20;
 HEAP32[i23 + 4 >> 2] = i19;
 i6 = i23 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 + 20 >> 2] = i17;
 HEAP32[i23 + 24 >> 2] = i16;
 HEAP32[i23 + 28 >> 2] = i7;
 HEAP32[i23 + 32 >> 2] = i8;
 HEAP8[i23 + 36 >> 0] = 1;
 HEAP32[i23 + 40 >> 2] = i2;
 HEAP32[i23 + 44 >> 2] = 0;
 HEAP32[i23 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i14 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i14 + 52 | 0, 4);
 HEAP32[i21 >> 2] = i20;
 HEAP32[i21 + 4 >> 2] = i19;
 i6 = i21 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 20 >> 2] = i17;
 HEAP32[i21 + 24 >> 2] = i16;
 HEAP32[i21 + 28 >> 2] = i7;
 HEAP32[i21 + 32 >> 2] = i8;
 HEAP8[i21 + 36 >> 0] = 1;
 HEAP32[i21 + 40 >> 2] = i2;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i21, i14 + 80 | 0, 6);
 HEAP32[i15 >> 2] = i20;
 HEAP32[i15 + 4 >> 2] = i19;
 i6 = i15 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i7;
 HEAP32[i15 + 32 >> 2] = i8;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i2;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj690ES3_NS_23PxVehicleDriveSimDataNWES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 108 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
  }
 }
 i24 = HEAP32[i4 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i24 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i11 + 308 | 0;
 i21 = i11 + 256 | 0;
 i13 = i11 + 360 | 0;
 i22 = i11 + 32 | 0;
 i15 = i11 + 204 | 0;
 i24 = i11 + 16 | 0;
 i1 = i11 + 200 | 0;
 i10 = i11 + 184 | 0;
 i9 = i11 + 168 | 0;
 i14 = i11 + 44 | 0;
 i18 = i11;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev(i14);
 HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i20 = i10;
 i19 = i9;
 i17 = i8;
 i16 = i7;
 i7 = i5;
 i8 = i6;
 i2 = i13;
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 >> 2] = i20;
 HEAP32[i23 + 4 >> 2] = i19;
 i6 = i23 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 + 20 >> 2] = i17;
 HEAP32[i23 + 24 >> 2] = i16;
 HEAP32[i23 + 28 >> 2] = i7;
 HEAP32[i23 + 32 >> 2] = i8;
 HEAP8[i23 + 36 >> 0] = 1;
 HEAP32[i23 + 40 >> 2] = i2;
 HEAP32[i23 + 44 >> 2] = 0;
 HEAP32[i23 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i14 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i14 + 52 | 0, 4);
 HEAP32[i21 >> 2] = i20;
 HEAP32[i21 + 4 >> 2] = i19;
 i6 = i21 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 20 >> 2] = i17;
 HEAP32[i21 + 24 >> 2] = i16;
 HEAP32[i21 + 28 >> 2] = i7;
 HEAP32[i21 + 32 >> 2] = i8;
 HEAP8[i21 + 36 >> 0] = 1;
 HEAP32[i21 + 40 >> 2] = i2;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i21, i14 + 80 | 0, 6);
 HEAP32[i15 >> 2] = i20;
 HEAP32[i15 + 4 >> 2] = i19;
 i6 = i15 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i7;
 HEAP32[i15 + 32 >> 2] = i8;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i2;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj678ES3_NS_23PxVehicleDriveSimData4WES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 108 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
  }
 }
 i24 = HEAP32[i4 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i24 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN13InitialModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i4 = i1 + 4 | 0;
 HEAP8[i4 >> 0] = 1;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, i5, i4, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620918 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620932 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620943 | 0, gb + 620954 | 0, i6, 0);
 __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 692 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620969 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 956 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620979 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 1220 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620990 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 1484 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621001 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 1748 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621016 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 2012 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621031 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621045 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 2540 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621072 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 2548 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621088 | 0, i5, i1 + 2552 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621095 | 0, i5, i1 + 2553 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i1 = i1 + 2276 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621122 | 0, gb + 620173 | 0, i1, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i11 + 596 | 0;
 i21 = i11 + 544 | 0;
 i13 = i11 + 648 | 0;
 i22 = i11 + 32 | 0;
 i15 = i11 + 492 | 0;
 i24 = i11 + 16 | 0;
 i1 = i11 + 488 | 0;
 i10 = i11 + 472 | 0;
 i9 = i11 + 456 | 0;
 i14 = i11 + 48 | 0;
 i18 = i11;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx28PxParticleFluidGeneratedInfoC2Ev(i14);
 HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i20 = i10;
 i19 = i9;
 i17 = i8;
 i16 = i7;
 i7 = i5;
 i8 = i6;
 i2 = i13;
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 >> 2] = i20;
 HEAP32[i23 + 4 >> 2] = i19;
 i6 = i23 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 + 20 >> 2] = i17;
 HEAP32[i23 + 24 >> 2] = i16;
 HEAP32[i23 + 28 >> 2] = i7;
 HEAP32[i23 + 32 >> 2] = i8;
 HEAP8[i23 + 36 >> 0] = 1;
 HEAP32[i23 + 40 >> 2] = i2;
 HEAP32[i23 + 44 >> 2] = 0;
 HEAP32[i23 + 48 >> 2] = 0;
 i6 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i14, i23, 0) | 0;
 HEAP32[i21 >> 2] = i20;
 HEAP32[i21 + 4 >> 2] = i19;
 i5 = i21 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 20 >> 2] = i17;
 HEAP32[i21 + 24 >> 2] = i16;
 HEAP32[i21 + 28 >> 2] = i7;
 HEAP32[i21 + 32 >> 2] = i8;
 HEAP8[i21 + 36 >> 0] = 1;
 HEAP32[i21 + 40 >> 2] = i2;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i14, i21, i6) | 0;
 HEAP32[i15 >> 2] = i20;
 HEAP32[i15 + 4 >> 2] = i19;
 i6 = i15 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i7;
 HEAP32[i15 + 32 >> 2] = i8;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i2;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj187ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 348 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj188ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 364 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj189ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 380 | 0, 2);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
  }
 }
 i24 = HEAP32[i4 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i24 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZNK22ParticleSystemRenderer16PrepareForRenderER14ParticleSystemRK6CameraRK10Matrix4x4ffP23ParticleSystemParticlesR22ParticleSystemTempData(i8, i12, i13, i2, f9, i1, i15) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 f9 = Math_fround(f9);
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i14 = 0, f16 = f0, f17 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 192 | 0;
 i5 = i14 + 152 | 0;
 i6 = i14 + 140 | 0;
 i1 = i14 + 128 | 0;
 i11 = i14 + 64 | 0;
 i7 = i14;
 if ((HEAP16[i8 + 340 >> 1] | 0) == 4) {
  i3 = HEAP32[i12 + 32 >> 2] | 0;
  if (!(HEAP8[i3 + 868 >> 0] | 0)) __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i3);
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i12, i3, i4, i5, i6, i1);
 i10 = (HEAP32[(HEAP32[i12 + 36 >> 2] | 0) + 280 >> 2] | 0) == 1 ? gb + 1162292 | 0 : i4;
 __ZNK9Transform11GetRotationEv(i7, i3);
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i11, gb + 1162364 | 0, i7);
 __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(__ZNK6Camera22GetWorldToCameraMatrixEv(i13) | 0, i10, i7);
 i5 = HEAP32[i7 + 24 >> 2] | 0;
 i4 = HEAP32[i7 + 40 >> 2] | 0;
 i3 = HEAP32[i7 + 56 >> 2] | 0;
 HEAP32[i15 + 336 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i15 + 340 >> 2] = i5;
 HEAP32[i15 + 344 >> 2] = i4;
 HEAP32[i15 + 348 >> 2] = i3;
 i3 = i15 + 352 | 0;
 i4 = i15 + 356 | 0;
 i5 = i15 + 360 | 0;
 i6 = i15 + 364 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!(HEAP8[i13 + 1088 >> 0] | 0)) {
  f17 = Math_fround(-f9);
  f16 = Math_fround(Math_fround(HEAPF32[i8 + 344 >> 2]) * f17);
  f17 = Math_fround(Math_fround(HEAPF32[i8 + 348 >> 2]) * f17);
  f9 = Math_fround(__ZNK6Camera6GetFarEv(i13));
  f16 = Math_fround(f16 / f9);
  f9 = Math_fround(f17 / f9);
  HEAPF32[i3 >> 2] = f16;
  HEAPF32[i4 >> 2] = f9;
  i8 = ((HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) == 2139095040;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  if (i8) HEAPF32[i3 >> 2] = Math_fround(0.0);
  if ((i1 & 2139095040 | 0) == 2139095040) HEAPF32[i4 >> 2] = Math_fround(-1.0);
 } else {
  f16 = Math_fround(Math_fround(HEAPF32[i8 + 344 >> 2]) * f9);
  f17 = Math_fround(Math_fround(HEAPF32[i8 + 348 >> 2]) * f9);
  HEAPF32[i5 >> 2] = f16;
  HEAPF32[i6 >> 2] = f17;
  i8 = ((HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) == 2139095040;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  if (i8) HEAPF32[i5 >> 2] = Math_fround(0.0);
  if ((i1 & 2139095040 | 0) == 2139095040) HEAPF32[i6 >> 2] = Math_fround(-1.0);
 }
 i4 = i15;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i1 = i15 + 128 | 0;
 i4 = i1;
 i2 = i10;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i4 = i15 + 256 | 0;
 i2 = i11;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 __Z25InvertMatrix4x4_General3DPKfPf(i15, i15 + 64 | 0) | 0;
 __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(i15, i1, i15 + 192 | 0);
 i1 = i15 + 320 | 0;
 i13 = i13 + 892 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i1 = i15 + 420 | 0;
 i13 = (HEAP32[i12 + 40 >> 2] | 0) + 316 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i1 = HEAP32[i12 + 864 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  i11 = 4096;
  i12 = 1;
  i15 = i15 + 332 | 0;
  i13 = HEAP32[i15 >> 2] | 0;
  i13 = i13 & -16777216;
  i12 = i11 | i12;
  i13 = i12 | i13;
  HEAP32[i15 >> 2] = i13;
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i1 + 540 >> 2] << 12 & 16773120;
 i12 = HEAP32[i1 + 536 >> 2] & 4095;
 i15 = i15 + 332 | 0;
 i13 = HEAP32[i15 >> 2] | 0;
 i13 = i13 & -16777216;
 i12 = i11 | i12;
 i13 = i12 | i13;
 HEAP32[i15 >> 2] = i13;
 STACKTOP = i14;
 return;
}

function __ZN9Transform23SetSiblingIndexInternalEib(i15, i1, i13) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i16 = i15 + 100 | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 if (!i14) {
  STACKTOP = i18;
  return;
 }
 i9 = i14 + 80 | 0;
 i11 = i14 + 92 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 > i1 >>> 0) if ((HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0) == (i15 | 0)) {
  STACKTOP = i18;
  return;
 }
 L8 : do if (!i4) {
  i1 = 0;
  i5 = 8;
 } else {
  i2 = i4 + -1 | 0;
  i1 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
  i2 = HEAP32[i14 + 80 >> 2] | 0;
  i3 = i2 + (i4 << 2) | 0;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i15 | 0)) break;
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i5 = 8;
    break L8;
   }
  }
  if ((i2 | 0) == (i3 | 0)) {
   i2 = i4;
   i10 = i9;
  } else {
   i10 = i2 + 4 | 0;
   _memmove(i2 | 0, i10 | 0, i3 - i10 | 0) | 0;
   i2 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
   HEAP32[i11 >> 2] = i2;
   i10 = i9;
  }
 } while (0);
 if ((i5 | 0) == 8) {
  i2 = i4;
  i10 = i9;
 }
 i6 = i15;
 i7 = i1 << 2 >> 2;
 i8 = i2 - i7 | 0;
 i2 = i2 + 1 | 0;
 HEAP32[i11 >> 2] = i2;
 i3 = i14 + 96 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i2 >>> 0) {
  i12 = i4 << 1;
  i2 = i12 >>> 0 > i2 >>> 0 ? i12 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i14 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i12;
   break;
  }
 } while (0);
 i12 = (HEAP32[i10 >> 2] | 0) + (i7 << 2) | 0;
 _memmove(i12 + 4 | 0, i12 | 0, i8 << 2 | 0) | 0;
 HEAP32[i12 >> 2] = i6;
 i12 = i15 + 32 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if (i8 | 0) {
  i11 = HEAP32[i15 + 36 >> 2] | 0;
  i2 = HEAP32[i15 + 92 >> 2] | 0;
  if (!i2) i9 = i11; else {
   i3 = i15;
   do {
    i3 = HEAP32[(HEAP32[i3 + 80 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
    i2 = HEAP32[i3 + 92 >> 2] | 0;
   } while ((i2 | 0) != 0);
   i9 = HEAP32[i3 + 36 >> 2] | 0;
  }
  if ((i1 | 0) > 0) {
   i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i2 = HEAP32[i1 + 92 >> 2] | 0;
   if (i2) do {
    i1 = HEAP32[(HEAP32[i1 + 80 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
    i2 = HEAP32[i1 + 92 >> 2] | 0;
   } while ((i2 | 0) != 0);
  } else i1 = i14;
  i5 = HEAP32[i1 + 36 >> 2] | 0;
  i6 = HEAP32[i8 + 72 >> 2] | 0;
  i7 = i6 + (i11 << 2) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 + 68 >> 2] | 0;
  i3 = i1 + (i9 << 2) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = -1;
  HEAP32[i1 + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = -1;
  if ((i2 | 0) != -1) HEAP32[i6 + (i2 << 2) >> 2] = i4;
  i10 = i1 + (i5 << 2) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  if ((i1 | 0) != -1) HEAP32[i6 + (i1 << 2) >> 2] = i9;
 }
 if (!i13) {
  STACKTOP = i18;
  return;
 }
 i6 = HEAP32[gb + 1158396 >> 2] | 0;
 i7 = HEAP32[i6 + 36 >> 2] | 0;
 i2 = i14 + 32 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i3 = HEAP32[i2 + 60 >> 2] | 0;
  i4 = HEAP32[i2 + 56 >> 2] | 0;
  i5 = i2 + 36 | 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  do {
   i14 = HEAP32[i3 + (i1 << 2) >> 2] & i7;
   i13 = i4 + (i1 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | i14;
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i14;
   i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
 }
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i6, HEAP32[i12 >> 2] | 0);
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i12 >> 2] | 0, HEAP32[i15 + 36 >> 2] | 0, 256);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105076 | 0, i17);
 STACKTOP = i18;
 return;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902127 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902137 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902149 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902162 | 0, gb + 906560 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902170 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 136 | 0;
 i4 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 901500 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 137 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902184 | 0, i4, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i1 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i7 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN15TerrainCollider6CreateEPK9Rigidbody(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i4 = i11;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 152 >> 2] | 0, i10 | 0);
 i6 = i10 + 60 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i4);
   i2 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = __Z18GetITerrainManagerv() | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i4);
    i2 = HEAP32[i9 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 21;
   }
  }
  if ((i7 | 0) == 19) i7 = 21;
  if ((i7 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 i2 = i1 + 248 | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i2 | 0) | 0;
 if (!i3) {
  STACKTOP = i11;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i5 | 0, i2 | 0);
 f14 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i9 >> 2]));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i9 + 4 >> 2]));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i9 + 8 >> 2]));
 HEAPF32[i10 + 100 >> 2] = f14;
 HEAPF32[i10 + 104 >> 2] = f13;
 HEAPF32[i10 + 108 >> 2] = f12;
 i6 = HEAP32[i1 + 336 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 + 340 >> 2]);
 i7 = HEAP32[i1 + 344 >> 2] | 0;
 f12 = Math_fround(f12 / Math_fround(32766.0));
 HEAP32[i9 >> 2] = 6;
 HEAP32[i9 + 4 >> 2] = i3;
 HEAPF32[i9 + 8 >> 2] = f12;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i10, i9, i8);
 if (HEAP32[i10 + 36 >> 2] | 0) {
  i2 = HEAP32[i1 + 316 >> 2] | 0;
  i3 = i10 + 68 | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i10 + 72 | 0; else {
    i9 = i10 + 72 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = i9;
   }
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  }
 }
 if (HEAP8[i10 + 64 >> 0] | 0) if (__Z14IsWorldPlayingv() | 0) __ZN15TerrainCollider11CreateTreesEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_6PxVec3ES6_RS4_S7_(i1, i4, i5, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i6 + 40 | 0;
 i26 = i6 + 12 | 0;
 i25 = i6;
 f21 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
 f14 = Math_fround(f21 * Math_fround(HEAPF32[i4 >> 2]));
 f20 = Math_fround(f21 * Math_fround(HEAPF32[i4 + 4 >> 2]));
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i4 + 8 >> 2]));
 HEAPF32[i3 >> 2] = f14;
 HEAPF32[i3 + 4 >> 2] = f20;
 HEAPF32[i3 + 8 >> 2] = f21;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i27 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i26 | 0, i1 | 0);
 f21 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i27 >> 2]);
 f14 = Math_fround(HEAPF32[i27 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i27 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i26 >> 2]);
 f8 = Math_fround(f21 * f7);
 f17 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f20 * f17));
 f15 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f14 * f15));
 f24 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f22 * f24));
 f12 = Math_fround(Math_fround(Math_fround(f22 * f7) + Math_fround(Math_fround(f14 * f17) + Math_fround(f21 * f24))) - Math_fround(f20 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f20 * f24) + Math_fround(Math_fround(f22 * f17) + Math_fround(f21 * f15))) - Math_fround(f14 * f7));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f17) - Math_fround(f20 * f7)) - Math_fround(f14 * f24)) - Math_fround(f22 * f15));
 f22 = Math_fround(f8 + f8);
 f24 = Math_fround(f12 + f12);
 f14 = Math_fround(f10 + f10);
 f7 = Math_fround(f12 * f24);
 f20 = Math_fround(f10 * f14);
 f12 = Math_fround(f22 * f12);
 f17 = Math_fround(f22 * f10);
 f21 = Math_fround(f22 * f15);
 f10 = Math_fround(f10 * f24);
 f24 = Math_fround(f15 * f24);
 f14 = Math_fround(f15 * f14);
 f15 = Math_fround(Math_fround(Math_fround(1.0) - f7) - f20);
 f9 = Math_fround(f12 + f14);
 f16 = Math_fround(f17 - f24);
 f14 = Math_fround(f12 - f14);
 f22 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f22));
 f20 = Math_fround(f22 - f20);
 f8 = Math_fround(f21 + f10);
 f24 = Math_fround(f17 + f24);
 f21 = Math_fround(f10 - f21);
 f7 = Math_fround(f22 - f7);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i25 | 0, i1 | 0);
 f22 = Math_fround(HEAPF32[i25 >> 2]);
 f10 = Math_fround(f22 * f15);
 f17 = Math_fround(f22 * f9);
 f22 = Math_fround(f22 * f16);
 f12 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f18 = Math_fround(f12 * f14);
 f11 = Math_fround(f12 * f20);
 f12 = Math_fround(f12 * f8);
 f23 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f19 = Math_fround(f23 * f24);
 f13 = Math_fround(f23 * f21);
 f15 = Math_fround(Math_fround(f24 * f19) + Math_fround(Math_fround(f14 * f18) + Math_fround(f15 * f10)));
 f14 = Math_fround(Math_fround(Math_fround(f9 * f17) + Math_fround(f20 * f11)) + Math_fround(f21 * f13));
 f12 = Math_fround(Math_fround(f7 * Math_fround(f23 * f7)) + Math_fround(Math_fround(f16 * f22) + Math_fround(f8 * f12)));
 f9 = Math_fround(Math_fround(f21 * f19) + Math_fround(Math_fround(f20 * f18) + Math_fround(f9 * f10)));
 f10 = Math_fround(Math_fround(f7 * f19) + Math_fround(Math_fround(f18 * f8) + Math_fround(f16 * f10)));
 f13 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f11 * f8)) + Math_fround(f7 * f13));
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f7 * f15);
 f8 = Math_fround(f7 * f9);
 f7 = Math_fround(f7 * f10);
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f9 = Math_fround(f15 + Math_fround(f11 * f9));
 f8 = Math_fround(Math_fround(f11 * f14) + f8);
 f7 = Math_fround(Math_fround(f11 * f13) + f7);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f8 = Math_fround(Math_fround(f11 * f13) + f8);
 f7 = Math_fround(Math_fround(f11 * f12) + f7);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f11 * f10) + f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 STACKTOP = i6;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i16, i7, i1) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i6 = i15 + 8 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i5 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i13 = HEAP32[i7 >> 2] | 0;
 i13 = (HEAP32[i13 >> 2] | 0) + i13 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i9 = HEAP32[gb + 37304 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 14; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 14) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 27; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 27; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 27) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i16, i7, i1) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i6 = i15 + 8 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i5 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i13 = HEAP32[i7 >> 2] | 0;
 i13 = (HEAP32[i13 >> 2] | 0) + i13 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 14; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 14) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 27; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 27; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 27) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i16, i7, i1) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i6 = i15 + 8 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i5 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i13 = HEAP32[i7 >> 2] | 0;
 i13 = (HEAP32[i13 >> 2] | 0) + i13 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 14; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 14) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 27; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 27; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 27) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = (i13 - i8 | 0) / 36 | 0;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 36 | 0) >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 119304647) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = (i1 - i2 | 0) / 36 | 0;
  i1 = i14 << 1;
  i1 = i14 >>> 0 < 59652323 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 119304647;
  if (i1 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 * 36 | 0) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 * 36 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 36 | 0;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 * 36 | 0) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP8[i7 + 16 >> 0] = HEAP8[i6 + 16 >> 0] | 0;
   i8 = i8 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i9, i13, i15 - (((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 36 | 0) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -36 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -24 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = (i13 - i8 | 0) / 36 | 0;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 36 | 0) >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -36 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -24 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 119304647) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = (i1 - i2 | 0) / 36 | 0;
  i1 = i14 << 1;
  i1 = i14 >>> 0 < 59652323 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 119304647;
  if (i1 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 * 36 | 0) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 * 36 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 36 | 0;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 * 36 | 0) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP8[i7 + 16 >> 0] = HEAP8[i6 + 16 >> 0] | 0;
   i8 = i8 + 36 | 0;
   i1 = i1 + 36 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i9, i13, i15 - (((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 36 | 0) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -36 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -24 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN5physx3Cct15userHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef(i5, i1, i2, f3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 4 >> 2] | 0;
 i4 = i9 >>> 16;
 switch (i9 & 65535 | 0) {
 case 0:
  {
   i9 = HEAP32[(__ZN5physx3Cct26CharacterControllerManager14getControllersEv(HEAP32[i6 + 464 >> 2] | 0) | 0) + (i4 << 2) >> 2] | 0;
   HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
   i5 = i7 + 8 | 0;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i7 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i7 + 36 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i7 + 40 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i7 + 44 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAPF32[i7 + 56 >> 2] = f3;
   i2 = i7 + 60 | 0;
   HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0) | 0;
   i1 = HEAP32[i6 + 72 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i7 | 0);
   i1 = HEAP32[i6 + 76 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0) & 255;
   i9 = i1;
   STACKTOP = i8;
   return i9 | 0;
  }
 case 1:
  {
   HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
   i9 = i7 + 8 | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i7 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i7 + 36 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i7 + 40 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i7 + 44 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAPF32[i7 + 56 >> 2] = f3;
   i9 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 4 >> 2] | 0;
   i2 = i9 + (i4 * 72 | 0) + 8 | 0;
   i1 = HEAP32[i9 + (i4 * 72 | 0) >> 2] | 0;
   HEAP32[i7 + 60 >> 2] = HEAP32[i9 + (i4 * 72 | 0) + 12 >> 2];
   HEAP32[i5 + 8 >> 2] = i2;
   HEAP32[i5 + 12 >> 2] = i1;
   i1 = HEAP32[i6 + 72 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0);
   i1 = HEAP32[i6 + 76 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0) | 0) & 255;
   i9 = i1;
   STACKTOP = i8;
   return i9 | 0;
  }
 case 2:
  {
   HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
   i9 = i7 + 8 | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i7 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i7 + 36 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i7 + 40 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i7 + 44 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAPF32[i7 + 56 >> 2] = f3;
   i9 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 16 >> 2] | 0;
   i2 = i9 + (i4 << 6) + 8 | 0;
   i1 = HEAP32[i9 + (i4 << 6) >> 2] | 0;
   HEAP32[i7 + 60 >> 2] = HEAP32[i9 + (i4 << 6) + 12 >> 2];
   HEAP32[i5 + 8 >> 2] = i2;
   HEAP32[i5 + 12 >> 2] = i1;
   i1 = HEAP32[i6 + 72 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0);
   i1 = HEAP32[i6 + 76 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0) | 0) & 255;
   i9 = i1;
   STACKTOP = i8;
   return i9 | 0;
  }
 default:
  {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i6);
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i10 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i7 + 112 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 88 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i7 + 92 >> 2] = i2;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 96 >> 2] = i1;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i7 + 100 >> 2] = i4;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i7 + 104 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i7 + 32 | 0, gb + 1048238 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i7 + 44 | 0, gb + 1048256 | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i7 + 56 | 0, gb + 1048283 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i7 + 68 | 0, gb + 1048292 | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f12 < Math_fround(0.0);
 i6 = f12 > Math_fround(1.0);
 f12 = i6 ? Math_fround(1.0) : f12;
 HEAPF32[i7 + 80 >> 2] = i1 ? Math_fround(0.0) : f12;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i6 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i1;
  i1 = i6;
 }
 HEAP8[i7 + 113 >> 0] = i1;
 i3 = i7 + 108 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(i1 << 24 >> 24)) {
  HEAP32[i3 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i3 >> 2] = 1;
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i11 + 324 | 0;
 i21 = i11 + 272 | 0;
 i13 = i11 + 376 | 0;
 i22 = i11 + 32 | 0;
 i14 = i11 + 220 | 0;
 i24 = i11 + 16 | 0;
 i1 = i11 + 216 | 0;
 i10 = i11 + 200 | 0;
 i9 = i11 + 184 | 0;
 i15 = i11 + 44 | 0;
 i18 = i11;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev(i15);
 HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i20 = i10;
 i19 = i9;
 i17 = i8;
 i16 = i7;
 i7 = i5;
 i8 = i6;
 i2 = i13;
 HEAP32[i22 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 >> 2] = i20;
 HEAP32[i23 + 4 >> 2] = i19;
 i6 = i23 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 HEAP32[i23 + 20 >> 2] = i17;
 HEAP32[i23 + 24 >> 2] = i16;
 HEAP32[i23 + 28 >> 2] = i7;
 HEAP32[i23 + 32 >> 2] = i8;
 HEAP8[i23 + 36 >> 0] = 1;
 HEAP32[i23 + 40 >> 2] = i2;
 HEAP32[i23 + 44 >> 2] = 0;
 HEAP32[i23 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i15 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i23, i15 + 52 | 0, 4);
 HEAP32[i21 >> 2] = i20;
 HEAP32[i21 + 4 >> 2] = i19;
 i6 = i21 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i21 + 20 >> 2] = i17;
 HEAP32[i21 + 24 >> 2] = i16;
 HEAP32[i21 + 28 >> 2] = i7;
 HEAP32[i21 + 32 >> 2] = i8;
 HEAP8[i21 + 36 >> 0] = 1;
 HEAP32[i21 + 40 >> 2] = i2;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i21, i15 + 80 | 0, 6);
 HEAP32[i14 >> 2] = i20;
 HEAP32[i14 + 4 >> 2] = i19;
 i6 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i7;
 HEAP32[i14 + 32 >> 2] = i8;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i2;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i24 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
  }
 }
 i24 = HEAP32[i4 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i24 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 40 | 0;
 i13 = i17 + 24 | 0;
 i11 = i17;
 i5 = i17 + 20 | 0;
 i6 = i17 + 16 | 0;
 i15 = i14 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i1 | 0;
 i4 = i1;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i17;
   return;
  }
  i3 = i4 + i12 | 0;
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i8 = i13 + 12 | 0;
  HEAP32[i8 >> 2] = i1;
  if (!i12) {
   i5 = i13 + 8 | 0;
   i3 = 0;
   i4 = 0;
   i1 = 0;
  } else {
   if ((i12 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i16 >> 2] = 14;
   HEAP32[i16 + 4 >> 2] = i1;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i13 >> 2] = i2;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2 + i12;
   i1 = i4;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i3 | 0));
   i5 = i6;
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = i2;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i12 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = i3;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i15 >> 2] = i4;
  i15 = i14 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i1;
  i1 = i12;
  if (i12 | 0) {
   if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i1;
   i15 = HEAP32[i8 >> 2] | 0;
   HEAP32[i16 >> 2] = 14;
   HEAP32[i16 + 4 >> 2] = i15;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
  STACKTOP = i17;
  return;
 }
 i10 = i14 + 8 | 0;
 if (((HEAP32[i10 >> 2] | 0) - i1 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i9 = i11 + 12 | 0;
 HEAP32[i9 >> 2] = i1;
 i7 = i11 + 8 | 0;
 if (i12 | 0) {
  HEAP32[i16 >> 2] = 14;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - i2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i4;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i7 >> 2] = i3 + i12;
  if (i1 | 0) {
   i4 = HEAP32[i9 >> 2] | 0;
   HEAP32[i16 >> 2] = 14;
   HEAP32[i16 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i13, i16);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i4 = i2;
 i5 = i1;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + i12 | 0;
  if ((i5 | 0) != (i3 | 0)) {
   HEAP32[i8 >> 2] = i3;
   i1 = i3;
  }
 }
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i1;
 i1 = i13;
 if (i13 | 0) {
  if ((i2 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i1;
  i15 = HEAP32[i9 >> 2] | 0;
  HEAP32[i16 >> 2] = 14;
  HEAP32[i16 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 }
 STACKTOP = i17;
 return;
}

function __Z18SkinGenericMathLibILi4ELb0ELb0EEvR12SkinMeshInfo(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 96 | 0;
 i23 = i25 + 48 | 0;
 i24 = i25;
 i20 = i21 + 60 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i19 = i1 + -1 | 0;
  i4 = HEAP32[i21 + 40 >> 2] | 0;
  i5 = HEAP32[i21 + 44 >> 2] | 0;
  i6 = HEAP32[i21 + 68 >> 2] | 0;
  i7 = HEAP32[i21 + 24 >> 2] | 0;
  i8 = i22 + 4 | 0;
  i9 = i22 + 8 | 0;
  i10 = i22 + 16 | 0;
  i11 = i22 + 20 | 0;
  i12 = i22 + 24 | 0;
  i13 = i22 + 32 | 0;
  i14 = i22 + 36 | 0;
  i15 = i22 + 40 | 0;
  i16 = i22 + 48 | 0;
  i17 = i22 + 52 | 0;
  i18 = i22 + 56 | 0;
  i1 = HEAP32[i21 + 36 >> 2] | 0;
  i2 = 0;
  i3 = HEAP32[i21 + 32 >> 2] | 0;
  while (1) {
   __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, i6, i7, i2);
   f29 = Math_fround(HEAPF32[i3 >> 2]);
   f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   i26 = HEAP32[i3 + 12 >> 2] | 0;
   f33 = Math_fround(f29 * Math_fround(HEAPF32[i22 >> 2]));
   f28 = Math_fround(f29 * Math_fround(HEAPF32[i8 >> 2]));
   f29 = Math_fround(f29 * Math_fround(HEAPF32[i9 >> 2]));
   f32 = Math_fround(f30 * Math_fround(HEAPF32[i10 >> 2]));
   f31 = Math_fround(f30 * Math_fround(HEAPF32[i11 >> 2]));
   f32 = Math_fround(f33 + f32);
   f31 = Math_fround(f28 + f31);
   f30 = Math_fround(f29 + Math_fround(f30 * Math_fround(HEAPF32[i12 >> 2])));
   f29 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
   f28 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
   f29 = Math_fround(f32 + f29);
   f28 = Math_fround(f31 + f28);
   f27 = Math_fround(f30 + Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2])));
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i16 >> 2]));
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i17 >> 2]));
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i18 >> 2]));
   HEAPF32[i1 >> 2] = f29;
   HEAPF32[i1 + 4 >> 2] = f28;
   HEAPF32[i1 + 8 >> 2] = f27;
   HEAP32[i1 + 12 >> 2] = i26;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i19 | 0)) break; else {
    i1 = i1 + i5 | 0;
    i3 = i3 + i4 | 0;
   }
  }
  i1 = HEAP32[i20 >> 2] | 0;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i25;
  return;
 }
 i2 = HEAP32[i21 + 20 >> 2] | 0;
 if ((i2 | 0) == 4) i2 = 32; else if ((i2 | 0) == 2) i2 = 16; else i2 = (i2 | 0) == 1 ? 4 : 0;
 i20 = i1 + -1 | 0;
 i18 = (HEAP32[i21 + 24 >> 2] | 0) + (Math_imul(i20, i2) | 0) | 0;
 i17 = HEAP32[i21 + 40 >> 2] | 0;
 i16 = (HEAP32[i21 + 32 >> 2] | 0) + (Math_imul(i17, i20) | 0) | 0;
 i19 = HEAP32[i21 + 36 >> 2] | 0;
 i26 = i21 + 44 | 0;
 i20 = Math_imul(HEAP32[i26 >> 2] | 0, i20) | 0;
 _memcpy(i23 | 0, i16 | 0, i17 | 0) | 0;
 __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, HEAP32[i21 + 68 >> 2] | 0, i18, 0);
 f31 = Math_fround(HEAPF32[i23 >> 2]);
 f30 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 i23 = HEAP32[i23 + 12 >> 2] | 0;
 f27 = Math_fround(f31 * Math_fround(HEAPF32[i22 >> 2]));
 f32 = Math_fround(f31 * Math_fround(HEAPF32[i22 + 4 >> 2]));
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i22 + 8 >> 2]));
 f28 = Math_fround(f30 * Math_fround(HEAPF32[i22 + 16 >> 2]));
 f29 = Math_fround(f30 * Math_fround(HEAPF32[i22 + 20 >> 2]));
 f28 = Math_fround(f27 + f28);
 f29 = Math_fround(f32 + f29);
 f30 = Math_fround(f31 + Math_fround(f30 * Math_fround(HEAPF32[i22 + 24 >> 2])));
 f31 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 32 >> 2]));
 f32 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f31 = Math_fround(f28 + f31);
 f32 = Math_fround(f29 + f32);
 f33 = Math_fround(f30 + Math_fround(f33 * Math_fround(HEAPF32[i22 + 40 >> 2])));
 f31 = Math_fround(f31 + Math_fround(HEAPF32[i22 + 48 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i22 + 52 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i22 + 56 >> 2]));
 HEAPF32[i24 >> 2] = f31;
 HEAPF32[i24 + 4 >> 2] = f32;
 HEAPF32[i24 + 8 >> 2] = f33;
 HEAP32[i24 + 12 >> 2] = i23;
 _memcpy(i19 + i20 | 0, i24 | 0, HEAP32[i26 >> 2] | 0) | 0;
 STACKTOP = i25;
 return;
}

function __Z18SkinGenericMathLibILi2ELb0ELb0EEvR12SkinMeshInfo(i21) {
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 96 | 0;
 i23 = i25 + 48 | 0;
 i24 = i25;
 i20 = i21 + 60 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i19 = i1 + -1 | 0;
  i4 = HEAP32[i21 + 40 >> 2] | 0;
  i5 = HEAP32[i21 + 44 >> 2] | 0;
  i6 = HEAP32[i21 + 68 >> 2] | 0;
  i7 = HEAP32[i21 + 24 >> 2] | 0;
  i8 = i22 + 4 | 0;
  i9 = i22 + 8 | 0;
  i10 = i22 + 16 | 0;
  i11 = i22 + 20 | 0;
  i12 = i22 + 24 | 0;
  i13 = i22 + 32 | 0;
  i14 = i22 + 36 | 0;
  i15 = i22 + 40 | 0;
  i16 = i22 + 48 | 0;
  i17 = i22 + 52 | 0;
  i18 = i22 + 56 | 0;
  i1 = HEAP32[i21 + 36 >> 2] | 0;
  i2 = 0;
  i3 = HEAP32[i21 + 32 >> 2] | 0;
  while (1) {
   __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, i6, i7, i2);
   f29 = Math_fround(HEAPF32[i3 >> 2]);
   f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f27 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   i26 = HEAP32[i3 + 12 >> 2] | 0;
   f33 = Math_fround(f29 * Math_fround(HEAPF32[i22 >> 2]));
   f28 = Math_fround(f29 * Math_fround(HEAPF32[i8 >> 2]));
   f29 = Math_fround(f29 * Math_fround(HEAPF32[i9 >> 2]));
   f32 = Math_fround(f30 * Math_fround(HEAPF32[i10 >> 2]));
   f31 = Math_fround(f30 * Math_fround(HEAPF32[i11 >> 2]));
   f32 = Math_fround(f33 + f32);
   f31 = Math_fround(f28 + f31);
   f30 = Math_fround(f29 + Math_fround(f30 * Math_fround(HEAPF32[i12 >> 2])));
   f29 = Math_fround(f27 * Math_fround(HEAPF32[i13 >> 2]));
   f28 = Math_fround(f27 * Math_fround(HEAPF32[i14 >> 2]));
   f29 = Math_fround(f32 + f29);
   f28 = Math_fround(f31 + f28);
   f27 = Math_fround(f30 + Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2])));
   f29 = Math_fround(f29 + Math_fround(HEAPF32[i16 >> 2]));
   f28 = Math_fround(f28 + Math_fround(HEAPF32[i17 >> 2]));
   f27 = Math_fround(f27 + Math_fround(HEAPF32[i18 >> 2]));
   HEAPF32[i1 >> 2] = f29;
   HEAPF32[i1 + 4 >> 2] = f28;
   HEAPF32[i1 + 8 >> 2] = f27;
   HEAP32[i1 + 12 >> 2] = i26;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i19 | 0)) break; else {
    i1 = i1 + i5 | 0;
    i3 = i3 + i4 | 0;
   }
  }
  i1 = HEAP32[i20 >> 2] | 0;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i25;
  return;
 }
 i2 = HEAP32[i21 + 20 >> 2] | 0;
 if ((i2 | 0) == 4) i2 = 32; else if ((i2 | 0) == 2) i2 = 16; else i2 = (i2 | 0) == 1 ? 4 : 0;
 i20 = i1 + -1 | 0;
 i18 = (HEAP32[i21 + 24 >> 2] | 0) + (Math_imul(i20, i2) | 0) | 0;
 i17 = HEAP32[i21 + 40 >> 2] | 0;
 i16 = (HEAP32[i21 + 32 >> 2] | 0) + (Math_imul(i17, i20) | 0) | 0;
 i19 = HEAP32[i21 + 36 >> 2] | 0;
 i26 = i21 + 44 | 0;
 i20 = Math_imul(HEAP32[i26 >> 2] | 0, i20) | 0;
 _memcpy(i23 | 0, i16 | 0, i17 | 0) | 0;
 __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, HEAP32[i21 + 68 >> 2] | 0, i18, 0);
 f31 = Math_fround(HEAPF32[i23 >> 2]);
 f30 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f33 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 i23 = HEAP32[i23 + 12 >> 2] | 0;
 f27 = Math_fround(f31 * Math_fround(HEAPF32[i22 >> 2]));
 f32 = Math_fround(f31 * Math_fround(HEAPF32[i22 + 4 >> 2]));
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i22 + 8 >> 2]));
 f28 = Math_fround(f30 * Math_fround(HEAPF32[i22 + 16 >> 2]));
 f29 = Math_fround(f30 * Math_fround(HEAPF32[i22 + 20 >> 2]));
 f28 = Math_fround(f27 + f28);
 f29 = Math_fround(f32 + f29);
 f30 = Math_fround(f31 + Math_fround(f30 * Math_fround(HEAPF32[i22 + 24 >> 2])));
 f31 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 32 >> 2]));
 f32 = Math_fround(f33 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f31 = Math_fround(f28 + f31);
 f32 = Math_fround(f29 + f32);
 f33 = Math_fround(f30 + Math_fround(f33 * Math_fround(HEAPF32[i22 + 40 >> 2])));
 f31 = Math_fround(f31 + Math_fround(HEAPF32[i22 + 48 >> 2]));
 f32 = Math_fround(f32 + Math_fround(HEAPF32[i22 + 52 >> 2]));
 f33 = Math_fround(f33 + Math_fround(HEAPF32[i22 + 56 >> 2]));
 HEAPF32[i24 >> 2] = f31;
 HEAPF32[i24 + 4 >> 2] = f32;
 HEAPF32[i24 + 8 >> 2] = f33;
 HEAP32[i24 + 12 >> 2] = i23;
 _memcpy(i19 + i20 | 0, i24 | 0, HEAP32[i26 >> 2] | 0) | 0;
 STACKTOP = i25;
 return;
}

function __ZN5physx17ConvexMeshBuilder22computeInternalObjectsEv(i17) {
 i17 = i17 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20;
 i18 = HEAP32[i17 + 136 >> 2] | 0;
 i8 = HEAP32[i17 + 132 >> 2] | 0;
 i4 = i17 + 64 | 0;
 HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i16 = HEAP8[i17 + 55 >> 0] | 0;
 if (!(i16 << 24 >> 24)) f15 = Math_fround(3402823469999999843913219.0e14); else {
  f9 = Math_fround(HEAPF32[i17 + 40 >> 2]);
  f5 = Math_fround(HEAPF32[i17 + 44 >> 2]);
  f7 = Math_fround(HEAPF32[i17 + 48 >> 2]);
  i2 = i16 & 255;
  f3 = Math_fround(3402823469999999843913219.0e14);
  i6 = 0;
  while (1) {
   f1 = Math_fround(f9 * Math_fround(HEAPF32[i18 + (i6 * 20 | 0) >> 2]));
   f1 = Math_fround(f1 + Math_fround(f5 * Math_fround(HEAPF32[i18 + (i6 * 20 | 0) + 4 >> 2])));
   f1 = Math_fround(f1 + Math_fround(f7 * Math_fround(HEAPF32[i18 + (i6 * 20 | 0) + 8 >> 2])));
   f1 = Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i18 + (i6 * 20 | 0) + 12 >> 2]) + f1)));
   if (f1 < f3) HEAPF32[i4 >> 2] = f1; else f1 = f3;
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i2 >>> 0) {
    f15 = f1;
    break;
   } else f3 = f1;
  }
 }
 i14 = HEAP8[i17 + 54 >> 0] | 0;
 i2 = i14 & 255;
 if (!(i14 << 24 >> 24)) {
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
  f1 = Math_fround(3402823469999999843913219.0e14);
 } else {
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
  f1 = Math_fround(3402823469999999843913219.0e14);
  i4 = 0;
  do {
   f21 = Math_fround(HEAPF32[i8 + (i4 * 12 | 0) >> 2]);
   f5 = f21 < f5 ? f21 : f5;
   f10 = f21 > f10 ? f21 : f10;
   f21 = Math_fround(HEAPF32[i8 + (i4 * 12 | 0) + 4 >> 2]);
   f3 = f21 < f3 ? f21 : f3;
   f9 = f21 > f9 ? f21 : f9;
   f21 = Math_fround(HEAPF32[i8 + (i4 * 12 | 0) + 8 >> 2]);
   f1 = f21 < f1 ? f21 : f1;
   f7 = f21 > f7 ? f21 : f7;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 f21 = Math_fround(f10 - f5);
 f3 = Math_fround(f9 - f3);
 f1 = Math_fround(f7 - f1);
 HEAPF32[i12 >> 2] = f21;
 HEAPF32[i12 + 4 >> 2] = f3;
 HEAPF32[i12 + 8 >> 2] = f1;
 f5 = Math_fround(f15 / Math_fround(1.73205078));
 i11 = f3 > f21 & 1;
 i4 = f1 > Math_fround(HEAPF32[i12 + (i11 << 2) >> 2]);
 i11 = i4 ? 2 : i11;
 f1 = Math_fround(Math_fround(HEAPF32[i12 + (i11 << 2) >> 2]) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f1 - f5) * Math_fround(.0009765625));
 i4 = i17 + 76 | 0;
 HEAPF32[i4 >> 2] = f5;
 i6 = i17 + 72 | 0;
 HEAPF32[i6 >> 2] = f5;
 i13 = i17 + 68 | 0;
 HEAPF32[i13 >> 2] = f5;
 i8 = i17 + 68 + (i11 << 2) | 0;
 HEAPF32[i8 >> 2] = f1;
 i14 = i17 + 40 | 0;
 i12 = i16 & 255;
 i2 = 0;
 while (1) {
  if (__ZL15TestContainmentRKN5physx6PxVec3EPKfjPKNS_2Gu15HullPolygonDataE(i14, i13, i12, i18) | 0) break;
  f1 = Math_fround(f1 - f3);
  HEAPF32[i8 >> 2] = f1;
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= 1024) {
   i19 = 11;
   break;
  }
 }
 if ((i19 | 0) == 11) {
  HEAPF32[i4 >> 2] = f5;
  HEAPF32[i6 >> 2] = f5;
  HEAPF32[i13 >> 2] = f5;
  STACKTOP = i20;
  return;
 }
 f5 = Math_fround(Math_fround(f15 - f5) * Math_fround(.0009765625));
 i6 = 1 << i11 & 3;
 i8 = i17 + 68 + (i6 << 2) | 0;
 i6 = i17 + 68 + ((1 << i6 & 3) << 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = 0;
 while (1) {
  f1 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i8 >> 2] = Math_fround(f5 + f1);
  f3 = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i6 >> 2] = f3;
  i4 = i4 + 1 | 0;
  if (!(__ZL15TestContainmentRKN5physx6PxVec3EPKfjPKNS_2Gu15HullPolygonDataE(i14, i13, i12, i18) | 0)) break;
  if (i4 >>> 0 >= 1024) {
   i19 = 16;
   break;
  } else i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if ((i19 | 0) == 16) {
  STACKTOP = i20;
  return;
 }
 HEAPF32[i8 >> 2] = f1;
 HEAP32[i6 >> 2] = i2;
 STACKTOP = i20;
 return;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEjRKS1_(i14, i13, i18) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20;
 i16 = i14 + 8 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i19 = i14 + 4 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (((i2 - i1 | 0) / 52 | 0) >>> 0 >= i13 >>> 0) {
  i3 = i18 + 8 | 0;
  i4 = i18 + 12 | 0;
  i5 = i18 + 16 | 0;
  i6 = i18 + 20 | 0;
  i7 = i18 + 24 | 0;
  i8 = i18 + 28 | 0;
  i9 = i18 + 32 | 0;
  i2 = i13;
  do {
   i15 = i18;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i1;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i8 >> 2];
   i17 = i1 + 32 | 0;
   HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i17 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   i1 = (HEAP32[i19 >> 2] | 0) + 52 | 0;
   HEAP32[i19 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i20;
  return;
 }
 i17 = i14 + 12 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i4 = ((i1 - i3 | 0) / 52 | 0) + i13 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i19 >> 2] | 0;
 }
 i12 = (i2 - i3 | 0) / 52 | 0;
 i5 = i12 << 1;
 i5 = i12 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i17 >> 2] | 0;
  HEAP32[i15 >> 2] = 16;
  HEAP32[i15 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 52 | 0, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i6 + (((i1 - i3 | 0) / 52 | 0) * 52 | 0) | 0;
 i2 = i4;
 i5 = i6 + (i5 * 52 | 0) | 0;
 i6 = i18 + 8 | 0;
 i7 = i18 + 12 | 0;
 i8 = i18 + 16 | 0;
 i9 = i18 + 20 | 0;
 i10 = i18 + 24 | 0;
 i11 = i18 + 28 | 0;
 i12 = i18 + 32 | 0;
 i1 = i13;
 i13 = i2;
 i3 = i4;
 do {
  i23 = i18;
  i22 = HEAP32[i23 + 4 >> 2] | 0;
  i21 = i3;
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = i22;
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i11 >> 2];
  i21 = i3 + 32 | 0;
  HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i21 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  i3 = i13 + 52 | 0;
  i13 = i3;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  do {
   i22 = i3;
   i3 = i3 + -52 | 0;
   i18 = i3;
   i21 = HEAP32[i18 + 4 >> 2] | 0;
   i23 = i4 + -52 | 0;
   HEAP32[i23 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i23 + 4 >> 2] = i21;
   HEAP32[i4 + -44 >> 2] = HEAP32[i22 + -44 >> 2];
   HEAP32[i4 + -40 >> 2] = HEAP32[i22 + -40 >> 2];
   HEAP32[i4 + -36 >> 2] = HEAP32[i22 + -36 >> 2];
   HEAP32[i4 + -32 >> 2] = HEAP32[i22 + -32 >> 2];
   HEAP32[i4 + -28 >> 2] = HEAP32[i22 + -28 >> 2];
   HEAP32[i4 + -24 >> 2] = HEAP32[i22 + -24 >> 2];
   i23 = i4 + -20 | 0;
   i22 = i22 + -20 | 0;
   HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
   HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
   HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
   HEAP32[i23 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
   i4 = i2 + -52 | 0;
   i2 = i4;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i19 >> 2] = i13;
 HEAP32[i16 >> 2] = i5;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i23 = HEAP32[i17 >> 2] | 0;
 HEAP32[i15 >> 2] = 16;
 HEAP32[i15 + 4 >> 2] = i23;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 STACKTOP = i20;
 return;
}

function __ZNK5physx2Gu4BoxV8isInsideERKS1_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 f3 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(-f23);
 f20 = Math_fround(-f20);
 f8 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(0.0)) + Math_fround(f11 * Math_fround(0.0))) + Math_fround(f15 * Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(f11 * f20)) + Math_fround(f15 * f8)));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * Math_fround(0.0)) + Math_fround(f9 * Math_fround(0.0))) + Math_fround(f12 * Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(f14 * f23) + Math_fround(f9 * f20)) + Math_fround(f12 * f8)));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * Math_fround(0.0)) + Math_fround(f10 * Math_fround(0.0))) + Math_fround(f25 * Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(f18 * f23) + Math_fround(f10 * f20)) + Math_fround(f25 * f8)));
 f20 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 100 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 f26 = Math_fround(Math_fround(Math_fround(f3 * f20) + Math_fround(f11 * f23)) + Math_fround(f15 * f22));
 f24 = Math_fround(Math_fround(Math_fround(f14 * f20) + Math_fround(f9 * f23)) + Math_fround(f12 * f22));
 f22 = Math_fround(Math_fround(Math_fround(f18 * f20) + Math_fround(f10 * f23)) + Math_fround(f25 * f22));
 f23 = Math_fround(HEAPF32[i2 + 112 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 120 >> 2]);
 f21 = Math_fround(Math_fround(Math_fround(f3 * f23) + Math_fround(f11 * f20)) + Math_fround(f15 * f17));
 f19 = Math_fround(Math_fround(Math_fround(f14 * f23) + Math_fround(f9 * f20)) + Math_fround(f12 * f17));
 f17 = Math_fround(Math_fround(Math_fround(f18 * f23) + Math_fround(f10 * f20)) + Math_fround(f25 * f17));
 f20 = Math_fround(HEAPF32[i2 + 128 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 132 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 136 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f3 * f20) + Math_fround(f11 * f23)) + Math_fround(f15 * f5));
 f12 = Math_fround(Math_fround(Math_fround(f14 * f20) + Math_fround(f9 * f23)) + Math_fround(f12 * f5));
 f5 = Math_fround(Math_fround(Math_fround(f18 * f20) + Math_fround(f10 * f23)) + Math_fround(f25 * f5));
 f25 = Math_fround(-f26);
 f23 = Math_fround(-f24);
 f10 = Math_fround(-f22);
 f20 = Math_fround(-f21);
 f18 = Math_fround(-f19);
 f9 = Math_fround(-f17);
 f14 = Math_fround(-f15);
 f11 = Math_fround(-f12);
 f3 = Math_fround(-f5);
 f29 = Math_fround(HEAPF32[i2 + 144 >> 2]);
 f28 = Math_fround(HEAPF32[i2 + 148 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + 152 >> 2]);
 f16 = Math_fround(-f29);
 f13 = Math_fround(-f28);
 f7 = Math_fround(-f27);
 f16 = f29 > f16 ? f29 : f16;
 f13 = f28 > f13 ? f28 : f13;
 f7 = f27 > f7 ? f27 : f7;
 f10 = Math_fround(Math_fround(Math_fround((f26 > f25 ? f26 : f25) * f16) + Math_fround((f24 > f23 ? f24 : f23) * f13)) + Math_fround((f22 > f10 ? f22 : f10) * f7));
 f9 = Math_fround(Math_fround(Math_fround((f21 > f20 ? f21 : f20) * f16) + Math_fround((f19 > f18 ? f19 : f18) * f13)) + Math_fround((f17 > f9 ? f17 : f9) * f7));
 f7 = Math_fround(Math_fround(Math_fround(f16 * (f15 > f14 ? f15 : f14)) + Math_fround(f13 * (f12 > f11 ? f12 : f11))) + Math_fround((f5 > f3 ? f5 : f3) * f7));
 f3 = Math_fround(HEAPF32[i1 + 144 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 148 >> 2]);
 f3 = Math_fround(f10 - f3);
 f5 = Math_fround(f9 - f5);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 + 152 >> 2]));
 return (f7 > f8 | (f5 > f6 | f3 > f4)) & (f8 > Math_fround(-f7) | (f6 > Math_fround(-f5) | f4 > Math_fround(-f3))) & 1 ^ 1 | 0;
}

function __ZN20ArchiveStorageReaderD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP32[i8 >> 2] = gb + 70808 + 8;
 i1 = i8 + 180 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 2364 | 0;
 i2 = i8 + 2376 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i8, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = i8 + 2392 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 2396 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 2400 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 2404 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 2408 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i8 + 1248 | 0;
 __ZN12FileAccessor5CloseEv(i2) | 0;
 if ((HEAP32[i8 + 2380 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i8 + 2368 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i8 + 2344 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 2356 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 __ZN12FileAccessorD2Ev(i2);
 __ZN13FileEntryDataD2Ev(i8 + 188 | 0);
 i1 = i8 + 156 | 0;
 if ((HEAP32[i8 + 172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 160 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 136 | 0;
 if ((HEAP32[i8 + 152 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 140 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i8 + 120 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i8 + 124 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i9 + 4 | 0;
   do {
    i3 = i2 + -40 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i9 >> 2] = 54;
     HEAP32[i7 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 132 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 104 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 108 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  i7 = HEAP32[i8 + 116 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i2 = i8 + 8 | 0;
 i1 = i8 + 44 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 56 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i1 = i8 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 40 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i9 >> 2] = 54;
 HEAP32[i9 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 STACKTOP = i10;
 return;
}

function __ZN13RendererScene14RemoveRendererEi(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 if ((i11 | 0) >= 0) {
  i10 = i12 + 72 | 0;
  if ((HEAP32[i10 >> 2] | 0) > (i11 | 0)) {
   i4 = i12 + 60 | 0;
   i9 = HEAP32[i4 >> 2] | 0;
   i2 = i9 + (i11 * 24 | 0) | 0;
   i13 = HEAP32[i2 >> 2] | 0;
   if (HEAP32[i12 + 148 >> 2] | 0) {
    i2 = i12 + 40 | 0;
    i3 = i12 + 52 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = i12 + 56 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    i8 = i7 & 2147483647;
    do if (i5 >>> 0 > i8 >>> 0) {
     i1 = i7 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
      HEAP32[i6 >> 2] = i1;
      HEAP32[i2 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i3 >> 2] = i5;
    HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
    i12 = i9 + (i11 * 24 | 0) + 20 | 0;
    HEAP8[i12 >> 0] = HEAP8[i12 >> 0] | 4;
    return i13 | 0;
   }
   i1 = i12 + 144 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else {
    i8 = __Z9GetIUmbrav() | 0;
    i1 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0) | 0;
   }
   if ((i1 | 0) > (i11 | 0)) {
    HEAP8[(HEAP32[i12 + 100 >> 2] | 0) + i11 >> 0] = 0;
    HEAP32[i2 >> 2] = 0;
    i12 = i9 + (i11 * 24 | 0) + 20 | 0;
    HEAP8[i12 >> 0] = HEAP8[i12 >> 0] & -3;
    return i13 | 0;
   }
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = i1 + -1 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = i2 + (i3 * 24 | 0) | 0;
   if ((i3 | 0) != (i11 | 0)) if (HEAP32[i9 >> 2] | 0) {
    i6 = i12 + 80 | 0;
    i5 = (HEAP32[i6 >> 2] | 0) + (i3 * 24 | 0) | 0;
    i8 = i12 + 100 | 0;
    i7 = HEAP8[(HEAP32[i8 >> 2] | 0) + i3 >> 0] | 0;
    i4 = i2 + (i11 * 24 | 0) | 0;
    HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
    HEAP8[i4 + 20 >> 0] = HEAP8[i9 + 20 >> 0] | 0;
    i6 = (HEAP32[i6 >> 2] | 0) + (i11 * 24 | 0) | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP8[(HEAP32[i8 >> 2] | 0) + i11 >> 0] = i7;
    if (HEAP8[i2 + (i3 * 24 | 0) + 20 >> 0] & 2) {
     i2 = i12 + 120 | 0;
     i3 = i12 + 132 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = i12 + 136 | 0;
     i7 = HEAP32[i6 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i5 >>> 0 > i8 >>> 0) {
      i1 = i7 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i6 >> 2] = i1;
       HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i12 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
       HEAP32[i6 >> 2] = i1;
       HEAP32[i2 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i3 >> 2] = i5;
     HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
    }
    i1 = HEAP32[i9 >> 2] | 0;
    __ZN8Renderer23NotifySceneHandleChangeEi((i1 | 0) == 0 ? 0 : i1 + -32 | 0, i11);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = i1 + -1;
   i11 = i12 + 92 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   i12 = i12 + 112 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   return i13 | 0;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 383143 | 0, 0, gb + 383163 | 0, 292, 1, 0, 0, 0);
 i13 = 0;
 return i13 | 0;
}

function runPostSets165() {
 HEAP32[gb + 146276 >> 2] = (HEAP32[gb + 146276 >> 2] | 0) + (gb + 765877 | 0);
 HEAP32[gb + 146280 >> 2] = (HEAP32[gb + 146280 >> 2] | 0) + (gb + 766633 | 0);
 HEAP32[gb + 146284 >> 2] = (HEAP32[gb + 146284 >> 2] | 0) + (gb + 765943 | 0);
 HEAP32[gb + 146288 >> 2] = (HEAP32[gb + 146288 >> 2] | 0) + (gb + 766667 | 0);
 HEAP32[gb + 146292 >> 2] = (HEAP32[gb + 146292 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 146296 >> 2] = (HEAP32[gb + 146296 >> 2] | 0) + (gb + 763448 | 0);
 HEAP32[gb + 146300 >> 2] = (HEAP32[gb + 146300 >> 2] | 0) + (gb + 1087441 | 0);
 HEAP32[gb + 146312 >> 2] = fb + 1922;
 HEAP32[gb + 146316 >> 2] = fb + 1923;
 HEAP32[gb + 146320 >> 2] = fb + 1924;
 HEAP32[gb + 146332 >> 2] = fb + 1925;
 HEAP32[gb + 146336 >> 2] = fb + 1923;
 HEAP32[gb + 146340 >> 2] = fb + 1926;
 HEAP32[gb + 146344 >> 2] = fb + 970;
 HEAP32[gb + 146352 >> 2] = fb + 971;
 HEAP32[gb + 146356 >> 2] = fb + 972;
 HEAP32[gb + 146376 >> 2] = fb + 1927;
 HEAP32[gb + 146380 >> 2] = fb + 1928;
 HEAP32[gb + 146384 >> 2] = fb + 1929;
 HEAP32[gb + 146388 >> 2] = fb + 1374;
 HEAP32[gb + 146392 >> 2] = fb + 1375;
 HEAP32[gb + 146396 >> 2] = fb + 1376;
 HEAP32[gb + 146400 >> 2] = fb + 1377;
 HEAP32[gb + 146404 >> 2] = fb + 973;
 HEAP32[gb + 146408 >> 2] = fb + 974;
 HEAP32[gb + 146412 >> 2] = fb + 975;
 HEAP32[gb + 146416 >> 2] = fb + 365;
 HEAP32[gb + 146420 >> 2] = fb + 1378;
 HEAP32[gb + 146424 >> 2] = fb + 366;
 HEAP32[gb + 146428 >> 2] = fb + 367;
 HEAP32[gb + 146432 >> 2] = fb + 976;
 HEAP32[gb + 146436 >> 2] = fb + 977;
 HEAP32[gb + 146440 >> 2] = fb + 214;
 HEAP32[gb + 146444 >> 2] = fb + 53;
 HEAP32[gb + 146448 >> 2] = fb + 1379;
 HEAP32[gb + 146460 >> 2] = fb + 1930;
 HEAP32[gb + 146464 >> 2] = fb + 1931;
 HEAP32[gb + 146468 >> 2] = fb + 1380;
 HEAP32[gb + 146472 >> 2] = fb + 1932;
 HEAP32[gb + 146476 >> 2] = fb + 375;
 HEAP32[gb + 146480 >> 2] = fb + 376;
 HEAP32[gb + 146484 >> 2] = fb + 1381;
 HEAP32[gb + 146488 >> 2] = fb + 978;
 HEAP32[gb + 146500 >> 2] = fb + 1933;
 HEAP32[gb + 146504 >> 2] = fb + 1934;
 HEAP32[gb + 146508 >> 2] = fb + 377;
 HEAP32[gb + 146512 >> 2] = fb + 378;
 HEAP32[gb + 146516 >> 2] = fb + 1382;
 HEAP32[gb + 146520 >> 2] = fb + 1935;
 HEAP32[gb + 146532 >> 2] = fb + 1936;
 HEAP32[gb + 146536 >> 2] = fb + 1937;
 HEAP32[gb + 146540 >> 2] = fb + 1383;
 HEAP32[gb + 146544 >> 2] = fb + 1938;
 HEAP32[gb + 146548 >> 2] = fb + 379;
 HEAP32[gb + 146552 >> 2] = fb + 380;
 HEAP32[gb + 146556 >> 2] = fb + 1384;
 HEAP32[gb + 146560 >> 2] = fb + 979;
 HEAP32[gb + 146572 >> 2] = fb + 1939;
 HEAP32[gb + 146576 >> 2] = fb + 1940;
 HEAP32[gb + 146580 >> 2] = fb + 215;
 HEAP32[gb + 146584 >> 2] = fb + 216;
 HEAP32[gb + 146588 >> 2] = fb + 368;
 HEAP32[gb + 146592 >> 2] = fb + 980;
 HEAP32[gb + 146596 >> 2] = fb + 981;
 HEAP32[gb + 146600 >> 2] = fb + 982;
 HEAP32[gb + 146604 >> 2] = fb + 983;
 HEAP32[gb + 146608 >> 2] = fb + 984;
 HEAP32[gb + 146612 >> 2] = fb + 985;
 HEAP32[gb + 146616 >> 2] = fb + 1941;
 HEAP32[gb + 146620 >> 2] = fb + 1942;
 HEAP32[gb + 146624 >> 2] = fb + 1385;
 HEAP32[gb + 146628 >> 2] = fb + 1386;
 HEAP32[gb + 146632 >> 2] = fb + 1387;
 HEAP32[gb + 146636 >> 2] = fb + 369;
 HEAP32[gb + 146640 >> 2] = fb + 1943;
 HEAP32[gb + 146652 >> 2] = fb + 1944;
 HEAP32[gb + 146656 >> 2] = fb + 1945;
 HEAP32[gb + 146660 >> 2] = fb + 370;
 HEAP32[gb + 146664 >> 2] = fb + 109;
 HEAP32[gb + 146668 >> 2] = fb + 66;
 HEAP32[gb + 146672 >> 2] = fb + 110;
 HEAP32[gb + 146676 >> 2] = fb + 67;
 HEAP32[gb + 146680 >> 2] = fb + 371;
 HEAP32[gb + 146684 >> 2] = fb + 1388;
 HEAP32[gb + 146696 >> 2] = fb + 217;
 HEAP32[gb + 146700 >> 2] = fb + 372;
 HEAP32[gb + 146704 >> 2] = fb + 1946;
 HEAP32[gb + 146708 >> 2] = fb + 1947;
 HEAP32[gb + 146712 >> 2] = fb + 1948;
 HEAP32[gb + 146716 >> 2] = (HEAP32[gb + 146716 >> 2] | 0) + (gb + 767358 | 0);
 HEAP32[gb + 146728 >> 2] = (HEAP32[gb + 146728 >> 2] | 0) + (gb + 767352 | 0);
 HEAP32[gb + 146740 >> 2] = (HEAP32[gb + 146740 >> 2] | 0) + (gb + 767417 | 0);
 HEAP32[gb + 146752 >> 2] = (HEAP32[gb + 146752 >> 2] | 0) + (gb + 767422 | 0);
 HEAP32[gb + 146764 >> 2] = (HEAP32[gb + 146764 >> 2] | 0) + (gb + 767429 | 0);
 HEAP32[gb + 146784 >> 2] = fb + 373;
 HEAP32[gb + 146788 >> 2] = fb + 381;
 HEAP32[gb + 146792 >> 2] = fb + 218;
 HEAP32[gb + 146796 >> 2] = fb + 1949;
 HEAP32[gb + 146800 >> 2] = fb + 1950;
 HEAP32[gb + 146812 >> 2] = fb + 374;
 runPostSets166();
}

function __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE(i16, i2) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, f18 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 2224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 96 | 0;
 i13 = i17;
 i11 = HEAP32[i2 + 2116 >> 2] | 0;
 i12 = (i11 | 0) == 0;
 if (i12) {
  i1 = i15 + 2116 | 0;
  HEAP32[i1 >> 2] = 0;
 } else {
  i1 = i11 << 2;
  i3 = 0;
  do {
   _memcpy(i15 + (i3 * 92 | 0) | 0, i2 + (i3 * 92 | 0) | 0, i1 | 0) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i11 | 0));
  i1 = i15 + 2116 | 0;
  HEAP32[i1 >> 2] = i11;
  if (!i12) _memset(i16 | 0, -1, i11 << 2 | 0) | 0;
 }
 i10 = i11 + -1 | 0;
 i3 = 0;
 do {
  f4 = Math_fround(0.0);
  i2 = 0;
  do {
   f5 = Math_fround(Math_abs(Math_fround(HEAPF32[i15 + (i3 * 92 | 0) + (i2 << 2) >> 2])));
   f4 = f5 > f4 ? f5 : f4;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 <= i10 >>> 0);
  HEAPF32[i13 + (i3 << 2) >> 2] = Math_fround(Math_fround(1.0) / f4);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 <= i10 >>> 0);
 i8 = 0;
 i9 = 0;
 while (1) {
  i3 = (i9 | 0) == 0;
  if (i3) {
   f5 = Math_fround(0.0);
   i6 = 0;
   i2 = i8;
   i14 = 19;
  } else {
   i7 = 0;
   do {
    i6 = i15 + (i7 * 92 | 0) + (i9 << 2) | 0;
    f4 = Math_fround(HEAPF32[i6 >> 2]);
    if (i7) {
     i2 = 0;
     do {
      f5 = Math_fround(HEAPF32[i15 + (i7 * 92 | 0) + (i2 << 2) >> 2]);
      f4 = Math_fround(f4 - Math_fround(f5 * Math_fround(HEAPF32[i15 + (i2 * 92 | 0) + (i9 << 2) >> 2])));
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i7 | 0));
    }
    HEAPF32[i6 >> 2] = f4;
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i9 | 0));
   if (i3) {
    f5 = Math_fround(0.0);
    i6 = 0;
    i2 = i8;
    i14 = 19;
   } else {
    f5 = Math_fround(0.0);
    i7 = i9;
    i2 = i8;
    while (1) {
     i6 = i15 + (i7 * 92 | 0) + (i9 << 2) | 0;
     i3 = 0;
     f4 = Math_fround(HEAPF32[i6 >> 2]);
     do {
      f18 = Math_fround(HEAPF32[i15 + (i7 * 92 | 0) + (i3 << 2) >> 2]);
      f4 = Math_fround(f4 - Math_fround(f18 * Math_fround(HEAPF32[i15 + (i3 * 92 | 0) + (i9 << 2) >> 2])));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i9 | 0));
     HEAPF32[i6 >> 2] = f4;
     f4 = Math_fround(Math_fround(HEAPF32[i13 + (i7 << 2) >> 2]) * Math_fround(Math_abs(Math_fround(f4))));
     i3 = !(f4 >= f5);
     i2 = i3 ? i2 : i7;
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 > i10 >>> 0) {
      i6 = i2;
      break;
     } else f5 = i3 ? f5 : f4;
    }
   }
  }
  if ((i14 | 0) == 19) while (1) {
   i14 = 0;
   f4 = Math_fround(HEAPF32[i15 + (i6 * 92 | 0) >> 2]);
   f4 = Math_fround(Math_fround(HEAPF32[i13 + (i6 << 2) >> 2]) * Math_fround(Math_abs(Math_fround(f4))));
   i3 = !(f4 >= f5);
   i2 = i3 ? i2 : i6;
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 > i10 >>> 0) {
    i6 = i2;
    break;
   } else {
    f5 = i3 ? f5 : f4;
    i14 = 19;
   }
  }
  if ((i9 | 0) != (i6 | 0)) {
   if (!i12) {
    i2 = 0;
    do {
     i3 = i15 + (i6 * 92 | 0) + (i2 << 2) | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     i8 = i15 + (i9 * 92 | 0) + (i2 << 2) | 0;
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i8 >> 2] = i7;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i11 | 0));
   }
   HEAP32[i13 + (i6 << 2) >> 2] = HEAP32[i13 + (i9 << 2) >> 2];
  }
  HEAP32[i16 + (i9 << 2) >> 2] = i6;
  i2 = i15 + (i9 * 92 | 0) + (i9 << 2) | 0;
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  if (f4 == Math_fround(0.0)) {
   HEAPF32[i2 >> 2] = Math_fround(9.99999968e-21);
   f4 = Math_fround(9.99999968e-21);
  }
  if ((i9 | 0) == (i10 | 0)) i2 = i9 + 1 | 0; else {
   f4 = Math_fround(Math_fround(1.0) / f4);
   i2 = i9 + 1 | 0;
   if (i2 >>> 0 <= i10 >>> 0) {
    i3 = i2;
    do {
     i8 = i15 + (i3 * 92 | 0) + (i9 << 2) | 0;
     HEAPF32[i8 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i8 >> 2]));
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 <= i10 >>> 0);
   }
  }
  if (i2 >>> 0 > i10 >>> 0) break; else {
   i8 = i6;
   i9 = i2;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i15 = 0;
  i16 = i16 + 2208 | 0;
  HEAP32[i16 >> 2] = i15;
  STACKTOP = i17;
  return;
 }
 i2 = i1 << 2;
 i3 = 0;
 do {
  _memcpy(i16 + 92 + (i3 * 92 | 0) | 0, i15 + (i3 * 92 | 0) | 0, i2 | 0) | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i16 = i16 + 2208 | 0;
 HEAP32[i16 >> 2] = i1;
 STACKTOP = i17;
 return;
}

function __ZN5Light8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZNK5Light16UnshareLightDataEv(i9);
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i6);
 i7 = i9 + 44 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 40 | 0;
 i10 = i6 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 20 | 0, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 44 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = i3 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i5;
 }
 i2 = i1 + 48 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i2 = i1 + 60 | 0;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i5;
 }
 i2 = i1 + 64 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 96 | 0, i6);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_((HEAP32[i7 >> 2] | 0) + 92 | 0, i6);
 i1 = (HEAP32[i7 >> 2] | 0) + 85 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 48 | 0, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 76 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = i3 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i5;
 }
 i2 = i1 + 36 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i3;
  i5 = i3;
 }
 i2 = i1 + 80 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i2, 4);
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i3;
  i5 = i1;
 }
 i1 = i5 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i5 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i9 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEbT0_S5_T_(i7, i6, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 switch (i6 - i7 >> 3 | 0) {
 case 2:
  {
   i1 = i6 + -8 | 0;
   if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i1, i7) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   i6 = i7;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i1;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i8 = i7;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = i4;
   i8 = i1;
   HEAP32[i8 >> 2] = i5;
   HEAP32[i8 + 4 >> 2] = i6;
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i7, i7 + 8 | 0, i6 + -8 | 0, i8) | 0;
   i8 = 1;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 4:
  {
   i2 = i7 + 8 | 0;
   i3 = i7 + 16 | 0;
   i1 = i6 + -8 | 0;
   __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i7, i2, i3, i8) | 0;
   if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i1, i3) | 0)) {
    i8 = 1;
    STACKTOP = i9;
    return i8 | 0;
   }
   i5 = i3;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = i1;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i6 = i3;
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i6 + 4 >> 2] = i10;
   i6 = i1;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i5;
   if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i3, i2) | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i10 = i2;
   i6 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i4 = i3;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i11 + 4 >> 2] = i5;
   i11 = i3;
   HEAP32[i11 >> 2] = i6;
   HEAP32[i11 + 4 >> 2] = i10;
   if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i2, i7) | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i10 = i7;
   i8 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i5 = i2;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = i7;
   HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i11 + 4 >> 2] = i6;
   i11 = i2;
   HEAP32[i11 >> 2] = i8;
   HEAP32[i11 + 4 >> 2] = i10;
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i7, i7 + 8 | 0, i7 + 16 | 0, i7 + 24 | 0, i6 + -8 | 0, i8) | 0;
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 case 1:
 case 0:
  {
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 default:
  {
   i3 = i7 + 16 | 0;
   __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i7, i7 + 8 | 0, i3, i8) | 0;
   i1 = i7 + 24 | 0;
   L3 : do if ((i1 | 0) == (i6 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i1, i3) | 0) {
      i10 = i1;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i4 = i5;
      HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i4 + 4 >> 2] = i11;
      i4 = i1;
      while (1) {
       i12 = i3;
       i10 = HEAP32[i12 + 4 >> 2] | 0;
       i11 = i4;
       HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
       HEAP32[i11 + 4 >> 2] = i10;
       if ((i3 | 0) == (i7 | 0)) break;
       i4 = i3 + -8 | 0;
       if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i5, i4) | 0) {
        i12 = i3;
        i3 = i4;
        i4 = i12;
       } else break;
      }
      i10 = i5;
      i11 = HEAP32[i10 + 4 >> 2] | 0;
      i12 = i3;
      HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i12 + 4 >> 2] = i11;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i6 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i6 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i12 = i1;
      i1 = i3;
      i3 = i12;
     }
    }
   } while (0);
   i12 = i1 | i2;
   STACKTOP = i9;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i17, i7, i1) {
 i17 = i17 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i6 = i16 + 8 | 0;
 i5 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i16;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i11 = i17 + 8 | 0;
  i13 = HEAP32[i11 + 4 >> 2] | 0;
  i14 = i7 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 i14 = i1 + (HEAP32[i5 >> 2] | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i8 = HEAP32[gb + 37300 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i12 = 15; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i12 = 15; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 15) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L17;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN12TreeDatabase11RemoveTreesERK8Vector2ffi(i17, i15, f4, i9) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 f4 = Math_fround(f4);
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20;
 f13 = Math_fround(f4 * f4);
 HEAP32[i18 >> 2] = 0;
 i19 = i18 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 i16 = i17 + 16 | 0;
 i14 = i17 + 20 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i1 = (HEAP32[i14 >> 2] | 0) - i3 | 0;
 i2 = (i1 | 0) / 40 | 0;
 i12 = i18 + 8 | 0;
 L1 : do if (i1) {
  i11 = __Znwj(i1) | 0;
  i5 = i11;
  HEAP32[i18 >> 2] = i5;
  HEAP32[i19 >> 2] = i5;
  HEAP32[i12 >> 2] = i11 + (i2 * 40 | 0);
  i11 = i15 + 4 | 0;
  if ((i9 | 0) == -1) {
   i5 = 0;
   while (1) {
    i1 = i3 + (i5 * 40 | 0) | 0;
    f4 = Math_fround(HEAPF32[i1 >> 2]);
    f7 = Math_fround(f4 - Math_fround(HEAPF32[i15 >> 2]));
    f6 = Math_fround(HEAPF32[i3 + (i5 * 40 | 0) + 8 >> 2]);
    f8 = Math_fround(f6 - Math_fround(HEAPF32[i11 >> 2]));
    do if (Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) > f13) {
     i2 = HEAP32[i19 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) {
      __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i18, i1);
      break;
     } else {
      HEAPF32[i2 >> 2] = f4;
      HEAP32[i2 + 4 >> 2] = HEAP32[i3 + (i5 * 40 | 0) + 4 >> 2];
      HEAPF32[i2 + 8 >> 2] = f6;
      i10 = i2 + 12 | 0;
      i9 = i3 + (i5 * 40 | 0) + 12 | 0;
      HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
      HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
      HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
      HEAP32[i19 >> 2] = i2 + 40;
      break;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i3 = HEAP32[i16 >> 2] | 0;
    i2 = ((HEAP32[i14 >> 2] | 0) - i3 | 0) / 40 | 0;
    if (i5 >>> 0 >= i2 >>> 0) break L1;
   }
  } else i5 = 0;
  do {
   i2 = i3 + (i5 * 40 | 0) | 0;
   f7 = Math_fround(HEAPF32[i2 >> 2]);
   f4 = Math_fround(f7 - Math_fround(HEAPF32[i15 >> 2]));
   f8 = Math_fround(HEAPF32[i3 + (i5 * 40 | 0) + 8 >> 2]);
   f6 = Math_fround(f8 - Math_fround(HEAPF32[i11 >> 2]));
   if ((HEAP32[i3 + (i5 * 40 | 0) + 32 >> 2] | 0) == (i9 | 0)) {
    if (Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) > f13) i10 = 11;
   } else i10 = 11;
   do if ((i10 | 0) == 11) {
    i10 = 0;
    i1 = HEAP32[i19 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
     __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i18, i2);
     break;
    } else {
     HEAPF32[i1 >> 2] = f7;
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 + (i5 * 40 | 0) + 4 >> 2];
     HEAPF32[i1 + 8 >> 2] = f8;
     i2 = i1 + 12 | 0;
     i3 = i3 + (i5 * 40 | 0) + 12 | 0;
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i19 >> 2] = i1 + 40;
     break;
    }
   } while (0);
   i5 = i5 + 1 | 0;
   i3 = HEAP32[i16 >> 2] | 0;
   i2 = ((HEAP32[i14 >> 2] | 0) - i3 | 0) / 40 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 } while (0);
 i5 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i3 = (i5 - i1 | 0) / 40 | 0;
 if ((i2 | 0) == (i3 | 0)) i3 = 0; else {
  if ((i16 | 0) != (i18 | 0)) __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i16, i1, i5);
  __ZN12TreeDatabase13ValidateTreesEv(i17);
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(HEAP32[i17 >> 2] | 0, 2);
  i3 = i2 - i3 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i20;
  return i3 | 0;
 }
 i2 = HEAP32[i19 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i19 >> 2] = i2 + (~(((i2 + -40 - i1 | 0) >>> 0) / 40 | 0) * 40 | 0);
 __ZdlPv(i1);
 STACKTOP = i20;
 return i3 | 0;
}

function __ZN9Texture2D10ReadPixelsEiiiiiiibb(i16, i5, i10, i11, i6, i8, i12, i13, i14, i15) {
 i16 = i16 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i18;
 i17 = i18 + 28 | 0;
 i9 = i18 + 8 | 0;
 if ((i13 | i12 | 0) < 0) if (!i16) i1 = 0; else i7 = 5; else if ((mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 136 >> 2] | 0, i16 | 0) | 0) > (i12 | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0) > (i13 | 0)) {
  if ((i8 | i6 | 0) < 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417096 | 0, 0, gb + 410682 | 0, 1439, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
   STACKTOP = i18;
   return;
  }
  i1 = __Z12GetGfxDevicev() | 0;
  if (!(HEAP8[i1 + 4192 >> 0] | 0)) if (HEAP8[(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, 0) | 0) + 31 >> 0] | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417140 | 0, 0, gb + 410682 | 0, 1445, 1, HEAP32[i16 + 4 >> 2] | 0, 0, 0);
  i1 = HEAP32[i16 + 52 >> 2] | 0;
  if ((i5 | 0) >= 0) {
   i2 = (i1 | 0) == 0;
   if (i2) i3 = 0; else i3 = HEAP32[i1 + 44 >> 2] | 0;
   if ((i3 | 0) > (i5 | 0)) {
    if (i2) {
     i3 = HEAP32[i16 + 92 >> 2] | 0;
     i3 = (i3 | 0) == -1 ? 5 : i3;
    } else i3 = HEAP32[i1 + 36 >> 2] | 0;
    i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
    if (i1 >>> 0 < 9) i1 = 265 >>> (i1 & 511) & 1; else i1 = 0;
    i2 = i3 + -3 | 0;
    if (i2 >>> 0 < 18) {
     if (!((147471 >>> i2 & 1 | 0) != 0 | (i1 | 0) == (i3 | 0))) i7 = 29;
    } else if ((i1 | 0) != (i3 | 0)) i7 = 29;
    if ((i7 | 0) == 29) {
     if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417300 | 0, 0, gb + 410682 | 0, 1458, 1, i1, 0, 0);
     STACKTOP = i18;
     return;
    };
    HEAP32[i17 >> 2] = 0;
    HEAP32[i17 + 4 >> 2] = 0;
    HEAP32[i17 + 8 >> 2] = 0;
    HEAP32[i17 + 12 >> 2] = 0;
    HEAP32[i17 + 16 >> 2] = 0;
    do if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i16, i17, i5, 0) | 0) {
     i4 = (i10 | 0) < 0;
     i2 = (i4 ? i10 : 0) + i6 | 0;
     i3 = (i11 | 0) < 0;
     i1 = (i3 ? i11 : 0) + i8 | 0;
     if ((i2 + i12 | 0) > (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 136 >> 2] | 0, i16 | 0) | 0)) i2 = (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 136 >> 2] | 0, i16 | 0) | 0) - i12 | 0;
     if ((i1 + i13 | 0) > (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0)) i1 = (mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0) | 0) - i13 | 0;
     i8 = __Z12GetGfxDevicev() | 0;
     mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 600 >> 2] | 0, i8 | 0, i17 | 0, (i4 ? 0 : i10) | 0, (i3 ? 0 : i11) | 0, i2 | 0, i1 | 0, i12 | 0, i13 | 0) | 0;
     if (i14) {
      __ZNK14ImageReference9ClipImageEiiii(i9, i17, i12, i13, i2, i1);
      __ZN14ImageReference10FlipImageYEv(i9);
     }
     if (i15) {
      if (!(HEAP32[i16 + 104 >> 2] & 1)) if (!(mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 112 >> 2] | 0, i16 | 0) | 0)) break;
      mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 200 >> 2] | 0, i16 | 0);
     }
    } else {
     if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 934273 | 0, 0, gb + 410682 | 0, 1465, 1, i1, 0, 0);
    } while (0);
    STACKTOP = i18;
    return;
   }
  }
  if (!i1) i1 = -1; else i1 = (HEAP32[i1 + 44 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z6FormatPKcz(i17, gb + 417235 | 0, i4);
  if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 410682 | 0, 1451, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i18;
  return;
 } else i7 = 5; else i7 = 5;
 if ((i7 | 0) == 5) i1 = HEAP32[i16 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417060 | 0, 0, gb + 410682 | 0, 1434, 1, i1, 0, 0);
 STACKTOP = i18;
 return;
}

function __ZN5Light8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
 i7 = i9 + 44 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 40 | 0;
 i10 = i6 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 20 | 0, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 44 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = i3 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i1 + 48 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i1 + 60 | 0;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i1 + 64 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZN14ShadowSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 96 | 0, i6);
 __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_((HEAP32[i7 >> 2] | 0) + 92 | 0, i6);
 i1 = (HEAP32[i7 >> 2] | 0) + 85 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 __ZN4PPtrI5FlareE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 48 | 0, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 76 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = i3 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i1 + 36 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
  i5 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i1 + 80 | 0;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
  i5 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i9 + 52 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  return;
 }
}

function __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN26AnimatorControllerPlayable29CleanupStateMachineBehavioursEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 8 | 0;
 i8 = i13;
 i11 = i10 + 112 | 0;
 i12 = i10 + 124 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i6 = HEAP32[i11 >> 2] | 0;
  do {
   i5 = HEAP32[i6 >> 2] | 0;
   do if (i5 | 0) {
    HEAP32[i8 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 9; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i4 = HEAP32[i7 >> 2] | 0;
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
      i1 = i3;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i9 = 11;
    }
    if ((i9 | 0) == 9) i9 = 11;
    if ((i9 | 0) == 11) {
     i9 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) break;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i8 >> 2] = i5;
    if (!i1) i9 = 18; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 18; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i9 = 20;
     }
    }
    if ((i9 | 0) == 18) i9 = 20;
    if ((i9 | 0) == 20) {
     i9 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
    i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
    if (i1 | 0) if (!(__Z29scripting_class_has_attributeP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 408 >> 2] | 0) | 0)) {
     HEAP32[i8 >> 2] = i5;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i9 = 28; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
       i2 = HEAP32[i7 >> 2] | 0;
       i4 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 28; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i9 = 30;
      }
     }
     if ((i9 | 0) == 28) i9 = 30;
     if ((i9 | 0) == 30) {
      i9 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     }
     __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
    }
   } while (0);
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i12 >> 2] << 2) | 0));
 }
 i1 = i10 + 128 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10 + 116 | 0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIeeEEPeEEvT0_S5_T_(i1, i4, i13) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 var d2 = 0.0, d3 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i4;
  i14 = i4 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i5 = i12 - i11 | 0;
    i6 = i5 >> 3;
    switch (i6 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i5 | 0) < 248) {
     i15 = 11;
     break L1;
    }
    i9 = i1 + (((i6 | 0) / 2 | 0) << 3) | 0;
    if ((i5 | 0) > 7992) {
     i5 = (i6 | 0) / 4 | 0;
     i5 = __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i5 << 3) | 0, i9, i9 + (i5 << 3) | 0, i14, i13) | 0;
    } else i5 = __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i1, i9, i14, i13) | 0;
    d8 = +HEAPF64[i1 >> 3];
    d2 = +HEAPF64[i9 >> 3];
    if (d8 < d2) {
     i6 = i14;
     break;
    } else i6 = i14;
    while (1) {
     i6 = i6 + -8 | 0;
     if ((i1 | 0) == (i6 | 0)) break;
     d3 = +HEAPF64[i6 >> 3];
     if (d3 < d2) {
      i15 = 29;
      break L5;
     }
    }
    i5 = i1 + 8 | 0;
    d3 = +HEAPF64[i14 >> 3];
    if (!(d8 < d3)) {
     while (1) {
      if ((i5 | 0) == (i14 | 0)) break L1;
      d2 = +HEAPF64[i5 >> 3];
      if (d8 < d2) break;
      i5 = i5 + 8 | 0;
     }
     HEAPF64[i5 >> 3] = d3;
     HEAPF64[i14 >> 3] = d2;
     i5 = i5 + 8 | 0;
    }
    if ((i5 | 0) == (i14 | 0)) break L1; else i6 = i14;
    while (1) {
     d8 = +HEAPF64[i1 >> 3];
     while (1) {
      d3 = +HEAPF64[i5 >> 3];
      i7 = i5 + 8 | 0;
      if (d8 < d3) break; else i5 = i7;
     }
     do {
      i6 = i6 + -8 | 0;
      d2 = +HEAPF64[i6 >> 3];
     } while (d8 < d2);
     if (i5 >>> 0 >= i6 >>> 0) {
      i1 = i5;
      continue L5;
     }
     HEAPF64[i5 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i5 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAPF64[i1 >> 3] = d3;
    HEAPF64[i6 >> 3] = d8;
    i5 = i5 + 1 | 0;
   }
   i7 = i1 + 8 | 0;
   L35 : do if (i7 >>> 0 < i6 >>> 0) {
    i10 = i9;
    while (1) {
     d8 = +HEAPF64[i10 >> 3];
     while (1) {
      d3 = +HEAPF64[i7 >> 3];
      i9 = i7 + 8 | 0;
      if (d3 < d8) i7 = i9; else break;
     }
     do {
      i6 = i6 + -8 | 0;
      d2 = +HEAPF64[i6 >> 3];
     } while (!(d2 < d8));
     if (i7 >>> 0 > i6 >>> 0) {
      i6 = i10;
      break L35;
     }
     HEAPF64[i7 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i10 = (i10 | 0) == (i7 | 0) ? i6 : i10;
     i7 = i9;
     i5 = i5 + 1 | 0;
    }
   } else i6 = i9; while (0);
   if ((i7 | 0) != (i6 | 0)) {
    d2 = +HEAPF64[i6 >> 3];
    d3 = +HEAPF64[i7 >> 3];
    if (d2 < d3) {
     HEAPF64[i7 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i5 = i5 + 1 | 0;
    }
   }
   if (!i5) {
    i5 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIeeEEPeEEbT0_S5_T_(i1, i7, i13) | 0;
    i6 = i7 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIeeEEPeEEbT0_S5_T_(i6, i4, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i5) {
     i1 = i6;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIeeEEPeEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 8 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIeeEEPeEEvT0_S5_T_(i7 + 8 | 0, i4, i13);
   i4 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i5) break; else {
    i4 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  d2 = +HEAPF64[i14 >> 3];
  d3 = +HEAPF64[i1 >> 3];
  if (d2 < d3) {
   HEAPF64[i1 >> 3] = d2;
   HEAPF64[i14 >> 3] = d3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIeeEEPeEEvT0_S5_T_(i1, i4, i13);
 return;
}

function __ZNSt3__26__sortIRNS_6__lessIddEEPdEEvT0_S5_T_(i1, i4, i13) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 var d2 = 0.0, d3 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 L1 : while (1) {
  i12 = i4;
  i14 = i4 + -8 | 0;
  while (1) {
   L5 : while (1) {
    i11 = i1;
    i5 = i12 - i11 | 0;
    i6 = i5 >> 3;
    switch (i6 | 0) {
    case 1:
    case 0:
     break L1;
    case 2:
     {
      i15 = 5;
      break L1;
     }
    case 3:
     {
      i15 = 7;
      break L1;
     }
    case 4:
     {
      i15 = 8;
      break L1;
     }
    case 5:
     {
      i15 = 9;
      break L1;
     }
    default:
     {}
    }
    if ((i5 | 0) < 248) {
     i15 = 11;
     break L1;
    }
    i9 = i1 + (((i6 | 0) / 2 | 0) << 3) | 0;
    if ((i5 | 0) > 7992) {
     i5 = (i6 | 0) / 4 | 0;
     i5 = __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_(i1, i1 + (i5 << 3) | 0, i9, i9 + (i5 << 3) | 0, i14, i13) | 0;
    } else i5 = __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i1, i9, i14, i13) | 0;
    d8 = +HEAPF64[i1 >> 3];
    d2 = +HEAPF64[i9 >> 3];
    if (d8 < d2) {
     i6 = i14;
     break;
    } else i6 = i14;
    while (1) {
     i6 = i6 + -8 | 0;
     if ((i1 | 0) == (i6 | 0)) break;
     d3 = +HEAPF64[i6 >> 3];
     if (d3 < d2) {
      i15 = 29;
      break L5;
     }
    }
    i5 = i1 + 8 | 0;
    d3 = +HEAPF64[i14 >> 3];
    if (!(d8 < d3)) {
     while (1) {
      if ((i5 | 0) == (i14 | 0)) break L1;
      d2 = +HEAPF64[i5 >> 3];
      if (d8 < d2) break;
      i5 = i5 + 8 | 0;
     }
     HEAPF64[i5 >> 3] = d3;
     HEAPF64[i14 >> 3] = d2;
     i5 = i5 + 8 | 0;
    }
    if ((i5 | 0) == (i14 | 0)) break L1; else i6 = i14;
    while (1) {
     d8 = +HEAPF64[i1 >> 3];
     while (1) {
      d3 = +HEAPF64[i5 >> 3];
      i7 = i5 + 8 | 0;
      if (d8 < d3) break; else i5 = i7;
     }
     do {
      i6 = i6 + -8 | 0;
      d2 = +HEAPF64[i6 >> 3];
     } while (d8 < d2);
     if (i5 >>> 0 >= i6 >>> 0) {
      i1 = i5;
      continue L5;
     }
     HEAPF64[i5 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i5 = i7;
    }
   }
   if ((i15 | 0) == 29) {
    i15 = 0;
    HEAPF64[i1 >> 3] = d3;
    HEAPF64[i6 >> 3] = d8;
    i5 = i5 + 1 | 0;
   }
   i7 = i1 + 8 | 0;
   L35 : do if (i7 >>> 0 < i6 >>> 0) {
    i10 = i9;
    while (1) {
     d8 = +HEAPF64[i10 >> 3];
     while (1) {
      d3 = +HEAPF64[i7 >> 3];
      i9 = i7 + 8 | 0;
      if (d3 < d8) i7 = i9; else break;
     }
     do {
      i6 = i6 + -8 | 0;
      d2 = +HEAPF64[i6 >> 3];
     } while (!(d2 < d8));
     if (i7 >>> 0 > i6 >>> 0) {
      i6 = i10;
      break L35;
     }
     HEAPF64[i7 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i10 = (i10 | 0) == (i7 | 0) ? i6 : i10;
     i7 = i9;
     i5 = i5 + 1 | 0;
    }
   } else i6 = i9; while (0);
   if ((i7 | 0) != (i6 | 0)) {
    d2 = +HEAPF64[i6 >> 3];
    d3 = +HEAPF64[i7 >> 3];
    if (d2 < d3) {
     HEAPF64[i7 >> 3] = d2;
     HEAPF64[i6 >> 3] = d3;
     i5 = i5 + 1 | 0;
    }
   }
   if (!i5) {
    i5 = __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIddEEPdEEbT0_S5_T_(i1, i7, i13) | 0;
    i6 = i7 + 8 | 0;
    if (__ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIddEEPdEEbT0_S5_T_(i6, i4, i13) | 0) {
     i15 = 45;
     break;
    }
    if (i5) {
     i1 = i6;
     continue;
    }
   }
   i10 = i7;
   if ((i10 - i11 | 0) >= (i12 - i10 | 0)) {
    i15 = 44;
    break;
   }
   __ZNSt3__26__sortIRNS_6__lessIddEEPdEEvT0_S5_T_(i1, i7, i13);
   i1 = i7 + 8 | 0;
  }
  if ((i15 | 0) == 44) {
   i15 = 0;
   __ZNSt3__26__sortIRNS_6__lessIddEEPdEEvT0_S5_T_(i7 + 8 | 0, i4, i13);
   i4 = i7;
   continue;
  } else if ((i15 | 0) == 45) {
   i15 = 0;
   if (i5) break; else {
    i4 = i7;
    continue;
   }
  }
 }
 if ((i15 | 0) == 5) {
  d2 = +HEAPF64[i14 >> 3];
  d3 = +HEAPF64[i1 >> 3];
  if (d2 < d3) {
   HEAPF64[i1 >> 3] = d2;
   HEAPF64[i14 >> 3] = d3;
  }
 } else if ((i15 | 0) == 7) __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i1, i1 + 8 | 0, i14, i13) | 0; else if ((i15 | 0) == 8) __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i14, i13) | 0; else if ((i15 | 0) == 9) __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_(i1, i1 + 8 | 0, i1 + 16 | 0, i1 + 24 | 0, i14, i13) | 0; else if ((i15 | 0) == 11) __ZNSt3__218__insertion_sort_3IRNS_6__lessIddEEPdEEvT0_S5_T_(i1, i4, i13);
 return;
}

function __ZL24PutAdditionalShadowLightRK4AABBRK11ActiveLightRK10Matrix4x4ffR13dynamic_arrayI16ForwardShadowMapLj4EE(i9, i10, i4, f7, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i1 = HEAP32[i8 >> 2] | 0;
 i11 = i8 + 12 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + (i12 * 152 | 0) | 0;
 L1 : do if (i12 | 0) {
  i2 = i1;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i10 | 0)) break;
   i2 = i2 + 152 | 0;
   if ((i2 | 0) == (i3 | 0)) break L1;
  }
  f7 = Math_fround(HEAPF32[i9 >> 2]);
  i6 = i9 + 12 | 0;
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i6 >> 2]));
  i8 = i9 + 4 | 0;
  f16 = Math_fround(HEAPF32[i8 >> 2]);
  i12 = i9 + 16 | 0;
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i12 >> 2]));
  i11 = i9 + 8 | 0;
  f15 = Math_fround(HEAPF32[i11 >> 2]);
  i10 = i9 + 20 | 0;
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i10 >> 2]));
  i3 = i2 + 116 | 0;
  f14 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i2 + 120 | 0;
  f13 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i2 + 124 | 0;
  f17 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i3 >> 2] = f7 < f14 ? f7 : f14;
  HEAPF32[i4 >> 2] = f16 < f13 ? f16 : f13;
  HEAPF32[i5 >> 2] = f15 < f17 ? f15 : f17;
  f17 = Math_fround(HEAPF32[i9 >> 2]);
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i6 >> 2]));
  f15 = Math_fround(HEAPF32[i8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i12 >> 2]));
  f13 = Math_fround(HEAPF32[i11 >> 2]);
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 >> 2]));
  i10 = i2 + 128 | 0;
  f16 = Math_fround(HEAPF32[i10 >> 2]);
  i11 = i2 + 132 | 0;
  f14 = Math_fround(HEAPF32[i11 >> 2]);
  i12 = i2 + 136 | 0;
  f7 = Math_fround(HEAPF32[i12 >> 2]);
  HEAPF32[i10 >> 2] = f16 < f17 ? f17 : f16;
  HEAPF32[i11 >> 2] = f14 < f15 ? f15 : f14;
  HEAPF32[i12 >> 2] = f7 < f13 ? f13 : f7;
  return;
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 if ((i3 | 0) != 1) {
  f17 = Math_fround(HEAPF32[i2 + 264 >> 2]);
  f16 = Math_fround(HEAPF32[i2 + 268 >> 2]);
  f15 = Math_fround(HEAPF32[i2 + 272 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i4 + 8 >> 2]));
  f16 = Math_fround(f17 + Math_fround(f16 * Math_fround(HEAPF32[i4 + 24 >> 2])));
  f15 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i4 + 40 >> 2])));
  f15 = Math_fround(-Math_fround(Math_fround(HEAPF32[i4 + 56 >> 2]) + f15));
  f16 = Math_fround(HEAPF32[i2 + 204 >> 2]);
  f17 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  if (Math_fround(f15 - ((i3 | 0) == 3 ? f16 : f17)) > f7) return;
 }
 i6 = i12 + 1 | 0;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i6 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 152 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 152 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 152 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i6;
 HEAP32[i1 + (i12 * 152 | 0) >> 2] = i10;
 f20 = Math_fround(HEAPF32[i9 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f7 = Math_fround(f20 - f15);
 f19 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f13 = Math_fround(f19 - f16);
 f18 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f14 = Math_fround(f18 - f17);
 f15 = Math_fround(f20 + f15);
 f16 = Math_fround(f19 + f16);
 f17 = Math_fround(f18 + f17);
 HEAPF32[i1 + (i12 * 152 | 0) + 116 >> 2] = f7;
 HEAPF32[i1 + (i12 * 152 | 0) + 120 >> 2] = f13;
 HEAPF32[i1 + (i12 * 152 | 0) + 124 >> 2] = f14;
 HEAPF32[i1 + (i12 * 152 | 0) + 128 >> 2] = f15;
 HEAPF32[i1 + (i12 * 152 | 0) + 132 >> 2] = f16;
 HEAPF32[i1 + (i12 * 152 | 0) + 136 >> 2] = f17;
 HEAP32[i1 + (i12 * 152 | 0) + 4 >> 2] = 0;
 HEAP32[i1 + (i12 * 152 | 0) + 144 >> 2] = 0;
 HEAP32[i1 + (i12 * 152 | 0) + 140 >> 2] = 0;
 HEAP32[i1 + (i12 * 152 | 0) + 48 >> 2] = 0;
 HEAP8[i1 + (i12 * 152 | 0) + 148 >> 0] = 0;
 return;
}

function __ZN14SplatPrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932887 | 0, gb + 1034905 | 0, i1, 0);
 i8 = i10 + 8 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932895 | 0, gb + 1034905 | 0, i8, 0);
 i7 = i10 + 8 | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 8 | 0;
 i9 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932905 | 0, i9, i7, 0);
 i8 = i2 + 20 | 0;
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932914 | 0, i9, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932925 | 0, HEAP32[gb + 37328 >> 2] | 0, i7, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932942 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorI12SkeletonBoneNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 72 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i12 = i1 + 16 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
   HEAP32[i1 + 60 >> 2] = HEAP32[gb + 62512 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
   HEAP32[i1 + 68 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
   i1 = (HEAP32[i11 >> 2] | 0) + 72 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 72 | 0) + i2 | 0;
 if (i5 >>> 0 > 59652323) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 72 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 29826161 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 59652323;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 72 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 72 | 0) * 72 | 0) | 0;
 i8 = i3;
 i4 = i6 + (i5 * 72 | 0) | 0;
 i6 = i8;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i7 = i1 + 16 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
  HEAP32[i1 + 60 >> 2] = HEAP32[gb + 62512 >> 2];
  HEAP32[i1 + 64 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
  HEAP32[i1 + 68 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  i1 = i6 + 72 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i7 = i5;
  i1 = i5;
  i2 = i8;
 } else {
  i2 = i8;
  do {
   i1 = i1 + -72 | 0;
   __ZN12SkeletonBoneC2ERKS_(i3 + -72 | 0, i1);
   i3 = i2 + -72 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i5 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i10 >> 2] = i4;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) {
  i4 = i12 + 4 | 0;
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -72 | 0;
   i3 = i2 + -56 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i2 + -44 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -60 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i6 | 0));
 }
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 24 | 0;
 i4 = i5;
 i7 = i1 + 4 | 0;
 i6 = i2 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i8;
 i6 = i1 + 8 | 0;
 i8 = i2 + 8 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i7;
 i8 = i1 + 9 | 0;
 i7 = i2 + 9 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i7 = i1 + 12 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i4, i7);
 i6 = i2 + 12 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i7, i6);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i6, i4);
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i3);
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i7 = i1 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i4, i7);
 i8 = i2 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i7, i8);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i8, i4);
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i3);
 }
 i3 = i1 + 52 | 0;
 i7 = i2 + 52 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 i7 = i1 + 56 | 0;
 i8 = i2 + 56 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i3;
 i3 = i1 + 60 | 0;
 i6 = i2 + 60 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 f9 = Math_fround((HEAP32[i7 >> 2] | 0) >>> 0);
 HEAP32[i1 + 68 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i1 + 64 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i1 + 72 >> 0] = 0;
 f9 = Math_fround((HEAP32[i8 >> 2] | 0) >>> 0);
 HEAP32[i2 + 68 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 64 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 72 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i5 = i13 + 16 | 0;
 i7 = i12 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i10 + 4;
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i11 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i12, i11, 0);
 i6 = i10 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = i12 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i10 + 8 >> 2] = i1;
 if (!i1) HEAP32[i6 >> 2] = 0; else {
  i4 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i3 = i6;
  i2 = i4 | 0 ? i4 - i3 | 0 : 0;
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i3 | 0, i1 << 4);
 }
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i10 + 20;
 HEAP32[i11 + 4 >> 2] = i10 + 16;
 HEAP32[i11 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i12, i11, 0);
 i5 = i10 + 28 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i10 + 24 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i4 | 0, i1 << 2);
 }
 i5 = i10 + 36 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i10 + 32 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i2 + i4 | 0, i1 << 2);
 }
 i4 = i10 + 44 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i10 + 40 >> 2] = i1;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  STACKTOP = i13;
  return;
 }
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 1) | 0;
 _memset(i3 | 0, 0, i1 | 0) | 0;
 i2 = i4;
 i3 = i3 | 0 ? i3 - i2 | 0 : 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
  STACKTOP = i13;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, i3 + i2 | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 STACKTOP = i13;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 32 | 0;
 i6 = i16 + 28 | 0;
 i15 = i16 + 8 | 0;
 i8 = i16 + 24 | 0;
 i9 = i16 + 20 | 0;
 i1 = i16 + 4 | 0;
 i2 = i16;
 i3 = i16 + 36 | 0;
 i13 = i12 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = ((HEAP32[i13 >> 2] | 0) - i4 | 0) / 20 | 0;
 if (i5 >>> 0 >= i10 >>> 0) {
  if (i5 >>> 0 <= i10 >>> 0) {
   STACKTOP = i16;
   return;
  }
  HEAP32[i1 >> 2] = i4;
  HEAP32[i2 >> 2] = i4 + (i10 * 20 | 0);
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2INS_11__wrap_iterIPS1_EEEET_S9_RKS3_PNS_9enable_ifIXaasr21__is_forward_iteratorIS9_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeE(i15, i6, i7, i3, 0);
  i6 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i12 >> 2] = i6;
  i6 = i15 + 4 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i13 >> 2] = i5;
  i13 = i15 + 8 | 0;
  i5 = i12 + 8 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i14;
  i5 = i1;
  if (i1 | 0) {
   if ((i2 | 0) != (i5 | 0)) {
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = HEAP32[i2 + -12 >> 2] | 0;
     i4 = i3;
     if (i3) {
      i1 = i2 + -8 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i3);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i15 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 8 | 0;
 if ((((HEAP32[i11 >> 2] | 0) - i4 | 0) / 20 | 0 | 0) == (i10 | 0)) {
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE8__appendEj(i12, i10 - i5 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i15 >> 2] = 0;
 i14 = i15 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE7reserveEj(i15, i10);
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i15, i6, i7);
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i1 = (i2 - i3 | 0) / 20 | 0;
 i4 = i2;
 if (i1 >>> 0 < i10 >>> 0) {
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE8__appendEj(i15, i10 - i1 | 0);
  i2 = HEAP32[i14 >> 2] | 0;
 } else if (i1 >>> 0 > i10 >>> 0) {
  i5 = i3 + (i10 * 20 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i14 >> 2] = i1;
    i3 = HEAP32[i2 + -12 >> 2] | 0;
    i4 = i3;
    if (i3) {
     i1 = i2 + -8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i3);
     i1 = HEAP32[i14 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i2 = i1;
  }
 }
 i5 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i12 >> 2] = i5;
 i12 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = i12;
 HEAP32[i13 >> 2] = i2;
 i2 = i15 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i5;
 i5 = i1;
 i2 = i12;
 if (i1 | 0) {
  if ((i2 | 0) != (i5 | 0)) {
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i14 >> 2] = i1;
    i3 = HEAP32[i2 + -12 >> 2] | 0;
    i4 = i3;
    if (i3) {
     i1 = i2 + -8 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i3);
     i1 = HEAP32[i14 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i15 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i11, i3, i7, i8, i4) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i6 = i14 + 16 | 0;
 i2 = i14 + 8 | 0;
 i9 = i14;
 i5 = (i3 | 0) == 4;
 switch (i3 | 0) {
 case 4:
 case 224:
  {
   if (i5) {
    i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(4) | 0;
    if (i1 | 0) if (__ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE(i11, i1) | 0) {
     if (!i4) {
      i13 = 0;
      STACKTOP = i14;
      return i13 | 0;
     }
     HEAP32[i2 >> 2] = __ZN6Object15ClassIDToStringEi(4) | 0;
     __Z6FormatPKcz(i12, gb + 445180 | 0, i2);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i12) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
     i13 = 0;
     STACKTOP = i14;
     return i13 | 0;
    }
   }
   break;
  }
 default:
  {}
 }
 i1 = gb + 63520 | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i3) | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = i15;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 i10 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i10, 0, i12, 0) | 0;
 if (!i10) {
  if (!i4) {
   i15 = 0;
   STACKTOP = i14;
   return i15 | 0;
  }
  HEAP32[i6 >> 2] = __ZN6Object15ClassIDToStringEi(i3) | 0;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z6FormatPKcz(i12, gb + 445235 | 0, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i12) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i15 = 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0);
 __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE(i11, i10);
 switch (i3 | 0) {
 case 4:
 case 224:
  {
   mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0);
   mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0);
   __ZN10GameObject21EnsureUniqueTransformEbb(i11, i5, 1) | 0;
   break;
  }
 default:
  {
   do if ((((HEAP32[i10 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
    i4 = HEAP32[i10 + 4 >> 2] | 0;
    if (!i8) __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i10, i7, 0); else {
     HEAP32[i12 >> 2] = HEAP32[i8 + 4 >> 2];
     __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i10, i12, 0);
    }
    if (!i4) {
     i15 = 0;
     STACKTOP = i14;
     return i15 | 0;
    }
    HEAP32[i9 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 21; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i9);
      i2 = HEAP32[i12 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 21; else if (HEAP32[i1 + 4 >> 2] | 0) break;
    }
    if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
     i15 = 0;
     STACKTOP = i14;
     return i15 | 0;
    }
   } while (0);
   mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0);
   mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0);
  }
 }
 HEAP32[i12 >> 2] = gb + 29020;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = i10;
 __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i11, gb + 1105256 | 0, i12);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, 4);
 i15 = i10;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN4crnd12crn_unpacker22decode_color_endpointsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 16 | 0;
 i13 = i17;
 i14 = i17 + 80 | 0;
 i15 = i17 + 32 | 0;
 i3 = i5 + 88 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i12 = (HEAPU8[i1 + 39 >> 0] | 0) << 8 | (HEAPU8[i1 + 40 >> 0] | 0);
 i11 = i5 + 236 | 0;
 i4 = i5 + 240 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i12 | 0)) {
  if (i2 >>> 0 <= i12 >>> 0) {
   do if ((HEAP32[i5 + 244 >> 2] | 0) >>> 0 < i12 >>> 0) {
    if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i11, i12, (i2 + 1 | 0) == (i12 | 0), 4, 0) | 0) {
     i1 = HEAP32[i4 >> 2] | 0;
     break;
    }
    HEAP8[i5 + 248 >> 0] = 1;
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   } else i1 = i2; while (0);
   _memset((HEAP32[i11 >> 2] | 0) + (i1 << 2) | 0, 0, i12 - i1 << 2 | 0) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i4 >> 2] = i12;
 }
 i10 = i5 + 92 | 0;
 i2 = (HEAP32[i5 + 4 >> 2] | 0) + ((HEAPU8[i1 + 34 >> 0] | 0) << 8 | (HEAPU8[i1 + 33 >> 0] | 0) << 16 | (HEAPU8[i1 + 35 >> 0] | 0)) | 0;
 i1 = (HEAPU8[i1 + 37 >> 0] | 0) << 8 | (HEAPU8[i1 + 36 >> 0] | 0) << 16 | (HEAPU8[i1 + 38 >> 0] | 0);
 if (!i1) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i5 + 96 >> 2] = i2;
 HEAP32[i5 + 104 >> 2] = i1;
 HEAP32[i5 + 100 >> 2] = i2 + i1;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 112 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP8[i15 + 16 >> 0] = 0;
 i9 = i15 + 24 | 0;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i10, i15) | 0) {
  i9 = i15 + 24 | 0;
  if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i10, i9) | 0) if (!i12) i3 = 1; else {
   i5 = 0;
   i6 = 0;
   i7 = 0;
   i8 = 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = 0;
   i4 = 0;
   i1 = 0;
   while (1) {
    i5 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i15) | 0) + i5 & 31;
    i6 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i9) | 0) + i6 & 63;
    i7 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i15) | 0) + i7 & 31;
    i1 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i15) | 0) + i1 | 0;
    i4 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i9) | 0) + i4 & 63;
    i3 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i10, i15) | 0) + i3 & 31;
    HEAP32[i2 >> 2] = i6 << 5 | i5 << 11 | i7 | i1 << 27 | i4 << 21 | i3 << 16;
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i12 | 0)) {
     i3 = 1;
     break;
    } else {
     i2 = i2 + 4 | 0;
     i1 = i1 & 31;
    }
   }
  } else i3 = 0;
 } else i3 = 0;
 i1 = HEAP32[i15 + 44 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i15 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i13 >> 2] = gb + 401209;
   HEAP32[i13 + 4 >> 2] = 2513;
   HEAP32[i13 + 8 >> 2] = gb + 401349;
   _sprintf(i14, gb + 401176 | 0, i13) | 0;
   _puts(i14) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i15 + 32 >> 2] = 0;
  HEAP32[i15 + 36 >> 2] = 0;
 }
 HEAP8[i15 + 40 >> 0] = 0;
 i1 = HEAP32[i15 + 20 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i15 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i16 >> 2] = gb + 401209;
   HEAP32[i16 + 4 >> 2] = 2513;
   HEAP32[i16 + 8 >> 2] = gb + 401349;
   _sprintf(i14, gb + 401176 | 0, i16) | 0;
   _puts(i14) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
 }
 i16 = i3;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN9rapidjson8internal6Grisu2EdPcPiS2_(d1, i11, i12, i13) {
 d1 = +d1;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i6 = HEAP32[tempDoublePtr >> 2] | 0;
 i7 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i5 = _bitshift64Lshr(i6 | 0, i7 | 0, 52) | 0;
 getTempRet0() | 0;
 i5 = i5 & 2047;
 i7 = i7 & 1048575;
 i8 = (i5 | 0) == 0;
 i6 = i8 ? i6 : i6;
 i7 = i8 ? i7 : i7 | 1048576;
 i5 = i8 ? -1074 : i5 + -1075 | 0;
 i8 = _bitshift64Shl(i6 | 0, i7 | 0, 1) | 0;
 i9 = getTempRet0() | 0;
 i2 = i8 | 1;
 i10 = i5 + -1 | 0;
 if (0 == 0 & (i9 & 2097152 | 0) == 0) {
  i4 = i9;
  i3 = i10;
  do {
   i2 = _bitshift64Shl(i2 | 0, i4 | 0, 1) | 0;
   i4 = getTempRet0() | 0;
   i3 = i3 + -1 | 0;
  } while (0 == 0 & (i4 & 2097152 | 0) == 0);
 } else {
  i4 = i9;
  i3 = i10;
 }
 i21 = _bitshift64Shl(i2 | 0, i4 | 0, 10) | 0;
 getTempRet0() | 0;
 i17 = (i6 | 0) == 0 & (i7 | 0) == 1048576;
 i20 = _i64Add(i8 | 0, i9 | 0, -1, -1) | 0;
 i19 = getTempRet0() | 0;
 i17 = _bitshift64Shl((i17 ? -1 : i20) | 0, (i17 ? 4194303 : i19) | 0, (i17 ? i5 + -2 | 0 : i10) + 10 - i3 | 0) | 0;
 i19 = getTempRet0() | 0;
 d1 = +(-51 - i3 | 0) * .30102999566398114 + 347.0;
 i20 = ~~d1;
 i20 = ((+(i20 | 0) != d1 & 1) + i20 >> 3) + 1 | 0;
 HEAP32[i13 >> 2] = 348 - (i20 << 3);
 i8 = gb + 2888 + (i20 << 3) | 0;
 i18 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i20 = HEAP16[gb + 227898 + (i20 << 1) >> 1] | 0;
 i10 = _llvm_ctlz_i64(i6 | 0, i7 | 0, 0) | 0;
 getTempRet0() | 0;
 i24 = _bitshift64Shl(i6 | 0, i7 | 0, i10 | 0) | 0;
 i25 = getTempRet0() | 0;
 i22 = ___muldi3(i8 | 0, 0, i25 | 0, 0) | 0;
 i6 = getTempRet0() | 0;
 i7 = ___muldi3(i8 | 0, 0, i24 | 0, 0) | 0;
 i9 = getTempRet0() | 0;
 i25 = ___muldi3(i18 | 0, 0, i25 | 0, 0) | 0;
 i23 = getTempRet0() | 0;
 ___muldi3(i18 | 0, 0, i24 | 0, 0) | 0;
 i24 = getTempRet0() | 0;
 i25 = _i64Add(i25 | 0, 0, -2147483648, 0) | 0;
 i24 = _i64Add(i25 | 0, getTempRet0() | 0, i24 | 0, 0) | 0;
 _i64Add(i24 | 0, getTempRet0() | 0, i7 | 0, 0) | 0;
 i7 = getTempRet0() | 0;
 i6 = _i64Add(i23 | 0, 0, i22 | 0, i6 | 0) | 0;
 i9 = _i64Add(i6 | 0, getTempRet0() | 0, i9 | 0, 0) | 0;
 i7 = _i64Add(i9 | 0, getTempRet0() | 0, i7 | 0, 0) | 0;
 i9 = getTempRet0() | 0;
 i6 = i14;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i14 + 8 >> 2] = i5 + 64 - i10 + i20;
 i6 = _bitshift64Lshr(i2 | 0, i4 | 0, 22) | 0;
 getTempRet0() | 0;
 i2 = i21 & -1024;
 i5 = ___muldi3(i8 | 0, 0, i6 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 i10 = ___muldi3(i8 | 0, 0, i2 | 0, 0) | 0;
 i9 = getTempRet0() | 0;
 i6 = ___muldi3(i18 | 0, 0, i6 | 0, 0) | 0;
 i7 = getTempRet0() | 0;
 ___muldi3(i18 | 0, 0, i2 | 0, 0) | 0;
 i2 = getTempRet0() | 0;
 i6 = _i64Add(i6 | 0, 0, -2147483648, 0) | 0;
 i2 = _i64Add(i6 | 0, getTempRet0() | 0, i2 | 0, 0) | 0;
 _i64Add(i2 | 0, getTempRet0() | 0, i10 & -1024 | 0, 0) | 0;
 i10 = getTempRet0() | 0;
 i4 = _i64Add(i7 | 0, 0, i5 | 0, i4 | 0) | 0;
 i9 = _i64Add(i4 | 0, getTempRet0() | 0, i9 | 0, 0) | 0;
 i10 = _i64Add(i9 | 0, getTempRet0() | 0, i10 | 0, 0) | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i15 + 8 >> 2] = i3 + 54 + i20;
 i4 = ___muldi3(i8 | 0, 0, i19 | 0, 0) | 0;
 i5 = getTempRet0() | 0;
 i8 = ___muldi3(i8 | 0, 0, i17 | 0, 0) | 0;
 i7 = getTempRet0() | 0;
 i2 = ___muldi3(i18 | 0, 0, i19 | 0, 0) | 0;
 i6 = getTempRet0() | 0;
 ___muldi3(i18 | 0, 0, i17 | 0, 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = _i64Add(i2 | 0, 0, -2147483648, 0) | 0;
 i3 = _i64Add(i2 | 0, getTempRet0() | 0, i3 | 0, 0) | 0;
 _i64Add(i3 | 0, getTempRet0() | 0, i8 | 0, 0) | 0;
 i8 = getTempRet0() | 0;
 i9 = _i64Add(i10 | 0, i9 | 0, -1, -1) | 0;
 i10 = getTempRet0() | 0;
 i3 = i15;
 HEAP32[i3 >> 2] = i9;
 HEAP32[i3 + 4 >> 2] = i10;
 i6 = _i64Subtract(~i4 | 0, ~i5 | 0, i6 | 0, 0) | 0;
 i7 = _i64Subtract(i6 | 0, getTempRet0() | 0, i7 | 0, 0) | 0;
 i8 = _i64Subtract(i7 | 0, getTempRet0() | 0, i8 | 0, 0) | 0;
 i10 = _i64Add(i8 | 0, getTempRet0() | 0, i9 | 0, i10 | 0) | 0;
 __ZN9rapidjson8internal8DigitGenERKNS0_5DiyFpES3_yPcPiS5_(i14, i15, i10, getTempRet0() | 0, i11, i12, i13);
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj(i23, i25, i24, i22, i19) {
 i23 = i23 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 24 | 0;
 i1 = i26 + 12 | 0;
 i2 = i26;
 if (!i22) {
  STACKTOP = i26;
  return;
 }
 i12 = i25 + 4 | 0;
 i13 = i25 + 8 | 0;
 i14 = i25 + 12 | 0;
 i15 = i25 + 16 | 0;
 i16 = i25 + 20 | 0;
 i17 = i25 + 24 | 0;
 i18 = i21 + 4 | 0;
 i3 = i21 + 20 | 0;
 i4 = i21 + 24 | 0;
 i5 = i21 + 40 | 0;
 i6 = i21 + 44 | 0;
 i7 = i21 + 60 | 0;
 i8 = i1 + 4 | 0;
 i9 = i1 + 8 | 0;
 i10 = i2 + 4 | 0;
 i11 = i2 + 8 | 0;
 i20 = 0;
 do {
  i27 = ((i20 | 0) == 0 ? i22 : i20) + -1 | 0;
  f40 = Math_fround(HEAPF32[i24 + (i27 << 4) >> 2]);
  f43 = Math_fround(HEAPF32[i24 + (i27 << 4) + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i24 + (i27 << 4) + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i24 + (i20 << 4) >> 2]);
  f38 = Math_fround(HEAPF32[i24 + (i20 << 4) + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i24 + (i20 << 4) + 8 >> 2]);
  f37 = Math_fround(HEAPF32[i25 >> 2]);
  f35 = Math_fround(HEAPF32[i12 >> 2]);
  f41 = Math_fround(HEAPF32[i13 >> 2]);
  f39 = Math_fround(HEAPF32[i14 >> 2]);
  f30 = Math_fround(HEAPF32[i15 >> 2]);
  f29 = Math_fround(HEAPF32[i16 >> 2]);
  f42 = Math_fround(HEAPF32[i17 >> 2]);
  f28 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
  f44 = Math_fround(Math_fround(Math_fround(f40 * f37) + Math_fround(f43 * f35)) + Math_fround(f31 * f41));
  f33 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f37 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f31 * f35) - Math_fround(f43 * f41))) + Math_fround(f40 * f28))) * Math_fround(2.0)));
  f32 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f35 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f40 * f41) - Math_fround(f31 * f37))) + Math_fround(f43 * f28))) * Math_fround(2.0)));
  f31 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f41 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f43 * f37) - Math_fround(f40 * f35))) + Math_fround(f31 * f28))) * Math_fround(2.0)));
  f40 = Math_fround(Math_fround(Math_fround(f36 * f37) + Math_fround(f38 * f35)) + Math_fround(f34 * f41));
  f30 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f37 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f34 * f35) - Math_fround(f38 * f41))) + Math_fround(f36 * f28))) * Math_fround(2.0)));
  f29 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f35 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f36 * f41) - Math_fround(f34 * f37))) + Math_fround(f38 * f28))) * Math_fround(2.0)));
  f28 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f38 * f37) - Math_fround(f36 * f35))) + Math_fround(f34 * f28))) * Math_fround(2.0)));
  HEAPF32[i21 >> 2] = Math_fround(1.0);
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  i27 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i23, i19) | 0, i21) | 0, 1) | 0;
  HEAPF32[i1 >> 2] = f33;
  HEAPF32[i8 >> 2] = f32;
  HEAPF32[i9 >> 2] = f31;
  i27 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i27, i1) | 0;
  HEAPF32[i2 >> 2] = f30;
  HEAPF32[i10 >> 2] = f29;
  HEAPF32[i11 >> 2] = f28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i27, i2) | 0;
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) != (i22 | 0));
 STACKTOP = i26;
 return;
}

function __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_18PxcAABBDataDynamicEbPNS_11IntegerAABBEj(i21, i13, i16, i15, i20, i19, i1) {
 i21 = i21 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i17 = 0, i18 = 0, i22 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 48 | 0;
 i14 = i18 + 24 | 0;
 i17 = i18;
 i1 = i15 + (HEAP32[i16 + (HEAP32[i21 >> 2] << 2) >> 2] << 4) | 0;
 i4 = i13 & 3 | 0 ? i13 & -4 : i13 + -4 | 0;
 if (!i4) f2 = Math_fround(0.0); else {
  i6 = i12 + 12 | 0;
  i7 = i12 + 4 | 0;
  i8 = i12 + 8 | 0;
  i9 = i6 + 4 | 0;
  i10 = i6 + 8 | 0;
  i11 = 0;
  f2 = Math_fround(0.0);
  do {
   i5 = 0;
   i3 = i1;
   while (1) {
    i22 = i5 + i11 | 0;
    i1 = i15 + (HEAP32[i16 + (HEAP32[i21 + (i22 + 1 << 2) >> 2] << 2) >> 2] << 4) | 0;
    f2 = Math_fround(f2 + Math_fround(__ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i20, i3, i12)));
    i3 = HEAP32[i21 + (i22 << 2) >> 2] | 0;
    i22 = HEAP32[i12 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + -16 & -16;
    i22 = HEAP32[i7 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) + 4 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + -16 & -16;
    i22 = HEAP32[i8 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) + 8 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + -16 & -16;
    i22 = HEAP32[i6 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) + 12 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + 16 & -16 | 1;
    i22 = HEAP32[i9 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) + 16 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + 16 & -16 | 1;
    i22 = HEAP32[i10 >> 2] | 0;
    HEAP32[i19 + (i3 * 24 | 0) + 20 >> 2] = ((i22 | 0) < 0 ? ~i22 : i22 | -2147483648) + 16 & -16 | 1;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == 4) break; else i3 = i1;
   }
   i11 = i11 + 4 | 0;
  } while (i11 >>> 0 < i4 >>> 0);
 }
 i11 = i13 + -1 | 0;
 if (i4 >>> 0 < i11 >>> 0) {
  i6 = i14 + 12 | 0;
  i7 = i14 + 4 | 0;
  i8 = i14 + 8 | 0;
  i9 = i6 + 4 | 0;
  i10 = i6 + 8 | 0;
  i5 = HEAP32[i21 + (i4 << 2) >> 2] | 0;
  i3 = i1;
  while (1) {
   i4 = i4 + 1 | 0;
   i22 = i5;
   i5 = HEAP32[i21 + (i4 << 2) >> 2] | 0;
   i1 = i15 + (HEAP32[i16 + (i5 << 2) >> 2] << 4) | 0;
   f2 = Math_fround(f2 + Math_fround(__ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i20, i3, i14)));
   i13 = HEAP32[i14 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + -16 & -16;
   i13 = HEAP32[i7 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) + 4 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + -16 & -16;
   i13 = HEAP32[i8 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) + 8 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + -16 & -16;
   i13 = HEAP32[i6 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) + 12 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + 16 & -16 | 1;
   i13 = HEAP32[i9 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) + 16 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + 16 & -16 | 1;
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i19 + (i22 * 24 | 0) + 20 >> 2] = ((i13 | 0) < 0 ? ~i13 : i13 | -2147483648) + 16 & -16 | 1;
   if ((i4 | 0) == (i11 | 0)) break; else i3 = i1;
  }
 }
 f2 = Math_fround(f2 + Math_fround(__ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i20, i1, i17)));
 i22 = HEAP32[i21 + (i11 << 2) >> 2] | 0;
 i21 = i17 + 12 | 0;
 i20 = HEAP32[i17 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
 i20 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) + 4 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
 i20 = HEAP32[i17 + 8 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) + 8 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
 i20 = HEAP32[i21 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) + 12 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) + 16 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
 i21 = HEAP32[i21 + 8 >> 2] | 0;
 HEAP32[i19 + (i22 * 24 | 0) + 20 >> 2] = ((i21 | 0) < 0 ? ~i21 : i21 | -2147483648) + 16 & -16 | 1;
 STACKTOP = i18;
 return ~~f2 >>> 0 | 0;
}

function __ZN11AudioSource12ApplyFiltersEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 64 | 0;
 i12 = i17 + 48 | 0;
 i11 = i17 + 32 | 0;
 i8 = i17 + 16 | 0;
 i7 = i17;
 i14 = i17 + 92 | 0;
 i15 = i17 + 80 | 0;
 i10 = i9 + 492 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i15 >> 2] = 0;
 i16 = i15 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb(i9, i15, 1) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i16 >> 2] | 0)) {
  i4 = i9 + 536 | 0;
  i5 = i14 + 11 | 0;
  i6 = i14 + 11 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i4 >> 2] | 0)) {
    i3 = __ZN4FMOD3DSP6removeEv(i2) | 0;
    if (i3 | 0) {
     i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i3) | 0;
     HEAP32[i7 >> 2] = gb + 855390;
     HEAP32[i7 + 4 >> 2] = 1775;
     HEAP32[i7 + 8 >> 2] = gb + 855766;
     HEAP32[i7 + 12 >> 2] = i3;
     __Z6FormatPKcz(i14, gb + 883334 | 0, i7);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    }
    i2 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[i10 >> 2] | 0, i2, 0) | 0;
    if (i2 | 0) {
     i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i2) | 0;
     HEAP32[i8 >> 2] = gb + 855390;
     HEAP32[i8 + 4 >> 2] = 1776;
     HEAP32[i8 + 8 >> 2] = gb + 861950;
     HEAP32[i8 + 12 >> 2] = i3;
     __Z6FormatPKcz(i14, gb + 883334 | 0, i8);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
    }
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i16 >> 2] | 0));
 }
 i2 = i9 + 540 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1 | 0) {
  i1 = __ZN4FMOD3DSP6removeEv(i1) | 0;
  if (i1 | 0) {
   i8 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i11 >> 2] = gb + 855390;
   HEAP32[i11 + 4 >> 2] = 1781;
   HEAP32[i11 + 8 >> 2] = gb + 861977;
   HEAP32[i11 + 12 >> 2] = i8;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  if (!(HEAP8[i9 + 424 >> 0] | 0)) if (HEAP8[i9 + 423 >> 0] | 0) {
   i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] | 0, 0) | 0;
   if (!i1) break;
   i13 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i12 >> 2] = gb + 855390;
   HEAP32[i12 + 4 >> 2] = 1783;
   HEAP32[i12 + 8 >> 2] = gb + 862004;
   HEAP32[i12 + 12 >> 2] = i13;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   break;
  }
  i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[i9 + 488 >> 2] | 0, HEAP32[i2 >> 2] | 0, 0) | 0;
  if (i1 | 0) {
   i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i13 >> 2] = gb + 855390;
   HEAP32[i13 + 4 >> 2] = 1785;
   HEAP32[i13 + 8 >> 2] = gb + 862048;
   HEAP32[i13 + 12 >> 2] = i12;
   __Z6FormatPKcz(i14, gb + 883334 | 0, i13);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
 } while (0);
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i16 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i16 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 STACKTOP = i17;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 4 | 0;
 i6 = i3;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 1);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 464003 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 450814 | 0, 0);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 60 | 0;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450831 | 0, i9, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450844 | 0, i9, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450863 | 0, i9, i1 + 92 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450898 | 0, i9, i1 + 108 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450932 | 0, i9, i1 + 124 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450962 | 0, i9, i1 + 140 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __Z37ReadDirectoryInfo_UnityWebAndUnityRawR12FileAccessorRKN20ArchiveStorageHeader6HeaderERNS1_13DirectoryInfoE(i12, i1, i6) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i13 + 32 | 0;
 i9 = i13 + 28 | 0;
 i10 = i13 + 24 | 0;
 i11 = i13 + 12 | 0;
 i5 = __ZN12FileAccessor4ReadEyPvPy(i12, 4, 0, i1, i8) | 0;
 i7 = i8;
 if (!(i5 & ((HEAP32[i7 >> 2] | 0) == 4 & (HEAP32[i7 + 4 >> 2] | 0) == 0))) {
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = (i1 - i3 | 0) / 40 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i6, i4 - i2 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 } else if (i4 >>> 0 < i2 >>> 0) {
  i4 = i3 + (i4 * 40 | 0) | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i5 = i8 + 4 | 0;
   do {
    i2 = i1 + -40 | 0;
    HEAP32[i7 >> 2] = i2;
    i3 = i1 + -20 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i1 = HEAP32[i1 + -8 >> 2] | 0;
     HEAP32[i8 >> 2] = 54;
     HEAP32[i5 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
     i1 = HEAP32[i7 >> 2] | 0;
    } else i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   i1 = i4;
  }
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i5 = i8 + 11 | 0;
 i6 = i8 + 4 | 0;
 while (1) {
  i1 = i2 + 20 | 0;
  if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i12, i1) | 0)) {
   i1 = 1;
   i4 = 28;
   break;
  }
  i3 = __ZN12FileAccessor4ReadEyPvPy(i12, 4, 0, i9, i8) | 0;
  i4 = i8;
  if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 4 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
   i4 = 26;
   break;
  }
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i3 = __ZN12FileAccessor4ReadEyPvPy(i12, 4, 0, i10, i8) | 0;
  i4 = i8;
  if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 4 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
   i4 = 26;
   break;
  }
  i3 = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = i2 + 8 | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i1, _strlen(i1) | 0);
  __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8, i11);
  i1 = HEAP8[i5 >> 0] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  switch ((i1 << 24 >> 24 < 0 ? i3 : i1 & 255) | 0) {
  case 0:
   {
    i4 = 23;
    break;
   }
  case 6:
   {
    if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, gb + 489832 | 0, 6) | 0)) i4 = 23; else {
     i1 = HEAP8[i5 >> 0] | 0;
     i3 = HEAP32[i6 >> 2] | 0;
     i4 = 21;
    }
    break;
   }
  default:
   i4 = 21;
  }
  do if ((i4 | 0) == 21) {
   i4 = 0;
   if (((i1 << 24 >> 24 < 0 ? i3 : i1 & 255) | 0) == 12) {
    i3 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, gb + 489839 | 0, 12) | 0) == 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    if (i3) {
     i4 = 25;
     break;
    } else {
     i1 = 0;
     break;
    }
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    i1 = 0;
    break;
   }
  } else if ((i4 | 0) == 23) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i4 = 25;
  } while (0);
  if ((i4 | 0) == 25) i1 = 4;
  HEAP32[i2 + 16 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i2 = i2 + 40 | 0;
  if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
   i1 = 0;
   i4 = 28;
   break;
  }
 }
 if ((i4 | 0) == 26) {
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 } else if ((i4 | 0) == 28) {
  STACKTOP = i13;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i8 = __ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i3, i2) | 0;
 i1 = __ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i4, i3) | 0;
 if (!i8) {
  if (!i1) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  };
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i1 = i3 + 16 | 0;
  i8 = i4 + 16 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i4;
  if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i3, i2) | 0)) {
   i8 = 1;
   STACKTOP = i7;
   return i8 | 0;
  };
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i6 = i2 + 16 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i8;
  i8 = 2;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (i1) {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i5 = i2 + 16 | 0;
  i8 = i4 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i6;
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i2 = i2 + 16 | 0;
 i1 = i3 + 16 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i8;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i4, i3) | 0)) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i8 = i4 + 16 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i6;
 i8 = 2;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i24, i1, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, d6 = 0.0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 136 | 0;
 i20 = i23 + 128 | 0;
 i19 = i23;
 i22 = i23 + 144 | 0;
 i15 = i23 + 180 | 0;
 i18 = i23 + 184 | 0;
 i17 = i24 + 8 | 0;
 i13 = i3 + 12 | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i17 >> 2] | 0) | 0;
 i16 = i22 + 20 | 0;
 i8 = i22 + 24 | 0;
 HEAP32[i22 + 28 >> 2] = 0;
 i9 = i22 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i8 >> 2] = i22;
 HEAP32[i9 >> 2] = 5;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i22, i14, i15);
 if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i24 + 4 | 0;
  i12 = i24 + 12 | 0;
  i15 = 0;
  do {
   i1 = i18;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i20 >> 2] = i15;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 32, gb + 832301 | 0, i20) | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i11 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i24 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i24 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i19 >> 2] = i18;
   HEAP8[i10 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i25 = i19;
    i4 = HEAP32[i25 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i7 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i19) | 0;
   f5 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i15 | 0));
   i4 = HEAP32[i11 >> 2] | 0;
   i7 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i24 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   d6 = +f5;
   i1 = i19;
   i2 = i1 + 128 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAPF64[i21 >> 3] = d6;
   __ZN5physx6string9sprintf_sEPcjPKcz(i19, 128, gb + 832323 | 0, i21) | 0;
   if (HEAP8[i19 >> 0] | 0) {
    i25 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_iiii(i25 | 0, i7 | 0, i19 | 0, _strlen(i19) | 0) | 0;
   }
   HEAP8[i19 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i19 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, HEAP32[i7 + 20 >> 2] | 0);
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i2 = HEAP32[i24 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i24 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i15 = i15 + 1 | 0;
  } while ((i15 | 0) != (i14 | 0));
 }
 i25 = HEAP32[i9 >> 2] | 0;
 if (!((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0)) {
  STACKTOP = i23;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i22 | 0) == (i1 | 0)) {
  HEAP8[i16 >> 0] = 0;
  STACKTOP = i23;
  return;
 }
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6removeERNS0_2Sc5SceneERS2_b(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 if (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i4 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i4 + 8 >> 1] & 8) {
  __ZL22addOrRemoveRigidObjectILb0ELb0ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(HEAP32[i2 + 1236 >> 2] | 0, i4);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i2 + 1236 >> 2] | 0;
 do if (!i1) {
  i12 = i14 + 256 | 0;
  i9 = i14 + 260 | 0;
  HEAP32[i14 + 264 >> 2] = 0;
  i10 = i14 + 268 | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP32[i9 >> 2] = i14;
  HEAP32[i10 >> 2] = 64;
  i11 = i13 + 256 | 0;
  HEAP8[i11 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
  __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i2, i4 + 16 | 0, i13, i3);
  i6 = i13 + 260 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i13 + 264 >> 2] | 0;
  if (i8 | 0) {
   i2 = (HEAP32[i4 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
    i3 = i4 + -16 | 0;
    i4 = i4 + -12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i3);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i13 + 268 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i13 | 0) == (i1 | 0)) {
    HEAP8[i11 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
  i15 = HEAP32[i10 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i2, i4 + 16 | 0, i10, i3);
  i6 = i10 + 260 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i10 + 264 >> 2] | 0;
  if (i8 | 0) {
   i2 = (HEAP32[i4 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
    i3 = i4 + -16 | 0;
    i4 = i4 + -12 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i3);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i10 | 0) == (i1 | 0)) {
    HEAP8[i9 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i11, i13) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 i8 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = i3 - i8 | 0;
 i9 = (i6 | 0) / 20 | 0;
 i12 = i10 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = i4;
 if (i9 >>> 0 > ((i1 - i4 | 0) / 20 | 0) >>> 0) {
  if (i4) {
   i5 = i10 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) i1 = i4; else {
    i3 = i1;
    while (1) {
     i1 = i3 + -20 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -16 | 0);
      HEAP32[i1 >> 2] = 0;
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 | 0)) break; else i3 = i1;
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i8 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 73;
   HEAP32[i7 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } else i2 = 0;
  i8 = (i1 - i2 | 0) / 20 | 0;
  i1 = i8 << 1;
  i1 = i8 >>> 0 < 1073741823 ? (i1 >>> 0 < i9 >>> 0 ? i9 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 73;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i10 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i12 >> 2] = i2 + (i1 * 20 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i14;
   return;
  }
  do {
   __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i2, i1);
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 20 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i14;
  return;
 }
 i10 = i10 + 4 | 0;
 i1 = ((HEAP32[i10 >> 2] | 0) - i4 | 0) / 20 | 0;
 i9 = i9 >>> 0 > i1 >>> 0;
 i1 = i9 ? i8 + (i1 * 20 | 0) | 0 : i3;
 if ((i8 | 0) == (i1 | 0)) i3 = i2; else {
  do {
   if ((i8 | 0) != (i2 | 0)) {
    i6 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i8 + 12 >> 2] | 0;
    i7 = i2 + 12 | 0;
    HEAP32[i7 >> 2] = i3;
    i4 = i2 + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i4 >> 2] = i3;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i3, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i2 >> 2] = i3;
     break;
    } else {
     i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = i12;
     i3 = i12;
     break;
    } else i3 = HEAP32[i2 >> 2] | 0; while (0);
    _memcpy(i3 | 0, i6 | 0, HEAP32[i7 >> 2] | 0) | 0;
   }
   i8 = i8 + 20 | 0;
   i2 = i2 + 20 | 0;
  } while ((i8 | 0) != (i1 | 0));
  i3 = i2;
 }
 if (i9) {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   STACKTOP = i14;
   return;
  }
  i3 = HEAP32[i10 >> 2] | 0;
  do {
   __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i3, i1);
   i1 = i1 + 20 | 0;
   i3 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
   HEAP32[i10 >> 2] = i3;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  i2 = i1 + -20 | 0;
  HEAP32[i10 >> 2] = i2;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i14;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 765091;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx22PxSphericalJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 765091;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 765091;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 765058;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx22PxPrismaticJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 765058;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 765058;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZNK5physx29PxSphericalJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 236 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj477ENS_22PxRepXPropertyAccessorILj477ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_(i9, i8);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj478ES3_NS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i6 + 252 | 0, i10 + 1 | 0);
 i5 = i6 + 268 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj479ENS_22PxRepXPropertyAccessorILj479ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 4 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj(i23, i25, i24, i22, i19) {
 i23 = i23 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i26 + 24 | 0;
 i1 = i26 + 12 | 0;
 i2 = i26;
 if (!i22) {
  STACKTOP = i26;
  return;
 }
 i12 = i25 + 4 | 0;
 i13 = i25 + 8 | 0;
 i14 = i25 + 12 | 0;
 i15 = i25 + 16 | 0;
 i16 = i25 + 20 | 0;
 i17 = i25 + 24 | 0;
 i18 = i21 + 4 | 0;
 i3 = i21 + 20 | 0;
 i4 = i21 + 24 | 0;
 i5 = i21 + 40 | 0;
 i6 = i21 + 44 | 0;
 i7 = i21 + 60 | 0;
 i8 = i1 + 4 | 0;
 i9 = i1 + 8 | 0;
 i10 = i2 + 4 | 0;
 i11 = i2 + 8 | 0;
 i20 = 0;
 do {
  i27 = ((i20 | 0) == 0 ? i22 : i20) + -1 | 0;
  f40 = Math_fround(HEAPF32[i24 + (i27 << 4) >> 2]);
  f43 = Math_fround(HEAPF32[i24 + (i27 << 4) + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i24 + (i27 << 4) + 8 >> 2]);
  f36 = Math_fround(HEAPF32[i24 + (i20 << 4) >> 2]);
  f38 = Math_fround(HEAPF32[i24 + (i20 << 4) + 4 >> 2]);
  f34 = Math_fround(HEAPF32[i24 + (i20 << 4) + 8 >> 2]);
  f37 = Math_fround(HEAPF32[i25 >> 2]);
  f35 = Math_fround(HEAPF32[i12 >> 2]);
  f41 = Math_fround(HEAPF32[i13 >> 2]);
  f39 = Math_fround(HEAPF32[i14 >> 2]);
  f30 = Math_fround(HEAPF32[i15 >> 2]);
  f29 = Math_fround(HEAPF32[i16 >> 2]);
  f42 = Math_fround(HEAPF32[i17 >> 2]);
  f28 = Math_fround(Math_fround(f39 * f39) + Math_fround(-.5));
  f44 = Math_fround(Math_fround(Math_fround(f40 * f37) + Math_fround(f43 * f35)) + Math_fround(f31 * f41));
  f33 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f37 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f31 * f35) - Math_fround(f43 * f41))) + Math_fround(f40 * f28))) * Math_fround(2.0)));
  f32 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f35 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f40 * f41) - Math_fround(f31 * f37))) + Math_fround(f43 * f28))) * Math_fround(2.0)));
  f31 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f41 * f44) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f43 * f37) - Math_fround(f40 * f35))) + Math_fround(f31 * f28))) * Math_fround(2.0)));
  f40 = Math_fround(Math_fround(Math_fround(f36 * f37) + Math_fround(f38 * f35)) + Math_fround(f34 * f41));
  f30 = Math_fround(f30 + Math_fround(Math_fround(Math_fround(f37 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f34 * f35) - Math_fround(f38 * f41))) + Math_fround(f36 * f28))) * Math_fround(2.0)));
  f29 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f35 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f36 * f41) - Math_fround(f34 * f37))) + Math_fround(f38 * f28))) * Math_fround(2.0)));
  f28 = Math_fround(f42 + Math_fround(Math_fround(Math_fround(f41 * f40) + Math_fround(Math_fround(f39 * Math_fround(Math_fround(f38 * f37) - Math_fround(f36 * f35))) + Math_fround(f34 * f28))) * Math_fround(2.0)));
  HEAPF32[i21 >> 2] = Math_fround(1.0);
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  i27 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i23, i19) | 0, i21) | 0, 1) | 0;
  HEAPF32[i1 >> 2] = f33;
  HEAPF32[i8 >> 2] = f32;
  HEAPF32[i9 >> 2] = f31;
  i27 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i27, i1) | 0;
  HEAPF32[i2 >> 2] = f30;
  HEAPF32[i10 >> 2] = f29;
  HEAPF32[i11 >> 2] = f28;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i27, i2) | 0;
  i20 = i20 + 1 | 0;
 } while ((i20 | 0) != (i22 | 0));
 STACKTOP = i26;
 return;
}

function __Z12WeldVerticesRK14VertexDataInfoRK13dynamic_arrayIjLj4EEfR18WeldVerticesOutput(i12, i15, f13, i16) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 f13 = Math_fround(f13);
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i21;
 i17 = i21 + 8 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i17 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i17 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i14 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 i1 = HEAP32[i19 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < 9) if ((i1 | 0) > -1) {
  HEAP32[i19 >> 2] = 9;
  i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, 180, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i17 >> 2] = i3;
  i14 = i17;
  i2 = i3;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(180, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i17 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i19 >> 2] = 9;
  HEAP32[i17 >> 2] = i3;
  i14 = i17;
  i2 = i3;
  break;
 } else {
  i14 = i17;
  i2 = 0;
  i3 = 0;
 } while (0);
 i11 = i12 + 84 | 0;
 i10 = 0;
 i1 = i2;
 i5 = i3;
 while (1) {
  if (!(HEAP8[i12 + (i10 << 2) + 3 >> 0] | 0)) {
   i4 = i2;
   i7 = i5;
  } else {
   i8 = HEAP32[i18 >> 2] | 0;
   i9 = i8 + 1 | 0;
   i6 = HEAP32[i19 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i9 >>> 0 > i7 >>> 0) {
    i4 = i6 << 1;
    i4 = (i4 | 0) == 0 ? 1 : i4;
    if (i7 >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i19 >> 2] = i4;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 * 20 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i14 >> 2] = i2;
     i1 = i2;
     i5 = i2;
     break;
    } else {
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 20 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i2 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 20 | 0) | 0;
     HEAP32[i19 >> 2] = i4;
     HEAP32[i14 >> 2] = i2;
     i1 = i2;
     i5 = i2;
     break;
    }
   } while (0);
   HEAP32[i18 >> 2] = i9;
   i4 = HEAP16[i12 + (i10 << 2) + 2 >> 1] | 0;
   HEAP32[i2 + (i8 * 20 | 0) >> 2] = i4 & 255;
   HEAP32[i2 + (i8 * 20 | 0) + 4 >> 2] = (i4 & 65535) >>> 8 & 65535;
   i4 = HEAP16[i12 + (i10 << 2) >> 1] | 0;
   HEAP32[i2 + (i8 * 20 | 0) + 8 >> 2] = (HEAP32[i11 >> 2] | 0) + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i12 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0));
   HEAP32[i2 + (i8 * 20 | 0) + 12 >> 2] = HEAPU8[i12 + 32 + ((i4 & 255) * 12 | 0) + 10 >> 0];
   HEAPF32[i2 + (i8 * 20 | 0) + 16 >> 2] = f13;
   i4 = i2;
   i3 = i2;
   i7 = i5;
  }
  i10 = i10 + 1 | 0;
  if ((i10 | 0) == 8) break; else {
   i5 = i7;
   i2 = i4;
  }
 }
 i12 = HEAP32[i12 + 92 >> 2] | 0;
 HEAP32[i17 + 20 >> 2] = i12;
 if ((i12 | 0) == (HEAP32[i15 + 12 >> 2] | 0)) {
  i5 = HEAP32[i18 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i6 >>> 0 > i4 >>> 0) {
   i2 = i3 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i19 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i7, i2 * 20 | 0, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i14 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 20 | 0, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i14 >> 2] | 0, (HEAP32[i18 >> 2] | 0) * 20 | 0) | 0;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i14 >> 2] = i1;
    break;
   }
  } while (0);
  HEAP32[i18 >> 2] = i6;
  HEAP32[i1 + (i5 * 20 | 0) >> 2] = 3;
  HEAP32[i1 + (i5 * 20 | 0) + 4 >> 2] = 4;
  HEAP32[i1 + (i5 * 20 | 0) + 8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + (i5 * 20 | 0) + 12 >> 2] = 4;
  HEAPF32[i1 + (i5 * 20 | 0) + 16 >> 2] = Math_fround(0.0);
 }
 __Z12WeldVerticesRK17WeldVerticesInputR18WeldVerticesOutput(i17, i16);
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i21;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i20);
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i21;
 return;
}

function __ZN7mecanim5human9HumanPose8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 72 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906072 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i7 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i7, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 899117 | 0, 0);
 i7 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899134 | 0, gb + 906539 | 0, i7, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = 4;
 HEAP32[i6 + 4 >> 2] = i1 + 68;
 i7 = HEAP32[gb + 37256 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899149 | 0, i7, i6, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1065353216;
 HEAP32[i4 + 28 >> 2] = 1065353216;
 HEAP32[i4 + 32 >> 2] = 1065353216;
 HEAP32[i4 + 36 >> 2] = 1065353216;
 i8 = i4 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899270 | 0, i4, 0);
 __ZN7mecanim5human9HumanGoal8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 324 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899161 | 0, gb + 899176 | 0, i8, 0);
 __ZN7mecanim4hand8HandPose8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 460 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899185 | 0, gb + 899176 | 0, i8, 0);
 __ZN7mecanim4hand8HandPose8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = 52;
 HEAP32[i6 + 4 >> 2] = i1 + 596;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899201 | 0, i7, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = 7;
 HEAP32[i6 + 4 >> 2] = i1 + 804;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899212 | 0, i7, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 765075;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx21PxRevoluteJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 765075;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 765075;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 742891;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx21PxDistanceJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 742891;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 742891;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = i1 + 32 | 0;
 if ((HEAP16[(HEAP32[i3 >> 2] | 0) + 18 >> 1] & 255) != 2) {
  i11 = i1 + 44 | 0;
  HEAP8[i11 >> 0] = HEAP8[i11 >> 0] & -17;
  return;
 }
 i11 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0;
 i4 = i11 << 24 >> 24 == 0;
 i10 = i1 + 44 | 0;
 if (i11 << 24 >> 24 == ((HEAPU8[i10 >> 0] | 0) >>> 4 & 1)) return;
 do if (i2) {
  i5 = HEAP32[i3 >> 2] | 0;
  i9 = i5 + 8 | 0;
  i2 = HEAP16[i5 + 18 >> 1] | 0;
  i1 = (i2 & 65535) < 1024 | (i2 & 255) != 2;
  if (i4) {
   if (i1) {
    i6 = 0;
    i8 = 0;
    i1 = i2;
   } else {
    i1 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i1) {
     i6 = 0;
     i8 = 1;
     i1 = i2;
    } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
     i6 = 0;
     i8 = 1;
     i1 = i2;
    } else {
     i7 = HEAP32[i5 + 16 >> 2] | 0;
     i6 = i1 + ((i7 >>> 8 & 255) + (HEAP32[i9 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i8 = HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i1 = i7 >>> 16 & 65535;
    }
   }
   if ((i1 & 65535) < 1024 | (i1 & 255) != 2) i7 = 0; else {
    i2 = HEAP32[i5 + 100 >> 2] | 0;
    i3 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i3) i7 = 0; else if (!(HEAP8[i5 + 19 >> 0] | 0)) i7 = 0; else {
     i1 = HEAP32[i5 + 16 >> 2] | 0;
     i7 = i3 + ((Math_imul(HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i2) | 0) + (HEAP32[i9 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0) + (i1 >>> 8 & 255)) | 0;
     i1 = i1 >>> 16 & 65535;
    }
   }
   if ((i1 & 65535) < 1024 | (i1 & 255) != 2) {
    i1 = 0;
    i5 = 0;
   } else {
    i1 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     i5 = 1;
    } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
     i1 = 0;
     i5 = 1;
    } else {
     i4 = HEAP16[i5 + 16 >> 1] | 0;
     i1 = i1 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i5 = HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   if ((i6 | 0) == (i7 | 0)) break;
   i4 = i1;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] | i2 << 16 & 16711680 | i2 & -16777216;
    i1 = i3 + i8 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  } else {
   if (i1) {
    i6 = 0;
    i8 = 0;
    i1 = i2;
   } else {
    i1 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i1) {
     i6 = 0;
     i8 = 1;
     i1 = i2;
    } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
     i6 = 0;
     i8 = 1;
     i1 = i2;
    } else {
     i7 = HEAP32[i5 + 16 >> 2] | 0;
     i6 = i1 + ((i7 >>> 8 & 255) + (HEAP32[i9 + 32 + ((i7 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i8 = HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
     i1 = i7 >>> 16 & 65535;
    }
   }
   if ((i1 & 65535) < 1024 | (i1 & 255) != 2) i7 = 0; else {
    i2 = HEAP32[i5 + 100 >> 2] | 0;
    i3 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i3) i7 = 0; else if (!(HEAP8[i5 + 19 >> 0] | 0)) i7 = 0; else {
     i1 = HEAP32[i5 + 16 >> 2] | 0;
     i7 = i3 + ((Math_imul(HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i2) | 0) + (HEAP32[i9 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0) + (i1 >>> 8 & 255)) | 0;
     i1 = i1 >>> 16 & 65535;
    }
   }
   if ((i1 & 65535) < 1024 | (i1 & 255) != 2) {
    i1 = 0;
    i5 = 0;
   } else {
    i1 = HEAP32[i5 + 92 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     i5 = 1;
    } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
     i1 = 0;
     i5 = 1;
    } else {
     i4 = HEAP16[i5 + 16 >> 1] | 0;
     i1 = i1 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
     i5 = HEAPU8[i9 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    }
   }
   if ((i6 | 0) == (i7 | 0)) break;
   i4 = i1;
   i3 = i6;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] | i2 << 16 & 16711680 | i2 & -16777216;
    i1 = i3 + i8 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else {
     i4 = i2;
     i3 = i1;
     i1 = i2;
    }
   }
  }
 } while (0);
 HEAP8[i10 >> 0] = HEAP8[i10 >> 0] & -17 | i11 << 4 & 255;
 return;
}

function __ZN5physx17ConvexMeshBuilder14loadConvexHullERKNS_16PxConvexMeshDescE(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 8 | 0;
 i15 = i17;
 i11 = i13 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i1 * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i2 = i12;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   i8 = i2;
   i9 = i3;
   i10 = i8 + 12 | 0;
   do {
    HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
    i8 = i8 + 1 | 0;
    i9 = i9 + 1 | 0;
   } while ((i8 | 0) < (i10 | 0));
   if (!i1) break; else {
    i2 = i2 + 12 | 0;
    i3 = i3 + i4 | 0;
   }
  }
 }
 i5 = i13 + 12 | 0;
 i6 = HEAP32[i13 + 16 >> 2] | 0;
 L6 : do if (!i6) i1 = 0; else {
  i2 = HEAP32[i13 + 20 >> 2] | 0;
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i2 * 12 | 0) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  if (!(HEAP16[i13 + 48 >> 1] & 2)) {
   i5 = HEAP32[i5 >> 2] | 0;
   if (!i2) break; else {
    i4 = i1;
    i3 = i6;
   }
   while (1) {
    i2 = i2 + -1 | 0;
    i8 = i4;
    i9 = i3;
    i10 = i8 + 12 | 0;
    do {
     HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i8 | 0) < (i10 | 0));
    if (!i2) break L6; else {
     i4 = i4 + 12 | 0;
     i3 = i3 + i5 | 0;
    }
   }
  }
  i3 = i1 + (i2 * 3 << 2) | 0;
  if (i1 >>> 0 < i3 >>> 0) {
   i4 = i1;
   i2 = i6;
   while (1) {
    HEAP32[i4 >> 2] = HEAPU16[i2 >> 1];
    HEAP32[i4 + 4 >> 2] = HEAPU16[i2 + 2 >> 1];
    HEAP32[i4 + 8 >> 2] = HEAPU16[i2 + 4 >> 1];
    i4 = i4 + 12 | 0;
    if (i4 >>> 0 >= i3 >>> 0) break; else i2 = i2 + (HEAP32[i5 >> 2] | 0) | 0;
   }
  }
 } while (0);
 i5 = i13 + 36 | 0;
 i3 = HEAP32[i13 + 40 >> 2] | 0;
 L17 : do if (i3) {
  i2 = HEAP32[i13 + 44 >> 2] | 0;
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i2 << 2) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  if (!(HEAP16[i13 + 48 >> 1] & 2)) {
   i5 = HEAP32[i5 >> 2] | 0;
   if (!i2) break; else i4 = i1;
   while (1) {
    i2 = i2 + -1 | 0;
    i10 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    HEAP8[i4 >> 0] = i10;
    HEAP8[i4 + 1 >> 0] = i10 >> 8;
    HEAP8[i4 + 2 >> 0] = i10 >> 16;
    HEAP8[i4 + 3 >> 0] = i10 >> 24;
    if (!i2) break L17; else {
     i4 = i4 + 4 | 0;
     i3 = i3 + i5 | 0;
    }
   }
  }
  i2 = i1 + (i2 << 2) | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i1;
   while (1) {
    HEAP32[i4 >> 2] = HEAPU16[i3 >> 1];
    HEAP32[i4 + 4 >> 2] = HEAPU16[i3 + 2 >> 1];
    HEAP32[i4 + 8 >> 2] = HEAPU16[i3 + 4 >> 1];
    i4 = i4 + 12 | 0;
    if (i4 >>> 0 >= i2 >>> 0) break; else i3 = i3 + (HEAP32[i5 >> 2] | 0) | 0;
   }
  }
 } while (0);
 i4 = HEAP32[i13 + 28 >> 2] | 0;
 i7 = i13 + 32 | 0;
 if (!i4) i2 = 0; else {
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i3 * 20 | 0) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i6 = HEAP32[i13 + 24 >> 2] | 0;
  if (i3) {
   i5 = i2;
   while (1) {
    i3 = i3 + -1 | 0;
    i8 = i5;
    i9 = i4;
    i10 = i8 + 20 | 0;
    do {
     HEAP8[i8 >> 0] = HEAP8[i9 >> 0] | 0;
     i8 = i8 + 1 | 0;
     i9 = i9 + 1 | 0;
    } while ((i8 | 0) < (i10 | 0));
    if (!i3) break; else {
     i5 = i5 + 20 | 0;
     i4 = i4 + i6 | 0;
    }
   }
  }
 }
 if (__ZN5physx17ConvexHullBuilder4InitEjPKNS_6PxVec3EjPKjjPKNS_13PxHullPolygonE(i14 + 132 | 0, HEAP32[i11 >> 2] | 0, i12, HEAP32[i13 + 20 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0, i2) | 0) {
  __ZN5physx17ConvexMeshBuilder15computeMassInfoEv(i14);
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 if (!i2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 32, gb + 726597 | 0, 253, gb + 729832 | 0, i16);
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 32, gb + 726597 | 0, 251, gb + 729775 | 0, i15);
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 return 0;
}

function __ZN21ImposterRenderTexture15UpdateImpostersERK6Camera(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 64 | 0;
 i8 = i11;
 i4 = i10 + 40 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 15) {
  i1 = i10 + 36 | 0;
  if ((HEAP8[i1 >> 0] | 0) == 1) i9 = 0; else {
   HEAP8[i1 >> 0] = 1;
   __ZN6Camera16SetTargetTextureEP13RenderTexture(HEAP32[i10 + 16 >> 2] | 0, HEAP32[i10 + 24 >> 2] | 0);
   i9 = 1;
  }
 } else i9 = 0;
 __ZNK9Transform11GetRotationEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i6, i8, 4);
 do if (!i9) {
  i1 = HEAP32[((HEAP8[i10 + 36 >> 0] | 0) == 0 ? i10 + 20 | 0 : i10 + 24 | 0) >> 2] | 0;
  if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) break;
  f2 = Math_fround(HEAPF32[i10 + 28 >> 2]);
  if (f2 != Math_fround(inf)) {
   f2 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f2);
   f2 = Math_fround(f2 - Math_fround(Math_fround(Math_floor(Math_fround(f2 / Math_fround(6.28318548)))) * Math_fround(6.28318548)));
   i7 = f2 > Math_fround(3.14159274);
   f12 = Math_fround(f2 + Math_fround(-6.28318548));
   if (Math_fround(Math_abs(Math_fround(i7 ? f12 : f2))) < Math_fround(.00174532924)) {
    f2 = Math_fround(HEAPF32[i10 + 32 >> 2]);
    if (f2 != Math_fround(inf)) {
     f12 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f2);
     f12 = Math_fround(f12 - Math_fround(Math_fround(Math_floor(Math_fround(f12 / Math_fround(6.28318548)))) * Math_fround(6.28318548)));
     i7 = f12 > Math_fround(3.14159274);
     f2 = Math_fround(f12 + Math_fround(-6.28318548));
     if (Math_fround(Math_abs(Math_fround(i7 ? f2 : f12))) < Math_fround(.00174532924)) {
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
      i10 = 0;
      STACKTOP = i11;
      return i10 | 0;
     }
    }
   }
  }
 } while (0);
 if (!(HEAP8[(__Z12GetGfxDevicev() | 0) + 4192 >> 0] | 0)) {
  i7 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 496 >> 2] | 0, i7 | 0);
 }
 HEAP32[i10 + 28 >> 2] = HEAP32[i6 >> 2];
 i3 = i6 + 4 | 0;
 HEAP32[i10 + 32 >> 2] = HEAP32[i3 >> 2];
 i5 = i10 + 16 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(57.2957763));
 HEAPF32[i8 >> 2] = Math_fround(f2 * Math_fround(57.2957763));
 HEAPF32[i8 + 4 >> 2] = f12;
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 __ZN9Transform19SetLocalEulerAnglesERK8Vector3fN4math13RotationOrderE(i1, i8, 4);
 __ZNK6Camera22GetCameraToWorldMatrixEv(i8, HEAP32[i5 >> 2] | 0);
 i1 = i10 + 52 | 0;
 i3 = i8;
 i4 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 i7 = __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i6, i8);
 __ZN6Camera13SetClearFlagsEi(HEAP32[i5 >> 2] | 0, 2);
 i6 = __Z16GetRenderManagerv() | 0;
 __ZN13RenderManager16SetCurrentCameraEP6Camera(i6, HEAP32[i5 >> 2] | 0);
 __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(HEAP32[i5 >> 2] | 0, HEAP32[gb + 1166248 >> 2] | 0, 4);
 __ZN6Camera13ClearNoSkyboxEb(HEAP32[i5 >> 2] | 0, 0);
 __ZNK14RenderSettings12SetupAmbientEv(__Z17GetRenderSettingsv() | 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i5 = i6 + 28 | 0;
 i6 = i6 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) {
  i4 = i10 + 4 | 0;
  i3 = 0;
  do {
   __ZN21ImposterRenderTexture14UpdateImposterERK5RectTIfERKN12TreeDatabase9PrototypeE(i10, (HEAP32[i4 >> 2] | 0) + (i3 << 4) | 0, i1 + (i3 * 156 | 0) | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 156 | 0) >>> 0);
 }
 __ZN6Camera15StandaloneSetupER17ShaderPassContext(i7, HEAP32[gb + 1166248 >> 2] | 0);
 i10 = i9;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN12TreeDatabase9Prototype11SetMaterialEiP8Material(i9, i13, i11) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 56 | 0;
 i3 = i17 + 36 | 0;
 i6 = i17 + 32 | 0;
 i1 = i17 + 52 | 0;
 i4 = i17 + 8 | 0;
 i5 = i17 + 48 | 0;
 i7 = i17 + 44 | 0;
 i8 = i17 + 40 | 0;
 i14 = i17 + 28 | 0;
 i15 = i17 + 24 | 0;
 i16 = i17;
 if ((i13 | 0) < 0) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((HEAP32[i9 + 88 >> 2] | 0) <= (i13 | 0)) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 HEAP32[i3 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i3, gb + 1017536 | 0);
 HEAP32[i6 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, gb + 935821 | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 i18 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i11, i12) | 0;
 i10 = i9 + 96 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + (i13 << 4) | 0;
 if (i18) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i4, i11, i12);
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = HEAP32[i4 + 8 >> 2] | 0;
  i18 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + (i13 << 4) + 4 >> 2] = i3;
  HEAP32[i1 + (i13 << 4) + 8 >> 2] = i5;
  HEAP32[i1 + (i13 << 4) + 12 >> 2] = i18;
 } else {
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + (i13 << 4) + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + (i13 << 4) + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + (i13 << 4) + 12 >> 2] = Math_fround(1.0);
 }
 i3 = i9 + 56 | 0;
 HEAPF32[(HEAP32[i3 >> 2] | 0) + (i13 << 2) >> 2] = Math_fround(1.0);
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i11, i12) | 0) {
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  f19 = Math_fround(Math_fround(.5) / Math_fround(__ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE(i11, i12)));
  HEAPF32[(HEAP32[i3 >> 2] | 0) + (i13 << 2) >> 2] = f19;
 }
 i1 = i9 + 76 | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i13 << 2) >> 2] | 0;
 if (i2 | 0) __Z19DestroySingleObjectP6Object(i2);
 i2 = __ZN8Material14CreateMaterialERKS_ib(i11, 61, 0) | 0;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i13 << 2) >> 2] = i2;
 i2 = i9 + 116 | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0;
 if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
 i1 = __ZN8Material14CreateMaterialERKS_ib(i11, 61, 0) | 0;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] = i1;
 i1 = __ZN8Material9GetShaderEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 933861 | 0, 15);
 i1 = __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i12) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 if (!i1) i1 = 0; else {
  __ZN8Material9SetShaderEP6Shader(HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0, i1);
  i18 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  HEAP32[i14 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i14, gb + 1017536 | 0);
  i1 = (HEAP32[i10 >> 2] | 0) + (i13 << 4) | 0;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i18, i12, i1);
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  HEAP32[i15 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i15, gb + 933877 | 0);
  f19 = Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + (i13 << 2) >> 2]);
  HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i12, f19);
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  HEAP32[i16 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i16, gb + 933893 | 0);
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i1, i12, gb + 1162292 | 0);
  i1 = 1;
 }
 i18 = i1;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i14, i1, i7, i8, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i6 = i15 + 8 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = i5;
 HEAP8[i13 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i10 = i13;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
 HEAP32[i6 >> 2] = 426;
 i12 = HEAP32[i14 + 20 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i6 : i12;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i9 = i13 + 4 | 0;
  i10 = i14 + 4 | 0;
  i11 = i14 + 8 | 0;
  i6 = i7 + 12 | 0;
  do {
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if (!i2) i2 = 0; else {
    i4 = i2 + -1 | 0;
    i5 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i10 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i5 + (i4 << 3) >> 2] | 0);
     i2 = HEAP32[i14 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i14 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
   }
   HEAP32[i13 >> 2] = i1;
   HEAP8[i9 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i4 = i13;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i7 + 4 >> 2] = i5;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i13) | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   i2 = mftCall_iii(HEAP32[i6 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
   if (gb + 759891 | 0) {
    i3 = gb + 759891 | 0;
    i4 = gb + 115792 | 0;
    do {
     if ((HEAP32[i4 + 4 >> 2] | 0) == (i2 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, i3 | 0);
     i4 = i4 + 8 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
    } while ((i3 | 0) != 0);
   }
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
     i2 = HEAP32[i10 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
     i2 = HEAP32[i14 >> 2] | 0;
     i1 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    }
    HEAP32[i1 + 8 >> 2] = i2 + -1;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i8 = i8 + 8 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc15ClothFabricCore4loadERKNS_17PxClothFabricDescE(i22, i21) {
 i22 = i22 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i27 + 136 | 0;
 i12 = i27 + 128 | 0;
 i11 = i27 + 120 | 0;
 i10 = i27 + 112 | 0;
 i9 = i27 + 104 | 0;
 i8 = i27 + 96 | 0;
 i7 = i27;
 i23 = i27 + 88 | 0;
 i1 = i27 + 76 | 0;
 i3 = i27 + 72 | 0;
 i24 = i27 + 60 | 0;
 i5 = i27 + 56 | 0;
 i15 = i27 + 48 | 0;
 i16 = i27 + 40 | 0;
 i17 = i27 + 32 | 0;
 i18 = i27 + 24 | 0;
 i19 = i27 + 16 | 0;
 i20 = i27 + 8 | 0;
 i6 = i22 + 8 | 0;
 i4 = i21 + 4 | 0;
 i14 = HEAP32[i4 >> 2] | 0;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i6, i14, i23);
 i23 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i14 = i1 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i26 = i1 + 8 | 0;
 HEAP32[i26 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i1, i23, i3);
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 HEAP32[i24 + 4 >> 2] = 0;
 i23 = i24 + 8 | 0;
 HEAP32[i23 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i24, i3, i5);
 L1 : do if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = i2;
  i25 = 7;
 } else {
  i5 = HEAP32[i21 + 8 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = 0;
  while (1) {
   i1 = HEAP32[i5 + (i3 << 3) >> 2] | 0;
   if ((i1 | 0) == 0 | (i1 | 0) > 4) break;
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
   HEAP32[i2 + (i3 << 2) >> 2] = HEAP32[i5 + (i3 << 3) + 4 >> 2];
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
    i1 = i2;
    i25 = 7;
    break L1;
   }
  }
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 723467 | 0, 211, gb + 723567 | 0, i7);
  i3 = 0;
 } while (0);
 if ((i25 | 0) == 7) {
  i25 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
  i5 = HEAP32[i21 + 12 >> 2] | 0;
  i4 = HEAP32[i21 + 16 >> 2] | 0;
  i6 = HEAP32[i4 + (i5 + -1 << 2) >> 2] | 0;
  i7 = HEAP32[(HEAP32[i25 >> 2] | 0) + 8 >> 2] | 0;
  i3 = HEAP32[i21 >> 2] | 0;
  i14 = i1 + (HEAP32[i14 >> 2] << 2) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i16 >> 2] = i4;
  HEAP32[i16 + 4 >> 2] = i4 + (i5 << 2);
  i14 = HEAP32[i21 + 24 >> 2] | 0;
  HEAP32[i17 >> 2] = i14;
  HEAP32[i17 + 4 >> 2] = i14 + (i6 << 2);
  i14 = HEAP32[i21 + 20 >> 2] | 0;
  HEAP32[i18 >> 2] = i14;
  HEAP32[i18 + 4 >> 2] = i14 + (i6 << 1 << 2);
  i6 = HEAP32[i21 + 32 >> 2] | 0;
  i14 = HEAP32[i21 + 28 >> 2] | 0;
  HEAP32[i19 >> 2] = i6;
  HEAP32[i19 + 4 >> 2] = i6 + (i14 << 2);
  i21 = HEAP32[i21 + 36 >> 2] | 0;
  HEAP32[i20 >> 2] = i21;
  HEAP32[i20 + 4 >> 2] = i21 + (i14 << 2);
  HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  i3 = mftCall_iiiiiiiii(i7 | 0, i25 | 0, i3 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0) | 0;
  HEAP32[i22 >> 2] = i3;
  i3 = i3 + 4 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + 1 << 16 >> 16;
  i3 = 1;
 }
 i25 = HEAP32[i23 >> 2] | 0;
 if ((i25 | 0) > -1 & (i25 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i24 >> 2] | 0;
  if (i1 | 0) {
   i25 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i25 >> 2] | 0) + 12 >> 2] | 0, i25 | 0, i1 | 0);
  }
 }
 i26 = HEAP32[i26 >> 2] | 0;
 if ((i26 & 2147483647 | 0) == 0 | (i26 | 0) < 0 | (i2 | 0) == 0) {
  STACKTOP = i27;
  return i3 | 0;
 }
 i26 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 12 >> 2] | 0, i26 | 0, i2 | 0);
 STACKTOP = i27;
 return i3 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 742907;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx18PxFixedJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 742907;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 742907;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE23handleArticulationLinksERKNS_32PxArticulationLinkCollectionPropE(i14, i3) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 280 | 0;
 i1 = i20;
 i17 = i20 + 8 | 0;
 i2 = i14 + 8 | 0;
 i10 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i10) {
  STACKTOP = i20;
  return;
 }
 i18 = i19 + 256 | 0;
 i16 = i19 + 260 | 0;
 HEAP32[i19 + 264 >> 2] = 0;
 i15 = i19 + 268 | 0;
 HEAP8[i18 >> 0] = 1;
 HEAP32[i16 >> 2] = i19;
 HEAP32[i15 >> 2] = 64;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i19, i10, i1);
 mftCall_iiii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i16 >> 2] | 0, i10 | 0) | 0;
 i13 = i17 + 256 | 0;
 i11 = i17 + 260 | 0;
 HEAP32[i17 + 264 >> 2] = 0;
 i12 = i17 + 268 | 0;
 HEAP8[i13 >> 0] = 1;
 HEAP32[i11 >> 2] = i17;
 HEAP32[i12 >> 2] = 64;
 i6 = i14 + 20 | 0;
 i8 = 0;
 while (1) {
  i7 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i8 << 2) >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i7;
  i1 = HEAP32[i2 + 24 >> 2] | 0;
  L6 : do if (!i1) i9 = 9; else {
   i4 = _i64Add(i5 | 0, 0, -1, ~i5 | 0) | 0;
   i3 = getTempRet0() | 0;
   i21 = _bitshift64Lshr(i4 | 0, i3 | 0, 22) | 0;
   i4 = i21 ^ i4;
   i3 = (getTempRet0() | 0) ^ i3;
   i21 = _bitshift64Shl(i4 | 0, i3 | 0, 13) | 0;
   i21 = _i64Add(i4 | 0, i3 | 0, ~i21 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i3 = getTempRet0() | 0;
   i4 = _bitshift64Lshr(i21 | 0, i3 | 0, 8) | 0;
   i3 = ___muldi3(i4 ^ i21 | 0, (getTempRet0() | 0) ^ i3 | 0, 9, 0) | 0;
   i21 = getTempRet0() | 0;
   i4 = _bitshift64Lshr(i3 | 0, i21 | 0, 15) | 0;
   i3 = i4 ^ i3;
   i21 = (getTempRet0() | 0) ^ i21;
   i4 = _bitshift64Shl(i3 | 0, i21 | 0, 27) | 0;
   i4 = _i64Add(i3 | 0, i21 | 0, ~i4 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i21 = getTempRet0() | 0;
   i3 = _bitshift64Lshr(i4 | 0, i21 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i21;
   i1 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (((i3 ^ i4) & i1 + -1) << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i9 = 9; else {
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i3 = i2 + 12 | 0;
    i2 = i1;
    while (1) {
     i1 = i4 + (i2 << 4) | 0;
     i21 = i1;
     if ((HEAP32[i21 + 4 >> 2] | 0) == 0 ? (HEAP32[i21 >> 2] | 0) == (i5 | 0) : 0) break;
     i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     if ((i2 | 0) == -1) {
      i9 = 9;
      break L6;
     }
    }
    if (!i1) i9 = 9;
   }
  } while (0);
  if ((i9 | 0) == 9) {
   i9 = 0;
   __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE25recurseAddLinkAndChildrenEPKNS_18PxArticulationLinkERNS_6shdfnd11InlineArrayIS6_Lj64ENS7_19ReflectionAllocatorIS6_EEEE(i14, i7, i17);
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == (i10 | 0)) {
   i1 = 0;
   break;
  }
 }
 do {
  __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE21writeArticulationLinkEPKNS_18PxArticulationLinkE(i14, HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i14 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
 }
 i21 = HEAP32[i12 >> 2] | 0;
 do if ((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i17 | 0) == (i1 | 0)) {
   HEAP8[i13 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 } while (0);
 i21 = HEAP32[i15 >> 2] | 0;
 do if ((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i19 | 0) == (i1 | 0)) {
   HEAP8[i18 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i21 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i20;
 return;
}

function __ZN12LineRenderer5ResetEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i13 = i14;
 HEAP8[i11 + 340 >> 0] = 1;
 i10 = i11 + 348 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = i1 + 24 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
  HEAP32[i2 >> 2] = 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else i4 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = i4 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483646) >>> 0 < 2) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 2;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 24, 4, i4 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i4 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i4 + 20 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = 2;
  HEAP32[i1 >> 2] = i9;
  break;
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + (i5 * 12 | 0) >> 2] = 0;
 HEAP32[i2 + (i5 * 12 | 0) + 4 >> 2] = 0;
 HEAP32[i2 + (i5 * 12 | 0) + 8 >> 2] = 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i10 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 + (i5 * 12 | 0) >> 2] = 0;
 HEAP32[i10 + (i5 * 12 | 0) + 4 >> 2] = 0;
 HEAP32[i10 + (i5 * 12 | 0) + 8 >> 2] = 1065353216;
 i10 = HEAP32[i11 + 344 >> 2] | 0;
 HEAPF32[i10 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 88 >> 2] = 0;
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i12, Math_fround(0.0), i13);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i10 + 20 | 0, i12) | 0;
 HEAP32[i12 >> 2] = 1065353216;
 HEAP32[i12 + 4 >> 2] = 1065353216;
 HEAP32[i12 + 8 >> 2] = 1065353216;
 HEAP32[i12 + 12 >> 2] = 1065353216;
 HEAPF32[i12 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 20 >> 2] = 1065353216;
 HEAP32[i12 + 24 >> 2] = 1065353216;
 HEAP32[i12 + 28 >> 2] = 1065353216;
 HEAP32[i12 + 32 >> 2] = 1065353216;
 HEAPF32[i12 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
 i9 = i10 + 108 | 0;
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i9, i12, 2);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i9, i13, 2);
 i13 = i10 + 180 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 __ZN8Renderer10SetVisibleEb(i11, 1);
 STACKTOP = i14;
 return;
}

function __Z14OrthoNormalizeP8Vector3fS0_S0_(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f1 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(f1 * f1);
 i13 = i10 + 4 | 0;
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f2 * f2));
 i14 = i10 + 8 | 0;
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f3 * f3))));
 if (f4 > Math_fround(9.99999974e-06)) {
  f1 = Math_fround(f1 / f4);
  HEAPF32[i10 >> 2] = f1;
  f5 = Math_fround(f2 / f4);
  HEAPF32[i13 >> 2] = f5;
  f2 = f1;
  f1 = Math_fround(f3 / f4);
 } else {
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  f2 = Math_fround(1.0);
  f5 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i14 >> 2] = f1;
 f17 = Math_fround(HEAPF32[i11 >> 2]);
 f16 = Math_fround(f2 * f17);
 i8 = i11 + 4 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f5 * f15));
 i9 = i11 + 8 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f1 * f4));
 f5 = Math_fround(f5 * f16);
 f3 = Math_fround(f1 * f16);
 f1 = Math_fround(f17 - Math_fround(f2 * f16));
 HEAPF32[i11 >> 2] = f1;
 f2 = Math_fround(f15 - f5);
 HEAPF32[i8 >> 2] = f2;
 f3 = Math_fround(f4 - f3);
 HEAPF32[i9 >> 2] = f3;
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)))));
 if (f4 > Math_fround(9.99999974e-06)) {
  f1 = Math_fround(f1 / f4);
  HEAPF32[i11 >> 2] = f1;
  f2 = Math_fround(f2 / f4);
  HEAPF32[i8 >> 2] = f2;
  f3 = Math_fround(f3 / f4);
 } else {
  f1 = Math_fround(HEAPF32[i14 >> 2]);
  i7 = f1 < Math_fround(0.0);
  f17 = Math_fround(-f1);
  if ((i7 ? f17 : f1) > Math_fround(.707106769)) {
   f3 = Math_fround(HEAPF32[i13 >> 2]);
   f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3)))));
   f3 = Math_fround(f3 * f2);
   f2 = Math_fround(-Math_fround(f1 * f2));
   f1 = Math_fround(0.0);
  } else {
   f2 = Math_fround(HEAPF32[i10 >> 2]);
   f1 = Math_fround(f2 * f2);
   f17 = Math_fround(HEAPF32[i13 >> 2]);
   f1 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f1 + Math_fround(f17 * f17)))));
   f3 = Math_fround(0.0);
   f2 = Math_fround(f2 * f1);
   f1 = Math_fround(-Math_fround(f17 * f1));
  }
  HEAPF32[i11 >> 2] = f1;
  HEAPF32[i8 >> 2] = f2;
 }
 HEAPF32[i9 >> 2] = f3;
 f19 = Math_fround(HEAPF32[i12 >> 2]);
 f18 = Math_fround(f1 * f19);
 i6 = i12 + 4 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f2 * f15));
 i7 = i12 + 8 | 0;
 f17 = Math_fround(HEAPF32[i7 >> 2]);
 f18 = Math_fround(f18 + Math_fround(f3 * f17));
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(f19 * f5);
 f16 = Math_fround(HEAPF32[i13 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f15 * f16));
 f20 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f17 * f20));
 f16 = Math_fround(Math_fround(f2 * f18) + Math_fround(f16 * f4));
 f2 = Math_fround(Math_fround(f3 * f18) + Math_fround(f20 * f4));
 f4 = Math_fround(f19 - Math_fround(Math_fround(f1 * f18) + Math_fround(f5 * f4)));
 HEAPF32[i12 >> 2] = f4;
 f1 = Math_fround(f15 - f16);
 HEAPF32[i6 >> 2] = f1;
 f2 = Math_fround(f17 - f2);
 HEAPF32[i7 >> 2] = f2;
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4)))));
 if (f3 > Math_fround(9.99999974e-06)) {
  HEAPF32[i12 >> 2] = Math_fround(f4 / f3);
  HEAPF32[i6 >> 2] = Math_fround(f1 / f3);
  f20 = Math_fround(f2 / f3);
  HEAPF32[i7 >> 2] = f20;
  return;
 } else {
  f17 = Math_fround(HEAPF32[i13 >> 2]);
  f19 = Math_fround(HEAPF32[i9 >> 2]);
  f18 = Math_fround(f17 * f19);
  f5 = Math_fround(HEAPF32[i14 >> 2]);
  f15 = Math_fround(HEAPF32[i8 >> 2]);
  f18 = Math_fround(f18 - Math_fround(f5 * f15));
  f20 = Math_fround(HEAPF32[i11 >> 2]);
  f5 = Math_fround(f5 * f20);
  f16 = Math_fround(HEAPF32[i10 >> 2]);
  f19 = Math_fround(f5 - Math_fround(f19 * f16));
  f20 = Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f20));
  HEAPF32[i12 >> 2] = f18;
  HEAPF32[i6 >> 2] = f19;
  HEAPF32[i7 >> 2] = f20;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStrS7_S7_(i12, i11, i10, i1) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 56 | 0;
 i15 = i19 + 40 | 0;
 i16 = i19 + 24 | 0;
 i17 = i19 + 12 | 0;
 i18 = i19;
 i9 = i12 + 2168 | 0;
 mftCall_vii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0, i12 | 0);
 i1 = i12 + 2256 | 0;
 i9 = i10 + 11 | 0;
 do if ((i1 | 0) == (i10 | 0)) {
  i3 = i10;
  i2 = i10 + 4 | 0;
  i1 = i10;
 } else {
  i8 = HEAP8[i9 >> 0] | 0;
  i5 = i8 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
  i2 = i10 + 4 | 0;
  i8 = i5 ? HEAP32[i2 >> 2] | 0 : i8 & 255;
  i5 = i1 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i6 = (HEAP32[i12 + 2264 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i8 >>> 0 > i6 >>> 0) {
   if (i4) i3 = HEAP32[i12 + 2260 >> 2] | 0; else i3 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i6, i8 - i6 | 0, i3, 0, i3, i8, i7);
   i3 = i10;
   i1 = i10;
   break;
  }
  if (i4) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i12 + 2260 >> 2] = i8;
   i3 = i10;
   i1 = i10;
   break;
  } else {
   HEAP8[i5 >> 0] = i8;
   i3 = i10;
   i1 = i10;
   break;
  }
 } while (0);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i10 = i8 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i8 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i10, i4);
 i4 = HEAP8[i9 >> 0] | 0;
 i11 = i4 << 24 >> 24 < 0;
 i1 = i11 ? HEAP32[i3 >> 2] | 0 : i1;
 i4 = i11 ? HEAP32[i2 >> 2] | 0 : i4 & 255;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i16, i17, i18);
 i4 = HEAP8[i16 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i16 >> 2] | 0 : i16;
 i4 = i1 ? HEAP32[i16 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 + 12 >> 2] | 0;
  i13 = 21;
 } else if (i4 >>> 0 < 11) {
  i2 = i15 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i15; else {
   i1 = i15;
   i13 = 23;
  }
 } else i13 = 21;
 if ((i13 | 0) == 21) {
  i2 = i4 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i15 + 4 >> 2] = i4;
  i2 = i15 + 11 | 0;
  i13 = 23;
 }
 if ((i13 | 0) == 23) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr(i12, i15) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i19;
  return i1 | 0;
 }
 i13 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = 66;
 HEAP32[i14 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i19;
 return i1 | 0;
}

function __ZN5Unity5Joint14FinalizeCreateEb(i13, i3) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 16 | 0;
 i6 = i14 + 8 | 0;
 i11 = i14;
 i12 = i13 + 32 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i13 + 80 >> 2]);
 i1 = f16 == Math_fround(inf);
 f16 = i1 ? Math_fround(3402823469999999843913219.0e14) : f16;
 f15 = Math_fround(HEAPF32[i13 + 84 >> 2]);
 i1 = f15 == Math_fround(inf);
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, +f16, +(i1 ? Math_fround(3402823469999999843913219.0e14) : f15));
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i13;
 i2 = (HEAP8[i13 + 89 >> 0] | 0) != 0;
 if (i1 | 0) if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1)) {
  i10 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 64 >> 2] | 0, i10 | 0, 512, i2 ^ 1 | 0);
  i10 = HEAP32[i12 >> 2] | 0;
  i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0) | 0;
  mftCall_vif(HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0, i10 | 0, +(i2 ? Math_fround(0.0) : Math_fround(9.99999993e-09)));
 }
 i2 = HEAP32[i12 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, 8, (HEAP8[i13 + 88 >> 0] | 0) != 0 | 0);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0;
 mftCall_viii(i1 | 0, i2 | 0, 32, __ZNK14PhysicsManager23GetPvdConnectionEnabledEv(__Z17GetPhysicsManagerv() | 0) | 0);
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 + 28 >> 2] | 0, gb + 67048 | 0) | 0;
 __ZN9Rigidbody6CreateEb(i2, 1);
 __ZN9Rigidbody22FetchPoseFromTransformEv(i2);
 i1 = i3 & 1;
 i7 = i1 ^ 1;
 i8 = HEAP32[i12 >> 2] | 0;
 i10 = i11 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, i11 | 0, i10 | 0);
 i1 = i11 + (i1 << 2) | 0;
 i2 = HEAP32[i2 + 52 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i8 = 0; else {
  HEAP32[i1 >> 2] = i2;
  i8 = 1;
 }
 i4 = i13 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i9 = 21; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 14; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 16;
   }
  }
  if ((i9 | 0) == 14) i9 = 16;
  if ((i9 | 0) == 16) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i9 = 21;
    break;
   }
  }
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i2) i9 = 21; else if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
   __ZN9Rigidbody6CreateEb(i1, 1);
   __ZN9Rigidbody22FetchPoseFromTransformEv(i1);
   i2 = i11 + (i7 << 2) | 0;
   i1 = HEAP32[i1 + 52 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i9 = 23; else {
    HEAP32[i2 >> 2] = i1;
    i9 = 24;
   }
  } else i9 = 21;
 } while (0);
 if ((i9 | 0) == 21) {
  i1 = i11 + (i7 << 2) | 0;
  if (!(HEAP32[i1 >> 2] | 0)) i9 = 23; else {
   HEAP32[i1 >> 2] = 0;
   i9 = 24;
  }
 }
 if ((i9 | 0) == 23) if (i8) i9 = 24;
 if ((i9 | 0) == 24) {
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i10 >> 2] | 0);
  __ZN5Unity5Joint9SetupAxesEi(i13, 3);
 }
 i1 = i13 + 76 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __ZN5Unity5Joint9SetupAxesEi(i13, 3);
  HEAP8[i1 >> 0] = 0;
 }
 STACKTOP = i14;
 return;
}

function __Z32register_external_gfx_allocationPvjjPKci(i9, i16, i7, i13, i14) {
 i9 = i9 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17;
 i11 = i17 + 32 | 0;
 i10 = i17 + 28 | 0;
 i15 = i9;
 i1 = HEAP32[gb + 1188412 >> 2] | 0;
 if (!i1) {
  i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i1 = __Znwj(16) | 0;
  i4 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[gb + 1188412 >> 2] = i1;
  if (i5) {
   __Z19pop_allocation_rootv();
   i1 = HEAP32[gb + 1188412 >> 2] | 0;
  }
 }
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) i8 = 11; else {
  i2 = i5;
  L6 : while (1) {
   i4 = i3;
   while (1) {
    if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i3) break L6; else i4 = i3;
   }
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) {
    i2 = i4;
    break;
   } else i2 = i4;
  }
  if ((i2 | 0) == (i5 | 0)) i8 = 11; else if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 > i9 >>> 0) i8 = 11;
 }
 if ((i8 | 0) == 11) i2 = i5;
 if ((i2 | 0) == (i1 + 4 | 0)) i6 = i1; else {
  i4 = HEAP32[i2 + 28 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  i8 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i6 >> 2] = i9;
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i6 + 8 >> 2] = i5;
  HEAP32[i6 + 12 >> 2] = i8;
  HEAP32[i6 + 16 >> 2] = i13;
  HEAP32[i6 + 20 >> 2] = i14;
  HEAP32[i6 + 24 >> 2] = i16;
  __Z6FormatPKcz(i11, gb + 582580 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 581974 | 0, 1391, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i6 = HEAP32[gb + 1188412 >> 2] | 0;
 }
 i5 = (i7 | 0) == 0 ? i15 : i7;
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i9 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i8 = 17;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i9 >>> 0) {
     i8 = 22;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i8 = 21;
     break;
    } else i1 = i2;
   }
  }
  if ((i8 | 0) == 17) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i8 | 0) == 21) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i8 | 0) == 22) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i10;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  i15 = HEAP32[gb + 1188356 >> 2] | 0;
  i15 = i15 + i16 | 0;
  HEAP32[gb + 1188356 >> 2] = i15;
  i15 = HEAP32[gb + 1163236 >> 2] | 0;
  __ZN14MemoryProfiler18RegisterMemoryToIDEjj(i15, i5, i16);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = 58;
 HEAP32[i11 + 4 >> 2] = i1;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i10 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i10;
  if (i10 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i12 = i1;
   break;
  }
 } else i12 = i1; while (0);
 i1 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i12, 36, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i1 + 16 >> 2] = i15;
 HEAP32[i1 + 20 >> 2] = i16;
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = i13;
 HEAP32[i1 + 32 >> 2] = i14;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
 i15 = i6 + 12 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 i15 = HEAP32[gb + 1188356 >> 2] | 0;
 i15 = i15 + i16 | 0;
 HEAP32[gb + 1188356 >> 2] = i15;
 i15 = HEAP32[gb + 1163236 >> 2] | 0;
 __ZN14MemoryProfiler18RegisterMemoryToIDEjj(i15, i5, i16);
 STACKTOP = i17;
 return;
}

function __ZN14OcclusionScene8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379057 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379072 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379086 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379099 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379111 | 0, gb + 863904 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _mbsrtowcs(i5, i9, i1, i3) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i3) i8 = 5; else {
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) i8 = 5; else if (!i5) {
   i3 = i1;
   i6 = i2;
   i8 = 17;
  } else {
   HEAP32[i3 >> 2] = 0;
   i7 = i5;
   i3 = i1;
   i8 = 38;
  }
 }
 if ((i8 | 0) == 5) if (!i5) {
  i3 = i1;
  i8 = 7;
 } else {
  i4 = i5;
  i3 = i1;
  i8 = 6;
 }
 L7 : while (1) if ((i8 | 0) == 6) {
  if (!i3) {
   i8 = 27;
   break;
  } else i5 = i4;
  while (1) {
   i4 = HEAP8[i2 >> 0] | 0;
   do if (((i4 & 255) + -1 | 0) >>> 0 < 127) if (i3 >>> 0 > 4 & (i2 & 3 | 0) == 0) {
    while (1) {
     i4 = HEAP32[i2 >> 2] | 0;
     if ((i4 + -16843009 | i4) & -2139062144 | 0) {
      i8 = 33;
      break;
     }
     HEAP32[i5 >> 2] = i4 & 255;
     HEAP32[i5 + 4 >> 2] = HEAPU8[i2 + 1 >> 0];
     HEAP32[i5 + 8 >> 2] = HEAPU8[i2 + 2 >> 0];
     i6 = i2 + 4 | 0;
     i4 = i5 + 16 | 0;
     HEAP32[i5 + 12 >> 2] = HEAPU8[i2 + 3 >> 0];
     i3 = i3 + -4 | 0;
     if (i3 >>> 0 > 4) {
      i5 = i4;
      i2 = i6;
     } else {
      i8 = 32;
      break;
     }
    }
    if ((i8 | 0) == 32) {
     i5 = i4;
     i2 = i6;
     i4 = HEAP8[i6 >> 0] | 0;
     break;
    } else if ((i8 | 0) == 33) {
     i4 = i4 & 255;
     break;
    }
   } while (0);
   i4 = i4 & 255;
   if ((i4 + -1 | 0) >>> 0 >= 127) break;
   i2 = i2 + 1 | 0;
   HEAP32[i5 >> 2] = i4;
   i3 = i3 + -1 | 0;
   if (!i3) {
    i8 = 27;
    break L7;
   } else i5 = i5 + 4 | 0;
  }
  i4 = i4 + -194 | 0;
  if (i4 >>> 0 > 50) {
   i8 = 49;
   break;
  }
  i7 = i5;
  i4 = HEAP32[gb + 191408 + (i4 << 2) >> 2] | 0;
  i2 = i2 + 1 | 0;
  i8 = 38;
  continue;
 } else if ((i8 | 0) == 7) {
  while (1) {
   i4 = HEAP8[i2 >> 0] | 0;
   if (((i4 & 255) + -1 | 0) >>> 0 < 127) if (!(i2 & 3)) {
    i8 = HEAP32[i2 >> 2] | 0;
    i4 = i8 & 255;
    if (!((i8 + -16843009 | i8) & -2139062144)) {
     do {
      i2 = i2 + 4 | 0;
      i3 = i3 + -4 | 0;
      i4 = HEAP32[i2 >> 2] | 0;
     } while (!((i4 + -16843009 | i4) & -2139062144 | 0));
     i4 = i4 & 255;
    }
   }
   i4 = i4 & 255;
   if ((i4 + -1 | 0) >>> 0 >= 127) break;
   i2 = i2 + 1 | 0;
   i3 = i3 + -1 | 0;
  }
  i4 = i4 + -194 | 0;
  if (i4 >>> 0 > 50) {
   i8 = 49;
   break;
  }
  i4 = HEAP32[gb + 191408 + (i4 << 2) >> 2] | 0;
  i6 = i2 + 1 | 0;
  i8 = 17;
  continue;
 } else if ((i8 | 0) == 17) {
  i8 = (HEAPU8[i6 >> 0] | 0) >>> 3;
  if ((i8 + -16 | i8 + (i4 >> 26)) >>> 0 > 7) {
   i8 = 18;
   break;
  }
  i2 = i6 + 1 | 0;
  if (i4 & 33554432) {
   if ((HEAP8[i2 >> 0] & -64) << 24 >> 24 != -128) {
    i8 = 21;
    break;
   }
   i2 = i6 + 2 | 0;
   if (i4 & 524288) {
    if ((HEAP8[i2 >> 0] & -64) << 24 >> 24 != -128) {
     i8 = 24;
     break;
    }
    i2 = i6 + 3 | 0;
   }
  }
  i3 = i3 + -1 | 0;
  i8 = 7;
  continue;
 } else if ((i8 | 0) == 38) {
  i5 = HEAPU8[i2 >> 0] | 0;
  i8 = i5 >>> 3;
  if ((i8 + -16 | i8 + (i4 >> 26)) >>> 0 > 7) {
   i8 = 39;
   break;
  }
  i6 = i2 + 1 | 0;
  i5 = i5 + -128 | i4 << 6;
  if ((i5 | 0) < 0) {
   i4 = (HEAPU8[i6 >> 0] | 0) + -128 | 0;
   if (i4 >>> 0 > 63) {
    i8 = 42;
    break;
   }
   i6 = i2 + 2 | 0;
   i5 = i4 | i5 << 6;
   if ((i5 | 0) < 0) {
    i4 = (HEAPU8[i6 >> 0] | 0) + -128 | 0;
    if (i4 >>> 0 > 63) {
     i8 = 45;
     break;
    }
    i5 = i4 | i5 << 6;
    i2 = i2 + 3 | 0;
   } else i2 = i6;
  } else i2 = i6;
  HEAP32[i7 >> 2] = i5;
  i4 = i7 + 4 | 0;
  i3 = i3 + -1 | 0;
  i8 = 6;
  continue;
 }
 if ((i8 | 0) == 18) {
  i2 = i6 + -1 | 0;
  i8 = 48;
 } else if ((i8 | 0) == 21) {
  i2 = i6 + -1 | 0;
  i8 = 48;
 } else if ((i8 | 0) == 24) {
  i2 = i6 + -1 | 0;
  i8 = 48;
 } else if ((i8 | 0) == 27) HEAP32[i9 >> 2] = i2; else if ((i8 | 0) == 39) {
  i2 = i2 + -1 | 0;
  i5 = i7;
  i8 = 48;
 } else if ((i8 | 0) == 42) {
  i2 = i2 + -1 | 0;
  i1 = i7;
  i8 = 53;
 } else if ((i8 | 0) == 45) {
  i2 = i2 + -1 | 0;
  i1 = i7;
  i8 = 53;
 }
 if ((i8 | 0) == 48) if (!i4) i8 = 49; else {
  i1 = i5;
  i8 = 53;
 }
 if ((i8 | 0) == 49) if (!(HEAP8[i2 >> 0] | 0)) {
  if (i5 | 0) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
  }
  i1 = i1 - i3 | 0;
 } else {
  i1 = i5;
  i8 = 53;
 }
 if ((i8 | 0) == 53) {
  HEAP32[(___errno_location() | 0) >> 2] = 84;
  if (!i1) i1 = -1; else {
   HEAP32[i9 >> 2] = i2;
   i1 = -1;
  }
 }
 return i1 | 0;
}

function __Z22sweepCapsule_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i3, i8, i17, f15, i16, i7, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i17 = i17 | 0;
 f15 = Math_fround(f15);
 i16 = i16 | 0;
 i7 = i7 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, d22 = 0.0, f23 = f0, f24 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i9 = i14;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i13, i3);
 f2 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) + f2);
 HEAP32[i16 + 8 >> 2] = -1;
 i21 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = i21;
 i20 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i9 + 4 >> 2] = i20;
 i19 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = i19;
 i18 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i9 + 12 >> 2] = i18;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 HEAP32[i9 + 16 >> 2] = i1;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i9 + 20 >> 2] = i3;
 f10 = Math_fround(HEAPF32[i13 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f10);
 f4 = Math_fround(f4 + Math_fround((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11));
 f4 = Math_fround(f4 + Math_fround((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f12));
 i19 = f4 < Math_fround(3402823469999999843913219.0e14);
 f4 = i19 ? f4 : Math_fround(3402823469999999843913219.0e14);
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f10);
 f6 = Math_fround(f6 + Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f11));
 f6 = Math_fround(f6 + Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f12));
 i3 = f6 < f4;
 f4 = i3 ? f6 : f4;
 i3 = i3 & 1;
 i1 = HEAPU16[i7 >> 1] | 0;
 if (!(i1 & 512)) {
  if (!(i1 & 16)) if (f4 <= Math_fround(f2 - Math_fround(HEAPF32[i13 + 12 >> 2]))) {
   HEAP16[i16 + 12 >> 1] = 6;
   HEAPF32[i16 + 40 >> 2] = Math_fround(0.0);
   f11 = Math_fround(-Math_fround(HEAPF32[i17 >> 2]));
   f12 = Math_fround(-Math_fround(HEAPF32[i17 + 4 >> 2]));
   f15 = Math_fround(-Math_fround(HEAPF32[i17 + 8 >> 2]));
   HEAPF32[i16 + 28 >> 2] = f11;
   HEAPF32[i16 + 32 >> 2] = f12;
   HEAPF32[i16 + 36 >> 2] = f15;
   i21 = 1;
   STACKTOP = i14;
   return i21 | 0;
  }
 } else if (f4 <= Math_fround(f2 - Math_fround(HEAPF32[i13 + 12 >> 2]))) {
  HEAP16[i16 + 12 >> 1] = 7;
  i21 = __ZN5physx2Gu23computePlane_CapsuleMTDERKNS_7PxPlaneERKNS0_7CapsuleERNS_10PxSweepHitE(i13, i8, i16) | 0;
  STACKTOP = i14;
  return i21 | 0;
 }
 f5 = Math_fround(f2 * f10);
 f6 = Math_fround(f2 * f11);
 f2 = Math_fround(f2 * f12);
 f5 = Math_fround(Math_fround(HEAPF32[i9 + (i3 * 12 | 0) >> 2]) - f5);
 f6 = Math_fround(Math_fround(HEAPF32[i9 + (i3 * 12 | 0) + 4 >> 2]) - f6);
 f2 = Math_fround(Math_fround(HEAPF32[i9 + (i3 * 12 | 0) + 8 >> 2]) - f2);
 f4 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f10);
 i1 = i17 + 4 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f11));
 i3 = i17 + 8 | 0;
 f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f12));
 d22 = +f4;
 if (d22 > -1.0e-07 & d22 < 1.0e-07) {
  i21 = 0;
  STACKTOP = i14;
  return i21 | 0;
 }
 f24 = Math_fround(Math_fround(Math_fround(f5 * f10) + Math_fround(f6 * f11)) + Math_fround(f2 * f12));
 f4 = Math_fround(Math_fround(-Math_fround(f24 + Math_fround(HEAPF32[i13 + 12 >> 2]))) / f4);
 HEAPF32[i16 + 40 >> 2] = f4;
 f24 = Math_fround(HEAPF32[i17 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(f6 + Math_fround(f4 * f23));
 f6 = Math_fround(f2 + Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i16 + 16 >> 2] = Math_fround(f5 + Math_fround(f4 * f24));
 HEAPF32[i16 + 20 >> 2] = f23;
 HEAPF32[i16 + 24 >> 2] = f6;
 if (!(f4 > Math_fround(0.0)) | !(f4 <= f15)) {
  i21 = 0;
  STACKTOP = i14;
  return i21 | 0;
 }
 HEAPF32[i16 + 28 >> 2] = f10;
 HEAPF32[i16 + 32 >> 2] = f11;
 HEAPF32[i16 + 36 >> 2] = f12;
 HEAP16[i16 + 12 >> 1] = 7;
 i21 = 1;
 STACKTOP = i14;
 return i21 | 0;
}

function __Z15GetPositionMeshIL20MeshDistributionMode0ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo(i3, i4, i8, i9, i10, i11, i12, i13, i1, i14, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 24 | 0;
 i15 = i2 + 8 | 0;
 i17 = i2 + 4 | 0;
 i16 = i2;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i17 >> 2] = i13;
 __Z12RangedRandomR5RandNRKiS2_(i1, i6, i15, i17);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i16 >> 2] = 3;
 __Z12RangedRandomR5RandNRKiS2_(i15, i6, i17, i16);
 __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E(i9, i10, i11, i12, i1, i15, i7, i3, i4, i8);
 if (!(HEAP32[i11 + 4 >> 2] | 0)) {
  i15 = HEAP32[i12 + (HEAP32[i1 + 4 >> 2] << 4) >> 2] | 0;
  i16 = HEAP32[i12 + (HEAP32[i1 + 8 >> 2] << 4) >> 2] | 0;
  i17 = HEAP32[i12 + (HEAP32[i1 + 12 >> 2] << 4) >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i12 + (HEAP32[i1 >> 2] << 4) >> 2];
  HEAP32[i8 + 4 >> 2] = i15;
  HEAP32[i8 + 8 >> 2] = i16;
  HEAP32[i8 + 12 >> 2] = i17;
 }
 f18 = Math_fround(HEAPF32[i5 >> 2]);
 f37 = Math_fround(f18 * Math_fround(HEAPF32[i3 >> 2]));
 i6 = i3 + 4 | 0;
 f36 = Math_fround(f18 * Math_fround(HEAPF32[i6 >> 2]));
 i7 = i3 + 8 | 0;
 f35 = Math_fround(f18 * Math_fround(HEAPF32[i7 >> 2]));
 i8 = i3 + 12 | 0;
 f34 = Math_fround(f18 * Math_fround(HEAPF32[i8 >> 2]));
 i9 = i3 + 16 | 0;
 f29 = Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2]));
 i10 = i3 + 20 | 0;
 f28 = Math_fround(f18 * Math_fround(HEAPF32[i10 >> 2]));
 i11 = i3 + 24 | 0;
 f27 = Math_fround(f18 * Math_fround(HEAPF32[i11 >> 2]));
 i12 = i3 + 28 | 0;
 f26 = Math_fround(f18 * Math_fround(HEAPF32[i12 >> 2]));
 i13 = i3 + 32 | 0;
 f21 = Math_fround(f18 * Math_fround(HEAPF32[i13 >> 2]));
 i15 = i3 + 36 | 0;
 f20 = Math_fround(f18 * Math_fround(HEAPF32[i15 >> 2]));
 i16 = i3 + 40 | 0;
 f19 = Math_fround(f18 * Math_fround(HEAPF32[i16 >> 2]));
 i17 = i3 + 44 | 0;
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i3 >> 2] = f37;
 HEAPF32[i6 >> 2] = f36;
 HEAPF32[i7 >> 2] = f35;
 HEAPF32[i8 >> 2] = f34;
 HEAPF32[i9 >> 2] = f29;
 HEAPF32[i10 >> 2] = f28;
 HEAPF32[i11 >> 2] = f27;
 HEAPF32[i12 >> 2] = f26;
 HEAPF32[i13 >> 2] = f21;
 HEAPF32[i15 >> 2] = f20;
 HEAPF32[i16 >> 2] = f19;
 HEAPF32[i17 >> 2] = f18;
 f23 = Math_fround(HEAPF32[i14 >> 2]);
 f38 = Math_fround(f23 * Math_fround(HEAPF32[i4 >> 2]));
 f41 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 4 >> 2]));
 f40 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 8 >> 2]));
 f39 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 12 >> 2]));
 f30 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 16 >> 2]));
 f33 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 20 >> 2]));
 f32 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 24 >> 2]));
 f31 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 28 >> 2]));
 f22 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 32 >> 2]));
 f25 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 36 >> 2]));
 f24 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 40 >> 2]));
 f23 = Math_fround(f23 * Math_fround(HEAPF32[i4 + 44 >> 2]));
 f36 = Math_fround(f41 + f36);
 f35 = Math_fround(f40 + f35);
 f34 = Math_fround(f39 + f34);
 HEAPF32[i3 >> 2] = Math_fround(f38 + f37);
 HEAPF32[i6 >> 2] = f36;
 HEAPF32[i7 >> 2] = f35;
 HEAPF32[i8 >> 2] = f34;
 f28 = Math_fround(f33 + f28);
 f27 = Math_fround(f32 + f27);
 f26 = Math_fround(f31 + f26);
 HEAPF32[i9 >> 2] = Math_fround(f30 + f29);
 HEAPF32[i10 >> 2] = f28;
 HEAPF32[i11 >> 2] = f27;
 HEAPF32[i12 >> 2] = f26;
 f20 = Math_fround(f25 + f20);
 f19 = Math_fround(f24 + f19);
 f18 = Math_fround(f23 + f18);
 HEAPF32[i13 >> 2] = Math_fround(f22 + f21);
 HEAPF32[i15 >> 2] = f20;
 HEAPF32[i16 >> 2] = f19;
 HEAPF32[i17 >> 2] = f18;
 STACKTOP = i2;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i11, i16, i15, i12, i13, i14) {
 i11 = i11 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 16 | 0;
 i4 = i17;
 i7 = i17 + 92 | 0;
 i6 = i17 + 88 | 0;
 i9 = i17 + 60 | 0;
 i10 = i17 + 32 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 if (mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, gb + 756565 | 0) | 0) {
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771563 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i1 = _strtoull(i1, i7, 10) | 0;
    i3 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i3 | 0) == 0) {
     i2 = 0;
     i1 = 1;
     break;
    }
    i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i1 | 0, i3 | 0) | 0;
    if (!i2) {
     i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i4 >> 2] = gb + 833471;
     i18 = i4 + 8 | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i18 + 4 >> 2] = i3;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i4);
    }
    i1 = 0;
    break;
   }
   i2 = 0;
   i1 = 1;
  } else {
   i2 = 0;
   i1 = 1;
  } while (0);
  i5 = i1 | (i2 | 0) != 0;
  do if (mftCall_iiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, gb + 771570 | 0, i6 | 0) | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
    i3 = _strtoull(i1, i7, 10) | 0;
    i4 = getTempRet0() | 0;
    if ((i3 | 0) == 0 & (i4 | 0) == 0) {
     i1 = 0;
     i3 = 1;
     break;
    }
    i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i3 | 0, i4 | 0) | 0;
    if (!i1) {
     i18 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
     HEAP32[i8 >> 2] = gb + 833471;
     i7 = i8 + 8 | 0;
     HEAP32[i7 >> 2] = i3;
     HEAP32[i7 + 4 >> 2] = i4;
     __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i18, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i8);
    }
    i3 = 0;
    break;
   }
   i1 = 0;
   i3 = 1;
  } else {
   i1 = 0;
   i3 = 1;
  } while (0);
  mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 40 >> 2] | 0, i15 | 0) | 0;
  if (!(i5 & (i3 | (i1 | 0) != 0))) {
   i16 = 0;
   i15 = i16;
   HEAP32[i11 >> 2] = gb + 765108;
   i18 = i11 + 4 | 0;
   HEAP32[i18 >> 2] = i16;
   i18 = i11 + 8 | 0;
   i16 = i18;
   HEAP32[i16 >> 2] = i15;
   i18 = i18 + 4 | 0;
   HEAP32[i18 >> 2] = 0;
   STACKTOP = i17;
   return;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i1 = __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(HEAP32[i13 >> 2] | 0, i2, i9, i1, i10) | 0;
 if (!i1) {
  i16 = 0;
  i15 = i16;
  HEAP32[i11 >> 2] = gb + 765108;
  i18 = i11 + 4 | 0;
  HEAP32[i18 >> 2] = i16;
  i18 = i11 + 8 | 0;
  i16 = i18;
  HEAP32[i16 >> 2] = i15;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i18 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i18 | 0, 0, 0);
 mftCall_iiiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i1 | 0, i15 | 0, i12 | 0, i13 | 0, i14 | 0) | 0;
 i16 = i1;
 i15 = i16;
 HEAP32[i11 >> 2] = gb + 765108;
 i18 = i11 + 4 | 0;
 HEAP32[i18 >> 2] = i16;
 i18 = i11 + 8 | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = i15;
 i18 = i18 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i6 = i1 + 4 | 0;
 i5 = i2 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i7;
 i5 = i1 + 8 | 0;
 i7 = i2 + 8 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = i6;
 i7 = i1 + 9 | 0;
 i6 = i2 + 9 | 0;
 i5 = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i5;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 i6 = i9 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i5 = i1 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i5);
 i7 = i1 + 24 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i8 = i2 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i8);
 i5 = i2 + 24 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 i6 = i9 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i5 = i1 + 36 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i5);
 i8 = i1 + 48 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i7 = i2 + 36 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i7);
 i5 = i2 + 48 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i9 = i1 + 60 | 0;
 i6 = i2 + 60 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 i6 = i1 + 64 | 0;
 i5 = i2 + 64 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i9;
 i9 = i1 + 68 | 0;
 i7 = i2 + 68 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 f4 = Math_fround((HEAP32[i6 >> 2] | 0) >>> 0);
 HEAP32[i1 + 76 >> 2] = ~~Math_fround(f4 * Math_fround(.5)) >>> 0;
 HEAP32[i1 + 72 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
 HEAP8[i1 + 80 >> 0] = 0;
 f4 = Math_fround((HEAP32[i5 >> 2] | 0) >>> 0);
 HEAP32[i2 + 76 >> 2] = ~~Math_fround(f4 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 72 >> 2] = ~~Math_fround(f4 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 80 >> 0] = 0;
 STACKTOP = i3;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 i17 = __Znwj(i2 * 20 | 0) | 0;
 i18 = i13 + 52 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 i14 = i13 + 56 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i12 = i1 >>> 0 > i2 >>> 0 ? i2 : i1;
 i9 = i3 + (i12 * 20 | 0) | 0;
 if (i12) {
  i8 = i16 + 4 | 0;
  i6 = i17;
  while (1) {
   i1 = HEAP32[i3 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i4 = i6 + 12 | 0;
   HEAP32[i4 >> 2] = i1;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i5 = HEAP32[i3 >> 2] | 0;
    i7 = HEAP32[i3 + 4 >> 2] | 0;
    if (i7 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
     i1 = HEAP32[i4 >> 2] | 0;
     i15 = 8;
    } else if (i7 >>> 0 < 11) {
     HEAP8[i6 + 11 >> 0] = i7;
     if (!i7) i1 = i6; else {
      i1 = i6;
      i15 = 10;
     }
    } else i15 = 8;
    if ((i15 | 0) == 8) {
     i12 = i7 + 16 & -16;
     HEAP32[i16 >> 2] = 54;
     HEAP32[i8 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i6 + 8 >> 2] = i12 | -2147483648;
     HEAP32[i6 + 4 >> 2] = i7;
     i15 = 10;
    }
    if ((i15 | 0) == 10) {
     i15 = 0;
     _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
    }
    HEAP8[i1 + i7 >> 0] = 0;
   } else {
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   }
   HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i3 = i3 + 20 | 0;
   if ((i3 | 0) == (i9 | 0)) break; else i6 = i6 + 20 | 0;
  }
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i11 = i17 + (i2 * 20 | 0) | 0;
 i12 = i13 + 32 | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i7 = i13 + 44 | 0;
  i8 = i12 + 11 | 0;
  i9 = i13 + 36 | 0;
  i10 = i16 + 4 | 0;
  i6 = i13 + 48 | 0;
  i4 = i17 + (i1 * 20 | 0) | 0;
  do {
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i2 = i4 + 12 | 0;
   HEAP32[i2 >> 2] = i1;
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    i3 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
     i1 = HEAP32[i2 >> 2] | 0;
     i15 = 21;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i4 + 11 >> 0] = i5;
     if (!i5) i1 = i4; else {
      i1 = i4;
      i15 = 23;
     }
    } else i15 = 21;
    if ((i15 | 0) == 21) {
     i13 = i5 + 16 & -16;
     HEAP32[i16 >> 2] = 54;
     HEAP32[i10 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i4 >> 2] = i1;
     HEAP32[i4 + 8 >> 2] = i13 | -2147483648;
     HEAP32[i4 + 4 >> 2] = i5;
     i15 = 23;
    }
    if ((i15 | 0) == 23) {
     i15 = 0;
     _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
    }
    HEAP8[i1 + i5 >> 0] = 0;
   } else {
    HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   }
   HEAP32[i4 + 16 >> 2] = HEAP32[i6 >> 2];
   i4 = i4 + 20 | 0;
  } while ((i4 | 0) != (i11 | 0));
  i2 = HEAP32[i14 >> 2] | 0;
 }
 if (!i2) {
  i16 = HEAP32[i18 >> 2] | 0;
  __ZdlPv(i16);
  HEAP32[i18 >> 2] = i17;
  STACKTOP = i19;
  return;
 }
 i3 = i16 + 4 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i18 >> 2] | 0;
  i5 = i4 + (i1 * 20 | 0) | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i5 >> 2] | 0;
   i14 = HEAP32[i4 + (i1 * 20 | 0) + 12 >> 2] | 0;
   HEAP32[i16 >> 2] = 54;
   HEAP32[i3 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i16 = HEAP32[i18 >> 2] | 0;
 __ZdlPv(i16);
 HEAP32[i18 >> 2] = i17;
 STACKTOP = i19;
 return;
}

function __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = i9 - i2 | 0;
 i6 = (i1 | 0) / 36 | 0;
 i8 = i7 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4;
 if (i6 >>> 0 > (((HEAP32[i8 >> 2] | 0) - i4 | 0) / 36 | 0) >>> 0) {
  __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE10deallocateEv(i7);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i4 = ((HEAP32[i8 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0) / 36 | 0;
  i3 = i4 << 1;
  i3 = i4 >>> 0 < 1073741823 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 77;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 36 | 0, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i1 + (i3 * 36 | 0);
  if ((i2 | 0) == (i9 | 0)) {
   STACKTOP = i10;
   return;
  }
  do {
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i8 = i1 + 4 | 0;
   i7 = i2 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   i2 = i2 + 36 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 36 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i9 | 0));
  STACKTOP = i10;
  return;
 }
 i8 = i7 + 4 | 0;
 i1 = ((HEAP32[i8 >> 2] | 0) - i4 | 0) / 36 | 0;
 i7 = i6 >>> 0 > i1 >>> 0;
 i1 = i2 + (i1 * 36 | 0) | 0;
 i6 = i7 ? i1 : i9;
 if ((i6 | 0) == (i2 | 0)) i4 = i3; else {
  do {
   i4 = i3 + 32 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63736 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i4 = i3 + 28 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 + 16 >> 2] | 0, gb + 63184 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63736 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i5 = i3 + 4 | 0;
   i4 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   i2 = i2 + 36 | 0;
   i3 = i3 + 36 | 0;
  } while ((i2 | 0) != (i6 | 0));
  i4 = i3;
 }
 if (i7) {
  if ((i6 | 0) == (i9 | 0)) {
   STACKTOP = i10;
   return;
  }
  i2 = HEAP32[i8 >> 2] | 0;
  do {
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i2 + 32 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i7 = i2 + 4 | 0;
   i6 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   i1 = i1 + 36 | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + 36 | 0;
   HEAP32[i8 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  HEAP32[i8 >> 2] = i1 + -36;
  i2 = i1 + -4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __Z14ProccessStringRNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEERKNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEE(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 64 | 0;
 i10 = i15 + 48 | 0;
 i13 = i15 + 16 | 0;
 i5 = i15;
 i14 = i15 + 36 | 0;
 i1 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i9 = _strlen(i1) | 0;
 i3 = i1 + i9 | 0;
 if ((i9 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i9 = ~i2;
 } else i9 = 0;
 i6 = i11 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) {
  i1 = i6;
  L7 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L7; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i6 | 0)) if (i9 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
   STACKTOP = i15;
   return i9 | 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i4);
 HEAP32[i5 >> 2] = i9;
 i7 = i5 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i14);
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 i1 = i13 + 4 | 0;
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i2 ? HEAP32[i5 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 16 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i13 + 16 >> 2] | 0;
  i8 = 14;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 16;
 } else i8 = 14;
 if ((i8 | 0) == 14) {
  i16 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i13 + 12 >> 2] = i16 | -2147483648;
  HEAP32[i13 + 8 >> 2] = i4;
  i1 = i5;
  i8 = 16;
 }
 if ((i8 | 0) == 16) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) {
  HEAP32[i12 >> 2] = i6;
  i2 = i6;
  i3 = i6;
 } else {
  i4 = HEAP32[i13 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i8 = 21;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i8 = 26;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i8 = 25;
     break;
    } else i1 = i2;
   }
  }
  if ((i8 | 0) == 21) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i8 | 0) == 25) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   break;
  } else if ((i8 | 0) == 26) {
   HEAP32[i12 >> 2] = i1;
   i2 = i1;
   i3 = i12;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i10, i11, i13);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i11 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 4 >> 2] | 0, i1);
  i16 = i11 + 8 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 }
 i1 = i13 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i16 = HEAP32[i1 >> 2] | 0;
  i13 = HEAP32[i13 + 16 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i12);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 STACKTOP = i15;
 return i9 | 0;
}

function __ZN15NavMeshObstacle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i7 = i1 + 40 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842452 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i7 = i1 + 56 | 0;
 i9 = HEAP32[gb + 37324 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842460 | 0, i9, i7, 0);
 i8 = i2 + 20 | 0;
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842470 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842486 | 0, i7, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842494 | 0, i7, i1 + 69 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034411 | 0, i9, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842516 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS2_9allocatorIiEEEEEvRT_17TransferMetaFlags(i16, i7, i1) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i3 = i15 + 8 | 0;
 i6 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i5 - i2 >> 2;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i7, i4 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 } else if (i4 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i4 << 2) | 0;
  if ((i5 | 0) == (i1 | 0)) i1 = i4; else {
   i5 = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2) | 0;
   HEAP32[i6 >> 2] = i5;
   i1 = i4;
  }
 } else i1 = i4;
 do if (i1 | 0) {
  i10 = HEAP32[gb + 37040 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i10, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i11 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i12 = i16 + 84 | 0;
  HEAP32[HEAP32[i12 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i10 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i5 | 0)) {
    i4 = i16 + 16 | 0;
    i6 = i16 + 20 | 0;
    i7 = i16 + 32 | 0;
    i8 = i16 + 36 | 0;
    i9 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i11) | 0) + i10 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i12 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i6 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 >> 2] | 0, 0 - (HEAP32[i7 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) i17 = 14; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 14) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i5 | 0)) break L14;
     i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) {
   i4 = i16 + 16 | 0;
   i6 = i16 + 20 | 0;
   i7 = i16 + 32 | 0;
   i8 = i16 + 36 | 0;
   i9 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i10, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i6 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 >> 2] | 0, 0 - (HEAP32[i7 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 27; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) i17 = 27; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 27) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN3MBP17populateNewRegionERK5IAABB(i34, i31) {
 i34 = i34 | 0;
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0;
 i35 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i35 + 48 | 0;
 i32 = i35 + 24 | 0;
 i30 = i35;
 i4 = HEAP32[i34 + 28 >> 2] | 0;
 i33 = HEAP32[i34 + 40 >> 2] | 0;
 i25 = (i33 >>> 0) / 3 | 0;
 i26 = HEAP32[i34 + 44 >> 2] | 0;
 if (i33 >>> 0 <= 2) {
  STACKTOP = i35;
  return;
 }
 i27 = i34 + 5252 | 0;
 i28 = i34 + 5260 | 0;
 i5 = i32 + 4 | 0;
 i6 = i30 + 4 | 0;
 i7 = i32 + 8 | 0;
 i8 = i30 + 8 | 0;
 i9 = i32 + 12 | 0;
 i10 = i30 + 12 | 0;
 i11 = i32 + 16 | 0;
 i12 = i30 + 16 | 0;
 i13 = i32 + 20 | 0;
 i14 = i30 + 20 | 0;
 i15 = i31 + 12 | 0;
 i16 = i31 + 4 | 0;
 i17 = i31 + 16 | 0;
 i18 = i31 + 8 | 0;
 i19 = i31 + 20 | 0;
 i20 = i29 + 12 | 0;
 i21 = i29 + 16 | 0;
 i22 = i29 + 4 | 0;
 i23 = i29 + 20 | 0;
 i24 = i29 + 8 | 0;
 i33 = 0;
 do {
  do if (!(HEAP32[(HEAP32[i27 >> 2] | 0) + (i33 >>> 5 << 2) >> 2] & 1 << (i33 & 31))) if (!(HEAP16[i26 + (i33 * 12 | 0) + 6 >> 1] & 4)) {
   i1 = HEAP16[i26 + (i33 * 12 | 0) + 4 >> 1] | 0;
   if (!(i1 << 16 >> 16)) {
    __ZNK5physx14PxsAABBManager11getBPBoundsEj(i32, HEAP32[i28 >> 2] | 0, HEAP32[i26 + (i33 * 12 | 0) >> 2] | 0);
    i37 = HEAP32[i32 >> 2] | 0;
    i37 = ((i37 | 0) < 0 ? i37 ^ -2 : i37 | -2147483648) >>> 1;
    HEAP32[i30 >> 2] = i37;
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = ((i1 | 0) < 0 ? i1 ^ -2 : i1 | -2147483648) >>> 1;
    HEAP32[i6 >> 2] = i1;
    i3 = HEAP32[i7 >> 2] | 0;
    i3 = ((i3 | 0) < 0 ? i3 ^ -2 : i3 | -2147483648) >>> 1;
    HEAP32[i8 >> 2] = i3;
    i38 = HEAP32[i9 >> 2] | 0;
    i38 = ((i38 | 0) < 0 ? i38 ^ -2 : i38 | -2147483648) >>> 1;
    HEAP32[i10 >> 2] = i38;
    i36 = HEAP32[i11 >> 2] | 0;
    i36 = ((i36 | 0) < 0 ? i36 ^ -2 : i36 | -2147483648) >>> 1;
    HEAP32[i12 >> 2] = i36;
    i2 = HEAP32[i13 >> 2] | 0;
    i2 = ((i2 | 0) < 0 ? i2 ^ -2 : i2 | -2147483648) >>> 1;
    HEAP32[i14 >> 2] = i2;
    if ((i38 >>> 0 < (HEAP32[i31 >> 2] | 0) >>> 0 ? 1 : (HEAP32[i15 >> 2] | 0) >>> 0 < i37 >>> 0) | i36 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0 | (HEAP32[i17 >> 2] | 0) >>> 0 < i1 >>> 0 | i2 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0 | (HEAP32[i19 >> 2] | 0) >>> 0 < i3 >>> 0) break;
    __ZN3MBP12updateObjectEjRK5IAABB(i34, HEAP32[i26 + (i33 * 12 | 0) + 8 >> 2] | 0, i30) | 0;
    break;
   }
   i2 = i26 + (i33 * 12 | 0) + 8 | 0;
   if (i1 << 16 >> 16 != 1) i2 = (HEAP32[i34 + 96 + ((i1 & 65535) << 4) + 8 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0;
   i3 = HEAP32[i4 + ((HEAPU16[i2 + 2 >> 1] | 0) * 40 | 0) + 28 >> 2] | 0;
   i2 = HEAPU16[i2 >> 1] | 0;
   i38 = HEAP32[i3 + 76 >> 2] | 0;
   i1 = i38 + (i2 << 3) + 4 | 0;
   i2 = HEAP32[i38 + (i2 << 3) >> 2] | 0;
   if (!(HEAP32[i1 >> 2] & 1)) {
    i38 = (HEAP32[i3 + 100 >> 2] | 0) + (i2 * 24 | 0) | 0;
    HEAP32[i29 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i38 + 16 >> 2];
    HEAP32[i29 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
   } else {
    i38 = (HEAP32[i3 + 96 >> 2] | 0) + (i2 * 24 | 0) | 0;
    HEAP32[i29 >> 2] = HEAP32[i38 >> 2];
    HEAP32[i29 + 4 >> 2] = HEAP32[i38 + 4 >> 2];
    HEAP32[i29 + 8 >> 2] = HEAP32[i38 + 8 >> 2];
    HEAP32[i29 + 12 >> 2] = HEAP32[i38 + 12 >> 2];
    HEAP32[i29 + 16 >> 2] = HEAP32[i38 + 16 >> 2];
    HEAP32[i29 + 20 >> 2] = HEAP32[i38 + 20 >> 2];
   }
   i1 = HEAP32[i1 >> 2] | 0;
   if ((HEAP32[i20 >> 2] | 0) >>> 0 >= (HEAP32[i31 >> 2] | 0) >>> 0) if ((HEAP32[i15 >> 2] | 0) >>> 0 >= (HEAP32[i29 >> 2] | 0) >>> 0) if ((HEAP32[i21 >> 2] | 0) >>> 0 >= (HEAP32[i16 >> 2] | 0) >>> 0) if ((HEAP32[i17 >> 2] | 0) >>> 0 >= (HEAP32[i22 >> 2] | 0) >>> 0) if ((HEAP32[i23 >> 2] | 0) >>> 0 >= (HEAP32[i18 >> 2] | 0) >>> 0) if ((HEAP32[i19 >> 2] | 0) >>> 0 >= (HEAP32[i24 >> 2] | 0) >>> 0) __ZN3MBP12updateObjectEjRK5IAABB(i34, i1, i29) | 0;
  } while (0);
  i33 = i33 + 1 | 0;
 } while (i33 >>> 0 < i25 >>> 0);
 STACKTOP = i35;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i22, i1, i3, i2) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 24 | 0;
 i17 = i21 + 16 | 0;
 i14 = i21;
 i20 = i21 + 48 | 0;
 i12 = i21 + 144 | 0;
 i16 = i21 + 160 | 0;
 i18 = i21 + 32 | 0;
 i15 = i22 + 8 | 0;
 i11 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
 i13 = i20 + 80 | 0;
 i6 = i20 + 84 | 0;
 HEAP32[i20 + 88 >> 2] = 0;
 i7 = i20 + 92 | 0;
 HEAP8[i13 >> 0] = 1;
 HEAP32[i6 >> 2] = i20;
 HEAP32[i7 >> 2] = 5;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i20, i5, i12);
 if (i5 | 0) {
  i8 = i17 + 4 | 0;
  i9 = i22 + 4 | 0;
  i10 = i22 + 12 | 0;
  i12 = 0;
  do {
   i1 = i16;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i19 >> 2] = i12;
   __ZN5physx6string9sprintf_sEPcjPKcz(i16, 32, gb + 832301 | 0, i19) | 0;
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i22 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i22 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i17 >> 2] = i16;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i24 = i17;
    i23 = HEAP32[i24 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i4 + 4 >> 2] = i23;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i17) | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, HEAP32[i15 >> 2] | 0, i12 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i22 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
   __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i4, i14) | 0;
   HEAP8[i17 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i17 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i22 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i5 | 0));
 }
 i24 = HEAP32[i7 >> 2] | 0;
 if (!((i24 | 0) > -1 & (i24 & 2147483647 | 0) != 0)) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i20 | 0) == (i1 | 0)) {
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i21;
  return;
 }
 if (!i1) {
  STACKTOP = i21;
  return;
 }
 i24 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i24 >> 2] | 0) + 12 >> 2] | 0, i24 | 0, i1 | 0);
 STACKTOP = i21;
 return;
}

function __ZN17PersistentManager14ReloadFromDiskER6Object(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i17 + 8 | 0;
 i9 = i17 + 4 | 0;
 i10 = i17;
 i11 = i17 + 12 | 0;
 i12 = i14;
 if ((HEAP16[gb + 1165932 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i12;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165932 | 0, i7);
  i16 = gb + 1165932 | 0;
 } else i16 = 0;
 i3 = HEAP32[i15 + 56 >> 2] | 0;
 i8 = i14 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i13 = 7; else {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  if ((i5 | 0) < (i2 | 0)) i13 = 7; else if ((HEAP32[i3 + 32 >> 2] | 0) < (i5 | 0)) i13 = 7; else {
   i5 = (i5 - i2 | 0) / 2 | 0;
   i6 = i5;
   i5 = ((i5 | 0) < 0) << 31 >> 31;
   i13 = 16;
  }
 }
 do if ((i13 | 0) == 7) {
  i4 = i3 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i2 = i4;
   L11 : while (1) {
    i3 = i1;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) break L11; else i3 = i1;
    }
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i2 = i3;
     break;
    } else i2 = i3;
   }
   if ((i2 | 0) != (i4 | 0)) if ((HEAP32[i2 + 16 >> 2] | 0) <= (i5 | 0)) {
    i1 = HEAP32[i2 + 24 >> 2] | 0;
    i2 = i2 + 32 | 0;
    if ((i1 | 0) == -1) {
     i13 = 24;
     break;
    } else {
     i6 = HEAP32[i2 >> 2] | 0;
     i5 = HEAP32[i2 + 4 >> 2] | 0;
     i13 = 16;
     break;
    }
   }
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467278 | 0, 0, gb + 466878 | 0, 1086, 1, i5, 0, 0);
  i1 = 0;
 } while (0);
 L21 : do if ((i13 | 0) == 16) {
  i4 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i15, i1) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i13 = 24; else if (__ZNK14SerializedFile11IsAvailableEx(i2, i6, i5) | 0) {
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   L25 : do if (i3 | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    i18 = HEAP32[i3 + 12 >> 2] | 0;
    i3 = i2 + (i18 << 3) | 0;
    L27 : do if (i18) while (1) {
     i18 = i2;
     if ((HEAP32[i18 >> 2] | 0) == (i6 | 0) ? (HEAP32[i18 + 4 >> 2] | 0) == (i5 | 0) : 0) break L27;
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i3 | 0)) break L25;
    } while (0);
    if ((i2 | 0) != (i3 | 0)) {
     i13 = 24;
     break L21;
    }
   } while (0);
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i13 = 24; else {
    i18 = i15 + 84 | 0;
    HEAP32[i18 >> 2] = i1;
    __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object(i2, i6, i5, 1, 1, i10, i11, i14);
    mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0);
    HEAP32[i18 >> 2] = -1;
    if ((HEAP16[gb + 1165848 + 6 >> 1] | 0) > -1) {
     HEAP32[i9 >> 2] = i12;
     HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165848 | 0, i7);
     i1 = gb + 1165848 | 0;
    } else i1 = 0;
    i2 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
    if (!i2) mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, 3); else {
     __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
     mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, 3);
     __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i2);
    }
    if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
    i1 = i15 + 176 | 0;
    i2 = i15 + 120 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) do {
     __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i15);
     __ZN17PersistentManager27IntegrateAllThreadedObjectsEv(i15);
    } while ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0));
    i1 = 1;
   }
  } else i13 = 24;
 } while (0);
 if ((i13 | 0) == 24) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467338 | 0, 0, gb + 466878 | 0, 1093, 1, HEAP32[i8 >> 2] | 0, 0, 0);
  i1 = 0;
 }
 if (!i16) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN15RelativeJoint2D6CreateEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i5 = i11;
 i8 = i9 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = i9 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i5);
    i4 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i5);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 20;
   }
  }
  if ((i7 | 0) == 18) i7 = 20;
  if ((i7 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i11;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i11;
   return;
  }
 } while (0);
 i2 = i10 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP32[i10 >> 2] = 11;
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 i2 = i10 + 24 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i10 + 28 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 32 >> 2] = HEAP32[i9 + 76 >> 2];
 HEAP32[i10 + 36 >> 2] = HEAP32[i9 + 80 >> 2];
 HEAP32[i10 + 40 >> 2] = HEAP32[i9 + 84 >> 2];
 if (HEAP8[i9 + 100 >> 0] | 0) if (!(HEAP8[i9 + 52 >> 0] | 0)) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 >> 2] | 0, gb + 67088 | 0) | 0;
  if (i1 | 0) __ZN11Rigidbody2D6CreateEv(i1);
  i8 = HEAP32[i1 + 92 >> 2] | 0;
  i7 = __ZNK7Joint2D10FetchBodyBEv(i9) | 0;
  f12 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i8 + 12 >> 2]));
  f14 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i8 + 16 >> 2]));
  f16 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f15 = Math_fround(f12 * f16);
  f13 = Math_fround(HEAPF32[i8 + 20 >> 2]);
  f12 = Math_fround(Math_fround(f16 * f14) - Math_fround(f12 * f13));
  HEAPF32[i9 + 88 >> 2] = Math_fround(f15 + Math_fround(f14 * f13));
  HEAPF32[i9 + 92 >> 2] = f12;
  f12 = Math_fround(HEAPF32[i7 + 56 >> 2]);
  HEAPF32[i9 + 96 >> 2] = Math_fround(f12 - Math_fround(HEAPF32[i8 + 56 >> 2]));
 }
 i8 = HEAP32[i9 + 92 >> 2] | 0;
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 88 >> 2];
 HEAP32[i2 >> 2] = i8;
 HEAP32[i3 >> 2] = HEAP32[i9 + 96 >> 2];
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i9, i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i6 = i13 - i8 | 0;
 i14 = i6 >> 4;
 i7 = i12 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i14 >>> 0 > i1 - i2 >> 4 >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i15 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i15 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i11 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i15 >> 2] = 34;
   HEAP32[i15 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i11 = i1 - i2 | 0;
  i1 = i11 >> 3;
  i1 = i11 >> 4 >>> 0 < 1073741823 ? (i1 >>> 0 < i14 >>> 0 ? i14 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i11 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i15 >> 2] = 34;
  HEAP32[i15 + 4 >> 2] = i11;
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 + 4 >> 2] = i15;
  HEAP32[i12 >> 2] = i15;
  HEAP32[i7 >> 2] = i15 + (i1 << 4);
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i12, i8, i13, i14);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = (HEAP32[i11 >> 2] | 0) - i2 >> 4;
 i10 = i14 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 << 4) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = i8 + 16 | 0;
   i1 = i1 + 16 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i12, i9, i13, i14 - ((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) >> 4) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i15 + 4 | 0;
 do {
  i2 = i1 + -16 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i14 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i15 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN5physx3Scb5Scene16removeRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 816 | 0;
 i11 = i17 + 544 | 0;
 i15 = i17 + 272 | 0;
 i14 = i17;
 if (!(HEAP8[i3 + 2433 >> 0] | 0)) {
  __ZL22addOrRemoveRigidObjectILb0ELb0ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(HEAP32[i3 + 1252 >> 2] | 0, i4);
  i16 = i4 + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & 268435455;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i5 >> 2] = i1 & 1073741823;
   HEAP32[i16 >> 2] = i4;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i16) | 0;
   break;
  }
 case 2:
  {
   HEAP32[i5 >> 2] = i1 | -1073741824;
   if (!(i1 & 268435456)) {
    HEAP32[i11 >> 2] = i4;
    i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i2, i11, i16) | 0;
    if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i4;
   }
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i3 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i4, i16) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i4, i16) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i21 = i10 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i20 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i20;
 i22 = i10 + 9 | 0;
 HEAP8[i22 >> 0] = (i20 & 65535) >>> 8;
 i20 = i10 + 12 | 0;
 i19 = i7 + 12 | 0;
 i15 = i19;
 i18 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i10 + 20 | 0;
 i18 = i7 + 20 | 0;
 i15 = i18;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i21 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i21 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i21;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
 HEAP8[i22 >> 0] = i2;
 i2 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i22 = i20;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = i21;
 HEAP32[i20 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i18 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i20 = i17;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 65;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN14SubstanceValue8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431322 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431332 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431342 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431352 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 39; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 39; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932887 | 0, gb + 1034905 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN7mecanim12statemachine20StateMachineConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i11 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i12 = i9 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (i7 | 0) {
  i7 = i9 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i7 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 64, 4) | 0;
    i3 = i2 + 52 | 0;
    i4 = i2;
    i5 = i4 + 52 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i5 | 0));
    HEAPF32[i3 >> 2] = Math_fround(1.0);
    HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
    HEAP8[i2 + 60 >> 0] = 1;
    HEAP8[i2 + 61 >> 0] = 1;
    HEAP8[i2 + 62 >> 0] = 0;
    HEAP8[i2 + 63 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine13StateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i9);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = i11 + 12 | 0;
 i5 = i11 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) {
  i5 = i9 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
    HEAP8[i2 + 36 >> 0] = 0;
    HEAP8[i2 + 37 >> 0] = 0;
    HEAP32[i2 + 40 >> 2] = 0;
    HEAP8[i2 + 44 >> 0] = 1;
    HEAP8[i2 + 45 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine18TransitionConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i9);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i11 + 20 | 0;
 i5 = i11 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) {
  i5 = i9 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP8[i2 + 12 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine21SelectorStateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i9);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i11 + 24 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i11 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  STACKTOP = i13;
  return;
 }
}

function __ZN5Umbra15BufferAllocator12expandBufferERNS_17BlockRasterBufferERKNS_8Vector4iEb(i18, i16, i1, i15) {
 i18 = i18 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 i17 = i16 + 4 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 if (!i9) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = ((Math_imul(i4 - i2 << 2, i14 - i3 | 0) | 0) + 31 | 0) >>> 5;
  HEAP8[i16 >> 0] = i2;
  i2 = i16 + 1 | 0;
  HEAP8[i2 >> 0] = i3;
  i3 = i16 + 2 | 0;
  HEAP8[i3 >> 0] = i4;
  i4 = i16 + 3 | 0;
  HEAP8[i4 >> 0] = i14;
  i1 = __ZN5Umbra15BufferAllocator8allocateEib(i18, i1, i15) | 0;
  HEAP32[i17 >> 2] = i1;
  if (!i1) {
   HEAP32[i17 >> 2] = HEAP32[i18 + 32912 >> 2];
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  } else {
   _memset(i1 | 0, 0, Math_imul((HEAPU8[i3 >> 0] | 0) - (HEAPU8[i16 >> 0] | 0) << 2, (HEAPU8[i4 >> 0] | 0) - (HEAPU8[i2 >> 0] | 0) | 0) | 0) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 i5 = HEAPU8[i16 >> 0] | 0;
 i2 = i16 + 1 | 0;
 i6 = HEAPU8[i2 >> 0] | 0;
 i3 = i16 + 2 | 0;
 i7 = HEAPU8[i3 >> 0] | 0;
 i4 = i16 + 3 | 0;
 i8 = HEAPU8[i4 >> 0] | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i22 = (i5 | 0) <= (i10 | 0);
 i10 = i22 ? i5 : i10;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i21 = (i6 | 0) <= (i11 | 0);
 i11 = i21 ? i6 : i11;
 i12 = HEAP32[i1 + 8 >> 2] | 0;
 i20 = (i7 | 0) >= (i12 | 0);
 i12 = i20 ? i7 : i12;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i13 = (i8 | 0) >= (i1 | 0);
 i1 = i13 ? i8 : i1;
 if (i22 & i21 & i20 & i13) {
  i22 = 1;
  STACKTOP = i19;
  return i22 | 0;
 }
 i21 = i16;
 i13 = HEAP32[i21 + 4 >> 2] | 0;
 i22 = i14;
 HEAP32[i22 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i22 + 4 >> 2] = i13;
 HEAP8[i16 >> 0] = i10;
 HEAP8[i2 >> 0] = i11;
 HEAP8[i3 >> 0] = i12;
 HEAP8[i4 >> 0] = i1;
 i3 = i18 + 32912 | 0;
 i4 = i13;
 do if ((i9 | 0) == (HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i2 = ((Math_imul(i7 - i5 << 2, i8 - i6 | 0) | 0) + 31 | 0) >>> 5;
  i1 = ((Math_imul(i12 - i10 << 2, i1 - i11 | 0) | 0) + 31 | 0) >>> 5;
  if (i1 >>> 0 > i2 >>> 0) {
   i22 = __ZN5Umbra15BufferAllocator8allocateEib(i18, i1, i15) | 0;
   HEAP32[i17 >> 2] = i22;
   if (!i22) {
    HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
    i1 = i13 - (i18 + 144) | 0;
    i5 = i1 >> 5;
    i6 = i18 + 132 | 0;
    if ((i5 | 0) >= (HEAP32[i6 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    i7 = i5 + i2 | 0;
    i22 = i1 >> 10;
    i1 = i18 + (i22 << 2) | 0;
    i3 = 1 << (i5 & 31);
    i4 = 0 - i3 | 0;
    if (!((i4 | 0) == -1 | (i22 | 0) == (i7 >> 5 | 0))) {
     HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i3 + -1;
     i4 = -1;
     i2 = (i5 | -32) + i2 | 0;
     i1 = i1 + 4 | 0;
    }
    if ((i2 | 0) > 31) {
     i2 = i2 + -32 | 0;
     i22 = i2 >>> 5;
     _memset(i1 | 0, 0, (i22 << 2) + 4 | 0) | 0;
     i2 = i2 - (i22 << 5) | 0;
     i1 = i1 + (i22 + 1 << 2) | 0;
    }
    if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(i4 & (1 << (i7 & 31)) + -1);
    if ((i7 | 0) != (HEAP32[i6 >> 2] | 0)) {
     i1 = 0;
     break;
    }
    HEAP32[i6 >> 2] = i5;
    i1 = 0;
    break;
   }
  }
  __ZN5Umbra9RasterOps10expandBlitERNS_17BlockRasterBufferERKS1_(i16, i14);
  if ((HEAP32[i17 >> 2] | 0) == (i4 | 0)) i1 = 1; else {
   i1 = i13 - (i18 + 144) | 0;
   i5 = i1 >> 5;
   i6 = i18 + 132 | 0;
   if ((i5 | 0) < (HEAP32[i6 >> 2] | 0)) {
    i7 = i5 + i2 | 0;
    i22 = i1 >> 10;
    i1 = i18 + (i22 << 2) | 0;
    i3 = 1 << (i5 & 31);
    i4 = 0 - i3 | 0;
    if (!((i4 | 0) == -1 | (i22 | 0) == (i7 >> 5 | 0))) {
     HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i3 + -1;
     i4 = -1;
     i2 = (i5 | -32) + i2 | 0;
     i1 = i1 + 4 | 0;
    }
    if ((i2 | 0) > 31) {
     i2 = i2 + -32 | 0;
     i22 = i2 >>> 5;
     _memset(i1 | 0, 0, (i22 << 2) + 4 | 0) | 0;
     i2 = i2 - (i22 << 5) | 0;
     i1 = i1 + (i22 + 1 << 2) | 0;
    }
    if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(i4 & (1 << (i7 & 31)) + -1);
    if ((i7 | 0) == (HEAP32[i6 >> 2] | 0)) {
     HEAP32[i6 >> 2] = i5;
     i1 = 1;
    } else i1 = 1;
   } else i1 = 1;
  }
 } while (0);
 i22 = i1;
 STACKTOP = i19;
 return i22 | 0;
}

function __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i11, i4, i5, i6, i7, i12) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i10 = i13 + 8 | 0;
 i8 = i11 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i8 >> 2] | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i8 >> 2] = i1;
 }
 i2 = (i12 & 8 | 0) == 0;
 if ((i4 | 0) == 0 & (i5 | 0) != 0 & i2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427743 | 0, 0, gb + 425656 | 0, 1090, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((((HEAP32[i1 + 132 >> 2] | 0) - (HEAP32[i1 + 128 >> 2] | 0) | 0) / 52 | 0) >>> 0 <= i6 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427787 | 0, 0, gb + 425656 | 0, 1096, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (!(((i5 >>> 0) % 3 | 0 | 0) == 0 | (i7 | 0) != 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427845 | 0, 0, gb + 425656 | 0, 1102, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 L19 : do if (i2) {
  i3 = HEAP32[i1 + 100 >> 2] | 0;
  L21 : do if (!(i12 & 1)) {
   if (!i5) break L19; else i2 = 0;
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) >>> 0 >= i3 >>> 0) break L21;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) break L19;
   }
  } else {
   if (!i5) break L19; else i2 = 0;
   while (1) {
    if ((HEAPU16[i4 + (i2 << 1) >> 1] | 0) >>> 0 >= i3 >>> 0) break L21;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i5 >>> 0) break L19;
   }
  } while (0);
  i12 = HEAP32[i1 + 100 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i9 + 4 >> 2] = i12;
  __Z12FormatStringPKcz(i10, gb + 427936 | 0, i9);
  if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
  i12 = HEAP32[i10 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i12 | 0) == 0 ? i10 + 4 | 0 : i12, 0, gb + 425656 | 0, 1116, 1, i1, 0, 0);
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i10 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i10 + 24 | 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 __ZN4Mesh12SetIndexDataEiiPKv16GfxPrimitiveTypei(i11, i6, i5, i4, i7, i12);
 if (!(i12 & 16)) {
  __ZN4Mesh24UpdateSubMeshVertexRangeEi(i11, i6);
  if (!(i12 & 32)) {
   __ZN4Mesh32RecalculateSubmeshBoundsInternalEj(i11, i6);
   HEAP32[i10 >> 2] = gb + 30832;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = HEAP32[i11 + 236 >> 2] | 0;
   i3 = i11 + 232 | 0;
   i2 = i1;
   if ((i2 | 0) != (i3 | 0)) do {
    i9 = i1;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i9 + 8 >> 2] | 0, gb + 1105176 | 0, i10);
    i2 = i1;
   } while ((i2 | 0) != (i3 | 0));
   i3 = i11 + 240 | 0;
   i1 = HEAP32[i11 + 244 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) != (i3 | 0)) do {
    i10 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i10 | 0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i3 | 0));
  }
 } else {
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = HEAP32[i9 + 128 >> 2] | 0;
  HEAP32[i10 + 44 >> 2] = 0;
  HEAP32[i10 + 48 >> 2] = HEAP32[i9 + 100 >> 2];
  i10 = i10 + 8 | 0;
  i9 = i11 + 48 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 }
 if (i12 & 4 | 0) __ZN17CollisionMeshData20VertexDataHasChangedEv(i11 + 204 | 0);
 __ZN4Mesh16SetChannelsDirtyEjb(i11, 0, 1);
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN13SpeedTreeWindC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAPF32[i5 >> 2] = Math_fround(5.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(2.5);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 416 >> 2] = Math_fround(50.0);
 HEAPF32[i5 + 420 >> 2] = Math_fround(2.0);
 HEAPF32[i5 + 624 >> 2] = Math_fround(.300000012);
 HEAPF32[i5 + 628 >> 2] = Math_fround(.75);
 HEAPF32[i5 + 632 >> 2] = Math_fround(.300000012);
 i6 = i5 + 504 | 0;
 i7 = i6 + 120 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i5 + 756 >> 2] = Math_fround(.300000012);
 HEAPF32[i5 + 760 >> 2] = Math_fround(.75);
 HEAPF32[i5 + 764 >> 2] = Math_fround(.300000012);
 i6 = i5 + 636 | 0;
 i7 = i6 + 120 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i5 + 968 >> 2] = Math_fround(20.0);
 HEAPF32[i5 + 972 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 976 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 980 >> 2] = Math_fround(.300000012);
 HEAPF32[i5 + 984 >> 2] = Math_fround(.00499999989);
 HEAPF32[i5 + 988 >> 2] = Math_fround(1.0);
 _memset(i5 + 768 | 0, 0, 200) | 0;
 HEAPF32[i5 + 1192 >> 2] = Math_fround(20.0);
 HEAPF32[i5 + 1196 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1200 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1204 >> 2] = Math_fround(.300000012);
 HEAPF32[i5 + 1208 >> 2] = Math_fround(.00499999989);
 HEAPF32[i5 + 1212 >> 2] = Math_fround(1.0);
 _memset(i5 + 992 | 0, 0, 200) | 0;
 HEAPF32[i5 + 1256 >> 2] = Math_fround(10.0);
 HEAPF32[i5 + 1260 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1264 >> 2] = Math_fround(.00499999989);
 HEAPF32[i5 + 1268 >> 2] = Math_fround(9.0);
 HEAPF32[i5 + 1272 >> 2] = Math_fround(32.0);
 HEAPF32[i5 + 1276 >> 2] = Math_fround(.400000006);
 HEAPF32[i5 + 1280 >> 2] = Math_fround(.0500000007);
 HEAPF32[i5 + 1284 >> 2] = Math_fround(.5);
 HEAPF32[i5 + 1288 >> 2] = Math_fround(.5);
 HEAPF32[i5 + 1292 >> 2] = Math_fround(-.5);
 HEAPF32[i5 + 1296 >> 2] = Math_fround(.5);
 HEAPF32[i5 + 1300 >> 2] = Math_fround(.5);
 HEAPF32[i5 + 1304 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1308 >> 2] = Math_fround(.5);
 HEAPF32[i5 + 1312 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1316 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1320 >> 2] = Math_fround(4.0);
 HEAPF32[i5 + 1324 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1328 >> 2] = Math_fround(1.0);
 _memset(i5 + 16 | 0, 0, 400) | 0;
 i1 = i5 + 1216 | 0;
 i6 = i5 + 424 | 0;
 i7 = i6 + 80 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i6 = i1;
 i7 = i6 + 40 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i5 + 1344 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1376 >> 2] = Math_fround(0.0);
 HEAPF64[i5 + 1392 >> 3] = -1.0;
 HEAP8[i5 + 1400 >> 0] = 0;
 i1 = i5 + 1440 | 0;
 i6 = i5 + 1404 | 0;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF64[i1 >> 3] = 1.0;
 HEAPF64[i5 + 1448 >> 3] = 0.0;
 HEAPF32[i5 + 1456 >> 2] = Math_fround(0.0);
 i1 = i5 + 1464 | 0;
 i2 = i5 + 1512 | 0;
 i3 = i5 + 1548 | 0;
 i6 = i5 + 1348 | 0;
 i7 = i6 + 28 | 0;
 do {
  HEAP8[i6 >> 0] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i4 = i5 + 1380 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i3;
 i7 = i6 + 80 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1496 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1528 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1484 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 1384 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1500 >> 2] = Math_fround(0.0);
 i7 = i5 + 1532 | 0;
 HEAPF32[i5 + 1488 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1388 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1504 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1492 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1340 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1336 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 1332 >> 2] = Math_fround(0.0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function _decompress_onepass(i36, i27) {
 i36 = i36 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i35 = i36 + 392 | 0;
 i30 = HEAP32[i35 >> 2] | 0;
 i31 = (HEAP32[i36 + 312 >> 2] | 0) + -1 | 0;
 i34 = i36 + 284 | 0;
 i3 = HEAP32[i34 >> 2] | 0;
 i32 = i3 + -1 | 0;
 i28 = i30 + 24 | 0;
 i2 = HEAP32[i28 >> 2] | 0;
 i29 = i30 + 28 | 0;
 i4 = HEAP32[i29 >> 2] | 0;
 do if ((i2 | 0) < (i4 | 0)) {
  i21 = i30 + 20 | 0;
  i22 = i30 + 32 | 0;
  i23 = i36 + 320 | 0;
  i24 = i36 + 408 | 0;
  i25 = i36 + 292 | 0;
  i26 = i36 + 412 | 0;
  i1 = i36 + 128 | 0;
  i20 = i2;
  i3 = i4;
  i2 = HEAP32[i21 >> 2] | 0;
  L3 : while (1) {
   if (i2 >>> 0 <= i31 >>> 0) {
    do {
     _jzero_far(HEAP32[i22 >> 2] | 0, HEAP32[i23 >> 2] << 7);
     if (!((mftCall_iii(HEAP32[(HEAP32[i24 >> 2] | 0) + 4 >> 2] | 0, i36 | 0, i22 | 0) | 0) << 24 >> 24)) break L3;
     i3 = HEAP32[i25 >> 2] | 0;
     if ((i3 | 0) > 0) {
      i19 = i2 >>> 0 < i31 >>> 0;
      i4 = 0;
      i18 = 0;
      do {
       i10 = HEAP32[i36 + 296 + (i18 << 2) >> 2] | 0;
       L13 : do if (!(HEAP8[i10 + 48 >> 0] | 0)) i4 = (HEAP32[i10 + 60 >> 2] | 0) + i4 | 0; else {
        i5 = HEAP32[i10 + 4 >> 2] | 0;
        i11 = HEAP32[(HEAP32[i26 >> 2] | 0) + 4 + (i5 << 2) >> 2] | 0;
        i12 = i10 + 52 | 0;
        i13 = HEAP32[(i19 ? i12 : i10 + 68 | 0) >> 2] | 0;
        i14 = i10 + 36 | 0;
        i15 = Math_imul(HEAP32[i10 + 64 >> 2] | 0, i2) | 0;
        i16 = i10 + 56 | 0;
        i7 = HEAP32[i16 >> 2] | 0;
        if ((i7 | 0) > 0) {
         i6 = HEAP32[i14 >> 2] | 0;
         i17 = i10 + 72 | 0;
         if ((i13 | 0) <= 0) {
          i6 = HEAP32[i12 >> 2] | 0;
          i5 = 0;
          while (1) {
           i4 = i6 + i4 | 0;
           i5 = i5 + 1 | 0;
           if ((i5 | 0) >= (i7 | 0)) break L13;
          }
         }
         i8 = (HEAP32[i27 + (i5 << 2) >> 2] | 0) + ((Math_imul(i6, i20) | 0) << 2) | 0;
         i9 = 0;
         i5 = i7;
         i3 = i6;
         while (1) {
          if ((HEAP32[i1 >> 2] | 0) >>> 0 < i32 >>> 0) {
           i5 = 0;
           i6 = i15;
           i33 = 19;
          } else if ((i9 + i20 | 0) < (HEAP32[i17 >> 2] | 0)) {
           i5 = 0;
           i6 = i15;
           i33 = 19;
          }
          if ((i33 | 0) == 19) {
           while (1) {
            i33 = 0;
            mftCall_viiiii(i11 | 0, i36 | 0, i10 | 0, HEAP32[i30 + 32 + (i5 + i4 << 2) >> 2] | 0, i8 | 0, i6 | 0);
            i3 = HEAP32[i14 >> 2] | 0;
            i5 = i5 + 1 | 0;
            if ((i5 | 0) == (i13 | 0)) break; else {
             i6 = i3 + i6 | 0;
             i33 = 19;
            }
           }
           i5 = HEAP32[i16 >> 2] | 0;
          }
          i4 = (HEAP32[i12 >> 2] | 0) + i4 | 0;
          i9 = i9 + 1 | 0;
          if ((i9 | 0) >= (i5 | 0)) break; else i8 = i8 + (i3 << 2) | 0;
         }
         i3 = HEAP32[i25 >> 2] | 0;
        }
       } while (0);
       i18 = i18 + 1 | 0;
      } while ((i18 | 0) < (i3 | 0));
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 <= i31 >>> 0);
    i3 = HEAP32[i29 >> 2] | 0;
   }
   HEAP32[i21 >> 2] = 0;
   i2 = i20 + 1 | 0;
   if ((i2 | 0) < (i3 | 0)) {
    i20 = i2;
    i2 = 0;
   } else {
    i33 = 26;
    break;
   }
  }
  if ((i33 | 0) == 26) {
   i3 = HEAP32[i34 >> 2] | 0;
   break;
  }
  HEAP32[i28 >> 2] = i20;
  HEAP32[i21 >> 2] = i2;
  i36 = 0;
  return i36 | 0;
 } else i1 = i36 + 128 | 0; while (0);
 i4 = i36 + 136 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i4;
 if (i4 >>> 0 >= i3 >>> 0) {
  mftCall_vi(HEAP32[(HEAP32[i36 + 400 >> 2] | 0) + 12 >> 2] | 0, i36 | 0);
  i36 = 4;
  return i36 | 0;
 }
 i2 = HEAP32[i35 >> 2] | 0;
 do if ((HEAP32[i36 + 292 >> 2] | 0) > 1) HEAP32[i2 + 28 >> 2] = 1; else {
  i1 = HEAP32[i36 + 296 >> 2] | 0;
  if (i4 >>> 0 < (i3 + -1 | 0) >>> 0) {
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 i36 = 3;
 return i36 | 0;
}

function __ZN5Unity5Cloth18ApplyConfigurationEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = i4 + 36 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 722, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
 } else if (f2 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 723, 1, 0, 0, 0);
  f2 = Math_fround(1.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i5 = i4 + 228 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i3 | 0, i1 | 0, 3);
  HEAPF32[i3 >> 2] = f2;
  i1 = HEAP32[i5 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i1 | 0, 3, i3 | 0);
 }
 __ZN5Unity5Cloth22SetStretchingStiffnessEf(i4, Math_fround(HEAPF32[i4 + 40 >> 2]));
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if (!(HEAP8[i4 + 44 >> 0] | 0)) f2 = Math_fround(0.0); else f2 = HEAP8[i4 + 359 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 268 >> 2] | 0, i1 | 0, i3 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 2, (HEAP8[i4 + 45 >> 0] | 0) == 0 | 0);
 }
 i1 = i4 + 48 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 765, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
 } else if (f2 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 766, 1, 0, 0, 0);
  f2 = Math_fround(1.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1) {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0;
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i3 + 4 >> 2] = f2;
  HEAPF32[i3 + 8 >> 2] = f2;
  mftCall_vii(i7 | 0, i1 | 0, i3 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   f2 = Math_fround(HEAPF32[i4 + 80 >> 2]);
   mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0, +f2);
  }
 }
 i1 = i4 + 84 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 821, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
 } else if (f2 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 822, 1, 0, 0, 0);
  f2 = Math_fround(1.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, i1 | 0, +f2);
 i1 = i4 + 88 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 832, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 380 >> 2] | 0, i1 | 0, +f2);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 2, (HEAP8[i4 + 92 >> 0] | 0) != 0 | 0);
 }
 __ZN5Unity5Cloth22SetUseVirtualParticlesEb(i4, (HEAP8[i4 + 93 >> 0] | 0) != 0);
 i1 = i4 + 120 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838940 | 0, 0, gb + 838562 | 0, 873, 1, 0, 0, 0);
  f2 = Math_fround(1.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0, +f2);
 i1 = i4 + 124 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 883, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 452 >> 2] | 0, i1 | 0, +f2);
 STACKTOP = i6;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i20 = i10 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i10 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i10 + 12 | 0;
 i23 = i7 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i10 + 20 | 0;
 i21 = i7 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i2 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i2;
 HEAP8[i22 >> 0] = i20;
 i22 = i7 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i2 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i21;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i19;
 i2 = i18;
 HEAP32[i2 >> 2] = i17;
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 65;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __Z14OutputPolymeshP14TESStesselatorP8TESSmeshiii(i9, i10, i8, i14, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0;
 if ((i14 | 0) > 3) if (!(__Z24tessMeshMergeConvexFacesP8TESSmeshi(i10, i14) | 0)) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i10 | 0)) do {
  HEAP32[i1 + 36 >> 2] = -1;
  i1 = HEAP32[i1 >> 2] | 0;
 } while ((i1 | 0) != (i10 | 0));
 i13 = i10 + 44 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = 0;
  i3 = 0;
  do {
   i6 = i1 + 16 | 0;
   HEAP32[i6 >> 2] = -1;
   if (HEAP8[i1 + 21 >> 0] | 0) {
    i7 = HEAP32[i1 + 8 >> 2] | 0;
    i5 = i7;
    do {
     i4 = (HEAP32[i5 + 16 >> 2] | 0) + 36 | 0;
     if ((HEAP32[i4 >> 2] | 0) == -1) {
      HEAP32[i4 >> 2] = i2;
      i2 = i2 + 1 | 0;
     }
     i5 = HEAP32[i5 + 12 >> 2] | 0;
    } while ((i5 | 0) != (i7 | 0));
    HEAP32[i6 >> 2] = i3;
    i3 = i3 + 1 | 0;
   }
   i1 = HEAP32[i1 >> 2] | 0;
  } while ((i1 | 0) != (i13 | 0));
  i1 = i3;
 }
 HEAP32[i9 + 100 >> 2] = i1;
 i7 = (i8 | 0) == 1;
 i3 = i9 + 104 | 0;
 i4 = i9 + 116 | 0;
 i12 = i14 << 2;
 i8 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, Math_imul(i12, i1 << (i7 & 1)) | 0) | 0;
 i6 = i9 + 96 | 0;
 HEAP32[i6 >> 2] = i8;
 if (!i8) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 }
 i1 = i9 + 92 | 0;
 HEAP32[i1 >> 2] = i2;
 i8 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, Math_imul(i11 << 2, i2) | 0) | 0;
 i5 = i9 + 84 | 0;
 HEAP32[i5 >> 2] = i8;
 if (!i8) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 }
 i3 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
 HEAP32[i9 + 88 >> 2] = i3;
 if (!i3) {
  HEAP32[i9 + 4 >> 2] = 1;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i10 | 0)) if ((i11 | 0) > 2) do {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i9 = Math_imul(i2, i11) | 0;
   i9 = (HEAP32[i5 >> 2] | 0) + (i9 << 2) | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i1 + 40 >> 2];
  }
  i1 = HEAP32[i1 >> 2] | 0;
 } while ((i1 | 0) != (i10 | 0)); else do {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i9 = Math_imul(i2, i11) | 0;
   i9 = (HEAP32[i5 >> 2] | 0) + (i9 << 2) | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i1 + 40 >> 2];
  }
  i1 = HEAP32[i1 >> 2] | 0;
 } while ((i1 | 0) != (i10 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) == (i13 | 0)) return;
 if (!i7) {
  do {
   if (HEAP8[i2 + 21 >> 0] | 0) {
    i6 = HEAP32[i2 + 8 >> 2] | 0;
    i3 = 0;
    i4 = i6;
    while (1) {
     i5 = i1;
     i1 = i1 + 4 | 0;
     HEAP32[i5 >> 2] = HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + 36 >> 2];
     i5 = i3 + 1 | 0;
     i4 = HEAP32[i4 + 12 >> 2] | 0;
     if ((i4 | 0) == (i6 | 0)) break; else i3 = i5;
    }
    if ((i5 | 0) < (i14 | 0)) {
     _memset(i1 | 0, -1, i12 - (i5 << 2) | 0) | 0;
     i1 = i1 + (i14 << 2) + (~i3 << 2) | 0;
    }
   }
   i2 = HEAP32[i2 >> 2] | 0;
  } while ((i2 | 0) != (i13 | 0));
  return;
 }
 do {
  if (HEAP8[i2 + 21 >> 0] | 0) {
   i4 = i2 + 8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i7 = 0;
   i3 = i5;
   while (1) {
    i8 = i1;
    i1 = i1 + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + 36 >> 2];
    i8 = i7 + 1 | 0;
    i3 = HEAP32[i3 + 12 >> 2] | 0;
    if ((i3 | 0) == (i5 | 0)) break; else i7 = i8;
   }
   i6 = (i8 | 0) < (i14 | 0);
   if (i6) {
    _memset(i1 | 0, -1, i12 - (i8 << 2) | 0) | 0;
    i1 = i1 + (i14 << 2) + (~i7 << 2) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
   }
   i4 = i5;
   do {
    i3 = HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 20 >> 2] | 0;
    if (!i3) i3 = -1; else if (!(HEAP8[i3 + 21 >> 0] | 0)) i3 = -1; else i3 = HEAP32[i3 + 16 >> 2] | 0;
    i11 = i1;
    i1 = i1 + 4 | 0;
    HEAP32[i11 >> 2] = i3;
    i4 = HEAP32[i4 + 12 >> 2] | 0;
   } while ((i4 | 0) != (i5 | 0));
   if (i6) {
    _memset(i1 | 0, -1, i12 - (i8 << 2) | 0) | 0;
    i1 = i1 + (i14 << 2) + (~i7 << 2) | 0;
   }
  }
  i2 = HEAP32[i2 >> 2] | 0;
 } while ((i2 | 0) != (i13 | 0));
 return;
}

function __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426256 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898897 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426246 | 0, HEAP32[gb + 37300 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx15PxsParticleData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i10 >> 2] = HEAP32[gb + 126276 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 126276 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 126276 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 126276 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 126276 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 126276 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 126276 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 126276 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 748145;
 HEAP32[i9 + 4 >> 2] = gb + 748168;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 140;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 126308 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 126308 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 126308 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 126308 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 126308 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 126308 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 126308 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 126308 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 126340 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 126340 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 126340 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 126340 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 126340 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 126340 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 126340 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 126340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 126372 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 126372 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 126372 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 126372 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 126372 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 126372 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 126372 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 126372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 126404 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 126404 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 126404 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 126404 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 126404 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 126404 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 126404 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 126404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 126436 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 126436 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 126436 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 126436 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 126436 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 126436 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 126436 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 126436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 126468 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 126468 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 126468 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 126468 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 126468 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 126468 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 126468 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 126468 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu21intersectSphereConvexERKNS0_6SphereERKNS0_10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformEPNS_6PxVec3E(i7, i5, i6, i4, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3 + 464 | 0;
 i17 = i3 + 448 | 0;
 i11 = i3 + 480 | 0;
 i16 = i3 + 80 | 0;
 i15 = i3 + 64 | 0;
 i8 = i3 + 240 | 0;
 i9 = i3 + 96 | 0;
 i1 = i3;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 f2 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 i27 = HEAP32[i6 + 4 >> 2] | 0;
 i28 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i16 + 4 >> 2] = i27;
 HEAP32[i16 + 8 >> 2] = i28;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 i28 = i6 + 12 | 0;
 i27 = HEAP32[i28 + 4 >> 2] | 0;
 i26 = HEAP32[i28 + 8 >> 2] | 0;
 i6 = HEAP32[i28 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i15 + 4 >> 2] = i27;
 HEAP32[i15 + 8 >> 2] = i26;
 HEAP32[i15 + 12 >> 2] = i6;
 f20 = Math_fround(HEAPF32[i7 >> 2]);
 f22 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f21 = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
 f19 = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f23 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i4 + 16 >> 2]));
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i4 + 20 >> 2]));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f22 = Math_fround(f22 * Math_fround(2.0));
 f24 = Math_fround(Math_fround(f24 - Math_fround(HEAPF32[i4 + 24 >> 2])) * Math_fround(2.0));
 f25 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(f22 * f19)) + Math_fround(f24 * f12));
 f14 = Math_fround(Math_fround(f18 * f21) + Math_fround(Math_fround(f25 * f20) + Math_fround(f23 * Math_fround(Math_fround(f24 * f19) - Math_fround(f22 * f12)))));
 f13 = Math_fround(Math_fround(f18 * f19) + Math_fround(Math_fround(f25 * f22) + Math_fround(f23 * Math_fround(Math_fround(f20 * f12) - Math_fround(f24 * f21)))));
 f12 = Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f23 * Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f19)))) + Math_fround(f18 * f12));
 __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i8, i5 + 16 | 0, i17, i16, i15);
 i7 = i9 + 64 | 0;
 HEAP32[i9 + 80 >> 2] = 4;
 HEAPF32[i9 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = f14;
 HEAPF32[i9 + 4 >> 2] = f13;
 HEAPF32[i9 + 8 >> 2] = f12;
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 128 >> 2] = f2;
 i6 = i9 + 132 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAPF32[i9 + 96 >> 2] = f14;
 HEAPF32[i9 + 100 >> 2] = f13;
 HEAPF32[i9 + 104 >> 2] = f12;
 HEAPF32[i9 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 112 >> 2] = f14;
 HEAPF32[i9 + 116 >> 2] = f13;
 HEAPF32[i9 + 120 >> 2] = f12;
 HEAPF32[i9 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 16 >> 2] = f2;
 i6 = i9 + 20 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAPF32[i9 + 32 >> 2] = f2;
 i6 = i9 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i10 >> 2] = -1;
 HEAP32[i10 + 4 >> 2] = -1;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP32[i10 + 12 >> 2] = -1;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 if ((__ZN5physx2Gu8GJKLocalERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i9, i8, i3 + 48 | 0, i3 + 32 | 0, i3 + 16 | 0, i1) | 0) == 1) {
  i28 = 1;
  STACKTOP = i3;
  return i28 | 0;
 }
 f25 = Math_fround(f2 * f2);
 i28 = f25 >= Math_fround(HEAPF32[i1 >> 2]);
 STACKTOP = i3;
 return i28 | 0;
}

function __ZN5physx10getInverseERNS_7PxMat33ERNS_6PxVec3ERKS0_RKS2_(i24, i25, i1, i26) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f27 = f0, f28 = f0, f29 = f0;
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f13 = Math_fround(f12 * f21);
 f22 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f22 * f23));
 f14 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f15 = Math_fround(f22 * f14);
 f16 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(f21 * f16);
 f11 = Math_fround(f15 - f17);
 f18 = Math_fround(Math_fround(f23 * f16) - Math_fround(f12 * f14));
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f13 * f19);
 f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(f10 + Math_fround(f20 * f11));
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f18 * f10));
 if (f11 != Math_fround(0.0)) {
  f29 = Math_fround(Math_fround(1.0) / f11);
  f28 = Math_fround(f13 * f29);
  f27 = Math_fround(-Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f23 * f10)) * f29));
  f11 = Math_fround(Math_fround(Math_fround(f22 * f20) - Math_fround(f12 * f10)) * f29);
  f13 = Math_fround(-Math_fround(Math_fround(f17 - f15) * f29));
  f15 = Math_fround(Math_fround(Math_fround(f21 * f19) - Math_fround(f14 * f10)) * f29);
  f17 = Math_fround(-Math_fround(Math_fround(Math_fround(f22 * f19) - Math_fround(f16 * f10)) * f29));
  f21 = Math_fround(f18 * f29);
  f22 = Math_fround(-Math_fround(Math_fround(Math_fround(f23 * f19) - Math_fround(f14 * f20)) * f29));
  f23 = Math_fround(Math_fround(Math_fround(f12 * f19) - Math_fround(f16 * f20)) * f29);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i9 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = 1065353216;
  i2 = 0;
  i3 = 0;
  i4 = 1065353216;
  i5 = 0;
  i6 = 0;
  i7 = 0;
  i8 = 1065353216;
  i9 = 0;
 }
 f27 = Math_fround(-Math_fround(HEAPF32[i26 >> 2]));
 f22 = Math_fround(-Math_fround(HEAPF32[i26 + 4 >> 2]));
 f29 = Math_fround(-Math_fround(HEAPF32[i26 + 8 >> 2]));
 f20 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f27);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f27);
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f27);
 f23 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f22);
 f21 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f22);
 f23 = Math_fround(f20 + f23);
 f21 = Math_fround(f28 + f21);
 f22 = Math_fround(f27 + Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f22));
 f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f29);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f29);
 f28 = Math_fround(f21 + f28);
 f29 = Math_fround(f22 + Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f29));
 HEAPF32[i25 >> 2] = Math_fround(f23 + f27);
 HEAPF32[i25 + 4 >> 2] = f28;
 HEAPF32[i25 + 8 >> 2] = f29;
 HEAP32[i24 >> 2] = i4;
 HEAP32[i24 + 4 >> 2] = i5;
 HEAP32[i24 + 8 >> 2] = i6;
 HEAP32[i24 + 12 >> 2] = i7;
 HEAP32[i24 + 16 >> 2] = i8;
 HEAP32[i24 + 20 >> 2] = i9;
 HEAP32[i24 + 24 >> 2] = i3;
 HEAP32[i24 + 28 >> 2] = i2;
 HEAP32[i24 + 32 >> 2] = i1;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN24dtObstacleAvoidanceQuery6addBoxEPKfS1_S1_S1_S1_S1_(i19, i1, i2, i3, i4, i5, i21) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i21 = i21 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i24 + 288 | 0;
 i7 = i24 + 96 | 0;
 i22 = i24;
 i20 = i24 + 384 | 0;
 __Z27CalculateOrientedBoxCornersPfPKfS1_S1_S1_S1_(i18, i1, i2, i3, i4, i5);
 f12 = Math_fround(HEAPF32[i19 + 10424 >> 2]);
 f13 = Math_fround(f12 + Math_fround(HEAPF32[i19 + 10436 >> 2]));
 f14 = Math_fround(HEAPF32[i19 + 10420 >> 2]);
 f15 = Math_fround(HEAPF32[i19 + 10428 >> 2]);
 i17 = i19 + 10432 | 0;
 i18 = __Z37CalculateExpandedClippedBoxConvexHullPfS_PKffff(i7, i22, i18, f12, f13, Math_fround(HEAPF32[i17 >> 2])) | 0;
 i16 = i18 + -1 | 0;
 i5 = (i18 | 0) > 0;
 if (i5) {
  i1 = i16;
  i4 = 0;
 } else {
  STACKTOP = i24;
  return;
 }
 while (1) {
  i3 = i22 + (i1 << 1 << 2) | 0;
  i2 = i22 + (i4 << 1 << 2) | 0;
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  i2 = Math_fround(Math_fround(Math_fround(f14 - f11) * Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) - f6)) - Math_fround(Math_fround(f15 - f6) * Math_fround(f12 - f11))) <= Math_fround(0.0);
  i3 = i20 + i1 | 0;
  HEAP8[i3 >> 0] = i2 & 1;
  i9 = i1 << 2;
  i8 = i7 + (i9 << 2) | 0;
  i9 = i7 + ((i9 | 2) << 2) | 0;
  f11 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i9 >> 2]);
  f6 = Math_fround(f6 - f11);
  f10 = Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) - f12);
  f11 = Math_fround(f14 - f11);
  f12 = Math_fround(f15 - f12);
  f13 = Math_fround(Math_fround(f6 * f6) + Math_fround(f10 * f10));
  if (f13 == Math_fround(0.0)) f6 = Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)); else {
   f25 = Math_fround(Math_fround(Math_fround(f11 * f6) + Math_fround(f12 * f10)) / f13);
   i9 = f25 > Math_fround(1.0);
   i8 = f25 < Math_fround(0.0);
   f25 = i8 ? Math_fround(0.0) : f25;
   f25 = i9 ? Math_fround(1.0) : f25;
   f13 = Math_fround(Math_fround(f6 * f25) - f11);
   f6 = Math_fround(Math_fround(f10 * f25) - f12);
   f6 = Math_fround(Math_fround(f13 * f13) + Math_fround(f6 * f6));
  }
  HEAP8[i3 >> 0] = (i2 | f6 < Math_fround(.00250000018)) & 1;
  i1 = i4 + 1 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i9 = i4;
   i4 = i1;
   i1 = i9;
  }
 }
 if (!i5) {
  STACKTOP = i24;
  return;
 }
 i7 = i19 + 10452 | 0;
 i8 = i21 + 8 | 0;
 i9 = i19 + 10460 | 0;
 i3 = i16;
 i5 = 0;
 i4 = HEAP8[i20 + i16 >> 0] | 0;
 while (1) {
  i2 = i20 + i3 | 0;
  if (i4 << 24 >> 24) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) < 104) {
    HEAP32[i9 >> 2] = i1 + 1;
    i16 = i22 + (i3 << 1 << 2) | 0;
    HEAP32[i19 + 4992 + (i1 * 52 | 0) >> 2] = HEAP32[i16 >> 2];
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    i16 = i22 + (i5 << 1 << 2) | 0;
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 8 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 12 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 16 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 20 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i19 + 4992 + (i1 * 52 | 0) + 44 >> 2] = HEAP32[i17 >> 2];
    HEAPF32[i19 + 4992 + (i1 * 52 | 0) + 48 >> 2] = Math_fround(1.0);
   }
  }
  i4 = HEAP8[i20 + i5 >> 0] | 0;
  if (!(i4 << 24 >> 24)) {
   if (HEAP8[i2 >> 0] | 0) i23 = 14;
  } else i23 = 14;
  if ((i23 | 0) == 14) {
   i23 = 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) < 104) {
    HEAP32[i7 >> 2] = i1 + 1;
    i16 = i22 + (i5 << 1 << 2) | 0;
    HEAP32[i19 + (i1 * 24 | 0) >> 2] = HEAP32[i16 >> 2];
    HEAP32[i19 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i19 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i21 >> 2];
    HEAP32[i19 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i19 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i17 >> 2];
    HEAPF32[i19 + (i1 * 24 | 0) + 20 >> 2] = Math_fround(1.0);
   }
  }
  i1 = i5 + 1 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i3 = i5;
   i5 = i1;
  }
 }
 STACKTOP = i24;
 return;
}

function __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i5 + 36 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i8 = i4 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 2);
  i1 = HEAP16[i6 >> 1] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i6 >> 1] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP16[i5 + 54 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 2);
  i2 = HEAP16[i6 >> 1] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i6 >> 1] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP16[i5 + 52 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i5 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i5 + 72 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i5 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i5 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 88 | 0, i4);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 92 | 0, i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i5 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i5 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i5 + 84 >> 2] = i1;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i4;
  HEAP32[i7 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 64 >> 0] = i1;
 i1 = i5 + 65 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z19RenderBasePassDepthRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERS2_I17PrePassRenderDataLj4EER17ShaderPassContext(i1, i22, i24, i25) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i28;
 i26 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 4;
 i3 = __Z12GetGfxDevicev() | 0;
 i27 = HEAP32[i1 + 1832 >> 2] | 0;
 i23 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, 2, 1, 0, 1, 0, 1) | 0;
 if (i23 | 0) mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 40 >> 2] | 0, i23 | 0, gb + 387937 | 0);
 __ZN7Texture13SetFilterModeEi(i23, 0);
 __ZN13RenderTexture6CreateEv(i23) | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i23, 0, -1, 0, 0);
 __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[i1 + 1888 >> 2] | 0, 6, i23);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(7, i2, Math_fround(1.0), 0, i25);
 __Z15gpu_time_samplev();
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, i1 + 1732 | 0);
 i20 = HEAP32[i22 + 12 >> 2] | 0;
 if (!i20) {
  HEAP32[gb + 1163232 >> 2] = i26;
  STACKTOP = i28;
  return i23 | 0;
 }
 i16 = i3 + 964 | 0;
 i17 = i3 + 968 | 0;
 i18 = i3 + 972 | 0;
 i19 = i3 + 976 | 0;
 i21 = i25 + 4 | 0;
 i11 = i3 + 608 | 0;
 i10 = 0;
 do {
  i5 = HEAP32[(HEAP32[i24 >> 2] | 0) + (i10 << 2) >> 2] | 0;
  i6 = HEAP32[i22 >> 2] | 0;
  i1 = i6 + (i5 << 5) | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i12 + 32 >> 2] | 0) + 36 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i13 = i6 + (i5 << 5) + 8 | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = HEAP32[i27 >> 2] | 0;
   i14 = HEAP32[(HEAP32[i4 + (i3 * 360 | 0) + 324 >> 2] | 0) + ((HEAPU16[i6 + (i5 << 5) + 18 >> 1] | 0) << 3) >> 2] | 0;
   f30 = Math_fround(HEAPF32[i4 + (i3 * 360 | 0) + 252 >> 2]);
   i15 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   f30 = Math_fround(Math_abs(Math_fround(f30)));
   f31 = Math_fround(f30 * Math_fround(16.0));
   i9 = f31 >= Math_fround(0.0);
   f29 = Math_fround(f31 + Math_fround(-.99999994));
   i9 = ~~(i9 ? f31 : f29);
   f29 = Math_fround(Math_fround(((i9 | 0) > 15 ? 15 : i9) | 0) * Math_fround(.0625));
   HEAPF32[i16 >> 2] = f30;
   HEAPF32[i17 >> 2] = f29;
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i19 >> 2] = Math_fround(0.0);
   switch (((i15 & 2147483647 | 0) == 0 ? 0 : i15 >> 31 | 1) | 0) {
   case 1:
    {
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & -12582913 | 8388608;
     break;
    }
   case -1:
    {
     HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & -12582913 | 4194304;
     break;
    }
   default:
    HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & -12582913;
   }
   i15 = i4 + (i3 * 360 | 0) + 176 | 0;
   HEAPF32[i11 >> 2] = HEAP32[i15 >> 2] & 4 | 0 ? Math_fround(-1.0) : Math_fround(1.0);
   i7 = HEAP32[(HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i8 = HEAP32[i7 + 20 >> 2] | 0;
   if ((i8 | 0) > 0) {
    i9 = i4 + (i3 * 360 | 0) | 0;
    i4 = i4 + (i3 * 360 | 0) + 332 | 0;
    i3 = i6 + (i5 << 5) + 14 | 0;
    i2 = 0;
    do {
     i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     if ((HEAP32[i1 + 696 >> 2] | 0) == 6) {
      i1 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i14, i25, i12, i1, i2, 1, 0, 0) | 0;
      if (i1 | 0) {
       __Z17SetupObjectMatrixRK10Matrix4x4fi(i9, HEAP32[i15 >> 2] | 0);
       mftCall_viiii(HEAP32[i4 >> 2] | 0, i27 | 0, HEAP32[i13 >> 2] | 0, i1 | 0, HEAPU16[i3 >> 1] | 0 | 0);
      }
     }
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i8 | 0));
   }
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i20 | 0));
 HEAP32[gb + 1163232 >> 2] = i26;
 STACKTOP = i28;
 return i23 | 0;
}

function __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 56 | 0;
 i7 = i14 + 16 | 0;
 i9 = i14 + 24 | 0;
 i10 = i14;
 i6 = i14 + 8 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i13 + 92 | 0;
   i2 = i13 + 16 | 0;
   i3 = i1;
   i4 = i2;
   i5 = i3 + 72 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   HEAP16[i1 + 72 >> 1] = HEAP16[i2 + 72 >> 1] | 0;
   i3 = i13 + 168 | 0;
   i2 = i13 + 376 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i8 = i3;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   break;
  }
 case 1:
  {
   i1 = i13 + 92 | 0;
   i2 = i13 + 212 | 0;
   i3 = i1;
   i4 = i2;
   i5 = i3 + 72 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   HEAP16[i1 + 72 >> 1] = HEAP16[i2 + 72 >> 1] | 0;
   i3 = i13 + 168 | 0;
   i2 = i13 + 288 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i8 = i3;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   break;
  }
 default:
  {
   i3 = i13 + 168 | 0;
   i2 = i3;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
 }
 HEAP8[i13 + 208 >> 0] = 1;
 i8 = i13 + 336 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i5, 0, i11);
 if (HEAP32[i13 + 168 >> 2] | 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i4 = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i13 + 128 | 0;
  i1 = HEAP32[gb + 1451148 >> 2] | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   if (HEAP8[i1 + 135 >> 0] | 0) {
    i10 = i7;
    HEAP32[i10 >> 2] = i3;
    HEAP32[i10 + 4 >> 2] = i4;
    HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i6, i11, 1, gb + 1451100 | 0);
   }
  } else if (HEAP8[i1 + 134 >> 0] | 0) {
   i1 = 0;
   do {
    i2 = __ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[i13 + 92 + (i1 << 2) >> 2] | 0) | 0;
    HEAP32[i9 + (i1 << 2) >> 2] = i2 ? 0 : i1 + 36064 | 0;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while (i1 >>> 0 < i2 >>> 0);
   i7 = i10;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = i4;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i6, i11, i2, i9);
  }
 }
 i1 = i13 + 176 | 0;
 i2 = i13 + 296 | 0;
 i3 = i13 + 180 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i13 + 300 >> 2] | 0)) if ((HEAP32[i13 + 184 >> 2] | 0) == (HEAP32[i13 + 304 >> 2] | 0)) {
  if ((HEAP32[i13 + 188 >> 2] | 0) != (HEAP32[i13 + 308 >> 2] | 0)) i12 = 18;
 } else i12 = 18; else i12 = 18; else i12 = 18;
 if ((i12 | 0) == 18) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 172 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i13 + 184 >> 2] | 0, HEAP32[i13 + 188 >> 2] | 0);
 }
 i1 = i13 + 192 | 0;
 i2 = i13 + 312 | 0;
 i3 = i13 + 196 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i13 + 316 >> 2] | 0)) if ((HEAP32[i13 + 200 >> 2] | 0) == (HEAP32[i13 + 320 >> 2] | 0)) if ((HEAP32[i13 + 204 >> 2] | 0) == (HEAP32[i13 + 324 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i13 + 200 >> 2] | 0, HEAP32[i13 + 204 >> 2] | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN5physx2Sn20SerializationContext17registerReferenceERNS_6PxBaseEjj(i12, i9, i14, i15) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 16 | 0;
 i7 = i16 + 36 | 0;
 i8 = i16;
 i1 = i16 + 32 | 0;
 i11 = i16 + 24 | 0;
 i2 = i12 + 180 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 L1 : do if (!i3) i10 = 15; else if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i9 | 0) | 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, i9 | 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = HEAP32[i12 + 24 >> 2] | 0;
  L4 : do if (i1 | 0) {
   i4 = _i64Add(i5 | 0, i6 | 0, -1, ~i5 | 0) | 0;
   i3 = getTempRet0() | 0;
   i2 = _bitshift64Lshr(i4 | 0, i3 | 0, 22) | 0;
   i4 = i2 ^ i4;
   i3 = (getTempRet0() | 0) ^ i3;
   i2 = _bitshift64Shl(i4 | 0, i3 | 0, 13) | 0;
   i2 = _i64Add(i4 | 0, i3 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i3 = getTempRet0() | 0;
   i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 8) | 0;
   i3 = ___muldi3(i4 ^ i2 | 0, (getTempRet0() | 0) ^ i3 | 0, 9, 0) | 0;
   i2 = getTempRet0() | 0;
   i4 = _bitshift64Lshr(i3 | 0, i2 | 0, 15) | 0;
   i3 = i4 ^ i3;
   i2 = (getTempRet0() | 0) ^ i2;
   i4 = _bitshift64Shl(i3 | 0, i2 | 0, 27) | 0;
   i4 = _i64Add(i3 | 0, i2 | 0, ~i4 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i2 = getTempRet0() | 0;
   i3 = _bitshift64Lshr(i4 | 0, i2 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i2;
   i1 = HEAP32[(HEAP32[i12 + 16 >> 2] | 0) + (((i3 ^ i4) & i1 + -1) << 2) >> 2] | 0;
   if ((i1 | 0) != -1) {
    i4 = HEAP32[i12 + 8 >> 2] | 0;
    i3 = i12 + 12 | 0;
    while (1) {
     i2 = i4 + (i1 << 4) | 0;
     i17 = i2;
     if ((HEAP32[i17 >> 2] | 0) == (i5 | 0) ? (HEAP32[i17 + 4 >> 2] | 0) == (i6 | 0) : 0) break;
     i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     if ((i1 | 0) == -1) break L4;
    }
    if (i2 | 0) {
     i3 = -2147483648;
     i2 = HEAP32[i4 + (i1 << 4) + 8 >> 2] | 0;
     break L1;
    }
   }
  } while (0);
  i3 = i12 + 44 | 0;
  i4 = i12 + 48 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i13;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i6;
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE6createERS4_Rb(i12 + 4 | 0, i13, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) {
   i17 = i1;
   HEAP32[i17 >> 2] = i5;
   HEAP32[i17 + 4 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i2;
  }
  i1 = HEAP16[i9 + 4 >> 1] | 0;
  i17 = i8;
  HEAP32[i17 >> 2] = i5;
  HEAP32[i17 + 4 >> 2] = i6;
  HEAP16[i8 + 8 >> 1] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i12 + 52 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i3 = (HEAP32[i3 >> 2] | 0) + (i1 << 4) | 0;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i3 = -2147483648;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_2Sn15ImportReferenceENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
   i3 = -2147483648;
   break;
  }
 } else i10 = 15; while (0);
 if ((i10 | 0) == 15) {
  HEAP32[i1 >> 2] = i9;
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS7_Rb(i12 + 136 | 0, i1, i13) | 0;
  if (!(HEAP8[i13 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = 0;
  i2 = i1;
 }
 HEAP32[i11 >> 2] = i15;
 HEAP32[i11 + 4 >> 2] = i14;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS5_Rb((i14 | 0) < 0 ? i12 + 56 | 0 : i12 + 96 | 0, i11, i13) | 0;
 if (!(HEAP8[i13 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i15;
  HEAP32[i1 + 4 >> 2] = i14;
  i17 = i1 + 8 | 0;
  HEAP32[i17 >> 2] = -1;
  i15 = i3 | i2;
  HEAP32[i17 >> 2] = i15;
  STACKTOP = i16;
  return;
 } else {
  i17 = i1 + 8 | 0;
  i15 = i3 | i2;
  HEAP32[i17 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = HEAP32[i10 >> 2] | 0;
 i7 = i11;
 i11 = i11 + ((HEAP32[i2 >> 2] | 0) - i7 >> 6 << 6) | 0;
 i13 = i10 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = i10 + 8 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i3 = i2;
 i5 = i12;
 if (i2 >>> 0 < i12 >>> 0) {
  if ((i11 | 0) == (i2 | 0)) {
   __ZN14AnimationEventC2ERKS_(i11, i1);
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 64;
   i14 = i11;
   STACKTOP = i15;
   return i14 | 0;
  }
  i5 = i3 - (i11 + 64) >> 6;
  i3 = i11 + (i5 << 6) | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   i4 = i3;
   i6 = i2;
   do {
    __ZN14AnimationEventC2ERKS_(i6, i4);
    i4 = i4 + 64 | 0;
    i6 = (HEAP32[i13 >> 2] | 0) + 64 | 0;
    HEAP32[i13 >> 2] = i6;
   } while (i4 >>> 0 < i2 >>> 0);
  }
  if (i5 | 0) do {
   i2 = i2 + -64 | 0;
   i3 = i3 + -64 | 0;
   __ZN14AnimationEventaSERKS_(i2, i3) | 0;
  } while ((i3 | 0) != (i11 | 0));
  if (i11 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i13 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 64 | 0 : i1;
  __ZN14AnimationEventaSERKS_(i11, i1) | 0;
  i14 = i11;
  STACKTOP = i15;
  return i14 | 0;
 }
 i12 = i10 + 12 | 0;
 i9 = i3 - i7 | 0;
 i6 = (i9 >> 6) + 1 | 0;
 if ((i9 | 0) < -64) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i9 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = i4;
  i2 = i5;
  i3 = i7;
 }
 i4 = i2 - i3 | 0;
 i7 = i4 >> 5;
 i7 = i4 >> 6 >>> 0 < 1073741823 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 2147483647;
 i4 = i11 - i3 | 0;
 i5 = i4 >> 6;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = 25;
  HEAP32[i14 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 6, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i8 + (i5 << 6) | 0;
 i2 = i6;
 i3 = i8 + (i7 << 6) | 0;
 do if ((i5 | 0) == (i7 | 0)) {
  if ((i4 | 0) > 0) {
   i2 = i6 + (((i7 + 1 | 0) / -2 | 0) << 6) | 0;
   break;
  }
  i3 = i7 << 6 >> 5;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i7 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = 25;
  HEAP32[i14 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 6, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i7 + (i3 >>> 2 << 6) | 0;
  i3 = i7 + (i3 << 6) | 0;
  if (i8) {
   i7 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 >> 2] = 25;
   HEAP32[i14 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i14);
  }
 } while (0);
 i4 = i2;
 __ZN14AnimationEventC2ERKS_(i4, i1);
 i1 = i4 + 64 | 0;
 i4 = i1;
 i8 = i2;
 i7 = HEAP32[i10 >> 2] | 0;
 if ((i7 | 0) == (i11 | 0)) i5 = i8; else {
  i6 = i11;
  i5 = i8;
  do {
   i6 = i6 + -64 | 0;
   __ZN14AnimationEventC2ERKS_(i5 + -64 | 0, i6);
   i5 = i2 + -64 | 0;
   i2 = i5;
  } while ((i6 | 0) != (i7 | 0));
 }
 i6 = HEAP32[i13 >> 2] | 0;
 if ((i6 | 0) == (i11 | 0)) {
  i1 = i5;
  i2 = i11;
 } else {
  i5 = i11;
  do {
   __ZN14AnimationEventC2ERKS_(i1, i5);
   i5 = i5 + 64 | 0;
   i1 = i4 + 64 | 0;
   i4 = i1;
  } while ((i5 | 0) != (i6 | 0));
  i1 = i2;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i5 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i9 >> 2] = i3;
 if ((i2 | 0) != (i5 | 0)) {
  i3 = i14 + 4 | 0;
  i4 = i14 + 4 | 0;
  do {
   i1 = i2 + -44 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i3 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
   }
   i1 = i2 + -60 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
   }
   i2 = i2 + -64 | 0;
  } while ((i2 | 0) != (i5 | 0));
 }
 if (!i5) {
  i14 = i8;
  STACKTOP = i15;
  return i14 | 0;
 }
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i14 >> 2] = 25;
 HEAP32[i14 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i14);
 i14 = i8;
 STACKTOP = i15;
 return i14 | 0;
}

function __Z30scripting_stack_trace_info_forP15Il2CppExceptionR14StackTraceInfo(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 284 | 0;
 i9 = i11 + 272 | 0;
 i2 = i11 + 268 | 0;
 i4 = i11 + 264 | 0;
 i7 = i11 + 260 | 0;
 i5 = i11 + 8 | 0;
 i3 = i11;
 i6 = i11 + 248 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 if (HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 428 >> 2] | 0) {
  i14 = (__Z23GetCoreScriptingClassesv() | 0) + 428 | 0;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i3;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = i13;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i10);
  __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i5, i1);
  __ZN18ScriptingArguments12AddOutObjectEPP12Il2CppObject(i5, i4);
  __ZN18ScriptingArguments12AddOutObjectEPP12Il2CppObject(i5, i7);
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i2, 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i13 = _il2cpp_class_get_name(_il2cpp_object_get_class(i1 | 0) | 0) | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i13, _strlen(i13) | 0);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i13 = i6 + 11 | 0;
   i14 = HEAP8[i13 >> 0] | 0;
   i14 = i14 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i14 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, gb + 463808 | 0, 78, i14 + 78 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, (HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i14) | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   i14 = HEAP8[i5 + 11 >> 0] | 0;
   i13 = i14 << 24 >> 24 < 0;
   i14 = i13 ? HEAP32[i5 + 4 >> 2] | 0 : i14 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i10, i13 ? HEAP32[i5 >> 2] | 0 : i5, i14, i14 + 46 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, gb + 463887 | 0, 46) | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 463578 | 0, 495, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i11;
   return;
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  __Z24scripting_cpp_string_forP12Il2CppString(i10, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  __Z24scripting_cpp_string_forP12Il2CppString(i10, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __Z21PostprocessStacktracePKcRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + 12 | 0, i10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + 24 | 0, i9) | 0;
 HEAP32[i8 + 36 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i8 + 40 | 0, gb + 463934 | 0) | 0;
 HEAP32[i8 + 52 >> 2] = -1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i11;
 return;
}

function __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i11, i1, i8, i9, i10, i4, i2, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i5 = (i2 | 0) < 0;
 if (i5) i6 = 3; else if ((i3 | 0) < (i9 | 0) & ((i2 | 0) < (i8 | 0) & (i3 | 0) > -1)) i5 = i2; else i6 = 3;
 do if ((i6 | 0) == 3) {
  if (i4 | 0) {
   if ((i8 | 0) < 1) i2 = 0; else {
    i4 = i8 + -1 | 0;
    if (i5) i2 = 0; else i2 = (i4 | 0) < (i2 | 0) ? i4 : i2;
   }
   if ((i9 | 0) < 1) {
    i5 = i2;
    i3 = 0;
    break;
   }
   i4 = i9 + -1 | 0;
   if ((i3 | 0) < 0) {
    i5 = i2;
    i3 = 0;
    break;
   }
   i5 = i2;
   i3 = (i4 | 0) < (i3 | 0) ? i4 : i3;
   break;
  }
  if (!i8) i2 = 0; else {
   if (i5) i2 = (Math_imul(1 - ((i2 | 0) / (i8 | 0) | 0) | 0, i8) | 0) + i2 | 0;
   i2 = (i2 | 0) % (i8 | 0) | 0;
  }
  if (!i9) {
   i5 = i2;
   i3 = 0;
  } else {
   if ((i3 | 0) < 0) i3 = (Math_imul(1 - ((i3 | 0) / (i9 | 0) | 0) | 0, i9) | 0) + i3 | 0;
   i5 = i2;
   i3 = (i3 | 0) % (i9 | 0) | 0;
  }
 } while (0);
 i4 = (i10 + -10 | 0) >>> 0 < 3;
 do if (i4) i6 = 23; else if (((i10 | 1) + -25 | 0) >>> 0 < 5) i6 = 23; else {
  i2 = i10 + -30 | 0;
  if (i2 >>> 0 < 15) if ((i10 + -48 | 0) >>> 0 < 12 | ((i10 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
   i6 = 23;
   break;
  } else {
   i6 = 30;
   break;
  } else if ((i10 + -45 | 0) >>> 0 < 3 | (i10 + -48 | 0) >>> 0 < 12) {
   i6 = 23;
   break;
  } else {
   i6 = 30;
   break;
  }
 } while (0);
 L31 : do if ((i6 | 0) == 23) {
  switch (i10 | 0) {
  case 10:
  case 11:
  case 12:
  case 26:
  case 27:
   break;
  default:
   {
    i2 = i10 | 1;
    if ((i2 | 0) != 25) if (i4 | (i2 + -25 | 0) >>> 0 < 5) break L31; else {
     i6 = 30;
     break L31;
    }
   }
  }
  __ZL19HandleDecompressionPKhii13TextureFormatiiii(i7, i1, i8, i9, i10, i5, i3, 1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i2 + (((i5 | 0) % (i1 | 0) | 0) << 2) + ((Math_imul((i3 | 0) % (i1 | 0) | 0, i1) | 0) << 2) | 0;
  if (!(HEAP8[i7 + 12 >> 0] | 0)) {
   i10 = HEAP8[i1 >> 0] | 0;
   i7 = HEAP8[i1 + 1 >> 0] | 0;
   i8 = HEAP8[i1 + 2 >> 0] | 0;
   i9 = HEAP8[i1 + 3 >> 0] | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
   f15 = Math_fround(Math_fround(i7 & 255) / Math_fround(255.0));
   f14 = Math_fround(Math_fround(i8 & 255) / Math_fround(255.0));
   f13 = Math_fround(Math_fround(i9 & 255) / Math_fround(255.0));
   HEAPF32[i11 >> 2] = Math_fround(Math_fround(i10 & 255) / Math_fround(255.0));
   HEAPF32[i11 + 4 >> 2] = f15;
   HEAPF32[i11 + 8 >> 2] = f14;
   HEAPF32[i11 + 12 >> 2] = f13;
  } else {
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   i9 = HEAP32[i1 + 8 >> 2] | 0;
   i10 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 + 4 >> 2] = i8;
   HEAP32[i11 + 8 >> 2] = i9;
   HEAP32[i11 + 12 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
  }
  STACKTOP = i12;
  return;
 } while (0);
 do if ((i6 | 0) == 30) {
  i2 = i10 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i10 + -48 | 0) >>> 0 < 12 | ((i10 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
  } else if ((i10 + -45 | 0) >>> 0 < 3 | (i10 + -48 | 0) >>> 0 < 12) break;
  i4 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i8, i10) | 0;
  if (!i1) i6 = 38; else {
   if ((i10 | 0) < 9) i2 = 1; else i2 = (i10 | 0) == 1e3 | ((i10 | 0) == 23 | (i10 + -13 | 0) >>> 0 < 9);
   if (!((i8 | 0) > 0 & (i9 | 0) > 0 & (i10 | 0) > 0 & i2)) i6 = 38;
  }
  if ((i6 | 0) == 38) i1 = 0;
  i9 = i1 + (Math_imul(i4, i3) | 0) | 0;
  __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i9 + (Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i10) | 0, i5) | 0) | 0, i10, i11);
  STACKTOP = i12;
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1649, 1, 0, 0, 0);
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i18 = i3 + 4 | 0;
 i6 = i1 + 72 + (i6 << 2) | 0;
 i16 = HEAP32[i6 >> 2] | 0;
 i18 = (HEAP32[i18 >> 2] | 0) + i18 | 0;
 f9 = Math_fround(HEAPF32[i18 + (i16 * 40 | 0) >> 2]);
 f11 = Math_fround(HEAPF32[i18 + (i16 * 40 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i18 + (i16 * 40 | 0) + 8 >> 2]);
 i5 = i1 + 72 + (i5 << 2) | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i18 + (i12 * 40 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i18 + (i12 * 40 | 0) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i18 + (i12 * 40 | 0) + 8 >> 2]);
 i8 = i2 + 4 | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
 f23 = Math_fround(HEAPF32[i8 + (i12 * 40 | 0) >> 2]);
 f20 = Math_fround(HEAPF32[i8 + (i12 * 40 | 0) + 4 >> 2]);
 f19 = Math_fround(f19 - f9);
 f13 = Math_fround(f13 - f11);
 f21 = Math_fround(f21 - f10);
 f9 = Math_fround(f23 - f9);
 f11 = Math_fround(f20 - f11);
 f10 = Math_fround(Math_fround(HEAPF32[i8 + (i12 * 40 | 0) + 8 >> 2]) - f10);
 f20 = Math_fround(Math_fround(f19 * f11) - Math_fround(f13 * f9));
 f23 = Math_fround(Math_fround(f13 * f10) - Math_fround(f21 * f11));
 f14 = Math_fround(Math_fround(f21 * f9) - Math_fround(f19 * f10));
 f10 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f21 * f21) + Math_fround(0.0))) * Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f19 * f9) + Math_fround(f13 * f11)) + Math_fround(Math_fround(f21 * f10) + Math_fround(0.0))));
 i12 = i18 + (i16 * 40 | 0) + 12 | 0;
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f11 = Math_fround(f21 * f14);
 i8 = i18 + (i16 * 40 | 0) + 24 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(f13 * f10);
 i7 = i18 + (i16 * 40 | 0) + 16 | 0;
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 f15 = Math_fround(f20 * f19);
 i2 = i18 + (i16 * 40 | 0) + 20 | 0;
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f22 * f10)) - Math_fround(f20 * f13)) - Math_fround(f23 * f19));
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f21 * f23)) - Math_fround(f20 * f22)) - Math_fround(f14 * f19));
 f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f14 * f22)) - Math_fround(f21 * f10)) - Math_fround(f23 * f13));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f19 * f10)) - Math_fround(f14 * f13));
 i16 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f13 = (HEAP32[tempDoublePtr >> 2] = i18 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f13 * f13);
 f11 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f11 * f11);
 f10 = (HEAP32[tempDoublePtr >> 2] = i16 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 + f14) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10))))));
 f11 = Math_fround(f14 * f11);
 f10 = Math_fround(f14 * f10);
 f9 = Math_fround(f14 * f9);
 HEAPF32[i12 >> 2] = Math_fround(f14 * f13);
 HEAPF32[i7 >> 2] = f11;
 HEAPF32[i2 >> 2] = f10;
 HEAPF32[i8 >> 2] = f9;
 i1 = i1 + 40 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 i7 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i8 | 0) == 0 ? 0 : i8 + i2 | 0, i3, i4, i7, i7);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i1 | 0) == 0 ? 0 : i1 + i2 | 0, i4, i3, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 return;
}

function __ZN18ProceduralMaterial19GetGeneratedTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 i2 = HEAP32[i1 + 124 >> 2] | 0;
 i6 = i1 + 128 | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i7 = i8 + 11 | 0;
 i5 = i8 + 4 | 0;
 i11 = i2;
 L4 : while (1) {
  i1 = HEAP32[i11 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i4 = HEAP32[i9 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 11;
   }
   if ((i12 | 0) == 9) i12 = 11;
   if ((i12 | 0) == 11) {
    i12 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   if (!i1) i12 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 20;
    }
   }
   if ((i12 | 0) == 18) i12 = 20;
   if ((i12 | 0) == 20) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
   }
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   i2 = _strlen(i1) | 0;
   i4 = HEAP8[i7 >> 0] | 0;
   if ((i2 | 0) == ((i4 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i4 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, i1, i2) | 0)) break L4;
  } while (0);
  i1 = i11 + 4 | 0;
  if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
   i1 = 0;
   i12 = 33;
   break;
  } else i11 = i1;
 }
 if ((i12 | 0) == 33) {
  STACKTOP = i13;
  return i1 | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 28; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 28; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 30;
  }
 }
 if ((i12 | 0) == 28) i12 = 30;
 if ((i12 | 0) == 30) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i11 >> 2] | 0) | 0;
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN20UnityConnectSettings8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i3 = i5 + 196 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047713 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 197 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041676 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 200 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041687 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 216 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041702 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041718 | 0, gb + 1041718 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN22CrashReportingSettings8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041741 | 0, gb + 1041741 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN23UnityPurchasingSettings8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041765 | 0, gb + 1041765 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN22UnityAnalyticsSettings8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 112 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041788 | 0, gb + 1041788 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN16UnityAdsSettings8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEbT0_S8_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i8 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i8 = 1;
   return i8 | 0;
  }
 case 3:
  {
   i6 = i8 + 4 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = i7 + -4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = (i1 | 0) < (i3 | 0);
   if ((i3 | 0) >= (i5 | 0)) {
    if (!i2) {
     i8 = 1;
     return i8 | 0;
    }
    HEAP32[i6 >> 2] = i1;
    HEAP32[i4 >> 2] = i3;
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i8 = 1;
     return i8 | 0;
    }
    HEAP32[i8 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
    i8 = 1;
    return i8 | 0;
   }
   if (i2) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = i5;
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i8 >> 2] = i3;
   HEAP32[i6 >> 2] = i5;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) >= (i5 | 0)) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i4 >> 2] = i5;
   i8 = 1;
   return i8 | 0;
  }
 case 4:
  {
   i6 = i8 + 4 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i5 = i8 + 8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = (i2 | 0) < (i3 | 0);
   do if ((i3 | 0) < (i1 | 0)) {
    if (i4) {
     HEAP32[i8 >> 2] = i2;
     HEAP32[i5 >> 2] = i1;
     i3 = i1;
     break;
    }
    HEAP32[i8 >> 2] = i3;
    HEAP32[i6 >> 2] = i1;
    if ((i2 | 0) < (i1 | 0)) {
     HEAP32[i6 >> 2] = i2;
     HEAP32[i5 >> 2] = i1;
     i3 = i1;
    } else i3 = i2;
   } else if (i4) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    if ((i2 | 0) < (i1 | 0)) {
     HEAP32[i8 >> 2] = i2;
     HEAP32[i6 >> 2] = i1;
    }
   } else i3 = i2; while (0);
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i5 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) >= (i1 | 0)) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) >= (i1 | 0)) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP32[i8 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   i8 = 1;
   return i8 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i8 = 1;
   return i8 | 0;
  }
 case 1:
 case 0:
  {
   i8 = 1;
   return i8 | 0;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   i1 = i8 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i6 = (i5 | 0) < (i3 | 0);
   do if ((i3 | 0) < (i4 | 0)) {
    if (i6) {
     HEAP32[i8 >> 2] = i5;
     HEAP32[i2 >> 2] = i4;
     i3 = i4;
     break;
    }
    HEAP32[i8 >> 2] = i3;
    HEAP32[i1 >> 2] = i4;
    if ((i5 | 0) < (i4 | 0)) {
     HEAP32[i1 >> 2] = i5;
     HEAP32[i2 >> 2] = i4;
     i3 = i4;
    } else i3 = i5;
   } else if (i6) {
    HEAP32[i1 >> 2] = i5;
    HEAP32[i2 >> 2] = i3;
    if ((i5 | 0) < (i4 | 0)) {
     HEAP32[i8 >> 2] = i5;
     HEAP32[i1 >> 2] = i4;
    }
   } else i3 = i5; while (0);
   i1 = i8 + 12 | 0;
   L13 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    while (1) {
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i5 | 0) < (i3 | 0)) {
      i4 = i6;
      while (1) {
       HEAP32[i4 >> 2] = i3;
       if ((i2 | 0) == (i8 | 0)) break;
       i4 = i2 + -4 | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) >= (i3 | 0)) break; else {
        i9 = i2;
        i2 = i4;
        i4 = i9;
       }
      }
      HEAP32[i2 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i7 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i3 = HEAP32[i6 >> 2] | 0;
     i9 = i6;
     i6 = i2;
     i2 = i9;
    }
   } while (0);
   i9 = i1 | i2;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN29InitialModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 do switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem7SetLoopEb(i2, f4 != Math_fround(0.0));
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem18SetSimulationSpeedEf(i2, f4);
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem13SetStartDelayEf(i2, f4);
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 772 >> 2] = f4;
   HEAP8[i3 + 778 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 692 | 0, i3 + 780 | 0, f4, HEAP16[i3 + 776 >> 1] | 0) | 0) & 1;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 1036 >> 2] = f4;
   HEAP8[i3 + 1042 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 956 | 0, i3 + 1044 | 0, f4, HEAP16[i3 + 1040 >> 1] | 0) | 0) & 1;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 1300 >> 2] = f4;
   HEAP8[i3 + 1306 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1220 | 0, i3 + 1308 | 0, f4, HEAP16[i3 + 1304 >> 1] | 0) | 0) & 1;
   return;
  }
 case 8:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 1564 >> 2] = f4;
   HEAP8[i3 + 1570 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1484 | 0, i3 + 1572 | 0, f4, HEAP16[i3 + 1568 >> 1] | 0) | 0) & 1;
   return;
  }
 case 9:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 1828 >> 2] = f4;
   HEAP8[i3 + 1834 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1748 | 0, i3 + 1836 | 0, f4, HEAP16[i3 + 1832 >> 1] | 0) | 0) & 1;
   return;
  }
 case 10:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 2092 >> 2] = f4;
   HEAP8[i3 + 2098 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 2012 | 0, i3 + 2100 | 0, f4, HEAP16[i3 + 2096 >> 1] | 0) | 0) & 1;
   return;
  }
 case 11:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 680 >> 0] = ~~f4;
   return;
  }
 case 12:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 681 >> 0] = ~~f4;
   return;
  }
 case 13:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 682 >> 0] = ~~f4;
   return;
  }
 case 14:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 683 >> 0] = ~~f4;
   return;
  }
 case 15:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 684 >> 0] = ~~f4;
   return;
  }
 case 16:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 685 >> 0] = ~~f4;
   return;
  }
 case 17:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 686 >> 0] = ~~f4;
   return;
  }
 case 18:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 687 >> 0] = ~~f4;
   return;
  }
 case 19:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 2540 >> 2] = f4;
   return;
  }
 case 20:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 44 >> 2] | 0;
   HEAPF32[i3 + 2356 >> 2] = f4;
   HEAP8[i3 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 2276 | 0, i3 + 2364 | 0, f4, HEAP16[i3 + 2360 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 } while (0);
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIiEEPiEEbT0_S5_T_(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 switch (i8 - i9 >> 2 | 0) {
 case 2:
  {
   i1 = i8 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i9 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   i6 = i9 + 4 | 0;
   i4 = i8 + -4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i3 = (i2 | 0) < (i1 | 0);
   if ((i1 | 0) >= (i5 | 0)) {
    if (!i3) {
     i9 = 1;
     return i9 | 0;
    }
    HEAP32[i6 >> 2] = i2;
    HEAP32[i4 >> 2] = i1;
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i9 = 1;
     return i9 | 0;
    }
    HEAP32[i9 >> 2] = i1;
    HEAP32[i6 >> 2] = i2;
    i9 = 1;
    return i9 | 0;
   }
   if (i3) {
    HEAP32[i9 >> 2] = i2;
    HEAP32[i4 >> 2] = i5;
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) >= (i5 | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i4 >> 2] = i5;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   i7 = i9 + 4 | 0;
   i6 = i9 + 8 | 0;
   i5 = i8 + -4 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i4 = (i3 | 0) < (i2 | 0);
   do if ((i2 | 0) < (i1 | 0)) {
    if (i4) {
     HEAP32[i9 >> 2] = i3;
     HEAP32[i6 >> 2] = i1;
     i2 = i1;
     break;
    }
    HEAP32[i9 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    if ((i3 | 0) < (i1 | 0)) {
     HEAP32[i7 >> 2] = i3;
     HEAP32[i6 >> 2] = i1;
     i2 = i1;
    } else i2 = i3;
   } else if (i4) {
    HEAP32[i7 >> 2] = i3;
    HEAP32[i6 >> 2] = i2;
    if ((i3 | 0) < (i1 | 0)) {
     HEAP32[i9 >> 2] = i3;
     HEAP32[i7 >> 2] = i1;
    }
   } else i2 = i3; while (0);
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i2 | 0) >= (i1 | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i7 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) >= (i1 | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_(i9, i9 + 4 | 0, i9 + 8 | 0, i9 + 12 | 0, i8 + -4 | 0, i1) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i2 = i9 + 8 | 0;
   i1 = i9 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i6 = (i5 | 0) < (i3 | 0);
   do if ((i3 | 0) < (i4 | 0)) {
    if (i6) {
     HEAP32[i9 >> 2] = i5;
     HEAP32[i2 >> 2] = i4;
     i3 = i4;
     break;
    }
    HEAP32[i9 >> 2] = i3;
    HEAP32[i1 >> 2] = i4;
    if ((i5 | 0) < (i4 | 0)) {
     HEAP32[i1 >> 2] = i5;
     HEAP32[i2 >> 2] = i4;
     i3 = i4;
    } else i3 = i5;
   } else if (i6) {
    HEAP32[i1 >> 2] = i5;
    HEAP32[i2 >> 2] = i3;
    if ((i5 | 0) < (i4 | 0)) {
     HEAP32[i9 >> 2] = i5;
     HEAP32[i1 >> 2] = i4;
    }
   } else i3 = i5; while (0);
   i1 = i9 + 12 | 0;
   L13 : do if ((i1 | 0) == (i8 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i1;
    i1 = 0;
    while (1) {
     i5 = HEAP32[i6 >> 2] | 0;
     if ((i5 | 0) < (i3 | 0)) {
      i4 = i6;
      while (1) {
       HEAP32[i4 >> 2] = i3;
       if ((i2 | 0) == (i9 | 0)) {
        i2 = i9;
        break;
       }
       i4 = i2 + -4 | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) >= (i3 | 0)) break; else {
        i7 = i2;
        i2 = i4;
        i4 = i7;
       }
      }
      HEAP32[i2 >> 2] = i5;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i6 + 4 | 0) == (i8 | 0);
       break L13;
      }
     }
     i2 = i6 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) {
      i2 = 1;
      i1 = 0;
      break L13;
     }
     i3 = HEAP32[i6 >> 2] | 0;
     i7 = i6;
     i6 = i2;
     i2 = i7;
    }
   } while (0);
   i9 = i1 | i2;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 32 | 0;
 i1 = i8 + 16 | 0;
 i2 = i8;
 i23 = HEAP32[i6 + 16 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 i22 = i23 + 4 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 i21 = i23 + 8 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i20 = i23 + 12 | 0;
 f13 = Math_fround(f14 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i23 + 16 | 0;
 f15 = Math_fround(f14 * Math_fround(HEAPF32[i19 >> 2]));
 i18 = i23 + 20 | 0;
 f13 = Math_fround(f11 + f13);
 f15 = Math_fround(f12 + f15);
 f14 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i17 = i23 + 24 | 0;
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 i16 = i23 + 28 | 0;
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 i3 = i23 + 32 | 0;
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i9 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i9 + 4 >> 2] = f11;
 HEAPF32[i9 + 8 >> 2] = f10;
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(f13 * Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2]));
 f14 = Math_fround(f11 + f14);
 f15 = Math_fround(f12 + f15);
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f14 + f12);
 HEAPF32[i1 + 4 >> 2] = f11;
 HEAPF32[i1 + 8 >> 2] = f10;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i23 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i22 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i21 >> 2]));
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(f14 * Math_fround(HEAPF32[i20 >> 2]));
 f15 = Math_fround(f14 * Math_fround(HEAPF32[i19 >> 2]));
 f13 = Math_fround(f11 + f13);
 f15 = Math_fround(f12 + f15);
 f14 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i18 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f14 + Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i2 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu20intersectTriangleBoxERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_(i6 + 144 | 0, i6 + 128 | 0, i9, i1, i2) | 0)) {
  i23 = 1;
  STACKTOP = i8;
  return i23 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i23 = 0;
  STACKTOP = i8;
  return i23 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i23 = 1;
  STACKTOP = i8;
  return i23 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i23 = 1;
  STACKTOP = i8;
  return i23 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i23 = 1;
  STACKTOP = i8;
  return i23 | 0;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 24 | 0;
 i4 = i5;
 i7 = i1 + 4 | 0;
 i6 = i2 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i8;
 i6 = i1 + 8 | 0;
 i8 = i2 + 8 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i7;
 i8 = i1 + 9 | 0;
 i7 = i2 + 9 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i7 = i1 + 12 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i4, i7);
 i6 = i2 + 12 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i7, i6);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i6, i4);
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i3);
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i7 = i1 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i4, i7);
 i8 = i2 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i7, i8);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i8, i4);
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i3);
 }
 i3 = i1 + 52 | 0;
 i7 = i2 + 52 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 i7 = i1 + 56 | 0;
 i8 = i2 + 56 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i3;
 i3 = i1 + 60 | 0;
 i6 = i2 + 60 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 f9 = Math_fround((HEAP32[i7 >> 2] | 0) >>> 0);
 HEAP32[i1 + 68 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i1 + 64 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i1 + 72 >> 0] = 0;
 f9 = Math_fround((HEAP32[i8 >> 2] | 0) >>> 0);
 HEAP32[i2 + 68 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 64 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 72 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __Z25GetAudioEffectDefinitionsPi(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  HEAP32[i14 >> 2] = 0;
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = __Z21GetManagerFromContexti(3) | 0;
 i15 = i1 + 240 | 0;
 i2 = i1 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if (!(i3 & 2147483647)) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 1024;
  HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, 4096, 4, i1 + 244 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 4, i1 + 244 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i1 + 252 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = 1024;
  HEAP32[i15 >> 2] = i13;
  break;
 } while (0);
 i13 = i15 + 12 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  do {
   i11 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   HEAP8[i11 + 5 >> 0] = (HEAP32[i11 + 8 >> 2] | 0) != 0 & 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if (__Z15PluginsGetCountv() | 0) {
  i9 = i15 + 16 | 0;
  i10 = i15 + 4 | 0;
  i8 = 0;
  do {
   HEAP32[i12 >> 2] = 0;
   i11 = __Z25GetAudioEffectDefinitionsjPPP26UnityAudioEffectDefinition(i8, i12) | 0;
   if (i11 | 0) {
    i7 = 0;
    do {
     i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i4 = HEAP32[i13 >> 2] | 0;
     L23 : do if (!i4) i1 = 0; else {
      i2 = HEAP32[i15 >> 2] | 0;
      i3 = i5 + 32 | 0;
      i1 = 0;
      do {
       if (!(_strcmp((HEAP32[HEAP32[i2 + (i1 << 2) >> 2] >> 2] | 0) + 128 | 0, i3) | 0)) break L23;
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < i4 >>> 0);
     } while (0);
     do if ((i1 | 0) == (i4 | 0)) {
      i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63328 | 0, 16, gb + 860370 | 0, 404) | 0;
      __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i1, i5, 0);
      i6 = i1;
      if (HEAP8[i1 + 4 >> 0] | 0) {
       if (i1 | 0) __ZN29AudioEffectInternalDefinitionD2Ev(i1);
       __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63328 | 0);
       break;
      }
      i2 = HEAP32[i13 >> 2] | 0;
      i3 = i2 + 1 | 0;
      i4 = HEAP32[i9 >> 2] | 0;
      i5 = i4 & 2147483647;
      do if (i3 >>> 0 > i5 >>> 0) {
       i1 = i4 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
        HEAP32[i9 >> 2] = i1;
        HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i5 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
        HEAP32[i9 >> 2] = i1;
        HEAP32[i15 >> 2] = i5;
        break;
       }
      } while (0);
      HEAP32[i13 >> 2] = i3;
      HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] = i6;
     } else HEAP8[(HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 5 >> 0] = 1; while (0);
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i11 | 0));
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < (__Z15PluginsGetCountv() | 0) >>> 0);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = 0;
  do {
   i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if (!(HEAP8[i3 + 5 >> 0] | 0)) {
    if (i3 | 0) __ZN29AudioEffectInternalDefinitionD2Ev(i3);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63328 | 0);
    HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] = 0;
    i1 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
    i12 = HEAP32[i15 >> 2] | 0;
    HEAP32[i12 + (i2 << 2) >> 2] = HEAP32[i12 + (i1 << 2) >> 2];
    HEAP32[i13 >> 2] = i1;
    i2 = i2 + -1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 if (i14) {
  HEAP32[i14 >> 2] = i1;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (!i1) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i15 >> 2] | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i14, i6, i9, i10, i11, i15) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 8 | 0;
 i4 = i17;
 i16 = (i6 | 0) == 0;
 if (i16) i3 = 0; else i3 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i14 + 744 | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) {
  if ((HEAP32[i14 + 780 >> 2] | 0) == (i9 | 0)) if (!(_memcmp(i10, i14 + 748 | 0, i9 << 2) | 0)) i3 = (HEAP32[i11 >> 2] | 0) == (HEAP32[i14 + 784 >> 2] | 0); else i3 = 0; else i3 = 0;
  if (i3 | i16 ^ 1) {
   STACKTOP = i17;
   return;
  }
 }
 i13 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 do if (!i3) i7 = 17; else {
  HEAP32[i4 >> 2] = i3;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i7 = 14; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[i3 + 32 >> 2] | 0;
    i3 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i3, i4);
    i4 = HEAP32[i12 >> 2] | 0;
    i18 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i3 = (i4 | 0) == -1 ? i18 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i18 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i7 = 14; else if (HEAP32[i3 + 4 >> 2] | 0) {
    i4 = 0;
    break;
   }
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) i7 = 17; else i4 = 0;
 } while (0);
 if ((i7 | 0) == 17) i4 = (HEAP32[i14 + 788 >> 2] | 0) == 0;
 if (i16) i3 = 0; else i3 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i3;
 i3 = i9 << 2;
 _memcpy(i14 + 748 | 0, i10 | 0, i3 | 0) | 0;
 if (i9 >>> 0 < 8) {
  i18 = 8 - i9 << 2;
  _memset(i14 + 748 + (i9 << 2) | 0, 0, i18 | 0) | 0;
  _memcpy(i14 + 788 | 0, i15 | 0, i3 | 0) | 0;
  _memset(i14 + 788 + (i9 << 2) | 0, 0, i18 | 0) | 0;
 } else _memcpy(i14 + 788 | 0, i15 | 0, i3 | 0) | 0;
 HEAP32[i14 + 780 >> 2] = i9;
 HEAP32[i14 + 784 >> 2] = HEAP32[i11 >> 2];
 i3 = i14 + 1086 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  __ZL19GetCameraTargetRectRK6Camerab(i12, i14, 1);
  f1 = Math_fround(HEAPF32[i14 + 864 >> 2]);
  f2 = Math_fround(HEAPF32[i14 + 868 >> 2]);
  f23 = Math_fround(HEAPF32[i14 + 872 >> 2]);
  f20 = Math_fround(HEAPF32[i14 + 876 >> 2]);
  f24 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f1 = Math_fround(f1 * f24);
  f23 = Math_fround(f23 * f24);
  f2 = Math_fround(f2 * f21);
  f20 = Math_fround(f20 * f21);
  f22 = Math_fround(HEAPF32[i12 >> 2]);
  f19 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f1 = Math_fround(f1 + f22);
  f2 = Math_fround(f2 + f19);
  f23 = Math_fround(f23 + f1);
  f20 = Math_fround(f20 + f2);
  f24 = Math_fround(f24 + f22);
  f21 = Math_fround(f21 + f19);
  f1 = Math_fround((f23 > f24 ? f24 : f23) - (f1 < f22 ? f22 : f1));
  f2 = Math_fround((f20 > f21 ? f21 : f20) - (f2 < f19 ? f19 : f2));
  i18 = f2 < Math_fround(0.0);
  f2 = i18 ? Math_fround(0.0) : f2;
  if (f2 != Math_fround(0.0)) {
   i18 = f1 < Math_fround(0.0);
   f1 = Math_fround((i18 ? Math_fround(0.0) : f1) / f2);
  } else f1 = Math_fround(1.0);
  HEAPF32[i14 + 1060 >> 2] = f1;
  HEAP8[i14 + 1077 >> 0] = 1;
  HEAP8[i14 + 1079 >> 0] = 1;
  HEAP8[i14 + 1078 >> 0] = 1;
  HEAP8[i3 >> 0] = 1;
 }
 if (!(HEAP8[i14 + 33 >> 0] | 0)) {
  STACKTOP = i17;
  return;
 }
 __ZN13RenderManager12RemoveCameraEP6Camera(__Z16GetRenderManagerv() | 0, i14);
 __ZN13RenderManager9AddCameraEP6Camera(__Z16GetRenderManagerv() | 0, i14);
 if ((i13 | 0) != (i14 | 0) | i4) {
  STACKTOP = i17;
  return;
 }
 if (i16) if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i14);
 STACKTOP = i17;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i17, i1, i16, i7, i2) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i6 = i18 + 24 | 0;
 i15 = i18 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i14 >> 2] = i5;
 HEAP8[i14 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i14;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i14) | 0;
 HEAP32[i6 >> 2] = 410;
 i13 = HEAP32[i17 + 20 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? i6 : i13;
 i1 = HEAP32[i17 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i8 = i14 + 4 | 0;
  i9 = i15 + 4 | 0;
  i10 = i15 + 8 | 0;
  i11 = i15 + 12 | 0;
  i12 = i17 + 4 | 0;
  while (1) {
   i4 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i3) i3 = 0; else {
    i5 = i3 + -1 | 0;
    i6 = HEAP32[i4 + 4 >> 2] | 0;
    if (!(HEAP8[i6 + (i5 << 3) + 4 >> 0] | 0)) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i6 + (i5 << 3) >> 2] | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i3 = HEAP32[i17 >> 2] | 0;
     i4 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
   }
   HEAP32[i14 >> 2] = i2;
   HEAP8[i8 >> 0] = 0;
   i2 = i4 + 8 | 0;
   if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    i19 = i14;
    i5 = HEAP32[i19 + 4 >> 2] | 0;
    i6 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i14) | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i11 >> 2] = i16;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i9 >> 2] = i1 + 8;
   __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i17, HEAP32[i13 >> 2] | 0, i15);
   i2 = HEAP32[i17 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (i3 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] | 0) {
     i3 = HEAP32[i12 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
     i3 = HEAP32[i17 >> 2] | 0;
     i2 = i3;
     i3 = HEAP32[i3 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i3 + -1;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   i7 = i7 + 8 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i18;
 return;
}

function __ZN5physx3Scb5Scene16removeRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 816 | 0;
 i11 = i17 + 544 | 0;
 i15 = i17 + 272 | 0;
 i14 = i17;
 if (!(HEAP8[i3 + 2433 >> 0] | 0)) {
  __ZL22addOrRemoveRigidObjectILb0ELb0ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(HEAP32[i3 + 1252 >> 2] | 0, i4);
  i16 = i4 + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] & 268435455;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i5 >> 2] = i1 & 1073741823;
   HEAP32[i16 >> 2] = i4;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i16) | 0;
   break;
  }
 case 2:
  {
   HEAP32[i5 >> 2] = i1 | -1073741824;
   if (!(i1 & 268435456)) {
    HEAP32[i11 >> 2] = i4;
    i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i2, i11, i16) | 0;
    if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i4;
   }
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i3 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i4, i16) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i4, i16) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN5physx12NpConstraint9setActorsEPNS_12PxRigidActorES2_(i13, i10, i11) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i3 = i13 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i1 + (HEAP32[gb + 1457020 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0) | 0, i1, 0, i13, gb + 688433 | 0);
 i2 = i13 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i1 + (HEAP32[gb + 1457020 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0) | 0, i1, 0, i13, gb + 688494 | 0);
 i8 = (i10 | 0) == 0;
 if (!i8) __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i10 + (HEAP32[gb + 1457020 + (HEAPU16[i10 + 4 >> 1] << 2) >> 2] | 0) | 0, 0, i13, gb + 688433 | 0);
 i9 = (i11 | 0) == 0;
 if (!i9) __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i11 + (HEAP32[gb + 1457020 + (HEAPU16[i11 + 4 >> 1] << 2) >> 2] | 0) | 0, 0, i13, gb + 688494 | 0);
 HEAP32[i3 >> 2] = i10;
 HEAP32[i2 >> 2] = i11;
 if (i8) i2 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0) | 0) & 8)) i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0) | 0; else i2 = 0;
 if (i9) i3 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0) | 0) & 8)) i3 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0, i11 | 0) | 0; else i3 = 0;
 i1 = (i2 | 0) != 0;
 if (i8 | i1) i7 = i9 | (i3 | 0) != 0 ? (i1 ? i2 : i3) : 0; else i7 = 0;
 if ((((HEAP32[i13 + 20 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i13 + 16 >> 2] | 0;
  if (!i1) i3 = 0; else i3 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 } else i3 = 0;
 if ((i3 | 0) == (i7 | 0)) {
  i3 = i13 + 16 | 0;
  L30 : do if (i8) i2 = 0; else switch (HEAP16[i10 + 4 >> 1] | 0) {
  case 5:
   {
    i2 = i10 + 48 | 0;
    break L30;
   }
  case 15:
   {
    i2 = i10 + 48 | 0;
    break L30;
   }
  default:
   {
    i2 = i10 + 48 | 0;
    break L30;
   }
  } while (0);
  L37 : do if (i9) i1 = 0; else switch (HEAP16[i11 + 4 >> 1] | 0) {
  case 5:
   {
    i1 = i11 + 48 | 0;
    break L37;
   }
  case 15:
   {
    i1 = i11 + 48 | 0;
    break L37;
   }
  default:
   {
    i1 = i11 + 48 | 0;
    break L37;
   }
  } while (0);
  __ZN5physx3Scb10Constraint9setBodiesEPNS0_11RigidObjectES3_(i3, i2, i1);
  STACKTOP = i14;
  return;
 }
 if (!i3) i4 = i13 + 16 | 0; else {
  i4 = i3 + 3540 | 0;
  i5 = i3 + 3544 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  L49 : do if (!i6) i1 = 0; else {
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = 0;
   do {
    if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i13 | 0)) break L49;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
  } while (0);
  if ((i1 | 0) != (i6 | 0)) {
   i2 = i6 + -1 | 0;
   HEAP32[i5 >> 2] = i2;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
  }
  i4 = i13 + 16 | 0;
  __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i3 + 16 | 0, i4);
 }
 L59 : do if (i8) i2 = 0; else switch (HEAP16[i10 + 4 >> 1] | 0) {
 case 5:
  {
   i2 = i10 + 48 | 0;
   break L59;
  }
 case 15:
  {
   i2 = i10 + 48 | 0;
   break L59;
  }
 default:
  {
   i2 = i10 + 48 | 0;
   break L59;
  }
 } while (0);
 L66 : do if (i9) i1 = 0; else switch (HEAP16[i11 + 4 >> 1] | 0) {
 case 5:
  {
   i1 = i11 + 48 | 0;
   break L66;
  }
 case 15:
  {
   i1 = i11 + 48 | 0;
   break L66;
  }
 default:
  {
   i1 = i11 + 48 | 0;
   break L66;
  }
 } while (0);
 __ZN5physx3Scb10Constraint9setBodiesEPNS0_11RigidObjectES3_(i4, i2, i1);
 if (!i7) {
  STACKTOP = i14;
  return;
 }
 i3 = i7 + 3540 | 0;
 HEAP32[i12 >> 2] = i13;
 i1 = i7 + 3544 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i7 + 3548 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = i13;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i12) | 0;
 __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE(i7 + 16 | 0, i4);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, i8, i13) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = (i3 - i5 | 0) / 28 | 0;
 i9 = i7 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i4;
 if (i6 >>> 0 > ((i1 - i4 | 0) / 28 | 0) >>> 0) {
  if (i4) {
   i5 = i7 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) i1 = i4; else {
    do {
     i4 = i1 + -28 | 0;
     HEAP32[i5 >> 2] = i4;
     i3 = i1 + -20 | 0;
     if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
      HEAP32[i3 >> 2] = 0;
      i1 = HEAP32[i5 >> 2] | 0;
     } else i1 = i4;
    } while ((i1 | 0) != (i2 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = 0;
  }
  if (i6 >>> 0 > 153391689) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  i12 = (i1 - i2 | 0) / 28 | 0;
  i2 = i12 << 1;
  i2 = i12 >>> 0 < 76695844 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 153391689;
  if (i2 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = __Znwj(i2 * 28 | 0) | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i9 >> 2] = i1 + (i2 * 28 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) return;
  do {
   i11 = i2;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i1 + 8 | 0, i2 + 8 | 0);
   i2 = i2 + 28 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 28 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  return;
 }
 i12 = i7 + 4 | 0;
 i1 = ((HEAP32[i12 >> 2] | 0) - i4 | 0) / 28 | 0;
 i11 = i6 >>> 0 > i1 >>> 0;
 i1 = i11 ? i5 + (i1 * 28 | 0) | 0 : i3;
 if ((i5 | 0) == (i1 | 0)) i4 = i2; else {
  i10 = i5;
  do {
   i8 = i10;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i4 = i2;
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 4 >> 2] = i9;
   i4 = i2 + 8 | 0;
   if ((i10 | 0) != (i2 | 0)) {
    i8 = HEAP32[i10 + 8 >> 2] | 0;
    i9 = i2 + 20 | 0;
    i3 = HEAP32[i10 + 20 >> 2] << 2;
    i5 = i3 >> 2;
    HEAP32[i9 >> 2] = i5;
    i6 = i2 + 24 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    do if ((i7 & 2147483647) >>> 0 < i5 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i5;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i3;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i6 >> 2] = i5;
     HEAP32[i4 >> 2] = i3;
     break;
    } else i3 = HEAP32[i4 >> 2] | 0; while (0);
    _memcpy(i3 | 0, i8 | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   }
   i10 = i10 + 28 | 0;
   i2 = i2 + 28 | 0;
  } while ((i10 | 0) != (i1 | 0));
  i4 = i2;
 }
 if (i11) {
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i12 >> 2] | 0;
  do {
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i2;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i11;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 8 | 0, i1 + 8 | 0);
   i1 = i1 + 28 | 0;
   i2 = (HEAP32[i12 >> 2] | 0) + 28 | 0;
   HEAP32[i12 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -28 | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i23, i1, i3, i2) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 136 | 0;
 i19 = i22 + 128 | 0;
 i18 = i22;
 i21 = i22 + 140 | 0;
 i14 = i22 + 176 | 0;
 i17 = i22 + 184 | 0;
 i16 = i23 + 8 | 0;
 i12 = i3 + 12 | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i16 >> 2] | 0) | 0;
 i15 = i21 + 20 | 0;
 i7 = i21 + 24 | 0;
 HEAP32[i21 + 28 >> 2] = 0;
 i8 = i21 + 32 | 0;
 HEAP8[i15 >> 0] = 1;
 HEAP32[i7 >> 2] = i21;
 HEAP32[i8 >> 2] = 5;
 HEAP32[i14 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE6resizeEjRKi(i21, i13, i14);
 if (i13 | 0) {
  i9 = i18 + 4 | 0;
  i10 = i23 + 4 | 0;
  i11 = i23 + 12 | 0;
  i14 = 0;
  do {
   i2 = i17;
   i3 = i2 + 32 | 0;
   do {
    HEAP8[i2 >> 0] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i3 | 0));
   HEAP32[i19 >> 2] = i14;
   __ZN5physx6string9sprintf_sEPcjPKcz(i17, 32, gb + 832301 | 0, i19) | 0;
   i1 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i10 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i23 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i23 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i18 >> 2] = i17;
   HEAP8[i9 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i4 = i18;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i18) | 0;
   i4 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i16 >> 2] | 0, i14 | 0) | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   i6 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i23 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   i2 = i18;
   i3 = i2 + 128 | 0;
   do {
    HEAP8[i2 >> 0] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i3 | 0));
   HEAP32[i20 >> 2] = i4;
   __ZN5physx6string9sprintf_sEPcjPKcz(i18, 128, gb + 1084492 | 0, i20) | 0;
   if (HEAP8[i18 >> 0] | 0) {
    i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    mftCall_iiii(i4 | 0, i6 | 0, i18 | 0, _strlen(i18) | 0) | 0;
   }
   HEAP8[i18 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i18 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
   HEAP32[i6 + 16 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   i2 = HEAP32[i23 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i10 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i23 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i14 = i14 + 1 | 0;
  } while ((i14 | 0) != (i13 | 0));
 }
 i23 = HEAP32[i8 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i22;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i21 | 0) == (i1 | 0)) {
  HEAP8[i15 >> 0] = 0;
  STACKTOP = i22;
  return;
 }
 if (!i1) {
  STACKTOP = i22;
  return;
 }
 i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i22;
 return;
}

function __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj(i28, i27, i26, i25) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i29 = 0, i30 = 0, i31 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i29 + 32 | 0;
 i20 = i29;
 i4 = i26 >>> 2;
 if (!i4) i1 = 0; else {
  i12 = i4 + -1 | 0;
  i13 = i21 + 4 | 0;
  i14 = i21 + 8 | 0;
  i15 = i21 + 12 | 0;
  i16 = i21 + 16 | 0;
  i17 = i21 + 20 | 0;
  i18 = i21 + 24 | 0;
  i19 = i21 + 28 | 0;
  i5 = i20 + 4 | 0;
  i6 = i20 + 8 | 0;
  i7 = i20 + 12 | 0;
  i8 = i20 + 16 | 0;
  i9 = i20 + 20 | 0;
  i10 = i20 + 24 | 0;
  i11 = i20 + 28 | 0;
  i22 = 0;
  i23 = 0;
  do {
   i3 = i22 >>> 0 < i12 >>> 0;
   i24 = i23;
   i23 = i23 + 4 | 0;
   if (i3) {
    i1 = HEAP32[i27 + (i23 << 3) + 4 >> 2] | 0;
    HEAP32[i21 >> 2] = HEAP32[i27 + (i23 << 3) >> 2];
    HEAP32[i13 >> 2] = i1;
    i1 = i24 + 5 | 0;
    i2 = HEAP32[i27 + (i1 << 3) + 4 >> 2] | 0;
    HEAP32[i14 >> 2] = HEAP32[i27 + (i1 << 3) >> 2];
    HEAP32[i15 >> 2] = i2;
    i2 = i24 + 6 | 0;
    i1 = HEAP32[i27 + (i2 << 3) + 4 >> 2] | 0;
    HEAP32[i16 >> 2] = HEAP32[i27 + (i2 << 3) >> 2];
    HEAP32[i17 >> 2] = i1;
    i1 = i24 + 7 | 0;
    i2 = HEAP32[i27 + (i1 << 3) + 4 >> 2] | 0;
    HEAP32[i18 >> 2] = HEAP32[i27 + (i1 << 3) >> 2];
    HEAP32[i19 >> 2] = i2;
   } else if (i23 >>> 0 < i26 >>> 0) {
    i1 = 0;
    i2 = i23;
    while (1) {
     i30 = HEAP32[i27 + (i2 << 3) + 4 >> 2] | 0;
     HEAP32[i21 + (i1 << 2) >> 2] = HEAP32[i27 + (i2 << 3) >> 2];
     HEAP32[i21 + ((i1 | 1) << 2) >> 2] = i30;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i26 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
   __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i28, HEAP32[i27 + (i24 << 3) >> 2] | 0, HEAP32[i27 + (i24 << 3) + 4 >> 2] | 0, i25);
   if (i3) {
    i30 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i20 >> 2] = HEAP32[(HEAP32[i21 >> 2] | 0) + 8 >> 2];
    HEAP32[i5 >> 2] = i30;
    i30 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2];
    HEAP32[i7 >> 2] = i30;
    i30 = HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2];
    HEAP32[i9 >> 2] = i30;
    i30 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
    HEAP32[i10 >> 2] = HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2];
    HEAP32[i11 >> 2] = i30;
   } else if (i23 >>> 0 < i26 >>> 0) {
    i1 = 0;
    i2 = i23;
    while (1) {
     i30 = i1 | 1;
     i31 = HEAP32[(HEAP32[i21 + (i30 << 2) >> 2] | 0) + 8 >> 2] | 0;
     HEAP32[i20 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i21 + (i1 << 2) >> 2] | 0) + 8 >> 2];
     HEAP32[i20 + (i30 << 2) >> 2] = i31;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i26 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
   i31 = i24 | 1;
   __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i28, HEAP32[i27 + (i31 << 3) >> 2] | 0, HEAP32[i27 + (i31 << 3) + 4 >> 2] | 0, i25);
   if (i3) {
    
   } else if (i23 >>> 0 < i26 >>> 0) {
    i1 = 0;
    i2 = i23;
    while (1) {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i26 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
   i31 = i24 | 2;
   __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i28, HEAP32[i27 + (i31 << 3) >> 2] | 0, HEAP32[i27 + (i31 << 3) + 4 >> 2] | 0, i25);
   if (!i3) if (i23 >>> 0 < i26 >>> 0) {
    i1 = 0;
    i2 = i23;
    while (1) {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i26 | 0)) break; else i1 = i1 + 2 | 0;
    }
   }
   i31 = i24 | 3;
   __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i28, HEAP32[i27 + (i31 << 3) >> 2] | 0, HEAP32[i27 + (i31 << 3) + 4 >> 2] | 0, i25);
   i22 = i22 + 1 | 0;
  } while ((i22 | 0) != (i4 | 0));
  i1 = i4 << 2;
 }
 if (i1 >>> 0 >= i26 >>> 0) {
  STACKTOP = i29;
  return;
 }
 do {
  __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j(i28, HEAP32[i27 + (i1 << 3) >> 2] | 0, HEAP32[i27 + (i1 << 3) + 4 >> 2] | 0, i25);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i26 | 0));
 STACKTOP = i29;
 return;
}

function __ZN5physx2Gu16testPolyDataAxisERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i8, i5, i7, i9, i36, i37) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i36 = i36 | 0;
 i37 = i37 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f6 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i38 = 0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i38 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i38 + 12 | 0;
 i35 = i38;
 i33 = HEAP32[i5 + 16 >> 2] | 0;
 L1 : do if (!i33) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f2 = Math_fround(0.0);
 } else {
  i34 = HEAP32[i5 + 24 >> 2] | 0;
  i32 = HEAP32[i5 + 28 >> 2] | 0;
  i5 = HEAP32[i7 + 40 >> 2] | 0;
  f31 = Math_fround(HEAPF32[i5 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f21 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f22 = Math_fround(HEAPF32[i5 + 32 >> 2]);
  f23 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  f24 = Math_fround(HEAPF32[i5 + 40 >> 2]);
  f25 = Math_fround(HEAPF32[i8 + 96 >> 2]);
  f26 = Math_fround(HEAPF32[i8 + 100 >> 2]);
  f27 = Math_fround(HEAPF32[i8 + 104 >> 2]);
  f28 = Math_fround(HEAPF32[i8 + 112 >> 2]);
  f29 = Math_fround(HEAPF32[i8 + 116 >> 2]);
  f30 = Math_fround(HEAPF32[i8 + 120 >> 2]);
  f16 = Math_fround(HEAPF32[i8 + 128 >> 2]);
  f15 = Math_fround(HEAPF32[i9 >> 2]);
  f13 = Math_fround(3402823469999999843913219.0e14);
  f2 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  i5 = 0;
  while (1) {
   i9 = HEAPU8[i34 + (i5 * 20 | 0) + 19 >> 0] | 0;
   f44 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) >> 2]);
   f42 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) + 4 >> 2]);
   f39 = Math_fround(HEAPF32[i32 + (i9 * 12 | 0) + 8 >> 2]);
   f40 = Math_fround(HEAPF32[i34 + (i5 * 20 | 0) + 12 >> 2]);
   f43 = Math_fround(HEAPF32[i34 + (i5 * 20 | 0) >> 2]);
   f6 = Math_fround(HEAPF32[i34 + (i5 * 20 | 0) + 4 >> 2]);
   f41 = Math_fround(HEAPF32[i34 + (i5 * 20 | 0) + 8 >> 2]);
   f14 = Math_fround(Math_fround(Math_fround(f43 * f31) + Math_fround(f6 * f17)) + Math_fround(f41 * f18));
   f12 = Math_fround(Math_fround(Math_fround(f43 * f19) + Math_fround(f6 * f20)) + Math_fround(f41 * f21));
   f11 = Math_fround(Math_fround(Math_fround(f43 * f22) + Math_fround(f6 * f23)) + Math_fround(f41 * f24));
   f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f12 * f12)) + Math_fround(f11 * f11)))));
   f14 = Math_fround(f14 * f10);
   f12 = Math_fround(f12 * f10);
   f11 = Math_fround(f10 * f11);
   f41 = Math_fround(Math_fround(Math_fround(Math_fround(f44 * f43) + Math_fround(f42 * f6)) + Math_fround(f39 * f41)) * f10);
   f10 = Math_fround(f40 * f10);
   f40 = Math_fround(Math_fround(Math_fround(f25 * f14) + Math_fround(f12 * f26)) + Math_fround(f11 * f27));
   f39 = Math_fround(Math_fround(Math_fround(f14 * f28) + Math_fround(f12 * f29)) + Math_fround(f11 * f30));
   i9 = f40 > f39;
   f6 = Math_fround((i9 ? f39 : f40) - f16);
   if (f6 > Math_fround(f15 - f10) ? 1 : f41 > Math_fround(f15 + Math_fround(f16 + (i9 ? f40 : f39)))) {
    i1 = 0;
    break;
   }
   f6 = Math_fround(Math_fround(-f10) - f6);
   if (f13 > f6) {
    HEAP32[i1 >> 2] = HEAP32[i35 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i35 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i35 + 8 >> 2];
    f4 = f11;
    f3 = f12;
    f2 = f14;
   } else f6 = f13;
   i5 = i5 + 1 | 0;
   if (i5 >>> 0 >= i33 >>> 0) break L1; else f13 = f6;
  }
  STACKTOP = i38;
  return i1 | 0;
 } while (0);
 HEAPF32[i37 >> 2] = f2;
 HEAPF32[i37 + 4 >> 2] = f3;
 HEAPF32[i37 + 8 >> 2] = f4;
 HEAPF32[i37 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i36 >> 2] = f6;
 i37 = i36 + 4 | 0;
 HEAP32[i37 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i37 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i37 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i37 = 1;
 STACKTOP = i38;
 return i37 | 0;
}

function __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i3 >> 2]);
 f30 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(f16 - f31);
 f15 = Math_fround(f14 - f30);
 f21 = Math_fround(f12 - f25);
 f21 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f21 * f21) + Math_fround(0.0)))));
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f16 - f15);
 f14 = Math_fround(f14 - f13);
 f12 = Math_fround(f12 - f8);
 f24 = Math_fround(HEAPF32[i5 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f24 = Math_fround(f21 * f24);
 f17 = Math_fround(f21 * f17);
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i5 + 8 >> 2]));
 f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f28 = Math_fround(f10 * Math_fround(-2.0));
 f18 = Math_fround(f10 * Math_fround(2.0));
 f23 = Math_fround(f28 * f9);
 f11 = Math_fround(f27 * Math_fround(2.0));
 f22 = Math_fround(f27 * Math_fround(-2.0));
 f29 = Math_fround(f9 * f22);
 f19 = Math_fround(f20 * Math_fround(-2.0));
 f26 = Math_fround(f20 * Math_fround(2.0));
 f9 = Math_fround(f9 * f19);
 f15 = Math_fround(Math_fround(f31 - Math_fround(Math_fround(f24 + Math_fround(f24 * Math_fround(Math_fround(f10 * f28) - Math_fround(f27 * f11)))) + Math_fround(Math_fround(f21 * Math_fround(Math_fround(f26 * f27) - f23)) + Math_fround(f17 * Math_fround(f29 - Math_fround(f10 * f19)))))) - f15);
 f13 = Math_fround(Math_fround(f30 - Math_fround(Math_fround(f17 + Math_fround(f24 * Math_fround(Math_fround(f20 * f18) - f29))) + Math_fround(Math_fround(f21 * Math_fround(f9 - Math_fround(f28 * f27))) + Math_fround(f17 * Math_fround(Math_fround(f27 * f22) - Math_fround(f20 * f26)))))) - f13);
 f8 = Math_fround(Math_fround(f25 - Math_fround(Math_fround(f21 + Math_fround(f24 * Math_fround(f23 - Math_fround(f20 * f22)))) + Math_fround(Math_fround(f21 * Math_fround(Math_fround(f20 * f19) - Math_fround(f10 * f18))) + Math_fround(f17 * Math_fround(Math_fround(f10 * f11) - f9))))) - f8);
 f9 = Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f13));
 f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f14 * f8));
 f10 = Math_fround(Math_fround(f16 * f8) - Math_fround(f12 * f15));
 f8 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))) * Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f8 * f8) + Math_fround(0.0)))))) + Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(Math_fround(f12 * f8) + Math_fround(0.0))));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8))))));
 f11 = Math_fround(f12 * f11);
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f8 = Math_fround(f12 * f8);
 f12 = Math_fround(HEAPF32[i7 >> 2]);
 f11 = Math_fround(f12 * f11);
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8))))));
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f8 = Math_fround(f12 * f8);
 HEAPF32[i1 >> 2] = Math_fround(f12 * f11);
 HEAPF32[i1 + 4 >> 2] = f10;
 HEAPF32[i1 + 8 >> 2] = f9;
 HEAPF32[i1 + 12 >> 2] = f8;
 return;
}

function __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, i8, i13) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = i3 - i5 >> 5;
 i9 = i7 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i4;
 if (i6 >>> 0 > i1 - i4 >> 5 >>> 0) {
  if (i4) {
   i5 = i7 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) i1 = i4; else {
    i3 = i1;
    while (1) {
     i1 = i3 + -32 | 0;
     HEAP32[i5 >> 2] = i1;
     i4 = i3 + -20 | 0;
     if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i3 + -16 | 0);
      HEAP32[i4 >> 2] = 0;
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 | 0)) break; else i3 = i1;
    }
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = 0;
  }
  if (i6 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  i12 = i1 - i2 | 0;
  i1 = i12 >> 4;
  i1 = i12 >> 5 >>> 0 < 67108863 ? (i1 >>> 0 < i6 >>> 0 ? i6 : i1) : 134217727;
  if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i2 = __Znwj(i1 << 5) | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i9 >> 2] = i2 + (i1 << 5);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 12 | 0, i1 + 12 | 0);
   i1 = i1 + 32 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i12 = i7 + 4 | 0;
 i1 = (HEAP32[i12 >> 2] | 0) - i4 >> 5;
 i11 = i6 >>> 0 > i1 >>> 0;
 i1 = i11 ? i5 + (i1 << 5) | 0 : i3;
 if ((i5 | 0) == (i1 | 0)) i4 = i2; else {
  i10 = i5;
  do {
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   i4 = i2 + 12 | 0;
   if ((i10 | 0) != (i2 | 0)) {
    i8 = HEAP32[i10 + 12 >> 2] | 0;
    i9 = i2 + 24 | 0;
    i3 = HEAP32[i10 + 24 >> 2] << 2;
    i5 = i3 >> 2;
    HEAP32[i9 >> 2] = i5;
    i6 = i2 + 28 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    do if ((i7 & 2147483647) >>> 0 < i5 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i5;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3, 4, i2 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i4 >> 2] = i3;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i2 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i6 >> 2] = i5;
     HEAP32[i4 >> 2] = i3;
     break;
    } else i3 = HEAP32[i4 >> 2] | 0; while (0);
    _memcpy(i3 | 0, i8 | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   }
   i10 = i10 + 32 | 0;
   i2 = i2 + 32 | 0;
  } while ((i10 | 0) != (i1 | 0));
  i4 = i2;
 }
 if (i11) {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
  i3 = HEAP32[i12 >> 2] | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i3 + 12 | 0, i1 + 12 | 0);
   i1 = i1 + 32 | 0;
   i3 = (HEAP32[i12 >> 2] | 0) + 32 | 0;
   HEAP32[i12 >> 2] = i3;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -32 | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx2Sc5Scene9solveStepEPNS_10PxBaseTaskE(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i6 = i8 + 64 | 0;
 if (!(Math_fround(HEAPF32[i6 >> 2]) != Math_fround(0.0))) {
  STACKTOP = i10;
  return;
 }
 i7 = i8 + 1792 | 0;
 i4 = i8 + 1880 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i8 + 1804 | 0) | 0;
 HEAP32[i8 + 1800 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 >> 2] = i5;
 i2 = i8 + 1836 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i8 + 1840 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i8 + 1832 >> 2] | 0) + (i3 << 2) >> 2] = i5;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i8 + 1812 | 0, i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
 HEAP8[i8 + 1876 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 if (!(HEAP16[i8 + 1192 >> 1] & 4)) {
  HEAP32[i8 + 1972 >> 2] = 1;
  i5 = i8 + 1968 | 0;
  HEAP32[i5 >> 2] = i7;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
  HEAP32[i8 + 1964 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 } else {
  i5 = i8 + 1888 | 0;
  HEAP32[i8 + 1904 >> 2] = 1;
  i4 = i8 + 1900 | 0;
  HEAP32[i4 >> 2] = i7;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
  HEAP32[i8 + 1896 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
  HEAP32[i8 + 1972 >> 2] = 1;
  i4 = i8 + 1968 | 0;
  HEAP32[i4 >> 2] = i5;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
  HEAP32[i8 + 1964 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
 }
 i5 = i8 + 1956 | 0;
 i1 = i8 + 168 | 0;
 L12 : do if (!(HEAP32[i1 >> 2] | 0)) i9 = 13; else {
  i2 = i8 + 160 | 0;
  i3 = i8 + 156 | 0;
  i4 = 0;
  while (1) {
   if (i4 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
    i9 = 13;
    break L12;
   }
   if (!((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0) | 0) & 4)) i4 = i4 + 1 | 0; else break;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iifi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i6 >> 2]), i5 | 0) | 0;
  HEAP32[i8 + 1564 >> 2] = 1;
  i6 = i8 + 1560 | 0;
  HEAP32[i6 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  HEAP32[i8 + 1556 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = i8 + 1548 | 0;
 } while (0);
 if ((i9 | 0) == 13) {
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
  i1 = i5;
 }
 i3 = i8 + 2068 | 0;
 HEAP32[i8 + 2084 >> 2] = 1;
 i4 = i8 + 2080 | 0;
 HEAP32[i4 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 HEAP32[i8 + 2076 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
 i4 = i8 + 1984 | 0;
 HEAP32[i8 + 2e3 >> 2] = 1;
 i6 = i8 + 1996 | 0;
 HEAP32[i6 >> 2] = i3;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
 HEAP32[i8 + 1992 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
 i6 = i8 + 2096 | 0;
 HEAP32[i8 + 2112 >> 2] = 1;
 i9 = i8 + 2108 | 0;
 HEAP32[i9 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 HEAP32[i8 + 2104 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2];
 i9 = i8 + 2124 | 0;
 HEAP32[i8 + 2140 >> 2] = 1;
 i2 = i8 + 2136 | 0;
 HEAP32[i2 >> 2] = i6;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
 HEAP32[i8 + 2132 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function __ZN17AudioReverbFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function _remquo(d1, d3, i17) {
 d1 = +d1;
 d3 = +d3;
 i17 = i17 | 0;
 var i2 = 0, i4 = 0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i7 = HEAP32[tempDoublePtr >> 2] | 0;
 i8 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d3;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i11 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i6 = _bitshift64Lshr(i7 | 0, i8 | 0, 52) | 0;
 getTempRet0() | 0;
 i6 = i6 & 2047;
 i9 = _bitshift64Lshr(i10 | 0, i11 | 0, 52) | 0;
 getTempRet0() | 0;
 i9 = i9 & 2047;
 i13 = _bitshift64Lshr(i7 | 0, i8 | 0, 63) | 0;
 i14 = getTempRet0() | 0;
 i15 = _bitshift64Lshr(i10 | 0, i11 | 0, 63) | 0;
 i16 = getTempRet0() | 0;
 HEAP32[i17 >> 2] = 0;
 i2 = i11 & 2147483647;
 do if ((i10 | 0) == 0 & (i2 | 0) == 0) i12 = 3; else if (i2 >>> 0 > 2146435072 | (i2 | 0) == 2146435072 & i10 >>> 0 > 0 | (i6 | 0) == 2047) i12 = 3; else if (!((i7 | 0) == 0 & (i8 & 2147483647 | 0) == 0)) {
  if (!i6) {
   i2 = _bitshift64Shl(i7 | 0, i8 | 0, 12) | 0;
   i4 = getTempRet0() | 0;
   if ((i4 | 0) > -1 | (i4 | 0) == -1 & i2 >>> 0 > 4294967295) {
    i6 = 0;
    do {
     i6 = i6 + -1 | 0;
     i2 = _bitshift64Shl(i2 | 0, i4 | 0, 1) | 0;
     i4 = getTempRet0() | 0;
    } while ((i4 | 0) > -1 | (i4 | 0) == -1 & i2 >>> 0 > 4294967295);
   } else i6 = 0;
   i7 = _bitshift64Shl(i7 | 0, i8 | 0, 1 - i6 | 0) | 0;
   i4 = getTempRet0() | 0;
  } else i4 = i8 & 1048575 | 1048576;
  if (!i9) {
   i8 = _bitshift64Shl(i10 | 0, i11 | 0, 12) | 0;
   i9 = getTempRet0() | 0;
   if ((i9 | 0) > -1 | (i9 | 0) == -1 & i8 >>> 0 > 4294967295) {
    i2 = 0;
    do {
     i2 = i2 + -1 | 0;
     i8 = _bitshift64Shl(i8 | 0, i9 | 0, 1) | 0;
     i9 = getTempRet0() | 0;
    } while ((i9 | 0) > -1 | (i9 | 0) == -1 & i8 >>> 0 > 4294967295);
   } else i2 = 0;
   i10 = _bitshift64Shl(i10 | 0, i11 | 0, 1 - i2 | 0) | 0;
   i9 = i2;
   i8 = getTempRet0() | 0;
  } else i8 = i11 & 1048575 | 1048576;
  if ((i6 | 0) < (i9 | 0)) if ((i6 + 1 | 0) == (i9 | 0)) {
   i2 = 0;
   i12 = 22;
  } else break; else {
   i18 = _i64Subtract(i7 | 0, i4 | 0, i10 | 0, i8 | 0) | 0;
   i12 = getTempRet0() | 0;
   i11 = (i12 | 0) > -1 | (i12 | 0) == -1 & i18 >>> 0 > 4294967295;
   i2 = _bitshift64Lshr(i18 | 0, i12 | 0, 63) | 0;
   getTempRet0() | 0;
   i2 = i2 ^ 1;
   i7 = i11 ? i18 : i7;
   i4 = i11 ? i12 : i4;
   if ((i6 | 0) > (i9 | 0)) {
    do {
     i7 = _bitshift64Shl(i7 | 0, i4 | 0, 1) | 0;
     i4 = getTempRet0() | 0;
     i6 = i6 + -1 | 0;
     i11 = _i64Subtract(i7 | 0, i4 | 0, i10 | 0, i8 | 0) | 0;
     i18 = getTempRet0() | 0;
     i12 = (i18 | 0) > -1 | (i18 | 0) == -1 & i11 >>> 0 > 4294967295;
     i19 = _bitshift64Lshr(i11 | 0, i18 | 0, 63) | 0;
     getTempRet0() | 0;
     i2 = (i19 | i2 << 1) ^ 1;
     i7 = i12 ? i11 : i7;
     i4 = i12 ? i18 : i4;
    } while ((i6 | 0) > (i9 | 0));
    i6 = i9;
   }
   if ((i7 | 0) == 0 & (i4 | 0) == 0) {
    i6 = -60;
    i7 = 0;
    i4 = 0;
    i12 = 24;
   } else if (i4 >>> 0 < 1048576 | (i4 | 0) == 1048576 & i7 >>> 0 < 0) {
    do {
     i7 = _bitshift64Shl(i7 | 0, i4 | 0, 1) | 0;
     i4 = getTempRet0() | 0;
     i6 = i6 + -1 | 0;
    } while (i4 >>> 0 < 1048576 | (i4 | 0) == 1048576 & i7 >>> 0 < 0);
    i12 = 22;
   } else i12 = 22;
  }
  if ((i12 | 0) == 22) if ((i6 | 0) > 0) {
   i19 = _i64Add(i7 | 0, i4 | 0, 0, -1048576) | 0;
   i7 = getTempRet0() | 0;
   i4 = _bitshift64Shl(i6 | 0, 0, 52) | 0;
   i4 = i19 | i4;
   i7 = i7 | (getTempRet0() | 0);
  } else i12 = 24;
  if ((i12 | 0) == 24) {
   i4 = _bitshift64Lshr(i7 | 0, i4 | 0, 1 - i6 | 0) | 0;
   i7 = getTempRet0() | 0;
  }
  HEAP32[tempDoublePtr >> 2] = i4;
  HEAP32[tempDoublePtr + 4 >> 2] = i7;
  d1 = +HEAPF64[tempDoublePtr >> 3];
  d5 = (i15 | 0) == 0 & (i16 | 0) == 0 ? d3 : -d3;
  if ((i6 | 0) == (i9 | 0)) i12 = 29; else if ((i6 + 1 | 0) == (i9 | 0)) {
   d3 = d1 * 2.0;
   if (d3 > d5) i12 = 29; else if (!((i2 & 1 | 0) == 0 | d3 != d5)) i12 = 29;
  }
  if ((i12 | 0) == 29) {
   d1 = d1 - d5;
   i2 = i2 + 1 | 0;
  }
  i19 = i2 & 2147483647;
  HEAP32[i17 >> 2] = (i13 | 0) != (i15 | 0) | (i14 | 0) != (i16 | 0) ? 0 - i19 | 0 : i19;
  d1 = (i13 | 0) != 0 | (i14 | 0) != 0 ? -d1 : d1;
 } while (0);
 if ((i12 | 0) == 3) {
  d1 = d1 * d3;
  d1 = d1 / d1;
 }
 return +d1;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe(i1, i19, i16, i17, d9) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 d9 = +d9;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 300 | 0;
 i7 = i18 + 48 | 0;
 i6 = i18 + 32 | 0;
 i4 = i18 + 24 | 0;
 i2 = i18 + 8 | 0;
 i8 = i18;
 i11 = i18 + 304 | 0;
 i10 = i18 + 296 | 0;
 i3 = i18 + 68 | 0;
 i15 = i18 + 64 | 0;
 i13 = i18 + 60 | 0;
 i14 = i18 + 56 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = 37;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = __ZNSt3__214__num_put_base14__format_floatEPcPKcj(i8 + 1 | 0, gb + 1083681 | 0, HEAP32[i16 + 4 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = __ZNSt3__26__clocEv() | 0;
 if (i5) {
  HEAP32[i2 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAPF64[i2 + 8 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i2) | 0;
 } else {
  HEAPF64[i4 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i4) | 0;
 }
 do if ((i1 | 0) > 29) {
  if (i5) {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAPF64[i6 + 8 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i6 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  } else {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    __THREW__ = 0;
    HEAPF64[i7 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i7 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  }
  if ((i20 | 0) == 12) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i4 = i2;
    i7 = i2;
    i20 = 16;
    break;
   }
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) {
    i7 = HEAP32[i10 >> 2] | 0;
    i4 = i7;
    i20 = 16;
    break;
   }
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = 0;
  i20 = 16;
 } while (0);
 if ((i20 | 0) == 16) {
  i5 = i4 + i1 | 0;
  i6 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i4, i5, i16) | 0;
  L22 : do if ((i4 | 0) == (i11 | 0)) {
   i4 = 0;
   i1 = i11;
   i20 = 22;
  } else {
   i2 = _malloc(i1 << 3) | 0;
   do if (!i2) {
    __THREW__ = 0;
    invoke_v(fb + 459 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L22;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i1 = i4; while (0);
   i3 = i2;
   i4 = i2;
   i20 = 22;
  } while (0);
  if ((i20 | 0) == 22) {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2804 | 0, i16 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   do if (i11 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i20 = 32;
   } else {
    HEAP32[i12 >> 2] = i2;
    __THREW__ = 0;
    invoke_viiiiiii(fb + 44 | 0, i1 | 0, i6 | 0, i5 | 0, i3 | 0, i15 | 0, i13 | 0, i12 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
     i20 = 32;
     break;
    }
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
    i15 = HEAP32[i15 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    i1 = invoke_iiiiiii(fb + 147 | 0, i12 | 0, i3 | 0, i15 | 0, i1 | 0, i16 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    HEAP32[i19 >> 2] = i1;
    if (i4 | 0) _free(i4);
    if (i7 | 0) _free(i7);
    STACKTOP = i18;
    return i1 | 0;
   } while (0);
   if (i4) _free(i4);
  }
  if (i7) _free(i7);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd(i1, i19, i16, i17, d9) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 d9 = +d9;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 300 | 0;
 i7 = i18 + 48 | 0;
 i6 = i18 + 32 | 0;
 i4 = i18 + 24 | 0;
 i2 = i18 + 8 | 0;
 i8 = i18;
 i11 = i18 + 304 | 0;
 i10 = i18 + 296 | 0;
 i3 = i18 + 68 | 0;
 i15 = i18 + 64 | 0;
 i13 = i18 + 60 | 0;
 i14 = i18 + 56 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = 37;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = __ZNSt3__214__num_put_base14__format_floatEPcPKcj(i8 + 1 | 0, gb + 1576256 | 0, HEAP32[i16 + 4 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = __ZNSt3__26__clocEv() | 0;
 if (i5) {
  HEAP32[i2 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAPF64[i2 + 8 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i2) | 0;
 } else {
  HEAPF64[i4 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i4) | 0;
 }
 do if ((i1 | 0) > 29) {
  if (i5) {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAPF64[i6 + 8 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i6 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  } else {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    __THREW__ = 0;
    HEAPF64[i7 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i7 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  }
  if ((i20 | 0) == 12) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i4 = i2;
    i7 = i2;
    i20 = 16;
    break;
   }
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) {
    i7 = HEAP32[i10 >> 2] | 0;
    i4 = i7;
    i20 = 16;
    break;
   }
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = 0;
  i20 = 16;
 } while (0);
 if ((i20 | 0) == 16) {
  i5 = i4 + i1 | 0;
  i6 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i4, i5, i16) | 0;
  L22 : do if ((i4 | 0) == (i11 | 0)) {
   i4 = 0;
   i1 = i11;
   i20 = 22;
  } else {
   i2 = _malloc(i1 << 3) | 0;
   do if (!i2) {
    __THREW__ = 0;
    invoke_v(fb + 459 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L22;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i1 = i4; while (0);
   i3 = i2;
   i4 = i2;
   i20 = 22;
  } while (0);
  if ((i20 | 0) == 22) {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2804 | 0, i16 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   do if (i11 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i20 = 32;
   } else {
    HEAP32[i12 >> 2] = i2;
    __THREW__ = 0;
    invoke_viiiiiii(fb + 44 | 0, i1 | 0, i6 | 0, i5 | 0, i3 | 0, i15 | 0, i13 | 0, i12 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
     i20 = 32;
     break;
    }
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
    i15 = HEAP32[i15 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    i1 = invoke_iiiiiii(fb + 147 | 0, i12 | 0, i3 | 0, i15 | 0, i1 | 0, i16 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    HEAP32[i19 >> 2] = i1;
    if (i4 | 0) _free(i4);
    if (i7 | 0) _free(i7);
    STACKTOP = i18;
    return i1 | 0;
   } while (0);
   if (i4) _free(i4);
  }
  if (i7) _free(i7);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN14ParticleSystem29ComputePrewarmStartParametersERff(i11, i7, f5) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i6 = 0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i19 + 52 | 0;
 i4 = i19 + 56 | 0;
 i14 = i19 + 40 | 0;
 i12 = i19 + 48 | 0;
 i16 = i19 + 16 | 0;
 i17 = i19 + 4 | 0;
 i18 = i19;
 HEAPF32[i6 >> 2] = f5;
 f13 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
 __ZNK11MinMaxCurve10FindMinMaxEv(i14, (HEAP32[i11 + 44 >> 2] | 0) + 8 | 0);
 f2 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 HEAPF32[i4 >> 2] = f2;
 i14 = i11 + 36 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i1 + 264 >> 2]);
 if ((HEAP8[i1 + 277 >> 0] | 0) == 0 & Math_fround(f2 + f15) < f5) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (!(HEAP8[(HEAP32[i11 + 916 >> 2] | 0) + 4 >> 0] | 0)) {
  f3 = Math_fround(0.0);
  i10 = i1;
 } else {
  f3 = Math_fround(__ZNK14ParticleSystem34CalculateSubEmitterMaximumLifeTimeEfi(i11, f2, 0));
  i10 = HEAP32[i14 >> 2] | 0;
 }
 HEAPF32[i7 >> 2] = f3;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f2 = f3 < f2 ? f9 : f3;
 f9 = Math_fround(_fmodf(f5, f13));
 f3 = Math_fround(Math_fround(f5 - f2) - f9);
 HEAPF32[i12 >> 2] = f3;
 f2 = Math_fround(f9 + f2);
 HEAPF32[i7 >> 2] = f2;
 if (!(HEAP8[i10 + 278 >> 0] | 0)) {
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  i4 = f3 < Math_fround(0.0);
  i4 = HEAP32[(i4 ? i16 : i12) >> 2] | 0;
  HEAP32[i12 >> 2] = i4;
  i6 = HEAP32[(f2 < f5 ? i7 : i6) >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  f2 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f9 = Math_fround(HEAPF32[i10 + 268 >> 2]);
 i1 = f9 < Math_fround(.00100000005);
 HEAPF32[i7 >> 2] = Math_fround(f2 / (i1 ? Math_fround(.00100000005) : f9));
 i1 = f3 < Math_fround(0.0);
 f9 = i1 ? Math_fround(-1.0) : Math_fround(1.0);
 f2 = Math_fround(-f3);
 if (i1) {
  f5 = Math_fround(f3 + Math_fround(f15 * Math_fround(~~Math_fround(Math_ceil(Math_fround(f2 / f15))) | 0)));
  HEAPF32[i12 >> 2] = f5;
 } else f5 = f3;
 f8 = Math_fround((i1 ? f2 : f3) + f5);
 f3 = Math_fround(_fmodf(f5, f15));
 i7 = i11 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAPF32[i1 + 396 >> 2] = f3;
 i10 = HEAP32[i10 + 272 >> 2] | 0;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 i6 = i16 + 4 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAP32[i16 + 8 >> 2] = i10;
 i10 = (Math_imul(i10, 1812433253) | 0) + 1 | 0;
 HEAP32[i16 + 12 >> 2] = i10;
 i10 = (Math_imul(i10, 1812433253) | 0) + 1 | 0;
 HEAP32[i16 + 16 >> 2] = i10;
 HEAP32[i16 + 20 >> 2] = (Math_imul(i10, 1812433253) | 0) + 1;
 HEAP32[i17 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 if (Math_fround(f13 + f8) > f8 & Math_fround(f13 + f5) > f5) {
  if (Math_fround(f5 + Math_fround(.0000999999974)) < f8) {
   i4 = i11 + 268 | 0;
   i1 = i11 + 272 | 0;
   f2 = f5;
   do {
    f5 = Math_fround(_fmodf(Math_fround(f13 + f2), f15));
    f3 = Math_fround(_fmodf(f2, f15));
    if (HEAP8[i4 >> 0] | 0) {
     __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff(i16, i1, i17, f3, f5, f13, Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 264 >> 2])) | 0;
     __ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff(i16, i18, i1, f3, f5, Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + 264 >> 2])) | 0;
    }
    f2 = Math_fround(f13 + f2);
    HEAPF32[i12 >> 2] = f2;
   } while (Math_fround(f2 + Math_fround(.0000999999974)) < f8);
   f2 = Math_fround(HEAPF32[i6 >> 2]);
   i1 = HEAP32[i7 >> 2] | 0;
  } else f2 = Math_fround(0.0);
  i18 = f9 > Math_fround(0.0);
  f15 = Math_fround(Math_fround(1.0) - f2);
  HEAPF32[i1 + 492 >> 2] = Math_fround((i18 ? f2 : f15) + Math_fround(.0000999999974));
  i1 = 1;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 621463 | 0, 0, gb + 612988 | 0, 1239, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  i1 = 0;
 }
 i18 = i1;
 STACKTOP = i19;
 return i18 | 0;
}

function _gray_rgb_convert(i1, i8, i5, i6, i3) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i7 = 0, i9 = 0;
 switch (HEAP32[i1 + 44 >> 2] | 0) {
 case 6:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 >> 0] = i9;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 12:
 case 7:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 >> 0] = i9;
     HEAP8[i2 + 3 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 8:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 + 2 >> 0] = i9;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 13:
 case 9:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 3 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 14:
 case 10:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 3 >> 0] = i9;
     HEAP8[i2 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 case 15:
 case 11:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 3 >> 0] = i9;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 >> 0] = -1;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 default:
  {
   i7 = HEAP32[i1 + 92 >> 2] | 0;
   if ((i3 | 0) < 1 | (i7 | 0) == 0) return;
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i1 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i9 = HEAP8[i4 + i1 >> 0] | 0;
     HEAP8[i2 + 2 >> 0] = i9;
     HEAP8[i2 + 1 >> 0] = i9;
     HEAP8[i2 >> 0] = i9;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 3 | 0;
    }
    if ((i3 | 0) > 1) {
     i6 = i6 + 4 | 0;
     i5 = i5 + 1 | 0;
     i3 = i3 + -1 | 0;
    } else break;
   }
   return;
  }
 }
}

function __ZN5physx20updateCollDataStaticERNS_19PxsParticleCollDataERKNS_11PxTransformEf(i13, i3, f1) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i11 = i12;
 i2 = i13 + 124 | 0;
 if (!(HEAP32[i2 >> 2] & 56)) {
  STACKTOP = i12;
  return;
 }
 f16 = Math_fround(Math_fround(HEAPF32[i13 + 144 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i13 + 148 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i13 + 152 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f20 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f16 * f17);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f18 * f15));
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f21 * f14));
 f5 = Math_fround(Math_fround(f17 * f7) + Math_fround(Math_fround(f16 * f20) + Math_fround(f19 * Math_fround(Math_fround(f21 * f15) - Math_fround(f18 * f14)))));
 f6 = Math_fround(Math_fround(f15 * f7) + Math_fround(Math_fround(f18 * f20) + Math_fround(f19 * Math_fround(Math_fround(f16 * f14) - Math_fround(f21 * f17)))));
 f7 = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)))) + Math_fround(f14 * f7));
 HEAPF32[i10 >> 2] = f5;
 HEAPF32[i10 + 4 >> 2] = f6;
 HEAPF32[i10 + 8 >> 2] = f7;
 f16 = Math_fround(Math_fround(HEAPF32[i13 + 160 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i13 + 164 >> 2]) * Math_fround(2.0));
 f21 = Math_fround(Math_fround(HEAPF32[i13 + 168 >> 2]) * Math_fround(2.0));
 f1 = Math_fround(Math_fround(Math_fround(f16 * f17) + Math_fround(f18 * f15)) + Math_fround(f21 * f14));
 f8 = Math_fround(Math_fround(f17 * f1) + Math_fround(Math_fround(f16 * f20) + Math_fround(f19 * Math_fround(Math_fround(f21 * f15) - Math_fround(f18 * f14)))));
 f9 = Math_fround(Math_fround(f15 * f1) + Math_fround(Math_fround(f18 * f20) + Math_fround(f19 * Math_fround(Math_fround(f16 * f14) - Math_fround(f21 * f17)))));
 f1 = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)))) + Math_fround(f14 * f1));
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f8);
 f9 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f9);
 f1 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f1);
 HEAPF32[i11 >> 2] = f8;
 HEAPF32[i11 + 4 >> 2] = f9;
 HEAPF32[i11 + 8 >> 2] = f1;
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 & 8 | 0) {
  i4 = i13 + 12 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -4 | 2;
  HEAPF32[i13 >> 2] = f5;
  HEAPF32[i13 + 4 >> 2] = f6;
  HEAPF32[i13 + 8 >> 2] = f7;
  HEAPF32[i13 + 16 >> 2] = f8;
  HEAPF32[i13 + 20 >> 2] = f9;
  HEAPF32[i13 + 24 >> 2] = f1;
  i4 = i13 + 60 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 2;
 }
 if (i2 & 16 | 0) {
  i3 = i13 + 12 | 0;
  i22 = HEAP32[i3 >> 2] | 0;
  i4 = i22 | 1;
  HEAP32[i3 >> 2] = i4;
  if (!(i22 & 4)) {
   HEAPF32[i13 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i13 >> 2]));
   i22 = i13 + 4 | 0;
   HEAPF32[i22 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i22 >> 2]));
   i22 = i13 + 8 | 0;
   HEAPF32[i22 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i22 >> 2]));
  } else {
   HEAPF32[i13 >> 2] = f5;
   HEAPF32[i13 + 4 >> 2] = f6;
   HEAPF32[i13 + 8 >> 2] = f7;
   HEAP32[i3 >> 2] = i4 & -5;
  }
  i22 = i13 + 16 | 0;
  HEAPF32[i22 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i22 >> 2]));
  i22 = i13 + 20 | 0;
  HEAPF32[i22 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i22 >> 2]));
  i22 = i13 + 24 | 0;
  HEAPF32[i22 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i22 >> 2]));
  i22 = i13 + 28 | 0;
  HEAPF32[i22 >> 2] = Math_fround(Math_fround(HEAPF32[i22 >> 2]) + Math_fround(1.0));
  i22 = i13 + 60 | 0;
  HEAP16[i22 >> 1] = HEAPU16[i22 >> 1] | 0 | 2;
 }
 if (!(i2 & 40)) {
  STACKTOP = i12;
  return;
 }
 __ZN5physx13addConstraintERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_(i13, i10, i11);
 STACKTOP = i12;
 return;
}

function _psh_hint_align(i12, i6, i7, i8) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i5 = HEAP32[i6 + 4 + (i7 * 204 | 0) + 196 >> 2] | 0;
 i16 = i12 + 16 | 0;
 if (HEAP32[i16 >> 2] & 8 | 0) {
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i6 + 4 + (i7 * 204 | 0) + 200 >> 2] | 0;
 i1 = (_UNITY_FT_MulFix(HEAP32[i12 >> 2] | 0, i5) | 0) + i1 | 0;
 i4 = i12 + 4 | 0;
 i9 = _UNITY_FT_MulFix(HEAP32[i4 >> 2] | 0, i5) | 0;
 switch (i7 | 0) {
 case 0:
  {
   i2 = HEAP32[i8 + 120 >> 2] | 0;
   if (!((i2 & 255) << 24 >> 24)) i10 = 5; else {
    i3 = 0;
    i11 = (i2 & 16711680 | 0) != 0;
   }
   break;
  }
 case 1:
  {
   if (!(HEAP8[i8 + 121 >> 0] | 0)) i10 = 5; else {
    i3 = 1;
    i11 = (HEAP8[i8 + 123 >> 0] | 0) != 0;
   }
   break;
  }
 default:
  {
   i3 = 0;
   i11 = 0;
  }
 }
 if ((i10 | 0) == 5) {
  HEAP32[i12 + 8 >> 2] = i1;
  HEAP32[i12 + 12 >> 2] = i9;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 8;
  STACKTOP = i17;
  return;
 }
 i13 = i12 + 12 | 0;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i15 >> 2] = 0;
 i14 = i15 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = i15 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 L13 : do if (i3) {
  i3 = HEAP32[i12 >> 2] | 0;
  _psh_blues_snap_stem(i6 + 412 | 0, (HEAP32[i4 >> 2] | 0) + i3 | 0, i3, i15);
  switch (HEAP32[i15 >> 2] | 0) {
  case 1:
   {
    i3 = (HEAP32[i14 >> 2] | 0) - i9 | 0;
    HEAP32[i12 + 8 >> 2] = i3;
    break L13;
   }
  case 2:
   {
    i3 = HEAP32[i2 >> 2] | 0;
    HEAP32[i12 + 8 >> 2] = i3;
    break L13;
   }
  case 3:
   {
    i3 = HEAP32[i2 >> 2] | 0;
    HEAP32[i12 + 8 >> 2] = i3;
    HEAP32[i13 >> 2] = (HEAP32[i14 >> 2] | 0) - i3;
    break L13;
   }
  default:
   {
    i10 = 13;
    break L13;
   }
  }
 } else i10 = 13; while (0);
 if ((i10 | 0) == 13) {
  i2 = HEAP32[i12 + 20 >> 2] | 0;
  if (i2) {
   if (!(HEAP32[i2 + 16 >> 2] & 8)) _psh_hint_align(i2, i6, i7, i8);
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = HEAP32[i2 + 12 >> 2] >> 1;
   i1 = i3 - (i9 >> 1) + i1 + (_UNITY_FT_MulFix((HEAP32[i12 >> 2] | 0) - ((HEAP32[i2 + 4 >> 2] >> 1) + (HEAP32[i2 >> 2] | 0)) + (HEAP32[i4 >> 2] >> 1) | 0, i5) | 0) | 0;
  }
  i5 = i12 + 8 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i13 >> 2] = i9;
  do if (!(HEAP8[i8 + 124 >> 0] | 0)) i3 = i9; else {
   if ((i9 | 0) < 65) {
    if ((i9 | 0) > 31) {
     i3 = 64;
     i1 = i1 + (i9 >> 1) & -64;
     break;
    }
    i2 = i1 + 32 & -64;
    if ((i9 | 0) <= 0) {
     i3 = i9;
     i1 = i2;
     break;
    }
    i3 = i1 + i9 | 0;
    i10 = i3 + 32 & -64;
    i8 = i2 - i1 | 0;
    i1 = i10 - i3 | 0;
    i3 = i9;
    i1 = (((i8 | 0) < 0 ? 0 - i8 | 0 : i8) | 0) > (((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) ? i10 : i2;
    break;
   }
   i2 = HEAP32[i6 + 4 + (i7 * 204 | 0) + 8 >> 2] | 0;
   i8 = i9 - i2 | 0;
   if ((((i8 | 0) < 0 ? 0 - i8 | 0 : i8) | 0) < 40) if ((i2 | 0) < 48) {
    i2 = 48;
    i3 = 48;
    i4 = 0;
   } else i10 = 25; else {
    i2 = i9;
    i10 = 25;
   }
   if ((i10 | 0) == 25) {
    if ((i2 | 0) >= 192) {
     i3 = i2 + 32 & -64;
     break;
    }
    i3 = i2 & 63;
    i4 = i2 & -64;
    if (i3 >>> 0 < 10) {
     i3 = i2;
     break;
    }
    if (i3 >>> 0 < 32) {
     i3 = i4 | 10;
     break;
    }
   }
   i3 = i3 >>> 0 < 54 ? i4 | 54 : i2;
  } while (0);
  i9 = i1 + 32 | 0;
  i10 = (i9 & -64) - i1 | 0;
  i9 = (i9 + i3 & -64) - i1 - i3 | 0;
  i10 = ((((i10 | 0) < 0 ? 0 - i10 | 0 : i10) | 0) > (((i9 | 0) < 0 ? 0 - i9 | 0 : i9) | 0) ? i9 : i10) + i1 | 0;
  HEAP32[i5 >> 2] = i10;
  HEAP32[i13 >> 2] = i3;
  i3 = i10;
 }
 L48 : do if (i11) {
  i2 = i12 + 8 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i1 = (i1 | 0) < 64 ? 64 : i1 + 32 & -64;
  switch (HEAP32[i15 >> 2] | 0) {
  case 3:
   break L48;
  case 1:
   {
    HEAP32[i2 >> 2] = (HEAP32[i14 >> 2] | 0) - i1;
    HEAP32[i13 >> 2] = i1;
    break L48;
   }
  case 2:
   {
    HEAP32[i13 >> 2] = i1;
    break L48;
   }
  default:
   {
    i15 = i1 >> 1;
    i14 = i3 + i15 | 0;
    HEAP32[i2 >> 2] = ((i1 & 64 | 0) == 0 ? i14 + 32 & -64 : i14 & -64 | 32) - i15;
    HEAP32[i13 >> 2] = i1;
    break L48;
   }
  }
 } while (0);
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 8;
 STACKTOP = i17;
 return;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce(i1, i19, i16, i17, d9) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 d9 = +d9;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 72 | 0;
 i7 = i18 + 48 | 0;
 i6 = i18 + 32 | 0;
 i4 = i18 + 24 | 0;
 i2 = i18 + 8 | 0;
 i8 = i18;
 i11 = i18 + 134 | 0;
 i10 = i18 + 68 | 0;
 i3 = i18 + 76 | 0;
 i15 = i18 + 64 | 0;
 i13 = i18 + 60 | 0;
 i14 = i18 + 56 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = 37;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = __ZNSt3__214__num_put_base14__format_floatEPcPKcj(i8 + 1 | 0, gb + 1083681 | 0, HEAP32[i16 + 4 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = __ZNSt3__26__clocEv() | 0;
 if (i5) {
  HEAP32[i2 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAPF64[i2 + 8 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i2) | 0;
 } else {
  HEAPF64[i4 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i4) | 0;
 }
 do if ((i1 | 0) > 29) {
  if (i5) {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAPF64[i6 + 8 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i6 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  } else {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    __THREW__ = 0;
    HEAPF64[i7 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i7 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  }
  if ((i20 | 0) == 12) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i4 = i2;
    i7 = i2;
    i20 = 16;
    break;
   }
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) {
    i7 = HEAP32[i10 >> 2] | 0;
    i4 = i7;
    i20 = 16;
    break;
   }
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = 0;
  i20 = 16;
 } while (0);
 if ((i20 | 0) == 16) {
  i5 = i4 + i1 | 0;
  i6 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i4, i5, i16) | 0;
  L22 : do if ((i4 | 0) == (i11 | 0)) {
   i4 = 0;
   i1 = i11;
   i20 = 22;
  } else {
   i2 = _malloc(i1 << 1) | 0;
   do if (!i2) {
    __THREW__ = 0;
    invoke_v(fb + 459 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L22;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i1 = i4; while (0);
   i3 = i2;
   i4 = i2;
   i20 = 22;
  } while (0);
  if ((i20 | 0) == 22) {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2804 | 0, i16 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   do if (i11 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i20 = 32;
   } else {
    HEAP32[i12 >> 2] = i2;
    __THREW__ = 0;
    invoke_viiiiiii(fb + 42 | 0, i1 | 0, i6 | 0, i5 | 0, i3 | 0, i15 | 0, i13 | 0, i12 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
     i20 = 32;
     break;
    }
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
    i15 = HEAP32[i15 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    i1 = invoke_iiiiiii(fb + 146 | 0, i12 | 0, i3 | 0, i15 | 0, i1 | 0, i16 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    HEAP32[i19 >> 2] = i1;
    if (i4 | 0) _free(i4);
    if (i7 | 0) _free(i7);
    STACKTOP = i18;
    return i1 | 0;
   } while (0);
   if (i4) _free(i4);
  }
  if (i7) _free(i7);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd(i1, i19, i16, i17, d9) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 d9 = +d9;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 72 | 0;
 i7 = i18 + 48 | 0;
 i6 = i18 + 32 | 0;
 i4 = i18 + 24 | 0;
 i2 = i18 + 8 | 0;
 i8 = i18;
 i11 = i18 + 134 | 0;
 i10 = i18 + 68 | 0;
 i3 = i18 + 76 | 0;
 i15 = i18 + 64 | 0;
 i13 = i18 + 60 | 0;
 i14 = i18 + 56 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = 37;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = __ZNSt3__214__num_put_base14__format_floatEPcPKcj(i8 + 1 | 0, gb + 1576256 | 0, HEAP32[i16 + 4 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = __ZNSt3__26__clocEv() | 0;
 if (i5) {
  HEAP32[i2 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAPF64[i2 + 8 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i2) | 0;
 } else {
  HEAPF64[i4 >> 3] = d9;
  i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i11, 30, i1, i8, i4) | 0;
 }
 do if ((i1 | 0) > 29) {
  if (i5) {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    __THREW__ = 0;
    HEAP32[i6 >> 2] = HEAP32[i16 + 8 >> 2];
    HEAPF64[i6 + 8 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i6 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  } else {
   __THREW__ = 0;
   i1 = invoke_i(fb + 314 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) {
    __THREW__ = 0;
    HEAPF64[i7 >> 3] = d9;
    i1 = invoke_iiiii(fb + 207 | 0, i10 | 0, i1 | 0, i8 | 0, i7 | 0) | 0;
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) i20 = 12;
   }
  }
  if ((i20 | 0) == 12) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) {
    i4 = i2;
    i7 = i2;
    i20 = 16;
    break;
   }
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) {
    i7 = HEAP32[i10 >> 2] | 0;
    i4 = i7;
    i20 = 16;
    break;
   }
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = 0;
  i20 = 16;
 } while (0);
 if ((i20 | 0) == 16) {
  i5 = i4 + i1 | 0;
  i6 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i4, i5, i16) | 0;
  L22 : do if ((i4 | 0) == (i11 | 0)) {
   i4 = 0;
   i1 = i11;
   i20 = 22;
  } else {
   i2 = _malloc(i1 << 1) | 0;
   do if (!i2) {
    __THREW__ = 0;
    invoke_v(fb + 459 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L22;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     break;
    }
   } else i1 = i4; while (0);
   i3 = i2;
   i4 = i2;
   i20 = 22;
  } while (0);
  if ((i20 | 0) == 22) {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2804 | 0, i16 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   do if (i11 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i20 = 32;
   } else {
    HEAP32[i12 >> 2] = i2;
    __THREW__ = 0;
    invoke_viiiiiii(fb + 42 | 0, i1 | 0, i6 | 0, i5 | 0, i3 | 0, i15 | 0, i13 | 0, i12 | 0);
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
     i20 = 32;
     break;
    }
    __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
    i15 = HEAP32[i15 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    __THREW__ = 0;
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    i1 = invoke_iiiiiii(fb + 146 | 0, i12 | 0, i3 | 0, i15 | 0, i1 | 0, i16 | 0, i17 | 0) | 0;
    i17 = __THREW__;
    __THREW__ = 0;
    if (i17 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
    HEAP32[i19 >> 2] = i1;
    if (i4 | 0) _free(i4);
    if (i7 | 0) _free(i7);
    STACKTOP = i18;
    return i1 | 0;
   } while (0);
   if (i4) _free(i4);
  }
  if (i7) _free(i7);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN15SerializeTraitsI12AspectRatiosE8TransferI14SafeBinaryReadEEvRS0_RT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i3 = i6 + 1 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 450070 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i6 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 450074 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i6 + 3 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 450078 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 450084 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 450089 | 0, i4, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 1);
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i1, i10, i9, i3, f2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12 + 4 | 0;
 i8 = i12;
 i1 = HEAP32[i1 + 120 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i1 + (i9 * 40 | 0) >> 2]);
 HEAPF32[i10 + 4 >> 2] = Math_fround(f20 + f2);
 f25 = Math_fround(HEAPF32[i1 + (i3 * 40 | 0) >> 2]);
 HEAPF32[i10 + 8 >> 2] = Math_fround(f25 + f2);
 HEAP32[i10 >> 2] = i9;
 f20 = Math_fround(f25 - f20);
 HEAPF32[i13 >> 2] = f20;
 HEAPF32[i8 >> 2] = Math_fround(.0000999999974);
 i7 = f20 < Math_fround(.0000999999974);
 i8 = HEAP32[(i7 ? i8 : i13) >> 2] | 0;
 HEAP32[i13 >> 2] = i8;
 i13 = i1 + (i9 * 40 | 0) + 4 | 0;
 f20 = Math_fround(HEAPF32[i1 + (i3 * 40 | 0) + 4 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i13 >> 2]));
 f25 = Math_fround(HEAPF32[i1 + (i3 * 40 | 0) + 8 >> 2]);
 f25 = Math_fround(f25 - Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 8 >> 2]));
 f23 = Math_fround(HEAPF32[i1 + (i3 * 40 | 0) + 12 >> 2]);
 f23 = Math_fround(f23 - Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 12 >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = Math_fround(Math_fround(1.0) / Math_fround(f28 * f28));
 i8 = i1 + (i9 * 40 | 0) + 28 | 0;
 f15 = Math_fround(HEAPF32[i8 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + (i9 * 40 | 0) + 36 >> 2]);
 i7 = i1 + (i3 * 40 | 0) + 16 | 0;
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + (i3 * 40 | 0) + 20 >> 2]);
 f19 = Math_fround(f28 * f15);
 f24 = Math_fround(f28 * f14);
 f22 = Math_fround(f28 * f2);
 f18 = Math_fround(f28 * f18);
 f17 = Math_fround(f28 * f17);
 f16 = Math_fround(f28 * Math_fround(HEAPF32[i1 + (i3 * 40 | 0) + 24 >> 2]));
 f27 = Math_fround(Math_fround(f21 * Math_fround(Math_fround(Math_fround(f24 + f17) - f25) - f25)) / f28);
 f26 = Math_fround(Math_fround(f21 * Math_fround(Math_fround(Math_fround(f22 + f16) - f23) - f23)) / f28);
 i6 = i10 + 12 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(f21 * Math_fround(Math_fround(Math_fround(f19 + f18) - f20) - f20)) / f28);
 HEAPF32[i10 + 16 >> 2] = f27;
 HEAPF32[i10 + 20 >> 2] = f26;
 f17 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(Math_fround(f25 + Math_fround(f25 + f25)) - f24) - f24) - f17));
 f16 = Math_fround(f21 * Math_fround(Math_fround(Math_fround(Math_fround(f23 + Math_fround(f23 + f23)) - f22) - f22) - f16));
 i5 = i10 + 24 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f21 * Math_fround(Math_fround(Math_fround(Math_fround(f20 + Math_fround(f20 + f20)) - f19) - f19) - f18));
 HEAPF32[i10 + 28 >> 2] = f17;
 HEAPF32[i10 + 32 >> 2] = f16;
 i4 = i10 + 36 | 0;
 HEAPF32[i4 >> 2] = f15;
 HEAPF32[i10 + 40 >> 2] = f14;
 HEAPF32[i10 + 44 >> 2] = f2;
 i3 = i10 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i3 = i1 + (i9 * 40 | 0) + 4 | 0;
 i1 = i10 + 48 | 0;
 i10 = Math_fround(HEAPF32[i8 >> 2]) == Math_fround(inf);
 if (i10 | Math_fround(HEAPF32[i7 >> 2]) == Math_fround(inf)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 }
 if (Math_fround(HEAPF32[i8 + 4 >> 2]) == Math_fround(inf)) i11 = 5; else if (Math_fround(HEAPF32[i7 + 4 >> 2]) == Math_fround(inf)) i11 = 5;
 if ((i11 | 0) == 5) {
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 }
 if (!(Math_fround(HEAPF32[i8 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i7 + 8 >> 2]) == Math_fround(inf))) {
  STACKTOP = i12;
  return;
 }
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i12;
 return;
}

function __ZN17PersistentManagerD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 HEAP32[i10 >> 2] = gb + 66904 + 8;
 i12 = i10 + 4 | 0;
 i3 = i10 + 16 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  do {
   i9 = i2 + 16 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i9 >> 2] = 0;
   if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
    HEAP32[i1 >> 2] = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63416 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    __ZN14SerializedFile7ReleaseEv(i1);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i2 + 24 | 0;
  } while ((i2 | 0) != ((HEAP32[i12 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0));
 }
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2 + 12 | 0, HEAP32[i2 + 16 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63416 | 0);
 HEAP32[i1 >> 2] = 0;
 __Z20CleanupStdConvertersv();
 i1 = HEAP32[i10 + 168 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i10 + 96 | 0, HEAP32[i10 + 100 >> 2] | 0);
 i3 = i10 + 64 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i10 + 68 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i9 = i2 + -24 | 0;
    HEAP32[i4 >> 2] = i9;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + -12 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  i9 = HEAP32[i10 + 76 >> 2] | 0;
  HEAP32[i11 >> 2] = 37;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 i7 = i10 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i8 = i10 + 44 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i9 = i11 + 4 | 0;
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i8 >> 2] = i3;
    i5 = HEAP32[i2 + -16 >> 2] | 0;
    i6 = i5;
    if (!i5) i2 = i3; else {
     i3 = i2 + -12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i6 | 0) >>> 3) << 3);
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i11 >> 2] = 37;
     HEAP32[i9 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i9 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i11 >> 2] = 37;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 i7 = i10 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i8 = i10 + 28 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i9 = i11 + 4 | 0;
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i8 >> 2] = i3;
    i5 = HEAP32[i2 + -16 >> 2] | 0;
    i6 = i5;
    if (!i5) i2 = i3; else {
     i3 = i2 + -12 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i6 | 0) >>> 3) << 3);
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i11 >> 2] = 37;
     HEAP32[i9 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
     i2 = HEAP32[i8 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i9 = HEAP32[i10 + 36 >> 2] | 0;
  HEAP32[i11 >> 2] = 37;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 if ((HEAP32[i10 + 20 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i10 + 8 | 0);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Ext7D6Joint11prepareDataEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0;
 i13 = HEAP32[i2 + 80 >> 2] | 0;
 i1 = i2 + 85 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  f17 = Math_fround(HEAPF32[i13 + 168 >> 2]);
  HEAPF32[i13 + 336 >> 2] = Math_fround(+Math_tan(+Math_fround(f17 * Math_fround(.5))));
  f16 = Math_fround(HEAPF32[i13 + 172 >> 2]);
  HEAPF32[i13 + 340 >> 2] = Math_fround(+Math_tan(+Math_fround(f16 * Math_fround(.5))));
  f15 = Math_fround(HEAPF32[i13 + 164 >> 2]);
  HEAPF32[i13 + 344 >> 2] = Math_fround(+Math_tan(+Math_fround(f15 * Math_fround(.5))));
  HEAPF32[i13 + 348 >> 2] = Math_fround(+Math_tan(+Math_fround(f17 * Math_fround(.25))));
  HEAPF32[i13 + 352 >> 2] = Math_fround(+Math_tan(+Math_fround(f16 * Math_fround(.25))));
  HEAPF32[i13 + 356 >> 2] = Math_fround(+Math_tan(+Math_fround(f15 * Math_fround(.25))));
  HEAPF32[i13 + 360 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i13 + 144 >> 2]) * Math_fround(.25))));
  HEAPF32[i13 + 364 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i13 + 140 >> 2]) * Math_fround(.25))));
  HEAPF32[i13 + 368 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i13 + 136 >> 2]) * Math_fround(.25))));
  HEAP8[i1 >> 0] = 0;
 }
 i11 = i2 + 84 | 0;
 if (!(HEAP8[i11 >> 0] | 0)) return i13 | 0;
 i12 = i13 + 332 | 0;
 HEAP32[i12 >> 2] = 0;
 i6 = i13 + 328 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 324 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = HEAP32[i13 + 72 >> 2] | 0;
 switch (i8 | 0) {
 case 1:
  {
   HEAP32[i6 >> 2] = 1;
   i1 = 0;
   i2 = 1;
   break;
  }
 case 0:
  {
   HEAP32[i7 >> 2] = 1;
   i1 = 1;
   i2 = 0;
   break;
  }
 default:
  {
   i1 = 0;
   i2 = 0;
  }
 }
 i10 = HEAP32[i13 + 76 >> 2] | 0;
 switch (i10 | 0) {
 case 1:
  {
   i2 = i2 | 2;
   HEAP32[i6 >> 2] = i2;
   break;
  }
 case 0:
  {
   i1 = i1 | 2;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 i9 = HEAP32[i13 + 80 >> 2] | 0;
 switch (i9 | 0) {
 case 1:
  {
   i2 = i2 | 4;
   HEAP32[i6 >> 2] = i2;
   break;
  }
 case 0:
  {
   i1 = i1 | 4;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 i3 = HEAP32[i13 + 84 >> 2] | 0;
 switch (i3 | 0) {
 case 1:
  {
   i2 = i2 | 8;
   HEAP32[i6 >> 2] = i2;
   break;
  }
 case 0:
  {
   i1 = i1 | 8;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 i5 = HEAP32[i13 + 88 >> 2] | 0;
 switch (i5 | 0) {
 case 1:
  {
   i2 = i2 | 16;
   HEAP32[i6 >> 2] = i2;
   break;
  }
 case 0:
  {
   i1 = i1 | 16;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 i4 = HEAP32[i13 + 92 >> 2] | 0;
 switch (i4 | 0) {
 case 1:
  {
   HEAP32[i6 >> 2] = i2 | 32;
   break;
  }
 case 0:
  {
   HEAP32[i7 >> 2] = i1 | 32;
   break;
  }
 default:
  {}
 }
 if (Math_fround(HEAPF32[i13 + 176 >> 2]) != Math_fround(0.0)) if (!i8) i1 = 0; else i14 = 10; else if ((i8 | 0) == 0 ? 1 : Math_fround(HEAPF32[i13 + 180 >> 2]) == Math_fround(0.0)) i1 = 0; else i14 = 10;
 if ((i14 | 0) == 10) {
  HEAP32[i12 >> 2] = 1;
  i1 = 1;
 }
 if (Math_fround(HEAPF32[i13 + 192 >> 2]) != Math_fround(0.0)) {
  if (i10) i14 = 14;
 } else if (!((i10 | 0) == 0 ? 1 : Math_fround(HEAPF32[i13 + 196 >> 2]) == Math_fround(0.0))) i14 = 14;
 if ((i14 | 0) == 14) {
  i1 = i1 | 2;
  HEAP32[i12 >> 2] = i1;
 }
 if (Math_fround(HEAPF32[i13 + 208 >> 2]) != Math_fround(0.0)) {
  if (i9) i14 = 18;
 } else if (!((i9 | 0) == 0 ? 1 : Math_fround(HEAPF32[i13 + 212 >> 2]) == Math_fround(0.0))) i14 = 18;
 if ((i14 | 0) == 18) {
  i1 = i1 | 4;
  HEAP32[i12 >> 2] = i1;
 }
 i2 = (i3 | 0) == 0;
 do if (Math_fround(HEAPF32[i13 + 256 >> 2]) != Math_fround(0.0)) i14 = 21; else if (Math_fround(HEAPF32[i13 + 260 >> 2]) != Math_fround(0.0)) i14 = 21; else {
  if (Math_fround(HEAPF32[i13 + 240 >> 2]) != Math_fround(0.0)) i3 = 0; else i3 = Math_fround(HEAPF32[i13 + 244 >> 2]) == Math_fround(0.0);
  if (!(i2 | i3)) {
   i1 = i1 | 16;
   HEAP32[i12 >> 2] = i1;
  }
  if (Math_fround(HEAPF32[i13 + 224 >> 2]) != Math_fround(0.0)) {
   if (!(i4 | i5)) break;
  } else if ((i4 | i5 | 0) == 0 ? 1 : Math_fround(HEAPF32[i13 + 228 >> 2]) == Math_fround(0.0)) break;
  HEAP32[i12 >> 2] = i1 | 8;
 } while (0);
 if ((i14 | 0) == 21) HEAP32[i12 >> 2] = i1 | 32;
 HEAP8[i11 >> 0] = 0;
 return i13 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 L1 : do if ((i3 - i1 | 0) > 1) {
  i2 = HEAP8[i1 >> 0] | 0;
  L3 : do switch (i2 << 24 >> 24) {
  case 100:
  case 111:
   {
    if ((HEAP8[i1 + 1 >> 0] | 0) == 110) {
     i4 = i1 + 2 | 0;
     if (i2 << 24 >> 24 != 111) {
      if ((i4 | 0) == (i3 | 0)) i2 = i3; else {
       i2 = __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_(i4, i3, i7) | 0;
       if ((i2 | 0) == (i4 | 0)) i2 = __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i4, i3, i7) | 0;
       if ((i2 | 0) == (i4 | 0)) i2 = i4; else {
        i3 = HEAP32[i7 + 4 >> 2] | 0;
        if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) i2 = i4; else __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i3 + -24 | 0, 0, gb + 1086597 | 0) | 0;
       }
      }
      i1 = (i2 | 0) == (i4 | 0) ? i1 : i2;
      break L1;
     }
     i2 = __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_(i4, i3, i7) | 0;
     if ((i2 | 0) == (i4 | 0)) break L1;
     i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i2, i3, i7) | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = i2;
      break L1;
     }
     i5 = i7 + 4 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     if (((i2 - (HEAP32[i7 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i8, i2 + -24 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + -24 | 0;
     i4 = i2;
     while (1) {
      if ((i4 | 0) == (i3 | 0)) break;
      i7 = i4 + -24 | 0;
      HEAP32[i5 >> 2] = i7;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i7);
      i4 = HEAP32[i5 >> 2] | 0;
     }
     i7 = HEAP8[i8 + 11 >> 0] | 0;
     i5 = i7 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i5 ? HEAP32[i8 >> 2] | 0 : i8) | 0, (i5 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255) | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
      break L3;
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
      break L1;
     }
    } else i6 = 21;
    break;
   }
  default:
   i6 = 21;
  } while (0);
  do if ((i6 | 0) == 21) {
   i2 = __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i7) | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i1 = i2;
    break L1;
   }
   i2 = __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i3, i7) | 0;
   if ((i2 | 0) == (i1 | 0)) break L1;
   i1 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i2, i3, i7) | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = i2;
    break L1;
   }
   i5 = i7 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (((i2 - (HEAP32[i7 >> 2] | 0) | 0) / 24 | 0) >>> 0 < 2) break L1;
   __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i8, i2 + -24 | 0);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = i2 + -24 | 0;
   i4 = i2;
   while (1) {
    if ((i4 | 0) == (i3 | 0)) break;
    i7 = i4 + -24 | 0;
    HEAP32[i5 >> 2] = i7;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i7);
    i4 = HEAP32[i5 >> 2] | 0;
   }
   i7 = HEAP8[i8 + 11 >> 0] | 0;
   i6 = i7 << 24 >> 24 < 0;
   __THREW__ = 0;
   invoke_iiii(fb + 519 | 0, i2 + -48 | 0, (i6 ? HEAP32[i8 >> 2] | 0 : i8) | 0, (i6 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255) | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
    break;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
    break L1;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 4 | 0;
 i13 = i15;
 i2 = HEAP32[i1 + 352 >> 2] | 0;
 i9 = i1 + 356 | 0;
 if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = i12 + 8 | 0;
 i7 = i12 + 4 | 0;
 i8 = (i11 & 8 | 0) == 0;
 if (!(i11 & 16)) {
  do {
   i1 = HEAP32[i2 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i13 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i14 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
      i3 = HEAP32[i12 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 10; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i14 = 11;
     }
    }
    if ((i14 | 0) == 10) i14 = 11;
    if ((i14 | 0) == 11) {
     i14 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
     if (!i1) break;
    }
    i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 35740 | 0) | 0;
    do if (i3 | 0) if (i8) {
     i6 = i3 + 224 | 0;
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i11;
     break;
    } else {
     __ZN7Terrain5FlushEv(i3);
     break;
    } while (0);
    HEAP32[i12 >> 2] = gb + 29192;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i7 >> 2] = i11;
    __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105776 | 0, i12);
   } while (0);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
  STACKTOP = i15;
  return;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i13 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 25; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i3 = HEAP32[i12 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 25; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 27;
    }
   }
   if ((i14 | 0) == 25) i14 = 27;
   if ((i14 | 0) == 27) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 35740 | 0) | 0;
   do if (i4 | 0) {
    i5 = i4 + 228 | 0;
    i6 = i4 + 240 | 0;
    if (HEAP32[i6 >> 2] | 0) {
     i3 = HEAP32[i5 >> 2] | 0;
     do {
      __ZN14DetailRenderer18ReloadDirtyDetailsEv(HEAP32[i3 + 12 >> 2] | 0);
      i3 = i3 + 20 | 0;
     } while ((i3 | 0) != ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 20 | 0) | 0));
    }
    if (i8) {
     i6 = i4 + 224 | 0;
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i11;
     break;
    } else {
     __ZN7Terrain5FlushEv(i4);
     break;
    }
   } while (0);
   HEAP32[i12 >> 2] = gb + 29192;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i7 >> 2] = i11;
   __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105776 | 0, i12);
  } while (0);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = i13 - i8 >> 5;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > i1 - i2 >> 5 >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -32 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -20 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = i1 - i2 | 0;
  i1 = i14 >> 4;
  i1 = i14 >> 5 >>> 0 < 67108863 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 134217727;
  if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 << 5) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 << 5);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = (HEAP32[i11 >> 2] | 0) - i2 >> 5;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 << 5) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i8 = i8 + 32 | 0;
   i1 = i1 + 32 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i9, i13, i15 - ((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) >> 5) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -32 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -20 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = (i13 - i8 | 0) / 28 | 0;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 28 | 0) >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -28 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -16 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 153391689) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = (i1 - i2 | 0) / 28 | 0;
  i1 = i14 << 1;
  i1 = i14 >>> 0 < 76695844 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 153391689;
  if (i1 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 * 28 | 0) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 * 28 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 28 | 0;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 * 28 | 0) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i7 = i1 + 16 | 0;
   i6 = i8 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i8 = i8 + 28 | 0;
   i1 = i1 + 28 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i9, i13, i15 - (((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 28 | 0) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -28 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -16 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f19 = Math_fround(f12 + f12);
 f23 = Math_fround(f6 + f6);
 f25 = Math_fround(f17 + f17);
 f10 = Math_fround(f6 * f23);
 f18 = Math_fround(f17 * f25);
 f6 = Math_fround(f19 * f6);
 f15 = Math_fround(f19 * f17);
 f16 = Math_fround(f19 * f24);
 f17 = Math_fround(f23 * f17);
 f23 = Math_fround(f23 * f24);
 f24 = Math_fround(f25 * f24);
 f25 = Math_fround(Math_fround(Math_fround(1.0) - f10) - f18);
 f20 = Math_fround(f6 + f24);
 f14 = Math_fround(f15 - f23);
 f24 = Math_fround(f6 - f24);
 f19 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f19));
 f18 = Math_fround(f19 - f18);
 f12 = Math_fround(f17 + f16);
 f23 = Math_fround(f15 + f23);
 f16 = Math_fround(f17 - f16);
 f10 = Math_fround(f19 - f10);
 f19 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 124 >> 2]));
 HEAPF32[i2 >> 2] = f19;
 HEAPF32[i2 + 20 >> 2] = f19;
 HEAPF32[i2 + 40 >> 2] = f19;
 f19 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 112 >> 2]));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 116 >> 2]));
 f15 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 120 >> 2]));
 f6 = Math_fround(f24 * Math_fround(0.0));
 f5 = Math_fround(f18 * Math_fround(0.0));
 f9 = Math_fround(f12 * Math_fround(0.0));
 f21 = Math_fround(f23 * Math_fround(0.0));
 f11 = Math_fround(f16 * Math_fround(0.0));
 f26 = Math_fround(f10 * Math_fround(0.0));
 f22 = Math_fround(f21 + Math_fround(f6 + Math_fround(f25 * f19)));
 f13 = Math_fround(f11 + Math_fround(f5 + Math_fround(f20 * f19)));
 f19 = Math_fround(f26 + Math_fround(f9 + Math_fround(f14 * f19)));
 f8 = Math_fround(f25 * Math_fround(0.0));
 f4 = Math_fround(f20 * Math_fround(0.0));
 f7 = Math_fround(f14 * Math_fround(0.0));
 f21 = Math_fround(f21 + Math_fround(f8 + Math_fround(f24 * f17)));
 f11 = Math_fround(f11 + Math_fround(f4 + Math_fround(f18 * f17)));
 f17 = Math_fround(f26 + Math_fround(f7 + Math_fround(f12 * f17)));
 f6 = Math_fround(Math_fround(f8 + f6) + Math_fround(f23 * f15));
 f5 = Math_fround(Math_fround(f4 + f5) + Math_fround(f16 * f15));
 f15 = Math_fround(Math_fround(f7 + f9) + Math_fround(f10 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f25 * f22) + Math_fround(f24 * f21)) + Math_fround(f23 * f6));
 f7 = Math_fround(Math_fround(Math_fround(f20 * f13) + Math_fround(f18 * f11)) + Math_fround(f16 * f5));
 f4 = Math_fround(Math_fround(Math_fround(f14 * f19) + Math_fround(f12 * f17)) + Math_fround(f10 * f15));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f25 * f13) + Math_fround(f24 * f11)) + Math_fround(f23 * f5)) + Math_fround(Math_fround(Math_fround(f20 * f22) + Math_fround(f18 * f21)) + Math_fround(f16 * f6))) * Math_fround(.5));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f25 * f19) + Math_fround(f24 * f17)) + Math_fround(f23 * f15)) + Math_fround(Math_fround(Math_fround(f14 * f22) + Math_fround(f12 * f21)) + Math_fround(f10 * f6))) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f7 + f7) * Math_fround(.5));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f17)) + Math_fround(f16 * f15)) + Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * f11)) + Math_fround(f10 * f5))) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f4 + f4) * Math_fround(.5));
 HEAPF32[i2 + 96 >> 2] = Math_fround(Math_fround(f9 + f9) * Math_fround(.5));
 HEAPF32[i2 + 100 >> 2] = f8;
 HEAPF32[i2 + 104 >> 2] = f6;
 HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 112 >> 2] = f8;
 HEAPF32[i2 + 116 >> 2] = f7;
 HEAPF32[i2 + 120 >> 2] = f5;
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 128 >> 2] = f6;
 HEAPF32[i2 + 132 >> 2] = f5;
 HEAPF32[i2 + 136 >> 2] = f4;
 HEAPF32[i2 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i21 = i10 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i20 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i20;
 i22 = i10 + 9 | 0;
 HEAP8[i22 >> 0] = (i20 & 65535) >>> 8;
 i20 = i10 + 12 | 0;
 i19 = i7 + 12 | 0;
 i15 = i19;
 i18 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i10 + 20 | 0;
 i18 = i7 + 20 | 0;
 i15 = i18;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i21 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i21 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i21;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
 HEAP8[i22 >> 0] = i2;
 i2 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i22 = i20;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = i21;
 HEAP32[i20 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i18 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i20 = i17;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 6;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 _memset(i5 | 0, 0, 164) | 0;
 __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev(i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 1 | 0, i3 + 12 | 0, i5);
 _memset(i5 | 0, 0, 168) | 0;
 __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev(i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 2 | 0, i3 + 36 | 0, i5);
 _memset(i5 | 0, 0, 140) | 0;
 __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev(i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 3 | 0, i3 + 60 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 4 | 0, i3 + 84 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 5 | 0, i3 + 108 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 6 | 0, i3 + 132 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 7 | 0, i3 + 156 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 8 | 0, i3 + 180 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 9 | 0, i3 + 204 | 0, i5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj622ES3_RKNS_27PxVehicleTireLoadFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 228 | 0, i2 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj623ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 244 | 0, i2 + 11 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj624ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 260 | 0, i2 + 12 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 276 | 0, i2 + 13 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 292 | 0, i2 + 14 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2 + 15 | 0, i3 + 308 | 0, i5);
 STACKTOP = i4;
 return i2 + 16 | 0;
}

function __ZN9Heightmap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 4 | 0;
 i5 = i10;
 i3 = i8 + 4 | 0;
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i12 = i6 + 8 | 0;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i2 = i8 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = i11;
 }
 HEAP16[i4 >> 1] = 0;
 __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy(i3, i1, i4, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, HEAP32[i3 >> 2] | 0, i1 << 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i3 = i8 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = i6 + 8 | 0;
  i11 = HEAP32[i2 + 4 >> 2] | 0;
  i12 = i8 + 28 | 0;
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i3, i1, i4, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, HEAP32[i3 >> 2] | 0, i1 << 2);
 i3 = i8 + 44 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = i6 + 8 | 0;
  i11 = HEAP32[i2 + 4 >> 2] | 0;
  i12 = i8 + 48 | 0;
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i3, i1, i4, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, HEAP32[i3 >> 2] | 0, i1 << 2);
 i1 = i8 + 72 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i2 = i8 + 80 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i1;
 }
 i2 = i8 + 88 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__28ios_base7copyfmtERKS0_(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i4 = i16 + 44 | 0;
 i13 = i17 + 40 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if ((HEAP32[i4 >> 2] | 0) >>> 0 < i1 >>> 0) {
  i2 = i1 << 2;
  i15 = _malloc(i2) | 0;
  i1 = i15;
  if (!i15) {
   i2 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i2);
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i2 | 0, gb + 13048 | 0, fb + 3215 | 0);
   __THREW__ = 0;
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i3 = 0;
  } else {
   i15 = _malloc(i2) | 0;
   i3 = i15;
   if (i15 | 0) {
    i5 = i3;
    i6 = 7;
    break;
   }
   i2 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i2);
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i2 | 0, gb + 13048 | 0, fb + 3215 | 0);
   __THREW__ = 0;
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
 } else {
  i5 = 0;
  i1 = 0;
  i6 = 7;
 } while (0);
 if ((i6 | 0) == 7) {
  i10 = i16 + 56 | 0;
  i14 = i17 + 52 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  if ((HEAP32[i10 >> 2] | 0) >>> 0 < i2 >>> 0) {
   i15 = _malloc(i2 << 2) | 0;
   i3 = i15;
   if (!i15) {
    i2 = ___cxa_allocate_exception(4) | 0;
    __ZNSt9bad_allocC2Ev(i2);
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i2 | 0, gb + 13048 | 0, fb + 3215 | 0);
    __THREW__ = 0;
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else i6 = 10;
  } else {
   i3 = 0;
   i6 = 10;
  }
  do if ((i6 | 0) == 10) {
   i12 = i16 + 68 | 0;
   i15 = i17 + 64 | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   if ((HEAP32[i12 >> 2] | 0) >>> 0 < i2 >>> 0) {
    i6 = _malloc(i2 << 2) | 0;
    if (!i6) {
     i2 = ___cxa_allocate_exception(4) | 0;
     __ZNSt9bad_allocC2Ev(i2);
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i2 | 0, gb + 13048 | 0, fb + 3215 | 0);
     __THREW__ = 0;
     i2 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    }
   } else i6 = 0;
   HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
   __ZNSt3__26localeaSERKS0_(i16 + 28 | 0, i17 + 28 | 0) | 0;
   i9 = i16 + 32 | 0;
   if ((HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
    _free(HEAP32[i9 >> 2] | 0);
    HEAP32[i9 >> 2] = i1;
    i8 = i16 + 36 | 0;
    _free(HEAP32[i8 >> 2] | 0);
    HEAP32[i8 >> 2] = i5;
    HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
    i11 = 0;
    i1 = 0;
   } else {
    i8 = i16 + 36 | 0;
    i11 = i5;
   }
   i2 = i16 + 40 | 0;
   i4 = i17 + 32 | 0;
   i5 = i17 + 36 | 0;
   i7 = 0;
   while (1) {
    HEAP32[i2 >> 2] = i7;
    if (i7 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break;
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i7 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 << 2) >> 2];
    HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + (i7 << 2) >> 2];
    i7 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
   }
   i7 = i16 + 48 | 0;
   if ((HEAP32[i10 >> 2] | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0) {
    _free(HEAP32[i7 >> 2] | 0);
    HEAP32[i7 >> 2] = i3;
    HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
    i3 = 0;
   }
   i2 = i16 + 52 | 0;
   i4 = HEAP32[i17 + 48 >> 2] | 0;
   i5 = 0;
   while (1) {
    HEAP32[i2 >> 2] = i5;
    if (i5 >>> 0 >= (HEAP32[i14 >> 2] | 0) >>> 0) break;
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
    i5 = i5 + 1 | 0;
   }
   i7 = i16 + 60 | 0;
   if ((HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0) {
    _free(HEAP32[i7 >> 2] | 0);
    HEAP32[i7 >> 2] = i6;
    HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
    i6 = 0;
   }
   i5 = i16 + 64 | 0;
   i2 = i17 + 60 | 0;
   i4 = 0;
   while (1) {
    HEAP32[i5 >> 2] = i4;
    if (i4 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break;
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2];
    i4 = i4 + 1 | 0;
   }
   if (i6 | 0) _free(i6);
   if (i3 | 0) _free(i3);
   if (i11 | 0) _free(i11);
   if (i1 | 0) _free(i1);
   return;
  } while (0);
  if (!i3) i3 = i5; else {
   _free(i3);
   i3 = i5;
  }
 }
 if (i3 | 0) _free(i3);
 if (i1 | 0) _free(i1);
 ___resumeException(i2 | 0);
}

function __ZN5physx2Sc5Scene11afterSolverEj(i1, i25) {
 i1 = i1 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i28 + 8 | 0;
 i27 = i28;
 i22 = HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i23 = i22 + 5864 | 0;
 i24 = (HEAP32[i22 + 5868 >> 2] | 0) == 0;
 __ZN5physx17PxsThresholdTable5buildERKNS_18PxsThresholdStreamE(i22 + 5876 | 0, i23);
 i18 = HEAP32[i1 + 1104 >> 2] | 0;
 HEAP32[i26 >> 2] = HEAP32[i18 + 32 >> 2];
 i2 = HEAP32[i18 + 36 >> 2] | 0;
 HEAP32[i27 >> 2] = i2;
 HEAP32[i26 + 4 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i27 + 4 >> 2] = HEAP32[i18 + 20 >> 2];
 i18 = i1 + 64 | 0;
 i19 = i22 + 5880 | 0;
 i20 = i22 + 5896 | 0;
 i21 = i22 + 5892 | 0;
 i22 = i22 + 5884 | 0;
 i1 = 0;
 while (1) {
  if (i2 | 0) {
   i17 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
   do {
    i2 = i2 + -1 | 0;
    i11 = i17;
    i17 = i17 + 4 | 0;
    i11 = HEAP32[i11 >> 2] | 0;
    i12 = (i2 | 0) == 0;
    i13 = i11 + 44 | 0;
    i14 = HEAP32[i13 >> 2] | 0;
    L10 : do if (i14 & 448 | 0) {
     i15 = i14 << 1 & 1048576;
     i16 = i15 | i14 & -1572865;
     HEAP32[i13 >> 2] = i16;
     L12 : do if (!i24) {
      i3 = HEAP32[i11 + 12 >> 2] | 0;
      switch (HEAP8[i3 + 50 >> 0] | 0) {
      case 1:
      case 4:
       {
        i4 = i3 + 64 | 0;
        break;
       }
      default:
       i4 = 0;
      }
      i3 = HEAP32[i11 + 16 >> 2] | 0;
      switch (HEAP8[i3 + 50 >> 0] | 0) {
      case 1:
      case 4:
       {
        i3 = i3 + 64 | 0;
        break;
       }
      default:
       i3 = 0;
      }
      f9 = Math_fround(HEAPF32[i18 >> 2]);
      i29 = HEAP32[i19 >> 2] | 0;
      i7 = HEAP32[i20 >> 2] | 0;
      i10 = HEAP32[i21 >> 2] | 0;
      i5 = i4 >>> 0 < i3 >>> 0;
      i8 = i5 ? i4 : i3;
      i5 = i5 ? i3 : i4;
      i3 = HEAP32[i22 >> 2] | 0;
      i6 = i5;
      i6 = _i64Add(i6 | 0, i8 | 0, -1, ~i6 | 0) | 0;
      i4 = getTempRet0() | 0;
      i30 = _bitshift64Lshr(i6 | 0, i4 | 0, 22) | 0;
      i6 = i30 ^ i6;
      i4 = (getTempRet0() | 0) ^ i4;
      i30 = _bitshift64Shl(i6 | 0, i4 | 0, 13) | 0;
      i30 = _i64Add(i6 | 0, i4 | 0, ~i30 | 0, ~(getTempRet0() | 0) | 0) | 0;
      i4 = getTempRet0() | 0;
      i6 = _bitshift64Lshr(i30 | 0, i4 | 0, 8) | 0;
      i4 = ___muldi3(i6 ^ i30 | 0, (getTempRet0() | 0) ^ i4 | 0, 9, 0) | 0;
      i30 = getTempRet0() | 0;
      i6 = _bitshift64Lshr(i4 | 0, i30 | 0, 15) | 0;
      i4 = i6 ^ i4;
      i30 = (getTempRet0() | 0) ^ i30;
      i6 = _bitshift64Shl(i4 | 0, i30 | 0, 27) | 0;
      i6 = _i64Add(i4 | 0, i30 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
      i30 = getTempRet0() | 0;
      i4 = _bitshift64Lshr(i6 | 0, i30 | 0, 31) | 0;
      (getTempRet0() | 0) ^ i30;
      i3 = HEAP32[i29 + ((((i4 ^ i6) >>> 0) % (i3 >>> 0) | 0) << 2) >> 2] | 0;
      if ((i3 | 0) != -1) {
       i6 = HEAP32[i23 >> 2] | 0;
       while (1) {
        i4 = HEAP32[i10 + (i3 << 3) >> 2] | 0;
        if ((HEAP32[i6 + (i4 << 4) >> 2] | 0) == (i8 | 0)) if ((HEAP32[i6 + (i4 << 4) + 4 >> 2] | 0) == (i5 | 0)) break;
        i3 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
        if ((i3 | 0) == -1) break L12;
       }
       f31 = Math_fround(HEAPF32[i10 + (i3 << 3) + 4 >> 2]);
       if (f31 > Math_fround(f9 * Math_fround(HEAPF32[i6 + (i4 << 4) + 12 >> 2]))) {
        HEAP32[i13 >> 2] = i16 | 524288;
        if (!((i14 & 64 | 0) == 0 | (i15 | 0) != 0)) {
         __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i11, 64, 0, 0, i25);
         break L10;
        }
        if ((i14 & 128 | 0) == 0 | (i15 | 0) == 0) break L10;
        __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i11, 128, 0, 0, i25);
        break L10;
       }
      }
     } while (0);
     if (!((i14 & 256 | 0) == 0 | (i15 | 0) == 0)) __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i11, 256, 0, 0, i25);
    } while (0);
   } while (!i12);
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 2) break;
  i2 = HEAP32[i27 + (i1 << 2) >> 2] | 0;
 }
 STACKTOP = i28;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i10, i6, i11, i2) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 108 | 0;
 i1 = i12 + 96 | 0;
 i7 = i12 + 60 | 0;
 i5 = i12 + 48 | 0;
 i9 = i12 + 36 | 0;
 i8 = i12;
 switch (i2 | 0) {
 case 0:
  {
   if (!i6) i3 = 0; else {
    if (!(HEAP32[i10 + 284 >> 2] & 1)) f4 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i10 + 64 | 0)); else f4 = Math_fround(HEAPF32[(HEAP32[i10 + 56 >> 2] | 0) + 92 >> 2]);
    f14 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
    f13 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2]));
    f4 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 8 >> 2]));
    HEAPF32[i3 >> 2] = f14;
    HEAPF32[i3 + 4 >> 2] = f13;
    HEAPF32[i3 + 8 >> 2] = f4;
   }
   i2 = i10 + 48 | 0;
   if (!i11) i1 = 0; else {
    __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv(i7, i2);
    f14 = Math_fround(HEAPF32[i11 >> 2]);
    f13 = Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2]));
    f4 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 4 >> 2]));
    f14 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 8 >> 2]));
    f16 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f15 = Math_fround(f16 * Math_fround(HEAPF32[i7 + 12 >> 2]));
    f17 = Math_fround(f16 * Math_fround(HEAPF32[i7 + 16 >> 2]));
    f15 = Math_fround(f13 + f15);
    f17 = Math_fround(f4 + f17);
    f16 = Math_fround(f14 + Math_fround(f16 * Math_fround(HEAPF32[i7 + 20 >> 2])));
    f14 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f4 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 24 >> 2]));
    f13 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 28 >> 2]));
    f13 = Math_fround(f17 + f13);
    f14 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i7 + 32 >> 2])));
    HEAPF32[i1 >> 2] = Math_fround(f15 + f4);
    HEAPF32[i1 + 4 >> 2] = f13;
    HEAPF32[i1 + 8 >> 2] = f14;
   }
   __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_(i2, i3, i1);
   STACKTOP = i12;
   return;
  }
 case 3:
  {
   __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_(i10 + 48 | 0, i6, i11);
   STACKTOP = i12;
   return;
  }
 case 1:
  {
   if (!i6) i3 = 0; else {
    if (!(HEAP32[i10 + 284 >> 2] & 1)) f4 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i10 + 64 | 0)); else f4 = Math_fround(HEAPF32[(HEAP32[i10 + 56 >> 2] | 0) + 92 >> 2]);
    f15 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
    f16 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2]));
    f17 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 8 >> 2]));
    HEAPF32[i5 >> 2] = f15;
    HEAPF32[i5 + 4 >> 2] = f16;
    HEAPF32[i5 + 8 >> 2] = f17;
    i3 = i5;
   }
   i2 = i10 + 48 | 0;
   if (!i11) i1 = 0; else {
    __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv(i8, i2);
    f17 = Math_fround(HEAPF32[i11 >> 2]);
    f16 = Math_fround(f17 * Math_fround(HEAPF32[i8 >> 2]));
    f15 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 4 >> 2]));
    f17 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 8 >> 2]));
    f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f14 = Math_fround(f13 * Math_fround(HEAPF32[i8 + 12 >> 2]));
    f4 = Math_fround(f13 * Math_fround(HEAPF32[i8 + 16 >> 2]));
    f14 = Math_fround(f16 + f14);
    f4 = Math_fround(f15 + f4);
    f13 = Math_fround(f17 + Math_fround(f13 * Math_fround(HEAPF32[i8 + 20 >> 2])));
    f17 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f15 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 24 >> 2]));
    f16 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 28 >> 2]));
    f16 = Math_fround(f4 + f16);
    f17 = Math_fround(f13 + Math_fround(f17 * Math_fround(HEAPF32[i8 + 32 >> 2])));
    HEAPF32[i9 >> 2] = Math_fround(f14 + f15);
    HEAPF32[i9 + 4 >> 2] = f16;
    HEAPF32[i9 + 8 >> 2] = f17;
    i1 = i9;
   }
   __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_(i2, i3, i1);
   STACKTOP = i12;
   return;
  }
 case 2:
  {
   __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_(i10 + 48 | 0, i6, i11);
   STACKTOP = i12;
   return;
  }
 default:
  {
   STACKTOP = i12;
   return;
  }
 }
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 48 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 48 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 48 | 0;
  i3 = (i2 | 0) / 48 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 89478485) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 48 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i1);
     i1 = i1 + 48 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 48 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -48 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 48 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 48 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 48 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 48 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 48 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -48 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -48 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_21PxHeightFieldGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i11, i6, i5) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i8 = i12 + 184 | 0;
 i10 = i12 + 160 | 0;
 i7 = i12 + 80 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = gb + 673012;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i9;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i9;
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAPF32[i10 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 20 >> 2] = 0;
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_21PxHeightFieldGeometryE(i6, HEAP32[i11 + 8 >> 2] | 0, i10) | 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i7);
 i3 = i11 + 4 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i9);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEEEEjT_j(i9, i8, 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i12;
 return;
}

function __ZN9ShaderLab7Program13AddSubProgramEPNS_10SubProgramE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP8[i12 + 204 >> 0] = 1;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) != 4) {
  i2 = i12 + 172 | 0;
  i3 = i11 + 16 | 0;
  i4 = i12 + 184 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i12 + 188 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i6 >>> 0 > i9 >>> 0) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 5, 4, i12 + 176 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i12 + 176 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 5 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i2 >> 2] = i12;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  i12 = (HEAP32[i2 >> 2] | 0) + (i5 << 5) | 0;
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i12 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
  if (HEAP32[i10 >> 2] | 0) {
   i12 = __Z21GetUncheckedGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 208 >> 2] | 0, i12 | 0, HEAP32[i10 >> 2] | 0);
  }
  HEAP32[i10 >> 2] = 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   __ZN20GpuProgramParametersD2Ev(i1);
   __ZdlPv(i1);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11 + 72 | 0);
  if ((HEAP32[i11 + 68 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 + 52 >> 2] | 0, i11 + 56 | 0);
  __ZdlPv(i11);
  return;
 }
 i2 = i12 + 8 | 0;
 i3 = i11;
 i4 = i12 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i12 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 << 2) >> 2] = i3;
 i9 = i12 + 28 | 0;
 i2 = i11 + 16 | 0;
 i3 = i12 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 44 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 5, 4, i12 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i12 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 5 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i12 = (HEAP32[i9 >> 2] | 0) + (i4 << 5) | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i12 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i12 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i10, i6, i11, i2) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 108 | 0;
 i1 = i12 + 96 | 0;
 i7 = i12 + 60 | 0;
 i5 = i12 + 48 | 0;
 i9 = i12 + 36 | 0;
 i8 = i12;
 switch (i2 | 0) {
 case 0:
  {
   if (!i6) i3 = 0; else {
    if (!(HEAP32[i10 + 284 >> 2] & 1)) f4 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i10 + 64 | 0)); else f4 = Math_fround(HEAPF32[(HEAP32[i10 + 56 >> 2] | 0) + 92 >> 2]);
    f14 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
    f13 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2]));
    f4 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 8 >> 2]));
    HEAPF32[i3 >> 2] = f14;
    HEAPF32[i3 + 4 >> 2] = f13;
    HEAPF32[i3 + 8 >> 2] = f4;
   }
   i2 = i10 + 48 | 0;
   if (!i11) i1 = 0; else {
    __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv(i7, i2);
    f14 = Math_fround(HEAPF32[i11 >> 2]);
    f13 = Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2]));
    f4 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 4 >> 2]));
    f14 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 8 >> 2]));
    f16 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f15 = Math_fround(f16 * Math_fround(HEAPF32[i7 + 12 >> 2]));
    f17 = Math_fround(f16 * Math_fround(HEAPF32[i7 + 16 >> 2]));
    f15 = Math_fround(f13 + f15);
    f17 = Math_fround(f4 + f17);
    f16 = Math_fround(f14 + Math_fround(f16 * Math_fround(HEAPF32[i7 + 20 >> 2])));
    f14 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f4 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 24 >> 2]));
    f13 = Math_fround(f14 * Math_fround(HEAPF32[i7 + 28 >> 2]));
    f13 = Math_fround(f17 + f13);
    f14 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i7 + 32 >> 2])));
    HEAPF32[i1 >> 2] = Math_fround(f15 + f4);
    HEAPF32[i1 + 4 >> 2] = f13;
    HEAPF32[i1 + 8 >> 2] = f14;
   }
   __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_(i2, i3, i1);
   STACKTOP = i12;
   return;
  }
 case 3:
  {
   __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_(i10 + 48 | 0, i6, i11);
   STACKTOP = i12;
   return;
  }
 case 1:
  {
   if (!i6) i3 = 0; else {
    if (!(HEAP32[i10 + 284 >> 2] & 1)) f4 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i10 + 64 | 0)); else f4 = Math_fround(HEAPF32[(HEAP32[i10 + 56 >> 2] | 0) + 92 >> 2]);
    f15 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
    f16 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2]));
    f17 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 8 >> 2]));
    HEAPF32[i5 >> 2] = f15;
    HEAPF32[i5 + 4 >> 2] = f16;
    HEAPF32[i5 + 8 >> 2] = f17;
    i3 = i5;
   }
   i2 = i10 + 48 | 0;
   if (!i11) i1 = 0; else {
    __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv(i8, i2);
    f17 = Math_fround(HEAPF32[i11 >> 2]);
    f16 = Math_fround(f17 * Math_fround(HEAPF32[i8 >> 2]));
    f15 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 4 >> 2]));
    f17 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 8 >> 2]));
    f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f14 = Math_fround(f13 * Math_fround(HEAPF32[i8 + 12 >> 2]));
    f4 = Math_fround(f13 * Math_fround(HEAPF32[i8 + 16 >> 2]));
    f14 = Math_fround(f16 + f14);
    f4 = Math_fround(f15 + f4);
    f13 = Math_fround(f17 + Math_fround(f13 * Math_fround(HEAPF32[i8 + 20 >> 2])));
    f17 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f15 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 24 >> 2]));
    f16 = Math_fround(f17 * Math_fround(HEAPF32[i8 + 28 >> 2]));
    f16 = Math_fround(f4 + f16);
    f17 = Math_fround(f13 + Math_fround(f17 * Math_fround(HEAPF32[i8 + 32 >> 2])));
    HEAPF32[i9 >> 2] = Math_fround(f14 + f15);
    HEAPF32[i9 + 4 >> 2] = f16;
    HEAPF32[i9 + 8 >> 2] = f17;
    i1 = i9;
   }
   __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_(i2, i3, i1);
   STACKTOP = i12;
   return;
  }
 case 2:
  {
   __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_(i10 + 48 | 0, i6, i11);
   STACKTOP = i12;
   return;
  }
 default:
  {
   STACKTOP = i12;
   return;
  }
 }
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = (i13 - i8 | 0) / 108 | 0;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 108 | 0) >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -108 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -96 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 39768215) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = (i1 - i2 | 0) / 108 | 0;
  i1 = i14 << 1;
  i1 = i14 >>> 0 < 19884107 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 39768215;
  if (i1 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 * 108 | 0) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 * 108 | 0);
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 108 | 0;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 * 108 | 0) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i2 = i1 + 16 | 0;
   i3 = i8 + 16 | 0;
   i4 = i2 + 92 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i8 = i8 + 108 | 0;
   i1 = i1 + 108 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i12, i9, i13, i15 - (((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 108 | 0) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -108 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -96 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN20DynamicPropertySheet10FlushQueueEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 32 | 0;
 i13 = i19 + 12 | 0;
 i16 = i19;
 i14 = i11 + 112 | 0;
 i17 = i11 + 124 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i15 = (i18 | 0) == 0;
 if (!i15) {
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = 0;
  do {
   i10 = i12 + (HEAP32[i2 + (i1 * 12 | 0) >> 2] << 2) | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i18 | 0));
 }
 i3 = i11 + 44 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + i18 | 0;
 i10 = i11 + 32 | 0;
 HEAP32[i3 >> 2] = i5;
 i1 = i11 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i5 << 2, 4, i11 + 36 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i11 + 36 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i10 >> 2] = i9;
  break;
 } while (0);
 i9 = i11 + 52 | 0;
 i1 = i11 + 64 | 0;
 HEAP32[i1 >> 2] = i5;
 i2 = i11 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i5 << 2, 4, i11 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i11 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  break;
 } while (0);
 if (i5 | 0) {
  i2 = 0;
  i1 = 0;
  i4 = HEAP32[i11 + 8 >> 2] | 0;
  while (1) {
   HEAP32[i13 + (i2 << 2) >> 2] = i1;
   i3 = i2 + 1 | 0;
   i8 = i4;
   i4 = HEAP32[i11 + 8 + (i3 << 2) >> 2] | 0;
   i1 = i4 - i8 + i1 | 0;
   if ((i2 | 0) < 3) {
    HEAP32[i16 + (i2 << 2) >> 2] = i1;
    i1 = (HEAP32[i12 + (i2 << 2) >> 2] | 0) + i1 | 0;
   }
   if (i1 >>> 0 >= i5 >>> 0) break; else i2 = i3;
  }
  if ((i2 | 0) > -1) do {
   i6 = i3;
   i3 = i3 + -1 | 0;
   i7 = HEAP32[i11 + 8 + (i3 << 2) >> 2] | 0;
   i2 = (HEAP32[i11 + 8 + (i6 << 2) >> 2] | 0) - i7 | 0;
   if (i2 | 0) {
    i8 = HEAP32[i13 + (i3 << 2) >> 2] | 0;
    if ((i7 | 0) != (i8 | 0)) {
     i1 = i2 + -1 | 0;
     i4 = (i2 | 0) > 0;
     if (i4) {
      i5 = HEAP32[i10 >> 2] | 0;
      i2 = i1;
      while (1) {
       HEAP32[i5 + (i2 + i8 << 2) >> 2] = HEAP32[i5 + (i2 + i7 << 2) >> 2];
       if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
      }
      if (i4) {
       i2 = HEAP32[i9 >> 2] | 0;
       while (1) {
        HEAP32[i2 + (i1 + i8 << 2) >> 2] = HEAP32[i2 + (i1 + i7 << 2) >> 2];
        if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else break;
       }
      }
     }
    }
   }
  } while ((i6 | 0) > 1);
 }
 i13 = HEAP32[i12 >> 2] | 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i13;
 i13 = (HEAP32[i12 + 4 >> 2] | 0) + i13 | 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i13;
 i12 = (HEAP32[i12 + 8 >> 2] | 0) + i13 | 0;
 i13 = i11 + 20 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
 i13 = i11 + 24 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
 i13 = i11 + 28 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
 if (i15) {
  HEAP32[i17 >> 2] = 0;
  STACKTOP = i19;
  return;
 }
 i4 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = 0;
 do {
  i15 = i16 + (HEAP32[i4 + (i1 * 12 | 0) >> 2] << 2) | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i3 + (i14 << 2) >> 2] = HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i2 + (i14 << 2) >> 2] = HEAP32[i4 + (i1 * 12 | 0) + 8 >> 2];
  HEAP32[i15 >> 2] = i14 + 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i18 | 0));
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZN5Unity17ConfigurableJoint6CreateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 28 | 0;
 i9 = i11;
 i10 = i7 + 32 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) i6 = 5; else {
  if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) __ZN5Unity5Joint7CleanupEv(i7);
  if (!(HEAP32[i10 >> 2] | 0)) i6 = 5;
 }
 if ((i6 | 0) == 5) {
  i5 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
  i4 = i7 + 92 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 13;
   }
   if ((i6 | 0) == 11) i6 = 13;
   if ((i6 | 0) == 13) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
    i1 = 0;
    break;
   }
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 21;
    }
   }
   if ((i6 | 0) == 19) i6 = 21;
   if ((i6 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   i1 = HEAP32[i1 + 52 >> 2] | 0;
  } while (0);
  i12 = __Z14GetDynamicsSDKv() | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
  HEAP32[i10 >> 2] = __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i12, i5, i8, i1, i9) | 0;
 }
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i7);
 i12 = (HEAP8[i7 + 293 >> 0] | 0) != 0;
 __ZN5Unity5Joint14FinalizeCreateEb(i7, i12);
 if (!i12) {
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, i12 | 0, 0);
 i12 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i9 | 0, i12 | 0, 1);
 i12 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0, i12 | 0, 0, i9 | 0);
 i12 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 32 >> 2] | 0, i12 | 0, 1, i8 | 0);
 STACKTOP = i11;
 return;
}

function __ZNK13WheelCollider29FindRigidBodyToWheelTransformEPK9Rigidbody(i16, i1, i18) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i26 + 16 | 0;
 i20 = i26;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 i21 = i16 + 4 | 0;
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 i22 = i16 + 8 | 0;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 i23 = i16 + 12 | 0;
 HEAPF32[i23 >> 2] = Math_fround(1.0);
 i24 = i16 + 16 | 0;
 HEAPF32[i24 >> 2] = Math_fround(0.0);
 i25 = i16 + 20 | 0;
 HEAPF32[i25 >> 2] = Math_fround(0.0);
 i17 = i16 + 24 | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 i1 = i1 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 67048 | 0) | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) if (!((i2 | 0) == (i18 | 0) | (__ZNK10GameObject8IsActiveEv(i3) | 0) ^ 1)) {
   STACKTOP = i26;
   return;
  }
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i26;
  return;
 }
 i11 = i19 + 4 | 0;
 i12 = i19 + 8 | 0;
 i13 = i20 + 4 | 0;
 i14 = i20 + 8 | 0;
 i15 = i20 + 12 | 0;
 f4 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 f7 = Math_fround(0.0);
 f8 = Math_fround(1.0);
 f9 = Math_fround(0.0);
 f10 = Math_fround(0.0);
 while (1) {
  __ZNK9Transform16GetLocalPositionEv(i19, i2);
  f38 = Math_fround(HEAPF32[i19 >> 2]);
  f37 = Math_fround(HEAPF32[i11 >> 2]);
  f36 = Math_fround(HEAPF32[i12 >> 2]);
  __ZNK9Transform16GetLocalRotationEv(i20, i2);
  f32 = Math_fround(HEAPF32[i20 >> 2]);
  f30 = Math_fround(HEAPF32[i13 >> 2]);
  f28 = Math_fround(HEAPF32[i14 >> 2]);
  f33 = Math_fround(HEAPF32[i15 >> 2]);
  f29 = Math_fround(f4 * Math_fround(2.0));
  f27 = Math_fround(f5 * Math_fround(2.0));
  f34 = Math_fround(f6 * Math_fround(2.0));
  f35 = Math_fround(Math_fround(f33 * f33) + Math_fround(-.5));
  f31 = Math_fround(Math_fround(Math_fround(f32 * f29) + Math_fround(f30 * f27)) + Math_fround(f28 * f34));
  f4 = Math_fround(f38 + Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(f29 * f35) + Math_fround(f33 * Math_fround(Math_fround(f30 * f34) - Math_fround(f28 * f27))))));
  f5 = Math_fround(f37 + Math_fround(Math_fround(f30 * f31) + Math_fround(Math_fround(f35 * f27) + Math_fround(f33 * Math_fround(Math_fround(f28 * f29) - Math_fround(f32 * f34))))));
  f6 = Math_fround(f36 + Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f33 * Math_fround(Math_fround(f32 * f27) - Math_fround(f30 * f29)))) + Math_fround(f28 * f31)));
  f31 = f7;
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f7) + Math_fround(f32 * f8)) + Math_fround(f30 * f9)) - Math_fround(f28 * f10));
  f29 = f10;
  f10 = Math_fround(Math_fround(Math_fround(f28 * f31) + Math_fround(Math_fround(f30 * f8) + Math_fround(f33 * f10))) - Math_fround(f32 * f9));
  f27 = f9;
  f9 = Math_fround(Math_fround(Math_fround(f32 * f29) + Math_fround(Math_fround(f28 * f8) + Math_fround(f33 * f9))) - Math_fround(f30 * f31));
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(f33 * f8) - Math_fround(f32 * f31)) - Math_fround(f30 * f29)) - Math_fround(f28 * f27));
  HEAPF32[i16 >> 2] = f7;
  HEAPF32[i21 >> 2] = f10;
  HEAPF32[i22 >> 2] = f9;
  HEAPF32[i23 >> 2] = f8;
  HEAPF32[i24 >> 2] = f4;
  HEAPF32[i25 >> 2] = f5;
  HEAPF32[i17 >> 2] = f6;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) {
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
   if (i2 | 0) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    if (i3 | 0) if (!((i2 | 0) == (i18 | 0) | (__ZNK10GameObject8IsActiveEv(i3) | 0) ^ 1)) {
     i1 = 11;
     break;
    }
   }
  }
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i2) {
   i1 = 11;
   break;
  } else {
   i3 = i1;
   i1 = i2;
   i2 = i3;
  }
 }
 if ((i1 | 0) == 11) {
  STACKTOP = i26;
  return;
 }
}

function __ZN5physx3Scb5Scene13addRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE(i4, i5, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 816 | 0;
 i11 = i17 + 544 | 0;
 i15 = i17 + 272 | 0;
 i14 = i17;
 HEAP32[i5 >> 2] = i4;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!(HEAP8[i4 + 2433 >> 0] | 0)) {
  HEAP32[i6 >> 2] = i2 & 268435455 | -2147483648;
  __ZL22addOrRemoveRigidObjectILb0ELb1ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(HEAP32[i4 + 1252 >> 2] | 0, i5);
  STACKTOP = i17;
  return;
 }
 i1 = i2 & 1073741823;
 if (i2 >>> 0 > 3221225471) {
  HEAP32[i6 >> 2] = i1 | -2147483648;
  if (!(i2 & 268435456)) {
   HEAP32[i16 >> 2] = i5;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i16) | 0;
  }
 } else {
  HEAP32[i6 >> 2] = i1 | 1073741824;
  HEAP32[i11 >> 2] = i5;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i11, i16) | 0;
  if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
 }
 i1 = HEAP32[i4 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i5, i16) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i5, i16) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN14Raycast2DQuery8RunQueryEb(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 8 | 0;
 i25 = i26;
 i21 = i26 + 44 | 0;
 i22 = i17 + 20 | 0;
 i23 = i17 + 28 | 0;
 f4 = Math_fround(HEAPF32[i23 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i22 >> 2]));
 i24 = i17 + 32 | 0;
 f5 = Math_fround(HEAPF32[i24 >> 2]);
 i18 = i17 + 24 | 0;
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i18 >> 2]));
 i19 = Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) > Math_fround(1.42108547e-14);
 if (i1) i2 = 3; else if (HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 93 >> 0] | 0) i2 = 3;
 if ((i2 | 0) == 3) {
  i16 = gb + 64016 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i14 = i25;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i21 >> 2] = 0;
  i14 = i21 + 12 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i21 + 16 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i21 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i25);
  i11 = i20;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i16;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  f4 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i17 + 12 >> 2]);
  if ((__ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(0, i22, HEAP32[i17 + 4 >> 2] | 0, f4, f5, HEAP32[i17 + 16 >> 2] | 0, i21) | 0) > 0) {
   if (i19) {
    f4 = Math_fround(HEAPF32[i22 >> 2]);
    f4 = Math_fround(f4 - Math_fround(HEAPF32[i23 >> 2]));
    f5 = Math_fround(HEAPF32[i18 >> 2]);
    f5 = Math_fround(f5 - Math_fround(HEAPF32[i24 >> 2]));
    f3 = Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5));
    if (!(f3 == Math_fround(0.0))) f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
    f4 = Math_fround(f4 * f3);
    f5 = Math_fround(f5 * f3);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
    i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   } else {
    i2 = HEAP32[gb + 1162356 >> 2] | 0;
    i6 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
   }
   if (HEAP32[i14 >> 2] | 0) {
    i9 = i20 + 32 | 0;
    i10 = i20 + 8 | 0;
    i7 = i20 + 16 | 0;
    i8 = i20 + 20 | 0;
    i11 = i20 + 24 | 0;
    i12 = i20 + 28 | 0;
    i13 = i17 + 36 | 0;
    i1 = HEAP32[i21 >> 2] | 0;
    do {
     HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
     i28 = i22;
     i29 = HEAP32[i28 >> 2] | 0;
     i28 = HEAP32[i28 + 4 >> 2] | 0;
     i27 = i10;
     HEAP32[i27 >> 2] = i29;
     HEAP32[i27 + 4 >> 2] = i28;
     i27 = i20;
     HEAP32[i27 >> 2] = i29;
     HEAP32[i27 + 4 >> 2] = i28;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i8 >> 2] = i6;
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i12 >> 2] = Math_fround(0.0);
     __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(HEAP32[i13 >> 2] | 0, i20);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != ((HEAP32[i21 >> 2] | 0) + (HEAP32[i14 >> 2] << 2) | 0));
   }
  }
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i16);
   HEAP32[i21 >> 2] = 0;
  }
 }
 if (i19) {
  i29 = HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0;
  i28 = HEAP32[i18 >> 2] | 0;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i20 + 4 >> 2] = i28;
  i28 = HEAP32[i24 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i25 + 4 >> 2] = i28;
  __ZNK7b2World7RayCastEP17b2RayCastCallbackRK6b2Vec2S4_(i29, i17, i20, i25);
  i29 = i17 + 36 | 0;
  i28 = HEAP32[i29 >> 2] | 0;
  i27 = HEAP32[i28 >> 2] | 0;
  __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_(i27, i27 + ((HEAP32[i28 + 12 >> 2] | 0) * 36 | 0) | 0, i20);
  i29 = HEAP32[i29 >> 2] | 0;
  i29 = i29 + 12 | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  STACKTOP = i26;
  return i29 | 0;
 } else {
  i29 = i17 + 36 | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  i29 = i29 + 12 | 0;
  i29 = HEAP32[i29 >> 2] | 0;
  STACKTOP = i26;
  return i29 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj(i20, i1, i2, i18, i19) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, f22 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 8 | 0;
 i16 = i21;
 i15 = i21 + 16 | 0;
 i11 = i21 + 12 | 0;
 i12 = i21 + 56 | 0;
 i13 = i21 + 24 | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i20, HEAP32[i2 >> 2] | 0);
 HEAP32[i11 >> 2] = 605;
 i14 = HEAP32[i20 + 44 >> 2] | 0;
 i14 = (i14 | 0) == 0 ? i11 : i14;
 if (!i18) {
  i5 = i20;
  i2 = HEAP32[i20 >> 2] | 0;
 } else {
  i8 = (i19 | 0) == 0;
  i9 = i20 + 36 | 0;
  i10 = i20 + 20 | 0;
  i11 = i20 + 24 | 0;
  i6 = i2 + 8 | 0;
  i7 = 0;
  do {
   i1 = i12;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i16 >> 2] = i7;
   __ZN5physx6string9sprintf_sEPcjPKcz(i12, 32, gb + 832784 | 0, i16) | 0;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i20, i12);
   if (!i8) {
    i5 = 0;
    do {
     i1 = i13;
     i2 = i1 + 32 | 0;
     do {
      HEAP8[i1 >> 0] = 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
     HEAP32[i17 >> 2] = i5;
     __ZN5physx6string9sprintf_sEPcjPKcz(i13, 32, gb + 832792 | 0, i17) | 0;
     __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i20, i13);
     if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i20, i15) | 0) {
      f22 = Math_fround(HEAPF32[i15 >> 2]);
      mftCall_viiif(HEAP32[i6 >> 2] | 0, HEAP32[i11 >> 2] | 0, i7 | 0, i5 | 0, +f22);
     }
     i2 = HEAP32[i20 >> 2] | 0;
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if (!i1) HEAP8[i9 >> 0] = 1; else {
      i3 = i1 + -1 | 0;
      i4 = HEAP32[i2 + 4 >> 2] | 0;
      if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
       i1 = HEAP32[i10 >> 2] | 0;
       mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
       i1 = HEAP32[i20 >> 2] | 0;
       i2 = i1;
       i1 = HEAP32[i1 + 8 >> 2] | 0;
      }
      HEAP32[i2 + 8 >> 2] = i1 + -1;
      i1 = HEAP32[i20 >> 2] | 0;
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      HEAP8[i9 >> 0] = 1;
      if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i9 >> 0] = 0;
     }
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i19 | 0));
   }
   i2 = HEAP32[i20 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i9 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i10 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i20 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i2 = HEAP32[i20 >> 2] | 0;
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP8[i9 >> 0] = 1;
    if (i1) if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i9 >> 0] = 0;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i18 | 0));
  i5 = i20;
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i20 + 36 >> 0] = 1;
  STACKTOP = i21;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i20 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i20 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i21;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i21;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i21;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator12estimateTomeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEERNS0_8EstimateE(i26, i27, i1, i28) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i31 + 44 | 0;
 i21 = i31 + 40 | 0;
 i14 = i31 + 36 | 0;
 i16 = i31 + 32 | 0;
 i18 = i31 + 28 | 0;
 i19 = i31 + 24 | 0;
 i12 = i31 + 20 | 0;
 i20 = i31 + 16 | 0;
 i22 = i31 + 12 | 0;
 i23 = i31 + 8 | 0;
 i15 = i31 + 4 | 0;
 i17 = i31;
 HEAP32[i28 >> 2] = 0;
 i24 = i28 + 4 | 0;
 HEAP32[i24 >> 2] = 1;
 i29 = i28 + 12 | 0;
 HEAP32[i29 >> 2] = 1;
 i30 = i28 + 8 | 0;
 HEAP32[i30 >> 2] = 0;
 HEAP32[i13 >> 2] = 2139095039;
 HEAP32[i21 >> 2] = 2139095039;
 HEAP32[i14 >> 2] = 2139095039;
 HEAP32[i16 >> 2] = -8388609;
 HEAP32[i18 >> 2] = -8388609;
 HEAP32[i19 >> 2] = -8388609;
 i25 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i25 | 0) > 0) {
  i11 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = 0;
  f5 = Math_fround(3402823469999999843913219.0e14);
  f6 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f10 = Math_fround(3402823469999999843913219.0e14);
  i3 = 1;
  while (1) {
   i1 = i11 + (i4 << 5) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i1 = i3; else {
    i36 = HEAP32[i2 >> 2] | 0;
    HEAP32[i12 >> 2] = i36;
    i35 = HEAP32[i2 + 4 >> 2] | 0;
    HEAP32[i20 >> 2] = i35;
    i34 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP32[i22 >> 2] = i34;
    i33 = HEAP32[i2 + 12 >> 2] | 0;
    HEAP32[i23 >> 2] = i33;
    i32 = HEAP32[i2 + 16 >> 2] | 0;
    HEAP32[i15 >> 2] = i32;
    i2 = HEAP32[i2 + 20 >> 2] | 0;
    HEAP32[i17 >> 2] = i2;
    i36 = f5 <= (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i36 = HEAP32[(i36 ? i13 : i12) >> 2] | 0;
    i35 = f10 <= (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i35 = HEAP32[(i35 ? i21 : i20) >> 2] | 0;
    i34 = f6 <= (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i34 = HEAP32[(i34 ? i14 : i22) >> 2] | 0;
    HEAP32[i13 >> 2] = i36;
    HEAP32[i21 >> 2] = i35;
    HEAP32[i14 >> 2] = i34;
    i33 = f7 >= (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i33 = HEAP32[(i33 ? i16 : i23) >> 2] | 0;
    i32 = f8 >= (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i32 = HEAP32[(i32 ? i18 : i15) >> 2] | 0;
    i2 = f9 >= (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i2 = HEAP32[(i2 ? i19 : i17) >> 2] | 0;
    HEAP32[i16 >> 2] = i33;
    HEAP32[i18 >> 2] = i32;
    HEAP32[i19 >> 2] = i2;
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] & 65535;
    i1 = (i3 | 0) >= (i1 | 0) ? i3 : i1;
    HEAP32[i24 >> 2] = i1;
    f5 = (HEAP32[tempDoublePtr >> 2] = i36, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f10 = (HEAP32[tempDoublePtr >> 2] = i35, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f6 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f7 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f8 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i25 | 0)) break; else i3 = i1;
  }
 }
 if ((i27 | 0) > 0) {
  i1 = 0;
  i2 = 1;
  i3 = 0;
  i4 = 0;
 } else {
  STACKTOP = i31;
  return;
 }
 do {
  i36 = HEAP32[i26 + (i1 << 2) >> 2] | 0;
  i35 = HEAP32[i36 + 124 >> 2] | 0;
  i2 = (i2 | 0) >= (i35 | 0) ? i2 : i35;
  i3 = i3 + (HEAP32[i36 + 64 >> 2] | 0) | 0;
  i4 = i4 + (HEAP32[i36 + 104 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 HEAP32[i29 >> 2] = i2;
 HEAP32[i28 >> 2] = i3;
 HEAP32[i30 >> 2] = i4;
 STACKTOP = i31;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator11SetMeshDataERNS_17TextMeshGeneratorE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i1 = i10;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 945167 | 0, 729) | 0;
  i5 = gb + 63520 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i1;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i2, i3, 0);
  __Z19pop_allocation_rootv();
  i2 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
  HEAP32[i9 >> 2] = i2;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 4);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 61);
  i7 = i2 + 44 | 0;
  HEAP8[i7 >> 0] = HEAP8[i7 >> 0] | 8;
 } else __ZN4Mesh5ClearEb(i2, 1);
 i5 = i8 + 180 | 0;
 i7 = HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0;
 i4 = (i7 | 0) < 65532 ? i7 : 65532;
 __ZN4Mesh14ResizeVerticesEjj(i2, i4, 13);
 i3 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0;
 i6 = i2 + 44 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] & -17 | i3 << 4 & 255;
 i6 = i2 + 32 | 0;
 if ((i7 | 0) > 0) {
  i1 = 0;
  i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 92 >> 2] | 0;
  while (1) {
   i12 = (HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + (i1 * 60 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i12 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i3 + 12 >> 2] = HEAP32[i12 + (i1 * 60 | 0) + 24 >> 2];
   i12 = i12 + (i1 * 60 | 0) + 28 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i7 = i3 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i7 + 4 >> 2] = i11;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) break; else i3 = i3 + 24 | 0;
  }
 }
 i5 = i8 + 284 | 0;
 __ZN4Mesh15SetSubMeshCountEjb(i2, HEAP32[i5 >> 2] | 0, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i8 + 20 + (i4 * 20 | 0) + 12 >> 2] | 0;
   if (i3) {
    __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i2, HEAP32[i8 + 20 + (i4 * 20 | 0) >> 2] | 0, i3, i4, 0, 1) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i1 | 0));
 }
 f17 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f16 = Math_fround(f17 + Math_fround(HEAPF32[i9 + 16 >> 2]));
 f18 = Math_fround(f13 + Math_fround(HEAPF32[i9 + 20 >> 2]));
 f15 = Math_fround(Math_fround(f13 + f18) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f16 - f17) * Math_fround(.5));
 f13 = Math_fround(Math_fround(f18 - f13) * Math_fround(.5));
 HEAPF32[i2 + 48 >> 2] = Math_fround(Math_fround(f17 + f16) * Math_fround(.5));
 HEAPF32[i2 + 52 >> 2] = f15;
 HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 60 >> 2] = f14;
 HEAPF32[i2 + 64 >> 2] = f13;
 HEAPF32[i2 + 68 >> 2] = Math_fround(0.0);
 __ZN4Mesh16SetChannelsDirtyEjb(i2, HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, 0);
 i6 = i9 + 88 | 0;
 i1 = i8 + 356 | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = i9 + 100 | 0;
 i1 = HEAP32[i8 + 368 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i5 >> 2] = i2;
 i3 = i9 + 104 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i9 + 92 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 92 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i9 + 4 | 0, 0);
 i3 = i9 + 16 | 0;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i10);
  i1 = i1 + 136 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i9 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i4 = i9 + 44 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i9 + 48 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9 + 60 | 0, i10);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i9 + 80 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i9 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i9 + 32 >> 2] | 0, i10);
 i3 = i9 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i9 + 108 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __Z29RenderForwardObjectsIntoDepthRK17RenderLoopContextP13RenderTextureP13dynamic_arrayI16RenderObjectDataLj4EE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseESC_iib(i24, i3, i18, i21, i22, i1, i2, i4) {
 i24 = i24 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i23 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 8 | 0;
 i2 = i20;
 i16 = i20 + 40 | 0;
 i19 = i20 + 20 | 0;
 i13 = i20 + 16 | 0;
 HEAP32[i16 >> 2] = i3;
 if (!i18) {
  STACKTOP = i20;
  return;
 }
 i1 = i18 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 i11 = HEAP32[i24 + 1832 >> 2] | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i12 = i2;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = i14;
 HEAP32[i19 >> 2] = 0;
 i12 = i19 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i14 = i19 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i2);
 i8 = i17;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i15;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 if (i4) {
  i2 = i18;
  i23 = 18;
 } else {
  i10 = HEAP32[i1 >> 2] | 0;
  i1 = i10 >>> 2;
  if (!i1) {
   i1 = 0;
   i2 = 0;
  } else {
   HEAP32[i14 >> 2] = i1;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 5, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i19 >> 2] = i2;
   i1 = i2;
  }
  if (i10 | 0) {
   i9 = 0;
   do {
    i8 = HEAP32[i18 >> 2] | 0;
    i6 = i8 + (i9 << 5) | 0;
    i8 = (HEAP32[i11 >> 2] | 0) + ((HEAP32[i8 + (i9 << 5) + 8 >> 2] | 0) * 360 | 0) + 232 | 0;
    if ((HEAPU16[i8 >> 1] | HEAPU8[i8 + 2 >> 0] << 16) & 256) if ((HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0) + 32 >> 2] | 0) != -1) {
     i7 = HEAP32[i12 >> 2] | 0;
     i8 = i7 + 1 | 0;
     i4 = HEAP32[i14 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i8 >>> 0 > i5 >>> 0) {
      i3 = i4 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i14 >> 2] = i3;
       i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 5, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i19 >> 2] = i2;
       break;
      } else {
       i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 5, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i2 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i12 >> 2] << 5 | 0) | 0;
       HEAP32[i14 >> 2] = i3;
       HEAP32[i19 >> 2] = i2;
       break;
      } else i2 = i1;
     } else i2 = i1; while (0);
     HEAP32[i12 >> 2] = i8;
     i1 = i2 + (i7 << 5) | 0;
     HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
     HEAP32[i1 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
     HEAP32[i1 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
     i1 = i2;
    }
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i10 | 0));
  }
  if (HEAP32[i12 >> 2] | 0) {
   i2 = i19;
   i23 = 18;
  }
 }
 if ((i23 | 0) == 18) {
  HEAP32[i13 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i21, i17, i16, 0, -1, 0, 0) | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 538 >> 0] | 0) mftCall_viff(HEAP32[(HEAP32[i1 >> 2] | 0) + 644 >> 2] | 0, i1 | 0, 1.0, 0.0);
  i24 = HEAP32[i24 + 1828 >> 2] | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = -1;
  __Z20RenderSceneDepthPassRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext(i2, i24, i17, 1, HEAP32[gb + 1166248 >> 2] | 0);
  mftCall_viff(HEAP32[(HEAP32[i1 >> 2] | 0) + 644 >> 2] | 0, i1 | 0, 0.0, 0.0);
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i15);
  HEAP32[i19 >> 2] = 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator17serializeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEERNS_7ImpTomeE(i15, i1, i16) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 8 | 0;
 i7 = i18 + 4 | 0;
 i9 = i18;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i17 = i15 + 300 | 0;
 i8 = i16 + 44 | 0;
 i10 = i15 + 104 | 0;
 i11 = i15 + 116 | 0;
 i13 = i12 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 if (!(__ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERNS_20RuntimeStructBuilderERNS_18SerializedTreeDataEPNS_5ArrayIiEEPPjPPfRKNS_4AABBE(i1, i17, i8, i15 + 144 | 0, i7, i9, i12) | 0)) {
  HEAP32[i15 + 464 >> 2] = 1;
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i11 = HEAP32[i15 + 156 >> 2] | 0;
 i13 = i15 + 192 | 0;
 HEAP32[i13 >> 2] = i11;
 i6 = HEAP32[i15 + 76 >> 2] | 0;
 if ((i6 | 0) > 0) {
  i2 = HEAP32[i15 + 68 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 5) + 4 >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
 }
 if ((i11 | 0) > 0) {
  i2 = HEAP32[i15 + 148 >> 2] | 0;
  i3 = i15 + 68 | 0;
  i4 = i15 + 164 | 0;
  i1 = 0;
  do {
   i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   do if ((i5 | 0) > -1) if ((i5 | 0) < (i6 | 0)) {
    HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 5) + 4 >> 2] = i1;
    break;
   } else {
    HEAP32[(HEAP32[i4 >> 2] | 0) + ((i5 - i6 | 0) * 40 | 0) + 24 >> 2] = i1;
    break;
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i11 | 0));
 }
 i10 = i15 + 24 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) >>> 5;
 i7 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i9 >> 2] | 0) + -4 | 0;
 i6 = HEAP32[i16 + 56 >> 2] | 0;
 HEAP32[i15 + 24 >> 2] = i2;
 HEAP32[i15 + 28 >> 2] = i7;
 HEAP32[i15 + 32 >> 2] = i7 + (((i2 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i15 + 36 >> 2] = i1;
 HEAP32[i15 + 40 >> 2] = 4;
 HEAP32[i15 + 44 >> 2] = 4;
 HEAP32[i15 + 48 >> 2] = i6;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = 2;
 i6 = 0;
 i1 = 0;
 i2 = 0;
 L21 : while (1) {
  i9 = i2 << 1;
  i3 = i12 + (i6 << 3) | 0;
  do if (((HEAP32[i7 + (i9 >> 5 << 2) >> 2] | 0) >>> (i9 & 30) & 3 | 0) == 3) {
   HEAP32[i3 >> 2] = 0;
   i1 = (i6 | 0) > (i1 | 0) ? i6 : i1;
   i14 = 12;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i14 = 12; else {
    i5 = i6 + 1 | 0;
    if ((i6 | 0) > 38) {
     i2 = -1;
     break L21;
    }
    HEAP32[i12 + (i5 << 3) >> 2] = 2;
    HEAP32[i3 >> 2] = i4 + -1;
    i2 = (__ZNK5Umbra6KDTree4rankEi(i10, i2) | 0) << 1;
    if ((i4 | 0) == 2) {
     HEAP32[i12 + (i5 << 3) + 4 >> 2] = i2 + -1;
     i2 = i5;
     break;
    } else {
     HEAP32[i12 + (i5 << 3) + 4 >> 2] = i2;
     i2 = i5;
     break;
    }
   }
  } while (0);
  if ((i14 | 0) == 12) {
   i14 = 0;
   i2 = i6 + -1 | 0;
  }
  if ((i2 | 0) <= -1) {
   i14 = 19;
   break;
  }
  i6 = i2;
  i2 = HEAP32[i12 + (i2 << 3) + 4 >> 2] | 0;
 }
 if ((i14 | 0) == 19) i2 = i1 + 1 | 0;
 i1 = (Math_imul(i11, i2) | 0) + 31 >> 5 << 2;
 if (__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i17, i1 + 16 | 0, 65536) | 0) {
  i12 = i1 + 15 & -16;
  i14 = (HEAP32[i15 + 444 >> 2] | 0) + (((HEAP32[i15 + 452 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i17 = HEAP32[i14 >> 2] | 0;
  _memset(i17 | 0, 0, i12 | 0) | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i12;
  i14 = i15 + 432 | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i16 + 152 >> 2] = (HEAP32[i15 + 304 + (i11 << 3) + 4 >> 2] | 0) - (HEAP32[i15 + 304 + (i11 << 3) >> 2] | 0);
  i14 = i15 + 304 + (HEAP32[i14 >> 2] << 3) + 4 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i12;
  _memset(i17 | 0, 0, (Math_imul(HEAP32[i13 >> 2] | 0, i2) | 0) + 31 >> 5 << 2 | 0) | 0;
  __ZNK5Umbra6KDTree8getPathsEPji(i10, i17, i2);
  HEAP8[i15 + 436 >> 0] = 0;
  HEAP32[i16 + 148 >> 2] = i2;
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 } else {
  HEAP32[i15 + 464 >> 2] = 1;
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 return 0;
}

function __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 72 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function _UNITY_png_read_info(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if ((i8 | 0) == 0 | (i2 | 0) == 0) return;
 _UNITY_png_read_sig(i8, i2);
 i3 = i8 + 372 | 0;
 i4 = i8 + 204 | 0;
 i5 = i8 + 431 | 0;
 L4 : while (1) {
  i9 = _UNITY_png_read_chunk_header(i8) | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  i7 = (i6 | 0) == 1229209940;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i7) {
   if (!(i1 & 1)) {
    i1 = 5;
    break;
   }
   if ((i1 & 2 | 0) == 0 & (HEAP8[i5 >> 0] | 0) == 3) {
    i1 = 7;
    break;
   }
   if (i1 & 8) {
    _UNITY_png_chunk_benign_error(i8, gb + 352160 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i4 >> 2] = i1 | 4;
  } else if (i1 & 4 | 0) HEAP32[i4 >> 2] = i1 | 8;
  L16 : do if ((i6 | 0) < 1229472850) {
   switch (i6 | 0) {
   case 1229278788:
    break;
   default:
    break L16;
   }
   _UNITY_png_handle_IEND(i8, i2, i9);
   continue L4;
  } else {
   switch (i6 | 0) {
   case 1229472850:
    break;
   default:
    break L16;
   }
   _UNITY_png_handle_IHDR(i8, i2, i9);
   continue L4;
  } while (0);
  i1 = _UNITY_png_chunk_unknown_handling(i8, i6) | 0;
  if (i1 | 0) {
   _UNITY_png_handle_unknown(i8, i2, i9, i1);
   if ((i6 | 0) == 1347179589) {
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
    continue;
   } else if (i7) {
    i1 = 20;
    break;
   } else continue;
  }
  if ((i6 | 0) == 1347179589) {
   _UNITY_png_handle_PLTE(i8, i2, i9);
   continue;
  }
  if (i7) {
   i1 = 24;
   break;
  }
  L32 : do if ((i6 | 0) < 1883455820) if ((i6 | 0) < 1766015824) {
   if ((i6 | 0) < 1665684045) {
    switch (i6 | 0) {
    case 1649100612:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_bKGD(i8, i2, i9);
    continue L4;
   }
   if ((i6 | 0) < 1732332865) {
    switch (i6 | 0) {
    case 1665684045:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_cHRM(i8, i2, i9);
    continue L4;
   } else {
    switch (i6 | 0) {
    case 1732332865:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_gAMA(i8, i2, i9);
    continue L4;
   }
  } else {
   if ((i6 | 0) < 1767135348) {
    switch (i6 | 0) {
    case 1766015824:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_iCCP(i8, i2, i9);
    continue L4;
   }
   if ((i6 | 0) < 1866876531) {
    switch (i6 | 0) {
    case 1767135348:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_iTXt(i8, i2, i9);
    continue L4;
   } else {
    switch (i6 | 0) {
    case 1866876531:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_oFFs(i8, i2, i9);
    continue L4;
   }
  } else {
   if ((i6 | 0) < 1933787468) {
    if ((i6 | 0) < 1883789683) {
     switch (i6 | 0) {
     case 1883455820:
      break;
     default:
      break L32;
     }
     _UNITY_png_handle_pCAL(i8, i2, i9);
     continue L4;
    }
    if ((i6 | 0) < 1933723988) {
     switch (i6 | 0) {
     case 1883789683:
      break;
     default:
      break L32;
     }
     _UNITY_png_handle_pHYs(i8, i2, i9);
     continue L4;
    } else {
     switch (i6 | 0) {
     case 1933723988:
      break;
     default:
      break L32;
     }
     _UNITY_png_handle_sBIT(i8, i2, i9);
     continue L4;
    }
   }
   if ((i6 | 0) < 1934772034) if ((i6 | 0) < 1934642260) {
    switch (i6 | 0) {
    case 1933787468:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_sCAL(i8, i2, i9);
    continue L4;
   } else {
    switch (i6 | 0) {
    case 1934642260:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_sPLT(i8, i2, i9);
    continue L4;
   } else if ((i6 | 0) < 1951551059) {
    switch (i6 | 0) {
    case 1934772034:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_sRGB(i8, i2, i9);
    continue L4;
   } else {
    switch (i6 | 0) {
    case 1951551059:
     break;
    default:
     break L32;
    }
    _UNITY_png_handle_tRNS(i8, i2, i9);
    continue L4;
   }
  } while (0);
  _UNITY_png_handle_unknown(i8, i2, i9, 0);
 }
 if ((i1 | 0) == 5) _UNITY_png_chunk_error(i8, gb + 352110 | 0); else if ((i1 | 0) == 7) _UNITY_png_chunk_error(i8, gb + 352135 | 0); else if ((i1 | 0) == 20) {
  HEAP32[i8 + 404 >> 2] = 0;
  return;
 } else if ((i1 | 0) == 24) {
  HEAP32[i8 + 404 >> 2] = i9;
  return;
 }
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = (i13 - i8 | 0) / 24 | 0;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 24 | 0) >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -24 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -12 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 178956970) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = (i1 - i2 | 0) / 24 | 0;
  i1 = i14 << 1;
  i1 = i14 >>> 0 < 89478485 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 178956970;
  if (i1 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 * 24 | 0) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 * 24 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 24 | 0;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 * 24 | 0) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i5 = i8 + 16 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i1 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   i8 = i8 + 24 | 0;
   i1 = i1 + 24 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i12, i9, i13, i15 - (((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 24 | 0) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -24 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN22BaseUnityConnectClient25PrepareCloudServiceConfigEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i8 + 132 | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) i3 = HEAP32[i8 + 136 >> 2] | 0; else i3 = i4 & 255;
 i1 = i8 + 232 | 0;
 do if (!i3) {
  i6 = i8 + 556 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i8 + 560 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 240 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 236 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 236 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } else {
  i7 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
  i6 = i5 ? HEAP32[i8 + 136 >> 2] | 0 : i4 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 240 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 236 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 236 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 i2 = i8 + 148 | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) i3 = HEAP32[i8 + 152 >> 2] | 0; else i3 = i4 & 255;
 i1 = i8 + 248 | 0;
 do if (!i3) {
  i6 = i8 + 572 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i8 + 576 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 256 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 252 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 252 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } else {
  i7 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
  i6 = i5 ? HEAP32[i8 + 152 >> 2] | 0 : i4 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 256 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 252 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 252 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i8 + 164 >> 2] = (HEAP32[i8 + 8 >> 2] | 0) == 0 ? 1 : 2;
 HEAP32[i8 + 168 >> 2] = HEAP32[i8 + 636 >> 2];
 __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i8 + 264 | 0, HEAP32[i8 + 616 >> 2] | 0, HEAP32[i8 + 620 >> 2] | 0);
 HEAP32[i8 + 172 >> 2] = HEAP32[i8 + 648 >> 2];
 HEAP32[i8 + 176 >> 2] = HEAP32[i8 + 652 >> 2];
 HEAP32[i8 + 180 >> 2] = HEAP32[i8 + 656 >> 2];
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN14NavMeshManager24InitializeNavMeshSystemsEPK11NavMeshData(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 32 | 0;
 i12 = i14 + 24 | 0;
 i9 = i14 + 16 | 0;
 i8 = i14 + 8 | 0;
 i7 = i14;
 i10 = i14 + 56 | 0;
 i6 = i14 + 36 | 0;
 __ZN14NavMeshManager7CleanupEv(i13);
 if ((HEAP32[i1 + 56 >> 2] | 0) == (HEAP32[i1 + 52 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i2 = i1 + 32 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = i2;
 i1 = HEAP32[i13 + 8 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = i1;
 i3 = i13 + 12 | 0;
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 >> 2];
 i4 = i13 + 16 | 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i4 >> 2];
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 24 >> 2] = i2;
 HEAP32[i13 + 28 >> 2] = i1;
 i1 = __Z14dtAllocNavMeshv() | 0;
 i2 = i13 + 108 | 0;
 HEAP32[i2 >> 2] = i1;
 do if (!i1) {
  HEAP32[i7 >> 2] = gb + 1030621;
  __Z6FormatPKcz(i10, gb + 846297 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZN14NavMeshManager7CleanupEv(i13);
 } else {
  if ((__ZN9dtNavMesh4initEPK15dtNavMeshParams(i1, i6) | 0) < 0) {
   HEAP32[i8 >> 2] = gb + 846327;
   __Z6FormatPKcz(i10, gb + 846297 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZN14NavMeshManager7CleanupEv(i13);
   break;
  }
  i8 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(HEAP32[i2 >> 2] | 0, 4096) | 0;
  HEAP32[i13 + 112 >> 2] = i8;
  if (!i8) {
   HEAP32[i9 >> 2] = gb + 846342;
   __Z6FormatPKcz(i10, gb + 846297 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZN14NavMeshManager7CleanupEv(i13);
   break;
  }
  i1 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63704 | 0, 16, gb + 842172 | 0, 538) | 0;
  __ZN15HeightMeshQueryC2Ev(i1);
  HEAP32[i13 + 116 >> 2] = i1;
  if (!i1) {
   HEAP32[i12 >> 2] = gb + 846359;
   __Z6FormatPKcz(i10, gb + 846297 | 0, i12);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZN14NavMeshManager7CleanupEv(i13);
   break;
  }
  f15 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(1.04999995));
  __ZN15HeightMeshQuery4InitEff(i1, f15, Math_fround(HEAPF32[i4 >> 2]));
  if (!(__ZN14NavMeshManager21InitializeCrowdSystemEf(i13, Math_fround(f5 * Math_fround(10.0))) | 0)) {
   HEAP32[i11 >> 2] = gb + 846383;
   __Z6FormatPKcz(i10, gb + 846297 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZN14NavMeshManager7CleanupEv(i13);
   break;
  }
  i1 = i13 + 104 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i12 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63704 | 0, 16, gb + 842172 | 0, 1295) | 0;
   __ZN14NavMeshCarvingC2Ev(i12);
   HEAP32[i1 >> 2] = i12;
  }
  i2 = i13 + 72 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = 0;
   do i1 = i1 + 1 | 0; while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
 } while (0);
 STACKTOP = i14;
 return;
}

function __Z29LoadMainObjectFromAssetBundleR11AssetBundle(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14;
 i13 = i14 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 + 44 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i13 = i1;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
 }
 __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb(i4, i4 + 36 | 0, 1);
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i13 >> 2] = 0;
 i6 = i13 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i9);
 i3 = i8;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = __ZN29AssetBundleLoadAssetOperation27PrepareMainAssetPreloadListER11AssetBundleR13dynamic_arrayIiLj4EE(i4, i13) | 0;
 do if (!i7) i1 = 0; else {
  if (HEAP32[i6 >> 2] | 0) {
   i4 = 0;
   do {
    i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    do if (i5 | 0) {
     HEAP32[i9 >> 2] = i5;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i12 = 25; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
       i2 = HEAP32[i8 >> 2] | 0;
       i15 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 25; else if (HEAP32[i1 + 4 >> 2] | 0) break;
     }
     if ((i12 | 0) == 25) i12 = 0;
     __Z31ReadObjectFromPersistentManageri(i5) | 0;
    } while (0);
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
  }
  HEAP32[i9 >> 2] = i7;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i15 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
 } while (0);
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i11);
  HEAP32[i13 >> 2] = 0;
 }
 i15 = i1;
 STACKTOP = i14;
 return i15 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = (i6 - i7 | 0) / 44 | 0;
 i3 = i7;
 if (i1 >>> 0 < i12 >>> 0) {
  i9 = i14 + 8 | 0;
  if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 44 | 0 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 8 | 0;
  if (i12 | 0) {
   i3 = __Znwj(i12 * 44 | 0) | 0;
   i1 = i3;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3 + (i12 * 44 | 0);
  }
  HEAP32[i4 >> 2] = i7;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i2, i13);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = (i1 - i4 | 0) / 44 | 0;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i2 | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 * 44 | 0) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~(((i5 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0) | 0;
    HEAP32[i10 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i3 + (i12 * 44 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i9 = i13 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 * 44 | 0;
  i2 = (i1 | 0) / 44 | 0;
  if (!i1) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 97612893) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i5 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i13 >> 2] = i5;
   i1 = i5 + (i2 * 44 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i8 = i5;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i6 = i5;
    i2 = i5;
    while (1) {
     i10 = i3;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i2;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
     HEAP32[i2 + 32 >> 2] = HEAP32[i3 + 32 >> 2];
     HEAP32[i2 + 36 >> 2] = HEAP32[i3 + 36 >> 2];
     HEAP32[i2 + 40 >> 2] = HEAP32[i3 + 40 >> 2];
     i3 = i3 + 44 | 0;
     i2 = i6 + 44 | 0;
     HEAP32[i9 >> 2] = i2;
     if ((i3 | 0) == (i7 | 0)) break; else i6 = i2;
    }
    i5 = i8;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZNK5physx14NpSceneQueries10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i11, i13, i18, i5, i1, i4, i3, i2) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 216 | 0;
 i10 = i19;
 i15 = i19 + 8 | 0;
 i9 = i4 + 16 | 0;
 i6 = HEAP16[i9 >> 1] | 0;
 if (!i1) i7 = 0; else {
  i7 = __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i1 + 4 >> 2] | 0) | 0;
  i7 = __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(i7, HEAP32[i1 >> 2] | 0) | 0;
 }
 i8 = i11 + 3392 | 0;
 __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv(i8);
 i12 = i18 + 20 | 0;
 HEAP8[i12 >> 0] = 0;
 i17 = i18 + 32 | 0;
 HEAP32[i17 >> 2] = 0;
 i5 = HEAP16[i5 >> 1] | 0;
 HEAP32[i14 >> 2] = gb + 93108 + 8;
 HEAP32[i14 + 4 >> 2] = i11;
 HEAP32[i14 + 8 >> 2] = i13;
 HEAP32[i14 + 12 >> 2] = i18;
 HEAP16[i14 + 16 >> 1] = i5;
 HEAP32[i14 + 20 >> 2] = i4;
 HEAP32[i14 + 24 >> 2] = i3;
 HEAPF32[i14 + 28 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i14 + 32 >> 2] = i2;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP8[i14 + 68 >> 0] = 0;
 i4 = i14 + 72 | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i14 + 41 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = (i6 & 65535) >>> 4 & 1;
 HEAP8[i14 + 39 >> 0] = i1;
 HEAP8[i14 + 40 >> 0] = i5 & 64 ? 1 : i1;
 i1 = HEAP16[i9 >> 1] | 0;
 i6 = (i1 & 65535) >>> 5 & 1;
 HEAP8[i14 + 38 >> 0] = i6;
 HEAP8[i14 + 37 >> 0] = i6;
 do if (!i7) i16 = 8; else if (!(HEAP32[i18 + 28 >> 2] | 0)) {
  i8 = __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE(i8, __ZN5physx2Sq8populateEPKNS0_10ActorShapeE(i7) | 0) | 0;
  HEAP8[i2 >> 0] = 1;
  i10 = __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj(i14, i10, i8, 1) | 0;
  HEAP8[i2 >> 0] = 0;
  if (i10) {
   i1 = HEAP16[i9 >> 1] | 0;
   i16 = 8;
   break;
  } else {
   i3 = HEAP8[i12 >> 0] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i1 = i3 << 24 >> 24 != 0 | (i4 | 0) != 0;
   break;
  }
 } else i16 = 8; while (0);
 do if ((i16 | 0) == 8) {
  i3 = HEAP32[i11 + 3404 >> 2] | 0;
  i2 = HEAP32[i11 + 3408 >> 2] | 0;
  i16 = i1 & 65535;
  i1 = i16 & 2;
  __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i15, HEAP32[i13 + 12 >> 2] | 0, HEAP32[i13 + 16 >> 2] | 0, Math_fround(HEAPF32[i13 + 20 >> 2]));
  HEAP32[i4 >> 2] = i15;
  if (i16 & 1 | 0) if (!(mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i15 | 0, i14 | 0) | 0)) {
   i3 = HEAP8[i12 >> 0] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i1 = i3 << 24 >> 24 != 0 | (i4 | 0) != 0;
   break;
  }
  if (!i1) i4 = 0; else i4 = (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i15 | 0, i14 | 0) | 0) ^ 1;
  i3 = HEAP8[i12 >> 0] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = i3 << 24 >> 24 != 0 | (i2 | 0) != 0;
  if (i4) {
   i17 = i1;
   i16 = HEAP32[i18 >> 2] | 0;
   i16 = i16 + 4 | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   mftCall_vi(i16 | 0, i18 | 0);
   STACKTOP = i19;
   return i17 | 0;
  } else i4 = i2;
 } while (0);
 i2 = (i4 | 0) == 0;
 do if (!(i3 << 24 >> 24)) {
  if (i2) {
   i17 = i1;
   i16 = HEAP32[i18 >> 2] | 0;
   i16 = i16 + 4 | 0;
   i16 = HEAP32[i16 >> 2] | 0;
   mftCall_vi(i16 | 0, i18 | 0);
   STACKTOP = i19;
   return i17 | 0;
  }
 } else if (i2) {
  i17 = i1;
  i16 = HEAP32[i18 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vi(i16 | 0, i18 | 0);
  STACKTOP = i19;
  return i17 | 0;
 } else {
  HEAP32[i17 >> 2] = i4;
  break;
 } while (0);
 if (!(mftCall_iiii(HEAP32[HEAP32[i18 >> 2] >> 2] | 0, i18 | 0, HEAP32[i18 + 24 >> 2] | 0, i4 | 0) | 0)) {
  i17 = i1;
  i16 = HEAP32[i18 >> 2] | 0;
  i16 = i16 + 4 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vi(i16 | 0, i18 | 0);
  STACKTOP = i19;
  return i17 | 0;
 }
 HEAP32[i17 >> 2] = 0;
 i17 = i1;
 i16 = HEAP32[i18 >> 2] | 0;
 i16 = i16 + 4 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vi(i16 | 0, i18 | 0);
 STACKTOP = i19;
 return i17 | 0;
}

function __ZN8Collider7RaycastERK3RayfR10RaycastHit(i1, i4, f3, i11) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i11 = i11 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 164 | 0;
 i7 = i13 + 136 | 0;
 i8 = i13 + 96 | 0;
 i9 = i13 + 64 | 0;
 i10 = i13 + 192 | 0;
 i12 = i13;
 i5 = i1 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i2 = f3 == Math_fround(inf);
 f3 = i2 ? Math_fround(3402823469999999843913219.0e14) : f3;
 HEAP32[i12 >> 2] = 0;
 i2 = i12 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = -1;
 HEAP16[i12 + 12 >> 1] = 0;
 i29 = i12 + 16 | 0;
 i14 = i12 + 40 | 0;
 HEAP32[i29 >> 2] = 0;
 HEAP32[i29 + 4 >> 2] = 0;
 HEAP32[i29 + 8 >> 2] = 0;
 HEAP32[i29 + 12 >> 2] = 0;
 HEAP32[i29 + 16 >> 2] = 0;
 HEAP32[i29 + 20 >> 2] = 0;
 HEAPF32[i14 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i12 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 48 >> 2] = Math_fround(0.0);
 i29 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i29 >> 2] | 0) + 84 >> 2] | 0, i6 | 0, i29 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i7 | 0, i1 | 0);
 f25 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * Math_fround(2.0));
 f28 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f27 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
 f26 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(f25 * f26);
 f24 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f23 * f24));
 f22 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f18 * f22));
 f17 = Math_fround(Math_fround(f26 * f15) + Math_fround(Math_fround(f25 * f27) + Math_fround(f28 * Math_fround(Math_fround(f18 * f24) - Math_fround(f23 * f22)))));
 f16 = Math_fround(Math_fround(f24 * f15) + Math_fround(Math_fround(f23 * f27) + Math_fround(f28 * Math_fround(Math_fround(f25 * f22) - Math_fround(f18 * f26)))));
 f15 = Math_fround(Math_fround(Math_fround(f18 * f27) + Math_fround(f28 * Math_fround(Math_fround(f23 * f26) - Math_fround(f25 * f24)))) + Math_fround(f22 * f15));
 f17 = Math_fround(Math_fround(HEAPF32[i6 + 16 >> 2]) + f17);
 f16 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) + f16);
 f15 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) + f15);
 f25 = Math_fround(HEAPF32[i7 >> 2]);
 f23 = Math_fround(f28 * f25);
 f27 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f26 * f27));
 f18 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f24 * f18));
 f21 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f22 * f25) + Math_fround(Math_fround(f24 * f27) + Math_fround(f28 * f21))) - Math_fround(f26 * f18));
 f19 = Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(Math_fround(f22 * f27) + Math_fround(f28 * f18))) - Math_fround(f24 * f25));
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f25)) - Math_fround(f24 * f21)) - Math_fround(f22 * f18));
 HEAPF32[i9 >> 2] = Math_fround(f23 - Math_fround(f22 * f21));
 HEAPF32[i9 + 4 >> 2] = f20;
 HEAPF32[i9 + 8 >> 2] = f19;
 HEAPF32[i9 + 12 >> 2] = f18;
 HEAPF32[i9 + 16 >> 2] = f17;
 HEAPF32[i9 + 20 >> 2] = f16;
 HEAPF32[i9 + 24 >> 2] = f15;
 HEAP16[i10 >> 1] = 15;
 i1 = __ZN5physx15PxGeometryQuery7raycastERKNS_6PxVec3ES3_RKNS_10PxGeometryERKNS_11PxTransformEfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEb(i4, i4 + 12 | 0, i8, i9, f3, i10, 1, i12, 0) | 0;
 i1 = i1 | 0 ? Math_fround(HEAPF32[i14 >> 2]) > Math_fround(0.0) : 0;
 if (i1) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  __Z14PxToRaycastHitRKN5physx12PxRaycastHitER10RaycastHit(i12, i11);
 }
 i29 = i1;
 STACKTOP = i13;
 return i29 | 0;
}

function __Z18SkinGenericMathLibILi1ELb0ELb0EEvR12SkinMeshInfo(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 48 | 0;
 i12 = i13;
 i9 = i10 + 60 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i7 = i1 + -1 | 0;
  i8 = HEAP32[i10 + 40 >> 2] | 0;
  i4 = HEAP32[i10 + 44 >> 2] | 0;
  i5 = HEAP32[i10 + 68 >> 2] | 0;
  i6 = HEAP32[i10 + 24 >> 2] | 0;
  i1 = HEAP32[i10 + 36 >> 2] | 0;
  i2 = 0;
  i3 = HEAP32[i10 + 32 >> 2] | 0;
  while (1) {
   i14 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   f22 = Math_fround(HEAPF32[i5 + (i14 << 6) >> 2]);
   f28 = Math_fround(HEAPF32[i5 + (i14 << 6) + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i5 + (i14 << 6) + 8 >> 2]);
   f20 = Math_fround(HEAPF32[i5 + (i14 << 6) + 16 >> 2]);
   f27 = Math_fround(HEAPF32[i5 + (i14 << 6) + 20 >> 2]);
   f24 = Math_fround(HEAPF32[i5 + (i14 << 6) + 24 >> 2]);
   f18 = Math_fround(HEAPF32[i5 + (i14 << 6) + 32 >> 2]);
   f16 = Math_fround(HEAPF32[i5 + (i14 << 6) + 36 >> 2]);
   f15 = Math_fround(HEAPF32[i5 + (i14 << 6) + 40 >> 2]);
   f23 = Math_fround(HEAPF32[i5 + (i14 << 6) + 48 >> 2]);
   f29 = Math_fround(HEAPF32[i5 + (i14 << 6) + 52 >> 2]);
   f26 = Math_fround(HEAPF32[i5 + (i14 << 6) + 56 >> 2]);
   f21 = Math_fround(HEAPF32[i3 >> 2]);
   f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   i14 = HEAP32[i3 + 12 >> 2] | 0;
   f16 = Math_fround(f29 + Math_fround(Math_fround(Math_fround(f28 * f21) + Math_fround(f27 * f19)) + Math_fround(f16 * f17)));
   f15 = Math_fround(f26 + Math_fround(Math_fround(Math_fround(f25 * f21) + Math_fround(f24 * f19)) + Math_fround(f15 * f17)));
   HEAPF32[i1 >> 2] = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f19)) + Math_fround(f18 * f17)));
   HEAPF32[i1 + 4 >> 2] = f16;
   HEAPF32[i1 + 8 >> 2] = f15;
   HEAP32[i1 + 12 >> 2] = i14;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else {
    i1 = i1 + i4 | 0;
    i3 = i3 + i8 | 0;
   }
  }
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 + 20 >> 2] | 0;
 if ((i2 | 0) == 4) i2 = 32; else if ((i2 | 0) == 2) i2 = 16; else i2 = (i2 | 0) == 1 ? 4 : 0;
 i9 = i1 + -1 | 0;
 i6 = (HEAP32[i10 + 24 >> 2] | 0) + (Math_imul(i9, i2) | 0) | 0;
 i7 = HEAP32[i10 + 40 >> 2] | 0;
 i5 = (HEAP32[i10 + 32 >> 2] | 0) + (Math_imul(i7, i9) | 0) | 0;
 i8 = HEAP32[i10 + 36 >> 2] | 0;
 i14 = HEAP32[i10 + 44 >> 2] | 0;
 i9 = Math_imul(i14, i9) | 0;
 _memcpy(i11 | 0, i5 | 0, i7 | 0) | 0;
 i7 = HEAP32[i10 + 68 >> 2] | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i7 + (i10 << 6) >> 2]);
 f16 = Math_fround(HEAPF32[i7 + (i10 << 6) + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + (i10 << 6) + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i7 + (i10 << 6) + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i7 + (i10 << 6) + 20 >> 2]);
 f20 = Math_fround(HEAPF32[i7 + (i10 << 6) + 24 >> 2]);
 f26 = Math_fround(HEAPF32[i7 + (i10 << 6) + 32 >> 2]);
 f28 = Math_fround(HEAPF32[i7 + (i10 << 6) + 36 >> 2]);
 f29 = Math_fround(HEAPF32[i7 + (i10 << 6) + 40 >> 2]);
 f21 = Math_fround(HEAPF32[i7 + (i10 << 6) + 48 >> 2]);
 f15 = Math_fround(HEAPF32[i7 + (i10 << 6) + 52 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + (i10 << 6) + 56 >> 2]);
 f23 = Math_fround(HEAPF32[i11 >> 2]);
 f25 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f27 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 f28 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f16 * f23) + Math_fround(f17 * f25)) + Math_fround(f28 * f27)));
 f29 = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f19 * f23) + Math_fround(f20 * f25)) + Math_fround(f29 * f27)));
 HEAPF32[i12 >> 2] = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(f24 * f25)) + Math_fround(f26 * f27)));
 HEAPF32[i12 + 4 >> 2] = f28;
 HEAPF32[i12 + 8 >> 2] = f29;
 HEAP32[i12 + 12 >> 2] = i11;
 _memcpy(i8 + i9 | 0, i12 | 0, i14 | 0) | 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i26, i1, i3, i2) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25;
 i18 = i25 + 112 | 0;
 i24 = i25 + 24 | 0;
 i20 = i25 + 128 | 0;
 i22 = i25 + 12 | 0;
 i19 = i26 + 8 | 0;
 i15 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
 i17 = i24 + 60 | 0;
 i6 = i24 + 64 | 0;
 HEAP32[i24 + 68 >> 2] = 0;
 i7 = i24 + 72 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i6 >> 2] = i24;
 HEAP32[i7 >> 2] = 5;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i24, i5, i25 + 100 | 0);
 if (i5 | 0) {
  i8 = i21 + 4 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 12 | 0;
  i11 = i18 + 4 | 0;
  i12 = i22 + 4 | 0;
  i13 = i18 + 8 | 0;
  i14 = i22 + 8 | 0;
  i16 = 0;
  do {
   i1 = i20;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i23 >> 2] = i16;
   __ZN5physx6string9sprintf_sEPcjPKcz(i20, 32, gb + 832301 | 0, i23) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i26 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i21 >> 2] = i20;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = i21;
    i27 = HEAP32[i28 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i4 + 4 >> 2] = i27;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
   mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, HEAP32[i19 >> 2] | 0, i16 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i18) | 0;
   HEAP8[i21 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i21 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i5 | 0));
 }
 i28 = HEAP32[i7 >> 2] | 0;
 if (!((i28 | 0) > -1 & (i28 & 2147483647 | 0) != 0)) {
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i24 | 0) == (i1 | 0)) {
  HEAP8[i17 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i26, i1, i3, i2) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25;
 i18 = i25 + 112 | 0;
 i24 = i25 + 24 | 0;
 i20 = i25 + 128 | 0;
 i22 = i25 + 12 | 0;
 i19 = i26 + 8 | 0;
 i15 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
 i17 = i24 + 60 | 0;
 i6 = i24 + 64 | 0;
 HEAP32[i24 + 68 >> 2] = 0;
 i7 = i24 + 72 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i6 >> 2] = i24;
 HEAP32[i7 >> 2] = 5;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i24, i5, i25 + 100 | 0);
 if (i5 | 0) {
  i8 = i21 + 4 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 12 | 0;
  i11 = i18 + 4 | 0;
  i12 = i22 + 4 | 0;
  i13 = i18 + 8 | 0;
  i14 = i22 + 8 | 0;
  i16 = 0;
  do {
   i1 = i20;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i23 >> 2] = i16;
   __ZN5physx6string9sprintf_sEPcjPKcz(i20, 32, gb + 832301 | 0, i23) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i26 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i21 >> 2] = i20;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = i21;
    i27 = HEAP32[i28 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i4 + 4 >> 2] = i27;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
   mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, HEAP32[i19 >> 2] | 0, i16 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i18) | 0;
   HEAP8[i21 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i21 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i5 | 0));
 }
 i28 = HEAP32[i7 >> 2] | 0;
 if (!((i28 | 0) > -1 & (i28 & 2147483647 | 0) != 0)) {
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i24 | 0) == (i1 | 0)) {
  HEAP8[i17 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i26, i1, i3, i2) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25;
 i18 = i25 + 112 | 0;
 i24 = i25 + 24 | 0;
 i20 = i25 + 128 | 0;
 i22 = i25 + 12 | 0;
 i19 = i26 + 8 | 0;
 i15 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
 i17 = i24 + 60 | 0;
 i6 = i24 + 64 | 0;
 HEAP32[i24 + 68 >> 2] = 0;
 i7 = i24 + 72 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i6 >> 2] = i24;
 HEAP32[i7 >> 2] = 5;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i24, i5, i25 + 100 | 0);
 if (i5 | 0) {
  i8 = i21 + 4 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 12 | 0;
  i11 = i18 + 4 | 0;
  i12 = i22 + 4 | 0;
  i13 = i18 + 8 | 0;
  i14 = i22 + 8 | 0;
  i16 = 0;
  do {
   i1 = i20;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i23 >> 2] = i16;
   __ZN5physx6string9sprintf_sEPcjPKcz(i20, 32, gb + 832301 | 0, i23) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i26 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i21 >> 2] = i20;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = i21;
    i27 = HEAP32[i28 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i4 + 4 >> 2] = i27;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
   mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, HEAP32[i19 >> 2] | 0, i16 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i18) | 0;
   HEAP8[i21 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i21 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i5 | 0));
 }
 i28 = HEAP32[i7 >> 2] | 0;
 if (!((i28 | 0) > -1 & (i28 & 2147483647 | 0) != 0)) {
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i24 | 0) == (i1 | 0)) {
  HEAP8[i17 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i26, i1, i3, i2) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0, i28 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i21 = i25;
 i18 = i25 + 112 | 0;
 i24 = i25 + 24 | 0;
 i20 = i25 + 128 | 0;
 i22 = i25 + 12 | 0;
 i19 = i26 + 8 | 0;
 i15 = i3 + 12 | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i19 >> 2] | 0) | 0;
 i17 = i24 + 60 | 0;
 i6 = i24 + 64 | 0;
 HEAP32[i24 + 68 >> 2] = 0;
 i7 = i24 + 72 | 0;
 HEAP8[i17 >> 0] = 1;
 HEAP32[i6 >> 2] = i24;
 HEAP32[i7 >> 2] = 5;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i24, i5, i25 + 100 | 0);
 if (i5 | 0) {
  i8 = i21 + 4 | 0;
  i9 = i26 + 4 | 0;
  i10 = i26 + 12 | 0;
  i11 = i18 + 4 | 0;
  i12 = i22 + 4 | 0;
  i13 = i18 + 8 | 0;
  i14 = i22 + 8 | 0;
  i16 = 0;
  do {
   i1 = i20;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i23 >> 2] = i16;
   __ZN5physx6string9sprintf_sEPcjPKcz(i20, 32, gb + 832301 | 0, i23) | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i9 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i26 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i26 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i21 >> 2] = i20;
   HEAP8[i8 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i28 = i21;
    i27 = HEAP32[i28 + 4 >> 2] | 0;
    i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i4 >> 2] = HEAP32[i28 >> 2];
    HEAP32[i4 + 4 >> 2] = i27;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i21) | 0;
   mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, HEAP32[i19 >> 2] | 0, i16 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i26 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i18) | 0;
   HEAP8[i21 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i21 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i26 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i16 = i16 + 1 | 0;
  } while ((i16 | 0) != (i5 | 0));
 }
 i28 = HEAP32[i7 >> 2] | 0;
 if (!((i28 | 0) > -1 & (i28 & 2147483647 | 0) != 0)) {
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i24 | 0) == (i1 | 0)) {
  HEAP8[i17 >> 0] = 0;
  STACKTOP = i25;
  return;
 }
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i28 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i28 >> 2] | 0) + 12 >> 2] | 0, i28 | 0, i1 | 0);
 STACKTOP = i25;
 return;
}

function ___udivmoddi4(i5, i6, i8, i11, i13) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0;
 i9 = i5;
 i4 = i6;
 i7 = i4;
 i2 = i8;
 i12 = i11;
 i3 = i12;
 if (!i7) {
  i1 = (i13 | 0) != 0;
  if (!i3) {
   if (i1) {
    HEAP32[i13 >> 2] = (i9 >>> 0) % (i2 >>> 0);
    HEAP32[i13 + 4 >> 2] = 0;
   }
   i12 = 0;
   i13 = (i9 >>> 0) / (i2 >>> 0) >>> 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  } else {
   if (!i1) {
    i12 = 0;
    i13 = 0;
    return (setTempRet0(i12 | 0), i13) | 0;
   }
   HEAP32[i13 >> 2] = i5 | 0;
   HEAP32[i13 + 4 >> 2] = i6 & 0;
   i12 = 0;
   i13 = 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  }
 }
 i1 = (i3 | 0) == 0;
 do if (!i2) {
  if (i1) {
   if (i13 | 0) {
    HEAP32[i13 >> 2] = (i7 >>> 0) % (i2 >>> 0);
    HEAP32[i13 + 4 >> 2] = 0;
   }
   i12 = 0;
   i13 = (i7 >>> 0) / (i2 >>> 0) >>> 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  }
  if (!i9) {
   if (i13 | 0) {
    HEAP32[i13 >> 2] = 0;
    HEAP32[i13 + 4 >> 2] = (i7 >>> 0) % (i3 >>> 0);
   }
   i12 = 0;
   i13 = (i7 >>> 0) / (i3 >>> 0) >>> 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  }
  i1 = i3 - 1 | 0;
  if (!(i1 & i3)) {
   if (i13 | 0) {
    HEAP32[i13 >> 2] = i5 | 0;
    HEAP32[i13 + 4 >> 2] = i1 & i7 | i6 & 0;
   }
   i12 = 0;
   i13 = i7 >>> ((_llvm_cttz_i32(i3 | 0) | 0) >>> 0);
   return (setTempRet0(i12 | 0), i13) | 0;
  }
  i1 = (Math_clz32(i3 | 0) | 0) - (Math_clz32(i7 | 0) | 0) | 0;
  if (i1 >>> 0 <= 30) {
   i6 = i1 + 1 | 0;
   i3 = 31 - i1 | 0;
   i2 = i6;
   i5 = i7 << i3 | i9 >>> (i6 >>> 0);
   i6 = i7 >>> (i6 >>> 0);
   i1 = 0;
   i3 = i9 << i3;
   break;
  }
  if (!i13) {
   i12 = 0;
   i13 = 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  }
  HEAP32[i13 >> 2] = i5 | 0;
  HEAP32[i13 + 4 >> 2] = i4 | i6 & 0;
  i12 = 0;
  i13 = 0;
  return (setTempRet0(i12 | 0), i13) | 0;
 } else {
  if (!i1) {
   i1 = (Math_clz32(i3 | 0) | 0) - (Math_clz32(i7 | 0) | 0) | 0;
   if (i1 >>> 0 <= 31) {
    i10 = i1 + 1 | 0;
    i3 = 31 - i1 | 0;
    i6 = i1 - 31 >> 31;
    i2 = i10;
    i5 = i9 >>> (i10 >>> 0) & i6 | i7 << i3;
    i6 = i7 >>> (i10 >>> 0) & i6;
    i1 = 0;
    i3 = i9 << i3;
    break;
   }
   if (!i13) {
    i12 = 0;
    i13 = 0;
    return (setTempRet0(i12 | 0), i13) | 0;
   }
   HEAP32[i13 >> 2] = i5 | 0;
   HEAP32[i13 + 4 >> 2] = i4 | i6 & 0;
   i12 = 0;
   i13 = 0;
   return (setTempRet0(i12 | 0), i13) | 0;
  }
  i1 = i2 - 1 | 0;
  if (i1 & i2 | 0) {
   i3 = (Math_clz32(i2 | 0) | 0) + 33 - (Math_clz32(i7 | 0) | 0) | 0;
   i15 = 64 - i3 | 0;
   i10 = 32 - i3 | 0;
   i4 = i10 >> 31;
   i14 = i3 - 32 | 0;
   i6 = i14 >> 31;
   i2 = i3;
   i5 = i10 - 1 >> 31 & i7 >>> (i14 >>> 0) | (i7 << i10 | i9 >>> (i3 >>> 0)) & i6;
   i6 = i6 & i7 >>> (i3 >>> 0);
   i1 = i9 << i15 & i4;
   i3 = (i7 << i15 | i9 >>> (i14 >>> 0)) & i4 | i9 << i10 & i3 - 33 >> 31;
   break;
  }
  if (i13 | 0) {
   HEAP32[i13 >> 2] = i1 & i9;
   HEAP32[i13 + 4 >> 2] = 0;
  }
  if ((i2 | 0) == 1) {
   i14 = i4 | i6 & 0;
   i15 = i5 | 0 | 0;
   return (setTempRet0(i14 | 0), i15) | 0;
  } else {
   i15 = _llvm_cttz_i32(i2 | 0) | 0;
   i14 = i7 >>> (i15 >>> 0) | 0;
   i15 = i7 << 32 - i15 | i9 >>> (i15 >>> 0) | 0;
   return (setTempRet0(i14 | 0), i15) | 0;
  }
 } while (0);
 if (!i2) {
  i7 = i3;
  i4 = 0;
  i3 = 0;
 } else {
  i10 = i8 | 0 | 0;
  i9 = i12 | i11 & 0;
  i7 = _i64Add(i10 | 0, i9 | 0, -1, -1) | 0;
  i8 = getTempRet0() | 0;
  i4 = i3;
  i3 = 0;
  do {
   i11 = i4;
   i4 = i1 >>> 31 | i4 << 1;
   i1 = i3 | i1 << 1;
   i11 = i5 << 1 | i11 >>> 31 | 0;
   i12 = i5 >>> 31 | i6 << 1 | 0;
   _i64Subtract(i7 | 0, i8 | 0, i11 | 0, i12 | 0) | 0;
   i15 = getTempRet0() | 0;
   i14 = i15 >> 31 | ((i15 | 0) < 0 ? -1 : 0) << 1;
   i3 = i14 & 1;
   i5 = _i64Subtract(i11 | 0, i12 | 0, i14 & i10 | 0, (((i15 | 0) < 0 ? -1 : 0) >> 31 | ((i15 | 0) < 0 ? -1 : 0) << 1) & i9 | 0) | 0;
   i6 = getTempRet0() | 0;
   i2 = i2 - 1 | 0;
  } while ((i2 | 0) != 0);
  i7 = i4;
  i4 = 0;
 }
 i2 = 0;
 if (i13 | 0) {
  HEAP32[i13 >> 2] = i5;
  HEAP32[i13 + 4 >> 2] = i6;
 }
 i14 = (i1 | 0) >>> 31 | (i7 | i2) << 1 | (i2 << 1 | i1 >>> 31) & 0 | i4;
 i15 = (i1 << 1 | 0 >>> 31) & -2 | i3;
 return (setTempRet0(i14 | 0), i15) | 0;
}

function __ZN7mecanim5human11CreateHumanEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEEjjRNS_6memory9AllocatorE(i2, i3, i6, i9, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, f5 = f0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i11 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, 396, 4) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 1065353216;
 HEAP32[i11 + 28 >> 2] = 1065353216;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 i4 = i11 + 40 | 0;
 i10 = i11 + 360 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 364 >> 2] = Math_fround(.5);
 HEAPF32[i11 + 368 >> 2] = Math_fround(.5);
 HEAPF32[i11 + 372 >> 2] = Math_fround(.5);
 HEAPF32[i11 + 376 >> 2] = Math_fround(.5);
 HEAPF32[i11 + 380 >> 2] = Math_fround(.0500000007);
 HEAPF32[i11 + 384 >> 2] = Math_fround(.0500000007);
 i1 = i11 + 388 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP16[i1 + 4 >> 1] = 0;
 HEAP8[i1 + 6 >> 0] = 0;
 i1 = 0;
 f5 = Math_fround(0.0);
 do {
  HEAP32[i11 + 72 + (i1 << 2) >> 2] = -1;
  f13 = Math_fround(HEAPF32[gb + 178764 + (i1 << 2) >> 2]);
  HEAPF32[i11 + 168 + (i1 << 2) >> 2] = f13;
  f5 = Math_fround(f5 + f13);
  HEAP32[i11 + 264 + (i1 << 2) >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i1 = 0;
 do {
  i14 = i11 + 168 + (i1 << 2) | 0;
  HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) / f5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 i4 = i11 + 44 | 0;
 HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 i4 = i11 + 60 | 0;
 if (!i6) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i6 * 48 | 0, 4) | 0;
  i3 = i1 + (i6 * 48 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 1065353216;
    HEAP32[i2 + 28 >> 2] = 1065353216;
    HEAP32[i2 + 32 >> 2] = 1065353216;
    HEAP32[i2 + 36 >> 2] = 1065353216;
    i14 = i2 + 40 | 0;
    HEAP32[i14 >> 2] = -1;
    HEAP32[i14 + 4 >> 2] = -1;
    i2 = i2 + 48 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 HEAP32[i11 + 56 >> 2] = i6;
 i4 = i11 + 68 | 0;
 if (!i9) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 * 72 | 0, 4) | 0;
  i3 = i1 + (i9 * 72 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 1065353216;
    HEAP32[i2 + 28 >> 2] = 1065353216;
    HEAP32[i2 + 32 >> 2] = 1065353216;
    HEAP32[i2 + 36 >> 2] = 1065353216;
    HEAP32[i2 + 40 >> 2] = 1;
    i14 = i2 + 44 | 0;
    HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
    HEAP32[i14 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
    HEAP32[i14 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
    i2 = i2 + 72 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 HEAP32[i11 + 64 >> 2] = i9;
 i1 = i11 + 72 | 0;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i11 + 264 | 0;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i11 + 392 >> 0] = 0;
 HEAP8[i11 + 393 >> 0] = 0;
 HEAP8[i11 + 394 >> 0] = 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i9, i1, i4, i11) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 80 | 0;
 i8 = i13 + 48 | 0;
 i5 = i13 + 32 | 0;
 i17 = i13 + 56 | 0;
 i6 = i13 + 24 | 0;
 i14 = i13 + 40 | 0;
 i10 = i13 + 64 | 0;
 i7 = i13 + 16 | 0;
 i2 = i13 + 8 | 0;
 i3 = i13;
 i18 = (__Z19GetScriptingManagerv() | 0) + 144 | 0;
 i15 = HEAP32[i18 + 4 >> 2] | 0;
 i16 = i17;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 4 >> 2] = i15;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i1, i12);
 i17 = (__Z19GetScriptingManagerv() | 0) + 152 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i14;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i1, i12);
 if (HEAP32[i6 >> 2] | 0) if (HEAP32[i5 >> 2] | 0) {
  i15 = __Znwj(68) | 0;
  __ZN9CoroutineC2Ev(i15);
  HEAP32[i11 >> 2] = i15;
  i15 = __Z22scripting_gchandle_newP12Il2CppObject(i1) | 0;
  i16 = HEAP32[i11 >> 2] | 0;
  HEAP32[i16 + 12 >> 2] = i15;
  HEAP32[i16 + 8 >> 2] = i1;
  i16 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
  HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
  HEAP8[i16 + 4 >> 0] = HEAP8[i4 + 4 >> 0] | 0;
  i16 = HEAP32[i11 >> 2] | 0;
  i15 = i5;
  i18 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = i2;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i18;
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN9Coroutine17SetMoveNextMethodE21ScriptingMethodIl2Cpp(i16, i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i16 = i6;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i18 = i3;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN9Coroutine16SetCurrentMethodE21ScriptingMethodIl2Cpp(i2, i12);
  HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] = i9;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] = 0;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 60 >> 2] = 0;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 64 >> 2] = 0;
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i3 + 44 >> 2] = 1;
  HEAP32[i3 + 48 >> 2] = 0;
  i2 = i9 + 64 | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i3 + 4 | 0; else {
    i18 = i3 + 4 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i18 >> 2];
    HEAP32[HEAP32[i18 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i18 >> 2] = 0;
    i1 = i18;
   }
   i18 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i18;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i18 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  }
  __ZN9Coroutine3RunEPb(HEAP32[i2 >> 2] | 0, i12) | 0;
  i17 = HEAP32[i11 >> 2] | 0;
  i18 = (HEAP32[i17 + 44 >> 2] | 0) < 2;
  __ZN9Coroutine16CleanupCoroutineEPv(i17) | 0;
  if (i18) {
   HEAP32[i11 >> 2] = 0;
   i1 = (HEAP8[i12 >> 0] | 0) == 0;
  } else i1 = 1;
  i18 = i1;
  STACKTOP = i13;
  return i18 | 0;
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 587306 | 0, 30);
 } else {
  i16 = i4;
  i17 = HEAP32[i16 + 4 >> 2] | 0;
  i18 = i7;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 >> 2] = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i12) | 0;
  __Z6FormatPKcz(i10, gb + 587270 | 0, i8);
 }
 if (!i9) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 587199 | 0, 693, 4, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i18 = 0;
 STACKTOP = i13;
 return i18 | 0;
}

function __ZN5physx23PxVehicleDriveSimDataNW17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i10 >> 2] = HEAP32[gb + 161456 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 161456 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 161456 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 161456 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 161456 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 161456 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 161456 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 161456 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 161488 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 161488 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 161488 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 161488 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 161488 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 161488 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 161488 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 161488 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 161520 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 161520 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 161520 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 161520 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 161520 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 161520 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 161520 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 161520 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 161552 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 161552 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 161552 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 161552 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 161552 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 161552 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 161552 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 161552 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 161584 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 161584 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 161584 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 161584 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 161584 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 161584 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 161584 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 161584 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 161616 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 161616 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 161616 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 161616 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 161616 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 161616 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 161616 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 161616 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 828758;
 HEAP32[i4 + 4 >> 2] = gb + 827821;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 544;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 161648 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 161648 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 161648 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 161648 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 161648 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 161648 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 161648 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 161648 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i10 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i10 + 12 | 0;
 i18 = i7 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i10 + 20 | 0;
 i17 = i7 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i2;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i10 + 20 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 65;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN2UI6Canvas16CheckConsistencyEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i10 + 352 | 0;
 HEAPF32[i9 >> 2] = Math_fround(.00100000005);
 i6 = Math_fround(HEAPF32[i7 >> 2]) < Math_fround(.00100000005);
 HEAP32[i7 >> 2] = HEAP32[(i6 ? i9 : i7) >> 2];
 i7 = HEAP32[i10 + 344 >> 2] | 0;
 L1 : do if (i7 | 0) {
  i1 = HEAP32[i7 + 424 >> 2] | 0;
  i6 = i7 + 428 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = (i1 | 0) == (i2 | 0);
  L3 : do if (!i4) {
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 >> 2] | 0) == (i10 | 0)) break;
    i3 = i3 + 4 | 0;
    if ((i3 | 0) == (i2 | 0)) break L3;
   }
   if (!(HEAP8[i10 + 375 >> 0] | 0)) break L1;
   i3 = i2;
   while (1) {
    if ((i1 | 0) == (i2 | 0)) break;
    i5 = i1 + 4 | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) {
     i8 = 9;
     break;
    } else i1 = i5;
   }
   if ((i8 | 0) == 9) {
    i3 = i3 - i5 | 0;
    i4 = i3 >> 2;
    if (i4) {
     _memmove(i1 | 0, i5 | 0, i3 | 0) | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
    i1 = i1 + (i4 << 2) | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
    i1 = i7 + 224 | 0;
    HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 4;
    i1 = HEAP32[gb + 1467948 >> 2] | 0;
    HEAP32[i9 >> 2] = i10;
    if (i10 | 0) __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i1 + 12 | 0, i9) | 0;
   }
   __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE(HEAP32[gb + 1467948 >> 2] | 0, i10);
   break L1;
  } while (0);
  if (!(HEAP8[i10 + 375 >> 0] | 0)) {
   HEAP32[i9 >> 2] = i10;
   i3 = i10;
   L26 : do if (i4) i8 = 21; else while (1) {
    if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) break L26;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i8 = 21;
     break;
    }
   } while (0);
   if ((i8 | 0) == 21) {
    if ((i2 | 0) == (HEAP32[i7 + 432 >> 2] | 0)) __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i7 + 424 | 0, i9); else {
     HEAP32[i2 >> 2] = i3;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 4;
    }
    i7 = i7 + 224 | 0;
    HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 4;
   }
   i6 = HEAP32[gb + 1467948 >> 2] | 0;
   HEAP32[i9 >> 2] = i10;
   i7 = i6 + 4 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = i2;
   i5 = HEAP32[i6 >> 2] | 0;
   while (1) {
    if ((i5 | 0) == (i2 | 0)) break;
    i4 = i5 + 4 | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i10 | 0)) {
     i8 = 28;
     break;
    } else i5 = i4;
   }
   if ((i8 | 0) == 28) {
    i1 = i1 - i4 | 0;
    i3 = i1 >> 2;
    if (i3) {
     _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i1 = i5 + (i3 << 2) | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
    __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i6 + 12 | 0, i9) | 0;
   }
  }
 } while (0);
 if (!(__ZNK2UI6Canvas13GetRenderModeEv(i10) | 0)) {
  i8 = HEAP32[gb + 1467948 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = fb + 1103;
  __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i7, i8, i9);
 }
 i1 = i10 + 28 | 0;
 if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28980 | 0) | 0) {
  i10 = i10 + 224 | 0;
  i9 = HEAP16[i10 >> 1] | 0;
  i9 = i9 & 65535;
  i9 = i9 | 6;
  i9 = i9 & 65535;
  HEAP16[i10 >> 1] = i9;
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(__Z30AddTransformComponentUncheckedR10GameObjecti(i1, 224) | 0)) {
  i10 = i10 + 224 | 0;
  i9 = HEAP16[i10 >> 1] | 0;
  i9 = i9 & 65535;
  i9 = i9 | 6;
  i9 = i9 & 65535;
  HEAP16[i10 >> 1] = i9;
  STACKTOP = i11;
  return;
 }
 __ZN10GameObject21EnsureUniqueTransformEbb(i1, 0, 1) | 0;
 i10 = i10 + 224 | 0;
 i9 = HEAP16[i10 >> 1] | 0;
 i9 = i9 & 65535;
 i9 = i9 | 6;
 i9 = i9 & 65535;
 HEAP16[i10 >> 1] = i9;
 STACKTOP = i11;
 return;
}

function __ZN15CollisionModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i13, i14, i15, i16, i18, i19) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i22 + 8 | 0;
 i9 = i22;
 i3 = i22 + 88 | 0;
 i20 = i22 + 40 | 0;
 i21 = i22 + 16 | 0;
 HEAP32[i3 >> 2] = i18;
 i8 = i16 + 12 | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i18 | 0)) {
  STACKTOP = i22;
  return;
 }
 if ((HEAP16[gb + 1451752 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451752 | 0, i4);
  i12 = gb + 1451752 | 0;
 } else i12 = 0;
 __ZN23ParticleSystemParticles22SetUsesCollisionEventsEb(i16, (HEAP8[i13 + 968 >> 0] | 0) != 0);
 HEAP32[i20 >> 2] = i13 + 408;
 HEAP32[i20 + 4 >> 2] = i13 + 672;
 HEAP32[i20 + 8 >> 2] = i13 + 144;
 f23 = Math_fround(HEAPF32[i13 + 936 >> 2]);
 HEAPF32[i20 + 12 >> 2] = Math_fround(f23 * f23);
 f23 = Math_fround(HEAPF32[i13 + 940 >> 2]);
 HEAPF32[i20 + 16 >> 2] = Math_fround(f23 * f23);
 HEAPF32[i20 + 20 >> 2] = Math_fround(Math_fround(HEAPF32[i13 + 944 >> 2]) * Math_fround(.5));
 i17 = i13 + 136 | 0;
 if ((HEAP32[i17 >> 2] | 0) == 1) i1 = (HEAP32[i13 + 960 >> 2] | 0) > 0 ? i13 + 8 | 0 : 0; else i1 = 0;
 HEAP32[i20 + 24 >> 2] = i1;
 i2 = i13 + 140 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i11 = __Z19GetRaycastInterfacev() | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else i11 = 0;
 HEAP32[i20 + 28 >> 2] = i11;
 if ((i1 | 0) == 1) i10 = __Z13GetIPhysics2Dv() | 0; else i10 = 0;
 HEAP32[i20 + 32 >> 2] = i10;
 HEAP32[i20 + 36 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i20 + 44 >> 2] = HEAP32[i13 + 964 >> 2];
 i1 = i15 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) i1 = i2 >>> 0 < i18 >>> 0 ? HEAP32[i3 >> 2] | 0 : HEAP32[i1 >> 2] | 0; else i1 = i18;
 HEAP32[i20 + 40 >> 2] = i1;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i21 >> 2] = 0;
 i5 = i21 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i21 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = i1 >>> 0 > 32 ? 32 : i1;
 if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 60 | 0, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
 }
 i4 = HEAP32[i13 + 956 >> 2] | 0;
 if ((HEAP32[i13 + 960 >> 2] | 0) > 0) {
  i1 = HEAP8[i13 + 949 >> 0] | 0;
  i3 = 0;
 } else {
  i3 = HEAP16[i13 + 948 >> 1] | 0;
  i1 = (i3 & 65535) >>> 8 & 255;
  i3 = (i3 & 255) << 24 >> 24 != 0;
 }
 i2 = HEAP32[i13 + 952 >> 2] | 0;
 i1 = i1 << 24 >> 24 != 0;
 if (!(HEAP32[i17 >> 2] | 0)) __Z14PlaneCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersif(i21, 0, i15, i16, i20, i18, Math_fround(0.0)); else if (!((i11 | 0) == 0 & (i10 | 0) == 0)) __Z14WorldCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjibibRKf(i21, i14, i15, i16, i20, i18, i4, i3, i2, i1, i19);
 if (HEAP32[i5 >> 2] | 0) {
  __Z22PerformPlaneCollisionsRK13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesRK33ParticleSystemCollisionParametersR5RandNRKf(i21, i14, i15, i16, i20, i13 + 996 | 0, i19);
  if (HEAP8[i16 + 875 >> 0] | 0) __ZN15CollisionEvents10SortEventsEv(i16 + 620 | 0);
 }
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i7);
  HEAP32[i21 >> 2] = 0;
 }
 if (!i12) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i22;
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i16, i7, i1) {
 i16 = i16 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i14 = i15 + 16 | 0;
 i8 = i15 + 12 | 0;
 i6 = i15 + 8 | 0;
 i5 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = i1 << 3;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 3) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = (HEAP32[i12 >> 2] | 0) + i12 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 3) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i6 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, gb + 904006 | 0, 0, 1) | 0;
  i9 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i6 | 0) == 2) {
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 4 | 0;
    i5 = i14 + 4 | 0;
    i6 = i14 + 8 | 0;
    i7 = HEAP32[gb + 37316 >> 2] | 0;
    i3 = 0;
    while (1) {
     i17 = (Math_imul(i3, i10) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i17;
     HEAP32[i2 + 12 >> 2] = i17;
     __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
     i17 = i13;
     i3 = HEAP32[i17 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i2 + 4 >> 2] = i3;
     i2 = HEAP32[i11 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i4 >> 2] | 0;
     HEAP32[i14 >> 2] = i1 + 4;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i6 >> 2] = i2;
     i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 904025 | 0, i7, i13, 1) | 0;
     if (i2 | 0) {
      if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i16, i14, 0); else {
       i2 = HEAP32[i13 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i14 | 0, i16 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i16);
     }
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i12 | 0)) break L15;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i3 = i16 + 4 | 0;
   i4 = i14 + 4 | 0;
   i5 = i14 + 8 | 0;
   i6 = HEAP32[gb + 37316 >> 2] | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, gb + 904006 | 0, i8, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i3 >> 2] | 0;
      HEAP32[i14 >> 2] = i1 + 4;
      HEAP32[i4 >> 2] = i1;
      HEAP32[i5 >> 2] = i2;
      i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 904025 | 0, i6, i13, 1) | 0;
      if (i2 | 0) {
       if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i16, i14, 0); else {
        i2 = HEAP32[i13 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i14 | 0, i16 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i16);
      }
     } else {
      i2 = HEAP32[i8 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __Z29CalculateBoxAreaRadialFrustumP8Vector3fffff(i10, f1, f4, f6, f7) {
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i2 = 0, d3 = 0.0, d5 = 0.0, d8 = 0.0, d9 = 0.0, i11 = 0, i12 = 0, i13 = 0, d14 = 0.0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 d8 = +Math_fround(Math_fround(Math_fround(Math_fround(f1 * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 d8 = +Math_cos(+d8) / +Math_sin(+d8);
 f1 = Math_fround(f6 - f4);
 d9 = +Math_fround(Math_fround(f4 + f6) / f1);
 d5 = +Math_fround(Math_fround(Math_fround(f4 * Math_fround(2.0)) * f6) / f1);
 d3 = +f7;
 i2 = 0;
 do {
  i15 = i11 + (i2 * 12 | 0) | 0;
  i13 = i10 + (i2 * 12 | 0) | 0;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  f6 = Math_fround(HEAPF32[i15 >> 2]);
  f1 = Math_fround(f6 * f6);
  i13 = i11 + (i2 * 12 | 0) + 4 | 0;
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f7 * f7));
  f4 = Math_fround(HEAPF32[i11 + (i2 * 12 | 0) + 8 >> 2]);
  d14 = d3 * (d8 * (1.0 / (d5 + d9 * +Math_fround(Math_sqrt(Math_fround(f1 + Math_fround(f4 * f4))))))) * .5;
  HEAPF32[i15 >> 2] = Math_fround(+f6 * d14);
  HEAPF32[i13 >> 2] = Math_fround(+f7 * d14);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 8);
 f28 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f23 = Math_fround(HEAPF32[i11 >> 2]);
 f22 = Math_fround(f28 - f23);
 f27 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f22 = Math_fround(f22 * Math_fround(f27 + f25));
 f21 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f17 = Math_fround(f21 - f28);
 f29 = Math_fround(HEAPF32[i11 + 40 >> 2]);
 f17 = Math_fround(f17 * Math_fround(f27 + f29));
 f26 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f16 = Math_fround(f23 - f26);
 f24 = Math_fround(HEAPF32[i11 + 28 >> 2]);
 f16 = Math_fround(f16 * Math_fround(f25 + f24));
 f31 = Math_fround(HEAPF32[i11 + 84 >> 2]);
 f18 = Math_fround(f31 - f21);
 f7 = Math_fround(HEAPF32[i11 + 88 >> 2]);
 f18 = Math_fround(f18 * Math_fround(f29 + f7));
 f30 = Math_fround(HEAPF32[i11 + 72 >> 2]);
 f1 = Math_fround(f26 - f30);
 f6 = Math_fround(HEAPF32[i11 + 76 >> 2]);
 f1 = Math_fround(f1 * Math_fround(f24 + f6));
 f24 = Math_fround(Math_fround(f21 - f26) * Math_fround(f29 + f24));
 f29 = Math_fround(HEAPF32[i11 + 60 >> 2]);
 f26 = Math_fround(HEAPF32[i11 + 48 >> 2]);
 f21 = Math_fround(f29 - f26);
 f20 = Math_fround(HEAPF32[i11 + 64 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 f21 = Math_fround(f21 * Math_fround(f20 + f4));
 f19 = Math_fround(Math_fround(f31 - f29) * Math_fround(f7 + f20));
 f7 = Math_fround(Math_fround(f30 - f31) * Math_fround(f7 + f6));
 f6 = Math_fround(Math_fround(f26 - f30) * Math_fround(f6 + f4));
 f20 = Math_fround(Math_fround(f29 - f28) * Math_fround(f27 + f20));
 f4 = Math_fround(Math_fround(f23 - f26) * Math_fround(f25 + f4));
 f25 = Math_fround(f16 + Math_fround(Math_fround(f22 + f17) - f24));
 i13 = f25 < Math_fround(0.0);
 f26 = Math_fround(-f25);
 f24 = Math_fround(f1 + Math_fround(Math_fround(f24 + f18) + f7));
 i15 = f24 < Math_fround(0.0);
 f23 = Math_fround(-f24);
 f24 = Math_fround((i13 ? f26 : f25) + (i15 ? f23 : f24));
 f7 = Math_fround(f6 + Math_fround(f7 + Math_fround(f19 + f21)));
 i15 = f7 < Math_fround(0.0);
 f23 = Math_fround(-f7);
 f7 = Math_fround(f24 + (i15 ? f23 : f7));
 f21 = Math_fround(f4 + Math_fround(Math_fround(f22 + f20) - f21));
 i15 = f21 < Math_fround(0.0);
 f22 = Math_fround(-f21);
 f7 = Math_fround((i15 ? f22 : f21) + f7);
 f17 = Math_fround(Math_fround(Math_fround(f20 + f19) - f18) - f17);
 i15 = f17 < Math_fround(0.0);
 f18 = Math_fround(-f17);
 f7 = Math_fround((i15 ? f18 : f17) + f7);
 f6 = Math_fround(f16 + Math_fround(f1 + Math_fround(Math_fround(-f4) - f6)));
 i15 = f6 < Math_fround(0.0);
 f4 = Math_fround(-f6);
 f7 = Math_fround(Math_fround((i15 ? f4 : f6) + f7) * Math_fround(.5));
 STACKTOP = i12;
 return Math_fround(f7);
}

function __Z24MonoAddComponentWithTypeR10GameObjectP12Il2CppObject(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i11 + 20 | 0;
 i7 = i11 + 16 | 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 if (!i3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 390647 | 0, 0, gb + 390571 | 0, 56, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return i9 | 0;
 }
 i2 = (i3 | 0) == (HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 264 >> 2] | 0);
 i1 = i4 + 4 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 390684 | 0, 0, gb + 390571 | 0, 63, 1, i8, 0, 0);
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return i9 | 0;
 }
 do if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i3, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 264 >> 2] | 0) | 0) {
  if (!(__ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i3) | 0)) __Z33CreateMonoScriptFromScriptingTypeP11Il2CppClass(i3) | 0;
  i1 = __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i4, 114, i3, i10) | 0;
 } else {
  i2 = __ZN6Object15StringToClassIDEPKc(__Z24scripting_class_get_nameP11Il2CppClass(i3) | 0) | 0;
  if ((i2 | 0) != -1) {
   i1 = __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i4, i2, 0, i10) | 0;
   break;
  }
  HEAP32[i5 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
  __Z6FormatPKcz(i6, gb + 390799 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 390571 | 0, 73, 512, HEAP32[i1 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return i9 | 0;
 } while (0);
 if (i1 | 0) {
  i9 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return i9 | 0;
 }
 i4 = i10 + 11 | 0;
 i5 = HEAP8[i4 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return i9 | 0;
 }
 do if (!i8) i1 = 0; else {
  HEAP32[i7 >> 2] = i8;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 21; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 21; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 23;
   }
  }
  if ((i9 | 0) == 21) i9 = 23;
  if ((i9 | 0) == 23) {
   i1 = __Z31ReadObjectFromPersistentManageri(i8) | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 390571 | 0, 99, 4, i1, 0, 0);
 i9 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i11;
 return i9 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i10 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i10 + 12 | 0;
 i18 = i7 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i10 + 20 | 0;
 i17 = i7 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i2;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i10 + 20 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 6;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN15CollisionModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i31 = i33 + 12 | 0;
 i32 = i33;
 if (HEAP32[i1 + 136 >> 2] | 0) {
  STACKTOP = i33;
  return;
 }
 if ((HEAP32[i2 + 280 >> 2] | 0) == 1) {
  STACKTOP = i33;
  return;
 }
 i18 = i3 + 448 | 0;
 if (!(HEAP32[i18 >> 2] | 0)) {
  STACKTOP = i33;
  return;
 }
 i19 = i3 + 444 | 0;
 i20 = i3 + 180 | 0;
 i21 = i3 + 196 | 0;
 i22 = i3 + 212 | 0;
 i23 = i3 + 228 | 0;
 i24 = i3 + 184 | 0;
 i25 = i3 + 200 | 0;
 i26 = i3 + 216 | 0;
 i27 = i3 + 232 | 0;
 i28 = i3 + 188 | 0;
 i29 = i3 + 204 | 0;
 i30 = i3 + 220 | 0;
 i9 = i3 + 236 | 0;
 f10 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i8 = 0;
 do {
  i14 = HEAP32[i19 >> 2] | 0;
  i11 = i14 + (i8 * 20 | 0) | 0;
  i12 = i14 + (i8 * 20 | 0) + 12 | 0;
  f17 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
  f37 = Math_fround(HEAPF32[i11 >> 2]);
  f6 = Math_fround(f37 * f17);
  i13 = i14 + (i8 * 20 | 0) + 4 | 0;
  f35 = Math_fround(HEAPF32[i13 >> 2]);
  f42 = Math_fround(f35 * f17);
  i14 = i14 + (i8 * 20 | 0) + 8 | 0;
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  f17 = Math_fround(f7 * f17);
  f41 = Math_fround(HEAPF32[i20 >> 2]);
  f15 = Math_fround(f6 * f41);
  f40 = Math_fround(HEAPF32[i21 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f42 * f40));
  f4 = Math_fround(HEAPF32[i22 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f17 * f4));
  f15 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) + f15);
  f39 = Math_fround(HEAPF32[i24 >> 2]);
  f16 = Math_fround(f6 * f39);
  f38 = Math_fround(HEAPF32[i25 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f42 * f38));
  f5 = Math_fround(HEAPF32[i26 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f17 * f5));
  f16 = Math_fround(Math_fround(HEAPF32[i27 >> 2]) + f16);
  f36 = Math_fround(HEAPF32[i28 >> 2]);
  f6 = Math_fround(f6 * f36);
  f34 = Math_fround(HEAPF32[i29 >> 2]);
  f42 = Math_fround(f6 + Math_fround(f42 * f34));
  f6 = Math_fround(HEAPF32[i30 >> 2]);
  f17 = Math_fround(f42 + Math_fround(f17 * f6));
  f17 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f17);
  f4 = Math_fround(Math_fround(Math_fround(f37 * f41) + Math_fround(f35 * f40)) + Math_fround(f7 * f4));
  f5 = Math_fround(Math_fround(Math_fround(f37 * f39) + Math_fround(f35 * f38)) + Math_fround(f7 * f5));
  f6 = Math_fround(Math_fround(Math_fround(f37 * f36) + Math_fround(f35 * f34)) + Math_fround(f7 * f6));
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
  if (f7 > f10) {
   f42 = Math_fround(f4 / f7);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   f42 = Math_fround(f5 / f7);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
   f42 = Math_fround(f6 / f7);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f42, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i1 = 0;
   i2 = 0;
   i3 = 1065353216;
  }
  HEAP32[i11 >> 2] = i1;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  f42 = Math_fround(f15 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  f42 = Math_fround(f42 + Math_fround(f16 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  HEAPF32[i12 >> 2] = Math_fround(-Math_fround(f42 + Math_fround(f17 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])))));
  __Z15NormalizeRobustRK8Vector3fRf(i32, i11, i31);
  HEAP32[i11 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i32 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i32 + 8 >> 2];
  f42 = Math_fround(HEAPF32[i31 >> 2]);
  HEAPF32[i12 >> 2] = Math_fround(f42 * Math_fround(HEAPF32[i12 >> 2]));
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < (HEAP32[i18 >> 2] | 0) >>> 0);
 STACKTOP = i33;
 return;
}

function __ZN5physx2Cm27getDynamicGlobalPoseAlignedERKNS_11PxTransformES3_S3_RS1_(i2, i4, i1, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 f12 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i4 >> 2]);
 f27 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f19 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f21 = Math_fround(Math_fround(f6 * f8) + Math_fround(Math_fround(Math_fround(f28 * f7) + Math_fround(f27 * f23)) + Math_fround(f13 * f26)));
 f11 = Math_fround(Math_fround(Math_fround(f28 * f8) + Math_fround(Math_fround(f27 * f26) - Math_fround(f13 * f23))) - Math_fround(f6 * f7));
 f18 = Math_fround(Math_fround(Math_fround(f27 * f8) + Math_fround(Math_fround(f13 * f7) - Math_fround(f28 * f26))) - Math_fround(f6 * f23));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f28 * f23) - Math_fround(f27 * f7)) + Math_fround(f13 * f8)) - Math_fround(f6 * f26));
 f24 = Math_fround(f12 - f24);
 f22 = Math_fround(f25 - f22);
 f5 = Math_fround(f15 - f5);
 f15 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f24 * f7) + Math_fround(f22 * f23)) + Math_fround(f5 * f26));
 f12 = Math_fround(Math_fround(f7 * f25) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f22 * f26) - Math_fround(f5 * f23))) + Math_fround(f24 * f15)));
 f13 = Math_fround(Math_fround(f23 * f25) + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f5 * f7) - Math_fround(f24 * f26))) + Math_fround(f22 * f15)));
 f15 = Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f7)) * f8) + Math_fround(f5 * f15)));
 f12 = Math_fround(f12 + f12);
 f13 = Math_fround(f13 + f13);
 f15 = Math_fround(f15 + f15);
 f5 = Math_fround(Math_fround(f21 * f17) - Math_fround(Math_fround(Math_fround(f11 * f19) + Math_fround(f18 * f16)) + Math_fround(f6 * f14)));
 f8 = Math_fround(Math_fround(f21 * f19) + Math_fround(Math_fround(f11 * f17) + Math_fround(Math_fround(f6 * f16) - Math_fround(f18 * f14))));
 f7 = Math_fround(Math_fround(f21 * f16) + Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f11 * f14) - Math_fround(f6 * f19))));
 f6 = Math_fround(Math_fround(f21 * f14) + Math_fround(Math_fround(Math_fround(f18 * f19) - Math_fround(f11 * f16)) + Math_fround(f6 * f17)));
 f11 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f18 = Math_fround(Math_fround(f14 * f15) + Math_fround(Math_fround(f19 * f12) + Math_fround(f16 * f13)));
 f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(f16 * f18) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f14 * f12) - Math_fround(f19 * f15))) + Math_fround(f13 * f11))) * Math_fround(2.0)));
 f9 = Math_fround(f9 + Math_fround(Math_fround(Math_fround(f14 * f18) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f19 * f13) - Math_fround(f16 * f12))) + Math_fround(f15 * f11))) * Math_fround(2.0)));
 HEAPF32[i3 + 16 >> 2] = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13))) + Math_fround(f12 * f11))) * Math_fround(2.0)));
 HEAPF32[i3 + 20 >> 2] = f10;
 HEAPF32[i3 + 24 >> 2] = f9;
 HEAPF32[i3 >> 2] = f8;
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f6;
 HEAPF32[i3 + 12 >> 2] = f5;
 return;
}

function __Z27GetComponentsInChildrenImplILb0EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE(i9, i16, i17) {
 i9 = i9 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = HEAP32[i9 + 40 >> 2] | 0;
 if ((i12 | 0) > 0) {
  i13 = i9 + 28 | 0;
  i8 = i16 + -1e5 | 0;
  i14 = i17 + 12 | 0;
  i10 = i17 + 16 | 0;
  i11 = i17 + 4 | 0;
  if ((i16 | 0) > 99999) {
   i7 = 0;
   do {
    i4 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[gb + 1106156 + 4 + (HEAP32[i4 + (i7 << 3) >> 2] << 2) >> 2] | 0;
    if (!i1) {
     i1 = -1;
     i2 = HEAP32[gb + 1110260 >> 2] | 0;
     i15 = 7;
    } else {
     i1 = HEAP32[i1 + 16 >> 2] | 0;
     i2 = HEAP32[gb + 1110260 >> 2] | 0;
     if ((i1 | 0) > 99999) {
      i6 = HEAP32[i2 + 24 >> 2] | 0;
      i3 = i6 + (i1 + -1e5 << 3) | 0;
      i1 = i6;
     } else i15 = 7;
    }
    if ((i15 | 0) == 7) {
     i15 = 0;
     i3 = (HEAP32[i2 + 4 >> 2] | 0) + (i1 << 3) | 0;
     i1 = HEAP32[i2 + 24 >> 2] | 0;
    }
    if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i1 + (i8 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + (i8 << 3) + 4 >> 2] | 0) >>> 0) {
     i2 = HEAP32[i4 + (i7 << 3) + 4 >> 2] | 0;
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i14 >> 2] = i4;
     HEAP32[(HEAP32[i17 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i12 | 0));
  } else {
   i7 = 0;
   do {
    i4 = HEAP32[i13 >> 2] | 0;
    i1 = HEAP32[gb + 1106156 + 4 + (HEAP32[i4 + (i7 << 3) >> 2] << 2) >> 2] | 0;
    if (!i1) {
     i1 = -1;
     i2 = HEAP32[gb + 1110260 >> 2] | 0;
     i15 = 20;
    } else {
     i1 = HEAP32[i1 + 16 >> 2] | 0;
     i2 = HEAP32[gb + 1110260 >> 2] | 0;
     if ((i1 | 0) > 99999) {
      i3 = (HEAP32[i2 + 24 >> 2] | 0) + (i1 + -1e5 << 3) | 0;
      i1 = HEAP32[i2 + 4 >> 2] | 0;
     } else i15 = 20;
    }
    if ((i15 | 0) == 20) {
     i15 = 0;
     i8 = HEAP32[i2 + 4 >> 2] | 0;
     i3 = i8 + (i1 << 3) | 0;
     i1 = i8;
    }
    if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i1 + (i16 << 3) >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + (i16 << 3) + 4 >> 2] | 0) >>> 0) {
     i2 = HEAP32[i4 + (i7 << 3) + 4 >> 2] | 0;
     i3 = HEAP32[i14 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
       HEAP32[i10 >> 2] = i1;
       HEAP32[i17 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i14 >> 2] = i4;
     HEAP32[(HEAP32[i17 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i12 | 0));
  }
 }
 i1 = __ZNK10GameObject23QueryComponentTransformEv(i9) | 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i1 + 80 | 0;
 i1 = 0;
 do {
  __Z27GetComponentsInChildrenImplILb0EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, i16, i17);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i13 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i13;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i1, i15, 0);
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i17 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
  STACKTOP = i18;
  return;
 }
 i8 = i12 + 4 | 0;
 i9 = i8;
 i10 = i12 + 4 | 0;
 i11 = i12 + 8 | 0;
 i2 = i1;
 while (1) {
  i1 = i2 + 32 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i1, i3);
  i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16) | 0;
  i1 = i2 + 16 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 20 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, i3);
  i6 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i8;
   i3 = i9;
   i4 = i8;
   i5 = 19;
  } else {
   while (1) {
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i6 | 0) < (i3 | 0)) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) {
      i5 = 12;
      break;
     } else i1 = i3;
    } else {
     if ((i3 | 0) >= (i6 | 0)) {
      i5 = 18;
      break;
     }
     i4 = i1 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i5 = 16;
      break;
     } else i1 = i3;
    }
   }
   if ((i5 | 0) == 12) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i4 = i1;
    i5 = 19;
    break;
   } else if ((i5 | 0) == 16) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i5 = 19;
    break;
   } else if ((i5 | 0) == 18) {
    i5 = 0;
    HEAP32[i14 >> 2] = i1;
    if (!i1) {
     i3 = i1;
     i4 = i14;
     i5 = 19;
     break;
    } else break;
   }
  } while (0);
  if ((i5 | 0) == 19) {
   i1 = __Znwj(24) | 0;
   HEAP32[i1 + 16 >> 2] = i6;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
   if (!i3) i3 = i1; else {
    HEAP32[i12 >> 2] = i3;
    i3 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i3);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 20 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i1;
 }
 i17 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
 STACKTOP = i18;
 return;
}

function __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i15 = i18 + 24 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i13 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i13;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i1, i15, 0);
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i17 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
  STACKTOP = i18;
  return;
 }
 i8 = i12 + 4 | 0;
 i9 = i8;
 i10 = i12 + 4 | 0;
 i11 = i12 + 8 | 0;
 i2 = i1;
 while (1) {
  i1 = i2 + 32 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i16, i1, i3);
  i7 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i16) | 0;
  i1 = i2 + 16 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 20 >> 2] | 0;
  } else i3 = i3 & 255;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i17, i1, i3);
  i6 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i8;
   i3 = i9;
   i4 = i8;
   i5 = 19;
  } else {
   while (1) {
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i6 | 0) < (i3 | 0)) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) {
      i5 = 12;
      break;
     } else i1 = i3;
    } else {
     if ((i3 | 0) >= (i6 | 0)) {
      i5 = 18;
      break;
     }
     i4 = i1 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i5 = 16;
      break;
     } else i1 = i3;
    }
   }
   if ((i5 | 0) == 12) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i4 = i1;
    i5 = 19;
    break;
   } else if ((i5 | 0) == 16) {
    HEAP32[i14 >> 2] = i1;
    i3 = i1;
    i5 = 19;
    break;
   } else if ((i5 | 0) == 18) {
    i5 = 0;
    HEAP32[i14 >> 2] = i1;
    if (!i1) {
     i3 = i1;
     i4 = i14;
     i5 = 19;
     break;
    } else break;
   }
  } while (0);
  if ((i5 | 0) == 19) {
   i1 = __Znwj(24) | 0;
   HEAP32[i1 + 16 >> 2] = i6;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
   if (!i3) i3 = i1; else {
    HEAP32[i12 >> 2] = i3;
    i3 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i3);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 20 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i1;
 }
 i17 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i15, i17);
 STACKTOP = i18;
 return;
}

function __ZN5physx14NpArticulation17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i10 >> 2] = HEAP32[gb + 123108 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 123108 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 123108 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 123108 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 123108 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 123108 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 123108 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 123108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = gb + 754717;
 HEAP32[i9 + 4 >> 2] = gb + 827530;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 108;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 123140 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123140 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123140 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123140 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123140 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123140 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123140 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 123172 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123172 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123172 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123172 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123172 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123172 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123172 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123172 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123204 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123204 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123204 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123204 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123204 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123204 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123204 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123204 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123236 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123236 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123236 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123236 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123236 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123236 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123236 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123236 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123268 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123268 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123268 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123268 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123268 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123268 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123268 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123268 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN2UI6Canvas8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i7 = i1 + 36 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011343 | 0, i8, i9, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i7 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011356 | 0, gb + 1011365 | 0, i7, 0);
 i6 = i9 + 8 | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011378 | 0, i6, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011394 | 0, i7, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011409 | 0, i7, i1 + 362 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011426 | 0, i7, i1 + 375 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011444 | 0, i7, i1 + 361 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011467 | 0, i6, i1 + 404 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011497 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 368 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011514 | 0, HEAP32[gb + 37240 >> 2] | 0, i1 + 372 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011529 | 0, HEAP32[gb + 37252 >> 2] | 0, i1 + 374 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i15, i2, i1) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i18 = i15 + 108 | 0;
 i19 = HEAP32[i18 >> 2] | 0;
 HEAP32[i17 >> 2] = 57;
 HEAP32[i17 + 4 >> 2] = i19;
 i19 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 36 | 0, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
 i20 = i15 + 84 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 i16 = i15 + 88 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i14 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
 i10 = i1 + (i14 * 36 | 0) | 0;
 if (i14) {
  i6 = i19;
  while (1) {
   HEAP32[i6 >> 2] = 0;
   i7 = i6 + 20 | 0;
   HEAP32[i7 >> 2] = 0;
   i4 = i6 + 24 | 0;
   i13 = i1 + 24 | 0;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i3 = i4;
   HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i3 + 4 >> 2] = i14;
   i3 = i6 + 4 | 0;
   HEAP8[i3 >> 0] = 0;
   do if ((i6 | 0) != (i1 | 0)) {
    i8 = HEAP32[i1 >> 2] | 0;
    i14 = (i8 | 0) == 0;
    i8 = i14 ? i1 + 4 | 0 : i8;
    i9 = HEAP32[i1 + 20 >> 2] | 0;
    i5 = i6 + 4 | 0;
    if (!((HEAP32[i1 + 4 >> 2] | 0) != 0 | i14)) {
     HEAP32[i6 >> 2] = i8;
     HEAP32[i7 >> 2] = i9;
     HEAP32[i5 >> 2] = 0;
     break;
    }
    if (i9 >>> 0 > 15) {
     i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i6 >> 2] = i14;
     HEAP32[i5 >> 2] = i9;
     i3 = (i14 | 0) == 0 ? i3 : i14;
    }
    _memcpy(i3 | 0, i8 | 0, i9 | 0) | 0;
    HEAP8[i3 + i9 >> 0] = 0;
    HEAP32[i7 >> 2] = i9;
   } while (0);
   HEAP32[i6 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i10 | 0)) break; else i6 = i6 + 36 | 0;
  }
  i3 = HEAP32[i16 >> 2] | 0;
 }
 i13 = i19 + (i2 * 36 | 0) | 0;
 i14 = i15 + 48 | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i9 = i15 + 72 | 0;
  i10 = i15 + 80 | 0;
  i11 = i15 + 52 | 0;
  i12 = i15 + 52 | 0;
  i8 = i15 + 68 | 0;
  i4 = i19 + (i3 * 36 | 0) | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i5 = i4 + 20 | 0;
   HEAP32[i5 >> 2] = 0;
   i2 = i4 + 24 | 0;
   i7 = i9;
   i15 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = i2;
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = i15;
   i1 = i4 + 4 | 0;
   HEAP8[i1 >> 0] = 0;
   do if ((i4 | 0) != (i14 | 0)) {
    i6 = HEAP32[i14 >> 2] | 0;
    i15 = (i6 | 0) == 0;
    i6 = i15 ? i12 : i6;
    i7 = HEAP32[i8 >> 2] | 0;
    i3 = i4 + 4 | 0;
    if (!((HEAP32[i11 >> 2] | 0) != 0 | i15)) {
     HEAP32[i4 >> 2] = i6;
     HEAP32[i5 >> 2] = i7;
     HEAP32[i3 >> 2] = 0;
     break;
    }
    if (i7 >>> 0 > 15) {
     i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i2, 0, gb + 1047486 | 0, 251) | 0;
     HEAP32[i4 >> 2] = i15;
     HEAP32[i3 >> 2] = i7;
     i1 = (i15 | 0) == 0 ? i1 : i15;
    }
    _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i1 + i7 >> 0] = 0;
    HEAP32[i5 >> 2] = i7;
   } while (0);
   HEAP32[i4 + 32 >> 2] = HEAP32[i10 >> 2];
   i4 = i4 + 36 | 0;
  } while ((i4 | 0) != (i13 | 0));
  i2 = HEAP32[i16 >> 2] | 0;
 }
 if (!i2) {
  i16 = HEAP32[i20 >> 2] | 0;
  i15 = HEAP32[i18 >> 2] | 0;
  HEAP32[i17 >> 2] = 57;
  i18 = i17 + 4 | 0;
  HEAP32[i18 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i17);
  HEAP32[i20 >> 2] = i19;
  STACKTOP = i21;
  return;
 } else i1 = 0;
 do {
  i3 = HEAP32[i20 >> 2] | 0;
  i4 = HEAP32[i3 + (i1 * 36 | 0) >> 2] | 0;
  if (i4 | 0) if (HEAP32[i3 + (i1 * 36 | 0) + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i4, i3 + (i1 * 36 | 0) + 24 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i16 = HEAP32[i20 >> 2] | 0;
 i15 = HEAP32[i18 >> 2] | 0;
 HEAP32[i17 >> 2] = 57;
 i18 = i17 + 4 | 0;
 HEAP32[i18 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i17);
 HEAP32[i20 >> 2] = i19;
 STACKTOP = i21;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i10 = i12 + 76 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = (i1 | 0) == 0;
 i11 = i13;
 L1 : do if (i7) {
  HEAP32[i9 >> 2] = 0;
  HEAP8[i9 + 4 >> 0] = -1;
  i3 = i12 + 44 | 0;
  i2 = 0;
  i8 = 14;
 } else {
  i2 = i11 + ~(i11 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = HEAP32[(HEAP32[i12 + 68 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   HEAP32[i9 >> 2] = 0;
   HEAP8[i9 + 4 >> 0] = -1;
   i2 = i12 + 44 | 0;
  } else {
   i4 = HEAP32[i12 + 60 >> 2] | 0;
   i5 = i12 + 64 | 0;
   i3 = i2;
   do {
    i2 = i4 + (i3 << 4) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i13 | 0)) {
     i8 = 8;
     break;
    }
    i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   } while ((i3 | 0) != -1);
   if ((i8 | 0) == 8) if (i2 | 0) {
    i13 = i2;
    i13 = i13 + 4 | 0;
    STACKTOP = i14;
    return i13 | 0;
   }
   HEAP32[i9 >> 2] = 0;
   HEAP8[i9 + 4 >> 0] = -1;
   i2 = i12 + 44 | 0;
   if (i7) {
    i3 = i2;
    i2 = 0;
    i8 = 14;
    break;
   }
  }
  i6 = i11 + ~(i11 << 15) | 0;
  i6 = (i6 >>> 10 ^ i6) * 9 | 0;
  i6 = i6 >>> 6 ^ i6;
  i6 = i6 + ~(i6 << 11) | 0;
  i6 = i1 + -1 & (i6 >>> 16 ^ i6);
  i3 = HEAP32[(HEAP32[i12 + 68 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  if ((i3 | 0) == -1) {
   i3 = i2;
   i2 = i6;
   i8 = 14;
  } else {
   i4 = HEAP32[i12 + 60 >> 2] | 0;
   i5 = i12 + 64 | 0;
   while (1) {
    if ((HEAP32[i4 + (i3 << 4) >> 2] | 0) == (i13 | 0)) break L1;
    i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if ((i3 | 0) == -1) {
     i3 = i2;
     i2 = i6;
     i8 = 14;
     break;
    }
   }
  }
 } while (0);
 if ((i8 | 0) == 14) {
  i4 = i12 + 92 | 0;
  if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i12 + 72 >> 2] | 0)) {
   i2 = i7 ? 16 : i1 << 1;
   if (i1 >>> 0 < i2 >>> 0) {
    __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i3, i2);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i8 = i11 + ~(i11 << 15) | 0;
   i8 = (i8 >>> 10 ^ i8) * 9 | 0;
   i8 = i8 >>> 6 ^ i8;
   i8 = i8 + ~(i8 << 11) | 0;
   i1 = i1 + -1 & (i8 >>> 16 ^ i8);
  } else i1 = i2;
  i7 = i12 + 84 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i8 + 1;
  i1 = (HEAP32[i12 + 68 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[(HEAP32[i12 + 64 >> 2] | 0) + (i8 << 2) >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i1 = i12 + 88 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i12 + 60 >> 2] | 0;
  HEAP32[i1 + (i8 << 4) >> 2] = i11;
  HEAP8[i1 + (i8 << 4) + 4 >> 0] = 0;
  HEAP8[i1 + (i8 << 4) + 5 >> 0] = 0;
  i7 = i1 + (i8 << 4) + 6 | 0;
  i9 = i9 + 1 | 0;
  i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
  HEAP8[i7 >> 0] = i9;
  HEAP8[i7 + 1 >> 0] = i9 >> 8;
  HEAP8[i7 + 2 >> 0] = i9 >> 16;
  HEAP8[i7 + 3 >> 0] = i9 >> 24;
  HEAP8[i1 + (i8 << 4) + 10 >> 0] = 0;
  HEAP8[i1 + (i8 << 4) + 11 >> 0] = 0;
  HEAP8[i1 + (i8 << 4) + 12 >> 0] = 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (!i1) {
  i13 = 0;
  i13 = i13 + 4 | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i11 = i11 + ~(i11 << 15) | 0;
 i11 = (i11 >>> 10 ^ i11) * 9 | 0;
 i11 = i11 >>> 6 ^ i11;
 i11 = i11 + ~(i11 << 11) | 0;
 i1 = HEAP32[(HEAP32[i12 + 68 >> 2] | 0) + ((i1 + -1 & (i11 >>> 16 ^ i11)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i13 = 0;
  i13 = i13 + 4 | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = HEAP32[i12 + 60 >> 2] | 0;
 i3 = i12 + 64 | 0;
 i2 = i1;
 while (1) {
  i1 = i4 + (i2 << 4) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i13 | 0)) {
   i8 = 24;
   break;
  }
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i8 = 24;
   break;
  }
 }
 if ((i8 | 0) == 24) {
  i13 = i1 + 4 | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i20 = i10 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i10 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i10 + 12 | 0;
 i23 = i7 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i10 + 20 | 0;
 i21 = i7 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i2 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i2;
 HEAP8[i22 >> 0] = i20;
 i22 = i7 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i2 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i21;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i19;
 i2 = i18;
 HEAP32[i2 >> 2] = i17;
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 127;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN12b2MotorJoint24SolveVelocityConstraintsERK12b2SolverData(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, i27 = 0;
 i20 = i4 + 104 | 0;
 i16 = HEAP32[i20 >> 2] | 0;
 i24 = i1 + 28 | 0;
 i27 = HEAP32[i24 >> 2] | 0;
 f25 = Math_fround(HEAPF32[i27 + (i16 * 12 | 0) >> 2]);
 f26 = Math_fround(HEAPF32[i27 + (i16 * 12 | 0) + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i27 + (i16 * 12 | 0) + 8 >> 2]);
 i16 = i4 + 108 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i27 + (i7 * 12 | 0) >> 2]);
 f18 = Math_fround(HEAPF32[i27 + (i7 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i27 + (i7 * 12 | 0) + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 156 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 160 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 164 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 168 >> 2]);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f10 - f8);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i4 + 100 >> 2]));
 f2 = Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 152 >> 2])));
 f2 = Math_fround(Math_fround(HEAPF32[i4 + 188 >> 2]) * f2);
 i7 = i4 + 88 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f6 * Math_fround(HEAPF32[i4 + 96 >> 2]));
 f2 = Math_fround(f9 - f2);
 f11 = Math_fround(-f14);
 f14 = f2 < f14 ? f2 : f14;
 f14 = f14 < f11 ? f11 : f14;
 HEAPF32[i7 >> 2] = f14;
 f9 = Math_fround(f14 - f9);
 f8 = Math_fround(f8 - Math_fround(f22 * f9));
 f9 = Math_fround(f10 + Math_fround(f23 * f9));
 f10 = Math_fround(HEAPF32[i4 + 124 >> 2]);
 f14 = Math_fround(f10 * f9);
 f11 = Math_fround(HEAPF32[i4 + 120 >> 2]);
 f14 = Math_fround(Math_fround(f17 - f14) - f25);
 f2 = Math_fround(Math_fround(f18 + Math_fround(f11 * f9)) - f26);
 f12 = Math_fround(HEAPF32[i4 + 116 >> 2]);
 f15 = Math_fround(f12 * f8);
 f13 = Math_fround(HEAPF32[i4 + 112 >> 2]);
 f14 = Math_fround(f15 + f14);
 f2 = Math_fround(f2 - Math_fround(f13 * f8));
 f15 = Math_fround(Math_fround(HEAPF32[i4 + 144 >> 2]) * f3);
 f14 = Math_fround(f15 + f14);
 f2 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i4 + 148 >> 2])) + f2);
 f3 = Math_fround(Math_fround(HEAPF32[i4 + 172 >> 2]) * f14);
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i4 + 180 >> 2]) * f2));
 f14 = Math_fround(Math_fround(HEAPF32[i4 + 176 >> 2]) * f14);
 f2 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i4 + 184 >> 2]) * f2));
 i7 = i4 + 80 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i4 + 84 | 0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f14 - f3);
 HEAPF32[i7 >> 2] = f3;
 f2 = Math_fround(f15 - f2);
 HEAPF32[i1 >> 2] = f2;
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i4 + 92 >> 2]));
 f5 = Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3));
 if (f5 > Math_fround(f6 * f6)) {
  f5 = Math_fround(Math_sqrt(Math_fround(f5)));
  if (!(f5 < Math_fround(1.1920929e-07))) {
   f5 = Math_fround(Math_fround(1.0) / f5);
   f3 = Math_fround(f3 * f5);
   HEAPF32[i7 >> 2] = f3;
   f2 = Math_fround(f2 * f5);
   HEAPF32[i1 >> 2] = f2;
  }
  f3 = Math_fround(f6 * f3);
  HEAPF32[i7 >> 2] = f3;
  f2 = Math_fround(f6 * f2);
  HEAPF32[i1 >> 2] = f2;
 }
 f6 = Math_fround(f3 - f14);
 f5 = Math_fround(f2 - f15);
 f14 = Math_fround(f25 - Math_fround(f19 * f6));
 f15 = Math_fround(f26 - Math_fround(f19 * f5));
 f19 = Math_fround(f8 - Math_fround(f22 * Math_fround(Math_fround(f13 * f5) - Math_fround(f6 * f12))));
 f22 = Math_fround(f17 + Math_fround(f21 * f6));
 f25 = Math_fround(f18 + Math_fround(f21 * f5));
 f26 = Math_fround(f9 + Math_fround(f23 * Math_fround(Math_fround(f5 * f11) - Math_fround(f6 * f10))));
 i7 = HEAP32[i20 >> 2] | 0;
 i27 = HEAP32[i24 >> 2] | 0;
 HEAPF32[i27 + (i7 * 12 | 0) >> 2] = f14;
 HEAPF32[i27 + (i7 * 12 | 0) + 4 >> 2] = f15;
 i7 = HEAP32[i24 >> 2] | 0;
 HEAPF32[i7 + ((HEAP32[i20 >> 2] | 0) * 12 | 0) + 8 >> 2] = f19;
 i27 = HEAP32[i16 >> 2] | 0;
 HEAPF32[i7 + (i27 * 12 | 0) >> 2] = f22;
 HEAPF32[i7 + (i27 * 12 | 0) + 4 >> 2] = f25;
 HEAPF32[(HEAP32[i24 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) * 12 | 0) + 8 >> 2] = f26;
 return;
}

function __Z29FindRelativeTransformWithPathR9TransformPKcb(i1, i7, i5) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = (HEAP32[gb + 1159900 >> 2] | 0) + 1 | 0;
 HEAP32[gb + 1159900 >> 2] = i12;
 L1 : do if (i12 >>> 0 > 2e3) i1 = 0; else {
  i3 = HEAP8[i7 >> 0] | 0;
  if (i3 << 24 >> 24) {
   i12 = i7;
   i2 = i3;
   L3 : while (1) {
    switch (i2 << 24 >> 24) {
    case 0:
    case 47:
     break L3;
    default:
     {}
    }
    i2 = i12 + 1 | 0;
    i12 = i2;
    i2 = HEAP8[i2 >> 0] | 0;
   }
   i11 = i12 - i7 | 0;
   switch (i3 << 24 >> 24) {
   case 47:
    {
     i1 = __Z27FindActiveTransformWithPathPKc(i7) | 0;
     break L1;
    }
   case 46:
    {
     i4 = 7;
     break;
    }
   default:
    {}
   }
   L9 : do if ((i4 | 0) == 7) if ((HEAP8[i7 + 1 >> 0] | 0) == 46) {
    i2 = HEAP32[i1 + 100 >> 2] | 0;
    switch (HEAP8[i7 + 2 >> 0] | 0) {
    case 0:
     {
      i1 = i2;
      break L1;
     }
    case 47:
     break;
    default:
     break L9;
    }
    if (!i2) {
     i1 = 0;
     break L1;
    }
    i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i2, i7 + 3 | 0, 0) | 0;
    break L1;
   } while (0);
   i9 = i1 + 80 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i10 = i12 + 1 | 0;
   i8 = i1 + 92 | 0;
   L15 : do if (!(HEAP32[i8 >> 2] | 0)) {
    i2 = 2;
    i1 = 0;
   } else {
    i6 = (i11 | 0) > 0;
    if (i5) {
     i5 = i2;
     i1 = 0;
     while (1) {
      i4 = HEAP32[i5 >> 2] | 0;
      i2 = HEAP32[i4 + 28 >> 2] | 0;
      if (i2) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
       i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
       if ((_strlen(i3) | 0) == (i11 | 0)) {
        L24 : do if (i6) {
         i2 = 0;
         while (1) {
          if ((HEAP8[i7 + i2 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break L24;
          i2 = i2 + 1 | 0;
          if ((i2 | 0) < (i11 | 0)) i3 = i3 + 1 | 0; else break;
         }
        } else i2 = 0; while (0);
        if ((i2 | 0) == (i11 | 0)) {
         if (!(HEAP8[i12 >> 0] | 0)) {
          i2 = 1;
          i1 = i4;
          break L15;
         }
         i4 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i4, i10, 0) | 0;
         i2 = (i4 | 0) == 0;
         i1 = i2 ? i1 : i4;
         i2 = i2 ? 0 : i2 & 1 ^ 1;
         if (i2) break L15;
        }
       }
      }
      i5 = i5 + 4 | 0;
      if ((i5 | 0) == ((HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0)) {
       i2 = 2;
       break L15;
      }
     }
    }
    if (i6) {
     i5 = i2;
     i1 = 0;
    } else {
     i5 = (i11 | 0) == 0;
     i4 = i2;
     i1 = 0;
     while (1) {
      i3 = HEAP32[i4 >> 2] | 0;
      if ((_strlen(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0) | 0) == (i11 | 0) & i5) {
       if (!(HEAP8[i12 >> 0] | 0)) {
        i2 = 1;
        i1 = i3;
        break L15;
       }
       i7 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i3, i10, 0) | 0;
       i2 = (i7 | 0) == 0;
       i1 = i2 ? i1 : i7;
       i2 = i2 ? 0 : i2 & 1 ^ 1;
       if (i2) break L15;
      }
      i4 = i4 + 4 | 0;
      if ((i4 | 0) == ((HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0)) {
       i2 = 2;
       break L15;
      }
     }
    }
    while (1) {
     i4 = HEAP32[i5 >> 2] | 0;
     i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     if ((_strlen(i3) | 0) == (i11 | 0)) {
      i2 = 0;
      while (1) {
       if ((HEAP8[i7 + i2 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break;
       i2 = i2 + 1 | 0;
       if ((i2 | 0) < (i11 | 0)) i3 = i3 + 1 | 0; else break;
      }
      if ((i2 | 0) == (i11 | 0)) {
       if (!(HEAP8[i12 >> 0] | 0)) {
        i2 = 1;
        i1 = i4;
        break L15;
       }
       i6 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i4, i10, 0) | 0;
       i2 = (i6 | 0) == 0;
       i1 = i2 ? i1 : i6;
       i2 = i2 ? 0 : i2 & 1 ^ 1;
       if (i2) break L15;
      }
     }
     i5 = i5 + 4 | 0;
     if ((i5 | 0) == ((HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0)) {
      i2 = 2;
      break;
     }
    }
   } while (0);
   i1 = (i2 | 0) == 2 ? 0 : i1;
  }
 } while (0);
 HEAP32[gb + 1159900 >> 2] = (HEAP32[gb + 1159900 >> 2] | 0) + -1;
 return i1 | 0;
}

function __Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 64 | 0;
 i8 = i9;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31312 | 0) | 0;
 do if (i5 | 0) {
  i1 = i5 + 32 | 0;
  i2 = i5 + 272 | 0;
  i4 = HEAP16[i2 >> 1] | 0;
  if ((i4 & 65535) > 255 | (i4 & 255) << 24 >> 24 != 0) {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
   HEAP8[i2 >> 0] = 0;
   HEAP8[i1 + 241 >> 0] = 0;
  }
  i2 = i5 + 36 | 0;
  i3 = i2 + 152 | 0;
  i4 = i2 + 164 | 0;
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  i1 = i2 + 168 | 0;
  if (!(f10 != Math_fround(HEAPF32[gb + 1162364 >> 2]))) {
   f10 = Math_fround(HEAPF32[i1 >> 2]);
   if (!(f10 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]))) {
    f10 = Math_fround(HEAPF32[i2 + 172 >> 2]);
    if (!(f10 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]))) break;
   }
  }
  __ZNK9Transform21GetWorldToLocalMatrixEv(i7, __ZN8Renderer12GetTransformEv(i5) | 0);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i7, i2, i8);
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f10 = Math_fround(HEAPF32[i2 + 172 >> 2]);
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(f19 * f13);
  i5 = f12 < Math_fround(0.0);
  f22 = Math_fround(-f12);
  f23 = Math_fround(HEAPF32[i8 + 16 >> 2]);
  f11 = Math_fround(f17 * f23);
  i7 = f11 < Math_fround(0.0);
  f15 = Math_fround(-f11);
  f11 = Math_fround((i5 ? f22 : f12) + (i7 ? f15 : f11));
  f15 = Math_fround(HEAPF32[i8 + 32 >> 2]);
  f12 = Math_fround(f10 * f15);
  i7 = f12 < Math_fround(0.0);
  f22 = Math_fround(-f12);
  f12 = Math_fround(f11 + (i7 ? f22 : f12));
  f22 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f11 = Math_fround(f19 * f22);
  i7 = f11 < Math_fround(0.0);
  f20 = Math_fround(-f11);
  f21 = Math_fround(HEAPF32[i8 + 20 >> 2]);
  f24 = Math_fround(f17 * f21);
  i5 = f24 < Math_fround(0.0);
  f14 = Math_fround(-f24);
  f24 = Math_fround((i7 ? f20 : f11) + (i5 ? f14 : f24));
  f14 = Math_fround(HEAPF32[i8 + 36 >> 2]);
  f11 = Math_fround(f10 * f14);
  i5 = f11 < Math_fround(0.0);
  f20 = Math_fround(-f11);
  f11 = Math_fround(f24 + (i5 ? f20 : f11));
  f20 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f19 = Math_fround(f19 * f20);
  i5 = f19 < Math_fround(0.0);
  f24 = Math_fround(-f19);
  f18 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f17 = Math_fround(f17 * f18);
  i7 = f17 < Math_fround(0.0);
  f16 = Math_fround(-f17);
  f17 = Math_fround((i5 ? f24 : f19) + (i7 ? f16 : f17));
  f16 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  f10 = Math_fround(f10 * f16);
  i7 = f10 < Math_fround(0.0);
  f19 = Math_fround(-f10);
  f10 = Math_fround(f17 + (i7 ? f19 : f10));
  f19 = Math_fround(HEAPF32[i3 >> 2]);
  f13 = Math_fround(f13 * f19);
  f17 = Math_fround(HEAPF32[i2 + 156 >> 2]);
  f23 = Math_fround(f13 + Math_fround(f23 * f17));
  f13 = Math_fround(HEAPF32[i2 + 160 >> 2]);
  f15 = Math_fround(f23 + Math_fround(f15 * f13));
  f15 = Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f15);
  f14 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(f21 * f17)) + Math_fround(f14 * f13));
  f14 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f14);
  f13 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f17)) + Math_fround(f16 * f13));
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i8 + 56 >> 2]));
  HEAPF32[i6 >> 2] = f15;
  HEAPF32[i6 + 4 >> 2] = f14;
  HEAPF32[i6 + 8 >> 2] = f13;
  HEAPF32[i6 + 12 >> 2] = f12;
  HEAPF32[i6 + 16 >> 2] = f11;
  HEAPF32[i6 + 20 >> 2] = f10;
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx3Scb5Scene13addRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE(i4, i5, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 816 | 0;
 i11 = i17 + 544 | 0;
 i15 = i17 + 272 | 0;
 i14 = i17;
 HEAP32[i5 >> 2] = i4;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!(HEAP8[i4 + 2433 >> 0] | 0)) {
  HEAP32[i6 >> 2] = i2 & 268435455 | -2147483648;
  __ZL22addOrRemoveRigidObjectILb0ELb1ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(HEAP32[i4 + 1252 >> 2] | 0, i5);
  STACKTOP = i17;
  return;
 }
 i1 = i2 & 1073741823;
 if (i2 >>> 0 > 3221225471) {
  HEAP32[i6 >> 2] = i1 | -2147483648;
  if (!(i2 & 268435456)) {
   HEAP32[i16 >> 2] = i5;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i16) | 0;
  }
 } else {
  HEAP32[i6 >> 2] = i1 | 1073741824;
  HEAP32[i11 >> 2] = i5;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i11, i16) | 0;
  if (!(HEAP8[i16 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
 }
 i1 = HEAP32[i4 + 1252 >> 2] | 0;
 do if (!i1) {
  i13 = i15 + 256 | 0;
  i10 = i15 + 260 | 0;
  HEAP32[i15 + 264 >> 2] = 0;
  i11 = i15 + 268 | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i10 >> 2] = i15;
  HEAP32[i11 >> 2] = 64;
  i12 = i14 + 256 | 0;
  HEAP8[i12 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i14, i15);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i5, i16) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i14 + 268 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i14 + 260 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
  i16 = HEAP32[i11 >> 2] | 0;
  do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i15 | 0) == (i1 | 0)) {
    HEAP8[i13 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i10 = i11 + 256 | 0;
  HEAP8[i10 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i11, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i8 = i1 + -16 | 0;
  i9 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i5, i16) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] & -1073741824;
  if (i9 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | i6;
     HEAP32[i2 + i8 >> 2] = i7;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i9 | 0));
  }
  i16 = HEAP32[i11 + 268 >> 2] | 0;
  if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i11 + 260 >> 2] | 0;
   if ((i11 | 0) == (i1 | 0)) {
    HEAP8[i10 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN17CommonStringTableC2Ev(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15;
 i2 = i14 + 400 | 0;
 i3 = i14;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
  i11 = i1;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i3 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  i3 = i3 + 20 | 0;
 } while ((i3 | 0) != (i2 | 0));
 i12 = gb + 63648 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i14 + 4 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i11;
 i13 = gb + 63648 | 0;
 i11 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i12 = i14 + 24 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 44 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 64 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 84 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 104 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 124 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 144 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 164 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 184 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 204 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 224 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 244 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 264 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 284 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 304 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 324 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 344 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 364 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = i14 + 384 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = gb + 388687 | 0;
 do {
  i13 = _strlen(i12) | 0;
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 0; else {
   i2 = 0;
   i3 = i12;
   do {
    i2 = (i2 << 4) + (i1 << 24 >> 24) | 0;
    i11 = i2 & -268435456;
    i2 = (i11 >>> 24 | i11) ^ i2;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i3 = i12;
  i4 = (i2 >>> 0) % 20 | 0;
  i5 = i14 + (i4 * 20 | 0) | 0;
  i6 = i14 + (i4 * 20 | 0) + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i9 = i14 + (i4 * 20 | 0) + 16 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i11 = i10 & 2147483647;
  do if (i8 >>> 0 > i11 >>> 0) {
   i1 = i10 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i11 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i9 >> 2] = i1;
    HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 3, 4, i14 + (i4 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i14 + (i4 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i5 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i8;
  i11 = HEAP32[i5 >> 2] | 0;
  HEAP32[i11 + (i7 << 3) >> 2] = i2;
  HEAP32[i11 + (i7 << 3) + 4 >> 2] = i3;
  i12 = i12 + (i13 + 1) | 0;
 } while (i12 >>> 0 < (gb + 388687 + 1052 | 0) >>> 0);
 i1 = 0;
 do {
  i2 = i14 + (i1 * 20 | 0) + 16 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   i13 = i14 + (i1 * 20 | 0) | 0;
   i12 = HEAP32[i14 + (i1 * 20 | 0) + 12 >> 2] | 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i12 << 3, 4, i14 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 STACKTOP = i15;
 return;
}

function __ZN5physx8debugger4comm20PvdConnectionManager6createERNS_19PxAllocatorCallbackES4_b(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 212, gb + 776851 | 0, gb + 776869 | 0, 382) | 0;
 i4 = i3 + 8 | 0;
 HEAP32[i3 >> 2] = gb + 150616 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 150616 + 96;
 HEAP32[i4 >> 2] = gb + 150616 + 120;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i3 + 16 >> 2] = i2;
 HEAP32[i3 + 20 >> 2] = 0;
 i2 = i1;
 i8 = i3 + 28 | 0;
 HEAP32[i8 >> 2] = i2;
 i7 = i3 + 32 | 0;
 HEAP32[i7 >> 2] = gb + 776964;
 HEAP32[i3 + 24 >> 2] = gb + 148172 + 8;
 i6 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i6 | 0, HEAP32[i7 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i3 + 36 >> 2] = i7;
 __ZN5physx6shdfnd9MutexImplC2Ev(i7);
 HEAP32[i3 + 40 >> 2] = __ZN5physx8debugger11StringTable6createERNS_19PxAllocatorCallbackE(i1) | 0;
 i1 = i3 + 44 | 0;
 HEAP32[i3 + 48 >> 2] = i2;
 HEAP32[i3 + 52 >> 2] = gb + 776990;
 HEAP32[i1 >> 2] = gb + 150752 + 8;
 i7 = i3 + 56 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAPF32[i3 + 80 >> 2] = Math_fround(.75);
 HEAP32[i3 + 84 >> 2] = -1;
 HEAP32[i3 + 88 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i3 + 96 | 0;
 HEAP32[i3 + 100 >> 2] = i2;
 HEAP32[i3 + 104 >> 2] = gb + 777022;
 HEAP32[i1 >> 2] = gb + 150768 + 8;
 i7 = i3 + 108 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAPF32[i3 + 132 >> 2] = Math_fround(.75);
 HEAP32[i3 + 136 >> 2] = -1;
 HEAP32[i3 + 140 >> 2] = 0;
 HEAP32[i3 + 144 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i3 + 152 >> 2] = i2;
 HEAP32[i3 + 156 >> 2] = gb + 777052;
 HEAP32[i3 + 160 >> 2] = 0;
 HEAP32[i3 + 164 >> 2] = 0;
 HEAP32[i3 + 168 >> 2] = 0;
 HEAP32[i3 + 148 >> 2] = gb + 150784 + 8;
 i1 = i3 + 172 | 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i3 + 196 | 0;
 HEAP32[i7 >> 2] = i2;
 i2 = i3 + 200 | 0;
 HEAP32[i2 >> 2] = gb + 777081;
 HEAP32[i3 + 192 >> 2] = gb + 148172 + 8;
 i6 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i2 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i3 + 204 >> 2] = i2;
 __ZN5physx6shdfnd9MutexImplC2Ev(i2);
 HEAP32[i3 + 208 >> 2] = 0;
 if (!i5) {
  i6 = fb + 3676 | 0;
  i7 = 0;
  i2 = fb + 186 | 0;
  i5 = 0;
  i8 = i3 + 176 | 0;
  HEAP32[i8 >> 2] = i2;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i5;
  i8 = i3 + 184 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 16 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = mftCall_ii(i7 | 0, i8 | 0) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 16 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vii(i7 | 0, i8 | 0, i4 | 0);
  return i3 | 0;
 }
 HEAP32[i1 >> 2] = __ZN5physx28PxProfileMemoryEventRecorder14createRecorderEPNS_12PxFoundationE(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) | 0;
 i6 = fb + 3677 | 0;
 i7 = 0;
 i2 = fb + 187 | 0;
 i5 = 0;
 i8 = i3 + 176 | 0;
 HEAP32[i8 >> 2] = i2;
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i5;
 i8 = i3 + 184 | 0;
 HEAP32[i8 >> 2] = i6;
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + 16 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = mftCall_ii(i7 | 0, i8 | 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + 16 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(i7 | 0, i8 | 0, i4 | 0);
 return i3 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i10 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i10 + 12 | 0;
 i18 = i7 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i10 + 20 | 0;
 i17 = i7 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i2;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i10 + 20 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 6;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN11b2GearJoint24SolveVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0;
 i16 = i1 + 160 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i3 = i2 + 28 | 0;
 i31 = HEAP32[i3 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i31 + (i5 * 12 | 0) >> 2]);
 f29 = Math_fround(HEAPF32[i31 + (i5 * 12 | 0) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i31 + (i5 * 12 | 0) + 8 >> 2]);
 i5 = i1 + 164 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i31 + (i8 * 12 | 0) >> 2]);
 f28 = Math_fround(HEAPF32[i31 + (i8 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i31 + (i8 * 12 | 0) + 8 >> 2]);
 i8 = i1 + 168 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 f27 = Math_fround(HEAPF32[i31 + (i2 * 12 | 0) >> 2]);
 f26 = Math_fround(HEAPF32[i31 + (i2 * 12 | 0) + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i31 + (i2 * 12 | 0) + 8 >> 2]);
 i2 = i1 + 172 | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 f24 = Math_fround(HEAPF32[i31 + (i13 * 12 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i31 + (i13 * 12 | 0) + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i31 + (i13 * 12 | 0) + 8 >> 2]);
 f17 = Math_fround(f19 - f27);
 f20 = Math_fround(f29 - f26);
 f11 = Math_fround(HEAPF32[i1 + 240 >> 2]);
 f17 = Math_fround(f17 * f11);
 f25 = Math_fround(HEAPF32[i1 + 244 >> 2]);
 f20 = Math_fround(f17 + Math_fround(f20 * f25));
 f17 = Math_fround(f15 - f24);
 f30 = Math_fround(f28 - f23);
 f7 = Math_fround(HEAPF32[i1 + 248 >> 2]);
 f17 = Math_fround(f17 * f7);
 f22 = Math_fround(HEAPF32[i1 + 252 >> 2]);
 f30 = Math_fround(f20 + Math_fround(f17 + Math_fround(f30 * f22)));
 f17 = Math_fround(HEAPF32[i1 + 256 >> 2]);
 f20 = Math_fround(f14 * f17);
 f9 = Math_fround(HEAPF32[i1 + 264 >> 2]);
 f20 = Math_fround(f20 - Math_fround(f6 * f9));
 f12 = Math_fround(HEAPF32[i1 + 260 >> 2]);
 f18 = Math_fround(f10 * f12);
 f4 = Math_fround(HEAPF32[i1 + 268 >> 2]);
 f18 = Math_fround(f30 + Math_fround(f20 + Math_fround(f18 - Math_fround(f21 * f4))));
 f18 = Math_fround(Math_fround(HEAPF32[i1 + 272 >> 2]) * f18);
 f20 = Math_fround(-f18);
 i13 = i1 + 156 | 0;
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f18);
 f18 = Math_fround(Math_fround(HEAPF32[i1 + 208 >> 2]) * f20);
 f19 = Math_fround(f19 + Math_fround(f11 * f18));
 f18 = Math_fround(f29 + Math_fround(f25 * f18));
 f17 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 224 >> 2]) * f20) * f17));
 f14 = Math_fround(Math_fround(HEAPF32[i1 + 212 >> 2]) * f20);
 f15 = Math_fround(f15 + Math_fround(f7 * f14));
 f14 = Math_fround(f28 + Math_fround(f14 * f22));
 f12 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 228 >> 2]) * f20) * f12));
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 216 >> 2]) * f20);
 f11 = Math_fround(f27 - Math_fround(f11 * f10));
 f10 = Math_fround(f26 - Math_fround(f25 * f10));
 f9 = Math_fround(f6 - Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 232 >> 2]) * f20) * f9));
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 220 >> 2]) * f20);
 f7 = Math_fround(f24 - Math_fround(f7 * f6));
 f6 = Math_fround(f23 - Math_fround(f22 * f6));
 f4 = Math_fround(f21 - Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 236 >> 2]) * f20) * f4));
 i13 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i1 + (i13 * 12 | 0) >> 2] = f19;
 HEAPF32[i1 + (i13 * 12 | 0) + 4 >> 2] = f18;
 i13 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i13 + ((HEAP32[i16 >> 2] | 0) * 12 | 0) + 8 >> 2] = f17;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAPF32[i13 + (i1 * 12 | 0) >> 2] = f15;
 HEAPF32[i13 + (i1 * 12 | 0) + 4 >> 2] = f14;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i1 + ((HEAP32[i5 >> 2] | 0) * 12 | 0) + 8 >> 2] = f12;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAPF32[i1 + (i5 * 12 | 0) >> 2] = f11;
 HEAPF32[i1 + (i5 * 12 | 0) + 4 >> 2] = f10;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i5 + ((HEAP32[i8 >> 2] | 0) * 12 | 0) + 8 >> 2] = f9;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i5 + (i1 * 12 | 0) >> 2] = f7;
 HEAPF32[i5 + (i1 * 12 | 0) + 4 >> 2] = f6;
 HEAPF32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 >> 2] = f4;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRK16BlendShapeVertexS3_EPS1_EEbT0_S8_T_(i19, i20, i15) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i21;
 switch ((i20 - i19 | 0) / 40 | 0 | 0) {
 case 2:
  {
   i11 = i20 + -40 | 0;
   if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i11 | 0, i19 | 0) | 0)) {
    i20 = 1;
    STACKTOP = i21;
    return i20 | 0;
   }
   i1 = HEAP32[i19 >> 2] | 0;
   i2 = HEAP32[i19 + 4 >> 2] | 0;
   i3 = HEAP32[i19 + 8 >> 2] | 0;
   i4 = HEAP32[i19 + 12 >> 2] | 0;
   i5 = HEAP32[i19 + 16 >> 2] | 0;
   i6 = HEAP32[i19 + 20 >> 2] | 0;
   i7 = HEAP32[i19 + 24 >> 2] | 0;
   i8 = HEAP32[i19 + 28 >> 2] | 0;
   i9 = HEAP32[i19 + 32 >> 2] | 0;
   i10 = HEAP32[i19 + 36 >> 2] | 0;
   i16 = i19;
   i17 = i11;
   i18 = i16 + 40 | 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
    i16 = i16 + 4 | 0;
    i17 = i17 + 4 | 0;
   } while ((i16 | 0) < (i18 | 0));
   HEAP32[i11 >> 2] = i1;
   HEAP32[i20 + -36 >> 2] = i2;
   HEAP32[i20 + -32 >> 2] = i3;
   HEAP32[i20 + -28 >> 2] = i4;
   HEAP32[i20 + -24 >> 2] = i5;
   HEAP32[i20 + -20 >> 2] = i6;
   HEAP32[i20 + -16 >> 2] = i7;
   HEAP32[i20 + -12 >> 2] = i8;
   HEAP32[i20 + -8 >> 2] = i9;
   HEAP32[i20 + -4 >> 2] = i10;
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i19, i19 + 40 | 0, i20 + -40 | 0, i15) | 0;
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_(i19, i19 + 40 | 0, i19 + 80 | 0, i20 + -40 | 0, i15) | 0;
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i19, i19 + 40 | 0, i19 + 80 | 0, i19 + 120 | 0, i20 + -40 | 0, i15) | 0;
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 case 1:
 case 0:
  {
   i20 = 1;
   STACKTOP = i21;
   return i20 | 0;
  }
 default:
  {
   i3 = i19 + 80 | 0;
   __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i19, i19 + 40 | 0, i3, i15) | 0;
   i1 = i19 + 120 | 0;
   L3 : do if ((i1 | 0) == (i20 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i5 + 4 | 0;
    i7 = i5 + 8 | 0;
    i8 = i5 + 12 | 0;
    i9 = i5 + 16 | 0;
    i10 = i5 + 20 | 0;
    i11 = i5 + 24 | 0;
    i12 = i5 + 28 | 0;
    i13 = i5 + 32 | 0;
    i14 = i5 + 36 | 0;
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i1 + 20 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i1 + 24 >> 2];
      HEAP32[i12 >> 2] = HEAP32[i1 + 28 >> 2];
      HEAP32[i13 >> 2] = HEAP32[i1 + 32 >> 2];
      HEAP32[i14 >> 2] = HEAP32[i1 + 36 >> 2];
      i4 = i1;
      while (1) {
       i16 = i4;
       i17 = i3;
       i18 = i16 + 40 | 0;
       do {
        HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
        i16 = i16 + 4 | 0;
        i17 = i17 + 4 | 0;
       } while ((i16 | 0) < (i18 | 0));
       if ((i3 | 0) == (i19 | 0)) break;
       i4 = i3 + -40 | 0;
       if (mftCall_iii(HEAP32[i15 >> 2] | 0, i5 | 0, i4 | 0) | 0) {
        i18 = i3;
        i3 = i4;
        i4 = i18;
       } else break;
      }
      i16 = i3;
      i17 = i5;
      i18 = i16 + 40 | 0;
      do {
       HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
       i16 = i16 + 4 | 0;
       i17 = i17 + 4 | 0;
      } while ((i16 | 0) < (i18 | 0));
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 40 | 0) == (i20 | 0);
       break L3;
      }
     }
     i3 = i1 + 40 | 0;
     if ((i3 | 0) == (i20 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i18 = i1;
      i1 = i3;
      i3 = i18;
     }
    }
   } while (0);
   i20 = i1 | i2;
   STACKTOP = i21;
   return i20 | 0;
  }
 }
 return 0;
}

function __ZN9AudioClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 44 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 64 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 65 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 66 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN16StreamedResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 72 | 0, i5);
 i1 = i4 + 104 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i4 + 32 | 0;
 i21 = i4;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f13));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f19 * f19));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f16 * f16)))));
 f15 = Math_fround(f15 * f17);
 f13 = Math_fround(f13 * f17);
 f19 = Math_fround(f19 * f17);
 f17 = Math_fround(f16 * f17);
 i24 = HEAP32[i2 + 16 >> 2] | 0;
 i23 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) >> 2] = f15;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2] = f13;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2] = f19;
 HEAPF32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2] = f17;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2] = i24;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2] = i23;
 HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2] = i22;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = i3 + 76 | 0;
 i26 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i26 >> 2] | 0) + 28 >> 2] | 0, i26 | 0, i25 | 0, i25 + 4 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i21, i3, HEAP32[i25 + (i1 << 2) >> 2] | 0);
 f16 = Math_fround(-Math_fround(HEAPF32[i21 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i21 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i21 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i21 + 16 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i21 + 20 >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f9 - Math_fround(HEAPF32[i21 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f6 = Math_fround(Math_fround(Math_fround(f11 * f16) + Math_fround(f10 * f18)) + Math_fround(f9 * f12));
 f8 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f20 * f11) + Math_fround(f14 * Math_fround(Math_fround(f9 * f18) - Math_fround(f10 * f12)))));
 f7 = Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f14 * Math_fround(Math_fround(f11 * f12) - Math_fround(f9 * f16)))));
 f6 = Math_fround(Math_fround(Math_fround(f20 * f9) + Math_fround(f14 * Math_fround(Math_fround(f10 * f16) - Math_fround(f11 * f18)))) + Math_fround(f6 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f17 * f18) + Math_fround(f13 * f14))) - Math_fround(f19 * f16));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f19 * f14))) - Math_fround(f15 * f18));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) - Math_fround(f15 * f16)) - Math_fround(f13 * f18)) - Math_fround(f19 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14))) - Math_fround(f13 * f12));
 HEAPF32[i5 + (i1 * 28 | 0) + 4 >> 2] = f11;
 HEAPF32[i5 + (i1 * 28 | 0) + 8 >> 2] = f10;
 HEAPF32[i5 + (i1 * 28 | 0) + 12 >> 2] = f9;
 HEAPF32[i5 + (i1 * 28 | 0) + 16 >> 2] = f8;
 HEAPF32[i5 + (i1 * 28 | 0) + 20 >> 2] = f7;
 HEAPF32[i5 + (i1 * 28 | 0) + 24 >> 2] = f6;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN19MeshParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i3 = i7 + 220 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1047999 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i5 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 221 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048022 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 224 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048035 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 228 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048055 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 35; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 35; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 236 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048075 | 0, gb + 1048082 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx11HullLibrary11ComputeHullEjPKfRNS_11PHullResultEjff(i6, i8, i9, i27, i1, f5, f4) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i28 + 26 | 0;
 i23 = i28 + 25 | 0;
 i2 = i28 + 20 | 0;
 i26 = i28 + 16 | 0;
 i11 = i28 + 12 | 0;
 i10 = i28 + 8 | 0;
 i7 = i28 + 4 | 0;
 i3 = i28;
 i25 = i28 + 24 | 0;
 if (f5 == Math_fround(0.0)) {
  i1 = __ZN5physx11HullLibrary8calchullEPNS_6float3EiRPiRiRS2_S5_if(i6, i9, i8, i7, i3, i11, i10, i1, f4) | 0;
  if ((i1 & -3 | 0) == 1) {
   i27 = i1;
   STACKTOP = i28;
   return i27 | 0;
  }
  i26 = HEAP32[i3 >> 2] | 0;
  HEAP32[i27 + 4 >> 2] = i26 * 3;
  HEAP32[i27 + 8 >> 2] = i26;
  HEAP32[i27 + 16 >> 2] = HEAP32[i7 >> 2];
  switch (i1 | 0) {
  case 2:
   {
    HEAP32[i27 + 12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i27 >> 2] = HEAP32[i10 >> 2];
    i27 = 0;
    STACKTOP = i28;
    return i27 | 0;
   }
  case 0:
   {
    HEAP32[i27 + 12 >> 2] = i9;
    HEAP32[i27 >> 2] = i8;
    i27 = 0;
    STACKTOP = i28;
    return i27 | 0;
   }
  default:
   {
    i27 = 0;
    STACKTOP = i28;
    return i27 | 0;
   }
  }
 }
 i3 = __ZN5physx11HullLibrary9overhullvEPNS_6float3EiiRS2_RiRPiS4_ffif(i6, i9, i8, 35, i11, i10, i26, i2, f5, Math_fround(120.0), i1, f4) | 0;
 if ((i3 & -3 | 0) == 1) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i24, i2);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i27 = i3;
  STACKTOP = i28;
  return i27 | 0;
 }
 HEAP32[i27 + 12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i27 >> 2] = HEAP32[i10 >> 2];
 if ((i3 | 0) == 2) {
  i25 = HEAP32[i2 >> 2] | 0;
  HEAP32[i27 + 4 >> 2] = i25 * 3;
  HEAP32[i27 + 8 >> 2] = i25;
  HEAP32[i27 + 16 >> 2] = HEAP32[i26 >> 2];
  i27 = 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i3 = HEAP32[i26 >> 2] | 0;
 i18 = HEAP32[i3 >> 2] | 0;
 if ((i18 | 0) > 0) {
  i1 = 0;
  i2 = 0;
  i8 = 0;
  i7 = 0;
  i6 = 0;
  i21 = 0;
  i16 = 1;
  while (1) {
   i19 = i16 + 1 | 0;
   i20 = HEAP32[i3 + (i16 << 2) >> 2] | 0;
   if ((i20 | 0) > 2) {
    i15 = i3 + (i19 << 2) | 0;
    i17 = i1 + -2 | 0;
    i14 = 2;
    while (1) {
     i11 = HEAP32[i15 >> 2] | 0;
     i12 = HEAP32[i3 + (i14 + i16 << 2) >> 2] | 0;
     i13 = HEAP32[i3 + (i14 + i19 << 2) >> 2] | 0;
     if ((i1 | 0) == (i6 | 0)) {
      i6 = (i1 | 0) == 0 ? 16 : i1 << 1;
      i10 = i7;
      i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i24, i6 * 12 | 0, gb + 730303 | 0, 136) | 0;
      i2 = i8;
      if ((i1 | 0) > 0) {
       HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
       HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
       if ((i1 | 0) > 1) {
        i9 = 1;
        do {
         i22 = i8 + (i9 * 12 | 0) | 0;
         i29 = i10 + (i9 * 12 | 0) | 0;
         HEAP32[i22 >> 2] = HEAP32[i29 >> 2];
         HEAP32[i22 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
         HEAP32[i22 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
         i9 = i9 + 1 | 0;
        } while ((i9 | 0) != (i1 | 0));
        i22 = 23;
       } else i22 = 23;
      } else if (i7 | 0) i22 = 23;
      if ((i22 | 0) == 23) {
       i22 = 0;
       __ZN5physx6shdfnd9Allocator10deallocateEPv(i23, i7);
      }
     }
     HEAP32[i8 + (i1 * 12 | 0) >> 2] = i11;
     HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] = i12;
     HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] = i13;
     i14 = i14 + 1 | 0;
     i7 = i8;
     if ((i14 | 0) == (i20 | 0)) {
      i1 = i6;
      break;
     } else i1 = i1 + 1 | 0;
    }
    i6 = i1;
    i1 = i17 + i20 | 0;
   }
   i21 = i21 + 1 | 0;
   if ((i21 | 0) == (i18 | 0)) break; else i16 = i20 + i19 | 0;
  }
  i3 = HEAP32[i26 >> 2] | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i25, i3);
 HEAP32[i26 >> 2] = 0;
 HEAP32[i27 + 4 >> 2] = i1 * 3;
 HEAP32[i27 + 8 >> 2] = i1;
 HEAP32[i27 + 16 >> 2] = i2;
 i29 = 0;
 STACKTOP = i28;
 return i29 | 0;
}

function __ZN7VRInput27ResetAllReferenceTransformsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i8 + 8 | 0;
 i2 = i1;
 if ((i2 | 0) == (i11 | 0)) {
  __ZN7VRInput27ClearAllReferenceTransformsEv(i8);
  STACKTOP = i13;
  return;
 }
 i7 = i2;
 while (1) {
  i6 = HEAP32[i7 + 16 >> 2] | 0;
  do if (i6 | 0) {
   HEAP32[i10 >> 2] = i6;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i12 = 10; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i5 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
     i5 = HEAP32[i9 >> 2] | 0;
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
     i2 = i4;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i12 = 10; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i12 = 12;
   }
   if ((i12 | 0) == 10) i12 = 12;
   if ((i12 | 0) == 12) {
    i12 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = i6;
   if (!i2) i12 = 19; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 19; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i12 = 21;
    }
   }
   if ((i12 | 0) == 19) i12 = 21;
   if ((i12 | 0) == 21) {
    i12 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
   }
   __ZN9Transform16SetLocalPositionERK8Vector3f(i2, i7 + 20 | 0);
   HEAP32[i10 >> 2] = i6;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i12 = 27; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 27; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i12 = 29;
    }
   }
   if ((i12 | 0) == 27) i12 = 29;
   if ((i12 | 0) == 29) {
    i12 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
   }
   __ZN9Transform16SetLocalRotationERK11Quaternionf(i2, i7 + 32 | 0);
  } while (0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i11 | 0)) break; else {
   i1 = i2;
   i7 = i2;
  }
 }
 __ZN7VRInput27ClearAllReferenceTransformsEv(i8);
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i20 = i10 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i10 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i10 + 12 | 0;
 i23 = i7 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i10 + 20 | 0;
 i21 = i7 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i2 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i2;
 HEAP8[i22 >> 0] = i20;
 i22 = i7 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i2 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i2 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i21;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i19;
 i2 = i18;
 HEAP32[i2 >> 2] = i17;
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function runPostSets214() {
 HEAP32[gb + 184164 >> 2] = fb + 53;
 HEAP32[gb + 184168 >> 2] = fb + 52;
 HEAP32[gb + 184172 >> 2] = fb + 110;
 HEAP32[gb + 184176 >> 2] = fb + 105;
 HEAP32[gb + 184180 >> 2] = fb + 138;
 HEAP32[gb + 184184 >> 2] = fb + 121;
 HEAP32[gb + 184188 >> 2] = fb + 139;
 HEAP32[gb + 184200 >> 2] = fb + 2786;
 HEAP32[gb + 184204 >> 2] = fb + 2787;
 HEAP32[gb + 184208 >> 2] = fb + 2788;
 HEAP32[gb + 184212 >> 2] = fb + 145;
 HEAP32[gb + 184216 >> 2] = fb + 16;
 HEAP32[gb + 184220 >> 2] = fb + 93;
 HEAP32[gb + 184224 >> 2] = fb + 2789;
 HEAP32[gb + 184228 >> 2] = fb + 2790;
 HEAP32[gb + 184232 >> 2] = fb + 1298;
 HEAP32[gb + 184236 >> 2] = fb + 103;
 HEAP32[gb + 184240 >> 2] = fb + 101;
 HEAP32[gb + 184244 >> 2] = fb + 62;
 HEAP32[gb + 184248 >> 2] = fb + 28;
 HEAP32[gb + 184252 >> 2] = fb + 63;
 HEAP32[gb + 184256 >> 2] = fb + 29;
 HEAP32[gb + 184260 >> 2] = fb + 34;
 HEAP32[gb + 184264 >> 2] = fb + 2113;
 HEAP32[gb + 184268 >> 2] = fb + 2114;
 HEAP32[gb + 184272 >> 2] = fb + 2115;
 HEAP32[gb + 184276 >> 2] = fb + 2116;
 HEAP32[gb + 184280 >> 2] = fb + 2117;
 HEAP32[gb + 184284 >> 2] = fb + 2118;
 HEAP32[gb + 184288 >> 2] = fb + 36;
 HEAP32[gb + 184292 >> 2] = fb + 104;
 HEAP32[gb + 184296 >> 2] = fb + 108;
 HEAP32[gb + 184300 >> 2] = fb + 94;
 HEAP32[gb + 184304 >> 2] = fb + 130;
 HEAP32[gb + 184308 >> 2] = fb + 112;
 HEAP32[gb + 184312 >> 2] = fb + 113;
 HEAP32[gb + 184316 >> 2] = fb + 131;
 HEAP32[gb + 184320 >> 2] = fb + 111;
 HEAP32[gb + 184324 >> 2] = fb + 112;
 HEAP32[gb + 184328 >> 2] = fb + 113;
 HEAP32[gb + 184332 >> 2] = fb + 2791;
 HEAP32[gb + 184336 >> 2] = fb + 2792;
 HEAP32[gb + 184340 >> 2] = (HEAP32[gb + 184340 >> 2] | 0) + (gb + 931464 | 0);
 HEAP32[gb + 184344 >> 2] = (HEAP32[gb + 184344 >> 2] | 0) + (gb + 931488 | 0);
 HEAP32[gb + 184348 >> 2] = (HEAP32[gb + 184348 >> 2] | 0) + (gb + 931535 | 0);
 HEAP32[gb + 184352 >> 2] = (HEAP32[gb + 184352 >> 2] | 0) + (gb + 931395 | 0);
 HEAP32[gb + 184356 >> 2] = (HEAP32[gb + 184356 >> 2] | 0) + (gb + 931418 | 0);
 HEAP32[gb + 184360 >> 2] = (HEAP32[gb + 184360 >> 2] | 0) + (gb + 935336 | 0);
 HEAP32[gb + 184364 >> 2] = (HEAP32[gb + 184364 >> 2] | 0) + (gb + 931324 | 0);
 HEAP32[gb + 184368 >> 2] = (HEAP32[gb + 184368 >> 2] | 0) + (gb + 931348 | 0);
 HEAP32[gb + 184372 >> 2] = (HEAP32[gb + 184372 >> 2] | 0) + (gb + 935336 | 0);
 HEAP32[gb + 184384 >> 2] = fb + 2793;
 HEAP32[gb + 184388 >> 2] = fb + 2794;
 HEAP32[gb + 184392 >> 2] = fb + 2795;
 HEAP32[gb + 184396 >> 2] = fb + 2119;
 HEAP32[gb + 184400 >> 2] = fb + 2796;
 HEAP32[gb + 184404 >> 2] = fb + 2797;
 HEAP32[gb + 184408 >> 2] = fb + 40;
 HEAP32[gb + 184412 >> 2] = fb + 19;
 HEAP32[gb + 184416 >> 2] = fb + 1299;
 HEAP32[gb + 184420 >> 2] = fb + 31;
 HEAP32[gb + 184424 >> 2] = fb + 27;
 HEAP32[gb + 184428 >> 2] = fb + 62;
 HEAP32[gb + 184432 >> 2] = fb + 28;
 HEAP32[gb + 184436 >> 2] = fb + 63;
 HEAP32[gb + 184440 >> 2] = fb + 29;
 HEAP32[gb + 184444 >> 2] = fb + 34;
 HEAP32[gb + 184448 >> 2] = fb + 2120;
 HEAP32[gb + 184452 >> 2] = fb + 2121;
 HEAP32[gb + 184456 >> 2] = fb + 2122;
 HEAP32[gb + 184460 >> 2] = fb + 2123;
 HEAP32[gb + 184464 >> 2] = fb + 2124;
 HEAP32[gb + 184468 >> 2] = fb + 2125;
 HEAP32[gb + 184472 >> 2] = fb + 36;
 HEAP32[gb + 184484 >> 2] = fb + 2798;
 HEAP32[gb + 184488 >> 2] = fb + 2799;
 HEAP32[gb + 184492 >> 2] = fb + 459;
 HEAP32[gb + 184496 >> 2] = fb + 457;
 HEAP32[gb + 184500 >> 2] = fb + 81;
 HEAP32[gb + 184504 >> 2] = fb + 122;
 HEAP32[gb + 184508 >> 2] = fb + 82;
 HEAP32[gb + 184512 >> 2] = fb + 458;
 HEAP32[gb + 184516 >> 2] = fb + 2800;
 HEAP32[gb + 184520 >> 2] = fb + 2126;
 HEAP32[gb + 184524 >> 2] = fb + 2127;
 HEAP32[gb + 184528 >> 2] = fb + 1300;
 HEAP32[gb + 184532 >> 2] = fb + 1301;
 HEAP32[gb + 184536 >> 2] = fb + 2801;
 HEAP32[gb + 184540 >> 2] = fb + 2802;
 HEAP32[gb + 184544 >> 2] = fb + 460;
 HEAP32[gb + 184548 >> 2] = fb + 1302;
 HEAP32[gb + 184552 >> 2] = fb + 459;
 HEAP32[gb + 184556 >> 2] = fb + 460;
 HEAP32[gb + 184560 >> 2] = fb + 461;
 HEAP32[gb + 184564 >> 2] = fb + 461;
 HEAP32[gb + 184568 >> 2] = fb + 462;
 HEAP32[gb + 184572 >> 2] = fb + 166;
 HEAP32[gb + 184576 >> 2] = fb + 167;
 HEAP32[gb + 184580 >> 2] = fb + 168;
 HEAP32[gb + 184584 >> 2] = fb + 462;
 runPostSets215();
}

function __ZN19CloudServiceHandlerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAP32[i1 + 76 >> 2] = 2592e3;
 HEAP32[i1 + 80 >> 2] = 20;
 HEAP32[i1 + 84 >> 2] = 60;
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046961 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046961 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046961 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046961 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046961 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046961 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046968 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046968 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046968 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046968 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046968 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046968 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i1 + 120 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 6;
 HEAP8[i2 >> 0] = HEAP8[gb + 1046975 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 1046975 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1046975 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1046975 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1046975 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 1046975 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = 0;
 i2 = i1 + 136 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 184 >> 2] = gb + 189712 + 8;
 HEAP8[i1 + 188 >> 0] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 __ZN11UnityEngine15CloudWebService19SessionEventManagerC2Ev(i1 + 200 | 0);
 i2 = i1 + 1072 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcherC2ERNS0_11IRestClientE(i1 + 792 | 0, i2);
 __ZN11UnityEngine15CloudWebService13WWWRestClientC2Ev(i2);
 HEAP32[i1 + 1140 >> 2] = 0;
 HEAP32[i1 + 1144 >> 2] = 0;
 HEAP32[i1 + 1148 >> 2] = 1;
 HEAP32[i1 + 1152 >> 2] = 0;
 HEAP32[i1 + 1156 >> 2] = 0;
 HEAP32[i1 + 1160 >> 2] = 0;
 HEAP32[i1 + 1164 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1168 >> 2] = 0;
 return;
}

function __ZN6Sprite10InitializeEP9Texture2DRK5RectTIfERK8Vector2ffj14SpriteMeshTypeRK8Vector4ffbPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENSD_9allocatorISG_EEEE(i12, i7, i15, i5, f17, i18, i19, i6, f20, i21, i13) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 f17 = Math_fround(f17);
 i18 = i18 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 f20 = Math_fround(f20);
 i21 = i21 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i16 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i22;
 i2 = i15 + 8 | 0;
 i16 = (i19 | 0) == 1 ? Math_fround(HEAPF32[i2 >> 2]) >= Math_fround(32.0) : 0;
 i4 = i15 + 12 | 0;
 i16 = i16 & Math_fround(HEAPF32[i4 >> 2]) >= Math_fround(32.0);
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 if (!i1) i8 = 0; else i8 = (HEAP32[i1 + 8 >> 2] | 0) != 0;
 i9 = i12 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i1 = i5;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = i12 + 72 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 i10 = i12 + 48 | 0;
 f24 = Math_fround(HEAPF32[i15 >> 2]);
 i11 = i15 + 4 | 0;
 f26 = Math_fround(HEAPF32[i11 >> 2]);
 f23 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(f23 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(Math_fround(f26 + Math_fround(f3 * Math_fround(HEAPF32[i5 + 4 >> 2]))) - Math_fround(f26 + Math_fround(f3 * Math_fround(.5))));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(f24 + f25) - Math_fround(f24 + Math_fround(f23 * Math_fround(.5))));
 HEAPF32[i12 + 52 >> 2] = f3;
 i1 = i12 + 140 | 0;
 if (f17 > Math_fround(0.0)) f3 = f17; else f3 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i1 >> 2] = f3;
 HEAP32[i12 + 144 >> 2] = i18;
 i2 = i12 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP8[i12 + 148 >> 0] = i21 & 1;
 i2 = i12 + 80 | 0;
 if (!i7) i1 = 0; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 if (i16 & i8 | i21) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  __ZN16SpriteRenderData16GenerateFullMeshERK5RectTIfERK8Vector2fffjPS1_bPNSt3__26vectorI13dynamic_arrayIS4_Lj4EENS8_9allocatorISB_EEEE(i2, i9, i10, f17, f20, i18, i14, i21, i13);
  i21 = i12 + 88 | 0;
  HEAP32[i21 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  f23 = Math_fround(HEAPF32[i9 >> 2]);
  f23 = Math_fround(f23 + Math_fround(HEAPF32[i21 >> 2]));
  HEAPF32[i21 >> 2] = f23;
  f24 = Math_fround(HEAPF32[i12 + 36 >> 2]);
  i21 = i12 + 92 | 0;
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i21 >> 2]));
  HEAPF32[i21 >> 2] = f24;
  i21 = i12 + 112 | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | 64;
  f25 = Math_fround(HEAPF32[i15 >> 2]);
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  f25 = Math_fround(f23 - f25);
  f26 = Math_fround(f24 - f26);
  i21 = i12 + 104 | 0;
  HEAPF32[i21 >> 2] = f25;
  i21 = i12 + 108 | 0;
  HEAPF32[i21 >> 2] = f26;
  i21 = i12 + 132 | 0;
  HEAP8[i21 >> 0] = 1;
  STACKTOP = i22;
  return;
 } else {
  __ZN16SpriteRenderData16GenerateQuadMeshERK5RectTIfERK8Vector2ff(i2, i9, i10, f17);
  i21 = i12 + 88 | 0;
  HEAP32[i21 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i21 = i12 + 112 | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] & -65 | i19 << 6 & 64;
  f23 = Math_fround(HEAPF32[i12 + 88 >> 2]);
  f24 = Math_fround(HEAPF32[i12 + 92 >> 2]);
  f25 = Math_fround(HEAPF32[i15 >> 2]);
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  f25 = Math_fround(f23 - f25);
  f26 = Math_fround(f24 - f26);
  i21 = i12 + 104 | 0;
  HEAPF32[i21 >> 2] = f25;
  i21 = i12 + 108 | 0;
  HEAPF32[i21 >> 2] = f26;
  i21 = i12 + 132 | 0;
  HEAP8[i21 >> 0] = 1;
  STACKTOP = i22;
  return;
 }
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesERKNS0_14IterationStateIS2_EE(i30, i5) {
 i30 = i30 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i31 = 0, f32 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i31 + 392 | 0;
 i10 = i31 + 280 | 0;
 i6 = i31 + 272 | 0;
 i7 = i31 + 248 | 0;
 i2 = i31 + 244 | 0;
 i3 = i31 + 240 | 0;
 i19 = i31 + 224 | 0;
 i21 = i31 + 216 | 0;
 i22 = i31 + 200 | 0;
 i23 = i31 + 192 | 0;
 i24 = i31 + 176 | 0;
 i25 = i31 + 168 | 0;
 i26 = i31 + 152 | 0;
 i27 = i31 + 144 | 0;
 i29 = i31 + 128 | 0;
 i12 = i31 + 112 | 0;
 i28 = i31 + 96 | 0;
 i13 = i31 + 80 | 0;
 i14 = i31 + 64 | 0;
 i15 = i31 + 48 | 0;
 i16 = i31 + 32 | 0;
 i17 = i31 + 16 | 0;
 i18 = i31;
 i4 = i30 + 432 | 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 192 >> 2] | 0;
 if (!i1) {
  STACKTOP = i31;
  return;
 }
 i20 = i30 + 436 | 0;
 i9 = __ZN14StackAllocatorILj16EE8allocateEj(HEAP32[i20 >> 2] | 0, i1 * 80 | 0) | 0;
 __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEC2EPKf(i6, HEAP32[(HEAP32[i4 >> 2] | 0) + 188 >> 2] | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 + 192 >> 2] | 0) == 1) __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth17UnalignedIteratorIS1_Lj3EEEEEvPNS3_12TriangleDataERKT0_j(i9, i6, HEAP32[i1 + 192 >> 2] | 0); else {
  __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEC2EPKf(i2, HEAP32[i1 + 184 >> 2] | 0);
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  f32 = Math_fround(__ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv(i5));
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
  __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ES4_S4_f(i7, i10, i11, f32);
  __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth12LerpIteratorIS1_NS3_17UnalignedIteratorIS1_Lj3EEEEEEEvPNS3_12TriangleDataERKT0_j(i9, i7, HEAP32[(HEAP32[i4 >> 2] | 0) + 192 >> 2] | 0);
 }
 i8 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] << 2;
 i2 = i1 + (i8 << 2) | 0;
 if ((i8 | 0) > 0) {
  i3 = i11 + 16 | 0;
  i4 = i11 + 32 | 0;
  i5 = i11 + 48 | 0;
  i6 = i10 + 96 | 0;
  i7 = i10 + 16 | 0;
  i8 = i10 + 32 | 0;
  do {
   __Z11loadAlignedPKfj(i21, i1, 0);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i19, i21);
   __ZN8Scalar4faSERKS_(i11, i19) | 0;
   __Z11loadAlignedPKfj(i23, i1, 16);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i22, i23);
   __ZN8Scalar4faSERKS_(i3, i22) | 0;
   __Z11loadAlignedPKfj(i25, i1, 32);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i24, i25);
   __ZN8Scalar4faSERKS_(i4, i24) | 0;
   __Z11loadAlignedPKfj(i27, i1, 48);
   __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i26, i27);
   __ZN8Scalar4faSERKS_(i5, i26) | 0;
   __Z9transposeR8Scalar4fS0_S0_S0_(i11, i3, i4, i5);
   __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i10);
   __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesEPKNS0_12TriangleDataEPS2_RNS3_18ImpulseAccumulatorE(i30, i9, i11, i10);
   __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i12, gb + 1097856 | 0);
   if (__Z10anyGreaterRK8Scalar4fS1_RS_(i6, i12, i29) | 0) {
    __Z5recipRK8Scalar4f(i28, i6);
    __ZmlRK8Scalar4fS1_(i14, i10, i28);
    __ZplRK8Scalar4fS1_(i13, i11, i14);
    __ZN8Scalar4faSERKS_(i11, i13) | 0;
    __ZmlRK8Scalar4fS1_(i16, i7, i28);
    __ZplRK8Scalar4fS1_(i15, i3, i16);
    __ZN8Scalar4faSERKS_(i3, i15) | 0;
    __ZmlRK8Scalar4fS1_(i18, i8, i28);
    __ZplRK8Scalar4fS1_(i17, i4, i18);
    __ZN8Scalar4faSERKS_(i4, i17) | 0;
    __Z9transposeR8Scalar4fS0_S0_S0_(i11, i3, i4, i5);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 0, i11);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 16, i3);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 32, i4);
    __Z12storeAlignedPfjRK8Scalar4f(i1, 48, i5);
   }
   i1 = i1 + 64 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 __ZN14StackAllocatorILj16EE10deallocateEPv(HEAP32[i20 >> 2] | 0, i9);
 STACKTOP = i31;
 return;
}

function __ZN16LightmapSettings8TransferI14SafeBinaryReadEEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_(i10, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 7);
 i2 = i10 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402150 | 0, gb + 402174 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN21EnlightenSceneMapping8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i10 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402196 | 0, gb + 402210 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI11LightProbesE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i10 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402228 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i6 = i10 + 28 | 0;
 i4 = (HEAP32[i6 >> 2] | 0) + 12 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402240 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i10 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402256 | 0, gb + 402269 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN10GISettings8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i10 + 236 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402280 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i7 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 41; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 3) | 0) HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] = 1;
 i9 = __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 1) | 0;
 i1 = (HEAP32[i6 >> 2] | 0) + 8 | 0;
 if (!i9) if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 HEAP8[i10 + 96 >> 0] = 1;
 HEAP8[i10 + 97 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab20ShaderBlendStateDescC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 4 >> 2] = -1;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 12 >> 2] = -1;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 20 >> 2] = -1;
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 28 >> 2] = -1;
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 36 >> 2] = -1;
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 44 >> 2] = -1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 52 >> 2] = -1;
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 60 >> 2] = -1;
 HEAPF32[i1 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 68 >> 2] = -1;
 HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 76 >> 2] = -1;
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 84 >> 2] = -1;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 92 >> 2] = -1;
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 100 >> 2] = -1;
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 108 >> 2] = -1;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 116 >> 2] = -1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 124 >> 2] = -1;
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 132 >> 2] = -1;
 HEAPF32[i1 + 136 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 140 >> 2] = -1;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 148 >> 2] = -1;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 156 >> 2] = -1;
 HEAPF32[i1 + 160 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 164 >> 2] = -1;
 HEAPF32[i1 + 168 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 172 >> 2] = -1;
 HEAPF32[i1 + 176 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 180 >> 2] = -1;
 HEAPF32[i1 + 184 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 188 >> 2] = -1;
 HEAPF32[i1 + 192 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 196 >> 2] = -1;
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 204 >> 2] = -1;
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 212 >> 2] = -1;
 HEAPF32[i1 + 216 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 220 >> 2] = -1;
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 228 >> 2] = -1;
 HEAPF32[i1 + 232 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 236 >> 2] = -1;
 HEAPF32[i1 + 240 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 244 >> 2] = -1;
 HEAPF32[i1 + 248 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 252 >> 2] = -1;
 HEAPF32[i1 + 256 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 260 >> 2] = -1;
 HEAPF32[i1 + 264 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 268 >> 2] = -1;
 HEAPF32[i1 + 272 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 276 >> 2] = -1;
 HEAPF32[i1 + 280 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 284 >> 2] = -1;
 HEAPF32[i1 + 288 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 292 >> 2] = -1;
 HEAPF32[i1 + 296 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 300 >> 2] = -1;
 HEAPF32[i1 + 304 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 308 >> 2] = -1;
 HEAPF32[i1 + 312 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 316 >> 2] = -1;
 HEAPF32[i1 + 320 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 324 >> 2] = -1;
 HEAPF32[i1 + 328 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 332 >> 2] = -1;
 HEAPF32[i1 + 336 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 340 >> 2] = -1;
 HEAPF32[i1 + 344 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 348 >> 2] = -1;
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 356 >> 2] = -1;
 HEAPF32[i1 + 360 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 364 >> 2] = -1;
 HEAPF32[i1 + 368 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 372 >> 2] = -1;
 HEAPF32[i1 + 376 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 380 >> 2] = -1;
 HEAPF32[i1 + 384 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 388 >> 2] = -1;
 HEAPF32[i1 + 392 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 396 >> 2] = -1;
 HEAPF32[i1 + 400 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 404 >> 2] = -1;
 HEAPF32[i1 + 408 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 412 >> 2] = -1;
 HEAPF32[i1 + 416 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 420 >> 2] = -1;
 HEAPF32[i1 + 424 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 428 >> 2] = -1;
 HEAPF32[i1 + 432 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 436 >> 2] = -1;
 HEAPF32[i1 + 440 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 444 >> 2] = -1;
 HEAPF32[i1 + 448 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 452 >> 2] = -1;
 HEAP8[i1 + 456 >> 0] = 0;
 return;
}

function __ZL8Perlin1DRKN4math8floatNx3ERKf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 * f1);
 f18 = Math_fround(f18 * f1);
 f15 = Math_fround(f15 * f1);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * f1);
 f11 = Math_fround(Math_floor(Math_fround(f7)));
 f4 = Math_fround(Math_floor(Math_fround(f18)));
 f5 = Math_fround(Math_floor(Math_fround(f15)));
 f6 = Math_fround(Math_floor(Math_fround(f12)));
 f7 = Math_fround(f7 - f11);
 f18 = Math_fround(f18 - f4);
 f15 = Math_fround(f15 - f5);
 f12 = Math_fround(f12 - f6);
 f9 = Math_fround(f7 + Math_fround(-1.0));
 f20 = Math_fround(f18 + Math_fround(-1.0));
 f17 = Math_fround(f15 + Math_fround(-1.0));
 f14 = Math_fround(f12 + Math_fround(-1.0));
 i23 = ~~f11 & 255;
 i22 = ~~f4 & 255;
 i21 = ~~f5 & 255;
 i3 = ~~f6 & 255;
 f6 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i23 << 2) >> 2] & 1) << 2) >> 2]);
 f5 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i22 << 2) >> 2] & 1) << 2) >> 2]);
 f4 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i21 << 2) >> 2] & 1) << 2) >> 2]);
 f11 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i3 << 2) >> 2] & 1) << 2) >> 2]);
 f8 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i23 + 1 << 2) >> 2] & 1) << 2) >> 2]);
 f19 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i22 + 1 << 2) >> 2] & 1) << 2) >> 2]);
 f16 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i21 + 1 << 2) >> 2] & 1) << 2) >> 2]);
 f13 = Math_fround(HEAPF32[gb + 82404 + ((HEAP32[gb + 80356 + (i3 + 1 << 2) >> 2] & 1) << 2) >> 2]);
 f10 = Math_fround(f1 * Math_fround(2.0));
 f5 = Math_fround(f10 * Math_fround(Math_fround(f5 + Math_fround(Math_fround(Math_fround(f18 * Math_fround(f18 * f18)) * Math_fround(Math_fround(f18 * Math_fround(Math_fround(f18 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0))) * Math_fround(f19 - f5))) + Math_fround(Math_fround(Math_fround(f18 * Math_fround(f18 * Math_fround(30.0))) * Math_fround(Math_fround(f18 * Math_fround(f18 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f5)))));
 f4 = Math_fround(f10 * Math_fround(Math_fround(f4 + Math_fround(Math_fround(Math_fround(f15 * Math_fround(f15 * f15)) * Math_fround(Math_fround(f15 * Math_fround(Math_fround(f15 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0))) * Math_fround(f16 - f4))) + Math_fround(Math_fround(Math_fround(f15 * Math_fround(f15 * Math_fround(30.0))) * Math_fround(Math_fround(f15 * Math_fround(f15 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f4)))));
 f1 = Math_fround(f10 * Math_fround(Math_fround(f11 + Math_fround(Math_fround(Math_fround(f12 * Math_fround(f12 * f12)) * Math_fround(Math_fround(f12 * Math_fround(Math_fround(f12 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0))) * Math_fround(f13 - f11))) + Math_fround(Math_fround(Math_fround(f12 * Math_fround(f12 * Math_fround(30.0))) * Math_fround(Math_fround(f12 * Math_fround(f12 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f11)))));
 HEAPF32[i2 >> 2] = Math_fround(f10 * Math_fround(Math_fround(f6 + Math_fround(Math_fround(Math_fround(f7 * Math_fround(f7 * f7)) * Math_fround(Math_fround(f7 * Math_fround(Math_fround(f7 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0))) * Math_fround(f8 - f6))) + Math_fround(Math_fround(Math_fround(f7 * Math_fround(f7 * Math_fround(30.0))) * Math_fround(Math_fround(f7 * Math_fround(f7 + Math_fround(-2.0))) + Math_fround(1.0))) * Math_fround(Math_fround(f9 * f8) - Math_fround(f7 * f6)))));
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = f1;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 return;
}

function __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i14, i10, i8, i9, i7) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 4 | 0;
 i1 = i16;
 if ((HEAP16[gb + 1457944 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457944 | 0, i15);
  i13 = gb + 1457944 | 0;
 } else i13 = 0;
 i1 = HEAP32[i14 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 112 >> 2] | 0, i14 | 0) | 0) {
  __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i14, i8 + 8 | 0, i8 + 12 | 0);
  i11 = HEAP32[i9 + 148 >> 2] | 0;
  i12 = (i11 | 0) != 0;
  if (i12) if (!(HEAP8[i11 + 49 >> 0] | 0)) f4 = Math_fround(1.0); else if (!(HEAP32[i11 + 68 >> 2] | 0)) f4 = Math_fround(HEAPF32[i14 + 48 >> 2]); else f4 = Math_fround(1.0); else f4 = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = f4;
  HEAP32[i8 + 4 >> 2] = i14;
  HEAP8[i8 + 20 >> 0] = HEAP8[i14 + 52 >> 0] | 0;
  if (!i7) {
   i1 = i14 + 60 | 0;
   i2 = i14 + 72 | 0;
   HEAP32[i2 >> 2] = 1;
   i3 = i14 + 76 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   do if (!(i5 & 2147483647)) if ((i5 | 0) > -1) {
    HEAP32[i3 >> 2] = 1;
    HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 4, 4, i14 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4, 4, i14 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = 1;
    HEAP32[i1 >> 2] = i7;
    break;
   } while (0);
   i8 = __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb(i9, i8, 1) | 0;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i8;
  } else {
   i5 = HEAP32[i7 + 12 >> 2] | 0;
   i6 = i14 + 60 | 0;
   i1 = i14 + 72 | 0;
   HEAP32[i1 >> 2] = i5;
   i2 = i14 + 76 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i2 >> 2] = i5;
    HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i5 << 2, 4, i14 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i14 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i3 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i6 >> 2] = i3;
    break;
   } while (0);
   if ((i5 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i15 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i15 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     HEAP32[i15 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
     HEAP32[i15 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
     HEAP32[i15 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2];
     i3 = __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb(i9, i15, 0) | 0;
     HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i3;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i5 | 0));
   }
  }
  __ZN6b2Body13ResetMassDataEv(i9);
  i3 = i14 + 80 | 0;
  i1 = i10;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  i1 = i14 + 144 | 0;
  if (i12) __ZNK9Transform13GetLocalScaleEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0); else {
   HEAP32[i15 >> 2] = HEAP32[gb + 62512 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  };
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 }
 if (!i13) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i16;
 return;
}

function __ZN19AssetBundleManifest29GetAllAssetBundlesWithVariantERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i4, i17) {
 i4 = i4 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22;
 i19 = i22 + 8 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i20 = i17 + 4 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i3 = i18 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i20 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i3 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i18);
    i1 = HEAP32[i20 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i4 + 64 >> 2] | 0;
 i16 = i4 + 68 | 0;
 if ((i1 | 0) == (HEAP32[i16 >> 2] | 0)) {
  i21 = i5;
  i20 = HEAP32[i17 >> 2] | 0;
  __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i20, i21, i18);
  STACKTOP = i22;
  return;
 }
 i7 = i4 + 48 | 0;
 i8 = i19 + 12 | 0;
 i6 = i19 + 12 | 0;
 i9 = i18 + 4 | 0;
 i10 = i19 + 8 | 0;
 i11 = i19 + 4 | 0;
 i12 = i17 + 8 | 0;
 i13 = i19 + 11 | 0;
 i14 = i18 + 4 | 0;
 i15 = i18 + 4 | 0;
 i5 = i1;
 do {
  __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_(i7, i18, i5);
  i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i8 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i19);
   i1 = HEAP32[i6 >> 2] | 0;
   i21 = 13;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i13 >> 0] = i3;
   if (!i3) i1 = i19; else {
    i1 = i19;
    i21 = 15;
   }
  } else i21 = 13;
  if ((i21 | 0) == 13) {
   i4 = i3 + 16 & -16;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i9 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i10 >> 2] = i4 | -2147483648;
   HEAP32[i11 >> 2] = i3;
   i21 = 15;
  }
  if ((i21 | 0) == 15) {
   i21 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i20 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i17, i19); else {
   i4 = HEAP8[i13 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i19 >> 2] | 0 : i19;
   i4 = i2 ? HEAP32[i11 >> 2] | 0 : i4 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i21 = 20;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i4;
    if (i4) i21 = 22;
   } else i21 = 20;
   if ((i21 | 0) == 20) {
    i23 = i4 + 16 & -16;
    HEAP32[i18 >> 2] = 66;
    HEAP32[i15 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i23, 16, i18, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = i23 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i2;
    i21 = 22;
   }
   if ((i21 | 0) == 22) {
    i21 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 16;
  }
  if ((HEAP8[i13 >> 0] | 0) < 0) {
   i23 = HEAP32[i19 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   HEAP32[i18 >> 2] = 66;
   HEAP32[i14 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i23, i18);
  }
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) != (HEAP32[i16 >> 2] | 0));
 i23 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i17 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i21, i23, i18);
 STACKTOP = i22;
 return;
}

function __ZN16Physics2DManager7BoxCastERK8Vector2fS2_fS2_fiffPK10Collider2DbP12RaycastHit2Di(i1, i5, i12, f13, i3, f11, i14, f15, f16, i17, i6, i2, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 i3 = i3 | 0;
 f11 = Math_fround(f11);
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 f16 = Math_fround(f16);
 i17 = i17 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i4 = 0, f8 = f0, f9 = f0, f10 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 8 | 0;
 i4 = i24;
 i1 = i24 + 560 | 0;
 i22 = i24 + 540 | 0;
 if ((HEAP16[gb + 1457680 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457680 | 0, i21);
  i23 = gb + 1457680 | 0;
 } else i23 = 0;
 if (!(Math_fround(HEAPF32[i12 >> 2]) <= Math_fround(.0000999999974))) if ((i7 | 0) == 0 ? 1 : Math_fround(HEAPF32[i12 + 4 >> 2]) <= Math_fround(.0000999999974)) i1 = 0; else {
  i18 = f11 == Math_fround(inf);
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(f10 * f10);
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f9 * f9));
  if (!(f8 == Math_fround(0.0))) f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
  f10 = Math_fround(f10 * f8);
  f9 = Math_fround(f9 * f8);
  f11 = i18 ? Math_fround(1.0e5) : f11;
  f10 = Math_fround(f11 * f10);
  f11 = Math_fround(f11 * f9);
  f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f10);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i5 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f11;
  i25 = gb + 64016 | 0;
  i20 = HEAP32[i25 + 4 >> 2] | 0;
  i19 = i4;
  HEAP32[i19 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  i19 = i22 + 16 | 0;
  HEAP32[i19 >> 2] = 0;
  i20 = i22 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i4);
  i25 = i21;
  i3 = HEAP32[i25 + 4 >> 2] | 0;
  i4 = i20;
  HEAP32[i4 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i21, i5, i1, Math_fround(f13 * Math_fround(.0174532924)), i14, f15, f16, i17, i6, i22);
  HEAP32[i21 >> 2] = gb + 158688 + 8;
  HEAP32[i21 + 372 >> 2] = gb + 151728 + 8;
  HEAP32[i21 + 376 >> 2] = 2;
  HEAP32[i21 + 380 >> 2] = HEAP32[gb + 151644 >> 2];
  HEAP32[i21 + 520 >> 2] = 0;
  HEAPF32[i21 + 384 >> 2] = Math_fround(0.0);
  HEAPF32[i21 + 388 >> 2] = Math_fround(0.0);
  i14 = i12;
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i1 = i21 + 524 | 0;
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = i17;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i21, 0) | 0;
  i1 = (i1 | 0) > (i7 | 0) ? i7 : i1;
  if ((i1 | 0) > 0) {
   i7 = HEAP32[i22 >> 2] | 0;
   if (i18) {
    i3 = 0;
    do {
     i4 = i7 + (i3 * 36 | 0) + 28 | 0;
     HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(1.0e5));
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else {
    i3 = 0;
    do {
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   }
  }
  HEAP32[i21 >> 2] = gb + 156124 + 8;
  i2 = i21 + 340 | 0;
  if ((HEAP32[i21 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i21 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i21 + 268 | 0);
  if ((HEAP32[i19 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i20);
   HEAP32[i22 >> 2] = 0;
  }
 } else i1 = 0;
 if (!i23) {
  STACKTOP = i24;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i23);
 STACKTOP = i24;
 return i1 | 0;
}

function _jpeg_copy_critical_parameters(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if ((i1 | 0) == 100) i9 = i12; else {
  i9 = HEAP32[i12 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 20;
  HEAP32[i9 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i12 | 0);
  i9 = i12;
 }
 HEAP32[i12 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i12 + 32 >> 2] = HEAP32[i11 + 32 >> 2];
 i5 = i11 + 36 | 0;
 HEAP32[i12 + 36 >> 2] = HEAP32[i5 >> 2];
 i3 = i11 + 40 | 0;
 HEAP32[i12 + 40 >> 2] = HEAP32[i3 >> 2];
 _jpeg_set_defaults(i12);
 _jpeg_set_colorspace(i12, HEAP32[i3 >> 2] | 0);
 HEAP32[i12 + 56 >> 2] = HEAP32[i11 + 192 >> 2];
 HEAP8[i12 + 179 >> 0] = HEAP8[i11 + 266 >> 0] | 0;
 i3 = i11 + 144 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i4 = i12 + 72 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = _jpeg_alloc_quant_table(i9) | 0;
   HEAP32[i4 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i3 = i1 + 128 | 0;
  do {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   i2 = i2 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP8[(HEAP32[i4 >> 2] | 0) + 128 >> 0] = 0;
 }
 i3 = i11 + 148 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i4 = i12 + 76 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = _jpeg_alloc_quant_table(i9) | 0;
   HEAP32[i4 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i3 = i1 + 128 | 0;
  do {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   i2 = i2 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP8[(HEAP32[i4 >> 2] | 0) + 128 >> 0] = 0;
 }
 i3 = i11 + 152 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i4 = i12 + 80 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = _jpeg_alloc_quant_table(i9) | 0;
   HEAP32[i4 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i3 = i1 + 128 | 0;
  do {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   i2 = i2 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP8[(HEAP32[i4 >> 2] | 0) + 128 >> 0] = 0;
 }
 i3 = i11 + 156 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i4 = i12 + 84 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = _jpeg_alloc_quant_table(i9) | 0;
   HEAP32[i4 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i3 = i1 + 128 | 0;
  do {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   i2 = i2 + 2 | 0;
  } while ((i1 | 0) < (i3 | 0));
  HEAP8[(HEAP32[i4 >> 2] | 0) + 128 >> 0] = 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i8 = i12 + 60 | 0;
 HEAP32[i8 >> 2] = i1;
 if ((i1 + -1 | 0) >>> 0 > 9) {
  i7 = HEAP32[i12 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 26;
  HEAP32[i7 + 24 >> 2] = i1;
  HEAP32[i7 + 28 >> 2] = 10;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) > 0) {
  i4 = 0;
  i5 = HEAP32[i11 + 196 >> 2] | 0;
  i6 = HEAP32[i12 + 68 >> 2] | 0;
  while (1) {
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i7 = HEAP32[i5 + 16 >> 2] | 0;
   HEAP32[i6 + 16 >> 2] = i7;
   i1 = i11 + 144 + (i7 << 2) | 0;
   if (i7 >>> 0 > 3) i10 = 14; else {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) i10 = 14;
   }
   if ((i10 | 0) == 14) {
    i10 = 0;
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 52;
    HEAP32[i2 + 24 >> 2] = i7;
    mftCall_vi(HEAP32[i2 >> 2] | 0, i9 | 0);
    i2 = HEAP32[i1 >> 2] | 0;
   }
   i3 = HEAP32[i5 + 76 >> 2] | 0;
   if (i3 | 0) {
    i1 = 0;
    do {
     if ((HEAP16[i3 + (i1 << 1) >> 1] | 0) != (HEAP16[i2 + (i1 << 1) >> 1] | 0)) {
      i13 = HEAP32[i12 >> 2] | 0;
      HEAP32[i13 + 20 >> 2] = 44;
      HEAP32[i13 + 24 >> 2] = i7;
      mftCall_vi(HEAP32[i13 >> 2] | 0, i9 | 0);
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 64);
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (HEAP32[i8 >> 2] | 0)) break; else {
    i5 = i5 + 84 | 0;
    i6 = i6 + 84 | 0;
   }
  }
 }
 i1 = HEAP32[i11 + 256 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) return;
 if ((i1 & 65280 | 0) == 256) {
  HEAP8[i12 + 197 >> 0] = 1;
  HEAP8[i12 + 198 >> 0] = i1 >>> 16;
 }
 HEAP8[i12 + 199 >> 0] = i1 >>> 24;
 i13 = HEAP32[i11 + 260 >> 2] | 0;
 HEAP16[i12 + 200 >> 1] = i13;
 HEAP16[i12 + 202 >> 1] = i13 >>> 16;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEbT0_SD_T_(i12, i14, i13) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15;
 switch ((i14 - i12 | 0) / 24 | 0 | 0) {
 case 2:
  {
   i1 = i14 + -24 | 0;
   if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i12 | 0) | 0)) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i6 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i6;
   i6 = i12 + 4 | 0;
   i8 = i14 + -20 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i9 = HEAP32[i12 + 8 >> 2] | 0;
   i10 = HEAP32[i12 + 12 >> 2] | 0;
   i11 = HEAP32[i12 + 16 >> 2] | 0;
   i13 = HEAP32[i12 + 20 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i8 >> 2] = i7;
   HEAP32[i14 + -16 >> 2] = i9;
   HEAP32[i14 + -12 >> 2] = i10;
   HEAP32[i14 + -8 >> 2] = i11;
   HEAP32[i14 + -4 >> 2] = i13;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i12, i12 + 24 | 0, i14 + -24 | 0, i13) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_(i12, i12 + 24 | 0, i12 + 48 | 0, i14 + -24 | 0, i13) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_(i12, i12 + 24 | 0, i12 + 48 | 0, i12 + 72 | 0, i14 + -24 | 0, i13) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i3 = i12 + 48 | 0;
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i12, i12 + 24 | 0, i3, i13) | 0;
   i1 = i12 + 72 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i7 = i6 + 4 | 0;
    i8 = i6 + 8 | 0;
    i9 = i6 + 12 | 0;
    i10 = i6 + 16 | 0;
    i11 = i6 + 20 | 0;
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i7 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i9 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i10 >> 2] = HEAP32[i1 + 16 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i1 + 20 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       i5 = i4 + 4 | 0;
       i4 = i3 + 4 | 0;
       HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
       if ((i3 | 0) == (i12 | 0)) break;
       i5 = i3 + -24 | 0;
       if (mftCall_iii(HEAP32[i13 >> 2] | 0, i6 | 0, i5 | 0) | 0) {
        i4 = i3;
        i3 = i5;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
      HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
      HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
      HEAP32[i4 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 24 | 0) == (i14 | 0);
       break L3;
      }
     }
     i3 = i1 + 24 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i5 = i1;
      i1 = i3;
      i3 = i5;
     }
    }
   } while (0);
   i14 = i1 | i2;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 return 0;
}

function _cf2_getGlyphOutline(i11, i12, i4, i14) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 8 | 0;
 i16 = i17;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 20 >> 2];
 i8 = HEAP32[i11 + 132 >> 2] | 0;
 i7 = HEAP32[i11 + 92 >> 2] | 0;
 i9 = HEAP32[i11 + 96 >> 2] | 0;
 i13 = i11 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 i1 = _cf2_getSubfont(i8) | 0;
 i2 = i11 + 136 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = 1;
 }
 i5 = _cf2_getPpemY(i8) | 0;
 i2 = i11 + 84 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i2 >> 2] = i5;
  i1 = 1;
 }
 i3 = HEAP32[i11 + 8 >> 2] | 0;
 HEAP8[i11 + 140 >> 0] = i3 & 1;
 i2 = i11 + 12 | 0;
 if (_memcmp(i4, i2, 16) | 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i11 + 32 >> 2] = 0;
  HEAP32[i11 + 28 >> 2] = 0;
  i1 = i11 + 36 | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i11 + 72 >> 2] = 65536;
  HEAP32[i11 + 60 >> 2] = 65536;
  HEAP32[i11 + 68 >> 2] = 0;
  HEAP32[i11 + 64 >> 2] = 0;
  i1 = 1;
 }
 i6 = i11 + 142 | 0;
 i2 = i3 & 2;
 if ((HEAPU8[i6 >> 0] | 0 | 0) == (i2 | 0)) {
  if (i1 << 24 >> 24) i10 = 10;
 } else {
  HEAP8[i6 >> 0] = i2;
  i10 = 10;
 }
 if ((i10 | 0) == 10) {
  i2 = HEAP32[i11 + 88 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 1e3 : i2;
  i4 = (i5 | 0) < 262144 ? 262144 : i5;
  i5 = 65536e3 / (i2 | 0) | 0;
  i1 = _cf2_getStdVW(i8) | 0;
  i3 = i11 + 176 | 0;
  HEAP32[i3 >> 2] = i1;
  if ((i1 | 0) < 1) {
   i1 = _UNITY_FT_DivFix(4915200, i5) | 0;
   HEAP32[i3 >> 2] = i1;
  }
  if ((i7 | 0) > 0) {
   i1 = i2 << 16;
   if ((i7 | 0) > (_UNITY_FT_DivFix(i1, i4) | 0)) i2 = i7; else i2 = _UNITY_FT_DivFix(i1, i4) | 0;
   i1 = i11 + 184 | 0;
   HEAP32[i1 >> 2] = 0;
   if (!((i5 | 0) < 655 | (i2 | 0) == 0)) HEAP32[i1 >> 2] = (i2 | 0) / 2 | 0;
  } else _cf2_computeDarkening(i5, i4, i1, i11 + 184 | 0, 0, HEAP8[i6 >> 0] | 0, i11 + 144 | 0);
  i1 = _cf2_getStdHW(i8) | 0;
  if ((i1 | 0) > 0) if ((HEAP32[i3 >> 2] | 0) > (i1 << 1 | 0)) {
   i2 = _UNITY_FT_DivFix(4915200, i5) | 0;
   HEAP32[i11 + 180 >> 2] = i2;
  } else i10 = 21; else i10 = 21;
  if ((i10 | 0) == 21) {
   i2 = _UNITY_FT_DivFix(7208960, i5) | 0;
   HEAP32[i11 + 180 >> 2] = i2;
  }
  i1 = i11 + 188 | 0;
  _cf2_computeDarkening(i5, i4, i2, i1, i9, HEAP8[i6 >> 0] | 0, i11 + 144 | 0);
  if (!(HEAP32[i11 + 184 >> 2] | 0)) if (!(HEAP32[i1 >> 2] | 0)) HEAP8[i11 + 141 >> 0] = 0; else i10 = 24; else i10 = 24;
  if ((i10 | 0) == 24) HEAP8[i11 + 141 >> 0] = 1;
  HEAP8[i11 + 192 >> 0] = 0;
  _cf2_blues_init(i11 + 196 | 0, i11);
 }
 if (HEAP32[i13 >> 2] | 0) {
  i16 = HEAP32[i16 >> 2] | 0;
  HEAP32[i14 >> 2] = i16;
  _cf2_setError(i13, 0);
  i16 = HEAP32[i13 >> 2] | 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i1 = i11 + 192 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = HEAP8[i11 + 141 >> 0] | 0;
 i3 = i11 + 100 | 0;
 _cf2_outline_reset(i3);
 _cf2_interpT2CharString(i11, i12, i3, i15, 0, 0, 0, i16);
 if (HEAP32[i13 >> 2] | 0) {
  i16 = HEAP32[i16 >> 2] | 0;
  HEAP32[i14 >> 2] = i16;
  _cf2_setError(i13, 0);
  i16 = HEAP32[i13 >> 2] | 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if (i2 << 24 >> 24) if ((HEAP32[i11 + 116 >> 2] | 0) <= -1) {
  HEAP8[i1 >> 0] = 1;
  _cf2_outline_reset(i3);
  _cf2_interpT2CharString(i11, i12, i3, i15, 0, 0, 0, i16);
  if (HEAP32[i13 >> 2] | 0) {
   i16 = HEAP32[i16 >> 2] | 0;
   HEAP32[i14 >> 2] = i16;
   _cf2_setError(i13, 0);
   i16 = HEAP32[i13 >> 2] | 0;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 _cf2_outline_close(i3);
 i16 = HEAP32[i16 >> 2] | 0;
 HEAP32[i14 >> 2] = i16;
 _cf2_setError(i13, 0);
 i16 = HEAP32[i13 >> 2] | 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN25ThreadsafeLinearAllocator8AllocateEji(i17, i16, i15) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 4 | 0;
 i12 = i18;
 i13 = i16 + 11 + i15 | 0;
 i9 = i17 + 48 | 0;
 L1 : do if (i13 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  i10 = i17 + 36 | 0;
  i6 = i17 + 32 | 0;
  i7 = i17 + 40 | 0;
  i8 = i17 + 52 | 0;
  while (1) {
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2];
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i3 = -1;
    i14 = 22;
    break L1;
   }
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = i3 + (i1 * 12 | 0) + 8 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = i3 + (i1 * 12 | 0) + 4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i13;
   i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) <= (HEAP32[i9 >> 2] | 0)) break;
   if ((HEAP16[gb + 1103860 + 6 >> 1] | 0) > -1) {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1103860 | 0, i11);
    i5 = gb + 1103860 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   } else {
    i5 = 0;
    i2 = i3;
   }
   i4 = i2 + (i1 * 12 | 0) + 8 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2];
   L10 : do if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) {
    i4 = HEAP32[i7 >> 2] | 0;
    L12 : do if ((i4 | 0) > 0) {
     i2 = 0;
     while (1) {
      if ((i2 | 0) != (HEAP32[i10 >> 2] | 0)) {
       i3 = HEAP32[i6 >> 2] | 0;
       i19 = i3 + (i2 * 12 | 0) + 8 | 0;
       HEAP32[i19 >> 2] = HEAP32[i19 >> 2];
       if (!(HEAP32[i19 >> 2] | 0)) break;
      }
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i4 | 0)) break L12;
     }
     HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] = 0;
     HEAP32[i10 >> 2] = i2;
     i1 = 0;
     break L10;
    } while (0);
    if ((i4 | 0) < (HEAP32[i8 >> 2] | 0)) {
     __Z16GetMemoryManagerv() | 0;
     i2 = __ZN13MemoryManager16LowLevelAllocateEj(HEAP32[i9 >> 2] | 0) | 0;
     if (i2 | 0) {
      i1 = HEAP32[i6 >> 2] | 0;
      HEAP32[i1 + (i4 * 12 | 0) >> 2] = i2;
      HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2] = 0;
      HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] = 0;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
      HEAP32[i10 >> 2] = i4;
      i1 = 0;
      break;
     }
    }
    if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
     HEAP32[i10 >> 2] = -1;
     i1 = 2;
    } else i1 = 0;
   } else i1 = 3; while (0);
   if (i5 | 0) __Z12profiler_endP19ProfilerInformation(i5);
   if ((i1 | 0) == 2) {
    i3 = -1;
    i14 = 22;
    break L1;
   }
  }
  i2 = (HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) + i2 + (0 - i13) | 0;
  if (!i2) {
   i3 = i1;
   i14 = 22;
  }
 } else {
  i3 = -1;
  i14 = 22;
 } while (0);
 if ((i14 | 0) == 22) {
  if ((HEAP16[gb + 1103872 + 6 >> 1] | 0) > -1) {
   HEAP32[i12 >> 2] = 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1103872 | 0, i11);
   i1 = gb + 1103872 | 0;
  } else i1 = 0;
  i2 = i17 + 44 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, gb + 64032 | 0, 0, gb + 365015 | 0, 177) | 0;
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  if (!i2) {
   i19 = 0;
   STACKTOP = i18;
   return i19 | 0;
  } else i1 = i3;
 }
 i19 = HEAP32[i17 + 60 >> 2] | 0;
 i14 = i15 + -1 + (i2 + 12) & 0 - i15;
 i4 = i14;
 HEAP32[i4 + -12 >> 2] = i16;
 i3 = i4 + -8 | 0;
 i13 = _bitshift64Shl(i19 | 0, 0, 60) | 0;
 i15 = getTempRet0() | 0;
 i14 = _bitshift64Shl(i14 - i2 | 0, 0, 9) | 0;
 getTempRet0() | 0;
 i16 = i3;
 HEAP32[i16 >> 2] = i13 | i14 & -512;
 HEAP32[i16 + 4 >> 2] = i15 | 218558477;
 i19 = i17 + 64 + (i19 << 2) | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 if ((i1 | 0) == -1) {
  i2 = i3;
  i1 = HEAP32[i2 >> 2] | 256;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } else {
  i2 = i3;
  i1 = HEAP32[i2 >> 2] & -256 | i1 & 255;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 i19 = i3;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i19 + 4 >> 2] = i2;
 i19 = i4;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZN23ReflectionProbesContext8CopyFromERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i8 + 12 | 0;
 i1 = (HEAP32[i9 + 12 >> 2] | 0) * 24 | 0;
 i2 = (i1 | 0) / 24 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  break;
 } else i1 = HEAP32[i8 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
 i2 = i8 + 20 | 0;
 i6 = HEAP32[i9 + 20 >> 2] | 0;
 i7 = i8 + 32 | 0;
 i1 = (HEAP32[i9 + 32 >> 2] | 0) * 40 | 0;
 i3 = (i1 | 0) / 40 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 i2 = i8 + 40 | 0;
 i6 = HEAP32[i9 + 40 >> 2] | 0;
 i7 = i8 + 52 | 0;
 i1 = (HEAP32[i9 + 52 >> 2] | 0) * 24 | 0;
 i3 = (i1 | 0) / 24 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 24 | 0) | 0;
 i2 = i8 + 60 | 0;
 i3 = HEAP32[i9 + 60 >> 2] | 0;
 i4 = i8 + 72 | 0;
 i1 = (HEAP32[i9 + 72 >> 2] | 0) * 44 | 0;
 i5 = (i1 | 0) / 44 | 0;
 HEAP32[i4 >> 2] = i5;
 i6 = i8 + 76 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 & 2147483647) >>> 0 >= i5 >>> 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i1 = i1 * 44 | 0;
  _memcpy(i2 | 0, i3 | 0, i1 | 0) | 0;
  i1 = i8 + 88 | 0;
  i2 = i9 + 88 | 0;
  i3 = i1 + 124 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  i1 = i1 * 44 | 0;
  _memcpy(i2 | 0, i3 | 0, i1 | 0) | 0;
  i1 = i8 + 88 | 0;
  i2 = i9 + 88 | 0;
  i3 = i1 + 124 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i2 >> 2] = i1;
  i2 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  i1 = i1 * 44 | 0;
  _memcpy(i2 | 0, i3 | 0, i1 | 0) | 0;
  i1 = i8 + 88 | 0;
  i2 = i9 + 88 | 0;
  i3 = i1 + 124 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  return;
 }
}

function __ZN15CollisionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 136 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 972 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 976 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 980 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 984 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 988 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 992 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 144 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 408 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 672 | 0, i6);
 i1 = i5 + 936 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 940 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 944 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 956 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 952 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 960 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 964 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 968 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 948 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 949 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function _decode_mcu_DC_first(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 20 | 0;
 i22 = i24;
 i23 = HEAP32[i14 + 408 >> 2] | 0;
 i17 = HEAP32[i14 + 376 >> 2] | 0;
 i4 = i14 + 252 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i23 + 40 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i19 = i23 + 16 | 0;
   i20 = HEAP32[i14 + 404 >> 2] | 0;
   i18 = i20 + 20 | 0;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) / 8 | 0);
   HEAP32[i19 >> 2] = 0;
   if (!((mftCall_ii(HEAP32[i20 + 8 >> 2] | 0, i14 | 0) | 0) << 24 >> 24)) {
    i23 = 0;
    STACKTOP = i24;
    return i23 | 0;
   }
   i3 = i14 + 292 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i23 + 24 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   HEAP32[i23 + 20 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   if (!(HEAP32[i14 + 380 >> 2] | 0)) HEAP8[i23 + 8 >> 0] = 0;
  }
 }
 if (!(HEAP8[i23 + 8 >> 0] | 0)) {
  HEAP32[i21 + 16 >> 2] = i14;
  i13 = i14 + 24 | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i21 >> 2] = i2;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i16 = i21 + 4 | 0;
  HEAP32[i16 >> 2] = i1;
  i18 = i23 + 12 | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i19 = i23 + 16 | 0;
  i5 = HEAP32[i19 >> 2] | 0;
  i20 = i23 + 20 | 0;
  HEAP32[i22 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
  HEAP32[i22 + 16 >> 2] = HEAP32[i20 + 16 >> 2];
  i12 = i14 + 320 | 0;
  do if ((HEAP32[i12 >> 2] | 0) > 0) {
   i10 = i21 + 8 | 0;
   i11 = i21 + 12 | 0;
   i7 = 0;
   while (1) {
    i8 = HEAP32[i15 + (i7 << 2) >> 2] | 0;
    i9 = HEAP32[i14 + 324 + (i7 << 2) >> 2] | 0;
    i3 = HEAP32[i23 + 44 + (HEAP32[(HEAP32[i14 + 296 + (i9 << 2) >> 2] | 0) + 20 >> 2] << 2) >> 2] | 0;
    if ((i5 | 0) < 8) {
     if (!((_jpeg_fill_bit_buffer(i21, i4, i5, 0) | 0) << 24 >> 24)) {
      i1 = 0;
      i6 = 27;
      break;
     }
     i4 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i11 >> 2] | 0;
     if ((i5 | 0) < 8) {
      i2 = 1;
      i6 = 16;
     } else i6 = 14;
    } else i6 = 14;
    if ((i6 | 0) == 14) {
     i6 = 0;
     i1 = HEAP32[i3 + 148 + ((i4 >> i5 + -8 & 255) << 2) >> 2] | 0;
     i2 = i1 >> 8;
     if ((i2 | 0) < 9) {
      i1 = i1 & 255;
      i5 = i5 - i2 | 0;
     } else i6 = 16;
    }
    if ((i6 | 0) == 16) {
     i1 = _jpeg_huff_decode(i21, i4, i5, i3, i2) | 0;
     if ((i1 | 0) < 0) {
      i1 = 0;
      i6 = 27;
      break;
     }
     i5 = HEAP32[i11 >> 2] | 0;
     i4 = HEAP32[i10 >> 2] | 0;
    }
    if (!i1) i1 = 0; else {
     if ((i5 | 0) < (i1 | 0)) {
      if (!((_jpeg_fill_bit_buffer(i21, i4, i5, i1) | 0) << 24 >> 24)) {
       i1 = 0;
       i6 = 27;
       break;
      }
      i5 = HEAP32[i11 >> 2] | 0;
      i4 = HEAP32[i10 >> 2] | 0;
     }
     i5 = i5 - i1 | 0;
     i6 = i4 >> i5 & (1 << i1) + -1;
     i1 = ((i6 | 0) < (1 << i1 + -1 | 0) ? (-1 << i1) + 1 | 0 : 0) + i6 | 0;
    }
    i6 = i22 + 4 + (i9 << 2) | 0;
    i9 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
    HEAP32[i6 >> 2] = i9;
    HEAP16[i8 >> 1] = i9 << i17;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) >= (HEAP32[i12 >> 2] | 0)) {
     i6 = 24;
     break;
    }
   }
   if ((i6 | 0) == 24) {
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i21 >> 2] | 0;
    i1 = HEAP32[i16 >> 2] | 0;
    break;
   } else if ((i6 | 0) == 27) {
    STACKTOP = i24;
    return i1 | 0;
   }
  } while (0);
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i18 >> 2] = i4;
  HEAP32[i19 >> 2] = i5;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
  HEAP32[i20 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 }
 i23 = i23 + 40 | 0;
 HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + -1;
 i23 = 1;
 STACKTOP = i24;
 return i23 | 0;
}

function __Z24CalculateSpotLightBoundsffRK10Matrix4x4fR15SpotLightBounds(f1, f2, i3, i4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 f2 = Math_fround(f1 / f2);
 i16 = i3 + 48 | 0;
 i12 = i3 + 52 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i7 = i3 + 56 | 0;
 i18 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i4 + 4 >> 2] = i17;
 HEAP32[i4 + 8 >> 2] = i18;
 f10 = Math_fround(-f2);
 f19 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f10);
 i18 = i3 + 16 | 0;
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f10));
 i17 = i3 + 32 | 0;
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f1));
 f19 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f19);
 i15 = i3 + 4 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f10);
 i14 = i3 + 20 | 0;
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f10));
 i13 = i3 + 36 | 0;
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f1));
 f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f5);
 i11 = i3 + 8 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f10);
 i9 = i3 + 24 | 0;
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f10));
 i8 = i3 + 40 | 0;
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f1));
 f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f6);
 HEAPF32[i4 + 12 >> 2] = f19;
 HEAPF32[i4 + 16 >> 2] = f5;
 HEAPF32[i4 + 20 >> 2] = f6;
 f6 = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f10));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f1));
 f6 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f6);
 f5 = Math_fround(f2 * Math_fround(HEAPF32[i15 >> 2]));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f10));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f1));
 f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f5);
 f19 = Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2]));
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f10));
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f1));
 f19 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f19);
 HEAPF32[i4 + 24 >> 2] = f6;
 HEAPF32[i4 + 28 >> 2] = f5;
 HEAPF32[i4 + 32 >> 2] = f19;
 f19 = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2])));
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f1));
 f19 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f19);
 f5 = Math_fround(f2 * Math_fround(HEAPF32[i15 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f2 * Math_fround(HEAPF32[i14 >> 2])));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f1));
 f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f5);
 f6 = Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f1));
 f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f6);
 HEAPF32[i4 + 36 >> 2] = f19;
 HEAPF32[i4 + 40 >> 2] = f5;
 HEAPF32[i4 + 44 >> 2] = f6;
 f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f10);
 f6 = Math_fround(f6 + Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2])));
 f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f1));
 f6 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * f10);
 f5 = Math_fround(f5 + Math_fround(f2 * Math_fround(HEAPF32[i14 >> 2])));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f1));
 f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f5);
 f10 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f10);
 f2 = Math_fround(f10 + Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2])));
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f1));
 f2 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f2);
 HEAPF32[i4 + 48 >> 2] = f6;
 HEAPF32[i4 + 52 >> 2] = f5;
 HEAPF32[i4 + 56 >> 2] = f2;
 return;
}

function __ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i1, i9, i10, i11) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + 4 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i2;
 do {
  if (i1 >>> 0 >= i10 >>> 0) {
   i13 = 4;
   break;
  }
  i4 = (HEAP8[i1 >> 0] | 0) == 0;
  i1 = i1 + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 } while (!i4);
 if ((i13 | 0) == 4) HEAP32[i9 >> 2] = i1 + 1;
 if (!i2) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = i8 + 20 | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i8 >> 2] | 0) + (i5 * 24 | 0) + 4 | 0, i4, i2);
 i3 = i6 + (i5 * 24 | 0) + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) <= -1) {
  i2 = HEAP32[gb + 36932 >> 2] | 0;
  i1 = i2 + (i1 & 2147483647) | 0;
  if ((i1 | 0) == (HEAP32[gb + 37244 >> 2] | 0)) {
   HEAP32[i3 >> 2] = (HEAP32[gb + 37040 >> 2] | 0) - i2 | -2147483648;
   break;
  }
  if ((i1 | 0) == (HEAP32[gb + 37292 >> 2] | 0)) HEAP32[i3 >> 2] = (HEAP32[gb + 37304 >> 2] | 0) - i2 | -2147483648;
 } while (0);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i2;
 do {
  if (i1 >>> 0 >= i10 >>> 0) {
   i13 = 14;
   break;
  }
  i3 = (HEAP8[i1 >> 0] | 0) == 0;
  i1 = i1 + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 } while (!i3);
 if ((i13 | 0) == 14) HEAP32[i9 >> 2] = i1 + 1;
 if (!i2) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i8 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 8 | 0, i4, i2);
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 + (i5 * 24 | 0) + 12 >> 2] = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 switch (i11 | 0) {
 case 2:
  {
   i1 = i2 + 8 | 0;
   HEAP32[i9 >> 2] = i1;
   i13 = 18;
   break;
  }
 case 3:
  {
   i2 = i1;
   i3 = 0;
   break;
  }
 default:
  i13 = 18;
 }
 if ((i13 | 0) == 18) {
  HEAP32[i6 + (i5 * 24 | 0) + 16 >> 2] = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
  i2 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = 1;
 }
 i1 = (HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24) >>> 24;
 i4 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP8[i6 + (i5 * 24 | 0) + 3 >> 0] = i1;
 i4 = _llvm_bswap_i32(HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24 | 0) | 0;
 i1 = i2 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP16[i6 + (i5 * 24 | 0) >> 1] = i4;
 if (i3) {
  HEAP32[i6 + (i5 * 24 | 0) + 20 >> 2] = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
  i1 = i2 + 12 | 0;
  HEAP32[i9 >> 2] = i1;
 }
 i4 = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
 HEAP32[i9 >> 2] = i1 + 4;
 i2 = HEAP32[gb + 1166048 >> 2] | 0;
 i1 = i2 + 1 | 0;
 HEAP32[gb + 1166048 >> 2] = i1;
 if (i4 >>> 0 > 5e3 | (i2 | 0) > 49) {
  HEAP32[gb + 1166048 >> 2] = i2;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468112 | 0, 0, gb + 468163 | 0, 540, 1, 0, 0, 0);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 do if ((i4 | 0) > 0) {
  i2 = i8 + 12 | 0;
  i3 = i12 + 4 | 0;
  i1 = 0;
  while (1) {
   __ZN8TypeTree8AddChildEj(i8, HEAP32[i7 >> 2] | 0);
   i6 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i12 >> 2] = i8;
   HEAP32[i3 >> 2] = i6;
   i1 = i1 + 1 | 0;
   if (!(__ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i12, i9, i10, i11) | 0)) break;
   if ((i1 | 0) >= (i4 | 0)) {
    i13 = 28;
    break;
   }
  }
  if ((i13 | 0) == 28) {
   i1 = HEAP32[gb + 1166048 >> 2] | 0;
   break;
  }
  HEAP32[gb + 1166048 >> 2] = (HEAP32[gb + 1166048 >> 2] | 0) + -1;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[gb + 1166048 >> 2] = i1 + -1;
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function _decode_mcu_AC_first(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21;
 i20 = HEAP32[i6 + 408 >> 2] | 0;
 i12 = HEAP32[i6 + 368 >> 2] | 0;
 i13 = HEAP32[i6 + 376 >> 2] | 0;
 i4 = i6 + 252 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i20 + 40 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i17 = i20 + 16 | 0;
   i18 = HEAP32[i6 + 404 >> 2] | 0;
   i16 = i18 + 20 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) / 8 | 0);
   HEAP32[i17 >> 2] = 0;
   if (!((mftCall_ii(HEAP32[i18 + 8 >> 2] | 0, i6 | 0) | 0) << 24 >> 24)) {
    i20 = 0;
    STACKTOP = i21;
    return i20 | 0;
   }
   i3 = i6 + 292 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i20 + 24 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   HEAP32[i20 + 20 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   if (!(HEAP32[i6 + 380 >> 2] | 0)) HEAP8[i20 + 8 >> 0] = 0;
  }
 }
 if (!(HEAP8[i20 + 8 >> 0] | 0)) {
  i18 = i20 + 20 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  if (!i1) {
   HEAP32[i19 + 16 >> 2] = i6;
   i14 = i6 + 24 | 0;
   i16 = HEAP32[i14 >> 2] | 0;
   HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
   i15 = i19 + 4 | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 + 4 >> 2];
   i16 = i20 + 12 | 0;
   i2 = HEAP32[i16 >> 2] | 0;
   i17 = i20 + 16 | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   i8 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i20 + 60 >> 2] | 0;
   i1 = HEAP32[i6 + 364 >> 2] | 0;
   L17 : do if ((i1 | 0) > (i12 | 0)) i1 = 0; else {
    i11 = i19 + 8 | 0;
    i10 = i19 + 12 | 0;
    i7 = i1;
    while (1) {
     if ((i3 | 0) < 8) {
      if (!((_jpeg_fill_bit_buffer(i19, i2, i3, 0) | 0) << 24 >> 24)) {
       i1 = 0;
       i6 = 37;
       break;
      }
      i2 = HEAP32[i11 >> 2] | 0;
      i3 = HEAP32[i10 >> 2] | 0;
      if ((i3 | 0) < 8) {
       i4 = 1;
       i6 = 18;
      } else i6 = 16;
     } else i6 = 16;
     if ((i6 | 0) == 16) {
      i6 = 0;
      i1 = HEAP32[i9 + 148 + ((i2 >> i3 + -8 & 255) << 2) >> 2] | 0;
      i4 = i1 >> 8;
      if ((i4 | 0) < 9) {
       i1 = i1 & 255;
       i3 = i3 - i4 | 0;
      } else i6 = 18;
     }
     if ((i6 | 0) == 18) {
      i1 = _jpeg_huff_decode(i19, i2, i3, i9, i4) | 0;
      if ((i1 | 0) < 0) {
       i1 = 0;
       i6 = 37;
       break;
      }
      i3 = HEAP32[i10 >> 2] | 0;
      i2 = HEAP32[i11 >> 2] | 0;
     }
     i5 = i1 >> 4;
     i4 = i1 & 15;
     if (!i4) {
      if ((i5 | 0) != 15) {
       i6 = 27;
       break;
      }
      i1 = i7 + 15 | 0;
     } else {
      i1 = i5 + i7 | 0;
      if ((i3 | 0) < (i4 | 0)) {
       if (!((_jpeg_fill_bit_buffer(i19, i2, i3, i4) | 0) << 24 >> 24)) {
        i1 = 0;
        i6 = 37;
        break;
       }
       i3 = HEAP32[i10 >> 2] | 0;
       i2 = HEAP32[i11 >> 2] | 0;
      }
      i3 = i3 - i4 | 0;
      i7 = i2 >> i3 & (1 << i4) + -1;
      HEAP16[i8 + (HEAP32[gb + 15416 + (i1 << 2) >> 2] << 1) >> 1] = ((i7 | 0) < (1 << i4 + -1 | 0) ? (-1 << i4) + 1 | 0 : 0) + i7 << i13;
     }
     if ((i1 | 0) < (i12 | 0)) i7 = i1 + 1 | 0; else {
      i1 = 0;
      break L17;
     }
    }
    if ((i6 | 0) == 27) {
     i1 = 1 << i5;
     if (i5) {
      do if ((i3 | 0) < (i5 | 0)) if (!((_jpeg_fill_bit_buffer(i19, i2, i3, i5) | 0) << 24 >> 24)) {
       i20 = 0;
       STACKTOP = i21;
       return i20 | 0;
      } else {
       i3 = HEAP32[i10 >> 2] | 0;
       i2 = HEAP32[i11 >> 2] | 0;
       break;
      } while (0);
      i3 = i3 - i5 | 0;
      i1 = (i2 >> i3 & i1 + -1) + i1 | 0;
     }
     i1 = i1 + -1 | 0;
     break;
    } else if ((i6 | 0) == 37) {
     STACKTOP = i21;
     return i1 | 0;
    }
   } while (0);
   i14 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i16 >> 2] = i2;
   HEAP32[i17 >> 2] = i3;
  } else i1 = i1 + -1 | 0;
  HEAP32[i18 >> 2] = i1;
 }
 i20 = i20 + 40 | 0;
 HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
 i20 = 1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i6 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i4 - i6 | 0;
 i10 = (i5 | 0) / 52 | 0;
 i12 = i13 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i2 = i6;
 i9 = i8;
 i14 = i4;
 if (i10 >>> 0 <= ((i1 - i8 | 0) / 52 | 0) >>> 0) {
  i5 = i13 + 4 | 0;
  i1 = ((HEAP32[i5 >> 2] | 0) - i8 | 0) / 52 | 0;
  i3 = i10 >>> 0 > i1 >>> 0;
  i1 = i3 ? i2 + (i1 * 52 | 0) | 0 : i4;
  i2 = i1 - i6 | 0;
  if (i2 | 0) _memmove(i8 | 0, i6 | 0, i2 | 0) | 0;
  i2 = i9 + (((i2 | 0) / 52 | 0) * 52 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i5 >> 2] = i1 + (~(((i1 + -52 - i2 | 0) >>> 0) / 52 | 0) * 52 | 0);
   STACKTOP = i15;
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i15;
   return;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i12 = i1;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i14 = i2;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i14 = i2 + 32 | 0;
   i13 = i1 + 32 | 0;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
   i1 = i1 + 52 | 0;
   i2 = (HEAP32[i5 >> 2] | 0) + 52 | 0;
   HEAP32[i5 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i15;
  return;
 }
 i4 = i8;
 if (i8) {
  i1 = i13 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -52 - i8 | 0) >>> 0) / 52 | 0) * 52 | 0);
  i9 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 16;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  i1 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
 } else i3 = 0;
 i9 = (i1 - i3 | 0) / 52 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i10 >>> 0 ? i10 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
 i1 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 16;
 HEAP32[i11 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 52 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i12 >> 2] = i1 + (i3 * 52 | 0);
 if ((i2 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 do {
  i11 = i2;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i1;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  i13 = i1 + 32 | 0;
  i12 = i2 + 32 | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  i2 = i2 + 52 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 52 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb(i22, i1, f4, f5, f7, f25, f24, i23) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f7 = Math_fround(f7);
 f25 = Math_fround(f25);
 f24 = Math_fround(f24);
 i23 = i23 | 0;
 var f2 = f0, i3 = 0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i26 = 0;
 f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (!(f21 >= Math_fround(0.0))) {
  f14 = Math_fround(HEAPF32[i1 >> 2]);
  f11 = Math_fround(-f14);
  f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f12 = Math_fround(-f15);
  f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f13 = Math_fround(-f17);
  f16 = Math_fround(-f21);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i18 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i19 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i20 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i26 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  f16 = f21;
  i18 = i26;
  i19 = i3;
  i20 = i6;
  i1 = i26;
 }
 f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(f14 * f4);
 f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(Math_fround(f12 * f5) + f2);
 f10 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = Math_fround(Math_fround(f10 * f7) + f2);
 if (Math_fround(Math_abs(Math_fround(f2))) > Math_fround(9.99999997e-07)) {
  f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f2 * f2))));
  f17 = Math_fround(f13 * f4);
  f15 = Math_fround(f13 * f5);
  f13 = Math_fround(f13 * f7);
  f11 = f2;
 } else {
  f17 = Math_fround(0.0);
  f15 = Math_fround(0.0);
  f13 = Math_fround(0.0);
  f11 = Math_fround(1.0);
 }
 f4 = Math_fround(-f17);
 f8 = Math_fround(-f15);
 f9 = Math_fround(-f13);
 f2 = Math_fround(Math_fround(Math_fround(f12 * f9) + Math_fround(Math_fround(f14 * f11) + Math_fround(f16 * f4))) - Math_fround(f10 * f8));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f16 * f8)) + Math_fround(f10 * f4)) - Math_fround(f14 * f9));
 f7 = Math_fround(Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(f10 * f11) + Math_fround(f16 * f9))) - Math_fround(f12 * f4));
 HEAP8[i23 >> 0] = 0;
 if (!(f25 > Math_fround(.999899983))) {
  if (!(Math_fround(Math_fround(Math_fround(Math_fround(f16 * f11) - Math_fround(f14 * f4)) - Math_fround(f12 * f8)) - Math_fround(f10 * f9)) >= Math_fround(0.0))) {
   f7 = Math_fround(-f7);
   f5 = Math_fround(-f5);
   f2 = Math_fround(-f2);
  }
  f4 = Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f5 * f5) + Math_fround(f2 * f2)));
  i26 = f4 > Math_fround(f25 * f25);
  HEAP8[i23 >> 0] = i26 & 1;
  if (i26) {
   f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
   f12 = Math_fround(Math_fround(f2 * f25) * f14);
   f10 = Math_fround(Math_fround(f5 * f25) * f14);
   f14 = Math_fround(Math_fround(f7 * f25) * f14);
   f16 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f15 * f24) + Math_fround(f11 * f10))) - Math_fround(f13 * f12));
   f21 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f24) + Math_fround(f11 * f14)) + Math_fround(f15 * f12)) - Math_fround(f17 * f10));
   f25 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f24) - Math_fround(f17 * f12)) - Math_fround(f15 * f10)) - Math_fround(f13 * f14));
   HEAPF32[i22 >> 2] = Math_fround(Math_fround(Math_fround(f13 * f10) + Math_fround(Math_fround(f17 * f24) + Math_fround(f11 * f12))) - Math_fround(f15 * f14));
   HEAPF32[i22 + 4 >> 2] = f16;
   HEAPF32[i22 + 8 >> 2] = f21;
   HEAPF32[i22 + 12 >> 2] = f25;
   return;
  }
 }
 HEAP32[i22 >> 2] = i18;
 HEAP32[i22 + 4 >> 2] = i19;
 HEAP32[i22 + 8 >> 2] = i20;
 HEAPF32[i22 + 12 >> 2] = f21;
 return;
}

function __ZN14NavMeshManager9PurgeDataEPK11NavMeshData(i13, i15) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 24 | 0;
 i19 = i20;
 i18 = i20 + 32 | 0;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i12 = i19;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i12 + 4 >> 2] = i16;
 HEAP32[i18 >> 2] = 0;
 i12 = i18 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i19);
 i2 = i14;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = i17;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 i11 = i13 + 128 | 0;
 i1 = HEAP32[i13 + 124 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i11 | 0)) {
  i3 = 0;
  i10 = 0;
  i9 = 0;
  while (1) {
   if ((HEAP32[i2 + 20 >> 2] | 0) == (i15 | 0)) {
    i6 = i2 + 16 | 0;
    i7 = HEAP32[i12 >> 2] | 0;
    i8 = i7 + 1 | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i8 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i16 >> 2] = i2;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i9, i2 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i18 >> 2] = i2;
      i3 = i2;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
      HEAP32[i16 >> 2] = i2;
      HEAP32[i18 >> 2] = i10;
      i3 = i10;
      i2 = i10;
      break;
     } else i2 = i10;
    } else i2 = i10; while (0);
    HEAP32[i12 >> 2] = i8;
    HEAP32[i2 + (i7 << 2) >> 2] = HEAP32[i6 >> 2];
    i10 = i2;
    i9 = i2;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i11 | 0)) break; else i1 = i2;
  }
  if (HEAP32[i12 >> 2] | 0) {
   __ZN14NavMeshManager10UnloadDataEi(i13, HEAP32[i3 >> 2] | 0);
   if ((HEAP32[i12 >> 2] | 0) >>> 0 > 1) {
    i1 = 1;
    do {
     __ZN14NavMeshManager10UnloadDataEi(i13, HEAP32[(HEAP32[i18 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
   }
  }
 }
 HEAP32[i19 >> 2] = 0;
 i10 = i19 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i19 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i1 = HEAP32[i14 + 4 >> 2] | 0;
 i9 = i12;
 HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i13 + 136 | 0;
 __ZNK24NavMeshSceneDataRegistry9GetScenesER13dynamic_arrayIiLj4EEPK11NavMeshData(HEAP32[i9 >> 2] | 0, i19, i15);
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i8 = 0;
  do {
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i7 = i5 + 12 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2) {
    i1 = 0;
    do {
     i3 = HEAP32[i5 >> 2] | 0;
     i4 = i3 + (i1 << 3) | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) {
      i2 = i2 + -1 | 0;
      i13 = i3 + (i2 << 3) | 0;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i15 = i4;
      HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i15 + 4 >> 2] = i14;
      HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
      i1 = i1 + -1 | 0;
     }
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i12);
  HEAP32[i19 >> 2] = 0;
 }
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(i7, i11, i12) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 if ((i11 | 0) == (i12 | 0)) {
  i12 = 1;
  return i12 | 0;
 }
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 i8 = i11 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) i5 = 0; else {
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = i2;
  do {
   HEAP32[i1 + 16 >> 2] = i4;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i5;
  HEAP32[i5 >> 2] = i10;
  i5 = HEAP32[i7 + 136 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i3;
  i5 = 1;
 }
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i10 = i11 + 20 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i6 = 0; else {
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = i4;
  do {
   HEAP32[i1 + 20 >> 2] = i3;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = i6;
  HEAP32[i6 >> 2] = i4;
  i6 = HEAP32[i7 + 140 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i2;
  i6 = 1;
 }
 i2 = i12 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i11 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i11;
 HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i4 >> 2] = i3;
 if (!i5) {
  i5 = HEAP32[i7 + 136 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i9 = 14; else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i9 = 14; else HEAP32[i5 >> 2] = i1;
  }
  if ((i9 | 0) == 14) {
   i1 = i5 + 8 | 0;
   i2 = i5 + 12 | 0;
   i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i4 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, i4 | 0) | 0;
   if (!i4) {
    i12 = 0;
    return i12 | 0;
   }
   i3 = i5 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   do {
    i1 = i1 - i3 | 0;
    i13 = i2;
    i2 = i4 + i1 | 0;
    HEAP32[i2 >> 2] = i13;
   } while ((i1 | 0) != 4);
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   if (!i2) {
    i13 = 0;
    return i13 | 0;
   }
  }
  i13 = HEAP32[i8 >> 2] | 0;
  i1 = i13 + 4 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i2 >> 2] = i13;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i2 + 8 >> 2] = i12;
  i1 = i12;
  do {
   HEAP32[i1 + 16 >> 2] = i2;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } while ((i1 | 0) != (i12 | 0));
  HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] = i11;
 }
 if (i6 | 0) {
  i13 = 1;
  return i13 | 0;
 }
 i5 = HEAP32[i7 + 140 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i9 = 25; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i9 = 25; else HEAP32[i5 >> 2] = i1;
 }
 if ((i9 | 0) == 25) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i13 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i13 = 0;
   return i13 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i1 = i1 - i3 | 0;
   i13 = i2;
   i2 = i4 + i1 | 0;
   HEAP32[i2 >> 2] = i13;
  } while ((i1 | 0) != 4);
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  if (!i2) {
   i13 = 0;
   return i13 | 0;
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i13 = i1 + 4 | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i2 + 8 >> 2] = i12;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP8[i2 + 21 >> 0] = HEAP8[i1 + 21 >> 0] | 0;
 i1 = i12;
 do {
  HEAP32[i1 + 20 >> 2] = i2;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != (i12 | 0));
 HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] = i11;
 i13 = 1;
 return i13 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_15PxParticleFluidEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i11 + 580 | 0;
 i20 = i11 + 528 | 0;
 i13 = i11 + 632 | 0;
 i22 = i11 + 16 | 0;
 i15 = i11 + 476 | 0;
 i23 = i11;
 i6 = i11 + 472 | 0;
 i10 = i11 + 48 | 0;
 i9 = i11 + 32 | 0;
 i14 = i11 + 64 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx28PxParticleFluidGeneratedInfoC2Ev(i14);
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i21 >> 2] = i19;
 HEAP32[i21 + 4 >> 2] = i18;
 i3 = i21 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i21 + 20 >> 2] = i17;
 HEAP32[i21 + 24 >> 2] = i16;
 HEAP32[i21 + 28 >> 2] = i1;
 HEAP32[i21 + 32 >> 2] = i4;
 HEAP8[i21 + 36 >> 0] = 1;
 HEAP32[i21 + 40 >> 2] = i5;
 HEAP32[i21 + 44 >> 2] = 0;
 HEAP32[i21 + 48 >> 2] = 0;
 i3 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i14, i21, 0) | 0;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i21 = i20 + 8 | 0;
 HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i14, i20, i3) | 0;
 HEAP32[i15 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i18;
 i3 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj187ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 348 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj188ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 364 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj189ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 380 | 0, 2);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i23 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
  }
 }
 i23 = HEAP32[i7 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i23 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN17ProceduralTexture18UploadBakedTextureEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 8 | 0;
 i1 = i19;
 i17 = i19 + 4 | 0;
 i12 = i16 + 160 | 0;
 if (!(HEAP32[i12 >> 2] & 2)) i10 = i16 + 48 | 0; else {
  i18 = __Z12GetGfxDevicev() | 0;
  i14 = HEAP32[(HEAP32[i18 >> 2] | 0) + 452 >> 2] | 0;
  i10 = i16 + 48 | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  mftCall_vii(i14 | 0, i18 | 0, i15 | 0);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -3;
  HEAP32[i16 + 208 >> 2] = 0;
 }
 i13 = i16 + 128 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 f21 = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
 i3 = HEAP32[i16 + 132 >> 2] | 0;
 f20 = Math_fround(Math_fround(1.0) / Math_fround(i3 | 0));
 HEAPF32[i16 + 68 >> 2] = f21;
 HEAPF32[i16 + 72 >> 2] = f20;
 i1 = HEAP32[i10 >> 2] | 0;
 i14 = i16 + 104 | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i18 = i16 + 108 | 0;
 i5 = (HEAP32[i18 >> 2] | 0) - i4 | 0;
 i11 = i16 + 136 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i16 + 140 >> 2] | 0;
 i8 = HEAP32[i16 + 56 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i9 = HEAP32[i16 + 60 >> 2] | 0; else i9 = 0;
 i23 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
 i22 = __Z21GetUncheckedGfxDevicev() | 0;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i15 + 4 >> 2] = i4;
 HEAP32[i15 + 8 >> 2] = i5;
 HEAP32[i15 + 12 >> 2] = i2;
 HEAP32[i15 + 16 >> 2] = i3;
 HEAP32[i15 + 20 >> 2] = i6;
 HEAP32[i15 + 24 >> 2] = i7;
 HEAP32[i15 + 28 >> 2] = 0;
 HEAP32[i15 + 32 >> 2] = i8;
 HEAP32[i15 + 36 >> 2] = i9;
 HEAP32[i15 + 40 >> 2] = i23;
 HEAP32[i15 + 44 >> 2] = i22;
 __Z19UploadTexture2DDataRK23UploadTextureDataParams(i15) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i16;
 i8 = HEAP32[gb + 1158372 >> 2] | 0;
 i3 = i8 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do if (!i2) {
  HEAP32[i15 >> 2] = i3;
  i6 = i3;
 } else {
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if (i1 >>> 0 < i3 >>> 0) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i5 = 9;
     break;
    } else i2 = i3;
   } else {
    if (i3 >>> 0 >= i1 >>> 0) {
     i5 = 14;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i5 = 13;
     break;
    } else i2 = i3;
   }
  }
  if ((i5 | 0) == 9) {
   HEAP32[i15 >> 2] = i2;
   i6 = i2;
   i3 = i2;
   break;
  } else if ((i5 | 0) == 13) {
   HEAP32[i15 >> 2] = i2;
   i6 = i2;
   i3 = i4;
   break;
  } else if ((i5 | 0) == 14) {
   HEAP32[i15 >> 2] = i2;
   i6 = i2;
   i3 = i15;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = __Znwj(24) | 0;
  i23 = i2 + 16 | 0;
  HEAP32[i23 >> 2] = i1;
  HEAP32[i23 + 4 >> 2] = i7;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = i6;
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (!i1) i1 = i2; else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
  i1 = i8 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 2;
 HEAP32[i16 + 208 >> 2] = 3;
 HEAP32[i17 >> 2] = i1;
 i3 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 148 >> 2] | 0, i16 | 0) | 0;
 i1 = (HEAP32[i11 >> 2] | 0) != 1;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i2 = HEAP32[i16 + 60 >> 2] | 0; else i2 = 0;
 i23 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 120 >> 2] | 0, i16 | 0) | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i16 + 32 | 0, i15, i3, i1, i2, i23, 0);
 i1 = i16 + 88 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i18 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i18 >> 2] = i1;
 STACKTOP = i19;
 return;
}

function __ZNSt3__218__insertion_sort_3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_(i9, i10, i12) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0;
 i2 = i9 + 24 | 0;
 __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_(i9, i9 + 12 | 0, i2, i12) | 0;
 i1 = i9 + 36 | 0;
 if ((i1 | 0) == (i10 | 0)) return;
 f13 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i14 = i12 + 24 | 0;
 i15 = i12 + 4 | 0;
 i11 = i12 + 8 | 0;
 i8 = i1;
 while (1) {
  i7 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  do if ((i7 | 0) == (i1 | 0)) {
   f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f17 = Math_fround(f3 - f4);
   if (Math_fround(f17 * f17) > f13) if (f3 > f4) {
    i16 = 10;
    break;
   } else break; else {
    i6 = HEAP32[i8 >> 2] | 0;
    i5 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
    f21 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) >> 2]);
    f20 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) + 4 >> 2]);
    f19 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) + 8 >> 2]);
    i6 = HEAP32[i2 >> 2] | 0;
    f24 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) >> 2]);
    f23 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) + 4 >> 2]);
    f22 = Math_fround(HEAPF32[i5 + (i6 * 24 | 0) + 8 >> 2]);
    f18 = Math_fround(HEAPF32[i12 >> 2]);
    f21 = Math_fround(f21 - f18);
    f4 = Math_fround(HEAPF32[i15 >> 2]);
    f20 = Math_fround(f20 - f4);
    f17 = Math_fround(HEAPF32[i11 >> 2]);
    f19 = Math_fround(f19 - f17);
    f18 = Math_fround(f24 - f18);
    f4 = Math_fround(f23 - f4);
    f17 = Math_fround(f22 - f17);
    if (Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)) + Math_fround(f19 * f19)) < Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f4 * f4)) + Math_fround(f17 * f17))) {
     i16 = 10;
     break;
    } else break;
   }
  } else if ((i7 | 0) > (i1 | 0)) {
   f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   i16 = 10;
  } while (0);
  if ((i16 | 0) == 10) {
   i16 = 0;
   i6 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   L15 : do if ((i2 | 0) == (i9 | 0)) i1 = i9; else while (1) {
    i1 = i2;
    i2 = i2 + -12 | 0;
    i5 = HEAP32[i1 + -4 >> 2] | 0;
    do if ((i7 | 0) == (i5 | 0)) {
     f4 = Math_fround(HEAPF32[i1 + -8 >> 2]);
     f24 = Math_fround(f3 - f4);
     if (Math_fround(f24 * f24) > f13) if (f3 > f4) break; else break L15; else {
      i25 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
      f19 = Math_fround(HEAPF32[i25 + (i6 * 24 | 0) >> 2]);
      f20 = Math_fround(HEAPF32[i25 + (i6 * 24 | 0) + 4 >> 2]);
      f21 = Math_fround(HEAPF32[i25 + (i6 * 24 | 0) + 8 >> 2]);
      i5 = HEAP32[i2 >> 2] | 0;
      f4 = Math_fround(HEAPF32[i25 + (i5 * 24 | 0) >> 2]);
      f17 = Math_fround(HEAPF32[i25 + (i5 * 24 | 0) + 4 >> 2]);
      f18 = Math_fround(HEAPF32[i25 + (i5 * 24 | 0) + 8 >> 2]);
      f22 = Math_fround(HEAPF32[i12 >> 2]);
      f19 = Math_fround(f19 - f22);
      f23 = Math_fround(HEAPF32[i15 >> 2]);
      f20 = Math_fround(f20 - f23);
      f24 = Math_fround(HEAPF32[i11 >> 2]);
      f21 = Math_fround(f21 - f24);
      f22 = Math_fround(f4 - f22);
      f23 = Math_fround(f17 - f23);
      f24 = Math_fround(f18 - f24);
      if (Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21)) < Math_fround(Math_fround(Math_fround(f22 * f22) + Math_fround(f23 * f23)) + Math_fround(f24 * f24))) break; else break L15;
     }
    } else if ((i7 | 0) <= (i5 | 0)) break L15; while (0);
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    if ((i2 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
   } while (0);
   HEAP32[i1 >> 2] = i6;
   HEAPF32[i1 + 4 >> 2] = f3;
   HEAP32[i1 + 8 >> 2] = i7;
  }
  i1 = i8 + 12 | 0;
  if ((i1 | 0) == (i10 | 0)) break; else {
   i2 = i8;
   i8 = i1;
  }
 }
 return;
}

function __ZN5physx9transformERKNS_2Cm8Matrix34ERKNS_2Gu3BoxE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f11 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f8 = Math_fround(f11 * Math_fround(HEAPF32[i2 >> 2]));
 f10 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f8 * f20);
 i19 = i3 + 4 | 0;
 f25 = Math_fround(HEAPF32[i19 >> 2]);
 f26 = Math_fround(f8 * f25);
 i18 = i3 + 8 | 0;
 f23 = Math_fround(HEAPF32[i18 >> 2]);
 f8 = Math_fround(f8 * f23);
 i17 = i3 + 12 | 0;
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f21 = Math_fround(f10 * f12);
 i16 = i3 + 16 | 0;
 f24 = Math_fround(HEAPF32[i16 >> 2]);
 f28 = Math_fround(f10 * f24);
 i15 = i3 + 20 | 0;
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f21 = Math_fround(f7 + f21);
 f28 = Math_fround(f26 + f28);
 f10 = Math_fround(f8 + Math_fround(f10 * f22));
 i14 = i3 + 24 | 0;
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 f26 = Math_fround(f11 * f8);
 i13 = i3 + 28 | 0;
 f7 = Math_fround(HEAPF32[i13 >> 2]);
 f27 = Math_fround(f11 * f7);
 i9 = i3 + 32 | 0;
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f27 = Math_fround(f28 + f27);
 f11 = Math_fround(f10 + Math_fround(f11 * f6));
 HEAPF32[i1 >> 2] = Math_fround(f21 + f26);
 HEAPF32[i1 + 4 >> 2] = f27;
 HEAPF32[i1 + 8 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f27 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f26 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 20 >> 2]));
 f21 = Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(f26 * f24)) + Math_fround(f11 * f7));
 f10 = Math_fround(Math_fround(Math_fround(f27 * f23) + Math_fround(f26 * f22)) + Math_fround(f11 * f6));
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(Math_fround(f27 * f20) + Math_fround(f26 * f12)) + Math_fround(f11 * f8));
 HEAPF32[i1 + 16 >> 2] = f21;
 HEAPF32[i1 + 20 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f21 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 28 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 32 >> 2]));
 f7 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(f11 * f24)) + Math_fround(f10 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f21 * f23) + Math_fround(f11 * f22)) + Math_fround(f10 * f6));
 HEAPF32[i1 + 24 >> 2] = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f11 * f12)) + Math_fround(f10 * f8));
 HEAPF32[i1 + 28 >> 2] = f7;
 HEAPF32[i1 + 32 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f7 = Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2]));
 f8 = Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2]));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 f10 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f10 * Math_fround(HEAPF32[i16 >> 2]));
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f8 + f11);
 f10 = Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i15 >> 2])));
 f6 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f8 = Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2]));
 f7 = Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2]));
 f8 = Math_fround(f12 + f8);
 f7 = Math_fround(f11 + f7);
 f6 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i3 + 36 >> 2]));
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 + 40 >> 2]));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 44 >> 2]));
 HEAPF32[i1 + 36 >> 2] = f8;
 HEAPF32[i1 + 40 >> 2] = f7;
 HEAPF32[i1 + 44 >> 2] = f6;
 __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E(i5, i1);
 HEAP32[i1 + 48 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN3WWW18FeedUnityWebStreamEb(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 24 | 0;
 i7 = i10;
 i1 = i10 + 16 | 0;
 i4 = i10 + 8 | 0;
 i5 = i10 + 1092 | 0;
 i6 = i8 + 8 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
  i12 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0) | 0;
  i13 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
  i3 = __ZnwjRK10MemLabelIdiPKci(40, gb + 64016 | 0, 16, gb + 586309 | 0, 281) | 0;
  i15 = gb + 64016 | 0;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i11 + 4 >> 2] = i14;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb(i3, i2, i12, i13, 0);
  i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 64016 | 0, 16, gb + 586309 | 0, 282) | 0;
  i13 = gb + 64016 | 0;
  i12 = HEAP32[i13 + 4 >> 2] | 0;
  i11 = i4;
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission(i1, i2, i3, 0);
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64016 | 0);
  }
  i12 = gb + 64016 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i15 = i7;
  HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i15 + 4 >> 2] = i13;
  i15 = i2 + 1040 | 0;
  HEAP8[i2 >> 0] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  HEAP32[i15 + 16 >> 2] = 0;
  i15 = __ZnwjRK10MemLabelIdiPKci(20, i7, 16, gb + 586372 | 0, 37) | 0;
  i13 = i7;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  HEAP32[i15 >> 2] = gb + 70720 + 8;
  HEAP32[i15 + 4 >> 2] = i1;
  i14 = i15 + 8 | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP8[i15 + 16 >> 0] = 1;
  HEAP32[i2 + 1044 >> 2] = i15;
  __ZN15FileSystemEntryC2ERK13FileEntryData(i5, i2);
  __ZN13FileEntryDataD2Ev(i2);
  __ZN12FileAccessorC2Ev(i2);
  __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i2, i5, 0, 0) | 0;
  __ZN12FileAccessor4SeekEx10FileOrigin(i2, 0, 0, 1) | 0;
  i15 = __ZN20ArchiveStorageHeader13IsArchiveFileER12FileAccessor(i2) | 0;
  __ZN12FileAccessorD2Ev(i2);
  __ZN13FileEntryDataD2Ev(i5);
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0);
  if (i15) {
   i15 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0) | 0;
   i15 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, gb + 63552 | 0, 16, gb + 586446 | 0, i15, gb + 586309 | 0, 296) | 0;
   i12 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0) | 0;
   i11 = i8 + 40 | 0;
   i13 = HEAP32[i8 + 56 >> 2] | 0;
   i14 = (HEAP8[i8 + 33 >> 0] | 0) != 0;
   HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   __ZN14UnityWebStreamC2EPKc7Hash128jb(i15, i12, i2, i13, i14);
   __Z19pop_allocation_rootv();
   HEAP32[i8 + 4 >> 2] = i15;
   __ZN14UnityWebStream6RetainEv(i15);
  }
  HEAP8[i6 >> 0] = 1;
 }
 i1 = i8 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0) | 0;
 i15 = i8 + 12 | 0;
 i13 = i13 + (HEAP32[i15 >> 2] | 0) | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
 __ZN14UnityWebStream16FeedDownloadDataEPKhib(i12, i13, i14 - (HEAP32[i15 >> 2] | 0) | 0, i9);
 HEAP32[i15 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0);
 STACKTOP = i10;
 return;
}

function __Z34GeomOverlapCallback_BoxHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 20 | 0;
 i7 = i1;
 f9 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
 f16 = Math_fround(-Math_fround(HEAPF32[i5 + 4 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i5 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i5 + 16 >> 2]));
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i5 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f14 = Math_fround(f14 * Math_fround(2.0));
 f12 = Math_fround(f12 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i5 + 24 >> 2])) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f8 = Math_fround(Math_fround(Math_fround(f14 * f9) + Math_fround(f12 * f16)) + Math_fround(f20 * f15));
 f13 = Math_fround(Math_fround(f8 * f9) + Math_fround(Math_fround(f17 * f14) + Math_fround(f21 * Math_fround(Math_fround(f20 * f16) - Math_fround(f12 * f15)))));
 f10 = Math_fround(Math_fround(f8 * f16) + Math_fround(Math_fround(f17 * f12) + Math_fround(f21 * Math_fround(Math_fround(f14 * f15) - Math_fround(f20 * f9)))));
 f8 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(f21 * Math_fround(Math_fround(f12 * f9) - Math_fround(f14 * f16)))) + Math_fround(f8 * f15));
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f21 * f14);
 f20 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f9));
 f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f17 * f16));
 f19 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f19 * f15));
 f11 = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(Math_fround(f20 * f16) + Math_fround(f21 * f19))) - Math_fround(f17 * f9));
 f18 = Math_fround(Math_fround(Math_fround(f19 * f9) + Math_fround(Math_fround(f20 * f15) + Math_fround(f21 * f17))) - Math_fround(f14 * f16));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f14 * f9)) - Math_fround(f19 * f16)) - Math_fround(f17 * f15));
 HEAPF32[i6 + 36 >> 2] = f13;
 HEAPF32[i6 + 40 >> 2] = f10;
 HEAPF32[i6 + 44 >> 2] = f8;
 HEAP32[i6 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f8 = Math_fround(f12 + f12);
 f10 = Math_fround(f11 + f11);
 f13 = Math_fround(f18 + f18);
 f17 = Math_fround(f11 * f10);
 f16 = Math_fround(f18 * f13);
 f11 = Math_fround(f8 * f11);
 f19 = Math_fround(f8 * f18);
 f9 = Math_fround(f8 * f15);
 f18 = Math_fround(f18 * f10);
 f10 = Math_fround(f15 * f10);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(f11 + f13);
 f14 = Math_fround(f19 - f10);
 f13 = Math_fround(f11 - f13);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f8));
 f12 = Math_fround(f8 - f16);
 f11 = Math_fround(f9 + f18);
 f10 = Math_fround(f19 + f10);
 f9 = Math_fround(f18 - f9);
 f8 = Math_fround(f8 - f17);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f17) - f16);
 HEAPF32[i6 + 4 >> 2] = f15;
 HEAPF32[i6 + 8 >> 2] = f14;
 HEAPF32[i6 + 12 >> 2] = f13;
 HEAPF32[i6 + 16 >> 2] = f12;
 HEAPF32[i6 + 20 >> 2] = f11;
 HEAPF32[i6 + 24 >> 2] = f10;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f8;
 HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 i5 = __ZN5physx2Gu23intersectHeightFieldBoxERKNS0_15HeightFieldUtilERKNS0_3BoxE(i7, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDriveNWEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i11 + 296 | 0;
 i20 = i11 + 244 | 0;
 i13 = i11 + 348 | 0;
 i21 = i11 + 16 | 0;
 i15 = i11 + 192 | 0;
 i23 = i11;
 i6 = i11 + 188 | 0;
 i10 = i11 + 48 | 0;
 i9 = i11 + 32 | 0;
 i14 = i11 + 64 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev(i14);
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 >> 2] = i19;
 HEAP32[i22 + 4 >> 2] = i18;
 i3 = i22 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 + 20 >> 2] = i17;
 HEAP32[i22 + 24 >> 2] = i16;
 HEAP32[i22 + 28 >> 2] = i1;
 HEAP32[i22 + 32 >> 2] = i4;
 HEAP8[i22 + 36 >> 0] = 1;
 HEAP32[i22 + 40 >> 2] = i5;
 HEAP32[i22 + 44 >> 2] = 0;
 HEAP32[i22 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i14 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i14 + 52 | 0, 4);
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14 + 80 | 0, 6);
 HEAP32[i15 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i18;
 i3 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj690ES3_NS_23PxVehicleDriveSimDataNWES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 108 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i23 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
  }
 }
 i23 = HEAP32[i7 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i23 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDrive4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i11 + 296 | 0;
 i20 = i11 + 244 | 0;
 i13 = i11 + 348 | 0;
 i21 = i11 + 16 | 0;
 i15 = i11 + 192 | 0;
 i23 = i11;
 i6 = i11 + 188 | 0;
 i10 = i11 + 48 | 0;
 i9 = i11 + 32 | 0;
 i14 = i11 + 64 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev(i14);
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 >> 2] = i19;
 HEAP32[i22 + 4 >> 2] = i18;
 i3 = i22 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 + 20 >> 2] = i17;
 HEAP32[i22 + 24 >> 2] = i16;
 HEAP32[i22 + 28 >> 2] = i1;
 HEAP32[i22 + 32 >> 2] = i4;
 HEAP8[i22 + 36 >> 0] = 1;
 HEAP32[i22 + 40 >> 2] = i5;
 HEAP32[i22 + 44 >> 2] = 0;
 HEAP32[i22 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i14 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i14 + 52 | 0, 4);
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14 + 80 | 0, 6);
 HEAP32[i15 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i18;
 i3 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj678ES3_NS_23PxVehicleDriveSimData4WES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 108 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i23 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
  }
 }
 i23 = HEAP32[i7 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i23 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZL26InitializeTextureImageLoadR9Texture2D13TextureFormatjjbR14ImageReferenceR13dynamic_arrayIhLj1EE(i3, i4, i10, i11, i7, i12, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0;
 if (!(HEAP32[i3 + 104 >> 2] & 1)) i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0; else i5 = 1;
 i6 = i5 & 1 | 4;
 i1 = i3 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i8 = 11; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i8 = 11; else if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0) == (i10 | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0) == (i11 | 0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 5 : i1;
  } else i1 = HEAP32[i1 + 36 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) i8 = 11;
 } else i8 = 11; else i8 = 11;
 if ((i8 | 0) == 11) if (!(mftCall_iiiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, i10 | 0, i11 | 0, i4 | 0, i6 | 0, 1, -1, 0) | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 if (i7) {
  do if (i5) {
   i5 = i10 >>> 0 > 65535;
   i6 = i5 ? i10 >>> 16 : i10;
   i5 = i5 ? 16 : 0;
   i8 = (i6 & 65280 | 0) == 0;
   i6 = i8 ? i6 : i6 >>> 8;
   i5 = i8 ? i5 : i5 | 8;
   i8 = (i6 & 240 | 0) == 0;
   i5 = (HEAP8[(i8 ? i6 : i6 >>> 4) + (gb + 936717) >> 0] | 0) + (i8 ? i5 : i5 | 4) | 0;
   i8 = i11 >>> 0 > 65535;
   i6 = i8 ? i11 >>> 16 : i11;
   i8 = i8 ? 16 : 0;
   i7 = (i6 & 65280 | 0) == 0;
   i6 = i7 ? i6 : i6 >>> 8;
   i8 = i7 ? i8 : i8 | 8;
   i7 = (i6 & 240 | 0) == 0;
   i8 = (HEAP8[(i7 ? i6 : i6 >>> 4) + (gb + 936717) >> 0] | 0) + (i7 ? i8 : i8 | 4) | 0;
   i5 = (i5 | 0) < (i8 | 0) ? i8 : i5;
   i5 = (i5 | 0) < 0 ? 0 : i5;
   if (i10 >>> 0 > 4294967292 | i11 >>> 0 > 4294967292) {
    i12 = 0;
    return i12 | 0;
   }
   if (!i10) {
    i3 = 0;
    i4 = 0;
   } else if ((((Math_imul(i11, i10) | 0) >>> 0) / (i10 >>> 0) | 0 | 0) == (i11 | 0)) {
    i3 = 0;
    i4 = 0;
   } else {
    i12 = 0;
    return i12 | 0;
   }
   while (1) {
    i2 = i10 >>> i4;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    i1 = i11 >>> i4;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if ((i2 | 0) < 1 | (i1 | 0) < 1) i1 = 0; else i1 = Math_imul(__Z29GetRowBytesFromWidthAndFormati13TextureFormat(i2, 4) | 0, i1) | 0;
    i8 = i3;
    i3 = i1 + i3 | 0;
    if (i3 >>> 0 < i8 >>> 0) {
     i1 = 0;
     i8 = 38;
     break;
    }
    if ((i4 | 0) >= (i5 | 0)) {
     i8 = 21;
     break;
    } else i4 = i4 + 1 | 0;
   }
   if ((i8 | 0) == 21) {
    i1 = __Z24CalculateImageMipMapSizeii13TextureFormat(i10, i11, 4) | 0;
    break;
   } else if ((i8 | 0) == 38) return i1 | 0;
  } else {
   if (i10 >>> 0 > 4294967292 | i11 >>> 0 > 4294967292) {
    i12 = 0;
    return i12 | 0;
   }
   if (!i10) i1 = 0; else {
    if ((((Math_imul(i11, i10) | 0) >>> 0) / (i10 >>> 0) | 0 | 0) != (i11 | 0)) {
     i12 = 0;
     return i12 | 0;
    }
    if ((i10 | 0) < 1 | (i11 | 0) < 1) i1 = 0; else i1 = Math_imul(__Z29GetRowBytesFromWidthAndFormati13TextureFormat(i10, 4) | 0, i11) | 0;
   }
  } while (0);
  i2 = i9 + 12 | 0;
  HEAP32[i2 >> 2] = i1;
  i3 = i9 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i9 >> 2] = i1;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i9 >> 2] = i7;
   i1 = i7;
   break;
  } else i1 = HEAP32[i9 >> 2] | 0; while (0);
  i2 = i10 << 2;
  if (!i1) i8 = 34; else if (!((i10 | 0) > 0 & (i11 | 0) > 0)) i8 = 34;
  if ((i8 | 0) == 34) i1 = 0;
  HEAP32[i12 >> 2] = 4;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = i11;
  HEAP32[i12 + 12 >> 2] = i2;
  HEAP32[i12 + 16 >> 2] = i1;
 } else if (!(__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i3, i12, 0, 0) | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 i12 = 1;
 return i12 | 0;
}

function __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iiiPKiS3_ii(i1, i10, i11, i12, i13, i14, i17, i18, i19, i20) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0, i16 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21 + 36 | 0;
 i7 = i21 + 32 | 0;
 i16 = i21;
 i9 = i1 >>> 0 > 8 ? 8 : i1;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 0;
 if (i9 | 0) {
  i6 = 0;
  do {
   i5 = HEAP32[i10 + (i6 << 3) >> 2] | 0;
   do if (!i5) i1 = 0; else {
    HEAP32[i7 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i8 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i7);
      i4 = HEAP32[i15 >> 2] | 0;
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
      i1 = i3;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i8 = 12;
    }
    if ((i8 | 0) == 10) i8 = 12;
    if ((i8 | 0) == 12) {
     i8 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) {
      i1 = 0;
      break;
     }
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
    }
    HEAP32[i7 >> 2] = i5;
    if (!i1) i8 = 19; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i7);
      i2 = HEAP32[i15 >> 2] | 0;
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 19; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i8 = 21;
     }
    }
    if ((i8 | 0) == 19) i8 = 21;
    if ((i8 | 0) == 21) {
     i8 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
   } while (0);
   HEAP32[i16 + (i6 << 2) >> 2] = i1;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i9 >>> 0);
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[(HEAP32[i1 + 128 >> 2] | 0) + 31 >> 0] | 0)) {
   i1 = i15;
   i2 = i1 + 76 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i15 + 36 >> 2] = i9;
   i2 = (i9 | 0) > 0;
   if (i2) {
    i1 = 0;
    do {
     HEAP32[i15 + (i1 << 2) >> 2] = HEAP32[i10 + (i1 << 3) + 4 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   }
   HEAP32[i15 + 32 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i15 + 44 >> 2] = i13;
   HEAP32[i15 + 40 >> 2] = i12;
   HEAP32[i15 + 48 >> 2] = i14;
   if (i2) {
    i1 = 0;
    do {
     HEAP8[i15 + 56 + i1 >> 0] = HEAP32[i17 + (i1 << 2) >> 2];
     HEAP8[i15 + 64 + i1 >> 0] = HEAP32[i18 + (i1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i9 | 0));
   }
   HEAP8[i15 + 72 >> 0] = i19;
   HEAP8[i15 + 73 >> 0] = i20;
   __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j(i15, i16, 0) | 0;
   STACKTOP = i21;
   return;
  }
 }
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 STACKTOP = i21;
 return;
}

function __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i28 = HEAP32[i4 + 192 >> 2] | 0;
 i25 = HEAP32[i28 + 40 >> 2] | 0;
 i28 = ((HEAPU8[i28 + 38 >> 0] | 0) * 12 | 0) + ((HEAPU8[i28 + 39 >> 0] | 0) * 20 | 0) + ((HEAPU16[i28 + 36 >> 1] | 0) << 1) | 0;
 i27 = HEAP32[i4 + 200 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i27 + (i2 * 12 | 0) >> 2]);
 f11 = Math_fround(HEAPF32[i27 + (i2 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i27 + (i2 * 12 | 0) + 8 >> 2]);
 i2 = i2 * 3 | 0;
 i27 = HEAPU8[i25 + (i28 + i2) >> 0] | 0;
 i26 = HEAPU8[i25 + (i2 + 1 + i28) >> 0] | 0;
 i2 = HEAPU8[i25 + (i2 + 2 + i28) >> 0] | 0;
 f17 = Math_fround(HEAPF32[i25 + (i27 * 20 | 0) >> 2]);
 f15 = Math_fround(HEAPF32[i25 + (i27 * 20 | 0) + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i25 + (i27 * 20 | 0) + 8 >> 2]);
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f15 * f15)) + Math_fround(f14 * f14)))));
 f17 = Math_fround(f17 * f20);
 f15 = Math_fround(f15 * f20);
 f20 = Math_fround(f14 * f20);
 f14 = Math_fround(HEAPF32[i25 + (i26 * 20 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i25 + (i26 * 20 | 0) + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i25 + (i26 * 20 | 0) + 8 >> 2]);
 f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f16 * f16)) + Math_fround(f24 * f24)))));
 f14 = Math_fround(f14 * f18);
 f16 = Math_fround(f16 * f18);
 f18 = Math_fround(f24 * f18);
 f24 = Math_fround(HEAPF32[i25 + (i2 * 20 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i25 + (i2 * 20 | 0) + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i25 + (i2 * 20 | 0) + 8 >> 2]);
 f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f23 * f23)) + Math_fround(f19 * f19)))));
 f24 = Math_fround(f24 * f22);
 f23 = Math_fround(f23 * f22);
 f22 = Math_fround(f19 * f22);
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f19 - Math_fround(Math_fround(f10 * f20) + Math_fround(Math_fround(f12 * f17) + Math_fround(f11 * f15))));
 f21 = Math_fround(f19 - Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f12 * f14) + Math_fround(f11 * f16))));
 f19 = Math_fround(f19 - Math_fround(Math_fround(f10 * f22) + Math_fround(Math_fround(f12 * f24) + Math_fround(f11 * f23))));
 f9 = Math_fround(Math_fround(f16 * f22) - Math_fround(f18 * f23));
 f8 = Math_fround(Math_fround(f18 * f24) - Math_fround(f14 * f22));
 f7 = Math_fround(Math_fround(f14 * f23) - Math_fround(f16 * f24));
 f14 = Math_fround(Math_fround(f24 * f21) - Math_fround(f14 * f19));
 f16 = Math_fround(Math_fround(f23 * f21) - Math_fround(f16 * f19));
 f19 = Math_fround(Math_fround(f22 * f21) - Math_fround(f18 * f19));
 f18 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f20 * f7) + Math_fround(Math_fround(f17 * f9) + Math_fround(f15 * f8))));
 f9 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f15 * f19) - Math_fround(f20 * f16)) - Math_fround(f13 * f9)));
 f8 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f20 * f14) - Math_fround(f17 * f19)) - Math_fround(f13 * f8)));
 f7 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)) - Math_fround(f13 * f7)));
 HEAPF32[i1 >> 2] = f9;
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(f12 - f9);
 f8 = Math_fround(f11 - f8);
 f7 = Math_fround(f10 - f7);
 HEAPF32[i4 + 48 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f7 * f7))));
 i4 = i4 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i2, i9, i13, i31, i29, i32, i3, i1, i28, i30) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i31 = i31 | 0;
 i29 = i29 | 0;
 i32 = i32 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f22 = Math_fround(f22 - f19);
 f23 = Math_fround(f23 - f20);
 f24 = Math_fround(f24 - f21);
 f25 = Math_fround(HEAPF32[i29 >> 2]);
 i1 = i29 + 4 | 0;
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i29 + 8 | 0;
 f27 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(Math_fround(f23 * f27) - Math_fround(f24 * f26));
 f8 = Math_fround(Math_fround(f24 * f25) - Math_fround(f22 * f27));
 f10 = Math_fround(Math_fround(f22 * f26) - Math_fround(f23 * f25));
 f12 = Math_fround(Math_fround(f21 * f10) + Math_fround(Math_fround(f19 * f7) + Math_fround(f20 * f8)));
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 f17 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f15 * f7) + Math_fround(f8 * f17)) + Math_fround(f10 * f18));
 f4 = Math_fround(HEAPF32[i13 >> 2]);
 f5 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 if (Math_fround(Math_fround(f11 - f12) * Math_fround(Math_fround(Math_fround(Math_fround(f7 * f4) + Math_fround(f8 * f5)) + Math_fround(f10 * f6)) - f12)) > Math_fround(0.0)) return;
 f16 = Math_fround(f4 - f15);
 f14 = Math_fround(f5 - f17);
 f5 = Math_fround(f6 - f18);
 f4 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f8 * f14)) + Math_fround(f10 * f5));
 if (f4 == Math_fround(0.0)) return;
 f10 = Math_fround(Math_fround(f12 - f11) / f4);
 f12 = Math_fround(Math_fround(f16 * f10) + f15);
 f11 = Math_fround(Math_fround(f14 * f10) + f17);
 f10 = Math_fround(Math_fround(f5 * f10) + f18);
 f18 = Math_fround(Math_fround(f5 * f26) - Math_fround(f14 * f27));
 f8 = Math_fround(Math_fround(f16 * f27) - Math_fround(f5 * f25));
 f17 = Math_fround(Math_fround(f14 * f25) - Math_fround(f16 * f26));
 f4 = Math_fround(f12 - f19);
 f5 = Math_fround(f11 - f20);
 f7 = Math_fround(f10 - f21);
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f4) + Math_fround(f8 * f5)) + Math_fround(f17 * f7)) / Math_fround(Math_fround(f24 * f17) + Math_fround(Math_fround(f22 * f18) + Math_fround(f23 * f8))));
 if (!(f8 >= Math_fround(0.0)) | !(f8 <= Math_fround(1.0))) return;
 f6 = Math_fround(f4 - Math_fround(f22 * f8));
 f5 = Math_fround(f5 - Math_fround(f23 * f8));
 f4 = Math_fround(f7 - Math_fround(f24 * f8));
 f24 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)));
 if (!(Math_fround(HEAPF32[i31 >> 2]) > f24)) return;
 f22 = Math_fround(f12 - f6);
 f23 = Math_fround(f11 - f5);
 f24 = Math_fround(f10 - f4);
 f27 = Math_fround(Math_fround(Math_fround(f6 * f25) + Math_fround(f5 * f26)) + Math_fround(f4 * f27));
 i31 = HEAP32[i30 >> 2] | 0;
 HEAPF32[i28 + (i31 << 6) >> 2] = f12;
 HEAPF32[i28 + (i31 << 6) + 4 >> 2] = f11;
 HEAPF32[i28 + (i31 << 6) + 8 >> 2] = f10;
 HEAPF32[i28 + (i31 << 6) + 12 >> 2] = Math_fround(0.0);
 i31 = HEAP32[i30 >> 2] | 0;
 HEAPF32[i28 + (i31 << 6) + 16 >> 2] = f22;
 HEAPF32[i28 + (i31 << 6) + 20 >> 2] = f23;
 HEAPF32[i28 + (i31 << 6) + 24 >> 2] = f24;
 HEAPF32[i28 + (i31 << 6) + 28 >> 2] = Math_fround(0.0);
 i31 = HEAP32[i30 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 HEAP32[i28 + (i31 << 6) + 32 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i28 + (i31 << 6) + 36 >> 2] = i9;
 HEAP32[i28 + (i31 << 6) + 40 >> 2] = i13;
 HEAPF32[i28 + (i31 << 6) + 44 >> 2] = f27;
 i31 = HEAP32[i30 >> 2] | 0;
 HEAP32[i30 >> 2] = i31 + 1;
 HEAP32[i28 + (i31 << 6) + 48 >> 2] = i32;
 return;
}

function __ZN18CrashReportHandler25UnregisterGlobalCallbacksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 20840 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 20072 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3931 | 0)) {
    i4 = i6 + 20072 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 20072 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 20072 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 20072 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 20072 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 20072 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 20072 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 20072 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 24700 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L12 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 23932 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3931 | 0)) {
    i4 = i6 + 23932 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 23932 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L12;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 23932 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 23932 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 23932 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 23932 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 36280 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L23 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 35512 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 168 | 0)) {
    i4 = i6 + 35512 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 35512 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L23;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 35512 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 35512 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 35512 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 35512 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 35512 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 35512 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 1540 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 772 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 3932 | 0)) {
   i4 = i6 + 772 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 772 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i9 = 29;
   break;
  }
 }
 if ((i9 | 0) == 29) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i9 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i9;
 if (i9 >>> 0 <= i1 >>> 0) return;
 do {
  i9 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 772 + (i9 * 12 | 0) >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 772 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 772 + (i9 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function _md5crypt(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i15 = i16 + 88 | 0;
 i13 = _strnlen(i5, 30001) | 0;
 if (i13 >>> 0 > 3e4) i1 = 0; else if (!(_strncmp(i6, gb + 1060033 | 0, 3) | 0)) {
  i14 = i6 + 3 | 0;
  L4 : do switch (HEAP8[i14 >> 0] | 0) {
  case 36:
  case 0:
   {
    i4 = 0;
    break;
   }
  default:
   {
    switch (HEAP8[i6 + 4 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 1;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 5 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 2;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 6 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 3;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 7 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 4;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 8 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 5;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 9 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 6;
      break L4;
     }
    default:
     {}
    }
    switch (HEAP8[i6 + 10 >> 0] | 0) {
    case 36:
    case 0:
     {
      i4 = 7;
      break L4;
     }
    default:
     {}
    }
    i4 = 8;
   }
  } while (0);
  i7 = i12;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i7 = i12 + 8 | 0;
  HEAP32[i7 >> 2] = 1732584193;
  i8 = i12 + 12 | 0;
  HEAP32[i8 >> 2] = -271733879;
  i9 = i12 + 16 | 0;
  HEAP32[i9 >> 2] = -1732584194;
  i10 = i12 + 20 | 0;
  HEAP32[i10 >> 2] = 271733878;
  _md5_update(i12, i5, i13);
  _md5_update(i12, i14, i4);
  _md5_update(i12, i5, i13);
  _md5_sum(i12, i15);
  i11 = i12;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i7 >> 2] = 1732584193;
  HEAP32[i8 >> 2] = -271733879;
  HEAP32[i9 >> 2] = -1732584194;
  HEAP32[i10 >> 2] = 271733878;
  _md5_update(i12, i5, i13);
  i11 = i4 + 3 | 0;
  _md5_update(i12, i6, i11);
  if (i13 >>> 0 > 16) {
   i3 = i13 + -17 & -16;
   i2 = i13;
   do {
    _md5_update(i12, i15, 16);
    i2 = i2 + -16 | 0;
   } while (i2 >>> 0 > 16);
   i2 = i13 + -16 - i3 | 0;
  } else i2 = i13;
  _md5_update(i12, i15, i2);
  HEAP8[i15 >> 0] = 0;
  if (i13 | 0) {
   i2 = i13;
   do {
    if (!(i2 & 1)) _md5_update(i12, i5, 1); else _md5_update(i12, i15, 1);
    i2 = i2 >>> 1;
   } while ((i2 | 0) != 0);
  }
  _md5_sum(i12, i15);
  i2 = 0;
  do {
   i3 = i12;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i7 >> 2] = 1732584193;
   HEAP32[i8 >> 2] = -271733879;
   HEAP32[i9 >> 2] = -1732584194;
   HEAP32[i10 >> 2] = 271733878;
   i3 = (i2 & 1 | 0) != 0;
   if (i3) _md5_update(i12, i5, i13); else _md5_update(i12, i15, 16);
   if ((i2 >>> 0) % 3 | 0 | 0) _md5_update(i12, i14, i4);
   if ((i2 >>> 0) % 7 | 0 | 0) _md5_update(i12, i5, i13);
   if (i3) _md5_update(i12, i15, 16); else _md5_update(i12, i5, i13);
   _md5_sum(i12, i15);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 1e3);
  _memcpy(i1 | 0, i6 | 0, i11 | 0) | 0;
  i6 = i1 + 3 + i4 | 0;
  HEAP8[i6 >> 0] = 36;
  i7 = i4 + 24 | 0;
  i4 = i6 + 1 | 0;
  i6 = 0;
  while (1) {
   i2 = HEAPU8[i15 + (HEAPU8[gb + 1060037 + (i6 * 3 | 0) + 1 >> 0] | 0) >> 0] << 8 | HEAPU8[i15 + (HEAPU8[gb + 1060037 + (i6 * 3 | 0) >> 0] | 0) >> 0] << 16 | HEAPU8[i15 + (HEAPU8[gb + 1060037 + (i6 * 3 | 0) + 2 >> 0] | 0) >> 0];
   i3 = i4;
   i5 = 4;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
    if ((i5 | 0) > 1) {
     i2 = i2 >>> 6;
     i3 = i3 + 1 | 0;
     i5 = i5 + -1 | 0;
    } else break;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 5) break; else i4 = i4 + 4 | 0;
  }
  i5 = i1 + i7 | 0;
  i2 = HEAPU8[i15 + 11 >> 0] | 0;
  i3 = i5;
  i4 = 2;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
   if ((i4 | 0) > 1) {
    i2 = i2 >>> 6;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else break;
  }
  HEAP8[i5 + 2 >> 0] = 0;
 } else i1 = 0;
 STACKTOP = i16;
 return i1 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = (i6 - i7 | 0) / 40 | 0;
 i3 = i7;
 if (i1 >>> 0 < i12 >>> 0) {
  i9 = i14 + 8 | 0;
  if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 40 | 0 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 8 | 0;
  if (i12 | 0) {
   i3 = __Znwj(i12 * 40 | 0) | 0;
   i1 = i3;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3 + (i12 * 40 | 0);
  }
  HEAP32[i4 >> 2] = i7;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i2, i13);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = (i1 - i4 | 0) / 40 | 0;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i2 | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 * 40 | 0) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~(((i5 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0) | 0;
    HEAP32[i10 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -40 - i3 | 0) >>> 0) / 40 | 0) * 40 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i3 + (i12 * 40 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i9 = i13 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 * 40 | 0;
  i2 = (i1 | 0) / 40 | 0;
  if (!i1) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 107374182) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i6 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i2 * 40 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i8 = i6;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i5 = i6;
    i2 = i6;
    while (1) {
     HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i12 = i5 + 12 | 0;
     i11 = i3 + 12 | 0;
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
     HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
     HEAP32[i12 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
     i3 = i3 + 40 | 0;
     i2 = i2 + 40 | 0;
     if ((i3 | 0) == (i7 | 0)) break; else i5 = i2;
    }
    HEAP32[i9 >> 2] = i2;
    i5 = i8;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -40 - i3 | 0) >>> 0) / 40 | 0) * 40 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __Z36GeneratePolygonOutlineVerticesOfSizeiR13dynamic_arrayI8Vector2fLj4EEii(i1, i11, i12, i13) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i2 = i14 + 8 | 0;
 i5 = i14;
 if (!i1) {
  i1 = i11 + 12 | 0;
  HEAP32[i1 >> 2] = 4;
  i5 = i11 + 16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483644) >>> 0 < 4) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = 4;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, 32, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i11 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = 4;
   HEAP32[i11 >> 2] = i2;
   break;
  } else i2 = HEAP32[i11 >> 2] | 0; while (0);
  HEAP32[i2 >> 2] = -1090519040;
  HEAP32[i2 + 4 >> 2] = -1090519040;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 + 8 >> 2] = -1090519040;
  HEAP32[i10 + 12 >> 2] = 1056964608;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 + 16 >> 2] = 1056964608;
  HEAP32[i10 + 20 >> 2] = 1056964608;
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 + 24 >> 2] = 1056964608;
  HEAP32[i10 + 28 >> 2] = -1090519040;
 } else {
  __ZN9Polygon2DC2Ev(i10);
  HEAPF32[i2 >> 2] = Math_fround(.5);
  HEAPF32[i2 + 4 >> 2] = Math_fround(.5);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_(i10, i1, i2, i5);
  i2 = HEAP32[i10 >> 2] | 0;
  i7 = i2 + 12 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i1 = i11 + 12 | 0;
  HEAP32[i1 >> 2] = i5;
  i9 = i11 + 16 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i5 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i9 >> 2] = i5;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i5 << 3, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i11 >> 2] = i8;
   break;
  } while (0);
  if ((i2 | 0) != (i11 | 0)) {
   i8 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] << 3;
   i5 = i2 >> 3;
   HEAP32[i1 >> 2] = i5;
   i6 = HEAP32[i9 >> 2] | 0;
   do if ((i6 & 2147483647) >>> 0 < i5 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i9 >> 2] = i5;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i11 >> 2] = i2;
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i2 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i11 >> 2] = i2;
    break;
   } else i2 = HEAP32[i11 >> 2] | 0; while (0);
   _memcpy(i2 | 0, i8 | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2 | 0) {
   i7 = i10 + 4 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) {
    do {
     i6 = i5 + -20 | 0;
     HEAP32[i7 >> 2] = i6;
     if ((HEAP32[i5 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + -16 | 0);
      HEAP32[i6 >> 2] = 0;
      i5 = HEAP32[i7 >> 2] | 0;
     } else i5 = i6;
    } while ((i5 | 0) != (i2 | 0));
    i2 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i2);
  }
 }
 i5 = HEAP32[i1 >> 2] | 0;
 if (!i5) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 f4 = Math_fround(i12 | 0);
 f3 = Math_fround(i13 | 0);
 i1 = 0;
 do {
  i13 = i2 + (i1 << 3) | 0;
  HEAPF32[i13 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i13 >> 2]));
  i13 = i2 + (i1 << 3) + 4 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i13 >> 2]));
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 STACKTOP = i14;
 return;
}

function runPostSets203() {
 HEAP32[gb + 171208 >> 2] = fb + 112;
 HEAP32[gb + 171212 >> 2] = fb + 113;
 HEAP32[gb + 171216 >> 2] = fb + 131;
 HEAP32[gb + 171220 >> 2] = fb + 2644;
 HEAP32[gb + 171224 >> 2] = fb + 112;
 HEAP32[gb + 171228 >> 2] = fb + 113;
 HEAP32[gb + 171232 >> 2] = fb + 2645;
 HEAP32[gb + 171236 >> 2] = fb + 2613;
 HEAP32[gb + 171248 >> 2] = (HEAP32[gb + 171248 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171252 >> 2] = (HEAP32[gb + 171252 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 171288 >> 2] = fb + 2646;
 HEAP32[gb + 171292 >> 2] = fb + 2647;
 HEAP32[gb + 171296 >> 2] = fb + 38;
 HEAP32[gb + 171300 >> 2] = fb + 1965;
 HEAP32[gb + 171304 >> 2] = fb + 16;
 HEAP32[gb + 171308 >> 2] = fb + 93;
 HEAP32[gb + 171312 >> 2] = fb + 40;
 HEAP32[gb + 171316 >> 2] = fb + 19;
 HEAP32[gb + 171320 >> 2] = fb + 1232;
 HEAP32[gb + 171324 >> 2] = fb + 103;
 HEAP32[gb + 171328 >> 2] = fb + 101;
 HEAP32[gb + 171332 >> 2] = fb + 62;
 HEAP32[gb + 171336 >> 2] = fb + 28;
 HEAP32[gb + 171340 >> 2] = fb + 63;
 HEAP32[gb + 171344 >> 2] = fb + 29;
 HEAP32[gb + 171348 >> 2] = fb + 34;
 HEAP32[gb + 171352 >> 2] = fb + 1966;
 HEAP32[gb + 171356 >> 2] = fb + 1967;
 HEAP32[gb + 171360 >> 2] = fb + 1968;
 HEAP32[gb + 171364 >> 2] = fb + 1969;
 HEAP32[gb + 171368 >> 2] = fb + 1970;
 HEAP32[gb + 171372 >> 2] = fb + 1971;
 HEAP32[gb + 171376 >> 2] = fb + 36;
 HEAP32[gb + 171380 >> 2] = fb + 104;
 HEAP32[gb + 171384 >> 2] = fb + 108;
 HEAP32[gb + 171388 >> 2] = fb + 94;
 HEAP32[gb + 171392 >> 2] = fb + 130;
 HEAP32[gb + 171396 >> 2] = fb + 112;
 HEAP32[gb + 171400 >> 2] = fb + 113;
 HEAP32[gb + 171404 >> 2] = fb + 131;
 HEAP32[gb + 171408 >> 2] = fb + 2648;
 HEAP32[gb + 171412 >> 2] = fb + 2649;
 HEAP32[gb + 171416 >> 2] = fb + 113;
 HEAP32[gb + 171420 >> 2] = fb + 2650;
 HEAP32[gb + 171424 >> 2] = fb + 2651;
 HEAP32[gb + 171436 >> 2] = (HEAP32[gb + 171436 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171440 >> 2] = (HEAP32[gb + 171440 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 171476 >> 2] = (HEAP32[gb + 171476 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171480 >> 2] = (HEAP32[gb + 171480 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 171516 >> 2] = fb + 2652;
 HEAP32[gb + 171520 >> 2] = fb + 2653;
 HEAP32[gb + 171524 >> 2] = fb + 2608;
 HEAP32[gb + 171528 >> 2] = fb + 1972;
 HEAP32[gb + 171532 >> 2] = fb + 16;
 HEAP32[gb + 171536 >> 2] = fb + 2654;
 HEAP32[gb + 171540 >> 2] = fb + 2655;
 HEAP32[gb + 171544 >> 2] = fb + 19;
 HEAP32[gb + 171548 >> 2] = fb + 1233;
 HEAP32[gb + 171552 >> 2] = fb + 103;
 HEAP32[gb + 171556 >> 2] = fb + 101;
 HEAP32[gb + 171560 >> 2] = fb + 62;
 HEAP32[gb + 171564 >> 2] = fb + 28;
 HEAP32[gb + 171568 >> 2] = fb + 63;
 HEAP32[gb + 171572 >> 2] = fb + 29;
 HEAP32[gb + 171576 >> 2] = fb + 34;
 HEAP32[gb + 171580 >> 2] = fb + 1973;
 HEAP32[gb + 171584 >> 2] = fb + 1974;
 HEAP32[gb + 171588 >> 2] = fb + 1975;
 HEAP32[gb + 171592 >> 2] = fb + 1976;
 HEAP32[gb + 171596 >> 2] = fb + 1977;
 HEAP32[gb + 171600 >> 2] = fb + 1978;
 HEAP32[gb + 171604 >> 2] = fb + 36;
 HEAP32[gb + 171608 >> 2] = fb + 104;
 HEAP32[gb + 171612 >> 2] = fb + 108;
 HEAP32[gb + 171616 >> 2] = fb + 94;
 HEAP32[gb + 171620 >> 2] = fb + 130;
 HEAP32[gb + 171624 >> 2] = fb + 112;
 HEAP32[gb + 171628 >> 2] = fb + 113;
 HEAP32[gb + 171632 >> 2] = fb + 131;
 HEAP32[gb + 171636 >> 2] = fb + 2656;
 HEAP32[gb + 171640 >> 2] = fb + 112;
 HEAP32[gb + 171644 >> 2] = fb + 113;
 HEAP32[gb + 171648 >> 2] = fb + 2657;
 HEAP32[gb + 171652 >> 2] = fb + 2613;
 HEAP32[gb + 171664 >> 2] = (HEAP32[gb + 171664 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171668 >> 2] = (HEAP32[gb + 171668 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 171704 >> 2] = fb + 2658;
 HEAP32[gb + 171708 >> 2] = fb + 2659;
 HEAP32[gb + 171712 >> 2] = fb + 2660;
 HEAP32[gb + 171716 >> 2] = fb + 1979;
 HEAP32[gb + 171720 >> 2] = fb + 16;
 HEAP32[gb + 171724 >> 2] = fb + 2661;
 HEAP32[gb + 171728 >> 2] = fb + 2662;
 HEAP32[gb + 171732 >> 2] = fb + 19;
 HEAP32[gb + 171736 >> 2] = fb + 1234;
 HEAP32[gb + 171740 >> 2] = fb + 99;
 HEAP32[gb + 171744 >> 2] = fb + 40;
 HEAP32[gb + 171748 >> 2] = fb + 62;
 HEAP32[gb + 171752 >> 2] = fb + 28;
 HEAP32[gb + 171756 >> 2] = fb + 63;
 runPostSets204();
}

function __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i1 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i5 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i7, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 i3 = i7 + 4 | 0;
 i4 = i8 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i8, i7 + 28 | 0, 0);
 i3 = i7 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 44 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i8, i7 + 64 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i7 + 84 | 0, i1 << 2);
 STACKTOP = i9;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 56 | 0;
 i10 = i13;
 i11 = i7 + 48 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv(i7);
 i12 = i7 + 32 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i22 = i10 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i10 + 8 | 0;
 i24 = i7 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i10 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i10 + 12 | 0;
 i18 = i7 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i10 + 20 | 0;
 i17 = i7 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i10 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i10 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i10 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i10, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i7 + 9 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i2;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i1;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i10 + 20 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i16 >> 2] = i2;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i12;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i11 >> 0] = 0;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i4 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i5 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 65;
  HEAP32[i9 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i13;
 return;
}

function __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 16 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 32 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEbT0_S6_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i19;
 switch ((i18 - i17 | 0) / 36 | 0 | 0) {
 case 2:
  {
   i7 = i18 + -36 | 0;
   if (!(Math_fround(HEAPF32[i18 + -8 >> 2]) < Math_fround(HEAPF32[i17 + 28 >> 2]))) {
    i18 = 1;
    STACKTOP = i19;
    return i18 | 0;
   }
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   i3 = HEAP32[i17 + 8 >> 2] | 0;
   i4 = HEAP32[i17 + 12 >> 2] | 0;
   i5 = HEAP32[i17 + 16 >> 2] | 0;
   i6 = HEAP32[i17 + 20 >> 2] | 0;
   i14 = i17 + 24 | 0;
   HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i14 = i17;
   i15 = i7;
   i16 = i14 + 36 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    i14 = i14 + 4 | 0;
    i15 = i15 + 4 | 0;
   } while ((i14 | 0) < (i16 | 0));
   HEAP32[i7 >> 2] = i1;
   HEAP32[i18 + -32 >> 2] = i2;
   HEAP32[i18 + -28 >> 2] = i3;
   HEAP32[i18 + -24 >> 2] = i4;
   HEAP32[i18 + -20 >> 2] = i5;
   HEAP32[i18 + -16 >> 2] = i6;
   i18 = i18 + -12 | 0;
   HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i17, i17 + 36 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_(i17, i17 + 36 | 0, i17 + 72 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_(i17, i17 + 36 | 0, i17 + 72 | 0, i17 + 108 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 1:
 case 0:
  {
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 default:
  {
   i3 = i17 + 72 | 0;
   __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i17, i17 + 36 | 0, i3, i1) | 0;
   i1 = i17 + 108 | 0;
   L3 : do if ((i1 | 0) == (i18 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     if (f9 < Math_fround(HEAPF32[i3 + 28 >> 2])) {
      i7 = HEAP32[i1 >> 2] | 0;
      i8 = HEAP32[i1 + 4 >> 2] | 0;
      i10 = HEAP32[i1 + 8 >> 2] | 0;
      i11 = HEAP32[i1 + 12 >> 2] | 0;
      i12 = HEAP32[i1 + 16 >> 2] | 0;
      i13 = HEAP32[i1 + 20 >> 2] | 0;
      i6 = HEAP32[i1 + 24 >> 2] | 0;
      i5 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i1;
      while (1) {
       i14 = i4;
       i15 = i3;
       i16 = i14 + 36 | 0;
       do {
        HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
        i14 = i14 + 4 | 0;
        i15 = i15 + 4 | 0;
       } while ((i14 | 0) < (i16 | 0));
       if ((i3 | 0) == (i17 | 0)) {
        i3 = i17;
        break;
       }
       if (f9 < Math_fround(HEAPF32[i3 + -8 >> 2])) {
        i4 = i3;
        i3 = i3 + -36 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i7;
      HEAP32[i3 + 4 >> 2] = i8;
      HEAP32[i3 + 8 >> 2] = i10;
      HEAP32[i3 + 12 >> 2] = i11;
      HEAP32[i3 + 16 >> 2] = i12;
      HEAP32[i3 + 20 >> 2] = i13;
      HEAP32[i3 + 24 >> 2] = i6;
      HEAPF32[i3 + 28 >> 2] = f9;
      HEAP32[i3 + 32 >> 2] = i5;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 36 | 0) == (i18 | 0);
       break L3;
      }
     }
     i3 = i1 + 36 | 0;
     if ((i3 | 0) == (i18 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i16 = i1;
      i1 = i3;
      i3 = i16;
     }
    }
   } while (0);
   i18 = i1 | i2;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 return 0;
}

function runPostSets201() {
 HEAP32[gb + 170152 >> 2] = fb + 113;
 HEAP32[gb + 170156 >> 2] = fb + 2612;
 HEAP32[gb + 170160 >> 2] = fb + 2613;
 HEAP32[gb + 170172 >> 2] = (HEAP32[gb + 170172 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 170176 >> 2] = (HEAP32[gb + 170176 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 170212 >> 2] = fb + 2614;
 HEAP32[gb + 170216 >> 2] = fb + 2615;
 HEAP32[gb + 170220 >> 2] = fb + 2608;
 HEAP32[gb + 170224 >> 2] = fb + 1921;
 HEAP32[gb + 170228 >> 2] = fb + 16;
 HEAP32[gb + 170232 >> 2] = fb + 93;
 HEAP32[gb + 170236 >> 2] = fb + 40;
 HEAP32[gb + 170240 >> 2] = fb + 19;
 HEAP32[gb + 170244 >> 2] = fb + 1224;
 HEAP32[gb + 170248 >> 2] = fb + 103;
 HEAP32[gb + 170252 >> 2] = fb + 101;
 HEAP32[gb + 170256 >> 2] = fb + 62;
 HEAP32[gb + 170260 >> 2] = fb + 28;
 HEAP32[gb + 170264 >> 2] = fb + 63;
 HEAP32[gb + 170268 >> 2] = fb + 29;
 HEAP32[gb + 170272 >> 2] = fb + 34;
 HEAP32[gb + 170276 >> 2] = fb + 1928;
 HEAP32[gb + 170280 >> 2] = fb + 1929;
 HEAP32[gb + 170284 >> 2] = fb + 1930;
 HEAP32[gb + 170288 >> 2] = fb + 1931;
 HEAP32[gb + 170292 >> 2] = fb + 1932;
 HEAP32[gb + 170296 >> 2] = fb + 1933;
 HEAP32[gb + 170300 >> 2] = fb + 36;
 HEAP32[gb + 170304 >> 2] = fb + 104;
 HEAP32[gb + 170308 >> 2] = fb + 108;
 HEAP32[gb + 170312 >> 2] = fb + 94;
 HEAP32[gb + 170316 >> 2] = fb + 130;
 HEAP32[gb + 170320 >> 2] = fb + 112;
 HEAP32[gb + 170324 >> 2] = fb + 113;
 HEAP32[gb + 170328 >> 2] = fb + 131;
 HEAP32[gb + 170332 >> 2] = fb + 111;
 HEAP32[gb + 170336 >> 2] = fb + 112;
 HEAP32[gb + 170340 >> 2] = fb + 113;
 HEAP32[gb + 170344 >> 2] = fb + 2616;
 HEAP32[gb + 170348 >> 2] = fb + 2613;
 HEAP32[gb + 170360 >> 2] = (HEAP32[gb + 170360 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 170364 >> 2] = (HEAP32[gb + 170364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 170400 >> 2] = fb + 2617;
 HEAP32[gb + 170404 >> 2] = fb + 2618;
 HEAP32[gb + 170408 >> 2] = fb + 2619;
 HEAP32[gb + 170412 >> 2] = fb + 39;
 HEAP32[gb + 170416 >> 2] = fb + 16;
 HEAP32[gb + 170420 >> 2] = fb + 39;
 HEAP32[gb + 170424 >> 2] = fb + 40;
 HEAP32[gb + 170428 >> 2] = fb + 19;
 HEAP32[gb + 170432 >> 2] = fb + 1225;
 HEAP32[gb + 170436 >> 2] = fb + 31;
 HEAP32[gb + 170440 >> 2] = fb + 27;
 HEAP32[gb + 170444 >> 2] = fb + 62;
 HEAP32[gb + 170448 >> 2] = fb + 28;
 HEAP32[gb + 170452 >> 2] = fb + 63;
 HEAP32[gb + 170456 >> 2] = fb + 29;
 HEAP32[gb + 170460 >> 2] = fb + 34;
 HEAP32[gb + 170464 >> 2] = fb + 1934;
 HEAP32[gb + 170468 >> 2] = fb + 1935;
 HEAP32[gb + 170472 >> 2] = fb + 1936;
 HEAP32[gb + 170476 >> 2] = fb + 1937;
 HEAP32[gb + 170480 >> 2] = fb + 1938;
 HEAP32[gb + 170484 >> 2] = fb + 1939;
 HEAP32[gb + 170488 >> 2] = fb + 36;
 HEAP32[gb + 170492 >> 2] = fb + 1226;
 HEAP32[gb + 170504 >> 2] = (HEAP32[gb + 170504 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 170508 >> 2] = (HEAP32[gb + 170508 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 170544 >> 2] = fb + 2620;
 HEAP32[gb + 170548 >> 2] = fb + 2621;
 HEAP32[gb + 170552 >> 2] = fb + 2622;
 HEAP32[gb + 170556 >> 2] = fb + 1940;
 HEAP32[gb + 170560 >> 2] = fb + 2623;
 HEAP32[gb + 170564 >> 2] = fb + 39;
 HEAP32[gb + 170568 >> 2] = fb + 40;
 HEAP32[gb + 170572 >> 2] = fb + 19;
 HEAP32[gb + 170576 >> 2] = fb + 1227;
 HEAP32[gb + 170580 >> 2] = fb + 31;
 HEAP32[gb + 170584 >> 2] = fb + 27;
 HEAP32[gb + 170588 >> 2] = fb + 62;
 HEAP32[gb + 170592 >> 2] = fb + 28;
 HEAP32[gb + 170596 >> 2] = fb + 63;
 HEAP32[gb + 170600 >> 2] = fb + 29;
 HEAP32[gb + 170604 >> 2] = fb + 34;
 HEAP32[gb + 170608 >> 2] = fb + 1941;
 HEAP32[gb + 170612 >> 2] = fb + 1942;
 HEAP32[gb + 170616 >> 2] = fb + 1943;
 HEAP32[gb + 170620 >> 2] = fb + 1944;
 HEAP32[gb + 170624 >> 2] = fb + 1945;
 HEAP32[gb + 170628 >> 2] = fb + 1946;
 HEAP32[gb + 170632 >> 2] = fb + 36;
 HEAP32[gb + 170636 >> 2] = fb + 1226;
 HEAP32[gb + 170648 >> 2] = (HEAP32[gb + 170648 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 170652 >> 2] = (HEAP32[gb + 170652 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 170688 >> 2] = fb + 2624;
 HEAP32[gb + 170692 >> 2] = fb + 2625;
 HEAP32[gb + 170696 >> 2] = fb + 1228;
 HEAP32[gb + 170708 >> 2] = fb + 2626;
 HEAP32[gb + 170712 >> 2] = fb + 2627;
 HEAP32[gb + 170724 >> 2] = fb + 2628;
 runPostSets202();
}

function _zipClose(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 if (!i14) {
  i14 = -102;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP32[i14 + 44 >> 2] | 0) == 1) i3 = _zipCloseFileInZipRaw(i14, 0, 0) | 0; else i3 = 0;
 if (!i1) {
  i1 = HEAP32[i14 + 16564 >> 2] | 0;
  if (!i1) {
   i12 = 0;
   i1 = 0;
  } else i2 = 6;
 } else i2 = 6;
 if ((i2 | 0) == 6) i12 = _strlen(i1) | 0;
 i10 = i14 + 28 | 0;
 i11 = i14 + 32 | 0;
 i9 = mftCall_iii(HEAP32[i14 + 12 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
 i8 = i14 + 36 | 0;
 if (!i3) {
  i2 = HEAP32[i8 >> 2] | 0;
  if (!i2) {
   i4 = 0;
   i3 = 0;
  } else {
   i7 = i14 + 8 | 0;
   i4 = 0;
   i3 = 0;
   do {
    i6 = i2 + 8 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    if (!i3) if (!i5) {
     i3 = 0;
     i5 = 0;
    } else {
     i3 = mftCall_iiiii(HEAP32[i7 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, i2 + 16 | 0, i5 | 0) | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i3 = ((i3 | 0) != (i5 | 0)) << 31 >> 31;
    }
    i4 = i5 + i4 | 0;
    i2 = HEAP32[i2 >> 2] | 0;
   } while ((i2 | 0) != 0);
  }
 } else i4 = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) do {
  i8 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  _free(i8);
 } while ((i2 | 0) != 0);
 if (!i3) {
  i6 = HEAP32[i11 >> 2] | 0;
  HEAP8[i13 >> 0] = 80;
  i7 = i13 + 1 | 0;
  HEAP8[i7 >> 0] = 75;
  i3 = i13 + 2 | 0;
  HEAP8[i3 >> 0] = 5;
  i5 = i13 + 3 | 0;
  HEAP8[i5 >> 0] = 6;
  i8 = i14 + 8 | 0;
  if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i6 | 0, i13 | 0, 4) | 0) == 4) {
   i6 = HEAP32[i11 >> 2] | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP8[i7 >> 0] = 0;
   if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i6 | 0, i13 | 0, 2) | 0) == 2) {
    i6 = HEAP32[i11 >> 2] | 0;
    HEAP8[i13 >> 0] = 0;
    HEAP8[i7 >> 0] = 0;
    if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i6 | 0, i13 | 0, 2) | 0) == 2) {
     i2 = HEAP32[i11 >> 2] | 0;
     i6 = i14 + 16560 | 0;
     i16 = HEAP32[i6 >> 2] | 0;
     HEAP8[i13 >> 0] = i16;
     HEAP8[i7 >> 0] = i16 >>> 8;
     if (i16 >>> 0 >= 65536) HEAP16[i13 >> 1] = -1;
     if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i2 | 0, i13 | 0, 2) | 0) == 2) {
      i2 = HEAP32[i11 >> 2] | 0;
      i16 = HEAP32[i6 >> 2] | 0;
      HEAP8[i13 >> 0] = i16;
      HEAP8[i7 >> 0] = i16 >>> 8;
      if (i16 >>> 0 >= 65536) HEAP16[i13 >> 1] = -1;
      if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i2 | 0, i13 | 0, 2) | 0) == 2) {
       i16 = HEAP32[i11 >> 2] | 0;
       HEAP8[i13 >> 0] = i4;
       HEAP8[i7 >> 0] = i4 >>> 8;
       HEAP8[i3 >> 0] = i4 >>> 16;
       HEAP8[i5 >> 0] = i4 >>> 24;
       if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i16 | 0, i13 | 0, 4) | 0) == 4) {
        i16 = HEAP32[i11 >> 2] | 0;
        i9 = i9 - (HEAP32[i14 + 16556 >> 2] | 0) | 0;
        HEAP8[i13 >> 0] = i9;
        HEAP8[i7 >> 0] = i9 >>> 8;
        HEAP8[i3 >> 0] = i9 >>> 16;
        HEAP8[i5 >> 0] = i9 >>> 24;
        if ((mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i16 | 0, i13 | 0, 4) | 0) == 4) {
         i2 = HEAP32[i11 >> 2] | 0;
         HEAP8[i13 >> 0] = i12;
         HEAP8[i7 >> 0] = i12 >>> 8;
         if (i12 >>> 0 >= 65536) HEAP16[i13 >> 1] = -1;
         i16 = (mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i2 | 0, i13 | 0, 2) | 0) != 2;
         i3 = i16 << 31 >> 31;
         if ((i12 | 0) != 0 & (i16 ^ 1)) {
          i16 = (mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0, i1 | 0, i12 | 0) | 0) == (i12 | 0);
          i3 = i16 ? i3 : -1;
         }
        } else i3 = -1;
       } else i3 = -1;
      } else i3 = -1;
     } else i3 = -1;
    } else i3 = -1;
   } else i3 = -1;
  } else i3 = -1;
 }
 i2 = (i3 | 0) == 0 & (mftCall_iii(HEAP32[i14 + 20 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0) != 0;
 i1 = HEAP32[i14 + 16564 >> 2] | 0;
 if (i1 | 0) _free(i1);
 _free(i14);
 i16 = i2 ? -1 : i3;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_18PxVehicleDriveTankEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i11 + 312 | 0;
 i20 = i11 + 260 | 0;
 i13 = i11 + 364 | 0;
 i21 = i11 + 16 | 0;
 i14 = i11 + 208 | 0;
 i23 = i11;
 i6 = i11 + 204 | 0;
 i10 = i11 + 48 | 0;
 i9 = i11 + 32 | 0;
 i15 = i11 + 64 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev(i15);
 HEAP32[i23 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 >> 2] = i19;
 HEAP32[i22 + 4 >> 2] = i18;
 i3 = i22 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
 HEAP32[i22 + 20 >> 2] = i17;
 HEAP32[i22 + 24 >> 2] = i16;
 HEAP32[i22 + 28 >> 2] = i1;
 HEAP32[i22 + 32 >> 2] = i4;
 HEAP8[i22 + 36 >> 0] = 1;
 HEAP32[i22 + 40 >> 2] = i5;
 HEAP32[i22 + 44 >> 2] = 0;
 HEAP32[i22 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i15 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i22, i15 + 52 | 0, 4);
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i15 + 80 | 0, 6);
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i23 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
  }
 }
 i23 = HEAP32[i7 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i23 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx5cloth4copyINS0_7SwClothES2_EEvRT_RKT0_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP32[i6 + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i6 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i7 + 44 >> 2];
 HEAP32[i6 + 48 >> 2] = HEAP32[i7 + 48 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i7 + 52 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i7 + 56 >> 2];
 HEAP32[i6 + 60 >> 2] = HEAP32[i7 + 60 >> 2];
 HEAP32[i6 + 64 >> 2] = HEAP32[i7 + 64 >> 2];
 HEAP32[i6 + 68 >> 2] = HEAP32[i7 + 68 >> 2];
 HEAP32[i6 + 72 >> 2] = HEAP32[i7 + 72 >> 2];
 HEAP32[i6 + 76 >> 2] = HEAP32[i7 + 76 >> 2];
 HEAP32[i6 + 80 >> 2] = HEAP32[i7 + 80 >> 2];
 HEAP32[i6 + 84 >> 2] = HEAP32[i7 + 84 >> 2];
 HEAP32[i6 + 88 >> 2] = HEAP32[i7 + 88 >> 2];
 HEAP32[i6 + 92 >> 2] = HEAP32[i7 + 92 >> 2];
 HEAP32[i6 + 96 >> 2] = HEAP32[i7 + 96 >> 2];
 HEAP32[i6 + 100 >> 2] = HEAP32[i7 + 100 >> 2];
 HEAP32[i6 + 104 >> 2] = HEAP32[i7 + 104 >> 2];
 HEAP32[i6 + 108 >> 2] = HEAP32[i7 + 108 >> 2];
 HEAP32[i6 + 112 >> 2] = HEAP32[i7 + 112 >> 2];
 HEAP32[i6 + 116 >> 2] = HEAP32[i7 + 116 >> 2];
 HEAP32[i6 + 120 >> 2] = HEAP32[i7 + 120 >> 2];
 HEAP32[i6 + 124 >> 2] = HEAP32[i7 + 124 >> 2];
 HEAP32[i6 + 128 >> 2] = HEAP32[i7 + 128 >> 2];
 HEAP32[i6 + 132 >> 2] = HEAP32[i7 + 132 >> 2];
 HEAP32[i6 + 136 >> 2] = HEAP32[i7 + 136 >> 2];
 HEAP32[i6 + 140 >> 2] = HEAP32[i7 + 140 >> 2];
 HEAP32[i6 + 144 >> 2] = HEAP32[i7 + 144 >> 2];
 HEAP32[i6 + 148 >> 2] = HEAP32[i7 + 148 >> 2];
 HEAP32[i6 + 152 >> 2] = HEAP32[i7 + 152 >> 2];
 HEAP32[i6 + 156 >> 2] = HEAP32[i7 + 156 >> 2];
 HEAP32[i6 + 160 >> 2] = HEAP32[i7 + 160 >> 2];
 HEAP32[i6 + 164 >> 2] = HEAP32[i7 + 164 >> 2];
 HEAP32[i6 + 168 >> 2] = HEAP32[i7 + 168 >> 2];
 HEAP32[i6 + 172 >> 2] = HEAP32[i7 + 172 >> 2];
 HEAP32[i6 + 176 >> 2] = HEAP32[i7 + 176 >> 2];
 HEAP32[i6 + 180 >> 2] = HEAP32[i7 + 180 >> 2];
 HEAP32[i6 + 184 >> 2] = HEAP32[i7 + 184 >> 2];
 HEAP32[i6 + 188 >> 2] = HEAP32[i7 + 188 >> 2];
 HEAP32[i6 + 192 >> 2] = HEAP32[i7 + 192 >> 2];
 HEAP32[i6 + 196 >> 2] = HEAP32[i7 + 196 >> 2];
 HEAP32[i6 + 200 >> 2] = HEAP32[i7 + 200 >> 2];
 HEAP32[i6 + 204 >> 2] = HEAP32[i7 + 204 >> 2];
 HEAP32[i6 + 208 >> 2] = HEAP32[i7 + 208 >> 2];
 HEAP32[i6 + 212 >> 2] = HEAP32[i7 + 212 >> 2];
 HEAP32[i6 + 216 >> 2] = HEAP32[i7 + 216 >> 2];
 HEAP32[i6 + 220 >> 2] = HEAP32[i7 + 220 >> 2];
 HEAP32[i6 + 224 >> 2] = HEAP32[i7 + 224 >> 2];
 HEAP32[i6 + 228 >> 2] = HEAP32[i7 + 228 >> 2];
 i2 = i6 + 232 | 0;
 if ((i7 | 0) != (i6 | 0)) {
  i5 = i6 + 236 | 0;
  HEAP32[i5 >> 2] = 0;
  i4 = i7 + 236 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i6 + 240 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj(i2, i1);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
  if ((i1 | 0) > 0) {
   i1 = i2;
   i2 = HEAP32[i7 + 232 >> 2] | 0;
   while (1) {
    i10 = i2;
    i9 = HEAP32[i10 + 4 >> 2] | 0;
    i8 = i1;
    HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i8 + 4 >> 2] = i9;
    i1 = i1 + 8 | 0;
    if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i1;
 }
 i8 = i7 + 244 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i6 + 244 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i6 + 264 >> 2] = HEAP32[i7 + 264 >> 2];
 HEAP32[i6 + 268 >> 2] = HEAP32[i7 + 268 >> 2];
 HEAP32[i6 + 296 >> 2] = HEAP32[i7 + 296 >> 2];
 HEAP32[i6 + 300 >> 2] = HEAP32[i7 + 300 >> 2];
 HEAP32[i6 + 304 >> 2] = HEAP32[i7 + 304 >> 2];
 HEAP8[i6 + 440 >> 0] = HEAP8[i7 + 440 >> 0] | 0;
 HEAP32[i6 + 444 >> 2] = HEAP32[i7 + 444 >> 2];
 HEAP32[i6 + 448 >> 2] = HEAP32[i7 + 448 >> 2];
 HEAP32[i6 + 480 >> 2] = HEAP32[i7 + 480 >> 2];
 HEAP32[i6 + 484 >> 2] = HEAP32[i7 + 484 >> 2];
 HEAP32[i6 + 512 >> 2] = HEAP32[i7 + 512 >> 2];
 HEAP32[i6 + 516 >> 2] = HEAP32[i7 + 516 >> 2];
 HEAP32[i6 + 520 >> 2] = HEAP32[i7 + 520 >> 2];
 HEAP32[i6 + 524 >> 2] = HEAP32[i7 + 524 >> 2];
 HEAP32[i6 + 528 >> 2] = HEAP32[i7 + 528 >> 2];
 HEAP32[i6 + 532 >> 2] = HEAP32[i7 + 532 >> 2];
 return;
}

function __ZN5physx27PxHeightFieldRepXSerializer16objectToFileImplEPKNS_13PxHeightFieldEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i3, i6, i14, i13, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 88 | 0;
 i15 = i12 + 56 | 0;
 i5 = i12 + 8 | 0;
 i4 = i12 + 24 | 0;
 i16 = i4 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i1 = i4 + 28 | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i17 = i4 + 8 | 0;
 HEAP32[i17 >> 2] = 1;
 i9 = i4 + 20 | 0;
 HEAPF32[i9 >> 2] = Math_fround(-1.0);
 i8 = i4 + 24 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAP16[i1 >> 1] = 0;
 HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i17 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i9 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0));
 HEAPF32[i8 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0));
 HEAP16[i1 >> 1] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0) | 0;
 i1 = Math_imul(i1 << 2, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0) | 0;
 i8 = i13 + 8 | 0;
 i9 = __ZN5physx19CVariableMemoryPool8allocateEj((HEAP32[i8 >> 2] | 0) + 4 | 0, i1) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i9 | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i5 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx30PxHeightFieldDescGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i5;
 HEAP32[i15 + 4 >> 2] = i14;
 HEAP32[i15 + 8 >> 2] = i4;
 HEAP32[i15 + 12 >> 2] = i13;
 HEAP32[i15 + 16 >> 2] = i6;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEEEEjT_j(i10, i15, 0) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i17 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
  }
 }
 i6 = Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i6 | 0) != 0 & (i4 | 0) != 0) {
  i5 = 0;
  do {
   i1 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
   if ((i5 | 0) != 0 & ((i5 >>> 0) % 6 | 0 | 0) == 0) mftCall_iiii(i1 | 0, i13 | 0, gb + 673156 | 0, 4) | 0; else mftCall_iiii(i1 | 0, i13 | 0, gb + 1086395 | 0, 1) | 0;
   i1 = i4 + (i5 << 2) | 0;
   i1 = HEAPU8[i4 + (i5 << 2) + 2 >> 0] << 16 | HEAPU8[i4 + (i5 << 2) + 3 >> 0] << 24 | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
   i2 = i10;
   i3 = i2 + 128 | 0;
   do {
    HEAP8[i2 >> 0] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i3 | 0));
   HEAP32[i11 >> 2] = i1;
   __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 1084495 | 0, i11) | 0;
   if (HEAP8[i10 >> 0] | 0) {
    i17 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
    mftCall_iiii(i17 | 0, i13 | 0, i10 | 0, _strlen(i10) | 0) | 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, i13 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, gb + 752413 | 0, HEAP32[i13 + 20 >> 2] | 0);
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
 }
 if (!i9) {
  STACKTOP = i12;
  return;
 }
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i8 >> 2] | 0) + 4 | 0, i9 + -8 | 0, HEAP32[i9 + -4 >> 2] | 0);
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i16, i4, i1) {
 i16 = i16 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i3 = i15 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i11 = i16 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i4 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 HEAP32[i14 >> 2] = 0;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i4, i2, i14, 1);
 i13 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i9 = HEAP32[gb + 37304 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 11; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 11; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 11) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L11;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 24; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 24; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 24) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14DetailRenderer18ReloadDirtyDetailsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 i4 = i7 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i9 = i1 + 128 | 0;
 i8 = i9 + 36 | 0;
 i9 = i9 + 4 | 0;
 i5 = i7 + 64 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 68 | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  i4 = i2;
  while (1) {
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    }
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   i4 = (Math_imul(HEAP32[i8 >> 2] | 0, HEAP32[i4 + 36 >> 2] | 0) | 0) + (HEAP32[i4 + 32 >> 2] | 0) | 0;
   if (HEAP8[(HEAP32[i9 >> 2] | 0) + (i4 * 52 | 0) + 24 >> 0] | 0) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i5, i10) | 0;
   }
   if ((i2 | 0) == (i6 | 0)) break; else {
    i1 = i2;
    i4 = i2;
   }
  }
 }
 i5 = i7 + 76 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 80 | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  i4 = i2;
  while (1) {
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    }
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   i4 = (Math_imul(HEAP32[i8 >> 2] | 0, HEAP32[i4 + 36 >> 2] | 0) | 0) + (HEAP32[i4 + 32 >> 2] | 0) | 0;
   if (HEAP8[(HEAP32[i9 >> 2] | 0) + (i4 * 52 | 0) + 24 >> 0] | 0) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i5, i10) | 0;
   }
   if ((i2 | 0) == (i6 | 0)) break; else {
    i1 = i2;
    i4 = i2;
   }
  }
 }
 i6 = i7 + 88 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i7 + 92 | 0;
 i2 = i1;
 if ((i2 | 0) == (i5 | 0)) {
  STACKTOP = i12;
  return;
 }
 i4 = i1;
 while (1) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) {
   i3 = i4;
   while (1) {
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break; else i3 = i1;
   }
  } else while (1) {
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) break; else i1 = i3;
  }
  i7 = (Math_imul(HEAP32[i8 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0) + (HEAP32[i2 + 32 >> 2] | 0) | 0;
  if (HEAP8[(HEAP32[i9 >> 2] | 0) + (i7 * 52 | 0) + 24 >> 0] | 0) {
   HEAP32[i11 >> 2] = i4;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i6, i10) | 0;
  }
  if ((i1 | 0) == (i5 | 0)) break; else {
   i4 = i1;
   i2 = i1;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZNK11LightProbes14LightProbeData33GetLightProbeInterpolationWeightsERK8Vector3fRiR8Vector4fRf(i24, i25, i26, i27, i28) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i32;
 i30 = HEAP32[i24 + 12 >> 2] | 0;
 i1 = HEAP32[i26 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 | 0) < (i30 | 0))) {
  HEAP32[i26 >> 2] = 0;
  i1 = 0;
 }
 i13 = i24 + 20 | 0;
 if ((i30 | 0) <= 0) {
  STACKTOP = i32;
  return;
 }
 i14 = i24 + 72 | 0;
 i15 = i24 + 60 | 0;
 i16 = i29 + 4 | 0;
 i17 = i29 + 8 | 0;
 i18 = i29 + 12 | 0;
 i19 = i25 + 4 | 0;
 i20 = i25 + 8 | 0;
 i21 = i27 + 4 | 0;
 i22 = i27 + 8 | 0;
 i23 = i27 + 12 | 0;
 i11 = 0;
 i12 = -1;
 i10 = -1;
 while (1) {
  i9 = HEAP32[i24 >> 2] | 0;
  i7 = i9 + (i1 * 80 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i14 >> 2] | 0;
  if (i8 >>> 0 > i2 >>> 0) HEAP32[i29 >> 2] = (HEAP32[i15 >> 2] | 0) + (i2 * 12 | 0);
  i2 = HEAP32[i9 + (i1 * 80 | 0) + 4 >> 2] | 0;
  if (i8 >>> 0 > i2 >>> 0) HEAP32[i16 >> 2] = (HEAP32[i15 >> 2] | 0) + (i2 * 12 | 0);
  i2 = HEAP32[i9 + (i1 * 80 | 0) + 8 >> 2] | 0;
  if (i8 >>> 0 > i2 >>> 0) HEAP32[i17 >> 2] = (HEAP32[i15 >> 2] | 0) + (i2 * 12 | 0);
  i2 = HEAP32[i9 + (i1 * 80 | 0) + 12 >> 2] | 0;
  if (i8 >>> 0 > i2 >>> 0) HEAP32[i18 >> 2] = (HEAP32[i15 >> 2] | 0) + (i2 * 12 | 0);
  if ((i2 | 0) > -1) {
   i8 = HEAP32[i18 >> 2] | 0;
   f33 = Math_fround(HEAPF32[i25 >> 2]);
   f33 = Math_fround(f33 - Math_fround(HEAPF32[i8 >> 2]));
   f4 = Math_fround(HEAPF32[i19 >> 2]);
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i8 + 4 >> 2]));
   f3 = Math_fround(HEAPF32[i20 >> 2]);
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 8 >> 2]));
   f5 = Math_fround(f33 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 32 >> 2]));
   f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 44 >> 2])));
   f5 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 56 >> 2])));
   f6 = Math_fround(f33 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 36 >> 2]));
   f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 48 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 60 >> 2])));
   f33 = Math_fround(f33 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 40 >> 2]));
   f4 = Math_fround(f33 + Math_fround(f4 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 52 >> 2])));
   f3 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i9 + (i1 * 80 | 0) + 64 >> 2])));
   HEAPF32[i27 >> 2] = f5;
   HEAPF32[i21 >> 2] = f6;
   HEAPF32[i22 >> 2] = f3;
   f4 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f5) - f6) - f3);
   HEAPF32[i23 >> 2] = f4;
  } else {
   __Z37GetBarycentricCoordinatesForOuterCellPPK8Vector3fRK13dynamic_arrayIS_Lj4EERS0_RK11TetrahedronR8Vector4fRf(i29, i13, i25, i7, i27, i28);
   f5 = Math_fround(HEAPF32[i27 >> 2]);
   f6 = Math_fround(HEAPF32[i21 >> 2]);
   f3 = Math_fround(HEAPF32[i22 >> 2]);
   f4 = Math_fround(HEAPF32[i23 >> 2]);
  }
  if (!(!(f5 >= Math_fround(0.0)) | !(f6 >= Math_fround(0.0)) | !(f3 >= Math_fround(0.0)) | !(f4 >= Math_fround(0.0)))) break;
  i2 = HEAP32[i26 >> 2] | 0;
  if ((i2 | 0) == (i10 | 0)) break;
  do if (f5 < f6 & f5 < f3 & f5 < f4) {
   i1 = HEAP32[i9 + (i1 * 80 | 0) + 16 >> 2] | 0;
   HEAP32[i26 >> 2] = i1;
  } else {
   if (f6 < f3 & f6 < f4) {
    i1 = HEAP32[i9 + (i1 * 80 | 0) + 20 >> 2] | 0;
    HEAP32[i26 >> 2] = i1;
    break;
   }
   if (f3 < f4) {
    i1 = HEAP32[i9 + (i1 * 80 | 0) + 24 >> 2] | 0;
    HEAP32[i26 >> 2] = i1;
    break;
   } else {
    i1 = HEAP32[i9 + (i1 * 80 | 0) + 28 >> 2] | 0;
    HEAP32[i26 >> 2] = i1;
    break;
   }
  } while (0);
  i11 = i11 + 1 | 0;
  if ((i11 | 0) >= (i30 | 0)) {
   i31 = 27;
   break;
  } else {
   i10 = i12;
   i12 = i2;
  }
 }
 if ((i31 | 0) == 27) {
  STACKTOP = i32;
  return;
 }
 STACKTOP = i32;
 return;
}

function __ZN7mecanim9animation4Clip8TransferI14SafeBinaryReadEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i7 = i11 + 4 | 0;
 i6 = i11;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898912 | 0, gb + 898927 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i8 + 4;
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i7 + 8 >> 2] = i1;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1041891 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
   i4 = i8 + 8 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898940 | 0, HEAP32[gb + 37304 >> 2] | 0, i9, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i10 + 16 | 0;
     i3 = HEAP32[i10 + 20 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i5 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i5 = 14; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i5 | 0) == 14) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898951 | 0, gb + 898963 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7mecanim9animation9DenseClip8TransferI14SafeBinaryReadEEvRT_(i2, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 898973 | 0, gb + 898988 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i8 + 40;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i7 + 8 >> 2] = i1;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 1041891 | 0, HEAP32[gb + 37316 >> 2] | 0, i9, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i10, i7, 0); else {
     i1 = HEAP32[i9 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i10);
   }
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i2 = i8 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 899001 | 0, gb + 905830 | 0, i9, 1) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i9 = i2;
   i1 = i1 | 0 ? i1 - i9 | 0 : 0;
   HEAP32[i2 >> 2] = i1;
   i2 = i9;
  }
  __ZN14SafeBinaryRead8TransferIN7mecanim18ValueArrayConstantEEEvRT_PKc17TransferMetaFlags(i10, i1 + i2 | 0, gb + 1041891 | 0, 0);
 } else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN14PhysicsManager15ProcessContactsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i25 + 4 | 0;
 i1 = i25;
 if ((HEAP16[gb + 1452440 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452440 | 0, i22);
  i24 = gb + 1452440 | 0;
 } else i24 = 0;
 i21 = i2 + 80 | 0;
 i23 = i2 + 84 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i20 = HEAP32[i21 >> 2] | 0;
 i5 = i20;
 if ((i1 | 0) != (i20 | 0)) {
  i20 = i22 + 8 | 0;
  i9 = i22 + 4 | 0;
  i10 = i22 + 8 | 0;
  i11 = i22 + 4 | 0;
  i12 = i22 + 8 | 0;
  i13 = i22 + 4 | 0;
  i14 = i22 + 8 | 0;
  i15 = i22 + 4 | 0;
  i16 = i22 + 8 | 0;
  i17 = i22 + 4 | 0;
  i18 = i22 + 8 | 0;
  i19 = i22 + 4 | 0;
  i8 = 0;
  do {
   i2 = i5 + (i8 * 72 | 0) | 0;
   i3 = i5 + (i8 * 72 | 0) + 8 | 0;
   i4 = i5 + (i8 * 72 | 0) + 12 | 0;
   i6 = i5 + (i8 * 72 | 0) + 16 | 0;
   i7 = i5 + (i8 * 72 | 0) + 20 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 & 4) {
    i1 = i5 + (i8 * 72 | 0) + 4 | 0;
    HEAP8[i1 >> 0] = 0;
    i26 = HEAP32[i3 >> 2] | 0;
    i26 = (i26 | 0) == 0 ? HEAP32[i6 >> 2] | 0 : i26;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i16 >> 2] = 0;
    HEAP32[i17 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i26, gb + 1104796 | 0, i22);
    HEAP8[i1 >> 0] = 1;
    i1 = HEAP32[i4 >> 2] | 0;
    i1 = (i1 | 0) == 0 ? HEAP32[i7 >> 2] | 0 : i1;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i18 >> 2] = 0;
    HEAP32[i19 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1104796 | 0, i22);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   if (i1 & 16) {
    i1 = i5 + (i8 * 72 | 0) + 4 | 0;
    HEAP8[i1 >> 0] = 0;
    i26 = HEAP32[i3 >> 2] | 0;
    i26 = (i26 | 0) == 0 ? HEAP32[i6 >> 2] | 0 : i26;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i13 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i26, gb + 1104816 | 0, i22);
    HEAP8[i1 >> 0] = 1;
    i1 = HEAP32[i4 >> 2] | 0;
    i1 = (i1 | 0) == 0 ? HEAP32[i7 >> 2] | 0 : i1;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i14 >> 2] = 0;
    HEAP32[i15 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1104816 | 0, i22);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   if (i1 & 8 | 0) {
    i26 = i5 + (i8 * 72 | 0) + 4 | 0;
    HEAP8[i26 >> 0] = 0;
    i5 = HEAP32[i3 >> 2] | 0;
    i6 = (i5 | 0) == 0 ? HEAP32[i6 >> 2] | 0 : i5;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i9 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i6, gb + 1104836 | 0, i22);
    HEAP8[i26 >> 0] = 1;
    i26 = HEAP32[i4 >> 2] | 0;
    i26 = (i26 | 0) == 0 ? HEAP32[i7 >> 2] | 0 : i26;
    HEAP32[i22 >> 2] = gb + 29512;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i11 >> 2] = i2;
    __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i26, gb + 1104836 | 0, i22);
   }
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i23 >> 2] | 0;
   i26 = HEAP32[i21 >> 2] | 0;
   i5 = i26;
  } while (i8 >>> 0 < ((i1 - i26 | 0) / 72 | 0) >>> 0);
 }
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = i1 + -72 | 0;
  HEAP32[i23 >> 2] = i2;
  i4 = i1 + -12 | 0;
  i3 = i1 + -4 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i1 = i2; else {
   i1 = HEAP32[i1 + -8 >> 2] | 0;
   i26 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
   i22 = HEAP32[i1 >> 2] | 0;
   HEAP32[i22 + 4 >> 2] = HEAP32[i26 >> 2];
   HEAP32[HEAP32[i26 >> 2] >> 2] = i22;
   HEAP32[i3 >> 2] = 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    do {
     i26 = i1;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     __ZdlPv(i26);
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i23 >> 2] | 0;
   }
  }
 } while ((i1 | 0) != (i5 | 0));
 if (!i24) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Gu35checkOverlapCapsule_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 20 | 0;
 i6 = i4;
 f20 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f20 = Math_fround(f20 * Math_fround(-2.0));
 f12 = Math_fround(f12 * Math_fround(-2.0));
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(-2.0));
 f18 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(f20 * f7);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f12 * f13));
 f22 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f8 * f22));
 f19 = Math_fround(Math_fround(f7 * f15) + Math_fround(Math_fround(f20 * f16) - Math_fround(f18 * Math_fround(Math_fround(f8 * f13) - Math_fround(f12 * f22)))));
 f17 = Math_fround(Math_fround(f13 * f15) + Math_fround(Math_fround(f12 * f16) - Math_fround(f18 * Math_fround(Math_fround(f20 * f22) - Math_fround(f8 * f7)))));
 f15 = Math_fround(Math_fround(Math_fround(f8 * f16) - Math_fround(f18 * Math_fround(Math_fround(f12 * f7) - Math_fround(f20 * f13)))) + Math_fround(f22 * f15));
 f20 = Math_fround(-f7);
 f12 = Math_fround(-f13);
 f16 = Math_fround(-f22);
 f7 = Math_fround(f20 - f7);
 f13 = Math_fround(f12 - f13);
 f22 = Math_fround(f16 - f22);
 f8 = Math_fround(f18 * f7);
 f11 = Math_fround(f18 * f13);
 f18 = Math_fround(f18 * f22);
 f10 = Math_fround(f13 * f20);
 f9 = Math_fround(f22 * f20);
 f13 = Math_fround(f13 * f12);
 f12 = Math_fround(f22 * f12);
 f16 = Math_fround(f22 * f16);
 f22 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f16);
 f21 = Math_fround(f10 + f18);
 f14 = Math_fround(f9 - f11);
 f18 = Math_fround(f10 - f18);
 f20 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f20));
 f16 = Math_fround(f20 - f16);
 f7 = Math_fround(f8 + f12);
 f9 = Math_fround(f11 + f9);
 f8 = Math_fround(f12 - f8);
 f13 = Math_fround(f20 - f13);
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f20 * f22);
 f11 = Math_fround(f20 * f21);
 f20 = Math_fround(f20 * f14);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f10 * f18));
 f11 = Math_fround(f11 + Math_fround(f10 * f16));
 f10 = Math_fround(f20 + Math_fround(f10 * f7));
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f19 + Math_fround(Math_fround(f20 * f9) + f12));
 f11 = Math_fround(f17 + Math_fround(Math_fround(f20 * f8) + f11));
 f10 = Math_fround(f15 + Math_fround(Math_fround(f13 * f20) + f10));
 f20 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f22 = Math_fround(f22 * f20);
 f21 = Math_fround(f21 * f20);
 f20 = Math_fround(f14 * f20);
 f14 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f18 = Math_fround(f22 + Math_fround(f18 * f14));
 f16 = Math_fround(f21 + Math_fround(f16 * f14));
 f14 = Math_fround(f20 + Math_fround(f7 * f14));
 f7 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f9 = Math_fround(f19 + Math_fround(f18 + Math_fround(f9 * f7)));
 f8 = Math_fround(f17 + Math_fround(f16 + Math_fround(f8 * f7)));
 f7 = Math_fround(f15 + Math_fround(f14 + Math_fround(f13 * f7)));
 i3 = HEAP32[i3 + 24 >> 2] | 0;
 HEAPF32[i5 >> 2] = f12;
 HEAPF32[i5 + 4 >> 2] = f11;
 HEAPF32[i5 + 8 >> 2] = f10;
 HEAPF32[i5 + 12 >> 2] = f9;
 HEAPF32[i5 + 16 >> 2] = f8;
 HEAPF32[i5 + 20 >> 2] = f7;
 HEAP32[i5 + 24 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 16 >> 2] = i1;
 HEAPF32[i6 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 12 >> 2]));
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 16 >> 2]));
 i3 = __ZN5physx2Gu27intersectHeightFieldCapsuleERKNS0_15HeightFieldUtilERKNS0_7CapsuleE(i6, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i10, i8, i1, i9, i2) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, f12 = f0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i5 | 0, i3 | 0, 88, (i4 ? gb + 734477 | 0 : gb + 837976 | 0) | 0, gb + 734589 | 0, 40) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0) | 0;
 HEAP16[i4 + 4 >> 1] = 261;
 HEAP16[i4 + 6 >> 1] = 3;
 i5 = i4 + 12 | 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 86848 + 8;
 HEAP32[i5 >> 2] = gb + 86848 + 256;
 HEAP8[i4 + 84 >> 0] = 1;
 HEAP8[i4 + 85 >> 0] = 1;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 16 | 0, 384, gb + 734589 | 0, 57) | 0;
 HEAP32[i4 + 80 >> 2] = i7;
 __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i4, i7, i8, i1, i9, i2);
 i1 = i7 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i7 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 124 >> 2] = Math_fround(.5);
 i1 = i7 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i7 + 136 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 140 >> 2] = Math_fround(1.57079637);
 HEAPF32[i7 + 144 >> 2] = Math_fround(-1.57079637);
 HEAPF32[i7 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 152 >> 2] = Math_fround(.5);
 i1 = i7 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i7 + 164 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 168 >> 2] = Math_fround(1.57079637);
 HEAPF32[i7 + 172 >> 2] = Math_fround(1.57079637);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 f12 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.00999999977));
 i1 = i7 + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAPF32[i7 + 112 >> 2] = f12;
 HEAPF32[i7 + 116 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 372 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(9.99999997e-07));
 HEAP32[i7 + 176 >> 2] = 0;
 HEAP32[i7 + 180 >> 2] = 0;
 HEAP32[i7 + 184 >> 2] = 2139095039;
 HEAP32[i7 + 188 >> 2] = 0;
 HEAP32[i7 + 192 >> 2] = 0;
 HEAP32[i7 + 196 >> 2] = 0;
 HEAP32[i7 + 200 >> 2] = 2139095039;
 HEAP32[i7 + 204 >> 2] = 0;
 HEAP32[i7 + 208 >> 2] = 0;
 HEAP32[i7 + 212 >> 2] = 0;
 HEAP32[i7 + 216 >> 2] = 2139095039;
 HEAP32[i7 + 220 >> 2] = 0;
 HEAP32[i7 + 224 >> 2] = 0;
 HEAP32[i7 + 228 >> 2] = 0;
 HEAP32[i7 + 232 >> 2] = 2139095039;
 HEAP32[i7 + 236 >> 2] = 0;
 HEAP32[i7 + 240 >> 2] = 0;
 HEAP32[i7 + 244 >> 2] = 0;
 HEAP32[i7 + 248 >> 2] = 2139095039;
 HEAP32[i7 + 252 >> 2] = 0;
 HEAP32[i7 + 256 >> 2] = 0;
 HEAP32[i7 + 260 >> 2] = 0;
 HEAP32[i7 + 264 >> 2] = 2139095039;
 i1 = i7 + 268 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i7 + 284 >> 2] = 1065353216;
 i1 = i7 + 376 | 0;
 i2 = i7 + 288 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0e10);
 HEAPF32[i7 + 380 >> 2] = Math_fround(3.14159274);
 i13 = mftCall_iiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0, i8 | 0, i9 | 0, i5 | 0, gb + 87140 | 0, 384) | 0;
 HEAP32[i6 >> 2] = i13;
 if (i13 | 0) {
  i13 = i4;
  STACKTOP = i11;
  return i13 | 0;
 }
 if (!i4) {
  i13 = 0;
  STACKTOP = i11;
  return i13 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 i13 = 0;
 STACKTOP = i11;
 return i13 | 0;
}

function __ZNK9Heightmap21GetInterpolatedNormalEff(i7, i1, f2, f3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f4 = f0, i5 = 0, f6 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i8 + 48 | 0;
 i17 = i8 + 36 | 0;
 i18 = i8 + 24 | 0;
 i5 = i8 + 12 | 0;
 i16 = i8;
 i23 = i1 + 72 | 0;
 i24 = HEAP32[i23 >> 2] | 0;
 f6 = Math_fround(Math_fround(i24 + -1 | 0) * f2);
 i22 = i1 + 76 | 0;
 i25 = HEAP32[i22 >> 2] | 0;
 f9 = Math_fround(Math_fround(i25 + -1 | 0) * f3);
 i20 = ~~f6;
 i19 = ~~f9;
 i27 = i1 + 88 | 0;
 i28 = i1 + 92 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) / Math_fround(32766.0));
 i26 = i1 + 96 | 0;
 i29 = HEAP32[i26 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
 HEAPF32[i21 + 4 >> 2] = f12;
 HEAP32[i21 + 8 >> 2] = i29;
 i1 = i1 + 4 | 0;
 __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i17, i20, i19, i24, i25, i1, i21);
 i25 = i20 + 1 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) / Math_fround(32766.0));
 i24 = HEAP32[i26 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
 HEAPF32[i21 + 4 >> 2] = f12;
 HEAP32[i21 + 8 >> 2] = i24;
 __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i18, i25, i19, HEAP32[i23 >> 2] | 0, HEAP32[i22 >> 2] | 0, i1, i21);
 i24 = i19 + 1 | 0;
 f12 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) / Math_fround(32766.0));
 i29 = HEAP32[i26 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
 HEAPF32[i21 + 4 >> 2] = f12;
 HEAP32[i21 + 8 >> 2] = i29;
 __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i5, i20, i24, HEAP32[i23 >> 2] | 0, HEAP32[i22 >> 2] | 0, i1, i21);
 f12 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) / Math_fround(32766.0));
 i26 = HEAP32[i26 >> 2] | 0;
 HEAP32[i21 >> 2] = HEAP32[i27 >> 2];
 HEAPF32[i21 + 4 >> 2] = f12;
 HEAP32[i21 + 8 >> 2] = i26;
 __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i16, i25, i24, HEAP32[i23 >> 2] | 0, HEAP32[i22 >> 2] | 0, i1, i21);
 f6 = Math_fround(f6 - Math_fround(i20 | 0));
 f9 = Math_fround(f9 - Math_fround(i19 | 0));
 f12 = Math_fround(f6 * Math_fround(HEAPF32[i18 >> 2]));
 f14 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 4 >> 2]));
 f10 = Math_fround(f6 * Math_fround(HEAPF32[i18 + 8 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - f6);
 f15 = Math_fround(f4 * Math_fround(HEAPF32[i17 >> 2]));
 f13 = Math_fround(f4 * Math_fround(HEAPF32[i17 + 4 >> 2]));
 f15 = Math_fround(f12 + f15);
 f13 = Math_fround(f14 + f13);
 f10 = Math_fround(f10 + Math_fround(f4 * Math_fround(HEAPF32[i17 + 8 >> 2])));
 f14 = Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2]));
 f12 = Math_fround(f6 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f2 = Math_fround(f4 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 4 >> 2]));
 f11 = Math_fround(Math_fround(1.0) - f9);
 f2 = Math_fround(Math_fround(f11 * f15) + Math_fround(f9 * Math_fround(f14 + f2)));
 f3 = Math_fround(Math_fround(f11 * f13) + Math_fround(f9 * Math_fround(f12 + f3)));
 f4 = Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 8 >> 2])))));
 HEAPF32[i7 >> 2] = f2;
 i1 = i7 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 i5 = i7 + 8 | 0;
 HEAPF32[i5 >> 2] = f4;
 f6 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4));
 if (f6 == Math_fround(0.0)) {
  f15 = f6;
  f13 = Math_fround(f2 * f15);
  f14 = Math_fround(f3 * f15);
  f15 = Math_fround(f4 * f15);
  HEAPF32[i7 >> 2] = f13;
  HEAPF32[i1 >> 2] = f14;
  HEAPF32[i5 >> 2] = f15;
  STACKTOP = i8;
  return;
 }
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6))));
 f13 = Math_fround(f2 * f15);
 f14 = Math_fround(f3 * f15);
 f15 = Math_fround(f4 * f15);
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i5 >> 2] = f15;
 STACKTOP = i8;
 return;
}

function __Z22RandomBarycentricCoordR5RandN(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0;
 i28 = HEAP32[i2 >> 2] | 0;
 i47 = i2 + 4 | 0;
 i15 = HEAP32[i47 >> 2] | 0;
 i45 = i2 + 8 | 0;
 i16 = HEAP32[i45 >> 2] | 0;
 i43 = i2 + 12 | 0;
 i17 = HEAP32[i43 >> 2] | 0;
 i28 = i28 << 11 ^ i28;
 i15 = i15 << 11 ^ i15;
 i16 = i16 << 11 ^ i16;
 i17 = i17 << 11 ^ i17;
 i41 = i2 + 16 | 0;
 i30 = HEAP32[i41 >> 2] | 0;
 i39 = i2 + 20 | 0;
 i27 = HEAP32[i39 >> 2] | 0;
 i37 = i2 + 24 | 0;
 i25 = HEAP32[i37 >> 2] | 0;
 i35 = i2 + 28 | 0;
 i23 = HEAP32[i35 >> 2] | 0;
 i34 = i2 + 32 | 0;
 i33 = i2 + 36 | 0;
 i48 = HEAP32[i33 >> 2] | 0;
 i32 = i2 + 40 | 0;
 i46 = HEAP32[i32 >> 2] | 0;
 i31 = i2 + 44 | 0;
 i44 = HEAP32[i31 >> 2] | 0;
 i21 = i2 + 48 | 0;
 i42 = HEAP32[i21 >> 2] | 0;
 i20 = i2 + 52 | 0;
 i40 = HEAP32[i20 >> 2] | 0;
 i19 = i2 + 56 | 0;
 i38 = HEAP32[i19 >> 2] | 0;
 i18 = i2 + 60 | 0;
 i36 = HEAP32[i18 >> 2] | 0;
 i28 = i28 >>> 8 ^ i28 ^ i42;
 i29 = i28 ^ i42 >>> 19;
 i15 = i15 >>> 8 ^ i15 ^ i40;
 i26 = i15 ^ i40 >>> 19;
 i16 = i16 >>> 8 ^ i16 ^ i38;
 i24 = i16 ^ i38 >>> 19;
 i17 = i17 >>> 8 ^ i17 ^ i36;
 i22 = i17 ^ i36 >>> 19;
 f14 = Math_fround(Math_fround(i29 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f13 = Math_fround(Math_fround(i26 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(i24 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f11 = Math_fround(Math_fround(i22 & 8388607 | 0) * Math_fround(1.19209304e-07));
 i30 = i30 << 11 ^ i30;
 i27 = i27 << 11 ^ i27;
 i25 = i25 << 11 ^ i25;
 i23 = i23 << 11 ^ i23;
 HEAP32[i2 >> 2] = HEAP32[i34 >> 2];
 HEAP32[i47 >> 2] = i48;
 HEAP32[i45 >> 2] = i46;
 HEAP32[i43 >> 2] = i44;
 HEAP32[i41 >> 2] = i42;
 HEAP32[i39 >> 2] = i40;
 HEAP32[i37 >> 2] = i38;
 HEAP32[i35 >> 2] = i36;
 HEAP32[i34 >> 2] = i29;
 HEAP32[i33 >> 2] = i26;
 HEAP32[i32 >> 2] = i24;
 HEAP32[i31 >> 2] = i22;
 i2 = i30 >>> 8 ^ i30 ^ i29 ^ i28 >>> 19;
 i15 = i27 >>> 8 ^ i27 ^ i26 ^ i15 >>> 19;
 i16 = i25 >>> 8 ^ i25 ^ i24 ^ i16 >>> 19;
 i17 = i23 >>> 8 ^ i23 ^ i22 ^ i17 >>> 19;
 HEAP32[i21 >> 2] = i2;
 HEAP32[i20 >> 2] = i15;
 HEAP32[i19 >> 2] = i16;
 HEAP32[i18 >> 2] = i17;
 f10 = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(i15 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(i16 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(i17 & 8388607 | 0) * Math_fround(1.19209304e-07));
 i17 = Math_fround(f14 + f10) > Math_fround(1.0);
 i16 = Math_fround(f13 + f9) > Math_fround(1.0);
 i15 = Math_fround(f12 + f8) > Math_fround(1.0);
 i2 = Math_fround(f11 + f7) > Math_fround(1.0);
 f6 = Math_fround(Math_fround(1.0) - f14);
 f5 = Math_fround(Math_fround(1.0) - f13);
 f4 = Math_fround(Math_fround(1.0) - f12);
 f3 = Math_fround(Math_fround(1.0) - f11);
 f14 = i17 ? f6 : f14;
 f13 = i16 ? f5 : f13;
 f12 = i15 ? f4 : f12;
 f11 = i2 ? f3 : f11;
 f3 = Math_fround(Math_fround(1.0) - f10);
 f4 = Math_fround(Math_fround(1.0) - f9);
 f5 = Math_fround(Math_fround(1.0) - f8);
 f6 = Math_fround(Math_fround(1.0) - f7);
 f10 = i17 ? f3 : f10;
 f9 = i16 ? f4 : f9;
 f8 = i15 ? f5 : f8;
 f7 = i2 ? f6 : f7;
 f6 = Math_fround(Math_fround(Math_fround(1.0) - f14) - f10);
 f5 = Math_fround(Math_fround(Math_fround(1.0) - f13) - f9);
 f4 = Math_fround(Math_fround(Math_fround(1.0) - f12) - f8);
 f3 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f7);
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = f11;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 28 >> 2] = f7;
 HEAPF32[i1 + 32 >> 2] = f6;
 HEAPF32[i1 + 36 >> 2] = f5;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAPF32[i1 + 44 >> 2] = f3;
 return;
}

function runPostSets32() {
 HEAP32[gb + 44164 >> 2] = fb + 82;
 HEAP32[gb + 44176 >> 2] = fb + 374;
 HEAP32[gb + 44180 >> 2] = fb + 375;
 HEAP32[gb + 44184 >> 2] = fb + 376;
 HEAP32[gb + 44188 >> 2] = fb + 353;
 HEAP32[gb + 44192 >> 2] = fb + 16;
 HEAP32[gb + 44196 >> 2] = fb + 377;
 HEAP32[gb + 44200 >> 2] = fb + 378;
 HEAP32[gb + 44204 >> 2] = fb + 379;
 HEAP32[gb + 44208 >> 2] = fb + 213;
 HEAP32[gb + 44212 >> 2] = fb + 103;
 HEAP32[gb + 44216 >> 2] = fb + 101;
 HEAP32[gb + 44220 >> 2] = fb + 62;
 HEAP32[gb + 44224 >> 2] = fb + 28;
 HEAP32[gb + 44228 >> 2] = fb + 63;
 HEAP32[gb + 44232 >> 2] = fb + 29;
 HEAP32[gb + 44236 >> 2] = fb + 34;
 HEAP32[gb + 44240 >> 2] = fb + 354;
 HEAP32[gb + 44244 >> 2] = fb + 355;
 HEAP32[gb + 44248 >> 2] = fb + 356;
 HEAP32[gb + 44252 >> 2] = fb + 357;
 HEAP32[gb + 44256 >> 2] = fb + 358;
 HEAP32[gb + 44260 >> 2] = fb + 359;
 HEAP32[gb + 44264 >> 2] = fb + 36;
 HEAP32[gb + 44268 >> 2] = fb + 214;
 HEAP32[gb + 44272 >> 2] = fb + 360;
 HEAP32[gb + 44276 >> 2] = fb + 94;
 HEAP32[gb + 44280 >> 2] = fb + 361;
 HEAP32[gb + 44284 >> 2] = fb + 105;
 HEAP32[gb + 44288 >> 2] = fb + 106;
 HEAP32[gb + 44292 >> 2] = fb + 110;
 HEAP32[gb + 44296 >> 2] = (HEAP32[gb + 44296 >> 2] | 0) + (gb + 406053 | 0);
 HEAP32[gb + 44308 >> 2] = fb + 380;
 HEAP32[gb + 44312 >> 2] = fb + 381;
 HEAP32[gb + 44316 >> 2] = fb + 382;
 HEAP32[gb + 44320 >> 2] = fb + 362;
 HEAP32[gb + 44324 >> 2] = fb + 16;
 HEAP32[gb + 44328 >> 2] = fb + 17;
 HEAP32[gb + 44332 >> 2] = fb + 18;
 HEAP32[gb + 44336 >> 2] = fb + 19;
 HEAP32[gb + 44340 >> 2] = fb + 215;
 HEAP32[gb + 44344 >> 2] = fb + 31;
 HEAP32[gb + 44348 >> 2] = fb + 27;
 HEAP32[gb + 44352 >> 2] = fb + 32;
 HEAP32[gb + 44356 >> 2] = fb + 28;
 HEAP32[gb + 44360 >> 2] = fb + 216;
 HEAP32[gb + 44364 >> 2] = fb + 29;
 HEAP32[gb + 44368 >> 2] = fb + 34;
 HEAP32[gb + 44372 >> 2] = fb + 363;
 HEAP32[gb + 44376 >> 2] = fb + 364;
 HEAP32[gb + 44380 >> 2] = fb + 365;
 HEAP32[gb + 44384 >> 2] = fb + 366;
 HEAP32[gb + 44388 >> 2] = fb + 367;
 HEAP32[gb + 44392 >> 2] = fb + 368;
 HEAP32[gb + 44396 >> 2] = fb + 36;
 HEAP32[gb + 44400 >> 2] = fb + 383;
 HEAP32[gb + 44404 >> 2] = fb + 35;
 HEAP32[gb + 44408 >> 2] = fb + 36;
 HEAP32[gb + 44412 >> 2] = fb + 37;
 HEAP32[gb + 44416 >> 2] = fb + 37;
 HEAP32[gb + 44420 >> 2] = fb + 38;
 HEAP32[gb + 44424 >> 2] = fb + 39;
 HEAP32[gb + 44428 >> 2] = fb + 217;
 HEAP32[gb + 44432 >> 2] = fb + 218;
 HEAP32[gb + 44436 >> 2] = fb + 42;
 HEAP32[gb + 44440 >> 2] = fb + 43;
 HEAP32[gb + 44444 >> 2] = fb + 219;
 HEAP32[gb + 44448 >> 2] = fb + 220;
 HEAP32[gb + 44452 >> 2] = fb + 221;
 HEAP32[gb + 44456 >> 2] = fb + 222;
 HEAP32[gb + 44460 >> 2] = fb + 223;
 HEAP32[gb + 44464 >> 2] = fb + 224;
 HEAP32[gb + 44468 >> 2] = fb + 369;
 HEAP32[gb + 44472 >> 2] = fb + 384;
 HEAP32[gb + 44476 >> 2] = fb + 8;
 HEAP32[gb + 44584 >> 2] = (HEAP32[gb + 44584 >> 2] | 0) + (gb + 585672 | 0);
 HEAP32[gb + 44588 >> 2] = (HEAP32[gb + 44588 >> 2] | 0) + (gb + 1046296 | 0);
 HEAP32[gb + 44592 >> 2] = (HEAP32[gb + 44592 >> 2] | 0) + (gb + 429151 | 0);
 HEAP32[gb + 44596 >> 2] = (HEAP32[gb + 44596 >> 2] | 0) + (gb + 429490 | 0);
 HEAP32[gb + 44600 >> 2] = (HEAP32[gb + 44600 >> 2] | 0) + (gb + 1048432 | 0);
 HEAP32[gb + 44604 >> 2] = (HEAP32[gb + 44604 >> 2] | 0) + (gb + 421148 | 0);
 HEAP32[gb + 44608 >> 2] = (HEAP32[gb + 44608 >> 2] | 0) + (gb + 405180 | 0);
 HEAP32[gb + 44612 >> 2] = (HEAP32[gb + 44612 >> 2] | 0) + (gb + 621574 | 0);
 HEAP32[gb + 44616 >> 2] = (HEAP32[gb + 44616 >> 2] | 0) + (gb + 422379 | 0);
 HEAP32[gb + 44620 >> 2] = (HEAP32[gb + 44620 >> 2] | 0) + (gb + 406392 | 0);
 HEAP32[gb + 44624 >> 2] = (HEAP32[gb + 44624 >> 2] | 0) + (gb + 406413 | 0);
 HEAP32[gb + 44636 >> 2] = fb + 7;
 HEAP32[gb + 44640 >> 2] = fb + 385;
 HEAP32[gb + 44644 >> 2] = fb + 1;
 HEAP32[gb + 44648 >> 2] = fb + 15;
 HEAP32[gb + 44652 >> 2] = fb + 9;
 HEAP32[gb + 44656 >> 2] = fb + 1;
 HEAP32[gb + 44660 >> 2] = fb + 6;
 HEAP32[gb + 44664 >> 2] = fb + 370;
 HEAP32[gb + 44668 >> 2] = fb + 225;
 HEAP32[gb + 44672 >> 2] = fb + 371;
 HEAP32[gb + 44676 >> 2] = fb + 226;
 HEAP32[gb + 44680 >> 2] = fb + 372;
 HEAP32[gb + 44684 >> 2] = fb + 18;
 HEAP32[gb + 44688 >> 2] = fb + 10;
 runPostSets33();
}

function __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i2, i14) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = (i14 - i2 | 0) / 28 | 0;
 i9 = i8 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4;
 if (i7 >>> 0 > ((i1 - i4 | 0) / 28 | 0) >>> 0) {
  if (i4) {
   i6 = i8 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
    i4 = i1;
    while (1) {
     i1 = i4 + -28 | 0;
     HEAP32[i6 >> 2] = i1;
     i5 = i4 + -20 | 0;
     if ((HEAP32[i4 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + -16 | 0);
      HEAP32[i5 >> 2] = 0;
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 | 0)) break; else i4 = i1;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 0;
  }
  if (i7 >>> 0 > 153391689) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
  } else i3 = 0;
  i13 = (i1 - i3 | 0) / 28 | 0;
  i3 = i13 << 1;
  i3 = i13 >>> 0 < 76695844 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 153391689;
  if (i3 >>> 0 > 153391689) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i1 = __Znwj(i3 * 28 | 0) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i1 + (i3 * 28 | 0);
  if ((i2 | 0) == (i14 | 0)) return;
  do {
   i11 = i2;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i1 + 8 | 0, i2 + 8 | 0);
   i2 = i2 + 28 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 28 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i14 | 0));
  return;
 }
 i13 = i8 + 4 | 0;
 i1 = ((HEAP32[i13 >> 2] | 0) - i4 | 0) / 28 | 0;
 i12 = i7 >>> 0 > i1 >>> 0;
 i1 = i2 + (i1 * 28 | 0) | 0;
 i11 = i12 ? i1 : i14;
 if ((i11 | 0) == (i2 | 0)) i4 = i3; else {
  do {
   i9 = i2;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i5 = i3;
   HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i5 + 4 >> 2] = i10;
   i5 = i3 + 8 | 0;
   if ((i2 | 0) != (i3 | 0)) {
    i9 = HEAP32[i2 + 8 >> 2] | 0;
    i10 = i3 + 20 | 0;
    i4 = HEAP32[i2 + 20 >> 2] << 2;
    i6 = i4 >> 2;
    HEAP32[i10 >> 2] = i6;
    i7 = i3 + 24 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    do if ((i8 & 2147483647) >>> 0 < i6 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i6;
     i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4, 4, i3 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i5 >> 2] = i4;
     break;
    } else {
     i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i3 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
     HEAP32[i7 >> 2] = i6;
     HEAP32[i5 >> 2] = i4;
     break;
    } else i4 = HEAP32[i5 >> 2] | 0; while (0);
    _memcpy(i4 | 0, i9 | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   }
   i2 = i2 + 28 | 0;
   i3 = i3 + 28 | 0;
  } while ((i2 | 0) != (i11 | 0));
  i4 = i3;
 }
 if (i12) {
  if ((i11 | 0) == (i14 | 0)) return;
  i2 = HEAP32[i13 >> 2] | 0;
  do {
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 8 | 0, i1 + 8 | 0);
   i1 = i1 + 28 | 0;
   i2 = (HEAP32[i13 >> 2] | 0) + 28 | 0;
   HEAP32[i13 >> 2] = i2;
  } while ((i1 | 0) != (i14 | 0));
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -28 | 0;
  HEAP32[i13 >> 2] = i2;
  i3 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i13 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZNSt3__26vectorI9HumanBoneNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 76 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i1 + 11 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i9 + 11 >> 0] = 0;
   HEAP8[i9 >> 0] = 0;
   i9 = HEAP32[gb + 1162364 >> 2] | 0;
   HEAP32[i1 + 32 >> 2] = i9;
   i10 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = i10;
   i12 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
   HEAP32[i1 + 40 >> 2] = i12;
   HEAP32[i1 + 44 >> 2] = i9;
   HEAP32[i1 + 48 >> 2] = i10;
   HEAP32[i1 + 52 >> 2] = i12;
   HEAP32[i1 + 56 >> 2] = i9;
   HEAP32[i1 + 60 >> 2] = i10;
   HEAP32[i1 + 64 >> 2] = i12;
   HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
   HEAP8[i1 + 72 >> 0] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 76 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 76 | 0) + i2 | 0;
 if (i5 >>> 0 > 56512727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 76 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 28256363 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 56512727;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 76 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 76 | 0) * 76 | 0) | 0;
 i8 = i3;
 i4 = i6 + (i5 * 76 | 0) | 0;
 i6 = i8;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i1 + 11 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
  i14 = i1 + 16 | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i14 + 11 >> 0] = 0;
  HEAP8[i14 >> 0] = 0;
  i14 = HEAP32[gb + 1162364 >> 2] | 0;
  HEAP32[i1 + 32 >> 2] = i14;
  i5 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  HEAP32[i1 + 36 >> 2] = i5;
  i7 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  HEAP32[i1 + 40 >> 2] = i7;
  HEAP32[i1 + 44 >> 2] = i14;
  HEAP32[i1 + 48 >> 2] = i5;
  HEAP32[i1 + 52 >> 2] = i7;
  HEAP32[i1 + 56 >> 2] = i14;
  HEAP32[i1 + 60 >> 2] = i5;
  HEAP32[i1 + 64 >> 2] = i7;
  HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
  HEAP8[i1 + 72 >> 0] = 0;
  i1 = i6 + 76 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i7 = i5;
  i1 = i5;
  i2 = i8;
 } else {
  i2 = i8;
  do {
   i1 = i1 + -76 | 0;
   __ZN9HumanBoneC2ERKS_(i3 + -76 | 0, i1);
   i3 = i2 + -76 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i5 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i10 >> 2] = i4;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) {
  i4 = i12 + 4 | 0;
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -76 | 0;
   i3 = i2 + -60 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i12);
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i2 + -64 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i12);
   }
  } while ((i1 | 0) != (i6 | 0));
 }
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i13;
 return;
}

function __Z12OptionalTypePKcS0_S0_(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 if (!(_strchr(i1, 47) | 0)) {
  i11 = __Z29scripting_class_from_fullnamePKcS0_S0_(i4, i5, i1) | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = _strlen(i1) | 0;
 i7 = i2 + 1 | 0;
 i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 1, gb + 64016 | 0, 0, gb + 464113 | 0, 26) | 0;
 _memcpy(i9 | 0, i1 | 0, i7 | 0) | 0;
 i7 = i9 + i2 | 0;
 do if (!i9) {
  i1 = 0;
  i8 = 7;
 } else {
  if ((i2 | 0) > 0) {
   i1 = _strchr(i9, 47) | 0;
   if (!i1) {
    i1 = i9;
    i8 = 7;
    break;
   }
   HEAP8[i1 >> 0] = 0;
   i2 = i9;
   i3 = i1 + 1 | 0;
  } else {
   i2 = 0;
   i3 = i9;
  }
  i2 = __Z29scripting_class_from_fullnamePKcS0_S0_(i4, i5, i2) | 0;
  if (i3 >>> 0 < i7 >>> 0) {
   i1 = _strchr(i3, 47) | 0;
   if (!i1) {
    i6 = i3;
    i3 = 0;
   } else {
    HEAP8[i1 >> 0] = 0;
    i6 = i3;
    i3 = i1 + 1 | 0;
   }
  } else i6 = 0;
 } while (0);
 if ((i8 | 0) == 7) {
  i6 = 0;
  i3 = 0;
  i2 = __Z29scripting_class_from_fullnamePKcS0_S0_(i4, i5, i1) | 0;
 }
 HEAP32[i11 >> 2] = 0;
 i5 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i3;
 L16 : while (1) {
  if (!i4) {
   if (!((i6 | 0) != 0 & (i2 | 0) != 0)) break;
   i1 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
   __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE(i2, i11);
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    i2 = 0;
    i6 = 0;
    i4 = 0;
    continue;
   }
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    i1 = i1 + 4 | 0;
    if (!(_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i2) | 0, i6) | 0)) {
     i6 = 0;
     i4 = 0;
     continue L16;
    }
    if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
     i2 = 0;
     i6 = 0;
     i4 = 0;
     continue L16;
    }
   }
  }
  i1 = (i6 | 0) != 0 & (i2 | 0) != 0;
  if (i4 >>> 0 >= i7 >>> 0) {
   i8 = 20;
   break;
  }
  if (!i1) break;
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
  __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE(i2, i11);
  i1 = HEAP32[i11 >> 2] | 0;
  L33 : do if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) i2 = 0; else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = i1 + 4 | 0;
   if (!(_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i2) | 0, i6) | 0)) break L33;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    i2 = 0;
    break;
   }
  } while (0);
  i1 = _strchr(i4, 47) | 0;
  if (!i1) {
   i6 = i4;
   i4 = 0;
   continue;
  }
  HEAP8[i1 >> 0] = 0;
  i6 = i4;
  i4 = i1 + 1 | 0;
 }
 L39 : do if ((i8 | 0) == 20) if (i1) {
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
  __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE(i2, i11);
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) i2 = 0; else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = i1 + 4 | 0;
   if (!(_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i2) | 0, i6) | 0)) break L39;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    i2 = 0;
    break;
   }
  }
 } while (0);
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1;
 if (i1 | 0) {
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64016 | 0);
 i11 = i2;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN14PhysicsManager15IgnoreCollisionEiib(i1, i11, i12, i5) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16;
 i13 = i16 + 36 | 0;
 i6 = i16 + 50 | 0;
 i7 = i16 + 48 | 0;
 i14 = i16 + 24 | 0;
 i15 = i16 + 8 | 0;
 if ((i12 | 0) > 31 | ((i11 | 0) > 31 | (i12 | i11 | 0) < 0)) {
  HEAP32[i2 >> 2] = 31;
  __Z6FormatPKcz(i13, gb + 662636 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 662472 | 0, 1384, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i1 + 724 >> 2] | 0;
 i2 = i1 + (i11 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = 1 << i12;
 if (!((i3 & i4 | 0) == 0 ^ i5)) {
  STACKTOP = i16;
  return;
 }
 if (i5) {
  HEAP32[i2 >> 2] = i3 & ~i4;
  i10 = i1 + (i12 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~(1 << i11);
 } else {
  HEAP32[i2 >> 2] = i3 | i4;
  i10 = i1 + (i12 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << i11;
 }
 i9 = HEAP32[gb + 1457404 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 72 >> 2] | 0;
 HEAP16[i6 >> 1] = 2;
 i9 = mftCall_iii(i10 | 0, i9 | 0, i6 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 i10 = i13 + 4 | 0;
 i6 = gb + 63160 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i9 << 2;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i1 | 3;
  if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 662472 | 0, 1410) | 0;
   i8 = gb + 64016 | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i10;
   HEAP32[i2 >> 2] = i6;
   HEAP32[i2 + 4 >> 2] = i8;
   i2 = i1;
   break;
  }
 } while (0);
 i8 = i2 + 3 & -4;
 i6 = HEAP32[gb + 1457404 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 76 >> 2] | 0;
 HEAP16[i7 >> 1] = 2;
 mftCall_iiiiii(i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, 0) | 0;
 if ((i9 | 0) > 0) {
  i6 = i14 + 4 | 0;
  i5 = 0;
  do {
   i4 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
   i4 = (HEAP16[i4 + 4 >> 1] | 0) == 5 ? i4 : 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0) | 0;
   HEAP32[i14 >> 2] = 0;
   i2 = gb + 63160 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = i6;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i7 << 2;
   do if (!i1) i1 = 0; else {
    i2 = i1 | 3;
    if (i2 >>> 0 < 2e3) {
     i1 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 662472 | 0, 1421) | 0;
     i2 = gb + 64016 | 0;
     i17 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     HEAP32[i14 >> 2] = i1;
     i3 = i6;
     HEAP32[i3 >> 2] = i17;
     HEAP32[i3 + 4 >> 2] = i2;
     break;
    }
   } while (0);
   i3 = i1 + 3 & -4;
   mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, i3 | 0, i7 | 0, 0) | 0;
   if (i7 | 0) {
    i1 = 0;
    do {
     i2 = i3 + (i1 << 2) | 0;
     i17 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 80 >> 2] | 0, i15 | 0, i17 | 0);
     i17 = HEAP32[i15 >> 2] & 255;
     if ((i17 | 0) == (i11 | 0) | (i17 | 0) == (i12 | 0)) {
      i17 = HEAP32[i2 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 76 >> 2] | 0, i17 | 0, i15 | 0);
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i7 | 0));
   }
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i6);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i9 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i16;
 return;
}

function __ZN7Terrain12AddToManagerEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13;
 i3 = __Z18GetITerrainManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i6 | 0);
 HEAP8[i6 + 34 >> 0] = 1;
 i3 = __ZnwjRK10MemLabelIdiPKci(76, gb + 63616 | 0, 16, gb + 930687 | 0, 153) | 0;
 i2 = HEAP32[i6 + 96 >> 2] | 0;
 if ((i2 | 0) == 3) i1 = HEAP32[i6 + 108 >> 2] | 0; else i1 = 0;
 i8 = HEAP32[i6 + 104 >> 2] | 0;
 i5 = i6 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = -1;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = (i2 | 0) == 0 ? gb + 184364 | 0 : (i2 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0;
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 100 >> 2];
 HEAP32[i3 + 24 >> 2] = i8;
 i1 = i3 + 28 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN14SplatMaterials16LoadSplatShadersEv(i3);
 __ZN14SplatMaterials15UpdateMaterialsEv(i3);
 HEAP32[i6 + 112 >> 2] = i3;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i4 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i12 = 9; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i12 = 11;
 }
 if ((i12 | 0) == 9) i12 = 11;
 do if ((i12 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i13;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 if (!i1) i12 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 20;
  }
 }
 if ((i12 | 0) == 18) i12 = 20;
 if ((i12 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i2 = HEAP32[i6 + 28 >> 2] | 0;
 i8 = i1 + 352 | 0;
 if (!i2) i7 = 0; else i7 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i7;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = HEAP32[i1 + 356 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i6 | 0)) i12 = 27; else if ((i7 | 0) < (HEAP32[i1 >> 2] | 0)) i12 = 27;
 if ((i12 | 0) == 27) {
  HEAP32[i10 >> 2] = i2;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i8, i9, i11) | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sc10NPhaseCoreC2ERNS0_5SceneERKNS_11PxSceneDescE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP32[i6 >> 2] = i1;
 i1 = i5 + 144 | 0;
 i2 = i6 + 4 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP16[i5 + 100 >> 1] | 0;
 i5 = i6 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = i3;
 HEAP32[i6 + 56 >> 2] = i3;
 HEAP32[i6 + 60 >> 2] = 0;
 HEAP8[i6 + 64 >> 0] = (i2 & 65535) >>> 10 & 1;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i3, gb + 705933 | 0, 150) | 0;
 i5 = i6 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 92 >> 2] = Math_fround(.75);
 HEAP32[i6 + 96 >> 2] = -1;
 HEAP32[i6 + 100 >> 2] = 0;
 HEAP32[i6 + 104 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i5, 64);
 i5 = i6 + 108 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i6 + 412 >> 2] = 0;
 HEAP8[i6 + 404 >> 0] = 1;
 HEAP32[i6 + 408 >> 2] = i6 + 148;
 HEAP32[i6 + 416 >> 2] = 64;
 HEAP32[i6 + 420 >> 2] = 32;
 HEAP32[i6 + 424 >> 2] = 0;
 HEAP32[i6 + 428 >> 2] = 0;
 HEAP32[i6 + 432 >> 2] = 768;
 HEAP32[i6 + 436 >> 2] = 0;
 HEAP32[i6 + 708 >> 2] = 0;
 HEAP8[i6 + 700 >> 0] = 1;
 HEAP32[i6 + 704 >> 2] = i6 + 444;
 HEAP32[i6 + 712 >> 2] = 64;
 HEAP32[i6 + 716 >> 2] = 32;
 HEAP32[i6 + 720 >> 2] = 0;
 HEAP32[i6 + 724 >> 2] = 0;
 HEAP32[i6 + 728 >> 2] = 768;
 HEAP32[i6 + 732 >> 2] = 0;
 HEAP32[i6 + 1004 >> 2] = 0;
 HEAP8[i6 + 996 >> 0] = 1;
 HEAP32[i6 + 1e3 >> 2] = i6 + 740;
 HEAP32[i6 + 1008 >> 2] = 64;
 HEAP32[i6 + 1012 >> 2] = 32;
 HEAP32[i6 + 1016 >> 2] = 0;
 HEAP32[i6 + 1020 >> 2] = 0;
 HEAP32[i6 + 1024 >> 2] = 2176;
 HEAP32[i6 + 1028 >> 2] = 0;
 HEAP32[i6 + 1300 >> 2] = 0;
 HEAP8[i6 + 1292 >> 0] = 1;
 HEAP32[i6 + 1296 >> 2] = i6 + 1036;
 HEAP32[i6 + 1304 >> 2] = 64;
 HEAP32[i6 + 1308 >> 2] = 32;
 HEAP32[i6 + 1312 >> 2] = 0;
 HEAP32[i6 + 1316 >> 2] = 0;
 HEAP32[i6 + 1320 >> 2] = 1920;
 HEAP32[i6 + 1324 >> 2] = 0;
 HEAP32[i6 + 1596 >> 2] = 0;
 HEAP8[i6 + 1588 >> 0] = 1;
 HEAP32[i6 + 1592 >> 2] = i6 + 1332;
 HEAP32[i6 + 1600 >> 2] = 64;
 HEAP32[i6 + 1604 >> 2] = 32;
 HEAP32[i6 + 1608 >> 2] = 0;
 HEAP32[i6 + 1612 >> 2] = 0;
 HEAP32[i6 + 1616 >> 2] = 1152;
 HEAP32[i6 + 1620 >> 2] = 0;
 HEAP32[i6 + 1892 >> 2] = 0;
 HEAP8[i6 + 1884 >> 0] = 1;
 HEAP32[i6 + 1888 >> 2] = i6 + 1628;
 HEAP32[i6 + 1896 >> 2] = 64;
 HEAP32[i6 + 1900 >> 2] = 32;
 HEAP32[i6 + 1904 >> 2] = 0;
 HEAP32[i6 + 1908 >> 2] = 0;
 HEAP32[i6 + 1912 >> 2] = 1280;
 HEAP32[i6 + 1916 >> 2] = 0;
 HEAP32[i6 + 2188 >> 2] = 0;
 HEAP8[i6 + 2180 >> 0] = 1;
 HEAP32[i6 + 2184 >> 2] = i6 + 1924;
 HEAP32[i6 + 2192 >> 2] = 64;
 HEAP32[i6 + 2196 >> 2] = 32;
 HEAP32[i6 + 2200 >> 2] = 0;
 HEAP32[i6 + 2204 >> 2] = 0;
 HEAP32[i6 + 2208 >> 2] = 1536;
 HEAP32[i6 + 2212 >> 2] = 0;
 HEAP32[i6 + 2484 >> 2] = 0;
 HEAP8[i6 + 2476 >> 0] = 1;
 HEAP32[i6 + 2480 >> 2] = i6 + 2220;
 HEAP32[i6 + 2488 >> 2] = 64;
 HEAP32[i6 + 2492 >> 2] = 32;
 HEAP32[i6 + 2496 >> 2] = 0;
 HEAP32[i6 + 2500 >> 2] = 0;
 HEAP32[i6 + 2504 >> 2] = 256;
 i5 = i6 + 2508 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAPF32[i6 + 2536 >> 2] = Math_fround(.75);
 HEAP32[i6 + 2540 >> 2] = -1;
 HEAP32[i6 + 2544 >> 2] = 0;
 HEAP32[i6 + 2548 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE15reserveInternalEj(i6 + 2512 | 0, 64);
 STACKTOP = i7;
 return;
}

function __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i7 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i7 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i7 + 28 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i7 + 32 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i7 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i7 + 40 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i10 = HEAP8[i9 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  i7 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i7;
  HEAP32[i10 >> 2] = i2;
  i10 = i7;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEbT0_SC_T_(i14, i16, i15) {
 i14 = i14 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17;
 switch ((i16 - i14 | 0) / 20 | 0 | 0) {
 case 2:
  {
   i1 = i16 + -20 | 0;
   if (!(mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i14 | 0) | 0)) {
    i16 = 1;
    STACKTOP = i17;
    return i16 | 0;
   }
   i2 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i2;
   i2 = i14 + 4 | 0;
   i10 = i16 + -16 | 0;
   i9 = HEAP32[i2 >> 2] | 0;
   i4 = i14 + 8 | 0;
   i11 = HEAP32[i4 >> 2] | 0;
   i6 = i14 + 12 | 0;
   i13 = HEAP32[i6 >> 2] | 0;
   i8 = i14 + 16 | 0;
   i15 = HEAP32[i8 >> 2] | 0;
   i12 = i16 + -12 | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i14 = i16 + -8 | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   i16 = i16 + -4 | 0;
   i7 = HEAP32[i16 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 >> 2] = i3;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i8 >> 2] = i7;
   HEAP32[i10 >> 2] = i9;
   HEAP32[i12 >> 2] = i11;
   HEAP32[i14 >> 2] = i13;
   HEAP32[i16 >> 2] = i15;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i14, i14 + 20 | 0, i16 + -20 | 0, i15) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_(i14, i14 + 20 | 0, i14 + 40 | 0, i16 + -20 | 0, i15) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_(i14, i14 + 20 | 0, i14 + 40 | 0, i14 + 60 | 0, i16 + -20 | 0, i15) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 1:
 case 0:
  {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 default:
  {
   i3 = i14 + 40 | 0;
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i14, i14 + 20 | 0, i3, i15) | 0;
   i1 = i14 + 60 | 0;
   L3 : do if ((i1 | 0) == (i16 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i10 = i9 + 4 | 0;
    i11 = i9 + 8 | 0;
    i12 = i9 + 12 | 0;
    i13 = i9 + 16 | 0;
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i15 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       i5 = i3 + 4 | 0;
       i6 = i3 + 8 | 0;
       i20 = HEAP32[i6 >> 2] | 0;
       i7 = i3 + 12 | 0;
       i19 = HEAP32[i7 >> 2] | 0;
       i8 = i3 + 16 | 0;
       i18 = HEAP32[i8 >> 2] | 0;
       HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i4 + 8 >> 2] = i20;
       HEAP32[i4 + 12 >> 2] = i19;
       HEAP32[i4 + 16 >> 2] = i18;
       if ((i3 | 0) == (i14 | 0)) break;
       i4 = i3 + -20 | 0;
       if (mftCall_iii(HEAP32[i15 >> 2] | 0, i9 | 0, i4 | 0) | 0) {
        i20 = i3;
        i3 = i4;
        i4 = i20;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
      i18 = HEAP32[i11 >> 2] | 0;
      i19 = HEAP32[i12 >> 2] | 0;
      i20 = HEAP32[i13 >> 2] | 0;
      HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
      HEAP32[i6 >> 2] = i18;
      HEAP32[i7 >> 2] = i19;
      HEAP32[i8 >> 2] = i20;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 20 | 0) == (i16 | 0);
       break L3;
      }
     }
     i3 = i1 + 20 | 0;
     if ((i3 | 0) == (i16 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i20 = i1;
      i1 = i3;
      i3 = i20;
     }
    }
   } while (0);
   i20 = i1 | i2;
   STACKTOP = i17;
   return i20 | 0;
  }
 }
 return 0;
}

function __ZNK5physx19TriangleMeshBuilder4saveERNS_14PxOutputStreamEbRKNS_15PxCookingParamsE(i11, i14, i13, i5) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15;
 if (!(__ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE(77, 69, 83, 72, 12, i13, i14) | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i7 = i11 + 176 | 0;
 i2 = (HEAP32[i7 >> 2] | 0) != 0 & 1;
 i9 = i11 + 180 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) == 0 ? i2 : i2 | 2;
 i10 = i11 + 184 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) == 0 ? i2 : i2 | 16;
 i8 = HEAP32[i11 + 28 >> 2] | 0;
 i12 = i11 + 20 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i4 = 0;
  i1 = 0;
  do {
   i16 = HEAP32[i8 + (i4 * 12 | 0) >> 2] | 0;
   i1 = i16 >>> 0 > i1 >>> 0 ? i16 : i1;
   i16 = HEAP32[i8 + (i4 * 12 | 0) + 4 >> 2] | 0;
   i1 = i16 >>> 0 > i1 >>> 0 ? i16 : i1;
   i16 = HEAP32[i8 + (i4 * 12 | 0) + 8 >> 2] | 0;
   i1 = i16 >>> 0 > i1 >>> 0 ? i16 : i1;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i3 >>> 0);
 }
 if (!(i1 >>> 0 > 65535 ? 1 : (HEAP32[i5 + 28 >> 2] & 32 | 0) != 0)) i2 = (i1 >>> 0 < 256 ? 4 : 8) | i2;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i2, i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 192 >> 2]), i13, i14);
 i16 = i11 + 16 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i16 >> 2] | 0, i13, i14);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i12 >> 2] | 0, i13, i14);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(HEAP32[i11 + 24 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 3 | 0, i13, i14);
 do if (!(i2 & 4)) {
  i1 = (HEAP32[i12 >> 2] | 0) * 3 | 0;
  if (!(i2 & 8)) {
   __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i8, i1, i13, i14);
   break;
  }
  if (i1 | 0) {
   i1 = 0;
   do {
    __ZN5physx9writeWordEtbRNS_14PxOutputStreamE(HEAP32[i8 + (i1 << 2) >> 2] & 65535, i13, i14);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < ((HEAP32[i12 >> 2] | 0) * 3 | 0) >>> 0);
  }
 } else if ((HEAP32[i12 >> 2] | 0) * 3 | 0) {
  i1 = 0;
  do {
   HEAP8[i6 >> 0] = HEAP32[i8 + (i1 << 2) >> 2];
   mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i6 | 0, 1) | 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < ((HEAP32[i12 >> 2] | 0) * 3 | 0) >>> 0);
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN5physx15writeWordBufferEPKtjbRNS_14PxOutputStreamE(i1, HEAP32[i12 >> 2] | 0, i13, i14);
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i16 = __ZN5physx15computeMaxIndexEPKjj(i1, HEAP32[i12 >> 2] | 0) | 0;
  __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i16, i13, i14);
  __ZN5physx12storeIndicesEjjPKjRNS_14PxOutputStreamEb(i16, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] | 0, i14, i13);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i1, (HEAP32[i12 >> 2] | 0) * 3 | 0, i13, i14);
 __ZNK5physx2Gu5RTree4saveERNS_14PxOutputStreamE(i11 + 48 | 0, i14) | 0;
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 36 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 144 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 148 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 152 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 156 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 160 >> 2]), i13, i14);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i11 + 164 >> 2]), i13, i14);
 i1 = i11 + 168 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(0, i13, i14);
  i16 = 1;
  STACKTOP = i15;
  return i16 | 0;
 } else {
  __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i12 >> 2] | 0, i13, i14);
  mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0) | 0;
  i16 = 1;
  STACKTOP = i15;
  return i16 | 0;
 }
 return 0;
}

function __ZN18AssetBundleManager29CollectPreloadDataRecursivelyEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEERK13dynamic_arrayIiLj4EER19InstanceIDHashTableIPKNS0_9AssetInfoENS3_4pairIKiSI_EEE(i6, i7, i10, i12, i19) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25 + 8 | 0;
 i22 = i25;
 i23 = i25 + 16 | 0;
 i11 = gb + 64016 | 0;
 i9 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i22;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i23 >> 2] = 0;
 i8 = i23 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i23 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, i22);
 i18 = i21;
 i20 = HEAP32[i18 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i13 + 4 >> 2] = i20;
 i13 = i12 + 12 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i14 = i22 + 4 | 0;
  i15 = i21 + 4 | 0;
  i16 = i19 + 8 | 0;
  i17 = i19 + 36 | 0;
  i5 = i19 + 28 | 0;
  i18 = i19 + 4 | 0;
  i20 = i19 + 12 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  do {
   HEAP32[i22 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i14 >> 2] = 0;
   __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj(i19, 1, 0);
   __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_(i21, i19, i22);
   if ((HEAP32[i21 >> 2] | 0) == -1) {
    i3 = HEAP32[i15 >> 2] | 0;
    if (!(HEAP8[i16 >> 0] | 0)) i24 = 12; else {
     i2 = HEAP32[i18 >> 2] | 0;
     if (!i2) i24 = 12; else {
      i1 = HEAP32[i5 >> 2] | 0;
      if ((HEAP32[i20 >> 2] | 0) == (HEAP32[i1 + (i3 << 3) >> 2] | 0)) HEAP32[i18 >> 2] = i2 + -1; else i24 = 12;
     }
    }
    if ((i24 | 0) == 12) {
     i24 = 0;
     HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    i26 = i22;
    i2 = HEAP32[i26 + 4 >> 2] | 0;
    i1 = i1 + (i3 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i26 >> 2];
    HEAP32[i1 + 4 >> 2] = i2;
    HEAP32[i22 >> 2] = HEAP32[i4 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i1 = 0; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i1, i22);
      i2 = HEAP32[i21 >> 2] | 0;
      i26 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i26 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i26 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    if (!i1) {
     i1 = __ZN18AssetBundleManager18CollectPreloadDataEiPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEER13dynamic_arrayIiLj4EE(i6, HEAP32[i4 >> 2] | 0, i7, i10, i23) | 0;
     if (i1 | 0) {
      __ZN18AssetBundleManager29CollectPreloadDataRecursivelyEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEERK13dynamic_arrayIiLj4EER19InstanceIDHashTableIPKNS0_9AssetInfoENS3_4pairIKiSI_EEE(i6, i1, i1 + 172 | 0, i23, i19);
      HEAP32[i8 >> 2] = 0;
     }
    }
   }
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) != ((HEAP32[i12 >> 2] | 0) + (HEAP32[i13 >> 2] << 2) | 0));
  if ((HEAP32[i9 >> 2] | 0) <= -1) {
   STACKTOP = i25;
   return;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i11);
 HEAP32[i23 >> 2] = 0;
 STACKTOP = i25;
 return;
}

function __ZN13UnityProfiler10SetLogPathENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i18 = i20 + 16 | 0;
 i14 = i20 + 8 | 0;
 i13 = i20;
 i17 = i20 + 28 | 0;
 i1 = i12 + 88 | 0;
 i15 = i1 + 11 | 0;
 i3 = HEAP8[i15 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 i16 = i12 + 92 | 0;
 i3 = i3 & 255;
 i5 = i8 ? HEAP32[i16 >> 2] | 0 : i3;
 i10 = i9 + 11 | 0;
 i7 = HEAP8[i10 >> 0] | 0;
 i2 = i7 << 24 >> 24 < 0;
 i11 = i9 + 4 | 0;
 L1 : do if ((i5 | 0) == ((i2 ? HEAP32[i11 >> 2] | 0 : i7 & 255) | 0)) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = i8 ? i6 : i1;
  i2 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  i4 = (i5 | 0) == 0;
  if (i8) {
   if (i4) {
    STACKTOP = i20;
    return;
   }
   if (_memcmp(i7, i2, i5) | 0) break;
   STACKTOP = i20;
   return;
  }
  if (i4) {
   STACKTOP = i20;
   return;
  }
  if ((i6 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
   i4 = i1;
   while (1) {
    i3 = i3 + -1 | 0;
    i4 = i4 + 1 | 0;
    if (!i3) break;
    i2 = i2 + 1 | 0;
    if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L1;
   }
   STACKTOP = i20;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i9) | 0;
 i2 = HEAP8[i10 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i2 = HEAP32[i11 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) {
  i1 = HEAP32[i12 + 108 >> 2] | 0;
  if (i1 | 0) __ZN4File5CloseEv(i1) | 0;
  i1 = HEAP32[i12 + 112 >> 2] | 0;
  if (!i1) {
   STACKTOP = i20;
   return;
  }
  __ZN4File5CloseEv(i1) | 0;
  STACKTOP = i20;
  return;
 }
 HEAP32[i12 + 100 >> 2] = 0;
 i3 = i12 + 108 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63576 | 0, 16, gb + 585151 | 0, 785) | 0;
  __ZN4FileC2Ev(i2);
  HEAP32[i3 >> 2] = i2;
 }
 i4 = i12 + 112 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63576 | 0, 16, gb + 585151 | 0, 787) | 0;
  __ZN4FileC2Ev(i2);
  HEAP32[i4 >> 2] = i2;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 if (__ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i2, i1, 1, 0) | 0) {
  if ((HEAP8[i15 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  HEAP32[i14 >> 2] = i2;
  _printf_console(gb + 585257 | 0, i14);
 } else {
  if ((HEAP8[i15 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  HEAP32[i13 >> 2] = i2;
  __Z6FormatPKcz(i17, gb + 585237 | 0, i13);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 585151 | 0, 790, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 }
 i14 = HEAP32[i4 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i12 = HEAP8[i15 >> 0] | 0;
 i13 = i12 << 24 >> 24 < 0;
 i16 = i13 ? HEAP32[i16 >> 2] | 0 : i12 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i17, i13 ? HEAP32[i1 >> 2] | 0 : i1, i16, i16 + 5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i17, gb + 585286 | 0, 5) | 0;
 i16 = __ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i14, i17, 1, 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 if (i16) {
  if ((HEAP8[i15 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i19 >> 2] = i1;
  _printf_console(gb + 585317 | 0, i19);
  STACKTOP = i20;
  return;
 } else {
  if ((HEAP8[i15 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  __Z6FormatPKcz(i17, gb + 585292 | 0, i18);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 585151 | 0, 795, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  STACKTOP = i20;
  return;
 }
}

function __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = i6 - i7 >> 4;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 << 4) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 << 4;
  i3 = i2 >> 4;
  if (!i3) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 << 4) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     HEAP32[i2 >> 2] = 0;
     __ZN14ConstantString6assignERKS_(i2, i1);
     i12 = i2 + 4 | 0;
     i11 = i1 + 4 | 0;
     HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
     i1 = i1 + 16 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -16 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN14ConstantStringD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if (((HEAP32[i9 >> 2] | 0) - i7 >> 4 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 << 4) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 << 4);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = i2 - i4 >> 4;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 << 4) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -16 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN14ConstantStringD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -16 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN14ConstantStringD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN15CollisionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 136 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 972 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 976 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 980 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 984 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 988 | 0, i6);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 992 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 144 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 408 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 672 | 0, i6);
 i1 = i5 + 936 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 940 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 944 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 956 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 952 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 960 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 964 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 968 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 948 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 949 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function runPostSets200() {
 HEAP32[gb + 169496 >> 2] = fb + 1906;
 HEAP32[gb + 169500 >> 2] = fb + 36;
 HEAP32[gb + 169512 >> 2] = (HEAP32[gb + 169512 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 169516 >> 2] = (HEAP32[gb + 169516 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 169544 >> 2] = (HEAP32[gb + 169544 >> 2] | 0) + (gb + 844074 | 0);
 HEAP32[gb + 169548 >> 2] = (HEAP32[gb + 169548 >> 2] | 0) + (gb + 844144 | 0);
 HEAP32[gb + 169560 >> 2] = fb + 2596;
 HEAP32[gb + 169564 >> 2] = fb + 2597;
 HEAP32[gb + 169568 >> 2] = fb + 80;
 HEAP32[gb + 169572 >> 2] = fb + 1907;
 HEAP32[gb + 169576 >> 2] = fb + 16;
 HEAP32[gb + 169580 >> 2] = fb + 2598;
 HEAP32[gb + 169584 >> 2] = fb + 2599;
 HEAP32[gb + 169588 >> 2] = fb + 19;
 HEAP32[gb + 169592 >> 2] = fb + 1220;
 HEAP32[gb + 169596 >> 2] = fb + 99;
 HEAP32[gb + 169600 >> 2] = fb + 40;
 HEAP32[gb + 169604 >> 2] = fb + 62;
 HEAP32[gb + 169608 >> 2] = fb + 28;
 HEAP32[gb + 169612 >> 2] = fb + 63;
 HEAP32[gb + 169616 >> 2] = fb + 29;
 HEAP32[gb + 169620 >> 2] = fb + 34;
 HEAP32[gb + 169624 >> 2] = fb + 1908;
 HEAP32[gb + 169628 >> 2] = fb + 1909;
 HEAP32[gb + 169632 >> 2] = fb + 1910;
 HEAP32[gb + 169636 >> 2] = fb + 1911;
 HEAP32[gb + 169640 >> 2] = fb + 1912;
 HEAP32[gb + 169644 >> 2] = fb + 1913;
 HEAP32[gb + 169648 >> 2] = fb + 36;
 HEAP32[gb + 169652 >> 2] = fb + 96;
 HEAP32[gb + 169656 >> 2] = fb + 81;
 HEAP32[gb + 169660 >> 2] = fb + 82;
 HEAP32[gb + 169672 >> 2] = (HEAP32[gb + 169672 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 169676 >> 2] = (HEAP32[gb + 169676 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 169712 >> 2] = fb + 2600;
 HEAP32[gb + 169716 >> 2] = fb + 2601;
 HEAP32[gb + 169720 >> 2] = fb + 2602;
 HEAP32[gb + 169724 >> 2] = fb + 1914;
 HEAP32[gb + 169728 >> 2] = fb + 16;
 HEAP32[gb + 169732 >> 2] = fb + 39;
 HEAP32[gb + 169736 >> 2] = fb + 2603;
 HEAP32[gb + 169740 >> 2] = fb + 19;
 HEAP32[gb + 169744 >> 2] = fb + 1221;
 HEAP32[gb + 169748 >> 2] = fb + 95;
 HEAP32[gb + 169752 >> 2] = fb + 40;
 HEAP32[gb + 169756 >> 2] = fb + 62;
 HEAP32[gb + 169760 >> 2] = fb + 28;
 HEAP32[gb + 169764 >> 2] = fb + 63;
 HEAP32[gb + 169768 >> 2] = fb + 29;
 HEAP32[gb + 169772 >> 2] = fb + 34;
 HEAP32[gb + 169776 >> 2] = fb + 1915;
 HEAP32[gb + 169780 >> 2] = fb + 1916;
 HEAP32[gb + 169784 >> 2] = fb + 1917;
 HEAP32[gb + 169788 >> 2] = fb + 1918;
 HEAP32[gb + 169792 >> 2] = fb + 1919;
 HEAP32[gb + 169796 >> 2] = fb + 1920;
 HEAP32[gb + 169800 >> 2] = fb + 36;
 HEAP32[gb + 169804 >> 2] = fb + 1222;
 HEAP32[gb + 169808 >> 2] = fb + 81;
 HEAP32[gb + 169812 >> 2] = fb + 82;
 HEAP32[gb + 169824 >> 2] = (HEAP32[gb + 169824 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 169828 >> 2] = (HEAP32[gb + 169828 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 169864 >> 2] = fb + 2604;
 HEAP32[gb + 169868 >> 2] = fb + 2605;
 HEAP32[gb + 169976 >> 2] = fb + 84;
 HEAP32[gb + 169988 >> 2] = fb + 85;
 HEAP32[gb + 17e4 >> 2] = fb + 86;
 HEAP32[gb + 170012 >> 2] = fb + 87;
 HEAP32[gb + 170024 >> 2] = fb + 2606;
 HEAP32[gb + 170028 >> 2] = fb + 2607;
 HEAP32[gb + 170032 >> 2] = fb + 2608;
 HEAP32[gb + 170036 >> 2] = fb + 1921;
 HEAP32[gb + 170040 >> 2] = fb + 16;
 HEAP32[gb + 170044 >> 2] = fb + 2609;
 HEAP32[gb + 170048 >> 2] = fb + 2610;
 HEAP32[gb + 170052 >> 2] = fb + 19;
 HEAP32[gb + 170056 >> 2] = fb + 1223;
 HEAP32[gb + 170060 >> 2] = fb + 103;
 HEAP32[gb + 170064 >> 2] = fb + 101;
 HEAP32[gb + 170068 >> 2] = fb + 62;
 HEAP32[gb + 170072 >> 2] = fb + 28;
 HEAP32[gb + 170076 >> 2] = fb + 63;
 HEAP32[gb + 170080 >> 2] = fb + 29;
 HEAP32[gb + 170084 >> 2] = fb + 34;
 HEAP32[gb + 170088 >> 2] = fb + 1922;
 HEAP32[gb + 170092 >> 2] = fb + 1923;
 HEAP32[gb + 170096 >> 2] = fb + 1924;
 HEAP32[gb + 170100 >> 2] = fb + 1925;
 HEAP32[gb + 170104 >> 2] = fb + 1926;
 HEAP32[gb + 170108 >> 2] = fb + 1927;
 HEAP32[gb + 170112 >> 2] = fb + 36;
 HEAP32[gb + 170116 >> 2] = fb + 104;
 HEAP32[gb + 170120 >> 2] = fb + 108;
 HEAP32[gb + 170124 >> 2] = fb + 94;
 HEAP32[gb + 170128 >> 2] = fb + 130;
 HEAP32[gb + 170132 >> 2] = fb + 112;
 HEAP32[gb + 170136 >> 2] = fb + 113;
 HEAP32[gb + 170140 >> 2] = fb + 131;
 HEAP32[gb + 170144 >> 2] = fb + 2611;
 HEAP32[gb + 170148 >> 2] = fb + 112;
 runPostSets201();
}

function __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 8 | 0;
 i16 = i21 + 4 | 0;
 i17 = i21;
 i18 = HEAP32[i14 >> 2] | 0;
 i19 = i14 + 4 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i20 = i15 + 4 | 0;
 if ((i1 | 0) == (i18 | 0)) {
  i17 = i20;
  i16 = i14;
  i20 = HEAP32[i20 >> 2] | 0;
  HEAP32[i16 >> 2] = i20;
  HEAP32[i17 >> 2] = i18;
  i18 = i15 + 8 | 0;
  i20 = HEAP32[i19 >> 2] | 0;
  i16 = HEAP32[i18 >> 2] | 0;
  HEAP32[i19 >> 2] = i16;
  HEAP32[i18 >> 2] = i20;
  i18 = i14 + 8 | 0;
  i20 = i15 + 12 | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i16 = HEAP32[i20 >> 2] | 0;
  HEAP32[i18 >> 2] = i16;
  HEAP32[i20 >> 2] = i19;
  i20 = HEAP32[i17 >> 2] | 0;
  HEAP32[i15 >> 2] = i20;
  STACKTOP = i21;
  return;
 }
 i12 = HEAP32[i20 >> 2] | 0;
 do {
  i3 = i12 + -28 | 0;
  i11 = i1;
  i1 = i1 + -28 | 0;
  HEAP32[i3 >> 2] = 0;
  i6 = i12 + -24 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i12 + -20 >> 2] = 0;
  i5 = i11 + -24 | 0;
  i2 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
  i4 = (i2 | 0) / 872 | 0;
  if (i2 | 0) {
   if (i4 >>> 0 > 4925421) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i2 = __Znwj(i2) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i12 + -20 >> 2] = i2 + (i4 * 872 | 0);
   i3 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) != (i4 | 0)) do {
    __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i3);
    i3 = i3 + 872 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 872 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i3 | 0) != (i4 | 0));
  }
  i7 = i12 + -16 | 0;
  i8 = i12 + -12 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i12 + -8 | 0;
  HEAP32[i9 >> 2] = 0;
  i2 = i12 + -12 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = HEAP32[i11 + -16 >> 2] | 0;
  i10 = i11 + -12 | 0;
  if ((i3 | 0) != (i10 | 0)) {
   i4 = i3;
   while (1) {
    i5 = i4 + 16 | 0;
    HEAP32[i17 >> 2] = i2;
    HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
    i6 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i7, i13, i16, i5) | 0;
    if (!(HEAP32[i6 >> 2] | 0)) {
     i4 = __Znwj(24) | 0;
     i23 = i5;
     i22 = HEAP32[i23 + 4 >> 2] | 0;
     i5 = i4 + 16 | 0;
     HEAP32[i5 >> 2] = HEAP32[i23 >> 2];
     HEAP32[i5 + 4 >> 2] = i22;
     i5 = HEAP32[i16 >> 2] | 0;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i4 + 4 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = i5;
     HEAP32[i6 >> 2] = i4;
     i5 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     if (i5) {
      HEAP32[i7 >> 2] = i5;
      i4 = HEAP32[i6 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i4);
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    }
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i4) while (1) {
     i4 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) {
      i3 = i4;
      break;
     } else i3 = i4;
    } else {
     i3 = i4;
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if (!i4) break; else i3 = i4;
     }
    }
    if ((i3 | 0) == (i10 | 0)) break; else i4 = i3;
   }
  }
  HEAP32[i12 + -4 >> 2] = HEAP32[i11 + -4 >> 2];
  i12 = (HEAP32[i20 >> 2] | 0) + -28 | 0;
  HEAP32[i20 >> 2] = i12;
 } while ((i1 | 0) != (i18 | 0));
 i23 = i20;
 i20 = i14;
 i18 = i12;
 i22 = HEAP32[i14 >> 2] | 0;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i23 >> 2] = i22;
 i22 = i15 + 8 | 0;
 i20 = HEAP32[i19 >> 2] | 0;
 i18 = HEAP32[i22 >> 2] | 0;
 HEAP32[i19 >> 2] = i18;
 HEAP32[i22 >> 2] = i20;
 i19 = i14 + 8 | 0;
 i22 = i15 + 12 | 0;
 i20 = HEAP32[i19 >> 2] | 0;
 i18 = HEAP32[i22 >> 2] | 0;
 HEAP32[i19 >> 2] = i18;
 HEAP32[i22 >> 2] = i20;
 i23 = HEAP32[i23 >> 2] | 0;
 HEAP32[i15 >> 2] = i23;
 STACKTOP = i21;
 return;
}

function __ZN4Mesh5SetUvEiPKfjj(i16, i3, i4, i14, i15) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i17;
 i10 = i17 + 40 | 0;
 i11 = i17 + 24 | 0;
 i9 = i17 + 8 | 0;
 if ((i14 + -1 | i3) >>> 0 > 3) {
  STACKTOP = i17;
  return;
 }
 i8 = i16 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) i7 = i1; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i8 >> 2] | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i13 = i2 + 4 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  if (!(HEAP32[i13 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i8 >> 2] = i1;
  i7 = i1;
 }
 i6 = i3 + 3 | 0;
 i13 = 1 << i6;
 if (!((i4 | 0) != 0 & (i15 | 0) != 0)) {
  i1 = i7 + 8 | 0;
  i2 = HEAP32[i7 + 100 >> 2] | 0;
  if (!(HEAP32[i7 + 176 >> 2] | 0)) if ((HEAP32[i16 + 116 >> 2] | 0) == (HEAP32[i16 + 112 >> 2] | 0)) {
   __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  } else i12 = 9; else i12 = 9;
  if ((i12 | 0) == 9) {
   HEAP32[i11 >> 2] = HEAP32[gb + 59228 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
  }
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i2, 0, i13, i11, gb + 1546313 | 0);
  __ZN4Mesh16SetChannelsDirtyEjb(i16, i13, 0);
  STACKTOP = i17;
  return;
 }
 if ((HEAP32[i7 + 100 >> 2] | 0) != (i15 | 0)) {
  HEAP32[i5 >> 2] = HEAP32[gb + 58184 + (i6 << 2) >> 2];
  __Z6FormatPKcz(i10, gb + 427581 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 904, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i17;
  return;
 }
 i1 = i11;
 i2 = i1 + 16 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i11 + (i6 << 1) >> 0] = 0;
 HEAP8[i11 + (i6 << 1) + 1 >> 0] = i14;
 i1 = i7 + 8 | 0;
 if (!(HEAP32[i7 + 176 >> 2] | 0)) if ((HEAP32[i16 + 116 >> 2] | 0) == (HEAP32[i16 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i1);
  HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 } else i12 = 16; else i12 = 16;
 if ((i12 | 0) == 16) {
  HEAP32[i9 >> 2] = HEAP32[gb + 59228 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 }
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i15, i13, 0, i9, i11);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i1 = HEAP16[i3 + (i6 << 2) >> 1] | 0;
 i6 = HEAPU8[i3 + 32 + ((i1 & 255) * 12 | 0) + 10 >> 0] | 0;
 if (i14 | 0) {
  i5 = 0;
  i1 = (HEAP32[i2 + 92 >> 2] | 0) + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i3 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
  while (1) {
   i2 = 0;
   i3 = i4;
   while (1) {
    HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i14 | 0)) break; else i3 = i3 + 4 | 0;
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i15 | 0)) break; else {
    i4 = i4 + (i14 << 2) | 0;
    i1 = i1 + i6 | 0;
   }
  }
 }
 __ZN4Mesh16SetChannelsDirtyEjb(i16, i13, 0);
 STACKTOP = i17;
 return;
}

function _wcsstr(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i2 = HEAP32[i13 >> 2] | 0;
 L1 : do if (i2) if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else {
  i11 = _wcschr(i1, i2) | 0;
  if (!i11) i1 = 0; else if (!(HEAP32[i13 + 4 >> 2] | 0)) i1 = i11; else if (!(HEAP32[i11 + 4 >> 2] | 0)) i1 = 0; else {
   i12 = 0;
   do {
    if (!(HEAP32[i11 + (i12 << 2) >> 2] | 0)) {
     i1 = 0;
     break L1;
    }
    i12 = i12 + 1 | 0;
   } while ((HEAP32[i13 + (i12 << 2) >> 2] | 0) != 0);
   L10 : do if (i12 >>> 0 > 1) {
    i2 = 0;
    i7 = -1;
    i3 = 1;
    L11 : while (1) {
     i4 = 1;
     i1 = i2;
     while (1) {
      i2 = i3;
      L15 : while (1) {
       i6 = 1;
       while (1) {
        i3 = HEAP32[i13 + (i6 + i7 << 2) >> 2] | 0;
        i5 = HEAP32[i13 + (i2 << 2) >> 2] | 0;
        if ((i3 | 0) != (i5 | 0)) break L15;
        if ((i6 | 0) == (i4 | 0)) break;
        i6 = i6 + 1 | 0;
        i2 = i6 + i1 | 0;
        if (i2 >>> 0 >= i12 >>> 0) {
         i8 = i4;
         i1 = i7;
         break L11;
        }
       }
       i1 = i1 + i4 | 0;
       i2 = i1 + 1 | 0;
       if (i2 >>> 0 >= i12 >>> 0) {
        i8 = i4;
        i1 = i7;
        break L11;
       }
      }
      i4 = i2 - i7 | 0;
      if ((i3 | 0) <= (i5 | 0)) break;
      i3 = i2 + 1 | 0;
      if (i3 >>> 0 >= i12 >>> 0) {
       i8 = i4;
       i1 = i7;
       break L11;
      } else i1 = i2;
     }
     i3 = i1 + 2 | 0;
     if (i3 >>> 0 >= i12 >>> 0) {
      i8 = 1;
      break;
     } else {
      i2 = i1 + 1 | 0;
      i7 = i1;
     }
    }
    i4 = 0;
    i9 = -1;
    i5 = 1;
    while (1) {
     i3 = 1;
     i2 = i4;
     while (1) {
      i4 = i5;
      L30 : while (1) {
       i7 = 1;
       while (1) {
        i5 = HEAP32[i13 + (i7 + i9 << 2) >> 2] | 0;
        i6 = HEAP32[i13 + (i4 << 2) >> 2] | 0;
        if ((i5 | 0) != (i6 | 0)) break L30;
        if ((i7 | 0) == (i3 | 0)) break;
        i7 = i7 + 1 | 0;
        i4 = i7 + i2 | 0;
        if (i4 >>> 0 >= i12 >>> 0) {
         i4 = i8;
         i2 = i9;
         break L10;
        }
       }
       i2 = i2 + i3 | 0;
       i4 = i2 + 1 | 0;
       if (i4 >>> 0 >= i12 >>> 0) {
        i4 = i8;
        i2 = i9;
        break L10;
       }
      }
      i3 = i4 - i9 | 0;
      if ((i5 | 0) >= (i6 | 0)) break;
      i5 = i4 + 1 | 0;
      if (i5 >>> 0 >= i12 >>> 0) {
       i4 = i8;
       i2 = i9;
       break L10;
      } else i2 = i4;
     }
     i5 = i2 + 2 | 0;
     if (i5 >>> 0 >= i12 >>> 0) {
      i4 = i8;
      i3 = 1;
      break;
     } else {
      i4 = i2 + 1 | 0;
      i9 = i2;
     }
    }
   } else {
    i4 = 1;
    i1 = -1;
    i3 = 1;
    i2 = -1;
   } while (0);
   i9 = (i2 + 1 | 0) >>> 0 > (i1 + 1 | 0) >>> 0;
   i3 = i9 ? i3 : i4;
   i9 = i9 ? i2 : i1;
   i10 = i9 + 1 | 0;
   if (!(_wmemcmp(i13, i13 + (i3 << 2) | 0, i10) | 0)) i8 = i12 - i3 | 0; else {
    i3 = i12 - i9 + -1 | 0;
    i8 = 0;
    i3 = (i9 >>> 0 > i3 >>> 0 ? i9 : i3) + 1 | 0;
   }
   i7 = i12 | 63;
   i1 = i11;
   i4 = 0;
   i2 = i11;
   while (1) {
    i5 = i1;
    do if (i2 - i5 >> 2 >>> 0 < i12 >>> 0) {
     i6 = _wmemchr(i2, 0, i7) | 0;
     if (!i6) {
      i6 = i2 + (i7 << 2) | 0;
      break;
     } else if (i6 - i5 >> 2 >>> 0 < i12 >>> 0) {
      i1 = 0;
      break L1;
     } else break;
    } else i6 = i2; while (0);
    i2 = i10 >>> 0 > i4 >>> 0 ? i10 : i4;
    i5 = HEAP32[i13 + (i2 << 2) >> 2] | 0;
    L53 : do if (!i5) {
     i2 = i10;
     i14 = 43;
    } else {
     while (1) {
      if ((i5 | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) break;
      i2 = i2 + 1 | 0;
      i5 = HEAP32[i13 + (i2 << 2) >> 2] | 0;
      if (!i5) {
       i2 = i10;
       i14 = 43;
       break L53;
      }
     }
     i4 = 0;
     i2 = i2 - i9 | 0;
    } while (0);
    if ((i14 | 0) == 43) while (1) {
     i14 = 0;
     if (i2 >>> 0 <= i4 >>> 0) break L1;
     i2 = i2 + -1 | 0;
     if ((HEAP32[i13 + (i2 << 2) >> 2] | 0) != (HEAP32[i1 + (i2 << 2) >> 2] | 0)) {
      i4 = i8;
      i2 = i3;
      break;
     } else i14 = 43;
    }
    i1 = i1 + (i2 << 2) | 0;
    i2 = i6;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx2Sq16BucketPrunerCore9addObjectERKNS0_13PrunerPayloadERKNS_9PxBounds3E(i15, i13, i14) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 8 | 0;
 i16 = i18;
 i11 = i15 + 7584 | 0;
 if (!(HEAP8[i11 >> 0] | 0)) {
  i12 = i15 + 28 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 >>> 0 < 16) {
   HEAP32[i12 >> 2] = i1 + 1;
   i16 = HEAP32[i13 + 4 >> 2] | 0;
   i17 = i15 + 32 + (i1 << 3) | 0;
   HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   HEAP32[i15 + 160 + (i1 * 24 | 0) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 160 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 160 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 160 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i15 + 160 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i15 + 160 + (i1 * 24 | 0) + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   STACKTOP = i18;
   return 1;
  }
  i6 = i15 + 4 | 0;
  i7 = i15 + 12 | 0;
  i8 = i15 + 8 | 0;
  i9 = i15 + 16 | 0;
  i5 = i15 + 544 | 0;
  i10 = 0;
  do {
   i2 = i15 + 32 + (i10 << 3) | 0;
   i1 = HEAP32[i15 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
    __ZN5physx2Sq16BucketPrunerCore10resizeCoreEv(i15);
    i1 = HEAP32[i15 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = i1 + 1;
   i19 = i2;
   i4 = HEAP32[i19 + 4 >> 2] | 0;
   i3 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP32[i3 + (i1 * 24 | 0) >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) >> 2];
   HEAP32[i3 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) + 4 >> 2];
   HEAP32[i3 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) + 8 >> 2];
   HEAP32[i3 + (i1 * 24 | 0) + 12 >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) + 12 >> 2];
   HEAP32[i3 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) + 16 >> 2];
   HEAP32[i3 + (i1 * 24 | 0) + 20 >> 2] = HEAP32[i15 + 160 + (i10 * 24 | 0) + 20 >> 2];
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = -1;
   i3 = i2;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i4 = i16;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = i3;
   i4 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i5, i16, i17) | 0;
   if (!(HEAP8[i17 >> 0] | 0)) {
    i19 = i4;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i19 + 4 >> 2] = i3;
    HEAP32[i4 + 8 >> 2] = i1;
   }
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
  HEAP32[i12 >> 2] = 0;
  HEAP8[i11 >> 0] = 1;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i15 + 4 >> 2] | 0)) {
  __ZN5physx2Sq16BucketPrunerCore10resizeCoreEv(i15);
  i4 = HEAP32[i15 >> 2] | 0;
 } else i4 = i1;
 HEAP32[i15 >> 2] = i4 + 1;
 i1 = i13;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = (HEAP32[i15 + 12 >> 2] | 0) + (i4 << 3) | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i3 + (i4 * 24 | 0) >> 2] = HEAP32[i14 >> 2];
 HEAP32[i3 + (i4 * 24 | 0) + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i3 + (i4 * 24 | 0) + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i3 + (i4 * 24 | 0) + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i3 + (i4 * 24 | 0) + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i3 + (i4 * 24 | 0) + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[(HEAP32[i15 + 16 >> 2] | 0) + (i4 << 2) >> 2] = -1;
 i3 = i13;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i16;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i15 + 544 | 0, i16, i17) | 0;
 if (!(HEAP8[i17 >> 0] | 0)) {
  i19 = i1;
  HEAP32[i19 >> 2] = i2;
  HEAP32[i19 + 4 >> 2] = i3;
  HEAP32[i1 + 8 >> 2] = i4;
 }
 STACKTOP = i18;
 return 1;
}

function __ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di(i1, i7, i3, f11, i6, f16, f18, i9, i20, i2, i19) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 f11 = Math_fround(f11);
 i6 = i6 | 0;
 f16 = Math_fround(f16);
 f18 = Math_fround(f18);
 i9 = i9 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var f4 = f0, i5 = 0, f8 = f0, f10 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i17 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, i27 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24 + 8 | 0;
 i1 = i24;
 i22 = i24 + 48 | 0;
 if ((HEAP16[gb + 1457632 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457632 | 0, i17);
  i23 = gb + 1457632 | 0;
 } else i23 = 0;
 if (!i19) i1 = 0; else {
  i21 = f11 == Math_fround(inf);
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  f4 = Math_fround(f8 * f8);
  f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f10 * f10));
  if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f13 = Math_fround(f8 * f4);
  f12 = Math_fround(f10 * f4);
  f4 = i21 ? Math_fround(1.0e5) : f11;
  f10 = Math_fround(f4 * f13);
  f4 = Math_fround(f4 * f12);
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  f10 = Math_fround(f8 + f10);
  i5 = i7 + 4 | 0;
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  f4 = Math_fround(f11 + f4);
  f26 = Math_fround(f10 - f8);
  f25 = Math_fround(f4 - f11);
  f25 = Math_fround(Math_sqrt(Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25))));
  if (((HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) == 2139095040) {
   f10 = Math_fround(f8 + Math_fround(f13 * Math_fround(1.0e5)));
   f4 = Math_fround(f11 + Math_fround(f12 * Math_fround(1.0e5)));
  }
  i27 = gb + 64016 | 0;
  i15 = HEAP32[i27 + 4 >> 2] | 0;
  i14 = i1;
  HEAP32[i14 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 12 >> 2] = 0;
  i14 = i22 + 16 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i22 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i1);
  i27 = i17;
  i3 = HEAP32[i27 + 4 >> 2] | 0;
  i1 = i15;
  HEAP32[i1 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i17 >> 2] = gb + 156148 + 8;
  HEAP32[i17 + 4 >> 2] = i6;
  i1 = i17 + 8 | 0;
  i3 = i17 + 12 | 0;
  HEAP32[i17 + 16 >> 2] = i9;
  HEAP32[i17 + 20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i5 >> 2];
  HEAPF32[i17 + 28 >> 2] = f10;
  HEAPF32[i17 + 32 >> 2] = f4;
  HEAP32[i17 + 36 >> 2] = i22;
  i9 = f16 == Math_fround(-inf);
  f8 = i9 ? Math_fround(-3402823469999999843913219.0e14) : f16;
  HEAPF32[i1 >> 2] = f8;
  i9 = f18 == Math_fround(inf);
  f4 = i9 ? Math_fround(3402823469999999843913219.0e14) : f18;
  HEAPF32[i3 >> 2] = f4;
  if (!(f8 < f4)) {
   HEAPF32[i1 >> 2] = f4;
   HEAPF32[i3 >> 2] = f8;
  }
  i1 = __ZN14Raycast2DQuery8RunQueryEb(i17, i20) | 0;
  i1 = (i1 | 0) > (i19 | 0) ? i19 : i1;
  if ((i1 | 0) > 0) {
   i9 = HEAP32[i22 >> 2] | 0;
   if (i21) {
    i3 = 0;
    do {
     i5 = i9 + (i3 * 36 | 0) + 28 | 0;
     HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(1.0e5));
     i5 = i2;
     i2 = i2 + 36 | 0;
     i6 = i9 + (i3 * 36 | 0) | 0;
     i7 = i5 + 36 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
      i5 = i5 + 4 | 0;
      i6 = i6 + 4 | 0;
     } while ((i5 | 0) < (i7 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else {
    i3 = 0;
    do {
     i5 = i2;
     i2 = i2 + 36 | 0;
     i6 = i9 + (i3 * 36 | 0) | 0;
     i7 = i5 + 36 | 0;
     do {
      HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
      i5 = i5 + 4 | 0;
      i6 = i6 + 4 | 0;
     } while ((i5 | 0) < (i7 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   }
  }
  if ((HEAP32[i14 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i15);
   HEAP32[i22 >> 2] = 0;
  }
 }
 if (!i23) {
  STACKTOP = i24;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i23);
 STACKTOP = i24;
 return i1 | 0;
}

function __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayIP13AnimationClipLj4EERNS1_6memory9AllocatorE(i25, i1, i26) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0;
 if (!i25) {
  i27 = 0;
  return i27 | 0;
 }
 i24 = i25 + 16 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 i1 = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE(i1, HEAP32[i25 >> 2] | 0, (i23 | 0) == 0 ? 0 : i23 + i24 | 0, i26) | 0;
 if (!i1) {
  i27 = 0;
  return i27 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if (!(HEAP32[i25 >> 2] | 0)) {
  i27 = i1;
  return i27 | 0;
 }
 i24 = i2 + 20 | 0;
 i14 = i2 + 24 | 0;
 i15 = i25 + 4 | 0;
 i16 = i15;
 i13 = 0;
 i17 = HEAP32[i24 >> 2] | 0;
 do {
  i2 = __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i17, i26) | 0;
  HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 2) >> 2] = i2;
  i17 = HEAP32[i24 >> 2] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + i16 + (i13 << 2) | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) + 20 | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  i11 = (i11 | 0) == 0 ? 0 : i2 + i11 | 0;
  i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  if (!i11) i3 = 1; else i3 = (HEAP32[i11 >> 2] | 0) == 0;
  i18 = HEAP32[i17 >> 2] | 0;
  L15 : do if (i18 | 0) {
   i19 = i17 + 4 | 0;
   i19 = (HEAP32[i19 >> 2] | 0) + i19 | 0;
   i20 = i2 + 4 | 0;
   i20 = (HEAP32[i20 >> 2] | 0) + i20 | 0;
   i21 = i2 + 12 | 0;
   i21 = (HEAP32[i21 >> 2] | 0) + i21 | 0;
   i22 = i2 + 20 | 0;
   i22 = (HEAP32[i22 >> 2] | 0) + i22 | 0;
   i23 = i2 + 28 | 0;
   i23 = (HEAP32[i23 >> 2] | 0) + i23 | 0;
   i12 = i2 + 36 | 0;
   i12 = (HEAP32[i12 >> 2] | 0) + i12 | 0;
   i9 = i11 + 4 | 0;
   i10 = i9;
   if (i3) {
    i2 = 0;
    while (1) {
     i3 = HEAP32[i19 + (i2 * 12 | 0) + 8 >> 2] | 0;
     switch (HEAP32[i19 + (i2 * 12 | 0) + 4 >> 2] | 0) {
     case 6:
      {
       HEAP8[i20 + i3 >> 0] = 1;
       break;
      }
     case 7:
      {
       HEAP8[i21 + i3 >> 0] = 1;
       break;
      }
     case 8:
      {
       HEAP8[i22 + i3 >> 0] = 1;
       break;
      }
     case 1:
      {
       HEAP8[i23 + i3 >> 0] = 1;
       break;
      }
     case 3:
      {
       HEAP8[i12 + i3 >> 0] = 1;
       break;
      }
     default:
      {}
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i18 | 0)) break L15;
    }
   } else i8 = 0;
   do {
    i7 = HEAP32[i19 + (i8 * 12 | 0) + 4 >> 2] | 0;
    L29 : do if ((i7 | 0) == 1) {
     i3 = 1;
     i2 = HEAP32[i19 + (i8 * 12 | 0) + 8 >> 2] | 0;
     i27 = 28;
    } else {
     i5 = HEAP32[i11 >> 2] | 0;
     i6 = i19 + (i8 * 12 | 0) | 0;
     L32 : do if (!i5) i3 = 0; else {
      i3 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
      i2 = 0;
      while (1) {
       if (Math_fround(HEAPF32[i3 + (i2 << 3) + 4 >> 2]) > Math_fround(0.0)) {
        i4 = HEAP32[i6 >> 2] | 0;
        if (!i4) {
         i3 = 1;
         break L32;
        }
        if ((i4 | 0) == (HEAP32[i3 + (i2 << 3) >> 2] | 0)) {
         i3 = 1;
         break L32;
        }
       }
       i2 = i2 + 1 | 0;
       if (i2 >>> 0 >= i5 >>> 0) {
        i3 = 0;
        break;
       }
      }
     } while (0);
     i2 = HEAP32[i19 + (i8 * 12 | 0) + 8 >> 2] | 0;
     switch (i7 | 0) {
     case 1:
      {
       i27 = 28;
       break L29;
      }
     case 6:
      {
       HEAP8[i20 + i2 >> 0] = i3;
       break L29;
      }
     case 7:
      {
       HEAP8[i21 + i2 >> 0] = i3;
       break L29;
      }
     case 8:
      {
       HEAP8[i22 + i2 >> 0] = i3;
       break L29;
      }
     case 3:
      {
       HEAP8[i12 + i2 >> 0] = i3;
       break L29;
      }
     default:
      break L29;
     }
    } while (0);
    if ((i27 | 0) == 28) {
     i27 = 0;
     HEAP8[i23 + i2 >> 0] = i3;
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != (i18 | 0));
  } while (0);
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i25 >> 2] | 0) >>> 0);
 return i1 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 48 | 0;
 if (HEAP8[i10 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12maybe_shrinkEv(i7);
 i11 = i7 + 32 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i12;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i12;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i17 = i9 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i16 = i9 + 8 | 0;
 i18 = i7 + 8 | 0;
 i15 = HEAP16[i18 >> 1] | 0;
 HEAP8[i16 >> 0] = i15;
 i6 = i9 + 9 | 0;
 HEAP8[i6 >> 0] = (i15 & 65535) >>> 8;
 i15 = i9 + 12 | 0;
 i14 = i7 + 12 | 0;
 i20 = i14;
 i13 = HEAP32[i20 + 4 >> 2] | 0;
 i5 = i15;
 HEAP32[i5 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i5 + 4 >> 2] = i13;
 i5 = i9 + 20 | 0;
 i13 = i7 + 20 | 0;
 i20 = i13;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i4 + 4 >> 2] = i19;
 i4 = i9 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j(i9, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i1;
 i2 = HEAP8[i18 >> 0] | 0;
 i17 = HEAP16[i16 >> 1] | 0;
 HEAP8[i18 >> 0] = i17;
 HEAP8[i16 >> 0] = i2;
 i2 = i7 + 9 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = (i17 & 65535) >>> 8;
 HEAP8[i6 >> 0] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i6 = i2 >>> 8;
 i17 = i15;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 HEAP32[i15 >> 2] = i1;
 HEAP8[i9 + 16 >> 0] = i2;
 i2 = i9 + 17 | 0;
 i1 = i6 & 65535;
 HEAP8[i2 >> 0] = i1;
 HEAP8[i2 + 1 >> 0] = i1 >> 8;
 HEAP8[i2 + 2 >> 0] = i6 >>> 16;
 i2 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = i6 >>> 8;
 i15 = i5;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i5 >> 2] = i2;
 HEAP8[i9 + 24 >> 0] = i6;
 i6 = i9 + 25 | 0;
 i5 = i1 & 65535;
 HEAP8[i6 >> 0] = i5;
 HEAP8[i6 + 1 >> 0] = i5 >> 8;
 HEAP8[i6 + 2 >> 0] = i1 >>> 16;
 i6 = i7 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i4 = i9 + 32 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i4 >> 2] = i6;
 i11 = i9 + 36 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i4;
 f3 = Math_fround(i5 >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i10 >> 0] = 0;
 f3 = Math_fround(i6 >>> 0);
 HEAP32[i9 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i9 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i9 + 48 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i12;
 return;
}

function __ZN9ShaderLab18SerializedProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i4 = i10 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i10 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i5;
 i12 = i11 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i7 = i2 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i7 = i7 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i6 = i10 + 16 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i10 + 20 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i10 + 32 | 0, 0);
 i5 = i10 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i10 + 48 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 56 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 60 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 64 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i12 = i10 + 68 | 0;
  __ZN9ShaderLab25SerializedTextureProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i11);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i12 = i10 + 68 | 0;
  __ZN9ShaderLab25SerializedTextureProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i11);
  STACKTOP = i13;
  return;
 }
}

function __ZN17PersistentManager40GlobalToLocalSerializedFileIndexInternalERK26SerializedObjectIdentifier(i19, i8, i11) {
 i19 = i19 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i24 + 56 | 0;
 i16 = i24 + 48 | 0;
 i17 = i24 + 40 | 0;
 i21 = i24;
 i20 = i11 + 8 | 0;
 i22 = HEAP32[i20 >> 2] | 0;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 i12 = HEAP32[i8 + 88 >> 2] | 0;
 i9 = HEAP32[i8 + 24 >> 2] | 0;
 i13 = HEAP32[i8 + 40 >> 2] | 0;
 i10 = i9 + (i12 * 20 | 0) + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + (i12 * 20 | 0) + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  i1 = i2;
  while (1) {
   i15 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i15 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i15 | 0 : i15;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i7 | 0)) if (!((i1 | 0) == (i7 | 0) ? 1 : (HEAP32[i11 >> 2] | 0) < (HEAP32[i1 >> 2] | 0))) {
  i21 = HEAP32[i1 + 4 >> 2] | 0;
  i23 = i19 + 8 | 0;
  HEAP32[i19 >> 2] = i21;
  i21 = i23;
  HEAP32[i21 >> 2] = i22;
  i23 = i23 + 4 | 0;
  HEAP32[i23 >> 2] = i20;
  STACKTOP = i24;
  return;
 }
 i15 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i14 = HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + (i12 * 24 | 0) >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i21 | 0, i8 | 0, HEAP32[i11 >> 2] | 0);
 __ZN14SerializedFile14AddExternalRefERK14FileIdentifier(i14, i21);
 i14 = HEAP32[i14 + 96 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i3 = i1;
 if ((i1 | 0) == (i7 | 0)) {
  i1 = HEAP32[i11 >> 2] | 0;
  i23 = 12;
 } else {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) < (HEAP32[i1 >> 2] | 0)) {
   i1 = i2;
   i23 = 12;
  }
 }
 if ((i23 | 0) == 12) {
  HEAP32[i16 >> 2] = i3;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  i1 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i10, i18, i17) | 0;
 }
 HEAP32[i1 + 4 >> 2] = i14;
 i8 = HEAP32[i11 >> 2] | 0;
 i7 = i13 + (i12 * 20 | 0) + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i13 + (i12 * 20 | 0) + 8 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i14 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i6 | 0)) i23 = 17; else if ((i14 | 0) < (HEAP32[i1 >> 2] | 0)) i23 = 17;
 if ((i23 | 0) == 17) {
  HEAP32[i16 >> 2] = i2;
  HEAP32[i17 >> 2] = i14;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
  i1 = __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i7, i18, i17) | 0;
 }
 HEAP32[i1 + 4 >> 2] = i8;
 if ((HEAP8[i21 + 11 >> 0] | 0) < 0) {
  i23 = HEAP32[i21 >> 2] | 0;
  i21 = HEAP32[i21 + 12 >> 2] | 0;
  HEAP32[i18 >> 2] = 66;
  HEAP32[i18 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i23, i18);
 }
 if (!i15) {
  i21 = i14;
  i23 = i19 + 8 | 0;
  HEAP32[i19 >> 2] = i21;
  i21 = i23;
  HEAP32[i21 >> 2] = i22;
  i23 = i23 + 4 | 0;
  HEAP32[i23 >> 2] = i20;
  STACKTOP = i24;
  return;
 }
 __Z19pop_allocation_rootv();
 i21 = i14;
 i23 = i19 + 8 | 0;
 HEAP32[i19 >> 2] = i21;
 i21 = i23;
 HEAP32[i21 >> 2] = i22;
 i23 = i23 + 4 | 0;
 HEAP32[i23 >> 2] = i20;
 STACKTOP = i24;
 return;
}

function __Z11SkinGenericILi2ELb1ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 i8 = HEAP32[i1 + 44 >> 2] | 0;
 i9 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 while (1) {
  f18 = Math_fround(HEAPF32[i3 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i27 = HEAP32[i3 + 8 >> 2] | 0;
  i10 = HEAP32[i3 + 12 >> 2] | 0;
  f11 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) >> 2]));
  f11 = Math_fround(f11 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) >> 2])));
  f23 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 4 >> 2]));
  f23 = Math_fround(f23 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 4 >> 2])));
  f21 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 8 >> 2]));
  f21 = Math_fround(f21 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 8 >> 2])));
  f24 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 16 >> 2]));
  f24 = Math_fround(f24 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 16 >> 2])));
  f22 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 20 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 20 >> 2])));
  f19 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 24 >> 2]));
  f19 = Math_fround(f19 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 24 >> 2])));
  f13 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 32 >> 2]));
  f13 = Math_fround(f13 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 32 >> 2])));
  f12 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 36 >> 2]));
  f12 = Math_fround(f12 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 36 >> 2])));
  f17 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 40 >> 2]));
  f17 = Math_fround(f17 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 40 >> 2])));
  f26 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 48 >> 2]));
  f26 = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 48 >> 2])));
  f15 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 52 >> 2]));
  f15 = Math_fround(f15 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 52 >> 2])));
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i6 + (i27 << 6) + 56 >> 2]));
  f25 = Math_fround(f18 + Math_fround(f25 * Math_fround(HEAPF32[i6 + (i10 << 6) + 56 >> 2])));
  i10 = i4 + i5 | 0;
  f18 = Math_fround(HEAPF32[i4 >> 2]);
  f16 = Math_fround(f11 * f18);
  f20 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f24 * f20));
  f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f16 = Math_fround(f26 + Math_fround(f16 + Math_fround(f13 * f14)));
  f15 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * f20)) + Math_fround(f12 * f14)));
  f14 = Math_fround(f25 + Math_fround(Math_fround(Math_fround(f21 * f18) + Math_fround(f19 * f20)) + Math_fround(f17 * f14)));
  f20 = Math_fround(HEAPF32[i10 >> 2]);
  f11 = Math_fround(f11 * f20);
  f18 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f24 = Math_fround(f11 + Math_fround(f24 * f18));
  f11 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f13 = Math_fround(f24 + Math_fround(f13 * f11));
  f12 = Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * f18)) + Math_fround(f12 * f11));
  f11 = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f18)) + Math_fround(f17 * f11));
  HEAPF32[i1 >> 2] = f16;
  HEAPF32[i1 + 4 >> 2] = f15;
  HEAPF32[i1 + 8 >> 2] = f14;
  i10 = i1 + i5 | 0;
  HEAPF32[i10 >> 2] = f13;
  HEAPF32[i10 + 4 >> 2] = f12;
  HEAPF32[i10 + 8 >> 2] = f11;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i9 | 0)) break; else {
   i3 = i3 + 16 | 0;
   i4 = i4 + i7 | 0;
   i1 = i1 + i8 | 0;
  }
 }
 return;
}

function _tt_sbit_decoder_load_bit_aligned(i1, i7, i22, i5, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i22 = i22 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i23 = HEAP32[i4 + 8 >> 2] | 0;
 i14 = HEAP32[i4 + 12 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = HEAPU16[i6 + 2 >> 1] | 0;
 i6 = HEAP16[i6 >> 1] | 0;
 i9 = i6 & 65535;
 i15 = Math_imul(HEAPU8[i1 + 18 >> 0] | 0, i2) | 0;
 if ((i5 | 0) < 0) {
  i23 = 3;
  return i23 | 0;
 }
 if ((i9 + i3 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0 | ((i3 | 0) < 0 ? 1 : (i2 + i5 | 0) >>> 0 > (HEAP32[i4 + 4 >> 2] | 0) >>> 0)) {
  i23 = 3;
  return i23 | 0;
 }
 if ((i7 + (((Math_imul(i15, i9) | 0) + 7 | 0) >>> 3) | 0) >>> 0 > i22 >>> 0) {
  i23 = 3;
  return i23 | 0;
 }
 i4 = Math_imul(i23, i3) | 0;
 i13 = i5 >> 3;
 i8 = i14 + (i4 + i13) | 0;
 i21 = i5 & 7;
 if (!(i6 << 16 >> 16)) {
  i23 = 0;
  return i23 | 0;
 }
 i18 = 8 - i21 | 0;
 i17 = i15 >>> 0 < i18 >>> 0 ? i15 : i18;
 i18 = ~(255 << i17) << i18 - i17;
 i19 = i15 - i17 | 0;
 i20 = 8 - i17 | 0;
 if (!i21) {
  i11 = i15 + -8 | 0;
  i6 = i11 >>> 3;
  i10 = i6 + 1 | 0;
  i11 = i11 - (i6 << 3) | 0;
  i12 = i15 >>> 0 > 7;
  i2 = 0;
  i1 = i7;
  i7 = 0;
  i6 = i14 + (i13 + i6 + i4 + 1) | 0;
  while (1) {
   if (i12) {
    i3 = i8;
    i4 = i15;
    i5 = i1;
    while (1) {
     i21 = HEAPU8[i5 >> 0] | 0 | i2 & 65535;
     HEAP8[i3 >> 0] = i21 >>> i7 | (HEAPU8[i3 >> 0] | 0);
     i2 = i21 << 8 & 65535;
     i4 = i4 + -8 | 0;
     if ((i4 | 0) <= 7) break; else {
      i3 = i3 + 1 | 0;
      i5 = i5 + 1 | 0;
     }
    }
    i3 = i11;
    i4 = i6;
    i1 = i1 + i10 | 0;
   } else {
    i3 = i15;
    i4 = i8;
   }
   do if ((i3 | 0) > 0) {
    if ((i7 | 0) >= (i3 | 0)) {
     HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 65280 >>> i3 & (i2 & 65535) >>> i7;
     i3 = i7 - i3 | 0;
     break;
    }
    if (i1 >>> 0 < i22 >>> 0) {
     i2 = (HEAPU8[i1 >> 0] | 0 | i2 & 65535) & 65535;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 & 65535;
    HEAP8[i4 >> 0] = i2 >>> i7 & 65280 >>> i3 | (HEAPU8[i4 >> 0] | 0);
    i3 = i7 + 8 - i3 | 0;
    i2 = i2 << 8 & 65535;
   } else i3 = i7; while (0);
   if ((i9 | 0) > 1) {
    i7 = i3;
    i9 = i9 + -1 | 0;
    i8 = i8 + i23 | 0;
    i6 = i6 + i23 | 0;
   } else {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 }
 i10 = 8 - i21 | 0;
 i15 = i15 + ~(i15 >>> 0 > i10 >>> 0 ? i10 : i15) + -7 | 0;
 i10 = i15 >>> 3;
 i12 = i10 + 1 | 0;
 i15 = i15 - (i10 << 3) | 0;
 i16 = (i19 | 0) > 7;
 i2 = 0;
 i1 = i7;
 i3 = 0;
 i11 = i9;
 i10 = i14 + (i13 + i10 + i4 + 2) | 0;
 while (1) {
  do if ((i11 | 0) == (i9 | 0)) {
   i7 = i21;
   i2 = HEAPU8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } else {
   if ((i3 | 0) >= (i17 | 0)) {
    i7 = i3 - i17 | 0;
    i2 = (i2 & 65535) >>> 8;
    break;
   }
   if (i1 >>> 0 < i22 >>> 0) {
    i2 = (HEAPU8[i1 >> 0] | 0 | i2 & 65535) & 65535;
    i1 = i1 + 1 | 0;
   }
   i7 = i20 + i3 | 0;
  } while (0);
  i5 = i2 & 65535;
  i2 = i8 + 1 | 0;
  HEAP8[i8 >> 0] = i5 >>> i7 & i18 | (HEAPU8[i8 >> 0] | 0);
  i5 = i5 << 8;
  if (i16) {
   i3 = i19;
   i4 = i1;
   while (1) {
    i14 = HEAPU8[i4 >> 0] | 0 | i5 & 65280;
    HEAP8[i2 >> 0] = i14 >>> i7 | (HEAPU8[i2 >> 0] | 0);
    i5 = i14 << 8;
    i3 = i3 + -8 | 0;
    if ((i3 | 0) <= 7) break; else {
     i2 = i2 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
   }
   i6 = i15;
   i4 = i10;
   i3 = i5;
   i1 = i1 + i12 | 0;
  } else {
   i6 = i19;
   i4 = i2;
   i3 = i5;
  }
  i2 = i3 & 65535;
  do if ((i6 | 0) > 0) {
   if ((i7 | 0) >= (i6 | 0)) {
    HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 65280 >>> i6 & (i3 & 65280) >>> i7;
    i3 = i7 - i6 | 0;
    break;
   }
   if (i1 >>> 0 < i22 >>> 0) {
    i2 = HEAPU8[i1 >> 0] | 0 | i3 & 65280;
    i1 = i1 + 1 | 0;
   } else i2 = i3;
   i2 = i2 & 65535;
   HEAP8[i4 >> 0] = i2 >>> i7 & 65280 >>> i6 | (HEAPU8[i4 >> 0] | 0);
   i3 = i7 + 8 - i6 | 0;
   i2 = i2 << 8 & 65535;
  } else i3 = i7; while (0);
  if ((i11 | 0) > 1) {
   i11 = i11 + -1 | 0;
   i8 = i8 + i23 | 0;
   i10 = i10 + i23 | 0;
  } else {
   i1 = 0;
   break;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeXSorterP16DetailMeshBVNodeEEbT0_S5_T_(i13, i14, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f15 = f0, i16 = 0;
 switch ((i14 - i13 | 0) / 28 | 0 | 0) {
 case 2:
  {
   i1 = i14 + -28 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(HEAPF32[i14 + -16 >> 2])) * Math_fround(.5));
   f3 = Math_fround(HEAPF32[i13 >> 2]);
   f4 = Math_fround(HEAPF32[i13 + 12 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f3 + f4) * Math_fround(.5)))) {
    i14 = 1;
    return i14 | 0;
   }
   i8 = HEAP32[i13 + 4 >> 2] | 0;
   i9 = HEAP32[i13 + 8 >> 2] | 0;
   i10 = HEAP32[i13 + 16 >> 2] | 0;
   i11 = HEAP32[i13 + 20 >> 2] | 0;
   i12 = HEAP32[i13 + 24 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAPF32[i1 >> 2] = f3;
   HEAP32[i14 + -24 >> 2] = i8;
   HEAP32[i14 + -20 >> 2] = i9;
   HEAPF32[i14 + -16 >> 2] = f4;
   HEAP32[i14 + -12 >> 2] = i10;
   HEAP32[i14 + -8 >> 2] = i11;
   HEAP32[i14 + -4 >> 2] = i12;
   i14 = 1;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i13 + 84 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   return i14 | 0;
  }
 default:
  {
   i5 = i13 + 56 | 0;
   __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i5, i1) | 0;
   i1 = i13 + 84 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f4 = Math_fround(HEAPF32[i1 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
     f15 = Math_fround(Math_fround(f4 + f7) * Math_fround(.5));
     f3 = Math_fround(HEAPF32[i5 >> 2]);
     if (f15 < Math_fround(Math_fround(f3 + Math_fround(HEAPF32[i5 + 12 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 + 4 >> 2] | 0;
      i9 = HEAP32[i1 + 8 >> 2] | 0;
      i10 = HEAP32[i1 + 16 >> 2] | 0;
      i11 = HEAP32[i1 + 20 >> 2] | 0;
      i12 = HEAP32[i1 + 24 >> 2] | 0;
      f3 = Math_fround(Math_fround(f4 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
       if ((i5 | 0) == (i13 | 0)) {
        i5 = i13;
        break;
       }
       i6 = i5 + -28 | 0;
       f15 = Math_fround(HEAPF32[i6 >> 2]);
       if (f3 < Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i5 + -16 >> 2])) * Math_fround(.5))) {
        i16 = i5;
        i5 = i6;
        i6 = i16;
       } else break;
      }
      HEAPF32[i5 >> 2] = f4;
      HEAP32[i5 + 4 >> 2] = i8;
      HEAP32[i5 + 8 >> 2] = i9;
      HEAPF32[i5 + 12 >> 2] = f7;
      HEAP32[i5 + 16 >> 2] = i10;
      HEAP32[i5 + 20 >> 2] = i11;
      HEAP32[i5 + 24 >> 2] = i12;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 28 | 0) == (i14 | 0);
       break L3;
      }
     }
     i5 = i1 + 28 | 0;
     if ((i5 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i16 = i1;
      i1 = i5;
      i5 = i16;
     }
    }
   } while (0);
   i16 = i1 | i2;
   return i16 | 0;
  }
 }
 return 0;
}

function __ZN17GeneralConnection4PollEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, d22 = 0.0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 16 | 0;
 i19 = i21;
 d22 = +_emscripten_get_now() * 1.0e6;
 i14 = ~~d22 >>> 0;
 i15 = +Math_abs(d22) >= 1.0 ? (d22 > 0.0 ? ~~+Math_min(+Math_floor(d22 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d22 - +(~~d22 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i1 = HEAP32[i17 + 88 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i19 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i17 + 92 | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i21;
  return;
 }
 i10 = i19 + 8 | 0;
 i11 = i18 + 2 | 0;
 i12 = i17 + 104 | 0;
 i13 = i18 + 4 | 0;
 i2 = i1;
 while (1) {
  i8 = i2 + 16 | 0;
  i5 = HEAP32[i2 + 20 >> 2] | 0;
  __ZN20BufferedSocketStream4PollEy(i5 + 20 | 0, 5, 0) | 0;
  d22 = +_emscripten_get_now() * 1.0e6;
  i7 = _i64Subtract(~~d22 >>> 0 | 0, (+Math_abs(d22) >= 1.0 ? (d22 > 0.0 ? ~~+Math_min(+Math_floor(d22 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d22 - +(~~d22 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i14 | 0, i15 | 0) | 0;
  i7 = __Z17TimeToNanosecondsy(i7, getTempRet0() | 0) | 0;
  i6 = getTempRet0() | 0;
  L6 : do if (i6 >>> 0 < 0 | (i6 | 0) == 0 & i7 >>> 0 < 2e7) do {
   i6 = __ZN17GeneralConnection10Connection14ReceiveMessageEPNS_14NetworkMessageE(i5, i18) | 0;
   if (!i6) break L6;
   i7 = HEAPU16[i11 >> 1] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   if (i3 | 0) {
    i1 = i12;
    L12 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i7 | 0)) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) break L12; else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i1 = i4;
      break;
     } else i1 = i4;
    }
    if ((i1 | 0) != (i12 | 0)) if ((i7 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) mftCall_viii(HEAP32[i1 + 20 >> 2] | 0, i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i8 >> 2] | 0);
   }
   __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv(i5);
   d22 = +_emscripten_get_now() * 1.0e6;
   i7 = _i64Subtract(~~d22 >>> 0 | 0, (+Math_abs(d22) >= 1.0 ? (d22 > 0.0 ? ~~+Math_min(+Math_floor(d22 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d22 - +(~~d22 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i14 | 0, i15 | 0) | 0;
   i7 = __Z17TimeToNanosecondsy(i7, getTempRet0() | 0) | 0;
   i6 = getTempRet0() | 0;
  } while (i6 >>> 0 < 0 | (i6 | 0) == 0 & i7 >>> 0 < 2e7); while (0);
  if (!(HEAP8[i5 + 39 >> 0] | 0)) i16 = 18; else if (!(HEAP32[i5 + 92 >> 2] | 0)) i16 = 18;
  do if ((i16 | 0) == 18) {
   i16 = 0;
   if (!(HEAP8[i5 + 38 >> 0] | 0)) {
    i1 = HEAP32[i20 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) {
     __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKiEEvRT_(i19, i8);
     break;
    } else {
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i20 >> 2] = i1 + 4;
     break;
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 i16 = HEAP32[i19 >> 2] | 0;
 i2 = i16;
 if ((i1 | 0) != (i16 | 0)) {
  i3 = 0;
  i1 = i2;
  while (1) {
   __ZN17GeneralConnection10DisconnectEj(i17, HEAP32[i1 + (i3 << 2) >> 2] | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i20 >> 2] | 0;
   i16 = HEAP32[i19 >> 2] | 0;
   i2 = i16;
   if (i3 >>> 0 >= i1 - i16 >> 2 >>> 0) break; else i1 = i2;
  }
 }
 if (!i2) {
  STACKTOP = i21;
  return;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i20 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 i20 = HEAP32[i19 + 12 >> 2] | 0;
 HEAP32[i18 >> 2] = 1;
 HEAP32[i18 + 4 >> 2] = i20;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i18);
 STACKTOP = i21;
 return;
}

function __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_(i6, i2, f3, i5, i15, i16, i17) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i5 = i5 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, f20 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18;
 i4 = i18 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 if (!(f3 > Math_fround(.0000999999974))) {
  STACKTOP = i18;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i10 = f3 > Math_fround(1.0);
 i10 = HEAP32[(i10 ? i4 : i1) >> 2] | 0;
 HEAP32[i1 >> 2] = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i14 = i2 + (i4 * 40 | 0) | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i1 * 40 | 0;
 i7 = i14 + (i1 * 40 | 0) | 0;
 i13 = i5 + 56 | 0;
 i12 = i6 + 8 | 0;
 i6 = (i11 | 0) / 40 | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!i11) {
  i6 = (i1 | 0) > 0;
  i7 = i2 + (i4 * 40 | 0) + 36 | 0;
  i8 = i2 + (i4 * 40 | 0) + 4 | 0;
  i9 = i2 + (i4 * 40 | 0) + 8 | 0;
  i10 = i2 + (i4 * 40 | 0) + 12 | 0;
  i11 = i2 + (i4 * 40 | 0) + 16 | 0;
  i2 = i2 + (i4 * 40 | 0) + 20 | 0;
  i1 = 0;
  do {
   if (i6) if ((HEAP32[i15 + (i1 << 2) >> 2] | 0) >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    f20 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f3);
    i4 = i16 + (i1 << 2) | 0;
    HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f20);
    f20 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * f3);
    i4 = i1 + 4 | 0;
    i5 = i16 + (i4 << 2) | 0;
    HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f20);
    f20 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * f3);
    i5 = i1 + 8 | 0;
    i19 = i16 + (i5 << 2) | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
    if (HEAP8[i13 >> 0] | 0) if (HEAP8[i12 >> 0] | 0) {
     f20 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f3);
     i19 = i17 + (i1 << 2) | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
     f20 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f3);
     i19 = i17 + (i4 << 2) | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
     f20 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f3);
     i19 = i17 + (i5 << 2) | 0;
     HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4);
  STACKTOP = i18;
  return;
 } else i5 = 0;
 do {
  i2 = HEAP32[i15 + (i5 << 2) >> 2] | 0;
  i1 = i6;
  i4 = i14;
  do {
   i19 = (i1 | 0) / 2 | 0;
   i11 = (HEAP32[i4 + (i19 * 40 | 0) + 36 >> 2] | 0) >>> 0 < i2 >>> 0;
   i1 = i11 ? i1 + -1 - i19 | 0 : i19;
   i4 = i11 ? i4 + (i19 * 40 | 0) + 40 | 0 : i4;
  } while ((i1 | 0) != 0);
  if (i4 >>> 0 < i7 >>> 0) if (i2 >>> 0 >= (HEAP32[i4 + 36 >> 2] | 0) >>> 0) {
   f20 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f3);
   i2 = i16 + (i5 << 2) | 0;
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f20);
   f20 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f3);
   i2 = i5 + 4 | 0;
   i1 = i16 + (i2 << 2) | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f20);
   f20 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * f3);
   i1 = i5 + 8 | 0;
   i19 = i16 + (i1 << 2) | 0;
   HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
   if (HEAP8[i13 >> 0] | 0) if (HEAP8[i12 >> 0] | 0) {
    f20 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * f3);
    i19 = i17 + (i5 << 2) | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
    f20 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) * f3);
    i19 = i17 + (i2 << 2) | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
    f20 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) * f3);
    i19 = i17 + (i1 << 2) | 0;
    HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f20);
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 4);
 STACKTOP = i18;
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i13, i9, i14) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i15 = (i14 - i9 | 0) / 20 | 0;
 i7 = i13 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i5 = i2;
 if (i15 >>> 0 > ((i1 - i2 | 0) / 20 | 0) >>> 0) {
  if (i2) {
   i6 = i13 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i5 | 0)) i1 = i2; else {
    i4 = i16 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -20 | 0;
     HEAP32[i6 >> 2] = i1;
     i3 = i2 + -16 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i3 >> 2] | 0;
      i12 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i16 >> 2] = 66;
      HEAP32[i4 >> 2] = i12;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } else i2 = 0;
  i16 = (i1 - i2 | 0) / 20 | 0;
  i1 = i16 << 1;
  i1 = i16 >>> 0 < 107374182 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i16 = __Znwj(i1 * 20 | 0) | 0;
  HEAP32[i13 + 4 >> 2] = i16;
  HEAP32[i13 >> 2] = i16;
  HEAP32[i7 >> 2] = i16 + (i1 * 20 | 0);
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i13, i9, i14, i15);
  STACKTOP = i17;
  return;
 }
 i12 = i13 + 4 | 0;
 i10 = ((HEAP32[i12 >> 2] | 0) - i2 | 0) / 20 | 0;
 i11 = i15 >>> 0 > i10 >>> 0;
 i10 = i11 ? i9 + (i10 * 20 | 0) | 0 : i14;
 if ((i10 | 0) != (i9 | 0)) {
  i1 = i5;
  do {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   i6 = i1 + 4 | 0;
   i2 = i9 + 4 | 0;
   do if ((i1 | 0) != (i9 | 0)) {
    i8 = HEAP8[i2 + 11 >> 0] | 0;
    i4 = i8 << 24 >> 24 < 0;
    i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
    i8 = i4 ? HEAP32[i9 + 8 >> 2] | 0 : i8 & 255;
    i4 = i6 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i8 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 8 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
     break;
    }
    if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
    if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
    HEAP8[i2 + i8 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 8 >> 2] = i8;
     break;
    } else {
     HEAP8[i4 >> 0] = i8;
     break;
    }
   } while (0);
   i9 = i9 + 20 | 0;
   i1 = i1 + 20 | 0;
  } while ((i9 | 0) != (i10 | 0));
  i5 = i1;
 }
 if (i11) {
  __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i13, i10, i14, i15 - (((HEAP32[i12 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0) / 20 | 0) | 0);
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = i16 + 4 | 0;
 do {
  i2 = i1 + -20 | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = i1 + -16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
   i1 = HEAP32[i12 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i17;
 return;
}
function __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj(i1, i14, i15, i16, i17, i11) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19 + 16 | 0;
 i12 = i19 + 8 | 0;
 i18 = i19;
 i13 = HEAP32[i1 >> 2] | 0;
 L1 : do if (!i13) i1 = 0; else {
  i10 = i18 + 4 | 0;
  if (!i11) {
   i2 = 0;
   i8 = 0;
   i1 = 0;
   while (1) {
    if (1 << i8 & i13) {
     i6 = HEAP8[i14 + 4 + (i8 << 2) + 3 >> 0] | 0;
     if (i6 << 24 >> 24) {
      i7 = HEAP8[i14 + 4 + (i8 << 2) + 1 >> 0] | 0;
      i3 = HEAPU8[i14 + 4 + (i8 << 2) >> 0] | 0;
      if (i3 >>> 0 < i17 >>> 0) {
       i5 = i15 + (i3 << 3) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i12 = i18;
       HEAP32[i12 >> 2] = i3;
       HEAP32[i12 + 4 >> 2] = i5;
       do if (i3) {
        i4 = HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 4 >> 2] | 0;
        i3 = HEAP8[i14 + 4 + (i8 << 2) + 2 >> 0] | 0;
        if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0) >>> 0 > i2 >>> 0) {
         i12 = (Math_imul(i5, i16) | 0) + (i7 & 255) | 0;
         i11 = i3 << 24 >> 24 == 2;
         __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv(HEAP32[gb + 1451080 >> 2] | 0, i2, i4, i3 << 24 >> 24 == 4 ? 2 : i11 & 1, i11 ? 4 : i6 & 255, i3 & 255, i5, i12);
         i1 = 1 << i2 | i1;
         break;
        } else {
         i12 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0;
         HEAP32[i9 >> 2] = i2;
         HEAP32[i9 + 4 >> 2] = i12;
         _printf_console(gb + 611922 | 0, i9);
         break;
        }
       } while (0);
      }
     }
     i2 = i2 + 1 | 0;
    }
    i12 = i8;
    i8 = i8 + 1 | 0;
    if ((i12 | 0) > 6 | (i13 >>> i8 | 0) == 0) break L1;
   }
  } else {
   i2 = 0;
   i9 = 0;
   i1 = 0;
  }
  do {
   if (1 << i9 & i13) {
    i7 = i14 + 4 + (i9 << 2) + 3 | 0;
    if (HEAP8[i7 >> 0] | 0) {
     i8 = HEAP8[i14 + 4 + (i9 << 2) + 1 >> 0] | 0;
     i3 = HEAPU8[i14 + 4 + (i9 << 2) >> 0] | 0;
     if (i3 >>> 0 <= i17 >>> 0) {
      if ((i3 | 0) == (i17 | 0)) {
       i4 = __Z16GetRealGfxDevicev() | 0;
       switch (i9 | 0) {
       case 7:
       case 1:
        {
         i3 = 1;
         break;
        }
       default:
        i3 = 0;
       }
       __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej(i18, i4, i3, i11);
       i3 = HEAP32[i18 >> 2] | 0;
      } else {
       i5 = i15 + (i3 << 3) | 0;
       i3 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i6 = i18;
       HEAP32[i6 >> 2] = i3;
       HEAP32[i6 + 4 >> 2] = i5;
      }
      do if (i3) {
       i6 = HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 4 >> 2] | 0;
       i5 = HEAP8[i14 + 4 + (i9 << 2) + 2 >> 0] | 0;
       i3 = HEAP8[i7 >> 0] | 0;
       i4 = HEAP32[i10 >> 2] | 0;
       if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0) >>> 0 > i2 >>> 0) {
        i8 = (Math_imul(i4, i16) | 0) + (i8 & 255) | 0;
        i7 = i5 << 24 >> 24 == 2;
        __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv(HEAP32[gb + 1451080 >> 2] | 0, i2, i6, i5 << 24 >> 24 == 4 ? 2 : i7 & 1, i7 ? 4 : i3 & 255, i5 & 255, i4, i8);
        i1 = 1 << i2 | i1;
        break;
       } else {
        i8 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0;
        HEAP32[i12 >> 2] = i2;
        HEAP32[i12 + 4 >> 2] = i8;
        _printf_console(gb + 611922 | 0, i12);
        break;
       }
      } while (0);
     }
    }
    i2 = i2 + 1 | 0;
   }
   i8 = i9;
   i9 = i9 + 1 | 0;
  } while (!((i8 | 0) > 6 | (i13 >>> i9 | 0) == 0));
 } while (0);
 i3 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 548 >> 2] | 0;
 if (i3 >>> 0 > 1) i2 = 1; else {
  STACKTOP = i19;
  return;
 }
 do {
  if (!(1 << i2 & i1)) __ZN7ApiGLES24DisableVertexArrayAttribEj(HEAP32[gb + 1451080 >> 2] | 0, i2);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i19;
 return;
}

function __ZN19ComputeShaderKernel8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i5 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i8 >> 2] = i6;
 i12 = i10 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 16 | 0;
 i7 = i9 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i9 + 28 | 0, 0);
 i3 = i9 + 40 | 0;
 i7 = i9 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 52 | 0;
 i7 = i9 + 56 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i9 + 76 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = HEAP32[i9 + 64 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i12 = i9 + 84 | 0;
  __Z13TransferArrayILi3Ej19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_(i12, gb + 469562 | 0, i10);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i12 = i9 + 84 | 0;
 __Z13TransferArrayILi3Ej19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_(i12, gb + 469562 | 0, i10);
 STACKTOP = i13;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 192 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 192 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 192 | 0;
  i3 = (i2 | 0) / 192 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 22369621) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 192 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i2, i1);
     i1 = i1 + 192 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 192 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -192 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN9ShaderLab20SerializedSubProgramD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 192 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 192 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 192 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 192 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 192 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -192 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -192 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function runPostSets8() {
 HEAP32[gb + 28556 >> 2] = fb + 63;
 HEAP32[gb + 28560 >> 2] = fb + 29;
 HEAP32[gb + 28564 >> 2] = fb + 34;
 HEAP32[gb + 28568 >> 2] = fb + 41;
 HEAP32[gb + 28572 >> 2] = fb + 42;
 HEAP32[gb + 28576 >> 2] = fb + 43;
 HEAP32[gb + 28580 >> 2] = fb + 44;
 HEAP32[gb + 28584 >> 2] = fb + 45;
 HEAP32[gb + 28588 >> 2] = fb + 46;
 HEAP32[gb + 28592 >> 2] = fb + 36;
 HEAP32[gb + 28596 >> 2] = fb + 96;
 HEAP32[gb + 28600 >> 2] = fb + 81;
 HEAP32[gb + 28604 >> 2] = fb + 82;
 HEAP32[gb + 28616 >> 2] = (HEAP32[gb + 28616 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28620 >> 2] = (HEAP32[gb + 28620 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28656 >> 2] = fb + 85;
 HEAP32[gb + 28660 >> 2] = fb + 86;
 HEAP32[gb + 28664 >> 2] = fb + 80;
 HEAP32[gb + 28668 >> 2] = fb + 39;
 HEAP32[gb + 28672 >> 2] = fb + 16;
 HEAP32[gb + 28676 >> 2] = fb + 39;
 HEAP32[gb + 28680 >> 2] = fb + 40;
 HEAP32[gb + 28684 >> 2] = fb + 19;
 HEAP32[gb + 28688 >> 2] = fb + 98;
 HEAP32[gb + 28692 >> 2] = fb + 99;
 HEAP32[gb + 28696 >> 2] = fb + 40;
 HEAP32[gb + 28700 >> 2] = fb + 62;
 HEAP32[gb + 28704 >> 2] = fb + 28;
 HEAP32[gb + 28708 >> 2] = fb + 63;
 HEAP32[gb + 28712 >> 2] = fb + 29;
 HEAP32[gb + 28716 >> 2] = fb + 34;
 HEAP32[gb + 28720 >> 2] = fb + 85;
 HEAP32[gb + 28724 >> 2] = fb + 86;
 HEAP32[gb + 28728 >> 2] = fb + 87;
 HEAP32[gb + 28732 >> 2] = fb + 88;
 HEAP32[gb + 28736 >> 2] = fb + 89;
 HEAP32[gb + 28740 >> 2] = fb + 90;
 HEAP32[gb + 28744 >> 2] = fb + 36;
 HEAP32[gb + 28748 >> 2] = fb + 96;
 HEAP32[gb + 28752 >> 2] = fb + 81;
 HEAP32[gb + 28756 >> 2] = fb + 82;
 HEAP32[gb + 28768 >> 2] = (HEAP32[gb + 28768 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28772 >> 2] = (HEAP32[gb + 28772 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28808 >> 2] = fb + 87;
 HEAP32[gb + 28812 >> 2] = fb + 88;
 HEAP32[gb + 28816 >> 2] = fb + 38;
 HEAP32[gb + 28820 >> 2] = fb + 91;
 HEAP32[gb + 28824 >> 2] = fb + 16;
 HEAP32[gb + 28828 >> 2] = fb + 89;
 HEAP32[gb + 28832 >> 2] = fb + 90;
 HEAP32[gb + 28836 >> 2] = fb + 19;
 HEAP32[gb + 28840 >> 2] = fb + 100;
 HEAP32[gb + 28844 >> 2] = fb + 101;
 HEAP32[gb + 28848 >> 2] = fb + 92;
 HEAP32[gb + 28852 >> 2] = fb + 62;
 HEAP32[gb + 28856 >> 2] = fb + 93;
 HEAP32[gb + 28860 >> 2] = fb + 63;
 HEAP32[gb + 28864 >> 2] = fb + 29;
 HEAP32[gb + 28868 >> 2] = fb + 34;
 HEAP32[gb + 28872 >> 2] = fb + 94;
 HEAP32[gb + 28876 >> 2] = fb + 95;
 HEAP32[gb + 28880 >> 2] = fb + 96;
 HEAP32[gb + 28884 >> 2] = fb + 97;
 HEAP32[gb + 28888 >> 2] = fb + 98;
 HEAP32[gb + 28892 >> 2] = fb + 99;
 HEAP32[gb + 28896 >> 2] = fb + 36;
 HEAP32[gb + 28908 >> 2] = (HEAP32[gb + 28908 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28912 >> 2] = (HEAP32[gb + 28912 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28948 >> 2] = (HEAP32[gb + 28948 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28952 >> 2] = (HEAP32[gb + 28952 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28988 >> 2] = (HEAP32[gb + 28988 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28992 >> 2] = (HEAP32[gb + 28992 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29028 >> 2] = (HEAP32[gb + 29028 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 29032 >> 2] = (HEAP32[gb + 29032 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 29068 >> 2] = fb + 91;
 HEAP32[gb + 29072 >> 2] = fb + 92;
 HEAP32[gb + 29076 >> 2] = fb + 38;
 HEAP32[gb + 29080 >> 2] = fb + 100;
 HEAP32[gb + 29084 >> 2] = fb + 16;
 HEAP32[gb + 29088 >> 2] = fb + 93;
 HEAP32[gb + 29092 >> 2] = fb + 40;
 HEAP32[gb + 29096 >> 2] = fb + 19;
 HEAP32[gb + 29100 >> 2] = fb + 102;
 HEAP32[gb + 29104 >> 2] = fb + 103;
 HEAP32[gb + 29108 >> 2] = fb + 101;
 HEAP32[gb + 29112 >> 2] = fb + 62;
 HEAP32[gb + 29116 >> 2] = fb + 28;
 HEAP32[gb + 29120 >> 2] = fb + 63;
 HEAP32[gb + 29124 >> 2] = fb + 29;
 HEAP32[gb + 29128 >> 2] = fb + 34;
 HEAP32[gb + 29132 >> 2] = fb + 102;
 HEAP32[gb + 29136 >> 2] = fb + 103;
 HEAP32[gb + 29140 >> 2] = fb + 104;
 HEAP32[gb + 29144 >> 2] = fb + 105;
 HEAP32[gb + 29148 >> 2] = fb + 106;
 HEAP32[gb + 29152 >> 2] = fb + 107;
 HEAP32[gb + 29156 >> 2] = fb + 36;
 HEAP32[gb + 29160 >> 2] = fb + 104;
 HEAP32[gb + 29164 >> 2] = fb + 108;
 HEAP32[gb + 29168 >> 2] = fb + 94;
 runPostSets9();
}

function __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeYSorterP16DetailMeshBVNodeEEbT0_S5_T_(i13, i14, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f15 = f0;
 switch ((i14 - i13 | 0) / 28 | 0 | 0) {
 case 2:
  {
   i2 = i14 + -28 | 0;
   i3 = i14 + -24 | 0;
   i1 = i14 + -12 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
   f4 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f5 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) {
    i14 = 1;
    return i14 | 0;
   }
   i8 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i13 + 8 >> 2] | 0;
   i10 = HEAP32[i13 + 12 >> 2] | 0;
   i11 = HEAP32[i13 + 20 >> 2] | 0;
   i12 = HEAP32[i13 + 24 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i2 >> 2] = i8;
   HEAPF32[i3 >> 2] = f4;
   HEAP32[i14 + -20 >> 2] = i9;
   HEAP32[i14 + -16 >> 2] = i10;
   HEAPF32[i1 >> 2] = f5;
   HEAP32[i14 + -8 >> 2] = i11;
   HEAP32[i14 + -4 >> 2] = i12;
   i14 = 1;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i13 + 84 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   return i14 | 0;
  }
 default:
  {
   i3 = i13 + 56 | 0;
   __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i3, i1) | 0;
   i1 = i13 + 84 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
     f15 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
     f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     if (f15 < Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i3 + 16 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 >> 2] | 0;
      i9 = HEAP32[i1 + 8 >> 2] | 0;
      i10 = HEAP32[i1 + 12 >> 2] | 0;
      i11 = HEAP32[i1 + 20 >> 2] | 0;
      i12 = HEAP32[i1 + 24 >> 2] | 0;
      f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       if ((i3 | 0) == (i13 | 0)) {
        i3 = i13;
        break;
       }
       f15 = Math_fround(HEAPF32[i3 + -24 >> 2]);
       if (f4 < Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i3 + -12 >> 2])) * Math_fround(.5))) {
        i6 = i3;
        i3 = i3 + -28 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i8;
      HEAPF32[i3 + 4 >> 2] = f5;
      HEAP32[i3 + 8 >> 2] = i9;
      HEAP32[i3 + 12 >> 2] = i10;
      HEAPF32[i3 + 16 >> 2] = f7;
      HEAP32[i3 + 20 >> 2] = i11;
      HEAP32[i3 + 24 >> 2] = i12;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 28 | 0) == (i14 | 0);
       break L3;
      }
     }
     i3 = i1 + 28 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i12 = i1;
      i1 = i3;
      i3 = i12;
     }
    }
   } while (0);
   i14 = i1 | i2;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZNSt3__218__insertion_sort_3IRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i7 + 32 | 0;
 i5 = i7 + 16 | 0;
 i4 = mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i7 | 0) | 0;
 i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i5 | 0) | 0;
 do if (i4) {
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP16[i6 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   i5 = i7 + 36 | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i4 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP16[i5 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
   break;
  }
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  i2 = i7 + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP16[i4 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP16[i2 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i5 | 0) | 0) {
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP16[i6 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i7 + 36 | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i2 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP16[i5 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
  }
 } else if (i2) {
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i7 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP16[i6 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i4 = i7 + 36 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP16[i2 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP16[i4 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i7 | 0) | 0) {
   i4 = HEAP32[i7 >> 2] | 0;
   i3 = i7 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP16[i6 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP16[i3 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP16[i2 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
  }
 } while (0);
 i2 = i7 + 48 | 0;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = i6 + 4 | 0;
 while (1) {
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i2 | 0, i1 | 0) | 0) {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i3 = i2;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i4 = i3 + 4 | 0;
    i3 = i1 + 4 | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP16[i4 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
    if ((i1 | 0) == (i7 | 0)) break;
    i4 = i1 + -16 | 0;
    if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, i4 | 0) | 0) {
     i3 = i1;
     i1 = i4;
    } else break;
   }
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP16[i3 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
  }
  i1 = i2 + 16 | 0;
  if ((i1 | 0) == (i8 | 0)) break; else {
   i4 = i2;
   i2 = i1;
   i1 = i4;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i11, i12, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i15 = i18 + 24 | 0;
 i16 = i18 + 8 | 0;
 i1 = __Z12GetIVRDevicev() | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  __Z12SetIVRDeviceP9IVRDevice(0);
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63816 | 0);
  HEAP32[i11 + 16 >> 2] = HEAP32[gb + 189476 >> 2];
  HEAP8[i11 + 20 >> 0] = 0;
 }
 HEAP32[i16 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i7 = i12 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 L4 : do if ((HEAP32[i7 >> 2] | 0) == (i1 | 0)) i17 = 25; else {
  i8 = i16 + 11 | 0;
  i9 = i16 + 4 | 0;
  i10 = i16 + 8 | 0;
  i6 = 0;
  while (1) {
   i2 = i1 + (i6 << 4) | 0;
   do if ((i16 | 0) != (i2 | 0)) {
    i4 = HEAP8[i2 + 11 >> 0] | 0;
    i3 = i4 << 24 >> 24 < 0;
    i5 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
    i4 = i3 ? HEAP32[i1 + (i6 << 4) + 4 >> 2] | 0 : i4 & 255;
    i1 = HEAP8[i8 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i10 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    if (i4 >>> 0 > i3 >>> 0) {
     i2 = i2 ? HEAP32[i9 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i16, i3, i4 - i3 | 0, i2, 0, i2, i4, i5);
     break;
    }
    i1 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
    if (i4 | 0) _memmove(i1 | 0, i5 | 0, i4 | 0) | 0;
    HEAP8[i1 + i4 >> 0] = 0;
    if ((HEAP8[i8 >> 0] | 0) < 0) {
     HEAP32[i9 >> 2] = i4;
     break;
    } else {
     HEAP8[i8 >> 0] = i4;
     break;
    }
   } while (0);
   i1 = HEAP8[i8 >> 0] | 0;
   i4 = i1 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i16 >> 2] | 0 : i16;
   i1 = i4 ? HEAP32[i9 >> 2] | 0 : i1 & 255;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, i5, i1);
   i1 = __Z21GetVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i15) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   if (i1 | 0) {
    if (!(_strncmp(i1, HEAP32[gb + 189476 >> 2] | 0, 64) | 0)) {
     i17 = 17;
     break;
    }
    i2 = __ZnwjRK10MemLabelIdiPKci(376, gb + 63816 | 0, 16, gb + 1046195 | 0, 170) | 0;
    __ZN8VRDeviceC2EPK23UnityVRDeviceDefinition(i2, i1);
    __Z12SetIVRDeviceP9IVRDevice(i2);
    if (!i13) break;
    i4 = __Z12GetIVRDevicev() | 0;
    i5 = HEAP16[i11 >> 1] | 0;
    if (__ZN8VRDevice10InitializeEb(i4, (i5 & 65535) > 255 | (i5 & 255) << 24 >> 24 == 0) | 0) break;
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
    __Z12SetIVRDeviceP9IVRDevice(0);
    if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63816 | 0);
   }
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   if (i6 >>> 0 >= (HEAP32[i7 >> 2] | 0) - i1 >> 4 >>> 0) {
    i17 = 25;
    break L4;
   }
  }
  if ((i17 | 0) == 17) {
   HEAP8[i11 >> 0] = 0;
   HEAP32[i11 + 16 >> 2] = i1;
   HEAP8[i11 + 20 >> 0] = i13 & 1;
   i17 = 25;
   break;
  }
  HEAP32[i11 + 16 >> 2] = i1;
  HEAP8[i11 + 20 >> 0] = i13 & 1;
  HEAP8[i11 >> 0] = 0;
  if ((i2 | 0) == 0 | i13 ^ 1) i17 = 25; else {
   i1 = i16 + 11 | 0;
   HEAP32[i14 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16;
   _printf_console(gb + 1046354 | 0, i14);
  }
 } while (0);
 if ((i17 | 0) == 25) i1 = i16 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i18;
  return;
 }
 i17 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = 66;
 HEAP32[i15 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i17, i15);
 STACKTOP = i18;
 return;
}

function __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i9 = mftCall_iii(HEAP32[i6 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 i1 = mftCall_iii(HEAP32[i6 >> 2] | 0, i4 | 0, i3 | 0) | 0;
 do if (i9) {
  if (i1) {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i1 = 1;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if (mftCall_iii(HEAP32[i6 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if (mftCall_iii(HEAP32[i6 >> 2] | 0, i3 | 0, i2 | 0) | 0) {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i6 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
  i9 = i1;
  STACKTOP = i8;
  return i9 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if (!(mftCall_iii(HEAP32[i6 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
  i9 = i1 + 1 | 0;
  STACKTOP = i8;
  return i9 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if (!(mftCall_iii(HEAP32[i6 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
  i9 = i1 + 2 | 0;
  STACKTOP = i8;
  return i9 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i9 = i1 + 3 | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeZSorterP16DetailMeshBVNodeEEbT0_S5_T_(i13, i14, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f15 = f0;
 switch ((i14 - i13 | 0) / 28 | 0 | 0) {
 case 2:
  {
   i2 = i14 + -28 | 0;
   i3 = i14 + -20 | 0;
   i1 = i14 + -8 | 0;
   f7 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
   f4 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   if (!(f7 < Math_fround(Math_fround(f4 + f5) * Math_fround(.5)))) {
    i14 = 1;
    return i14 | 0;
   }
   i8 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i13 + 4 >> 2] | 0;
   i10 = HEAP32[i13 + 12 >> 2] | 0;
   i11 = HEAP32[i13 + 16 >> 2] | 0;
   i12 = HEAP32[i13 + 24 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i2 >> 2] = i8;
   HEAP32[i14 + -24 >> 2] = i9;
   HEAPF32[i3 >> 2] = f4;
   HEAP32[i14 + -16 >> 2] = i10;
   HEAP32[i14 + -12 >> 2] = i11;
   HEAPF32[i1 >> 2] = f5;
   HEAP32[i14 + -4 >> 2] = i12;
   i14 = 1;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_(i13, i13 + 28 | 0, i13 + 56 | 0, i13 + 84 | 0, i14 + -28 | 0, i1) | 0;
   i14 = 1;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   return i14 | 0;
  }
 default:
  {
   i3 = i13 + 56 | 0;
   __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i13, i13 + 28 | 0, i3, i1) | 0;
   i1 = i13 + 84 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
     f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
     f15 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
     f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     if (f15 < Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i3 + 20 >> 2])) * Math_fround(.5))) {
      i8 = HEAP32[i1 >> 2] | 0;
      i9 = HEAP32[i1 + 4 >> 2] | 0;
      i10 = HEAP32[i1 + 12 >> 2] | 0;
      i11 = HEAP32[i1 + 16 >> 2] | 0;
      i12 = HEAP32[i1 + 24 >> 2] | 0;
      f4 = Math_fround(Math_fround(f5 + f7) * Math_fround(.5));
      i6 = i1;
      while (1) {
       HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
       HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
       HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
       if ((i3 | 0) == (i13 | 0)) {
        i3 = i13;
        break;
       }
       f15 = Math_fround(HEAPF32[i3 + -20 >> 2]);
       if (f4 < Math_fround(Math_fround(f15 + Math_fround(HEAPF32[i3 + -8 >> 2])) * Math_fround(.5))) {
        i6 = i3;
        i3 = i3 + -28 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i8;
      HEAP32[i3 + 4 >> 2] = i9;
      HEAPF32[i3 + 8 >> 2] = f5;
      HEAP32[i3 + 12 >> 2] = i10;
      HEAP32[i3 + 16 >> 2] = i11;
      HEAPF32[i3 + 20 >> 2] = f7;
      HEAP32[i3 + 24 >> 2] = i12;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 28 | 0) == (i14 | 0);
       break L3;
      }
     }
     i3 = i1 + 28 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i12 = i1;
      i1 = i3;
      i3 = i12;
     }
    }
   } while (0);
   i14 = i1 | i2;
   return i14 | 0;
  }
 }
 return 0;
}

function __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram16TextureParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i11 + 4 | 0;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471202 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899057 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471276 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 28 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i10 >> 0] = i1;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471291 | 0, HEAP32[gb + 37252 >> 2] | 0, i8, 0) | 0;
 if (!i2) {
  i10 = i1;
  i10 = i10 << 24 >> 24;
  HEAP32[i4 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 do if ((i2 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) {
   i3 = i2 + 1 | 0;
   if (i3 >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = i3;
    break;
   }
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 i10 = HEAP8[i10 >> 0] | 0;
 i10 = i10 << 24 >> 24;
 HEAP32[i4 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZL21ConnectLeftDegenerateP14TESStesselatorP12ActiveRegionP10TESSvertex(i11, i5, i9) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 if (f4 == f2) {
  f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  if (f4 == Math_fround(HEAPF32[i9 + 28 >> 2])) if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i11 >> 2] | 0, i6, HEAP32[i9 + 8 >> 2] | 0) | 0)) _longjmp(i11 + 144 | 0, 1); else return;
 }
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (Math_fround(HEAPF32[i1 + 24 >> 2]) == f2) {
  f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
  if (f4 == Math_fround(HEAPF32[i9 + 28 >> 2])) {
   i7 = i5;
   do i7 = HEAP32[HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 4 >> 2] >> 2] | 0; while ((HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] | 0) == (i1 | 0));
   i1 = HEAP32[HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 8 >> 2] >> 2] | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = HEAP32[i5 + 8 >> 2] | 0;
   do if (!(HEAP32[i1 + 24 >> 2] | 0)) {
    i10 = i5;
    i8 = i11;
   } else {
    HEAP32[i3 + 24 >> 2] = 0;
    i3 = HEAP32[i11 + 64 >> 2] | 0;
    i12 = HEAP32[i1 + 4 >> 2] | 0;
    i13 = i12 + 8 | 0;
    i14 = HEAP32[i12 + 4 >> 2] | 0;
    HEAP32[i14 + 8 >> 2] = HEAP32[i13 >> 2];
    HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] = i14;
    i3 = HEAP32[i3 + 16 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i3 >> 2] = i12;
    i3 = HEAP32[i11 + 76 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i3 >> 2] = i1;
    if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i11 >> 2] | 0, i5) | 0)) _longjmp(i11 + 144 | 0, 1); else {
     i10 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 12 >> 2] | 0;
     i8 = i11;
     break;
    }
   } while (0);
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i8 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0, i10) | 0)) _longjmp(i11 + 144 | 0, 1);
   i1 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 16 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   i3 = HEAP32[i6 + 16 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
   do if (f2 < f4) i1 = i6; else {
    if (f2 == f4) {
     f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     if (f4 <= Math_fround(HEAPF32[i3 + 28 >> 2])) {
      i1 = i6;
      break;
     }
    }
    i1 = 0;
   } while (0);
   __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i(i11, i7, HEAP32[i10 + 8 >> 2] | 0, i6, i1, 1);
   return;
  }
 }
 i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(HEAP32[i11 >> 2] | 0, i3) | 0;
 if (!i1) {
  i14 = i11 + 144 | 0;
  _longjmp(i14 | 0, 1);
 }
 i14 = HEAP32[i1 + 4 >> 2] | 0;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i12 + 4 >> 2] | 0) + 12 >> 2] | 0;
 i8 = i12 + 8 | 0;
 i13 = HEAP32[i8 >> 2] | 0;
 i10 = i1 + 8 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 12 >> 2] = i1;
 HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i12;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i10 >> 2] = i13;
 i10 = HEAP32[i8 >> 2] | 0;
 i13 = i14 + 8 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 HEAP32[(HEAP32[i10 + 4 >> 2] | 0) + 12 >> 2] = i14;
 HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i12;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[(HEAP32[i13 + 16 >> 2] | 0) + 8 >> 2] = i13;
 HEAP32[i13 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 if (!i14) {
  i14 = i11 + 144 | 0;
  _longjmp(i14 | 0, 1);
 }
 i1 = i5 + 24 | 0;
 do if (HEAP32[i1 >> 2] | 0) if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i11 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0)) _longjmp(i11 + 144 | 0, 1); else {
  HEAP32[i1 >> 2] = 0;
  break;
 } while (0);
 if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i11 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0, i6) | 0)) _longjmp(i11 + 144 | 0, 1);
 __ZL10SweepEventP14TESStesselatorP10TESSvertex(i11, i9);
 return;
}

function _processblock(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = 0;
 do {
  i13 = i1 << 2;
  HEAP32[i14 + (i1 << 2) >> 2] = (HEAPU8[i2 + (i13 | 3) >> 0] | 0) << 24 | ((HEAPU8[i2 + (i13 | 2) >> 0] | 0) << 16 | ((HEAPU8[i2 + (i13 | 1) >> 0] | 0) << 8 | (HEAPU8[i2 + i13 >> 0] | 0)));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 i8 = i3 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i3 + 12 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i3 + 16 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i6 = i3 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i13;
 i4 = i11;
 i2 = i9;
 i1 = i7;
 i5 = 0;
 do {
  i2 = ((i1 ^ i3) & i4 ^ i1) + i2 + (HEAP32[i14 + (i5 << 2) >> 2] | 0) + (HEAP32[gb + 203204 + (i5 << 2) >> 2] | 0) | 0;
  i2 = (i2 >>> 25 | i2 << 7) + i4 | 0;
  i16 = i5 | 1;
  i1 = (HEAP32[i14 + (i16 << 2) >> 2] | 0) + i1 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + (i2 & (i3 ^ i4) ^ i3) | 0;
  i1 = (i1 >>> 20 | i1 << 12) + i2 | 0;
  i16 = i5 | 2;
  i3 = (HEAP32[i14 + (i16 << 2) >> 2] | 0) + i3 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + (i1 & (i2 ^ i4) ^ i4) | 0;
  i3 = (i3 >>> 15 | i3 << 17) + i1 | 0;
  i16 = i5 | 3;
  i4 = (HEAP32[i14 + (i16 << 2) >> 2] | 0) + i4 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + (i3 & (i1 ^ i2) ^ i2) | 0;
  i4 = (i4 >>> 10 | i4 << 22) + i3 | 0;
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < 16);
 i5 = 16;
 do {
  i2 = (i1 & (i3 ^ i4) ^ i3) + i2 + (HEAP32[i14 + ((i5 * 5 & 12 | 1) << 2) >> 2] | 0) + (HEAP32[gb + 203204 + (i5 << 2) >> 2] | 0) | 0;
  i2 = (i2 >>> 27 | i2 << 5) + i4 | 0;
  i16 = i5 | 1;
  i1 = (HEAP32[i14 + (((i16 * 5 | 0) + 1 & 15) << 2) >> 2] | 0) + i1 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + ((i2 ^ i4) & i3 ^ i4) | 0;
  i1 = (i1 >>> 23 | i1 << 9) + i2 | 0;
  i16 = i5 | 2;
  i3 = (HEAP32[i14 + ((i16 * 5 & 14 | 1) << 2) >> 2] | 0) + i3 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + ((i1 ^ i2) & i4 ^ i2) | 0;
  i3 = (i3 >>> 18 | i3 << 14) + i1 | 0;
  i16 = i5 | 3;
  i4 = (HEAP32[i14 + (((i16 * 5 | 0) + 1 & 15) << 2) >> 2] | 0) + i4 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + ((i3 ^ i1) & i2 ^ i1) | 0;
  i4 = (i4 >>> 12 | i4 << 20) + i3 | 0;
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < 32);
 i5 = 32;
 do {
  i16 = i3 ^ i4;
  i2 = (i16 ^ i1) + i2 + (HEAP32[i14 + (((i5 * 3 | 0) + 5 & 13) << 2) >> 2] | 0) + (HEAP32[gb + 203204 + (i5 << 2) >> 2] | 0) | 0;
  i2 = (i2 >>> 28 | i2 << 4) + i4 | 0;
  i17 = i5 | 1;
  i1 = (HEAP32[i14 + (((i17 * 3 | 0) + 5 & 15) << 2) >> 2] | 0) + i1 + (HEAP32[gb + 203204 + (i17 << 2) >> 2] | 0) + (i16 ^ i2) | 0;
  i1 = (i1 >>> 21 | i1 << 11) + i2 | 0;
  i16 = i5 | 2;
  i3 = (HEAP32[i14 + (((i16 * 3 | 0) + 5 & 15) << 2) >> 2] | 0) + i3 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + (i2 ^ i4 ^ i1) | 0;
  i3 = (i3 >>> 16 | i3 << 16) + i1 | 0;
  i16 = i5 | 3;
  i4 = (HEAP32[i14 + (((i16 * 3 | 0) + 5 & 15) << 2) >> 2] | 0) + i4 + (HEAP32[gb + 203204 + (i16 << 2) >> 2] | 0) + (i1 ^ i2 ^ i3) | 0;
  i4 = (i4 >>> 9 | i4 << 23) + i3 | 0;
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < 48);
 i5 = i3;
 i3 = i2;
 i2 = 48;
 do {
  i17 = ((i4 | ~i1) ^ i5) + i3 + (HEAP32[i14 + ((i2 * 7 & 12) << 2) >> 2] | 0) + (HEAP32[gb + 203204 + (i2 << 2) >> 2] | 0) | 0;
  i3 = (i17 >>> 26 | i17 << 6) + i4 | 0;
  i17 = i2 | 1;
  i17 = (HEAP32[i14 + ((i17 * 7 & 15) << 2) >> 2] | 0) + i1 + (HEAP32[gb + 203204 + (i17 << 2) >> 2] | 0) + ((i3 | ~i5) ^ i4) | 0;
  i1 = (i17 >>> 22 | i17 << 10) + i3 | 0;
  i17 = i2 | 2;
  i17 = (HEAP32[i14 + ((i17 * 7 & 14) << 2) >> 2] | 0) + i5 + (HEAP32[gb + 203204 + (i17 << 2) >> 2] | 0) + ((i1 | ~i4) ^ i3) | 0;
  i5 = (i17 >>> 17 | i17 << 15) + i1 | 0;
  i17 = i2 | 3;
  i17 = (HEAP32[i14 + ((i17 * 7 & 15) << 2) >> 2] | 0) + i4 + (HEAP32[gb + 203204 + (i17 << 2) >> 2] | 0) + ((i5 | ~i3) ^ i1) | 0;
  i4 = (i17 >>> 11 | i17 << 21) + i5 | 0;
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < 64);
 HEAP32[i8 >> 2] = i9 + i3;
 HEAP32[i10 >> 2] = i11 + i4;
 HEAP32[i12 >> 2] = i13 + i5;
 HEAP32[i6 >> 2] = i7 + i1;
 STACKTOP = i15;
 return;
}

function __ZN5Umbra8QueryExt16queryLineSegmentEPNS_16LineSegmentQueryEi(i1, i13, i14) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 if ((i13 | 0) == 0 | (i14 | 0) == 0) {
  i17 = 3;
  STACKTOP = i18;
  return i17 | 0;
 }
 i10 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i17 >> 2] = i10;
 i2 = HEAP32[i10 + 76 >> 2] | 0;
 HEAP32[i17 + 4 >> 2] = i2;
 i16 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i16 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i16 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i17 + 8 >> 2] = i1;
 i12 = i1 + i4 | 0;
 HEAP32[i17 + 12 >> 2] = i12;
 i15 = i17 + 16 | 0;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i17 + 20 >> 2] = i4;
 i11 = i17 + 24 | 0;
 i16 = i17 + 28 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i17 + 40 >> 2] = -1;
 i11 = HEAP32[i10 + 84 >> 2] | 0;
 HEAP32[i17 + 44 >> 2] = i11;
 i5 = i17 + 48 | 0;
 HEAP32[i5 >> 2] = i11;
 HEAP32[i17 + 52 >> 2] = 0;
 HEAP32[i17 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i3 = 0; else {
  i2 = i1 + 80 | 0;
  HEAP32[i15 >> 2] = i2;
  if (!i1) {
   i3 = 0;
   i1 = i2;
  } else {
   HEAP32[i1 >> 2] = 13;
   i3 = i1 + 16 | 0;
   i1 = i2;
  }
 }
 HEAP32[i17 + 60 >> 2] = i3;
 i2 = i3;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 if (!(HEAP32[i10 >> 2] | 0)) i1 = 6; else {
  i4 = i17 + 4 | 0;
  i2 = i1 + 4448 | 0;
  if (i2 >>> 0 > i12 >>> 0) i11 = 0; else {
   HEAP32[i15 >> 2] = i2;
   i11 = i1;
   i1 = i2;
  }
  HEAP32[i11 >> 2] = i17;
  i2 = i11 + 3076 | 0;
  i3 = i11 + 4 | 0;
  do {
   HEAP32[i3 >> 2] = -1;
   i3 = i3 + 12 | 0;
  } while ((i3 | 0) != (i2 | 0));
  i21 = i11 + 4120 | 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  HEAP32[i21 + 12 >> 2] = 0;
  HEAP32[i21 + 16 >> 2] = 0;
  HEAP32[i21 + 20 >> 2] = 0;
  HEAP32[i21 + 24 >> 2] = 0;
  HEAP32[i11 + 4152 >> 2] = i4;
  i21 = i17 + 44 | 0;
  i7 = i11 + 4164 | 0;
  HEAP32[i7 >> 2] = i21;
  i20 = HEAP32[i5 >> 2] | 0;
  i9 = i11 + 4168 | 0;
  HEAP32[i9 >> 2] = i20;
  HEAP32[i11 + 4172 >> 2] = 36;
  HEAP32[i11 + 4188 >> 2] = i4;
  i6 = i11 + 4200 | 0;
  HEAP32[i6 >> 2] = i21;
  i8 = i11 + 4204 | 0;
  HEAP32[i8 >> 2] = i20 + 1;
  HEAP32[i11 + 4208 >> 2] = 8;
  i3 = i11 + 4224 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i3 + 136 >> 2] | 0;
  i19 = (HEAP32[i3 + 144 >> 2] | 0) + 1 | 0;
  HEAP32[i11 + 4260 >> 2] = i4;
  i4 = i11 + 4272 | 0;
  HEAP32[i4 >> 2] = i21;
  HEAP32[i5 >> 2] = i20 + 3;
  i5 = i11 + 4276 | 0;
  HEAP32[i5 >> 2] = i20 + 2;
  HEAP32[i11 + 4280 >> 2] = 4;
  HEAP32[i11 + 4292 >> 2] = i19;
  HEAP32[i11 + 4264 >> 2] = (i2 | 0) == 0 ? 0 : i3 + i2 | 0;
  _memset(i11 + 4296 | 0, 0, 144) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i2 + 136 >> 2] | 0;
  if (!i3) i2 = 0; else i2 = (HEAP32[i2 + i3 + (HEAP32[i2 + 144 >> 2] << 2) >> 2] | 0) + 31 >> 5 << 2;
  i3 = i1 + (i2 + 15 & -16) | 0;
  if (i3 >>> 0 > i12 >>> 0) i1 = 0; else {
   HEAP32[i15 >> 2] = i3;
   if (!i1) i1 = 0; else _memset(i1 | 0, 0, i2 | 0) | 0;
  }
  i21 = i11 + 4148 | 0;
  HEAP32[i21 >> 2] = i1;
  __ZN5Umbra17LineSegmentFinder7executeEPNS_19ImpLineSegmentQueryEi(i11, i13, i14);
  i1 = HEAP32[i21 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 >> 2] = i11;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 __ZN5Umbra12QueryContextD2Ev(i17);
 i21 = i1;
 STACKTOP = i18;
 return i21 | 0;
}

function __ZN19ComputeShaderKernelC2ERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i3 = i8 + 4 | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i6 = i9 + 8 | 0;
 i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i2 = (i1 | 0) / 20 | 0;
 if (i1 | 0) {
  if (i2 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
  i5 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i8 + 12 >> 2] = i5 + (i2 * 20 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i5 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i5 + (((i1 >>> 0) / 20 | 0) * 20 | 0);
  }
 }
 i2 = i8 + 16 | 0;
 i3 = i9 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i8 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 i5 = i9 + 20 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 20 | 0;
 if (i1 | 0) {
  if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i6 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i8 + 24 >> 2] = i6 + (i4 * 20 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i6 + (((i1 >>> 0) / 20 | 0) * 20 | 0);
  }
 }
 i2 = i8 + 28 | 0;
 i3 = i9 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i8 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 36 >> 2] = 0;
 i5 = i9 + 32 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 >> 3;
 if (i4 | 0) {
  if (i4 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i6 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i8 + 36 >> 2] = i6 + (i4 << 3);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i6 + (i1 >> 3 << 3);
  }
 }
 i2 = i8 + 40 | 0;
 i3 = i9 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i8 + 44 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 i5 = i9 + 44 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 20 | 0;
 if (i1 | 0) {
  if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i6 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i8 + 48 >> 2] = i6 + (i4 * 20 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i6 + (((i1 >>> 0) / 20 | 0) * 20 | 0);
  }
 }
 i2 = i8 + 52 | 0;
 i3 = i9 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i8 + 56 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 i5 = i9 + 56 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 20 | 0;
 if (!i1) {
  i6 = i8 + 64 | 0;
  i7 = i9 + 64 | 0;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i6, i7);
  i8 = i8 + 84 | 0;
  i9 = i9 + 84 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  return;
 }
 if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
 i6 = __Znwj(i1) | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i8 + 60 >> 2] = i6 + (i4 * 20 | 0);
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) {
  i6 = i8 + 64 | 0;
  i7 = i9 + 64 | 0;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i6, i7);
  i8 = i8 + 84 | 0;
  i9 = i9 + 84 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  return;
 }
 _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6 + (((i1 >>> 0) / 20 | 0) * 20 | 0);
 i6 = i8 + 64 | 0;
 i7 = i9 + 64 | 0;
 __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i6, i7);
 i8 = i8 + 84 | 0;
 i9 = i9 + 84 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 return;
}

function __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 16 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 32 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 36 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 40 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 12 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZNSt3__218__insertion_sort_3IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i9 + 32 | 0;
 i4 = i9 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i1 = (i6 | 0) < (i2 | 0);
 do if ((i2 | 0) < (i5 | 0)) {
  if (i1) {
   HEAP32[i9 >> 2] = i6;
   HEAP32[i3 >> 2] = i5;
   i6 = i9 + 4 | 0;
   i2 = i9 + 36 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i2 = i5;
   break;
  }
  HEAP32[i9 >> 2] = i2;
  HEAP32[i4 >> 2] = i5;
  i2 = i9 + 4 | 0;
  i1 = i9 + 20 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if ((i6 | 0) < (i5 | 0)) {
   HEAP32[i4 >> 2] = i6;
   HEAP32[i3 >> 2] = i5;
   i2 = i9 + 36 | 0;
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i2 = i5;
  } else i2 = i6;
 } else if (i1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i3 >> 2] = i2;
  i1 = i9 + 20 | 0;
  i11 = i9 + 36 | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if ((i6 | 0) < (i5 | 0)) {
   HEAP32[i9 >> 2] = i6;
   HEAP32[i4 >> 2] = i5;
   i11 = i9 + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
 } else i2 = i6; while (0);
 i1 = i9 + 48 | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i8;
  return;
 }
 i6 = i1;
 i1 = i2;
 while (1) {
  i5 = HEAP32[i6 >> 2] | 0;
  if ((i5 | 0) < (i1 | 0)) {
   i4 = i6 + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i4 = i3;
   i1 = i6;
   i3 = HEAP32[i3 >> 2] | 0;
   while (1) {
    HEAP32[i1 >> 2] = i3;
    i11 = i1 + 4 | 0;
    i1 = i4 + 4 | 0;
    HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    if ((i4 | 0) == (i9 | 0)) break;
    i2 = i4 + -16 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else {
     i1 = i4;
     i4 = i2;
    }
   }
   HEAP32[i4 >> 2] = i5;
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
  i1 = i6 + 16 | 0;
  if ((i1 | 0) == (i10 | 0)) break;
  i11 = HEAP32[i6 >> 2] | 0;
  i3 = i6;
  i6 = i1;
  i1 = i11;
 }
 STACKTOP = i8;
 return;
}

function __ZNK5physx36PxJointAngularLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 80 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj497ENS_22PxRepXPropertyAccessorILj497ES4_ffEEEEvRKT0_(i9, i8);
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i6 + 96 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj498ENS_22PxRepXPropertyAccessorILj498ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN4gles21InitRenderSurfaceGLESEP7ApiGLESR17RenderSurfaceGLESN2gl17TextureSrgbDecodeE(i10, i9, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 16 | 0;
 i3 = i11;
 i1 = i11 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i7;
 i7 = __Z16GetRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 176 >> 2] | 0, i7 | 0, 2, 1, i1 | 0);
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i2, i1, i3);
  i2 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = i2;
  if (i2 | 0) {
   i5 = (HEAP32[i7 >> 2] | 0) == 0;
   i6 = i9 + 40 | 0;
   HEAP32[i7 + 40 >> 2] = HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i10 + 860 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) >> 2];
   if (!i5) {
    i3 = i9 + 20 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if (!(i1 & 1024)) i4 = 12; else {
     i5 = __Z12GetIVRDevicev() | 0;
     if (mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, HEAP32[i2 >> 2] | 0, i9 | 0, 0, 0) | 0) {
      i1 = i9 + 24 | 0;
      break;
     } else {
      i1 = HEAP32[i3 >> 2] | 0;
      i4 = 12;
      break;
     }
    } while (0);
    if ((i4 | 0) == 12) {
     if (!(i1 & 2)) {
      i2 = i9 + 4 | 0;
      i3 = i9 + 8 | 0;
      i4 = i9 + 12 | 0;
      i1 = i9 + 24 | 0;
      i5 = 1;
     } else {
      i14 = i9 + 4 | 0;
      i13 = i9 + 8 | 0;
      i12 = i9 + 24 | 0;
      i5 = i9 + 12 | 0;
      i2 = i14;
      i3 = i13;
      i4 = i5;
      i1 = i12;
      i5 = __Z22CalculateMipMapCount3Diii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i12 >> 2] | 0) == 3 ? HEAP32[i5 >> 2] | 0 : 1) | 0;
     }
     __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii(i10, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, i5, HEAP32[i9 + 16 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
     HEAP32[i7 + 24 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i7 + 28 >> 2] = HEAP32[i3 >> 2];
     i13 = HEAP32[i4 >> 2] | 0;
     i14 = i7 + 32 | 0;
     HEAP32[i14 >> 2] = i13;
     HEAP32[i14 >> 2] = (HEAP32[i1 >> 2] | 0) == 4 ? 6 : i13;
     HEAP32[i7 + 36 >> 2] = i5;
    }
    if ((HEAP32[i1 >> 2] | 0) != 2) {
     STACKTOP = i11;
     return;
    }
    __ZN7ApiGLES14TextureSamplerEj16TextureDimension17TextureFilterMode15TextureWrapModeifb18ShadowSamplingModeN2gl17TextureSrgbDecodeE(i10, HEAP32[i7 >> 2] | 0, 2, 1, 1, 0, Math_fround(0.0), 0, 2, i8);
    STACKTOP = i11;
    return;
   }
  }
 }
 i1 = i9 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = __ZN7ApiGLES18CreateRenderbufferEiN2gl9TexFormatEii(i10, HEAP32[i9 + 16 >> 2] | 0, HEAP32[i9 + 40 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0) | 0;
 i1 = i9 + 44 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 715 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 699 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 if (!(__ZN2gl20IsFormatDepthStencilENS_9TexFormatE(HEAP32[i9 + 40 >> 2] | 0) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i1 >> 2] = __ZN7ApiGLES18CreateRenderbufferEiN2gl9TexFormatEii(i10, HEAP32[i9 + 16 >> 2] | 0, 32, HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0) | 0;
 STACKTOP = i11;
 return;
}

function __ZN8VRModule22StartRenderingToDeviceEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 96 | 0;
 i11 = i16 + 64 | 0;
 i15 = i16 + 32 | 0;
 i9 = i16 + 16 | 0;
 i10 = i16;
 do if (!(__Z12GetIVRDevicev() | 0)) i12 = 19; else {
  i7 = __Z12GetIVRDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 184 >> 2] | 0, i11 | 0, i7 | 0);
  __ZNK8VRModule23GetFirstSupportedDeviceEv(i10, i13);
  i7 = i10 + 11 | 0;
  i2 = HEAP8[i7 >> 0] | 0;
  i6 = i2 << 24 >> 24 < 0;
  i8 = i6 ? HEAP32[i10 >> 2] | 0 : i10;
  i2 = i6 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i8, i2);
  HEAP32[i15 >> 2] = 0;
  i2 = i15 + 20 | 0;
  HEAP32[i2 >> 2] = 0;
  i8 = i15 + 24 | 0;
  i6 = gb + 63648 | 0;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i8;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  i5 = i15 + 4 | 0;
  HEAP8[i5 >> 0] = 0;
  i4 = HEAP8[i9 + 11 >> 0] | 0;
  i6 = i4 << 24 >> 24 < 0;
  i3 = i6 ? HEAP32[i9 >> 2] | 0 : i9;
  i4 = i6 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
  if (i4 >>> 0 > 15) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i8, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i15 + 4 >> 2] = i4;
   i1 = (i1 | 0) == 0 ? i5 : i1;
  } else i1 = i5;
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i2 >> 2] = i4;
  i6 = HEAP32[i15 >> 2] | 0;
  L6 : do if ((HEAP32[i11 + 20 >> 2] | 0) == (i4 | 0)) {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i4 | 0) {
    i3 = i4;
    i2 = (i6 | 0) == 0 ? i5 : i6;
    i1 = (i1 | 0) == 0 ? i11 + 4 | 0 : i1;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i2 = 1;
      break L6;
     }
     i3 = i3 + -1 | 0;
     if (!i3) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
   i2 = (HEAP8[i13 + 20 >> 0] | 0) == 0;
  } else i2 = 1; while (0);
  if (i6 | 0) if (HEAP32[i15 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i11 + 4 >> 2] | 0) {
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i11 + 24 | 0);
   if (i2) {
    i12 = 19;
    break;
   } else break;
  }
  if (i2) i12 = 19;
 } while (0);
 do if ((i12 | 0) == 19) {
  i1 = i13 + 20 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) if (__Z12GetIVRDevicev() | 0) {
   i11 = __Z12GetIVRDevicev() | 0;
   i12 = HEAP16[i13 >> 1] | 0;
   if (__ZN8VRDevice10InitializeEb(i11, (i12 & 65535) > 255 | (i12 & 255) << 24 >> 24 == 0) | 0) {
    HEAP8[i1 >> 0] = 1;
    break;
   }
  }
  HEAP32[i15 >> 2] = 0;
  i5 = i15 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i13, i15);
  __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i13, i15, 1);
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i4 = i14 + 4 | 0;
    do {
     i3 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i3;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i13 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i4 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
      i2 = HEAP32[i5 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i15 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 } while (0);
 if (!(__Z12GetIVRDevicev() | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN8VRDevice22StartRenderingToDeviceEv(__Z12GetIVRDevicev() | 0);
 STACKTOP = i16;
 return;
}

function __Z20SetupVehiclesManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i1 = HEAP32[gb + 1458884 >> 2] | 0;
 if (!i1) {
  i8 = __Z14GetDynamicsSDKv() | 0;
  i8 = mftCall_iifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, 0.0, 0.0, 1.0) | 0;
  HEAP32[gb + 1458884 >> 2] = i8;
  mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0, 1, 1);
 } else {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, 0.0);
  i8 = HEAP32[gb + 1458884 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, 0.0);
  i8 = HEAP32[gb + 1458884 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0, 1.0);
  i8 = HEAP32[gb + 1458884 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0, 1, 1);
 }
 i1 = HEAP32[gb + 1458540 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) - i3 >> 2 >>> 0 < 256) {
  i4 = i1 + 4 | 0;
  i5 = (HEAP32[i4 >> 2] | 0) - i3 | 0;
  i8 = i5 >> 2;
  i6 = __Znwj(1024) | 0;
  i7 = i6 + (i8 << 2) | 0;
  i8 = i7 + (0 - i8 << 2) | 0;
  if ((i5 | 0) > 0) _memcpy(i8 | 0, i3 | 0, i5 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i6 + 1024;
  if (i3 | 0) __ZdlPv(i3);
 }
 i1 = HEAP32[gb + 1458620 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) - i3 >> 3 >>> 0 < 256) {
  i4 = i1 + 4 | 0;
  i5 = (HEAP32[i4 >> 2] | 0) - i3 | 0;
  i8 = i5 >> 3;
  i6 = __Znwj(2048) | 0;
  i7 = i6 + (i8 << 3) | 0;
  i8 = i7 + (0 - i8 << 3) | 0;
  if ((i5 | 0) > 0) _memcpy(i8 | 0, i3 | 0, i5 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i6 + 2048;
  if (i3 | 0) __ZdlPv(i3);
 }
 i1 = HEAP32[gb + 1458700 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) - i3 >> 2 >>> 0 < 256) {
  i4 = i1 + 4 | 0;
  i5 = (HEAP32[i4 >> 2] | 0) - i3 | 0;
  i8 = i5 >> 2;
  i6 = __Znwj(1024) | 0;
  i7 = i6 + (i8 << 2) | 0;
  i8 = i7 + (0 - i8 << 2) | 0;
  if ((i5 | 0) > 0) _memcpy(i8 | 0, i3 | 0, i5 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i2 >> 2] = i6 + 1024;
  if (i3 | 0) __ZdlPv(i3);
 }
 __ZN14dynamic_bitset6resizeEjb(HEAP32[gb + 1458780 >> 2] | 0, 256, 0);
 HEAP32[gb + 1458868 >> 2] = 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(18456, 16, gb + 63400 | 0, 0, gb + 835805 | 0, 73) | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = fb + 157;
 i6 = i1 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 24;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i1 + 10264;
 i4 = i1 + 20 | 0;
 HEAP32[i4 >> 2] = 128;
 HEAP32[gb + 1458872 >> 2] = i1;
 i8 = __Z16GetDynamicsScenev() | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = i9 + 40 | 0;
 i12 = i3 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP8[i9 + 32 >> 0] = 0;
 HEAP32[i9 + 72 >> 2] = i4;
 HEAP32[i9 + 76 >> 2] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 HEAP8[i9 + 84 >> 0] = 1;
 HEAP32[i9 + 36 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 60 >> 2] = i4;
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i7 >> 2];
 i8 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 328 >> 2] | 0, i8 | 0, i9 | 0) | 0;
 HEAP32[gb + 1458876 >> 2] = i8;
 i8 = __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs8allocateEjj(1, 1) | 0;
 HEAP32[gb + 1458880 >> 2] = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs5setupEjjPPKNS_10PxMaterialEPKNS_28PxVehicleDrivableSurfaceTypeE(i8, 1, 1, i9, i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17;
 i15 = HEAP32[i13 >> 2] | 0;
 i3 = i15;
 i15 = i15 + ((((HEAP32[i2 >> 2] | 0) - i3 | 0) / 60 | 0) * 60 | 0) | 0;
 i16 = i13 + 4 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i4 = i13 + 8 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i2 = i6;
 i5 = i12;
 if (i6 >>> 0 < i12 >>> 0) {
  if ((i15 | 0) == (i6 | 0)) {
   i3 = i15;
   i8 = i1;
   i9 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    i3 = i3 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i3 | 0) < (i9 | 0));
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 60;
   i16 = i15;
   STACKTOP = i17;
   return i16 | 0;
  }
  i4 = i2 - (i15 + 60) | 0;
  i2 = i15 + (((i4 | 0) / 60 | 0) * 60 | 0) | 0;
  if (i2 >>> 0 < i6 >>> 0) {
   i3 = i6;
   do {
    i8 = i2;
    i9 = i3 + 60 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     i3 = i3 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i3 | 0) < (i9 | 0));
    i2 = i2 + 60 | 0;
    i3 = (HEAP32[i16 >> 2] | 0) + 60 | 0;
    HEAP32[i16 >> 2] = i3;
   } while (i2 >>> 0 < i6 >>> 0);
  }
  if (i4 | 0) _memmove(i6 + (((i4 | 0) / -60 | 0) * 60 | 0) | 0, i15 | 0, i4 | 0) | 0;
  if (i15 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i16 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 60 | 0 : i1;
  i3 = i15;
  i8 = i1;
  i9 = i3 + 56 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   i3 = i3 + 4 | 0;
   i8 = i8 + 4 | 0;
  } while ((i3 | 0) < (i9 | 0));
  HEAP8[i15 + 56 >> 0] = HEAP8[i1 + 56 >> 0] | 0;
  i16 = i15;
  STACKTOP = i17;
  return i16 | 0;
 }
 i12 = i13 + 12 | 0;
 i11 = i2 - i3 | 0;
 i6 = ((i11 | 0) / 60 | 0) + 1 | 0;
 if ((i11 | 0) < -60) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i11 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
 } else {
  i11 = i4;
  i2 = i5;
 }
 i2 = (i2 - i3 | 0) / 60 | 0;
 i10 = i2 << 1;
 i6 = i2 >>> 0 < 1073741823 ? (i10 >>> 0 < i6 >>> 0 ? i6 : i10) : 2147483647;
 i10 = i15;
 i2 = i10 - i3 | 0;
 i4 = (i2 | 0) / 60 | 0;
 if (!i6) i8 = 0; else {
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = 34;
  HEAP32[i14 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 60 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i8 + (i4 * 60 | 0) | 0;
 i5 = i3;
 i7 = i8 + (i6 * 60 | 0) | 0;
 do if ((i4 | 0) == (i6 | 0)) {
  if ((i2 | 0) > 0) {
   i3 = i3 + (((i6 + 1 | 0) / -2 | 0) * 60 | 0) | 0;
   i5 = i3;
   break;
  }
  i4 = i6 * 60 | 0;
  i4 = (i4 | 0) == 0 ? 1 : ((i4 | 0) / 60 | 0) << 1;
  if (!i4) i2 = 0; else {
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 >> 2] = 34;
   HEAP32[i14 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 60 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  }
  i3 = i2 + ((i4 >>> 2) * 60 | 0) | 0;
  i5 = i3;
  i2 = i2 + (i4 * 60 | 0) | 0;
  if (!i8) i7 = i2; else {
   i7 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 >> 2] = 34;
   HEAP32[i14 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i14);
   i7 = i2;
  }
 } while (0);
 i8 = i1;
 i9 = i3 + 60 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  i3 = i3 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i3 | 0) < (i9 | 0));
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i10 - i2 | 0;
 i4 = i5 + (((i3 | 0) / -60 | 0) * 60 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i4 | 0, i2 | 0, i3 | 0) | 0;
 i2 = (HEAP32[i16 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i15 | 0, i2 | 0) | 0;
  i1 = i1 + (((i2 >>> 0) / 60 | 0) * 60 | 0) | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i11 >> 2] = i7;
 if (!i2) {
  i16 = i5;
  STACKTOP = i17;
  return i16 | 0;
 }
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i14 >> 2] = 34;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
 i16 = i5;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN19RuntimeSceneManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i1 >> 2] = gb + 66432 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i2 = i4;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i2 = i4;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 52 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6172 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 5404 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 5404 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 5404 + (i1 * 12 | 0) >> 2] = fb + 3430;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 5400 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 24 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 4632 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) >> 2] = fb + 548;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 2312 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 32 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = fb + 3431;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 37052 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i6 = i3;
  i4 = i6 + 1 | 0;
  HEAP32[i2 >> 2] = i4;
  i4 = i1 + 36284 + (i6 * 12 | 0) + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  i4 = i1 + 36284 + (i6 * 12 | 0) + 8 | 0;
  HEAP8[i4 >> 0] = 0;
  i6 = i1 + 36284 + (i6 * 12 | 0) | 0;
  HEAP32[i6 >> 2] = fb + 2756;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 40 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i6 = HEAP32[i2 >> 2] | 0;
 i4 = i6 + 1 | 0;
 HEAP32[i2 >> 2] = i4;
 i4 = i1 + 36284 + (i6 * 12 | 0) + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 36284 + (i6 * 12 | 0) + 8 | 0;
 HEAP8[i4 >> 0] = 0;
 i6 = i1 + 36284 + (i6 * 12 | 0) | 0;
 HEAP32[i6 >> 2] = fb + 2756;
 STACKTOP = i5;
 return;
}

function __ZNK5physx35PxJointLinearLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 80 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj493ENS_22PxRepXPropertyAccessorILj493ES4_ffEEEEvRKT0_(i9, i8);
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i6 + 96 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj494ENS_22PxRepXPropertyAccessorILj494ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx2Gu11HeightField4loadERNS_13PxInputStreamE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 9 | 0;
 if (HEAP16[i1 + 6 >> 1] & 1) {
  i5 = i1 + 36 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 10 | 0, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
 }
 if (!(__ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE(72, 70, 72, 70, i6 + 4 | 0, i3, i4) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 i8 = i1 + 20 | 0;
 HEAP32[i8 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAPF32[i1 + 24 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 28 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 32 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 40 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 44 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAP16[i1 + 48 >> 1] = __ZN5physx8readWordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAP32[i1 + 52 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAPF32[i1 + 56 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 60 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 64 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 68 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 72 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 76 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAP32[i1 + 80 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAP32[i1 + 84 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAP32[i1 + 88 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAP32[i1 + 92 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAP32[i1 + 96 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 i5 = i1 + 100 | 0;
 HEAP32[i5 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4) | 0;
 HEAPF32[i1 + 104 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 HEAPF32[i1 + 108 >> 2] = Math_fround(__ZN5physx9readFloatEbRNS_13PxInputStreamE((HEAP8[i3 >> 0] | 0) != 0, i4));
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = Math_imul(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!i1) {
  i8 = 1;
  STACKTOP = i6;
  return i8 | 0;
 }
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6 + 8 | 0, i1 << 2, gb + 724537 | 0, 307) | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 724537 | 0, 310, gb + 724619 | 0, i6);
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i8 = 1;
  STACKTOP = i6;
  return i8 | 0;
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i8 = 1;
  STACKTOP = i6;
  return i8 | 0;
 } else i1 = 0;
 do {
  i4 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i7 = HEAP8[i4 >> 0] | 0;
  i8 = i4 + 1 | 0;
  HEAP8[i4 >> 0] = HEAP8[i8 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 i1 = 1;
 STACKTOP = i6;
 return i1 | 0;
}

function __Z9SetupArgviPPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i6 = i7 + 12 | 0;
 i5 = i7;
 HEAP32[gb + 1170792 >> 2] = i1;
 HEAP32[gb + 1170796 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 487942 | 0, 9);
 i3 = (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0) & 1;
 HEAP8[gb + 1546618 >> 0] = i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 487952 | 0, 8);
 if (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0) HEAP8[gb + 1546619 >> 0] = 1; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 487961 | 0, 14);
  i3 = (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0) & 1;
  HEAP8[gb + 1546619 >> 0] = i3;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 487976 | 0, 9);
 i3 = (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0) & 1;
 HEAP8[gb + 1546620 >> 0] = i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 487986 | 0, 17);
 i3 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (!i3) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 487986 | 0, 17);
 __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5);
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i4 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i1);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i8;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = i6 + 11 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i2 = i6 + 4 | 0;
 if (((i8 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i8 & 255) | 0) == 4) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, gb + 1044172 | 0, 4) | 0)) __Z20SetStackTraceLogType17StackTraceLogType(0);
 i8 = HEAP8[i1 >> 0] | 0;
 if (((i8 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i8 & 255) | 0) == 10) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, gb + 488004 | 0, 10) | 0)) __Z20SetStackTraceLogType17StackTraceLogType(1);
 i8 = HEAP8[i1 >> 0] | 0;
 if (((i8 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i8 & 255) | 0) == 4) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, gb + 488015 | 0, 4) | 0)) __Z20SetStackTraceLogType17StackTraceLogType(2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function runPostSets224() {
 HEAP32[gb + 190184 >> 2] = fb + 292;
 HEAP32[gb + 190188 >> 2] = fb + 2254;
 HEAP32[gb + 190192 >> 2] = fb + 2992;
 HEAP32[gb + 190196 >> 2] = fb + 2993;
 HEAP32[gb + 190200 >> 2] = fb + 1394;
 HEAP32[gb + 190204 >> 2] = fb + 1395;
 HEAP32[gb + 190208 >> 2] = fb + 2988;
 HEAP32[gb + 190212 >> 2] = (HEAP32[gb + 190212 >> 2] | 0) + (gb + 1046982 | 0);
 HEAP32[gb + 190216 >> 2] = (HEAP32[gb + 190216 >> 2] | 0) + (gb + 1046994 | 0);
 HEAP32[gb + 190220 >> 2] = (HEAP32[gb + 190220 >> 2] | 0) + (gb + 1047004 | 0);
 HEAP32[gb + 190232 >> 2] = fb + 2994;
 HEAP32[gb + 190236 >> 2] = fb + 2995;
 HEAP32[gb + 190240 >> 2] = fb + 291;
 HEAP32[gb + 190244 >> 2] = fb + 2253;
 HEAP32[gb + 190248 >> 2] = fb + 2986;
 HEAP32[gb + 190252 >> 2] = fb + 2987;
 HEAP32[gb + 190256 >> 2] = fb + 1394;
 HEAP32[gb + 190260 >> 2] = fb + 1395;
 HEAP32[gb + 190264 >> 2] = fb + 2988;
 HEAP32[gb + 190268 >> 2] = fb + 475;
 HEAP32[gb + 190280 >> 2] = fb + 2996;
 HEAP32[gb + 190284 >> 2] = fb + 2997;
 HEAP32[gb + 190288 >> 2] = fb + 38;
 HEAP32[gb + 190292 >> 2] = fb + 2255;
 HEAP32[gb + 190296 >> 2] = fb + 16;
 HEAP32[gb + 190300 >> 2] = fb + 93;
 HEAP32[gb + 190304 >> 2] = fb + 40;
 HEAP32[gb + 190308 >> 2] = fb + 19;
 HEAP32[gb + 190312 >> 2] = fb + 1396;
 HEAP32[gb + 190316 >> 2] = fb + 103;
 HEAP32[gb + 190320 >> 2] = fb + 101;
 HEAP32[gb + 190324 >> 2] = fb + 62;
 HEAP32[gb + 190328 >> 2] = fb + 28;
 HEAP32[gb + 190332 >> 2] = fb + 63;
 HEAP32[gb + 190336 >> 2] = fb + 29;
 HEAP32[gb + 190340 >> 2] = fb + 34;
 HEAP32[gb + 190344 >> 2] = fb + 2256;
 HEAP32[gb + 190348 >> 2] = fb + 2257;
 HEAP32[gb + 190352 >> 2] = fb + 2258;
 HEAP32[gb + 190356 >> 2] = fb + 2259;
 HEAP32[gb + 190360 >> 2] = fb + 2260;
 HEAP32[gb + 190364 >> 2] = fb + 2261;
 HEAP32[gb + 190368 >> 2] = fb + 36;
 HEAP32[gb + 190372 >> 2] = fb + 104;
 HEAP32[gb + 190376 >> 2] = fb + 108;
 HEAP32[gb + 190380 >> 2] = fb + 94;
 HEAP32[gb + 190384 >> 2] = fb + 2262;
 HEAP32[gb + 190388 >> 2] = fb + 1397;
 HEAP32[gb + 190392 >> 2] = fb + 1398;
 HEAP32[gb + 190396 >> 2] = fb + 2263;
 HEAP32[gb + 190400 >> 2] = fb + 92;
 HEAP32[gb + 190412 >> 2] = (HEAP32[gb + 190412 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 190416 >> 2] = (HEAP32[gb + 190416 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 190452 >> 2] = fb + 2998;
 HEAP32[gb + 190456 >> 2] = fb + 2999;
 HEAP32[gb + 190460 >> 2] = fb + 38;
 HEAP32[gb + 190464 >> 2] = fb + 2255;
 HEAP32[gb + 190468 >> 2] = fb + 16;
 HEAP32[gb + 190472 >> 2] = fb + 93;
 HEAP32[gb + 190476 >> 2] = fb + 40;
 HEAP32[gb + 190480 >> 2] = fb + 19;
 HEAP32[gb + 190484 >> 2] = fb + 1399;
 HEAP32[gb + 190488 >> 2] = fb + 103;
 HEAP32[gb + 190492 >> 2] = fb + 101;
 HEAP32[gb + 190496 >> 2] = fb + 62;
 HEAP32[gb + 190500 >> 2] = fb + 28;
 HEAP32[gb + 190504 >> 2] = fb + 63;
 HEAP32[gb + 190508 >> 2] = fb + 29;
 HEAP32[gb + 190512 >> 2] = fb + 34;
 HEAP32[gb + 190516 >> 2] = fb + 2264;
 HEAP32[gb + 190520 >> 2] = fb + 2265;
 HEAP32[gb + 190524 >> 2] = fb + 2266;
 HEAP32[gb + 190528 >> 2] = fb + 2267;
 HEAP32[gb + 190532 >> 2] = fb + 2268;
 HEAP32[gb + 190536 >> 2] = fb + 2269;
 HEAP32[gb + 190540 >> 2] = fb + 36;
 HEAP32[gb + 190544 >> 2] = fb + 104;
 HEAP32[gb + 190548 >> 2] = fb + 108;
 HEAP32[gb + 190552 >> 2] = fb + 94;
 HEAP32[gb + 190556 >> 2] = fb + 2262;
 HEAP32[gb + 190560 >> 2] = fb + 1397;
 HEAP32[gb + 190564 >> 2] = fb + 1398;
 HEAP32[gb + 190568 >> 2] = fb + 2263;
 HEAP32[gb + 190572 >> 2] = fb + 1;
 HEAP32[gb + 190584 >> 2] = (HEAP32[gb + 190584 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 190588 >> 2] = (HEAP32[gb + 190588 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 190624 >> 2] = fb + 3e3;
 HEAP32[gb + 190628 >> 2] = fb + 3001;
 HEAP32[gb + 190632 >> 2] = fb + 38;
 HEAP32[gb + 190636 >> 2] = fb + 2255;
 HEAP32[gb + 190640 >> 2] = fb + 16;
 HEAP32[gb + 190644 >> 2] = fb + 93;
 HEAP32[gb + 190648 >> 2] = fb + 3002;
 HEAP32[gb + 190652 >> 2] = fb + 19;
 HEAP32[gb + 190656 >> 2] = fb + 1400;
 HEAP32[gb + 190660 >> 2] = fb + 103;
 HEAP32[gb + 190664 >> 2] = fb + 101;
 HEAP32[gb + 190668 >> 2] = fb + 62;
 HEAP32[gb + 190672 >> 2] = fb + 28;
 HEAP32[gb + 190676 >> 2] = fb + 63;
 runPostSets225();
}

function __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17;
 i15 = HEAP32[i13 >> 2] | 0;
 i3 = i15;
 i15 = i15 + ((((HEAP32[i2 >> 2] | 0) - i3 | 0) / 60 | 0) * 60 | 0) | 0;
 i16 = i13 + 4 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i4 = i13 + 8 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i2 = i6;
 i5 = i12;
 if (i6 >>> 0 < i12 >>> 0) {
  if ((i15 | 0) == (i6 | 0)) {
   i3 = i15;
   i8 = i1;
   i9 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    i3 = i3 + 4 | 0;
    i8 = i8 + 4 | 0;
   } while ((i3 | 0) < (i9 | 0));
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 60;
   i16 = i15;
   STACKTOP = i17;
   return i16 | 0;
  }
  i4 = i2 - (i15 + 60) | 0;
  i2 = i15 + (((i4 | 0) / 60 | 0) * 60 | 0) | 0;
  if (i2 >>> 0 < i6 >>> 0) {
   i3 = i6;
   do {
    i8 = i2;
    i9 = i3 + 60 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
     i3 = i3 + 4 | 0;
     i8 = i8 + 4 | 0;
    } while ((i3 | 0) < (i9 | 0));
    i2 = i2 + 60 | 0;
    i3 = (HEAP32[i16 >> 2] | 0) + 60 | 0;
    HEAP32[i16 >> 2] = i3;
   } while (i2 >>> 0 < i6 >>> 0);
  }
  if (i4 | 0) _memmove(i6 + (((i4 | 0) / -60 | 0) * 60 | 0) | 0, i15 | 0, i4 | 0) | 0;
  if (i15 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i16 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 60 | 0 : i1;
  i3 = i15;
  i8 = i1;
  i9 = i3 + 56 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   i3 = i3 + 4 | 0;
   i8 = i8 + 4 | 0;
  } while ((i3 | 0) < (i9 | 0));
  HEAP8[i15 + 56 >> 0] = HEAP8[i1 + 56 >> 0] | 0;
  i16 = i15;
  STACKTOP = i17;
  return i16 | 0;
 }
 i12 = i13 + 12 | 0;
 i11 = i2 - i3 | 0;
 i6 = ((i11 | 0) / 60 | 0) + 1 | 0;
 if ((i11 | 0) < -60) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i11 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
 } else {
  i11 = i4;
  i2 = i5;
 }
 i2 = (i2 - i3 | 0) / 60 | 0;
 i10 = i2 << 1;
 i6 = i2 >>> 0 < 1073741823 ? (i10 >>> 0 < i6 >>> 0 ? i6 : i10) : 2147483647;
 i10 = i15;
 i2 = i10 - i3 | 0;
 i4 = (i2 | 0) / 60 | 0;
 if (!i6) i8 = 0; else {
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 60 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i8 + (i4 * 60 | 0) | 0;
 i5 = i3;
 i7 = i8 + (i6 * 60 | 0) | 0;
 do if ((i4 | 0) == (i6 | 0)) {
  if ((i2 | 0) > 0) {
   i3 = i3 + (((i6 + 1 | 0) / -2 | 0) * 60 | 0) | 0;
   i5 = i3;
   break;
  }
  i4 = i6 * 60 | 0;
  i4 = (i4 | 0) == 0 ? 1 : ((i4 | 0) / 60 | 0) << 1;
  if (!i4) i2 = 0; else {
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 60 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  }
  i3 = i2 + ((i4 >>> 2) * 60 | 0) | 0;
  i5 = i3;
  i2 = i2 + (i4 * 60 | 0) | 0;
  if (!i8) i7 = i2; else {
   i7 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i14);
   i7 = i2;
  }
 } while (0);
 i8 = i1;
 i9 = i3 + 60 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  i3 = i3 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i3 | 0) < (i9 | 0));
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i10 - i2 | 0;
 i4 = i5 + (((i3 | 0) / -60 | 0) * 60 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i4 | 0, i2 | 0, i3 | 0) | 0;
 i2 = (HEAP32[i16 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i15 | 0, i2 | 0) | 0;
  i1 = i1 + (((i2 >>> 0) / 60 | 0) * 60 | 0) | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i11 >> 2] = i7;
 if (!i2) {
  i16 = i5;
  STACKTOP = i17;
  return i16 | 0;
 }
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i14 >> 2] = 1;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
 i16 = i5;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_17PxCapsuleGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i11, i6, i5) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i8 = i12 + 76 | 0;
 i10 = i12 + 64 | 0;
 i7 = i12 + 32 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = gb + 673012;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i9;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i9;
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 HEAP32[i10 >> 2] = 2;
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_17PxCapsuleGeometryE(i6, HEAP32[i11 + 8 >> 2] | 0, i10) | 0;
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i7);
 i3 = i11 + 4 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i9);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx30PxCapsuleGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEEEEEjT_j(i9, i8, 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i12;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j(i13, i17, i6) {
 i13 = i13 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = i13 + 28 | 0;
 i21 = i13 + 32 | 0;
 HEAP32[i21 >> 2] = 32;
 i10 = i13 + 44 | 0;
 HEAP32[i10 >> 2] = 16;
 i11 = i13 + 40 | 0;
 HEAP32[i11 >> 2] = 6;
 i12 = i13 + 48 | 0;
 HEAP8[i12 >> 0] = 0;
 i4 = __Znwj(256) | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (!i1) i1 = 32; else {
  __ZdlPv(i1);
  i1 = HEAP32[i21 >> 2] | 0;
 }
 HEAP32[i20 >> 2] = i4;
 i2 = i4 + (i1 << 3) | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i3 = i13 + 20 | 0;
  i1 = i4;
  do {
   i16 = i3;
   i18 = HEAP32[i16 + 4 >> 2] | 0;
   i19 = i1;
   HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i18 = i13 + 36 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i19 = i17 + 4 | 0;
 f5 = Math_fround(((HEAP32[i17 + 36 >> 2] | 0) - (HEAP32[i19 >> 2] | 0) | 0) >>> 0);
 i2 = 32;
 while (1) {
  if (i2 >>> 0 >= i6 >>> 0) {
   f8 = Math_fround(i2 >>> 0);
   f9 = Math_fround(f8 * Math_fround(.5));
   if (!(f5 >= f9)) break;
  }
  i2 = i2 << 1;
 }
 i3 = HEAP32[i21 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  i7 = __Znwj(i2 << 3) | 0;
  i1 = HEAP32[i20 >> 2] | 0;
  if (i1) {
   i4 = i1 + (i3 << 3) | 0;
   if (i3) {
    i3 = i7;
    while (1) {
     i14 = i1;
     i15 = HEAP32[i14 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 8 | 0;
    }
    i1 = HEAP32[i20 >> 2] | 0;
   }
   __ZdlPv(i1);
   i3 = HEAP32[i21 >> 2] | 0;
  }
  i4 = i7 + (i2 << 3) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i6 = i13 + 20 | 0;
   i1 = i7 + (i3 << 3) | 0;
   do {
    i14 = i6;
    i15 = HEAP32[i14 + 4 >> 2] | 0;
    i16 = i1;
    HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  HEAP32[i20 >> 2] = i7;
  HEAP32[i21 >> 2] = i2;
  HEAP32[i10 >> 2] = ~~f9 >>> 0;
  HEAP32[i11 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i12 >> 0] = 0;
 } else i2 = i3;
 i14 = i17 + 28 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i15 = i17 + 32 | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 i16 = i1 + (i12 << 3) | 0;
 L31 : do if (i12) {
  i6 = i17 + 8 | 0;
  i7 = i17 + 12 | 0;
  i4 = HEAP32[i17 + 20 >> 2] | 0;
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break L31;
    if (!(HEAP32[i19 >> 2] | 0)) break L31;
    if ((HEAP32[i7 >> 2] | 0) != (i3 | 0)) break L31;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i16 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i16 | 0)) return;
 i11 = i13 + 20 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17 + 12 | 0;
 i10 = i17 + 20 | 0;
 while (1) {
  i4 = i2 + -1 | 0;
  i2 = (Math_imul(HEAP32[i1 >> 2] | 0, 1419247029) | 0) & i4;
  i7 = HEAP32[i20 >> 2] | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  if ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0)) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i2 = i3 + i2 & i4;
   } while ((i6 | 0) != (HEAP32[i7 + (i2 << 3) >> 2] | 0));
  }
  i4 = i1;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i17 = i7 + (i2 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i17 + 4 >> 2] = i6;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
  i1 = i1 + 8 | 0;
  L51 : do if ((i1 | 0) == (i16 | 0)) i1 = i16; else {
   i3 = HEAP32[i10 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) != (i2 | 0)) {
     if (!(HEAP8[i12 >> 0] | 0)) break L51;
     if (!(HEAP32[i19 >> 2] | 0)) break L51;
     if ((HEAP32[i13 >> 2] | 0) != (i2 | 0)) break L51;
    }
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i16 | 0)) {
     i1 = i16;
     break;
    }
   }
  } while (0);
  if ((i1 | 0) == ((HEAP32[i14 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0)) break;
  i2 = HEAP32[i21 >> 2] | 0;
 }
 return;
}

function _UNITY_FT_Raccess_Get_HeaderInfo(i1, i20, i5, i23, i6) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i23 = i23 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i18 = i22 + 24 | 0;
 i19 = i22 + 8 | 0;
 i1 = _UNITY_FT_Stream_Seek(i20, i5) | 0;
 HEAP32[i21 >> 2] = i1;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i22;
  return i23 | 0;
 }
 i1 = _UNITY_FT_Stream_Read(i20, i18, 16) | 0;
 HEAP32[i21 >> 2] = i1;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i22;
  return i23 | 0;
 }
 i1 = HEAP8[i18 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i23 = 2;
  STACKTOP = i22;
  return i23 | 0;
 }
 i13 = i18 + 4 | 0;
 i2 = HEAP8[i13 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i23 = 2;
  STACKTOP = i22;
  return i23 | 0;
 }
 i14 = i18 + 8 | 0;
 i4 = HEAP8[i14 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i23 = 2;
  STACKTOP = i22;
  return i23 | 0;
 }
 i15 = i18 + 1 | 0;
 i16 = i18 + 2 | 0;
 i17 = i18 + 3 | 0;
 i3 = HEAPU8[i15 >> 0] << 16 | (i1 & 255) << 24 | HEAPU8[i16 >> 0] << 8 | HEAPU8[i17 >> 0];
 HEAP32[i6 >> 2] = i3;
 i10 = i18 + 5 | 0;
 i11 = i18 + 6 | 0;
 i12 = i18 + 7 | 0;
 i1 = HEAPU8[i10 >> 0] << 16 | (i2 & 255) << 24 | HEAPU8[i11 >> 0] << 8 | HEAPU8[i12 >> 0];
 i7 = i18 + 9 | 0;
 i8 = i18 + 10 | 0;
 i9 = i18 + 11 | 0;
 if ((i1 | 0) == 0 ? 1 : (i3 | 0) != (i1 - (HEAPU8[i7 >> 0] << 16 | (i4 & 255) << 24 | HEAPU8[i8 >> 0] << 8 | HEAPU8[i9 >> 0]) | 0)) {
  i23 = 2;
  STACKTOP = i22;
  return i23 | 0;
 }
 i4 = 2147483647 - i5 | 0;
 if ((i4 | 0) < (i3 | 0) | (i4 | 0) < (i1 | 0)) {
  i23 = 2;
  STACKTOP = i22;
  return i23 | 0;
 }
 HEAP32[i6 >> 2] = i3 + i5;
 i4 = i1 + i5 | 0;
 i1 = _UNITY_FT_Stream_Seek(i20, i4) | 0;
 HEAP32[i21 >> 2] = i1;
 if (i1 | 0) {
  i23 = i1;
  STACKTOP = i22;
  return i23 | 0;
 }
 i1 = i18 + 15 | 0;
 i2 = i19 + 15 | 0;
 HEAP8[i2 >> 0] = (HEAPU8[i1 >> 0] | 0) + 1;
 i3 = _UNITY_FT_Stream_Read(i20, i19, 16) | 0;
 HEAP32[i21 >> 2] = i3;
 if (i3 | 0) {
  i23 = i3;
  STACKTOP = i22;
  return i23 | 0;
 }
 i6 = HEAP8[i19 >> 0] | 0;
 i5 = HEAP8[i19 + 1 >> 0] | 0;
 i3 = HEAP8[i19 + 2 >> 0] | 0;
 i24 = HEAP8[i19 + 3 >> 0] | 0;
 i25 = HEAP8[i19 + 4 >> 0] | 0;
 i26 = HEAP8[i19 + 5 >> 0] | 0;
 i27 = HEAP8[i19 + 6 >> 0] | 0;
 i28 = HEAP8[i19 + 7 >> 0] | 0;
 i29 = HEAP8[i19 + 8 >> 0] | 0;
 i30 = HEAP8[i19 + 9 >> 0] | 0;
 i31 = HEAP8[i19 + 10 >> 0] | 0;
 i32 = HEAP8[i19 + 11 >> 0] | 0;
 i33 = HEAP8[i19 + 12 >> 0] | 0;
 i34 = HEAP8[i19 + 13 >> 0] | 0;
 i19 = HEAP8[i19 + 14 >> 0] | 0;
 i2 = HEAP8[i2 >> 0] | 0;
 if (!((i2 << 24 >> 24 == (HEAP8[i1 >> 0] | 0) & (i19 << 24 >> 24 == (HEAP8[i18 + 14 >> 0] | 0) & (i34 << 24 >> 24 == (HEAP8[i18 + 13 >> 0] | 0) & (i33 << 24 >> 24 == (HEAP8[i18 + 12 >> 0] | 0) & (i32 << 24 >> 24 == (HEAP8[i9 >> 0] | 0) & (i31 << 24 >> 24 == (HEAP8[i8 >> 0] | 0) & (i30 << 24 >> 24 == (HEAP8[i7 >> 0] | 0) & (i29 << 24 >> 24 == (HEAP8[i14 >> 0] | 0) & (i28 << 24 >> 24 == (HEAP8[i12 >> 0] | 0) & (i27 << 24 >> 24 == (HEAP8[i11 >> 0] | 0) & (i26 << 24 >> 24 == (HEAP8[i10 >> 0] | 0) & (i25 << 24 >> 24 == (HEAP8[i13 >> 0] | 0) & (i24 << 24 >> 24 == (HEAP8[i17 >> 0] | 0) & (i3 << 24 >> 24 == (HEAP8[i16 >> 0] | 0) ? i5 << 24 >> 24 == (HEAP8[i15 >> 0] | 0) : 0))))))))))))) ? i6 << 24 >> 24 == (HEAP8[i18 >> 0] | 0) & 1 : 0) | ((i2 | (i19 | (i34 | (i33 | (i32 | (i31 | (i30 | (i29 | (i28 | (i27 | (i26 | (i25 | (i24 | (i3 | i5)))))))))))))) << 24 >> 24 == 0 ? i6 << 24 >> 24 == 0 & 1 : 0))) {
  i34 = 2;
  STACKTOP = i22;
  return i34 | 0;
 }
 HEAP32[i21 >> 2] = _UNITY_FT_Stream_Skip(i20, 8) | 0;
 i1 = _UNITY_FT_Stream_ReadUShort(i20, i21) | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 if (i2 | 0) {
  i34 = i2;
  STACKTOP = i22;
  return i34 | 0;
 }
 i2 = (i1 & 65535) + i4 | 0;
 i1 = _UNITY_FT_Stream_Seek(i20, i2) | 0;
 HEAP32[i21 >> 2] = i1;
 if (i1 | 0) {
  i34 = i1;
  STACKTOP = i22;
  return i34 | 0;
 }
 HEAP32[i23 >> 2] = i2;
 i34 = 0;
 STACKTOP = i22;
 return i34 | 0;
}

function __ZN8Animator28SetRuntimeAnimatorControllerEP25RuntimeAnimatorController(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 i4 = i11 + 8 | 0;
 i5 = i11 + 4 | 0;
 i2 = (i7 | 0) == 0;
 if (i2) i1 = 0; else i1 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i10 + 108 | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 do if (i2) {
  i1 = 0;
  i9 = 22;
 } else {
  if ((((HEAP32[i7 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178624 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 178624 + 28 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = 22;
   break;
  }
  if (!(mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 92 >> 2] | 0, i7 | 0, 1) | 0)) {
   HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
   __Z6FormatPKcz(i4, gb + 910673 | 0, i3);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 910807 | 0, 1597, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   STACKTOP = i11;
   return;
  }
  i6 = __ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController(i7) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 14; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 14; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 16;
    }
   }
   if ((i9 | 0) == 14) i9 = 16;
   if ((i9 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  }
  if ((i6 | 0) != (__ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController(i1) | 0)) {
   HEAP32[i8 >> 2] = HEAP32[i7 + 4 >> 2];
   break;
  }
  if (!(HEAP32[i10 + 124 >> 2] | 0)) {
   HEAP32[i8 >> 2] = HEAP32[i7 + 4 >> 2];
   break;
  }
  i1 = i10 + 624 | 0;
  i6 = (HEAP32[i1 >> 2] | 0) == 0;
  HEAP32[i8 >> 2] = HEAP32[i7 + 4 >> 2];
  if (!i6) {
   __ZN8UserList5ClearEv(i10 + 480 | 0);
   __ZN26AnimatorControllerPlayable21SetOverrideControllerEP26AnimatorOverrideController(HEAP32[i1 >> 2] | 0, i7);
   __ZN8Animator14CreateBindingsEv(i10);
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (HEAP32[i1 + 28 >> 2] | 0) {
     i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 4 >> 2] | 0;
     if (i1 | 0) {
      i5 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0;
      if (i5 | 0) {
       i4 = HEAP32[(HEAP32[i10 + 168 >> 2] | 0) + 32 >> 2] | 0;
       i2 = HEAP32[i1 + 100 >> 2] | 0;
       i3 = HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 24 >> 2] | 0;
       i4 = HEAP32[i4 + 12 >> 2] | 0;
       i1 = 0;
       do {
        HEAP8[i2 + (i1 * 12 | 0) >> 0] = HEAP8[i4 + i1 >> 0] | 0;
        HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
        i1 = i1 + 1 | 0;
       } while ((i1 | 0) != (i5 | 0));
      }
     }
    }
   }
   if (!(__ZNK9HPlayable7IsValidEv(i10 + 628 | 0) | 0)) {
    STACKTOP = i11;
    return;
   }
   __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[(HEAP32[i10 + 628 >> 2] | 0) + 20 >> 2] | 0, i10 + 40 | 0);
   STACKTOP = i11;
   return;
  }
 } while (0);
 if ((i9 | 0) == 22) HEAP32[i8 >> 2] = i1;
 __ZN8Animator6RebindEb(i10, 1);
 STACKTOP = i11;
 return;
}

function __Z9CullSceneR22SceneCullingParametersPK6CameraR11CullResults(i1, i17, i18) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 8 | 0;
 i3 = i19;
 if ((HEAP16[gb + 1110644 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110644 | 0, i15);
  i16 = gb + 1110644 | 0;
 } else i16 = 0;
 i4 = i18 + 8 | 0;
 __Z16CullDynamicSceneR8JobFenceS0_RK22SceneCullingParametersR13CullingOutput(i4, i18, i1, i18 + 16 | 0);
 __Z17PrepareSceneNodesP11CullResults(i18);
 if (HEAP8[i1 + 817 >> 0] | 0) {
  if (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 37824 >> 2] | 0) {
   i2 = i18 + 84 | 0;
   if (HEAP32[i2 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i2);
  }
  __ZL10CullLightsRK22SceneCullingParametersR11CullResults(i1, i18);
 }
 if ((HEAP16[gb + 1110776 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110776 | 0, i15);
  i14 = gb + 1110776 | 0;
 } else i14 = 0;
 if (HEAP32[i4 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i4);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i18 + 16 | 0;
 i4 = i18 + 1136 | 0;
 i5 = i2 + 27788 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = 0;
  do {
   i6 = i2 + 27020 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 27020 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i6 >> 2] | 0, i3 | 0, i4 | 0); else mftCall_viii(HEAP32[i6 >> 2] | 0, HEAP32[i2 + 27020 + (i1 * 12 | 0) + 4 >> 2] | 0, i3 | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i1 = i18 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 __ZN13RendererScene27SetPreventAddRemoveRendererEb(__Z16GetRendererScenev() | 0, 1);
 i2 = i18 + 104 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i18 + 92 | 0;
  i4 = i15 + 4 | 0;
  i5 = i15 + 8 | 0;
  i1 = 0;
  do {
   i13 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData((i13 | 0) == 0 ? 0 : i13 + -32 | 0, gb + 1105336 | 0, i15);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 __ZN13RendererScene27SetPreventAddRemoveRendererEb(__Z16GetRendererScenev() | 0, 0);
 i6 = i17 + 1076 | 0;
 i7 = i17 + 36 | 0;
 i8 = i17 + 1080 | 0;
 i9 = i15 + 4 | 0;
 i10 = i15 + 8 | 0;
 i11 = i17 + 28 | 0;
 i5 = 0;
 do {
  i1 = i18 + 112 + (i5 * 20 | 0) + 12 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i12 = __ZN15GlobalCallbacks3GetEv() | 0;
   i13 = HEAP32[i18 + 112 + (i5 * 20 | 0) >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (HEAP8[i6 >> 0] | 0) if (HEAP8[i8 >> 0] | 0) {
    HEAPF32[i15 >> 2] = Math_fround(1.0);
    HEAPF32[i9 >> 2] = Math_fround(1.0);
    HEAPF32[i10 >> 2] = Math_fround(-1.0);
    __ZN10Matrix4x4f8SetScaleERK8Vector3f(i7, i15) | 0;
    __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 >> 2] | 0, gb + 28940 | 0) | 0);
    __ZN10Matrix4x4fmLERKS_(i7, i15) | 0;
    HEAP8[i6 >> 0] = 0;
   }
   i3 = i12 + 27792 + (i5 * 772 | 0) + 768 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = 0;
    do {
     i4 = i12 + 27792 + (i5 * 772 | 0) + (i1 * 12 | 0) | 0;
     if (!(HEAP8[i12 + 27792 + (i5 * 772 | 0) + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiii(HEAP32[i4 >> 2] | 0, i13 | 0, i2 | 0, i17 | 0, i7 | 0); else mftCall_viiiii(HEAP32[i4 >> 2] | 0, HEAP32[i12 + 27792 + (i5 * 772 | 0) + (i1 * 12 | 0) + 4 >> 2] | 0, i13 | 0, i2 | 0, i17 | 0, i7 | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 10);
 if (i14 | 0) __Z12profiler_endP19ProfilerInformation(i14);
 if (!i16) {
  STACKTOP = i19;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i19;
 return;
}

function __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i9, i6, i10) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 8 | 0;
 i5 = i11;
 i7 = i9 + 36 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) {
  __ZN13MonoBehaviour22DoScriptRebuildWarningEv(i9);
  STACKTOP = i11;
  return;
 }
 i3 = __ZNK13MonoBehaviour15CanAssignScriptERK4PPtrI10MonoScriptE(i9, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i3) {
  HEAP32[i7 >> 2] = i1;
  if (!i1) i1 = 0; else {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 31; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 31; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 33;
    }
   }
   if ((i8 | 0) == 31) i8 = 33;
   if ((i8 | 0) == 33) {
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
    if (!i1) {
     i1 = 0;
     break;
    }
   }
   i1 = __ZN10MonoScript8GetClassEv(i1) | 0;
  }
 } else {
  do if (i1 | 0) {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 12;
   }
   if ((i8 | 0) == 10) i8 = 12;
   if ((i8 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i5 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i8 = 19; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
      i2 = HEAP32[i4 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 19; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i8 = 21;
     }
    }
    if ((i8 | 0) == 19) i8 = 21;
    if ((i8 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   }
   __ZN10MonoScript7ReleaseEv(i1);
  } while (0);
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 } while (0);
 __ZN13MonoBehaviour35RebuildMonoInstanceFromScriptChangeEP11Il2CppClassP12Il2CppObject(i9, i1, i10);
 STACKTOP = i11;
 return;
}

function _do_nftw(i13, i14, i11, i15, i5) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 28 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20;
 i19 = _strlen(i13) | 0;
 if (!i19) i12 = 3; else {
  i1 = i19 + -1 | 0;
  if ((HEAP8[i13 + i1 >> 0] | 0) == 47) i9 = i1; else i12 = 3;
 }
 if ((i12 | 0) == 3) i9 = i19;
 i2 = i15 & 1;
 if (!i2) if ((_stat(i13, i16) | 0) < 0) {
  i1 = ___errno_location() | 0;
  if ((HEAP32[i1 >> 2] | 0) == 2) if (!(_lstat(i13, i16) | 0)) {
   i10 = 7;
   i12 = 15;
  } else i12 = 10; else i12 = 10;
 } else i12 = 11; else if (!(_lstat(i13, i16) | 0)) i12 = 11; else {
  i1 = ___errno_location() | 0;
  i12 = 10;
 }
 L12 : do if ((i12 | 0) == 10) if ((HEAP32[i1 >> 2] | 0) == 13) {
  i10 = 4;
  i12 = 15;
 } else i1 = -1; else if ((i12 | 0) == 11) {
  i1 = HEAP32[i16 + 12 >> 2] & 61440;
  if (i1 << 16 >> 16 < 16384) {
   switch (i1 << 16 >> 16) {
   case -24576:
    break;
   default:
    {
     i10 = 1;
     i12 = 15;
     break L12;
    }
   }
   i10 = i2 << 1 ^ 7;
   i12 = 15;
   break;
  }
  switch (i1 << 16 >> 16) {
  case 16384:
   break;
  default:
   {
    i10 = 1;
    i12 = 15;
    break L12;
   }
  }
  if ((_access(i13, 4) | 0) < 0) {
   i10 = 3;
   i12 = 15;
  } else {
   i10 = i15 >>> 1 & 4 | 2;
   i12 = 15;
  }
 } while (0);
 L21 : do if ((i12 | 0) == 15) {
  i2 = (i5 | 0) != 0;
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i15 & 2 | 0) != 0 & i2) if ((i1 | 0) != (HEAP32[i5 + 4 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i17 >> 2] = i5;
  HEAP32[i17 + 4 >> 2] = i1;
  i4 = i16 + 72 | 0;
  HEAP32[i17 + 8 >> 2] = HEAP32[i4 >> 2];
  if (i2) {
   i1 = (HEAP32[i5 + 12 >> 2] | 0) + 1 | 0;
   HEAP32[i17 + 12 >> 2] = i1;
   HEAP32[i17 + 16 >> 2] = i19 + 1;
   HEAP32[i18 + 4 >> 2] = i1;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
  } else {
   HEAP32[i17 + 12 >> 2] = 0;
   HEAP32[i17 + 16 >> 2] = i19 + 1;
   HEAP32[i18 + 4 >> 2] = 0;
   i1 = _strrchr(i13, 47) | 0;
   if (!i1) i1 = 0; else i1 = i1 - i13 | 0;
  }
  HEAP32[i18 >> 2] = i1;
  i8 = (i15 & 8 | 0) != 0;
  if (!i8) {
   i1 = mftCall_iiiii(i14 | 0, i13 | 0, i16 | 0, i10 | 0, i18 | 0) | 0;
   if (i1 | 0) break;
  }
  if (i5 | 0) {
   i3 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = i5;
   do {
    if ((HEAP32[i1 + 4 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i1 + 8 >> 2] | 0) == (i2 | 0)) {
     i1 = 0;
     break L21;
    }
    i1 = HEAP32[i1 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  do if ((i11 | 0) != 0 & (i10 | 4 | 0) == 6) {
   i6 = _opendir(i13) | 0;
   if (!i6) if ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 13) break; else {
    i1 = -1;
    break L21;
   }
   i2 = _readdir(i6) | 0;
   L47 : do if (i2 | 0) {
    i7 = 4096 - i19 | 0;
    i4 = i13 + i9 | 0;
    i5 = i4 + 1 | 0;
    i3 = i11 + -1 | 0;
    while (1) {
     i1 = i2 + 11 | 0;
     L51 : do if ((HEAP8[i1 >> 0] | 0) == 46) {
      switch (HEAP8[i2 + 12 >> 0] | 0) {
      case 0:
       break L51;
      case 46:
       break;
      default:
       {
        i12 = 35;
        break L51;
       }
      }
      if (HEAP8[i2 + 13 >> 0] | 0) i12 = 35;
     } else i12 = 35; while (0);
     if ((i12 | 0) == 35) {
      i12 = 0;
      if ((_strlen(i1) | 0) >>> 0 >= i7 >>> 0) {
       i12 = 36;
       break;
      }
      HEAP8[i4 >> 0] = 47;
      _strcpy(i5, i1) | 0;
      i1 = _do_nftw(i13, i14, i3, i15, i17) | 0;
      if (i1 | 0) {
       i12 = 39;
       break;
      }
     }
     i2 = _readdir(i6) | 0;
     if (!i2) break L47;
    }
    if ((i12 | 0) == 36) {
     HEAP32[(___errno_location() | 0) >> 2] = 36;
     _closedir(i6) | 0;
     i1 = -1;
     break L21;
    } else if ((i12 | 0) == 39) {
     _closedir(i6) | 0;
     break L21;
    }
   } while (0);
   _closedir(i6) | 0;
  } while (0);
  HEAP8[i13 + i19 >> 0] = 0;
  if (i8) {
   i1 = mftCall_iiiii(i14 | 0, i13 | 0, i16 | 0, i10 | 0, i18 | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = 0;
 } while (0);
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN18UnityPropertySheet8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i15) {
 i8 = i8 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 48 | 0;
 i1 = i18 + 32 | 0;
 i6 = i18 + 16 | 0;
 i9 = i18;
 i16 = i1 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i1 + 8 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 __Z36UnityPropertySheet_MakeSortedTexEnvsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEER10vector_mapIS2_S4_S6_NS7_INS8_IS2_S4_EEEEE(i8, i1);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 24 | 0;
 HEAP32[i13 >> 2] = i3;
 i11 = i15 + 16 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i12 = i15 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i13, 4);
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i15);
  __ZN18UnityPropertySheet11UnityTexEnv8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i15);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i10 = i6 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i14 = i6 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z35UnityPropertySheet_MakeSortedFloatsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_fEEEEEER10vector_mapIS2_fS4_NS5_INS6_IS2_fEEEEE(i8 + 12 | 0, i6);
 i5 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i5 - i1 >> 3;
 HEAP32[i13 >> 2] = i2;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i13, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i14 >> 2] | 0;
 }
 if ((i1 | 0) != (i5 | 0)) do {
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i15);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i9 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 __Z35UnityPropertySheet_MakeSortedColorsRKNSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEER10vector_mapIS2_S3_S5_NS6_INS7_IS2_S3_EEEEE(i8 + 24 | 0, i9);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i13 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i13, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i15);
   __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i15);
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~(((i3 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i14 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i14 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i2 = HEAP32[i17 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i17 >> 2] = i2 + (~(((i2 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
 __ZdlPv(i1);
 STACKTOP = i18;
 return;
}

function runPostSets57() {
 HEAP32[gb + 66944 >> 2] = fb + 740;
 HEAP32[gb + 66948 >> 2] = fb + 741;
 HEAP32[gb + 66952 >> 2] = fb + 46;
 HEAP32[gb + 66956 >> 2] = fb + 47;
 HEAP32[gb + 66960 >> 2] = fb + 45;
 HEAP32[gb + 66964 >> 2] = fb + 46;
 HEAP32[gb + 66976 >> 2] = (HEAP32[gb + 66976 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 66980 >> 2] = (HEAP32[gb + 66980 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 67016 >> 2] = (HEAP32[gb + 67016 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 67020 >> 2] = (HEAP32[gb + 67020 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 67056 >> 2] = (HEAP32[gb + 67056 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 67060 >> 2] = (HEAP32[gb + 67060 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 67096 >> 2] = (HEAP32[gb + 67096 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 67100 >> 2] = (HEAP32[gb + 67100 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 67136 >> 2] = (HEAP32[gb + 67136 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 67140 >> 2] = (HEAP32[gb + 67140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 67176 >> 2] = fb + 742;
 HEAP32[gb + 67180 >> 2] = fb + 743;
 HEAP32[gb + 67184 >> 2] = fb + 35;
 HEAP32[gb + 67188 >> 2] = fb + 36;
 HEAP32[gb + 67192 >> 2] = fb + 594;
 HEAP32[gb + 67196 >> 2] = fb + 321;
 HEAP32[gb + 67200 >> 2] = fb + 595;
 HEAP32[gb + 67204 >> 2] = fb + 322;
 HEAP32[gb + 67208 >> 2] = fb + 323;
 HEAP32[gb + 67220 >> 2] = fb + 48;
 HEAP32[gb + 67224 >> 2] = fb + 744;
 HEAP32[gb + 67228 >> 2] = fb + 745;
 HEAP32[gb + 67240 >> 2] = fb + 746;
 HEAP32[gb + 67244 >> 2] = fb + 747;
 HEAP32[gb + 67248 >> 2] = fb + 37;
 HEAP32[gb + 67252 >> 2] = fb + 38;
 HEAP32[gb + 67256 >> 2] = fb + 596;
 HEAP32[gb + 67260 >> 2] = fb + 324;
 HEAP32[gb + 67264 >> 2] = fb + 597;
 HEAP32[gb + 67268 >> 2] = fb + 325;
 HEAP32[gb + 67272 >> 2] = fb + 326;
 HEAP32[gb + 67284 >> 2] = fb + 748;
 HEAP32[gb + 67288 >> 2] = fb + 749;
 HEAP32[gb + 67292 >> 2] = fb + 39;
 HEAP32[gb + 67296 >> 2] = fb + 40;
 HEAP32[gb + 67300 >> 2] = fb + 598;
 HEAP32[gb + 67304 >> 2] = fb + 327;
 HEAP32[gb + 67308 >> 2] = fb + 599;
 HEAP32[gb + 67312 >> 2] = fb + 328;
 HEAP32[gb + 67316 >> 2] = fb + 329;
 HEAP32[gb + 67328 >> 2] = fb + 748;
 HEAP32[gb + 67332 >> 2] = fb + 750;
 HEAP32[gb + 67336 >> 2] = fb + 1;
 HEAP32[gb + 67340 >> 2] = fb + 1;
 HEAP32[gb + 67344 >> 2] = fb + 1;
 HEAP32[gb + 67348 >> 2] = fb + 1;
 HEAP32[gb + 67352 >> 2] = fb + 1;
 HEAP32[gb + 67356 >> 2] = fb + 1;
 HEAP32[gb + 67360 >> 2] = fb + 326;
 HEAP32[gb + 67372 >> 2] = fb + 751;
 HEAP32[gb + 67376 >> 2] = fb + 752;
 HEAP32[gb + 67380 >> 2] = fb + 1;
 HEAP32[gb + 67384 >> 2] = fb + 11;
 HEAP32[gb + 67388 >> 2] = fb + 1;
 HEAP32[gb + 67392 >> 2] = fb + 1;
 HEAP32[gb + 67396 >> 2] = fb + 1;
 HEAP32[gb + 67400 >> 2] = fb + 1;
 HEAP32[gb + 67404 >> 2] = fb + 149;
 HEAP32[gb + 67408 >> 2] = (HEAP32[gb + 67408 >> 2] | 0) + (gb + 468990 | 0);
 HEAP32[gb + 67420 >> 2] = fb + 753;
 HEAP32[gb + 67424 >> 2] = fb + 754;
 HEAP32[gb + 67428 >> 2] = fb + 755;
 HEAP32[gb + 67432 >> 2] = fb + 600;
 HEAP32[gb + 67436 >> 2] = fb + 16;
 HEAP32[gb + 67440 >> 2] = fb + 39;
 HEAP32[gb + 67444 >> 2] = fb + 40;
 HEAP32[gb + 67448 >> 2] = fb + 19;
 HEAP32[gb + 67452 >> 2] = fb + 330;
 HEAP32[gb + 67456 >> 2] = fb + 31;
 HEAP32[gb + 67460 >> 2] = fb + 27;
 HEAP32[gb + 67464 >> 2] = fb + 62;
 HEAP32[gb + 67468 >> 2] = fb + 28;
 HEAP32[gb + 67472 >> 2] = fb + 63;
 HEAP32[gb + 67476 >> 2] = fb + 29;
 HEAP32[gb + 67480 >> 2] = fb + 34;
 HEAP32[gb + 67484 >> 2] = fb + 601;
 HEAP32[gb + 67488 >> 2] = fb + 602;
 HEAP32[gb + 67492 >> 2] = fb + 603;
 HEAP32[gb + 67496 >> 2] = fb + 604;
 HEAP32[gb + 67500 >> 2] = fb + 605;
 HEAP32[gb + 67504 >> 2] = fb + 606;
 HEAP32[gb + 67508 >> 2] = fb + 36;
 HEAP32[gb + 67520 >> 2] = fb + 756;
 HEAP32[gb + 67524 >> 2] = fb + 757;
 HEAP32[gb + 67528 >> 2] = fb + 758;
 HEAP32[gb + 67532 >> 2] = fb + 607;
 HEAP32[gb + 67536 >> 2] = fb + 16;
 HEAP32[gb + 67540 >> 2] = fb + 39;
 HEAP32[gb + 67544 >> 2] = fb + 635;
 HEAP32[gb + 67548 >> 2] = fb + 19;
 HEAP32[gb + 67552 >> 2] = fb + 331;
 HEAP32[gb + 67556 >> 2] = fb + 31;
 HEAP32[gb + 67560 >> 2] = fb + 27;
 HEAP32[gb + 67564 >> 2] = fb + 62;
 runPostSets58();
}

function __ZN5physx2GuL25getClosestPtPointTriangleEPNS_6shdfnd3aos5Vec3VERKNS2_5BoolVEPjRj(i14, i11, i7, i15, i17) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 60 | 0;
 i4 = i18 + 56 | 0;
 i6 = i18 + 32 | 0;
 i9 = i18 + 52 | 0;
 i10 = i18 + 16 | 0;
 i13 = i18 + 48 | 0;
 i16 = i18;
 HEAP32[i12 >> 2] = HEAP32[gb + 101572 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 101572 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 101572 + 8 >> 2];
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i14, i11, i11 + 16 | 0, i11 + 32 | 0, i15, i17);
  f19 = Math_fround(HEAPF32[i14 >> 2]);
  f5 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f5 * f5)) + Math_fround(f3 * f3));
 } else f3 = Math_fround(3402823469999999843913219.0e14);
 i8 = i7 + 8 | 0;
 if ((HEAP32[i7 + 4 >> 2] | 0) == -1) {
  HEAP32[i4 >> 2] = 3;
  HEAP32[i12 >> 2] = 0;
  i1 = i12 + 4 | 0;
  HEAP32[i1 >> 2] = 2;
  i2 = i12 + 8 | 0;
  HEAP32[i2 >> 2] = 3;
  __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i6, i11, i11 + 32 | 0, i11 + 48 | 0, i12, i4);
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  f19 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f19 * f19)) + Math_fround(f5 * f5));
  if (f3 > f5) {
   HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
  } else f5 = f3;
 } else f5 = f3;
 i4 = i7 + 12 | 0;
 if ((HEAP32[i8 >> 2] | 0) == -1) {
  HEAP32[i9 >> 2] = 3;
  HEAP32[i12 >> 2] = 0;
  i1 = i12 + 4 | 0;
  HEAP32[i1 >> 2] = 3;
  i2 = i12 + 8 | 0;
  HEAP32[i2 >> 2] = 1;
  __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i10, i11, i11 + 48 | 0, i11 + 16 | 0, i12, i9);
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  f20 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f3 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f3 * f3));
  if (f5 > f3) {
   HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
  } else f3 = f5;
 } else f3 = f5;
 if ((HEAP32[i4 >> 2] | 0) != -1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i13 >> 2] = 3;
 HEAP32[i12 >> 2] = 1;
 i1 = i12 + 4 | 0;
 HEAP32[i1 >> 2] = 3;
 i2 = i12 + 8 | 0;
 HEAP32[i2 >> 2] = 2;
 __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj(i16, i11 + 16 | 0, i11 + 48 | 0, i11 + 32 | 0, i12, i13);
 f5 = Math_fround(HEAPF32[i16 >> 2]);
 f19 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 if (!(f3 > Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f19 * f19)) + Math_fround(f20 * f20)))) {
  STACKTOP = i18;
  return;
 };
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
 STACKTOP = i18;
 return;
}

function __ZNK19SimpleRayTriOverlap7overlapERKN5physx6PxVec3ES3_S3_RNS0_12PxRaycastHitE(i13, i2, i3, i5, i25) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i25 = i25 | 0;
 var f1 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(f20 - f1);
 f21 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f21 = Math_fround(f21 - f4);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f16 - f6);
 f23 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f1);
 f24 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f4);
 f22 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f6);
 f17 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f7 = Math_fround(f17 * f22);
 f18 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f24 * f18));
 f8 = Math_fround(f23 * f18);
 f19 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f22 * f19));
 f9 = Math_fround(Math_fround(f24 * f19) - Math_fround(f23 * f17));
 f14 = Math_fround(Math_fround(f16 * f9) + Math_fround(Math_fround(f20 * f7) + Math_fround(f21 * f8)));
 f15 = Math_fround(HEAPF32[i13 + 28 >> 2]);
 if (!(HEAP8[i13 + 24 >> 0] | 0)) {
  if (f14 < f15) {
   i25 = 0;
   return i25 | 0;
  }
  f12 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f1);
  f11 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) - f4);
  f1 = Math_fround(Math_fround(HEAPF32[i13 + 8 >> 2]) - f6);
  f9 = Math_fround(Math_fround(Math_fround(f7 * f12) + Math_fround(f8 * f11)) + Math_fround(f9 * f1));
  f10 = Math_fround(-f15);
  if (f9 < f10) {
   i25 = 0;
   return i25 | 0;
  }
  f4 = Math_fround(f15 + f14);
  if (f9 > f4) {
   i25 = 0;
   return i25 | 0;
  }
  f8 = Math_fround(Math_fround(f16 * f11) - Math_fround(f21 * f1));
  f7 = Math_fround(Math_fround(f20 * f1) - Math_fround(f16 * f12));
  f1 = Math_fround(Math_fround(f21 * f12) - Math_fround(f20 * f11));
  f6 = Math_fround(Math_fround(f18 * f1) + Math_fround(Math_fround(f19 * f8) + Math_fround(f17 * f7)));
  if (f6 < f10 | Math_fround(f9 + f6) > f4) {
   i25 = 0;
   return i25 | 0;
  }
  f4 = Math_fround(Math_fround(1.0) / f14);
  f1 = Math_fround(Math_fround(Math_fround(f22 * f1) + Math_fround(Math_fround(f23 * f8) + Math_fround(f24 * f7))) * f4);
  if (f1 < f10) {
   i25 = 0;
   return i25 | 0;
  }
  i13 = f1 > Math_fround(0.0);
  HEAPF32[i25 + 40 >> 2] = i13 ? f1 : Math_fround(0.0);
  HEAPF32[i25 + 44 >> 2] = Math_fround(f9 * f4);
  HEAPF32[i25 + 48 >> 2] = Math_fround(f6 * f4);
  i25 = 1;
  return i25 | 0;
 } else {
  if (Math_fround(Math_abs(Math_fround(f14))) < f15) {
   i25 = 0;
   return i25 | 0;
  }
  f12 = Math_fround(Math_fround(1.0) / f14);
  f11 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f1);
  f4 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) - f4);
  f1 = Math_fround(Math_fround(HEAPF32[i13 + 8 >> 2]) - f6);
  f9 = Math_fround(f12 * Math_fround(Math_fround(Math_fround(f7 * f11) + Math_fround(f8 * f4)) + Math_fround(f9 * f1)));
  f10 = Math_fround(-f15);
  if (f9 < f10) {
   i25 = 0;
   return i25 | 0;
  }
  f7 = Math_fround(f15 + Math_fround(1.0));
  if (f9 > f7) {
   i25 = 0;
   return i25 | 0;
  }
  f8 = Math_fround(Math_fround(f16 * f4) - Math_fround(f21 * f1));
  f6 = Math_fround(Math_fround(f20 * f1) - Math_fround(f16 * f11));
  f1 = Math_fround(Math_fround(f21 * f11) - Math_fround(f20 * f4));
  f4 = Math_fround(f12 * Math_fround(Math_fround(f18 * f1) + Math_fround(Math_fround(f19 * f8) + Math_fround(f17 * f6))));
  if (f4 < f10 | Math_fround(f9 + f4) > f7) {
   i25 = 0;
   return i25 | 0;
  }
  f1 = Math_fround(f12 * Math_fround(Math_fround(f22 * f1) + Math_fround(Math_fround(f23 * f8) + Math_fround(f24 * f6))));
  if (f1 < f10) {
   i25 = 0;
   return i25 | 0;
  }
  i13 = f1 > Math_fround(0.0);
  HEAPF32[i25 + 40 >> 2] = i13 ? f1 : Math_fround(0.0);
  HEAPF32[i25 + 44 >> 2] = f9;
  HEAPF32[i25 + 48 >> 2] = f4;
  i25 = 1;
  return i25 | 0;
 }
 return 0;
}

function __ZN5physx8debugger19PvdNetworkOutStream20createDoubleBufferedERNS_19PxAllocatorCallbackERS1_j(i3, i13, i2) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 1 | 0;
 i10 = i14;
 i11 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 120, gb + 775280 | 0, gb + 775144 | 0, 659) | 0;
 HEAP32[i11 >> 2] = gb + 149136 + 8;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = gb + 86828 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd10ThreadImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
  i8 = _PxGetFoundation() | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
  i1 = mftCall_iiiiii(i6 | 0, i7 | 0, i1 | 0, (i8 ? gb + 775304 | 0 : gb + 837976 | 0) | 0, gb + 775428 | 0, 236) | 0;
 }
 i8 = i11 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6shdfnd10ThreadImplC2Ev(i1);
 HEAP32[i11 >> 2] = gb + 149176 + 8;
 HEAP32[i12 >> 2] = gb + 149176 + 52;
 HEAP32[i11 + 12 >> 2] = i3;
 i7 = i11 + 16 | 0;
 HEAP32[i7 >> 2] = i2 >>> 1;
 i6 = i11 + 20 | 0;
 HEAP32[i11 + 24 >> 2] = i3;
 HEAP32[i11 + 28 >> 2] = gb + 775505;
 i2 = i11 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i11 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 + 40 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 148736 + 8;
 i5 = i11 + 44 | 0;
 HEAP32[i11 + 48 >> 2] = i3;
 HEAP32[i11 + 52 >> 2] = gb + 775547;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = 0;
 HEAP32[i11 + 64 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 148736 + 8;
 i16 = i11 + 80 | 0;
 HEAP32[i16 >> 2] = i3;
 i1 = i11 + 84 | 0;
 HEAP32[i1 >> 2] = gb + 775590;
 HEAP32[i11 + 76 >> 2] = gb + 148172 + 8;
 i15 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i15 | 0, HEAP32[i1 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i11 + 88 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i17 = HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0;
  i16 = _PxGetFoundation() | 0;
  i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0) | 0;
  i1 = mftCall_iiiiii(i17 | 0, i15 | 0, i1 | 0, (i16 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i11 + 92 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
  i17 = _PxGetFoundation() | 0;
  i17 = mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 24 >> 2] | 0, i17 | 0) | 0;
  i1 = mftCall_iiiiii(i15 | 0, i16 | 0, i1 | 0, (i17 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i11 + 96 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 i15 = HEAP32[i7 >> 2] | 0;
 HEAP8[i9 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i6, i15, i9);
 i15 = HEAP32[i7 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i5, i15, i10);
 i15 = HEAP32[i2 >> 2] | 0;
 HEAP32[i11 + 68 >> 2] = i15;
 HEAP32[i11 + 72 >> 2] = i15 + (HEAP32[i4 >> 2] | 0);
 HEAP32[i11 + 100 >> 2] = i13;
 i15 = i11 + 108 | 0;
 HEAP32[i15 >> 2] = i3;
 i17 = i11 + 112 | 0;
 HEAP32[i17 >> 2] = gb + 775822;
 HEAP32[i11 + 104 >> 2] = gb + 148172 + 8;
 i16 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i17 = mftCall_iiiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i16 | 0, HEAP32[i17 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i11 + 116 >> 2] = i17;
 __ZN5physx6shdfnd9MutexImplC2Ev(i17);
 __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE(HEAP32[i8 >> 2] | 0, 16384, i12);
 STACKTOP = i14;
 return i11 | 0;
}

function _deflate_stored(i13, i10) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i6 = (HEAP32[i13 + 12 >> 2] | 0) + -5 | 0;
 i6 = i6 >>> 0 < 65535 ? i6 : 65535;
 i7 = i13 + 116 | 0;
 i11 = i13 + 108 | 0;
 i12 = i13 + 92 | 0;
 i8 = i13 + 44 | 0;
 i9 = i13 + 56 | 0;
 while (1) {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 >>> 0 < 2) {
   _fill_window(i13);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!(i1 | i10)) {
    i1 = 0;
    i2 = 28;
    break;
   }
   if (!i1) {
    i2 = 20;
    break;
   }
  }
  i1 = (HEAP32[i11 >> 2] | 0) + i1 | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i7 >> 2] = 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = i3 + i6 | 0;
  if (!((i1 | 0) != 0 & i1 >>> 0 < i2 >>> 0)) {
   HEAP32[i7 >> 2] = i1 - i2;
   HEAP32[i11 >> 2] = i2;
   if ((i3 | 0) > -1) i1 = (HEAP32[i9 >> 2] | 0) + i3 | 0; else i1 = 0;
   _unity_z_tr_flush_block(i13, i1, i6, 0);
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   i4 = HEAP32[i13 >> 2] | 0;
   i1 = i4 + 28 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 20 >> 2] | 0;
   i5 = i4 + 16 | 0;
   i14 = HEAP32[i5 >> 2] | 0;
   i3 = i3 >>> 0 > i14 >>> 0 ? i14 : i3;
   if (i3 | 0) {
    i14 = i4 + 12 | 0;
    _memcpy(HEAP32[i14 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i3 | 0) | 0;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i3;
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
    i14 = i4 + 20 | 0;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i3;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i3;
    i5 = i1 + 20 | 0;
    i14 = (HEAP32[i5 >> 2] | 0) - i3 | 0;
    HEAP32[i5 >> 2] = i14;
    if (!i14) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
   }
   if (!(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0)) {
    i1 = 0;
    i2 = 28;
    break;
   }
   i1 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
  }
  i2 = i1 - i3 | 0;
  if (i2 >>> 0 < ((HEAP32[i8 >> 2] | 0) + -262 | 0) >>> 0) continue;
  if ((i3 | 0) > -1) i1 = (HEAP32[i9 >> 2] | 0) + i3 | 0; else i1 = 0;
  _unity_z_tr_flush_block(i13, i1, i2, 0);
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  i4 = HEAP32[i13 >> 2] | 0;
  i1 = i4 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i5 = i4 + 16 | 0;
  i14 = HEAP32[i5 >> 2] | 0;
  i3 = i3 >>> 0 > i14 >>> 0 ? i14 : i3;
  if (i3 | 0) {
   i14 = i4 + 12 | 0;
   _memcpy(HEAP32[i14 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i3 | 0) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i3;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
   i14 = i4 + 20 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i3;
   i5 = i1 + 20 | 0;
   i14 = (HEAP32[i5 >> 2] | 0) - i3 | 0;
   HEAP32[i5 >> 2] = i14;
   if (!i14) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0)) {
   i1 = 0;
   i2 = 28;
   break;
  }
 }
 if ((i2 | 0) == 20) {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) > -1) i1 = (HEAP32[i9 >> 2] | 0) + i2 | 0; else i1 = 0;
  i6 = (i10 | 0) == 4;
  _unity_z_tr_flush_block(i13, i1, (HEAP32[i11 >> 2] | 0) - i2 | 0, i6 & 1);
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  i4 = HEAP32[i13 >> 2] | 0;
  i1 = i4 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i5 = i4 + 16 | 0;
  i14 = HEAP32[i5 >> 2] | 0;
  i3 = i3 >>> 0 > i14 >>> 0 ? i14 : i3;
  if (i3 | 0) {
   i12 = i4 + 12 | 0;
   _memcpy(HEAP32[i12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, i3 | 0) | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
   i12 = i4 + 20 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i3;
   i12 = i1 + 20 | 0;
   i14 = (HEAP32[i12 >> 2] | 0) - i3 | 0;
   HEAP32[i12 >> 2] = i14;
   if (!i14) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
  }
  if (!(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0)) {
   i14 = i6 ? 2 : 0;
   return i14 | 0;
  } else {
   i14 = i6 ? 3 : 1;
   return i14 | 0;
  }
 } else if ((i2 | 0) == 28) return i1 | 0;
 return 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 88 | 0;
 i6 = i5 + 12 | 0;
 i8 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 906499 | 0, i2, i4);
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + 4;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i4;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 906508 | 0, i4, i8, 0);
 HEAP32[i6 >> 2] = -1;
 i11 = i6 + 4 | 0;
 HEAP32[i11 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 906602 | 0, i6, 0);
 i12 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 906607 | 0, i12, i6, 0);
 i10 = i1 + 16 | 0;
 i9 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 906618 | 0, i12, i11, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + 8;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i11;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 910040 | 0, i4, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + 16;
 HEAP32[i8 + 4 >> 2] = i2 + 12;
 HEAP32[i8 + 8 >> 2] = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 906515 | 0, i4, i8, 0);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(-1.0);
 HEAPF32[i6 + 60 >> 2] = Math_fround(-1.0);
 HEAPF32[i6 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 72 >> 2] = 3;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 906527 | 0, i6, 0);
 __ZN4math4Axes8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZNK5physx2Gu24ShrunkConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVERS4_Ri(i20, i24, i1, i19, i23, i21) {
 i20 = i20 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i22 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i25 + 16 | 0;
 i22 = i25;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f3 * Math_fround(HEAPF32[i19 >> 2]));
 i18 = i19 + 4 | 0;
 f8 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2])));
 i11 = i19 + 8 | 0;
 f8 = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2])));
 i12 = i19 + 16 | 0;
 f9 = Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]));
 i13 = i19 + 20 | 0;
 f9 = Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 i14 = i19 + 24 | 0;
 f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i14 >> 2])));
 i15 = i19 + 32 | 0;
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i15 >> 2]));
 i16 = i19 + 36 | 0;
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 i17 = i19 + 40 | 0;
 f10 = Math_fround(f5 + Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i2 >> 2] = f8;
 HEAPF32[i2 + 4 >> 2] = f9;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(HEAP32[i24 + 196 >> 2] | 0)) {
  i6 = i24 + 200 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i24 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f8);
   f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f9));
   f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f10));
   i2 = 1;
   i1 = 0;
   while (1) {
    i4 = HEAP32[i6 >> 2] | 0;
    f26 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) >> 2]);
    f3 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 4 >> 2]);
    f3 = Math_fround(Math_fround(Math_fround(f26 * f8) + Math_fround(f3 * f9)) + Math_fround(Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 8 >> 2]) * f10));
    i4 = f3 > f5;
    i1 = i4 ? i2 : i1;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f5 = i4 ? f3 : f5; else break;
   }
  } else i1 = 0;
 } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i24, i2) | 0;
 HEAP32[i21 >> 2] = i1;
 __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i22, i24, i1, i24 + 16 | 0);
 HEAP32[i23 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 f8 = Math_fround(HEAPF32[i19 + 48 >> 2]);
 f27 = Math_fround(HEAPF32[i19 + 52 >> 2]);
 f3 = Math_fround(HEAPF32[i19 + 56 >> 2]);
 f28 = Math_fround(HEAPF32[i22 >> 2]);
 f5 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f9 = Math_fround(f28 * Math_fround(HEAPF32[i19 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i12 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f26 * Math_fround(HEAPF32[i15 >> 2])));
 f10 = Math_fround(f28 * Math_fround(HEAPF32[i18 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f26 * Math_fround(HEAPF32[i16 >> 2])));
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2]));
 f5 = Math_fround(f28 + Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2])));
 f10 = Math_fround(f27 + f10);
 f26 = Math_fround(f3 + Math_fround(f5 + Math_fround(f26 * Math_fround(HEAPF32[i17 >> 2]))));
 HEAPF32[i20 >> 2] = Math_fround(f8 + f9);
 HEAPF32[i20 + 4 >> 2] = f10;
 HEAPF32[i20 + 8 >> 2] = f26;
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i20 + 12 >> 2];
 STACKTOP = i25;
 return;
}

function __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i2, i5, i4, i1, i6, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f15 = Math_fround(-f15);
 f18 = Math_fround(-f18);
 f11 = Math_fround(-Math_fround(HEAPF32[i4 + 8 >> 2]));
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f16 = Math_fround(f16 + Math_fround(Math_fround(f7 * f18) - Math_fround(f8 * f11)));
 f11 = Math_fround(f12 + Math_fround(Math_fround(f17 * f11) - Math_fround(f7 * f15)));
 f18 = Math_fround(f10 + Math_fround(Math_fround(f8 * f15) - Math_fround(f17 * f18)));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 96 >> 2]));
 f20 = Math_fround(f20 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 112 >> 2])));
 f20 = Math_fround(f20 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 128 >> 2])));
 f19 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 100 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 116 >> 2])));
 f19 = Math_fround(f19 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 132 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 104 >> 2]));
 f10 = Math_fround(f15 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 120 >> 2])));
 f12 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 136 >> 2])));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 8 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f9 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f9)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 24 >> 2]))));
 f10 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 40 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 52 >> 2]);
 f13 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f13)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 56 >> 2]))));
 f10 = Math_fround(HEAPF32[i5 + 64 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 72 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 80 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 84 >> 2]);
 f9 = Math_fround(f20 + f9);
 f13 = Math_fround(f19 + f13);
 f14 = Math_fround(f12 + Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f14)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 88 >> 2])))));
 f10 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f11 = Math_fround(f11 - Math_fround(Math_fround(f9 * f12) - Math_fround(f10 * f14)));
 f10 = Math_fround(f18 - Math_fround(Math_fround(f13 * f10) - Math_fround(f9 * f15)));
 f9 = Math_fround(f17 - f9);
 f8 = Math_fround(f8 - f13);
 f7 = Math_fround(f7 - f14);
 HEAPF32[i2 >> 2] = Math_fround(f16 - Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)));
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f9;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f7;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZN2UI13CanvasManager17EmitWorldGeometryENS0_10CameraTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 8 | 0;
 i16 = i19;
 i17 = i19 + 16 | 0;
 i3 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i15 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i15, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i3, i15, Math_fround(4.0), 0);
 i3 = __Z16GetRenderManagerv() | 0;
 i4 = __Z16GetRenderManagerv() | 0;
 HEAP16[i17 >> 1] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i13 = i1 + 4 | 0;
 if ((i5 | 0) == (HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i19;
  return;
 }
 i14 = (i2 & 2 | 0) == 0;
 i11 = (i2 & 1 | 0) == 0;
 i12 = i3 + 8 | 0;
 i9 = i3 + 4 | 0;
 i10 = i4 + 20 | 0;
 i8 = i4 + 16 | 0;
 do {
  i7 = HEAP32[i5 >> 2] | 0;
  if ((__ZNK2UI6Canvas13GetRenderModeEv(i7) | 0) == 2) {
   if (!i14) {
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) != (i8 | 0)) do {
     i6 = i1 + 8 | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (!i1) i1 = 0; else {
      HEAP32[i16 >> 2] = i1;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i18 = 13; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i3 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
        i3 = HEAP32[i15 >> 2] | 0;
        i20 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i3 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i18 = 13; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i18 = 15;
       }
      }
      if ((i18 | 0) == 13) i18 = 15;
      if ((i18 | 0) == 15) {
       i18 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      }
     }
     __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i7, i1, i17, 0);
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     i2 = i1;
    } while ((i2 | 0) != (i8 | 0));
   }
   if (!i11) {
    i1 = HEAP32[i12 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) != (i9 | 0)) do {
     i6 = i1 + 8 | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (!i1) i1 = 0; else {
      HEAP32[i16 >> 2] = i1;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i18 = 26; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i3 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i3 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i16);
        i3 = HEAP32[i15 >> 2] | 0;
        i20 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i3 | 0) == -1 ? i20 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i20 + (i3 << 3) | 0;
        i3 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i18 = 26; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i18 = 28;
       }
      }
      if ((i18 | 0) == 26) i18 = 28;
      if ((i18 | 0) == 28) {
       i18 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
      }
     }
     __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i7, i1, i17, 0);
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     i2 = i1;
    } while ((i2 | 0) != (i9 | 0));
   }
  }
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) != (HEAP32[i13 >> 2] | 0));
 STACKTOP = i19;
 return;
}

function __ZNK5physx2Gu11ConvexHullV22BruteForceSearchMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(i3, i19, i23, i22) {
 i3 = i3 | 0;
 i19 = i19 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i24 + 36 | 0;
 i21 = i24 + 24 | 0;
 i6 = i24 + 12 | 0;
 i5 = i24;
 i7 = i3 + 200 | 0;
 i18 = HEAP32[i7 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i18 >> 2]);
 f26 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 i18 = i3 + 96 | 0;
 f27 = Math_fround(f2 * Math_fround(HEAPF32[i18 >> 2]));
 i8 = i3 + 112 | 0;
 f27 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i8 >> 2])));
 i9 = i3 + 128 | 0;
 f27 = Math_fround(f27 + Math_fround(f1 * Math_fround(HEAPF32[i9 >> 2])));
 i10 = i3 + 100 | 0;
 f25 = Math_fround(f2 * Math_fround(HEAPF32[i10 >> 2]));
 i11 = i3 + 116 | 0;
 f25 = Math_fround(f25 + Math_fround(f26 * Math_fround(HEAPF32[i11 >> 2])));
 i12 = i3 + 132 | 0;
 f25 = Math_fround(f25 + Math_fround(f1 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i3 + 104 | 0;
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i13 >> 2]));
 i14 = i3 + 120 | 0;
 f26 = Math_fround(f2 + Math_fround(f26 * Math_fround(HEAPF32[i14 >> 2])));
 i15 = i3 + 136 | 0;
 f1 = Math_fround(f26 + Math_fround(f1 * Math_fround(HEAPF32[i15 >> 2])));
 f26 = Math_fround(HEAPF32[i19 >> 2]);
 i16 = i19 + 4 | 0;
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i19 + 8 | 0;
 f1 = Math_fround(Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f2)) + Math_fround(f1 * Math_fround(HEAPF32[i17 >> 2])));
 i4 = i3 + 204 | 0;
 if ((HEAPU8[i4 >> 0] | 0) <= 1) {
  f26 = f1;
  f27 = f1;
  HEAPF32[i23 >> 2] = f26;
  i23 = i23 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  HEAPF32[i22 >> 2] = f27;
  i23 = i22 + 4 | 0;
  HEAP32[i23 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i23 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
  HEAP32[i23 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
  STACKTOP = i24;
  return;
 }
 f2 = f1;
 i3 = 1;
 do {
  i30 = HEAP32[i7 >> 2] | 0;
  f26 = Math_fround(HEAPF32[i30 + (i3 * 12 | 0) >> 2]);
  f28 = Math_fround(HEAPF32[i30 + (i3 * 12 | 0) + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i30 + (i3 * 12 | 0) + 8 >> 2]);
  f29 = Math_fround(f26 * Math_fround(HEAPF32[i18 >> 2]));
  f29 = Math_fround(f29 + Math_fround(f28 * Math_fround(HEAPF32[i8 >> 2])));
  f29 = Math_fround(f29 + Math_fround(f27 * Math_fround(HEAPF32[i9 >> 2])));
  f25 = Math_fround(f26 * Math_fround(HEAPF32[i10 >> 2]));
  f25 = Math_fround(f25 + Math_fround(f28 * Math_fround(HEAPF32[i11 >> 2])));
  f25 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i12 >> 2])));
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i13 >> 2]));
  f28 = Math_fround(f26 + Math_fround(f28 * Math_fround(HEAPF32[i14 >> 2])));
  f27 = Math_fround(f28 + Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2])));
  f28 = Math_fround(HEAPF32[i19 >> 2]);
  f26 = Math_fround(HEAPF32[i16 >> 2]);
  f27 = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(f25 * f26)) + Math_fround(f27 * Math_fround(HEAPF32[i17 >> 2])));
  f1 = f27 > f1 ? f27 : f1;
  HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  f2 = f27 > f2 ? f2 : f27;
  HEAP32[i21 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAPU8[i4 >> 0] | 0) >>> 0);
 HEAPF32[i23 >> 2] = f2;
 i30 = i23 + 4 | 0;
 HEAP32[i30 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAPF32[i22 >> 2] = f1;
 i30 = i22 + 4 | 0;
 HEAP32[i30 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 STACKTOP = i24;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i23, i4, i1) {
 i23 = i23 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 60 | 0;
 i21 = i22;
 i1 = i23 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i23 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i20, 4);
  i3 = HEAP32[i20 >> 2] | 0;
 } else {
  i19 = HEAP32[i2 >> 2] | 0;
  HEAP32[i20 >> 2] = i19;
  HEAP32[i1 >> 2] = i3;
  i3 = i19;
 }
 i19 = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i4 + 4 | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (i19 | 0)) {
  i18 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0;
  i18 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i2 >> 2] | 0, i18, i19) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i1 + 4 >> 2] = i19;
 }
 i14 = i21 + 24 | 0;
 HEAP8[i14 >> 0] = 1;
 i15 = i21 + 28 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i21 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 36 | 0;
 HEAP32[i17 >> 2] = -1;
 i18 = i21 + 44 | 0;
 HEAP32[i18 >> 2] = 0;
 i7 = i21 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0) & 1;
 i11 = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) | 0) | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = i4;
 i8 = i6 - i2 >> 6;
 HEAP32[i21 >> 2] = i1;
 i9 = i21 + 4 | 0;
 HEAP8[i9 >> 0] = i5;
 i10 = i21 + 8 | 0;
 HEAP32[i10 >> 2] = i11;
 i11 = i21 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i21 + 16 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i21 + 20 | 0;
 HEAP8[i14 >> 0] = 1;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = -1;
 HEAP32[i21 + 40 >> 2] = i4;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i21 + 52 >> 2] = i8;
 HEAP32[i21 + 56 >> 2] = i8;
 if (!i3) {
  STACKTOP = i22;
  return;
 }
 i6 = i21 + 40 | 0;
 i7 = i20 + 20 | 0;
 i8 = i20 + 16 | 0;
 i3 = i5;
 i1 = 0;
 while (1) {
  HEAP32[i18 >> 2] = i2;
  HEAP32[i13 >> 2] = i6;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i12 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, HEAP32[i11 >> 2] | 0, i1);
   }
   i3 = HEAP32[i12 >> 2] | 0;
   HEAP8[i14 >> 0] = 1;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = i3;
   i3 = HEAP32[i13 >> 2] | 0;
   i1 = -1;
  } else {
   i5 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i10 >> 2] | 0, i1) | 0) + 16 | 0;
   HEAP8[i14 >> 0] = 0;
   HEAP32[i15 >> 2] = i5;
   HEAP32[i16 >> 2] = i3;
   i3 = i6;
  }
  HEAP32[i17 >> 2] = i1;
  HEAP32[i7 >> 2] = i23;
  HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i8 >> 2] = i3;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = i3 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i3 = i3 + 12 | 0;
   do {
    i24 = i1 + 64 | 0;
    HEAP32[i4 >> 2] = i24;
    HEAP32[i3 >> 2] = i2 - i24 >> 6;
    mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i20 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i1;
  if ((i1 | 0) == (i19 | 0)) break;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP8[i9 >> 0] | 0;
 }
 STACKTOP = i22;
 return;
}

function __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i10, i9) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 296 | 0;
 i12 = i13;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = i12 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 32 >> 2] = Math_fround(1.0);
 i1 = i12 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 52 >> 2] = Math_fround(1.0);
 i1 = i12 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 72 >> 2] = Math_fround(1.0);
 i1 = i12 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 92 >> 2] = Math_fround(1.0);
 i1 = i12 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 112 >> 2] = Math_fround(1.0);
 i1 = i12 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 132 >> 2] = Math_fround(1.0);
 i1 = i12 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 152 >> 2] = Math_fround(1.0);
 i1 = i12 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i12 + 172 >> 2] = Math_fround(1.0);
 i1 = i12 + 176 | 0;
 i2 = i12 + 249 | 0;
 i3 = i1;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i12 + 292 | 0;
 i3 = i12 + 252 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i12 + 293 >> 0] = 0;
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i14;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = gb + 1034552;
  if (!i14) {
   i14 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i14 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8GUIStyle8TransferI8JSONReadEEvRT_(i12, i3);
   HEAP8[i5 >> 0] = 1;
   i14 = i3 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  i2 = i8 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = i10 + 4 | 0;
  i4 = i10 + 12 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i10 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
  if (!i1) {
   i1 = _il2cpp_object_new(HEAP32[i9 >> 2] | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  }
  __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i12) | 0;
  i14 = HEAP32[i2 >> 2] | 0;
  HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i10 >> 0] | 0) == 0 ? i14 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i14) >> 2] = i1;
 } while (0);
 if ((HEAP8[i12 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
 STACKTOP = i13;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 88 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 88 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 88 | 0;
  i3 = (i2 | 0) / 88 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 48806446) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 88 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i1);
     i1 = i1 + 88 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -88 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN9ShaderLab18SerializedPropertyD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 88 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 88 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 88 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 88 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 88 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -88 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN9ShaderLab18SerializedPropertyD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -88 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN9ShaderLab18SerializedPropertyD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i11 = i14 + 8 | 0;
 i12 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i3 - i1 | 0) / 60 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i10 = i1 + 16 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i1 + 36 >> 2] = 0;
   HEAP32[i1 + 40 >> 2] = 0;
   HEAP32[i1 + 52 >> 2] = 0;
   HEAP32[i1 + 56 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i10 = i9;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i1 + 44 | 0;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i1 = (HEAP32[i13 >> 2] | 0) + 60 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i6 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 60 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 60 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i6;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = 25;
  HEAP32[i9 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 60 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (((i1 - i4 | 0) / 60 | 0) * 60 | 0) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i11 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i3 + (i5 * 60 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 52 >> 2] = 0;
  HEAP32[i1 + 56 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i3 = i9;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1 + 44 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  i1 = (HEAP32[i7 >> 2] | 0) + 60 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i4 = i6;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i6 >> 2] | 0;
  do {
   i1 = i1 + -60 | 0;
   __ZN13AnimationClip9PPtrCurveC2ERKS0_(i3 + -60 | 0, i1);
   i3 = (HEAP32[i6 >> 2] | 0) + -60 | 0;
   HEAP32[i6 >> 2] = i3;
  } while ((i1 | 0) != (i2 | 0));
  i4 = i6;
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i3;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i13;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 __ZNSt3__214__split_bufferIN13AnimationClip9PPtrCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_17PxcAABBDataStaticEPNS_11IntegerAABBEj(i19, i12, i15, i14, i18, i1) {
 i19 = i19 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0, i17 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 48 | 0;
 i13 = i17 + 24 | 0;
 i16 = i17;
 i1 = i14 + (HEAP32[i15 + (HEAP32[i19 >> 2] << 2) >> 2] << 3) | 0;
 i3 = i12 & 3 | 0 ? i12 & -4 : i12 + -4 | 0;
 if (i3) {
  i5 = i11 + 12 | 0;
  i6 = i11 + 4 | 0;
  i7 = i11 + 8 | 0;
  i8 = i5 + 4 | 0;
  i9 = i5 + 8 | 0;
  i10 = 0;
  do {
   i4 = 0;
   i2 = i1;
   while (1) {
    i20 = i4 + i10 | 0;
    i1 = i14 + (HEAP32[i15 + (HEAP32[i19 + (i20 + 1 << 2) >> 2] << 2) >> 2] << 3) | 0;
    __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E(i2, i11);
    i2 = HEAP32[i19 + (i20 << 2) >> 2] | 0;
    i20 = HEAP32[i11 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
    i20 = HEAP32[i6 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) + 4 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
    i20 = HEAP32[i7 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) + 8 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + -16 & -16;
    i20 = HEAP32[i5 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) + 12 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
    i20 = HEAP32[i8 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) + 16 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
    i20 = HEAP32[i9 >> 2] | 0;
    HEAP32[i18 + (i2 * 24 | 0) + 20 >> 2] = ((i20 | 0) < 0 ? ~i20 : i20 | -2147483648) + 16 & -16 | 1;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == 4) break; else i2 = i1;
   }
   i10 = i10 + 4 | 0;
  } while (i10 >>> 0 < i3 >>> 0);
 }
 i10 = i12 + -1 | 0;
 if (i3 >>> 0 < i10 >>> 0) {
  i5 = i13 + 12 | 0;
  i6 = i13 + 4 | 0;
  i7 = i13 + 8 | 0;
  i8 = i5 + 4 | 0;
  i9 = i5 + 8 | 0;
  i4 = HEAP32[i19 + (i3 << 2) >> 2] | 0;
  i2 = i1;
  while (1) {
   i3 = i3 + 1 | 0;
   i20 = i4;
   i4 = HEAP32[i19 + (i3 << 2) >> 2] | 0;
   i1 = i14 + (HEAP32[i15 + (i4 << 2) >> 2] << 3) | 0;
   __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E(i2, i13);
   i12 = HEAP32[i13 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + -16 & -16;
   i12 = HEAP32[i6 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) + 4 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + -16 & -16;
   i12 = HEAP32[i7 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) + 8 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + -16 & -16;
   i12 = HEAP32[i5 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) + 12 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + 16 & -16 | 1;
   i12 = HEAP32[i8 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) + 16 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + 16 & -16 | 1;
   i12 = HEAP32[i9 >> 2] | 0;
   HEAP32[i18 + (i20 * 24 | 0) + 20 >> 2] = ((i12 | 0) < 0 ? ~i12 : i12 | -2147483648) + 16 & -16 | 1;
   if ((i3 | 0) == (i10 | 0)) break; else i2 = i1;
  }
 }
 __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E(i1, i16);
 i20 = HEAP32[i19 + (i10 << 2) >> 2] | 0;
 i19 = i16 + 12 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) >> 2] = ((i15 | 0) < 0 ? ~i15 : i15 | -2147483648) + -16 & -16;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) + 4 >> 2] = ((i15 | 0) < 0 ? ~i15 : i15 | -2147483648) + -16 & -16;
 i16 = HEAP32[i16 + 8 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) + 8 >> 2] = ((i16 | 0) < 0 ? ~i16 : i16 | -2147483648) + -16 & -16;
 i16 = HEAP32[i19 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) + 12 >> 2] = ((i16 | 0) < 0 ? ~i16 : i16 | -2147483648) + 16 & -16 | 1;
 i16 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) + 16 >> 2] = ((i16 | 0) < 0 ? ~i16 : i16 | -2147483648) + 16 & -16 | 1;
 i19 = HEAP32[i19 + 8 >> 2] | 0;
 HEAP32[i18 + (i20 * 24 | 0) + 20 >> 2] = ((i19 | 0) < 0 ? ~i19 : i19 | -2147483648) + 16 & -16 | 1;
 STACKTOP = i17;
 return;
}

function __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf(i10, i9, i5, i8, i6, i4, f3) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i7 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 144 | 0;
 i7 = i11 + 160 | 0;
 i2 = i11;
 if (!(HEAP8[i10 + 52 >> 0] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(HEAP8[i10 + 53 >> 0] | 0)) {
  HEAP16[i9 + 12 >> 1] = 7;
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(HEAP16[HEAP32[i10 + 40 >> 2] >> 1] & 512)) {
  HEAPF32[i9 + 40 >> 2] = Math_fround(0.0);
  i10 = HEAP32[i10 + 36 >> 2] | 0;
  f13 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
  f12 = Math_fround(-Math_fround(HEAPF32[i10 + 4 >> 2]));
  f3 = Math_fround(-Math_fround(HEAPF32[i10 + 8 >> 2]));
  HEAPF32[i9 + 28 >> 2] = f13;
  HEAPF32[i9 + 32 >> 2] = f12;
  HEAPF32[i9 + 36 >> 2] = f3;
  HEAP16[i9 + 12 >> 1] = 6;
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i14 = HEAP32[i10 + 32 >> 2] | 0;
 i23 = HEAP32[i14 >> 2] | 0;
 i22 = HEAP32[i14 + 4 >> 2] | 0;
 i21 = HEAP32[i14 + 8 >> 2] | 0;
 i20 = HEAP32[i14 + 12 >> 2] | 0;
 i19 = HEAP32[i14 + 16 >> 2] | 0;
 i17 = HEAP32[i14 + 20 >> 2] | 0;
 i5 = HEAP32[i5 + 24 >> 2] | 0;
 i24 = i2 + 64 | 0;
 HEAP32[i2 + 80 >> 2] = 4;
 HEAPF32[i2 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 8 >> 2] = -1;
 HEAP32[i1 + 12 >> 2] = -1;
 HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i24 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 128 >> 2] = i5;
 i1 = i2 + 132 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 96 >> 2] = i23;
 HEAP32[i2 + 100 >> 2] = i22;
 HEAP32[i2 + 104 >> 2] = i21;
 HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 112 >> 2] = i20;
 HEAP32[i2 + 116 >> 2] = i19;
 HEAP32[i2 + 120 >> 2] = i17;
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 16 >> 2] = i5;
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 32 >> 2] = i5;
 i1 = i2 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 f16 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(Math_fround(f18 + f12) * Math_fround(.5));
 f13 = Math_fround(Math_fround(f13 + (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f16 + f15) * Math_fround(.5));
 HEAPF32[i2 + 4 >> 2] = f12;
 HEAPF32[i2 + 8 >> 2] = f13;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 i8 = __ZN5physx2Gu30computeCapsule_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbRNS_10PxSweepHitE(i8, i6, i2, Math_fround(HEAPF32[i14 + 24 >> 2]), f3, i4, i9) | 0;
 i1 = i9 + 12 | 0;
 HEAP16[i1 >> 1] = 6;
 if (i8) HEAP16[i1 >> 1] = 7; else {
  HEAPF32[i9 + 40 >> 2] = Math_fround(0.0);
  i24 = HEAP32[i10 + 36 >> 2] | 0;
  f15 = Math_fround(-Math_fround(HEAPF32[i24 >> 2]));
  f16 = Math_fround(-Math_fround(HEAPF32[i24 + 4 >> 2]));
  f18 = Math_fround(-Math_fround(HEAPF32[i24 + 8 >> 2]));
  HEAPF32[i9 + 28 >> 2] = f15;
  HEAPF32[i9 + 32 >> 2] = f16;
  HEAPF32[i9 + 36 >> 2] = f18;
 }
 i24 = 1;
 STACKTOP = i11;
 return i24 | 0;
}

function __ZNK5physx29PxJointLimitConeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 80 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj501ENS_22PxRepXPropertyAccessorILj501ES4_ffEEEEvRKT0_(i9, i8);
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i6 + 96 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj502ENS_22PxRepXPropertyAccessorILj502ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}
function __ZN11AudioSource8SetPitchEf(i8, f2) {
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i8 + 436 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i3 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 if ((i6 & 2139095040 | 0) == 2139095040) {
  if (!i8) i1 = 0; else i1 = HEAP32[i8 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 866542 | 0, 0, gb + 855390 | 0, 1122, 512, i1, 0, 0);
  STACKTOP = i9;
  return;
 }
 if (f2 != f2 | Math_fround(0.0) != Math_fround(0.0)) {
  if (!i8) i1 = 0; else i1 = HEAP32[i8 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 866615 | 0, 0, gb + 855390 | 0, 1127, 512, i1, 0, 0);
  STACKTOP = i9;
  return;
 }
 if (i1) {
  i3 = f2 < Math_fround(0.0);
  if (i3) if (__ZNK10SampleClip20GetCompressionFormatEv(i1) | 0) if (HEAP32[i1 + 52 >> 2] | 0) {
   if (!i8) i1 = 0; else i1 = HEAP32[i8 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 866683 | 0, 0, gb + 855390 | 0, 1134, 512, i1, 0, 0);
   STACKTOP = i9;
   return;
  }
  i1 = HEAP32[i1 + 124 >> 2] | 0;
  if (i1) if (HEAP32[i1 + 44 >> 2] | 0) {
   i10 = f2 > Math_fround(3.0);
   f2 = i10 ? Math_fround(3.0) : f2;
   i6 = i3 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  }
 }
 f2 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = i8 + 408 | 0;
 if (f2 != Math_fround(HEAPF32[i1 >> 2])) HEAP32[i1 >> 2] = i6;
 i1 = i8 + 456 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
  i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i10 + 224 >> 2] = i6;
  __ZN20SoundChannelInstance11UpdatePitchEv(i10);
 }
 i1 = HEAP32[i8 + 432 >> 2] | 0;
 i5 = i8 + 428 | 0;
 i3 = i1;
 if ((i3 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  if (!i4) {
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
  } else {
   i1 = i4 + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = i4 + 16 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 + 224 >> 2] = i6;
    __ZN20SoundChannelInstance11UpdatePitchEv(i10);
   }
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   i10 = i4 + 4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   if (!(HEAP32[i10 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
   }
  }
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function runPostSets221() {
 HEAP32[gb + 188576 >> 2] = fb + 96;
 HEAP32[gb + 188580 >> 2] = fb + 81;
 HEAP32[gb + 188584 >> 2] = fb + 82;
 HEAP32[gb + 188596 >> 2] = (HEAP32[gb + 188596 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 188600 >> 2] = (HEAP32[gb + 188600 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 188636 >> 2] = fb + 2899;
 HEAP32[gb + 188640 >> 2] = fb + 2900;
 HEAP32[gb + 188644 >> 2] = fb + 2211;
 HEAP32[gb + 188656 >> 2] = fb + 2901;
 HEAP32[gb + 188660 >> 2] = fb + 2902;
 HEAP32[gb + 188664 >> 2] = fb + 2212;
 HEAP32[gb + 188676 >> 2] = fb + 2903;
 HEAP32[gb + 188680 >> 2] = fb + 2904;
 HEAP32[gb + 188684 >> 2] = fb + 80;
 HEAP32[gb + 188688 >> 2] = fb + 39;
 HEAP32[gb + 188692 >> 2] = fb + 16;
 HEAP32[gb + 188696 >> 2] = fb + 39;
 HEAP32[gb + 188700 >> 2] = fb + 40;
 HEAP32[gb + 188704 >> 2] = fb + 19;
 HEAP32[gb + 188708 >> 2] = fb + 1364;
 HEAP32[gb + 188712 >> 2] = fb + 99;
 HEAP32[gb + 188716 >> 2] = fb + 40;
 HEAP32[gb + 188720 >> 2] = fb + 62;
 HEAP32[gb + 188724 >> 2] = fb + 28;
 HEAP32[gb + 188728 >> 2] = fb + 63;
 HEAP32[gb + 188732 >> 2] = fb + 29;
 HEAP32[gb + 188736 >> 2] = fb + 34;
 HEAP32[gb + 188740 >> 2] = fb + 2213;
 HEAP32[gb + 188744 >> 2] = fb + 2214;
 HEAP32[gb + 188748 >> 2] = fb + 2215;
 HEAP32[gb + 188752 >> 2] = fb + 2216;
 HEAP32[gb + 188756 >> 2] = fb + 2217;
 HEAP32[gb + 188760 >> 2] = fb + 2218;
 HEAP32[gb + 188764 >> 2] = fb + 36;
 HEAP32[gb + 188768 >> 2] = fb + 96;
 HEAP32[gb + 188772 >> 2] = fb + 81;
 HEAP32[gb + 188776 >> 2] = fb + 82;
 HEAP32[gb + 188788 >> 2] = (HEAP32[gb + 188788 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 188792 >> 2] = (HEAP32[gb + 188792 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 188828 >> 2] = fb + 90;
 HEAP32[gb + 188832 >> 2] = fb + 169;
 HEAP32[gb + 188836 >> 2] = fb + 2905;
 HEAP32[gb + 188840 >> 2] = fb + 2906;
 HEAP32[gb + 188844 >> 2] = fb + 1;
 HEAP32[gb + 188848 >> 2] = fb + 2907;
 HEAP32[gb + 188852 >> 2] = fb + 2908;
 HEAP32[gb + 188856 >> 2] = fb + 2909;
 HEAP32[gb + 188860 >> 2] = fb + 2910;
 HEAP32[gb + 188864 >> 2] = fb + 2911;
 HEAP32[gb + 188868 >> 2] = fb + 2912;
 HEAP32[gb + 188872 >> 2] = fb + 2913;
 HEAP32[gb + 188884 >> 2] = fb + 2914;
 HEAP32[gb + 188888 >> 2] = fb + 2915;
 HEAP32[gb + 188892 >> 2] = fb + 2219;
 HEAP32[gb + 188904 >> 2] = fb + 2914;
 HEAP32[gb + 188908 >> 2] = fb + 2916;
 HEAP32[gb + 188912 >> 2] = fb + 2220;
 HEAP32[gb + 188924 >> 2] = fb + 2917;
 HEAP32[gb + 188928 >> 2] = fb + 2918;
 HEAP32[gb + 188932 >> 2] = fb + 2221;
 HEAP32[gb + 188944 >> 2] = fb + 2919;
 HEAP32[gb + 188948 >> 2] = fb + 2920;
 HEAP32[gb + 188952 >> 2] = fb + 2222;
 HEAP32[gb + 188964 >> 2] = fb + 2917;
 HEAP32[gb + 188968 >> 2] = fb + 2921;
 HEAP32[gb + 188972 >> 2] = fb + 2221;
 HEAP32[gb + 188984 >> 2] = fb + 2914;
 HEAP32[gb + 188988 >> 2] = fb + 2922;
 HEAP32[gb + 188992 >> 2] = fb + 2220;
 HEAP32[gb + 188996 >> 2] = (HEAP32[gb + 188996 >> 2] | 0) + (gb + 1041308 | 0);
 HEAP32[gb + 189e3 >> 2] = (HEAP32[gb + 189e3 >> 2] | 0) + (gb + 1041318 | 0);
 HEAP32[gb + 189012 >> 2] = fb + 90;
 HEAP32[gb + 189016 >> 2] = fb + 169;
 HEAP32[gb + 189020 >> 2] = fb + 2923;
 HEAP32[gb + 189024 >> 2] = fb + 2924;
 HEAP32[gb + 189028 >> 2] = fb + 1365;
 HEAP32[gb + 189032 >> 2] = fb + 2907;
 HEAP32[gb + 189036 >> 2] = fb + 2908;
 HEAP32[gb + 189040 >> 2] = fb + 2909;
 HEAP32[gb + 189044 >> 2] = fb + 2910;
 HEAP32[gb + 189048 >> 2] = fb + 2911;
 HEAP32[gb + 189052 >> 2] = fb + 2912;
 HEAP32[gb + 189056 >> 2] = fb + 2913;
 HEAP32[gb + 189060 >> 2] = fb + 170;
 HEAP32[gb + 189072 >> 2] = fb + 171;
 HEAP32[gb + 189076 >> 2] = fb + 2925;
 HEAP32[gb + 189080 >> 2] = fb + 2926;
 HEAP32[gb + 189092 >> 2] = fb + 2927;
 HEAP32[gb + 189096 >> 2] = fb + 2928;
 HEAP32[gb + 189100 >> 2] = fb + 2929;
 HEAP32[gb + 189104 >> 2] = fb + 2223;
 HEAP32[gb + 189108 >> 2] = fb + 2224;
 HEAP32[gb + 189120 >> 2] = fb + 172;
 HEAP32[gb + 189124 >> 2] = fb + 2930;
 HEAP32[gb + 189128 >> 2] = fb + 2931;
 HEAP32[gb + 189140 >> 2] = fb + 2932;
 HEAP32[gb + 189144 >> 2] = fb + 2933;
 HEAP32[gb + 189148 >> 2] = fb + 80;
 HEAP32[gb + 189152 >> 2] = fb + 39;
 HEAP32[gb + 189156 >> 2] = fb + 16;
 runPostSets222();
}

function __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_(i9, i10, i7, i6, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_(i9, i10, i7, i6, i1) | 0;
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 >= i1 >>> 0) {
  if ((i2 | 0) != (i1 | 0)) {
   i11 = i8;
   STACKTOP = i12;
   return i11 | 0;
  }
  if ((HEAP32[i5 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
   i11 = i8;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i1 = i11;
 i2 = i6;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i6;
 i2 = i5;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 36 >> 0] = HEAP8[i5 + 36 >> 0] | 0;
 i1 = i5;
 i2 = i11;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i5 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i3 = i8 + 1 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = i7 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  if ((i1 | 0) != (i2 | 0)) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
  if ((HEAP32[i6 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i1 = i11;
 i2 = i7;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i7;
 i2 = i6;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i7 + 36 >> 0] = HEAP8[i6 + 36 >> 0] | 0;
 i1 = i6;
 i2 = i11;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i6 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i3 = i8 + 2 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = i10 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  if ((i1 | 0) != (i2 | 0)) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
  if ((HEAP32[i7 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i1 = i11;
 i2 = i10;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i10;
 i2 = i7;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i10 + 36 >> 0] = HEAP8[i7 + 36 >> 0] | 0;
 i1 = i7;
 i2 = i11;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i7 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i3 = i8 + 3 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i9 + 16 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  if ((i1 | 0) != (i2 | 0)) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
  if ((HEAP32[i10 + 24 >> 2] | 0) >>> 0 >= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   i11 = i3;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i1 = i11;
 i2 = i9;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i9;
 i2 = i10;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i9 + 36 >> 0] = HEAP8[i10 + 36 >> 0] | 0;
 i1 = i10;
 i2 = i11;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i10 + 36 >> 0] = HEAP8[i11 + 36 >> 0] | 0;
 i11 = i8 + 4 | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 6 >>> 0 >= i2 >>> 0) {
  do {
   i13 = i1 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i13 + 11 >> 0] = 0;
   HEAP8[i13 >> 0] = 0;
   i13 = i1 + 20 | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i13 + 11 >> 0] = 0;
   HEAP8[i13 >> 0] = 0;
   i13 = i1 + 36 | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i13 + 12 >> 2] = 0;
   HEAP32[i13 + 16 >> 2] = 0;
   HEAP32[i13 + 20 >> 2] = 0;
   HEAP32[i13 + 24 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 64 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i13 = i9 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 6) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 5;
 i3 = i8 >> 6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 6, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i5 + (i1 - i4 >> 6 << 6) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 6) | 0;
 i8 = i6;
 i1 = i7;
 do {
  i5 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i5 + 11 >> 0] = 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 20 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i5 + 11 >> 0] = 0;
  HEAP8[i5 >> 0] = 0;
  i5 = i1 + 36 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  i1 = i8 + 64 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i1 = i6;
  i6 = i4;
  i2 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -64 | 0;
   __ZN14AnimationEventC2ERKS_(i2 + -64 | 0, i1);
   i2 = i3 + -64 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i1 = i3;
  i6 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i3 = i6;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  i5 = i12 + 4 | 0;
  do {
   i1 = i2 + -44 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   i1 = i2 + -60 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   i2 = i2 + -64 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Cm12RenderBuffer6appendERKNS_14PxRenderBufferE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i9 + 4 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0) | 0;
 i7 = i9 + 8 | 0;
 i2 = (HEAP32[i7 >> 2] | 0) + i3 | 0;
 i6 = i9 + 12 | 0;
 if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i5, i2);
 i4 = i1 + (i3 << 4) | 0;
 if ((i3 | 0) > 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 + (i2 << 4) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + (i2 << 4) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + (i2 << 4) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + (i2 << 4) + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i7 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i5, i1) | 0;
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i5 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0) | 0;
 __ZN5physx2Cm12RenderBuffer6appendINS_11PxDebugLineEEEvRNS_6shdfnd5ArrayIT_NS4_15AllocatorTraitsIS6_E4TypeEEEPKS6_j(i9, i9 + 16 | 0, i5, mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0) | 0);
 i5 = i9 + 28 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
 i6 = i9 + 32 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + i3 | 0;
 i7 = i9 + 36 | 0;
 if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i5, i2);
 i4 = i1 + (i3 * 48 | 0) | 0;
 if ((i3 | 0) > 0) do {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i3 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 + (i2 * 48 | 0) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 36 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i3 + (i2 * 48 | 0) + 44 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i5, i1) | 0;
  i1 = i1 + 48 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i7 = i9 + 40 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0) | 0;
 i6 = i9 + 44 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + i3 | 0;
 i5 = i9 + 48 | 0;
 if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i7, i2);
 i4 = i1 + (i3 * 24 | 0) | 0;
 if ((i3 | 0) <= 0) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i9 = HEAP32[i7 >> 2] | 0;
   HEAP32[i9 + (i2 * 24 | 0) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + (i2 * 24 | 0) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + (i2 * 24 | 0) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i9 = i9 + (i2 * 24 | 0) + 12 | 0;
   i8 = i1 + 12 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i7, i1) | 0;
  i1 = i1 + 24 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function runPostSets187() {
 HEAP32[gb + 158012 >> 2] = fb + 111;
 HEAP32[gb + 158016 >> 2] = fb + 112;
 HEAP32[gb + 158020 >> 2] = fb + 113;
 HEAP32[gb + 158024 >> 2] = fb + 2328;
 HEAP32[gb + 158028 >> 2] = fb + 2329;
 HEAP32[gb + 158032 >> 2] = fb + 1758;
 HEAP32[gb + 158036 >> 2] = fb + 1759;
 HEAP32[gb + 158040 >> 2] = fb + 123;
 HEAP32[gb + 158044 >> 2] = fb + 1102;
 HEAP32[gb + 158048 >> 2] = fb + 1064;
 HEAP32[gb + 158052 >> 2] = fb + 1065;
 HEAP32[gb + 158056 >> 2] = fb + 1103;
 HEAP32[gb + 158060 >> 2] = fb + 1104;
 HEAP32[gb + 158064 >> 2] = fb + 2330;
 HEAP32[gb + 158076 >> 2] = (HEAP32[gb + 158076 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 158080 >> 2] = (HEAP32[gb + 158080 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 158116 >> 2] = fb + 2452;
 HEAP32[gb + 158120 >> 2] = fb + 2453;
 HEAP32[gb + 158124 >> 2] = fb + 38;
 HEAP32[gb + 158128 >> 2] = fb + 1760;
 HEAP32[gb + 158132 >> 2] = fb + 16;
 HEAP32[gb + 158136 >> 2] = fb + 2454;
 HEAP32[gb + 158140 >> 2] = fb + 2455;
 HEAP32[gb + 158144 >> 2] = fb + 2456;
 HEAP32[gb + 158148 >> 2] = fb + 1105;
 HEAP32[gb + 158152 >> 2] = fb + 103;
 HEAP32[gb + 158156 >> 2] = fb + 101;
 HEAP32[gb + 158160 >> 2] = fb + 62;
 HEAP32[gb + 158164 >> 2] = fb + 28;
 HEAP32[gb + 158168 >> 2] = fb + 63;
 HEAP32[gb + 158172 >> 2] = fb + 29;
 HEAP32[gb + 158176 >> 2] = fb + 34;
 HEAP32[gb + 158180 >> 2] = fb + 1761;
 HEAP32[gb + 158184 >> 2] = fb + 1762;
 HEAP32[gb + 158188 >> 2] = fb + 1763;
 HEAP32[gb + 158192 >> 2] = fb + 1764;
 HEAP32[gb + 158196 >> 2] = fb + 1765;
 HEAP32[gb + 158200 >> 2] = fb + 1766;
 HEAP32[gb + 158204 >> 2] = fb + 36;
 HEAP32[gb + 158208 >> 2] = fb + 104;
 HEAP32[gb + 158212 >> 2] = fb + 108;
 HEAP32[gb + 158216 >> 2] = fb + 94;
 HEAP32[gb + 158220 >> 2] = fb + 1574;
 HEAP32[gb + 158224 >> 2] = fb + 112;
 HEAP32[gb + 158228 >> 2] = fb + 113;
 HEAP32[gb + 158232 >> 2] = fb + 131;
 HEAP32[gb + 158236 >> 2] = fb + 111;
 HEAP32[gb + 158240 >> 2] = fb + 112;
 HEAP32[gb + 158244 >> 2] = fb + 113;
 HEAP32[gb + 158248 >> 2] = fb + 2317;
 HEAP32[gb + 158252 >> 2] = fb + 2318;
 HEAP32[gb + 158256 >> 2] = fb + 2457;
 HEAP32[gb + 158260 >> 2] = fb + 1575;
 HEAP32[gb + 158264 >> 2] = fb + 1106;
 HEAP32[gb + 158268 >> 2] = fb + 1107;
 HEAP32[gb + 158280 >> 2] = (HEAP32[gb + 158280 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 158284 >> 2] = (HEAP32[gb + 158284 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 158320 >> 2] = fb + 2458;
 HEAP32[gb + 158324 >> 2] = fb + 2459;
 HEAP32[gb + 158328 >> 2] = fb + 38;
 HEAP32[gb + 158332 >> 2] = fb + 1767;
 HEAP32[gb + 158336 >> 2] = fb + 16;
 HEAP32[gb + 158340 >> 2] = fb + 2460;
 HEAP32[gb + 158344 >> 2] = fb + 2461;
 HEAP32[gb + 158348 >> 2] = fb + 19;
 HEAP32[gb + 158352 >> 2] = fb + 1108;
 HEAP32[gb + 158356 >> 2] = fb + 103;
 HEAP32[gb + 158360 >> 2] = fb + 101;
 HEAP32[gb + 158364 >> 2] = fb + 62;
 HEAP32[gb + 158368 >> 2] = fb + 28;
 HEAP32[gb + 158372 >> 2] = fb + 63;
 HEAP32[gb + 158376 >> 2] = fb + 29;
 HEAP32[gb + 158380 >> 2] = fb + 34;
 HEAP32[gb + 158384 >> 2] = fb + 1768;
 HEAP32[gb + 158388 >> 2] = fb + 1769;
 HEAP32[gb + 158392 >> 2] = fb + 1770;
 HEAP32[gb + 158396 >> 2] = fb + 1771;
 HEAP32[gb + 158400 >> 2] = fb + 1772;
 HEAP32[gb + 158404 >> 2] = fb + 1773;
 HEAP32[gb + 158408 >> 2] = fb + 36;
 HEAP32[gb + 158412 >> 2] = fb + 104;
 HEAP32[gb + 158416 >> 2] = fb + 108;
 HEAP32[gb + 158420 >> 2] = fb + 94;
 HEAP32[gb + 158424 >> 2] = fb + 1574;
 HEAP32[gb + 158428 >> 2] = fb + 112;
 HEAP32[gb + 158432 >> 2] = fb + 113;
 HEAP32[gb + 158436 >> 2] = fb + 131;
 HEAP32[gb + 158440 >> 2] = fb + 111;
 HEAP32[gb + 158444 >> 2] = fb + 112;
 HEAP32[gb + 158448 >> 2] = fb + 113;
 HEAP32[gb + 158452 >> 2] = fb + 2317;
 HEAP32[gb + 158456 >> 2] = fb + 2318;
 HEAP32[gb + 158460 >> 2] = fb + 2462;
 HEAP32[gb + 158464 >> 2] = fb + 1575;
 HEAP32[gb + 158468 >> 2] = fb + 1059;
 HEAP32[gb + 158472 >> 2] = fb + 1060;
 HEAP32[gb + 158476 >> 2] = fb + 1576;
 HEAP32[gb + 158480 >> 2] = fb + 1577;
 HEAP32[gb + 158492 >> 2] = (HEAP32[gb + 158492 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 158496 >> 2] = (HEAP32[gb + 158496 >> 2] | 0) + (gb + 1576256 | 0);
 runPostSets188();
}

function __ZN24RingBufferMemoryFileData16ConsumeReadBytesEy(i16, i10, i12) {
 i16 = i16 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i22 + 8 | 0;
 i2 = i22;
 i20 = i22 + 16 | 0;
 i15 = i16 + 40 | 0;
 i19 = i15;
 i11 = i16 + 20 | 0;
 i19 = _i64Add(HEAP32[i11 >> 2] | 0, 0, HEAP32[i19 >> 2] | 0, HEAP32[i19 + 4 >> 2] | 0) | 0;
 i18 = getTempRet0() | 0;
 if (i18 >>> 0 > i12 >>> 0 | (i18 | 0) == (i12 | 0) & i19 >>> 0 > i10 >>> 0) {
  STACKTOP = i22;
  return;
 }
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i17 = i2;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i20 >> 2] = 0;
 i17 = i20 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i20 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i14 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = i19;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i16 + 52 | 0;
 i14 = i16 + 64 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) i21 = 21; else {
  i9 = i16 + 48 | 0;
  i2 = 0;
  i8 = 0;
  while (1) {
   i4 = i15;
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = _i64Add(i3 | 0, 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   i5 = getTempRet0() | 0;
   if (i5 >>> 0 > i12 >>> 0 | (i5 | 0) == (i12 | 0) & i4 >>> 0 > i10 >>> 0) break;
   i7 = i2 + 1 | 0;
   i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i2 = i15;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i3;
   i2 = i8;
   i8 = i8 + 1 | 0;
   i3 = HEAP32[i18 >> 2] | 0;
   i4 = i3 & 2147483647;
   do if (i8 >>> 0 > i4 >>> 0) {
    i1 = i3 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i18 >> 2] = i1;
     HEAP32[i20 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i20 >> 2] | 0, i1 << 2, 4, i19, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i19, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
     HEAP32[i18 >> 2] = i1;
     HEAP32[i20 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i17 >> 2] = i8;
   HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   i1 = HEAP32[i14 >> 2] | 0;
   if (i7 >>> 0 >= i1 >>> 0) {
    i2 = i7;
    break;
   } else i2 = i7;
  }
  if (!i2) i21 = 21; else {
   i15 = HEAP32[i13 >> 2] | 0;
   _memmove(i15 | 0, i15 + (i2 << 2) | 0, i1 - i2 << 2 | 0) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) - (i2 << 2 >> 2);
   if (HEAP32[i17 >> 2] | 0) {
    i9 = i16 + 76 | 0;
    i10 = i16 + 88 | 0;
    i11 = i16 + 92 | 0;
    i3 = i16 + 80 | 0;
    i1 = 0;
    i5 = HEAP32[i10 >> 2] | 0;
    do {
     i4 = (HEAP32[i20 >> 2] | 0) + (i1 << 2) | 0;
     i6 = i5;
     i5 = i5 + 1 | 0;
     i7 = HEAP32[i11 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i5 >>> 0 > i8 >>> 0) {
      i2 = i7 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i11 >> 2] = i2;
       HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i16 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
       HEAP32[i11 >> 2] = i2;
       HEAP32[i9 >> 2] = i16;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i5;
     HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] = HEAP32[i4 >> 2];
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
   }
  }
 }
 if ((HEAP32[i18 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i19);
  HEAP32[i20 >> 2] = 0;
 }
 STACKTOP = i22;
 return;
}
function __Z31CullDirectionalShadowCastersJobP20ShadowCullingJobDataj(i11, i6) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 12 | 0;
 i13 = i14;
 if ((HEAP16[gb + 1112840 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112840 | 0, i10);
  i12 = gb + 1112840 | 0;
 } else i12 = 0;
 i9 = i11 + 28 + (i6 * 12 | 0) | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 if (!(HEAP8[(HEAP32[i5 + 832 >> 2] | 0) + 60 >> 0] | 0)) {
  i3 = HEAP32[i11 + 20 >> 2] | 0;
  i2 = HEAP32[i5 + 752 + (i3 * 12 | 0) >> 2] | 0;
  i3 = HEAP32[i5 + 752 + (i3 * 12 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i11 + 24 >> 2] | 0;
  if ((HEAP16[gb + 1112960 + 6 >> 1] | 0) > -1) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112960 | 0, i10);
   i1 = gb + 1112960 | 0;
  } else i1 = 0;
  i15 = HEAP32[i9 >> 2] | 0;
  i8 = i11 + 28 + (i6 * 12 | 0) + 4 | 0;
  i16 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i4 >> 2] | 0) + (i15 << 2);
  i7 = i10 + 4 | 0;
  HEAP32[i7 >> 2] = i16;
  HEAP32[i10 + 8 >> 2] = i16;
  __Z29CullShadowCastersWithoutUmbraR9IndexListRK22SceneCullingParametersPK4AABBjj(i10, i5, i2, i15, i16 + i15 | 0);
  __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(i5, i3, i2, i10);
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 } else {
  if ((HEAP16[gb + 1112948 + 6 >> 1] | 0) > -1) {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112948 | 0, i10);
   i1 = gb + 1112948 | 0;
  } else i1 = 0;
  i15 = __Z9GetIUmbrav() | 0;
  i15 = mftCall_iiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 52 >> 2] | 0, i15 | 0, i11 | 0, i9 | 0, i6 | 0) | 0;
  HEAP32[i10 >> 2] = (HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0) + (HEAP32[i9 >> 2] << 2);
  i16 = i10 + 4 | 0;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i10 + 8 >> 2] = i15;
  i15 = HEAP32[i11 + 20 >> 2] | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(i8, HEAP32[i8 + 752 + (i15 * 12 | 0) + 4 >> 2] | 0, HEAP32[i8 + 752 + (i15 * 12 | 0) >> 2] | 0, i10);
  HEAP32[i11 + 28 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i16 >> 2];
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if ((HEAP16[gb + 1112852 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112852 | 0, i10);
  i8 = gb + 1112852 | 0;
 } else i8 = 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i16 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP32[i11 + 20 >> 2] | 0;
 i7 = HEAP32[i16 + 952 >> 2] | 0;
 i2 = (HEAP8[i7 + 816 >> 0] | 0) != 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 16 >> 2];
 if ((HEAP32[i1 + 40 >> 2] | 0) == 3) i1 = 0; else if ((HEAP32[i1 + 88 >> 2] | 0) > -1) i1 = (HEAP32[i1 + 80 >> 2] | 0) == 1; else i1 = 0;
 HEAP8[i10 + 4 >> 0] = i2 & i1 & 1;
 i6 = i11 + 28 + (i6 * 12 | 0) + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i13 >> 2] = (HEAP32[HEAP32[i11 + 24 >> 2] >> 2] | 0) + (HEAP32[i9 >> 2] << 2);
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i13 + 8 >> 2] = i5;
 i5 = i7 + 752 + (i3 * 12 | 0) + 4 | 0;
 i3 = i7 + 752 + (i3 * 12 | 0) | 0;
 __Z22CullDirectionalShadowsR9IndexListPK9SceneNodePK4AABBR22DirectionalCullContext(i13, HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0, i10);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 852 >> 2] | 0;
 if (i2 | 0) mftCall_viiii(i2 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0, i13 | 0, HEAP32[i1 + 856 >> 2] | 0);
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
 if (!i12) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf(i15, i1, i11, i13) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, i14 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 24 | 0;
 i14 = i16 + 12 | 0;
 i12 = i16;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f6 * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(f8 * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(f8 + Math_fround(1.0));
 f18 = Math_fround(f10 / f17);
 f17 = Math_fround(-Math_fround(f4 / f17));
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 4 >> 2] = f18;
 HEAPF32[i14 + 8 >> 2] = f17;
 f18 = Math_fround(Math_abs(Math_fround(f18)));
 f2 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f18 = Math_fround(Math_fround(f18 + f2) / Math_fround(Math_fround(1.0) - Math_fround(f18 * f2)));
 f17 = Math_fround(Math_abs(Math_fround(f17)));
 f17 = Math_fround(Math_fround(f2 + f17) / Math_fround(Math_fround(1.0) - Math_fround(f2 * f17)));
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 f18 = Math_fround(f18 / f2);
 f18 = Math_fround(f18 * f18);
 i1 = i15 + 4 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(f17 / f3);
 if (Math_fround(f18 + Math_fround(f17 * f17)) <= Math_fround(1.0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f19 = Math_fround(Math_fround(f7 * f10) - Math_fround(f9 * f4));
 f4 = Math_fround(Math_fround(f10 * f9) + Math_fround(f7 * f4));
 f6 = Math_fround(Math_fround(f6 * f7) + Math_fround(Math_fround(f8 * f9) + Math_fround(-1.0)));
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = f2;
 HEAPF32[i5 + 8 >> 2] = f3;
 __ZN5physx6shdfnd12ellipseClampERKNS_6PxVec3ES3_(i12, i14, i5);
 f22 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i15 >> 2]);
 f21 = Math_fround(f22 / Math_fround(f21 * f21));
 f25 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(f25 / Math_fround(f20 * f20));
 f8 = Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(0.0)) + Math_fround(f22 * f22));
 f18 = Math_fround(Math_fround(1.0) - f8);
 f24 = Math_fround(Math_fround(1.0) / Math_fround(f8 + Math_fround(1.0)));
 f23 = Math_fround(f24 * f24);
 f9 = Math_fround(f23 * Math_fround(f18 * Math_fround(2.0)));
 f3 = Math_fround(f22 * Math_fround(2.0));
 f2 = Math_fround(f25 * Math_fround(2.0));
 f7 = Math_fround(f3 * f9);
 f10 = Math_fround(f2 * f9);
 f17 = Math_fround(Math_fround(f18 * f9) + Math_fround(-1.0));
 f22 = Math_fround(Math_fround(Math_fround(f20 * f25) + Math_fround(0.0)) + Math_fround(f21 * f22));
 f8 = Math_fround(f24 * Math_fround(f23 * Math_fround(Math_fround(f22 * Math_fround(-4.0)) * Math_fround(Math_fround(3.0) - f8))));
 f18 = Math_fround(Math_fround(Math_fround(f22 * Math_fround(-2.0)) * f9) + Math_fround(f18 * f8));
 f3 = Math_fround(Math_fround(Math_fround(f21 * Math_fround(2.0)) * f9) + Math_fround(f3 * f8));
 f8 = Math_fround(Math_fround(Math_fround(f20 * Math_fround(2.0)) * f9) + Math_fround(f2 * f8));
 f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f18 * f18) + Math_fround(f3 * f3))))));
 f9 = Math_fround(f2 * Math_fround(Math_fround(f7 * f8) - Math_fround(f10 * f3)));
 f8 = Math_fround(f2 * Math_fround(Math_fround(f10 * f18) - Math_fround(f17 * f8)));
 f18 = Math_fround(f2 * Math_fround(Math_fround(f17 * f3) - Math_fround(f7 * f18)));
 HEAPF32[i11 >> 2] = f9;
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f18;
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(f19 * Math_fround(Math_fround(f8 * f17) - Math_fround(f9 * f7))) + Math_fround(Math_fround(f6 * Math_fround(Math_fround(f7 * f18) - Math_fround(f8 * f10))) + Math_fround(f4 * Math_fround(Math_fround(f9 * f10) - Math_fround(f17 * f18)))));
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN10GUITexture16RenderGUIElementERK5RectTIfER17ShaderPassContext(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 240 | 0;
 i10 = i15 + 228 | 0;
 i11 = i15 + 32 | 0;
 i12 = i15 + 16 | 0;
 i13 = i15;
 i4 = i6 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i14 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i14 = 9;
  }
 }
 if ((i14 | 0) == 7) i14 = 9;
 if ((i14 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i15;
   return;
  }
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i2 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
 i1 = i1 ? i2 : 0;
 i2 = i6 + 92 | 0;
 i3 = i6 + 96 | 0;
 if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) if ((i5 | 0) == (HEAP32[i3 >> 2] | 0)) {
  if ((HEAP32[i6 + 100 >> 2] | 0) != (i1 | 0)) i14 = 13;
 } else i14 = 13; else i14 = 13;
 if ((i14 | 0) == 13) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 + 100 >> 2] = i1;
  __ZN10GUITexture10BuildSheetEv(i6);
 }
 i14 = __Z12GetGfxDevicev() | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i11, __Z12GetGfxDevicev() | 0);
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 i5 = i12 + 4 | 0;
 f20 = Math_fround(HEAPF32[i5 >> 2]);
 HEAPF32[i12 >> 2] = Math_fround(f21 - f21);
 HEAPF32[i5 >> 2] = Math_fround(f20 - f20);
 __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb(i12, i14, 1);
 i14 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i9, i14);
 __ZNK9Transform18GetWorldScaleLossyEv(i10, i14);
 f20 = Math_fround(HEAPF32[i9 >> 2]);
 f21 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(.5));
 f18 = Math_fround(f20 - f21);
 f21 = Math_fround(f20 + f21);
 f20 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f19 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) * Math_fround(.5));
 f16 = Math_fround(f20 - f19);
 f19 = Math_fround(f20 + f19);
 f20 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f18 = Math_fround(f18 * f20);
 f17 = Math_fround(HEAPF32[i6 + 72 >> 2]);
 f18 = Math_fround(f18 + f17);
 HEAPF32[i13 >> 2] = f18;
 f20 = Math_fround(f21 * f20);
 HEAPF32[i13 + 8 >> 2] = Math_fround(Math_fround(f20 + Math_fround(f17 + Math_fround(HEAPF32[i6 + 80 >> 2]))) - f18);
 f18 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f16 = Math_fround(f16 * f18);
 f17 = Math_fround(HEAPF32[i6 + 76 >> 2]);
 f16 = Math_fround(f16 + f17);
 HEAPF32[i13 + 4 >> 2] = f16;
 f18 = Math_fround(f19 * f18);
 HEAPF32[i13 + 12 >> 2] = Math_fround(Math_fround(f18 + Math_fround(f17 + Math_fround(HEAPF32[i6 + 84 >> 2]))) - f16);
 __ZN10GUITexture14DrawGUITextureERK5RectTIfER17ShaderPassContext(i6, i13, i8);
 __ZN22DeviceMVPMatricesStateD2Ev(i11);
 STACKTOP = i15;
 return;
}

function runPostSets128() {
 HEAP32[gb + 112088 >> 2] = fb + 1265;
 HEAP32[gb + 112092 >> 2] = fb + 36;
 HEAP32[gb + 112096 >> 2] = fb + 104;
 HEAP32[gb + 112100 >> 2] = fb + 108;
 HEAP32[gb + 112104 >> 2] = fb + 94;
 HEAP32[gb + 112108 >> 2] = fb + 130;
 HEAP32[gb + 112112 >> 2] = fb + 112;
 HEAP32[gb + 112116 >> 2] = fb + 113;
 HEAP32[gb + 112120 >> 2] = fb + 131;
 HEAP32[gb + 112124 >> 2] = fb + 111;
 HEAP32[gb + 112128 >> 2] = fb + 1769;
 HEAP32[gb + 112132 >> 2] = fb + 113;
 HEAP32[gb + 112136 >> 2] = fb + 1770;
 HEAP32[gb + 112140 >> 2] = fb + 1771;
 HEAP32[gb + 112152 >> 2] = (HEAP32[gb + 112152 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 112156 >> 2] = (HEAP32[gb + 112156 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 112192 >> 2] = fb + 1772;
 HEAP32[gb + 112196 >> 2] = fb + 1773;
 HEAP32[gb + 112200 >> 2] = fb + 1757;
 HEAP32[gb + 112204 >> 2] = fb + 1238;
 HEAP32[gb + 112208 >> 2] = fb + 16;
 HEAP32[gb + 112212 >> 2] = fb + 1774;
 HEAP32[gb + 112216 >> 2] = fb + 1775;
 HEAP32[gb + 112220 >> 2] = fb + 19;
 HEAP32[gb + 112224 >> 2] = fb + 879;
 HEAP32[gb + 112228 >> 2] = fb + 103;
 HEAP32[gb + 112232 >> 2] = fb + 101;
 HEAP32[gb + 112236 >> 2] = fb + 62;
 HEAP32[gb + 112240 >> 2] = fb + 28;
 HEAP32[gb + 112244 >> 2] = fb + 63;
 HEAP32[gb + 112248 >> 2] = fb + 29;
 HEAP32[gb + 112252 >> 2] = fb + 34;
 HEAP32[gb + 112256 >> 2] = fb + 1266;
 HEAP32[gb + 112260 >> 2] = fb + 1267;
 HEAP32[gb + 112264 >> 2] = fb + 1268;
 HEAP32[gb + 112268 >> 2] = fb + 1269;
 HEAP32[gb + 112272 >> 2] = fb + 1270;
 HEAP32[gb + 112276 >> 2] = fb + 1271;
 HEAP32[gb + 112280 >> 2] = fb + 36;
 HEAP32[gb + 112284 >> 2] = fb + 104;
 HEAP32[gb + 112288 >> 2] = fb + 108;
 HEAP32[gb + 112292 >> 2] = fb + 94;
 HEAP32[gb + 112296 >> 2] = fb + 1245;
 HEAP32[gb + 112300 >> 2] = fb + 105;
 HEAP32[gb + 112304 >> 2] = fb + 106;
 HEAP32[gb + 112308 >> 2] = fb + 110;
 HEAP32[gb + 112312 >> 2] = fb + 1246;
 HEAP32[gb + 112316 >> 2] = fb + 1247;
 HEAP32[gb + 112320 >> 2] = fb + 1248;
 HEAP32[gb + 112324 >> 2] = fb + 1249;
 HEAP32[gb + 112328 >> 2] = fb + 1250;
 HEAP32[gb + 112332 >> 2] = fb + 103;
 HEAP32[gb + 112336 >> 2] = fb + 1776;
 HEAP32[gb + 112340 >> 2] = fb + 1272;
 HEAP32[gb + 112352 >> 2] = (HEAP32[gb + 112352 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 112356 >> 2] = (HEAP32[gb + 112356 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 112392 >> 2] = fb + 1777;
 HEAP32[gb + 112396 >> 2] = fb + 1778;
 HEAP32[gb + 112400 >> 2] = fb + 1757;
 HEAP32[gb + 112404 >> 2] = fb + 1238;
 HEAP32[gb + 112408 >> 2] = fb + 16;
 HEAP32[gb + 112412 >> 2] = fb + 1779;
 HEAP32[gb + 112416 >> 2] = fb + 1780;
 HEAP32[gb + 112420 >> 2] = fb + 19;
 HEAP32[gb + 112424 >> 2] = fb + 880;
 HEAP32[gb + 112428 >> 2] = fb + 103;
 HEAP32[gb + 112432 >> 2] = fb + 101;
 HEAP32[gb + 112436 >> 2] = fb + 62;
 HEAP32[gb + 112440 >> 2] = fb + 28;
 HEAP32[gb + 112444 >> 2] = fb + 63;
 HEAP32[gb + 112448 >> 2] = fb + 29;
 HEAP32[gb + 112452 >> 2] = fb + 34;
 HEAP32[gb + 112456 >> 2] = fb + 1273;
 HEAP32[gb + 112460 >> 2] = fb + 1274;
 HEAP32[gb + 112464 >> 2] = fb + 1275;
 HEAP32[gb + 112468 >> 2] = fb + 1276;
 HEAP32[gb + 112472 >> 2] = fb + 1277;
 HEAP32[gb + 112476 >> 2] = fb + 1278;
 HEAP32[gb + 112480 >> 2] = fb + 36;
 HEAP32[gb + 112484 >> 2] = fb + 104;
 HEAP32[gb + 112488 >> 2] = fb + 108;
 HEAP32[gb + 112492 >> 2] = fb + 94;
 HEAP32[gb + 112496 >> 2] = fb + 1245;
 HEAP32[gb + 112500 >> 2] = fb + 105;
 HEAP32[gb + 112504 >> 2] = fb + 106;
 HEAP32[gb + 112508 >> 2] = fb + 110;
 HEAP32[gb + 112512 >> 2] = fb + 1246;
 HEAP32[gb + 112516 >> 2] = fb + 1247;
 HEAP32[gb + 112520 >> 2] = fb + 1248;
 HEAP32[gb + 112524 >> 2] = fb + 1249;
 HEAP32[gb + 112528 >> 2] = fb + 1250;
 HEAP32[gb + 112532 >> 2] = fb + 103;
 HEAP32[gb + 112536 >> 2] = fb + 1781;
 HEAP32[gb + 112540 >> 2] = fb + 1279;
 HEAP32[gb + 112552 >> 2] = (HEAP32[gb + 112552 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 112556 >> 2] = (HEAP32[gb + 112556 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 112592 >> 2] = fb + 1782;
 HEAP32[gb + 112596 >> 2] = fb + 1783;
 HEAP32[gb + 112600 >> 2] = fb + 1757;
 HEAP32[gb + 112604 >> 2] = fb + 1238;
 runPostSets129();
}

function __ZN9Heightmap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i4 = i8 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i3 << 1) | 0;
 if (i3 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i4 = i8 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = HEAP32[i8 + 24 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i4 = i8 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i8 + 72 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZN8Animator22ApplyBuiltinRootMotionEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 36 | 0;
 i9 = i15;
 switch (HEAP32[i14 + 548 >> 2] | 0) {
 case 2:
  {
   i1 = 2;
   break;
  }
 case 1:
  {
   STACKTOP = i15;
   return;
  }
 default:
  {}
 }
 if ((i1 | 0) == 2) if (Math_fround(HEAPF32[i14 + 420 >> 2]) < Math_fround(0.0)) {
  STACKTOP = i15;
  return;
 }
 if (!(HEAP32[i14 + 100 >> 2] & 2)) {
  STACKTOP = i15;
  return;
 }
 if ((HEAP16[gb + 1466920 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i14;
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466920 | 0, i13);
  i10 = gb + 1466920 | 0;
 } else i10 = 0;
 i12 = HEAP32[i14 + 276 >> 2] | 0;
 i11 = HEAP32[i14 + 280 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i14 + 272 >> 2];
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 i11 = i9 + 12 | 0;
 i12 = i14 + 153 | 0;
 i8 = (HEAP8[i12 >> 0] | 0) == 0;
 if (i8) {
  i5 = 0;
  i6 = 0;
  i7 = 0;
  i1 = 1065353216;
 } else {
  i5 = HEAP32[i14 + 136 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f19 = Math_fround(f17 * f17);
  f16 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f2 = Math_fround(f16 * f16);
  f3 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f4 = Math_fround(f3 * f3);
  f18 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f4 = Math_fround(Math_fround(f19 + f2) + Math_fround(f4 + Math_fround(f18 * f18)));
  f2 = Math_fround(Math_sqrt(Math_fround(f4)));
  f17 = Math_fround(f17 / f2);
  f16 = Math_fround(f16 / f2);
  f3 = Math_fround(f3 / f2);
  f2 = Math_fround(f18 / f2);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = f4 > Math_fround(1.0e-30);
  i5 = i1 ? i5 : 0;
  i6 = i1 ? i6 : 0;
  i7 = i1 ? i7 : 0;
  i1 = i1 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 }
 HEAP32[i11 >> 2] = i5;
 HEAP32[i9 + 16 >> 2] = i6;
 HEAP32[i9 + 20 >> 2] = i7;
 HEAP32[i9 + 24 >> 2] = i1;
 if (i8) f2 = Math_fround(0.0); else {
  i1 = HEAP32[i14 + 132 >> 2] | 0;
  if (!i1) f2 = Math_fround(0.0); else {
   i1 = HEAP32[i1 + 16 >> 2] | 0;
   if (!i1) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i1 + 284 >> 2]);
  }
 }
 HEAPF32[i9 + 28 >> 2] = f2;
 i1 = i9 + 32 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i13 >> 2] = gb + 29632;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = i9;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i14, gb + 1105456 | 0, i13);
 do if (HEAP8[i12 >> 0] | 0) if ((HEAP32[i14 + 168 >> 2] | 0) != 0 & (HEAP8[i1 >> 0] | 0) == 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i14 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  f19 = Math_fround(HEAPF32[i14 + 300 >> 2]);
  f2 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
  if (!(f19 != f2)) {
   f19 = Math_fround(HEAPF32[i14 + 304 >> 2]);
   f3 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
   if (!(f19 != f3)) {
    f19 = Math_fround(HEAPF32[i14 + 308 >> 2]);
    f4 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
    if (!(f19 != f4)) if (!(Math_fround(HEAPF32[i14 + 312 >> 2]) != f2)) if (!(Math_fround(HEAPF32[i14 + 316 >> 2]) != f3)) if (!(Math_fround(HEAPF32[i14 + 320 >> 2]) != f4)) break;
   }
  }
  if (!(HEAP8[i12 >> 0] | 0)) {
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i13 + 8 >> 2] = Math_fround(0.0);
  } else {
   i14 = HEAP32[i14 + 136 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  }
  __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i1, i13, i11);
 } while (0);
 if (!i10) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i8, i11, i27, i29, i31, i2, i1, i28, i30) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 i27 = i27 | 0;
 i29 = i29 | 0;
 i31 = i31 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i30 = i30 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f18 - f21);
 f20 = Math_fround(f20 - f22);
 f23 = Math_fround(f23 - f19);
 f24 = Math_fround(HEAPF32[i29 >> 2]);
 i1 = i29 + 4 | 0;
 f25 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i29 + 8 | 0;
 f26 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(Math_fround(f20 * f26) - Math_fround(f23 * f25));
 f7 = Math_fround(Math_fround(f23 * f24) - Math_fround(f18 * f26));
 f9 = Math_fround(Math_fround(f18 * f25) - Math_fround(f20 * f24));
 f13 = Math_fround(Math_fround(f19 * f9) + Math_fround(Math_fround(f21 * f6) + Math_fround(f22 * f7)));
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f14 * f6) + Math_fround(f7 * f16)) + Math_fround(f9 * f17));
 f3 = Math_fround(HEAPF32[i11 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 if (Math_fround(Math_fround(f10 - f13) * Math_fround(Math_fround(Math_fround(Math_fround(f6 * f3) + Math_fround(f7 * f4)) + Math_fround(f9 * f5)) - f13)) > Math_fround(0.0)) return;
 f15 = Math_fround(f3 - f14);
 f12 = Math_fround(f4 - f16);
 f4 = Math_fround(f5 - f17);
 f3 = Math_fround(Math_fround(Math_fround(f6 * f15) + Math_fround(f7 * f12)) + Math_fround(f9 * f4));
 if (f3 == Math_fround(0.0)) return;
 f7 = Math_fround(Math_fround(f13 - f10) / f3);
 f10 = Math_fround(Math_fround(f15 * f7) + f14);
 f9 = Math_fround(Math_fround(f12 * f7) + f16);
 f7 = Math_fround(Math_fround(f4 * f7) + f17);
 f17 = Math_fround(Math_fround(f4 * f25) - Math_fround(f12 * f26));
 f4 = Math_fround(Math_fround(f15 * f26) - Math_fround(f4 * f24));
 f16 = Math_fround(Math_fround(f12 * f24) - Math_fround(f15 * f25));
 f6 = Math_fround(f10 - f21);
 f5 = Math_fround(f9 - f22);
 f3 = Math_fround(f7 - f19);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(f4 * f5)) + Math_fround(f16 * f3)) / Math_fround(Math_fround(f23 * f16) + Math_fround(Math_fround(f18 * f17) + Math_fround(f20 * f4))));
 i11 = f4 > Math_fround(1.0);
 f4 = i11 ? Math_fround(1.0) : f4;
 i11 = f4 > Math_fround(0.0);
 f4 = i11 ? f4 : Math_fround(0.0);
 f6 = Math_fround(f6 - Math_fround(f18 * f4));
 f5 = Math_fround(f5 - Math_fround(f20 * f4));
 f4 = Math_fround(f3 - Math_fround(f23 * f4));
 f3 = Math_fround(Math_fround(f26 * f4) + Math_fround(Math_fround(f24 * f6) + Math_fround(f25 * f5)));
 if (!(Math_fround(HEAPF32[i27 >> 2]) > f3)) return;
 f24 = Math_fround(f10 - f6);
 f25 = Math_fround(f9 - f5);
 f26 = Math_fround(f7 - f4);
 i27 = HEAP32[i30 >> 2] | 0;
 HEAPF32[i28 + (i27 << 6) >> 2] = f10;
 HEAPF32[i28 + (i27 << 6) + 4 >> 2] = f9;
 HEAPF32[i28 + (i27 << 6) + 8 >> 2] = f7;
 HEAPF32[i28 + (i27 << 6) + 12 >> 2] = Math_fround(0.0);
 i27 = HEAP32[i30 >> 2] | 0;
 HEAPF32[i28 + (i27 << 6) + 16 >> 2] = f24;
 HEAPF32[i28 + (i27 << 6) + 20 >> 2] = f25;
 HEAPF32[i28 + (i27 << 6) + 24 >> 2] = f26;
 HEAPF32[i28 + (i27 << 6) + 28 >> 2] = Math_fround(0.0);
 i27 = HEAP32[i30 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i28 + (i27 << 6) + 32 >> 2] = HEAP32[i29 >> 2];
 HEAP32[i28 + (i27 << 6) + 36 >> 2] = i8;
 HEAP32[i28 + (i27 << 6) + 40 >> 2] = i11;
 HEAPF32[i28 + (i27 << 6) + 44 >> 2] = f3;
 i29 = HEAP32[i30 >> 2] | 0;
 HEAP32[i30 >> 2] = i29 + 1;
 HEAP32[i28 + (i29 << 6) + 48 >> 2] = i31;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold20reduceBatchContacts2EPKNS0_17PersistentContactEj(i9, i17, i16) {
 i9 = i9 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18;
 _memset(i15 | 0, 0, i16 | 0) | 0;
 i13 = i16 >>> 0 > 1;
 if (i13) {
  i4 = HEAP32[i17 + 44 >> 2] | 0;
  i6 = 1;
  i1 = 0;
  while (1) {
   i3 = HEAP32[i17 + (i6 * 48 | 0) + 44 >> 2] | 0;
   f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i5 = f12 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i5 ? i6 : i1;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i16 | 0)) break; else i4 = i5 ? i3 : i4;
  }
 } else i1 = 0;
 i14 = i9 + 44 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i3 = i17 + (i1 * 48 | 0) | 0;
 i4 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i5 = i5 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i5 | 0) < (i4 | 0));
 HEAP8[i15 + i1 >> 0] = 1;
 f2 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i17 + 24 >> 2]);
 i9 = HEAP32[i14 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f2 = Math_fround(f2 - f10);
 f7 = Math_fround(f7 - f11);
 f8 = Math_fround(f8 - f12);
 if (i13) {
  f8 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f7 * f7)) + Math_fround(f8 * f8));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = 1;
  i1 = 0;
  while (1) {
   f7 = Math_fround(HEAPF32[i17 + (i5 * 48 | 0) + 16 >> 2]);
   f8 = Math_fround(HEAPF32[i17 + (i5 * 48 | 0) + 20 >> 2]);
   f7 = Math_fround(f7 - f10);
   f8 = Math_fround(f8 - f11);
   f2 = Math_fround(Math_fround(HEAPF32[i17 + (i5 * 48 | 0) + 24 >> 2]) - f12);
   f2 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f2 * f2));
   i4 = f2 > (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = i4 ? i5 : i1;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i16 | 0)) {
    i6 = i1;
    break;
   } else i3 = i4 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : i3;
  }
 } else i6 = 0;
 i5 = i9 + 48 | 0;
 i3 = i17 + (i6 * 48 | 0) | 0;
 i4 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i5 = i5 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i5 | 0) < (i4 | 0));
 HEAP8[i15 + i6 >> 0] = 1;
 f2 = Math_fround(HEAPF32[i17 + (i6 * 48 | 0) + 44 >> 2]);
 if (!i16) {
  STACKTOP = i18;
  return;
 } else {
  i3 = 0;
  i1 = i6;
 }
 do {
  if (!(HEAP8[i15 + i3 >> 0] | 0)) {
   i13 = HEAP32[i14 >> 2] | 0;
   f19 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f7 = Math_fround(HEAPF32[i13 + 20 >> 2]);
   f8 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f10 = Math_fround(HEAPF32[i17 + (i3 * 48 | 0) + 16 >> 2]);
   f11 = Math_fround(HEAPF32[i17 + (i3 * 48 | 0) + 20 >> 2]);
   f12 = Math_fround(HEAPF32[i17 + (i3 * 48 | 0) + 24 >> 2]);
   f19 = Math_fround(f19 - f10);
   f7 = Math_fround(f7 - f11);
   f8 = Math_fround(f8 - f12);
   f21 = Math_fround(HEAPF32[i13 + 64 >> 2]);
   f20 = Math_fround(HEAPF32[i13 + 68 >> 2]);
   f10 = Math_fround(f21 - f10);
   f11 = Math_fround(f20 - f11);
   f12 = Math_fround(Math_fround(HEAPF32[i13 + 72 >> 2]) - f12);
   if (Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)) > Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11)) + Math_fround(f12 * f12))) {
    i13 = f2 > Math_fround(HEAPF32[i17 + (i3 * 48 | 0) + 44 >> 2]);
    i1 = i13 ? i3 : i1;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i16 | 0));
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = (HEAP32[i14 >> 2] | 0) + 48 | 0;
 i3 = i17 + (i1 * 48 | 0) | 0;
 i4 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i5 = i5 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i5 | 0) < (i4 | 0));
 STACKTOP = i18;
 return;
}

function __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 32 | 0;
 i13 = i15 + 16 | 0;
 i4 = i15;
 __ZN11TypeManager27FatalErrorOnClassIDConflictEiPKc(i11, HEAP32[i10 + 16 >> 2] | 0, HEAP32[i10 + 8 >> 2] | 0);
 i14 = HEAP32[i10 + 40 >> 2] | 0;
 i1 = i14;
 i2 = i10;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i2 = i11 + 120 | 0;
 i9 = i14 + 16 | 0;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i12, i2, i9);
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 if ((i1 | 0) == ((HEAP32[i11 + 148 >> 2] | 0) + (HEAP32[i11 + 152 >> 2] << 3) | 0)) {
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i13 + 4 >> 2] = 0;
  __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i2, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_(i4, i2, i13);
  i1 = HEAP32[i4 + 4 >> 2] | 0;
 }
 HEAP32[i1 + 4 >> 2] = i14;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i8 >>> 0 < i7 >>> 0 ? i7 : i8;
 i8 = i10 + 44 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = i7;
 if (!i7) if (!(HEAP32[i10 + 48 >> 2] | 0)) {
  if (HEAP32[i10 + 52 >> 2] | 0) i5 = 6;
 } else i5 = 6; else i5 = 6;
 if ((i5 | 0) == 6) {
  i5 = i11 + 48 | 0;
  i7 = i11 + 52 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i6 = (i4 - i2 | 0) / 12 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  do if ((i6 | 0) <= (i3 | 0)) {
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 > i6 >>> 0) {
    __ZNSt3__26vectorIN11TypeManager18TypeCallbackStructE13stl_allocatorIS2_L18MemLabelIdentifier6ELi16EEE8__appendEj(i5, i3 - i6 | 0);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    break;
   }
   if (i3 >>> 0 < i6 >>> 0) {
    i3 = i2 + (i3 * 12 | 0) | 0;
    if ((i4 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = i4 + (~(((i4 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
   }
  } while (0);
  i9 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + (i9 * 12 | 0) >> 2] = i1;
  HEAP32[i2 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i10 + 48 >> 2];
  HEAP32[i2 + (i9 * 12 | 0) + 8 >> 2] = HEAP32[i10 + 52 >> 2];
 }
 if (HEAP8[i14 + 36 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 i4 = i14 + 8 | 0;
 i5 = i11 + 64 | 0;
 if ((HEAP32[i11 + 100 >> 2] | 0) == (HEAP32[i11 + 68 >> 2] | 0)) {
  i2 = HEAP32[i11 + 92 >> 2] | 0;
  i3 = HEAP32[i11 + 96 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_(i12, i5, i4);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 + 92 >> 2] | 0;
  i3 = HEAP32[i11 + 96 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = 0;
  __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj(i5, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_(i13, i5, i12);
  i1 = HEAP32[i13 + 4 >> 2] | 0;
 }
 HEAP32[i1 + 4 >> 2] = i14;
 STACKTOP = i15;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEbT0_SB_T_(i7, i10, i8) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 switch ((i10 - i7 | 0) / 20 | 0 | 0) {
 case 2:
  {
   i1 = i10 + -20 | 0;
   if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i8, i1, i7) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   };
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i8 = i7 + 16 | 0;
   i10 = i10 + -4 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i9;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i7, i7 + 20 | 0, i10 + -20 | 0, i8) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_(i7, i7 + 20 | 0, i7 + 40 | 0, i10 + -20 | 0, i8) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_(i7, i7 + 20 | 0, i7 + 40 | 0, i7 + 60 | 0, i10 + -20 | 0, i8) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i3 = i7 + 40 | 0;
   __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i7, i7 + 20 | 0, i3, i8) | 0;
   i1 = i7 + 60 | 0;
   L3 : do if ((i1 | 0) == (i10 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i9 + 16 | 0;
    i2 = 0;
    while (1) {
     if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i8, i1, i3) | 0) {
      HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
       HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
       HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
       i5 = i3 + 16 | 0;
       HEAP32[i4 + 16 >> 2] = HEAP32[i5 >> 2];
       if ((i3 | 0) == (i7 | 0)) break;
       i4 = i3 + -20 | 0;
       if (__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i8, i9, i4) | 0) {
        i5 = i3;
        i3 = i4;
        i4 = i5;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
      HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 20 | 0) == (i10 | 0);
       break L3;
      }
     }
     i3 = i1 + 20 | 0;
     if ((i3 | 0) == (i10 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i5 = i1;
      i1 = i3;
      i3 = i5;
     }
    }
   } while (0);
   i10 = i1 | i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3712;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3713;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3710;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3711;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3708;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i15, i16, i10, i1, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 20 | 0;
 i19 = i21 + 8 | 0;
 i20 = i21;
 i8 = i17 - i1 | 0;
 i11 = i8 + 499 | 0;
 i12 = (i11 | 0) / 500 | 0;
 i13 = ((i8 + -1 + i12 | 0) / (i12 | 0) | 0) + 3 | 0;
 i13 = i13 - ((i13 | 0) % 4 | 0) | 0;
 HEAP32[i18 >> 2] = 0;
 i14 = i18 + 4 | 0;
 i7 = gb + 63160 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 i8 = (i8 + 998 - ((i11 | 0) % 500 | 0) | 0) >>> 0 > 998;
 do if (i8) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i7;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 418) | 0;
   i6 = gb + 64016 | 0;
   i9 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i6;
   i2 = gb + 63160 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i7;
 } while (0);
 i7 = i1 + 3 & -4;
 HEAP32[i19 >> 2] = 0;
 i9 = i19 + 4 | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i12 * 28 | 0;
 do if (i8) {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 421) | 0;
   i6 = gb + 64016 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i19 >> 2] = i1;
   i8 = i9;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  }
 } else i1 = 0; while (0);
 i2 = i1 + 3 & -4;
 i8 = HEAP32[i10 + 272 >> 2] | 0;
 i1 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 i10 = (Math_imul(i6, 1812433253) | 0) + 1 | 0;
 i8 = i8 << 11 ^ i8;
 i8 = i8 >>> 8 ^ i8 ^ i10;
 i10 = i8 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i1 = i1 << 11 ^ i1;
 i10 = i1 >>> 8 ^ i1 ^ i10;
 i8 = i10 ^ i8 >>> 19;
 f4 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 i6 = i6 << 11 ^ i6;
 f5 = Math_fround(Math_fround(((i6 >>> 8 ^ i6 ^ i8) & 8388607 ^ i10 >>> 19) >>> 0) * Math_fround(1.19209304e-07));
 if ((i11 | 0) > 499) {
  i1 = 0;
  do {
   HEAP32[i7 + (i1 << 3) >> 2] = fb + 3709;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = i2 + (i1 * 28 | 0);
   HEAP32[i2 + (i1 * 28 | 0) >> 2] = i15;
   HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] = i16;
   i11 = Math_imul(i1, i13) | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 8 >> 2] = i11;
   i11 = i11 + i13 | 0;
   HEAP32[i2 + (i1 * 28 | 0) + 12 >> 2] = i11 >>> 0 > i17 >>> 0 ? i17 : i11;
   HEAPF32[i2 + (i1 * 28 | 0) + 16 >> 2] = f3;
   HEAPF32[i2 + (i1 * 28 | 0) + 20 >> 2] = f4;
   HEAPF32[i2 + (i1 * 28 | 0) + 24 >> 2] = f5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i12 | 0));
 }
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i20, i7, i12, 0);
 if (!(HEAP32[i20 >> 2] | 0)) {
  i20 = HEAP32[i19 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
  i20 = HEAP32[i18 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
  STACKTOP = i21;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i20);
 i20 = HEAP32[i19 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i9);
 i20 = HEAP32[i18 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i20, i14);
 STACKTOP = i21;
 return;
}

function _PxInitVehicleSDK(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5physx6shdfnd10Foundation11incRefCountEv();
 __ZN5physx24setVehicleToleranceScaleERKNS_17PxTolerancesScaleE(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0);
 __ZN5physx27setSerializationRegistryPtrEPKNS_23PxSerializationRegistryE(i2);
 if (!i2) return 1;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 830816 | 0, 52) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 166e3 + 8;
 mftCall_viii(i1 | 0, i2 | 0, 513, i3 | 0);
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 830799 | 0, gb + 830816 | 0, 53) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i1 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 166040 + 8;
 mftCall_viii(i3 | 0, i2 | 0, 515, i1 | 0);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830799 | 0, gb + 830816 | 0, 54) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 >> 2] = gb + 166080 + 8;
 mftCall_viii(i1 | 0, i2 | 0, 514, i3 | 0);
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 830799 | 0, gb + 830816 | 0, 55) | 0;
 i4 = _PxGetFoundation() | 0;
 HEAP32[i1 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 166120 + 8;
 mftCall_viii(i3 | 0, i2 | 0, 512, i1 | 0);
 i1 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 830816 | 0, 57) | 0;
 HEAP32[i3 >> 2] = gb + 166160 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 835156;
 mftCall_viii(i1 | 0, i2 | 0, 513, i3 | 0);
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 830897 | 0, gb + 830816 | 0, 58) | 0;
 HEAP32[i1 >> 2] = gb + 166208 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 834990;
 mftCall_viii(i3 | 0, i2 | 0, 515, i1 | 0);
 i1 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 8, gb + 830897 | 0, gb + 830816 | 0, 59) | 0;
 HEAP32[i3 >> 2] = gb + 166256 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 833702;
 mftCall_viii(i1 | 0, i2 | 0, 512, i3 | 0);
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 8, gb + 830897 | 0, gb + 830816 | 0, 60) | 0;
 HEAP32[i1 >> 2] = gb + 166304 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 834943;
 mftCall_viii(i3 | 0, i2 | 0, 514, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3762 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3763 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3764 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3765 | 0);
 return 1;
}

function __ZN8GUILayer7HitTestERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 48 | 0;
 i18 = i22 + 40 | 0;
 i14 = i22 + 28 | 0;
 i19 = i22;
 i20 = i22 + 16 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 29832 | 0) | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 f3 = Math_fround(__ZNK6Camera7GetNearEv(i1));
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAPF32[i17 + 8 >> 2] = f3;
 __ZNK6Camera21ScreenToViewportPointERK8Vector3f(i14, i1, i17);
 f3 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 if (!(f4 < Math_fround(1.0) & ((!(f3 < Math_fround(1.0)) | !(f3 >= Math_fround(0.0)) | !(f4 >= Math_fround(0.0))) ^ 1))) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 __ZNK6Camera13GetCameraRectEb(i19, i1, 1);
 i9 = __Z16GetScreenManagerv() | 0;
 f16 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 80 >> 2] | 0, i9 | 0) | 0);
 f16 = Math_fround(f3 * f16);
 f15 = Math_fround(f4 * Math_fround(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i9 | 0) | 0));
 i9 = HEAP32[i1 + 880 >> 2] & -5;
 i10 = HEAP32[gb + 1114500 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i10 = i10 + 4 | 0;
 if ((i2 | 0) == (i10 | 0)) i1 = 0; else {
  i11 = i17 + 8 | 0;
  i12 = i17 + 4 | 0;
  i13 = i17 + 12 | 0;
  i14 = i20 + 8 | 0;
  i1 = 0;
  f4 = Math_fround(-inf);
  while (1) {
   i8 = i2 + 16 | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   do if (!i5) f3 = f4; else {
    HEAP32[i18 >> 2] = i5;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i5) i21 = 11; else {
     if ((HEAP32[i5 + 36 >> 2] | 0) == (HEAP32[i5 + 4 >> 2] | 0)) {
      i6 = HEAP32[i5 + 28 >> 2] | 0;
      i7 = HEAP32[i5 + 32 >> 2] | 0;
      i5 = i6 + (i7 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i17, i5, i18);
      i6 = HEAP32[i17 >> 2] | 0;
      i23 = HEAP32[i5 + 28 >> 2] | 0;
      i7 = HEAP32[gb + 1104264 >> 2] | 0;
      i5 = (i6 | 0) == -1 ? i23 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i23 + (i6 << 3) | 0;
      i6 = HEAP32[i7 + 28 >> 2] | 0;
      i7 = HEAP32[i7 + 32 >> 2] | 0;
     }
     if ((i5 | 0) == (i6 + (i7 << 3) | 0)) i21 = 11; else {
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if (!i5) i21 = 13;
     }
    }
    if ((i21 | 0) == 11) i21 = 13;
    if ((i21 | 0) == 13) {
     i21 = 0;
     i5 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
     if (!i5) {
      f3 = f4;
      break;
     }
    }
    i6 = i5 + 28 | 0;
    if (!(i9 & 1 << HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2])) f3 = f4; else {
     mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i17 | 0, i5 | 0, i19 | 0);
     f3 = Math_fround(HEAPF32[i17 >> 2]);
     if (f3 <= f16) if (Math_fround(f3 + Math_fround(HEAPF32[i11 >> 2])) > f16) {
      f3 = Math_fround(HEAPF32[i12 >> 2]);
      if (f3 <= f15) {
       if (!(Math_fround(f3 + Math_fround(HEAPF32[i13 >> 2])) > f15)) {
        f3 = f4;
        break;
       }
       __ZNK9Transform16GetLocalPositionEv(i20, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
       f3 = Math_fround(HEAPF32[i14 >> 2]);
       i23 = f3 > f4;
       i1 = i23 ? i5 : i1;
       f3 = i23 ? f3 : f4;
       break;
      }
     }
     f3 = f4;
    }
   } while (0);
   i5 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i5) while (1) {
    i5 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i2 | 0)) {
     i2 = i5;
     break;
    } else i2 = i5;
   } else {
    i2 = i5;
    while (1) {
     i5 = HEAP32[i2 >> 2] | 0;
     if (!i5) break; else i2 = i5;
    }
   }
   if ((i2 | 0) == (i10 | 0)) break; else f4 = f3;
  }
 }
 i23 = i1;
 STACKTOP = i22;
 return i23 | 0;
}

function __ZN8DrawUtil36DrawLineOrTrailMultipleFromNodeQueueERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i6, i7, i15) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, i20 = 0, i21 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18 + 16 | 0;
 i16 = i18;
 i17 = i7 + 4 | 0;
 if (!(HEAP32[i17 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 if ((HEAP16[gb + 1157784 + 6 >> 1] | 0) > -1) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157784 | 0, i8);
  i9 = gb + 1157784 | 0;
 } else i9 = 0;
 d19 = +_emscripten_get_now() * 1.0e6;
 i10 = ~~d19 >>> 0;
 i11 = +Math_abs(d19) >= 1.0 ? (d19 > 0.0 ? ~~+Math_min(+Math_floor(d19 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d19 - +(~~d19 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i12 = __Z12GetGfxDevicev() | 0;
 i13 = __ZN9GfxDevice13GetDynamicVBOEv(i12) | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 104 >> 2] | 0, i12 | 0, gb + 1162292 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 i14 = i8 + 4 | 0;
 i5 = gb + 63160 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i14;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = HEAP32[i17 >> 2] | 0;
 i1 = i3 * 20 | 0;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i1;
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 400980 | 0, 294) | 0;
   i3 = gb + 64016 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i14;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1;
   i3 = HEAP32[i17 >> 2] | 0;
   break;
  }
 } while (0);
 i5 = i2 + 3 & -4;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = -1;
 HEAP32[i16 + 12 >> 2] = 0;
 if (!i3) i2 = 0; else {
  i1 = 0;
  i2 = 0;
  do {
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 3) >> 2] | 0;
   i20 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i20 + (i4 * 360 | 0) + 328 >> 2] | 0;
   i4 = HEAP32[i20 + (i4 * 360 | 0) + 188 >> 2] | 0;
   if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 188 >> 2] | 0, i12 | 0, i4 | 0);
   if (!i1) {
    HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   }
   i21 = HEAP32[i3 + 16 >> 2] | 0;
   i20 = i3 + 152 | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   HEAP32[i5 + (i1 * 20 | 0) >> 2] = 24;
   HEAP32[i5 + (i1 * 20 | 0) + 4 >> 2] = i21;
   HEAP32[i5 + (i1 * 20 | 0) + 8 >> 2] = i4;
   HEAP32[i5 + (i1 * 20 | 0) + 12 >> 2] = 0;
   HEAP32[i5 + (i1 * 20 | 0) + 16 >> 2] = 0;
   i2 = (HEAP32[i20 >> 2] | 0) + i2 | 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i17 >> 2] | 0) >>> 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0;
 i21 = HEAP32[gb + 1157820 + 4 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i21 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i21, HEAP32[i15 >> 2] | 0, 0) | 0;
 mftCall_viiiiiii(i8 | 0, i13 | 0, i16 | 0, i15 | 0, i20 | 0, i21 | 0, i5 | 0, HEAP32[i17 >> 2] | 0);
 __Z15gpu_time_samplev();
 d19 = +_emscripten_get_now() * 1.0e6;
 i21 = +Math_abs(d19) >= 1.0 ? (d19 > 0.0 ? ~~+Math_min(+Math_floor(d19 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d19 - +(~~d19 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i16 = HEAP32[(HEAP32[i12 >> 2] | 0) + 268 >> 2] | 0;
 i20 = HEAP32[i17 >> 2] | 0;
 i21 = _i64Subtract(~~d19 >>> 0 | 0, i21 | 0, i10 | 0, i11 | 0) | 0;
 mftCall_viiiiiii(i16 | 0, i12 | 0, 1, 0, i2 | 0, i20 | 0, i21 | 0, getTempRet0() | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 if (!i9) {
  STACKTOP = i18;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i18;
 return;
}

function __ZN12CubemapArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 i12 = i14;
 __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i11);
 i13 = i10 + 80 | 0;
 i6 = i11 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i11 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i13 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i7 = i10 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i10 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i10 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i5 = i10 + 96 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10 + 32 | 0, i11);
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 }
 HEAP32[i10 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i3 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i6 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i10 + 105 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i11, i12, gb + 411165 | 0, 1);
 i3 = i10 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i10 + 100 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i10 + 104 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 + 48 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  mftCall_vii(i2 | 0, i6 | 0, i8 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) i1 = 0; else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = (i2 >>> 0) / ((i1 * 6 | 0) >>> 0) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
 HEAP32[i3 >> 2] = i9;
 f15 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i13 >> 2] | 0));
 HEAPF32[i10 + 68 >> 2] = f15;
 HEAPF32[i10 + 72 >> 2] = f15;
 __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i11, HEAP32[i12 >> 2] | 0, i9, 0);
 STACKTOP = i14;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEbT0_S5_T_(i18, i19, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 switch ((i19 - i18 | 0) / 44 | 0 | 0) {
 case 2:
  {
   i13 = i19 + -44 | 0;
   if ((HEAP32[i19 + -4 >> 2] | 0) >= (HEAP32[i18 + 40 >> 2] | 0)) {
    i19 = 1;
    return i19 | 0;
   }
   i1 = HEAP32[i18 >> 2] | 0;
   i2 = HEAP32[i18 + 4 >> 2] | 0;
   i3 = HEAP32[i18 + 8 >> 2] | 0;
   i5 = HEAP32[i18 + 12 >> 2] | 0;
   i6 = HEAP32[i18 + 16 >> 2] | 0;
   i7 = HEAP32[i18 + 20 >> 2] | 0;
   i8 = HEAP32[i18 + 24 >> 2] | 0;
   i9 = HEAP32[i18 + 28 >> 2] | 0;
   i10 = HEAP32[i18 + 32 >> 2] | 0;
   i12 = i18 + 36 | 0;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i4 = i18;
   i16 = i13;
   i17 = i4 + 44 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
    i4 = i4 + 4 | 0;
    i16 = i16 + 4 | 0;
   } while ((i4 | 0) < (i17 | 0));
   HEAP32[i13 >> 2] = i1;
   HEAP32[i19 + -40 >> 2] = i2;
   HEAP32[i19 + -36 >> 2] = i3;
   HEAP32[i19 + -32 >> 2] = i5;
   HEAP32[i19 + -28 >> 2] = i6;
   HEAP32[i19 + -24 >> 2] = i7;
   HEAP32[i19 + -20 >> 2] = i8;
   HEAP32[i19 + -16 >> 2] = i9;
   HEAP32[i19 + -12 >> 2] = i10;
   i19 = i19 + -8 | 0;
   HEAP32[i19 >> 2] = i11;
   HEAP32[i19 + 4 >> 2] = i12;
   i19 = 1;
   return i19 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i18, i18 + 44 | 0, i19 + -44 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_(i18, i18 + 44 | 0, i18 + 88 | 0, i19 + -44 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_(i18, i18 + 44 | 0, i18 + 88 | 0, i18 + 132 | 0, i19 + -44 | 0, i1) | 0;
   i19 = 1;
   return i19 | 0;
  }
 case 1:
 case 0:
  {
   i19 = 1;
   return i19 | 0;
  }
 default:
  {
   i3 = i18 + 88 | 0;
   __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i18, i18 + 44 | 0, i3, i1) | 0;
   i1 = i18 + 132 | 0;
   L3 : do if ((i1 | 0) == (i19 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     if ((HEAP32[i1 + 40 >> 2] | 0) < (HEAP32[i3 + 40 >> 2] | 0)) {
      i5 = HEAP32[i1 >> 2] | 0;
      i6 = HEAP32[i1 + 4 >> 2] | 0;
      i7 = HEAP32[i1 + 8 >> 2] | 0;
      i8 = HEAP32[i1 + 12 >> 2] | 0;
      i9 = HEAP32[i1 + 16 >> 2] | 0;
      i10 = HEAP32[i1 + 20 >> 2] | 0;
      i11 = HEAP32[i1 + 24 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i13 = HEAP32[i1 + 32 >> 2] | 0;
      i15 = i1 + 36 | 0;
      i14 = HEAP32[i15 >> 2] | 0;
      i15 = HEAP32[i15 + 4 >> 2] | 0;
      i4 = i1;
      while (1) {
       i16 = i3;
       i17 = i4 + 44 | 0;
       do {
        HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
        i4 = i4 + 4 | 0;
        i16 = i16 + 4 | 0;
       } while ((i4 | 0) < (i17 | 0));
       if ((i3 | 0) == (i18 | 0)) {
        i3 = i18;
        break;
       }
       if ((i15 | 0) < (HEAP32[i3 + -4 >> 2] | 0)) {
        i4 = i3;
        i3 = i3 + -44 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      HEAP32[i3 + 4 >> 2] = i6;
      HEAP32[i3 + 8 >> 2] = i7;
      HEAP32[i3 + 12 >> 2] = i8;
      HEAP32[i3 + 16 >> 2] = i9;
      HEAP32[i3 + 20 >> 2] = i10;
      HEAP32[i3 + 24 >> 2] = i11;
      HEAP32[i3 + 28 >> 2] = i12;
      HEAP32[i3 + 32 >> 2] = i13;
      i17 = i3 + 36 | 0;
      HEAP32[i17 >> 2] = i14;
      HEAP32[i17 + 4 >> 2] = i15;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 44 | 0) == (i19 | 0);
       break L3;
      }
     }
     i3 = i1 + 44 | 0;
     if ((i3 | 0) == (i19 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i17 = i1;
      i1 = i3;
      i3 = i17;
     }
    }
   } while (0);
   i19 = i1 | i2;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZN13AnimationClip10FloatCurveaSERKS0_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = (i9 | 0) == (i10 | 0);
 do if (!i8) {
  i5 = HEAP8[i10 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i10 >> 2] | 0 : i10;
  i5 = i3 ? HEAP32[i10 + 4 >> 2] | 0 : i5 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
  } else {
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i9 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i3 >> 0] = i5;
    break;
   }
  } while (0);
  i1 = i9 + 16 | 0;
  i6 = i10 + 16 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i10 + 20 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 20 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i6 = i10 + 32 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i9 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 i5 = i9 + 40 | 0;
 i7 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i5 = i9 + 68 | 0;
 i7 = i10 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i5 = i9 + 96 | 0;
 if (i8) {
  i8 = i9 + 116 | 0;
  i7 = i10 + 116 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i8 = i10 + 128 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i9 + 128 | 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 }
 i6 = HEAP32[i10 + 96 >> 2] | 0;
 i7 = i9 + 108 | 0;
 i1 = HEAP32[i10 + 108 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 112 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 100 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 100 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i8 = i9 + 116 | 0;
 i7 = i10 + 116 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i8 = i10 + 128 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i10 = i9 + 128 | 0;
 HEAP32[i10 >> 2] = i8;
 return i9 | 0;
}

function __Z21FilterCubeMapMipChainP13CImageSurfaceS0_iRK17CubemapgenOptionsf(i20, i21, i24, i25, f5) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, f32 = f0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, f37 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i31 + 56 | 0;
 i26 = i31 + 40 | 0;
 i27 = i31 + 20 | 0;
 i28 = i31;
 if ((HEAP16[gb + 1157736 + 6 >> 1] | 0) > -1) {
  HEAP32[i26 >> 2] = 0;
  HEAP32[i19 >> 2] = HEAP32[i26 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157736 | 0, i19);
  i29 = gb + 1157736 | 0;
 } else i29 = 0;
 i22 = i19 + 100 | 0;
 HEAP32[i22 >> 2] = 4096;
 i1 = __Znaj(16384) | 0;
 i23 = i19 + 96 | 0;
 HEAP32[i23 >> 2] = i1;
 i2 = (i24 | 0) > 0;
 i3 = i19;
 i4 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 if (i2) {
  i4 = i25 + 100 | 0;
  i8 = i25 + 104 | 0;
  i9 = i26 + 4 | 0;
  f10 = Math_fround(Math_fround(1.0) / Math_fround(i24 | 0));
  i11 = i26 + 8 | 0;
  i12 = i26 + 12 | 0;
  i13 = i25 + 84 | 0;
  i14 = i25 + 76 | 0;
  i15 = i25 + 96 | 0;
  i16 = i25 + 88 | 0;
  i17 = i25 + 92 | 0;
  i18 = i25 + 80 | 0;
  f7 = Math_fround(Math_fround(1.0) / f5);
  i3 = 0;
  do {
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i26 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i2;
   f5 = Math_fround(f10 * Math_fround(i3 | 0));
   HEAPF32[i11 >> 2] = f5;
   HEAPF32[i12 >> 2] = Math_fround(f10 + f5);
   f5 = Math_fround(HEAPF32[i25 + 4 + (i3 << 2) >> 2]);
   i2 = HEAP32[i25 >> 2] | 0;
   if ((i2 | 0) == 4) {
    i1 = f5 < Math_fround(4096.0);
    f6 = Math_fround(180.0);
    f5 = i1 ? f5 : Math_fround(4096.0);
   } else {
    f32 = Math_fround(+Math_pow(+Math_fround(f5 / Math_fround(180.0)), +f7));
    f32 = Math_fround(f32 * f32);
    f6 = f5;
    f5 = Math_fround(Math_fround(Math_fround(2.0) / Math_fround(f32 * f32)) + Math_fround(-2.0));
   }
   i1 = (i3 | 0) < (HEAP32[i13 >> 2] | 0) ? 0 : HEAP32[i14 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i33 = i3 * 6 | 0;
    i34 = i20 + (i33 + -6 << 4) | 0;
    i33 = i21 + (i33 << 4) | 0;
    i35 = HEAP32[i34 >> 2] | 0;
    f37 = Math_fround(Math_fround(+Math_atan2(1.0, +Math_fround(i35 | 0))) * Math_fround(57.2957763));
    f32 = Math_fround(f6 * Math_fround(.5));
    f32 = f32 < f37 ? f37 : f32;
    i36 = f32 > Math_fround(90.0);
    f32 = i36 ? Math_fround(90.0) : f32;
    __Z19BuildAngleWeightLUTPfiiff(HEAP32[i23 >> 2] | 0, HEAP32[i22 >> 2] | 0, i2, f32, f5);
    __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei(i35, i19, i1);
    __Z18FilterCubeSurfacesP13CImageSurfaceS0_fibfiiifR17PrecomputeContextR15ProgressContext(i34, i33, f6, HEAP32[i25 >> 2] | 0, (HEAP8[i15 >> 0] | 0) != 0, f5, 0, i1, HEAP32[i16 >> 2] | 0, Math_fround(HEAPF32[i17 >> 2]), i19, i26);
    __Z14FixupCubeEdgesP13CImageSurfaceii(i33, i1, HEAP32[i18 >> 2] | 0);
   } else {
    i1 = 0;
    do {
     i36 = HEAP32[i20 + (i1 << 4) >> 2] | 0;
     i35 = HEAP32[i20 + (i1 << 4) + 4 >> 2] | 0;
     i34 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i36, 6) | 0;
     __ZN14ImageReferenceC2Eiii13TextureFormatPv(i27, i36, i35, i34, 6, HEAP32[i20 + (i1 << 4) + 12 >> 2] | 0);
     i34 = HEAP32[i21 + (i1 << 4) >> 2] | 0;
     i35 = HEAP32[i21 + (i1 << 4) + 4 >> 2] | 0;
     i36 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i34, 6) | 0;
     __ZN14ImageReferenceC2Eiii13TextureFormatPv(i28, i34, i35, i36, 6, HEAP32[i21 + (i1 << 4) + 12 >> 2] | 0);
     __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i28, i27, 2);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 6);
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i24 | 0));
  i1 = HEAP32[i23 >> 2] | 0;
  if (i1 | 0) i30 = 6;
 } else i30 = 6;
 if ((i30 | 0) == 6) __ZdaPv(i1);
 if (!i29) {
  STACKTOP = i31;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i29);
 STACKTOP = i31;
 return;
}

function __ZNK5physx25PxFixedJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 i5 = i6 + 236 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj451ENS_22PxRepXPropertyAccessorILj451ES4_ffEEEEvRKT0_(i9, i8);
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else {
  if (HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i3 + 8 >> 2] = i1 + -1;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 + 8 >> 2] | 0;
 }
 i5 = i6 + 252 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i1 = i2 + -1 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj452ENS_22PxRepXPropertyAccessorILj452ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 3 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 3 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx20SingleAABBUpdateTask11runInternalEv(i28) {
 i28 = i28 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 16464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 8264 | 0;
 i26 = i29 + 72 | 0;
 i25 = i29 + 64 | 0;
 i22 = i29 + 56 | 0;
 i17 = i29 + 48 | 0;
 i24 = i29 + 40 | 0;
 i21 = i29 + 32 | 0;
 i18 = i29 + 24 | 0;
 i19 = i29 + 16 | 0;
 i23 = i29 + 8 | 0;
 i20 = i29;
 i1 = i25;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i22;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i17;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i24;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i21;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i18;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i19;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i23;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i20;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i28 + 44 >> 2] | 0;
 if (!(i1 & 1)) i2 = 0; else {
  i2 = HEAP32[i28 + 20 >> 2] | 0;
  HEAP32[i25 >> 2] = HEAP32[i2 + 16900 >> 2];
  HEAP32[i22 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i24 >> 2] = HEAP32[i2 + 44 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i2 + 56 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i2 + 36 >> 2];
  HEAP32[i23 >> 2] = HEAP32[i28 + 48 >> 2];
  HEAP32[i20 >> 2] = HEAP32[i28 + 52 >> 2];
  i2 = 1;
 }
 if (!(i1 & 2)) if (!i2) {
  i27 = 0;
  i28 = i28 + 64 | 0;
  i26 = HEAP32[i28 >> 2] | 0;
  i27 = i26 + i27 | 0;
  HEAP32[i28 >> 2] = i27;
  STACKTOP = i29;
  return;
 } else i16 = 1; else {
  i16 = HEAP32[i28 + 20 >> 2] | 0;
  HEAP32[i25 + (i2 << 2) >> 2] = HEAP32[i16 + 33316 >> 2];
  HEAP32[i22 + (i2 << 2) >> 2] = HEAP32[i16 + 308 >> 2];
  HEAP32[i17 + (i2 << 2) >> 2] = HEAP32[i16 + 320 >> 2];
  HEAP32[i24 + (i2 << 2) >> 2] = HEAP32[i16 + 332 >> 2];
  HEAP32[i21 + (i2 << 2) >> 2] = HEAP32[i16 + 344 >> 2];
  HEAP32[i18 + (i2 << 2) >> 2] = HEAP32[i16 + 300 >> 2];
  HEAP32[i19 + (i2 << 2) >> 2] = HEAP32[i16 + 324 >> 2];
  HEAP32[i23 + (i2 << 2) >> 2] = HEAP32[i28 + 56 >> 2];
  HEAP32[i20 + (i2 << 2) >> 2] = HEAP32[i28 + 60 >> 2];
  i16 = i2 + 1 | 0;
 }
 i14 = i28 + 36 | 0;
 i15 = 0;
 i1 = 0;
 do {
  i7 = HEAP32[i25 + (i15 << 2) >> 2] | 0;
  i8 = HEAP32[i22 + (i15 << 2) >> 2] | 0;
  i13 = HEAP32[i17 + (i15 << 2) >> 2] | 0;
  i9 = HEAP32[i24 + (i15 << 2) >> 2] | 0;
  i10 = HEAP32[i21 + (i15 << 2) >> 2] | 0;
  i11 = HEAP32[i18 + (i15 << 2) >> 2] | 0;
  i12 = HEAP32[i19 + (i15 << 2) >> 2] | 0;
  i2 = HEAP32[i23 + (i15 << 2) >> 2] | 0;
  i6 = (HEAP32[i20 + (i15 << 2) >> 2] | 0) + i2 | 0;
  if (i2 >>> 0 < i6 >>> 0) {
   i5 = i2;
   i3 = 0;
   i2 = 0;
   do {
    i4 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
    if (!(HEAP32[i8 + (i4 << 2) >> 2] | 0)) {
     HEAP32[i27 + (i2 << 2) >> 2] = i4;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == 2048) {
      __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_17PxcAABBDataStaticEPNS_11IntegerAABBEj(i27, 2048, i13, i9, i11, i12);
      i2 = 0;
     }
    } else {
     HEAP32[i26 + (i3 << 2) >> 2] = i4;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == 2048) {
      i1 = (__ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_18PxcAABBDataDynamicEbPNS_11IntegerAABBEj(i26, 2048, i13, i10, (HEAP8[i14 >> 0] | 0) != 0, i11, i12) | 0) + i1 | 0;
      i3 = 0;
     }
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
   if (i2 | 0) __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_17PxcAABBDataStaticEPNS_11IntegerAABBEj(i27, i2, i13, i9, i11, i12);
   if (i3) i1 = (__ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_18PxcAABBDataDynamicEbPNS_11IntegerAABBEj(i26, i3, i13, i10, (HEAP8[i14 >> 0] | 0) != 0, i11, i12) | 0) + i1 | 0;
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) != (i16 | 0));
 i28 = i28 + 64 | 0;
 i27 = HEAP32[i28 >> 2] | 0;
 i27 = i27 + i1 | 0;
 HEAP32[i28 >> 2] = i27;
 STACKTOP = i29;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 872 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 872 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 872 | 0;
  i3 = (i2 | 0) / 872 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 4925421) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 872 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i1);
     i1 = i1 + 872 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 872 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -872 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN9ShaderLab14SerializedPassD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 872 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 872 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 872 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 872 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 872 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -872 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN9ShaderLab14SerializedPassD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -872 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN9ShaderLab14SerializedPassD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function _start_input_pass_28(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i6 + 292 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == 1) {
  i1 = HEAP32[i6 + 296 >> 2] | 0;
  HEAP32[i6 + 312 >> 2] = HEAP32[i1 + 28 >> 2];
  i5 = HEAP32[i1 + 32 >> 2] | 0;
  HEAP32[i6 + 316 >> 2] = i5;
  HEAP32[i1 + 52 >> 2] = 1;
  HEAP32[i1 + 56 >> 2] = 1;
  HEAP32[i1 + 60 >> 2] = 1;
  HEAP32[i1 + 64 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i1 + 68 >> 2] = 1;
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  i5 = (i5 >>> 0) % (i4 >>> 0) | 0;
  HEAP32[i1 + 72 >> 2] = (i5 | 0) == 0 ? i4 : i5;
  HEAP32[i6 + 320 >> 2] = 1;
  HEAP32[i6 + 324 >> 2] = 0;
  i1 = 1;
 } else {
  if ((i1 + -1 | 0) >>> 0 > 3) {
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i5 + 20 >> 2] = 26;
   HEAP32[i5 + 24 >> 2] = i1;
   HEAP32[i5 + 28 >> 2] = 4;
   mftCall_vi(HEAP32[i5 >> 2] | 0, i6 | 0);
  }
  HEAP32[i6 + 312 >> 2] = _jdiv_round_up(HEAP32[i6 + 28 >> 2] | 0, HEAP32[i6 + 272 >> 2] << 3) | 0;
  HEAP32[i6 + 316 >> 2] = _jdiv_round_up(HEAP32[i6 + 32 >> 2] | 0, HEAP32[i6 + 276 >> 2] << 3) | 0;
  i4 = i6 + 320 | 0;
  HEAP32[i4 >> 2] = 0;
  if ((HEAP32[i7 >> 2] | 0) <= 0) {
   i7 = i6 + 408 | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   mftCall_vi(i7 | 0, i6 | 0);
   i7 = i6 + 392 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i8 = HEAP32[i8 >> 2] | 0;
   mftCall_vi(i8 | 0, i6 | 0);
   i7 = HEAP32[i7 >> 2] | 0;
   i7 = i7 + 4 | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i8 = i6 + 400 | 0;
   i8 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i7;
   return;
  }
  i2 = 0;
  i3 = 0;
  while (1) {
   i5 = HEAP32[i6 + 296 + (i2 << 2) >> 2] | 0;
   i11 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i5 + 52 >> 2] = i11;
   i10 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i5 + 56 >> 2] = i10;
   i1 = Math_imul(i10, i11) | 0;
   HEAP32[i5 + 60 >> 2] = i1;
   HEAP32[i5 + 64 >> 2] = Math_imul(HEAP32[i5 + 36 >> 2] | 0, i11) | 0;
   i9 = ((HEAP32[i5 + 28 >> 2] | 0) >>> 0) % (i11 >>> 0) | 0;
   HEAP32[i5 + 68 >> 2] = (i9 | 0) == 0 ? i11 : i9;
   i9 = ((HEAP32[i5 + 32 >> 2] | 0) >>> 0) % (i10 >>> 0) | 0;
   HEAP32[i5 + 72 >> 2] = (i9 | 0) == 0 ? i10 : i9;
   if ((i1 + i3 | 0) > 10) {
    i11 = HEAP32[i6 >> 2] | 0;
    HEAP32[i11 + 20 >> 2] = 13;
    mftCall_vi(HEAP32[i11 >> 2] | 0, i6 | 0);
   }
   if ((i1 | 0) > 0) while (1) {
    i11 = HEAP32[i4 >> 2] | 0;
    HEAP32[i4 >> 2] = i11 + 1;
    HEAP32[i6 + 324 + (i11 << 2) >> 2] = i2;
    if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
   }
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i2 | 0) >= (i1 | 0)) break;
   i3 = HEAP32[i4 >> 2] | 0;
  }
  if ((i1 | 0) <= 0) {
   i10 = i6 + 408 | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   mftCall_vi(i10 | 0, i6 | 0);
   i10 = i6 + 392 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   mftCall_vi(i11 | 0, i6 | 0);
   i10 = HEAP32[i10 >> 2] | 0;
   i10 = i10 + 4 | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   i11 = i6 + 400 | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i10;
   return;
  }
 }
 i5 = i6 + 4 | 0;
 i4 = 0;
 do {
  i2 = HEAP32[i6 + 296 + (i4 << 2) >> 2] | 0;
  i3 = i2 + 76 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   i1 = i6 + 144 + (i2 << 2) | 0;
   if (i2 >>> 0 > 3) i8 = 18; else if (!(HEAP32[i1 >> 2] | 0)) i8 = 18;
   if ((i8 | 0) == 18) {
    i8 = 0;
    i11 = HEAP32[i6 >> 2] | 0;
    HEAP32[i11 + 20 >> 2] = 52;
    HEAP32[i11 + 24 >> 2] = i2;
    mftCall_vi(HEAP32[i11 >> 2] | 0, i6 | 0);
   }
   i11 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i6 | 0, 1, 130) | 0;
   _memcpy(i11 | 0, HEAP32[i1 >> 2] | 0, 130) | 0;
   HEAP32[i3 >> 2] = i11;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 i10 = i6 + 408 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 mftCall_vi(i10 | 0, i6 | 0);
 i10 = i6 + 392 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vi(i11 | 0, i6 | 0);
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = i6 + 400 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i1, i8, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i12 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i3;
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i10) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i9 = HEAP32[i12 + 20 >> 2] | 0;
    i9 = (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i9;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i9;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i9 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i9 = i12 + 36 | 0;
 L12 : do if (HEAP8[i9 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i12, gb + 830924 | 0);
  if (!(HEAP8[i9 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i12 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i9 >> 0] = i1;
  }
  i7 = HEAP32[i12 >> 2] | 0;
  HEAP8[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP32[i7 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i7 = HEAP32[i12 >> 2] | 0;
  HEAP8[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP32[i7 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i5 = i12 + 20 | 0;
   i6 = i12 + 40 | 0;
   i7 = i12 + 24 | 0;
   i3 = i8 + 12 | 0;
   i1 = 0;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    if (!i2) i13 = 17; else if (!(HEAP8[i2 >> 0] | 0)) i13 = 17; else {
     HEAP32[i10 >> 2] = i2;
     i1 = _strtoul(i2, i10, 10) | 0;
    }
    if ((i13 | 0) == 17) {
     i13 = 0;
     HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
    }
    mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0);
    if (!(HEAP8[i9 >> 0] | 0)) break L12;
    i8 = HEAP32[i5 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0) i4 = i4 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i12 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i13 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i9 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i9 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i13 | 0) == 24) HEAP8[i9 >> 0] = 1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i14;
 return;
}

function __ZNK5physx32PxClothTetherConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj395ENS_22PxRepXPropertyAccessorILj395ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj396ENS_22PxRepXPropertyAccessorILj396ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx2Gu26intersectHeightFieldSphereERKNS0_15HeightFieldUtilERKNS0_6SphereE(i19, i21) {
 i19 = i19 | 0;
 i21 = i21 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 12 | 0;
 i17 = i23;
 i8 = HEAP32[i19 + 12 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i21 >> 2]);
 i18 = i21 + 8 | 0;
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 f5 = Math_fround(f4 * f6);
 i1 = i19 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f7 * f2);
 do if (f5 >= Math_fround(0.0) & f3 >= Math_fround(0.0)) if (f5 < Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) + Math_fround(1.0))) if (f3 < Math_fround(Math_fround(HEAPF32[i8 + 28 >> 2]) + Math_fround(1.0))) {
  f2 = Math_fround(HEAPF32[(HEAP32[i19 + 16 >> 2] | 0) + 8 >> 2]);
  f2 = Math_fround(f2 * Math_fround(__ZNK5physx2Gu11HeightField17getHeightInternalEff(i8, f5, f3)));
  f2 = Math_fround(Math_fround(HEAPF32[i21 + 4 >> 2]) - f2);
  f3 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  if (!(f3 <= f2) | (!(f2 <= Math_fround(0.0)) | !(f3 <= Math_fround(0.0)))) if (!(f3 > f2 & (f2 > Math_fround(-0.0) & f3 > Math_fround(0.0)))) {
   f4 = Math_fround(HEAPF32[i21 >> 2]);
   f6 = Math_fround(HEAPF32[i19 >> 2]);
   f3 = Math_fround(HEAPF32[i18 >> 2]);
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   break;
  }
  f7 = Math_fround(HEAPF32[i21 >> 2]);
  i22 = (__ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff(i19, f7, Math_fround(HEAPF32[i18 >> 2])) | 0) != -1;
  STACKTOP = i23;
  return i22 | 0;
 } else f3 = f7; else f3 = f7; else f3 = f7; while (0);
 f7 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f5 = Math_fround(f7 * f7);
 f24 = Math_fround(f4 * f6);
 i16 = i21 + 4 | 0;
 f4 = Math_fround(f3 * f2);
 f6 = Math_fround(f7 * Math_fround(Math_abs(Math_fround(f6))));
 f7 = Math_fround(f7 * Math_fround(Math_abs(Math_fround(f2))));
 i1 = ~~Math_fround(Math_floor(Math_fround(f24 - f6)));
 i11 = HEAP32[i8 + 16 >> 2] | 0;
 i15 = i11 + -2 | 0;
 i1 = (i1 | 0) > 0 ? i1 : 0;
 i1 = (i1 | 0) > (i15 | 0) ? i15 : i1;
 i15 = ~~Math_fround(Math_ceil(Math_fround(f24 + f6)));
 i11 = i11 + -1 | 0;
 i15 = (i15 | 0) > 0 ? i15 : 0;
 i15 = (i15 | 0) > (i11 | 0) ? i11 : i15;
 i11 = ~~Math_fround(Math_floor(Math_fround(f4 - f7)));
 i14 = HEAP32[i8 + 20 >> 2] | 0;
 i12 = i14 + -2 | 0;
 i11 = (i11 | 0) > 0 ? i11 : 0;
 i11 = (i11 | 0) > (i12 | 0) ? i12 : i11;
 i12 = ~~Math_fround(Math_ceil(Math_fround(f4 + f7)));
 i14 = i14 + -1 | 0;
 i12 = (i12 | 0) > 0 ? i12 : 0;
 i12 = (i12 | 0) > (i14 | 0) ? i14 : i12;
 if (i1 >>> 0 >= i15 >>> 0) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i13 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 if (i11 >>> 0 >= i12 >>> 0) {
  do i1 = i1 + 1 | 0; while (i1 >>> 0 < i15 >>> 0);
  i1 = 0;
  STACKTOP = i23;
  return i1 | 0;
 }
 L18 : while (1) {
  i9 = i11;
  do {
   HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
   i8 = __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb(i19, i1, i9, i17, i20, 0, 1, 1, 1) | 0;
   if (i8 | 0) {
    f2 = Math_fround(HEAPF32[i21 >> 2]);
    f3 = Math_fround(HEAPF32[i16 >> 2]);
    f4 = Math_fround(HEAPF32[i18 >> 2]);
    i10 = 0;
    do {
     f6 = Math_fround(f2 - Math_fround(HEAPF32[i20 + (i10 * 12 | 0) >> 2]));
     f7 = Math_fround(f3 - Math_fround(HEAPF32[i20 + (i10 * 12 | 0) + 4 >> 2]));
     f24 = Math_fround(f4 - Math_fround(HEAPF32[i20 + (i10 * 12 | 0) + 8 >> 2]));
     i10 = i10 + 1 | 0;
     if (!(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f24 * f24)) > f5)) break L18;
    } while (i10 >>> 0 < i8 >>> 0);
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < i12 >>> 0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i15 >>> 0) {
   i1 = 0;
   i22 = 19;
   break;
  }
 }
 if ((i22 | 0) == 19) {
  STACKTOP = i23;
  return i1 | 0;
 }
 i22 = 1;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 24 | 0, i7 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj117ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 40 | 0, i7 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj118ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 56 | 0, i7 + 4 | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, gb + 672885 | 0);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj120ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 88 | 0, i7 + 6 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj121ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 104 | 0, i7 + 7 | 0);
 i2 = i8 + 120 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEE14handleAccessorILj122ENS_22PxRepXPropertyAccessorILj122ES4_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESC_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  i5 = i8 + 148 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 13 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 36 | 0;
 HEAP8[i3 >> 0] = 1;
 if (!i2) {
  i5 = i8 + 148 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 13 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  i5 = i8 + 148 | 0;
  i8 = i7 + 10 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
  i8 = i7 + 13 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i3 >> 0] = 0;
 i5 = i8 + 148 | 0;
 i8 = i7 + 10 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, i8);
 i8 = i7 + 13 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 >> 2] = i2;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i2 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i7, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE8TransferI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEEEvRT_PKc17TransferMetaFlags(i10, i9 + 20 | 0, gb + 903708 | 0, 0);
 i2 = i9 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 40, 4) | 0;
  i3 = i1;
  i4 = i3 + 40 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim9animation19Blend2dDataConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + i2 | 0, i10);
 i1 = i9 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP8[i2 + 8 >> 0] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 }
 __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim9animation23BlendDirectDataConstantEEEvRT_PKc17TransferMetaFlags(i10, i2 + i1 | 0, gb + 1041891 | 0, 0);
 i1 = i9 + 32 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 44 | 0;
 if ((i2 + 1 | 0) >>> 0 < i3 >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_(i6, i7, i4, i3, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i6, i7, i4, i1) | 0;
 i1 = _strcmp(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i8 = i5;
   STACKTOP = i9;
   return i8 | 0;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i8 = i5;
   STACKTOP = i9;
   return i8 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i8 = i5;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i3 = i5 + 1 | 0;
 i1 = _strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  if (!i1) {
   i8 = i3;
   STACKTOP = i9;
   return i8 | 0;
  }
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i8 = i3;
   STACKTOP = i9;
   return i8 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i8 = i3;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i3 = i5 + 2 | 0;
 i1 = _strcmp(HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  if (!i1) {
   i8 = i3;
   STACKTOP = i9;
   return i8 | 0;
  }
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i8 = i3;
   STACKTOP = i9;
   return i8 | 0;
  }
 } else if ((i1 | 0) >= 0) {
  i8 = i3;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i8 = i5 + 3 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 272 | 0;
 i13 = i11 + 324 | 0;
 i16 = i11 + 220 | 0;
 i22 = i11 + 16 | 0;
 i1 = i11 + 216 | 0;
 i10 = i11 + 200 | 0;
 i9 = i11 + 184 | 0;
 i15 = i11 + 32 | 0;
 i19 = i11;
 HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i3 = i10 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev(i15);
 HEAP32[i22 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i21 = i10;
 i20 = i9;
 i18 = i8;
 i17 = i7;
 i7 = i5;
 i8 = i6;
 i2 = i13;
 HEAP32[i14 >> 2] = i21;
 HEAP32[i14 + 4 >> 2] = i20;
 i6 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i18;
 HEAP32[i14 + 24 >> 2] = i17;
 HEAP32[i14 + 28 >> 2] = i7;
 HEAP32[i14 + 32 >> 2] = i8;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i2;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i15 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i15 + 52 | 0, 4);
 HEAP32[i16 >> 2] = i21;
 HEAP32[i16 + 4 >> 2] = i20;
 i6 = i16 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i16 + 20 >> 2] = i18;
 HEAP32[i16 + 24 >> 2] = i17;
 HEAP32[i16 + 28 >> 2] = i7;
 HEAP32[i16 + 32 >> 2] = i8;
 HEAP8[i16 + 36 >> 0] = 1;
 HEAP32[i16 + 40 >> 2] = i2;
 HEAP32[i16 + 44 >> 2] = 0;
 HEAP32[i16 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 0, i15 + 68 | 0, i14);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 1, i15 + 92 | 0, i14);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 2, i15 + 116 | 0, i14);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i22 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i3 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i22 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i18, i1, i17, i16) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 277 | 0;
 i13 = i15 + 276 | 0;
 i11 = i15 + 224 | 0;
 i14 = i15 + 112 | 0;
 i12 = i15;
 i1 = HEAP32[i18 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i18 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i9 = HEAP32[i18 + 20 >> 2] | 0;
    i9 = (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i9;
    i1 = HEAP32[i18 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i9;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i9 = HEAP32[i18 >> 2] | 0;
   HEAP8[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i18 + 36 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = i18 + 24 | 0;
 mftCall_vii(HEAP32[i17 + 16 >> 2] | 0, i14 | 0, HEAP32[i1 >> 2] | 0);
 i8 = HEAP32[i18 >> 2] | 0;
 i7 = HEAP32[i18 + 4 >> 2] | 0;
 i2 = HEAP32[i18 + 20 >> 2] | 0;
 i4 = HEAP32[i18 + 28 >> 2] | 0;
 i5 = HEAP32[i18 + 32 >> 2] | 0;
 HEAP8[i13 >> 0] = 0;
 i3 = i14;
 i6 = i13;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i7;
 i7 = i11 + 8 | 0;
 i8 = i18 + 8 | 0;
 i9 = i7 + 12 | 0;
 do {
  HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
  i7 = i7 + 1 | 0;
  i8 = i8 + 1 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i11 + 20 >> 2] = i2;
 HEAP32[i11 + 24 >> 2] = i3;
 HEAP32[i11 + 28 >> 2] = i4;
 HEAP32[i11 + 32 >> 2] = i5;
 HEAP8[i11 + 36 >> 0] = 1;
 HEAP32[i11 + 40 >> 2] = i6;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, 2, i16 + 24 | 0, i10);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 52 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 68 | 0, 4);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 84 | 0, 5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 100 | 0, 6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 116 | 0, 7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 132 | 0, 8);
 if (HEAP8[i13 >> 0] | 0) HEAP8[HEAP32[i18 + 40 >> 2] >> 0] = 1;
 i18 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i14 + 64 >> 2] | 0;
 _memcpy(i12 | 0, i14 | 0, i16 << 3 | 0) | 0;
 HEAP32[i12 + 64 >> 2] = i16;
 i16 = i12 + 80 | 0;
 i14 = i14 + 80 | 0;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 mftCall_vii(HEAP32[i17 + 20 >> 2] | 0, i18 | 0, i12 | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i18, i1, i17, i16) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 277 | 0;
 i13 = i15 + 276 | 0;
 i11 = i15 + 224 | 0;
 i14 = i15 + 112 | 0;
 i12 = i15;
 i1 = HEAP32[i18 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i18 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i9 = HEAP32[i18 + 20 >> 2] | 0;
    i9 = (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i9;
    i1 = HEAP32[i18 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i9;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i9 = HEAP32[i18 >> 2] | 0;
   HEAP8[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i18 + 36 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = i18 + 24 | 0;
 mftCall_vii(HEAP32[i17 + 16 >> 2] | 0, i14 | 0, HEAP32[i1 >> 2] | 0);
 i8 = HEAP32[i18 >> 2] | 0;
 i7 = HEAP32[i18 + 4 >> 2] | 0;
 i2 = HEAP32[i18 + 20 >> 2] | 0;
 i4 = HEAP32[i18 + 28 >> 2] | 0;
 i5 = HEAP32[i18 + 32 >> 2] | 0;
 HEAP8[i13 >> 0] = 0;
 i3 = i14;
 i6 = i13;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i7;
 i7 = i11 + 8 | 0;
 i8 = i18 + 8 | 0;
 i9 = i7 + 12 | 0;
 do {
  HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
  i7 = i7 + 1 | 0;
  i8 = i8 + 1 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i11 + 20 >> 2] = i2;
 HEAP32[i11 + 24 >> 2] = i3;
 HEAP32[i11 + 28 >> 2] = i4;
 HEAP32[i11 + 32 >> 2] = i5;
 HEAP8[i11 + 36 >> 0] = 1;
 HEAP32[i11 + 40 >> 2] = i6;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, 2, i16 + 24 | 0, i10);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 52 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 68 | 0, 4);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 84 | 0, 5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 100 | 0, 6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 116 | 0, 7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 132 | 0, 8);
 if (HEAP8[i13 >> 0] | 0) HEAP8[HEAP32[i18 + 40 >> 2] >> 0] = 1;
 i18 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i14 + 64 >> 2] | 0;
 _memcpy(i12 | 0, i14 | 0, i16 << 3 | 0) | 0;
 HEAP32[i12 + 64 >> 2] = i16;
 i16 = i12 + 80 | 0;
 i14 = i14 + 80 | 0;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 mftCall_vii(HEAP32[i17 + 20 >> 2] | 0, i18 | 0, i12 | 0);
 STACKTOP = i15;
 return;
}

function __ZL12AddLightToSHRK4AABBRK15SharedLightDataP18ForwardLightsBlockf(i8, i9, i10, f11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i13 = i14;
 i7 = HEAP32[i9 + 40 >> 2] | 0;
 if ((i7 | 0) == 1) {
  f3 = Math_fround(HEAPF32[i9 + 248 >> 2]);
  f2 = Math_fround(HEAPF32[i9 + 252 >> 2]);
  f2 = Math_fround(-f2);
  f1 = Math_fround(-Math_fround(HEAPF32[i9 + 256 >> 2]));
  HEAPF32[i12 >> 2] = Math_fround(-f3);
  HEAPF32[i12 + 4 >> 2] = f2;
  HEAPF32[i12 + 8 >> 2] = f1;
  f1 = Math_fround(HEAPF32[i9 + 188 >> 2]);
  f2 = Math_fround(HEAPF32[i9 + 192 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 196 >> 2]);
  f15 = Math_fround(HEAPF32[i9 + 200 >> 2]);
  f1 = Math_fround(f1 * f11);
  f2 = Math_fround(f2 * f11);
  f3 = Math_fround(f3 * f11);
  f11 = Math_fround(f15 * f11);
  HEAPF32[i13 >> 2] = f1;
  i9 = i13 + 4 | 0;
  HEAPF32[i9 >> 2] = f2;
  i9 = i13 + 8 | 0;
  HEAPF32[i9 >> 2] = f3;
  i9 = i13 + 12 | 0;
  HEAPF32[i9 >> 2] = f11;
  __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i10, i12, i13);
  STACKTOP = i14;
  return;
 }
 f3 = Math_fround(HEAPF32[i9 + 264 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + 268 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 272 >> 2]);
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f1 = Math_fround(f3 - f1);
 f2 = Math_fround(f15 - f2);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i8 + 8 >> 2]));
 f15 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(0.0)) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)));
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f15))));
 f1 = Math_fround(f1 * f3);
 f2 = Math_fround(f2 * f3);
 f3 = Math_fround(f16 * f3);
 i6 = f15 > Math_fround(9.99999974e-06);
 i5 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i4 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i6 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i6;
 i6 = i8 + 12 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f18 * f18)) + Math_fround(Math_fround(f3 * f3) + Math_fround(0.0)));
 f18 = Math_fround(HEAPF32[i9 + 204 >> 2]);
 f2 = Math_fround(HEAPF32[i9 + 48 >> 2]);
 f2 = (i7 | 0) == 3 ? f18 : f2;
 f2 = Math_fround(f2 * f2);
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + 264 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 268 >> 2]);
 f15 = Math_fround(f18 - f15);
 f16 = Math_fround(f17 - f16);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i9 + 272 >> 2]));
 f1 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_fround(25.0) / f2) * Math_fround(_fmaxf(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f16 * f16)) + Math_fround(Math_fround(f1 * f1) + Math_fround(0.0))), f3))) + Math_fround(1.0)));
 if (f3 > f2) f1 = Math_fround(Math_fround(f2 / f3) * f1);
 f15 = Math_fround(HEAPF32[i9 + 188 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 192 >> 2]);
 f17 = Math_fround(HEAPF32[i9 + 196 >> 2]);
 f15 = Math_fround(f1 * f15);
 f16 = Math_fround(f1 * f16);
 f17 = Math_fround(f1 * f17);
 f18 = Math_fround(f1 * Math_fround(HEAPF32[i9 + 200 >> 2]));
 f15 = Math_fround(f15 * f11);
 f16 = Math_fround(f16 * f11);
 f17 = Math_fround(f17 * f11);
 f18 = Math_fround(f18 * f11);
 HEAPF32[i13 >> 2] = f15;
 i9 = i13 + 4 | 0;
 HEAPF32[i9 >> 2] = f16;
 i9 = i13 + 8 | 0;
 HEAPF32[i9 >> 2] = f17;
 i9 = i13 + 12 | 0;
 HEAPF32[i9 >> 2] = f18;
 __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i10, i12, i13);
 STACKTOP = i14;
 return;
}

function runPostSets29() {
 HEAP32[gb + 41804 >> 2] = fb + 28;
 HEAP32[gb + 41808 >> 2] = fb + 190;
 HEAP32[gb + 41812 >> 2] = fb + 29;
 HEAP32[gb + 41816 >> 2] = fb + 34;
 HEAP32[gb + 41820 >> 2] = fb + 306;
 HEAP32[gb + 41824 >> 2] = fb + 307;
 HEAP32[gb + 41828 >> 2] = fb + 308;
 HEAP32[gb + 41832 >> 2] = fb + 309;
 HEAP32[gb + 41836 >> 2] = fb + 310;
 HEAP32[gb + 41840 >> 2] = fb + 311;
 HEAP32[gb + 41844 >> 2] = fb + 36;
 HEAP32[gb + 41848 >> 2] = fb + 318;
 HEAP32[gb + 41852 >> 2] = fb + 191;
 HEAP32[gb + 41856 >> 2] = fb + 192;
 HEAP32[gb + 41860 >> 2] = fb + 193;
 HEAP32[gb + 41864 >> 2] = fb + 312;
 HEAP32[gb + 41868 >> 2] = fb + 38;
 HEAP32[gb + 41872 >> 2] = fb + 39;
 HEAP32[gb + 41876 >> 2] = fb + 40;
 HEAP32[gb + 41880 >> 2] = fb + 41;
 HEAP32[gb + 41884 >> 2] = fb + 194;
 HEAP32[gb + 41888 >> 2] = fb + 195;
 HEAP32[gb + 41892 >> 2] = fb + 196;
 HEAP32[gb + 41896 >> 2] = fb + 197;
 HEAP32[gb + 41900 >> 2] = fb + 198;
 HEAP32[gb + 41904 >> 2] = fb + 199;
 HEAP32[gb + 41908 >> 2] = fb + 48;
 HEAP32[gb + 41912 >> 2] = fb + 200;
 HEAP32[gb + 41916 >> 2] = fb + 313;
 HEAP32[gb + 41920 >> 2] = fb + 319;
 HEAP32[gb + 41924 >> 2] = fb + 6;
 HEAP32[gb + 41928 >> 2] = fb + 320;
 HEAP32[gb + 41932 >> 2] = fb + 314;
 HEAP32[gb + 41936 >> 2] = fb + 315;
 HEAP32[gb + 41940 >> 2] = fb + 201;
 HEAP32[gb + 41944 >> 2] = fb + 4;
 HEAP32[gb + 41948 >> 2] = fb + 321;
 HEAP32[gb + 41952 >> 2] = fb + 322;
 HEAP32[gb + 41956 >> 2] = fb + 323;
 HEAP32[gb + 41968 >> 2] = fb + 324;
 HEAP32[gb + 41972 >> 2] = fb + 325;
 HEAP32[gb + 42988 >> 2] = (HEAP32[gb + 42988 >> 2] | 0) + (gb + 453523 | 0);
 HEAP32[gb + 42996 >> 2] = (HEAP32[gb + 42996 >> 2] | 0) + (gb + 453572 | 0);
 HEAP32[gb + 43004 >> 2] = (HEAP32[gb + 43004 >> 2] | 0) + (gb + 453634 | 0);
 HEAP32[gb + 43012 >> 2] = (HEAP32[gb + 43012 >> 2] | 0) + (gb + 453595 | 0);
 HEAP32[gb + 43020 >> 2] = (HEAP32[gb + 43020 >> 2] | 0) + (gb + 453548 | 0);
 HEAP32[gb + 43028 >> 2] = (HEAP32[gb + 43028 >> 2] | 0) + (gb + 453659 | 0);
 HEAP32[gb + 43036 >> 2] = (HEAP32[gb + 43036 >> 2] | 0) + (gb + 453460 | 0);
 HEAP32[gb + 43044 >> 2] = fb + 7;
 HEAP32[gb + 43048 >> 2] = fb + 66;
 HEAP32[gb + 43068 >> 2] = (HEAP32[gb + 43068 >> 2] | 0) + (gb + 401671 | 0);
 HEAP32[gb + 43072 >> 2] = (HEAP32[gb + 43072 >> 2] | 0) + (gb + 401811 | 0);
 HEAP32[gb + 43076 >> 2] = (HEAP32[gb + 43076 >> 2] | 0) + (gb + 401906 | 0);
 HEAP32[gb + 43088 >> 2] = fb + 326;
 HEAP32[gb + 43092 >> 2] = fb + 327;
 HEAP32[gb + 43096 >> 2] = fb + 33;
 HEAP32[gb + 43100 >> 2] = fb + 1;
 HEAP32[gb + 43104 >> 2] = fb + 1;
 HEAP32[gb + 43116 >> 2] = fb + 328;
 HEAP32[gb + 43120 >> 2] = fb + 329;
 HEAP32[gb + 43124 >> 2] = fb + 33;
 HEAP32[gb + 43128 >> 2] = fb + 330;
 HEAP32[gb + 43132 >> 2] = fb + 7;
 HEAP32[gb + 43144 >> 2] = fb + 331;
 HEAP32[gb + 43148 >> 2] = fb + 332;
 HEAP32[gb + 43152 >> 2] = fb + 33;
 HEAP32[gb + 43156 >> 2] = fb + 333;
 HEAP32[gb + 43160 >> 2] = fb + 8;
 HEAP32[gb + 43172 >> 2] = fb + 334;
 HEAP32[gb + 43176 >> 2] = fb + 335;
 HEAP32[gb + 43180 >> 2] = fb + 38;
 HEAP32[gb + 43184 >> 2] = fb + 145;
 HEAP32[gb + 43188 >> 2] = fb + 16;
 HEAP32[gb + 43192 >> 2] = fb + 93;
 HEAP32[gb + 43196 >> 2] = fb + 40;
 HEAP32[gb + 43200 >> 2] = fb + 19;
 HEAP32[gb + 43204 >> 2] = fb + 202;
 HEAP32[gb + 43208 >> 2] = fb + 103;
 HEAP32[gb + 43212 >> 2] = fb + 101;
 HEAP32[gb + 43216 >> 2] = fb + 62;
 HEAP32[gb + 43220 >> 2] = fb + 28;
 HEAP32[gb + 43224 >> 2] = fb + 63;
 HEAP32[gb + 43228 >> 2] = fb + 29;
 HEAP32[gb + 43232 >> 2] = fb + 34;
 HEAP32[gb + 43236 >> 2] = fb + 316;
 HEAP32[gb + 43240 >> 2] = fb + 317;
 HEAP32[gb + 43244 >> 2] = fb + 318;
 HEAP32[gb + 43248 >> 2] = fb + 319;
 HEAP32[gb + 43252 >> 2] = fb + 320;
 HEAP32[gb + 43256 >> 2] = fb + 321;
 HEAP32[gb + 43260 >> 2] = fb + 36;
 HEAP32[gb + 43264 >> 2] = fb + 104;
 HEAP32[gb + 43268 >> 2] = fb + 108;
 HEAP32[gb + 43272 >> 2] = fb + 94;
 HEAP32[gb + 43276 >> 2] = fb + 130;
 HEAP32[gb + 43280 >> 2] = fb + 112;
 HEAP32[gb + 43284 >> 2] = fb + 113;
 HEAP32[gb + 43288 >> 2] = fb + 131;
 HEAP32[gb + 43292 >> 2] = fb + 111;
 HEAP32[gb + 43296 >> 2] = fb + 112;
 runPostSets30();
}

function __ZN9Rigidbody17AddExplosionForceEfRK8Vector3fffi(i14, f15, i4, f2, f1, i16) {
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 i16 = i16 | 0;
 var f3 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 56 | 0;
 i9 = i19 + 28 | 0;
 i18 = i19 + 16 | 0;
 i5 = i19 + 12 | 0;
 i8 = i19;
 if (!(HEAP8[i14 + 80 >> 0] | 0)) {
  STACKTOP = i19;
  return;
 }
 f12 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - f1);
 i20 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i10 = i8 + 4 | 0;
 HEAPF32[i10 >> 2] = f12;
 i13 = i8 + 8 | 0;
 HEAP32[i13 >> 2] = i20;
 i20 = f1 == Math_fround(0.0);
 __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i14, i4, i18, i5);
 if (!i20) __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i14, i8, i18, i17);
 f11 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 if (f11 < f2) {
  f12 = Math_fround(Math_fround(Math_sqrt(Math_fround(HEAPF32[i5 >> 2]))) / f2);
  i20 = f12 < Math_fround(0.0);
  i5 = f12 > Math_fround(1.0);
  f12 = Math_fround(Math_fround(1.0) - (i5 ? Math_fround(1.0) : f12));
  f12 = i20 ? Math_fround(1.0) : f12;
 } else f12 = Math_fround(1.0);
 f1 = Math_fround(HEAPF32[i18 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i8 >> 2]));
 f2 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i10 >> 2]));
 f6 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i13 >> 2]));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(f6 * f6))));
 if (f7 > f11) {
  f3 = Math_fround(f1 / f7);
  f2 = Math_fround(f2 / f7);
  f1 = Math_fround(f6 / f7);
 } else {
  i20 = i14 + 52 | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i17 | 0, i5 | 0);
  i20 = HEAP32[i20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 124 >> 2] | 0, i9 | 0, i20 | 0);
  f21 = Math_fround(Math_fround(HEAPF32[i9 + 16 >> 2]) * Math_fround(2.0));
  f23 = Math_fround(Math_fround(HEAPF32[i9 + 20 >> 2]) * Math_fround(2.0));
  f26 = Math_fround(Math_fround(HEAPF32[i9 + 24 >> 2]) * Math_fround(2.0));
  f24 = Math_fround(HEAPF32[i17 + 12 >> 2]);
  f25 = Math_fround(Math_fround(f24 * f24) + Math_fround(-.5));
  f22 = Math_fround(HEAPF32[i17 >> 2]);
  f1 = Math_fround(f21 * f22);
  f6 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f23 * f6));
  f7 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f1 = Math_fround(f1 + Math_fround(f26 * f7));
  f3 = Math_fround(Math_fround(f22 * f1) + Math_fround(Math_fround(f21 * f25) + Math_fround(f24 * Math_fround(Math_fround(f26 * f6) - Math_fround(f23 * f7)))));
  f2 = Math_fround(Math_fround(f6 * f1) + Math_fround(Math_fround(f23 * f25) + Math_fround(f24 * Math_fround(Math_fround(f21 * f7) - Math_fround(f26 * f22)))));
  f1 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f24 * Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f6)))) + Math_fround(f7 * f1));
  f3 = Math_fround(Math_fround(HEAPF32[i17 + 16 >> 2]) + f3);
  f2 = Math_fround(Math_fround(HEAPF32[i17 + 20 >> 2]) + f2);
  f1 = Math_fround(Math_fround(HEAPF32[i17 + 24 >> 2]) + f1);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i8 >> 2]));
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i10 >> 2]));
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i13 >> 2]));
  if (Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)) + Math_fround(f1 * f1)))) <= f11) {
   f3 = Math_fround(0.0);
   f2 = Math_fround(1.0);
   f1 = Math_fround(0.0);
  }
 }
 f24 = Math_fround(f12 * f15);
 f25 = Math_fround(f24 * f2);
 f26 = Math_fround(f24 * f1);
 HEAPF32[i17 >> 2] = Math_fround(f24 * f3);
 HEAPF32[i17 + 4 >> 2] = f25;
 HEAPF32[i17 + 8 >> 2] = f26;
 __ZN9Rigidbody18AddForceAtPositionERK8Vector3fS2_i(i14, i17, i18, i16);
 STACKTOP = i19;
 return;
}

function __ZNK5physx21PxSpringGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj505ENS_22PxRepXPropertyAccessorILj505ENS_8PxSpringEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj506ENS_22PxRepXPropertyAccessorILj506ENS_8PxSpringEffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function runPostSets199() {
 HEAP32[gb + 168920 >> 2] = fb + 2579;
 HEAP32[gb + 168932 >> 2] = fb + 82;
 HEAP32[gb + 168944 >> 2] = (HEAP32[gb + 168944 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 168948 >> 2] = (HEAP32[gb + 168948 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 168984 >> 2] = (HEAP32[gb + 168984 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 168988 >> 2] = (HEAP32[gb + 168988 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 169048 >> 2] = fb + 2580;
 HEAP32[gb + 169052 >> 2] = fb + 2581;
 HEAP32[gb + 169056 >> 2] = fb + 38;
 HEAP32[gb + 169060 >> 2] = fb + 1886;
 HEAP32[gb + 169064 >> 2] = fb + 16;
 HEAP32[gb + 169068 >> 2] = fb + 2582;
 HEAP32[gb + 169072 >> 2] = fb + 2583;
 HEAP32[gb + 169076 >> 2] = fb + 2584;
 HEAP32[gb + 169080 >> 2] = fb + 1216;
 HEAP32[gb + 169084 >> 2] = fb + 103;
 HEAP32[gb + 169088 >> 2] = fb + 101;
 HEAP32[gb + 169092 >> 2] = fb + 62;
 HEAP32[gb + 169096 >> 2] = fb + 28;
 HEAP32[gb + 169100 >> 2] = fb + 63;
 HEAP32[gb + 169104 >> 2] = fb + 29;
 HEAP32[gb + 169108 >> 2] = fb + 34;
 HEAP32[gb + 169112 >> 2] = fb + 1887;
 HEAP32[gb + 169116 >> 2] = fb + 1888;
 HEAP32[gb + 169120 >> 2] = fb + 1889;
 HEAP32[gb + 169124 >> 2] = fb + 1890;
 HEAP32[gb + 169128 >> 2] = fb + 1891;
 HEAP32[gb + 169132 >> 2] = fb + 1892;
 HEAP32[gb + 169136 >> 2] = fb + 36;
 HEAP32[gb + 169140 >> 2] = fb + 1217;
 HEAP32[gb + 169144 >> 2] = fb + 108;
 HEAP32[gb + 169148 >> 2] = fb + 94;
 HEAP32[gb + 169152 >> 2] = fb + 130;
 HEAP32[gb + 169156 >> 2] = fb + 112;
 HEAP32[gb + 169160 >> 2] = fb + 113;
 HEAP32[gb + 169164 >> 2] = fb + 131;
 HEAP32[gb + 169168 >> 2] = fb + 111;
 HEAP32[gb + 169172 >> 2] = fb + 112;
 HEAP32[gb + 169176 >> 2] = fb + 113;
 HEAP32[gb + 169180 >> 2] = fb + 2585;
 HEAP32[gb + 169184 >> 2] = fb + 2586;
 HEAP32[gb + 169196 >> 2] = fb + 2587;
 HEAP32[gb + 169200 >> 2] = fb + 2588;
 HEAP32[gb + 169204 >> 2] = fb + 38;
 HEAP32[gb + 169208 >> 2] = fb + 1893;
 HEAP32[gb + 169212 >> 2] = fb + 16;
 HEAP32[gb + 169216 >> 2] = fb + 93;
 HEAP32[gb + 169220 >> 2] = fb + 2589;
 HEAP32[gb + 169224 >> 2] = fb + 2590;
 HEAP32[gb + 169228 >> 2] = fb + 1218;
 HEAP32[gb + 169232 >> 2] = fb + 103;
 HEAP32[gb + 169236 >> 2] = fb + 101;
 HEAP32[gb + 169240 >> 2] = fb + 62;
 HEAP32[gb + 169244 >> 2] = fb + 28;
 HEAP32[gb + 169248 >> 2] = fb + 63;
 HEAP32[gb + 169252 >> 2] = fb + 29;
 HEAP32[gb + 169256 >> 2] = fb + 34;
 HEAP32[gb + 169260 >> 2] = fb + 1894;
 HEAP32[gb + 169264 >> 2] = fb + 1895;
 HEAP32[gb + 169268 >> 2] = fb + 1896;
 HEAP32[gb + 169272 >> 2] = fb + 1897;
 HEAP32[gb + 169276 >> 2] = fb + 1898;
 HEAP32[gb + 169280 >> 2] = fb + 1899;
 HEAP32[gb + 169284 >> 2] = fb + 36;
 HEAP32[gb + 169288 >> 2] = fb + 104;
 HEAP32[gb + 169292 >> 2] = fb + 108;
 HEAP32[gb + 169296 >> 2] = fb + 94;
 HEAP32[gb + 169300 >> 2] = fb + 130;
 HEAP32[gb + 169304 >> 2] = fb + 112;
 HEAP32[gb + 169308 >> 2] = fb + 113;
 HEAP32[gb + 169312 >> 2] = fb + 131;
 HEAP32[gb + 169316 >> 2] = fb + 111;
 HEAP32[gb + 169320 >> 2] = fb + 112;
 HEAP32[gb + 169324 >> 2] = fb + 113;
 HEAP32[gb + 169328 >> 2] = fb + 2591;
 HEAP32[gb + 169332 >> 2] = fb + 2592;
 HEAP32[gb + 169344 >> 2] = (HEAP32[gb + 169344 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 169348 >> 2] = (HEAP32[gb + 169348 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 169384 >> 2] = fb + 83;
 HEAP32[gb + 169412 >> 2] = fb + 2593;
 HEAP32[gb + 169416 >> 2] = fb + 2594;
 HEAP32[gb + 169420 >> 2] = fb + 2595;
 HEAP32[gb + 169424 >> 2] = fb + 1900;
 HEAP32[gb + 169428 >> 2] = fb + 16;
 HEAP32[gb + 169432 >> 2] = fb + 39;
 HEAP32[gb + 169436 >> 2] = fb + 40;
 HEAP32[gb + 169440 >> 2] = fb + 19;
 HEAP32[gb + 169444 >> 2] = fb + 1219;
 HEAP32[gb + 169448 >> 2] = fb + 31;
 HEAP32[gb + 169452 >> 2] = fb + 27;
 HEAP32[gb + 169456 >> 2] = fb + 62;
 HEAP32[gb + 169460 >> 2] = fb + 28;
 HEAP32[gb + 169464 >> 2] = fb + 63;
 HEAP32[gb + 169468 >> 2] = fb + 29;
 HEAP32[gb + 169472 >> 2] = fb + 34;
 HEAP32[gb + 169476 >> 2] = fb + 1901;
 HEAP32[gb + 169480 >> 2] = fb + 1902;
 HEAP32[gb + 169484 >> 2] = fb + 1903;
 HEAP32[gb + 169488 >> 2] = fb + 1904;
 HEAP32[gb + 169492 >> 2] = fb + 1905;
 runPostSets200();
}

function _process_data_context_main(i23, i18, i19, i20) {
 i23 = i23 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0;
 i21 = i23 + 388 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 i25 = i22 + 48 | 0;
 do if (!(HEAP8[i25 >> 0] | 0)) if (!(mftCall_iii(HEAP32[(HEAP32[i23 + 392 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, HEAP32[i22 + 56 + (HEAP32[i22 + 64 >> 2] << 2) >> 2] | 0) | 0)) return; else {
  HEAP8[i25 >> 0] = 1;
  i24 = i22 + 76 | 0;
  HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) + 1;
  break;
 } while (0);
 i24 = i22 + 68 | 0;
 switch (HEAP32[i24 >> 2] | 0) {
 case 2:
  {
   i1 = i22 + 52 | 0;
   i2 = i22 + 72 | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i23 + 396 >> 2] | 0) + 4 >> 2] | 0, i23 | 0, HEAP32[i22 + 56 + (HEAP32[i22 + 64 >> 2] << 2) >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, i18 | 0, i19 | 0, i20 | 0);
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) return;
   HEAP32[i24 >> 2] = 0;
   if ((HEAP32[i19 >> 2] | 0) >>> 0 < i20 >>> 0) i3 = 9; else return;
   break;
  }
 case 0:
  {
   i1 = i22 + 52 | 0;
   i2 = i22 + 72 | 0;
   i3 = 9;
   break;
  }
 case 1:
  {
   i17 = i22 + 52 | 0;
   i16 = i22 + 72 | 0;
   break;
  }
 default:
  return;
 }
 if ((i3 | 0) == 9) {
  HEAP32[i1 >> 2] = 0;
  i8 = HEAP32[i23 + 280 >> 2] | 0;
  HEAP32[i2 >> 2] = i8 + -1;
  if ((HEAP32[i22 + 76 >> 2] | 0) == (HEAP32[i23 + 284 >> 2] | 0)) {
   i9 = HEAP32[i21 >> 2] | 0;
   i10 = HEAP32[i23 + 36 >> 2] | 0;
   if ((i10 | 0) > 0) {
    i11 = i9 + 72 | 0;
    i12 = i9 + 64 | 0;
    i6 = HEAP32[i23 + 196 >> 2] | 0;
    i7 = 0;
    while (1) {
     i17 = Math_imul(HEAP32[i6 + 36 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0) | 0;
     i3 = (i17 | 0) / (i8 | 0) | 0;
     i5 = ((HEAP32[i6 + 44 >> 2] | 0) >>> 0) % (i17 >>> 0) | 0;
     i5 = (i5 | 0) == 0 ? i17 : i5;
     if (!i7) HEAP32[i11 >> 2] = ((i5 + -1 | 0) / (i3 | 0) | 0) + 1;
     i13 = HEAP32[(HEAP32[i9 + 56 + (HEAP32[i12 >> 2] << 2) >> 2] | 0) + (i7 << 2) >> 2] | 0;
     i14 = i3 << 1;
     if ((i3 | 0) > 0) {
      i4 = i13 + (i5 + -1 << 2) | 0;
      i3 = 0;
      do {
       HEAP32[i13 + (i3 + i5 << 2) >> 2] = HEAP32[i4 >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) < (i14 | 0));
     }
     i7 = i7 + 1 | 0;
     if ((i7 | 0) == (i10 | 0)) break; else i6 = i6 + 84 | 0;
    }
   }
  }
  HEAP32[i24 >> 2] = 1;
  i17 = i1;
  i16 = i2;
 }
 i15 = i22 + 64 | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i23 + 396 >> 2] | 0) + 4 >> 2] | 0, i23 | 0, HEAP32[i22 + 56 + (HEAP32[i15 >> 2] << 2) >> 2] | 0, i17 | 0, HEAP32[i16 >> 2] | 0, i18 | 0, i19 | 0, i20 | 0);
 if ((HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0) return;
 if ((HEAP32[i22 + 76 >> 2] | 0) == 1) {
  i2 = HEAP32[i21 >> 2] | 0;
  i1 = HEAP32[i23 + 280 >> 2] | 0;
  i13 = HEAP32[i23 + 36 >> 2] | 0;
  if ((i13 | 0) > 0) {
   i14 = i2 + 56 | 0;
   i10 = i2 + 60 | 0;
   i11 = i1 + 1 | 0;
   i12 = i1 + 2 | 0;
   i3 = HEAP32[i23 + 196 >> 2] | 0;
   i4 = 0;
   while (1) {
    i5 = (Math_imul(HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0) | 0) / (i1 | 0) | 0;
    i6 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i7 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    if ((i5 | 0) > 0) {
     i8 = Math_imul(i5, i11) | 0;
     i9 = Math_imul(i5, i12) | 0;
     i2 = 0;
     do {
      i22 = i2 + i8 | 0;
      i23 = i2 - i5 | 0;
      HEAP32[i6 + (i23 << 2) >> 2] = HEAP32[i6 + (i22 << 2) >> 2];
      HEAP32[i7 + (i23 << 2) >> 2] = HEAP32[i7 + (i22 << 2) >> 2];
      i23 = i2 + i9 | 0;
      HEAP32[i6 + (i23 << 2) >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
      HEAP32[i7 + (i23 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i5 | 0));
    }
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i13 | 0)) break; else i3 = i3 + 84 | 0;
   }
  }
 } else i1 = HEAP32[i23 + 280 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i15 >> 2] ^ 1;
 HEAP8[i25 >> 0] = 0;
 HEAP32[i17 >> 2] = i1 + 1;
 HEAP32[i16 >> 2] = i1 + 2;
 HEAP32[i24 >> 2] = 2;
 return;
}

function _cff_parse_cid_ros(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i7 + 412 >> 2] | 0;
 i9 = i7 + 28 | 0;
 if ((HEAP32[i7 + 404 >> 2] | 0) >>> 0 < i9 >>> 0) {
  i10 = 161;
  return i10 | 0;
 }
 i1 = i7 + 20 | 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP8[i3 >> 0] | 0;
 L4 : do if (i6 << 24 >> 24 == 30) {
  i6 = (_cff_parse_real(i3, i2, 0, 0) | 0) >> 16;
  i8 = HEAP32[i1 >> 2] | 0;
  i1 = i6;
 } else {
  i4 = i3 + 1 | 0;
  i5 = i6 & 255;
  switch (i6 << 24 >> 24) {
  case 28:
   {
    if ((i3 + 3 | 0) >>> 0 > i2 >>> 0) {
     i8 = i2;
     i1 = 0;
     break L4;
    }
    i8 = i2;
    i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i3 + 2 >> 0] | 0)) << 16 >> 16;
    break L4;
   }
  case 29:
   {
    if ((i3 + 5 | 0) >>> 0 > i2 >>> 0) {
     i8 = i2;
     i1 = 0;
     break L4;
    }
    i8 = i2;
    i1 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i3 + 3 >> 0] | 0) << 8 | (HEAPU8[i3 + 4 >> 0] | 0);
    break L4;
   }
  default:
   {
    if ((i6 & 255) < 247) {
     i8 = i2;
     i1 = i5 + -139 | 0;
     break L4;
    }
    i1 = (i3 + 2 | 0) >>> 0 > i2 >>> 0;
    if ((i6 & 255) < 251) {
     if (i1) {
      i8 = i2;
      i1 = 0;
      break L4;
     }
     i8 = i2;
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     break L4;
    } else {
     if (i1) {
      i8 = i2;
      i1 = 0;
      break L4;
     }
     i8 = i2;
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     break L4;
    }
   }
  }
 } while (0);
 HEAP32[i10 + 132 >> 2] = i1;
 i1 = i7 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP8[i8 >> 0] | 0;
 L22 : do if (i3 << 24 >> 24 == 30) {
  i8 = (_cff_parse_real(i8, i2, 0, 0) | 0) >> 16;
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = i8;
 } else {
  i4 = i8 + 1 | 0;
  i5 = i3 & 255;
  switch (i3 << 24 >> 24) {
  case 28:
   {
    if ((i8 + 3 | 0) >>> 0 > i2 >>> 0) {
     i6 = i2;
     i1 = 0;
     break L22;
    }
    i6 = i2;
    i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i8 + 2 >> 0] | 0)) << 16 >> 16;
    break L22;
   }
  case 29:
   {
    if ((i8 + 5 | 0) >>> 0 > i2 >>> 0) {
     i6 = i2;
     i1 = 0;
     break L22;
    }
    i6 = i2;
    i1 = (HEAPU8[i8 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i8 + 3 >> 0] | 0) << 8 | (HEAPU8[i8 + 4 >> 0] | 0);
    break L22;
   }
  default:
   {
    if ((i3 & 255) < 247) {
     i6 = i2;
     i1 = i5 + -139 | 0;
     break L22;
    }
    i1 = (i8 + 2 | 0) >>> 0 > i2 >>> 0;
    if ((i3 & 255) < 251) {
     if (i1) {
      i6 = i2;
      i1 = 0;
      break L22;
     }
     i6 = i2;
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     break L22;
    } else {
     if (i1) {
      i6 = i2;
      i1 = 0;
      break L22;
     }
     i6 = i2;
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     break L22;
    }
   }
  }
 } while (0);
 HEAP32[i10 + 136 >> 2] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 L40 : do if (i2 << 24 >> 24 == 30) i1 = (_cff_parse_real(i6, i1, 0, 0) | 0) >> 16; else {
  i3 = i6 + 1 | 0;
  i4 = i2 & 255;
  switch (i2 << 24 >> 24) {
  case 28:
   {
    if ((i6 + 3 | 0) >>> 0 > i1 >>> 0) {
     i1 = 0;
     break L40;
    }
    i1 = ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i6 + 2 >> 0] | 0)) << 16 >> 16;
    break L40;
   }
  case 29:
   {
    if ((i6 + 5 | 0) >>> 0 > i1 >>> 0) {
     i1 = 0;
     break L40;
    }
    i1 = (HEAPU8[i6 + 2 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i6 + 3 >> 0] | 0) << 8 | (HEAPU8[i6 + 4 >> 0] | 0);
    break L40;
   }
  default:
   {
    if ((i2 & 255) < 247) {
     i1 = i4 + -139 | 0;
     break L40;
    }
    i1 = (i6 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i2 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L40;
     }
     i1 = (HEAPU8[i3 >> 0] | 0 | (i4 << 8) + -63232) + 108 | 0;
     break L40;
    } else {
     if (i1) {
      i1 = 0;
      break L40;
     }
     i1 = (251 - i4 << 8) + -108 - (HEAPU8[i3 >> 0] | 0) | 0;
     break L40;
    }
   }
  }
 } while (0);
 HEAP32[i10 + 140 >> 2] = i1;
 i10 = 0;
 return i10 | 0;
}

function __Z22InverseTransformVector23TransformAccessReadOnlyRKN4math7_float3E(i10, i2, i3) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11 + 20 | 0;
 i6 = i11 + 8 | 0;
 i7 = i11;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 if (!(HEAP32[i2 + 4 >> 2] | 0)) {
  i3 = i2;
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f1 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
 } else {
  i3 = i2;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i13 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i12 = i7;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i12 + 4 >> 2] = i13;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __Z22InverseTransformVector23TransformAccessReadOnlyRKN4math7_float3E(i6, i8, i9);
  i12 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = HEAP32[i6 + 8 >> 2] | 0;
  HEAP32[i9 >> 2] = i12;
  HEAP32[i9 + 4 >> 2] = i7;
  HEAP32[i9 + 8 >> 2] = i8;
  f4 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 24 >> 2]);
 f18 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i3 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i3 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i3 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f25 = Math_fround(f18 * Math_fround(-2.0));
 f19 = Math_fround(f18 * Math_fround(2.0));
 f23 = Math_fround(f15 * f25);
 f17 = Math_fround(f24 * Math_fround(2.0));
 f22 = Math_fround(f24 * Math_fround(-2.0));
 f26 = Math_fround(f15 * f22);
 f20 = Math_fround(f21 * Math_fround(-2.0));
 f16 = Math_fround(f21 * Math_fround(2.0));
 f15 = Math_fround(f15 * f20);
 f14 = Math_fround(Math_fround(f4 + Math_fround(f4 * Math_fround(Math_fround(f18 * f25) - Math_fround(f24 * f17)))) + Math_fround(Math_fround(f1 * Math_fround(Math_fround(f16 * f24) - f23)) + Math_fround(f5 * Math_fround(f26 - Math_fround(f18 * f20)))));
 f16 = Math_fround(Math_fround(f5 + Math_fround(f4 * Math_fround(Math_fround(f21 * f19) - f26))) + Math_fround(Math_fround(f1 * Math_fround(f15 - Math_fround(f24 * f25))) + Math_fround(f5 * Math_fround(Math_fround(f24 * f22) - Math_fround(f21 * f16)))));
 f5 = Math_fround(Math_fround(f1 + Math_fround(f4 * Math_fround(f23 - Math_fround(f21 * f22)))) + Math_fround(Math_fround(f1 * Math_fround(Math_fround(f21 * f20) - Math_fround(f18 * f19))) + Math_fround(f5 * Math_fround(Math_fround(f18 * f17) - f15))));
 f1 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + (i3 * 40 | 0) + 36 >> 2]);
 i9 = Math_fround(Math_abs(Math_fround(f1))) < Math_fround(9.99999971e-10);
 i12 = Math_fround(Math_abs(Math_fround(f4))) < Math_fround(9.99999971e-10);
 i13 = Math_fround(Math_abs(Math_fround(f15))) < Math_fround(9.99999971e-10);
 f1 = Math_fround(Math_fround(1.0) / f1);
 f1 = i9 ? Math_fround(1.0) : f1;
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i12 ? Math_fround(1.0) : f4;
 f15 = Math_fround(Math_fround(1.0) / f15);
 f4 = Math_fround(f4 * f16);
 f5 = Math_fround((i13 ? Math_fround(1.0) : f15) * f5);
 HEAPF32[i10 >> 2] = Math_fround(f1 * f14);
 HEAPF32[i10 + 4 >> 2] = f4;
 HEAPF32[i10 + 8 >> 2] = f5;
 STACKTOP = i11;
 return;
}

function runPostSets180() {
 HEAP32[gb + 154516 >> 2] = fb + 131;
 HEAP32[gb + 154520 >> 2] = fb + 111;
 HEAP32[gb + 154524 >> 2] = fb + 112;
 HEAP32[gb + 154528 >> 2] = fb + 113;
 HEAP32[gb + 154532 >> 2] = fb + 2339;
 HEAP32[gb + 154536 >> 2] = fb + 2340;
 HEAP32[gb + 154540 >> 2] = fb + 1637;
 HEAP32[gb + 154544 >> 2] = fb + 1615;
 HEAP32[gb + 154556 >> 2] = (HEAP32[gb + 154556 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 154560 >> 2] = (HEAP32[gb + 154560 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 154596 >> 2] = fb + 2359;
 HEAP32[gb + 154600 >> 2] = fb + 2360;
 HEAP32[gb + 154604 >> 2] = fb + 1638;
 HEAP32[gb + 154608 >> 2] = fb + 1639;
 HEAP32[gb + 154612 >> 2] = fb + 418;
 HEAP32[gb + 154616 >> 2] = fb + 417;
 HEAP32[gb + 154628 >> 2] = fb + 2361;
 HEAP32[gb + 154632 >> 2] = fb + 2362;
 HEAP32[gb + 154636 >> 2] = fb + 38;
 HEAP32[gb + 154640 >> 2] = fb + 145;
 HEAP32[gb + 154644 >> 2] = fb + 16;
 HEAP32[gb + 154648 >> 2] = fb + 2363;
 HEAP32[gb + 154652 >> 2] = fb + 2364;
 HEAP32[gb + 154656 >> 2] = fb + 19;
 HEAP32[gb + 154660 >> 2] = fb + 1077;
 HEAP32[gb + 154664 >> 2] = fb + 103;
 HEAP32[gb + 154668 >> 2] = fb + 101;
 HEAP32[gb + 154672 >> 2] = fb + 62;
 HEAP32[gb + 154676 >> 2] = fb + 28;
 HEAP32[gb + 154680 >> 2] = fb + 63;
 HEAP32[gb + 154684 >> 2] = fb + 29;
 HEAP32[gb + 154688 >> 2] = fb + 34;
 HEAP32[gb + 154692 >> 2] = fb + 1640;
 HEAP32[gb + 154696 >> 2] = fb + 1641;
 HEAP32[gb + 154700 >> 2] = fb + 1642;
 HEAP32[gb + 154704 >> 2] = fb + 1643;
 HEAP32[gb + 154708 >> 2] = fb + 1644;
 HEAP32[gb + 154712 >> 2] = fb + 1645;
 HEAP32[gb + 154716 >> 2] = fb + 36;
 HEAP32[gb + 154720 >> 2] = fb + 104;
 HEAP32[gb + 154724 >> 2] = fb + 108;
 HEAP32[gb + 154728 >> 2] = fb + 94;
 HEAP32[gb + 154732 >> 2] = fb + 130;
 HEAP32[gb + 154736 >> 2] = fb + 112;
 HEAP32[gb + 154740 >> 2] = fb + 113;
 HEAP32[gb + 154744 >> 2] = fb + 131;
 HEAP32[gb + 154748 >> 2] = fb + 111;
 HEAP32[gb + 154752 >> 2] = fb + 2365;
 HEAP32[gb + 154756 >> 2] = fb + 113;
 HEAP32[gb + 154760 >> 2] = fb + 2366;
 HEAP32[gb + 154764 >> 2] = fb + 2367;
 HEAP32[gb + 154776 >> 2] = (HEAP32[gb + 154776 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 154780 >> 2] = (HEAP32[gb + 154780 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 154816 >> 2] = fb + 2368;
 HEAP32[gb + 154820 >> 2] = fb + 2369;
 HEAP32[gb + 154824 >> 2] = fb + 38;
 HEAP32[gb + 154828 >> 2] = fb + 145;
 HEAP32[gb + 154832 >> 2] = fb + 16;
 HEAP32[gb + 154836 >> 2] = fb + 93;
 HEAP32[gb + 154840 >> 2] = fb + 40;
 HEAP32[gb + 154844 >> 2] = fb + 19;
 HEAP32[gb + 154848 >> 2] = fb + 1078;
 HEAP32[gb + 154852 >> 2] = fb + 103;
 HEAP32[gb + 154856 >> 2] = fb + 101;
 HEAP32[gb + 154860 >> 2] = fb + 62;
 HEAP32[gb + 154864 >> 2] = fb + 28;
 HEAP32[gb + 154868 >> 2] = fb + 63;
 HEAP32[gb + 154872 >> 2] = fb + 29;
 HEAP32[gb + 154876 >> 2] = fb + 34;
 HEAP32[gb + 154880 >> 2] = fb + 146;
 HEAP32[gb + 154884 >> 2] = fb + 147;
 HEAP32[gb + 154888 >> 2] = fb + 148;
 HEAP32[gb + 154892 >> 2] = fb + 149;
 HEAP32[gb + 154896 >> 2] = fb + 150;
 HEAP32[gb + 154900 >> 2] = fb + 151;
 HEAP32[gb + 154904 >> 2] = fb + 36;
 HEAP32[gb + 154908 >> 2] = fb + 104;
 HEAP32[gb + 154912 >> 2] = fb + 108;
 HEAP32[gb + 154916 >> 2] = fb + 94;
 HEAP32[gb + 154920 >> 2] = fb + 130;
 HEAP32[gb + 154924 >> 2] = fb + 112;
 HEAP32[gb + 154928 >> 2] = fb + 113;
 HEAP32[gb + 154932 >> 2] = fb + 131;
 HEAP32[gb + 154936 >> 2] = fb + 111;
 HEAP32[gb + 154940 >> 2] = fb + 112;
 HEAP32[gb + 154944 >> 2] = fb + 113;
 HEAP32[gb + 154948 >> 2] = fb + 2366;
 HEAP32[gb + 154952 >> 2] = fb + 2367;
 HEAP32[gb + 154964 >> 2] = (HEAP32[gb + 154964 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 154968 >> 2] = (HEAP32[gb + 154968 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 155004 >> 2] = fb + 2370;
 HEAP32[gb + 155008 >> 2] = fb + 2371;
 HEAP32[gb + 155012 >> 2] = fb + 38;
 HEAP32[gb + 155016 >> 2] = fb + 1646;
 HEAP32[gb + 155020 >> 2] = fb + 16;
 HEAP32[gb + 155024 >> 2] = fb + 2372;
 HEAP32[gb + 155028 >> 2] = fb + 2373;
 HEAP32[gb + 155032 >> 2] = fb + 19;
 HEAP32[gb + 155036 >> 2] = fb + 1079;
 HEAP32[gb + 155040 >> 2] = fb + 103;
 runPostSets181();
}

function __ZNK5physx30PxCapsuleGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj260ENS_22PxRepXPropertyAccessorILj260ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj261ENS_22PxRepXPropertyAccessorILj261ES4_ffEEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEEEEEjT_j(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i11 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
 }
 i5 = i6 + 16 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i1 = i3 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_(i9, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx8CCDSweepINS_2Gu4BoxVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN12AudioManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11);
 i1 = i10 + 28 | 0;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i13 = i11 + 24 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i7 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i7 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i6 = i10 + 140 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i8 = i10 + 144 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i3;
 i5 = i7 + 4 | 0;
 if (i5 >>> 0 < i4 >>> 0) {
  HEAP32[i7 >> 2] = i3;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i10 + 224 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i10 + 225 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_16PxSphereGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i11, i6, i5) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i8 = i12 + 64 | 0;
 i10 = i12 + 56 | 0;
 i7 = i12 + 28 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = gb + 673012;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i9;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i4 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i9;
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  i14 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_16PxSphereGeometryE(i6, HEAP32[i11 + 8 >> 2] | 0, i10) | 0;
 __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i7);
 i3 = i11 + 4 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i9);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP32[i8 + 12 >> 2] = i2;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx29PxSphereGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEEEEEjT_j(i9, i8, 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i12;
 return;
}

function __ZN12NavMeshAgent8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i8 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, i8, i1 + 36 | 0, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903494 | 0, i8, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842264 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842279 | 0, i7, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842297 | 0, i8, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842312 | 0, i8, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842331 | 0, i9, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842357 | 0, i9, i1 + 105 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842371 | 0, i9, i1 + 106 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i8, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842384 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842397 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 92 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842412 | 0, i7, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i9, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
  i4 = i3;
 }
 i1 = i9 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 >> 2] = i3;
 }
 i1 = i9 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i11 >> 2] = i2;
 }
 i5 = i9 + 16 | 0;
 i6 = i10 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i11 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i9 + 12 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, i2 + i4 | 0, i1 << 2);
 }
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i9 + 20 | 0, i10);
 i2 = i9 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 40, 4) | 0;
  i3 = i1;
  i4 = i3 + 40 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim9animation19Blend2dDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i10);
 i2 = i9 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 12, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP8[i1 + 8 >> 0] = 0;
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim9animation23BlendDirectDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i10);
 i1 = i9 + 32 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i11 >> 2] = i4;
 }
 i1 = i9 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i11 >> 2] = i3;
  i4 = i3;
 }
 i1 = i9 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i11 >> 2] = i3;
 }
 i1 = i9 + 44 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i11, i1, i8, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 i10 = i11 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + (i3 << 2) >> 2] = i5;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i1) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i9 = HEAP32[i11 + 20 >> 2] | 0;
    i9 = (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i9;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i9;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i9 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i9 = i11 + 36 | 0;
 L12 : do if (HEAP8[i9 >> 0] | 0) {
  __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i11, gb + 830924 | 0);
  if (!(HEAP8[i9 >> 0] | 0)) i1 = 0; else {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
   HEAP8[i9 >> 0] = i1;
  }
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP32[i7 + 8 >> 2] | 0) + -1 << 3) + 5 >> 0] = i1;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP32[i7 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i1;
  if (i1 << 24 >> 24) {
   i5 = i11 + 20 | 0;
   i6 = i11 + 40 | 0;
   i7 = i11 + 24 | 0;
   i3 = i8 + 12 | 0;
   i1 = 0;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    if (!i2) i12 = 17; else if (!(HEAP8[i2 >> 0] | 0)) i12 = 17; else i1 = (_strcasecmp(i2, gb + 1087447 | 0) | 0) == 0 & 1;
    if ((i12 | 0) == 17) {
     i12 = 0;
     HEAP8[HEAP32[i6 >> 2] >> 0] = 1;
    }
    mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i7 >> 2] | 0, i4 | 0, i1 << 24 >> 24 != 0 | 0);
    if (!(HEAP8[i9 >> 0] | 0)) break L12;
    i8 = HEAP32[i5 >> 2] | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0) i4 = i4 + 1 | 0; else break;
   }
  }
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i6 >>> 0) {
  i5 = i11 + 20 | 0;
  i1 = i3;
  i2 = i4;
  do {
   if (!i1) {
    i12 = 24;
    break;
   }
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i5 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i9 >> 0] = 1;
   if (!i1) break;
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i9 >> 0] = 0;
  } while (i1 >>> 0 > i6 >>> 0);
  if ((i12 | 0) == 24) HEAP8[i9 >> 0] = 1;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i23, i5, i1) {
 i23 = i23 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 64 | 0;
 i1 = i22 + 60 | 0;
 i21 = i22;
 i2 = i23 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i23 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i19 = HEAP32[i1 >> 2] | 0;
 } else {
  i19 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i19;
  HEAP32[i2 >> 2] = i4;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i5 + 4 | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (i19 | 0)) {
  i18 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0;
  i18 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i2 >> 2] | 0, i18, i19) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i1 + 4 >> 2] = i19;
 }
 i14 = i21 + 24 | 0;
 HEAP8[i14 >> 0] = 1;
 i15 = i21 + 28 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i21 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 36 | 0;
 HEAP32[i17 >> 2] = -1;
 i18 = i21 + 44 | 0;
 HEAP32[i18 >> 2] = 0;
 i12 = i21 + 48 | 0;
 HEAP32[i12 >> 2] = 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0) & 1;
 i8 = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) | 0) | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 8 >> 2] | 0;
 i2 = i5;
 i13 = i11 - i2 >> 6;
 HEAP32[i21 >> 2] = i1;
 i6 = i21 + 4 | 0;
 HEAP8[i6 >> 0] = i3;
 i7 = i21 + 8 | 0;
 HEAP32[i7 >> 2] = i8;
 i8 = i21 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i21 + 16 | 0;
 HEAP32[i9 >> 2] = i10;
 i10 = i21 + 20 | 0;
 HEAP8[i14 >> 0] = 1;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i17 >> 2] = -1;
 HEAP32[i21 + 40 >> 2] = i5;
 HEAP32[i18 >> 2] = i5;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i21 + 52 >> 2] = i13;
 HEAP32[i21 + 56 >> 2] = i13;
 if (!i19) {
  STACKTOP = i22;
  return;
 }
 i11 = i21 + 40 | 0;
 i12 = i20 + 20 | 0;
 i13 = i20 + 16 | 0;
 i1 = 0;
 while (1) {
  HEAP32[i18 >> 2] = i2;
  HEAP32[i10 >> 2] = i11;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i9 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, HEAP32[i8 >> 2] | 0, i1);
   }
   i3 = HEAP32[i9 >> 2] | 0;
   HEAP8[i14 >> 0] = 1;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i16 >> 2] = i3;
   i3 = HEAP32[i10 >> 2] | 0;
   i1 = -1;
  } else {
   i5 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i7 >> 2] | 0, i1) | 0) + 16 | 0;
   HEAP8[i14 >> 0] = 0;
   HEAP32[i15 >> 2] = i5;
   HEAP32[i16 >> 2] = i3;
   i3 = i11;
  }
  HEAP32[i17 >> 2] = i1;
  HEAP32[i12 >> 2] = i23;
  HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i13 >> 2] = i3;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = i3 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i3 = i3 + 12 | 0;
   do {
    i24 = i1 + 64 | 0;
    HEAP32[i4 >> 2] = i24;
    HEAP32[i3 >> 2] = i2 - i24 >> 6;
    mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i20 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i1 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i1;
  if ((i1 | 0) == (i19 | 0)) break;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP8[i6 >> 0] | 0;
 }
 STACKTOP = i22;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i17, i15, i2, i18) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i19, i15 + 208 | 0, i2);
 i16 = HEAP32[i15 + 192 >> 2] | 0;
 L1 : do if (!i16) i1 = 0; else {
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i1 = 0;
  do {
   f14 = Math_fround(HEAPF32[i15 + 64 + (i1 << 2) >> 2]);
   if (!(f6 > f14 & (f5 > f14 & (f7 > f14 & f4 > f14)))) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i16 >>> 0);
 } while (0);
 L7 : do if (i1 >>> 0 < i16 >>> 0) {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i11 = i1;
  i12 = 0;
  i8 = -1;
  i13 = 0;
  i3 = -1;
  i10 = 0;
  i2 = -1;
  i1 = -1;
  i9 = 0;
  while (1) {
   if ((i9 & i13 & i10 & i12 | 0) <= -1) break L7;
   f4 = Math_fround(HEAPF32[i15 + 64 + (i11 << 2) >> 2]);
   i21 = HEAP32[i15 + (i11 << 2) >> 2] | 0;
   i8 = i21 & ~i12 | i12 & i8;
   i3 = i21 & ~i10 | i10 & i3;
   i2 = i21 & ~i9 | i9 & i2;
   i1 = i21 & ~i13 | i13 & i1;
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i16 >>> 0) break; else {
    i12 = (f6 < f4) << 31 >> 31;
    i13 = (f5 < f4) << 31 >> 31;
    i10 = (f7 < f4) << 31 >> 31;
    i9 = (f14 < f4) << 31 >> 31;
   }
  }
 } else {
  i8 = -1;
  i3 = -1;
  i2 = -1;
  i1 = -1;
 } while (0);
 f6 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(255.0));
 f7 = Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) * Math_fround(255.0));
 f14 = Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) * Math_fround(255.0));
 i10 = ~~Math_fround(Math_fround(HEAPF32[i18 + 12 >> 2]) * Math_fround(255.0));
 i13 = HEAP32[i19 >> 2] | 0;
 i22 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = HEAP32[i19 + 8 >> 2] | 0;
 i9 = HEAP32[i19 + 12 >> 2] | 0;
 i11 = i13 & 255;
 i15 = ~~f6 & 255;
 i12 = i13 >>> 8 & 255;
 i16 = i13 >>> 16 & 255;
 i13 = i13 >>> 24;
 i24 = i22 & 255;
 i23 = ~~f7 & 255;
 i19 = i22 >>> 8 & 255;
 i18 = i22 >>> 16 & 255;
 i22 = i22 >>> 24;
 i18 = ((Math_imul((i3 & 255) - i24 | 0, i23) | 0) + 128 >> 8) + i24 | (i19 << 8 | 128) + (Math_imul((i3 >>> 8 & 255) - i19 | 0, i23) | 0) & -256 | (((Math_imul((i3 >>> 24) - i22 | 0, i23) | 0) + 128 | 0) >>> 8) + i22 << 24 | (((Math_imul((i3 >>> 16 & 255) - i18 | 0, i23) | 0) + 128 | 0) >>> 8) + i18 << 16;
 i23 = i21 & 255;
 i3 = ~~f14 & 255;
 i22 = i21 >>> 8 & 255;
 i19 = i21 >>> 16 & 255;
 i21 = i21 >>> 24;
 i19 = ((Math_imul((i2 & 255) - i23 | 0, i3) | 0) + 128 >> 8) + i23 | (i22 << 8 | 128) + (Math_imul((i2 >>> 8 & 255) - i22 | 0, i3) | 0) & -256 | (((Math_imul((i2 >>> 24) - i21 | 0, i3) | 0) + 128 | 0) >>> 8) + i21 << 24 | (((Math_imul((i2 >>> 16 & 255) - i19 | 0, i3) | 0) + 128 | 0) >>> 8) + i19 << 16;
 i2 = i9 & 255;
 i10 = i10 & 255;
 i3 = i9 >>> 8 & 255;
 i21 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i21 = ((Math_imul((i1 & 255) - i2 | 0, i10) | 0) + 128 >> 8) + i2 | (i3 << 8 | 128) + (Math_imul((i1 >>> 8 & 255) - i3 | 0, i10) | 0) & -256 | (((Math_imul((i1 >>> 24) - i9 | 0, i10) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i1 >>> 16 & 255) - i21 | 0, i10) | 0) + 128 | 0) >>> 8) + i21 << 16;
 HEAP32[i17 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i15) | 0) + 128 >> 8) + i11 | (i12 << 8 | 128) + (Math_imul((i8 >>> 8 & 255) - i12 | 0, i15) | 0) & -256 | (((Math_imul((i8 >>> 24) - i13 | 0, i15) | 0) + 128 | 0) >>> 8) + i13 << 24 | (((Math_imul((i8 >>> 16 & 255) - i16 | 0, i15) | 0) + 128 | 0) >>> 8) + i16 << 16;
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i17 + 8 >> 2] = i19;
 HEAP32[i17 + 12 >> 2] = i21;
 STACKTOP = i20;
 return;
}

function __ZN5physx13NpVolumeCache7forEachERNS_13PxVolumeCache8IteratorE(i30, i29) {
 i30 = i30 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31;
 i10 = i31 + 81 | 0;
 i26 = i31 + 24 | 0;
 i28 = i31 + 80 | 0;
 i21 = i30 + 4 | 0;
 if ((HEAP32[i21 >> 2] | 0) == -1) {
  STACKTOP = i31;
  return;
 }
 i24 = i30 + 80 | 0;
 i5 = i30 + 112 | 0;
 i6 = i27 + 16 | 0;
 i7 = i27 + 18 | 0;
 i25 = i26 + 4 | 0;
 i11 = i26 + 8 | 0;
 i12 = i26 + 12 | 0;
 i13 = i26 + 20 | 0;
 i14 = i26 + 24 | 0;
 i15 = i26 + 28 | 0;
 i16 = i26 + 32 | 0;
 i17 = i26 + 36 | 0;
 i18 = i26 + 40 | 0;
 i19 = i26 + 44 | 0;
 i20 = i26 + 48 | 0;
 i22 = i26 + 52 | 0;
 i23 = i30 + 44 | 0;
 if (!(HEAP8[i30 + 116 >> 0] | 0)) if ((HEAP32[(HEAP32[i24 >> 2] | 0) + 20 >> 2] | 0) == (HEAP32[i30 + 108 >> 2] | 0)) i8 = 0; else i9 = 4; else i9 = 4;
 if ((i9 | 0) == 4) {
  i3 = HEAP32[i30 + 72 >> 2] | 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  HEAP16[i6 >> 1] = 1;
  HEAP8[i7 >> 0] = 0;
  i2 = i3 + 1 | 0;
  if (i2 >>> 0 < 66) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + 1568 | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = i1;
   i1 = i1 + 1040 | 0;
  } else {
   i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i10, i2 * 24 | 0, gb + 704671 | 0, 326) | 0;
   i4 = i1;
   i1 = i1 + (i2 << 4) | 0;
  }
  HEAP32[i25 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = -1;
  HEAP8[i13 >> 0] = 0;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i26 >> 2] = gb + 101548 + 8;
  HEAP32[i17 >> 2] = i30;
  HEAP32[i18 >> 2] = i29;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i20 >> 2] = i1;
  HEAP8[i22 >> 0] = 0;
  i1 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i24 >> 2] | 0) | 0;
  mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 356 >> 2] | 0, i1 | 0, i21 | 0, i23 | 0, i26 | 0, i27 | 0, 0) | 0;
  i1 = HEAP8[i22 >> 0] | 0;
  if (i3 >>> 0 > 64) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i28, i4);
  i8 = i1;
 }
 if (!(HEAP8[i30 + 117 >> 0] | 0)) if ((HEAP32[(HEAP32[i24 >> 2] | 0) + 24 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) i2 = 0; else i9 = 19; else i9 = 19;
 if ((i9 | 0) == 19) {
  i4 = HEAP32[i30 + 76 >> 2] | 0;
  HEAP32[i27 >> 2] = 0;
  HEAP32[i27 + 4 >> 2] = 0;
  HEAP32[i27 + 8 >> 2] = 0;
  HEAP32[i27 + 12 >> 2] = 0;
  HEAP16[i6 >> 1] = 2;
  HEAP8[i7 >> 0] = 0;
  i2 = i4 + 1 | 0;
  if (i2 >>> 0 < 66) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + 1568 | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i3 = i1;
   i1 = i1 + 1040 | 0;
  } else {
   i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i10, i2 * 24 | 0, gb + 704671 | 0, 326) | 0;
   i3 = i1;
   i1 = i1 + (i2 << 4) | 0;
  }
  HEAP32[i25 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = -1;
  HEAP8[i13 >> 0] = 0;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i26 >> 2] = gb + 101548 + 8;
  HEAP32[i17 >> 2] = i30;
  HEAP32[i18 >> 2] = i29;
  HEAP32[i19 >> 2] = 1;
  HEAP32[i20 >> 2] = i1;
  HEAP8[i22 >> 0] = 0;
  i2 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i24 >> 2] | 0) | 0;
  mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 356 >> 2] | 0, i2 | 0, i21 | 0, i23 | 0, i26 | 0, i27 | 0, 0) | 0;
  i2 = HEAP8[i22 >> 0] | 0;
  if (i4 >>> 0 > 64) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i28, i3);
 }
 if (!(i8 << 24 >> 24)) {
  i1 = HEAP32[i30 + 88 >> 2] | 0;
  if (i1 | 0) mftCall_viii(HEAP32[HEAP32[i29 >> 2] >> 2] | 0, i29 | 0, i1 | 0, HEAP32[i30 + 84 >> 2] | 0);
 }
 if (!(i2 << 24 >> 24)) {
  i1 = HEAP32[i30 + 100 >> 2] | 0;
  if (i1 | 0) mftCall_viii(HEAP32[HEAP32[i29 >> 2] >> 2] | 0, i29 | 0, i1 | 0, HEAP32[i30 + 96 >> 2] | 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i29 >> 2] | 0) + 4 >> 2] | 0, i29 | 0);
 STACKTOP = i31;
 return;
}

function __ZN5Umbra9RasterOps10expandBlitERNS_17BlockRasterBufferERKS1_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i14 = i8 & 255;
 i19 = HEAPU8[i1 + 1 >> 0] | 0;
 i11 = HEAP8[i1 + 2 >> 0] | 0;
 i13 = i11 & 255;
 i7 = HEAP8[i3 >> 0] | 0;
 i15 = i7 & 255;
 i5 = HEAPU8[i3 + 1 >> 0] | 0;
 i10 = HEAP8[i3 + 2 >> 0] | 0;
 i12 = i10 & 255;
 i4 = i13 - i14 | 0;
 i20 = i12 - i15 | 0;
 i9 = (HEAPU8[i3 + 3 >> 0] | 0) - i5 | 0;
 i5 = i5 - i19 | 0;
 i21 = i1 + 4 | 0;
 i6 = HEAP32[i21 >> 2] | 0;
 i2 = i6 + ((Math_imul(i9 + i5 | 0, i4) | 0) << 2) | 0;
 i1 = i6 + ((Math_imul((HEAPU8[i1 + 3 >> 0] | 0) - i19 | 0, i4) | 0) << 2) + -4 | 0;
 if (i1 >>> 0 >= i2 >>> 0) do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + -4 | 0;
 } while (i1 >>> 0 >= i2 >>> 0);
 L5 : do if ((i20 | 0) == (i4 | 0)) {
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i5 | 0) == 0 & (i6 | 0) == (i3 | 0)) return;
  i2 = Math_imul(i9, i4) | 0;
  if (i2) {
   i5 = 0 - i2 | 0;
   i4 = i2;
   i2 = i3 + (i2 << 2) | 0;
   i3 = i1;
   while (1) {
    i2 = i2 + -4 | 0;
    i4 = i4 + -1 | 0;
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    if (!i4) break; else i3 = i3 + -4 | 0;
   }
   i1 = i1 + (i5 << 2) | 0;
  }
 } else {
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + ((Math_imul(i9, i20) | 0) << 2) + -4 | 0;
  i5 = i9 + -1 | 0;
  if (i9) {
   i19 = (i20 | 0) > 0;
   i2 = (i8 & 255) < (i7 & 255);
   if ((i10 & 255) < (i11 & 255)) {
    i16 = i12 - i13 | 0;
    i17 = i12 + 1 - i13 | 0;
    i18 = i13 - i12 << 2;
    i11 = i15 - i12 | 0;
    i10 = i15 - i13 | 0;
    if (!i2) while (1) {
     _memset(i1 + (i17 << 2) | 0, 0, i18 | 0) | 0;
     i2 = i1 + (i16 << 2) | 0;
     if (i19) {
      i4 = i6 + (i11 << 2) | 0;
      i3 = 0;
      while (1) {
       HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i20 | 0)) break; else {
        i6 = i6 + -4 | 0;
        i2 = i2 + -4 | 0;
       }
      }
      i6 = i4;
      i1 = i1 + (i10 << 2) | 0;
     } else i1 = i2;
     if (!i5) break L5; else i5 = i5 + -1 | 0;
    }
    i8 = i14 - i15 | 0;
    i9 = i14 + 1 - i15 | 0;
    i7 = i15 - i14 << 2;
    while (1) {
     _memset(i1 + (i17 << 2) | 0, 0, i18 | 0) | 0;
     i2 = i1 + (i16 << 2) | 0;
     if (i19) {
      i4 = i6 + (i11 << 2) | 0;
      i3 = 0;
      while (1) {
       HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i20 | 0)) break; else {
        i6 = i6 + -4 | 0;
        i2 = i2 + -4 | 0;
       }
      }
      i6 = i4;
      i1 = i1 + (i10 << 2) | 0;
     } else i1 = i2;
     _memset(i1 + (i9 << 2) | 0, 0, i7 | 0) | 0;
     i1 = i1 + (i8 << 2) | 0;
     if (!i5) break L5; else i5 = i5 + -1 | 0;
    }
   }
   if (i2) {
    i8 = i15 - i12 | 0;
    i9 = i14 - i15 | 0;
    i10 = i14 + 1 - i15 | 0;
    i7 = i15 - i14 << 2;
    while (1) {
     if (i19) {
      i4 = i6 + (i8 << 2) | 0;
      i3 = 0;
      i2 = i1;
      while (1) {
       HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i20 | 0)) break; else {
        i6 = i6 + -4 | 0;
        i2 = i2 + -4 | 0;
       }
      }
      i6 = i4;
      i1 = i1 + (i8 << 2) | 0;
     }
     _memset(i1 + (i10 << 2) | 0, 0, i7 | 0) | 0;
     i1 = i1 + (i9 << 2) | 0;
     if (!i5) break; else i5 = i5 + -1 | 0;
    }
   } else {
    if (!i19) break;
    i8 = i15 - i12 | 0;
    i7 = i1 + (i8 << 2) + (Math_imul(i5, i15 - i12 << 2) | 0) | 0;
    while (1) {
     i2 = 0;
     i3 = i6;
     i6 = i6 + (i8 << 2) | 0;
     i4 = i1;
     while (1) {
      HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break; else {
       i3 = i3 + -4 | 0;
       i4 = i4 + -4 | 0;
      }
     }
     if (!i5) break; else {
      i1 = i1 + (i8 << 2) | 0;
      i5 = i5 + -1 | 0;
     }
    }
    i1 = i7;
    break;
   }
  }
 } while (0);
 i2 = HEAP32[i21 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) return;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + -4 | 0;
 } while (i1 >>> 0 >= i2 >>> 0);
 return;
}

function __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN30AudioEffectInternalDescriptionC2E13FMOD_DSP_TYPEPb(i7, i1, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i11 = i14 + 264 | 0;
 i12 = i14 + 8 | 0;
 i5 = i7;
 i6 = i5 + 92 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i8 = i7 + 96 | 0;
 i5 = i8;
 i6 = i5 + 108 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i3 >> 0] = 0;
 i10 = HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 if (__ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i10, i1, i11) | 0) {
  HEAP8[i3 >> 0] = 1;
  HEAP32[i4 >> 2] = i1;
  __Z6FormatPKcz(i12, gb + 873082 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 860370 | 0, 190, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 }
 i9 = i7 + 60 | 0;
 __ZN4FMOD3DSP16getNumParametersEPi(HEAP32[i11 >> 2] | 0, i9) | 0;
 __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_(HEAP32[i11 >> 2] | 0, i7, 0, 0, 0, 0) | 0;
 i5 = i7 + 128 | 0;
 i6 = (_strncmp(i7, gb + 873126 | 0, 5) | 0) == 0;
 _strncpy(i5, i7 + (i6 ? 5 : 0) | 0, 31) | 0;
 _strncpy(i7, i5, 31) | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 * 48 | 0;
 i4 = __Znaj(i5 >>> 0 > 89478485 ? -1 : i6) | 0;
 i10 = i7 + 64 | 0;
 HEAP32[i10 >> 2] = i4;
 _memset(i4 | 0, 0, i6 | 0) | 0;
 HEAP32[i8 >> 2] = 104;
 HEAP32[i7 + 100 >> 2] = 56;
 HEAP32[i7 + 116 >> 2] = i5;
 i6 = i7 + 180 | 0;
 HEAP32[i6 >> 2] = __Znaj(i5 >>> 0 > 76695844 ? -1 : i5 * 56 | 0) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i13 = i1;
  __ZN4FMOD3DSP7releaseEv(i13) | 0;
  STACKTOP = i14;
  return;
 }
 i3 = 0;
 while (1) {
  __ZN4FMOD3DSP16getParameterInfoEiPcS1_S1_iPfS2_(i1, i3, i4 + (i3 * 48 | 0) + 12 | 0, i4 + (i3 * 48 | 0) + 28 | 0, i12, 255, i4 + (i3 * 48 | 0) | 0, i4 + (i3 * 48 | 0) + 4 | 0) | 0;
  __ZN4FMOD3DSP12getParameterEiPfPci(HEAP32[i11 >> 2] | 0, i3, (HEAP32[i10 >> 2] | 0) + (i3 * 48 | 0) + 8 | 0, 0, 0) | 0;
  i5 = (_strlen(i12) | 0) + 1 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = i1 + (i3 * 48 | 0) + 28 | 0;
  if (!(_strcmp(i4, gb + 873132 | 0) | 0)) {
   HEAP8[i4 >> 0] = HEAP8[gb + 873135 >> 0] | 0;
   HEAP8[i4 + 1 >> 0] = HEAP8[gb + 873135 + 1 >> 0] | 0;
   HEAP8[i4 + 2 >> 0] = HEAP8[gb + 873135 + 2 >> 0] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i8 = __Znaj(i5) | 0;
  HEAP32[i1 + (i3 * 48 | 0) + 44 >> 2] = i8;
  _strncpy(i8, i12, i5) | 0;
  _strncpy((HEAP32[i6 >> 2] | 0) + (i3 * 56 | 0) | 0, (HEAP32[i10 >> 2] | 0) + (i3 * 48 | 0) + 12 | 0, 16) | 0;
  _strncpy((HEAP32[i6 >> 2] | 0) + (i3 * 56 | 0) + 16 | 0, (HEAP32[i10 >> 2] | 0) + (i3 * 48 | 0) + 28 | 0, 16) | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 + (i3 * 56 | 0) + 32 >> 2] = HEAP32[i8 + (i3 * 48 | 0) + 44 >> 2];
  HEAP32[i7 + (i3 * 56 | 0) + 36 >> 2] = HEAP32[i8 + (i3 * 48 | 0) >> 2];
  i5 = HEAP32[i8 + (i3 * 48 | 0) + 4 >> 2] | 0;
  HEAP32[i7 + (i3 * 56 | 0) + 40 >> 2] = i5;
  HEAP32[i7 + (i3 * 56 | 0) + 44 >> 2] = HEAP32[i8 + (i3 * 48 | 0) + 8 >> 2];
  i8 = i7 + (i3 * 56 | 0) + 16 | 0;
  i4 = (_strcmp(i8, gb + 1087751 | 0) | 0) == 0;
  i5 = i4 & (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(1.0);
  HEAPF32[i7 + (i3 * 56 | 0) + 48 >> 2] = i5 ? Math_fround(100.0) : Math_fround(1.0);
  if (!(__Z7StrICmpPKcS0_(i8, gb + 873138 | 0) | 0)) i13 = 10; else if (!(__Z7StrICmpPKcS0_((HEAP32[i6 >> 2] | 0) + (i3 * 56 | 0) + 16 | 0, gb + 873135 | 0) | 0)) i13 = 10; else f2 = Math_fround(1.0);
  if ((i13 | 0) == 10) {
   i13 = 0;
   f2 = Math_fround(3.0);
  }
  HEAPF32[(HEAP32[i6 >> 2] | 0) + (i3 * 56 | 0) + 52 >> 2] = f2;
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i3 | 0) >= (HEAP32[i9 >> 2] | 0)) break;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 __ZN4FMOD3DSP7releaseEv(i1) | 0;
 STACKTOP = i14;
 return;
}

function __ZN12FlareManager9UpdateJobEP25FlareManagerUpdateJobData(i18) {
 i18 = i18 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i27 + 48 | 0;
 i19 = i27;
 if ((HEAP16[gb + 1110800 + 6 >> 1] | 0) > -1) {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110800 | 0, i13);
  i14 = gb + 1110800 | 0;
 } else i14 = 0;
 f23 = Math_fround(HEAPF32[i18 + 204 >> 2]);
 i24 = i18 + 208 | 0;
 i25 = i18 + 200 | 0;
 if ((HEAP32[i25 >> 2] | 0) > 0) {
  i20 = i18 + 212 | 0;
  i21 = i18 + 216 | 0;
  i15 = i13 + 12 | 0;
  i16 = i13 + 16 | 0;
  i17 = i13 + 20 | 0;
  i12 = 0;
  do {
   i6 = HEAP32[i18 + (i12 << 2) >> 2] | 0;
   i22 = HEAP32[i18 + 40 + (i12 << 2) >> 2] | 0;
   i3 = i18 + 80 + (i12 * 12 | 0) | 0;
   i9 = ~HEAP32[i6 + 36 >> 2];
   f1 = Math_fround(HEAPF32[i6 + 44 >> 2]);
   if (__Z14IsWorldPlayingv() | 0) f2 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]); else f2 = Math_fround(1.0);
   f10 = Math_fround(f1 * f2);
   f11 = Math_fround(f10 * Math_fround(.5));
   i4 = (HEAP8[i6 + 48 >> 0] | 0) == 0;
   if (i4) if (Math_fround(HEAPF32[i18 + 80 + (i12 * 12 | 0) + 8 >> 2]) < f23) {
    f8 = Math_fround(HEAPF32[i3 >> 2]);
    if (f8 > Math_fround(0.0) & f8 < Math_fround(1.0)) {
     f8 = Math_fround(HEAPF32[i18 + 80 + (i12 * 12 | 0) + 4 >> 2]);
     if (f8 > Math_fround(0.0) & f8 < Math_fround(1.0)) i26 = 16; else f1 = Math_fround(0.0);
    } else f1 = Math_fround(0.0);
   } else f1 = Math_fround(0.0); else {
    f8 = Math_fround(HEAPF32[i3 >> 2]);
    if (f8 > Math_fround(0.0) & f8 < Math_fround(1.0)) {
     f8 = Math_fround(HEAPF32[i18 + 80 + (i12 * 12 | 0) + 4 >> 2]);
     if (f8 > Math_fround(0.0) & f8 < Math_fround(1.0)) i26 = 16; else f1 = Math_fround(0.0);
    } else f1 = Math_fround(0.0);
   }
   if ((i26 | 0) == 16) {
    i26 = 0;
    HEAP32[i13 >> 2] = HEAP32[i24 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
    f8 = Math_fround(HEAPF32[i6 + 16 >> 2]);
    f2 = Math_fround(HEAPF32[i6 + 20 >> 2]);
    f1 = Math_fround(HEAPF32[i6 + 24 >> 2]);
    if (i4) {
     f29 = Math_fround(HEAPF32[i24 >> 2]);
     f31 = Math_fround(f29 - f8);
     f30 = Math_fround(HEAPF32[i20 >> 2]);
     f7 = Math_fround(f30 - f2);
     f5 = Math_fround(HEAPF32[i21 >> 2]);
     f28 = Math_fround(f5 - f1);
     f28 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f7 * f7)) + Math_fround(f28 * f28))));
     f7 = f28;
     f5 = Math_fround(Math_fround(f1 - f5) / f28);
     f2 = Math_fround(Math_fround(f2 - f30) / f28);
     f1 = Math_fround(Math_fround(f8 - f29) / f28);
    } else {
     f7 = Math_fround(1.0e4);
     f5 = Math_fround(-f1);
     f2 = Math_fround(-f2);
     f1 = Math_fround(-f8);
    }
    HEAPF32[i15 >> 2] = f1;
    HEAPF32[i16 >> 2] = f2;
    HEAPF32[i17 >> 2] = f5;
    i3 = __Z19GetRaycastInterfacev() | 0;
    if (!i3) f1 = Math_fround(1.0); else {
     i9 = mftCall_iiifiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i13 | 0, +f7, i9 | 0, 0, i19 | 0) | 0;
     f1 = i9 ? Math_fround(0.0) : Math_fround(1.0);
    }
   }
   f2 = Math_fround(HEAPF32[i22 >> 2]);
   if (f1 > f2) {
    f31 = Math_fround(f10 + f2);
    HEAPF32[i22 >> 2] = f31;
    if (f31 > Math_fround(1.0)) HEAPF32[i22 >> 2] = Math_fround(1.0);
   } else if (f1 < f2) {
    f31 = Math_fround(f2 - f11);
    HEAPF32[i22 >> 2] = f31;
    if (f31 < Math_fround(0.0)) HEAPF32[i22 >> 2] = Math_fround(0.0);
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) < (HEAP32[i25 >> 2] | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i18, gb + 64024 | 0);
 if (!i14) {
  STACKTOP = i27;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i27;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i16, i17, i18, i19) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21;
 i15 = HEAP32[i17 + 400 >> 2] | 0;
 L1 : do if (!i15) i1 = 0; else {
  f6 = Math_fround(HEAPF32[i18 >> 2]);
  f3 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  i1 = 0;
  do {
   f14 = Math_fround(HEAPF32[i17 + 272 + (i1 << 2) >> 2]);
   if (!(f5 > f14 & (f4 > f14 & (f6 > f14 & f3 > f14)))) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i15 >>> 0);
 } while (0);
 L7 : do if (i1 >>> 0 < i15 >>> 0) {
  f4 = Math_fround(HEAPF32[i18 >> 2]);
  f5 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  i11 = i1;
  i12 = 0;
  i8 = -1;
  i13 = 0;
  i7 = -1;
  i10 = 0;
  i2 = -1;
  i1 = -1;
  i9 = 0;
  while (1) {
   if ((i9 & i13 & i10 & i12 | 0) <= -1) break L7;
   f3 = Math_fround(HEAPF32[i17 + 272 + (i11 << 2) >> 2]);
   i22 = HEAP32[i17 + 208 + (i11 << 2) >> 2] | 0;
   i8 = i22 & ~i12 | i12 & i8;
   i7 = i22 & ~i10 | i10 & i7;
   i2 = i22 & ~i9 | i9 & i2;
   i1 = i22 & ~i13 | i13 & i1;
   i11 = i11 + 1 | 0;
   if (i11 >>> 0 >= i15 >>> 0) break; else {
    i12 = (f4 < f3) << 31 >> 31;
    i13 = (f14 < f3) << 31 >> 31;
    i10 = (f5 < f3) << 31 >> 31;
    i9 = (f6 < f3) << 31 >> 31;
   }
  }
 } else {
  i8 = -1;
  i7 = -1;
  i2 = -1;
  i1 = -1;
 } while (0);
 __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i20, i17, i18);
 f5 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * Math_fround(255.0));
 f6 = Math_fround(Math_fround(HEAPF32[i19 + 4 >> 2]) * Math_fround(255.0));
 f14 = Math_fround(Math_fround(HEAPF32[i19 + 8 >> 2]) * Math_fround(255.0));
 i10 = ~~Math_fround(Math_fround(HEAPF32[i19 + 12 >> 2]) * Math_fround(255.0));
 i15 = HEAP32[i20 >> 2] | 0;
 i24 = HEAP32[i20 + 4 >> 2] | 0;
 i22 = HEAP32[i20 + 8 >> 2] | 0;
 i9 = HEAP32[i20 + 12 >> 2] | 0;
 i11 = i8 & 255;
 i17 = ~~f5 & 255;
 i12 = i8 >>> 8 & 255;
 i18 = i8 >>> 16 & 255;
 i13 = i8 >>> 24;
 i20 = i7 & 255;
 i23 = ~~f6 & 255;
 i8 = i7 >>> 8 & 255;
 i19 = i7 >>> 16 & 255;
 i7 = i7 >>> 24;
 i19 = ((Math_imul((i24 & 255) - i20 | 0, i23) | 0) + 128 >> 8) + i20 | (Math_imul((i24 >>> 8 & 255) - i8 | 0, i23) | 0) + (i8 << 8 | 128) & -256 | (((Math_imul((i24 >>> 24) - i7 | 0, i23) | 0) + 128 | 0) >>> 8) + i7 << 24 | (((Math_imul((i24 >>> 16 & 255) - i19 | 0, i23) | 0) + 128 | 0) >>> 8) + i19 << 16;
 i23 = i2 & 255;
 i7 = ~~f14 & 255;
 i8 = i2 >>> 8 & 255;
 i20 = i2 >>> 16 & 255;
 i2 = i2 >>> 24;
 i20 = ((Math_imul((i22 & 255) - i23 | 0, i7) | 0) + 128 >> 8) + i23 | (Math_imul((i22 >>> 8 & 255) - i8 | 0, i7) | 0) + (i8 << 8 | 128) & -256 | (((Math_imul((i22 >>> 24) - i2 | 0, i7) | 0) + 128 | 0) >>> 8) + i2 << 24 | (((Math_imul((i22 >>> 16 & 255) - i20 | 0, i7) | 0) + 128 | 0) >>> 8) + i20 << 16;
 i2 = i1 & 255;
 i10 = i10 & 255;
 i7 = i1 >>> 8 & 255;
 i22 = i1 >>> 16 & 255;
 i8 = i1 >>> 24;
 i22 = ((Math_imul((i9 & 255) - i2 | 0, i10) | 0) + 128 >> 8) + i2 | (Math_imul((i9 >>> 8 & 255) - i7 | 0, i10) | 0) + (i7 << 8 | 128) & -256 | (((Math_imul((i9 >>> 24) - i8 | 0, i10) | 0) + 128 | 0) >>> 8) + i8 << 24 | (((Math_imul((i9 >>> 16 & 255) - i22 | 0, i10) | 0) + 128 | 0) >>> 8) + i22 << 16;
 HEAP32[i16 >> 2] = ((Math_imul((i15 & 255) - i11 | 0, i17) | 0) + 128 >> 8) + i11 | (Math_imul((i15 >>> 8 & 255) - i12 | 0, i17) | 0) + (i12 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i13 | 0, i17) | 0) + 128 | 0) >>> 8) + i13 << 24 | (((Math_imul((i15 >>> 16 & 255) - i18 | 0, i17) | 0) + 128 | 0) >>> 8) + i18 << 16;
 HEAP32[i16 + 4 >> 2] = i19;
 HEAP32[i16 + 8 >> 2] = i20;
 HEAP32[i16 + 12 >> 2] = i22;
 STACKTOP = i21;
 return;
}

function __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK15TerrainRenderer17CreateMeshPatchesER13dynamic_arrayIP4MeshLj4EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20;
 i14 = i20 + 32 | 0;
 i15 = i20 + 24 | 0;
 i16 = i20 + 12 | 0;
 i17 = i12 + 72 | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i19 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
   i2 = HEAP32[i14 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i19 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i19 = 8;
  }
 }
 if ((i19 | 0) == 6) i19 = 8;
 if ((i19 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i17 >> 2] | 0) | 0;
 i10 = i1 + 248 | 0;
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 i11 = 1 << i1;
 i2 = i11 << i1;
 i3 = i13 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i13 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i13 >> 2] = i9;
  break;
 } while (0);
 if ((i1 | 0) == 31) {
  STACKTOP = i20;
  return;
 }
 i9 = i16 + 11 | 0;
 i8 = 0;
 i1 = 0;
 do {
  i7 = 0;
  do {
   i5 = __Z15GetMeshForPatchiiiR9HeightmapPK15TerrainRenderer(i7, i8, 0, i10, i12) | 0;
   i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i19 = 22; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i2, i15);
     i3 = HEAP32[i14 >> 2] | 0;
     i21 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i21 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i21 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i19 = 22; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i19 = 23;
    }
   }
   if ((i19 | 0) == 22) i19 = 23;
   if ((i19 | 0) == 23) {
    i19 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i17 >> 2] | 0) | 0;
   }
   HEAP32[i18 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
   HEAP32[i18 + 4 >> 2] = i7;
   HEAP32[i18 + 8 >> 2] = i8;
   __Z6FormatPKcz(i16, gb + 935464 | 0, i18);
   mftCall_vii(i6 | 0, i5 | 0, ((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   i21 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i21 << 2) >> 2] = i5;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (i11 | 0));
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i11 | 0));
 STACKTOP = i20;
 return;
}

function __ZN5Umbra11ShadowUtils13getClipPlanesERKNS_9Matrix4x4EPNS_7Vector4ERb(i2, i9, i8) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var f1 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0, i22 = 0;
 f14 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 i21 = i2 + 32 | 0;
 i19 = i2 + 36 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i18 = i2 + 40 | 0;
 i22 = HEAP32[i18 >> 2] | 0;
 i17 = i2 + 44 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i21 >> 2];
 i3 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = i9 + 8 | 0;
 HEAP32[i4 >> 2] = i22;
 HEAP32[i9 + 12 >> 2] = i10;
 f5 = Math_fround(HEAPF32[i21 >> 2]);
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f5 = Math_fround(f14 - f5);
 f6 = Math_fround(f16 - f6);
 f7 = Math_fround(f15 - f7);
 f20 = Math_fround(f1 - Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i9 + 16 >> 2] = f5;
 HEAPF32[i9 + 20 >> 2] = f6;
 HEAPF32[i9 + 24 >> 2] = f7;
 HEAPF32[i9 + 28 >> 2] = f20;
 f20 = Math_fround(HEAPF32[i2 >> 2]);
 i17 = i2 + 4 | 0;
 f11 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i2 + 8 | 0;
 f12 = Math_fround(HEAPF32[i18 >> 2]);
 i19 = i2 + 12 | 0;
 f11 = Math_fround(f16 - f11);
 f12 = Math_fround(f15 - f12);
 f13 = Math_fround(f1 - Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i9 + 32 >> 2] = Math_fround(f14 - f20);
 HEAPF32[i9 + 36 >> 2] = f11;
 HEAPF32[i9 + 40 >> 2] = f12;
 HEAPF32[i9 + 44 >> 2] = f13;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f11 = Math_fround(HEAPF32[i18 >> 2]);
 f12 = Math_fround(f16 + f12);
 f11 = Math_fround(f15 + f11);
 f20 = Math_fround(f1 + Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i9 + 48 >> 2] = Math_fround(f14 + f13);
 HEAPF32[i9 + 52 >> 2] = f12;
 HEAPF32[i9 + 56 >> 2] = f11;
 HEAPF32[i9 + 60 >> 2] = f20;
 i19 = i2 + 16 | 0;
 f20 = Math_fround(HEAPF32[i19 >> 2]);
 i18 = i2 + 20 | 0;
 f11 = Math_fround(HEAPF32[i18 >> 2]);
 i17 = i2 + 24 | 0;
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 i2 = i2 + 28 | 0;
 f11 = Math_fround(f16 - f11);
 f12 = Math_fround(f15 - f12);
 f13 = Math_fround(f1 - Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i9 + 64 >> 2] = Math_fround(f14 - f20);
 HEAPF32[i9 + 68 >> 2] = f11;
 HEAPF32[i9 + 72 >> 2] = f12;
 HEAPF32[i9 + 76 >> 2] = f13;
 f13 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(HEAPF32[i18 >> 2]);
 f11 = Math_fround(HEAPF32[i17 >> 2]);
 f12 = Math_fround(f16 + f12);
 f11 = Math_fround(f15 + f11);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i9 + 80 >> 2] = Math_fround(f14 + f13);
 HEAPF32[i9 + 84 >> 2] = f12;
 HEAPF32[i9 + 88 >> 2] = f11;
 HEAPF32[i9 + 92 >> 2] = f1;
 i2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)))) > Math_fround(0.0);
 f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i2) {
  f16 = Math_fround(HEAPF32[i9 >> 2]);
  f20 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = Math_fround(Math_fround(Math_fround(f5 * f16) + Math_fround(f6 * f20)) + Math_fround(f7 * Math_fround(HEAPF32[i4 >> 2]))) < Math_fround(0.0) & 1;
 } else i2 = 0;
 HEAP8[i8 >> 0] = i2;
 i3 = 0;
 while (1) {
  i21 = i9 + (i3 << 4) | 0;
  f13 = Math_fround(HEAPF32[i21 >> 2]);
  f14 = Math_fround(f13 * f13);
  i22 = i9 + (i3 << 4) + 4 | 0;
  f15 = Math_fround(HEAPF32[i22 >> 2]);
  f14 = Math_fround(f14 + Math_fround(f15 * f15));
  i2 = i9 + (i3 << 4) + 8 | 0;
  f16 = Math_fround(HEAPF32[i2 >> 2]);
  f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f14 + Math_fround(f16 * f16)))));
  f15 = Math_fround(f15 * f14);
  f16 = Math_fround(f16 * f14);
  f20 = Math_fround(f14 * f1);
  HEAPF32[i21 >> 2] = Math_fround(f13 * f14);
  HEAPF32[i22 >> 2] = f15;
  HEAPF32[i2 >> 2] = f16;
  HEAPF32[i9 + (i3 << 4) + 12 >> 2] = f20;
  i2 = i3 + 1 | 0;
  if ((i2 | 0) == 6) break;
  i3 = i2;
  f1 = Math_fround(HEAPF32[i9 + (i2 << 4) + 12 >> 2]);
 }
 return;
}

function __ZN5physx8CCDSweepINS_2Gu11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_11ConvexHullVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5Unity11Adjacencies4InitEPKtPKji(i8, i5, i6, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i10 = i8 + 12 | 0;
 HEAP32[i10 >> 2] = i1;
 i4 = __Znaj(i1 >>> 0 > 178956970 ? -1 : i1 * 24 | 0) | 0;
 i11 = i8 + 16 | 0;
 HEAP32[i11 >> 2] = i4;
 i3 = i1 * 3 | 0;
 i3 = __Znaj(i3 >>> 0 > 357913941 ? -1 : i3 * 12 | 0) | 0;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = i3;
 if (!i1) {
  i11 = __ZN5Unity11Adjacencies14CreateDatabaseEv(i8) | 0;
  return i11 | 0;
 }
 i7 = i8 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i5) {
  i1 = 0;
  while (1) {
   i13 = i1 * 3 | 0;
   i15 = HEAP32[i6 + (i13 << 2) >> 2] | 0;
   i12 = HEAP32[i6 + (i13 + 1 << 2) >> 2] | 0;
   i13 = HEAP32[i6 + (i13 + 2 << 2) >> 2] | 0;
   HEAP32[i4 + (i2 * 24 | 0) >> 2] = i15;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 4 >> 2] = i12;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 8 >> 2] = i13;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 16 >> 2] = -1;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 20 >> 2] = -1;
   i4 = i15 >>> 0 < i12 >>> 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i3 + (i2 * 12 | 0) >> 2] = i4 ? i15 : i12;
   HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] = i4 ? i12 : i15;
   HEAP32[i3 + (i2 * 12 | 0) + 8 >> 2] = i5;
   i5 = i2 + 1 | 0;
   i4 = i15 >>> 0 < i13 >>> 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i14 = HEAP32[i9 >> 2] | 0;
   HEAP32[i14 + (i5 * 12 | 0) >> 2] = i4 ? i15 : i13;
   HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2] = i4 ? i13 : i15;
   HEAP32[i14 + (i5 * 12 | 0) + 8 >> 2] = i3;
   i5 = i2 + 2 | 0;
   i14 = i12 >>> 0 < i13 >>> 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   HEAP32[i4 + (i5 * 12 | 0) >> 2] = i14 ? i12 : i13;
   HEAP32[i4 + (i5 * 12 | 0) + 4 >> 2] = i14 ? i13 : i12;
   HEAP32[i4 + (i5 * 12 | 0) + 8 >> 2] = i3;
   HEAP32[i8 >> 2] = i2 + 3;
   i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   HEAP32[i7 >> 2] = i2;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break;
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  }
  i15 = __ZN5Unity11Adjacencies14CreateDatabaseEv(i8) | 0;
  return i15 | 0;
 } else {
  i1 = 0;
  while (1) {
   i12 = i1 * 3 | 0;
   i16 = HEAP16[i5 + (i12 << 1) >> 1] | 0;
   i6 = HEAP16[i5 + (i12 + 1 << 1) >> 1] | 0;
   i12 = HEAP16[i5 + (i12 + 2 << 1) >> 1] | 0;
   HEAP32[i4 + (i2 * 24 | 0) >> 2] = i16 & 65535;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 4 >> 2] = i6 & 65535;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 8 >> 2] = i12 & 65535;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 16 >> 2] = -1;
   HEAP32[i4 + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 20 >> 2] = -1;
   i15 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i3 + (i2 * 12 | 0) >> 2] = ((i16 & 65535) < (i6 & 65535) ? i16 : i6) & 65535;
   HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] = ((i16 & 65535) > (i6 & 65535) ? i16 : i6) & 65535;
   HEAP32[i3 + (i2 * 12 | 0) + 8 >> 2] = i15;
   i15 = i2 + 1 | 0;
   i14 = HEAP32[i7 >> 2] | 0;
   i13 = HEAP32[i9 >> 2] | 0;
   HEAP32[i13 + (i15 * 12 | 0) >> 2] = ((i16 & 65535) < (i12 & 65535) ? i16 : i12) & 65535;
   HEAP32[i13 + (i15 * 12 | 0) + 4 >> 2] = ((i16 & 65535) > (i12 & 65535) ? i16 : i12) & 65535;
   HEAP32[i13 + (i15 * 12 | 0) + 8 >> 2] = i14;
   i15 = i2 + 2 | 0;
   i13 = HEAP32[i7 >> 2] | 0;
   i14 = HEAP32[i9 >> 2] | 0;
   HEAP32[i14 + (i15 * 12 | 0) >> 2] = ((i6 & 65535) < (i12 & 65535) ? i6 : i12) & 65535;
   HEAP32[i14 + (i15 * 12 | 0) + 4 >> 2] = ((i6 & 65535) > (i12 & 65535) ? i6 : i12) & 65535;
   HEAP32[i14 + (i15 * 12 | 0) + 8 >> 2] = i13;
   HEAP32[i8 >> 2] = i2 + 3;
   i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   HEAP32[i7 >> 2] = i2;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break;
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  }
  i16 = __ZN5Unity11Adjacencies14CreateDatabaseEv(i8) | 0;
  return i16 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_127SphereMeshContactGeneration10addContactERKN5physx6PxVec3Efj(i6, i3, f1, i20) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i20 = i20 | 0;
 var f2 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f21 = f0;
 if (f1 > Math_fround(.0000999999974)) {
  f19 = Math_fround(Math_sqrt(Math_fround(f1)));
  f5 = Math_fround(Math_fround(1.0) / f19);
  f1 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
  f2 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 4 >> 2]));
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 } else {
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f2 = Math_fround(f5 * f5);
  f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f4 * f4));
  f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f1 * f1));
  if (f2 > Math_fround(0.0)) {
   f19 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
   f1 = Math_fround(f1 * f19);
   f2 = Math_fround(f4 * f19);
   f4 = Math_fround(f5 * f19);
  } else {
   f1 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f4 = Math_fround(0.0);
  }
  f5 = Math_fround(-f1);
  f2 = Math_fround(-f2);
  f1 = Math_fround(-f4);
  f19 = Math_fround(0.0);
 }
 i8 = HEAP32[i6 + 8 >> 2] | 0;
 f9 = Math_fround(f1 * Math_fround(2.0));
 f10 = Math_fround(f2 * Math_fround(2.0));
 f11 = Math_fround(f5 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f13 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(f9 * f14);
 f15 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f10 * f15));
 f16 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f11 * f16));
 i3 = HEAP32[i6 + 16 >> 2] | 0;
 f18 = Math_fround(HEAPF32[(HEAP32[i6 >> 2] | 0) + 4 >> 2]);
 f1 = Math_fround(f1 * f18);
 f2 = Math_fround(f2 * f18);
 f4 = Math_fround(f5 * f18);
 f1 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f1);
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f1 = Math_fround(f1 * Math_fround(2.0));
 f2 = Math_fround(f2 * Math_fround(2.0));
 f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i3 + 8 >> 2])) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(Math_fround(f14 * f1) + Math_fround(f15 * f2)) + Math_fround(f16 * f4));
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = i3 + 4096 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (i7 >>> 0 > 63) return;
 f19 = Math_fround(f19 - f18);
 f18 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f12 * Math_fround(Math_fround(f14 * f2) - Math_fround(f15 * f1)))) + Math_fround(f16 * f5)) + Math_fround(HEAPF32[i8 + 24 >> 2]));
 f21 = Math_fround(Math_fround(Math_fround(f15 * f5) + Math_fround(Math_fround(f13 * f2) + Math_fround(f12 * Math_fround(Math_fround(f16 * f1) - Math_fround(f14 * f4))))) + Math_fround(HEAPF32[i8 + 20 >> 2]));
 f5 = Math_fround(Math_fround(Math_fround(f14 * f5) + Math_fround(Math_fround(f13 * f1) + Math_fround(f12 * Math_fround(Math_fround(f15 * f4) - Math_fround(f16 * f2))))) + Math_fround(HEAPF32[i8 + 16 >> 2]));
 f4 = Math_fround(-Math_fround(Math_fround(Math_fround(f11 * f13) + Math_fround(f12 * Math_fround(Math_fround(f10 * f14) - Math_fround(f9 * f15)))) + Math_fround(f16 * f17)));
 f2 = Math_fround(-Math_fround(Math_fround(f15 * f17) + Math_fround(Math_fround(f10 * f13) + Math_fround(f12 * Math_fround(Math_fround(f9 * f16) - Math_fround(f11 * f14))))));
 f17 = Math_fround(-Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f9 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f15) - Math_fround(f10 * f16))))));
 HEAP32[i6 >> 2] = i7 + 1;
 HEAPF32[i3 + (i7 << 6) >> 2] = f17;
 HEAPF32[i3 + (i7 << 6) + 4 >> 2] = f2;
 HEAPF32[i3 + (i7 << 6) + 8 >> 2] = f4;
 HEAPF32[i3 + (i7 << 6) + 16 >> 2] = f5;
 HEAPF32[i3 + (i7 << 6) + 20 >> 2] = f21;
 HEAPF32[i3 + (i7 << 6) + 24 >> 2] = f18;
 HEAPF32[i3 + (i7 << 6) + 12 >> 2] = f19;
 HEAP32[i3 + (i7 << 6) + 48 >> 2] = -1;
 HEAP32[i3 + (i7 << 6) + 52 >> 2] = i20;
 return;
}

function __ZN12_GLOBAL__N_121PrismaticJointProjectEPKvRN5physx11PxTransformES4_b(i21, i16, i17, i22) {
 i21 = i21 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i22 = i22 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i24 + 84 | 0;
 i20 = i24 + 56 | 0;
 i19 = i24 + 28 | 0;
 i23 = i24;
 __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i21, i16, i17, i18, i20, i19);
 f1 = Math_fround(HEAPF32[i19 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i19 + 24 >> 2]);
 i15 = i23 + 16 | 0;
 f5 = Math_fround(HEAPF32[i21 + 100 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(0.0)) + Math_fround(f3 * f3));
 i14 = f4 > Math_fround(f5 * f5);
 if (i14) {
  f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f13 = Math_fround(f5 * Math_fround(f12 * Math_fround(0.0)));
  f1 = Math_fround(f5 * Math_fround(f1 * f12));
  f3 = Math_fround(f5 * Math_fround(f3 * f12));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 } else i2 = 0;
 HEAP32[i15 >> 2] = i2;
 HEAPF32[i23 + 20 >> 2] = f1;
 HEAPF32[i23 + 24 >> 2] = f3;
 f12 = Math_fround(Math_fround(HEAPF32[i21 + 104 >> 2]) * Math_fround(.5));
 f11 = Math_fround(+Math_sin(+f12));
 f12 = Math_fround(+Math_cos(+f12));
 do if (f11 > Math_fround(.999899983)) {
  i9 = HEAP32[i19 >> 2] | 0;
  i8 = HEAP32[i19 + 4 >> 2] | 0;
  i7 = HEAP32[i19 + 8 >> 2] | 0;
  i6 = HEAP32[i19 + 12 >> 2] | 0;
  i2 = 0;
 } else {
  f13 = Math_fround(HEAPF32[i19 + 12 >> 2]);
  if (!(f13 >= Math_fround(0.0))) {
   f3 = Math_fround(HEAPF32[i19 >> 2]);
   f26 = Math_fround(-f3);
   f4 = Math_fround(HEAPF32[i19 + 4 >> 2]);
   f25 = Math_fround(-f4);
   f5 = Math_fround(HEAPF32[i19 + 8 >> 2]);
   f1 = Math_fround(-f5);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i2 = HEAP32[i19 >> 2] | 0;
   i6 = HEAP32[i19 + 4 >> 2] | 0;
   i7 = HEAP32[i19 + 8 >> 2] | 0;
   i8 = i6;
   i9 = i2;
   i10 = i7;
  }
  f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(f5 * f5);
  f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f4 * f4) + f3);
  f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f1 * f1) + f3);
  i10 = f3 > Math_fround(f11 * f11);
  i2 = i10 & 1;
  if (i10) {
   f26 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
   f13 = Math_fround(Math_fround(f11 * f5) * f26);
   f25 = Math_fround(Math_fround(f11 * f4) * f26);
   f26 = Math_fround(Math_fround(f11 * f1) * f26);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
   i7 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  } else {
   i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 } while (0);
 HEAP32[i23 >> 2] = i9;
 HEAP32[i23 + 4 >> 2] = i8;
 HEAP32[i23 + 8 >> 2] = i7;
 HEAP32[i23 + 12 >> 2] = i6;
 if (i2 << 24 >> 24 == 0 & (i14 ^ 1)) {
  STACKTOP = i24;
  return;
 }
 HEAP32[i15 >> 2] = HEAP32[i19 + 16 >> 2];
 __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i16, i17, i18, i20, i23, i21, i22);
 STACKTOP = i24;
 return;
}

function __ZN7mecanim9animation11xformPrePowERKN4math4trsXEi(i19, i1, i23) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, f22 = f0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i24 = i19 + 28 | 0;
 i25 = i19 + 24 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i19 + 16 >> 2] = 0;
 HEAP32[i19 + 20 >> 2] = 0;
 HEAP32[i25 >> 2] = 1065353216;
 HEAP32[i24 >> 2] = 1065353216;
 i26 = i19 + 32 | 0;
 HEAP32[i26 >> 2] = 1065353216;
 i27 = i19 + 36 | 0;
 HEAP32[i27 >> 2] = 1065353216;
 if ((i23 | 0) <= 0) return;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i28 = i19 + 16 | 0;
 i29 = i19 + 20 | 0;
 i15 = i19 + 4 | 0;
 i16 = i19 + 8 | 0;
 f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i4 = i19 + 12 | 0;
 i1 = 0;
 f2 = Math_fround(0.0);
 f8 = Math_fround(0.0);
 f9 = Math_fround(0.0);
 f10 = Math_fround(1.0);
 f11 = Math_fround(0.0);
 f12 = Math_fround(0.0);
 f13 = Math_fround(0.0);
 do {
  f37 = Math_fround(f8 * Math_fround(-2.0));
  f31 = Math_fround(f8 * Math_fround(2.0));
  f35 = Math_fround(f37 * f10);
  f30 = Math_fround(f11 * Math_fround(2.0));
  f34 = Math_fround(f11 * Math_fround(-2.0));
  f38 = Math_fround(f10 * f34);
  f33 = Math_fround(f9 * Math_fround(-2.0));
  f36 = Math_fround(f9 * Math_fround(2.0));
  f32 = Math_fround(f10 * f33);
  f2 = Math_fround(f2 + Math_fround(Math_fround(f14 + Math_fround(f14 * Math_fround(Math_fround(f8 * f37) - Math_fround(f11 * f30)))) + Math_fround(Math_fround(f18 * Math_fround(Math_fround(f36 * f11) - f35)) + Math_fround(f17 * Math_fround(f38 - Math_fround(f8 * f33))))));
  f12 = Math_fround(f12 + Math_fround(Math_fround(f17 + Math_fround(f14 * Math_fround(Math_fround(f9 * f31) - f38))) + Math_fround(Math_fround(f18 * Math_fround(f32 - Math_fround(f37 * f11))) + Math_fround(f17 * Math_fround(Math_fround(f11 * f34) - Math_fround(f9 * f36))))));
  f13 = Math_fround(f13 + Math_fround(Math_fround(f18 + Math_fround(f14 * Math_fround(f35 - Math_fround(f9 * f34)))) + Math_fround(Math_fround(f18 * Math_fround(Math_fround(f9 * f33) - Math_fround(f8 * f31))) + Math_fround(f17 * Math_fround(Math_fround(f8 * f30) - f32)))));
  f32 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f20) - Math_fround(f10 * f3)) - Math_fround(f11 * f21)) - Math_fround(f9 * f22));
  f30 = f10;
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f21) - Math_fround(f9 * f20)) - Math_fround(f11 * f3)) - Math_fround(f8 * f22));
  f31 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f22) - Math_fround(f8 * f3)) - Math_fround(f30 * f20)) - Math_fround(f9 * f21));
  f30 = Math_fround(Math_fround(Math_fround(Math_fround(f9 * f3) - Math_fround(f11 * f20)) - Math_fround(f30 * f22)) - Math_fround(f8 * f21));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f32, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f31, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = i5 ^ -2147483648;
  i6 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i7 = i7 ^ -2147483648;
  i1 = i1 + 1 | 0;
  f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i1 | 0) != (i23 | 0));
 HEAP32[i4 >> 2] = i5;
 HEAP32[i28 >> 2] = i6;
 HEAP32[i29 >> 2] = i7;
 HEAPF32[i25 >> 2] = f10;
 HEAPF32[i19 >> 2] = f2;
 HEAPF32[i15 >> 2] = f12;
 HEAPF32[i16 >> 2] = f13;
 HEAP32[i24 >> 2] = 1065353216;
 HEAP32[i26 >> 2] = 1065353216;
 HEAP32[i27 >> 2] = 1065353216;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 1);
 i2 = i3 + 28 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 464003 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450814 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450831 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 76 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450844 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450863 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450898 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450932 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450962 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i7 = i9 + 32 | 0;
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i9 + 36 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i11 = i10 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 52 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 58 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 2);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 56 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 2);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 84 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 48 | 0, i10);
 i1 = i9 + 80 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  STACKTOP = i13;
  return;
 }
}

function __ZN37RotationBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 617454 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617454 + 30 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617485 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617485 + 30 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617516 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617516 + 34 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617551 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617551 + 29 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617581 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617581 + 29 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function runPostSets182() {
 HEAP32[gb + 155524 >> 2] = fb + 113;
 HEAP32[gb + 155528 >> 2] = fb + 131;
 HEAP32[gb + 155532 >> 2] = fb + 111;
 HEAP32[gb + 155536 >> 2] = fb + 112;
 HEAP32[gb + 155540 >> 2] = fb + 113;
 HEAP32[gb + 155544 >> 2] = fb + 2317;
 HEAP32[gb + 155548 >> 2] = fb + 2318;
 HEAP32[gb + 155552 >> 2] = fb + 2384;
 HEAP32[gb + 155556 >> 2] = fb + 1668;
 HEAP32[gb + 155560 >> 2] = fb + 1059;
 HEAP32[gb + 155564 >> 2] = fb + 1060;
 HEAP32[gb + 155568 >> 2] = fb + 1576;
 HEAP32[gb + 155572 >> 2] = fb + 1577;
 HEAP32[gb + 155584 >> 2] = (HEAP32[gb + 155584 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 155588 >> 2] = (HEAP32[gb + 155588 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 155624 >> 2] = fb + 2385;
 HEAP32[gb + 155628 >> 2] = fb + 2386;
 HEAP32[gb + 155632 >> 2] = fb + 38;
 HEAP32[gb + 155636 >> 2] = fb + 1669;
 HEAP32[gb + 155640 >> 2] = fb + 16;
 HEAP32[gb + 155644 >> 2] = fb + 2387;
 HEAP32[gb + 155648 >> 2] = fb + 2388;
 HEAP32[gb + 155652 >> 2] = fb + 19;
 HEAP32[gb + 155656 >> 2] = fb + 1082;
 HEAP32[gb + 155660 >> 2] = fb + 103;
 HEAP32[gb + 155664 >> 2] = fb + 101;
 HEAP32[gb + 155668 >> 2] = fb + 62;
 HEAP32[gb + 155672 >> 2] = fb + 28;
 HEAP32[gb + 155676 >> 2] = fb + 63;
 HEAP32[gb + 155680 >> 2] = fb + 29;
 HEAP32[gb + 155684 >> 2] = fb + 34;
 HEAP32[gb + 155688 >> 2] = fb + 1670;
 HEAP32[gb + 155692 >> 2] = fb + 1671;
 HEAP32[gb + 155696 >> 2] = fb + 1672;
 HEAP32[gb + 155700 >> 2] = fb + 1673;
 HEAP32[gb + 155704 >> 2] = fb + 1674;
 HEAP32[gb + 155708 >> 2] = fb + 1675;
 HEAP32[gb + 155712 >> 2] = fb + 36;
 HEAP32[gb + 155716 >> 2] = fb + 104;
 HEAP32[gb + 155720 >> 2] = fb + 108;
 HEAP32[gb + 155724 >> 2] = fb + 94;
 HEAP32[gb + 155728 >> 2] = fb + 1574;
 HEAP32[gb + 155732 >> 2] = fb + 112;
 HEAP32[gb + 155736 >> 2] = fb + 113;
 HEAP32[gb + 155740 >> 2] = fb + 131;
 HEAP32[gb + 155744 >> 2] = fb + 111;
 HEAP32[gb + 155748 >> 2] = fb + 112;
 HEAP32[gb + 155752 >> 2] = fb + 113;
 HEAP32[gb + 155756 >> 2] = fb + 2317;
 HEAP32[gb + 155760 >> 2] = fb + 2318;
 HEAP32[gb + 155764 >> 2] = fb + 2389;
 HEAP32[gb + 155768 >> 2] = fb + 1575;
 HEAP32[gb + 155772 >> 2] = fb + 1059;
 HEAP32[gb + 155776 >> 2] = fb + 1060;
 HEAP32[gb + 155780 >> 2] = fb + 1576;
 HEAP32[gb + 155784 >> 2] = fb + 1577;
 HEAP32[gb + 155796 >> 2] = (HEAP32[gb + 155796 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 155800 >> 2] = (HEAP32[gb + 155800 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 155836 >> 2] = fb + 2390;
 HEAP32[gb + 155840 >> 2] = fb + 2391;
 HEAP32[gb + 155844 >> 2] = fb + 38;
 HEAP32[gb + 155848 >> 2] = fb + 1676;
 HEAP32[gb + 155852 >> 2] = fb + 16;
 HEAP32[gb + 155856 >> 2] = fb + 2392;
 HEAP32[gb + 155860 >> 2] = fb + 2393;
 HEAP32[gb + 155864 >> 2] = fb + 19;
 HEAP32[gb + 155868 >> 2] = fb + 1083;
 HEAP32[gb + 155872 >> 2] = fb + 103;
 HEAP32[gb + 155876 >> 2] = fb + 101;
 HEAP32[gb + 155880 >> 2] = fb + 62;
 HEAP32[gb + 155884 >> 2] = fb + 28;
 HEAP32[gb + 155888 >> 2] = fb + 63;
 HEAP32[gb + 155892 >> 2] = fb + 29;
 HEAP32[gb + 155896 >> 2] = fb + 34;
 HEAP32[gb + 155900 >> 2] = fb + 1677;
 HEAP32[gb + 155904 >> 2] = fb + 1678;
 HEAP32[gb + 155908 >> 2] = fb + 1679;
 HEAP32[gb + 155912 >> 2] = fb + 1680;
 HEAP32[gb + 155916 >> 2] = fb + 1681;
 HEAP32[gb + 155920 >> 2] = fb + 1682;
 HEAP32[gb + 155924 >> 2] = fb + 36;
 HEAP32[gb + 155928 >> 2] = fb + 104;
 HEAP32[gb + 155932 >> 2] = fb + 108;
 HEAP32[gb + 155936 >> 2] = fb + 94;
 HEAP32[gb + 155940 >> 2] = fb + 1574;
 HEAP32[gb + 155944 >> 2] = fb + 112;
 HEAP32[gb + 155948 >> 2] = fb + 113;
 HEAP32[gb + 155952 >> 2] = fb + 131;
 HEAP32[gb + 155956 >> 2] = fb + 111;
 HEAP32[gb + 155960 >> 2] = fb + 112;
 HEAP32[gb + 155964 >> 2] = fb + 113;
 HEAP32[gb + 155968 >> 2] = fb + 2317;
 HEAP32[gb + 155972 >> 2] = fb + 2318;
 HEAP32[gb + 155976 >> 2] = fb + 2394;
 HEAP32[gb + 155980 >> 2] = fb + 1683;
 HEAP32[gb + 155984 >> 2] = fb + 1059;
 HEAP32[gb + 155988 >> 2] = fb + 1060;
 HEAP32[gb + 155992 >> 2] = fb + 1576;
 HEAP32[gb + 155996 >> 2] = fb + 1577;
 HEAP32[gb + 156008 >> 2] = (HEAP32[gb + 156008 >> 2] | 0) + (gb + 1047948 | 0);
 runPostSets183();
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EEPS1_(i11, i12, i10) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i14 = i12 + 4 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 if ((i7 | 0) == (i10 | 0)) i1 = i15; else {
  i8 = i13 + 4 | 0;
  i6 = i10;
  i1 = i15;
  do {
   i3 = i1 + -16 | 0;
   i2 = i6;
   i6 = i6 + -16 | 0;
   i5 = HEAP8[i6 + 11 >> 0] | 0;
   i9 = i5 << 24 >> 24 < 0;
   i4 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
   i5 = i9 ? HEAP32[i2 + -12 >> 2] | 0 : i5 & 255;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + -4 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
    i2 = HEAP32[i1 + -4 >> 2] | 0;
    i16 = 6;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i3 + 11 >> 0] = i5;
    if (!i5) i1 = i3; else {
     i1 = i3;
     i16 = 8;
    }
   } else i16 = 6;
   if ((i16 | 0) == 6) {
    i18 = i5 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i3 >> 2] = i9;
    HEAP32[i1 + -8 >> 2] = i18 | -2147483648;
    HEAP32[i1 + -12 >> 2] = i5;
    i1 = i9;
    i16 = 8;
   }
   if ((i16 | 0) == 8) {
    i16 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i1 = (HEAP32[i14 >> 2] | 0) + -16 | 0;
   HEAP32[i14 >> 2] = i1;
  } while ((i6 | 0) != (i7 | 0));
 }
 i7 = i11 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i12 + 8 | 0;
 if ((i8 | 0) == (i10 | 0)) {
  i18 = i14;
  i16 = i1;
  i13 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i16;
  HEAP32[i18 >> 2] = i13;
  i13 = HEAP32[i7 >> 2] | 0;
  i16 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 >> 2] = i16;
  HEAP32[i9 >> 2] = i13;
  i13 = i11 + 8 | 0;
  i16 = i12 + 12 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i11 = HEAP32[i16 >> 2] | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i16 >> 2] = i14;
  i18 = HEAP32[i18 >> 2] | 0;
  HEAP32[i12 >> 2] = i18;
  STACKTOP = i17;
  return i15 | 0;
 }
 i6 = i13 + 4 | 0;
 i4 = i10;
 i1 = HEAP32[i9 >> 2] | 0;
 do {
  i5 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
  i5 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i16 = 16;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i16 = 18;
  } else i16 = 16;
  if ((i16 | 0) == 16) {
   i10 = i5 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i18;
   HEAP32[i1 + 8 >> 2] = i10 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i18;
   i16 = 18;
  }
  if ((i16 | 0) == 18) {
   i16 = 0;
   _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  i4 = i4 + 16 | 0;
  i1 = (HEAP32[i9 >> 2] | 0) + 16 | 0;
  HEAP32[i9 >> 2] = i1;
 } while ((i4 | 0) != (i8 | 0));
 i18 = i14;
 i16 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i16;
 HEAP32[i18 >> 2] = i13;
 i13 = HEAP32[i7 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i9 >> 2] = i13;
 i13 = i11 + 8 | 0;
 i16 = i12 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i16 >> 2] = i14;
 i18 = HEAP32[i18 >> 2] | 0;
 HEAP32[i12 >> 2] = i18;
 STACKTOP = i17;
 return i15 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i17, i5, i1) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i4 = i16 + 8 | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[HEAP32[i3 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i4) | 0)) {
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i14 = HEAP32[i5 + 8 >> 2] | 0;
  i14 = mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, 1) | 0;
  _memset(i14 | 0, 0, i1 | 0) | 0;
  i1 = i14 | 0 ? i14 - i2 | 0 : 0;
 }
 HEAP32[i2 >> 2] = i1;
 i14 = HEAP32[i5 >> 2] | 0;
 i14 = (HEAP32[i14 >> 2] | 0) + i14 + (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i8 = HEAP32[gb + 36976 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L11 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i12 = 11; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i12 = 11; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 11) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L11;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags(i17, i5, i1) {
 i17 = i17 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i4 = i16 + 8 | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[HEAP32[i3 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i4) | 0)) {
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i14 = HEAP32[i5 + 8 >> 2] | 0;
  i14 = mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, 1) | 0;
  _memset(i14 | 0, 0, i1 | 0) | 0;
  i1 = i14 | 0 ? i14 - i2 | 0 : 0;
 }
 HEAP32[i2 >> 2] = i1;
 i14 = HEAP32[i5 >> 2] | 0;
 i14 = (HEAP32[i14 >> 2] | 0) + i14 + (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i8 = HEAP32[gb + 36972 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L11 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i12 = 11; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i12 = 11; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 11) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L11;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ES2_RKNS_19PxVehicleEngineDataES6_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i18, i1, i17, i16) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 277 | 0;
 i13 = i15 + 276 | 0;
 i11 = i15 + 224 | 0;
 i14 = i15 + 112 | 0;
 i12 = i15;
 i1 = HEAP32[i18 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i18 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i9 = HEAP32[i18 + 20 >> 2] | 0;
    i9 = (mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i9;
    i1 = HEAP32[i18 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i9;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i9 = HEAP32[i18 >> 2] | 0;
   HEAP8[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i18 + 36 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = i18 + 24 | 0;
 mftCall_vii(HEAP32[i17 + 16 >> 2] | 0, i14 | 0, HEAP32[i1 >> 2] | 0);
 i8 = HEAP32[i18 >> 2] | 0;
 i7 = HEAP32[i18 + 4 >> 2] | 0;
 i2 = HEAP32[i18 + 20 >> 2] | 0;
 i4 = HEAP32[i18 + 28 >> 2] | 0;
 i5 = HEAP32[i18 + 32 >> 2] | 0;
 HEAP8[i13 >> 0] = 0;
 i3 = i14;
 i6 = i13;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i7;
 i7 = i11 + 8 | 0;
 i8 = i18 + 8 | 0;
 i9 = i7 + 12 | 0;
 do {
  HEAP8[i7 >> 0] = HEAP8[i8 >> 0] | 0;
  i7 = i7 + 1 | 0;
  i8 = i8 + 1 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i11 + 20 >> 2] = i2;
 HEAP32[i11 + 24 >> 2] = i3;
 HEAP32[i11 + 28 >> 2] = i4;
 HEAP32[i11 + 32 >> 2] = i5;
 HEAP8[i11 + 36 >> 0] = 1;
 HEAP32[i11 + 40 >> 2] = i6;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i11, 2, i16 + 24 | 0, i10);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 52 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 68 | 0, 4);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 84 | 0, 5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 100 | 0, 6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 116 | 0, 7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i16 + 132 | 0, 8);
 if (HEAP8[i13 >> 0] | 0) HEAP8[HEAP32[i18 + 40 >> 2] >> 0] = 1;
 i18 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i14 + 64 >> 2] | 0;
 _memcpy(i12 | 0, i14 | 0, i16 << 3 | 0) | 0;
 HEAP32[i12 + 64 >> 2] = i16;
 i16 = i12 + 80 | 0;
 i14 = i14 + 80 | 0;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 mftCall_vii(HEAP32[i17 + 20 >> 2] | 0, i18 | 0, i12 | 0);
 STACKTOP = i15;
 return;
}

function __ZN35ClampVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 613832 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613832 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 613861 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613861 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 613890 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613890 + 28 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 613919 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613919 + 29 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 613949 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 613949 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN14PlayerSettingsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 64368 + 8;
 i1 = i2 + 604 | 0;
 if ((HEAP32[i2 + 620 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 608 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 588 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 600 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 572 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 584 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 556 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 568 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 540 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 552 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 524 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 536 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 488 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 500 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 472 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 484 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 456 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 468 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 340 | 0;
 if ((HEAP32[i2 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 344 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 216 | 0;
 if ((HEAP32[i2 + 232 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 220 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 128 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 140 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 124 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 96 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 108 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 76 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 44 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  HEAP32[i2 >> 2] = gb + 28648 + 8;
  HEAP32[i2 >> 2] = gb + 28496 + 8;
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 HEAP32[i2 >> 2] = gb + 28648 + 8;
 HEAP32[i2 >> 2] = gb + 28496 + 8;
 STACKTOP = i4;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E13find_positionERS9_(i29, i6, i30) {
 i29 = i29 | 0;
 i6 = i6 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0;
 i31 = (HEAP32[i6 + 56 >> 2] | 0) + -1 | 0;
 i4 = HEAP8[i30 + 11 >> 0] | 0;
 i32 = i4 << 24 >> 24 < 0;
 i5 = HEAP32[i30 >> 2] | 0;
 i28 = i32 ? i5 : i30;
 i1 = HEAP8[i28 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i3 = i28;
  i2 = 5381;
  do {
   i3 = i3 + 1 | 0;
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i21 = i6 + 32 | 0;
 i22 = HEAP32[i6 + 52 >> 2] | 0;
 i24 = HEAP8[i21 + 11 >> 0] | 0;
 i23 = i24 << 24 >> 24 < 0;
 i24 = i24 & 255;
 i25 = i23 ? HEAP32[i6 + 36 >> 2] | 0 : i24;
 i26 = (i25 | 0) == 0;
 i27 = i6 + 8 | 0;
 i18 = i4 & 255;
 i19 = i32 ? HEAP32[i30 + 4 >> 2] | 0 : i18;
 i20 = (i19 | 0) == 0;
 i14 = i5 & 255;
 i15 = i6 + 4 | 0;
 i16 = i6 + 12 | 0;
 i17 = i16 + 11 | 0;
 i13 = i6 + 16 | 0;
 i11 = 0;
 i12 = -1;
 L5 : while (1) {
  i10 = i2 & i31;
  i7 = i22 + (i10 * 20 | 0) | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i22 + (i10 * 20 | 0) + 4 >> 2] | 0 : i9 & 255;
  do if ((i25 | 0) == (i9 | 0)) {
   i2 = HEAP32[i21 >> 2] | 0;
   i3 = i23 ? i2 : i21;
   i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
   if (i23) {
    if (i26) break L5;
    if (!(_memcmp(i3, i1, i25) | 0)) break L5; else break;
   }
   if (i26) break L5;
   if ((i2 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i2 = i21;
    i3 = i24;
    do {
     i3 = i3 + -1 | 0;
     i2 = i2 + 1 | 0;
     if (!i3) break L5;
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  } while (0);
  L18 : do if (!(HEAP8[i27 >> 0] | 0)) i33 = 26; else if (!(HEAP32[i15 >> 2] | 0)) i33 = 26; else {
   i2 = HEAP8[i17 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   i2 = i2 & 255;
   if (((i3 ? HEAP32[i13 >> 2] | 0 : i2) | 0) == (i9 | 0)) {
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i3 ? i4 : i16;
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    i6 = (i9 | 0) == 0;
    L22 : do if (i3) {
     if (!i6) if (_memcmp(i5, i1, i9) | 0) {
      i33 = 26;
      break L18;
     }
    } else if (!i6) {
     if ((i4 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i3 = i16; else {
      i33 = 26;
      break L18;
     }
     while (1) {
      i2 = i2 + -1 | 0;
      i3 = i3 + 1 | 0;
      if (!i2) break L22;
      i1 = i1 + 1 | 0;
      if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i33 = 26;
       break L18;
      }
     }
    } while (0);
    i1 = (i12 | 0) == -1 ? i10 : i12;
   } else i33 = 26;
  } while (0);
  do if ((i33 | 0) == 26) {
   i33 = 0;
   if ((i19 | 0) == (i9 | 0)) {
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    if (i32) {
     if (i20) {
      i33 = 34;
      break L5;
     }
     if (!(_memcmp(i28, i1, i19) | 0)) {
      i33 = 34;
      break L5;
     } else {
      i1 = i12;
      break;
     }
    }
    if (i20) {
     i33 = 34;
     break L5;
    }
    if (i14 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
     i2 = i30;
     i3 = i18;
     while (1) {
      i3 = i3 + -1 | 0;
      i2 = i2 + 1 | 0;
      if (!i3) {
       i33 = 34;
       break L5;
      }
      i1 = i1 + 1 | 0;
      if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i1 = i12;
       break;
      }
     }
    } else i1 = i12;
   } else i1 = i12;
  } while (0);
  i2 = i11 + 1 | 0;
  i11 = i2;
  i12 = i1;
  i2 = i2 + i10 | 0;
 }
 if ((i33 | 0) == 34) {
  HEAP32[i29 >> 2] = i10;
  HEAP32[i29 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i29 >> 2] = -1;
 i1 = i29 + 4 | 0;
 if ((i12 | 0) == -1) {
  HEAP32[i1 >> 2] = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = i12;
  return;
 }
}

function __ZN5physx8CCDSweepINS_2Gu8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN33SizeBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 617719 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617719 + 30 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617750 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617750 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617777 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617777 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617804 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617804 + 25 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617830 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617830 + 25 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 4;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZL30GeomOverlapCallback_CapsuleBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i3, i2, i4, i5, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 32 | 0;
 i11 = i13 + 56 | 0;
 i14 = i13 + 16 | 0;
 i10 = i13;
 f24 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(f24 * Math_fround(2.0));
 f26 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f21 = Math_fround(f26 * Math_fround(2.0));
 f26 = Math_fround(Math_fround(f24 * f18) + Math_fround(Math_fround(f26 * f21) + Math_fround(-1.0)));
 f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f19 = Math_fround(f24 * f21);
 f20 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f18 * f20));
 f20 = Math_fround(Math_fround(f18 * f24) - Math_fround(f21 * f20));
 f21 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(f21 * f26);
 f19 = Math_fround(f21 * f19);
 f20 = Math_fround(f21 * f20);
 f21 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f24 = Math_fround(f21 + f26);
 f18 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f25 = Math_fround(f18 + f19);
 f16 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f23 = Math_fround(f20 + f16);
 HEAPF32[i12 >> 2] = f24;
 i15 = i12 + 4 | 0;
 HEAPF32[i15 >> 2] = f25;
 i2 = i12 + 8 | 0;
 HEAPF32[i2 >> 2] = f23;
 f19 = Math_fround(f18 - f19);
 f20 = Math_fround(f16 - f20);
 HEAPF32[i12 + 12 >> 2] = Math_fround(f21 - f26);
 i6 = i12 + 16 | 0;
 HEAPF32[i6 >> 2] = f19;
 i7 = i12 + 20 | 0;
 HEAPF32[i7 >> 2] = f20;
 i8 = i5 + 16 | 0;
 i9 = i4 + 4 | 0;
 HEAP32[i11 + 36 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i11 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i11 + 48 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 52 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i11 + 56 >> 2] = HEAP32[i4 + 12 >> 2];
 f20 = Math_fround(HEAPF32[i5 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f26 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f16 = Math_fround(f20 + f20);
 f18 = Math_fround(f19 + f19);
 f23 = Math_fround(f26 + f26);
 f25 = Math_fround(f19 * f18);
 f24 = Math_fround(f26 * f23);
 f19 = Math_fround(f16 * f19);
 f27 = Math_fround(f16 * f26);
 f17 = Math_fround(f16 * f21);
 f26 = Math_fround(f18 * f26);
 f18 = Math_fround(f18 * f21);
 f21 = Math_fround(f23 * f21);
 f23 = Math_fround(f19 + f21);
 f22 = Math_fround(f27 - f18);
 f21 = Math_fround(f19 - f21);
 f16 = Math_fround(Math_fround(1.0) - Math_fround(f20 * f16));
 f20 = Math_fround(f16 - f24);
 f19 = Math_fround(f26 + f17);
 f18 = Math_fround(f27 + f18);
 f17 = Math_fround(f26 - f17);
 f16 = Math_fround(f16 - f25);
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f25) - f24);
 HEAPF32[i11 + 4 >> 2] = f23;
 HEAPF32[i11 + 8 >> 2] = f22;
 HEAPF32[i11 + 12 >> 2] = f21;
 HEAPF32[i11 + 16 >> 2] = f20;
 HEAPF32[i11 + 20 >> 2] = f19;
 HEAPF32[i11 + 24 >> 2] = f18;
 HEAPF32[i11 + 28 >> 2] = f17;
 HEAPF32[i11 + 32 >> 2] = f16;
 i3 = i3 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i14 + 12 >> 2] = i1;
 if (__ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i14, i11) | 0) {
  i15 = 1;
  STACKTOP = i13;
  return i15 | 0;
 }
 i2 = i12 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 12 >> 2] = i1;
 if (__ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i10, i11) | 0) {
  i15 = 1;
  STACKTOP = i13;
  return i15 | 0;
 }
 f26 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i12, i2, i8, i9, i11, 0, 0));
 f27 = Math_fround(HEAPF32[i3 >> 2]);
 i15 = f26 <= Math_fround(f27 * f27);
 STACKTOP = i13;
 return i15 | 0;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i2, i12) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i3 = i2;
 i5 = i12 - i3 | 0;
 i7 = (i5 | 0) / 52 | 0;
 i11 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i8;
 if (i7 >>> 0 <= ((i1 - i8 | 0) / 52 | 0) >>> 0) {
  i6 = i10 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i8 | 0) / 52 | 0;
  i5 = i7 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 52 | 0) | 0;
  i4 = i5 ? i1 : i12;
  i3 = i4 - i3 | 0;
  if (i3 | 0) _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i9 + (((i3 | 0) / 52 | 0) * 52 | 0) | 0;
  if (!i5) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -52 - i2 | 0) >>> 0) / 52 | 0) * 52 | 0);
   STACKTOP = i13;
   return;
  }
  if ((i4 | 0) == (i12 | 0)) {
   STACKTOP = i13;
   return;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i9 = i1;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i11 = i2 + 32 | 0;
   i10 = i1 + 32 | 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
   i1 = i1 + 52 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 52 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 }
 i4 = i8;
 if (i8) {
  i1 = i10 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -52 - i8 | 0) >>> 0) / 52 | 0) * 52 | 0);
  i9 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 16;
  HEAP32[i6 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i9 = (i1 - i3 | 0) / 52 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 16;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 52 | 0, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 * 52 | 0);
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i9 = i2;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  i11 = i1 + 32 | 0;
  i10 = i2 + 32 | 0;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  i2 = i2 + 52 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 52 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 STACKTOP = i13;
 return;
}

function __ZN13SpringJoint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i10 = i6 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803035 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i5 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i10, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803059 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 15; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 15; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 15) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803283 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 26; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 26; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 26) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853582 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i7 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i7 >>> 0) i8 = 37; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 37; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 37) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 3) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i10 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function runPostSets223() {
 HEAP32[gb + 189672 >> 2] = fb + 2965;
 HEAP32[gb + 189676 >> 2] = fb + 2239;
 HEAP32[gb + 189680 >> 2] = fb + 2240;
 HEAP32[gb + 189692 >> 2] = fb + 2966;
 HEAP32[gb + 189696 >> 2] = fb + 2967;
 HEAP32[gb + 189700 >> 2] = (HEAP32[gb + 189700 >> 2] | 0) + (gb + 1044481 | 0);
 HEAP32[gb + 189704 >> 2] = (HEAP32[gb + 189704 >> 2] | 0) + (gb + 1044494 | 0);
 HEAP32[gb + 189708 >> 2] = (HEAP32[gb + 189708 >> 2] | 0) + (gb + 1044508 | 0);
 HEAP32[gb + 189720 >> 2] = fb + 1383;
 HEAP32[gb + 189724 >> 2] = fb + 1384;
 HEAP32[gb + 189728 >> 2] = fb + 290;
 HEAP32[gb + 189732 >> 2] = fb + 2968;
 HEAP32[gb + 189736 >> 2] = fb + 2969;
 HEAP32[gb + 189748 >> 2] = fb + 2970;
 HEAP32[gb + 189752 >> 2] = fb + 2971;
 HEAP32[gb + 189756 >> 2] = fb + 80;
 HEAP32[gb + 189760 >> 2] = fb + 39;
 HEAP32[gb + 189764 >> 2] = fb + 16;
 HEAP32[gb + 189768 >> 2] = fb + 39;
 HEAP32[gb + 189772 >> 2] = fb + 40;
 HEAP32[gb + 189776 >> 2] = fb + 19;
 HEAP32[gb + 189780 >> 2] = fb + 1385;
 HEAP32[gb + 189784 >> 2] = fb + 99;
 HEAP32[gb + 189788 >> 2] = fb + 40;
 HEAP32[gb + 189792 >> 2] = fb + 62;
 HEAP32[gb + 189796 >> 2] = fb + 28;
 HEAP32[gb + 189800 >> 2] = fb + 63;
 HEAP32[gb + 189804 >> 2] = fb + 29;
 HEAP32[gb + 189808 >> 2] = fb + 34;
 HEAP32[gb + 189812 >> 2] = fb + 2241;
 HEAP32[gb + 189816 >> 2] = fb + 2242;
 HEAP32[gb + 189820 >> 2] = fb + 2243;
 HEAP32[gb + 189824 >> 2] = fb + 2244;
 HEAP32[gb + 189828 >> 2] = fb + 2245;
 HEAP32[gb + 189832 >> 2] = fb + 2246;
 HEAP32[gb + 189836 >> 2] = fb + 36;
 HEAP32[gb + 189840 >> 2] = fb + 96;
 HEAP32[gb + 189844 >> 2] = fb + 81;
 HEAP32[gb + 189848 >> 2] = fb + 82;
 HEAP32[gb + 189860 >> 2] = (HEAP32[gb + 189860 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 189864 >> 2] = (HEAP32[gb + 189864 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 189900 >> 2] = fb + 2247;
 HEAP32[gb + 189904 >> 2] = fb + 2248;
 HEAP32[gb + 189908 >> 2] = fb + 2972;
 HEAP32[gb + 189912 >> 2] = fb + 2973;
 HEAP32[gb + 189916 >> 2] = fb + 2249;
 HEAP32[gb + 189928 >> 2] = fb + 2250;
 HEAP32[gb + 189932 >> 2] = fb + 2974;
 HEAP32[gb + 189936 >> 2] = fb + 2975;
 HEAP32[gb + 189948 >> 2] = fb + 2251;
 HEAP32[gb + 189952 >> 2] = fb + 469;
 HEAP32[gb + 189956 >> 2] = fb + 2976;
 HEAP32[gb + 189960 >> 2] = fb + 1386;
 HEAP32[gb + 189964 >> 2] = fb + 1387;
 HEAP32[gb + 189968 >> 2] = fb + 1388;
 HEAP32[gb + 189972 >> 2] = fb + 2977;
 HEAP32[gb + 189976 >> 2] = fb + 1389;
 HEAP32[gb + 189980 >> 2] = fb + 2978;
 HEAP32[gb + 189984 >> 2] = fb + 1390;
 HEAP32[gb + 189988 >> 2] = fb + 2252;
 HEAP32[gb + 189992 >> 2] = fb + 470;
 HEAP32[gb + 189996 >> 2] = fb + 472;
 HEAP32[gb + 19e4 >> 2] = fb + 473;
 HEAP32[gb + 190004 >> 2] = fb + 2979;
 HEAP32[gb + 190008 >> 2] = fb + 2980;
 HEAP32[gb + 190012 >> 2] = fb + 1391;
 HEAP32[gb + 190016 >> 2] = fb + 1392;
 HEAP32[gb + 190028 >> 2] = fb + 2251;
 HEAP32[gb + 190032 >> 2] = fb + 469;
 HEAP32[gb + 190036 >> 2] = fb + 1;
 HEAP32[gb + 190040 >> 2] = fb + 1;
 HEAP32[gb + 190044 >> 2] = fb + 1;
 HEAP32[gb + 190048 >> 2] = fb + 1;
 HEAP32[gb + 190052 >> 2] = fb + 1;
 HEAP32[gb + 190056 >> 2] = fb + 1393;
 HEAP32[gb + 190060 >> 2] = fb + 2981;
 HEAP32[gb + 190064 >> 2] = fb + 1;
 HEAP32[gb + 190068 >> 2] = fb + 2252;
 HEAP32[gb + 190072 >> 2] = fb + 470;
 HEAP32[gb + 190076 >> 2] = fb + 472;
 HEAP32[gb + 190080 >> 2] = fb + 473;
 HEAP32[gb + 190084 >> 2] = fb + 2982;
 HEAP32[gb + 190088 >> 2] = fb + 2983;
 HEAP32[gb + 190092 >> 2] = fb + 1;
 HEAP32[gb + 190096 >> 2] = fb + 1;
 HEAP32[gb + 190108 >> 2] = fb + 2984;
 HEAP32[gb + 190112 >> 2] = fb + 2985;
 HEAP32[gb + 190116 >> 2] = fb + 291;
 HEAP32[gb + 190120 >> 2] = fb + 2253;
 HEAP32[gb + 190124 >> 2] = fb + 2986;
 HEAP32[gb + 190128 >> 2] = fb + 2987;
 HEAP32[gb + 190132 >> 2] = fb + 1394;
 HEAP32[gb + 190136 >> 2] = fb + 1395;
 HEAP32[gb + 190140 >> 2] = fb + 2988;
 HEAP32[gb + 190144 >> 2] = fb + 474;
 HEAP32[gb + 190156 >> 2] = fb + 2914;
 HEAP32[gb + 190160 >> 2] = fb + 2989;
 HEAP32[gb + 190164 >> 2] = fb + 2220;
 HEAP32[gb + 190176 >> 2] = fb + 2990;
 HEAP32[gb + 190180 >> 2] = fb + 2991;
 runPostSets224();
}

function __ZN13RendererScene19AddRendererInternalEP8RendereriRK4AABB(i12, i1, i8, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 i9 = i12 + 60 | 0;
 i10 = i12 + 72 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i6 = (i1 | 0) == 0 ? 0 : i1 + 32 | 0;
 i2 = i13 + 1 | 0;
 i3 = i12 + 76 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 * 24 | 0, 4, i12 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i12 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i9 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i2;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i2 + (i13 * 24 | 0) >> 2] = i6;
 HEAP32[i2 + (i13 * 24 | 0) + 4 >> 2] = i8;
 HEAP32[i2 + (i13 * 24 | 0) + 8 >> 2] = -1;
 i3 = i2 + (i13 * 24 | 0) + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i2 + (i13 * 24 | 0) + 20 >> 0] = 0;
 i2 = i2 + (i13 * 24 | 0) + 21 | 0;
 HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[i7 + 2 >> 0] | 0;
 i2 = i12 + 80 | 0;
 i3 = i12 + 92 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 96 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i12 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i12 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + (i4 * 24 | 0) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + (i4 * 24 | 0) + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i2 + (i4 * 24 | 0) + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i2 + (i4 * 24 | 0) + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i2 + (i4 * 24 | 0) + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i2 + (i4 * 24 | 0) + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 i2 = i12 + 100 | 0;
 i3 = i12 + 112 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 116 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i12 = HEAP32[i2 >> 2] | 0;
  i12 = i12 + i4 | 0;
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i12 = HEAP32[i2 >> 2] | 0;
  i12 = i12 + i4 | 0;
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i12 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i12 = HEAP32[i2 >> 2] | 0;
  i12 = i12 + i4 | 0;
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i14;
  return i13 | 0;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i3 >> 2] = i5;
  i12 = HEAP32[i2 >> 2] | 0;
  i12 = i12 + i4 | 0;
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 return 0;
}

function __ZNSt3__214__scan_keywordIPwPNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SC_SB_SB_RKT1_Rjb(i13, i14, i1, i18, i15, i19, i16) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i20;
 i4 = (i18 - i1 | 0) / 12 | 0;
 do if (i4 >>> 0 > 100) {
  i3 = _malloc(i4) | 0;
  if (!i3) {
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  }
  i2 = i3;
  i17 = i3;
  i5 = 6;
 } else {
  i17 = 0;
  i5 = 6;
 } while (0);
 if ((i5 | 0) == 6) {
  i6 = i1;
  i7 = i2;
  i3 = 0;
  while (1) {
   if ((i6 | 0) == (i18 | 0)) break;
   i5 = HEAP8[i6 + 8 + 3 >> 0] | 0;
   if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
   if (!i5) {
    HEAP8[i7 >> 0] = 2;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else HEAP8[i7 >> 0] = 1;
   i6 = i6 + 12 | 0;
   i7 = i7 + 1 | 0;
  }
  i11 = 0;
  i5 = i3;
  L21 : while (1) {
   i3 = HEAP32[i13 >> 2] | 0;
   if (!((i4 | 0) != 0 & (i3 | 0) != (i14 | 0))) {
    i5 = 17;
    break;
   }
   i3 = HEAP32[i3 >> 2] | 0;
   if (!i16) {
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i3 | 0) | 0;
    i12 = __THREW__;
    __THREW__ = 0;
    if (i12 & 1) {
     i5 = 20;
     break;
    }
   }
   i12 = i11 + 1 | 0;
   i8 = i1;
   i7 = 0;
   i9 = i2;
   i10 = i5;
   while (1) {
    if ((i8 | 0) == (i18 | 0)) break;
    do if ((HEAP8[i9 >> 0] | 0) == 1) {
     i6 = i8 + 8 + 3 | 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
     i5 = HEAP32[i5 + (i11 << 2) >> 2] | 0;
     if (!i16) {
      __THREW__ = 0;
      i5 = invoke_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i5 = 30;
       break L21;
      }
     }
     if ((i3 | 0) != (i5 | 0)) {
      HEAP8[i9 >> 0] = 0;
      i5 = i7;
      i6 = i10;
      i4 = i4 + -1 | 0;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i8 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) == (i12 | 0)) {
      HEAP8[i9 >> 0] = 2;
      i5 = 1;
      i6 = i10 + 1 | 0;
      i4 = i4 + -1 | 0;
     } else {
      i5 = 1;
      i6 = i10;
     }
    } else {
     i5 = i7;
     i6 = i10;
    } while (0);
    i8 = i8 + 12 | 0;
    i7 = i5;
    i9 = i9 + 1 | 0;
    i10 = i6;
   }
   if (!i7) {
    i11 = i12;
    i5 = i10;
    continue;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
   if ((i10 + i4 | 0) >>> 0 > 1) {
    i6 = i1;
    i7 = i2;
    i3 = i10;
   } else {
    i11 = i12;
    i5 = i10;
    continue;
   }
   while (1) {
    if ((i6 | 0) == (i18 | 0)) {
     i11 = i12;
     i5 = i3;
     continue L21;
    }
    if ((HEAP8[i7 >> 0] | 0) == 2) {
     i5 = HEAP8[i6 + 8 + 3 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) != (i12 | 0)) {
      HEAP8[i7 >> 0] = 0;
      i3 = i3 + -1 | 0;
     }
    }
    i6 = i6 + 12 | 0;
    i7 = i7 + 1 | 0;
   }
  }
  if ((i5 | 0) == 17) {
   if ((i3 | 0) == (i14 | 0)) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
   while (1) {
    if ((i1 | 0) == (i18 | 0)) {
     i5 = 52;
     break;
    }
    if ((HEAP8[i2 >> 0] | 0) == 2) break;
    i1 = i1 + 12 | 0;
    i2 = i2 + 1 | 0;
   }
   if ((i5 | 0) == 52) {
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 4;
    i1 = i18;
   }
   if (i17 | 0) _free(i17);
   STACKTOP = i20;
   return i1 | 0;
  } else if ((i5 | 0) == 20) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i5 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  if (i17) _free(i17);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN5physx8CCDSweepINS_2Gu4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f(i4, i6, i5, i14, i15, i9, i13, i12, i10, i11, i7, f8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i1 = i16 + 16 | 0;
 i3 = i16;
 if (!(__ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i4, i6, i5, i9, i13, i12, i2, i3, i1, f8, 1) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f29 = Math_fround(HEAPF32[i15 >> 2]);
 f31 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f30 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f28 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = f28 > Math_fround(0.0);
 f28 = i12 ? f28 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 i12 = i14 + 4 | 0;
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 i13 = i14 + 8 | 0;
 f22 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i14 + 12 | 0;
 f20 = Math_fround(HEAPF32[i15 >> 2]);
 f27 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f26 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f17 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * f19)) + Math_fround(f22 * f24));
 f21 = Math_fround(Math_fround(f31 * f28) + Math_fround(f21 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f25 * f19) + Math_fround(f20 * Math_fround(Math_fround(f22 * f23) - Math_fround(f8 * f24))))) * Math_fround(2.0))));
 f26 = Math_fround(Math_fround(f30 * f28) + Math_fround(f26 + Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f20 * Math_fround(Math_fround(f8 * f19) - Math_fround(f18 * f23)))) + Math_fround(f22 * f17)) * Math_fround(2.0))));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f29 * f28) + Math_fround(f27 + Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(Math_fround(f25 * f23) + Math_fround(f20 * Math_fround(Math_fround(f18 * f24) - Math_fround(f22 * f19))))) * Math_fround(2.0))));
 HEAPF32[i7 + 4 >> 2] = f21;
 HEAPF32[i7 + 8 >> 2] = f26;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 f26 = Math_fround(HEAPF32[i14 >> 2]);
 f21 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f22 * f22) + Math_fround(-.5));
 f25 = Math_fround(Math_fround(Math_fround(f26 * f24) + Math_fround(f21 * f18)) + Math_fround(f19 * f20));
 f17 = Math_fround(Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f23 * f18) + Math_fround(f22 * Math_fround(Math_fround(f19 * f24) - Math_fround(f26 * f20))))) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * Math_fround(Math_fround(f26 * f18) - Math_fround(f21 * f24)))) + Math_fround(f19 * f25)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18))))) * Math_fround(2.0));
 HEAPF32[i11 + 4 >> 2] = f17;
 HEAPF32[i11 + 8 >> 2] = f8;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5Unity10HingeJoint8TransferI14SafeBinaryReadEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_(i6, i7);
 i3 = i6 + 158 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 736317 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i6 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 738014 | 0, gb + 827201 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI11JointSpringE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i6 + 157 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 803251 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i6 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 803262 | 0, gb + 736329 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10JointMotorE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i6 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 802926 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 736340 | 0, gb + 736349 | 0, i5, 1) | 0;
 if (!i1) {
  __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i6, i7);
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN11JointLimits8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i6, i7);
 STACKTOP = i8;
 return;
}

function __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i3 = i8 + 4 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN11DetailPatch8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 136 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i2;
  i3 = i4;
 }
 i4 = i8 + 44 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j(i4, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i4 >> 2] | 0, i1 * 12 | 0);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 60 | 0, i9);
 i1 = i8 + 76 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i8 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i8 + 32 >> 2] | 0, i9);
 i3 = i8 + 104 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 108 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i29, i6, i30) {
 i29 = i29 | 0;
 i6 = i6 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0;
 i31 = (HEAP32[i6 + 56 >> 2] | 0) + -1 | 0;
 i4 = HEAP8[i30 + 11 >> 0] | 0;
 i32 = i4 << 24 >> 24 < 0;
 i5 = HEAP32[i30 >> 2] | 0;
 i28 = i32 ? i5 : i30;
 i1 = HEAP8[i28 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i3 = i28;
  i2 = 5381;
  do {
   i3 = i3 + 1 | 0;
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i21 = i6 + 32 | 0;
 i22 = HEAP32[i6 + 52 >> 2] | 0;
 i24 = HEAP8[i21 + 11 >> 0] | 0;
 i23 = i24 << 24 >> 24 < 0;
 i24 = i24 & 255;
 i25 = i23 ? HEAP32[i6 + 36 >> 2] | 0 : i24;
 i26 = (i25 | 0) == 0;
 i27 = i6 + 8 | 0;
 i18 = i4 & 255;
 i19 = i32 ? HEAP32[i30 + 4 >> 2] | 0 : i18;
 i20 = (i19 | 0) == 0;
 i14 = i5 & 255;
 i15 = i6 + 4 | 0;
 i16 = i6 + 12 | 0;
 i17 = i16 + 11 | 0;
 i13 = i6 + 16 | 0;
 i11 = 0;
 i12 = -1;
 L5 : while (1) {
  i10 = i2 & i31;
  i7 = i22 + (i10 * 20 | 0) | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i22 + (i10 * 20 | 0) + 4 >> 2] | 0 : i9 & 255;
  do if ((i25 | 0) == (i9 | 0)) {
   i2 = HEAP32[i21 >> 2] | 0;
   i3 = i23 ? i2 : i21;
   i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
   if (i23) {
    if (i26) break L5;
    if (!(_memcmp(i3, i1, i25) | 0)) break L5; else break;
   }
   if (i26) break L5;
   if ((i2 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i2 = i21;
    i3 = i24;
    do {
     i3 = i3 + -1 | 0;
     i2 = i2 + 1 | 0;
     if (!i3) break L5;
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  } while (0);
  L18 : do if (!(HEAP8[i27 >> 0] | 0)) i33 = 26; else if (!(HEAP32[i15 >> 2] | 0)) i33 = 26; else {
   i2 = HEAP8[i17 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   i2 = i2 & 255;
   if (((i3 ? HEAP32[i13 >> 2] | 0 : i2) | 0) == (i9 | 0)) {
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i3 ? i4 : i16;
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    i6 = (i9 | 0) == 0;
    L22 : do if (i3) {
     if (!i6) if (_memcmp(i5, i1, i9) | 0) {
      i33 = 26;
      break L18;
     }
    } else if (!i6) {
     if ((i4 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i3 = i16; else {
      i33 = 26;
      break L18;
     }
     while (1) {
      i2 = i2 + -1 | 0;
      i3 = i3 + 1 | 0;
      if (!i2) break L22;
      i1 = i1 + 1 | 0;
      if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i33 = 26;
       break L18;
      }
     }
    } while (0);
    i1 = (i12 | 0) == -1 ? i10 : i12;
   } else i33 = 26;
  } while (0);
  do if ((i33 | 0) == 26) {
   i33 = 0;
   if ((i19 | 0) == (i9 | 0)) {
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    if (i32) {
     if (i20) {
      i33 = 34;
      break L5;
     }
     if (!(_memcmp(i28, i1, i19) | 0)) {
      i33 = 34;
      break L5;
     } else {
      i1 = i12;
      break;
     }
    }
    if (i20) {
     i33 = 34;
     break L5;
    }
    if (i14 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
     i2 = i30;
     i3 = i18;
     while (1) {
      i3 = i3 + -1 | 0;
      i2 = i2 + 1 | 0;
      if (!i3) {
       i33 = 34;
       break L5;
      }
      i1 = i1 + 1 | 0;
      if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i1 = i12;
       break;
      }
     }
    } else i1 = i12;
   } else i1 = i12;
  } while (0);
  i2 = i11 + 1 | 0;
  i11 = i2;
  i12 = i1;
  i2 = i2 + i10 | 0;
 }
 if ((i33 | 0) == 34) {
  HEAP32[i29 >> 2] = i10;
  HEAP32[i29 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i29 >> 2] = -1;
 i1 = i29 + 4 | 0;
 if ((i12 | 0) == -1) {
  HEAP32[i1 >> 2] = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = i12;
  return;
 }
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2615;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __Z27RegisterModuleClasses_Audiov() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __Z13RegisterClassI12AudioManagerEvv();
 __Z13RegisterClassI13AudioListenerEvv();
 HEAP32[i2 >> 2] = gb + 175648;
 HEAP32[i2 + 4 >> 2] = fb + 936;
 HEAP32[i2 + 8 >> 2] = gb + 867588;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 82;
 HEAP32[i2 + 20 >> 2] = 552;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171656;
 HEAP32[i2 + 44 >> 2] = fb + 290;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 291;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI9AudioClipEvv();
 __Z13RegisterClassI14AudioBehaviourEvv();
 __Z13RegisterClassI10SampleClipEvv();
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 937;
 HEAP32[i2 + 8 >> 2] = gb + 863974;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 164;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 175128;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI19AudioHighPassFilterEvv();
 __Z13RegisterClassI17AudioChorusFilterEvv();
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 938;
 HEAP32[i2 + 8 >> 2] = gb + 864200;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 167;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174088;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI15AudioEchoFilterEvv();
 __Z13RegisterClassI18AudioLowPassFilterEvv();
 __Z13RegisterClassI21AudioDistortionFilterEvv();
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 939;
 HEAP32[i2 + 8 >> 2] = gb + 853489;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 181;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170352;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI10AudioMixerEvv();
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 934;
 HEAP32[i2 + 8 >> 2] = gb + 863848;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 273;
 HEAP32[i2 + 20 >> 2] = 72;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174800;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 935;
 HEAP32[i2 + 8 >> 2] = gb + 863942;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 272;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174940;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI16BaseVideoTextureEvv();
 __Z13RegisterClassI13WebCamTextureEvv();
 STACKTOP = i1;
 return;
}

function __ZNSt3__214__scan_keywordIPcPNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SC_SB_SB_RKT1_Rjb(i13, i14, i1, i18, i15, i19, i16) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i20;
 i4 = (i18 - i1 | 0) / 12 | 0;
 do if (i4 >>> 0 > 100) {
  i3 = _malloc(i4) | 0;
  if (!i3) {
   __THREW__ = 0;
   invoke_v(fb + 459 | 0);
   i17 = __THREW__;
   __THREW__ = 0;
   if (i17 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
  }
  i2 = i3;
  i17 = i3;
  i5 = 6;
 } else {
  i17 = 0;
  i5 = 6;
 } while (0);
 if ((i5 | 0) == 6) {
  i6 = i1;
  i7 = i2;
  i3 = 0;
  while (1) {
   if ((i6 | 0) == (i18 | 0)) break;
   i5 = HEAP8[i6 + 11 >> 0] | 0;
   if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
   if (!i5) {
    HEAP8[i7 >> 0] = 2;
    i3 = i3 + 1 | 0;
    i4 = i4 + -1 | 0;
   } else HEAP8[i7 >> 0] = 1;
   i6 = i6 + 12 | 0;
   i7 = i7 + 1 | 0;
  }
  i11 = 0;
  i5 = i3;
  L21 : while (1) {
   i3 = HEAP32[i13 >> 2] | 0;
   if (!((i4 | 0) != 0 & (i3 | 0) != (i14 | 0))) {
    i5 = 17;
    break;
   }
   i3 = HEAP8[i3 >> 0] | 0;
   if (!i16) {
    __THREW__ = 0;
    i3 = invoke_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i3 | 0) | 0;
    i12 = __THREW__;
    __THREW__ = 0;
    if (i12 & 1) {
     i5 = 20;
     break;
    }
   }
   i12 = i11 + 1 | 0;
   i8 = i1;
   i7 = 0;
   i9 = i2;
   i10 = i5;
   while (1) {
    if ((i8 | 0) == (i18 | 0)) break;
    do if ((HEAP8[i9 >> 0] | 0) == 1) {
     i6 = i8 + 11 | 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
     i5 = HEAP8[i5 + i11 >> 0] | 0;
     if (!i16) {
      __THREW__ = 0;
      i5 = invoke_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i5 | 0) | 0;
      i21 = __THREW__;
      __THREW__ = 0;
      if (i21 & 1) {
       i5 = 30;
       break L21;
      }
     }
     if (i3 << 24 >> 24 != i5 << 24 >> 24) {
      HEAP8[i9 >> 0] = 0;
      i5 = i7;
      i6 = i10;
      i4 = i4 + -1 | 0;
      break;
     }
     i5 = HEAP8[i6 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i8 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) == (i12 | 0)) {
      HEAP8[i9 >> 0] = 2;
      i5 = 1;
      i6 = i10 + 1 | 0;
      i4 = i4 + -1 | 0;
     } else {
      i5 = 1;
      i6 = i10;
     }
    } else {
     i5 = i7;
     i6 = i10;
    } while (0);
    i8 = i8 + 12 | 0;
    i7 = i5;
    i9 = i9 + 1 | 0;
    i10 = i6;
   }
   if (!i7) {
    i11 = i12;
    i5 = i10;
    continue;
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   if ((i10 + i4 | 0) >>> 0 > 1) {
    i6 = i1;
    i7 = i2;
    i3 = i10;
   } else {
    i11 = i12;
    i5 = i10;
    continue;
   }
   while (1) {
    if ((i6 | 0) == (i18 | 0)) {
     i11 = i12;
     i5 = i3;
     continue L21;
    }
    if ((HEAP8[i7 >> 0] | 0) == 2) {
     i5 = HEAP8[i6 + 11 >> 0] | 0;
     if (i5 << 24 >> 24 < 0) i5 = HEAP32[i6 + 4 >> 2] | 0; else i5 = i5 & 255;
     if ((i5 | 0) != (i12 | 0)) {
      HEAP8[i7 >> 0] = 0;
      i3 = i3 + -1 | 0;
     }
    }
    i6 = i6 + 12 | 0;
    i7 = i7 + 1 | 0;
   }
  }
  if ((i5 | 0) == 17) {
   if ((i3 | 0) == (i14 | 0)) HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 2;
   while (1) {
    if ((i1 | 0) == (i18 | 0)) {
     i5 = 52;
     break;
    }
    if ((HEAP8[i2 >> 0] | 0) == 2) break;
    i1 = i1 + 12 | 0;
    i2 = i2 + 1 | 0;
   }
   if ((i5 | 0) == 52) {
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 4;
    i1 = i18;
   }
   if (i17 | 0) _free(i17);
   STACKTOP = i20;
   return i1 | 0;
  } else if ((i5 | 0) == 20) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else if ((i5 | 0) == 30) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  if (i17) _free(i17);
 }
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN9GfxDeviceC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 16 | 0;
 i3 = i2;
 i6 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 38136 + 8;
 __ZN24BuiltinShaderParamValuesC2Ev(i1 + 4 | 0);
 i8 = i1 + 3616 | 0;
 HEAP32[i8 >> 2] = gb + 39052 + 8;
 HEAP32[i1 + 3740 >> 2] = 0;
 HEAP32[i1 + 3744 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 3748 >> 2] = 0;
 HEAP32[i1 + 3736 >> 2] = i1 + 3740;
 i7 = i1 + 3880 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 mftCall_viiiiiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, 64, 64, 4, 4, 4, 0);
 i8 = i1 + 3808 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i8 = i1 + 3904 | 0;
 HEAP32[i8 >> 2] = gb + 39052 + 8;
 HEAP32[i1 + 4028 >> 2] = 0;
 HEAP32[i1 + 4032 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 4036 >> 2] = 0;
 HEAP32[i1 + 4024 >> 2] = i1 + 4028;
 i7 = i1 + 4168 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 16 >> 0] = 0;
 mftCall_viiiiiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, 64, 64, 4, 4, 4, 0);
 i8 = i1 + 4096 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i1 + 4248 >> 2] = -1;
 i8 = i1 + 4252 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4268 >> 2] = -1;
 i8 = i1 + 4272 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4288 >> 2] = -1;
 i8 = i1 + 4292 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4308 >> 2] = -1;
 i8 = i1 + 4312 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4328 >> 2] = -1;
 i8 = i1 + 4332 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4348 >> 2] = -1;
 i8 = i1 + 4352 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP32[i1 + 4400 >> 2] = 0;
 HEAP32[i1 + 4404 >> 2] = 0;
 i8 = gb + 63304 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i1 + 4412 >> 2] = 0;
 HEAP32[i1 + 4424 >> 2] = 0;
 HEAP32[i1 + 4428 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 4416 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i1 + 4432 >> 2] = 0;
 HEAP32[i1 + 4436 >> 2] = 0;
 HEAP32[i1 + 4440 >> 2] = -1;
 HEAP32[i1 + 4444 >> 2] = 0;
 i7 = gb + 63664 | 0;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17UniqueIDGeneratorC2E10MemLabelId(i1 + 4448 | 0, i5);
 HEAP32[i1 + 4472 >> 2] = 0;
 HEAP32[i1 + 4484 >> 2] = 0;
 HEAP32[i1 + 4488 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 4476 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 4492 >> 2] = 0;
 HEAP32[i1 + 4504 >> 2] = 0;
 HEAP32[i1 + 4508 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4496 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 4528 >> 2] = 0;
 HEAP32[i1 + 4532 >> 2] = 0;
 HEAP32[i1 + 4524 >> 2] = i1 + 4528;
 HEAP32[i1 + 4552 >> 2] = 0;
 HEAP32[i1 + 4588 >> 2] = 0;
 HEAP32[i1 + 4592 >> 2] = 0;
 HEAP32[i1 + 4596 >> 2] = -1;
 HEAP32[i1 + 4600 >> 2] = 0;
 HEAP32[i1 + 4408 >> 2] = 0;
 i3 = i1 + 4516 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZN9GfxDevice8OnCreateEv(i1);
 STACKTOP = i2;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2560;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2726;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2670;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 56 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 657235 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 56 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 56 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 56 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 56 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i4 + (i1 * 56 | 0) + 48 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 56 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 56 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 56 | 0) | 0;
 return i9 | 0;
}

function __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i(i12, i16, i17, i18) {
 i12 = i12 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22 + 8 | 0;
 i14 = i22;
 i19 = i22 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i15 = i19 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i20 = i19 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 i21 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i1 = i13;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i21;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i12 + 16 | 0;
 i10 = i12 + 20 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = 0; else {
  i11 = i12 + 28 | 0;
  i7 = 0;
  i3 = 0;
  i8 = 0;
  while (1) {
   if ((HEAP32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i2 + (i8 * 40 | 0) + 32 >> 2] | 0) * 156 | 0) + 4 >> 2] | 0) == 1) {
    i5 = HEAP32[i15 >> 2] | 0;
    i6 = i5 + 1 | 0;
    i2 = HEAP32[i20 >> 2] | 0;
    i4 = i2 & 2147483647;
    do if (i6 >>> 0 > i4 >>> 0) {
     i1 = i2 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
      HEAP32[i20 >> 2] = i1;
      i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i1 << 2, 4, i21, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i1;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i21, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
      HEAP32[i20 >> 2] = i1;
      HEAP32[i19 >> 2] = i7;
      i1 = i7;
      break;
     } else i1 = i7;
    } else i1 = i7; while (0);
    HEAP32[i15 >> 2] = i6;
    HEAP32[i1 + (i5 << 2) >> 2] = i8;
    i4 = i1;
    i3 = i1;
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   } else i4 = i7;
   i8 = i8 + 1 | 0;
   if (i8 >>> 0 >= ((i1 - i2 | 0) / 40 | 0) >>> 0) break; else i7 = i4;
  }
  if (!(HEAP32[i15 >> 2] | 0)) i1 = 0; else {
   i1 = __Znwj(88) | 0;
   HEAP32[i1 >> 2] = i12;
   i5 = gb + 63616 | 0;
   i8 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = i14;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = i8;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   i8 = i1 + 16 | 0;
   i5 = i1 + 20 | 0;
   HEAP32[i5 >> 2] = 0;
   i6 = i1 + 8 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i14);
   i3 = i13;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i6;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i2;
   i7 = i1 + 24 | 0;
   HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
   f25 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
   f24 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   HEAPF32[i1 + 36 >> 2] = f25;
   HEAPF32[i1 + 40 >> 2] = f24;
   HEAPF32[i1 + 44 >> 2] = f23;
   i7 = i1 + 48 | 0;
   HEAP32[i1 + 80 >> 2] = 0;
   HEAP32[i1 + 84 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   i7 = HEAP32[i19 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] << 2;
   i3 = i2 >> 2;
   HEAP32[i8 >> 2] = i3;
   if (!i3) {
    i3 = 0;
    i2 = 0;
   } else {
    HEAP32[i5 >> 2] = i3;
    i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i4 >> 2] = i3;
    i2 = HEAP32[i8 >> 2] << 2;
   }
   _memcpy(i3 | 0, i7 | 0, i2 | 0) | 0;
   __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i(i1, i16, i17, i18);
  }
 }
 if ((HEAP32[i20 >> 2] | 0) <= -1) {
  STACKTOP = i22;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
 HEAP32[i19 >> 2] = 0;
 STACKTOP = i22;
 return i1 | 0;
}

function _ft_smooth_render_generic(i11, i8, i1, i3, i2) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 64 | 0;
 i4 = i24 + 48 | 0;
 i13 = i24;
 i23 = i8 + 108 | 0;
 i14 = i8 + 76 | 0;
 i21 = HEAP32[i11 + 8 >> 2] | 0;
 i12 = (i1 | 0) == 3;
 i17 = (i1 | 0) == 4;
 i9 = i8 + 72 | 0;
 if ((HEAP32[i9 >> 2] | 0) != (HEAP32[i11 + 16 >> 2] | 0)) {
  HEAP32[i22 >> 2] = 6;
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  HEAP32[i22 >> 2] = 19;
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
 }
 _UNITY_FT_Outline_Get_CBox(i23, i4);
 i5 = (HEAP32[i4 >> 2] | 0) + i1 | 0;
 i7 = i5 & -64;
 HEAP32[i4 >> 2] = i7;
 i20 = i4 + 4 | 0;
 i6 = (HEAP32[i20 >> 2] | 0) + i2 & -64;
 HEAP32[i20 >> 2] = i6;
 i20 = i4 + 8 | 0;
 i10 = i1 + 63 + (HEAP32[i20 >> 2] | 0) & -64;
 HEAP32[i20 >> 2] = i10;
 i20 = i4 + 12 | 0;
 i3 = i2 + 63 + (HEAP32[i20 >> 2] | 0) | 0;
 i15 = i3 & -64;
 HEAP32[i20 >> 2] = i15;
 i20 = i1 - i7 | 0;
 i18 = i2 - i6 | 0;
 i7 = (i10 - i7 | 0) >>> 6;
 i2 = (i15 - i6 | 0) >>> 6;
 i6 = i7 * 3 | 0;
 i15 = i12 ? i6 + 3 & 536870908 : i7;
 i6 = i12 ? i6 : i7;
 i10 = i17 ? i2 * 3 | 0 : i2;
 if ((i6 | i10) & 268402688 | 0) {
  HEAP32[i22 >> 2] = 98;
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i19 = i8 + 156 | 0;
 i16 = i8 + 88 | 0;
 if (HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] & 1 | 0) {
  _UNITY_ft_mem_free(i21, HEAP32[i16 >> 2] | 0);
  HEAP32[i16 >> 2] = 0;
  i4 = (HEAP32[i19 >> 2] | 0) + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -2;
 }
 HEAP32[i16 >> 2] = _UNITY_ft_mem_alloc(i21, Math_imul(i15, i10) | 0, i22) | 0;
 if (HEAP32[i22 >> 2] | 0) {
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 i4 = (HEAP32[i19 >> 2] | 0) + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
 HEAP32[i9 >> 2] = 1651078259;
 HEAP32[i8 + 100 >> 2] = i5 >> 6;
 HEAP32[i8 + 104 >> 2] = i3 >> 6;
 HEAP8[i8 + 94 >> 0] = 2;
 HEAP16[i8 + 92 >> 1] = 256;
 HEAP32[i8 + 80 >> 2] = i6;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i8 + 84 >> 2] = i15;
 if (!(i18 | i20)) i8 = 0; else {
  _UNITY_FT_Outline_Translate(i23, i20, i18);
  i8 = 1;
 }
 HEAP32[i13 >> 2] = i14;
 HEAP32[i13 + 4 >> 2] = i23;
 HEAP32[i13 + 8 >> 2] = 1;
 i14 = mftCall_iii(HEAP32[i11 + 56 >> 2] | 0, HEAP32[i11 + 52 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i22 >> 2] = i14;
 if (!i14) {
  if (!((i2 | 0) == 0 | i12 ^ 1 | (i7 | 0) == 0)) {
   i4 = i2;
   i5 = HEAP32[i16 >> 2] | 0;
   while (1) {
    i1 = i5 + i6 | 0;
    i3 = i7;
    do {
     i3 = i3 + -1 | 0;
     i13 = HEAP8[i5 + i3 >> 0] | 0;
     i14 = i1;
     i1 = i1 + -3 | 0;
     HEAP8[i1 >> 0] = i13;
     HEAP8[i14 + -2 >> 0] = i13;
     HEAP8[i14 + -1 >> 0] = i13;
    } while ((i3 | 0) != 0);
    i4 = i4 + -1 | 0;
    if (!i4) break; else i5 = i5 + i15 | 0;
   }
  }
  if (i17) {
   i1 = HEAP32[i16 >> 2] | 0;
   if (i2 | 0) {
    i4 = i1;
    i3 = i1 + (Math_imul(i15, i10 - i2 | 0) | 0) | 0;
    while (1) {
     _memcpy(i4 | 0, i3 | 0, i15 | 0) | 0;
     i1 = i4 + i15 | 0;
     _memcpy(i1 | 0, i3 | 0, i15 | 0) | 0;
     i1 = i1 + i15 | 0;
     _memcpy(i1 | 0, i3 | 0, i15 | 0) | 0;
     i2 = i2 + -1 | 0;
     if (!i2) break; else {
      i4 = i1 + i15 | 0;
      i3 = i3 + i15 | 0;
     }
    }
   }
  }
  HEAP32[i22 >> 2] = 0;
  i1 = 0;
 } else i1 = 1;
 if (i8 << 24 >> 24) _UNITY_FT_Outline_Translate(i23, 0 - i20 | 0, 0 - i18 | 0);
 if (!(i1 << 24 >> 24)) {
  i23 = HEAP32[i22 >> 2] | 0;
  STACKTOP = i24;
  return i23 | 0;
 }
 _UNITY_ft_mem_free(i21, HEAP32[i16 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 i23 = (HEAP32[i19 >> 2] | 0) + 4 | 0;
 HEAP32[i23 >> 2] = HEAP32[i23 >> 2] & -2;
 i23 = HEAP32[i22 >> 2] | 0;
 STACKTOP = i24;
 return i23 | 0;
}

function __ZL21PxcGenerateVFContactsRKN5physx2Cm8Matrix34ERNS_2Gu13ContactBufferERKNS4_7SegmentEfPKNS_6PxVec3ERSB_jf(i40, i39, i43, f42, i45, i41, i46, f1) {
 i40 = i40 | 0;
 i39 = i39 | 0;
 i43 = i43 | 0;
 f42 = Math_fround(f42);
 i45 = i45 | 0;
 i41 = i41 | 0;
 i46 = i46 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i44 = 0, i47 = 0, i48 = 0, i49 = 0, f50 = f0, f51 = f0, f52 = f0;
 i49 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i44 = i49 + 20 | 0;
 i47 = i49 + 16 | 0;
 i48 = i49 + 12 | 0;
 i32 = i49;
 i33 = i41 + 4 | 0;
 i34 = i41 + 8 | 0;
 i35 = i32 + 4 | 0;
 i36 = i32 + 8 | 0;
 i37 = i45 + 12 | 0;
 i38 = i45 + 24 | 0;
 f25 = Math_fround(f42 + f1);
 i26 = i40 + 4 | 0;
 i27 = i40 + 8 | 0;
 i14 = i40 + 12 | 0;
 i15 = i40 + 16 | 0;
 i16 = i40 + 20 | 0;
 i17 = i40 + 24 | 0;
 i18 = i40 + 28 | 0;
 i19 = i40 + 32 | 0;
 i20 = i39 + 4096 | 0;
 i21 = i40 + 44 | 0;
 i22 = i40 + 40 | 0;
 i23 = i40 + 36 | 0;
 i28 = 0;
 do {
  i2 = i43 + (i28 * 12 | 0) | 0;
  f29 = Math_fround(-Math_fround(HEAPF32[i41 >> 2]));
  f30 = Math_fround(-Math_fround(HEAPF32[i33 >> 2]));
  f31 = Math_fround(-Math_fround(HEAPF32[i34 >> 2]));
  HEAPF32[i32 >> 2] = f29;
  HEAPF32[i35 >> 2] = f30;
  HEAPF32[i36 >> 2] = f31;
  if (__ZN5physx2Gu27intersectRayTriangleCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i2, i32, i45, i37, i38, i44, i47, i48, Math_fround(.00100000005)) | 0) {
   f24 = Math_fround(HEAPF32[i44 >> 2]);
   if (f24 < f25) {
    f29 = Math_fround(HEAPF32[i41 >> 2]);
    f30 = Math_fround(HEAPF32[i33 >> 2]);
    f31 = Math_fround(HEAPF32[i34 >> 2]);
    f1 = Math_fround(f24 * f29);
    f3 = Math_fround(f24 * f30);
    f4 = Math_fround(f24 * f31);
    f1 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f1);
    f3 = Math_fround(Math_fround(HEAPF32[i43 + (i28 * 12 | 0) + 4 >> 2]) - f3);
    f4 = Math_fround(Math_fround(HEAPF32[i43 + (i28 * 12 | 0) + 8 >> 2]) - f4);
    f5 = Math_fround(HEAPF32[i40 >> 2]);
    f6 = Math_fround(HEAPF32[i26 >> 2]);
    f7 = Math_fround(HEAPF32[i27 >> 2]);
    f8 = Math_fround(HEAPF32[i14 >> 2]);
    f9 = Math_fround(HEAPF32[i15 >> 2]);
    f10 = Math_fround(HEAPF32[i16 >> 2]);
    f11 = Math_fround(HEAPF32[i17 >> 2]);
    f12 = Math_fround(HEAPF32[i18 >> 2]);
    f13 = Math_fround(HEAPF32[i19 >> 2]);
    i2 = HEAP32[i20 >> 2] | 0;
    if (i2 >>> 0 <= 63) {
     f24 = Math_fround(f24 - f42);
     f50 = Math_fround(Math_fround(Math_fround(f7 * f29) + Math_fround(f10 * f30)) + Math_fround(f13 * f31));
     f51 = Math_fround(Math_fround(Math_fround(f6 * f29) + Math_fround(f9 * f30)) + Math_fround(f12 * f31));
     f52 = Math_fround(Math_fround(Math_fround(f5 * f29) + Math_fround(f8 * f30)) + Math_fround(f11 * f31));
     f31 = Math_fround(Math_fround(Math_fround(f1 * f7) + Math_fround(f3 * f10)) + Math_fround(f4 * f13));
     f31 = Math_fround(f31 + Math_fround(HEAPF32[i21 >> 2]));
     f30 = Math_fround(Math_fround(Math_fround(f1 * f6) + Math_fround(f3 * f9)) + Math_fround(f4 * f12));
     f30 = Math_fround(f30 + Math_fround(HEAPF32[i22 >> 2]));
     f29 = Math_fround(Math_fround(Math_fround(f1 * f5) + Math_fround(f3 * f8)) + Math_fround(f4 * f11));
     f29 = Math_fround(f29 + Math_fround(HEAPF32[i23 >> 2]));
     HEAP32[i20 >> 2] = i2 + 1;
     HEAPF32[i39 + (i2 << 6) >> 2] = f52;
     HEAPF32[i39 + (i2 << 6) + 4 >> 2] = f51;
     HEAPF32[i39 + (i2 << 6) + 8 >> 2] = f50;
     HEAPF32[i39 + (i2 << 6) + 16 >> 2] = f29;
     HEAPF32[i39 + (i2 << 6) + 20 >> 2] = f30;
     HEAPF32[i39 + (i2 << 6) + 24 >> 2] = f31;
     HEAPF32[i39 + (i2 << 6) + 12 >> 2] = f24;
     HEAP32[i39 + (i2 << 6) + 48 >> 2] = -1;
     HEAP32[i39 + (i2 << 6) + 52 >> 2] = i46;
    }
   }
  }
  i28 = i28 + 1 | 0;
 } while ((i28 | 0) != 2);
 STACKTOP = i49;
 return;
}

function runPostSets222() {
 HEAP32[gb + 189160 >> 2] = fb + 2934;
 HEAP32[gb + 189164 >> 2] = fb + 2935;
 HEAP32[gb + 189168 >> 2] = fb + 19;
 HEAP32[gb + 189172 >> 2] = fb + 1366;
 HEAP32[gb + 189176 >> 2] = fb + 99;
 HEAP32[gb + 189180 >> 2] = fb + 40;
 HEAP32[gb + 189184 >> 2] = fb + 62;
 HEAP32[gb + 189188 >> 2] = fb + 28;
 HEAP32[gb + 189192 >> 2] = fb + 63;
 HEAP32[gb + 189196 >> 2] = fb + 29;
 HEAP32[gb + 189200 >> 2] = fb + 34;
 HEAP32[gb + 189204 >> 2] = fb + 2225;
 HEAP32[gb + 189208 >> 2] = fb + 2226;
 HEAP32[gb + 189212 >> 2] = fb + 2227;
 HEAP32[gb + 189216 >> 2] = fb + 2228;
 HEAP32[gb + 189220 >> 2] = fb + 2229;
 HEAP32[gb + 189224 >> 2] = fb + 2230;
 HEAP32[gb + 189228 >> 2] = fb + 36;
 HEAP32[gb + 189232 >> 2] = fb + 96;
 HEAP32[gb + 189236 >> 2] = fb + 81;
 HEAP32[gb + 189240 >> 2] = fb + 82;
 HEAP32[gb + 189252 >> 2] = (HEAP32[gb + 189252 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 189256 >> 2] = (HEAP32[gb + 189256 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 189292 >> 2] = fb + 2936;
 HEAP32[gb + 189296 >> 2] = fb + 2937;
 HEAP32[gb + 189300 >> 2] = fb + 2231;
 HEAP32[gb + 189304 >> 2] = fb + 2938;
 HEAP32[gb + 189308 >> 2] = fb + 2939;
 HEAP32[gb + 189320 >> 2] = fb + 2940;
 HEAP32[gb + 189324 >> 2] = fb + 2941;
 HEAP32[gb + 189328 >> 2] = fb + 2232;
 HEAP32[gb + 189332 >> 2] = fb + 2942;
 HEAP32[gb + 189336 >> 2] = fb + 2939;
 HEAP32[gb + 189348 >> 2] = fb + 2943;
 HEAP32[gb + 189352 >> 2] = fb + 2944;
 HEAP32[gb + 189356 >> 2] = fb + 2233;
 HEAP32[gb + 189360 >> 2] = fb + 2945;
 HEAP32[gb + 189364 >> 2] = fb + 2939;
 HEAP32[gb + 189376 >> 2] = fb + 2927;
 HEAP32[gb + 189380 >> 2] = fb + 2946;
 HEAP32[gb + 189384 >> 2] = fb + 2947;
 HEAP32[gb + 189388 >> 2] = fb + 2234;
 HEAP32[gb + 189392 >> 2] = fb + 2235;
 HEAP32[gb + 189404 >> 2] = fb + 2948;
 HEAP32[gb + 189408 >> 2] = fb + 2949;
 HEAP32[gb + 189412 >> 2] = fb + 2236;
 HEAP32[gb + 189416 >> 2] = fb + 2950;
 HEAP32[gb + 189420 >> 2] = fb + 2939;
 HEAP32[gb + 189432 >> 2] = fb + 2948;
 HEAP32[gb + 189436 >> 2] = fb + 2951;
 HEAP32[gb + 189440 >> 2] = fb + 2233;
 HEAP32[gb + 189444 >> 2] = fb + 2952;
 HEAP32[gb + 189448 >> 2] = fb + 2939;
 HEAP32[gb + 189476 >> 2] = (HEAP32[gb + 189476 >> 2] | 0) + (gb + 1044172 | 0);
 HEAP32[gb + 189480 >> 2] = (HEAP32[gb + 189480 >> 2] | 0) + (gb + 1044177 | 0);
 HEAP32[gb + 189492 >> 2] = fb + 2953;
 HEAP32[gb + 189496 >> 2] = fb + 2954;
 HEAP32[gb + 189500 >> 2] = fb + 2955;
 HEAP32[gb + 189504 >> 2] = fb + 1367;
 HEAP32[gb + 189508 >> 2] = fb + 1368;
 HEAP32[gb + 189512 >> 2] = fb + 1369;
 HEAP32[gb + 189516 >> 2] = fb + 1370;
 HEAP32[gb + 189520 >> 2] = fb + 2956;
 HEAP32[gb + 189524 >> 2] = fb + 83;
 HEAP32[gb + 189528 >> 2] = fb + 288;
 HEAP32[gb + 189532 >> 2] = fb + 2957;
 HEAP32[gb + 189536 >> 2] = fb + 2958;
 HEAP32[gb + 189540 >> 2] = fb + 2959;
 HEAP32[gb + 189544 >> 2] = fb + 2960;
 HEAP32[gb + 189548 >> 2] = fb + 2961;
 HEAP32[gb + 189552 >> 2] = fb + 2962;
 HEAP32[gb + 189556 >> 2] = fb + 2963;
 HEAP32[gb + 189560 >> 2] = fb + 2237;
 HEAP32[gb + 189564 >> 2] = fb + 466;
 HEAP32[gb + 189568 >> 2] = fb + 173;
 HEAP32[gb + 189572 >> 2] = fb + 467;
 HEAP32[gb + 189576 >> 2] = fb + 2238;
 HEAP32[gb + 189580 >> 2] = fb + 1371;
 HEAP32[gb + 189584 >> 2] = fb + 174;
 HEAP32[gb + 189588 >> 2] = fb + 175;
 HEAP32[gb + 189592 >> 2] = fb + 91;
 HEAP32[gb + 189596 >> 2] = fb + 1372;
 HEAP32[gb + 189600 >> 2] = fb + 289;
 HEAP32[gb + 189604 >> 2] = fb + 1373;
 HEAP32[gb + 189608 >> 2] = fb + 1374;
 HEAP32[gb + 189612 >> 2] = fb + 195;
 HEAP32[gb + 189616 >> 2] = fb + 1375;
 HEAP32[gb + 189620 >> 2] = fb + 196;
 HEAP32[gb + 189624 >> 2] = fb + 1376;
 HEAP32[gb + 189628 >> 2] = fb + 197;
 HEAP32[gb + 189632 >> 2] = fb + 1377;
 HEAP32[gb + 189636 >> 2] = fb + 1378;
 HEAP32[gb + 189640 >> 2] = fb + 1379;
 HEAP32[gb + 189644 >> 2] = fb + 1380;
 HEAP32[gb + 189648 >> 2] = fb + 468;
 HEAP32[gb + 189652 >> 2] = fb + 1381;
 HEAP32[gb + 189656 >> 2] = fb + 2964;
 HEAP32[gb + 189660 >> 2] = fb + 1382;
 HEAP32[gb + 189664 >> 2] = fb + 471;
 HEAP32[gb + 189668 >> 2] = fb + 126;
 runPostSets223();
}

function _UNITY_FT_Outline_EmboldenXY(i22, i1, i2) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i27;
 if (!i22) {
  i26 = 20;
  STACKTOP = i27;
  return i26 | 0;
 }
 i24 = (i1 | 0) / 2 | 0;
 i25 = (i2 | 0) / 2 | 0;
 if ((i1 + 1 | 0) >>> 0 < 3 & (i2 + 1 | 0) >>> 0 < 3) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i1 = _UNITY_FT_Outline_Get_Orientation(i22) | 0;
 if ((i1 | 0) == 2) {
  i26 = (HEAP16[i22 >> 1] | 0) == 0 ? 0 : 6;
  STACKTOP = i27;
  return i26 | 0;
 }
 i20 = HEAP32[i22 + 4 >> 2] | 0;
 i2 = HEAP16[i22 >> 1] | 0;
 if (i2 << 16 >> 16 <= 0) {
  i26 = 0;
  STACKTOP = i27;
  return i26 | 0;
 }
 i21 = i22 + 12 | 0;
 i19 = i23 + 4 | 0;
 i18 = (i1 | 0) == 0;
 i16 = 0;
 i17 = 0;
 while (1) {
  i14 = HEAP16[(HEAP32[i21 >> 2] | 0) + (i17 << 1) >> 1] | 0;
  i15 = i14 << 16 >> 16;
  if (!((i16 | 0) == (i15 | 0) | i14 << 16 >> 16 == -1)) {
   i14 = i16;
   i1 = i15;
   i4 = 0;
   i10 = 0;
   i7 = -1;
   i9 = 0;
   i6 = 0;
   i3 = 0;
   i5 = 0;
   while (1) {
    if ((i14 | 0) == (i7 | 0)) {
     HEAP32[i23 >> 2] = i9;
     HEAP32[i19 >> 2] = i3;
     i13 = i4;
     i26 = 11;
    } else {
     HEAP32[i23 >> 2] = (HEAP32[i20 + (i14 << 3) >> 2] | 0) - (HEAP32[i20 + (i1 << 3) >> 2] | 0);
     HEAP32[i19 >> 2] = (HEAP32[i20 + (i14 << 3) + 4 >> 2] | 0) - (HEAP32[i20 + (i1 << 3) + 4 >> 2] | 0);
     i2 = _UNITY_FT_Vector_NormLen(i23) | 0;
     if (!i2) {
      i8 = i10;
      i2 = i9;
     } else {
      i13 = i2;
      i26 = 11;
     }
    }
    if ((i26 | 0) == 11) {
     i26 = 0;
     if (!i10) {
      i1 = i7;
      i2 = i9;
     } else {
      i2 = (i7 | 0) < 0;
      i12 = i2 ? i5 : i3;
      i11 = i2 ? i6 : i9;
      i4 = i2 ? i10 : i4;
      i9 = i2 ? i1 : i7;
      i2 = _UNITY_FT_MulFix(i6, HEAP32[i23 >> 2] | 0) | 0;
      i2 = (_UNITY_FT_MulFix(i5, HEAP32[i19 >> 2] | 0) | 0) + i2 | 0;
      do if ((i2 | 0) > -61440) {
       i8 = i2 + 65536 | 0;
       i2 = (HEAP32[i19 >> 2] | 0) + i5 | 0;
       i3 = HEAP32[i23 >> 2] | 0;
       i7 = i3 + i6 | 0;
       i7 = i18 ? i7 : 0 - i7 | 0;
       i2 = i18 ? 0 - i2 | 0 : i2;
       i5 = _UNITY_FT_MulFix(i3, i5) | 0;
       i6 = i5 - (_UNITY_FT_MulFix(HEAP32[i19 >> 2] | 0, i6) | 0) | 0;
       i6 = i18 ? 0 - i6 | 0 : i6;
       i5 = (i10 | 0) < (i13 | 0) ? i10 : i13;
       i10 = _UNITY_FT_MulFix(i24, i6) | 0;
       if ((i10 | 0) > (_UNITY_FT_MulFix(i5, i8) | 0)) i2 = _UNITY_FT_MulDiv(i2, i5, i6) | 0; else i2 = _UNITY_FT_MulDiv(i2, i24, i8) | 0;
       i10 = _UNITY_FT_MulFix(i25, i6) | 0;
       if ((i10 | 0) > (_UNITY_FT_MulFix(i5, i8) | 0)) {
        i3 = i2;
        i2 = _UNITY_FT_MulDiv(i7, i5, i6) | 0;
        break;
       } else {
        i3 = i2;
        i2 = _UNITY_FT_MulDiv(i7, i25, i8) | 0;
        break;
       }
      } else {
       i3 = 0;
       i2 = 0;
      } while (0);
      if ((i1 | 0) == (i14 | 0)) {
       i1 = i9;
       i2 = i11;
       i3 = i12;
      } else {
       i3 = i3 + i24 | 0;
       i2 = i2 + i25 | 0;
       do {
        i10 = i20 + (i1 << 3) | 0;
        HEAP32[i10 >> 2] = i3 + (HEAP32[i10 >> 2] | 0);
        i10 = i20 + (i1 << 3) + 4 | 0;
        HEAP32[i10 >> 2] = i2 + (HEAP32[i10 >> 2] | 0);
        i1 = (i1 | 0) < (i15 | 0) ? i1 + 1 | 0 : i16;
       } while ((i1 | 0) != (i14 | 0));
       i1 = i9;
       i2 = i11;
       i3 = i12;
      }
     }
     i8 = i13;
     i7 = i1;
     i1 = i14;
     i6 = HEAP32[i23 >> 2] | 0;
     i5 = HEAP32[i19 >> 2] | 0;
    }
    i14 = (i14 | 0) < (i15 | 0) ? i14 + 1 | 0 : i16;
    if ((i14 | 0) == (i1 | 0) | (i1 | 0) == (i7 | 0)) break; else {
     i10 = i8;
     i9 = i2;
    }
   }
   i2 = HEAP16[i22 >> 1] | 0;
  }
  i17 = i17 + 1 | 0;
  if ((i17 | 0) >= (i2 << 16 >> 16 | 0)) {
   i1 = 0;
   break;
  } else i16 = i15 + 1 | 0;
 }
 STACKTOP = i27;
 return i1 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 200 | 0;
 i13 = i11 + 252 | 0;
 i15 = i11 + 148 | 0;
 i21 = i11;
 i6 = i11 + 144 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i14 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev(i14);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i20, i14 + 48 | 0, 3);
 HEAP32[i15 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i18;
 i3 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj669ES3_RKNS_27PxVehicleDifferential4WDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 64 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj670ES3_RKNS_30PxVehicleAckermannGeometryDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 80 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI8BlobSizeEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i6 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 & 65535;
 if (!((i1 & 255) << 24 >> 24)) {
  i2 = i6 + 16 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i4 = i4 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i4 & 3) | 0;
  i4 = (i3 & 65535) < 256 ? i4 : i4 + 4 | 0;
  HEAP32[i2 >> 2] = (0 - i4 & 3) + i4;
  i2 = 0;
 } else {
  HEAP8[i8 >> 0] = 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i3 & 255;
  i1 = i3;
  i3 = i3 & 65535;
 }
 if (!((i1 & 255) << 24 >> 24)) {
  i4 = i6 + 16 | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  i9 = i9 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i9 & 3) | 0;
  i9 = (i3 & 65535) < 256 ? i9 : i9 + 4 | 0;
  HEAP32[i4 >> 2] = (0 - i9 & 3) + i9;
  i4 = i2;
 } else {
  HEAP8[i8 >> 0] = 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 & 255;
  i1 = i3;
  i3 = i3 & 65535;
 }
 if (!((i1 & 255) << 24 >> 24)) {
  i2 = i6 + 16 | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  i1 = i9 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i9 & 3) | 0;
  i1 = (i3 & 65535) < 256 ? i1 : i1 + 4 | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(i4 << 24 >> 24)) i7 = 11; else HEAP8[i8 >> 0] = 0;
 } else {
  HEAP8[i8 >> 0] = 0;
  i1 = i6 + 16 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i7 = 11;
 }
 if ((i7 | 0) == 11) {
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i8 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i6 + 16 >> 2] = i1;
 } else HEAP8[i8 >> 0] = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i3 = i6 + 16 | 0;
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  HEAP8[i8 >> 0] = 0;
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 if (!((i2 & 255) << 24 >> 24)) {
  i4 = i6 + 16 | 0;
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i8 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i4 >> 2] = i1;
 } else {
  HEAP8[i8 >> 0] = 0;
  i4 = i6 + 16 | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i8 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i4 >> 2] = i1;
 } else HEAP8[i8 >> 0] = 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i4 >> 2] = (0 - i1 & 3) + i1;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i5 + 44 | 0, i6);
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 & 65535;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i3 & 65535) < 256 ? i1 : i1 + 4 | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i4 >> 2] = i1;
 } else {
  HEAP8[i8 >> 0] = 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i3;
  i3 = i3 & 65535;
 }
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i3 & 65535) < 256 ? i1 : i1 + 4 | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i4 >> 2] = i1;
  if (!((i2 & 255) << 24 >> 24)) i7 = 31; else HEAP8[i8 >> 0] = 0;
 } else {
  HEAP8[i8 >> 0] = 0;
  i7 = 31;
 }
 if ((i7 | 0) == 31) {
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i9 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i9 = (i2 & 65535) < 256 ? i9 : i9 + 4 | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP32[i4 >> 2] = (0 - i9 & 3) + i9;
  return;
 } else {
  HEAP8[i8 >> 0] = 0;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 64 | 0;
 i8 = i11;
 i9 = i5 + 44 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 48 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 56 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 56 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i8 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i17 = i8 + 9 | 0;
 HEAP8[i17 >> 0] = (i21 & 65535) >>> 8;
 i21 = i8 + 12 | 0;
 i20 = i5 + 12 | 0;
 HEAP32[i21 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 i19 = i8 + 24 | 0;
 i18 = i5 + 24 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 i14 = i8 + 36 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 40 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 44 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 52 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 48 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 56 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i17 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = i17;
 i17 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i8 + 24 >> 2] = i17;
 HEAP32[i8 + 28 >> 2] = i1;
 HEAP32[i8 + 32 >> 2] = i4;
 i4 = i5 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 56 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 60 >> 2] | 0;
  HEAP32[i6 >> 2] = 65;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 56 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function runPostSets183() {
 HEAP32[gb + 156012 >> 2] = (HEAP32[gb + 156012 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 156048 >> 2] = fb + 2395;
 HEAP32[gb + 156052 >> 2] = fb + 2396;
 HEAP32[gb + 156056 >> 2] = fb + 2397;
 HEAP32[gb + 156060 >> 2] = fb + 2398;
 HEAP32[gb + 156064 >> 2] = fb + 410;
 HEAP32[gb + 156068 >> 2] = fb + 1;
 HEAP32[gb + 156072 >> 2] = fb + 411;
 HEAP32[gb + 156076 >> 2] = fb + 130;
 HEAP32[gb + 156080 >> 2] = fb + 120;
 HEAP32[gb + 156084 >> 2] = fb + 136;
 HEAP32[gb + 156088 >> 2] = fb + 419;
 HEAP32[gb + 156092 >> 2] = fb + 412;
 HEAP32[gb + 156096 >> 2] = fb + 1684;
 HEAP32[gb + 156108 >> 2] = fb + 2399;
 HEAP32[gb + 156112 >> 2] = fb + 2400;
 HEAP32[gb + 156116 >> 2] = fb + 413;
 HEAP32[gb + 156120 >> 2] = fb + 1084;
 HEAP32[gb + 156132 >> 2] = fb + 2401;
 HEAP32[gb + 156136 >> 2] = fb + 2402;
 HEAP32[gb + 156140 >> 2] = fb + 413;
 HEAP32[gb + 156144 >> 2] = fb + 1;
 HEAP32[gb + 156156 >> 2] = fb + 2403;
 HEAP32[gb + 156160 >> 2] = fb + 2404;
 HEAP32[gb + 156164 >> 2] = fb + 1;
 HEAP32[gb + 156176 >> 2] = fb + 2405;
 HEAP32[gb + 156180 >> 2] = fb + 2406;
 HEAP32[gb + 156184 >> 2] = fb + 414;
 HEAP32[gb + 156196 >> 2] = fb + 2407;
 HEAP32[gb + 156200 >> 2] = fb + 2408;
 HEAP32[gb + 156204 >> 2] = fb + 38;
 HEAP32[gb + 156208 >> 2] = fb + 39;
 HEAP32[gb + 156212 >> 2] = fb + 16;
 HEAP32[gb + 156216 >> 2] = fb + 2409;
 HEAP32[gb + 156220 >> 2] = fb + 2410;
 HEAP32[gb + 156224 >> 2] = fb + 19;
 HEAP32[gb + 156228 >> 2] = fb + 1085;
 HEAP32[gb + 156232 >> 2] = fb + 31;
 HEAP32[gb + 156236 >> 2] = fb + 27;
 HEAP32[gb + 156240 >> 2] = fb + 62;
 HEAP32[gb + 156244 >> 2] = fb + 28;
 HEAP32[gb + 156248 >> 2] = fb + 63;
 HEAP32[gb + 156252 >> 2] = fb + 29;
 HEAP32[gb + 156256 >> 2] = fb + 34;
 HEAP32[gb + 156260 >> 2] = fb + 1685;
 HEAP32[gb + 156264 >> 2] = fb + 1686;
 HEAP32[gb + 156268 >> 2] = fb + 1687;
 HEAP32[gb + 156272 >> 2] = fb + 1688;
 HEAP32[gb + 156276 >> 2] = fb + 1689;
 HEAP32[gb + 156280 >> 2] = fb + 1690;
 HEAP32[gb + 156284 >> 2] = fb + 36;
 HEAP32[gb + 156296 >> 2] = (HEAP32[gb + 156296 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 156300 >> 2] = (HEAP32[gb + 156300 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 156336 >> 2] = fb + 2411;
 HEAP32[gb + 156340 >> 2] = fb + 2412;
 HEAP32[gb + 156344 >> 2] = fb + 80;
 HEAP32[gb + 156348 >> 2] = fb + 1691;
 HEAP32[gb + 156352 >> 2] = fb + 16;
 HEAP32[gb + 156356 >> 2] = fb + 2413;
 HEAP32[gb + 156360 >> 2] = fb + 2414;
 HEAP32[gb + 156364 >> 2] = fb + 19;
 HEAP32[gb + 156368 >> 2] = fb + 1086;
 HEAP32[gb + 156372 >> 2] = fb + 99;
 HEAP32[gb + 156376 >> 2] = fb + 40;
 HEAP32[gb + 156380 >> 2] = fb + 62;
 HEAP32[gb + 156384 >> 2] = fb + 28;
 HEAP32[gb + 156388 >> 2] = fb + 63;
 HEAP32[gb + 156392 >> 2] = fb + 29;
 HEAP32[gb + 156396 >> 2] = fb + 34;
 HEAP32[gb + 156400 >> 2] = fb + 1692;
 HEAP32[gb + 156404 >> 2] = fb + 1693;
 HEAP32[gb + 156408 >> 2] = fb + 1694;
 HEAP32[gb + 156412 >> 2] = fb + 1695;
 HEAP32[gb + 156416 >> 2] = fb + 1696;
 HEAP32[gb + 156420 >> 2] = fb + 1697;
 HEAP32[gb + 156424 >> 2] = fb + 36;
 HEAP32[gb + 156428 >> 2] = fb + 96;
 HEAP32[gb + 156432 >> 2] = fb + 81;
 HEAP32[gb + 156436 >> 2] = fb + 82;
 HEAP32[gb + 156448 >> 2] = (HEAP32[gb + 156448 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 156452 >> 2] = (HEAP32[gb + 156452 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 156488 >> 2] = fb + 2415;
 HEAP32[gb + 156492 >> 2] = fb + 2416;
 HEAP32[gb + 156496 >> 2] = fb + 2325;
 HEAP32[gb + 156500 >> 2] = fb + 1584;
 HEAP32[gb + 156504 >> 2] = fb + 16;
 HEAP32[gb + 156508 >> 2] = fb + 2417;
 HEAP32[gb + 156512 >> 2] = fb + 2418;
 HEAP32[gb + 156516 >> 2] = fb + 19;
 HEAP32[gb + 156520 >> 2] = fb + 1087;
 HEAP32[gb + 156524 >> 2] = fb + 103;
 HEAP32[gb + 156528 >> 2] = fb + 101;
 HEAP32[gb + 156532 >> 2] = fb + 62;
 HEAP32[gb + 156536 >> 2] = fb + 28;
 HEAP32[gb + 156540 >> 2] = fb + 63;
 HEAP32[gb + 156544 >> 2] = fb + 29;
 HEAP32[gb + 156548 >> 2] = fb + 34;
 HEAP32[gb + 156552 >> 2] = fb + 1698;
 HEAP32[gb + 156556 >> 2] = fb + 1699;
 HEAP32[gb + 156560 >> 2] = fb + 1700;
 runPostSets184();
}

function __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_(i29, i6, i30) {
 i29 = i29 | 0;
 i6 = i6 | 0;
 i30 = i30 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i31 = 0, i32 = 0, i33 = 0;
 i31 = (HEAP32[i6 + 64 >> 2] | 0) + -1 | 0;
 i4 = HEAP8[i30 + 11 >> 0] | 0;
 i32 = i4 << 24 >> 24 < 0;
 i5 = HEAP32[i30 >> 2] | 0;
 i28 = i32 ? i5 : i30;
 i1 = HEAP8[i28 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i3 = i28;
  i2 = 5381;
  do {
   i3 = i3 + 1 | 0;
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i21 = i6 + 36 | 0;
 i22 = HEAP32[i6 + 60 >> 2] | 0;
 i24 = HEAP8[i21 + 11 >> 0] | 0;
 i23 = i24 << 24 >> 24 < 0;
 i24 = i24 & 255;
 i25 = i23 ? HEAP32[i6 + 40 >> 2] | 0 : i24;
 i26 = (i25 | 0) == 0;
 i27 = i6 + 8 | 0;
 i18 = i4 & 255;
 i19 = i32 ? HEAP32[i30 + 4 >> 2] | 0 : i18;
 i20 = (i19 | 0) == 0;
 i14 = i5 & 255;
 i15 = i6 + 4 | 0;
 i16 = i6 + 12 | 0;
 i17 = i16 + 11 | 0;
 i13 = i6 + 16 | 0;
 i11 = 0;
 i12 = -1;
 L5 : while (1) {
  i10 = i2 & i31;
  i7 = i22 + (i10 * 24 | 0) | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i22 + (i10 * 24 | 0) + 4 >> 2] | 0 : i9 & 255;
  do if ((i25 | 0) == (i9 | 0)) {
   i2 = HEAP32[i21 >> 2] | 0;
   i3 = i23 ? i2 : i21;
   i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
   if (i23) {
    if (i26) break L5;
    if (!(_memcmp(i3, i1, i25) | 0)) break L5; else break;
   }
   if (i26) break L5;
   if ((i2 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i2 = i21;
    i3 = i24;
    do {
     i3 = i3 + -1 | 0;
     i2 = i2 + 1 | 0;
     if (!i3) break L5;
     i1 = i1 + 1 | 0;
    } while ((HEAP8[i2 >> 0] | 0) == (HEAP8[i1 >> 0] | 0));
   }
  } while (0);
  L18 : do if (!(HEAP8[i27 >> 0] | 0)) i33 = 26; else if (!(HEAP32[i15 >> 2] | 0)) i33 = 26; else {
   i2 = HEAP8[i17 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   i2 = i2 & 255;
   if (((i3 ? HEAP32[i13 >> 2] | 0 : i2) | 0) == (i9 | 0)) {
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i3 ? i4 : i16;
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    i6 = (i9 | 0) == 0;
    L22 : do if (i3) {
     if (!i6) if (_memcmp(i5, i1, i9) | 0) {
      i33 = 26;
      break L18;
     }
    } else if (!i6) {
     if ((i4 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i3 = i16; else {
      i33 = 26;
      break L18;
     }
     while (1) {
      i2 = i2 + -1 | 0;
      i3 = i3 + 1 | 0;
      if (!i2) break L22;
      i1 = i1 + 1 | 0;
      if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i33 = 26;
       break L18;
      }
     }
    } while (0);
    i1 = (i12 | 0) == -1 ? i10 : i12;
   } else i33 = 26;
  } while (0);
  do if ((i33 | 0) == 26) {
   i33 = 0;
   if ((i19 | 0) == (i9 | 0)) {
    i1 = i8 ? HEAP32[i7 >> 2] | 0 : i7;
    if (i32) {
     if (i20) {
      i33 = 34;
      break L5;
     }
     if (!(_memcmp(i28, i1, i19) | 0)) {
      i33 = 34;
      break L5;
     } else {
      i1 = i12;
      break;
     }
    }
    if (i20) {
     i33 = 34;
     break L5;
    }
    if (i14 << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
     i2 = i30;
     i3 = i18;
     while (1) {
      i3 = i3 + -1 | 0;
      i2 = i2 + 1 | 0;
      if (!i3) {
       i33 = 34;
       break L5;
      }
      i1 = i1 + 1 | 0;
      if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
       i1 = i12;
       break;
      }
     }
    } else i1 = i12;
   } else i1 = i12;
  } while (0);
  i2 = i11 + 1 | 0;
  i11 = i2;
  i12 = i1;
  i2 = i2 + i10 | 0;
 }
 if ((i33 | 0) == 34) {
  HEAP32[i29 >> 2] = i10;
  HEAP32[i29 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i29 >> 2] = -1;
 i1 = i29 + 4 | 0;
 if ((i12 | 0) == -1) {
  HEAP32[i1 >> 2] = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = i12;
  return;
 }
}

function __ZN9Animation5BlendER14AnimationStateff(i19, i18, f14, f15) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, i25 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22;
 i21 = i22 + 4 | 0;
 i4 = HEAP32[i19 + 104 >> 2] | 0;
 i16 = i19 + 108 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i6 = i18 + 56 | 0;
  i7 = i18 + 24 | 0;
  i8 = i18 + 8 | 0;
  i9 = i18 + 76 | 0;
  i10 = i18 + 52 | 0;
  i11 = i18 + 48 | 0;
  i12 = i18 + 52 | 0;
  i13 = i18 + 76 | 0;
  if (+f15 > .001) {
   i1 = 0;
   do {
    if ((HEAP32[i4 >> 2] | 0) == (i18 | 0)) {
     i1 = HEAP16[i6 >> 1] | 0;
     if (!(i1 & 2)) {
      HEAPF64[i7 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
      i1 = HEAP16[i6 >> 1] | 0;
     }
     i2 = i1 | 2;
     HEAP16[i6 >> 1] = i2;
     f3 = Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i8 >> 2])) / f15);
     if (!(i1 & 1)) i17 = 9; else {
      f5 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f14);
      i1 = f5 < Math_fround(0.0);
      f23 = Math_fround(-f5);
      if (!((i1 ? f23 : f5) <= Math_fround(.0000999999974))) i17 = 9; else {
       f5 = Math_fround(HEAPF32[i13 >> 2]);
       i25 = f5 < Math_fround(0.0);
       f24 = Math_fround(-f5);
       i1 = f3 < Math_fround(0.0);
       f23 = Math_fround(-f3);
       if ((i25 ? f24 : f5) > (i1 ? f23 : f3)) {
        i1 = i13;
        f3 = f5;
       } else i17 = 9;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      HEAPF32[i9 >> 2] = f3;
      i1 = i9;
     }
     i25 = f3 < Math_fround(0.0);
     f24 = Math_fround(-f3);
     if ((i25 ? f24 : f3) <= Math_fround(.0000999999974)) HEAPF32[i1 >> 2] = Math_fround(1.0e5);
     HEAPF32[i10 >> 2] = f14;
     HEAP16[i6 >> 1] = i2 & -38 | 1;
     HEAPF32[i11 >> 2] = f15;
     i1 = 1;
     i2 = HEAP32[i16 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
  } else {
   i1 = 0;
   do {
    if ((HEAP32[i4 >> 2] | 0) == (i18 | 0)) {
     i1 = HEAP16[i6 >> 1] | 0;
     if (!(i1 & 2)) {
      HEAPF64[i7 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
      i1 = HEAP16[i6 >> 1] | 0;
     }
     i2 = i1 | 2;
     HEAP16[i6 >> 1] = i2;
     f3 = Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i8 >> 2])) * Math_fround(1.0e5));
     if (!(i1 & 1)) i17 = 21; else {
      f24 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f14);
      i25 = f24 < Math_fround(0.0);
      f23 = Math_fround(-f24);
      if (!((i25 ? f23 : f24) <= Math_fround(.0000999999974))) i17 = 21; else {
       f5 = Math_fround(HEAPF32[i13 >> 2]);
       i1 = f5 < Math_fround(0.0);
       f23 = Math_fround(-f5);
       i25 = f3 < Math_fround(0.0);
       f24 = Math_fround(-f3);
       if ((i1 ? f23 : f5) > (i25 ? f24 : f3)) {
        i1 = i13;
        f3 = f5;
       } else i17 = 21;
      }
     }
     if ((i17 | 0) == 21) {
      i17 = 0;
      HEAPF32[i9 >> 2] = f3;
      i1 = i9;
     }
     i25 = f3 < Math_fround(0.0);
     f24 = Math_fround(-f3);
     if ((i25 ? f24 : f3) <= Math_fround(.0000999999974)) HEAPF32[i1 >> 2] = Math_fround(1.0e5);
     HEAPF32[i10 >> 2] = f14;
     HEAP16[i6 >> 1] = i2 & -38 | 1;
     HEAPF32[i11 >> 2] = f15;
     i1 = 1;
     i2 = HEAP32[i16 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
  }
  if (i1) {
   STACKTOP = i22;
   return;
  }
 }
 i2 = HEAP32[gb + 176232 >> 2] | 0;
 i1 = i18 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i20 >> 2] = i1;
 __Z6FormatPKcz(i21, i2, i20);
 if (!i19) i1 = 0; else i1 = HEAP32[i19 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i21 + 11 >> 0] | 0) < 0 ? HEAP32[i21 >> 2] | 0 : i21, 0, gb + 896407 | 0, 457, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i21);
 STACKTOP = i22;
 return;
}

function __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERNS0_8SwFabricENS0_5RangeIKNS_6PxVec4EEE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 32 | 0;
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAP32[i4 >> 2] = i1;
 i13 = i4 + 4 | 0;
 HEAP32[i13 >> 2] = i2;
 i10 = i4 + 8 | 0;
 i6 = i4 + 12 | 0;
 i11 = i4 + 20 | 0;
 i12 = i4 + 24 | 0;
 i7 = i4 + 28 | 0;
 i9 = i4 + 232 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i4 + 248 >> 2] = 1;
 HEAP32[i4 + 252 >> 2] = 0;
 HEAP32[i4 + 256 >> 2] = 0;
 HEAP32[i4 + 260 >> 2] = 0;
 i9 = i4 + 272 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 i9 = i4 + 452 | 0;
 i1 = i4 + 488 | 0;
 HEAP32[i4 + 532 >> 2] = 0;
 _memset(i4 + 308 | 0, 0, 132) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 __ZN5physx5cloth10initializeINS0_7SwClothEEEvRT_PKNS_6PxVec4ES7_(i4, i1, i9);
 i9 = i9 - i1 >> 4;
 i5 = i9 + 3 | 0;
 if ((HEAP32[i4 + 16 >> 2] & 2147483647) >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i10, i5);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i10, i9);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + (i4 << 4) | 0;
 if ((i4 | 0) > 0) while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 16 | 0;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i10, i5, i8);
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i11, i1);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + (i1 << 4) | 0;
 if ((i1 | 0) <= 0) {
  HEAP32[i12 >> 2] = i1;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i10, i9, i14);
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i11, i9, i15);
  i15 = HEAP32[i13 >> 2] | 0;
  i15 = i15 + 8 | 0;
  i14 = HEAP16[i15 >> 1] | 0;
  i14 = i14 + 1 << 16 >> 16;
  HEAP16[i15 >> 1] = i14;
  STACKTOP = i16;
  return;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 16 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i10, i9, i14);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i11, i9, i15);
 i15 = HEAP32[i13 >> 2] | 0;
 i15 = i15 + 8 | 0;
 i14 = HEAP16[i15 >> 1] | 0;
 i14 = i14 + 1 << 16 >> 16;
 HEAP16[i15 >> 1] = i14;
 STACKTOP = i16;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i2 = HEAP16[i8 >> 1] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i8 >> 1] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP16[i6 + 58 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i2 = i1 + 2 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
  i1 = HEAP16[i8 >> 1] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i8 >> 1] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP16[i6 + 56 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 84 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 48 | 0, i7);
 i1 = i6 + 80 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16;
 i15 = i14 + 4 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i1 = i5 - i6 >> 5;
 i10 = i6;
 if (i1 >>> 0 < i12 >>> 0) {
  i8 = i14 + 8 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i6 >> 5 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i11 >> 2] = 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i7 = i11 + 8 | 0;
  if (i12 | 0) {
   i10 = __Znwj(i12 << 5) | 0;
   i1 = i10;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i10 + (i12 << 5);
  }
  HEAP32[i3 >> 2] = i6;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i2, i13);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = i1 - i4 >> 5;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE8__appendEj(i11, i12 - i2 | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 << 5) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -32 - i2 | 0) >>> 5) << 5) | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -32 - i3 | 0) >>> 5) << 5);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i10 + (i12 << 5) | 0;
  HEAP32[i13 >> 2] = 0;
  i11 = i13 + 4 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 << 5;
  i1 = i2 >> 5;
  if (!i1) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i8 = __Znwj(i2) | 0;
   HEAP32[i11 >> 2] = i8;
   HEAP32[i13 >> 2] = i8;
   i1 = i8 + (i1 << 5) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i9 = i8;
   if (!i12) {
    i5 = i9;
    i2 = i9;
   } else {
    i5 = ((i2 + -32 | 0) >>> 5) + 1 | 0;
    i6 = i8;
    i2 = i10;
    i4 = i8;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i6 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
     i2 = i2 + 32 | 0;
     i4 = i4 + 32 | 0;
     if ((i2 | 0) == (i7 | 0)) break; else i6 = i4;
    }
    i2 = i8 + (i5 << 5) | 0;
    HEAP32[i11 >> 2] = i2;
    i5 = i9;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -32 - i4 | 0) >>> 5) << 5);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN9Projector12AddToManagerEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 8 | 0;
 i11 = i17;
 i15 = HEAP32[gb + 1112268 >> 2] | 0;
 i16 = i15 + 56 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i13 = i15 + 60 | 0;
 i2 = i1;
 if ((i2 | 0) != (i13 | 0)) {
  i9 = i15 + 64 | 0;
  i8 = i15 + 60 | 0;
  while (1) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i6 = (i3 | 0) == 0;
   if (i6) {
    i4 = i1;
    while (1) {
     i5 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i5 >> 2] | 0) == (i4 | 0)) break; else i4 = i5;
    }
   } else {
    i4 = i3;
    while (1) {
     i5 = HEAP32[i4 >> 2] | 0;
     if (!i5) {
      i5 = i4;
      break;
     } else i4 = i5;
    }
   }
   if ((HEAP32[i2 + 20 >> 2] | 0) == (i12 | 0)) {
    i7 = i1;
    if (i6) {
     i4 = i7;
     while (1) {
      i3 = HEAP32[i4 + 8 >> 2] | 0;
      if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
     }
    } else while (1) {
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else i3 = i4;
    }
    if ((HEAP32[i16 >> 2] | 0) == (i2 | 0)) HEAP32[i16 >> 2] = i3;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
    __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i7);
    __ZdlPv(i1);
   }
   i1 = i5;
   if ((i5 | 0) == (i13 | 0)) break; else i2 = i5;
  }
 }
 i4 = i12 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i6 = 2501; else {
  HEAP32[i11 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 21; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
    i2 = HEAP32[i10 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 21; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 23;
   }
  }
  if ((i14 | 0) == 21) i14 = 23;
  if ((i14 | 0) == 23) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i6 = 2501;
    break;
   }
  }
  i6 = __ZNK8Material20GetActualRenderQueueEv(i1) | 0;
  i6 = (i6 | 0) == 2e3 ? 2501 : i6;
 } while (0);
 i5 = i12;
 i1 = HEAP32[i13 >> 2] | 0;
 do if (!i1) {
  i4 = i13;
  i3 = i13;
 } else {
  while (1) if ((HEAP32[i1 + 16 >> 2] | 0) > (i6 | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i14 = 28;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i14 = 31;
    break;
   } else i1 = i2;
  }
  if ((i14 | 0) == 28) {
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i14 | 0) == 31) {
   i4 = i1;
   break;
  }
 } while (0);
 i2 = __Znwj(24) | 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
 if (!i1) {
  i16 = i2;
  i14 = i15 + 60 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i14, i16);
  i16 = i15 + 64 | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i15 = i15 + 1 | 0;
  HEAP32[i16 >> 2] = i15;
  STACKTOP = i17;
  return;
 }
 HEAP32[i16 >> 2] = i1;
 i16 = HEAP32[i3 >> 2] | 0;
 i14 = i15 + 60 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i14, i16);
 i16 = i15 + 64 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 i15 = i15 + 1 | 0;
 HEAP32[i16 >> 2] = i15;
 STACKTOP = i17;
 return;
}

function __ZN5physx18ReducedVertexCloud6ReduceEPNS_12REDUCEDCLOUDE(i13, i16) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 12 | 0;
 i5 = i18 + 49 | 0;
 i7 = i18;
 i8 = i18 + 48 | 0;
 i15 = i13 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i14, HEAP32[i15 >> 2] | 0);
 HEAP32[i15 >> 2] = 0;
 i9 = i13 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i18 + 50 | 0, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
 if (!i1) i1 = 0; else {
  i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i1 = mftCall_iiiiii(i11 | 0, i12 | 0, i1 | 0, (i2 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 728744 | 0, 57) | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i1;
 i1 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
 if (!i1) i4 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i12 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i4 = mftCall_iiiiii(i12 | 0, i2 | 0, i1 | 0, (i4 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 728744 | 0, 59) | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 if (i2 | 0) {
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i1 + (i3 * 12 | 0) >> 2];
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 }
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i14);
 __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i14, i4, HEAP32[i13 >> 2] | 0, 1) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 * 12 | 0) + 4 >> 2];
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i14, i4, i1, 1) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = HEAP32[i13 + 4 >> 2] | 0;
  i3 = 0;
  do {
   HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 * 12 | 0) + 8 >> 2];
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i6 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i14, i4, i1, 1) | 0) + 8 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i4);
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, (HEAP32[i13 >> 2] | 0) * 12 | 0, gb + 728744 | 0, 80) | 0;
 HEAP32[i9 >> 2] = i11;
 i1 = HEAP32[i13 >> 2] | 0;
 i10 = i11;
 if (i1 | 0) {
  i8 = HEAP32[i13 + 4 >> 2] | 0;
  i9 = HEAP32[i15 >> 2] | 0;
  do {
   i1 = i1 + -1 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = i6 + 4 | 0;
   i4 = i7;
   i7 = i8 + (i5 * 12 | 0) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i8 + (i5 * 12 | 0) + 4 | 0;
   if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) if ((HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] | 0) == (HEAP32[i4 + 8 >> 2] | 0)) i2 = HEAP32[i12 >> 2] | 0; else i17 = 20; else i17 = 20; else i17 = 20;
   if ((i17 | 0) == 20) {
    i17 = 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i13 = i4 + 1 | 0;
    HEAP32[i12 >> 2] = i13;
    HEAP32[i11 + (i4 * 12 | 0) >> 2] = i2;
    HEAP32[i11 + (i4 * 12 | 0) + 4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i11 + (i4 * 12 | 0) + 8 >> 2] = HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2];
    i2 = i13;
   }
   HEAP32[i9 + (i5 << 2) >> 2] = i2 + -1;
  } while ((i1 | 0) != 0);
 }
 if (!i16) {
  __ZN5physx2Gu17RadixSortBufferedD2Ev(i14);
  STACKTOP = i18;
  return 1;
 }
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 >> 2] = i10;
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i14);
 STACKTOP = i18;
 return 1;
}

function __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i5 = mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0;
 i2 = mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0;
 if (!i5) {
  if (!i2) {
   i9 = 0;
   return i9 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i1 = i7 + 4 | 0;
  i14 = i8 + 4 | 0;
  i15 = HEAP32[i1 >> 2] | 0;
  i2 = i7 + 8 | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  i3 = i7 + 12 | 0;
  i12 = HEAP32[i3 >> 2] | 0;
  i4 = i7 + 16 | 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i5 = i7 + 20 | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  HEAP32[i14 >> 2] = i15;
  HEAP32[i8 + 8 >> 2] = i13;
  HEAP32[i8 + 12 >> 2] = i12;
  HEAP32[i8 + 16 >> 2] = i11;
  HEAP32[i8 + 20 >> 2] = i10;
  if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
   i15 = 1;
   return i15 | 0;
  }
  i10 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i10;
  i10 = i6 + 4 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i6 + 8 >> 2] | 0;
  i13 = HEAP32[i6 + 12 >> 2] | 0;
  i14 = HEAP32[i6 + 16 >> 2] | 0;
  i15 = HEAP32[i6 + 20 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i1 >> 2] = i11;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i3 >> 2] = i13;
  HEAP32[i4 >> 2] = i14;
  HEAP32[i5 >> 2] = i15;
  i15 = 2;
  return i15 | 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i9 = i6 + 4 | 0;
  i11 = i8 + 4 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i6 + 8 >> 2] | 0;
  i13 = HEAP32[i6 + 12 >> 2] | 0;
  i14 = HEAP32[i6 + 16 >> 2] | 0;
  i15 = HEAP32[i6 + 20 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i11 >> 2] = i10;
  HEAP32[i8 + 8 >> 2] = i12;
  HEAP32[i8 + 12 >> 2] = i13;
  HEAP32[i8 + 16 >> 2] = i14;
  HEAP32[i8 + 20 >> 2] = i15;
  i15 = 1;
  return i15 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i14 = i6 + 4 | 0;
 i5 = i7 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 i4 = HEAP32[i6 + 16 >> 2] | 0;
 i15 = HEAP32[i6 + 20 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i5 >> 2] = i1;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = i7 + 20 | 0;
 HEAP32[i4 >> 2] = i15;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0)) {
  i15 = 1;
  return i15 | 0;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i11;
 i11 = i8 + 4 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i15 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i11 >> 2] = i10;
 HEAP32[i8 + 8 >> 2] = i12;
 HEAP32[i8 + 12 >> 2] = i13;
 HEAP32[i8 + 16 >> 2] = i14;
 HEAP32[i8 + 20 >> 2] = i15;
 i15 = 2;
 return i15 | 0;
}

function __GLOBAL__sub_I_runtime_physics2d2_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457512 | 0, gb + 797929 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457524 | 0, gb + 797953 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457536 | 0, gb + 797975 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457548 | 0, gb + 797999 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457560 | 0, gb + 798029 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457572 | 0, gb + 798048 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457584 | 0, gb + 798075 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457596 | 0, gb + 798102 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457608 | 0, gb + 798122 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457620 | 0, gb + 798141 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457632 | 0, gb + 798163 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457644 | 0, gb + 798181 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457656 | 0, gb + 798202 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457668 | 0, gb + 798223 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457680 | 0, gb + 798247 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457692 | 0, gb + 798265 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457704 | 0, gb + 798286 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457716 | 0, gb + 798308 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457728 | 0, gb + 798333 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457740 | 0, gb + 798356 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457752 | 0, gb + 798382 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457764 | 0, gb + 798405 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457776 | 0, gb + 798431 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457788 | 0, gb + 798455 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457800 | 0, gb + 798482 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457812 | 0, gb + 798503 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457824 | 0, gb + 798527 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457836 | 0, gb + 798556 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457848 | 0, gb + 798588 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457860 | 0, gb + 798620 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457872 | 0, gb + 798659 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457884 | 0, gb + 798693 | 0, 3, 0);
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i21, i1, i3, i2) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 8 | 0;
 i17 = i20;
 i19 = i20 + 12 | 0;
 i12 = i20 + 64 | 0;
 i16 = i20 + 32 | 0;
 i15 = i21 + 8 | 0;
 i10 = i3 + 12 | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
 i13 = i19 + 5 | 0;
 i6 = i19 + 8 | 0;
 HEAP32[i19 + 12 >> 2] = 0;
 i14 = i19 + 16 | 0;
 HEAP8[i13 >> 0] = 1;
 HEAP32[i6 >> 2] = i19;
 HEAP32[i14 >> 2] = 5;
 HEAP8[i12 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE6resizeEjRKb(i19, i11, i12);
 if (i11 | 0) {
  i7 = i17 + 4 | 0;
  i8 = i21 + 4 | 0;
  i9 = i21 + 12 | 0;
  i12 = 0;
  do {
   i1 = i16;
   i2 = i1 + 32 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i18 >> 2] = i12;
   __ZN5physx6string9sprintf_sEPcjPKcz(i16, 32, gb + 832301 | 0, i18) | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    i2 = 0;
   } else {
    i3 = i2 + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
     i2 = HEAP32[i8 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
     i2 = HEAP32[i21 >> 2] | 0;
     HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
     i2 = HEAP32[i21 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i2 + 8 >> 2] | 0;
    } else i3 = i1;
   }
   HEAP32[i17 >> 2] = i16;
   HEAP8[i7 >> 0] = 0;
   i1 = i3 + 8 | 0;
   if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i22 = i17;
    i4 = HEAP32[i22 + 4 >> 2] | 0;
    i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i5 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i17) | 0;
   i3 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i15 >> 2] | 0, i12 | 0) | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i21 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
   i2 = i3 ? gb + 1087447 | 0 : gb + 1087441 | 0;
   if (HEAP8[i2 >> 0] | 0) mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, (i3 ? 4 : 5) | 0) | 0;
   HEAP8[i17 >> 0] = 0;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i17 | 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i2 = HEAP32[i21 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (i1 | 0) {
    if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
     i1 = HEAP32[i8 >> 2] | 0;
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
     i1 = HEAP32[i21 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i11 | 0));
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i22 = HEAP32[i14 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i20;
  return;
 }
 if ((i19 | 0) == (i1 | 0)) {
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i20;
  return;
 }
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
 STACKTOP = i20;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2505;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E14squash_deletedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 76 | 0;
 i4 = i5;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i14 = i4 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i13 = i4 + 8 | 0;
 i15 = i3 + 8 | 0;
 i9 = HEAP16[i15 >> 1] | 0;
 HEAP8[i13 >> 0] = i9;
 i12 = i4 + 9 | 0;
 HEAP8[i12 >> 0] = (i9 & 65535) >>> 8;
 i9 = i4 + 12 | 0;
 i11 = i3 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 i10 = i4 + 32 | 0;
 i7 = i3 + 32 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 i8 = i4 + 52 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i8 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i4, i3, 0);
 i16 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i16;
 i2 = HEAP8[i15 >> 0] | 0;
 i14 = HEAP16[i13 >> 1] | 0;
 HEAP8[i15 >> 0] = i14;
 HEAP8[i13 >> 0] = i2;
 i13 = i3 + 9 | 0;
 i2 = HEAP8[i13 >> 0] | 0;
 HEAP8[i13 >> 0] = (i14 & 65535) >>> 8;
 HEAP8[i12 >> 0] = i2;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 i10 = i3 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i8 = i3 + 56 | 0;
 i10 = i4 + 56 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i10 >> 2] = i2;
 i10 = i3 + 60 | 0;
 i8 = i4 + 60 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i9;
 f6 = Math_fround(i7 >>> 0);
 HEAP32[i3 + 68 >> 2] = ~~Math_fround(f6 * Math_fround(.5)) >>> 0;
 HEAP32[i3 + 64 >> 2] = ~~Math_fround(f6 * Math_fround(.200000003)) >>> 0;
 HEAP8[i3 + 72 >> 0] = 0;
 f6 = Math_fround(i2 >>> 0);
 HEAP32[i4 + 68 >> 2] = ~~Math_fround(f6 * Math_fround(.5)) >>> 0;
 HEAP32[i4 + 64 >> 2] = ~~Math_fround(f6 * Math_fround(.200000003)) >>> 0;
 HEAP8[i4 + 72 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EEPS1_(i11, i12, i10) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i14 = i12 + 4 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 if ((i7 | 0) == (i10 | 0)) i1 = i15; else {
  i8 = i13 + 4 | 0;
  i6 = i10;
  i1 = i15;
  do {
   i3 = i1 + -16 | 0;
   i2 = i6;
   i6 = i6 + -16 | 0;
   i5 = HEAP8[i6 + 11 >> 0] | 0;
   i9 = i5 << 24 >> 24 < 0;
   i4 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
   i5 = i9 ? HEAP32[i2 + -12 >> 2] | 0 : i5 & 255;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + -4 >> 2] = i2;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
    i2 = HEAP32[i1 + -4 >> 2] | 0;
    i16 = 6;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i3 + 11 >> 0] = i5;
    if (!i5) i1 = i3; else {
     i1 = i3;
     i16 = 8;
    }
   } else i16 = 6;
   if ((i16 | 0) == 6) {
    i18 = i5 + 16 & -16;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i3 >> 2] = i9;
    HEAP32[i1 + -8 >> 2] = i18 | -2147483648;
    HEAP32[i1 + -12 >> 2] = i5;
    i1 = i9;
    i16 = 8;
   }
   if ((i16 | 0) == 8) {
    i16 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i1 = (HEAP32[i14 >> 2] | 0) + -16 | 0;
   HEAP32[i14 >> 2] = i1;
  } while ((i6 | 0) != (i7 | 0));
 }
 i7 = i11 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i12 + 8 | 0;
 if ((i8 | 0) == (i10 | 0)) {
  i18 = i14;
  i16 = i1;
  i13 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i16;
  HEAP32[i18 >> 2] = i13;
  i13 = HEAP32[i7 >> 2] | 0;
  i16 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 >> 2] = i16;
  HEAP32[i9 >> 2] = i13;
  i13 = i11 + 8 | 0;
  i16 = i12 + 12 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i11 = HEAP32[i16 >> 2] | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i16 >> 2] = i14;
  i18 = HEAP32[i18 >> 2] | 0;
  HEAP32[i12 >> 2] = i18;
  STACKTOP = i17;
  return i15 | 0;
 }
 i6 = i13 + 4 | 0;
 i4 = i10;
 i1 = HEAP32[i9 >> 2] | 0;
 do {
  i5 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
  i5 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i16 = 16;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i16 = 18;
  } else i16 = 16;
  if ((i16 | 0) == 16) {
   i10 = i5 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i18;
   HEAP32[i1 + 8 >> 2] = i10 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i18;
   i16 = 18;
  }
  if ((i16 | 0) == 18) {
   i16 = 0;
   _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  i4 = i4 + 16 | 0;
  i1 = (HEAP32[i9 >> 2] | 0) + 16 | 0;
  HEAP32[i9 >> 2] = i1;
 } while ((i4 | 0) != (i8 | 0));
 i18 = i14;
 i16 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i16;
 HEAP32[i18 >> 2] = i13;
 i13 = HEAP32[i7 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i9 >> 2] = i13;
 i13 = i11 + 8 | 0;
 i16 = i12 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i16 >> 2] = i14;
 i18 = HEAP32[i18 >> 2] | 0;
 HEAP32[i12 >> 2] = i18;
 STACKTOP = i17;
 return i15 | 0;
}

function __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 96 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 96 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 96 | 0;
  i3 = (i2 | 0) / 96 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 96 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN19ComputeShaderKernelC2ERKS_(i2, i1);
     i1 = i1 + 96 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 96 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -96 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN19ComputeShaderKernelD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 96 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 96 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 96 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 96 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 96 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -96 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN19ComputeShaderKernelD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -96 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN19ComputeShaderKernelD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function _inet_pton(i1, i4, i12) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 L1 : do switch (i1 | 0) {
 case 2:
  {
   i5 = 0;
   while (1) {
    i3 = 0;
    i2 = 0;
    while (1) {
     i1 = HEAP8[i4 + i2 >> 0] | 0;
     if ((i1 + -48 | 0) >>> 0 >= 10) {
      i11 = 5;
      break;
     }
     i1 = (i3 * 10 | 0) + -48 + i1 | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) < 3) i3 = i1; else {
      i11 = 7;
      break;
     }
    }
    if ((i11 | 0) == 5) {
     i11 = 0;
     if (!i2) {
      i1 = 0;
      break L1;
     }
     if ((i2 | 0) > 1) {
      i1 = i3;
      i2 = 2;
      i11 = 7;
     } else if ((i3 | 0) > 255) {
      i1 = 0;
      break L1;
     } else i1 = i3;
    }
    if ((i11 | 0) == 7) if ((i1 | 0) > 255 | (HEAP8[i4 >> 0] | 0) == 48) {
     i1 = 0;
     break L1;
    }
    HEAP8[i12 + i5 >> 0] = i1;
    i1 = HEAP8[i4 + i2 >> 0] | 0;
    if ((i5 | 0) == 3 & i1 << 24 >> 24 == 0) {
     i1 = 1;
     break L1;
    }
    if (i1 << 24 >> 24 != 46) {
     i1 = 0;
     break L1;
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= 4) {
     i1 = 0;
     break;
    } else i4 = i4 + (i2 + 1) | 0;
   }
   break;
  }
 case 10:
  {
   i2 = HEAP8[i4 >> 0] | 0;
   if (i2 << 24 >> 24 == 58) {
    i1 = i4 + 1 | 0;
    if ((HEAP8[i1 >> 0] | 0) == 58) {
     i3 = -1;
     i9 = 0;
     i2 = 58;
    } else {
     i1 = 0;
     break L1;
    }
   } else {
    i3 = -1;
    i9 = 0;
    i1 = i4;
   }
   L20 : while (1) {
    i8 = (i3 | 0) < 0;
    if (i8 & i2 << 24 >> 24 == 58) {
     HEAP16[i10 + ((i9 & 7) << 1) >> 1] = 0;
     i1 = i1 + 1 | 0;
     i2 = HEAP8[i1 >> 0] | 0;
     if (!(i2 << 24 >> 24)) {
      i5 = 0;
      i3 = i9;
      i2 = i9;
      i4 = i1;
      break;
     }
     if ((i9 | 0) == 7) {
      i1 = 0;
      break L1;
     } else i3 = i9;
    } else {
     i7 = 0;
     i4 = 0;
     while (1) {
      i5 = i2 << 24 >> 24;
      i2 = i5 + -48 | 0;
      i5 = i5 | 32;
      i6 = i5 + -87 | 0;
      if (i2 >>> 0 >= 10) if ((i5 + -97 | 0) >>> 0 < 6 & (i6 | 0) > -1) i2 = i6; else {
       i11 = 22;
       break;
      }
      i2 = i2 + (i7 << 4) | 0;
      i5 = i4 + 1 | 0;
      if ((i5 | 0) >= 4) {
       i4 = i5;
       break;
      }
      i7 = i2;
      i4 = i5;
      i2 = HEAP8[i1 + i5 >> 0] | 0;
     }
     if ((i11 | 0) == 22) {
      i11 = 0;
      if (!i4) {
       i1 = 0;
       break L1;
      } else i2 = i7;
     }
     HEAP16[i10 + ((i9 & 7) << 1) >> 1] = i2;
     i2 = HEAP8[i1 + i4 >> 0] | 0;
     if (!(i2 << 24 >> 24)) if ((i9 | 0) == 7 | (i3 | 0) > -1) {
      i5 = 0;
      i2 = i9;
      i4 = i1;
      break;
     }
     if ((i9 | 0) == 7) {
      i1 = 0;
      break L1;
     }
     switch (i2 << 24 >> 24) {
     case 46:
      {
       i11 = 27;
       break L20;
      }
     case 58:
      break;
     default:
      {
       i1 = 0;
       break L1;
      }
     }
     i2 = i1 + (i4 + 1) | 0;
     i1 = i2;
     i2 = HEAP8[i2 >> 0] | 0;
    }
    i9 = i9 + 1 | 0;
   }
   if ((i11 | 0) == 27) {
    if ((i9 | 0) < 6 & i8) {
     i1 = 0;
     break L1;
    }
    i5 = 1;
    i2 = i9 + 1 | 0;
    i4 = i1;
   }
   if ((i3 | 0) > -1) {
    i1 = i10 + (i3 << 1) | 0;
    _memmove(i1 + 14 + (0 - i2 << 1) | 0, i1 | 0, i2 + 1 - i3 << 1 | 0) | 0;
    if ((i2 | 0) < 7) {
     _memset(i1 | 0, 0, 14 - (i2 << 1) | 0) | 0;
     i1 = i12;
     i2 = 0;
    } else {
     i1 = i12;
     i2 = 0;
    }
   } else {
    i1 = i12;
    i2 = 0;
   }
   while (1) {
    i11 = i10 + (i2 << 1) | 0;
    HEAP8[i1 >> 0] = (HEAPU16[i11 >> 1] | 0) >>> 8;
    HEAP8[i1 + 1 >> 0] = HEAP16[i11 >> 1];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == 8) break; else i1 = i1 + 2 | 0;
   }
   if (i5 | 0) if ((_inet_pton(2, i4, i12 + 12 | 0) | 0) < 1) {
    i1 = 0;
    break L1;
   }
   i1 = 1;
   break;
  }
 default:
  {
   HEAP32[(___errno_location() | 0) >> 2] = 97;
   i1 = -1;
  }
 } while (0);
 STACKTOP = i13;
 return i1 | 0;
}

function __Z14GetDeviceColorRK10ColorRGBAf(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f9 = f0;
 if ((__Z19GetActiveColorSpacev() | 0) != 1) {
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = f7 < Math_fround(0.0);
  f7 = i4 ? Math_fround(0.0) : f7;
  i4 = f7 > Math_fround(1.0);
  i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i5 = f7 < Math_fround(0.0);
  f7 = i5 ? Math_fround(0.0) : f7;
  i5 = f7 > Math_fround(1.0);
  i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i6 = f7 < Math_fround(0.0);
  f7 = i6 ? Math_fround(0.0) : f7;
  i6 = f7 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  i3 = f7 < Math_fround(0.0);
  f7 = i3 ? Math_fround(0.0) : f7;
  i3 = f7 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
   HEAP32[i8 >> 2] = i5 << 8 & 65280 | i4 & 255 | i6 << 16 & 16711680 | i3 << 24;
   return;
  } else {
   HEAP8[i8 >> 0] = i6;
   HEAP8[i8 + 1 >> 0] = i5;
   HEAP8[i8 + 2 >> 0] = i4;
   HEAP8[i8 + 3 >> 0] = i3;
   return;
  }
 }
 i6 = (__Z19GetActiveColorSpacev() | 0) == 1;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 do if (i6) {
  do if (!(f1 <= Math_fround(.0404499993))) {
   if (f1 < Math_fround(1.0)) {
    f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
  } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
  f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  if (f7 <= Math_fround(.0404499993)) {
   f7 = Math_fround(f7 / Math_fround(12.9200001));
   break;
  }
  if (f7 < Math_fround(1.0)) {
   f7 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f7 == Math_fround(1.0)) f7 = Math_fround(1.0); else f7 = Math_fround(+Math_pow(+f7, 2.20000005));
 } else {
  f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 } while (0);
 f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i6 = f1 < Math_fround(0.0);
 f1 = i6 ? Math_fround(0.0) : f1;
 i6 = f1 > Math_fround(1.0);
 i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f1) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i5 = f2 < Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 i5 = f2 > Math_fround(1.0);
 i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f2) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i4 = f9 < Math_fround(0.0);
 f7 = i4 ? Math_fround(0.0) : f9;
 i4 = f7 > Math_fround(1.0);
 i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0)) {
  HEAP32[i8 >> 2] = i5 << 8 & 65280 | i6 & 255 | i3 << 16 & 16711680 | i4 << 24;
  return;
 } else {
  HEAP8[i8 >> 0] = i3;
  HEAP8[i8 + 1 >> 0] = i5;
  HEAP8[i8 + 2 >> 0] = i6;
  HEAP8[i8 + 3 >> 0] = i4;
  return;
 }
}

function __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i3 + 124 | 0;
 i21 = i3 + 96 | 0;
 i15 = i3 + 56 | 0;
 i14 = i3 + 24 | 0;
 i13 = i3;
 i23 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 32 >> 2] | 0, i15 | 0, i23 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i22 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 72 >> 2] | 0, i21 | 0, i23 | 0);
 f17 = Math_fround(Math_fround(HEAPF32[i21 + 16 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i22 >> 2]);
 f6 = Math_fround(f17 * f18);
 f16 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * f16));
 f10 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f5 * f10));
 f9 = Math_fround(Math_fround(f18 * f6) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f5 * f16) - Math_fround(f7 * f10)))));
 f12 = Math_fround(Math_fround(f16 * f6) + Math_fround(Math_fround(f7 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f10) - Math_fround(f5 * f18)))));
 f6 = Math_fround(Math_fround(Math_fround(f5 * f19) + Math_fround(f20 * Math_fround(Math_fround(f7 * f18) - Math_fround(f17 * f16)))) + Math_fround(f10 * f6));
 f9 = Math_fround(Math_fround(HEAPF32[i22 + 16 >> 2]) + f9);
 f12 = Math_fround(Math_fround(HEAPF32[i22 + 20 >> 2]) + f12);
 f6 = Math_fround(Math_fround(HEAPF32[i22 + 24 >> 2]) + f6);
 f17 = Math_fround(HEAPF32[i21 >> 2]);
 f7 = Math_fround(f20 * f17);
 f19 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f18 * f19));
 f5 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f16 * f5));
 f4 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f10 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f4))) - Math_fround(f18 * f5));
 f11 = Math_fround(Math_fround(Math_fround(f18 * f4) + Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * f5))) - Math_fround(f16 * f17));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f4)) - Math_fround(f10 * f5));
 HEAPF32[i14 >> 2] = Math_fround(f7 - Math_fround(f10 * f4));
 HEAPF32[i14 + 4 >> 2] = f8;
 HEAPF32[i14 + 8 >> 2] = f11;
 HEAPF32[i14 + 12 >> 2] = f5;
 HEAPF32[i14 + 16 >> 2] = f9;
 HEAPF32[i14 + 20 >> 2] = f12;
 HEAPF32[i14 + 24 >> 2] = f6;
 __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf(i13, i15, i14, Math_fround(1.0));
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f9 = Math_fround(f6 + f12);
 f5 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f8 = Math_fround(f5 + f11);
 f4 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 f8 = Math_fround(f8 * Math_fround(.5));
 f7 = Math_fround(Math_fround(f4 + f10) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f12 - f6) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f11 - f5) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f10 - f4) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(f9 * Math_fround(.5));
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = Math_fround(f6 + Math_fround(9.99999974e-06));
 HEAPF32[i1 + 16 >> 2] = Math_fround(f5 + Math_fround(9.99999974e-06));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f4 + Math_fround(9.99999974e-06));
 STACKTOP = i3;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 2450;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __ZN20UnityConnectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i1 = i9 + 196 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 197 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 200 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 204 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 216 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 220 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN22CrashReportingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 28 | 0, i10);
 i1 = i9 + 64 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i12 = i9 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  i12 = i9 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i12 = i9 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  i12 = i9 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx16PxsFluidDynamics9updateSphERNS_10PxBaseTaskE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i2 = i11 + 80 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i6 = HEAP32[i8 + 40 >> 2] | 0;
 i7 = HEAP32[i8 + 36 >> 2] | 0;
 i8 = HEAP32[HEAP32[i8 + 72 >> 2] >> 2] | 0;
 i4 = i11 + 84 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[i1 + 8 >> 2] << 5 | 19;
  i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i13 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i13 | 0, i12 | 0, i3 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 768860 | 0, 297) | 0;
  if (!i1) i1 = 0; else {
   i13 = i1 + 19 & -16;
   HEAP32[i13 + -4 >> 2] = i13 - i1;
   i1 = i13;
  }
  HEAP32[i4 >> 2] = i1;
 }
 i3 = i11 + 88 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = (HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0) + 8 >> 2] | 0) * 12 | 0;
  i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i12 | 0, i13 | 0, i2 + 23 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 768860 | 0, 308) | 0;
  if (!i1) i1 = 0; else {
   i13 = i1 + 19 & -16;
   HEAP32[i13 + -4 >> 2] = i13 - i1;
   i1 = i13;
  }
  HEAP32[i3 >> 2] = i1;
  _memset(i1 | 0, 0, i2 + 4 | 0) | 0;
 }
 if (i6 | 0) {
  i1 = 0;
  do {
   i12 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
   i13 = HEAP32[i4 >> 2] | 0;
   HEAP32[i13 + (i1 << 5) >> 2] = HEAP32[i5 + (i12 << 5) >> 2];
   HEAP32[i13 + (i1 << 5) + 4 >> 2] = HEAP32[i5 + (i12 << 5) + 4 >> 2];
   HEAP32[i13 + (i1 << 5) + 8 >> 2] = HEAP32[i5 + (i12 << 5) + 8 >> 2];
   HEAP32[i13 + (i1 << 5) + 12 >> 2] = HEAP32[i5 + (i12 << 5) + 12 >> 2];
   HEAP32[i13 + (i1 << 5) + 16 >> 2] = HEAP32[i5 + (i12 << 5) + 16 >> 2];
   HEAP32[i13 + (i1 << 5) + 20 >> 2] = HEAP32[i5 + (i12 << 5) + 20 >> 2];
   HEAP32[i13 + (i1 << 5) + 24 >> 2] = HEAP32[i5 + (i12 << 5) + 24 >> 2];
   i13 = i13 + (i1 << 5) + 28 | 0;
   i12 = i5 + (i12 << 5) + 28 | 0;
   i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
   HEAP16[i13 >> 1] = i12;
   HEAP16[i13 + 2 >> 1] = i12 >>> 16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i7 = i6 >>> 3;
 i6 = 0;
 i1 = 0;
 i2 = 0;
 i7 = i7 >>> 0 < 512 ? 512 : i7;
 do {
  i7 = (i6 | 0) == 7 ? -1 : i7;
  if ((i2 & 65535) < 1024 & (i7 | 0) != 0) {
   i3 = 0;
   i4 = i2;
   do {
    i13 = HEAP32[i8 + ((i4 & 65535) << 4) + 8 >> 2] | 0;
    i3 = ((i13 | 0) == -1 ? 0 : i13) + i3 | 0;
    i4 = i4 + 1 << 16 >> 16;
   } while ((i4 & 65535) < 1024 & i3 >>> 0 < i7 >>> 0);
   i5 = i4;
   i4 = i11 + 512 + (i6 << 2) | 0;
   if (!i3) {
    i2 = i5;
    i9 = 17;
   } else {
    HEAP16[i4 >> 1] = i2;
    i3 = i5;
    i1 = i1 + 1 | 0;
    i2 = i5;
   }
  } else {
   i4 = i11 + 512 + (i6 << 2) | 0;
   i9 = 17;
  }
  if ((i9 | 0) == 17) {
   i9 = 0;
   HEAP16[i4 >> 1] = -1;
   i3 = -1;
  }
  HEAP16[i11 + 512 + (i6 << 2) + 2 >> 1] = i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 8);
 HEAP32[i11 + 148 >> 2] = i1;
 i13 = HEAP32[i11 + 156 >> 2] | 0;
 __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj(i11, i1 >>> 0 < i13 >>> 0 ? i13 : i1);
 HEAP32[i11 + 136 >> 2] = 1;
 i13 = i11 + 132 | 0;
 HEAP32[i13 >> 2] = i10;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 HEAP32[i11 + 128 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2];
 i13 = i11 + 92 | 0;
 i10 = i11 + 120 | 0;
 HEAP32[i11 + 108 >> 2] = 1;
 i12 = i11 + 104 | 0;
 HEAP32[i12 >> 2] = i10;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 HEAP32[i11 + 100 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2];
 __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE(i11, 0, i13);
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0);
 return;
}

function __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i2, i13, i14) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18;
 i16 = i18 + 24 | 0;
 i17 = (i13 | 0) == 0;
 do if (!i17) {
  i1 = HEAP32[i13 + 16 >> 2] | 0;
  if ((i1 & 255 | 0) != 3) {
   if ((i1 | 0) != 4) break;
   i12 = (HEAP32[i2 + 152 >> 2] | 0) + ((HEAP32[i2 + 164 >> 2] | 0) + -1 << 2) | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = i1 + 1;
   i1 = (HEAP32[i13 >> 2] | 0) + (i1 * 24 | 0) | 0;
   if (!i1) break;
   STACKTOP = i18;
   return i1 | 0;
  }
  i1 = i14;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  i12 = i14;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  HEAP32[i15 + 12 >> 2] = 0;
  HEAP32[i15 + 16 >> 2] = 1048581;
  HEAP32[i15 >> 2] = i12;
  HEAP32[i15 + 4 >> 2] = i1 - i12;
  i1 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i13, i15) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
  if ((i1 | 0) != ((HEAP32[i13 >> 2] | 0) + ((HEAP32[i13 + 4 >> 2] | 0) * 48 | 0) | 0)) {
   i17 = i1 + 24 | 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 } while (0);
 HEAP32[i16 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i16 + 4 >> 2] = __Z29GetGlobalAllowNameConversionsv() | 0;
 i7 = i2 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L13 : do if (!i1) i1 = 0; else {
  i8 = i13 + 16 | 0;
  i9 = i15 + 16 | 0;
  i10 = i15 + 4 | 0;
  i11 = i13 + 4 | 0;
  i12 = i2 + 164 | 0;
  i6 = i2 + 152 | 0;
  i5 = 0;
  while (1) {
   i1 = __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_(HEAP32[i16 + (i5 << 2) >> 2] | 0, i1, i14) | 0;
   L17 : do if (i1 | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    i4 = i1 + 4 | 0;
    if ((i2 | 0) != (i4 | 0)) {
     if (i17) while (1) {
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((i1 | 0) == (i4 | 0)) break L17; else i2 = i1;
     }
     while (1) {
      i3 = HEAP32[i2 + 16 >> 2] | 0;
      i1 = HEAP32[i8 >> 2] | 0;
      if ((i1 & 255 | 0) == 3) {
       i1 = i3;
       while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
       HEAP32[i15 >> 2] = 0;
       HEAP32[i15 + 4 >> 2] = 0;
       HEAP32[i15 + 8 >> 2] = 0;
       HEAP32[i15 + 12 >> 2] = 0;
       HEAP32[i9 >> 2] = 1048581;
       HEAP32[i15 >> 2] = i3;
       HEAP32[i10 >> 2] = i1 - i3;
       i1 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i13, i15) | 0;
       __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
       if ((i1 | 0) != ((HEAP32[i13 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 48 | 0) | 0)) {
        i1 = i1 + 24 | 0;
        break L13;
       }
      } else if ((i1 | 0) == 4) {
       i3 = (HEAP32[i6 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
       i1 = HEAP32[i3 >> 2] | 0;
       HEAP32[i3 >> 2] = i1 + 1;
       i1 = (HEAP32[i13 >> 2] | 0) + (i1 * 24 | 0) | 0;
       if (i1 | 0) break L13;
      }
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      } else while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) break; else i1 = i2;
      }
      if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
     }
    }
   } while (0);
   i1 = i5 + 1 | 0;
   if ((i1 | 0) >= 2) {
    i1 = 0;
    break L13;
   }
   i5 = i1;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 } while (0);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvRS2_S5_RKS2_S7_(i22, i20, i21, i1, i2) {
 i22 = i22 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 f3 = Math_fround(HEAPF32[i21 >> 2]);
 f4 = Math_fround(HEAPF32[i20 >> 2]);
 f11 = Math_fround(f3 - f4);
 i13 = i21 + 4 | 0;
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i20 + 4 | 0;
 f16 = Math_fround(HEAPF32[i15 >> 2]);
 f17 = Math_fround(f14 - f16);
 i18 = i21 + 8 | 0;
 f19 = Math_fround(HEAPF32[i18 >> 2]);
 i1 = i20 + 8 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f19 - f5);
 i2 = i21 + 12 | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 i8 = i20 + 12 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f7 - f9);
 f12 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f17 * f17)) + Math_fround(f6 * f6));
 if (f12 > Math_fround(HEAPF32[i22 + 16 >> 2])) if (f12 > Math_fround(HEAPF32[i22 + 20 >> 2])) if (f12 > Math_fround(HEAPF32[i22 + 24 >> 2])) if (f12 > Math_fround(HEAPF32[i22 + 28 >> 2])) return;
 f28 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12))));
 f32 = Math_fround(f28 * Math_fround(HEAPF32[i22 >> 2]));
 f30 = Math_fround(f28 * Math_fround(HEAPF32[i22 + 4 >> 2]));
 f29 = Math_fround(f28 * Math_fround(HEAPF32[i22 + 8 >> 2]));
 f28 = Math_fround(f28 * Math_fround(HEAPF32[i22 + 12 >> 2]));
 f31 = Math_fround(HEAPF32[gb + 1097584 >> 2]);
 f23 = Math_fround(HEAPF32[gb + 1097584 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[gb + 1097584 + 8 >> 2]);
 f31 = Math_fround(Math_fround(1.0) / Math_fround(f7 + Math_fround(f9 + f31)));
 f23 = Math_fround(Math_fround(1.0) / Math_fround(f7 + Math_fround(f9 + f23)));
 f24 = Math_fround(Math_fround(1.0) / Math_fround(f7 + Math_fround(f9 + f24)));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(f7 + Math_fround(f9 + Math_fround(HEAPF32[gb + 1097584 + 12 >> 2]))));
 f31 = Math_fround(f31 * Math_fround(HEAPF32[i22 + 32 >> 2]));
 f23 = Math_fround(f23 * Math_fround(HEAPF32[i22 + 36 >> 2]));
 f24 = Math_fround(f24 * Math_fround(HEAPF32[i22 + 40 >> 2]));
 f11 = Math_fround(Math_fround(f11 - Math_fround(f11 * f32)) * f31);
 f23 = Math_fround(Math_fround(f17 - Math_fround(f17 * f30)) * f23);
 f24 = Math_fround(Math_fround(f6 - Math_fround(f6 * f29)) * f24);
 f12 = Math_fround(Math_fround(f10 - Math_fround(f10 * f28)) * Math_fround(f12 * Math_fround(HEAPF32[i22 + 44 >> 2])));
 i27 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i26 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
 i25 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
 i26 = HEAP32[gb + 1097568 + 4 >> 2] & i26;
 i25 = HEAP32[gb + 1097568 + 8 >> 2] & i25;
 i22 = HEAP32[gb + 1097568 + 12 >> 2] & (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f12 = (HEAP32[tempDoublePtr >> 2] = HEAP32[gb + 1097568 >> 2] & i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f24 = Math_fround(f9 * f12);
 f10 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(f9 * f10);
 f17 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f9 * f17);
 f11 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f23 = Math_fround(f23 + f16);
 f6 = Math_fround(f6 + f5);
 f16 = Math_fround(Math_fround(f9 * f11) + f9);
 HEAPF32[i20 >> 2] = Math_fround(f24 + f4);
 HEAPF32[i15 >> 2] = f23;
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i8 >> 2] = f16;
 f16 = Math_fround(f14 - Math_fround(f7 * f10));
 f17 = Math_fround(f19 - Math_fround(f7 * f17));
 f19 = Math_fround(f7 - Math_fround(f7 * f11));
 HEAPF32[i21 >> 2] = Math_fround(f3 - Math_fround(f7 * f12));
 HEAPF32[i13 >> 2] = f16;
 HEAPF32[i18 >> 2] = f17;
 HEAPF32[i2 >> 2] = f19;
 return;
}

function runPostSets131() {
 HEAP32[gb + 113584 >> 2] = fb + 104;
 HEAP32[gb + 113588 >> 2] = fb + 1202;
 HEAP32[gb + 113592 >> 2] = fb + 94;
 HEAP32[gb + 113596 >> 2] = fb + 1203;
 HEAP32[gb + 113600 >> 2] = fb + 866;
 HEAP32[gb + 113604 >> 2] = fb + 867;
 HEAP32[gb + 113608 >> 2] = fb + 1204;
 HEAP32[gb + 113612 >> 2] = fb + 868;
 HEAP32[gb + 113616 >> 2] = fb + 869;
 HEAP32[gb + 113620 >> 2] = fb + 1205;
 HEAP32[gb + 113624 >> 2] = fb + 870;
 HEAP32[gb + 113628 >> 2] = fb + 871;
 HEAP32[gb + 113632 >> 2] = fb + 1320;
 HEAP32[gb + 113636 >> 2] = fb + 1321;
 HEAP32[gb + 113640 >> 2] = fb + 1810;
 HEAP32[gb + 113644 >> 2] = fb + 1736;
 HEAP32[gb + 113648 >> 2] = fb + 1730;
 HEAP32[gb + 113652 >> 2] = fb + 1731;
 HEAP32[gb + 113656 >> 2] = fb + 275;
 HEAP32[gb + 113660 >> 2] = fb + 1322;
 HEAP32[gb + 113664 >> 2] = fb + 1811;
 HEAP32[gb + 113676 >> 2] = (HEAP32[gb + 113676 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 113680 >> 2] = (HEAP32[gb + 113680 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 113716 >> 2] = fb + 1812;
 HEAP32[gb + 113720 >> 2] = fb + 1813;
 HEAP32[gb + 113724 >> 2] = fb + 1757;
 HEAP32[gb + 113728 >> 2] = fb + 1238;
 HEAP32[gb + 113732 >> 2] = fb + 16;
 HEAP32[gb + 113736 >> 2] = fb + 1814;
 HEAP32[gb + 113740 >> 2] = fb + 1815;
 HEAP32[gb + 113744 >> 2] = fb + 19;
 HEAP32[gb + 113748 >> 2] = fb + 887;
 HEAP32[gb + 113752 >> 2] = fb + 103;
 HEAP32[gb + 113756 >> 2] = fb + 101;
 HEAP32[gb + 113760 >> 2] = fb + 62;
 HEAP32[gb + 113764 >> 2] = fb + 28;
 HEAP32[gb + 113768 >> 2] = fb + 63;
 HEAP32[gb + 113772 >> 2] = fb + 29;
 HEAP32[gb + 113776 >> 2] = fb + 34;
 HEAP32[gb + 113780 >> 2] = fb + 1323;
 HEAP32[gb + 113784 >> 2] = fb + 1324;
 HEAP32[gb + 113788 >> 2] = fb + 1325;
 HEAP32[gb + 113792 >> 2] = fb + 1326;
 HEAP32[gb + 113796 >> 2] = fb + 1327;
 HEAP32[gb + 113800 >> 2] = fb + 1328;
 HEAP32[gb + 113804 >> 2] = fb + 36;
 HEAP32[gb + 113808 >> 2] = fb + 104;
 HEAP32[gb + 113812 >> 2] = fb + 108;
 HEAP32[gb + 113816 >> 2] = fb + 94;
 HEAP32[gb + 113820 >> 2] = fb + 1245;
 HEAP32[gb + 113824 >> 2] = fb + 105;
 HEAP32[gb + 113828 >> 2] = fb + 106;
 HEAP32[gb + 113832 >> 2] = fb + 110;
 HEAP32[gb + 113836 >> 2] = fb + 1246;
 HEAP32[gb + 113840 >> 2] = fb + 1247;
 HEAP32[gb + 113844 >> 2] = fb + 1248;
 HEAP32[gb + 113848 >> 2] = fb + 1249;
 HEAP32[gb + 113852 >> 2] = fb + 1250;
 HEAP32[gb + 113856 >> 2] = fb + 103;
 HEAP32[gb + 113860 >> 2] = fb + 1816;
 HEAP32[gb + 113864 >> 2] = fb + 1329;
 HEAP32[gb + 113876 >> 2] = (HEAP32[gb + 113876 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 113880 >> 2] = (HEAP32[gb + 113880 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 113916 >> 2] = fb + 184;
 HEAP32[gb + 113920 >> 2] = fb + 1817;
 HEAP32[gb + 113924 >> 2] = fb + 1818;
 HEAP32[gb + 113928 >> 2] = fb + 185;
 HEAP32[gb + 113940 >> 2] = fb + 186;
 HEAP32[gb + 113944 >> 2] = fb + 1819;
 HEAP32[gb + 113948 >> 2] = fb + 1820;
 HEAP32[gb + 113960 >> 2] = fb + 1821;
 HEAP32[gb + 113964 >> 2] = fb + 1822;
 HEAP32[gb + 113968 >> 2] = fb + 9;
 HEAP32[gb + 113972 >> 2] = fb + 106;
 HEAP32[gb + 113976 >> 2] = fb + 1;
 HEAP32[gb + 113980 >> 2] = fb + 1;
 HEAP32[gb + 113984 >> 2] = fb + 352;
 HEAP32[gb + 113996 >> 2] = fb + 187;
 HEAP32[gb + 114e3 >> 2] = fb + 1053;
 HEAP32[gb + 114004 >> 2] = fb + 1054;
 HEAP32[gb + 114008 >> 2] = fb + 1823;
 HEAP32[gb + 114020 >> 2] = fb + 64;
 HEAP32[gb + 114024 >> 2] = fb + 188;
 HEAP32[gb + 114028 >> 2] = fb + 1051;
 HEAP32[gb + 114032 >> 2] = fb + 1824;
 HEAP32[gb + 114044 >> 2] = fb + 65;
 HEAP32[gb + 114048 >> 2] = fb + 188;
 HEAP32[gb + 114052 >> 2] = fb + 1825;
 HEAP32[gb + 114056 >> 2] = fb + 1826;
 HEAP32[gb + 114072 >> 2] = fb + 1827;
 HEAP32[gb + 114076 >> 2] = fb + 1828;
 HEAP32[gb + 114080 >> 2] = fb + 1829;
 HEAP32[gb + 114084 >> 2] = fb + 1330;
 HEAP32[gb + 114088 >> 2] = fb + 1331;
 HEAP32[gb + 114092 >> 2] = fb + 1332;
 HEAP32[gb + 114096 >> 2] = fb + 1333;
 HEAP32[gb + 114100 >> 2] = fb + 107;
 HEAP32[gb + 114104 >> 2] = fb + 108;
 HEAP32[gb + 114108 >> 2] = fb + 1334;
 HEAP32[gb + 114112 >> 2] = fb + 1830;
 runPostSets132();
}

function __ZN8Animator8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN14DirectorPlayer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 104 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905764 | 0, gb + 902244 | 0, i5, 0);
 i10 = i7 + 8 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905632 | 0, gb + 905645 | 0, i10, 0);
 i6 = i7 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 92 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902257 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i6 = i1 + 96 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902271 | 0, i8, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902284 | 0, i6, i1 + 417 | 0, 8388608);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902302 | 0, i6, i1 + 418 | 0, 8388608);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902327 | 0, i6, i1 + 561 | 0, 8388608);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902351 | 0, i6, i1 + 560 | 0, 8388608);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl4saveERNS_14PxOutputStreamE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i9 + 108 | 0;
 i11 = i9 + 80 | 0;
 i2 = i9 + 64 | 0;
 i8 = i9 + 12 | 0;
 i5 = i9 + 48 | 0;
 i13 = i9;
 i14 = HEAP32[i7 + 8 >> 2] | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0) | 0;
 HEAP32[i8 >> 2] = gb + 146452 + 8;
 i6 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i1;
 HEAP32[i8 + 12 >> 2] = i6;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP8[i6 + 12 >> 0] = 0;
 HEAP32[i8 + 32 >> 2] = 0;
 __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8beginTagEPKc(i8, gb + 766844 | 0);
 __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE12addAttributeEPKcS5_(i8, gb + 1039677 | 0, HEAP32[i7 + 156 >> 2] | 0);
 i14 = i7 + 104 | 0;
 HEAP32[i5 >> 2] = gb + 146492 + 8;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i5 + 12 >> 2] = i14;
 HEAP32[i13 >> 2] = HEAP32[i7 + 144 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 148 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 152 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i14, i13) | 0;
 HEAP8[i12 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i12 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0, gb + 766862 | 0, HEAP32[i7 + 124 >> 2] | 0);
 HEAP32[i7 + 120 >> 2] = 0;
 HEAP32[i7 + 116 >> 2] = 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, gb + 766871 | 0);
 HEAP32[i3 >> 2] = 1;
 i13 = HEAP32[i7 + 160 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 + 112 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i10 = i2 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx30PxTolerancesScaleGeneratedInfoC2Ev(i12);
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i11 + 8 >> 2] = i7 + 132;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 __ZNK5physx30PxTolerancesScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEEEEEjT_j(i12, i11, 0) | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i14 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
  }
 }
 if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i5 >> 2] = gb + 146492 + 8; else {
  i1 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
  i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = gb + 146492 + 8;
  if (i1 | 0) do {
   HEAP32[i3 >> 2] = i1 + -1;
   i14 = HEAP32[i4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = i7 + 24 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i7 + 20 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sn18RepXCollectionImpl11saveXmlNodeEPNS0_7XmlNodeERNS0_15SimpleXmlWriterE(i7, HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 * 24 | 0) + 16 >> 2] | 0, i8);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i8 >> 2] = gb + 146452 + 8;
 i1 = i8 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv(i8);
  if (HEAP32[i1 >> 2] | 0) do mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i14 = HEAP32[i8 + 24 >> 2] | 0;
 if (!((i14 | 0) > -1 & (i14 & 2147483647 | 0) != 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i14 = HEAP32[HEAP32[i8 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx17AggregateAABBTask11runInternalEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 24 | 0;
 i11 = i15;
 HEAP32[i14 + 100 >> 2] = 0;
 HEAP32[i14 + 160 >> 2] = 0;
 HEAP32[i14 + 220 >> 2] = 0;
 HEAP32[i14 + 280 >> 2] = 0;
 HEAP32[i14 + 340 >> 2] = 0;
 HEAP32[i14 + 400 >> 2] = 0;
 i3 = i14 + 20 | 0;
 i1 = i14 + 24 | 0;
 i2 = 0;
 do {
  i9 = HEAP32[i3 >> 2] | 0;
  i13 = HEAP32[i9 + 37444 >> 2] | 0;
  i8 = i14 + 44 + (i2 * 60 | 0) | 0;
  HEAP16[i14 + 44 + (i2 * 60 | 0) + 4 >> 1] = -1;
  HEAP16[i14 + 44 + (i2 * 60 | 0) + 6 >> 1] = 0;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 8 >> 2] = 0;
  HEAP32[i8 >> 2] = gb + 87404 + 8;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 12 >> 2] = 0;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 16 >> 2] = 0;
  HEAP32[i8 >> 2] = gb + 104412 + 8;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 20 >> 2] = i9;
  i9 = i14 + 44 + (i2 * 60 | 0) + 24 | 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 44 >> 2] = i13;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 48 >> 2] = 0;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 52 >> 2] = 0;
  HEAP32[i14 + 44 + (i2 * 60 | 0) + 56 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 i13 = HEAP32[i14 + 24 >> 2] | 0;
 i9 = i13 >>> 0 > 6 ? 6 : i13;
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 372 >> 2] | 0;
 do if (i7 | 0) {
  i8 = i9 >>> 0 > 1 & i7 >>> 0 > 32;
  if (!i8) {
   HEAP32[i14 + 92 >> 2] = 0;
   HEAP32[i14 + 96 >> 2] = i7;
   break;
  }
  i1 = (i7 + 31 | 0) >>> 5;
  i3 = (i1 >>> 0) / (i9 >>> 0) | 0;
  i6 = i3 << 5;
  i2 = (Math_imul(i3, i9) | 0) - i1 + i9 | 0;
  if (!i2) {
   i1 = 0;
   i3 = 0;
  } else {
   i4 = (Math_imul(i3 + 1 | 0, i9) | 0) - i1 | 0;
   i3 = 0;
   i5 = 0;
   while (1) {
    HEAP32[i12 + (i5 << 2) >> 2] = i3;
    HEAP32[i11 + (i5 << 2) >> 2] = i6;
    i1 = i3 + i6 | 0;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i4 | 0)) break; else i3 = i1;
   }
  }
  i4 = i6 + 32 | 0;
  if (i2 >>> 0 < i9 >>> 0) while (1) {
   HEAP32[i12 + (i2 << 2) >> 2] = i1;
   HEAP32[i11 + (i2 << 2) >> 2] = i4;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i9 | 0)) break; else i1 = i1 + i4 | 0;
  } else i1 = i3;
  HEAP32[i11 + (i9 + -1 << 2) >> 2] = i7 - i1;
  if (i9 >>> 0 < 6) {
   i7 = i13 >>> 0 < 6 ? ~i13 : -7;
   i6 = ~i7;
   i7 = (i7 << 2) + 28 | 0;
   _memset(i12 + (i6 << 2) | 0, 0, i7 | 0) | 0;
   _memset(i11 + (i6 << 2) | 0, 0, i7 | 0) | 0;
   if (i9 | 0) i10 = 12;
  } else i10 = 12;
  if ((i10 | 0) == 12) {
   i1 = i13 >>> 0 < 6 ? i13 : 6;
   i2 = 0;
   do {
    i10 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
    HEAP32[i14 + 44 + (i2 * 60 | 0) + 48 >> 2] = HEAP32[i12 + (i2 << 2) >> 2];
    HEAP32[i14 + 44 + (i2 * 60 | 0) + 52 >> 2] = i10;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  if (i8) {
   i1 = (i9 | 0) == 0;
   if (i1) {
    STACKTOP = i15;
    return;
   }
   i2 = i14 + 12 | 0;
   i3 = i13 >>> 0 < 6 ? i13 : 6;
   i6 = 0;
   do {
    i4 = HEAP32[i2 >> 2] | 0;
    HEAP32[i14 + 44 + (i6 * 60 | 0) + 16 >> 2] = 1;
    i5 = i14 + 44 + (i6 * 60 | 0) + 12 | 0;
    HEAP32[i5 >> 2] = i4;
    if (i4 | 0) {
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
     HEAP32[i14 + 44 + (i6 * 60 | 0) + 8 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i3 | 0));
   if (i1) {
    STACKTOP = i15;
    return;
   }
   i1 = i13 >>> 0 < 6 ? i13 : 6;
   i2 = 0;
   do {
    i13 = i14 + 44 + (i2 * 60 | 0) | 0;
    mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   STACKTOP = i15;
   return;
  }
 } while (0);
 i14 = i14 + 44 | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0);
 STACKTOP = i15;
 return;
}

function __ZN7ApiGLESC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 _memset(i3 | 0, 0, 852) | 0;
 i4 = i3 + 852 | 0;
 HEAP32[i4 >> 2] = __Znwj(2376) | 0;
 i1 = __Znwj(16) | 0;
 __ZN9DebugGLESC2ERK7ApiGLES(i1, i3);
 HEAP32[i3 + 856 >> 2] = i1;
 HEAP32[i3 + 860 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 864 >> 2] = i1;
 HEAP32[i3 + 868 >> 2] = 0;
 HEAP32[i3 + 872 >> 2] = 0;
 i1 = i3 + 876 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 880 >> 2] = -1;
 i4 = i3 + 884 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 888 >> 2] = -1;
 HEAP32[i3 + 1316 >> 2] = 0;
 HEAP32[i3 + 1320 >> 2] = -1;
 i2 = i3 + 1324 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1340 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1356 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1372 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1388 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1404 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1420 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1436 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1452 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1468 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1484 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1500 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1516 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1532 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 i2 = i3 + 1548 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP32[i3 + 1564 >> 2] = 0;
 HEAP32[i3 + 1568 >> 2] = -1;
 HEAP32[i3 + 1572 >> 2] = 0;
 HEAP32[i3 + 1576 >> 2] = 0;
 HEAP32[i3 + 1580 >> 2] = 0;
 HEAP32[i3 + 1592 >> 2] = 0;
 HEAP8[i3 + 1596 >> 0] = 0;
 HEAP32[i3 + 1600 >> 2] = 0;
 HEAP32[i3 + 1988 >> 2] = -559030611;
 HEAP8[i3 + 1992 >> 0] = 0;
 i2 = i3 + 1732 | 0;
 i5 = i3 + 1604 | 0;
 i6 = i5 + 128 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 2;
 HEAP32[i3 + 1736 >> 2] = 2;
 HEAP32[i3 + 1740 >> 2] = 2;
 HEAP32[i3 + 1744 >> 2] = 2;
 HEAP32[i3 + 1748 >> 2] = 2;
 HEAP32[i3 + 1752 >> 2] = 2;
 HEAP32[i3 + 1756 >> 2] = 2;
 HEAP32[i3 + 1760 >> 2] = 2;
 HEAP32[i3 + 1764 >> 2] = 2;
 HEAP32[i3 + 1768 >> 2] = 2;
 HEAP32[i3 + 1772 >> 2] = 2;
 HEAP32[i3 + 1776 >> 2] = 2;
 HEAP32[i3 + 1780 >> 2] = 2;
 HEAP32[i3 + 1784 >> 2] = 2;
 HEAP32[i3 + 1788 >> 2] = 2;
 HEAP32[i3 + 1792 >> 2] = 2;
 HEAP32[i3 + 1796 >> 2] = 2;
 HEAP32[i3 + 1800 >> 2] = 2;
 HEAP32[i3 + 1804 >> 2] = 2;
 HEAP32[i3 + 1808 >> 2] = 2;
 HEAP32[i3 + 1812 >> 2] = 2;
 HEAP32[i3 + 1816 >> 2] = 2;
 HEAP32[i3 + 1820 >> 2] = 2;
 HEAP32[i3 + 1824 >> 2] = 2;
 HEAP32[i3 + 1828 >> 2] = 2;
 HEAP32[i3 + 1832 >> 2] = 2;
 HEAP32[i3 + 1836 >> 2] = 2;
 HEAP32[i3 + 1840 >> 2] = 2;
 HEAP32[i3 + 1844 >> 2] = 2;
 HEAP32[i3 + 1848 >> 2] = 2;
 HEAP32[i3 + 1852 >> 2] = 2;
 HEAP32[i3 + 1856 >> 2] = 2;
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 880 | 0;
 i5 = i3 + 1860 | 0;
 i6 = i5 + 128 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i1 >> 2] = -1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 888 >> 2] = -1;
 _memset(i3 + 892 | 0, 0, 424) | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 32 | 0;
 i1 = i8 + 16 | 0;
 i2 = i8;
 f24 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f23 = Math_fround(f24 * f22);
 f21 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f13 = Math_fround(f24 * f21);
 f20 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f24 = Math_fround(f24 * f20);
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f10 = Math_fround(f12 * f15);
 f19 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f11 = Math_fround(f12 * f19);
 f17 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f10 = Math_fround(f23 + f10);
 f11 = Math_fround(f13 + f11);
 f12 = Math_fround(f24 + Math_fround(f12 * f17));
 f24 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 44 >> 2]);
 f23 = Math_fround(f24 * f13);
 f18 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f25 = Math_fround(f24 * f18);
 f16 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f23 = Math_fround(f10 + f23);
 f25 = Math_fround(f11 + f25);
 f24 = Math_fround(f12 + Math_fround(f24 * f16));
 f12 = Math_fround(HEAPF32[i6 + 56 >> 2]);
 f23 = Math_fround(f23 + f12);
 f11 = Math_fround(HEAPF32[i6 + 60 >> 2]);
 f25 = Math_fround(f25 + f11);
 f10 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f24 = Math_fround(f24 + f10);
 HEAPF32[i9 >> 2] = f23;
 HEAPF32[i9 + 4 >> 2] = f25;
 HEAPF32[i9 + 8 >> 2] = f24;
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 f24 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(f24 * f22);
 f23 = Math_fround(f24 * f21);
 f24 = Math_fround(f24 * f20);
 f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f25 = Math_fround(f25 + Math_fround(f14 * f15));
 f23 = Math_fround(f23 + Math_fround(f14 * f19));
 f14 = Math_fround(f24 + Math_fround(f14 * f17));
 f24 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f23 = Math_fround(Math_fround(f23 + Math_fround(f24 * f18)) + f11);
 f14 = Math_fround(Math_fround(f14 + Math_fround(f24 * f16)) + f10);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f25 + Math_fround(f24 * f13)) + f12);
 HEAPF32[i1 + 4 >> 2] = f23;
 HEAPF32[i1 + 8 >> 2] = f14;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f22 = Math_fround(f14 * f22);
 f21 = Math_fround(f14 * f21);
 f20 = Math_fround(f14 * f20);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(f22 + Math_fround(f14 * f15));
 f19 = Math_fround(f21 + Math_fround(f14 * f19));
 f17 = Math_fround(f20 + Math_fround(f14 * f17));
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f11 = Math_fround(Math_fround(f19 + Math_fround(f14 * f18)) + f11);
 f10 = Math_fround(Math_fround(f17 + Math_fround(f14 * f16)) + f10);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f15 + Math_fround(f14 * f13)) + f12);
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu20intersectTriangleBoxERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_(i6 + 144 | 0, i6 + 128 | 0, i9, i1, i2) | 0)) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 return 0;
}

function __Z50Renderer_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 8 | 0;
 i2 = i15;
 i14 = i15 + 40 | 0;
 i8 = i15 + 16 | 0;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i14 >> 2] = 0;
 i10 = i14 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i2);
 i3 = i13;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = __Z19GetReflectionProbesv() | 0;
 if (!i6) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i4 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __Z18CalculateWorldAABBR10GameObject(i8, HEAP32[i1 + 28 >> 2] | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 i4 = i1 + 32 + 248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i2);
    i2 = HEAP32[i13 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 12; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 14;
   }
  }
  if ((i5 | 0) == 12) i5 = 14;
  if ((i5 | 0) == 14) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 i2 = i2 + 32 + 236 | 0;
 __ZN16ReflectionProbes16GetClosestProbesERK4AABBP9Transform20ReflectionProbeUsageR13dynamic_arrayI24ReflectionProbeBlendInfoLj4EE(i7, i8, i1, ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 14 & 3, i14);
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 308 >> 2] | 0;
 i2 = i9 + 8 | 0;
 i16 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i16 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   __Z35ReflectionProbeBlendInfoToScriptingRK24ReflectionProbeBlendInfoR33ScriptingReflectionProbeBlendInfo(i1, i13);
   i8 = i13;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i16 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i16 >> 2] = i7;
   HEAP32[i16 + 4 >> 2] = i8;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 8 | 0;
  }
 }
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 >> 2];
 i16 = i9 + 16 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i12);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc15ArticulationSim7addBodyERNS0_7BodySimEPS2_PNS0_20ArticulationJointSimE(i16, i15, i11, i12) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i17 + 4 | 0;
 i1 = i17;
 HEAP32[i4 >> 2] = i12;
 i13 = i16 + 24 | 0;
 HEAP32[i1 >> 2] = i15;
 i14 = i16 + 28 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i16 + 32 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = i15;
  HEAP32[i14 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i13, i1) | 0;
 i1 = i16 + 36 | 0;
 i2 = i16 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i16 + 44 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i12;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i4) | 0;
 i8 = i16 + 12 | 0;
 i3 = i16 + 16 | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i16 + 20 >> 2] | 0;
 i2 = i1 & 2147483647;
 if (i2 >>> 0 > i10 >>> 0) i6 = i10; else {
  __ZN5physx6shdfnd5ArrayINS_19PxsArticulationLinkENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i8, (i2 | 0) == 0 ? 1 : i1 << 1);
  i6 = HEAP32[i3 >> 2] | 0;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 >> 2] = i6 + 1;
 HEAP32[i5 + (i6 << 5) + 16 >> 2] = i15 + 64;
 HEAP32[i5 + (i6 << 5) + 20 >> 2] = (HEAP32[i15 + 52 >> 2] | 0) + 16;
 i7 = i5 + (i6 << 5) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i7 = __ZN5physx2Sc7BodySim37checkSleepReadinessBesidesWakeCounterEv(i15) | 0;
 f9 = Math_fround(__ZNK5physx2Sc16ArticulationCore14getWakeCounterEv(HEAP32[i16 + 8 >> 2] | 0));
 if (!i11) {
  i1 = f9 == Math_fround(0.0);
  HEAP32[i5 + (i6 << 5) + 28 >> 2] = -1;
  i12 = i5 + (i6 << 5) + 8 | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i5 + (i6 << 5) + 24 >> 2] = 0;
 } else {
  i3 = HEAP32[i13 >> 2] | 0;
  i1 = (HEAP8[(HEAP32[i3 >> 2] | 0) + 51 >> 0] & 1) == 0;
  i4 = HEAP32[i14 >> 2] | 0;
  L15 : do if (!i4) i2 = -2147483648; else {
   i2 = 0;
   while (1) {
    if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) == (i11 | 0)) break L15;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i4 >>> 0) {
     i2 = -2147483648;
     break;
    }
   }
  } while (0);
  HEAP32[i5 + (i6 << 5) + 28 >> 2] = i2;
  i4 = HEAP32[i8 >> 2] | 0;
  i18 = i4 + (i2 << 5) + 8 | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i8 = _bitshift64Shl(1, 0, i10 | 0) | 0;
  i11 = getTempRet0() | 0;
  i3 = i5 + (i6 << 5) + 8 | 0;
  HEAP32[i3 >> 2] = i19 | i8;
  HEAP32[i3 + 4 >> 2] = i18 | i11;
  HEAP32[i5 + (i6 << 5) + 24 >> 2] = (HEAP32[i12 + 36 >> 2] | 0) + 4;
  i12 = i4 + (i2 << 5) | 0;
  i6 = i12;
  i11 = HEAP32[i6 + 4 >> 2] | i11;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2] | i8;
  HEAP32[i12 + 4 >> 2] = i11;
 }
 i2 = i7 & i1;
 if (!(i2 | i1 ^ 1)) if ((HEAP32[i14 >> 2] | 0) != 1) {
  i1 = 0;
  do {
   __ZN5physx2Sc7BodySim30internalWakeUpArticulationLinkEf(HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0, f9);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < ((HEAP32[i14 >> 2] | 0) + -1 | 0) >>> 0);
 }
 __ZN5physx2Sc7BodySim15setArticulationEPNS0_15ArticulationSimEfb(i15, i16, f9, i2);
 i2 = HEAP32[i16 >> 2] | i10;
 i3 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i15) | 0) + 1204 >> 2] | 0) | 0;
 i1 = i15 + 188 | 0;
 if (!(i2 & 63)) {
  __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i3, i2, i16, i1);
  i19 = i16 + 160 | 0;
  HEAP8[i19 >> 0] = 1;
  STACKTOP = i17;
  return;
 } else {
  __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i3, i2, i16, i1);
  i19 = i16 + 160 | 0;
  HEAP8[i19 >> 0] = 1;
  STACKTOP = i17;
  return;
 }
}

function __ZN24OcclusionCullingSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i10 = i3 + 20 | 0;
 i7 = i3 + 16 | 0;
 __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379174 | 0, gb + 863904 | 0, i5, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379186 | 0, gb + 379209 | 0, i5, 0);
 i11 = i9 + 8 | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i11, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379236 | 0, i11, i1 + 32 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 425246 | 0, i7, 0);
 i12 = i9 + 8 | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i12, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379254 | 0, i11, i1 + 52 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 379401 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT__4326(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 4399;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function __ZN27ParticleSystemReadOnlyState8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621138 | 0, i6, i1 + 264 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621751 | 0, i6, i1 + 268 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621150 | 0, i6, i1 + 277 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621158 | 0, i6, i1 + 278 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621166 | 0, i6, i1 + 279 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621178 | 0, i6, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621193 | 0, gb + 620173 | 0, i1, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621204 | 0, i6, i1 + 280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = i1 + 288 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621222 | 0, gb + 842702 | 0, i8, 0);
 i7 = i9 + 8 | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621246 | 0, i6, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 621258 | 0, i6, i1 + 272 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z46EmitSerializationCommandsForManagedObjectFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i18, i1) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i2 = i25 + 40 | 0;
 i24 = i25 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT__4326(HEAP32[i3 >> 2] | 0) | 0)) {
  STACKTOP = i25;
  return;
 }
 i19 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 24 | 0;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i2 + 4 >> 2] = i19;
 HEAP32[i2 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i2 + 16 >> 1] = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP32[i2 + 12 >> 2] = (HEAP32[i4 + 32 >> 2] | 0) + 1;
 HEAP32[i24 >> 2] = 0;
 i5 = i24 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i19 = i24 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i24 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i21, gb + 63664 | 0);
 i17 = i21;
 i23 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i20;
 HEAP32[i22 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 + 4 >> 2] = i23;
 i22 = i24 + 20 | 0;
 i23 = i18 + 20 | 0;
 HEAP8[i22 >> 0] = HEAP8[i23 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i2, i24, i1, 0, i4);
 if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP32[i5 >> 2] | 0) == 0)) {
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  HEAP32[i21 + 8 >> 2] = 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i12 = __Z24scripting_field_get_nameP9FieldInfo(i11) | 0;
  i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i14 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i11) | 0) | 0;
  i15 = __Z26scripting_field_get_offsetP9FieldInfo(i11) | 0;
  i16 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
  i17 = HEAP32[i4 + 28 >> 2] | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i4 + 12 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i18 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i18 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i18 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i8 = HEAP32[i18 >> 2] | 0;
  HEAP32[i8 + (i4 << 6) >> 2] = fb + 4343;
  HEAP32[i8 + (i4 << 6) + 4 >> 2] = i11;
  HEAP32[i8 + (i4 << 6) + 8 >> 2] = i12;
  HEAP32[i8 + (i4 << 6) + 12 >> 2] = i16;
  HEAP32[i8 + (i4 << 6) + 16 >> 2] = i13;
  HEAP32[i8 + (i4 << 6) + 20 >> 2] = i14;
  HEAP32[i8 + (i4 << 6) + 24 >> 2] = i15;
  HEAP32[i8 + (i4 << 6) + 28 >> 2] = i17;
  HEAP32[i8 + (i4 << 6) + 32 >> 2] = i10;
  HEAP32[i8 + (i4 << 6) + 36 >> 2] = i9;
  HEAP32[i8 + (i4 << 6) + 48 >> 2] = i2;
  i17 = i8 + (i4 << 6) + 52 | 0;
  HEAP32[i17 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i18, i24);
  HEAP8[i23 >> 0] = HEAP8[i22 >> 0] | HEAP8[i23 >> 0];
 }
 if ((HEAP32[i19 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i24 >> 2] | 0, i20);
  HEAP32[i24 >> 2] = 0;
 }
 STACKTOP = i25;
 return;
}

function runPostSets184() {
 HEAP32[gb + 156564 >> 2] = fb + 1701;
 HEAP32[gb + 156568 >> 2] = fb + 1702;
 HEAP32[gb + 156572 >> 2] = fb + 1703;
 HEAP32[gb + 156576 >> 2] = fb + 36;
 HEAP32[gb + 156580 >> 2] = fb + 104;
 HEAP32[gb + 156584 >> 2] = fb + 108;
 HEAP32[gb + 156588 >> 2] = fb + 94;
 HEAP32[gb + 156592 >> 2] = fb + 130;
 HEAP32[gb + 156596 >> 2] = fb + 112;
 HEAP32[gb + 156600 >> 2] = fb + 113;
 HEAP32[gb + 156604 >> 2] = fb + 131;
 HEAP32[gb + 156608 >> 2] = fb + 111;
 HEAP32[gb + 156612 >> 2] = fb + 112;
 HEAP32[gb + 156616 >> 2] = fb + 113;
 HEAP32[gb + 156620 >> 2] = fb + 2328;
 HEAP32[gb + 156624 >> 2] = fb + 2329;
 HEAP32[gb + 156628 >> 2] = fb + 1704;
 HEAP32[gb + 156632 >> 2] = fb + 1705;
 HEAP32[gb + 156636 >> 2] = fb + 121;
 HEAP32[gb + 156640 >> 2] = fb + 1088;
 HEAP32[gb + 156644 >> 2] = fb + 1064;
 HEAP32[gb + 156648 >> 2] = fb + 1065;
 HEAP32[gb + 156652 >> 2] = fb + 1089;
 HEAP32[gb + 156656 >> 2] = fb + 1090;
 HEAP32[gb + 156660 >> 2] = fb + 2419;
 HEAP32[gb + 156672 >> 2] = (HEAP32[gb + 156672 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 156676 >> 2] = (HEAP32[gb + 156676 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 156712 >> 2] = fb + 2420;
 HEAP32[gb + 156716 >> 2] = fb + 2421;
 HEAP32[gb + 156720 >> 2] = fb + 2325;
 HEAP32[gb + 156724 >> 2] = fb + 1584;
 HEAP32[gb + 156728 >> 2] = fb + 16;
 HEAP32[gb + 156732 >> 2] = fb + 2422;
 HEAP32[gb + 156736 >> 2] = fb + 2423;
 HEAP32[gb + 156740 >> 2] = fb + 19;
 HEAP32[gb + 156744 >> 2] = fb + 1091;
 HEAP32[gb + 156748 >> 2] = fb + 103;
 HEAP32[gb + 156752 >> 2] = fb + 101;
 HEAP32[gb + 156756 >> 2] = fb + 62;
 HEAP32[gb + 156760 >> 2] = fb + 28;
 HEAP32[gb + 156764 >> 2] = fb + 63;
 HEAP32[gb + 156768 >> 2] = fb + 29;
 HEAP32[gb + 156772 >> 2] = fb + 34;
 HEAP32[gb + 156776 >> 2] = fb + 1706;
 HEAP32[gb + 156780 >> 2] = fb + 1707;
 HEAP32[gb + 156784 >> 2] = fb + 1708;
 HEAP32[gb + 156788 >> 2] = fb + 1709;
 HEAP32[gb + 156792 >> 2] = fb + 1710;
 HEAP32[gb + 156796 >> 2] = fb + 1711;
 HEAP32[gb + 156800 >> 2] = fb + 36;
 HEAP32[gb + 156804 >> 2] = fb + 104;
 HEAP32[gb + 156808 >> 2] = fb + 108;
 HEAP32[gb + 156812 >> 2] = fb + 94;
 HEAP32[gb + 156816 >> 2] = fb + 130;
 HEAP32[gb + 156820 >> 2] = fb + 112;
 HEAP32[gb + 156824 >> 2] = fb + 113;
 HEAP32[gb + 156828 >> 2] = fb + 131;
 HEAP32[gb + 156832 >> 2] = fb + 111;
 HEAP32[gb + 156836 >> 2] = fb + 112;
 HEAP32[gb + 156840 >> 2] = fb + 113;
 HEAP32[gb + 156844 >> 2] = fb + 2328;
 HEAP32[gb + 156848 >> 2] = fb + 2329;
 HEAP32[gb + 156852 >> 2] = fb + 1712;
 HEAP32[gb + 156856 >> 2] = fb + 1713;
 HEAP32[gb + 156860 >> 2] = fb + 122;
 HEAP32[gb + 156864 >> 2] = fb + 1092;
 HEAP32[gb + 156868 >> 2] = fb + 1064;
 HEAP32[gb + 156872 >> 2] = fb + 1065;
 HEAP32[gb + 156876 >> 2] = fb + 1093;
 HEAP32[gb + 156880 >> 2] = fb + 1094;
 HEAP32[gb + 156884 >> 2] = fb + 2330;
 HEAP32[gb + 156896 >> 2] = (HEAP32[gb + 156896 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 156900 >> 2] = (HEAP32[gb + 156900 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 156936 >> 2] = fb + 2424;
 HEAP32[gb + 156940 >> 2] = fb + 2425;
 HEAP32[gb + 156944 >> 2] = fb + 38;
 HEAP32[gb + 156948 >> 2] = fb + 1599;
 HEAP32[gb + 156952 >> 2] = fb + 16;
 HEAP32[gb + 156956 >> 2] = fb + 2426;
 HEAP32[gb + 156960 >> 2] = fb + 2427;
 HEAP32[gb + 156964 >> 2] = fb + 2428;
 HEAP32[gb + 156968 >> 2] = fb + 1095;
 HEAP32[gb + 156972 >> 2] = fb + 103;
 HEAP32[gb + 156976 >> 2] = fb + 101;
 HEAP32[gb + 156980 >> 2] = fb + 62;
 HEAP32[gb + 156984 >> 2] = fb + 28;
 HEAP32[gb + 156988 >> 2] = fb + 63;
 HEAP32[gb + 156992 >> 2] = fb + 29;
 HEAP32[gb + 156996 >> 2] = fb + 34;
 HEAP32[gb + 157e3 >> 2] = fb + 1714;
 HEAP32[gb + 157004 >> 2] = fb + 1715;
 HEAP32[gb + 157008 >> 2] = fb + 1716;
 HEAP32[gb + 157012 >> 2] = fb + 1717;
 HEAP32[gb + 157016 >> 2] = fb + 1718;
 HEAP32[gb + 157020 >> 2] = fb + 1719;
 HEAP32[gb + 157024 >> 2] = fb + 36;
 HEAP32[gb + 157028 >> 2] = fb + 104;
 HEAP32[gb + 157032 >> 2] = fb + 108;
 HEAP32[gb + 157036 >> 2] = fb + 94;
 HEAP32[gb + 157040 >> 2] = fb + 1606;
 runPostSets185();
}

function runPostSets176() {
 HEAP32[gb + 152620 >> 2] = fb + 1555;
 HEAP32[gb + 152624 >> 2] = fb + 1556;
 HEAP32[gb + 152628 >> 2] = fb + 407;
 HEAP32[gb + 152640 >> 2] = fb + 1557;
 HEAP32[gb + 152644 >> 2] = fb + 1558;
 HEAP32[gb + 152648 >> 2] = fb + 36;
 HEAP32[gb + 152652 >> 2] = fb + 10;
 HEAP32[gb + 152656 >> 2] = fb + 2305;
 HEAP32[gb + 152660 >> 2] = fb + 1520;
 HEAP32[gb + 152664 >> 2] = fb + 2287;
 HEAP32[gb + 152668 >> 2] = fb + 2306;
 HEAP32[gb + 152672 >> 2] = fb + 1559;
 HEAP32[gb + 152676 >> 2] = fb + 1560;
 HEAP32[gb + 152680 >> 2] = fb + 408;
 HEAP32[gb + 152692 >> 2] = fb + 1561;
 HEAP32[gb + 152696 >> 2] = fb + 1562;
 HEAP32[gb + 152700 >> 2] = fb + 37;
 HEAP32[gb + 152704 >> 2] = fb + 11;
 HEAP32[gb + 152708 >> 2] = fb + 2307;
 HEAP32[gb + 152712 >> 2] = fb + 1520;
 HEAP32[gb + 152716 >> 2] = fb + 2287;
 HEAP32[gb + 152720 >> 2] = fb + 2308;
 HEAP32[gb + 152724 >> 2] = fb + 1563;
 HEAP32[gb + 152728 >> 2] = fb + 1564;
 HEAP32[gb + 152732 >> 2] = fb + 409;
 HEAP32[gb + 152736 >> 2] = (HEAP32[gb + 152736 >> 2] | 0) + (gb + 152740 | 0);
 HEAP32[gb + 152748 >> 2] = fb + 2309;
 HEAP32[gb + 152752 >> 2] = fb + 2310;
 HEAP32[gb + 152756 >> 2] = fb + 255;
 HEAP32[gb + 152760 >> 2] = (HEAP32[gb + 152760 >> 2] | 0) + (gb + 152764 | 0);
 HEAP32[gb + 152772 >> 2] = fb + 2311;
 HEAP32[gb + 152776 >> 2] = fb + 2312;
 HEAP32[gb + 152780 >> 2] = fb + 1565;
 HEAP32[gb + 152784 >> 2] = fb + 1566;
 HEAP32[gb + 152788 >> 2] = fb + 416;
 HEAP32[gb + 152792 >> 2] = fb + 417;
 HEAP32[gb + 152804 >> 2] = fb + 2313;
 HEAP32[gb + 152808 >> 2] = fb + 2314;
 HEAP32[gb + 152812 >> 2] = fb + 38;
 HEAP32[gb + 152816 >> 2] = fb + 1567;
 HEAP32[gb + 152820 >> 2] = fb + 16;
 HEAP32[gb + 152824 >> 2] = fb + 2315;
 HEAP32[gb + 152828 >> 2] = fb + 2316;
 HEAP32[gb + 152832 >> 2] = fb + 19;
 HEAP32[gb + 152836 >> 2] = fb + 1058;
 HEAP32[gb + 152840 >> 2] = fb + 103;
 HEAP32[gb + 152844 >> 2] = fb + 101;
 HEAP32[gb + 152848 >> 2] = fb + 62;
 HEAP32[gb + 152852 >> 2] = fb + 28;
 HEAP32[gb + 152856 >> 2] = fb + 63;
 HEAP32[gb + 152860 >> 2] = fb + 29;
 HEAP32[gb + 152864 >> 2] = fb + 34;
 HEAP32[gb + 152868 >> 2] = fb + 1568;
 HEAP32[gb + 152872 >> 2] = fb + 1569;
 HEAP32[gb + 152876 >> 2] = fb + 1570;
 HEAP32[gb + 152880 >> 2] = fb + 1571;
 HEAP32[gb + 152884 >> 2] = fb + 1572;
 HEAP32[gb + 152888 >> 2] = fb + 1573;
 HEAP32[gb + 152892 >> 2] = fb + 36;
 HEAP32[gb + 152896 >> 2] = fb + 104;
 HEAP32[gb + 152900 >> 2] = fb + 108;
 HEAP32[gb + 152904 >> 2] = fb + 94;
 HEAP32[gb + 152908 >> 2] = fb + 1574;
 HEAP32[gb + 152912 >> 2] = fb + 112;
 HEAP32[gb + 152916 >> 2] = fb + 113;
 HEAP32[gb + 152920 >> 2] = fb + 131;
 HEAP32[gb + 152924 >> 2] = fb + 111;
 HEAP32[gb + 152928 >> 2] = fb + 112;
 HEAP32[gb + 152932 >> 2] = fb + 113;
 HEAP32[gb + 152936 >> 2] = fb + 2317;
 HEAP32[gb + 152940 >> 2] = fb + 2318;
 HEAP32[gb + 152944 >> 2] = fb + 1;
 HEAP32[gb + 152948 >> 2] = fb + 1575;
 HEAP32[gb + 152952 >> 2] = fb + 1059;
 HEAP32[gb + 152956 >> 2] = fb + 1060;
 HEAP32[gb + 152960 >> 2] = fb + 1576;
 HEAP32[gb + 152964 >> 2] = fb + 1577;
 HEAP32[gb + 152976 >> 2] = (HEAP32[gb + 152976 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 152980 >> 2] = (HEAP32[gb + 152980 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 153016 >> 2] = fb + 2319;
 HEAP32[gb + 153020 >> 2] = fb + 2320;
 HEAP32[gb + 153024 >> 2] = fb + 38;
 HEAP32[gb + 153028 >> 2] = fb + 1567;
 HEAP32[gb + 153032 >> 2] = fb + 16;
 HEAP32[gb + 153036 >> 2] = fb + 2321;
 HEAP32[gb + 153040 >> 2] = fb + 2322;
 HEAP32[gb + 153044 >> 2] = fb + 19;
 HEAP32[gb + 153048 >> 2] = fb + 1061;
 HEAP32[gb + 153052 >> 2] = fb + 103;
 HEAP32[gb + 153056 >> 2] = fb + 101;
 HEAP32[gb + 153060 >> 2] = fb + 62;
 HEAP32[gb + 153064 >> 2] = fb + 28;
 HEAP32[gb + 153068 >> 2] = fb + 63;
 HEAP32[gb + 153072 >> 2] = fb + 29;
 HEAP32[gb + 153076 >> 2] = fb + 34;
 HEAP32[gb + 153080 >> 2] = fb + 1578;
 HEAP32[gb + 153084 >> 2] = fb + 1579;
 HEAP32[gb + 153088 >> 2] = fb + 1580;
 HEAP32[gb + 153092 >> 2] = fb + 1581;
 HEAP32[gb + 153096 >> 2] = fb + 1582;
 runPostSets177();
}

function __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i17, i18, i15, i5, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i16 = __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i15, i1) | 0;
 i1 = i5 + 8 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 20 | 0;
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i9 = i15 + 8 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i15 + 20 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i18 = i16;
  return i18 | 0;
 }
 i22 = HEAP32[i15 >> 2] | 0;
 i11 = i15 + 4 | 0;
 i21 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i20 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 24 | 0;
 i8 = i14;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = i22;
 HEAP32[i5 + 4 >> 2] = i21;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 12 >> 2] = i20;
 HEAP32[i5 + 16 >> 2] = i6;
 HEAPF32[i4 >> 2] = f3;
 i1 = i5 + 24 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i8;
 f19 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
 i1 = i18 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i18 + 20 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i16 + 1 | 0;
  return i22 | 0;
 }
 i25 = HEAP32[i18 >> 2] | 0;
 i5 = i18 + 4 | 0;
 i24 = HEAP32[i5 >> 2] | 0;
 i6 = i18 + 12 | 0;
 i23 = HEAP32[i6 >> 2] | 0;
 i7 = i18 + 16 | 0;
 i22 = HEAP32[i7 >> 2] | 0;
 i8 = i18 + 24 | 0;
 i21 = i8;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
 HEAP32[i15 >> 2] = i25;
 HEAP32[i11 >> 2] = i24;
 HEAPF32[i9 >> 2] = f2;
 HEAP32[i12 >> 2] = i23;
 HEAP32[i13 >> 2] = i22;
 HEAPF32[i10 >> 2] = f3;
 i22 = i14;
 HEAP32[i22 >> 2] = i20;
 HEAP32[i22 + 4 >> 2] = i21;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i16 + 2 | 0;
  return i25 | 0;
 }
 i20 = HEAP32[i17 >> 2] | 0;
 i21 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = HEAP32[i17 + 12 >> 2] | 0;
 i25 = HEAP32[i17 + 16 >> 2] | 0;
 i24 = i17 + 24 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 HEAP32[i18 >> 2] = i20;
 HEAP32[i5 >> 2] = i21;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i6 >> 2] = i22;
 HEAP32[i7 >> 2] = i25;
 HEAPF32[i4 >> 2] = f3;
 i25 = i8;
 HEAP32[i25 >> 2] = i23;
 HEAP32[i25 + 4 >> 2] = i24;
 i25 = i16 + 3 | 0;
 return i25 | 0;
}

function __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i17, i18, i15, i5, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i16 = __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i15, i1) | 0;
 i1 = i5 + 4 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 16 | 0;
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i9 = i15 + 4 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i15 + 16 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i18 = i16;
  return i18 | 0;
 }
 i22 = HEAP32[i15 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i21 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i20 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 20 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 24 | 0;
 i8 = i14;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i5 >> 2] = i22;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 8 >> 2] = i21;
 HEAP32[i5 + 12 >> 2] = i20;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 20 >> 2] = i6;
 i1 = i5 + 24 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i8;
 f19 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
 i1 = i18 + 4 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i18 + 16 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i22 = i16 + 1 | 0;
  return i22 | 0;
 }
 i25 = HEAP32[i18 >> 2] | 0;
 i5 = i18 + 8 | 0;
 i24 = HEAP32[i5 >> 2] | 0;
 i6 = i18 + 12 | 0;
 i23 = HEAP32[i6 >> 2] | 0;
 i7 = i18 + 20 | 0;
 i22 = HEAP32[i7 >> 2] | 0;
 i8 = i18 + 24 | 0;
 i21 = i8;
 i20 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i18 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
 HEAP32[i15 >> 2] = i25;
 HEAPF32[i9 >> 2] = f2;
 HEAP32[i11 >> 2] = i24;
 HEAP32[i12 >> 2] = i23;
 HEAPF32[i10 >> 2] = f3;
 HEAP32[i13 >> 2] = i22;
 i22 = i14;
 HEAP32[i22 >> 2] = i20;
 HEAP32[i22 + 4 >> 2] = i21;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i25 = i16 + 2 | 0;
  return i25 | 0;
 }
 i20 = HEAP32[i17 >> 2] | 0;
 i21 = HEAP32[i17 + 8 >> 2] | 0;
 i22 = HEAP32[i17 + 12 >> 2] | 0;
 i25 = HEAP32[i17 + 20 >> 2] | 0;
 i24 = i17 + 24 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 i24 = HEAP32[i24 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i18 + 28 >> 2];
 HEAP32[i18 >> 2] = i20;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 >> 2] = i21;
 HEAP32[i6 >> 2] = i22;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i7 >> 2] = i25;
 i25 = i8;
 HEAP32[i25 >> 2] = i23;
 HEAP32[i25 + 4 >> 2] = i24;
 i25 = i16 + 3 | 0;
 return i25 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i16, i3, i1) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i2 = i15 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i15;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i13 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i12 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i12 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i12 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i13 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i13 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i12 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i13 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i13 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function runPostSets186() {
 HEAP32[gb + 157532 >> 2] = fb + 1738;
 HEAP32[gb + 157536 >> 2] = fb + 1739;
 HEAP32[gb + 157540 >> 2] = fb + 1740;
 HEAP32[gb + 157544 >> 2] = fb + 1741;
 HEAP32[gb + 157548 >> 2] = fb + 1742;
 HEAP32[gb + 157552 >> 2] = fb + 1743;
 HEAP32[gb + 157556 >> 2] = fb + 36;
 HEAP32[gb + 157560 >> 2] = fb + 104;
 HEAP32[gb + 157564 >> 2] = fb + 108;
 HEAP32[gb + 157568 >> 2] = fb + 94;
 HEAP32[gb + 157572 >> 2] = fb + 1574;
 HEAP32[gb + 157576 >> 2] = fb + 112;
 HEAP32[gb + 157580 >> 2] = fb + 113;
 HEAP32[gb + 157584 >> 2] = fb + 131;
 HEAP32[gb + 157588 >> 2] = fb + 111;
 HEAP32[gb + 157592 >> 2] = fb + 112;
 HEAP32[gb + 157596 >> 2] = fb + 113;
 HEAP32[gb + 157600 >> 2] = fb + 2317;
 HEAP32[gb + 157604 >> 2] = fb + 2318;
 HEAP32[gb + 157608 >> 2] = fb + 2442;
 HEAP32[gb + 157612 >> 2] = fb + 1744;
 HEAP32[gb + 157616 >> 2] = fb + 1059;
 HEAP32[gb + 157620 >> 2] = fb + 1060;
 HEAP32[gb + 157624 >> 2] = fb + 1576;
 HEAP32[gb + 157628 >> 2] = fb + 1577;
 HEAP32[gb + 157640 >> 2] = (HEAP32[gb + 157640 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 157644 >> 2] = (HEAP32[gb + 157644 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 157680 >> 2] = fb + 2443;
 HEAP32[gb + 157684 >> 2] = fb + 2444;
 HEAP32[gb + 157688 >> 2] = fb + 38;
 HEAP32[gb + 157692 >> 2] = fb + 1745;
 HEAP32[gb + 157696 >> 2] = fb + 16;
 HEAP32[gb + 157700 >> 2] = fb + 2445;
 HEAP32[gb + 157704 >> 2] = fb + 2446;
 HEAP32[gb + 157708 >> 2] = fb + 19;
 HEAP32[gb + 157712 >> 2] = fb + 1100;
 HEAP32[gb + 157716 >> 2] = fb + 103;
 HEAP32[gb + 157720 >> 2] = fb + 101;
 HEAP32[gb + 157724 >> 2] = fb + 62;
 HEAP32[gb + 157728 >> 2] = fb + 28;
 HEAP32[gb + 157732 >> 2] = fb + 63;
 HEAP32[gb + 157736 >> 2] = fb + 29;
 HEAP32[gb + 157740 >> 2] = fb + 34;
 HEAP32[gb + 157744 >> 2] = fb + 1746;
 HEAP32[gb + 157748 >> 2] = fb + 1747;
 HEAP32[gb + 157752 >> 2] = fb + 1748;
 HEAP32[gb + 157756 >> 2] = fb + 1749;
 HEAP32[gb + 157760 >> 2] = fb + 1750;
 HEAP32[gb + 157764 >> 2] = fb + 1751;
 HEAP32[gb + 157768 >> 2] = fb + 36;
 HEAP32[gb + 157772 >> 2] = fb + 104;
 HEAP32[gb + 157776 >> 2] = fb + 108;
 HEAP32[gb + 157780 >> 2] = fb + 94;
 HEAP32[gb + 157784 >> 2] = fb + 1574;
 HEAP32[gb + 157788 >> 2] = fb + 112;
 HEAP32[gb + 157792 >> 2] = fb + 113;
 HEAP32[gb + 157796 >> 2] = fb + 131;
 HEAP32[gb + 157800 >> 2] = fb + 111;
 HEAP32[gb + 157804 >> 2] = fb + 112;
 HEAP32[gb + 157808 >> 2] = fb + 113;
 HEAP32[gb + 157812 >> 2] = fb + 2317;
 HEAP32[gb + 157816 >> 2] = fb + 2318;
 HEAP32[gb + 157820 >> 2] = fb + 2447;
 HEAP32[gb + 157824 >> 2] = fb + 1575;
 HEAP32[gb + 157828 >> 2] = fb + 1059;
 HEAP32[gb + 157832 >> 2] = fb + 1060;
 HEAP32[gb + 157836 >> 2] = fb + 1576;
 HEAP32[gb + 157840 >> 2] = fb + 1577;
 HEAP32[gb + 157852 >> 2] = (HEAP32[gb + 157852 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 157856 >> 2] = (HEAP32[gb + 157856 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 157892 >> 2] = fb + 2448;
 HEAP32[gb + 157896 >> 2] = fb + 2449;
 HEAP32[gb + 157900 >> 2] = fb + 2325;
 HEAP32[gb + 157904 >> 2] = fb + 1584;
 HEAP32[gb + 157908 >> 2] = fb + 16;
 HEAP32[gb + 157912 >> 2] = fb + 2450;
 HEAP32[gb + 157916 >> 2] = fb + 2451;
 HEAP32[gb + 157920 >> 2] = fb + 19;
 HEAP32[gb + 157924 >> 2] = fb + 1101;
 HEAP32[gb + 157928 >> 2] = fb + 103;
 HEAP32[gb + 157932 >> 2] = fb + 101;
 HEAP32[gb + 157936 >> 2] = fb + 62;
 HEAP32[gb + 157940 >> 2] = fb + 28;
 HEAP32[gb + 157944 >> 2] = fb + 63;
 HEAP32[gb + 157948 >> 2] = fb + 29;
 HEAP32[gb + 157952 >> 2] = fb + 34;
 HEAP32[gb + 157956 >> 2] = fb + 1752;
 HEAP32[gb + 157960 >> 2] = fb + 1753;
 HEAP32[gb + 157964 >> 2] = fb + 1754;
 HEAP32[gb + 157968 >> 2] = fb + 1755;
 HEAP32[gb + 157972 >> 2] = fb + 1756;
 HEAP32[gb + 157976 >> 2] = fb + 1757;
 HEAP32[gb + 157980 >> 2] = fb + 36;
 HEAP32[gb + 157984 >> 2] = fb + 104;
 HEAP32[gb + 157988 >> 2] = fb + 108;
 HEAP32[gb + 157992 >> 2] = fb + 94;
 HEAP32[gb + 157996 >> 2] = fb + 130;
 HEAP32[gb + 158e3 >> 2] = fb + 112;
 HEAP32[gb + 158004 >> 2] = fb + 113;
 HEAP32[gb + 158008 >> 2] = fb + 131;
 runPostSets187();
}

function runPostSets179() {
 HEAP32[gb + 154036 >> 2] = fb + 29;
 HEAP32[gb + 154040 >> 2] = fb + 34;
 HEAP32[gb + 154044 >> 2] = fb + 1616;
 HEAP32[gb + 154048 >> 2] = fb + 1617;
 HEAP32[gb + 154052 >> 2] = fb + 1618;
 HEAP32[gb + 154056 >> 2] = fb + 1619;
 HEAP32[gb + 154060 >> 2] = fb + 1620;
 HEAP32[gb + 154064 >> 2] = fb + 1621;
 HEAP32[gb + 154068 >> 2] = fb + 36;
 HEAP32[gb + 154072 >> 2] = fb + 104;
 HEAP32[gb + 154076 >> 2] = fb + 108;
 HEAP32[gb + 154080 >> 2] = fb + 94;
 HEAP32[gb + 154084 >> 2] = fb + 130;
 HEAP32[gb + 154088 >> 2] = fb + 112;
 HEAP32[gb + 154092 >> 2] = fb + 113;
 HEAP32[gb + 154096 >> 2] = fb + 131;
 HEAP32[gb + 154100 >> 2] = fb + 111;
 HEAP32[gb + 154104 >> 2] = fb + 112;
 HEAP32[gb + 154108 >> 2] = fb + 113;
 HEAP32[gb + 154112 >> 2] = fb + 2328;
 HEAP32[gb + 154116 >> 2] = fb + 2329;
 HEAP32[gb + 154120 >> 2] = fb + 1622;
 HEAP32[gb + 154124 >> 2] = fb + 1623;
 HEAP32[gb + 154128 >> 2] = fb + 120;
 HEAP32[gb + 154132 >> 2] = fb + 1072;
 HEAP32[gb + 154136 >> 2] = fb + 1064;
 HEAP32[gb + 154140 >> 2] = fb + 1065;
 HEAP32[gb + 154144 >> 2] = fb + 1073;
 HEAP32[gb + 154148 >> 2] = fb + 1074;
 HEAP32[gb + 154152 >> 2] = fb + 2330;
 HEAP32[gb + 154164 >> 2] = (HEAP32[gb + 154164 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 154168 >> 2] = (HEAP32[gb + 154168 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 154204 >> 2] = fb + 2349;
 HEAP32[gb + 154208 >> 2] = fb + 2350;
 HEAP32[gb + 154212 >> 2] = fb + 38;
 HEAP32[gb + 154216 >> 2] = fb + 1599;
 HEAP32[gb + 154220 >> 2] = fb + 16;
 HEAP32[gb + 154224 >> 2] = fb + 2351;
 HEAP32[gb + 154228 >> 2] = fb + 2352;
 HEAP32[gb + 154232 >> 2] = fb + 2353;
 HEAP32[gb + 154236 >> 2] = fb + 1075;
 HEAP32[gb + 154240 >> 2] = fb + 103;
 HEAP32[gb + 154244 >> 2] = fb + 101;
 HEAP32[gb + 154248 >> 2] = fb + 62;
 HEAP32[gb + 154252 >> 2] = fb + 28;
 HEAP32[gb + 154256 >> 2] = fb + 63;
 HEAP32[gb + 154260 >> 2] = fb + 29;
 HEAP32[gb + 154264 >> 2] = fb + 34;
 HEAP32[gb + 154268 >> 2] = fb + 1624;
 HEAP32[gb + 154272 >> 2] = fb + 1625;
 HEAP32[gb + 154276 >> 2] = fb + 1626;
 HEAP32[gb + 154280 >> 2] = fb + 1627;
 HEAP32[gb + 154284 >> 2] = fb + 1628;
 HEAP32[gb + 154288 >> 2] = fb + 1629;
 HEAP32[gb + 154292 >> 2] = fb + 36;
 HEAP32[gb + 154296 >> 2] = fb + 104;
 HEAP32[gb + 154300 >> 2] = fb + 108;
 HEAP32[gb + 154304 >> 2] = fb + 94;
 HEAP32[gb + 154308 >> 2] = fb + 1606;
 HEAP32[gb + 154312 >> 2] = fb + 112;
 HEAP32[gb + 154316 >> 2] = fb + 113;
 HEAP32[gb + 154320 >> 2] = fb + 131;
 HEAP32[gb + 154324 >> 2] = fb + 111;
 HEAP32[gb + 154328 >> 2] = fb + 112;
 HEAP32[gb + 154332 >> 2] = fb + 113;
 HEAP32[gb + 154336 >> 2] = fb + 2339;
 HEAP32[gb + 154340 >> 2] = fb + 2340;
 HEAP32[gb + 154344 >> 2] = fb + 1630;
 HEAP32[gb + 154348 >> 2] = fb + 1615;
 HEAP32[gb + 154360 >> 2] = (HEAP32[gb + 154360 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 154364 >> 2] = (HEAP32[gb + 154364 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 154400 >> 2] = fb + 2354;
 HEAP32[gb + 154404 >> 2] = fb + 2355;
 HEAP32[gb + 154408 >> 2] = fb + 38;
 HEAP32[gb + 154412 >> 2] = fb + 1599;
 HEAP32[gb + 154416 >> 2] = fb + 16;
 HEAP32[gb + 154420 >> 2] = fb + 2356;
 HEAP32[gb + 154424 >> 2] = fb + 2357;
 HEAP32[gb + 154428 >> 2] = fb + 2358;
 HEAP32[gb + 154432 >> 2] = fb + 1076;
 HEAP32[gb + 154436 >> 2] = fb + 103;
 HEAP32[gb + 154440 >> 2] = fb + 101;
 HEAP32[gb + 154444 >> 2] = fb + 62;
 HEAP32[gb + 154448 >> 2] = fb + 28;
 HEAP32[gb + 154452 >> 2] = fb + 63;
 HEAP32[gb + 154456 >> 2] = fb + 29;
 HEAP32[gb + 154460 >> 2] = fb + 34;
 HEAP32[gb + 154464 >> 2] = fb + 1631;
 HEAP32[gb + 154468 >> 2] = fb + 1632;
 HEAP32[gb + 154472 >> 2] = fb + 1633;
 HEAP32[gb + 154476 >> 2] = fb + 1634;
 HEAP32[gb + 154480 >> 2] = fb + 1635;
 HEAP32[gb + 154484 >> 2] = fb + 1636;
 HEAP32[gb + 154488 >> 2] = fb + 36;
 HEAP32[gb + 154492 >> 2] = fb + 104;
 HEAP32[gb + 154496 >> 2] = fb + 108;
 HEAP32[gb + 154500 >> 2] = fb + 94;
 HEAP32[gb + 154504 >> 2] = fb + 1606;
 HEAP32[gb + 154508 >> 2] = fb + 112;
 HEAP32[gb + 154512 >> 2] = fb + 113;
 runPostSets180();
}

function __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 136 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 136 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 136 | 0;
  i3 = (i2 | 0) / 136 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 31580641) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 136 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN15DetailPrototypeC2ERKS_(i2, i1);
     i1 = i1 + 136 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 136 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -136 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN15DetailPrototypeD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 136 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 136 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 136 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 136 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 136 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -136 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN15DetailPrototypeD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -136 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN15DetailPrototypeD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function runPostSets41() {
 HEAP32[gb + 58500 >> 2] = fb + 69;
 HEAP32[gb + 58504 >> 2] = fb + 366;
 HEAP32[gb + 58508 >> 2] = fb + 355;
 HEAP32[gb + 58512 >> 2] = fb + 356;
 HEAP32[gb + 58516 >> 2] = fb + 38;
 HEAP32[gb + 58520 >> 2] = fb + 271;
 HEAP32[gb + 58532 >> 2] = fb + 602;
 HEAP32[gb + 58536 >> 2] = fb + 603;
 HEAP32[gb + 58540 >> 2] = fb + 39;
 HEAP32[gb + 58544 >> 2] = fb + 102;
 HEAP32[gb + 58548 >> 2] = fb + 359;
 HEAP32[gb + 58552 >> 2] = fb + 360;
 HEAP32[gb + 58556 >> 2] = fb + 209;
 HEAP32[gb + 58560 >> 2] = fb + 210;
 HEAP32[gb + 58564 >> 2] = fb + 70;
 HEAP32[gb + 58568 >> 2] = fb + 71;
 HEAP32[gb + 58572 >> 2] = fb + 272;
 HEAP32[gb + 58576 >> 2] = fb + 105;
 HEAP32[gb + 58580 >> 2] = fb + 369;
 HEAP32[gb + 58592 >> 2] = fb + 6;
 HEAP32[gb + 58596 >> 2] = fb + 6;
 HEAP32[gb + 58600 >> 2] = fb + 39;
 HEAP32[gb + 58604 >> 2] = fb + 77;
 HEAP32[gb + 58608 >> 2] = fb + 22;
 HEAP32[gb + 58612 >> 2] = fb + 23;
 HEAP32[gb + 58616 >> 2] = fb + 31;
 HEAP32[gb + 58620 >> 2] = fb + 40;
 HEAP32[gb + 58624 >> 2] = (HEAP32[gb + 58624 >> 2] | 0) + (gb + 602071 | 0);
 HEAP32[gb + 58628 >> 2] = (HEAP32[gb + 58628 >> 2] | 0) + (gb + 428867 | 0);
 HEAP32[gb + 58632 >> 2] = (HEAP32[gb + 58632 >> 2] | 0) + (gb + 945665 | 0);
 HEAP32[gb + 58636 >> 2] = (HEAP32[gb + 58636 >> 2] | 0) + (gb + 428874 | 0);
 HEAP32[gb + 58640 >> 2] = (HEAP32[gb + 58640 >> 2] | 0) + (gb + 428883 | 0);
 HEAP32[gb + 58644 >> 2] = (HEAP32[gb + 58644 >> 2] | 0) + (gb + 428893 | 0);
 HEAP32[gb + 58648 >> 2] = (HEAP32[gb + 58648 >> 2] | 0) + (gb + 428903 | 0);
 HEAP32[gb + 58652 >> 2] = (HEAP32[gb + 58652 >> 2] | 0) + (gb + 428913 | 0);
 HEAP32[gb + 58664 >> 2] = fb + 604;
 HEAP32[gb + 58668 >> 2] = fb + 605;
 HEAP32[gb + 58680 >> 2] = fb + 606;
 HEAP32[gb + 58684 >> 2] = fb + 607;
 HEAP32[gb + 58688 >> 2] = fb + 608;
 HEAP32[gb + 58692 >> 2] = fb + 472;
 HEAP32[gb + 58696 >> 2] = fb + 16;
 HEAP32[gb + 58700 >> 2] = fb + 364;
 HEAP32[gb + 58704 >> 2] = fb + 609;
 HEAP32[gb + 58708 >> 2] = fb + 349;
 HEAP32[gb + 58712 >> 2] = fb + 273;
 HEAP32[gb + 58716 >> 2] = fb + 103;
 HEAP32[gb + 58720 >> 2] = fb + 101;
 HEAP32[gb + 58724 >> 2] = fb + 62;
 HEAP32[gb + 58728 >> 2] = fb + 28;
 HEAP32[gb + 58732 >> 2] = fb + 63;
 HEAP32[gb + 58736 >> 2] = fb + 29;
 HEAP32[gb + 58740 >> 2] = fb + 34;
 HEAP32[gb + 58744 >> 2] = fb + 473;
 HEAP32[gb + 58748 >> 2] = fb + 474;
 HEAP32[gb + 58752 >> 2] = fb + 475;
 HEAP32[gb + 58756 >> 2] = fb + 476;
 HEAP32[gb + 58760 >> 2] = fb + 477;
 HEAP32[gb + 58764 >> 2] = fb + 478;
 HEAP32[gb + 58768 >> 2] = fb + 36;
 HEAP32[gb + 58772 >> 2] = fb + 104;
 HEAP32[gb + 58776 >> 2] = fb + 336;
 HEAP32[gb + 58780 >> 2] = fb + 94;
 HEAP32[gb + 58784 >> 2] = fb + 479;
 HEAP32[gb + 58788 >> 2] = fb + 205;
 HEAP32[gb + 58792 >> 2] = fb + 206;
 HEAP32[gb + 58796 >> 2] = fb + 338;
 HEAP32[gb + 58800 >> 2] = fb + 350;
 HEAP32[gb + 58804 >> 2] = fb + 351;
 HEAP32[gb + 58808 >> 2] = fb + 207;
 HEAP32[gb + 58812 >> 2] = fb + 610;
 HEAP32[gb + 58816 >> 2] = fb + 353;
 HEAP32[gb + 58820 >> 2] = fb + 208;
 HEAP32[gb + 58824 >> 2] = fb + 68;
 HEAP32[gb + 58828 >> 2] = fb + 69;
 HEAP32[gb + 58832 >> 2] = fb + 611;
 HEAP32[gb + 58836 >> 2] = fb + 355;
 HEAP32[gb + 58840 >> 2] = fb + 356;
 HEAP32[gb + 58844 >> 2] = fb + 612;
 HEAP32[gb + 58848 >> 2] = fb + 613;
 HEAP32[gb + 58852 >> 2] = fb + 614;
 HEAP32[gb + 58856 >> 2] = fb + 40;
 HEAP32[gb + 58868 >> 2] = fb + 615;
 HEAP32[gb + 58872 >> 2] = fb + 616;
 HEAP32[gb + 58876 >> 2] = fb + 41;
 HEAP32[gb + 58880 >> 2] = fb + 102;
 HEAP32[gb + 58884 >> 2] = fb + 359;
 HEAP32[gb + 58888 >> 2] = fb + 360;
 HEAP32[gb + 58892 >> 2] = fb + 209;
 HEAP32[gb + 58896 >> 2] = fb + 210;
 HEAP32[gb + 58900 >> 2] = fb + 70;
 HEAP32[gb + 58904 >> 2] = fb + 71;
 HEAP32[gb + 58908 >> 2] = fb + 110;
 HEAP32[gb + 58912 >> 2] = fb + 617;
 HEAP32[gb + 58916 >> 2] = fb + 618;
 HEAP32[gb + 58928 >> 2] = fb + 619;
 HEAP32[gb + 58932 >> 2] = fb + 620;
 HEAP32[gb + 58944 >> 2] = fb + 621;
 HEAP32[gb + 58948 >> 2] = fb + 622;
 HEAP32[gb + 58952 >> 2] = fb + 623;
 runPostSets42();
}

function __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_(i3, i4, i5, i10, i11, i12, i2, i8, i9, i1, i7, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0, i45 = 0, i46 = 0, i47 = 0, i48 = 0, i49 = 0, i50 = 0, i51 = 0, i52 = 0, i53 = 0, i54 = 0, i55 = 0, i56 = 0, i57 = 0, i58 = 0, i59 = 0, i60 = 0, i61 = 0, i62 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i13 + 768 | 0;
 i60 = i13 + 752 | 0;
 i62 = i13 + 736 | 0;
 i61 = i13 + 720 | 0;
 i59 = i13 + 704 | 0;
 i26 = i13 + 688 | 0;
 i57 = i13 + 672 | 0;
 i58 = i13 + 656 | 0;
 i46 = i13 + 640 | 0;
 i43 = i13 + 624 | 0;
 i39 = i13 + 608 | 0;
 i45 = i13 + 592 | 0;
 i56 = i13 + 576 | 0;
 i55 = i13 + 560 | 0;
 i42 = i13 + 544 | 0;
 i54 = i13 + 528 | 0;
 i53 = i13 + 512 | 0;
 i38 = i13 + 496 | 0;
 i52 = i13 + 480 | 0;
 i51 = i13 + 464 | 0;
 i40 = i13 + 448 | 0;
 i48 = i13 + 432 | 0;
 i50 = i13 + 416 | 0;
 i49 = i13 + 400 | 0;
 i47 = i13 + 384 | 0;
 i20 = i13 + 368 | 0;
 i44 = i13 + 352 | 0;
 i18 = i13 + 336 | 0;
 i41 = i13 + 320 | 0;
 i16 = i13 + 304 | 0;
 i37 = i13 + 288 | 0;
 i24 = i13 + 272 | 0;
 i30 = i13 + 256 | 0;
 i32 = i13 + 240 | 0;
 i34 = i13 + 224 | 0;
 i36 = i13 + 208 | 0;
 i35 = i13 + 192 | 0;
 i33 = i13 + 176 | 0;
 i31 = i13 + 160 | 0;
 i15 = i13 + 144 | 0;
 i21 = i13 + 128 | 0;
 i23 = i13 + 112 | 0;
 i25 = i13 + 96 | 0;
 i27 = i13 + 80 | 0;
 i29 = i13 + 64 | 0;
 i22 = i13 + 48 | 0;
 i19 = i13 + 32 | 0;
 i17 = i13 + 16 | 0;
 i14 = i13;
 __ZmlRK8Scalar4fS1_(i62, i3, i3);
 __ZmlRK8Scalar4fS1_(i61, i4, i4);
 __ZplRK8Scalar4fS1_(i60, i62, i61);
 __ZmlRK8Scalar4fS1_(i59, i5, i5);
 __ZplRK8Scalar4fS1_(i28, i60, i59);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i58, gb + 1097856 | 0);
 __ZplRK8Scalar4fS1_(i57, i28, i58);
 __Z5rsqrtRK8Scalar4f(i26, i57);
 __ZmlRK8Scalar4fS1_(i46, i3, i26);
 __ZmlRK8Scalar4fS1_(i43, i4, i26);
 __ZmlRK8Scalar4fS1_(i39, i5, i26);
 __ZmiRK8Scalar4fS1_(i56, i2, i8);
 __ZmlRK8Scalar4fS1_(i55, i10, i9);
 __ZmiRK8Scalar4fS1_(i45, i56, i55);
 __ZmiRK8Scalar4fS1_(i54, i2 + 16 | 0, i8 + 16 | 0);
 __ZmlRK8Scalar4fS1_(i53, i11, i9);
 __ZmiRK8Scalar4fS1_(i42, i54, i53);
 __ZmiRK8Scalar4fS1_(i52, i2 + 32 | 0, i8 + 32 | 0);
 __ZmlRK8Scalar4fS1_(i51, i12, i9);
 __ZmiRK8Scalar4fS1_(i38, i52, i51);
 __ZmlRK8Scalar4fS1_(i50, i45, i46);
 __ZmlRK8Scalar4fS1_(i49, i42, i43);
 __ZplRK8Scalar4fS1_(i48, i50, i49);
 __ZmlRK8Scalar4fS1_(i47, i38, i39);
 __ZplRK8Scalar4fS1_(i40, i48, i47);
 __ZmlRK8Scalar4fS1_(i44, i40, i46);
 __ZmiRK8Scalar4fS1_(i20, i45, i44);
 __ZmlRK8Scalar4fS1_(i41, i40, i43);
 __ZmiRK8Scalar4fS1_(i18, i42, i41);
 __ZmlRK8Scalar4fS1_(i37, i40, i39);
 __ZmiRK8Scalar4fS1_(i16, i38, i37);
 __ZmlRK8Scalar4fS1_(i36, i20, i20);
 __ZmlRK8Scalar4fS1_(i35, i18, i18);
 __ZplRK8Scalar4fS1_(i34, i36, i35);
 __ZmlRK8Scalar4fS1_(i33, i16, i16);
 __ZplRK8Scalar4fS1_(i32, i34, i33);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i31, gb + 1097856 | 0);
 __ZplRK8Scalar4fS1_(i30, i32, i31);
 __Z5rsqrtRK8Scalar4f(i24, i30);
 __ZngRK8Scalar4f(i29, i1);
 __ZmlRK8Scalar4fS1_(i27, i29, i28);
 __ZmlRK8Scalar4fS1_(i25, i27, i26);
 __ZmlRK8Scalar4fS1_(i23, i25, i24);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i22, gb + 1097744 | 0);
 __Z3maxRK8Scalar4fS1_(i21, i23, i22);
 __ZanRK8Scalar4fS1_(i15, i21, i7);
 __ZmlRK8Scalar4fS1_(i19, i20, i15);
 __ZN8Scalar4faSERKS_(i6, i19) | 0;
 __ZmlRK8Scalar4fS1_(i17, i18, i15);
 __ZN8Scalar4faSERKS_(i6 + 16 | 0, i17) | 0;
 __ZmlRK8Scalar4fS1_(i14, i16, i15);
 __ZN8Scalar4faSERKS_(i6 + 32 | 0, i14) | 0;
 STACKTOP = i13;
 return;
}

function runPostSets40() {
 HEAP32[gb + 58012 >> 2] = fb + 589;
 HEAP32[gb + 58016 >> 2] = fb + 590;
 HEAP32[gb + 58020 >> 2] = fb + 591;
 HEAP32[gb + 58024 >> 2] = fb + 450;
 HEAP32[gb + 58028 >> 2] = fb + 592;
 HEAP32[gb + 58032 >> 2] = fb + 39;
 HEAP32[gb + 58036 >> 2] = fb + 40;
 HEAP32[gb + 58040 >> 2] = fb + 19;
 HEAP32[gb + 58044 >> 2] = fb + 266;
 HEAP32[gb + 58048 >> 2] = fb + 31;
 HEAP32[gb + 58052 >> 2] = fb + 27;
 HEAP32[gb + 58056 >> 2] = fb + 267;
 HEAP32[gb + 58060 >> 2] = fb + 28;
 HEAP32[gb + 58064 >> 2] = fb + 268;
 HEAP32[gb + 58068 >> 2] = fb + 29;
 HEAP32[gb + 58072 >> 2] = fb + 34;
 HEAP32[gb + 58076 >> 2] = fb + 451;
 HEAP32[gb + 58080 >> 2] = fb + 452;
 HEAP32[gb + 58084 >> 2] = fb + 453;
 HEAP32[gb + 58088 >> 2] = fb + 454;
 HEAP32[gb + 58092 >> 2] = fb + 455;
 HEAP32[gb + 58096 >> 2] = fb + 456;
 HEAP32[gb + 58100 >> 2] = fb + 36;
 HEAP32[gb + 58112 >> 2] = fb + 593;
 HEAP32[gb + 58116 >> 2] = fb + 594;
 HEAP32[gb + 58184 >> 2] = (HEAP32[gb + 58184 >> 2] | 0) + (gb + 500490 | 0);
 HEAP32[gb + 58188 >> 2] = (HEAP32[gb + 58188 >> 2] | 0) + (gb + 426580 | 0);
 HEAP32[gb + 58192 >> 2] = (HEAP32[gb + 58192 >> 2] | 0) + (gb + 426588 | 0);
 HEAP32[gb + 58196 >> 2] = (HEAP32[gb + 58196 >> 2] | 0) + (gb + 944890 | 0);
 HEAP32[gb + 58200 >> 2] = (HEAP32[gb + 58200 >> 2] | 0) + (gb + 426595 | 0);
 HEAP32[gb + 58204 >> 2] = (HEAP32[gb + 58204 >> 2] | 0) + (gb + 426599 | 0);
 HEAP32[gb + 58208 >> 2] = (HEAP32[gb + 58208 >> 2] | 0) + (gb + 426603 | 0);
 HEAP32[gb + 58212 >> 2] = (HEAP32[gb + 58212 >> 2] | 0) + (gb + 426607 | 0);
 HEAP32[gb + 58224 >> 2] = fb + 595;
 HEAP32[gb + 58228 >> 2] = fb + 596;
 HEAP32[gb + 58232 >> 2] = fb + 38;
 HEAP32[gb + 58236 >> 2] = fb + 457;
 HEAP32[gb + 58240 >> 2] = fb + 16;
 HEAP32[gb + 58244 >> 2] = fb + 93;
 HEAP32[gb + 58248 >> 2] = fb + 40;
 HEAP32[gb + 58252 >> 2] = fb + 19;
 HEAP32[gb + 58256 >> 2] = fb + 269;
 HEAP32[gb + 58260 >> 2] = fb + 103;
 HEAP32[gb + 58264 >> 2] = fb + 101;
 HEAP32[gb + 58268 >> 2] = fb + 62;
 HEAP32[gb + 58272 >> 2] = fb + 28;
 HEAP32[gb + 58276 >> 2] = fb + 63;
 HEAP32[gb + 58280 >> 2] = fb + 29;
 HEAP32[gb + 58284 >> 2] = fb + 34;
 HEAP32[gb + 58288 >> 2] = fb + 458;
 HEAP32[gb + 58292 >> 2] = fb + 459;
 HEAP32[gb + 58296 >> 2] = fb + 460;
 HEAP32[gb + 58300 >> 2] = fb + 461;
 HEAP32[gb + 58304 >> 2] = fb + 462;
 HEAP32[gb + 58308 >> 2] = fb + 463;
 HEAP32[gb + 58312 >> 2] = fb + 36;
 HEAP32[gb + 58316 >> 2] = fb + 104;
 HEAP32[gb + 58320 >> 2] = fb + 108;
 HEAP32[gb + 58324 >> 2] = fb + 597;
 HEAP32[gb + 58328 >> 2] = fb + 109;
 HEAP32[gb + 58332 >> 2] = fb + 105;
 HEAP32[gb + 58336 >> 2] = fb + 106;
 HEAP32[gb + 58340 >> 2] = fb + 110;
 HEAP32[gb + 58352 >> 2] = fb + 598;
 HEAP32[gb + 58356 >> 2] = fb + 599;
 HEAP32[gb + 58360 >> 2] = fb + 600;
 HEAP32[gb + 58364 >> 2] = fb + 464;
 HEAP32[gb + 58368 >> 2] = fb + 16;
 HEAP32[gb + 58372 >> 2] = fb + 364;
 HEAP32[gb + 58376 >> 2] = fb + 40;
 HEAP32[gb + 58380 >> 2] = fb + 349;
 HEAP32[gb + 58384 >> 2] = fb + 270;
 HEAP32[gb + 58388 >> 2] = fb + 103;
 HEAP32[gb + 58392 >> 2] = fb + 101;
 HEAP32[gb + 58396 >> 2] = fb + 62;
 HEAP32[gb + 58400 >> 2] = fb + 28;
 HEAP32[gb + 58404 >> 2] = fb + 63;
 HEAP32[gb + 58408 >> 2] = fb + 29;
 HEAP32[gb + 58412 >> 2] = fb + 34;
 HEAP32[gb + 58416 >> 2] = fb + 465;
 HEAP32[gb + 58420 >> 2] = fb + 466;
 HEAP32[gb + 58424 >> 2] = fb + 467;
 HEAP32[gb + 58428 >> 2] = fb + 468;
 HEAP32[gb + 58432 >> 2] = fb + 469;
 HEAP32[gb + 58436 >> 2] = fb + 470;
 HEAP32[gb + 58440 >> 2] = fb + 36;
 HEAP32[gb + 58444 >> 2] = fb + 104;
 HEAP32[gb + 58448 >> 2] = fb + 336;
 HEAP32[gb + 58452 >> 2] = fb + 94;
 HEAP32[gb + 58456 >> 2] = fb + 471;
 HEAP32[gb + 58460 >> 2] = fb + 205;
 HEAP32[gb + 58464 >> 2] = fb + 206;
 HEAP32[gb + 58468 >> 2] = fb + 338;
 HEAP32[gb + 58472 >> 2] = fb + 350;
 HEAP32[gb + 58476 >> 2] = fb + 351;
 HEAP32[gb + 58480 >> 2] = fb + 207;
 HEAP32[gb + 58484 >> 2] = fb + 365;
 HEAP32[gb + 58488 >> 2] = fb + 601;
 HEAP32[gb + 58492 >> 2] = fb + 208;
 HEAP32[gb + 58496 >> 2] = fb + 68;
 runPostSets41();
}

function __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE(i11, i10, i6) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i9 = i13;
 i7 = i10 + 100 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i12 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i12 = 3;
 if ((i12 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i10);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 L6 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i1 + 44 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i5 | 0)) break;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i3 | 0)) break L6;
  }
  if ((i2 | 0) > -1) {
   i3 = HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (i2 << 2) >> 2] & 1048575;
   i2 = HEAP8[i1 + 164 >> 0] | 0;
   if (!(i2 & 1)) i12 = 11; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i12 = 11;
   if ((i12 | 0) == 11) {
    __ZN8Material15BuildPropertiesEv(i10);
    i2 = HEAP32[i7 >> 2] | 0;
    i1 = i2;
    i2 = HEAP8[i2 + 164 >> 0] | 0;
   }
   i3 = HEAP32[(HEAP32[i1 + 84 >> 2] | 0) + i3 + 20 >> 2] | 0;
   if (!(i2 & 1)) i12 = 14; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i12 = 14;
   if ((i12 | 0) == 14) {
    __ZN8Material15BuildPropertiesEv(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   if ((i3 | 0) > -1) {
    i12 = (HEAP32[i1 + 84 >> 2] | 0) + (HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) + i3 << 2) >> 2] & 1048575) | 0;
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    STACKTOP = i13;
    return;
   } else {
    HEAPF32[i11 >> 2] = Math_fround(1.0);
    HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
    HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
    STACKTOP = i13;
    return;
   }
  }
 } while (0);
 i5 = i10 + 48 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = i5;
  L31 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L31;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if (!((i1 | 0) == (i5 | 0) ? 1 : (i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0))) {
   i9 = HEAP32[i1 + 24 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i12 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i11 + 4 >> 2] = i9;
   HEAP32[i11 + 8 >> 2] = i10;
   HEAP32[i11 + 12 >> 2] = i12;
   STACKTOP = i13;
   return;
  }
 }
 i4 = i10 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 33; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 33; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 } while (0);
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = HEAP16[i9 + 8 >> 1] | 0;
 HEAP8[i8 + 8 >> 0] = i1;
 HEAP8[i8 + 9 >> 0] = (i1 & 65535) >>> 8;
 i1 = i8 + 12 | 0;
 i2 = i9 + 12 | 0;
 i3 = HEAP32[i9 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i8 + 24 | 0;
 HEAP32[i4 >> 2] = i3;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i9 + 16 >> 2] | 0;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i4 >> 2] | 0;
   i11 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i6;
   if (i6) i11 = 8;
  } else {
   i2 = i3;
   i11 = 6;
  }
  if ((i11 | 0) == 6) {
   i3 = i6 + 16 & -16;
   HEAP32[i7 >> 2] = 54;
   HEAP32[i7 + 4 >> 2] = i2;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i8 + 20 >> 2] = i3 | -2147483648;
   HEAP32[i8 + 16 >> 2] = i6;
   i1 = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 HEAP32[i8 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 i1 = i8 + 32 | 0;
 i2 = i9 + 32 | 0;
 i3 = HEAP32[i9 + 44 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i3;
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i11 = i8 + 48 | 0;
  i7 = i9 + 48 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  HEAP32[i11 >> 2] = i7;
  i11 = i8 + 52 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i11 + 16 >> 2] = 0;
  HEAP8[i11 + 20 >> 0] = 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9copy_fromERKSM_j(i8, i9, i10);
  STACKTOP = i12;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i9 + 36 >> 2] | 0;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i4 >> 2] | 0;
  i11 = 15;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i6;
  if (i6) i11 = 17;
 } else {
  i2 = i3;
  i11 = 15;
 }
 if ((i11 | 0) == 15) {
  i4 = i6 + 16 & -16;
  HEAP32[i7 >> 2] = 54;
  HEAP32[i7 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i8 + 40 >> 2] = i4 | -2147483648;
  HEAP32[i8 + 36 >> 2] = i6;
  i1 = i7;
  i11 = 17;
 }
 if ((i11 | 0) == 17) _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 i11 = i8 + 48 | 0;
 i7 = i9 + 48 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i11 >> 2] = i7;
 i11 = i8 + 52 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP8[i11 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9copy_fromERKSM_j(i8, i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim5human17HumanPoseBlendEndERNS0_9HumanPoseERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 f3 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i2 >> 2]))))));
 i8 = i1 + 80 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
 i6 = i1 + 84 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 i4 = i1 + 88 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
 i2 = i1 + 92 | 0;
 f10 = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f10 * f10))))));
 f7 = Math_fround(f7 * f9);
 f5 = Math_fround(f5 * f9);
 f10 = Math_fround(f10 * f9);
 HEAPF32[i8 >> 2] = Math_fround(f11 * f9);
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i4 >> 2] = f5;
 HEAPF32[i2 >> 2] = f10;
 i2 = i1 + 144 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 i4 = i1 + 148 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
 i6 = i1 + 152 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 i8 = i1 + 156 | 0;
 f9 = Math_fround(f3 + Math_fround(HEAPF32[i8 >> 2]));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f9 * f9))))));
 f5 = Math_fround(f5 * f11);
 f7 = Math_fround(f7 * f11);
 f9 = Math_fround(f9 * f11);
 HEAPF32[i2 >> 2] = Math_fround(f10 * f11);
 HEAPF32[i4 >> 2] = f5;
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i8 >> 2] = f9;
 i8 = i1 + 208 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
 i6 = i1 + 212 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 i4 = i1 + 216 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
 i2 = i1 + 220 | 0;
 f11 = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f11 * f11))))));
 f7 = Math_fround(f7 * f10);
 f5 = Math_fround(f5 * f10);
 f11 = Math_fround(f11 * f10);
 HEAPF32[i8 >> 2] = Math_fround(f9 * f10);
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i4 >> 2] = f5;
 HEAPF32[i2 >> 2] = f11;
 i2 = i1 + 272 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(0.0));
 i4 = i1 + 276 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
 i6 = i1 + 280 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 i8 = i1 + 284 | 0;
 f10 = Math_fround(f3 + Math_fround(HEAPF32[i8 >> 2]));
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f7 * f7) + Math_fround(f10 * f10))))));
 f5 = Math_fround(f5 * f9);
 f7 = Math_fround(f7 * f9);
 f10 = Math_fround(f10 * f9);
 HEAPF32[i2 >> 2] = Math_fround(f11 * f9);
 HEAPF32[i4 >> 2] = f5;
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i8 >> 2] = f10;
 i8 = i1 + 12 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + Math_fround(0.0));
 i6 = i1 + 16 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 i4 = i1 + 20 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(0.0));
 i2 = i1 + 24 | 0;
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7)) + Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))))));
 f7 = Math_fround(f7 * f9);
 f5 = Math_fround(f5 * f9);
 f3 = Math_fround(f3 * f9);
 HEAPF32[i8 >> 2] = Math_fround(f10 * f9);
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i4 >> 2] = f5;
 HEAPF32[i2 >> 2] = f3;
 return;
}

function __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i11 = i16 + 4 | 0;
 i14 = i16;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i13);
 i15 = i12 + 80 | 0;
 i8 = i13 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i13 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i15, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i10 = i12 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i10, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i6 = i12 + 88 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i12 + 92 | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i5 = i1;
 }
 HEAP32[i4 >> 2] = i2;
 i1 = i12 + 76 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i5 = i12 + 100 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4); else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12 + 32 | 0, i13);
 i1 = i12 + 60 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i12 + 109 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i13);
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i13, i14, gb + 411165 | 0, 1);
 i3 = i12 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i12 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i12 + 108 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i8 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i12 + 48 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  mftCall_vii(i7 | 0, i8 | 0, i9 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) i1 = 0; else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = (i2 >>> 0) / (i1 >>> 0) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
 HEAP32[i3 >> 2] = i11;
 f18 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i15 >> 2] | 0));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i10 >> 2] | 0));
 HEAPF32[i12 + 68 >> 2] = f18;
 HEAPF32[i12 + 72 >> 2] = f17;
 __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i13, HEAP32[i14 >> 2] | 0, i11, 0);
 STACKTOP = i16;
 return;
}

function runPostSets205() {
 HEAP32[gb + 174916 >> 2] = fb + 2003;
 HEAP32[gb + 174920 >> 2] = fb + 2004;
 HEAP32[gb + 174924 >> 2] = fb + 2005;
 HEAP32[gb + 174928 >> 2] = fb + 2006;
 HEAP32[gb + 174932 >> 2] = fb + 2007;
 HEAP32[gb + 174936 >> 2] = fb + 36;
 HEAP32[gb + 174948 >> 2] = (HEAP32[gb + 174948 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 174952 >> 2] = (HEAP32[gb + 174952 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 174988 >> 2] = fb + 2676;
 HEAP32[gb + 174992 >> 2] = fb + 2677;
 HEAP32[gb + 174996 >> 2] = fb + 2608;
 HEAP32[gb + 175e3 >> 2] = fb + 1921;
 HEAP32[gb + 175004 >> 2] = fb + 16;
 HEAP32[gb + 175008 >> 2] = fb + 2678;
 HEAP32[gb + 175012 >> 2] = fb + 2679;
 HEAP32[gb + 175016 >> 2] = fb + 19;
 HEAP32[gb + 175020 >> 2] = fb + 1241;
 HEAP32[gb + 175024 >> 2] = fb + 103;
 HEAP32[gb + 175028 >> 2] = fb + 101;
 HEAP32[gb + 175032 >> 2] = fb + 62;
 HEAP32[gb + 175036 >> 2] = fb + 28;
 HEAP32[gb + 175040 >> 2] = fb + 63;
 HEAP32[gb + 175044 >> 2] = fb + 29;
 HEAP32[gb + 175048 >> 2] = fb + 34;
 HEAP32[gb + 175052 >> 2] = fb + 2008;
 HEAP32[gb + 175056 >> 2] = fb + 2009;
 HEAP32[gb + 175060 >> 2] = fb + 2010;
 HEAP32[gb + 175064 >> 2] = fb + 2011;
 HEAP32[gb + 175068 >> 2] = fb + 2012;
 HEAP32[gb + 175072 >> 2] = fb + 2013;
 HEAP32[gb + 175076 >> 2] = fb + 36;
 HEAP32[gb + 175080 >> 2] = fb + 104;
 HEAP32[gb + 175084 >> 2] = fb + 108;
 HEAP32[gb + 175088 >> 2] = fb + 94;
 HEAP32[gb + 175092 >> 2] = fb + 130;
 HEAP32[gb + 175096 >> 2] = fb + 112;
 HEAP32[gb + 175100 >> 2] = fb + 113;
 HEAP32[gb + 175104 >> 2] = fb + 131;
 HEAP32[gb + 175108 >> 2] = fb + 2680;
 HEAP32[gb + 175112 >> 2] = fb + 112;
 HEAP32[gb + 175116 >> 2] = fb + 113;
 HEAP32[gb + 175120 >> 2] = fb + 2681;
 HEAP32[gb + 175124 >> 2] = fb + 2613;
 HEAP32[gb + 175136 >> 2] = (HEAP32[gb + 175136 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 175140 >> 2] = (HEAP32[gb + 175140 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 175176 >> 2] = fb + 2682;
 HEAP32[gb + 175180 >> 2] = fb + 2683;
 HEAP32[gb + 175184 >> 2] = fb + 2684;
 HEAP32[gb + 175188 >> 2] = fb + 2014;
 HEAP32[gb + 175192 >> 2] = fb + 16;
 HEAP32[gb + 175196 >> 2] = fb + 2685;
 HEAP32[gb + 175200 >> 2] = fb + 2686;
 HEAP32[gb + 175204 >> 2] = fb + 19;
 HEAP32[gb + 175208 >> 2] = fb + 1242;
 HEAP32[gb + 175212 >> 2] = fb + 103;
 HEAP32[gb + 175216 >> 2] = fb + 101;
 HEAP32[gb + 175220 >> 2] = fb + 62;
 HEAP32[gb + 175224 >> 2] = fb + 28;
 HEAP32[gb + 175228 >> 2] = fb + 63;
 HEAP32[gb + 175232 >> 2] = fb + 29;
 HEAP32[gb + 175236 >> 2] = fb + 34;
 HEAP32[gb + 175240 >> 2] = fb + 2015;
 HEAP32[gb + 175244 >> 2] = fb + 2016;
 HEAP32[gb + 175248 >> 2] = fb + 2017;
 HEAP32[gb + 175252 >> 2] = fb + 2018;
 HEAP32[gb + 175256 >> 2] = fb + 2019;
 HEAP32[gb + 175260 >> 2] = fb + 2020;
 HEAP32[gb + 175264 >> 2] = fb + 36;
 HEAP32[gb + 175268 >> 2] = fb + 104;
 HEAP32[gb + 175272 >> 2] = fb + 108;
 HEAP32[gb + 175276 >> 2] = fb + 94;
 HEAP32[gb + 175280 >> 2] = fb + 130;
 HEAP32[gb + 175284 >> 2] = fb + 112;
 HEAP32[gb + 175288 >> 2] = fb + 113;
 HEAP32[gb + 175292 >> 2] = fb + 131;
 HEAP32[gb + 175296 >> 2] = fb + 2687;
 HEAP32[gb + 175300 >> 2] = fb + 112;
 HEAP32[gb + 175304 >> 2] = fb + 113;
 HEAP32[gb + 175308 >> 2] = fb + 2688;
 HEAP32[gb + 175312 >> 2] = fb + 2689;
 HEAP32[gb + 175324 >> 2] = fb + 2690;
 HEAP32[gb + 175328 >> 2] = fb + 2691;
 HEAP32[gb + 175332 >> 2] = fb + 2692;
 HEAP32[gb + 175336 >> 2] = fb + 2021;
 HEAP32[gb + 175340 >> 2] = fb + 16;
 HEAP32[gb + 175344 >> 2] = fb + 2693;
 HEAP32[gb + 175348 >> 2] = fb + 2694;
 HEAP32[gb + 175352 >> 2] = fb + 19;
 HEAP32[gb + 175356 >> 2] = fb + 1243;
 HEAP32[gb + 175360 >> 2] = fb + 103;
 HEAP32[gb + 175364 >> 2] = fb + 101;
 HEAP32[gb + 175368 >> 2] = fb + 62;
 HEAP32[gb + 175372 >> 2] = fb + 28;
 HEAP32[gb + 175376 >> 2] = fb + 63;
 HEAP32[gb + 175380 >> 2] = fb + 29;
 HEAP32[gb + 175384 >> 2] = fb + 34;
 HEAP32[gb + 175388 >> 2] = fb + 2022;
 HEAP32[gb + 175392 >> 2] = fb + 2023;
 HEAP32[gb + 175396 >> 2] = fb + 2024;
 HEAP32[gb + 175400 >> 2] = fb + 2025;
 runPostSets206();
}

function runPostSets181() {
 HEAP32[gb + 155044 >> 2] = fb + 101;
 HEAP32[gb + 155048 >> 2] = fb + 62;
 HEAP32[gb + 155052 >> 2] = fb + 28;
 HEAP32[gb + 155056 >> 2] = fb + 63;
 HEAP32[gb + 155060 >> 2] = fb + 29;
 HEAP32[gb + 155064 >> 2] = fb + 34;
 HEAP32[gb + 155068 >> 2] = fb + 1647;
 HEAP32[gb + 155072 >> 2] = fb + 1648;
 HEAP32[gb + 155076 >> 2] = fb + 1649;
 HEAP32[gb + 155080 >> 2] = fb + 1650;
 HEAP32[gb + 155084 >> 2] = fb + 1651;
 HEAP32[gb + 155088 >> 2] = fb + 1652;
 HEAP32[gb + 155092 >> 2] = fb + 36;
 HEAP32[gb + 155096 >> 2] = fb + 104;
 HEAP32[gb + 155100 >> 2] = fb + 108;
 HEAP32[gb + 155104 >> 2] = fb + 94;
 HEAP32[gb + 155108 >> 2] = fb + 1574;
 HEAP32[gb + 155112 >> 2] = fb + 112;
 HEAP32[gb + 155116 >> 2] = fb + 113;
 HEAP32[gb + 155120 >> 2] = fb + 131;
 HEAP32[gb + 155124 >> 2] = fb + 111;
 HEAP32[gb + 155128 >> 2] = fb + 112;
 HEAP32[gb + 155132 >> 2] = fb + 113;
 HEAP32[gb + 155136 >> 2] = fb + 2317;
 HEAP32[gb + 155140 >> 2] = fb + 2318;
 HEAP32[gb + 155144 >> 2] = fb + 2374;
 HEAP32[gb + 155148 >> 2] = fb + 1575;
 HEAP32[gb + 155152 >> 2] = fb + 1059;
 HEAP32[gb + 155156 >> 2] = fb + 1060;
 HEAP32[gb + 155160 >> 2] = fb + 1576;
 HEAP32[gb + 155164 >> 2] = fb + 1577;
 HEAP32[gb + 155176 >> 2] = (HEAP32[gb + 155176 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 155180 >> 2] = (HEAP32[gb + 155180 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 155216 >> 2] = fb + 2375;
 HEAP32[gb + 155220 >> 2] = fb + 2376;
 HEAP32[gb + 155224 >> 2] = fb + 38;
 HEAP32[gb + 155228 >> 2] = fb + 1599;
 HEAP32[gb + 155232 >> 2] = fb + 16;
 HEAP32[gb + 155236 >> 2] = fb + 2377;
 HEAP32[gb + 155240 >> 2] = fb + 2378;
 HEAP32[gb + 155244 >> 2] = fb + 2379;
 HEAP32[gb + 155248 >> 2] = fb + 1080;
 HEAP32[gb + 155252 >> 2] = fb + 103;
 HEAP32[gb + 155256 >> 2] = fb + 101;
 HEAP32[gb + 155260 >> 2] = fb + 62;
 HEAP32[gb + 155264 >> 2] = fb + 28;
 HEAP32[gb + 155268 >> 2] = fb + 63;
 HEAP32[gb + 155272 >> 2] = fb + 29;
 HEAP32[gb + 155276 >> 2] = fb + 34;
 HEAP32[gb + 155280 >> 2] = fb + 1653;
 HEAP32[gb + 155284 >> 2] = fb + 1654;
 HEAP32[gb + 155288 >> 2] = fb + 1655;
 HEAP32[gb + 155292 >> 2] = fb + 1656;
 HEAP32[gb + 155296 >> 2] = fb + 1657;
 HEAP32[gb + 155300 >> 2] = fb + 1658;
 HEAP32[gb + 155304 >> 2] = fb + 36;
 HEAP32[gb + 155308 >> 2] = fb + 104;
 HEAP32[gb + 155312 >> 2] = fb + 108;
 HEAP32[gb + 155316 >> 2] = fb + 94;
 HEAP32[gb + 155320 >> 2] = fb + 1606;
 HEAP32[gb + 155324 >> 2] = fb + 112;
 HEAP32[gb + 155328 >> 2] = fb + 113;
 HEAP32[gb + 155332 >> 2] = fb + 131;
 HEAP32[gb + 155336 >> 2] = fb + 111;
 HEAP32[gb + 155340 >> 2] = fb + 112;
 HEAP32[gb + 155344 >> 2] = fb + 113;
 HEAP32[gb + 155348 >> 2] = fb + 2339;
 HEAP32[gb + 155352 >> 2] = fb + 2340;
 HEAP32[gb + 155356 >> 2] = fb + 1659;
 HEAP32[gb + 155360 >> 2] = fb + 1660;
 HEAP32[gb + 155372 >> 2] = (HEAP32[gb + 155372 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 155376 >> 2] = (HEAP32[gb + 155376 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 155412 >> 2] = fb + 2380;
 HEAP32[gb + 155416 >> 2] = fb + 2381;
 HEAP32[gb + 155420 >> 2] = fb + 38;
 HEAP32[gb + 155424 >> 2] = fb + 1661;
 HEAP32[gb + 155428 >> 2] = fb + 16;
 HEAP32[gb + 155432 >> 2] = fb + 2382;
 HEAP32[gb + 155436 >> 2] = fb + 2383;
 HEAP32[gb + 155440 >> 2] = fb + 19;
 HEAP32[gb + 155444 >> 2] = fb + 1081;
 HEAP32[gb + 155448 >> 2] = fb + 103;
 HEAP32[gb + 155452 >> 2] = fb + 101;
 HEAP32[gb + 155456 >> 2] = fb + 62;
 HEAP32[gb + 155460 >> 2] = fb + 28;
 HEAP32[gb + 155464 >> 2] = fb + 63;
 HEAP32[gb + 155468 >> 2] = fb + 29;
 HEAP32[gb + 155472 >> 2] = fb + 34;
 HEAP32[gb + 155476 >> 2] = fb + 1662;
 HEAP32[gb + 155480 >> 2] = fb + 1663;
 HEAP32[gb + 155484 >> 2] = fb + 1664;
 HEAP32[gb + 155488 >> 2] = fb + 1665;
 HEAP32[gb + 155492 >> 2] = fb + 1666;
 HEAP32[gb + 155496 >> 2] = fb + 1667;
 HEAP32[gb + 155500 >> 2] = fb + 36;
 HEAP32[gb + 155504 >> 2] = fb + 104;
 HEAP32[gb + 155508 >> 2] = fb + 108;
 HEAP32[gb + 155512 >> 2] = fb + 94;
 HEAP32[gb + 155516 >> 2] = fb + 1574;
 HEAP32[gb + 155520 >> 2] = fb + 112;
 runPostSets182();
}

function runPostSets127() {
 HEAP32[gb + 111608 >> 2] = fb + 1757;
 HEAP32[gb + 111612 >> 2] = fb + 1238;
 HEAP32[gb + 111616 >> 2] = fb + 16;
 HEAP32[gb + 111620 >> 2] = fb + 1758;
 HEAP32[gb + 111624 >> 2] = fb + 1759;
 HEAP32[gb + 111628 >> 2] = fb + 19;
 HEAP32[gb + 111632 >> 2] = fb + 876;
 HEAP32[gb + 111636 >> 2] = fb + 103;
 HEAP32[gb + 111640 >> 2] = fb + 101;
 HEAP32[gb + 111644 >> 2] = fb + 62;
 HEAP32[gb + 111648 >> 2] = fb + 28;
 HEAP32[gb + 111652 >> 2] = fb + 63;
 HEAP32[gb + 111656 >> 2] = fb + 29;
 HEAP32[gb + 111660 >> 2] = fb + 34;
 HEAP32[gb + 111664 >> 2] = fb + 1239;
 HEAP32[gb + 111668 >> 2] = fb + 1240;
 HEAP32[gb + 111672 >> 2] = fb + 1241;
 HEAP32[gb + 111676 >> 2] = fb + 1242;
 HEAP32[gb + 111680 >> 2] = fb + 1243;
 HEAP32[gb + 111684 >> 2] = fb + 1244;
 HEAP32[gb + 111688 >> 2] = fb + 36;
 HEAP32[gb + 111692 >> 2] = fb + 104;
 HEAP32[gb + 111696 >> 2] = fb + 108;
 HEAP32[gb + 111700 >> 2] = fb + 94;
 HEAP32[gb + 111704 >> 2] = fb + 1245;
 HEAP32[gb + 111708 >> 2] = fb + 105;
 HEAP32[gb + 111712 >> 2] = fb + 106;
 HEAP32[gb + 111716 >> 2] = fb + 110;
 HEAP32[gb + 111720 >> 2] = fb + 1246;
 HEAP32[gb + 111724 >> 2] = fb + 1247;
 HEAP32[gb + 111728 >> 2] = fb + 1248;
 HEAP32[gb + 111732 >> 2] = fb + 1249;
 HEAP32[gb + 111736 >> 2] = fb + 1250;
 HEAP32[gb + 111740 >> 2] = fb + 101;
 HEAP32[gb + 111744 >> 2] = fb + 1760;
 HEAP32[gb + 111748 >> 2] = fb + 1251;
 HEAP32[gb + 111752 >> 2] = fb + 1252;
 HEAP32[gb + 111764 >> 2] = (HEAP32[gb + 111764 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 111768 >> 2] = (HEAP32[gb + 111768 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 111804 >> 2] = fb + 1761;
 HEAP32[gb + 111808 >> 2] = fb + 1762;
 HEAP32[gb + 111812 >> 2] = fb + 1757;
 HEAP32[gb + 111816 >> 2] = fb + 1238;
 HEAP32[gb + 111820 >> 2] = fb + 16;
 HEAP32[gb + 111824 >> 2] = fb + 1763;
 HEAP32[gb + 111828 >> 2] = fb + 1764;
 HEAP32[gb + 111832 >> 2] = fb + 19;
 HEAP32[gb + 111836 >> 2] = fb + 877;
 HEAP32[gb + 111840 >> 2] = fb + 103;
 HEAP32[gb + 111844 >> 2] = fb + 101;
 HEAP32[gb + 111848 >> 2] = fb + 62;
 HEAP32[gb + 111852 >> 2] = fb + 28;
 HEAP32[gb + 111856 >> 2] = fb + 63;
 HEAP32[gb + 111860 >> 2] = fb + 29;
 HEAP32[gb + 111864 >> 2] = fb + 34;
 HEAP32[gb + 111868 >> 2] = fb + 1253;
 HEAP32[gb + 111872 >> 2] = fb + 1254;
 HEAP32[gb + 111876 >> 2] = fb + 1255;
 HEAP32[gb + 111880 >> 2] = fb + 1256;
 HEAP32[gb + 111884 >> 2] = fb + 1257;
 HEAP32[gb + 111888 >> 2] = fb + 1258;
 HEAP32[gb + 111892 >> 2] = fb + 36;
 HEAP32[gb + 111896 >> 2] = fb + 104;
 HEAP32[gb + 111900 >> 2] = fb + 108;
 HEAP32[gb + 111904 >> 2] = fb + 94;
 HEAP32[gb + 111908 >> 2] = fb + 1245;
 HEAP32[gb + 111912 >> 2] = fb + 105;
 HEAP32[gb + 111916 >> 2] = fb + 106;
 HEAP32[gb + 111920 >> 2] = fb + 110;
 HEAP32[gb + 111924 >> 2] = fb + 1246;
 HEAP32[gb + 111928 >> 2] = fb + 1247;
 HEAP32[gb + 111932 >> 2] = fb + 1248;
 HEAP32[gb + 111936 >> 2] = fb + 1249;
 HEAP32[gb + 111940 >> 2] = fb + 1250;
 HEAP32[gb + 111944 >> 2] = fb + 102;
 HEAP32[gb + 111948 >> 2] = fb + 1765;
 HEAP32[gb + 111952 >> 2] = fb + 1259;
 HEAP32[gb + 111964 >> 2] = (HEAP32[gb + 111964 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 111968 >> 2] = (HEAP32[gb + 111968 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 112004 >> 2] = fb + 1766;
 HEAP32[gb + 112008 >> 2] = fb + 1767;
 HEAP32[gb + 112012 >> 2] = fb + 38;
 HEAP32[gb + 112016 >> 2] = fb + 145;
 HEAP32[gb + 112020 >> 2] = fb + 16;
 HEAP32[gb + 112024 >> 2] = fb + 93;
 HEAP32[gb + 112028 >> 2] = fb + 1768;
 HEAP32[gb + 112032 >> 2] = fb + 19;
 HEAP32[gb + 112036 >> 2] = fb + 878;
 HEAP32[gb + 112040 >> 2] = fb + 103;
 HEAP32[gb + 112044 >> 2] = fb + 101;
 HEAP32[gb + 112048 >> 2] = fb + 62;
 HEAP32[gb + 112052 >> 2] = fb + 28;
 HEAP32[gb + 112056 >> 2] = fb + 63;
 HEAP32[gb + 112060 >> 2] = fb + 29;
 HEAP32[gb + 112064 >> 2] = fb + 34;
 HEAP32[gb + 112068 >> 2] = fb + 1260;
 HEAP32[gb + 112072 >> 2] = fb + 1261;
 HEAP32[gb + 112076 >> 2] = fb + 1262;
 HEAP32[gb + 112080 >> 2] = fb + 1263;
 HEAP32[gb + 112084 >> 2] = fb + 1264;
 runPostSets128();
}

function __ZN15AABBTreeOverlapIN5physx2Gu12OBBAABBTestsILb1EEEEclEPNS0_2Sq13PrunerPayloadERKNS5_8AABBTreeERKS3_RNS5_14PrunerCallbackE(i1, i17, i19, i18, i20) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i20 = i20 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i21 + 48 | 0;
 i4 = i21 + 32 | 0;
 i15 = i21 + 72 | 0;
 i6 = i21 + 16 | 0;
 i7 = i21;
 i16 = i21 + 64 | 0;
 i8 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = i8;
 i9 = i6 + 4 | 0;
 i10 = i6 + 8 | 0;
 i11 = i6 + 12 | 0;
 i12 = i7 + 4 | 0;
 i13 = i7 + 8 | 0;
 i14 = i7 + 12 | 0;
 i1 = 1;
 L1 : while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i15 + (i1 << 2) >> 2] | 0;
  i26 = HEAP32[i2 >> 2] | 0;
  i25 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  f22 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i2 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f24 = Math_fround(Math_fround(i26 & 255 | 0) * f22);
  f23 = Math_fround(Math_fround(i25 & 255 | 0) * f22);
  f22 = Math_fround(Math_fround(i3 & 255 | 0) * f22);
  HEAP32[i6 >> 2] = i26;
  HEAP32[i9 >> 2] = i25;
  HEAP32[i10 >> 2] = i3;
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = f24;
  HEAPF32[i12 >> 2] = f23;
  HEAPF32[i13 >> 2] = f22;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  L3 : do if (__ZNK5physx2Gu12OBBAABBTestsILb1EEclENS_6shdfnd3aos5Vec3VES5_(i18, i4, i5) | 0) {
   while (1) {
    i3 = i2 + 16 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!((i2 & 1 | 0) == 0 & 0 == 0)) break;
    i27 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
    getTempRet0() | 0;
    i27 = i27 & 524287;
    i2 = i8 + (i27 * 24 | 0) | 0;
    i3 = i1 + 1 | 0;
    HEAP32[i15 + (i1 << 2) >> 2] = i8 + ((i27 + 1 | 0) * 24 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
    i25 = HEAP32[i8 + (i27 * 24 | 0) + 4 >> 2] | 0;
    i26 = HEAP32[i8 + (i27 * 24 | 0) + 8 >> 2] | 0;
    f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + (i27 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
    f22 = Math_fround(Math_fround(i1 & 255 | 0) * f24);
    f23 = Math_fround(Math_fround(i25 & 255 | 0) * f24);
    f24 = Math_fround(Math_fround(i26 & 255 | 0) * f24);
    HEAP32[i6 >> 2] = i1;
    HEAP32[i9 >> 2] = i25;
    HEAP32[i10 >> 2] = i26;
    HEAPF32[i11 >> 2] = Math_fround(0.0);
    HEAPF32[i7 >> 2] = f22;
    HEAPF32[i12 >> 2] = f23;
    HEAPF32[i13 >> 2] = f24;
    HEAPF32[i14 >> 2] = Math_fround(0.0);
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    if (!(__ZNK5physx2Gu12OBBAABBTestsILb1EEclENS_6shdfnd3aos5Vec3VES5_(i18, i4, i5) | 0)) {
     i1 = i3;
     break L3;
    } else i1 = i3;
   }
   i26 = HEAP32[i19 >> 2] | 0;
   i27 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
   getTempRet0() | 0;
   if (!(mftCall_iiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i16 | 0, i17 + (HEAP32[i26 + ((i27 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
    i1 = 0;
    i2 = 7;
    break L1;
   }
  } while (0);
  if (!i1) {
   i1 = 1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i21;
  return i1 | 0;
 }
 return 0;
}

function __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i5);
 i4 = i8 + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i9 = i5 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i5 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i8 + 48 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 50 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 49 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i8 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i8 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 72 | 0, i5);
 i4 = i8 + 56 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i1;
 i4 = i8 + 60 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i4 >> 2] = i2;
 i5 = i8 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = i8 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx6shdfnd12PxRingBuffer11receiveDataERPKvRj(i12, i7, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = i12 + 32 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i8 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2];
  STACKTOP = i14;
  return i13 | 0;
 }
 i9 = i12 + 20 | 0;
 i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 i6 = i12 + 16 | 0;
 if ((i1 | 0) == (HEAP32[HEAP32[i6 >> 2] >> 2] | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i13 = i12 + 4 | 0;
 i4 = i1;
 L9 : while (1) {
  i2 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i2 + i4 >> 2] | 0) + -8;
  i5 = i2 + (i4 + 8) | 0;
  HEAP32[i7 >> 2] = i5;
  i1 = HEAP32[i2 + (i4 + 4) >> 2] & 2147483647;
  L11 : do switch (i1 | 0) {
  case 2:
   {
    i1 = i5;
    i3 = 12;
    break L9;
   }
  case 1:
   {
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i2 + (i1 + 4) >> 2] | 0) < 0) {
     HEAP32[i3 >> 2] = 0;
     i1 = 0;
     break L11;
    }
    i1 = (HEAP32[i2 + i1 >> 2] | 0) + i1 | 0;
    i2 = HEAP32[i13 >> 2] | 0;
    if (i1 >>> 0 < i2 >>> 0) {
     HEAP32[i3 >> 2] = i1;
     break L11;
    } else {
     i1 = i1 - i2 | 0;
     HEAP32[i3 >> 2] = i1;
     break L11;
    }
   }
  case 3:
   {
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    do if ((HEAP32[i2 + (i1 + 4) >> 2] | 0) < 0) HEAP32[i3 >> 2] = 0; else {
     i1 = (HEAP32[i2 + i1 >> 2] | 0) + i1 | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     if (i1 >>> 0 < i2 >>> 0) {
      HEAP32[i3 >> 2] = i1;
      break;
     } else {
      HEAP32[i3 >> 2] = i1 - i2;
      break;
     }
    } while (0);
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i1 = i3 + 12 | 0;
    _memcpy(HEAP32[i1 >> 2] | 0, i5 | 0, i4 | 0) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
    i3 = i3 + 16 | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i5 - i4;
    if ((i5 | 0) != (i4 | 0)) {
     i1 = 0;
     i3 = 26;
     break L9;
    }
    HEAP32[i1 >> 2] = 0;
    i5 = HEAP32[i11 >> 2] | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i8 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2];
    if ((i1 | 0) != 1) {
     i3 = 26;
     break L9;
    }
    i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
    break;
   }
  default:
   {
    i3 = 26;
    break L9;
   }
  } while (0);
  if ((i1 | 0) == (HEAP32[HEAP32[i6 >> 2] >> 2] | 0)) {
   i1 = 1;
   i3 = 26;
   break;
  } else i4 = i1;
 }
 if ((i3 | 0) == 12) {
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i3 = mftCall_iiiiii(i7 | 0, i8 | 0, 20, (i3 ? gb + 777940 | 0 : gb + 837976 | 0) | 0, gb + 778098 | 0, 275) | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i1 = HEAP32[i2 + (i4 + 12) >> 2] | 0;
  i2 = i3 + 4 | 0;
  HEAP32[i2 >> 2] = i1;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i1, gb + 778098 | 0, 419) | 0;
  HEAP32[i3 + 8 >> 2] = i1;
  HEAP32[i3 + 12 >> 2] = i1;
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 >> 2] = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i1 + (i2 + 4) >> 2] | 0) < 0) {
   HEAP32[i3 >> 2] = 0;
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
  i2 = (HEAP32[i1 + i2 >> 2] | 0) + i2 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   HEAP32[i3 >> 2] = i2;
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  } else {
   HEAP32[i3 >> 2] = i2 - i1;
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 } else if ((i3 | 0) == 26) {
  STACKTOP = i14;
  return i1 | 0;
 }
 return 0;
}

function __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = (i6 - i7 | 0) / 156 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 * 156 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 * 156 | 0;
  i3 = (i2 | 0) / 156 | 0;
  if (!i2) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 27531841) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 * 156 | 0) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     __ZN14SubstanceInputC2ERKS_(i2, i1);
     i1 = i1 + 156 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 156 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -156 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN14SubstanceInputD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 156 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 * 156 | 0) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 * 156 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i2 - i4 | 0) / 156 | 0;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 * 156 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -156 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN14SubstanceInputD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -156 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN14SubstanceInputD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function runPostSets202() {
 HEAP32[gb + 170728 >> 2] = fb + 2629;
 HEAP32[gb + 170732 >> 2] = fb + 2608;
 HEAP32[gb + 170736 >> 2] = fb + 1921;
 HEAP32[gb + 170740 >> 2] = fb + 16;
 HEAP32[gb + 170744 >> 2] = fb + 2630;
 HEAP32[gb + 170748 >> 2] = fb + 2631;
 HEAP32[gb + 170752 >> 2] = fb + 19;
 HEAP32[gb + 170756 >> 2] = fb + 1229;
 HEAP32[gb + 170760 >> 2] = fb + 103;
 HEAP32[gb + 170764 >> 2] = fb + 101;
 HEAP32[gb + 170768 >> 2] = fb + 62;
 HEAP32[gb + 170772 >> 2] = fb + 28;
 HEAP32[gb + 170776 >> 2] = fb + 63;
 HEAP32[gb + 170780 >> 2] = fb + 29;
 HEAP32[gb + 170784 >> 2] = fb + 34;
 HEAP32[gb + 170788 >> 2] = fb + 1947;
 HEAP32[gb + 170792 >> 2] = fb + 1948;
 HEAP32[gb + 170796 >> 2] = fb + 1949;
 HEAP32[gb + 170800 >> 2] = fb + 1950;
 HEAP32[gb + 170804 >> 2] = fb + 1951;
 HEAP32[gb + 170808 >> 2] = fb + 1952;
 HEAP32[gb + 170812 >> 2] = fb + 36;
 HEAP32[gb + 170816 >> 2] = fb + 104;
 HEAP32[gb + 170820 >> 2] = fb + 108;
 HEAP32[gb + 170824 >> 2] = fb + 94;
 HEAP32[gb + 170828 >> 2] = fb + 130;
 HEAP32[gb + 170832 >> 2] = fb + 112;
 HEAP32[gb + 170836 >> 2] = fb + 113;
 HEAP32[gb + 170840 >> 2] = fb + 131;
 HEAP32[gb + 170844 >> 2] = fb + 2632;
 HEAP32[gb + 170848 >> 2] = fb + 112;
 HEAP32[gb + 170852 >> 2] = fb + 113;
 HEAP32[gb + 170856 >> 2] = fb + 2633;
 HEAP32[gb + 170860 >> 2] = fb + 2613;
 HEAP32[gb + 170872 >> 2] = (HEAP32[gb + 170872 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 170876 >> 2] = (HEAP32[gb + 170876 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 170912 >> 2] = fb + 2634;
 HEAP32[gb + 170916 >> 2] = fb + 2635;
 HEAP32[gb + 170920 >> 2] = fb + 2608;
 HEAP32[gb + 170924 >> 2] = fb + 1921;
 HEAP32[gb + 170928 >> 2] = fb + 16;
 HEAP32[gb + 170932 >> 2] = fb + 2636;
 HEAP32[gb + 170936 >> 2] = fb + 2637;
 HEAP32[gb + 170940 >> 2] = fb + 19;
 HEAP32[gb + 170944 >> 2] = fb + 1230;
 HEAP32[gb + 170948 >> 2] = fb + 103;
 HEAP32[gb + 170952 >> 2] = fb + 101;
 HEAP32[gb + 170956 >> 2] = fb + 62;
 HEAP32[gb + 170960 >> 2] = fb + 28;
 HEAP32[gb + 170964 >> 2] = fb + 63;
 HEAP32[gb + 170968 >> 2] = fb + 29;
 HEAP32[gb + 170972 >> 2] = fb + 34;
 HEAP32[gb + 170976 >> 2] = fb + 1953;
 HEAP32[gb + 170980 >> 2] = fb + 1954;
 HEAP32[gb + 170984 >> 2] = fb + 1955;
 HEAP32[gb + 170988 >> 2] = fb + 1956;
 HEAP32[gb + 170992 >> 2] = fb + 1957;
 HEAP32[gb + 170996 >> 2] = fb + 1958;
 HEAP32[gb + 171e3 >> 2] = fb + 36;
 HEAP32[gb + 171004 >> 2] = fb + 104;
 HEAP32[gb + 171008 >> 2] = fb + 108;
 HEAP32[gb + 171012 >> 2] = fb + 94;
 HEAP32[gb + 171016 >> 2] = fb + 130;
 HEAP32[gb + 171020 >> 2] = fb + 112;
 HEAP32[gb + 171024 >> 2] = fb + 113;
 HEAP32[gb + 171028 >> 2] = fb + 131;
 HEAP32[gb + 171032 >> 2] = fb + 2638;
 HEAP32[gb + 171036 >> 2] = fb + 112;
 HEAP32[gb + 171040 >> 2] = fb + 113;
 HEAP32[gb + 171044 >> 2] = fb + 2639;
 HEAP32[gb + 171048 >> 2] = fb + 2613;
 HEAP32[gb + 171060 >> 2] = (HEAP32[gb + 171060 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 171064 >> 2] = (HEAP32[gb + 171064 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 171100 >> 2] = fb + 2640;
 HEAP32[gb + 171104 >> 2] = fb + 2641;
 HEAP32[gb + 171108 >> 2] = fb + 2608;
 HEAP32[gb + 171112 >> 2] = fb + 1921;
 HEAP32[gb + 171116 >> 2] = fb + 16;
 HEAP32[gb + 171120 >> 2] = fb + 2642;
 HEAP32[gb + 171124 >> 2] = fb + 2643;
 HEAP32[gb + 171128 >> 2] = fb + 19;
 HEAP32[gb + 171132 >> 2] = fb + 1231;
 HEAP32[gb + 171136 >> 2] = fb + 103;
 HEAP32[gb + 171140 >> 2] = fb + 101;
 HEAP32[gb + 171144 >> 2] = fb + 62;
 HEAP32[gb + 171148 >> 2] = fb + 28;
 HEAP32[gb + 171152 >> 2] = fb + 63;
 HEAP32[gb + 171156 >> 2] = fb + 29;
 HEAP32[gb + 171160 >> 2] = fb + 34;
 HEAP32[gb + 171164 >> 2] = fb + 1959;
 HEAP32[gb + 171168 >> 2] = fb + 1960;
 HEAP32[gb + 171172 >> 2] = fb + 1961;
 HEAP32[gb + 171176 >> 2] = fb + 1962;
 HEAP32[gb + 171180 >> 2] = fb + 1963;
 HEAP32[gb + 171184 >> 2] = fb + 1964;
 HEAP32[gb + 171188 >> 2] = fb + 36;
 HEAP32[gb + 171192 >> 2] = fb + 104;
 HEAP32[gb + 171196 >> 2] = fb + 108;
 HEAP32[gb + 171200 >> 2] = fb + 94;
 HEAP32[gb + 171204 >> 2] = fb + 130;
 runPostSets203();
}

function __ZN12NavMeshAgent10SmartResetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 36 | 0;
 i6 = i8 + 24 | 0;
 i2 = i8;
 i7 = i4 + 28 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i2) | 0) {
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i2 + 12 >> 2]));
  f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 + 16 >> 2]));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 20 >> 2]));
  HEAPF32[i4 + 36 >> 2] = f9 < f10 ? f10 : f9;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  i1 = i4 + 68 | 0;
  if ((HEAP32[i1 >> 2] | 0) != -1) {
   __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i4, i5);
   __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i5);
  }
  HEAPF32[i4 + 40 >> 2] = Math_fround(f3 * Math_fround(2.0));
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  if ((HEAP32[i1 >> 2] | 0) == -1) {
   HEAPF32[i4 + 44 >> 2] = f3;
   STACKTOP = i8;
   return;
  }
  __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i4, i5);
  __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i5);
  i2 = (HEAP32[i1 >> 2] | 0) == -1;
  i1 = i4 + 44 | 0;
  HEAPF32[i1 >> 2] = f3;
  if (i2) {
   STACKTOP = i8;
   return;
  }
  if (!(HEAP8[i4 + 107 >> 0] & 1)) {
   STACKTOP = i8;
   return;
  }
  i4 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 + 480 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 484 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 488 >> 2];
  i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0;
  f10 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = f10;
  HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
  __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i7, i6, i5);
  STACKTOP = i8;
  return;
 }
 HEAPF32[i4 + 36 >> 2] = Math_fround(.5);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 i1 = i4 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i4, i5);
  __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i5);
 }
 HEAPF32[i4 + 40 >> 2] = Math_fround(2.0);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
  STACKTOP = i8;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i4, i5);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i5);
 i2 = (HEAP32[i1 >> 2] | 0) == -1;
 i1 = i4 + 44 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 if (i2) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i4 + 107 >> 0] & 1)) {
  STACKTOP = i8;
  return;
 }
 i4 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0) | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 + 480 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 484 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 488 >> 2];
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0;
 f10 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = f10;
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i7, i6, i5);
 STACKTOP = i8;
 return;
}

function runPostSets185() {
 HEAP32[gb + 157044 >> 2] = fb + 112;
 HEAP32[gb + 157048 >> 2] = fb + 113;
 HEAP32[gb + 157052 >> 2] = fb + 131;
 HEAP32[gb + 157056 >> 2] = fb + 111;
 HEAP32[gb + 157060 >> 2] = fb + 112;
 HEAP32[gb + 157064 >> 2] = fb + 113;
 HEAP32[gb + 157068 >> 2] = fb + 2339;
 HEAP32[gb + 157072 >> 2] = fb + 2340;
 HEAP32[gb + 157076 >> 2] = fb + 1720;
 HEAP32[gb + 157080 >> 2] = fb + 1721;
 HEAP32[gb + 157084 >> 2] = fb + 1096;
 HEAP32[gb + 157096 >> 2] = (HEAP32[gb + 157096 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 157100 >> 2] = (HEAP32[gb + 157100 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 157136 >> 2] = fb + 2429;
 HEAP32[gb + 157140 >> 2] = fb + 2430;
 HEAP32[gb + 157144 >> 2] = fb + 38;
 HEAP32[gb + 157148 >> 2] = fb + 1722;
 HEAP32[gb + 157152 >> 2] = fb + 16;
 HEAP32[gb + 157156 >> 2] = fb + 2431;
 HEAP32[gb + 157160 >> 2] = fb + 2432;
 HEAP32[gb + 157164 >> 2] = fb + 19;
 HEAP32[gb + 157168 >> 2] = fb + 1097;
 HEAP32[gb + 157172 >> 2] = fb + 103;
 HEAP32[gb + 157176 >> 2] = fb + 101;
 HEAP32[gb + 157180 >> 2] = fb + 62;
 HEAP32[gb + 157184 >> 2] = fb + 28;
 HEAP32[gb + 157188 >> 2] = fb + 63;
 HEAP32[gb + 157192 >> 2] = fb + 29;
 HEAP32[gb + 157196 >> 2] = fb + 34;
 HEAP32[gb + 157200 >> 2] = fb + 1723;
 HEAP32[gb + 157204 >> 2] = fb + 1724;
 HEAP32[gb + 157208 >> 2] = fb + 1725;
 HEAP32[gb + 157212 >> 2] = fb + 1726;
 HEAP32[gb + 157216 >> 2] = fb + 1727;
 HEAP32[gb + 157220 >> 2] = fb + 1728;
 HEAP32[gb + 157224 >> 2] = fb + 36;
 HEAP32[gb + 157228 >> 2] = fb + 104;
 HEAP32[gb + 157232 >> 2] = fb + 108;
 HEAP32[gb + 157236 >> 2] = fb + 94;
 HEAP32[gb + 157240 >> 2] = fb + 1574;
 HEAP32[gb + 157244 >> 2] = fb + 112;
 HEAP32[gb + 157248 >> 2] = fb + 113;
 HEAP32[gb + 157252 >> 2] = fb + 131;
 HEAP32[gb + 157256 >> 2] = fb + 111;
 HEAP32[gb + 157260 >> 2] = fb + 112;
 HEAP32[gb + 157264 >> 2] = fb + 113;
 HEAP32[gb + 157268 >> 2] = fb + 2317;
 HEAP32[gb + 157272 >> 2] = fb + 2318;
 HEAP32[gb + 157276 >> 2] = fb + 2433;
 HEAP32[gb + 157280 >> 2] = fb + 1575;
 HEAP32[gb + 157284 >> 2] = fb + 1059;
 HEAP32[gb + 157288 >> 2] = fb + 1060;
 HEAP32[gb + 157300 >> 2] = (HEAP32[gb + 157300 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 157304 >> 2] = (HEAP32[gb + 157304 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 157340 >> 2] = fb + 2434;
 HEAP32[gb + 157344 >> 2] = fb + 2435;
 HEAP32[gb + 157348 >> 2] = fb + 38;
 HEAP32[gb + 157352 >> 2] = fb + 1729;
 HEAP32[gb + 157356 >> 2] = fb + 16;
 HEAP32[gb + 157360 >> 2] = fb + 2436;
 HEAP32[gb + 157364 >> 2] = fb + 2437;
 HEAP32[gb + 157368 >> 2] = fb + 19;
 HEAP32[gb + 157372 >> 2] = fb + 1098;
 HEAP32[gb + 157376 >> 2] = fb + 103;
 HEAP32[gb + 157380 >> 2] = fb + 101;
 HEAP32[gb + 157384 >> 2] = fb + 62;
 HEAP32[gb + 157388 >> 2] = fb + 28;
 HEAP32[gb + 157392 >> 2] = fb + 63;
 HEAP32[gb + 157396 >> 2] = fb + 29;
 HEAP32[gb + 157400 >> 2] = fb + 34;
 HEAP32[gb + 157404 >> 2] = fb + 1730;
 HEAP32[gb + 157408 >> 2] = fb + 1731;
 HEAP32[gb + 157412 >> 2] = fb + 1732;
 HEAP32[gb + 157416 >> 2] = fb + 1733;
 HEAP32[gb + 157420 >> 2] = fb + 1734;
 HEAP32[gb + 157424 >> 2] = fb + 1735;
 HEAP32[gb + 157428 >> 2] = fb + 36;
 HEAP32[gb + 157432 >> 2] = fb + 104;
 HEAP32[gb + 157436 >> 2] = fb + 108;
 HEAP32[gb + 157440 >> 2] = fb + 94;
 HEAP32[gb + 157444 >> 2] = fb + 1736;
 HEAP32[gb + 157448 >> 2] = fb + 105;
 HEAP32[gb + 157452 >> 2] = fb + 106;
 HEAP32[gb + 157456 >> 2] = fb + 110;
 HEAP32[gb + 157468 >> 2] = fb + 2438;
 HEAP32[gb + 157472 >> 2] = fb + 2439;
 HEAP32[gb + 157476 >> 2] = fb + 38;
 HEAP32[gb + 157480 >> 2] = fb + 1737;
 HEAP32[gb + 157484 >> 2] = fb + 16;
 HEAP32[gb + 157488 >> 2] = fb + 2440;
 HEAP32[gb + 157492 >> 2] = fb + 2441;
 HEAP32[gb + 157496 >> 2] = fb + 19;
 HEAP32[gb + 157500 >> 2] = fb + 1099;
 HEAP32[gb + 157504 >> 2] = fb + 103;
 HEAP32[gb + 157508 >> 2] = fb + 101;
 HEAP32[gb + 157512 >> 2] = fb + 62;
 HEAP32[gb + 157516 >> 2] = fb + 28;
 HEAP32[gb + 157520 >> 2] = fb + 63;
 HEAP32[gb + 157524 >> 2] = fb + 29;
 HEAP32[gb + 157528 >> 2] = fb + 34;
 runPostSets186();
}

function __ZN14GfxContextGLES11MakeCurrentER7ApiGLESN2gl13ContextHandleE(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 4 | 0;
 i2 = i14;
 i4 = HEAP32[i1 >> 2] | 0;
 i11 = i4;
 if ((i4 | 0) == 1) {
  HEAP32[i2 >> 2] = __ZN2gl17GetCurrentContextEv() | 0;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  __ZN7ApiGLES15ActivateContextEN2gl13ContextHandleE(i13, i9) | 0;
  i1 = i12 + 12 | 0;
  if (!(HEAP32[i12 + 8 >> 2] | 0)) i10 = i1; else {
   HEAP32[i1 >> 2] = HEAP32[i12 + 20 >> 2];
   i11 = i12 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 + 24 >> 2];
   __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i13, i12);
   i13 = HEAP32[i11 >> 2] | 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 } else {
  HEAP32[i2 >> 2] = i11;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  __ZN7ApiGLES15ActivateContextEN2gl13ContextHandleE(i13, i9) | 0;
  i10 = i12 + 12 | 0;
 }
 if ((i4 | 0) == (HEAP32[i12 + 12 >> 2] | 0)) {
  i11 = i12 + 16 | 0;
  __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i13, i12);
  i13 = HEAP32[i11 >> 2] | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i5 = i12 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i1 = i5;
  L12 : while (1) {
   i3 = i2;
   while (1) {
    if (i4 >>> 0 >= (HEAP32[i3 + 16 >> 2] | 0) >>> 0) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L12; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i5 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) {
   i9 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i10 >> 2] = i11;
   i11 = i12 + 16 | 0;
   HEAP32[i11 >> 2] = i9;
   __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i13, i12);
   i13 = HEAP32[i11 >> 2] | 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 i7 = i12 + 8 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) == 0;
 i1 = __Znwj(540) | 0;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i13;
 __ZN18GfxFramebufferGLESC2ER7ApiGLESPv(i1 + 8 | 0, i13, i1);
 i2 = i1 + 532 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 695 >> 0] | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 536 >> 2] = -1;
 } else __ZN7ApiGLES17CreateVertexArrayEv(i2, HEAP32[gb + 1451080 >> 2] | 0);
 i6 = i1;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  HEAP32[i9 >> 2] = i5;
  i4 = i5;
  i3 = i5;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 < i4 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 21;
     break;
    } else i1 = i2;
   } else {
    if (i4 >>> 0 >= i2 >>> 0) {
     i2 = 26;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 25;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 21) {
   HEAP32[i9 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 25) {
   HEAP32[i9 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 26) {
   HEAP32[i9 >> 2] = i1;
   i4 = i1;
   i3 = i9;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(24) | 0;
  HEAP32[i1 + 16 >> 2] = i11;
  HEAP32[i1 + 20 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i12 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 4 >> 2] | 0, i2);
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 i1 = i12 + 16 | 0;
 HEAP32[i1 >> 2] = i2;
 if (!i8) {
  i11 = i1;
  __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i13, i12);
  i13 = HEAP32[i11 >> 2] | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i12 + 20 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 24 >> 2] = i2;
 i11 = i1;
 __ZN7ApiGLES10InvalidateERK14GfxContextGLES(i13, i12);
 i13 = HEAP32[i11 >> 2] | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN9Texture2D25CreateScaledAndPaddedDataEPP17SharedTextureDataS2_(i5, i9, i10) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i1 = i5 + 80 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 1) HEAP32[i1 >> 2] = 2;
 i8 = i5 + 52 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = HEAP32[i5 + 92 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? 5 : i3;
 } else i3 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = (i3 + -10 | 0) >>> 0 < 3;
 L8 : do if (i2) i1 = 3; else if (((i3 | 1) + -25 | 0) >>> 0 < 5) i1 = 3; else {
  switch (i3 | 0) {
  case 34:
  case 35:
  case 36:
  case 45:
  case 46:
  case 47:
   {
    i1 = 3;
    break L8;
   }
  default:
   {}
  }
  i1 = (i3 + -41 | 0) >>> 0 < 4 ? 3 : 0;
 } while (0);
 do if (!((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0) & i1)) if (!((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0) & i1)) {
  if (!(HEAP8[i5 + 108 >> 0] | 0)) if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 128 >> 2] | 0, i5 | 0) | 0)) break;
  i11 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i9 >> 2] = i11;
  i11 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  f14 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0));
  f13 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0));
  HEAPF32[i5 + 68 >> 2] = f14;
  HEAPF32[i5 + 72 >> 2] = f13;
  STACKTOP = i12;
  return;
 } while (0);
 i7 = (HEAP32[i5 + 56 >> 2] | 0) == 6;
 if (!i7) {
  do if (i2) i4 = 21; else if (((i3 | 1) + -25 | 0) >>> 0 < 5) i4 = 21; else {
   i1 = i3 + -30 | 0;
   if (i1 >>> 0 < 15) if ((i3 + -48 | 0) >>> 0 < 12 | ((i3 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
    i4 = 21;
    break;
   } else {
    i1 = i3;
    break;
   } else if ((i3 + -45 | 0) >>> 0 < 3 | (i3 + -48 | 0) >>> 0 < 12) {
    i4 = 21;
    break;
   } else {
    i1 = i3;
    break;
   }
  } while (0);
  if ((i4 | 0) == 21) i1 = 4;
  HEAP32[i9 >> 2] = __ZN9Texture2D26AllocateScaledOrPaddedDataE13TextureFormat(i5, i1) | 0;
 }
 HEAP32[i10 >> 2] = __ZN9Texture2D26AllocateScaledOrPaddedDataE13TextureFormat(i5, i3) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[i1 + 44 >> 2] | 0;
  i5 = HEAP32[i5 + 76 >> 2] | 0;
  if ((i6 | 0) > 0) if ((i5 | 0) > 0) {
   i4 = 0;
   do {
    if (i7) {
     i1 = 0;
     do {
      __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb(HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i4, i1, 1, 0);
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i5 | 0));
    } else {
     i3 = 0;
     do {
      i2 = HEAP32[i9 >> 2] | 0;
      i1 = HEAP32[i8 >> 2] | 0;
      if (HEAP32[i1 + 28 >> 2] | 0) if (HEAP32[i1 + 32 >> 2] | 0) {
       __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 32 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, i3) | 0;
       HEAP32[i11 >> 2] = 0;
       HEAP32[i11 + 4 >> 2] = 0;
       HEAP32[i11 + 8 >> 2] = 0;
       HEAP32[i11 + 12 >> 2] = 0;
       HEAP32[i11 + 16 >> 2] = 0;
       __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i2, i11, i4, i3) | 0;
       __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i1, i11, 2, 1, i4) | 0;
       i1 = HEAP32[i8 >> 2] | 0;
      }
      __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb(i1, HEAP32[i10 >> 2] | 0, i4, i3, 1, 0);
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i5 | 0));
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i6 | 0));
  }
 }
 if (!i7) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 i11 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos15PsMatTransformVEPNS6_5Vec3VEjj(i28, i30, i29, i27, i24) {
 i28 = i28 | 0;
 i30 = i30 | 0;
 i29 = i29 | 0;
 i27 = i27 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i31 = 0, i32 = 0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0, f48 = f0, f49 = f0, f50 = f0, f51 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i31 + 24 | 0;
 i1 = i31 + 12 | 0;
 i2 = i31;
 if (!i27) {
  STACKTOP = i31;
  return;
 }
 i17 = i30 + 48 | 0;
 i18 = i30 + 52 | 0;
 i19 = i30 + 56 | 0;
 i20 = i30 + 16 | 0;
 i21 = i30 + 32 | 0;
 i22 = i30 + 4 | 0;
 i23 = i30 + 20 | 0;
 i3 = i30 + 36 | 0;
 i4 = i30 + 8 | 0;
 i5 = i30 + 24 | 0;
 i6 = i30 + 40 | 0;
 i7 = i26 + 4 | 0;
 i8 = i26 + 20 | 0;
 i9 = i26 + 24 | 0;
 i10 = i26 + 40 | 0;
 i11 = i26 + 44 | 0;
 i12 = i26 + 60 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1 + 8 | 0;
 i15 = i2 + 4 | 0;
 i16 = i2 + 8 | 0;
 i25 = 0;
 do {
  i32 = ((i25 | 0) == 0 ? i27 : i25) + -1 | 0;
  f33 = Math_fround(HEAPF32[i29 + (i32 << 4) >> 2]);
  f51 = Math_fround(HEAPF32[i29 + (i32 << 4) + 4 >> 2]);
  f36 = Math_fround(HEAPF32[i29 + (i32 << 4) + 8 >> 2]);
  f43 = Math_fround(HEAPF32[i29 + (i25 << 4) >> 2]);
  f41 = Math_fround(HEAPF32[i29 + (i25 << 4) + 4 >> 2]);
  f39 = Math_fround(HEAPF32[i29 + (i25 << 4) + 8 >> 2]);
  f50 = Math_fround(HEAPF32[i17 >> 2]);
  f47 = Math_fround(HEAPF32[i18 >> 2]);
  f44 = Math_fround(HEAPF32[i19 >> 2]);
  f49 = Math_fround(HEAPF32[i30 >> 2]);
  f38 = Math_fround(f33 * f49);
  f48 = Math_fround(HEAPF32[i20 >> 2]);
  f38 = Math_fround(f38 + Math_fround(f51 * f48));
  f35 = Math_fround(HEAPF32[i21 >> 2]);
  f38 = Math_fround(f38 + Math_fround(f36 * f35));
  f46 = Math_fround(HEAPF32[i22 >> 2]);
  f37 = Math_fround(f33 * f46);
  f45 = Math_fround(HEAPF32[i23 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f51 * f45));
  f34 = Math_fround(HEAPF32[i3 >> 2]);
  f37 = Math_fround(f37 + Math_fround(f36 * f34));
  f42 = Math_fround(HEAPF32[i4 >> 2]);
  f33 = Math_fround(f33 * f42);
  f40 = Math_fround(HEAPF32[i5 >> 2]);
  f51 = Math_fround(f33 + Math_fround(f51 * f40));
  f33 = Math_fround(HEAPF32[i6 >> 2]);
  f38 = Math_fround(f50 + f38);
  f37 = Math_fround(f47 + f37);
  f36 = Math_fround(f44 + Math_fround(f51 + Math_fround(f36 * f33)));
  f35 = Math_fround(f50 + Math_fround(Math_fround(Math_fround(f43 * f49) + Math_fround(f41 * f48)) + Math_fround(f39 * f35)));
  f34 = Math_fround(f47 + Math_fround(Math_fround(Math_fround(f43 * f46) + Math_fround(f41 * f45)) + Math_fround(f39 * f34)));
  f33 = Math_fround(f44 + Math_fround(Math_fround(Math_fround(f43 * f42) + Math_fround(f41 * f40)) + Math_fround(f39 * f33)));
  HEAPF32[i26 >> 2] = Math_fround(1.0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  i32 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i28, i24) | 0, i26) | 0, 1) | 0;
  HEAPF32[i1 >> 2] = f38;
  HEAPF32[i13 >> 2] = f37;
  HEAPF32[i14 >> 2] = f36;
  i32 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i1) | 0;
  HEAPF32[i2 >> 2] = f35;
  HEAPF32[i15 >> 2] = f34;
  HEAPF32[i16 >> 2] = f33;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i32, i2) | 0;
  i25 = i25 + 1 | 0;
 } while ((i25 | 0) != (i27 | 0));
 STACKTOP = i31;
 return;
}

function __ZN2UIL31GenerateRenderableUIInstructionEPNS_28PreprocessUIInstructionsDataEj(i20, i21) {
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, i29 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i22 + 4 | 0;
 i2 = i22;
 if ((HEAP16[gb + 1468084 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468084 | 0, i1);
  i19 = gb + 1468084 | 0;
 } else i19 = 0;
 i14 = HEAP32[i20 + (i21 * 12 | 0) >> 2] | 0;
 i17 = i20 + 780 | 0;
 i18 = (HEAP32[i17 >> 2] | 0) + (i14 * 672 | 0) | 0;
 i14 = (HEAP32[(HEAP32[i20 + 776 >> 2] | 0) + 12 >> 2] | 0) + ((i14 << 3) * 252 | 0) | 0;
 f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f6 = Math_fround(-f8);
 f5 = Math_fround(-f3);
 f4 = Math_fround(-f7);
 i15 = i20 + (i21 * 12 | 0) + 4 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  i9 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i16 = i20 + 772 | 0;
  i9 = 0;
  i2 = 0;
  i13 = 0;
  i10 = 0;
  while (1) {
   i1 = i14 + (i9 * 252 | 0) | 0;
   i12 = i18 + (i13 * 672 | 0) | 0;
   __ZN2UIL8PopulateERNS_23RenderableUIInstructionERKNS_13UIInstructionEib(i1, i12, 0, (HEAP8[i16 >> 0] | 0) != 0);
   HEAP32[i1 + 84 >> 2] = i9;
   if (!(HEAP8[i1 + 249 >> 0] | 0)) i1 = i10; else {
    i11 = i1 + 184 | 0;
    f28 = Math_fround(HEAPF32[i11 >> 2]);
    f23 = Math_fround(HEAPF32[i11 + 4 >> 2]);
    f27 = Math_fround(HEAPF32[i11 + 8 >> 2]);
    f26 = Math_fround(HEAPF32[i11 + 12 >> 2]);
    f25 = Math_fround(HEAPF32[i11 + 16 >> 2]);
    f24 = Math_fround(HEAPF32[i11 + 20 >> 2]);
    i9 = i9 + 1 | 0;
    i2 = (HEAP32[i1 + 80 >> 2] | 0) + i2 | 0;
    i1 = (HEAP32[i1 + 68 >> 2] | 0) + i10 | 0;
    f8 = f28 < f8 ? f28 : f8;
    f7 = f27 < f7 ? f27 : f7;
    f6 = f6 < f26 ? f26 : f6;
    f5 = f5 < f25 ? f25 : f5;
    f4 = f4 < f24 ? f24 : f4;
    f3 = f23 < f3 ? f23 : f3;
   }
   if ((HEAP32[(HEAP32[i17 >> 2] | 0) + (i13 * 672 | 0) + 448 >> 2] | 0) > 1) {
    i11 = 1;
    i10 = i1;
    while (1) {
     i1 = i14 + (i9 * 252 | 0) | 0;
     __ZN2UIL8PopulateERNS_23RenderableUIInstructionERKNS_13UIInstructionEib(i1, i12, i11, (HEAP8[i16 >> 0] | 0) != 0);
     HEAP32[i1 + 84 >> 2] = i9;
     if (!(HEAP8[i1 + 249 >> 0] | 0)) i1 = i10; else {
      i29 = i1 + 184 | 0;
      f23 = Math_fround(HEAPF32[i29 >> 2]);
      f28 = Math_fround(HEAPF32[i29 + 4 >> 2]);
      f24 = Math_fround(HEAPF32[i29 + 8 >> 2]);
      f25 = Math_fround(HEAPF32[i29 + 12 >> 2]);
      f26 = Math_fround(HEAPF32[i29 + 16 >> 2]);
      f27 = Math_fround(HEAPF32[i29 + 20 >> 2]);
      i9 = i9 + 1 | 0;
      i2 = (HEAP32[i1 + 80 >> 2] | 0) + i2 | 0;
      i1 = (HEAP32[i1 + 68 >> 2] | 0) + i10 | 0;
      f8 = f23 < f8 ? f23 : f8;
      f7 = f24 < f7 ? f24 : f7;
      f6 = f6 < f25 ? f25 : f6;
      f5 = f5 < f26 ? f26 : f5;
      f4 = f4 < f27 ? f27 : f4;
      f3 = f28 < f3 ? f28 : f3;
     }
     i11 = i11 + 1 | 0;
     if ((i11 | 0) >= (HEAP32[(HEAP32[i17 >> 2] | 0) + (i13 * 672 | 0) + 448 >> 2] | 0)) break; else i10 = i1;
    }
   }
   i13 = i13 + 1 | 0;
   if (i13 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else i10 = i1;
  }
 }
 HEAP32[i20 + 192 + (i21 << 2) >> 2] = i9;
 HEAP32[i20 + 256 + (i21 << 2) >> 2] = i2;
 HEAP32[i20 + 320 + (i21 << 2) >> 2] = i1;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) >> 2] = f8;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) + 4 >> 2] = f3;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) + 8 >> 2] = f7;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) + 12 >> 2] = f6;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) + 16 >> 2] = f5;
 HEAPF32[i20 + 384 + (i21 * 24 | 0) + 20 >> 2] = f4;
 if (!i19) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i22;
 return;
}

function __ZN18CrashReportManager27OnPlayerSessionStateChangedEjyy(i9, i5, i1, i2, i3, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i8 = i10;
 switch (i5 | 0) {
 case 0:
  {
   __ZN18CrashReportManager12CloseServiceEv(i9);
   STACKTOP = i10;
   return;
  }
 case 2:
  {
   i5 = HEAP32[i9 + 28 >> 2] | 0;
   if (!i5) {
    STACKTOP = i10;
    return;
   }
   i3 = i5 + 40 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = i5 + 44 | 0;
   if ((i1 | 0) != (i4 | 0)) {
    i2 = i1;
    while (1) {
     i1 = i2 + 144 | 0;
     if (HEAP32[i1 >> 2] | 0) {
      __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i5, i2 + 32 | 0) | 0;
      HEAP32[i1 >> 2] = 0;
     }
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
   }
   __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i3, HEAP32[i4 >> 2] | 0);
   HEAP32[i5 + 52 >> 2] = 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i4 >> 2] = 0;
   STACKTOP = i10;
   return;
  }
 case 1:
  {
   HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   i2 = __Z20GetPlayerSettingsPtrv() | 0;
   if (!i2) {
    i3 = i8 + 11 | 0;
    i2 = 0;
    i1 = 0;
   } else {
    i1 = i2 + 44 | 0;
    i3 = HEAP8[i1 + 11 >> 0] | 0;
    if (i3 << 24 >> 24 < 0) {
     i4 = HEAP32[i1 >> 2] | 0;
     i1 = HEAP32[i2 + 48 >> 2] | 0;
    } else {
     i4 = i1;
     i1 = i3 & 255;
    };
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, i1);
    i5 = HEAP8[i7 + 11 >> 0] | 0;
    i6 = i5 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i7 >> 2] | 0 : i7;
    i5 = i6 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255;
    i6 = i8 + 11 | 0;
    i1 = HEAP8[i6 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    do if (i5 >>> 0 > i3 >>> 0) {
     i11 = i8 + 4 | 0;
     i1 = i2 ? HEAP32[i11 >> 2] | 0 : i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i5 - i3 | 0, i1, 0, i1, i5, i4);
     i1 = i11;
    } else {
     i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
     if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
     HEAP8[i1 + i5 >> 0] = 0;
     if ((HEAP8[i6 >> 0] | 0) < 0) {
      i1 = i8 + 4 | 0;
      HEAP32[i1 >> 2] = i5;
      break;
     } else {
      HEAP8[i6 >> 0] = i5;
      i1 = i8 + 4 | 0;
      break;
     }
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i3 = i6;
    i2 = HEAP8[i6 >> 0] | 0;
    i1 = HEAP32[i1 >> 2] | 0;
   }
   if ((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) if (HEAP8[(__Z25GetCrashReportingSettingsv() | 0) + 8 >> 0] | 0) {
    i2 = __Z25GetCrashReportingSettingsv() | 0;
    i1 = i9 + 28 | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     i11 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63160 | 0, 16, gb + 1039700 | 0, 43) | 0;
     __ZN18CrashReportHandlerC2ERK8UnityStrS2_(i11, i2 + 12 | 0, i8);
     HEAP32[i1 >> 2] = i11;
    }
   }
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    i11 = HEAP32[i8 >> 2] | 0;
    i9 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i7 + 4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
   }
   STACKTOP = i10;
   return;
  }
 default:
  {
   STACKTOP = i10;
   return;
  }
 }
}

function runPostSets217() {
 HEAP32[gb + 186596 >> 2] = fb + 103;
 HEAP32[gb + 186600 >> 2] = fb + 101;
 HEAP32[gb + 186604 >> 2] = fb + 62;
 HEAP32[gb + 186608 >> 2] = fb + 28;
 HEAP32[gb + 186612 >> 2] = fb + 63;
 HEAP32[gb + 186616 >> 2] = fb + 29;
 HEAP32[gb + 186620 >> 2] = fb + 34;
 HEAP32[gb + 186624 >> 2] = fb + 2156;
 HEAP32[gb + 186628 >> 2] = fb + 2157;
 HEAP32[gb + 186632 >> 2] = fb + 2158;
 HEAP32[gb + 186636 >> 2] = fb + 2159;
 HEAP32[gb + 186640 >> 2] = fb + 2160;
 HEAP32[gb + 186644 >> 2] = fb + 2161;
 HEAP32[gb + 186648 >> 2] = fb + 36;
 HEAP32[gb + 186652 >> 2] = fb + 104;
 HEAP32[gb + 186656 >> 2] = fb + 108;
 HEAP32[gb + 186660 >> 2] = fb + 94;
 HEAP32[gb + 186664 >> 2] = fb + 130;
 HEAP32[gb + 186668 >> 2] = fb + 112;
 HEAP32[gb + 186672 >> 2] = fb + 113;
 HEAP32[gb + 186676 >> 2] = fb + 131;
 HEAP32[gb + 186680 >> 2] = fb + 111;
 HEAP32[gb + 186684 >> 2] = fb + 112;
 HEAP32[gb + 186688 >> 2] = fb + 113;
 HEAP32[gb + 186692 >> 2] = fb + 2824;
 HEAP32[gb + 186696 >> 2] = fb + 2825;
 HEAP32[gb + 186700 >> 2] = fb + 2826;
 HEAP32[gb + 186712 >> 2] = fb + 2827;
 HEAP32[gb + 186716 >> 2] = fb + 2828;
 HEAP32[gb + 186720 >> 2] = fb + 38;
 HEAP32[gb + 186724 >> 2] = fb + 2162;
 HEAP32[gb + 186728 >> 2] = fb + 16;
 HEAP32[gb + 186732 >> 2] = fb + 2829;
 HEAP32[gb + 186736 >> 2] = fb + 40;
 HEAP32[gb + 186740 >> 2] = fb + 19;
 HEAP32[gb + 186744 >> 2] = fb + 1313;
 HEAP32[gb + 186748 >> 2] = fb + 103;
 HEAP32[gb + 186752 >> 2] = fb + 101;
 HEAP32[gb + 186756 >> 2] = fb + 62;
 HEAP32[gb + 186760 >> 2] = fb + 28;
 HEAP32[gb + 186764 >> 2] = fb + 63;
 HEAP32[gb + 186768 >> 2] = fb + 29;
 HEAP32[gb + 186772 >> 2] = fb + 34;
 HEAP32[gb + 186776 >> 2] = fb + 2163;
 HEAP32[gb + 186780 >> 2] = fb + 2164;
 HEAP32[gb + 186784 >> 2] = fb + 2165;
 HEAP32[gb + 186788 >> 2] = fb + 2166;
 HEAP32[gb + 186792 >> 2] = fb + 2167;
 HEAP32[gb + 186796 >> 2] = fb + 2168;
 HEAP32[gb + 186800 >> 2] = fb + 36;
 HEAP32[gb + 186804 >> 2] = fb + 104;
 HEAP32[gb + 186808 >> 2] = fb + 108;
 HEAP32[gb + 186812 >> 2] = fb + 94;
 HEAP32[gb + 186816 >> 2] = fb + 130;
 HEAP32[gb + 186820 >> 2] = fb + 112;
 HEAP32[gb + 186824 >> 2] = fb + 113;
 HEAP32[gb + 186828 >> 2] = fb + 131;
 HEAP32[gb + 186832 >> 2] = fb + 111;
 HEAP32[gb + 186836 >> 2] = fb + 112;
 HEAP32[gb + 186840 >> 2] = fb + 113;
 HEAP32[gb + 186844 >> 2] = fb + 2830;
 HEAP32[gb + 186848 >> 2] = fb + 2831;
 HEAP32[gb + 186860 >> 2] = (HEAP32[gb + 186860 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 186864 >> 2] = (HEAP32[gb + 186864 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 186900 >> 2] = fb + 2832;
 HEAP32[gb + 186904 >> 2] = fb + 2833;
 HEAP32[gb + 186908 >> 2] = fb + 2834;
 HEAP32[gb + 186912 >> 2] = fb + 2169;
 HEAP32[gb + 186916 >> 2] = fb + 16;
 HEAP32[gb + 186920 >> 2] = fb + 2835;
 HEAP32[gb + 186924 >> 2] = fb + 40;
 HEAP32[gb + 186928 >> 2] = fb + 19;
 HEAP32[gb + 186932 >> 2] = fb + 1314;
 HEAP32[gb + 186936 >> 2] = fb + 103;
 HEAP32[gb + 186940 >> 2] = fb + 101;
 HEAP32[gb + 186944 >> 2] = fb + 62;
 HEAP32[gb + 186948 >> 2] = fb + 28;
 HEAP32[gb + 186952 >> 2] = fb + 63;
 HEAP32[gb + 186956 >> 2] = fb + 29;
 HEAP32[gb + 186960 >> 2] = fb + 34;
 HEAP32[gb + 186964 >> 2] = fb + 2170;
 HEAP32[gb + 186968 >> 2] = fb + 2171;
 HEAP32[gb + 186972 >> 2] = fb + 2172;
 HEAP32[gb + 186976 >> 2] = fb + 2173;
 HEAP32[gb + 186980 >> 2] = fb + 2174;
 HEAP32[gb + 186984 >> 2] = fb + 2175;
 HEAP32[gb + 186988 >> 2] = fb + 36;
 HEAP32[gb + 186992 >> 2] = fb + 104;
 HEAP32[gb + 186996 >> 2] = fb + 108;
 HEAP32[gb + 187e3 >> 2] = fb + 2836;
 HEAP32[gb + 187004 >> 2] = fb + 109;
 HEAP32[gb + 187008 >> 2] = fb + 105;
 HEAP32[gb + 187012 >> 2] = fb + 106;
 HEAP32[gb + 187016 >> 2] = fb + 110;
 HEAP32[gb + 187028 >> 2] = (HEAP32[gb + 187028 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 187032 >> 2] = (HEAP32[gb + 187032 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 187068 >> 2] = fb + 2837;
 HEAP32[gb + 187072 >> 2] = fb + 2838;
 HEAP32[gb + 187076 >> 2] = fb + 2839;
 HEAP32[gb + 187080 >> 2] = fb + 1209;
 runPostSets218();
}

function runPostSets212() {
 HEAP32[gb + 178508 >> 2] = fb + 40;
 HEAP32[gb + 178512 >> 2] = fb + 19;
 HEAP32[gb + 178516 >> 2] = fb + 1287;
 HEAP32[gb + 178520 >> 2] = fb + 31;
 HEAP32[gb + 178524 >> 2] = fb + 27;
 HEAP32[gb + 178528 >> 2] = fb + 62;
 HEAP32[gb + 178532 >> 2] = fb + 28;
 HEAP32[gb + 178536 >> 2] = fb + 63;
 HEAP32[gb + 178540 >> 2] = fb + 29;
 HEAP32[gb + 178544 >> 2] = fb + 34;
 HEAP32[gb + 178548 >> 2] = fb + 2099;
 HEAP32[gb + 178552 >> 2] = fb + 2100;
 HEAP32[gb + 178556 >> 2] = fb + 2101;
 HEAP32[gb + 178560 >> 2] = fb + 2102;
 HEAP32[gb + 178564 >> 2] = fb + 2103;
 HEAP32[gb + 178568 >> 2] = fb + 2104;
 HEAP32[gb + 178572 >> 2] = fb + 36;
 HEAP32[gb + 178576 >> 2] = fb + 451;
 HEAP32[gb + 178580 >> 2] = fb + 1288;
 HEAP32[gb + 178584 >> 2] = fb + 1289;
 HEAP32[gb + 178588 >> 2] = fb + 456;
 HEAP32[gb + 178592 >> 2] = fb + 1290;
 HEAP32[gb + 178596 >> 2] = fb + 1291;
 HEAP32[gb + 178600 >> 2] = fb + 1292;
 HEAP32[gb + 178604 >> 2] = fb + 1293;
 HEAP32[gb + 178608 >> 2] = fb + 2767;
 HEAP32[gb + 178612 >> 2] = fb + 2105;
 HEAP32[gb + 178616 >> 2] = fb + 2774;
 HEAP32[gb + 178620 >> 2] = fb + 2775;
 HEAP32[gb + 178632 >> 2] = (HEAP32[gb + 178632 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 178636 >> 2] = (HEAP32[gb + 178636 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 178672 >> 2] = fb + 2776;
 HEAP32[gb + 178676 >> 2] = fb + 2777;
 HEAP32[gb + 178680 >> 2] = fb + 2778;
 HEAP32[gb + 178684 >> 2] = fb + 2106;
 HEAP32[gb + 178688 >> 2] = fb + 16;
 HEAP32[gb + 178692 >> 2] = fb + 2779;
 HEAP32[gb + 178696 >> 2] = fb + 40;
 HEAP32[gb + 178700 >> 2] = fb + 19;
 HEAP32[gb + 178704 >> 2] = fb + 1294;
 HEAP32[gb + 178708 >> 2] = fb + 31;
 HEAP32[gb + 178712 >> 2] = fb + 27;
 HEAP32[gb + 178716 >> 2] = fb + 62;
 HEAP32[gb + 178720 >> 2] = fb + 28;
 HEAP32[gb + 178724 >> 2] = fb + 63;
 HEAP32[gb + 178728 >> 2] = fb + 29;
 HEAP32[gb + 178732 >> 2] = fb + 34;
 HEAP32[gb + 178736 >> 2] = fb + 2107;
 HEAP32[gb + 178740 >> 2] = fb + 2108;
 HEAP32[gb + 178744 >> 2] = fb + 2109;
 HEAP32[gb + 178748 >> 2] = fb + 2110;
 HEAP32[gb + 178752 >> 2] = fb + 2111;
 HEAP32[gb + 178756 >> 2] = fb + 2112;
 HEAP32[gb + 178760 >> 2] = fb + 36;
 HEAP32[gb + 178868 >> 2] = (HEAP32[gb + 178868 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 178872 >> 2] = (HEAP32[gb + 178872 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 178908 >> 2] = fb + 2780;
 HEAP32[gb + 178912 >> 2] = fb + 2781;
 HEAP32[gb + 178924 >> 2] = fb + 80;
 HEAP32[gb + 178928 >> 2] = fb + 162;
 HEAP32[gb + 178932 >> 2] = fb + 452;
 HEAP32[gb + 178936 >> 2] = fb + 2782;
 HEAP32[gb + 178940 >> 2] = fb + 2783;
 HEAP32[gb + 178952 >> 2] = fb + 2736;
 HEAP32[gb + 178956 >> 2] = fb + 2784;
 HEAP32[gb + 178960 >> 2] = fb + 143;
 HEAP32[gb + 178964 >> 2] = fb + 13;
 HEAP32[gb + 178968 >> 2] = fb + 2;
 HEAP32[gb + 178972 >> 2] = fb + 3;
 HEAP32[gb + 178976 >> 2] = fb + 3;
 HEAP32[gb + 178980 >> 2] = fb + 4;
 HEAP32[gb + 178984 >> 2] = fb + 256;
 HEAP32[gb + 178988 >> 2] = fb + 144;
 HEAP32[gb + 178992 >> 2] = fb + 4;
 HEAP32[gb + 178996 >> 2] = fb + 2;
 HEAP32[gb + 179e3 >> 2] = fb + 1295;
 HEAP32[gb + 179004 >> 2] = fb + 453;
 HEAP32[gb + 179008 >> 2] = fb + 2738;
 HEAP32[gb + 179012 >> 2] = fb + 268;
 HEAP32[gb + 179016 >> 2] = fb + 24;
 HEAP32[gb + 179020 >> 2] = fb + 2066;
 HEAP32[gb + 179024 >> 2] = fb + 163;
 HEAP32[gb + 179028 >> 2] = fb + 1296;
 HEAP32[gb + 179032 >> 2] = fb + 2067;
 HEAP32[gb + 179036 >> 2] = fb + 450;
 HEAP32[gb + 179040 >> 2] = fb + 2;
 HEAP32[gb + 179044 >> 2] = fb + 2068;
 HEAP32[gb + 179048 >> 2] = fb + 2739;
 HEAP32[gb + 179052 >> 2] = fb + 2740;
 HEAP32[gb + 179056 >> 2] = fb + 2069;
 HEAP32[gb + 179060 >> 2] = fb + 1260;
 HEAP32[gb + 179064 >> 2] = fb + 1297;
 HEAP32[gb + 179068 >> 2] = fb + 440;
 HEAP32[gb + 179072 >> 2] = fb + 1262;
 HEAP32[gb + 179076 >> 2] = fb + 2070;
 HEAP32[gb + 179080 >> 2] = fb + 2071;
 HEAP32[gb + 179084 >> 2] = fb + 2072;
 HEAP32[gb + 179096 >> 2] = fb + 454;
 HEAP32[gb + 179100 >> 2] = fb + 164;
 HEAP32[gb + 179104 >> 2] = fb + 165;
 runPostSets213();
}

function runPostSets130() {
 HEAP32[gb + 113088 >> 2] = fb + 1293;
 HEAP32[gb + 113092 >> 2] = fb + 1294;
 HEAP32[gb + 113096 >> 2] = fb + 1295;
 HEAP32[gb + 113100 >> 2] = fb + 1296;
 HEAP32[gb + 113104 >> 2] = fb + 36;
 HEAP32[gb + 113116 >> 2] = (HEAP32[gb + 113116 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 113120 >> 2] = (HEAP32[gb + 113120 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 113156 >> 2] = fb + 1795;
 HEAP32[gb + 113160 >> 2] = fb + 1796;
 HEAP32[gb + 113164 >> 2] = fb + 1797;
 HEAP32[gb + 113168 >> 2] = fb + 1297;
 HEAP32[gb + 113172 >> 2] = fb + 16;
 HEAP32[gb + 113176 >> 2] = fb + 39;
 HEAP32[gb + 113180 >> 2] = fb + 1798;
 HEAP32[gb + 113184 >> 2] = fb + 19;
 HEAP32[gb + 113188 >> 2] = fb + 884;
 HEAP32[gb + 113192 >> 2] = fb + 99;
 HEAP32[gb + 113196 >> 2] = fb + 40;
 HEAP32[gb + 113200 >> 2] = fb + 62;
 HEAP32[gb + 113204 >> 2] = fb + 28;
 HEAP32[gb + 113208 >> 2] = fb + 63;
 HEAP32[gb + 113212 >> 2] = fb + 29;
 HEAP32[gb + 113216 >> 2] = fb + 34;
 HEAP32[gb + 113220 >> 2] = fb + 1298;
 HEAP32[gb + 113224 >> 2] = fb + 1299;
 HEAP32[gb + 113228 >> 2] = fb + 1300;
 HEAP32[gb + 113232 >> 2] = fb + 1301;
 HEAP32[gb + 113236 >> 2] = fb + 1302;
 HEAP32[gb + 113240 >> 2] = fb + 1303;
 HEAP32[gb + 113244 >> 2] = fb + 36;
 HEAP32[gb + 113248 >> 2] = fb + 96;
 HEAP32[gb + 113252 >> 2] = fb + 81;
 HEAP32[gb + 113256 >> 2] = fb + 82;
 HEAP32[gb + 113260 >> 2] = fb + 267;
 HEAP32[gb + 113264 >> 2] = fb + 104;
 HEAP32[gb + 113268 >> 2] = fb + 268;
 HEAP32[gb + 113272 >> 2] = fb + 269;
 HEAP32[gb + 113276 >> 2] = fb + 270;
 HEAP32[gb + 113288 >> 2] = fb + 271;
 HEAP32[gb + 113292 >> 2] = fb + 272;
 HEAP32[gb + 113296 >> 2] = fb + 273;
 HEAP32[gb + 113300 >> 2] = fb + 105;
 HEAP32[gb + 113304 >> 2] = fb + 274;
 HEAP32[gb + 113308 >> 2] = fb + 1799;
 HEAP32[gb + 113312 >> 2] = fb + 1800;
 HEAP32[gb + 113324 >> 2] = (HEAP32[gb + 113324 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 113328 >> 2] = (HEAP32[gb + 113328 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 113364 >> 2] = fb + 1801;
 HEAP32[gb + 113368 >> 2] = fb + 1802;
 HEAP32[gb + 113372 >> 2] = fb + 1803;
 HEAP32[gb + 113376 >> 2] = fb + 1304;
 HEAP32[gb + 113380 >> 2] = fb + 16;
 HEAP32[gb + 113384 >> 2] = fb + 1804;
 HEAP32[gb + 113388 >> 2] = fb + 1805;
 HEAP32[gb + 113392 >> 2] = fb + 19;
 HEAP32[gb + 113396 >> 2] = fb + 885;
 HEAP32[gb + 113400 >> 2] = fb + 103;
 HEAP32[gb + 113404 >> 2] = fb + 101;
 HEAP32[gb + 113408 >> 2] = fb + 62;
 HEAP32[gb + 113412 >> 2] = fb + 28;
 HEAP32[gb + 113416 >> 2] = fb + 63;
 HEAP32[gb + 113420 >> 2] = fb + 29;
 HEAP32[gb + 113424 >> 2] = fb + 34;
 HEAP32[gb + 113428 >> 2] = fb + 1305;
 HEAP32[gb + 113432 >> 2] = fb + 1306;
 HEAP32[gb + 113436 >> 2] = fb + 1307;
 HEAP32[gb + 113440 >> 2] = fb + 1308;
 HEAP32[gb + 113444 >> 2] = fb + 1309;
 HEAP32[gb + 113448 >> 2] = fb + 1310;
 HEAP32[gb + 113452 >> 2] = fb + 36;
 HEAP32[gb + 113456 >> 2] = fb + 104;
 HEAP32[gb + 113460 >> 2] = fb + 1311;
 HEAP32[gb + 113464 >> 2] = fb + 94;
 HEAP32[gb + 113468 >> 2] = fb + 1312;
 HEAP32[gb + 113472 >> 2] = fb + 105;
 HEAP32[gb + 113476 >> 2] = fb + 106;
 HEAP32[gb + 113480 >> 2] = fb + 110;
 HEAP32[gb + 113492 >> 2] = fb + 1806;
 HEAP32[gb + 113496 >> 2] = fb + 1807;
 HEAP32[gb + 113500 >> 2] = fb + 1735;
 HEAP32[gb + 113504 >> 2] = fb + 1313;
 HEAP32[gb + 113508 >> 2] = fb + 16;
 HEAP32[gb + 113512 >> 2] = fb + 93;
 HEAP32[gb + 113516 >> 2] = fb + 1808;
 HEAP32[gb + 113520 >> 2] = fb + 1809;
 HEAP32[gb + 113524 >> 2] = fb + 886;
 HEAP32[gb + 113528 >> 2] = fb + 103;
 HEAP32[gb + 113532 >> 2] = fb + 101;
 HEAP32[gb + 113536 >> 2] = fb + 62;
 HEAP32[gb + 113540 >> 2] = fb + 28;
 HEAP32[gb + 113544 >> 2] = fb + 63;
 HEAP32[gb + 113548 >> 2] = fb + 29;
 HEAP32[gb + 113552 >> 2] = fb + 34;
 HEAP32[gb + 113556 >> 2] = fb + 1314;
 HEAP32[gb + 113560 >> 2] = fb + 1315;
 HEAP32[gb + 113564 >> 2] = fb + 1316;
 HEAP32[gb + 113568 >> 2] = fb + 1317;
 HEAP32[gb + 113572 >> 2] = fb + 1318;
 HEAP32[gb + 113576 >> 2] = fb + 1319;
 HEAP32[gb + 113580 >> 2] = fb + 36;
 runPostSets131();
}

function __ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj(i12, i13, i16, i19, i9, i10, f11, i8, i17) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i8 = i8 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i14 = 0, i15 = 0, i18 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 40 | 0;
 i14 = i20 + 16 | 0;
 i15 = i20;
 i7 = HEAP32[i19 >> 2] | 0;
 if (!i7) {
  HEAP32[i12 + 464 >> 2] = 1;
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 if ((i16 | 0) > 0) {
  i6 = HEAP32[i12 + 56 >> 2] | 0;
  i5 = 0;
  i1 = 0;
  do {
   i2 = i13 + (i5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (Math_fround(HEAPF32[(HEAP32[i6 + (i3 << 2) >> 2] | 0) + 32 + (i10 << 2) >> 2]) <= f11) {
    i4 = i13 + (i1 << 2) | 0;
    if ((i5 | 0) != (i1 | 0)) {
     HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
    i1 = i1 + 1 | 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i16 | 0));
  i3 = i1;
 } else i3 = 0;
 do if (i8) {
  i4 = i19 + 8 | 0;
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i1 + (HEAP32[i4 >> 2] << 3) >> 2] = i10 << 2 | 1;
  i8 = i7 + 36 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = (i2 | 0) >= (i7 | 0) ? i2 : i7;
 } else {
  if (__ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor7kdSplitEif(i19, i10, f11) | 0) {
   i2 = i19 + 8 | 0;
   i4 = i2;
   i1 = HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   break;
  }
  HEAP32[i12 + 464 >> 2] = 1;
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 } while (0);
 HEAP32[i1 + (i2 << 3) + 4 >> 2] = -1;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i18 >> 2] = i2;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i18 + 4 >> 2] = i5;
 i6 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i18 + 8 >> 2] = i6;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i18 + 12 >> 2] = i7;
 i8 = HEAP32[i9 + 16 >> 2] | 0;
 HEAP32[i18 + 16 >> 2] = i8;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 HEAP32[i18 + 20 >> 2] = i1;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i5;
 HEAP32[i14 + 8 >> 2] = i6;
 HEAP32[i14 + 12 >> 2] = i7;
 HEAP32[i14 + 16 >> 2] = i8;
 HEAP32[i14 + 20 >> 2] = i1;
 HEAPF32[i18 + 12 + (i10 << 2) >> 2] = f11;
 HEAPF32[i14 + (i10 << 2) >> 2] = f11;
 i1 = i10 << 1;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor13constructLeftERS3_(i19, i15);
 L24 : do if (__ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij(i12, i15, i18, i13, i3, i17 & ~(1 << (i1 | 1))) | 0) {
  __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor14constructRightERS3_(i19, i15);
  if (__ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij(i12, i15, i14, i13 + (i3 << 2) | 0, i16 - i3 | 0, i17 & ~(1 << i1)) | 0) {
   i5 = i19 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i1 = 1; else {
    i1 = HEAP32[i4 >> 2] | 0;
    if ((i1 | 0) == ((HEAP32[i2 + 8 >> 2] | 0) + 1 | 0)) {
     i4 = __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(HEAP32[i19 >> 2] | 0, i1) | 0;
     i3 = HEAP32[i19 >> 2] | 0;
     i1 = (HEAP32[i3 + 8 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] << 3) | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     switch (i2 & 3) {
     case 1:
      {
       HEAP32[i1 >> 2] = i2 & 15 | i4 << 4;
       i1 = 1;
       break L24;
      }
     case 0:
      {
       i1 = (HEAP32[i3 + 24 >> 2] | 0) + (i2 >>> 2 << 3) | 0;
       HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 3 | i4 << 2;
       i1 = 1;
       break L24;
      }
     default:
      {
       i1 = 1;
       break L24;
      }
     }
    } else i1 = 1;
   }
  } else i1 = 0;
 } else i1 = 0; while (0);
 i19 = i1;
 STACKTOP = i20;
 return i19 | 0;
}

function runPostSets211() {
 HEAP32[gb + 177652 >> 2] = fb + 1270;
 HEAP32[gb + 177656 >> 2] = fb + 2070;
 HEAP32[gb + 177660 >> 2] = fb + 2071;
 HEAP32[gb + 177664 >> 2] = fb + 2083;
 HEAP32[gb + 177668 >> 2] = fb + 272;
 HEAP32[gb + 177672 >> 2] = fb + 273;
 HEAP32[gb + 177676 >> 2] = fb + 274;
 HEAP32[gb + 177680 >> 2] = fb + 275;
 HEAP32[gb + 177684 >> 2] = fb + 276;
 HEAP32[gb + 177688 >> 2] = fb + 277;
 HEAP32[gb + 177692 >> 2] = fb + 448;
 HEAP32[gb + 177696 >> 2] = fb + 449;
 HEAP32[gb + 177700 >> 2] = fb + 1271;
 HEAP32[gb + 177704 >> 2] = fb + 1272;
 HEAP32[gb + 177708 >> 2] = fb + 1273;
 HEAP32[gb + 177712 >> 2] = fb + 1274;
 HEAP32[gb + 177724 >> 2] = fb + 1275;
 HEAP32[gb + 177728 >> 2] = fb + 1276;
 HEAP32[gb + 177732 >> 2] = fb + 1277;
 HEAP32[gb + 177736 >> 2] = fb + 1278;
 HEAP32[gb + 177748 >> 2] = fb + 2759;
 HEAP32[gb + 177752 >> 2] = fb + 2760;
 HEAP32[gb + 178108 >> 2] = fb + 2761;
 HEAP32[gb + 178112 >> 2] = fb + 2762;
 HEAP32[gb + 178124 >> 2] = fb + 2763;
 HEAP32[gb + 178128 >> 2] = fb + 2764;
 HEAP32[gb + 178132 >> 2] = fb + 2765;
 HEAP32[gb + 178136 >> 2] = fb + 2084;
 HEAP32[gb + 178140 >> 2] = fb + 16;
 HEAP32[gb + 178144 >> 2] = fb + 2766;
 HEAP32[gb + 178148 >> 2] = fb + 40;
 HEAP32[gb + 178152 >> 2] = fb + 19;
 HEAP32[gb + 178156 >> 2] = fb + 1279;
 HEAP32[gb + 178160 >> 2] = fb + 31;
 HEAP32[gb + 178164 >> 2] = fb + 27;
 HEAP32[gb + 178168 >> 2] = fb + 62;
 HEAP32[gb + 178172 >> 2] = fb + 28;
 HEAP32[gb + 178176 >> 2] = fb + 63;
 HEAP32[gb + 178180 >> 2] = fb + 29;
 HEAP32[gb + 178184 >> 2] = fb + 34;
 HEAP32[gb + 178188 >> 2] = fb + 2085;
 HEAP32[gb + 178192 >> 2] = fb + 2086;
 HEAP32[gb + 178196 >> 2] = fb + 2087;
 HEAP32[gb + 178200 >> 2] = fb + 2088;
 HEAP32[gb + 178204 >> 2] = fb + 2089;
 HEAP32[gb + 178208 >> 2] = fb + 2090;
 HEAP32[gb + 178212 >> 2] = fb + 36;
 HEAP32[gb + 178216 >> 2] = fb + 450;
 HEAP32[gb + 178220 >> 2] = fb + 1280;
 HEAP32[gb + 178224 >> 2] = fb + 1281;
 HEAP32[gb + 178228 >> 2] = fb + 455;
 HEAP32[gb + 178232 >> 2] = fb + 1282;
 HEAP32[gb + 178236 >> 2] = fb + 1283;
 HEAP32[gb + 178240 >> 2] = fb + 1284;
 HEAP32[gb + 178244 >> 2] = fb + 1285;
 HEAP32[gb + 178248 >> 2] = fb + 2767;
 HEAP32[gb + 178252 >> 2] = fb + 2091;
 HEAP32[gb + 178264 >> 2] = (HEAP32[gb + 178264 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 178268 >> 2] = (HEAP32[gb + 178268 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 178304 >> 2] = fb + 2768;
 HEAP32[gb + 178308 >> 2] = fb + 2769;
 HEAP32[gb + 178312 >> 2] = fb + 2770;
 HEAP32[gb + 178316 >> 2] = fb + 39;
 HEAP32[gb + 178320 >> 2] = fb + 16;
 HEAP32[gb + 178324 >> 2] = fb + 39;
 HEAP32[gb + 178328 >> 2] = fb + 40;
 HEAP32[gb + 178332 >> 2] = fb + 19;
 HEAP32[gb + 178336 >> 2] = fb + 1286;
 HEAP32[gb + 178340 >> 2] = fb + 31;
 HEAP32[gb + 178344 >> 2] = fb + 27;
 HEAP32[gb + 178348 >> 2] = fb + 62;
 HEAP32[gb + 178352 >> 2] = fb + 28;
 HEAP32[gb + 178356 >> 2] = fb + 63;
 HEAP32[gb + 178360 >> 2] = fb + 29;
 HEAP32[gb + 178364 >> 2] = fb + 34;
 HEAP32[gb + 178368 >> 2] = fb + 2092;
 HEAP32[gb + 178372 >> 2] = fb + 2093;
 HEAP32[gb + 178376 >> 2] = fb + 2094;
 HEAP32[gb + 178380 >> 2] = fb + 2095;
 HEAP32[gb + 178384 >> 2] = fb + 2096;
 HEAP32[gb + 178388 >> 2] = fb + 2097;
 HEAP32[gb + 178392 >> 2] = fb + 36;
 HEAP32[gb + 178396 >> 2] = fb + 1;
 HEAP32[gb + 178400 >> 2] = fb + 1;
 HEAP32[gb + 178404 >> 2] = fb + 1;
 HEAP32[gb + 178408 >> 2] = fb + 1;
 HEAP32[gb + 178412 >> 2] = fb + 1;
 HEAP32[gb + 178416 >> 2] = fb + 1;
 HEAP32[gb + 178420 >> 2] = fb + 1;
 HEAP32[gb + 178424 >> 2] = fb + 1285;
 HEAP32[gb + 178428 >> 2] = fb + 2767;
 HEAP32[gb + 178432 >> 2] = fb + 1;
 HEAP32[gb + 178444 >> 2] = (HEAP32[gb + 178444 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 178448 >> 2] = (HEAP32[gb + 178448 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 178484 >> 2] = fb + 2771;
 HEAP32[gb + 178488 >> 2] = fb + 2772;
 HEAP32[gb + 178492 >> 2] = fb + 2773;
 HEAP32[gb + 178496 >> 2] = fb + 2098;
 HEAP32[gb + 178500 >> 2] = fb + 16;
 HEAP32[gb + 178504 >> 2] = fb + 39;
 runPostSets212();
}

function __ZN2UI14DepthSortLayer11GetDepthForERKNS_23RenderableUIInstructionEPS2_(i13, i21, i22) {
 i13 = i13 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 8 | 0;
 i1 = i26;
 i25 = i26 + 16 | 0;
 i24 = gb + 64016 | 0;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i14 + 4 >> 2] = i23;
 HEAP32[i25 >> 2] = 0;
 i14 = i25 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i23 = i25 + 16 | 0;
 HEAP32[i23 >> 2] = 0;
 i24 = i25 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i1);
 i1 = HEAP32[i20 + 4 >> 2] | 0;
 i15 = i24;
 HEAP32[i15 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i15 + 4 >> 2] = i1;
 i15 = i13 + 12 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  i3 = -1;
  i1 = 1;
  i2 = 0;
 } else {
  i16 = i13 + 20 | 0;
  i17 = i21 + 168 | 0;
  i18 = i21 + 172 | 0;
  i19 = i21 + 176 | 0;
  i20 = i21 + 180 | 0;
  i12 = 0;
  i3 = -1;
  i2 = 0;
  i6 = 0;
  i9 = 0;
  i5 = 0;
  i8 = 0;
  do {
   i4 = HEAP32[i16 >> 2] | 0;
   f27 = Math_fround(HEAPF32[i4 + (i12 << 5) >> 2]);
   i7 = f27 < Math_fround(HEAPF32[i17 >> 2]);
   f27 = Math_fround(HEAPF32[i4 + (i12 << 5) + 4 >> 2]);
   i10 = f27 < Math_fround(HEAPF32[i18 >> 2]);
   f27 = Math_fround(HEAPF32[i4 + (i12 << 5) + 8 >> 2]);
   i11 = f27 < Math_fround(HEAPF32[i19 >> 2]);
   f27 = Math_fround(HEAPF32[i4 + (i12 << 5) + 12 >> 2]);
   if (i7 & i10 & i11 & f27 < Math_fround(HEAPF32[i20 >> 2])) {
    i7 = HEAP32[i13 >> 2] | 0;
    i4 = HEAP32[i7 + (i12 << 5) + 4 >> 2] | 0;
    if ((i4 | 0) >= (i3 | 0)) {
     if ((i4 | 0) == (i3 | 0)) {
      i11 = i9;
      i1 = i7;
      i10 = HEAP32[i14 >> 2] | 0;
      i7 = HEAP32[i23 >> 2] | 0;
     } else {
      if ((HEAP32[i23 >> 2] | 0) > -1) {
       __Z19free_alloc_internalPvRK10MemLabelId(i8, i24);
       HEAP32[i25 >> 2] = 0;
       i3 = HEAP32[i13 >> 2] | 0;
       i1 = i3;
       i3 = HEAP32[i3 + (i12 << 5) + 4 >> 2] | 0;
      } else {
       i1 = i7;
       i3 = i4;
      }
      HEAP32[i25 >> 2] = 0;
      HEAP32[i14 >> 2] = 0;
      HEAP32[i23 >> 2] = 0;
      i2 = 0;
      i6 = 0;
      i11 = 0;
      i10 = 0;
      i7 = 0;
      i5 = 0;
     }
     i8 = i1 + (i12 << 5) | 0;
     i9 = i10 + 1 | 0;
     i4 = i7 & 2147483647;
     do if (i9 >>> 0 > i4 >>> 0) {
      i1 = i7 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i4 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i23 >> 2] = i1;
       i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i1 << 2, 4, i24, 0, gb + 1047584 | 0, 464) | 0;
       HEAP32[i25 >> 2] = i1;
       i2 = i1;
       i6 = i1;
       break;
      } else {
       i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i24, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i11 | 0, HEAP32[i25 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
       HEAP32[i23 >> 2] = i1;
       HEAP32[i25 >> 2] = i11;
       i2 = i11;
       i6 = i11;
       i1 = i11;
       break;
      } else i1 = i11;
     } else i1 = i11; while (0);
     HEAP32[i14 >> 2] = i9;
     HEAP32[i1 + (i10 << 2) >> 2] = HEAP32[i8 >> 2];
     i9 = i1;
     i5 = i1;
     i8 = i1;
     i1 = HEAP32[i15 >> 2] | 0;
    }
   }
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < i1 >>> 0);
  i5 = HEAP32[i14 >> 2] | 0;
  if (!i5) {
   i4 = 0;
   i1 = 1;
  } else {
   i4 = 0;
   i1 = 0;
   do {
    i4 = i4 | (__ZN2UI11BreaksBatchERKNS_23RenderableUIInstructionES2_(i22 + ((HEAP32[i6 + (i1 << 2) >> 2] | 0) * 252 | 0) | 0, i21) | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
   i1 = (i5 | 0) == 0;
  }
 }
 i1 = ((i4 | i1) & 1) + i3 | 0;
 if ((HEAP32[i23 >> 2] | 0) <= -1) {
  STACKTOP = i26;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i24);
 HEAP32[i25 >> 2] = 0;
 STACKTOP = i26;
 return i1 | 0;
}

function __ZN5physx21propagateVelocitySIMDERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE(i2, i5, i4, i1, i6, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(Math_fround(f8 * f11) - Math_fround(f7 * f15)));
 f11 = Math_fround(f12 + Math_fround(Math_fround(f7 * f18) - Math_fround(f17 * f11)));
 f18 = Math_fround(f10 + Math_fround(Math_fround(f17 * f15) - Math_fround(f8 * f18)));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 96 >> 2]));
 f20 = Math_fround(f20 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 112 >> 2])));
 f20 = Math_fround(f20 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 128 >> 2])));
 f19 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 100 >> 2]));
 f19 = Math_fround(f19 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 116 >> 2])));
 f19 = Math_fround(f19 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 132 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i5 + 104 >> 2]));
 f10 = Math_fround(f15 + Math_fround(f10 * Math_fround(HEAPF32[i5 + 120 >> 2])));
 f12 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 136 >> 2])));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 8 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f9 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f9)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 24 >> 2]))));
 f10 = Math_fround(HEAPF32[i5 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 36 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 40 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 52 >> 2]);
 f13 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f13)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 56 >> 2]))));
 f10 = Math_fround(HEAPF32[i5 + 64 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f11 * f15)) + Math_fround(f18 * Math_fround(HEAPF32[i5 + 72 >> 2])));
 f10 = Math_fround(HEAPF32[i5 + 80 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 84 >> 2]);
 f9 = Math_fround(f20 + f9);
 f13 = Math_fround(f19 + f13);
 f14 = Math_fround(f12 + Math_fround(f15 + Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f8 * f14)) + Math_fround(f7 * Math_fround(HEAPF32[i5 + 88 >> 2])))));
 f10 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f11 = Math_fround(f11 - Math_fround(Math_fround(f9 * f12) - Math_fround(f10 * f14)));
 f10 = Math_fround(f18 - Math_fround(Math_fround(f13 * f10) - Math_fround(f9 * f15)));
 f9 = Math_fround(f17 - f9);
 f8 = Math_fround(f8 - f13);
 f7 = Math_fround(f7 - f14);
 HEAPF32[i2 >> 2] = Math_fround(f16 - Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)));
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = f9;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f7;
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15SerializeTraitsI11KeyframeTplIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034360 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034365 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034371 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034379 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function runPostSets225() {
 HEAP32[gb + 190680 >> 2] = fb + 29;
 HEAP32[gb + 190684 >> 2] = fb + 34;
 HEAP32[gb + 190688 >> 2] = fb + 2270;
 HEAP32[gb + 190692 >> 2] = fb + 2271;
 HEAP32[gb + 190696 >> 2] = fb + 2272;
 HEAP32[gb + 190700 >> 2] = fb + 2273;
 HEAP32[gb + 190704 >> 2] = fb + 2274;
 HEAP32[gb + 190708 >> 2] = fb + 2275;
 HEAP32[gb + 190712 >> 2] = fb + 36;
 HEAP32[gb + 190716 >> 2] = fb + 104;
 HEAP32[gb + 190720 >> 2] = fb + 108;
 HEAP32[gb + 190724 >> 2] = fb + 94;
 HEAP32[gb + 190728 >> 2] = fb + 2262;
 HEAP32[gb + 190732 >> 2] = fb + 1397;
 HEAP32[gb + 190736 >> 2] = fb + 1398;
 HEAP32[gb + 190740 >> 2] = fb + 2263;
 HEAP32[gb + 190744 >> 2] = fb + 93;
 HEAP32[gb + 190756 >> 2] = (HEAP32[gb + 190756 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 190760 >> 2] = (HEAP32[gb + 190760 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 190796 >> 2] = fb + 3003;
 HEAP32[gb + 190800 >> 2] = fb + 3004;
 HEAP32[gb + 190804 >> 2] = fb + 38;
 HEAP32[gb + 190808 >> 2] = fb + 100;
 HEAP32[gb + 190812 >> 2] = fb + 16;
 HEAP32[gb + 190816 >> 2] = fb + 93;
 HEAP32[gb + 190820 >> 2] = fb + 40;
 HEAP32[gb + 190824 >> 2] = fb + 19;
 HEAP32[gb + 190828 >> 2] = fb + 1401;
 HEAP32[gb + 190832 >> 2] = fb + 103;
 HEAP32[gb + 190836 >> 2] = fb + 101;
 HEAP32[gb + 190840 >> 2] = fb + 62;
 HEAP32[gb + 190844 >> 2] = fb + 28;
 HEAP32[gb + 190848 >> 2] = fb + 63;
 HEAP32[gb + 190852 >> 2] = fb + 29;
 HEAP32[gb + 190856 >> 2] = fb + 34;
 HEAP32[gb + 190860 >> 2] = fb + 2276;
 HEAP32[gb + 190864 >> 2] = fb + 2277;
 HEAP32[gb + 190868 >> 2] = fb + 2278;
 HEAP32[gb + 190872 >> 2] = fb + 2279;
 HEAP32[gb + 190876 >> 2] = fb + 2280;
 HEAP32[gb + 190880 >> 2] = fb + 2281;
 HEAP32[gb + 190884 >> 2] = fb + 36;
 HEAP32[gb + 190888 >> 2] = fb + 104;
 HEAP32[gb + 190892 >> 2] = fb + 108;
 HEAP32[gb + 190896 >> 2] = fb + 94;
 HEAP32[gb + 190900 >> 2] = fb + 109;
 HEAP32[gb + 190904 >> 2] = fb + 105;
 HEAP32[gb + 190908 >> 2] = fb + 106;
 HEAP32[gb + 190912 >> 2] = fb + 110;
 HEAP32[gb + 190924 >> 2] = (HEAP32[gb + 190924 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 190928 >> 2] = (HEAP32[gb + 190928 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 190964 >> 2] = fb + 3005;
 HEAP32[gb + 190968 >> 2] = fb + 3006;
 HEAP32[gb + 190972 >> 2] = fb + 346;
 HEAP32[gb + 190976 >> 2] = fb + 2282;
 HEAP32[gb + 190980 >> 2] = fb + 16;
 HEAP32[gb + 190984 >> 2] = fb + 3007;
 HEAP32[gb + 190988 >> 2] = fb + 3008;
 HEAP32[gb + 190992 >> 2] = fb + 349;
 HEAP32[gb + 190996 >> 2] = fb + 1402;
 HEAP32[gb + 191e3 >> 2] = fb + 103;
 HEAP32[gb + 191004 >> 2] = fb + 101;
 HEAP32[gb + 191008 >> 2] = fb + 62;
 HEAP32[gb + 191012 >> 2] = fb + 28;
 HEAP32[gb + 191016 >> 2] = fb + 63;
 HEAP32[gb + 191020 >> 2] = fb + 29;
 HEAP32[gb + 191024 >> 2] = fb + 34;
 HEAP32[gb + 191028 >> 2] = fb + 2283;
 HEAP32[gb + 191032 >> 2] = fb + 2284;
 HEAP32[gb + 191036 >> 2] = fb + 2285;
 HEAP32[gb + 191040 >> 2] = fb + 2286;
 HEAP32[gb + 191044 >> 2] = fb + 2287;
 HEAP32[gb + 191048 >> 2] = fb + 2288;
 HEAP32[gb + 191052 >> 2] = fb + 36;
 HEAP32[gb + 191056 >> 2] = fb + 104;
 HEAP32[gb + 191060 >> 2] = fb + 336;
 HEAP32[gb + 191064 >> 2] = fb + 94;
 HEAP32[gb + 191068 >> 2] = fb + 337;
 HEAP32[gb + 191072 >> 2] = fb + 205;
 HEAP32[gb + 191076 >> 2] = fb + 206;
 HEAP32[gb + 191080 >> 2] = fb + 338;
 HEAP32[gb + 191084 >> 2] = fb + 350;
 HEAP32[gb + 191088 >> 2] = fb + 351;
 HEAP32[gb + 191092 >> 2] = fb + 207;
 HEAP32[gb + 191096 >> 2] = fb + 3009;
 HEAP32[gb + 191100 >> 2] = fb + 353;
 HEAP32[gb + 191104 >> 2] = fb + 208;
 HEAP32[gb + 191108 >> 2] = fb + 68;
 HEAP32[gb + 191112 >> 2] = fb + 69;
 HEAP32[gb + 191116 >> 2] = fb + 3010;
 HEAP32[gb + 191120 >> 2] = fb + 355;
 HEAP32[gb + 191124 >> 2] = fb + 356;
 HEAP32[gb + 191128 >> 2] = fb + 293;
 HEAP32[gb + 191140 >> 2] = fb + 3011;
 HEAP32[gb + 191144 >> 2] = fb + 3012;
 HEAP32[gb + 191148 >> 2] = fb + 294;
 HEAP32[gb + 191152 >> 2] = fb + 102;
 HEAP32[gb + 191156 >> 2] = fb + 359;
 HEAP32[gb + 191160 >> 2] = fb + 360;
 HEAP32[gb + 191164 >> 2] = fb + 209;
 runPostSets226();
}

function runPostSets178() {
 HEAP32[gb + 153548 >> 2] = fb + 1;
 HEAP32[gb + 153552 >> 2] = fb + 1;
 HEAP32[gb + 153556 >> 2] = fb + 1;
 HEAP32[gb + 153560 >> 2] = fb + 1064;
 HEAP32[gb + 153564 >> 2] = fb + 1065;
 HEAP32[gb + 153568 >> 2] = fb + 1;
 HEAP32[gb + 153572 >> 2] = fb + 1;
 HEAP32[gb + 153576 >> 2] = fb + 2330;
 HEAP32[gb + 153588 >> 2] = (HEAP32[gb + 153588 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 153592 >> 2] = (HEAP32[gb + 153592 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 153628 >> 2] = fb + 2334;
 HEAP32[gb + 153632 >> 2] = fb + 2335;
 HEAP32[gb + 153636 >> 2] = fb + 38;
 HEAP32[gb + 153640 >> 2] = fb + 1599;
 HEAP32[gb + 153644 >> 2] = fb + 16;
 HEAP32[gb + 153648 >> 2] = fb + 2336;
 HEAP32[gb + 153652 >> 2] = fb + 2337;
 HEAP32[gb + 153656 >> 2] = fb + 2338;
 HEAP32[gb + 153660 >> 2] = fb + 1069;
 HEAP32[gb + 153664 >> 2] = fb + 103;
 HEAP32[gb + 153668 >> 2] = fb + 101;
 HEAP32[gb + 153672 >> 2] = fb + 62;
 HEAP32[gb + 153676 >> 2] = fb + 28;
 HEAP32[gb + 153680 >> 2] = fb + 63;
 HEAP32[gb + 153684 >> 2] = fb + 29;
 HEAP32[gb + 153688 >> 2] = fb + 34;
 HEAP32[gb + 153692 >> 2] = fb + 1600;
 HEAP32[gb + 153696 >> 2] = fb + 1601;
 HEAP32[gb + 153700 >> 2] = fb + 1602;
 HEAP32[gb + 153704 >> 2] = fb + 1603;
 HEAP32[gb + 153708 >> 2] = fb + 1604;
 HEAP32[gb + 153712 >> 2] = fb + 1605;
 HEAP32[gb + 153716 >> 2] = fb + 36;
 HEAP32[gb + 153720 >> 2] = fb + 104;
 HEAP32[gb + 153724 >> 2] = fb + 108;
 HEAP32[gb + 153728 >> 2] = fb + 94;
 HEAP32[gb + 153732 >> 2] = fb + 1606;
 HEAP32[gb + 153736 >> 2] = fb + 112;
 HEAP32[gb + 153740 >> 2] = fb + 113;
 HEAP32[gb + 153744 >> 2] = fb + 131;
 HEAP32[gb + 153748 >> 2] = fb + 111;
 HEAP32[gb + 153752 >> 2] = fb + 112;
 HEAP32[gb + 153756 >> 2] = fb + 113;
 HEAP32[gb + 153760 >> 2] = fb + 2339;
 HEAP32[gb + 153764 >> 2] = fb + 2340;
 HEAP32[gb + 153768 >> 2] = fb + 1607;
 HEAP32[gb + 153772 >> 2] = fb + 1608;
 HEAP32[gb + 153784 >> 2] = (HEAP32[gb + 153784 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 153788 >> 2] = (HEAP32[gb + 153788 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 153824 >> 2] = fb + 2341;
 HEAP32[gb + 153828 >> 2] = fb + 2342;
 HEAP32[gb + 153832 >> 2] = fb + 38;
 HEAP32[gb + 153836 >> 2] = fb + 1599;
 HEAP32[gb + 153840 >> 2] = fb + 16;
 HEAP32[gb + 153844 >> 2] = fb + 2343;
 HEAP32[gb + 153848 >> 2] = fb + 2344;
 HEAP32[gb + 153852 >> 2] = fb + 19;
 HEAP32[gb + 153856 >> 2] = fb + 1070;
 HEAP32[gb + 153860 >> 2] = fb + 103;
 HEAP32[gb + 153864 >> 2] = fb + 101;
 HEAP32[gb + 153868 >> 2] = fb + 62;
 HEAP32[gb + 153872 >> 2] = fb + 28;
 HEAP32[gb + 153876 >> 2] = fb + 63;
 HEAP32[gb + 153880 >> 2] = fb + 29;
 HEAP32[gb + 153884 >> 2] = fb + 34;
 HEAP32[gb + 153888 >> 2] = fb + 1609;
 HEAP32[gb + 153892 >> 2] = fb + 1610;
 HEAP32[gb + 153896 >> 2] = fb + 1611;
 HEAP32[gb + 153900 >> 2] = fb + 1612;
 HEAP32[gb + 153904 >> 2] = fb + 1613;
 HEAP32[gb + 153908 >> 2] = fb + 1614;
 HEAP32[gb + 153912 >> 2] = fb + 36;
 HEAP32[gb + 153916 >> 2] = fb + 104;
 HEAP32[gb + 153920 >> 2] = fb + 108;
 HEAP32[gb + 153924 >> 2] = fb + 94;
 HEAP32[gb + 153928 >> 2] = fb + 1606;
 HEAP32[gb + 153932 >> 2] = fb + 112;
 HEAP32[gb + 153936 >> 2] = fb + 113;
 HEAP32[gb + 153940 >> 2] = fb + 131;
 HEAP32[gb + 153944 >> 2] = fb + 111;
 HEAP32[gb + 153948 >> 2] = fb + 112;
 HEAP32[gb + 153952 >> 2] = fb + 113;
 HEAP32[gb + 153956 >> 2] = fb + 2339;
 HEAP32[gb + 153960 >> 2] = fb + 2340;
 HEAP32[gb + 153964 >> 2] = fb + 1;
 HEAP32[gb + 153968 >> 2] = fb + 1615;
 HEAP32[gb + 153980 >> 2] = fb + 2345;
 HEAP32[gb + 153984 >> 2] = fb + 2346;
 HEAP32[gb + 153988 >> 2] = fb + 2325;
 HEAP32[gb + 153992 >> 2] = fb + 1584;
 HEAP32[gb + 153996 >> 2] = fb + 16;
 HEAP32[gb + 154e3 >> 2] = fb + 2347;
 HEAP32[gb + 154004 >> 2] = fb + 2348;
 HEAP32[gb + 154008 >> 2] = fb + 19;
 HEAP32[gb + 154012 >> 2] = fb + 1071;
 HEAP32[gb + 154016 >> 2] = fb + 103;
 HEAP32[gb + 154020 >> 2] = fb + 101;
 HEAP32[gb + 154024 >> 2] = fb + 62;
 HEAP32[gb + 154028 >> 2] = fb + 28;
 HEAP32[gb + 154032 >> 2] = fb + 63;
 runPostSets179();
}

function runPostSets129() {
 HEAP32[gb + 112608 >> 2] = fb + 16;
 HEAP32[gb + 112612 >> 2] = fb + 1774;
 HEAP32[gb + 112616 >> 2] = fb + 1780;
 HEAP32[gb + 112620 >> 2] = fb + 19;
 HEAP32[gb + 112624 >> 2] = fb + 881;
 HEAP32[gb + 112628 >> 2] = fb + 103;
 HEAP32[gb + 112632 >> 2] = fb + 101;
 HEAP32[gb + 112636 >> 2] = fb + 62;
 HEAP32[gb + 112640 >> 2] = fb + 28;
 HEAP32[gb + 112644 >> 2] = fb + 63;
 HEAP32[gb + 112648 >> 2] = fb + 29;
 HEAP32[gb + 112652 >> 2] = fb + 34;
 HEAP32[gb + 112656 >> 2] = fb + 102;
 HEAP32[gb + 112660 >> 2] = fb + 103;
 HEAP32[gb + 112664 >> 2] = fb + 104;
 HEAP32[gb + 112668 >> 2] = fb + 105;
 HEAP32[gb + 112672 >> 2] = fb + 106;
 HEAP32[gb + 112676 >> 2] = fb + 107;
 HEAP32[gb + 112680 >> 2] = fb + 36;
 HEAP32[gb + 112684 >> 2] = fb + 104;
 HEAP32[gb + 112688 >> 2] = fb + 108;
 HEAP32[gb + 112692 >> 2] = fb + 94;
 HEAP32[gb + 112696 >> 2] = fb + 1245;
 HEAP32[gb + 112700 >> 2] = fb + 105;
 HEAP32[gb + 112704 >> 2] = fb + 106;
 HEAP32[gb + 112708 >> 2] = fb + 110;
 HEAP32[gb + 112712 >> 2] = fb + 1246;
 HEAP32[gb + 112716 >> 2] = fb + 1247;
 HEAP32[gb + 112720 >> 2] = fb + 1248;
 HEAP32[gb + 112724 >> 2] = fb + 1249;
 HEAP32[gb + 112728 >> 2] = fb + 1250;
 HEAP32[gb + 112732 >> 2] = fb + 103;
 HEAP32[gb + 112736 >> 2] = fb + 1;
 HEAP32[gb + 112740 >> 2] = fb + 1;
 HEAP32[gb + 112752 >> 2] = (HEAP32[gb + 112752 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 112756 >> 2] = (HEAP32[gb + 112756 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 112792 >> 2] = fb + 1784;
 HEAP32[gb + 112796 >> 2] = fb + 1785;
 HEAP32[gb + 112800 >> 2] = fb + 1786;
 HEAP32[gb + 112804 >> 2] = fb + 1280;
 HEAP32[gb + 112808 >> 2] = fb + 16;
 HEAP32[gb + 112812 >> 2] = fb + 1787;
 HEAP32[gb + 112816 >> 2] = fb + 1788;
 HEAP32[gb + 112820 >> 2] = fb + 19;
 HEAP32[gb + 112824 >> 2] = fb + 882;
 HEAP32[gb + 112828 >> 2] = fb + 103;
 HEAP32[gb + 112832 >> 2] = fb + 101;
 HEAP32[gb + 112836 >> 2] = fb + 62;
 HEAP32[gb + 112840 >> 2] = fb + 28;
 HEAP32[gb + 112844 >> 2] = fb + 63;
 HEAP32[gb + 112848 >> 2] = fb + 29;
 HEAP32[gb + 112852 >> 2] = fb + 34;
 HEAP32[gb + 112856 >> 2] = fb + 1281;
 HEAP32[gb + 112860 >> 2] = fb + 1282;
 HEAP32[gb + 112864 >> 2] = fb + 1283;
 HEAP32[gb + 112868 >> 2] = fb + 1284;
 HEAP32[gb + 112872 >> 2] = fb + 1285;
 HEAP32[gb + 112876 >> 2] = fb + 1286;
 HEAP32[gb + 112880 >> 2] = fb + 36;
 HEAP32[gb + 112884 >> 2] = fb + 104;
 HEAP32[gb + 112888 >> 2] = fb + 1202;
 HEAP32[gb + 112892 >> 2] = fb + 94;
 HEAP32[gb + 112896 >> 2] = fb + 1203;
 HEAP32[gb + 112900 >> 2] = fb + 866;
 HEAP32[gb + 112904 >> 2] = fb + 867;
 HEAP32[gb + 112908 >> 2] = fb + 1204;
 HEAP32[gb + 112912 >> 2] = fb + 868;
 HEAP32[gb + 112916 >> 2] = fb + 869;
 HEAP32[gb + 112920 >> 2] = fb + 1287;
 HEAP32[gb + 112924 >> 2] = fb + 870;
 HEAP32[gb + 112928 >> 2] = fb + 871;
 HEAP32[gb + 112932 >> 2] = fb + 1206;
 HEAP32[gb + 112936 >> 2] = fb + 1288;
 HEAP32[gb + 112940 >> 2] = fb + 1789;
 HEAP32[gb + 112944 >> 2] = fb + 1790;
 HEAP32[gb + 112948 >> 2] = fb + 1730;
 HEAP32[gb + 112952 >> 2] = fb + 1731;
 HEAP32[gb + 112956 >> 2] = fb + 265;
 HEAP32[gb + 112960 >> 2] = fb + 1289;
 HEAP32[gb + 112964 >> 2] = fb + 1737;
 HEAP32[gb + 112976 >> 2] = (HEAP32[gb + 112976 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 112980 >> 2] = (HEAP32[gb + 112980 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 113016 >> 2] = fb + 1791;
 HEAP32[gb + 113020 >> 2] = fb + 1792;
 HEAP32[gb + 113024 >> 2] = fb + 1793;
 HEAP32[gb + 113028 >> 2] = fb + 1290;
 HEAP32[gb + 113032 >> 2] = fb + 16;
 HEAP32[gb + 113036 >> 2] = fb + 39;
 HEAP32[gb + 113040 >> 2] = fb + 1794;
 HEAP32[gb + 113044 >> 2] = fb + 19;
 HEAP32[gb + 113048 >> 2] = fb + 883;
 HEAP32[gb + 113052 >> 2] = fb + 31;
 HEAP32[gb + 113056 >> 2] = fb + 27;
 HEAP32[gb + 113060 >> 2] = fb + 62;
 HEAP32[gb + 113064 >> 2] = fb + 28;
 HEAP32[gb + 113068 >> 2] = fb + 63;
 HEAP32[gb + 113072 >> 2] = fb + 29;
 HEAP32[gb + 113076 >> 2] = fb + 34;
 HEAP32[gb + 113080 >> 2] = fb + 1291;
 HEAP32[gb + 113084 >> 2] = fb + 1292;
 runPostSets130();
}

function __ZN9Texture2D11InitTextureEii13TextureFormatNS_10EInitFlagsEiii(i11, i12, i13, i14, i1, i15, i3, i8) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 8 | 0;
 i4 = i17;
 i9 = i17 + 4 | 0;
 i16 = __Z20push_allocation_rootPvP13BaseAllocatorb(i11, 0, 0) | 0;
 L1 : do if (i12 >>> 0 > 16384 | i13 >>> 0 > 16384) {
  if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410753 | 0, 0, gb + 410682 | 0, 440, 1, i1, 0, 0);
  i1 = 0;
 } else {
  i7 = (i14 + -10 | 0) >>> 0 < 3;
  L7 : do if (!((i14 + -1 | 0) >>> 0 < 23 | i7)) {
   i2 = i14 | 1;
   switch (i2 | 0) {
   case 25:
   case 27:
    break L7;
   default:
    {}
   }
   if ((i14 + -48 | 0) >>> 0 >= 12) {
    switch (i14 | 0) {
    case 28:
    case 29:
    case 30:
    case 31:
    case 32:
    case 33:
    case 34:
    case 35:
    case 36:
    case 41:
    case 42:
    case 43:
    case 44:
    case 45:
    case 46:
    case 47:
     break L7;
    default:
     {}
    }
    if ((i2 | 0) != 61) {
     if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410793 | 0, 0, gb + 410682 | 0, 446, 1, i1, 0, 0);
     i1 = 0;
     break L1;
    }
   }
  } while (0);
  i2 = i14 + -6 | 0;
  if (i2 >>> 0 < 18) if (!(159745 >>> (i2 & 262143) & 1)) i5 = 16; else switch (i14 | 0) {
  case 23:
  case 6:
   break;
  default:
   i5 = 17;
  } else i5 = 16;
  if ((i5 | 0) == 16) switch (i14 | 0) {
  case 15:
  case 16:
  case 17:
  case 21:
   {
    i5 = 17;
    break;
   }
  default:
   {}
  }
  if ((i5 | 0) == 17) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 171 + i14 >> 0] | 0)) {
   HEAP32[i4 >> 2] = i14;
   __Z6FormatPKcz(i10, gb + 410819 | 0, i4);
   if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 410682 | 0, 460, 1, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i1 = 0;
   break;
  }
  if ((i3 | 0) == -1) if (!(i1 & 1)) i6 = 1; else {
   i6 = __Z25GetNextAllowedTextureSizeib13TextureFormat(i12, 1, i14) | 0;
   i6 = __Z22CalculateMipMapCount3Diii(i6, __Z25GetNextAllowedTextureSizeib13TextureFormat(i13, 1, i14) | 0, 1) | 0;
  } else i6 = i3;
  i5 = i14 | 1;
  do if ((i5 | 0) == 29) {
   i4 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (!(i1 & 1)) i3 = __Z18CalculateImageSizeii13TextureFormat(i12, i13, i14) | 0; else i3 = __Z24CalculateImageMipMapSizeii13TextureFormat(i12, i13, i14) | 0;
   i2 = Math_imul(i3, i15) | 0;
   if (!i3) i4 = 0; else if (((i2 >>> 0) / (i3 >>> 0) | 0 | 0) == (i15 | 0)) i4 = i3; else {
    i1 = 0;
    break L1;
   }
   if (i7 | (i5 + -25 | 0) >>> 0 < 5) i3 = 0; else {
    i3 = i14 + -30 | 0;
    if (i3 >>> 0 < 15) {
     if ((i14 + -48 | 0) >>> 0 < 12 | ((i14 + -45 | 0) >>> 0 < 3 | (30847 >>> (i3 & 65535) & 1) != 0)) {
      i3 = 0;
      break;
     }
    } else if ((i14 + -45 | 0) >>> 0 < 3 | (i14 + -48 | 0) >>> 0 < 12) {
     i3 = 0;
     break;
    }
    i3 = HEAP32[gb + 45784 + (i14 << 2) >> 2] | 0;
   }
  } while (0);
  if ((i3 + i2 | 0) >>> 0 < i2 >>> 0) i1 = 0; else {
   if (i8) {
    i7 = __Z12GetGfxDevicev() | 0;
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 428 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i11 + 48 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    mftCall_viiii(i5 | 0, i7 | 0, i10 | 0, i8 | 0, 2);
    i1 = i1 | 16;
   }
   __ZN9Texture2D19InitTextureInternalEii13TextureFormatiNS_10EInitFlagsEii(i11, i12, i13, i14, i4, i1, i15, i6);
   i1 = 1;
  }
 } while (0);
 if (!i16) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN15DirectorManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN15DirectorManager32StopScheduledPlayableControllersEv(i8);
 __ZN15DirectorManager12CleanupClassEv(0);
 i1 = i8 + 444 | 0;
 if ((HEAP32[i8 + 460 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 448 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 420 | 0;
 if ((HEAP32[i8 + 436 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 424 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i8 + 404 | 0, HEAP32[i8 + 408 >> 2] | 0);
 i1 = i8 + 384 | 0;
 if ((HEAP32[i8 + 400 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 364 | 0;
 if ((HEAP32[i8 + 380 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 368 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i6 = i8 + 280 | 0;
 i7 = i8 + 364 | 0;
 do {
  i2 = i7;
  i7 = i7 + -12 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i5 = i2 + -8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i3 = i2 + -24 | 0;
     HEAP32[i5 >> 2] = i3;
     i4 = i2 + -20 | 0;
     if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
      HEAP32[i4 >> 2] = 0;
      i2 = HEAP32[i5 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 } while ((i7 | 0) != (i6 | 0));
 i1 = i8 + 260 | 0;
 if ((HEAP32[i8 + 276 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 264 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 240 | 0;
 if ((HEAP32[i8 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 220 | 0;
 if ((HEAP32[i8 + 236 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 224 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 200 | 0;
 if ((HEAP32[i8 + 216 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 204 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 180 | 0;
 if ((HEAP32[i8 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 160 | 0;
 if ((HEAP32[i8 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 140 | 0;
 if ((HEAP32[i8 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 120 | 0;
 if ((HEAP32[i8 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 100 | 0;
 if ((HEAP32[i8 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 80 | 0;
 if ((HEAP32[i8 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 60 | 0;
 if ((HEAP32[i8 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 40 | 0;
 if ((HEAP32[i8 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 20 | 0;
 if ((HEAP32[i8 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i8 + 4 | 0);
 HEAP32[i8 >> 2] = 0;
 return;
}

function __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext(i8, i9, i10, i11, i1, i12) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i3 = i8 + 64 | 0;
 i5 = i2 + 2212 | 0;
 i6 = i3;
 i7 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i4 = i8 + 128 | 0;
 i5 = i2 + 2276 | 0;
 i6 = i4;
 i7 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i1 = i8 + 192 | 0;
 i5 = i2 + 2340 | 0;
 i6 = i1;
 i7 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i19 = i10 + 4 | 0;
 i21 = HEAP32[i19 >> 2] | 0;
 i5 = i10 + 8 | 0;
 i20 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i2 + 820 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 824 >> 2] = i21;
 HEAP32[i2 + 828 >> 2] = i20;
 HEAP32[i2 + 832 >> 2] = i7;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i2 + 836 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i2 + 840 >> 2] = i5;
 HEAP32[i2 + 844 >> 2] = i6;
 HEAP32[i2 + 848 >> 2] = i7;
 i7 = i2 + 852 | 0;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i7 = i11 + 16 | 0;
 i6 = i2 + 868 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i6 = i11 + 32 | 0;
 i7 = i2 + 884 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i7 = i11 + 48 | 0;
 i6 = i2 + 900 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i6 = HEAP32[i11 + 28 >> 2] | 0;
 i7 = HEAP32[i11 + 44 >> 2] | 0;
 i10 = HEAP32[i11 + 60 >> 2] | 0;
 HEAP32[i2 + 916 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i2 + 920 >> 2] = i6;
 HEAP32[i2 + 924 >> 2] = i7;
 HEAP32[i2 + 928 >> 2] = i10;
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f18 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f18 * f18)))) + Math_fround(9.99999997e-07));
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 68 >> 2]);
 f15 = Math_fround(HEAPF32[i8 + 72 >> 2]);
 f15 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f15 * f15)))) + Math_fround(9.99999997e-07));
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 132 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 136 >> 2]);
 f14 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) + Math_fround(f14 * f14)))) + Math_fround(9.99999997e-07));
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 196 >> 2]);
 f13 = Math_fround(HEAPF32[i8 + 200 >> 2]);
 f15 = Math_fround(f18 / f15);
 f14 = Math_fround(f18 / f14);
 f13 = Math_fround(f18 / Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f13 * f13)))) + Math_fround(9.99999997e-07)));
 HEAPF32[i2 + 932 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 936 >> 2] = f15;
 HEAPF32[i2 + 940 >> 2] = f14;
 HEAPF32[i2 + 944 >> 2] = f13;
 i12 = i12 + 4 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i9 | 0) > 1 ? i11 & -1025 : i11 | 1024;
 return;
}

function __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript(i12, i1, i6, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i7 = i13 + 56 | 0;
 i8 = i13 + 40 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13 + 24 | 0;
 if (HEAP32[i12 + 20 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 56 >> 2] | 0, i12 | 0, 0);
 i4 = i12 + 60 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i12 + 56 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  __ZNK15MonoScriptCache7ReleaseEv(i2);
  HEAP32[i5 >> 2] = 0;
 }
 do if (!i3) if (!i1) {
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(0, 2, i12, 0) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i1, 2, i12, 0) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = HEAPU8[i3 + 140 >> 0] | 0;
  i2 = __ZN10MonoScript8GetClassEv(i3) | 0;
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i2, i1, i12, HEAP32[i3 + 64 >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i1;
 } while (0);
 __ZNK15MonoScriptCache6RetainEv(i1);
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0;
 if (__Z14IsWorldPlayingv() | 0) if (!(__Z17IsValidScriptType14MonoScriptType(i1) | 0)) {
  __ZN13MonoBehaviour22GetScriptFullClassNameEv(i10, i12);
  i3 = i10 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i15 = i2 << 24 >> 24 < 0;
  i14 = i15 ? HEAP32[i10 >> 2] | 0 : i10;
  i2 = i15 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i14, i2);
  __Z21FormatScriptTypeError14MonoScriptTypeRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i1, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 587199 | 0, 1526, 512, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i15 = HEAP32[i10 >> 2] | 0;
   i14 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 66;
   HEAP32[i7 + 4 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i7);
  }
 }
 if (!(__Z17IsValidScriptType14MonoScriptType(i1) | 0)) {
  STACKTOP = i13;
  return;
 }
 if (i1 | 0) if (HEAP32[i12 + 28 >> 2] | 0) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i4 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 if (i6 | 0) {
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i6, i12) | 0;
  STACKTOP = i13;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 if (!(__Z64scripting_unity_engine_object_new_and_invoke_default_constructorP11Il2CppClassP6ObjectPP15Il2CppException(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i12, i7) | 0)) {
  if (__Z14IsWorldPlayingv() | 0) {
   __ZN13MonoBehaviour22GetScriptFullClassNameEv(i8, i12);
   i15 = i8 + 11 | 0;
   HEAP32[i11 >> 2] = (HEAP8[i15 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   __Z6FormatPKcz(i9, gb + 587932 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 587199 | 0, 1560, 512, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i15 = HEAP32[i8 >> 2] | 0;
    i14 = HEAP32[i8 + 12 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i11 + 4 >> 2] = i14;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i11);
   }
  }
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i1, HEAP32[i12 + 4 >> 2] | 0, 0);
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_(i16, i17, i14, i4, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i15 = __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_(i16, i17, i14, i1) | 0;
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i4 + 12 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i14 >> 2]);
 i1 = i14 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i17 = i15;
  return i17 | 0;
 }
 i9 = i14 + 4 | 0;
 i20 = HEAP32[i9 >> 2] | 0;
 i10 = i14 + 8 | 0;
 i19 = HEAP32[i10 >> 2] | 0;
 i11 = i14 + 16 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i14 + 20 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i13 = i14 + 24 | 0;
 i7 = i13;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i14 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i4 + 4 >> 2] = i20;
 HEAP32[i4 + 8 >> 2] = i19;
 HEAPF32[i4 + 12 >> 2] = f3;
 HEAP32[i4 + 16 >> 2] = i5;
 HEAP32[i4 + 20 >> 2] = i8;
 i8 = i4 + 24 | 0;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i7;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 >> 2]);
 i1 = i17 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i20 = i15 + 1 | 0;
  return i20 | 0;
 }
 i4 = i17 + 4 | 0;
 i24 = HEAP32[i4 >> 2] | 0;
 i5 = i17 + 8 | 0;
 i23 = HEAP32[i5 >> 2] | 0;
 i6 = i17 + 16 | 0;
 i22 = HEAP32[i6 >> 2] | 0;
 i7 = i17 + 20 | 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i8 = i17 + 24 | 0;
 i19 = i8;
 i21 = HEAP32[i19 >> 2] | 0;
 i19 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
 HEAPF32[i14 >> 2] = f2;
 HEAP32[i9 >> 2] = i24;
 HEAP32[i10 >> 2] = i23;
 HEAPF32[i14 + 12 >> 2] = f3;
 HEAP32[i11 >> 2] = i22;
 HEAP32[i12 >> 2] = i20;
 i20 = i13;
 HEAP32[i20 >> 2] = i21;
 HEAP32[i20 + 4 >> 2] = i19;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i24 = i15 + 2 | 0;
  return i24 | 0;
 }
 i19 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = HEAP32[i16 + 8 >> 2] | 0;
 i21 = HEAP32[i16 + 16 >> 2] | 0;
 i24 = HEAP32[i16 + 20 >> 2] | 0;
 i23 = i16 + 24 | 0;
 i22 = HEAP32[i23 >> 2] | 0;
 i23 = HEAP32[i23 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
 HEAP32[i16 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
 HEAPF32[i17 >> 2] = f2;
 HEAP32[i4 >> 2] = i19;
 HEAP32[i5 >> 2] = i20;
 HEAPF32[i17 + 12 >> 2] = f3;
 HEAP32[i6 >> 2] = i21;
 HEAP32[i7 >> 2] = i24;
 i24 = i8;
 HEAP32[i24 >> 2] = i22;
 HEAP32[i24 + 4 >> 2] = i23;
 i24 = i15 + 3 | 0;
 return i24 | 0;
}

function __ZN8VRDevice39UpdateTrackedDevicesAndCameraTransformsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i1 = HEAP32[i8 + 280 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 __ZN7VRInput20UpdateTrackedDevicesEv(i1);
 i7 = __Z16GetRenderManagerv() | 0;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i7 = i7 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  do if (i6 | 0) {
   HEAP32[i10 >> 2] = i6;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i5 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i5 = HEAP32[i9 >> 2] | 0;
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
     i1 = i4;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i5 | 0) == (i3 + (i4 << 3) | 0)) i11 = 10; else if (!(HEAP32[i5 + 4 >> 2] | 0)) i11 = 12;
   }
   if ((i11 | 0) == 10) i11 = 12;
   if ((i11 | 0) == 12) {
    i11 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   HEAP32[i10 >> 2] = i6;
   if (!i1) i11 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 21;
    }
   }
   if ((i11 | 0) == 19) i11 = 21;
   if ((i11 | 0) == 21) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
   }
   if (HEAP32[i1 + 824 >> 2] | 0) if (__Z23IsWorldPlayingThisFramev() | 0) {
    HEAP32[i10 >> 2] = i6;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 29; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i5 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 29; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 31;
     }
    }
    if ((i11 | 0) == 29) i11 = 31;
    if ((i11 | 0) == 31) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
    }
    __ZN8VRDevice21UpdateCameraTransformERK6Camera(i8, i1);
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 STACKTOP = i12;
 return;
}

function __ZN12HingeJoint2D6CreateEv(i10) {
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i7 = i12;
 i2 = HEAP32[i10 + 28 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i10 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 do if (i2 | 0) {
  HEAP32[i7 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i9 = 9; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i6 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i7);
    i6 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i6 = (i6 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i6 << 3) | 0;
    i2 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i6 | 0) == (i3 + (i4 << 3) | 0)) i9 = 9; else if (!(HEAP32[i6 + 4 >> 2] | 0)) i9 = 11;
  }
  if ((i9 | 0) == 9) i9 = 11;
  if ((i9 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) break;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  if (!i2) i9 = 18; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i7);
    i3 = HEAP32[i11 >> 2] | 0;
    i7 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 18; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i9 = 20;
   }
  }
  if ((i9 | 0) == 18) i9 = 20;
  if ((i9 | 0) == 20) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  i2 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i2) {
   STACKTOP = i12;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
   STACKTOP = i12;
   return;
  }
 } while (0);
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i11 >> 2] = 1;
 i4 = i11 + 20 | 0;
 i2 = i11 + 44 | 0;
 i3 = i11 + 48 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = HEAP32[i10 + 112 >> 2] | 0;
 HEAP8[i11 + 52 >> 0] = i4;
 HEAP8[i11 + 40 >> 0] = (i4 & 65535) >>> 8;
 HEAPF32[i11 + 56 >> 2] = Math_fround(Math_fround(HEAPF32[i10 + 96 >> 2]) * Math_fround(.0174532924));
 HEAP32[i11 + 60 >> 2] = HEAP32[i10 + 100 >> 2];
 f1 = Math_fround(Math_fround(HEAPF32[i10 + 104 >> 2]) * Math_fround(.0174532924));
 HEAPF32[i2 >> 2] = f1;
 f5 = Math_fround(Math_fround(HEAPF32[i10 + 108 >> 2]) * Math_fround(.0174532924));
 HEAPF32[i3 >> 2] = f5;
 if (f1 > f5) {
  HEAPF32[i2 >> 2] = f5;
  HEAPF32[i3 >> 2] = f1;
 }
 if (!(i4 & 16711680)) {
  f1 = Math_fround(HEAPF32[(__ZNK7Joint2D10FetchBodyBEv(i10) | 0) + 56 >> 2]);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[(__ZNK7Joint2D10FetchBodyAEv(i10) | 0) + 56 >> 2]));
 } else f1 = Math_fround(HEAPF32[i10 + 116 >> 2]);
 HEAPF32[i11 + 36 >> 2] = f1;
 __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i10, i11 + 20 | 0, i11 + 28 | 0);
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i10, i11);
 STACKTOP = i12;
 return;
}

function __ZN10GameObject18TransferComponentsI14SafeBinaryReadEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17 + 8 | 0;
 i1 = i17;
 i16 = i17 + 16 | 0;
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i4, 4) | 0)) {
  if (HEAP32[i4 >> 2] & 16384 | 0) {
   STACKTOP = i17;
   return;
  }
  i2 = i5 + 28 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 368714 | 0, HEAP32[gb + 37316 >> 2] | 0, i3, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN10GameObject13ComponentPairELj4EEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i4);
  }
  STACKTOP = i17;
  return;
 }
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i1;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i16 >> 2] = 0;
 i13 = i16 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i16 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i11 = i3;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i15;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 368714 | 0, HEAP32[gb + 37316 >> 2] | 0, i3, 1) | 0;
 if (!i1) i2 = 0; else {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEELj4EEEEvRT_17TransferMetaFlags(i4, i16, 0); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i16 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i11 = i5 + 28 | 0;
 i12 = i5 + 44 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i12 >> 2] = i2;
  HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 << 3, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i5 + 40 >> 2] << 3 | 0) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i11 >> 2] = i10;
  break;
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i16 >> 2] | 0;
  i10 = i5 + 40 | 0;
  i9 = i5 + 32 | 0;
  i8 = i2;
  do {
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   if (i3) {
    i7 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    i4 = i2 + 1 | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i12 >> 2] = i1;
      HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 3, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i11 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    HEAP32[i1 + (i2 << 3) >> 2] = i7;
    HEAP32[i1 + (i2 << 3) + 4 >> 2] = i3;
    i2 = HEAP32[i16 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
   }
   i8 = i8 + 8 | 0;
  } while ((i8 | 0) != (i2 + (i1 << 3) | 0));
 }
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i15);
  HEAP32[i16 >> 2] = 0;
 }
 STACKTOP = i17;
 return;
}

function __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE13set_empty_keyERSF_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 24 | 0;
 i14 = i17;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i15 = i14 + 12 | 0;
 HEAP32[i15 >> 2] = i2;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
   i1 = HEAP32[i15 >> 2] | 0;
   i16 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i14 + 11 >> 0] = i4;
   if (!i4) i1 = i14; else {
    i1 = i14;
    i16 = 8;
   }
  } else {
   i1 = i2;
   i16 = 6;
  }
  if ((i16 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i13 >> 2] = 54;
   HEAP32[i13 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i14 + 4 >> 2] = i4;
   i16 = 8;
  }
  if ((i16 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
 } else {
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP8[i5 + 9 >> 0] = 1;
 i7 = i5 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i5, i7, i14);
 i8 = i5 + 56 | 0;
 i1 = (HEAP32[i8 >> 2] | 0) * 20 | 0;
 i12 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i13 >> 2] = 54;
 HEAP32[i13 + 4 >> 2] = i12;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 52 >> 2] = i1;
 i8 = i1 + ((HEAP32[i8 >> 2] | 0) * 20 | 0) | 0;
 if ((i1 | 0) != (i8 | 0)) {
  i9 = i5 + 44 | 0;
  i10 = i7 + 11 | 0;
  i11 = i5 + 36 | 0;
  i12 = i13 + 4 | 0;
  i6 = i5 + 48 | 0;
  do {
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = i2;
   if ((HEAP8[i10 >> 0] | 0) < 0) {
    i4 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i11 >> 2] | 0;
    if (i5 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
     i2 = HEAP32[i3 >> 2] | 0;
     i16 = 17;
    } else if (i5 >>> 0 < 11) {
     HEAP8[i1 + 11 >> 0] = i5;
     if (!i5) i2 = i1; else {
      i2 = i1;
      i16 = 19;
     }
    } else i16 = 17;
    if ((i16 | 0) == 17) {
     i3 = i5 + 16 & -16;
     HEAP32[i13 >> 2] = 54;
     HEAP32[i12 >> 2] = i2;
     i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i1 >> 2] = i2;
     HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
     HEAP32[i1 + 4 >> 2] = i5;
     i16 = 19;
    }
    if ((i16 | 0) == 19) {
     i16 = 0;
     _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
    }
    HEAP8[i2 + i5 >> 0] = 0;
   } else {
    HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   }
   HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 if ((HEAP8[i14 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i17;
  return;
 }
 i16 = HEAP32[i14 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = 54;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i13);
 STACKTOP = i17;
 return;
}

function runPostSets207() {
 HEAP32[gb + 175868 >> 2] = fb + 5;
 HEAP32[gb + 175872 >> 2] = fb + 22;
 HEAP32[gb + 175876 >> 2] = fb + 50;
 HEAP32[gb + 175880 >> 2] = fb + 23;
 HEAP32[gb + 175884 >> 2] = fb + 1;
 HEAP32[gb + 175888 >> 2] = fb + 33;
 HEAP32[gb + 175892 >> 2] = fb + 34;
 HEAP32[gb + 175896 >> 2] = fb + 35;
 HEAP32[gb + 175900 >> 2] = fb + 51;
 HEAP32[gb + 175904 >> 2] = fb + 28;
 HEAP32[gb + 175908 >> 2] = fb + 29;
 HEAP32[gb + 175912 >> 2] = fb + 52;
 HEAP32[gb + 175916 >> 2] = fb + 53;
 HEAP32[gb + 175920 >> 2] = fb + 59;
 HEAP32[gb + 175932 >> 2] = fb + 266;
 HEAP32[gb + 175936 >> 2] = fb + 2028;
 HEAP32[gb + 175948 >> 2] = fb + 2029;
 HEAP32[gb + 175952 >> 2] = fb + 2030;
 HEAP32[gb + 175956 >> 2] = fb + 2707;
 HEAP32[gb + 175960 >> 2] = fb + 2708;
 HEAP32[gb + 175964 >> 2] = fb + 2709;
 HEAP32[gb + 175968 >> 2] = fb + 2710;
 HEAP32[gb + 175972 >> 2] = fb + 2711;
 HEAP32[gb + 175976 >> 2] = fb + 2712;
 HEAP32[gb + 175980 >> 2] = fb + 2713;
 HEAP32[gb + 175984 >> 2] = fb + 91;
 HEAP32[gb + 175988 >> 2] = fb + 434;
 HEAP32[gb + 175992 >> 2] = fb + 435;
 HEAP32[gb + 175996 >> 2] = fb + 436;
 HEAP32[gb + 176e3 >> 2] = fb + 2031;
 HEAP32[gb + 176004 >> 2] = fb + 437;
 HEAP32[gb + 176008 >> 2] = fb + 448;
 HEAP32[gb + 176012 >> 2] = fb + 2032;
 HEAP32[gb + 176016 >> 2] = fb + 88;
 HEAP32[gb + 176020 >> 2] = fb + 2033;
 HEAP32[gb + 176024 >> 2] = fb + 2034;
 HEAP32[gb + 176028 >> 2] = fb + 438;
 HEAP32[gb + 176032 >> 2] = fb + 2035;
 HEAP32[gb + 176036 >> 2] = fb + 1246;
 HEAP32[gb + 176040 >> 2] = fb + 1247;
 HEAP32[gb + 176052 >> 2] = fb + 2714;
 HEAP32[gb + 176056 >> 2] = fb + 2715;
 HEAP32[gb + 176060 >> 2] = fb + 2716;
 HEAP32[gb + 176064 >> 2] = fb + 2036;
 HEAP32[gb + 176068 >> 2] = fb + 16;
 HEAP32[gb + 176072 >> 2] = fb + 93;
 HEAP32[gb + 176076 >> 2] = fb + 40;
 HEAP32[gb + 176080 >> 2] = fb + 19;
 HEAP32[gb + 176084 >> 2] = fb + 1248;
 HEAP32[gb + 176088 >> 2] = fb + 103;
 HEAP32[gb + 176092 >> 2] = fb + 101;
 HEAP32[gb + 176096 >> 2] = fb + 62;
 HEAP32[gb + 176100 >> 2] = fb + 28;
 HEAP32[gb + 176104 >> 2] = fb + 63;
 HEAP32[gb + 176108 >> 2] = fb + 29;
 HEAP32[gb + 176112 >> 2] = fb + 34;
 HEAP32[gb + 176116 >> 2] = fb + 2037;
 HEAP32[gb + 176120 >> 2] = fb + 2038;
 HEAP32[gb + 176124 >> 2] = fb + 2039;
 HEAP32[gb + 176128 >> 2] = fb + 2040;
 HEAP32[gb + 176132 >> 2] = fb + 2041;
 HEAP32[gb + 176136 >> 2] = fb + 2042;
 HEAP32[gb + 176140 >> 2] = fb + 36;
 HEAP32[gb + 176144 >> 2] = fb + 104;
 HEAP32[gb + 176148 >> 2] = fb + 108;
 HEAP32[gb + 176152 >> 2] = fb + 94;
 HEAP32[gb + 176156 >> 2] = fb + 2043;
 HEAP32[gb + 176160 >> 2] = fb + 112;
 HEAP32[gb + 176164 >> 2] = fb + 113;
 HEAP32[gb + 176168 >> 2] = fb + 131;
 HEAP32[gb + 176172 >> 2] = fb + 111;
 HEAP32[gb + 176176 >> 2] = fb + 112;
 HEAP32[gb + 176180 >> 2] = fb + 113;
 HEAP32[gb + 176184 >> 2] = fb + 2717;
 HEAP32[gb + 176188 >> 2] = fb + 2718;
 HEAP32[gb + 176200 >> 2] = (HEAP32[gb + 176200 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 176204 >> 2] = (HEAP32[gb + 176204 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 176232 >> 2] = (HEAP32[gb + 176232 >> 2] | 0) + (gb + 896479 | 0);
 HEAP32[gb + 176236 >> 2] = (HEAP32[gb + 176236 >> 2] | 0) + (gb + 897740 | 0);
 HEAP32[gb + 176248 >> 2] = fb + 2719;
 HEAP32[gb + 176252 >> 2] = fb + 2720;
 HEAP32[gb + 176256 >> 2] = fb + 2721;
 HEAP32[gb + 176260 >> 2] = fb + 2044;
 HEAP32[gb + 176264 >> 2] = fb + 16;
 HEAP32[gb + 176268 >> 2] = fb + 2722;
 HEAP32[gb + 176272 >> 2] = fb + 40;
 HEAP32[gb + 176276 >> 2] = fb + 19;
 HEAP32[gb + 176280 >> 2] = fb + 1249;
 HEAP32[gb + 176284 >> 2] = fb + 31;
 HEAP32[gb + 176288 >> 2] = fb + 2045;
 HEAP32[gb + 176292 >> 2] = fb + 62;
 HEAP32[gb + 176296 >> 2] = fb + 28;
 HEAP32[gb + 176300 >> 2] = fb + 63;
 HEAP32[gb + 176304 >> 2] = fb + 29;
 HEAP32[gb + 176308 >> 2] = fb + 34;
 HEAP32[gb + 176312 >> 2] = fb + 2046;
 HEAP32[gb + 176316 >> 2] = fb + 2047;
 HEAP32[gb + 176320 >> 2] = fb + 2048;
 HEAP32[gb + 176324 >> 2] = fb + 2049;
 HEAP32[gb + 176328 >> 2] = fb + 2050;
 runPostSets208();
}

function __ZN16ReflectionProbes9GetCameraEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i9 + 12 | 0;
 i6 = i9 + 8 | 0;
 i7 = i1 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (!i1) i8 = 10; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) i8 = 10;
 } while (0);
 if ((i8 | 0) == 10) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 383730 | 0, 24);
  HEAP32[i4 >> 2] = 0;
  i1 = __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz(i5, 1, 61, gb + 1044265 | 0, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 29832 | 0) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 19;
   }
  }
  if ((i8 | 0) == 17) i8 = 19;
  if ((i8 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 0);
 }
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 26; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 26; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i10 = i1;
    STACKTOP = i9;
    return i10 | 0;
   }
  }
 }
 i10 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034504 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034510 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN9ShaderLab16SerializedShader8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i1 = i8;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470530 | 0, gb + 470541 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470562 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab18SerializedPropertyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i5, 0); else {
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i7);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 12 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470570 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 24 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034561 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470583 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470602 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470499 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470617 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __Z16RemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 24 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i1);
 i6 = i11 + 11 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
 i7 = i11 + 4 | 0;
 i5 = i2 ? HEAP32[i7 >> 2] | 0 : i5 & 255;
 i2 = i1 + i5 | 0;
 if (i5 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i11, 0, 4, gb + 488815 | 0) | 0)) {
  i5 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i11, 4, 4, gb + 488820 | 0) | 0) == 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
  } else {
   i2 = i1 & 255;
   i4 = i11;
  }
  if (i2 >>> 0 < 5) i1 = 2; else {
   i1 = i4 + 4 | 0;
   i3 = i4 + i2 | 0;
   i2 = i3;
   L16 : do if ((i2 - i1 | 0) < 1) i1 = i2; else while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 58) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i1 = i2;
     break L16;
    }
   } while (0);
   i1 = (i1 | 0) == (i3 | 0) | (i1 - i4 | 0) == -1 ? 2 : 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i11);
  i5 = __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i8, i5 ? 9 : 5, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i11, 0, i5 + -1 | 0) | 0;
 }
 if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i11, 0, 4, gb + 488825 | 0) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i11);
  i8 = __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i9, 5, 1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i11, 0, i8 + -1 | 0) | 0;
 }
 i1 = HEAP8[i6 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i2 = i1 & 255;
  i1 = i11;
 }
 if (i2 >>> 0 >= 2) {
  i6 = i1 + i2 | 0;
  i5 = i6;
  i7 = i1;
  L33 : do if ((i2 | 0) < 2) i1 = i5; else {
   i4 = i6 + -1 | 0;
   if ((i4 | 0) == (i1 | 0)) i1 = i5; else L35 : while (1) {
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) == 47) {
      i2 = gb + 488812 | 0;
      i3 = i1;
      break;
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i4 | 0)) {
      i1 = i5;
      break L33;
     }
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (gb + 488812 + 2 | 0)) break L35;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i5;
     break L33;
    }
   }
  } while (0);
  if ((i1 | 0) == (i7 | 0) & (i1 | 0) != (i6 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i11);
   i9 = __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i10, 3, 2) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i11, 0, i9 + -1 | 0) | 0;
  }
 }
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i11, 58, 0) | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i12;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i11, 0, i1 + 1 | 0) | 0;
 STACKTOP = i12;
 return;
}

function __ZN17ProceduralTexture24AcquireSharedTextureDataEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 i9 = i12;
 i4 = i5 + 80 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i8);
   i2 = HEAP32[i10 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 8;
  }
 }
 if ((i11 | 0) == 6) i11 = 8;
 if ((i11 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = __ZN18ProceduralMaterial22CloneMaterialForExportEbb(i1, 1, 1) | 0;
 i5 = HEAP32[i5 + 192 + 4 >> 2] | 0;
 i1 = HEAP32[i7 + 124 >> 2] | 0;
 i6 = i7 + 128 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i11 = 0;
  __Z19DestroySingleObjectP6Object(i7);
  STACKTOP = i12;
  return i11 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i8 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i11 = 18; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i8);
     i3 = HEAP32[i10 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 18; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i11 = 20;
    }
   }
   if ((i11 | 0) == 18) i11 = 20;
   if ((i11 | 0) == 20) {
    i11 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
   }
  }
  i1 = i1 + 4 | 0;
  if ((HEAP32[i2 + 192 + 4 >> 2] | 0) == (i5 | 0)) break;
  if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
   i1 = 0;
   i11 = 24;
   break;
  }
 }
 if ((i11 | 0) == 24) {
  __Z19DestroySingleObjectP6Object(i7);
  STACKTOP = i12;
  return i1 | 0;
 }
 i6 = i2 + 104 | 0;
 i8 = i2 + 108 | 0;
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i8 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0, 16, gb + 63272 | 0, 1, gb + 431386 | 0, 409) | 0;
 i13 = HEAP32[i6 >> 2] | 0;
 _memcpy(i11 | 0, i13 | 0, (HEAP32[i8 >> 2] | 0) - i13 | 0) | 0;
 i13 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 431386 | 0, 414) | 0;
 i3 = gb + 63272 | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = HEAP32[i2 + 128 >> 2] | 0;
 i5 = HEAP32[i2 + 132 >> 2] | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 i8 = HEAP32[i2 + 136 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibPv(i13, i10, i4, i5, 4, i6, 1, i8, 1, i11);
 i11 = i13 + 24 | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & 2147483647;
 __Z19DestroySingleObjectP6Object(i7);
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN7mecanim12statemachine17ConditionConstant8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903131 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903147 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903157 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 903174 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx2Gu18ConvexHullNoScaleV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(i6, i11, i15, i14) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 76 | 0;
 i13 = i16 + 64 | 0;
 i10 = i16 + 52 | 0;
 i9 = i16 + 40 | 0;
 i5 = i16;
 i4 = i16 + 28 | 0;
 i3 = i16 + 16 | 0;
 if (HEAP32[i6 + 196 >> 2] | 0) {
  i8 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i6, i11) | 0;
  f2 = Math_fround(HEAPF32[i11 >> 2]);
  i12 = i11 + 4 | 0;
  f17 = Math_fround(HEAPF32[i12 >> 2]);
  i13 = i11 + 8 | 0;
  f17 = Math_fround(-f17);
  f19 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
  HEAPF32[i5 >> 2] = Math_fround(-f2);
  HEAPF32[i5 + 4 >> 2] = f17;
  HEAPF32[i5 + 8 >> 2] = f19;
  HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
  i10 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i6, i5) | 0;
  i9 = HEAP32[i6 + 200 >> 2] | 0;
  f19 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) >> 2]);
  f17 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i9 + (i10 * 12 | 0) >> 2]);
  f20 = Math_fround(HEAPF32[i9 + (i10 * 12 | 0) + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i9 + (i10 * 12 | 0) + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i11 >> 2]);
  f1 = Math_fround(HEAPF32[i12 >> 2]);
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f1)) + Math_fround(f18 * Math_fround(HEAPF32[i13 >> 2])));
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  f18 = Math_fround(HEAPF32[i11 >> 2]);
  f1 = Math_fround(HEAPF32[i12 >> 2]);
  HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * f1)) + Math_fround(f2 * Math_fround(HEAPF32[i13 >> 2])));
  i15 = i14 + 4 | 0;
  HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i16;
  return;
 }
 i5 = i6 + 200 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 f21 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i11 >> 2]);
 i7 = i11 + 4 | 0;
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i11 + 8 | 0;
 f1 = Math_fround(Math_fround(Math_fround(f19 * f20) + Math_fround(f21 * f22)) + Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2])));
 i4 = i6 + 204 | 0;
 if ((HEAPU8[i4 >> 0] | 0) > 1) {
  f2 = f1;
  i3 = 1;
  do {
   i6 = HEAP32[i5 >> 2] | 0;
   f18 = Math_fround(HEAPF32[i6 + (i3 * 12 | 0) >> 2]);
   f20 = Math_fround(HEAPF32[i6 + (i3 * 12 | 0) + 4 >> 2]);
   f22 = Math_fround(HEAPF32[i6 + (i3 * 12 | 0) + 8 >> 2]);
   f19 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(HEAPF32[i7 >> 2]);
   f22 = Math_fround(Math_fround(Math_fround(f18 * f19) + Math_fround(f20 * f21)) + Math_fround(f22 * Math_fround(HEAPF32[i8 >> 2])));
   f1 = f22 > f1 ? f22 : f1;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   f2 = f22 > f2 ? f2 : f22;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAPU8[i4 >> 0] | 0) >>> 0);
 } else f2 = f1;
 HEAPF32[i15 >> 2] = f2;
 i15 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAPF32[i14 >> 2] = f1;
 i15 = i14 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 STACKTOP = i16;
 return;
}

function __ZN22UnityProfilerPerThreadD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i8 + 160 | 0;
 i6 = i8 + 168 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i1 = HEAP32[i8 + 164 >> 2] | 0;
  i4 = i1;
  if ((i4 | 0) != (i7 | 0)) {
   i2 = i4;
   do {
    i3 = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 8 >> 2] | 0, i3 + 20 | 0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i7 | 0));
   i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
   i2 = i8 + 172 | 0;
   i3 = i5 + 4 | 0;
   i1 = i4;
   do {
    i4 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    i10 = HEAP32[i2 >> 2] | 0;
    HEAP32[i5 >> 2] = 72;
    HEAP32[i3 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
   } while ((i1 | 0) != (i7 | 0));
  }
 }
 i3 = i8 + 188 | 0;
 i4 = i8 + 192 | 0;
 __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3, HEAP32[i4 >> 2] | 0);
 HEAP32[i8 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 i5 = i8 + 204 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i8 + 208 | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i2 = i1;
  while (1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63576 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5, HEAP32[i6 >> 2] | 0);
 HEAP32[i8 + 216 >> 2] = 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5, 0);
 __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3, HEAP32[i4 >> 2] | 0);
 __ZN22ForwardLinearAllocatorD2Ev(i7);
 i1 = i8 + 136 | 0;
 if ((HEAP32[i8 + 152 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 140 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 116 | 0;
 if ((HEAP32[i8 + 132 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 120 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 96 | 0;
 if ((HEAP32[i8 + 112 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 100 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 76 | 0;
 if ((HEAP32[i8 + 92 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 80 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 56 | 0;
 if ((HEAP32[i8 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 36 | 0;
 if ((HEAP32[i8 + 52 >> 2] | 0) <= -1) {
  i10 = i8 + 4 | 0;
  __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EED2Ev(i10);
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 40 | 0);
 HEAP32[i1 >> 2] = 0;
 i10 = i8 + 4 | 0;
 __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EED2Ev(i10);
 STACKTOP = i9;
 return;
}

function _emit_dqt(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i7 + 72 + (i3 << 2) >> 2] | 0;
 if (!i8) {
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 52;
  HEAP32[i1 + 24 >> 2] = i3;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i7 | 0);
  i1 = 0;
  i6 = 0;
 } else {
  i1 = 0;
  i6 = 0;
 }
 do {
  i6 = (HEAPU16[i8 + (i1 << 1) >> 1] | 0) > 255 ? 1 : i6;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 i4 = i8 + 128 | 0;
 if (HEAP8[i4 >> 0] | 0) return i6 | 0;
 i5 = i7 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = -1;
 i9 = i1 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i2;
 if (!i2) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i7 | 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP8[i2 >> 0] = -37;
 i2 = i1 + 4 | 0;
 i9 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i9;
 if (!i9) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i7 | 0);
 }
 i2 = (i6 | 0) != 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + 1;
 HEAP8[i10 >> 0] = 0;
 i10 = i1 + 4 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 HEAP32[i10 >> 2] = i9;
 if (!i9) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = i2 ? -125 : 67;
 i9 = i1 + 4 | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i10;
 if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = (i6 << 4) + i3;
 i9 = i1 + 4 | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i10;
 if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
 }
 if (i2) {
  i2 = 0;
  do {
   i3 = HEAP16[i8 + (HEAP32[gb + 15416 + (i2 << 2) >> 2] << 1) >> 1] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i9 + 1;
   HEAP8[i9 >> 0] = (i3 & 65535) >>> 8;
   i9 = i1 + 4 | 0;
   i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
   HEAP32[i9 >> 2] = i10;
   if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
    i10 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
   }
   i1 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i9 + 1;
   HEAP8[i9 >> 0] = i3;
   i9 = i1 + 4 | 0;
   i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
   HEAP32[i9 >> 2] = i10;
   if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
    i10 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 64);
 } else {
  i1 = 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP16[i8 + (HEAP32[gb + 15416 + (i1 << 2) >> 2] << 1) >> 1] & 255;
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i9 + 1;
   HEAP8[i9 >> 0] = i10;
   i9 = i2 + 4 | 0;
   i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
   HEAP32[i9 >> 2] = i10;
   if (!i10) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
    i10 = HEAP32[i7 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i10 >> 2] | 0, i7 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
 }
 HEAP8[i4 >> 0] = 1;
 return i6 | 0;
}

function __Z15tessMeshNewMeshP9TESSalloc(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 12 | 0;
 i11 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 144) | 0;
 if (!i11) {
  i11 = 0;
  return i11 | 0;
 }
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) < 16) {
  HEAP32[i1 >> 2] = 16;
  i2 = 16;
 } else if ((i2 | 0) > 4096) {
  HEAP32[i1 >> 2] = 4096;
  i2 = 4096;
 }
 i7 = i9 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 16) HEAP32[i7 >> 2] = 16; else if ((i1 | 0) > 4096) HEAP32[i7 >> 2] = 4096;
 i8 = i9 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) < 16) HEAP32[i8 >> 2] = 16; else if ((i1 | 0) > 4096) HEAP32[i8 >> 2] = 4096;
 i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 24) | 0;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 16 >> 2] = gb + 362989;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 64;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, i2 << 6 | 4 | 0) | 0;
 if (!i6) {
  mftCall_vii(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i1 | 0);
  i1 = 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i6;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i5 >> 2] | 0, i4) | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  do {
   i2 = i2 - i4 | 0;
   i5 = i3;
   i3 = i6 + i2 | 0;
   HEAP32[i3 >> 2] = i5;
  } while ((i2 | 0) != 4);
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i11 + 132 >> 2] = i1;
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 24) | 0;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 16 >> 2] = gb + 363e3;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 44;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, (i6 * 44 | 0) + 4 | 0) | 0;
 if (!i6) {
  mftCall_vii(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i1 | 0);
  i1 = 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i6;
  i5 = HEAP32[i2 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i4 >> 2] | 0, i5) | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  do {
   i2 = i2 - i5 | 0;
   i7 = i3;
   i3 = i6 + i2 | 0;
   HEAP32[i3 >> 2] = i7;
  } while ((i2 | 0) != 4);
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i11 + 136 >> 2] = i1;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, 24) | 0;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 16 >> 2] = gb + 363014;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 24;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, i6 * 24 | 4 | 0) | 0;
 if (!i6) {
  mftCall_vii(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i10 >> 2] | 0, i1 | 0);
  i1 = 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i6;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i5 >> 2] | 0, i4) | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  do {
   i2 = i2 - i4 | 0;
   i10 = i3;
   i3 = i6 + i2 | 0;
   HEAP32[i3 >> 2] = i10;
  } while ((i2 | 0) != 4);
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i11 + 140 >> 2] = i1;
 i8 = i11 + 44 | 0;
 i10 = i11 + 68 | 0;
 i9 = i11 + 100 | 0;
 HEAP32[i11 + 4 >> 2] = i11;
 HEAP32[i11 >> 2] = i11;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = i8;
 HEAP32[i8 >> 2] = i8;
 HEAP32[i11 + 52 >> 2] = 0;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP8[i11 + 64 >> 0] = 0;
 HEAP8[i11 + 65 >> 0] = 0;
 HEAP32[i10 >> 2] = i10;
 HEAP32[i11 + 72 >> 2] = i9;
 i8 = i11 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i9 >> 2] = i9;
 HEAP32[i11 + 104 >> 2] = i10;
 i10 = i11 + 108 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 return i11 | 0;
}

function __ZN22BaseUnityConnectClient22UpdateConfigFromServerEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i9 = i12 + 24 | 0;
 i10 = i12 + 8 | 0;
 i4 = i8 + 116 | 0;
 i7 = i4 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i8 + 120 >> 2] | 0; else i2 = i1 & 255;
 do if (!i2) {
  i5 = i8 + 588 | 0;
  i6 = HEAP8[i5 + 11 >> 0] | 0;
  i2 = i6 << 24 >> 24 < 0;
  i5 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i2 ? HEAP32[i8 + 592 >> 2] | 0 : i6 & 255;
  if (i3) i2 = (HEAP32[i8 + 124 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
  if (i6 >>> 0 > i2 >>> 0) {
   if (i3) i1 = HEAP32[i8 + 120 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i2, i6 - i2 | 0, i1, 0, i1, i6, i5);
   i1 = HEAP8[i7 >> 0] | 0;
   i5 = 20;
   break;
  }
  if (i3) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i8 + 120 >> 2] = i6;
   i2 = i10;
   i1 = i9;
   i5 = 21;
   break;
  } else {
   i1 = i6 & 255;
   HEAP8[i7 >> 0] = i1;
   i5 = 20;
   break;
  }
 } else i5 = 20; while (0);
 if ((i5 | 0) == 20) if (i1 << 24 >> 24 < 0) {
  i2 = i10;
  i1 = i9;
  i5 = 21;
 } else {
  i3 = i10;
  i1 = i9;
 }
 if ((i5 | 0) == 21) {
  i4 = HEAP32[i4 >> 2] | 0;
  i3 = i2;
 }
 i2 = i8 + 16 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = i2;
 __Z6FormatPKcz(i10, gb + 1040795 | 0, i11);
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i10 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i5 = 29;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i9 + 11 >> 0] = i4;
  if (i4) i5 = 31;
 } else {
  i1 = i2;
  i5 = 29;
 }
 if ((i5 | 0) == 29) {
  i7 = i4 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i4;
  i5 = 31;
 }
 if ((i5 | 0) == 31) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i7 = HEAP32[i8 + 280 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i10 + 11 | 0;
 HEAP8[i8 >> 0] = 6;
 HEAP8[i10 >> 0] = HEAP8[gb + 1040788 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[gb + 1040788 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[gb + 1040788 + 2 >> 0] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[gb + 1040788 + 3 >> 0] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[gb + 1040788 + 4 >> 0] | 0;
 HEAP8[i10 + 5 >> 0] = HEAP8[gb + 1040788 + 5 >> 0] | 0;
 HEAP8[i10 + 6 >> 0] = 0;
 __ZN19CloudServiceHandler18SaveFileFromServerERK8UnityStrS2_PN11UnityEngine15CloudWebService16WWWRestHeaderMapE(i7, i10, i9, 0) | 0;
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i8 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 }
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 STACKTOP = i12;
 return;
}

function __ZN19AssetBundleManifest18GetAllAssetBundlesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i4, i16) {
 i4 = i4 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i18 = i21 + 8 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i19 = i16 + 4 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i3 = i17 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i19 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i17 >> 2] = 66;
    HEAP32[i3 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i17);
    i1 = HEAP32[i19 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i15 = i4 + 56 | 0;
 if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
  i20 = i5;
  i19 = HEAP32[i16 >> 2] | 0;
  __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i19, i20, i17);
  STACKTOP = i21;
  return;
 }
 i7 = i18 + 12 | 0;
 i6 = i18 + 12 | 0;
 i8 = i17 + 4 | 0;
 i9 = i18 + 8 | 0;
 i10 = i18 + 4 | 0;
 i11 = i16 + 8 | 0;
 i12 = i18 + 11 | 0;
 i13 = i17 + 4 | 0;
 i14 = i17 + 4 | 0;
 i5 = i1;
 do {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i18 + 4 >> 2] = 0;
  HEAP32[i18 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = _strlen(i2) | 0;
  if (i3 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i18);
   i1 = HEAP32[i6 >> 2] | 0;
   i20 = 13;
  } else if (i3 >>> 0 < 11) {
   HEAP8[i12 >> 0] = i3;
   if (!i3) i1 = i18; else {
    i1 = i18;
    i20 = 15;
   }
  } else i20 = 13;
  if ((i20 | 0) == 13) {
   i4 = i3 + 16 & -16;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i8 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i18 >> 2] = i1;
   HEAP32[i9 >> 2] = i4 | -2147483648;
   HEAP32[i10 >> 2] = i3;
   i20 = 15;
  }
  if ((i20 | 0) == 15) {
   i20 = 0;
   _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  }
  HEAP8[i1 + i3 >> 0] = 0;
  i1 = HEAP32[i19 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i11 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i16, i18); else {
   i4 = HEAP8[i12 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i18 >> 2] | 0 : i18;
   i4 = i2 ? HEAP32[i10 >> 2] | 0 : i4 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i20 = 20;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i4;
    if (i4) i20 = 22;
   } else i20 = 20;
   if ((i20 | 0) == 20) {
    i22 = i4 + 16 & -16;
    HEAP32[i17 >> 2] = 66;
    HEAP32[i14 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i22, 16, i17, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = i22 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i2;
    i20 = 22;
   }
   if ((i20 | 0) == 22) {
    i20 = 0;
    _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i1 + i4 >> 0] = 0;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 16;
  }
  if ((HEAP8[i12 >> 0] | 0) < 0) {
   i22 = HEAP32[i18 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   HEAP32[i17 >> 2] = 66;
   HEAP32[i13 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i22, i17);
  }
  i5 = i5 + 8 | 0;
 } while ((i5 | 0) != (HEAP32[i15 >> 2] | 0));
 i22 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i16 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_(i20, i22, i17);
 STACKTOP = i21;
 return;
}

function __ZN5physx2GuL34fullContactsGenerationSphereConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESB_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i1, i4, i10, i11, i7, i9, i2, i5, i6, i8, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i12 + 64 | 0;
 i13 = i12;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i4, i5, i14);
 HEAP32[i13 + 32 >> 2] = i11;
 HEAP32[i13 + 36 >> 2] = i4 + 96;
 HEAP32[i13 + 40 >> 2] = i4 + 144;
 HEAP8[i13 + 44 >> 0] = i5 & 1;
 HEAP32[i13 >> 2] = i5 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i13 + 48 >> 2] = i4;
 i5 = (__ZN5physx2Gu33generateSphereFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalEPNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERNSC_5Vec3VEb(i1, i14, i13, i7, i9, i3, i8, 1) | 0) ^ 1;
 if ((HEAP32[i9 >> 2] | 0) == 0 | i5) {
  i14 = 0;
  STACKTOP = i12;
  return i14 | 0;
 }
 i13 = HEAP32[i6 + 44 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i14 = i13 + 16 | 0;
 i9 = i7 + 16 | 0;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i13 = i13 + 32 | 0;
 i14 = i7 + 32 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP8[i6 + 32 >> 0] = 1;
 f22 = Math_fround(HEAPF32[i11 >> 2]);
 f17 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f25 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f19 = Math_fround(Math_fround(Math_fround(f22 * f18) + Math_fround(f17 * f16)) + Math_fround(f15 * f24));
 f21 = Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f18 * f25) + Math_fround(f23 * Math_fround(Math_fround(f17 * f24) - Math_fround(f15 * f16))))) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(Math_fround(f25 * f16) + Math_fround(f23 * Math_fround(Math_fround(f15 * f18) - Math_fround(f22 * f24))))) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f23 * Math_fround(Math_fround(f22 * f16) - Math_fround(f17 * f18)))) + Math_fround(f15 * f19)) * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f18 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f18 = Math_fround(f18 - Math_fround(f15 * f21));
 f17 = Math_fround(f17 - Math_fround(f15 * f20));
 f16 = Math_fround(Math_fround(HEAPF32[i10 + 24 >> 2]) - Math_fround(f15 * f19));
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 44 >> 2]) - f15);
 i13 = i2 + 4096 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i14 + 1;
 i13 = i2 + (i14 << 6) | 0;
 HEAPF32[i13 >> 2] = f21;
 HEAPF32[i13 + 4 >> 2] = f20;
 HEAPF32[i13 + 8 >> 2] = f19;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 i13 = i2 + (i14 << 6) + 16 | 0;
 HEAPF32[i13 >> 2] = f18;
 HEAPF32[i13 + 4 >> 2] = f17;
 HEAPF32[i13 + 8 >> 2] = f16;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + (i14 << 6) + 12 >> 2] = f15;
 HEAP32[i2 + (i14 << 6) + 48 >> 2] = -1;
 HEAP32[i2 + (i14 << 6) + 52 >> 2] = -1;
 i14 = 1;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZNK13TranslateGLES13GetFormatGLESEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if ((i2 | 0) < 35907) {
  if ((i2 | 0) >= 33779) do switch (i2 | 0) {
  case 35905:
   {
    i1 = 2;
    break L1;
   }
  case 35906:
   {
    i1 = 4;
    break L1;
   }
  case 34842:
   {
    i1 = 21;
    break L1;
   }
  case 34837:
   {
    i1 = 24;
    break L1;
   }
  case 34836:
   {
    i1 = 25;
    break L1;
   }
  case 35898:
   {
    i1 = 26;
    break L1;
   }
  case 35056:
   {
    i1 = 31;
    break L1;
   }
  case 33779:
   {
    i1 = 38;
    break L1;
   }
  case 35841:
   {
    i1 = 45;
    break L1;
   }
  case 35412:
   {
    i1 = 46;
    break L1;
   }
  case 35843:
   {
    i1 = 49;
    break L1;
   }
  case 35414:
   {
    i1 = 50;
    break L1;
   }
  case 35840:
   {
    i1 = 47;
    break L1;
   }
  case 35413:
   {
    i1 = 48;
    break L1;
   }
  case 35842:
   {
    i1 = 51;
    break L1;
   }
  case 35415:
   {
    i1 = 52;
    break L1;
   }
  case 34798:
   {
    i1 = 54;
    break L1;
   }
  default:
   {
    i1 = 3;
    break L1;
   }
  } while (0);
  if ((i2 | 0) >= 33190) switch (i2 | 0) {
  case 33325:
   {
    i1 = 19;
    break L1;
   }
  case 33327:
   {
    i1 = 20;
    break L1;
   }
  case 33326:
   {
    i1 = 22;
    break L1;
   }
  case 33328:
   {
    i1 = 23;
    break L1;
   }
  case 33322:
   {
    i1 = 19;
    break L1;
   }
  case 33190:
   {
    i1 = 31;
    break L1;
   }
  case 33776:
   {
    i1 = 34;
    break L1;
   }
  case 33778:
   {
    i1 = 36;
    break L1;
   }
  default:
   {
    i1 = 3;
    break L1;
   }
  }
  if ((i2 | 0) >= 32854) switch (i2 | 0) {
  case 32854:
   {
    i1 = 17;
    break L1;
   }
  case 32855:
   {
    i1 = 16;
    break L1;
   }
  case 32857:
   {
    i1 = 11;
    break L1;
   }
  case 33189:
   {
    i1 = 30;
    break L1;
   }
  default:
   {
    i1 = 3;
    break L1;
   }
  }
  if ((i2 | 0) >= 32830) switch (i2 | 0) {
  case 32849:
   {
    i1 = 1;
    break L1;
   }
  case 32830:
   {
    i1 = 14;
    break L1;
   }
  default:
   {
    i1 = 3;
    break L1;
   }
  }
  if ((i2 | 0) < 32828) {
   switch (i2 | 0) {
   case 6406:
    break;
   default:
    {
     i1 = 3;
     break L1;
    }
   }
   i1 = 13;
   break;
  } else {
   switch (i2 | 0) {
   case 32828:
    break;
   default:
    {
     i1 = 3;
     break L1;
    }
   }
   i1 = 13;
   break;
  }
 } else do switch (i2 | 0) {
 case 37853:
  {
   i1 = 78;
   break L1;
  }
 case 35907:
  {
   i1 = 4;
   break L1;
  }
 case 37793:
  {
   i1 = 7;
   break L1;
  }
 case 36194:
  {
   i1 = 15;
   break L1;
  }
 case 36396:
  {
   i1 = 30;
   break L1;
  }
 case 35916:
  {
   i1 = 35;
   break L1;
  }
 case 35918:
  {
   i1 = 37;
   break L1;
  }
 case 35919:
  {
   i1 = 39;
   break L1;
  }
 case 36283:
  {
   i1 = 40;
   break L1;
  }
 case 36285:
  {
   i1 = 41;
   break L1;
  }
 case 36495:
  {
   i1 = 42;
   break L1;
  }
 case 36492:
  {
   i1 = 43;
   break L1;
  }
 case 36493:
  {
   i1 = 44;
   break L1;
  }
 case 35986:
  {
   i1 = 53;
   break L1;
  }
 case 37488:
  {
   i1 = 63;
   break L1;
  }
 case 37489:
  {
   i1 = 64;
   break L1;
  }
 case 37490:
  {
   i1 = 65;
   break L1;
  }
 case 37491:
  {
   i1 = 66;
   break L1;
  }
 case 36196:
  {
   i1 = 55;
   break L1;
  }
 case 37492:
  {
   i1 = 57;
   break L1;
  }
 case 37494:
  {
   i1 = 59;
   break L1;
  }
 case 37496:
  {
   i1 = 61;
   break L1;
  }
 case 37808:
  {
   i1 = 67;
   break L1;
  }
 case 37840:
  {
   i1 = 68;
   break L1;
  }
 case 37810:
  {
   i1 = 69;
   break L1;
  }
 case 37842:
  {
   i1 = 70;
   break L1;
  }
 case 37812:
  {
   i1 = 71;
   break L1;
  }
 case 37844:
  {
   i1 = 72;
   break L1;
  }
 case 37815:
  {
   i1 = 73;
   break L1;
  }
 case 37847:
  {
   i1 = 74;
   break L1;
  }
 case 37819:
  {
   i1 = 75;
   break L1;
  }
 case 37851:
  {
   i1 = 76;
   break L1;
  }
 case 37821:
  {
   i1 = 77;
   break L1;
  }
 default:
  {
   i1 = 3;
   break L1;
  }
 } while (0); while (0);
 return i1 | 0;
}

function __ZN15SerializeTraitsIN17ProceduralTexture17TextureParametersEE8TransferI14SafeBinaryReadEEvRS1_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034504 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034510 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431996 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 432006 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 397134 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 397147 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 397155 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 896261 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, d7 = 0.0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f10 * f13);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f11 * f12));
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(f11 * f6);
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f13 * f3));
 f5 = Math_fround(Math_fround(f12 * f3) - Math_fround(f10 * f6));
 f6 = Math_fround(Math_fround(f13 * f11) + Math_fround(Math_fround(f10 * f12) + Math_fround(f6 * f3)));
 d7 = +f6;
 if (d7 > .9999990000000025) {
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 32 >> 2] = Math_fround(1.0);
  return i8 | 0;
 }
 if (d7 < -.9999990000000025) {
  f23 = Math_fround(-f10);
  f12 = Math_fround(f11 * f11);
  f14 = Math_fround(f10 * f10);
  i2 = Math_fround(Math_fround(f12 + Math_fround(0.0)) + f14) < Math_fround(9.99999997e-07);
  f21 = Math_fround(-f11);
  f21 = i2 ? f21 : Math_fround(0.0);
  f24 = i2 ? Math_fround(0.0) : f11;
  f23 = i2 ? f3 : f23;
  f22 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f21 * f21) + Math_fround(f24 * f24)) + Math_fround(f23 * f23)))));
  f21 = Math_fround(f22 * f21);
  f24 = Math_fround(f22 * f24);
  f23 = Math_fround(f22 * f23);
  f22 = Math_fround(Math_fround(f11 * f24) - Math_fround(f10 * f23));
  f5 = Math_fround(Math_fround(f3 * f23) - Math_fround(f11 * f21));
  f4 = Math_fround(Math_fround(f10 * f21) - Math_fround(f24 * f3));
  f19 = Math_fround(f3 * f10);
  f16 = Math_fround(f3 * f11);
  f6 = Math_fround(f10 * f11);
  f15 = Math_fround(f5 * f5);
  f11 = Math_fround(f4 * f4);
  f20 = Math_fround(f22 * f5);
  f17 = Math_fround(f4 * f22);
  f5 = Math_fround(f4 * f5);
  f4 = Math_fround(f24 * f24);
  f13 = Math_fround(f23 * f23);
  f18 = Math_fround(f21 * f24);
  f9 = Math_fround(f21 * f23);
  f10 = Math_fround(f24 * f23);
  HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f22 * f22) - Math_fround(f3 * f3)) - Math_fround(f21 * f21));
  f3 = Math_fround(Math_fround(f20 - f19) - f18);
  HEAPF32[i8 + 12 >> 2] = f3;
  f9 = Math_fround(Math_fround(f17 - f16) - f9);
  HEAPF32[i8 + 24 >> 2] = f9;
  HEAPF32[i8 + 4 >> 2] = f3;
  HEAPF32[i8 + 16 >> 2] = Math_fround(Math_fround(f15 - f14) - f4);
  f10 = Math_fround(Math_fround(f5 - f6) - f10);
  HEAPF32[i8 + 28 >> 2] = f10;
  HEAPF32[i8 + 8 >> 2] = f9;
  HEAPF32[i8 + 20 >> 2] = f10;
  HEAPF32[i8 + 32 >> 2] = Math_fround(Math_fround(f11 - f12) - f13);
  return i8 | 0;
 } else {
  f21 = Math_fround(Math_fround(Math_fround(1.0) - f6) / Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f9 * f9) + Math_fround(f4 * f4))));
  f19 = Math_fround(f9 * f21);
  f24 = Math_fround(f5 * f21);
  f20 = Math_fround(f4 * f19);
  f22 = Math_fround(f5 * f19);
  f23 = Math_fround(f4 * f24);
  HEAPF32[i8 >> 2] = Math_fround(f6 + Math_fround(f9 * f19));
  HEAPF32[i8 + 12 >> 2] = Math_fround(f20 - f5);
  HEAPF32[i8 + 24 >> 2] = Math_fround(f4 + f22);
  HEAPF32[i8 + 4 >> 2] = Math_fround(f5 + f20);
  HEAPF32[i8 + 16 >> 2] = Math_fround(f6 + Math_fround(f4 * Math_fround(f4 * f21)));
  HEAPF32[i8 + 28 >> 2] = Math_fround(f23 - f9);
  HEAPF32[i8 + 8 >> 2] = Math_fround(f22 - f4);
  HEAPF32[i8 + 20 >> 2] = Math_fround(f9 + f23);
  HEAPF32[i8 + 32 >> 2] = Math_fround(f6 + Math_fround(f5 * f24));
  return i8 | 0;
 }
 return 0;
}

function __ZN13SparseTexture11InitTextureEii13TextureFormatib(i11, i7, i8, i9, i2, i4) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 12 | 0;
 i12 = i13;
 i10 = i13 + 8 | 0;
 L1 : do if (!((i9 + -1 | 0) >>> 0 < 23 | (i9 + -10 | 0) >>> 0 < 3)) {
  i1 = i9 | 1;
  switch (i1 | 0) {
  case 25:
  case 27:
   break L1;
  default:
   {}
  }
  if ((i9 + -48 | 0) >>> 0 >= 12) {
   switch (i9 | 0) {
   case 28:
   case 29:
   case 30:
   case 31:
   case 32:
   case 33:
   case 34:
   case 35:
   case 36:
   case 41:
   case 42:
   case 43:
   case 44:
   case 45:
   case 46:
   case 47:
    break L1;
   default:
    {}
   }
   if ((i1 | 0) != 61) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411541 | 0, 0, gb + 411582 | 0, 62, 1, 0, 0, 0);
    i12 = 0;
    STACKTOP = i13;
    return i12 | 0;
   }
  }
 } while (0);
 if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 524 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411657 | 0, 0, gb + 411582 | 0, 68, 1, 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((i8 + -1 | i7 + -1) >>> 0 > 16383) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411691 | 0, 0, gb + 411582 | 0, 75, 1, 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 171 + i9 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411737 | 0, 0, gb + 411582 | 0, 81, 1, 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = __Z22CalculateMipMapCount3Diii(i7, i8, 1) | 0;
 i6 = (i2 | 0) == -1 ? i1 : i2;
 i6 = (i6 | 0) < 1 ? 1 : (i6 | 0) > (i1 | 0) ? i1 : i6;
 i1 = i11 + 60 | 0;
 HEAP32[i1 >> 2] = i4 & 1 ^ 1;
 HEAP32[i11 + 80 >> 2] = i7;
 HEAP32[i11 + 84 >> 2] = i8;
 HEAP32[i11 + 76 >> 2] = i6;
 HEAP32[i11 + 96 >> 2] = i9;
 HEAP8[i11 + 100 >> 0] = 1;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 480 >> 2] | 0;
 i2 = i11 + 48 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 >> 2] | 0; else i1 = 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 mftCall_viiiiiiii(i5 | 0, i12 | 0, i4 | 0, i3 | 0, i7 | 0, i8 | 0, i9 | 0, i6 | 0, i1 | 0);
 i6 = HEAP32[i2 >> 2] | 0;
 i7 = i11;
 i8 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i6 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 18;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i6 >>> 0) {
     i2 = 23;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 22;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 18) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 22) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 23) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 4 >> 2] = i7;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i8 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
  i10 = i8 + 8 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 92 >> 2] | 0, i11 | 0);
 HEAP32[i11 + 88 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 92 >> 2] = HEAP32[i12 + 4 >> 2];
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __Z26ValidateGlobalGameManagersv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24 + 40 | 0;
 i18 = i24 + 32 | 0;
 i8 = i24 + 16 | 0;
 i17 = i24;
 i20 = i24 + 64 | 0;
 i23 = i24 + 44 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 i22 = gb + 64016 | 0;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 i9 = i17;
 HEAP32[i9 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i9 + 4 >> 2] = i21;
 HEAP32[i23 >> 2] = 0;
 i9 = i23 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i21 = i23 + 16 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i23 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i17);
 i12 = i8;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i22;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 28608 | 0, i23, 0);
 i10 = i8 + 4 | 0;
 i11 = i8 + 8 | 0;
 i12 = i17 + 11 | 0;
 i13 = i17 + 4 | 0;
 i14 = i17 + 11 | 0;
 i15 = i17 + 4 | 0;
 i16 = i8 + 8 | 0;
 i7 = 0;
 do {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 0;
  } else {
   i6 = gb + 1104348 + 112 + (i7 << 2) | 0;
   i5 = 0;
   do {
    i2 = (HEAP32[i23 >> 2] | 0) + (i5 << 2) | 0;
    i25 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i3 = i25;
    do if ((((HEAP32[i25 + 8 >> 2] | 0) >>> 21) - (HEAP32[i4 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + 28 >> 2] | 0) >>> 0) {
     i4 = HEAP32[i10 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i16 >> 2] | 0)) {
      __ZNSt3__26vectorIP11GameManagerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i2);
      i1 = HEAP32[i9 >> 2] | 0;
      break;
     } else {
      HEAP32[i4 >> 2] = i3;
      HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
      break;
     }
    } while (0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  switch (i1 - i2 >> 2 | 0) {
  case 1:
   break;
  case 0:
   {
    HEAP32[i18 >> 2] = HEAP32[(HEAP32[gb + 1104348 + 112 + (i7 << 2) >> 2] | 0) + 8 >> 2];
    __Z6FormatPKcz(i17, gb + 370405 | 0, i18);
    i25 = HEAP8[i14 >> 0] | 0;
    i6 = i25 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i6 ? HEAP32[i17 >> 2] | 0 : i17, i6 ? HEAP32[i15 >> 2] | 0 : i25 & 255) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
    break;
   }
  default:
   {
    HEAP32[i19 >> 2] = HEAP32[(HEAP32[gb + 1104348 + 112 + (i7 << 2) >> 2] | 0) + 8 >> 2];
    __Z6FormatPKcz(i17, gb + 370441 | 0, i19);
    i25 = HEAP8[i12 >> 0] | 0;
    i6 = i25 << 24 >> 24 < 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i20, i6 ? HEAP32[i17 >> 2] | 0 : i17, i6 ? HEAP32[i13 >> 2] | 0 : i25 & 255) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   }
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 24);
 i25 = HEAP8[i20 + 11 >> 0] | 0;
 i1 = i25 << 24 >> 24 < 0;
 if ((i1 ? HEAP32[i20 + 4 >> 2] | 0 : i25 & 255) | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i1 ? HEAP32[i20 >> 2] | 0 : i20, 0, gb + 370483 | 0, 165, 1, 0, 0, 0);
 if ((HEAP32[i21 >> 2] | 0) <= -1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  STACKTOP = i24;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i22);
 HEAP32[i23 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 STACKTOP = i24;
 return;
}

function __ZN12TreeRendererD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN12TreeRenderer14ClearRenderersEv(i10);
 i9 = i10 + 176 | 0;
 i5 = i10 + 188 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = i2 + 60 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = i2 + 48 | 0;
    __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i7 = i10 + 192 | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i10 + 180 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i1 = i10 + 152 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i10 + 4 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i10 + 420 | 0;
 if ((HEAP32[i10 + 436 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 424 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 400 | 0;
 if ((HEAP32[i10 + 416 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 404 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 380 | 0;
 if ((HEAP32[i10 + 396 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 384 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i10 + 364 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i10 + 368 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -44 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -40 | 0;
    if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -36 | 0);
     HEAP32[i4 >> 2] = 0;
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i6 = HEAP32[i10 + 376 >> 2] | 0;
  HEAP32[i8 >> 2] = 62;
  HEAP32[i8 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 __ZN15LODGroupManagerD2Ev(i10 + 304 | 0);
 i1 = i10 + 276 | 0;
 if ((HEAP32[i10 + 292 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 280 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 256 | 0;
 if ((HEAP32[i10 + 272 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 260 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 236 | 0;
 if ((HEAP32[i10 + 252 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 240 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN22ForwardLinearAllocatorD2Ev(i10 + 204 | 0);
 i1 = HEAP32[i10 + 196 >> 2] | 0;
 if (i1 | 0) {
  __ZN21ImposterRenderTextureD2Ev(i1);
  __ZdlPv(i1);
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i10 + 180 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 i1 = i10 + 156 | 0;
 if ((HEAP32[i10 + 172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 160 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i10 + 148 >> 2] | 0;
 if (i1 | 0) {
  __ZN14TreeBinaryTreeD2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[i10 + 8 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i10 + 96 >> 2] | 0) > -1) {
  i9 = i10 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i10 + 84 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 i1 = i10 + 60 | 0;
 if ((HEAP32[i10 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 40 | 0;
 if ((HEAP32[i10 + 56 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i10 + 44 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i5, i7, i6, i1, i9) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i1, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i4 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, HEAP32[i6 >> 2] | 0);
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 1736, 4) | 0;
  __ZN7mecanim5human9HumanPoseC2Ev(i2);
  i4 = i2 + 888 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i2 + 912 >> 2] = 1065353216;
  HEAP32[i2 + 916 >> 2] = 1065353216;
  HEAP32[i2 + 920 >> 2] = 1065353216;
  HEAP32[i2 + 924 >> 2] = 1065353216;
  i4 = i2 + 928 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i2 + 952 >> 2] = 1065353216;
  HEAP32[i2 + 956 >> 2] = 1065353216;
  HEAP32[i2 + 960 >> 2] = 1065353216;
  HEAP32[i2 + 964 >> 2] = 1065353216;
  i4 = i2 + 968 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i2 + 992 >> 2] = 1065353216;
  HEAP32[i2 + 996 >> 2] = 1065353216;
  HEAP32[i2 + 1e3 >> 2] = 1065353216;
  HEAP32[i2 + 1004 >> 2] = 1065353216;
  i4 = i2 + 1008 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i2 + 1032 >> 2] = 1065353216;
  HEAP32[i2 + 1036 >> 2] = 1065353216;
  HEAP32[i2 + 1040 >> 2] = 1065353216;
  HEAP32[i2 + 1044 >> 2] = 1065353216;
  i4 = i2 + 1048 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAPF32[i2 + 1068 >> 2] = Math_fround(1.0);
  i4 = i2 + 1072 | 0;
  i6 = i2 + 1708 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP16[i6 + 20 >> 1] = 0;
  HEAP8[i2 + 1730 >> 0] = 1;
  HEAP8[i2 + 1731 >> 0] = 0;
  HEAP8[i2 + 1732 >> 0] = 1;
  HEAP8[i2 + 1733 >> 0] = 0;
  HEAP8[i2 + 1734 >> 0] = 0;
  _memset(i2 + 1088 | 0, -1, 620) | 0;
  HEAP32[i5 >> 2] = i2;
 } else i2 = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i7, gb + 898415 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN7mecanim9animation18ClipMuscleConstant8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function runPostSets173() {
 HEAP32[gb + 150876 >> 2] = fb + 1040;
 HEAP32[gb + 150880 >> 2] = fb + 2233;
 HEAP32[gb + 150884 >> 2] = fb + 2234;
 HEAP32[gb + 150888 >> 2] = fb + 1041;
 HEAP32[gb + 150900 >> 2] = fb + 2235;
 HEAP32[gb + 150904 >> 2] = fb + 2236;
 HEAP32[gb + 150908 >> 2] = fb + 242;
 HEAP32[gb + 150912 >> 2] = fb + 1042;
 HEAP32[gb + 150916 >> 2] = fb + 2237;
 HEAP32[gb + 150920 >> 2] = fb + 2238;
 HEAP32[gb + 150924 >> 2] = fb + 1043;
 HEAP32[gb + 150928 >> 2] = fb + 1044;
 HEAP32[gb + 150940 >> 2] = fb + 2239;
 HEAP32[gb + 150944 >> 2] = fb + 2240;
 HEAP32[gb + 150948 >> 2] = fb + 2241;
 HEAP32[gb + 150952 >> 2] = fb + 411;
 HEAP32[gb + 150964 >> 2] = fb + 2242;
 HEAP32[gb + 150968 >> 2] = fb + 2243;
 HEAP32[gb + 150972 >> 2] = fb + 1494;
 HEAP32[gb + 150976 >> 2] = fb + 1495;
 HEAP32[gb + 150980 >> 2] = fb + 1496;
 HEAP32[gb + 150984 >> 2] = fb + 1497;
 HEAP32[gb + 150988 >> 2] = fb + 1498;
 HEAP32[gb + 150992 >> 2] = fb + 1499;
 HEAP32[gb + 150996 >> 2] = fb + 1500;
 HEAP32[gb + 151e3 >> 2] = fb + 1045;
 HEAP32[gb + 151004 >> 2] = fb + 1046;
 HEAP32[gb + 151016 >> 2] = fb + 2244;
 HEAP32[gb + 151020 >> 2] = fb + 2245;
 HEAP32[gb + 151024 >> 2] = fb + 2246;
 HEAP32[gb + 151028 >> 2] = fb + 412;
 HEAP32[gb + 151040 >> 2] = fb + 2247;
 HEAP32[gb + 151044 >> 2] = fb + 2248;
 HEAP32[gb + 151048 >> 2] = fb + 1501;
 HEAP32[gb + 151052 >> 2] = fb + 1502;
 HEAP32[gb + 151056 >> 2] = fb + 1503;
 HEAP32[gb + 151060 >> 2] = fb + 1504;
 HEAP32[gb + 151064 >> 2] = fb + 1505;
 HEAP32[gb + 151068 >> 2] = fb + 1506;
 HEAP32[gb + 151072 >> 2] = fb + 1507;
 HEAP32[gb + 151076 >> 2] = fb + 1047;
 HEAP32[gb + 151080 >> 2] = fb + 1048;
 HEAP32[gb + 151084 >> 2] = (HEAP32[gb + 151084 >> 2] | 0) + (gb + 151088 | 0);
 HEAP32[gb + 151088 >> 2] = (HEAP32[gb + 151088 >> 2] | 0) + (gb + 151092 | 0);
 HEAP32[gb + 151100 >> 2] = fb + 2249;
 HEAP32[gb + 151104 >> 2] = fb + 2250;
 HEAP32[gb + 151108 >> 2] = fb + 66;
 HEAP32[gb + 151120 >> 2] = fb + 1049;
 HEAP32[gb + 151124 >> 2] = fb + 118;
 HEAP32[gb + 151128 >> 2] = fb + 387;
 HEAP32[gb + 151132 >> 2] = fb + 1050;
 HEAP32[gb + 151136 >> 2] = fb + 1051;
 HEAP32[gb + 151140 >> 2] = fb + 1052;
 HEAP32[gb + 151144 >> 2] = fb + 388;
 HEAP32[gb + 151148 >> 2] = fb + 2251;
 HEAP32[gb + 151152 >> 2] = fb + 2252;
 HEAP32[gb + 151156 >> 2] = fb + 2253;
 HEAP32[gb + 151168 >> 2] = fb + 1009;
 HEAP32[gb + 151172 >> 2] = fb + 2254;
 HEAP32[gb + 151176 >> 2] = fb + 125;
 HEAP32[gb + 151180 >> 2] = fb + 67;
 HEAP32[gb + 151184 >> 2] = fb + 1508;
 HEAP32[gb + 151196 >> 2] = fb + 1009;
 HEAP32[gb + 151200 >> 2] = fb + 2255;
 HEAP32[gb + 151204 >> 2] = fb + 126;
 HEAP32[gb + 151208 >> 2] = fb + 68;
 HEAP32[gb + 151212 >> 2] = fb + 1509;
 HEAP32[gb + 151224 >> 2] = fb + 1009;
 HEAP32[gb + 151228 >> 2] = fb + 2256;
 HEAP32[gb + 151232 >> 2] = fb + 127;
 HEAP32[gb + 151236 >> 2] = fb + 69;
 HEAP32[gb + 151240 >> 2] = fb + 1510;
 HEAP32[gb + 151252 >> 2] = fb + 1009;
 HEAP32[gb + 151256 >> 2] = fb + 2257;
 HEAP32[gb + 151260 >> 2] = fb + 128;
 HEAP32[gb + 151264 >> 2] = fb + 70;
 HEAP32[gb + 151268 >> 2] = fb + 1511;
 HEAP32[gb + 151312 >> 2] = fb + 243;
 HEAP32[gb + 151316 >> 2] = fb + 1035;
 HEAP32[gb + 151320 >> 2] = fb + 1036;
 HEAP32[gb + 151324 >> 2] = fb + 2258;
 HEAP32[gb + 151336 >> 2] = fb + 244;
 HEAP32[gb + 151340 >> 2] = fb + 1053;
 HEAP32[gb + 151344 >> 2] = fb + 1054;
 HEAP32[gb + 151348 >> 2] = fb + 2259;
 HEAP32[gb + 151360 >> 2] = fb + 245;
 HEAP32[gb + 151364 >> 2] = fb + 1298;
 HEAP32[gb + 151368 >> 2] = fb + 1294;
 HEAP32[gb + 151372 >> 2] = fb + 2260;
 HEAP32[gb + 151384 >> 2] = fb + 246;
 HEAP32[gb + 151388 >> 2] = fb + 1298;
 HEAP32[gb + 151392 >> 2] = fb + 1294;
 HEAP32[gb + 151396 >> 2] = fb + 2261;
 HEAP32[gb + 151408 >> 2] = fb + 247;
 HEAP32[gb + 151412 >> 2] = fb + 1035;
 HEAP32[gb + 151416 >> 2] = fb + 1036;
 HEAP32[gb + 151420 >> 2] = fb + 2262;
 HEAP32[gb + 151432 >> 2] = fb + 64;
 HEAP32[gb + 151436 >> 2] = fb + 248;
 HEAP32[gb + 151440 >> 2] = fb + 1051;
 runPostSets174();
}

function __ZN5physx23PxsBroadPhaseContextSap17performBoxPruningENS_2Gu4AxesE(i14, i21) {
 i14 = i14 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i34 + 202 | 0;
 i33 = i34 + 144 | 0;
 i31 = i34 + 108 | 0;
 i23 = i34 + 196 | 0;
 i22 = i34 + 192 | 0;
 i29 = i34 + 72 | 0;
 i27 = i34 + 180 | 0;
 i10 = i34 + 201 | 0;
 i8 = i34 + 200 | 0;
 i26 = i34 + 36 | 0;
 i19 = i34;
 i5 = HEAP32[i21 >> 2] | 0;
 i6 = i14 + 80 | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i7 = i14 + 168 | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 i18 = i16 - i15 | 0;
 i30 = i33 + 32 | 0;
 i17 = i18 >>> 0 < 9;
 if (i17) i1 = i33; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i18 << 2, gb + 716893 | 0, 39) | 0;
 HEAP32[i30 >> 2] = i1;
 i28 = i31 + 32 | 0;
 if (i15 >>> 0 < 9) i20 = i31; else {
  i20 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i15 << 2, gb + 716893 | 0, 39) | 0;
  i1 = HEAP32[i30 >> 2] | 0;
 }
 HEAP32[i28 >> 2] = i20;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i22 >> 2] = 0;
 i24 = (HEAP32[i14 + 108 >> 2] << 1) + 31 | 0;
 i3 = i24 >>> 5;
 i25 = i29 + 32 | 0;
 if (i24 >>> 0 < 288) {
  i2 = i3 << 2;
  i4 = i29;
 } else {
  i4 = i3 << 2;
  i2 = i4;
  i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i4, gb + 716893 | 0, 39) | 0;
 }
 HEAP32[i25 >> 2] = i4;
 _memset(i4 | 0, 0, i2 | 0) | 0;
 i24 = i27 + 4 | 0;
 HEAP32[i27 >> 2] = i4;
 HEAP32[i24 >> 2] = i3 | -2147483648;
 HEAP8[i10 >> 0] = 0;
 HEAP8[i8 >> 0] = 0;
 i12 = i14 + 112 | 0;
 i13 = i14 + 104 | 0;
 __ZN5physx18ComputeSortedListsEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjPKjPPNS_8SapBox1DES7_PjSB_jRKNS_2Gu4AxesESB_RjSB_SG_RbSH_(i27, 0, HEAP32[i6 >> 2] | 0, HEAP32[i14 + 76 >> 2] | 0, i12, HEAP32[i13 >> 2] | 0, HEAP32[i14 + 124 + (i5 << 2) >> 2] | 0, HEAP32[i14 + 136 + (i5 << 2) >> 2] | 0, (HEAP32[i7 >> 2] << 1) + 2 | 0, i21, i20, i22, i1, i23, i10, i8);
 i3 = HEAP8[i10 >> 0] | 0;
 if (i3 << 24 >> 24 == 0 | (HEAP8[i8 >> 0] | 0) == 0) {
  i2 = i15 + 1 | 0;
  i11 = i26 + 32 | 0;
  if (i2 >>> 0 < 9) i9 = i26; else {
   i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i2 << 2, gb + 716893 | 0, 39) | 0;
   i3 = HEAP8[i10 >> 0] | 0;
  }
  HEAP32[i11 >> 2] = i9;
  i6 = i14 + 192 | 0;
  i7 = i14 + 180 | 0;
  i8 = i14 + 184 | 0;
  i5 = i14 + 188 | 0;
  __ZN5physx23performBoxPruningNewNewERKNS_2Gu4AxesEPKjjbPjPPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_(i21, i20, HEAP32[i22 >> 2] | 0, i3 << 24 >> 24 != 0, i9, i12, HEAP32[i13 >> 2] | 0, i6, i7, i8, i5);
  if ((i16 | 0) != (i15 | 0)) {
   i4 = i19 + 32 | 0;
   if (i17) {
    i3 = i19;
    i2 = i19;
   } else {
    i3 = i19;
    i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i32, i18 << 2, gb + 716893 | 0, 39) | 0;
   }
   HEAP32[i4 >> 2] = i2;
   __ZN5physx23performBoxPruningNewOldERKNS_2Gu4AxesEPKjjS5_jPjS6_PPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_(i21, i20, HEAP32[i22 >> 2] | 0, i1, HEAP32[i23 >> 2] | 0, i9, i2, i12, HEAP32[i13 >> 2] | 0, i6, i7, i8, i5);
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != (i3 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) != (i26 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
 }
 i1 = HEAP32[i27 >> 2] | 0;
 if ((i1 | 0) != 0 & (HEAP32[i24 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i27 + 8 | 0, i1);
 i1 = HEAP32[i25 >> 2] | 0;
 if ((i1 | 0) != (i29 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
 i1 = HEAP32[i28 >> 2] | 0;
 if ((i1 | 0) != (i31 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
 i1 = HEAP32[i30 >> 2] | 0;
 if ((i1 | 0) == (i33 | 0)) {
  STACKTOP = i34;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i32, i1);
 STACKTOP = i34;
 return;
}

function __ZN13GfxDeviceGLES22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_(i26, i11, i12, i13, i14, i2, i15, i21, i22, i23, i17, i27, i28, i29, i1, i30, i31) {
 i26 = i26 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i17 = i17 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i1 = i1 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, i25 = 0, i32 = 0, i33 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25 + 32 | 0;
 i16 = i25 + 16 | 0;
 i9 = i25 + 28 | 0;
 i10 = i25 + 8 | 0;
 i18 = i25 + 24 | 0;
 i19 = i25 + 20 | 0;
 i20 = i25;
 if (i11 | 0) {
  i5 = i26 + 7288 | 0;
  i6 = i26 + 5480 | 0;
  i7 = i26 + 7376 | 0;
  i8 = i26 + 6616 | 0;
  i4 = 0;
  do {
   i1 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i16 >> 2] = i1;
    i1 = HEAP32[gb + 1157724 >> 2] | 0;
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i24, i1, i16);
     i2 = HEAP32[i24 >> 2] | 0;
     i32 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1157724 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i32 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i32 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    i32 = i1 + 8 | 0;
    i2 = HEAP32[i32 + 4 >> 2] | 0;
    i3 = i5;
    i33 = HEAP32[i3 + 4 >> 2] | 0;
    if (i33 >>> 0 < i2 >>> 0 | ((i33 | 0) == (i2 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i32 >> 2] | 0) >>> 0 : 0)) {
     i33 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i6 >> 2] | 0, 3) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i33;
    }
    __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(i8, HEAP32[i1 >> 2] | 0, HEAP32[i13 + (i4 << 2) >> 2] | 0, HEAP32[i14 + (i4 << 2) >> 2] & 65535, (HEAP32[i15 + (i4 << 2) >> 2] | 0) >>> 16);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i11 | 0));
 }
 if (i21 | 0) {
  i1 = 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i22 + (i1 << 2) >> 2];
   i33 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
   i14 = i17 + (i1 << 3) | 0;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i32 = i10;
   HEAP32[i32 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i32 + 4 >> 2] = i15;
   HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i24 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb(i26, i16, i33, i24, 1, 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i21 | 0));
 }
 if (!i27) {
  STACKTOP = i25;
  return;
 }
 i1 = 0;
 do {
  i2 = HEAP32[i30 + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) < 0) {
   HEAP32[i18 >> 2] = HEAP32[i29 + (i1 << 2) >> 2];
   HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
   __ZN13GfxDeviceGLES15SetImageTextureE9TextureIDi(i26, i24, i2 & 2147483647);
  } else {
   HEAP32[i19 >> 2] = HEAP32[i28 + (i1 << 2) >> 2];
   i23 = i31 + (i1 << 3) | 0;
   i32 = HEAP32[i23 + 4 >> 2] | 0;
   i33 = i20;
   HEAP32[i33 >> 2] = HEAP32[i23 >> 2];
   HEAP32[i33 + 4 >> 2] = i32;
   HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i24 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i24 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb(i26, i16, i2, i24, 0, 1);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 STACKTOP = i25;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i2 - i1 | 0) / 872 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   __ZN9ShaderLab21SerializedShaderStateC2Ev(i1 + 4 | 0);
   i2 = i1 + 800 | 0;
   i6 = i1 + 724 | 0;
   i7 = i6 + 88 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   HEAP32[i1 + 812 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i11 = i1 + 816 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i1 + 828 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   i11 = i1 + 832 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i1 + 844 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i1 + 852 >> 2] = 0;
   HEAP32[i1 + 856 >> 2] = 0;
   HEAP32[i1 + 848 >> 2] = i1 + 852;
   HEAP32[i1 + 864 >> 2] = 0;
   HEAP32[i1 + 868 >> 2] = 0;
   HEAP32[i1 + 860 >> 2] = i1 + 864;
   i1 = (HEAP32[i12 >> 2] | 0) + 872 | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 872 | 0) + i3 | 0;
 if (i5 >>> 0 > 4925421) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 872 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 2462710 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 4925421;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 872 | 0) | 0;
 i2 = i6 + (((i1 - i4 | 0) / 872 | 0) * 872 | 0) | 0;
 i8 = i2;
 i5 = i6 + (i5 * 872 | 0) | 0;
 i9 = i8;
 i1 = i2;
 do {
  HEAP32[i1 >> 2] = 0;
  __ZN9ShaderLab21SerializedShaderStateC2Ev(i1 + 4 | 0);
  i4 = i1 + 800 | 0;
  i6 = i1 + 724 | 0;
  i7 = i6 + 88 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i7 | 0));
  HEAP32[i1 + 812 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i7 = i1 + 816 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i1 + 828 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i7 = i1 + 832 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i1 + 844 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i1 + 852 >> 2] = 0;
  HEAP32[i1 + 856 >> 2] = 0;
  HEAP32[i1 + 848 >> 2] = i1 + 852;
  HEAP32[i1 + 864 >> 2] = 0;
  HEAP32[i1 + 868 >> 2] = 0;
  HEAP32[i1 + 860 >> 2] = i1 + 864;
  i1 = i9 + 872 | 0;
  i9 = i1;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i8;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i8;
  do {
   i1 = i1 + -872 | 0;
   __ZN9ShaderLab14SerializedPassC2ERKS0_(i2 + -872 | 0, i1);
   i2 = i3 + -872 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i11 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -872 | 0;
  __ZN9ShaderLab14SerializedPassD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function runPostSets219() {
 HEAP32[gb + 187536 >> 2] = fb + 284;
 HEAP32[gb + 187540 >> 2] = fb + 2190;
 HEAP32[gb + 187544 >> 2] = fb + 2857;
 HEAP32[gb + 187548 >> 2] = fb + 1333;
 HEAP32[gb + 187552 >> 2] = fb + 1334;
 HEAP32[gb + 187556 >> 2] = fb + 1335;
 HEAP32[gb + 187560 >> 2] = fb + 185;
 HEAP32[gb + 187564 >> 2] = fb + 1327;
 HEAP32[gb + 187568 >> 2] = fb + 2851;
 HEAP32[gb + 187572 >> 2] = fb + 1328;
 HEAP32[gb + 187576 >> 2] = fb + 1329;
 HEAP32[gb + 187580 >> 2] = fb + 1326;
 HEAP32[gb + 187592 >> 2] = fb + 2858;
 HEAP32[gb + 187596 >> 2] = fb + 2859;
 HEAP32[gb + 187600 >> 2] = fb + 2860;
 HEAP32[gb + 187604 >> 2] = fb + 2191;
 HEAP32[gb + 187608 >> 2] = fb + 285;
 HEAP32[gb + 187612 >> 2] = fb + 2192;
 HEAP32[gb + 187616 >> 2] = fb + 2861;
 HEAP32[gb + 187620 >> 2] = fb + 1336;
 HEAP32[gb + 187624 >> 2] = fb + 1337;
 HEAP32[gb + 187628 >> 2] = fb + 1338;
 HEAP32[gb + 187632 >> 2] = fb + 186;
 HEAP32[gb + 187636 >> 2] = fb + 1327;
 HEAP32[gb + 187640 >> 2] = fb + 2851;
 HEAP32[gb + 187644 >> 2] = fb + 1328;
 HEAP32[gb + 187648 >> 2] = fb + 1329;
 HEAP32[gb + 187652 >> 2] = fb + 1326;
 HEAP32[gb + 187664 >> 2] = fb + 2862;
 HEAP32[gb + 187668 >> 2] = fb + 2863;
 HEAP32[gb + 187672 >> 2] = fb + 2846;
 HEAP32[gb + 187676 >> 2] = fb + 2187;
 HEAP32[gb + 187680 >> 2] = fb + 286;
 HEAP32[gb + 187684 >> 2] = fb + 2193;
 HEAP32[gb + 187688 >> 2] = fb + 2864;
 HEAP32[gb + 187692 >> 2] = fb + 1339;
 HEAP32[gb + 187696 >> 2] = fb + 1340;
 HEAP32[gb + 187700 >> 2] = fb + 1341;
 HEAP32[gb + 187704 >> 2] = fb + 187;
 HEAP32[gb + 187708 >> 2] = fb + 1327;
 HEAP32[gb + 187712 >> 2] = fb + 2851;
 HEAP32[gb + 187716 >> 2] = fb + 1328;
 HEAP32[gb + 187720 >> 2] = fb + 1329;
 HEAP32[gb + 187724 >> 2] = fb + 1326;
 HEAP32[gb + 187736 >> 2] = fb + 2865;
 HEAP32[gb + 187740 >> 2] = fb + 2866;
 HEAP32[gb + 187744 >> 2] = fb + 2846;
 HEAP32[gb + 187748 >> 2] = fb + 2187;
 HEAP32[gb + 187752 >> 2] = fb + 287;
 HEAP32[gb + 187756 >> 2] = fb + 2194;
 HEAP32[gb + 187760 >> 2] = fb + 2867;
 HEAP32[gb + 187764 >> 2] = fb + 1342;
 HEAP32[gb + 187768 >> 2] = fb + 1343;
 HEAP32[gb + 187772 >> 2] = fb + 1344;
 HEAP32[gb + 187776 >> 2] = fb + 188;
 HEAP32[gb + 187780 >> 2] = fb + 1327;
 HEAP32[gb + 187784 >> 2] = fb + 2851;
 HEAP32[gb + 187788 >> 2] = fb + 1328;
 HEAP32[gb + 187792 >> 2] = fb + 1329;
 HEAP32[gb + 187796 >> 2] = fb + 1326;
 HEAP32[gb + 187832 >> 2] = (HEAP32[gb + 187832 >> 2] | 0) + (gb + 1026921 | 0);
 HEAP32[gb + 187836 >> 2] = (HEAP32[gb + 187836 >> 2] | 0) + (gb + 1026939 | 0);
 HEAP32[gb + 187852 >> 2] = fb + 1345;
 HEAP32[gb + 187856 >> 2] = fb + 470;
 HEAP32[gb + 187860 >> 2] = fb + 1346;
 HEAP32[gb + 187864 >> 2] = fb + 1347;
 HEAP32[gb + 187868 >> 2] = fb + 1348;
 HEAP32[gb + 187884 >> 2] = fb + 2868;
 HEAP32[gb + 187888 >> 2] = fb + 2869;
 HEAP32[gb + 187892 >> 2] = fb + 2870;
 HEAP32[gb + 187896 >> 2] = fb + 2195;
 HEAP32[gb + 187900 >> 2] = fb + 2871;
 HEAP32[gb + 187904 >> 2] = fb + 125;
 HEAP32[gb + 187908 >> 2] = fb + 1349;
 HEAP32[gb + 187912 >> 2] = fb + 1350;
 HEAP32[gb + 187916 >> 2] = fb + 1351;
 HEAP32[gb + 187920 >> 2] = fb + 189;
 HEAP32[gb + 187924 >> 2] = fb + 2196;
 HEAP32[gb + 187936 >> 2] = fb + 2872;
 HEAP32[gb + 187940 >> 2] = fb + 2873;
 HEAP32[gb + 187944 >> 2] = fb + 2870;
 HEAP32[gb + 187948 >> 2] = fb + 2195;
 HEAP32[gb + 187952 >> 2] = fb + 1;
 HEAP32[gb + 187956 >> 2] = fb + 1;
 HEAP32[gb + 187960 >> 2] = fb + 1;
 HEAP32[gb + 187964 >> 2] = fb + 1;
 HEAP32[gb + 187968 >> 2] = fb + 1;
 HEAP32[gb + 187972 >> 2] = fb + 1;
 HEAP32[gb + 187976 >> 2] = fb + 2196;
 HEAP32[gb + 187988 >> 2] = fb + 2874;
 HEAP32[gb + 187992 >> 2] = fb + 2875;
 HEAP32[gb + 187996 >> 2] = fb + 190;
 HEAP32[gb + 188e3 >> 2] = fb + 1352;
 HEAP32[gb + 188004 >> 2] = fb + 191;
 HEAP32[gb + 188008 >> 2] = fb + 1353;
 HEAP32[gb + 188020 >> 2] = fb + 2876;
 HEAP32[gb + 188024 >> 2] = fb + 2877;
 HEAP32[gb + 188028 >> 2] = fb + 192;
 HEAP32[gb + 188032 >> 2] = fb + 1354;
 HEAP32[gb + 188036 >> 2] = fb + 193;
 runPostSets220();
}

function __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEPK10TextureRef(i14, i15, i16, i5) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i18;
 i6 = i18 + 32 | 0;
 i17 = i18 + 16 | 0;
 if (!i5) i13 = 7; else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i13 = 7; else {
   i7 = i14 + 72 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i15 | 0;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i3;
   if (i3 | i1 | 0) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if (!((i1 | 0) == 1 | (i1 | 0) == (i3 | 0))) {
     i19 = HEAP32[gb + 68604 + (i3 << 2) >> 2] | 0;
     i1 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
     i3 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i16) | 0;
     HEAP32[i8 >> 2] = i19;
     HEAP32[i8 + 4 >> 2] = i1;
     HEAP32[i8 + 8 >> 2] = i3;
     __Z6FormatPKcz(i6, gb + 478736 | 0, i8);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    }
   }
   HEAP32[i2 + 12 >> 2] = i4;
   f9 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f10 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   f11 = Math_fround(HEAPF32[i5 + 20 >> 2]);
   f12 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   i19 = i5 + 28 | 0;
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  }
 }
 if ((i13 | 0) == 7) {
  i7 = i14 + 72 | 0;
  i19 = (HEAP32[i7 >> 2] | 0) + i15 | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i19 + 4 >> 2] = 0;
  HEAP32[i19 + 12 >> 2] = 0;
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i6, 0, 0);
  HEAP32[i17 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  f9 = Math_fround(1.0);
  f10 = Math_fround(1.0);
  f11 = Math_fround(1.0);
  f12 = Math_fround(1.0);
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + i15 + 24 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i14, i16, gb + 478720 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i2 + i15 + 24 >> 2] = i1;
 }
 i3 = i14 + 12 | 0;
 i4 = i14 + 52 | 0;
 i1 = i2 + (HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) + i1 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i1 >> 2] = f9;
 HEAPF32[i1 + 4 >> 2] = f10;
 HEAPF32[i1 + 8 >> 2] = f11;
 HEAPF32[i1 + 12 >> 2] = f12;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + i15 + 28 >> 2] | 0;
 if ((i2 | 0) >= 0) {
  i19 = i2;
  i16 = i1;
  i15 = HEAP32[i3 >> 2] | 0;
  i19 = i15 + i19 | 0;
  i15 = HEAP32[i4 >> 2] | 0;
  i19 = i15 + (i19 << 2) | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i19 = i19 & 1048575;
  i19 = i16 + i19 | 0;
  HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  STACKTOP = i18;
  return;
 }
 i19 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i14, i16, gb + 478731 | 0) | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 HEAP32[i16 + i15 + 28 >> 2] = i19;
 i15 = HEAP32[i3 >> 2] | 0;
 i19 = i15 + i19 | 0;
 i15 = HEAP32[i4 >> 2] | 0;
 i19 = i15 + (i19 << 2) | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i19 = i19 & 1048575;
 i19 = i16 + i19 | 0;
 HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN5physx3Scb11RigidObject9syncStateEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 4 | 0;
 i6 = i15;
 i8 = i15 + 8 | 0;
 i14 = i12 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 do if (i9 & 32 | 0) {
  i4 = HEAP32[i12 >> 2] | 0;
  i1 = i9 >>> 24 & 15;
  i7 = (HEAP32[gb + 90260 + 24 + (i1 << 2) >> 2] | 0) + i12 | 0;
  i2 = i12 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(i4, i1) | 0;
   HEAP32[i2 >> 2] = i3;
  }
  i5 = i3 + 88 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i3 + 84 | 0;
  if ((i2 | 0) != 1) if (!i2) break; else i1 = (HEAP32[i4 + 2516 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (HEAP8[((HEAP32[i3 + 4 >> 2] & 64 | 0) == 0 ? i3 + 80 | 0 : (HEAP32[i3 + 8 >> 2] | 0) + 52 | 0) >> 0] & 5) {
    HEAP32[i6 >> 2] = 128;
    HEAP8[i8 >> 0] = 0;
    __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i7, i3 + 16 | 0, i6, i8);
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 } while (0);
 if (i9 & 8 | 0) {
  i9 = i12 + 8 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i12 >> 2] | 0, (HEAP32[i14 >> 2] | 0) >>> 24 & 15) | 0;
   HEAP32[i9 >> 2] = i1;
  }
  i8 = i12;
  i10 = i1 + 4 | 0;
  i11 = i1 + 28 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  L21 : do if (i6 | 0) {
   i7 = i1 + 24 | 0;
   if ((HEAP32[i14 >> 2] | 0) >>> 0 > 3221225471) {
    i1 = HEAP32[i7 >> 2] | 0;
    i5 = 0;
    while (1) {
     i2 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
     i3 = i2 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 & 251658240 | 0) == 16777216) {
      i9 = HEAP32[i12 >> 2] | 0;
      HEAP32[i3 >> 2] = i4 & 1073741823;
      HEAP32[i2 >> 2] = i9;
     }
     i5 = i5 + 1 | 0;
     if (i5 >>> 0 >= i6 >>> 0) break L21;
    }
   } else {
    i1 = i6;
    i5 = 0;
   }
   do {
    i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 & 251658240 | 0) == 16777216) {
     i6 = HEAP32[i12 >> 2] | 0;
     HEAP32[i2 >> 2] = i3 & 1073741823 | -2147483648;
     HEAP32[i4 >> 2] = i6;
    }
    i6 = HEAP32[i14 >> 2] | 0;
    i2 = (HEAP32[gb + 90260 + 24 + ((i6 >>> 24 & 15) << 2) >> 2] | 0) + i8 | 0;
    if (!(HEAP16[((i6 & 1 | 0) == 0 ? i2 + 8 | 0 : HEAP32[i9 >> 2] | 0) >> 1] & 8)) {
     __ZN5physx2Sc9RigidCore15addShapeToSceneERNS0_9ShapeCoreE(i2, i4 + 16 | 0);
     __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i4);
     i1 = HEAP32[i11 >> 2] | 0;
    }
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
  } while (0);
  HEAP32[i13 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE6resizeEjRKS4_(i10, 0, i13);
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE8recreateEj(i10, HEAP32[i11 >> 2] | 0);
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!(i1 & 7)) {
  STACKTOP = i15;
  return;
 }
 i3 = i1 >>> 24 & 15;
 i5 = (HEAP32[gb + 90260 + 24 + (i3 << 2) >> 2] | 0) + i12 | 0;
 i4 = i12 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i12 >> 2] | 0, i3) | 0;
  HEAP32[i4 >> 2] = i2;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if (i1 & 1) {
  HEAP16[i13 >> 1] = HEAP16[i2 >> 1] | 0;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i13);
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if (i1 & 2) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i5, HEAP8[i2 + 2 >> 0] | 0);
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if (!(i1 & 4)) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i5 + 11 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
 STACKTOP = i15;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 4 | 0;
 i1 = i13;
 i11 = i14 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i14 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i11 >> 2] = i3;
  i1 = i9;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 * 28 | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 * 28 | 0) | 0)) _memset(i4 | 0, 0, i3 - (((i3 + -28 | 0) >>> 0) % 28 | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i9 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i8 = i1 + (i9 * 28 | 0) | 0;
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i9 = i14 + 4 | 0;
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  }
  i6 = i1 + 8 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i11, i10, 4);
   i2 = HEAP32[i10 >> 2] | 0;
  } else {
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i10 >> 2] = i7;
   HEAP32[i11 >> 2] = i2;
   i2 = i7;
  }
  HEAP32[i1 + 4 >> 2] = i2;
  if (!i2) HEAP32[i6 >> 2] = 0; else {
   i3 = i2 << 2;
   i4 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i3 | 0, 4) | 0;
   if ((i4 | 0) != (i4 + (i2 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
   i5 = i6;
   i3 = i4 | 0 ? i4 - i5 | 0 : 0;
   HEAP32[i6 >> 2] = i3;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i14, i3 + i5 | 0, i2 << 2);
  }
  i6 = i1 + 20 | 0;
  i7 = i1 + 16 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i11, i10, 4);
   i2 = HEAP32[i10 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i11 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = i2;
  if (!i2) HEAP32[i6 >> 2] = 0; else {
   i3 = i2 << 2;
   i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
   if ((i4 | 0) != (i4 + (i2 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
   i5 = i6;
   i3 = i4 | 0 ? i4 - i5 | 0 : 0;
   HEAP32[i6 >> 2] = i3;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i14, i3 + i5 | 0, i2 << 2);
  }
  i6 = i1 + 24 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i11, i10, 4);
   i4 = HEAP32[i10 >> 2] | 0;
  } else {
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i11 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = i4;
  if (!i4) HEAP32[i6 >> 2] = 0; else {
   i2 = i4 << 2;
   i3 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, 4) | 0;
   if ((i3 | 0) != (i3 + (i4 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
   i4 = i6;
   i3 = i3 | 0 ? i3 - i4 | 0 : 0;
   HEAP32[i6 >> 2] = i3;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i14, i3 + i4 | 0, i2 << 2);
  }
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function _UNITY_TT_Load_Context(i10, i8, i1) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i10 + 396 >> 2] = HEAP32[i1 + 116 >> 2];
  HEAP32[i10 + 400 >> 2] = HEAP32[i1 + 120 >> 2];
  HEAP32[i10 + 408 >> 2] = HEAP32[i1 + 128 >> 2];
  HEAP32[i10 + 412 >> 2] = HEAP32[i1 + 132 >> 2];
  HEAP32[i10 + 404 >> 2] = HEAP32[i1 + 124 >> 2];
  HEAP32[i10 + 416 >> 2] = HEAP32[i1 + 136 >> 2];
  i2 = i10 + 244 | 0;
  i3 = i1 + 72 | 0;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i4 = i10 + 216 | 0;
  i3 = i1 + 44 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
  HEAP32[i10 + 420 >> 2] = HEAP32[i1 + 140 >> 2];
  HEAP32[i10 + 424 >> 2] = HEAP32[i1 + 144 >> 2];
  i4 = i1 + 148 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i10 + 444 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = i1 + 156 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i10 + 452 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i1 + 164 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i10 + 460 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = i10 + 284 | 0;
  i3 = i1 + 172 | 0;
  i4 = i2 + 68 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  HEAP32[i10 + 380 >> 2] = HEAP32[i1 + 240 >> 2];
  HEAP32[i10 + 384 >> 2] = HEAP32[i1 + 244 >> 2];
  HEAP16[i10 + 468 >> 1] = HEAP16[i1 + 248 >> 1] | 0;
  HEAP32[i10 + 472 >> 2] = HEAP32[i1 + 252 >> 2];
  i2 = i10 + 180 | 0;
  i3 = i1 + 256 | 0;
  i4 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i2 = i10 + 36 | 0;
  i4 = i2 + 108 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
 }
 i7 = i10 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = i10 + 24 | 0;
 i3 = HEAP32[i8 + 284 >> 2] | 0;
 i4 = (i3 & 65535) + 32 | 0;
 do if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i5, 1, i2 << 2, i4 << 2, HEAP32[i1 >> 2] | 0, i9) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) {
   i1 = i4;
   i3 = HEAP16[i8 + 286 >> 1] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   break;
  }
  HEAP32[i7 >> 2] = i2;
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i1 = i2;
  i3 = i3 >>> 16 & 65535;
 } while (0);
 HEAP32[i7 >> 2] = i1;
 i4 = i10 + 388 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i10 + 392 | 0;
 i3 = i3 & 65535;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = _UNITY_ft_mem_realloc(i5, 1, i1, i3, HEAP32[i2 >> 2] | 0, i9) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (!i2) i1 = i3; else {
   HEAP32[i4 >> 2] = i1 & 65535;
   i10 = i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 HEAP32[i4 >> 2] = i1 & 65535;
 i1 = i10 + 144 | 0;
 HEAP16[i10 + 152 >> 1] = 0;
 HEAP16[i10 + 154 >> 1] = 0;
 i2 = i10 + 72 | 0;
 i3 = i1;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i10 + 108 | 0;
 i3 = i1;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i10 + 36 | 0;
 i3 = i1;
 i4 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i10 + 488 >> 0] = 0;
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNK5Umbra17ImpTomeCollection9serializeERNS_12OutputStreamE(i3, i14) {
 i3 = i3 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 32 | 0;
 i6 = i18;
 i17 = i3 + 32 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 if (!i9) {
  i17 = 10;
  STACKTOP = i18;
  return i17 | 0;
 }
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i6 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i6 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 >> 2] = -419430399;
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 L4 : do if (!(HEAP8[i3 + 24 >> 0] | 0)) {
  HEAP32[i6 + 4 >> 2] = 32;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  i1 = (mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i6 | 0, 32) | 0) == 32;
  i1 = i1 ? 0 : 6;
 } else {
  i8 = i3 + 44 | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  i16 = i9 + 44 | 0;
  HEAP32[i6 + 4 >> 2] = i1 + 44 + ((((HEAP32[i16 >> 2] | 0) >>> 5) + i13 | 0) * 12 | 0);
  HEAP32[i2 >> 2] = 32;
  HEAP32[i6 + 24 >> 2] = i13;
  i13 = i3 + 40 | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  i12 = i3 + 36 | 0;
  HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
  if ((mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i6 | 0, 32) | 0) == 32) {
   i11 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i9 | 0, HEAP32[i5 >> 2] | 0) | 0;
   if ((i11 | 0) == (HEAP32[i5 >> 2] | 0)) {
    i11 = i9;
    L9 : do if ((HEAP32[i8 >> 2] | 0) > 0) {
     i2 = i15 + 4 | 0;
     i3 = i15 + 8 | 0;
     i1 = 0;
     while (1) {
      i7 = (HEAP32[i17 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) + (i1 << 5)) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i3 >> 2] = i7 - i11;
      i1 = i1 + 1 | 0;
      if ((mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i15 | 0, 12) | 0) != 12) break L9;
      if ((i1 | 0) >= (HEAP32[i8 >> 2] | 0)) {
       i10 = 10;
       break;
      }
     }
    } else i10 = 10; while (0);
    L14 : do if ((i10 | 0) == 10) {
     i5 = HEAP32[i9 + 160 >> 2] | 0;
     i5 = (i5 | 0) == 0 ? 0 : i9 + i5 | 0;
     if ((HEAP32[i16 >> 2] | 0) >>> 0 > 31) {
      i6 = i15 + 4 | 0;
      i7 = i15 + 8 | 0;
      i8 = i15 + 4 | 0;
      i9 = i15 + 8 | 0;
      i4 = 0;
      do {
       i2 = i5 + (i4 << 3) | 0;
       i3 = HEAP32[i2 >> 2] | 0;
       i1 = HEAP32[i12 >> 2] | 0;
       if (!i1) i1 = 0; else i1 = (HEAP32[i17 >> 2] | 0) + (i1 + (i4 << 5)) | 0;
       do if (i3 | 0) {
        if (!(HEAP32[i3 + 44 >> 2] & 2)) {
         i1 = HEAP32[i1 >> 2] | 0;
         if ((i1 | 0) == -1) break;
         i10 = HEAP32[(HEAP32[i17 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) + (i1 << 5)) >> 2] | 0;
         HEAP32[i15 >> 2] = i1;
         HEAP32[i6 >> 2] = i3 - i10;
         HEAP32[i7 >> 2] = i2 - i11;
         i1 = (mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i15 | 0, 12) | 0) != 12 & 1;
        } else {
         HEAP32[i15 >> 2] = -1;
         HEAP32[i8 >> 2] = i3 - i11;
         HEAP32[i9 >> 2] = i2 - i11;
         i1 = (mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i15 | 0, 12) | 0) == 12;
         i1 = i1 ? 7 : 1;
        }
        switch (i1 & 7) {
        case 7:
        case 0:
         break;
        default:
         break L14;
        }
       } while (0);
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) < ((HEAP32[i16 >> 2] | 0) >>> 5 | 0));
     }
     HEAP32[i15 >> 2] = -2;
     i1 = (mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i15 | 0, 12) | 0) == 12;
     i1 = i1 ? 0 : 6;
     break L4;
    } while (0);
    HEAP32[i15 >> 2] = -2;
    mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i15 | 0, 12) | 0;
    i1 = 6;
   } else i1 = 6;
  } else i1 = 6;
 } while (0);
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZL7EdgeLeqP14TESStesselatorP12ActiveRegionS2_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f2 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i15 = HEAP32[i1 + 72 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 16 >> 2] | 0;
 i14 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + 16 >> 2] | 0;
 i3 = (i14 | 0) == (i15 | 0);
 if ((i4 | 0) != (i15 | 0)) {
  i11 = HEAP32[i1 + 16 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i15 + 24 >> 2]);
  f9 = Math_fround(f12 - Math_fround(HEAPF32[i4 + 24 >> 2]));
  f7 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) - f12);
  f8 = Math_fround(f9 + f7);
  i1 = f8 > Math_fround(0.0);
  if (i3) {
   if (i1) {
    f12 = Math_fround(HEAPF32[i15 + 28 >> 2]);
    f10 = Math_fround(f9 * Math_fround(f12 - Math_fround(HEAPF32[i11 + 28 >> 2])));
    i1 = Math_fround(f10 + Math_fround(f7 * Math_fround(f12 - Math_fround(HEAPF32[i4 + 28 >> 2])))) >= Math_fround(0.0);
   } else i1 = 1;
   i15 = i1 & 1;
   return i15 | 0;
  }
  do if (i1) {
   f6 = Math_fround(HEAPF32[i15 + 28 >> 2]);
   f5 = Math_fround(HEAPF32[i4 + 28 >> 2]);
   f2 = Math_fround(HEAPF32[i11 + 28 >> 2]);
   if (f9 < f7) {
    f10 = Math_fround(Math_fround(f6 - f5) + Math_fround(Math_fround(f9 / f8) * Math_fround(f5 - f2)));
    break;
   } else {
    f10 = Math_fround(Math_fround(f6 - f2) + Math_fround(Math_fround(f7 / f8) * Math_fround(f2 - f5)));
    break;
   }
  } else f10 = Math_fround(0.0); while (0);
  i1 = HEAP32[i13 + 16 >> 2] | 0;
  f9 = Math_fround(f12 - Math_fround(HEAPF32[i14 + 24 >> 2]));
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) - f12);
  f8 = Math_fround(f9 + f7);
  do if (f8 > Math_fround(0.0)) {
   f6 = Math_fround(HEAPF32[i15 + 28 >> 2]);
   f5 = Math_fround(HEAPF32[i14 + 28 >> 2]);
   f2 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (f9 < f7) {
    f2 = Math_fround(Math_fround(f6 - f5) + Math_fround(Math_fround(f9 / f8) * Math_fround(f5 - f2)));
    break;
   } else {
    f2 = Math_fround(Math_fround(f6 - f2) + Math_fround(Math_fround(f7 / f8) * Math_fround(f2 - f5)));
    break;
   }
  } else f2 = Math_fround(0.0); while (0);
  i15 = f10 >= f2 & 1;
  return i15 | 0;
 }
 if (!i3) {
  i1 = HEAP32[i13 + 16 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i15 + 24 >> 2]);
  f2 = Math_fround(f5 - Math_fround(HEAPF32[i14 + 24 >> 2]));
  f5 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) - f5);
  if (Math_fround(f2 + f5) > Math_fround(0.0)) {
   f12 = Math_fround(HEAPF32[i15 + 28 >> 2]);
   f10 = Math_fround(f2 * Math_fround(f12 - Math_fround(HEAPF32[i1 + 28 >> 2])));
   i1 = Math_fround(f10 + Math_fround(f5 * Math_fround(f12 - Math_fround(HEAPF32[i14 + 28 >> 2])))) <= Math_fround(0.0);
  } else i1 = 1;
  i15 = i1 & 1;
  return i15 | 0;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 do if (!(f6 < f2)) {
  if (f6 == f2) {
   f12 = Math_fround(HEAPF32[i3 + 28 >> 2]);
   if (f12 <= Math_fround(HEAPF32[i1 + 28 >> 2])) break;
  }
  f5 = Math_fround(f2 - Math_fround(HEAPF32[i15 + 24 >> 2]));
  f2 = Math_fround(f6 - f2);
  if (Math_fround(f5 + f2) > Math_fround(0.0)) {
   f12 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   f10 = Math_fround(f5 * Math_fround(f12 - Math_fround(HEAPF32[i3 + 28 >> 2])));
   i1 = Math_fround(f10 + Math_fround(f2 * Math_fround(f12 - Math_fround(HEAPF32[i15 + 28 >> 2])))) >= Math_fround(0.0);
  } else i1 = 1;
  i15 = i1 & 1;
  return i15 | 0;
 } while (0);
 f5 = Math_fround(f6 - Math_fround(HEAPF32[i15 + 24 >> 2]));
 f2 = Math_fround(f2 - f6);
 if (Math_fround(f5 + f2) > Math_fround(0.0)) {
  f12 = Math_fround(HEAPF32[i3 + 28 >> 2]);
  f10 = Math_fround(f5 * Math_fround(f12 - Math_fround(HEAPF32[i1 + 28 >> 2])));
  i1 = Math_fround(f10 + Math_fround(f2 * Math_fround(f12 - Math_fround(HEAPF32[i15 + 28 >> 2])))) <= Math_fround(0.0);
 } else i1 = 1;
 i15 = i1 & 1;
 return i15 | 0;
}

function __ZNK5physx2Sc8SimStats7readOutERNS_22PxSimulationStatisticsERKNS_11PxvSimStatsE(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 896 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 __ZN5physx22PxSimulationStatisticsC2Ev(i2);
 _memcpy(i4 | 0, i2 | 0, 888) | 0;
 i2 = 0;
 do {
  i1 = i3 + 48 + (i2 * 28 | 0) | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  if (i2 | 0) {
   i7 = i4 + 676 + (i2 << 2) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  }
  i1 = i3 + 48 + (i2 * 28 | 0) + 4 | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  if ((i2 | 0) != 1) {
   i7 = i4 + 704 + (i2 << 2) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  }
  i1 = i3 + 48 + (i2 * 28 | 0) + 8 | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) + 8 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  if ((i2 | 0) != 2) {
   i7 = i4 + 732 + (i2 << 2) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  }
  i1 = i3 + 48 + (i2 * 28 | 0) + 12 | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) + 12 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  if ((i2 | 0) != 3) {
   i7 = i4 + 760 + (i2 << 2) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  }
  i1 = i3 + 48 + (i2 * 28 | 0) + 16 | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) + 16 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  if ((i2 | 0) != 4) {
   i7 = i4 + 788 + (i2 << 2) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  }
  i7 = i3 + 48 + (i2 * 28 | 0) + 20 | 0;
  i1 = i4 + 676 + (i2 * 28 | 0) + 20 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (HEAP32[i7 >> 2] | 0);
  i1 = i4 + 816 + (i2 << 2) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (HEAP32[i7 >> 2] | 0);
  i1 = i3 + 48 + (i2 * 28 | 0) + 24 | 0;
  i7 = i4 + 676 + (i2 * 28 | 0) + 24 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  i7 = i4 + 844 + (i2 << 2) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 5);
 HEAP32[i4 + 64 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 76 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 68 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 80 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 72 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 84 >> 2] = HEAP32[i3 + 20 >> 2];
 i1 = 0;
 do {
  HEAP32[i4 + 88 + (i1 * 28 | 0) + (i1 << 2) >> 2] = HEAP32[i5 + (i1 * 28 | 0) + (i1 << 2) >> 2];
  HEAP32[i4 + 480 + (i1 * 28 | 0) + (i1 << 2) >> 2] = HEAP32[i5 + 392 + (i1 * 28 | 0) + (i1 << 2) >> 2];
  HEAP32[i4 + 284 + (i1 * 28 | 0) + (i1 << 2) >> 2] = HEAP32[i5 + 196 + (i1 * 28 | 0) + (i1 << 2) >> 2];
  i2 = i1;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 < 7) {
   i3 = i1;
   do {
    i7 = HEAP32[i5 + (i2 * 28 | 0) + (i3 << 2) >> 2] | 0;
    HEAP32[i4 + 88 + (i2 * 28 | 0) + (i3 << 2) >> 2] = i7;
    HEAP32[i4 + 88 + (i3 * 28 | 0) + (i2 << 2) >> 2] = i7;
    i7 = HEAP32[i5 + 392 + (i2 * 28 | 0) + (i3 << 2) >> 2] | 0;
    HEAP32[i4 + 480 + (i2 * 28 | 0) + (i3 << 2) >> 2] = i7;
    HEAP32[i4 + 480 + (i3 * 28 | 0) + (i2 << 2) >> 2] = i7;
    i7 = HEAP32[i5 + 196 + (i2 * 28 | 0) + (i3 << 2) >> 2] | 0;
    HEAP32[i4 + 284 + (i2 * 28 | 0) + (i3 << 2) >> 2] = i7;
    HEAP32[i4 + 284 + (i3 * 28 | 0) + (i2 << 2) >> 2] = i7;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != 7);
  }
 } while ((i1 | 0) != 7);
 HEAP32[i4 + 872 >> 2] = HEAP32[i5 + 588 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 + 592 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 596 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 600 >> 2];
 HEAP32[i4 + 48 >> 2] = HEAP32[i5 + 604 >> 2];
 HEAP32[i4 + 60 >> 2] = HEAP32[i5 + 616 >> 2] << 14;
 HEAP32[i4 + 52 >> 2] = HEAP32[i5 + 608 >> 2];
 HEAP32[i4 + 56 >> 2] = HEAP32[i5 + 612 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN14RenderSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 1) | 0) {
  i4 = i5 + 28 | 0;
  i3 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 381810 | 0, HEAP32[gb + 36980 >> 2] | 0, i2, 1) | 0;
  if (i3 | 0) {
   if ((i3 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i4, i6); else {
    i2 = HEAP32[i2 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i8 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i5 + 32 >> 2] | 0;
  i3 = HEAP32[i5 + 36 >> 2] | 0;
  i4 = HEAP32[i5 + 40 >> 2] | 0;
  HEAP32[i5 + 44 >> 2] = i8;
  HEAP32[i5 + 48 >> 2] = i2;
  HEAP32[i5 + 52 >> 2] = i3;
  HEAP32[i5 + 56 >> 2] = i4;
  HEAP32[i5 + 60 >> 2] = i8;
  HEAP32[i5 + 64 >> 2] = i2;
  HEAP32[i5 + 68 >> 2] = i3;
  HEAP32[i5 + 72 >> 2] = i4;
  HEAP32[i5 + 188 >> 2] = 3;
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 4) | 0) if ((HEAP32[i5 + 188 >> 2] | 0) == 3) {
  i3 = HEAP32[i5 + 48 >> 2] | 0;
  i4 = HEAP32[i5 + 52 >> 2] | 0;
  i8 = HEAP32[i5 + 56 >> 2] | 0;
  HEAP32[i5 + 28 >> 2] = HEAP32[i5 + 44 >> 2];
  HEAP32[i5 + 32 >> 2] = i3;
  HEAP32[i5 + 36 >> 2] = i4;
  HEAP32[i5 + 40 >> 2] = i8;
 }
 if (__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 5) | 0) {
  if ((HEAP32[i5 + 188 >> 2] | 0) != 1) if ((__Z19GetActiveColorSpacev() | 0) == 1) {
   i2 = i5 + 184 | 0;
   f1 = Math_fround(HEAPF32[i2 >> 2]);
   do if (!(f1 <= Math_fround(0.0))) {
    if (f1 <= Math_fround(.00313080009)) {
     f1 = Math_fround(f1 * Math_fround(12.9200001));
     break;
    }
    if (f1 < Math_fround(1.0)) {
     f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
   } else f1 = Math_fround(0.0); while (0);
   HEAPF32[i2 >> 2] = f1;
  }
  i2 = i5 + 364 | 0;
  f1 = Math_fround(HEAPF32[i2 >> 2]);
  do if (!(f1 <= Math_fround(0.0))) {
   if (f1 <= Math_fround(.00313080009)) {
    f1 = Math_fround(f1 * Math_fround(12.9200001));
    break;
   }
   if (f1 < Math_fround(1.0)) {
    f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
    break;
   }
   if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
  } else f1 = Math_fround(0.0); while (0);
  HEAPF32[i2 >> 2] = f1;
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 6) | 0)) {
  STACKTOP = i7;
  return;
 }
 f1 = Math_fround(HEAPF32[i5 + 184 >> 2]);
 i8 = i5 + 28 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 32 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 36 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 40 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 44 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 48 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 52 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 56 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 60 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 64 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 68 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = i5 + 72 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 STACKTOP = i7;
 return;
}

function __ZN4crnd17crnd_unpack_beginEPKvj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i2 = i14;
 i10 = i14 + 32 | 0;
 i1 = i14 + 28 | 0;
 if ((i8 | 0) == 0 | i9 >>> 0 < 62) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i1 >> 2] = 300;
 i11 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, 0, 300, i1 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
 if ((i11 | 0) == 0 | (HEAP32[i1 >> 2] | 0) >>> 0 < 300) {
  HEAP32[i2 >> 2] = gb + 401209;
  HEAP32[i2 + 4 >> 2] = 2513;
  HEAP32[i2 + 8 >> 2] = gb + 401368;
  _sprintf(i10, gb + 401176 | 0, i2) | 0;
  _puts(i10) | 0;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i11 >> 2] = 519686845;
 i1 = i11 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i11 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i11 + 88 | 0;
 i3 = i11 + 136 | 0;
 i4 = i11 + 160 | 0;
 i5 = i7;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i7 + 44 >> 0] = 0;
 i15 = i11 + 184 | 0;
 i5 = i11 + 208 | 0;
 i6 = i11 + 232 | 0;
 i16 = i11 + 252 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP8[i16 + 12 >> 0] = 0;
 i16 = i11 + 268 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP8[i16 + 12 >> 0] = 0;
 i16 = i11 + 284 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP8[i16 + 12 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP8[i3 + 20 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP8[i15 + 20 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP8[i5 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP8[i6 + 16 >> 0] = 0;
 do if (i9 >>> 0 < 74) i13 = 8; else if (((HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0) | 0) == 18552) if (((HEAPU8[i8 + 2 >> 0] | 0) << 8 | (HEAPU8[i8 + 3 >> 0] | 0)) >>> 0 < 74) i13 = 8; else if (((HEAPU8[i8 + 7 >> 0] | 0) << 16 | (HEAPU8[i8 + 6 >> 0] | 0) << 24 | (HEAPU8[i8 + 8 >> 0] | 0) << 8 | (HEAPU8[i8 + 9 >> 0] | 0)) >>> 0 > i9 >>> 0) i13 = 8; else {
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i2 >> 2] = i9;
  if (__ZN4crnd12crn_unpacker11init_tablesEv(i11) | 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((HEAPU8[i1 + 39 >> 0] | 0) << 8 | (HEAPU8[i1 + 40 >> 0] | 0)) {
    if (!(__ZN4crnd12crn_unpacker22decode_color_endpointsEv(i11) | 0)) break;
    if (!(__ZN4crnd12crn_unpacker22decode_color_selectorsEv(i11) | 0)) break;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   if (!((HEAPU8[i1 + 55 >> 0] | 0) << 8 | (HEAPU8[i1 + 56 >> 0] | 0))) {
    i16 = i11;
    STACKTOP = i14;
    return i16 | 0;
   }
   if (__ZN4crnd12crn_unpacker22decode_alpha_endpointsEv(i11) | 0) if (__ZN4crnd12crn_unpacker22decode_alpha_selectorsEv(i11) | 0) {
    i16 = i11;
    STACKTOP = i14;
    return i16 | 0;
   }
  }
 } else i13 = 8; while (0);
 if ((i13 | 0) == 8) HEAP32[i7 >> 2] = 0;
 __ZN4crnd12crn_unpackerD2Ev(i11);
 if (!(i11 & 7)) {
  mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i11 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  i16 = 0;
  STACKTOP = i14;
  return i16 | 0;
 } else {
  HEAP32[i12 >> 2] = gb + 401209;
  HEAP32[i12 + 4 >> 2] = 2513;
  HEAP32[i12 + 8 >> 2] = gb + 401349;
  _sprintf(i10, gb + 401176 | 0, i12) | 0;
  _puts(i10) | 0;
  i16 = 0;
  STACKTOP = i14;
  return i16 | 0;
 }
 return 0;
}

function __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 8 | 0;
 i5 = i10;
 i7 = i9 + 172 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 9;
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
  i6 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 16; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 18;
    }
   }
   if ((i8 | 0) == 16) i8 = 18;
   if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  }
  __Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture(i6, i6, Math_fround(1.0), i1) | 0;
  i1 = i9 + 164 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i8 = i9 + 176 | 0;
   HEAP8[i8 >> 0] = 1;
   i8 = i9 + 144 | 0;
   HEAP8[i8 >> 0] = 0;
   i8 = __Z14GetTimeManagerv() | 0;
   i8 = i8 + 132 | 0;
   i8 = HEAP32[i8 >> 2] | 0;
   i11 = i9 + 148 | 0;
   HEAP32[i11 >> 2] = i8;
   STACKTOP = i10;
   return;
  }
  __Z19DestroySingleObjectP6Object(i2);
  HEAP32[i1 >> 2] = 0;
  i8 = i9 + 176 | 0;
  HEAP8[i8 >> 0] = 1;
  i8 = i9 + 144 | 0;
  HEAP8[i8 >> 0] = 0;
  i8 = __Z14GetTimeManagerv() | 0;
  i8 = i8 + 132 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i11 = i9 + 148 | 0;
  HEAP32[i11 >> 2] = i8;
  STACKTOP = i10;
  return;
 } while (0);
 i2 = i9 + 164 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i11 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 8;
  i1 = __Z15GetGraphicsCapsv() | 0;
  if (i11) if (!(HEAP8[i1 + 704 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 726 >> 0] | 0) != 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 20;
  i1 = __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb(i9, i1) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i8 = HEAP32[i6 + 20 >> 2] | 0;
 __Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture(i8, i8, Math_fround(1.0), i1) | 0;
 i8 = i9 + 176 | 0;
 HEAP8[i8 >> 0] = 1;
 i8 = i9 + 144 | 0;
 HEAP8[i8 >> 0] = 0;
 i8 = __Z14GetTimeManagerv() | 0;
 i8 = i8 + 132 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i11 = i9 + 148 | 0;
 HEAP32[i11 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function __ZN15DetailPrototypeC2ERKS_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i10;
 i2 = i9;
 i3 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i10 + 76 | 0;
 i4 = i9 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i10 + 80 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i10 + 84 >> 2] = 0;
 i5 = i9 + 80 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i2 = (i1 | 0) / 12 | 0;
 if (i1 | 0) {
  if (i2 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
  i1 = __Znwj(i1) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 + 84 >> 2] = i1 + (i2 * 12 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i2 + 12 | 0;
    i1 = i1 + 12 | 0;
   } while ((i2 | 0) != (i3 | 0));
   HEAP32[i6 >> 2] = i1;
  }
 }
 i2 = i10 + 88 | 0;
 i3 = i9 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i10 + 92 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i10 + 96 >> 2] = 0;
 i5 = i9 + 92 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 12 | 0;
 if (i1 | 0) {
  if (i4 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i1 = __Znwj(i1) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 + 96 >> 2] = i1 + (i4 * 12 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i2 + 12 | 0;
    i1 = i1 + 12 | 0;
   } while ((i2 | 0) != (i3 | 0));
   HEAP32[i6 >> 2] = i1;
  }
 }
 i2 = i10 + 100 | 0;
 i3 = i9 + 100 | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i10 + 104 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 108 >> 2] = 0;
 i5 = i9 + 104 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 >> 3;
 if (i4 | 0) {
  if (i4 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i7 = __Znwj(i1) | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i2 >> 2] = i7;
  HEAP32[i10 + 108 >> 2] = i7 + (i4 << 3);
  i6 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i2 | 0)) {
   i3 = i2 + -8 | 0;
   i1 = i6;
   i4 = i7;
   while (1) {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i2 | 0)) break; else i4 = i4 + 8 | 0;
   }
   HEAP32[i8 >> 2] = i7 + (((i3 - i6 | 0) >>> 3) + 1 << 3);
  }
 }
 i2 = i10 + 112 | 0;
 i3 = i9 + 112 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i10 + 116 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 120 >> 2] = 0;
 i5 = i9 + 116 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 >> 2;
 if (i4 | 0) {
  if (i4 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i6 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i10 + 120 >> 2] = i6 + (i4 << 2);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i6 + (i1 >> 2 << 2);
  }
 }
 i3 = i10 + 124 | 0;
 i4 = i9 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i10 + 128 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 132 >> 2] = 0;
 i5 = i9 + 128 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i2 = i1 >> 1;
 if (!i2) return;
 if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
 i6 = __Znwj(i1) | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i10 + 132 >> 2] = i6 + (i2 << 1);
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) return;
 _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6 + (i1 >> 1 << 1);
 return;
}

function __Z12PlayerRenderb(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i8 = i9;
 i1 = __Z12GetGfxDevicev() | 0;
 while (1) {
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0) break;
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 520 >> 2] | 0, i1 | 0) | 0)) {
   i5 = 4;
   break;
  }
 }
 if ((i5 | 0) == 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 583694 | 0, 0, gb + 583770 | 0, 718, 4, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 __ZN13RenderManager22RenderOffscreenCamerasEv(__Z16GetRenderManagerv() | 0);
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 if (!(HEAP8[(__Z12GetGfxDevicev() | 0) + 4192 >> 0] | 0)) {
  i4 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 496 >> 2] | 0, i4 | 0);
 }
 __ZN13RenderManager13RenderCamerasEiPFvvE(__Z16GetRenderManagerv() | 0, 0, 0);
 i1 = HEAP32[gb + 1115296 + 412 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, 0);
 i1 = __Z19GetScreenManagerPtrv() | 0;
 if (!i1) i5 = 16; else if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0) {
  i4 = __Z12GetGfxDevicev() | 0;
  i1 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, 0);
  i3 = HEAP32[gb + 1115296 + 416 >> 2] | 0;
  if (i3 | 0) mftCall_vi(i3 | 0, 0);
  __Z23DrawSplashAndWatermarksv();
  __ZN7Cursors20RenderSoftwareCursorEv();
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 852 >> 2] | 0, i4 | 0, 1);
  i1 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, 0);
  i3 = HEAP32[gb + 1115296 + 416 >> 2] | 0;
  if (i3 | 0) mftCall_vi(i3 | 0, 0);
  __Z23DrawSplashAndWatermarksv();
  __ZN7Cursors20RenderSoftwareCursorEv();
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 852 >> 2] | 0, i4 | 0, 0);
 } else i5 = 16;
 if ((i5 | 0) == 16) {
  i1 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, 0);
  i3 = HEAP32[gb + 1115296 + 416 >> 2] | 0;
  if (i3 | 0) mftCall_vi(i3 | 0, 0);
  __Z23DrawSplashAndWatermarksv();
  __ZN7Cursors20RenderSoftwareCursorEv();
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0);
 }
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i1 | 0);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 884 >> 2] | 0, i1 | 0) | 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 880 >> 2] | 0, i1 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0);
  i5 = __ZN10DynamicVBO9NextFrameEv() | 0;
  i4 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 512 >> 2] | 0, i4 | 0, i5 | 0);
 }
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 __Z20SetHasFrameToPresentb(1);
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 500 >> 2] | 0, i1 | 0);
 if ((HEAP16[gb + 1450840 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450840 | 0, i6);
  i1 = gb + 1450840 | 0;
 } else i1 = 0;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 508 >> 2] | 0, i8 | 0, 0);
 __Z15gpu_time_samplev();
 __Z20SetHasFrameToPresentb(0);
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i9;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRK8Vector2fS3_EPS1_EEbT0_S8_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 switch (i7 - i8 >> 3 | 0) {
 case 2:
  {
   i1 = i7 + -8 | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i8 | 0) | 0)) {
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i6 = HEAP32[i8 >> 2] | 0;
   i7 = HEAP32[i8 + 4 >> 2] | 0;
   i4 = i1;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = i8;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = i5;
   i9 = i1;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i7;
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i8, i8 + 8 | 0, i7 + -8 | 0, i9) | 0;
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 4:
  {
   i2 = i8 + 8 | 0;
   i3 = i8 + 16 | 0;
   i1 = i7 + -8 | 0;
   __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i8, i2, i3, i9) | 0;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i3 | 0) | 0)) {
    i9 = 1;
    STACKTOP = i10;
    return i9 | 0;
   }
   i5 = HEAP32[i3 >> 2] | 0;
   i6 = HEAP32[i8 + 20 >> 2] | 0;
   i11 = i1;
   i4 = HEAP32[i11 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = i4;
   i7 = i1;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
    i11 = 1;
    STACKTOP = i10;
    return i11 | 0;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i8 + 12 >> 2] | 0;
   i4 = i3;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i11 + 4 >> 2] = i5;
   i11 = i3;
   HEAP32[i11 >> 2] = i6;
   HEAP32[i11 + 4 >> 2] = i7;
   if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i2 | 0, i8 | 0) | 0)) {
    i11 = 1;
    STACKTOP = i10;
    return i11 | 0;
   }
   i7 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i5 = i2;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = i8;
   HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i11 + 4 >> 2] = i6;
   i11 = i2;
   HEAP32[i11 >> 2] = i7;
   HEAP32[i11 + 4 >> 2] = i9;
   i11 = 1;
   STACKTOP = i10;
   return i11 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i8 + 24 | 0, i7 + -8 | 0, i9) | 0;
   i11 = 1;
   STACKTOP = i10;
   return i11 | 0;
  }
 case 1:
 case 0:
  {
   i11 = 1;
   STACKTOP = i10;
   return i11 | 0;
  }
 default:
  {
   i2 = i8 + 16 | 0;
   __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i8, i8 + 8 | 0, i2, i9) | 0;
   i1 = i8 + 24 | 0;
   L3 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i6 = i5 + 4 | 0;
    i4 = i1;
    i1 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i2 | 0) | 0) {
      HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i6 >> 2] = HEAP32[i4 + 4 >> 2];
      i3 = i4;
      while (1) {
       i13 = i2;
       i12 = HEAP32[i13 + 4 >> 2] | 0;
       i11 = i3;
       HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i11 + 4 >> 2] = i12;
       if ((i2 | 0) == (i8 | 0)) break;
       i3 = i2 + -8 | 0;
       if (mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i3 | 0) | 0) {
        i13 = i2;
        i2 = i3;
        i3 = i13;
       } else break;
      }
      i11 = i5;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i13 = i2;
      HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i13 + 4 >> 2] = i12;
      i1 = i1 + 1 | 0;
      if ((i1 | 0) == 8) {
       i2 = 0;
       i1 = (i4 + 8 | 0) == (i7 | 0);
       break L3;
      }
     }
     i2 = i4 + 8 | 0;
     if ((i2 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i13 = i4;
      i4 = i2;
      i2 = i13;
     }
    }
   } while (0);
   i13 = i1 | i2;
   STACKTOP = i10;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + 4;
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i5 + 8 >> 2] = i4;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i7, i5, 0);
 i4 = i6 + 8 | 0;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i7 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 20 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 24 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 28 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 32 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 36 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 37 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i4 = i6 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i6 + 44 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 45 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN11Rigidbody2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
 i5 = i8 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i10 = i6 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i7 = i6 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i1 = i8 + 48 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i8 + 50 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i8 + 49 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 72 | 0, i6);
 i5 = i8 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i5 = i8 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i5 = i8 + 64 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i1 = i8 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 }
}

function __ZN13MonoBehaviour13AwakeFromLoadE17AwakeFromLoadMode(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 488 | 0;
 i11 = i15 + 248 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i5 = i9 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN10GameObject25SetSupportedMessagesDirtyEv(i1);
 i7 = i9 + 20 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (!i8) {
  __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i9, i10);
  STACKTOP = i15;
  return;
 }
 do if (i10 & 16 | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = HEAP32[i9 + 56 >> 2] | 0;
   if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) break;
   i2 = HEAP32[i9 + 60 >> 2] | 0;
   i1 = HEAP32[i2 + 152 >> 2] | 0;
   i2 = HEAP32[i2 + 156 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAP32[i5 >> 2] | 0;
    if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i12 >> 2] = i1;
     HEAP32[i12 + 4 >> 2] = i2;
     HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i11, i4, i14);
     HEAP32[i11 + 216 >> 2] = HEAP32[i9 + 4 >> 2];
     HEAP32[i14 >> 2] = 0;
     __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i11, i14, 0) | 0;
    }
   }
  }
 } while (0);
 i4 = i9 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i6 = 17; else if (!(HEAP8[i1 + 36 >> 0] | 0)) i6 = 17;
 if ((i6 | 0) == 17) if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 112 >> 2] | 0, i9 | 0) | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i9, i10);
   STACKTOP = i15;
   return;
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i6 = 24; else if (!(HEAP8[i1 + 36 >> 0] | 0)) i6 = 24; else {
  i1 = i9 + 140 | 0;
  i5 = 0;
 }
 if ((i6 | 0) == 24) {
  i1 = i9 + 140 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i5 = 0; else i5 = __ZNK10GameObject8IsActiveEv(i2) | 0;
  } else i5 = 0;
 }
 i3 = (HEAP8[i1 >> 0] | 0) == 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (i2 | 0) == 0;
 if (i3) if (i1) {
  i2 = 0;
  i1 = 0;
 } else if (!(HEAP8[i2 + 36 >> 0] | 0)) {
  i1 = ((HEAP32[i2 + 28 >> 2] | 0) + -1 | 0) >>> 0 < 2;
  i6 = 32;
 } else {
  i1 = 0;
  i6 = 32;
 } else if (i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  i6 = 32;
 }
 do if ((i6 | 0) == 32) {
  i2 = HEAP16[i2 + 36 >> 1] | 0;
  if (!((i2 & 255) << 24 >> 24)) i2 = 0; else {
   if ((i2 & 65535) < 256) {
    if ((HEAP32[i9 + 8 >> 2] & 1048576 | 0) != 0 | i3 ^ 1) {
     i2 = 0;
     break;
    }
   } else if (!i3) {
    i2 = 0;
    break;
   }
   i2 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 112 >> 2] | 0, i9 | 0) | 0;
  }
 } while (0);
 if (i5 | i1 | i2) {
  __ZN13MonoBehaviour9CallAwakeEv(i9);
  if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0)) {
   STACKTOP = i15;
   return;
  }
 }
 if (i1 | i2) {
  i1 = HEAP32[i9 + 60 >> 2] | 0;
  i2 = HEAP32[i1 + 64 >> 2] | 0;
  if (i2 | 0) {
   i5 = HEAP32[i1 + 68 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i6 = i13;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i12, i7, i14);
   HEAP8[i12 + 233 >> 0] = 1;
   HEAP32[i12 + 216 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i12);
   __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i12, i11) | 0;
   if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0)) {
    STACKTOP = i15;
    return;
   }
  }
 }
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i9, i10);
 STACKTOP = i15;
 return;
}

function __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 744104 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801720 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827416 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827423 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_117FixedJointProjectEPKvRN5physx11PxTransformES4_b(i19, i15, i16, i20) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 84 | 0;
 i18 = i22 + 56 | 0;
 i2 = i22 + 28 | 0;
 i21 = i22;
 __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i19, i15, i16, i17, i18, i2);
 f7 = Math_fround(HEAPF32[i19 + 72 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f5 = Math_fround(f1 * f1);
 f3 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f4 * f4));
 i14 = f5 > Math_fround(f7 * f7);
 if (i14) {
  f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
  f4 = Math_fround(f7 * Math_fround(f4 * f13));
  f3 = Math_fround(f7 * Math_fround(f3 * f13));
  f1 = Math_fround(f7 * Math_fround(f1 * f13));
 }
 HEAPF32[i21 + 16 >> 2] = f1;
 HEAPF32[i21 + 20 >> 2] = f3;
 HEAPF32[i21 + 24 >> 2] = f4;
 f12 = Math_fround(Math_fround(HEAPF32[i19 + 76 >> 2]) * Math_fround(.5));
 f7 = Math_fround(+Math_sin(+f12));
 f12 = Math_fround(+Math_cos(+f12));
 do if (f7 > Math_fround(.999899983)) {
  i10 = HEAP32[i2 >> 2] | 0;
  i9 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = HEAP32[i2 + 8 >> 2] | 0;
  i6 = HEAP32[i2 + 12 >> 2] | 0;
  i2 = 0;
 } else {
  f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  if (!(f13 >= Math_fround(0.0))) {
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   f24 = Math_fround(-f3);
   f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f23 = Math_fround(-f4);
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f1 = Math_fround(-f5);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i11 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i6 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i2 + 4 >> 2] | 0;
   i8 = HEAP32[i2 + 8 >> 2] | 0;
   i11 = i6;
   i2 = i6;
   i6 = i9;
   i10 = i8;
  }
  f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(f5 * f5);
  f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f4 * f4) + f3);
  f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(Math_fround(f1 * f1) + f3);
  i10 = f3 > Math_fround(f7 * f7);
  i2 = i10 & 1;
  if (i10) {
   f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
   f13 = Math_fround(Math_fround(f7 * f5) * f24);
   f23 = Math_fround(Math_fround(f7 * f4) * f24);
   f24 = Math_fround(Math_fround(f7 * f1) * f24);
   i10 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i9 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
   i8 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  } else {
   i10 = i11;
   i6 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 } while (0);
 HEAP32[i21 >> 2] = i10;
 HEAP32[i21 + 4 >> 2] = i9;
 HEAP32[i21 + 8 >> 2] = i8;
 HEAP32[i21 + 12 >> 2] = i6;
 if (i2 << 24 >> 24 == 0 & (i14 ^ 1)) {
  STACKTOP = i22;
  return;
 }
 __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i15, i16, i17, i18, i21, i19, i20);
 STACKTOP = i22;
 return;
}

function __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i3, i4, i9, i5, i2, i13, i1, i14) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 i11 = (i9 + 3 | 0) / 4 | 0;
 i12 = (i5 + 3 | 0) / 4 | 0;
 switch (i3 | 0) {
 case 10:
  {
   if ((i5 | 0) > 0) {
    i6 = i11 << 1;
    i7 = i13 << 2;
    if ((i9 | 0) > 0) {
     i4 = 0;
     do {
      i5 = Math_imul(i7, i4) | 0;
      i1 = 0;
      i3 = i2 + ((Math_imul(i6, i4) | 0) << 2) | 0;
      while (1) {
       __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i3, i10);
       __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i14 + (i1 << 2 << 2) + (i5 << 2) | 0, i3, i13, i10);
       i1 = i1 + 1 | 0;
       if ((i1 | 0) == (i11 | 0)) break; else i3 = i3 + 8 | 0;
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i12 | 0));
    }
   }
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 11:
  {
   __Z14DecompressDXT3iiiPKjPj(i11, i12, i13, i2, i14);
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 12:
  {
   HEAP8[i10 + 3 >> 0] = 0;
   HEAP8[i10 + 2 >> 0] = -1;
   HEAP8[i10 + 1 >> 0] = -1;
   HEAP8[i10 >> 0] = -1;
   i8 = HEAP32[i10 >> 2] | 0;
   if ((i5 | 0) > 0) {
    i6 = i11 << 2;
    i7 = i13 << 2;
    if ((i9 | 0) > 0) {
     i1 = 0;
     do {
      i5 = Math_imul(i7, i1) | 0;
      i3 = 0;
      i4 = i2 + ((Math_imul(i6, i1) | 0) << 2) | 0;
      while (1) {
       i16 = i4 + 8 | 0;
       __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i16, i10);
       i9 = i14 + (i3 << 2 << 2) + (i5 << 2) | 0;
       __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i9, i16, i13, i10);
       __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i9, i4, i13, i8, 0);
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i11 | 0)) break; else i4 = i4 + 16 | 0;
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i12 | 0));
    }
   }
   i16 = 1;
   STACKTOP = i15;
   return i16 | 0;
  }
 case 26:
  {
   if ((i5 | 0) <= 0) {
    i16 = 1;
    STACKTOP = i15;
    return i16 | 0;
   }
   i6 = i13 << 2;
   if ((i9 | 0) <= 0) {
    i16 = 1;
    STACKTOP = i15;
    return i16 | 0;
   }
   i5 = 0;
   while (1) {
    i1 = i14 + ((Math_imul(i6, i5) | 0) << 2) | 0;
    i3 = 0;
    i4 = i2;
    while (1) {
     __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i1, i4, i13, 0, 24);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i11 | 0)) break; else {
      i1 = i1 + 16 | 0;
      i4 = i4 + 8 | 0;
     }
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i12 | 0)) {
     i1 = 1;
     break;
    } else i2 = i2 + (i11 << 3) | 0;
   }
   STACKTOP = i15;
   return i1 | 0;
  }
 case 27:
  {
   if ((i5 | 0) <= 0) {
    i16 = 1;
    STACKTOP = i15;
    return i16 | 0;
   }
   i7 = i13 << 2;
   if ((i9 | 0) <= 0) {
    i16 = 1;
    STACKTOP = i15;
    return i16 | 0;
   }
   i6 = i11 << 1;
   i5 = 0;
   while (1) {
    i1 = i14 + ((Math_imul(i7, i5) | 0) << 2) | 0;
    i3 = 0;
    i4 = i2;
    while (1) {
     __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i1, i4, i13, 0, 24);
     __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i1, i4 + 8 | 0, i13, 16777215, 16);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i11 | 0)) break; else {
      i1 = i1 + 16 | 0;
      i4 = i4 + 16 | 0;
     }
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i12 | 0)) {
     i1 = 1;
     break;
    } else i2 = i2 + (i6 << 3) | 0;
   }
   STACKTOP = i15;
   return i1 | 0;
  }
 case 24:
  {
   __Z14DecompressBC6HiiiPKjPj13TextureFormat(i11, i12, i13, i2, i14, i4);
   i16 = 1;
   STACKTOP = i15;
   return i16 | 0;
  }
 case 25:
  {
   __Z13DecompressBC7iiiPKjPj(i11, i12, i13, i2, i14);
   i16 = 1;
   STACKTOP = i15;
   return i16 | 0;
  }
 default:
  {
   i16 = 0;
   STACKTOP = i15;
   return i16 | 0;
  }
 }
 return 0;
}

function __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = i6 - i7 >> 2;
 i1 = i7;
 if (i2 >>> 0 >= i12 >>> 0) {
  if (i2 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i5 = i1 + (i12 << 2) | 0;
  HEAP32[i13 >> 2] = 0;
  i7 = i13 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = i12 << 2;
  i3 = i2 >> 2;
  if (!i3) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i3 = 0;
   i2 = 0;
  } else {
   if (i3 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i4 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i13 >> 2] = i4;
   i2 = i4 + (i3 << 2) | 0;
   i6 = i13 + 8 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i4;
   if (!i12) {
    i4 = i6;
    i5 = i3;
   } else {
    i2 = i4;
    do {
     HEAP32[i2 >> 2] = 0;
     __ZN14ConstantString6assignERKS_(i2, i1);
     i1 = i1 + 4 | 0;
     i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
     HEAP32[i7 >> 2] = i2;
    } while ((i1 | 0) != (i5 | 0));
    i4 = i6;
    i5 = HEAP32[i13 >> 2] | 0;
    i3 = i2;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  }
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i5;
  i12 = HEAP32[i15 >> 2] | 0;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i15 >> 2] = i3;
  i3 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i1;
  i2 = i12;
  if (i1 | 0) {
   if ((i2 | 0) != (i3 | 0)) {
    i1 = i2;
    do {
     i15 = i1 + -4 | 0;
     HEAP32[i7 >> 2] = i15;
     __ZN14ConstantStringD2Ev(i15);
     i1 = HEAP32[i7 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i13 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if (((HEAP32[i9 >> 2] | 0) - i7 >> 2 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i2 = __Znwj(i12 << 2) | 0;
  i1 = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + (i12 << 2);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i3, i13);
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = i2 - i4 >> 2;
 i1 = i2;
 if (i3 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i3 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
 } else if (i3 >>> 0 > i12 >>> 0) {
  i3 = i4 + (i12 << 2) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i13 = i1 + -4 | 0;
    HEAP32[i10 >> 2] = i13;
    __ZN14ConstantStringD2Ev(i13);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i14 >> 2] = i3;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i15 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i3 = i1;
 i2 = i14;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2;
   do {
    i15 = i1 + -4 | 0;
    HEAP32[i10 >> 2] = i15;
    __ZN14ConstantStringD2Ev(i15);
    i1 = HEAP32[i10 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i9, i4, i1, i11, i7) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i5 = HEAP32[i9 + 8 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i2 + 96 >> 2] | 0;
 i10 = i5 + 44 | 0;
 if (HEAP32[i10 >> 2] | 0) if (HEAP32[i2 + 100 >> 2] | 0) {
  if (i11) i8 = i1 + 4 | 0; else {
   HEAP32[i1 >> 2] = HEAP32[i5 + 8 >> 2];
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = 0;
  }
  if (HEAP32[i5 + 12 >> 2] | 0) {
   i13 = i5 + 12 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i2 = i1 + 8 | 0;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = i12;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i2 + 1;
   if (HEAP32[i5 + 20 >> 2] | 0) {
    i14 = i5 + 20 | 0;
    i12 = HEAP32[i14 + 4 >> 2] | 0;
    i13 = i1 + 16 | 0;
    HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
    HEAP32[i8 >> 2] = i2 + 2;
    if (HEAP32[i5 + 28 >> 2] | 0) {
     i12 = i5 + 28 | 0;
     i13 = HEAP32[i12 + 4 >> 2] | 0;
     i14 = i1 + 24 | 0;
     HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i14 + 4 >> 2] = i13;
     HEAP32[i8 >> 2] = i2 + 3;
     if (HEAP32[i5 + 36 >> 2] | 0) {
      i12 = i5 + 36 | 0;
      i13 = HEAP32[i12 + 4 >> 2] | 0;
      i14 = i1 + 32 | 0;
      HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i14 + 4 >> 2] = i13;
      HEAP32[i8 >> 2] = i2 + 4;
     }
    }
   }
  }
  i2 = HEAP32[i9 + 20 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i14 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = i14 >>> 0 > 1 ? i14 : 1;
  }
  if (!i6) i2 = 0; else {
   i5 = HEAP32[i8 >> 2] | 0;
   if (!(HEAP32[i6 + 12 >> 2] | 0)) i2 = i5; else {
    i13 = i6 + 12 | 0;
    i14 = HEAP32[i13 + 4 >> 2] | 0;
    i2 = i1 + 8 + (i5 << 3) | 0;
    HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i2 + 4 >> 2] = i14;
    i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
    HEAP32[i8 >> 2] = i2;
    if (HEAP32[i6 + 20 >> 2] | 0) {
     i13 = i6 + 20 | 0;
     i14 = HEAP32[i13 + 4 >> 2] | 0;
     i2 = i1 + 8 + (i5 + 1 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i2 + 4 >> 2] = i14;
     i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
     HEAP32[i8 >> 2] = i2;
     if (HEAP32[i6 + 28 >> 2] | 0) {
      i13 = i6 + 28 | 0;
      i14 = HEAP32[i13 + 4 >> 2] | 0;
      i2 = i1 + 8 + (i5 + 2 << 3) | 0;
      HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i2 + 4 >> 2] = i14;
      i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
      HEAP32[i8 >> 2] = i2;
      if (HEAP32[i6 + 36 >> 2] | 0) {
       i13 = i6 + 36 | 0;
       i14 = HEAP32[i13 + 4 >> 2] | 0;
       i2 = i1 + 8 + (i5 + 3 << 3) | 0;
       HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
       HEAP32[i2 + 4 >> 2] = i14;
       i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
       HEAP32[i8 >> 2] = i2;
      }
     }
    }
   }
   if ((i5 | 0) == (i2 | 0)) i2 = 0; else {
    i3 = HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + 96 >> 2] | i3;
    i2 = HEAP32[i6 + 44 >> 2] | 0;
   }
  }
  if (i7) {
   i5 = HEAP32[i9 + 24 >> 2] | 0;
   if (i5) {
    i6 = HEAP32[i8 >> 2] | 0;
    if ((i6 | 0) < 4) {
     HEAP32[i1 + 8 + (i6 << 3) >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i1 + 8 + (i6 << 3) + 4 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     i4 = i4 | 2;
     i3 = i3 | 2;
     i2 = HEAP32[gb + 1161532 + 4 >> 2] | 0;
    }
   }
  }
  if (!i11) {
   i14 = __Z12GetGfxDevicev() | 0;
   __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj(i14, i1, HEAP32[(HEAP32[i9 >> 2] | 0) + 100 >> 2] | 0, i4, i3);
   HEAP32[i1 + 40 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(HEAP32[i10 >> 2] | 0, i4, i2) | 0;
  }
  if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i8 >> 2] | 0)) {
   i14 = 0;
   return i14 | 0;
  }
  i14 = 1;
  return i14 | 0;
 }
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i14 = 0;
 return i14 | 0;
}

function runPostSets7() {
 HEAP32[gb + 27988 >> 2] = fb + 63;
 HEAP32[gb + 27992 >> 2] = fb + 29;
 HEAP32[gb + 27996 >> 2] = fb + 34;
 HEAP32[gb + 28e3 >> 2] = fb + 73;
 HEAP32[gb + 28004 >> 2] = fb + 74;
 HEAP32[gb + 28008 >> 2] = fb + 75;
 HEAP32[gb + 28012 >> 2] = fb + 76;
 HEAP32[gb + 28016 >> 2] = fb + 77;
 HEAP32[gb + 28020 >> 2] = fb + 78;
 HEAP32[gb + 28024 >> 2] = fb + 36;
 HEAP32[gb + 28036 >> 2] = (HEAP32[gb + 28036 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28040 >> 2] = (HEAP32[gb + 28040 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28076 >> 2] = (HEAP32[gb + 28076 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28080 >> 2] = (HEAP32[gb + 28080 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28116 >> 2] = fb + 69;
 HEAP32[gb + 28120 >> 2] = fb + 75;
 HEAP32[gb + 28124 >> 2] = fb + 91;
 HEAP32[gb + 28128 >> 2] = fb + 5;
 HEAP32[gb + 28132 >> 2] = fb + 87;
 HEAP32[gb + 28136 >> 2] = fb + 72;
 HEAP32[gb + 28140 >> 2] = fb + 88;
 HEAP32[gb + 28144 >> 2] = fb + 69;
 HEAP32[gb + 28148 >> 2] = fb + 60;
 HEAP32[gb + 28152 >> 2] = fb + 1;
 HEAP32[gb + 28156 >> 2] = fb + 65;
 HEAP32[gb + 28160 >> 2] = fb + 51;
 HEAP32[gb + 28164 >> 2] = fb + 66;
 HEAP32[gb + 28168 >> 2] = fb + 89;
 HEAP32[gb + 28172 >> 2] = fb + 90;
 HEAP32[gb + 28176 >> 2] = fb + 71;
 HEAP32[gb + 28180 >> 2] = fb + 16;
 HEAP32[gb + 28184 >> 2] = fb + 17;
 HEAP32[gb + 28196 >> 2] = fb + 18;
 HEAP32[gb + 28200 >> 2] = fb + 19;
 HEAP32[gb + 28212 >> 2] = fb + 76;
 HEAP32[gb + 28216 >> 2] = fb + 77;
 HEAP32[gb + 28220 >> 2] = fb + 38;
 HEAP32[gb + 28224 >> 2] = fb + 39;
 HEAP32[gb + 28228 >> 2] = fb + 16;
 HEAP32[gb + 28232 >> 2] = fb + 39;
 HEAP32[gb + 28236 >> 2] = fb + 40;
 HEAP32[gb + 28240 >> 2] = fb + 19;
 HEAP32[gb + 28244 >> 2] = fb + 93;
 HEAP32[gb + 28248 >> 2] = fb + 61;
 HEAP32[gb + 28252 >> 2] = fb + 40;
 HEAP32[gb + 28256 >> 2] = fb + 62;
 HEAP32[gb + 28260 >> 2] = fb + 28;
 HEAP32[gb + 28264 >> 2] = fb + 63;
 HEAP32[gb + 28268 >> 2] = fb + 29;
 HEAP32[gb + 28272 >> 2] = fb + 34;
 HEAP32[gb + 28276 >> 2] = fb + 41;
 HEAP32[gb + 28280 >> 2] = fb + 42;
 HEAP32[gb + 28284 >> 2] = fb + 43;
 HEAP32[gb + 28288 >> 2] = fb + 44;
 HEAP32[gb + 28292 >> 2] = fb + 45;
 HEAP32[gb + 28296 >> 2] = fb + 46;
 HEAP32[gb + 28300 >> 2] = fb + 36;
 HEAP32[gb + 28312 >> 2] = (HEAP32[gb + 28312 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28316 >> 2] = (HEAP32[gb + 28316 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28352 >> 2] = fb + 78;
 HEAP32[gb + 28356 >> 2] = fb + 79;
 HEAP32[gb + 28360 >> 2] = fb + 80;
 HEAP32[gb + 28364 >> 2] = fb + 39;
 HEAP32[gb + 28368 >> 2] = fb + 16;
 HEAP32[gb + 28372 >> 2] = fb + 39;
 HEAP32[gb + 28376 >> 2] = fb + 40;
 HEAP32[gb + 28380 >> 2] = fb + 19;
 HEAP32[gb + 28384 >> 2] = fb + 94;
 HEAP32[gb + 28388 >> 2] = fb + 95;
 HEAP32[gb + 28392 >> 2] = fb + 40;
 HEAP32[gb + 28396 >> 2] = fb + 62;
 HEAP32[gb + 28400 >> 2] = fb + 28;
 HEAP32[gb + 28404 >> 2] = fb + 63;
 HEAP32[gb + 28408 >> 2] = fb + 29;
 HEAP32[gb + 28412 >> 2] = fb + 34;
 HEAP32[gb + 28416 >> 2] = fb + 79;
 HEAP32[gb + 28420 >> 2] = fb + 80;
 HEAP32[gb + 28424 >> 2] = fb + 81;
 HEAP32[gb + 28428 >> 2] = fb + 82;
 HEAP32[gb + 28432 >> 2] = fb + 83;
 HEAP32[gb + 28436 >> 2] = fb + 84;
 HEAP32[gb + 28440 >> 2] = fb + 36;
 HEAP32[gb + 28444 >> 2] = fb + 96;
 HEAP32[gb + 28448 >> 2] = fb + 81;
 HEAP32[gb + 28452 >> 2] = fb + 82;
 HEAP32[gb + 28464 >> 2] = (HEAP32[gb + 28464 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 28468 >> 2] = (HEAP32[gb + 28468 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 28504 >> 2] = fb + 83;
 HEAP32[gb + 28508 >> 2] = fb + 84;
 HEAP32[gb + 28512 >> 2] = fb + 80;
 HEAP32[gb + 28516 >> 2] = fb + 39;
 HEAP32[gb + 28520 >> 2] = fb + 16;
 HEAP32[gb + 28524 >> 2] = fb + 39;
 HEAP32[gb + 28528 >> 2] = fb + 40;
 HEAP32[gb + 28532 >> 2] = fb + 19;
 HEAP32[gb + 28536 >> 2] = fb + 97;
 HEAP32[gb + 28540 >> 2] = fb + 61;
 HEAP32[gb + 28544 >> 2] = fb + 40;
 HEAP32[gb + 28548 >> 2] = fb + 62;
 HEAP32[gb + 28552 >> 2] = fb + 28;
 runPostSets8();
}

function __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = i5 - i3 | 0;
 i9 = (i8 | 0) / 204 | 0;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i3;
 i3 = i4;
 i12 = i5;
 if (i9 >>> 0 <= ((i1 - i4 | 0) / 204 | 0) >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i4 | 0) / 204 | 0;
  i4 = i9 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 * 204 | 0) | 0 : i5;
  if ((i2 | 0) != (i1 | 0)) do {
   __ZN13AnimationClip15QuaternionCurveaSERKS0_(i3, i2) | 0;
   i2 = i2 + 204 | 0;
   i3 = i3 + 204 | 0;
  } while ((i2 | 0) != (i1 | 0));
  if (i4) {
   if ((i1 | 0) == (i12 | 0)) {
    STACKTOP = i14;
    return;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   do {
    __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i2, i1);
    i1 = i1 + 204 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 204 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i1 | 0) != (i12 | 0));
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i14;
   return;
  }
  i5 = i13 + 4 | 0;
  do {
   i2 = i1 + -204 | 0;
   HEAP32[i6 >> 2] = i2;
   i4 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -192 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
   }
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i14;
  return;
 }
 if (i4) {
  i7 = i11 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
   i6 = i13 + 4 | 0;
   do {
    i4 = i1 + -204 | 0;
    HEAP32[i7 >> 2] = i4;
    i5 = i1 + -36 | 0;
    if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1 + -32 | 0);
     HEAP32[i5 >> 2] = 0;
    }
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i1 + -192 >> 2] | 0;
     HEAP32[i13 >> 2] = 66;
     HEAP32[i6 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i13);
    }
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i6 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 25;
  HEAP32[i13 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if ((i8 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 204 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 25;
 HEAP32[i13 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 204 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i10 >> 2] = i1 + (i3 * 204 | 0);
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1, i2);
  i2 = i2 + 204 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 204 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 STACKTOP = i14;
 return;
}

function __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085899 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx5cloth10initializeINS0_7SwClothEEEvRT_PKNS_6PxVec4ES7_(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 if ((i1 | 0) == (i2 | 0)) {
  f10 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f6 = Math_fround(-3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  f10 = Math_fround(3402823469999999843913219.0e14);
  f5 = Math_fround(-3402823469999999843913219.0e14);
  f6 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(-3402823469999999843913219.0e14);
  f8 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  do {
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f8 = f8 < f16 ? f8 : f16;
   f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f9 = f9 < f15 ? f9 : f15;
   f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f10 = f10 < f14 ? f10 : f14;
   f5 = f5 > f16 ? f5 : f16;
   f6 = f6 > f15 ? f6 : f15;
   f7 = f7 > f14 ? f7 : f14;
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 f18 = Math_fround(Math_fround(f9 + f6) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f10 + f7) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f5 - f8) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f6 - f9) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f7 - f10) * Math_fround(.5));
 HEAPF32[i12 + 32 >> 2] = Math_fround(Math_fround(f8 + f5) * Math_fround(.5));
 HEAPF32[i12 + 36 >> 2] = f18;
 HEAPF32[i12 + 40 >> 2] = f17;
 HEAPF32[i12 + 44 >> 2] = f14;
 HEAPF32[i12 + 48 >> 2] = f15;
 HEAPF32[i12 + 52 >> 2] = f16;
 i1 = i12 + 104 | 0;
 i3 = i12 + 56 | 0;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i12 + 108 >> 2] = 1065353216;
 HEAP32[i12 + 112 >> 2] = 1065353216;
 HEAP32[i12 + 116 >> 2] = 1065353216;
 HEAP32[i12 + 120 >> 2] = 1065353216;
 HEAP32[i12 + 124 >> 2] = 1065353216;
 HEAP32[i12 + 128 >> 2] = 1065353216;
 HEAP32[i12 + 132 >> 2] = 1065353216;
 HEAP32[i12 + 136 >> 2] = 1065353216;
 HEAPF32[i12 + 140 >> 2] = Math_fround(60.0);
 HEAPF32[i12 + 144 >> 2] = Math_fround(10.0);
 HEAP32[i12 + 148 >> 2] = 0;
 HEAP32[i12 + 152 >> 2] = 0;
 HEAP32[i12 + 156 >> 2] = 0;
 HEAP32[i12 + 160 >> 2] = 1065353216;
 i1 = i12 + 164 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i12 + 188 >> 2] = 1065353216;
 i1 = i12 + 232 | 0;
 i2 = i11 + 16 | 0;
 i3 = i12 + 192 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 30;
 if ((i11 | 0) != (i1 | 0)) HEAP32[i12 + 236 >> 2] = 0;
 i3 = i11 + 12 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i12 + 244 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i4;
 HEAPF32[i12 + 264 >> 2] = Math_fround(-128.0);
 HEAPF32[i12 + 268 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 296 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 300 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 304 >> 2] = Math_fround(-128.0);
 HEAP8[i12 + 440 >> 0] = 0;
 HEAPF32[i12 + 444 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 448 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 480 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 484 >> 2] = Math_fround(-128.0);
 HEAP32[i12 + 512 >> 2] = -1;
 HEAP32[i12 + 516 >> 2] = -1;
 HEAPF32[i12 + 520 >> 2] = Math_fround(0.0);
 HEAP32[i12 + 524 >> 2] = 0;
 HEAP32[i12 + 528 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZL23stbir__calculate_memoryP11stbir__info(i17) {
 i17 = i17 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i7 = i17 + 80 | 0;
 i6 = i17 + 56 | 0;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 i16 = f1 > Math_fround(1.0);
 i2 = HEAP32[gb + 71848 + (HEAP32[i7 >> 2] << 3) + 4 >> 2] | 0;
 if (i16) f1 = Math_fround(Math_fround(+mftCall_ff(i2 | 0, +Math_fround(Math_fround(1.0) / f1))) * Math_fround(2.0)); else f1 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i2 | 0, +f1)) * Math_fround(2.0)) / f1);
 i15 = (~~Math_fround(Math_ceil(Math_fround(f1))) | 0) / 2 | 0;
 i8 = i17 + 84 | 0;
 i16 = i17 + 60 | 0;
 f1 = Math_fround(HEAPF32[i16 >> 2]);
 i14 = f1 > Math_fround(1.0);
 i2 = HEAP32[gb + 71848 + (HEAP32[i8 >> 2] << 3) + 4 >> 2] | 0;
 if (i14) f1 = Math_fround(Math_fround(+mftCall_ff(i2 | 0, +Math_fround(Math_fround(1.0) / f1))) * Math_fround(2.0)); else f1 = Math_fround(Math_fround(Math_fround(+mftCall_ff(i2 | 0, +f1)) * Math_fround(2.0)) / f1);
 i14 = ~~Math_fround(Math_ceil(Math_fround(f1)));
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 i11 = i17 + 4 | 0;
 i12 = i17 + 20 | 0;
 if (f1 > Math_fround(1.0)) i2 = HEAP32[i12 >> 2] | 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i2 = (((~~Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+mftCall_ff(HEAP32[gb + 71848 + (HEAP32[i7 >> 2] << 3) + 4 >> 2] | 0, +f1)) * Math_fround(2.0)) / f1))) | 0) / 2 | 0) << 1) + i2 | 0;
 }
 i3 = i17 + 152 | 0;
 HEAP32[i3 >> 2] = i2;
 f1 = Math_fround(HEAPF32[i16 >> 2]);
 if (f1 > Math_fround(1.0)) {
  i4 = HEAP32[i17 + 24 >> 2] | 0;
  i3 = i2;
 } else {
  i4 = HEAP32[i17 + 8 >> 2] | 0;
  i4 = (((~~Math_fround(Math_ceil(Math_fround(Math_fround(Math_fround(+mftCall_ff(HEAP32[gb + 71848 + (HEAP32[i8 >> 2] << 3) + 4 >> 2] | 0, +f1)) * Math_fround(2.0)) / f1))) | 0) / 2 | 0) << 1) + i4 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 i5 = i17 + 156 | 0;
 HEAP32[i5 >> 2] = i4;
 i13 = i17 + 184 | 0;
 HEAP32[i13 >> 2] = i3 << 3;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 i10 = f1 > Math_fround(1.0);
 i2 = HEAP32[gb + 71848 + (HEAP32[i7 >> 2] << 3) + 4 >> 2] | 0;
 if (i10) f1 = Math_fround(+mftCall_ff(i2 | 0, +Math_fround(Math_fround(1.0) / f1))); else f1 = Math_fround(+mftCall_ff(i2 | 0, +f1));
 i10 = i17 + 188 | 0;
 HEAP32[i10 >> 2] = Math_imul(i3 << 2, ~~Math_fround(Math_ceil(Math_fround(f1 * Math_fround(2.0))))) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i9 = i17 + 192 | 0;
 HEAP32[i9 >> 2] = i3 << 3;
 f1 = Math_fround(HEAPF32[i16 >> 2]);
 i7 = f1 > Math_fround(1.0);
 i2 = HEAP32[gb + 71848 + (HEAP32[i8 >> 2] << 3) + 4 >> 2] | 0;
 if (i7) f1 = Math_fround(+mftCall_ff(i2 | 0, +Math_fround(Math_fround(1.0) / f1))); else f1 = Math_fround(+mftCall_ff(i2 | 0, +f1));
 i8 = Math_imul(i3 << 2, ~~Math_fround(Math_ceil(Math_fround(f1 * Math_fround(2.0))))) | 0;
 HEAP32[i17 + 196 >> 2] = i8;
 i4 = HEAP32[i17 + 64 >> 2] | 0;
 i5 = i4 << 2;
 i7 = Math_imul(i5, (HEAP32[i11 >> 2] | 0) + (i15 << 1) | 0) | 0;
 HEAP32[i17 + 200 >> 2] = i7;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = Math_imul(i5, i2) | 0;
 i6 = i17 + 204 | 0;
 HEAP32[i6 >> 2] = i5;
 i3 = Math_imul(Math_imul(i14 << 2, i2) | 0, i4) | 0;
 HEAP32[i17 + 208 >> 2] = i3;
 i4 = Math_imul(i2 << 2, i4) | 0;
 i2 = i17 + 212 | 0;
 HEAP32[i2 >> 2] = i4;
 if (Math_fround(HEAPF32[i16 >> 2]) > Math_fround(1.0)) {
  HEAP32[i6 >> 2] = 0;
  i16 = 0;
  i17 = i4;
  i14 = HEAP32[i13 >> 2] | 0;
  i15 = HEAP32[i10 >> 2] | 0;
  i14 = i15 + i14 | 0;
  i15 = HEAP32[i9 >> 2] | 0;
  i15 = i14 + i15 | 0;
  i15 = i15 + i8 | 0;
  i15 = i15 + i7 | 0;
  i16 = i15 + i16 | 0;
  i16 = i16 + i3 | 0;
  i17 = i16 + i17 | 0;
  return i17 | 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  i16 = i5;
  i17 = 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i15 = HEAP32[i10 >> 2] | 0;
  i14 = i15 + i14 | 0;
  i15 = HEAP32[i9 >> 2] | 0;
  i15 = i14 + i15 | 0;
  i15 = i15 + i8 | 0;
  i15 = i15 + i7 | 0;
  i16 = i15 + i16 | 0;
  i16 = i16 + i3 | 0;
  i17 = i16 + i17 | 0;
  return i17 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i8 = (i4 - i1 | 0) / 52 | 0;
 i7 = i9 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i6 = i3;
 i10 = i4;
 if (i8 >>> 0 > ((i2 - i3 | 0) / 52 | 0) >>> 0) {
  if (i3) {
   i5 = i9 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (i6 | 0)) i2 = i3; else {
    do {
     HEAP32[i5 >> 2] = i2 + -52;
     i3 = HEAP32[i2 + -12 >> 2] | 0;
     if (i3 | 0) {
      i4 = i2 + -8 | 0;
      if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
      __ZdlPv(i3);
     }
     i3 = HEAP32[i2 + -24 >> 2] | 0;
     if (i3 | 0) {
      i2 = i2 + -20 | 0;
      if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i3;
      __ZdlPv(i3);
     }
     i2 = HEAP32[i5 >> 2] | 0;
    } while ((i2 | 0) != (i6 | 0));
    i2 = HEAP32[i9 >> 2] | 0;
   }
   __ZdlPv(i2);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i2 = 0;
  }
  if (i8 >>> 0 > 82595524) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  } else i3 = 0;
  i6 = (i2 - i3 | 0) / 52 | 0;
  i3 = i6 << 1;
  i3 = i6 >>> 0 < 41297762 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 82595524;
  if (i3 >>> 0 > 82595524) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i2 = __Znwj(i3 * 52 | 0) | 0;
  i4 = i9 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i3 * 52 | 0);
  if ((i1 | 0) == (i10 | 0)) return;
  do {
   __ZN11DetailPatchC2ERKS_(i2, i1);
   i1 = i1 + 52 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 52 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 } else {
  i7 = i9 + 4 | 0;
  i5 = ((HEAP32[i7 >> 2] | 0) - i3 | 0) / 52 | 0;
  i3 = i8 >>> 0 > i5 >>> 0;
  i5 = i3 ? i1 + (i5 * 52 | 0) | 0 : i4;
  if ((i1 | 0) == (i5 | 0)) i4 = i6; else {
   i2 = i6;
   do {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP8[i2 + 24 >> 0] = HEAP8[i1 + 24 >> 0] | 0;
    if ((i2 | 0) != (i1 | 0)) {
     __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i2 + 28 | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0);
     __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i2 + 40 | 0, HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0);
    }
    i1 = i1 + 52 | 0;
    i2 = i2 + 52 | 0;
   } while ((i1 | 0) != (i5 | 0));
   i4 = i2;
  }
  if (i3) {
   if ((i5 | 0) == (i10 | 0)) return;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = i5;
   do {
    __ZN11DetailPatchC2ERKS_(i2, i1);
    i1 = i1 + 52 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 52 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) return;
  do {
   HEAP32[i7 >> 2] = i1 + -52;
   i2 = HEAP32[i1 + -12 >> 2] | 0;
   if (i2 | 0) {
    i3 = i1 + -8 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
    __ZdlPv(i2);
   }
   i2 = HEAP32[i1 + -24 >> 2] | 0;
   if (i2 | 0) {
    i1 = i1 + -20 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
    __ZdlPv(i2);
   }
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
  return;
 }
}

function __ZN13RenderManager23AddRemoveCamerasDelayedEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i7 = i8 + 40 | 0;
 i6 = i8 + 44 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i7 | 0)) {
  i3 = i1;
  do {
   i5 = i3 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 16;
     }
    }
    if ((i11 | 0) == 14) i11 = 16;
    if ((i11 | 0) == 16) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   __ZN13RenderManager12RemoveCameraEP6Camera(i8, i1);
   i2 = i3;
  } while ((i2 | 0) != (i7 | 0));
 }
 i2 = i8 + 48 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i13 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 + 4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[HEAP32[i13 >> 2] >> 2] = i6;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i7 | 0)) do {
   i13 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZdlPv(i13);
  } while ((i1 | 0) != (i7 | 0));
 }
 i7 = i8 + 28 | 0;
 i6 = i8 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i7 | 0)) {
  i3 = i1;
  do {
   i5 = i3 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 29; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 29; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 31;
     }
    }
    if ((i11 | 0) == 29) i11 = 31;
    if ((i11 | 0) == 31) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   __ZN13RenderManager9AddCameraEP6Camera(i8, i1);
   i2 = i3;
  } while ((i2 | 0) != (i7 | 0));
 }
 i2 = i8 + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i13 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[HEAP32[i13 >> 2] >> 2] = i11;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i13 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZdlPv(i13);
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i12;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = (i6 - i7 | 0) / 24 | 0;
 i3 = i7;
 if (i1 >>> 0 < i12 >>> 0) {
  i9 = i14 + 8 | 0;
  if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 24 | 0 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 8 | 0;
  if (i12 | 0) {
   i3 = __Znwj(i12 * 24 | 0) | 0;
   i1 = i3;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3 + (i12 * 24 | 0);
  }
  HEAP32[i4 >> 2] = i7;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i2, i13);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = (i1 - i4 | 0) / 24 | 0;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i2 | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 * 24 | 0) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~(((i5 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
    HEAP32[i10 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i3 + (i12 * 24 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i9 = i13 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 * 24 | 0;
  i2 = (i1 | 0) / 24 | 0;
  if (!i1) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i5 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i13 >> 2] = i5;
   i1 = i5 + (i2 * 24 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i8 = i5;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i6 = i5;
    i2 = i5;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     i3 = i3 + 24 | 0;
     i2 = i2 + 24 | 0;
     if ((i3 | 0) == (i7 | 0)) break; else i6 = i2;
    }
    HEAP32[i9 >> 2] = i2;
    i5 = i8;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx26PxcPCMContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i3, i6, i2, i4, i5, i1, i19) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i2 = i2 + 16 | 0;
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 i4 = i4 + 16 | 0;
 f25 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i5 >> 2]);
 f23 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f21 = Math_fround(f12 * Math_fround(2.0));
 f7 = Math_fround(f11 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f21) + Math_fround(f11 * f7)) + Math_fround(-1.0)) * f23);
 f12 = Math_fround(Math_fround(Math_fround(f21 * f8) + Math_fround(f9 * f7)) * f23);
 f23 = Math_fround(Math_fround(Math_fround(f21 * f9) - Math_fround(f8 * f7)) * f23);
 f7 = Math_fround(f25 + f11);
 f8 = Math_fround(f13 + f12);
 f9 = Math_fround(f24 + f23);
 f10 = Math_fround(f15 + f10);
 f20 = Math_fround(f10 + f20);
 f21 = Math_fround(f16 - f7);
 f14 = Math_fround(f17 - f8);
 f22 = Math_fround(f18 - f9);
 f11 = Math_fround(Math_fround(f25 - f11) - f7);
 f12 = Math_fround(Math_fround(f13 - f12) - f8);
 f23 = Math_fround(Math_fround(f24 - f23) - f9);
 f24 = Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)));
 f13 = Math_fround(Math_fround(Math_fround(1.0) / f24) * Math_fround(Math_fround(f22 * f23) + Math_fround(Math_fround(f21 * f11) + Math_fround(f14 * f12))));
 i6 = f13 > Math_fround(1.0);
 f13 = i6 ? Math_fround(1.0) : f13;
 i6 = f13 > Math_fround(0.0);
 f13 = i6 ? f13 : Math_fround(0.0);
 i6 = f24 == Math_fround(0.0);
 f13 = i6 ? Math_fround(0.0) : f13;
 f11 = Math_fround(f11 * f13);
 f12 = Math_fround(f12 * f13);
 f13 = Math_fround(f23 * f13);
 f21 = Math_fround(f21 - f11);
 f14 = Math_fround(f14 - f12);
 f22 = Math_fround(f22 - f13);
 f14 = Math_fround(Math_fround(f22 * f22) + Math_fround(Math_fround(f21 * f21) + Math_fround(f14 * f14)));
 if (!(Math_fround(f20 * f20) > f14)) {
  i19 = 0;
  return i19 | 0;
 }
 f23 = Math_fround(f16 - Math_fround(f7 + f11));
 f20 = Math_fround(f17 - Math_fround(f8 + f12));
 f22 = Math_fround(f18 - Math_fround(f9 + f13));
 f21 = Math_fround(Math_fround(f22 * f22) + Math_fround(Math_fround(f23 * f23) + Math_fround(f20 * f20)));
 i5 = f21 == Math_fround(0.0);
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f21))));
 f13 = Math_fround(f23 * f21);
 f20 = Math_fround(f20 * f21);
 f21 = Math_fround(f22 * f21);
 f13 = i5 ? Math_fround(1.0) : f13;
 f20 = i5 ? Math_fround(0.0) : f20;
 f21 = i5 ? Math_fround(0.0) : f21;
 f22 = Math_fround(f16 - Math_fround(f15 * f13));
 f23 = Math_fround(f17 - Math_fround(f15 * f20));
 f24 = Math_fround(f18 - Math_fround(f15 * f21));
 f25 = Math_fround(Math_fround(Math_sqrt(Math_fround(f14))) - f10);
 i5 = i19 + 4096 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + 1;
 i5 = i19 + (i6 << 6) | 0;
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i5 + 4 >> 2] = f20;
 HEAPF32[i5 + 8 >> 2] = f21;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 i5 = i19 + (i6 << 6) + 16 | 0;
 HEAPF32[i5 >> 2] = f22;
 HEAPF32[i5 + 4 >> 2] = f23;
 HEAPF32[i5 + 8 >> 2] = f24;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + (i6 << 6) + 12 >> 2] = f25;
 HEAP32[i19 + (i6 << 6) + 48 >> 2] = -1;
 HEAP32[i19 + (i6 << 6) + 52 >> 2] = -1;
 i19 = 1;
 return i19 | 0;
}

function __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1033960 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1033967 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1033975 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1033981 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084155 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1086064 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085890 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085926 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14BlendShapeData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 40 | 0;
 i6 = i3;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 500490 | 0, i8, i1, 0);
 i11 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i6 >> 2] = i11;
 i10 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = i10;
 i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = i5;
 i9 = i6 + 12 | 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i6 + 16 >> 2] = i10;
 HEAP32[i6 + 20 >> 2] = i5;
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i6 + 28 >> 2] = i10;
 HEAP32[i6 + 32 >> 2] = i5;
 i5 = i6 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 426504 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 602071 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i9, gb + 428867 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 428913 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944884 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426370 | 0, i8, i1 + 20 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP16[i6 + 8 >> 1] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 426442 | 0, i6, 0);
 __ZN10BlendShape8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426377 | 0, i8, i1 + 40 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i6);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 426398 | 0, i6, 0);
 __ZN17BlendShapeChannel8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN14ConstantStringD2Ev(i6);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426386 | 0, i8, i1 + 52 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z20AddDirectionalLightsPPK5LightjR12ActiveLights(i16, i17, i18) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, f20 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19 + 4 | 0;
 i2 = i19;
 if ((HEAP16[gb + 1111148 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111148 | 0, i1);
  i14 = gb + 1111148 | 0;
 } else i14 = 0;
 i15 = i18 + 44 | 0;
 HEAP8[i15 >> 0] = 0;
 i11 = (i17 | 0) == 0;
 if (i11) i12 = 12; else {
  f4 = Math_fround(-1.0);
  i1 = 0;
  i13 = -1;
  while (1) {
   i2 = HEAP32[(HEAP32[i16 + (i1 << 2) >> 2] | 0) + 44 >> 2] | 0;
   f20 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(.300000012));
   f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(.589999974)));
   f20 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * Math_fround(.109999999)));
   f20 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * f20);
   f3 = Math_fround(f20 * Math_fround(16.0));
   f3 = (HEAP32[i2 + 96 >> 2] | 0) == 0 ? f20 : f3;
   i2 = f3 > f4 ? (HEAP32[i2 + 76 >> 2] | 0) != 2 : 0;
   i13 = i2 ? i1 : i13;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i17 | 0)) break; else f4 = i2 ? f3 : f4;
  }
  if ((i13 | 0) == -1) i12 = 12; else {
   i2 = HEAP32[i16 + (i13 << 2) >> 2] | 0;
   i5 = i18 + 12 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 + 1 | 0;
   i8 = i18 + 16 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   i10 = i9 & 2147483647;
   do if (i7 >>> 0 > i10 >>> 0) {
    i1 = i9 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
     HEAP32[i8 >> 2] = i1;
     HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 * 180 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 180 | 0, 4, i18 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 180 | 0) | 0;
     HEAP32[i8 >> 2] = i1;
     HEAP32[i18 >> 2] = i10;
     break;
    }
   } while (0);
   HEAP32[i5 >> 2] = i7;
   __ZL27SetupActiveDirectionalLightRK5LightR11ActiveLight(i2, (HEAP32[i18 >> 2] | 0) + (i6 * 180 | 0) | 0);
   HEAP8[i18 + 20 >> 0] = 1;
  }
 }
 if ((i12 | 0) == 12) {
  HEAP8[i18 + 20 >> 0] = 0;
  i13 = -1;
 }
 i12 = i18 + 12 | 0;
 if (!i11) {
  i5 = i18 + 16 | 0;
  i6 = i18 + 4 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[i16 + (i1 << 2) >> 2] | 0;
   if (HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + 96 >> 2] | 0) HEAP8[i15 >> 0] = 1;
   if ((i1 | 0) != (i13 | 0)) {
    i8 = HEAP32[i12 >> 2] | 0;
    i9 = i8 + 1 | 0;
    i10 = HEAP32[i5 >> 2] | 0;
    i11 = i10 & 2147483647;
    do if (i9 >>> 0 > i11 >>> 0) {
     i2 = i10 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i11 >>> 0 < i2 >>> 0) if ((i10 | 0) > -1) {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i2 * 180 | 0, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 180 | 0, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i11 | 0, HEAP32[i18 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 180 | 0) | 0;
      HEAP32[i5 >> 2] = i2;
      HEAP32[i18 >> 2] = i11;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i9;
    __ZL27SetupActiveDirectionalLightRK5LightR11ActiveLight(i7, (HEAP32[i18 >> 2] | 0) + (i8 * 180 | 0) | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i17 | 0));
 }
 HEAP32[i18 + 24 >> 2] = HEAP32[i12 >> 2];
 if (!i14) {
  STACKTOP = i19;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i19;
 return;
}

function __ZN9AudioClip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i7 = i1 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853560 | 0, i8, i4, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853571 | 0, i8, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853582 | 0, i8, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853594 | 0, i8, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906581 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853610 | 0, i7, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853628 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853644 | 0, i7, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853663 | 0, i7, i1 + 65 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853682 | 0, i7, i1 + 66 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853693 | 0, gb + 853704 | 0, i7, 0);
 __ZN16StreamedResource8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 104 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853721 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx31ComputeCreatedDeletedPairsListsEPKjS1_jRPNS_17PxcBroadPhasePairERjS5_S4_S5_S5_RNS_14SapPairManagerE(i1, i17, i18, i11, i13, i12, i21, i14, i19, i22) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i21 = i21 | 0;
 i14 = i14 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0, i20 = 0, i23 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 1 | 0;
 i16 = i20;
 i10 = (i18 | 0) == 0;
 if (i10) i2 = HEAP32[i14 >> 2] | 0; else {
  i4 = i22 + 20 | 0;
  i5 = i22 + 24 | 0;
  i9 = 0;
  do {
   i6 = HEAP32[i17 + (i9 << 2) >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   i8 = i7 + (i6 << 3) | 0;
   i3 = i8;
   i1 = (HEAP32[i5 >> 2] | 0) + (i6 << 3 >> 3) | 0;
   i2 = HEAP8[i1 >> 0] | 0;
   if (!(i2 & 2)) {
    HEAP8[i1 >> 0] = i2 & 254;
    if (HEAP8[(HEAP32[i5 >> 2] | 0) + (i3 - (HEAP32[i4 >> 2] | 0) >> 3) >> 0] & 4) {
     i1 = HEAP32[i13 >> 2] | 0;
     if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
      i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i15, i1 << 4, gb + 716761 | 0, 504) | 0;
      _memcpy(i2 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[i11 >> 2] | 0);
      HEAP32[i11 >> 2] = i2;
      HEAP32[i12 >> 2] = i1 << 1;
      i1 = HEAP32[i13 >> 2] | 0;
     } else i2 = HEAP32[i11 >> 2] | 0;
     i23 = HEAP32[i8 >> 2] | 0;
     i7 = HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0;
     i6 = i23 >>> 0 < i7 >>> 0;
     i8 = i2 + (i1 << 3) | 0;
     HEAP32[i8 >> 2] = i6 ? i23 : i7;
     HEAP32[i8 + 4 >> 2] = i6 ? i7 : i23;
     HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     i8 = (HEAP32[i5 >> 2] | 0) + (i3 - (HEAP32[i4 >> 2] | 0) >> 3) | 0;
     HEAP8[i8 >> 0] = (HEAPU8[i8 >> 0] | 0) & 251;
    }
   } else if (!(i2 & 4)) {
    i1 = HEAP32[i14 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i19 >> 2] | 0)) {
     i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i15, i1 << 4, gb + 716761 | 0, 504) | 0;
     _memcpy(i2 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i19 >> 2] << 3 | 0) | 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[i21 >> 2] | 0);
     HEAP32[i21 >> 2] = i2;
     HEAP32[i19 >> 2] = i1 << 1;
     i1 = HEAP32[i14 >> 2] | 0;
    } else i2 = HEAP32[i21 >> 2] | 0;
    i8 = HEAP32[i8 >> 2] | 0;
    i7 = HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0;
    i6 = i8 >>> 0 < i7 >>> 0;
    i23 = i2 + (i1 << 3) | 0;
    HEAP32[i23 >> 2] = i6 ? i8 : i7;
    HEAP32[i23 + 4 >> 2] = i6 ? i7 : i8;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i18 | 0));
  i2 = HEAP32[i14 >> 2] | 0;
  if (!i10) {
   i5 = i22 + 20 | 0;
   i6 = i22 + 24 | 0;
   i7 = 0;
   do {
    i3 = HEAP32[i17 + (i7 << 2) >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    if ((HEAP8[(HEAP32[i6 >> 2] | 0) + (i3 << 3 >> 3) >> 0] & 6) == 6) {
     if ((i2 | 0) == (HEAP32[i19 >> 2] | 0)) {
      i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i15, i2 << 4, gb + 716761 | 0, 504) | 0;
      _memcpy(i1 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i19 >> 2] << 3 | 0) | 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[i21 >> 2] | 0);
      HEAP32[i21 >> 2] = i1;
      HEAP32[i19 >> 2] = i2 << 1;
     } else i1 = HEAP32[i21 >> 2] | 0;
     i14 = HEAP32[i4 + (i3 << 3) >> 2] | 0;
     i13 = HEAP32[i4 + (i3 << 3) + 4 >> 2] | 0;
     i12 = i14 >>> 0 < i13 >>> 0;
     i23 = i1 + (i2 << 3) | 0;
     HEAP32[i23 >> 2] = i12 ? i14 : i13;
     HEAP32[i23 + 4 >> 2] = i12 ? i13 : i14;
     i2 = i2 + 1 | 0;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i18 | 0));
  }
 }
 if (!i2) {
  STACKTOP = i20;
  return;
 } else i1 = 0;
 do {
  i23 = HEAP32[i21 >> 2] | 0;
  __ZN5physx14SapPairManager10RemovePairEjj(i22, HEAP32[i23 + (i1 << 3) >> 2] | 0, HEAP32[i23 + (i1 << 3) + 4 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i20;
 return;
}

function __ZN7mecanim9animation25CreateControllerWorkspaceEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(i13, i15) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, 20, 4) | 0;
 HEAP32[i16 >> 2] = 0;
 i14 = i16 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i17 = i16 + 8 | 0;
 HEAP32[i17 >> 2] = 0;
 i4 = i13 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 HEAP32[i14 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i16 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 i12 = i16 + 12 | 0;
 HEAP32[i12 >> 2] = i2;
 if (!i2) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i13 + 12 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = 0;
  i1 = 0;
  do {
   i11 = i3 + (i1 << 2) | 0;
   i11 = HEAP32[i11 + (HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0;
   i4 = i4 >>> 0 < i11 >>> 0 ? i11 : i4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  if (!i4) {
   i2 = 0;
   i1 = 0;
  } else {
   i1 = i4 << 2;
   i2 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i1 | 0, 4) | 0;
   if ((i2 | 0) != (i2 + (i4 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  }
 }
 HEAP32[i16 + 16 >> 2] = i2;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i10 = i13 + 12 | 0;
  i11 = i10;
  i9 = 0;
  do {
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = i1 + i11 + (i9 << 2) | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   i8 = (i8 | 0) == 0 ? 0 : i3 + i8 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (!i3) i2 = 0; else {
    i5 = i8 + 28 | 0;
    i6 = i8 + 4 | 0;
    i7 = i6;
    i2 = 0;
    i4 = 0;
    i1 = HEAP32[i5 >> 2] | 0;
    do {
     if (!i1) i1 = 0; else {
      i3 = 0;
      do {
       i18 = (HEAP32[i6 >> 2] | 0) + i7 + (i4 << 2) | 0;
       i1 = HEAP32[i18 >> 2] | 0;
       i1 = __ZN7mecanim12statemachine20GetBlendTreeConstantERKNS0_13StateConstantEi((i1 | 0) == 0 ? 0 : i18 + i1 | 0, i3) | 0;
       if (i1) {
        i18 = HEAP32[i1 >> 2] | 0;
        i2 = i2 >>> 0 < i18 >>> 0 ? i18 : i2;
       }
       i3 = i3 + 1 | 0;
       i1 = HEAP32[i5 >> 2] | 0;
      } while (i3 >>> 0 < i1 >>> 0);
      i3 = HEAP32[i8 >> 2] | 0;
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i3 >>> 0);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i18 = i1 + i11 + (i9 << 2) | 0;
   i8 = HEAP32[i18 >> 2] | 0;
   i8 = __ZN7mecanim12statemachine24CreateStateMachineOutputEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE((i8 | 0) == 0 ? 0 : i18 + i8 | 0, i2, i15) | 0;
   HEAP32[(HEAP32[i14 >> 2] | 0) + (i9 << 2) >> 2] = i8;
   i8 = (HEAP32[i10 >> 2] | 0) + i11 + (i9 << 2) | 0;
   i18 = HEAP32[i8 >> 2] | 0;
   i18 = __ZN7mecanim12statemachine27CreateStateMachineWorkspaceEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE((i18 | 0) == 0 ? 0 : i8 + i18 | 0, i2, i15) | 0;
   HEAP32[(HEAP32[i16 >> 2] | 0) + (i9 << 2) >> 2] = i18;
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 }
 i1 = i13 + 16 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i18 = 0;
  HEAP32[i17 >> 2] = i18;
  return i16 | 0;
 }
 i3 = i1 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i1 = 0;
 i2 = 0;
 do {
  switch (HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) {
  case 9:
  case 4:
   {
    i1 = i1 + 1 | 0;
    break;
   }
  default:
   {}
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 if (!i1) {
  i18 = 0;
  HEAP32[i17 >> 2] = i18;
  return i16 | 0;
 }
 i18 = mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i1 | 0, 1) | 0;
 _memset(i18 | 0, 0, i1 | 0) | 0;
 HEAP32[i17 >> 2] = i18;
 return i16 | 0;
}

function __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE(i4, i14) {
 i4 = i4 | 0;
 i14 = i14 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f15 = f0;
 f13 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i4 + 12 | 0;
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i3 >> 2]));
 i5 = i4 + 4 | 0;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 i7 = i4 + 16 | 0;
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 >> 2]));
 i9 = i4 + 8 | 0;
 f11 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = i4 + 20 | 0;
 f12 = Math_fround(f12 * Math_fround(.5));
 f11 = Math_fround(Math_fround(f11 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
 HEAPF32[i14 + 36 >> 2] = Math_fround(f13 * Math_fround(.5));
 HEAPF32[i14 + 40 >> 2] = f12;
 HEAPF32[i14 + 44 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i3 >> 2]));
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i7 >> 2]));
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i8 >> 2]));
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13))));
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 HEAPF32[i14 + 48 >> 2] = Math_fround(f12 + Math_fround(f13 * Math_fround(.5)));
 HEAPF32[i14 + 52 >> 2] = f12;
 HEAPF32[i14 + 56 >> 2] = f12;
 if (f13 == Math_fround(0.0)) {
  HEAP32[i14 >> 2] = 1065353216;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 + 16 >> 2] = 1065353216;
  HEAP32[i14 + 20 >> 2] = 0;
  HEAP32[i14 + 24 >> 2] = 0;
  HEAP32[i14 + 28 >> 2] = 0;
  HEAP32[i14 + 32 >> 2] = 1065353216;
  return;
 }
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i4 >> 2]));
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i5 >> 2]));
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i9 >> 2]));
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6)) + Math_fround(f1 * f1))));
 if (f2 > Math_fround(0.0)) {
  f13 = Math_fround(Math_fround(1.0) / f2);
  f1 = Math_fround(f1 * f13);
  f6 = Math_fround(f6 * f13);
  f10 = Math_fround(f10 * f13);
 }
 if (Math_fround(Math_abs(Math_fround(f6))) > Math_fround(.999899983)) {
  f11 = Math_fround(1.0);
  i4 = 1065353216;
  i5 = 0;
  i3 = 0;
  f12 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  f13 = Math_fround(f6 * Math_fround(0.0));
  f11 = Math_fround(f1 - f13);
  f2 = Math_fround(Math_fround(f10 * Math_fround(0.0)) - Math_fround(f1 * Math_fround(0.0)));
  f13 = Math_fround(f13 - f10);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f11 * f11) + Math_fround(f2 * f2)))));
  if (f12 > Math_fround(0.0)) {
   f12 = Math_fround(Math_fround(1.0) / f12);
   f11 = Math_fround(f11 * f12);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   f2 = Math_fround(f2 * f12);
   i5 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   f12 = Math_fround(f13 * f12);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  } else f12 = f13;
 }
 f15 = Math_fround(Math_fround(f6 * f12) - Math_fround(f1 * f2));
 f12 = Math_fround(Math_fround(f1 * f11) - Math_fround(f10 * f12));
 f13 = Math_fround(Math_fround(f10 * f2) - Math_fround(f6 * f11));
 HEAPF32[i14 >> 2] = f10;
 HEAPF32[i14 + 4 >> 2] = f6;
 HEAPF32[i14 + 8 >> 2] = f1;
 HEAP32[i14 + 12 >> 2] = i4;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = i3;
 HEAPF32[i14 + 24 >> 2] = f15;
 HEAPF32[i14 + 28 >> 2] = f12;
 HEAPF32[i14 + 32 >> 2] = f13;
 return;
}

function __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379117 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379125 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379133 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 379141 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10MonoScript27InitializeAndRegisterScriptERK8UnityStrRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_SB_b(i11, i1, i2, i8, i9, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i13 = i15 + 4 | 0;
 i14 = i15;
 mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 96 >> 2] | 0, i11 | 0, i1 | 0) | 0;
 i1 = i11 + 92 | 0;
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
 i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i11 + 100 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i11 + 96 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 96 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 i1 = i11 + 108 | 0;
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i11 + 116 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i11 + 112 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 112 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 i1 = i11 + 124 | 0;
 i6 = HEAP8[i9 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
 i6 = i4 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i11 + 132 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i11 + 128 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i11 + 128 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP8[i11 + 140 >> 0] = i10 & 1;
 __ZN7Hash1285ResetEv(i11 + 72 | 0);
 i7 = __Z19GetScriptingManagerv() | 0;
 i8 = i7 + 28 | 0;
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = i6;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 + 32 >> 2] | 0;
 i1 = i7 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i11 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i11 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i11 | 0 : i11;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i7 | 0)) if ((i6 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i13 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i8, i12, i14) | 0;
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = i5 - i3 | 0;
 i9 = (i8 | 0) / 172 | 0;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i3;
 i3 = i4;
 i12 = i5;
 if (i9 >>> 0 <= ((i1 - i4 | 0) / 172 | 0) >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i4 | 0) / 172 | 0;
  i4 = i9 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 * 172 | 0) | 0 : i5;
  if ((i2 | 0) != (i1 | 0)) do {
   __ZN13AnimationClip12Vector3CurveaSERKS0_(i3, i2) | 0;
   i2 = i2 + 172 | 0;
   i3 = i3 + 172 | 0;
  } while ((i2 | 0) != (i1 | 0));
  if (i4) {
   if ((i1 | 0) == (i12 | 0)) {
    STACKTOP = i14;
    return;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   do {
    __ZN13AnimationClip12Vector3CurveC2ERKS0_(i2, i1);
    i1 = i1 + 172 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 172 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i1 | 0) != (i12 | 0));
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i14;
   return;
  }
  i5 = i13 + 4 | 0;
  do {
   i2 = i1 + -172 | 0;
   HEAP32[i6 >> 2] = i2;
   i4 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -160 >> 2] | 0;
    HEAP32[i13 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
   }
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i14;
  return;
 }
 if (i4) {
  i7 = i11 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
   i6 = i13 + 4 | 0;
   do {
    i4 = i1 + -172 | 0;
    HEAP32[i7 >> 2] = i4;
    i5 = i1 + -36 | 0;
    if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1 + -32 | 0);
     HEAP32[i5 >> 2] = 0;
    }
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i1 + -160 >> 2] | 0;
     HEAP32[i13 >> 2] = 66;
     HEAP32[i6 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i13);
    }
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i6 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 25;
  HEAP32[i13 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if ((i8 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 172 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 25;
 HEAP32[i13 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 172 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i10 >> 2] = i1 + (i3 * 172 | 0);
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i2);
  i2 = i2 + 172 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 172 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 STACKTOP = i14;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 56 | 0;
 if (HEAP8[i10 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv(i7);
 i11 = i7 + 40 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 44 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i5 >>> 0 > i6 >>> 0) if ((i2 + i1 | 0) >>> 0 <= (HEAP32[i7 + 52 >> 2] | 0) >>> 0) {
  STACKTOP = i12;
  return;
 }
 i4 = i2 + i1 | 0;
 f3 = Math_fround(i4 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i5 >>> 0) {
  STACKTOP = i12;
  return;
 }
 i2 = i7 + 4 | 0;
 f3 = Math_fround((i4 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i6 >>> 0) if (!(f3 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 i18 = i9 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 i5 = i9 + 8 | 0;
 i17 = i7 + 8 | 0;
 i16 = HEAP16[i17 >> 1] | 0;
 HEAP8[i5 >> 0] = i16;
 i6 = i9 + 9 | 0;
 HEAP8[i6 >> 0] = (i16 & 65535) >>> 8;
 i16 = i9 + 12 | 0;
 i15 = i7 + 12 | 0;
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i14 = i9 + 24 | 0;
 i13 = i7 + 24 | 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 i4 = i9 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i9, i7, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i18 >> 2] = i1;
 i1 = HEAP8[i17 >> 0] | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 HEAP8[i17 >> 0] = i2;
 HEAP8[i5 >> 0] = i1;
 i5 = i7 + 9 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = (i2 & 65535) >>> 8;
 HEAP8[i6 >> 0] = i1;
 i6 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i5 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i1;
 HEAP32[i9 + 20 >> 2] = i5;
 i5 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i6 = HEAP32[i7 + 32 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i9 + 24 >> 2] = i5;
 HEAP32[i9 + 28 >> 2] = i1;
 HEAP32[i9 + 32 >> 2] = i6;
 i6 = i7 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i4 = i9 + 40 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i4 >> 2] = i6;
 i11 = i9 + 44 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i4;
 f3 = Math_fround(i5 >>> 0);
 HEAP32[i7 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 48 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i10 >> 0] = 0;
 f3 = Math_fround(i6 >>> 0);
 HEAP32[i9 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i9 + 48 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i9 + 56 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i12;
 return;
}

function __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 HEAP8[i8 + 872 >> 0] = 1;
 i10 = HEAP32[i8 + 16 >> 2] | 0;
 i9 = i10 & 2147483647;
 i6 = HEAP32[i8 + 12 >> 2] | 0;
 i10 = i10 << 2;
 i7 = i6 << 2;
 if (i6 | 0) {
  i5 = 0;
  do {
   i3 = i8 + 180 + (i5 * 20 | 0) | 0;
   i4 = i8 + 180 + (i5 * 20 | 0) + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if ((i1 & 2147483647) >>> 0 < i9 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i4 >> 2] = i9;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i8 + 180 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 180 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 + 180 + (i5 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i9;
    HEAP32[i3 >> 2] = i1;
    i1 = i9;
    break;
   } while (0);
   i2 = i8 + 180 + (i5 * 20 | 0) + 12 | 0;
   HEAP32[i2 >> 2] = i6;
   do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i4 >> 2] = i6;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i7, 4, i8 + 180 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i3 >> 2] = i2;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 4, i8 + 180 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i1;
    i2 = i1;
    break;
   } else i2 = HEAP32[i3 >> 2] | 0; while (0);
   i1 = 0;
   do {
    i4 = i2 + (i1 << 2) | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 3);
  return;
 }
 i1 = i8 + 180 | 0;
 i2 = i8 + 196 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i9 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i8 + 184 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 184 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 + 192 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = i7;
  break;
 } while (0);
 HEAP32[i8 + 192 >> 2] = 0;
 i1 = i8 + 200 | 0;
 i2 = i8 + 216 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i9 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i8 + 204 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 204 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 + 212 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = i7;
  break;
 } while (0);
 HEAP32[i8 + 212 >> 2] = 0;
 i1 = i8 + 220 | 0;
 i2 = i8 + 236 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i9 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i8 + 224 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 224 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 + 232 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = i10;
  break;
 } while (0);
 HEAP32[i8 + 232 >> 2] = 0;
 return;
}

function __ZN18UnityConnectClient27OnPlayerSessionStateChangedEjyy(i8, i5, i1, i2, i3, i4) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 64 | 0;
 i10 = i9;
 i6 = i8 + 108 | 0;
 HEAP8[i6 >> 0] = ((HEAP32[i10 >> 2] | 0) != (i1 | 0) ? 1 : (HEAP32[i10 + 4 >> 2] | 0) != (i2 | 0)) & 1;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 i2 = i8 + 72 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 switch (i5 | 0) {
 case 0:
  {
   i1 = i8 + 4 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) return;
   i3 = i8 + 280 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) return;
   i2 = i8 + 113 | 0;
   if (HEAP8[i2 >> 0] | 0) return;
   HEAP8[i2 >> 0] = 1;
   L60 : do if ((HEAP32[i1 >> 2] | 0) != 5) {
    switch (HEAP32[i1 >> 2] | 0) {
    case 5:
    case 0:
     break L60;
    default:
     {}
    }
    mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0);
   } while (0);
   HEAP8[i2 >> 0] = 0;
   __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE(i8 + 548 | 0, HEAP32[i8 + 544 >> 2] | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) return;
   __ZN19CloudServiceHandler7ReleaseEv(i1);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 case 2:
  {
   i1 = i8 + 113 | 0;
   if (HEAP8[i1 >> 0] | 0) return;
   HEAP8[i1 >> 0] = 1;
   i2 = i8 + 4 | 0;
   L72 : do if ((HEAP32[i2 >> 2] | 0) != 4) {
    switch (HEAP32[i2 >> 2] | 0) {
    case 1:
    case 5:
    case 0:
     break L72;
    default:
     {}
    }
    mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0);
   } while (0);
   HEAP8[i1 >> 0] = 0;
   return;
  }
 default:
  {
   i2 = i8 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
   if (!(HEAP32[i2 >> 2] | 0)) i7 = 17; else {
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
    if ((HEAP32[i2 >> 2] | 0) == 5) i7 = 17;
   }
   if ((i7 | 0) == 17) if (!(__ZN18UnityConnectClient17InitConnectClientEv(i8) | 0)) return;
   if ((i5 | 0) == 3) if (!(HEAP8[i6 >> 0] | 0)) {
    i1 = i8 + 113 | 0;
    if (HEAP8[i1 >> 0] | 0) return;
    HEAP8[i1 >> 0] = 1;
    L15 : do if ((HEAP32[i2 >> 2] | 0) != 3) {
     switch (HEAP32[i2 >> 2] | 0) {
     case 5:
     case 0:
      break L15;
     case 1:
      {
       i7 = 25;
       break;
      }
     case 2:
      {
       if (!(HEAP8[i8 + 112 >> 0] | 0)) {
        mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0);
        break L15;
       } else i7 = 26;
       break;
      }
     case 4:
      {
       if (!(HEAP8[i8 + 110 >> 0] | 0)) i7 = 25; else i7 = 26;
       break;
      }
     default:
      i7 = 26;
     }
     if ((i7 | 0) == 25) {
      mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0);
      break;
     } else if ((i7 | 0) == 26) {
      mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0);
      break;
     }
    } while (0);
    HEAP8[i1 >> 0] = 0;
    return;
   }
   i1 = i8 + 113 | 0;
   if (HEAP8[i1 >> 0] | 0) return;
   HEAP8[i1 >> 0] = 1;
   L30 : do if ((HEAP32[i2 >> 2] | 0) != 3) {
    switch (HEAP32[i2 >> 2] | 0) {
    case 5:
    case 0:
     break L30;
    case 1:
     {
      i7 = 35;
      break;
     }
    case 2:
     {
      if (!(HEAP8[i8 + 112 >> 0] | 0)) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0); else i7 = 36;
      break;
     }
    case 4:
     {
      if (!(HEAP8[i8 + 110 >> 0] | 0)) i7 = 35; else if (!(HEAP8[i6 >> 0] | 0)) i7 = 36; else i7 = 35;
      break;
     }
    default:
     i7 = 36;
    }
    if ((i7 | 0) == 35) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0); else if ((i7 | 0) == 36) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0);
    HEAP8[i1 >> 0] = 0;
    if ((__ZN10systeminfo18GetRuntimePlatformEv() | 0) != 11) return;
    if (!(__Z20IsHumanControllingUsv() | 0)) return;
    __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener(__Z15GetAdsIdHandlerv() | 0, i8 + 680 | 0) | 0;
    return;
   } while (0);
   HEAP8[i1 >> 0] = 0;
   return;
  }
 }
}

function __ZN15ParticleEmitter4EmitERK8Vector3fS2_ffRK11ColorRGBA32ff(i14, i2, i1, f7, f8, i9, f10, f11) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i13 = i14 + 56 | 0;
 i3 = i14 + 60 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4;
 if (((i4 - (HEAP32[i13 >> 2] | 0) | 0) / 48 | 0) >>> 0 > 16249) {
  STACKTOP = i16;
  return;
 };
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = i12 + 24 | 0;
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i12 + 28 >> 2] = Math_fround(Math_fround(Math_fround(f10 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i12 + 32 >> 2] = Math_fround(Math_fround(Math_fround(f11 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i12 + 36 >> 2] = f8;
 HEAPF32[i12 + 40 >> 2] = f8;
 HEAP32[i12 + 44 >> 2] = HEAP32[i9 >> 2];
 if ((i5 | 0) == (HEAP32[i14 + 64 >> 2] | 0)) __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i13, i12); else {
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  i13 = i5 + 24 | 0;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 48;
 }
 i6 = i14 + 72 | 0;
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 i13 = i14 + 76 | 0;
 f8 = Math_fround(HEAPF32[i13 >> 2]);
 i1 = i2 + 4 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i12 = i14 + 80 | 0;
 f17 = Math_fround(HEAPF32[i12 >> 2]);
 i9 = i2 + 8 | 0;
 f18 = Math_fround(HEAPF32[i9 >> 2]);
 HEAPF32[i6 >> 2] = f10 < f11 ? f10 : f11;
 HEAPF32[i13 >> 2] = f7 < f8 ? f7 : f8;
 HEAPF32[i12 >> 2] = f18 < f17 ? f18 : f17;
 i12 = i14 + 84 | 0;
 f17 = Math_fround(HEAPF32[i12 >> 2]);
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 i13 = i14 + 88 | 0;
 f8 = Math_fround(HEAPF32[i13 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i14 + 92 | 0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i9 >> 2]);
 HEAPF32[i12 >> 2] = f17 < f18 ? f18 : f17;
 HEAPF32[i13 >> 2] = f8 < f7 ? f7 : f8;
 HEAPF32[i1 >> 2] = f11 < f10 ? f10 : f11;
 i1 = HEAP32[i14 + 28 >> 2] | 0;
 do if (!i1) {
  i1 = i14 + 208 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) i15 = 15;
 } else {
  i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  i3 = i14 + 208 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i1 ^ (i2 | 0) != 0) {
   if (!i1) if (!i2) break; else {
    i1 = i3;
    i15 = 15;
    break;
   }
   if ((i3 | 0) != (gb + 1469400 | 0)) {
    if (!i2) i1 = i14 + 212 | 0; else {
     i1 = i14 + 212 | 0;
     HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i1 >> 2] = 0;
    }
    i14 = HEAP32[gb + 1469400 >> 2] | 0;
    HEAP32[i3 >> 2] = i14;
    HEAP32[i1 >> 2] = gb + 1469400;
    HEAP32[i14 + 4 >> 2] = i3;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
   }
  }
 } while (0);
 if ((i15 | 0) == 15) {
  i15 = i14 + 212 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 >> 2];
  HEAP32[HEAP32[i15 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
 }
 STACKTOP = i16;
 return;
}

function runPostSets126() {
 HEAP32[gb + 111144 >> 2] = fb + 1738;
 HEAP32[gb + 111148 >> 2] = fb + 1739;
 HEAP32[gb + 111152 >> 2] = fb + 1735;
 HEAP32[gb + 111156 >> 2] = fb + 1217;
 HEAP32[gb + 111160 >> 2] = fb + 16;
 HEAP32[gb + 111164 >> 2] = fb + 93;
 HEAP32[gb + 111168 >> 2] = fb + 1740;
 HEAP32[gb + 111172 >> 2] = fb + 1741;
 HEAP32[gb + 111176 >> 2] = fb + 873;
 HEAP32[gb + 111180 >> 2] = fb + 103;
 HEAP32[gb + 111184 >> 2] = fb + 101;
 HEAP32[gb + 111188 >> 2] = fb + 62;
 HEAP32[gb + 111192 >> 2] = fb + 28;
 HEAP32[gb + 111196 >> 2] = fb + 63;
 HEAP32[gb + 111200 >> 2] = fb + 29;
 HEAP32[gb + 111204 >> 2] = fb + 34;
 HEAP32[gb + 111208 >> 2] = fb + 1218;
 HEAP32[gb + 111212 >> 2] = fb + 1219;
 HEAP32[gb + 111216 >> 2] = fb + 1220;
 HEAP32[gb + 111220 >> 2] = fb + 1221;
 HEAP32[gb + 111224 >> 2] = fb + 1222;
 HEAP32[gb + 111228 >> 2] = fb + 1223;
 HEAP32[gb + 111232 >> 2] = fb + 36;
 HEAP32[gb + 111236 >> 2] = fb + 104;
 HEAP32[gb + 111240 >> 2] = fb + 1202;
 HEAP32[gb + 111244 >> 2] = fb + 94;
 HEAP32[gb + 111248 >> 2] = fb + 1203;
 HEAP32[gb + 111252 >> 2] = fb + 866;
 HEAP32[gb + 111256 >> 2] = fb + 867;
 HEAP32[gb + 111260 >> 2] = fb + 1204;
 HEAP32[gb + 111264 >> 2] = fb + 868;
 HEAP32[gb + 111268 >> 2] = fb + 869;
 HEAP32[gb + 111272 >> 2] = fb + 1205;
 HEAP32[gb + 111276 >> 2] = fb + 870;
 HEAP32[gb + 111280 >> 2] = fb + 871;
 HEAP32[gb + 111284 >> 2] = fb + 1224;
 HEAP32[gb + 111288 >> 2] = fb + 1225;
 HEAP32[gb + 111292 >> 2] = fb + 1742;
 HEAP32[gb + 111296 >> 2] = fb + 1736;
 HEAP32[gb + 111300 >> 2] = fb + 1730;
 HEAP32[gb + 111304 >> 2] = fb + 1731;
 HEAP32[gb + 111308 >> 2] = fb + 266;
 HEAP32[gb + 111312 >> 2] = fb + 1226;
 HEAP32[gb + 111316 >> 2] = fb + 1743;
 HEAP32[gb + 111328 >> 2] = fb + 63;
 HEAP32[gb + 111332 >> 2] = fb + 183;
 HEAP32[gb + 111336 >> 2] = fb + 1744;
 HEAP32[gb + 111340 >> 2] = fb + 1745;
 HEAP32[gb + 111352 >> 2] = fb + 1746;
 HEAP32[gb + 111356 >> 2] = fb + 1747;
 HEAP32[gb + 111360 >> 2] = fb + 1735;
 HEAP32[gb + 111364 >> 2] = fb + 1227;
 HEAP32[gb + 111368 >> 2] = fb + 16;
 HEAP32[gb + 111372 >> 2] = fb + 93;
 HEAP32[gb + 111376 >> 2] = fb + 1748;
 HEAP32[gb + 111380 >> 2] = fb + 1749;
 HEAP32[gb + 111384 >> 2] = fb + 874;
 HEAP32[gb + 111388 >> 2] = fb + 103;
 HEAP32[gb + 111392 >> 2] = fb + 101;
 HEAP32[gb + 111396 >> 2] = fb + 62;
 HEAP32[gb + 111400 >> 2] = fb + 28;
 HEAP32[gb + 111404 >> 2] = fb + 63;
 HEAP32[gb + 111408 >> 2] = fb + 29;
 HEAP32[gb + 111412 >> 2] = fb + 34;
 HEAP32[gb + 111416 >> 2] = fb + 1228;
 HEAP32[gb + 111420 >> 2] = fb + 1229;
 HEAP32[gb + 111424 >> 2] = fb + 1230;
 HEAP32[gb + 111428 >> 2] = fb + 1231;
 HEAP32[gb + 111432 >> 2] = fb + 1232;
 HEAP32[gb + 111436 >> 2] = fb + 1233;
 HEAP32[gb + 111440 >> 2] = fb + 36;
 HEAP32[gb + 111444 >> 2] = fb + 104;
 HEAP32[gb + 111448 >> 2] = fb + 1202;
 HEAP32[gb + 111452 >> 2] = fb + 94;
 HEAP32[gb + 111456 >> 2] = fb + 1203;
 HEAP32[gb + 111460 >> 2] = fb + 866;
 HEAP32[gb + 111464 >> 2] = fb + 867;
 HEAP32[gb + 111468 >> 2] = fb + 1204;
 HEAP32[gb + 111472 >> 2] = fb + 868;
 HEAP32[gb + 111476 >> 2] = fb + 869;
 HEAP32[gb + 111480 >> 2] = fb + 1234;
 HEAP32[gb + 111484 >> 2] = fb + 870;
 HEAP32[gb + 111488 >> 2] = fb + 871;
 HEAP32[gb + 111492 >> 2] = fb + 1235;
 HEAP32[gb + 111496 >> 2] = fb + 1236;
 HEAP32[gb + 111500 >> 2] = fb + 1750;
 HEAP32[gb + 111504 >> 2] = fb + 1751;
 HEAP32[gb + 111508 >> 2] = fb + 1730;
 HEAP32[gb + 111512 >> 2] = fb + 1731;
 HEAP32[gb + 111516 >> 2] = fb + 265;
 HEAP32[gb + 111520 >> 2] = fb + 1237;
 HEAP32[gb + 111524 >> 2] = fb + 1737;
 HEAP32[gb + 111536 >> 2] = fb + 875;
 HEAP32[gb + 111540 >> 2] = fb + 1752;
 HEAP32[gb + 111544 >> 2] = fb + 1753;
 HEAP32[gb + 111548 >> 2] = fb + 1754;
 HEAP32[gb + 111560 >> 2] = (HEAP32[gb + 111560 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 111564 >> 2] = (HEAP32[gb + 111564 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 111600 >> 2] = fb + 1755;
 HEAP32[gb + 111604 >> 2] = fb + 1756;
 runPostSets127();
}

function __ZL32CullAllPerObjectLightsCombineJobP29CullAllPerObjectLightsJobData(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 4 | 0;
 i2 = i15;
 if ((HEAP16[gb + 1114476 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114476 | 0, i1);
  i13 = gb + 1114476 | 0;
 } else i13 = 0;
 i11 = i14 + 180 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i14 + 40 >> 2] | 0;
 i10 = i5 + 8 | 0;
 i12 = i5 + 28 | 0;
 i6 = (i9 | 0) > 0;
 if (i6) {
  i2 = 0;
  i1 = 0;
  do {
   i1 = (HEAP32[(HEAP32[i14 + 44 + (i2 << 2) >> 2] | 0) + 12 >> 2] | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i9 | 0));
 } else i1 = 0;
 i2 = i5 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 3, 4, i5 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i5 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i5 + 20 >> 2] << 3 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i8;
  break;
 } while (0);
 i1 = (HEAP32[i14 + 36 >> 2] | 0) + 1 | 0;
 i2 = i5 + 40 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i5 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i8;
  break;
 } while (0);
 i8 = i5 + 20 | 0;
 if (i6) {
  i1 = 0;
  i6 = 0;
  do {
   i7 = HEAP32[i14 + 44 + (i6 << 2) >> 2] | 0;
   i3 = HEAP32[i14 + 108 + (i6 << 2) >> 2] | 0;
   i4 = HEAP32[i14 + 172 + (i6 * 12 | 0) + 4 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   if ((i5 | 0) != 0 & (i4 | 0) != 0) {
    i2 = 0;
    do {
     i16 = i3 + (i2 << 2) | 0;
     i17 = HEAP32[i16 >> 2] | 0;
     HEAP32[i16 >> 2] = (i17 & 2147483647) + i5 | i17 & -2147483648;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i4 | 0));
   }
   _memcpy((HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0, i3 | 0, i4 << 2 | 0) | 0;
   i1 = i4 + i1 | 0;
   i17 = HEAP32[i7 >> 2] | 0;
   __ZN13dynamic_arrayI11CulledLightLj4EE6insertEPS0_PKS0_S4_(i10, (HEAP32[i10 >> 2] | 0) + (HEAP32[i8 >> 2] << 3) | 0, i17, i17 + (HEAP32[i7 + 12 >> 2] << 3) | 0) | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i9 | 0));
 } else i1 = 0;
 HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i8 >> 2];
 if (i14 | 0) {
  i2 = i14 + 108 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 64024 | 0);
  HEAP32[i2 >> 2] = 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    i3 = i14 + 44 + (i1 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) if ((HEAP32[i4 + 16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 + 8 >> 2] | 0, i14);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 64024 | 0);
 if (!i13) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu18CompleteBoxPruningEPKNS_9PxBounds3EjRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE(i24, i2, i25, i1) {
 i24 = i24 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0, f27 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i26 + 8 | 0;
 i21 = i26 + 4 | 0;
 i22 = i26;
 i19 = i26 + 44 | 0;
 i20 = i25 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 if (!i2) {
  i25 = 0;
  STACKTOP = i26;
  return i25 | 0;
 }
 i17 = HEAP32[i1 >> 2] | 0;
 i18 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i26 + 45 | 0, i2 << 2, gb + 657458 | 0, 140) | 0;
 i1 = 0;
 do {
  HEAP32[i18 + (i1 << 2) >> 2] = HEAP32[i24 + (i1 * 24 | 0) + (i17 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i23);
 i1 = HEAP32[(__ZN5physx2Gu17RadixSortBuffered4SortEPKfj(i23, i18, i2) | 0) + 8 >> 2] | 0;
 i16 = i1 + (i2 << 2) | 0;
 L7 : do if ((i2 | 0) > 0) {
  i15 = i25 + 8 | 0;
  i2 = i1;
  i14 = i1;
  while (1) {
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = i14 + 4 | 0;
   HEAP32[i21 >> 2] = i13;
   i3 = i18 + (i13 << 2) | 0;
   while (1) {
    if (i2 >>> 0 >= i16 >>> 0) {
     i1 = i2;
     break;
    }
    i1 = i2 + 4 | 0;
    f27 = Math_fround(HEAPF32[i18 + (HEAP32[i2 >> 2] << 2) >> 2]);
    if (f27 < Math_fround(HEAPF32[i3 >> 2])) i2 = i1; else break;
   }
   i3 = i1 >>> 0 < i16 >>> 0;
   if (!i3) break L7;
   i4 = i24 + (i13 * 24 | 0) + 12 | 0;
   i5 = i4 + (i17 << 2) | 0;
   i6 = i24 + (i13 * 24 | 0) | 0;
   i7 = i24 + (i13 * 24 | 0) + 16 | 0;
   i8 = i24 + (i13 * 24 | 0) + 4 | 0;
   i9 = i24 + (i13 * 24 | 0) + 20 | 0;
   i10 = i24 + (i13 * 24 | 0) + 8 | 0;
   i12 = i1;
   do {
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = i12 + 4 | 0;
    HEAP32[i22 >> 2] = i11;
    f27 = Math_fround(HEAPF32[i18 + (i11 << 2) >> 2]);
    if (!(f27 <= Math_fround(HEAPF32[i5 >> 2]))) break;
    do if ((i13 | 0) != (i11 | 0)) {
     f27 = Math_fround(HEAPF32[i24 + (i11 * 24 | 0) >> 2]);
     if (!(f27 > Math_fround(HEAPF32[i4 >> 2]))) {
      f27 = Math_fround(HEAPF32[i6 >> 2]);
      if (!(f27 > Math_fround(HEAPF32[i24 + (i11 * 24 | 0) + 12 >> 2]))) {
       f27 = Math_fround(HEAPF32[i24 + (i11 * 24 | 0) + 4 >> 2]);
       if (!(f27 > Math_fround(HEAPF32[i7 >> 2]))) {
        f27 = Math_fround(HEAPF32[i8 >> 2]);
        if (!(f27 > Math_fround(HEAPF32[i24 + (i11 * 24 | 0) + 16 >> 2]))) {
         f27 = Math_fround(HEAPF32[i24 + (i11 * 24 | 0) + 8 >> 2]);
         if (!(f27 > Math_fround(HEAPF32[i9 >> 2]))) {
          f27 = Math_fround(HEAPF32[i10 >> 2]);
          if (!(f27 > Math_fround(HEAPF32[i24 + (i11 * 24 | 0) + 20 >> 2]))) {
           i2 = HEAP32[i20 >> 2] | 0;
           if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
            HEAP32[(HEAP32[i25 >> 2] | 0) + (i2 << 2) >> 2] = i13;
            i2 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
            HEAP32[i20 >> 2] = i2;
           } else {
            __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i25, i21) | 0;
            i2 = HEAP32[i20 >> 2] | 0;
           }
           if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
            HEAP32[(HEAP32[i25 >> 2] | 0) + (i2 << 2) >> 2] = i11;
            HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 1;
            break;
           } else {
            __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i25, i22) | 0;
            break;
           }
          }
         }
        }
       }
      }
     }
    } while (0);
   } while (i12 >>> 0 < i16 >>> 0);
   if (!(i14 >>> 0 < i16 >>> 0 & i3)) break; else i2 = i1;
  }
 } while (0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, i18);
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i23);
 i25 = 1;
 STACKTOP = i26;
 return i25 | 0;
}

function runPostSets198() {
 HEAP32[gb + 168428 >> 2] = fb + 1127;
 HEAP32[gb + 168432 >> 2] = fb + 1128;
 HEAP32[gb + 168436 >> 2] = fb + 469;
 HEAP32[gb + 168440 >> 2] = fb + 1129;
 HEAP32[gb + 168444 >> 2] = fb + 2558;
 HEAP32[gb + 168456 >> 2] = fb + 1125;
 HEAP32[gb + 168460 >> 2] = fb + 2559;
 HEAP32[gb + 168464 >> 2] = fb + 1258;
 HEAP32[gb + 168468 >> 2] = fb + 1211;
 HEAP32[gb + 168472 >> 2] = fb + 1127;
 HEAP32[gb + 168476 >> 2] = fb + 1128;
 HEAP32[gb + 168480 >> 2] = fb + 469;
 HEAP32[gb + 168484 >> 2] = fb + 1129;
 HEAP32[gb + 168488 >> 2] = fb + 2560;
 HEAP32[gb + 168500 >> 2] = fb + 1125;
 HEAP32[gb + 168504 >> 2] = fb + 2561;
 HEAP32[gb + 168508 >> 2] = fb + 1258;
 HEAP32[gb + 168512 >> 2] = fb + 1212;
 HEAP32[gb + 168516 >> 2] = fb + 1127;
 HEAP32[gb + 168520 >> 2] = fb + 1128;
 HEAP32[gb + 168524 >> 2] = fb + 469;
 HEAP32[gb + 168528 >> 2] = fb + 2562;
 HEAP32[gb + 168532 >> 2] = fb + 2563;
 HEAP32[gb + 168564 >> 2] = fb + 2564;
 HEAP32[gb + 168568 >> 2] = fb + 2565;
 HEAP32[gb + 168572 >> 2] = fb + 38;
 HEAP32[gb + 168576 >> 2] = fb + 1869;
 HEAP32[gb + 168580 >> 2] = fb + 16;
 HEAP32[gb + 168584 >> 2] = fb + 93;
 HEAP32[gb + 168588 >> 2] = fb + 2566;
 HEAP32[gb + 168592 >> 2] = fb + 19;
 HEAP32[gb + 168596 >> 2] = fb + 1213;
 HEAP32[gb + 168600 >> 2] = fb + 103;
 HEAP32[gb + 168604 >> 2] = fb + 101;
 HEAP32[gb + 168608 >> 2] = fb + 62;
 HEAP32[gb + 168612 >> 2] = fb + 28;
 HEAP32[gb + 168616 >> 2] = fb + 63;
 HEAP32[gb + 168620 >> 2] = fb + 29;
 HEAP32[gb + 168624 >> 2] = fb + 34;
 HEAP32[gb + 168628 >> 2] = fb + 1870;
 HEAP32[gb + 168632 >> 2] = fb + 1871;
 HEAP32[gb + 168636 >> 2] = fb + 1872;
 HEAP32[gb + 168640 >> 2] = fb + 1873;
 HEAP32[gb + 168644 >> 2] = fb + 1874;
 HEAP32[gb + 168648 >> 2] = fb + 1875;
 HEAP32[gb + 168652 >> 2] = fb + 36;
 HEAP32[gb + 168656 >> 2] = fb + 104;
 HEAP32[gb + 168660 >> 2] = fb + 108;
 HEAP32[gb + 168664 >> 2] = fb + 94;
 HEAP32[gb + 168668 >> 2] = fb + 1876;
 HEAP32[gb + 168672 >> 2] = fb + 112;
 HEAP32[gb + 168676 >> 2] = fb + 113;
 HEAP32[gb + 168680 >> 2] = fb + 1877;
 HEAP32[gb + 168684 >> 2] = fb + 111;
 HEAP32[gb + 168688 >> 2] = fb + 112;
 HEAP32[gb + 168692 >> 2] = fb + 2567;
 HEAP32[gb + 168696 >> 2] = fb + 2568;
 HEAP32[gb + 168700 >> 2] = fb + 2569;
 HEAP32[gb + 168712 >> 2] = (HEAP32[gb + 168712 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 168716 >> 2] = (HEAP32[gb + 168716 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 168752 >> 2] = fb + 1214;
 HEAP32[gb + 168756 >> 2] = fb + 1878;
 HEAP32[gb + 168760 >> 2] = fb + 18;
 HEAP32[gb + 168764 >> 2] = fb + 2570;
 HEAP32[gb + 168768 >> 2] = fb + 2571;
 HEAP32[gb + 168772 >> 2] = fb + 2572;
 HEAP32[gb + 168784 >> 2] = fb + 2573;
 HEAP32[gb + 168788 >> 2] = fb + 2574;
 HEAP32[gb + 168792 >> 2] = fb + 38;
 HEAP32[gb + 168796 >> 2] = fb + 1879;
 HEAP32[gb + 168800 >> 2] = fb + 16;
 HEAP32[gb + 168804 >> 2] = fb + 2575;
 HEAP32[gb + 168808 >> 2] = fb + 2576;
 HEAP32[gb + 168812 >> 2] = fb + 2577;
 HEAP32[gb + 168816 >> 2] = fb + 1215;
 HEAP32[gb + 168820 >> 2] = fb + 103;
 HEAP32[gb + 168824 >> 2] = fb + 101;
 HEAP32[gb + 168828 >> 2] = fb + 62;
 HEAP32[gb + 168832 >> 2] = fb + 28;
 HEAP32[gb + 168836 >> 2] = fb + 63;
 HEAP32[gb + 168840 >> 2] = fb + 29;
 HEAP32[gb + 168844 >> 2] = fb + 34;
 HEAP32[gb + 168848 >> 2] = fb + 1880;
 HEAP32[gb + 168852 >> 2] = fb + 1881;
 HEAP32[gb + 168856 >> 2] = fb + 1882;
 HEAP32[gb + 168860 >> 2] = fb + 1883;
 HEAP32[gb + 168864 >> 2] = fb + 1884;
 HEAP32[gb + 168868 >> 2] = fb + 1885;
 HEAP32[gb + 168872 >> 2] = fb + 36;
 HEAP32[gb + 168876 >> 2] = fb + 104;
 HEAP32[gb + 168880 >> 2] = fb + 108;
 HEAP32[gb + 168884 >> 2] = fb + 94;
 HEAP32[gb + 168888 >> 2] = fb + 130;
 HEAP32[gb + 168892 >> 2] = fb + 112;
 HEAP32[gb + 168896 >> 2] = fb + 113;
 HEAP32[gb + 168900 >> 2] = fb + 131;
 HEAP32[gb + 168904 >> 2] = fb + 111;
 HEAP32[gb + 168908 >> 2] = fb + 112;
 HEAP32[gb + 168912 >> 2] = fb + 113;
 HEAP32[gb + 168916 >> 2] = fb + 2578;
 runPostSets199();
}

function __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 152 | 0;
 i5 = i13 + 144 | 0;
 i9 = i13 + 128 | 0;
 i10 = i13 + 64 | 0;
 i11 = i13;
 __ZL19GetCameraTargetRectRK6Camerab(i4, i1, 1);
 f17 = Math_fround(HEAPF32[i1 + 864 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 868 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 872 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 876 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f17 = Math_fround(f17 * f19);
 f16 = Math_fround(f16 * f19);
 f15 = Math_fround(f15 * f18);
 f14 = Math_fround(f14 * f18);
 f21 = Math_fround(HEAPF32[i4 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f17 = Math_fround(f17 + f21);
 f15 = Math_fround(f15 + f20);
 f16 = Math_fround(f16 + f17);
 f14 = Math_fround(f14 + f15);
 f19 = Math_fround(f19 + f21);
 f18 = Math_fround(f18 + f20);
 f17 = f17 < f21 ? f21 : f17;
 f15 = f15 < f20 ? f20 : f15;
 f16 = Math_fround((f16 > f19 ? f19 : f16) - f17);
 i3 = f16 < Math_fround(0.0);
 f16 = i3 ? Math_fround(0.0) : f16;
 f14 = Math_fround((f14 > f18 ? f18 : f14) - f15);
 i3 = f14 < Math_fround(0.0);
 f14 = i3 ? Math_fround(0.0) : f14;
 f18 = Math_fround(f17 + Math_fround(.5));
 i3 = f18 >= Math_fround(0.0);
 f19 = Math_fround(f18 + Math_fround(-.99999994));
 i3 = ~~(i3 ? f18 : f19);
 HEAP32[i9 >> 2] = i3;
 f19 = Math_fround(f15 + Math_fround(.5));
 i2 = f19 >= Math_fround(0.0);
 f18 = Math_fround(f19 + Math_fround(-.99999994));
 i2 = ~~(i2 ? f19 : f18);
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = (~~Math_fround(Math_fround(f17 + f16) + Math_fround(.5)) >>> 0) - i3;
 HEAP32[i9 + 12 >> 2] = (~~Math_fround(Math_fround(f15 + f14) + Math_fround(.5)) >>> 0) - i2;
 __Z20InvertMatrix4x4_FullPKfPf(__ZNK6Camera20GetWorldToClipMatrixEv(i1) | 0, i10) | 0;
 i2 = i1 + 36 | 0;
 i3 = i1 + 1076 | 0;
 if (HEAP8[i3 >> 0] | 0) if (HEAP8[i1 + 1080 >> 0] | 0) {
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i2, i4) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i2, i4) | 0;
  HEAP8[i3 >> 0] = 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i2, i11) | 0;
 i6 = i1 + 744 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i8, i11, i10, i9, i7, 0) | 0;
  STACKTOP = i13;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 10; else if (HEAP32[i1 + 4 >> 2] | 0) {
   __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i8, i11, i10, i9, i7, 0) | 0;
   STACKTOP = i13;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i8, i11, i10, i9, i7, 0) | 0;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN12TreeRenderer13PrototypeInfoE13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 8 | 0;
 i9 = i15;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 44 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i13 = gb + 63616 | 0;
   i11 = HEAP32[i13 + 4 >> 2] | 0;
   i10 = i9;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i9);
   i10 = i14;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i1 + 8 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i11;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP8[i1 + 32 >> 0] = 0;
   HEAP32[i1 + 36 >> 2] = 0;
   HEAP32[i1 + 40 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 44 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 44 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 44 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = 62;
  HEAP32[i14 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 44 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i6 + (((i1 - i4 | 0) / 44 | 0) * 44 | 0) | 0;
 i3 = i7;
 i4 = i6 + (i5 * 44 | 0) | 0;
 i8 = i3;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  i6 = gb + 63616 | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  i16 = i9;
  HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i16 + 4 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i9);
  i16 = i14;
  i5 = HEAP32[i16 + 4 >> 2] | 0;
  i6 = i1 + 8 | 0;
  HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  i1 = i8 + 44 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i9 = i1;
   i1 = i1 + -44 | 0;
   HEAP32[i2 + -44 >> 2] = HEAP32[i1 >> 2];
   __ZN13dynamic_arrayIN12TreeRenderer15RendererLODInfoELj4EEC2ERKS2_(i2 + -40 | 0, i9 + -40 | 0);
   i16 = i2 + -20 | 0;
   i9 = i9 + -20 | 0;
   HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i16 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   i2 = i3 + -44 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -40 | 0;
  if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -36 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -44 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = 62;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i14);
 STACKTOP = i15;
 return;
}

function __ZN12NavMeshAgent8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 36 | 0;
 i9 = i5 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 106 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 40 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
  i5 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i9 >> 2] = i3;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, i39 = 0;
 f11 = Math_fround(HEAPF32[i3 + (i4 << 4) >> 2]);
 f9 = Math_fround(HEAPF32[i3 + (i4 << 4) + 4 >> 2]);
 i39 = HEAP32[i3 + (i4 << 4) + 8 >> 2] | 0;
 f35 = Math_fround(HEAPF32[i2 + (i39 << 6) >> 2]);
 f38 = Math_fround(HEAPF32[i2 + (i39 << 6) + 4 >> 2]);
 f37 = Math_fround(HEAPF32[i2 + (i39 << 6) + 8 >> 2]);
 f36 = Math_fround(HEAPF32[i2 + (i39 << 6) + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i2 + (i39 << 6) + 16 >> 2]);
 f30 = Math_fround(HEAPF32[i2 + (i39 << 6) + 20 >> 2]);
 f29 = Math_fround(HEAPF32[i2 + (i39 << 6) + 24 >> 2]);
 f28 = Math_fround(HEAPF32[i2 + (i39 << 6) + 28 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + (i39 << 6) + 32 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + (i39 << 6) + 36 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + (i39 << 6) + 40 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + (i39 << 6) + 44 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + (i39 << 6) + 48 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + (i39 << 6) + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + (i39 << 6) + 56 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + (i39 << 6) + 60 >> 2]);
 i4 = HEAP32[i3 + (i4 << 4) + 12 >> 2] | 0;
 f34 = Math_fround(HEAPF32[i2 + (i4 << 6) >> 2]);
 f33 = Math_fround(HEAPF32[i2 + (i4 << 6) + 4 >> 2]);
 f32 = Math_fround(HEAPF32[i2 + (i4 << 6) + 8 >> 2]);
 f31 = Math_fround(HEAPF32[i2 + (i4 << 6) + 12 >> 2]);
 f26 = Math_fround(HEAPF32[i2 + (i4 << 6) + 16 >> 2]);
 f25 = Math_fround(HEAPF32[i2 + (i4 << 6) + 20 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + (i4 << 6) + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + (i4 << 6) + 28 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + (i4 << 6) + 32 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + (i4 << 6) + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + (i4 << 6) + 40 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + (i4 << 6) + 44 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + (i4 << 6) + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + (i4 << 6) + 52 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + (i4 << 6) + 56 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + (i4 << 6) + 60 >> 2]);
 f33 = Math_fround(Math_fround(f11 * f38) + Math_fround(f9 * f33));
 f32 = Math_fround(Math_fround(f11 * f37) + Math_fround(f9 * f32));
 f31 = Math_fround(Math_fround(f11 * f36) + Math_fround(f9 * f31));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f11 * f35) + Math_fround(f9 * f34));
 HEAPF32[i1 + 4 >> 2] = f33;
 HEAPF32[i1 + 8 >> 2] = f32;
 HEAPF32[i1 + 12 >> 2] = f31;
 f25 = Math_fround(Math_fround(f11 * f30) + Math_fround(f9 * f25));
 f24 = Math_fround(Math_fround(f11 * f29) + Math_fround(f9 * f24));
 f23 = Math_fround(Math_fround(f11 * f28) + Math_fround(f9 * f23));
 HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(f11 * f27) + Math_fround(f9 * f26));
 HEAPF32[i1 + 20 >> 2] = f25;
 HEAPF32[i1 + 24 >> 2] = f24;
 HEAPF32[i1 + 28 >> 2] = f23;
 f17 = Math_fround(Math_fround(f11 * f22) + Math_fround(f9 * f17));
 f16 = Math_fround(Math_fround(f11 * f21) + Math_fround(f9 * f16));
 f15 = Math_fround(Math_fround(f11 * f20) + Math_fround(f9 * f15));
 HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(f11 * f19) + Math_fround(f9 * f18));
 HEAPF32[i1 + 36 >> 2] = f17;
 HEAPF32[i1 + 40 >> 2] = f16;
 HEAPF32[i1 + 44 >> 2] = f15;
 f7 = Math_fround(Math_fround(f11 * f14) + Math_fround(f9 * f7));
 f6 = Math_fround(Math_fround(f11 * f13) + Math_fround(f9 * f6));
 f5 = Math_fround(Math_fround(f11 * f12) + Math_fround(f9 * f5));
 HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f8));
 HEAPF32[i1 + 52 >> 2] = f7;
 HEAPF32[i1 + 56 >> 2] = f6;
 HEAPF32[i1 + 60 >> 2] = f5;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR12RaycastHit2DPS1_EEbT0_S4_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i19;
 switch ((i18 - i17 | 0) / 36 | 0 | 0) {
 case 2:
  {
   i7 = i18 + -36 | 0;
   if (!(Math_fround(HEAPF32[i18 + -8 >> 2]) < Math_fround(HEAPF32[i17 + 28 >> 2]))) {
    i18 = 1;
    STACKTOP = i19;
    return i18 | 0;
   }
   i1 = HEAP32[i17 >> 2] | 0;
   i2 = HEAP32[i17 + 4 >> 2] | 0;
   i3 = HEAP32[i17 + 8 >> 2] | 0;
   i4 = HEAP32[i17 + 12 >> 2] | 0;
   i5 = HEAP32[i17 + 16 >> 2] | 0;
   i6 = HEAP32[i17 + 20 >> 2] | 0;
   i14 = i17 + 24 | 0;
   HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   i14 = i17;
   i15 = i7;
   i16 = i14 + 36 | 0;
   do {
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    i14 = i14 + 4 | 0;
    i15 = i15 + 4 | 0;
   } while ((i14 | 0) < (i16 | 0));
   HEAP32[i7 >> 2] = i1;
   HEAP32[i18 + -32 >> 2] = i2;
   HEAP32[i18 + -28 >> 2] = i3;
   HEAP32[i18 + -24 >> 2] = i4;
   HEAP32[i18 + -20 >> 2] = i5;
   HEAP32[i18 + -16 >> 2] = i6;
   i18 = i18 + -12 | 0;
   HEAP32[i18 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i18 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i18 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i17, i17 + 36 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_(i17, i17 + 36 | 0, i17 + 72 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_(i17, i17 + 36 | 0, i17 + 72 | 0, i17 + 108 | 0, i18 + -36 | 0, i1) | 0;
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 1:
 case 0:
  {
   i18 = 1;
   STACKTOP = i19;
   return i18 | 0;
  }
 default:
  {
   i3 = i17 + 72 | 0;
   __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i17, i17 + 36 | 0, i3, i1) | 0;
   i1 = i17 + 108 | 0;
   L3 : do if ((i1 | 0) == (i18 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
     if (f9 < Math_fround(HEAPF32[i3 + 28 >> 2])) {
      i7 = HEAP32[i1 >> 2] | 0;
      i8 = HEAP32[i1 + 4 >> 2] | 0;
      i10 = HEAP32[i1 + 8 >> 2] | 0;
      i11 = HEAP32[i1 + 12 >> 2] | 0;
      i12 = HEAP32[i1 + 16 >> 2] | 0;
      i13 = HEAP32[i1 + 20 >> 2] | 0;
      i6 = HEAP32[i1 + 24 >> 2] | 0;
      i5 = HEAP32[i1 + 32 >> 2] | 0;
      i4 = i1;
      while (1) {
       i14 = i4;
       i15 = i3;
       i16 = i14 + 36 | 0;
       do {
        HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
        i14 = i14 + 4 | 0;
        i15 = i15 + 4 | 0;
       } while ((i14 | 0) < (i16 | 0));
       if ((i3 | 0) == (i17 | 0)) {
        i3 = i17;
        break;
       }
       if (f9 < Math_fround(HEAPF32[i3 + -8 >> 2])) {
        i4 = i3;
        i3 = i3 + -36 | 0;
       } else break;
      }
      HEAP32[i3 >> 2] = i7;
      HEAP32[i3 + 4 >> 2] = i8;
      HEAP32[i3 + 8 >> 2] = i10;
      HEAP32[i3 + 12 >> 2] = i11;
      HEAP32[i3 + 16 >> 2] = i12;
      HEAP32[i3 + 20 >> 2] = i13;
      HEAP32[i3 + 24 >> 2] = i6;
      HEAPF32[i3 + 28 >> 2] = f9;
      HEAP32[i3 + 32 >> 2] = i5;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 36 | 0) == (i18 | 0);
       break L3;
      }
     }
     i3 = i1 + 36 | 0;
     if ((i3 | 0) == (i18 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i16 = i1;
      i1 = i3;
      i3 = i16;
     }
    }
   } while (0);
   i18 = i1 | i2;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i27, i28, i26, i2, i1) {
 i27 = i27 | 0;
 i28 = i28 | 0;
 i26 = i26 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(f18 * f18);
 HEAPF32[i27 >> 2] = Math_fround(0.0);
 i19 = i28 + 384 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) {
  STACKTOP = i25;
  return;
 }
 i20 = i26 + 48 | 0;
 i21 = i26 + 52 | 0;
 i22 = i26 + 56 | 0;
 i23 = i26 + 16 | 0;
 i10 = i26 + 32 | 0;
 i11 = i26 + 4 | 0;
 i12 = i26 + 20 | 0;
 i13 = i26 + 36 | 0;
 i14 = i26 + 8 | 0;
 i15 = i26 + 24 | 0;
 i16 = i26 + 40 | 0;
 i17 = i27 + 4 | 0;
 f3 = Math_fround(0.0);
 do {
  i1 = i1 + -1 | 0;
  f31 = Math_fround(HEAPF32[i20 >> 2]);
  f33 = Math_fround(HEAPF32[i21 >> 2]);
  f35 = Math_fround(HEAPF32[i22 >> 2]);
  f38 = Math_fround(HEAPF32[i28 + (i1 << 6) >> 2]);
  f37 = Math_fround(HEAPF32[i28 + (i1 << 6) + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i28 + (i1 << 6) + 8 >> 2]);
  f36 = Math_fround(f38 * Math_fround(HEAPF32[i26 >> 2]));
  f36 = Math_fround(f36 + Math_fround(f37 * Math_fround(HEAPF32[i23 >> 2])));
  f36 = Math_fround(f36 + Math_fround(f32 * Math_fround(HEAPF32[i10 >> 2])));
  f34 = Math_fround(f38 * Math_fround(HEAPF32[i11 >> 2]));
  f34 = Math_fround(f34 + Math_fround(f37 * Math_fround(HEAPF32[i12 >> 2])));
  f34 = Math_fround(f34 + Math_fround(f32 * Math_fround(HEAPF32[i13 >> 2])));
  f38 = Math_fround(f38 * Math_fround(HEAPF32[i14 >> 2]));
  f37 = Math_fround(f38 + Math_fround(f37 * Math_fround(HEAPF32[i15 >> 2])));
  f36 = Math_fround(f31 + f36);
  f34 = Math_fround(f33 + f34);
  f32 = Math_fround(f35 + Math_fround(f37 + Math_fround(f32 * Math_fround(HEAPF32[i16 >> 2]))));
  f37 = Math_fround(HEAPF32[i28 + (i1 << 6) + 16 >> 2]);
  f35 = Math_fround(HEAPF32[i28 + (i1 << 6) + 20 >> 2]);
  f33 = Math_fround(HEAPF32[i28 + (i1 << 6) + 24 >> 2]);
  f31 = Math_fround(f36 - f37);
  f38 = Math_fround(f34 - f35);
  f9 = Math_fround(f32 - f33);
  i2 = i28 + (i1 << 6) + 32 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i28 + (i1 << 6) + 36 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i28 + (i1 << 6) + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  f30 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f31 = Math_fround(f31 * f30);
  f29 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f38 = Math_fround(f31 + Math_fround(f38 * f29));
  f31 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = Math_fround(f38 + Math_fround(f9 * f31));
  f30 = Math_fround(f37 - Math_fround(f36 - Math_fround(f30 * f9)));
  f29 = Math_fround(f35 - Math_fround(f34 - Math_fround(f29 * f9)));
  f31 = Math_fround(f33 - Math_fround(f32 - Math_fround(f31 * f9)));
  if (Math_fround(Math_fround(f31 * f31) + Math_fround(Math_fround(f30 * f30) + Math_fround(f29 * f29))) > f18) {
   i4 = (HEAP32[i19 >> 2] | 0) + -1 | 0;
   HEAP32[i19 >> 2] = i4;
   i2 = i28 + (i1 << 6) | 0;
   i4 = i28 + (i4 << 6) | 0;
   i5 = i2 + 52 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    i2 = i2 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i2 | 0) < (i5 | 0));
  } else {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i7 >> 2] = i8;
   HEAPF32[i28 + (i1 << 6) + 44 >> 2] = f9;
   f3 = f3 > f9 ? f9 : f3;
   HEAPF32[i27 >> 2] = f3;
   HEAP32[i17 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i25;
 return;
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 - i3 | 0;
 i5 = (i1 | 0) / 84 | 0;
 i8 = i9 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = i3;
 i3 = i4;
 i10 = i6;
 if (i5 >>> 0 > (((HEAP32[i8 >> 2] | 0) - i4 | 0) / 84 | 0) >>> 0) {
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE10deallocateEv(i9);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i6 = ((HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 84 | 0;
  i3 = i6 << 1;
  i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 73;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 84 | 0, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i9 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i8 >> 2] = i1 + (i3 * 84 | 0);
  if ((i2 | 0) == (i10 | 0)) {
   STACKTOP = i11;
   return;
  }
  do {
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i1, i2);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i1 + 20 | 0, i2 + 20 | 0);
   __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i1 + 40 | 0, i2 + 40 | 0);
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 68 >> 2];
   HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 72 >> 2];
   HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
   HEAP32[i1 + 80 >> 2] = HEAP32[i2 + 80 >> 2];
   i2 = i2 + 84 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 84 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i10 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i9 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 84 | 0;
 i4 = i5 >>> 0 > i1 >>> 0;
 i1 = i4 ? i2 + (i1 * 84 | 0) | 0 : i6;
 if ((i2 | 0) != (i1 | 0)) do {
  __ZN14HeightMeshDataaSERKS_(i3, i2) | 0;
  i2 = i2 + 84 | 0;
  i3 = i3 + 84 | 0;
 } while ((i2 | 0) != (i1 | 0));
 if (i4) {
  if ((i1 | 0) == (i10 | 0)) {
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2, i1);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + 20 | 0, i1 + 20 | 0);
   __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i2 + 40 | 0, i1 + 40 | 0);
   HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
   HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
   HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
   HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
   HEAP32[i2 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
   HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
   i1 = i1 + 84 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 84 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i4 = i1 + -84 | 0;
  HEAP32[i7 >> 2] = i4;
  i2 = i1 + -44 | 0;
  if ((HEAP32[i1 + -28 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -40 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -64 | 0;
  if ((HEAP32[i1 + -48 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -60 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  if ((HEAP32[i1 + -68 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + -80 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx7NpScene16addActorInternalERNS_7PxActorE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i4 = i7 + 12 | 0;
 switch (HEAPU16[i5 + 4 >> 1] | 0) {
 case 6:
  {
   i1 = i5 + 20 | 0;
   if (!(HEAP16[i1 + 4 >> 1] | 0)) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 358, gb + 682388 | 0, i7);
   i3 = ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0) & 8) != 0;
   __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb(i6 + 16 | 0, i5 + 48 | 0, i3);
   __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i1, i5);
   if (!i3) if (HEAP32[i5 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i5 + 12 | 0);
   i1 = i6 + 3552 | 0;
   i2 = i6 + 3556 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 + 36 >> 2] = i3;
   HEAP32[i4 >> 2] = i5;
   if ((HEAP32[i6 + 3560 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i4) | 0;
   STACKTOP = i7;
   return;
  }
 case 5:
  {
   i3 = ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0) & 8) != 0;
   __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i6 + 16 | 0, i5 + 48 | 0, i3);
   __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i5 + 20 | 0, i5);
   if (!i3) if (HEAP32[i5 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i5 + 12 | 0);
   i1 = i6 + 3552 | 0;
   i2 = i6 + 3556 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 + 36 >> 2] = i3;
   HEAP32[i4 >> 2] = i5;
   if ((HEAP32[i6 + 3560 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i4) | 0;
   STACKTOP = i7;
   return;
  }
 case 11:
  {
   __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE(i6 + 16 | 0, i5 + 20 | 0);
   i1 = i6 + 3640 | 0;
   HEAP32[i4 >> 2] = i5;
   i2 = i6 + 3644 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i6 + 3648 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i4) | 0;
   STACKTOP = i7;
   return;
  }
 case 12:
  {
   __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE(i6 + 16 | 0, i5 + 20 | 0);
   i1 = i6 + 3640 | 0;
   HEAP32[i4 >> 2] = i5;
   i2 = i6 + 3644 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i6 + 3648 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i4) | 0;
   STACKTOP = i7;
   return;
  }
 case 10:
  {
   __ZN5physx3Scb5Scene8addClothERNS0_5ClothE(i6 + 16 | 0, i5 + 20 | 0);
   i1 = i6 + 3652 | 0;
   HEAP32[i4 >> 2] = i5;
   i2 = i6 + 3656 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i6 + 3660 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
    HEAP32[i2 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_7PxClothENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i4) | 0;
   STACKTOP = i7;
   return;
  }
 case 15:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 406, gb + 682452 | 0, i1);
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE5eraseERS4_(i15, i1) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i14 = i15 + 24 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if (!i2) {
  i15 = 0;
  return i15 | 0;
 }
 i8 = i1;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = _i64Add(i7 | 0, i8 | 0, -1, ~i7 | 0) | 0;
 i1 = getTempRet0() | 0;
 i13 = _bitshift64Lshr(i3 | 0, i1 | 0, 22) | 0;
 i3 = i13 ^ i3;
 i1 = (getTempRet0() | 0) ^ i1;
 i13 = _bitshift64Shl(i3 | 0, i1 | 0, 13) | 0;
 i13 = _i64Add(i3 | 0, i1 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i1 = getTempRet0() | 0;
 i3 = _bitshift64Lshr(i13 | 0, i1 | 0, 8) | 0;
 i1 = ___muldi3(i3 ^ i13 | 0, (getTempRet0() | 0) ^ i1 | 0, 9, 0) | 0;
 i13 = getTempRet0() | 0;
 i3 = _bitshift64Lshr(i1 | 0, i13 | 0, 15) | 0;
 i1 = i3 ^ i1;
 i13 = (getTempRet0() | 0) ^ i13;
 i3 = _bitshift64Shl(i1 | 0, i13 | 0, 27) | 0;
 i3 = _i64Add(i1 | 0, i13 | 0, ~i3 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i13 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i3 | 0, i13 | 0, 31) | 0;
 (getTempRet0() | 0) ^ i13;
 i13 = i15 + 16 | 0;
 i3 = (HEAP32[i13 >> 2] | 0) + (((i1 ^ i3) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i15 = 0;
  return i15 | 0;
 }
 i11 = i15 + 8 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i10 = i15 + 12 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i2 = i1;
 while (1) {
  i4 = i9 + (i2 << 5) | 0;
  i16 = i4;
  i1 = i3;
  i3 = i6 + (i2 << 2) | 0;
  i5 = i2;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i16 >> 2] | 0) == (i7 | 0) ? (HEAP32[i16 + 4 >> 2] | 0) == (i8 | 0) : 0) break;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i12 = 11;
   break;
  }
 }
 if ((i12 | 0) == 11) return i1 | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i15 + 40 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i16 = i15 + 36 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  i2 = i9 + (i1 << 5) | 0;
  i16 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i16;
  i4 = i9 + (i5 << 5) + 8 | 0;
  i1 = i9 + (i1 << 5) + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  i4 = HEAP32[i10 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 >> 2] << 2) >> 2];
  i1 = HEAP32[i14 >> 2] | 0;
  i16 = (HEAP32[i11 >> 2] | 0) + (i5 << 5) | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  i2 = _i64Add(i2 | 0, HEAP32[i16 + 4 >> 2] | 0, -1, ~i2 | 0) | 0;
  i16 = getTempRet0() | 0;
  i14 = _bitshift64Lshr(i2 | 0, i16 | 0, 22) | 0;
  i2 = i14 ^ i2;
  i16 = (getTempRet0() | 0) ^ i16;
  i14 = _bitshift64Shl(i2 | 0, i16 | 0, 13) | 0;
  i14 = _i64Add(i2 | 0, i16 | 0, ~i14 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i16 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i14 | 0, i16 | 0, 8) | 0;
  i16 = ___muldi3(i2 ^ i14 | 0, (getTempRet0() | 0) ^ i16 | 0, 9, 0) | 0;
  i14 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i16 | 0, i14 | 0, 15) | 0;
  i16 = i2 ^ i16;
  i14 = (getTempRet0() | 0) ^ i14;
  i2 = _bitshift64Shl(i16 | 0, i14 | 0, 27) | 0;
  i2 = _i64Add(i16 | 0, i14 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i14 = getTempRet0() | 0;
  i16 = _bitshift64Lshr(i2 | 0, i14 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i14;
  i1 = (HEAP32[i13 >> 2] | 0) + (((i16 ^ i2) & i1 + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i16 = i15 + 32 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
 i16 = 1;
 return i16 | 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE17buildAccelerationEv(i31) {
 i31 = i31 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i32 + 528 | 0;
 i33 = i32 + 496 | 0;
 i5 = i32 + 464 | 0;
 i1 = i32 + 432 | 0;
 i2 = i32 + 400 | 0;
 i3 = i32 + 368 | 0;
 i26 = i32 + 336 | 0;
 i27 = i32 + 320 | 0;
 i21 = i32 + 304 | 0;
 i22 = i32 + 288 | 0;
 i23 = i32 + 272 | 0;
 i24 = i32 + 256 | 0;
 i29 = i32 + 240 | 0;
 i25 = i32 + 224 | 0;
 i7 = i32 + 208 | 0;
 i8 = i32 + 192 | 0;
 i30 = i32 + 176 | 0;
 i9 = i32 + 160 | 0;
 i10 = i32 + 144 | 0;
 i11 = i32 + 128 | 0;
 i28 = i32 + 112 | 0;
 i12 = i32 + 96 | 0;
 i13 = i32 + 80 | 0;
 i14 = i32 + 64 | 0;
 i15 = i32 + 48 | 0;
 i16 = i32 + 32 | 0;
 i17 = i32 + 16 | 0;
 i18 = i32;
 __ZN5physx5cloth11emptyBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEv(i33);
 i19 = i31 + 424 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i20 = i31 + 432 | 0;
 __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_PKNS0_10SphereDataESA_(i6, i33, i4, i4 + (HEAP32[(HEAP32[i20 >> 2] | 0) + 152 >> 2] << 4) | 0);
 __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf(i5, (HEAP32[i20 >> 2] | 0) + 12 | 0);
 i4 = HEAP32[i20 >> 2] | 0;
 if (HEAP8[i4 + 212 >> 0] | 0) {
  i33 = HEAP32[i31 + 416 >> 2] | 0;
  __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_PKNS0_10SphereDataESA_(i1, i6, i33, i33 + (HEAP32[i4 + 152 >> 2] << 4) | 0);
  __ZN5physx5cloth11BoundingBoxI8Scalar4fEaSERKS3_(i6, i1) | 0;
  __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf(i3, (HEAP32[i20 >> 2] | 0) + 36 | 0);
  __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_(i2, i5, i3);
  __ZN5physx5cloth11BoundingBoxI8Scalar4fEaSERKS3_(i5, i2) | 0;
 }
 __ZN5physx5cloth15intersectBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_(i26, i6, i5);
 i1 = i26 + 16 | 0;
 __ZmiRK8Scalar4fS1_(i21, i1, i26);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i23, gb + 1097792 | 0);
 __ZcoRK8Scalar4f(i22, i23);
 __ZanRK8Scalar4fRK14ComplementExprIS_E(i27, i21, i22);
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i24, i32 + 560 | 0);
 if (!(__Z15allGreaterEqualRK8Scalar4fS1_(i27, i24) | 0)) {
  i33 = 0;
  STACKTOP = i32;
  return i33 | 0;
 }
 __Z3absRK8Scalar4f(i7, i26);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i8, gb + 1097680 | 0);
 __ZmlRK8Scalar4fS1_(i25, i7, i8);
 __ZmiRK8Scalar4fS1_(i29, i26, i25);
 __Z3absRK8Scalar4f(i10, i1);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i11, gb + 1097680 | 0);
 __ZmlRK8Scalar4fS1_(i9, i10, i11);
 __ZplRK8Scalar4fS1_(i30, i1, i9);
 __ZmiRK8Scalar4fS1_(i12, i30, i29);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i13, gb + 1097856 | 0);
 __Z3maxRK8Scalar4fS1_(i28, i12, i13);
 i30 = i31 + 384 | 0;
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i15, gb + 1097696 | 0);
 __Z6recipTILi1EE8Scalar4fRKS0_(i16, i28);
 __ZmlRK8Scalar4fS1_(i14, i15, i16);
 __ZN8Scalar4faSERKS_(i30, i14) | 0;
 i33 = i31 + 400 | 0;
 __ZngRK8Scalar4f(i18, i29);
 __ZmlRK8Scalar4fS1_(i17, i18, i30);
 __ZN8Scalar4faSERKS_(i33, i17) | 0;
 HEAPF32[(__Z5arrayR8Scalar4f(i33) | 0) + 12 >> 2] = Math_fround(1.0);
 _memset(i31 | 0, 0, 192) | 0;
 if (HEAP8[(HEAP32[i20 >> 2] | 0) + 212 >> 0] | 0) __ZN5physx5cloth11SwCollisionI8Scalar4fE23buildSphereAccelerationEPKNS0_10SphereDataE(i31, HEAP32[i31 + 416 >> 2] | 0);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE23buildSphereAccelerationEPKNS0_10SphereDataE(i31, HEAP32[i19 >> 2] | 0);
 _memset(i31 + 192 | 0, 0, 192) | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE21buildConeAccelerationEv(i31);
 i33 = 1;
 STACKTOP = i32;
 return i33 | 0;
}

function __ZN19VREyeTextureManager20FlushToDeviceTextureEf(i1, f5) {
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i7 = i12;
 i10 = i1 + 40 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 i11 = i1 + 36 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i3 + 16 >> 2] | 0;
 i8 = HEAP32[i2 + 16 >> 2] | 0;
 if (!((i8 | 0) != 0 & (HEAP8[i1 + 104 >> 0] | 0) != 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = (i9 | 0) == 2;
 i4 = (i8 | 0) == 2;
 if (i1 ^ i4) {
  if (i1 & (i8 | 0) == 4) {
   i9 = HEAP32[i3 >> 2] | 0;
   __Z11CopyTextureP7TextureiiiiiiS0_iiii(i9, 0, 0, 0, 0, (HEAP32[i9 + 80 >> 2] | 0) / 2 | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i2 >> 2] | 0, 0, 0, 0, 0) | 0;
   i11 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
   i9 = HEAP32[i11 + 80 >> 2] | 0;
   __Z11CopyTextureP7TextureiiiiiiS0_iiii(i11, 0, 0, (i9 | 0) / 2 | 0, 0, (i9 | 0) / 2 | 0, HEAP32[i11 + 84 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0, 1, 0, 0, 0) | 0;
   STACKTOP = i12;
   return;
  }
  if (i1) {
   i9 = __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0;
   i4 = i6 + 4 | 0;
   i8 = i7 + 4 | 0;
   HEAPF32[i6 >> 2] = Math_fround(.5);
   HEAPF32[i4 >> 2] = Math_fround(1.0);
   HEAPF32[i7 >> 2] = Math_fround(f5 * Math_fround(0.0));
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(HEAP32[gb + 1166248 >> 2] | 0, HEAP32[HEAP32[i11 >> 2] >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i9, -1, 1, -1, i6, i7);
   HEAPF32[i6 >> 2] = Math_fround(.5);
   HEAPF32[i4 >> 2] = Math_fround(1.0);
   HEAPF32[i7 >> 2] = Math_fround(f5 * Math_fround(.5));
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(HEAP32[gb + 1166248 >> 2] | 0, HEAP32[HEAP32[i11 >> 2] >> 2] | 0, HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i9, -1, 1, -1, i6, i7);
   STACKTOP = i12;
   return;
  }
  if (!i4) {
   STACKTOP = i12;
   return;
  }
  __ZN12VRGfxHelpers13BlitLeftRightEP13RenderTextureS1_S1_(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0);
  STACKTOP = i12;
  return;
 }
 i4 = i1 ? 1 : 2;
 i1 = (i8 | 0) == 4;
 if ((i9 | 0) == 4) {
  if (!i1) {
   i1 = 0;
   while (1) {
    i9 = HEAP32[i3 >> 2] | 0;
    __Z11CopyTextureP7TextureiiiiiiS0_iiii(i9, i1, 0, 0, 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i2 + (i1 << 2) >> 2] | 0, 0, 0, 0, 0) | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i4 | 0)) break;
    i3 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   STACKTOP = i12;
   return;
  }
  i1 = 0;
  while (1) {
   i9 = HEAP32[i3 >> 2] | 0;
   __Z11CopyTextureP7TextureiiiiiiS0_iiii(i9, i1, 0, 0, 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1, 0, 0, 0) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) break;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  }
  STACKTOP = i12;
  return;
 } else {
  if (!i1) {
   i1 = 0;
   while (1) {
    i9 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    __Z11CopyTextureP7TextureiiiiiiS0_iiii(i9, 0, 0, 0, 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i2 + (i1 << 2) >> 2] | 0, 0, 0, 0, 0) | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i4 | 0)) break;
    i3 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   STACKTOP = i12;
   return;
  }
  i1 = 0;
  while (1) {
   i9 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   __Z11CopyTextureP7TextureiiiiiiS0_iiii(i9, 0, 0, 0, 0, HEAP32[i9 + 80 >> 2] | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1, 0, 0, 0) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) break;
   i3 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  }
  STACKTOP = i12;
  return;
 }
}

function __ZN14SpriteRenderer15SetupPropertiesER19ShaderPropertySheetRK16SpriteRenderData(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 32 | 0;
 i7 = i12 + 20 | 0;
 i5 = i12;
 i6 = i12 + 24 | 0;
 i10 = i12 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i11 = 11; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i7);
    i2 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 9;
   }
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i11 = 11;
    break;
   }
  }
  i13 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
  i2 = HEAP32[i1 + 68 >> 2] | 0;
  i3 = HEAP32[i1 + 72 >> 2] | 0;
  f15 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
  f14 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0);
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  HEAPF32[i5 + 8 >> 2] = f15;
  HEAPF32[i5 + 12 >> 2] = f14;
  i1 = i13;
 } while (0);
 if ((i11 | 0) == 11) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  i1 = 0;
 }
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i9, 4);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i9, gb + 1161704 | 0, i8, 2, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i9, gb + 1161708 | 0, i5, 0);
 i4 = i4 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i7);
   i2 = HEAP32[i8 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 20;
  }
 }
 if ((i11 | 0) == 18) i11 = 20;
 if ((i11 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i9, gb + 1161712 | 0, i8, 2, 0);
 STACKTOP = i12;
 return;
}

function runPostSets174() {
 HEAP32[gb + 151444 >> 2] = fb + 2263;
 HEAP32[gb + 151456 >> 2] = fb + 124;
 HEAP32[gb + 151460 >> 2] = fb + 1035;
 HEAP32[gb + 151464 >> 2] = fb + 1036;
 HEAP32[gb + 151468 >> 2] = fb + 2264;
 HEAP32[gb + 151480 >> 2] = fb + 15;
 HEAP32[gb + 151484 >> 2] = fb + 249;
 HEAP32[gb + 151488 >> 2] = fb + 71;
 HEAP32[gb + 151492 >> 2] = fb + 413;
 HEAP32[gb + 151496 >> 2] = fb + 414;
 HEAP32[gb + 151500 >> 2] = fb + 415;
 HEAP32[gb + 151504 >> 2] = fb + 1512;
 HEAP32[gb + 151508 >> 2] = fb + 389;
 HEAP32[gb + 151512 >> 2] = fb + 21;
 HEAP32[gb + 151516 >> 2] = fb + 390;
 HEAP32[gb + 151520 >> 2] = fb + 391;
 HEAP32[gb + 151524 >> 2] = fb + 392;
 HEAP32[gb + 151528 >> 2] = fb + 1;
 HEAP32[gb + 151532 >> 2] = fb + 129;
 HEAP32[gb + 151536 >> 2] = fb + 1513;
 HEAP32[gb + 151540 >> 2] = fb + 1514;
 HEAP32[gb + 151544 >> 2] = fb + 393;
 HEAP32[gb + 151548 >> 2] = fb + 1515;
 HEAP32[gb + 151552 >> 2] = fb + 1516;
 HEAP32[gb + 151556 >> 2] = fb + 119;
 HEAP32[gb + 151560 >> 2] = fb + 1517;
 HEAP32[gb + 151572 >> 2] = (HEAP32[gb + 151572 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 151576 >> 2] = (HEAP32[gb + 151576 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 151612 >> 2] = fb + 2265;
 HEAP32[gb + 151616 >> 2] = fb + 2266;
 HEAP32[gb + 151620 >> 2] = fb + 394;
 HEAP32[gb + 151624 >> 2] = fb + 1053;
 HEAP32[gb + 151628 >> 2] = fb + 250;
 HEAP32[gb + 151632 >> 2] = fb + 75;
 HEAP32[gb + 151636 >> 2] = fb + 72;
 HEAP32[gb + 151640 >> 2] = fb + 22;
 HEAP32[gb + 151656 >> 2] = fb + 2267;
 HEAP32[gb + 151660 >> 2] = fb + 2268;
 HEAP32[gb + 151664 >> 2] = fb + 395;
 HEAP32[gb + 151668 >> 2] = fb + 1054;
 HEAP32[gb + 151672 >> 2] = fb + 251;
 HEAP32[gb + 151676 >> 2] = fb + 76;
 HEAP32[gb + 151680 >> 2] = fb + 73;
 HEAP32[gb + 151684 >> 2] = fb + 23;
 HEAP32[gb + 151696 >> 2] = fb + 2269;
 HEAP32[gb + 151700 >> 2] = fb + 2270;
 HEAP32[gb + 151704 >> 2] = fb + 396;
 HEAP32[gb + 151708 >> 2] = fb + 1055;
 HEAP32[gb + 151712 >> 2] = fb + 252;
 HEAP32[gb + 151716 >> 2] = fb + 77;
 HEAP32[gb + 151720 >> 2] = fb + 74;
 HEAP32[gb + 151724 >> 2] = fb + 24;
 HEAP32[gb + 151736 >> 2] = fb + 2267;
 HEAP32[gb + 151740 >> 2] = fb + 2271;
 HEAP32[gb + 151744 >> 2] = fb + 397;
 HEAP32[gb + 151748 >> 2] = fb + 1056;
 HEAP32[gb + 151752 >> 2] = fb + 253;
 HEAP32[gb + 151756 >> 2] = fb + 78;
 HEAP32[gb + 151760 >> 2] = fb + 75;
 HEAP32[gb + 151764 >> 2] = fb + 25;
 HEAP32[gb + 151832 >> 2] = fb + 2267;
 HEAP32[gb + 151836 >> 2] = fb + 2272;
 HEAP32[gb + 151840 >> 2] = fb + 398;
 HEAP32[gb + 151844 >> 2] = fb + 1057;
 HEAP32[gb + 151848 >> 2] = fb + 254;
 HEAP32[gb + 151852 >> 2] = fb + 79;
 HEAP32[gb + 151856 >> 2] = fb + 76;
 HEAP32[gb + 151860 >> 2] = fb + 26;
 HEAP32[gb + 151932 >> 2] = fb + 124;
 HEAP32[gb + 151936 >> 2] = fb + 2273;
 HEAP32[gb + 151940 >> 2] = fb + 2274;
 HEAP32[gb + 151952 >> 2] = fb + 125;
 HEAP32[gb + 151956 >> 2] = fb + 2273;
 HEAP32[gb + 151960 >> 2] = fb + 2275;
 HEAP32[gb + 151972 >> 2] = fb + 126;
 HEAP32[gb + 151976 >> 2] = fb + 2273;
 HEAP32[gb + 151980 >> 2] = fb + 2276;
 HEAP32[gb + 151992 >> 2] = fb + 127;
 HEAP32[gb + 151996 >> 2] = fb + 2273;
 HEAP32[gb + 152e3 >> 2] = fb + 2277;
 HEAP32[gb + 152012 >> 2] = fb + 128;
 HEAP32[gb + 152016 >> 2] = fb + 2273;
 HEAP32[gb + 152020 >> 2] = fb + 2278;
 HEAP32[gb + 152032 >> 2] = fb + 129;
 HEAP32[gb + 152036 >> 2] = fb + 2273;
 HEAP32[gb + 152040 >> 2] = fb + 2279;
 HEAP32[gb + 152052 >> 2] = fb + 130;
 HEAP32[gb + 152056 >> 2] = fb + 2273;
 HEAP32[gb + 152060 >> 2] = fb + 2280;
 HEAP32[gb + 152072 >> 2] = fb + 131;
 HEAP32[gb + 152076 >> 2] = fb + 2273;
 HEAP32[gb + 152080 >> 2] = fb + 2281;
 HEAP32[gb + 152092 >> 2] = fb + 132;
 HEAP32[gb + 152096 >> 2] = fb + 2273;
 HEAP32[gb + 152100 >> 2] = fb + 2282;
 HEAP32[gb + 152112 >> 2] = fb + 133;
 HEAP32[gb + 152116 >> 2] = fb + 2273;
 HEAP32[gb + 152120 >> 2] = fb + 2283;
 HEAP32[gb + 152132 >> 2] = fb + 134;
 HEAP32[gb + 152136 >> 2] = fb + 2273;
 runPostSets175();
}

function runPostSets125() {
 HEAP32[gb + 110672 >> 2] = fb + 1718;
 HEAP32[gb + 110676 >> 2] = fb + 1719;
 HEAP32[gb + 110680 >> 2] = fb + 181;
 HEAP32[gb + 110684 >> 2] = fb + 863;
 HEAP32[gb + 110696 >> 2] = fb + 1718;
 HEAP32[gb + 110700 >> 2] = fb + 1720;
 HEAP32[gb + 110704 >> 2] = fb + 182;
 HEAP32[gb + 110708 >> 2] = fb + 864;
 HEAP32[gb + 110720 >> 2] = fb + 1721;
 HEAP32[gb + 110724 >> 2] = fb + 1722;
 HEAP32[gb + 110736 >> 2] = fb + 1723;
 HEAP32[gb + 110740 >> 2] = fb + 1724;
 HEAP32[gb + 110744 >> 2] = fb + 1725;
 HEAP32[gb + 110748 >> 2] = fb + 1195;
 HEAP32[gb + 110752 >> 2] = fb + 16;
 HEAP32[gb + 110756 >> 2] = fb + 93;
 HEAP32[gb + 110760 >> 2] = fb + 1726;
 HEAP32[gb + 110764 >> 2] = fb + 1727;
 HEAP32[gb + 110768 >> 2] = fb + 865;
 HEAP32[gb + 110772 >> 2] = fb + 103;
 HEAP32[gb + 110776 >> 2] = fb + 101;
 HEAP32[gb + 110780 >> 2] = fb + 62;
 HEAP32[gb + 110784 >> 2] = fb + 28;
 HEAP32[gb + 110788 >> 2] = fb + 63;
 HEAP32[gb + 110792 >> 2] = fb + 29;
 HEAP32[gb + 110796 >> 2] = fb + 34;
 HEAP32[gb + 110800 >> 2] = fb + 1196;
 HEAP32[gb + 110804 >> 2] = fb + 1197;
 HEAP32[gb + 110808 >> 2] = fb + 1198;
 HEAP32[gb + 110812 >> 2] = fb + 1199;
 HEAP32[gb + 110816 >> 2] = fb + 1200;
 HEAP32[gb + 110820 >> 2] = fb + 1201;
 HEAP32[gb + 110824 >> 2] = fb + 36;
 HEAP32[gb + 110828 >> 2] = fb + 104;
 HEAP32[gb + 110832 >> 2] = fb + 1202;
 HEAP32[gb + 110836 >> 2] = fb + 94;
 HEAP32[gb + 110840 >> 2] = fb + 1203;
 HEAP32[gb + 110844 >> 2] = fb + 866;
 HEAP32[gb + 110848 >> 2] = fb + 867;
 HEAP32[gb + 110852 >> 2] = fb + 1204;
 HEAP32[gb + 110856 >> 2] = fb + 868;
 HEAP32[gb + 110860 >> 2] = fb + 869;
 HEAP32[gb + 110864 >> 2] = fb + 1205;
 HEAP32[gb + 110868 >> 2] = fb + 870;
 HEAP32[gb + 110872 >> 2] = fb + 871;
 HEAP32[gb + 110876 >> 2] = fb + 1206;
 HEAP32[gb + 110880 >> 2] = fb + 1207;
 HEAP32[gb + 110884 >> 2] = fb + 1728;
 HEAP32[gb + 110888 >> 2] = fb + 1729;
 HEAP32[gb + 110892 >> 2] = fb + 1730;
 HEAP32[gb + 110896 >> 2] = fb + 1731;
 HEAP32[gb + 110900 >> 2] = fb + 264;
 HEAP32[gb + 110904 >> 2] = fb + 1208;
 HEAP32[gb + 110908 >> 2] = fb + 1732;
 HEAP32[gb + 110920 >> 2] = (HEAP32[gb + 110920 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 110924 >> 2] = (HEAP32[gb + 110924 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 110960 >> 2] = fb + 1733;
 HEAP32[gb + 110964 >> 2] = fb + 1734;
 HEAP32[gb + 110968 >> 2] = fb + 1735;
 HEAP32[gb + 110972 >> 2] = fb + 1209;
 HEAP32[gb + 110976 >> 2] = fb + 16;
 HEAP32[gb + 110980 >> 2] = fb + 93;
 HEAP32[gb + 110984 >> 2] = fb + 40;
 HEAP32[gb + 110988 >> 2] = fb + 19;
 HEAP32[gb + 110992 >> 2] = fb + 872;
 HEAP32[gb + 110996 >> 2] = fb + 103;
 HEAP32[gb + 111e3 >> 2] = fb + 101;
 HEAP32[gb + 111004 >> 2] = fb + 62;
 HEAP32[gb + 111008 >> 2] = fb + 28;
 HEAP32[gb + 111012 >> 2] = fb + 63;
 HEAP32[gb + 111016 >> 2] = fb + 29;
 HEAP32[gb + 111020 >> 2] = fb + 34;
 HEAP32[gb + 111024 >> 2] = fb + 1210;
 HEAP32[gb + 111028 >> 2] = fb + 1211;
 HEAP32[gb + 111032 >> 2] = fb + 1212;
 HEAP32[gb + 111036 >> 2] = fb + 1213;
 HEAP32[gb + 111040 >> 2] = fb + 1214;
 HEAP32[gb + 111044 >> 2] = fb + 1215;
 HEAP32[gb + 111048 >> 2] = fb + 36;
 HEAP32[gb + 111052 >> 2] = fb + 104;
 HEAP32[gb + 111056 >> 2] = fb + 1202;
 HEAP32[gb + 111060 >> 2] = fb + 94;
 HEAP32[gb + 111064 >> 2] = fb + 1203;
 HEAP32[gb + 111068 >> 2] = fb + 866;
 HEAP32[gb + 111072 >> 2] = fb + 867;
 HEAP32[gb + 111076 >> 2] = fb + 1204;
 HEAP32[gb + 111080 >> 2] = fb + 868;
 HEAP32[gb + 111084 >> 2] = fb + 869;
 HEAP32[gb + 111088 >> 2] = fb + 1205;
 HEAP32[gb + 111092 >> 2] = fb + 870;
 HEAP32[gb + 111096 >> 2] = fb + 871;
 HEAP32[gb + 111100 >> 2] = fb + 1206;
 HEAP32[gb + 111104 >> 2] = fb + 1;
 HEAP32[gb + 111108 >> 2] = fb + 1;
 HEAP32[gb + 111112 >> 2] = fb + 1736;
 HEAP32[gb + 111116 >> 2] = fb + 1730;
 HEAP32[gb + 111120 >> 2] = fb + 1731;
 HEAP32[gb + 111124 >> 2] = fb + 265;
 HEAP32[gb + 111128 >> 2] = fb + 1216;
 HEAP32[gb + 111132 >> 2] = fb + 1737;
 runPostSets126();
}

function __ZN5physx30PxcContactTraceSegmentCallback12underFaceHitERKNS_2Gu15HeightFieldUtilERKNS_6PxVec3ES7_fffj(i21, i1, i17, i5, f23, f24, f20, i22) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i5 = i5 | 0;
 f23 = Math_fround(f23);
 f24 = Math_fround(f24);
 f20 = Math_fround(f20);
 i22 = i22 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f18 = f0, i19 = 0, f25 = f0, f26 = f0;
 i19 = i21 + 68 | 0;
 if ((HEAP32[i19 >> 2] | 0) == -1) {
  HEAP32[i19 >> 2] = i22;
  return 1;
 }
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 16 >> 2] | 0) + 8 >> 2]);
 f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f23);
 f6 = Math_fround(f20 - Math_fround(f2 * Math_fround(__ZNK5physx2Gu11HeightField17getHeightInternalEff(i7, f6, Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f24)))));
 f2 = Math_fround(HEAPF32[i21 + 64 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 if (!(f18 <= f6) | (!(f6 <= f2) | !(f18 <= Math_fround(0.0)))) if (!(f18 > f6 & (f6 > Math_fround(-f2) & f18 > Math_fround(0.0)))) return 1;
 f16 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f2 = Math_fround(f16 * f3);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f13 * f14));
 f4 = Math_fround(HEAPF32[i21 >> 2]);
 f13 = Math_fround(f13 * f4);
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(f13 - Math_fround(f3 * f15));
 f4 = Math_fround(Math_fround(f14 * f15) - Math_fround(f16 * f4));
 if (f3 < Math_fround(0.0)) {
  f3 = Math_fround(-f3);
  f4 = Math_fround(-f4);
  f2 = Math_fround(-f2);
 }
 if (f3 < Math_fround(0.0)) return 1;
 f2 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2)));
 if (!(f2 > Math_fround(0.0))) return 1;
 f3 = Math_fround(f6 * Math_fround(f3 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))))));
 i7 = HEAP32[i21 + 12 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i21 + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i21 + 32 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + 36 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + 40 >> 2]);
 f13 = Math_fround(HEAPF32[i21 + 44 >> 2]);
 f14 = Math_fround(HEAPF32[i21 + 48 >> 2]);
 f15 = Math_fround(HEAPF32[i17 >> 2]);
 f16 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 i1 = i7 + 4096 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (i5 >>> 0 <= 63) {
  i17 = f18 > Math_fround(0.0);
  f18 = Math_fround(-f3);
  f25 = Math_fround(Math_fround(Math_fround(f8 * f15) + Math_fround(f11 * f16)) + Math_fround(f14 * f2));
  f26 = Math_fround(Math_fround(Math_fround(f6 * f15) + Math_fround(f10 * f16)) + Math_fround(f13 * f2));
  f2 = Math_fround(Math_fround(Math_fround(f4 * f15) + Math_fround(f9 * f16)) + Math_fround(f12 * f2));
  f16 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f11 * f20)) + Math_fround(f14 * f24));
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i21 + 60 >> 2]));
  f15 = Math_fround(Math_fround(Math_fround(f6 * f23) + Math_fround(f10 * f20)) + Math_fround(f13 * f24));
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i21 + 56 >> 2]));
  f24 = Math_fround(Math_fround(Math_fround(f4 * f23) + Math_fround(f9 * f20)) + Math_fround(f12 * f24));
  f24 = Math_fround(f24 + Math_fround(HEAPF32[i21 + 52 >> 2]));
  HEAP32[i1 >> 2] = i5 + 1;
  HEAPF32[i7 + (i5 << 6) >> 2] = f2;
  HEAPF32[i7 + (i5 << 6) + 4 >> 2] = f26;
  HEAPF32[i7 + (i5 << 6) + 8 >> 2] = f25;
  HEAPF32[i7 + (i5 << 6) + 16 >> 2] = f24;
  HEAPF32[i7 + (i5 << 6) + 20 >> 2] = f15;
  HEAPF32[i7 + (i5 << 6) + 24 >> 2] = f16;
  HEAPF32[i7 + (i5 << 6) + 12 >> 2] = i17 ? f18 : f3;
  HEAP32[i7 + (i5 << 6) + 48 >> 2] = -1;
  HEAP32[i7 + (i5 << 6) + 52 >> 2] = i22;
 }
 HEAP32[i19 >> 2] = i22;
 return 1;
}

function __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085899 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6insertERNS0_2Sc5SceneERS2_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 if (HEAP16[((i12 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i12 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 8 | 0 : HEAP32[i3 + 8 >> 2] | 0) >> 1] & 8) {
  __ZL22addOrRemoveRigidObjectILb0ELb1ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(HEAP32[i2 + 1236 >> 2] | 0, i3);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i2 + 1236 >> 2] | 0;
 do if (!i1) {
  i12 = i14 + 256 | 0;
  i9 = i14 + 260 | 0;
  HEAP32[i14 + 264 >> 2] = 0;
  i10 = i14 + 268 | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP32[i9 >> 2] = i14;
  HEAP32[i10 >> 2] = 64;
  i11 = i13 + 256 | 0;
  HEAP8[i11 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i3, i15) | 0;
  __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj(i2, i3 + 16 | 0, HEAP32[i15 >> 2] | 0, i8, i1);
  i6 = HEAP32[i3 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i3 + i7 | 0;
    i3 = i3 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 >> 2] = i6;
    }
    __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i2);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i13 + 268 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i13 + 260 >> 2] | 0;
   if ((i13 | 0) == (i1 | 0)) {
    HEAP8[i11 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
  i15 = HEAP32[i10 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i3, i15) | 0;
  __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj(i2, i3 + 16 | 0, HEAP32[i15 >> 2] | 0, i8, i1);
  i6 = HEAP32[i3 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i3 + i7 | 0;
    i3 = i3 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 >> 2] = i6;
    }
    __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i2);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 + 260 >> 2] | 0;
   if ((i10 | 0) == (i1 | 0)) {
    HEAP8[i9 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085899 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 39; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 39; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 39) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f21 = Math_fround(f20 + f20);
 f13 = Math_fround(f19 + f19);
 f17 = Math_fround(f16 + f16);
 f18 = Math_fround(f19 * f13);
 f6 = Math_fround(f16 * f17);
 f19 = Math_fround(f21 * f19);
 f24 = Math_fround(f21 * f16);
 f7 = Math_fround(f21 * f15);
 f16 = Math_fround(f13 * f16);
 f13 = Math_fround(f13 * f15);
 f15 = Math_fround(f17 * f15);
 f17 = Math_fround(Math_fround(Math_fround(1.0) - f18) - f6);
 f25 = Math_fround(f19 + f15);
 f22 = Math_fround(f24 - f13);
 f15 = Math_fround(f19 - f15);
 f21 = Math_fround(Math_fround(1.0) - Math_fround(f20 * f21));
 f6 = Math_fround(f21 - f6);
 f20 = Math_fround(f16 + f7);
 f13 = Math_fround(f24 + f13);
 f7 = Math_fround(f16 - f7);
 f18 = Math_fround(f21 - f18);
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(f21 * f17);
 f24 = Math_fround(f21 * f25);
 f21 = Math_fround(f21 * f22);
 f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f19 * f15));
 f24 = Math_fround(f24 + Math_fround(f19 * f6));
 f19 = Math_fround(f21 + Math_fround(f19 * f20));
 f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f13 * f21));
 f24 = Math_fround(f24 + Math_fround(f7 * f21));
 f21 = Math_fround(f19 + Math_fround(f18 * f21));
 f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f14 = Math_fround(f17 * f19);
 f23 = Math_fround(f25 * f19);
 f19 = Math_fround(f22 * f19);
 f4 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f15 * f4));
 f23 = Math_fround(f23 + Math_fround(f6 * f4));
 f4 = Math_fround(f19 + Math_fround(f20 * f4));
 f19 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f13 * f19));
 f23 = Math_fround(f23 + Math_fround(f7 * f19));
 f19 = Math_fround(f4 + Math_fround(f18 * f19));
 f4 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f17 * f4);
 f5 = Math_fround(f25 * f4);
 f4 = Math_fround(f22 * f4);
 f11 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f15 * f11));
 f5 = Math_fround(f5 + Math_fround(f6 * f11));
 f11 = Math_fround(f4 + Math_fround(f20 * f11));
 f4 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f4));
 f5 = Math_fround(f5 + Math_fround(f7 * f4));
 f4 = Math_fround(f11 + Math_fround(f18 * f4));
 f11 = Math_fround(Math_fround(Math_fround(f17 * f24) + Math_fround(f15 * f23)) + Math_fround(f13 * f5));
 f10 = Math_fround(Math_fround(Math_fround(f17 * f21) + Math_fround(f15 * f19)) + Math_fround(f13 * f4));
 f9 = Math_fround(Math_fround(Math_fround(f25 * f16) + Math_fround(f6 * f14)) + Math_fround(f7 * f12));
 f8 = Math_fround(Math_fround(Math_fround(f25 * f24) + Math_fround(f6 * f23)) + Math_fround(f7 * f5));
 f7 = Math_fround(Math_fround(Math_fround(f25 * f21) + Math_fround(f6 * f19)) + Math_fround(f7 * f4));
 f6 = Math_fround(Math_fround(Math_fround(f22 * f16) + Math_fround(f20 * f14)) + Math_fround(f18 * f12));
 f5 = Math_fround(Math_fround(Math_fround(f22 * f24) + Math_fround(f20 * f23)) + Math_fround(f18 * f5));
 f4 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f19)) + Math_fround(f18 * f4));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14)) + Math_fround(f13 * f12));
 HEAPF32[i1 + 4 >> 2] = f11;
 HEAPF32[i1 + 8 >> 2] = f10;
 HEAPF32[i1 + 12 >> 2] = f9;
 HEAPF32[i1 + 16 >> 2] = f8;
 HEAPF32[i1 + 20 >> 2] = f7;
 HEAPF32[i1 + 24 >> 2] = f6;
 HEAPF32[i1 + 28 >> 2] = f5;
 HEAPF32[i1 + 32 >> 2] = f4;
 return;
}

function __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i11, i4, i13, i10) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 L1 : do if (!(i10 & 2)) {
  i2 = HEAP32[i11 + 12 >> 2] | 0;
  i5 = HEAP32[i11 + 16 >> 2] | 0;
  if ((i2 | 0) < (i5 | 0)) {
   i7 = HEAP32[i11 + 32 >> 2] | 0;
   i8 = HEAP32[i4 >> 2] | 0;
   while (1) {
    if ((HEAP32[i7 + (i2 << 2) >> 2] | 0) == (i8 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i5 | 0)) {
     i12 = 7;
     break L1;
    }
   }
   if ((i2 | 0) < 0) i12 = 7; else {
    i5 = (HEAP32[i11 + 52 >> 2] | 0) + (i2 << 2) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i4 = i2 & 1048575;
    if (i10 & 1) {
     i2 = i2 | 1073741824;
     HEAP32[i5 >> 2] = i2;
    }
   }
  } else i12 = 7;
 } else i12 = 7; while (0);
 if ((i12 | 0) == 7) {
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i9, i11, i4, 1, 16, 0, i10 << 30 & 1073741824);
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i11 + 52 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) >> 2] | 0;
 }
 i8 = (HEAP32[i11 + 72 >> 2] | 0) + i4 | 0;
 if (!(i2 & 1073741824)) {
  i9 = HEAP32[i13 >> 2] | 0;
  i10 = HEAP32[i13 + 4 >> 2] | 0;
  i11 = HEAP32[i13 + 8 >> 2] | 0;
  i12 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = i10;
  i13 = i8 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i8 + 12 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i13 + 4 >> 2] | 0;
 i5 = HEAP32[i13 + 8 >> 2] | 0;
 i7 = HEAP32[i13 + 12 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) != 1) {
  i13 = i2;
  i10 = i4;
  i11 = i5;
  i12 = i7;
  HEAP32[i8 >> 2] = i13;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = i10;
  i13 = i8 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i8 + 12 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f6 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f3 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 f1 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = i7;
 HEAP32[i8 >> 2] = i13;
 i13 = i8 + 4 | 0;
 HEAP32[i13 >> 2] = i10;
 i13 = i8 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i8 + 12 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi155EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 155 ? 155 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN12ShaderErrors11ShaderErrorC2ERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_S9_iibb(i7, i1, i4, i5, i8, i9, i10, i11) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i14 = i3 << 24 >> 24 < 0;
 i2 = i14 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = i14 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i12 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i7 + 11 >> 0] = i3;
  if (!i3) i1 = i7; else {
   i1 = i7;
   i12 = 6;
  }
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i14 = i3 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i14 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i3;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i14 = i2 << 24 >> 24 < 0;
 i3 = i14 ? HEAP32[i4 >> 2] | 0 : i4;
 i4 = i14 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i7 + 28 >> 2] | 0;
  i12 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i12 = 12;
 } else i12 = 10;
 if ((i12 | 0) == 10) {
  i15 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i14;
  HEAP32[i7 + 24 >> 2] = i15 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i4;
  i1 = i14;
  i12 = 12;
 }
 if ((i12 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i7 + 32 | 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i3 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 44 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i7 + 44 >> 2] | 0;
  i12 = 16;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i15 = i1;
   i15 = i15 + i3 | 0;
   HEAP8[i15 >> 0] = 0;
   i15 = i7 + 48 | 0;
   HEAP32[i15 >> 2] = i8;
   i15 = i7 + 52 | 0;
   HEAP32[i15 >> 2] = i9;
   i15 = i7 + 56 | 0;
   i14 = i10 & 1;
   HEAP8[i15 >> 0] = i14;
   i15 = i7 + 57 | 0;
   i14 = i11 & 1;
   HEAP8[i15 >> 0] = i14;
   STACKTOP = i13;
   return;
  }
 } else i12 = 16;
 if ((i12 | 0) == 16) {
  i14 = i3 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i15;
  HEAP32[i7 + 40 >> 2] = i14 | -2147483648;
  HEAP32[i7 + 36 >> 2] = i3;
  i1 = i15;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 i15 = i1;
 i15 = i15 + i3 | 0;
 HEAP8[i15 >> 0] = 0;
 i15 = i7 + 48 | 0;
 HEAP32[i15 >> 2] = i8;
 i15 = i7 + 52 | 0;
 HEAP32[i15 >> 2] = i9;
 i15 = i7 + 56 | 0;
 i14 = i10 & 1;
 HEAP8[i15 >> 0] = i14;
 i15 = i7 + 57 | 0;
 i14 = i11 & 1;
 HEAP8[i15 >> 0] = i14;
 STACKTOP = i13;
 return;
}

function runPostSets11() {
 HEAP32[gb + 32512 >> 2] = fb + 118;
 HEAP32[gb + 32516 >> 2] = fb + 119;
 HEAP32[gb + 32520 >> 2] = fb + 120;
 HEAP32[gb + 32524 >> 2] = fb + 121;
 HEAP32[gb + 32528 >> 2] = fb + 122;
 HEAP32[gb + 32532 >> 2] = fb + 36;
 HEAP32[gb + 32536 >> 2] = fb + 96;
 HEAP32[gb + 32540 >> 2] = fb + 81;
 HEAP32[gb + 32544 >> 2] = fb + 82;
 HEAP32[gb + 32556 >> 2] = (HEAP32[gb + 32556 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32560 >> 2] = (HEAP32[gb + 32560 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32596 >> 2] = (HEAP32[gb + 32596 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32600 >> 2] = (HEAP32[gb + 32600 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32636 >> 2] = (HEAP32[gb + 32636 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 32640 >> 2] = (HEAP32[gb + 32640 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 32676 >> 2] = fb + 100;
 HEAP32[gb + 32680 >> 2] = fb + 101;
 HEAP32[gb + 32684 >> 2] = fb + 20;
 HEAP32[gb + 32688 >> 2] = fb + 102;
 HEAP32[gb + 32692 >> 2] = fb + 103;
 HEAP32[gb + 32696 >> 2] = fb + 104;
 HEAP32[gb + 32700 >> 2] = fb + 1;
 HEAP32[gb + 32704 >> 2] = fb + 1;
 HEAP32[gb + 32708 >> 2] = fb + 1;
 HEAP32[gb + 32712 >> 2] = fb + 52;
 HEAP32[gb + 32716 >> 2] = fb + 110;
 HEAP32[gb + 32720 >> 2] = fb + 105;
 HEAP32[gb + 32724 >> 2] = fb + 1;
 HEAP32[gb + 32736 >> 2] = fb + 106;
 HEAP32[gb + 32740 >> 2] = fb + 107;
 HEAP32[gb + 32744 >> 2] = fb + 108;
 HEAP32[gb + 32748 >> 2] = fb + 123;
 HEAP32[gb + 32752 >> 2] = fb + 16;
 HEAP32[gb + 32756 >> 2] = fb + 109;
 HEAP32[gb + 32760 >> 2] = fb + 110;
 HEAP32[gb + 32764 >> 2] = fb + 19;
 HEAP32[gb + 32768 >> 2] = fb + 111;
 HEAP32[gb + 32772 >> 2] = fb + 103;
 HEAP32[gb + 32776 >> 2] = fb + 101;
 HEAP32[gb + 32780 >> 2] = fb + 62;
 HEAP32[gb + 32784 >> 2] = fb + 28;
 HEAP32[gb + 32788 >> 2] = fb + 63;
 HEAP32[gb + 32792 >> 2] = fb + 29;
 HEAP32[gb + 32796 >> 2] = fb + 34;
 HEAP32[gb + 32800 >> 2] = fb + 124;
 HEAP32[gb + 32804 >> 2] = fb + 125;
 HEAP32[gb + 32808 >> 2] = fb + 126;
 HEAP32[gb + 32812 >> 2] = fb + 127;
 HEAP32[gb + 32816 >> 2] = fb + 128;
 HEAP32[gb + 32820 >> 2] = fb + 129;
 HEAP32[gb + 32824 >> 2] = fb + 36;
 HEAP32[gb + 32828 >> 2] = fb + 104;
 HEAP32[gb + 32832 >> 2] = fb + 108;
 HEAP32[gb + 32836 >> 2] = fb + 94;
 HEAP32[gb + 32840 >> 2] = fb + 130;
 HEAP32[gb + 32844 >> 2] = fb + 112;
 HEAP32[gb + 32848 >> 2] = fb + 113;
 HEAP32[gb + 32852 >> 2] = fb + 131;
 HEAP32[gb + 32856 >> 2] = fb + 111;
 HEAP32[gb + 32860 >> 2] = fb + 112;
 HEAP32[gb + 32864 >> 2] = fb + 113;
 HEAP32[gb + 32868 >> 2] = fb + 114;
 HEAP32[gb + 32872 >> 2] = fb + 115;
 HEAP32[gb + 32884 >> 2] = fb + 116;
 HEAP32[gb + 32888 >> 2] = fb + 117;
 HEAP32[gb + 32892 >> 2] = fb + 38;
 HEAP32[gb + 32896 >> 2] = fb + 39;
 HEAP32[gb + 32900 >> 2] = fb + 16;
 HEAP32[gb + 32904 >> 2] = fb + 39;
 HEAP32[gb + 32908 >> 2] = fb + 118;
 HEAP32[gb + 32912 >> 2] = fb + 19;
 HEAP32[gb + 32916 >> 2] = fb + 114;
 HEAP32[gb + 32920 >> 2] = fb + 31;
 HEAP32[gb + 32924 >> 2] = fb + 27;
 HEAP32[gb + 32928 >> 2] = fb + 62;
 HEAP32[gb + 32932 >> 2] = fb + 28;
 HEAP32[gb + 32936 >> 2] = fb + 63;
 HEAP32[gb + 32940 >> 2] = fb + 29;
 HEAP32[gb + 32944 >> 2] = fb + 34;
 HEAP32[gb + 32948 >> 2] = fb + 132;
 HEAP32[gb + 32952 >> 2] = fb + 133;
 HEAP32[gb + 32956 >> 2] = fb + 134;
 HEAP32[gb + 32960 >> 2] = fb + 135;
 HEAP32[gb + 32964 >> 2] = fb + 136;
 HEAP32[gb + 32968 >> 2] = fb + 137;
 HEAP32[gb + 32972 >> 2] = fb + 36;
 HEAP32[gb + 32984 >> 2] = fb + 119;
 HEAP32[gb + 32988 >> 2] = fb + 120;
 HEAP32[gb + 32992 >> 2] = fb + 38;
 HEAP32[gb + 32996 >> 2] = fb + 138;
 HEAP32[gb + 33e3 >> 2] = fb + 16;
 HEAP32[gb + 33004 >> 2] = fb + 93;
 HEAP32[gb + 33008 >> 2] = fb + 121;
 HEAP32[gb + 33012 >> 2] = fb + 19;
 HEAP32[gb + 33016 >> 2] = fb + 115;
 HEAP32[gb + 33020 >> 2] = fb + 103;
 HEAP32[gb + 33024 >> 2] = fb + 101;
 HEAP32[gb + 33028 >> 2] = fb + 62;
 HEAP32[gb + 33032 >> 2] = fb + 28;
 HEAP32[gb + 33036 >> 2] = fb + 63;
 runPostSets12();
}

function runPostSets177() {
 HEAP32[gb + 153100 >> 2] = fb + 1583;
 HEAP32[gb + 153104 >> 2] = fb + 36;
 HEAP32[gb + 153108 >> 2] = fb + 104;
 HEAP32[gb + 153112 >> 2] = fb + 108;
 HEAP32[gb + 153116 >> 2] = fb + 94;
 HEAP32[gb + 153120 >> 2] = fb + 1574;
 HEAP32[gb + 153124 >> 2] = fb + 112;
 HEAP32[gb + 153128 >> 2] = fb + 113;
 HEAP32[gb + 153132 >> 2] = fb + 131;
 HEAP32[gb + 153136 >> 2] = fb + 111;
 HEAP32[gb + 153140 >> 2] = fb + 112;
 HEAP32[gb + 153144 >> 2] = fb + 113;
 HEAP32[gb + 153148 >> 2] = fb + 2317;
 HEAP32[gb + 153152 >> 2] = fb + 2318;
 HEAP32[gb + 153156 >> 2] = fb + 1;
 HEAP32[gb + 153160 >> 2] = fb + 1575;
 HEAP32[gb + 153164 >> 2] = fb + 1059;
 HEAP32[gb + 153168 >> 2] = fb + 1060;
 HEAP32[gb + 153180 >> 2] = fb + 2323;
 HEAP32[gb + 153184 >> 2] = fb + 2324;
 HEAP32[gb + 153188 >> 2] = fb + 2325;
 HEAP32[gb + 153192 >> 2] = fb + 1584;
 HEAP32[gb + 153196 >> 2] = fb + 16;
 HEAP32[gb + 153200 >> 2] = fb + 2326;
 HEAP32[gb + 153204 >> 2] = fb + 2327;
 HEAP32[gb + 153208 >> 2] = fb + 19;
 HEAP32[gb + 153212 >> 2] = fb + 1062;
 HEAP32[gb + 153216 >> 2] = fb + 103;
 HEAP32[gb + 153220 >> 2] = fb + 101;
 HEAP32[gb + 153224 >> 2] = fb + 62;
 HEAP32[gb + 153228 >> 2] = fb + 28;
 HEAP32[gb + 153232 >> 2] = fb + 63;
 HEAP32[gb + 153236 >> 2] = fb + 29;
 HEAP32[gb + 153240 >> 2] = fb + 34;
 HEAP32[gb + 153244 >> 2] = fb + 1585;
 HEAP32[gb + 153248 >> 2] = fb + 1586;
 HEAP32[gb + 153252 >> 2] = fb + 1587;
 HEAP32[gb + 153256 >> 2] = fb + 1588;
 HEAP32[gb + 153260 >> 2] = fb + 1589;
 HEAP32[gb + 153264 >> 2] = fb + 1590;
 HEAP32[gb + 153268 >> 2] = fb + 36;
 HEAP32[gb + 153272 >> 2] = fb + 104;
 HEAP32[gb + 153276 >> 2] = fb + 108;
 HEAP32[gb + 153280 >> 2] = fb + 94;
 HEAP32[gb + 153284 >> 2] = fb + 130;
 HEAP32[gb + 153288 >> 2] = fb + 112;
 HEAP32[gb + 153292 >> 2] = fb + 113;
 HEAP32[gb + 153296 >> 2] = fb + 131;
 HEAP32[gb + 153300 >> 2] = fb + 111;
 HEAP32[gb + 153304 >> 2] = fb + 112;
 HEAP32[gb + 153308 >> 2] = fb + 113;
 HEAP32[gb + 153312 >> 2] = fb + 2328;
 HEAP32[gb + 153316 >> 2] = fb + 2329;
 HEAP32[gb + 153320 >> 2] = fb + 1591;
 HEAP32[gb + 153324 >> 2] = fb + 1592;
 HEAP32[gb + 153328 >> 2] = fb + 119;
 HEAP32[gb + 153332 >> 2] = fb + 1063;
 HEAP32[gb + 153336 >> 2] = fb + 1064;
 HEAP32[gb + 153340 >> 2] = fb + 1065;
 HEAP32[gb + 153344 >> 2] = fb + 1066;
 HEAP32[gb + 153348 >> 2] = fb + 1067;
 HEAP32[gb + 153352 >> 2] = fb + 2330;
 HEAP32[gb + 153364 >> 2] = (HEAP32[gb + 153364 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 153368 >> 2] = (HEAP32[gb + 153368 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 153404 >> 2] = fb + 2331;
 HEAP32[gb + 153408 >> 2] = fb + 2332;
 HEAP32[gb + 153412 >> 2] = fb + 2325;
 HEAP32[gb + 153416 >> 2] = fb + 1584;
 HEAP32[gb + 153420 >> 2] = fb + 16;
 HEAP32[gb + 153424 >> 2] = fb + 93;
 HEAP32[gb + 153428 >> 2] = fb + 2333;
 HEAP32[gb + 153432 >> 2] = fb + 19;
 HEAP32[gb + 153436 >> 2] = fb + 1068;
 HEAP32[gb + 153440 >> 2] = fb + 103;
 HEAP32[gb + 153444 >> 2] = fb + 101;
 HEAP32[gb + 153448 >> 2] = fb + 62;
 HEAP32[gb + 153452 >> 2] = fb + 28;
 HEAP32[gb + 153456 >> 2] = fb + 63;
 HEAP32[gb + 153460 >> 2] = fb + 29;
 HEAP32[gb + 153464 >> 2] = fb + 34;
 HEAP32[gb + 153468 >> 2] = fb + 1593;
 HEAP32[gb + 153472 >> 2] = fb + 1594;
 HEAP32[gb + 153476 >> 2] = fb + 1595;
 HEAP32[gb + 153480 >> 2] = fb + 1596;
 HEAP32[gb + 153484 >> 2] = fb + 1597;
 HEAP32[gb + 153488 >> 2] = fb + 1598;
 HEAP32[gb + 153492 >> 2] = fb + 36;
 HEAP32[gb + 153496 >> 2] = fb + 104;
 HEAP32[gb + 153500 >> 2] = fb + 108;
 HEAP32[gb + 153504 >> 2] = fb + 94;
 HEAP32[gb + 153508 >> 2] = fb + 130;
 HEAP32[gb + 153512 >> 2] = fb + 112;
 HEAP32[gb + 153516 >> 2] = fb + 113;
 HEAP32[gb + 153520 >> 2] = fb + 131;
 HEAP32[gb + 153524 >> 2] = fb + 111;
 HEAP32[gb + 153528 >> 2] = fb + 112;
 HEAP32[gb + 153532 >> 2] = fb + 113;
 HEAP32[gb + 153536 >> 2] = fb + 2328;
 HEAP32[gb + 153540 >> 2] = fb + 2329;
 HEAP32[gb + 153544 >> 2] = fb + 1;
 runPostSets178();
}

function runPostSets166() {
 HEAP32[gb + 146816 >> 2] = fb + 1951;
 HEAP32[gb + 146820 >> 2] = fb + 1952;
 HEAP32[gb + 146832 >> 2] = fb + 1953;
 HEAP32[gb + 146836 >> 2] = fb + 1954;
 HEAP32[gb + 146840 >> 2] = fb + 112;
 HEAP32[gb + 146844 >> 2] = (HEAP32[gb + 146844 >> 2] | 0) + (gb + 110608 | 0);
 HEAP32[gb + 146852 >> 2] = fb + 1389;
 HEAP32[gb + 146856 >> 2] = fb + 1390;
 HEAP32[gb + 146868 >> 2] = fb + 1391;
 HEAP32[gb + 146872 >> 2] = fb + 1389;
 HEAP32[gb + 146880 >> 2] = fb + 1392;
 HEAP32[gb + 146884 >> 2] = fb + 1390;
 HEAP32[gb + 146896 >> 2] = fb + 1393;
 HEAP32[gb + 146900 >> 2] = fb + 1392;
 HEAP32[gb + 146916 >> 2] = fb + 1145;
 HEAP32[gb + 146920 >> 2] = fb + 1146;
 HEAP32[gb + 146936 >> 2] = fb + 995;
 HEAP32[gb + 146940 >> 2] = fb + 1955;
 HEAP32[gb + 146944 >> 2] = fb + 382;
 HEAP32[gb + 146948 >> 2] = fb + 113;
 HEAP32[gb + 146952 >> 2] = fb + 54;
 HEAP32[gb + 146964 >> 2] = fb + 995;
 HEAP32[gb + 146968 >> 2] = fb + 1956;
 HEAP32[gb + 146972 >> 2] = fb + 383;
 HEAP32[gb + 146976 >> 2] = fb + 114;
 HEAP32[gb + 146980 >> 2] = fb + 55;
 HEAP32[gb + 146992 >> 2] = fb + 986;
 HEAP32[gb + 146996 >> 2] = fb + 1957;
 HEAP32[gb + 147e3 >> 2] = fb + 219;
 HEAP32[gb + 147012 >> 2] = fb + 995;
 HEAP32[gb + 147016 >> 2] = fb + 1958;
 HEAP32[gb + 147020 >> 2] = fb + 384;
 HEAP32[gb + 147024 >> 2] = fb + 115;
 HEAP32[gb + 147028 >> 2] = fb + 56;
 HEAP32[gb + 147040 >> 2] = fb + 986;
 HEAP32[gb + 147044 >> 2] = fb + 1959;
 HEAP32[gb + 147048 >> 2] = fb + 220;
 HEAP32[gb + 147060 >> 2] = fb + 986;
 HEAP32[gb + 147064 >> 2] = fb + 1960;
 HEAP32[gb + 147068 >> 2] = fb + 221;
 HEAP32[gb + 147176 >> 2] = fb + 1125;
 HEAP32[gb + 147180 >> 2] = fb + 1961;
 HEAP32[gb + 147184 >> 2] = fb + 1258;
 HEAP32[gb + 147188 >> 2] = fb + 986;
 HEAP32[gb + 147192 >> 2] = fb + 1127;
 HEAP32[gb + 147196 >> 2] = fb + 1128;
 HEAP32[gb + 147200 >> 2] = fb + 469;
 HEAP32[gb + 147204 >> 2] = fb + 1129;
 HEAP32[gb + 147208 >> 2] = fb + 1962;
 HEAP32[gb + 147220 >> 2] = fb + 1125;
 HEAP32[gb + 147224 >> 2] = fb + 1963;
 HEAP32[gb + 147228 >> 2] = fb + 1258;
 HEAP32[gb + 147232 >> 2] = fb + 987;
 HEAP32[gb + 147236 >> 2] = fb + 1127;
 HEAP32[gb + 147240 >> 2] = fb + 1128;
 HEAP32[gb + 147244 >> 2] = fb + 469;
 HEAP32[gb + 147248 >> 2] = fb + 1129;
 HEAP32[gb + 147252 >> 2] = fb + 1964;
 HEAP32[gb + 147264 >> 2] = fb + 1125;
 HEAP32[gb + 147268 >> 2] = fb + 1965;
 HEAP32[gb + 147272 >> 2] = fb + 1258;
 HEAP32[gb + 147276 >> 2] = fb + 988;
 HEAP32[gb + 147280 >> 2] = fb + 1127;
 HEAP32[gb + 147284 >> 2] = fb + 1128;
 HEAP32[gb + 147288 >> 2] = fb + 469;
 HEAP32[gb + 147292 >> 2] = fb + 1129;
 HEAP32[gb + 147296 >> 2] = fb + 1966;
 HEAP32[gb + 147308 >> 2] = fb + 1125;
 HEAP32[gb + 147312 >> 2] = fb + 1967;
 HEAP32[gb + 147316 >> 2] = fb + 1258;
 HEAP32[gb + 147320 >> 2] = fb + 989;
 HEAP32[gb + 147324 >> 2] = fb + 1127;
 HEAP32[gb + 147328 >> 2] = fb + 1128;
 HEAP32[gb + 147332 >> 2] = fb + 469;
 HEAP32[gb + 147336 >> 2] = fb + 1129;
 HEAP32[gb + 147340 >> 2] = fb + 1968;
 HEAP32[gb + 147352 >> 2] = fb + 1125;
 HEAP32[gb + 147356 >> 2] = fb + 1969;
 HEAP32[gb + 147360 >> 2] = fb + 1258;
 HEAP32[gb + 147364 >> 2] = fb + 990;
 HEAP32[gb + 147368 >> 2] = fb + 1127;
 HEAP32[gb + 147372 >> 2] = fb + 1128;
 HEAP32[gb + 147376 >> 2] = fb + 469;
 HEAP32[gb + 147380 >> 2] = fb + 1129;
 HEAP32[gb + 147384 >> 2] = fb + 1970;
 HEAP32[gb + 147396 >> 2] = fb + 1125;
 HEAP32[gb + 147400 >> 2] = fb + 1971;
 HEAP32[gb + 147404 >> 2] = fb + 1258;
 HEAP32[gb + 147408 >> 2] = fb + 991;
 HEAP32[gb + 147412 >> 2] = fb + 1127;
 HEAP32[gb + 147416 >> 2] = fb + 1128;
 HEAP32[gb + 147420 >> 2] = fb + 469;
 HEAP32[gb + 147424 >> 2] = fb + 1129;
 HEAP32[gb + 147428 >> 2] = fb + 1972;
 HEAP32[gb + 147440 >> 2] = fb + 1125;
 HEAP32[gb + 147444 >> 2] = fb + 1973;
 HEAP32[gb + 147448 >> 2] = fb + 1258;
 HEAP32[gb + 147452 >> 2] = fb + 992;
 HEAP32[gb + 147456 >> 2] = fb + 1127;
 HEAP32[gb + 147460 >> 2] = fb + 1128;
 runPostSets167();
}

function __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i18, i19, i6) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0;
 i20 = HEAP32[i19 + 224 >> 2] | 0;
 L1 : do if (!i20) i1 = 0; else {
  f4 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  i1 = 0;
  do {
   f17 = Math_fround(HEAPF32[i19 + 192 + (i1 << 2) >> 2]);
   if (!(f4 > f17 & f5 > f17 & f2 > f17 & f3 > f17)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i20 >>> 0);
 } while (0);
 i14 = i18 + 12 | 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i15 = i18 + 8 | 0;
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i16 = i18 + 4 | 0;
 HEAPF32[i16 >> 2] = Math_fround(1.0);
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 if (i1 >>> 0 >= i20 >>> 0) return;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 i7 = 0;
 i8 = 0;
 i9 = 0;
 i6 = 0;
 i10 = 1065353216;
 i11 = 1065353216;
 i12 = 1065353216;
 i13 = 1065353216;
 while (1) {
  if ((i9 & i7 & i6 & i8 | 0) <= -1) {
   i1 = 11;
   break;
  }
  if (!i1) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i19 + 192 + (i1 + -1 << 2) >> 2]);
  f34 = Math_fround(f4 - f2);
  f32 = Math_fround(f5 - f2);
  f30 = Math_fround(f17 - f2);
  f28 = Math_fround(f3 - f2);
  f27 = Math_fround(HEAPF32[i19 + 160 + (i1 << 2) >> 2]);
  f29 = Math_fround(HEAPF32[i19 + 128 + (i1 << 2) >> 2]);
  f35 = Math_fround(f27 + Math_fround(f34 * f29));
  f33 = Math_fround(f27 + Math_fround(f32 * f29));
  f31 = Math_fround(f27 + Math_fround(f30 * f29));
  f29 = Math_fround(f27 + Math_fround(f28 * f29));
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) >> 2]);
  f26 = Math_fround(f34 * f27);
  f25 = Math_fround(f32 * f27);
  f24 = Math_fround(f30 * f27);
  f27 = Math_fround(f28 * f27);
  f2 = Math_fround(HEAPF32[i19 + (i1 << 4) + 4 >> 2]);
  f26 = Math_fround(f34 * Math_fround(f26 + f2));
  f25 = Math_fround(f32 * Math_fround(f25 + f2));
  f24 = Math_fround(f30 * Math_fround(f24 + f2));
  f2 = Math_fround(f28 * Math_fround(f27 + f2));
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) + 8 >> 2]);
  f26 = Math_fround(f34 * Math_fround(f27 + f26));
  f25 = Math_fround(f32 * Math_fround(f27 + f25));
  f24 = Math_fround(f30 * Math_fround(f27 + f24));
  f2 = Math_fround(f28 * Math_fround(f27 + f2));
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) + 12 >> 2]);
  f26 = Math_fround(f35 + Math_fround(f34 * Math_fround(f34 * Math_fround(f27 + f26))));
  f25 = Math_fround(f33 + Math_fround(f32 * Math_fround(f32 * Math_fround(f27 + f25))));
  f24 = Math_fround(f31 + Math_fround(f30 * Math_fround(f30 * Math_fround(f27 + f24))));
  f2 = Math_fround(f29 + Math_fround(f28 * Math_fround(f28 * Math_fround(f27 + f2))));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i10 = i23 & ~i7 | i10 & i7;
  i11 = i22 & ~i9 | i11 & i9;
  i12 = i21 & ~i6 | i12 & i6;
  i13 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & ~i8 | i13 & i8;
  HEAP32[i18 >> 2] = i10;
  HEAP32[i16 >> 2] = i11;
  HEAP32[i15 >> 2] = i12;
  HEAP32[i14 >> 2] = i13;
  f2 = Math_fround(HEAPF32[i19 + 192 + (i1 << 2) >> 2]);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i20 >>> 0) {
   i1 = 11;
   break;
  } else {
   i7 = (f4 <= f2) << 31 >> 31;
   i8 = (f3 <= f2) << 31 >> 31;
   i9 = (f5 <= f2) << 31 >> 31;
   i6 = (f17 <= f2) << 31 >> 31;
  }
 }
 if ((i1 | 0) == 11) return;
}

function __ZN5physx2Sc10NPhaseCore19findTriggerContactsEPNS0_18TriggerInteractionEbb(i11, i5, i1, i2) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 68 | 0;
 i4 = i14 + 40 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i6 = HEAP32[i5 + 32 >> 2] | 0;
 i7 = HEAP32[i5 + 36 >> 2] | 0;
 i8 = HEAP16[i5 + 56 >> 1] | 0;
 if (i1) {
  i9 = i2 ? 4 : 0;
  i10 = 0;
 } else {
  i9 = i6 + 28 | 0;
  i16 = i7 + 28 | 0;
  i15 = (HEAP32[(HEAP32[i11 >> 2] | 0) + 1184 >> 2] | 0) + 48 + ((HEAP32[(HEAP32[i9 >> 2] | 0) + 68 >> 2] | 0) * 28 | 0) + (HEAP32[(HEAP32[i16 >> 2] | 0) + 68 >> 2] << 2) | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  i15 = i6;
  i2 = i7;
  i16 = (HEAP32[(HEAP32[i9 >> 2] | 0) + 68 >> 2] | 0) > (HEAP32[(HEAP32[i16 >> 2] | 0) + 68 >> 2] | 0);
  i9 = i16 ? i15 : i2;
  i10 = i9 + 28 | 0;
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0;
  i15 = i16 ? i2 : i15;
  i2 = i15 + 28 | 0;
  i16 = HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0;
  i1 = HEAP32[(__ZN5physx2Gu25GetGeomOverlapMethodTableEv() | 0) + (i16 * 28 | 0) + (i1 << 2) >> 2] | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + 68 | 0;
  __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i3, i15);
  i10 = (HEAP32[i10 >> 2] | 0) + 68 | 0;
  __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i4, i9);
  i9 = 0;
  i10 = mftCall_iiiiii(i1 | 0, i2 | 0, i3 | 0, i10 | 0, i4 | 0, i5 + 40 | 0) | 0;
 }
 i4 = i5 + 58 | 0;
 i1 = HEAP8[i4 >> 0] | 0 ? (i10 ? 0 : 16) : i10 ? 4 : 0;
 if (!((i1 & i8) << 16 >> 16)) {
  i16 = i10 & 1;
  HEAP8[i4 >> 0] = i16;
  STACKTOP = i14;
  return;
 }
 HEAP32[i12 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i6 + 28 >> 2] | 0) | 0;
 HEAP32[i12 + 8 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i7 + 28 >> 2] | 0) | 0;
 HEAP32[i12 + 16 >> 2] = i1 & 65535;
 HEAP8[i12 + 20 >> 0] = i9;
 i2 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i6) | 0) + 52 >> 2] | 0;
 i16 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i7) | 0) + 52 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = __ZNK5physx2Sc9RigidCore10getPxActorEv(i2) | 0;
 HEAP32[i12 + 12 >> 2] = __ZNK5physx2Sc9RigidCore10getPxActorEv(i16) | 0;
 i15 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP8[i2 + 13 >> 0] | 0;
 i3 = HEAP8[i16 + 13 >> 0] | 0;
 i2 = HEAP8[i2 + 11 >> 0] | 0;
 i16 = HEAP8[i16 + 11 >> 0] | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP8[i13 + 8 >> 0] = i1;
 HEAP8[i13 + 9 >> 0] = i3;
 HEAP8[i13 + 10 >> 0] = i2;
 HEAP8[i13 + 11 >> 0] = i16;
 i16 = HEAP32[i11 >> 2] | 0;
 i2 = i16 + 100 | 0;
 i3 = i16 + 104 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i16 + 108 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i16 = HEAP32[i2 >> 2] | 0;
  i15 = i16 + (i1 * 24 | 0) | 0;
  HEAP32[i15 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP8[i16 + (i1 * 24 | 0) + 20 >> 0] = i9;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i2, i12) | 0;
 i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + 112 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i16 = (HEAP32[i1 >> 2] | 0) + (i3 * 12 | 0) | 0;
  HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i16 = i10 & 1;
  HEAP8[i4 >> 0] = i16;
  STACKTOP = i14;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i13) | 0;
  i16 = i10 & 1;
  HEAP8[i4 >> 0] = i16;
  STACKTOP = i14;
  return;
 }
}

function __ZN21RotationBySpeedModule5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i29;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAPF32[i2 + 804 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 808 >> 2] = Math_fround(1.0);
 HEAP8[i2 + 800 >> 0] = 0;
 i25 = i3 + 4 | 0;
 i26 = i3 + 8 | 0;
 i27 = i3 + 12 | 0;
 i28 = i3 + 16 | 0;
 i4 = i3 + 20 | 0;
 i5 = i3 + 24 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3 + 32 | 0;
 i8 = i3 + 40 | 0;
 i9 = i3 + 44 | 0;
 i10 = i3 + 48 | 0;
 i11 = i3 + 52 | 0;
 i12 = i3 + 56 | 0;
 i13 = i3 + 60 | 0;
 i14 = i3 + 64 | 0;
 i15 = i3 + 68 | 0;
 i16 = i3 + 72 | 0;
 i17 = i3 + 80 | 0;
 i18 = i3 + 88 | 0;
 i19 = i3 + 232 | 0;
 i20 = i3 + 248 | 0;
 i21 = i3 + 236 | 0;
 i22 = i3 + 144 | 0;
 i23 = i3 + 160 | 0;
 i24 = i3 + 148 | 0;
 i1 = 0;
 do {
  __ZN11MinMaxCurveC2Ev(i3);
  i30 = HEAP32[i25 >> 2] | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  i32 = HEAP32[i27 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 4 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 8 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 12 >> 2] = i32;
  i32 = HEAP32[i4 >> 2] | 0;
  i31 = HEAP32[i5 >> 2] | 0;
  i30 = HEAP32[i6 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 20 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 24 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 28 >> 2] = i30;
  i30 = i7;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i32 = i2 + 8 + (i1 * 264 | 0) + 32 | 0;
  HEAP32[i32 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i32 + 4 >> 2] = i31;
  i32 = HEAP32[i9 >> 2] | 0;
  i31 = HEAP32[i10 >> 2] | 0;
  i30 = HEAP32[i11 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 40 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 44 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 48 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 52 >> 2] = i30;
  i30 = HEAP32[i13 >> 2] | 0;
  i31 = HEAP32[i14 >> 2] | 0;
  i32 = HEAP32[i15 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 56 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 60 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 64 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 68 >> 2] = i32;
  i32 = i16;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  i30 = i2 + 8 + (i1 * 264 | 0) + 72 | 0;
  HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  i30 = i2 + 8 + (i1 * 264 | 0) + 80 | 0;
  HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
  HEAP16[i30 + 4 >> 1] = HEAP16[i17 + 4 >> 1] | 0;
  HEAP8[i30 + 6 >> 0] = HEAP8[i17 + 6 >> 0] | 0;
  __ZN21MinMaxAnimationCurvesaSERKS_(i2 + 8 + (i1 * 264 | 0) + 88 | 0, i18) | 0;
  if ((HEAP32[i20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
   HEAP32[i19 >> 2] = 0;
  }
  if ((HEAP32[i23 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i24);
   HEAP32[i22 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 HEAPF32[i2 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 8 | 0, i2 + 96 | 0, Math_fround(0.0), HEAP16[i2 + 92 >> 1] | 0) | 0) & 1;
 HEAPF32[i2 + 352 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 272 | 0, i2 + 360 | 0, Math_fround(0.0), HEAP16[i2 + 356 >> 1] | 0) | 0) & 1;
 HEAPF32[i2 + 616 >> 2] = Math_fround(.785398185);
 HEAP8[i2 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 536 | 0, i2 + 624 | 0, Math_fround(.785398185), HEAP16[i2 + 620 >> 1] | 0) | 0) & 1;
 STACKTOP = i29;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi24EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 24 ? 24 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi15EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 15 ? 15 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi52EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 52 ? 52 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi24EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 24 ? 24 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi20EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 20 ? 20 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i12, i8, i13) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = i13 - i8 >> 4;
 i6 = i12 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2;
 if (i15 >>> 0 > i1 - i2 >> 4 >>> 0) {
  if (i2) {
   i5 = i12 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    i3 = i14 + 4 | 0;
    i2 = i1;
    while (1) {
     i1 = i2 + -16 | 0;
     HEAP32[i5 >> 2] = i1;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i11 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i14 >> 2] = 66;
      HEAP32[i3 >> 2] = i11;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
      i1 = HEAP32[i5 >> 2] | 0;
     }
     if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
    }
    i1 = HEAP32[i12 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   i1 = 0;
  }
  if (i15 >>> 0 > 268435455) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
  } else i2 = 0;
  i14 = i1 - i2 | 0;
  i1 = i14 >> 3;
  i1 = i14 >> 4 >>> 0 < 134217727 ? (i1 >>> 0 < i15 >>> 0 ? i15 : i1) : 268435455;
  if (i1 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i14 = __Znwj(i1 << 4) | 0;
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 >> 2] = i14;
  HEAP32[i6 >> 2] = i14 + (i1 << 4);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i12, i8, i13, i15);
  STACKTOP = i16;
  return;
 }
 i11 = i12 + 4 | 0;
 i9 = (HEAP32[i11 >> 2] | 0) - i2 >> 4;
 i10 = i15 >>> 0 > i9 >>> 0;
 i9 = i10 ? i8 + (i9 << 4) | 0 : i13;
 if ((i9 | 0) != (i8 | 0)) {
  i1 = i4;
  do {
   do if ((i1 | 0) != (i8 | 0)) {
    i7 = HEAP8[i8 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
    i4 = i1 + 11 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 << 24 >> 24 < 0;
    if (i3) i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
    if (i7 >>> 0 > i5 >>> 0) {
     if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
     break;
    }
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if (i7 | 0) _memmove(i2 | 0, i6 | 0, i7 | 0) | 0;
    HEAP8[i2 + i7 >> 0] = 0;
    if ((HEAP8[i4 >> 0] | 0) < 0) {
     HEAP32[i1 + 4 >> 2] = i7;
     break;
    } else {
     HEAP8[i4 >> 0] = i7;
     break;
    }
   } while (0);
   i8 = i8 + 16 | 0;
   i1 = i1 + 16 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i4 = i1;
 }
 if (i10) {
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i12, i9, i13, i15 - ((HEAP32[i11 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) >> 4) | 0);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 do {
  i2 = i1 + -16 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i15 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i3 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i14);
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue20GetEventsAsJsonArrayEjR8UnityStrPj(i10, i1, i12, i13) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 136 | 0;
 i15 = i18;
 i16 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = gb + 77468 + 12;
 i17 = i15 + 56 | 0;
 HEAP32[i17 >> 2] = gb + 77468 + 32;
 __ZNSt3__28ios_base4initEPv(i15 + 56 | 0, i16);
 HEAP32[i15 + 128 >> 2] = 0;
 HEAP32[i15 + 132 >> 2] = -1;
 HEAP32[i15 >> 2] = gb + 77508 + 12;
 HEAP32[i15 + 56 >> 2] = gb + 77508 + 32;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i16);
 HEAP32[i16 >> 2] = gb + 77548 + 8;
 i11 = i15 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i15 + 52 >> 2] = 16;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i16, i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i15, gb + 1073935 | 0, 1) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i9 = (HEAP32[i10 + 4 >> 2] | 0) - i2 >> 2;
 i9 = i9 >>> 0 < i1 >>> 0 ? i9 : i1;
 L1 : do if (!i9) {
  i8 = 0;
  i4 = 0;
 } else {
  i6 = 0;
  i8 = 0;
  i7 = 0;
  i4 = 0;
  i1 = i2;
  while (1) {
   i5 = HEAP32[i1 + (i7 << 2) >> 2] | 0;
   i2 = i5 + 11 | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) i3 = HEAP32[i5 + 4 >> 2] | 0; else i3 = i1 & 255;
   if (!i3) i2 = i6; else {
    if (i6) {
     __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i15, gb + 1087585 | 0, 1) | 0;
     i1 = HEAP8[i2 >> 0] | 0;
    }
    if (i1 << 24 >> 24 < 0) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
    __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i15, i1, _strlen(i1) | 0) | 0;
    i2 = 1;
    i8 = i8 + 1 | 0;
    i4 = (HEAP32[i5 + 32 >> 2] & 1) + i4 | 0;
   }
   i1 = i7 + 1 | 0;
   if (i1 >>> 0 >= i9 >>> 0) break L1;
   i6 = i2;
   i7 = i1;
   i1 = HEAP32[i10 >> 2] | 0;
  }
 } while (0);
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i15, gb + 1086372 | 0, 1) | 0;
 __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i14, i16);
 i6 = HEAP8[i14 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i14 >> 2] | 0 : i14;
 i6 = i7 ? HEAP32[i14 + 4 >> 2] | 0 : i6 & 255;
 i7 = i12 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i6 >>> 0 > i3 >>> 0) {
  i10 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i6 - i3 | 0, i10, 0, i10, i6, i5);
 } else {
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 HEAP32[i13 >> 2] = i4;
 HEAP32[i15 >> 2] = gb + 77508 + 12;
 HEAP32[i17 >> 2] = gb + 77508 + 32;
 HEAP32[i16 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i16);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i15, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i17);
 STACKTOP = i18;
 return i8 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIjLi3EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 3 ? 3 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37304 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi1EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 1 ? 1 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi1EEEEvRT_17TransferMetaFlags(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i1 = i15 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i16, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i13 >>> 0 > 1 ? 1 : i13;
 HEAP32[i2 >> 2] = i12;
 i1 = i2 + 4 | 0;
 i12 = (HEAP32[i1 >> 2] | 0) + (i12 << 2) | 0;
 do if (i13 | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, 0, 0) | 0;
  i13 = i16 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i16 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i12 | 0)) {
    i4 = i16 + 16 | 0;
    i5 = i16 + 20 | 0;
    i6 = i16 + 32 | 0;
    i7 = i16 + 36 | 0;
    i8 = i16 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
     i19 = i14;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i17 = 9; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 9; else {
       HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i4 >> 2] = i3;
      }
     }
     if ((i17 | 0) == 9) {
      i17 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
     }
     if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i12 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i16);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i16);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i12 | 0)) {
   i4 = i16 + 16 | 0;
   i5 = i16 + 20 | 0;
   i6 = i16 + 32 | 0;
   i7 = i16 + 36 | 0;
   i8 = i16 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i16, gb + 1041891 | 0, i9, i14, 0) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i19 = HEAP32[i5 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i4 >> 2] = i2;
      if (i2 >>> 0 < i19 >>> 0) i17 = 22; else {
       i3 = i2 + 4 | 0;
       if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i17 = 22; else {
        HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
        HEAP32[i4 >> 2] = i3;
       }
      }
      if ((i17 | 0) == 22) {
       i17 = 0;
       __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
      }
      if (HEAP32[i16 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
     } else {
      i2 = HEAP32[i14 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i16 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i16);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i16);
 STACKTOP = i15;
 return;
}

function __ZN15Cast2DQueryBase19ConvertToRaycastHitERNS_14FixtureContactEP12RaycastHit2D(i2, i11, i17) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i17 = i17 | 0;
 var i1 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18 + 48 | 0;
 i8 = i18 + 32 | 0;
 i14 = i18;
 i1 = i2 + 40 | 0;
 i9 = i11 + 16 | 0;
 i15 = i2 + 268 | 0;
 i16 = __ZN9b2Contact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i1, 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 + 20 >> 2] | 0, i15) | 0;
 if (!i16) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i10 = (HEAP32[i16 + 52 >> 2] | 0) == (i1 | 0);
 if (i10) {
  i5 = i11 + 52 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = i11 + 36 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = i2 + 36 | 0;
  i1 = (HEAP32[i9 >> 2] | 0) + 32 | 0;
 } else {
  i5 = i11 + 36 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = i11 + 52 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = (HEAP32[i9 >> 2] | 0) + 32 | 0;
  i1 = i2 + 36 | 0;
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + 8 >> 2]);
 i1 = i16 + 64 | 0;
 mftCall_viiii(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i16 | 0, i1 | 0, i6 | 0, i8 | 0);
 i12 = i16 + 124 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i13 = (i7 | 0) > 0;
 if (i13) {
  __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i14, i1, i6, f4, i8, f3);
  HEAP32[i17 + 32 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2];
  i1 = i17 + 16 | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i5 = HEAP32[i14 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  i6 = i17 + 20 | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i17 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i11 + 32 >> 2];
  i9 = HEAP32[i11 + 40 >> 2] | 0;
  HEAP32[i17 >> 2] = HEAP32[i11 + 36 >> 2];
  HEAP32[i17 + 4 >> 2] = i9;
  if (!i10) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f4 = Math_fround(-f4);
   HEAPF32[i1 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   HEAPF32[i6 >> 2] = f4;
  }
  if ((i7 | 0) == 1) {
   i11 = HEAP32[i14 + 12 >> 2] | 0;
   HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = i11;
  } else {
   i1 = i14 + 8 | 0;
   i2 = i14 + 16 | 0;
   f3 = Math_fround(HEAPF32[i14 + 24 >> 2]);
   f4 = Math_fround(HEAPF32[i14 + 28 >> 2]);
   f19 = Math_fround(f3 - f4);
   i11 = f19 < Math_fround(0.0);
   f20 = Math_fround(-f19);
   if (!((i11 ? f20 : f19) <= Math_fround(.0000249999994))) {
    i2 = f3 < f4 ? i1 : i2;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
   } else {
    f19 = Math_fround(HEAPF32[i1 >> 2]);
    f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i2 >> 2])) * Math_fround(.5));
    f20 = Math_fround(HEAPF32[i14 + 12 >> 2]);
    f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i14 + 20 >> 2])) * Math_fround(.5));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
   }
   HEAP32[i17 + 8 >> 2] = i1;
   HEAP32[i17 + 12 >> 2] = i2;
  }
 }
 HEAP32[i12 >> 2] = 0;
 __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator(i16, i15);
 i17 = i13;
 STACKTOP = i18;
 return i17 | 0;
}

function runPostSets171() {
 HEAP32[gb + 149716 >> 2] = fb + 2162;
 HEAP32[gb + 149720 >> 2] = fb + 2164;
 HEAP32[gb + 149724 >> 2] = fb + 1425;
 HEAP32[gb + 149728 >> 2] = fb + 1426;
 HEAP32[gb + 149732 >> 2] = fb + 1427;
 HEAP32[gb + 149736 >> 2] = fb + 1428;
 HEAP32[gb + 149740 >> 2] = fb + 1429;
 HEAP32[gb + 149744 >> 2] = fb + 1430;
 HEAP32[gb + 149748 >> 2] = fb + 1431;
 HEAP32[gb + 149752 >> 2] = fb + 1432;
 HEAP32[gb + 149756 >> 2] = fb + 1433;
 HEAP32[gb + 149760 >> 2] = fb + 1434;
 HEAP32[gb + 149772 >> 2] = fb + 2162;
 HEAP32[gb + 149776 >> 2] = fb + 2165;
 HEAP32[gb + 149780 >> 2] = fb + 1435;
 HEAP32[gb + 149784 >> 2] = fb + 1436;
 HEAP32[gb + 149788 >> 2] = fb + 1437;
 HEAP32[gb + 149792 >> 2] = fb + 1438;
 HEAP32[gb + 149796 >> 2] = fb + 1439;
 HEAP32[gb + 149800 >> 2] = fb + 1440;
 HEAP32[gb + 149804 >> 2] = fb + 1441;
 HEAP32[gb + 149808 >> 2] = fb + 1442;
 HEAP32[gb + 149812 >> 2] = fb + 1443;
 HEAP32[gb + 149816 >> 2] = fb + 1444;
 HEAP32[gb + 149828 >> 2] = fb + 2105;
 HEAP32[gb + 149832 >> 2] = fb + 2166;
 HEAP32[gb + 149836 >> 2] = fb + 1445;
 HEAP32[gb + 149848 >> 2] = fb + 2105;
 HEAP32[gb + 149852 >> 2] = fb + 2167;
 HEAP32[gb + 149856 >> 2] = fb + 1446;
 HEAP32[gb + 149868 >> 2] = fb + 2105;
 HEAP32[gb + 149872 >> 2] = fb + 2168;
 HEAP32[gb + 149876 >> 2] = fb + 1447;
 HEAP32[gb + 149888 >> 2] = fb + 2105;
 HEAP32[gb + 149892 >> 2] = fb + 2169;
 HEAP32[gb + 149896 >> 2] = fb + 1448;
 HEAP32[gb + 149908 >> 2] = fb + 2105;
 HEAP32[gb + 149912 >> 2] = fb + 2170;
 HEAP32[gb + 149916 >> 2] = fb + 1449;
 HEAP32[gb + 149928 >> 2] = fb + 2105;
 HEAP32[gb + 149932 >> 2] = fb + 2171;
 HEAP32[gb + 149936 >> 2] = fb + 1450;
 HEAP32[gb + 149948 >> 2] = fb + 2105;
 HEAP32[gb + 149952 >> 2] = fb + 2172;
 HEAP32[gb + 149956 >> 2] = fb + 1451;
 HEAP32[gb + 149968 >> 2] = fb + 2105;
 HEAP32[gb + 149972 >> 2] = fb + 2173;
 HEAP32[gb + 149976 >> 2] = fb + 1452;
 HEAP32[gb + 149988 >> 2] = fb + 2105;
 HEAP32[gb + 149992 >> 2] = fb + 2174;
 HEAP32[gb + 149996 >> 2] = fb + 1453;
 HEAP32[gb + 150008 >> 2] = fb + 2105;
 HEAP32[gb + 150012 >> 2] = fb + 2175;
 HEAP32[gb + 150016 >> 2] = fb + 1454;
 HEAP32[gb + 150028 >> 2] = fb + 2105;
 HEAP32[gb + 150032 >> 2] = fb + 2176;
 HEAP32[gb + 150036 >> 2] = fb + 1455;
 HEAP32[gb + 150048 >> 2] = fb + 2105;
 HEAP32[gb + 150052 >> 2] = fb + 2177;
 HEAP32[gb + 150056 >> 2] = fb + 1456;
 HEAP32[gb + 150068 >> 2] = fb + 2105;
 HEAP32[gb + 150072 >> 2] = fb + 2178;
 HEAP32[gb + 150076 >> 2] = fb + 1457;
 HEAP32[gb + 150088 >> 2] = fb + 2105;
 HEAP32[gb + 150092 >> 2] = fb + 2179;
 HEAP32[gb + 150096 >> 2] = fb + 1458;
 HEAP32[gb + 150108 >> 2] = fb + 2105;
 HEAP32[gb + 150112 >> 2] = fb + 2180;
 HEAP32[gb + 150116 >> 2] = fb + 1459;
 HEAP32[gb + 150128 >> 2] = fb + 2105;
 HEAP32[gb + 150132 >> 2] = fb + 2181;
 HEAP32[gb + 150136 >> 2] = fb + 1460;
 HEAP32[gb + 150148 >> 2] = fb + 2105;
 HEAP32[gb + 150152 >> 2] = fb + 2182;
 HEAP32[gb + 150156 >> 2] = fb + 1461;
 HEAP32[gb + 150168 >> 2] = fb + 2105;
 HEAP32[gb + 150172 >> 2] = fb + 2183;
 HEAP32[gb + 150176 >> 2] = fb + 1462;
 HEAP32[gb + 150188 >> 2] = fb + 2105;
 HEAP32[gb + 150192 >> 2] = fb + 2184;
 HEAP32[gb + 150196 >> 2] = fb + 1463;
 HEAP32[gb + 150208 >> 2] = fb + 2105;
 HEAP32[gb + 150212 >> 2] = fb + 2185;
 HEAP32[gb + 150216 >> 2] = fb + 1464;
 HEAP32[gb + 150228 >> 2] = fb + 2105;
 HEAP32[gb + 150232 >> 2] = fb + 2186;
 HEAP32[gb + 150236 >> 2] = fb + 1465;
 HEAP32[gb + 150248 >> 2] = fb + 2105;
 HEAP32[gb + 150252 >> 2] = fb + 2187;
 HEAP32[gb + 150256 >> 2] = fb + 1466;
 HEAP32[gb + 150268 >> 2] = fb + 2105;
 HEAP32[gb + 150272 >> 2] = fb + 2188;
 HEAP32[gb + 150276 >> 2] = fb + 1467;
 HEAP32[gb + 150288 >> 2] = fb + 2189;
 HEAP32[gb + 150292 >> 2] = fb + 2190;
 HEAP32[gb + 150296 >> 2] = fb + 402;
 HEAP32[gb + 150300 >> 2] = fb + 2191;
 HEAP32[gb + 150304 >> 2] = fb + 1468;
 HEAP32[gb + 150316 >> 2] = fb + 2105;
 HEAP32[gb + 150320 >> 2] = fb + 2192;
 runPostSets172();
}

function __ZN13SplatDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = i3 + 20 | 0;
 i5 = i3 + 16 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932752 | 0, i4, i1, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAPF32[i7 + 8 >> 2] = Math_fround(15.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(15.0);
 i8 = i7 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 937573 | 0, i7, 0);
 __ZN14SplatPrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932761 | 0, i4, i1 + 12 | 0, 0);
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034905 | 0, i5, 0);
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932777 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932798 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932818 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932831 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932858 | 0, i6, i1 + 49 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEbT0_SB_T_(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 switch (i9 - i8 >> 3 | 0) {
 case 2:
  {
   i1 = i9 + -8 | 0;
   if (!(mftCall_iii(HEAP32[i10 >> 2] | 0, i1 | 0, i8 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i10 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i10;
   i8 = i8 + 4 | 0;
   i10 = i9 + -4 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i9;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i8, i8 + 8 | 0, i9 + -8 | 0, i10) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 4:
  {
   i4 = i8 + 8 | 0;
   i2 = i8 + 16 | 0;
   i1 = i9 + -8 | 0;
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i8, i4, i2, i10) | 0;
   if (!(mftCall_iii(HEAP32[i10 >> 2] | 0, i1 | 0, i2 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i3;
   i3 = i8 + 20 | 0;
   i9 = i9 + -4 | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i7;
   if (!(mftCall_iii(HEAP32[i10 >> 2] | 0, i2 | 0, i4 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i1;
   i1 = i8 + 12 | 0;
   i9 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i9;
   if (!(mftCall_iii(HEAP32[i10 >> 2] | 0, i4 | 0, i8 | 0) | 0)) {
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i9;
   i9 = i8 + 4 | 0;
   i10 = HEAP32[i9 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i10;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i8 + 24 | 0, i9 + -8 | 0, i10) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 1:
 case 0:
  {
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i3 = i8 + 16 | 0;
   __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i8, i8 + 8 | 0, i3, i10) | 0;
   i1 = i8 + 24 | 0;
   L3 : do if ((i1 | 0) == (i9 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i7 = i6 + 4 | 0;
    i2 = 0;
    while (1) {
     if (mftCall_iii(HEAP32[i10 >> 2] | 0, i1 | 0, i3 | 0) | 0) {
      i12 = i1;
      i5 = HEAP32[i12 + 4 >> 2] | 0;
      i4 = i6;
      HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
      HEAP32[i4 + 4 >> 2] = i5;
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       i5 = i3 + 4 | 0;
       HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
       if ((i3 | 0) == (i8 | 0)) break;
       i4 = i3 + -8 | 0;
       if (mftCall_iii(HEAP32[i10 >> 2] | 0, i6 | 0, i4 | 0) | 0) {
        i12 = i3;
        i3 = i4;
        i4 = i12;
       } else break;
      }
      HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i9 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i9 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i12 = i1;
      i1 = i3;
      i3 = i12;
     }
    }
   } while (0);
   i12 = i1 | i2;
   STACKTOP = i11;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i10, i2, i13) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i8 = i13 - i2 | 0;
 i9 = (i8 | 0) / 204 | 0;
 i11 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (i9 >>> 0 <= ((i1 - i4 | 0) / 204 | 0) >>> 0) {
  i7 = i10 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 204 | 0;
  i6 = i9 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 204 | 0) | 0;
  i4 = i6 ? i1 : i13;
  if ((i4 | 0) == (i2 | 0)) i5 = i3; else {
   do {
    __ZN13AnimationClip15QuaternionCurveaSERKS0_(i3, i2) | 0;
    i2 = i2 + 204 | 0;
    i3 = i3 + 204 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i5 = i3;
  }
  if (i6) {
   if ((i4 | 0) == (i13 | 0)) {
    STACKTOP = i14;
    return;
   }
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i2, i1);
    i1 = i1 + 204 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 204 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i13 | 0));
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i14;
   return;
  }
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -204 | 0;
   HEAP32[i7 >> 2] = i2;
   i3 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -192 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
   }
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (i5 | 0));
  STACKTOP = i14;
  return;
 }
 if (i4) {
  i7 = i10 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
   i6 = i12 + 4 | 0;
   do {
    i4 = i1 + -204 | 0;
    HEAP32[i7 >> 2] = i4;
    i5 = i1 + -36 | 0;
    if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1 + -32 | 0);
     HEAP32[i5 >> 2] = 0;
    }
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i1 + -192 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i6 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
    }
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i8 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 204 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 204 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 * 204 | 0);
 if ((i2 | 0) == (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1, i2);
  i2 = i2 + 204 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 204 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i13 | 0));
 STACKTOP = i14;
 return;
}

function __ZN9b2Contact6UpdateEP17b2ContactListener(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i5 = i15 + 64 | 0;
 i1 = i17;
 i2 = i5;
 i3 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i13 = i15 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!(i1 & 64)) {
  i1 = i1 | 4;
  HEAP32[i13 >> 2] = i1;
 }
 i9 = i1 >>> 1;
 i4 = HEAP32[i15 + 48 >> 2] | 0;
 i1 = HEAP32[i15 + 52 >> 2] | 0;
 i14 = (HEAP8[i1 + 58 >> 0] | HEAP8[i4 + 58 >> 0]) << 24 >> 24 != 0;
 i10 = HEAP32[i4 + 28 >> 2] | 0;
 i12 = HEAP32[i1 + 28 >> 2] | 0;
 i2 = i10 + 12 | 0;
 i3 = i12 + 12 | 0;
 i4 = HEAP32[i4 + 32 >> 2] | 0;
 do if (i14) {
  i4 = __Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i4, HEAP32[i15 + 56 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, HEAP32[i15 + 60 >> 2] | 0, i2, i3) | 0;
  HEAP32[i15 + 124 >> 2] = 0;
  i1 = i9 & 1;
 } else {
  HEAP32[i15 + 128 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i15 + 132 >> 2] = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 8 >> 2];
  mftCall_viiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i5 | 0, i2 | 0, i3 | 0);
  i8 = i15 + 124 | 0;
  i4 = (HEAP32[i8 >> 2] | 0) > 0;
  L7 : do if (i4) {
   i5 = HEAP32[i17 + 60 >> 2] | 0;
   if ((i5 | 0) > 0) i2 = 0; else {
    i1 = 0;
    while (1) {
     HEAPF32[i15 + 64 + (i1 * 20 | 0) + 8 >> 2] = Math_fround(0.0);
     HEAPF32[i15 + 64 + (i1 * 20 | 0) + 12 >> 2] = Math_fround(0.0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (HEAP32[i8 >> 2] | 0)) break L7;
    }
   }
   do {
    i6 = i15 + 64 + (i2 * 20 | 0) + 8 | 0;
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    i7 = i15 + 64 + (i2 * 20 | 0) + 12 | 0;
    HEAPF32[i7 >> 2] = Math_fround(0.0);
    i3 = HEAP32[i15 + 64 + (i2 * 20 | 0) + 16 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i17 + (i1 * 20 | 0) + 16 >> 2] | 0) == (i3 | 0)) {
      i11 = 10;
      break;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i5 | 0));
    if ((i11 | 0) == 10) {
     i11 = 0;
     HEAP32[i6 >> 2] = HEAP32[i17 + (i1 * 20 | 0) + 8 >> 2];
     HEAP32[i7 >> 2] = HEAP32[i17 + (i1 * 20 | 0) + 12 >> 2];
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i8 >> 2] | 0));
  } while (0);
  i1 = i9 & 1;
  if ((i1 | 0) != 0 ^ i4) {
   i2 = i10 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(HEAP32[i10 >> 2] | 0)) {
    HEAP16[i2 >> 1] = i3 & 65533;
    HEAPF32[i10 + 144 >> 2] = Math_fround(0.0);
    i11 = i10 + 64 | 0;
    HEAP32[i11 >> 2] = 0;
    HEAP32[i11 + 4 >> 2] = 0;
    HEAP32[i11 + 8 >> 2] = 0;
    HEAP32[i11 + 12 >> 2] = 0;
    HEAP32[i11 + 16 >> 2] = 0;
    HEAP32[i11 + 20 >> 2] = 0;
   } else if (!(i3 & 2)) {
    HEAP16[i2 >> 1] = i3 | 2;
    HEAPF32[i10 + 144 >> 2] = Math_fround(0.0);
   }
   i2 = i12 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(HEAP32[i12 >> 2] | 0)) {
    HEAP16[i2 >> 1] = i3 & 65533;
    HEAPF32[i12 + 144 >> 2] = Math_fround(0.0);
    i12 = i12 + 64 | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    HEAP32[i12 + 12 >> 2] = 0;
    HEAP32[i12 + 16 >> 2] = 0;
    HEAP32[i12 + 20 >> 2] = 0;
    break;
   }
   if (!(i3 & 2)) {
    HEAP16[i2 >> 1] = i3 | 2;
    HEAPF32[i12 + 144 >> 2] = Math_fround(0.0);
   }
  }
 } while (0);
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i4 ? i2 | 2 : i2 & -3;
 i1 = (i1 | 0) == 0;
 i2 = (i16 | 0) != 0;
 i3 = i2 & i4;
 if (i1 & i3) mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i15 | 0);
 if (i2 & (i4 ^ 1) & (i1 ^ 1)) mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i15 | 0);
 if (!(i3 & (i14 ^ 1))) {
  STACKTOP = i18;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i16 | 0, i15 | 0, i17 | 0);
 STACKTOP = i18;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = (i6 - i7 | 0) / 20 | 0;
 i3 = i7;
 if (i1 >>> 0 < i12 >>> 0) {
  i9 = i14 + 8 | 0;
  if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 20 | 0 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i11 >> 2] = 0;
  i10 = i11 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i8 = i11 + 8 | 0;
  if (i12 | 0) {
   i3 = __Znwj(i12 * 20 | 0) | 0;
   i1 = i3;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3 + (i12 * 20 | 0);
  }
  HEAP32[i4 >> 2] = i7;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i2, i13);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = (i1 - i4 | 0) / 20 | 0;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i2 | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 * 20 | 0) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~(((i5 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0) | 0;
    HEAP32[i10 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i3 + (i12 * 20 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i9 = i13 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 * 20 | 0;
  i2 = (i1 | 0) / 20 | 0;
  if (!i1) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i5 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i13 >> 2] = i5;
   i1 = i5 + (i2 * 20 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i8 = i5;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i6 = i5;
    i2 = i5;
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     i3 = i3 + 20 | 0;
     i2 = i2 + 20 | 0;
     if ((i3 | 0) == (i7 | 0)) break; else i6 = i2;
    }
    HEAP32[i9 >> 2] = i2;
    i5 = i8;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i6 = HEAP32[(HEAP32[i10 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i8 = HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0;
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 if (!(HEAP8[i8 + 156 >> 0] & 2)) {
  i7 = HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2] | 0;
  i8 = HEAP32[i1 + (i6 * 12 | 0) >> 2] | 0;
  i1 = HEAP32[i1 + (i6 * 12 | 0) + 8 >> 2] | 0;
 } else {
  i7 = HEAPU16[i1 + (i6 * 6 | 0) + 2 >> 1] | 0;
  i8 = HEAPU16[i1 + (i6 * 6 | 0) >> 1] | 0;
  i1 = HEAPU16[i1 + (i6 * 6 | 0) + 4 >> 1] | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i10 >> 2]);
 f20 = Math_fround(f16 * f23);
 f22 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f4 = Math_fround(f16 * f22);
 f15 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f16 = Math_fround(f16 * f15);
 f14 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f5 = Math_fround(f14 * f19);
 f17 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f13 = Math_fround(f14 * f17);
 f3 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f5 = Math_fround(f20 + f5);
 f13 = Math_fround(f4 + f13);
 f14 = Math_fround(f16 + Math_fround(f14 * f3));
 f16 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f20 = Math_fround(f16 * f4);
 f12 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 f18 = Math_fround(f16 * f12);
 f2 = Math_fround(HEAPF32[i10 + 32 >> 2]);
 f20 = Math_fround(f5 + f20);
 f18 = Math_fround(f13 + f18);
 f16 = Math_fround(f14 + Math_fround(f16 * f2));
 f14 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) >> 2]);
 f13 = Math_fround(f23 * f14);
 f5 = Math_fround(f22 * f14);
 f14 = Math_fround(f15 * f14);
 f21 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f19 * f21));
 f5 = Math_fround(f5 + Math_fround(f17 * f21));
 f21 = Math_fround(f14 + Math_fround(f3 * f21));
 f14 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f4 * f14));
 f5 = Math_fround(f5 + Math_fround(f12 * f14));
 f14 = Math_fround(f21 + Math_fround(f2 * f14));
 f21 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) >> 2]);
 f23 = Math_fround(f23 * f21);
 f22 = Math_fround(f22 * f21);
 f21 = Math_fround(f15 * f21);
 f15 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2]);
 f19 = Math_fround(f23 + Math_fround(f19 * f15));
 f17 = Math_fround(f22 + Math_fround(f17 * f15));
 f15 = Math_fround(f21 + Math_fround(f3 * f15));
 f3 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2]);
 f13 = Math_fround(f20 - f13);
 f5 = Math_fround(f18 - f5);
 f14 = Math_fround(f16 - f14);
 f4 = Math_fround(f20 - Math_fround(f19 + Math_fround(f4 * f3)));
 f12 = Math_fround(f18 - Math_fround(f17 + Math_fround(f12 * f3)));
 f3 = Math_fround(f16 - Math_fround(f15 + Math_fround(f2 * f3)));
 f2 = Math_fround(Math_fround(f5 * f3) - Math_fround(f14 * f12));
 f3 = Math_fround(Math_fround(f14 * f4) - Math_fround(f13 * f3));
 f4 = Math_fround(Math_fround(f13 * f12) - Math_fround(f5 * f4));
 f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)));
 if (!(f5 > Math_fround(0.0))) {
  f23 = Math_fround(0.0);
  f22 = Math_fround(0.0);
  f21 = Math_fround(0.0);
  HEAPF32[i11 >> 2] = f21;
  i10 = i11 + 4 | 0;
  HEAPF32[i10 >> 2] = f22;
  i11 = i11 + 8 | 0;
  HEAPF32[i11 >> 2] = f23;
  return;
 }
 f21 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f5))));
 f23 = Math_fround(f4 * f21);
 f22 = Math_fround(f3 * f21);
 f21 = Math_fround(f2 * f21);
 HEAPF32[i11 >> 2] = f21;
 i10 = i11 + 4 | 0;
 HEAPF32[i10 >> 2] = f22;
 i11 = i11 + 8 | 0;
 HEAPF32[i11 >> 2] = f23;
 return;
}

function __Z19getShapeWorldBoundsRKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i3 + 124 | 0;
 i21 = i3 + 96 | 0;
 i15 = i3 + 56 | 0;
 i14 = i3 + 24 | 0;
 i13 = i3;
 i23 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i15 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 84 >> 2] | 0, i22 | 0, i23 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i21 | 0, i2 | 0);
 f17 = Math_fround(Math_fround(HEAPF32[i21 + 16 >> 2]) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(HEAPF32[i22 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i22 >> 2]);
 f12 = Math_fround(f17 * f18);
 f16 = Math_fround(HEAPF32[i22 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f7 * f16));
 f4 = Math_fround(HEAPF32[i22 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f11 * f4));
 f9 = Math_fround(Math_fround(f18 * f12) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f11 * f16) - Math_fround(f7 * f4)))));
 f6 = Math_fround(Math_fround(f16 * f12) + Math_fround(Math_fround(f7 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f4) - Math_fround(f11 * f18)))));
 f12 = Math_fround(Math_fround(Math_fround(f11 * f19) + Math_fround(f20 * Math_fround(Math_fround(f7 * f18) - Math_fround(f17 * f16)))) + Math_fround(f4 * f12));
 f9 = Math_fround(Math_fround(HEAPF32[i22 + 16 >> 2]) + f9);
 f6 = Math_fround(Math_fround(HEAPF32[i22 + 20 >> 2]) + f6);
 f12 = Math_fround(Math_fround(HEAPF32[i22 + 24 >> 2]) + f12);
 f17 = Math_fround(HEAPF32[i21 >> 2]);
 f7 = Math_fround(f20 * f17);
 f19 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f18 * f19));
 f11 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f16 * f11));
 f10 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f4 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f10))) - Math_fround(f18 * f11));
 f5 = Math_fround(Math_fround(Math_fround(f18 * f10) + Math_fround(Math_fround(f4 * f19) + Math_fround(f20 * f11))) - Math_fround(f16 * f17));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f10)) - Math_fround(f4 * f11));
 HEAPF32[i14 >> 2] = Math_fround(f7 - Math_fround(f4 * f10));
 HEAPF32[i14 + 4 >> 2] = f8;
 HEAPF32[i14 + 8 >> 2] = f5;
 HEAPF32[i14 + 12 >> 2] = f11;
 HEAPF32[i14 + 16 >> 2] = f9;
 HEAPF32[i14 + 20 >> 2] = f6;
 HEAPF32[i14 + 24 >> 2] = f12;
 __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf(i13, i15, i14, Math_fround(1.0));
 f12 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(f12 - f6);
 f11 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f8 = Math_fround(f11 - f5);
 f10 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f8 = Math_fround(f8 * Math_fround(.5));
 f7 = Math_fround(Math_fround(f10 - f4) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f12 + f6) * Math_fround(.5));
 f5 = Math_fround(Math_fround(f11 + f5) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f10 + f4) * Math_fround(.5));
 HEAPF32[i1 + 12 >> 2] = Math_fround(f9 * Math_fround(.5));
 HEAPF32[i1 + 16 >> 2] = f8;
 HEAPF32[i1 + 20 >> 2] = f7;
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function runPostSets215() {
 HEAP32[gb + 184588 >> 2] = fb + 463;
 HEAP32[gb + 184600 >> 2] = fb + 136;
 HEAP32[gb + 184604 >> 2] = fb + 2803;
 HEAP32[gb + 184608 >> 2] = fb + 279;
 HEAP32[gb + 184612 >> 2] = fb + 102;
 HEAP32[gb + 184616 >> 2] = fb + 103;
 HEAP32[gb + 184620 >> 2] = fb + 104;
 HEAP32[gb + 184624 >> 2] = fb + 1303;
 HEAP32[gb + 184628 >> 2] = fb + 1304;
 HEAP32[gb + 184632 >> 2] = fb + 464;
 HEAP32[gb + 184636 >> 2] = fb + 465;
 HEAP32[gb + 184640 >> 2] = fb + 110;
 HEAP32[gb + 184644 >> 2] = fb + 105;
 HEAP32[gb + 184648 >> 2] = fb + 138;
 HEAP32[gb + 184652 >> 2] = fb + 1305;
 HEAP32[gb + 184656 >> 2] = fb + 139;
 HEAP32[gb + 184668 >> 2] = fb + 136;
 HEAP32[gb + 184672 >> 2] = fb + 2804;
 HEAP32[gb + 184676 >> 2] = fb + 280;
 HEAP32[gb + 184680 >> 2] = fb + 102;
 HEAP32[gb + 184684 >> 2] = fb + 103;
 HEAP32[gb + 184688 >> 2] = fb + 104;
 HEAP32[gb + 184692 >> 2] = fb + 1303;
 HEAP32[gb + 184696 >> 2] = fb + 120;
 HEAP32[gb + 184700 >> 2] = fb + 53;
 HEAP32[gb + 184704 >> 2] = fb + 52;
 HEAP32[gb + 184708 >> 2] = fb + 110;
 HEAP32[gb + 184712 >> 2] = fb + 105;
 HEAP32[gb + 184716 >> 2] = fb + 138;
 HEAP32[gb + 184720 >> 2] = fb + 1305;
 HEAP32[gb + 184724 >> 2] = fb + 139;
 HEAP32[gb + 184736 >> 2] = fb + 136;
 HEAP32[gb + 184740 >> 2] = fb + 2805;
 HEAP32[gb + 184744 >> 2] = fb + 281;
 HEAP32[gb + 184748 >> 2] = fb + 102;
 HEAP32[gb + 184752 >> 2] = fb + 103;
 HEAP32[gb + 184756 >> 2] = fb + 104;
 HEAP32[gb + 184760 >> 2] = fb + 1303;
 HEAP32[gb + 184764 >> 2] = fb + 1306;
 HEAP32[gb + 184768 >> 2] = fb + 466;
 HEAP32[gb + 184772 >> 2] = fb + 467;
 HEAP32[gb + 184776 >> 2] = fb + 110;
 HEAP32[gb + 184780 >> 2] = fb + 105;
 HEAP32[gb + 184784 >> 2] = fb + 138;
 HEAP32[gb + 184788 >> 2] = fb + 1305;
 HEAP32[gb + 184792 >> 2] = fb + 139;
 HEAP32[gb + 184804 >> 2] = (HEAP32[gb + 184804 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 184808 >> 2] = (HEAP32[gb + 184808 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 185100 >> 2] = fb + 2806;
 HEAP32[gb + 185104 >> 2] = fb + 2807;
 HEAP32[gb + 185108 >> 2] = fb + 38;
 HEAP32[gb + 185112 >> 2] = fb + 100;
 HEAP32[gb + 185116 >> 2] = fb + 16;
 HEAP32[gb + 185120 >> 2] = fb + 93;
 HEAP32[gb + 185124 >> 2] = fb + 40;
 HEAP32[gb + 185128 >> 2] = fb + 19;
 HEAP32[gb + 185132 >> 2] = fb + 1307;
 HEAP32[gb + 185136 >> 2] = fb + 103;
 HEAP32[gb + 185140 >> 2] = fb + 101;
 HEAP32[gb + 185144 >> 2] = fb + 62;
 HEAP32[gb + 185148 >> 2] = fb + 28;
 HEAP32[gb + 185152 >> 2] = fb + 63;
 HEAP32[gb + 185156 >> 2] = fb + 29;
 HEAP32[gb + 185160 >> 2] = fb + 34;
 HEAP32[gb + 185164 >> 2] = fb + 2128;
 HEAP32[gb + 185168 >> 2] = fb + 2129;
 HEAP32[gb + 185172 >> 2] = fb + 2130;
 HEAP32[gb + 185176 >> 2] = fb + 2131;
 HEAP32[gb + 185180 >> 2] = fb + 2132;
 HEAP32[gb + 185184 >> 2] = fb + 2133;
 HEAP32[gb + 185188 >> 2] = fb + 36;
 HEAP32[gb + 185192 >> 2] = fb + 1308;
 HEAP32[gb + 185196 >> 2] = fb + 108;
 HEAP32[gb + 185200 >> 2] = fb + 2808;
 HEAP32[gb + 185204 >> 2] = fb + 109;
 HEAP32[gb + 185208 >> 2] = fb + 105;
 HEAP32[gb + 185212 >> 2] = fb + 106;
 HEAP32[gb + 185216 >> 2] = fb + 110;
 HEAP32[gb + 185228 >> 2] = fb + 2809;
 HEAP32[gb + 185232 >> 2] = fb + 2810;
 HEAP32[gb + 185236 >> 2] = fb + 38;
 HEAP32[gb + 185240 >> 2] = fb + 2134;
 HEAP32[gb + 185244 >> 2] = fb + 16;
 HEAP32[gb + 185248 >> 2] = fb + 39;
 HEAP32[gb + 185252 >> 2] = fb + 2811;
 HEAP32[gb + 185256 >> 2] = fb + 19;
 HEAP32[gb + 185260 >> 2] = fb + 1309;
 HEAP32[gb + 185264 >> 2] = fb + 31;
 HEAP32[gb + 185268 >> 2] = fb + 27;
 HEAP32[gb + 185272 >> 2] = fb + 62;
 HEAP32[gb + 185276 >> 2] = fb + 28;
 HEAP32[gb + 185280 >> 2] = fb + 63;
 HEAP32[gb + 185284 >> 2] = fb + 29;
 HEAP32[gb + 185288 >> 2] = fb + 34;
 HEAP32[gb + 185292 >> 2] = fb + 2135;
 HEAP32[gb + 185296 >> 2] = fb + 2136;
 HEAP32[gb + 185300 >> 2] = fb + 2137;
 HEAP32[gb + 185304 >> 2] = fb + 2138;
 HEAP32[gb + 185308 >> 2] = fb + 2139;
 HEAP32[gb + 185312 >> 2] = fb + 2140;
 runPostSets216();
}

function __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i13, i11, i12) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i9 = i14 + 92 | 0;
 i10 = i14 + 64 | 0;
 i6 = i14 + 32 | 0;
 i7 = HEAP32[i13 + 8 >> 2] | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i8;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i15 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i15;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i10 = i13 + 16 | 0;
  i15 = i12 + 1 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj279ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i10, i15);
  i13 = i13 + 32 | 0;
  i15 = i12 + 2 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i13, i15);
  i15 = i12 + 3 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i10 = i13 + 16 | 0;
 i15 = i12 + 1 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj279ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i10, i15);
 i13 = i13 + 32 | 0;
 i15 = i12 + 2 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i13, i15);
 i15 = i12 + 3 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN10GUIManager16SendQueuedEventsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i12 = i14 + 52 | 0;
 i13 = __Z18GetGUIEventManagerv() | 0;
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 0) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 72 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 1) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 124 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 2) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 176 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 3) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 228 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 4) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 280 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 5) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 332 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 6) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 384 | 0, i1);
 i1 = __ZN15GUIEventManager22GetLastEventForDisplayEi(i13, 7) | 0;
 if (i1 | 0) __ZN10InputEventaSERKS_((HEAP32[gb + 1468156 >> 2] | 0) + 436 | 0, i1);
 HEAP32[i12 >> 2] = 0;
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i12 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i5 = i11;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 if ((__ZNK15GUIEventManager13GetEventCountEv(i13) | 0) > 0) {
  i7 = i11 + 40 | 0;
  i8 = 0;
  do {
   __ZN10InputEventC2ERKS_(i11, __ZNK15GUIEventManager15GetEventAtIndexEi(i13, i8) | 0);
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i1 | 0) != 2) {
    i2 = HEAP32[gb + 1468156 >> 2] | 0;
    switch (i1 | 0) {
    case 4:
    case 1:
    case 0:
     {
      i5 = HEAP32[i7 >> 2] | 0;
      f15 = Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
      HEAPF32[(HEAP32[gb + 1468156 >> 2] | 0) + 40 + (i5 << 2) >> 2] = f15;
      break;
     }
    default:
     {}
    }
    __ZN10GUIManager10DoGUIEventER10InputEventb(i2, i11, 1);
    if ((HEAP32[i11 >> 2] | 0) == 12) {
     i2 = HEAP32[i6 >> 2] | 0;
     i3 = i2 + 1 | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     i5 = i4 & 2147483647;
     do if (i3 >>> 0 > i5 >>> 0) {
      i1 = i4 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
       HEAP32[i9 >> 2] = i1;
       HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i5 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
       HEAP32[i9 >> 2] = i1;
       HEAP32[i12 >> 2] = i5;
       break;
      }
     } while (0);
     HEAP32[i6 >> 2] = i3;
     HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] = i8;
    }
   }
   __ZN10InputEventD2Ev(i11);
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) < (__ZNK15GUIEventManager13GetEventCountEv(i13) | 0));
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + -1 | 0;
   if ((i1 | 0) > -1) do {
    __ZN15GUIEventManager18RemoveEventAtIndexEi(i13, i1);
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) > -1);
  }
 }
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i10);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __Z24CalculateVertexLightDataRK15SharedLightDataR14GfxVertexLight(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i6 = i4 + 40 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 + 60 >> 2] = i8;
 switch (i8 | 0) {
 case 2:
  {
   i9 = HEAP32[i4 + 268 >> 2] | 0;
   i8 = HEAP32[i4 + 272 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 + 264 >> 2];
   HEAP32[i5 + 4 >> 2] = i9;
   HEAP32[i5 + 8 >> 2] = i8;
   HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 56 >> 2] = Math_fround(-1.0);
   f7 = Math_fround(HEAPF32[i4 + 48 >> 2]);
   HEAPF32[i5 + 52 >> 2] = Math_fround(Math_fround(25.0) / Math_fround(f7 * f7));
   HEAPF32[i5 + 16 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
   break;
  }
 case 1:
  {
   i8 = HEAP32[i4 + 252 >> 2] | 0;
   i9 = HEAP32[i4 + 256 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 + 248 >> 2];
   HEAP32[i5 + 4 >> 2] = i8;
   HEAP32[i5 + 8 >> 2] = i9;
   HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 52 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 56 >> 2] = Math_fround(-1.0);
   HEAPF32[i5 + 16 >> 2] = Math_fround(1.0);
   HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
   break;
  }
 case 0:
  {
   i9 = HEAP32[i4 + 268 >> 2] | 0;
   i8 = HEAP32[i4 + 272 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 + 264 >> 2];
   HEAP32[i5 + 4 >> 2] = i9;
   HEAP32[i5 + 8 >> 2] = i8;
   HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
   i8 = HEAP32[i4 + 252 >> 2] | 0;
   i9 = HEAP32[i4 + 256 >> 2] | 0;
   HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 248 >> 2];
   HEAP32[i5 + 20 >> 2] = i8;
   HEAP32[i5 + 24 >> 2] = i9;
   HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
   HEAP32[i5 + 56 >> 2] = HEAP32[i4 + 60 >> 2];
   f7 = Math_fround(HEAPF32[i4 + 48 >> 2]);
   HEAPF32[i5 + 52 >> 2] = Math_fround(Math_fround(25.0) / Math_fround(f7 * f7));
   break;
  }
 case 3:
  break;
 default:
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 379986 | 0, 0, gb + 380258 | 0, 344, 1, HEAP32[i4 + 16 >> 2] | 0, 0, 0);
 }
 f7 = Math_fround(HEAPF32[i4 + 44 >> 2]);
 f2 = Math_fround(f7 * Math_fround(HEAPF32[i4 + 20 >> 2]));
 f1 = Math_fround(f7 * Math_fround(HEAPF32[i4 + 24 >> 2]));
 f3 = Math_fround(f7 * Math_fround(HEAPF32[i4 + 28 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i4 + 32 >> 2]));
 do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  do if (!(f2 <= Math_fround(.0404499993))) {
   if (f2 < Math_fround(1.0)) {
    f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, 2.20000005));
  } else f2 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
  do if (!(f1 <= Math_fround(.0404499993))) {
   if (f1 < Math_fround(1.0)) {
    f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
  } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
  if (f3 <= Math_fround(.0404499993)) {
   f3 = Math_fround(f3 / Math_fround(12.9200001));
   break;
  }
  if (f3 < Math_fround(1.0)) {
   f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, 2.20000005));
 } while (0);
 HEAPF32[i5 + 32 >> 2] = f2;
 HEAPF32[i5 + 36 >> 2] = f1;
 HEAPF32[i5 + 40 >> 2] = f3;
 HEAPF32[i5 + 44 >> 2] = f7;
 HEAP32[i5 + 48 >> 2] = HEAP32[((HEAP32[i6 >> 2] | 0) == 3 ? i4 + 204 | 0 : i4 + 48 | 0) >> 2];
 return;
}

function __ZN9ShaderLab14SerializedPassD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i5 + 860 | 0, HEAP32[i5 + 864 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i5 + 848 | 0, HEAP32[i5 + 852 >> 2] | 0);
 i1 = i5 + 832 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 844 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 816 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 828 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 800 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 812 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i3 = i5 + 788 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 792 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i5 + 776 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 780 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i5 + 764 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 768 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i5 + 752 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 756 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i5 + 740 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 744 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i5 + 728 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 732 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -192 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i5 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i5 + 704 | 0, HEAP32[i5 + 708 >> 2] | 0);
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i6);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine9AnimationL22GenerateBindingRecurseERK16TypeTreeIteratorP12Il2CppObjectN7mecanim5crc32ER13dynamic_arrayINS0_13CachedBindingELj4EE(i12, i13, i1, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 8 | 0;
 i16 = i17;
 i5 = i17 + 16 | 0;
 if ((i1 | 0) == -1) i2 = -1; else i2 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 46) << 2) >> 2] ^ i1 >>> 8;
 i1 = __ZNK16TypeTreeIterator4NameEv(i12) | 0;
 i11 = _strlen(__ZNK16TypeTreeIterator4NameEv(i12) | 0) | 0;
 i3 = i1 + i11 | 0;
 if ((i11 | 0) > 0) do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i4 = __ZNK16TypeTreeIterator10ByteOffsetEv(i12) | 0;
 i1 = (i13 | 0) != 0;
 L8 : do if ((i4 >>> 31 | 0) == (i1 & 1 | 0)) {
  do if (i1) {
   i3 = __ZN11UnityEngine9AnimationL19GetTypeTreeBindTypeERK16TypeTreeIterator(i12) | 0;
   if ((i3 + -5 | 0) >>> 0 < 2) if ((i4 | 0) == -1) break L8; else {
    i1 = -1;
    i4 = i4 & 2147483647;
    break;
   }
   __ZNK16TypeTreeIterator6FatherEv(i15, i12);
   if (!(HEAP32[i15 >> 2] | 0)) break L8;
   __ZNK16TypeTreeIterator6FatherEv(i16, i12);
   __ZNK16TypeTreeIterator6FatherEv(i5, i16);
   if (HEAP32[i5 >> 2] | 0) break L8;
   i3 = __Z26scripting_object_get_classP12Il2CppObject(i13) | 0;
   i3 = __Z35scripting_class_get_field_from_nameP11Il2CppClassPKc(i3, __ZNK16TypeTreeIterator4NameEv(i12) | 0) | 0;
   if (!i3) break L8;
   i1 = __Z24scripting_field_get_typeP9FieldInfo(i3) | 0;
   if ((__Z23scripting_type_get_typePK10Il2CppType(i1) | 0) != 18) break L8;
   i1 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(__Z25scripting_class_from_typePK10Il2CppType(i1) | 0) | 0;
   if (!i1) break L8;
   i1 = HEAP32[i1 + 16 >> 2] | 0;
   switch (i1 | 0) {
   case 114:
   case 0:
   case -1:
    break L8;
   default:
    {}
   }
   i4 = __Z26scripting_field_get_offsetP9FieldInfo(i3) | 0;
   if ((i4 | 0) == -1) break L8; else i3 = 9;
  } else {
   if ((i4 | 0) == -1) break L8;
   i3 = __ZN11UnityEngine9AnimationL19GetTypeTreeBindTypeERK16TypeTreeIterator(i12) | 0;
   if (!i3) break L8; else {
    i1 = -1;
    i4 = i4 & 2147483647;
   }
  } while (0);
  i6 = i14 + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i9 = i14 + 16 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i11 = i10 & 2147483647;
  do if (i8 >>> 0 > i11 >>> 0) {
   i5 = i10 << 1;
   i5 = (i5 | 0) == 0 ? 1 : i5;
   if (i11 >>> 0 < i5 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i9 >> 2] = i5;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i5 << 4, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
    HEAP32[i9 >> 2] = i5;
    HEAP32[i14 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i8;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i11 + (i7 << 4) >> 2] = ~i2;
  HEAP32[i11 + (i7 << 4) + 4 >> 2] = i4;
  HEAP32[i11 + (i7 << 4) + 8 >> 2] = i3;
  HEAP32[i11 + (i7 << 4) + 12 >> 2] = i1;
 } while (0);
 __ZNK16TypeTreeIterator8ChildrenEv(i15, i12);
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 do {
  __ZN11UnityEngine9AnimationL22GenerateBindingRecurseERK16TypeTreeIteratorP12Il2CppObjectN7mecanim5crc32ER13dynamic_arrayINS0_13CachedBindingELj4EE(i15, i13, i2, i14);
  __ZNK16TypeTreeIterator4NextEv(i16, i15);
  i10 = i16;
  i12 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i11 = i15;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i11 + 4 >> 2] = i10;
 } while ((i12 | 0) != 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i10, i1, i3, i6, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 56 | 0;
 i7 = i12 + 32 | 0;
 i4 = i12 + 8 | 0;
 i11 = i12;
 i2 = i1 + 32 | 0;
 i1 = i3 + (HEAP32[gb + 1457208 + ((HEAPU16[i3 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 if (!i5) {
  __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i4, i2, i1);
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 } else {
  f15 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f19 = Math_fround(HEAPF32[i5 >> 2]);
  f18 = Math_fround(f15 - f19);
  f21 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f14 = Math_fround(f21 - f17);
  f20 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f18 = Math_fround(Math_fround(f18 * Math_fround(.5)) * Math_fround(.00999999977));
  f14 = Math_fround(Math_fround(f14 * Math_fround(.5)) * Math_fround(.00999999977));
  f13 = Math_fround(Math_fround(Math_fround(f20 - f16) * Math_fround(.5)) * Math_fround(.00999999977));
  f17 = Math_fround(f17 - f14);
  f16 = Math_fround(f16 - f13);
  f15 = Math_fround(f15 + f18);
  f14 = Math_fround(f21 + f14);
  f13 = Math_fround(f20 + f13);
  HEAPF32[i7 >> 2] = Math_fround(f19 - f18);
  HEAPF32[i7 + 4 >> 2] = f17;
  HEAPF32[i7 + 8 >> 2] = f16;
  HEAPF32[i7 + 12 >> 2] = f15;
  HEAPF32[i7 + 16 >> 2] = f14;
  HEAPF32[i7 + 20 >> 2] = f13;
 }
 i9 = i6 & 1;
 i4 = HEAP32[i10 + 12 + (i9 << 2) >> 2] | 0;
 mftCall_iiiiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i11 | 0, i7 | 0, i8 | 0, 1) | 0;
 i4 = i10 + 20 + (i9 << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i10 + 28 + (i9 * 12 | 0) | 0;
 i5 = i10 + 28 + (i9 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i1 << 5 >>> 0 > i2 >>> 0) {
  i10 = i2;
  i8 = i10 & 31;
  i8 = 1 << i8;
  i8 = ~i8;
  i10 = i10 >>> 5;
  i7 = HEAP32[i4 >> 2] | 0;
  i10 = i7 + (i10 << 2) | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i8 = i7 & i8;
  HEAP32[i10 >> 2] = i8;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 << 2;
  i11 = i9 | i11;
  i11 = i11 | 2;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i1 << 6 >>> 0 < 1024 ? 32 : i1 << 1 & 134217726;
 if (i6 >>> 0 <= (i1 & 2147483647) >>> 0) {
  i10 = i2;
  i8 = i10 & 31;
  i8 = 1 << i8;
  i8 = ~i8;
  i10 = i10 >>> 5;
  i7 = HEAP32[i4 >> 2] | 0;
  i10 = i7 + (i10 << 2) | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i8 = i7 & i8;
  HEAP32[i10 >> 2] = i8;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 << 2;
  i11 = i9 | i11;
  i11 = i11 | 2;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = i10 + 28 + (i9 * 12 | 0) + 8 | 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i6 << 2, gb + 769739 | 0, 329) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 | 0) {
  _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i4 >> 2] | 0);
 }
 i10 = HEAP32[i5 >> 2] | 0;
 _memset(i2 + ((i10 & 2147483647) << 2) | 0, 0, i6 - i10 << 2 | 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i5 >> 2] = i6;
 i10 = HEAP32[i11 >> 2] | 0;
 i8 = i10 & 31;
 i8 = 1 << i8;
 i8 = ~i8;
 i10 = i10 >>> 5;
 i7 = HEAP32[i4 >> 2] | 0;
 i10 = i7 + (i10 << 2) | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = i7 & i8;
 HEAP32[i10 >> 2] = i8;
 i11 = HEAP32[i11 >> 2] | 0;
 i11 = i11 << 2;
 i11 = i9 | i11;
 i11 = i11 | 2;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN27AnimatorControllerParameter8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i6, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31AnimatorControllerParameterTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i6 + 16 | 0, gb + 913271 | 0, 0);
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 913278 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 913293 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 913306 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 905632 | 0, gb + 913320 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI18AnimatorControllerE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN11SoundHandle8InstanceD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 16 | 0;
 i2 = i9;
 i6 = i9 + 32 | 0;
 i7 = i5 + 28 | 0;
 i8 = i5 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i7 | 0)) do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!(HEAP8[i1 + 239 >> 0] | 0)) __ZN20SoundChannelInstance4StopEv(i1); else {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63328 | 0);
  }
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != (i7 | 0));
 i4 = i5 + 120 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 + 16 >> 2] = 0;
  i10 = i1 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  if (!(HEAP32[i10 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i5 + 108 | 0;
 i10 = HEAP32[i5 + 104 >> 2] | 0;
 HEAP32[i10 + 108 >> 2] = HEAP32[i1 >> 2];
 HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] = i10;
 i1 = HEAP32[i5 + 36 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i5 + 40 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZN4FMOD5Sound7releaseEv(i1) | 0;
   if (i1 | 0) {
    i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
    HEAP32[i3 >> 2] = gb + 853741;
    HEAP32[i3 + 4 >> 2] = 127;
    HEAP32[i3 + 8 >> 2] = gb + 853899;
    HEAP32[i3 + 12 >> 2] = i10;
    __Z6FormatPKcz(i6, gb + 883334 | 0, i3);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   }
  }
 } else {
  i1 = __ZN4FMOD5Sound7releaseEv(i1) | 0;
  if (i1 | 0) {
   i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i2 >> 2] = gb + 853741;
   HEAP32[i2 + 4 >> 2] = 125;
   HEAP32[i2 + 8 >> 2] = gb + 853882;
   HEAP32[i2 + 12 >> 2] = i10;
   __Z6FormatPKcz(i6, gb + 883334 | 0, i2);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i10 = i5 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i7 | 0)) do {
  i10 = i1 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 } while ((i1 | 0) != (i7 | 0));
 HEAP32[i8 >> 2] = i7;
 HEAP32[i7 >> 2] = i7;
 i2 = i5 + 96 | 0;
 i3 = i5 + 100 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i10 = i1 + 4 | 0;
  i11 = i1;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 HEAP32[gb + 1459904 >> 2] = (HEAP32[gb + 1459904 >> 2] | 0) + -1;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + -1;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  if (!(HEAP32[i11 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i5 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E(i7, i1, i4, i3, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var f2 = f0, i5 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i4 + 32 | 0;
 switch (HEAP8[i3 + 50 >> 0] | 0) {
 case 1:
 case 4:
  {
   i3 = HEAP32[i3 + 52 >> 2] | 0;
   __ZN5physx2Cm27getDynamicGlobalPoseAlignedERKNS_11PxTransformES3_S3_RS1_(i3 + 16 | 0, i1, i3 + 48 | 0, i5);
   break;
  }
 default:
  {
   i3 = HEAP32[i3 + 52 >> 2] | 0;
   f23 = Math_fround(HEAPF32[i3 + 32 >> 2]);
   f13 = Math_fround(HEAPF32[i3 + 36 >> 2]);
   f12 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   i3 = i3 + 16 | 0;
   f22 = Math_fround(HEAPF32[i3 >> 2]);
   f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i3 + 12 >> 2]);
   f20 = Math_fround(HEAPF32[i4 + 48 >> 2]);
   f14 = Math_fround(HEAPF32[i4 + 52 >> 2]);
   f16 = Math_fround(HEAPF32[i4 + 56 >> 2]);
   f9 = Math_fround(HEAPF32[i1 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f2 = Math_fround(Math_fround(f18 * f24) - Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f17 * f19)) + Math_fround(f15 * f21)));
   f11 = Math_fround(Math_fround(f22 * f24) + Math_fround(Math_fround(f18 * f9) + Math_fround(Math_fround(f17 * f21) - Math_fround(f15 * f19))));
   f10 = Math_fround(Math_fround(f17 * f24) + Math_fround(Math_fround(f18 * f19) + Math_fround(Math_fround(f15 * f9) - Math_fround(f22 * f21))));
   f9 = Math_fround(Math_fround(f15 * f24) + Math_fround(Math_fround(f18 * f21) + Math_fround(Math_fround(f22 * f19) - Math_fround(f17 * f9))));
   f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
   f21 = Math_fround(Math_fround(Math_fround(f22 * f20) + Math_fround(f17 * f14)) + Math_fround(f15 * f16));
   f13 = Math_fround(f13 + Math_fround(Math_fround(Math_fround(f17 * f21) + Math_fround(Math_fround(f14 * f19) + Math_fround(f18 * Math_fround(Math_fround(f15 * f20) - Math_fround(f22 * f16))))) * Math_fround(2.0)));
   f12 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(Math_fround(f19 * f16) + Math_fround(f18 * Math_fround(Math_fround(f22 * f14) - Math_fround(f17 * f20)))) + Math_fround(f15 * f21)) * Math_fround(2.0)));
   HEAPF32[i5 + 16 >> 2] = Math_fround(f23 + Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14))))) * Math_fround(2.0)));
   HEAPF32[i5 + 20 >> 2] = f13;
   HEAPF32[i5 + 24 >> 2] = f12;
   HEAPF32[i5 >> 2] = f11;
   HEAPF32[i5 + 4 >> 2] = f10;
   HEAPF32[i5 + 8 >> 2] = f9;
   HEAPF32[i5 + 12 >> 2] = f2;
  }
 }
 f2 = Math_fround(HEAPF32[i4 + 60 >> 2]);
 i1 = i4 + 68 | 0;
 if (!i8) {
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1, i7, i5, f2, 0);
  STACKTOP = i6;
  return;
 } else {
  __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1, i8, i5, Math_fround(0.0), 0);
  f24 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f2);
  f23 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f2);
  f22 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) - f2);
  HEAPF32[i7 >> 2] = f24;
  HEAPF32[i7 + 4 >> 2] = f23;
  HEAPF32[i7 + 8 >> 2] = f22;
  f22 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 12 >> 2]));
  f23 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 16 >> 2]));
  f24 = Math_fround(f2 + Math_fround(HEAPF32[i8 + 20 >> 2]));
  HEAPF32[i7 + 12 >> 2] = f22;
  HEAPF32[i7 + 16 >> 2] = f23;
  HEAPF32[i7 + 20 >> 2] = f24;
  STACKTOP = i6;
  return;
 }
}

function __ZN20ArchiveStorageReader28AcquireAndPrefillUnusedBlockEjPNS_11CacheResultE(i16, i14, i15) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17;
 i10 = i16 + 2388 | 0;
 i12 = i16 + 2364 | 0;
 i13 = i16 + 2376 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) i11 = 13; else {
  i8 = HEAP32[i12 >> 2] | 0;
  i7 = 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   i6 = HEAP32[i8 + (i7 << 2) >> 2] | 0;
   i5 = i6 + 32 | 0;
   L5 : do if (!(HEAP32[i5 >> 2] | 0)) {
    HEAP32[i5 >> 2] = 1;
    i2 = i6 + 28 | 0;
    do if (!(HEAP32[i2 >> 2] | 0)) {
     HEAP32[i2 >> 2] = 0;
     i4 = i1;
     i2 = i6 + 36 | 0;
     if (i1 | 0) {
      if ((i3 | 0) <= (HEAP32[i2 >> 2] | 0)) break;
      HEAP32[i4 + 32 >> 2] = 0;
     }
     i3 = HEAP32[i2 >> 2] | 0;
     i1 = i6;
     break L5;
    } while (0);
    HEAP32[i5 >> 2] = 0;
   } while (0);
   i7 = i7 + 1 | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } while (i7 >>> 0 < i2 >>> 0);
  if ((i1 | 0) == 0 | (i2 | 0) == 0) i11 = 13; else __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj(i16, i1, i14);
 }
 if ((i11 | 0) == 13) {
  i3 = __ZnwjRK10MemLabelIdiPKci(72, gb + 63552 | 0, 16, gb + 489692 | 0, 625) | 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i1 = i9;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i3 + 12 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i3 + 44 >> 2] = 0;
  HEAP32[i3 + 56 >> 2] = 0;
  HEAP32[i3 + 60 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i5 = i9;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i3 + 48 | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i3;
  HEAP32[i3 >> 2] = -1;
  HEAP32[i3 + 4 >> 2] = -1;
  HEAP32[i3 + 40 >> 2] = 0;
  i4 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i4 + 1;
  HEAP32[i3 + 36 >> 2] = i4;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i3 + 32 >> 2] = 1;
  __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj(i16, i3, i14);
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i16 + 2380 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 2, 4, i16 + 2368 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i16 + 2368 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i12 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i13 >> 2] = i4;
  HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i1;
 }
 i4 = i1 + 28 | 0;
 HEAP32[i4 >> 2] = 1;
 i2 = i16 + 104 | 0;
 if (!(HEAP16[(HEAP32[i2 >> 2] | 0) + (i14 * 12 | 0) + 8 >> 1] & 64)) i3 = __ZN20ArchiveStorageReader20FillChunkCachedBlockEPNS_11CachedBlockE(i16, i1) | 0; else i3 = __ZN20ArchiveStorageReader21FillStreamCachedBlockEPNS_11CachedBlockE(i16, i1) | 0;
 if (i15 | 0) HEAP32[i15 >> 2] = i3;
 if ((i3 | 0) >= 0) {
  i2 = HEAP16[(HEAP32[i2 >> 2] | 0) + (i14 * 12 | 0) + 8 >> 1] | 0;
  if (!((i3 | 0) == 1 & (i2 & 64) == 0)) {
   if (i2 & 64) {
    i16 = i1;
    STACKTOP = i17;
    return i16 | 0;
   }
   HEAP32[i1 + 32 >> 2] = 0;
   i16 = i1;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj(i16, i1, -1);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 HEAP32[i1 + 32 >> 2] = 0;
 i16 = 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN8Animator16InitializeAvatarEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 i7 = i8 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  i9 = i8 + 124 | 0;
  __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb(i8, i7, i9, 0);
  STACKTOP = i10;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i11 + 28 >> 2] | 0;
   i4 = HEAP32[i11 + 32 >> 2] | 0;
   i1 = i11;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 9;
 }
 if ((i9 | 0) == 7) i9 = 9;
 do if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i9 = 0;
  i11 = i8 + 124 | 0;
  __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb(i8, i9, i11, 0);
  STACKTOP = i10;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i4 = __ZN6Avatar8GetAssetEv(i1) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 24; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 24; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 26;
  }
 }
 if ((i9 | 0) == 24) i9 = 26;
 if ((i9 | 0) == 26) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 __ZN8UserList7AddUserER12UserListNode(i1 + 76 | 0, i8 + 468 | 0);
 i9 = i4;
 i11 = i8 + 124 | 0;
 __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb(i8, i9, i11, 0);
 STACKTOP = i10;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i20 = i8 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i8 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i8 + 12 | 0;
 i23 = i5 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i8 + 20 | 0;
 i21 = i5 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i4 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i4;
 HEAP8[i22 >> 0] = i20;
 i22 = i5 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i4 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i4 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i4 = i21;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i4 + 4 >> 2] = i19;
 i4 = i18;
 HEAP32[i4 >> 2] = i17;
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 65;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function runPostSets65() {
 HEAP32[gb + 71864 >> 2] = fb + 4;
 HEAP32[gb + 71868 >> 2] = fb + 3;
 HEAP32[gb + 71872 >> 2] = fb + 5;
 HEAP32[gb + 71876 >> 2] = fb + 4;
 HEAP32[gb + 71880 >> 2] = fb + 6;
 HEAP32[gb + 71884 >> 2] = fb + 4;
 HEAP32[gb + 71888 >> 2] = fb + 7;
 HEAP32[gb + 71892 >> 2] = fb + 4;
 HEAP32[gb + 71896 >> 2] = fb + 8;
 HEAP32[gb + 71900 >> 2] = fb + 4;
 HEAP32[gb + 73344 >> 2] = (HEAP32[gb + 73344 >> 2] | 0) + (gb + 1088336 | 0);
 HEAP32[gb + 73356 >> 2] = fb + 817;
 HEAP32[gb + 73360 >> 2] = fb + 818;
 HEAP32[gb + 73364 >> 2] = fb + 84;
 HEAP32[gb + 73368 >> 2] = fb + 45;
 HEAP32[gb + 73372 >> 2] = fb + 664;
 HEAP32[gb + 73376 >> 2] = fb + 21;
 HEAP32[gb + 73380 >> 2] = fb + 148;
 HEAP32[gb + 73384 >> 2] = fb + 149;
 HEAP32[gb + 73388 >> 2] = fb + 64;
 HEAP32[gb + 73392 >> 2] = fb + 65;
 HEAP32[gb + 73396 >> 2] = fb + 66;
 HEAP32[gb + 73400 >> 2] = fb + 67;
 HEAP32[gb + 73404 >> 2] = fb + 68;
 HEAP32[gb + 73408 >> 2] = fb + 69;
 HEAP32[gb + 73412 >> 2] = fb + 70;
 HEAP32[gb + 73416 >> 2] = fb + 6;
 HEAP32[gb + 73420 >> 2] = fb + 7;
 HEAP32[gb + 73424 >> 2] = fb + 47;
 HEAP32[gb + 73428 >> 2] = fb + 43;
 HEAP32[gb + 73432 >> 2] = fb + 48;
 HEAP32[gb + 73436 >> 2] = fb + 150;
 HEAP32[gb + 73440 >> 2] = fb + 151;
 HEAP32[gb + 73444 >> 2] = fb + 152;
 HEAP32[gb + 73448 >> 2] = fb + 49;
 HEAP32[gb + 73452 >> 2] = fb + 71;
 HEAP32[gb + 73456 >> 2] = (HEAP32[gb + 73456 >> 2] | 0) + (gb + 1188616 | 0);
 HEAP32[gb + 73460 >> 2] = (HEAP32[gb + 73460 >> 2] | 0) + (gb + 1477636 | 0);
 HEAP32[gb + 73488 >> 2] = (HEAP32[gb + 73488 >> 2] | 0) + (gb + 584063 | 0);
 HEAP32[gb + 73492 >> 2] = (HEAP32[gb + 73492 >> 2] | 0) + (gb + 584076 | 0);
 HEAP32[gb + 73496 >> 2] = (HEAP32[gb + 73496 >> 2] | 0) + (gb + 584095 | 0);
 HEAP32[gb + 73532 >> 2] = fb + 697;
 HEAP32[gb + 73536 >> 2] = fb + 819;
 HEAP32[gb + 73548 >> 2] = fb + 697;
 HEAP32[gb + 73552 >> 2] = fb + 820;
 HEAP32[gb + 73564 >> 2] = fb + 697;
 HEAP32[gb + 73568 >> 2] = fb + 821;
 HEAP32[gb + 73572 >> 2] = fb + 85;
 HEAP32[gb + 73576 >> 2] = fb + 86;
 HEAP32[gb + 73580 >> 2] = fb + 368;
 HEAP32[gb + 73584 >> 2] = fb + 369;
 HEAP32[gb + 73588 >> 2] = fb + 370;
 HEAP32[gb + 73592 >> 2] = fb + 371;
 HEAP32[gb + 73596 >> 2] = fb + 372;
 HEAP32[gb + 73600 >> 2] = fb + 373;
 HEAP32[gb + 73604 >> 2] = fb + 153;
 HEAP32[gb + 73608 >> 2] = fb + 87;
 HEAP32[gb + 73612 >> 2] = fb + 822;
 HEAP32[gb + 73624 >> 2] = fb + 823;
 HEAP32[gb + 73628 >> 2] = fb + 824;
 HEAP32[gb + 73632 >> 2] = fb + 88;
 HEAP32[gb + 73636 >> 2] = fb + 89;
 HEAP32[gb + 73640 >> 2] = fb + 374;
 HEAP32[gb + 73644 >> 2] = fb + 375;
 HEAP32[gb + 73648 >> 2] = fb + 376;
 HEAP32[gb + 73652 >> 2] = fb + 377;
 HEAP32[gb + 73656 >> 2] = fb + 372;
 HEAP32[gb + 73660 >> 2] = fb + 378;
 HEAP32[gb + 73664 >> 2] = fb + 154;
 HEAP32[gb + 73668 >> 2] = fb + 90;
 HEAP32[gb + 73672 >> 2] = fb + 825;
 HEAP32[gb + 73784 >> 2] = fb + 826;
 HEAP32[gb + 73788 >> 2] = fb + 827;
 HEAP32[gb + 73792 >> 2] = fb + 46;
 HEAP32[gb + 73796 >> 2] = fb + 14;
 HEAP32[gb + 73800 >> 2] = fb + 23;
 HEAP32[gb + 73804 >> 2] = fb + 15;
 HEAP32[gb + 73808 >> 2] = fb + 24;
 HEAP32[gb + 73812 >> 2] = fb + 155;
 HEAP32[gb + 73816 >> 2] = fb + 24;
 HEAP32[gb + 73820 >> 2] = fb + 156;
 HEAP32[gb + 73824 >> 2] = fb + 47;
 HEAP32[gb + 73828 >> 2] = fb + 157;
 HEAP32[gb + 73832 >> 2] = fb + 158;
 HEAP32[gb + 73836 >> 2] = fb + 61;
 HEAP32[gb + 73840 >> 2] = fb + 159;
 HEAP32[gb + 73844 >> 2] = fb + 665;
 HEAP32[gb + 73848 >> 2] = fb + 666;
 HEAP32[gb + 73852 >> 2] = fb + 379;
 HEAP32[gb + 73856 >> 2] = fb + 67;
 HEAP32[gb + 73860 >> 2] = fb + 123;
 HEAP32[gb + 73864 >> 2] = fb + 160;
 HEAP32[gb + 73868 >> 2] = fb + 124;
 HEAP32[gb + 73872 >> 2] = fb + 125;
 HEAP32[gb + 73876 >> 2] = fb + 54;
 HEAP32[gb + 73880 >> 2] = fb + 126;
 HEAP32[gb + 73884 >> 2] = fb + 3;
 HEAP32[gb + 73888 >> 2] = fb + 40;
 HEAP32[gb + 73892 >> 2] = fb + 127;
 HEAP32[gb + 73896 >> 2] = fb + 161;
 runPostSets66();
}

function __ZN5physx2Cm12RenderBuffer5shiftERKNS_6PxVec3E(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, f9 = f0;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = i7 + 4 | 0;
  i4 = i7 + 8 | 0;
  i5 = 0;
  do {
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i2 + (i5 << 4) | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i2 + (i5 << 4) + 4 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i4 >> 2]);
   i8 = i2 + (i5 << 4) + 8 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 if (i4 | 0) {
  i1 = HEAP32[i6 + 16 >> 2] | 0;
  i2 = i7 + 4 | 0;
  i3 = i7 + 8 | 0;
  i5 = 0;
  do {
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i1 + (i5 << 5) | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   i8 = i1 + (i5 << 5) + 4 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i1 + (i5 << 5) + 8 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i1 + (i5 << 5) + 16 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   i8 = i1 + (i5 << 5) + 20 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i1 + (i5 << 5) + 24 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i4 >>> 0);
 }
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i3 = i7 + 4 | 0;
  i4 = i7 + 8 | 0;
  i5 = 0;
  do {
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i2 + (i5 * 48 | 0) | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 4 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i4 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 8 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 16 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 20 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i4 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 24 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i7 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 32 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 36 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   f9 = Math_fround(HEAPF32[i4 >> 2]);
   i8 = i2 + (i5 * 48 | 0) + 40 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 i5 = HEAP32[i6 + 44 >> 2] | 0;
 if (!i5) return;
 i1 = HEAP32[i6 + 40 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i4 = 0;
 do {
  f9 = Math_fround(HEAPF32[i7 >> 2]);
  i8 = i1 + (i4 * 24 | 0) | 0;
  HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  i8 = i1 + (i4 * 24 | 0) + 4 | 0;
  HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  i8 = i1 + (i4 * 24 | 0) + 8 | 0;
  HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i5 >>> 0);
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignINS_11__wrap_iterIPK8UnityStrEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISG_E9referenceEEE5valueEvE4typeESG_SG_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i6 = i4 - i3 >> 4;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i2 = i3;
 i3 = i5;
 i10 = i4;
 if (i6 >>> 0 > ((i1 - i5 | 0) / 12 | 0) >>> 0) {
  if (i5) {
   i4 = i9 + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
    do {
     i8 = i1 + -12 | 0;
     HEAP32[i4 >> 2] = i8;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
     i1 = HEAP32[i4 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i9 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i1 = 0;
  }
  if (i6 >>> 0 > 357913941) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  } else i3 = 0;
  i8 = (i1 - i3 | 0) / 12 | 0;
  i3 = i8 << 1;
  i3 = i8 >>> 0 < 178956970 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 357913941;
  if (i3 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = __Znwj(i3 * 12 | 0) | 0;
  i4 = i9 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i1 + (i3 * 12 | 0);
  if ((i2 | 0) == (i10 | 0)) {
   STACKTOP = i11;
   return;
  }
  do {
   i9 = HEAP8[i2 + 11 >> 0] | 0;
   i7 = i9 << 24 >> 24 < 0;
   i8 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
   i9 = i7 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i8, i9);
   i2 = i2 + 16 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 12 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i10 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i9 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 12 | 0;
 i6 = i6 >>> 0 > i1 >>> 0;
 i1 = i6 ? i2 + (i1 << 4) | 0 : i4;
 if ((i2 | 0) == (i1 | 0)) i2 = i3; else {
  do {
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   if (i4 << 24 >> 24 < 0) {
    i5 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
   } else {
    i5 = i2;
    i4 = i4 & 255;
   };
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i8) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i2 = i2 + 16 | 0;
   i3 = i3 + 12 | 0;
  } while ((i2 | 0) != (i1 | 0));
  i2 = i3;
 }
 if (!i6) {
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   STACKTOP = i11;
   return;
  }
  do {
   i10 = i1 + -12 | 0;
   HEAP32[i7 >> 2] = i10;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 do {
  i9 = HEAP8[i1 + 11 >> 0] | 0;
  i6 = i9 << 24 >> 24 < 0;
  i8 = i6 ? HEAP32[i1 >> 2] | 0 : i1;
  i9 = i6 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i8, i9);
  i1 = i1 + 16 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 12 | 0;
  HEAP32[i7 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i12 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i14 = i10 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (((i3 - i1 | 0) / 52 | 0) >>> 0 >= i2 >>> 0) {
  i3 = HEAP32[gb + 1155204 >> 2] | 0;
  i4 = HEAP32[gb + 1155204 + 4 >> 2] | 0;
  i5 = HEAP32[gb + 1155204 + 8 >> 2] | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i1 + 12 >> 2] = i4;
   HEAP32[i1 + 16 >> 2] = i5;
   HEAP32[i1 + 20 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
   i13 = i1 + 32 | 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i13 + 12 >> 2] = 0;
   HEAP32[i13 + 16 >> 2] = 0;
   i1 = (HEAP32[i14 >> 2] | 0) + 52 | 0;
   HEAP32[i14 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 52 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 52 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 1073741823 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i13 >> 2] | 0;
  HEAP32[i11 >> 2] = 16;
  HEAP32[i11 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 52 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (((i1 - i4 | 0) / 52 | 0) * 52 | 0) | 0;
 i8 = i3;
 i4 = i6 + (i5 * 52 | 0) | 0;
 i5 = HEAP32[gb + 1155204 >> 2] | 0;
 i6 = HEAP32[gb + 1155204 + 4 >> 2] | 0;
 i7 = HEAP32[gb + 1155204 + 8 >> 2] | 0;
 i9 = i8;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 + 12 >> 2] = i6;
  HEAP32[i1 + 16 >> 2] = i7;
  HEAP32[i1 + 20 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
  i16 = i1 + 32 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i16 + 8 >> 2] = 0;
  HEAP32[i16 + 12 >> 2] = 0;
  HEAP32[i16 + 16 >> 2] = 0;
  i1 = i9 + 52 | 0;
  i9 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i8; else {
  i4 = i2;
  i2 = i8;
  do {
   i8 = i4;
   i4 = i4 + -52 | 0;
   i6 = i4;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i16 = i3 + -52 | 0;
   HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i16 + 4 >> 2] = i7;
   HEAP32[i3 + -44 >> 2] = HEAP32[i8 + -44 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i8 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i8 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i8 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i8 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i8 + -24 >> 2];
   i16 = i3 + -20 | 0;
   i8 = i8 + -20 | 0;
   HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i16 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i16 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i16 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i16 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i3 = i2 + -52 | 0;
   i2 = i3;
  } while ((i4 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i14 >> 2] = i9;
 HEAP32[i12 >> 2] = i5;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i11 >> 2] = 16;
 HEAP32[i11 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i15;
 return;
}

function __ZNSt3__24listIP19CloudServiceHandler13stl_allocatorIS2_L18MemLabelIdentifier85ELi16EEE6removeERKS2_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAP32[i15 >> 2] = i15;
 i11 = i15 + 4 | 0;
 HEAP32[i11 >> 2] = i15;
 i12 = i15 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i13;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i9 | 0)) {
  i8 = i9 + 8 | 0;
  if ((i15 | 0) == (i9 | 0)) {
   i5 = i2;
   while (1) {
    i4 = HEAP32[i1 + 8 >> 2] | 0;
    i2 = i5 + 4 | 0;
    if ((i4 | 0) == (HEAP32[i10 >> 2] | 0)) {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = i3;
     L8 : do if ((i3 | 0) == (i9 | 0)) {
      i4 = 0;
      i3 = i9;
     } else while (1) {
      if ((HEAP32[i2 + 8 >> 2] | 0) != (i4 | 0)) {
       i4 = 1;
       break L8;
      }
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = i2;
      if ((i3 | 0) == (i9 | 0)) {
       i4 = 0;
       i3 = i9;
       break;
      }
     } while (0);
     if ((i5 | 0) != (i3 | 0)) {
      i7 = HEAP32[i2 >> 2] | 0;
      i8 = i7 + 4 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      HEAP32[i6 + 4 >> 2] = HEAP32[i8 >> 2];
      HEAP32[HEAP32[i8 >> 2] >> 2] = i6;
      i6 = HEAP32[i15 >> 2] | 0;
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i6;
      HEAP32[i15 >> 2] = i7;
      HEAP32[i8 >> 2] = i15;
     }
     if (i4) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i2;
    } else i1 = HEAP32[i2 >> 2] | 0;
    i5 = i1;
    if ((i5 | 0) == (i9 | 0)) break L1;
   }
  }
  do {
   i6 = HEAP32[i1 + 8 >> 2] | 0;
   i3 = i2 + 4 | 0;
   if ((i6 | 0) == (HEAP32[i10 >> 2] | 0)) {
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = i5;
    L23 : do if ((i5 | 0) == (i9 | 0)) {
     i7 = 0;
     i4 = i9;
     i6 = i3;
    } else {
     i4 = i5;
     while (1) {
      if ((HEAP32[i3 + 8 >> 2] | 0) != (i6 | 0)) {
       i7 = 1;
       i6 = i3;
       break L23;
      }
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      i4 = i3;
      if ((i4 | 0) == (i9 | 0)) {
       i7 = 0;
       i4 = i9;
       i6 = i3;
       break;
      }
     }
    } while (0);
    if ((i2 | 0) != (i4 | 0)) {
     if ((i5 | 0) == (i4 | 0)) i3 = 1; else {
      i3 = 1;
      do {
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i3 = i3 + 1 | 0;
      } while ((i5 | 0) != (i4 | 0));
     }
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i3;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
     i3 = HEAP32[i6 >> 2] | 0;
     i5 = i3 + 4 | 0;
     i17 = HEAP32[i2 >> 2] | 0;
     HEAP32[i17 + 4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[HEAP32[i5 >> 2] >> 2] = i17;
     i17 = HEAP32[i15 >> 2] | 0;
     HEAP32[i17 + 4 >> 2] = i2;
     HEAP32[i1 >> 2] = i17;
     HEAP32[i15 >> 2] = i3;
     HEAP32[i5 >> 2] = i15;
    }
    if (i7) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = i6;
   } else i1 = HEAP32[i3 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i9 | 0));
 } while (0);
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i17 = (HEAP32[i15 >> 2] | 0) + 4 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[HEAP32[i17 >> 2] >> 2] = i11;
 HEAP32[i12 >> 2] = 0;
 if ((i2 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i15 + 12 | 0;
 i4 = i14 + 4 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = 85;
 HEAP32[i4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 do {
  i13 = HEAP32[i3 >> 2] | 0;
  i17 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i14 >> 2] = 85;
  HEAP32[i4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i14);
 } while ((i1 | 0) != (i15 | 0));
 STACKTOP = i16;
 return;
}

function __ZN11Rigidbody2D6CreateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 28 | 0;
 i4 = i8 + 16 | 0;
 i5 = i8;
 i6 = i7 + 92 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 i2 = i3 + 4 | 0;
 i1 = i3 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i1 >> 0] = 1;
 i2 = i3 + 37 | 0;
 HEAP8[i2 >> 0] = 1;
 i9 = HEAP32[i7 + 68 >> 2] | 0;
 HEAP32[i3 >> 2] = (i9 | 0) == 0 ? 2 : (i9 | 0) == 1 & 1;
 HEAP32[i3 + 44 >> 2] = i7;
 HEAP8[i3 + 39 >> 0] = (HEAP32[i7 + 64 >> 2] | 0) == 1 & 1;
 HEAP32[i3 + 28 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i7 + 44 >> 2];
 HEAP8[i3 + 38 >> 0] = (HEAP32[i7 + 52 >> 2] | 0) >>> 2 & 1;
 HEAP8[i3 + 40 >> 0] = HEAP8[i7 + 48 >> 0] | 0;
 if ((i9 | 0) == 2) {
  HEAP8[i1 >> 0] = 1;
  i1 = 0;
 } else {
  i9 = HEAP32[i7 + 60 >> 2] | 0;
  HEAP8[i1 >> 0] = (i9 | 0) != 0 & 1;
  i1 = (i9 | 0) != 2 & 1;
 }
 HEAP8[i2 >> 0] = i1;
 i2 = i7 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0;
  __ZNK9Transform11GetPositionEv(i4, i9);
  __ZNK9Transform11GetRotationEv(i5, i9);
  i9 = i7 + 156 | 0;
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i9 = i7 + 168 | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i9 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 8 >> 2] = i9;
  f10 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  i9 = f10 < Math_fround(0.0);
  f12 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f13 = Math_fround(-f12);
  f11 = Math_fround(-f10);
  HEAPF32[i3 + 12 >> 2] = Math_fround(Math_fround(+Math_atan2(+(i9 ? f13 : f12), +(i9 ? f11 : f10))) * Math_fround(2.0));
 }
 i4 = __ZN7b2World10CreateBodyEPK9b2BodyDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i3) | 0;
 HEAP32[i6 >> 2] = i4;
 __ZN6b2Body13ResetMassDataEv(i4);
 HEAP8[i7 + 225 >> 0] = 0;
 i4 = i7 + 128 | 0;
 i3 = i7 + 184 | 0;
 i9 = i7 + 156 | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i4 = i7 + 140 | 0;
 i9 = i7 + 196 | 0;
 i3 = i7 + 168 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i4 = HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
 i2 = __Z17GetTransformDepthR9Transform(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0) | 0;
 i2 = i4 + 68 + (((i2 | 0) < 63 ? i2 : 63) << 3) | 0;
 i3 = i7 + 104 | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i7 + 108 | 0; else {
   i9 = i7 + 108 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i1 = i9;
  }
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i9 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 }
 HEAP8[i4 + 625 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i10, i2, i13) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i8 = i13 - i2 | 0;
 i9 = (i8 | 0) / 172 | 0;
 i11 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (i9 >>> 0 <= ((i1 - i4 | 0) / 172 | 0) >>> 0) {
  i7 = i10 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 172 | 0;
  i6 = i9 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 172 | 0) | 0;
  i4 = i6 ? i1 : i13;
  if ((i4 | 0) == (i2 | 0)) i5 = i3; else {
   do {
    __ZN13AnimationClip12Vector3CurveaSERKS0_(i3, i2) | 0;
    i2 = i2 + 172 | 0;
    i3 = i3 + 172 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i5 = i3;
  }
  if (i6) {
   if ((i4 | 0) == (i13 | 0)) {
    STACKTOP = i14;
    return;
   }
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    __ZN13AnimationClip12Vector3CurveC2ERKS0_(i2, i1);
    i1 = i1 + 172 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 172 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i13 | 0));
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i14;
   return;
  }
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -172 | 0;
   HEAP32[i7 >> 2] = i2;
   i3 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -160 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
   }
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (i5 | 0));
  STACKTOP = i14;
  return;
 }
 if (i4) {
  i7 = i10 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i4; else {
   i6 = i12 + 4 | 0;
   do {
    i4 = i1 + -172 | 0;
    HEAP32[i7 >> 2] = i4;
    i5 = i1 + -36 | 0;
    if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1 + -32 | 0);
     HEAP32[i5 >> 2] = 0;
    }
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i5 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i1 + -160 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i6 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
    }
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i8 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 172 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 172 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 * 172 | 0);
 if ((i2 | 0) == (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1, i2);
  i2 = i2 + 172 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 172 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i13 | 0));
 STACKTOP = i14;
 return;
}

function __Z16MarkDependenciesR27GarbageCollectorThreadStatej(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i1 = i5 + (i2 << 3) | 0;
 i2 = HEAP32[i5 + (i2 << 3) + 4 >> 2] | 0;
 switch (i2 & 536870911 | 0) {
 case 1:
  {
   if (!(i2 & 1073741824)) return;
   __ZNK10GameObject38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   return;
  }
 case 4:
  {
   if (i2 & 1073741824 | 0) __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 80 >> 2] | 0;
   i6 = HEAP32[i2 + 92 >> 2] | 0;
   i3 = i1 + (i6 << 2) | 0;
   if (i6 | 0) do {
    __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i7);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i2 + 100 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(i1, i7);
   return;
  }
 case 23:
  {
   if (i2 & 1073741824 | 0) __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 288 >> 2] | 0;
   i6 = HEAP32[i2 + 300 >> 2] | 0;
   i3 = i1 + (i6 << 2) | 0;
   if (i6 | 0) do {
    __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i3 | 0));
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i2 + 280 >> 2] | 0, i7);
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i2 + 380 >> 2] | 0, i7);
   return;
  }
 case 33:
  {
   if (i2 & 1073741824 | 0) __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i7);
   return;
  }
 case 21:
  {
   __ZNK8Material16MarkDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   return;
  }
 case 64:
  {
   if (i2 & 1073741824 | 0) __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   i6 = HEAP32[i1 >> 2] | 0;
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i6 + 32 >> 2] | 0, i7);
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i6 + 64 >> 2] | 0, i7);
   return;
  }
 case 65:
  {
   if (i2 & 1073741824 | 0) __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(HEAP32[i1 >> 2] | 0, i7);
   __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i7);
   return;
  }
 case 114:
  {
   i4 = HEAP32[i1 >> 2] | 0;
   if (!(i2 & 1073741824)) i2 = i3; else {
    __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(i4, i7);
    i2 = HEAP32[i6 >> 2] | 0;
   }
   if (HEAP8[i2 + 104 >> 0] | 0) {
    __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i4 + 36 >> 2] | 0, i7);
    i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 >> 2] | 0) | 0;
    if (i2 | 0) __Z40scripting_liveness_calculation_from_rootP12Il2CppObjectPv(i2, HEAP32[i7 >> 2] | 0);
    i5 = i4 + 64 | 0;
    i2 = HEAP32[i4 + 68 >> 2] | 0;
    i3 = i2;
    if ((i3 | 0) != (i5 | 0)) do {
     __Z40scripting_liveness_calculation_from_rootP12Il2CppObjectPv(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i7 >> 2] | 0);
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i3 = i2;
    } while ((i3 | 0) != (i5 | 0));
   }
   if (HEAP8[(HEAP32[i6 >> 2] | 0) + 104 >> 0] | 0) return;
   break;
  }
 default:
  {}
 }
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 72 >> 2] | 0, i6 | 0, i7 + 36 | 0);
 return;
}

function __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i3 = i11 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 72 | 0) + 1 | 0;
 if (i4 >>> 0 > 59652323) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i12 = ((HEAP32[i11 + 8 >> 2] | 0) - i2 | 0) / 72 | 0;
 i3 = i12 << 1;
 i3 = i12 >>> 0 < 29826161 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 59652323;
 i1 = (i1 - i2 | 0) / 72 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i11 + 8;
 if (!i3) i2 = 0; else i2 = __Znwj(i3 * 72 | 0) | 0;
 HEAP32[i13 >> 2] = i2;
 i9 = i2 + (i1 * 72 | 0) | 0;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = i9;
 i10 = i13 + 4 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i13 + 12 >> 2] = i2 + (i3 * 72 | 0);
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 44 >> 2] = HEAP32[i8 + 44 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 48 >> 2] = HEAP32[i8 + 48 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 52 >> 2] = HEAP32[i8 + 52 >> 2];
 HEAP32[i2 + (i1 * 72 | 0) + 56 >> 2] = HEAP32[i8 + 56 >> 2];
 i7 = i2 + (i1 * 72 | 0) + 60 | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i2 + (i1 * 72 | 0) + 64 >> 2] = i7;
 i5 = i2 + (i1 * 72 | 0) + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 60 | 0;
 i1 = HEAP32[i8 + 64 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  i3 = i7;
  i4 = 0;
  do {
   i15 = i1;
   i8 = i3;
   i3 = __Znwj(44) | 0;
   i18 = i15 + 8 | 0;
   i17 = HEAP32[i18 + 4 >> 2] | 0;
   i16 = i3 + 8 | 0;
   HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i16 + 4 >> 2] = i17;
   HEAP32[i3 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
   HEAP32[i3 + 32 >> 2] = HEAP32[i15 + 32 >> 2];
   HEAP32[i3 + 36 >> 2] = HEAP32[i15 + 36 >> 2];
   HEAP32[i3 + 40 >> 2] = HEAP32[i15 + 40 >> 2];
   HEAP32[i3 + 4 >> 2] = i7;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i8 + 4 >> 2] = i3;
   HEAP32[i7 >> 2] = i3;
   i4 = i4 + 1 | 0;
   HEAP32[i5 >> 2] = i4;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i6 | 0));
 }
 HEAP32[i12 >> 2] = i9 + 72;
 __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i11, i13);
 i5 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = i1 + -72 | 0;
  HEAP32[i12 >> 2] = i2;
  i4 = i1 + -12 | 0;
  i3 = i1 + -4 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i1 = i2; else {
   i1 = HEAP32[i1 + -8 >> 2] | 0;
   i18 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
   i17 = HEAP32[i1 >> 2] | 0;
   HEAP32[i17 + 4 >> 2] = HEAP32[i18 >> 2];
   HEAP32[HEAP32[i18 >> 2] >> 2] = i17;
   HEAP32[i3 >> 2] = 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
    do {
     i18 = i1;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     __ZdlPv(i18);
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i12 >> 2] | 0;
   }
  }
 } while ((i1 | 0) != (i5 | 0));
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN9InputAxisC2ERKS_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP32[i6 >> 2] = gb + 59740 + 8;
 i1 = i6 + 4 | 0;
 i3 = i8 + 4 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i8 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i7 = 6;
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 12 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 8 >> 2] = i4;
  i1 = i2;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i1 = i6 + 24 | 0;
 i3 = i8 + 24 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i8 + 28 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 36 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 36 >> 2] | 0;
  i7 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i7 = 12;
 } else i7 = 10;
 if ((i7 | 0) == 10) {
  i11 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i6 + 32 >> 2] = i11 | -2147483648;
  HEAP32[i6 + 28 >> 2] = i4;
  i1 = i10;
  i7 = 12;
 }
 if ((i7 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 40 | 0;
 i3 = i8 + 40 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i8 + 44 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 52 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 52 >> 2] | 0;
  i7 = 16;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i5 = i1;
   i5 = i5 + i4 | 0;
   HEAP8[i5 >> 0] = 0;
   i5 = i6 + 56 | 0;
   i1 = i8 + 56 | 0;
   i2 = i5;
   i3 = i1;
   i4 = i2 + 48 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP16[i5 + 48 >> 1] = HEAP16[i1 + 48 >> 1] | 0;
   STACKTOP = i9;
   return;
  }
 } else i7 = 16;
 if ((i7 | 0) == 16) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i6 + 48 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 44 >> 2] = i4;
  i1 = i11;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i5 = i1;
 i5 = i5 + i4 | 0;
 HEAP8[i5 >> 0] = 0;
 i5 = i6 + 56 | 0;
 i1 = i8 + 56 | 0;
 i2 = i5;
 i3 = i1;
 i4 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP16[i5 + 48 >> 1] = HEAP16[i1 + 48 >> 1] | 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx20PxsParticleSystemSim19initializeParameterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i2 = i1 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i1 + 124 >> 2] = f13;
 f10 = Math_fround(f13 * Math_fround(.00100000005));
 HEAPF32[i1 + 84 >> 2] = f10;
 f17 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f8 = Math_fround(f14 * f17);
 HEAPF32[i1 + 88 >> 2] = f8;
 f4 = Math_fround(Math_fround(1.0) / f8);
 HEAPF32[i1 + 92 >> 2] = f4;
 HEAPF32[i1 + 96 >> 2] = Math_fround(f8 * f8);
 i7 = HEAP32[i6 + 24 >> 2] | 0;
 i3 = 1 << i7;
 f5 = Math_fround(f8 * Math_fround(i3 | 0));
 HEAPF32[i1 + 100 >> 2] = f5;
 f17 = Math_fround(f17 * Math_fround(.100000001));
 f15 = Math_fround(f17 * f17);
 f9 = Math_fround(f15 * Math_fround(f15 * f15));
 f11 = Math_fround(Math_fround(315.0) / Math_fround(Math_fround(f17 * Math_fround(f15 * f9)) * Math_fround(201.061935)));
 f9 = Math_fround(f9 * Math_fround(3.14159274));
 f16 = Math_fround(Math_fround(22.5) / f9);
 HEAPF32[i1 + 104 >> 2] = f17;
 HEAPF32[i1 + 108 >> 2] = f15;
 f11 = Math_fround(f11 * f10);
 HEAPF32[i1 + 112 >> 2] = f11;
 f16 = Math_fround(f16 * f10);
 HEAPF32[i1 + 116 >> 2] = Math_fround(f16 * Math_fround(HEAPF32[i6 + 48 >> 2]));
 f11 = Math_fround(f15 * Math_fround(f15 * Math_fround(f15 * f11)));
 HEAPF32[i1 + 80 >> 2] = f11;
 f14 = Math_fround(Math_fround(.100000001) / f14);
 HEAPF32[i1 + 128 >> 2] = f14;
 HEAPF32[i1 + 132 >> 2] = Math_fround(f14 * f14);
 HEAPF32[i1 + 136 >> 2] = Math_fround(Math_fround(1.0) / f14);
 HEAP32[i1 + 144 >> 2] = i7;
 f11 = Math_fround(f13 - f11);
 i12 = f11 > Math_fround(0.0);
 f11 = Math_fround(Math_fround(1.0) / f11);
 HEAPF32[i1 + 140 >> 2] = i12 ? f11 : Math_fround(0.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) * Math_fround(Math_fround(45.0) / f9)));
 HEAPF32[i1 + 652 >> 2] = f8;
 HEAPF32[i1 + 656 >> 2] = f4;
 HEAP32[i1 + 660 >> 2] = i7;
 HEAP32[i1 + 664 >> 2] = i3;
 HEAPF32[i1 + 668 >> 2] = f5;
 HEAP32[i1 + 672 >> 2] = HEAP32[i6 + 56 >> 2];
 i3 = HEAP32[i6 + 60 >> 2] | 0;
 HEAP32[i1 + 676 >> 2] = i3;
 f5 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 HEAPF32[i1 + 680 >> 2] = f5;
 HEAPF32[i1 + 684 >> 2] = Math_fround(Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + Math_fround(.00100000005));
 i2 = HEAP32[i2 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 1104 >> 2]);
 f5 = Math_fround(f5 * f4);
 i3 = f5 < Math_fround(1.0);
 f5 = Math_fround(Math_fround(1.0) - f5);
 HEAPF32[i1 + 636 >> 2] = i3 ? f5 : Math_fround(0.0);
 HEAP32[i1 + 624 >> 2] = HEAP32[i1 + 1112 >> 2];
 HEAP32[i1 + 628 >> 2] = HEAP32[i1 + 1116 >> 2];
 HEAP32[i1 + 632 >> 2] = HEAP32[i1 + 1120 >> 2];
 HEAP32[i1 + 696 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i1 + 700 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i1 + 704 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i1 + 708 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAPF32[i1 + 688 >> 2] = f4;
 i3 = f4 > Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 HEAPF32[i1 + 692 >> 2] = i3 ? f4 : Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 i3 = f4 < Math_fround(0.0);
 f4 = i3 ? Math_fround(0.0) : f4;
 i3 = f4 > Math_fround(.949999988);
 HEAPF32[i1 + 640 >> 2] = i3 ? Math_fround(.949999988) : f4;
 f4 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 i3 = f4 < Math_fround(.00100000005);
 f4 = i3 ? Math_fround(.00100000005) : f4;
 i3 = f4 > Math_fround(1.0);
 HEAPF32[i1 + 644 >> 2] = i3 ? Math_fround(1.0) : f4;
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 HEAPF32[i1 + 648 >> 2] = Math_fround(f4 * f4);
 i3 = HEAP32[i2 + 84 >> 2] | 0;
 HEAP32[i1 + 716 >> 2] = (Math_imul(Math_imul(i3, 4999879) | 0, i3) | 0) & 65535;
 HEAP32[i1 + 712 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i3, i1, i12, i8, i13, i14) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18;
 i16 = i18 + 120 | 0;
 i17 = i18 + 96 | 0;
 i7 = i15 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i15 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i15 + 24 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i9 = i15 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i15 + 48 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i15 + 52 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 switch (HEAP32[i3 + 4 >> 2] | 0) {
 case 0:
  {
   HEAP32[i7 >> 2] = i3 + 12;
   HEAP32[i4 >> 2] = 1;
   HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
   break;
  }
 case 2:
  {
   HEAP32[i7 >> 2] = i3 + 20;
   HEAP32[i4 >> 2] = HEAP32[i3 + 148 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
   break;
  }
 case 4:
  {
   HEAP32[i7 >> 2] = i3 + 12;
   HEAP32[i4 >> 2] = 2;
   HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
   break;
  }
 case 3:
  {
   i6 = HEAP32[i3 + 12 >> 2] | 0;
   i20 = i6 + (i1 << 3) | 0;
   i19 = HEAP32[i20 + 4 >> 2] | 0;
   i2 = i15;
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i2 + 4 >> 2] = i19;
   i1 = i1 + 1 | 0;
   i2 = i15 + 8 | 0;
   if ((i1 | 0) < (HEAP32[i3 + 16 >> 2] | 0)) {
    i6 = i6 + (i1 << 3) | 0;
    i19 = HEAP32[i6 + 4 >> 2] | 0;
    i20 = i2;
    HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i20 + 4 >> 2] = i19;
   } else {
    i19 = HEAP32[i6 + 4 >> 2] | 0;
    i20 = i2;
    HEAP32[i20 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i20 + 4 >> 2] = i19;
   }
   HEAP32[i7 >> 2] = i15;
   HEAP32[i4 >> 2] = 2;
   HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
   break;
  }
 case 1:
  {
   HEAP32[i7 >> 2] = i3 + 12;
   HEAP32[i4 >> 2] = 2;
   HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
   break;
  }
 default:
  {}
 }
 i3 = i15 + 28 | 0;
 switch (HEAP32[i12 + 4 >> 2] | 0) {
 case 0:
  {
   HEAP32[i9 >> 2] = i12 + 12;
   HEAP32[i10 >> 2] = 1;
   HEAP32[i11 >> 2] = HEAP32[i12 + 8 >> 2];
   break;
  }
 case 2:
  {
   HEAP32[i9 >> 2] = i12 + 20;
   HEAP32[i10 >> 2] = HEAP32[i12 + 148 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i12 + 8 >> 2];
   break;
  }
 case 4:
  {
   HEAP32[i9 >> 2] = i12 + 12;
   HEAP32[i10 >> 2] = 2;
   HEAP32[i11 >> 2] = HEAP32[i12 + 8 >> 2];
   break;
  }
 case 3:
  {
   i4 = HEAP32[i12 + 12 >> 2] | 0;
   i20 = i4 + (i8 << 3) | 0;
   i1 = HEAP32[i20 + 4 >> 2] | 0;
   i2 = i3;
   HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   i2 = i8 + 1 | 0;
   i1 = i15 + 36 | 0;
   if ((i2 | 0) < (HEAP32[i12 + 16 >> 2] | 0)) {
    i8 = i4 + (i2 << 3) | 0;
    i19 = HEAP32[i8 + 4 >> 2] | 0;
    i20 = i1;
    HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i20 + 4 >> 2] = i19;
   } else {
    i8 = i4;
    i19 = HEAP32[i8 + 4 >> 2] | 0;
    i20 = i1;
    HEAP32[i20 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i20 + 4 >> 2] = i19;
   }
   HEAP32[i9 >> 2] = i3;
   HEAP32[i10 >> 2] = 2;
   HEAP32[i11 >> 2] = HEAP32[i12 + 8 >> 2];
   break;
  }
 case 1:
  {
   HEAP32[i9 >> 2] = i12 + 12;
   HEAP32[i10 >> 2] = 2;
   HEAP32[i11 >> 2] = HEAP32[i12 + 8 >> 2];
   break;
  }
 default:
  {}
 }
 i20 = i15 + 56 | 0;
 HEAP32[i20 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i20 = i15 + 72 | 0;
 HEAP32[i20 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP8[i15 + 88 >> 0] = 1;
 HEAP16[i16 + 4 >> 1] = 0;
 __Z10b2DistanceP16b2DistanceOutputP14b2SimplexCachePK15b2DistanceInput(i17, i16, i15);
 i20 = Math_fround(HEAPF32[i17 + 16 >> 2]) < Math_fround(1.1920929e-06);
 STACKTOP = i18;
 return i20 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 88 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   i9 = i1 + 32 | 0;
   i10 = i1 + 68 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i1 + 84 >> 2] = 1;
   i10 = i1 + 52 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 88 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 88 | 0) + i2 | 0;
 if (i5 >>> 0 > 48806446) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 88 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 24403223 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 48806446;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 88 | 0) | 0;
 i7 = i5 + (((i1 - i4 | 0) / 88 | 0) * 88 | 0) | 0;
 i6 = i7;
 i3 = i5 + (i3 * 88 | 0) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i1 + 32 | 0;
  i5 = i1 + 68 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 1;
  i5 = i1 + 52 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  i1 = i8 + 88 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -88 | 0;
   __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2 + -88 | 0, i1);
   i2 = i3 + -88 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -88 | 0;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN12AudioManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 120 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 124 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 128 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 132 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 140 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 224 >> 0] = i1;
 i1 = i4 + 225 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN21ArchiveStorageCreator10StoreChunkEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 8 | 0;
 i11 = i18 + 24 | 0;
 i10 = i18;
 i14 = i18 + 12 | 0;
 i12 = i1 + 1280 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i13;
 i16 = i1 + 1308 | 0;
 i9 = HEAPU16[i1 + 1316 >> 1] & 63;
 if (!i13) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i7 = i1 + 1268 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i1 + 1168 >> 2] & 128)) {
  i8 = i1 + 1248 | 0;
  HEAP32[i8 >> 2] = __Z7CRCFeedjPKhj(HEAP32[i8 >> 2] | 0, i3, i13) | 0;
 }
 i8 = i1 + 1260 | 0;
 do if (!(HEAP32[i8 >> 2] | 0)) {
  i6 = i9;
  i2 = i13;
 } else {
  i6 = i1 + 1288 | 0;
  i2 = i1 + 1300 | 0;
  HEAP32[i2 >> 2] = i13;
  i4 = i1 + 1304 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i13 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i13;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i13, 1, i1 + 1292 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i2;
   i4 = i6;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 1, i1 + 1292 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
   HEAP32[i4 >> 2] = i13;
   HEAP32[i6 >> 2] = i5;
   i4 = i6;
   i2 = i5;
   break;
  } else {
   i4 = i6;
   i2 = HEAP32[i6 >> 2] | 0;
  } while (0);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = mftCall_iiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, HEAP32[i7 >> 2] | 0, i13 | 0, i2 | 0, i11 | 0, HEAP32[i1 + 1252 >> 2] | 0) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if (i8 & i2 >>> 0 < i13 >>> 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   i6 = i9;
   break;
  } else {
   HEAP32[i11 >> 2] = i13;
   i6 = 0;
   i2 = i13;
   break;
  }
 } while (0);
 if (__ZN12FileAccessor5WriteEyPKvPy(i1 + 12 | 0, i2, 0, i3, i10) | 0) {
  i3 = i10;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) == (i5 | 0) & (i3 | 0) == 0) {
   HEAP32[i12 >> 2] = 0;
   i4 = i1 + 1224 | 0;
   i14 = i4;
   i14 = _i64Add(HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, i13 | 0, 0) | 0;
   i15 = getTempRet0() | 0;
   HEAP32[i4 >> 2] = i14;
   HEAP32[i4 + 4 >> 2] = i15;
   i4 = i1 + 1232 | 0;
   i15 = i4;
   i3 = _i64Add(HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, i2 | 0, i3 | 0) | 0;
   i2 = getTempRet0() | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = i2;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i13;
   i4 = i1 + 1312 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i5;
   i2 = i1 + 1196 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 1200 >> 2] | 0)) {
    __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 1192 | 0, i16);
    i1 = HEAP32[i2 >> 2] | 0;
   } else {
    HEAP32[i3 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    i1 = (HEAP32[i2 >> 2] | 0) + 12 | 0;
    HEAP32[i2 >> 2] = i1;
   }
   i1 = i1 + -4 | 0;
   HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] & 65472 | i6;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = 1;
  } else i17 = 15;
 } else i17 = 15;
 if ((i17 | 0) == 15) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  __Z6FormatPKcz(i14, gb + 490485 | 0, i15);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 490375 | 0, 472, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i1 = 0;
 }
 i17 = i1;
 STACKTOP = i18;
 return i17 | 0;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i20, i1, i21) {
 i2 = i2 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i19 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i19) return;
 i17 = HEAP32[i2 + 520 >> 2] | 0;
 i18 = i21 + 192 | 0;
 i16 = 0;
 do {
  i15 = i17 + (i16 << 2) | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  f12 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f11 = Math_fround(f11 * Math_fround(.00999999977));
  f12 = Math_fround(f12 * Math_fround(.00999999977));
  f13 = Math_fround(f13 * Math_fround(.00999999977));
  f14 = Math_fround(Math_fround(HEAPF32[i15 + 12 >> 2]) * Math_fround(.00999999977));
  i15 = HEAP32[i18 >> 2] | 0;
  L6 : do if (!i15) i1 = 0; else {
   i1 = 0;
   do {
    f10 = Math_fround(HEAPF32[i21 + 64 + (i1 << 2) >> 2]);
    if (!(f14 > f10 & (f13 > f10 & (f11 > f10 & f12 > f10)))) break L6;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i15 >>> 0);
  } while (0);
  L11 : do if (i1 >>> 0 < i15 >>> 0) {
   i7 = i1;
   i8 = 0;
   i4 = -1;
   i9 = 0;
   i3 = -1;
   i5 = 0;
   i2 = -1;
   i6 = 0;
   i1 = -1;
   while (1) {
    if ((i6 & i9 & i5 & i8 | 0) <= -1) break L11;
    f10 = Math_fround(HEAPF32[i21 + 64 + (i7 << 2) >> 2]);
    i22 = HEAP32[i21 + (i7 << 2) >> 2] | 0;
    i4 = i22 & ~i8 | i8 & i4;
    i3 = i22 & ~i5 | i5 & i3;
    i2 = i22 & ~i6 | i6 & i2;
    i1 = i22 & ~i9 | i9 & i1;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i15 >>> 0) break; else {
     i8 = (f11 < f10) << 31 >> 31;
     i9 = (f14 < f10) << 31 >> 31;
     i5 = (f12 < f10) << 31 >> 31;
     i6 = (f13 < f10) << 31 >> 31;
    }
   }
  } else {
   i4 = -1;
   i3 = -1;
   i2 = -1;
   i1 = -1;
  } while (0);
  i29 = i20 + (i16 << 2) | 0;
  i31 = HEAP32[i29 >> 2] | 0;
  i24 = i29 + 4 | 0;
  i26 = HEAP32[i24 >> 2] | 0;
  i6 = i29 + 8 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i22 = i29 + 12 | 0;
  i9 = HEAP32[i22 >> 2] | 0;
  i32 = (Math_imul(i31 & 255, i4 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i31 >>> 8 & 255, i4 >>> 8 & 255) | 0) + 128 | 0;
  i30 = (Math_imul(i31 >>> 16 & 255, i4 >>> 16 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i31 >>> 24, i4 >>> 24) | 0) + 128 | 0;
  i27 = (Math_imul(i26 & 255, i3 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i26 >>> 8 & 255, i3 >>> 8 & 255) | 0) + 128 | 0;
  i25 = (Math_imul(i26 >>> 16 & 255, i3 >>> 16 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i26 >>> 24, i3 >>> 24) | 0) + 128 | 0;
  i3 = (Math_imul(i8 & 255, i2 & 255) | 0) + 128 | 0;
  i23 = (Math_imul(i8 >>> 8 & 255, i2 >>> 8 & 255) | 0) + 128 | 0;
  i5 = (Math_imul(i8 >>> 16 & 255, i2 >>> 16 & 255) | 0) + 128 | 0;
  i4 = (Math_imul(i8 >>> 24, i2 >>> 24) | 0) + 128 | 0;
  i8 = (Math_imul(i9 & 255, i1 & 255) | 0) + 128 | 0;
  i7 = (Math_imul(i9 >>> 8 & 255, i1 >>> 8 & 255) | 0) + 128 | 0;
  i15 = (Math_imul(i9 >>> 16 & 255, i1 >>> 16 & 255) | 0) + 128 | 0;
  i9 = (Math_imul(i9 >>> 24, i1 >>> 24) | 0) + 128 | 0;
  HEAP32[i29 >> 2] = (i33 >>> 8) + i33 & 261888 | ((i32 >>> 8) + i32 | 0) >>> 8 | ((i31 >>> 8) + i31 | 0) >>> 8 << 24 | ((i30 >>> 8) + i30 | 0) >>> 8 << 16;
  HEAP32[i24 >> 2] = (i28 >>> 8) + i28 & 261888 | ((i27 >>> 8) + i27 | 0) >>> 8 | ((i26 >>> 8) + i26 | 0) >>> 8 << 24 | ((i25 >>> 8) + i25 | 0) >>> 8 << 16;
  HEAP32[i6 >> 2] = (i23 >>> 8) + i23 & 261888 | ((i3 >>> 8) + i3 | 0) >>> 8 | ((i4 >>> 8) + i4 | 0) >>> 8 << 24 | ((i5 >>> 8) + i5 | 0) >>> 8 << 16;
  HEAP32[i22 >> 2] = (i7 >>> 8) + i7 & 261888 | ((i8 >>> 8) + i8 | 0) >>> 8 | ((i9 >>> 8) + i9 | 0) >>> 8 << 24 | ((i15 >>> 8) + i15 | 0) >>> 8 << 16;
  i16 = i16 + 4 | 0;
 } while (i16 >>> 0 < i19 >>> 0);
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i20, i1, i21) {
 i2 = i2 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0;
 i19 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i19) return;
 i17 = HEAP32[i2 + 520 >> 2] | 0;
 i18 = i21 + 192 | 0;
 i16 = 0;
 do {
  i15 = i17 + (i16 << 2) | 0;
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  f12 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f11 = Math_fround(f11 * Math_fround(.00999999977));
  f12 = Math_fround(f12 * Math_fround(.00999999977));
  f13 = Math_fround(f13 * Math_fround(.00999999977));
  f14 = Math_fround(Math_fround(HEAPF32[i15 + 12 >> 2]) * Math_fround(.00999999977));
  i15 = HEAP32[i18 >> 2] | 0;
  L6 : do if (!i15) i1 = 0; else {
   i1 = 0;
   do {
    f10 = Math_fround(HEAPF32[i21 + 64 + (i1 << 2) >> 2]);
    if (!(f14 > f10 & (f13 > f10 & (f11 > f10 & f12 > f10)))) break L6;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i15 >>> 0);
  } while (0);
  L11 : do if (i1 >>> 0 < i15 >>> 0) {
   i7 = i1;
   i8 = 0;
   i4 = -1;
   i9 = 0;
   i3 = -1;
   i5 = 0;
   i2 = -1;
   i6 = 0;
   i1 = -1;
   while (1) {
    if ((i6 & i9 & i5 & i8 | 0) <= -1) break L11;
    f10 = Math_fround(HEAPF32[i21 + 64 + (i7 << 2) >> 2]);
    i22 = HEAP32[i21 + (i7 << 2) >> 2] | 0;
    i4 = i22 & ~i8 | i8 & i4;
    i3 = i22 & ~i5 | i5 & i3;
    i2 = i22 & ~i6 | i6 & i2;
    i1 = i22 & ~i9 | i9 & i1;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i15 >>> 0) break; else {
     i8 = (f11 < f10) << 31 >> 31;
     i9 = (f14 < f10) << 31 >> 31;
     i5 = (f12 < f10) << 31 >> 31;
     i6 = (f13 < f10) << 31 >> 31;
    }
   }
  } else {
   i4 = -1;
   i3 = -1;
   i2 = -1;
   i1 = -1;
  } while (0);
  i29 = i20 + (i16 << 2) | 0;
  i31 = HEAP32[i29 >> 2] | 0;
  i24 = i29 + 4 | 0;
  i26 = HEAP32[i24 >> 2] | 0;
  i6 = i29 + 8 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i22 = i29 + 12 | 0;
  i9 = HEAP32[i22 >> 2] | 0;
  i32 = (Math_imul(i31 & 255, i4 & 255) | 0) + 128 | 0;
  i33 = (Math_imul(i31 >>> 8 & 255, i4 >>> 8 & 255) | 0) + 128 | 0;
  i30 = (Math_imul(i31 >>> 16 & 255, i4 >>> 16 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i31 >>> 24, i4 >>> 24) | 0) + 128 | 0;
  i27 = (Math_imul(i26 & 255, i3 & 255) | 0) + 128 | 0;
  i28 = (Math_imul(i26 >>> 8 & 255, i3 >>> 8 & 255) | 0) + 128 | 0;
  i25 = (Math_imul(i26 >>> 16 & 255, i3 >>> 16 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i26 >>> 24, i3 >>> 24) | 0) + 128 | 0;
  i3 = (Math_imul(i8 & 255, i2 & 255) | 0) + 128 | 0;
  i23 = (Math_imul(i8 >>> 8 & 255, i2 >>> 8 & 255) | 0) + 128 | 0;
  i5 = (Math_imul(i8 >>> 16 & 255, i2 >>> 16 & 255) | 0) + 128 | 0;
  i4 = (Math_imul(i8 >>> 24, i2 >>> 24) | 0) + 128 | 0;
  i8 = (Math_imul(i9 & 255, i1 & 255) | 0) + 128 | 0;
  i7 = (Math_imul(i9 >>> 8 & 255, i1 >>> 8 & 255) | 0) + 128 | 0;
  i15 = (Math_imul(i9 >>> 16 & 255, i1 >>> 16 & 255) | 0) + 128 | 0;
  i9 = (Math_imul(i9 >>> 24, i1 >>> 24) | 0) + 128 | 0;
  HEAP32[i29 >> 2] = (i33 >>> 8) + i33 & 261888 | ((i32 >>> 8) + i32 | 0) >>> 8 | ((i31 >>> 8) + i31 | 0) >>> 8 << 24 | ((i30 >>> 8) + i30 | 0) >>> 8 << 16;
  HEAP32[i24 >> 2] = (i28 >>> 8) + i28 & 261888 | ((i27 >>> 8) + i27 | 0) >>> 8 | ((i26 >>> 8) + i26 | 0) >>> 8 << 24 | ((i25 >>> 8) + i25 | 0) >>> 8 << 16;
  HEAP32[i6 >> 2] = (i23 >>> 8) + i23 & 261888 | ((i3 >>> 8) + i3 | 0) >>> 8 | ((i4 >>> 8) + i4 | 0) >>> 8 << 24 | ((i5 >>> 8) + i5 | 0) >>> 8 << 16;
  HEAP32[i22 >> 2] = (i7 >>> 8) + i7 & 261888 | ((i8 >>> 8) + i8 | 0) >>> 8 | ((i9 >>> 8) + i9 | 0) >>> 8 << 24 | ((i15 >>> 8) + i15 | 0) >>> 8 << 16;
  i16 = i16 + 4 | 0;
 } while (i16 >>> 0 < i19 >>> 0);
 return;
}

function runPostSets208() {
 HEAP32[gb + 176332 >> 2] = fb + 2051;
 HEAP32[gb + 176336 >> 2] = fb + 36;
 HEAP32[gb + 176340 >> 2] = fb + 180;
 HEAP32[gb + 176344 >> 2] = fb + 181;
 HEAP32[gb + 176348 >> 2] = fb + 2052;
 HEAP32[gb + 176352 >> 2] = fb + 182;
 HEAP32[gb + 176356 >> 2] = fb + 1250;
 HEAP32[gb + 176360 >> 2] = fb + 1251;
 HEAP32[gb + 176364 >> 2] = fb + 1252;
 HEAP32[gb + 176368 >> 2] = fb + 2053;
 HEAP32[gb + 176372 >> 2] = fb + 2054;
 HEAP32[gb + 176384 >> 2] = fb + 267;
 HEAP32[gb + 176388 >> 2] = fb + 2055;
 HEAP32[gb + 176400 >> 2] = fb + 2723;
 HEAP32[gb + 176404 >> 2] = fb + 2724;
 HEAP32[gb + 176408 >> 2] = fb + 2725;
 HEAP32[gb + 176412 >> 2] = fb + 39;
 HEAP32[gb + 176416 >> 2] = fb + 16;
 HEAP32[gb + 176420 >> 2] = fb + 39;
 HEAP32[gb + 176424 >> 2] = fb + 40;
 HEAP32[gb + 176428 >> 2] = fb + 19;
 HEAP32[gb + 176432 >> 2] = fb + 1253;
 HEAP32[gb + 176436 >> 2] = fb + 31;
 HEAP32[gb + 176440 >> 2] = fb + 27;
 HEAP32[gb + 176444 >> 2] = fb + 62;
 HEAP32[gb + 176448 >> 2] = fb + 28;
 HEAP32[gb + 176452 >> 2] = fb + 63;
 HEAP32[gb + 176456 >> 2] = fb + 29;
 HEAP32[gb + 176460 >> 2] = fb + 34;
 HEAP32[gb + 176464 >> 2] = fb + 111;
 HEAP32[gb + 176468 >> 2] = fb + 112;
 HEAP32[gb + 176472 >> 2] = fb + 113;
 HEAP32[gb + 176476 >> 2] = fb + 114;
 HEAP32[gb + 176480 >> 2] = fb + 115;
 HEAP32[gb + 176484 >> 2] = fb + 116;
 HEAP32[gb + 176488 >> 2] = fb + 36;
 HEAP32[gb + 176492 >> 2] = fb + 1;
 HEAP32[gb + 176496 >> 2] = fb + 1;
 HEAP32[gb + 176500 >> 2] = fb + 1;
 HEAP32[gb + 176504 >> 2] = fb + 1;
 HEAP32[gb + 176508 >> 2] = fb + 1;
 HEAP32[gb + 176512 >> 2] = fb + 1;
 HEAP32[gb + 176516 >> 2] = fb + 1;
 HEAP32[gb + 176520 >> 2] = fb + 2053;
 HEAP32[gb + 176532 >> 2] = (HEAP32[gb + 176532 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 176536 >> 2] = (HEAP32[gb + 176536 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 176572 >> 2] = fb + 2726;
 HEAP32[gb + 176576 >> 2] = fb + 2727;
 HEAP32[gb + 176580 >> 2] = fb + 2728;
 HEAP32[gb + 176584 >> 2] = fb + 2056;
 HEAP32[gb + 176588 >> 2] = fb + 16;
 HEAP32[gb + 176592 >> 2] = fb + 2729;
 HEAP32[gb + 176596 >> 2] = fb + 2730;
 HEAP32[gb + 176600 >> 2] = fb + 19;
 HEAP32[gb + 176604 >> 2] = fb + 1254;
 HEAP32[gb + 176608 >> 2] = fb + 103;
 HEAP32[gb + 176612 >> 2] = fb + 101;
 HEAP32[gb + 176616 >> 2] = fb + 62;
 HEAP32[gb + 176620 >> 2] = fb + 28;
 HEAP32[gb + 176624 >> 2] = fb + 63;
 HEAP32[gb + 176628 >> 2] = fb + 29;
 HEAP32[gb + 176632 >> 2] = fb + 34;
 HEAP32[gb + 176636 >> 2] = fb + 2057;
 HEAP32[gb + 176640 >> 2] = fb + 2058;
 HEAP32[gb + 176644 >> 2] = fb + 2059;
 HEAP32[gb + 176648 >> 2] = fb + 2060;
 HEAP32[gb + 176652 >> 2] = fb + 2061;
 HEAP32[gb + 176656 >> 2] = fb + 2062;
 HEAP32[gb + 176660 >> 2] = fb + 36;
 HEAP32[gb + 176664 >> 2] = fb + 104;
 HEAP32[gb + 176668 >> 2] = fb + 108;
 HEAP32[gb + 176672 >> 2] = fb + 94;
 HEAP32[gb + 176676 >> 2] = fb + 2063;
 HEAP32[gb + 176680 >> 2] = fb + 112;
 HEAP32[gb + 176684 >> 2] = fb + 113;
 HEAP32[gb + 176688 >> 2] = fb + 131;
 HEAP32[gb + 176692 >> 2] = fb + 111;
 HEAP32[gb + 176696 >> 2] = fb + 2731;
 HEAP32[gb + 176700 >> 2] = fb + 113;
 HEAP32[gb + 176704 >> 2] = fb + 2732;
 HEAP32[gb + 176708 >> 2] = fb + 2733;
 HEAP32[gb + 176712 >> 2] = fb + 2064;
 HEAP32[gb + 176716 >> 2] = fb + 155;
 HEAP32[gb + 176720 >> 2] = fb + 255;
 HEAP32[gb + 176724 >> 2] = fb + 1255;
 HEAP32[gb + 176728 >> 2] = fb + 1;
 HEAP32[gb + 176732 >> 2] = fb + 2;
 HEAP32[gb + 176736 >> 2] = fb + 449;
 HEAP32[gb + 176740 >> 2] = fb + 253;
 HEAP32[gb + 176744 >> 2] = fb + 2734;
 HEAP32[gb + 176748 >> 2] = fb + 2065;
 HEAP32[gb + 176752 >> 2] = fb + 2735;
 HEAP32[gb + 176756 >> 2] = fb + 1256;
 HEAP32[gb + 176760 >> 2] = fb + 1257;
 HEAP32[gb + 176772 >> 2] = fb + 2736;
 HEAP32[gb + 176776 >> 2] = fb + 2737;
 HEAP32[gb + 176780 >> 2] = fb + 143;
 HEAP32[gb + 176784 >> 2] = fb + 13;
 HEAP32[gb + 176788 >> 2] = fb + 2;
 HEAP32[gb + 176792 >> 2] = fb + 3;
 runPostSets209();
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_(i11, i1, i15, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i8 = i11 + 4 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i1 = i13;
 do if ((i13 | 0) != (i8 | 0)) {
  i5 = i13 + 16 | 0;
  i10 = HEAP8[i12 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i12 + 4 >> 2] | 0 : i10 & 255;
  i3 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i3 = i4 ? HEAP32[i13 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i10 >>> 0;
  i2 = i6 ? i3 : i10;
  if (!i2) i14 = 4; else {
   i2 = _memcmp(i9 ? HEAP32[i12 >> 2] | 0 : i12, i4 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
   if (!i2) i14 = 4; else if ((i2 | 0) < 0) break;
  }
  if ((i14 | 0) == 4) if (i10 >>> 0 < i3 >>> 0) break;
  i2 = i10 >>> 0 < i3 >>> 0 ? i10 : i3;
  if (!i2) i14 = 20; else {
   i2 = _memcmp(i4 ? HEAP32[i5 >> 2] | 0 : i5, i9 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
   if (!i2) i14 = 20; else if ((i2 | 0) >= 0) i14 = 34;
  }
  if ((i14 | 0) == 20) if (!i6) i14 = 34;
  if ((i14 | 0) == 34) {
   HEAP32[i15 >> 2] = i1;
   return i15 | 0;
  }
  i6 = i13 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = (i1 | 0) == 0;
  if (i7) {
   i1 = i13;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  do if ((i2 | 0) != (i8 | 0)) {
   i3 = i2 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i2 + 20 >> 2] | 0 : i5 & 255;
   i1 = i5 >>> 0 < i10 >>> 0 ? i5 : i10;
   if (!i1) i14 = 28; else {
    i1 = _memcmp(i9 ? HEAP32[i12 >> 2] | 0 : i12, i4 ? HEAP32[i3 >> 2] | 0 : i3, i1) | 0;
    if (!i1) i14 = 28; else if ((i1 | 0) < 0) break;
   }
   if ((i14 | 0) == 28) if (i10 >>> 0 < i5 >>> 0) break;
   i15 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i11, i15, i12) | 0;
   return i15 | 0;
  } while (0);
  if (i7) {
   HEAP32[i15 >> 2] = i13;
   i15 = i6;
   return i15 | 0;
  } else {
   HEAP32[i15 >> 2] = i2;
   i15 = i2;
   return i15 | 0;
  }
 } while (0);
 do if ((i13 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) {
   i1 = i13;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i2; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = i2;
  i4 = i2 + 16 | 0;
  i6 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
  i7 = HEAP8[i12 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i2 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
  if (!i2) i14 = 12; else {
   i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
   if (!i2) i14 = 12; else if ((i2 | 0) < 0) break;
  }
  if ((i14 | 0) == 12) if (i6 >>> 0 < i7 >>> 0) break;
  i15 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i11, i15, i12) | 0;
  return i15 | 0;
 } while (0);
 if (!(HEAP32[i13 >> 2] | 0)) {
  HEAP32[i15 >> 2] = i13;
  i15 = i13;
  return i15 | 0;
 } else {
  i14 = i1;
  HEAP32[i15 >> 2] = i14;
  i15 = i14 + 4 | 0;
  return i15 | 0;
 }
 return 0;
}

function runPostSets114() {
 HEAP32[gb + 102244 >> 2] = fb + 1129;
 HEAP32[gb + 102248 >> 2] = fb + 1495;
 HEAP32[gb + 102260 >> 2] = fb + 1125;
 HEAP32[gb + 102264 >> 2] = fb + 1496;
 HEAP32[gb + 102268 >> 2] = fb + 1258;
 HEAP32[gb + 102272 >> 2] = fb + 757;
 HEAP32[gb + 102276 >> 2] = fb + 1127;
 HEAP32[gb + 102280 >> 2] = fb + 1128;
 HEAP32[gb + 102284 >> 2] = fb + 469;
 HEAP32[gb + 102288 >> 2] = fb + 1129;
 HEAP32[gb + 102292 >> 2] = fb + 1497;
 HEAP32[gb + 102304 >> 2] = fb + 1125;
 HEAP32[gb + 102308 >> 2] = fb + 1498;
 HEAP32[gb + 102312 >> 2] = fb + 1258;
 HEAP32[gb + 102316 >> 2] = fb + 758;
 HEAP32[gb + 102320 >> 2] = fb + 1127;
 HEAP32[gb + 102324 >> 2] = fb + 1128;
 HEAP32[gb + 102328 >> 2] = fb + 469;
 HEAP32[gb + 102332 >> 2] = fb + 1129;
 HEAP32[gb + 102336 >> 2] = fb + 1499;
 HEAP32[gb + 102348 >> 2] = fb + 1125;
 HEAP32[gb + 102352 >> 2] = fb + 1500;
 HEAP32[gb + 102356 >> 2] = fb + 1258;
 HEAP32[gb + 102360 >> 2] = fb + 759;
 HEAP32[gb + 102364 >> 2] = fb + 1127;
 HEAP32[gb + 102368 >> 2] = fb + 1128;
 HEAP32[gb + 102372 >> 2] = fb + 469;
 HEAP32[gb + 102376 >> 2] = fb + 1129;
 HEAP32[gb + 102380 >> 2] = fb + 1501;
 HEAP32[gb + 102392 >> 2] = fb + 1125;
 HEAP32[gb + 102396 >> 2] = fb + 1502;
 HEAP32[gb + 102400 >> 2] = fb + 1258;
 HEAP32[gb + 102404 >> 2] = fb + 760;
 HEAP32[gb + 102408 >> 2] = fb + 1127;
 HEAP32[gb + 102412 >> 2] = fb + 1128;
 HEAP32[gb + 102416 >> 2] = fb + 469;
 HEAP32[gb + 102420 >> 2] = fb + 1129;
 HEAP32[gb + 102424 >> 2] = fb + 1503;
 HEAP32[gb + 102436 >> 2] = fb + 1455;
 HEAP32[gb + 102440 >> 2] = fb + 1504;
 HEAP32[gb + 102444 >> 2] = fb + 1457;
 HEAP32[gb + 102448 >> 2] = fb + 748;
 HEAP32[gb + 102452 >> 2] = fb + 1458;
 HEAP32[gb + 102456 >> 2] = fb + 1459;
 HEAP32[gb + 102460 >> 2] = fb + 749;
 HEAP32[gb + 102464 >> 2] = fb + 1460;
 HEAP32[gb + 102468 >> 2] = fb + 1505;
 HEAP32[gb + 102480 >> 2] = fb + 1125;
 HEAP32[gb + 102484 >> 2] = fb + 1506;
 HEAP32[gb + 102488 >> 2] = fb + 1258;
 HEAP32[gb + 102492 >> 2] = fb + 761;
 HEAP32[gb + 102496 >> 2] = fb + 1127;
 HEAP32[gb + 102500 >> 2] = fb + 1128;
 HEAP32[gb + 102504 >> 2] = fb + 469;
 HEAP32[gb + 102508 >> 2] = fb + 1129;
 HEAP32[gb + 102512 >> 2] = fb + 1507;
 HEAP32[gb + 102524 >> 2] = fb + 1125;
 HEAP32[gb + 102528 >> 2] = fb + 1508;
 HEAP32[gb + 102532 >> 2] = fb + 1258;
 HEAP32[gb + 102536 >> 2] = fb + 762;
 HEAP32[gb + 102540 >> 2] = fb + 1127;
 HEAP32[gb + 102544 >> 2] = fb + 1128;
 HEAP32[gb + 102548 >> 2] = fb + 469;
 HEAP32[gb + 102552 >> 2] = fb + 1129;
 HEAP32[gb + 102556 >> 2] = fb + 1509;
 HEAP32[gb + 102568 >> 2] = fb + 1125;
 HEAP32[gb + 102572 >> 2] = fb + 1510;
 HEAP32[gb + 102576 >> 2] = fb + 1258;
 HEAP32[gb + 102580 >> 2] = fb + 763;
 HEAP32[gb + 102584 >> 2] = fb + 1127;
 HEAP32[gb + 102588 >> 2] = fb + 1128;
 HEAP32[gb + 102592 >> 2] = fb + 469;
 HEAP32[gb + 102596 >> 2] = fb + 1129;
 HEAP32[gb + 102600 >> 2] = fb + 1511;
 HEAP32[gb + 102612 >> 2] = fb + 1125;
 HEAP32[gb + 102616 >> 2] = fb + 1512;
 HEAP32[gb + 102620 >> 2] = fb + 1258;
 HEAP32[gb + 102624 >> 2] = fb + 764;
 HEAP32[gb + 102628 >> 2] = fb + 1127;
 HEAP32[gb + 102632 >> 2] = fb + 1128;
 HEAP32[gb + 102636 >> 2] = fb + 469;
 HEAP32[gb + 102640 >> 2] = fb + 1129;
 HEAP32[gb + 102644 >> 2] = fb + 1513;
 HEAP32[gb + 102656 >> 2] = fb + 1125;
 HEAP32[gb + 102660 >> 2] = fb + 1514;
 HEAP32[gb + 102664 >> 2] = fb + 1258;
 HEAP32[gb + 102668 >> 2] = fb + 765;
 HEAP32[gb + 102672 >> 2] = fb + 1127;
 HEAP32[gb + 102676 >> 2] = fb + 1128;
 HEAP32[gb + 102680 >> 2] = fb + 469;
 HEAP32[gb + 102684 >> 2] = fb + 1129;
 HEAP32[gb + 102688 >> 2] = fb + 1515;
 HEAP32[gb + 102700 >> 2] = fb + 1125;
 HEAP32[gb + 102704 >> 2] = fb + 1516;
 HEAP32[gb + 102708 >> 2] = fb + 1258;
 HEAP32[gb + 102712 >> 2] = fb + 766;
 HEAP32[gb + 102716 >> 2] = fb + 1127;
 HEAP32[gb + 102720 >> 2] = fb + 1128;
 HEAP32[gb + 102724 >> 2] = fb + 469;
 HEAP32[gb + 102728 >> 2] = fb + 1129;
 runPostSets115();
}

function __ZNSt3__24listIPFb7LogTypePKcPiE13stl_allocatorIS6_L18MemLabelIdentifier7ELi16EEE6removeERKS6_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAP32[i15 >> 2] = i15;
 i11 = i15 + 4 | 0;
 HEAP32[i11 >> 2] = i15;
 i12 = i15 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i13;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i9 | 0)) {
  i8 = i9 + 8 | 0;
  if ((i15 | 0) == (i9 | 0)) {
   i5 = i2;
   while (1) {
    i4 = HEAP32[i1 + 8 >> 2] | 0;
    i2 = i5 + 4 | 0;
    if ((i4 | 0) == (HEAP32[i10 >> 2] | 0)) {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = i3;
     L8 : do if ((i3 | 0) == (i9 | 0)) {
      i4 = 0;
      i3 = i9;
     } else while (1) {
      if ((HEAP32[i2 + 8 >> 2] | 0) != (i4 | 0)) {
       i4 = 1;
       break L8;
      }
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      i3 = i2;
      if ((i3 | 0) == (i9 | 0)) {
       i4 = 0;
       i3 = i9;
       break;
      }
     } while (0);
     if ((i5 | 0) != (i3 | 0)) {
      i7 = HEAP32[i2 >> 2] | 0;
      i8 = i7 + 4 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      HEAP32[i6 + 4 >> 2] = HEAP32[i8 >> 2];
      HEAP32[HEAP32[i8 >> 2] >> 2] = i6;
      i6 = HEAP32[i15 >> 2] | 0;
      HEAP32[i6 + 4 >> 2] = i5;
      HEAP32[i1 >> 2] = i6;
      HEAP32[i15 >> 2] = i7;
      HEAP32[i8 >> 2] = i15;
     }
     if (i4) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i2;
    } else i1 = HEAP32[i2 >> 2] | 0;
    i5 = i1;
    if ((i5 | 0) == (i9 | 0)) break L1;
   }
  }
  do {
   i6 = HEAP32[i1 + 8 >> 2] | 0;
   i3 = i2 + 4 | 0;
   if ((i6 | 0) == (HEAP32[i10 >> 2] | 0)) {
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = i5;
    L23 : do if ((i5 | 0) == (i9 | 0)) {
     i7 = 0;
     i4 = i9;
     i6 = i3;
    } else {
     i4 = i5;
     while (1) {
      if ((HEAP32[i3 + 8 >> 2] | 0) != (i6 | 0)) {
       i7 = 1;
       i6 = i3;
       break L23;
      }
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      i4 = i3;
      if ((i4 | 0) == (i9 | 0)) {
       i7 = 0;
       i4 = i9;
       i6 = i3;
       break;
      }
     }
    } while (0);
    if ((i2 | 0) != (i4 | 0)) {
     if ((i5 | 0) == (i4 | 0)) i3 = 1; else {
      i3 = 1;
      do {
       i5 = HEAP32[i5 + 4 >> 2] | 0;
       i3 = i3 + 1 | 0;
      } while ((i5 | 0) != (i4 | 0));
     }
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i3;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
     i3 = HEAP32[i6 >> 2] | 0;
     i5 = i3 + 4 | 0;
     i17 = HEAP32[i2 >> 2] | 0;
     HEAP32[i17 + 4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[HEAP32[i5 >> 2] >> 2] = i17;
     i17 = HEAP32[i15 >> 2] | 0;
     HEAP32[i17 + 4 >> 2] = i2;
     HEAP32[i1 >> 2] = i17;
     HEAP32[i15 >> 2] = i3;
     HEAP32[i5 >> 2] = i15;
    }
    if (i7) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = i6;
   } else i1 = HEAP32[i3 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i9 | 0));
 } while (0);
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i17 = (HEAP32[i15 >> 2] | 0) + 4 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[HEAP32[i17 >> 2] >> 2] = i11;
 HEAP32[i12 >> 2] = 0;
 if ((i2 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 i3 = i15 + 12 | 0;
 i4 = i14 + 4 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = 7;
 HEAP32[i4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
 if ((i1 | 0) == (i15 | 0)) {
  STACKTOP = i16;
  return;
 }
 do {
  i13 = HEAP32[i3 >> 2] | 0;
  i17 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i14 >> 2] = 7;
  HEAP32[i4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i17, i14);
 } while ((i1 | 0) != (i15 | 0));
 STACKTOP = i16;
 return;
}

function __ZNK5Umbra6KDTree4Node13getDebugLinesEPNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 4 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i2 + 8 >> 2] = i4;
 i4 = i1 + 16 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 16 >> 2] = i8;
 HEAP32[i2 + 20 >> 2] = i3;
 i3 = i4 + 4 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 28 >> 2] = i8;
 HEAP32[i2 + 32 >> 2] = i5;
 i5 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 40 >> 2] = i5;
 HEAP32[i2 + 44 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 8 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 52 >> 2] = i8;
 HEAP32[i2 + 56 >> 2] = i9;
 i9 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 60 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 64 >> 2] = i9;
 HEAP32[i2 + 68 >> 2] = i8;
 i8 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 76 >> 2] = i8;
 HEAP32[i2 + 80 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 84 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 88 >> 2] = i9;
 HEAP32[i2 + 92 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 100 >> 2] = i8;
 HEAP32[i2 + 104 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 108 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 112 >> 2] = i9;
 HEAP32[i2 + 116 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 120 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 124 >> 2] = i8;
 HEAP32[i2 + 128 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 132 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 136 >> 2] = i9;
 HEAP32[i2 + 140 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 144 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 148 >> 2] = i8;
 HEAP32[i2 + 152 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 156 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 160 >> 2] = i9;
 HEAP32[i2 + 164 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 168 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 172 >> 2] = i8;
 HEAP32[i2 + 176 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 180 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 184 >> 2] = i9;
 HEAP32[i2 + 188 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 192 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 196 >> 2] = i8;
 HEAP32[i2 + 200 >> 2] = i9;
 i9 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 204 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 208 >> 2] = i9;
 HEAP32[i2 + 212 >> 2] = i8;
 i8 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 216 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 220 >> 2] = i8;
 HEAP32[i2 + 224 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 228 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 232 >> 2] = i9;
 HEAP32[i2 + 236 >> 2] = i8;
 i8 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 240 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 244 >> 2] = i8;
 HEAP32[i2 + 248 >> 2] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 252 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 256 >> 2] = i1;
 HEAP32[i2 + 260 >> 2] = i6;
 i6 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 + 264 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 268 >> 2] = i6;
 HEAP32[i2 + 272 >> 2] = i1;
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + 276 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 280 >> 2] = i3;
 HEAP32[i2 + 284 >> 2] = i1;
 return;
}

function __ZL18ReplacementPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i20 + 196 | 0;
 i19 = i20;
 if ((HEAP16[gb + 1115268 + 6 >> 1] | 0) > -1) {
  HEAP32[i19 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1115268 | 0, i1);
  i18 = gb + 1115268 | 0;
 } else i18 = 0;
 i15 = HEAP32[gb + 1115268 >> 2] | 0;
 i16 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 648 >> 2] | 0, i16 | 0, i15 | 0);
 i15 = i14 + 12 | 0;
 i16 = HEAP32[i14 + 8 >> 2] | 0;
 i17 = (HEAP32[i2 + 8 >> 2] | 0) + 8 | 0;
 __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i19, i1, i17, (HEAP8[i2 + 104 >> 0] | 0) != 0, 1);
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 112 >> 2] | 0, i16 | 0, i2 + 40 | 0);
 i13 = i14 + 164 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i13 = (HEAP32[i13 + 4 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 < i13 >>> 0) {
  i12 = i2 + 12 | 0;
  do {
   i9 = HEAP32[i12 >> 2] | 0;
   i5 = i9 + (i1 * 40 | 0) + 8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   i6 = i9 + (i1 * 40 | 0) + 20 | 0;
   i7 = HEAP32[(HEAP32[i4 + (i2 * 360 | 0) + 324 >> 2] | 0) + (HEAP32[i6 >> 2] << 3) >> 2] | 0;
   __Z12SetupLODFadeR9GfxDeviceR17ShaderPassContextf(i16, i15, Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 24 >> 2]));
   __Z21SetupOddNegativeScaleR9GfxDeviceb(i16, (HEAP32[i4 + (i2 * 360 | 0) + 176 >> 2] & 4 | 0) != 0);
   i8 = i9 + (i1 * 40 | 0) + 16 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[(HEAP32[HEAP32[i3 + 32 >> 2] >> 2] | 0) + (HEAP32[i9 + (i1 * 40 | 0) + 12 >> 2] << 2) >> 2] | 0;
   i10 = HEAP32[i9 + 20 >> 2] | 0;
   L8 : do if ((i10 | 0) > 0) {
    i11 = i4 + (i2 * 360 | 0) + 182 | 0;
    i4 = i4 + (i2 * 360 | 0) + 180 | 0;
    i2 = 0;
    while (1) {
     i22 = HEAP32[i6 >> 2] | 0;
     i23 = HEAP16[i11 >> 1] | 0;
     i21 = i23 & 65535;
     __ZN13BatchRenderer20RenderSingleWithPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEiPKNS7_10GrabPassesEjib(i19, i15, i7, i3, HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0, i2, 0, HEAP32[i5 >> 2] | 0, (i23 << 16 >> 16 == 0 | (i21 | 0) > (i22 | 0) ? i22 : i21 + -1 | 0) + (HEAPU16[i4 >> 1] | 0) | 0, 0);
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i10 | 0)) break L8;
     i3 = HEAP32[i8 >> 2] | 0;
    }
   } while (0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
 }
 i1 = i14 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777217;
 i1 = i19 + 140 | 0;
 if ((HEAP32[i19 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i19 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i19 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 35824 + 8;
 i2 = i19 + 120 | 0;
 if ((HEAP32[i19 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i19 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i19 + 96 >> 2] | 0) > -1) {
  i23 = i19 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i23 >> 2] | 0, i19 + 84 | 0);
  HEAP32[i23 >> 2] = 0;
 }
 i1 = i19 + 60 | 0;
 if ((HEAP32[i19 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i19 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i19 + 40 | 0;
 if ((HEAP32[i19 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i19 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i23 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 652 >> 2] | 0, i23 | 0);
 if (!i18) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i20;
 return;
}

function __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_(i11, i12, i10, i9, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i12;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i11;
 i6 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i10;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i3 >>> 0 < i7 >>> 0;
 do if (i4 >>> 0 < i5 >>> 0 | (i4 | 0) == (i5 | 0) & i7 >>> 0 < i6 >>> 0) {
  if (i1) {
   i8 = i11;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = i2;
   i3 = i10;
   HEAP32[i3 >> 2] = i6;
   HEAP32[i3 + 4 >> 2] = i5;
   i3 = i11 + 8 | 0;
   i8 = i10 + 8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i4;
   i8 = 1;
   i4 = i5;
   i3 = i6;
   break;
  }
  i1 = i11;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 4 >> 2] = i4;
  i4 = i12;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i5;
  i4 = i11 + 8 | 0;
  i1 = i12 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i4 = i10;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0 | (i4 | 0) == (i5 | 0) & i3 >>> 0 < i6 >>> 0) {
   i8 = i12;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = i4;
   i8 = i10;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i8 + 4 >> 2] = i5;
   i8 = i10 + 8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i2;
   i8 = 2;
   i4 = i5;
   i3 = i6;
  } else i8 = 1;
 } else if (i1) {
  i1 = i12;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = i10;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i12 + 8 | 0;
  i3 = i10 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  i3 = i12;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i11;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  if (i3 >>> 0 < i6 >>> 0 | (i3 | 0) == (i6 | 0) & i2 >>> 0 < i5 >>> 0) {
   i8 = i11;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i3;
   i8 = i12;
   HEAP32[i8 >> 2] = i5;
   HEAP32[i8 + 4 >> 2] = i6;
   i8 = i11 + 8 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i3;
   i3 = i10;
   i8 = 2;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
  } else {
   i8 = 1;
   i3 = i7;
  }
 } else {
  i8 = 0;
  i4 = i2;
 } while (0);
 i2 = i9;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
  i12 = i8;
  return i12 | 0;
 }
 i6 = i10;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 i6 = i9;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i10 + 8 | 0;
 i2 = i9 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i12;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
  i12 = i8 + 1 | 0;
  return i12 | 0;
 }
 i5 = i12;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 i5 = i10;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i12 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i2 = i12;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i11;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0)) {
  i12 = i8 + 2 | 0;
  return i12 | 0;
 }
 i10 = i11;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i2;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i12 + 4 >> 2] = i4;
 i11 = i11 + 8 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i12;
 i12 = i8 + 3 | 0;
 return i12 | 0;
}

function __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 36 | 0;
 i9 = i5 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 52 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 104 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 106 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 40 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 92 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i9 = i7;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx23PxsBroadPhaseContextSap11batchRemoveEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 528 | 0;
 i18 = i19;
 i16 = i19 + 516 | 0;
 i11 = i15 + 88 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i12 = i15 + 168 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i14 = i15 + 172 | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 i10 = i15 + 84 | 0;
 i8 = 0;
 do {
  i6 = HEAP32[i15 + 124 + (i8 << 2) >> 2] | 0;
  i7 = HEAP32[i15 + 136 + (i8 << 2) >> 2] | 0;
  if (!i1) {
   i1 = (HEAP32[i12 >> 2] << 1) + 2 | 0;
   i2 = -1;
   i9 = 10;
  } else {
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i15 + 112 + (i8 << 2) >> 2] | 0;
   i2 = -1;
   i4 = 0;
   do {
    i20 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
    i5 = HEAP32[i3 + (i20 << 3) >> 2] | 0;
    i20 = HEAP32[i3 + (i20 << 3) + 4 >> 2] | 0;
    HEAP32[i7 + (i5 << 2) >> 2] = 1073741821;
    HEAP32[i7 + (i20 << 2) >> 2] = 1073741821;
    i2 = i5 >>> 0 < i2 >>> 0 ? i5 : i2;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
   i1 = (HEAP32[i12 >> 2] << 1) + 2 | 0;
   if ((i2 | 0) != (i1 | 0)) i9 = 10;
  }
  L12 : do if ((i9 | 0) == 10) {
   i9 = 0;
   i4 = i15 + 112 + (i8 << 2) | 0;
   i5 = i2;
   while (1) {
    if ((i2 | 0) == (i1 | 0)) break L12;
    while (1) {
     i3 = i7 + (i2 << 2) | 0;
     if ((HEAP32[i3 >> 2] | 0) != 1073741821) break;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i1 | 0)) break L12;
    }
    if ((i2 | 0) != (i5 | 0)) {
     HEAP32[i6 + (i5 << 2) >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
     i3 = HEAP32[i3 >> 2] | 0;
     HEAP32[i7 + (i5 << 2) >> 2] = i3;
     if ((i3 & -2 | 0) != 1073741822) HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 >>> 1 << 3) + ((i3 & 1) << 2) >> 2] = i5;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i1 | 0)) break; else i5 = i5 + 1 | 0;
   }
  } while (0);
  i8 = i8 + 1 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 } while ((i8 | 0) != 3);
 if (i1 | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i15 + 112 >> 2] | 0;
  i3 = HEAP32[i15 + 116 >> 2] | 0;
  i4 = HEAP32[i15 + 120 >> 2] | 0;
  i5 = 0;
  do {
   i20 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   HEAP32[i2 + (i20 << 3) >> 2] = 1073741821;
   HEAP32[i2 + (i20 << 3) + 4 >> 2] = 1073741821;
   HEAP32[i3 + (i20 << 3) >> 2] = 1073741821;
   HEAP32[i3 + (i20 << 3) + 4 >> 2] = 1073741821;
   HEAP32[i4 + (i20 << 3) >> 2] = 1073741821;
   HEAP32[i4 + (i20 << 3) + 4 >> 2] = 1073741821;
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 i3 = ((HEAP32[i15 + 108 >> 2] | 0) >>> 5) + 1 | 0;
 i5 = i18 + 512 | 0;
 if (i3 >>> 0 < 129) {
  i1 = i3 << 2;
  i2 = i18;
 } else {
  i2 = i3 << 2;
  i1 = i2;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i2, gb + 716893 | 0, 39) | 0;
 }
 HEAP32[i5 >> 2] = i2;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 i4 = i16 + 4 | 0;
 i20 = HEAP32[i5 >> 2] | 0;
 HEAP32[i16 >> 2] = i20;
 HEAP32[i4 >> 2] = i3 | -2147483648;
 i3 = i20;
 if (HEAP32[i11 >> 2] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  do {
   i10 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
   i20 = i3 + (i10 >>> 5 << 2) | 0;
   HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 1 << (i10 & 31);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 __ZN5physx14SapPairManager11RemovePairsERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i15 + 192 | 0, i16) | 0;
 i1 = i13 - (HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 >> 2] = i1 - (HEAP32[i15 + 80 >> 2] | 0);
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) != 0 & (HEAP32[i4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i16 + 8 | 0, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i18 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i1);
 STACKTOP = i19;
 return;
}

function __ZN24MeshIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i11 = i16;
 i14 = HEAP32[i8 + 280 >> 2] | 0;
 if (!i14) {
  i15 = -1;
  STACKTOP = i16;
  return i15 | 0;
 }
 __ZN4Mesh18CheckIfBuffersLostEv(i14);
 if (HEAP8[i14 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i14);
 i13 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 + (i13 * 360 | 0) + 248 >> 2] = HEAP32[i14 + 228 >> 2];
 i7 = i8 + 284 | 0;
 HEAP16[i12 + (i13 * 360 | 0) + 180 >> 1] = HEAP32[i7 >> 2];
 i5 = i2 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 28 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i6 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 28;
 i10 = i12 + (i13 * 360 | 0) + 328 | 0;
 HEAP32[i10 >> 2] = i6;
 i6 = i12 + (i13 * 360 | 0) + 324 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i12 + (i13 * 360 | 0) + 244 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
   if (i4 | 0) {
    i17 = i4 + 4 | 0;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
    if (!(HEAP32[i17 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63288 | 0);
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 8 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 8;
 HEAP32[i6 >> 2] = i5;
 i4 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, HEAP32[i7 >> 2] | 0) | 0;
 do if (!i4) i15 = 23; else {
  HEAP32[i11 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i15 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i11);
    i2 = HEAP32[i9 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i15 = 17;
   }
  }
  if ((i15 | 0) == 15) i15 = 17;
  if ((i15 | 0) == 17) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) {
    i15 = 23;
    break;
   }
  }
  HEAP32[i5 >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(i1) | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 36 >> 2];
 } while (0);
 if ((i15 | 0) == 23) {
  HEAP32[i5 >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(__ZN8Material10GetDefaultEv() | 0) | 0;
  HEAP32[i5 + 4 >> 2] = -1;
 }
 __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(HEAP32[i10 >> 2] | 0, i14, 0, 0, 0, 0);
 HEAP32[i12 + (i13 * 360 | 0) + 348 >> 2] = 3;
 HEAP32[i12 + (i13 * 360 | 0) + 340 >> 2] = fb + 492;
 HEAP32[i12 + (i13 * 360 | 0) + 332 >> 2] = fb + 211;
 HEAP32[i12 + (i13 * 360 | 0) + 344 >> 2] = fb + 2371;
 i17 = i13;
 STACKTOP = i16;
 return i17 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i24 = HEAP32[i5 + 4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(-f17);
 f28 = Math_fround(-f16);
 f29 = Math_fround(-f15);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 f33 = Math_fround(f20 * f8);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f7 * f28));
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f12 * f29));
 f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f32 = Math_fround(f9 * f8);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f11 * f28));
 f14 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f14 * f29));
 f21 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f8 = Math_fround(f21 * f8);
 f6 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f28 = Math_fround(f8 + Math_fround(f6 * f28));
 f8 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f29 = Math_fround(f28 + Math_fround(f8 * f29));
 f28 = Math_fround(HEAPF32[i24 + 96 >> 2]);
 f26 = Math_fround(HEAPF32[i24 + 100 >> 2]);
 f19 = Math_fround(HEAPF32[i24 + 104 >> 2]);
 f27 = Math_fround(HEAPF32[i24 + 112 >> 2]);
 f25 = Math_fround(HEAPF32[i24 + 116 >> 2]);
 f22 = Math_fround(HEAPF32[i24 + 120 >> 2]);
 f13 = Math_fround(HEAPF32[i24 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i24 + 132 >> 2]);
 f18 = Math_fround(HEAPF32[i24 + 136 >> 2]);
 f31 = Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(f32 * f26)) + Math_fround(f29 * f19));
 f30 = Math_fround(Math_fround(Math_fround(f33 * f27) + Math_fround(f32 * f25)) + Math_fround(f29 * f22));
 f29 = Math_fround(Math_fround(Math_fround(f33 * f13) + Math_fround(f32 * f10)) + Math_fround(f29 * f18));
 i24 = f31 > f30 & f31 > f29;
 i23 = f30 > f29;
 f13 = i24 ? f28 : i23 ? f27 : f13;
 f10 = i24 ? f26 : i23 ? f25 : f10;
 f18 = i24 ? f19 : i23 ? f22 : f18;
 f22 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f9 = Math_fround(f22 + Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f20 * f13) + Math_fround(f9 * f10))));
 f11 = Math_fround(f19 + Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f7 * f13) + Math_fround(f11 * f10))));
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) + Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f12 * f13) + Math_fround(f14 * f10))));
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i5 + 96 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 100 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 104 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * f13)) + Math_fround(f15 * f12));
 f8 = Math_fround(HEAPF32[i5 + 112 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 116 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 120 >> 2]);
 i5 = f18 > Math_fround(Math_fround(Math_fround(f17 * f8) + Math_fround(f16 * f7)) + Math_fround(f15 * f6));
 f8 = i5 ? f14 : f8;
 f7 = i5 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 8 | 0;
 i20 = i22;
 i13 = i22 + 16 | 0;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i20;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i13 >> 2] = 0;
 i10 = i13 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i13 + 16 | 0;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i19, i20);
 i20 = HEAP32[i19 + 4 >> 2] | 0;
 i14 = i12;
 HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i14 + 4 >> 2] = i20;
 HEAP32[i11 >> 2] = 100;
 HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 400, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
 i14 = i9 + 192 | 0;
 L1 : do if (!(HEAP8[i14 >> 0] | 0)) {
  i15 = i9 + 168 | 0;
  i16 = i9 + 172 | 0;
  i17 = i9 + 148 | 0;
  i18 = i9 + 124 | 0;
  i19 = i9 + 120 | 0;
  i20 = i9 + 128 | 0;
  do {
   HEAP32[i10 >> 2] = 0;
   i1 = HEAP32[i15 >> 2] | 0;
   i7 = HEAP32[i16 >> 2] | 0;
   i8 = i1 + (i7 * 20 | 0) | 0;
   L5 : do if (!i7) i21 = 11; else {
    i3 = HEAP32[i17 >> 2] | 0;
    do {
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) != (i2 | 0)) {
      if (!(HEAP8[i18 >> 0] | 0)) {
       i21 = 11;
       break L5;
      }
      if (!(HEAP32[i19 >> 2] | 0)) {
       i21 = 11;
       break L5;
      }
      if ((HEAP32[i20 >> 2] | 0) != (i2 | 0)) {
       i21 = 11;
       break L5;
      }
     }
     i1 = i1 + 20 | 0;
    } while ((i1 | 0) != (i8 | 0));
   } while (0);
   if ((i21 | 0) == 11) {
    i21 = 0;
    if ((i1 | 0) != (i8 | 0)) do {
     if (!(HEAP8[i1 + 18 >> 0] | 0)) {
      i3 = i1 + 4 | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i5 = i4 + 1 | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i5 >>> 0 > i7 >>> 0) {
       i2 = i6 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i11 >> 2] = i2;
        HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
        HEAP32[i11 >> 2] = i2;
        HEAP32[i13 >> 2] = i7;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = i5;
      HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
     }
     i1 = i1 + 20 | 0;
     L28 : do if ((i1 | 0) == (i8 | 0)) i1 = i8; else {
      i3 = HEAP32[i17 >> 2] | 0;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if ((i3 | 0) != (i2 | 0)) {
        if (!(HEAP8[i18 >> 0] | 0)) break L28;
        if (!(HEAP32[i19 >> 2] | 0)) break L28;
        if ((HEAP32[i20 >> 2] | 0) != (i2 | 0)) break L28;
       }
       i1 = i1 + 20 | 0;
       if ((i1 | 0) == (i8 | 0)) {
        i1 = i8;
        break;
       }
      }
     } while (0);
    } while ((i1 | 0) != ((HEAP32[i15 >> 2] | 0) + ((HEAP32[i16 >> 2] | 0) * 20 | 0) | 0));
   }
   if (!(HEAP32[i10 >> 2] | 0)) break L1; else i1 = 0;
   do {
    if (HEAP8[i14 >> 0] | 0) break L1;
    __ZN17PersistentManager18ReadObjectThreadedEi(i9, HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  } while (!(HEAP8[i14 >> 0] | 0));
 } while (0);
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i22;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i12);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i22;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertINS_11__wrap_iterIPS6_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESC_E4typeENSA_IPKS6_EESE_SE_(i12, i1, i2, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i6 = i7;
 i1 = i7 + ((((HEAP32[i1 >> 2] | 0) - i6 | 0) / 12 | 0) * 12 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i13 = i4 - i2 | 0;
 i8 = (i13 | 0) / 12 | 0;
 i10 = i4;
 if ((i13 | 0) <= 0) {
  i13 = i1;
  return i13 | 0;
 }
 i11 = i12 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i13 = i12 + 4 | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 i5 = i9;
 if ((i8 | 0) <= ((i3 - i5 | 0) / 12 | 0 | 0)) {
  i6 = i5 - i1 | 0;
  i3 = (i6 | 0) / 12 | 0;
  if ((i8 | 0) > (i3 | 0)) {
   i5 = i2 + (i3 * 12 | 0) | 0;
   i4 = i5;
   if ((i5 | 0) == (i10 | 0)) i3 = i9; else {
    i3 = i9;
    do {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i5);
     i5 = i5 + 12 | 0;
     i3 = (HEAP32[i13 >> 2] | 0) + 12 | 0;
     HEAP32[i13 >> 2] = i3;
    } while ((i5 | 0) != (i10 | 0));
   }
   if ((i6 | 0) <= 0) {
    i13 = i1;
    return i13 | 0;
   }
  } else i3 = i9;
  i7 = i3 - (i1 + (i8 * 12 | 0)) | 0;
  i5 = i1 + (((i7 | 0) / 12 | 0) * 12 | 0) | 0;
  if (i5 >>> 0 < i9 >>> 0) {
   i6 = i5;
   i8 = i3;
   do {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i6);
    i6 = i6 + 12 | 0;
    i8 = (HEAP32[i13 >> 2] | 0) + 12 | 0;
    HEAP32[i13 >> 2] = i8;
   } while (i6 >>> 0 < i9 >>> 0);
  }
  if (i7 | 0) do {
   i3 = i3 + -12 | 0;
   i5 = i5 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i5) | 0;
  } while ((i5 | 0) != (i1 | 0));
  if ((i2 | 0) == (i4 | 0)) {
   i13 = i1;
   return i13 | 0;
  } else i3 = i1;
  while (1) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
   i2 = i2 + 12 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 12 | 0;
  }
  return i1 | 0;
 }
 i5 = ((i5 - i6 | 0) / 12 | 0) + i8 | 0;
 if (i5 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i4 = HEAP32[i12 >> 2] | 0;
  i7 = i4;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i4 = i6;
 i9 = (i3 - i4 | 0) / 12 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 178956970 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 357913941;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 12 | 0) | 0;
 i9 = i5 + (((i1 - i4 | 0) / 12 | 0) * 12 | 0) | 0;
 i6 = i9;
 i8 = i5 + (i3 * 12 | 0) | 0;
 if ((i2 | 0) == (i10 | 0)) i4 = i6; else {
  i3 = i6;
  i4 = i9;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
   i4 = i3 + 12 | 0;
   i3 = i4;
   i2 = i2 + 12 | 0;
  } while ((i2 | 0) != (i10 | 0));
  i4 = i3;
  i7 = HEAP32[i12 >> 2] | 0;
 }
 if ((i7 | 0) == (i1 | 0)) i3 = i9; else {
  i5 = i1;
  i2 = i6;
  i3 = i9;
  do {
   i5 = i5 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + -12 | 0, i5);
   i3 = i2 + -12 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i7 | 0));
  i6 = i2;
 }
 i5 = HEAP32[i13 >> 2] | 0;
 if ((i5 | 0) != (i1 | 0)) {
  i3 = i4;
  i2 = i4;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1);
   i1 = i1 + 12 | 0;
   i2 = i3 + 12 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i4 = i3;
  i3 = i6;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i8;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i2) {
  i13 = i9;
  return i13 | 0;
 }
 __ZdlPv(i2);
 i13 = i9;
 return i13 | 0;
}

function runPostSets169() {
 HEAP32[gb + 148532 >> 2] = fb + 224;
 HEAP32[gb + 148536 >> 2] = fb + 378;
 HEAP32[gb + 148540 >> 2] = fb + 379;
 HEAP32[gb + 148544 >> 2] = fb + 2060;
 HEAP32[gb + 148556 >> 2] = fb + 2061;
 HEAP32[gb + 148560 >> 2] = fb + 2062;
 HEAP32[gb + 148572 >> 2] = fb + 2063;
 HEAP32[gb + 148576 >> 2] = fb + 2064;
 HEAP32[gb + 148588 >> 2] = fb + 2065;
 HEAP32[gb + 148592 >> 2] = fb + 2066;
 HEAP32[gb + 148604 >> 2] = fb + 2067;
 HEAP32[gb + 148608 >> 2] = fb + 2068;
 HEAP32[gb + 148620 >> 2] = fb + 2069;
 HEAP32[gb + 148624 >> 2] = fb + 2070;
 HEAP32[gb + 148636 >> 2] = fb + 2069;
 HEAP32[gb + 148640 >> 2] = fb + 2071;
 HEAP32[gb + 148652 >> 2] = fb + 2056;
 HEAP32[gb + 148656 >> 2] = fb + 2072;
 HEAP32[gb + 148668 >> 2] = fb + 2073;
 HEAP32[gb + 148672 >> 2] = fb + 2074;
 HEAP32[gb + 148676 >> 2] = fb + 225;
 HEAP32[gb + 148680 >> 2] = fb + 226;
 HEAP32[gb + 148692 >> 2] = fb + 2075;
 HEAP32[gb + 148696 >> 2] = fb + 2076;
 HEAP32[gb + 148708 >> 2] = fb + 2077;
 HEAP32[gb + 148712 >> 2] = fb + 2078;
 HEAP32[gb + 148716 >> 2] = fb + 227;
 HEAP32[gb + 148728 >> 2] = fb + 2075;
 HEAP32[gb + 148732 >> 2] = fb + 2079;
 HEAP32[gb + 148744 >> 2] = fb + 2080;
 HEAP32[gb + 148748 >> 2] = fb + 2081;
 HEAP32[gb + 148760 >> 2] = fb + 2080;
 HEAP32[gb + 148764 >> 2] = fb + 2082;
 HEAP32[gb + 148776 >> 2] = fb + 2083;
 HEAP32[gb + 148780 >> 2] = fb + 2084;
 HEAP32[gb + 148792 >> 2] = fb + 2085;
 HEAP32[gb + 148796 >> 2] = fb + 2086;
 HEAP32[gb + 148808 >> 2] = fb + 2087;
 HEAP32[gb + 148812 >> 2] = fb + 2088;
 HEAP32[gb + 148824 >> 2] = fb + 2089;
 HEAP32[gb + 148828 >> 2] = fb + 2090;
 HEAP32[gb + 148840 >> 2] = fb + 2091;
 HEAP32[gb + 148844 >> 2] = fb + 2092;
 HEAP32[gb + 148856 >> 2] = fb + 2093;
 HEAP32[gb + 148860 >> 2] = fb + 2094;
 HEAP32[gb + 148872 >> 2] = fb + 2095;
 HEAP32[gb + 148876 >> 2] = fb + 2096;
 HEAP32[gb + 148888 >> 2] = fb + 2093;
 HEAP32[gb + 148892 >> 2] = fb + 2097;
 HEAP32[gb + 148904 >> 2] = fb + 2091;
 HEAP32[gb + 148908 >> 2] = fb + 2098;
 HEAP32[gb + 148920 >> 2] = fb + 2089;
 HEAP32[gb + 148924 >> 2] = fb + 2099;
 HEAP32[gb + 148936 >> 2] = fb + 2085;
 HEAP32[gb + 148940 >> 2] = fb + 2100;
 HEAP32[gb + 148952 >> 2] = fb + 2101;
 HEAP32[gb + 148956 >> 2] = fb + 2102;
 HEAP32[gb + 148968 >> 2] = fb + 2103;
 HEAP32[gb + 148972 >> 2] = fb + 2104;
 HEAP32[gb + 148984 >> 2] = fb + 2105;
 HEAP32[gb + 148988 >> 2] = fb + 2106;
 HEAP32[gb + 148992 >> 2] = fb + 1411;
 HEAP32[gb + 149004 >> 2] = fb + 2107;
 HEAP32[gb + 149008 >> 2] = fb + 2108;
 HEAP32[gb + 149012 >> 2] = fb + 2109;
 HEAP32[gb + 149016 >> 2] = fb + 2110;
 HEAP32[gb + 149020 >> 2] = fb + 1012;
 HEAP32[gb + 149024 >> 2] = fb + 2111;
 HEAP32[gb + 149028 >> 2] = fb + 1013;
 HEAP32[gb + 149032 >> 2] = fb + 2112;
 HEAP32[gb + 149036 >> 2] = fb + 228;
 HEAP32[gb + 149040 >> 2] = fb + 229;
 HEAP32[gb + 149044 >> 2] = fb + 1014;
 HEAP32[gb + 149048 >> 2] = fb + 1015;
 HEAP32[gb + 149052 >> 2] = fb + 1016;
 HEAP32[gb + 149056 >> 2] = fb + 1017;
 HEAP32[gb + 149068 >> 2] = fb + 2113;
 HEAP32[gb + 149072 >> 2] = fb + 2114;
 HEAP32[gb + 149076 >> 2] = fb + 230;
 HEAP32[gb + 149080 >> 2] = fb + 1018;
 HEAP32[gb + 149084 >> 2] = fb + 2115;
 HEAP32[gb + 149088 >> 2] = fb + 2116;
 HEAP32[gb + 149092 >> 2] = fb + 1019;
 HEAP32[gb + 149104 >> 2] = fb + 2117;
 HEAP32[gb + 149108 >> 2] = fb + 2118;
 HEAP32[gb + 149112 >> 2] = fb + 231;
 HEAP32[gb + 149116 >> 2] = fb + 1020;
 HEAP32[gb + 149120 >> 2] = fb + 2119;
 HEAP32[gb + 149124 >> 2] = fb + 2120;
 HEAP32[gb + 149128 >> 2] = fb + 1021;
 HEAP32[gb + 149132 >> 2] = fb + 1022;
 HEAP32[gb + 149144 >> 2] = fb + 2121;
 HEAP32[gb + 149148 >> 2] = fb + 2122;
 HEAP32[gb + 149152 >> 2] = fb + 1;
 HEAP32[gb + 149156 >> 2] = fb + 1;
 HEAP32[gb + 149160 >> 2] = fb + 1;
 HEAP32[gb + 149164 >> 2] = fb + 1;
 HEAP32[gb + 149168 >> 2] = fb + 1;
 HEAP32[gb + 149172 >> 2] = fb + 1;
 HEAP32[gb + 149184 >> 2] = fb + 2123;
 runPostSets170();
}

function _ft_stroker_arcto(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i29 + 32 | 0;
 i14 = i29 + 24 | 0;
 i23 = i29 + 16 | 0;
 i25 = i29 + 8 | 0;
 i26 = i29;
 i27 = HEAP32[i1 + 60 >> 2] | 0;
 i4 = Math_imul(i2, -11796480) | 0;
 i3 = _UNITY_FT_Angle_Diff(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 i3 = (i3 | 0) == 11796480 ? -5898240 - i4 << 1 : i3;
 i4 = i4 + 5898240 + (HEAP32[i1 >> 2] | 0) | 0;
 _UNITY_FT_Vector_From_Polar(i14, i27, i4);
 i11 = i1 + 8 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP32[i11 >> 2] | 0);
 i12 = i1 + 12 | 0;
 i13 = i14 + 4 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + (HEAP32[i12 >> 2] | 0);
 i15 = (i3 >> 31 & -11796480) + 5898240 | 0;
 if (!i3) {
  i28 = 0;
  i27 = i1 + 64 + (i2 << 5) + 16 | 0;
  HEAP8[i27 >> 0] = 0;
  STACKTOP = i29;
  return i28 | 0;
 }
 i16 = i23 + 4 | 0;
 i17 = i25 + 4 | 0;
 i18 = i26 + 4 | 0;
 i19 = i1 + 64 + (i2 << 5) + 4 | 0;
 i20 = i1 + 64 + (i2 << 5) | 0;
 i21 = i1 + 64 + (i2 << 5) + 24 | 0;
 i22 = i1 + 64 + (i2 << 5) + 8 | 0;
 i24 = i1 + 64 + (i2 << 5) + 12 | 0;
 i1 = i1 + 64 + (i2 << 5) + 16 | 0;
 while (1) {
  i9 = (i3 | 0) > 5898240 ? 5898240 : (i3 | 0) < -5898240 ? -5898240 : i3;
  i2 = i4;
  i4 = i9 + i4 | 0;
  i7 = ((i9 | 0) < 0 ? 0 - i9 | 0 : i9) >> 1;
  _UNITY_FT_Vector_From_Polar(i23, i27, i4);
  HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + (HEAP32[i11 >> 2] | 0);
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + (HEAP32[i12 >> 2] | 0);
  i5 = (_UNITY_FT_Sin(i7) | 0) << 2;
  i7 = _UNITY_FT_MulDiv(i27, i5, ((_UNITY_FT_Cos(i7) | 0) * 3 | 0) + 196608 | 0) | 0;
  _UNITY_FT_Vector_From_Polar(i25, i7, i2 + i15 | 0);
  HEAP32[i25 >> 2] = (HEAP32[i25 >> 2] | 0) + (HEAP32[i14 >> 2] | 0);
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + (HEAP32[i13 >> 2] | 0);
  _UNITY_FT_Vector_From_Polar(i26, i7, i4 - i15 | 0);
  HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + (HEAP32[i23 >> 2] | 0);
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + (HEAP32[i16 >> 2] | 0);
  i7 = HEAP32[i19 >> 2] | 0;
  i2 = HEAP32[i20 >> 2] | 0;
  i5 = i2 + 3 | 0;
  HEAP32[i10 >> 2] = 0;
  if (i5 >>> 0 > i7 >>> 0) {
   i6 = HEAP32[i21 >> 2] | 0;
   i8 = i7;
   do i8 = i8 + 16 + (i8 >>> 1) | 0; while (i8 >>> 0 < i5 >>> 0);
   HEAP32[i22 >> 2] = _UNITY_ft_mem_realloc(i6, 8, i7, i8, HEAP32[i22 >> 2] | 0, i10) | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) break;
   i6 = _UNITY_ft_mem_realloc(i6, 1, i7, i8, HEAP32[i24 >> 2] | 0, i10) | 0;
   HEAP32[i24 >> 2] = i6;
   i2 = HEAP32[i10 >> 2] | 0;
   if (i2 | 0) break;
   HEAP32[i19 >> 2] = i8;
   i5 = HEAP32[i20 >> 2] | 0;
   i2 = i6;
  } else {
   i5 = i2;
   i2 = HEAP32[i24 >> 2] | 0;
  }
  i7 = (HEAP32[i22 >> 2] | 0) + (i5 << 3) | 0;
  i6 = i2 + i5 | 0;
  i5 = i25;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i7;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i8;
  i2 = i26;
  i8 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i7 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i8;
  i5 = i23;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i7 + 16 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP8[i6 >> 0] = 2;
  HEAP8[i6 + 1 >> 0] = 2;
  HEAP8[i6 + 2 >> 0] = 1;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + 3;
  HEAP8[i1 >> 0] = 0;
  i6 = i23;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i14;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i3 = i3 - i9 | 0;
  if (!i3) {
   i2 = 0;
   i28 = 13;
   break;
  }
 }
 if ((i28 | 0) == 13) {
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i29;
  return i2 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i28 = i2;
 i27 = i1;
 HEAP8[i27 >> 0] = 0;
 STACKTOP = i29;
 return i28 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleNoDriveEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 256 | 0;
 i13 = i11 + 308 | 0;
 i16 = i11 + 200 | 0;
 i21 = i11;
 i6 = i11 + 252 | 0;
 i10 = i11 + 184 | 0;
 i9 = i11 + 168 | 0;
 i15 = i11 + 16 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i20 = i10;
 i19 = i9;
 i18 = i5;
 i17 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i14 >> 2] = i20;
 HEAP32[i14 + 4 >> 2] = i19;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i18;
 HEAP32[i14 + 24 >> 2] = i17;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i15 + 36 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i15 + 52 | 0, 4);
 HEAP32[i16 >> 2] = i20;
 HEAP32[i16 + 4 >> 2] = i19;
 i3 = i16 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i16 + 20 >> 2] = i18;
 HEAP32[i16 + 24 >> 2] = i17;
 HEAP32[i16 + 28 >> 2] = i1;
 HEAP32[i16 + 32 >> 2] = i4;
 HEAP8[i16 + 36 >> 0] = 1;
 HEAP32[i16 + 40 >> 2] = i5;
 HEAP32[i16 + 44 >> 2] = 0;
 HEAP32[i16 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 0, i15 + 68 | 0, i14);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 1, i15 + 92 | 0, i14);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i16, 2, i15 + 116 | 0, i14);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i21 = i8 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i20 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i20;
 i22 = i8 + 9 | 0;
 HEAP8[i22 >> 0] = (i20 & 65535) >>> 8;
 i20 = i8 + 12 | 0;
 i19 = i5 + 12 | 0;
 i15 = i19;
 i18 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i8 + 20 | 0;
 i18 = i5 + 20 | 0;
 i15 = i18;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i21 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i21 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i21;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
 HEAP8[i22 >> 0] = i4;
 i4 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i22 = i20;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = i21;
 HEAP32[i20 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i20 = i17;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 65;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0;
 i13 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i13) return;
 i8 = HEAP32[i1 + 520 >> 2] | 0;
 i9 = i11 + 32 | 0;
 i10 = i11 + 4 | 0;
 i2 = i11 + 8 | 0;
 i3 = i11 + 12 | 0;
 i4 = i11 + 16 | 0;
 i5 = i11 + 20 | 0;
 i6 = i11 + 24 | 0;
 i7 = i11 + 28 | 0;
 i1 = 0;
 do {
  i20 = i8 + (i1 << 2) | 0;
  f35 = Math_fround(HEAPF32[i20 >> 2]);
  f33 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f35 = Math_fround(f35 * Math_fround(.00999999977));
  f33 = Math_fround(f33 * Math_fround(.00999999977));
  f31 = Math_fround(f31 * Math_fround(.00999999977));
  f29 = Math_fround(Math_fround(HEAPF32[i20 + 12 >> 2]) * Math_fround(.00999999977));
  i20 = i12 + (i1 << 2) | 0;
  f22 = Math_fround(HEAPF32[i20 >> 2]);
  i18 = i20 + 4 | 0;
  f26 = Math_fround(HEAPF32[i18 >> 2]);
  i16 = i20 + 8 | 0;
  f25 = Math_fround(HEAPF32[i16 >> 2]);
  i14 = i20 + 12 | 0;
  f24 = Math_fround(HEAPF32[i14 >> 2]);
  f28 = Math_fround(HEAPF32[i9 >> 2]);
  f40 = Math_fround(HEAPF32[i11 >> 2]);
  f21 = Math_fround(f35 * f40);
  f19 = Math_fround(f33 * f40);
  f17 = Math_fround(f31 * f40);
  f40 = Math_fround(f29 * f40);
  f15 = Math_fround(HEAPF32[i10 >> 2]);
  f21 = Math_fround(f35 * Math_fround(f21 + f15));
  f19 = Math_fround(f33 * Math_fround(f19 + f15));
  f17 = Math_fround(f31 * Math_fround(f17 + f15));
  f15 = Math_fround(f29 * Math_fround(f40 + f15));
  f40 = Math_fround(HEAPF32[i2 >> 2]);
  f21 = Math_fround(f35 * Math_fround(f40 + f21));
  f19 = Math_fround(f33 * Math_fround(f40 + f19));
  f17 = Math_fround(f31 * Math_fround(f40 + f17));
  f15 = Math_fround(f29 * Math_fround(f40 + f15));
  f40 = Math_fround(HEAPF32[i3 >> 2]);
  f21 = Math_fround(f40 + f21);
  f19 = Math_fround(f40 + f19);
  f17 = Math_fround(f40 + f17);
  f15 = Math_fround(f40 + f15);
  f40 = Math_fround(f35 - f28);
  f39 = Math_fround(f33 - f28);
  f38 = Math_fround(f31 - f28);
  f37 = Math_fround(f29 - f28);
  f36 = Math_fround(HEAPF32[i4 >> 2]);
  f34 = Math_fround(f40 * f36);
  f32 = Math_fround(f39 * f36);
  f30 = Math_fround(f38 * f36);
  f36 = Math_fround(f37 * f36);
  f27 = Math_fround(HEAPF32[i5 >> 2]);
  f34 = Math_fround(f40 * Math_fround(f34 + f27));
  f32 = Math_fround(f39 * Math_fround(f32 + f27));
  f30 = Math_fround(f38 * Math_fround(f30 + f27));
  f27 = Math_fround(f37 * Math_fround(f36 + f27));
  f36 = Math_fround(HEAPF32[i6 >> 2]);
  f34 = Math_fround(f40 * Math_fround(f36 + f34));
  f32 = Math_fround(f39 * Math_fround(f36 + f32));
  f30 = Math_fround(f38 * Math_fround(f36 + f30));
  f27 = Math_fround(f37 * Math_fround(f36 + f27));
  f36 = Math_fround(HEAPF32[i7 >> 2]);
  f34 = Math_fround(f36 + f34);
  f32 = Math_fround(f36 + f32);
  f30 = Math_fround(f36 + f30);
  f27 = Math_fround(f36 + f27);
  f21 = f35 > f28 ? f34 : f21;
  f19 = f33 > f28 ? f32 : f19;
  f17 = f31 > f28 ? f30 : f17;
  f15 = f29 > f28 ? f27 : f15;
  i23 = f21 < Math_fround(0.0);
  f21 = i23 ? Math_fround(0.0) : f21;
  i23 = f19 < Math_fround(0.0);
  f19 = i23 ? Math_fround(0.0) : f19;
  i23 = f17 < Math_fround(0.0);
  f17 = i23 ? Math_fround(0.0) : f17;
  i23 = f15 < Math_fround(0.0);
  f19 = Math_fround(f26 * f19);
  f17 = Math_fround(f25 * f17);
  f15 = Math_fround(f24 * (i23 ? Math_fround(0.0) : f15));
  HEAPF32[i20 >> 2] = Math_fround(f22 * f21);
  HEAPF32[i18 >> 2] = f19;
  HEAPF32[i16 >> 2] = f17;
  HEAPF32[i14 >> 2] = f15;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i13 >>> 0);
 return;
}

function runPostSets167() {
 HEAP32[gb + 147464 >> 2] = fb + 469;
 HEAP32[gb + 147468 >> 2] = fb + 1129;
 HEAP32[gb + 147472 >> 2] = fb + 1974;
 HEAP32[gb + 147484 >> 2] = fb + 72;
 HEAP32[gb + 147488 >> 2] = fb + 988;
 HEAP32[gb + 147492 >> 2] = fb + 1975;
 HEAP32[gb + 147504 >> 2] = fb + 1125;
 HEAP32[gb + 147508 >> 2] = fb + 1976;
 HEAP32[gb + 147512 >> 2] = fb + 1258;
 HEAP32[gb + 147516 >> 2] = fb + 993;
 HEAP32[gb + 147520 >> 2] = fb + 1127;
 HEAP32[gb + 147524 >> 2] = fb + 1128;
 HEAP32[gb + 147528 >> 2] = fb + 469;
 HEAP32[gb + 147532 >> 2] = fb + 1129;
 HEAP32[gb + 147536 >> 2] = fb + 1977;
 HEAP32[gb + 147548 >> 2] = fb + 1125;
 HEAP32[gb + 147552 >> 2] = fb + 1978;
 HEAP32[gb + 147556 >> 2] = fb + 1258;
 HEAP32[gb + 147560 >> 2] = fb + 994;
 HEAP32[gb + 147564 >> 2] = fb + 1127;
 HEAP32[gb + 147568 >> 2] = fb + 1128;
 HEAP32[gb + 147572 >> 2] = fb + 469;
 HEAP32[gb + 147576 >> 2] = fb + 1129;
 HEAP32[gb + 147580 >> 2] = fb + 1979;
 HEAP32[gb + 147592 >> 2] = fb + 1125;
 HEAP32[gb + 147596 >> 2] = fb + 1980;
 HEAP32[gb + 147600 >> 2] = fb + 1258;
 HEAP32[gb + 147604 >> 2] = fb + 995;
 HEAP32[gb + 147608 >> 2] = fb + 1127;
 HEAP32[gb + 147612 >> 2] = fb + 1128;
 HEAP32[gb + 147616 >> 2] = fb + 469;
 HEAP32[gb + 147620 >> 2] = fb + 1129;
 HEAP32[gb + 147624 >> 2] = fb + 1981;
 HEAP32[gb + 147636 >> 2] = fb + 1125;
 HEAP32[gb + 147640 >> 2] = fb + 1982;
 HEAP32[gb + 147644 >> 2] = fb + 1258;
 HEAP32[gb + 147648 >> 2] = fb + 996;
 HEAP32[gb + 147652 >> 2] = fb + 1127;
 HEAP32[gb + 147656 >> 2] = fb + 1128;
 HEAP32[gb + 147660 >> 2] = fb + 469;
 HEAP32[gb + 147664 >> 2] = fb + 1129;
 HEAP32[gb + 147668 >> 2] = fb + 1983;
 HEAP32[gb + 147676 >> 2] = fb + 116;
 HEAP32[gb + 147680 >> 2] = fb + 117;
 HEAP32[gb + 147684 >> 2] = fb + 116;
 HEAP32[gb + 147688 >> 2] = fb + 117;
 HEAP32[gb + 147692 >> 2] = fb + 116;
 HEAP32[gb + 147696 >> 2] = fb + 116;
 HEAP32[gb + 147708 >> 2] = fb + 1984;
 HEAP32[gb + 147712 >> 2] = fb + 1985;
 HEAP32[gb + 147716 >> 2] = fb + 117;
 HEAP32[gb + 147720 >> 2] = fb + 1394;
 HEAP32[gb + 147724 >> 2] = fb + 1395;
 HEAP32[gb + 147728 >> 2] = fb + 1986;
 HEAP32[gb + 147740 >> 2] = fb + 1987;
 HEAP32[gb + 147744 >> 2] = fb + 1988;
 HEAP32[gb + 147748 >> 2] = fb + 118;
 HEAP32[gb + 147752 >> 2] = fb + 1396;
 HEAP32[gb + 147764 >> 2] = fb + 1989;
 HEAP32[gb + 147768 >> 2] = fb + 1990;
 HEAP32[gb + 147772 >> 2] = fb + 119;
 HEAP32[gb + 147776 >> 2] = fb + 1397;
 HEAP32[gb + 147780 >> 2] = fb + 1991;
 HEAP32[gb + 147784 >> 2] = fb + 1398;
 HEAP32[gb + 147788 >> 2] = fb + 1399;
 HEAP32[gb + 147792 >> 2] = fb + 997;
 HEAP32[gb + 147796 >> 2] = fb + 1992;
 HEAP32[gb + 147808 >> 2] = fb + 1993;
 HEAP32[gb + 147812 >> 2] = fb + 1994;
 HEAP32[gb + 147816 >> 2] = fb + 1400;
 HEAP32[gb + 147820 >> 2] = fb + 1401;
 HEAP32[gb + 147824 >> 2] = fb + 998;
 HEAP32[gb + 147836 >> 2] = fb + 1995;
 HEAP32[gb + 147840 >> 2] = fb + 1996;
 HEAP32[gb + 147844 >> 2] = fb + 1997;
 HEAP32[gb + 147856 >> 2] = fb + 1998;
 HEAP32[gb + 147860 >> 2] = fb + 1999;
 HEAP32[gb + 147864 >> 2] = fb + 2e3;
 HEAP32[gb + 147868 >> 2] = fb + 385;
 HEAP32[gb + 147872 >> 2] = fb + 2001;
 HEAP32[gb + 147884 >> 2] = fb + 2002;
 HEAP32[gb + 147888 >> 2] = fb + 2003;
 HEAP32[gb + 147892 >> 2] = fb + 2e3;
 HEAP32[gb + 147896 >> 2] = fb + 385;
 HEAP32[gb + 147900 >> 2] = fb + 2001;
 HEAP32[gb + 147912 >> 2] = fb + 2004;
 HEAP32[gb + 147916 >> 2] = fb + 2005;
 HEAP32[gb + 147920 >> 2] = fb + 2006;
 HEAP32[gb + 147924 >> 2] = fb + 2007;
 HEAP32[gb + 147928 >> 2] = fb + 999;
 HEAP32[gb + 147932 >> 2] = fb + 1e3;
 HEAP32[gb + 147936 >> 2] = fb + 1001;
 HEAP32[gb + 147940 >> 2] = fb + 2008;
 HEAP32[gb + 147944 >> 2] = fb + 1002;
 HEAP32[gb + 147948 >> 2] = fb + 1003;
 HEAP32[gb + 147952 >> 2] = fb + 2009;
 HEAP32[gb + 147956 >> 2] = fb + 2010;
 HEAP32[gb + 147960 >> 2] = fb + 1004;
 HEAP32[gb + 147964 >> 2] = fb + 2011;
 HEAP32[gb + 147968 >> 2] = fb + 386;
 runPostSets168();
}

function runPostSets172() {
 HEAP32[gb + 150324 >> 2] = fb + 1469;
 HEAP32[gb + 150336 >> 2] = fb + 2105;
 HEAP32[gb + 150340 >> 2] = fb + 2193;
 HEAP32[gb + 150344 >> 2] = fb + 1470;
 HEAP32[gb + 150356 >> 2] = fb + 2105;
 HEAP32[gb + 150360 >> 2] = fb + 2194;
 HEAP32[gb + 150364 >> 2] = fb + 1471;
 HEAP32[gb + 150376 >> 2] = fb + 2105;
 HEAP32[gb + 150380 >> 2] = fb + 2195;
 HEAP32[gb + 150384 >> 2] = fb + 1472;
 HEAP32[gb + 150396 >> 2] = fb + 2105;
 HEAP32[gb + 150400 >> 2] = fb + 2196;
 HEAP32[gb + 150404 >> 2] = fb + 1473;
 HEAP32[gb + 150416 >> 2] = fb + 2105;
 HEAP32[gb + 150420 >> 2] = fb + 2197;
 HEAP32[gb + 150424 >> 2] = fb + 1474;
 HEAP32[gb + 150436 >> 2] = fb + 2198;
 HEAP32[gb + 150440 >> 2] = fb + 2199;
 HEAP32[gb + 150444 >> 2] = fb + 403;
 HEAP32[gb + 150448 >> 2] = fb + 2200;
 HEAP32[gb + 150460 >> 2] = fb + 2201;
 HEAP32[gb + 150464 >> 2] = fb + 2202;
 HEAP32[gb + 150468 >> 2] = fb + 1475;
 HEAP32[gb + 150472 >> 2] = fb + 1476;
 HEAP32[gb + 150476 >> 2] = fb + 1032;
 HEAP32[gb + 150480 >> 2] = fb + 2203;
 HEAP32[gb + 150484 >> 2] = fb + 2204;
 HEAP32[gb + 150488 >> 2] = fb + 1477;
 HEAP32[gb + 150492 >> 2] = fb + 404;
 HEAP32[gb + 150496 >> 2] = fb + 405;
 HEAP32[gb + 150500 >> 2] = fb + 406;
 HEAP32[gb + 150504 >> 2] = fb + 63;
 HEAP32[gb + 150508 >> 2] = fb + 407;
 HEAP32[gb + 150512 >> 2] = fb + 6;
 HEAP32[gb + 150516 >> 2] = fb + 3;
 HEAP32[gb + 150520 >> 2] = fb + 4;
 HEAP32[gb + 150524 >> 2] = fb + 3;
 HEAP32[gb + 150528 >> 2] = fb + 2205;
 HEAP32[gb + 150540 >> 2] = fb + 2206;
 HEAP32[gb + 150544 >> 2] = fb + 2207;
 HEAP32[gb + 150556 >> 2] = fb + 2206;
 HEAP32[gb + 150560 >> 2] = fb + 2208;
 HEAP32[gb + 150572 >> 2] = fb + 2209;
 HEAP32[gb + 150576 >> 2] = fb + 2210;
 HEAP32[gb + 150580 >> 2] = fb + 1478;
 HEAP32[gb + 150584 >> 2] = fb + 1479;
 HEAP32[gb + 150588 >> 2] = fb + 1480;
 HEAP32[gb + 150592 >> 2] = fb + 1481;
 HEAP32[gb + 150596 >> 2] = fb + 1482;
 HEAP32[gb + 150600 >> 2] = fb + 1483;
 HEAP32[gb + 150604 >> 2] = fb + 1484;
 HEAP32[gb + 150608 >> 2] = fb + 1033;
 HEAP32[gb + 150612 >> 2] = fb + 1034;
 HEAP32[gb + 150624 >> 2] = fb + 2211;
 HEAP32[gb + 150628 >> 2] = fb + 2212;
 HEAP32[gb + 150632 >> 2] = fb + 1485;
 HEAP32[gb + 150636 >> 2] = fb + 408;
 HEAP32[gb + 150640 >> 2] = fb + 409;
 HEAP32[gb + 150644 >> 2] = fb + 64;
 HEAP32[gb + 150648 >> 2] = fb + 65;
 HEAP32[gb + 150652 >> 2] = fb + 410;
 HEAP32[gb + 150656 >> 2] = fb + 2213;
 HEAP32[gb + 150660 >> 2] = fb + 1486;
 HEAP32[gb + 150664 >> 2] = fb + 1487;
 HEAP32[gb + 150668 >> 2] = fb + 74;
 HEAP32[gb + 150672 >> 2] = fb + 1035;
 HEAP32[gb + 150676 >> 2] = fb + 1036;
 HEAP32[gb + 150680 >> 2] = fb + 2214;
 HEAP32[gb + 150684 >> 2] = fb + 2215;
 HEAP32[gb + 150688 >> 2] = fb + 1488;
 HEAP32[gb + 150692 >> 2] = fb + 1489;
 HEAP32[gb + 150696 >> 2] = fb + 123;
 HEAP32[gb + 150700 >> 2] = fb + 1490;
 HEAP32[gb + 150712 >> 2] = fb + 2216;
 HEAP32[gb + 150716 >> 2] = fb + 2217;
 HEAP32[gb + 150720 >> 2] = fb + 1491;
 HEAP32[gb + 150724 >> 2] = fb + 1492;
 HEAP32[gb + 150736 >> 2] = fb + 2218;
 HEAP32[gb + 150740 >> 2] = fb + 2219;
 HEAP32[gb + 150744 >> 2] = fb + 124;
 HEAP32[gb + 150748 >> 2] = fb + 1493;
 HEAP32[gb + 150760 >> 2] = fb + 2220;
 HEAP32[gb + 150764 >> 2] = fb + 2221;
 HEAP32[gb + 150776 >> 2] = fb + 2222;
 HEAP32[gb + 150780 >> 2] = fb + 2223;
 HEAP32[gb + 150792 >> 2] = fb + 2224;
 HEAP32[gb + 150796 >> 2] = fb + 2225;
 HEAP32[gb + 150808 >> 2] = fb + 2224;
 HEAP32[gb + 150812 >> 2] = fb + 2226;
 HEAP32[gb + 150824 >> 2] = fb + 2227;
 HEAP32[gb + 150828 >> 2] = fb + 2228;
 HEAP32[gb + 150832 >> 2] = fb + 240;
 HEAP32[gb + 150836 >> 2] = fb + 1037;
 HEAP32[gb + 150840 >> 2] = fb + 2229;
 HEAP32[gb + 150844 >> 2] = fb + 2230;
 HEAP32[gb + 150848 >> 2] = fb + 1038;
 HEAP32[gb + 150852 >> 2] = fb + 1039;
 HEAP32[gb + 150864 >> 2] = fb + 2231;
 HEAP32[gb + 150868 >> 2] = fb + 2232;
 HEAP32[gb + 150872 >> 2] = fb + 241;
 runPostSets173();
}

function __ZN10ScSceneFnsIN5physx3Scb4BodyEE6insertERNS0_2Sc5SceneERS2_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 if (HEAP16[((i12 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i12 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 8 | 0 : HEAP32[i3 + 8 >> 2] | 0) >> 1] & 8) {
  __ZL22addOrRemoveRigidObjectILb0ELb1ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(HEAP32[i2 + 1236 >> 2] | 0, i3);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i2 + 1236 >> 2] | 0;
 do if (!i1) {
  i12 = i14 + 256 | 0;
  i9 = i14 + 260 | 0;
  HEAP32[i14 + 264 >> 2] = 0;
  i10 = i14 + 268 | 0;
  HEAP8[i12 >> 0] = 1;
  HEAP32[i9 >> 2] = i14;
  HEAP32[i10 >> 2] = 64;
  i11 = i13 + 256 | 0;
  HEAP8[i11 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i3, i15) | 0;
  __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj(i2, i3 + 16 | 0, HEAP32[i15 >> 2] | 0, i8, i1);
  i6 = HEAP32[i3 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i3 + i7 | 0;
    i3 = i3 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 >> 2] = i6;
    }
    __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i2);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i13 + 268 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i13 + 260 >> 2] | 0;
   if ((i13 | 0) == (i1 | 0)) {
    HEAP8[i11 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
  i15 = HEAP32[i10 >> 2] | 0;
  do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i14 | 0) == (i1 | 0)) {
    HEAP8[i12 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  } while (0);
 } else {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i3, i15) | 0;
  __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj(i2, i3 + 16 | 0, HEAP32[i15 >> 2] | 0, i8, i1);
  i6 = HEAP32[i3 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i3 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i2 = i3 + i7 | 0;
    i3 = i3 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 >> 2] = i6;
    }
    __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i2);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i10 + 260 >> 2] | 0;
   if ((i10 | 0) == (i1 | 0)) {
    HEAP8[i9 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZL22addOrRemoveRigidObjectILb0ELb0ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 820 | 0;
 i16 = i17 + 816 | 0;
 i10 = i17 + 544 | 0;
 i14 = i17;
 i13 = i17 + 272 | 0;
 if (i1 | 0) {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i2, i16) | 0;
  if (i8 | 0) {
   i6 = i1 + -12 | 0;
   i2 = (HEAP32[i2 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i4 + i7 | 0;
    i4 = i4 + i6 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i16 = HEAP32[i10 + 268 >> 2] | 0;
  if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
   STACKTOP = i17;
   return;
  }
  i1 = HEAP32[i10 + 260 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0)) {
   HEAP8[i9 >> 0] = 0;
   STACKTOP = i17;
   return;
  }
  if (!i1) {
   STACKTOP = i17;
   return;
  }
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  STACKTOP = i17;
  return;
 }
 i12 = i14 + 256 | 0;
 i9 = i14 + 260 | 0;
 HEAP32[i14 + 264 >> 2] = 0;
 i10 = i14 + 268 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 >> 2] = i14;
 HEAP32[i10 >> 2] = 64;
 i11 = i13 + 256 | 0;
 HEAP8[i11 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
 i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i7 = i1 + -16 | 0;
 i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i2, i16) | 0;
 if (i8 | 0) {
  i6 = i1 + -12 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + 2464 | 0;
  i5 = 0;
  do {
   i4 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i4 + i7 | 0;
   i4 = i4 + i6 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 & 268435456) {
    __ZN5physx3Scb5Shape9syncStateEv(i3);
    HEAP32[i15 >> 2] = i3;
    __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   if ((i1 & 251658240 | 0) == 16777216) {
    HEAP32[i4 >> 2] = i1 & 1073741823;
    HEAP32[i3 >> 2] = 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 i16 = HEAP32[i13 + 268 >> 2] | 0;
 do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i13 + 260 >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) {
   HEAP8[i11 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 } while (0);
 i16 = HEAP32[i10 >> 2] | 0;
 do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i14 | 0) == (i1 | 0)) {
   HEAP8[i12 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function runPostSets113() {
 HEAP32[gb + 101752 >> 2] = fb + 1132;
 HEAP32[gb + 101756 >> 2] = fb + 1471;
 HEAP32[gb + 101760 >> 2] = fb + 1472;
 HEAP32[gb + 101764 >> 2] = fb + 224;
 HEAP32[gb + 101776 >> 2] = fb + 1473;
 HEAP32[gb + 101780 >> 2] = fb + 1474;
 HEAP32[gb + 101784 >> 2] = fb + 328;
 HEAP32[gb + 101788 >> 2] = fb + 1133;
 HEAP32[gb + 101800 >> 2] = fb + 57;
 HEAP32[gb + 101804 >> 2] = fb + 225;
 HEAP32[gb + 101808 >> 2] = fb + 95;
 HEAP32[gb + 101812 >> 2] = fb + 1475;
 HEAP32[gb + 101816 >> 2] = fb + 58;
 HEAP32[gb + 101820 >> 2] = fb + 162;
 HEAP32[gb + 101824 >> 2] = fb + 59;
 HEAP32[gb + 101828 >> 2] = fb + 329;
 HEAP32[gb + 101832 >> 2] = fb + 1134;
 HEAP32[gb + 101836 >> 2] = fb + 1135;
 HEAP32[gb + 101840 >> 2] = fb + 1476;
 HEAP32[gb + 101844 >> 2] = fb + 1477;
 HEAP32[gb + 101848 >> 2] = fb + 226;
 HEAP32[gb + 101864 >> 2] = fb + 1125;
 HEAP32[gb + 101868 >> 2] = fb + 1478;
 HEAP32[gb + 101872 >> 2] = fb + 1258;
 HEAP32[gb + 101876 >> 2] = fb + 750;
 HEAP32[gb + 101880 >> 2] = fb + 1127;
 HEAP32[gb + 101884 >> 2] = fb + 1128;
 HEAP32[gb + 101888 >> 2] = fb + 469;
 HEAP32[gb + 101892 >> 2] = fb + 1129;
 HEAP32[gb + 101896 >> 2] = fb + 1479;
 HEAP32[gb + 101908 >> 2] = fb + 1125;
 HEAP32[gb + 101912 >> 2] = fb + 1480;
 HEAP32[gb + 101916 >> 2] = fb + 1258;
 HEAP32[gb + 101920 >> 2] = fb + 751;
 HEAP32[gb + 101924 >> 2] = fb + 1127;
 HEAP32[gb + 101928 >> 2] = fb + 1128;
 HEAP32[gb + 101932 >> 2] = fb + 469;
 HEAP32[gb + 101936 >> 2] = fb + 1129;
 HEAP32[gb + 101940 >> 2] = fb + 1481;
 HEAP32[gb + 101952 >> 2] = fb + 1455;
 HEAP32[gb + 101956 >> 2] = fb + 1482;
 HEAP32[gb + 101960 >> 2] = fb + 1457;
 HEAP32[gb + 101964 >> 2] = fb + 748;
 HEAP32[gb + 101968 >> 2] = fb + 1458;
 HEAP32[gb + 101972 >> 2] = fb + 1459;
 HEAP32[gb + 101976 >> 2] = fb + 749;
 HEAP32[gb + 101980 >> 2] = fb + 1460;
 HEAP32[gb + 101984 >> 2] = fb + 1483;
 HEAP32[gb + 101996 >> 2] = fb + 1455;
 HEAP32[gb + 102e3 >> 2] = fb + 1484;
 HEAP32[gb + 102004 >> 2] = fb + 1457;
 HEAP32[gb + 102008 >> 2] = fb + 748;
 HEAP32[gb + 102012 >> 2] = fb + 1458;
 HEAP32[gb + 102016 >> 2] = fb + 1459;
 HEAP32[gb + 102020 >> 2] = fb + 749;
 HEAP32[gb + 102024 >> 2] = fb + 1460;
 HEAP32[gb + 102028 >> 2] = fb + 1485;
 HEAP32[gb + 102040 >> 2] = fb + 1125;
 HEAP32[gb + 102044 >> 2] = fb + 1486;
 HEAP32[gb + 102048 >> 2] = fb + 1258;
 HEAP32[gb + 102052 >> 2] = fb + 752;
 HEAP32[gb + 102056 >> 2] = fb + 1127;
 HEAP32[gb + 102060 >> 2] = fb + 1128;
 HEAP32[gb + 102064 >> 2] = fb + 469;
 HEAP32[gb + 102068 >> 2] = fb + 1129;
 HEAP32[gb + 102072 >> 2] = fb + 1487;
 HEAP32[gb + 102084 >> 2] = fb + 1125;
 HEAP32[gb + 102088 >> 2] = fb + 1488;
 HEAP32[gb + 102092 >> 2] = fb + 1258;
 HEAP32[gb + 102096 >> 2] = fb + 753;
 HEAP32[gb + 102100 >> 2] = fb + 1127;
 HEAP32[gb + 102104 >> 2] = fb + 1128;
 HEAP32[gb + 102108 >> 2] = fb + 469;
 HEAP32[gb + 102112 >> 2] = fb + 1129;
 HEAP32[gb + 102116 >> 2] = fb + 1489;
 HEAP32[gb + 102128 >> 2] = fb + 1125;
 HEAP32[gb + 102132 >> 2] = fb + 1490;
 HEAP32[gb + 102136 >> 2] = fb + 1258;
 HEAP32[gb + 102140 >> 2] = fb + 754;
 HEAP32[gb + 102144 >> 2] = fb + 1127;
 HEAP32[gb + 102148 >> 2] = fb + 1128;
 HEAP32[gb + 102152 >> 2] = fb + 469;
 HEAP32[gb + 102156 >> 2] = fb + 1129;
 HEAP32[gb + 102160 >> 2] = fb + 1491;
 HEAP32[gb + 102172 >> 2] = fb + 1125;
 HEAP32[gb + 102176 >> 2] = fb + 1492;
 HEAP32[gb + 102180 >> 2] = fb + 1258;
 HEAP32[gb + 102184 >> 2] = fb + 755;
 HEAP32[gb + 102188 >> 2] = fb + 1127;
 HEAP32[gb + 102192 >> 2] = fb + 1128;
 HEAP32[gb + 102196 >> 2] = fb + 469;
 HEAP32[gb + 102200 >> 2] = fb + 1129;
 HEAP32[gb + 102204 >> 2] = fb + 1493;
 HEAP32[gb + 102216 >> 2] = fb + 1125;
 HEAP32[gb + 102220 >> 2] = fb + 1494;
 HEAP32[gb + 102224 >> 2] = fb + 1258;
 HEAP32[gb + 102228 >> 2] = fb + 756;
 HEAP32[gb + 102232 >> 2] = fb + 1127;
 HEAP32[gb + 102236 >> 2] = fb + 1128;
 HEAP32[gb + 102240 >> 2] = fb + 469;
 runPostSets114();
}

function _emit_dht(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i5 = i1 << 24 >> 24 == 0;
 i3 = i5 ? i2 : i2 + 16 | 0;
 i5 = HEAP32[(i5 ? i8 + 88 + (i2 << 2) | 0 : i8 + 104 + (i2 << 2) | 0) >> 2] | 0;
 if (!i5) {
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 50;
  HEAP32[i7 + 24 >> 2] = i3;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i8 | 0);
 }
 i6 = i5 + 273 | 0;
 if (HEAP8[i6 >> 0] | 0) return;
 i7 = i8 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP8[i2 >> 0] = -1;
 i2 = i1 + 4 | 0;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (!i4) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i8 | 0);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP8[i2 >> 0] = -60;
 i2 = i1 + 4 | 0;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (!i4) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i8 | 0);
 }
 i4 = (HEAPU8[i5 + 16 >> 0] | 0) + ((HEAPU8[i5 + 15 >> 0] | 0) + ((HEAPU8[i5 + 14 >> 0] | 0) + ((HEAPU8[i5 + 13 >> 0] | 0) + ((HEAPU8[i5 + 12 >> 0] | 0) + ((HEAPU8[i5 + 11 >> 0] | 0) + ((HEAPU8[i5 + 10 >> 0] | 0) + ((HEAPU8[i5 + 9 >> 0] | 0) + ((HEAPU8[i5 + 8 >> 0] | 0) + ((HEAPU8[i5 + 7 >> 0] | 0) + ((HEAPU8[i5 + 6 >> 0] | 0) + ((HEAPU8[i5 + 5 >> 0] | 0) + ((HEAPU8[i5 + 4 >> 0] | 0) + ((HEAPU8[i5 + 3 >> 0] | 0) + ((HEAPU8[i5 + 2 >> 0] | 0) + (HEAPU8[i5 + 1 >> 0] | 0))))))))))))))) | 0;
 i2 = i4 + 19 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + 1;
 HEAP8[i10 >> 0] = i2 >>> 8;
 i10 = i1 + 4 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 HEAP32[i10 >> 2] = i9;
 if (!i9) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i8 | 0);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = i2;
 i9 = i1 + 4 | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i10;
 if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i8 | 0);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i9 + 1;
 HEAP8[i9 >> 0] = i3;
 i9 = i1 + 4 | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i10;
 if (!i10) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i8 | 0);
 }
 i1 = 1;
 do {
  i10 = HEAP8[i5 + i1 >> 0] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = i10;
  i9 = i2 + 4 | 0;
  i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
  HEAP32[i9 >> 2] = i10;
  if (!i10) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
   i10 = HEAP32[i8 >> 2] | 0;
   HEAP32[i10 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i10 >> 2] | 0, i8 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 17);
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   i10 = HEAP8[i5 + 17 + i1 >> 0] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i9 + 1;
   HEAP8[i9 >> 0] = i10;
   i9 = i2 + 4 | 0;
   i10 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
   HEAP32[i9 >> 2] = i10;
   if (!i10) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
    i10 = HEAP32[i8 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 24;
    mftCall_vi(HEAP32[i10 >> 2] | 0, i8 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP8[i6 >> 0] = 1;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj(i18, i17, i16) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20;
 i19 = i18 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i19 >> 2] | 0);
 if (!i16) {
  i18 = 0;
  i19 = HEAP32[i19 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
  STACKTOP = i20;
  return i18 | 0;
 }
 i4 = HEAP32[i18 + 192 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i5 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i5;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i18 + 184 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i18 + 176 >> 2] | 0;
   i3 = i18 + 180 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L4;
   }
   if (i2 | 0) {
    i18 = HEAP16[(HEAP32[i18 + 156 >> 2] | 0) + (HEAP32[i4 + (i1 << 3) + 4 >> 2] << 3) + 4 >> 1] | 0;
    i19 = HEAP32[i19 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
    STACKTOP = i20;
    return i18 | 0;
   }
  }
 } while (0);
 i9 = i18 + 228 | 0;
 i10 = i18 + 220 | 0;
 i11 = i18 + 224 | 0;
 i13 = HEAP32[i18 + 236 >> 2] | 0;
 i12 = (i13 | 0) == 0;
 i13 = i13 + -1 | 0;
 i1 = HEAP32[i18 + 160 >> 2] & 65535;
 do {
  i1 = i1 + 1 << 16 >> 16;
  i6 = i1 & 65535;
  if (i12) {
   i14 = 13;
   break;
  }
  i7 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  i8 = 0;
  do {
   i2 = i2 + i6 | 0;
   i4 = i2 & 65535;
   i2 = i2 & 65535;
   i2 = i2 + ~(i2 << 15) | 0;
   i2 = (i2 >>> 10 ^ i2) * 9 | 0;
   i2 = i2 >>> 6 ^ i2;
   i2 = i2 + ~(i2 << 11) | 0;
   i2 = HEAP32[i7 + ((i13 & (i2 >>> 16 ^ i2)) << 2) >> 2] | 0;
   L23 : do if ((i2 | 0) == -1) i2 = 0; else {
    i5 = HEAP32[i10 >> 2] | 0;
    i3 = i2;
    while (1) {
     i2 = i5 + (i3 << 3) | 0;
     if ((HEAP16[i2 >> 1] | 0) == i4 << 16 >> 16) break L23;
     i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if ((i3 | 0) == -1) {
      i2 = 0;
      break;
     }
    }
   } while (0);
   i3 = (i2 | 0) != 0;
   i8 = i8 + 1 << 16 >> 16;
   i2 = i8 & 65535;
  } while (!(i3 | i2 >>> 0 >= i16 >>> 0));
 } while (i3);
 if ((i14 | 0) == 13) {
  i2 = 0;
  do i2 = i2 + 1 << 16 >> 16; while ((i2 & 65535) >>> 0 < i16 >>> 0);
 }
 i5 = HEAP32[i18 + 268 >> 2] | 0;
 i9 = i1 & 65535;
 i6 = i18 + 264 | 0;
 i7 = i15 + 4 | 0;
 if (!i5) {
  i2 = 0;
  i3 = 0;
  do {
   __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb(i18, HEAP32[i17 + (i2 << 2) >> 2] | 0, i2 + i9 & 65535, 1);
   i3 = i3 + 1 << 16 >> 16;
   i2 = i3 & 65535;
  } while (i2 >>> 0 < i16 >>> 0);
  i19 = HEAP32[i19 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
  STACKTOP = i20;
  return i1 | 0;
 } else {
  i2 = 0;
  i8 = 0;
 }
 do {
  i3 = i2 + i9 | 0;
  i2 = i17 + (i2 << 2) | 0;
  __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb(i18, HEAP32[i2 >> 2] | 0, i3 & 65535, 1);
  i3 = i3 | 65536;
  i4 = 0;
  do {
   i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i3;
   mftCall_vii(i13 | 0, i14 | 0, i15 | 0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
  i8 = i8 + 1 << 16 >> 16;
  i2 = i8 & 65535;
 } while (i2 >>> 0 < i16 >>> 0);
 i19 = HEAP32[i19 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN11NoiseModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 8 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 272 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 536 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 804 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 800 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 805 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 808 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 812 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 816 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 820 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 824 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 1092 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 1356 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 1620 | 0, i5);
 i1 = i4 + 1884 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function runPostSets196() {
 HEAP32[gb + 167596 >> 2] = fb + 129;
 HEAP32[gb + 167600 >> 2] = fb + 151;
 HEAP32[gb + 167604 >> 2] = fb + 130;
 HEAP32[gb + 167608 >> 2] = fb + 152;
 HEAP32[gb + 167612 >> 2] = fb + 1817;
 HEAP32[gb + 167616 >> 2] = fb + 1159;
 HEAP32[gb + 167620 >> 2] = fb + 1818;
 HEAP32[gb + 167624 >> 2] = fb + 143;
 HEAP32[gb + 167628 >> 2] = fb + 1160;
 HEAP32[gb + 167632 >> 2] = fb + 144;
 HEAP32[gb + 167636 >> 2] = fb + 1161;
 HEAP32[gb + 167640 >> 2] = fb + 145;
 HEAP32[gb + 167644 >> 2] = fb + 1162;
 HEAP32[gb + 167648 >> 2] = fb + 146;
 HEAP32[gb + 167652 >> 2] = fb + 1163;
 HEAP32[gb + 167656 >> 2] = fb + 147;
 HEAP32[gb + 167660 >> 2] = fb + 148;
 HEAP32[gb + 167664 >> 2] = fb + 1164;
 HEAP32[gb + 167668 >> 2] = fb + 1165;
 HEAP32[gb + 167672 >> 2] = fb + 1819;
 HEAP32[gb + 167676 >> 2] = fb + 153;
 HEAP32[gb + 167680 >> 2] = fb + 131;
 HEAP32[gb + 167684 >> 2] = fb + 132;
 HEAP32[gb + 167688 >> 2] = fb + 154;
 HEAP32[gb + 167692 >> 2] = fb + 446;
 HEAP32[gb + 167696 >> 2] = fb + 1166;
 HEAP32[gb + 167700 >> 2] = fb + 1167;
 HEAP32[gb + 167704 >> 2] = fb + 133;
 HEAP32[gb + 167708 >> 2] = fb + 155;
 HEAP32[gb + 167712 >> 2] = fb + 134;
 HEAP32[gb + 167716 >> 2] = fb + 156;
 HEAP32[gb + 167720 >> 2] = fb + 1820;
 HEAP32[gb + 167724 >> 2] = fb + 2536;
 HEAP32[gb + 167728 >> 2] = fb + 1168;
 HEAP32[gb + 167732 >> 2] = fb + 11;
 HEAP32[gb + 167736 >> 2] = fb + 157;
 HEAP32[gb + 167740 >> 2] = fb + 158;
 HEAP32[gb + 167744 >> 2] = fb + 135;
 HEAP32[gb + 167748 >> 2] = fb + 159;
 HEAP32[gb + 167752 >> 2] = fb + 1821;
 HEAP32[gb + 167756 >> 2] = fb + 2537;
 HEAP32[gb + 167760 >> 2] = fb + 1169;
 HEAP32[gb + 167764 >> 2] = fb + 2538;
 HEAP32[gb + 167768 >> 2] = fb + 1822;
 HEAP32[gb + 167772 >> 2] = fb + 2539;
 HEAP32[gb + 167776 >> 2] = fb + 1170;
 HEAP32[gb + 167780 >> 2] = fb + 136;
 HEAP32[gb + 167784 >> 2] = fb + 160;
 HEAP32[gb + 167788 >> 2] = fb + 137;
 HEAP32[gb + 167792 >> 2] = fb + 161;
 HEAP32[gb + 167796 >> 2] = fb + 1823;
 HEAP32[gb + 167800 >> 2] = fb + 1171;
 HEAP32[gb + 167804 >> 2] = fb + 1824;
 HEAP32[gb + 167808 >> 2] = fb + 1172;
 HEAP32[gb + 167812 >> 2] = fb + 1173;
 HEAP32[gb + 167816 >> 2] = fb + 1174;
 HEAP32[gb + 167820 >> 2] = fb + 138;
 HEAP32[gb + 167824 >> 2] = fb + 162;
 HEAP32[gb + 167828 >> 2] = fb + 1825;
 HEAP32[gb + 167832 >> 2] = fb + 1175;
 HEAP32[gb + 167836 >> 2] = fb + 1826;
 HEAP32[gb + 167840 >> 2] = fb + 1176;
 HEAP32[gb + 167844 >> 2] = fb + 1177;
 HEAP32[gb + 167848 >> 2] = fb + 1178;
 HEAP32[gb + 167852 >> 2] = fb + 2540;
 HEAP32[gb + 167856 >> 2] = fb + 2541;
 HEAP32[gb + 167860 >> 2] = fb + 1827;
 HEAP32[gb + 167864 >> 2] = fb + 1179;
 HEAP32[gb + 167876 >> 2] = fb + 2542;
 HEAP32[gb + 167880 >> 2] = fb + 2543;
 HEAP32[gb + 167884 >> 2] = fb + 432;
 HEAP32[gb + 167888 >> 2] = fb + 1180;
 HEAP32[gb + 167892 >> 2] = fb + 1181;
 HEAP32[gb + 167896 >> 2] = fb + 1182;
 HEAP32[gb + 167900 >> 2] = fb + 2544;
 HEAP32[gb + 167904 >> 2] = fb + 2545;
 HEAP32[gb + 167908 >> 2] = fb + 1828;
 HEAP32[gb + 167912 >> 2] = fb + 1829;
 HEAP32[gb + 167916 >> 2] = fb + 1830;
 HEAP32[gb + 167920 >> 2] = fb + 1831;
 HEAP32[gb + 167924 >> 2] = fb + 1832;
 HEAP32[gb + 167928 >> 2] = fb + 1833;
 HEAP32[gb + 167932 >> 2] = fb + 1834;
 HEAP32[gb + 167936 >> 2] = fb + 1183;
 HEAP32[gb + 167940 >> 2] = fb + 1184;
 HEAP32[gb + 167944 >> 2] = fb + 2546;
 HEAP32[gb + 167948 >> 2] = fb + 1835;
 HEAP32[gb + 167952 >> 2] = fb + 163;
 HEAP32[gb + 167956 >> 2] = fb + 1836;
 HEAP32[gb + 167960 >> 2] = fb + 1837;
 HEAP32[gb + 167964 >> 2] = fb + 1838;
 HEAP32[gb + 167968 >> 2] = fb + 1839;
 HEAP32[gb + 167972 >> 2] = fb + 1840;
 HEAP32[gb + 167976 >> 2] = fb + 1841;
 HEAP32[gb + 167980 >> 2] = fb + 1842;
 HEAP32[gb + 167984 >> 2] = fb + 1843;
 HEAP32[gb + 167988 >> 2] = fb + 1844;
 HEAP32[gb + 167992 >> 2] = fb + 1845;
 HEAP32[gb + 167996 >> 2] = fb + 1846;
 HEAP32[gb + 168e3 >> 2] = fb + 1847;
 runPostSets197();
}

function __ZNK5physx2Sc15ArticulationSim11checkResizeEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 96 | 0;
 i2 = i16 + 140 | 0;
 i4 = i16 + 48 | 0;
 i5 = i16;
 i9 = i16 + 136 | 0;
 i10 = i16 + 132 | 0;
 i8 = i16 + 128 | 0;
 i6 = i16 + 169 | 0;
 i7 = i16 + 168 | 0;
 if (!(HEAP32[i15 + 28 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 if ((HEAP32[(HEAP32[HEAP32[i15 + 24 >> 2] >> 2] | 0) + 188 >> 2] | 0) == -1) {
  STACKTOP = i16;
  return;
 }
 i11 = i15 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 160 | 0;
 if (!(HEAP8[i12 >> 0] | 0)) {
  STACKTOP = i16;
  return;
 }
 i13 = i15 + 48 | 0;
 i14 = i15 + 84 | 0;
 if ((i3 | 0) == (HEAPU16[i14 >> 1] | 0)) i1 = i15 + 100 | 0; else {
  i18 = i15 + 124 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i18, i3, i1);
  i17 = i15 + 112 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i17, i3, i2);
  i1 = i15 + 100 | 0;
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  i2 = i4 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAPF32[i4 + 20 >> 2] = Math_fround(1.0);
  i2 = i4 + 24 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAPF32[i4 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
  __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i3, i4);
  i4 = i15 + 88 | 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  i2 = i5 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAPF32[i5 + 20 >> 2] = Math_fround(1.0);
  i2 = i5 + 24 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAPF32[i5 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 44 >> 2] = Math_fround(0.0);
  __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i4, i3, i5);
  __ZN5physx21PxcArticulationHelper12getDataSizesEjRjS1_S1_(i3, i9, i10, i8);
  i5 = i15 + 136 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  HEAP8[i6 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE6resizeEjRKc(i5, i3, i6);
  HEAP32[i15 + 56 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i15 + 64 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i15 + 68 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i15 + 60 >> 2] = HEAP32[i17 >> 2];
  HEAP16[i15 + 82 >> 1] = HEAP32[i9 >> 2];
  HEAP16[i15 + 80 >> 1] = HEAP32[i10 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
  i10 = i15 + 148 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP8[i7 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE6resizeEjRKc(i10, i9, i7);
  HEAP32[i15 + 76 >> 2] = HEAP32[i10 >> 2];
  HEAP16[i15 + 86 >> 1] = HEAP32[i8 >> 2];
 }
 i18 = i15 + 104 | 0;
 _memset(HEAP32[i1 >> 2] | 0, 0, (HEAP32[i18 >> 2] | 0) * 48 | 0) | 0;
 _memset(HEAP32[i15 + 88 >> 2] | 0, 0, (HEAP32[i18 >> 2] | 0) * 48 | 0) | 0;
 HEAP32[i15 + 52 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP16[i14 >> 1] = HEAP32[i11 >> 2];
 HEAP32[HEAP32[i15 >> 2] >> 2] = i13;
 HEAP8[i12 >> 0] = 0;
 STACKTOP = i16;
 return;
}

function __ZN7mecanim12statemachine20StateMachineConstant8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 12 | 0;
 i4 = i10;
 i2 = i9 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i6 + 4;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i3;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902860 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i6 + 12;
 HEAP32[i4 + 4 >> 2] = i6 + 8;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902881 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i6 + 20;
 HEAP32[i4 + 4 >> 2] = i6 + 16;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902915 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags(i9, i4, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902944 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 902959 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 35; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 35; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 35) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_(i15, i14, i1) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = i15 + 32 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i11 = (i13 | 0) == 0;
 L1 : do if (i11) i2 = 0; else {
  i6 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i14 + 4 >> 2] | 0;
  i10 = HEAP32[i14 + 8 >> 2] | 0;
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i3 = 5381; else {
   i3 = 5381;
   i4 = i6;
   do {
    i3 = i3 * 33 ^ i2 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
  }
  i2 = HEAP8[i7 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i2 = 5381; else {
   i4 = 5381;
   i5 = i7;
   do {
    i4 = i4 * 33 ^ i2 << 24 >> 24;
    i5 = i5 + 1 | 0;
    i2 = HEAP8[i5 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
   i2 = i4;
  }
  i5 = i2 ^ i3;
  i2 = HEAP8[i10 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i2 = 5381; else {
   i3 = 5381;
   i4 = i10;
   do {
    i3 = i3 * 33 ^ i2 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
   i2 = i3;
  }
  i2 = (i5 ^ i2) & i13 + -1;
  i4 = HEAP32[(HEAP32[i15 + 24 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i4 | 0) != -1) {
   i9 = HEAP32[i15 + 16 >> 2] | 0;
   i8 = i6 | 0 ? i6 : gb + 1576256 | 0;
   i7 = i7 | 0 ? i7 : gb + 1576256 | 0;
   i5 = i10 | 0 ? i10 : gb + 1576256 | 0;
   i6 = i15 + 20 | 0;
   while (1) {
    i10 = HEAP32[i9 + (i4 << 4) >> 2] | 0;
    i3 = HEAP32[i9 + (i4 << 4) + 4 >> 2] | 0;
    if (!(_strcmp(i10 | 0 ? i10 : gb + 1576256 | 0, i8) | 0)) if (!(_strcmp(i3 | 0 ? i3 : gb + 1576256 | 0, i7) | 0)) {
     i10 = HEAP32[i9 + (i4 << 4) + 8 >> 2] | 0;
     if (!(_strcmp(i10 | 0 ? i10 : gb + 1576256 | 0, i5) | 0)) break;
    }
    i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    if ((i4 | 0) == -1) break L1;
   }
   return;
  }
 } while (0);
 i9 = i15 + 48 | 0;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i15 + 28 >> 2] | 0)) {
  i2 = i11 ? 16 : i13 << 1;
  if (i13 >>> 0 < i2 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i15, i2);
   i8 = HEAP32[i12 >> 2] | 0;
  } else i8 = i13;
  i4 = HEAP32[i14 >> 2] | 0;
  i6 = HEAP32[i14 + 4 >> 2] | 0;
  i7 = HEAP32[i14 + 8 >> 2] | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i3 = 5381; else {
   i3 = 5381;
   do {
    i3 = i3 * 33 ^ i2 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
  }
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i2 = 5381; else {
   i5 = i2;
   i2 = 5381;
   i4 = i6;
   do {
    i2 = i2 * 33 ^ i5 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i5 = HEAP8[i4 >> 0] | 0;
   } while (i5 << 24 >> 24 != 0);
  }
  i5 = i2 ^ i3;
  i2 = HEAP8[i7 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i2 = 5381; else {
   i4 = i2;
   i2 = 5381;
   i3 = i7;
   do {
    i2 = i2 * 33 ^ i4 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
   } while (i4 << 24 >> 24 != 0);
  }
  i2 = (i5 ^ i2) & i8 + -1;
 }
 i12 = i15 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i13 + 1;
 i12 = (HEAP32[i15 + 24 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[(HEAP32[i15 + 20 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i12 = i15 + 44 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i15 = HEAP32[i15 + 16 >> 2] | 0;
 i12 = i15 + (i13 << 4) | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i15 + (i13 << 4) + 12 >> 2] = i1;
 return;
}

function __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Transform8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 136 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 148 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 152 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 156 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 164 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 168 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 172 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i6 + 177 | 0;
  HEAP8[i8 >> 0] = 1;
  STACKTOP = i9;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i8 = i5;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i6 + 177 | 0;
  HEAP8[i8 >> 0] = 1;
  STACKTOP = i9;
  return;
 }
}

function _qsort(i5, i1, i11, i12) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i14 = i16;
 i4 = Math_imul(i11, i1) | 0;
 i10 = i14;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 if (i4 | 0) {
  i10 = 0 - i11 | 0;
  HEAP32[i13 + 4 >> 2] = i11;
  HEAP32[i13 >> 2] = i11;
  i2 = 2;
  i1 = i11;
  i3 = i11;
  while (1) {
   i1 = i1 + i11 + i3 | 0;
   HEAP32[i13 + (i2 << 2) >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) {
    i9 = i3;
    i2 = i2 + 1 | 0;
    i3 = i1;
    i1 = i9;
   } else break;
  }
  i6 = i5 + i4 + i10 | 0;
  i9 = i14 + 4 | 0;
  if (i6 >>> 0 > i5 >>> 0) {
   i7 = i6;
   i2 = 1;
   i4 = i5;
   i3 = 1;
   while (1) {
    do if ((i3 & 3 | 0) == 3) {
     _sift(i4, i11, i12, i2, i13);
     i8 = HEAP32[i9 >> 2] | 0;
     i1 = i8 << 30 | (HEAP32[i14 >> 2] | 0) >>> 2;
     HEAP32[i14 >> 2] = i1;
     HEAP32[i9 >> 2] = i8 >>> 2;
     i2 = i2 + 2 | 0;
    } else {
     i1 = i2 + -1 | 0;
     if ((HEAP32[i13 + (i1 << 2) >> 2] | 0) >>> 0 < (i7 - i4 | 0) >>> 0) _sift(i4, i11, i12, i2, i13); else _trinkle(i4, i11, i12, i14, i2, 0, i13);
     if ((i2 | 0) == 1) {
      i1 = HEAP32[i14 >> 2] | 0;
      HEAP32[i9 >> 2] = i1 >>> 31 | HEAP32[i9 >> 2] << 1;
      i1 = i1 << 1;
      HEAP32[i14 >> 2] = i1;
      i2 = 0;
      break;
     }
     if (i1 >>> 0 > 31) {
      i3 = HEAP32[i14 >> 2] | 0;
      HEAP32[i9 >> 2] = i3;
      HEAP32[i14 >> 2] = 0;
      i1 = i2 + -33 | 0;
      i2 = i3;
      i3 = 0;
     } else {
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i14 >> 2] | 0;
     }
     HEAP32[i9 >> 2] = i3 >>> (32 - i1 | 0) | i2 << i1;
     i1 = i3 << i1;
     HEAP32[i14 >> 2] = i1;
     i2 = 1;
    } while (0);
    i3 = i1 | 1;
    HEAP32[i14 >> 2] = i3;
    i1 = i4 + i11 | 0;
    if (i1 >>> 0 >= i6 >>> 0) break; else i4 = i1;
   }
  } else {
   i2 = 1;
   i1 = i5;
  }
  _trinkle(i1, i11, i12, i14, i2, 0, i13);
  i8 = i14 + 4 | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = (i5 | 0) == 0;
  if (!((i2 | 0) == 1 & (i4 | 0) == 1 & i3)) {
   i7 = i2;
   while (1) {
    if ((i7 | 0) < 2) {
     i2 = i4 + -1 | 0;
     do if (!i2) {
      i2 = 32;
      i15 = 28;
     } else {
      if (!(i2 & 1)) {
       i3 = i2;
       i2 = 0;
       do {
        i2 = i2 + 1 | 0;
        i3 = i3 >>> 1;
       } while (!(i3 & 1 | 0));
      } else {
       if (i3) i2 = 32; else {
        if (!(i5 & 1)) {
         i3 = i5;
         i2 = 0;
        } else {
         i6 = 0;
         i3 = i5;
         i2 = 0;
         break;
        }
        do {
         i2 = i2 + 1 | 0;
         i3 = i3 >>> 1;
        } while (!(i3 & 1 | 0));
       }
       i2 = i2 + 32 | 0;
      }
      if (i2 >>> 0 > 31) i15 = 28; else {
       i6 = i2;
       i3 = i5;
      }
     } while (0);
     if ((i15 | 0) == 28) {
      i15 = 0;
      HEAP32[i14 >> 2] = i5;
      HEAP32[i9 >> 2] = 0;
      i6 = i2 + -32 | 0;
      i4 = i5;
      i3 = 0;
     }
     HEAP32[i14 >> 2] = i3 << 32 - i6 | i4 >>> i6;
     HEAP32[i9 >> 2] = i3 >>> i6;
     i1 = i1 + i10 | 0;
     i2 = i2 + i7 | 0;
    } else {
     i6 = i4 >>> 30;
     i2 = i7 + -2 | 0;
     HEAP32[i14 >> 2] = (i4 << 1 & 2147483646 | i6 << 31) ^ 3;
     HEAP32[i9 >> 2] = (i6 | i5 << 2) >>> 1;
     _trinkle(i1 + (0 - (HEAP32[i13 + (i2 << 2) >> 2] | 0)) + i10 | 0, i11, i12, i14, i7 + -1 | 0, 1, i13);
     i7 = HEAP32[i14 >> 2] | 0;
     HEAP32[i9 >> 2] = i7 >>> 31 | HEAP32[i9 >> 2] << 1;
     HEAP32[i14 >> 2] = i7 << 1 | 1;
     i1 = i1 + i10 | 0;
     _trinkle(i1, i11, i12, i14, i2, 1, i13);
    }
    i4 = HEAP32[i14 >> 2] | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    i3 = (i5 | 0) == 0;
    if ((i2 | 0) == 1 & (i4 | 0) == 1 & i3) break; else i7 = i2;
   }
  }
 }
 STACKTOP = i16;
 return;
}

function __ZNK13MonoBehaviour15CanAssignScriptERK4PPtrI10MonoScriptE(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i9 = 9;
 }
 if ((i9 | 0) == 7) i9 = 9;
 do if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i5 = __ZNK10MonoScript13GetScriptTypeEv(i1) | 0;
 if (HEAP32[i8 + 28 >> 2] | 0) {
  i9 = (i5 + -1 | 0) >>> 0 > 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i8 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 27; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 27; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 29;
 }
 if ((i9 | 0) == 27) i9 = 29;
 if ((i9 | 0) == 29) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[i8 + 56 >> 2] | 0;
 if (i1 | 0) if (((HEAP32[i1 + 28 >> 2] | 0) + -1 | 0) >>> 0 < 2) {
  i9 = (i5 | 0) != 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = (i5 + -1 | 0) >>> 0 > 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN19RenderBufferManager7CleanupEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i6 = i8 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 16 | 0;
 if ((i1 | 0) != (i7 | 0)) {
  i2 = i1;
  while (1) {
   i5 = i2 + 16 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 11; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 11; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 13;
     }
    }
    if ((i11 | 0) == 11) i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __Z19DestroySingleObjectP6Object(i1);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE(i6, HEAP32[i7 >> 2] | 0);
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i7 >> 2] = 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i8 | 0)) {
  __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv(i8);
  STACKTOP = i12;
  return;
 }
 do {
  i5 = i1 + 12 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 27; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 27; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 29;
    }
   }
   if ((i11 | 0) == 27) i11 = 29;
   if ((i11 | 0) == 29) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __Z19DestroySingleObjectP6Object(i1);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i8 | 0));
 __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv(i8);
 STACKTOP = i12;
 return;
}

function __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i4 = mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0;
 i2 = mftCall_iii(HEAP32[i8 >> 2] | 0, i7 | 0, i6 | 0) | 0;
 if (!i4) {
  if (!i2) {
   i8 = 0;
   return i8 | 0;
  }
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i4;
  i4 = i6 + 4 | 0;
  i14 = i7 + 4 | 0;
  i15 = HEAP32[i4 >> 2] | 0;
  i1 = i6 + 8 | 0;
  i13 = HEAP32[i1 >> 2] | 0;
  i2 = i6 + 12 | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  i3 = i6 + 16 | 0;
  i9 = HEAP32[i3 >> 2] | 0;
  i12 = i7 + 8 | 0;
  i18 = HEAP32[i12 >> 2] | 0;
  i10 = i7 + 12 | 0;
  i17 = HEAP32[i10 >> 2] | 0;
  i7 = i7 + 16 | 0;
  i16 = HEAP32[i7 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 >> 2] = i18;
  HEAP32[i2 >> 2] = i17;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i14 >> 2] = i15;
  HEAP32[i12 >> 2] = i13;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i7 >> 2] = i9;
  if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0)) {
   i18 = 1;
   return i18 | 0;
  }
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i8;
  i8 = i5 + 4 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i10 = i5 + 8 | 0;
  i16 = HEAP32[i10 >> 2] | 0;
  i12 = i5 + 12 | 0;
  i17 = HEAP32[i12 >> 2] | 0;
  i14 = i5 + 16 | 0;
  i18 = HEAP32[i14 >> 2] | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i9;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i4 >> 2] = i15;
  HEAP32[i1 >> 2] = i16;
  HEAP32[i2 >> 2] = i17;
  HEAP32[i3 >> 2] = i18;
  i18 = 2;
  return i18 | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (i2) {
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i1;
  i3 = i5 + 4 | 0;
  i12 = i7 + 4 | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  i4 = i5 + 8 | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  i8 = i5 + 12 | 0;
  i15 = HEAP32[i8 >> 2] | 0;
  i10 = i5 + 16 | 0;
  i17 = HEAP32[i10 >> 2] | 0;
  i14 = i7 + 8 | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i16 = i7 + 12 | 0;
  i6 = HEAP32[i16 >> 2] | 0;
  i18 = i7 + 16 | 0;
  i9 = HEAP32[i18 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 >> 2] = i5;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i16 >> 2] = i15;
  HEAP32[i18 >> 2] = i17;
  i18 = 1;
  return i18 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i1;
 i19 = i5 + 4 | 0;
 i4 = i6 + 4 | 0;
 i15 = HEAP32[i19 >> 2] | 0;
 i10 = i5 + 8 | 0;
 i16 = HEAP32[i10 >> 2] | 0;
 i12 = i5 + 12 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i14 = i5 + 16 | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 i1 = i6 + 8 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 12 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i3 = i6 + 16 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 >> 2] = i9;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i4 >> 2] = i15;
 HEAP32[i1 >> 2] = i16;
 HEAP32[i2 >> 2] = i17;
 HEAP32[i3 >> 2] = i18;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i19 = 1;
  return i19 | 0;
 }
 i13 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i13;
 i13 = i7 + 4 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i14 = HEAP32[i1 >> 2] | 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i18 = HEAP32[i3 >> 2] | 0;
 i15 = i7 + 8 | 0;
 i9 = HEAP32[i15 >> 2] | 0;
 i17 = i7 + 12 | 0;
 i10 = HEAP32[i17 >> 2] | 0;
 i19 = i7 + 16 | 0;
 i11 = HEAP32[i19 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 >> 2] = i9;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i3 >> 2] = i11;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i19 >> 2] = i18;
 i19 = 2;
 return i19 | 0;
}

function __ZN8TypeTree19AppendChildrenRangeERK16TypeTreeIteratorjjb(i14, i2, i15, i16, i1) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i18 = i21 + 16 | 0;
 i19 = i21 + 8 | 0;
 HEAP32[i18 >> 2] = i14;
 HEAP32[i18 + 4 >> 2] = 0;
 if (i1) {
  i12 = HEAP32[i14 >> 2] | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i11 = HEAP32[(HEAP32[i13 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
  i10 = HEAP32[gb + 36932 >> 2] | 0;
  i9 = i14 + 20 | 0;
  __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc(i12 + 4 | 0, i9, ((i11 | 0) < 0 ? i10 : HEAP32[i13 + 20 >> 2] | 0) + (i11 & 2147483647) | 0);
  i11 = HEAP32[i2 >> 2] | 0;
  i13 = HEAP32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 8 >> 2] | 0;
  __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i14 >> 2] | 0) + 8 | 0, i9, ((i13 | 0) < 0 ? i10 : HEAP32[i11 + 20 >> 2] | 0) + (i13 & 2147483647) | 0);
  i13 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 + 12 >> 2] = HEAP32[i3 + (i2 * 24 | 0) + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i3 + (i2 * 24 | 0) + 16 >> 2];
  HEAP8[i12 + 3 >> 0] = HEAP8[i3 + (i2 * 24 | 0) + 3 >> 0] | 0;
  HEAP16[i12 >> 1] = HEAP16[i3 + (i2 * 24 | 0) >> 1] | 0;
  HEAP32[i12 + 20 >> 2] = HEAP32[i3 + (i2 * 24 | 0) + 20 >> 2];
 } else {
  i13 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 i1 = i3 + (i2 * 24 | 0) | 0;
 if ((i1 + 24 | 0) >>> 0 < (i3 + ((HEAP32[i13 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i1 + 26 >> 0] | 0 | 0) == ((HEAPU8[i3 + (i2 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i1 = i2 + 1 | 0;
  HEAP32[i17 >> 2] = i13;
  HEAP32[i17 + 4 >> 2] = i1;
  if (!i13) {
   i20 = HEAP32[i14 >> 2] | 0;
   i20 = i20 + 12 | 0;
   HEAP32[i20 >> 2] = -1;
   HEAP32[i17 >> 2] = 0;
   __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i14, i18, i17);
   STACKTOP = i21;
   return;
  }
  i8 = i14 + 12 | 0;
  i9 = i19 + 4 | 0;
  i7 = i17 + 4 | 0;
  i10 = i13 + 12 | 0;
  i11 = i13;
  i12 = (i13 | 0) == 0;
  i6 = 0;
  L11 : while (1) {
   if (i6 >>> 0 >= i15 >>> 0 & i6 >>> 0 < i16 >>> 0) {
    __ZN8TypeTree8AddChildEj(i14, 0);
    i5 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
    HEAP32[i19 >> 2] = i14;
    HEAP32[i9 >> 2] = i5;
    __ZL11RecurseCopyR8TypeTreeRK16TypeTreeIteratorS3_(i14, i19, i17);
   }
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
   i4 = i2 + ((HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
   i5 = i2;
   i2 = i2 + (i1 * 24 | 0) | 0;
   do {
    i1 = i2;
    i2 = i2 + 24 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break L11;
    i1 = HEAP8[i1 + 26 >> 0] | 0;
   } while ((i1 & 255) > (i3 & 255));
   if (i1 << 24 >> 24 != i3 << 24 >> 24) break;
   i1 = (i2 - i5 | 0) / 24 | 0;
   HEAP32[i17 >> 2] = i11;
   HEAP32[i7 >> 2] = i1;
   if (i12) {
    i20 = 9;
    break;
   } else i6 = i6 + 1 | 0;
  }
  if ((i20 | 0) == 9) {
   i20 = HEAP32[i14 >> 2] | 0;
   i20 = i20 + 12 | 0;
   HEAP32[i20 >> 2] = -1;
   HEAP32[i17 >> 2] = 0;
   __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i14, i18, i17);
   STACKTOP = i21;
   return;
  }
  HEAP32[i17 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i20 = HEAP32[i14 >> 2] | 0;
  i20 = i20 + 12 | 0;
  HEAP32[i20 >> 2] = -1;
  HEAP32[i17 >> 2] = 0;
  __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i14, i18, i17);
  STACKTOP = i21;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i20 = HEAP32[i14 >> 2] | 0;
 i20 = i20 + 12 | 0;
 HEAP32[i20 >> 2] = -1;
 HEAP32[i17 >> 2] = 0;
 __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i14, i18, i17);
 STACKTOP = i21;
 return;
}

function __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i23, i18, i6, i2, i24, i1) {
 i23 = i23 | 0;
 i18 = i18 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 f5 = Math_fround(HEAPF32[i23 >> 2]);
 f5 = Math_fround(Math_fround(f5 - Math_fround(HEAP32[i2 >> 2] | 0)) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f5 / Math_fround(HEAP32[i2 + 8 >> 2] | 0)) + Math_fround(-1.0));
 f3 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f3 = Math_fround(Math_fround(f3 - Math_fround(HEAP32[i2 + 4 >> 2] | 0)) * Math_fround(2.0));
 f3 = Math_fround(Math_fround(f3 / Math_fround(HEAP32[i2 + 12 >> 2] | 0)) + Math_fround(-1.0));
 f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f4 = Math_fround(f5 * f19);
 f20 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f20 * f3));
 f21 = Math_fround(HEAPF32[i6 + 44 >> 2]);
 f4 = Math_fround(Math_fround(f21 * Math_fround(.949999988)) + f4);
 f22 = Math_fround(HEAPF32[i6 + 60 >> 2]);
 f4 = Math_fround(f22 + f4);
 i2 = f4 < Math_fround(0.0);
 f17 = Math_fround(-f4);
 if ((i2 ? f17 : f4) > Math_fround(1.00000001e-07)) {
  f11 = Math_fround(f5 * Math_fround(HEAPF32[i6 + 8 >> 2]));
  f11 = Math_fround(f11 + Math_fround(f3 * Math_fround(HEAPF32[i6 + 24 >> 2])));
  f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i6 + 40 >> 2]) * Math_fround(.949999988)));
  f11 = Math_fround(Math_fround(HEAPF32[i6 + 56 >> 2]) + f11);
  f10 = Math_fround(f5 * Math_fround(HEAPF32[i6 + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f3 * Math_fround(HEAPF32[i6 + 20 >> 2])));
  f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i6 + 36 >> 2]) * Math_fround(.949999988)));
  f10 = Math_fround(Math_fround(HEAPF32[i6 + 52 >> 2]) + f10);
  f9 = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f3 * Math_fround(HEAPF32[i6 + 16 >> 2])));
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i6 + 32 >> 2]) * Math_fround(.949999988)));
  f12 = Math_fround(Math_fround(1.0) / f4);
  f9 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i6 + 48 >> 2]) + f9));
  f10 = Math_fround(f12 * f10);
  f11 = Math_fround(f12 * f11);
  f12 = Math_fround(HEAPF32[i18 + 48 >> 2]);
  f13 = Math_fround(HEAPF32[i18 + 52 >> 2]);
  f14 = Math_fround(HEAPF32[i18 + 56 >> 2]);
  f15 = Math_fround(f9 - f12);
  f16 = Math_fround(f10 - f13);
  f17 = Math_fround(f11 - f14);
  f7 = Math_fround(HEAPF32[i18 + 32 >> 2]);
  f8 = Math_fround(HEAPF32[i18 + 36 >> 2]);
  f7 = Math_fround(-f7);
  f8 = Math_fround(-f8);
  f4 = Math_fround(-Math_fround(HEAPF32[i18 + 40 >> 2]));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f7) + Math_fround(f16 * f8)) + Math_fround(f17 * f4));
  i18 = f5 < Math_fround(0.0);
  f3 = Math_fround(-f5);
  if ((i18 ? f3 : f5) >= Math_fround(9.99999997e-07)) {
   i18 = f19 != Math_fround(0.0) | f20 != Math_fround(0.0) | f21 != Math_fround(0.0) | f22 != Math_fround(1.0);
   f3 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   if (i18) {
    f20 = Math_fround(f3 / f5);
    f21 = Math_fround(f13 + Math_fround(f16 * f20));
    f22 = Math_fround(f14 + Math_fround(f17 * f20));
    HEAPF32[i24 >> 2] = Math_fround(f12 + Math_fround(f15 * f20));
    HEAPF32[i24 + 4 >> 2] = f21;
    HEAPF32[i24 + 8 >> 2] = f22;
    i24 = 1;
    return i24 | 0;
   } else {
    f20 = Math_fround(f5 - f3);
    f21 = Math_fround(f10 - Math_fround(f20 * f8));
    f22 = Math_fround(f11 - Math_fround(f20 * f4));
    HEAPF32[i24 >> 2] = Math_fround(f9 - Math_fround(f20 * f7));
    HEAPF32[i24 + 4 >> 2] = f21;
    HEAPF32[i24 + 8 >> 2] = f22;
    i24 = 1;
    return i24 | 0;
   }
  }
 }
 HEAPF32[i24 >> 2] = Math_fround(0.0);
 HEAPF32[i24 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i24 + 8 >> 2] = Math_fround(0.0);
 i24 = 0;
 return i24 | 0;
}

function runPostSets170() {
 HEAP32[gb + 149188 >> 2] = fb + 2124;
 HEAP32[gb + 149192 >> 2] = fb + 232;
 HEAP32[gb + 149196 >> 2] = fb + 1023;
 HEAP32[gb + 149200 >> 2] = fb + 2125;
 HEAP32[gb + 149204 >> 2] = fb + 2126;
 HEAP32[gb + 149208 >> 2] = fb + 1024;
 HEAP32[gb + 149212 >> 2] = fb + 1025;
 HEAP32[gb + 149216 >> 2] = fb + 2127;
 HEAP32[gb + 149228 >> 2] = fb + 2128;
 HEAP32[gb + 149232 >> 2] = fb + 2129;
 HEAP32[gb + 149236 >> 2] = fb + 2130;
 HEAP32[gb + 149248 >> 2] = fb + 2131;
 HEAP32[gb + 149252 >> 2] = fb + 2132;
 HEAP32[gb + 149256 >> 2] = fb + 398;
 HEAP32[gb + 149260 >> 2] = fb + 2133;
 HEAP32[gb + 149272 >> 2] = fb + 2134;
 HEAP32[gb + 149276 >> 2] = fb + 2135;
 HEAP32[gb + 149280 >> 2] = fb + 233;
 HEAP32[gb + 149284 >> 2] = fb + 380;
 HEAP32[gb + 149288 >> 2] = fb + 71;
 HEAP32[gb + 149292 >> 2] = fb + 114;
 HEAP32[gb + 149296 >> 2] = fb + 381;
 HEAP32[gb + 149300 >> 2] = fb + 1026;
 HEAP32[gb + 149304 >> 2] = fb + 115;
 HEAP32[gb + 149308 >> 2] = fb + 382;
 HEAP32[gb + 149312 >> 2] = fb + 234;
 HEAP32[gb + 149316 >> 2] = fb + 1027;
 HEAP32[gb + 149320 >> 2] = fb + 116;
 HEAP32[gb + 149324 >> 2] = fb + 117;
 HEAP32[gb + 149328 >> 2] = fb + 383;
 HEAP32[gb + 149332 >> 2] = fb + 235;
 HEAP32[gb + 149336 >> 2] = fb + 236;
 HEAP32[gb + 149340 >> 2] = fb + 237;
 HEAP32[gb + 149344 >> 2] = fb + 384;
 HEAP32[gb + 149348 >> 2] = fb + 1412;
 HEAP32[gb + 149352 >> 2] = fb + 2136;
 HEAP32[gb + 149356 >> 2] = fb + 2137;
 HEAP32[gb + 149360 >> 2] = fb + 2138;
 HEAP32[gb + 149364 >> 2] = fb + 1028;
 HEAP32[gb + 149368 >> 2] = fb + 1029;
 HEAP32[gb + 149372 >> 2] = fb + 1030;
 HEAP32[gb + 149376 >> 2] = fb + 2139;
 HEAP32[gb + 149380 >> 2] = fb + 2140;
 HEAP32[gb + 149384 >> 2] = fb + 399;
 HEAP32[gb + 149388 >> 2] = fb + 61;
 HEAP32[gb + 149392 >> 2] = fb + 385;
 HEAP32[gb + 149396 >> 2] = fb + 238;
 HEAP32[gb + 149400 >> 2] = fb + 73;
 HEAP32[gb + 149404 >> 2] = fb + 72;
 HEAP32[gb + 149416 >> 2] = fb + 2141;
 HEAP32[gb + 149420 >> 2] = fb + 2142;
 HEAP32[gb + 149424 >> 2] = fb + 386;
 HEAP32[gb + 149428 >> 2] = fb + 239;
 HEAP32[gb + 149432 >> 2] = fb + 74;
 HEAP32[gb + 149436 >> 2] = fb + 73;
 HEAP32[gb + 149448 >> 2] = fb + 2143;
 HEAP32[gb + 149452 >> 2] = fb + 2144;
 HEAP32[gb + 149456 >> 2] = fb + 400;
 HEAP32[gb + 149460 >> 2] = fb + 121;
 HEAP32[gb + 149464 >> 2] = fb + 2145;
 HEAP32[gb + 149468 >> 2] = fb + 2146;
 HEAP32[gb + 149472 >> 2] = fb + 1031;
 HEAP32[gb + 149476 >> 2] = fb + 401;
 HEAP32[gb + 149480 >> 2] = fb + 2147;
 HEAP32[gb + 149484 >> 2] = fb + 1413;
 HEAP32[gb + 149488 >> 2] = fb + 62;
 HEAP32[gb + 149492 >> 2] = fb + 122;
 HEAP32[gb + 149496 >> 2] = fb + 123;
 HEAP32[gb + 149500 >> 2] = fb + 2148;
 HEAP32[gb + 149512 >> 2] = fb + 2149;
 HEAP32[gb + 149516 >> 2] = fb + 2150;
 HEAP32[gb + 149528 >> 2] = fb + 2151;
 HEAP32[gb + 149532 >> 2] = fb + 2152;
 HEAP32[gb + 149544 >> 2] = fb + 2153;
 HEAP32[gb + 149548 >> 2] = fb + 2154;
 HEAP32[gb + 149560 >> 2] = fb + 2155;
 HEAP32[gb + 149564 >> 2] = fb + 2156;
 HEAP32[gb + 149576 >> 2] = fb + 2155;
 HEAP32[gb + 149580 >> 2] = fb + 2157;
 HEAP32[gb + 149592 >> 2] = fb + 2153;
 HEAP32[gb + 149596 >> 2] = fb + 2158;
 HEAP32[gb + 149608 >> 2] = fb + 2151;
 HEAP32[gb + 149612 >> 2] = fb + 2159;
 HEAP32[gb + 149624 >> 2] = fb + 2149;
 HEAP32[gb + 149628 >> 2] = fb + 2160;
 HEAP32[gb + 149640 >> 2] = fb + 2105;
 HEAP32[gb + 149644 >> 2] = fb + 2161;
 HEAP32[gb + 149648 >> 2] = fb + 1414;
 HEAP32[gb + 149660 >> 2] = fb + 2162;
 HEAP32[gb + 149664 >> 2] = fb + 2163;
 HEAP32[gb + 149668 >> 2] = fb + 1415;
 HEAP32[gb + 149672 >> 2] = fb + 1416;
 HEAP32[gb + 149676 >> 2] = fb + 1417;
 HEAP32[gb + 149680 >> 2] = fb + 1418;
 HEAP32[gb + 149684 >> 2] = fb + 1419;
 HEAP32[gb + 149688 >> 2] = fb + 1420;
 HEAP32[gb + 149692 >> 2] = fb + 1421;
 HEAP32[gb + 149696 >> 2] = fb + 1422;
 HEAP32[gb + 149700 >> 2] = fb + 1423;
 HEAP32[gb + 149704 >> 2] = fb + 1424;
 runPostSets171();
}

function __ZN9LensFlare8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i2 = i7 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373697 | 0, gb + 373705 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI5FlareE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i9); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 56 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373717 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373730 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 29; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 29; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i9, i7 + 64 | 0, gb + 380814 | 0, 0);
 i3 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 373742 | 0, HEAP32[gb + 36972 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i1 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i8 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i4 + 48 | 0;
 i23 = i4 + 8 | 0;
 i25 = i4;
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f12 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(f12 * Math_fround(-2.0));
 f6 = Math_fround(f12 * Math_fround(2.0));
 f14 = Math_fround(f12 * f18);
 f21 = Math_fround(f15 * Math_fround(-2.0));
 f16 = Math_fround(f15 * Math_fround(2.0));
 f19 = Math_fround(f15 * f21);
 f22 = Math_fround(Math_fround(f14 + f19) + Math_fround(1.0));
 f20 = Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(f13 * f16)) + Math_fround(0.0));
 f18 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(f17 * f16)) + Math_fround(0.0));
 f7 = Math_fround(f17 * Math_fround(2.0));
 f11 = Math_fround(f17 * Math_fround(-2.0));
 f17 = Math_fround(f17 * f11);
 f21 = Math_fround(Math_fround(Math_fround(f12 * f7) + Math_fround(f13 * f21)) + Math_fround(0.0));
 f19 = Math_fround(Math_fround(f17 + f19) + Math_fround(1.0));
 f16 = Math_fround(Math_fround(Math_fround(f13 * f7) + Math_fround(f12 * f16)) + Math_fround(0.0));
 f7 = Math_fround(Math_fround(Math_fround(f7 * f15) + Math_fround(f13 * f6)) + Math_fround(0.0));
 f6 = Math_fround(Math_fround(Math_fround(f13 * f11) + Math_fround(f15 * f6)) + Math_fround(0.0));
 f14 = Math_fround(Math_fround(f17 + f14) + Math_fround(1.0));
 i26 = i2;
 i2 = HEAP32[i26 + 4 >> 2] | 0;
 i3 = i25;
 HEAP32[i3 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i24 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i24 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 __Z17CalculateGlobalRS23TransformAccessReadOnly(i23, i24);
 f17 = Math_fround(HEAPF32[i23 >> 2]);
 f15 = Math_fround(HEAPF32[i23 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i23 + 8 >> 2]);
 f13 = Math_fround(Math_fround(f17 * f22) + Math_fround(Math_fround(f21 * f15) + Math_fround(f7 * f11)));
 f12 = Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f19 * f15) + Math_fround(f6 * f11)));
 f11 = Math_fround(Math_fround(f17 * f18) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f11)));
 f15 = Math_fround(HEAPF32[i23 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i23 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i23 + 20 >> 2]);
 f10 = Math_fround(Math_fround(f22 * f15) + Math_fround(Math_fround(f21 * f17) + Math_fround(f7 * f8)));
 f9 = Math_fround(Math_fround(f20 * f15) + Math_fround(Math_fround(f19 * f17) + Math_fround(f6 * f8)));
 f8 = Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f16 * f17) + Math_fround(f14 * f8)));
 f17 = Math_fround(HEAPF32[i23 + 24 >> 2]);
 f15 = Math_fround(HEAPF32[i23 + 28 >> 2]);
 f5 = Math_fround(HEAPF32[i23 + 32 >> 2]);
 f7 = Math_fround(Math_fround(f22 * f17) + Math_fround(Math_fround(f21 * f15) + Math_fround(f7 * f5)));
 f6 = Math_fround(Math_fround(f20 * f17) + Math_fround(Math_fround(f19 * f15) + Math_fround(f6 * f5)));
 f5 = Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f5)));
 HEAPF32[i1 >> 2] = f13;
 HEAPF32[i1 + 4 >> 2] = f12;
 HEAPF32[i1 + 8 >> 2] = f11;
 HEAPF32[i1 + 12 >> 2] = f10;
 HEAPF32[i1 + 16 >> 2] = f9;
 HEAPF32[i1 + 20 >> 2] = f8;
 HEAPF32[i1 + 24 >> 2] = f7;
 HEAPF32[i1 + 28 >> 2] = f6;
 HEAPF32[i1 + 32 >> 2] = f5;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj433ES2_NS_9PxD6Drive4EnumENS_14PxD6JointDriveEEEKNS_27PxD6JointDriveGeneratedInfoEEEvPjRKT_RT0_(i14, i1, i9, i13) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 48 | 0;
 i8 = i12 + 152 | 0;
 i11 = i12 + 32 | 0;
 i6 = i12 + 100 | 0;
 i7 = i12;
 i10 = i12 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i14 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i14 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i14 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i14 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i14 + 36 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = i14 + 24 | 0;
 i3 = i9 + 12 | 0;
 i1 = i9 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 i20 = i14 + 8 | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 i18 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = HEAP32[i14 + 20 >> 2] | 0;
 i15 = HEAP32[i14 + 28 >> 2] | 0;
 i4 = HEAP32[i14 + 32 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP8[i8 >> 0] = 0;
 i16 = i10;
 i9 = i8;
 HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
 HEAP32[i5 >> 2] = i19;
 HEAP32[i5 + 4 >> 2] = i18;
 i20 = i5 + 8 | 0;
 HEAP32[i20 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i17;
 HEAP32[i5 + 24 >> 2] = i16;
 HEAP32[i5 + 28 >> 2] = i15;
 HEAP32[i5 + 32 >> 2] = i4;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i9;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj505ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i13, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj506ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i13 + 16 | 0, 1);
 HEAP32[i6 >> 2] = i19;
 HEAP32[i6 + 4 >> 2] = i18;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i17;
 HEAP32[i6 + 24 >> 2] = i16;
 HEAP32[i6 + 28 >> 2] = i15;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i9;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEEEEjT_j(i13, i6, 0) | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP8[HEAP32[i14 + 40 >> 2] >> 0] = 1;
 i19 = HEAP32[i2 >> 2] | 0;
 i13 = i10;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i16 = HEAP32[i10 + 12 >> 2] | 0;
 i17 = HEAP32[i10 + 8 >> 2] | 0;
 i20 = HEAP32[i1 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i15 = i5;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = i14;
 HEAP32[i5 + 12 >> 2] = i16;
 HEAP32[i5 + 8 >> 2] = i17;
 mftCall_viii(i18 | 0, i19 | 0, i20 | 0, i5 | 0);
 STACKTOP = i12;
 return;
}

function runPostSets168() {
 HEAP32[gb + 147972 >> 2] = fb + 387;
 HEAP32[gb + 147976 >> 2] = fb + 57;
 HEAP32[gb + 147980 >> 2] = fb + 58;
 HEAP32[gb + 147984 >> 2] = fb + 388;
 HEAP32[gb + 147988 >> 2] = fb + 2012;
 HEAP32[gb + 147992 >> 2] = fb + 2013;
 HEAP32[gb + 147996 >> 2] = fb + 1402;
 HEAP32[gb + 148e3 >> 2] = fb + 1403;
 HEAP32[gb + 148004 >> 2] = fb + 120;
 HEAP32[gb + 148008 >> 2] = fb + 1404;
 HEAP32[gb + 148012 >> 2] = fb + 59;
 HEAP32[gb + 148024 >> 2] = fb + 2014;
 HEAP32[gb + 148028 >> 2] = fb + 2015;
 HEAP32[gb + 148032 >> 2] = fb + 1405;
 HEAP32[gb + 148036 >> 2] = fb + 1406;
 HEAP32[gb + 148048 >> 2] = fb + 2016;
 HEAP32[gb + 148052 >> 2] = fb + 2017;
 HEAP32[gb + 148056 >> 2] = fb + 121;
 HEAP32[gb + 148060 >> 2] = fb + 1407;
 HEAP32[gb + 148072 >> 2] = fb + 2018;
 HEAP32[gb + 148076 >> 2] = fb + 2019;
 HEAP32[gb + 148080 >> 2] = fb + 60;
 HEAP32[gb + 148092 >> 2] = fb + 2020;
 HEAP32[gb + 148096 >> 2] = fb + 2021;
 HEAP32[gb + 148100 >> 2] = fb + 2022;
 HEAP32[gb + 148104 >> 2] = fb + 2023;
 HEAP32[gb + 148108 >> 2] = fb + 68;
 HEAP32[gb + 148112 >> 2] = fb + 69;
 HEAP32[gb + 148116 >> 2] = fb + 1005;
 HEAP32[gb + 148120 >> 2] = fb + 2024;
 HEAP32[gb + 148132 >> 2] = fb + 2025;
 HEAP32[gb + 148136 >> 2] = fb + 2026;
 HEAP32[gb + 148140 >> 2] = fb + 2027;
 HEAP32[gb + 148144 >> 2] = fb + 2028;
 HEAP32[gb + 148148 >> 2] = fb + 1006;
 HEAP32[gb + 148152 >> 2] = fb + 2029;
 HEAP32[gb + 148156 >> 2] = fb + 222;
 HEAP32[gb + 148160 >> 2] = fb + 375;
 HEAP32[gb + 148164 >> 2] = fb + 1408;
 HEAP32[gb + 148168 >> 2] = fb + 376;
 HEAP32[gb + 148180 >> 2] = fb + 2030;
 HEAP32[gb + 148184 >> 2] = fb + 2031;
 HEAP32[gb + 148196 >> 2] = fb + 2032;
 HEAP32[gb + 148200 >> 2] = fb + 2033;
 HEAP32[gb + 148212 >> 2] = fb + 2034;
 HEAP32[gb + 148216 >> 2] = fb + 2035;
 HEAP32[gb + 148228 >> 2] = fb + 2036;
 HEAP32[gb + 148232 >> 2] = fb + 2037;
 HEAP32[gb + 148236 >> 2] = fb + 2038;
 HEAP32[gb + 148248 >> 2] = fb + 2034;
 HEAP32[gb + 148252 >> 2] = fb + 2039;
 HEAP32[gb + 148264 >> 2] = fb + 2040;
 HEAP32[gb + 148268 >> 2] = fb + 2041;
 HEAP32[gb + 148280 >> 2] = fb + 2042;
 HEAP32[gb + 148284 >> 2] = fb + 2043;
 HEAP32[gb + 148296 >> 2] = fb + 2044;
 HEAP32[gb + 148300 >> 2] = fb + 2045;
 HEAP32[gb + 148312 >> 2] = fb + 2044;
 HEAP32[gb + 148316 >> 2] = fb + 2046;
 HEAP32[gb + 148328 >> 2] = fb + 2042;
 HEAP32[gb + 148332 >> 2] = fb + 2047;
 HEAP32[gb + 148344 >> 2] = fb + 2048;
 HEAP32[gb + 148348 >> 2] = fb + 2049;
 HEAP32[gb + 148352 >> 2] = fb + 389;
 HEAP32[gb + 148356 >> 2] = fb + 223;
 HEAP32[gb + 148360 >> 2] = fb + 390;
 HEAP32[gb + 148364 >> 2] = fb + 391;
 HEAP32[gb + 148368 >> 2] = fb + 392;
 HEAP32[gb + 148372 >> 2] = fb + 1409;
 HEAP32[gb + 148376 >> 2] = fb + 1007;
 HEAP32[gb + 148380 >> 2] = fb + 111;
 HEAP32[gb + 148384 >> 2] = fb + 14;
 HEAP32[gb + 148388 >> 2] = fb + 118;
 HEAP32[gb + 148392 >> 2] = fb + 119;
 HEAP32[gb + 148396 >> 2] = fb + 393;
 HEAP32[gb + 148400 >> 2] = fb + 394;
 HEAP32[gb + 148404 >> 2] = fb + 395;
 HEAP32[gb + 148408 >> 2] = fb + 377;
 HEAP32[gb + 148412 >> 2] = fb + 70;
 HEAP32[gb + 148416 >> 2] = fb + 120;
 HEAP32[gb + 148420 >> 2] = fb + 122;
 HEAP32[gb + 148424 >> 2] = fb + 396;
 HEAP32[gb + 148428 >> 2] = fb + 397;
 HEAP32[gb + 148432 >> 2] = fb + 1008;
 HEAP32[gb + 148436 >> 2] = fb + 112;
 HEAP32[gb + 148440 >> 2] = fb + 1009;
 HEAP32[gb + 148444 >> 2] = fb + 1410;
 HEAP32[gb + 148448 >> 2] = fb + 1010;
 HEAP32[gb + 148452 >> 2] = fb + 2050;
 HEAP32[gb + 148456 >> 2] = fb + 2051;
 HEAP32[gb + 148468 >> 2] = fb + 2052;
 HEAP32[gb + 148472 >> 2] = fb + 2053;
 HEAP32[gb + 148484 >> 2] = fb + 2054;
 HEAP32[gb + 148488 >> 2] = fb + 2055;
 HEAP32[gb + 148500 >> 2] = fb + 2056;
 HEAP32[gb + 148504 >> 2] = fb + 2057;
 HEAP32[gb + 148516 >> 2] = fb + 2058;
 HEAP32[gb + 148520 >> 2] = fb + 2059;
 HEAP32[gb + 148524 >> 2] = fb + 1011;
 HEAP32[gb + 148528 >> 2] = fb + 113;
 runPostSets169();
}

function runPostSets149() {
 HEAP32[gb + 139684 >> 2] = fb + 952;
 HEAP32[gb + 139688 >> 2] = fb + 208;
 HEAP32[gb + 139692 >> 2] = fb + 1863;
 HEAP32[gb + 139696 >> 2] = fb + 1894;
 HEAP32[gb + 139708 >> 2] = fb + 953;
 HEAP32[gb + 139712 >> 2] = fb + 354;
 HEAP32[gb + 139716 >> 2] = fb + 954;
 HEAP32[gb + 139720 >> 2] = fb + 355;
 HEAP32[gb + 139724 >> 2] = fb + 356;
 HEAP32[gb + 139728 >> 2] = fb + 357;
 HEAP32[gb + 139732 >> 2] = fb + 955;
 HEAP32[gb + 139736 >> 2] = fb + 209;
 HEAP32[gb + 139740 >> 2] = fb + 1863;
 HEAP32[gb + 139744 >> 2] = fb + 1895;
 HEAP32[gb + 139756 >> 2] = fb + 956;
 HEAP32[gb + 139760 >> 2] = fb + 358;
 HEAP32[gb + 139764 >> 2] = fb + 957;
 HEAP32[gb + 139768 >> 2] = fb + 359;
 HEAP32[gb + 139772 >> 2] = fb + 360;
 HEAP32[gb + 139776 >> 2] = fb + 361;
 HEAP32[gb + 139780 >> 2] = fb + 958;
 HEAP32[gb + 139784 >> 2] = fb + 210;
 HEAP32[gb + 139788 >> 2] = fb + 1863;
 HEAP32[gb + 139792 >> 2] = fb + 1896;
 HEAP32[gb + 139804 >> 2] = fb + 959;
 HEAP32[gb + 139808 >> 2] = fb + 362;
 HEAP32[gb + 139812 >> 2] = fb + 960;
 HEAP32[gb + 139816 >> 2] = fb + 363;
 HEAP32[gb + 139820 >> 2] = fb + 364;
 HEAP32[gb + 139824 >> 2] = fb + 365;
 HEAP32[gb + 139828 >> 2] = fb + 961;
 HEAP32[gb + 139832 >> 2] = fb + 211;
 HEAP32[gb + 139836 >> 2] = fb + 1863;
 HEAP32[gb + 139840 >> 2] = fb + 1897;
 HEAP32[gb + 139852 >> 2] = fb + 962;
 HEAP32[gb + 139856 >> 2] = fb + 366;
 HEAP32[gb + 139860 >> 2] = fb + 963;
 HEAP32[gb + 139864 >> 2] = fb + 367;
 HEAP32[gb + 139868 >> 2] = fb + 368;
 HEAP32[gb + 139872 >> 2] = fb + 369;
 HEAP32[gb + 139876 >> 2] = fb + 964;
 HEAP32[gb + 139880 >> 2] = fb + 212;
 HEAP32[gb + 139884 >> 2] = fb + 1863;
 HEAP32[gb + 139888 >> 2] = fb + 1898;
 HEAP32[gb + 139900 >> 2] = fb + 965;
 HEAP32[gb + 139904 >> 2] = fb + 370;
 HEAP32[gb + 139908 >> 2] = fb + 966;
 HEAP32[gb + 139912 >> 2] = fb + 371;
 HEAP32[gb + 139916 >> 2] = fb + 372;
 HEAP32[gb + 139920 >> 2] = fb + 373;
 HEAP32[gb + 139924 >> 2] = fb + 967;
 HEAP32[gb + 139928 >> 2] = fb + 213;
 HEAP32[gb + 139932 >> 2] = fb + 1863;
 HEAP32[gb + 139936 >> 2] = fb + 1899;
 HEAP32[gb + 139948 >> 2] = fb + 1870;
 HEAP32[gb + 139952 >> 2] = fb + 1900;
 HEAP32[gb + 139956 >> 2] = fb + 1354;
 HEAP32[gb + 139968 >> 2] = fb + 1870;
 HEAP32[gb + 139972 >> 2] = fb + 1901;
 HEAP32[gb + 139976 >> 2] = fb + 1355;
 HEAP32[gb + 139988 >> 2] = fb + 1870;
 HEAP32[gb + 139992 >> 2] = fb + 1902;
 HEAP32[gb + 139996 >> 2] = fb + 1356;
 HEAP32[gb + 140008 >> 2] = fb + 1870;
 HEAP32[gb + 140012 >> 2] = fb + 1903;
 HEAP32[gb + 140016 >> 2] = fb + 1357;
 HEAP32[gb + 140028 >> 2] = fb + 1870;
 HEAP32[gb + 140032 >> 2] = fb + 1904;
 HEAP32[gb + 140036 >> 2] = fb + 1358;
 HEAP32[gb + 140048 >> 2] = fb + 1870;
 HEAP32[gb + 140052 >> 2] = fb + 1905;
 HEAP32[gb + 140056 >> 2] = fb + 1359;
 HEAP32[gb + 140068 >> 2] = fb + 1870;
 HEAP32[gb + 140072 >> 2] = fb + 1906;
 HEAP32[gb + 140076 >> 2] = fb + 1360;
 HEAP32[gb + 140088 >> 2] = fb + 1870;
 HEAP32[gb + 140092 >> 2] = fb + 1907;
 HEAP32[gb + 140096 >> 2] = fb + 1361;
 HEAP32[gb + 140108 >> 2] = fb + 1870;
 HEAP32[gb + 140112 >> 2] = fb + 1908;
 HEAP32[gb + 140116 >> 2] = fb + 1362;
 HEAP32[gb + 140128 >> 2] = fb + 1870;
 HEAP32[gb + 140132 >> 2] = fb + 1909;
 HEAP32[gb + 140136 >> 2] = fb + 1363;
 HEAP32[gb + 140148 >> 2] = fb + 1870;
 HEAP32[gb + 140152 >> 2] = fb + 1910;
 HEAP32[gb + 140156 >> 2] = fb + 1364;
 HEAP32[gb + 140168 >> 2] = fb + 1870;
 HEAP32[gb + 140172 >> 2] = fb + 1911;
 HEAP32[gb + 140176 >> 2] = fb + 1365;
 HEAP32[gb + 140188 >> 2] = fb + 1870;
 HEAP32[gb + 140192 >> 2] = fb + 1912;
 HEAP32[gb + 140196 >> 2] = fb + 1366;
 HEAP32[gb + 140208 >> 2] = fb + 1870;
 HEAP32[gb + 140212 >> 2] = fb + 1913;
 HEAP32[gb + 140216 >> 2] = fb + 1367;
 HEAP32[gb + 140228 >> 2] = fb + 1870;
 HEAP32[gb + 140232 >> 2] = fb + 1914;
 HEAP32[gb + 140236 >> 2] = fb + 1368;
 HEAP32[gb + 140248 >> 2] = fb + 1870;
 runPostSets150();
}

function runPostSets117() {
 HEAP32[gb + 103864 >> 2] = fb + 96;
 HEAP32[gb + 103868 >> 2] = fb + 164;
 HEAP32[gb + 103872 >> 2] = fb + 331;
 HEAP32[gb + 103876 >> 2] = fb + 771;
 HEAP32[gb + 103880 >> 2] = fb + 772;
 HEAP32[gb + 103884 >> 2] = fb + 773;
 HEAP32[gb + 103888 >> 2] = fb + 1538;
 HEAP32[gb + 103892 >> 2] = fb + 46;
 HEAP32[gb + 103896 >> 2] = fb + 774;
 HEAP32[gb + 103900 >> 2] = fb + 775;
 HEAP32[gb + 103904 >> 2] = fb + 776;
 HEAP32[gb + 103908 >> 2] = fb + 777;
 HEAP32[gb + 103912 >> 2] = fb + 1539;
 HEAP32[gb + 103916 >> 2] = fb + 1152;
 HEAP32[gb + 103928 >> 2] = fb + 1125;
 HEAP32[gb + 103932 >> 2] = fb + 1540;
 HEAP32[gb + 103936 >> 2] = fb + 1258;
 HEAP32[gb + 103940 >> 2] = fb + 778;
 HEAP32[gb + 103944 >> 2] = fb + 1127;
 HEAP32[gb + 103948 >> 2] = fb + 1128;
 HEAP32[gb + 103952 >> 2] = fb + 469;
 HEAP32[gb + 103956 >> 2] = fb + 1129;
 HEAP32[gb + 103960 >> 2] = fb + 1541;
 HEAP32[gb + 103972 >> 2] = fb + 1125;
 HEAP32[gb + 103976 >> 2] = fb + 1542;
 HEAP32[gb + 103980 >> 2] = fb + 1258;
 HEAP32[gb + 103984 >> 2] = fb + 779;
 HEAP32[gb + 103988 >> 2] = fb + 1127;
 HEAP32[gb + 103992 >> 2] = fb + 1128;
 HEAP32[gb + 103996 >> 2] = fb + 469;
 HEAP32[gb + 104e3 >> 2] = fb + 1129;
 HEAP32[gb + 104004 >> 2] = fb + 1543;
 HEAP32[gb + 104016 >> 2] = fb + 1125;
 HEAP32[gb + 104020 >> 2] = fb + 1544;
 HEAP32[gb + 104024 >> 2] = fb + 1258;
 HEAP32[gb + 104028 >> 2] = fb + 780;
 HEAP32[gb + 104032 >> 2] = fb + 1127;
 HEAP32[gb + 104036 >> 2] = fb + 1128;
 HEAP32[gb + 104040 >> 2] = fb + 469;
 HEAP32[gb + 104044 >> 2] = fb + 1129;
 HEAP32[gb + 104048 >> 2] = fb + 1545;
 HEAP32[gb + 104060 >> 2] = fb + 1546;
 HEAP32[gb + 104064 >> 2] = fb + 1547;
 HEAP32[gb + 104068 >> 2] = fb + 332;
 HEAP32[gb + 104072 >> 2] = fb + 781;
 HEAP32[gb + 104076 >> 2] = fb + 97;
 HEAP32[gb + 104080 >> 2] = fb + 165;
 HEAP32[gb + 104084 >> 2] = fb + 333;
 HEAP32[gb + 104088 >> 2] = fb + 782;
 HEAP32[gb + 104092 >> 2] = fb + 783;
 HEAP32[gb + 104096 >> 2] = fb + 784;
 HEAP32[gb + 104100 >> 2] = fb + 1548;
 HEAP32[gb + 104104 >> 2] = fb + 47;
 HEAP32[gb + 104108 >> 2] = fb + 785;
 HEAP32[gb + 104112 >> 2] = fb + 786;
 HEAP32[gb + 104116 >> 2] = fb + 787;
 HEAP32[gb + 104120 >> 2] = fb + 788;
 HEAP32[gb + 104124 >> 2] = fb + 1549;
 HEAP32[gb + 104128 >> 2] = fb + 1153;
 HEAP32[gb + 104140 >> 2] = fb + 1550;
 HEAP32[gb + 104144 >> 2] = fb + 1551;
 HEAP32[gb + 104156 >> 2] = fb + 1125;
 HEAP32[gb + 104160 >> 2] = fb + 1552;
 HEAP32[gb + 104164 >> 2] = fb + 1258;
 HEAP32[gb + 104168 >> 2] = fb + 789;
 HEAP32[gb + 104172 >> 2] = fb + 1127;
 HEAP32[gb + 104176 >> 2] = fb + 1128;
 HEAP32[gb + 104180 >> 2] = fb + 469;
 HEAP32[gb + 104184 >> 2] = fb + 1129;
 HEAP32[gb + 104188 >> 2] = fb + 1553;
 HEAP32[gb + 104200 >> 2] = fb + 1554;
 HEAP32[gb + 104204 >> 2] = fb + 1555;
 HEAP32[gb + 104208 >> 2] = fb + 1258;
 HEAP32[gb + 104212 >> 2] = fb + 790;
 HEAP32[gb + 104216 >> 2] = fb + 1127;
 HEAP32[gb + 104220 >> 2] = fb + 1128;
 HEAP32[gb + 104224 >> 2] = fb + 469;
 HEAP32[gb + 104228 >> 2] = fb + 1129;
 HEAP32[gb + 104232 >> 2] = fb + 1556;
 HEAP32[gb + 104244 >> 2] = fb + 1125;
 HEAP32[gb + 104248 >> 2] = fb + 1557;
 HEAP32[gb + 104252 >> 2] = fb + 1258;
 HEAP32[gb + 104256 >> 2] = fb + 791;
 HEAP32[gb + 104260 >> 2] = fb + 1127;
 HEAP32[gb + 104264 >> 2] = fb + 1128;
 HEAP32[gb + 104268 >> 2] = fb + 469;
 HEAP32[gb + 104272 >> 2] = fb + 1129;
 HEAP32[gb + 104276 >> 2] = fb + 1558;
 HEAP32[gb + 104288 >> 2] = fb + 1125;
 HEAP32[gb + 104292 >> 2] = fb + 1559;
 HEAP32[gb + 104296 >> 2] = fb + 1258;
 HEAP32[gb + 104300 >> 2] = fb + 792;
 HEAP32[gb + 104304 >> 2] = fb + 1127;
 HEAP32[gb + 104308 >> 2] = fb + 1128;
 HEAP32[gb + 104312 >> 2] = fb + 469;
 HEAP32[gb + 104316 >> 2] = fb + 1129;
 HEAP32[gb + 104320 >> 2] = fb + 1560;
 HEAP32[gb + 104332 >> 2] = fb + 1125;
 HEAP32[gb + 104336 >> 2] = fb + 1561;
 HEAP32[gb + 104340 >> 2] = fb + 1258;
 runPostSets118();
}

function __ZN14RenderSettings31CalculateAmbientProbeFromSkyboxEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 112 | 0;
 i5 = i11 + 108 | 0;
 i7 = i11;
 if ((HEAP16[gb + 1112668 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i9;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112668 | 0, i4);
  i8 = gb + 1112668 | 0;
 } else i8 = 0;
 do if (!(HEAP32[i9 + 188 >> 2] | 0)) {
  i6 = i9 + 360 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i10 = 28; else {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i10 = 12;
   }
   if ((i10 | 0) == 10) i10 = 12;
   if ((i10 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
    i10 = 28;
    break;
   }
   __ZN20SphericalHarmonicsL27SetZeroEv(i7);
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i5 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i10 = 19; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
      i2 = HEAP32[i4 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 19; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i10 = 21;
     }
    }
    if ((i10 | 0) == 19) i10 = 21;
    if ((i10 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   }
   __ZN17AmbientProbeBaker16BakeAmbientProbeEP8MaterialR20SphericalHarmonicsL2(i1, i7) | 0;
   i2 = i9 + 76 | 0;
   i1 = 0;
   do {
    f13 = Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]);
    f13 = Math_fround(f13 - Math_fround(HEAPF32[i9 + 76 + (i1 << 2) >> 2]));
    i12 = f13 < Math_fround(0.0);
    f14 = Math_fround(-f13);
    i1 = i1 + 1 | 0;
    if (!((i12 ? f14 : f13) <= Math_fround(9.99999974e-06))) {
     i10 = 26;
     break;
    }
   } while ((i1 | 0) < 27);
   if ((i10 | 0) == 26) {
    i1 = i7;
    i3 = i2 + 108 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
     i2 = i2 + 4 | 0;
     i1 = i1 + 4 | 0;
    } while ((i2 | 0) < (i3 | 0));
    __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i9);
    __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i9);
   }
  }
 } else i10 = 28; while (0);
 if ((i10 | 0) == 28) __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i9);
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i11;
 return;
}

function _gz_open(i7, i2, i12) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 i13 = i19 + 40 | 0;
 if (!((i7 | 0) != 0 & (i2 | 0) != 0)) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i17 = _malloc(116) | 0;
 if (!i17) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 HEAP32[i17 + 32 >> 2] = 0;
 HEAP32[i17 + 36 >> 2] = 0;
 HEAP32[i17 + 40 >> 2] = 0;
 i8 = i17 + 68 | 0;
 HEAP32[i17 >> 2] = 0;
 i9 = i17 + 72 | 0;
 i10 = i17 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i17 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i15 = i17 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i17 + 64 | 0;
 i1 = i17 + 56 | 0;
 HEAP32[i17 + 100 >> 2] = 0;
 HEAP32[i17 + 104 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i17 + 108 >> 2] = -1;
 HEAP32[i17 + 76 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
 HEAP32[i17 + 80 >> 2] = 0;
 HEAP32[i17 + 88 >> 2] = 0;
 i1 = _malloc((_strlen(i7) | 0) + 1 | 0) | 0;
 HEAP32[i17 + 84 >> 2] = i1;
 if (!i1) {
  _destroy(i17) | 0;
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 _strncpy(i1, i7, (_strlen(i7) | 0) + 1 | 0) | 0;
 i14 = i17 + 92 | 0;
 HEAP8[i14 >> 0] = 0;
 i6 = i13 + 80 | 0;
 i3 = i13;
 i4 = 0;
 i5 = -1;
 while (1) {
  i1 = HEAP8[i2 >> 0] | 0;
  if (i1 << 24 >> 24 == 114) {
   HEAP8[i14 >> 0] = 114;
   i1 = HEAP8[i2 >> 0] | 0;
  }
  switch (i1 << 24 >> 24) {
  case 97:
  case 119:
   {
    HEAP8[i14 >> 0] = 119;
    i1 = HEAP8[i2 >> 0] | 0;
    break;
   }
  default:
   {}
  }
  L19 : do if ((i1 + -48 & 255) < 10) i5 = (i1 << 24 >> 24) + -48 | 0; else switch (i1 << 24 >> 24) {
  case 102:
   {
    i4 = 1;
    i1 = 104;
    break L19;
   }
  case 104:
   {
    i4 = 2;
    i1 = 104;
    break L19;
   }
  case 82:
   {
    i4 = 3;
    i1 = 104;
    break L19;
   }
  default:
   {
    HEAP8[i3 >> 0] = i1;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i2 >> 0] | 0;
    break L19;
   }
  } while (0);
  if ((i3 | 0) != (i6 | 0) & i1 << 24 >> 24 != 0) i2 = i2 + 1 | 0; else break;
 }
 L28 : do switch (HEAP8[i14 >> 0] | 0) {
 case 0:
  {
   _destroy(i17) | 0;
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 119:
  {
   i6 = _unity_z_deflateInit2_(i17, i5, 8, -15, 8, i4, gb + 362978 | 0, 56) | 0;
   i8 = _malloc(16384) | 0;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i10 >> 2] = i8;
   if ((i6 | 0) != 0 | (i8 | 0) == 0) {
    _destroy(i17) | 0;
    i18 = 0;
    STACKTOP = i19;
    return i18 | 0;
   }
   break;
  }
 default:
  {
   i10 = _malloc(16384) | 0;
   HEAP32[i8 >> 2] = i10;
   HEAP32[i17 >> 2] = i10;
   if (!(_unity_z_inflateInit2_(i17, -15, gb + 362978 | 0, 56) | 0)) if (HEAP32[i8 >> 2] | 0) break L28;
   _destroy(i17) | 0;
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 } while (0);
 HEAP32[i11 >> 2] = 16384;
 HEAP32[(___errno_location() | 0) >> 2] = 0;
 if ((i12 | 0) < 0) i1 = _fopen(i7, i13) | 0; else i1 = mftCall_iii(fb + 513 | 0, i12 | 0, i13 | 0) | 0;
 HEAP32[i16 >> 2] = i1;
 if (!i1) {
  _destroy(i17) | 0;
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 if ((HEAP8[i14 >> 0] | 0) == 119) {
  HEAP32[i18 >> 2] = 31;
  HEAP32[i18 + 4 >> 2] = 139;
  HEAP32[i18 + 8 >> 2] = 8;
  HEAP32[i18 + 12 >> 2] = 0;
  HEAP32[i18 + 16 >> 2] = 0;
  HEAP32[i18 + 20 >> 2] = 0;
  HEAP32[i18 + 24 >> 2] = 0;
  HEAP32[i18 + 28 >> 2] = 0;
  HEAP32[i18 + 32 >> 2] = 0;
  HEAP32[i18 + 36 >> 2] = 3;
  _fprintf(i1, gb + 362525 | 0, i18) | 0;
  HEAP32[i17 + 96 >> 2] = 10;
  i18 = i17;
  STACKTOP = i19;
  return i18 | 0;
 } else {
  _check_header(i17);
  i18 = _ftell(HEAP32[i16 >> 2] | 0) | 0;
  HEAP32[i17 + 96 >> 2] = i18 - (HEAP32[i15 >> 2] | 0);
  i18 = i17;
  STACKTOP = i19;
  return i18 | 0;
 }
 return 0;
}

function __ZN19CollisionListener2D25DestroyColliderCollisionsEP10Collider2D(i24, i25) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0;
 i21 = i24 + 176 | 0;
 i9 = HEAP32[i21 >> 2] | 0;
 i22 = i24 + 180 | 0;
 i10 = HEAP32[i22 >> 2] | 0;
 i23 = i9 + (i10 * 80 | 0) | 0;
 L1 : do if (!i10) {
  i1 = i9;
  i26 = 10;
 } else {
  i8 = HEAP32[i24 + 96 >> 2] | 0;
  i2 = i24 + 100 | 0;
  i3 = i24 + 8 | 0;
  i4 = i24 + 16 | 0;
  i5 = i24 + 20 | 0;
  i6 = i24 + 12 | 0;
  i1 = i9;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   if ((i8 | 0) == (i7 | 0)) {
    if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i26 = 5;
   } else i26 = 5;
   if ((i26 | 0) == 5) {
    i26 = 0;
    if (!(HEAP8[i6 >> 0] | 0)) {
     i26 = 10;
     break L1;
    }
    if (!(HEAP32[i3 >> 2] | 0)) {
     i26 = 10;
     break L1;
    }
    if ((HEAP32[i4 >> 2] | 0) != (i7 | 0)) {
     i26 = 10;
     break L1;
    }
    if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i26 = 10;
     break L1;
    }
   }
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i23 | 0));
 } while (0);
 if ((i26 | 0) == 10) if ((i1 | 0) != (i23 | 0)) {
  i7 = i24 + 12 | 0;
  i8 = i24 + 16 | 0;
  i11 = i24 + 24 | 0;
  i12 = i24 + 80 | 0;
  i13 = i24 + 84 | 0;
  i14 = i24 + 88 | 0;
  i15 = i24 + 8 | 0;
  i16 = i24 + 196 | 0;
  i17 = i24 + 16 | 0;
  i18 = i24 + 20 | 0;
  i19 = i24 + 96 | 0;
  i20 = i24 + 100 | 0;
  i6 = i9;
  i5 = i10;
  while (1) {
   i2 = i1 + 80 | 0;
   L18 : do if ((i2 | 0) == (i23 | 0)) i2 = i23; else {
    i4 = HEAP32[i19 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i4 | 0) == (i3 | 0)) {
      if ((HEAP32[i20 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) i26 = 23;
     } else i26 = 23;
     if ((i26 | 0) == 23) {
      i26 = 0;
      if (!(HEAP8[i7 >> 0] | 0)) break L18;
      if (!(HEAP32[i15 >> 2] | 0)) break L18;
      if ((HEAP32[i17 >> 2] | 0) != (i3 | 0)) break L18;
      if ((HEAP32[i18 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) break L18;
     }
     i2 = i2 + 80 | 0;
     if ((i2 | 0) == (i23 | 0)) {
      i2 = i23;
      break;
     }
    }
   } while (0);
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) == (i25 | 0)) {
    if ((i1 | 0) != (i6 + (i5 * 80 | 0) | 0)) i26 = 31;
   } else if (!((i1 | 0) == (i6 + (i5 * 80 | 0) | 0) ? 1 : (HEAP32[i1 + 4 >> 2] | 0) != (i25 | 0))) i26 = 31;
   if ((i26 | 0) == 31) {
    i26 = 0;
    if (!(HEAP8[i7 >> 0] | 0)) i3 = 1; else if (!(HEAP32[i15 >> 2] | 0)) i3 = 1; else if ((HEAP32[i17 >> 2] | 0) == (i3 | 0)) i3 = (HEAP32[i18 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0); else i3 = 1;
    i6 = i8;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    i4 = i1;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = i5;
    i4 = i1 + 8 | 0;
    i5 = i11;
    i6 = i4 + 56 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + 4 | 0;
     i5 = i5 + 4 | 0;
    } while ((i4 | 0) < (i6 | 0));
    HEAP32[i1 + 64 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i1 + 68 >> 2] = HEAP32[i13 >> 2];
    i6 = i14;
    i9 = HEAP32[i6 + 4 >> 2] | 0;
    i10 = i1 + 72 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
    if (i3) {
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
     HEAP8[i16 >> 0] = 1;
    }
   }
   i6 = HEAP32[i21 >> 2] | 0;
   i5 = HEAP32[i22 >> 2] | 0;
   if ((i2 | 0) == (i6 + (i5 * 80 | 0) | 0)) break; else i1 = i2;
  }
 }
 i1 = HEAP32[i24 + 216 >> 2] | 0;
 if (!i1) return;
 i24 = HEAP32[i24 + 204 >> 2] | 0;
 i2 = i24 + (i1 * 72 | 0) | 0;
 i1 = i24;
 do {
  if ((HEAP32[i1 + 8 >> 2] | 0) == (i25 | 0)) i26 = 16; else if ((HEAP32[i1 + 12 >> 2] | 0) == (i25 | 0)) i26 = 16;
  if ((i26 | 0) == 16) {
   i26 = 0;
   HEAP32[i1 + 64 >> 2] = 0;
  }
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function runPostSets197() {
 HEAP32[gb + 168004 >> 2] = fb + 1848;
 HEAP32[gb + 168008 >> 2] = fb + 1849;
 HEAP32[gb + 168012 >> 2] = fb + 139;
 HEAP32[gb + 168016 >> 2] = fb + 164;
 HEAP32[gb + 168020 >> 2] = fb + 140;
 HEAP32[gb + 168024 >> 2] = fb + 165;
 HEAP32[gb + 168028 >> 2] = fb + 1850;
 HEAP32[gb + 168032 >> 2] = fb + 1185;
 HEAP32[gb + 168036 >> 2] = fb + 1851;
 HEAP32[gb + 168040 >> 2] = fb + 149;
 HEAP32[gb + 168044 >> 2] = fb + 1186;
 HEAP32[gb + 168048 >> 2] = fb + 150;
 HEAP32[gb + 168052 >> 2] = fb + 1187;
 HEAP32[gb + 168056 >> 2] = fb + 151;
 HEAP32[gb + 168060 >> 2] = fb + 1188;
 HEAP32[gb + 168064 >> 2] = fb + 152;
 HEAP32[gb + 168068 >> 2] = fb + 1189;
 HEAP32[gb + 168072 >> 2] = fb + 153;
 HEAP32[gb + 168076 >> 2] = fb + 154;
 HEAP32[gb + 168080 >> 2] = fb + 1190;
 HEAP32[gb + 168084 >> 2] = fb + 1191;
 HEAP32[gb + 168088 >> 2] = fb + 1852;
 HEAP32[gb + 168092 >> 2] = fb + 166;
 HEAP32[gb + 168096 >> 2] = fb + 141;
 HEAP32[gb + 168100 >> 2] = fb + 142;
 HEAP32[gb + 168104 >> 2] = fb + 167;
 HEAP32[gb + 168108 >> 2] = fb + 447;
 HEAP32[gb + 168112 >> 2] = fb + 1192;
 HEAP32[gb + 168116 >> 2] = fb + 1193;
 HEAP32[gb + 168120 >> 2] = fb + 143;
 HEAP32[gb + 168124 >> 2] = fb + 168;
 HEAP32[gb + 168128 >> 2] = fb + 144;
 HEAP32[gb + 168132 >> 2] = fb + 169;
 HEAP32[gb + 168136 >> 2] = fb + 1853;
 HEAP32[gb + 168140 >> 2] = fb + 2547;
 HEAP32[gb + 168144 >> 2] = fb + 1194;
 HEAP32[gb + 168148 >> 2] = fb + 12;
 HEAP32[gb + 168152 >> 2] = fb + 170;
 HEAP32[gb + 168156 >> 2] = fb + 171;
 HEAP32[gb + 168160 >> 2] = fb + 145;
 HEAP32[gb + 168164 >> 2] = fb + 172;
 HEAP32[gb + 168168 >> 2] = fb + 1854;
 HEAP32[gb + 168172 >> 2] = fb + 2548;
 HEAP32[gb + 168176 >> 2] = fb + 1195;
 HEAP32[gb + 168180 >> 2] = fb + 2549;
 HEAP32[gb + 168184 >> 2] = fb + 1855;
 HEAP32[gb + 168188 >> 2] = fb + 2550;
 HEAP32[gb + 168192 >> 2] = fb + 1196;
 HEAP32[gb + 168196 >> 2] = fb + 146;
 HEAP32[gb + 168200 >> 2] = fb + 173;
 HEAP32[gb + 168204 >> 2] = fb + 147;
 HEAP32[gb + 168208 >> 2] = fb + 174;
 HEAP32[gb + 168212 >> 2] = fb + 1856;
 HEAP32[gb + 168216 >> 2] = fb + 1197;
 HEAP32[gb + 168220 >> 2] = fb + 1857;
 HEAP32[gb + 168224 >> 2] = fb + 1198;
 HEAP32[gb + 168228 >> 2] = fb + 1199;
 HEAP32[gb + 168232 >> 2] = fb + 1200;
 HEAP32[gb + 168236 >> 2] = fb + 148;
 HEAP32[gb + 168240 >> 2] = fb + 175;
 HEAP32[gb + 168244 >> 2] = fb + 1858;
 HEAP32[gb + 168248 >> 2] = fb + 1201;
 HEAP32[gb + 168252 >> 2] = fb + 1859;
 HEAP32[gb + 168256 >> 2] = fb + 1202;
 HEAP32[gb + 168260 >> 2] = fb + 1203;
 HEAP32[gb + 168264 >> 2] = fb + 1204;
 HEAP32[gb + 168268 >> 2] = fb + 2551;
 HEAP32[gb + 168272 >> 2] = fb + 2552;
 HEAP32[gb + 168276 >> 2] = fb + 1860;
 HEAP32[gb + 168280 >> 2] = fb + 1205;
 HEAP32[gb + 168292 >> 2] = fb + 2553;
 HEAP32[gb + 168296 >> 2] = fb + 2554;
 HEAP32[gb + 168300 >> 2] = fb + 1861;
 HEAP32[gb + 168304 >> 2] = fb + 1862;
 HEAP32[gb + 168308 >> 2] = fb + 2;
 HEAP32[gb + 168312 >> 2] = fb + 149;
 HEAP32[gb + 168316 >> 2] = fb + 176;
 HEAP32[gb + 168320 >> 2] = fb + 150;
 HEAP32[gb + 168324 >> 2] = fb + 177;
 HEAP32[gb + 168328 >> 2] = fb + 1863;
 HEAP32[gb + 168332 >> 2] = fb + 1206;
 HEAP32[gb + 168336 >> 2] = fb + 1864;
 HEAP32[gb + 168340 >> 2] = fb + 1207;
 HEAP32[gb + 168352 >> 2] = fb + 2555;
 HEAP32[gb + 168356 >> 2] = fb + 2556;
 HEAP32[gb + 168360 >> 2] = fb + 1865;
 HEAP32[gb + 168364 >> 2] = fb + 1866;
 HEAP32[gb + 168368 >> 2] = fb + 3;
 HEAP32[gb + 168372 >> 2] = fb + 151;
 HEAP32[gb + 168376 >> 2] = fb + 178;
 HEAP32[gb + 168380 >> 2] = fb + 152;
 HEAP32[gb + 168384 >> 2] = fb + 179;
 HEAP32[gb + 168388 >> 2] = fb + 1867;
 HEAP32[gb + 168392 >> 2] = fb + 1208;
 HEAP32[gb + 168396 >> 2] = fb + 1868;
 HEAP32[gb + 168400 >> 2] = fb + 1209;
 HEAP32[gb + 168412 >> 2] = fb + 1125;
 HEAP32[gb + 168416 >> 2] = fb + 2557;
 HEAP32[gb + 168420 >> 2] = fb + 1258;
 HEAP32[gb + 168424 >> 2] = fb + 1210;
 runPostSets198();
}

function __ZNK13TextRendering4Font10GetTextureEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i6 = i10;
 i8 = i10 + 4 | 0;
 i5 = i4 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i6);
    i2 = HEAP32[i7 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 9;
  }
  if ((i9 | 0) == 7) i9 = 9;
  if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
  i11 = HEAP32[i5 >> 2] | 0;
  STACKTOP = i10;
  return i11 | 0;
 } while (0);
 i5 = i4 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i6);
   i4 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i9 = 17; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i9 = 19;
 }
 if ((i9 | 0) == 17) i9 = 19;
 do if ((i9 | 0) == 19) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!i1) i9 = 26; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i6);
   i2 = HEAP32[i7 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 26; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 28;
  }
 }
 if ((i9 | 0) == 26) i9 = 28;
 if ((i9 | 0) == 28) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8, gb + 1046318 | 0);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE(i1, i7) | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN19CollisionListener2D26DestroyRigidbodyCollisionsEP11Rigidbody2D(i24, i25) {
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i26 = 0;
 i21 = i24 + 176 | 0;
 i9 = HEAP32[i21 >> 2] | 0;
 i22 = i24 + 180 | 0;
 i10 = HEAP32[i22 >> 2] | 0;
 i23 = i9 + (i10 * 80 | 0) | 0;
 L1 : do if (!i10) {
  i1 = i9;
  i26 = 10;
 } else {
  i8 = HEAP32[i24 + 96 >> 2] | 0;
  i2 = i24 + 100 | 0;
  i3 = i24 + 8 | 0;
  i4 = i24 + 16 | 0;
  i5 = i24 + 20 | 0;
  i6 = i24 + 12 | 0;
  i1 = i9;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   if ((i8 | 0) == (i7 | 0)) {
    if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i26 = 5;
   } else i26 = 5;
   if ((i26 | 0) == 5) {
    i26 = 0;
    if (!(HEAP8[i6 >> 0] | 0)) {
     i26 = 10;
     break L1;
    }
    if (!(HEAP32[i3 >> 2] | 0)) {
     i26 = 10;
     break L1;
    }
    if ((HEAP32[i4 >> 2] | 0) != (i7 | 0)) {
     i26 = 10;
     break L1;
    }
    if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i26 = 10;
     break L1;
    }
   }
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i23 | 0));
 } while (0);
 if ((i26 | 0) == 10) if ((i1 | 0) != (i23 | 0)) {
  i7 = i24 + 12 | 0;
  i8 = i24 + 16 | 0;
  i11 = i24 + 24 | 0;
  i12 = i24 + 80 | 0;
  i13 = i24 + 84 | 0;
  i14 = i24 + 88 | 0;
  i15 = i24 + 8 | 0;
  i16 = i24 + 196 | 0;
  i17 = i24 + 16 | 0;
  i18 = i24 + 20 | 0;
  i19 = i24 + 96 | 0;
  i20 = i24 + 100 | 0;
  i6 = i9;
  i5 = i10;
  while (1) {
   i2 = i1 + 80 | 0;
   L18 : do if ((i2 | 0) == (i23 | 0)) i2 = i23; else {
    i4 = HEAP32[i19 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i4 | 0) == (i3 | 0)) {
      if ((HEAP32[i20 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) i26 = 23;
     } else i26 = 23;
     if ((i26 | 0) == 23) {
      i26 = 0;
      if (!(HEAP8[i7 >> 0] | 0)) break L18;
      if (!(HEAP32[i15 >> 2] | 0)) break L18;
      if ((HEAP32[i17 >> 2] | 0) != (i3 | 0)) break L18;
      if ((HEAP32[i18 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) break L18;
     }
     i2 = i2 + 80 | 0;
     if ((i2 | 0) == (i23 | 0)) {
      i2 = i23;
      break;
     }
    }
   } while (0);
   if ((HEAP32[i1 + 8 >> 2] | 0) == (i25 | 0)) {
    if ((i1 | 0) != (i6 + (i5 * 80 | 0) | 0)) i26 = 31;
   } else if (!((i1 | 0) == (i6 + (i5 * 80 | 0) | 0) ? 1 : (HEAP32[i1 + 12 >> 2] | 0) != (i25 | 0))) i26 = 31;
   if ((i26 | 0) == 31) {
    i26 = 0;
    if (!(HEAP8[i7 >> 0] | 0)) i3 = 1; else if (!(HEAP32[i15 >> 2] | 0)) i3 = 1; else if ((HEAP32[i17 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) i3 = (HEAP32[i18 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0); else i3 = 1;
    i6 = i8;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    i4 = i1;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = i5;
    i4 = i1 + 8 | 0;
    i5 = i11;
    i6 = i4 + 56 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + 4 | 0;
     i5 = i5 + 4 | 0;
    } while ((i4 | 0) < (i6 | 0));
    HEAP32[i1 + 64 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i1 + 68 >> 2] = HEAP32[i13 >> 2];
    i6 = i14;
    i9 = HEAP32[i6 + 4 >> 2] | 0;
    i10 = i1 + 72 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
    if (i3) {
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
     HEAP8[i16 >> 0] = 1;
    }
   }
   i6 = HEAP32[i21 >> 2] | 0;
   i5 = HEAP32[i22 >> 2] | 0;
   if ((i2 | 0) == (i6 + (i5 * 80 | 0) | 0)) break; else i1 = i2;
  }
 }
 i1 = HEAP32[i24 + 216 >> 2] | 0;
 if (!i1) return;
 i24 = HEAP32[i24 + 204 >> 2] | 0;
 i2 = i24 + (i1 * 72 | 0) | 0;
 i1 = i24;
 do {
  if ((HEAP32[i1 >> 2] | 0) == (i25 | 0)) i26 = 16; else if ((HEAP32[i1 + 4 >> 2] | 0) == (i25 | 0)) i26 = 16;
  if ((i26 | 0) == 16) {
   i26 = 0;
   HEAP32[i1 + 64 >> 2] = 0;
  }
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN14SerializedFile4Type8ReadTypeILb1EEEbibRPKhS3_Pi(i5, i6, i4, i7, i8, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i9 = 0;
 if ((i6 | 0) < 16) {
  i9 = HEAP32[i7 >> 2] | 0;
  i2 = _llvm_bswap_i32(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24 | 0) | 0;
  HEAP32[i7 >> 2] = i9 + 4;
  if (i1 | 0) HEAP32[i1 >> 2] = i2;
  i2 = (i2 | 0) > -1 ? i2 : -1;
  HEAP32[i5 >> 2] = i2;
  HEAP8[i5 + 40 >> 0] = 0;
  HEAP16[i5 + 42 >> 1] = -1;
  i1 = i5;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
  HEAP32[i5 >> 2] = i2;
  i1 = i1 + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP8[i5 + 40 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  i1 = i5;
 }
 HEAP32[i5 + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i2) | 0;
 if ((i6 | 0) > 16) {
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP16[i5 + 42 >> 1] = _llvm_bswap_i16(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | 0) | 0;
  HEAP32[i7 >> 2] = i3 + 2;
  i3 = 9;
 } else if ((i6 | 0) > 12) i3 = 9;
 if ((i3 | 0) == 9) {
  switch (HEAP32[i1 >> 2] | 0) {
  case -1:
  case 114:
   {
    i1 = i5 + 8 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
    i9 = i2 + 4 | 0;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24 | 0) | 0;
    i9 = i2 + 8 | 0;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i5 + 16 >> 2] = _llvm_bswap_i32(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24 | 0) | 0;
    i9 = i2 + 12 | 0;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i1 + 12 >> 2] = _llvm_bswap_i32(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24 | 0) | 0;
    i2 = i2 + 16 | 0;
    HEAP32[i7 >> 2] = i2;
    i1 = i7;
    break;
   }
  default:
   {
    i1 = i7;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
  i9 = i5 + 24 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0) | 0;
  i3 = i2 + 4 | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = _llvm_bswap_i32(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24 | 0) | 0;
  i3 = i2 + 8 | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i5 + 32 >> 2] = _llvm_bswap_i32(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24 | 0) | 0;
  i3 = i2 + 12 | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i9 + 12 >> 2] = _llvm_bswap_i32(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24 | 0) | 0;
  HEAP32[i1 >> 2] = i2 + 16;
 }
 if (!i4) {
  i9 = 1;
  return i9 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63720 | 0, 16, gb + 588245 | 0, 312) | 0;
 __ZN8TypeTreeC2ERK10MemLabelId(i2, gb + 63720 | 0);
 if (__Z12ReadTypeTreeR8TypeTreeRPKhS2_ib(i2, i7, i8, i6, 1) | 0) {
  HEAP32[i5 + 44 >> 2] = i2;
  i9 = 1;
  return i9 | 0;
 }
 if (i2 | 0) {
  i1 = i2 + 40 | 0;
  if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
   i9 = i2 + 20 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i2 + 24 | 0);
   HEAP32[i9 >> 2] = 0;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63720 | 0);
 i9 = 0;
 return i9 | 0;
}

function __ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE(i1, i5, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 32 | 0;
 i11 = i12 + 16 | 0;
 i7 = i12;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 444384 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i10, i1, i7);
 i9 = __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE(i11, i10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (i9) {
  i1 = i11 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i9 = i3 << 24 >> 24 < 0;
  __Z27FindSeparatedPathComponentsPKcjc(i10, i9 ? HEAP32[i11 >> 2] | 0 : i11, i9 ? HEAP32[i11 + 4 >> 2] | 0 : i3 & 255, 10);
  i3 = HEAP32[i10 >> 2] | 0;
  i9 = i10 + 4 | 0;
  if ((i3 | 0) == (HEAP32[i9 >> 2] | 0)) i2 = 0; else {
   L5 : do if ((__Z11StringToIntPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0) > -1) i2 = 0; else {
    i2 = i3 + 12 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    if ((i2 | 0) == (i4 | 0)) i2 = 0; else {
     if (i5) {
      HEAP32[i5 >> 2] = __Z11StringToIntPKc((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
      i4 = HEAP32[i9 >> 2] | 0;
     }
     i2 = i3 + 24 | 0;
     if ((i2 | 0) == (i4 | 0)) i2 = 0; else if (!i8) i2 = 1; else {
      i7 = __Z11StringToIntPKc((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
      i6 = i8 + 4 | 0;
      i2 = HEAP32[i6 >> 2] | 0;
      i5 = HEAP32[i8 >> 2] | 0;
      i4 = (i2 - i5 | 0) / 12 | 0;
      if (i7 >>> 0 > i4 >>> 0) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE8__appendEj(i8, i7 - i4 | 0); else if (i7 >>> 0 < i4 >>> 0) {
       i4 = i5 + (i7 * 12 | 0) | 0;
       if ((i2 | 0) != (i4 | 0)) do {
        i5 = i2 + -12 | 0;
        HEAP32[i6 >> 2] = i5;
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
        i2 = HEAP32[i6 >> 2] | 0;
       } while ((i2 | 0) != (i4 | 0));
      }
      i2 = i3 + 36 | 0;
      if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) i2 = 0; else if ((i7 | 0) > 0) {
       i3 = 0;
       while (1) {
        __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_((HEAP32[i8 >> 2] | 0) + (i3 * 12 | 0) | 0, i2) | 0;
        i2 = i2 + 12 | 0;
        if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) break;
        i3 = i3 + 1 | 0;
        if ((i3 | 0) >= (i7 | 0)) {
         i2 = 1;
         break L5;
        }
       }
       i2 = (i3 | 0) == (i7 + -1 | 0);
      } else i2 = 1;
     }
    }
   } while (0);
   i3 = HEAP32[i10 >> 2] | 0;
  }
  if (i3 | 0) {
   i4 = HEAP32[i9 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    do {
     i8 = i4 + -12 | 0;
     HEAP32[i9 >> 2] = i8;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
     i4 = HEAP32[i9 >> 2] | 0;
    } while ((i4 | 0) != (i3 | 0));
    i3 = HEAP32[i10 >> 2] | 0;
   }
   __ZdlPv(i3);
  }
 } else {
  i2 = 0;
  i1 = i11 + 11 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i2 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return i2 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E15insert_noresizeERKS4_(i14, i15, i19) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i20 = i15 + 100 | 0;
 i12 = HEAP32[i20 >> 2] | 0;
 i11 = i12 + -1 | 0;
 i16 = i19;
 i21 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i16 & i11;
 i17 = i15 + 96 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i10 = i15 + 56 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i18 + (i1 * 40 | 0) | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i13 = HEAP8[i15 + 8 >> 0] | 0;
 L1 : do if ((i9 | 0) == (i3 | 0) & (i10 | 0) == (i8 | 0)) i5 = 16; else {
  i2 = i15 + 16 | 0;
  L3 : do if (!(i13 << 24 >> 24)) {
   i4 = 0;
   i2 = i8;
   while (1) {
    if ((i21 | 0) == (i3 | 0) & (i16 | 0) == (i2 | 0)) break L3;
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i11;
    i2 = i18 + (i1 * 40 | 0) | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if ((i9 | 0) == (i3 | 0) & (i10 | 0) == (i2 | 0)) {
     i5 = 20;
     break L1;
    }
   }
  } else {
   if (!(HEAP32[i15 + 4 >> 2] | 0)) {
    i4 = 0;
    i2 = i8;
    while (1) {
     if ((i21 | 0) == (i3 | 0) & (i16 | 0) == (i2 | 0)) break L3;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i11;
     i2 = i18 + (i1 * 40 | 0) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if ((i9 | 0) == (i3 | 0) & (i10 | 0) == (i2 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else {
    i7 = i2;
    i6 = HEAP32[i7 >> 2] | 0;
    i7 = HEAP32[i7 + 4 >> 2] | 0;
    i2 = -1;
    i5 = 0;
    i4 = i8;
    do {
     if ((i6 | 0) == (i3 | 0) & (i7 | 0) == (i4 | 0)) i2 = (i2 | 0) == -1 ? i1 : i2; else if ((i21 | 0) == (i3 | 0) & (i16 | 0) == (i4 | 0)) break L3;
     i5 = i5 + 1 | 0;
     i1 = i5 + i1 & i11;
     i4 = i18 + (i1 * 40 | 0) | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
    } while (!((i9 | 0) == (i3 | 0) & (i10 | 0) == (i4 | 0)));
   }
   i1 = (i2 | 0) == -1 ? i1 : i2;
   i5 = 16;
   break L1;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = -1;
   i5 = 16;
  } else {
   HEAP32[i14 >> 2] = i15;
   HEAP32[i14 + 4 >> 2] = i18 + (i1 * 40 | 0);
   HEAP32[i14 + 8 >> 2] = i18 + (i12 * 40 | 0);
   HEAP8[i14 + 12 >> 0] = 0;
   return;
  }
 } while (0);
 if ((i5 | 0) == 16) if (!(i13 << 24 >> 24)) i5 = 20; else {
  i3 = i15 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) i5 = 20; else {
   i2 = i18 + (i1 * 40 | 0) | 0;
   i12 = i15 + 16 | 0;
   i13 = i2;
   if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i13 >> 2] | 0) ? (HEAP32[i12 + 4 >> 2] | 0) == (HEAP32[i13 + 4 >> 2] | 0) : 0) HEAP32[i3 >> 2] = i4 + -1; else i5 = 20;
  }
 }
 if ((i5 | 0) == 20) {
  i2 = i15 + 104 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i18 + (i1 * 40 | 0) | 0;
 }
 i13 = i2;
 HEAP32[i13 >> 2] = i21;
 HEAP32[i13 + 4 >> 2] = i16;
 HEAP32[i18 + (i1 * 40 | 0) + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i18 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i19 + 12 >> 2];
 HEAP32[i18 + (i1 * 40 | 0) + 16 >> 2] = HEAP32[i19 + 16 >> 2];
 HEAP32[i18 + (i1 * 40 | 0) + 20 >> 2] = HEAP32[i19 + 20 >> 2];
 HEAP32[i18 + (i1 * 40 | 0) + 24 >> 2] = HEAP32[i19 + 24 >> 2];
 HEAP32[i18 + (i1 * 40 | 0) + 28 >> 2] = HEAP32[i19 + 28 >> 2];
 i16 = i19 + 32 | 0;
 i21 = HEAP32[i16 + 4 >> 2] | 0;
 i19 = i18 + (i1 * 40 | 0) + 32 | 0;
 HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i19 + 4 >> 2] = i21;
 i19 = HEAP32[i17 >> 2] | 0;
 i21 = i19 + ((HEAP32[i20 >> 2] | 0) * 40 | 0) | 0;
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i19 + (i1 * 40 | 0);
 HEAP32[i14 + 8 >> 2] = i21;
 HEAP8[i14 + 12 >> 0] = 1;
 return;
}

function __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 i3 = i1 + 36 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i5 + 284 >> 2] | 0;
 __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i2);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i5 = i1 + 40 | 0;
 __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i5 >> 2] | 0, i2);
 i6 = i1 + 44 | 0;
 __ZN13InitialModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 48 | 0;
 __ZN11ShapeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i2);
 __ZN11ShapeModule16CheckConsistencyEv(i6);
 i6 = i1 + 264 | 0;
 __ZN14EmissionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i2);
 __ZN14EmissionModule16CheckConsistencyEv(i6);
 __ZN10SizeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 852 >> 2] | 0, i2);
 __ZN14RotationModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 856 >> 2] | 0, i2);
 __ZN11ColorModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 860 >> 2] | 0, i2);
 i6 = i1 + 864 | 0;
 __ZN8UVModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN14VelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 868 >> 2] | 0, i2);
 i6 = i1 + 872 | 0;
 __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN11ForceModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 876 >> 2] | 0, i2);
 __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 880 >> 2] | 0, i2);
 i6 = i1 + 884 | 0;
 __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 888 | 0;
 __ZN11NoiseModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 892 | 0;
 __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 896 | 0;
 __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 900 | 0;
 __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 904 | 0;
 __ZN15CollisionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 912 | 0;
 __ZN13TriggerModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN9SubModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 916 >> 2] | 0, i2);
 i6 = i1 + 920 | 0;
 __ZN12LightsModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 908 | 0;
 __ZN11TrailModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i1 = __ZN14ParticleSystem27DetermineSupportsProceduralERKS_(i1) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP8[i2 + 25 >> 0] = i1 & 1;
 HEAP8[i2 + 26 >> 0] = 1;
 i2 = i2 + 27 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | (i4 | 0) != (HEAP32[(HEAP32[i3 >> 2] | 0) + 284 >> 2] | 0);
 return;
}

function __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i3 = i1 + 36 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i5 + 284 >> 2] | 0;
 __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i2);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i5 = i1 + 40 | 0;
 __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i5 >> 2] | 0, i2);
 i6 = i1 + 44 | 0;
 __ZN13InitialModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 48 | 0;
 __ZN11ShapeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
 __ZN11ShapeModule16CheckConsistencyEv(i6);
 i6 = i1 + 264 | 0;
 __ZN14EmissionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
 __ZN14EmissionModule16CheckConsistencyEv(i6);
 __ZN10SizeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 852 >> 2] | 0, i2);
 __ZN14RotationModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 856 >> 2] | 0, i2);
 __ZN11ColorModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 860 >> 2] | 0, i2);
 i6 = i1 + 864 | 0;
 __ZN8UVModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN14VelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 868 >> 2] | 0, i2);
 i6 = i1 + 872 | 0;
 __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN11ForceModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 876 >> 2] | 0, i2);
 __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 880 >> 2] | 0, i2);
 i6 = i1 + 884 | 0;
 __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 888 | 0;
 __ZN11NoiseModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 892 | 0;
 __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 896 | 0;
 __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 900 | 0;
 __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 904 | 0;
 __ZN15CollisionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 912 | 0;
 __ZN13TriggerModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 __ZN9SubModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 916 >> 2] | 0, i2);
 i6 = i1 + 920 | 0;
 __ZN12LightsModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i6 = i1 + 908 | 0;
 __ZN11TrailModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i6 >> 2] | 0, i2);
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i6 >> 2] | 0);
 i1 = __ZN14ParticleSystem27DetermineSupportsProceduralERKS_(i1) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP8[i2 + 25 >> 0] = i1 & 1;
 HEAP8[i2 + 26 >> 0] = 1;
 i2 = i2 + 27 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | (i4 | 0) != (HEAP32[(HEAP32[i3 >> 2] | 0) + 284 >> 2] | 0);
 return;
}

function __ZN5physxL17AddConvexTriangleEPNS_27ConvexHullTriangleInterfaceEPKfS3_S3_(i5, i7, i8, i9) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 64 | 0;
 i11 = i13 + 32 | 0;
 i12 = i13;
 i26 = HEAP32[i7 >> 2] | 0;
 HEAP32[i10 >> 2] = i26;
 i25 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i10 + 4 >> 2] = i25;
 i24 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i10 + 8 >> 2] = i24;
 i23 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i23;
 i22 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i22;
 i21 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 + 8 >> 2] = i21;
 i20 = HEAP32[i9 >> 2] | 0;
 HEAP32[i12 >> 2] = i20;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = i1;
 i6 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i12 + 8 >> 2] = i6;
 f19 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f4 - f15);
 f14 = Math_fround(f16 - f14);
 f17 = Math_fround(f3 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f4 = Math_fround(f19 - f4);
 f16 = Math_fround(f18 - f16);
 f3 = Math_fround(f2 - f3);
 f2 = Math_fround(Math_fround(f3 * f14) - Math_fround(f16 * f17));
 f3 = Math_fround(Math_fround(f4 * f17) - Math_fround(f3 * f15));
 f14 = Math_fround(Math_fround(f16 * f15) - Math_fround(f4 * f14));
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)))));
 i6 = f4 < Math_fround(9.99999997e-07);
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i6 ? Math_fround(0.0) : f4;
 f2 = Math_fround(f2 * f4);
 f3 = Math_fround(f3 * f4);
 f4 = Math_fround(f14 * f4);
 HEAPF32[i10 + 12 >> 2] = f2;
 HEAPF32[i10 + 16 >> 2] = f3;
 HEAPF32[i10 + 20 >> 2] = f4;
 HEAPF32[i11 + 12 >> 2] = f2;
 HEAPF32[i11 + 16 >> 2] = f3;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i12 + 12 >> 2] = f2;
 HEAPF32[i12 + 16 >> 2] = f3;
 HEAPF32[i12 + 20 >> 2] = f4;
 f2 = Math_fround(Math_abs(Math_fround(f2)));
 f3 = Math_fround(Math_abs(Math_fround(f3)));
 f4 = Math_fround(Math_abs(Math_fround(f4)));
 i6 = !(f4 <= f2) | !(f4 <= f3) ? (!(f3 <= f2) | !(f3 <= f4)) & 1 ^ 1 : 2;
 switch (i6 | 0) {
 case 0:
  {
   i1 = f3 < f4 ? 1 : 2;
   break;
  }
 case 1:
  {
   i1 = f2 < f4 ? 0 : 2;
   break;
  }
 case 2:
  {
   i1 = !(f2 < f3) & 1;
   break;
  }
 default:
  i1 = 0;
 }
 HEAPF32[i10 + 24 >> 2] = Math_fround(Math_fround(HEAPF32[i7 + (i6 << 2) >> 2]) * Math_fround(.25));
 HEAPF32[i10 + 28 >> 2] = Math_fround(Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]) * Math_fround(.25));
 HEAPF32[i11 + 24 >> 2] = Math_fround(Math_fround(HEAPF32[i8 + (i6 << 2) >> 2]) * Math_fround(.25));
 HEAPF32[i11 + 28 >> 2] = Math_fround(Math_fround(HEAPF32[i8 + (i1 << 2) >> 2]) * Math_fround(.25));
 HEAPF32[i12 + 24 >> 2] = Math_fround(Math_fround(HEAPF32[i9 + (i6 << 2) >> 2]) * Math_fround(.25));
 HEAPF32[i12 + 28 >> 2] = Math_fround(Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]) * Math_fround(.25));
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i12 | 0, i11 | 0, i10 | 0);
 STACKTOP = i13;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE20EvaluateWithoutCacheEfRS0_(i3, f1, i15) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i15 = i15 | 0;
 var i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17 + 4 | 0;
 i4 = i17;
 if ((HEAP32[i3 + 132 >> 2] | 0) == 1) {
  i16 = (HEAP32[i3 + 120 >> 2] | 0) + 4 | 0;
  HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  STACKTOP = i17;
  return;
 }
 f5 = Math_fround(__ZNK17AnimationCurveTplI8Vector3fE8WrapTimeEf(i3, f1));
 __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i3, i3, f5, i2, i4);
 i14 = HEAP32[i2 >> 2] | 0;
 i13 = HEAP32[i3 + 120 >> 2] | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i13 + (i12 * 40 | 0) >> 2]);
 f1 = Math_fround(HEAPF32[i13 + (i14 * 40 | 0) >> 2]);
 f6 = Math_fround(f6 - f1);
 if (f6 != Math_fround(0.0)) {
  f7 = Math_fround(Math_fround(f5 - f1) / f6);
  i4 = i13 + (i14 * 40 | 0) + 28 | 0;
  f9 = Math_fround(f6 * Math_fround(HEAPF32[i4 >> 2]));
  f11 = Math_fround(f6 * Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 32 >> 2]));
  f5 = Math_fround(f6 * Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 36 >> 2]));
  i3 = i13 + (i12 * 40 | 0) + 16 | 0;
  f8 = Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2]));
  f10 = Math_fround(f6 * Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 20 >> 2]));
  f1 = Math_fround(f6 * Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 24 >> 2]));
 } else {
  f7 = Math_fround(0.0);
  i3 = i13 + (i12 * 40 | 0) + 16 | 0;
  i4 = i13 + (i14 * 40 | 0) + 28 | 0;
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 }
 i2 = i13 + (i14 * 40 | 0) + 4 | 0;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f23 = Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 8 >> 2]);
 f19 = Math_fround(f7 * f7);
 f26 = Math_fround(f7 * f19);
 f21 = Math_fround(f26 * Math_fround(2.0));
 f25 = Math_fround(f19 * Math_fround(3.0));
 f6 = Math_fround(Math_fround(f21 - f25) + Math_fround(1.0));
 f7 = Math_fround(f7 + Math_fround(f26 - Math_fround(f19 * Math_fround(2.0))));
 f19 = Math_fround(f26 - f19);
 f21 = Math_fround(f25 - f21);
 f10 = Math_fround(Math_fround(f21 * f24) + Math_fround(Math_fround(f10 * f19) + Math_fround(Math_fround(f11 * f7) + Math_fround(f23 * f6))));
 f11 = Math_fround(Math_fround(f21 * Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 12 >> 2])) + Math_fround(Math_fround(f1 * f19) + Math_fround(Math_fround(f5 * f7) + Math_fround(f22 * f6))));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(f21 * f20) + Math_fround(Math_fround(f8 * f19) + Math_fround(Math_fround(f9 * f7) + Math_fround(f18 * f6))));
 HEAPF32[i15 + 4 >> 2] = f10;
 HEAPF32[i15 + 8 >> 2] = f11;
 i4 = Math_fround(HEAPF32[i4 >> 2]) == Math_fround(inf);
 if (i4 | Math_fround(HEAPF32[i3 >> 2]) == Math_fround(inf)) HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 if (Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 28 + 4 >> 2]) == Math_fround(inf)) i16 = 10; else if (Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 16 + 4 >> 2]) == Math_fround(inf)) i16 = 10;
 if ((i16 | 0) == 10) HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 if (Math_fround(HEAPF32[i13 + (i14 * 40 | 0) + 28 + 8 >> 2]) == Math_fround(inf)) i16 = 13; else if (Math_fround(HEAPF32[i13 + (i12 * 40 | 0) + 16 + 8 >> 2]) == Math_fround(inf)) i16 = 13;
 if ((i16 | 0) == 13) HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 STACKTOP = i17;
 return;
}

function __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i11, i6, i9, i12) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 64 | 0;
 i10 = i14 + 48 | 0;
 i7 = i14 + 32 | 0;
 i8 = i14 + 16 | 0;
 i5 = i14;
 if (!i11) {
  STACKTOP = i14;
  return;
 }
 i3 = i6 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i11 + 16 | 0;
  i2 = 0;
  do {
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 5) >> 2] | 0;
   if (i1 | 0) {
    i1 = __ZN4FMOD3DSP7releaseEv(i1) | 0;
    if (i1 | 0) {
     i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i5 >> 2] = gb + 859765;
     HEAP32[i5 + 4 >> 2] = 508;
     HEAP32[i5 + 8 >> 2] = i15;
     HEAP32[i5 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i5);
    }
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (HEAP32[i6 >> 2] | 0) {
  i3 = i11 + 4 | 0;
  i2 = 0;
  do {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if (i1 | 0) {
    i1 = __ZN4FMOD3DSP7releaseEv(i1) | 0;
    if (i1 | 0) {
     i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i8 >> 2] = gb + 859765;
     HEAP32[i8 + 4 >> 2] = 513;
     HEAP32[i8 + 8 >> 2] = i15;
     HEAP32[i8 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i8);
    }
   }
   i1 = __ZN4FMOD12ChannelGroup7releaseEv(HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0;
   if (i1 | 0) {
    i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
    HEAP32[i7 >> 2] = gb + 859765;
    HEAP32[i7 + 4 >> 2] = 514;
    HEAP32[i7 + 8 >> 2] = i15;
    HEAP32[i7 + 12 >> 2] = i1;
    _printf_console(gb + 859725 | 0, i7);
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i1 = __ZN4FMOD12ChannelGroup7releaseEv(HEAP32[i11 + 68 >> 2] | 0) | 0;
 if (i1 | 0) {
  i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i10 >> 2] = gb + 859765;
  HEAP32[i10 + 4 >> 2] = 517;
  HEAP32[i10 + 8 >> 2] = i15;
  HEAP32[i10 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i10);
 }
 i1 = __ZN4FMOD6System6updateEv(i9) | 0;
 if (i1 | 0) {
  i15 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
  HEAP32[i13 >> 2] = gb + 859765;
  HEAP32[i13 + 4 >> 2] = 519;
  HEAP32[i13 + 8 >> 2] = i15;
  HEAP32[i13 + 12 >> 2] = i1;
  _printf_console(gb + 859725 | 0, i13);
 }
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 64 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 24 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 28 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 32 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 36 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 52 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 40 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, HEAP32[i11 + 72 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu24PCMMeshContactGeneration23addManifoldPointToPatchERKNS_6shdfnd3aos5Vec3VERKNS3_6FloatVEj(i14, i3, i13, i10) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i1 = i14 + 2328 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i12 = i2 + -1 | 0;
  f20 = Math_fround(HEAPF32[i14 + (i12 << 6) >> 2]);
  f18 = Math_fround(HEAPF32[i14 + (i12 << 6) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i14 + (i12 << 6) + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i3 >> 2]);
  f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f16 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f17)) + Math_fround(f16 * Math_fround(HEAPF32[i3 + 8 >> 2])));
  if (f16 > Math_fround(HEAPF32[i14 + 2224 >> 2])) {
   i2 = HEAP32[i14 + (i12 << 6) + 48 >> 2] | 0;
   i9 = i14 + (i12 << 6) + 52 | 0;
   i6 = i14 + 2324 | 0;
   if (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    i7 = i14 + 2320 | 0;
    i8 = i14 + 2240 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    do {
     if (i1 >>> 0 > i10 >>> 0) {
      i3 = i10;
      do {
       i4 = HEAP32[i7 >> 2] | 0;
       f16 = Math_fround(HEAPF32[i4 + (i3 << 6) + 16 >> 2]);
       f17 = Math_fround(HEAPF32[i4 + (i3 << 6) + 20 >> 2]);
       f20 = Math_fround(HEAPF32[i4 + (i3 << 6) + 24 >> 2]);
       f18 = Math_fround(HEAPF32[i4 + (i2 << 6) + 16 >> 2]);
       f19 = Math_fround(HEAPF32[i4 + (i2 << 6) + 20 >> 2]);
       f18 = Math_fround(f16 - f18);
       f19 = Math_fround(f17 - f19);
       f20 = Math_fround(f20 - Math_fround(HEAPF32[i4 + (i2 << 6) + 24 >> 2]));
       f20 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)) + Math_fround(f20 * f20));
       if (Math_fround(HEAPF32[i8 >> 2]) > f20) {
        f20 = Math_fround(HEAPF32[i4 + (i2 << 6) + 44 >> 2]);
        if (f20 > Math_fround(HEAPF32[i4 + (i3 << 6) + 44 >> 2])) {
         i5 = i4 + (i2 << 6) | 0;
         i1 = i4 + (i3 << 6) | 0;
         i4 = i5 + 52 | 0;
         do {
          HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
          i5 = i5 + 4 | 0;
          i1 = i1 + 4 | 0;
         } while ((i5 | 0) < (i4 | 0));
         i4 = HEAP32[i7 >> 2] | 0;
         i1 = HEAP32[i6 >> 2] | 0;
        }
        i5 = i4 + (i3 << 6) | 0;
        i1 = i4 + (i1 + -1 << 6) | 0;
        i4 = i5 + 52 | 0;
        do {
         HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
         i5 = i5 + 4 | 0;
         i1 = i1 + 4 | 0;
        } while ((i5 | 0) < (i4 | 0));
        i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
        HEAP32[i6 >> 2] = i1;
        i3 = i3 + -1 | 0;
       }
       i3 = i3 + 1 | 0;
      } while (i3 >>> 0 < i1 >>> 0);
     }
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   } else i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   i10 = i14 + (i12 << 6) + 32 | 0;
   f20 = Math_fround(HEAPF32[i10 >> 2]);
   i14 = i14 + (i12 << 6) + 36 | 0;
   f19 = Math_fround(HEAPF32[i13 >> 2]);
   HEAPF32[i10 >> 2] = f20 > f19 ? f19 : f20;
   HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   STACKTOP = i15;
   return;
  }
 }
 HEAP32[i14 + (i2 << 6) + 48 >> 2] = i10;
 HEAP32[i14 + (i2 << 6) + 52 >> 2] = HEAP32[i14 + 2324 >> 2];
 i12 = i14 + (i2 << 6) + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i1 >> 2] = i2 + 1;
 i14 = i14 + (i2 << 6) | 0;
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN5physx15PxsParticleData13addParticlesVERKNS_22PxParticleCreationDataE(i23, i22) {
 i23 = i23 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i24;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 i21 = i22 + 4 | 0;
 i20 = i22 + 8 | 0;
 i17 = HEAP32[i20 >> 2] | 0;
 i19 = HEAP32[i22 + 16 >> 2] | 0;
 i1 = HEAP32[i22 + 20 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 i5 = i2 ? 0 : HEAP32[i22 + 24 >> 2] | 0;
 if (!(HEAP32[i22 >> 2] | 0)) i6 = 0; else {
  i7 = HEAP32[i23 + 48 >> 2] | 0;
  i8 = HEAP32[i23 + 56 >> 2] | 0;
  i9 = i23 + 16 | 0;
  i10 = i23 + 24 | 0;
  i11 = i23 + 28 | 0;
  i12 = i23 + 32 | 0;
  i13 = i23 + 36 | 0;
  i14 = i23 + 40 | 0;
  i15 = i23 + 44 | 0;
  i16 = HEAP32[i21 >> 2] | 0;
  i18 = HEAP32[i22 + 12 >> 2] | 0;
  i3 = i2 ? i3 : i1;
  i4 = 0;
  while (1) {
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = i8 + (i1 >>> 5 << 2) | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i1 & 31);
   i2 = i1 + 1 | 0;
   if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) HEAP32[i9 >> 2] = i2;
   i31 = i7 + (i1 << 5) | 0;
   i32 = i18;
   i34 = HEAP32[i18 >> 2] | 0;
   HEAP32[i31 >> 2] = i34;
   i33 = HEAP32[i32 + 4 >> 2] | 0;
   i2 = i7 + (i1 << 5) + 4 | 0;
   HEAP32[i2 >> 2] = i33;
   i32 = HEAP32[i32 + 8 >> 2] | 0;
   i6 = i7 + (i1 << 5) + 8 | 0;
   HEAP32[i6 >> 2] = i32;
   i35 = i3;
   HEAP32[i7 + (i1 << 5) + 16 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + (i1 << 5) + 20 >> 2] = HEAP32[i35 + 4 >> 2];
   HEAP32[i7 + (i1 << 5) + 24 >> 2] = HEAP32[i35 + 8 >> 2];
   HEAP16[i7 + (i1 << 5) + 30 >> 1] = 0;
   HEAP16[i7 + (i1 << 5) + 28 >> 1] = 1;
   HEAPF32[i7 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
   f25 = Math_fround(HEAPF32[i10 >> 2]);
   f26 = (HEAP32[tempDoublePtr >> 2] = i34, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f27 = Math_fround(HEAPF32[i11 >> 2]);
   f28 = (HEAP32[tempDoublePtr >> 2] = i33, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f29 = Math_fround(HEAPF32[i12 >> 2]);
   f30 = (HEAP32[tempDoublePtr >> 2] = i32, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAPF32[i10 >> 2] = f25 < f26 ? f25 : f26;
   HEAPF32[i11 >> 2] = f27 < f28 ? f27 : f28;
   HEAPF32[i12 >> 2] = f29 < f30 ? f29 : f30;
   f30 = Math_fround(HEAPF32[i13 >> 2]);
   f29 = Math_fround(HEAPF32[i31 >> 2]);
   f28 = Math_fround(HEAPF32[i14 >> 2]);
   f27 = Math_fround(HEAPF32[i2 >> 2]);
   f26 = Math_fround(HEAPF32[i15 >> 2]);
   f25 = Math_fround(HEAPF32[i6 >> 2]);
   HEAPF32[i13 >> 2] = f30 > f29 ? f30 : f29;
   HEAPF32[i14 >> 2] = f28 > f27 ? f28 : f27;
   HEAPF32[i15 >> 2] = f26 > f25 ? f26 : f25;
   i4 = i4 + 1 | 0;
   i6 = HEAP32[i22 >> 2] | 0;
   if (i4 >>> 0 >= i6 >>> 0) break; else {
    i16 = i16 + i17 | 0;
    i18 = i18 + i19 | 0;
    i3 = i3 + i5 | 0;
   }
  }
 }
 i7 = HEAP32[i23 + 52 >> 2] | 0;
 if (!i7) {
  i35 = i23 + 20 | 0;
  i34 = HEAP32[i35 >> 2] | 0;
  i34 = i34 + i6 | 0;
  HEAP32[i35 >> 2] = i34;
  STACKTOP = i24;
  return 1;
 }
 i5 = HEAP32[i22 + 32 >> 2] | 0;
 i4 = HEAP32[i20 >> 2] | 0;
 if (!i6) {
  i35 = i23 + 20 | 0;
  i34 = HEAP32[i35 >> 2] | 0;
  i34 = i34 + i6 | 0;
  HEAP32[i35 >> 2] = i34;
  STACKTOP = i24;
  return 1;
 }
 i3 = HEAP32[i21 >> 2] | 0;
 i1 = HEAP32[i22 + 28 >> 2] | 0;
 i2 = 0;
 while (1) {
  HEAP32[i7 + (HEAP32[i3 >> 2] << 2) >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i6 >>> 0) break; else {
   i3 = i3 + i4 | 0;
   i1 = i1 + i5 | 0;
  }
 }
 i35 = i23 + 20 | 0;
 i34 = HEAP32[i35 >> 2] | 0;
 i34 = i34 + i6 | 0;
 HEAP32[i35 >> 2] = i34;
 STACKTOP = i24;
 return 1;
}

function __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i13, i12, i11, i4, i2) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 56 | 0;
 i8 = i14 + 40 | 0;
 i7 = i14 + 24 | 0;
 i9 = i14 + 8 | 0;
 i5 = i14 + 4 | 0;
 i6 = i14;
 i3 = i12 + 6 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (i1 & 2) {
  if (i2) {
   __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i12);
   i1 = HEAP16[i3 >> 1] | 0;
  }
  i1 = i1 & 65533;
  HEAP16[i3 >> 1] = i1;
 }
 if (i1 & 4) if (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0) | 0) {
  i3 = __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv(i13, i12) | 0;
  i15 = HEAP32[i12 + 32 >> 2] | 0;
  i1 = HEAP32[i12 + 36 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i5 | 0, i7 | 0);
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i6 | 0, i9 | 0);
  i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + 1120 >> 2] | 0;
  i15 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  mftCall_viiiiiii(i15 | 0, i1 | 0, i2 | 0, i5 | 0, i8 | 0, i6 | 0, i10 | 0, (i11 & 1 | 0) != 0 | 0);
  __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i13, i3);
 }
 switch (HEAPU8[i12 + 28 >> 0] | 0 | 0) {
 case 2:
  {
   __ZN5physx2Sc10NPhaseCore19findTriggerContactsEPNS0_18TriggerInteractionEbb(i13, i12, 1, (i11 & 1 | 0) != 0);
   __ZN5physx2Sc18TriggerInteraction7destroyEv(i12);
   mftCall_vi(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0);
   i1 = i13 + 1312 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i13 + 1324 | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i12;
   i1 = i13 + 1316 | 0;
   i15 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i15 + 1;
   if ((i15 | 0) < ((HEAP32[i13 + 1308 >> 2] | 0) * 50 | 0)) {
    STACKTOP = i14;
    return;
   }
   __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i13 + 1032 | 0);
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i14;
   return;
  }
 case 3:
  {
   __ZN5physx2Sc24ElementInteractionMarker7destroyEv(i12);
   mftCall_vi(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0);
   i1 = i13 + 1904 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i13 + 1916 | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i12;
   i1 = i13 + 1908 | 0;
   i15 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i15 + 1;
   if ((i15 | 0) < ((HEAP32[i13 + 1900 >> 2] | 0) * 50 | 0)) {
    STACKTOP = i14;
    return;
   }
   __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i13 + 1624 | 0);
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i14;
   return;
  }
 case 0:
  {
   __ZN5physx2Sc10NPhaseCore24releaseShapeInstancePairEPNS0_19ShapeInstancePairLLEjj(i13, i12, i11, i4);
   STACKTOP = i14;
   return;
  }
 case 4:
  {
   __ZN5physx2Sc10NPhaseCore39pool_deleteParticleElementRbElementPairEPNS0_35ParticleElementRbElementInteractionEjj(i13, i12, i11, i4);
   STACKTOP = i14;
   return;
  }
 default:
  {
   STACKTOP = i14;
   return;
  }
 }
}

function runPostSets175() {
 HEAP32[gb + 152140 >> 2] = fb + 2284;
 HEAP32[gb + 152152 >> 2] = fb + 135;
 HEAP32[gb + 152156 >> 2] = fb + 2273;
 HEAP32[gb + 152160 >> 2] = fb + 2285;
 HEAP32[gb + 152172 >> 2] = fb + 1518;
 HEAP32[gb + 152176 >> 2] = fb + 1519;
 HEAP32[gb + 152180 >> 2] = fb + 27;
 HEAP32[gb + 152184 >> 2] = fb + 1;
 HEAP32[gb + 152188 >> 2] = fb + 2286;
 HEAP32[gb + 152192 >> 2] = fb + 1520;
 HEAP32[gb + 152196 >> 2] = fb + 2287;
 HEAP32[gb + 152200 >> 2] = fb + 2288;
 HEAP32[gb + 152204 >> 2] = fb + 1521;
 HEAP32[gb + 152208 >> 2] = fb + 1522;
 HEAP32[gb + 152212 >> 2] = fb + 399;
 HEAP32[gb + 152224 >> 2] = fb + 1523;
 HEAP32[gb + 152228 >> 2] = fb + 1524;
 HEAP32[gb + 152232 >> 2] = fb + 28;
 HEAP32[gb + 152236 >> 2] = fb + 2;
 HEAP32[gb + 152240 >> 2] = fb + 2289;
 HEAP32[gb + 152244 >> 2] = fb + 1520;
 HEAP32[gb + 152248 >> 2] = fb + 2287;
 HEAP32[gb + 152252 >> 2] = fb + 2290;
 HEAP32[gb + 152256 >> 2] = fb + 1525;
 HEAP32[gb + 152260 >> 2] = fb + 1526;
 HEAP32[gb + 152264 >> 2] = fb + 400;
 HEAP32[gb + 152276 >> 2] = fb + 1527;
 HEAP32[gb + 152280 >> 2] = fb + 1528;
 HEAP32[gb + 152284 >> 2] = fb + 29;
 HEAP32[gb + 152288 >> 2] = fb + 3;
 HEAP32[gb + 152292 >> 2] = fb + 2291;
 HEAP32[gb + 152296 >> 2] = fb + 1520;
 HEAP32[gb + 152300 >> 2] = fb + 2287;
 HEAP32[gb + 152304 >> 2] = fb + 2292;
 HEAP32[gb + 152308 >> 2] = fb + 1529;
 HEAP32[gb + 152312 >> 2] = fb + 1530;
 HEAP32[gb + 152316 >> 2] = fb + 401;
 HEAP32[gb + 152328 >> 2] = fb + 1531;
 HEAP32[gb + 152332 >> 2] = fb + 1532;
 HEAP32[gb + 152336 >> 2] = fb + 30;
 HEAP32[gb + 152340 >> 2] = fb + 4;
 HEAP32[gb + 152344 >> 2] = fb + 2293;
 HEAP32[gb + 152348 >> 2] = fb + 1520;
 HEAP32[gb + 152352 >> 2] = fb + 2287;
 HEAP32[gb + 152356 >> 2] = fb + 2294;
 HEAP32[gb + 152360 >> 2] = fb + 1533;
 HEAP32[gb + 152364 >> 2] = fb + 1534;
 HEAP32[gb + 152368 >> 2] = fb + 402;
 HEAP32[gb + 152380 >> 2] = fb + 1535;
 HEAP32[gb + 152384 >> 2] = fb + 1536;
 HEAP32[gb + 152388 >> 2] = fb + 31;
 HEAP32[gb + 152392 >> 2] = fb + 5;
 HEAP32[gb + 152396 >> 2] = fb + 2295;
 HEAP32[gb + 152400 >> 2] = fb + 1537;
 HEAP32[gb + 152404 >> 2] = fb + 2287;
 HEAP32[gb + 152408 >> 2] = fb + 2296;
 HEAP32[gb + 152412 >> 2] = fb + 1538;
 HEAP32[gb + 152416 >> 2] = fb + 1539;
 HEAP32[gb + 152420 >> 2] = fb + 403;
 HEAP32[gb + 152432 >> 2] = fb + 1540;
 HEAP32[gb + 152436 >> 2] = fb + 1541;
 HEAP32[gb + 152440 >> 2] = fb + 32;
 HEAP32[gb + 152444 >> 2] = fb + 6;
 HEAP32[gb + 152448 >> 2] = fb + 2297;
 HEAP32[gb + 152452 >> 2] = fb + 1520;
 HEAP32[gb + 152456 >> 2] = fb + 2287;
 HEAP32[gb + 152460 >> 2] = fb + 2298;
 HEAP32[gb + 152464 >> 2] = fb + 1542;
 HEAP32[gb + 152468 >> 2] = fb + 1543;
 HEAP32[gb + 152472 >> 2] = fb + 404;
 HEAP32[gb + 152484 >> 2] = fb + 1544;
 HEAP32[gb + 152488 >> 2] = fb + 1545;
 HEAP32[gb + 152492 >> 2] = fb + 33;
 HEAP32[gb + 152496 >> 2] = fb + 7;
 HEAP32[gb + 152500 >> 2] = fb + 2299;
 HEAP32[gb + 152504 >> 2] = fb + 1546;
 HEAP32[gb + 152508 >> 2] = fb + 2287;
 HEAP32[gb + 152512 >> 2] = fb + 2300;
 HEAP32[gb + 152516 >> 2] = fb + 1547;
 HEAP32[gb + 152520 >> 2] = fb + 1548;
 HEAP32[gb + 152524 >> 2] = fb + 405;
 HEAP32[gb + 152536 >> 2] = fb + 1549;
 HEAP32[gb + 152540 >> 2] = fb + 1550;
 HEAP32[gb + 152544 >> 2] = fb + 34;
 HEAP32[gb + 152548 >> 2] = fb + 8;
 HEAP32[gb + 152552 >> 2] = fb + 2301;
 HEAP32[gb + 152556 >> 2] = fb + 1520;
 HEAP32[gb + 152560 >> 2] = fb + 2287;
 HEAP32[gb + 152564 >> 2] = fb + 2302;
 HEAP32[gb + 152568 >> 2] = fb + 1551;
 HEAP32[gb + 152572 >> 2] = fb + 1552;
 HEAP32[gb + 152576 >> 2] = fb + 406;
 HEAP32[gb + 152588 >> 2] = fb + 1553;
 HEAP32[gb + 152592 >> 2] = fb + 1554;
 HEAP32[gb + 152596 >> 2] = fb + 35;
 HEAP32[gb + 152600 >> 2] = fb + 9;
 HEAP32[gb + 152604 >> 2] = fb + 2303;
 HEAP32[gb + 152608 >> 2] = fb + 1520;
 HEAP32[gb + 152612 >> 2] = fb + 2287;
 HEAP32[gb + 152616 >> 2] = fb + 2304;
 runPostSets176();
}

function runPostSets112() {
 HEAP32[gb + 101216 >> 2] = fb + 2;
 HEAP32[gb + 101228 >> 2] = fb + 1424;
 HEAP32[gb + 101232 >> 2] = fb + 1425;
 HEAP32[gb + 101236 >> 2] = fb + 907;
 HEAP32[gb + 101240 >> 2] = fb + 1;
 HEAP32[gb + 101252 >> 2] = fb + 1426;
 HEAP32[gb + 101256 >> 2] = fb + 1427;
 HEAP32[gb + 101260 >> 2] = fb + 1122;
 HEAP32[gb + 101264 >> 2] = fb + 742;
 HEAP32[gb + 101268 >> 2] = fb + 743;
 HEAP32[gb + 101272 >> 2] = fb + 1428;
 HEAP32[gb + 101276 >> 2] = fb + 1429;
 HEAP32[gb + 101280 >> 2] = fb + 315;
 HEAP32[gb + 101284 >> 2] = fb + 316;
 HEAP32[gb + 101296 >> 2] = fb + 1430;
 HEAP32[gb + 101300 >> 2] = fb + 1431;
 HEAP32[gb + 101304 >> 2] = fb + 1432;
 HEAP32[gb + 101308 >> 2] = fb + 1433;
 HEAP32[gb + 101312 >> 2] = fb + 317;
 HEAP32[gb + 101316 >> 2] = fb + 318;
 HEAP32[gb + 101328 >> 2] = fb + 1434;
 HEAP32[gb + 101332 >> 2] = fb + 1435;
 HEAP32[gb + 101336 >> 2] = fb + 907;
 HEAP32[gb + 101340 >> 2] = fb + 742;
 HEAP32[gb + 101344 >> 2] = fb + 743;
 HEAP32[gb + 101348 >> 2] = fb + 319;
 HEAP32[gb + 101352 >> 2] = fb + 320;
 HEAP32[gb + 101356 >> 2] = fb + 1436;
 HEAP32[gb + 101360 >> 2] = fb + 1437;
 HEAP32[gb + 101372 >> 2] = fb + 1438;
 HEAP32[gb + 101376 >> 2] = fb + 1439;
 HEAP32[gb + 101380 >> 2] = fb + 1440;
 HEAP32[gb + 101384 >> 2] = fb + 1441;
 HEAP32[gb + 101388 >> 2] = fb + 321;
 HEAP32[gb + 101392 >> 2] = fb + 322;
 HEAP32[gb + 101404 >> 2] = fb + 1442;
 HEAP32[gb + 101408 >> 2] = fb + 1443;
 HEAP32[gb + 101412 >> 2] = fb + 1123;
 HEAP32[gb + 101416 >> 2] = fb + 742;
 HEAP32[gb + 101420 >> 2] = fb + 743;
 HEAP32[gb + 101424 >> 2] = fb + 1444;
 HEAP32[gb + 101428 >> 2] = fb + 1445;
 HEAP32[gb + 101432 >> 2] = fb + 323;
 HEAP32[gb + 101436 >> 2] = fb + 324;
 HEAP32[gb + 101448 >> 2] = fb + 1446;
 HEAP32[gb + 101452 >> 2] = fb + 1447;
 HEAP32[gb + 101456 >> 2] = fb + 1448;
 HEAP32[gb + 101460 >> 2] = fb + 1449;
 HEAP32[gb + 101464 >> 2] = fb + 325;
 HEAP32[gb + 101468 >> 2] = fb + 326;
 HEAP32[gb + 101484 >> 2] = fb + 158;
 HEAP32[gb + 101488 >> 2] = fb + 744;
 HEAP32[gb + 101492 >> 2] = fb + 1450;
 HEAP32[gb + 101496 >> 2] = fb + 159;
 HEAP32[gb + 101500 >> 2] = fb + 745;
 HEAP32[gb + 101504 >> 2] = fb + 1451;
 HEAP32[gb + 101508 >> 2] = fb + 1124;
 HEAP32[gb + 101512 >> 2] = fb + 1125;
 HEAP32[gb + 101516 >> 2] = fb + 1126;
 HEAP32[gb + 101520 >> 2] = fb + 746;
 HEAP32[gb + 101524 >> 2] = fb + 747;
 HEAP32[gb + 101528 >> 2] = fb + 1;
 HEAP32[gb + 101532 >> 2] = fb + 1;
 HEAP32[gb + 101536 >> 2] = fb + 78;
 HEAP32[gb + 101540 >> 2] = fb + 1452;
 HEAP32[gb + 101544 >> 2] = fb + 1453;
 HEAP32[gb + 101556 >> 2] = fb + 160;
 HEAP32[gb + 101560 >> 2] = fb + 1035;
 HEAP32[gb + 101564 >> 2] = fb + 1036;
 HEAP32[gb + 101568 >> 2] = fb + 1454;
 HEAP32[gb + 101592 >> 2] = fb + 1455;
 HEAP32[gb + 101596 >> 2] = fb + 1456;
 HEAP32[gb + 101600 >> 2] = fb + 1457;
 HEAP32[gb + 101604 >> 2] = fb + 748;
 HEAP32[gb + 101608 >> 2] = fb + 1458;
 HEAP32[gb + 101612 >> 2] = fb + 1459;
 HEAP32[gb + 101616 >> 2] = fb + 749;
 HEAP32[gb + 101620 >> 2] = fb + 1460;
 HEAP32[gb + 101624 >> 2] = fb + 1461;
 HEAP32[gb + 101636 >> 2] = fb + 1462;
 HEAP32[gb + 101640 >> 2] = fb + 1463;
 HEAP32[gb + 101644 >> 2] = fb + 1127;
 HEAP32[gb + 101656 >> 2] = fb + 1464;
 HEAP32[gb + 101660 >> 2] = fb + 1465;
 HEAP32[gb + 101664 >> 2] = fb + 1128;
 HEAP32[gb + 101676 >> 2] = fb + 1466;
 HEAP32[gb + 101680 >> 2] = fb + 1467;
 HEAP32[gb + 101684 >> 2] = fb + 1129;
 HEAP32[gb + 101696 >> 2] = fb + 1468;
 HEAP32[gb + 101700 >> 2] = fb + 1469;
 HEAP32[gb + 101704 >> 2] = fb + 1130;
 HEAP32[gb + 101716 >> 2] = fb + 54;
 HEAP32[gb + 101720 >> 2] = fb + 223;
 HEAP32[gb + 101724 >> 2] = fb + 94;
 HEAP32[gb + 101728 >> 2] = fb + 1470;
 HEAP32[gb + 101732 >> 2] = fb + 55;
 HEAP32[gb + 101736 >> 2] = fb + 161;
 HEAP32[gb + 101740 >> 2] = fb + 56;
 HEAP32[gb + 101744 >> 2] = fb + 327;
 HEAP32[gb + 101748 >> 2] = fb + 1131;
 runPostSets113();
}

function __ZN10AudioMixer16ResumeProcessingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 247, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 __ZN5audio5mixer12SetSuspendedERNS0_16AudioMixerMemoryEb(HEAP32[i1 + 76 >> 2] | 0, 0);
 i5 = i1 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i1 = i3;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i8 = 12;
 }
 if ((i8 | 0) == 10) i8 = 12;
 do if ((i8 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i9;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 if (!i1) i8 = 19; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i4 = i10 + (i3 << 3) | 0;
   i2 = i1;
   i1 = i10;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i4 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
   i2 = i3;
   i1 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i4 | 0) == (i1 + (i3 << 3) | 0)) i8 = 19; else {
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i1) i8 = 21;
  }
 }
 if ((i8 | 0) == 19) i8 = 21;
 if ((i8 | 0) == 21) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
 }
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 if (!i2) i8 = 27; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i10 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i10 + (i3 << 3) | 0;
   i2 = i10;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
   i1 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 27; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 29;
  }
 }
 if ((i8 | 0) == 27) i8 = 29;
 if ((i8 | 0) == 29) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 __ZN10AudioMixer16ResumeProcessingEv(i1);
 STACKTOP = i9;
 return;
}

function __ZL22addOrRemoveRigidObjectILb0ELb0ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 820 | 0;
 i16 = i17 + 816 | 0;
 i10 = i17 + 544 | 0;
 i14 = i17;
 i13 = i17 + 272 | 0;
 if (i1 | 0) {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i2, i16) | 0;
  if (i8 | 0) {
   i6 = i1 + -12 | 0;
   i2 = (HEAP32[i2 >> 2] | 0) + 2464 | 0;
   i5 = 0;
   do {
    i4 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i4 + i7 | 0;
    i4 = i4 + i6 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 & 268435456) {
     __ZN5physx3Scb5Shape9syncStateEv(i3);
     HEAP32[i15 >> 2] = i3;
     __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    if ((i1 & 251658240 | 0) == 16777216) {
     HEAP32[i4 >> 2] = i1 & 1073741823;
     HEAP32[i3 >> 2] = 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i16 = HEAP32[i10 + 268 >> 2] | 0;
  if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
   STACKTOP = i17;
   return;
  }
  i1 = HEAP32[i10 + 260 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0)) {
   HEAP8[i9 >> 0] = 0;
   STACKTOP = i17;
   return;
  }
  if (!i1) {
   STACKTOP = i17;
   return;
  }
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  STACKTOP = i17;
  return;
 }
 i12 = i14 + 256 | 0;
 i9 = i14 + 260 | 0;
 HEAP32[i14 + 264 >> 2] = 0;
 i10 = i14 + 268 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 >> 2] = i14;
 HEAP32[i10 >> 2] = 64;
 i11 = i13 + 256 | 0;
 HEAP8[i11 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
 i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i7 = i1 + -16 | 0;
 i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i2, i16) | 0;
 if (i8 | 0) {
  i6 = i1 + -12 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + 2464 | 0;
  i5 = 0;
  do {
   i4 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i4 + i7 | 0;
   i4 = i4 + i6 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 & 268435456) {
    __ZN5physx3Scb5Shape9syncStateEv(i3);
    HEAP32[i15 >> 2] = i3;
    __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i15) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   if ((i1 & 251658240 | 0) == 16777216) {
    HEAP32[i4 >> 2] = i1 & 1073741823;
    HEAP32[i3 >> 2] = 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 i16 = HEAP32[i13 + 268 >> 2] | 0;
 do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i13 + 260 >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) {
   HEAP8[i11 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 } while (0);
 i16 = HEAP32[i10 >> 2] | 0;
 do if ((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i14 | 0) == (i1 | 0)) {
   HEAP8[i12 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i17;
 return;
}

function __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i3 = i4 + 32 | 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 36 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 56 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 68 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function runPostSets120() {
 HEAP32[gb + 105792 >> 2] = fb + 1128;
 HEAP32[gb + 105796 >> 2] = fb + 469;
 HEAP32[gb + 105800 >> 2] = fb + 1597;
 HEAP32[gb + 105804 >> 2] = fb + 1598;
 HEAP32[gb + 105816 >> 2] = fb + 1599;
 HEAP32[gb + 105820 >> 2] = fb + 1600;
 HEAP32[gb + 105824 >> 2] = fb + 1258;
 HEAP32[gb + 105828 >> 2] = fb + 805;
 HEAP32[gb + 105832 >> 2] = fb + 1127;
 HEAP32[gb + 105836 >> 2] = fb + 1128;
 HEAP32[gb + 105840 >> 2] = fb + 469;
 HEAP32[gb + 105844 >> 2] = fb + 1129;
 HEAP32[gb + 105848 >> 2] = fb + 1601;
 HEAP32[gb + 105860 >> 2] = fb + 1602;
 HEAP32[gb + 105864 >> 2] = fb + 1603;
 HEAP32[gb + 105868 >> 2] = fb + 1258;
 HEAP32[gb + 105872 >> 2] = fb + 806;
 HEAP32[gb + 105876 >> 2] = fb + 1127;
 HEAP32[gb + 105880 >> 2] = fb + 1128;
 HEAP32[gb + 105884 >> 2] = fb + 469;
 HEAP32[gb + 105888 >> 2] = fb + 1129;
 HEAP32[gb + 105892 >> 2] = fb + 1604;
 HEAP32[gb + 105904 >> 2] = fb + 1605;
 HEAP32[gb + 105908 >> 2] = fb + 1606;
 HEAP32[gb + 105912 >> 2] = fb + 1258;
 HEAP32[gb + 105916 >> 2] = fb + 807;
 HEAP32[gb + 105920 >> 2] = fb + 1127;
 HEAP32[gb + 105924 >> 2] = fb + 1128;
 HEAP32[gb + 105928 >> 2] = fb + 469;
 HEAP32[gb + 105932 >> 2] = fb + 1129;
 HEAP32[gb + 105936 >> 2] = fb + 1607;
 HEAP32[gb + 105948 >> 2] = fb + 1608;
 HEAP32[gb + 105952 >> 2] = fb + 1609;
 HEAP32[gb + 105956 >> 2] = fb + 1258;
 HEAP32[gb + 105960 >> 2] = fb + 808;
 HEAP32[gb + 105964 >> 2] = fb + 1127;
 HEAP32[gb + 105968 >> 2] = fb + 1128;
 HEAP32[gb + 105972 >> 2] = fb + 469;
 HEAP32[gb + 105976 >> 2] = fb + 1129;
 HEAP32[gb + 105980 >> 2] = fb + 1610;
 HEAP32[gb + 105992 >> 2] = fb + 1611;
 HEAP32[gb + 105996 >> 2] = fb + 1612;
 HEAP32[gb + 106e3 >> 2] = fb + 1258;
 HEAP32[gb + 106004 >> 2] = fb + 809;
 HEAP32[gb + 106008 >> 2] = fb + 1127;
 HEAP32[gb + 106012 >> 2] = fb + 1128;
 HEAP32[gb + 106016 >> 2] = fb + 469;
 HEAP32[gb + 106020 >> 2] = fb + 1129;
 HEAP32[gb + 106024 >> 2] = fb + 1613;
 HEAP32[gb + 106164 >> 2] = fb + 1125;
 HEAP32[gb + 106168 >> 2] = fb + 1614;
 HEAP32[gb + 106172 >> 2] = fb + 1258;
 HEAP32[gb + 106176 >> 2] = fb + 810;
 HEAP32[gb + 106180 >> 2] = fb + 1127;
 HEAP32[gb + 106184 >> 2] = fb + 1128;
 HEAP32[gb + 106188 >> 2] = fb + 469;
 HEAP32[gb + 106192 >> 2] = fb + 1129;
 HEAP32[gb + 106196 >> 2] = fb + 1615;
 HEAP32[gb + 106200 >> 2] = fb + 1;
 HEAP32[gb + 106204 >> 2] = fb + 2;
 HEAP32[gb + 106208 >> 2] = fb + 2;
 HEAP32[gb + 106212 >> 2] = fb + 3;
 HEAP32[gb + 106216 >> 2] = fb + 4;
 HEAP32[gb + 106220 >> 2] = fb + 4;
 HEAP32[gb + 106232 >> 2] = fb + 1125;
 HEAP32[gb + 106236 >> 2] = fb + 1616;
 HEAP32[gb + 106240 >> 2] = fb + 1258;
 HEAP32[gb + 106244 >> 2] = fb + 811;
 HEAP32[gb + 106248 >> 2] = fb + 1127;
 HEAP32[gb + 106252 >> 2] = fb + 1128;
 HEAP32[gb + 106256 >> 2] = fb + 469;
 HEAP32[gb + 106260 >> 2] = fb + 1129;
 HEAP32[gb + 106264 >> 2] = fb + 1617;
 HEAP32[gb + 106268 >> 2] = fb + 1;
 HEAP32[gb + 106272 >> 2] = fb + 2;
 HEAP32[gb + 106276 >> 2] = fb + 2;
 HEAP32[gb + 106280 >> 2] = fb + 1;
 HEAP32[gb + 106284 >> 2] = fb + 2;
 HEAP32[gb + 106288 >> 2] = fb + 2;
 HEAP32[gb + 106364 >> 2] = fb + 1618;
 HEAP32[gb + 106368 >> 2] = fb + 1619;
 HEAP32[gb + 106372 >> 2] = fb + 1258;
 HEAP32[gb + 106376 >> 2] = fb + 812;
 HEAP32[gb + 106380 >> 2] = fb + 1127;
 HEAP32[gb + 106384 >> 2] = fb + 1128;
 HEAP32[gb + 106388 >> 2] = fb + 469;
 HEAP32[gb + 106392 >> 2] = fb + 1129;
 HEAP32[gb + 106396 >> 2] = fb + 1620;
 HEAP32[gb + 106408 >> 2] = fb + 1125;
 HEAP32[gb + 106412 >> 2] = fb + 1621;
 HEAP32[gb + 106416 >> 2] = fb + 1258;
 HEAP32[gb + 106420 >> 2] = fb + 813;
 HEAP32[gb + 106424 >> 2] = fb + 1127;
 HEAP32[gb + 106428 >> 2] = fb + 1128;
 HEAP32[gb + 106432 >> 2] = fb + 469;
 HEAP32[gb + 106436 >> 2] = fb + 1129;
 HEAP32[gb + 106440 >> 2] = fb + 1622;
 HEAP32[gb + 106452 >> 2] = fb + 1125;
 HEAP32[gb + 106456 >> 2] = fb + 1623;
 HEAP32[gb + 106460 >> 2] = fb + 1258;
 runPostSets121();
}

function __ZN13AudioListener8DoUpdateEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 128 | 0;
 i16 = i19 + 64 | 0;
 i9 = i19 + 48 | 0;
 i8 = i19 + 36 | 0;
 i17 = i19 + 24 | 0;
 i13 = i19 + 12 | 0;
 i12 = i19;
 i18 = i14 + 28 | 0;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i18 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i15, i11);
 __ZNK9Transform21GetWorldToLocalMatrixEv(i16, i11);
 i1 = i14 + 68 | 0;
 i6 = i16;
 i7 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i1 | 0) < (i7 | 0));
 i6 = i14 + 36 | 0;
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i6 >> 2]));
 f3 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i14 + 40 >> 2]));
 f4 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i14 + 44 >> 2]));
 f5 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
 f3 = Math_fround(f3 * f5);
 f4 = Math_fround(f4 * f5);
 HEAPF32[i14 + 48 >> 2] = Math_fround(f2 * f5);
 HEAPF32[i14 + 52 >> 2] = f3;
 HEAPF32[i14 + 56 >> 2] = f4;
 i1 = __Z21GetManagerFromContexti(3) | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform18TransformDirectionERK8Vector3f(i9, i11, i8);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 f10 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 if (f3 > f10) {
  HEAPF32[i16 >> 2] = Math_fround(f4 / f3);
  HEAPF32[i16 + 4 >> 2] = Math_fround(f5 / f3);
  HEAPF32[i16 + 8 >> 2] = Math_fround(f2 / f3);
 } else {
  HEAP32[i16 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(1.0);
 __ZNK9Transform18TransformDirectionERK8Vector3f(i13, i11, i12);
 f4 = Math_fround(HEAPF32[i13 >> 2]);
 f3 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (f3 > f10) {
  HEAPF32[i17 >> 2] = Math_fround(f4 / f3);
  HEAPF32[i17 + 4 >> 2] = Math_fround(f5 / f3);
  HEAPF32[i17 + 8 >> 2] = Math_fround(f2 / f3);
 } else {
  HEAP32[i17 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (i1 | 0) __ZN4FMOD6System23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_(i1, 0, i15, i14 + 48 | 0, i17, i16) | 0;
 HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i18 >> 2] | 0, gb + 171428 | 0) | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 100 >> 2] | 0) + 4 >> 2]);
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i18 = f2 < Math_fround(0.0);
 i17 = f2 > Math_fround(1.0);
 f10 = Math_fround(Math_fround((i17 ? Math_fround(1.0) : f2) * Math_fround(21990.0)) + Math_fround(10.0));
 __ZN4FMOD3DSP12setParameterEif(i1, 0, i18 ? Math_fround(10.0) : f10) | 0;
 STACKTOP = i19;
 return;
}

function __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_(i15, i16, i13, i12, i11, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_(i15, i16, i13, i12, i1) | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 i9 = i3;
 i10 = i8;
 do if ((i1 | 0) == (i2 | 0)) {
  i4 = i8 + 112 | 0;
  i5 = i3 + 112 | 0;
  i7 = HEAP8[i5 + 11 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i3 + 116 >> 2] | 0 : i7 & 255;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i8 + 116 >> 2] | 0 : i3 & 255;
  i1 = i3 >>> 0 < i7 >>> 0 ? i3 : i7;
  if (i1 | 0) {
   i1 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i2 ? HEAP32[i4 >> 2] | 0 : i4, i1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) < 0) break; else i1 = i14;
    return i1 | 0;
   }
  }
  if (i7 >>> 0 >= i3 >>> 0) {
   i16 = i14;
   return i16 | 0;
  }
 } else if ((i1 | 0) <= (i2 | 0)) {
  i16 = i14;
  return i16 | 0;
 } while (0);
 HEAP32[i12 >> 2] = i10;
 HEAP32[i11 >> 2] = i9;
 i1 = i14 + 1 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = i4;
 i11 = i5;
 do if ((i2 | 0) == (i3 | 0)) {
  i6 = i5 + 112 | 0;
  i7 = i4 + 112 | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i4 + 116 >> 2] | 0 : i9 & 255;
  i4 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i5 + 116 >> 2] | 0 : i4 & 255;
  i2 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  if (i2 | 0) {
   i2 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
   if (i2 | 0) {
    if ((i2 | 0) < 0) break;
    return i1 | 0;
   }
  }
  if (i9 >>> 0 >= i4 >>> 0) {
   i16 = i1;
   return i16 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i16 = i1;
  return i16 | 0;
 } while (0);
 HEAP32[i13 >> 2] = i11;
 HEAP32[i12 >> 2] = i10;
 i1 = i14 + 2 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = i4;
 i11 = i5;
 do if ((i2 | 0) == (i3 | 0)) {
  i6 = i5 + 112 | 0;
  i7 = i4 + 112 | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i4 + 116 >> 2] | 0 : i9 & 255;
  i4 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i5 + 116 >> 2] | 0 : i4 & 255;
  i2 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  if (i2 | 0) {
   i2 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
   if (i2 | 0) {
    if ((i2 | 0) < 0) break;
    return i1 | 0;
   }
  }
  if (i9 >>> 0 >= i4 >>> 0) {
   i16 = i1;
   return i16 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i16 = i1;
  return i16 | 0;
 } while (0);
 HEAP32[i16 >> 2] = i11;
 HEAP32[i13 >> 2] = i10;
 i1 = i14 + 3 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = i4;
 i11 = i5;
 do if ((i2 | 0) == (i3 | 0)) {
  i6 = i5 + 112 | 0;
  i7 = i4 + 112 | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i4 + 116 >> 2] | 0 : i9 & 255;
  i4 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i5 + 116 >> 2] | 0 : i4 & 255;
  i2 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  if (i2 | 0) {
   i2 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
   if (i2 | 0) {
    if ((i2 | 0) < 0) break;
    return i1 | 0;
   }
  }
  if (i9 >>> 0 >= i4 >>> 0) {
   i16 = i1;
   return i16 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i16 = i1;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = i11;
 HEAP32[i16 >> 2] = i10;
 i16 = i14 + 4 | 0;
 return i16 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i21 = i8 + 4 | 0;
 HEAP32[i21 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i20 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i20;
 i22 = i8 + 9 | 0;
 HEAP8[i22 >> 0] = (i20 & 65535) >>> 8;
 i20 = i8 + 12 | 0;
 i19 = i5 + 12 | 0;
 i15 = i19;
 i18 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = i20;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = i8 + 20 | 0;
 i18 = i5 + 20 | 0;
 i15 = i18;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i21 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i21 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i21;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i21 & 65535) >>> 8;
 HEAP8[i22 >> 0] = i4;
 i4 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i22 = i20;
 i21 = HEAP32[i22 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i19 + 4 >> 2] = i21;
 HEAP32[i20 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i18 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i20 = i17;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 6;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function runPostSets218() {
 HEAP32[gb + 187084 >> 2] = fb + 16;
 HEAP32[gb + 187088 >> 2] = fb + 93;
 HEAP32[gb + 187092 >> 2] = fb + 40;
 HEAP32[gb + 187096 >> 2] = fb + 19;
 HEAP32[gb + 187100 >> 2] = fb + 1315;
 HEAP32[gb + 187104 >> 2] = fb + 103;
 HEAP32[gb + 187108 >> 2] = fb + 101;
 HEAP32[gb + 187112 >> 2] = fb + 62;
 HEAP32[gb + 187116 >> 2] = fb + 28;
 HEAP32[gb + 187120 >> 2] = fb + 63;
 HEAP32[gb + 187124 >> 2] = fb + 29;
 HEAP32[gb + 187128 >> 2] = fb + 34;
 HEAP32[gb + 187132 >> 2] = fb + 2176;
 HEAP32[gb + 187136 >> 2] = fb + 2177;
 HEAP32[gb + 187140 >> 2] = fb + 2178;
 HEAP32[gb + 187144 >> 2] = fb + 2179;
 HEAP32[gb + 187148 >> 2] = fb + 2180;
 HEAP32[gb + 187152 >> 2] = fb + 2181;
 HEAP32[gb + 187156 >> 2] = fb + 36;
 HEAP32[gb + 187160 >> 2] = fb + 104;
 HEAP32[gb + 187164 >> 2] = fb + 1202;
 HEAP32[gb + 187168 >> 2] = fb + 94;
 HEAP32[gb + 187172 >> 2] = fb + 1203;
 HEAP32[gb + 187176 >> 2] = fb + 866;
 HEAP32[gb + 187180 >> 2] = fb + 867;
 HEAP32[gb + 187184 >> 2] = fb + 1204;
 HEAP32[gb + 187188 >> 2] = fb + 868;
 HEAP32[gb + 187192 >> 2] = fb + 1316;
 HEAP32[gb + 187196 >> 2] = fb + 2182;
 HEAP32[gb + 187200 >> 2] = fb + 1317;
 HEAP32[gb + 187204 >> 2] = fb + 871;
 HEAP32[gb + 187208 >> 2] = fb + 1206;
 HEAP32[gb + 187212 >> 2] = fb + 2183;
 HEAP32[gb + 187216 >> 2] = fb + 2840;
 HEAP32[gb + 187220 >> 2] = fb + 2841;
 HEAP32[gb + 187224 >> 2] = fb + 1730;
 HEAP32[gb + 187228 >> 2] = fb + 1731;
 HEAP32[gb + 187232 >> 2] = fb + 265;
 HEAP32[gb + 187236 >> 2] = fb + 2184;
 HEAP32[gb + 187240 >> 2] = fb + 2842;
 HEAP32[gb + 187252 >> 2] = fb + 465;
 HEAP32[gb + 187268 >> 2] = fb + 76;
 HEAP32[gb + 187272 >> 2] = fb + 2185;
 HEAP32[gb + 187276 >> 2] = fb + 1318;
 HEAP32[gb + 187280 >> 2] = fb + 2843;
 HEAP32[gb + 187284 >> 2] = fb + 2186;
 HEAP32[gb + 187288 >> 2] = fb + 1319;
 HEAP32[gb + 187292 >> 2] = fb + 469;
 HEAP32[gb + 187304 >> 2] = fb + 2844;
 HEAP32[gb + 187308 >> 2] = fb + 2845;
 HEAP32[gb + 187312 >> 2] = fb + 2846;
 HEAP32[gb + 187316 >> 2] = fb + 2187;
 HEAP32[gb + 187320 >> 2] = fb + 282;
 HEAP32[gb + 187324 >> 2] = fb + 2188;
 HEAP32[gb + 187328 >> 2] = fb + 2847;
 HEAP32[gb + 187332 >> 2] = fb + 1320;
 HEAP32[gb + 187336 >> 2] = fb + 1321;
 HEAP32[gb + 187340 >> 2] = fb + 1322;
 HEAP32[gb + 187344 >> 2] = fb + 183;
 HEAP32[gb + 187348 >> 2] = fb + 1323;
 HEAP32[gb + 187352 >> 2] = fb + 2848;
 HEAP32[gb + 187356 >> 2] = fb + 1324;
 HEAP32[gb + 187360 >> 2] = fb + 1325;
 HEAP32[gb + 187364 >> 2] = fb + 1326;
 HEAP32[gb + 187376 >> 2] = fb + 2849;
 HEAP32[gb + 187380 >> 2] = fb + 2850;
 HEAP32[gb + 187384 >> 2] = fb + 2846;
 HEAP32[gb + 187388 >> 2] = fb + 2187;
 HEAP32[gb + 187392 >> 2] = fb + 1;
 HEAP32[gb + 187396 >> 2] = fb + 1;
 HEAP32[gb + 187400 >> 2] = fb + 1;
 HEAP32[gb + 187404 >> 2] = fb + 1;
 HEAP32[gb + 187408 >> 2] = fb + 1;
 HEAP32[gb + 187412 >> 2] = fb + 1;
 HEAP32[gb + 187416 >> 2] = fb + 1;
 HEAP32[gb + 187420 >> 2] = fb + 1327;
 HEAP32[gb + 187424 >> 2] = fb + 2851;
 HEAP32[gb + 187428 >> 2] = fb + 1328;
 HEAP32[gb + 187432 >> 2] = fb + 1329;
 HEAP32[gb + 187436 >> 2] = fb + 1326;
 HEAP32[gb + 187448 >> 2] = fb + 2852;
 HEAP32[gb + 187452 >> 2] = fb + 2853;
 HEAP32[gb + 187456 >> 2] = fb + 2846;
 HEAP32[gb + 187460 >> 2] = fb + 2187;
 HEAP32[gb + 187464 >> 2] = fb + 283;
 HEAP32[gb + 187468 >> 2] = fb + 2189;
 HEAP32[gb + 187472 >> 2] = fb + 2854;
 HEAP32[gb + 187476 >> 2] = fb + 1330;
 HEAP32[gb + 187480 >> 2] = fb + 1331;
 HEAP32[gb + 187484 >> 2] = fb + 1332;
 HEAP32[gb + 187488 >> 2] = fb + 184;
 HEAP32[gb + 187492 >> 2] = fb + 1327;
 HEAP32[gb + 187496 >> 2] = fb + 2851;
 HEAP32[gb + 187500 >> 2] = fb + 1328;
 HEAP32[gb + 187504 >> 2] = fb + 1329;
 HEAP32[gb + 187508 >> 2] = fb + 1326;
 HEAP32[gb + 187520 >> 2] = fb + 2855;
 HEAP32[gb + 187524 >> 2] = fb + 2856;
 HEAP32[gb + 187528 >> 2] = fb + 2846;
 HEAP32[gb + 187532 >> 2] = fb + 2187;
 runPostSets219();
}

function runPostSets206() {
 HEAP32[gb + 175404 >> 2] = fb + 2026;
 HEAP32[gb + 175408 >> 2] = fb + 2027;
 HEAP32[gb + 175412 >> 2] = fb + 36;
 HEAP32[gb + 175416 >> 2] = fb + 104;
 HEAP32[gb + 175420 >> 2] = fb + 108;
 HEAP32[gb + 175424 >> 2] = fb + 94;
 HEAP32[gb + 175428 >> 2] = fb + 130;
 HEAP32[gb + 175432 >> 2] = fb + 112;
 HEAP32[gb + 175436 >> 2] = fb + 113;
 HEAP32[gb + 175440 >> 2] = fb + 131;
 HEAP32[gb + 175444 >> 2] = fb + 2695;
 HEAP32[gb + 175448 >> 2] = fb + 2696;
 HEAP32[gb + 175452 >> 2] = fb + 113;
 HEAP32[gb + 175456 >> 2] = fb + 2697;
 HEAP32[gb + 175460 >> 2] = fb + 2698;
 HEAP32[gb + 175472 >> 2] = fb + 2699;
 HEAP32[gb + 175476 >> 2] = fb + 2700;
 HEAP32[gb + 175488 >> 2] = fb + 2701;
 HEAP32[gb + 175492 >> 2] = fb + 2702;
 HEAP32[gb + 175496 >> 2] = fb + 1244;
 HEAP32[gb + 175508 >> 2] = fb + 2703;
 HEAP32[gb + 175512 >> 2] = fb + 2704;
 HEAP32[gb + 175516 >> 2] = fb + 38;
 HEAP32[gb + 175520 >> 2] = fb + 145;
 HEAP32[gb + 175524 >> 2] = fb + 16;
 HEAP32[gb + 175528 >> 2] = fb + 93;
 HEAP32[gb + 175532 >> 2] = fb + 40;
 HEAP32[gb + 175536 >> 2] = fb + 19;
 HEAP32[gb + 175540 >> 2] = fb + 1245;
 HEAP32[gb + 175544 >> 2] = fb + 103;
 HEAP32[gb + 175548 >> 2] = fb + 101;
 HEAP32[gb + 175552 >> 2] = fb + 62;
 HEAP32[gb + 175556 >> 2] = fb + 28;
 HEAP32[gb + 175560 >> 2] = fb + 63;
 HEAP32[gb + 175564 >> 2] = fb + 29;
 HEAP32[gb + 175568 >> 2] = fb + 34;
 HEAP32[gb + 175572 >> 2] = fb + 146;
 HEAP32[gb + 175576 >> 2] = fb + 147;
 HEAP32[gb + 175580 >> 2] = fb + 148;
 HEAP32[gb + 175584 >> 2] = fb + 149;
 HEAP32[gb + 175588 >> 2] = fb + 150;
 HEAP32[gb + 175592 >> 2] = fb + 151;
 HEAP32[gb + 175596 >> 2] = fb + 36;
 HEAP32[gb + 175600 >> 2] = fb + 104;
 HEAP32[gb + 175604 >> 2] = fb + 108;
 HEAP32[gb + 175608 >> 2] = fb + 94;
 HEAP32[gb + 175612 >> 2] = fb + 130;
 HEAP32[gb + 175616 >> 2] = fb + 112;
 HEAP32[gb + 175620 >> 2] = fb + 113;
 HEAP32[gb + 175624 >> 2] = fb + 131;
 HEAP32[gb + 175628 >> 2] = fb + 111;
 HEAP32[gb + 175632 >> 2] = fb + 112;
 HEAP32[gb + 175636 >> 2] = fb + 113;
 HEAP32[gb + 175640 >> 2] = fb + 1;
 HEAP32[gb + 175644 >> 2] = fb + 1;
 HEAP32[gb + 175656 >> 2] = (HEAP32[gb + 175656 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 175660 >> 2] = (HEAP32[gb + 175660 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 175696 >> 2] = fb + 2705;
 HEAP32[gb + 175700 >> 2] = fb + 2706;
 HEAP32[gb + 175704 >> 2] = fb + 15;
 HEAP32[gb + 175708 >> 2] = fb + 26;
 HEAP32[gb + 175712 >> 2] = fb + 16;
 HEAP32[gb + 175716 >> 2] = fb + 17;
 HEAP32[gb + 175720 >> 2] = fb + 18;
 HEAP32[gb + 175724 >> 2] = fb + 19;
 HEAP32[gb + 175728 >> 2] = fb + 58;
 HEAP32[gb + 175732 >> 2] = fb + 31;
 HEAP32[gb + 175736 >> 2] = fb + 27;
 HEAP32[gb + 175740 >> 2] = fb + 32;
 HEAP32[gb + 175744 >> 2] = fb + 28;
 HEAP32[gb + 175748 >> 2] = fb + 33;
 HEAP32[gb + 175752 >> 2] = fb + 29;
 HEAP32[gb + 175756 >> 2] = fb + 34;
 HEAP32[gb + 175760 >> 2] = fb + 30;
 HEAP32[gb + 175764 >> 2] = fb + 31;
 HEAP32[gb + 175768 >> 2] = fb + 32;
 HEAP32[gb + 175772 >> 2] = fb + 33;
 HEAP32[gb + 175776 >> 2] = fb + 34;
 HEAP32[gb + 175780 >> 2] = fb + 35;
 HEAP32[gb + 175784 >> 2] = fb + 36;
 HEAP32[gb + 175788 >> 2] = fb + 20;
 HEAP32[gb + 175792 >> 2] = fb + 35;
 HEAP32[gb + 175796 >> 2] = fb + 36;
 HEAP32[gb + 175800 >> 2] = fb + 37;
 HEAP32[gb + 175804 >> 2] = fb + 37;
 HEAP32[gb + 175808 >> 2] = fb + 38;
 HEAP32[gb + 175812 >> 2] = fb + 39;
 HEAP32[gb + 175816 >> 2] = fb + 40;
 HEAP32[gb + 175820 >> 2] = fb + 41;
 HEAP32[gb + 175824 >> 2] = fb + 42;
 HEAP32[gb + 175828 >> 2] = fb + 43;
 HEAP32[gb + 175832 >> 2] = fb + 44;
 HEAP32[gb + 175836 >> 2] = fb + 45;
 HEAP32[gb + 175840 >> 2] = fb + 46;
 HEAP32[gb + 175844 >> 2] = fb + 47;
 HEAP32[gb + 175848 >> 2] = fb + 48;
 HEAP32[gb + 175852 >> 2] = fb + 1;
 HEAP32[gb + 175856 >> 2] = fb + 38;
 HEAP32[gb + 175860 >> 2] = fb + 21;
 HEAP32[gb + 175864 >> 2] = fb + 3;
 runPostSets207();
}

function __ZN5physx2Sn20handleShapeMaterialsINS0_21RepXVisitorWriterBaseINS_7PxShapeEEEEEvRT_RKNS_24PxShapeMaterialsPropertyE(i13, i3) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18 + 16 | 0;
 i10 = i18;
 i17 = i18 + 20 | 0;
 i1 = i18 + 56 | 0;
 i2 = i13 + 8 | 0;
 i11 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i11) {
  STACKTOP = i18;
  return;
 }
 i16 = i17 + 20 | 0;
 i15 = i17 + 24 | 0;
 HEAP32[i17 + 28 >> 2] = 0;
 i14 = i17 + 32 | 0;
 HEAP8[i16 >> 0] = 1;
 HEAP32[i15 >> 2] = i17;
 HEAP32[i14 >> 2] = 5;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i17, i11, i1);
 mftCall_iiii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i15 >> 2] | 0, i11 | 0) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i13 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i10 >> 2] = gb + 672932;
 HEAP8[i10 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i10;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i10) | 0;
 i3 = i13 + 4 | 0;
 i4 = i13 + 16 | 0;
 i5 = i10 + 4 | 0;
 i6 = i10 + 8 | 0;
 i9 = 0;
 do {
  i7 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  i2 = i8;
  if (!i8) {
   i1 = 0;
   i2 = 0;
  } else {
   if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0) | 0)) {
    i19 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i12 >> 2] = gb + 672932;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i19, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i12);
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i8 | 0) | 0;
   i19 = getTempRet0() | 0;
   i20 = (i1 | 0) == 0 & (i19 | 0) == 0;
   i1 = i20 ? i2 : i1;
   i2 = i20 ? 0 : i19;
  }
  i20 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = gb + 763461;
  HEAP32[i5 >> 2] = i8;
  i19 = i6;
  HEAP32[i19 >> 2] = i1;
  HEAP32[i19 + 4 >> 2] = i2;
  mftCall_viii(i20 | 0, i7 | 0, gb + 672932 | 0, i10 | 0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i11 | 0));
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
 }
 i20 = HEAP32[i14 >> 2] | 0;
 do if ((i20 | 0) > -1 & (i20 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i15 >> 2] | 0;
  if ((i17 | 0) == (i1 | 0)) {
   HEAP8[i16 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i20 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 12 >> 2] | 0, i20 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i18;
 return;
}

function __ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter(i6, i7, i9, i3, i4) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 32 | 0;
 i5 = i13 + 56 | 0;
 i10 = i13;
 i11 = i13 + 44 | 0;
 i12 = i13 + 40 | 0;
 i8 = i6 + 112 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i1, i9, i6 + 20 | 0, i4, i2, i5) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
   if ((__ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(HEAP32[i8 >> 2] | 0, i1, i2, i5, i3, i4, i10, 0, 0, 0) | 0) < 0) {
    HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
    i1 = i7 + 12 | 0;
    HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    HEAPF32[i7 + 24 >> 2] = Math_fround(inf);
    HEAP32[i7 + 28 >> 2] = 0;
    HEAP32[i7 + 32 >> 2] = 0;
    i1 = 0;
   } else {
    f14 = Math_fround(HEAPF32[i10 >> 2]);
    f17 = Math_fround(f14 * Math_fround(HEAPF32[i3 >> 2]));
    f19 = Math_fround(f14 * Math_fround(HEAPF32[i3 + 4 >> 2]));
    f18 = Math_fround(f14 * Math_fround(HEAPF32[i3 + 8 >> 2]));
    f14 = Math_fround(Math_fround(1.0) - f14);
    f16 = Math_fround(f14 * Math_fround(HEAPF32[i5 >> 2]));
    f15 = Math_fround(f14 * Math_fround(HEAPF32[i5 + 4 >> 2]));
    f15 = Math_fround(f19 + f15);
    f14 = Math_fround(f18 + Math_fround(f14 * Math_fround(HEAPF32[i5 + 8 >> 2])));
    HEAPF32[i11 >> 2] = Math_fround(f17 + f16);
    i1 = i11 + 4 | 0;
    HEAPF32[i1 >> 2] = f15;
    HEAPF32[i11 + 8 >> 2] = f14;
    i5 = i10 + 16 | 0;
    if ((__ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i11, i12) | 0) >= 0) HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
    __ZNK15HeightMeshQuery17SetPositionHeightEPf(HEAP32[i6 + 116 >> 2] | 0, i11) | 0;
    i1 = Math_fround(HEAPF32[i10 >> 2]) < Math_fround(1.0);
    HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    i12 = HEAP32[i10 + 8 >> 2] | 0;
    HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAPF32[i7 + 16 >> 2] = Math_fround(0.0);
    HEAP32[i7 + 20 >> 2] = i12;
    f17 = Math_fround(HEAPF32[i7 >> 2]);
    f17 = Math_fround(f17 - Math_fround(HEAPF32[i9 >> 2]));
    f18 = Math_fround(HEAPF32[i7 + 4 >> 2]);
    f18 = Math_fround(f18 - Math_fround(HEAPF32[i9 + 4 >> 2]));
    f19 = Math_fround(HEAPF32[i7 + 8 >> 2]);
    f19 = Math_fround(f19 - Math_fround(HEAPF32[i9 + 8 >> 2]));
    HEAPF32[i7 + 24 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19))));
    i12 = i10 + 24 | 0;
    HEAP32[i7 + 28 >> 2] = __ZNK9dtNavMesh12getPolyFlagsEy(HEAP32[i6 + 108 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
    HEAP32[i7 + 32 >> 2] = i1 & 1;
   }
   i12 = i1;
   STACKTOP = i13;
   return i12 | 0;
  }
 };
 HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 i12 = i7 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i7 + 24 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 i12 = 0;
 STACKTOP = i13;
 return i12 | 0;
}

function runPostSets70() {
 HEAP32[gb + 77344 >> 2] = fb + 865;
 HEAP32[gb + 77348 >> 2] = fb + 866;
 HEAP32[gb + 77352 >> 2] = fb + 1;
 HEAP32[gb + 77356 >> 2] = fb + 1;
 HEAP32[gb + 77368 >> 2] = fb + 867;
 HEAP32[gb + 77372 >> 2] = fb + 868;
 HEAP32[gb + 77376 >> 2] = fb + 180;
 HEAP32[gb + 77380 >> 2] = fb + 869;
 HEAP32[gb + 77384 >> 2] = fb + 703;
 HEAP32[gb + 77388 >> 2] = fb + 870;
 HEAP32[gb + 77392 >> 2] = fb + 181;
 HEAP32[gb + 77404 >> 2] = fb + 871;
 HEAP32[gb + 77408 >> 2] = fb + 872;
 HEAP32[gb + 77412 >> 2] = fb + 182;
 HEAP32[gb + 77416 >> 2] = fb + 873;
 HEAP32[gb + 77420 >> 2] = fb + 704;
 HEAP32[gb + 77424 >> 2] = fb + 874;
 HEAP32[gb + 77428 >> 2] = fb + 183;
 HEAP32[gb + 77440 >> 2] = fb + 875;
 HEAP32[gb + 77444 >> 2] = fb + 876;
 HEAP32[gb + 77448 >> 2] = fb + 184;
 HEAP32[gb + 77452 >> 2] = fb + 877;
 HEAP32[gb + 77456 >> 2] = fb + 705;
 HEAP32[gb + 77460 >> 2] = fb + 878;
 HEAP32[gb + 77464 >> 2] = fb + 185;
 HEAP32[gb + 77480 >> 2] = fb + 879;
 HEAP32[gb + 77484 >> 2] = fb + 880;
 HEAP32[gb + 77500 >> 2] = fb + 881;
 HEAP32[gb + 77504 >> 2] = fb + 882;
 HEAP32[gb + 77520 >> 2] = fb + 883;
 HEAP32[gb + 77524 >> 2] = fb + 884;
 HEAP32[gb + 77540 >> 2] = fb + 885;
 HEAP32[gb + 77544 >> 2] = fb + 886;
 HEAP32[gb + 77556 >> 2] = fb + 887;
 HEAP32[gb + 77560 >> 2] = fb + 888;
 HEAP32[gb + 77564 >> 2] = fb + 706;
 HEAP32[gb + 77568 >> 2] = fb + 96;
 HEAP32[gb + 77572 >> 2] = fb + 27;
 HEAP32[gb + 77576 >> 2] = fb + 54;
 HEAP32[gb + 77580 >> 2] = fb + 400;
 HEAP32[gb + 77584 >> 2] = fb + 401;
 HEAP32[gb + 77588 >> 2] = fb + 97;
 HEAP32[gb + 77592 >> 2] = fb + 402;
 HEAP32[gb + 77596 >> 2] = fb + 403;
 HEAP32[gb + 77600 >> 2] = fb + 186;
 HEAP32[gb + 77604 >> 2] = fb + 98;
 HEAP32[gb + 77608 >> 2] = fb + 187;
 HEAP32[gb + 77612 >> 2] = (HEAP32[gb + 77612 >> 2] | 0) + (gb + 77508 | 0);
 HEAP32[gb + 77616 >> 2] = (HEAP32[gb + 77616 >> 2] | 0) + (gb + 77468 | 0);
 HEAP32[gb + 77620 >> 2] = (HEAP32[gb + 77620 >> 2] | 0) + (gb + 77468 | 0);
 HEAP32[gb + 77624 >> 2] = (HEAP32[gb + 77624 >> 2] | 0) + (gb + 77508 | 0);
 HEAP32[gb + 77636 >> 2] = fb + 889;
 HEAP32[gb + 77640 >> 2] = fb + 890;
 HEAP32[gb + 77644 >> 2] = fb + 277;
 HEAP32[gb + 77648 >> 2] = fb + 278;
 HEAP32[gb + 77652 >> 2] = fb + 279;
 HEAP32[gb + 77656 >> 2] = fb + 151;
 HEAP32[gb + 77660 >> 2] = fb + 260;
 HEAP32[gb + 77664 >> 2] = fb + 261;
 HEAP32[gb + 77668 >> 2] = fb + 2;
 HEAP32[gb + 77672 >> 2] = fb + 707;
 HEAP32[gb + 77676 >> 2] = fb + 280;
 HEAP32[gb + 77680 >> 2] = fb + 188;
 HEAP32[gb + 77684 >> 2] = fb + 189;
 HEAP32[gb + 77688 >> 2] = fb + 190;
 HEAP32[gb + 77692 >> 2] = fb + 191;
 HEAP32[gb + 77696 >> 2] = fb + 708;
 HEAP32[gb + 77700 >> 2] = fb + 709;
 HEAP32[gb + 77704 >> 2] = fb + 710;
 HEAP32[gb + 77708 >> 2] = fb + 78;
 HEAP32[gb + 77712 >> 2] = fb + 263;
 HEAP32[gb + 77716 >> 2] = fb + 711;
 HEAP32[gb + 77720 >> 2] = fb + 404;
 HEAP32[gb + 77724 >> 2] = fb + 712;
 HEAP32[gb + 77728 >> 2] = fb + 713;
 HEAP32[gb + 77732 >> 2] = fb + 714;
 HEAP32[gb + 77736 >> 2] = fb + 405;
 HEAP32[gb + 77740 >> 2] = fb + 14;
 HEAP32[gb + 77744 >> 2] = fb + 715;
 HEAP32[gb + 77748 >> 2] = fb + 716;
 HEAP32[gb + 77752 >> 2] = fb + 717;
 HEAP32[gb + 77756 >> 2] = fb + 281;
 HEAP32[gb + 77760 >> 2] = fb + 406;
 HEAP32[gb + 77764 >> 2] = fb + 407;
 HEAP32[gb + 77768 >> 2] = fb + 408;
 HEAP32[gb + 77772 >> 2] = fb + 409;
 HEAP32[gb + 77776 >> 2] = fb + 410;
 HEAP32[gb + 77780 >> 2] = fb + 6;
 HEAP32[gb + 77784 >> 2] = fb + 718;
 HEAP32[gb + 77788 >> 2] = fb + 719;
 HEAP32[gb + 77792 >> 2] = fb + 720;
 HEAP32[gb + 77796 >> 2] = fb + 721;
 HEAP32[gb + 77800 >> 2] = fb + 891;
 HEAP32[gb + 77804 >> 2] = fb + 411;
 HEAP32[gb + 77808 >> 2] = fb + 722;
 HEAP32[gb + 77812 >> 2] = fb + 55;
 HEAP32[gb + 77816 >> 2] = fb + 2;
 HEAP32[gb + 77820 >> 2] = fb + 723;
 HEAP32[gb + 77824 >> 2] = fb + 267;
 HEAP32[gb + 77828 >> 2] = fb + 49;
 runPostSets71();
}

function __ZN21EnlightenSceneMapping6AppendEiRKS_(i14, i3, i4) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i13 = i14 + 12 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i6 = i14 + 20 | 0;
 i5 = i14 + 32 | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 i9 = i14 + 80 | 0;
 i7 = i14 + 92 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i11 = i14 + 100 | 0;
 i10 = i14 + 112 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i17 = i4 + 32 | 0;
 __Z16AppendSceneRangeiiiR13dynamic_arrayI10SceneRangeLj4EE(i3, i12, HEAP32[i17 >> 2] | 0, i14 + 60 | 0);
 i3 = HEAP32[i4 >> 2] | 0;
 __ZN13dynamic_arrayI28EnlightenRendererInformationLj8EE6insertEPS0_PKS0_S4_(i14, (HEAP32[i14 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 40 | 0) | 0, i3, i3 + ((HEAP32[i4 + 12 >> 2] | 0) * 40 | 0) | 0) | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 __ZN13dynamic_arrayI26EnlightenSystemInformationLj8EE6insertEPS0_PKS0_S4_(i6, (HEAP32[i6 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 56 | 0) | 0, i3, i3 + ((HEAP32[i17 >> 2] | 0) * 56 | 0) | 0) | 0;
 i3 = HEAP32[i4 + 80 >> 2] | 0;
 __ZN13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EE6insertEPS0_PKS0_S4_(i9, (HEAP32[i9 >> 2] | 0) + (HEAP32[i7 >> 2] << 5) | 0, i3, i3 + (HEAP32[i4 + 92 >> 2] << 5) | 0) | 0;
 i3 = HEAP32[i4 + 100 >> 2] | 0;
 __ZN13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EE6insertEPS0_PKS0_S4_(i11, (HEAP32[i11 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 12 | 0) | 0, i3, i3 + ((HEAP32[i4 + 112 >> 2] | 0) * 12 | 0) | 0) | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 if ((i8 | 0) != (i13 | 0)) {
  i4 = HEAP32[i14 >> 2] | 0;
  i3 = i8;
  do {
   i17 = i4 + (i3 * 40 | 0) + 20 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i12;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i13 | 0));
 }
 i5 = HEAP32[i5 >> 2] | 0;
 if ((i12 | 0) != (i5 | 0)) {
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i12;
  do {
   i17 = i4 + (i3 * 56 | 0) | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i8;
   i17 = i4 + (i3 * 56 | 0) + 8 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 }
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i4 | 0)) {
  i3 = HEAP32[i9 >> 2] | 0;
  do {
   i17 = i3 + (i2 << 5) + 24 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i12;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 i3 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = HEAP32[i11 >> 2] | 0;
  do {
   i17 = i2 + (i1 * 12 | 0) | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i12;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i14 + 124 >> 2] | 0;
 i6 = i14 + 128 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i1 = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 if (!i13) {
  i17 = i14 + 120 | 0;
  __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i17);
  STACKTOP = i16;
  return;
 }
 i3 = i15 + 4 | 0;
 i4 = i14 + 132 | 0;
 i5 = i14 + 124 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i15 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 * 40 | 0) >> 2];
  HEAP32[i3 >> 2] = i2;
  if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i15); else {
   i11 = i15;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i17 = i1;
   HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i17 + 4 >> 2] = i12;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 8;
  }
  i1 = i2 + 1 | 0;
  if ((i1 | 0) == (i13 | 0)) break;
  i2 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i17 = i14 + 120 | 0;
 __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di(i1, i5, f12, i3, f11, i7, f13, f14, i15, i16, i2, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 f12 = Math_fround(f12);
 i3 = i3 | 0;
 f11 = Math_fround(f11);
 i7 = i7 | 0;
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 i15 = i15 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i4 = 0, f8 = f0, f9 = f0, f10 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 8 | 0;
 i4 = i23;
 i1 = i23 + 424 | 0;
 i21 = i23 + 404 | 0;
 if ((HEAP16[gb + 1457656 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457656 | 0, i20);
  i22 = gb + 1457656 | 0;
 } else i22 = 0;
 if (f12 <= Math_fround(.0000999999974) | (i6 | 0) == 0) i1 = 0; else {
  i17 = f11 == Math_fround(inf);
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(f10 * f10);
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(f8 + Math_fround(f9 * f9));
  if (!(f8 == Math_fround(0.0))) f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
  f10 = Math_fround(f10 * f8);
  f9 = Math_fround(f9 * f8);
  f11 = i17 ? Math_fround(1.0e5) : f11;
  f10 = Math_fround(f11 * f10);
  f11 = Math_fround(f11 * f9);
  f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f10);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i5 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f11;
  i24 = gb + 64016 | 0;
  i19 = HEAP32[i24 + 4 >> 2] | 0;
  i18 = i4;
  HEAP32[i18 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i18 + 4 >> 2] = i19;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 12 >> 2] = 0;
  i18 = i21 + 16 | 0;
  HEAP32[i18 >> 2] = 0;
  i19 = i21 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i20, i4);
  i24 = i20;
  i3 = HEAP32[i24 + 4 >> 2] | 0;
  i4 = i19;
  HEAP32[i4 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i20, i5, i1, Math_fround(0.0), i7, f13, f14, i15, i16, i21);
  HEAP32[i20 >> 2] = gb + 156100 + 8;
  HEAP32[i20 + 372 >> 2] = gb + 151824 + 8;
  i1 = i20 + 376 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i20 + 392 >> 2] = f12;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i20, 0) | 0;
  i1 = (i1 | 0) > (i6 | 0) ? i6 : i1;
  if ((i1 | 0) > 0) {
   i7 = HEAP32[i21 >> 2] | 0;
   if (i17) {
    i3 = 0;
    do {
     i4 = i7 + (i3 * 36 | 0) + 28 | 0;
     HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(1.0e5));
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else {
    i3 = 0;
    do {
     i4 = i2;
     i2 = i2 + 36 | 0;
     i5 = i7 + (i3 * 36 | 0) | 0;
     i6 = i4 + 36 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
      i4 = i4 + 4 | 0;
      i5 = i5 + 4 | 0;
     } while ((i4 | 0) < (i6 | 0));
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (i1 | 0));
   }
  }
  HEAP32[i20 >> 2] = gb + 156124 + 8;
  i2 = i20 + 340 | 0;
  if ((HEAP32[i20 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i20 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i20 + 268 | 0);
  if ((HEAP32[i18 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i19);
   HEAP32[i21 >> 2] = 0;
  }
 }
 if (!i22) {
  STACKTOP = i23;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i22);
 STACKTOP = i23;
 return i1 | 0;
}

function _UNITY_png_create_png_struct(i8, i4, i5, i6, i1, i2, i3) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 912 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = 4;
 i12 = _malloc(40) | 0;
 HEAP32[i12 >> 2] = 0;
 i11 = i13 + 156 | 0;
 i9 = i13;
 _memset(i11 | 0, 0, 756) | 0;
 HEAP32[i11 + 624 >> 2] = 2147483647;
 HEAP32[i11 + 628 >> 2] = 2147483647;
 HEAP32[i11 + 632 >> 2] = 0;
 HEAP32[i11 + 636 >> 2] = 0;
 __THREW__ = 0;
 invoke_viiii(fb + 186 | 0, i11 | 0, i1 | 0, i2 | 0, i3 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
  i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i12 | 0, i10 | 0) | 0;
  if (!i2) _longjmp(i1 | 0, threwValue | 0);
  setTempRet0(threwValue | 0);
 } else i2 = -1;
 i1 = getTempRet0() | 0;
 if ((i2 | 0) != 1) {
  __THREW__ = 0;
  invoke_viiii(fb + 187 | 0, i11 | 0, i4 | 0, i5 | 0, i6 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i12 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i12 = _saveSetjmp(i9, 1, i12 | 0, i10 | 0) | 0;
   i10 = getTempRet0() | 0;
   __THREW__ = 0;
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i12 | 0, i10 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) != 1) i1 = 0;
  }
 }
 while (1) {
  if (i1 | 0) {
   i1 = 0;
   i2 = 30;
   break;
  }
  i5 = i11 + 160 | 0;
  HEAP32[i5 >> 2] = i9;
  i6 = i11 + 164 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i11 + 156 | 0;
  HEAP32[i7 >> 2] = fb + 2356;
  i4 = (i8 | 0) == 0;
  i3 = i11 + 208 | 0;
  if (i4) {
   i1 = HEAP32[i3 >> 2] | 131072;
   HEAP32[i3 >> 2] = i1;
  } else {
   if ((HEAP8[i8 >> 0] | 0) != 49) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 131072;
   if ((HEAP8[i8 + 1 >> 0] | 0) != 46) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 131072;
   if ((HEAP8[i8 + 2 >> 0] | 0) != 54) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 131072;
   if ((HEAP8[i8 + 3 >> 0] | 0) != 46) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 131072;
   if ((HEAP8[i8 + 4 >> 0] | 0) != 49) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 131072;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP8[i8 + 5 >> 0] | 0) != 48) {
    i1 = i1 | 131072;
    HEAP32[i3 >> 2] = i1;
   }
   i2 = i1 | 131072;
   if (HEAP8[i8 + 6 >> 0] | 0) {
    HEAP32[i3 >> 2] = i2;
    i1 = i2;
   }
  }
  if (i1 & 131072 | 0) {
   if (i4) {
    i1 = 0;
    i2 = 30;
    break;
   }
   if ((HEAP8[i8 >> 0] | 0) != 49) {
    i1 = 0;
    i2 = 30;
    break;
   }
   if ((HEAP8[i8 + 2 >> 0] | 0) != 54) {
    i1 = 0;
    i2 = 30;
    break;
   }
   if ((HEAP8[i8 + 3 >> 0] | 0) != 46) {
    i1 = 0;
    i2 = 30;
    break;
   }
  }
  __THREW__ = 0;
  i3 = invoke_iii(fb + 498 | 0, i11 | 0, 756) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i12 | 0, i10 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) {
   i2 = 28;
   break;
  }
 }
 if ((i2 | 0) == 28) {
  if (!i3) {
   i11 = 0;
   _free(i12 | 0);
   STACKTOP = i13;
   return i11 | 0;
  }
  HEAP32[i11 + 252 >> 2] = fb + 331;
  HEAP32[i11 + 256 >> 2] = fb + 2357;
  HEAP32[i11 + 260 >> 2] = i3;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  _memcpy(i3 | 0, i11 | 0, 756) | 0;
  i11 = i3;
  _free(i12 | 0);
  STACKTOP = i13;
  return i11 | 0;
 } else if ((i2 | 0) == 30) {
  _free(i12 | 0);
  STACKTOP = i13;
  return i1 | 0;
 }
 return 0;
}

function runPostSets4() {
 HEAP32[gb + 26460 >> 2] = fb + 34;
 HEAP32[gb + 26464 >> 2] = fb + 41;
 HEAP32[gb + 26468 >> 2] = fb + 42;
 HEAP32[gb + 26472 >> 2] = fb + 43;
 HEAP32[gb + 26476 >> 2] = fb + 44;
 HEAP32[gb + 26480 >> 2] = fb + 45;
 HEAP32[gb + 26484 >> 2] = fb + 46;
 HEAP32[gb + 26488 >> 2] = fb + 36;
 HEAP32[gb + 26500 >> 2] = (HEAP32[gb + 26500 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 26504 >> 2] = (HEAP32[gb + 26504 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 26540 >> 2] = (HEAP32[gb + 26540 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 26544 >> 2] = (HEAP32[gb + 26544 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 26580 >> 2] = (HEAP32[gb + 26580 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 26584 >> 2] = (HEAP32[gb + 26584 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 26620 >> 2] = fb + 41;
 HEAP32[gb + 26624 >> 2] = fb + 42;
 HEAP32[gb + 26628 >> 2] = fb + 1;
 HEAP32[gb + 26632 >> 2] = fb + 1;
 HEAP32[gb + 26636 >> 2] = fb + 1;
 HEAP32[gb + 26640 >> 2] = fb + 21;
 HEAP32[gb + 26644 >> 2] = fb + 1;
 HEAP32[gb + 26648 >> 2] = fb + 1;
 HEAP32[gb + 26652 >> 2] = fb + 64;
 HEAP32[gb + 26656 >> 2] = fb + 65;
 HEAP32[gb + 26660 >> 2] = fb + 66;
 HEAP32[gb + 26664 >> 2] = fb + 67;
 HEAP32[gb + 26668 >> 2] = fb + 68;
 HEAP32[gb + 26672 >> 2] = fb + 69;
 HEAP32[gb + 26676 >> 2] = fb + 70;
 HEAP32[gb + 26680 >> 2] = fb + 6;
 HEAP32[gb + 26684 >> 2] = fb + 7;
 HEAP32[gb + 26688 >> 2] = fb + 47;
 HEAP32[gb + 26692 >> 2] = fb + 43;
 HEAP32[gb + 26696 >> 2] = fb + 48;
 HEAP32[gb + 26700 >> 2] = fb + 1;
 HEAP32[gb + 26704 >> 2] = fb + 1;
 HEAP32[gb + 26708 >> 2] = fb + 22;
 HEAP32[gb + 26712 >> 2] = fb + 49;
 HEAP32[gb + 26716 >> 2] = fb + 71;
 HEAP32[gb + 26728 >> 2] = fb + 44;
 HEAP32[gb + 26732 >> 2] = fb + 45;
 HEAP32[gb + 26736 >> 2] = fb + 11;
 HEAP32[gb + 26740 >> 2] = fb + 4;
 HEAP32[gb + 26744 >> 2] = fb + 50;
 HEAP32[gb + 26748 >> 2] = fb + 23;
 HEAP32[gb + 26752 >> 2] = fb + 24;
 HEAP32[gb + 26756 >> 2] = fb + 25;
 HEAP32[gb + 26760 >> 2] = fb + 64;
 HEAP32[gb + 26764 >> 2] = fb + 72;
 HEAP32[gb + 26768 >> 2] = fb + 73;
 HEAP32[gb + 26772 >> 2] = fb + 74;
 HEAP32[gb + 26776 >> 2] = fb + 68;
 HEAP32[gb + 26780 >> 2] = fb + 75;
 HEAP32[gb + 26784 >> 2] = fb + 70;
 HEAP32[gb + 26788 >> 2] = fb + 6;
 HEAP32[gb + 26792 >> 2] = fb + 7;
 HEAP32[gb + 26796 >> 2] = fb + 47;
 HEAP32[gb + 26800 >> 2] = fb + 46;
 HEAP32[gb + 26804 >> 2] = fb + 51;
 HEAP32[gb + 26808 >> 2] = fb + 26;
 HEAP32[gb + 26812 >> 2] = fb + 27;
 HEAP32[gb + 26816 >> 2] = fb + 28;
 HEAP32[gb + 26820 >> 2] = fb + 49;
 HEAP32[gb + 26824 >> 2] = fb + 71;
 HEAP32[gb + 26836 >> 2] = fb + 47;
 HEAP32[gb + 26840 >> 2] = fb + 48;
 HEAP32[gb + 26844 >> 2] = fb + 12;
 HEAP32[gb + 26848 >> 2] = fb + 5;
 HEAP32[gb + 26852 >> 2] = fb + 52;
 HEAP32[gb + 26856 >> 2] = fb + 29;
 HEAP32[gb + 26860 >> 2] = fb + 30;
 HEAP32[gb + 26864 >> 2] = fb + 31;
 HEAP32[gb + 26868 >> 2] = fb + 64;
 HEAP32[gb + 26872 >> 2] = fb + 76;
 HEAP32[gb + 26876 >> 2] = fb + 66;
 HEAP32[gb + 26880 >> 2] = fb + 67;
 HEAP32[gb + 26884 >> 2] = fb + 68;
 HEAP32[gb + 26888 >> 2] = fb + 69;
 HEAP32[gb + 26892 >> 2] = fb + 70;
 HEAP32[gb + 26896 >> 2] = fb + 6;
 HEAP32[gb + 26900 >> 2] = fb + 7;
 HEAP32[gb + 26904 >> 2] = fb + 47;
 HEAP32[gb + 26908 >> 2] = fb + 43;
 HEAP32[gb + 26912 >> 2] = fb + 48;
 HEAP32[gb + 26916 >> 2] = fb + 32;
 HEAP32[gb + 26920 >> 2] = fb + 33;
 HEAP32[gb + 26924 >> 2] = fb + 34;
 HEAP32[gb + 26928 >> 2] = fb + 49;
 HEAP32[gb + 26932 >> 2] = fb + 71;
 HEAP32[gb + 26944 >> 2] = fb + 49;
 HEAP32[gb + 26948 >> 2] = fb + 50;
 HEAP32[gb + 26952 >> 2] = fb + 13;
 HEAP32[gb + 26956 >> 2] = fb + 6;
 HEAP32[gb + 26960 >> 2] = fb + 53;
 HEAP32[gb + 26964 >> 2] = fb + 35;
 HEAP32[gb + 26968 >> 2] = fb + 36;
 HEAP32[gb + 26972 >> 2] = fb + 37;
 HEAP32[gb + 26976 >> 2] = fb + 64;
 HEAP32[gb + 26980 >> 2] = fb + 65;
 HEAP32[gb + 26984 >> 2] = fb + 66;
 runPostSets5();
}

function __ZN5physx15PxSerialization8completeERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_b(i17, i21, i18, i19) {
 i17 = i17 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i23 + 24 | 0;
 i20 = i23 + 8 | 0;
 i10 = i23 + 4 | 0;
 i22 = i23;
 i2 = __Z18PxCreateCollectionv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i17 | 0);
 i12 = i16 + 4 | 0;
 i13 = i16 + 8 | 0;
 i14 = i16 + 12 | 0;
 i15 = i20 + 4 | 0;
 i11 = i20 + 8 | 0;
 i1 = __Z18PxCreateCollectionv() | 0;
 while (1) {
  HEAP32[i16 >> 2] = gb + 120060 + 8;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i17;
  HEAP32[i14 >> 2] = i18;
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) {
   i7 = 0;
   do {
    i3 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i7 | 0) | 0;
    i9 = mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, HEAP16[i3 + 4 >> 1] | 0) | 0;
    mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i3 | 0, i16 | 0);
    if (i19) if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, gb + 833471 | 0) | 0) {
     i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i20 >> 2] = 0;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i20, i5, i10);
     i5 = HEAP32[i20 >> 2] | 0;
     i6 = HEAP32[i15 >> 2] | 0;
     mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i5 | 0, i6 | 0, 0) | 0;
     if (i6 | 0) {
      i4 = 0;
      do {
       i3 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
       i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0, i3 | 0, i22 | 0) | 0;
       if (!(HEAP32[i22 >> 2] | 0)) {
        i9 = mftCall_iii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, HEAP16[i3 + 4 >> 1] | 0) | 0;
        mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i3 | 0, i16 | 0);
        if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0) | 0)) mftCall_viiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 0, 0);
       }
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i6 | 0));
     }
     i9 = HEAP32[i11 >> 2] | 0;
     if (!((i5 | 0) == 0 | ((i9 | 0) < 0 | (i9 & 2147483647 | 0) == 0))) {
      i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i5 | 0);
     }
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) >>> 0);
  }
  mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i1 | 0);
  i3 = HEAP32[i2 + 64 >> 2] | 0;
  if (i3 | 0) {
   i9 = i2 + 80 | 0;
   if (HEAP32[i9 >> 2] | 0) {
    _memset(HEAP32[i2 + 56 >> 2] | 0, -1, i3 << 2 | 0) | 0;
    i8 = i2 + 60 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i7 = i4 + -1 | 0;
    i6 = i2 + 52 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (i7) {
     i5 = 0;
     while (1) {
      i4 = i5 + 1 | 0;
      i3 = HEAP32[i6 >> 2] | 0;
      HEAP32[i3 + (i5 << 2) >> 2] = i4;
      if ((i4 | 0) == (i7 | 0)) break; else i5 = i4;
     }
     i4 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i3 + (i4 + -1 << 2) >> 2] = -1;
    HEAP32[i2 + 72 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
   }
  }
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0)) break; else {
   i9 = i1;
   i1 = i2;
   i2 = i9;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0);
 STACKTOP = i23;
 return;
}

function runPostSets123() {
 HEAP32[gb + 107404 >> 2] = fb + 1;
 HEAP32[gb + 107408 >> 2] = fb + 1;
 HEAP32[gb + 107412 >> 2] = fb + 1;
 HEAP32[gb + 107416 >> 2] = fb + 1;
 HEAP32[gb + 107428 >> 2] = fb + 1664;
 HEAP32[gb + 107432 >> 2] = fb + 842;
 HEAP32[gb + 107436 >> 2] = fb + 456;
 HEAP32[gb + 107440 >> 2] = fb + 1665;
 HEAP32[gb + 107444 >> 2] = fb + 1666;
 HEAP32[gb + 107448 >> 2] = fb + 346;
 HEAP32[gb + 107452 >> 2] = fb + 843;
 HEAP32[gb + 107456 >> 2] = fb + 844;
 HEAP32[gb + 107460 >> 2] = fb + 845;
 HEAP32[gb + 107464 >> 2] = fb + 846;
 HEAP32[gb + 107468 >> 2] = fb + 847;
 HEAP32[gb + 107472 >> 2] = fb + 848;
 HEAP32[gb + 107476 >> 2] = fb + 347;
 HEAP32[gb + 107480 >> 2] = fb + 1173;
 HEAP32[gb + 107484 >> 2] = fb + 849;
 HEAP32[gb + 107488 >> 2] = fb + 1667;
 HEAP32[gb + 107492 >> 2] = fb + 1174;
 HEAP32[gb + 107496 >> 2] = fb + 1175;
 HEAP32[gb + 107508 >> 2] = fb + 1668;
 HEAP32[gb + 107512 >> 2] = fb + 1669;
 HEAP32[gb + 107516 >> 2] = fb + 1670;
 HEAP32[gb + 107528 >> 2] = fb + 175;
 HEAP32[gb + 107532 >> 2] = fb + 259;
 HEAP32[gb + 107536 >> 2] = fb + 1176;
 HEAP32[gb + 107540 >> 2] = fb + 260;
 HEAP32[gb + 107544 >> 2] = fb + 4;
 HEAP32[gb + 107548 >> 2] = fb + 5;
 HEAP32[gb + 107552 >> 2] = fb + 1671;
 HEAP32[gb + 107556 >> 2] = fb + 1672;
 HEAP32[gb + 107560 >> 2] = fb + 1177;
 HEAP32[gb + 107564 >> 2] = fb + 1673;
 HEAP32[gb + 107568 >> 2] = fb + 1674;
 HEAP32[gb + 107572 >> 2] = fb + 1675;
 HEAP32[gb + 107576 >> 2] = fb + 1676;
 HEAP32[gb + 107580 >> 2] = fb + 261;
 HEAP32[gb + 107592 >> 2] = fb + 102;
 HEAP32[gb + 107596 >> 2] = fb + 1296;
 HEAP32[gb + 107600 >> 2] = fb + 1677;
 HEAP32[gb + 107612 >> 2] = fb + 103;
 HEAP32[gb + 107616 >> 2] = fb + 1296;
 HEAP32[gb + 107620 >> 2] = fb + 1678;
 HEAP32[gb + 107632 >> 2] = fb + 1221;
 HEAP32[gb + 107636 >> 2] = fb + 1227;
 HEAP32[gb + 107640 >> 2] = fb + 1679;
 HEAP32[gb + 107644 >> 2] = fb + 1680;
 HEAP32[gb + 107648 >> 2] = fb + 258;
 HEAP32[gb + 107652 >> 2] = fb + 259;
 HEAP32[gb + 107656 >> 2] = fb + 546;
 HEAP32[gb + 107668 >> 2] = fb + 1681;
 HEAP32[gb + 107672 >> 2] = fb + 1682;
 HEAP32[gb + 107676 >> 2] = fb + 907;
 HEAP32[gb + 107680 >> 2] = fb + 547;
 HEAP32[gb + 107692 >> 2] = fb + 1426;
 HEAP32[gb + 107696 >> 2] = fb + 1683;
 HEAP32[gb + 107700 >> 2] = fb + 907;
 HEAP32[gb + 107704 >> 2] = fb + 742;
 HEAP32[gb + 107708 >> 2] = fb + 803;
 HEAP32[gb + 107720 >> 2] = fb + 1221;
 HEAP32[gb + 107724 >> 2] = fb + 1227;
 HEAP32[gb + 107728 >> 2] = fb + 1684;
 HEAP32[gb + 107732 >> 2] = fb + 1685;
 HEAP32[gb + 107736 >> 2] = fb + 258;
 HEAP32[gb + 107740 >> 2] = fb + 259;
 HEAP32[gb + 107752 >> 2] = fb + 1426;
 HEAP32[gb + 107756 >> 2] = fb + 1686;
 HEAP32[gb + 107760 >> 2] = fb + 907;
 HEAP32[gb + 107764 >> 2] = fb + 742;
 HEAP32[gb + 107768 >> 2] = fb + 743;
 HEAP32[gb + 107780 >> 2] = fb + 1221;
 HEAP32[gb + 107784 >> 2] = fb + 1227;
 HEAP32[gb + 107788 >> 2] = fb + 1687;
 HEAP32[gb + 107792 >> 2] = fb + 1688;
 HEAP32[gb + 107796 >> 2] = fb + 258;
 HEAP32[gb + 107800 >> 2] = fb + 259;
 HEAP32[gb + 109892 >> 2] = fb + 1689;
 HEAP32[gb + 109896 >> 2] = fb + 1690;
 HEAP32[gb + 109900 >> 2] = fb + 1178;
 HEAP32[gb + 109904 >> 2] = fb + 1179;
 HEAP32[gb + 109908 >> 2] = fb + 850;
 HEAP32[gb + 109912 >> 2] = fb + 1691;
 HEAP32[gb + 109924 >> 2] = fb + 851;
 HEAP32[gb + 109928 >> 2] = fb + 262;
 HEAP32[gb + 109932 >> 2] = fb + 1180;
 HEAP32[gb + 109936 >> 2] = fb + 1181;
 HEAP32[gb + 109940 >> 2] = fb + 852;
 HEAP32[gb + 109944 >> 2] = fb + 118;
 HEAP32[gb + 109948 >> 2] = fb + 149;
 HEAP32[gb + 109952 >> 2] = fb + 1182;
 HEAP32[gb + 109956 >> 2] = fb + 853;
 HEAP32[gb + 109960 >> 2] = fb + 90;
 HEAP32[gb + 109964 >> 2] = fb + 13;
 HEAP32[gb + 109968 >> 2] = fb + 97;
 HEAP32[gb + 109972 >> 2] = fb + 1692;
 HEAP32[gb + 109976 >> 2] = fb + 1183;
 HEAP32[gb + 109980 >> 2] = fb + 1693;
 HEAP32[gb + 109984 >> 2] = fb + 1694;
 runPostSets124();
}

function __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_(i16, i17, i14, i9, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i16, i17, i14, i1) | 0;
 i6 = i9 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i13 = i14 + 4 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 do if ((i7 | 0) == (i8 | 0)) {
  i3 = i9 + 8 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i4 = i14 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) {
   if ((i5 | 0) < (i2 | 0)) {
    i1 = i5;
    break;
   } else i1 = i15;
   return i1 | 0;
  }
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i2 = HEAP32[i14 + 12 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   if ((HEAP32[i9 >> 2] | 0) < (HEAP32[i14 >> 2] | 0)) {
    i2 = i5;
    i1 = i5;
    break;
   } else i1 = i15;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i2 >>> 0) {
    i2 = i5;
    i1 = i5;
    break;
   } else i1 = i15;
   return i1 | 0;
  }
 } else if ((i7 | 0) < (i8 | 0)) {
  i2 = i14 + 8 | 0;
  i1 = i9 + 8 | 0;
  i3 = i1;
  i4 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  break;
 } else {
  i17 = i15;
  return i17 | 0;
 } while (0);
 i10 = HEAP32[i14 >> 2] | 0;
 i11 = i14 + 12 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 >> 2] = i7;
 HEAP32[i4 >> 2] = i1;
 i1 = i9 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = i12;
 i1 = i15 + 1 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i12 = i17 + 4 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 do if ((i7 | 0) == (i8 | 0)) {
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = i17 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i2 | 0)) {
   if ((i6 | 0) < (i2 | 0)) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i17 + 12 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   if ((HEAP32[i14 >> 2] | 0) < (HEAP32[i17 >> 2] | 0)) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i2 >>> 0 < i3 >>> 0) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } else if ((i7 | 0) < (i8 | 0)) {
  i2 = i17 + 8 | 0;
  i5 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  break;
 } else {
  i17 = i1;
  return i17 | 0;
 } while (0);
 i6 = HEAP32[i17 >> 2] | 0;
 i10 = i17 + 12 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 >> 2] = i7;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 >> 2] = i6;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i11 >> 2] = i9;
 i1 = i15 + 2 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i8 = i16 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 do if ((i7 | 0) == (i9 | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  i3 = i16 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i6 | 0) != (i2 | 0)) {
   if ((i6 | 0) < (i2 | 0)) {
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i16 + 12 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0)) {
   if ((HEAP32[i17 >> 2] | 0) < (HEAP32[i16 >> 2] | 0)) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  } else {
   if (i2 >>> 0 < i4 >>> 0) {
    i2 = i6;
    i1 = i6;
    break;
   }
   return i1 | 0;
  }
 } else if ((i7 | 0) < (i9 | 0)) {
  i2 = i16 + 8 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  break;
 } else {
  i17 = i1;
  return i17 | 0;
 } while (0);
 i13 = HEAP32[i16 >> 2] | 0;
 i11 = i16 + 12 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i8 >> 2] = i7;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i17 >> 2] = i13;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i10 >> 2] = i14;
 i17 = i15 + 3 | 0;
 return i17 | 0;
}

function __ZNK32PlaneColliderCache_dense_hashmap4FindERK8Vector3fS2_RS0_S3_RiS4_f(i12, i1, i2, i19, i20, i21, i22, f3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i23;
 f6 = Math_fround(f3 * Math_fround(4.0));
 HEAP32[i4 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 >> 2]) / f3)));
 HEAP32[i4 + 4 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) / f6)));
 HEAP32[i4 + 8 >> 2] = ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f3)));
 i4 = __Z13MurmurHash64APKviy(i4, 12, 409413374, -559038737) | 0;
 i18 = getTempRet0() | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f24 = Math_fround(Math_abs(Math_fround(f6)));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(Math_abs(Math_fround(f7)));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f5)));
 do if (!(f24 >= f8) | !(f24 >= f3)) if (!(f8 >= f3)) {
  i1 = f5 > Math_fround(0.0);
  i1 = i1 ? 4 : 5;
  break;
 } else {
  i1 = f7 > Math_fround(0.0);
  i1 = i1 ? 2 : 3;
  break;
 } else i1 = !(f6 > Math_fround(0.0)) & 1; while (0);
 i13 = i1 ^ i4;
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 if ((HEAP32[i12 + 104 >> 2] | 0) == (i10 | 0)) {
  i2 = HEAP32[i12 + 96 >> 2] | 0;
  i1 = HEAP32[i12 + 100 >> 2] | 0;
  i4 = i2 + (i1 * 40 | 0) | 0;
 } else {
  i17 = HEAP32[i12 + 100 >> 2] | 0;
  i14 = i17 + -1 | 0;
  i1 = i14 & i18;
  i2 = HEAP32[i12 + 96 >> 2] | 0;
  i16 = i12 + 56 | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  i4 = i2 + (i1 * 40 | 0) | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  L11 : do if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i4 | 0)) i1 = -1; else {
   i11 = i12 + 16 | 0;
   if (!(HEAP8[i12 + 8 >> 0] | 0)) {
    i10 = 0;
    while (1) {
     if ((i13 | 0) == (i9 | 0) & (i18 | 0) == (i4 | 0)) break L11;
     i10 = i10 + 1 | 0;
     i1 = i10 + i1 & i14;
     i4 = i2 + (i1 * 40 | 0) | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i4 | 0)) {
      i1 = -1;
      break L11;
     }
    }
   }
   if (!i10) {
    i10 = 0;
    while (1) {
     if ((i13 | 0) == (i9 | 0) & (i18 | 0) == (i4 | 0)) break L11;
     i10 = i10 + 1 | 0;
     i1 = i10 + i1 & i14;
     i4 = i2 + (i1 * 40 | 0) | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i4 | 0)) {
      i1 = -1;
      break L11;
     }
    }
   }
   i12 = i11;
   i11 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = 0;
   while (1) {
    if (((i11 | 0) != (i9 | 0) | (i12 | 0) != (i4 | 0)) & ((i13 | 0) == (i9 | 0) & (i18 | 0) == (i4 | 0))) break L11;
    i10 = i10 + 1 | 0;
    i1 = i10 + i1 & i14;
    i4 = i2 + (i1 * 40 | 0) | 0;
    i9 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i15 | 0) == (i9 | 0) & (i16 | 0) == (i4 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i4 = (i1 | 0) == -1 ? i2 + (i17 * 40 | 0) | 0 : i2 + (i1 * 40 | 0) | 0;
  i1 = i17;
 }
 if ((i4 | 0) == (i2 + (i1 * 40 | 0) | 0)) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i18 = i4 + 8 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 i19 = i4 + 20 | 0;
 HEAP32[i20 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
 HEAP32[i21 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i22 >> 2] = HEAP32[i4 + 36 >> 2];
 i22 = 1;
 STACKTOP = i23;
 return i22 | 0;
}

function __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = i8 + 16 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 156 >> 2] | 0, i7 | 0, i4 | 0);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i1 = i8 + 32 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 172 >> 2] | 0, i7 | 0, i4 | 0);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP8[i8 + 57 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 168 >> 2] | 0, i4 | 0) | 0) & 1;
 i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i8 + 52 >> 2] = i1;
 HEAP8[i8 + 56 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0) | 0) & 1;
 i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i8 + 48 >> 2] = i1;
 i1 = i8 + 124 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 60 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 188 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i4 = i9 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i7 = i9 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 L7 : do if ((i1 | 0) < (i2 | 0)) {
  i5 = HEAP32[i9 + 68 >> 2] | 0;
  i6 = HEAP32[gb + 1110556 >> 2] | 0;
  i3 = i1;
  while (1) {
   if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i6 | 0)) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i2 | 0)) break L7;
  }
  if ((i3 | 0) > -1) {
   i1 = i8 + 252 | 0;
   i2 = (HEAP32[i9 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i9 + 88 >> 2] | 0) + (i3 << 2) >> 2] & 1048575) | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
 } while (0);
 if ((i1 | 0) >= (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = HEAP32[i9 + 68 >> 2] | 0;
 i4 = HEAP32[gb + 1110560 >> 2] | 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i10 = 17;
   break;
  }
 }
 if ((i10 | 0) == 17) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 i10 = i8 + 284 | 0;
 i9 = (HEAP32[i9 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i9 + 88 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc5Scene20finishBatchInsertionERNS0_19BatchInsertionStateE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 1 | 0;
 i13 = i14;
 i7 = HEAP32[i10 + 1216 >> 2] | 0;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 L1 : do if (i8 | 0) {
  i9 = i7 + 24 | 0;
  if (!(HEAP8[i9 >> 0] | 0)) i1 = i7 + 16 | 0; else {
   i1 = i7 + 16 | 0;
   __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i12, i13, 32);
  }
  i5 = Math_imul(HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  if ((i1 | 0) >= 0) {
   i6 = HEAP32[i7 + 12 >> 2] | 0;
   i2 = 0;
   i4 = i1;
   L8 : while (1) {
    while (1) {
     i1 = i2 + i4 >> 1;
     i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
     if (i3 >>> 0 <= i8 >>> 0 & (i3 + i5 | 0) >>> 0 > i8 >>> 0) break L8;
     if (i3 >>> 0 >= i8 >>> 0) break;
     if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else break L1;
    }
    i1 = i1 + -1 | 0;
    if ((i2 | 0) > (i1 | 0)) break L1; else i4 = i1;
   }
   i6 = i6 + (i1 * 12 | 0) + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i8;
   if (HEAP8[i9 >> 0] | 0) HEAP32[i7 + 8 >> 2] = i1;
   HEAP8[i9 >> 0] = 0;
  }
 } while (0);
 i7 = HEAP32[i10 + 1220 >> 2] | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 L20 : do if (i8 | 0) {
  i9 = i7 + 24 | 0;
  if (!(HEAP8[i9 >> 0] | 0)) i1 = i7 + 16 | 0; else {
   i1 = i7 + 16 | 0;
   __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i12, i13, 32);
  }
  i5 = Math_imul(HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  if ((i1 | 0) >= 0) {
   i6 = HEAP32[i7 + 12 >> 2] | 0;
   i2 = 0;
   i4 = i1;
   L27 : while (1) {
    while (1) {
     i1 = i2 + i4 >> 1;
     i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
     if (i3 >>> 0 <= i8 >>> 0 & (i3 + i5 | 0) >>> 0 > i8 >>> 0) break L27;
     if (i3 >>> 0 >= i8 >>> 0) break;
     if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else break L20;
    }
    i1 = i1 + -1 | 0;
    if ((i2 | 0) > (i1 | 0)) break L20; else i4 = i1;
   }
   i6 = i6 + (i1 * 12 | 0) + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i8;
   if (HEAP8[i9 >> 0] | 0) HEAP32[i7 + 8 >> 2] = i1;
   HEAP8[i9 >> 0] = 0;
  }
 } while (0);
 i9 = HEAP32[i10 + 1212 >> 2] | 0;
 i7 = HEAP32[i11 + 8 >> 2] | 0;
 if (!i7) {
  STACKTOP = i14;
  return;
 }
 i8 = i9 + 24 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) i1 = i9 + 16 | 0; else {
  i1 = i9 + 16 | 0;
  __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i9 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i12, i13, 32);
 }
 i5 = Math_imul(HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 if ((i1 | 0) < 0) {
  STACKTOP = i14;
  return;
 }
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i2 = 0;
 i4 = i1;
 L49 : while (1) {
  while (1) {
   i1 = i2 + i4 >> 1;
   i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
   if (i3 >>> 0 <= i7 >>> 0 & (i3 + i5 | 0) >>> 0 > i7 >>> 0) {
    i2 = 37;
    break L49;
   }
   if (i3 >>> 0 >= i7 >>> 0) break;
   if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else {
    i2 = 43;
    break L49;
   }
  }
  i1 = i1 + -1 | 0;
  if ((i2 | 0) > (i1 | 0)) {
   i2 = 43;
   break;
  } else i4 = i1;
 }
 if ((i2 | 0) == 37) {
  i13 = i6 + (i1 * 12 | 0) + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i7;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i9 + 8 >> 2] = i1;
  HEAP8[i8 >> 0] = 0;
  STACKTOP = i14;
  return;
 } else if ((i2 | 0) == 43) {
  STACKTOP = i14;
  return;
 }
}

function runPostSets124() {
 HEAP32[gb + 109988 >> 2] = fb + 3;
 HEAP32[gb + 109992 >> 2] = fb + 4;
 HEAP32[gb + 109996 >> 2] = fb + 4;
 HEAP32[gb + 110008 >> 2] = fb + 1695;
 HEAP32[gb + 110012 >> 2] = fb + 1184;
 HEAP32[gb + 110016 >> 2] = fb + 854;
 HEAP32[gb + 110020 >> 2] = fb + 855;
 HEAP32[gb + 110024 >> 2] = fb + 176;
 HEAP32[gb + 110028 >> 2] = fb + 177;
 HEAP32[gb + 110032 >> 2] = fb + 348;
 HEAP32[gb + 110036 >> 2] = fb + 104;
 HEAP32[gb + 110040 >> 2] = fb + 2;
 HEAP32[gb + 110044 >> 2] = fb + 178;
 HEAP32[gb + 110048 >> 2] = fb + 179;
 HEAP32[gb + 110052 >> 2] = fb + 1696;
 HEAP32[gb + 110056 >> 2] = fb + 1697;
 HEAP32[gb + 110068 >> 2] = fb + 1648;
 HEAP32[gb + 110072 >> 2] = fb + 829;
 HEAP32[gb + 110076 >> 2] = fb + 456;
 HEAP32[gb + 110080 >> 2] = fb + 1698;
 HEAP32[gb + 110084 >> 2] = fb + 1699;
 HEAP32[gb + 110088 >> 2] = fb + 343;
 HEAP32[gb + 110092 >> 2] = fb + 830;
 HEAP32[gb + 110096 >> 2] = fb + 831;
 HEAP32[gb + 110100 >> 2] = fb + 832;
 HEAP32[gb + 110104 >> 2] = fb + 833;
 HEAP32[gb + 110108 >> 2] = fb + 173;
 HEAP32[gb + 110112 >> 2] = fb + 834;
 HEAP32[gb + 110116 >> 2] = fb + 96;
 HEAP32[gb + 110120 >> 2] = fb + 1168;
 HEAP32[gb + 110124 >> 2] = fb + 1169;
 HEAP32[gb + 110128 >> 2] = fb + 1651;
 HEAP32[gb + 110132 >> 2] = fb + 1170;
 HEAP32[gb + 110144 >> 2] = fb + 1700;
 HEAP32[gb + 110148 >> 2] = fb + 1701;
 HEAP32[gb + 110152 >> 2] = fb + 1654;
 HEAP32[gb + 110172 >> 2] = fb + 1664;
 HEAP32[gb + 110176 >> 2] = fb + 842;
 HEAP32[gb + 110180 >> 2] = fb + 456;
 HEAP32[gb + 110184 >> 2] = fb + 1665;
 HEAP32[gb + 110188 >> 2] = fb + 1702;
 HEAP32[gb + 110192 >> 2] = fb + 346;
 HEAP32[gb + 110196 >> 2] = fb + 843;
 HEAP32[gb + 110200 >> 2] = fb + 844;
 HEAP32[gb + 110204 >> 2] = fb + 845;
 HEAP32[gb + 110208 >> 2] = fb + 846;
 HEAP32[gb + 110212 >> 2] = fb + 847;
 HEAP32[gb + 110216 >> 2] = fb + 848;
 HEAP32[gb + 110220 >> 2] = fb + 347;
 HEAP32[gb + 110224 >> 2] = fb + 1173;
 HEAP32[gb + 110228 >> 2] = fb + 849;
 HEAP32[gb + 110232 >> 2] = fb + 1667;
 HEAP32[gb + 110236 >> 2] = fb + 1174;
 HEAP32[gb + 110240 >> 2] = fb + 1175;
 HEAP32[gb + 110252 >> 2] = fb + 1703;
 HEAP32[gb + 110256 >> 2] = fb + 1704;
 HEAP32[gb + 110260 >> 2] = fb + 1670;
 HEAP32[gb + 110272 >> 2] = fb + 1705;
 HEAP32[gb + 110276 >> 2] = fb + 1706;
 HEAP32[gb + 110280 >> 2] = fb + 98;
 HEAP32[gb + 110460 >> 2] = fb + 1707;
 HEAP32[gb + 110464 >> 2] = fb + 856;
 HEAP32[gb + 110468 >> 2] = fb + 1185;
 HEAP32[gb + 110472 >> 2] = fb + 857;
 HEAP32[gb + 110476 >> 2] = fb + 858;
 HEAP32[gb + 110480 >> 2] = fb + 859;
 HEAP32[gb + 110484 >> 2] = fb + 860;
 HEAP32[gb + 110488 >> 2] = fb + 1186;
 HEAP32[gb + 110492 >> 2] = fb + 1708;
 HEAP32[gb + 110496 >> 2] = fb + 1709;
 HEAP32[gb + 110508 >> 2] = fb + 1121;
 HEAP32[gb + 110512 >> 2] = fb + 1710;
 HEAP32[gb + 110516 >> 2] = fb + 61;
 HEAP32[gb + 110520 >> 2] = fb + 1187;
 HEAP32[gb + 110524 >> 2] = fb + 1188;
 HEAP32[gb + 110528 >> 2] = fb + 1189;
 HEAP32[gb + 110540 >> 2] = fb + 99;
 HEAP32[gb + 110544 >> 2] = fb + 1190;
 HEAP32[gb + 110548 >> 2] = fb + 349;
 HEAP32[gb + 110552 >> 2] = fb + 100;
 HEAP32[gb + 110556 >> 2] = fb + 263;
 HEAP32[gb + 110560 >> 2] = fb + 1191;
 HEAP32[gb + 110564 >> 2] = fb + 1192;
 HEAP32[gb + 110568 >> 2] = fb + 861;
 HEAP32[gb + 110572 >> 2] = fb + 350;
 HEAP32[gb + 110576 >> 2] = fb + 105;
 HEAP32[gb + 110580 >> 2] = fb + 180;
 HEAP32[gb + 110584 >> 2] = fb + 862;
 HEAP32[gb + 110588 >> 2] = fb + 106;
 HEAP32[gb + 110592 >> 2] = fb + 351;
 HEAP32[gb + 110596 >> 2] = fb + 1711;
 HEAP32[gb + 110600 >> 2] = fb + 1712;
 HEAP32[gb + 110604 >> 2] = fb + 1713;
 HEAP32[gb + 110616 >> 2] = fb + 1193;
 HEAP32[gb + 110620 >> 2] = fb + 1714;
 HEAP32[gb + 110624 >> 2] = fb + 1715;
 HEAP32[gb + 110636 >> 2] = fb + 1716;
 HEAP32[gb + 110640 >> 2] = fb + 1717;
 HEAP32[gb + 110644 >> 2] = fb + 62;
 HEAP32[gb + 110648 >> 2] = fb + 1194;
 runPostSets125();
}

function __ZN17PersistentManagerC2Eii(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 HEAP32[i6 >> 2] = gb + 66904 + 8;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = i7;
 HEAP32[i6 + 100 >> 2] = 0;
 HEAP32[i6 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 108 >> 2] = 0;
 HEAP32[i6 + 96 >> 2] = i6 + 100;
 HEAP32[i6 + 120 >> 2] = 0;
 i7 = i6 + 124 | 0;
 HEAP8[i7 >> 0] = 0;
 i3 = i6 + 125 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i6 + 128 | 0;
 i5 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 i5 = i6 + 172 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i6 + 176 >> 2] = 0;
 HEAP32[i6 + 184 >> 2] = 16;
 HEAP32[i6 + 180 >> 2] = 6;
 HEAP8[i6 + 188 >> 0] = 0;
 HEAP32[gb + 1166040 >> 2] = i6;
 HEAP32[i6 + 92 >> 2] = i1;
 HEAP32[i6 + 80 >> 2] = i2;
 HEAP8[i6 + 115 >> 0] = 0;
 i2 = i6 + 84 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(40, gb + 63416 | 0, 16, gb + 466851 | 0, gb + 1576256 | 0, gb + 466878 | 0, 1885) | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i1;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = -1;
 __Z19pop_allocation_rootv();
 HEAP32[i6 + 56 >> 2] = i2;
 HEAP8[i3 >> 0] = 1;
 i2 = i6 + 148 | 0;
 HEAP32[i6 + 148 >> 2] = -1;
 i3 = i6 + 152 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = __Znwj(i3 * 20 | 0) | 0;
 HEAP32[i6 + 168 >> 2] = i1;
 i3 = i1 + (i3 * 20 | 0) | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i5 = i6 + 116 | 0;
  __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E14squash_deletedEv(i5);
  HEAP8[i7 >> 0] = 1;
  i7 = i6 + 128 | 0;
  HEAP32[i7 >> 2] = -2;
  i7 = i6 + 132 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  __Z23InitializeStdConvertersv();
  i7 = i6 + 192 | 0;
  HEAP8[i7 >> 0] = 0;
  STACKTOP = i8;
  return;
 }
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i5 = i6 + 116 | 0;
 __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E14squash_deletedEv(i5);
 HEAP8[i7 >> 0] = 1;
 i7 = i6 + 128 | 0;
 HEAP32[i7 >> 2] = -2;
 i7 = i6 + 132 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __Z23InitializeStdConvertersv();
 i7 = i6 + 192 | 0;
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 96 | 0;
 i11 = i15 + 84 | 0;
 i3 = i15 + 80 | 0;
 i4 = i15 + 72 | 0;
 i13 = i15;
 i14 = i15 + 108 | 0;
 HEAP8[i13 >> 0] = 15;
 HEAP8[i13 + 1 >> 0] = 1;
 HEAP8[i13 + 2 >> 0] = 0;
 HEAP8[i13 + 3 >> 0] = 1;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP8[i13 + 8 >> 0] = 15;
 HEAP8[i13 + 9 >> 0] = 1;
 HEAP8[i13 + 10 >> 0] = 0;
 HEAP8[i13 + 11 >> 0] = 1;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP8[i13 + 16 >> 0] = 15;
 HEAP8[i13 + 17 >> 0] = 1;
 HEAP8[i13 + 18 >> 0] = 0;
 HEAP8[i13 + 19 >> 0] = 1;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP8[i13 + 24 >> 0] = 15;
 HEAP8[i13 + 25 >> 0] = 1;
 HEAP8[i13 + 26 >> 0] = 0;
 HEAP8[i13 + 27 >> 0] = 1;
 HEAP32[i13 + 28 >> 2] = 0;
 HEAP8[i13 + 32 >> 0] = 15;
 HEAP8[i13 + 33 >> 0] = 1;
 HEAP8[i13 + 34 >> 0] = 0;
 HEAP8[i13 + 35 >> 0] = 1;
 HEAP32[i13 + 36 >> 2] = 0;
 HEAP8[i13 + 40 >> 0] = 15;
 HEAP8[i13 + 41 >> 0] = 1;
 HEAP8[i13 + 42 >> 0] = 0;
 HEAP8[i13 + 43 >> 0] = 1;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP8[i13 + 48 >> 0] = 15;
 HEAP8[i13 + 49 >> 0] = 1;
 HEAP8[i13 + 50 >> 0] = 0;
 HEAP8[i13 + 51 >> 0] = 1;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP8[i13 + 56 >> 0] = 15;
 HEAP8[i13 + 57 >> 0] = 1;
 HEAP8[i13 + 58 >> 0] = 0;
 HEAP8[i13 + 59 >> 0] = 1;
 HEAP32[i13 + 60 >> 2] = 0;
 HEAP32[i13 + 64 >> 2] = 0;
 __ZNK9ShaderLab20ShaderBlendStateDesc15ToGfxBlendStateEPK19ShaderPropertySheetS3_R13GfxBlendState(i6 + 80 | 0, i8, i9, i13);
 HEAP8[i14 >> 0] = 1;
 i12 = i14 + 1 | 0;
 HEAP8[i12 >> 0] = 2;
 i2 = HEAP32[i6 + 544 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i6 + 540 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i4, i8, i9, i5, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i4 >> 2] >> 2]);
 }
 HEAP8[i14 >> 0] = f1 != Math_fround(0.0) & 1;
 i2 = HEAP32[i6 + 552 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i6 + 548 >> 2]); else {
  HEAP32[i11 >> 2] = -1;
  HEAP32[i11 + 4 >> 2] = 4;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i4, i8, i9, i5, i11);
  f1 = Math_fround(HEAPF32[HEAP32[i4 >> 2] >> 2]);
 }
 i4 = ~~f1;
 HEAP8[i12 >> 0] = (i4 | 0) < 0 ? 0 : ((i4 | 0) > 8 ? 8 : i4) & 255;
 HEAP32[i5 >> 2] = 2;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 __ZNK9ShaderLab21ShaderRasterStateDesc16ToGfxRasterStateEPK19ShaderPropertySheetS3_R14GfxRasterState(i6 + 556 | 0, i8, i9, i5);
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = -1;
 HEAP8[i11 + 2 >> 0] = -1;
 HEAP8[i11 + 3 >> 0] = 0;
 HEAP8[i11 + 4 >> 0] = 8;
 HEAP8[i11 + 5 >> 0] = 0;
 HEAP8[i11 + 6 >> 0] = 0;
 HEAP8[i11 + 7 >> 0] = 0;
 HEAP8[i11 + 8 >> 0] = 8;
 HEAP8[i11 + 9 >> 0] = 0;
 HEAP8[i11 + 10 >> 0] = 0;
 HEAP8[i11 + 11 >> 0] = 0;
 __ZNK9ShaderLab22ShaderStencilStateDesc17ToGfxStencilStateEPK19ShaderPropertySheetS3_RK14GfxRasterStateR15GfxStencilState(i6 + 580 | 0, i8, i9, i5, i11);
 HEAP32[i10 + 4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0, i7 | 0, i13 | 0) | 0;
 HEAP32[i10 + 8 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 48 >> 2] | 0, i7 | 0, i14 | 0) | 0;
 HEAP32[i10 + 12 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 56 >> 2] | 0, i7 | 0, i5 | 0) | 0;
 HEAP32[i10 + 16 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0, i11 | 0) | 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i10 = HEAP32[i2 >> 2] & 255;
   i8 = HEAP32[i4 >> 2] | 0;
   i9 = i8 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i5 = i8 + 8 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i13 = i3;
   i6 = i1 - i13 | 0;
   i2 = i6 + 1 | 0;
   i7 = i8 + 16 | 0;
   if (((HEAP32[i7 >> 2] | 0) - i13 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i8 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) {
      i13 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
     }
    }
    HEAP32[i5 >> 2] = i2;
    i1 = i2 + i6 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i7 >> 2] = i2 + i4;
   }
   HEAP8[i1 >> 0] = i10;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   return;
  }
 case 1:
  {
   i11 = HEAP32[i2 >> 2] | 0;
   i10 = i11 & 255;
   i11 = (i11 & 65535) >>> 8 & 255;
   i5 = HEAP32[i4 >> 2] | 0;
   i9 = i5 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i13 = i3;
   i7 = i1 - i13 | 0;
   i2 = i7 + 2 | 0;
   i8 = i5 + 16 | 0;
   if (((HEAP32[i8 >> 2] | 0) - i13 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) {
      i13 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
     }
    }
    HEAP32[i6 >> 2] = i2;
    i1 = i2 + i7 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i8 >> 2] = i2 + i4;
   }
   HEAP8[i1 >> 0] = i10;
   HEAP8[i1 + 1 >> 0] = i11;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 2;
   return;
  }
 case 2:
  {
   i13 = HEAP32[i2 >> 2] | 0;
   i10 = i13 & 255;
   i11 = i13 >>> 8 & 255;
   i12 = i13 >>> 16 & 255;
   i13 = i13 >>> 24 & 255;
   i5 = HEAP32[i4 >> 2] | 0;
   i9 = i5 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i4 = i3;
   i7 = i1 - i4 | 0;
   i2 = i7 + 4 | 0;
   i8 = i5 + 16 | 0;
   if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) {
      i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
     }
    }
    HEAP32[i6 >> 2] = i2;
    i1 = i2 + i7 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i8 >> 2] = i2 + i4;
   }
   HEAP8[i1 >> 0] = i10;
   HEAP8[i1 + 1 >> 0] = i11;
   HEAP8[i1 + 2 >> 0] = i12;
   HEAP8[i1 + 3 >> 0] = i13;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 4;
   return;
  }
 default:
  {
   __ZN5physx7profile12MemoryBufferINS0_21WrapperNamedAllocatorEE5writeIyEEvRKT_(HEAP32[i4 >> 2] | 0, i2);
   return;
  }
 }
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i20 = i8 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i8 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i8 + 12 | 0;
 i23 = i5 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i8 + 20 | 0;
 i21 = i5 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i4 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i4;
 HEAP8[i22 >> 0] = i20;
 i22 = i5 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i4 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i4 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i4 = i21;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i4 + 4 >> 2] = i19;
 i4 = i18;
 HEAP32[i4 >> 2] = i17;
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 127;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN15DirectorManager14ConnectionPool12SwitchBucketEP14ConnectionList(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i12 + 56 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) > 3) {
  i1 = i12 + 16 | 0;
  i2 = i12 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 << 1;
  do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3 << 4, 4, i12 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i12 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i12 + 28 >> 2] << 3 | 0) | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i1 >> 2] = i11;
   break;
  } while (0);
  i1 = i12 + 36 | 0;
  i2 = i12 + 52 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 << 1;
  if ((i3 & 2147483647) >>> 0 >= i4 >>> 0) return i12 | 0;
  if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3 << 4, 4, i12 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   return i12 | 0;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i12 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i12 + 48 >> 2] << 3 | 0) | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i1 >> 2] = i11;
   return i12 | 0;
  }
 }
 i1 = i1 + 1 | 0;
 i2 = HEAP32[i10 + 48 + (i1 << 2) >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = __ZN15DirectorManager14ConnectionPool10CreateItemEi(i10, i1) | 0;
  HEAP32[i10 + 4 >> 2] = 1;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i9 = i10 + 28 + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 i7 = i3 + 28 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i3 + 48 | 0;
 HEAP32[i9 >> 2] = 0;
 i2 = i3 + 16 | 0;
 if ((i3 | 0) != (i12 | 0)) {
  i8 = HEAP32[i12 + 16 >> 2] | 0;
  i1 = HEAP32[i12 + 28 >> 2] << 3;
  i4 = i1 >> 3;
  HEAP32[i7 >> 2] = i4;
  i5 = i3 + 32 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i3 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i2 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i3 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i2 >> 2] = i1;
   break;
  } else i1 = HEAP32[i2 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i8 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  i2 = i3 + 36 | 0;
  i7 = HEAP32[i12 + 36 >> 2] | 0;
  i1 = HEAP32[i12 + 48 >> 2] << 3;
  i4 = i1 >> 3;
  HEAP32[i9 >> 2] = i4;
  i5 = i3 + 52 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i3 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i2 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i3 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i2 >> 2] = i1;
   break;
  } else i1 = HEAP32[i2 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
 }
 i9 = i10 + 28 + (HEAP32[i11 >> 2] << 2) | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 i11 = HEAP32[i10 + 48 + (HEAP32[i11 >> 2] << 2) >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i12;
 i12 = i3;
 return i12 | 0;
}

function __ZN14ParticleSystem22AllocateParticleArraysEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
 if (i1 | 0) if ((HEAP16[i1 + 340 >> 1] | 0) == 4) {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 868 >> 0] | 0)) __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
 }
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!(HEAP8[i2 + 4 >> 0] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(HEAP8[i2 + 2553 >> 0] | 0)) i1 = 0; else {
   i3 = HEAP32[i6 + 32 >> 2] | 0;
   if (!(HEAP8[i3 + 870 >> 0] | 0)) {
    __ZN23ParticleSystemParticles17SetUses3DRotationEv(i3);
    i2 = HEAP32[i1 >> 2] | 0;
    if (!(HEAP8[i2 + 4 >> 0] | 0)) {
     i1 = 1;
     i2 = 0;
     break;
    } else i1 = 1;
   } else i1 = 1;
  }
  if (!(HEAP8[i2 + 2552 >> 0] | 0)) i2 = 0; else {
   i2 = HEAP32[i6 + 32 >> 2] | 0;
   if (!(HEAP8[i2 + 871 >> 0] | 0)) {
    __ZN23ParticleSystemParticles13SetUses3DSizeEv(i2);
    i2 = 1;
   } else i2 = 1;
  }
 } while (0);
 if (HEAP8[i6 + 52 >> 0] | 0) if (HEAP8[i6 + 260 >> 0] | 0) {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 870 >> 0] | 0)) {
   __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
   i1 = 1;
  } else i1 = 1;
 }
 i3 = HEAP32[i6 + 856 >> 2] | 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i6 + 896 >> 2] | 0) + 4 >> 0] | 0)) i5 = i1; else i4 = 21; else if (!(HEAP8[i3 + 800 >> 0] | 0)) i4 = 21; else {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 870 >> 0] | 0)) {
   __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
   i1 = 1;
   i4 = 21;
  } else {
   i1 = 1;
   i4 = 21;
  }
 }
 if ((i4 | 0) == 21) {
  i3 = HEAP32[i6 + 896 >> 2] | 0;
  if (HEAP8[i3 + 4 >> 0] | 0) if (HEAP8[i3 + 800 >> 0] | 0) {
   i1 = HEAP32[i6 + 32 >> 2] | 0;
   if (!(HEAP8[i1 + 870 >> 0] | 0)) {
    __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
    i1 = 1;
   } else i1 = 1;
  }
  i3 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i3 + 869 >> 0] | 0)) {
   __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i3);
   i5 = i1;
  } else i5 = i1;
 }
 i1 = HEAP32[i6 + 852 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  if (HEAP8[(HEAP32[i6 + 892 >> 2] | 0) + 4 >> 0] | 0) i4 = 32;
 } else if (!(HEAP8[i1 + 800 >> 0] | 0)) i4 = 32; else {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 871 >> 0] | 0)) {
   __ZN23ParticleSystemParticles13SetUses3DSizeEv(i1);
   i2 = 1;
   i4 = 32;
  } else {
   i2 = 1;
   i4 = 32;
  }
 }
 if ((i4 | 0) == 32) {
  i1 = HEAP32[i6 + 892 >> 2] | 0;
  if (HEAP8[i1 + 4 >> 0] | 0) if (HEAP8[i1 + 808 >> 0] | 0) {
   i1 = HEAP32[i6 + 32 >> 2] | 0;
   if (!(HEAP8[i1 + 871 >> 0] | 0)) {
    __ZN23ParticleSystemParticles13SetUses3DSizeEv(i1);
    i2 = 1;
   } else i2 = 1;
  }
 }
 i1 = HEAP32[i6 + 872 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) if (!(HEAP32[i1 + 8 >> 2] | 0)) if (((HEAP16[i1 + 96 >> 1] | 0) + -1 & 65535) < 2) {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (!(HEAP8[i1 + 872 >> 0] | 0)) __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv(i1);
 }
 i4 = i6 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 874 | 0;
 if (!(HEAP8[(HEAP32[i6 + 908 >> 2] | 0) + 4 >> 0] | 0)) HEAP8[i3 >> 0] = 0; else if (!(HEAP8[i3 >> 0] | 0)) {
  HEAP8[i3 >> 0] = 1;
  __ZN14ParticleTrails10ReallocateEjj(i1 + 740 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, -1);
 }
 if (HEAP8[(HEAP32[i6 + 920 >> 2] | 0) + 4 >> 0] | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i1 + 873 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   HEAP8[i3 >> 0] = 1;
   __ZN14dynamic_bitset6resizeEjb(i1 + 600 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, 0);
  }
 }
 if (!i2) if (!(HEAP8[(HEAP32[i6 + 40 >> 2] | 0) + 29 >> 0] | 0)) HEAP8[(HEAP32[i4 >> 2] | 0) + 871 >> 0] = 0;
 if (i5) return;
 if (HEAP8[(HEAP32[i6 + 40 >> 2] | 0) + 28 >> 0] | 0) return;
 HEAP8[(HEAP32[i4 >> 2] | 0) + 870 >> 0] = 0;
 return;
}

function __ZN14ParticleSystem16AssignRayBudgetsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[(HEAP32[gb + 1451700 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 i8 = gb + 63160 | 0;
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i9 << 2;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 2606) | 0;
   i8 = gb + 64016 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i10 = i12;
   HEAP32[i10 >> 2] = i7;
   HEAP32[i10 + 4 >> 2] = i8;
   break;
  }
 } while (0);
 i10 = i1 + 3 & -4;
 if ((i9 | 0) > 0) {
  i5 = 0;
  i8 = 0;
 } else {
  i11 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
  STACKTOP = i13;
  return;
 }
 do {
  i7 = HEAP32[(HEAP32[HEAP32[gb + 1451700 >> 2] >> 2] | 0) + (i8 << 2) >> 2] | 0;
  i6 = i7 + 904 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i4 + 960 >> 2] | 0;
  i2 = i7 + 928 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) {
   switch (i1 | 0) {
   case 0:
    {
     HEAP32[i7 + 932 >> 2] = 0;
     i3 = 0;
     break;
    }
   case 1:
    {
     HEAP32[i7 + 932 >> 2] = 0;
     i3 = 0;
     break;
    }
   case 2:
    {
     HEAP32[i7 + 932 >> 2] = 4;
     i3 = 4;
     break;
    }
   default:
    {
     HEAP32[i7 + 932 >> 2] = 0;
     i3 = 0;
    }
   }
   HEAP32[i7 + 936 >> 2] = i3;
   HEAP32[i2 >> 2] = i1;
  }
  i2 = i7 + 940 | 0;
  HEAP32[i2 >> 2] = 0;
  do if (i4) if (HEAP8[i4 + 4 >> 0] | 0) if ((HEAP32[i4 + 136 >> 2] | 0) == 1) if (!(HEAP32[i7 + 936 >> 2] | 0)) {
   i1 = HEAP32[i7 + 28 >> 2] | 0;
   if (i1) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if ((HEAP32[(HEAP32[i6 >> 2] | 0) + 960 >> 2] | 0) > 0) {
    HEAP32[i10 + (i5 << 2) >> 2] = i7;
    i5 = i5 + 1 | 0;
    break;
   } else {
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i7 + 32 >> 2] | 0) + 12 >> 2];
    break;
   }
  } while (0);
  i2 = i7 + 936 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = HEAP32[i7 + 932 >> 2] | 0; else i1 = i1 + -1 | 0;
  HEAP32[i2 >> 2] = i1;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i9 | 0));
 if (!i5) {
  i11 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
  STACKTOP = i13;
  return;
 }
 i1 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 92 >> 2] | 0;
 i3 = (i1 | 0) / (i5 | 0) | 0;
 i3 = (i3 | 0) > 0 ? i3 : 0;
 i4 = (i5 | 0) > 0;
 if (i4) i2 = 0; else {
  i11 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
  STACKTOP = i13;
  return;
 }
 do {
  i8 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
  i9 = HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 12 >> 2] | 0;
  i9 = (i3 | 0) < (i9 | 0) ? i3 : i9;
  HEAP32[i8 + 940 >> 2] = i9;
  i9 = i1 - i9 | 0;
  i1 = (i9 | 0) < 0 ? 0 : i9;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 if (i4) i3 = 0; else {
  i11 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
  STACKTOP = i13;
  return;
 }
 while (1) {
  i2 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
  i9 = i2 + 940 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i2 = (HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 12 >> 2] | 0) - i8 | 0;
  i2 = (i2 | 0) < (i1 | 0) ? i2 : i1;
  HEAP32[i9 >> 2] = i2 + i8;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i5 | 0)) break; else i1 = i1 - i2 | 0;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
 STACKTOP = i13;
 return;
}

function __ZN12AudioManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 867642 | 0, i6, i1 + 28 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855945 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855959 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855974 | 0, i6, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898090 | 0, i6, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855995 | 0, i6, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 856011 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 856031 | 0, i6, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 856048 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 140 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 856068 | 0, i6, i1 + 224 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 856083 | 0, i6, i1 + 225 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13WheelCollider16TransformChangedEi(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i7 = i13;
 i12 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0) | 0;
 if (!(i1 & 64)) {
  i8 = i11 + 148 | 0;
  if (!((i12 | 0) != 0 & (HEAP32[i8 >> 2] | 0) != -1)) {
   STACKTOP = i13;
   return;
  }
  i3 = HEAP32[i12 + 56 >> 2] | 0;
  i10 = i11 + 28 | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0);
  f4 = Math_fround(HEAPF32[i11 + 72 >> 2]);
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2]));
  i2 = f4 < Math_fround(0.0);
  f5 = Math_fround(-f4);
  f4 = i2 ? f5 : f4;
  i2 = f4 < Math_fround(9.99999974e-06);
  f4 = i2 ? Math_fround(9.99999974e-06) : f4;
  __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0);
  f5 = Math_fround(HEAPF32[i11 + 88 >> 2]);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i6 + 4 >> 2]));
  i10 = f5 < Math_fround(0.0);
  f9 = Math_fround(-f5);
  f5 = i10 ? f9 : f5;
  i10 = f5 < Math_fround(9.99999974e-06);
  f5 = i10 ? Math_fround(9.99999974e-06) : f5;
  f9 = Math_fround(HEAPF32[i11 + 84 >> 2]);
  i10 = i3 + 8 | 0;
  __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i11);
  __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf(i3, Math_fround(__ZNK9Rigidbody7GetMassEv(i12)));
  if (i1 & 8 | 0) {
   i1 = i6;
   i2 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i10, HEAP32[i8 >> 2] | 0) | 0;
   i3 = i1 + 48 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAPF32[i6 >> 2] = f4;
   HEAPF32[i6 + 12 >> 2] = Math_fround(f4 * Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) * Math_fround(.5))));
   __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i10, HEAP32[i8 >> 2] | 0, i6);
   i1 = i7;
   i2 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i10, HEAP32[i8 >> 2] | 0) | 0;
   i3 = i1 + 48 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f9) * f5);
   HEAPF32[i7 + 12 >> 2] = Math_fround(f9 * f5);
   __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i10, HEAP32[i8 >> 2] | 0, i7);
  }
  i12 = HEAP32[i12 + 52 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 284 >> 2] | 0, i12 | 0);
  STACKTOP = i13;
  return;
 }
 i3 = i11 + 28 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 67048 | 0) | 0;
 L11 : do if (!i1) {
  i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  if (!i1) i1 = 0; else while (1) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if (i2 | 0) {
    i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
    if (i2 | 0) {
     i1 = i2;
     break L11;
    }
   }
   i1 = HEAP32[i1 + 100 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 if ((i1 | 0) == (i12 | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i13;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 112 >> 2] | 0, i11 | 0) | 0)) {
  STACKTOP = i13;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 144 >> 2] | 0, i11 | 0, 0);
 STACKTOP = i13;
 return;
}

function __ZN9Projector22SetupProjectorSettingsEP8MaterialR23ProjectorRenderSettings(i1, i7, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 400 | 0;
 i13 = i19 + 336 | 0;
 i14 = i19 + 272 | 0;
 i15 = i19 + 208 | 0;
 i16 = i19 + 144 | 0;
 i17 = i19 + 80 | 0;
 i18 = i19 + 16 | 0;
 i8 = i19;
 f4 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 i9 = i1 + 36 | 0;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i1 + 40 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 if (!(HEAP8[i1 + 52 >> 0] | 0)) __ZN10Matrix4x4f14SetPerspectiveEffff(i12, Math_fround(HEAPF32[i1 + 44 >> 2]), f4, f5, f6) | 0; else {
  f20 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  f21 = Math_fround(-f20);
  __ZN10Matrix4x4f8SetOrthoEffffff(i12, Math_fround(f4 * f21), Math_fround(f4 * f20), f21, f20, f5, f6) | 0;
 }
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 HEAPF32[i14 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i14 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i13, i14) | 0;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = i14;
 i2 = i15;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF32[i8 >> 2] = Math_fround(.5);
 HEAPF32[i8 + 4 >> 2] = Math_fround(.5);
 HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i15, i8) | 0;
 HEAPF32[i8 >> 2] = Math_fround(.5);
 HEAPF32[i8 + 4 >> 2] = Math_fround(.5);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i16, i8) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i16, i12, i17);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i17, i13, i18);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i18, i15, i16);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i16, i14, i11);
 f21 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i8 >> 2] = f21;
 HEAPF32[i8 + 4 >> 2] = f21;
 HEAPF32[i8 + 8 >> 2] = f21;
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i15, i8) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i16) | 0;
 i2 = i16 + 16 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i16 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i16, i15, i17);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i17, i14, i11 + 64 | 0);
 f21 = Math_fround(HEAPF32[i10 >> 2]);
 f21 = Math_fround(Math_fround(1.0) / Math_fround(f21 - Math_fround(HEAPF32[i9 >> 2])));
 HEAPF32[i8 >> 2] = f21;
 HEAPF32[i8 + 4 >> 2] = f21;
 HEAPF32[i8 + 8 >> 2] = f21;
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i15, i8) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i16) | 0;
 f21 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
 HEAPF32[i8 >> 2] = f21;
 HEAPF32[i8 + 4 >> 2] = f21;
 HEAPF32[i8 + 8 >> 2] = f21;
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i17, i8) | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i16, i15, i18);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i18, i17, i15);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i15, i14, i11 + 128 | 0);
 i18 = __ZN8Material9GetShaderEv(i7) | 0;
 HEAP32[i11 + 256 >> 2] = i7;
 HEAP32[i11 + 260 >> 2] = 0;
 HEAP32[i11 + 264 >> 2] = HEAP32[(HEAP32[HEAP32[HEAP32[i18 + 32 >> 2] >> 2] >> 2] | 0) + 20 >> 2];
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i12, i13, i15);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i15, i14, i11 + 192 | 0);
 STACKTOP = i19;
 return;
}

function __ZN14PhysicsManager15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 60 | 0;
 i2 = i5 + 48 | 0;
 i3 = i5 + 4 | 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 737328 | 0, gb + 781527 | 0, gb + 737364 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 737328 | 0, gb + 781544 | 0, gb + 737458 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 737328 | 0, gb + 781567 | 0, gb + 737484 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 737328 | 0, gb + 781598 | 0, gb + 737484 | 0);
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = gb + 113952 + 8;
 __Z19SetRaycastInterfaceP8IRaycast(i1);
 i1 = _PxCreateFoundation(50529024, gb + 1452432 | 0, gb + 1452428 | 0) | 0;
 HEAP32[gb + 1457460 >> 2] = i1;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 781625 | 0, 0, gb + 662472 | 0, 486, 32785, 0, 0, 0);
  i1 = HEAP32[gb + 1457460 >> 2] | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, -131);
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(1.0e3);
 HEAPF32[i2 + 8 >> 2] = Math_fround(10.0);
 i1 = _PxCreateBasePhysics(50529024, HEAP32[gb + 1457460 >> 2] | 0, i2, 0, 0) | 0;
 HEAP32[gb + 1457408 >> 2] = i1;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 781625 | 0, 0, gb + 662472 | 0, 501, 32785, 0, 0, 0);
  i1 = HEAP32[gb + 1457408 >> 2] | 0;
 }
 _PxRegisterHeightFields(i1);
 if (!(_PxInitExtensions(HEAP32[gb + 1457408 >> 2] | 0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 781647 | 0, 0, gb + 662472 | 0, 506, 32785, 0, 0, 0);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i3 + 4 >> 2] = Math_fround(f6 * Math_fround(.0250000004));
 HEAPF32[i3 + 8 >> 2] = Math_fround(f6 * Math_fround(f6 * Math_fround(.0599999987)));
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP8[i3 + 13 >> 0] = 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 40 >> 2] = Math_fround(.550000012);
 HEAP32[i3 >> 2] = 0;
 i3 = _PxCreateCooking(50529024, HEAP32[gb + 1457460 >> 2] | 0, i3) | 0;
 HEAP32[gb + 1457456 >> 2] = i3;
 __ZN14PhysicsManager19CreateDynamicsSceneEbb(0, 1);
 __ZN19CharacterController23CreateControllerManagerEv();
 if (__Z12GetIVehiclesv() | 0) {
  i3 = __Z12GetIVehiclesv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 }
 if (__Z9GetIClothv() | 0) {
  i3 = __Z9GetIClothv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 }
 HEAP32[gb + 1115296 + 156 >> 2] = fb + 217;
 HEAP32[gb + 1115296 + 172 >> 2] = fb + 218;
 HEAP32[gb + 1115296 + 124 >> 2] = fb + 219;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 3084 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 2316 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 2316 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 2316 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 220;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 2316 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 2316 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 2316 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 220;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_13PxBoxGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i10, i7, i5) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i9 = i11 + 24 | 0;
 i8 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = gb + 673012;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i13 = i6;
  i12 = HEAP32[i13 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = HEAP32[i6 + 4 >> 2] | 0;
  i13 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i9 >> 2] = 3;
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_13PxBoxGeometryE(i7, HEAP32[i10 + 8 >> 2] | 0, i9) | 0;
 __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i8);
 i3 = i10 + 4 | 0;
 __ZN5physx2Sn18writeAllPropertiesINS_13PxBoxGeometryEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(HEAP32[i10 >> 2] | 0, i9, HEAP32[i3 >> 2] | 0, HEAP32[i10 + 12 >> 2] | 0, HEAP32[i10 + 16 >> 2] | 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i11;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap11shiftOriginERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0;
 i25 = i2 + 168 | 0;
 if (!(HEAP32[i25 >> 2] | 0)) return;
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f27 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i24 = HEAP32[i2 + 136 >> 2] | 0;
 i19 = HEAP32[i2 + 124 >> 2] | 0;
 i20 = HEAP32[i2 + 140 >> 2] | 0;
 i21 = HEAP32[i2 + 128 >> 2] | 0;
 i22 = HEAP32[i2 + 144 >> 2] | 0;
 i18 = HEAP32[i2 + 132 >> 2] | 0;
 i10 = i19 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i24 + 4 | 0;
 i11 = i21 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = i20 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i6 = i18 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i9 = i22 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i1 | 0) < 0 ? i1 & 2147483647 : ~i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i2 | 0) < 0 ? i2 & 2147483647 : ~i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 | 0) < 0 ? i4 & 2147483647 : ~i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (i1 | 0) < 0 ? ~i1 : i1 | -2147483648;
 if (!(HEAP32[i7 >> 2] & 1)) i1 = i1 + -16 & -16; else i1 = i1 + 16 & -16 | 1;
 HEAP32[i10 >> 2] = i1;
 i1 = (i2 | 0) < 0 ? ~i2 : i2 | -2147483648;
 if (!(i3 & 1)) i1 = i1 + -16 & -16; else i1 = i1 + 16 & -16 | 1;
 HEAP32[i11 >> 2] = i1;
 i1 = (i4 | 0) < 0 ? ~i4 : i4 | -2147483648;
 if (!(i5 & 1)) i1 = i1 + -16 & -16; else i1 = i1 + 16 & -16 | 1;
 HEAP32[i6 >> 2] = i1;
 if (HEAP32[i25 >> 2] << 1 >>> 0 < 2) return;
 i17 = 2;
 i16 = HEAP32[i7 >> 2] & 1;
 i15 = HEAP32[i8 >> 2] & 1;
 i14 = HEAP32[i9 >> 2] & 1;
 i13 = HEAP32[i10 >> 2] | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 do {
  i9 = i16;
  i16 = HEAP32[i24 + (i17 << 2) >> 2] & 1;
  i10 = i15;
  i15 = HEAP32[i20 + (i17 << 2) >> 2] & 1;
  i11 = i14;
  i14 = HEAP32[i22 + (i17 << 2) >> 2] & 1;
  i6 = i19 + (i17 << 2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i7 = i21 + (i17 << 2) | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = i18 + (i17 << 2) | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i2 | 0) < 0 ? i2 & 2147483647 : ~i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i3 | 0) < 0 ? i3 & 2147483647 : ~i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  f28 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 | 0) < 0 ? i4 & 2147483647 : ~i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f23);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f28, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (i2 | 0) < 0 ? ~i2 : i2 | -2147483648;
  if (!i16) i5 = i2 + -16 & -16; else i5 = i2 + 16 & -16 | 1;
  i2 = (i3 | 0) < 0 ? ~i3 : i3 | -2147483648;
  if (!i15) i3 = i2 + -16 & -16; else i3 = i2 + 16 & -16 | 1;
  i2 = (i4 | 0) < 0 ? ~i4 : i4 | -2147483648;
  if (!i14) i2 = i2 + -16 & -16; else i2 = i2 + 16 & -16 | 1;
  i13 = i5 >>> 0 < i13 >>> 0 ? (i16 ^ i9) + i13 | 0 : i5;
  i12 = i3 >>> 0 < i12 >>> 0 ? (i15 ^ i10) + i12 | 0 : i3;
  i1 = i2 >>> 0 < i1 >>> 0 ? (i14 ^ i11) + i1 | 0 : i2;
  HEAP32[i6 >> 2] = i13;
  HEAP32[i7 >> 2] = i12;
  HEAP32[i8 >> 2] = i1;
  i17 = i17 + 1 | 0;
 } while (i17 >>> 0 <= HEAP32[i25 >> 2] << 1 >>> 0);
 return;
}

function __ZN5physx22propagateDrivenImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKS8_(i4, i6, i5, i2, i3, i1) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i18 = i3 + 16 | 0;
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 i17 = i3 + 20 | 0;
 f10 = Math_fround(HEAPF32[i17 >> 2]);
 i16 = i3 + 24 | 0;
 f24 = Math_fround(HEAPF32[i16 >> 2]);
 f25 = Math_fround(HEAPF32[i3 >> 2]);
 i20 = i3 + 4 | 0;
 f21 = Math_fround(HEAPF32[i20 >> 2]);
 i19 = i3 + 8 | 0;
 f23 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f22 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(f8 + Math_fround(Math_fround(f21 * f22) - Math_fround(f23 * f7)));
 f22 = Math_fround(f10 + Math_fround(Math_fround(f23 * f14) - Math_fround(f25 * f22)));
 f14 = Math_fround(f24 + Math_fround(Math_fround(f25 * f7) - Math_fround(f21 * f14)));
 f21 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f21 = Math_fround(f8 - f21);
 f7 = Math_fround(f22 - f7);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i2 >> 2] = f21;
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f14;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 f22 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f23 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f11 = Math_fround(HEAPF32[i6 + 68 >> 2]);
 f12 = Math_fround(Math_fround(f21 * f22) + Math_fround(Math_fround(f7 * f24) + Math_fround(f14 * f12)));
 f11 = Math_fround(Math_fround(f21 * f8) + Math_fround(Math_fround(f7 * f23) + Math_fround(f14 * f11)));
 f10 = Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f7 * f10) + Math_fround(f14 * Math_fround(HEAPF32[i6 + 72 >> 2]))));
 f25 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f23 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f24 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f22 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 56 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 80 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 84 >> 2]);
 f9 = Math_fround(Math_fround(f21 * f25) + Math_fround(Math_fround(f7 * f24) + Math_fround(f14 * f9)));
 f15 = Math_fround(Math_fround(f21 * f23) + Math_fround(Math_fround(f7 * f22) + Math_fround(f14 * f15)));
 f14 = Math_fround(Math_fround(f21 * f8) + Math_fround(Math_fround(f7 * f13) + Math_fround(f14 * Math_fround(HEAPF32[i6 + 88 >> 2]))));
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i20 >> 2]);
 f12 = Math_fround(f13 - f12);
 f11 = Math_fround(f7 - f11);
 f10 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f10);
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f13 = Math_fround(HEAPF32[i17 >> 2]);
 f9 = Math_fround(f7 - f9);
 f15 = Math_fround(f13 - f15);
 f14 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f14);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(Math_fround(f10 * f7) - Math_fround(f11 * f8)));
 f8 = Math_fround(f15 + Math_fround(Math_fround(f12 * f8) - Math_fround(f10 * f13)));
 f7 = Math_fround(f14 + Math_fround(Math_fround(f11 * f13) - Math_fround(f12 * f7)));
 HEAPF32[i4 >> 2] = f12;
 HEAPF32[i4 + 4 >> 2] = f11;
 HEAPF32[i4 + 8 >> 2] = f10;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 16 >> 2] = f9;
 HEAPF32[i4 + 20 >> 2] = f8;
 HEAPF32[i4 + 24 >> 2] = f7;
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i20 = i8 + 4 | 0;
 HEAP32[i20 >> 2] = 0;
 i22 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i19 = HEAP16[i24 >> 1] | 0;
 HEAP8[i22 >> 0] = i19;
 i17 = i8 + 9 | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 i19 = i8 + 12 | 0;
 i23 = i5 + 12 | 0;
 i15 = i23;
 i21 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = i19;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = i21;
 i18 = i8 + 20 | 0;
 i21 = i5 + 20 | 0;
 i15 = i21;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i18;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i1;
 i20 = HEAP8[i24 >> 0] | 0;
 i4 = HEAP16[i22 >> 1] | 0;
 HEAP8[i24 >> 0] = i4;
 HEAP8[i22 >> 0] = i20;
 i22 = i5 + 9 | 0;
 i20 = HEAP8[i22 >> 0] | 0;
 HEAP8[i22 >> 0] = (i4 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i20;
 i17 = i23;
 i20 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = i19;
 i4 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = i23;
 HEAP32[i1 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i19;
 HEAP32[i1 >> 2] = i20;
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i21;
 i17 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = i18;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i4 = i21;
 HEAP32[i4 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i4 + 4 >> 2] = i19;
 i4 = i18;
 HEAP32[i4 >> 2] = i17;
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN13b2DynamicTree15RebuildBottomUpEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0;
 i4 = i14 + 8 | 0;
 i15 = __Z7b2Alloci(HEAP32[i4 >> 2] << 2) | 0;
 i6 = i14 + 12 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i14 >> 2] = i13;
  __Z6b2FreePv(i15);
  return;
 }
 i7 = HEAP32[i14 + 4 >> 2] | 0;
 i5 = i14 + 16 | 0;
 i1 = 0;
 i3 = 0;
 do {
  i2 = i7 + (i3 * 36 | 0) + 32 | 0;
  do if ((HEAP32[i2 >> 2] | 0) >= 0) if ((HEAP32[i7 + (i3 * 36 | 0) + 24 >> 2] | 0) == -1) {
   HEAP32[i7 + (i3 * 36 | 0) + 20 >> 2] = -1;
   HEAP32[i15 + (i1 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
   break;
  } else {
   HEAP32[i7 + (i3 * 36 | 0) + 20 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 >> 2] = -1;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   break;
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i6 >> 2] | 0));
 if ((i1 | 0) <= 1) {
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i14 >> 2] = i13;
  __Z6b2FreePv(i15);
  return;
 }
 i13 = i14 + 4 | 0;
 do {
  i7 = HEAP32[i13 >> 2] | 0;
  f8 = Math_fround(3402823469999999843913219.0e14);
  i3 = -1;
  i2 = -1;
  i6 = 0;
  do {
   i4 = HEAP32[i15 + (i6 << 2) >> 2] | 0;
   f9 = Math_fround(HEAPF32[i7 + (i4 * 36 | 0) >> 2]);
   f10 = Math_fround(HEAPF32[i7 + (i4 * 36 | 0) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i7 + (i4 * 36 | 0) + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i7 + (i4 * 36 | 0) + 12 >> 2]);
   i4 = i6;
   i6 = i6 + 1 | 0;
   if ((i6 | 0) < (i1 | 0)) {
    i5 = i6;
    do {
     i17 = HEAP32[i15 + (i5 << 2) >> 2] | 0;
     f19 = Math_fround(HEAPF32[i7 + (i17 * 36 | 0) >> 2]);
     f16 = Math_fround(HEAPF32[i7 + (i17 * 36 | 0) + 4 >> 2]);
     f20 = Math_fround(HEAPF32[i7 + (i17 * 36 | 0) + 8 >> 2]);
     f18 = Math_fround(HEAPF32[i7 + (i17 * 36 | 0) + 12 >> 2]);
     f16 = Math_fround(Math_fround(Math_fround((f11 > f20 ? f11 : f20) - (f9 < f19 ? f9 : f19)) + Math_fround((f12 > f18 ? f12 : f18) - (f10 < f16 ? f10 : f16))) * Math_fround(2.0));
     i17 = f16 < f8;
     i2 = i17 ? i5 : i2;
     i3 = i17 ? i4 : i3;
     f8 = i17 ? f16 : f8;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i1 | 0));
   }
  } while ((i6 | 0) != (i1 | 0));
  i5 = HEAP32[i15 + (i3 << 2) >> 2] | 0;
  i6 = HEAP32[i15 + (i2 << 2) >> 2] | 0;
  i17 = __ZN13b2DynamicTree12AllocateNodeEv(i14) | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i4 + (i17 * 36 | 0) + 24 >> 2] = i5;
  HEAP32[i4 + (i17 * 36 | 0) + 28 >> 2] = i6;
  i22 = HEAP32[i7 + (i5 * 36 | 0) + 32 >> 2] | 0;
  i21 = HEAP32[i7 + (i6 * 36 | 0) + 32 >> 2] | 0;
  HEAP32[i4 + (i17 * 36 | 0) + 32 >> 2] = ((i22 | 0) > (i21 | 0) ? i22 : i21) + 1;
  f20 = Math_fround(HEAPF32[i7 + (i5 * 36 | 0) >> 2]);
  f19 = Math_fround(HEAPF32[i7 + (i6 * 36 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i7 + (i5 * 36 | 0) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + (i6 * 36 | 0) + 4 >> 2]);
  HEAPF32[i4 + (i17 * 36 | 0) >> 2] = f20 < f19 ? f20 : f19;
  HEAPF32[i4 + (i17 * 36 | 0) + 4 >> 2] = f18 < f16 ? f18 : f16;
  f16 = Math_fround(HEAPF32[i7 + (i5 * 36 | 0) + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i7 + (i6 * 36 | 0) + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i7 + (i5 * 36 | 0) + 12 >> 2]);
  f20 = Math_fround(HEAPF32[i7 + (i6 * 36 | 0) + 12 >> 2]);
  HEAPF32[i4 + (i17 * 36 | 0) + 8 >> 2] = f16 > f18 ? f16 : f18;
  HEAPF32[i4 + (i17 * 36 | 0) + 12 >> 2] = f19 > f20 ? f19 : f20;
  HEAP32[i4 + (i17 * 36 | 0) + 20 >> 2] = -1;
  HEAP32[i7 + (i5 * 36 | 0) + 20 >> 2] = i17;
  HEAP32[i7 + (i6 * 36 | 0) + 20 >> 2] = i17;
  i1 = i1 + -1 | 0;
  HEAP32[i15 + (i2 << 2) >> 2] = HEAP32[i15 + (i1 << 2) >> 2];
  HEAP32[i15 + (i3 << 2) >> 2] = i17;
 } while ((i1 | 0) > 1);
 i22 = HEAP32[i15 >> 2] | 0;
 HEAP32[i14 >> 2] = i22;
 __Z6b2FreePv(i15);
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator17generateEmptyTileERNS_7DataPtrERKNS_4AABBEi(i11, i3, i4, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i11 + 300 | 0, 192, 65536) | 0) {
  i8 = i11 + 432 | 0;
  i1 = HEAP32[i11 + 304 + (HEAP32[i8 >> 2] << 3) + 4 >> 2] | 0;
  i5 = i11 + 452 | 0;
  i6 = i11 + 444 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  i9 = i7;
  i10 = i9 + 80 | 0;
  do {
   HEAP8[i9 >> 0] = 0;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i10 | 0));
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 80;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i11 + 304 + (i9 << 3) + 4 >> 2] | 0) - (HEAP32[i11 + 304 + (i9 << 3) >> 2] | 0);
  i3 = HEAP32[i8 >> 2] | 0;
  i9 = i11 + 304 + (i3 << 3) + 4 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 80 | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i3 + 1 | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i11 + 304 + (i3 << 3) >> 2] = i1;
  HEAP32[i11 + 304 + (HEAP32[i8 >> 2] << 3) + 4 >> 2] = i2;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i1 = i7 + 12 | 0;
  i2 = i4 + 12 | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i7 + 52 >> 2] = 1;
  HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
  HEAP32[i7 + 24 >> 2] = 33;
  i1 = i7 + 28 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i9 = i3;
  i10 = i9 + 16 | 0;
  do {
   HEAP8[i9 >> 0] = 0;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i10 | 0));
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = (HEAP32[i11 + 304 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i11 + 304 + (i2 << 3) >> 2] | 0);
  i1 = i11 + 304 + (HEAP32[i8 >> 2] << 3) + 4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  HEAP32[i3 >> 2] = HEAP32[HEAP32[i11 + 204 >> 2] >> 2];
  i1 = i7 + 32 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i9 = i3;
  i10 = i9 + 16 | 0;
  do {
   HEAP8[i9 >> 0] = 0;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i10 | 0));
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = (HEAP32[i11 + 304 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i11 + 304 + (i2 << 3) >> 2] | 0);
  i1 = i11 + 304 + (HEAP32[i8 >> 2] << 3) + 4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  HEAP32[i3 >> 2] = 0;
  i3 = i7 + 56 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i9 = i2;
  i10 = i9 + 48 | 0;
  do {
   HEAP8[i9 >> 0] = 0;
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i10 | 0));
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 48;
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i11 + 304 + (i10 << 3) + 4 >> 2] | 0) - (HEAP32[i11 + 304 + (i10 << 3) >> 2] | 0);
  i10 = i11 + 304 + (HEAP32[i8 >> 2] << 3) + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 48;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 65535;
  HEAP32[i2 + 32 >> 2] = -1;
  i10 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i11 + 304 + (i10 << 3) + 4 >> 2] | 0;
  i9 = i10 + -1 | 0;
  HEAP32[i11 + 304 + (i9 << 3) + 4 >> 2] = i6;
  i10 = i6 - (HEAP32[i11 + 304 + (i10 << 3) >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i7 + 44 >> 2] = i10 << 8 | 3;
  HEAP8[i11 + 436 >> 0] = 0;
  i11 = i7;
  return i11 | 0;
 } else {
  HEAP32[i11 + 464 >> 2] = 1;
  i11 = 0;
  return i11 | 0;
 }
 return 0;
}

function runPostSets195() {
 HEAP32[gb + 167148 >> 2] = fb + 1143;
 HEAP32[gb + 167152 >> 2] = fb + 1144;
 HEAP32[gb + 167156 >> 2] = fb + 1145;
 HEAP32[gb + 167160 >> 2] = fb + 1146;
 HEAP32[gb + 167164 >> 2] = fb + 125;
 HEAP32[gb + 167168 >> 2] = fb + 126;
 HEAP32[gb + 167180 >> 2] = fb + 2521;
 HEAP32[gb + 167184 >> 2] = fb + 2522;
 HEAP32[gb + 167188 >> 2] = fb + 1147;
 HEAP32[gb + 167192 >> 2] = fb + 1148;
 HEAP32[gb + 167196 >> 2] = fb + 1149;
 HEAP32[gb + 167200 >> 2] = fb + 1150;
 HEAP32[gb + 167204 >> 2] = fb + 1151;
 HEAP32[gb + 167208 >> 2] = fb + 1152;
 HEAP32[gb + 167212 >> 2] = fb + 1153;
 HEAP32[gb + 167216 >> 2] = fb + 127;
 HEAP32[gb + 167220 >> 2] = fb + 128;
 HEAP32[gb + 167232 >> 2] = fb + 2523;
 HEAP32[gb + 167236 >> 2] = fb + 2524;
 HEAP32[gb + 167240 >> 2] = fb + 1;
 HEAP32[gb + 167244 >> 2] = fb + 1;
 HEAP32[gb + 167248 >> 2] = fb + 1;
 HEAP32[gb + 167252 >> 2] = fb + 1;
 HEAP32[gb + 167256 >> 2] = fb + 1;
 HEAP32[gb + 167260 >> 2] = fb + 1;
 HEAP32[gb + 167264 >> 2] = fb + 1;
 HEAP32[gb + 167268 >> 2] = fb + 1;
 HEAP32[gb + 167272 >> 2] = fb + 1;
 HEAP32[gb + 167284 >> 2] = fb + 2525;
 HEAP32[gb + 167288 >> 2] = fb + 2526;
 HEAP32[gb + 167300 >> 2] = fb + 2527;
 HEAP32[gb + 167304 >> 2] = fb + 2528;
 HEAP32[gb + 167308 >> 2] = fb + 18;
 HEAP32[gb + 167312 >> 2] = fb + 262;
 HEAP32[gb + 167316 >> 2] = fb + 263;
 HEAP32[gb + 167320 >> 2] = fb + 429;
 HEAP32[gb + 167324 >> 2] = fb + 12;
 HEAP32[gb + 167328 >> 2] = fb + 16;
 HEAP32[gb + 167332 >> 2] = fb + 436;
 HEAP32[gb + 167336 >> 2] = fb + 437;
 HEAP32[gb + 167340 >> 2] = fb + 438;
 HEAP32[gb + 167344 >> 2] = fb + 137;
 HEAP32[gb + 167348 >> 2] = fb + 439;
 HEAP32[gb + 167352 >> 2] = fb + 440;
 HEAP32[gb + 167356 >> 2] = fb + 138;
 HEAP32[gb + 167360 >> 2] = fb + 139;
 HEAP32[gb + 167364 >> 2] = fb + 78;
 HEAP32[gb + 167368 >> 2] = fb + 79;
 HEAP32[gb + 167380 >> 2] = fb + 2529;
 HEAP32[gb + 167384 >> 2] = fb + 2530;
 HEAP32[gb + 167388 >> 2] = fb + 19;
 HEAP32[gb + 167392 >> 2] = fb + 264;
 HEAP32[gb + 167396 >> 2] = fb + 265;
 HEAP32[gb + 167400 >> 2] = fb + 430;
 HEAP32[gb + 167404 >> 2] = fb + 13;
 HEAP32[gb + 167408 >> 2] = fb + 17;
 HEAP32[gb + 167412 >> 2] = fb + 441;
 HEAP32[gb + 167416 >> 2] = fb + 442;
 HEAP32[gb + 167420 >> 2] = fb + 443;
 HEAP32[gb + 167424 >> 2] = fb + 140;
 HEAP32[gb + 167428 >> 2] = fb + 444;
 HEAP32[gb + 167432 >> 2] = fb + 445;
 HEAP32[gb + 167436 >> 2] = fb + 141;
 HEAP32[gb + 167440 >> 2] = fb + 142;
 HEAP32[gb + 167444 >> 2] = fb + 80;
 HEAP32[gb + 167448 >> 2] = fb + 81;
 HEAP32[gb + 167460 >> 2] = fb + 2531;
 HEAP32[gb + 167464 >> 2] = fb + 2532;
 HEAP32[gb + 167468 >> 2] = fb + 431;
 HEAP32[gb + 167472 >> 2] = fb + 1154;
 HEAP32[gb + 167476 >> 2] = fb + 1155;
 HEAP32[gb + 167480 >> 2] = fb + 1156;
 HEAP32[gb + 167484 >> 2] = fb + 2533;
 HEAP32[gb + 167488 >> 2] = fb + 2534;
 HEAP32[gb + 167492 >> 2] = fb + 1795;
 HEAP32[gb + 167496 >> 2] = fb + 1796;
 HEAP32[gb + 167500 >> 2] = fb + 1797;
 HEAP32[gb + 167504 >> 2] = fb + 1798;
 HEAP32[gb + 167508 >> 2] = fb + 1799;
 HEAP32[gb + 167512 >> 2] = fb + 1800;
 HEAP32[gb + 167516 >> 2] = fb + 1801;
 HEAP32[gb + 167520 >> 2] = fb + 1157;
 HEAP32[gb + 167524 >> 2] = fb + 1158;
 HEAP32[gb + 167528 >> 2] = fb + 2535;
 HEAP32[gb + 167532 >> 2] = fb + 1802;
 HEAP32[gb + 167536 >> 2] = fb + 150;
 HEAP32[gb + 167540 >> 2] = fb + 1803;
 HEAP32[gb + 167544 >> 2] = fb + 1804;
 HEAP32[gb + 167548 >> 2] = fb + 1805;
 HEAP32[gb + 167552 >> 2] = fb + 1806;
 HEAP32[gb + 167556 >> 2] = fb + 1807;
 HEAP32[gb + 167560 >> 2] = fb + 1808;
 HEAP32[gb + 167564 >> 2] = fb + 1809;
 HEAP32[gb + 167568 >> 2] = fb + 1810;
 HEAP32[gb + 167572 >> 2] = fb + 1811;
 HEAP32[gb + 167576 >> 2] = fb + 1812;
 HEAP32[gb + 167580 >> 2] = fb + 1813;
 HEAP32[gb + 167584 >> 2] = fb + 1814;
 HEAP32[gb + 167588 >> 2] = fb + 1815;
 HEAP32[gb + 167592 >> 2] = fb + 1816;
 runPostSets196();
}

function __ZNK12TreeDatabase27NeedUpgradeScaledPrototypesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 16 | 0;
 i12 = i16 + 12 | 0;
 i13 = i16;
 if (!(HEAP8[i1 + 40 >> 0] | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i14 = i1 + 4 | 0;
 i10 = i1 + 8 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 f9 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i7 = i13 + 4 | 0;
 i8 = i13 + 8 | 0;
 f9 = Math_fround(f9 * f9);
 i6 = 0;
 L7 : while (1) {
  i5 = i1 + (i6 << 3) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i12 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i4 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i4 = HEAP32[i11 >> 2] | 0;
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
     i1 = i3;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i15 = 10; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i15 = 12;
   }
   if ((i15 | 0) == 10) i15 = 12;
   if ((i15 | 0) == 12) {
    i15 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
   }
   i4 = (HEAP32[i14 >> 2] | 0) + (i6 << 3) | 0;
   HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
   if (!i1) i15 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i12);
     i2 = HEAP32[i11 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i15 = 21;
    }
   }
   if ((i15 | 0) == 19) i15 = 21;
   if ((i15 | 0) == 21) {
    i15 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   __ZNK9Transform18GetWorldScaleLossyEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
   f19 = Math_fround(HEAPF32[gb + 62512 >> 2]);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i13 >> 2]));
   f18 = Math_fround(HEAPF32[gb + 62512 + 4 >> 2]);
   f18 = Math_fround(f18 - Math_fround(HEAPF32[i7 >> 2]));
   f17 = Math_fround(HEAPF32[gb + 62512 + 8 >> 2]);
   f17 = Math_fround(f17 - Math_fround(HEAPF32[i8 >> 2]));
   if (!(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)) + Math_fround(f17 * f17)) <= f9)) {
    i1 = 1;
    i15 = 24;
    break L7;
   }
  } while (0);
  i6 = i6 + 1 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  if (i6 >>> 0 >= (HEAP32[i10 >> 2] | 0) - i1 >> 3 >>> 0) {
   i1 = 0;
   i15 = 24;
   break;
  }
 }
 if ((i15 | 0) == 24) {
  STACKTOP = i16;
  return i1 | 0;
 }
 return 0;
}

function __ZN5Umbra9Matrix4x3mLERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 i9 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 i15 = i1 + 32 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 i17 = i2 + 4 | 0;
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 i16 = i2 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 i14 = i2 + 16 | 0;
 f11 = Math_fround(f4 * Math_fround(HEAPF32[i14 >> 2]));
 i13 = i2 + 20 | 0;
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 i12 = i2 + 24 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i12 >> 2])));
 i9 = i2 + 32 | 0;
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2]));
 i7 = i2 + 36 | 0;
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 i5 = i2 + 40 | 0;
 HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i5 >> 2])));
 i15 = i1 + 4 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 36 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f11 + Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2])));
 f11 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f11 + Math_fround(f4 * Math_fround(HEAPF32[i12 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i5 >> 2])));
 i3 = i1 + 8 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i1 + 24 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i15 = i1 + 40 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f11 = Math_fround(f4 * Math_fround(HEAPF32[i14 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i12 >> 2])));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i5 >> 2])));
 i15 = i1 + 12 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = i1 + 28 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 44 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f11);
 f11 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f4 * Math_fround(HEAPF32[i12 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) + f11);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i5 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) + f4);
 return i1 | 0;
}

function __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZL18InitializeIfNeededv();
 i4 = (__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1103788 >> 2] | 0, i6) | 0) == 0;
 i5 = HEAP32[gb + 1103828 >> 2] | 0;
 if (i4) {
  i2 = HEAP8[i6 + 11 >> 0] | 0;
  i2 = i2 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i2 & 255;
  if (((HEAP32[i8 >> 2] | 0) + -253 | 0) >>> 0 < 2) i1 = 5; else {
   i1 = HEAP8[i8 + 8 + 11 >> 0] | 0;
   i1 = i1 << 24 >> 24 < 0 ? HEAP32[i8 + 12 >> 2] | 0 : i1 & 255;
   i1 = (i1 >>> 0 < 128 ? 1 : 5) + i1 | 0;
  }
  i1 = i2 + i5 + (i2 >>> 0 < 128 ? 1 : 5) + i1 | 0;
 } else {
  i4 = HEAP32[gb + 1103788 >> 2] | 0;
  i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i4, i7, i6) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i1 = __Znwj(48) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i6);
   HEAP32[i1 + 28 >> 2] = 255;
   i2 = i1 + 36 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i4 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
   i4 = i4 + 8 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  }
  if (((HEAP32[i1 + 28 >> 2] | 0) + -253 | 0) >>> 0 < 2) i1 = 5; else {
   i4 = HEAP8[i1 + 36 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0 ? HEAP32[i1 + 40 >> 2] | 0 : i4 & 255;
   i1 = (i1 >>> 0 < 128 ? 1 : 5) + i1 | 0;
  }
  if (((HEAP32[i8 >> 2] | 0) + -253 | 0) >>> 0 < 2) i2 = 5; else {
   i2 = HEAP8[i8 + 8 + 11 >> 0] | 0;
   i2 = i2 << 24 >> 24 < 0 ? HEAP32[i8 + 12 >> 2] | 0 : i2 & 255;
   i2 = (i2 >>> 0 < 128 ? 1 : 5) + i2 | 0;
  }
  i1 = i5 - i1 + i2 | 0;
 }
 if (i1 >>> 0 > (HEAP32[gb + 1103832 >> 2] | 0) >>> 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[gb + 1544208 >> 0] = 1;
 HEAP32[gb + 1103828 >> 2] = i1;
 i4 = HEAP32[gb + 1103788 >> 2] | 0;
 i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i4, i7, i6) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(48) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i6);
  HEAP32[i1 + 28 >> 2] = 255;
  i2 = i1 + 36 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
  i7 = i4 + 8 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i5 = i8;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 36 | 0, i8 + 8 | 0) | 0;
 __ZN11PlayerPrefs4SyncEv();
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z22DeOptimizeIndexBuffersR4Mesh(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i29 + 32 | 0;
 i17 = i29 + 16 | 0;
 i27 = i29;
 i28 = i8 + 32 | 0;
 i11 = HEAP32[i28 >> 2] | 0;
 i26 = (HEAP32[i11 + 132 >> 2] | 0) - (HEAP32[i11 + 128 >> 2] | 0) | 0;
 i10 = (i26 | 0) / 52 | 0;
 i11 = HEAP32[i11 + 100 >> 2] | 0;
 if ((i26 | 0) <= 0) {
  STACKTOP = i29;
  return;
 }
 i12 = i17 + 4 | 0;
 i13 = i17 + 8 | 0;
 i14 = i17 + 12 | 0;
 i15 = i27 + 4 | 0;
 i16 = i27 + 8 | 0;
 i18 = i27 + 12 | 0;
 i19 = i9 + 4 | 0;
 i20 = i9 + 8 | 0;
 i21 = i9 + 12 | 0;
 i22 = i17 + 12 | 0;
 i23 = i9 + 4 | 0;
 i24 = i27 + 12 | 0;
 i25 = i9 + 4 | 0;
 i26 = i8 + 4 | 0;
 i7 = 0;
 do {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  i6 = HEAP32[i28 >> 2] | 0;
  switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i17, i7, i6 + 128 | 0, i6) | 0) {
  case 1:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i26 >> 2] | 0, 0, 0);
    break;
   }
  case 4:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i26 >> 2] | 0, 0, 0);
    break;
   }
  default:
   {}
  }
  HEAP32[i27 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i18 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  i1 = i4 - i5 >> 2;
  i3 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i2 = i3 - i6 >> 2;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i27, i1 - i2 | 0);
   i5 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i27 >> 2] | 0;
  } else if (i1 >>> 0 < i2 >>> 0) {
   i1 = i6 + (i1 << 2) | 0;
   if ((i3 | 0) == (i1 | 0)) i1 = i6; else {
    HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i1 = i6;
   }
  } else i1 = i6;
  HEAP32[i19 >> 2] = 16;
  i2 = __Znaj(64) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i21 >> 2] = 0;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = -1;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN22VertexCacheDeOptimizerIjLi16EE19DeOptimizeTrianglesEPjjPKjj(i9, i1, i11, i5, (i4 - i5 >> 2 >>> 0) / 3 | 0);
  i1 = HEAP32[i27 >> 2] | 0;
  __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i8, i1, (HEAP32[i15 >> 2] | 0) - i1 >> 2, i7, 0, 4) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
  i1 = HEAP32[i27 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i15 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i25 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  }
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i12 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i6 = HEAP32[i22 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i23 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i10 | 0));
 STACKTOP = i29;
 return;
}

function runPostSets132() {
 HEAP32[gb + 114124 >> 2] = fb + 1335;
 HEAP32[gb + 114128 >> 2] = fb + 1714;
 HEAP32[gb + 114132 >> 2] = fb + 1831;
 HEAP32[gb + 114144 >> 2] = fb + 1832;
 HEAP32[gb + 114148 >> 2] = fb + 1833;
 HEAP32[gb + 114152 >> 2] = fb + 1834;
 HEAP32[gb + 114156 >> 2] = fb + 276;
 HEAP32[gb + 114160 >> 2] = fb + 1835;
 HEAP32[gb + 114172 >> 2] = fb + 1836;
 HEAP32[gb + 114176 >> 2] = fb + 1837;
 HEAP32[gb + 114180 >> 2] = fb + 1834;
 HEAP32[gb + 114184 >> 2] = fb + 277;
 HEAP32[gb + 114188 >> 2] = fb + 1838;
 HEAP32[gb + 114192 >> 2] = fb + 1336;
 HEAP32[gb + 114196 >> 2] = fb + 353;
 HEAP32[gb + 114200 >> 2] = fb + 189;
 HEAP32[gb + 114204 >> 2] = fb + 1337;
 HEAP32[gb + 114208 >> 2] = fb + 888;
 HEAP32[gb + 114212 >> 2] = fb + 889;
 HEAP32[gb + 114216 >> 2] = fb + 1338;
 HEAP32[gb + 114220 >> 2] = fb + 1339;
 HEAP32[gb + 114224 >> 2] = fb + 890;
 HEAP32[gb + 114228 >> 2] = fb + 1340;
 HEAP32[gb + 114232 >> 2] = fb + 1839;
 HEAP32[gb + 114236 >> 2] = fb + 1840;
 HEAP32[gb + 114240 >> 2] = fb + 107;
 HEAP32[gb + 114244 >> 2] = fb + 108;
 HEAP32[gb + 114248 >> 2] = fb + 49;
 HEAP32[gb + 114252 >> 2] = fb + 50;
 HEAP32[gb + 114256 >> 2] = fb + 91;
 HEAP32[gb + 114260 >> 2] = fb + 2;
 HEAP32[gb + 114264 >> 2] = fb + 1841;
 HEAP32[gb + 114276 >> 2] = fb + 1842;
 HEAP32[gb + 114280 >> 2] = fb + 1843;
 HEAP32[gb + 114284 >> 2] = fb + 1341;
 HEAP32[gb + 114288 >> 2] = fb + 1342;
 HEAP32[gb + 114292 >> 2] = fb + 891;
 HEAP32[gb + 114296 >> 2] = fb + 892;
 HEAP32[gb + 114300 >> 2] = fb + 1844;
 HEAP32[gb + 114304 >> 2] = fb + 1343;
 HEAP32[gb + 114308 >> 2] = fb + 893;
 HEAP32[gb + 114312 >> 2] = fb + 354;
 HEAP32[gb + 114316 >> 2] = fb + 190;
 HEAP32[gb + 114320 >> 2] = fb + 1344;
 HEAP32[gb + 114332 >> 2] = fb + 1345;
 HEAP32[gb + 114336 >> 2] = fb + 1845;
 HEAP32[gb + 114340 >> 2] = fb + 1846;
 HEAP32[gb + 114352 >> 2] = fb + 1847;
 HEAP32[gb + 114356 >> 2] = fb + 1848;
 HEAP32[gb + 114360 >> 2] = fb + 109;
 HEAP32[gb + 114364 >> 2] = fb + 110;
 HEAP32[gb + 114368 >> 2] = fb + 51;
 HEAP32[gb + 114372 >> 2] = fb + 52;
 HEAP32[gb + 114376 >> 2] = fb + 92;
 HEAP32[gb + 114380 >> 2] = fb + 3;
 HEAP32[gb + 114392 >> 2] = fb + 1849;
 HEAP32[gb + 114396 >> 2] = fb + 1850;
 HEAP32[gb + 114400 >> 2] = fb + 1851;
 HEAP32[gb + 114412 >> 2] = fb + 1852;
 HEAP32[gb + 114416 >> 2] = fb + 1853;
 HEAP32[gb + 114420 >> 2] = fb + 278;
 HEAP32[gb + 114424 >> 2] = fb + 1854;
 HEAP32[gb + 114428 >> 2] = fb + 279;
 HEAP32[gb + 114432 >> 2] = fb + 280;
 HEAP32[gb + 114436 >> 2] = fb + 281;
 HEAP32[gb + 114440 >> 2] = fb + 282;
 HEAP32[gb + 114444 >> 2] = fb + 283;
 HEAP32[gb + 114448 >> 2] = fb + 284;
 HEAP32[gb + 114452 >> 2] = fb + 285;
 HEAP32[gb + 114464 >> 2] = fb + 1193;
 HEAP32[gb + 114468 >> 2] = fb + 1855;
 HEAP32[gb + 114472 >> 2] = fb + 894;
 HEAP32[gb + 114476 >> 2] = fb + 93;
 HEAP32[gb + 114480 >> 2] = fb + 94;
 HEAP32[gb + 114484 >> 2] = fb + 95;
 HEAP32[gb + 114488 >> 2] = fb + 79;
 HEAP32[gb + 114492 >> 2] = fb + 355;
 HEAP32[gb + 114504 >> 2] = fb + 1193;
 HEAP32[gb + 114508 >> 2] = fb + 1856;
 HEAP32[gb + 114512 >> 2] = fb + 895;
 HEAP32[gb + 114516 >> 2] = fb + 96;
 HEAP32[gb + 114520 >> 2] = fb + 97;
 HEAP32[gb + 114524 >> 2] = fb + 98;
 HEAP32[gb + 114528 >> 2] = fb + 80;
 HEAP32[gb + 114532 >> 2] = fb + 356;
 HEAP32[gb + 114544 >> 2] = fb + 1193;
 HEAP32[gb + 114548 >> 2] = fb + 1857;
 HEAP32[gb + 114552 >> 2] = fb + 896;
 HEAP32[gb + 114556 >> 2] = fb + 99;
 HEAP32[gb + 114560 >> 2] = fb + 100;
 HEAP32[gb + 114564 >> 2] = fb + 101;
 HEAP32[gb + 114568 >> 2] = fb + 81;
 HEAP32[gb + 114572 >> 2] = fb + 357;
 HEAP32[gb + 114584 >> 2] = fb + 1193;
 HEAP32[gb + 114588 >> 2] = fb + 1858;
 HEAP32[gb + 114592 >> 2] = fb + 897;
 HEAP32[gb + 114596 >> 2] = fb + 102;
 HEAP32[gb + 114600 >> 2] = fb + 103;
 HEAP32[gb + 114604 >> 2] = fb + 104;
 HEAP32[gb + 114608 >> 2] = fb + 82;
 runPostSets133();
}

function __ZN5physx17PxcNpMemBlockPoolD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv(i5);
 __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv(i5);
 __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv(i5);
 __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv(i5);
 __ZN5physx17PxcNpMemBlockPool23releaseConstraintMemoryEv(i5);
 __ZN5physx17PxcNpMemBlockPool15releaseContactsEv(i5);
 __ZN5physx17PxcNpMemBlockPool15releaseContactsEv(i5);
 i3 = i5 + 116 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 112 | 0;
  do {
   i8 = i1 + -1 | 0;
   i7 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   HEAP32[i3 >> 2] = i8;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i7);
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i8 = HEAP32[i5 + 120 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 112 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 108 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 100 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 96 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 88 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 84 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 76 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 72 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 64 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 60 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 52 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 48 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 40 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 36 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 24 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 16 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i8 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 STACKTOP = i6;
 return;
}

function __Z30CalculateBoxAreaRadialFrustum2P8Vector3ffff(i2, f3, f4, f5) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = 0;
 do {
  i11 = i6 + (i1 * 12 | 0) | 0;
  i8 = i2 + (i1 * 12 | 0) | 0;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  f13 = Math_fround(f12 * f12);
  i8 = i6 + (i1 * 12 | 0) + 4 | 0;
  f10 = Math_fround(HEAPF32[i8 >> 2]);
  f13 = Math_fround(f13 + Math_fround(f10 * f10));
  f9 = Math_fround(HEAPF32[i6 + (i1 * 12 | 0) + 8 >> 2]);
  f9 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f9 * f9)))) * f3) + f4)) * f5);
  HEAPF32[i11 >> 2] = Math_fround(f12 * f9);
  HEAPF32[i8 >> 2] = Math_fround(f10 * f9);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 f23 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f17 = Math_fround(f23 - f18);
 f22 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f17 = Math_fround(f17 * Math_fround(f22 + f20));
 f16 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f4 = Math_fround(f16 - f23);
 f24 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f4 = Math_fround(f4 * Math_fround(f22 + f24));
 f21 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f5 = Math_fround(f18 - f21);
 f19 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f20 + f19));
 f26 = Math_fround(HEAPF32[i6 + 84 >> 2]);
 f3 = Math_fround(f26 - f16);
 f13 = Math_fround(HEAPF32[i6 + 88 >> 2]);
 f3 = Math_fround(f3 * Math_fround(f24 + f13));
 f25 = Math_fround(HEAPF32[i6 + 72 >> 2]);
 f9 = Math_fround(f21 - f25);
 f12 = Math_fround(HEAPF32[i6 + 76 >> 2]);
 f9 = Math_fround(f9 * Math_fround(f19 + f12));
 f19 = Math_fround(Math_fround(f16 - f21) * Math_fround(f24 + f19));
 f24 = Math_fround(HEAPF32[i6 + 60 >> 2]);
 f21 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f16 = Math_fround(f24 - f21);
 f15 = Math_fround(HEAPF32[i6 + 64 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f16 = Math_fround(f16 * Math_fround(f15 + f10));
 f14 = Math_fround(Math_fround(f26 - f24) * Math_fround(f13 + f15));
 f13 = Math_fround(Math_fround(f25 - f26) * Math_fround(f13 + f12));
 f12 = Math_fround(Math_fround(f21 - f25) * Math_fround(f12 + f10));
 f15 = Math_fround(Math_fround(f24 - f23) * Math_fround(f22 + f15));
 f10 = Math_fround(Math_fround(f18 - f21) * Math_fround(f20 + f10));
 f20 = Math_fround(f5 + Math_fround(Math_fround(f17 + f4) - f19));
 i8 = f20 < Math_fround(0.0);
 f21 = Math_fround(-f20);
 f19 = Math_fround(f9 + Math_fround(Math_fround(f19 + f3) + f13));
 i11 = f19 < Math_fround(0.0);
 f18 = Math_fround(-f19);
 f19 = Math_fround((i8 ? f21 : f20) + (i11 ? f18 : f19));
 f13 = Math_fround(f12 + Math_fround(f13 + Math_fround(f14 + f16)));
 i11 = f13 < Math_fround(0.0);
 f18 = Math_fround(-f13);
 f13 = Math_fround(f19 + (i11 ? f18 : f13));
 f16 = Math_fround(f10 + Math_fround(Math_fround(f17 + f15) - f16));
 i11 = f16 < Math_fround(0.0);
 f17 = Math_fround(-f16);
 f13 = Math_fround((i11 ? f17 : f16) + f13);
 f4 = Math_fround(Math_fround(Math_fround(f15 + f14) - f3) - f4);
 i11 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 f13 = Math_fround((i11 ? f3 : f4) + f13);
 f12 = Math_fround(f5 + Math_fround(f9 + Math_fround(Math_fround(-f10) - f12)));
 i11 = f12 < Math_fround(0.0);
 f10 = Math_fround(-f12);
 f13 = Math_fround(Math_fround((i11 ? f10 : f12) + f13) * Math_fround(.5));
 STACKTOP = i7;
 return Math_fround(f13);
}

function __ZN9Heightmap23RecomputeInvalidPatchesER13dynamic_arrayIiLj4EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i16 = i13 + 16 | 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i13 + 4 | 0);
  HEAP32[i13 >> 2] = 0;
 }
 HEAP32[i13 >> 2] = 0;
 i17 = i13 + 12 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 i18 = i12 + 80 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) < 0) return;
 i14 = i12 + 24 | 0;
 i15 = i13 + 4 | 0;
 i11 = 0;
 while (1) {
  i10 = i1 - i11 | 0;
  i9 = 1 << i10;
  if ((i10 | 0) != 31) {
   i10 = (i11 | 0) > 0;
   i8 = 0;
   do {
    if (i10) {
     i7 = 0;
     do {
      i1 = 1 << HEAP32[i18 >> 2];
      i2 = 0;
      i3 = 0;
      do {
       i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
       i1 = i1 >> 1;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i11 | 0));
      i2 = i2 + i7 + (Math_imul(i1, i8) | 0) | 0;
      if (Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2]) == Math_fround(inf)) {
       f19 = Math_fround(__ZNK9Heightmap25ComputeMaximumHeightErrorEiii(i12, i7, i8, i11));
       HEAPF32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = f19;
       __ZN9Heightmap23RecalculateMinMaxHeightEiii(i12, i7, i8, i11);
       i3 = HEAP32[i17 >> 2] | 0;
       i4 = i3 + 1 | 0;
       i5 = HEAP32[i16 >> 2] | 0;
       i6 = i5 & 2147483647;
       do if (i4 >>> 0 > i6 >>> 0) {
        i1 = i5 << 1;
        i1 = (i1 | 0) == 0 ? 1 : i1;
        if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
         HEAP32[i16 >> 2] = i1;
         HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
         HEAP32[i16 >> 2] = i1;
         HEAP32[i13 >> 2] = i6;
         break;
        }
       } while (0);
       HEAP32[i17 >> 2] = i4;
       HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = i2;
      }
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) < (i9 | 0));
    } else {
     i1 = 0;
     do {
      i3 = i1 + (i8 << HEAP32[i18 >> 2]) | 0;
      if (Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + (i3 << 2) >> 2]) == Math_fround(inf)) {
       f19 = Math_fround(__ZNK9Heightmap25ComputeMaximumHeightErrorEiii(i12, i1, i8, i11));
       HEAPF32[(HEAP32[i14 >> 2] | 0) + (i3 << 2) >> 2] = f19;
       __ZN9Heightmap23RecalculateMinMaxHeightEiii(i12, i1, i8, i11);
       i4 = HEAP32[i17 >> 2] | 0;
       i5 = i4 + 1 | 0;
       i6 = HEAP32[i16 >> 2] | 0;
       i7 = i6 & 2147483647;
       do if (i5 >>> 0 > i7 >>> 0) {
        i2 = i6 << 1;
        i2 = (i2 | 0) == 0 ? 1 : i2;
        if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
         HEAP32[i16 >> 2] = i2;
         HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
         break;
        } else {
         i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
         _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i17 >> 2] << 2 | 0) | 0;
         HEAP32[i16 >> 2] = i2;
         HEAP32[i13 >> 2] = i7;
         break;
        }
       } while (0);
       HEAP32[i17 >> 2] = i5;
       HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] = i3;
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i9 | 0));
    }
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) < (i9 | 0));
  }
  i1 = HEAP32[i18 >> 2] | 0;
  if ((i1 | 0) <= (i11 | 0)) break; else i11 = i11 + 1 | 0;
 }
 return;
}

function runPostSets133() {
 HEAP32[gb + 114612 >> 2] = fb + 358;
 HEAP32[gb + 114624 >> 2] = fb + 1193;
 HEAP32[gb + 114628 >> 2] = fb + 1859;
 HEAP32[gb + 114632 >> 2] = fb + 898;
 HEAP32[gb + 114636 >> 2] = fb + 105;
 HEAP32[gb + 114640 >> 2] = fb + 106;
 HEAP32[gb + 114644 >> 2] = fb + 107;
 HEAP32[gb + 114648 >> 2] = fb + 83;
 HEAP32[gb + 114652 >> 2] = fb + 359;
 HEAP32[gb + 114664 >> 2] = fb + 1193;
 HEAP32[gb + 114668 >> 2] = fb + 1860;
 HEAP32[gb + 114672 >> 2] = fb + 899;
 HEAP32[gb + 114676 >> 2] = fb + 108;
 HEAP32[gb + 114680 >> 2] = fb + 109;
 HEAP32[gb + 114684 >> 2] = fb + 110;
 HEAP32[gb + 114688 >> 2] = fb + 84;
 HEAP32[gb + 114692 >> 2] = fb + 360;
 HEAP32[gb + 114704 >> 2] = fb + 1193;
 HEAP32[gb + 114708 >> 2] = fb + 1861;
 HEAP32[gb + 114712 >> 2] = fb + 900;
 HEAP32[gb + 114716 >> 2] = fb + 111;
 HEAP32[gb + 114720 >> 2] = fb + 112;
 HEAP32[gb + 114724 >> 2] = fb + 113;
 HEAP32[gb + 114728 >> 2] = fb + 85;
 HEAP32[gb + 114732 >> 2] = fb + 361;
 HEAP32[gb + 114744 >> 2] = fb + 1193;
 HEAP32[gb + 114748 >> 2] = fb + 1862;
 HEAP32[gb + 114752 >> 2] = fb + 901;
 HEAP32[gb + 114756 >> 2] = fb + 114;
 HEAP32[gb + 114760 >> 2] = fb + 115;
 HEAP32[gb + 114764 >> 2] = fb + 116;
 HEAP32[gb + 114768 >> 2] = fb + 86;
 HEAP32[gb + 114772 >> 2] = fb + 362;
 HEAP32[gb + 114784 >> 2] = fb + 902;
 HEAP32[gb + 114788 >> 2] = fb + 286;
 HEAP32[gb + 114792 >> 2] = fb + 903;
 HEAP32[gb + 114796 >> 2] = fb + 287;
 HEAP32[gb + 114800 >> 2] = fb + 288;
 HEAP32[gb + 114804 >> 2] = fb + 289;
 HEAP32[gb + 114808 >> 2] = fb + 904;
 HEAP32[gb + 114812 >> 2] = fb + 191;
 HEAP32[gb + 114816 >> 2] = fb + 1863;
 HEAP32[gb + 114820 >> 2] = fb + 1864;
 HEAP32[gb + 114832 >> 2] = fb + 905;
 HEAP32[gb + 114836 >> 2] = fb + 290;
 HEAP32[gb + 114840 >> 2] = fb + 906;
 HEAP32[gb + 114844 >> 2] = fb + 291;
 HEAP32[gb + 114848 >> 2] = fb + 292;
 HEAP32[gb + 114852 >> 2] = fb + 293;
 HEAP32[gb + 114856 >> 2] = fb + 907;
 HEAP32[gb + 114860 >> 2] = fb + 192;
 HEAP32[gb + 114864 >> 2] = fb + 1863;
 HEAP32[gb + 114868 >> 2] = fb + 1865;
 HEAP32[gb + 114880 >> 2] = fb + 908;
 HEAP32[gb + 114884 >> 2] = fb + 294;
 HEAP32[gb + 114888 >> 2] = fb + 909;
 HEAP32[gb + 114892 >> 2] = fb + 295;
 HEAP32[gb + 114896 >> 2] = fb + 296;
 HEAP32[gb + 114900 >> 2] = fb + 297;
 HEAP32[gb + 114904 >> 2] = fb + 910;
 HEAP32[gb + 114908 >> 2] = fb + 193;
 HEAP32[gb + 114912 >> 2] = fb + 1863;
 HEAP32[gb + 114916 >> 2] = fb + 1866;
 HEAP32[gb + 114928 >> 2] = fb + 911;
 HEAP32[gb + 114932 >> 2] = fb + 298;
 HEAP32[gb + 114936 >> 2] = fb + 912;
 HEAP32[gb + 114940 >> 2] = fb + 299;
 HEAP32[gb + 114944 >> 2] = fb + 300;
 HEAP32[gb + 114948 >> 2] = fb + 301;
 HEAP32[gb + 114952 >> 2] = fb + 913;
 HEAP32[gb + 114956 >> 2] = fb + 194;
 HEAP32[gb + 114960 >> 2] = fb + 1863;
 HEAP32[gb + 114964 >> 2] = fb + 1867;
 HEAP32[gb + 114976 >> 2] = fb + 914;
 HEAP32[gb + 114980 >> 2] = fb + 302;
 HEAP32[gb + 114984 >> 2] = fb + 915;
 HEAP32[gb + 114988 >> 2] = fb + 303;
 HEAP32[gb + 114992 >> 2] = fb + 304;
 HEAP32[gb + 114996 >> 2] = fb + 305;
 HEAP32[gb + 115e3 >> 2] = fb + 916;
 HEAP32[gb + 115004 >> 2] = fb + 195;
 HEAP32[gb + 115008 >> 2] = fb + 1863;
 HEAP32[gb + 115012 >> 2] = fb + 1868;
 HEAP32[gb + 115024 >> 2] = fb + 917;
 HEAP32[gb + 115028 >> 2] = fb + 306;
 HEAP32[gb + 115032 >> 2] = fb + 918;
 HEAP32[gb + 115036 >> 2] = fb + 307;
 HEAP32[gb + 115040 >> 2] = fb + 308;
 HEAP32[gb + 115044 >> 2] = fb + 309;
 HEAP32[gb + 115048 >> 2] = fb + 919;
 HEAP32[gb + 115052 >> 2] = fb + 196;
 HEAP32[gb + 115056 >> 2] = fb + 1863;
 HEAP32[gb + 115060 >> 2] = fb + 1869;
 HEAP32[gb + 115072 >> 2] = fb + 1870;
 HEAP32[gb + 115076 >> 2] = fb + 1871;
 HEAP32[gb + 115080 >> 2] = fb + 1346;
 HEAP32[gb + 115092 >> 2] = fb + 1870;
 HEAP32[gb + 115096 >> 2] = fb + 1872;
 HEAP32[gb + 115100 >> 2] = fb + 1347;
 HEAP32[gb + 115112 >> 2] = fb + 1870;
 runPostSets134();
}

function runPostSets111() {
 HEAP32[gb + 100776 >> 2] = fb + 93;
 HEAP32[gb + 100780 >> 2] = fb + 1;
 HEAP32[gb + 100784 >> 2] = fb + 2;
 HEAP32[gb + 100788 >> 2] = fb + 1;
 HEAP32[gb + 100792 >> 2] = fb + 310;
 HEAP32[gb + 100796 >> 2] = fb + 155;
 HEAP32[gb + 100800 >> 2] = fb + 1110;
 HEAP32[gb + 100804 >> 2] = fb + 1111;
 HEAP32[gb + 100808 >> 2] = fb + 1112;
 HEAP32[gb + 100812 >> 2] = fb + 1113;
 HEAP32[gb + 100816 >> 2] = fb + 116;
 HEAP32[gb + 100820 >> 2] = fb + 142;
 HEAP32[gb + 100824 >> 2] = fb + 1114;
 HEAP32[gb + 100828 >> 2] = fb + 722;
 HEAP32[gb + 100832 >> 2] = fb + 143;
 HEAP32[gb + 100836 >> 2] = fb + 144;
 HEAP32[gb + 100840 >> 2] = fb + 145;
 HEAP32[gb + 100844 >> 2] = fb + 1115;
 HEAP32[gb + 100848 >> 2] = fb + 723;
 HEAP32[gb + 100852 >> 2] = fb + 1;
 HEAP32[gb + 100856 >> 2] = fb + 11;
 HEAP32[gb + 100860 >> 2] = fb + 1116;
 HEAP32[gb + 100864 >> 2] = fb + 724;
 HEAP32[gb + 100868 >> 2] = fb + 725;
 HEAP32[gb + 100872 >> 2] = fb + 1117;
 HEAP32[gb + 100876 >> 2] = fb + 726;
 HEAP32[gb + 100880 >> 2] = fb + 727;
 HEAP32[gb + 100884 >> 2] = fb + 1410;
 HEAP32[gb + 100888 >> 2] = fb + 311;
 HEAP32[gb + 100892 >> 2] = fb + 156;
 HEAP32[gb + 100896 >> 2] = fb + 1118;
 HEAP32[gb + 100900 >> 2] = fb + 728;
 HEAP32[gb + 100904 >> 2] = fb + 219;
 HEAP32[gb + 100908 >> 2] = fb + 1;
 HEAP32[gb + 100912 >> 2] = fb + 1;
 HEAP32[gb + 100916 >> 2] = fb + 77;
 HEAP32[gb + 100920 >> 2] = fb + 729;
 HEAP32[gb + 100924 >> 2] = fb + 730;
 HEAP32[gb + 100928 >> 2] = fb + 312;
 HEAP32[gb + 100932 >> 2] = fb + 731;
 HEAP32[gb + 100936 >> 2] = fb + 92;
 HEAP32[gb + 100940 >> 2] = fb + 157;
 HEAP32[gb + 100944 >> 2] = fb + 313;
 HEAP32[gb + 100948 >> 2] = fb + 732;
 HEAP32[gb + 100952 >> 2] = fb + 220;
 HEAP32[gb + 100956 >> 2] = fb + 1411;
 HEAP32[gb + 100960 >> 2] = fb + 221;
 HEAP32[gb + 100964 >> 2] = fb + 1412;
 HEAP32[gb + 100968 >> 2] = fb + 1119;
 HEAP32[gb + 100972 >> 2] = fb + 733;
 HEAP32[gb + 100976 >> 2] = fb + 734;
 HEAP32[gb + 100980 >> 2] = fb + 735;
 HEAP32[gb + 100984 >> 2] = fb + 1120;
 HEAP32[gb + 100988 >> 2] = fb + 736;
 HEAP32[gb + 100992 >> 2] = fb + 146;
 HEAP32[gb + 100996 >> 2] = fb + 1121;
 HEAP32[gb + 101e3 >> 2] = fb + 314;
 HEAP32[gb + 101004 >> 2] = fb + 737;
 HEAP32[gb + 101016 >> 2] = fb + 1125;
 HEAP32[gb + 101020 >> 2] = fb + 1413;
 HEAP32[gb + 101024 >> 2] = fb + 1258;
 HEAP32[gb + 101028 >> 2] = fb + 738;
 HEAP32[gb + 101032 >> 2] = fb + 1127;
 HEAP32[gb + 101036 >> 2] = fb + 1128;
 HEAP32[gb + 101040 >> 2] = fb + 469;
 HEAP32[gb + 101044 >> 2] = fb + 1414;
 HEAP32[gb + 101048 >> 2] = fb + 1415;
 HEAP32[gb + 101060 >> 2] = fb + 1125;
 HEAP32[gb + 101064 >> 2] = fb + 1416;
 HEAP32[gb + 101068 >> 2] = fb + 1258;
 HEAP32[gb + 101072 >> 2] = fb + 739;
 HEAP32[gb + 101076 >> 2] = fb + 1127;
 HEAP32[gb + 101080 >> 2] = fb + 1128;
 HEAP32[gb + 101084 >> 2] = fb + 469;
 HEAP32[gb + 101088 >> 2] = fb + 1129;
 HEAP32[gb + 101092 >> 2] = fb + 1417;
 HEAP32[gb + 101104 >> 2] = fb + 1125;
 HEAP32[gb + 101108 >> 2] = fb + 1418;
 HEAP32[gb + 101112 >> 2] = fb + 1258;
 HEAP32[gb + 101116 >> 2] = fb + 740;
 HEAP32[gb + 101120 >> 2] = fb + 1127;
 HEAP32[gb + 101124 >> 2] = fb + 1128;
 HEAP32[gb + 101128 >> 2] = fb + 469;
 HEAP32[gb + 101132 >> 2] = fb + 1129;
 HEAP32[gb + 101136 >> 2] = fb + 1419;
 HEAP32[gb + 101148 >> 2] = fb + 1125;
 HEAP32[gb + 101152 >> 2] = fb + 1420;
 HEAP32[gb + 101156 >> 2] = fb + 1258;
 HEAP32[gb + 101160 >> 2] = fb + 741;
 HEAP32[gb + 101164 >> 2] = fb + 1127;
 HEAP32[gb + 101168 >> 2] = fb + 1128;
 HEAP32[gb + 101172 >> 2] = fb + 469;
 HEAP32[gb + 101176 >> 2] = fb + 1129;
 HEAP32[gb + 101180 >> 2] = fb + 1421;
 HEAP32[gb + 101192 >> 2] = fb + 1422;
 HEAP32[gb + 101196 >> 2] = fb + 1423;
 HEAP32[gb + 101200 >> 2] = fb + 222;
 HEAP32[gb + 101204 >> 2] = fb + 3;
 HEAP32[gb + 101208 >> 2] = fb + 1;
 HEAP32[gb + 101212 >> 2] = fb + 2;
 runPostSets112();
}

function __ZN7mecanim9animation20CreateAvatarConstantEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEES8_PNS_5human5HumanES3_iRKS6_RNS_6memory9AllocatorE(i11, i1, i2, i3, i4, i5, i6, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i12 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, 100, 4) | 0;
 i18 = i12 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 i18 = i12 + 44 | 0;
 i15 = i12 + 72 | 0;
 i16 = i12 + 68 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i16 >> 2] = 1065353216;
 HEAP32[i15 >> 2] = 1065353216;
 i14 = i12 + 76 | 0;
 HEAP32[i14 >> 2] = 1065353216;
 i13 = i12 + 80 | 0;
 HEAP32[i13 >> 2] = 1065353216;
 i8 = i12 + 84 | 0;
 i9 = i12 + 88 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i9 = i12;
 HEAP32[i12 >> 2] = i11 | 0 ? i11 - i9 | 0 : 0;
 i7 = i12 + 4 | 0;
 HEAP32[i7 >> 2] = i1 | 0 ? i1 - i7 | 0 : 0;
 i7 = i12 + 8 | 0;
 HEAP32[i7 >> 2] = i2 | 0 ? i2 - i7 | 0 : 0;
 i7 = i12 + 20 | 0;
 HEAP32[i7 >> 2] = i3 | 0 ? i3 - i7 | 0 : 0;
 i7 = i8;
 HEAP32[i8 >> 2] = i4 | 0 ? i4 - i7 | 0 : 0;
 HEAP32[i12 + 40 >> 2] = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i17 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 48 >> 2] = i2;
 HEAP32[i12 + 52 >> 2] = i17;
 i17 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 HEAP32[i12 + 56 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i12 + 60 >> 2] = i17;
 HEAP32[i12 + 64 >> 2] = i2;
 HEAP32[i16 >> 2] = i1;
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 i2 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i14 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 if (!i3) {
  if ((i5 | 0) == -1) return i12 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i12 + 92 >> 2] = i2;
  i4 = i12 + 96 | 0;
  if (!i2) i1 = 0; else {
   i3 = i2 << 2;
   i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i3 | 0, 4) | 0;
   if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  }
  i17 = i4;
  i16 = i1 | 0 ? i1 - i17 | 0 : 0;
  HEAP32[i4 >> 2] = i16;
  i18 = HEAP32[i8 >> 2] | 0;
  __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_((i16 | 0) == 0 ? 0 : i16 + i17 | 0, (i18 | 0) == 0 ? 0 : i18 + i7 | 0, i11);
  return i12 | 0;
 }
 i6 = i3 + 40 | 0;
 i7 = i6;
 i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + i7 >> 2] | 0;
 HEAP32[i12 + 24 >> 2] = i2;
 i8 = i12 + 28 | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i5 = i8;
 i4 = i1 | 0 ? i1 - i5 | 0 : 0;
 HEAP32[i8 >> 2] = i4;
 i2 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_((i4 | 0) == 0 ? 0 : i4 + i5 | 0, (i2 | 0) == 0 ? 0 : i2 + i7 | 0, i11);
 i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + i9 >> 2] | 0;
 HEAP32[i12 + 32 >> 2] = i2;
 i4 = i12 + 36 | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i16 = i4;
 i15 = i1 | 0 ? i1 - i16 | 0 : 0;
 HEAP32[i4 >> 2] = i15;
 i17 = HEAP32[i8 >> 2] | 0;
 i18 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim8skeleton30SkeletonBuildReverseIndexArrayEPiPKiPKNS0_8SkeletonES6_((i15 | 0) == 0 ? 0 : i15 + i16 | 0, (i17 | 0) == 0 ? 0 : i17 + i5 | 0, (i18 | 0) == 0 ? 0 : i18 + i7 | 0, i11);
 return i12 | 0;
}

function __Z38GeomOverlapCallback_CapsuleHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 20 | 0;
 i7 = i1;
 f18 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i5 + 4 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i5 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i5 + 16 >> 2]));
 f9 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i5 + 20 >> 2]));
 f20 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f19 = Math_fround(f19 * Math_fround(2.0));
 f9 = Math_fround(f9 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i5 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f12 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f9 * f15)) + Math_fround(f20 * f10));
 f11 = Math_fround(Math_fround(f12 * f18) + Math_fround(Math_fround(f16 * f19) + Math_fround(f21 * Math_fround(Math_fround(f20 * f15) - Math_fround(f9 * f10)))));
 f13 = Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f16 * f9) + Math_fround(f21 * Math_fround(Math_fround(f19 * f10) - Math_fround(f20 * f18)))));
 f12 = Math_fround(Math_fround(Math_fround(f16 * f20) + Math_fround(f21 * Math_fround(Math_fround(f9 * f18) - Math_fround(f19 * f15)))) + Math_fround(f12 * f10));
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(f21 * f19);
 f20 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f20 * f18));
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f16 * f15));
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f17 * f10));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(f20 * f15) + Math_fround(f21 * f17))) - Math_fround(f16 * f18));
 f14 = Math_fround(Math_fround(Math_fround(f17 * f18) + Math_fround(Math_fround(f20 * f10) + Math_fround(f21 * f16))) - Math_fround(f19 * f15));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f15)) - Math_fround(f16 * f10));
 f16 = Math_fround(f9 * Math_fround(2.0));
 f15 = Math_fround(f10 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f9 * f16) + Math_fround(Math_fround(f10 * f15) + Math_fround(-1.0)));
 f9 = Math_fround(Math_fround(f14 * f15) + Math_fround(f16 * f8));
 f8 = Math_fround(Math_fround(f16 * f14) - Math_fround(f15 * f8));
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f15 * f10);
 f9 = Math_fround(f15 * f9);
 f8 = Math_fround(f15 * f8);
 f15 = Math_fround(f13 + f9);
 f14 = Math_fround(f12 + f8);
 HEAPF32[i6 >> 2] = Math_fround(f11 + f10);
 HEAPF32[i6 + 4 >> 2] = f15;
 HEAPF32[i6 + 8 >> 2] = f14;
 f9 = Math_fround(f13 - f9);
 f8 = Math_fround(f12 - f8);
 HEAPF32[i6 + 12 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i6 + 16 >> 2] = f9;
 HEAPF32[i6 + 20 >> 2] = f8;
 HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 i5 = __ZN5physx2Gu27intersectHeightFieldCapsuleERKNS0_15HeightFieldUtilERKNS0_7CapsuleE(i7, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN12FlareManager9AddCameraER6Camera(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i4;
 i6 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) {
  HEAP32[i9 >> 2] = i6;
  i2 = i6;
  i3 = i6;
  i5 = 11;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 4;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i5 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i5 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 4) {
   HEAP32[i9 >> 2] = i1;
   i2 = i1;
   i3 = i1;
   i5 = 11;
   break;
  } else if ((i5 | 0) == 8) {
   HEAP32[i9 >> 2] = i1;
   i2 = i1;
   i5 = 11;
   break;
  } else if ((i5 | 0) == 10) {
   HEAP32[i9 >> 2] = i1;
   if (!i1) {
    i2 = i1;
    i3 = i9;
    i5 = 11;
    break;
   } else break;
  }
 } while (0);
 if ((i5 | 0) == 11) {
  i1 = __Znwj(32) | 0;
  HEAP32[i1 + 16 >> 2] = i7;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i8 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i2);
  i5 = i8 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZNSt3__26vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i1 + 20 | 0, 0, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) {
  HEAP32[i9 >> 2] = i6;
  i4 = i6;
  i2 = i6;
  i5 = 24;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 17;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i5 = 23;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i5 = 21;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 17) {
   HEAP32[i9 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   i5 = 24;
   break;
  } else if ((i5 | 0) == 21) {
   HEAP32[i9 >> 2] = i1;
   i4 = i1;
   i2 = i3;
   i5 = 24;
   break;
  } else if ((i5 | 0) == 23) {
   HEAP32[i9 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i2 = i9;
    i5 = 24;
    break;
   } else break;
  }
 } while (0);
 if ((i5 | 0) == 24) {
  i3 = __Znwj(32) | 0;
  HEAP32[i3 + 16 >> 2] = i7;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = i4;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (!i1) i1 = i3; else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
  i1 = i8 + 8 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i3;
 }
 i6 = i1 + 20 | 0;
 i3 = ((HEAP32[i8 + 16 >> 2] | 0) - (HEAP32[i8 + 12 >> 2] | 0) | 0) / 52 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i4 = i1 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i5 - i1 >> 2;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEjRKf(i6, i3 - i2 | 0, i9);
  STACKTOP = i10;
  return;
 }
 if (i3 >>> 0 >= i2 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i1 = i1 + (i3 << 2) | 0;
 if ((i5 | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
 STACKTOP = i10;
 return;
}

function runPostSets148() {
 HEAP32[gb + 139204 >> 2] = fb + 922;
 HEAP32[gb + 139208 >> 2] = fb + 198;
 HEAP32[gb + 139212 >> 2] = fb + 1863;
 HEAP32[gb + 139216 >> 2] = fb + 1884;
 HEAP32[gb + 139228 >> 2] = fb + 923;
 HEAP32[gb + 139232 >> 2] = fb + 314;
 HEAP32[gb + 139236 >> 2] = fb + 924;
 HEAP32[gb + 139240 >> 2] = fb + 315;
 HEAP32[gb + 139244 >> 2] = fb + 316;
 HEAP32[gb + 139248 >> 2] = fb + 317;
 HEAP32[gb + 139252 >> 2] = fb + 925;
 HEAP32[gb + 139256 >> 2] = fb + 199;
 HEAP32[gb + 139260 >> 2] = fb + 1863;
 HEAP32[gb + 139264 >> 2] = fb + 1885;
 HEAP32[gb + 139276 >> 2] = fb + 926;
 HEAP32[gb + 139280 >> 2] = fb + 318;
 HEAP32[gb + 139284 >> 2] = fb + 927;
 HEAP32[gb + 139288 >> 2] = fb + 319;
 HEAP32[gb + 139292 >> 2] = fb + 320;
 HEAP32[gb + 139296 >> 2] = fb + 321;
 HEAP32[gb + 139300 >> 2] = fb + 928;
 HEAP32[gb + 139304 >> 2] = fb + 200;
 HEAP32[gb + 139308 >> 2] = fb + 1863;
 HEAP32[gb + 139312 >> 2] = fb + 1886;
 HEAP32[gb + 139324 >> 2] = fb + 929;
 HEAP32[gb + 139328 >> 2] = fb + 322;
 HEAP32[gb + 139332 >> 2] = fb + 930;
 HEAP32[gb + 139336 >> 2] = fb + 323;
 HEAP32[gb + 139340 >> 2] = fb + 324;
 HEAP32[gb + 139344 >> 2] = fb + 325;
 HEAP32[gb + 139348 >> 2] = fb + 931;
 HEAP32[gb + 139352 >> 2] = fb + 201;
 HEAP32[gb + 139356 >> 2] = fb + 1863;
 HEAP32[gb + 139360 >> 2] = fb + 1887;
 HEAP32[gb + 139372 >> 2] = fb + 932;
 HEAP32[gb + 139376 >> 2] = fb + 326;
 HEAP32[gb + 139380 >> 2] = fb + 933;
 HEAP32[gb + 139384 >> 2] = fb + 327;
 HEAP32[gb + 139388 >> 2] = fb + 328;
 HEAP32[gb + 139392 >> 2] = fb + 329;
 HEAP32[gb + 139396 >> 2] = fb + 934;
 HEAP32[gb + 139400 >> 2] = fb + 202;
 HEAP32[gb + 139404 >> 2] = fb + 1863;
 HEAP32[gb + 139408 >> 2] = fb + 1888;
 HEAP32[gb + 139420 >> 2] = fb + 935;
 HEAP32[gb + 139424 >> 2] = fb + 330;
 HEAP32[gb + 139428 >> 2] = fb + 936;
 HEAP32[gb + 139432 >> 2] = fb + 331;
 HEAP32[gb + 139436 >> 2] = fb + 332;
 HEAP32[gb + 139440 >> 2] = fb + 333;
 HEAP32[gb + 139444 >> 2] = fb + 937;
 HEAP32[gb + 139448 >> 2] = fb + 203;
 HEAP32[gb + 139452 >> 2] = fb + 1863;
 HEAP32[gb + 139456 >> 2] = fb + 1889;
 HEAP32[gb + 139468 >> 2] = fb + 938;
 HEAP32[gb + 139472 >> 2] = fb + 334;
 HEAP32[gb + 139476 >> 2] = fb + 939;
 HEAP32[gb + 139480 >> 2] = fb + 335;
 HEAP32[gb + 139484 >> 2] = fb + 336;
 HEAP32[gb + 139488 >> 2] = fb + 337;
 HEAP32[gb + 139492 >> 2] = fb + 940;
 HEAP32[gb + 139496 >> 2] = fb + 204;
 HEAP32[gb + 139500 >> 2] = fb + 1863;
 HEAP32[gb + 139504 >> 2] = fb + 1890;
 HEAP32[gb + 139516 >> 2] = fb + 941;
 HEAP32[gb + 139520 >> 2] = fb + 338;
 HEAP32[gb + 139524 >> 2] = fb + 942;
 HEAP32[gb + 139528 >> 2] = fb + 339;
 HEAP32[gb + 139532 >> 2] = fb + 340;
 HEAP32[gb + 139536 >> 2] = fb + 341;
 HEAP32[gb + 139540 >> 2] = fb + 943;
 HEAP32[gb + 139544 >> 2] = fb + 205;
 HEAP32[gb + 139548 >> 2] = fb + 1863;
 HEAP32[gb + 139552 >> 2] = fb + 1891;
 HEAP32[gb + 139564 >> 2] = fb + 944;
 HEAP32[gb + 139568 >> 2] = fb + 342;
 HEAP32[gb + 139572 >> 2] = fb + 945;
 HEAP32[gb + 139576 >> 2] = fb + 343;
 HEAP32[gb + 139580 >> 2] = fb + 344;
 HEAP32[gb + 139584 >> 2] = fb + 345;
 HEAP32[gb + 139588 >> 2] = fb + 946;
 HEAP32[gb + 139592 >> 2] = fb + 206;
 HEAP32[gb + 139596 >> 2] = fb + 1863;
 HEAP32[gb + 139600 >> 2] = fb + 1892;
 HEAP32[gb + 139612 >> 2] = fb + 947;
 HEAP32[gb + 139616 >> 2] = fb + 346;
 HEAP32[gb + 139620 >> 2] = fb + 948;
 HEAP32[gb + 139624 >> 2] = fb + 347;
 HEAP32[gb + 139628 >> 2] = fb + 348;
 HEAP32[gb + 139632 >> 2] = fb + 349;
 HEAP32[gb + 139636 >> 2] = fb + 949;
 HEAP32[gb + 139640 >> 2] = fb + 207;
 HEAP32[gb + 139644 >> 2] = fb + 1863;
 HEAP32[gb + 139648 >> 2] = fb + 1893;
 HEAP32[gb + 139660 >> 2] = fb + 950;
 HEAP32[gb + 139664 >> 2] = fb + 350;
 HEAP32[gb + 139668 >> 2] = fb + 951;
 HEAP32[gb + 139672 >> 2] = fb + 351;
 HEAP32[gb + 139676 >> 2] = fb + 352;
 HEAP32[gb + 139680 >> 2] = fb + 353;
 runPostSets149();
}

function __ZN5physx23performBoxPruningNewOldERKNS_2Gu4AxesEPKjjS5_jPjS6_PPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_(i1, i23, i22, i25, i24, i20, i21, i15, i16, i26, i17, i19, i18) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i26 = i26 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i27 = 0, i28 = 0;
 if (!((i22 | 0) != 0 & (i24 | 0) != 0)) return;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i14 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i15 + (i12 << 2) >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i20 + (i2 << 2) >> 2] = HEAP32[i1 + (HEAP32[i23 + (i2 << 2) >> 2] << 3) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i22 | 0));
 i1 = HEAP32[i15 + (i12 << 2) >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i21 + (i2 << 2) >> 2] = HEAP32[i1 + (HEAP32[i25 + (i2 << 2) >> 2] << 3) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i24 | 0));
 i6 = HEAP32[i15 + (i12 << 2) >> 2] | 0;
 i7 = i15 + (i13 << 2) | 0;
 i8 = i15 + (i14 << 2) | 0;
 i1 = 0;
 i11 = 0;
 do {
  i9 = HEAP32[i23 + (i11 << 2) >> 2] | 0;
  i10 = HEAP32[i6 + (i9 << 3) + 4 >> 2] | 0;
  L12 : do if (i1 >>> 0 < i24 >>> 0) {
   i2 = HEAP32[i20 + (i11 << 2) >> 2] | 0;
   do {
    if ((HEAP32[i21 + (i1 << 2) >> 2] | 0) >>> 0 >= i2 >>> 0) break L12;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i24 >>> 0);
  } while (0);
  i11 = i11 + 1 | 0;
  i2 = i1 >>> 0 < i24 >>> 0;
  if (!i2) break;
  i3 = i16 + (i9 << 2) | 0;
  i5 = i1;
  do {
   if ((HEAP32[i21 + (i5 << 2) >> 2] | 0) >>> 0 > i10 >>> 0) break;
   i4 = HEAP32[i25 + (i5 << 2) >> 2] | 0;
   i5 = i5 + 1 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i16 + (i4 << 2) >> 2] | 0)) {
    i28 = HEAP32[i7 >> 2] | 0;
    i27 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[i27 + (i4 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i27 + (i9 << 3) >> 2] | 0) >>> 0 & ((((HEAP32[i28 + (i9 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i28 + (i4 << 3) >> 2] | 0) >>> 0 ? 1 : (HEAP32[i28 + (i4 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i28 + (i9 << 3) >> 2] | 0) >>> 0) | (HEAP32[i27 + (i9 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i27 + (i4 << 3) >> 2] | 0) >>> 0) ^ 1)) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i9, i4, i26, i17, i19, i18) | 0;
   }
  } while (i5 >>> 0 < i24 >>> 0);
 } while (i11 >>> 0 < i22 >>> 0 & i2);
 i11 = HEAP32[i15 + (i12 << 2) >> 2] | 0;
 i10 = i15 + (i13 << 2) | 0;
 i6 = i15 + (i14 << 2) | 0;
 i1 = 0;
 i9 = 0;
 while (1) {
  i7 = HEAP32[i25 + (i9 << 2) >> 2] | 0;
  i8 = HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0;
  L30 : do if (i1 >>> 0 < i22 >>> 0) {
   i2 = HEAP32[i21 + (i9 << 2) >> 2] | 0;
   do {
    if ((HEAP32[i20 + (i1 << 2) >> 2] | 0) >>> 0 > i2 >>> 0) break L30;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i22 >>> 0);
  } while (0);
  i9 = i9 + 1 | 0;
  i3 = i1 >>> 0 < i22 >>> 0;
  if (!i3) {
   i1 = 32;
   break;
  }
  i4 = i16 + (i7 << 2) | 0;
  i5 = i1;
  do {
   if ((HEAP32[i20 + (i5 << 2) >> 2] | 0) >>> 0 > i8 >>> 0) break;
   i2 = HEAP32[i23 + (i5 << 2) >> 2] | 0;
   i5 = i5 + 1 | 0;
   if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i16 + (i2 << 2) >> 2] | 0)) {
    i27 = HEAP32[i10 >> 2] | 0;
    i28 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i28 + (i2 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i28 + (i7 << 3) >> 2] | 0) >>> 0 & ((((HEAP32[i27 + (i7 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i27 + (i2 << 3) >> 2] | 0) >>> 0 ? 1 : (HEAP32[i27 + (i2 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i27 + (i7 << 3) >> 2] | 0) >>> 0) | (HEAP32[i28 + (i7 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i28 + (i2 << 3) >> 2] | 0) >>> 0) ^ 1)) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i7, i2, i26, i17, i19, i18) | 0;
   }
  } while (i5 >>> 0 < i22 >>> 0);
  if (!(i9 >>> 0 < i24 >>> 0 & i3)) {
   i1 = 32;
   break;
  }
 }
 if ((i1 | 0) == 32) return;
}

function __ZN14RenderSettings14ApplyFogParamsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, i13 = 0;
 i12 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i11 + 312 >> 0] | 0)) i13 = 0; else i13 = HEAP32[i11 + 316 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i11 + 344 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 336 >> 2]);
 f6 = Math_fround(HEAPF32[i11 + 340 >> 2]);
 if (!i13) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(1.0e4);
  f6 = Math_fround(2.0e4);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f10 = Math_fround(0.0);
 } else {
  i5 = (i13 | 0) == 1;
  f10 = Math_fround(f6 - f4);
  f10 = i5 ? f10 : Math_fround(0.0);
  i2 = f10 < Math_fround(0.0);
  f7 = Math_fround(-f10);
  i2 = (i2 ? f7 : f10) > Math_fround(.0000999999974);
  f10 = Math_fround(Math_fround(1.0) / f10);
  f10 = i2 ? f10 : Math_fround(0.0);
  f7 = Math_fround(f3 * Math_fround(1.2011224));
  f8 = Math_fround(f3 * Math_fround(1.44269502));
  f9 = Math_fround(-f10);
  f9 = i5 ? f9 : Math_fround(0.0);
  f10 = Math_fround(f6 * f10);
  f10 = i5 ? f10 : Math_fround(0.0);
 }
 HEAPF32[i12 + 1268 >> 2] = f4;
 HEAPF32[i12 + 1272 >> 2] = f4;
 HEAPF32[i12 + 1276 >> 2] = f4;
 HEAPF32[i12 + 1280 >> 2] = f4;
 HEAPF32[i12 + 1284 >> 2] = f6;
 HEAPF32[i12 + 1288 >> 2] = f6;
 HEAPF32[i12 + 1292 >> 2] = f6;
 HEAPF32[i12 + 1296 >> 2] = f6;
 HEAPF32[i12 + 1300 >> 2] = f3;
 HEAPF32[i12 + 1304 >> 2] = f3;
 HEAPF32[i12 + 1308 >> 2] = f3;
 HEAPF32[i12 + 1312 >> 2] = f3;
 HEAPF32[i12 + 1332 >> 2] = f7;
 HEAPF32[i12 + 1336 >> 2] = f8;
 HEAPF32[i12 + 1340 >> 2] = f9;
 HEAPF32[i12 + 1344 >> 2] = f10;
 i1 = i11 + 320 | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  do if (!(f3 <= Math_fround(.0404499993))) {
   if (f3 < Math_fround(1.0)) {
    f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f3 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f3, 2.20000005));
  } else f6 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
  f3 = Math_fround(HEAPF32[i11 + 324 >> 2]);
  do if (!(f3 <= Math_fround(.0404499993))) {
   if (f3 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f3 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f3, 2.20000005));
  } else f4 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
  f3 = Math_fround(HEAPF32[i11 + 328 >> 2]);
  do if (!(f3 <= Math_fround(.0404499993))) {
   if (f3 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, 2.20000005));
  } else f3 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i11 + 324 >> 2] | 0;
  i1 = HEAP32[i11 + 328 >> 2] | 0;
 }
 i11 = HEAP32[i11 + 332 >> 2] | 0;
 HEAP32[i12 + 1316 >> 2] = i2;
 HEAP32[i12 + 1320 >> 2] = i5;
 HEAP32[i12 + 1324 >> 2] = i1;
 HEAP32[i12 + 1328 >> 2] = i11;
 i1 = (HEAP32[gb + 1166248 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i1 >> 2] & -229377;
 HEAP32[i1 >> 2] = i2;
 switch (i13 | 0) {
 case 1:
  {
   HEAP32[i1 >> 2] = i2 | 32768;
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = i2 | 65536;
   return;
  }
 case 3:
  {
   HEAP32[i1 >> 2] = i2 | 131072;
   return;
  }
 default:
  return;
 }
}

function __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f7 = Math_fround(f4 + f5);
 f6 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f7 = Math_fround(f7 + f6);
 if (f7 > Math_fround(0.0)) {
  f11 = Math_fround(Math_sqrt(Math_fround(f7 + Math_fround(1.0))));
  f10 = Math_fround(f11 * Math_fround(.5));
  i3 = i2 + 12 | 0;
  HEAPF32[i3 >> 2] = f10;
  f11 = Math_fround(Math_fround(.5) / f11);
  f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f4 = Math_fround(f11 * Math_fround(f4 - Math_fround(HEAPF32[i1 + 28 >> 2])));
  HEAPF32[i2 >> 2] = f4;
  f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f5 = Math_fround(f11 * Math_fround(f5 - Math_fround(HEAPF32[i1 + 8 >> 2])));
  i9 = i2 + 4 | 0;
  HEAPF32[i9 >> 2] = f5;
  f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f6 = Math_fround(f11 * Math_fround(f6 - Math_fround(HEAPF32[i1 + 12 >> 2])));
  i1 = i2 + 8 | 0;
  HEAPF32[i1 >> 2] = f6;
  f11 = Math_fround(f4 * f4);
  f7 = Math_fround(f5 * f5);
  f7 = Math_fround(f11 + f7);
  f11 = Math_fround(f6 * f6);
  f11 = Math_fround(f7 + f11);
  f7 = Math_fround(f10 * f10);
  f7 = Math_fround(f11 + f7);
  f7 = Math_fround(Math_sqrt(Math_fround(f7)));
  f4 = Math_fround(f4 / f7);
  f5 = Math_fround(f5 / f7);
  f6 = Math_fround(f6 / f7);
  f7 = Math_fround(f10 / f7);
  HEAPF32[i2 >> 2] = f4;
  HEAPF32[i9 >> 2] = f5;
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i3 >> 2] = f7;
  STACKTOP = i8;
  return;
 } else {
  i18 = f5 > f4;
  i15 = i18 & 1;
  i18 = f6 > Math_fround(HEAPF32[i1 + ((i18 ? 3 : 0) + i15 << 2) >> 2]);
  i15 = i18 ? 2 : i15;
  i18 = HEAP32[gb + 84752 + (i15 << 2) >> 2] | 0;
  i14 = HEAP32[gb + 84752 + (i18 << 2) >> 2] | 0;
  i17 = i15 * 3 | 0;
  f7 = Math_fround(HEAPF32[i1 + (i15 << 2 << 2) >> 2]);
  i19 = i18 * 3 | 0;
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 + (i18 << 2 << 2) >> 2]));
  i16 = i14 * 3 | 0;
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i1 + (i14 << 2 << 2) >> 2])) + Math_fround(1.0))));
  HEAP32[i3 >> 2] = i2;
  i13 = i2 + 4 | 0;
  HEAP32[i3 + 4 >> 2] = i13;
  i9 = i2 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = i9;
  f6 = Math_fround(f7 * Math_fround(.5));
  HEAPF32[HEAP32[i3 + (i15 << 2) >> 2] >> 2] = f6;
  f7 = Math_fround(Math_fround(.5) / f7);
  f6 = Math_fround(HEAPF32[i1 + (i19 + i14 << 2) >> 2]);
  i12 = i2 + 12 | 0;
  HEAPF32[i12 >> 2] = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i1 + (i16 + i18 << 2) >> 2])));
  f6 = Math_fround(HEAPF32[i1 + (i17 + i18 << 2) >> 2]);
  f6 = Math_fround(f7 * Math_fround(f6 + Math_fround(HEAPF32[i1 + (i19 + i15 << 2) >> 2])));
  HEAPF32[HEAP32[i3 + (i18 << 2) >> 2] >> 2] = f6;
  f6 = Math_fround(HEAPF32[i1 + (i17 + i14 << 2) >> 2]);
  f6 = Math_fround(f7 * Math_fround(f6 + Math_fround(HEAPF32[i1 + (i16 + i15 << 2) >> 2])));
  HEAPF32[HEAP32[i3 + (i14 << 2) >> 2] >> 2] = f6;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  f10 = Math_fround(HEAPF32[i9 >> 2]);
  i1 = i13;
  i3 = i9;
  i9 = i12;
  f5 = Math_fround(HEAPF32[i12 >> 2]);
  f4 = Math_fround(f6 * f6);
  f11 = Math_fround(f7 * f7);
  f11 = Math_fround(f4 + f11);
  f4 = Math_fround(f10 * f10);
  f4 = Math_fround(f11 + f4);
  f11 = Math_fround(f5 * f5);
  f11 = Math_fround(f4 + f11);
  f11 = Math_fround(Math_sqrt(Math_fround(f11)));
  f6 = Math_fround(f6 / f11);
  f7 = Math_fround(f7 / f11);
  f10 = Math_fround(f10 / f11);
  f11 = Math_fround(f5 / f11);
  HEAPF32[i2 >> 2] = f6;
  HEAPF32[i1 >> 2] = f7;
  HEAPF32[i3 >> 2] = f10;
  HEAPF32[i9 >> 2] = f11;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx24writeBackContactCoulomb4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i30, i27, i28, i29) {
 i30 = i30 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i31 = 0, i32 = 0, i33 = 0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i33 + 16 | 0;
 i31 = i33;
 i5 = HEAP32[i30 + 16 >> 2] | 0;
 i6 = HEAP32[i30 + 20 >> 2] | 0;
 i7 = HEAP32[i30 + 52 >> 2] | 0;
 i8 = HEAP32[i30 + 84 >> 2] | 0;
 i9 = HEAP32[i30 + 116 >> 2] | 0;
 i26 = HEAP16[i5 + 2 >> 1] | 0;
 i22 = i5 + (i26 & 65535) | 0;
 i23 = (HEAP8[i5 >> 0] | 0) == 7 ? 272 : 176;
 HEAP32[i32 >> 2] = 0;
 if (!(i26 << 16 >> 16)) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  i24 = i32 + 1 | 0;
  i25 = i32 + 2 | 0;
  i26 = i32 + 3 | 0;
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  do {
   i11 = i5 + 112 | 0;
   HEAP8[i32 >> 0] = HEAP8[i5 + 8 >> 0] & 1;
   HEAP8[i24 >> 0] = HEAP8[i5 + 9 >> 0] & 1;
   HEAP8[i25 >> 0] = HEAP8[i5 + 10 >> 0] & 1;
   HEAP8[i26 >> 0] = HEAP8[i5 + 11 >> 0] & 1;
   i10 = HEAP8[i5 + 1 >> 0] | 0;
   if (!(i10 << 24 >> 24)) i5 = i11; else {
    i17 = i5 + 7 | 0;
    i18 = i5 + 6 | 0;
    i19 = i5 + 5 | 0;
    i20 = i5 + 4 | 0;
    i16 = i10 & 255;
    i21 = Math_imul(i23, i16) | 0;
    i10 = 0;
    do {
     f12 = Math_fround(HEAPF32[i11 + 96 >> 2]);
     f13 = Math_fround(HEAPF32[i11 + 100 >> 2]);
     f14 = Math_fround(HEAPF32[i11 + 104 >> 2]);
     f15 = Math_fround(HEAPF32[i11 + 108 >> 2]);
     i11 = i11 + i23 | 0;
     if (!i6) i6 = 0; else if (i10 >>> 0 < (HEAPU8[i20 >> 0] | 0) >>> 0) {
      HEAPF32[i6 >> 2] = f12;
      i6 = i6 + 4 | 0;
     }
     if (!i7) i7 = 0; else if (i10 >>> 0 < (HEAPU8[i19 >> 0] | 0) >>> 0) {
      HEAPF32[i7 >> 2] = f13;
      i7 = i7 + 4 | 0;
     }
     if (!i8) i8 = 0; else if (i10 >>> 0 < (HEAPU8[i18 >> 0] | 0) >>> 0) {
      HEAPF32[i8 >> 2] = f14;
      i8 = i8 + 4 | 0;
     }
     if (!i9) i9 = 0; else if (i10 >>> 0 < (HEAPU8[i17 >> 0] | 0) >>> 0) {
      HEAPF32[i9 >> 2] = f15;
      i9 = i9 + 4 | 0;
     }
     f1 = Math_fround(f1 + f12);
     f2 = Math_fround(f2 + f13);
     f3 = Math_fround(f3 + f14);
     f4 = Math_fround(f4 + f15);
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != (i16 | 0));
    i5 = i5 + (i21 + 112) | 0;
   }
  } while (i5 >>> 0 < i22 >>> 0);
 }
 HEAPF32[i31 >> 2] = f1;
 HEAPF32[i31 + 4 >> 2] = f2;
 HEAPF32[i31 + 8 >> 2] = f3;
 HEAPF32[i31 + 12 >> 2] = f4;
 i10 = i27 + 8 | 0;
 i7 = i27 + 4 | 0;
 i9 = 0;
 do {
  if (HEAP8[i32 + i9 >> 0] | 0) if ((HEAP16[i30 + (i9 << 5) + 8 >> 1] | 0) == -1) if ((HEAP16[i30 + (i9 << 5) + 12 >> 1] | 0) == -1) {
   i8 = HEAP32[i31 + (i9 << 2) >> 2] | 0;
   if (i8 | 0) {
    i6 = HEAP32[i28 + (i9 << 2) >> 2] | 0;
    f2 = Math_fround(HEAPF32[i6 + 36 >> 2]);
    i27 = f2 < Math_fround(3402823469999999843913219.0e14);
    i5 = HEAP32[i29 + (i9 << 2) >> 2] | 0;
    f1 = Math_fround(HEAPF32[i5 + 36 >> 2]);
    if (i27 | f1 < Math_fround(3402823469999999843913219.0e14)) {
     i24 = HEAP32[i6 + 40 >> 2] | 0;
     i25 = HEAP32[i5 + 40 >> 2] | 0;
     i23 = i25 >>> 0 < i24 >>> 0;
     i27 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = i27 + 1;
     i26 = HEAP32[i7 >> 2] | 0;
     HEAP32[i26 + (i27 << 4) >> 2] = i23 ? i25 : i24;
     HEAP32[i26 + (i27 << 4) + 4 >> 2] = i23 ? i24 : i25;
     HEAP32[i26 + (i27 << 4) + 8 >> 2] = i8;
     HEAPF32[i26 + (i27 << 4) + 12 >> 2] = f2 < f1 ? f2 : f1;
    }
   }
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != 4);
 STACKTOP = i33;
 return;
}

function __Z20OptimizeIndexBuffersR4Mesh(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i29 + 32 | 0;
 i17 = i29 + 16 | 0;
 i27 = i29;
 i28 = i8 + 32 | 0;
 i11 = HEAP32[i28 >> 2] | 0;
 i26 = (HEAP32[i11 + 132 >> 2] | 0) - (HEAP32[i11 + 128 >> 2] | 0) | 0;
 i10 = (i26 | 0) / 52 | 0;
 i11 = HEAP32[i11 + 100 >> 2] | 0;
 if ((i26 | 0) <= 0) {
  STACKTOP = i29;
  return;
 }
 i12 = i17 + 4 | 0;
 i13 = i17 + 8 | 0;
 i14 = i17 + 12 | 0;
 i15 = i27 + 4 | 0;
 i16 = i27 + 8 | 0;
 i18 = i27 + 12 | 0;
 i19 = i9 + 4 | 0;
 i20 = i9 + 8 | 0;
 i21 = i9 + 12 | 0;
 i22 = i17 + 12 | 0;
 i23 = i9 + 4 | 0;
 i24 = i27 + 12 | 0;
 i25 = i9 + 4 | 0;
 i26 = i8 + 4 | 0;
 i7 = 0;
 do {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  i6 = HEAP32[i28 >> 2] | 0;
  switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i17, i7, i6 + 128 | 0, i6) | 0) {
  case 1:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i26 >> 2] | 0, 0, 0);
    break;
   }
  case 4:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i26 >> 2] | 0, 0, 0);
    break;
   }
  default:
   {}
  }
  HEAP32[i27 >> 2] = 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i18 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  i1 = i4 - i5 >> 2;
  i3 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i27 >> 2] | 0;
  i2 = i3 - i6 >> 2;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i27, i1 - i2 | 0);
   i5 = HEAP32[i17 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i27 >> 2] | 0;
  } else if (i1 >>> 0 < i2 >>> 0) {
   i1 = i6 + (i1 << 2) | 0;
   if ((i3 | 0) == (i1 | 0)) i1 = i6; else {
    HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
    i1 = i6;
   }
  } else i1 = i6;
  HEAP32[i19 >> 2] = 16;
  i2 = __Znaj(64) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i20 >> 2] = 0;
  HEAP32[i21 >> 2] = 0;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = -1;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __ZN20VertexCacheOptimizerIjLi16EE17OptimizeTrianglesEPjjPKjj(i9, i1, i11, i5, (i4 - i5 >> 2 >>> 0) / 3 | 0);
  i1 = HEAP32[i27 >> 2] | 0;
  __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i8, i1, (HEAP32[i15 >> 2] | 0) - i1 >> 2, i7, 0, 4) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
  i1 = HEAP32[i27 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i15 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i15 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i6 = HEAP32[i24 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i25 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  }
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i12 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i6 = HEAP32[i22 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i23 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i10 | 0));
 STACKTOP = i29;
 return;
}

function __ZL18computePlaneBoundsRN5physx9PxBounds3ERKNS_11PxTransformEf(i12, i1, f13) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 f13 = Math_fround(f13);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f3 * Math_fround(2.0));
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f2 = Math_fround(f5 * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f3 * f4) + Math_fround(Math_fround(f5 * f2) + Math_fround(-1.0)));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f3 * f2);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f4 * f11));
 f11 = Math_fround(Math_fround(f4 * f3) - Math_fround(f2 * f11));
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) * f5);
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) * f10));
 f2 = Math_fround(f2 + Math_fround(f11 * Math_fround(HEAPF32[i1 + 24 >> 2])));
 f3 = Math_fround(-f2);
 f4 = Math_fround(Math_abs(Math_fround(f5)));
 f7 = Math_fround(Math_abs(Math_fround(f10)));
 f6 = Math_fround(Math_abs(Math_fround(f11)));
 i8 = f7 < Math_fround(9.99999997e-07);
 i9 = f6 < Math_fround(9.99999997e-07);
 do if (f4 > Math_fround(.999998986) & i8 & i9) if (f5 > Math_fround(0.0)) {
  f6 = Math_fround(-8507058669999999534545717.0e13);
  f7 = Math_fround(-8507058669999999534545717.0e13);
  f3 = Math_fround(-8507058669999999534545717.0e13);
  f4 = f2;
  f5 = Math_fround(8507058669999999534545717.0e13);
  f2 = Math_fround(8507058669999999534545717.0e13);
 } else {
  f6 = f3;
  f7 = Math_fround(-8507058669999999534545717.0e13);
  f3 = Math_fround(-8507058669999999534545717.0e13);
  f4 = Math_fround(8507058669999999534545717.0e13);
  f5 = Math_fround(8507058669999999534545717.0e13);
  f2 = Math_fround(8507058669999999534545717.0e13);
 } else {
  i1 = f4 < Math_fround(9.99999997e-07);
  if (i1 & f7 > Math_fround(.999998986) & i9) {
   if (f10 > Math_fround(0.0)) {
    f6 = Math_fround(-8507058669999999534545717.0e13);
    f7 = Math_fround(-8507058669999999534545717.0e13);
    f3 = Math_fround(-8507058669999999534545717.0e13);
    f4 = Math_fround(8507058669999999534545717.0e13);
    f5 = f2;
    f2 = Math_fround(8507058669999999534545717.0e13);
    break;
   }
   f6 = Math_fround(-8507058669999999534545717.0e13);
   f7 = f3;
   f3 = Math_fround(-8507058669999999534545717.0e13);
   f4 = Math_fround(8507058669999999534545717.0e13);
   f5 = Math_fround(8507058669999999534545717.0e13);
   f2 = Math_fround(8507058669999999534545717.0e13);
   break;
  }
  if (i1 & i8 & f6 > Math_fround(.999998986)) if (f11 > Math_fround(0.0)) {
   f6 = Math_fround(-8507058669999999534545717.0e13);
   f7 = Math_fround(-8507058669999999534545717.0e13);
   f3 = Math_fround(-8507058669999999534545717.0e13);
   f4 = Math_fround(8507058669999999534545717.0e13);
   f5 = Math_fround(8507058669999999534545717.0e13);
  } else {
   f6 = Math_fround(-8507058669999999534545717.0e13);
   f7 = Math_fround(-8507058669999999534545717.0e13);
   f4 = Math_fround(8507058669999999534545717.0e13);
   f5 = Math_fround(8507058669999999534545717.0e13);
   f2 = Math_fround(8507058669999999534545717.0e13);
  } else {
   f6 = Math_fround(-8507058669999999534545717.0e13);
   f7 = Math_fround(-8507058669999999534545717.0e13);
   f3 = Math_fround(-8507058669999999534545717.0e13);
   f4 = Math_fround(8507058669999999534545717.0e13);
   f5 = Math_fround(8507058669999999534545717.0e13);
   f2 = Math_fround(8507058669999999534545717.0e13);
  }
 } while (0);
 f11 = Math_fround(f7 - f13);
 f10 = Math_fround(f3 - f13);
 HEAPF32[i12 >> 2] = Math_fround(f6 - f13);
 HEAPF32[i12 + 4 >> 2] = f11;
 HEAPF32[i12 + 8 >> 2] = f10;
 f10 = Math_fround(f5 + f13);
 f11 = Math_fround(f2 + f13);
 HEAPF32[i12 + 12 >> 2] = Math_fround(f4 + f13);
 HEAPF32[i12 + 16 >> 2] = f10;
 HEAPF32[i12 + 20 >> 2] = f11;
 return;
}

function __Z29CollectAndProduceClonedIslandR6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i10, i14) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 8 | 0;
 i9 = i17;
 if ((HEAP16[gb + 1155180 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i1;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155180 | 0, i15);
  i13 = gb + 1155180 | 0;
 } else i13 = 0;
 i11 = i14 + 4 | 0;
 i12 = i14 + 12 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i12 >> 2] | 0) - i2 >> 3 >>> 0 < 64) {
  i7 = i14 + 16 | 0;
  i8 = i14 + 8 | 0;
  i5 = (HEAP32[i8 >> 2] | 0) - i2 >> 3;
  i4 = HEAP32[i7 >> 2] | 0;
  HEAP32[i15 >> 2] = 1;
  HEAP32[i15 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(512, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i5 = i4 + (i5 << 3) | 0;
  i3 = (HEAP32[i8 >> 2] | 0) - i2 | 0;
  i6 = i5 + (0 - (i3 >> 3) << 3) | 0;
  if ((i3 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i3 | 0) | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i6;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i12 >> 2] = i4 + 512;
  if (i2 | 0) {
   i8 = HEAP32[i7 >> 2] | 0;
   HEAP32[i15 >> 2] = 1;
   HEAP32[i15 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i15);
  }
 }
 i3 = i1 + 8 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) >>> 21;
 do if ((i2 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) i16 = 13; else {
  if ((i2 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if (i2 | 0) {
    i1 = i2;
    i16 = 13;
    break;
   }
  }
  i8 = gb + 63520 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i3 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
  i10 = i9;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  i2 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i2, 0, i15, 2) | 0;
  if (i2 | 0) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN13MonoBehaviour20SetScriptingDataFromERKS_(i2, i1);
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i15 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i15 + 4 >> 2] = i2;
  i1 = i14 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i11, i15); else {
   i10 = i15;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
  }
 } while (0);
 if ((i16 | 0) == 13) {
  __ZL36CollectAndProduceGameObjectHierarchyR9TransformPS_R10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS3_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0, i10, i14);
  i1 = i14 + 8 | 0;
 }
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 HEAP8[i15 >> 0] = HEAP8[i14 >> 0] | 0;
 __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i12, i16, i15);
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i17;
 return;
}

function runPostSets61() {
 HEAP32[gb + 68992 >> 2] = (HEAP32[gb + 68992 >> 2] | 0) + (gb + 481252 | 0);
 HEAP32[gb + 69004 >> 2] = (HEAP32[gb + 69004 >> 2] | 0) + (gb + 481262 | 0);
 HEAP32[gb + 69016 >> 2] = (HEAP32[gb + 69016 >> 2] | 0) + (gb + 481274 | 0);
 HEAP32[gb + 69036 >> 2] = fb + 773;
 HEAP32[gb + 69040 >> 2] = fb + 774;
 HEAP32[gb + 69044 >> 2] = fb + 775;
 HEAP32[gb + 69048 >> 2] = fb + 635;
 HEAP32[gb + 69052 >> 2] = fb + 16;
 HEAP32[gb + 69056 >> 2] = fb + 39;
 HEAP32[gb + 69060 >> 2] = fb + 40;
 HEAP32[gb + 69064 >> 2] = fb + 19;
 HEAP32[gb + 69068 >> 2] = fb + 339;
 HEAP32[gb + 69072 >> 2] = fb + 31;
 HEAP32[gb + 69076 >> 2] = fb + 27;
 HEAP32[gb + 69080 >> 2] = fb + 62;
 HEAP32[gb + 69084 >> 2] = fb + 28;
 HEAP32[gb + 69088 >> 2] = fb + 63;
 HEAP32[gb + 69092 >> 2] = fb + 29;
 HEAP32[gb + 69096 >> 2] = fb + 34;
 HEAP32[gb + 69100 >> 2] = fb + 636;
 HEAP32[gb + 69104 >> 2] = fb + 637;
 HEAP32[gb + 69108 >> 2] = fb + 638;
 HEAP32[gb + 69112 >> 2] = fb + 639;
 HEAP32[gb + 69116 >> 2] = fb + 640;
 HEAP32[gb + 69120 >> 2] = fb + 641;
 HEAP32[gb + 69124 >> 2] = fb + 36;
 HEAP32[gb + 69140 >> 2] = fb + 776;
 HEAP32[gb + 69144 >> 2] = fb + 777;
 HEAP32[gb + 69148 >> 2] = fb + 38;
 HEAP32[gb + 69152 >> 2] = fb + 145;
 HEAP32[gb + 69156 >> 2] = fb + 16;
 HEAP32[gb + 69160 >> 2] = fb + 93;
 HEAP32[gb + 69164 >> 2] = fb + 778;
 HEAP32[gb + 69168 >> 2] = fb + 19;
 HEAP32[gb + 69172 >> 2] = fb + 340;
 HEAP32[gb + 69176 >> 2] = fb + 103;
 HEAP32[gb + 69180 >> 2] = fb + 101;
 HEAP32[gb + 69184 >> 2] = fb + 62;
 HEAP32[gb + 69188 >> 2] = fb + 28;
 HEAP32[gb + 69192 >> 2] = fb + 63;
 HEAP32[gb + 69196 >> 2] = fb + 29;
 HEAP32[gb + 69200 >> 2] = fb + 34;
 HEAP32[gb + 69204 >> 2] = fb + 642;
 HEAP32[gb + 69208 >> 2] = fb + 643;
 HEAP32[gb + 69212 >> 2] = fb + 644;
 HEAP32[gb + 69216 >> 2] = fb + 645;
 HEAP32[gb + 69220 >> 2] = fb + 646;
 HEAP32[gb + 69224 >> 2] = fb + 647;
 HEAP32[gb + 69228 >> 2] = fb + 36;
 HEAP32[gb + 69232 >> 2] = fb + 104;
 HEAP32[gb + 69236 >> 2] = fb + 108;
 HEAP32[gb + 69240 >> 2] = fb + 94;
 HEAP32[gb + 69244 >> 2] = fb + 130;
 HEAP32[gb + 69248 >> 2] = fb + 112;
 HEAP32[gb + 69252 >> 2] = fb + 113;
 HEAP32[gb + 69256 >> 2] = fb + 131;
 HEAP32[gb + 69260 >> 2] = fb + 111;
 HEAP32[gb + 69264 >> 2] = fb + 112;
 HEAP32[gb + 69268 >> 2] = fb + 113;
 HEAP32[gb + 69272 >> 2] = fb + 779;
 HEAP32[gb + 69276 >> 2] = fb + 780;
 HEAP32[gb + 70304 >> 2] = (HEAP32[gb + 70304 >> 2] | 0) + (gb + 488445 | 0);
 HEAP32[gb + 70316 >> 2] = fb + 781;
 HEAP32[gb + 70320 >> 2] = fb + 782;
 HEAP32[gb + 70324 >> 2] = fb + 1;
 HEAP32[gb + 70336 >> 2] = fb + 659;
 HEAP32[gb + 70340 >> 2] = fb + 783;
 HEAP32[gb + 70344 >> 2] = fb + 341;
 HEAP32[gb + 70348 >> 2] = fb + 8;
 HEAP32[gb + 70352 >> 2] = fb + 288;
 HEAP32[gb + 70356 >> 2] = fb + 522;
 HEAP32[gb + 70360 >> 2] = fb + 88;
 HEAP32[gb + 70364 >> 2] = fb + 69;
 HEAP32[gb + 70368 >> 2] = fb + 60;
 HEAP32[gb + 70380 >> 2] = fb + 659;
 HEAP32[gb + 70384 >> 2] = fb + 784;
 HEAP32[gb + 70388 >> 2] = fb + 342;
 HEAP32[gb + 70392 >> 2] = fb + 9;
 HEAP32[gb + 70396 >> 2] = fb + 288;
 HEAP32[gb + 70400 >> 2] = fb + 522;
 HEAP32[gb + 70404 >> 2] = fb + 88;
 HEAP32[gb + 70408 >> 2] = fb + 69;
 HEAP32[gb + 70412 >> 2] = fb + 60;
 HEAP32[gb + 70424 >> 2] = fb + 785;
 HEAP32[gb + 70428 >> 2] = fb + 786;
 HEAP32[gb + 70432 >> 2] = fb + 343;
 HEAP32[gb + 70436 >> 2] = fb + 88;
 HEAP32[gb + 70440 >> 2] = fb + 5;
 HEAP32[gb + 70444 >> 2] = fb + 49;
 HEAP32[gb + 70448 >> 2] = fb + 648;
 HEAP32[gb + 70452 >> 2] = fb + 1;
 HEAP32[gb + 70464 >> 2] = fb + 787;
 HEAP32[gb + 70468 >> 2] = fb + 788;
 HEAP32[gb + 70472 >> 2] = fb + 344;
 HEAP32[gb + 70476 >> 2] = fb + 15;
 HEAP32[gb + 70480 >> 2] = fb + 89;
 HEAP32[gb + 70484 >> 2] = fb + 649;
 HEAP32[gb + 70488 >> 2] = fb + 2;
 HEAP32[gb + 70500 >> 2] = fb + 789;
 HEAP32[gb + 70504 >> 2] = fb + 790;
 runPostSets62();
}

function runPostSets188() {
 HEAP32[gb + 158532 >> 2] = fb + 2463;
 HEAP32[gb + 158536 >> 2] = fb + 2464;
 HEAP32[gb + 158540 >> 2] = fb + 1;
 HEAP32[gb + 158544 >> 2] = fb + 1;
 HEAP32[gb + 158548 >> 2] = fb + 1;
 HEAP32[gb + 158552 >> 2] = fb + 1;
 HEAP32[gb + 158556 >> 2] = fb + 1;
 HEAP32[gb + 158560 >> 2] = fb + 1;
 HEAP32[gb + 158564 >> 2] = fb + 1;
 HEAP32[gb + 158568 >> 2] = fb + 1;
 HEAP32[gb + 158580 >> 2] = fb + 1;
 HEAP32[gb + 158584 >> 2] = fb + 2273;
 HEAP32[gb + 158588 >> 2] = fb + 2465;
 HEAP32[gb + 158600 >> 2] = fb + 1;
 HEAP32[gb + 158604 >> 2] = fb + 1;
 HEAP32[gb + 158608 >> 2] = fb + 1;
 HEAP32[gb + 158612 >> 2] = fb + 1;
 HEAP32[gb + 158616 >> 2] = fb + 2466;
 HEAP32[gb + 158620 >> 2] = fb + 1520;
 HEAP32[gb + 158624 >> 2] = fb + 2287;
 HEAP32[gb + 158628 >> 2] = fb + 2467;
 HEAP32[gb + 158632 >> 2] = fb + 1;
 HEAP32[gb + 158636 >> 2] = fb + 1;
 HEAP32[gb + 158640 >> 2] = fb + 1;
 HEAP32[gb + 158652 >> 2] = fb + 2401;
 HEAP32[gb + 158656 >> 2] = fb + 2468;
 HEAP32[gb + 158660 >> 2] = fb + 413;
 HEAP32[gb + 158664 >> 2] = fb + 1109;
 HEAP32[gb + 158676 >> 2] = fb + 2309;
 HEAP32[gb + 158680 >> 2] = fb + 2469;
 HEAP32[gb + 158684 >> 2] = fb + 256;
 HEAP32[gb + 158696 >> 2] = fb + 2470;
 HEAP32[gb + 158700 >> 2] = fb + 2471;
 HEAP32[gb + 158704 >> 2] = fb + 413;
 HEAP32[gb + 158708 >> 2] = fb + 1110;
 HEAP32[gb + 158720 >> 2] = fb + 2472;
 HEAP32[gb + 158724 >> 2] = fb + 2473;
 HEAP32[gb + 158728 >> 2] = fb + 413;
 HEAP32[gb + 158732 >> 2] = fb + 1111;
 HEAP32[gb + 158744 >> 2] = fb + 2474;
 HEAP32[gb + 158748 >> 2] = fb + 2475;
 HEAP32[gb + 158752 >> 2] = fb + 415;
 HEAP32[gb + 158764 >> 2] = fb + 2476;
 HEAP32[gb + 158768 >> 2] = fb + 2477;
 HEAP32[gb + 158772 >> 2] = fb + 416;
 HEAP32[gb + 158784 >> 2] = fb + 2478;
 HEAP32[gb + 158788 >> 2] = fb + 2479;
 HEAP32[gb + 158792 >> 2] = fb + 417;
 HEAP32[gb + 158804 >> 2] = fb + 2480;
 HEAP32[gb + 158808 >> 2] = fb + 1112;
 HEAP32[gb + 158812 >> 2] = fb + 456;
 HEAP32[gb + 158816 >> 2] = fb + 2481;
 HEAP32[gb + 158820 >> 2] = fb + 2482;
 HEAP32[gb + 158824 >> 2] = fb + 418;
 HEAP32[gb + 158828 >> 2] = fb + 1774;
 HEAP32[gb + 158832 >> 2] = fb + 1775;
 HEAP32[gb + 158896 >> 2] = fb + 2480;
 HEAP32[gb + 158900 >> 2] = fb + 1113;
 HEAP32[gb + 158904 >> 2] = fb + 456;
 HEAP32[gb + 158908 >> 2] = fb + 2481;
 HEAP32[gb + 158912 >> 2] = fb + 2483;
 HEAP32[gb + 158916 >> 2] = fb + 419;
 HEAP32[gb + 158920 >> 2] = fb + 1774;
 HEAP32[gb + 158924 >> 2] = fb + 1776;
 HEAP32[gb + 158936 >> 2] = fb + 2484;
 HEAP32[gb + 158940 >> 2] = fb + 2485;
 HEAP32[gb + 158944 >> 2] = fb + 2486;
 HEAP32[gb + 158948 >> 2] = fb + 1777;
 HEAP32[gb + 158952 >> 2] = fb + 16;
 HEAP32[gb + 158956 >> 2] = fb + 2487;
 HEAP32[gb + 158960 >> 2] = fb + 2488;
 HEAP32[gb + 158964 >> 2] = fb + 2489;
 HEAP32[gb + 158968 >> 2] = fb + 1114;
 HEAP32[gb + 158972 >> 2] = fb + 103;
 HEAP32[gb + 158976 >> 2] = fb + 101;
 HEAP32[gb + 158980 >> 2] = fb + 62;
 HEAP32[gb + 158984 >> 2] = fb + 28;
 HEAP32[gb + 158988 >> 2] = fb + 63;
 HEAP32[gb + 158992 >> 2] = fb + 29;
 HEAP32[gb + 158996 >> 2] = fb + 34;
 HEAP32[gb + 159e3 >> 2] = fb + 1778;
 HEAP32[gb + 159004 >> 2] = fb + 1779;
 HEAP32[gb + 159008 >> 2] = fb + 1780;
 HEAP32[gb + 159012 >> 2] = fb + 1781;
 HEAP32[gb + 159016 >> 2] = fb + 1782;
 HEAP32[gb + 159020 >> 2] = fb + 1783;
 HEAP32[gb + 159024 >> 2] = fb + 36;
 HEAP32[gb + 159028 >> 2] = fb + 104;
 HEAP32[gb + 159032 >> 2] = fb + 1202;
 HEAP32[gb + 159036 >> 2] = fb + 94;
 HEAP32[gb + 159040 >> 2] = fb + 1784;
 HEAP32[gb + 159044 >> 2] = fb + 866;
 HEAP32[gb + 159048 >> 2] = fb + 867;
 HEAP32[gb + 159052 >> 2] = fb + 1204;
 HEAP32[gb + 159056 >> 2] = fb + 1115;
 HEAP32[gb + 159060 >> 2] = fb + 869;
 HEAP32[gb + 159064 >> 2] = fb + 1205;
 HEAP32[gb + 159068 >> 2] = fb + 870;
 HEAP32[gb + 159072 >> 2] = fb + 1116;
 HEAP32[gb + 159076 >> 2] = fb + 1206;
 runPostSets189();
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i17, i8, i1) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 8 | 0;
 i14 = i16;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i17 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 1, 2, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 1) | 0, 0, i5 - i4 << 1 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 1) | 0;
 L16 : do if (HEAP32[i7 >> 2] | 0) {
  i12 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, HEAP32[gb + 37288 >> 2] | 0, 0, 0) | 0;
  i9 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i12 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i13 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferItEEvRT_PKc17TransferMetaFlags(i17, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 2 | 0;
    if ((i1 | 0) == (i13 | 0)) break L16;
   }
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  L23 : do if ((i1 | 0) != (i13 | 0)) {
   i4 = i17 + 16 | 0;
   i5 = i17 + 20 | 0;
   i6 = i17 + 32 | 0;
   i7 = i17 + 36 | 0;
   i8 = i17 + 24 | 0;
   i3 = 0;
   while (1) {
    i19 = (Math_imul(i3, i10) | 0) + i12 | 0;
    HEAP32[i2 + 20 >> 2] = i19;
    HEAP32[i2 + 12 >> 2] = i19;
    __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
    i19 = i14;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i3 = i2 + 24 | 0;
    HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i3 + 4 >> 2] = i18;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i15 = 17; else {
     i3 = i2 + 2 | 0;
     if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i15 = 17; else {
      HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
      HEAP32[i4 >> 2] = i3;
     }
    }
    if ((i15 | 0) == 17) {
     i15 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 2);
    }
    if (HEAP32[i17 >> 2] & 512 | 0) HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
    i1 = i1 + 2 | 0;
    if ((i1 | 0) == (i13 | 0)) break L23;
    i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i4 = i9 + 104 | 0;
 i5 = i6 + 32 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP16[i7 + 18 >> 1] | 0;
 if ((i3 & 255) != 2) {
  i8 = HEAP32[i7 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i1);
  HEAP8[i4 >> 0] = 0;
  HEAP8[i4 + 1 >> 0] = 4;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i1, i2, i8, 2, i4);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i8, HEAP32[i1 + 88 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + 8 | 0, i1);
  STACKTOP = i9;
  return;
 }
 i1 = (i3 & 65535) < 1024;
 if (!(HEAP8[i6 + 44 >> 0] & 16)) {
  if (i1) {
   STACKTOP = i9;
   return;
  }
  i1 = HEAP32[i7 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i7 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i3 = HEAP32[i7 + 16 >> 2] | 0;
   i1 = i1 + ((i3 >>> 8 & 255) + (HEAP32[i8 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i3 = i3 >>> 16 & 65535;
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) i3 = 0; else {
   i3 = HEAP32[i7 + 100 >> 2] | 0;
   i4 = HEAP32[i7 + 92 >> 2] | 0;
   if (!i4) i3 = 0; else if (!(HEAP8[i7 + 19 >> 0] | 0)) i3 = 0; else {
    i6 = HEAP16[i7 + 16 >> 1] | 0;
    i3 = i4 + ((Math_imul(HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i3) | 0) + (HEAP32[i8 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i9;
   return;
  }
  while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   f12 = Math_fround(Math_fround((i8 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f11 = Math_fround(Math_fround(i8 >>> 16 & 255) / Math_fround(255.0));
   f10 = Math_fround(Math_fround(i8 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(i8 & 255) / Math_fround(255.0));
   HEAPF32[i2 + 4 >> 2] = f12;
   HEAPF32[i2 + 8 >> 2] = f11;
   HEAPF32[i2 + 12 >> 2] = f10;
   i1 = i1 + i5 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
  STACKTOP = i9;
  return;
 } else {
  if (i1) {
   STACKTOP = i9;
   return;
  }
  i1 = HEAP32[i7 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i7 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i3 = HEAP32[i7 + 16 >> 2] | 0;
   i1 = i1 + ((i3 >>> 8 & 255) + (HEAP32[i8 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i3 = i3 >>> 16 & 65535;
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) i3 = 0; else {
   i3 = HEAP32[i7 + 100 >> 2] | 0;
   i4 = HEAP32[i7 + 92 >> 2] | 0;
   if (!i4) i3 = 0; else if (!(HEAP8[i7 + 19 >> 0] | 0)) i3 = 0; else {
    i6 = HEAP16[i7 + 16 >> 1] | 0;
    i3 = i4 + ((Math_imul(HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i3) | 0) + (HEAP32[i8 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i9;
   return;
  }
  while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   f10 = Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0));
   f11 = Math_fround(Math_fround(i8 & 255) / Math_fround(255.0));
   f12 = Math_fround(Math_fround(i8 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 2 >> 0] | 0) / Math_fround(255.0));
   HEAPF32[i2 + 4 >> 2] = f10;
   HEAPF32[i2 + 8 >> 2] = f11;
   HEAPF32[i2 + 12 >> 2] = f12;
   i1 = i1 + i5 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i3 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 i6 = i1 + 4 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i1 = i2 + 4 | 0;
 if (!i3) {
  i5 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i4 = i6 + 12 | 0;
  i5 = i1 + i5 | 0;
  i1 = i5 + 12 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i5 + 16 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i5 + 20 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = i5 + 24 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  i4 = i6 + 16 | 0;
  HEAP32[i4 >> 2] = i2;
  i4 = i6 + 20 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i6 + 24 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 i5 = i4 + 4 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i2 = i1;
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + i2 | 0;
 do {
  i13 = HEAP32[i5 + (i3 << 3) >> 2] | 0;
  f16 = Math_fround(HEAPF32[i4 + (i13 * 40 | 0) + 24 >> 2]);
  f11 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i13 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 12 >> 2]);
  f9 = Math_fround(f11 * f18);
  f10 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 24 >> 2]);
  f7 = Math_fround(f16 * f10);
  f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i13 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 16 >> 2]);
  f12 = Math_fround(f17 * f8);
  f20 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i13 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 20 >> 2]);
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f16 * f19)) - Math_fround(f17 * f10)) - Math_fround(f20 * f8));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f20 * f18)) - Math_fround(f17 * f19)) - Math_fround(f11 * f8));
  f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f11 * f19)) - Math_fround(f16 * f18)) - Math_fround(f20 * f10));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f8)) - Math_fround(f11 * f10));
  i13 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i15 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f10 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = Math_fround(f10 * f10);
  f9 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f9 * f9);
  f8 = (HEAP32[tempDoublePtr >> 2] = i13 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f11) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
  f9 = Math_fround(f11 * f9);
  f8 = Math_fround(f11 * f8);
  f7 = Math_fround(f11 * f7);
  HEAPF32[i6 + (i3 * 40 | 0) + 12 >> 2] = Math_fround(f11 * f10);
  HEAPF32[i6 + (i3 * 40 | 0) + 16 >> 2] = f9;
  HEAPF32[i6 + (i3 * 40 | 0) + 20 >> 2] = f8;
  HEAPF32[i6 + (i3 * 40 | 0) + 24 >> 2] = f7;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i15 = i6 + 12 | 0;
 i14 = i1 + i2 | 0;
 i4 = i14 + 12 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i5 = i14 + 16 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i13 = i14 + 20 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i14 = i14 + 24 | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = i4;
 i15 = i6 + 16 | 0;
 HEAP32[i15 >> 2] = i5;
 i15 = i6 + 20 | 0;
 HEAP32[i15 >> 2] = i13;
 i15 = i6 + 24 | 0;
 HEAP32[i15 >> 2] = i14;
 return;
}

function __ZN5Cache15UpdateTimestampERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEl(i13, i1, i10) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i15 = i13 + 56 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i14 = i13 + 60 | 0;
 i3 = i2;
 if ((i3 | 0) == (i14 | 0)) {
  STACKTOP = i17;
  return;
 }
 i9 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i9 << 24 >> 24 < 0;
 i9 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
 i7 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i8 = (i9 | 0) == 0;
 i11 = i2;
 L4 : while (1) {
  i6 = i3 + 16 | 0;
  i1 = HEAP8[i6 + 11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  i1 = i1 & 255;
  do if (((i2 ? HEAP32[i3 + 20 >> 2] | 0 : i1) | 0) == (i9 | 0)) {
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i2 ? i4 : i6;
   if (i2) {
    if (i8) break L4;
    if (!(_memcmp(i5, i7, i9) | 0)) break L4; else break;
   }
   if (i8) break L4;
   if ((i4 & 255) << 24 >> 24 == (HEAP8[i7 >> 0] | 0)) {
    i4 = i6;
    i2 = i7;
    do {
     i1 = i1 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i1) break L4;
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   }
  } while (0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i1) {
   i1 = i11;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i14 | 0)) {
   i12 = 33;
   break;
  } else {
   i11 = i1;
   i3 = i1;
  }
 }
 if ((i12 | 0) == 33) {
  STACKTOP = i17;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i16, i6);
 i8 = i16 + 12 | 0;
 i1 = i3 + 28 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i16 + 20 | 0;
 HEAP32[i5 >> 2] = i10;
 i4 = i11;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i4;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i15 >> 2] | 0) == (i3 | 0)) HEAP32[i15 >> 2] = i1;
 i7 = i13 + 64 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 i6 = i13 + 60 | 0;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
 __ZdlPv(i11);
 i1 = HEAP32[i14 >> 2] | 0;
 do if (!i1) {
  i2 = i14;
  i3 = i14;
 } else {
  i4 = HEAP32[i5 >> 2] | 0;
  while (1) if ((i4 | 0) < (HEAP32[i1 + 36 >> 2] | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i12 = 20;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i12 = 23;
    break;
   } else i1 = i2;
  }
  if ((i12 | 0) == 20) {
   i2 = i1;
   i3 = i1;
   break;
  } else if ((i12 | 0) == 23) {
   i2 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(40) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i16);
 i14 = i1 + 28 | 0;
 HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i15 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i1);
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 STACKTOP = i17;
 return;
}

function __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb(i2, i3, i8, i9, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i10 + 8 | 0;
 i12 = i10;
 HEAP32[i2 >> 2] = 0;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i6 = i2 + 8 | 0;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 33952 + 8;
 i7 = gb + 64016 | 0;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i5 = i13;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i2 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = gb + 64016 | 0;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i5 = i13;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i2 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = gb + 64016 | 0;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i5 = i13;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i2 + 84 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i7 = gb + 64016 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i2 + 108 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP8[i2 + 116 >> 0] = 1;
 i5 = i2 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 35824 + 8;
 i6 = i12;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i2 + 120 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i6 = i13;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 + 124 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 i4 = i2 + 140 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 152 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i2 + 156 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i2 + 144 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP8[i2 + 160 >> 0] = i9 & 1;
 HEAP8[i2 + 161 >> 0] = 0;
 HEAP32[i2 + 164 >> 2] = i3;
 HEAP32[i2 + 168 >> 2] = i8;
 i9 = i2 + 172 | 0;
 i1 = i2 + 188 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i1 >> 0] = HEAP8[i1 >> 0] & -16;
 HEAP32[i2 + 192 >> 2] = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i2 >> 2] = i1 + 4;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 & 2147483520) >>> 0 >= 128) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i6 >> 2] = 128;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, 1024, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i10;
  return;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i6 >> 2] = 128;
  HEAP32[i4 >> 2] = i13;
  STACKTOP = i10;
  return;
 }
}

function _tt_cmap4_char_map_linear(i1, i22, i3) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i19 = (HEAP32[i2 + 500 >> 2] | 0) + (HEAP32[i2 + 504 >> 2] | 0) | 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i16 = (HEAPU8[i4 + 7 >> 0] | 0) & 254 | (HEAPU8[i4 + 6 >> 0] | 0) << 8;
 i17 = i16 >>> 1;
 if (!i17) {
  i22 = 0;
  return i22 | 0;
 }
 i21 = i3 << 24 >> 24 != 0;
 i1 = (HEAP32[i22 >> 2] | 0) + (i21 & 1) | 0;
 if (i1 >>> 0 > 65535) {
  i22 = 0;
  return i22 | 0;
 }
 i18 = i17 + -1 | 0;
 i15 = i2 + 16 | 0;
 i14 = i3 << 24 >> 24 == 0;
 i13 = i4 + 16 + i16 | 0;
 i11 = i4 + 14 | 0;
 i12 = 0;
 L7 : while (1) {
  i5 = (HEAPU8[i11 >> 0] | 0) << 8 | (HEAPU8[i11 + 1 >> 0] | 0);
  i11 = i11 + 2 | 0;
  i6 = (HEAPU8[i13 >> 0] | 0) << 8 | (HEAPU8[i13 + 1 >> 0] | 0);
  i10 = i1 >>> 0 >= i6 >>> 0;
  i2 = i10 ? i1 : i6;
  if (!(i21 | i10)) {
   i2 = 0;
   break;
  }
  i7 = i13 + i16 | 0;
  i13 = i13 + 2 | 0;
  i8 = i7 + 1 | 0;
  i9 = i7 + i16 | 0;
  i10 = i9 + 1 | 0;
  L10 : do if ((i5 | 0) == 65535 & (i12 >>> 0 >= i18 >>> 0 & (i6 | 0) == 65535)) {
   i1 = i2;
   while (1) {
    if (i1 >>> 0 > 65535) break L10;
    i3 = ((HEAPU8[i7 >> 0] | 0) << 8 | (HEAPU8[i8 >> 0] | 0)) << 16 >> 16;
    i2 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i10 >> 0] | 0);
    L14 : do if (!i2) i20 = 9; else {
     i6 = (i9 + i2 + 2 | 0) >>> 0 > i19 >>> 0;
     i2 = i6 ? 0 : i2;
     i3 = i6 ? 1 : i3;
     switch ((i2 & 65535) << 16 >> 16) {
     case -1:
      break L10;
     case 0:
      {
       i20 = 9;
       break L14;
      }
     default:
      {}
     }
     i2 = i9 + (i2 + ((i1 << 1) + -131070)) | 0;
     if (i21 & i2 >>> 0 > i19 >>> 0) break L10;
     i6 = (HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0);
     i2 = i6 + i3 & 65535;
     if (!i6) i2 = 0; else i2 = i2 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0 ? 0 : i2;
    } while (0);
    do if ((i20 | 0) == 9) {
     i20 = 0;
     i4 = i3 + i1 | 0;
     i2 = i4 & 65535;
     if (i14) break L7;
     if (i2 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) {
      if ((i4 | 0) < 0 & (i3 + 65535 | 0) > -1) {
       i2 = 0;
       i1 = 0 - i3 | 0;
       break;
      }
      if (!((i4 | 0) < 65536 & (i3 | 0) > 0)) break L10;
      i2 = 0;
      i1 = 65536 - i3 | 0;
     }
    } while (0);
    i6 = i1 >>> 0 > 65534 | (i14 | (i2 | 0) != 0);
    i1 = (i6 & 1 ^ 1) + i1 | 0;
    if (i6) break L7;
   }
  } else {
   i1 = i2;
   while (1) {
    if (i1 >>> 0 > i5 >>> 0) break L10;
    i4 = ((HEAPU8[i7 >> 0] | 0) << 8 | (HEAPU8[i8 >> 0] | 0)) << 16 >> 16;
    i2 = (HEAPU8[i9 >> 0] | 0) << 8 | (HEAPU8[i10 >> 0] | 0);
    L31 : do switch ((i2 & 65535) << 16 >> 16) {
    case -1:
     break L10;
    case 0:
     {
      i3 = i4 + i1 | 0;
      i2 = i3 & 65535;
      if (i14) break L7;
      if (i2 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) {
       i2 = i4 + i5 | 0;
       if ((i3 | 0) < 0 & (i2 | 0) > -1) {
        i2 = 0;
        i1 = 0 - i4 | 0;
        break L31;
       }
       if (!((i3 | 0) < 65536 & (i2 | 0) > 65535)) break L10;
       i2 = 0;
       i1 = 65536 - i4 | 0;
      }
      break;
     }
    default:
     {
      i2 = i9 + (i2 + (i1 - i6 << 1)) | 0;
      if (i21 & i2 >>> 0 > i19 >>> 0) break L10;
      i3 = (HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0);
      i2 = i3 + i4 & 65535;
      if (!i3) i2 = 0; else i2 = i2 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0 ? 0 : i2;
     }
    } while (0);
    i4 = i1 >>> 0 > 65534 | (i14 | (i2 | 0) != 0);
    i1 = (i4 & 1 ^ 1) + i1 | 0;
    if (i4) break L7;
   }
  } while (0);
  i12 = i12 + 1 | 0;
  if (i12 >>> 0 >= i17 >>> 0) {
   i2 = 0;
   break;
  }
 }
 if (!i21) {
  i22 = i2;
  return i22 | 0;
 }
 HEAP32[i22 >> 2] = i1;
 i22 = i2;
 return i22 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i8 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i8 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i8 + 12 | 0;
 i18 = i5 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i8 + 20 | 0;
 i17 = i5 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 65;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i17, i8, i1) {
 i17 = i17 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 8 | 0;
 i14 = i16;
 i6 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i11 = i17 + 8 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i8 + 4 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else {
  i1 = i3;
  i2 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 L16 : do if (HEAP32[i7 >> 2] | 0) {
  i12 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, 0, 0) | 0;
  i9 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i12 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i13 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferIiEEvRT_PKc17TransferMetaFlags(i17, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i13 | 0)) break L16;
   }
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  L23 : do if ((i1 | 0) != (i13 | 0)) {
   i4 = i17 + 16 | 0;
   i5 = i17 + 20 | 0;
   i6 = i17 + 32 | 0;
   i7 = i17 + 36 | 0;
   i8 = i17 + 24 | 0;
   i3 = 0;
   while (1) {
    i19 = (Math_imul(i3, i10) | 0) + i12 | 0;
    HEAP32[i2 + 20 >> 2] = i19;
    HEAP32[i2 + 12 >> 2] = i19;
    __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
    i19 = i14;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i3 = i2 + 24 | 0;
    HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i3 + 4 >> 2] = i18;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i15 = 17; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i15 = 17; else {
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i4 >> 2] = i3;
     }
    }
    if ((i15 | 0) == 17) {
     i15 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
    }
    if (HEAP32[i17 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i13 | 0)) break L23;
    i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN5physx22PxcHeightFieldAabbTest8IteratorppEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, f22 = f0;
 i19 = i20 + 8 | 0;
 i7 = HEAP32[i19 >> 2] | 0;
 i18 = HEAP32[i20 + 16 >> 2] | 0;
 if ((i7 | 0) == 1) {
  i8 = i20 + 12 | 0;
  i9 = 1;
  i6 = i8;
  i1 = HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0;
  i8 = HEAP32[i8 >> 2] | 0;
 } else {
  i6 = i20 + 12 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0;
  i16 = HEAP32[i1 + 36 >> 2] | 0;
  f2 = Math_fround(HEAP16[i16 + (i8 << 2) >> 1] | 0);
  f3 = Math_fround(HEAP16[i16 + (i8 + 1 << 2) >> 1] | 0);
  i1 = HEAP32[i1 + 20 >> 2] | 0;
  i17 = i1 + i8 | 0;
  f4 = Math_fround(HEAP16[i16 + (i17 << 2) >> 1] | 0);
  f5 = Math_fround(HEAP16[i16 + (i17 + 1 << 2) >> 1] | 0);
  f22 = Math_fround(HEAPF32[i18 + 28 >> 2]);
  if (f22 < f5 & (f22 < f4 & (f22 < f2 & f22 < f3))) i9 = 0; else {
   f22 = Math_fround(HEAPF32[i18 + 24 >> 2]);
   i9 = !(f22 > f5) | f22 > f4 & (f22 > f2 & f22 > f3) ^ 1;
  }
 }
 i17 = HEAP32[i18 + 12 >> 2] | 0;
 i11 = Math_imul(i1, i17) | 0;
 i10 = HEAP32[i18 + 20 >> 2] | 0;
 i11 = i11 + i10 | 0;
 if (i8 >>> 0 >= i11 >>> 0) return i20 | 0;
 i12 = i20 + 4 | 0;
 i13 = i18 + 28 | 0;
 i14 = i18 + 24 | 0;
 i15 = i18 + 16 | 0;
 i16 = i18 + 16 | 0;
 i1 = i8;
 i8 = i9;
 L9 : while (1) {
  L11 : do if (i8) while (1) {
   if (!i7) {
    HEAP32[i19 >> 2] = 1;
    if ((HEAP8[(HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0) + 36 >> 2] | 0) + ((i1 & 2147483647) << 2) + 3 >> 0] & 127) == 127) i7 = 1; else {
     i21 = 22;
     break L9;
    }
   } else {
    HEAP32[i19 >> 2] = 0;
    i9 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
    HEAP32[i12 >> 2] = i9;
    i1 = i1 + 1 | 0;
    HEAP32[i6 >> 2] = i1;
    if ((i9 | 0) != (i10 | 0)) break L11;
    i9 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
    HEAP32[i20 >> 2] = i9;
    i7 = HEAP32[i15 >> 2] | 0;
    i1 = (HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0) - i10 + i7 + i1 | 0;
    HEAP32[i6 >> 2] = i1;
    if ((i9 | 0) != (i17 | 0)) {
     i21 = 17;
     break L11;
    }
    i1 = i10 + i1 - i7 | 0;
    HEAP32[i6 >> 2] = i1;
    i7 = 0;
   }
   if (i1 >>> 0 >= i11 >>> 0) {
    i21 = 22;
    break L9;
   }
  } else while (1) {
   HEAP32[i19 >> 2] = 0;
   i9 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
   HEAP32[i12 >> 2] = i9;
   i1 = i1 + 1 | 0;
   HEAP32[i6 >> 2] = i1;
   if ((i9 | 0) != (i10 | 0)) break L11;
   i9 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
   HEAP32[i20 >> 2] = i9;
   i7 = HEAP32[i16 >> 2] | 0;
   i1 = (HEAP32[(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0) + 20 >> 2] | 0) - i10 + i7 + i1 | 0;
   HEAP32[i6 >> 2] = i1;
   if ((i9 | 0) != (i17 | 0)) {
    i21 = 17;
    break L11;
   }
   i1 = i10 + i1 - i7 | 0;
   HEAP32[i6 >> 2] = i1;
   if (i1 >>> 0 >= i11 >>> 0) {
    i21 = 22;
    break L9;
   }
  } while (0);
  if ((i21 | 0) == 17) {
   i21 = 0;
   HEAP32[i12 >> 2] = i7;
  }
  i9 = HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0;
  i7 = HEAP32[i9 + 36 >> 2] | 0;
  f2 = Math_fround(HEAP16[i7 + (i1 << 2) >> 1] | 0);
  f3 = Math_fround(HEAP16[i7 + (i1 + 1 << 2) >> 1] | 0);
  i9 = (HEAP32[i9 + 20 >> 2] | 0) + i1 | 0;
  f4 = Math_fround(HEAP16[i7 + (i9 << 2) >> 1] | 0);
  f5 = Math_fround(HEAP16[i7 + (i9 + 1 << 2) >> 1] | 0);
  f22 = Math_fround(HEAPF32[i13 >> 2]);
  if (f22 < f5 & (f22 < f4 & (f22 < f2 & f22 < f3))) i8 = 0; else {
   f22 = Math_fround(HEAPF32[i14 >> 2]);
   if (!(f22 > f5) | f22 > f4 & (f22 > f2 & f22 > f3) ^ 1) if ((HEAP8[i7 + ((i1 & 2147483647) << 2) + 2 >> 0] & 127) == 127) i8 = 1; else {
    i21 = 22;
    break;
   } else i8 = 0;
  }
  if (i1 >>> 0 < i11 >>> 0) i7 = 0; else {
   i21 = 22;
   break;
  }
 }
 if ((i21 | 0) == 22) return i20 | 0;
 return 0;
}

function __ZNK14DetailDatabase18GetSupportedLayersEiiiiPi(i6, i14, i16, i4, i5, i19) {
 i6 = i6 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 i17 = i6 + 36 | 0;
 if ((HEAP32[i17 >> 2] | 0) < 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 936627 | 0, 0, gb + 932993 | 0, 122, 1, 0, 0, 0);
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i15 = (HEAP32[i6 + 20 >> 2] | 0) - (HEAP32[i6 + 16 >> 2] | 0) | 0;
 i20 = (i15 | 0) / 136 | 0;
 HEAP32[i22 >> 2] = 0;
 i21 = i22 + 4 | 0;
 i13 = gb + 63160 | 0;
 i18 = HEAP32[i13 + 4 >> 2] | 0;
 i3 = i21;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = i18;
 i3 = i20 << 2;
 do if (!i15) i1 = 0; else {
  i2 = i3 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 128) | 0;
   i13 = gb + 64016 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i22 >> 2] = i1;
   i18 = i21;
   HEAP32[i18 >> 2] = i12;
   HEAP32[i18 + 4 >> 2] = i13;
   break;
  }
 } while (0);
 i13 = i1 + 3 & -4;
 i18 = i13;
 _memset(i13 | 0, 0, i3 | 0) | 0;
 i13 = i6 + 40 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i12 = (i14 | 0) / (i7 | 0) | 0;
 i9 = (HEAP32[i17 >> 2] | 0) + -1 | 0;
 i12 = (i12 | 0) < 0 ? 0 : (i12 | 0) > (i9 | 0) ? i9 : i12;
 i1 = (i16 | 0) / (i7 | 0) | 0;
 i1 = (i1 | 0) < 0 ? 0 : (i1 | 0) > (i9 | 0) ? i9 : i1;
 i11 = i4 + i14 | 0;
 i10 = (i11 | 0) / (i7 | 0) | 0;
 i10 = (i10 | 0) < 0 ? 0 : (i10 | 0) > (i9 | 0) ? i9 : i10;
 i8 = i5 + i16 | 0;
 i7 = (i8 | 0) / (i7 | 0) | 0;
 i7 = (i7 | 0) < 0 ? 0 : (i7 | 0) > (i9 | 0) ? i9 : i7;
 if ((i1 | 0) <= (i7 | 0)) {
  i9 = (i12 | 0) > (i10 | 0);
  i6 = i6 + 4 | 0;
  while (1) {
   if (!i9) {
    i4 = i12;
    while (1) {
     i24 = HEAP32[i13 >> 2] | 0;
     i26 = Math_imul(i24, i4) | 0;
     i25 = i14 - i26 | 0;
     i3 = i24 + -1 | 0;
     i2 = Math_imul(i24, i1) | 0;
     i5 = i16 - i2 | 0;
     i26 = i11 - i26 | 0;
     i2 = i8 - i2 | 0;
     if (!((((i26 | 0) < 0 ? 0 : (i26 | 0) > (i24 | 0) ? i24 : i26) | 0) == (((i25 | 0) < 0 ? 0 : (i25 | 0) > (i3 | 0) ? i3 : i25) | 0) ? 1 : (((i2 | 0) < 0 ? 0 : (i2 | 0) > (i24 | 0) ? i24 : i2) | 0) == (((i5 | 0) < 0 ? 0 : (i5 | 0) > (i3 | 0) ? i3 : i5) | 0))) {
      i3 = (Math_imul(HEAP32[i17 >> 2] | 0, i1) | 0) + i4 | 0;
      i5 = HEAP32[i6 >> 2] | 0;
      i2 = HEAP32[i5 + (i3 * 52 | 0) + 32 >> 2] | 0;
      i3 = HEAP32[i5 + (i3 * 52 | 0) + 28 >> 2] | 0;
      i5 = i3;
      if ((i2 | 0) != (i3 | 0)) {
       i3 = i2 - i3 | 0;
       i2 = 0;
       do {
        HEAP32[i18 + ((HEAPU8[i5 + i2 >> 0] | 0) << 2) >> 2] = 1;
        i2 = i2 + 1 | 0;
       } while (i2 >>> 0 < i3 >>> 0);
      }
     }
     if ((i4 | 0) < (i10 | 0)) i4 = i4 + 1 | 0; else break;
    }
   }
   if ((i1 | 0) < (i7 | 0)) i1 = i1 + 1 | 0; else break;
  }
 }
 L26 : do if ((i15 | 0) > 0) {
  if (!i19) {
   i1 = 0;
   i2 = 0;
   while (1) {
    i1 = i1 + ((HEAP32[i18 + (i2 << 2) >> 2] | 0) != 0 & 1) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i20 | 0)) break L26;
   }
  } else {
   i1 = 0;
   i2 = 0;
  }
  do {
   if (HEAP32[i18 + (i2 << 2) >> 2] | 0) {
    HEAP32[i19 + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i20 | 0));
 } else i1 = 0; while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i21);
 i26 = i1;
 STACKTOP = i23;
 return i26 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i8 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i8 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i8 + 12 | 0;
 i18 = i5 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i8 + 20 | 0;
 i17 = i5 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 6;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i13, i7, i1) {
 i13 = i13 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i6 = i12 + 8 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i13, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i12;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i2 = i5 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i10 = HEAP32[i7 >> 2] | 0;
 i10 = (HEAP32[i10 >> 2] | 0) + i10 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 1041891 | 0, gb + 905830 | 0, 0, 1) | 0;
  i5 = i13 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i13 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i10 | 0)) {
    i4 = i13 + 4 | 0;
    i3 = 0;
    while (1) {
     i3 = (Math_imul(i3, i6) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i3;
     HEAP32[i2 + 12 >> 2] = i3;
     __ZNK16TypeTreeIterator8ChildrenEv(i11, i2);
     i3 = i11;
     i7 = HEAP32[i3 + 4 >> 2] | 0;
     i2 = i2 + 24 | 0;
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = i7;
     i2 = HEAP32[i8 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = HEAP32[i4 >> 2] | 0;
      i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
      HEAP32[i2 >> 2] = 0;
      HEAP32[i2 + 4 >> 2] = 0;
      i3 = i1;
      i2 = i2 | 0 ? i2 - i3 | 0 : 0;
      HEAP32[i1 >> 2] = i2;
     } else i3 = i1;
     __ZN14SafeBinaryRead8TransferIN7mecanim9animation17BlendTreeConstantEEEvRT_PKc17TransferMetaFlags(i13, i2 + i3 | 0, gb + 1041891 | 0, 0);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i10 | 0)) break L15;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i13);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i13);
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i10 | 0)) {
   i4 = i13 + 4 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i13, gb + 1041891 | 0, gb + 905830 | 0, i11, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = HEAP32[i4 >> 2] | 0;
       i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
       HEAP32[i2 >> 2] = 0;
       HEAP32[i2 + 4 >> 2] = 0;
       i3 = i1;
       i2 = i2 | 0 ? i2 - i3 | 0 : 0;
       HEAP32[i1 >> 2] = i2;
      } else i3 = i1;
      __ZN14SafeBinaryRead8TransferIN7mecanim9animation17BlendTreeConstantEEEvRT_PKc17TransferMetaFlags(i13, i2 + i3 | 0, gb + 1041891 | 0, 0);
     } else {
      i2 = HEAP32[i11 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i13 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i13);
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i10 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i13);
 STACKTOP = i12;
 return;
}

function __ZN14RotationModule5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i29;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAP8[i2 + 800 >> 0] = 0;
 i23 = i3 + 4 | 0;
 i24 = i3 + 8 | 0;
 i25 = i3 + 12 | 0;
 i26 = i3 + 16 | 0;
 i27 = i3 + 20 | 0;
 i28 = i3 + 24 | 0;
 i4 = i3 + 28 | 0;
 i5 = i3 + 32 | 0;
 i6 = i3 + 40 | 0;
 i7 = i3 + 44 | 0;
 i8 = i3 + 48 | 0;
 i9 = i3 + 52 | 0;
 i10 = i3 + 56 | 0;
 i11 = i3 + 60 | 0;
 i12 = i3 + 64 | 0;
 i13 = i3 + 68 | 0;
 i14 = i3 + 72 | 0;
 i15 = i3 + 80 | 0;
 i16 = i3 + 88 | 0;
 i17 = i3 + 232 | 0;
 i18 = i3 + 248 | 0;
 i19 = i3 + 236 | 0;
 i20 = i3 + 144 | 0;
 i21 = i3 + 160 | 0;
 i22 = i3 + 148 | 0;
 i1 = 0;
 do {
  __ZN11MinMaxCurveC2Ev(i3);
  i30 = HEAP32[i23 >> 2] | 0;
  i31 = HEAP32[i24 >> 2] | 0;
  i32 = HEAP32[i25 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 4 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 8 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 12 >> 2] = i32;
  i32 = HEAP32[i27 >> 2] | 0;
  i31 = HEAP32[i28 >> 2] | 0;
  i30 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 16 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 20 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 24 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 28 >> 2] = i30;
  i30 = i5;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i32 = i2 + 8 + (i1 * 264 | 0) + 32 | 0;
  HEAP32[i32 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i32 + 4 >> 2] = i31;
  i32 = HEAP32[i7 >> 2] | 0;
  i31 = HEAP32[i8 >> 2] | 0;
  i30 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 40 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 44 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 48 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 52 >> 2] = i30;
  i30 = HEAP32[i11 >> 2] | 0;
  i31 = HEAP32[i12 >> 2] | 0;
  i32 = HEAP32[i13 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 56 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 60 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 64 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 68 >> 2] = i32;
  i32 = i14;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  i30 = i2 + 8 + (i1 * 264 | 0) + 72 | 0;
  HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  i30 = i2 + 8 + (i1 * 264 | 0) + 80 | 0;
  HEAP32[i30 >> 2] = HEAP32[i15 >> 2];
  HEAP16[i30 + 4 >> 1] = HEAP16[i15 + 4 >> 1] | 0;
  HEAP8[i30 + 6 >> 0] = HEAP8[i15 + 6 >> 0] | 0;
  __ZN21MinMaxAnimationCurvesaSERKS_(i2 + 8 + (i1 * 264 | 0) + 88 | 0, i16) | 0;
  if ((HEAP32[i18 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i19);
   HEAP32[i17 >> 2] = 0;
  }
  if ((HEAP32[i21 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i22);
   HEAP32[i20 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 HEAPF32[i2 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 8 | 0, i2 + 96 | 0, Math_fround(0.0), HEAP16[i2 + 92 >> 1] | 0) | 0) & 1;
 HEAPF32[i2 + 352 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 272 | 0, i2 + 360 | 0, Math_fround(0.0), HEAP16[i2 + 356 >> 1] | 0) | 0) & 1;
 HEAPF32[i2 + 616 >> 2] = Math_fround(.785398185);
 HEAP8[i2 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 536 | 0, i2 + 624 | 0, Math_fround(.785398185), HEAP16[i2 + 620 >> 1] | 0) | 0) & 1;
 STACKTOP = i29;
 return;
}

function __ZN14DetailDatabase28GenerateTextureAtlasThreadedEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 24 | 0;
 i12 = i15 + 8 | 0;
 i6 = i15;
 i10 = i9 + 104 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 108 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i3 = i13;
 i5 = i1;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i13 = i12 + 4 | 0;
 i4 = gb + 63160 | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i13;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i3 - i5 | 0;
 do if (!i2) {
  i2 = 0;
  i4 = i5;
 } else {
  i4 = i2 + 3 | 0;
  if (i4 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i4 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = i5;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, gb + 64016 | 0, 0, gb + 932993 | 0, 394) | 0;
   i1 = gb + 64016 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i2;
   i4 = i13;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = i1;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = i4;
   i3 = HEAP32[i11 >> 2] | 0;
   break;
  }
 } while (0);
 i7 = i2 + 3 & -4;
 L10 : do if ((i3 | 0) == (i4 | 0)) {
  i2 = 0;
  i1 = i4;
 } else {
  i2 = 0;
  while (1) {
   HEAP32[i8 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
   i1 = __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i8) | 0;
   if (!i1) break;
   HEAP32[i7 + (i2 << 2) >> 2] = i1;
   i2 = i2 + 1 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if (i2 >>> 0 >= i3 - i1 >> 2 >>> 0) break L10;
  }
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } while (0);
 if ((i2 | 0) == (i3 - i1 >> 2 | 0)) {
  i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 932993 | 0, 409) | 0;
  i2 = gb + 63520 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i6;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i5, i8, 1);
  __Z19pop_allocation_rootv();
  i8 = __ZN6Object24CalculateCachedTypeIndexEPS_(i5) | 0;
  i5 = i9 + 56 | 0;
  HEAP32[i5 >> 2] = i8;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0);
  if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
   i8 = HEAP32[i5 >> 2] | 0;
   mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 188 >> 2] | 0, i8 | 0, 2, 2, 5, 1, 1, -1, 0) | 0;
  }
  i6 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  i6 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, 61);
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) << 2, 16, gb + 63312 | 0, 0, gb + 932993 | 0, 420) | 0;
  HEAP32[i9 + 116 >> 2] = i6;
  i11 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
  i2 = i11 >> 2;
  i3 = HEAP32[i5 >> 2] | 0;
  L22 : do if ((i11 | 0) > 0) {
   i1 = 0;
   while (1) {
    i4 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
    if (i4 | 0) if (HEAP32[i4 + 60 >> 2] | 0) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i14 = 19;
     break L22;
    }
   }
   __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
  } else i14 = 19; while (0);
  if ((i14 | 0) == 19) __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 0);
  __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb(HEAP32[i5 >> 2] | 0, 2048, i2, i7, i6, 0, 0, 0) | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i13);
 STACKTOP = i15;
 return;
}

function runPostSets209() {
 HEAP32[gb + 176796 >> 2] = fb + 3;
 HEAP32[gb + 176800 >> 2] = fb + 4;
 HEAP32[gb + 176804 >> 2] = fb + 256;
 HEAP32[gb + 176808 >> 2] = fb + 144;
 HEAP32[gb + 176812 >> 2] = fb + 4;
 HEAP32[gb + 176816 >> 2] = fb + 2;
 HEAP32[gb + 176820 >> 2] = fb + 1258;
 HEAP32[gb + 176824 >> 2] = fb + 439;
 HEAP32[gb + 176828 >> 2] = fb + 2738;
 HEAP32[gb + 176832 >> 2] = fb + 268;
 HEAP32[gb + 176836 >> 2] = fb + 24;
 HEAP32[gb + 176840 >> 2] = fb + 2066;
 HEAP32[gb + 176844 >> 2] = fb + 156;
 HEAP32[gb + 176848 >> 2] = fb + 1259;
 HEAP32[gb + 176852 >> 2] = fb + 2067;
 HEAP32[gb + 176856 >> 2] = fb + 450;
 HEAP32[gb + 176860 >> 2] = fb + 2;
 HEAP32[gb + 176864 >> 2] = fb + 2068;
 HEAP32[gb + 176868 >> 2] = fb + 2739;
 HEAP32[gb + 176872 >> 2] = fb + 2740;
 HEAP32[gb + 176876 >> 2] = fb + 2069;
 HEAP32[gb + 176880 >> 2] = fb + 1260;
 HEAP32[gb + 176884 >> 2] = fb + 1261;
 HEAP32[gb + 176888 >> 2] = fb + 440;
 HEAP32[gb + 176892 >> 2] = fb + 1262;
 HEAP32[gb + 176896 >> 2] = fb + 2070;
 HEAP32[gb + 176900 >> 2] = fb + 2071;
 HEAP32[gb + 176904 >> 2] = fb + 2072;
 HEAP32[gb + 176916 >> 2] = fb + 2741;
 HEAP32[gb + 176920 >> 2] = fb + 2742;
 HEAP32[gb + 176924 >> 2] = fb + 143;
 HEAP32[gb + 176928 >> 2] = fb + 13;
 HEAP32[gb + 176932 >> 2] = fb + 2;
 HEAP32[gb + 176936 >> 2] = fb + 3;
 HEAP32[gb + 176940 >> 2] = fb + 3;
 HEAP32[gb + 176944 >> 2] = fb + 4;
 HEAP32[gb + 176948 >> 2] = fb + 256;
 HEAP32[gb + 176952 >> 2] = fb + 144;
 HEAP32[gb + 176956 >> 2] = fb + 4;
 HEAP32[gb + 176960 >> 2] = fb + 2;
 HEAP32[gb + 176964 >> 2] = fb + 1263;
 HEAP32[gb + 176968 >> 2] = fb + 441;
 HEAP32[gb + 176972 >> 2] = fb + 2743;
 HEAP32[gb + 176976 >> 2] = fb + 269;
 HEAP32[gb + 176980 >> 2] = fb + 24;
 HEAP32[gb + 176984 >> 2] = fb + 2073;
 HEAP32[gb + 176988 >> 2] = fb + 157;
 HEAP32[gb + 176992 >> 2] = fb + 1259;
 HEAP32[gb + 176996 >> 2] = fb + 2067;
 HEAP32[gb + 177e3 >> 2] = fb + 450;
 HEAP32[gb + 177004 >> 2] = fb + 3;
 HEAP32[gb + 177008 >> 2] = fb + 2068;
 HEAP32[gb + 177012 >> 2] = fb + 2739;
 HEAP32[gb + 177016 >> 2] = fb + 2744;
 HEAP32[gb + 177020 >> 2] = fb + 2069;
 HEAP32[gb + 177024 >> 2] = fb + 1260;
 HEAP32[gb + 177028 >> 2] = fb + 1261;
 HEAP32[gb + 177032 >> 2] = fb + 440;
 HEAP32[gb + 177036 >> 2] = fb + 1262;
 HEAP32[gb + 177040 >> 2] = fb + 2070;
 HEAP32[gb + 177044 >> 2] = fb + 2071;
 HEAP32[gb + 177048 >> 2] = fb + 2072;
 HEAP32[gb + 177052 >> 2] = fb + 442;
 HEAP32[gb + 177056 >> 2] = fb + 443;
 HEAP32[gb + 177068 >> 2] = fb + 2736;
 HEAP32[gb + 177072 >> 2] = fb + 2745;
 HEAP32[gb + 177076 >> 2] = fb + 143;
 HEAP32[gb + 177080 >> 2] = fb + 13;
 HEAP32[gb + 177084 >> 2] = fb + 2;
 HEAP32[gb + 177088 >> 2] = fb + 3;
 HEAP32[gb + 177092 >> 2] = fb + 3;
 HEAP32[gb + 177096 >> 2] = fb + 4;
 HEAP32[gb + 177100 >> 2] = fb + 256;
 HEAP32[gb + 177104 >> 2] = fb + 144;
 HEAP32[gb + 177108 >> 2] = fb + 4;
 HEAP32[gb + 177112 >> 2] = fb + 2;
 HEAP32[gb + 177116 >> 2] = fb + 1264;
 HEAP32[gb + 177120 >> 2] = fb + 444;
 HEAP32[gb + 177124 >> 2] = fb + 2738;
 HEAP32[gb + 177128 >> 2] = fb + 270;
 HEAP32[gb + 177132 >> 2] = fb + 24;
 HEAP32[gb + 177136 >> 2] = fb + 2066;
 HEAP32[gb + 177140 >> 2] = fb + 158;
 HEAP32[gb + 177144 >> 2] = fb + 1265;
 HEAP32[gb + 177148 >> 2] = fb + 2067;
 HEAP32[gb + 177152 >> 2] = fb + 450;
 HEAP32[gb + 177156 >> 2] = fb + 2;
 HEAP32[gb + 177160 >> 2] = fb + 2068;
 HEAP32[gb + 177164 >> 2] = fb + 2739;
 HEAP32[gb + 177168 >> 2] = fb + 2740;
 HEAP32[gb + 177172 >> 2] = fb + 2069;
 HEAP32[gb + 177176 >> 2] = fb + 1260;
 HEAP32[gb + 177180 >> 2] = fb + 1261;
 HEAP32[gb + 177184 >> 2] = fb + 440;
 HEAP32[gb + 177188 >> 2] = fb + 1262;
 HEAP32[gb + 177192 >> 2] = fb + 2070;
 HEAP32[gb + 177196 >> 2] = fb + 2071;
 HEAP32[gb + 177200 >> 2] = fb + 2072;
 HEAP32[gb + 177212 >> 2] = fb + 2736;
 HEAP32[gb + 177216 >> 2] = fb + 2746;
 runPostSets210();
}

function runPostSets118() {
 HEAP32[gb + 104344 >> 2] = fb + 793;
 HEAP32[gb + 104348 >> 2] = fb + 1127;
 HEAP32[gb + 104352 >> 2] = fb + 1128;
 HEAP32[gb + 104356 >> 2] = fb + 469;
 HEAP32[gb + 104360 >> 2] = fb + 1129;
 HEAP32[gb + 104364 >> 2] = fb + 1562;
 HEAP32[gb + 104376 >> 2] = fb + 1563;
 HEAP32[gb + 104380 >> 2] = fb + 1564;
 HEAP32[gb + 104384 >> 2] = fb + 1258;
 HEAP32[gb + 104388 >> 2] = fb + 794;
 HEAP32[gb + 104392 >> 2] = fb + 1127;
 HEAP32[gb + 104396 >> 2] = fb + 1128;
 HEAP32[gb + 104400 >> 2] = fb + 469;
 HEAP32[gb + 104404 >> 2] = fb + 1129;
 HEAP32[gb + 104408 >> 2] = fb + 1565;
 HEAP32[gb + 104420 >> 2] = fb + 1125;
 HEAP32[gb + 104424 >> 2] = fb + 1566;
 HEAP32[gb + 104428 >> 2] = fb + 1258;
 HEAP32[gb + 104432 >> 2] = fb + 795;
 HEAP32[gb + 104436 >> 2] = fb + 1127;
 HEAP32[gb + 104440 >> 2] = fb + 1128;
 HEAP32[gb + 104444 >> 2] = fb + 469;
 HEAP32[gb + 104448 >> 2] = fb + 1129;
 HEAP32[gb + 104452 >> 2] = fb + 1567;
 HEAP32[gb + 104464 >> 2] = fb + 1568;
 HEAP32[gb + 104468 >> 2] = fb + 1569;
 HEAP32[gb + 104472 >> 2] = fb + 1258;
 HEAP32[gb + 104476 >> 2] = fb + 796;
 HEAP32[gb + 104480 >> 2] = fb + 1127;
 HEAP32[gb + 104484 >> 2] = fb + 1128;
 HEAP32[gb + 104488 >> 2] = fb + 469;
 HEAP32[gb + 104492 >> 2] = fb + 1129;
 HEAP32[gb + 104496 >> 2] = fb + 1570;
 HEAP32[gb + 104508 >> 2] = fb + 1125;
 HEAP32[gb + 104512 >> 2] = fb + 1571;
 HEAP32[gb + 104516 >> 2] = fb + 1258;
 HEAP32[gb + 104520 >> 2] = fb + 797;
 HEAP32[gb + 104524 >> 2] = fb + 1127;
 HEAP32[gb + 104528 >> 2] = fb + 1128;
 HEAP32[gb + 104532 >> 2] = fb + 469;
 HEAP32[gb + 104536 >> 2] = fb + 1129;
 HEAP32[gb + 104540 >> 2] = fb + 1572;
 HEAP32[gb + 104552 >> 2] = fb + 1573;
 HEAP32[gb + 104556 >> 2] = fb + 1574;
 HEAP32[gb + 104560 >> 2] = fb + 1258;
 HEAP32[gb + 104564 >> 2] = fb + 798;
 HEAP32[gb + 104568 >> 2] = fb + 1127;
 HEAP32[gb + 104572 >> 2] = fb + 1128;
 HEAP32[gb + 104576 >> 2] = fb + 469;
 HEAP32[gb + 104580 >> 2] = fb + 1129;
 HEAP32[gb + 104584 >> 2] = fb + 1575;
 HEAP32[gb + 104596 >> 2] = fb + 1125;
 HEAP32[gb + 104600 >> 2] = fb + 1576;
 HEAP32[gb + 104604 >> 2] = fb + 1258;
 HEAP32[gb + 104608 >> 2] = fb + 799;
 HEAP32[gb + 104612 >> 2] = fb + 1127;
 HEAP32[gb + 104616 >> 2] = fb + 1128;
 HEAP32[gb + 104620 >> 2] = fb + 469;
 HEAP32[gb + 104624 >> 2] = fb + 1129;
 HEAP32[gb + 104628 >> 2] = fb + 1577;
 HEAP32[gb + 104632 >> 2] = fb + 32;
 HEAP32[gb + 104636 >> 2] = fb + 33;
 HEAP32[gb + 104640 >> 2] = fb + 34;
 HEAP32[gb + 104644 >> 2] = fb + 35;
 HEAP32[gb + 104648 >> 2] = fb + 36;
 HEAP32[gb + 104652 >> 2] = fb + 37;
 HEAP32[gb + 104656 >> 2] = fb + 38;
 HEAP32[gb + 104664 >> 2] = fb + 38;
 HEAP32[gb + 104668 >> 2] = fb + 39;
 HEAP32[gb + 104672 >> 2] = fb + 40;
 HEAP32[gb + 104676 >> 2] = fb + 41;
 HEAP32[gb + 104680 >> 2] = fb + 38;
 HEAP32[gb + 104684 >> 2] = fb + 38;
 HEAP32[gb + 104696 >> 2] = fb + 42;
 HEAP32[gb + 104700 >> 2] = fb + 43;
 HEAP32[gb + 104704 >> 2] = fb + 44;
 HEAP32[gb + 104708 >> 2] = fb + 45;
 HEAP32[gb + 104712 >> 2] = fb + 38;
 HEAP32[gb + 104728 >> 2] = fb + 46;
 HEAP32[gb + 104732 >> 2] = fb + 47;
 HEAP32[gb + 104736 >> 2] = fb + 48;
 HEAP32[gb + 104740 >> 2] = fb + 38;
 HEAP32[gb + 104760 >> 2] = fb + 49;
 HEAP32[gb + 104764 >> 2] = fb + 50;
 HEAP32[gb + 104768 >> 2] = fb + 38;
 HEAP32[gb + 104792 >> 2] = fb + 38;
 HEAP32[gb + 104796 >> 2] = fb + 38;
 HEAP32[gb + 104824 >> 2] = fb + 38;
 HEAP32[gb + 104828 >> 2] = fb + 98;
 HEAP32[gb + 104832 >> 2] = fb + 98;
 HEAP32[gb + 104836 >> 2] = fb + 98;
 HEAP32[gb + 104840 >> 2] = fb + 98;
 HEAP32[gb + 104844 >> 2] = fb + 98;
 HEAP32[gb + 104848 >> 2] = fb + 99;
 HEAP32[gb + 104852 >> 2] = fb + 100;
 HEAP32[gb + 104864 >> 2] = fb + 98;
 HEAP32[gb + 104868 >> 2] = fb + 98;
 HEAP32[gb + 104872 >> 2] = fb + 98;
 HEAP32[gb + 104892 >> 2] = fb + 98;
 HEAP32[gb + 104896 >> 2] = fb + 98;
 runPostSets119();
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 76 | 0, 4) | 0;
  i2 = i4 + (i1 * 76 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 60 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 64 >> 2] = Math_fround(-1.0);
    HEAP32[i1 + 68 >> 2] = 1065353216;
    HEAP32[i1 + 72 >> 2] = 3;
    i1 = i1 + 76 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) * 76 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906527 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN4math4Axes8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 76 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906527 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4math4Axes8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 76 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(i2, i9, i11) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 24 | 0;
 i6 = i15 + 16 | 0;
 i12 = i15;
 i13 = i15 + 8 | 0;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((__Z24GetExecutionRestrictionsv() | 0) & 4 | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 465098 | 0, 0, gb + 465174 | 0, 324, 512, 0, 0, 0);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i2 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 L7 : do if ((i1 | 0) > 0) {
  i8 = i2 + 28 | 0;
  L9 : do if (!i5) {
   i3 = 0;
   while (1) {
    i2 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i3 << 3) >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
     i2 = HEAP32[i2 + (i3 << 3) + 4 >> 2] | 0;
     if (HEAP32[i2 + 20 >> 2] | 0) {
      __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc(i12, __ZNK13MonoBehaviour8GetClassEv(i2) | 0, i9);
      if (HEAP32[i12 >> 2] | 0) break;
      i1 = HEAP32[i10 >> 2] | 0;
     }
    }
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i1 | 0)) {
     i2 = 0;
     i1 = 0;
     break L7;
    }
   }
   i9 = i12;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i13;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i10;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i2, i14, i11) | 0;
  } else {
   i1 = 0;
   i4 = 0;
   while (1) {
    i2 = HEAP32[i8 >> 2] | 0;
    do if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i4 << 3) >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
     i2 = HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0;
     if (HEAP32[i2 + 20 >> 2] | 0) {
      __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc(i12, __ZNK13MonoBehaviour8GetClassEv(i2) | 0, i9);
      if (!(HEAP32[i12 >> 2] | 0)) break;
      i16 = i12;
      i3 = HEAP32[i16 + 4 >> 2] | 0;
      i1 = i13;
      HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i1 + 4 >> 2] = i3;
      HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
      __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i2, i14, i11) | 0;
      HEAP32[i6 >> 2] = i5;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i7 = 20; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i3 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i6);
        i2 = HEAP32[i14 >> 2] | 0;
        i16 = HEAP32[i1 + 28 >> 2] | 0;
        i3 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
        i2 = HEAP32[i3 + 28 >> 2] | 0;
        i3 = HEAP32[i3 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 20; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 22;
      }
      if ((i7 | 0) == 20) i7 = 22;
      if ((i7 | 0) == 22) {
       i7 = 0;
       if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) break L9;
      }
      i1 = 1;
     }
    } while (0);
    i4 = i4 + 1 | 0;
    if ((i4 | 0) >= (HEAP32[i10 >> 2] | 0)) {
     i2 = 0;
     break L7;
    }
   }
  } while (0);
  i2 = 1;
  i1 = 1;
 } else {
  i2 = 0;
  i1 = 0;
 } while (0);
 i16 = i2 | i1;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 76 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 837834 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 76 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   i12 = i2 + 68 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 68 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 76 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 76 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i4 + (i1 * 76 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 48 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 52 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 56 >> 2] = HEAP32[i6 + 56 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 60 >> 2] = HEAP32[i6 + 60 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 64 >> 2] = HEAP32[i6 + 64 >> 2];
 i10 = i6 + 68 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 * 76 | 0) + 68 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 * 76 | 0) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 * 76 | 0) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 * 76 | 0) | 0;
 return i12 | 0;
}

function __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = HEAP32[i4 + 20 >> 2] | 0;
 if (!i15) return;
 i14 = HEAP32[i4 + 16 >> 2] | 0;
 i13 = (HEAP8[i14 >> 0] | 0) == 4 ? 176 : 112;
 i1 = HEAP8[i14 + 1 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i9 = 0;
  i4 = 0;
  i2 = 0;
  i8 = 0;
  i3 = 0;
  i1 = 0;
 } else {
  i10 = i1 & 255;
  i3 = 0;
  i8 = 0;
  i9 = 0;
  i2 = 0;
  i4 = 0;
  i1 = 0;
  i11 = i14 + 48 | 0;
  i12 = 0;
  while (1) {
   if (HEAP32[i11 + 108 >> 2] & 2) {
    f7 = Math_fround(HEAPF32[i11 + 104 >> 2]);
    f16 = Math_fround(f7 * Math_fround(HEAPF32[i11 >> 2]));
    f6 = Math_fround(f7 * Math_fround(HEAPF32[i11 + 4 >> 2]));
    f5 = Math_fround(f7 * Math_fround(HEAPF32[i11 + 8 >> 2]));
    f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f16);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
    i8 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f5);
    i9 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    f5 = Math_fround(f7 * Math_fround(HEAPF32[i11 + 32 >> 2]));
    f6 = Math_fround(f7 * Math_fround(HEAPF32[i11 + 36 >> 2]));
    f7 = Math_fround(f7 * Math_fround(HEAPF32[i11 + 40 >> 2]));
    f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f5);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
    f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
    f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f7);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   }
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= i10 >>> 0) break; else i11 = i11 + i13 | 0;
  }
 }
 f5 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f18 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f18 * f5);
 f6 = Math_fround(HEAPF32[i14 + 24 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 - Math_fround(f17 * f6));
 f16 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f16 * f6);
 f19 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f18 * f19));
 f5 = Math_fround(Math_fround(f17 * f19) - Math_fround(f16 * f5));
 f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f7);
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f6);
 f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f5);
 HEAP32[i15 >> 2] = i3;
 HEAP32[i15 + 4 >> 2] = i8;
 HEAP32[i15 + 8 >> 2] = i9;
 HEAPF32[i15 + 16 >> 2] = f7;
 HEAPF32[i15 + 20 >> 2] = f6;
 HEAPF32[i15 + 24 >> 2] = f5;
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(f18 * f18) + Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)))));
 if (f16 > Math_fround(HEAPF32[i14 + 4 >> 2])) i1 = 1; else {
  f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)))));
  i1 = f19 > Math_fround(HEAPF32[i14 + 8 >> 2]);
 }
 HEAP32[i15 + 12 >> 2] = i1 & 1;
 return;
}

function runPostSets210() {
 HEAP32[gb + 177220 >> 2] = fb + 143;
 HEAP32[gb + 177224 >> 2] = fb + 13;
 HEAP32[gb + 177228 >> 2] = fb + 2;
 HEAP32[gb + 177232 >> 2] = fb + 3;
 HEAP32[gb + 177236 >> 2] = fb + 3;
 HEAP32[gb + 177240 >> 2] = fb + 4;
 HEAP32[gb + 177244 >> 2] = fb + 256;
 HEAP32[gb + 177248 >> 2] = fb + 144;
 HEAP32[gb + 177252 >> 2] = fb + 4;
 HEAP32[gb + 177256 >> 2] = fb + 2;
 HEAP32[gb + 177260 >> 2] = fb + 1258;
 HEAP32[gb + 177264 >> 2] = fb + 439;
 HEAP32[gb + 177268 >> 2] = fb + 2747;
 HEAP32[gb + 177272 >> 2] = fb + 268;
 HEAP32[gb + 177276 >> 2] = fb + 24;
 HEAP32[gb + 177280 >> 2] = fb + 2074;
 HEAP32[gb + 177284 >> 2] = fb + 159;
 HEAP32[gb + 177288 >> 2] = fb + 1259;
 HEAP32[gb + 177292 >> 2] = fb + 2067;
 HEAP32[gb + 177296 >> 2] = fb + 451;
 HEAP32[gb + 177300 >> 2] = fb + 2;
 HEAP32[gb + 177304 >> 2] = fb + 2068;
 HEAP32[gb + 177308 >> 2] = fb + 2739;
 HEAP32[gb + 177312 >> 2] = fb + 2740;
 HEAP32[gb + 177316 >> 2] = fb + 2069;
 HEAP32[gb + 177320 >> 2] = fb + 1260;
 HEAP32[gb + 177324 >> 2] = fb + 1261;
 HEAP32[gb + 177328 >> 2] = fb + 440;
 HEAP32[gb + 177332 >> 2] = fb + 1262;
 HEAP32[gb + 177336 >> 2] = fb + 2070;
 HEAP32[gb + 177340 >> 2] = fb + 2071;
 HEAP32[gb + 177344 >> 2] = fb + 2072;
 HEAP32[gb + 177356 >> 2] = fb + 2748;
 HEAP32[gb + 177360 >> 2] = fb + 2749;
 HEAP32[gb + 177364 >> 2] = fb + 143;
 HEAP32[gb + 177368 >> 2] = fb + 452;
 HEAP32[gb + 177372 >> 2] = fb + 4;
 HEAP32[gb + 177376 >> 2] = fb + 3;
 HEAP32[gb + 177380 >> 2] = fb + 5;
 HEAP32[gb + 177384 >> 2] = fb + 6;
 HEAP32[gb + 177388 >> 2] = fb + 256;
 HEAP32[gb + 177392 >> 2] = fb + 144;
 HEAP32[gb + 177396 >> 2] = fb + 4;
 HEAP32[gb + 177400 >> 2] = fb + 2;
 HEAP32[gb + 177404 >> 2] = fb + 1266;
 HEAP32[gb + 177408 >> 2] = fb + 445;
 HEAP32[gb + 177412 >> 2] = fb + 2750;
 HEAP32[gb + 177416 >> 2] = fb + 268;
 HEAP32[gb + 177420 >> 2] = fb + 24;
 HEAP32[gb + 177424 >> 2] = fb + 2075;
 HEAP32[gb + 177428 >> 2] = fb + 160;
 HEAP32[gb + 177432 >> 2] = fb + 1259;
 HEAP32[gb + 177436 >> 2] = fb + 2076;
 HEAP32[gb + 177440 >> 2] = fb + 450;
 HEAP32[gb + 177444 >> 2] = fb + 4;
 HEAP32[gb + 177448 >> 2] = fb + 2068;
 HEAP32[gb + 177452 >> 2] = fb + 2739;
 HEAP32[gb + 177456 >> 2] = fb + 2751;
 HEAP32[gb + 177460 >> 2] = fb + 2069;
 HEAP32[gb + 177464 >> 2] = fb + 1260;
 HEAP32[gb + 177468 >> 2] = fb + 1261;
 HEAP32[gb + 177472 >> 2] = fb + 440;
 HEAP32[gb + 177476 >> 2] = fb + 1267;
 HEAP32[gb + 177480 >> 2] = fb + 2077;
 HEAP32[gb + 177484 >> 2] = fb + 2071;
 HEAP32[gb + 177488 >> 2] = fb + 2072;
 HEAP32[gb + 177500 >> 2] = fb + 2752;
 HEAP32[gb + 177504 >> 2] = fb + 2753;
 HEAP32[gb + 177516 >> 2] = fb + 271;
 HEAP32[gb + 177520 >> 2] = fb + 2078;
 HEAP32[gb + 177532 >> 2] = fb + 2754;
 HEAP32[gb + 177536 >> 2] = fb + 2755;
 HEAP32[gb + 177540 >> 2] = fb + 1268;
 HEAP32[gb + 177544 >> 2] = fb + 453;
 HEAP32[gb + 177548 >> 2] = fb + 2;
 HEAP32[gb + 177552 >> 2] = fb + 3;
 HEAP32[gb + 177556 >> 2] = fb + 3;
 HEAP32[gb + 177560 >> 2] = fb + 4;
 HEAP32[gb + 177564 >> 2] = fb + 2079;
 HEAP32[gb + 177568 >> 2] = fb + 144;
 HEAP32[gb + 177572 >> 2] = fb + 4;
 HEAP32[gb + 177576 >> 2] = fb + 2;
 HEAP32[gb + 177580 >> 2] = fb + 1269;
 HEAP32[gb + 177584 >> 2] = fb + 446;
 HEAP32[gb + 177588 >> 2] = fb + 2756;
 HEAP32[gb + 177592 >> 2] = fb + 268;
 HEAP32[gb + 177596 >> 2] = fb + 24;
 HEAP32[gb + 177600 >> 2] = fb + 2066;
 HEAP32[gb + 177604 >> 2] = fb + 161;
 HEAP32[gb + 177608 >> 2] = fb + 1259;
 HEAP32[gb + 177612 >> 2] = fb + 2080;
 HEAP32[gb + 177616 >> 2] = fb + 454;
 HEAP32[gb + 177620 >> 2] = fb + 2;
 HEAP32[gb + 177624 >> 2] = fb + 2081;
 HEAP32[gb + 177628 >> 2] = fb + 2757;
 HEAP32[gb + 177632 >> 2] = fb + 2758;
 HEAP32[gb + 177636 >> 2] = fb + 2082;
 HEAP32[gb + 177640 >> 2] = fb + 1260;
 HEAP32[gb + 177644 >> 2] = fb + 1261;
 HEAP32[gb + 177648 >> 2] = fb + 447;
 runPostSets211();
}

function runPostSets121() {
 HEAP32[gb + 106464 >> 2] = fb + 814;
 HEAP32[gb + 106468 >> 2] = fb + 1127;
 HEAP32[gb + 106472 >> 2] = fb + 1128;
 HEAP32[gb + 106476 >> 2] = fb + 469;
 HEAP32[gb + 106480 >> 2] = fb + 1129;
 HEAP32[gb + 106484 >> 2] = fb + 1624;
 HEAP32[gb + 106496 >> 2] = fb + 1125;
 HEAP32[gb + 106500 >> 2] = fb + 1625;
 HEAP32[gb + 106504 >> 2] = fb + 1258;
 HEAP32[gb + 106508 >> 2] = fb + 815;
 HEAP32[gb + 106512 >> 2] = fb + 1127;
 HEAP32[gb + 106516 >> 2] = fb + 1128;
 HEAP32[gb + 106520 >> 2] = fb + 469;
 HEAP32[gb + 106524 >> 2] = fb + 1129;
 HEAP32[gb + 106528 >> 2] = fb + 1626;
 HEAP32[gb + 106540 >> 2] = fb + 1125;
 HEAP32[gb + 106544 >> 2] = fb + 1627;
 HEAP32[gb + 106548 >> 2] = fb + 1258;
 HEAP32[gb + 106552 >> 2] = fb + 816;
 HEAP32[gb + 106556 >> 2] = fb + 1127;
 HEAP32[gb + 106560 >> 2] = fb + 1128;
 HEAP32[gb + 106564 >> 2] = fb + 469;
 HEAP32[gb + 106568 >> 2] = fb + 1129;
 HEAP32[gb + 106572 >> 2] = fb + 1628;
 HEAP32[gb + 106584 >> 2] = fb + 1125;
 HEAP32[gb + 106588 >> 2] = fb + 1629;
 HEAP32[gb + 106592 >> 2] = fb + 1258;
 HEAP32[gb + 106596 >> 2] = fb + 817;
 HEAP32[gb + 106600 >> 2] = fb + 1127;
 HEAP32[gb + 106604 >> 2] = fb + 1128;
 HEAP32[gb + 106608 >> 2] = fb + 469;
 HEAP32[gb + 106612 >> 2] = fb + 1129;
 HEAP32[gb + 106616 >> 2] = fb + 1630;
 HEAP32[gb + 106628 >> 2] = fb + 1125;
 HEAP32[gb + 106632 >> 2] = fb + 1631;
 HEAP32[gb + 106636 >> 2] = fb + 1258;
 HEAP32[gb + 106640 >> 2] = fb + 818;
 HEAP32[gb + 106644 >> 2] = fb + 1127;
 HEAP32[gb + 106648 >> 2] = fb + 1128;
 HEAP32[gb + 106652 >> 2] = fb + 469;
 HEAP32[gb + 106656 >> 2] = fb + 1129;
 HEAP32[gb + 106660 >> 2] = fb + 1632;
 HEAP32[gb + 106672 >> 2] = fb + 1633;
 HEAP32[gb + 106676 >> 2] = fb + 1634;
 HEAP32[gb + 106680 >> 2] = fb + 1;
 HEAP32[gb + 106684 >> 2] = fb + 1;
 HEAP32[gb + 106688 >> 2] = fb + 1;
 HEAP32[gb + 106692 >> 2] = fb + 1;
 HEAP32[gb + 106696 >> 2] = fb + 1;
 HEAP32[gb + 106700 >> 2] = fb + 1;
 HEAP32[gb + 106712 >> 2] = fb + 1125;
 HEAP32[gb + 106716 >> 2] = fb + 1635;
 HEAP32[gb + 106720 >> 2] = fb + 1258;
 HEAP32[gb + 106724 >> 2] = fb + 819;
 HEAP32[gb + 106728 >> 2] = fb + 1127;
 HEAP32[gb + 106732 >> 2] = fb + 1128;
 HEAP32[gb + 106736 >> 2] = fb + 469;
 HEAP32[gb + 106740 >> 2] = fb + 1129;
 HEAP32[gb + 106744 >> 2] = fb + 1636;
 HEAP32[gb + 106756 >> 2] = fb + 1637;
 HEAP32[gb + 106760 >> 2] = fb + 1638;
 HEAP32[gb + 106764 >> 2] = fb + 257;
 HEAP32[gb + 106768 >> 2] = fb + 820;
 HEAP32[gb + 106780 >> 2] = fb + 1;
 HEAP32[gb + 106784 >> 2] = fb + 821;
 HEAP32[gb + 106788 >> 2] = fb + 456;
 HEAP32[gb + 106792 >> 2] = fb + 1270;
 HEAP32[gb + 106796 >> 2] = fb + 1639;
 HEAP32[gb + 106800 >> 2] = fb + 341;
 HEAP32[gb + 106804 >> 2] = fb + 1;
 HEAP32[gb + 106808 >> 2] = fb + 1;
 HEAP32[gb + 106812 >> 2] = fb + 1;
 HEAP32[gb + 106816 >> 2] = fb + 1;
 HEAP32[gb + 106820 >> 2] = fb + 1;
 HEAP32[gb + 106824 >> 2] = fb + 1;
 HEAP32[gb + 106828 >> 2] = fb + 1;
 HEAP32[gb + 106832 >> 2] = fb + 1;
 HEAP32[gb + 106836 >> 2] = fb + 1;
 HEAP32[gb + 106840 >> 2] = fb + 1;
 HEAP32[gb + 106844 >> 2] = fb + 1;
 HEAP32[gb + 106848 >> 2] = fb + 1;
 HEAP32[gb + 106852 >> 2] = fb + 1;
 HEAP32[gb + 106856 >> 2] = fb + 1;
 HEAP32[gb + 106860 >> 2] = fb + 1;
 HEAP32[gb + 106872 >> 2] = fb + 1640;
 HEAP32[gb + 106876 >> 2] = fb + 821;
 HEAP32[gb + 106880 >> 2] = fb + 456;
 HEAP32[gb + 106884 >> 2] = fb + 1641;
 HEAP32[gb + 106888 >> 2] = fb + 1642;
 HEAP32[gb + 106892 >> 2] = fb + 341;
 HEAP32[gb + 106896 >> 2] = fb + 822;
 HEAP32[gb + 106900 >> 2] = fb + 823;
 HEAP32[gb + 106904 >> 2] = fb + 824;
 HEAP32[gb + 106908 >> 2] = fb + 825;
 HEAP32[gb + 106912 >> 2] = fb + 826;
 HEAP32[gb + 106916 >> 2] = fb + 827;
 HEAP32[gb + 106920 >> 2] = fb + 167;
 HEAP32[gb + 106924 >> 2] = fb + 168;
 HEAP32[gb + 106928 >> 2] = fb + 169;
 HEAP32[gb + 106932 >> 2] = fb + 170;
 runPostSets122();
}

function __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i8 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i8 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i8 + 12 | 0;
 i18 = i5 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i8 + 20 | 0;
 i17 = i5 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 6;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function _tt_cmap4_validate(i7, i20) {
 i7 = i7 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = i20 + 8 | 0;
 if ((i7 + 4 | 0) >>> 0 > (HEAP32[i21 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i20, 8);
 i1 = (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
 if ((i7 + i1 | 0) >>> 0 > (HEAP32[i21 >> 2] | 0) >>> 0) {
  if (HEAP32[i20 + 12 >> 2] | 0) _UNITY_ft_validator_error(i20, 8);
  i1 = (HEAP32[i21 >> 2] | 0) - i7 | 0;
 }
 if (i1 >>> 0 < 16) _UNITY_ft_validator_error(i20, 8);
 i18 = HEAPU8[i7 + 7 >> 0] | 0;
 i2 = (HEAPU8[i7 + 6 >> 0] | 0) << 8 | i18;
 i19 = i20 + 12 | 0;
 if (!((HEAP32[i19 >> 2] | 0) >>> 0 < 2 | (i18 & 1 | 0) == 0)) _UNITY_ft_validator_error(i20, 8);
 i18 = i2 >>> 1;
 i5 = i18 << 1;
 if (i1 >>> 0 < ((i18 << 3) + 16 | 0) >>> 0) _UNITY_ft_validator_error(i20, 8);
 if ((HEAP32[i19 >> 2] | 0) >>> 0 > 1) {
  i17 = HEAP8[i7 + 9 >> 0] | 0;
  i2 = (HEAPU8[i7 + 8 >> 0] | 0) << 8 | i17 & 255;
  i3 = (HEAPU8[i7 + 10 >> 0] | 0) << 8 | (HEAPU8[i7 + 11 >> 0] | 0);
  i16 = HEAP8[i7 + 13 >> 0] | 0;
  i4 = (HEAPU8[i7 + 12 >> 0] | 0) << 8 | i16 & 255;
  if ((i16 | i17) & 1) _UNITY_ft_validator_error(i20, 8);
  i17 = i2 >>> 1;
  if (!((i17 | 0) == (1 << i3 | 0) & (i17 >>> 0 <= i18 >>> 0 & i17 << 1 >>> 0 >= i18 >>> 0 & ((i4 >>> 1) + i17 | 0) == (i18 | 0)))) _UNITY_ft_validator_error(i20, 8);
 }
 i4 = i7 + 14 | 0;
 i6 = i7 + 16 + i5 | 0;
 i3 = i6 + i5 | 0;
 i2 = i3 + i5 | 0;
 i17 = i2 + i5 | 0;
 if ((HEAP32[i19 >> 2] | 0) >>> 0 > 1) {
  i16 = i4 + (i5 + -2) | 0;
  if (((HEAPU8[i16 >> 0] | 0) << 8 | (HEAPU8[i16 + 1 >> 0] | 0) | 0) != 65535) _UNITY_ft_validator_error(i20, 8);
 }
 if (!i18) {
  i21 = 0;
  return i21 | 0;
 }
 i15 = i18 + -1 | 0;
 i16 = i20 + 20 | 0;
 i14 = i7 + i1 | 0;
 i10 = 0;
 i11 = 0;
 i12 = 0;
 i1 = 0;
 do {
  i13 = i6;
  i6 = i6 + 2 | 0;
  i7 = i11;
  i11 = (HEAPU8[i13 >> 0] | 0) << 8 | (HEAPU8[i13 + 1 >> 0] | 0);
  i13 = i4;
  i4 = i4 + 2 | 0;
  i5 = i10;
  i10 = (HEAPU8[i13 >> 0] | 0) << 8 | (HEAPU8[i13 + 1 >> 0] | 0);
  i13 = (HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i3 + 1 >> 0] | 0);
  i3 = i3 + 2 | 0;
  i8 = i2;
  i2 = i2 + 2 | 0;
  i9 = (HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0);
  if (i10 >>> 0 < i11 >>> 0) _UNITY_ft_validator_error(i20, 8);
  do if ((i12 | 0) != 0 & i11 >>> 0 <= i5 >>> 0) {
   if (HEAP32[i19 >> 2] | 0) {
    _UNITY_ft_validator_error(i20, 8);
    break;
   }
   if (i7 >>> 0 > i11 >>> 0 | i5 >>> 0 > i10 >>> 0) {
    i1 = i1 | 1;
    break;
   } else {
    i1 = i1 | 2;
    break;
   }
  } while (0);
  L47 : do switch ((i9 & 65535) << 16 >> 16) {
  case -1:
   {
    if ((HEAP32[i19 >> 2] | 0) >>> 0 <= 1) if ((i12 | 0) == (i15 | 0) & (i11 | 0) == 65535 & (i10 | 0) == 65535) break L47;
    _UNITY_ft_validator_error(i20, 8);
    break;
   }
  case 0:
   break;
  default:
   {
    i5 = i8 + i9 | 0;
    do if (!(HEAP32[i19 >> 2] | 0)) {
     if (!((i12 | 0) == (i15 | 0) & (i11 | 0) == 65535 & (i10 | 0) == 65535)) {
      if (i5 >>> 0 >= i17 >>> 0) if ((i5 + ((i10 - i11 << 1) + 2) | 0) >>> 0 <= (HEAP32[i21 >> 2] | 0) >>> 0) break;
      _UNITY_ft_validator_error(i20, 8);
     }
    } else {
     if (i5 >>> 0 >= i17 >>> 0) if ((i5 + ((i10 - i11 << 1) + 2) | 0) >>> 0 <= i14 >>> 0) break;
     _UNITY_ft_validator_error(i20, 8);
    } while (0);
    if ((HEAP32[i19 >> 2] | 0) != 0 & i10 >>> 0 > i11 >>> 0) {
     i7 = i11;
     do {
      i8 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
      i5 = i5 + 2 | 0;
      if (i8 | 0) if ((i8 + i13 & 65535) >>> 0 >= (HEAP32[i16 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i20, 16);
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i10 | 0));
    }
   }
  } while (0);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != (i18 | 0));
 return i1 | 0;
}

function __ZN9dtNavMesh10removeTileEyPPKhPi(i17, i1, i2, i19, i20) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i20 = -2147483640;
  return i20 | 0;
 }
 i18 = _bitshift64Lshr(i1 | 0, i2 | 0, 20) | 0;
 getTempRet0() | 0;
 i18 = i18 & 268435455;
 if (i18 >>> 0 >= (HEAP32[i17 + 16 >> 2] | 0) >>> 0) {
  i20 = -2147483640;
  return i20 | 0;
 }
 i1 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i13 = i17 + 20 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = i14 + (i18 * 56 | 0) | 0;
 i15 = i14 + (i18 * 56 | 0) + 4 | 0;
 if ((HEAP32[i15 >> 2] | 0) != (i1 | 0)) {
  i20 = -2147483640;
  return i20 | 0;
 }
 i16 = i14 + (i18 * 56 | 0) + 8 | 0;
 i6 = HEAP32[i16 >> 2] | 0;
 i2 = (Math_imul(HEAP32[i6 + 12 >> 2] | 0, -669632447) | 0) + (Math_imul(HEAP32[i6 + 8 >> 2] | 0, -1918454973) | 0) & HEAP32[i17 + 4 >> 2];
 i2 = (HEAP32[i17 + 8 >> 2] | 0) + (i2 << 2) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 L10 : do if ((i4 | 0) == (i18 | 0)) {
  HEAP32[i2 >> 2] = HEAP32[i14 + (i18 * 56 | 0) + 52 >> 2];
  i1 = HEAP32[i15 >> 2] | 0;
 } else {
  i2 = HEAP32[i14 + (i4 * 56 | 0) + 52 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i3 = i2;
   i2 = i4;
   while (1) {
    if ((i3 | 0) == (i18 | 0)) break;
    i2 = HEAP32[i14 + (i3 * 56 | 0) + 52 >> 2] | 0;
    if ((i2 | 0) == -1) break L10; else {
     i11 = i3;
     i3 = i2;
     i2 = i11;
    }
   }
   HEAP32[i14 + (i2 * 56 | 0) + 52 >> 2] = HEAP32[i14 + (i18 * 56 | 0) + 52 >> 2];
  }
 } while (0);
 i7 = _bitshift64Shl(i1 | 0, 0, 48) | 0;
 i8 = getTempRet0() | 0;
 i11 = _bitshift64Shl((i18 * 56 | 0) / 56 | 0 | 0, 0, 20) | 0;
 i7 = i11 | i7;
 i8 = getTempRet0() | 0 | i8;
 if ((HEAP32[i6 + 20 >> 2] | 0) > 0) {
  i9 = i14 + (i18 * 56 | 0) + 12 | 0;
  i10 = i17 + 36 | 0;
  i11 = i17 + 28 | 0;
  i5 = 0;
  i1 = i6;
  i2 = HEAP32[i9 >> 2] | 0;
  do {
   i4 = i5 | i7;
   i3 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
   if ((i3 | 0) != -1) {
    i1 = i3;
    i2 = HEAP32[i10 >> 2] | 0;
    do {
     i6 = i1;
     i1 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
     i3 = i2 + (i6 << 4) | 0;
     __ZN9dtNavMesh17removeLinkBetweenEyy(i17, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i4, i8);
     i2 = HEAP32[i10 >> 2] | 0;
     HEAP32[i2 + (i6 << 4) + 8 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = i6;
    } while ((i1 | 0) != -1);
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i2 + (i5 << 2) >> 2] = -1;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i1 + 20 >> 2] | 0));
 }
 __ZN9dtNavMesh33unconnectOffMeshConnectionsToTileEPK10dtMeshTile(i17, i12);
 i1 = i14 + (i18 * 56 | 0) + 48 | 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i19 | 0) HEAP32[i19 >> 2] = HEAP32[i14 + (i18 * 56 | 0) + 40 >> 2];
  if (i20 | 0) HEAP32[i20 >> 2] = HEAP32[i14 + (i18 * 56 | 0) + 44 >> 2];
 } else {
  i12 = i14 + (i18 * 56 | 0) + 40 | 0;
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i12 >> 2] | 0);
  HEAP32[i12 >> 2] = 0;
  HEAP32[i14 + (i18 * 56 | 0) + 44 >> 2] = 0;
  if (i19 | 0) HEAP32[i19 >> 2] = 0;
  if (i20 | 0) HEAP32[i20 >> 2] = 0;
 }
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i14 + (i18 * 56 | 0) + 12 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = 0;
 HEAP32[i16 + 20 >> 2] = 0;
 HEAP32[i16 + 24 >> 2] = 0;
 HEAP32[i16 + 28 >> 2] = 0;
 i20 = (HEAP32[i15 >> 2] | 0) + 1 & 65535;
 HEAP32[i15 >> 2] = ((i20 | 0) == 0 & 1) + i20;
 i20 = i17 + 12 | 0;
 HEAP32[(HEAP32[i13 >> 2] | 0) + (i18 * 56 | 0) + 52 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i20 >> 2] = i18;
 i20 = i17 + 24 | 0;
 HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
 i20 = 1073741824;
 return i20 | 0;
}

function __ZN8Remapper41GetAllLoadedObjectsForSerializedFileIndexEiPNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(i1, i6, i12) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 8 | 0;
 i14 = i15;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  STACKTOP = i15;
  return;
 } else {
  i4 = i5;
  i3 = i2;
 }
 L3 : while (1) {
  i1 = i3;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i6 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i3 = i4;
    break L3;
   }
  }
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   i3 = i1;
   break;
  } else i4 = i1;
 }
 i4 = i5;
 L10 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) > (i6 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i4;
    break L10;
   }
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i4 = i1;
 }
 if ((i3 | 0) == (i1 | 0)) {
  STACKTOP = i15;
  return;
 }
 i7 = i12 + 4 | 0;
 i8 = i7;
 i9 = i12 + 4 | 0;
 i10 = i12 + 8 | 0;
 while (1) {
  i6 = HEAP32[i3 + 32 >> 2] | 0;
  HEAP32[i14 >> 2] = i6;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i11 = 19; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i4 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
    i4 = HEAP32[i13 >> 2] | 0;
    i16 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i4 | 0) == -1 ? i16 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i16 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i11 = 19; else if (HEAP32[i2 + 4 >> 2] | 0) {
    i2 = HEAP32[i7 >> 2] | 0;
    do if (!i2) {
     HEAP32[i13 >> 2] = i7;
     i4 = i8;
     i5 = i7;
    } else {
     while (1) {
      i4 = HEAP32[i2 + 16 >> 2] | 0;
      if ((i6 | 0) < (i4 | 0)) {
       i4 = HEAP32[i2 >> 2] | 0;
       if (!i4) {
        i11 = 24;
        break;
       } else i2 = i4;
      } else {
       if ((i4 | 0) >= (i6 | 0)) {
        i11 = 29;
        break;
       }
       i5 = i2 + 4 | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       if (!i4) {
        i11 = 28;
        break;
       } else i2 = i4;
      }
     }
     if ((i11 | 0) == 24) {
      i11 = 0;
      HEAP32[i13 >> 2] = i2;
      i4 = i2;
      i5 = i2;
      break;
     } else if ((i11 | 0) == 28) {
      i11 = 0;
      HEAP32[i13 >> 2] = i2;
      i4 = i2;
      break;
     } else if ((i11 | 0) == 29) {
      i11 = 0;
      HEAP32[i13 >> 2] = i2;
      i4 = i2;
      i5 = i13;
      break;
     }
    } while (0);
    if (!(HEAP32[i5 >> 2] | 0)) {
     i2 = __Znwj(20) | 0;
     HEAP32[i2 + 16 >> 2] = i6;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = i4;
     HEAP32[i5 >> 2] = i2;
     i4 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
     if (i4) {
      HEAP32[i12 >> 2] = i4;
      i2 = HEAP32[i5 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i2);
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
    }
   }
  }
  if ((i11 | 0) == 19) i11 = 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
 }
 STACKTOP = i15;
 return;
}

function __ZN6Camera13CopiableStateC2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = i6 + 128 | 0;
 i7 = i6 + 260 | 0;
 i4 = i6 + 64 | 0;
 i5 = i6 + 192 | 0;
 i8 = i6 + 388 | 0;
 i9 = i6 + 712 | 0;
 i2 = i6 + 644 | 0;
 i10 = i6 + 748 | 0;
 HEAP32[i6 + 784 >> 2] = 0;
 i1 = i6 + 788 | 0;
 i11 = i6 + 708 | 0;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAP32[i1 >> 2] = 3;
 i11 = i6 + 792 | 0;
 i1 = i6 + 828 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i6 + 856 | 0;
 HEAP32[i6 + 1036 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i6 + 1040 >> 2] = 16843009;
 HEAP8[i6 + 1057 >> 0] = 0;
 HEAP32[i6 + 844 >> 2] = -1;
 HEAP32[i6 + 848 >> 2] = -1;
 i11 = i6 + 896 | 0;
 i12 = i11 + 128 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i6 + 868 | 0;
 HEAP8[i6 + 1054 >> 0] = 0;
 HEAP32[i6 + 1028 >> 2] = 0;
 HEAP32[i6 + 1032 >> 2] = 0;
 HEAP8[i6 + 1044 >> 0] = 1;
 HEAP8[i6 + 1045 >> 0] = 1;
 HEAP8[i6 + 1049 >> 0] = 1;
 HEAP8[i6 + 1050 >> 0] = 1;
 HEAP8[i6 + 1051 >> 0] = 1;
 HEAP8[i6 + 1046 >> 0] = 1;
 HEAP8[i6 + 1055 >> 0] = 0;
 HEAP8[i6 + 1056 >> 0] = 0;
 HEAPF32[i6 + 1024 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 1072 >> 2] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i11 = i2;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i5;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i4;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i3;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 _memmove(i6 | 0, gb + 1162292 | 0, 64) | 0;
 HEAP8[i6 + 1053 >> 0] = 1;
 HEAP32[i6 + 744 >> 2] = 1;
 i1 = i6 + 1060 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 i11 = i10;
 i12 = i11 + 36 | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i11 = i11 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.0219999999);
 HEAPF32[i6 + 1064 >> 2] = Math_fround(10.0);
 HEAP32[i6 + 1068 >> 2] = 0;
 HEAP8[i6 + 1076 >> 0] = 0;
 HEAP8[i6 + 1047 >> 0] = 1;
 HEAP8[i6 + 1048 >> 0] = 1;
 i11 = i7;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i8;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i6 + 324 | 0;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 i11 = i6 + 452 | 0;
 i1 = gb + 1162292 | 0;
 i12 = i11 + 64 | 0;
 do {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  i11 = i11 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i11 | 0) < (i12 | 0));
 return;
}

function runPostSets6() {
 HEAP32[gb + 27456 >> 2] = fb + 61;
 HEAP32[gb + 27460 >> 2] = fb + 50;
 HEAP32[gb + 27464 >> 2] = fb + 62;
 HEAP32[gb + 27468 >> 2] = fb + 89;
 HEAP32[gb + 27472 >> 2] = fb + 90;
 HEAP32[gb + 27476 >> 2] = fb + 70;
 HEAP32[gb + 27488 >> 2] = (HEAP32[gb + 27488 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 27492 >> 2] = (HEAP32[gb + 27492 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 27528 >> 2] = fb + 63;
 HEAP32[gb + 27532 >> 2] = fb + 64;
 HEAP32[gb + 27536 >> 2] = fb + 91;
 HEAP32[gb + 27540 >> 2] = fb + 4;
 HEAP32[gb + 27544 >> 2] = fb + 87;
 HEAP32[gb + 27548 >> 2] = fb + 68;
 HEAP32[gb + 27552 >> 2] = fb + 88;
 HEAP32[gb + 27556 >> 2] = fb + 69;
 HEAP32[gb + 27560 >> 2] = fb + 60;
 HEAP32[gb + 27564 >> 2] = fb + 1;
 HEAP32[gb + 27568 >> 2] = fb + 65;
 HEAP32[gb + 27572 >> 2] = fb + 51;
 HEAP32[gb + 27576 >> 2] = fb + 66;
 HEAP32[gb + 27580 >> 2] = fb + 89;
 HEAP32[gb + 27584 >> 2] = fb + 90;
 HEAP32[gb + 27588 >> 2] = fb + 71;
 HEAP32[gb + 27600 >> 2] = (HEAP32[gb + 27600 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 27604 >> 2] = (HEAP32[gb + 27604 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 27640 >> 2] = fb + 67;
 HEAP32[gb + 27644 >> 2] = fb + 68;
 HEAP32[gb + 27648 >> 2] = fb + 91;
 HEAP32[gb + 27652 >> 2] = fb + 5;
 HEAP32[gb + 27656 >> 2] = fb + 87;
 HEAP32[gb + 27660 >> 2] = fb + 72;
 HEAP32[gb + 27664 >> 2] = fb + 88;
 HEAP32[gb + 27668 >> 2] = fb + 69;
 HEAP32[gb + 27672 >> 2] = fb + 60;
 HEAP32[gb + 27676 >> 2] = fb + 1;
 HEAP32[gb + 27680 >> 2] = fb + 65;
 HEAP32[gb + 27684 >> 2] = fb + 51;
 HEAP32[gb + 27688 >> 2] = fb + 66;
 HEAP32[gb + 27692 >> 2] = fb + 89;
 HEAP32[gb + 27696 >> 2] = fb + 90;
 HEAP32[gb + 27700 >> 2] = fb + 71;
 HEAP32[gb + 27704 >> 2] = fb + 16;
 HEAP32[gb + 27708 >> 2] = fb + 17;
 HEAP32[gb + 27720 >> 2] = fb + 18;
 HEAP32[gb + 27724 >> 2] = fb + 19;
 HEAP32[gb + 27728 >> 2] = (HEAP32[gb + 27728 >> 2] | 0) + (gb + 366911 | 0);
 HEAP32[gb + 27740 >> 2] = fb + 69;
 HEAP32[gb + 27744 >> 2] = fb + 70;
 HEAP32[gb + 27748 >> 2] = fb + 91;
 HEAP32[gb + 27752 >> 2] = fb + 5;
 HEAP32[gb + 27756 >> 2] = fb + 87;
 HEAP32[gb + 27760 >> 2] = fb + 72;
 HEAP32[gb + 27764 >> 2] = fb + 88;
 HEAP32[gb + 27768 >> 2] = fb + 69;
 HEAP32[gb + 27772 >> 2] = fb + 60;
 HEAP32[gb + 27776 >> 2] = fb + 1;
 HEAP32[gb + 27780 >> 2] = fb + 65;
 HEAP32[gb + 27784 >> 2] = fb + 51;
 HEAP32[gb + 27788 >> 2] = fb + 66;
 HEAP32[gb + 27792 >> 2] = fb + 89;
 HEAP32[gb + 27796 >> 2] = fb + 90;
 HEAP32[gb + 27800 >> 2] = fb + 71;
 HEAP32[gb + 27804 >> 2] = fb + 16;
 HEAP32[gb + 27808 >> 2] = fb + 17;
 HEAP32[gb + 27820 >> 2] = fb + 18;
 HEAP32[gb + 27824 >> 2] = fb + 19;
 HEAP32[gb + 27836 >> 2] = fb + 71;
 HEAP32[gb + 27840 >> 2] = fb + 72;
 HEAP32[gb + 27844 >> 2] = fb + 91;
 HEAP32[gb + 27848 >> 2] = fb + 5;
 HEAP32[gb + 27852 >> 2] = fb + 87;
 HEAP32[gb + 27856 >> 2] = fb + 72;
 HEAP32[gb + 27860 >> 2] = fb + 88;
 HEAP32[gb + 27864 >> 2] = fb + 69;
 HEAP32[gb + 27868 >> 2] = fb + 60;
 HEAP32[gb + 27872 >> 2] = fb + 1;
 HEAP32[gb + 27876 >> 2] = fb + 65;
 HEAP32[gb + 27880 >> 2] = fb + 51;
 HEAP32[gb + 27884 >> 2] = fb + 66;
 HEAP32[gb + 27888 >> 2] = fb + 89;
 HEAP32[gb + 27892 >> 2] = fb + 90;
 HEAP32[gb + 27896 >> 2] = fb + 71;
 HEAP32[gb + 27900 >> 2] = fb + 16;
 HEAP32[gb + 27904 >> 2] = fb + 17;
 HEAP32[gb + 27916 >> 2] = fb + 18;
 HEAP32[gb + 27920 >> 2] = fb + 19;
 HEAP32[gb + 27936 >> 2] = fb + 73;
 HEAP32[gb + 27940 >> 2] = fb + 74;
 HEAP32[gb + 27944 >> 2] = fb + 38;
 HEAP32[gb + 27948 >> 2] = fb + 39;
 HEAP32[gb + 27952 >> 2] = fb + 16;
 HEAP32[gb + 27956 >> 2] = fb + 39;
 HEAP32[gb + 27960 >> 2] = fb + 40;
 HEAP32[gb + 27964 >> 2] = fb + 19;
 HEAP32[gb + 27968 >> 2] = fb + 92;
 HEAP32[gb + 27972 >> 2] = fb + 31;
 HEAP32[gb + 27976 >> 2] = fb + 27;
 HEAP32[gb + 27980 >> 2] = fb + 62;
 HEAP32[gb + 27984 >> 2] = fb + 28;
 runPostSets7();
}

function __ZN9ShaderLab19ParseQueueAndOffsetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERi(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i7 = i10;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i6);
 i4 = i9 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i9 + 4 | 0;
 if ((i3 ? HEAP32[i5 >> 2] | 0 : i2 & 255) | 0) {
  i3 = i3 ? i1 : i9;
  do {
   i11 = HEAP8[i3 >> 0] | 0;
   i2 = i11 << 24 >> 24;
   HEAP8[i3 >> 0] = (i11 + -97 & 255) < 26 ? i2 + 224 | 0 : i2;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i11 = i2 << 24 >> 24 < 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } while ((i3 | 0) != ((i11 ? i1 : i9) + (i11 ? HEAP32[i5 >> 2] | 0 : i2 & 255) | 0));
 }
 i5 = i2 << 24 >> 24 < 0 ? i1 : i9;
 i4 = i6 + 11 | 0;
 i2 = i6 + 4 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255;
 if ((i1 | 0) < 10) i3 = 11; else if (!(_memcmp(i5, gb + 481241 | 0, 10) | 0)) if ((i1 | 0) == 10) {
  i1 = 0;
  i3 = 7;
 } else {
  HEAP32[i7 >> 2] = 0;
  i11 = i5 + 10 | 0;
  i1 = _strtol(i11, i7, 10) | 0;
  if ((HEAP32[i7 >> 2] | 0) == (i11 | 0)) i3 = 11; else {
   i2 = 0;
   i3 = 10;
  }
 } else i3 = 11;
 do if ((i3 | 0) == 11) {
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255;
  if ((i1 | 0) >= 8) if (!(_memcmp(i5, gb + 604628 | 0, 8) | 0)) {
   if ((i1 | 0) == 8) {
    i1 = 1;
    i3 = 7;
    break;
   }
   HEAP32[i7 >> 2] = 0;
   i11 = i5 + 8 | 0;
   i1 = _strtol(i11, i7, 10) | 0;
   if ((HEAP32[i7 >> 2] | 0) != (i11 | 0)) {
    i2 = 1;
    i3 = 10;
    break;
   }
  }
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255;
  if ((i1 | 0) >= 9) if (!(_memcmp(i5, gb + 481252 | 0, 9) | 0)) {
   if ((i1 | 0) == 9) {
    i1 = 2;
    i3 = 7;
    break;
   }
   HEAP32[i7 >> 2] = 0;
   i11 = i5 + 9 | 0;
   i1 = _strtol(i11, i7, 10) | 0;
   if ((HEAP32[i7 >> 2] | 0) != (i11 | 0)) {
    i2 = 2;
    i3 = 10;
    break;
   }
  }
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255;
  if ((i1 | 0) >= 11) if (!(_memcmp(i5, gb + 481262 | 0, 11) | 0)) {
   if ((i1 | 0) == 11) {
    i1 = 3;
    i3 = 7;
    break;
   }
   HEAP32[i7 >> 2] = 0;
   i11 = i5 + 11 | 0;
   i1 = _strtol(i11, i7, 10) | 0;
   if ((HEAP32[i7 >> 2] | 0) != (i11 | 0)) {
    i2 = 3;
    i3 = 10;
    break;
   }
  }
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255;
  if ((i1 | 0) < 7) {
   i11 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i10;
   return i11 | 0;
  }
  if (_memcmp(i5, gb + 481274 | 0, 7) | 0) {
   i11 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i10;
   return i11 | 0;
  }
  if ((i1 | 0) == 7) {
   i1 = 4;
   i3 = 7;
  } else {
   HEAP32[i7 >> 2] = 0;
   i11 = i5 + 7 | 0;
   i1 = _strtol(i11, i7, 10) | 0;
   if ((HEAP32[i7 >> 2] | 0) == (i11 | 0)) {
    i11 = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    STACKTOP = i10;
    return i11 | 0;
   } else {
    i2 = 4;
    i3 = 10;
   }
  }
 } while (0);
 if ((i3 | 0) == 7) {
  HEAP32[i8 >> 2] = HEAP32[gb + 68968 + (i1 * 12 | 0) + 8 >> 2];
  i11 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i11 | 0;
 } else if ((i3 | 0) == 10) {
  HEAP32[i8 >> 2] = (HEAP32[gb + 68968 + (i2 * 12 | 0) + 8 >> 2] | 0) + i1;
  i11 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx3Scb14ParticleSystem9syncStateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i7 = i11 + 8 | 0;
 i9 = HEAP32[i5 + 152 >> 2] | 0;
 i10 = (i9 | 0) == 0;
 if (!i10) {
  i2 = i9 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i9 + 73 | 0; else {
   i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i8 = i9 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 707273;
   HEAP32[i1 + 4 >> 2] = i8;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i8;
  }
  _strncpy(i1, gb + 707273 | 0, 128) | 0;
  HEAP8[i9 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 i8 = i5 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 8 | 0;
 do if (i1 & 16777215) {
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) {
   i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i1 >>> 24 & 15) | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP32[i8 >> 2] | 0;
  } else i3 = i1;
  if (i3 & 32) {
   __ZN5physx2Sc18ParticleSystemCore12setStiffnessEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 4 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 64) {
   __ZN5physx2Sc18ParticleSystemCore12setViscosityEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 8 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 128) {
   __ZN5physx2Sc18ParticleSystemCore10setDampingEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 12 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 256) {
   __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E(i5 + 12 | 0, i2 + 16 | 0);
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 512) {
   __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE(i5 + 12 | 0, i2 + 28 | 0);
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 1024) {
   __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 44 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 2048) {
   __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 48 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 4096) {
   __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 52 >> 2]));
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if (i3 & 8192 | 0) __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 56 >> 2]));
  if (i1 & 65536 | 0) __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv(i5 + 12 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 & 16384) {
   __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE(i5 + 12 | 0, i2 + 60 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 32768) {
   HEAP16[i7 >> 1] = HEAP16[i2 + 76 >> 1] | 0;
   __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE(i5 + 12 | 0, i7);
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 & 7) {
   i3 = i1 >>> 24 & 15;
   i4 = (HEAP32[gb + 90260 + 24 + (i3 << 2) >> 2] | 0) + i5 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (!i2) {
    i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i3) | 0;
    HEAP32[i6 >> 2] = i2;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   if (i1 & 1) {
    HEAP16[i7 >> 1] = HEAP16[i2 >> 1] | 0;
    __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i4, i7);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   if (i1 & 2) {
    __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i4, HEAP8[i2 + 2 >> 0] | 0);
    i1 = HEAP32[i8 >> 2] | 0;
   }
   if (!(i1 & 4)) break;
   HEAP8[i4 + 11 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
  }
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 >> 2] = i1 & -16777216;
 if (i10) {
  STACKTOP = i11;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0);
 STACKTOP = i11;
 return;
}

function __ZN16LightmapSettings7RebuildEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i11 = i13;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
  HEAP32[i2 + 4 >> 2] = 1;
  HEAP32[i2 >> 2] = gb + 43424 + 8;
  HEAP32[i2 + 8 >> 2] = 1;
  HEAP32[i2 + 12 >> 2] = 1;
  i9 = i2 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 i8 = HEAP32[i3 + 48 >> 2] | 0;
 i1 = __Znaj(i8 >>> 0 > 536870911 ? -1 : i8 << 3) | 0;
 if (!i8) {
  HEAP32[i9 >> 2] = i1;
  HEAP32[i2 + 20 >> 2] = i8;
  STACKTOP = i13;
  return;
 }
 _memset(i1 | 0, 0, i8 << 3 | 0) | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i2 + 20 >> 2] = i8;
 i7 = i3 + 36 | 0;
 i6 = 0;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = i2 + (i6 << 3) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i3 = i2;
  } else {
   HEAP32[i11 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 15; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 15; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 17;
    }
   }
   if ((i12 | 0) == 15) i12 = 17;
   if ((i12 | 0) == 17) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i3 = HEAP32[i7 >> 2] | 0;
  }
  i2 = HEAP32[gb + 1157932 >> 2] | 0;
  i5 = HEAP32[((i1 | 0) == 0 ? i2 + 48 | 0 : i1 + 48 | 0) >> 2] | 0;
  i4 = i3 + (i6 << 3) + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i11 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 25; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 25; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 27;
    }
   }
   if ((i12 | 0) == 25) i12 = 27;
   if ((i12 | 0) == 27) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i2 = HEAP32[gb + 1157932 >> 2] | 0;
  }
  i4 = HEAP32[((i1 | 0) == 0 ? i2 + 48 | 0 : i1 + 48 | 0) >> 2] | 0;
  i14 = (HEAP32[i9 >> 2] | 0) + (i6 << 3) | 0;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i14 + 4 >> 2] = i4;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function __ZN15b2FrictionJoint24SolveVelocityConstraintsERK12b2SolverData(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0;
 i21 = i4 + 104 | 0;
 i17 = HEAP32[i21 >> 2] | 0;
 i25 = i1 + 28 | 0;
 i29 = HEAP32[i25 >> 2] | 0;
 i26 = i29 + (i17 * 12 | 0) | 0;
 f27 = Math_fround(HEAPF32[i26 >> 2]);
 i16 = i29 + (i17 * 12 | 0) + 4 | 0;
 f28 = Math_fround(HEAPF32[i16 >> 2]);
 f8 = Math_fround(HEAPF32[i29 + (i17 * 12 | 0) + 8 >> 2]);
 i17 = i4 + 108 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i29 + (i7 * 12 | 0) >> 2]);
 f19 = Math_fround(HEAPF32[i29 + (i7 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i29 + (i7 * 12 | 0) + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 144 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 148 >> 2]);
 f23 = Math_fround(HEAPF32[i4 + 152 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 156 >> 2]);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f10 - f8);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i4 + 176 >> 2]));
 i7 = i4 + 92 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f6 * Math_fround(HEAPF32[i4 + 100 >> 2]));
 f2 = Math_fround(f9 - f2);
 f11 = Math_fround(-f14);
 f14 = f2 < f14 ? f2 : f14;
 f14 = f14 < f11 ? f11 : f14;
 HEAPF32[i7 >> 2] = f14;
 f9 = Math_fround(f14 - f9);
 f8 = Math_fround(f8 - Math_fround(f23 * f9));
 f9 = Math_fround(f10 + Math_fround(f24 * f9));
 f10 = Math_fround(HEAPF32[i4 + 124 >> 2]);
 f14 = Math_fround(f10 * f9);
 f11 = Math_fround(HEAPF32[i4 + 120 >> 2]);
 f14 = Math_fround(Math_fround(f18 - f14) - f27);
 f2 = Math_fround(Math_fround(f19 + Math_fround(f11 * f9)) - f28);
 f12 = Math_fround(HEAPF32[i4 + 116 >> 2]);
 f3 = Math_fround(f12 * f8);
 f13 = Math_fround(HEAPF32[i4 + 112 >> 2]);
 f14 = Math_fround(f3 + f14);
 f2 = Math_fround(f2 - Math_fround(f13 * f8));
 f3 = Math_fround(Math_fround(HEAPF32[i4 + 160 >> 2]) * f14);
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i4 + 168 >> 2]) * f2));
 f14 = Math_fround(Math_fround(HEAPF32[i4 + 164 >> 2]) * f14);
 f2 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i4 + 172 >> 2]) * f2));
 i7 = i4 + 84 | 0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i4 + 88 | 0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f14 - f3);
 HEAPF32[i7 >> 2] = f3;
 f2 = Math_fround(f15 - f2);
 HEAPF32[i1 >> 2] = f2;
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i4 + 96 >> 2]));
 f5 = Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2));
 if (f5 > Math_fround(f6 * f6)) {
  f5 = Math_fround(Math_sqrt(Math_fround(f5)));
  if (!(f5 < Math_fround(1.1920929e-07))) {
   f5 = Math_fround(Math_fround(1.0) / f5);
   f3 = Math_fround(f3 * f5);
   HEAPF32[i7 >> 2] = f3;
   f2 = Math_fround(f2 * f5);
   HEAPF32[i1 >> 2] = f2;
  }
  f3 = Math_fround(f6 * f3);
  HEAPF32[i7 >> 2] = f3;
  f2 = Math_fround(f6 * f2);
  HEAPF32[i1 >> 2] = f2;
 }
 f6 = Math_fround(f3 - f14);
 f5 = Math_fround(f2 - f15);
 f14 = Math_fround(f28 - Math_fround(f20 * f5));
 f15 = Math_fround(f8 - Math_fround(f23 * Math_fround(Math_fround(f13 * f5) - Math_fround(f6 * f12))));
 f18 = Math_fround(f18 + Math_fround(f22 * f6));
 f23 = Math_fround(f19 + Math_fround(f22 * f5));
 f28 = Math_fround(f9 + Math_fround(f24 * Math_fround(Math_fround(f5 * f11) - Math_fround(f6 * f10))));
 HEAPF32[i26 >> 2] = Math_fround(f27 - Math_fround(f20 * f6));
 HEAPF32[i16 >> 2] = f14;
 i26 = HEAP32[i25 >> 2] | 0;
 HEAPF32[i26 + ((HEAP32[i21 >> 2] | 0) * 12 | 0) + 8 >> 2] = f15;
 i29 = HEAP32[i17 >> 2] | 0;
 HEAPF32[i26 + (i29 * 12 | 0) >> 2] = f18;
 HEAPF32[i26 + (i29 * 12 | 0) + 4 >> 2] = f23;
 HEAPF32[(HEAP32[i25 >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 12 | 0) + 8 >> 2] = f28;
 return;
}

function __ZN13ProbeRenderer10RenderCubeEP15ReflectionProbeP13RenderTextureib(i3, i4, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 16 | 0;
 i9 = i10;
 if ((HEAP16[gb + 1111224 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111224 | 0, i1);
  i2 = gb + 1111224 | 0;
 } else i2 = 0;
 __ZN13RenderTexture15DiscardContentsEbb(i4, (i7 | 0) == 63, 1);
 i5 = __ZN16ReflectionProbes9GetCameraEv(__Z19GetReflectionProbesv() | 0) | 0;
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 __ZN9Transform11SetRotationERK11Quaternionf(i6, i1);
 __ZN6Camera15SetOrthographicEb(i5, 0);
 HEAP32[gb + 1113448 >> 2] = (HEAP32[gb + 1113448 >> 2] | 0) + 1;
 if (!i3) {
  __ZN9Transform11SetPositionERK8Vector3f(i6, gb + 1162364 | 0);
  __ZN6Camera13SetClearFlagsEi(i5, 1);
  __ZN6Camera9SetAspectEf(i5, Math_fround(1.0));
  __ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_(i5, i4, i7, fb + 213 | 0, 0) | 0;
 } else {
  __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN9Transform11SetPositionERK8Vector3f(i6, i1);
  i6 = __Z18GetQualitySettingsv() | 0;
  f11 = Math_fround(HEAPF32[(HEAP32[i6 + 28 >> 2] | 0) + ((HEAP32[i6 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2]);
  i6 = __Z18GetQualitySettingsv() | 0;
  __ZN15QualitySettings28SetShadowDistanceTemporarilyEf(i6, Math_fround(HEAPF32[i3 + 96 >> 2]));
  f15 = Math_fround(HEAPF32[i3 + 108 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 112 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 116 >> 2]);
  i6 = f15 < Math_fround(0.0);
  f15 = i6 ? Math_fround(0.0) : f15;
  i6 = f15 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i14 = f12 < Math_fround(0.0);
  f12 = i14 ? Math_fround(0.0) : f12;
  i14 = f12 > Math_fround(1.0);
  i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f13 < Math_fround(0.0);
  f13 = i1 ? Math_fround(0.0) : f13;
  i1 = f13 > Math_fround(1.0);
  i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  __ZN6Camera7SetNearEf(i5, Math_fround(HEAPF32[i3 + 88 >> 2]));
  __ZN6Camera6SetFarEf(i5, Math_fround(HEAPF32[i3 + 92 >> 2]));
  __ZN6Camera13SetClearFlagsEi(i5, HEAP32[i3 + 104 >> 2] | 0);
  f13 = Math_fround(Math_fround(i14 & 255) / Math_fround(255.0));
  f12 = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(i6 & 255) / Math_fround(255.0));
  HEAPF32[i9 + 4 >> 2] = f13;
  HEAPF32[i9 + 8 >> 2] = f12;
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i5, i9);
  __ZN6Camera14SetCullingMaskEj(i5, HEAP32[i3 + 100 >> 2] | 0);
  __ZN6Camera9SetAspectEf(i5, Math_fround(1.0));
  HEAP8[i5 + 1089 >> 0] = i8 & 1;
  __ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_(i5, i4, i7, 0, 0) | 0;
  __ZN15QualitySettings28SetShadowDistanceTemporarilyEf(__Z18GetQualitySettingsv() | 0, f11);
 }
 HEAP32[gb + 1113448 >> 2] = (HEAP32[gb + 1113448 >> 2] | 0) + -1;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return;
}

function __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f(i10, i1, i3, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i5 = i9;
 i7 = i10 + 72 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 32 | 0;
 HEAP32[i10 + 112 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 i1 = gb + 63616 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i10 + 116 >> 2] = 0;
 HEAP32[i10 + 128 >> 2] = 0;
 HEAP32[i10 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i5);
 i6 = i4;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i10 + 120 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i10 + 200 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 8;
  }
 }
 if ((i12 | 0) == 6) i12 = 8;
 if ((i12 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 HEAP32[i10 + 28 >> 2] = HEAP32[i1 + 248 + 80 >> 2];
 HEAP32[i7 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i1 = i10 + 108 | 0;
 HEAP16[i1 + 2 >> 1] = -1;
 HEAP16[i1 >> 1] = -1;
 HEAPF32[i10 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 104 >> 2] = Math_fround(0.0);
 i1 = i10 + 136 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i8 = HEAPU8[gb + 1546313 + 1 >> 0] | 0;
 i8 = Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 >> 0] | 0) | 0, i8) | 0;
 i11 = HEAPU8[gb + 1546313 + 3 >> 0] | 0;
 i11 = (Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 + 2 >> 0] | 0) | 0, i11) | 0) + i8 | 0;
 i12 = HEAPU8[gb + 1546313 + 7 >> 0] | 0;
 i12 = (Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 + 6 >> 0] | 0) | 0, i12) | 0) + i11 | 0;
 HEAP8[i10 + 202 >> 0] = HEAP8[gb + 1546313 >> 0] | 0;
 HEAP8[i10 + 203 >> 0] = HEAP8[gb + 1546313 + 1 >> 0] | 0;
 HEAP8[i10 + 206 >> 0] = HEAP8[gb + 1546313 + 2 >> 0] | 0;
 HEAP8[i10 + 207 >> 0] = HEAP8[gb + 1546313 + 3 >> 0] | 0;
 HEAP8[i10 + 205 >> 0] = i8;
 HEAP8[i10 + 214 >> 0] = HEAP8[gb + 1546313 + 6 >> 0] | 0;
 HEAP8[i10 + 215 >> 0] = HEAP8[gb + 1546313 + 7 >> 0] | 0;
 HEAP8[i10 + 213 >> 0] = i11;
 HEAP32[i10 + 216 >> 2] = HEAP32[i10 + 212 >> 2];
 HEAP32[i10 + 236 >> 2] = i12 & 255;
 __ZN15TerrainRenderer12RebuildNodesEv(i10);
 STACKTOP = i9;
 return;
}

function __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_(i5, i6, i3, i1, i2, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_(i5, i6, i3, i1, i7) | 0;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i7, i2, i1) | 0)) {
  STACKTOP = i10;
  return i9 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i1 + 16 | 0;
 i2 = i2 + 16 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i11;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i7, i1, i3) | 0)) {
  i11 = i9 + 1 | 0;
  STACKTOP = i10;
  return i11 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i2 = i3 + 16 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i11;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i7, i3, i6) | 0)) {
  i11 = i9 + 2 | 0;
  STACKTOP = i10;
  return i11 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i1 = i6 + 16 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i11;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i7, i6, i5) | 0)) {
  i11 = i9 + 3 | 0;
  STACKTOP = i10;
  return i11 | 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i8 = i5 + 16 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i11;
 i11 = i9 + 4 | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN11UmbraModule24OcclusionCullLocalLightsER21LocalLightCullJobDataR10BlockRange(i1, i19, i22) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i24 + 36 | 0;
 i23 = i24 + 24 | 0;
 i12 = i24 + 12 | 0;
 i13 = i24;
 i17 = i24 + 72 | 0;
 i18 = i24 + 40 | 0;
 i1 = HEAP32[(HEAP32[i19 >> 2] | 0) + 832 >> 2] | 0;
 if (!(HEAP8[i1 + 60 >> 0] | 0)) {
  STACKTOP = i24;
  return;
 }
 i20 = HEAP32[i19 + 24 >> 2] | 0;
 i11 = HEAP32[i19 + 12 >> 2] | 0;
 i14 = HEAP32[i1 + 64 >> 2] | 0;
 i5 = __Z9GetIUmbrav() | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i14 | 0) | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 i21 = i22 + 4 | 0;
 __Z13InitIndexListR9IndexListj(i23, HEAP32[i21 >> 2] | 0);
 i3 = HEAP32[i22 >> 2] | 0;
 i6 = (HEAP32[i21 >> 2] | 0) + i3 | 0;
 i15 = i19 + 4 | 0;
 if (i3 >>> 0 < i6 >>> 0) {
  i7 = i12 + 4 | 0;
  i8 = i12 + 8 | 0;
  i9 = i13 + 4 | 0;
  i10 = i13 + 8 | 0;
  i1 = 0;
  i2 = i3;
  i4 = i3;
  do {
   i3 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i32 = (HEAP32[i15 >> 2] | 0) + (i3 << 4) | 0;
   f30 = Math_fround(HEAPF32[i32 + 12 >> 2]);
   f31 = Math_fround(HEAPF32[i32 >> 2]);
   f26 = Math_fround(HEAPF32[i32 + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i32 + 8 >> 2]);
   f29 = Math_fround(f26 - f30);
   f28 = Math_fround(f25 - f30);
   f27 = Math_fround(f30 + f31);
   f26 = Math_fround(f30 + f26);
   f25 = Math_fround(f30 + f25);
   HEAPF32[i12 >> 2] = Math_fround(f31 - f30);
   HEAPF32[i7 >> 2] = f29;
   HEAPF32[i8 >> 2] = f28;
   HEAPF32[i13 >> 2] = f27;
   HEAPF32[i9 >> 2] = f26;
   HEAPF32[i10 >> 2] = f25;
   do if (__ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf(i5, i12, i13, 0, 0) | 0) if (!(HEAP32[i11 + (i3 << 2) >> 2] | 0)) {
    HEAP32[(HEAP32[i23 >> 2] | 0) + (i1 << 2) >> 2] = i3;
    i1 = i1 + 1 | 0;
    break;
   } else {
    HEAP32[(HEAP32[i20 >> 2] | 0) + (i2 << 2) >> 2] = i3;
    i2 = i2 + 1 | 0;
    break;
   } while (0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
  i7 = i1;
  i1 = HEAP32[i22 >> 2] | 0;
 } else {
  i7 = 0;
  i2 = i3;
  i1 = i3;
 }
 i32 = i2 - i1 | 0;
 __ZN5Umbra9IndexListC2EPiii(i17, (HEAP32[i20 >> 2] | 0) + (i1 << 2) | 0, i32, i32);
 __ZN5Umbra9IndexListC2ERKS0_(i18, i17);
 i32 = HEAP32[i19 >> 2] | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(102400, gb + 64024 | 0, 16, gb + 612578 | 0, 19) | 0;
 __ZN5Umbra8QueryExtC2EPKNS_4TomeE(i1, HEAP32[i32 + 836 >> 2] | 0);
 __ZN5Umbra15GateStateVectorC2EPvjb(i16, HEAP32[i32 + 840 >> 2] | 0, 0, 0);
 __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE(i1, i16);
 __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE(i1, HEAP32[i32 + 844 >> 2] | 0);
 i32 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i19 + 8 >> 2] | 0;
 __ZN5Umbra8QueryExt16queryLocalLightsERNS_9IndexListEjPKNS_11SphereLightEiRKS1_PS6_(i1, i18, 0, i32, i3, __ZNK5Umbra10Visibility17getOutputClustersEv(i14) | 0, i17) | 0;
 i3 = __ZNK5Umbra9IndexList7getSizeEv(i18) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 i1 = HEAP32[i22 >> 2] | 0;
 i2 = i1 + i3 | 0;
 if (i7) {
  i6 = HEAP32[i23 >> 2] | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  i4 = i3 + i7 | 0;
  i3 = 0;
  while (1) {
   HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i6 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i2 = i4 + i1 | 0;
  i1 = HEAP32[i22 >> 2] | 0;
 }
 HEAP32[i21 >> 2] = i2 - i1;
 __Z16DestroyIndexListR9IndexList(i23);
 STACKTOP = i24;
 return;
}

function __ZN6Sprite8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410471 | 0, HEAP32[gb + 37212 >> 2] | 0, i6, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 48 | 0;
 i8 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800947 | 0, i8, i6, 0);
 i7 = i2 + 20 | 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034662 | 0, HEAP32[gb + 37328 >> 2] | 0, i6, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410478 | 0, i5, i1 + 140 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902162 | 0, i8, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410494 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 144 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410504 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 148 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i1 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410516 | 0, gb + 410521 | 0, i1, 0);
 __ZN16SpriteRenderData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i11 = i12 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 619466 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i4 = i10 + 16 | 0;
   i8 = HEAP32[i10 + 20 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   if (i1 >>> 0 < i8 >>> 0) i9 = 6; else {
    i3 = i1 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 6; else {
     HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i9 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i11, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i11 >> 2] = _llvm_bswap_i32(HEAP32[i11 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i8 = i12 + 88 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 619473 | 0, gb + 1034188 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i8, i10); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i6 = i12 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 619482 | 0, gb + 1034188 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i6, i10); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i5 = i12 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 619491 | 0, HEAP32[gb + 37240 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i7 = HEAP32[i10 + 20 >> 2] | 0;
   i3 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i3;
   if (i3 >>> 0 < i7 >>> 0) i9 = 29; else {
    i4 = i3 + 2 | 0;
    if (i4 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i9 = 29; else {
     HEAP16[i5 >> 1] = HEAP16[i3 >> 1] | 0;
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i9 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 2);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP16[i5 >> 1] = _llvm_bswap_i16(HEAP16[i5 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 f2 = Math_fround(HEAPF32[i11 >> 2]);
 i11 = HEAP16[i5 >> 1] | 0;
 i1 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12, i8, f2) | 0;
 if ((i11 & -2) << 16 >> 16 == 2) {
  if (!i1) {
   i11 = 0;
   i12 = i12 + 86 | 0;
   i11 = i11 & 1;
   HEAP8[i12 >> 0] = i11;
   STACKTOP = i13;
   return;
  }
  i11 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12 + 40 | 0, i6, f2) | 0;
  i12 = i12 + 86 | 0;
  i11 = i11 & 1;
  HEAP8[i12 >> 0] = i11;
  STACKTOP = i13;
  return;
 } else {
  if (!i1) {
   i11 = 0;
   i12 = i12 + 86 | 0;
   i11 = i11 & 1;
   HEAP8[i12 >> 0] = i11;
   STACKTOP = i13;
   return;
  }
  i11 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12 + 40 | 0, i8, f2) | 0;
  i12 = i12 + 86 | 0;
  i11 = i11 & 1;
  HEAP8[i12 >> 0] = i11;
  STACKTOP = i13;
  return;
 }
}

function runPostSets73() {
 HEAP32[gb + 78812 >> 2] = fb + 196;
 HEAP32[gb + 78816 >> 2] = fb + 197;
 HEAP32[gb + 78820 >> 2] = fb + 104;
 HEAP32[gb + 78824 >> 2] = fb + 420;
 HEAP32[gb + 78828 >> 2] = fb + 733;
 HEAP32[gb + 78832 >> 2] = fb + 198;
 HEAP32[gb + 78836 >> 2] = fb + 51;
 HEAP32[gb + 78840 >> 2] = fb + 58;
 HEAP32[gb + 78844 >> 2] = fb + 13;
 HEAP32[gb + 78848 >> 2] = fb + 199;
 HEAP32[gb + 78852 >> 2] = fb + 83;
 HEAP32[gb + 78856 >> 2] = fb + 52;
 HEAP32[gb + 78860 >> 2] = fb + 14;
 HEAP32[gb + 78864 >> 2] = fb + 28;
 HEAP32[gb + 78868 >> 2] = fb + 7;
 HEAP32[gb + 78872 >> 2] = fb + 59;
 HEAP32[gb + 78876 >> 2] = fb + 10;
 HEAP32[gb + 79048 >> 2] = fb + 909;
 HEAP32[gb + 79052 >> 2] = fb + 910;
 HEAP32[gb + 79056 >> 2] = fb + 1;
 HEAP32[gb + 79068 >> 2] = fb + 911;
 HEAP32[gb + 79072 >> 2] = fb + 912;
 HEAP32[gb + 79076 >> 2] = fb + 105;
 HEAP32[gb + 79080 >> 2] = fb + 734;
 HEAP32[gb + 80200 >> 2] = fb + 911;
 HEAP32[gb + 80204 >> 2] = fb + 913;
 HEAP32[gb + 80208 >> 2] = fb + 106;
 HEAP32[gb + 80212 >> 2] = fb + 735;
 HEAP32[gb + 80224 >> 2] = fb + 911;
 HEAP32[gb + 80228 >> 2] = fb + 914;
 HEAP32[gb + 80232 >> 2] = fb + 107;
 HEAP32[gb + 80236 >> 2] = fb + 736;
 HEAP32[gb + 80248 >> 2] = fb + 737;
 HEAP32[gb + 80252 >> 2] = fb + 1;
 HEAP32[gb + 80256 >> 2] = fb + 1;
 HEAP32[gb + 80268 >> 2] = (HEAP32[gb + 80268 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 80272 >> 2] = (HEAP32[gb + 80272 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 80308 >> 2] = (HEAP32[gb + 80308 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 80312 >> 2] = (HEAP32[gb + 80312 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 80348 >> 2] = fb + 915;
 HEAP32[gb + 80352 >> 2] = fb + 916;
 HEAP32[gb + 82420 >> 2] = fb + 738;
 HEAP32[gb + 82424 >> 2] = fb + 2;
 HEAP32[gb + 82428 >> 2] = fb + 2;
 HEAP32[gb + 82440 >> 2] = fb + 739;
 HEAP32[gb + 82444 >> 2] = fb + 3;
 HEAP32[gb + 82448 >> 2] = fb + 3;
 HEAP32[gb + 82460 >> 2] = fb + 740;
 HEAP32[gb + 82464 >> 2] = fb + 4;
 HEAP32[gb + 82468 >> 2] = fb + 4;
 HEAP32[gb + 82480 >> 2] = fb + 741;
 HEAP32[gb + 82484 >> 2] = fb + 5;
 HEAP32[gb + 82488 >> 2] = fb + 5;
 HEAP32[gb + 82500 >> 2] = fb + 742;
 HEAP32[gb + 82504 >> 2] = fb + 6;
 HEAP32[gb + 82508 >> 2] = fb + 6;
 HEAP32[gb + 82520 >> 2] = fb + 743;
 HEAP32[gb + 82524 >> 2] = fb + 7;
 HEAP32[gb + 82528 >> 2] = fb + 7;
 HEAP32[gb + 82540 >> 2] = fb + 744;
 HEAP32[gb + 82544 >> 2] = fb + 8;
 HEAP32[gb + 82548 >> 2] = fb + 8;
 HEAP32[gb + 82560 >> 2] = fb + 745;
 HEAP32[gb + 82564 >> 2] = fb + 9;
 HEAP32[gb + 82568 >> 2] = fb + 9;
 HEAP32[gb + 82580 >> 2] = fb + 746;
 HEAP32[gb + 82584 >> 2] = fb + 10;
 HEAP32[gb + 82588 >> 2] = fb + 10;
 HEAP32[gb + 82600 >> 2] = fb + 747;
 HEAP32[gb + 82604 >> 2] = fb + 11;
 HEAP32[gb + 82608 >> 2] = fb + 11;
 HEAP32[gb + 82620 >> 2] = fb + 748;
 HEAP32[gb + 82624 >> 2] = fb + 12;
 HEAP32[gb + 82628 >> 2] = fb + 12;
 HEAP32[gb + 82640 >> 2] = fb + 749;
 HEAP32[gb + 82644 >> 2] = fb + 13;
 HEAP32[gb + 82648 >> 2] = fb + 13;
 HEAP32[gb + 82660 >> 2] = fb + 750;
 HEAP32[gb + 82664 >> 2] = fb + 14;
 HEAP32[gb + 82668 >> 2] = fb + 14;
 HEAP32[gb + 82680 >> 2] = fb + 751;
 HEAP32[gb + 82684 >> 2] = fb + 15;
 HEAP32[gb + 82688 >> 2] = fb + 15;
 HEAP32[gb + 82700 >> 2] = fb + 752;
 HEAP32[gb + 82704 >> 2] = fb + 16;
 HEAP32[gb + 82708 >> 2] = fb + 16;
 HEAP32[gb + 82720 >> 2] = fb + 753;
 HEAP32[gb + 82724 >> 2] = fb + 17;
 HEAP32[gb + 82728 >> 2] = fb + 17;
 HEAP32[gb + 82740 >> 2] = fb + 754;
 HEAP32[gb + 82744 >> 2] = fb + 18;
 HEAP32[gb + 82748 >> 2] = fb + 18;
 HEAP32[gb + 82760 >> 2] = fb + 755;
 HEAP32[gb + 82764 >> 2] = fb + 19;
 HEAP32[gb + 82768 >> 2] = fb + 19;
 HEAP32[gb + 82780 >> 2] = fb + 756;
 HEAP32[gb + 82784 >> 2] = fb + 20;
 HEAP32[gb + 82788 >> 2] = fb + 20;
 HEAP32[gb + 82800 >> 2] = fb + 917;
 HEAP32[gb + 82804 >> 2] = fb + 918;
 runPostSets74();
}

function runPostSets119() {
 HEAP32[gb + 104900 >> 2] = fb + 98;
 HEAP32[gb + 104904 >> 2] = fb + 99;
 HEAP32[gb + 104908 >> 2] = fb + 100;
 HEAP32[gb + 104924 >> 2] = fb + 98;
 HEAP32[gb + 104928 >> 2] = fb + 98;
 HEAP32[gb + 104932 >> 2] = fb + 99;
 HEAP32[gb + 104936 >> 2] = fb + 100;
 HEAP32[gb + 104956 >> 2] = fb + 98;
 HEAP32[gb + 104960 >> 2] = fb + 99;
 HEAP32[gb + 104964 >> 2] = fb + 100;
 HEAP32[gb + 105216 >> 2] = fb + 51;
 HEAP32[gb + 105220 >> 2] = fb + 52;
 HEAP32[gb + 105224 >> 2] = fb + 53;
 HEAP32[gb + 105228 >> 2] = fb + 54;
 HEAP32[gb + 105232 >> 2] = fb + 55;
 HEAP32[gb + 105236 >> 2] = fb + 56;
 HEAP32[gb + 105240 >> 2] = fb + 38;
 HEAP32[gb + 105248 >> 2] = fb + 38;
 HEAP32[gb + 105252 >> 2] = fb + 57;
 HEAP32[gb + 105256 >> 2] = fb + 58;
 HEAP32[gb + 105260 >> 2] = fb + 59;
 HEAP32[gb + 105264 >> 2] = fb + 38;
 HEAP32[gb + 105268 >> 2] = fb + 38;
 HEAP32[gb + 105280 >> 2] = fb + 60;
 HEAP32[gb + 105284 >> 2] = fb + 61;
 HEAP32[gb + 105288 >> 2] = fb + 62;
 HEAP32[gb + 105292 >> 2] = fb + 63;
 HEAP32[gb + 105296 >> 2] = fb + 38;
 HEAP32[gb + 105312 >> 2] = fb + 64;
 HEAP32[gb + 105316 >> 2] = fb + 65;
 HEAP32[gb + 105320 >> 2] = fb + 66;
 HEAP32[gb + 105324 >> 2] = fb + 38;
 HEAP32[gb + 105344 >> 2] = fb + 67;
 HEAP32[gb + 105348 >> 2] = fb + 68;
 HEAP32[gb + 105352 >> 2] = fb + 38;
 HEAP32[gb + 105376 >> 2] = fb + 38;
 HEAP32[gb + 105380 >> 2] = fb + 38;
 HEAP32[gb + 105408 >> 2] = fb + 38;
 HEAP32[gb + 105420 >> 2] = fb + 69;
 HEAP32[gb + 105424 >> 2] = fb + 988;
 HEAP32[gb + 105428 >> 2] = fb + 1578;
 HEAP32[gb + 105480 >> 2] = fb + 70;
 HEAP32[gb + 105484 >> 2] = fb + 988;
 HEAP32[gb + 105488 >> 2] = fb + 1579;
 HEAP32[gb + 105524 >> 2] = fb + 71;
 HEAP32[gb + 105528 >> 2] = fb + 988;
 HEAP32[gb + 105532 >> 2] = fb + 1580;
 HEAP32[gb + 105544 >> 2] = fb + 1009;
 HEAP32[gb + 105548 >> 2] = fb + 1581;
 HEAP32[gb + 105552 >> 2] = fb + 89;
 HEAP32[gb + 105556 >> 2] = fb + 48;
 HEAP32[gb + 105560 >> 2] = fb + 1154;
 HEAP32[gb + 105576 >> 2] = fb + 1155;
 HEAP32[gb + 105580 >> 2] = fb + 1156;
 HEAP32[gb + 105584 >> 2] = fb + 1157;
 HEAP32[gb + 105588 >> 2] = fb + 1158;
 HEAP32[gb + 105592 >> 2] = fb + 800;
 HEAP32[gb + 105596 >> 2] = fb + 801;
 HEAP32[gb + 105600 >> 2] = fb + 802;
 HEAP32[gb + 105604 >> 2] = fb + 1582;
 HEAP32[gb + 105608 >> 2] = fb + 1583;
 HEAP32[gb + 105612 >> 2] = fb + 1584;
 HEAP32[gb + 105616 >> 2] = fb + 1159;
 HEAP32[gb + 105620 >> 2] = fb + 334;
 HEAP32[gb + 105624 >> 2] = fb + 101;
 HEAP32[gb + 105628 >> 2] = fb + 166;
 HEAP32[gb + 105632 >> 2] = fb + 335;
 HEAP32[gb + 105636 >> 2] = fb + 1585;
 HEAP32[gb + 105640 >> 2] = fb + 1586;
 HEAP32[gb + 105644 >> 2] = fb + 1587;
 HEAP32[gb + 105648 >> 2] = fb + 253;
 HEAP32[gb + 105652 >> 2] = fb + 254;
 HEAP32[gb + 105656 >> 2] = fb + 1160;
 HEAP32[gb + 105660 >> 2] = fb + 1161;
 HEAP32[gb + 105664 >> 2] = fb + 336;
 HEAP32[gb + 105668 >> 2] = fb + 1162;
 HEAP32[gb + 105672 >> 2] = fb + 1163;
 HEAP32[gb + 105676 >> 2] = fb + 1164;
 HEAP32[gb + 105680 >> 2] = fb + 255;
 HEAP32[gb + 105684 >> 2] = fb + 256;
 HEAP32[gb + 105696 >> 2] = fb + 1588;
 HEAP32[gb + 105700 >> 2] = fb + 1589;
 HEAP32[gb + 105704 >> 2] = fb + 1165;
 HEAP32[gb + 105708 >> 2] = fb + 742;
 HEAP32[gb + 105712 >> 2] = fb + 803;
 HEAP32[gb + 105716 >> 2] = fb + 1590;
 HEAP32[gb + 105720 >> 2] = fb + 1591;
 HEAP32[gb + 105724 >> 2] = fb + 337;
 HEAP32[gb + 105728 >> 2] = fb + 338;
 HEAP32[gb + 105740 >> 2] = fb + 1592;
 HEAP32[gb + 105744 >> 2] = fb + 1593;
 HEAP32[gb + 105748 >> 2] = fb + 1594;
 HEAP32[gb + 105752 >> 2] = fb + 1595;
 HEAP32[gb + 105756 >> 2] = fb + 339;
 HEAP32[gb + 105760 >> 2] = fb + 340;
 HEAP32[gb + 105772 >> 2] = fb + 1125;
 HEAP32[gb + 105776 >> 2] = fb + 1596;
 HEAP32[gb + 105780 >> 2] = fb + 1258;
 HEAP32[gb + 105784 >> 2] = fb + 804;
 HEAP32[gb + 105788 >> 2] = fb + 1127;
 runPostSets120();
}

function runPostSets116() {
 HEAP32[gb + 103304 >> 2] = fb + 1531;
 HEAP32[gb + 103308 >> 2] = fb + 73;
 HEAP32[gb + 103312 >> 2] = fb + 44;
 HEAP32[gb + 103316 >> 2] = fb + 1140;
 HEAP32[gb + 103328 >> 2] = fb + 1009;
 HEAP32[gb + 103332 >> 2] = fb + 1532;
 HEAP32[gb + 103336 >> 2] = fb + 74;
 HEAP32[gb + 103340 >> 2] = fb + 45;
 HEAP32[gb + 103344 >> 2] = fb + 1141;
 HEAP32[gb + 103356 >> 2] = fb + 1533;
 HEAP32[gb + 103360 >> 2] = fb + 1534;
 HEAP32[gb + 103364 >> 2] = fb + 1535;
 HEAP32[gb + 103368 >> 2] = fb + 1;
 HEAP32[gb + 103372 >> 2] = fb + 2;
 HEAP32[gb + 103376 >> 2] = fb + 1;
 HEAP32[gb + 103380 >> 2] = fb + 1;
 HEAP32[gb + 103384 >> 2] = fb + 1;
 HEAP32[gb + 103388 >> 2] = fb + 2;
 HEAP32[gb + 103392 >> 2] = fb + 11;
 HEAP32[gb + 103396 >> 2] = fb + 7;
 HEAP32[gb + 103404 >> 2] = fb + 227;
 HEAP32[gb + 103408 >> 2] = fb + 228;
 HEAP32[gb + 103420 >> 2] = fb + 229;
 HEAP32[gb + 103424 >> 2] = fb + 227;
 HEAP32[gb + 103428 >> 2] = fb + 230;
 HEAP32[gb + 103432 >> 2] = fb + 231;
 HEAP32[gb + 103436 >> 2] = fb + 232;
 HEAP32[gb + 103440 >> 2] = fb + 233;
 HEAP32[gb + 103444 >> 2] = fb + 234;
 HEAP32[gb + 103452 >> 2] = fb + 235;
 HEAP32[gb + 103456 >> 2] = fb + 236;
 HEAP32[gb + 103464 >> 2] = fb + 237;
 HEAP32[gb + 103468 >> 2] = fb + 238;
 HEAP32[gb + 103480 >> 2] = fb + 239;
 HEAP32[gb + 103484 >> 2] = fb + 237;
 HEAP32[gb + 103488 >> 2] = fb + 240;
 HEAP32[gb + 103492 >> 2] = fb + 241;
 HEAP32[gb + 103496 >> 2] = fb + 242;
 HEAP32[gb + 103500 >> 2] = fb + 233;
 HEAP32[gb + 103504 >> 2] = fb + 234;
 HEAP32[gb + 103512 >> 2] = fb + 243;
 HEAP32[gb + 103516 >> 2] = fb + 244;
 HEAP32[gb + 103524 >> 2] = fb + 75;
 HEAP32[gb + 103528 >> 2] = fb + 76;
 HEAP32[gb + 103540 >> 2] = fb + 77;
 HEAP32[gb + 103544 >> 2] = fb + 75;
 HEAP32[gb + 103548 >> 2] = fb + 78;
 HEAP32[gb + 103552 >> 2] = fb + 79;
 HEAP32[gb + 103556 >> 2] = fb + 80;
 HEAP32[gb + 103560 >> 2] = fb + 81;
 HEAP32[gb + 103564 >> 2] = fb + 82;
 HEAP32[gb + 103572 >> 2] = fb + 83;
 HEAP32[gb + 103576 >> 2] = fb + 84;
 HEAP32[gb + 103584 >> 2] = fb + 245;
 HEAP32[gb + 103588 >> 2] = fb + 228;
 HEAP32[gb + 103600 >> 2] = fb + 246;
 HEAP32[gb + 103604 >> 2] = fb + 245;
 HEAP32[gb + 103608 >> 2] = fb + 247;
 HEAP32[gb + 103612 >> 2] = fb + 248;
 HEAP32[gb + 103616 >> 2] = fb + 232;
 HEAP32[gb + 103624 >> 2] = fb + 249;
 HEAP32[gb + 103628 >> 2] = fb + 238;
 HEAP32[gb + 103640 >> 2] = fb + 250;
 HEAP32[gb + 103644 >> 2] = fb + 249;
 HEAP32[gb + 103648 >> 2] = fb + 251;
 HEAP32[gb + 103652 >> 2] = fb + 252;
 HEAP32[gb + 103656 >> 2] = fb + 242;
 HEAP32[gb + 103664 >> 2] = fb + 85;
 HEAP32[gb + 103668 >> 2] = fb + 76;
 HEAP32[gb + 103680 >> 2] = fb + 86;
 HEAP32[gb + 103684 >> 2] = fb + 85;
 HEAP32[gb + 103688 >> 2] = fb + 87;
 HEAP32[gb + 103692 >> 2] = fb + 88;
 HEAP32[gb + 103696 >> 2] = fb + 80;
 HEAP32[gb + 103704 >> 2] = fb + 1142;
 HEAP32[gb + 103708 >> 2] = fb + 1143;
 HEAP32[gb + 103720 >> 2] = fb + 1144;
 HEAP32[gb + 103724 >> 2] = fb + 1142;
 HEAP32[gb + 103744 >> 2] = fb + 1145;
 HEAP32[gb + 103748 >> 2] = fb + 1146;
 HEAP32[gb + 103760 >> 2] = fb + 1147;
 HEAP32[gb + 103764 >> 2] = fb + 1148;
 HEAP32[gb + 103768 >> 2] = fb + 1147;
 HEAP32[gb + 103772 >> 2] = fb + 1148;
 HEAP32[gb + 103776 >> 2] = fb + 1147;
 HEAP32[gb + 103780 >> 2] = fb + 1147;
 HEAP32[gb + 103788 >> 2] = fb + 1149;
 HEAP32[gb + 103792 >> 2] = fb + 1143;
 HEAP32[gb + 103804 >> 2] = fb + 1150;
 HEAP32[gb + 103808 >> 2] = fb + 1149;
 HEAP32[gb + 103816 >> 2] = fb + 1151;
 HEAP32[gb + 103820 >> 2] = fb + 1148;
 HEAP32[gb + 103824 >> 2] = fb + 1151;
 HEAP32[gb + 103828 >> 2] = fb + 1148;
 HEAP32[gb + 103832 >> 2] = fb + 1151;
 HEAP32[gb + 103836 >> 2] = fb + 1151;
 HEAP32[gb + 103848 >> 2] = fb + 1536;
 HEAP32[gb + 103852 >> 2] = fb + 1537;
 HEAP32[gb + 103856 >> 2] = fb + 330;
 HEAP32[gb + 103860 >> 2] = fb + 770;
 runPostSets117();
}

function __ZN5physx22PxD6JointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 908242;
 HEAP32[i1 + 240 >> 2] = 426;
 HEAP32[i1 + 244 >> 2] = fb + 782;
 HEAP32[i1 + 248 >> 2] = fb + 828;
 HEAP32[i1 + 252 >> 2] = gb + 742667;
 HEAP32[i1 + 256 >> 2] = 427;
 HEAP32[i1 + 260 >> 2] = fb + 447;
 HEAP32[i1 + 264 >> 2] = gb + 742673;
 HEAP32[i1 + 268 >> 2] = 428;
 HEAP32[i1 + 272 >> 2] = fb + 448;
 HEAP32[i1 + 276 >> 2] = gb + 742685;
 HEAP32[i1 + 280 >> 2] = 429;
 HEAP32[i1 + 284 >> 2] = fb + 449;
 HEAP32[i1 + 288 >> 2] = gb + 742697;
 HEAP32[i1 + 292 >> 2] = 430;
 HEAP32[i1 + 296 >> 2] = fb + 3566;
 HEAP32[i1 + 300 >> 2] = fb + 3567;
 HEAP32[i1 + 304 >> 2] = gb + 765156;
 HEAP32[i1 + 308 >> 2] = 431;
 HEAP32[i1 + 312 >> 2] = fb + 3568;
 HEAP32[i1 + 316 >> 2] = fb + 3569;
 HEAP32[i1 + 320 >> 2] = gb + 742709;
 HEAP32[i1 + 324 >> 2] = 432;
 HEAP32[i1 + 328 >> 2] = fb + 3570;
 HEAP32[i1 + 332 >> 2] = fb + 3571;
 HEAP32[i1 + 336 >> 2] = gb + 742720;
 HEAP32[i1 + 340 >> 2] = 433;
 HEAP32[i1 + 344 >> 2] = fb + 783;
 HEAP32[i1 + 348 >> 2] = fb + 784;
 HEAP32[i1 + 352 >> 2] = gb + 742726;
 HEAP32[i1 + 356 >> 2] = 434;
 HEAP32[i1 + 360 >> 2] = fb + 3572;
 HEAP32[i1 + 364 >> 2] = fb + 3573;
 HEAP32[i1 + 368 >> 2] = gb + 742203;
 HEAP32[i1 + 372 >> 2] = 435;
 HEAP32[i1 + 376 >> 2] = gb + 771588;
 HEAP32[i1 + 380 >> 2] = gb + 771595;
 HEAP32[i1 + 384 >> 2] = fb + 785;
 HEAP32[i1 + 388 >> 2] = fb + 786;
 HEAP32[i1 + 392 >> 2] = gb + 741652;
 HEAP32[i1 + 396 >> 2] = 436;
 HEAP32[i1 + 400 >> 2] = fb + 450;
 HEAP32[i1 + 404 >> 2] = fb + 386;
 HEAP32[i1 + 408 >> 2] = gb + 742267;
 HEAP32[i1 + 412 >> 2] = 437;
 HEAP32[i1 + 416 >> 2] = fb + 451;
 HEAP32[i1 + 420 >> 2] = fb + 387;
 HEAP32[i1 + 424 >> 2] = gb + 831985;
 HEAP32[i1 + 428 >> 2] = 438;
 HEAP32[i1 + 432 >> 2] = fb + 2171;
 return;
}

function __ZN14EmissionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 272 | 0, i7);
 i8 = i7 + 16 | 0;
 i5 = i7 + 24 | 0;
 i1 = i6 + 552 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 556 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 560 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 564 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 568 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 572 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 576 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 580 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 536 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 540 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 544 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 548 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 584 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i2, i4, i3, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 64 | 0;
 i6 = i7;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 i8 = f9 < Math_fround(HEAPF32[i2 >> 2]);
 i1 = Math_fround(HEAPF32[i3 >> 2]) < f9;
 if (!i8) {
  if (!i1) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  __ZN14AnimationEventC2ERKS_(i6, i4);
  __ZN14AnimationEventaSERKS_(i4, i3) | 0;
  __ZN14AnimationEventaSERKS_(i3, i6) | 0;
  i1 = i6 + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i6 + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  i1 = i6 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i6 + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  if (!(f9 < Math_fround(HEAPF32[i2 >> 2]))) {
   i8 = 1;
   STACKTOP = i7;
   return i8 | 0;
  }
  __ZN14AnimationEventC2ERKS_(i6, i2);
  __ZN14AnimationEventaSERKS_(i2, i4) | 0;
  __ZN14AnimationEventaSERKS_(i4, i6) | 0;
  i1 = i6 + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i6 + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  i1 = i6 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i6 + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  i8 = 2;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (i1) {
  __ZN14AnimationEventC2ERKS_(i6, i2);
  __ZN14AnimationEventaSERKS_(i2, i3) | 0;
  __ZN14AnimationEventaSERKS_(i3, i6) | 0;
  i1 = i6 + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i6 + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  i1 = i6 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i6 + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i6, i2);
 __ZN14AnimationEventaSERKS_(i2, i4) | 0;
 __ZN14AnimationEventaSERKS_(i4, i6) | 0;
 i1 = i6 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i6 + 32 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 }
 i1 = i6 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 }
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f9 < Math_fround(HEAPF32[i4 >> 2]))) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i6, i4);
 __ZN14AnimationEventaSERKS_(i4, i3) | 0;
 __ZN14AnimationEventaSERKS_(i3, i6) | 0;
 i1 = i6 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i6 + 32 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 }
 i1 = i6 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i6 + 16 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 }
 i8 = 2;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN7mecanim5human9HumanGoal8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906345 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899280 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899290 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899300 | 0, gb + 906560 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899308 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 40; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 40; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 40) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN16b2ContactManager7AddPairEPvS0_(i13, i1, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (HEAP8[i13 + 80 >> 0] | 0) return;
 i10 = HEAP32[i1 + 16 >> 2] | 0;
 i11 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 i8 = HEAP32[i2 + 20 >> 2] | 0;
 i7 = HEAP32[i10 + 28 >> 2] | 0;
 i6 = HEAP32[i11 + 28 >> 2] | 0;
 if ((i7 | 0) == (i6 | 0)) return;
 i1 = HEAP32[i6 + 112 >> 2] | 0;
 L7 : do if (i1 | 0) {
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) {
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = HEAP32[i5 + 48 >> 2] | 0;
    i3 = HEAP32[i5 + 52 >> 2] | 0;
    i4 = HEAP32[i5 + 56 >> 2] | 0;
    i5 = HEAP32[i5 + 60 >> 2] | 0;
    if ((i2 | 0) == (i10 | 0) & (i3 | 0) == (i11 | 0) & (i4 | 0) == (i9 | 0) & (i5 | 0) == (i8 | 0)) {
     i12 = 37;
     break;
    }
    if ((i2 | 0) == (i11 | 0) & (i3 | 0) == (i10 | 0) & (i4 | 0) == (i8 | 0) & (i5 | 0) == (i9 | 0)) {
     i12 = 37;
     break;
    }
   }
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   if (!i1) break L7;
  }
  if ((i12 | 0) == 37) return;
 } while (0);
 if (!(HEAP32[i6 >> 2] | 0)) if (!(HEAP32[i7 >> 2] | 0)) return;
 i1 = HEAP32[i6 + 108 >> 2] | 0;
 L22 : do if (i1 | 0) {
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 61 >> 0] | 0)) break;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   if (!i1) break L22;
  }
  return;
 } while (0);
 i1 = HEAP32[i13 + 68 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i10 | 0, i11 | 0) | 0)) return;
 i4 = __ZN9b2Contact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i10, i9, i11, i8, HEAP32[i13 + 76 >> 2] | 0) | 0;
 if (!i4) return;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 128;
 i5 = HEAP32[i4 + 48 >> 2] | 0;
 i6 = HEAP32[i4 + 52 >> 2] | 0;
 i7 = HEAP32[i5 + 28 >> 2] | 0;
 i8 = HEAP32[i6 + 28 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i13 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i2;
 if (i2 | 0) HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = i4 + 16 | 0;
 HEAP32[i4 + 20 >> 2] = i4;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i4 + 24 >> 2] = 0;
 i2 = i7 + 112 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 28 >> 2] = i3;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 i2 = i4 + 32 | 0;
 HEAP32[i4 + 36 >> 2] = i4;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i4 + 40 >> 2] = 0;
 i3 = i8 + 112 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 + 44 >> 2] = i1;
 if (i1 | 0) HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 if (!(HEAP8[i5 + 58 >> 0] | 0)) if (!(HEAP8[i6 + 58 >> 0] | 0)) i12 = 28; else i12 = 27; else if (!(HEAP32[i7 >> 2] | 0)) i12 = 28; else if (HEAP8[i6 + 58 >> 0] | 0) i12 = 27;
 if ((i12 | 0) == 27) if (!(HEAP32[i8 >> 2] | 0)) i12 = 28;
 do if ((i12 | 0) == 28) {
  i1 = i7 + 4 | 0;
  i2 = HEAPU16[i1 >> 1] | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   HEAP16[i1 >> 1] = i2 & 65533;
   HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
   i12 = i7 + 64 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
  } else if (!(i2 & 2)) {
   HEAP16[i1 >> 1] = i2 | 2;
   HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
  }
  i1 = i8 + 4 | 0;
  i2 = HEAPU16[i1 >> 1] | 0;
  if (!(HEAP32[i8 >> 2] | 0)) {
   HEAP16[i1 >> 1] = i2 & 65533;
   HEAPF32[i8 + 144 >> 2] = Math_fround(0.0);
   i12 = i8 + 64 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
   break;
  }
  if (!(i2 & 2)) {
   HEAP16[i1 >> 1] = i2 | 2;
   HEAPF32[i8 + 144 >> 2] = Math_fround(0.0);
  }
 } while (0);
 i13 = i13 + 64 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 return;
}

function _UNITY_png_write_tRNS(i6, i3, i1, i4, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i5 = i8;
 switch (i2 | 0) {
 case 3:
  {
   if ((i4 | 0) >= 1) if ((HEAPU16[i6 + 416 >> 1] | 0 | 0) >= (i4 | 0)) {
    i1 = i6 + 656 | 0;
    HEAP32[i1 >> 2] = 34;
    HEAP8[i7 >> 0] = i4 >>> 24;
    HEAP8[i7 + 1 >> 0] = i4 >>> 16;
    HEAP8[i7 + 2 >> 0] = i4 >>> 8;
    HEAP8[i7 + 3 >> 0] = i4;
    i5 = i7 + 4 | 0;
    HEAP8[i5 >> 0] = 116;
    HEAP8[i7 + 5 >> 0] = 82;
    HEAP8[i7 + 6 >> 0] = 78;
    HEAP8[i7 + 7 >> 0] = 83;
    _UNITY_png_write_data(i6, i7, 8);
    HEAP32[i6 + 372 >> 2] = 1951551059;
    _UNITY_png_reset_crc(i6);
    _UNITY_png_calculate_crc(i6, i5, 4);
    HEAP32[i1 >> 2] = 66;
    if (i3 | 0) {
     _UNITY_png_write_data(i6, i3, i4);
     _UNITY_png_calculate_crc(i6, i3, i4);
    }
    HEAP32[i1 >> 2] = 130;
    i5 = HEAP32[i6 + 408 >> 2] | 0;
    HEAP8[i7 >> 0] = i5 >>> 24;
    HEAP8[i7 + 1 >> 0] = i5 >>> 16;
    HEAP8[i7 + 2 >> 0] = i5 >>> 8;
    HEAP8[i7 + 3 >> 0] = i5;
    _UNITY_png_write_data(i6, i7, 4);
    STACKTOP = i8;
    return;
   }
   _UNITY_png_app_warning(i6, gb + 355618 | 0);
   STACKTOP = i8;
   return;
  }
 case 0:
  {
   i1 = HEAP16[i1 + 8 >> 1] | 0;
   if ((i1 & 65535 | 0) < (1 << (HEAPU8[i6 + 432 >> 0] | 0) | 0)) {
    HEAP8[i5 >> 0] = (i1 & 65535) >>> 8;
    HEAP8[i5 + 1 >> 0] = i1;
    i4 = i6 + 656 | 0;
    HEAP32[i4 >> 2] = 34;
    HEAP8[i7 >> 0] = 0;
    HEAP8[i7 + 1 >> 0] = 0;
    HEAP8[i7 + 2 >> 0] = 0;
    HEAP8[i7 + 3 >> 0] = 2;
    i3 = i7 + 4 | 0;
    HEAP8[i3 >> 0] = 116;
    HEAP8[i7 + 5 >> 0] = 82;
    HEAP8[i7 + 6 >> 0] = 78;
    HEAP8[i7 + 7 >> 0] = 83;
    _UNITY_png_write_data(i6, i7, 8);
    HEAP32[i6 + 372 >> 2] = 1951551059;
    _UNITY_png_reset_crc(i6);
    _UNITY_png_calculate_crc(i6, i3, 4);
    HEAP32[i4 >> 2] = 66;
    _UNITY_png_write_data(i6, i5, 2);
    _UNITY_png_calculate_crc(i6, i5, 2);
    HEAP32[i4 >> 2] = 130;
    i5 = HEAP32[i6 + 408 >> 2] | 0;
    HEAP8[i7 >> 0] = i5 >>> 24;
    HEAP8[i7 + 1 >> 0] = i5 >>> 16;
    HEAP8[i7 + 2 >> 0] = i5 >>> 8;
    HEAP8[i7 + 3 >> 0] = i5;
    _UNITY_png_write_data(i6, i7, 4);
    STACKTOP = i8;
    return;
   } else {
    _UNITY_png_app_warning(i6, gb + 355665 | 0);
    STACKTOP = i8;
    return;
   }
  }
 case 2:
  {
   i4 = HEAP16[i1 + 2 >> 1] | 0;
   i3 = (i4 & 65535) >>> 8;
   HEAP8[i5 >> 0] = i3;
   HEAP8[i5 + 1 >> 0] = i4;
   i4 = HEAP16[i1 + 4 >> 1] | 0;
   i2 = (i4 & 65535) >>> 8;
   HEAP8[i5 + 2 >> 0] = i2;
   HEAP8[i5 + 3 >> 0] = i4;
   i1 = HEAP16[i1 + 6 >> 1] | 0;
   i4 = (i1 & 65535) >>> 8;
   HEAP8[i5 + 4 >> 0] = i4;
   HEAP8[i5 + 5 >> 0] = i1;
   if ((i2 | i3 | i4) << 16 >> 16) {
    _UNITY_png_app_warning(i6, gb + 355729 | 0);
    STACKTOP = i8;
    return;
   }
   if (!i6) {
    STACKTOP = i8;
    return;
   }
   i4 = i6 + 656 | 0;
   HEAP32[i4 >> 2] = 34;
   HEAP8[i7 >> 0] = 0;
   HEAP8[i7 + 1 >> 0] = 0;
   HEAP8[i7 + 2 >> 0] = 0;
   HEAP8[i7 + 3 >> 0] = 6;
   i3 = i7 + 4 | 0;
   HEAP8[i3 >> 0] = 116;
   HEAP8[i7 + 5 >> 0] = 82;
   HEAP8[i7 + 6 >> 0] = 78;
   HEAP8[i7 + 7 >> 0] = 83;
   _UNITY_png_write_data(i6, i7, 8);
   HEAP32[i6 + 372 >> 2] = 1951551059;
   _UNITY_png_reset_crc(i6);
   _UNITY_png_calculate_crc(i6, i3, 4);
   HEAP32[i4 >> 2] = 66;
   _UNITY_png_write_data(i6, i5, 6);
   _UNITY_png_calculate_crc(i6, i5, 6);
   HEAP32[i4 >> 2] = 130;
   i5 = HEAP32[i6 + 408 >> 2] | 0;
   HEAP8[i7 >> 0] = i5 >>> 24;
   HEAP8[i7 + 1 >> 0] = i5 >>> 16;
   HEAP8[i7 + 2 >> 0] = i5 >>> 8;
   HEAP8[i7 + 3 >> 0] = i5;
   _UNITY_png_write_data(i6, i7, 4);
   STACKTOP = i8;
   return;
  }
 default:
  {
   _UNITY_png_app_warning(i6, gb + 355793 | 0);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN7mecanim12statemachine19EvaluateTransitionsERK9OffsetPtrIS1_INS0_18TransitionConstantEEEjRNS0_15TransitionInputERNS0_16TransitionOutputERNS0_16TransitionMemoryEPKNS0_20StateMachineConstantEPKNS0_17StateMachineInputEPNS0_18StateMachineOutputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceEi(i12, i13, i23, i24, i19, i20, i25, i26, i27, i21, i22) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i28 = 0, f29 = f0, f30 = f0;
 if (!i13) {
  i27 = 0;
  i28 = 0;
  i28 = i27 & i28;
  return i28 | 0;
 }
 i14 = i12;
 i15 = i27 + 81 | 0;
 i16 = i19 + 4 | 0;
 i17 = i27 + 8 | 0;
 i18 = i21 + 8 | 0;
 i11 = 0;
 L4 : while (1) {
  i1 = (HEAP32[i12 >> 2] | 0) + i14 + (i11 << 2) | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  i10 = (i10 | 0) == 0 ? 0 : i1 + i10 | 0;
  HEAP8[i16 >> 0] = HEAP8[i15 >> 0] | 0;
  __ZN7mecanim12statemachine18EvaluateTransitionEPKNS0_18TransitionConstantEPKNS0_15TransitionInputEPNS0_16TransitionOutputEPKNS0_16TransitionMemoryEPNS0_21StateMachineWorkspaceE(i10, i23, i24, i19, 0);
  i1 = HEAP8[i24 >> 0] | 0;
  do if (i1 << 24 >> 24) {
   if (!(HEAP8[i10 + 45 >> 0] | 0)) if (!(HEAP8[i15 >> 0] | 0)) if ((HEAP32[i10 + 8 >> 2] | 0) == (HEAP32[i17 >> 2] | 0)) {
    HEAP8[i24 >> 0] = 0;
    break;
   }
   i7 = i10 + 4 | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i9 = HEAP32[i19 >> 2] | 0;
   if (i8) {
    i4 = i7;
    i5 = i9 + 4 | 0;
    i6 = i5;
    i3 = 0;
    do {
     i2 = (HEAP32[i7 >> 2] | 0) + i4 + (i3 << 2) | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i1 = (i1 | 0) == 0 ? 0 : i2 + i1 | 0;
     if ((HEAP32[i1 >> 2] | 0) == 1) {
      i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i9, HEAP32[i1 + 4 >> 2] | 0) | 0;
      if ((i1 | 0) > -1) {
       i2 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
       if ((HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) == 9) HEAP8[(HEAP32[HEAP32[i18 >> 2] >> 2] | 0) + (HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) >> 0] = 1;
      }
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i8 | 0));
    i1 = HEAP8[i24 >> 0] | 0;
   }
   if (i1 << 24 >> 24) break L4;
  } while (0);
  i1 = i11 + 1 | 0;
  if (i1 >>> 0 < i13 >>> 0) i11 = i1; else {
   i1 = 0;
   i2 = 0;
   i28 = 21;
   break;
  }
 }
 if ((i28 | 0) == 21) {
  i28 = i1 & i2;
  return i28 | 0;
 }
 HEAP8[i15 >> 0] = 1;
 HEAP32[i27 + 28 >> 2] = 1;
 HEAP32[i27 + 12 >> 2] = __ZN7mecanim12statemachine17EvaluateSelectorsEPKNS0_20StateMachineConstantEPKNS_18ValueArrayConstantEPNS_10ValueArrayEjPKNS0_17StateMachineInputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceE(i20, HEAP32[i21 + 4 >> 2] | 0, HEAP32[i25 + 16 >> 2] | 0, HEAP32[i10 + 8 >> 2] | 0, i25, i27, i21) | 0;
 i1 = HEAP32[i25 + 32 >> 2] | 0;
 if (i1 | 0) if (!(__ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i1) | 0)) {
  i27 = 1;
  i28 = 0;
  i28 = i27 & i28;
  return i28 | 0;
 }
 HEAP32[i27 + 20 >> 2] = i11;
 HEAP32[i27 + 24 >> 2] = i22;
 HEAP32[i27 + 72 >> 2] = HEAP32[i10 + 24 >> 2];
 i22 = HEAP32[i10 + 28 >> 2] | 0;
 HEAP32[i27 + 76 >> 2] = i22;
 HEAPF32[i27 + 68 >> 2] = Math_fround(0.0);
 i28 = HEAP16[i10 + 36 >> 1] | 0;
 HEAP32[i27 + 64 >> 2] = HEAP32[((i28 & 255) << 24 >> 24 == 0 ? i23 + 4 | 0 : i10 + 32 | 0) >> 2];
 HEAP8[i27 + 83 >> 0] = 1;
 HEAP8[i27 + 84 >> 0] = (i28 & 65535) >>> 8;
 i28 = HEAP32[i25 + 24 >> 2] | 0;
 HEAP32[i28 >> 2] = 0;
 HEAP32[i28 + 4 >> 2] = i22;
 f30 = Math_fround(HEAPF32[i24 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i27 + 40 >> 2]);
 i27 = f29 == Math_fround(inf);
 HEAPF32[i28 + 16 >> 2] = Math_fround(f30 * (i27 ? Math_fround(0.0) : f29));
 HEAP32[i26 + 8 >> 2] = 25;
 i27 = 1;
 i28 = 1;
 i28 = i27 & i28;
 return i28 | 0;
}

function __ZN6Skybox14RenderAllFacesEP8Material(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i22 + 112 | 0;
 i14 = i22 + 80 | 0;
 i15 = i22 + 48 | 0;
 i16 = i22;
 i17 = __Z12GetGfxDevicev() | 0;
 i18 = __ZN15SkyboxGenerator18GetCubemapSkyboxVBEv() | 0;
 i19 = __ZN8Material9GetShaderEv(i6) | 0;
 i20 = __ZNK6Shader23GetActiveSubShaderIndexEv(i19) | 0;
 i21 = __ZNK8Material12GetPassCountEv(i6) | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = HEAP32[gb + 1114340 >> 2];
 L1 : do if ((i21 | 0) > 0) {
  i8 = i19 + 32 | 0;
  i9 = i16 + 8 | 0;
  i10 = i16 + 12 | 0;
  i11 = i16 + 4 | 0;
  i12 = i7 + 7 | 0;
  i13 = i16 + 40 | 0;
  i5 = 0;
  while (1) {
   i1 = HEAP32[(HEAP32[HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + (i20 << 2) >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0;
   switch (HEAP32[i1 + 696 >> 2] | 0) {
   case 0:
   case 1:
   case 4:
    {
     if (!(HEAP32[i1 + 744 >> 2] | 0)) {
      i4 = __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib(i6, i1, HEAP32[gb + 1166248 >> 2] | 0, i19, i5, 1) | 0;
      if (i4 | 0) {
       i1 = i16;
       i3 = i1 + 44 | 0;
       do {
        HEAP32[i1 >> 2] = 0;
        i1 = i1 + 4 | 0;
       } while ((i1 | 0) < (i3 | 0));
       HEAP32[i9 >> 2] = i18;
       HEAP32[i10 >> 2] = 28;
       HEAP32[i11 >> 2] = 1;
       i1 = HEAP32[gb + 1114344 >> 2] | 0;
       if (!i1) {
        i1 = i7;
        i2 = gb + 1546313 | 0;
        i3 = i1 + 16 | 0;
        do {
         HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
         i1 = i1 + 1 | 0;
         i2 = i2 + 1 | 0;
        } while ((i1 | 0) < (i3 | 0));
        HEAP8[i12 >> 0] = 3;
        HEAP32[i14 >> 2] = 0;
        HEAP32[i14 + 4 >> 2] = 0;
        HEAP32[i14 + 8 >> 2] = 0;
        HEAP32[i14 + 12 >> 2] = 0;
        HEAP32[i14 + 16 >> 2] = 0;
        HEAP32[i14 + 20 >> 2] = 0;
        HEAP32[i14 + 24 >> 2] = 0;
        HEAP32[i14 + 28 >> 2] = 0;
        __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(13, i7, i14) | 0;
        i1 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i14) | 0;
        HEAP32[gb + 1114344 >> 2] = i1;
       }
       i2 = HEAP32[i4 >> 2] | 0;
       i3 = HEAP32[i1 + 4 >> 2] | 0;
       HEAP32[i13 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i1, i2, 0) | 0;
       __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj(i17, i16, i15, i2, i3);
       mftCall_viiiiiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 244 >> 2] | 0, i17 | 0, 0, i9 | 0, HEAP32[i11 >> 2] | 0, i15 | 0, 1, HEAP32[i13 >> 2] | 0, i4 | 0);
       __Z15gpu_time_samplev();
      }
     }
     break;
    }
   default:
    {}
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i21 | 0)) break L1;
  }
 } while (0);
 if (!(__Z20IsRunningNativeTestsv() | 0)) {
  STACKTOP = i22;
  return;
 }
 if (!(__Z11IsGfxDevicev() | 0)) {
  STACKTOP = i22;
  return;
 }
 if (HEAP32[gb + 1114336 >> 2] | 0) {
  i21 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 236 >> 2] | 0, i21 | 0, HEAP32[gb + 1114336 >> 2] | 0);
  HEAP32[gb + 1114336 >> 2] = 0;
 }
 if (!(HEAP32[gb + 1114348 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 i21 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 236 >> 2] | 0, i21 | 0, HEAP32[gb + 1114348 >> 2] | 0);
 HEAP32[gb + 1114348 >> 2] = 0;
 STACKTOP = i22;
 return;
}

function __ZN5physx21PxShapeRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i9, i1, i13, i10, i11, i12) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i18 + 96 | 0;
 i8 = i18 + 92 | 0;
 i17 = i18 + 32 | 0;
 i16 = i18 + 16 | 0;
 i19 = i18 + 109 | 0;
 i20 = i18 + 48 | 0;
 i6 = i18 + 4 | 0;
 i3 = i18;
 i1 = i18 + 108 | 0;
 HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i17 >> 2] = i8;
 i14 = i17 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i15 = i17 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i16 >> 2] = i8;
 i8 = i16 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 i7 = i16 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP8[i19 >> 0] = 0;
 HEAP32[i20 >> 2] = i17;
 HEAP32[i20 + 4 >> 2] = i16;
 i2 = i20 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i13;
 HEAP32[i20 + 24 >> 2] = 0;
 HEAP32[i20 + 28 >> 2] = i10;
 HEAP32[i20 + 32 >> 2] = i12;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i19;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn10parseShapeINS0_17RepXVisitorReaderINS_7PxShapeEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE(i20, i3, i6);
 do if (!(HEAP8[i19 >> 0] | 0)) {
  i21 = HEAP32[i11 >> 2] | 0;
  i22 = HEAP32[(HEAP32[i21 >> 2] | 0) + 124 >> 2] | 0;
  i20 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i19 = HEAP32[i2 >> 2] & 65535;
  HEAP8[i1 >> 0] = 11;
  i1 = mftCall_iiiiiii(i22 | 0, i21 | 0, i20 | 0, i3 | 0, i19 | 0, 0, i1 | 0) | 0;
  i19 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i20 | 0);
  HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  if (__ZN5physx2Sn17readAllPropertiesINS_7PxShapeEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i5, i13, i1, i10, i12) | 0) {
   HEAP32[i9 >> 2] = gb + 690295;
   HEAP32[i9 + 4 >> 2] = i1;
   i22 = i9 + 8 | 0;
   HEAP32[i22 >> 2] = i1;
   HEAP32[i22 + 4 >> 2] = 0;
   break;
  } else {
   HEAP32[i9 >> 2] = gb + 1576256;
   HEAP32[i9 + 4 >> 2] = 0;
   i22 = i9 + 8 | 0;
   HEAP32[i22 >> 2] = 0;
   HEAP32[i22 + 4 >> 2] = 0;
   break;
  }
 } else {
  HEAP32[i9 >> 2] = gb + 1576256;
  HEAP32[i9 + 4 >> 2] = 0;
  i22 = i9 + 8 | 0;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
 } while (0);
 i22 = HEAP32[i4 >> 2] | 0;
 if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i7 >> 2] | 0;
 if ((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i22 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
  }
 }
 i22 = HEAP32[i15 >> 2] | 0;
 if (!((i22 | 0) > -1 & (i22 & 2147483647 | 0) != 0)) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i22 = HEAP32[HEAP32[i17 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i1 | 0);
 STACKTOP = i18;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = i9 + 20 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i7 * 76 | 0, HEAP32[i9 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i9 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 76 | 0) | 0;
 i6 = i9 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 148864 + 8;
   i11 = i2 + 4 | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i13 = i2 + 16 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i11 = i1 + 28 | 0;
   i12 = i2 + 28 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   i11 = i2 + 44 | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1 + 44 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   i13 = i2 + 52 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1 + 52 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   i11 = i1 + 64 | 0;
   i12 = i2 + 64 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = i1 + 76 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 76 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 * 76 | 0) >> 2] = gb + 148864 + 8;
 i13 = i8 + 4 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i4 + (i1 * 76 | 0) + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i11 = i8 + 16 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 * 76 | 0) + 16 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i13 = i4 + (i1 * 76 | 0) + 28 | 0;
 i12 = i8 + 28 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 i13 = i8 + 44 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i4 + (i1 * 76 | 0) + 44 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = i8 + 52 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 * 76 | 0) + 52 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 60 >> 2] = HEAP32[i8 + 60 >> 2];
 i13 = i4 + (i1 * 76 | 0) + 64 | 0;
 i12 = i8 + 64 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i10 >> 2] = i7;
  i13 = HEAP32[i5 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i5 >> 2] = i12;
  i13 = i4 + (i13 * 76 | 0) | 0;
  return i13 | 0;
 }
 i13 = HEAP32[i9 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 i13 = HEAP32[i5 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i5 >> 2] = i12;
 i13 = i4 + (i13 * 76 | 0) | 0;
 return i13 | 0;
}

function __ZN20ArchiveStorageReader31TryToReadDirectoryFromBlockDataEyPKvj(i7, i8, i9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 32 | 0;
 i1 = i14 + 24 | 0;
 i3 = i14 + 16 | 0;
 i5 = i14 + 8 | 0;
 i6 = i14;
 i13 = i7 + 180 | 0;
 if ((i8 | 0) == 0 & (i9 | 0) == 0 & (HEAP32[i13 >> 2] | 0) == 0) {
  i4 = __ZnwjRK10MemLabelIdiPKci(40, gb + 64016 | 0, 16, gb + 489692 | 0, 323) | 0;
  i15 = gb + 64016 | 0;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = i16;
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb(i4, i12, i10, i11, 0);
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 64016 | 0, 16, gb + 489692 | 0, 324) | 0;
  i16 = gb + 64016 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = i3;
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission(i2, i12, i4, 0);
  i1 = i7 + 184 | 0;
  HEAP8[i1 >> 0] = (__ZN20ArchiveStorageReader28TryReadDirectoryInfoFromFileEP5IFile(i7, i2) | 0) & 1;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64016 | 0);
  }
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
  i3 = i1;
 } else i3 = i7 + 184 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63552 | 0, 16, gb + 489692 | 0, 336) | 0;
  i16 = gb + 63552 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  i1 = HEAP32[gb + 71488 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i2, i12, i1);
  i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63552 | 0, 16, gb + 489692 | 0, 337) | 0;
  i5 = gb + 63552 | 0;
  i15 = HEAP32[i5 + 4 >> 2] | 0;
  i16 = i6;
  HEAP32[i16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i16 + 4 >> 2] = i15;
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission(i1, i12, i2, 2);
  HEAP32[i13 >> 2] = i1;
  i16 = i2 + 4 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
  if (!(HEAP32[i16 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
  }
 }
 i16 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 i15 = getTempRet0() | 0;
 if (i15 >>> 0 > i9 >>> 0 | (i15 | 0) == (i9 | 0) & i16 >>> 0 > i8 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0, i16 | 0, i8 | 0, i9 | 0, 1) | 0;
 i16 = HEAP32[i13 >> 2] | 0;
 mftCall_iiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] | 0, i16 | 0, i11 | 0, 0, i10 | 0, i12 | 0) | 0;
 i16 = __ZN20ArchiveStorageReader28TryReadDirectoryInfoFromFileEP5IFile(i7, HEAP32[i13 >> 2] | 0) | 0;
 HEAP8[i3 >> 0] = i16 & 1;
 if (i16) {
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i13 >> 2] = 0;
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16updateSleepStateEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i25 + 28 | 0;
 i18 = i25 + 24 | 0;
 i19 = i25 + 20 | 0;
 i17 = i25 + 16 | 0;
 i11 = i25 + 12 | 0;
 i12 = i25 + 8 | 0;
 i13 = i25 + 4 | 0;
 i14 = i25;
 f21 = Math_fround(HEAPF32[i22 + 724 >> 2]);
 i15 = ~~Math_fround(f21 * Math_fround(1.0e3)) >>> 0;
 i23 = i22 + 4 | 0;
 i20 = (HEAP32[i23 >> 2] | 0) + 248 | 0;
 HEAP32[i20 >> 2] = (i15 >>> 0 > 1 ? i15 : 1) + (HEAP32[i20 >> 2] | 0);
 i20 = HEAP32[i23 >> 2] | 0;
 if ((HEAP32[i20 + 248 >> 2] | 0) >>> 0 < (HEAP32[(HEAP32[i22 >> 2] | 0) + 512 >> 2] | 0) >>> 0) {
  STACKTOP = i25;
  return;
 }
 i3 = HEAP32[i20 + 8 >> 2] | 0;
 i1 = HEAP32[i20 + 4 >> 2] | 0;
 i10 = HEAP32[i20 >> 2] | 0;
 i15 = i1 + (i10 << 4) | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 if ((i10 | 0) > 0) {
  i10 = i1;
  f2 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  while (1) {
   f29 = Math_fround(HEAPF32[i10 >> 2]);
   f29 = Math_fround(f29 - Math_fround(HEAPF32[i3 >> 2]));
   f28 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f28 = Math_fround(f28 - Math_fround(HEAPF32[i3 + 4 >> 2]));
   f27 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f27 = Math_fround(f27 - Math_fround(HEAPF32[i3 + 8 >> 2]));
   f26 = Math_fround(HEAPF32[i10 + 12 >> 2]);
   f29 = Math_fround(Math_abs(Math_fround(f29)));
   f28 = Math_fround(Math_abs(Math_fround(f28)));
   f27 = Math_fround(Math_abs(Math_fround(f27)));
   f26 = Math_fround(Math_abs(Math_fround(f26 - Math_fround(HEAPF32[i3 + 12 >> 2]))));
   HEAPF32[i11 >> 2] = f29;
   HEAPF32[i12 >> 2] = f28;
   HEAPF32[i13 >> 2] = f27;
   HEAPF32[i14 >> 2] = f26;
   i6 = HEAP32[(f2 < f29 ? i11 : i16) >> 2] | 0;
   i4 = HEAP32[(f7 < f28 ? i12 : i18) >> 2] | 0;
   i1 = HEAP32[(f8 < f27 ? i13 : i19) >> 2] | 0;
   i5 = HEAP32[(f9 < f26 ? i14 : i17) >> 2] | 0;
   HEAP32[i16 >> 2] = i6;
   HEAP32[i18 >> 2] = i4;
   HEAP32[i19 >> 2] = i1;
   HEAP32[i17 >> 2] = i5;
   i10 = i10 + 16 | 0;
   f2 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (i10 >>> 0 >= i15 >>> 0) break; else i3 = i3 + 16 | 0;
  }
 } else {
  i6 = 0;
  i4 = 0;
  i1 = 0;
  i5 = 0;
 }
 i3 = HEAP32[gb + 1097472 + 12 >> 2] | 0;
 i17 = HEAP32[gb + 1097472 >> 2] & i6;
 i18 = HEAP32[gb + 1097472 + 4 >> 2] & i4;
 i19 = HEAP32[gb + 1097472 + 8 >> 2] & i1;
 i1 = i20 + 244 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i22 >> 2] | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 520 >> 2]) * f21);
 i20 = !((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f2);
 i20 = i20 & !((HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f2);
 if (!((HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f2) & i20) {
  if ((HEAP32[tempDoublePtr >> 2] = i3 & i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) >= f2) i24 = 7;
 } else i24 = 7;
 if ((i24 | 0) == 7) {
  HEAP32[(HEAP32[i23 >> 2] | 0) + 244 >> 2] = 0;
  i1 = HEAP32[i22 >> 2] | 0;
 }
 i24 = (HEAP32[i23 >> 2] | 0) + 248 | 0;
 HEAP32[i24 >> 2] = (HEAP32[i24 >> 2] | 0) - (HEAP32[i1 + 512 >> 2] | 0);
 STACKTOP = i25;
 return;
}

function __ZNSt3__215numpunct_bynameIwE6__initEPKc(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i7 = i6;
 L1 : do if (_strcmp(i2, gb + 1083663 | 0) | 0) {
  i8 = _newlocale(2147483647, i2, 0) | 0;
  i9 = (i8 | 0) == 0;
  L3 : do if (i9) {
   i4 = ___cxa_allocate_exception(8) | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   i6 = _strlen(i2) | 0;
   __THREW__ = 0;
   invoke_viii(fb + 1040 | 0, i7 | 0, i2 | 0, i6 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 511 | 0, i7 | 0, 0, gb + 1081941 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     i2 = 1;
    } else {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4518 | 0, i4 | 0, i3 | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) i2 = 1; else {
      __THREW__ = 0;
      invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
      __THREW__ = 0;
      i2 = 0;
     }
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    if (!i2) break;
   }
   ___cxa_free_exception(i4 | 0);
  } else {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2805 | 0, i8 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   do if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    __THREW__ = 0;
    i4 = invoke_i(fb + 318 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     if (!i2) {
      i1 = i3;
      break;
     }
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (!(i7 & 1)) {
      i1 = i3;
      break;
     }
     i7 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i7);
    }
    if (i2 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i7 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i7);
     }
    }
    i2 = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
    if (i2 << 24 >> 24) HEAP32[i5 + 8 >> 2] = i2 << 24 >> 24;
    i2 = HEAP8[HEAP32[i4 + 4 >> 2] >> 0] | 0;
    if (i2 << 24 >> 24) HEAP32[i5 + 12 >> 2] = i2 << 24 >> 24;
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, i5 + 16 | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L3;
    }
    __THREW__ = 0;
    invoke_vi(fb + 4002 | 0, i8 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break L1;
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   } while (0);
  } while (0);
  if (!i9) {
   __THREW__ = 0;
   invoke_vi(fb + 4002 | 0, i8 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i9 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i9);
   }
  }
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseERKNS_6bitsetILj66EEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP32[i6 >> 2] & 1)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 1065353216;
  HEAP32[i5 + 28 >> 2] = 1065353216;
  HEAP32[i5 + 32 >> 2] = 1065353216;
  HEAP32[i5 + 36 >> 2] = 1065353216;
 }
 if (!(HEAP32[i6 + 4 >> 2] & 2097152)) {
  i4 = i5 + 68 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i5 + 92 >> 2] = 1065353216;
  HEAP32[i5 + 96 >> 2] = 1065353216;
  HEAP32[i5 + 100 >> 2] = 1065353216;
  HEAP32[i5 + 104 >> 2] = 1065353216;
 }
 if (!(HEAP32[i6 + 4 >> 2] & 4194304)) {
  i4 = i5 + 132 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i5 + 156 >> 2] = 1065353216;
  HEAP32[i5 + 160 >> 2] = 1065353216;
  HEAP32[i5 + 164 >> 2] = 1065353216;
  HEAP32[i5 + 168 >> 2] = 1065353216;
 }
 if (!(HEAP32[i6 + 4 >> 2] & 8388608)) {
  i4 = i5 + 196 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i5 + 220 >> 2] = 1065353216;
  HEAP32[i5 + 224 >> 2] = 1065353216;
  HEAP32[i5 + 228 >> 2] = 1065353216;
  HEAP32[i5 + 232 >> 2] = 1065353216;
 }
 if (!(HEAP32[i6 + 4 >> 2] & 16777216)) {
  i1 = i5 + 260 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i5 + 284 >> 2] = 1065353216;
  HEAP32[i5 + 288 >> 2] = 1065353216;
  HEAP32[i5 + 292 >> 2] = 1065353216;
  HEAP32[i5 + 296 >> 2] = 1065353216;
  i1 = 0;
 } else i1 = 0;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  if (!(HEAP32[i6 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31))) HEAPF32[i5 + 596 + (i2 << 2) >> 2] = Math_fround(0.0);
 } while ((i1 | 0) != 52);
 i4 = i6 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = (i3 & 67108864 | 0) == 0;
 do if (!(i3 & 33554432)) {
  i2 = i5 + 364 | 0;
  if (i1) {
   i3 = i5 + 500 | 0;
   i1 = i2 + 80 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i1 | 0));
   i2 = i3;
   i1 = i2 + 80 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i1 | 0));
   break;
  } else {
   i1 = i2 + 80 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i1 | 0));
   break;
  }
 } else if (i1) {
  i2 = i5 + 500 | 0;
  i1 = i2 + 80 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i1 | 0));
 } while (0);
 if (!(HEAP32[i4 >> 2] & 134217728)) {
  HEAP32[i5 + 804 >> 2] = 0;
  HEAP32[i5 + 808 >> 2] = 0;
  HEAP32[i5 + 812 >> 2] = 0;
 }
 if (!(HEAP32[i4 >> 2] & 268435456)) {
  HEAP32[i5 + 816 >> 2] = 0;
  HEAP32[i5 + 820 >> 2] = 0;
  HEAP32[i5 + 824 >> 2] = 0;
 }
 if (!(HEAP32[i4 >> 2] & 536870912)) {
  HEAP32[i5 + 828 >> 2] = 0;
  HEAP32[i5 + 832 >> 2] = 0;
  HEAP32[i5 + 836 >> 2] = 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(i1 & 1073741824)) {
  HEAP32[i5 + 840 >> 2] = 0;
  HEAP32[i5 + 844 >> 2] = 0;
  HEAP32[i5 + 848 >> 2] = 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i5 + 852 >> 2] = 0;
  HEAP32[i5 + 856 >> 2] = 0;
  HEAP32[i5 + 860 >> 2] = 0;
 }
 if (!(HEAP32[i6 + 8 >> 2] & 1)) {
  HEAP32[i5 + 864 >> 2] = 0;
  HEAP32[i5 + 868 >> 2] = 0;
  HEAP32[i5 + 872 >> 2] = 0;
 }
 if (HEAP32[i6 + 8 >> 2] & 2 | 0) return;
 HEAP32[i5 + 876 >> 2] = 0;
 HEAP32[i5 + 880 >> 2] = 0;
 HEAP32[i5 + 884 >> 2] = 0;
 return;
}

function __ZN16GraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 9);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 28 | 0, gb + 373773 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 36 | 0, gb + 373784 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 44 | 0, gb + 373806 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 52 | 0, gb + 373827 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 68 | 0, gb + 373844 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 60 | 0, gb + 405015 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 76 | 0, gb + 373859 | 0, 0);
 __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i4 + 84 | 0, gb + 373871 | 0, 0);
 i2 = i4 + 92 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 373883 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 373907 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 373926 | 0, gb + 946436 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 373951 | 0, gb + 373972 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 136 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 373993 | 0, gb + 373972 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 374014 | 0, gb + 373972 | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function _jn(i6, d1) {
 i6 = i6 | 0;
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0, d5 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, d10 = 0.0, i11 = 0, i12 = 0, d13 = 0.0, i14 = 0, d15 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i8 = HEAP32[tempDoublePtr >> 2] | 0;
 i9 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Lshr(i8 | 0, i9 | 0, 63) | 0;
 getTempRet0() | 0;
 i9 = i9 & 2147483647;
 do if ((i9 | (i8 | 0 - i8) >>> 31) >>> 0 <= 2146435072) {
  if (!i6) {
   d1 = +_j0(d1);
   break;
  }
  if ((i6 | 0) < 0) {
   d1 = -d1;
   i4 = i4 ^ 1;
   i12 = ~i6;
  } else i12 = i6 + -1 | 0;
  if (!i12) {
   d1 = +_j1(d1);
   break;
  }
  i14 = i4 & i6;
  d13 = +Math_abs(+d1);
  L13 : do if ((i9 | 0) == 2146435072 | (i9 | i8 | 0) == 0) d1 = 0.0; else {
   d1 = +(i12 | 0);
   if (d1 < d13) {
    if (i9 >>> 0 <= 1389363199) {
     d2 = +_j0(d13);
     d1 = +_j1(d13);
     if ((i12 | 0) > 0) i4 = 0; else break;
     while (1) {
      i4 = i4 + 1 | 0;
      d2 = d1 * (+(i4 | 0) * 2.0 / d13) - d2;
      if ((i4 | 0) == (i12 | 0)) {
       d1 = d2;
       break L13;
      } else {
       d10 = d1;
       d1 = d2;
       d2 = d10;
      }
     }
    }
    switch (i12 & 3) {
    case 0:
     {
      d2 = +Math_sin(+d13) - +Math_cos(+d13);
      break;
     }
    case 1:
     {
      d2 = -+Math_cos(+d13) - +Math_sin(+d13);
      break;
     }
    case 2:
     {
      d2 = +Math_cos(+d13) - +Math_sin(+d13);
      break;
     }
    case 3:
     {
      d2 = +Math_cos(+d13) + +Math_sin(+d13);
      break;
     }
    default:
     {}
    }
    d1 = d2 * .5641895835477563 / +Math_sqrt(+d13);
    break;
   }
   if (i9 >>> 0 < 1041235968) {
    if ((i12 | 0) > 32) {
     d1 = 0.0;
     break;
    }
    d2 = d13 * .5;
    if ((i12 + 1 | 0) < 2) d1 = 1.0; else {
     d3 = d2;
     d1 = 1.0;
     i4 = 2;
     while (1) {
      d1 = d1 * +(i4 | 0);
      d3 = d2 * d3;
      if ((i4 | 0) > (i12 | 0)) {
       d2 = d3;
       break;
      } else i4 = i4 + 1 | 0;
     }
    }
    d1 = d2 / d1;
    break;
   }
   d7 = d1 + 1.0;
   d10 = d7 * 2.0 / d13;
   d5 = 2.0 / d13;
   d1 = d10 + d5;
   d2 = d10 * d1 + -1.0;
   if (d2 < 1.0e9) {
    d3 = d10;
    i6 = 1;
    while (1) {
     i4 = i6 + 1 | 0;
     d1 = d5 + d1;
     d3 = d2 * d1 - d3;
     if (!(d3 < 1.0e9)) break; else {
      d15 = d2;
      d2 = d3;
      i6 = i4;
      d3 = d15;
     }
    }
    if ((i6 | 0) > -2) {
     d1 = 0.0;
     i11 = 29;
    } else d3 = 0.0;
   } else {
    d1 = 0.0;
    i4 = 1;
    i11 = 29;
   }
   if ((i11 | 0) == 29) while (1) {
    d1 = 1.0 / ((d7 + +(i4 | 0)) * 2.0 / d13 - d1);
    if ((i4 | 0) > 0) {
     i4 = i4 + -1 | 0;
     i11 = 29;
    } else {
     d3 = d1;
     break;
    }
   }
   i4 = (i12 | 0) > 0;
   if (d7 * +Math_log(+(+Math_abs(+d10))) < 709.782712893384) if (i4) {
    d2 = 1.0;
    d1 = d3;
    i4 = i12;
    while (1) {
     d1 = d2 * (+(i4 | 0) * 2.0) / d13 - d1;
     if ((i4 | 0) > 1) {
      d15 = d2;
      d2 = d1;
      i4 = i4 + -1 | 0;
      d1 = d15;
     } else {
      d7 = d3;
      d5 = d1;
      break;
     }
    }
   } else {
    d7 = d3;
    d5 = 1.0;
    d2 = d3;
   } else if (i4) {
    d2 = d3;
    d5 = 1.0;
    d1 = d3;
    i4 = i12;
    while (1) {
     d1 = d5 * (+(i4 | 0) * 2.0) / d13 - d1;
     if (d1 > 3273390607896141870013189.0e126) {
      d2 = d2 / d1;
      d3 = 1.0;
      d1 = d5 / d1;
     } else {
      d3 = d1;
      d1 = d5;
     }
     if ((i4 | 0) > 1) {
      d5 = d3;
      i4 = i4 + -1 | 0;
     } else {
      d7 = d2;
      d5 = d3;
      d2 = d1;
      break;
     }
    }
   } else {
    d7 = d3;
    d5 = 1.0;
    d2 = d3;
   }
   d3 = +_j0(d13);
   d1 = +_j1(d13);
   if (!(+Math_abs(+d3) >= +Math_abs(+d1))) {
    d1 = d7 * d1 / d2;
    break;
   } else {
    d1 = d7 * d3 / d5;
    break;
   }
  } while (0);
  d1 = i14 | 0 ? -d1 : d1;
 } while (0);
 return +d1;
}

function __ZN5physx3Scb5Scene9syncStateEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i12 = i15 + 8 | 0;
 i1 = i14 + 3356 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i14 + 16 | 0;
  do {
   __ZN5physx2Sc5Scene12createClientEv(i2) | 0;
   i13 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
   HEAP32[i1 >> 2] = i13;
  } while ((i13 | 0) != 0);
 }
 i13 = i14 + 3372 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  HEAP32[i13 >> 2] = 0;
  i1 = i14 + 3080 | 0;
  i2 = i1 + 124 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i1 = i14 + 3012 | 0;
  i2 = i1 + 37 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  STACKTOP = i15;
  return;
 }
 if (i1 & 1 | 0) {
  HEAP32[i14 + 64 >> 2] = HEAP32[i14 + 3332 >> 2];
  HEAP32[i14 + 68 >> 2] = HEAP32[i14 + 3336 >> 2];
  HEAP32[i14 + 72 >> 2] = HEAP32[i14 + 3340 >> 2];
  HEAP32[i14 + 76 >> 2] = 1;
 }
 if (i1 & 2) {
  __ZN5physx2Sc5Scene26setBounceThresholdVelocityEf(i14 + 16 | 0, Math_fround(HEAPF32[i14 + 3344 >> 2]));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (i1 & 4 | 0) HEAP16[i14 + 1208 >> 1] = HEAP16[i14 + 3348 >> 1] | 0;
 if (i1 & 8) {
  i1 = i14 + 16 | 0;
  i2 = i11 + 4 | 0;
  i7 = 0;
  do {
   i3 = i14 + 3080 + (i7 << 2) | 0;
   i8 = i7;
   i7 = i7 + 1 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i4 = i14 + 3204 + (i8 << 2) | 0;
    i5 = 1 << i8;
    i6 = i8 & 255;
    i10 = i7;
    do {
     HEAPF32[i11 >> 2] = Math_fround(0.0);
     HEAPF32[i2 >> 2] = Math_fround(0.0);
     if (i8 >>> 0 < i10 >>> 0) i9 = HEAP32[i3 >> 2] & 1 << i10; else i9 = HEAP32[i14 + 3080 + (i10 << 2) >> 2] & i5;
     if (i9 | 0) {
      HEAPF32[i11 >> 2] = Math_fround((HEAP32[i4 >> 2] & 1 << i10) >>> i10 >>> 0);
      HEAPF32[i2 >> 2] = Math_fround((HEAP32[i14 + 3204 + (i10 << 2) >> 2] & i5) >>> i8 >>> 0);
      __ZN5physx2Sc5Scene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE(i1, i6, i10 & 255, i11);
     }
     i10 = i10 + 1 | 0;
    } while ((i10 | 0) != 32);
   }
  } while ((i7 | 0) != 31);
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (i1 & 16) {
  __ZN5physx2Sc5Scene18setSolverBatchSizeEj(i14 + 16 | 0, HEAP32[i14 + 3352 >> 2] | 0);
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if (i1 & 32) {
  i7 = i14 + 3364 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (i2) {
   i5 = i14 + 3360 | 0;
   i6 = i14 + 16 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = 0;
   do {
    i3 = HEAP8[i1 + i4 >> 0] | 0;
    if (i3 << 24 >> 24 != -1) {
     HEAP8[i12 >> 0] = i3;
     __ZN5physx2Sc5Scene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE(i6, i4 & 255, i12);
     i1 = HEAP32[i5 >> 2] | 0;
     HEAP8[i1 + i4 >> 0] = -1;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i2 >>> 0);
   i1 = HEAP32[i13 >> 2] | 0;
  }
 }
 if (!(i1 & 64)) {
  HEAP32[i13 >> 2] = 0;
  i1 = i14 + 3080 | 0;
  i2 = i1 + 124 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i1 = i14 + 3012 | 0;
  i2 = i1 + 37 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  STACKTOP = i15;
  return;
 }
 i1 = i14 + 16 | 0;
 i2 = 0;
 do {
  if (HEAP8[i14 + 3012 + i2 >> 0] | 0) __ZN5physx2Sc5Scene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(i1, i2, Math_fround(HEAPF32[i14 + 2864 + (i2 << 2) >> 2]));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 37);
 HEAP32[i13 >> 2] = 0;
 i1 = i14 + 3080 | 0;
 i2 = i1 + 124 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i14 + 3012 | 0;
 i2 = i1 + 37 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn9StrToImplINS_15PxMetaDataPlaneEE5strtoERS2_RPKc(i1, i11, i10) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0, i13 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L1 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L1;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 i5 = i8 + 255 | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L6 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L6;
   i6 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i6 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i6 = i8;
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L12 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L12;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L17 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L17;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 + 4 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L23 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L23;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L28 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L28;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 + 8 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L34 : do if (!(i2 << 24 >> 24)) i4 = i1; else while (1) {
  if (!(_isspace(i2 & 255) | 0)) {
   i4 = i1;
   break L34;
  }
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i4 = i1;
   break;
  }
 } while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i1 = HEAP8[i4 >> 0] | 0;
 L39 : do if (!(i1 << 24 >> 24)) i1 = i8; else if (!(_isspace(i1 & 255) | 0)) {
  i3 = i4;
  i2 = i8;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L39;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i1 >>> 0 < i13 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i8; while (0);
 HEAP8[i1 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 HEAP32[i10 >> 2] = i4 + ((HEAP32[i7 >> 2] | 0) - i6);
 HEAPF32[i11 + 12 >> 2] = f12;
 STACKTOP = i9;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR11EventSorterP14AnimationEventEEbT0_S5_T_(i13, i14, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 64 | 0;
 i16 = i17;
 switch (i14 - i13 >> 6 | 0) {
 case 2:
  {
   i1 = i14 + -64 | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) < Math_fround(HEAPF32[i13 >> 2]))) {
    i16 = 1;
    STACKTOP = i17;
    return i16 | 0;
   }
   __ZN14AnimationEventC2ERKS_(i16, i13);
   __ZN14AnimationEventaSERKS_(i13, i1) | 0;
   __ZN14AnimationEventaSERKS_(i1, i16) | 0;
   i1 = i16 + 20 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i1 >> 2] | 0;
    i13 = HEAP32[i16 + 32 >> 2] | 0;
    HEAP32[i15 >> 2] = 66;
    HEAP32[i15 + 4 >> 2] = i13;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
   }
   i1 = i16 + 4 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i1 >> 2] | 0;
    i16 = HEAP32[i16 + 16 >> 2] | 0;
    HEAP32[i15 >> 2] = 66;
    HEAP32[i15 + 4 >> 2] = i16;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i15);
   }
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i13, i13 + 64 | 0, i14 + -64 | 0, i1) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_(i13, i13 + 64 | 0, i13 + 128 | 0, i14 + -64 | 0, i1) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_(i13, i13 + 64 | 0, i13 + 128 | 0, i13 + 192 | 0, i14 + -64 | 0, i1) | 0;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 case 1:
 case 0:
  {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 default:
  {
   i3 = i13 + 128 | 0;
   __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i13, i13 + 64 | 0, i3, i1) | 0;
   i1 = i13 + 192 | 0;
   L3 : do if ((i1 | 0) == (i14 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i5 = i16 + 20 | 0;
    i6 = i5 + 11 | 0;
    i7 = i16 + 32 | 0;
    i8 = i15 + 4 | 0;
    i9 = i16 + 4 | 0;
    i10 = i9 + 11 | 0;
    i11 = i16 + 16 | 0;
    i12 = i15 + 4 | 0;
    i2 = 0;
    while (1) {
     f18 = Math_fround(HEAPF32[i1 >> 2]);
     if (f18 < Math_fround(HEAPF32[i3 >> 2])) {
      __ZN14AnimationEventC2ERKS_(i16, i1);
      i4 = i1;
      while (1) {
       __ZN14AnimationEventaSERKS_(i4, i3) | 0;
       if ((i3 | 0) == (i13 | 0)) {
        i3 = i13;
        break;
       }
       i4 = i3 + -64 | 0;
       f18 = Math_fround(HEAPF32[i16 >> 2]);
       if (f18 < Math_fround(HEAPF32[i4 >> 2])) {
        i19 = i3;
        i3 = i4;
        i4 = i19;
       } else break;
      }
      __ZN14AnimationEventaSERKS_(i3, i16) | 0;
      i2 = i2 + 1 | 0;
      if ((HEAP8[i6 >> 0] | 0) < 0) {
       i19 = HEAP32[i5 >> 2] | 0;
       i4 = HEAP32[i7 >> 2] | 0;
       HEAP32[i15 >> 2] = 66;
       HEAP32[i8 >> 2] = i4;
       __Z19free_alloc_internalPvRK10MemLabelId(i19, i15);
      }
      if ((HEAP8[i10 >> 0] | 0) < 0) {
       i19 = HEAP32[i9 >> 2] | 0;
       i4 = HEAP32[i11 >> 2] | 0;
       HEAP32[i15 >> 2] = 66;
       HEAP32[i12 >> 2] = i4;
       __Z19free_alloc_internalPvRK10MemLabelId(i19, i15);
      }
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 64 | 0) == (i14 | 0);
       break L3;
      }
     }
     i3 = i1 + 64 | 0;
     if ((i3 | 0) == (i14 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i19 = i1;
      i1 = i3;
      i3 = i19;
     }
    }
   } while (0);
   i19 = i1 | i2;
   STACKTOP = i17;
   return i19 | 0;
  }
 }
 return 0;
}

function __ZN5Unity12PhysicsQuery7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction(i1, i5, f2, i15, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 40 | 0;
 i1 = i16 + 20 | 0;
 i3 = i16 + 124 | 0;
 i4 = i16;
 if ((HEAP16[gb + 1452596 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452596 | 0, i13);
  i14 = gb + 1452596 | 0;
 } else i14 = 0;
 i12 = f2 == Math_fround(inf);
 f2 = i12 ? Math_fround(3402823469999999843913219.0e14) : f2;
 HEAP32[i4 >> 2] = gb + 114012 + 8;
 HEAP32[i4 + 4 >> 2] = 2;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i6;
 switch (i7 | 0) {
 case 0:
  {
   HEAP8[i4 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i4 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i4 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i17 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i8 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i7 = i13 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i13 + 12 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP16[i13 + 16 >> 1] = 0;
 i10 = i13 + 20 | 0;
 i12 = i13 + 44 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAPF32[i12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i10 = i13 + 48 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 i11 = i13 + 52 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAP8[i13 + 68 >> 0] = 0;
 HEAP32[i13 + 72 >> 2] = 0;
 HEAP32[i13 + 76 >> 2] = 0;
 HEAP32[i13 + 80 >> 2] = 0;
 HEAP32[i13 >> 2] = gb + 85940 + 8;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 15;
 HEAP8[i1 + 18 >> 0] = 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 348 >> 2] | 0;
 HEAP16[i3 >> 1] = i17 ? 143 : 15;
 mftCall_iiiifiiiii(i9 | 0, i8 | 0, i5 | 0, i5 + 12 | 0, +f2, i13 | 0, i3 | 0, i1 | 0, i4 | 0, 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i13 + 20 >> 2] | 0;
 i5 = HEAP32[i13 + 24 >> 2] | 0;
 i6 = HEAP32[i13 + 28 >> 2] | 0;
 i7 = HEAP32[i13 + 32 >> 2] | 0;
 i8 = HEAP32[i13 + 36 >> 2] | 0;
 i9 = HEAP32[i13 + 40 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i15 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i15 >> 2] = i4;
  HEAP32[i15 + 4 >> 2] = i5;
  HEAP32[i15 + 8 >> 2] = i6;
  HEAP32[i15 + 12 >> 2] = i7;
  HEAP32[i15 + 16 >> 2] = i8;
  HEAP32[i15 + 20 >> 2] = i9;
  HEAP32[i13 >> 2] = 5;
  HEAPF32[i13 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i13 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i13 + 28 >> 2] = Math_fround(1.0);
  i17 = i13 + 32 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i13 | 0) | 0) {
   i1 = HEAP32[i13 + 36 >> 2] | 0;
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) + (i3 << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i15 + 24 >> 2] = i1;
  HEAP32[i15 + 28 >> 2] = i12;
  HEAP32[i15 + 32 >> 2] = i10;
  HEAP32[i15 + 36 >> 2] = i11;
  i1 = 1;
 }
 if (!i14) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i16;
 return i1 | 0;
}

function runPostSets30() {
 HEAP32[gb + 43300 >> 2] = fb + 113;
 HEAP32[gb + 43304 >> 2] = fb + 336;
 HEAP32[gb + 43308 >> 2] = fb + 337;
 HEAP32[gb + 43320 >> 2] = fb + 338;
 HEAP32[gb + 43324 >> 2] = fb + 339;
 HEAP32[gb + 43328 >> 2] = fb + 80;
 HEAP32[gb + 43332 >> 2] = fb + 322;
 HEAP32[gb + 43336 >> 2] = fb + 16;
 HEAP32[gb + 43340 >> 2] = fb + 340;
 HEAP32[gb + 43344 >> 2] = fb + 341;
 HEAP32[gb + 43348 >> 2] = fb + 19;
 HEAP32[gb + 43352 >> 2] = fb + 203;
 HEAP32[gb + 43356 >> 2] = fb + 95;
 HEAP32[gb + 43360 >> 2] = fb + 40;
 HEAP32[gb + 43364 >> 2] = fb + 62;
 HEAP32[gb + 43368 >> 2] = fb + 28;
 HEAP32[gb + 43372 >> 2] = fb + 63;
 HEAP32[gb + 43376 >> 2] = fb + 29;
 HEAP32[gb + 43380 >> 2] = fb + 34;
 HEAP32[gb + 43384 >> 2] = fb + 323;
 HEAP32[gb + 43388 >> 2] = fb + 324;
 HEAP32[gb + 43392 >> 2] = fb + 325;
 HEAP32[gb + 43396 >> 2] = fb + 326;
 HEAP32[gb + 43400 >> 2] = fb + 327;
 HEAP32[gb + 43404 >> 2] = fb + 328;
 HEAP32[gb + 43408 >> 2] = fb + 36;
 HEAP32[gb + 43412 >> 2] = fb + 96;
 HEAP32[gb + 43416 >> 2] = fb + 81;
 HEAP32[gb + 43420 >> 2] = fb + 82;
 HEAP32[gb + 43432 >> 2] = fb + 342;
 HEAP32[gb + 43436 >> 2] = fb + 343;
 HEAP32[gb + 43440 >> 2] = (HEAP32[gb + 43440 >> 2] | 0) + (gb + 403239 | 0);
 HEAP32[gb + 43444 >> 2] = (HEAP32[gb + 43444 >> 2] | 0) + (gb + 403255 | 0);
 HEAP32[gb + 43448 >> 2] = (HEAP32[gb + 43448 >> 2] | 0) + (gb + 403267 | 0);
 HEAP32[gb + 43460 >> 2] = fb + 2;
 HEAP32[gb + 43464 >> 2] = fb + 2;
 HEAP32[gb + 43468 >> 2] = fb + 34;
 HEAP32[gb + 43472 >> 2] = fb + 67;
 HEAP32[gb + 43476 >> 2] = fb + 14;
 HEAP32[gb + 43480 >> 2] = fb + 15;
 HEAP32[gb + 43484 >> 2] = fb + 22;
 HEAP32[gb + 43488 >> 2] = fb + 9;
 HEAP32[gb + 43500 >> 2] = fb + 344;
 HEAP32[gb + 43504 >> 2] = fb + 345;
 HEAP32[gb + 43508 >> 2] = fb + 346;
 HEAP32[gb + 43512 >> 2] = fb + 329;
 HEAP32[gb + 43516 >> 2] = fb + 16;
 HEAP32[gb + 43520 >> 2] = fb + 347;
 HEAP32[gb + 43524 >> 2] = fb + 348;
 HEAP32[gb + 43528 >> 2] = fb + 349;
 HEAP32[gb + 43532 >> 2] = fb + 204;
 HEAP32[gb + 43536 >> 2] = fb + 103;
 HEAP32[gb + 43540 >> 2] = fb + 101;
 HEAP32[gb + 43544 >> 2] = fb + 62;
 HEAP32[gb + 43548 >> 2] = fb + 28;
 HEAP32[gb + 43552 >> 2] = fb + 63;
 HEAP32[gb + 43556 >> 2] = fb + 29;
 HEAP32[gb + 43560 >> 2] = fb + 34;
 HEAP32[gb + 43564 >> 2] = fb + 330;
 HEAP32[gb + 43568 >> 2] = fb + 331;
 HEAP32[gb + 43572 >> 2] = fb + 332;
 HEAP32[gb + 43576 >> 2] = fb + 333;
 HEAP32[gb + 43580 >> 2] = fb + 334;
 HEAP32[gb + 43584 >> 2] = fb + 335;
 HEAP32[gb + 43588 >> 2] = fb + 36;
 HEAP32[gb + 43592 >> 2] = fb + 104;
 HEAP32[gb + 43596 >> 2] = fb + 336;
 HEAP32[gb + 43600 >> 2] = fb + 94;
 HEAP32[gb + 43604 >> 2] = fb + 337;
 HEAP32[gb + 43608 >> 2] = fb + 205;
 HEAP32[gb + 43612 >> 2] = fb + 206;
 HEAP32[gb + 43616 >> 2] = fb + 338;
 HEAP32[gb + 43620 >> 2] = fb + 350;
 HEAP32[gb + 43624 >> 2] = fb + 351;
 HEAP32[gb + 43628 >> 2] = fb + 207;
 HEAP32[gb + 43632 >> 2] = fb + 352;
 HEAP32[gb + 43636 >> 2] = fb + 353;
 HEAP32[gb + 43640 >> 2] = fb + 208;
 HEAP32[gb + 43644 >> 2] = fb + 68;
 HEAP32[gb + 43648 >> 2] = fb + 69;
 HEAP32[gb + 43652 >> 2] = fb + 354;
 HEAP32[gb + 43656 >> 2] = fb + 355;
 HEAP32[gb + 43660 >> 2] = fb + 356;
 HEAP32[gb + 43664 >> 2] = fb + 28;
 HEAP32[gb + 43676 >> 2] = fb + 357;
 HEAP32[gb + 43680 >> 2] = fb + 358;
 HEAP32[gb + 43684 >> 2] = fb + 29;
 HEAP32[gb + 43688 >> 2] = fb + 102;
 HEAP32[gb + 43692 >> 2] = fb + 359;
 HEAP32[gb + 43696 >> 2] = fb + 360;
 HEAP32[gb + 43700 >> 2] = fb + 209;
 HEAP32[gb + 43704 >> 2] = fb + 210;
 HEAP32[gb + 43708 >> 2] = fb + 70;
 HEAP32[gb + 43712 >> 2] = fb + 71;
 HEAP32[gb + 43716 >> 2] = fb + 110;
 HEAP32[gb + 43720 >> 2] = fb + 105;
 HEAP32[gb + 43724 >> 2] = fb + 361;
 HEAP32[gb + 43736 >> 2] = fb + 362;
 HEAP32[gb + 43740 >> 2] = fb + 363;
 HEAP32[gb + 43744 >> 2] = fb + 346;
 runPostSets31();
}

function __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff(i15, i16, i8, i12, i13, f10, f7) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 f10 = Math_fround(f10);
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i9 = 0, i11 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18;
 i17 = i18 + 16 | 0;
 i1 = HEAP32[i15 + 20 >> 2] | 0;
 i2 = HEAP32[i15 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i2 | 0)) {
  i4 = HEAP32[i15 + 32 >> 2] | 0;
  i5 = HEAP32[i16 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i9 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i14 = HEAP32[(HEAP32[i15 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i9 = 7;
 } else i9 = 7; while (0);
 if ((i9 | 0) == 7) i14 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i15, i16, 0) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = i15 + 72 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) + i14 | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  f10 = Math_fround(1.0);
  f7 = Math_fround(1.0);
  f6 = Math_fround(1.0);
  f3 = Math_fround(1.0);
 } else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = 2;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if ((i1 + -1 | 0) >>> 0 >= 2) {
   i5 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i9 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i16) | 0;
   HEAP32[i11 >> 2] = gb + 478914;
   HEAP32[i11 + 4 >> 2] = i5;
   HEAP32[i11 + 8 >> 2] = i9;
   __Z6FormatPKcz(i17, gb + 478736 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
  }
  HEAP32[i2 + 12 >> 2] = 0;
  f6 = Math_fround(i12 | 0);
  f3 = Math_fround(i13 | 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + i14 + 24 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i15, i16, gb + 478720 | 0) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i2 + i14 + 24 >> 2] = i1;
 }
 i4 = i15 + 12 | 0;
 i5 = i15 + 52 | 0;
 i1 = i2 + (HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) + i1 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i1 >> 2] = f10;
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f6;
 HEAPF32[i1 + 12 >> 2] = f3;
 __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i17, 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + i14 + 28 >> 2] | 0;
 if ((i2 | 0) >= 0) {
  i16 = i2;
  i15 = i1;
  i14 = HEAP32[i4 >> 2] | 0;
  i16 = i14 + i16 | 0;
  i14 = HEAP32[i5 >> 2] | 0;
  i16 = i14 + (i16 << 2) | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i16 = i16 & 1048575;
  i16 = i15 + i16 | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  STACKTOP = i18;
  return;
 }
 i16 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i15, i16, gb + 478731 | 0) | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 + i14 + 28 >> 2] = i16;
 i14 = HEAP32[i4 >> 2] | 0;
 i16 = i14 + i16 | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i16 = i14 + (i16 << 2) | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i16 = i16 & 1048575;
 i16 = i15 + i16 | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 STACKTOP = i18;
 return;
}

function __Z17CircleHullOverlapPfRK13dynamic_arrayI8Vector2fLj4EERKS1_f(i19, i1, i9, f20) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 f20 = Math_fround(f20);
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f21 = f0;
 i17 = HEAP32[i1 + 12 >> 2] | 0;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 i16 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 if (i17 >>> 0 > 1) {
  i5 = 1;
  do {
   f15 = Math_fround(HEAPF32[i16 + (i5 << 3) >> 2]);
   f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f15);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   f15 = Math_fround(HEAPF32[i16 + (i5 << 3) + 4 >> 2]);
   f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f15);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i17 | 0));
 }
 f6 = Math_fround(Math_fround(1.0) / Math_fround(i17 >>> 0));
 f7 = Math_fround(f6 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f6 = Math_fround(f6 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 if (!i17) {
  i19 = 0;
  return i19 | 0;
 }
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 f14 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f2 = Math_fround(f15 - f7);
 f4 = Math_fround(f14 - f6);
 i1 = i17 + -1 | 0;
 i3 = 0;
 while (1) {
  f13 = Math_fround(HEAPF32[i16 + (i1 << 3) >> 2]);
  f12 = Math_fround(HEAPF32[i16 + (i1 << 3) + 4 >> 2]);
  if (!(Math_fround(Math_fround(Math_fround(f13 - f7) * f4) - Math_fround(Math_fround(f12 - f6) * f2)) > Math_fround(0.0))) {
   f10 = Math_fround(HEAPF32[i16 + (i3 << 3) >> 2]);
   f11 = Math_fround(HEAPF32[i16 + (i3 << 3) + 4 >> 2]);
   if (!(Math_fround(Math_fround(f4 * Math_fround(f10 - f7)) - Math_fround(f2 * Math_fround(f11 - f6))) < Math_fround(0.0))) break;
  }
  i1 = i3 + 1 | 0;
  if (i1 >>> 0 < i17 >>> 0) {
   i9 = i3;
   i3 = i1;
   i1 = i9;
  } else {
   i1 = 0;
   i18 = 20;
   break;
  }
 }
 if ((i18 | 0) == 20) return i1 | 0;
 f7 = Math_fround(f10 - f13);
 f8 = Math_fround(f11 - f12);
 f6 = Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8));
 do if (f6 == Math_fround(0.0)) {
  f4 = Math_fround(f13 - f15);
  f6 = Math_fround(f12 - f14);
  f6 = Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6));
  f4 = Math_fround(f14 - f12);
  f2 = Math_fround(f15 - f13);
 } else {
  f4 = Math_fround(f14 - f12);
  f2 = Math_fround(f15 - f13);
  f6 = Math_fround(Math_fround(Math_fround(f2 * f7) + Math_fround(f4 * f8)) / f6);
  if (f6 <= Math_fround(0.0)) {
   f15 = Math_fround(f13 - f15);
   f6 = Math_fround(f12 - f14);
   f6 = Math_fround(Math_fround(f15 * f15) + Math_fround(f6 * f6));
   break;
  }
  if (!(f6 >= Math_fround(1.0))) {
   f21 = Math_fround(Math_fround(1.0) - f6);
   f15 = Math_fround(Math_fround(Math_fround(f10 * f6) + Math_fround(f13 * f21)) - f15);
   f6 = Math_fround(Math_fround(Math_fround(f11 * f6) + Math_fround(f12 * f21)) - f14);
   f6 = Math_fround(Math_fround(f15 * f15) + Math_fround(f6 * f6));
   break;
  } else {
   f21 = Math_fround(f10 - f15);
   f6 = Math_fround(f11 - f14);
   f6 = Math_fround(Math_fround(f21 * f21) + Math_fround(f6 * f6));
   break;
  }
 } while (0);
 if (Math_fround(Math_fround(f7 * f4) - Math_fround(f8 * f2)) < Math_fround(0.0)) {
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(f6))) + f20);
  i19 = 1;
  return i19 | 0;
 }
 if (!(f6 >= Math_fround(f20 * f20))) {
  HEAPF32[i19 >> 2] = Math_fround(f20 - Math_fround(Math_sqrt(Math_fround(f6))));
  i19 = 1;
  return i19 | 0;
 } else {
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  i19 = 0;
  return i19 | 0;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i9 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
  i9 = i5 + 48 | 0;
  HEAP8[i9 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i9 = i5 + 48 | 0;
  HEAP8[i9 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i17 = i6 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i16 = i6 + 8 | 0;
 i18 = i5 + 8 | 0;
 i15 = HEAP16[i18 >> 1] | 0;
 HEAP8[i16 >> 0] = i15;
 i12 = i6 + 9 | 0;
 HEAP8[i12 >> 0] = (i15 & 65535) >>> 8;
 i15 = i6 + 12 | 0;
 i14 = i5 + 12 | 0;
 i20 = i14;
 i13 = HEAP32[i20 + 4 >> 2] | 0;
 i2 = i15;
 HEAP32[i2 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i2 + 4 >> 2] = i13;
 i2 = i6 + 20 | 0;
 i13 = i5 + 20 | 0;
 i20 = i13;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i11 = i2;
 HEAP32[i11 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i11 + 4 >> 2] = i19;
 i11 = i6 + 28 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP8[i11 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j(i6, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i1;
 i4 = HEAP8[i18 >> 0] | 0;
 i17 = HEAP16[i16 >> 1] | 0;
 HEAP8[i18 >> 0] = i17;
 HEAP8[i16 >> 0] = i4;
 i4 = i5 + 9 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = (i17 & 65535) >>> 8;
 HEAP8[i12 >> 0] = i1;
 i1 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i5 + 16 >> 2] | 0;
 i4 = i12 >>> 8;
 i17 = i15;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 HEAP32[i15 >> 2] = i1;
 HEAP8[i6 + 16 >> 0] = i12;
 i12 = i6 + 17 | 0;
 i1 = i4 & 65535;
 HEAP8[i12 >> 0] = i1;
 HEAP8[i12 + 1 >> 0] = i1 >> 8;
 HEAP8[i12 + 2 >> 0] = i4 >>> 16;
 i12 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = i4 >>> 8;
 i15 = i2;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i2 >> 2] = i12;
 HEAP8[i6 + 24 >> 0] = i4;
 i4 = i6 + 25 | 0;
 i2 = i1 & 65535;
 HEAP8[i4 >> 0] = i2;
 HEAP8[i4 + 1 >> 0] = i2 >> 8;
 HEAP8[i4 + 2 >> 0] = i1 >>> 16;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i1;
 i11 = i6 + 32 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i11 >> 2] = i4;
 i7 = i6 + 36 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i11;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i9 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i6 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i6 + 40 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 + 48 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 i20 = i5 + 48 | 0;
 HEAP8[i20 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j(i13, i11) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 24 | 0;
 i2 = i15 + 20 | 0;
 i10 = i15 + 8 | 0;
 i3 = i15 + 4 | 0;
 i4 = i15;
 i14 = i13 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i1 = i5 - i6 >> 3;
 i8 = i6;
 if (i1 >>> 0 < i11 >>> 0) {
  i8 = i13 + 8 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i6 >> 3 | 0) == (i11 | 0)) {
   __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE8__appendEj(i13, i11 - i1 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i10 >> 2] = 0;
  i9 = i10 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i7 = i10 + 8 | 0;
  if (i11 | 0) {
   i1 = __Znwj(i11 << 3) | 0;
   i16 = i1;
   HEAP32[i10 >> 2] = i16;
   HEAP32[i9 >> 2] = i16;
   HEAP32[i7 >> 2] = i1 + (i11 << 3);
  }
  HEAP32[i3 >> 2] = i6;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i10, i2, i12);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = i1 - i4 >> 3;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i11 >>> 0) {
   __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE8__appendEj(i10, i11 - i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else if (i2 >>> 0 > i11 >>> 0) {
   i2 = i3 + (i11 << 3) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -8 - i2 | 0) >>> 3) << 3) | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i13 >> 2] = i2;
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i14 >> 2] = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 } else {
  if (i1 >>> 0 <= i11 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i5 = i8 + (i11 << 3) | 0;
  HEAP32[i12 >> 2] = 0;
  i9 = i12 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = i11 << 3;
  i2 = i1 >> 3;
  if (!i2) {
   i4 = i12 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i4 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i12 >> 2] = i4;
   i1 = i4 + (i2 << 3) | 0;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = i1;
   i6 = i4;
   if (!i11) {
    i4 = i7;
    i5 = i6;
    i2 = i6;
   } else {
    i1 = i8;
    i3 = i4;
    i2 = i4;
    while (1) {
     i10 = i1;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i16 + 4 >> 2] = i11;
     i1 = i1 + 8 | 0;
     i2 = i2 + 8 | 0;
     HEAP32[i9 >> 2] = i2;
     if ((i1 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i4 = i7;
    i5 = i6;
    i1 = HEAP32[i7 >> 2] | 0;
   }
  }
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
  i16 = HEAP32[i14 >> 2] | 0;
  HEAP32[i9 >> 2] = i16;
  HEAP32[i14 >> 2] = i2;
  i2 = i13 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i16;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
}

function __ZN5physx2Gu5Debug9visualizeERKNS_15PxPlaneGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i1, i8, i7, i2, i6, i3, f4, i5) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 8 | 0;
 i1 = i3;
 if ((i6 & 8192 | 0) == 0 & 0 == 0) {
  STACKTOP = i3;
  return;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = HEAP32[i7 + 8 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 i16 = HEAP32[i7 + 40 >> 2] | 0;
 i15 = HEAP32[i7 + 44 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i2 + 52 >> 2] = i16;
 HEAP32[i2 + 56 >> 2] = i15;
 HEAP32[i2 + 60 >> 2] = 0;
 f13 = Math_fround(-f13);
 f12 = Math_fround(-f12);
 HEAPF32[i2 + 16 >> 2] = Math_fround(-f14);
 HEAPF32[i2 + 20 >> 2] = f13;
 HEAPF32[i2 + 24 >> 2] = f12;
 HEAPF32[i2 + 28 >> 2] = Math_fround(-0.0);
 HEAP32[i2 + 32 >> 2] = i11;
 HEAP32[i2 + 36 >> 2] = i5;
 HEAP32[i2 + 40 >> 2] = i6;
 HEAP32[i2 + 44 >> 2] = 0;
 f9 = Math_fround(-f9);
 f4 = Math_fround(-f4);
 HEAPF32[i2 >> 2] = Math_fround(-f10);
 HEAPF32[i2 + 4 >> 2] = f9;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = Math_fround(-0.0);
 i7 = i1 + 4 | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(4.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(16.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(36.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(64.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(100.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(144.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(196.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i6 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(256.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i6, i1) | 0;
 i8 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i8, -65281) | 0, i2) | 0;
 HEAP32[i1 >> 2] = 100;
 HEAPF32[i7 >> 2] = Math_fround(324.0);
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i8, i1) | 0;
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 56 | 0;
 i11 = i12 + 40 | 0;
 i6 = i12 + 24 | 0;
 i7 = i12 + 12 | 0;
 i8 = i12;
 i1 = HEAP8[i5 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 } else {
  i3 = i5;
  i1 = i1 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i3, i1);
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i3 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i7, i8);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i6 >> 2] | 0 : i6;
 i4 = i1 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i11 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i11; else {
   i1 = i11;
   i9 = 9;
  }
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i4;
  i2 = i11 + 11 | 0;
  i9 = 9;
 }
 if ((i9 | 0) == 9) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i9 = i5 + 120 | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP8[i9 + 1 >> 0] = 0;
 HEAP8[i9 + 2 >> 0] = 0;
 HEAP8[i9 + 3 >> 0] = 0;
 HEAP8[i9 + 4 >> 0] = 0;
 __Z29DeleteFileOrDirectoryIfExistsPKcb((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 1) | 0;
 __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11);
 i9 = __ZNK15FileSystemEntry12FolderExistsEv(i10) | 0;
 __ZN13FileEntryDataD2Ev(i10);
 if (i9) {
  __Z29DeleteFileOrDirectoryIfExistsPKcb((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 1) | 0;
  __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11);
  i9 = __ZNK15FileSystemEntry12FolderExistsEv(i10) | 0;
  __ZN13FileEntryDataD2Ev(i10);
  if (i9) {
   __ZN11UnityEngine15CloudWebService16SessionContainer31HandleDeleteArchivedFolderErrorERK8UnityStr(i5, i11);
   __Z29DeleteFileOrDirectoryIfExistsPKcb((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 1) | 0;
   __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11);
   i1 = (__ZNK15FileSystemEntry12FolderExistsEv(i10) | 0) ^ 1;
   __ZN13FileEntryDataD2Ev(i10);
  } else i1 = 1;
 } else i1 = 1;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN11AssetBundle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i4 = i9 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 48 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i9 + 76 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i3 = i9 + 72 | 0;
 i1 = HEAP32[i9 + 68 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS5_RT_(i2 + 16 | 0, i10);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 i1 = i9 + 36 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 44 | 0, i10);
 i1 = i9 + 32 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i9 + 168 | 0, i10);
 i3 = i9 + 172 | 0;
 i7 = i9 + 176 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 184 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i9);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i9);
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = i10 + 20 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i8 * 76 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + (i1 * 76 | 0) | 0;
 i7 = i10 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 148864 + 8;
   i11 = i2 + 4 | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i13 = i2 + 16 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i11 = i1 + 28 | 0;
   i12 = i2 + 28 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   i11 = i2 + 44 | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i1 + 44 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   i13 = i2 + 52 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1 + 52 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   i11 = i1 + 64 | 0;
   i12 = i2 + 64 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i1 = i1 + 76 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 76 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i4 + (i1 * 76 | 0) >> 2] = gb + 148864 + 8;
 i13 = i9 + 4 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i4 + (i1 * 76 | 0) + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i11 = i9 + 16 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 * 76 | 0) + 16 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i13 = i4 + (i1 * 76 | 0) + 28 | 0;
 i12 = i9 + 28 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i4 + (i1 * 76 | 0) + 40 >> 2] = HEAP32[i9 + 40 >> 2];
 i13 = i9 + 44 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i4 + (i1 * 76 | 0) + 44 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = i9 + 52 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 * 76 | 0) + 52 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i4 + (i1 * 76 | 0) + 60 >> 2] = HEAP32[i9 + 60 >> 2];
 i13 = i4 + (i1 * 76 | 0) + 64 | 0;
 i12 = i9 + 64 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i4 + (i13 * 76 | 0) | 0;
  return i13 | 0;
 }
 i13 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i4;
 HEAP32[i5 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i4 + (i13 * 76 | 0) | 0;
 return i13 | 0;
}

function __ZNK6Sprite11GetInnerUVsEb(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i7 = i8;
 i6 = HEAP32[i10 + 80 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 9;
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 17;
   }
  }
  if ((i11 | 0) == 15) i11 = 17;
  if ((i11 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i1 | 0);
  f20 = Math_fround(HEAPF32[i10 + 88 >> 2]);
  f18 = Math_fround(HEAPF32[i10 + 92 >> 2]);
  f19 = Math_fround(HEAPF32[i10 + 96 >> 2]);
  f16 = Math_fround(HEAPF32[i10 + 100 >> 2]);
  f14 = Math_fround(HEAPF32[i10 + 104 >> 2]);
  f17 = Math_fround(HEAPF32[i10 + 108 >> 2]);
  f15 = Math_fround(Math_fround(HEAPF32[i10 + 40 >> 2]) - Math_fround(f14 + f19));
  f13 = Math_fround(Math_fround(HEAPF32[i10 + 44 >> 2]) - Math_fround(f17 + f16));
  f14 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i10 + 56 >> 2])) - f14);
  f17 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i10 + 60 >> 2])) - f17);
  f19 = Math_fround(f20 + f19);
  f15 = Math_fround(f19 - Math_fround(Math_fround(HEAPF32[i10 + 64 >> 2]) - f15));
  f16 = Math_fround(f18 + f16);
  f13 = Math_fround(f16 - Math_fround(Math_fround(HEAPF32[i10 + 68 >> 2]) - f13));
  f16 = Math_fround(HEAPF32[i7 >> 2]);
  HEAPF32[i9 >> 2] = Math_fround(f16 * f14);
  f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  HEAPF32[i9 + 4 >> 2] = Math_fround(f14 * f17);
  HEAPF32[i9 + 8 >> 2] = Math_fround(f16 * f15);
  HEAPF32[i9 + 12 >> 2] = Math_fround(f14 * f13);
  STACKTOP = i8;
  return;
 } while (0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 56 | 0;
 i8 = i11;
 i9 = i5 + 36 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i10 = i5 + 40 | 0;
 if (i2 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i10 = i5 + 48 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i22 = i8 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i8 + 8 | 0;
 i24 = i5 + 8 | 0;
 i21 = HEAP16[i24 >> 1] | 0;
 HEAP8[i23 >> 0] = i21;
 i20 = i8 + 9 | 0;
 HEAP8[i20 >> 0] = (i21 & 65535) >>> 8;
 i21 = i8 + 12 | 0;
 i18 = i5 + 12 | 0;
 i15 = i18;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 i19 = i21;
 HEAP32[i19 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i19 + 4 >> 2] = i17;
 i19 = i8 + 20 | 0;
 i17 = i5 + 20 | 0;
 i15 = i17;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i19;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i16;
 i14 = i8 + 28 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i8 + 32 | 0;
 HEAP32[i16 >> 2] = 0;
 i15 = i8 + 36 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i13 = i8 + 44 | 0;
 HEAP32[i13 >> 2] = 0;
 i12 = i8 + 40 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i8, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i22 >> 2] = i1;
 i1 = HEAP8[i24 >> 0] | 0;
 i22 = HEAP16[i23 >> 1] | 0;
 HEAP8[i24 >> 0] = i22;
 HEAP8[i23 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i22 & 65535) >>> 8;
 HEAP8[i20 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i1;
 i4 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i16 >> 2] | 0;
 HEAP32[i7 >> 2] = i14;
 HEAP32[i16 >> 2] = i4;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i7;
 f3 = Math_fround(i14 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i13 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i12 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 >> 0] = 0;
 if (i1 | 0) {
  i24 = HEAP32[i8 + 52 >> 2] | 0;
  HEAP32[i6 >> 2] = 65;
  HEAP32[i6 + 4 >> 2] = i24;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i24 = i5 + 48 | 0;
 HEAP8[i24 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN10systeminfo18GetOperatingSystemEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 32 | 0;
 i12 = i14 + 16 | 0;
 i11 = i14;
 i3 = HEAP32[gb + 1103748 >> 2] | 0;
 i4 = HEAP8[i3 + 16 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 if (i2) i1 = HEAP32[i3 + 20 >> 2] | 0; else i1 = i4 & 255;
 if (i1 | 0) {
  i1 = i3 + 16 | 0;
  if (i2) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i3 + 20 >> 2] | 0;
  } else {
   i2 = i1;
   i1 = i4 & 255;
  };
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i2, i1);
  STACKTOP = i14;
  return;
 }
 i2 = _JS_SystemInfo_GetOS(0, 0) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i12, i2, 0);
 i2 = i12 + 11 | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 _JS_SystemInfo_GetOS((i9 ? HEAP32[i12 >> 2] | 0 : i12) | 0, (i9 ? HEAP32[i12 + 4 >> 2] | 0 : i8 & 255) | 0) | 0;
 i8 = HEAP32[gb + 1103748 >> 2] | 0;
 i9 = i8 + 16 | 0;
 i2 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i5 = 12;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i5 = 14;
  }
 } else i5 = 12;
 if ((i5 | 0) == 12) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i5 = 14;
 }
 if ((i5 | 0) == 14) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i11 + 11 | 0;
 do if ((i9 | 0) != (i11 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i7 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 20 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 20 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 }
 i3 = HEAP32[gb + 1103748 >> 2] | 0;
 i1 = i3 + 16 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 20 >> 2] | 0;
 } else {
  i2 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i2, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN9Transform13AwakeFromLoadE17AwakeFromLoadMode(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i10 = i11 + 32 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) __ZN9Transform25RebuildTransformHierarchyEv(i11);
 if (!i1) {
  i8 = i11 + 32 | 0;
  i9 = i8;
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i20 = i11 + 56 | 0;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = HEAP32[i20 + 8 >> 2] | 0;
  i4 = i11 + 40 | 0;
  i17 = HEAP32[i4 >> 2] | 0;
  i16 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  i7 = i11 + 68 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i9 + 8 >> 2] | 0;
  HEAP32[i5 + (i1 * 40 | 0) >> 2] = HEAP32[i20 >> 2];
  HEAP32[i5 + (i1 * 40 | 0) + 4 >> 2] = i19;
  HEAP32[i5 + (i1 * 40 | 0) + 8 >> 2] = i18;
  HEAP32[i5 + (i1 * 40 | 0) + 12 >> 2] = i17;
  HEAP32[i5 + (i1 * 40 | 0) + 16 >> 2] = i16;
  HEAP32[i5 + (i1 * 40 | 0) + 20 >> 2] = i2;
  HEAP32[i5 + (i1 * 40 | 0) + 24 >> 2] = i4;
  HEAP32[i5 + (i1 * 40 | 0) + 28 >> 2] = i3;
  HEAP32[i5 + (i1 * 40 | 0) + 32 >> 2] = i6;
  HEAP32[i5 + (i1 * 40 | 0) + 36 >> 2] = i7;
  f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i7 = (HEAP32[tempDoublePtr >> 2] = i6 & -2147483648 ^ (i3 & -2147483648 | 1065353216) ^ i7 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
  i3 = ((Math_fround(Math_abs(Math_fround(f13 - f15))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f15 - f14))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f14 - f13))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i7) ^ 1;
  i3 = (i7 << 2 | 3) & ~(i3 << 1) & (i3 & ((Math_fround(Math_abs(Math_fround(f15 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f14 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f13 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
  HEAP32[(HEAP32[i9 + 64 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i8 + 44 >> 2] | HEAP32[i8 + 40 >> 2] | HEAP32[i8 + 48 >> 2];
  i3 = HEAP32[(HEAP32[i8 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i8 + 60 >> 2] | 0;
   i5 = HEAP32[i8 + 56 >> 2] | 0;
   i6 = i8 + 36 | 0;
   i7 = HEAP32[i8 + 68 >> 2] | 0;
   i2 = 0;
   while (1) {
    i20 = HEAP32[i4 + (i1 << 2) >> 2] & i9;
    i19 = i5 + (i1 << 2) | 0;
    HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i20;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i20;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
   }
  }
  __ZL24SendTransformChangedMaskRK18TransformHierarchyii(i8, HEAP32[i11 + 36 >> 2] | 0, 139);
  __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 }
 if (HEAP32[i11 + 104 >> 2] | 0) return;
 i1 = __Z15GetSceneManagerv() | 0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i2) i12 = 11; else {
  i1 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
  if (!i1) i12 = 11;
 }
 if ((i12 | 0) == 11) i1 = __ZN19RuntimeSceneManager14GetActiveSceneEv(__Z15GetSceneManagerv() | 0) | 0;
 if (HEAP32[i11 + 100 >> 2] | 0) return;
 if (!(i1 | 0 ? (HEAP32[i11 + 8 >> 2] & 1048576 | 0) == 0 : 0)) return;
 __ZN10UnityScene14AddRootToSceneERS_R9Transform(i1, i11);
 return;
}

function __ZN5physx2Sn9StrToImplINS_6PxQuatEE5strtoERS2_RPKc(i1, i11, i10) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0, i13 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L1 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L1;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 i5 = i8 + 255 | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L6 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L6;
   i6 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i6 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i6 = i8;
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L12 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L12;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L17 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L17;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 + 4 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L23 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L23;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP8[i1 >> 0] | 0;
 L28 : do if (!(i2 << 24 >> 24)) i2 = i8; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i8;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L28;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i2 >>> 0 < i13 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i8; while (0);
 HEAP8[i2 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 i1 = i1 + ((HEAP32[i7 >> 2] | 0) - i6) | 0;
 HEAP32[i10 >> 2] = i1;
 HEAPF32[i11 + 8 >> 2] = f12;
 i2 = HEAP8[i1 >> 0] | 0;
 L34 : do if (!(i2 << 24 >> 24)) i4 = i1; else while (1) {
  if (!(_isspace(i2 & 255) | 0)) {
   i4 = i1;
   break L34;
  }
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i4 = i1;
   break;
  }
 } while (0);
 _memset(i8 | 0, 0, 256) | 0;
 HEAP32[i7 >> 2] = i5;
 i1 = HEAP8[i4 >> 0] | 0;
 L39 : do if (!(i1 << 24 >> 24)) i1 = i8; else if (!(_isspace(i1 & 255) | 0)) {
  i3 = i4;
  i2 = i8;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L39;
   i13 = HEAP32[i7 >> 2] | 0;
   if (!(i1 >>> 0 < i13 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i8; while (0);
 HEAP8[i1 >> 0] = 0;
 f12 = Math_fround(+_strtod(i8, i7));
 HEAP32[i10 >> 2] = i4 + ((HEAP32[i7 >> 2] | 0) - i6);
 HEAPF32[i11 + 12 >> 2] = f12;
 STACKTOP = i9;
 return;
}

function __ZNK6Avatar15GetPostRotationEi(i12, i1, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0;
 i11 = HEAP32[i1 + 56 >> 2] | 0;
 L1 : do if ((i10 | 0) < 0) {
  f6 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 } else {
  do if ((i10 | 0) < 24) {
   i1 = i11 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   }
   i7 = i2 + i1 | 0;
   i8 = i7 + 40 | 0;
   if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + i8 >> 2] | 0)) i9 = 8; else {
    i7 = i7 + 72 + (i10 << 2) | 0;
    i1 = i2;
   }
  } else {
   if ((i10 | 0) < 39) {
    i1 = i11 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     f6 = Math_fround(0.0);
     f3 = Math_fround(1.0);
     f4 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     break L1;
    } else {
     i9 = 8;
     break;
    }
   }
   if ((i10 | 0) >= 54) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   }
   i1 = i11 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   } else i9 = 13;
  } while (0);
  if ((i9 | 0) == 8) {
   i7 = i1 + i2 | 0;
   i8 = i7 + 40 | 0;
   if (!(HEAP32[i8 + (HEAP32[i8 >> 2] | 0) >> 2] | 0)) i9 = 13; else {
    i7 = i7 + 48 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    if (!i8) i9 = 13; else {
     i7 = i8 + i7 + (i10 + -24 << 2) | 0;
     i1 = i2;
    }
   }
  }
  if ((i9 | 0) == 13) {
   i1 = i1 + i2 | 0;
   i9 = i1 + 40 | 0;
   if (!(HEAP32[i9 + (HEAP32[i9 >> 2] | 0) >> 2] | 0)) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break;
   }
   i1 = i1 + 52 | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   if (!i7) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break;
   }
   i7 = i7 + i1 + (i10 + -39 << 2) | 0;
   i1 = i2;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == -1) {
   f6 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
  } else {
   i1 = i1 + (i11 + 20) + 40 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i11 = i1 + 4 | 0;
   i2 = HEAP32[i11 + (HEAP32[i11 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
   } else {
    i11 = i1 + 16 | 0;
    i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
    f6 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 16 >> 2]);
    f4 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 20 >> 2]);
    f5 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 24 >> 2]);
    f3 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 28 >> 2]);
   }
  }
 } while (0);
 f13 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)));
 f15 = Math_fround(Math_sqrt(Math_fround(f13)));
 f14 = Math_fround(f6 / f15);
 f4 = Math_fround(f4 / f15);
 f6 = Math_fround(f5 / f15);
 f3 = Math_fround(f3 / f15);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f13 > Math_fround(1.0e-30);
 i11 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i12 >> 2] = i8 ? i1 : 0;
 HEAP32[i12 + 4 >> 2] = i8 ? i2 : 0;
 HEAP32[i12 + 8 >> 2] = i8 ? i7 : 0;
 HEAP32[i12 + 12 >> 2] = i11;
 return;
}

function __ZN8Animator24SetupAnimationClipsCacheEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i4 = i5 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 9;
   }
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 if (__ZNK9HPlayable7IsValidEv(i5 + 628 | 0) | 0) {
  i11 = HEAP32[(HEAP32[i5 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 80 >> 2] | 0, i11 | 0, i5 + 604 | 0);
  STACKTOP = i12;
  return;
 }
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 i7 = i5 + 604 | 0;
 i8 = i6 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i5 + 616 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i5 + 620 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i5 + 608 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i5 + 608 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i5;
  break;
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i5 = 0;
 i2 = i1;
 do {
  i4 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 26; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 26; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 28;
    }
   }
   if ((i11 | 0) == 26) i11 = 28;
   if ((i11 | 0) == 28) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i2 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] = i1;
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i2 >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i6 = i1 + 32 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i1 + 20 | 0;
  i8 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i8 | 0) {
   i4 = i8 + 24 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i10 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i1 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0, i2 | 0) | 0;
   d12 = +_emscripten_get_now() * 1.0e6;
   i11 = +Math_abs(d12) >= 1.0 ? (d12 > 0.0 ? ~~+Math_min(+Math_floor(d12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d12 - +(~~d12 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i2 = i8 + 40 | 0;
   i9 = i2;
   i10 = _i64Subtract(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, ~~d13 >>> 0 | 0, i10 | 0) | 0;
   i11 = _i64Add(i10 | 0, getTempRet0() | 0, ~~d12 >>> 0 | 0, i11 | 0) | 0;
   i10 = getTempRet0() | 0;
   i9 = i2;
   HEAP32[i9 >> 2] = i11;
   HEAP32[i9 + 4 >> 2] = i10;
   if (!i1) {
    i11 = 0;
    return i11 | 0;
   }
   if ((i3 & 1 | 0) == 0 & ((mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0) ^ 1)) i1 = (i3 & 2 | 0) == 0; else i1 = 0;
   if ((i5 | 0) != 1 | i1) {
    i11 = 0;
    return i11 | 0;
   }
   d13 = +_emscripten_get_now() * 1.0e6;
   i11 = +Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i10 = HEAP32[i7 >> 2] | 0;
   _memmove(i10 | 0, i10 + 4 | 0, (HEAP32[i6 >> 2] << 2) + -4 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 48 >> 2] | 0, i8 | 0);
   d12 = +_emscripten_get_now() * 1.0e6;
   i11 = _i64Subtract(~~d12 >>> 0 | 0, (+Math_abs(d12) >= 1.0 ? (d12 > 0.0 ? ~~+Math_min(+Math_floor(d12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d12 - +(~~d12 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, ~~d13 >>> 0 | 0, i11 | 0) | 0;
   i11 = __Z17TimeToNanosecondsy(i11, getTempRet0() | 0) | 0;
   f16 = Math_fround(Math_fround((+(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
   i11 = i8 + 32 | 0;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   d13 = +_emscripten_get_now() * 1.0e6;
   i11 = _i64Subtract(~~d13 >>> 0 | 0, (+Math_abs(d13) >= 1.0 ? (d13 > 0.0 ? ~~+Math_min(+Math_floor(d13 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d13 - +(~~d13 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i10 | 0, i11 | 0) | 0;
   i11 = __Z17TimeToNanosecondsy(i11, getTempRet0() | 0) | 0;
   f14 = Math_fround(Math_fround((+(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
   i11 = i2;
   i11 = __Z17TimeToNanosecondsy(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
   f15 = Math_fround(Math_fround((+(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
   i11 = i8 + 48 | 0;
   i11 = __Z17TimeToNanosecondsy(HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
   f17 = Math_fround(Math_fround((+(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * 1.0e-09) * Math_fround(1.0e3));
   mftCall_viffff(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, +f17, +f16, +f15, +f14);
   HEAP32[i4 >> 2] = 2;
   __ZN14AsyncOperation15InvokeCoroutineEv(i8);
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0);
   i11 = 1;
   return i11 | 0;
  }
 }
 __ZN14PreloadManager22ProcessSingleOperationEv(i1);
 i11 = 0;
 return i11 | 0;
}

function __ZN7Terrain17RemoveFromManagerEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i6 = i12;
 i7 = __Z18GetITerrainManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0, i7 | 0, i11 | 0);
 HEAP8[i11 + 34 >> 0] = 0;
 i7 = i11 + 48 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i4 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i4 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
    i1 = i3;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i4 + 4 >> 2] | 0)) i8 = 9;
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i8 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 18; else i2 = i1;
   }
  }
  if ((i8 | 0) == 16) i8 = 18;
  if ((i8 | 0) == 18) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i1 = HEAP32[i11 + 28 >> 2] | 0;
  if (!i1) i8 = 0; else i8 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i2 + 352 >> 2] | 0;
  i10 = i2 + 356 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i1 = i9 - i3 >> 2;
  i2 = i9;
  if (!i1) i5 = i3; else {
   i4 = i3;
   i5 = i3;
   while (1) {
    i13 = (i1 | 0) / 2 | 0;
    i7 = i5 + (i13 << 2) | 0;
    i6 = (HEAP32[i7 >> 2] | 0) < (i8 | 0);
    i7 = i7 + 4 | 0;
    i3 = i6 ? i7 : i4;
    i1 = i6 ? i1 + -1 - i13 | 0 : i13;
    if (!i1) {
     i5 = i3;
     break;
    } else {
     i4 = i3;
     i5 = i6 ? i7 : i5;
    }
   }
  }
  if ((i5 | 0) != (i2 | 0)) if ((i8 | 0) >= (HEAP32[i5 >> 2] | 0)) {
   i3 = i5 + 4 | 0;
   i1 = i9 - i3 | 0;
   i4 = i1 >> 2;
   if (i4) {
    _memmove(i5 | 0, i3 | 0, i1 | 0) | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   i1 = i5 + (i4 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  }
 } while (0);
 i1 = i11 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63616 | 0);
  HEAP32[i1 >> 2] = 0;
  __ZN7Terrain5FlushEv(i11);
  STACKTOP = i12;
  return;
 }
 __ZN14SplatMaterialsD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63616 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN7Terrain5FlushEv(i11);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i7, i8, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i6 = (i3 - i4 | 0) / 20 | 0;
 i9 = i7 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = i5;
 if (i6 >>> 0 > ((i1 - i5 | 0) / 20 | 0) >>> 0) {
  if (i5) {
   i4 = i7 + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) i1 = i5; else {
    i3 = i1;
    while (1) {
     i1 = i3 + -20 | 0;
     HEAP32[i4 >> 2] = i1;
     if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -16 | 0);
      HEAP32[i1 >> 2] = 0;
      i1 = HEAP32[i4 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 | 0)) break; else i3 = i1;
    }
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = 0;
  }
  if (i6 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  i11 = (i1 - i2 | 0) / 20 | 0;
  i1 = i11 << 1;
  i1 = i11 >>> 0 < 107374182 ? (i1 >>> 0 < i6 >>> 0 ? i6 : i1) : 214748364;
  if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i2 = __Znwj(i1 * 20 | 0) | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i9 >> 2] = i2 + (i1 * 20 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  do {
   __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i2, i1);
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 20 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i11 = i7 + 4 | 0;
 i1 = ((HEAP32[i11 >> 2] | 0) - i5 | 0) / 20 | 0;
 i10 = i6 >>> 0 > i1 >>> 0;
 i1 = i10 ? i4 + (i1 * 20 | 0) | 0 : i3;
 if ((i4 | 0) == (i1 | 0)) i3 = i2; else {
  i9 = i4;
  do {
   if ((i9 | 0) != (i2 | 0)) {
    i7 = HEAP32[i9 >> 2] | 0;
    i8 = i2 + 12 | 0;
    i3 = HEAP32[i9 + 12 >> 2] << 3;
    i4 = i3 >> 3;
    HEAP32[i8 >> 2] = i4;
    i5 = i2 + 16 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i4;
     i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i2 >> 2] = i3;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
     HEAP32[i5 >> 2] = i4;
     HEAP32[i2 >> 2] = i3;
     break;
    } else i3 = HEAP32[i2 >> 2] | 0; while (0);
    _memcpy(i3 | 0, i7 | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   }
   i9 = i9 + 20 | 0;
   i2 = i2 + 20 | 0;
  } while ((i9 | 0) != (i1 | 0));
  i3 = i2;
 }
 if (i10) {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
  i3 = HEAP32[i11 >> 2] | 0;
  do {
   __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i3, i1);
   i1 = i1 + 20 | 0;
   i3 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
   HEAP32[i11 >> 2] = i3;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i2 = i1 + -20 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN8keywords6CreateEPKc(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i11 = i12 + 8 | 0;
 i2 = (HEAP32[gb + 1166252 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i9 = 8; else {
  i1 = i2;
  i4 = i3;
  L2 : while (1) {
   i3 = i4;
   while (1) {
    if ((__Z6StrCmpPKcS0_(HEAP32[i3 + 16 >> 2] | 0, i6) | 0) >= 0) break;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) break L2;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i2 | 0)) i9 = 8; else if ((__Z6StrCmpPKcS0_(i6, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0) i9 = 8; else i2 = i1;
 }
 i1 = HEAP32[gb + 1166252 >> 2] | 0;
 if ((i2 | 0) != (i1 + 4 | 0)) {
  i11 = HEAP32[i2 + 20 >> 2] | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i10 | 0) > 255) {
  HEAP32[i5 >> 2] = 256;
  HEAP32[i5 + 4 >> 2] = i6;
  __Z6FormatPKcz(i11, gb + 470035 | 0, i5);
  i3 = HEAP32[gb + 1166252 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i3 + 4 | 0;
  i1 = i2;
  if ((i1 | 0) != (i3 | 0)) while (1) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i11, 32);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i11, HEAP32[i1 + 16 >> 2] | 0) | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i11, 256, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i11 = 255;
  STACKTOP = i12;
  return i11 | 0;
 }
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i7 = (_strlen(i6) | 0) + 1 | 0;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, gb + 63280 | 0, 0, gb + 469960 | 0, 129) | 0;
 _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
 i7 = HEAP32[gb + 1166252 >> 2] | 0;
 i6 = i5;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((__Z6StrCmpPKcS0_(i5, HEAP32[i2 >> 2] | 0) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i9 = 22;
     break;
    } else i1 = i2;
   } else {
    if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i5) | 0) >= 0) {
     i9 = 27;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i9 = 26;
     break;
    } else i1 = i2;
   }
  }
  if ((i9 | 0) == 22) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i9 | 0) == 26) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i9 | 0) == 27) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i11;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  HEAP32[i1 + 16 >> 2] = i6;
  HEAP32[i1 + 20 >> 2] = i10;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i11 = i7 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63280 | 0);
 if (!i8) {
  i11 = i10;
  STACKTOP = i12;
  return i11 | 0;
 }
 __Z19pop_allocation_rootv();
 i11 = i10;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN13TrailRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj(i2, i11) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 4 | 0;
 i1 = i14;
 if ((HEAP16[gb + 1159828 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159828 | 0, i10);
  i13 = gb + 1159828 | 0;
 } else i13 = 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i9 + (i11 * 156 | 0) | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + (i11 * 20 | 0) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i1 = i9 + (i11 * 156 | 0) + 140 | 0; else {
  HEAP32[i10 >> 2] = 0;
  i6 = i10 + 4 | 0;
  i5 = gb + 63160 | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i6;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i1;
  i7 = i9 + (i11 * 156 | 0) + 132 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) * 12 | 0;
  do if (!i1) i1 = 0; else {
   i2 = i1 | 3;
   if (i2 >>> 0 < 2e3) {
    i1 = STACKTOP;
    STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
    if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 421073 | 0, 425) | 0;
    i4 = gb + 64016 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    i5 = i6;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i4;
    break;
   }
  } while (0);
  i3 = i1 + 3 & -4;
  i4 = i3;
  i5 = i3;
  i2 = HEAP32[i9 + (i11 * 156 | 0) + 148 >> 2] | 0;
  i1 = HEAP32[i9 + (i11 * 156 | 0) + 152 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i9 + (i11 * 156 | 0) + 144 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i9 + (i11 * 156 | 0) + 140 | 0;
  i2 = i4 + -1 | 0;
  L13 : do if ((i4 | 0) > 1) {
   i3 = i2;
   i4 = HEAP32[i9 + (i11 * 156 | 0) + 136 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (i4 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
     i2 = i3;
     break L13;
    }
    i15 = i5 + (i3 * 12 | 0) | 0;
    i2 = (HEAP32[i2 + 8 >> 2] | 0) + (i4 << 4) | 0;
    HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i3 + -1 | 0;
    if ((i3 | 0) > 1) {
     i3 = i2;
     i4 = i4 + 1 | 0;
    } else break;
   }
  } while (0);
  if ((i2 | 0) > 0) {
   i3 = 0;
   while (1) {
    i15 = i5 + (i2 * 12 | 0) | 0;
    i4 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0) + (i3 << 4) | 0;
    HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i15 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    if ((i2 | 0) > 1) {
     i2 = i2 + -1 | 0;
     i3 = i3 + 1 | 0;
    } else break;
   }
  }
  __Z11Build3DLineP10LineVertexRK14LineParametersRKN4math8float4x4ES7_PKNS4_14float3_storageEj(HEAP32[i8 >> 2] | 0, HEAP32[i12 >> 2] | 0, i9 + (i11 * 156 | 0) + 4 | 0, i9 + (i11 * 156 | 0) + 68 | 0, i5, HEAP32[i7 >> 2] | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i15 = i1 + 4 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
 if (!(HEAP32[i15 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 12 | 0);
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i15 = i1 + 4 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
 if (!(HEAP32[i15 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return;
}

function runPostSets122() {
 HEAP32[gb + 106936 >> 2] = fb + 171;
 HEAP32[gb + 106940 >> 2] = fb + 172;
 HEAP32[gb + 106944 >> 2] = fb + 342;
 HEAP32[gb + 106948 >> 2] = fb + 117;
 HEAP32[gb + 106952 >> 2] = fb + 828;
 HEAP32[gb + 106956 >> 2] = fb + 1643;
 HEAP32[gb + 106960 >> 2] = fb + 1166;
 HEAP32[gb + 106964 >> 2] = fb + 1167;
 HEAP32[gb + 106976 >> 2] = fb + 1644;
 HEAP32[gb + 106980 >> 2] = fb + 1645;
 HEAP32[gb + 106984 >> 2] = fb + 1646;
 HEAP32[gb + 106996 >> 2] = fb + 1;
 HEAP32[gb + 107e3 >> 2] = fb + 829;
 HEAP32[gb + 107004 >> 2] = fb + 456;
 HEAP32[gb + 107008 >> 2] = fb + 1270;
 HEAP32[gb + 107012 >> 2] = fb + 1647;
 HEAP32[gb + 107016 >> 2] = fb + 343;
 HEAP32[gb + 107020 >> 2] = fb + 1;
 HEAP32[gb + 107024 >> 2] = fb + 1;
 HEAP32[gb + 107028 >> 2] = fb + 1;
 HEAP32[gb + 107032 >> 2] = fb + 1;
 HEAP32[gb + 107036 >> 2] = fb + 1;
 HEAP32[gb + 107040 >> 2] = fb + 1;
 HEAP32[gb + 107044 >> 2] = fb + 1;
 HEAP32[gb + 107048 >> 2] = fb + 1;
 HEAP32[gb + 107060 >> 2] = fb + 1648;
 HEAP32[gb + 107064 >> 2] = fb + 829;
 HEAP32[gb + 107068 >> 2] = fb + 456;
 HEAP32[gb + 107072 >> 2] = fb + 1649;
 HEAP32[gb + 107076 >> 2] = fb + 1650;
 HEAP32[gb + 107080 >> 2] = fb + 343;
 HEAP32[gb + 107084 >> 2] = fb + 830;
 HEAP32[gb + 107088 >> 2] = fb + 831;
 HEAP32[gb + 107092 >> 2] = fb + 832;
 HEAP32[gb + 107096 >> 2] = fb + 833;
 HEAP32[gb + 107100 >> 2] = fb + 173;
 HEAP32[gb + 107104 >> 2] = fb + 834;
 HEAP32[gb + 107108 >> 2] = fb + 96;
 HEAP32[gb + 107112 >> 2] = fb + 1168;
 HEAP32[gb + 107116 >> 2] = fb + 1169;
 HEAP32[gb + 107120 >> 2] = fb + 1651;
 HEAP32[gb + 107124 >> 2] = fb + 1170;
 HEAP32[gb + 107136 >> 2] = fb + 1652;
 HEAP32[gb + 107140 >> 2] = fb + 1653;
 HEAP32[gb + 107144 >> 2] = fb + 1654;
 HEAP32[gb + 107156 >> 2] = fb + 1;
 HEAP32[gb + 107160 >> 2] = fb + 835;
 HEAP32[gb + 107164 >> 2] = fb + 456;
 HEAP32[gb + 107168 >> 2] = fb + 1270;
 HEAP32[gb + 107172 >> 2] = fb + 1655;
 HEAP32[gb + 107176 >> 2] = fb + 344;
 HEAP32[gb + 107180 >> 2] = fb + 1;
 HEAP32[gb + 107184 >> 2] = fb + 1;
 HEAP32[gb + 107188 >> 2] = fb + 1;
 HEAP32[gb + 107192 >> 2] = fb + 1;
 HEAP32[gb + 107196 >> 2] = fb + 1;
 HEAP32[gb + 107200 >> 2] = fb + 1;
 HEAP32[gb + 107204 >> 2] = fb + 1;
 HEAP32[gb + 107208 >> 2] = fb + 1;
 HEAP32[gb + 107212 >> 2] = fb + 1;
 HEAP32[gb + 107216 >> 2] = fb + 1;
 HEAP32[gb + 107220 >> 2] = fb + 1;
 HEAP32[gb + 107224 >> 2] = fb + 1;
 HEAP32[gb + 107228 >> 2] = fb + 1;
 HEAP32[gb + 107240 >> 2] = fb + 1656;
 HEAP32[gb + 107244 >> 2] = fb + 835;
 HEAP32[gb + 107248 >> 2] = fb + 456;
 HEAP32[gb + 107252 >> 2] = fb + 1657;
 HEAP32[gb + 107256 >> 2] = fb + 1658;
 HEAP32[gb + 107260 >> 2] = fb + 344;
 HEAP32[gb + 107264 >> 2] = fb + 174;
 HEAP32[gb + 107268 >> 2] = fb + 60;
 HEAP32[gb + 107272 >> 2] = fb + 836;
 HEAP32[gb + 107276 >> 2] = fb + 837;
 HEAP32[gb + 107280 >> 2] = fb + 838;
 HEAP32[gb + 107284 >> 2] = fb + 839;
 HEAP32[gb + 107288 >> 2] = fb + 147;
 HEAP32[gb + 107292 >> 2] = fb + 148;
 HEAP32[gb + 107296 >> 2] = fb + 840;
 HEAP32[gb + 107300 >> 2] = fb + 1;
 HEAP32[gb + 107304 >> 2] = fb + 841;
 HEAP32[gb + 107308 >> 2] = fb + 345;
 HEAP32[gb + 107312 >> 2] = fb + 258;
 HEAP32[gb + 107316 >> 2] = fb + 1171;
 HEAP32[gb + 107320 >> 2] = fb + 1172;
 HEAP32[gb + 107324 >> 2] = fb + 1659;
 HEAP32[gb + 107336 >> 2] = fb + 1660;
 HEAP32[gb + 107340 >> 2] = fb + 1661;
 HEAP32[gb + 107344 >> 2] = fb + 1662;
 HEAP32[gb + 107360 >> 2] = fb + 1;
 HEAP32[gb + 107364 >> 2] = fb + 842;
 HEAP32[gb + 107368 >> 2] = fb + 456;
 HEAP32[gb + 107372 >> 2] = fb + 1270;
 HEAP32[gb + 107376 >> 2] = fb + 1663;
 HEAP32[gb + 107380 >> 2] = fb + 346;
 HEAP32[gb + 107384 >> 2] = fb + 1;
 HEAP32[gb + 107388 >> 2] = fb + 1;
 HEAP32[gb + 107392 >> 2] = fb + 1;
 HEAP32[gb + 107396 >> 2] = fb + 1;
 HEAP32[gb + 107400 >> 2] = fb + 1;
 runPostSets123();
}

function __Z19AppendTransformPathR8UnityStrPKc(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 16 | 0;
 i8 = i12;
 i10 = i9 + 11 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = i1 & 255;
 if (!((i3 ? i2 : i1) | 0)) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i8 + 12 >> 2] = i1;
  i2 = _strlen(i5) | 0;
  if (i2 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i8 + 12 >> 2] | 0;
   i4 = 5;
  } else if (i2 >>> 0 < 11) {
   HEAP8[i8 + 11 >> 0] = i2;
   if (!i2) i1 = i8; else {
    i1 = i8;
    i4 = 7;
   }
  } else i4 = 5;
  if ((i4 | 0) == 5) {
   i6 = i2 + 16 & -16;
   HEAP32[i7 >> 2] = 66;
   HEAP32[i7 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 8 >> 2] = i6 | -2147483648;
   HEAP32[i8 + 4 >> 2] = i2;
   i4 = 7;
  }
  if ((i4 | 0) == 7) _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
  i4 = i8 + 11 | 0;
  do if ((i8 | 0) != (i9 | 0)) {
   i6 = HEAP8[i4 >> 0] | 0;
   i1 = i6 << 24 >> 24 < 0;
   i5 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
   i6 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
   i1 = HEAP8[i10 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
   if (i6 >>> 0 > i3 >>> 0) {
    i11 = i2 ? HEAP32[i11 >> 2] | 0 : i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i6 - i3 | 0, i11, 0, i11, i6, i5);
    break;
   }
   i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i10 >> 0] | 0) < 0) {
    HEAP32[i11 >> 2] = i6;
    break;
   } else {
    HEAP8[i10 >> 0] = i6;
    break;
   }
  } while (0);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i11 = HEAP32[i8 >> 2] | 0;
   i10 = HEAP32[i8 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 66;
   HEAP32[i7 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
  }
  STACKTOP = i12;
  return;
 } else {
  if (i3) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else {
   i2 = i1;
   i1 = 10;
  }
  if ((i2 | 0) == (i1 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i9, i1, 1, i1, i1, 0, 0);
   if ((HEAP8[i10 >> 0] | 0) > -1) i4 = 26; else i4 = 27;
  } else if (i3) i4 = 27; else i4 = 26;
  if ((i4 | 0) == 26) {
   HEAP8[i10 >> 0] = i2 + 1;
   i1 = i9;
  } else if ((i4 | 0) == 27) {
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i11 >> 2] = i2 + 1;
  }
  i4 = i1 + i2 | 0;
  HEAP8[i4 >> 0] = 47;
  HEAP8[i4 + 1 >> 0] = 0;
  i4 = _strlen(i5) | 0;
  i1 = HEAP8[i10 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) {
   i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } else {
   i3 = 10;
   i1 = i1 & 255;
  }
  if ((i3 - i1 | 0) >>> 0 < i4 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i4 - i3 + i1 | 0, i1, i1, 0, i4, i5);
   STACKTOP = i12;
   return;
  }
  if (!i4) {
   STACKTOP = i12;
   return;
  }
  i2 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  _memcpy(i2 + i1 | 0, i5 | 0, i4 | 0) | 0;
  i1 = i1 + i4 | 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) HEAP32[i11 >> 2] = i1; else HEAP8[i10 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
  STACKTOP = i12;
  return;
 }
}

function __ZNK6Avatar14GetPreRotationEi(i12, i1, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0;
 i11 = HEAP32[i1 + 56 >> 2] | 0;
 L1 : do if ((i10 | 0) < 0) {
  f6 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 } else {
  do if ((i10 | 0) < 24) {
   i1 = i11 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   }
   i7 = i2 + i1 | 0;
   i8 = i7 + 40 | 0;
   if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + i8 >> 2] | 0)) i9 = 8; else {
    i7 = i7 + 72 + (i10 << 2) | 0;
    i1 = i2;
   }
  } else {
   if ((i10 | 0) < 39) {
    i1 = i11 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     f6 = Math_fround(0.0);
     f3 = Math_fround(1.0);
     f4 = Math_fround(0.0);
     f5 = Math_fround(0.0);
     break L1;
    } else {
     i9 = 8;
     break;
    }
   }
   if ((i10 | 0) >= 54) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   }
   i1 = i11 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break L1;
   } else i9 = 13;
  } while (0);
  if ((i9 | 0) == 8) {
   i7 = i1 + i2 | 0;
   i8 = i7 + 40 | 0;
   if (!(HEAP32[i8 + (HEAP32[i8 >> 2] | 0) >> 2] | 0)) i9 = 13; else {
    i7 = i7 + 48 | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    if (!i8) i9 = 13; else {
     i7 = i8 + i7 + (i10 + -24 << 2) | 0;
     i1 = i2;
    }
   }
  }
  if ((i9 | 0) == 13) {
   i1 = i1 + i2 | 0;
   i9 = i1 + 40 | 0;
   if (!(HEAP32[i9 + (HEAP32[i9 >> 2] | 0) >> 2] | 0)) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break;
   }
   i1 = i1 + 52 | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   if (!i7) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
    break;
   }
   i7 = i7 + i1 + (i10 + -39 << 2) | 0;
   i1 = i2;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == -1) {
   f6 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
  } else {
   i1 = i1 + (i11 + 20) + 40 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i11 = i1 + 4 | 0;
   i2 = HEAP32[i11 + (HEAP32[i11 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) {
    f6 = Math_fround(0.0);
    f3 = Math_fround(1.0);
    f4 = Math_fround(0.0);
    f5 = Math_fround(0.0);
   } else {
    i11 = i1 + 16 | 0;
    i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
    f6 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 4 >> 2]);
    f5 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 8 >> 2]);
    f3 = Math_fround(HEAPF32[i11 + (i2 * 76 | 0) + 12 >> 2]);
   }
  }
 } while (0);
 f13 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5)) + Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)));
 f15 = Math_fround(Math_sqrt(Math_fround(f13)));
 f14 = Math_fround(f6 / f15);
 f4 = Math_fround(f4 / f15);
 f6 = Math_fround(f5 / f15);
 f3 = Math_fround(f3 / f15);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f13 > Math_fround(1.0e-30);
 i11 = i8 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i12 >> 2] = i8 ? i1 : 0;
 HEAP32[i12 + 4 >> 2] = i8 ? i2 : 0;
 HEAP32[i12 + 8 >> 2] = i8 ? i7 : 0;
 HEAP32[i12 + 12 >> 2] = i11;
 return;
}

function __ZN19ParticleSystemStateC2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i21;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP8[i7 + 12 >> 0] = 1;
 HEAP8[i7 + 13 >> 0] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP8[i7 + 24 >> 0] = 0;
 HEAP8[i7 + 25 >> 0] = 1;
 i5 = i7 + 26 | 0;
 HEAP16[i5 >> 1] = 0;
 HEAP16[i5 + 2 >> 1] = 0;
 HEAP8[i5 + 4 >> 0] = 0;
 HEAP8[i7 + 31 >> 0] = 1;
 i5 = i7 + 32 | 0;
 i8 = i7 + 52 | 0;
 i9 = i7 + 116 | 0;
 i10 = i7 + 180 | 0;
 i11 = i7 + 244 | 0;
 i12 = i7 + 280 | 0;
 i13 = i7 + 292 | 0;
 i14 = i7 + 304 | 0;
 i15 = i7 + 316 | 0;
 i16 = i7 + 368 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i16 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f24 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f23 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f22 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i7 + 380 >> 2] = f24;
 i5 = i7 + 384 | 0;
 HEAPF32[i5 >> 2] = f23;
 i6 = i7 + 388 | 0;
 HEAPF32[i6 >> 2] = f22;
 i17 = i7 + 400 | 0;
 i18 = i7 + 456 | 0;
 i19 = i7 + 460 | 0;
 i20 = i7 + 464 | 0;
 HEAP32[i7 + 480 >> 2] = 0;
 HEAP32[i7 + 484 >> 2] = 0;
 i2 = i7 + 472 | 0;
 i3 = i7 + 392 | 0;
 i4 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i3 = i1;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAPF32[i7 + 488 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 492 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 496 >> 2] = 0;
 HEAP32[i7 + 500 >> 2] = 1;
 HEAP32[i7 + 504 >> 2] = 1812433254;
 HEAP32[i7 + 508 >> 2] = 1900727103;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i8) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i9) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i10) | 0;
 __ZN10Matrix3x3f11SetIdentityEv(i11) | 0;
 HEAP32[i12 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i13 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i14 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 HEAP32[i15 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 i18 = HEAP32[gb + 1162364 >> 2] | 0;
 i19 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 i20 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = i18;
 HEAP32[i7 + 372 >> 2] = i19;
 HEAP32[i7 + 376 >> 2] = i20;
 HEAP32[i7 + 380 >> 2] = i18;
 HEAP32[i5 >> 2] = i19;
 HEAP32[i6 >> 2] = i20;
 STACKTOP = i21;
 return;
}

function _UNITY_png_write_IHDR(i15, i11, i12, i8, i6, i1, i3, i2) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 16 | 0;
 i10 = i14;
 L1 : do switch (i6 | 0) {
 case 0:
  {
   switch (i8 | 0) {
   case 8:
   case 4:
   case 2:
   case 1:
    {
     HEAP8[i15 + 435 >> 0] = 1;
     i13 = 1;
     break L1;
    }
   default:
    _UNITY_png_error(i15, gb + 355094 | 0);
   }
   break;
  }
 case 2:
  {
   if ((i8 | 0) == 8) {
    HEAP8[i15 + 435 >> 0] = 3;
    i13 = 3;
    break L1;
   } else _UNITY_png_error(i15, gb + 355132 | 0);
   break;
  }
 case 3:
  {
   switch (i8 | 0) {
   case 8:
   case 4:
   case 2:
   case 1:
    {
     HEAP8[i15 + 435 >> 0] = 1;
     i13 = 1;
     break L1;
    }
   default:
    _UNITY_png_error(i15, gb + 355164 | 0);
   }
   break;
  }
 case 4:
  {
   switch (i8 | 0) {
   case 8:
   case 16:
    {
     HEAP8[i15 + 435 >> 0] = 2;
     i13 = 2;
     break L1;
    }
   default:
    _UNITY_png_error(i15, gb + 355201 | 0);
   }
   break;
  }
 case 6:
  {
   if ((i8 | 0) == 8) {
    HEAP8[i15 + 435 >> 0] = 4;
    i13 = 4;
    break L1;
   } else _UNITY_png_error(i15, gb + 355245 | 0);
   break;
  }
 default:
  _UNITY_png_error(i15, gb + 355278 | 0);
 } while (0);
 if (!(HEAP32[i15 + 596 >> 2] & 4)) i4 = 21; else if (!(HEAP32[i15 + 204 >> 2] & 4096)) {
  if ((i3 | 0) != 0 & ((i6 | 4 | 0) != 6 | (i3 | 0) != 64)) i4 = 22;
 } else i4 = 21;
 if ((i4 | 0) == 21) if (!i3) i3 = 0; else i4 = 22;
 if ((i4 | 0) == 22) i3 = 0;
 i5 = i8 & 255;
 i7 = i15 + 432 | 0;
 HEAP8[i7 >> 0] = i5;
 i4 = i6 & 255;
 HEAP8[i15 + 431 >> 0] = i4;
 HEAP8[i15 + 428 >> 0] = 0;
 i2 = i3 & 255;
 HEAP8[i15 + 600 >> 0] = i2;
 HEAP8[i15 + 620 >> 0] = 0;
 HEAP32[i15 + 344 >> 2] = i11;
 HEAP32[i15 + 348 >> 2] = i12;
 i1 = Math_imul(i13 & 255, i8) | 0;
 HEAP8[i15 + 434 >> 0] = i1;
 i1 = i1 & 255;
 if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i11) | 0; else i1 = ((Math_imul(i1, i11) | 0) + 7 | 0) >>> 3;
 HEAP32[i15 + 360 >> 2] = i1;
 HEAP32[i15 + 356 >> 2] = i11;
 HEAP8[i15 + 433 >> 0] = i5;
 HEAP8[i15 + 436 >> 0] = i13;
 HEAP8[i10 >> 0] = i11 >>> 24;
 HEAP8[i10 + 1 >> 0] = i11 >>> 16;
 HEAP8[i10 + 2 >> 0] = i11 >>> 8;
 HEAP8[i10 + 3 >> 0] = i11;
 HEAP8[i10 + 4 >> 0] = i12 >>> 24;
 HEAP8[i10 + 5 >> 0] = i12 >>> 16;
 HEAP8[i10 + 6 >> 0] = i12 >>> 8;
 HEAP8[i10 + 7 >> 0] = i12;
 HEAP8[i10 + 8 >> 0] = i5;
 HEAP8[i10 + 9 >> 0] = i4;
 HEAP8[i10 + 10 >> 0] = 0;
 HEAP8[i10 + 11 >> 0] = i2;
 HEAP8[i10 + 12 >> 0] = 0;
 i1 = i15 + 656 | 0;
 HEAP32[i1 >> 2] = 34;
 HEAP8[i9 >> 0] = 0;
 HEAP8[i9 + 1 >> 0] = 0;
 HEAP8[i9 + 2 >> 0] = 0;
 HEAP8[i9 + 3 >> 0] = 13;
 i2 = i9 + 4 | 0;
 HEAP8[i2 >> 0] = 73;
 HEAP8[i9 + 5 >> 0] = 72;
 HEAP8[i9 + 6 >> 0] = 68;
 HEAP8[i9 + 7 >> 0] = 82;
 _UNITY_png_write_data(i15, i9, 8);
 HEAP32[i15 + 372 >> 2] = 1229472850;
 _UNITY_png_reset_crc(i15);
 _UNITY_png_calculate_crc(i15, i2, 4);
 HEAP32[i1 >> 2] = 66;
 _UNITY_png_write_data(i15, i10, 13);
 _UNITY_png_calculate_crc(i15, i10, 13);
 HEAP32[i1 >> 2] = 130;
 i1 = HEAP32[i15 + 408 >> 2] | 0;
 HEAP8[i9 >> 0] = i1 >>> 24;
 HEAP8[i9 + 1 >> 0] = i1 >>> 16;
 HEAP8[i9 + 2 >> 0] = i1 >>> 8;
 HEAP8[i9 + 3 >> 0] = i1;
 _UNITY_png_write_data(i15, i9, 4);
 i1 = i15 + 430 | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 if ((i2 & 255) << 24 >> 24) {
  i15 = i15 + 204 | 0;
  HEAP32[i15 >> 2] = 1;
  STACKTOP = i14;
  return;
 }
 if ((i2 & -256) << 16 >> 16 != 768) if ((HEAPU8[i7 >> 0] | 0) >= 8) {
  HEAP8[i1 >> 0] = -8;
  i15 = i15 + 204 | 0;
  HEAP32[i15 >> 2] = 1;
  STACKTOP = i14;
  return;
 }
 HEAP8[i1 >> 0] = 8;
 i15 = i15 + 204 | 0;
 HEAP32[i15 >> 2] = 1;
 STACKTOP = i14;
 return;
}

function __ZN5physx17collisionResponseERNS_19PxsParticleCollDataEbbRNS_27PxsFluidCollisionParametersE(i12, i17, i4, i14) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 24 | 0;
 i16 = i18 + 12 | 0;
 i13 = i18;
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = (i1 & 1 | 0) == 0;
 i21 = HEAP32[i12 >> 2] | 0;
 HEAP32[i15 >> 2] = i21;
 i10 = i15 + 4 | 0;
 i11 = i12 + 4 | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i20;
 i5 = i15 + 8 | 0;
 i6 = i12 + 8 | 0;
 i19 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i19;
 f7 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i4) {
  HEAPF32[i16 >> 2] = Math_fround(0.0);
  HEAPF32[i16 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i16 + 8 >> 2] = Math_fround(0.0);
 } else {
  HEAP32[i16 >> 2] = HEAP32[i12 + 32 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i12 + 36 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i12 + 40 >> 2];
 }
 if (!(i1 & 2)) {
  if (i3) {
   STACKTOP = i18;
   return;
  }
  i1 = i12 + 28 | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  if (f2 < Math_fround(3.0)) if (!(Math_fround(f2 + Math_fround(-1.5)) >= Math_fround(0.0))) f2 = Math_fround(1.0); else f2 = Math_fround(.5); else f2 = Math_fround(Math_fround(1.0) / f2);
  f22 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 16 >> 2]));
  f23 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 20 >> 2]));
  f24 = Math_fround(f2 * Math_fround(HEAPF32[i12 + 24 >> 2]));
  HEAPF32[i12 + 64 >> 2] = f22;
  HEAPF32[i12 + 68 >> 2] = f23;
  HEAPF32[i12 + 72 >> 2] = f24;
  i19 = i12 + 32 | 0;
  f24 = Math_fround(f2 * Math_fround(HEAPF32[i19 >> 2]));
  i20 = i12 + 36 | 0;
  f23 = Math_fround(f2 * Math_fround(HEAPF32[i20 >> 2]));
  i21 = i12 + 40 | 0;
  f22 = Math_fround(f2 * Math_fround(HEAPF32[i21 >> 2]));
  HEAPF32[i16 >> 2] = f24;
  HEAPF32[i16 + 4 >> 2] = f23;
  HEAPF32[i16 + 8 >> 2] = f22;
  HEAPF32[i19 >> 2] = f24;
  HEAPF32[i20 >> 2] = f23;
  HEAPF32[i21 >> 2] = f22;
  if (!(f2 == Math_fround(1.0))) {
   f24 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9)))));
   f22 = Math_fround(f7 * f24);
   f23 = Math_fround(f8 * f24);
   f24 = Math_fround(f9 * f24);
   HEAPF32[i15 >> 2] = f22;
   HEAPF32[i10 >> 2] = f23;
   HEAPF32[i5 >> 2] = f24;
   HEAPF32[i12 >> 2] = f22;
   HEAPF32[i11 >> 2] = f23;
   HEAPF32[i6 >> 2] = f24;
  }
  HEAPF32[i1 >> 2] = Math_fround(0.0);
 } else {
  HEAP32[i12 + 64 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i12 + 68 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i12 + 72 >> 2] = HEAP32[i12 + 24 >> 2];
 }
 i1 = i12 + 80 | 0;
 __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE(i13, i1, i1, i15, i16, HEAP32[i12 + 76 >> 2] | 0, i14);
 if (i17) if (HEAP32[i12 + 108 >> 2] | 0) {
  f22 = Math_fround(HEAPF32[i1 >> 2]);
  f22 = Math_fround(f22 - Math_fround(HEAPF32[i13 >> 2]));
  f23 = Math_fround(HEAPF32[i12 + 84 >> 2]);
  f23 = Math_fround(f23 - Math_fround(HEAPF32[i13 + 4 >> 2]));
  f24 = Math_fround(HEAPF32[i12 + 88 >> 2]);
  f24 = Math_fround(f24 - Math_fround(HEAPF32[i13 + 8 >> 2]));
  HEAPF32[i12 + 96 >> 2] = f22;
  HEAPF32[i12 + 100 >> 2] = f23;
  HEAPF32[i12 + 104 >> 2] = f24;
 }
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 84 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 88 >> 2] = HEAP32[i13 + 8 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN18GfxFramebufferGLES20CleanupFBOMapForRBIDERKj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 16 | 0;
 i11 = i19 + 8 | 0;
 i12 = i19;
 i1 = HEAP32[i8 >> 2] | 0;
 i13 = i8 + 4 | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i19;
  return;
 }
 i14 = i8 + 336 | 0;
 i15 = i8 + 376 | 0;
 i16 = i8 + 8 | 0;
 i10 = i8 + 4 | 0;
 i2 = i1;
 while (1) {
  i5 = i2 + 16 | 0;
  i6 = i2 + 112 | 0;
  L6 : do if (!(HEAP32[i6 >> 2] | 0)) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (i1 | 0) while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break L6; else i1 = i2;
   }
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else {
   i3 = HEAP32[i9 >> 2] | 0;
   i7 = i2 + 108 | 0;
   if (!(HEAP8[i7 >> 0] | 0)) i18 = 13; else if ((HEAP32[i2 + 88 >> 2] | 0) != (i3 | 0)) if ((HEAP32[i2 + 92 >> 2] | 0) != (i3 | 0)) i18 = 13;
   L18 : do if ((i18 | 0) == 13) {
    i18 = 0;
    i4 = HEAP32[i5 >> 2] | 0;
    if (i4 | 0) {
     i1 = 0;
     do {
      if ((HEAP32[i2 + 52 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break L18;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i4 >>> 0);
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (i1 | 0) while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break L6; else i1 = i2;
    }
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break L6; else i2 = i1;
    }
   } while (0);
   i4 = HEAP32[i14 >> 2] | 0;
   i20 = i6;
   i1 = HEAP32[i20 + 4 >> 2] | 0;
   i3 = i11;
   HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i4, 0, i17);
   i4 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 668 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     mftCall_viiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i1 + 36064 | 0, 3553, 0, 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   if (HEAP8[i7 >> 0] | 0) {
    mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, 36096, 36161, 0);
    mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, 36128, 36161, 0);
   }
   i3 = HEAP32[i14 >> 2] | 0;
   i7 = i15;
   i20 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = i12;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = i20;
   HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_(i3, i6, i17);
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = (i3 | 0) == 0;
   if (i5) {
    i4 = i2;
    while (1) {
     i1 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
      i6 = i2;
      break;
     } else i4 = i1;
    }
   } else {
    i1 = i3;
    while (1) {
     i4 = HEAP32[i1 >> 2] | 0;
     if (!i4) break; else i1 = i4;
    }
    i6 = i2;
   }
   if (i5) {
    i4 = i6;
    while (1) {
     i3 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
    }
   } else while (1) {
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) break; else i3 = i4;
   }
   if ((HEAP32[i8 >> 2] | 0) == (i2 | 0)) HEAP32[i8 >> 2] = i3;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i6);
   __ZdlPv(i2);
  } while (0);
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i1;
 }
 STACKTOP = i19;
 return;
}

function __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth12LerpIteratorIS1_NS3_17UnalignedIteratorIS1_Lj3EEEEEEEvPNS3_12TriangleDataERKT0_j(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i36 + 496 | 0;
 i32 = i36 + 480 | 0;
 i33 = i36 + 464 | 0;
 i34 = i36 + 448 | 0;
 i25 = i36 + 432 | 0;
 i28 = i36 + 416 | 0;
 i30 = i36 + 400 | 0;
 i27 = i36 + 384 | 0;
 i29 = i36 + 368 | 0;
 i26 = i36 + 352 | 0;
 i31 = i36 + 336 | 0;
 i4 = i36 + 320 | 0;
 i24 = i36 + 304 | 0;
 i5 = i36 + 288 | 0;
 i14 = i36 + 272 | 0;
 i23 = i36 + 256 | 0;
 i15 = i36 + 240 | 0;
 i16 = i36 + 224 | 0;
 i22 = i36 + 208 | 0;
 i17 = i36 + 192 | 0;
 i18 = i36 + 176 | 0;
 i19 = i36 + 160 | 0;
 i20 = i36 + 144 | 0;
 i21 = i36 + 128 | 0;
 i6 = i36 + 112 | 0;
 i7 = i36 + 96 | 0;
 i8 = i36 + 80 | 0;
 i9 = i36 + 64 | 0;
 i10 = i36 + 48 | 0;
 i11 = i36 + 32 | 0;
 i12 = i36 + 16 | 0;
 i13 = i36;
 __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ERKS5_(i35, i3);
 if (!i1) {
  STACKTOP = i36;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv(i32, i35);
  __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv(i35) | 0;
  __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv(i33, i35);
  __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv(i35) | 0;
  __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv(i34, i35);
  __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv(i35) | 0;
  __ZmiRK8Scalar4fS1_(i25, i33, i32);
  __ZmiRK8Scalar4fS1_(i28, i34, i32);
  __Z6cross3RK8Scalar4fS1_(i30, i25, i28);
  __Z4dot3RK8Scalar4fS1_(i27, i25, i25);
  __Z4dot3RK8Scalar4fS1_(i29, i28, i28);
  __Z4dot3RK8Scalar4fS1_(i26, i25, i28);
  __Z4dot3RK8Scalar4fS1_(i4, i30, i30);
  __Z5rsqrtRK8Scalar4f(i31, i4);
  __ZmlRK8Scalar4fS1_(i5, i27, i29);
  __ZmlRK8Scalar4fS1_(i14, i26, i26);
  __ZmiRK8Scalar4fS1_(i24, i5, i14);
  __ZplRK8Scalar4fS1_(i16, i27, i29);
  __ZmiRK8Scalar4fS1_(i15, i16, i26);
  __ZmiRK8Scalar4fS1_(i23, i15, i26);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i17, gb + 1097824 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i22, i17, i24, i23);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i19, gb + 1097808 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i18, i19, i27, i22);
  __ZN8Scalar4faSERKS_(i22, i18) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i21, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i20, i21, i29, i22);
  __ZN8Scalar4faSERKS_(i22, i20) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i7, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i6, i7, i26, i32);
  __Z12storeAlignedPfRK8Scalar4f(i2, i6);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i9, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i8, i9, i27, i25);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 16 | 0, i8);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i11, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i10, i11, i29, i28);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 32 | 0, i10);
  __ZmlRK8Scalar4fS1_(i12, i30, i31);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 48 | 0, i12);
  __Z6recipTILi1EE8Scalar4fRKS0_(i13, i22);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 64 | 0, i13);
  if (!i1) break; else i2 = i2 + 80 | 0;
 }
 STACKTOP = i36;
 return;
}

function __ZN21LightProbeProxyVolume8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN14EmissionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 272 | 0, i7);
 i8 = i7 + 16 | 0;
 i5 = i7 + 24 | 0;
 i1 = i6 + 552 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 556 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 560 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 564 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 568 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 572 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 576 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 580 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 536 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 540 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 544 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 548 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 584 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 52 | 0;
 i4 = i15 + 32 | 0;
 i9 = i15 + 16 | 0;
 i13 = i15;
 i14 = i15 + 48 | 0;
 if (HEAP32[i11 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i11);
 f18 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f18 = Math_fround(f18 - f6);
 f17 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f17 = Math_fround(f17 - f7);
 f16 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i12 + 28 >> 2]);
 f16 = Math_fround(f16 - f8);
 HEAPF32[i4 >> 2] = f18;
 HEAPF32[i4 + 4 >> 2] = f17;
 HEAPF32[i4 + 8 >> 2] = f16;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 i2 = i9 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i3 = i9 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 if (i1) {
  f18 = Math_fround(HEAPF32[gb + 62452 >> 2]);
  f19 = Math_fround(Math_fround(HEAPF32[gb + 1162364 >> 2]) - f6);
  f16 = Math_fround(Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]) - f7);
  f17 = Math_fround(Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]) - f8);
  if (!(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f16 * f16)) + Math_fround(f17 * f17)) <= Math_fround(f18 * f18))) {
   HEAPF32[i9 >> 2] = Math_fround(Math_fround(.5) / f6);
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(.5) / f7);
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(.5) / f8);
  }
 }
 f18 = Math_fround(i1 & 1);
 f19 = Math_fround((HEAP8[i12 + 96 >> 0] | 0) != 0 & 1);
 i5 = HEAP32[i12 + 4 >> 2] | 0;
 HEAPF32[i13 >> 2] = f18;
 HEAPF32[i13 + 4 >> 2] = f19;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 i5 = (HEAP32[i11 >> 2] | 0) + 1696 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i11 + 8 | 0;
 HEAP32[i10 >> 2] = 1073741930;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i10, i4, 2);
 i1 = (HEAP32[i11 >> 2] | 0) + 1712 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 >> 2] = 1073741931;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i10, i9, 2);
 i1 = i12 + 32 | 0;
 i2 = (HEAP32[i11 >> 2] | 0) + 2912 | 0;
 i3 = i1;
 i4 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i10 >> 2] = -2147483630;
 __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i5, i10, i1, 0);
 i9 = (HEAP32[i11 >> 2] | 0) + 1728 | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i10 >> 2] = 1073741932;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i5, i10, i13, 2);
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i11, 21, 3, 0, i10);
 STACKTOP = i15;
 return;
}

function runPostSets54() {
 HEAP32[gb + 65472 >> 2] = fb + 309;
 HEAP32[gb + 65476 >> 2] = fb + 108;
 HEAP32[gb + 65480 >> 2] = fb + 691;
 HEAP32[gb + 65484 >> 2] = fb + 566;
 HEAP32[gb + 65488 >> 2] = fb + 310;
 HEAP32[gb + 65492 >> 2] = fb + 113;
 HEAP32[gb + 65496 >> 2] = fb + 131;
 HEAP32[gb + 65500 >> 2] = fb + 692;
 HEAP32[gb + 65504 >> 2] = fb + 693;
 HEAP32[gb + 65508 >> 2] = fb + 694;
 HEAP32[gb + 65512 >> 2] = fb + 695;
 HEAP32[gb + 65516 >> 2] = fb + 696;
 HEAP32[gb + 65520 >> 2] = fb + 28;
 HEAP32[gb + 65532 >> 2] = fb + 9;
 HEAP32[gb + 65536 >> 2] = fb + 9;
 HEAP32[gb + 65540 >> 2] = fb + 43;
 HEAP32[gb + 65544 >> 2] = fb + 83;
 HEAP32[gb + 65548 >> 2] = fb + 29;
 HEAP32[gb + 65552 >> 2] = fb + 30;
 HEAP32[gb + 65556 >> 2] = fb + 24;
 HEAP32[gb + 65560 >> 2] = fb + 9;
 HEAP32[gb + 65572 >> 2] = fb + 697;
 HEAP32[gb + 65576 >> 2] = fb + 698;
 HEAP32[gb + 65588 >> 2] = fb + 699;
 HEAP32[gb + 65592 >> 2] = fb + 700;
 HEAP32[gb + 65608 >> 2] = fb + 701;
 HEAP32[gb + 65612 >> 2] = fb + 702;
 HEAP32[gb + 65616 >> 2] = fb + 703;
 HEAP32[gb + 65620 >> 2] = fb + 1;
 HEAP32[gb + 65624 >> 2] = fb + 567;
 HEAP32[gb + 65628 >> 2] = (HEAP32[gb + 65628 >> 2] | 0) + (gb + 459285 | 0);
 HEAP32[gb + 65640 >> 2] = fb + 704;
 HEAP32[gb + 65644 >> 2] = fb + 705;
 HEAP32[gb + 65648 >> 2] = fb + 703;
 HEAP32[gb + 65652 >> 2] = fb + 311;
 HEAP32[gb + 65656 >> 2] = fb + 567;
 HEAP32[gb + 65668 >> 2] = fb + 706;
 HEAP32[gb + 65672 >> 2] = fb + 707;
 HEAP32[gb + 65676 >> 2] = fb + 84;
 HEAP32[gb + 65680 >> 2] = fb + 11;
 HEAP32[gb + 65684 >> 2] = fb + 34;
 HEAP32[gb + 65688 >> 2] = fb + 568;
 HEAP32[gb + 65692 >> 2] = fb + 312;
 HEAP32[gb + 65696 >> 2] = fb + 569;
 HEAP32[gb + 65700 >> 2] = fb + 149;
 HEAP32[gb + 65716 >> 2] = fb + 708;
 HEAP32[gb + 65720 >> 2] = fb + 709;
 HEAP32[gb + 65724 >> 2] = fb + 86;
 HEAP32[gb + 65728 >> 2] = fb + 4;
 HEAP32[gb + 65732 >> 2] = fb + 87;
 HEAP32[gb + 65736 >> 2] = fb + 68;
 HEAP32[gb + 65740 >> 2] = fb + 88;
 HEAP32[gb + 65744 >> 2] = fb + 69;
 HEAP32[gb + 65748 >> 2] = fb + 60;
 HEAP32[gb + 65752 >> 2] = fb + 1;
 HEAP32[gb + 65756 >> 2] = fb + 710;
 HEAP32[gb + 65760 >> 2] = fb + 50;
 HEAP32[gb + 65764 >> 2] = fb + 62;
 HEAP32[gb + 65768 >> 2] = fb + 89;
 HEAP32[gb + 65772 >> 2] = fb + 90;
 HEAP32[gb + 65776 >> 2] = fb + 70;
 HEAP32[gb + 65788 >> 2] = (HEAP32[gb + 65788 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 65792 >> 2] = (HEAP32[gb + 65792 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 65828 >> 2] = fb + 711;
 HEAP32[gb + 65832 >> 2] = fb + 712;
 HEAP32[gb + 65836 >> 2] = fb + 86;
 HEAP32[gb + 65840 >> 2] = fb + 4;
 HEAP32[gb + 65844 >> 2] = fb + 87;
 HEAP32[gb + 65848 >> 2] = fb + 68;
 HEAP32[gb + 65852 >> 2] = fb + 313;
 HEAP32[gb + 65856 >> 2] = fb + 570;
 HEAP32[gb + 65860 >> 2] = fb + 60;
 HEAP32[gb + 65864 >> 2] = fb + 3;
 HEAP32[gb + 65868 >> 2] = fb + 713;
 HEAP32[gb + 65872 >> 2] = fb + 85;
 HEAP32[gb + 65876 >> 2] = fb + 714;
 HEAP32[gb + 65880 >> 2] = fb + 314;
 HEAP32[gb + 65884 >> 2] = fb + 90;
 HEAP32[gb + 65888 >> 2] = fb + 70;
 HEAP32[gb + 65900 >> 2] = fb + 659;
 HEAP32[gb + 65904 >> 2] = fb + 715;
 HEAP32[gb + 65908 >> 2] = fb + 86;
 HEAP32[gb + 65912 >> 2] = fb + 4;
 HEAP32[gb + 65916 >> 2] = fb + 87;
 HEAP32[gb + 65920 >> 2] = fb + 68;
 HEAP32[gb + 65924 >> 2] = fb + 88;
 HEAP32[gb + 65928 >> 2] = fb + 69;
 HEAP32[gb + 65932 >> 2] = fb + 60;
 HEAP32[gb + 65936 >> 2] = fb + 1;
 HEAP32[gb + 65940 >> 2] = fb + 1;
 HEAP32[gb + 65944 >> 2] = fb + 51;
 HEAP32[gb + 65948 >> 2] = fb + 716;
 HEAP32[gb + 65952 >> 2] = fb + 89;
 HEAP32[gb + 65956 >> 2] = fb + 90;
 HEAP32[gb + 65960 >> 2] = fb + 571;
 HEAP32[gb + 65972 >> 2] = fb + 717;
 HEAP32[gb + 65976 >> 2] = fb + 718;
 HEAP32[gb + 65980 >> 2] = fb + 86;
 HEAP32[gb + 65984 >> 2] = fb + 4;
 HEAP32[gb + 65988 >> 2] = fb + 87;
 runPostSets55();
}

function __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0;
 f4 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = f19 < f4 ? f19 : f4;
 i15 = i3 + 4 | 0;
 f17 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = f17 < f4 ? f17 : f4;
 i14 = i3 + 8 | 0;
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = f5 < f4 ? f5 : f4;
 i13 = i3 + 12 | 0;
 f7 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = f7 < f4 ? f7 : f4;
 f19 = Math_fround(f19 - f4);
 f17 = Math_fround(f17 - f4);
 f5 = Math_fround(f5 - f4);
 f7 = Math_fround(f7 - f4);
 i21 = f19 < Math_fround(0.0);
 f19 = i21 ? Math_fround(0.0) : f19;
 i21 = f17 < Math_fround(0.0);
 f17 = i21 ? Math_fround(0.0) : f17;
 i21 = f5 < Math_fround(0.0);
 f5 = i21 ? Math_fround(0.0) : f5;
 i21 = f7 < Math_fround(0.0);
 f7 = i21 ? Math_fround(0.0) : f7;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f20 = Math_fround(f10 * f6);
 f18 = Math_fround(f11 * f6);
 f16 = Math_fround(f6 * f12);
 f6 = Math_fround(f6 * f9);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f10 * Math_fround(f20 + f8));
 f18 = Math_fround(f11 * Math_fround(f18 + f8));
 f16 = Math_fround(f12 * Math_fround(f16 + f8));
 f6 = Math_fround(f9 * Math_fround(f8 + f6));
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(f10 * Math_fround(f8 + f20));
 f18 = Math_fround(f11 * Math_fround(f8 + f18));
 f16 = Math_fround(f12 * Math_fround(f8 + f16));
 f6 = Math_fround(f9 * Math_fround(f8 + f6));
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f20 = Math_fround(f10 * Math_fround(f10 * Math_fround(f8 + f20)));
 f18 = Math_fround(f11 * Math_fround(f11 * Math_fround(f8 + f18)));
 f16 = Math_fround(f12 * Math_fround(f12 * Math_fround(f8 + f16)));
 f6 = Math_fround(f9 * Math_fround(f9 * Math_fround(f8 + f6)));
 f8 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f9 = Math_fround(f19 * f8);
 f12 = Math_fround(f17 * f8);
 f11 = Math_fround(f5 * f8);
 f8 = Math_fround(f7 * f8);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(f19 * Math_fround(f9 + f10));
 f12 = Math_fround(f17 * Math_fround(f12 + f10));
 f11 = Math_fround(f5 * Math_fround(f11 + f10));
 f10 = Math_fround(f7 * Math_fround(f8 + f10));
 f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f9 = Math_fround(f19 * Math_fround(f8 + f9));
 f12 = Math_fround(f17 * Math_fround(f8 + f12));
 f11 = Math_fround(f5 * Math_fround(f8 + f11));
 f10 = Math_fround(f7 * Math_fround(f8 + f10));
 f8 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f9 = Math_fround(f20 + Math_fround(f19 * Math_fround(f19 * Math_fround(f8 + f9))));
 f12 = Math_fround(f18 + Math_fround(f17 * Math_fround(f17 * Math_fround(f8 + f12))));
 f11 = Math_fround(f16 + Math_fround(f5 * Math_fround(f5 * Math_fround(f8 + f11))));
 f10 = Math_fround(f6 + Math_fround(f7 * Math_fround(f7 * Math_fround(f8 + f10))));
 f8 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f7 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f4);
 f6 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f4);
 f5 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f4);
 f4 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f4);
 i3 = f7 > Math_fround(0.0);
 f7 = i3 ? f7 : Math_fround(0.0);
 i3 = f6 > Math_fround(0.0);
 f6 = i3 ? f6 : Math_fround(0.0);
 i3 = f5 > Math_fround(0.0);
 f5 = i3 ? f5 : Math_fround(0.0);
 i3 = f4 > Math_fround(0.0);
 f6 = Math_fround(f12 + Math_fround(f8 * f6));
 f5 = Math_fround(f11 + Math_fround(f8 * f5));
 f4 = Math_fround(f10 + Math_fround(f8 * (i3 ? f4 : Math_fround(0.0))));
 HEAPF32[i1 >> 2] = Math_fround(f9 + Math_fround(f8 * f7));
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = f4;
 return;
}

function __ZN5physx18NpArticulationLink9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i14, i13, i3) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 48 | 0;
 i11 = i16 + 16 | 0;
 i15 = i16;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i14, i13, i3);
 i7 = HEAP32[i14 + 52 >> 2] | 0;
 i9 = i14 + 56 | 0;
 if (!(HEAP16[((i7 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i7 >>> 24 & 15) << 2) >> 2] | 0) + (i14 + 48) + 8 | 0 : HEAP32[i9 >> 2] | 0) >> 1] & 1)) {
  STACKTOP = i16;
  return;
 }
 i7 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0) | 0;
 f12 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i7 >> 2] | 0) + 296 >> 2] | 0, i7 | 0, 0));
 i7 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0) | 0;
 if (Math_fround(f12 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i7 >> 2] | 0) + 296 >> 2] | 0, i7 | 0, 3))) != Math_fround(0.0)) {
  i3 = i14 + 284 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(i4 & 2)) {
   i5 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i14 + 64 | 0) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
  } else i5 = (HEAP32[i9 >> 2] | 0) + 96 | 0;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  f6 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  i3 = f2 == Math_fround(0.0);
  f2 = Math_fround(Math_fround(1.0) / f2);
  i5 = f6 == Math_fround(0.0);
  f6 = Math_fround(Math_fround(1.0) / f6);
  i7 = f8 == Math_fround(0.0);
  f8 = Math_fround(Math_fround(1.0) / f8);
  if (!(i4 & 1)) f1 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i14 + 64 | 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i9 >> 2] | 0) + 92 >> 2]);
  f18 = Math_fround(Math_fround(6.0) / Math_fround(Math_fround(1.0) / f1));
  f1 = Math_fround((i3 ? Math_fround(0.0) : f2) * f18);
  f17 = Math_fround((i5 ? Math_fround(0.0) : f6) * f18);
  f8 = Math_fround((i7 ? Math_fround(0.0) : f8) * f18);
  f2 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(f8 + Math_fround(f17 - f1))))));
  f6 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(f8 + Math_fround(f1 - f17))))));
  f8 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(Math_fround(f1 + f17) - f8)))));
  i9 = __ZN5physx2Cm12RenderOutputlsEj(i13, 16777215) | 0;
  __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i10, i14 + 224 | 0);
  i10 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i9, i10) | 0;
  f2 = Math_fround(f2 * Math_fround(.5));
  f6 = Math_fround(f6 * Math_fround(.5));
  f8 = Math_fround(f8 * Math_fround(.5));
  f17 = Math_fround(-f6);
  f1 = Math_fround(-f8);
  HEAPF32[i11 >> 2] = Math_fround(-f2);
  HEAPF32[i11 + 4 >> 2] = f17;
  HEAPF32[i11 + 8 >> 2] = f1;
  HEAPF32[i11 + 12 >> 2] = f2;
  HEAPF32[i11 + 16 >> 2] = f6;
  HEAPF32[i11 + 20 >> 2] = f8;
  HEAP8[i11 + 24 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i10, i11) | 0;
 }
 i11 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0) | 0;
 f2 = Math_fround(f12 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 21)));
 i11 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0, i14 | 0) | 0;
 f1 = Math_fround(f12 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i11 >> 2] | 0) + 296 >> 2] | 0, i11 | 0, 22)));
 if (!(f2 != Math_fround(0.0) | f1 != Math_fround(0.0))) {
  STACKTOP = i16;
  return;
 }
 HEAP32[i15 >> 2] = gb + 101184 + 8;
 HEAPF32[i15 + 4 >> 2] = f2;
 HEAPF32[i15 + 8 >> 2] = f1;
 HEAP32[i15 + 12 >> 2] = i13;
 __ZN5physx18NpArticulationLink14visualizeJointERNS_22PxConstraintVisualizerE(i14, i15);
 STACKTOP = i16;
 return;
}

function __ZN18UnityPropertySheet8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 24 | 0;
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i9 = HEAP32[gb + 37052 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469881 | 0, i9, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 HEAP32[i5 >> 2] = -1;
 i10 = i5 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnvC2Ev(i10);
 i7 = HEAP32[gb + 37152 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i5, 0);
 i6 = HEAP32[gb + 37008 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i6, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[gb + 37224 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i4, gb + 469909 | 0, i10, 0);
 __ZN15SerializeTraitsIN18UnityPropertySheet11UnityTexEnvEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469891 | 0, i9, i1 + 12 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 HEAP32[i5 >> 2] = -1;
 i10 = i5 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i6, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i4, HEAP32[gb + 37012 >> 2] | 0, i10, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469900 | 0, i9, i1 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 HEAP32[i5 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i6, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i5 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, i4, HEAP32[gb + 36980 >> 2] | 0, i1, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL19SweepBoxUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i11) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, d24 = 0.0, d25 = 0.0, i26 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 112 | 0;
 i19 = i12 + 100 | 0;
 i18 = i12 + 88 | 0;
 i17 = i12 + 72 | 0;
 i16 = i12 + 40 | 0;
 i15 = i12 + 28 | 0;
 i14 = i12;
 i13 = i12 + 160 | 0;
 HEAP32[i17 >> 2] = 3;
 i26 = i4 + 40 | 0;
 d25 = +HEAPF64[i1 >> 3];
 d24 = +HEAPF64[i1 + 8 >> 3];
 d23 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d21 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d20 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i26 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i26 + 4 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAPF32[i16 + 16 >> 2] = Math_fround(d25 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d24 - d21);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d23 - d20);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 2;
 i1 = i15 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i19 >> 2] = Math_fround(+HEAPF64[i3 + 40 >> 3] - d22);
 HEAPF32[i19 + 4 >> 2] = Math_fround(+HEAPF64[i3 + 48 >> 3] - d21);
 HEAPF32[i19 + 8 >> 2] = Math_fround(+HEAPF64[i3 + 56 >> 3] - d20);
 HEAPF32[i18 >> 2] = Math_fround(+HEAPF64[i3 + 64 >> 3] - d22);
 HEAPF32[i18 + 4 >> 2] = Math_fround(+HEAPF64[i3 + 72 >> 3] - d21);
 HEAPF32[i18 + 8 >> 2] = Math_fround(+HEAPF64[i3 + 80 >> 3] - d20);
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 88 >> 2];
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i19, i18, i1);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP16[i10 + 12 >> 1] = 0;
 i3 = i10 + 16 | 0;
 i1 = i10 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i11 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i10, i13, Math_fround(0.0)) | 0)) {
  i26 = 0;
  STACKTOP = i12;
  return i26 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i26 = 0;
  STACKTOP = i12;
  return i26 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 36 >> 2];
 HEAP32[i11 + 40 >> 2] = -1;
 HEAP32[i11 + 44 >> 2] = -1;
 d25 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i11 >> 3] = d25 + +HEAPF64[i5 >> 3];
 d25 = +Math_fround(HEAPF32[i10 + 20 >> 2]);
 HEAPF64[i11 + 8 >> 3] = d25 + +HEAPF64[i6 >> 3];
 d25 = +Math_fround(HEAPF32[i10 + 24 >> 2]);
 HEAPF64[i11 + 16 >> 3] = d25 + +HEAPF64[i7 >> 3];
 i26 = 1;
 STACKTOP = i12;
 return i26 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i9 = i5 - i3 >> 5;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = i4;
 i13 = i5;
 if (i9 >>> 0 <= i1 - i4 >> 5 >>> 0) {
  i7 = i11 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i4 >> 5;
  i4 = i9 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 << 5) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN9ShaderLab26SerializedShaderDependencyaSERKS0_(i2, i3) | 0;
   i3 = i3 + 32 | 0;
   i2 = i2 + 32 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (i4) {
   if ((i1 | 0) == (i13 | 0)) {
    STACKTOP = i14;
    return;
   }
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i2, i1);
    i1 = i1 + 32 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 32 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i1 | 0) != (i13 | 0));
   STACKTOP = i14;
   return;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   STACKTOP = i14;
   return;
  }
  i5 = i12 + 4 | 0;
  i6 = i12 + 4 | 0;
  do {
   i3 = i1 + -32 | 0;
   HEAP32[i7 >> 2] = i3;
   i4 = i1 + -16 | 0;
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i4 >> 2] | 0;
    i11 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i1 + -20 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
   }
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i14;
  return;
 }
 if (i4) {
  i8 = i11 + 4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i4; else {
   i6 = i12 + 4 | 0;
   i7 = i12 + 4 | 0;
   do {
    i4 = i1 + -32 | 0;
    HEAP32[i8 >> 2] = i4;
    i5 = i1 + -16 | 0;
    if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
     i5 = HEAP32[i5 >> 2] | 0;
     i15 = HEAP32[i1 + -4 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i6 >> 2] = i15;
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
    }
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i15 = HEAP32[i4 >> 2] | 0;
     i5 = HEAP32[i1 + -20 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i7 >> 2] = i5;
     __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    }
    i1 = HEAP32[i8 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if (i9 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else i2 = 0;
 i15 = i1 - i2 | 0;
 i1 = i15 >> 4;
 i1 = i15 >> 5 >>> 0 < 67108863 ? (i1 >>> 0 < i9 >>> 0 ? i9 : i1) : 134217727;
 if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i2 = __Znwj(i1 << 5) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i10 >> 2] = i2 + (i1 << 5);
 if ((i3 | 0) == (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = i3;
 do {
  __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i2, i1);
  i1 = i1 + 32 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return;
}

function __ZNSt3__215numpunct_bynameIcE6__initEPKc(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i7 = i6;
 L1 : do if (_strcmp(i2, gb + 1083663 | 0) | 0) {
  i8 = _newlocale(2147483647, i2, 0) | 0;
  i9 = (i8 | 0) == 0;
  L3 : do if (i9) {
   i4 = ___cxa_allocate_exception(8) | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   i6 = _strlen(i2) | 0;
   __THREW__ = 0;
   invoke_viii(fb + 1040 | 0, i7 | 0, i2 | 0, i6 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 511 | 0, i7 | 0, 0, gb + 1081941 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     i2 = 1;
    } else {
     HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     invoke_vii(fb + 4518 | 0, i4 | 0, i3 | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) i2 = 1; else {
      __THREW__ = 0;
      invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
      __THREW__ = 0;
      i2 = 0;
     }
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    if (!i2) break;
   }
   ___cxa_free_exception(i4 | 0);
  } else {
   __THREW__ = 0;
   i2 = invoke_ii(fb + 2805 | 0, i8 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   do if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    __THREW__ = 0;
    i4 = invoke_i(fb + 318 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i3 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     if (!i2) {
      i1 = i3;
      break;
     }
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (!(i7 & 1)) {
      i1 = i3;
      break;
     }
     i7 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i7);
    }
    if (i2 | 0) {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i7 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i7);
     }
    }
    i2 = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
    if (i2 << 24 >> 24) HEAP8[i5 + 8 >> 0] = i2;
    i2 = HEAP8[HEAP32[i4 + 4 >> 2] >> 0] | 0;
    if (i2 << 24 >> 24) HEAP8[i5 + 9 >> 0] = i2;
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, i5 + 12 | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break L3;
    }
    __THREW__ = 0;
    invoke_vi(fb + 4002 | 0, i8 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break L1;
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   } while (0);
  } while (0);
  if (!i9) {
   __THREW__ = 0;
   invoke_vi(fb + 4002 | 0, i8 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i9 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i9);
   }
  }
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZN17PersistentManager25PreallocateObjectThreadedEi(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 16 | 0;
 i1 = i13 + 32 | 0;
 i12 = i13;
 HEAP32[i1 >> 2] = i11;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i1 = 0; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i8 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i8 + (i3 << 3) | 0;
   i2 = i8;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i1);
   i1 = HEAP32[i9 >> 2] | 0;
   i8 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i8 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i8 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if (i1 | 0) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = __ZN17PersistentManager22GetFromActivationQueueEi(i10, i11) | 0;
 if (i1 | 0) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i3 = HEAP32[i10 + 56 >> 2] | 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i8 = 13; else {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  if ((i2 | 0) > (i11 | 0)) i8 = 13; else if ((HEAP32[i3 + 32 >> 2] | 0) < (i11 | 0)) i8 = 13; else {
   i5 = (i11 - i2 | 0) / 2 | 0;
   i6 = 0;
   i7 = i5;
   i5 = ((i5 | 0) < 0) << 31 >> 31;
   i8 = 21;
  }
 }
 if ((i8 | 0) == 13) {
  i4 = i3 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = i4;
   L21 : while (1) {
    i2 = i1;
    while (1) {
     if ((HEAP32[i2 + 16 >> 2] | 0) >= (i11 | 0)) break;
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      break L21;
     } else i2 = i1;
    }
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) break; else i3 = i2;
   }
   if ((i2 | 0) == (i4 | 0)) i1 = 0; else if ((HEAP32[i2 + 16 >> 2] | 0) > (i11 | 0)) i1 = 0; else {
    i1 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 32 | 0;
    if ((i1 | 0) == -1) i1 = 0; else {
     i6 = HEAP32[i2 + 24 + 4 >> 2] | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     i5 = HEAP32[i3 + 4 >> 2] | 0;
     i8 = 21;
    }
   }
  }
 }
 L30 : do if ((i8 | 0) == 21) {
  i4 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i10, i1) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i1 = 0; else if (__ZNK14SerializedFile11IsAvailableEx(i2, i7, i5) | 0) {
   i3 = HEAP32[i4 + 16 >> 2] | 0;
   L34 : do if (i3 | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    i8 = HEAP32[i3 + 12 >> 2] | 0;
    i3 = i2 + (i8 << 3) | 0;
    L36 : do if (i8) while (1) {
     i8 = i2;
     if ((HEAP32[i8 >> 2] | 0) == (i7 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i5 | 0) : 0) break L36;
     i2 = i2 + 8 | 0;
     if ((i2 | 0) == (i3 | 0)) break L34;
    } while (0);
    if ((i2 | 0) != (i3 | 0)) {
     i1 = 0;
     break L30;
    }
   } while (0);
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i1 = 0; else {
    HEAP32[i12 >> 2] = i1;
    HEAP32[i12 + 4 >> 2] = i6;
    i1 = i12 + 8 | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 4 >> 2] = i5;
    HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
    i1 = __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib(i10, i2, i9, i11, 0) | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
  } else i1 = 0;
 } while (0);
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN17PersistentManager21ProduceObjectInternalER14SerializedFile26SerializedObjectIdentifierii(i12, i1, i8, i3, i4) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 44 | 0;
 i11 = i15 + 16 | 0;
 i14 = i15 + 40 | 0;
 i9 = i15;
 i5 = i15 + 24 | 0;
 i6 = i15 + 32 | 0;
 i10 = i15 + 20 | 0;
 i7 = i9 + 8 | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i2 = i8 + 8 | 0;
 i2 = __ZN14SerializedFile14GetProduceDataExRiR31LocalSerializedObjectIdentifierR18MemLabelIdentifier(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i13, i9, i5) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) > -1) i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0; else i1 = 0;
 if (!i2) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 i6 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i1, i3, i13, i4) | 0;
 if (!i6) {
  HEAP32[i11 >> 2] = HEAP32[i1 + 16 >> 2];
  __Z6FormatPKcz(i13, gb + 467391 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 466878 | 0, 1323, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i11 = i7;
 if ((HEAP32[i11 >> 2] | 0) == 0 & (HEAP32[i11 + 4 >> 2] | 0) == 0) {
  i14 = i6;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((((HEAP32[i6 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
  i14 = i6;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP32[i10 >> 2] = 0;
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalEiRK31LocalSerializedObjectIdentifierRi(i12, HEAP32[i8 >> 2] | 0, i9, i10);
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = __ZN17PersistentManager22GetFromActivationQueueEi(i12, i4) | 0;
 if (!i1) i5 = 11; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) {
  HEAP32[i6 + 36 >> 2] = i4;
  i5 = 21;
 } else i5 = 11;
 do if ((i5 | 0) == 11) {
  HEAP32[i14 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i1 = 0; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
    i2 = HEAP32[i13 >> 2] | 0;
    i14 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) {
   HEAP32[i6 + 36 >> 2] = i4;
   i5 = 21;
   break;
  }
  HEAP32[i6 + 36 >> 2] = i4;
  i2 = 0;
  i1 = 0;
 } while (0);
 if ((i5 | 0) == 21) {
  i2 = i1;
  i1 = __ZN10MonoScript8GetClassEv(i1) | 0;
 }
 __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript(i6, i1, 0, i2);
 i14 = i6;
 STACKTOP = i15;
 return i14 | 0;
}

function _UNITY_FT_Add_Module(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 4 | 0;
 i13 = i14;
 if (!i11) {
  i13 = 33;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!i10) {
  i13 = 6;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((HEAP32[i10 + 16 >> 2] | 0) > 131078) {
  i13 = 4;
  STACKTOP = i14;
  return i13 | 0;
 }
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i2) {
  i6 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  i2 = i11;
 } else {
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i11 + 20 + (i1 << 2) >> 2] | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i1 = i1 + 1 | 0;
   if (!(_strcmp(HEAP32[i5 + 8 >> 2] | 0, i3) | 0)) {
    i9 = 9;
    break;
   }
  } while (i1 >>> 0 < i2 >>> 0);
  do if ((i9 | 0) == 9) if ((HEAP32[i10 + 12 >> 2] | 0) > (HEAP32[i5 + 12 >> 2] | 0)) {
   _UNITY_FT_Remove_Module(i11, i4) | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   break;
  } else {
   i13 = 5;
   STACKTOP = i14;
   return i13 | 0;
  } while (0);
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 0;
  if (i2 >>> 0 > 31) {
   HEAP32[i13 >> 2] = 48;
   i13 = 48;
   STACKTOP = i14;
   return i13 | 0;
  } else {
   i6 = i1;
   i2 = i11;
  }
 }
 i7 = _UNITY_ft_mem_alloc(i6, HEAP32[i10 + 4 >> 2] | 0, i13) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i7 + 8 >> 2] = i6;
 HEAP32[i7 >> 2] = i10;
 do if (!(HEAP32[i10 >> 2] & 2)) i9 = 27; else {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = _UNITY_ft_mem_alloc(i4, 12, i8) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i13 >> 2] = i1;
   break;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 + 12 >> 2] = i1;
  i3 = HEAP32[i1 + 36 >> 2] | 0;
  HEAP32[i7 + 16 >> 2] = i3;
  if ((i3 | 0) == 1869968492) {
   i2 = i1 + 56 | 0;
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0;
   if (!i3) i9 = 21; else {
    i3 = mftCall_iii(i3 | 0, i4 | 0, i7 + 52 | 0) | 0;
    HEAP32[i8 >> 2] = i3;
    if (!i3) {
     HEAP32[i7 + 56 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2];
     HEAP32[i7 + 60 >> 2] = HEAP32[i1 + 40 >> 2];
     i9 = 21;
    }
   }
  } else i9 = 21;
  if ((i9 | 0) == 21) {
   HEAP32[i5 + 8 >> 2] = i7;
   _UNITY_FT_List_Add(i11 + 148 | 0, i5);
   i1 = HEAP32[i11 + 148 >> 2] | 0;
   L39 : do if (!i1) i1 = 0; else {
    i2 = i1;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 + 16 >> 2] | 0) == 1869968492) break L39;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) {
      i1 = 0;
      break;
     }
    }
   } while (0);
   HEAP32[i11 + 156 >> 2] = i1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    HEAP32[i13 >> 2] = 0;
    i9 = 27;
    break;
   }
  }
  _UNITY_ft_mem_free(i4, i5);
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP32[i13 >> 2] = i8;
  if (!i8) i9 = 27;
 } while (0);
 do if ((i9 | 0) == 27) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 & 4 | 0) HEAP32[i11 + 160 >> 2] = i7;
  if (i2 & 1 | 0) HEAP32[i7 + 12 >> 2] = i1;
  i1 = HEAP32[i10 + 24 >> 2] | 0;
  if (i1 | 0) {
   i10 = mftCall_ii(i1 | 0, i7 | 0) | 0;
   HEAP32[i13 >> 2] = i10;
   if (i10 | 0) break;
  }
  i13 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 >> 2] = i13 + 1;
  HEAP32[i11 + 20 + (i13 << 2) >> 2] = i7;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 if (HEAP32[HEAP32[i7 >> 2] >> 2] & 2 | 0) {
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i1 + 36 >> 2] | 0) == 1869968492) {
   i2 = HEAP32[i7 + 52 >> 2] | 0;
   if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i1 + 56 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  }
 }
 _UNITY_ft_mem_free(i6, i7);
 i13 = HEAP32[i13 >> 2] | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer16GetJsonDataBlockEjRK8UnityStrRS2_Pj(i1, i2, i3, i12, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 152 | 0;
 i14 = i16 + 16 | 0;
 i15 = i16;
 HEAP32[i4 >> 2] = 0;
 if (!i2) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = gb + 77468 + 12;
 i10 = i14 + 56 | 0;
 HEAP32[i10 >> 2] = gb + 77468 + 32;
 __ZNSt3__28ios_base4initEPv(i14 + 56 | 0, i9);
 HEAP32[i14 + 128 >> 2] = 0;
 HEAP32[i14 + 132 >> 2] = -1;
 HEAP32[i14 >> 2] = gb + 77508 + 12;
 HEAP32[i14 + 56 >> 2] = gb + 77508 + 32;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i9);
 HEAP32[i9 >> 2] = gb + 77548 + 8;
 i11 = i14 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i14 + 52 >> 2] = 16;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i9, i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZN11UnityEngine15CloudWebService16SessionContainer24GetSessionHeaderJsonDataERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i1, i3, i14) | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i7 = __ZN11UnityEngine15CloudWebService17SessionEventQueue19GetEventsAsJsonDataEjR8UnityStrPj(i1 + 68 | 0, i2, i15, i4) | 0;
 i8 = i15 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 if ((i1 ? HEAP32[i15 + 4 >> 2] | 0 : i6 & 255) | 0) {
  i6 = i1 ? HEAP32[i15 >> 2] | 0 : i15;
  __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i14, i6, _strlen(i6) | 0) | 0;
 }
 __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i13, i9);
 i5 = HEAP8[i13 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i4 = i6 ? HEAP32[i13 >> 2] | 0 : i13;
 i5 = i6 ? HEAP32[i13 + 4 >> 2] | 0 : i5 & 255;
 i6 = i12 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i6 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i5 - i3 | 0, i6, 0, i6, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i12 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i12 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 }
 HEAP32[i14 >> 2] = gb + 77508 + 12;
 HEAP32[i10 >> 2] = gb + 77508 + 32;
 HEAP32[i9 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i9);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i14, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i10);
 i15 = i7;
 STACKTOP = i16;
 return i15 | 0;
}

function runPostSets115() {
 HEAP32[gb + 102732 >> 2] = fb + 1517;
 HEAP32[gb + 102744 >> 2] = fb + 1125;
 HEAP32[gb + 102748 >> 2] = fb + 1518;
 HEAP32[gb + 102752 >> 2] = fb + 1258;
 HEAP32[gb + 102756 >> 2] = fb + 767;
 HEAP32[gb + 102760 >> 2] = fb + 1127;
 HEAP32[gb + 102764 >> 2] = fb + 1128;
 HEAP32[gb + 102768 >> 2] = fb + 469;
 HEAP32[gb + 102772 >> 2] = fb + 1129;
 HEAP32[gb + 102776 >> 2] = fb + 1519;
 HEAP32[gb + 102788 >> 2] = fb + 1125;
 HEAP32[gb + 102792 >> 2] = fb + 1520;
 HEAP32[gb + 102796 >> 2] = fb + 1258;
 HEAP32[gb + 102800 >> 2] = fb + 768;
 HEAP32[gb + 102804 >> 2] = fb + 1127;
 HEAP32[gb + 102808 >> 2] = fb + 1128;
 HEAP32[gb + 102812 >> 2] = fb + 469;
 HEAP32[gb + 102816 >> 2] = fb + 1129;
 HEAP32[gb + 102820 >> 2] = fb + 1521;
 HEAP32[gb + 102832 >> 2] = fb + 1125;
 HEAP32[gb + 102836 >> 2] = fb + 1522;
 HEAP32[gb + 102840 >> 2] = fb + 1258;
 HEAP32[gb + 102844 >> 2] = fb + 769;
 HEAP32[gb + 102848 >> 2] = fb + 1127;
 HEAP32[gb + 102852 >> 2] = fb + 1128;
 HEAP32[gb + 102856 >> 2] = fb + 469;
 HEAP32[gb + 102860 >> 2] = fb + 1129;
 HEAP32[gb + 102864 >> 2] = fb + 1523;
 HEAP32[gb + 102876 >> 2] = fb + 986;
 HEAP32[gb + 102880 >> 2] = fb + 1524;
 HEAP32[gb + 102884 >> 2] = fb + 163;
 HEAP32[gb + 102896 >> 2] = fb + 30;
 HEAP32[gb + 102900 >> 2] = fb + 988;
 HEAP32[gb + 102904 >> 2] = fb + 1525;
 HEAP32[gb + 102908 >> 2] = fb + 1;
 HEAP32[gb + 102912 >> 2] = fb + 2;
 HEAP32[gb + 102916 >> 2] = fb + 3;
 HEAP32[gb + 102920 >> 2] = fb + 4;
 HEAP32[gb + 102924 >> 2] = fb + 5;
 HEAP32[gb + 102928 >> 2] = fb + 6;
 HEAP32[gb + 102932 >> 2] = fb + 7;
 HEAP32[gb + 102940 >> 2] = fb + 2;
 HEAP32[gb + 102944 >> 2] = fb + 2;
 HEAP32[gb + 102948 >> 2] = fb + 2;
 HEAP32[gb + 102952 >> 2] = fb + 2;
 HEAP32[gb + 102956 >> 2] = fb + 2;
 HEAP32[gb + 102960 >> 2] = fb + 2;
 HEAP32[gb + 102972 >> 2] = fb + 3;
 HEAP32[gb + 102976 >> 2] = fb + 8;
 HEAP32[gb + 102980 >> 2] = fb + 5;
 HEAP32[gb + 102984 >> 2] = fb + 6;
 HEAP32[gb + 102988 >> 2] = fb + 7;
 HEAP32[gb + 103004 >> 2] = fb + 9;
 HEAP32[gb + 103008 >> 2] = fb + 10;
 HEAP32[gb + 103012 >> 2] = fb + 6;
 HEAP32[gb + 103016 >> 2] = fb + 7;
 HEAP32[gb + 103036 >> 2] = fb + 11;
 HEAP32[gb + 103040 >> 2] = fb + 6;
 HEAP32[gb + 103044 >> 2] = fb + 7;
 HEAP32[gb + 103068 >> 2] = fb + 2;
 HEAP32[gb + 103072 >> 2] = fb + 2;
 HEAP32[gb + 103100 >> 2] = fb + 2;
 HEAP32[gb + 103104 >> 2] = fb + 93;
 HEAP32[gb + 103108 >> 2] = fb + 93;
 HEAP32[gb + 103112 >> 2] = fb + 93;
 HEAP32[gb + 103116 >> 2] = fb + 93;
 HEAP32[gb + 103120 >> 2] = fb + 93;
 HEAP32[gb + 103124 >> 2] = fb + 94;
 HEAP32[gb + 103128 >> 2] = fb + 95;
 HEAP32[gb + 103140 >> 2] = fb + 1009;
 HEAP32[gb + 103144 >> 2] = fb + 1526;
 HEAP32[gb + 103148 >> 2] = fb + 69;
 HEAP32[gb + 103152 >> 2] = fb + 40;
 HEAP32[gb + 103156 >> 2] = fb + 1136;
 HEAP32[gb + 103160 >> 2] = fb + 1;
 HEAP32[gb + 103164 >> 2] = fb + 2;
 HEAP32[gb + 103168 >> 2] = fb + 3;
 HEAP32[gb + 103172 >> 2] = fb + 4;
 HEAP32[gb + 103176 >> 2] = fb + 5;
 HEAP32[gb + 103180 >> 2] = fb + 2;
 HEAP32[gb + 103184 >> 2] = fb + 2;
 HEAP32[gb + 103196 >> 2] = fb + 1009;
 HEAP32[gb + 103200 >> 2] = fb + 1527;
 HEAP32[gb + 103204 >> 2] = fb + 70;
 HEAP32[gb + 103208 >> 2] = fb + 41;
 HEAP32[gb + 103212 >> 2] = fb + 1137;
 HEAP32[gb + 103224 >> 2] = fb + 1009;
 HEAP32[gb + 103228 >> 2] = fb + 1528;
 HEAP32[gb + 103232 >> 2] = fb + 71;
 HEAP32[gb + 103236 >> 2] = fb + 42;
 HEAP32[gb + 103240 >> 2] = fb + 1138;
 HEAP32[gb + 103252 >> 2] = fb + 1009;
 HEAP32[gb + 103256 >> 2] = fb + 1529;
 HEAP32[gb + 103260 >> 2] = fb + 72;
 HEAP32[gb + 103264 >> 2] = fb + 43;
 HEAP32[gb + 103268 >> 2] = fb + 1139;
 HEAP32[gb + 103280 >> 2] = fb + 31;
 HEAP32[gb + 103284 >> 2] = fb + 988;
 HEAP32[gb + 103288 >> 2] = fb + 1530;
 HEAP32[gb + 103300 >> 2] = fb + 1009;
 runPostSets116();
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_(i11, i1, i15, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i8 = i11 + 4 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i1 = i13;
 do if ((i13 | 0) != (i8 | 0)) {
  i5 = i13 + 16 | 0;
  i10 = HEAP8[i12 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i12 + 4 >> 2] | 0 : i10 & 255;
  i3 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i3 = i4 ? HEAP32[i13 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i10 >>> 0;
  i2 = i6 ? i3 : i10;
  if (!i2) i14 = 4; else {
   i2 = _memcmp(i9 ? HEAP32[i12 >> 2] | 0 : i12, i4 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
   if (!i2) i14 = 4; else if ((i2 | 0) < 0) break;
  }
  if ((i14 | 0) == 4) if (i10 >>> 0 < i3 >>> 0) break;
  i2 = i10 >>> 0 < i3 >>> 0 ? i10 : i3;
  if (!i2) i14 = 20; else {
   i2 = _memcmp(i4 ? HEAP32[i5 >> 2] | 0 : i5, i9 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
   if (!i2) i14 = 20; else if ((i2 | 0) >= 0) i14 = 34;
  }
  if ((i14 | 0) == 20) if (!i6) i14 = 34;
  if ((i14 | 0) == 34) {
   HEAP32[i15 >> 2] = i1;
   return i15 | 0;
  }
  i6 = i13 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = (i1 | 0) == 0;
  if (i7) {
   i1 = i13;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  do if ((i2 | 0) != (i8 | 0)) {
   i3 = i2 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i2 + 20 >> 2] | 0 : i5 & 255;
   i1 = i5 >>> 0 < i10 >>> 0 ? i5 : i10;
   if (!i1) i14 = 28; else {
    i1 = _memcmp(i9 ? HEAP32[i12 >> 2] | 0 : i12, i4 ? HEAP32[i3 >> 2] | 0 : i3, i1) | 0;
    if (!i1) i14 = 28; else if ((i1 | 0) < 0) break;
   }
   if ((i14 | 0) == 28) if (i10 >>> 0 < i5 >>> 0) break;
   i15 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i11, i15, i12) | 0;
   return i15 | 0;
  } while (0);
  if (i7) {
   HEAP32[i15 >> 2] = i13;
   i15 = i6;
   return i15 | 0;
  } else {
   HEAP32[i15 >> 2] = i2;
   i15 = i2;
   return i15 | 0;
  }
 } while (0);
 do if ((i13 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) {
   i1 = i13;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i2; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = i2;
  i4 = i2 + 16 | 0;
  i6 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
  i7 = HEAP8[i12 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i2 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
  if (!i2) i14 = 12; else {
   i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
   if (!i2) i14 = 12; else if ((i2 | 0) < 0) break;
  }
  if ((i14 | 0) == 12) if (i6 >>> 0 < i7 >>> 0) break;
  i15 = __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i11, i15, i12) | 0;
  return i15 | 0;
 } while (0);
 if (!(HEAP32[i13 >> 2] | 0)) {
  HEAP32[i15 >> 2] = i13;
  i15 = i13;
  return i15 | 0;
 } else {
  i14 = i1;
  HEAP32[i15 >> 2] = i14;
  i15 = i14 + 4 | 0;
  return i15 | 0;
 }
 return 0;
}

function runPostSets18() {
 HEAP32[gb + 36428 >> 2] = fb + 1;
 HEAP32[gb + 36432 >> 2] = fb + 1;
 HEAP32[gb + 36444 >> 2] = fb + 217;
 HEAP32[gb + 36448 >> 2] = fb + 218;
 HEAP32[gb + 36452 >> 2] = fb + 38;
 HEAP32[gb + 36456 >> 2] = fb + 240;
 HEAP32[gb + 36460 >> 2] = fb + 16;
 HEAP32[gb + 36464 >> 2] = fb + 93;
 HEAP32[gb + 36468 >> 2] = fb + 219;
 HEAP32[gb + 36472 >> 2] = fb + 19;
 HEAP32[gb + 36476 >> 2] = fb + 139;
 HEAP32[gb + 36480 >> 2] = fb + 103;
 HEAP32[gb + 36484 >> 2] = fb + 101;
 HEAP32[gb + 36488 >> 2] = fb + 62;
 HEAP32[gb + 36492 >> 2] = fb + 28;
 HEAP32[gb + 36496 >> 2] = fb + 63;
 HEAP32[gb + 36500 >> 2] = fb + 29;
 HEAP32[gb + 36504 >> 2] = fb + 34;
 HEAP32[gb + 36508 >> 2] = fb + 241;
 HEAP32[gb + 36512 >> 2] = fb + 242;
 HEAP32[gb + 36516 >> 2] = fb + 243;
 HEAP32[gb + 36520 >> 2] = fb + 244;
 HEAP32[gb + 36524 >> 2] = fb + 245;
 HEAP32[gb + 36528 >> 2] = fb + 246;
 HEAP32[gb + 36532 >> 2] = fb + 36;
 HEAP32[gb + 36536 >> 2] = fb + 104;
 HEAP32[gb + 36540 >> 2] = fb + 108;
 HEAP32[gb + 36544 >> 2] = fb + 94;
 HEAP32[gb + 36548 >> 2] = fb + 130;
 HEAP32[gb + 36552 >> 2] = fb + 112;
 HEAP32[gb + 36556 >> 2] = fb + 113;
 HEAP32[gb + 36560 >> 2] = fb + 131;
 HEAP32[gb + 36564 >> 2] = fb + 111;
 HEAP32[gb + 36568 >> 2] = fb + 112;
 HEAP32[gb + 36572 >> 2] = fb + 113;
 HEAP32[gb + 36576 >> 2] = fb + 215;
 HEAP32[gb + 36580 >> 2] = fb + 216;
 HEAP32[gb + 36584 >> 2] = fb + 10;
 HEAP32[gb + 36588 >> 2] = fb + 11;
 HEAP32[gb + 36600 >> 2] = fb + 220;
 HEAP32[gb + 36604 >> 2] = fb + 221;
 HEAP32[gb + 36608 >> 2] = fb + 38;
 HEAP32[gb + 36612 >> 2] = fb + 145;
 HEAP32[gb + 36616 >> 2] = fb + 16;
 HEAP32[gb + 36620 >> 2] = fb + 93;
 HEAP32[gb + 36624 >> 2] = fb + 40;
 HEAP32[gb + 36628 >> 2] = fb + 19;
 HEAP32[gb + 36632 >> 2] = fb + 140;
 HEAP32[gb + 36636 >> 2] = fb + 103;
 HEAP32[gb + 36640 >> 2] = fb + 101;
 HEAP32[gb + 36644 >> 2] = fb + 62;
 HEAP32[gb + 36648 >> 2] = fb + 28;
 HEAP32[gb + 36652 >> 2] = fb + 63;
 HEAP32[gb + 36656 >> 2] = fb + 29;
 HEAP32[gb + 36660 >> 2] = fb + 34;
 HEAP32[gb + 36664 >> 2] = fb + 146;
 HEAP32[gb + 36668 >> 2] = fb + 147;
 HEAP32[gb + 36672 >> 2] = fb + 148;
 HEAP32[gb + 36676 >> 2] = fb + 149;
 HEAP32[gb + 36680 >> 2] = fb + 150;
 HEAP32[gb + 36684 >> 2] = fb + 151;
 HEAP32[gb + 36688 >> 2] = fb + 36;
 HEAP32[gb + 36692 >> 2] = fb + 104;
 HEAP32[gb + 36696 >> 2] = fb + 108;
 HEAP32[gb + 36700 >> 2] = fb + 94;
 HEAP32[gb + 36704 >> 2] = fb + 130;
 HEAP32[gb + 36708 >> 2] = fb + 112;
 HEAP32[gb + 36712 >> 2] = fb + 113;
 HEAP32[gb + 36716 >> 2] = fb + 131;
 HEAP32[gb + 36720 >> 2] = fb + 111;
 HEAP32[gb + 36724 >> 2] = fb + 112;
 HEAP32[gb + 36728 >> 2] = fb + 113;
 HEAP32[gb + 36732 >> 2] = fb + 222;
 HEAP32[gb + 36736 >> 2] = fb + 223;
 HEAP32[gb + 36764 >> 2] = fb + 224;
 HEAP32[gb + 36768 >> 2] = fb + 225;
 HEAP32[gb + 36772 >> 2] = fb + 226;
 HEAP32[gb + 36784 >> 2] = fb + 227;
 HEAP32[gb + 36788 >> 2] = fb + 228;
 HEAP32[gb + 36800 >> 2] = fb + 229;
 HEAP32[gb + 36804 >> 2] = fb + 230;
 HEAP32[gb + 36808 >> 2] = fb + 231;
 HEAP32[gb + 36820 >> 2] = fb + 232;
 HEAP32[gb + 36824 >> 2] = fb + 233;
 HEAP32[gb + 36836 >> 2] = fb + 234;
 HEAP32[gb + 36840 >> 2] = fb + 235;
 HEAP32[gb + 36844 >> 2] = fb + 236;
 HEAP32[gb + 36856 >> 2] = fb + 237;
 HEAP32[gb + 36860 >> 2] = fb + 238;
 HEAP32[gb + 36872 >> 2] = fb + 239;
 HEAP32[gb + 36876 >> 2] = fb + 240;
 HEAP32[gb + 36888 >> 2] = fb + 241;
 HEAP32[gb + 36892 >> 2] = fb + 242;
 HEAP32[gb + 36904 >> 2] = fb + 243;
 HEAP32[gb + 36908 >> 2] = fb + 244;
 HEAP32[gb + 36912 >> 2] = fb + 245;
 HEAP32[gb + 36924 >> 2] = fb + 246;
 HEAP32[gb + 36928 >> 2] = fb + 247;
 HEAP32[gb + 36932 >> 2] = (HEAP32[gb + 36932 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 36936 >> 2] = (HEAP32[gb + 36936 >> 2] | 0) + (gb + 388687 | 0);
 runPostSets19();
}

function __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i7 = HEAP32[i11 >> 2] | 0;
 i2 = i7;
 i6 = (HEAP32[i1 >> 2] | 0) - i2 >> 3;
 i15 = i7 + (i6 << 3) | 0;
 i14 = i11 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i4 = i11 + 8 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i3 = i1;
 i5 = i10;
 if (i1 >>> 0 < i10 >>> 0) {
  if ((i15 | 0) == (i1 | 0)) {
   i11 = i12;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i15;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 8;
   STACKTOP = i16;
   return i15 | 0;
  }
  i5 = i3 - (i15 + 8) >> 3;
  i2 = i15 + (i5 << 3) | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   i4 = i2;
   i3 = i1;
   do {
    i11 = i4;
    i13 = HEAP32[i11 + 4 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i3 + 4 >> 2] = i13;
    i4 = i4 + 8 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 8 | 0;
    HEAP32[i14 >> 2] = i3;
   } while (i4 >>> 0 < i1 >>> 0);
  } else i3 = i1;
  if (i5 | 0) do {
   i14 = i1;
   i1 = i1 + -8 | 0;
   i13 = i2;
   i2 = i2 + -8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i14 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
  } while ((i2 | 0) != (i15 | 0));
  i14 = i15 >>> 0 > i12 >>> 0 ? i12 : i3 >>> 0 > i12 >>> 0 ? i12 + 8 | 0 : i12;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i7 + (i6 << 3) + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i11 + 12 | 0;
 i9 = i3 - i2 | 0;
 i3 = (i9 >> 3) + 1 | 0;
 if ((i9 | 0) < -8) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i9 = i4;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i4;
  i1 = i5;
 }
 i8 = i1 - i2 | 0;
 i6 = i8 >> 2;
 i6 = i8 >> 3 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 i8 = i15;
 i4 = i8 - i2 | 0;
 i5 = i4 >> 3;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i10 >> 2] | 0;
  HEAP32[i13 >> 2] = 37;
  HEAP32[i13 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i1 = i7 + (i5 << 3) | 0;
 i2 = i1;
 i3 = i7 + (i6 << 3) | 0;
 do if ((i5 | 0) == (i6 | 0)) {
  if ((i4 | 0) > 0) {
   i1 = i1 + (((i6 + 1 | 0) / -2 | 0) << 3) | 0;
   i2 = i1;
   break;
  }
  i3 = i6 << 3 >> 2;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i6 = HEAP32[i10 >> 2] | 0;
  HEAP32[i13 >> 2] = 37;
  HEAP32[i13 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  i1 = i6 + (i3 >>> 2 << 3) | 0;
  i2 = i1;
  i3 = i6 + (i3 << 3) | 0;
  if (i7) {
   i6 = HEAP32[i10 >> 2] | 0;
   HEAP32[i13 >> 2] = 37;
   HEAP32[i13 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i7, i13);
  }
 } while (0);
 i4 = i12;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i2 + 8 | 0;
 i5 = i2;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i8 - i2 | 0;
 i6 = i5 + (0 - (i4 >> 3) << 3) | 0;
 if ((i4 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i4 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i8 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i15 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 3 << 3) | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 if (!i2) {
  i15 = i5;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i10 >> 2] | 0;
 HEAP32[i13 >> 2] = 37;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i5;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK14NavMeshManager23GetSourceTileDataBoundsER13dynamic_arrayI12TileLocationLj4EE(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = i1 + 128 | 0;
 i4 = i1 + 124 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) i1 = 0; else {
  i2 = 0;
  while (1) {
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = (((HEAP32[i3 + 56 >> 2] | 0) - (HEAP32[i3 + 52 >> 2] | 0) | 0) / 20 | 0) + i2 | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i16 | 0)) {
    i1 = i3;
    break;
   } else i2 = i3;
  }
 }
 i14 = i15 + 16 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i14 >> 2] = i1;
  HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 36 | 0, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 4, i15 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i15 + 12 >> 2] | 0) * 36 | 0) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i15 >> 2] = i13;
  break;
 } while (0);
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) return;
 i12 = i15 + 12 | 0;
 i13 = i15 + 4 | 0;
 i2 = i1;
 while (1) {
  i9 = HEAP32[i2 + 16 >> 2] | 0;
  i11 = HEAP32[i2 + 20 >> 2] | 0;
  i10 = i11 + 52 | 0;
  i11 = i11 + 56 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if ((HEAP32[i11 >> 2] | 0) != (i1 | 0)) {
   i8 = 0;
   do {
    i3 = HEAP32[i1 + (i8 * 20 | 0) >> 2] | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i1 = i6 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 36 | 0, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 36 | 0) | 0;
      HEAP32[i14 >> 2] = i1;
      HEAP32[i15 >> 2] = i7;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[i15 >> 2] | 0;
    HEAP32[i1 + (i4 * 36 | 0) + 32 >> 2] = i9;
    HEAP32[i1 + (i4 * 36 | 0) + 24 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i1 + (i4 * 36 | 0) + 28 >> 2] = HEAP32[i3 + 12 >> 2];
    i18 = HEAP32[i3 + 48 >> 2] | 0;
    i17 = HEAP32[i3 + 52 >> 2] | 0;
    i5 = HEAP32[i3 + 56 >> 2] | 0;
    i6 = HEAP32[i3 + 60 >> 2] | 0;
    i7 = HEAP32[i3 + 64 >> 2] | 0;
    HEAP32[i1 + (i4 * 36 | 0) >> 2] = HEAP32[i3 + 44 >> 2];
    HEAP32[i1 + (i4 * 36 | 0) + 4 >> 2] = i18;
    HEAP32[i1 + (i4 * 36 | 0) + 8 >> 2] = i17;
    HEAP32[i1 + (i4 * 36 | 0) + 12 >> 2] = i5;
    HEAP32[i1 + (i4 * 36 | 0) + 16 >> 2] = i6;
    HEAP32[i1 + (i4 * 36 | 0) + 20 >> 2] = i7;
    i8 = i8 + 1 | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   } while (i8 >>> 0 < (((HEAP32[i11 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0);
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i16 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN5physx16PxsBroadPhaseMBP13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE(i15, i12) {
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 48 | 0;
 i11 = i16 + 24 | 0;
 i14 = i16;
 i3 = HEAP32[i12 + 32 >> 2] | 0;
 i4 = i15 + 92 | 0;
 if (i3 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16 + 49 | 0, i3 << 2, gb + 717183 | 0, 3535) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   _memcpy(i5 | 0, HEAP32[i15 + 88 >> 2] | 0, i1 << 2 | 0) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  if (i1 >>> 0 < i3 >>> 0) {
   i13 = i1 << 2;
   _memset(i5 + i13 | 0, -1, (i3 << 2) - i13 | 0) | 0;
  }
  i13 = i15 + 88 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i13 >> 2] | 0);
  HEAP32[i13 >> 2] = i5;
  HEAP32[i4 >> 2] = i3;
 }
 i13 = HEAP32[i12 + 24 >> 2] | 0;
 i10 = HEAP32[i12 + 28 >> 2] | 0;
 HEAP32[i15 + 120 >> 2] = i10;
 i2 = HEAP32[i12 + 16 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i12 + 20 >> 2] | 0;
  if (i1 | 0) {
   i3 = i15 + 84 | 0;
   i4 = i15 + 88 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   while (1) {
    i1 = i1 + -1 | 0;
    i9 = HEAP32[i2 >> 2] | 0;
    __ZN3MBP12removeObjectEj(HEAP32[i3 >> 2] | 0, HEAP32[i5 + (i9 << 2) >> 2] | 0) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    HEAP32[i5 + (i9 << 2) >> 2] = -1;
    if (!i1) break; else i2 = i2 + 4 | 0;
   }
  }
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  if (i2 | 0) {
   i3 = i11 + 4 | 0;
   i4 = i11 + 8 | 0;
   i5 = i11 + 12 | 0;
   i6 = i11 + 16 | 0;
   i7 = i11 + 20 | 0;
   i8 = i15 + 84 | 0;
   i9 = i15 + 88 | 0;
   while (1) {
    i2 = i2 + -1 | 0;
    i17 = HEAP32[i1 >> 2] | 0;
    i18 = (HEAP32[i10 + (i17 << 2) >> 2] | 0) == 0;
    HEAP32[i11 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) >> 2] | 0) >>> 1;
    HEAP32[i3 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) + 4 >> 2] | 0) >>> 1;
    HEAP32[i4 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) + 8 >> 2] | 0) >>> 1;
    HEAP32[i5 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) + 12 >> 2] | 0) >>> 1;
    HEAP32[i6 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) + 16 >> 2] | 0) >>> 1;
    HEAP32[i7 >> 2] = (HEAP32[i13 + (i17 * 24 | 0) + 20 >> 2] | 0) >>> 1;
    i18 = __ZN3MBP9addObjectERK5IAABBjb(HEAP32[i8 >> 2] | 0, i11, i17, i18) | 0;
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i17 << 2) >> 2] = i18;
    if (!i2) break; else i1 = i1 + 4 | 0;
   }
  }
 }
 i2 = HEAP32[i12 + 8 >> 2] | 0;
 if (!i2) {
  i18 = i15 + 84 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  __ZN3MBP17prepareOverlapsMTEv(i18);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i12 + 12 >> 2] | 0;
 if (!i1) {
  i18 = i15 + 84 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  __ZN3MBP17prepareOverlapsMTEv(i18);
  STACKTOP = i16;
  return;
 }
 i3 = i14 + 4 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14 + 12 | 0;
 i6 = i14 + 16 | 0;
 i7 = i14 + 20 | 0;
 i8 = i15 + 84 | 0;
 i9 = i15 + 88 | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i18 = HEAP32[i2 >> 2] | 0;
  HEAP32[i14 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) >> 2] | 0) >>> 1;
  HEAP32[i3 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) + 4 >> 2] | 0) >>> 1;
  HEAP32[i4 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) + 8 >> 2] | 0) >>> 1;
  HEAP32[i5 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) + 12 >> 2] | 0) >>> 1;
  HEAP32[i6 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) + 16 >> 2] | 0) >>> 1;
  HEAP32[i7 >> 2] = (HEAP32[i13 + (i18 * 24 | 0) + 20 >> 2] | 0) >>> 1;
  __ZN3MBP12updateObjectEjRK5IAABB(HEAP32[i8 >> 2] | 0, HEAP32[(HEAP32[i9 >> 2] | 0) + (i18 << 2) >> 2] | 0, i14) | 0;
  if (!i1) break; else i2 = i2 + 4 | 0;
 }
 i18 = i15 + 84 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 __ZN3MBP17prepareOverlapsMTEv(i18);
 STACKTOP = i16;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i2 = i17 + 48 | 0;
 __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_(i17, i17 + 24 | 0, i2, i1) | 0;
 i1 = i17 + 72 | 0;
 if ((i1 | 0) == (i18 | 0)) return; else i16 = i1;
 while (1) {
  i14 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i15 = i14;
  i9 = i1;
  do if (i14 >>> 0 < i1 >>> 0) {
   i4 = i16 + 8 | 0;
   i13 = i4;
   i3 = i2 + 8 | 0;
   i1 = i3;
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i19 = 9;
  } else if (i1 >>> 0 >= i14 >>> 0) {
   i4 = i16 + 8 | 0;
   i7 = i4;
   i5 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = i2 + 8 | 0;
   i8 = i1;
   i6 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   if ((i5 | 0) == (i6 | 0) & (i7 | 0) == (i8 | 0)) {
    i12 = i16 + 16 | 0;
    i10 = HEAP32[i12 + 4 >> 2] | 0;
    i13 = i2 + 16 | 0;
    i11 = HEAP32[i13 + 4 >> 2] | 0;
    if (i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) {
     i3 = i1;
     i12 = i5;
     i13 = i7;
     i6 = i5;
     i1 = i7;
     i19 = 9;
     break;
    } else break;
   } else if (i7 >>> 0 < i8 >>> 0 | (i7 | 0) == (i8 | 0) & i5 >>> 0 < i6 >>> 0) {
    i3 = i1;
    i12 = i5;
    i13 = i7;
    i1 = i8;
    i19 = 9;
    break;
   } else break;
  } while (0);
  if ((i19 | 0) == 9) {
   i19 = 0;
   i5 = i16 + 16 | 0;
   i11 = i5;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   HEAP32[i16 >> 2] = i9;
   i7 = i4;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i7 + 4 >> 2] = i1;
   i1 = i2 + 16 | 0;
   i7 = i1;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i5;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   L14 : do if ((i2 | 0) != (i17 | 0)) {
    i6 = i3;
    i8 = i2;
    while (1) {
     i2 = i8 + -24 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     i7 = i3;
     do if (i14 >>> 0 < i3 >>> 0) {
      i3 = i8 + -16 | 0;
      i1 = i3;
      i4 = HEAP32[i1 >> 2] | 0;
      i1 = HEAP32[i1 + 4 >> 2] | 0;
     } else {
      if (i3 >>> 0 < i14 >>> 0) {
       i3 = i6;
       i2 = i8;
       break L14;
      }
      i3 = i8 + -16 | 0;
      i5 = i3;
      i4 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if ((i12 | 0) == (i4 | 0) & (i13 | 0) == (i5 | 0)) {
       i9 = i8 + -8 | 0;
       i5 = HEAP32[i9 + 4 >> 2] | 0;
       if (i11 >>> 0 < i5 >>> 0 | ((i11 | 0) == (i5 | 0) ? i10 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0 : 0)) {
        i4 = i12;
        i1 = i13;
        break;
       } else {
        i3 = i6;
        i2 = i8;
        break L14;
       }
      } else if (i13 >>> 0 < i5 >>> 0 | (i13 | 0) == (i5 | 0) & i12 >>> 0 < i4 >>> 0) {
       i1 = i5;
       break;
      } else {
       i3 = i6;
       i2 = i8;
       break L14;
      }
     } while (0);
     HEAP32[i8 >> 2] = i7;
     i6 = i8 + 8 | 0;
     HEAP32[i6 >> 2] = i4;
     HEAP32[i6 + 4 >> 2] = i1;
     i1 = i8 + -8 | 0;
     i6 = i1;
     i7 = HEAP32[i6 + 4 >> 2] | 0;
     i9 = i8 + 16 | 0;
     HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i9 + 4 >> 2] = i7;
     if ((i2 | 0) == (i17 | 0)) break; else {
      i6 = i3;
      i8 = i2;
     }
    }
   } while (0);
   HEAP32[i2 >> 2] = i15;
   i15 = i3;
   HEAP32[i15 >> 2] = i12;
   HEAP32[i15 + 4 >> 2] = i13;
   i15 = i1;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i15 + 4 >> 2] = i11;
  }
  i1 = i16 + 24 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i2 = i16;
   i16 = i1;
  }
 }
 return;
}

function __ZN15SharedLightData7PrecalcEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i9 = i11 + 92 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i3 = HEAP32[i3 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 9;
   }
  }
  if ((i10 | 0) == 7) i10 = 9;
  if ((i10 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
  i1 = (i1 | 0) != 0 & 1;
 }
 HEAP8[i11 + 84 >> 0] = i1;
 i1 = i11 + 44 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 20 >> 2]));
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 24 >> 2]));
 f7 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 28 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 32 >> 2]));
 do if (!(f2 <= Math_fround(.0404499993))) {
  if (f2 < Math_fround(1.0)) {
   f6 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f2 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f2, 2.20000005));
 } else f6 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
 do if (!(f5 <= Math_fround(.0404499993))) {
  if (f5 < Math_fround(1.0)) {
   f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
 } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
 do if (!(f7 <= Math_fround(.0404499993))) {
  if (f7 < Math_fround(1.0)) {
   f2 = Math_fround(+Math_pow(+Math_fround(Math_fround(f7 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f7 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f7, 2.20000005));
 } else f2 = Math_fround(f7 / Math_fround(12.9200001)); while (0);
 HEAPF32[i11 + 188 >> 2] = f6;
 HEAPF32[i11 + 192 >> 2] = f5;
 HEAPF32[i11 + 196 >> 2] = f2;
 HEAPF32[i11 + 200 >> 2] = f8;
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i11 + 60 >> 2]) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f8 = Math_fround(+Math_cos(+f7));
 HEAPF32[i11 + 68 >> 2] = Math_fround(f8 / Math_fround(+Math_sin(+f7)));
 HEAPF32[i11 + 72 >> 2] = Math_fround(Math_fround(1.0) / f8);
 __Z24CalculateVertexLightDataRK15SharedLightDataR14GfxVertexLight(i11, i11 + 124 | 0);
 f8 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 f7 = Math_fround(HEAPF32[i11 + 56 >> 2]);
 f8 = Math_fround((f8 < f7 ? f7 : f8) * Math_fround(.5));
 HEAPF32[i11 + 204 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) / Math_fround(.00499999989)) + Math_fround(-1.0)))) * f8);
 STACKTOP = i12;
 return;
}

function __ZN12GraphicsCapsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i10 = i1 + 12 | 0;
 HEAP32[i10 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i8 = i1 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = i1 + 28 | 0;
 HEAP32[i9 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i7 = i1 + 44 | 0;
 HEAP32[i7 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i1 + 60 | 0;
 HEAP32[i5 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN16GraphicsCapsGLESC2Ev(i1 + 540 | 0);
 _memset(i1 | 0, 0, 736) | 0;
 HEAP32[i10 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i5 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 240 | 0;
 i3 = i1 + 171 | 0;
 i4 = i3 + 85 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i2 >> 0] = 1;
 HEAP8[i1 + 242 >> 0] = 1;
 i3 = i1 + 256 | 0;
 i4 = i3 + 23 | 0;
 do {
  HEAP8[i3 >> 0] = 1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 476 >> 0] = 1;
 HEAP8[i1 + 477 >> 0] = 1;
 HEAP8[i1 + 478 >> 0] = 1;
 HEAP32[i1 + 88 >> 2] = 20;
 HEAP32[i1 + 96 >> 2] = 4;
 HEAPF32[i1 + 100 >> 2] = Math_fround(16.0);
 HEAP8[i1 + 105 >> 0] = 0;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP32[i1 + 112 >> 2] = 1;
 HEAP32[i1 + 120 >> 2] = 8;
 HEAP32[i1 + 116 >> 2] = 4;
 HEAP32[i1 + 124 >> 2] = 256;
 HEAP32[i1 + 128 >> 2] = 64;
 HEAP32[i1 + 132 >> 2] = 128;
 HEAP32[i1 + 136 >> 2] = 1;
 HEAP32[i1 + 140 >> 2] = 1;
 HEAP8[i1 + 144 >> 0] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 484 >> 2] = 0;
 HEAP32[i1 + 488 >> 2] = 0;
 HEAP8[i1 + 492 >> 0] = 0;
 HEAP8[i1 + 496 >> 0] = 1;
 HEAP8[i1 + 500 >> 0] = 1;
 HEAP8[i1 + 168 >> 0] = 1;
 HEAP8[i1 + 510 >> 0] = 1;
 HEAP8[i1 + 502 >> 0] = 1;
 HEAP8[i1 + 507 >> 0] = 1;
 HEAP8[i1 + 503 >> 0] = 1;
 HEAP32[i1 + 524 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 2;
 HEAP8[i1 + 158 >> 0] = 0;
 _memset(i1 + 280 | 0, -1, 196) | 0;
 return;
}

function __ZNK6Camera18WorldToScreenPointERK8Vector3fPb(i8, i3, i9, i13) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 88 | 0;
 i5 = i14 + 80 | 0;
 i10 = i14 + 64 | 0;
 i11 = i14;
 __ZL19GetCameraTargetRectRK6Camerab(i4, i3, 1);
 f18 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 872 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f18 = Math_fround(f18 * f20);
 f17 = Math_fround(f17 * f20);
 f16 = Math_fround(f16 * f19);
 f15 = Math_fround(f15 * f19);
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f18 = Math_fround(f18 + f22);
 f16 = Math_fround(f16 + f21);
 f17 = Math_fround(f17 + f18);
 f15 = Math_fround(f15 + f16);
 f20 = Math_fround(f20 + f22);
 f19 = Math_fround(f19 + f21);
 f18 = f18 < f22 ? f22 : f18;
 f16 = f16 < f21 ? f21 : f16;
 f17 = Math_fround((f17 > f20 ? f20 : f17) - f18);
 i2 = f17 < Math_fround(0.0);
 f17 = i2 ? Math_fround(0.0) : f17;
 f15 = Math_fround((f15 > f19 ? f19 : f15) - f16);
 i2 = f15 < Math_fround(0.0);
 f15 = i2 ? Math_fround(0.0) : f15;
 f19 = Math_fround(f18 + Math_fround(.5));
 i2 = f19 >= Math_fround(0.0);
 f20 = Math_fround(f19 + Math_fround(-.99999994));
 i2 = ~~(i2 ? f19 : f20);
 HEAP32[i10 >> 2] = i2;
 f20 = Math_fround(f16 + Math_fround(.5));
 i1 = f20 >= Math_fround(0.0);
 f19 = Math_fround(f20 + Math_fround(-.99999994));
 i1 = ~~(i1 ? f20 : f19);
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = (~~Math_fround(Math_fround(f18 + f17) + Math_fround(.5)) >>> 0) - i2;
 HEAP32[i10 + 12 >> 2] = (~~Math_fround(Math_fround(f16 + f15) + Math_fround(.5)) >>> 0) - i1;
 i1 = i3 + 36 | 0;
 i2 = i3 + 1076 | 0;
 if (HEAP8[i2 >> 0] | 0) if (HEAP8[i3 + 1080 >> 0] | 0) {
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i1, i4) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i1, i4) | 0;
  HEAP8[i2 >> 0] = 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i1, i11) | 0;
 i7 = __ZNK6Camera20GetWorldToClipMatrixEv(i3) | 0;
 i6 = i3 + 744 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 10; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 } while (0);
 i1 = __Z13CameraProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i9, i11, i7, i10, i8, 0) | 0;
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 HEAP8[i13 >> 0] = i1 & 1;
 STACKTOP = i14;
 return;
}

function __ZN9Heightmap13SetResolutionEi(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = ((i1 | 0) / 17 | 0) + -1 | 0;
 i1 = i1 >>> 16 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = (i1 >>> 1 | i1) + 1 | 0;
 i2 = i1 >>> 0 > 65535;
 i1 = i2 ? i1 >>> 16 : i1;
 i2 = i2 ? 16 : 0;
 i7 = (i1 & 65280 | 0) == 0;
 i1 = i7 ? i1 : i1 >>> 8;
 i2 = i7 ? i2 : i2 | 8;
 i7 = (i1 & 240 | 0) == 0;
 i2 = (HEAP8[(i7 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) + (i7 ? i2 : i2 | 4) | 0;
 i7 = i9 + 80 | 0;
 i2 = (i2 | 0) > 1 ? i2 : 1;
 HEAP32[i7 >> 2] = i2;
 i2 = (16 << i2) + 1 | 0;
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i9 + 72 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i9 + 4 | 0;
 i6 = i9 + 20 | 0;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9 + 8 | 0);
  HEAP32[i5 >> 2] = 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i4 = i2;
  i1 = i2;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i1 = Math_imul(i4, i1) | 0;
 HEAP16[i8 >> 1] = 0;
 __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy(i5, i1, i8, 1);
 i5 = i9 + 24 | 0;
 i1 = i9 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9 + 28 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i1 = 1 << i4;
  i2 = 0;
  i3 = 0;
  while (1) {
   i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i1 = i1 >> 1;
  }
  i1 = i2 + 1 | 0;
 } else i1 = 1;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i5, i1, i8, 1);
 i5 = i9 + 44 | 0;
 i1 = i9 + 60 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9 + 48 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i1 = 1 << i4;
  i2 = 0;
  i3 = 0;
  while (1) {
   i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i1 = i1 >> 1;
  }
  i1 = (i2 << 1) + 2 | 0;
 } else i1 = 2;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i5, i1, i8, 1);
 i2 = i9 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i1 = i8 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 1;
  HEAPF32[i8 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAP16[i8 + 28 >> 1] = 0;
  if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i9, i8) | 0) {
   i7 = __Z11GetIPhysicsv() | 0;
   HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 64 >> 2] | 0, i7 | 0, i8 | 0) | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
  }
 }
 i1 = HEAP32[i9 + 68 >> 2] | 0;
 i3 = i9 + 64 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  i9 = HEAP32[i9 >> 2] | 0;
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i9, 1);
  STACKTOP = i10;
  return;
 }
 do {
  i8 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, 0);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i9 = HEAP32[i9 >> 2] | 0;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i9, 1);
 STACKTOP = i10;
 return;
}

function __ZN5physx12NpBatchQuery5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheEf(i14, i23, i24, i25, f22, i11, i17, i3, i12, i10, f1) {
 i14 = i14 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 f22 = Math_fround(f22);
 i11 = i11 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i26 + 40 | 0;
 i18 = i26 + 32 | 0;
 i15 = i26 + 24 | 0;
 i9 = i26;
 i20 = i26 + 48 | 0;
 i2 = i14 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 >= (HEAP32[i14 + 120 >> 2] | 0) >>> 0) {
  STACKTOP = i26;
  return;
 }
 i21 = i14 + 40 | 0;
 if ((__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i21, -1, 0) | 0) == 1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 581, gb + 687757 | 0, i26 + 16 | 0);
  STACKTOP = i26;
  return;
 }
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i7 = HEAP16[i17 >> 1] | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i8 = HEAP16[i3 + 16 >> 1] | 0;
 i2 = HEAP8[i3 + 18 >> 0] | 0;
 i16 = i14 + 12 | 0;
 i3 = i14 + 24 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i4 = i13 + 40 | 0;
 i5 = HEAP32[i14 + 20 >> 2] & 2147483647;
 if (i4 >>> 0 > i5 >>> 0) {
  i6 = (i4 * 3 | 0) + 256 | 0;
  if (i5 >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i16, i6);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i16, i4);
 i5 = HEAP32[i16 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + i6 >> 2] = -16;
 HEAP16[i5 + (i6 + 4) >> 1] = i7;
 i7 = i5 + (i6 + 8) | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP16[i5 + (i6 + 24) >> 1] = i8;
 HEAP8[i5 + (i6 + 26) >> 0] = i2;
 HEAP32[i5 + (i6 + 28) >> 2] = i12;
 HEAP32[i5 + (i6 + 32) >> 2] = i10;
 HEAP16[i5 + (i6 + 36) >> 1] = i11;
 HEAP8[i5 + (i6 + 38) >> 0] = 2;
 HEAP32[i3 >> 2] = i4;
 i3 = i14 + 144 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -16) i2 = i3; else i2 = (HEAP32[i16 >> 2] | 0) + i2 | 0;
 HEAP32[i2 >> 2] = i13;
 HEAP32[i3 >> 2] = i13;
 i2 = HEAP16[i17 >> 1] | 0;
 i14 = i14 + 148 | 0;
 HEAP8[i14 >> 0] = (i2 & 65535) >>> 9 & 1 | (HEAPU8[i14 >> 0] | 0);
 if ((i2 & 768) == 768) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 687683 | 0, 591, gb + 704183 | 0, i15);
  i2 = HEAP16[i17 >> 1] & -257;
  HEAP16[i17 >> 1] = i2;
 }
 if ((i2 & 528) == 528) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 687683 | 0, 597, gb + 704250 | 0, i18);
  i2 = HEAP16[i17 >> 1] & -17;
  HEAP16[i17 >> 1] = i2;
 }
 if (f1 > Math_fround(0.0) & (i2 & 256) != 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 687683 | 0, 605, gb + 704362 | 0, i19);
  f1 = Math_fround(0.0);
 }
 HEAP32[i20 >> 2] = 0;
 HEAPF32[i20 + 8 >> 2] = f22;
 HEAP32[i20 + 4 >> 2] = i25;
 HEAP32[i20 + 12 >> 2] = i23;
 HEAP32[i20 + 16 >> 2] = i24;
 HEAPF32[i20 + 20 >> 2] = f1;
 __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE(i16, i20);
 __ZN5physx6shdfnd14atomicExchangeEPVii(i21, 0) | 0;
 STACKTOP = i26;
 return;
}

function runPostSets17() {
 HEAP32[gb + 35644 >> 2] = fb + 201;
 HEAP32[gb + 35648 >> 2] = fb + 19;
 HEAP32[gb + 35652 >> 2] = fb + 135;
 HEAP32[gb + 35656 >> 2] = fb + 95;
 HEAP32[gb + 35660 >> 2] = fb + 40;
 HEAP32[gb + 35664 >> 2] = fb + 62;
 HEAP32[gb + 35668 >> 2] = fb + 28;
 HEAP32[gb + 35672 >> 2] = fb + 63;
 HEAP32[gb + 35676 >> 2] = fb + 29;
 HEAP32[gb + 35680 >> 2] = fb + 34;
 HEAP32[gb + 35684 >> 2] = fb + 228;
 HEAP32[gb + 35688 >> 2] = fb + 229;
 HEAP32[gb + 35692 >> 2] = fb + 230;
 HEAP32[gb + 35696 >> 2] = fb + 231;
 HEAP32[gb + 35700 >> 2] = fb + 232;
 HEAP32[gb + 35704 >> 2] = fb + 233;
 HEAP32[gb + 35708 >> 2] = fb + 36;
 HEAP32[gb + 35712 >> 2] = fb + 96;
 HEAP32[gb + 35716 >> 2] = fb + 81;
 HEAP32[gb + 35720 >> 2] = fb + 82;
 HEAP32[gb + 35732 >> 2] = fb + 202;
 HEAP32[gb + 35736 >> 2] = fb + 203;
 HEAP32[gb + 35748 >> 2] = (HEAP32[gb + 35748 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 35752 >> 2] = (HEAP32[gb + 35752 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 35812 >> 2] = fb + 204;
 HEAP32[gb + 35816 >> 2] = fb + 205;
 HEAP32[gb + 35820 >> 2] = fb + 206;
 HEAP32[gb + 35832 >> 2] = fb + 207;
 HEAP32[gb + 35836 >> 2] = fb + 208;
 HEAP32[gb + 35840 >> 2] = fb + 136;
 HEAP32[gb + 35852 >> 2] = fb + 209;
 HEAP32[gb + 35856 >> 2] = fb + 210;
 HEAP32[gb + 35860 >> 2] = fb + 38;
 HEAP32[gb + 35864 >> 2] = fb + 145;
 HEAP32[gb + 35868 >> 2] = fb + 16;
 HEAP32[gb + 35872 >> 2] = fb + 93;
 HEAP32[gb + 35876 >> 2] = fb + 40;
 HEAP32[gb + 35880 >> 2] = fb + 19;
 HEAP32[gb + 35884 >> 2] = fb + 137;
 HEAP32[gb + 35888 >> 2] = fb + 103;
 HEAP32[gb + 35892 >> 2] = fb + 101;
 HEAP32[gb + 35896 >> 2] = fb + 62;
 HEAP32[gb + 35900 >> 2] = fb + 28;
 HEAP32[gb + 35904 >> 2] = fb + 63;
 HEAP32[gb + 35908 >> 2] = fb + 29;
 HEAP32[gb + 35912 >> 2] = fb + 34;
 HEAP32[gb + 35916 >> 2] = fb + 234;
 HEAP32[gb + 35920 >> 2] = fb + 235;
 HEAP32[gb + 35924 >> 2] = fb + 236;
 HEAP32[gb + 35928 >> 2] = fb + 237;
 HEAP32[gb + 35932 >> 2] = fb + 238;
 HEAP32[gb + 35936 >> 2] = fb + 239;
 HEAP32[gb + 35940 >> 2] = fb + 36;
 HEAP32[gb + 35944 >> 2] = fb + 104;
 HEAP32[gb + 35948 >> 2] = fb + 108;
 HEAP32[gb + 35952 >> 2] = fb + 94;
 HEAP32[gb + 35956 >> 2] = fb + 130;
 HEAP32[gb + 35960 >> 2] = fb + 112;
 HEAP32[gb + 35964 >> 2] = fb + 113;
 HEAP32[gb + 35968 >> 2] = fb + 131;
 HEAP32[gb + 35972 >> 2] = fb + 111;
 HEAP32[gb + 35976 >> 2] = fb + 112;
 HEAP32[gb + 35980 >> 2] = fb + 113;
 HEAP32[gb + 35984 >> 2] = fb + 211;
 HEAP32[gb + 35988 >> 2] = fb + 212;
 HEAP32[gb + 36288 >> 2] = fb + 213;
 HEAP32[gb + 36292 >> 2] = fb + 214;
 HEAP32[gb + 36296 >> 2] = fb + 38;
 HEAP32[gb + 36300 >> 2] = fb + 145;
 HEAP32[gb + 36304 >> 2] = fb + 16;
 HEAP32[gb + 36308 >> 2] = fb + 93;
 HEAP32[gb + 36312 >> 2] = fb + 40;
 HEAP32[gb + 36316 >> 2] = fb + 19;
 HEAP32[gb + 36320 >> 2] = fb + 138;
 HEAP32[gb + 36324 >> 2] = fb + 103;
 HEAP32[gb + 36328 >> 2] = fb + 101;
 HEAP32[gb + 36332 >> 2] = fb + 62;
 HEAP32[gb + 36336 >> 2] = fb + 28;
 HEAP32[gb + 36340 >> 2] = fb + 63;
 HEAP32[gb + 36344 >> 2] = fb + 29;
 HEAP32[gb + 36348 >> 2] = fb + 34;
 HEAP32[gb + 36352 >> 2] = fb + 146;
 HEAP32[gb + 36356 >> 2] = fb + 147;
 HEAP32[gb + 36360 >> 2] = fb + 148;
 HEAP32[gb + 36364 >> 2] = fb + 149;
 HEAP32[gb + 36368 >> 2] = fb + 150;
 HEAP32[gb + 36372 >> 2] = fb + 151;
 HEAP32[gb + 36376 >> 2] = fb + 36;
 HEAP32[gb + 36380 >> 2] = fb + 104;
 HEAP32[gb + 36384 >> 2] = fb + 108;
 HEAP32[gb + 36388 >> 2] = fb + 94;
 HEAP32[gb + 36392 >> 2] = fb + 130;
 HEAP32[gb + 36396 >> 2] = fb + 112;
 HEAP32[gb + 36400 >> 2] = fb + 113;
 HEAP32[gb + 36404 >> 2] = fb + 131;
 HEAP32[gb + 36408 >> 2] = fb + 111;
 HEAP32[gb + 36412 >> 2] = fb + 112;
 HEAP32[gb + 36416 >> 2] = fb + 113;
 HEAP32[gb + 36420 >> 2] = fb + 215;
 HEAP32[gb + 36424 >> 2] = fb + 216;
 runPostSets18();
}

function __ZNK5physx2Gu5Facet15getClosestPointEPKNS_6shdfnd3aos5Vec3VES6_RS4_S7_(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, i36 = 0, i37 = 0;
 i37 = HEAP8[i5 + 35 >> 0] | 0;
 f18 = Math_fround(HEAPF32[i1 + (i37 << 4) >> 2]);
 f16 = Math_fround(HEAPF32[i1 + (i37 << 4) + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + (i37 << 4) + 8 >> 2]);
 i36 = HEAP8[i5 + 36 >> 0] | 0;
 f21 = Math_fround(HEAPF32[i1 + (i36 << 4) >> 2]);
 f25 = Math_fround(HEAPF32[i1 + (i36 << 4) + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + (i36 << 4) + 8 >> 2]);
 i5 = HEAP8[i5 + 37 >> 0] | 0;
 f19 = Math_fround(HEAPF32[i1 + (i5 << 4) >> 2]);
 f24 = Math_fround(HEAPF32[i1 + (i5 << 4) + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + (i5 << 4) + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + (i37 << 4) >> 2]);
 f14 = Math_fround(HEAPF32[i2 + (i37 << 4) + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + (i37 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + (i36 << 4) >> 2]);
 f13 = Math_fround(HEAPF32[i2 + (i36 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + (i36 << 4) + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + (i5 << 4) >> 2]);
 f7 = Math_fround(HEAPF32[i2 + (i5 << 4) + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + (i5 << 4) + 8 >> 2]);
 f33 = Math_fround(f18 - f10);
 f31 = Math_fround(f16 - f14);
 f29 = Math_fround(f15 - f12);
 f35 = Math_fround(Math_fround(f21 - f9) - f33);
 f34 = Math_fround(Math_fround(f25 - f13) - f31);
 f28 = Math_fround(Math_fround(f23 - f11) - f29);
 f32 = Math_fround(Math_fround(f19 - f8) - f33);
 f30 = Math_fround(Math_fround(f24 - f7) - f31);
 f17 = Math_fround(Math_fround(f22 - f6) - f29);
 f26 = Math_fround(Math_fround(Math_fround(f35 * f35) + Math_fround(f34 * f34)) + Math_fround(f28 * f28));
 f27 = Math_fround(Math_fround(Math_fround(f35 * f32) + Math_fround(f34 * f30)) + Math_fround(f28 * f17));
 f20 = Math_fround(Math_fround(Math_fround(f32 * f32) + Math_fround(f30 * f30)) + Math_fround(f17 * f17));
 f28 = Math_fround(Math_fround(Math_fround(f33 * f35) + Math_fround(f31 * f34)) + Math_fround(f29 * f28));
 f17 = Math_fround(Math_fround(Math_fround(f33 * f32) + Math_fround(f31 * f30)) + Math_fround(f29 * f17));
 f29 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f26 * f20) - Math_fround(f27 * f27)));
 f20 = Math_fround(f29 * Math_fround(Math_fround(f17 * f27) - Math_fround(f28 * f20)));
 f17 = Math_fround(f29 * Math_fround(Math_fround(f28 * f27) - Math_fround(f26 * f17)));
 f9 = Math_fround(Math_fround(f9 - f10) * f20);
 f13 = Math_fround(Math_fround(f13 - f14) * f20);
 f11 = Math_fround(Math_fround(f11 - f12) * f20);
 f8 = Math_fround(Math_fround(f8 - f10) * f17);
 f7 = Math_fround(Math_fround(f7 - f14) * f17);
 f6 = Math_fround(Math_fround(f6 - f12) * f17);
 f16 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f25 - f16) * f20) + Math_fround(Math_fround(f24 - f16) * f17)));
 f15 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f23 - f15) * f20) + Math_fround(Math_fround(f22 - f15) * f17)));
 HEAPF32[i3 >> 2] = Math_fround(f18 + Math_fround(Math_fround(Math_fround(f21 - f18) * f20) + Math_fround(Math_fround(f19 - f18) * f17)));
 HEAPF32[i3 + 4 >> 2] = f16;
 HEAPF32[i3 + 8 >> 2] = f15;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f14 + Math_fround(f13 + f7));
 f6 = Math_fround(f12 + Math_fround(f11 + f6));
 HEAPF32[i4 >> 2] = Math_fround(f10 + Math_fround(f9 + f8));
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformEb(i8, i1, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i8) | 0;
 i5 = i8 + 48 | 0;
 i6 = i8 + 284 | 0;
 i2 = (HEAP32[i6 >> 2] & 512 | 0) == 0 ? i8 + 112 | 0 : (HEAP32[i8 + 56 >> 2] | 0) + 144 | 0;
 f20 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 f23 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f22 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f21 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f20 * f21);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f16 * f19));
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f13 * f17));
 f12 = Math_fround(Math_fround(f21 * f10) + Math_fround(Math_fround(f20 * f22) + Math_fround(f23 * Math_fround(Math_fround(f13 * f19) - Math_fround(f16 * f17)))));
 f11 = Math_fround(Math_fround(f19 * f10) + Math_fround(Math_fround(f16 * f22) + Math_fround(f23 * Math_fround(Math_fround(f20 * f17) - Math_fround(f13 * f21)))));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f22) + Math_fround(f23 * Math_fround(Math_fround(f16 * f21) - Math_fround(f20 * f19)))) + Math_fround(f17 * f10));
 f12 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f12);
 f11 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f11);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f10);
 f20 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(f23 * f20);
 f22 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f21 * f22));
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f16 + Math_fround(f19 * f13));
 f18 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(f16 - Math_fround(f17 * f18));
 f15 = Math_fround(Math_fround(Math_fround(f17 * f20) + Math_fround(Math_fround(f19 * f22) + Math_fround(f23 * f18))) - Math_fround(f21 * f13));
 f14 = Math_fround(Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f17 * f22) + Math_fround(f23 * f13))) - Math_fround(f19 * f20));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f19 * f18)) - Math_fround(f17 * f13));
 HEAPF32[i3 >> 2] = f16;
 HEAPF32[i3 + 4 >> 2] = f15;
 HEAPF32[i3 + 8 >> 2] = f14;
 HEAPF32[i3 + 12 >> 2] = f13;
 HEAPF32[i3 + 16 >> 2] = f12;
 HEAPF32[i3 + 20 >> 2] = f11;
 HEAPF32[i3 + 24 >> 2] = f10;
 HEAPF32[i8 + 224 >> 2] = f16;
 HEAPF32[i8 + 228 >> 2] = f15;
 HEAPF32[i8 + 232 >> 2] = f14;
 HEAPF32[i8 + 236 >> 2] = f13;
 HEAPF32[i8 + 240 >> 2] = f12;
 HEAPF32[i8 + 244 >> 2] = f11;
 HEAPF32[i8 + 248 >> 2] = f10;
 switch ((HEAP32[i8 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = 5;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i1 + 2433 >> 0] | 0)) i2 = 4; else i2 = 5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i8 + 64 | 0, i3); else if ((i2 | 0) == 5) {
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -524289;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i5);
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 262144;
 }
 if ((i4 | 0) == 0 | i7 ^ 1) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx14NpArticulation14wakeUpInternalEbb(HEAP32[i8 + 288 >> 2] | 0, 0, 1);
 STACKTOP = i9;
 return;
}

function __ZN12AudioManager15GetProfilerDataER10AudioStats(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 200 | 0;
 i10 = i14 + 196 | 0;
 i11 = i14 + 192 | 0;
 i12 = i14;
 i13 = i2 + 88 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i6 = HEAP32[gb + 1460024 >> 2] | 0;
 HEAP32[i8 >> 2] = i6;
 i4 = HEAP32[i2 + 48 >> 2] | 0;
 i7 = i2 + 44 | 0;
 i5 = i4;
 if ((i5 | 0) == (i7 | 0)) {
  i3 = 0;
  i2 = i6;
 } else {
  i3 = 0;
  i2 = i4;
  i1 = i5;
  do {
   i6 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i3 = ((__ZNK11AudioSource9IsPlayingEv(HEAP32[i6 + 8 >> 2] | 0) | 0) & 1) + i3 | 0;
   i1 = i2;
  } while ((i1 | 0) != (i7 | 0));
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i2 - i3;
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 1459900 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 1460032 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 1459908 >> 2];
 HEAP32[i8 + 76 >> 2] = HEAP32[gb + 1459944 >> 2];
 __ZN4FMOD6System18getChannelsPlayingEPi(i1, i8 + 72 | 0) | 0;
 __ZN4FMOD6System11getCPUUsageEPfS1_S1_S1_S1_(HEAP32[i13 >> 2] | 0, i9, i10, 0, 0, i11) | 0;
 f18 = Math_fround(Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(10.0)) + Math_fround(.5));
 i4 = f18 >= Math_fround(0.0);
 f17 = Math_fround(f18 + Math_fround(-.99999994));
 i4 = ~~(i4 ? f18 : f17);
 HEAP32[i8 + 80 >> 2] = i4;
 f17 = Math_fround(Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(10.0)) + Math_fround(.5));
 i3 = f17 >= Math_fround(0.0);
 f18 = Math_fround(f17 + Math_fround(-.99999994));
 i3 = ~~(i3 ? f17 : f18);
 HEAP32[i8 + 84 >> 2] = i3;
 f18 = Math_fround(Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(10.0)) + Math_fround(.5));
 i5 = f18 >= Math_fround(0.0);
 f17 = Math_fround(f18 + Math_fround(-.99999994));
 i5 = ~~(i5 ? f18 : f17);
 HEAP32[i8 + 88 >> 2] = i5;
 HEAP32[i8 + 92 >> 2] = i4 - i3 - i5;
 __ZN4FMOD6System13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(HEAP32[i13 >> 2] | 0, -1, 0, 0, i12) | 0;
 i5 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63368 | 0) | 0;
 i3 = i8 + 100 | 0;
 HEAP32[i3 >> 2] = i5;
 i4 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63376 | 0) | 0;
 i2 = i8 + 104 | 0;
 HEAP32[i2 >> 2] = i4;
 i6 = (HEAP32[i12 + 24 >> 2] | 0) + (HEAP32[i12 + 20 >> 2] | 0) | 0;
 HEAP32[i8 + 108 >> 2] = i6;
 i7 = (HEAP32[i12 + 52 >> 2] | 0) + (HEAP32[i12 + 56 >> 2] | 0) | 0;
 HEAP32[i8 + 112 >> 2] = i7;
 i9 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63384 | 0) | 0;
 i1 = i8 + 116 | 0;
 HEAP32[i1 >> 2] = i9;
 i10 = (HEAP32[i12 + 60 >> 2] | 0) + (HEAP32[i12 + 28 >> 2] | 0) | 0;
 HEAP32[i8 + 120 >> 2] = i10;
 i11 = HEAP32[i12 + 68 >> 2] | 0;
 HEAP32[i8 + 124 >> 2] = i11;
 i12 = HEAP32[i12 + 72 >> 2] | 0;
 HEAP32[i8 + 128 >> 2] = i12;
 i13 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63336 | 0) | 0;
 i16 = i8 + 132 | 0;
 HEAP32[i16 >> 2] = i13;
 i15 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63328 | 0) | 0;
 i15 = (HEAP32[i16 >> 2] | 0) + i15 | 0;
 i15 = i15 + (__ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63360 | 0) | 0) | 0;
 i3 = i15 + (HEAP32[i1 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i8 + 96 >> 2] = i3;
 HEAP32[i8 + 136 >> 2] = i3 - (i4 + i5 + i6 + i7 + i9 + i10 + i11 + i12 + i13);
 STACKTOP = i14;
 return;
}

function __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = i7 + 80 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800780 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800793 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 88 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800723 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 89 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 738044 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN18ColorBySpeedModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 416 | 0;
 i7 = i9;
 if ((HEAP16[gb + 1452316 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452316 | 0, i2);
  i3 = gb + 1452316 | 0;
 } else i3 = 0;
 __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i2, i4 + 164 | 0);
 i8 = i4 + 8 | 0;
 __ZN14MinMaxGradient19InitializeOptimizedER23OptimizedMinMaxGradient(i8, i7);
 L4 : do switch (HEAP16[i4 + 160 >> 1] | 0) {
 case 1:
  {
   i1 = (HEAP32[i4 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i4 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   }
  }
 case 3:
  {
   i1 = (HEAP32[i4 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i4 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   }
  }
 default:
  {
   i1 = (HEAP32[i4 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i4 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f(i5, i6, i8, i7, i2);
    break L4;
   }
  }
 } while (0);
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i9;
 return;
}

function __ZN11TypeManager21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(i3, i1, i13, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 12 | 0;
 i12 = i14;
 HEAP32[i11 >> 2] = i1;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i12, i3 + 120 | 0, i11);
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 if ((i1 | 0) == ((HEAP32[i3 + 148 >> 2] | 0) + (HEAP32[i3 + 152 >> 2] << 3) | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i7 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i11 = i1 + i7 | 0;
 i12 = i13 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i10;
  break;
 } while (0);
 i1 = i7 >>> 0 < i11 >>> 0;
 if (!i4) {
  if (!i1) {
   STACKTOP = i14;
   return;
  }
  i8 = i3 + 44 | 0;
  i9 = i13 + 12 | 0;
  i10 = i13 + 4 | 0;
  i1 = i7;
  i4 = HEAP32[i9 >> 2] | 0;
  do {
   i3 = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 + (i1 << 2) >> 2] | 0) + 16 >> 2] | 0;
   i5 = i4;
   i4 = i4 + 1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i4;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  STACKTOP = i14;
  return;
 }
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i8 = i3 + 44 | 0;
 i9 = i13 + 12 | 0;
 i10 = i13 + 4 | 0;
 do {
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 4 + (i7 << 2) >> 2] | 0;
  if (!(HEAP8[i1 + 32 >> 0] | 0)) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i12 >> 2] = i1;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i1;
     HEAP32[i13 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i4;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i11 | 0));
 STACKTOP = i14;
 return;
}

function __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERKS1_(i12, i1, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP32[i12 >> 2] = i1;
 i1 = i12 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i11 + 4 >> 2];
 i6 = i12 + 8 | 0;
 i7 = i12 + 20 | 0;
 i8 = i12 + 232 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i12 + 248 >> 2] = 1;
 __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE(i12 + 252 | 0, i11 + 252 | 0);
 i8 = i12 + 272 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i2 = i12 + 308 | 0;
 i3 = i12 + 332 | 0;
 i4 = i12 + 344 | 0;
 i5 = i11 + 344 | 0;
 i9 = i2;
 i10 = i9 + 36 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE(i4, i5);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 356 | 0, i11 + 356 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 368 | 0, i11 + 368 | 0);
 HEAP32[i12 + 380 >> 2] = 0;
 HEAP32[i12 + 384 >> 2] = 0;
 HEAP32[i12 + 388 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 392 | 0, i11 + 392 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 404 | 0, i11 + 404 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4copyIS3_EEvRKNS1_IS2_T_EE(i12 + 416 | 0, i11 + 416 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4copyIS3_EEvRKNS1_IS2_T_EE(i12 + 428 | 0, i11 + 428 | 0);
 __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE4copyIS5_EEvRKNS1_IS4_T_EE(i12 + 452 | 0, i11 + 452 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 464 | 0, i11 + 464 | 0);
 HEAP32[i12 + 476 >> 2] = HEAP32[i11 + 476 >> 2];
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE4copyIS2_EEvRKNS1_IjT_EE(i12 + 488 | 0, i11 + 488 | 0);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i12 + 500 | 0, i11 + 500 | 0);
 __ZN5physx5cloth4copyINS0_7SwClothES2_EEvRT_RKT0_(i12, i11);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i6, i11 + 8 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i7, i11 + 20 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i8, i11 + 272 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i12 + 284 | 0, i11 + 284 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i2, i11 + 308 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i12 + 320 | 0, i11 + 320 | 0);
 __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i3, i11 + 332 | 0);
 i12 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP16[i12 >> 1] = (HEAP16[i12 >> 1] | 0) + 1 << 16 >> 16;
 return;
}

function _tre_set_union(i13, i9, i14, i10, i11) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = (i10 | 0) == 0;
 if (i12) i8 = 0; else {
  i1 = 0;
  while (1) if ((HEAP32[i10 + (i1 << 2) >> 2] | 0) > -1) i1 = i1 + 1 | 0; else {
   i8 = i1;
   break;
  }
 }
 i2 = 0;
 while (1) if ((HEAP32[i9 + (i2 << 5) >> 2] | 0) > -1) i2 = i2 + 1 | 0; else {
  i1 = 0;
  break;
 }
 while (1) if ((HEAP32[i14 + (i1 << 5) >> 2] | 0) > -1) i1 = i1 + 1 | 0; else break;
 i1 = ___tre_mem_alloc_impl(i13, 0, 0, 1, (i1 + i2 << 5) + 32 | 0) | 0;
 L10 : do if (!i1) i1 = 0; else {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i7 = (i8 | 0) > 0;
   i3 = 0;
   while (1) {
    HEAP32[i1 + (i3 << 5) >> 2] = i2;
    HEAP32[i1 + (i3 << 5) + 4 >> 2] = HEAP32[i9 + (i3 << 5) + 4 >> 2];
    HEAP32[i1 + (i3 << 5) + 8 >> 2] = HEAP32[i9 + (i3 << 5) + 8 >> 2];
    HEAP32[i1 + (i3 << 5) + 16 >> 2] = HEAP32[i9 + (i3 << 5) + 16 >> 2] | i11;
    HEAP32[i1 + (i3 << 5) + 20 >> 2] = HEAP32[i9 + (i3 << 5) + 20 >> 2];
    HEAP32[i1 + (i3 << 5) + 24 >> 2] = HEAP32[i9 + (i3 << 5) + 24 >> 2];
    HEAP32[i1 + (i3 << 5) + 28 >> 2] = HEAP32[i9 + (i3 << 5) + 28 >> 2];
    i5 = i9 + (i3 << 5) + 12 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i2 = (i4 | 0) == 0;
    if (i12 & i2) HEAP32[i1 + (i3 << 5) + 12 >> 2] = 0; else {
     if (i2) i2 = 0; else {
      i2 = 0;
      while (1) if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) > -1) i2 = i2 + 1 | 0; else break;
     }
     i6 = ___tre_mem_alloc_impl(i13, 0, 0, 0, (i2 + i8 << 2) + 4 | 0) | 0;
     if (!i6) {
      i1 = 0;
      break L10;
     }
     if ((i2 | 0) > 0) {
      i5 = HEAP32[i5 >> 2] | 0;
      i4 = 0;
      do {
       HEAP32[i6 + (i4 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i2 | 0));
     } else i2 = 0;
     if (i7) {
      i4 = 0;
      do {
       HEAP32[i6 + (i4 + i2 << 2) >> 2] = HEAP32[i10 + (i4 << 2) >> 2];
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i8 | 0));
      i4 = i8;
     } else i4 = 0;
     HEAP32[i6 + (i4 + i2 << 2) >> 2] = -1;
     HEAP32[i1 + (i3 << 5) + 12 >> 2] = i6;
    }
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i9 + (i3 << 5) >> 2] | 0;
    if ((i2 | 0) <= -1) {
     i8 = i3;
     break;
    }
   }
  } else i8 = 0;
  i3 = HEAP32[i14 >> 2] | 0;
  i2 = i1 + (i8 << 5) | 0;
  if ((i3 | 0) > -1) {
   i7 = 0;
   i6 = i8;
   do {
    HEAP32[i2 >> 2] = i3;
    HEAP32[i1 + (i6 << 5) + 4 >> 2] = HEAP32[i14 + (i7 << 5) + 4 >> 2];
    HEAP32[i1 + (i6 << 5) + 8 >> 2] = HEAP32[i14 + (i7 << 5) + 8 >> 2];
    HEAP32[i1 + (i6 << 5) + 16 >> 2] = HEAP32[i14 + (i7 << 5) + 16 >> 2];
    HEAP32[i1 + (i6 << 5) + 20 >> 2] = HEAP32[i14 + (i7 << 5) + 20 >> 2];
    HEAP32[i1 + (i6 << 5) + 24 >> 2] = HEAP32[i14 + (i7 << 5) + 24 >> 2];
    HEAP32[i1 + (i6 << 5) + 28 >> 2] = HEAP32[i14 + (i7 << 5) + 28 >> 2];
    i4 = i14 + (i7 << 5) + 12 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) HEAP32[i1 + (i6 << 5) + 12 >> 2] = 0; else {
     i2 = 0;
     while (1) if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) > -1) i2 = i2 + 1 | 0; else break;
     i5 = ___tre_mem_alloc_impl(i13, 0, 0, 0, (i2 << 2) + 4 | 0) | 0;
     if (!i5) {
      i1 = 0;
      break L10;
     }
     if ((i2 | 0) > 0) {
      i4 = HEAP32[i4 >> 2] | 0;
      i3 = 0;
      do {
       HEAP32[i5 + (i3 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i2 | 0));
     } else i2 = 0;
     HEAP32[i5 + (i2 << 2) >> 2] = -1;
     HEAP32[i1 + (i6 << 5) + 12 >> 2] = i5;
    }
    i7 = i7 + 1 | 0;
    i3 = HEAP32[i14 + (i7 << 5) >> 2] | 0;
    i6 = i7 + i8 | 0;
    i2 = i1 + (i6 << 5) | 0;
   } while ((i3 | 0) > -1);
  }
  HEAP32[i2 >> 2] = -1;
 } while (0);
 return i1 | 0;
}

function __ZN5physx10PxsContext30secondPassUpdateContactManagerEfPNS_25NarrowPhaseContactManagerEjPNS_10PxBaseTaskE(i18, f16, i15, i17, i9) {
 i18 = i18 | 0;
 f16 = Math_fround(f16);
 i15 = i15 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0, i20 = 0;
 i5 = i18 + 1348 | 0;
 _memset(HEAP32[i18 + 1344 >> 2] | 0, 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 HEAP32[i18 + 1356 >> 2] = 0;
 HEAP32[i18 + 1360 >> 2] = 0;
 HEAP32[i18 + 1364 >> 2] = 0;
 i8 = i18 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl5flushEv(HEAP32[i8 >> 2] | 0) | 0;
 i6 = (i1 | 0) == 0;
 if (i6) {
  i2 = i1;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i1;
 }
 i7 = i18 + 5916 | 0;
 L4 : while (1) {
  i4 = (i2 | 0) == 0;
  while (1) {
   if (!i3) break L4;
   __ZN5physx16PxsThreadContext5resetEjj(i3, HEAP32[i7 >> 2] << 5, HEAP32[i5 >> 2] << 5);
   if (i4) i3 = 0; else break;
  }
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 if (!i6) do {
  i14 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i8 >> 2] | 0, i14);
 } while ((i1 | 0) != 0);
 HEAP32[i18 + 6944 >> 2] = 1;
 i1 = i18 + 6940 | 0;
 HEAP32[i1 >> 2] = i9;
 if (i9 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0);
  HEAP32[i18 + 6936 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 i12 = i18 + 6900 | 0;
 i13 = i18 + 6928 | 0;
 HEAP32[i18 + 6916 >> 2] = 1;
 i14 = i18 + 6912 | 0;
 HEAP32[i14 >> 2] = i13;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0);
 HEAP32[i18 + 6908 >> 2] = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2];
 HEAP32[i18 + 1372 >> 2] = 0;
 HEAP32[i18 + 1384 >> 2] = 0;
 HEAP32[i18 + 1396 >> 2] = 0;
 HEAP32[i18 + 1408 >> 2] = 0;
 HEAP32[i18 + 1420 >> 2] = 0;
 HEAP32[i18 + 1432 >> 2] = 0;
 if (!i17) {
  i19 = HEAP32[i12 >> 2] | 0;
  i19 = i19 + 20 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  mftCall_vi(i19 | 0, i12 | 0);
  return;
 }
 i13 = i18 + 6960 | 0;
 i14 = ~i17;
 i1 = 0;
 do {
  i8 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
  i11 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i8, 160, 16) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
  HEAP16[i11 + 4 >> 1] = -1;
  HEAP16[i11 + 6 >> 1] = 0;
  i8 = i11 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i11 >> 2] = gb + 87404 + 8;
  i9 = i11 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i11 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i7 = i11 + 148 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAPF32[i11 + 152 >> 2] = f16;
  HEAP32[i11 + 156 >> 2] = i18;
  i2 = i11 + 20 | 0;
  i3 = i2 + 128 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i11 >> 2] = gb + 105764 + 8;
  i6 = i17 - i1 | 0;
  i6 = i6 >>> 0 > 32 ? 32 : i6;
  if (!i6) {
   i1 = i6 + i1 | 0;
   i19 = 22;
  } else {
   i4 = i1 + i14 | 0;
   i4 = i4 >>> 0 > 4294967263 ? ~i4 : 32;
   i2 = 0;
   i5 = 0;
   do {
    i3 = HEAP32[i15 + (i5 + i1 << 3) >> 2] | 0;
    if (i3) {
     i20 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 >> 2] = i20 + 1;
     HEAP32[i11 + 20 + (i20 << 2) >> 2] = i3;
     i2 = i2 + 1 | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i4 | 0));
   i1 = i6 + i1 | 0;
   if (!i2) i19 = 22; else {
    HEAP32[i10 >> 2] = 1;
    HEAP32[i9 >> 2] = i12;
    mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0);
    HEAP32[i8 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0);
   }
  }
  if ((i19 | 0) == 22) {
   i19 = 0;
   mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0, i11 | 0);
  }
 } while (i1 >>> 0 < i17 >>> 0);
 i20 = HEAP32[i12 >> 2] | 0;
 i20 = i20 + 20 | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 mftCall_vi(i20 | 0, i12 | 0);
 return;
}
function __ZN19RingbufferTemplates22WriteValueToRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RKT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i2 + 20 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i1 = i1 >>> 0 < 12 ? i1 : 12;
 i6 = i2 + 28 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i7 + 24 | 0;
 i11 = HEAP32[i7 + 16 >> 2] | 0;
 i10 = i11 - (HEAP32[i4 >> 2] | 0) + (HEAP32[i7 + 20 >> 2] | 0) | 0;
 i4 = i11 + -1 & HEAP32[i4 >> 2];
 i11 = i11 - i4 | 0;
 i10 = i11 >>> 0 < i10 >>> 0 ? i11 : i10;
 i1 = i10 >>> 0 < i1 >>> 0 ? i10 : i1;
 switch (i1 | 0) {
 case 12:
  {
   i11 = (HEAP32[i7 >> 2] | 0) + i4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i11 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 12;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
   i11 = HEAP32[i6 >> 2] | 0;
   if (((HEAP32[i11 + 16 >> 2] | 0) - (HEAP32[i11 + 24 >> 2] | 0) | 0) != (0 - (HEAP32[i11 + 20 >> 2] | 0) | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i7 = __Znwj(32) | 0;
   i3 = i2 + 8 | 0;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i11 = i2 + 16 | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i10 = i8;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = i5;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = 0;
   i4 = 1 << 31 - (Math_clz32((i4 << 1) + -1 | 0) | 0);
   i10 = i7 + 16 | 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i8, 0, gb + 584872 | 0, 112) | 0;
   HEAP8[i7 + 4 >> 0] = 1;
   i4 = i8;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i8 = i7 + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = i5;
   HEAP32[i7 + 28 >> 2] = 0;
   HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] = i7;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 case 0:
  {
   i11 = 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 default:
  {
   i11 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
   i11 = HEAP32[i6 >> 2] | 0;
   if (((HEAP32[i11 + 16 >> 2] | 0) - (HEAP32[i11 + 24 >> 2] | 0) | 0) == (0 - (HEAP32[i11 + 20 >> 2] | 0) | 0)) if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
    i7 = __Znwj(32) | 0;
    i1 = i2 + 8 | 0;
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    i11 = i2 + 16 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i10 = i8;
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = i5;
    HEAP32[i7 + 20 >> 2] = 0;
    HEAP32[i7 + 24 >> 2] = 0;
    i4 = 1 << 31 - (Math_clz32((i4 << 1) + -1 | 0) | 0);
    i10 = i7 + 16 | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i8, 0, gb + 584872 | 0, 112) | 0;
    HEAP8[i7 + 4 >> 0] = 1;
    i4 = i8;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i8 = i7 + 8 | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i8 + 4 >> 2] = i5;
    HEAP32[i7 + 28 >> 2] = 0;
    HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] = i7;
    HEAP32[i6 >> 2] = i7;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
   }
   i11 = __ZN19RingbufferTemplates22WriteValueToRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RKT_(i2, i3) | 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZN13AnimationClip8TransferI17RemapPPtrTransferEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 1744 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i11, i12);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 i1 = HEAP32[i11 + 164 >> 2] | 0;
 i5 = HEAP32[i11 + 168 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i6 = i12 + 16 | 0;
  i7 = i12 + 36 | 0;
  i4 = i12 + 40 | 0;
  do {
   i2 = i1 + 36 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   if (HEAP8[i4 >> 0] | 0) HEAP32[i2 >> 2] = i3;
   i1 = i1 + 132 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 i1 = HEAP32[i11 + 180 >> 2] | 0;
 i9 = HEAP32[i11 + 184 >> 2] | 0;
 if ((i1 | 0) != (i9 | 0)) {
  i6 = i12 + 16 | 0;
  i7 = i12 + 36 | 0;
  i8 = i12 + 40 | 0;
  do {
   i2 = HEAP32[i1 + 40 >> 2] | 0;
   i4 = HEAP32[i1 + 52 >> 2] | 0;
   i5 = i2 + (i4 << 3) | 0;
   if (i4 | 0) do {
    i3 = i2 + 4 | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
    if (HEAP8[i8 >> 0] | 0) HEAP32[i3 >> 2] = i4;
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i5 | 0));
   i2 = i1 + 36 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   if (HEAP8[i8 >> 0] | 0) HEAP32[i2 >> 2] = i3;
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 HEAP32[i12 + 4 >> 2] = i11 + 56;
 __ZN7mecanim5human9HumanPoseC2Ev(i10);
 i1 = HEAP32[i11 + 224 >> 2] | 0;
 i10 = HEAP32[i11 + 236 >> 2] | 0;
 i4 = i1 + (i10 << 4) | 0;
 if (i10 | 0) {
  i5 = i12 + 16 | 0;
  i6 = i12 + 36 | 0;
  i7 = i12 + 40 | 0;
  do {
   i2 = i1 + 8 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i7 >> 0] | 0) HEAP32[i2 >> 2] = i3;
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i11 + 244 >> 2] | 0;
 i10 = HEAP32[i11 + 256 >> 2] | 0;
 i3 = i1 + (i10 << 2) | 0;
 if (i10 | 0) {
  i4 = i12 + 16 | 0;
  i5 = i12 + 36 | 0;
  i6 = i12 + 40 | 0;
  do {
   i2 = HEAP32[i4 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i12, 1);
 i1 = HEAP32[i11 + 196 >> 2] | 0;
 i7 = HEAP32[i11 + 200 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
  STACKTOP = i13;
  return;
 }
 i4 = i12 + 16 | 0;
 i5 = i12 + 36 | 0;
 i6 = i12 + 40 | 0;
 do {
  i2 = i1 + 36 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (HEAP8[i6 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i7 | 0));
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i12);
 STACKTOP = i13;
 return;
}

function __Z26SkinVerticesGenericMathLibILi4ELb1ELb1EEvPKhiiiiPhiPKvS4_(i1, i4, i14, i17, i18, i2, i19, i20, i21) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 if ((i4 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i5 = i22 + 4 | 0;
 i6 = i22 + 8 | 0;
 i7 = i22 + 16 | 0;
 i8 = i22 + 20 | 0;
 i9 = i22 + 24 | 0;
 i10 = i22 + 32 | 0;
 i11 = i22 + 36 | 0;
 i12 = i22 + 40 | 0;
 i13 = i22 + 48 | 0;
 i15 = i22 + 52 | 0;
 i16 = i22 + 56 | 0;
 i3 = 0;
 while (1) {
  __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, i20, i21, i3);
  f28 = Math_fround(HEAPF32[i1 >> 2]);
  f37 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i24 = HEAP32[i1 + 12 >> 2] | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f27 = Math_fround(f28 * f44);
  f42 = Math_fround(HEAPF32[i5 >> 2]);
  f35 = Math_fround(f28 * f42);
  f40 = Math_fround(HEAPF32[i6 >> 2]);
  f28 = Math_fround(f28 * f40);
  f43 = Math_fround(HEAPF32[i7 >> 2]);
  f30 = Math_fround(f37 * f43);
  f41 = Math_fround(HEAPF32[i8 >> 2]);
  f39 = Math_fround(f37 * f41);
  f38 = Math_fround(HEAPF32[i9 >> 2]);
  f30 = Math_fround(f27 + f30);
  f39 = Math_fround(f35 + f39);
  f37 = Math_fround(f28 + Math_fround(f37 * f38));
  f28 = Math_fround(HEAPF32[i10 >> 2]);
  f35 = Math_fround(f33 * f28);
  f27 = Math_fround(HEAPF32[i11 >> 2]);
  f34 = Math_fround(f33 * f27);
  f36 = Math_fround(HEAPF32[i12 >> 2]);
  f35 = Math_fround(f30 + f35);
  f34 = Math_fround(f39 + f34);
  f33 = Math_fround(f37 + Math_fround(f33 * f36));
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i13 >> 2]));
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i15 >> 2]));
  f33 = Math_fround(f33 + Math_fround(HEAPF32[i16 >> 2]));
  i29 = i1 + i14 | 0;
  f37 = Math_fround(HEAPF32[i29 >> 2]);
  f39 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i29 = HEAP32[i29 + 12 >> 2] | 0;
  f32 = Math_fround(Math_fround(Math_fround(f44 * f37) + Math_fround(f43 * f39)) + Math_fround(f28 * f30));
  f31 = Math_fround(Math_fround(Math_fround(f42 * f37) + Math_fround(f41 * f39)) + Math_fround(f27 * f30));
  f30 = Math_fround(Math_fround(Math_fround(f40 * f37) + Math_fround(f38 * f39)) + Math_fround(f36 * f30));
  i25 = i1 + i17 | 0;
  f39 = Math_fround(HEAPF32[i25 >> 2]);
  f37 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  i25 = HEAP32[i25 + 12 >> 2] | 0;
  f28 = Math_fround(Math_fround(Math_fround(f44 * f39) + Math_fround(f43 * f37)) + Math_fround(f28 * f26));
  f27 = Math_fround(Math_fround(Math_fround(f42 * f39) + Math_fround(f41 * f37)) + Math_fround(f27 * f26));
  f26 = Math_fround(Math_fround(Math_fround(f40 * f39) + Math_fround(f38 * f37)) + Math_fround(f36 * f26));
  HEAPF32[i2 >> 2] = f35;
  HEAPF32[i2 + 4 >> 2] = f34;
  HEAPF32[i2 + 8 >> 2] = f33;
  HEAP32[i2 + 12 >> 2] = i24;
  i24 = i2 + i14 | 0;
  HEAPF32[i24 >> 2] = f32;
  HEAPF32[i24 + 4 >> 2] = f31;
  HEAPF32[i24 + 8 >> 2] = f30;
  HEAP32[i24 + 12 >> 2] = i29;
  i24 = i2 + i17 | 0;
  HEAPF32[i24 >> 2] = f28;
  HEAPF32[i24 + 4 >> 2] = f27;
  HEAPF32[i24 + 8 >> 2] = f26;
  HEAP32[i24 + 12 >> 2] = i25;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + i18 | 0;
   i2 = i2 + i19 | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function __Z26SkinVerticesGenericMathLibILi2ELb1ELb1EEvPKhiiiiPhiPKvS4_(i1, i4, i14, i17, i18, i2, i19, i20, i21) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 if ((i4 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i5 = i22 + 4 | 0;
 i6 = i22 + 8 | 0;
 i7 = i22 + 16 | 0;
 i8 = i22 + 20 | 0;
 i9 = i22 + 24 | 0;
 i10 = i22 + 32 | 0;
 i11 = i22 + 36 | 0;
 i12 = i22 + 40 | 0;
 i13 = i22 + 48 | 0;
 i15 = i22 + 52 | 0;
 i16 = i22 + 56 | 0;
 i3 = 0;
 while (1) {
  __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i22, i20, i21, i3);
  f28 = Math_fround(HEAPF32[i1 >> 2]);
  f37 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f33 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i24 = HEAP32[i1 + 12 >> 2] | 0;
  f44 = Math_fround(HEAPF32[i22 >> 2]);
  f27 = Math_fround(f28 * f44);
  f42 = Math_fround(HEAPF32[i5 >> 2]);
  f35 = Math_fround(f28 * f42);
  f40 = Math_fround(HEAPF32[i6 >> 2]);
  f28 = Math_fround(f28 * f40);
  f43 = Math_fround(HEAPF32[i7 >> 2]);
  f30 = Math_fround(f37 * f43);
  f41 = Math_fround(HEAPF32[i8 >> 2]);
  f39 = Math_fround(f37 * f41);
  f38 = Math_fround(HEAPF32[i9 >> 2]);
  f30 = Math_fround(f27 + f30);
  f39 = Math_fround(f35 + f39);
  f37 = Math_fround(f28 + Math_fround(f37 * f38));
  f28 = Math_fround(HEAPF32[i10 >> 2]);
  f35 = Math_fround(f33 * f28);
  f27 = Math_fround(HEAPF32[i11 >> 2]);
  f34 = Math_fround(f33 * f27);
  f36 = Math_fround(HEAPF32[i12 >> 2]);
  f35 = Math_fround(f30 + f35);
  f34 = Math_fround(f39 + f34);
  f33 = Math_fround(f37 + Math_fround(f33 * f36));
  f35 = Math_fround(f35 + Math_fround(HEAPF32[i13 >> 2]));
  f34 = Math_fround(f34 + Math_fround(HEAPF32[i15 >> 2]));
  f33 = Math_fround(f33 + Math_fround(HEAPF32[i16 >> 2]));
  i29 = i1 + i14 | 0;
  f37 = Math_fround(HEAPF32[i29 >> 2]);
  f39 = Math_fround(HEAPF32[i29 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i29 + 8 >> 2]);
  i29 = HEAP32[i29 + 12 >> 2] | 0;
  f32 = Math_fround(Math_fround(Math_fround(f44 * f37) + Math_fround(f43 * f39)) + Math_fround(f28 * f30));
  f31 = Math_fround(Math_fround(Math_fround(f42 * f37) + Math_fround(f41 * f39)) + Math_fround(f27 * f30));
  f30 = Math_fround(Math_fround(Math_fround(f40 * f37) + Math_fround(f38 * f39)) + Math_fround(f36 * f30));
  i25 = i1 + i17 | 0;
  f39 = Math_fround(HEAPF32[i25 >> 2]);
  f37 = Math_fround(HEAPF32[i25 + 4 >> 2]);
  f26 = Math_fround(HEAPF32[i25 + 8 >> 2]);
  i25 = HEAP32[i25 + 12 >> 2] | 0;
  f28 = Math_fround(Math_fround(Math_fround(f44 * f39) + Math_fround(f43 * f37)) + Math_fround(f28 * f26));
  f27 = Math_fround(Math_fround(Math_fround(f42 * f39) + Math_fround(f41 * f37)) + Math_fround(f27 * f26));
  f26 = Math_fround(Math_fround(Math_fround(f40 * f39) + Math_fround(f38 * f37)) + Math_fround(f36 * f26));
  HEAPF32[i2 >> 2] = f35;
  HEAPF32[i2 + 4 >> 2] = f34;
  HEAPF32[i2 + 8 >> 2] = f33;
  HEAP32[i2 + 12 >> 2] = i24;
  i24 = i2 + i14 | 0;
  HEAPF32[i24 >> 2] = f32;
  HEAPF32[i24 + 4 >> 2] = f31;
  HEAPF32[i24 + 8 >> 2] = f30;
  HEAP32[i24 + 12 >> 2] = i29;
  i24 = i2 + i17 | 0;
  HEAPF32[i24 >> 2] = f28;
  HEAPF32[i24 + 4 >> 2] = f27;
  HEAPF32[i24 + 8 >> 2] = f26;
  HEAP32[i24 + 12 >> 2] = i25;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + i18 | 0;
   i2 = i2 + i19 | 0;
  }
 }
 STACKTOP = i23;
 return;
}

function runPostSets39() {
 HEAP32[gb + 57300 >> 2] = fb + 544;
 HEAP32[gb + 57304 >> 2] = fb + 545;
 HEAP32[gb + 57308 >> 2] = fb + 546;
 HEAP32[gb + 57340 >> 2] = fb + 547;
 HEAP32[gb + 57392 >> 2] = fb + 548;
 HEAP32[gb + 57444 >> 2] = fb + 549;
 HEAP32[gb + 57452 >> 2] = fb + 550;
 HEAP32[gb + 57496 >> 2] = fb + 551;
 HEAP32[gb + 57504 >> 2] = fb + 552;
 HEAP32[gb + 57548 >> 2] = fb + 553;
 HEAP32[gb + 57556 >> 2] = fb + 554;
 HEAP32[gb + 57572 >> 2] = fb + 555;
 HEAP32[gb + 57576 >> 2] = fb + 556;
 HEAP32[gb + 57580 >> 2] = fb + 557;
 HEAP32[gb + 57584 >> 2] = fb + 558;
 HEAP32[gb + 57588 >> 2] = fb + 559;
 HEAP32[gb + 57592 >> 2] = fb + 560;
 HEAP32[gb + 57596 >> 2] = fb + 561;
 HEAP32[gb + 57600 >> 2] = fb + 562;
 HEAP32[gb + 57604 >> 2] = fb + 563;
 HEAP32[gb + 57608 >> 2] = fb + 564;
 HEAP32[gb + 57612 >> 2] = fb + 565;
 HEAP32[gb + 57616 >> 2] = fb + 566;
 HEAP32[gb + 57620 >> 2] = fb + 567;
 HEAP32[gb + 57624 >> 2] = fb + 568;
 HEAP32[gb + 57628 >> 2] = fb + 569;
 HEAP32[gb + 57632 >> 2] = fb + 570;
 HEAP32[gb + 57636 >> 2] = fb + 571;
 HEAP32[gb + 57640 >> 2] = fb + 572;
 HEAP32[gb + 57644 >> 2] = fb + 573;
 HEAP32[gb + 57648 >> 2] = fb + 574;
 HEAP32[gb + 57656 >> 2] = fb + 575;
 HEAP32[gb + 57660 >> 2] = fb + 575;
 HEAP32[gb + 57664 >> 2] = fb + 576;
 HEAP32[gb + 57668 >> 2] = fb + 577;
 HEAP32[gb + 57676 >> 2] = fb + 578;
 HEAP32[gb + 57680 >> 2] = fb + 579;
 HEAP32[gb + 57684 >> 2] = fb + 577;
 HEAP32[gb + 57688 >> 2] = fb + 579;
 HEAP32[gb + 57692 >> 2] = fb + 578;
 HEAP32[gb + 57696 >> 2] = fb + 579;
 HEAP32[gb + 57700 >> 2] = fb + 579;
 HEAP32[gb + 57704 >> 2] = fb + 25;
 HEAP32[gb + 57708 >> 2] = fb + 26;
 HEAP32[gb + 57712 >> 2] = fb + 27;
 HEAP32[gb + 57716 >> 2] = fb + 28;
 HEAP32[gb + 57772 >> 2] = fb + 580;
 HEAP32[gb + 57776 >> 2] = fb + 581;
 HEAP32[gb + 57780 >> 2] = fb + 38;
 HEAP32[gb + 57784 >> 2] = fb + 439;
 HEAP32[gb + 57788 >> 2] = fb + 16;
 HEAP32[gb + 57792 >> 2] = fb + 582;
 HEAP32[gb + 57796 >> 2] = fb + 583;
 HEAP32[gb + 57800 >> 2] = fb + 584;
 HEAP32[gb + 57804 >> 2] = fb + 263;
 HEAP32[gb + 57808 >> 2] = fb + 103;
 HEAP32[gb + 57812 >> 2] = fb + 101;
 HEAP32[gb + 57816 >> 2] = fb + 62;
 HEAP32[gb + 57820 >> 2] = fb + 28;
 HEAP32[gb + 57824 >> 2] = fb + 63;
 HEAP32[gb + 57828 >> 2] = fb + 29;
 HEAP32[gb + 57832 >> 2] = fb + 34;
 HEAP32[gb + 57836 >> 2] = fb + 440;
 HEAP32[gb + 57840 >> 2] = fb + 441;
 HEAP32[gb + 57844 >> 2] = fb + 442;
 HEAP32[gb + 57848 >> 2] = fb + 443;
 HEAP32[gb + 57852 >> 2] = fb + 444;
 HEAP32[gb + 57856 >> 2] = fb + 445;
 HEAP32[gb + 57860 >> 2] = fb + 36;
 HEAP32[gb + 57864 >> 2] = fb + 104;
 HEAP32[gb + 57868 >> 2] = fb + 108;
 HEAP32[gb + 57872 >> 2] = fb + 94;
 HEAP32[gb + 57876 >> 2] = fb + 446;
 HEAP32[gb + 57880 >> 2] = fb + 264;
 HEAP32[gb + 57884 >> 2] = fb + 265;
 HEAP32[gb + 57888 >> 2] = fb + 447;
 HEAP32[gb + 57892 >> 2] = (HEAP32[gb + 57892 >> 2] | 0) + (gb + 425530 | 0);
 HEAP32[gb + 57896 >> 2] = (HEAP32[gb + 57896 >> 2] | 0) + (gb + 425542 | 0);
 HEAP32[gb + 57908 >> 2] = fb + 585;
 HEAP32[gb + 57912 >> 2] = fb + 586;
 HEAP32[gb + 57916 >> 2] = fb + 4;
 HEAP32[gb + 57920 >> 2] = fb + 29;
 HEAP32[gb + 57924 >> 2] = fb + 5;
 HEAP32[gb + 57928 >> 2] = fb + 448;
 HEAP32[gb + 57932 >> 2] = fb + 34;
 HEAP32[gb + 57936 >> 2] = fb + 1;
 HEAP32[gb + 57940 >> 2] = fb + 1;
 HEAP32[gb + 57944 >> 2] = fb + 1;
 HEAP32[gb + 57948 >> 2] = fb + 1;
 HEAP32[gb + 57960 >> 2] = fb + 587;
 HEAP32[gb + 57964 >> 2] = fb + 588;
 HEAP32[gb + 57968 >> 2] = fb + 4;
 HEAP32[gb + 57972 >> 2] = fb + 29;
 HEAP32[gb + 57976 >> 2] = fb + 5;
 HEAP32[gb + 57980 >> 2] = fb + 449;
 HEAP32[gb + 57984 >> 2] = fb + 35;
 HEAP32[gb + 57988 >> 2] = fb + 36;
 HEAP32[gb + 57992 >> 2] = fb + 37;
 HEAP32[gb + 57996 >> 2] = fb + 6;
 HEAP32[gb + 58e3 >> 2] = fb + 30;
 runPostSets40();
}

function __ZN9ShaderLab18SerializedPropertyaSERKS0_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = (i9 | 0) == (i10 | 0);
 if (!i8) {
  i5 = HEAP8[i10 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i10 >> 2] | 0 : i10;
  i5 = i3 ? HEAP32[i10 + 4 >> 2] | 0 : i5 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
  } else {
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
   if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
   HEAP8[i1 + i5 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i9 + 4 >> 2] = i5;
    break;
   } else {
    HEAP8[i3 >> 0] = i5;
    break;
   }
  } while (0);
  i1 = i9 + 16 | 0;
  i6 = i10 + 16 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i10 + 20 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  do if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  } else {
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i9 + 20 >> 2] = i7;
    break;
   } else {
    HEAP8[i4 >> 0] = i7;
    break;
   }
  } while (0);
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i9 + 32 | 0, HEAP32[i10 + 32 >> 2] | 0, HEAP32[i10 + 36 >> 2] | 0);
 }
 i7 = i9 + 44 | 0;
 i1 = i10 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i7 = i9 + 68 | 0;
 i1 = i10 + 68 | 0;
 if (i8) {
  i8 = i10 + 84 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i9 + 84 | 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 }
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i10 + 72 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i9 + 76 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i9 + 72 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  i8 = i10 + 84 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i9 + 84 | 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i9 + 72 >> 2] = i6;
  i8 = i10 + 84 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i9 + 84 | 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 } else {
  HEAP8[i3 >> 0] = i6;
  i8 = i10 + 84 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i9 + 84 | 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 }
 return 0;
}

function __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i5 = HEAP32[i2 + 72 + (HEAP32[gb + 179492 + (i4 << 4) + 8 >> 2] << 2) >> 2] | 0;
 if ((i4 | 0) < 2) {
  i13 = HEAP32[i2 + 72 + (HEAP32[gb + 179492 + (i4 << 4) + 12 >> 2] << 2) >> 2] | 0;
  i4 = i3 + 4 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i3 = i2 + 40 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i12 = i3 + 16 | 0;
  i3 = i3 + 4 | 0;
  i3 = HEAP32[i3 + (HEAP32[i3 >> 2] | 0) + (i13 << 3) + 4 >> 2] | 0;
  i12 = i12 + (HEAP32[i12 >> 2] | 0) | 0;
  f16 = Math_fround(HEAPF32[i12 + (i3 * 76 | 0) + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i12 + (i3 * 76 | 0) + 20 >> 2]);
  f18 = Math_fround(HEAPF32[i12 + (i3 * 76 | 0) + 24 >> 2]);
  f8 = Math_fround(HEAPF32[i12 + (i3 * 76 | 0) + 28 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + (i13 * 40 | 0) + 16 >> 2]);
  f6 = Math_fround(f16 * f10);
  f9 = Math_fround(HEAPF32[i4 + (i13 * 40 | 0) + 24 >> 2]);
  f11 = Math_fround(f8 * f9);
  f15 = Math_fround(HEAPF32[i4 + (i13 * 40 | 0) + 20 >> 2]);
  f7 = Math_fround(f14 * f15);
  f17 = Math_fround(HEAPF32[i4 + (i13 * 40 | 0) + 12 >> 2]);
  f6 = Math_fround(Math_fround(Math_fround(f6 - Math_fround(f18 * f9)) - Math_fround(f8 * f15)) - Math_fround(f14 * f17));
  f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f16 * f17)) - Math_fround(f18 * f15)) - Math_fround(f14 * f10));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f18 * f10)) - Math_fround(f16 * f9)) - Math_fround(f8 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f9)) - Math_fround(f8 * f10));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i12 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f10 = (HEAP32[tempDoublePtr >> 2] = i13 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f10 * f10);
  f6 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(f6 * f6);
  f9 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9)) + Math_fround(f7 + f8)))));
  f10 = Math_fround(f8 * f10);
  f6 = Math_fround(f8 * f6);
  f9 = Math_fround(f8 * f9);
  f11 = Math_fround(f8 * f11);
  f8 = Math_fround(Math_fround(f10 * f6) - Math_fround(f11 * f9));
  f7 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(-.5)) + Math_fround(f6 * f6));
  f6 = Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f6));
  f8 = Math_fround(f8 + f8);
  f7 = Math_fround(f7 + f7);
  f6 = Math_fround(f6 + f6);
  f9 = Math_fround(Math_fround(HEAPF32[i2 + 360 >> 2]) * Math_fround(.25));
  f8 = Math_fround(f9 * f8);
  f7 = Math_fround(f9 * f7);
  f6 = Math_fround(f9 * f6);
  f9 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) >> 2]);
  f10 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 4 >> 2]);
  f7 = Math_fround(f10 - f7);
  f6 = Math_fround(Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 8 >> 2]) - f6);
  HEAPF32[i1 >> 2] = Math_fround(f9 - f8);
  HEAPF32[i1 + 4 >> 2] = f7;
  HEAPF32[i1 + 8 >> 2] = f6;
  return;
 } else {
  i13 = i3 + 4 | 0;
  i13 = (HEAP32[i13 >> 2] | 0) + i13 + (i5 * 40 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  return;
 }
}

function __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0;
 i14 = HEAP32[i1 + 36 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f11 * Math_fround(HEAPF32[i14 + 4 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f7 * Math_fround(HEAPF32[i14 + 8 >> 2])));
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i14 + 16 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f11 * Math_fround(HEAPF32[i14 + 20 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i14 + 24 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i14 + 32 >> 2]));
 f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i14 + 36 >> 2])));
 f7 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i14 + 40 >> 2])));
 f11 = Math_fround(-f4);
 f12 = Math_fround(-f6);
 f13 = Math_fround(-f7);
 i14 = HEAP32[i9 + 24 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i14 >> 2]);
 f3 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f4 * f15) + Math_fround(f6 * f3)) + Math_fround(f7 * Math_fround(HEAPF32[i14 + 8 >> 2])));
 i5 = HEAP32[i9 + 16 >> 2] | 0;
 if (i5 >>> 0 > 1) {
  i1 = 0;
  i2 = 1;
  do {
   f16 = Math_fround(HEAPF32[i14 + (i2 * 20 | 0) >> 2]);
   f15 = Math_fround(HEAPF32[i14 + (i2 * 20 | 0) + 4 >> 2]);
   f15 = Math_fround(Math_fround(Math_fround(f4 * f16) + Math_fround(f6 * f15)) + Math_fround(f7 * Math_fround(HEAPF32[i14 + (i2 * 20 | 0) + 8 >> 2])));
   i10 = f3 > f15;
   f3 = i10 ? f15 : f3;
   i1 = i10 ? i2 : i1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i5 >>> 0);
  i10 = i1;
 } else i10 = 0;
 i8 = HEAP32[i9 + 20 >> 2] | 0;
 i9 = HEAP32[i9 + 36 >> 2] | 0;
 if (!i8) {
  i14 = i10;
  return i14 | 0;
 }
 f3 = Math_fround(f3 * f3);
 i1 = -1;
 i5 = 0;
 while (1) {
  i2 = i5 << 1;
  i17 = HEAPU8[i9 + i2 >> 0] | 0;
  f6 = Math_fround(HEAPF32[i14 + (i17 * 20 | 0) >> 2]);
  f4 = Math_fround(HEAPF32[i14 + (i17 * 20 | 0) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i14 + (i17 * 20 | 0) + 8 >> 2]);
  i2 = HEAPU8[i9 + (i2 | 1) >> 0] | 0;
  f7 = Math_fround(HEAPF32[i14 + (i2 * 20 | 0) >> 2]);
  f16 = Math_fround(HEAPF32[i14 + (i2 * 20 | 0) + 4 >> 2]);
  f7 = Math_fround(f6 + f7);
  f16 = Math_fround(f4 + f16);
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i14 + (i2 * 20 | 0) + 8 >> 2]));
  f4 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f16 * f16)) + Math_fround(f15 * f15));
  f15 = Math_fround(Math_fround(Math_fround(f7 * f11) + Math_fround(f16 * f12)) + Math_fround(f15 * f13));
  f16 = Math_fround(f15 * f15);
  i2 = f15 >= Math_fround(0.0) & f16 > Math_fround(f3 * f4);
  f4 = Math_fround(f16 / f4);
  i1 = i2 ? i5 : i1;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i8 | 0)) break; else f3 = i2 ? f4 : f3;
 }
 if ((i1 | 0) == -1) {
  i17 = i10;
  return i17 | 0;
 }
 i17 = i1 << 1;
 i10 = HEAPU8[i9 + i17 >> 0] | 0;
 i17 = HEAPU8[i9 + (i17 | 1) >> 0] | 0;
 f4 = Math_fround(HEAPF32[i14 + (i10 * 20 | 0) >> 2]);
 f6 = Math_fround(HEAPF32[i14 + (i10 * 20 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + (i10 * 20 | 0) + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i14 + (i17 * 20 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i14 + (i17 * 20 | 0) + 4 >> 2]);
 i14 = Math_fround(Math_fround(Math_fround(f4 * f11) + Math_fround(f6 * f12)) + Math_fround(f7 * f13)) > Math_fround(Math_fround(Math_fround(f15 * f11) + Math_fround(f16 * f12)) + Math_fround(Math_fround(HEAPF32[i14 + (i17 * 20 | 0) + 8 >> 2]) * f13));
 i17 = i14 ? i10 : i17;
 return i17 | 0;
}

function __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b(i2, i10, i14, i3, i15, i16, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, f18 = f0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 212 | 0;
 i4 = i17 + 208 | 0;
 i5 = i17 + 204 | 0;
 i6 = i17 + 200 | 0;
 i11 = i17 + 4 | 0;
 i12 = i17;
 i13 = __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0;
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 if (i1) {
  i1 = i10 + 4 | 0;
  i8 = i14 + 4 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i7;
 }
 i8 = __Z12GetGfxDevicev() | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i3, 0, -1, 0, 0);
 if (!i2) i7 = 0; else {
  HEAP32[i4 >> 2] = HEAP32[gb + 1469332 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i13, i9) | 0) {
   HEAP32[i5 >> 2] = HEAP32[gb + 1469332 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i13, i9, i2);
   HEAP32[i6 >> 2] = HEAP32[gb + 1469332 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i13, i9, gb + 62472 | 0, gb + 1162356 | 0);
   i7 = 1;
  } else i7 = 0;
 }
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i11, __Z12GetGfxDevicev() | 0);
 __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
 i2 = __ZNK8Material12GetPassCountEv(i13) | 0;
 if ((i2 | 0) > 0) {
  i3 = i10 + 4 | 0;
  i4 = i15 + 4 | 0;
  i5 = i14 + 4 | 0;
  i6 = i16 + 4 | 0;
  i1 = 0;
  do {
   i19 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i13, i1, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
   mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 580 >> 2] | 0, i8 | 0, 2, i19 | 0);
   mftCall_viffff(HEAP32[(HEAP32[i8 >> 2] | 0) + 568 >> 2] | 0, i8 | 0, 1.0, 1.0, 1.0, 1.0);
   f18 = Math_fround(HEAPF32[i10 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 572 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i3 >> 2]), 0.0);
   f18 = Math_fround(HEAPF32[i15 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 560 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i4 >> 2]), .100000001);
   f18 = Math_fround(HEAPF32[i10 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 572 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i5 >> 2]), 0.0);
   f18 = Math_fround(HEAPF32[i15 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 560 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i6 >> 2]), .100000001);
   f18 = Math_fround(HEAPF32[i14 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 572 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i5 >> 2]), 0.0);
   f18 = Math_fround(HEAPF32[i16 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 560 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i6 >> 2]), .100000001);
   f18 = Math_fround(HEAPF32[i14 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 572 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i3 >> 2]), 0.0);
   f18 = Math_fround(HEAPF32[i16 >> 2]);
   mftCall_vifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 560 >> 2] | 0, i8 | 0, +f18, +Math_fround(HEAPF32[i4 >> 2]), .100000001);
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 584 >> 2] | 0, i8 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if (i7) {
  HEAP32[i12 >> 2] = HEAP32[gb + 1469332 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i13, i9, 0);
 }
 __ZN22DeviceMVPMatricesStateD2Ev(i11);
 STACKTOP = i17;
 return;
}

function __Z21BindGenericFloatCurveRK7CurveIDRP6ObjectP10GameObjectP9TransformRPvRiRN11UnityEngine9Animation10BoundCurveE(i4, i13, i1, i14, i15, i16, i17) {
 i4 = i4 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i18 = 0, i19 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 56 | 0;
 i9 = i12 + 32 | 0;
 i10 = i12 + 16 | 0;
 i11 = i12 + 48 | 0;
 i7 = i12;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i8 = __ZN11UnityEngine9Animation31GetGenericAnimationBindingCacheEv() | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i18 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i18 = 6;
  }
 } else i18 = 4;
 if ((i18 | 0) == 4) {
  i5 = i3 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i18 = 6;
 }
 if ((i18 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i18 = 12;
 } else if (i4 >>> 0 < 11) {
  i1 = i7 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i7; else {
   i2 = i7;
   i18 = 14;
  }
 } else i18 = 12;
 if ((i18 | 0) == 12) {
  i19 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i19, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i19 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i1 = i7 + 11 | 0;
  i18 = 14;
 }
 if ((i18 | 0) == 14) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 __ZNK11UnityEngine9Animation28GenericAnimationBindingCache20CreateGenericBindingERK8UnityStri4PPtrI10MonoScriptES4_bRNS0_14GenericBindingE(i8, i10, i5, i6, i7, 0, i9);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i19 = HEAP32[i7 >> 2] | 0;
  i18 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i19, i6);
 }
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i19 = HEAP32[i10 >> 2] | 0;
  i18 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i19, i6);
 }
 if ((__ZN11UnityEngine9Animation28GenericAnimationBindingCache11BindGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(__ZN11UnityEngine9Animation31GetGenericAnimationBindingCacheEv() | 0, i9, i14, i17) | 0) == -1) {
  i19 = 0;
  STACKTOP = i12;
  return i19 | 0;
 }
 HEAP32[i13 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i17 + 4 >> 2];
 i19 = 1;
 STACKTOP = i12;
 return i19 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i4 = i11 + 12 | 0;
 i2 = i11 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843883 | 0, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i4 = HEAP32[gb + 37316 >> 2] | 0;
    i3 = 0;
    while (1) {
     i14 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i14;
     HEAP32[i2 + 12 >> 2] = i14;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i14 = i10;
     i13 = HEAP32[i14 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i3 + 4 >> 2] = i13;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     if (!(HEAP32[i12 >> 2] & 512)) {
      i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 843899 | 0, i4, i10, 1) | 0;
      if (i2 | 0) {
       if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i12, i1, 0); else {
        i2 = HEAP32[i10 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i12);
      }
     } else __Z24TransferMeshDataByteSwapI14SafeBinaryReadEvRT_R13dynamic_arrayIhLj1EE(i12, i1);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) {
   i3 = HEAP32[gb + 37316 >> 2] | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843883 | 0, i4, 1) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      if (HEAP32[i12 >> 2] & 512 | 0) {
       __Z24TransferMeshDataByteSwapI14SafeBinaryReadEvRT_R13dynamic_arrayIhLj1EE(i12, i1);
       break;
      }
      i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 843899 | 0, i3, i10, 1) | 0;
      if (i2 | 0) {
       if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i12, i1, 0); else {
        i2 = HEAP32[i10 >> 2] | 0;
        if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
       }
       __ZN14SafeBinaryRead11EndTransferEv(i12);
      }
     } else {
      i2 = HEAP32[i4 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i12);
    }
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != (i9 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL23SweepCapsuleUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i11) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, d24 = 0.0, d25 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 104 | 0;
 i19 = i12 + 92 | 0;
 i18 = i12 + 80 | 0;
 i17 = i12 + 68 | 0;
 i16 = i12 + 40 | 0;
 i15 = i12 + 28 | 0;
 i14 = i12;
 i13 = i12 + 152 | 0;
 HEAP32[i17 >> 2] = 2;
 d25 = +HEAPF64[i1 >> 3];
 d24 = +HEAPF64[i1 + 8 >> 3];
 d23 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d21 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d20 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAPF32[i17 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i16 + 16 >> 2] = Math_fround(d25 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d24 - d21);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d23 - d20);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 2;
 i1 = i15 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i19 >> 2] = Math_fround(+HEAPF64[i3 + 40 >> 3] - d22);
 HEAPF32[i19 + 4 >> 2] = Math_fround(+HEAPF64[i3 + 48 >> 3] - d21);
 HEAPF32[i19 + 8 >> 2] = Math_fround(+HEAPF64[i3 + 56 >> 3] - d20);
 HEAPF32[i18 >> 2] = Math_fround(+HEAPF64[i3 + 64 >> 3] - d22);
 HEAPF32[i18 + 4 >> 2] = Math_fround(+HEAPF64[i3 + 72 >> 3] - d21);
 HEAPF32[i18 + 8 >> 2] = Math_fround(+HEAPF64[i3 + 80 >> 3] - d20);
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 88 >> 2];
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i19, i18, i1);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP16[i10 + 12 >> 1] = 0;
 i3 = i10 + 16 | 0;
 i1 = i10 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i11 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i10, i13, Math_fround(0.0)) | 0)) {
  i19 = 0;
  STACKTOP = i12;
  return i19 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i19 = 0;
  STACKTOP = i12;
  return i19 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 36 >> 2];
 HEAP32[i11 + 40 >> 2] = -1;
 HEAP32[i11 + 44 >> 2] = -1;
 d25 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i11 >> 3] = d25 + +HEAPF64[i5 >> 3];
 d25 = +Math_fround(HEAPF32[i10 + 20 >> 2]);
 HEAPF64[i11 + 8 >> 3] = d25 + +HEAPF64[i6 >> 3];
 d25 = +Math_fround(HEAPF32[i10 + 24 >> 2]);
 HEAPF64[i11 + 16 >> 3] = d25 + +HEAPF64[i7 >> 3];
 i19 = 1;
 STACKTOP = i12;
 return i19 | 0;
}

function __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_(i36, i37, i31, i12, i1) {
 i36 = i36 | 0;
 i37 = i37 | 0;
 i31 = i31 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_(i36, i37, i31, i1) | 0;
 i13 = i31 + 40 | 0;
 if ((HEAP32[i12 + 40 >> 2] | 0) >= (HEAP32[i13 >> 2] | 0)) {
  i37 = i32;
  return i37 | 0;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 i22 = i31 + 4 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 i23 = i31 + 8 | 0;
 i3 = HEAP32[i23 >> 2] | 0;
 i24 = i31 + 12 | 0;
 i4 = HEAP32[i24 >> 2] | 0;
 i25 = i31 + 16 | 0;
 i5 = HEAP32[i25 >> 2] | 0;
 i26 = i31 + 20 | 0;
 i6 = HEAP32[i26 >> 2] | 0;
 i27 = i31 + 24 | 0;
 i7 = HEAP32[i27 >> 2] | 0;
 i28 = i31 + 28 | 0;
 i8 = HEAP32[i28 >> 2] | 0;
 i29 = i31 + 32 | 0;
 i9 = HEAP32[i29 >> 2] | 0;
 i30 = i31 + 36 | 0;
 i11 = i30;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i33 = i31;
 i34 = i12;
 i35 = i33 + 44 | 0;
 do {
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  i33 = i33 + 4 | 0;
  i34 = i34 + 4 | 0;
 } while ((i33 | 0) < (i35 | 0));
 HEAP32[i12 >> 2] = i1;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i3;
 HEAP32[i12 + 12 >> 2] = i4;
 HEAP32[i12 + 16 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i6;
 HEAP32[i12 + 24 >> 2] = i7;
 HEAP32[i12 + 28 >> 2] = i8;
 HEAP32[i12 + 32 >> 2] = i9;
 i12 = i12 + 36 | 0;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i37 + 40 | 0;
 if ((HEAP32[i13 >> 2] | 0) >= (HEAP32[i12 >> 2] | 0)) {
  i37 = i32 + 1 | 0;
  return i37 | 0;
 }
 i1 = HEAP32[i37 >> 2] | 0;
 i13 = i37 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = i37 + 8 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i15 = i37 + 12 | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i16 = i37 + 16 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i17 = i37 + 20 | 0;
 i6 = HEAP32[i17 >> 2] | 0;
 i18 = i37 + 24 | 0;
 i7 = HEAP32[i18 >> 2] | 0;
 i19 = i37 + 28 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 i20 = i37 + 32 | 0;
 i9 = HEAP32[i20 >> 2] | 0;
 i21 = i37 + 36 | 0;
 i11 = i21;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i33 = i37;
 i34 = i31;
 i35 = i33 + 44 | 0;
 do {
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  i33 = i33 + 4 | 0;
  i34 = i34 + 4 | 0;
 } while ((i33 | 0) < (i35 | 0));
 HEAP32[i31 >> 2] = i1;
 HEAP32[i22 >> 2] = i2;
 HEAP32[i23 >> 2] = i3;
 HEAP32[i24 >> 2] = i4;
 HEAP32[i25 >> 2] = i5;
 HEAP32[i26 >> 2] = i6;
 HEAP32[i27 >> 2] = i7;
 HEAP32[i28 >> 2] = i8;
 HEAP32[i29 >> 2] = i9;
 i35 = i30;
 HEAP32[i35 >> 2] = i10;
 HEAP32[i35 + 4 >> 2] = i11;
 if ((HEAP32[i12 >> 2] | 0) >= (HEAP32[i36 + 40 >> 2] | 0)) {
  i37 = i32 + 2 | 0;
  return i37 | 0;
 }
 i2 = HEAP32[i36 >> 2] | 0;
 i3 = HEAP32[i36 + 4 >> 2] | 0;
 i4 = HEAP32[i36 + 8 >> 2] | 0;
 i5 = HEAP32[i36 + 12 >> 2] | 0;
 i6 = HEAP32[i36 + 16 >> 2] | 0;
 i7 = HEAP32[i36 + 20 >> 2] | 0;
 i8 = HEAP32[i36 + 24 >> 2] | 0;
 i9 = HEAP32[i36 + 28 >> 2] | 0;
 i10 = HEAP32[i36 + 32 >> 2] | 0;
 i1 = i36 + 36 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i33 = i36;
 i34 = i37;
 i35 = i33 + 44 | 0;
 do {
  HEAP32[i33 >> 2] = HEAP32[i34 >> 2];
  i33 = i33 + 4 | 0;
  i34 = i34 + 4 | 0;
 } while ((i33 | 0) < (i35 | 0));
 HEAP32[i37 >> 2] = i2;
 HEAP32[i13 >> 2] = i3;
 HEAP32[i14 >> 2] = i4;
 HEAP32[i15 >> 2] = i5;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i17 >> 2] = i7;
 HEAP32[i18 >> 2] = i8;
 HEAP32[i19 >> 2] = i9;
 HEAP32[i20 >> 2] = i10;
 i37 = i21;
 HEAP32[i37 >> 2] = i11;
 HEAP32[i37 + 4 >> 2] = i1;
 i37 = i32 + 3 | 0;
 return i37 | 0;
}

function __ZN15SerializeTraitsI10BlendShapeE8TransferI14SafeBinaryReadEEvRS0_RT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426457 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426469 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 8 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426481 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i6 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i7 + 9 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 426492 | 0, i4, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i8 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function runPostSets15() {
 HEAP32[gb + 34728 >> 2] = fb + 182;
 HEAP32[gb + 34732 >> 2] = fb + 183;
 HEAP32[gb + 34736 >> 2] = fb + 184;
 HEAP32[gb + 34740 >> 2] = fb + 185;
 HEAP32[gb + 34744 >> 2] = fb + 36;
 HEAP32[gb + 34756 >> 2] = fb + 175;
 HEAP32[gb + 34760 >> 2] = fb + 176;
 HEAP32[gb + 34764 >> 2] = fb + 38;
 HEAP32[gb + 34768 >> 2] = fb + 100;
 HEAP32[gb + 34772 >> 2] = fb + 16;
 HEAP32[gb + 34776 >> 2] = fb + 93;
 HEAP32[gb + 34780 >> 2] = fb + 177;
 HEAP32[gb + 34784 >> 2] = fb + 19;
 HEAP32[gb + 34788 >> 2] = fb + 128;
 HEAP32[gb + 34792 >> 2] = fb + 103;
 HEAP32[gb + 34796 >> 2] = fb + 101;
 HEAP32[gb + 34800 >> 2] = fb + 62;
 HEAP32[gb + 34804 >> 2] = fb + 28;
 HEAP32[gb + 34808 >> 2] = fb + 63;
 HEAP32[gb + 34812 >> 2] = fb + 29;
 HEAP32[gb + 34816 >> 2] = fb + 34;
 HEAP32[gb + 34820 >> 2] = fb + 186;
 HEAP32[gb + 34824 >> 2] = fb + 187;
 HEAP32[gb + 34828 >> 2] = fb + 188;
 HEAP32[gb + 34832 >> 2] = fb + 189;
 HEAP32[gb + 34836 >> 2] = fb + 190;
 HEAP32[gb + 34840 >> 2] = fb + 191;
 HEAP32[gb + 34844 >> 2] = fb + 36;
 HEAP32[gb + 34848 >> 2] = fb + 104;
 HEAP32[gb + 34852 >> 2] = fb + 108;
 HEAP32[gb + 34856 >> 2] = fb + 94;
 HEAP32[gb + 34860 >> 2] = fb + 109;
 HEAP32[gb + 34864 >> 2] = fb + 105;
 HEAP32[gb + 34868 >> 2] = fb + 106;
 HEAP32[gb + 34872 >> 2] = fb + 110;
 HEAP32[gb + 34884 >> 2] = fb + 178;
 HEAP32[gb + 34888 >> 2] = fb + 179;
 HEAP32[gb + 34892 >> 2] = fb + 180;
 HEAP32[gb + 34896 >> 2] = fb + 192;
 HEAP32[gb + 34900 >> 2] = fb + 16;
 HEAP32[gb + 34904 >> 2] = fb + 39;
 HEAP32[gb + 34908 >> 2] = fb + 40;
 HEAP32[gb + 34912 >> 2] = fb + 19;
 HEAP32[gb + 34916 >> 2] = fb + 129;
 HEAP32[gb + 34920 >> 2] = fb + 31;
 HEAP32[gb + 34924 >> 2] = fb + 27;
 HEAP32[gb + 34928 >> 2] = fb + 62;
 HEAP32[gb + 34932 >> 2] = fb + 28;
 HEAP32[gb + 34936 >> 2] = fb + 63;
 HEAP32[gb + 34940 >> 2] = fb + 29;
 HEAP32[gb + 34944 >> 2] = fb + 34;
 HEAP32[gb + 34948 >> 2] = fb + 193;
 HEAP32[gb + 34952 >> 2] = fb + 194;
 HEAP32[gb + 34956 >> 2] = fb + 195;
 HEAP32[gb + 34960 >> 2] = fb + 196;
 HEAP32[gb + 34964 >> 2] = fb + 197;
 HEAP32[gb + 34968 >> 2] = fb + 198;
 HEAP32[gb + 34972 >> 2] = fb + 36;
 HEAP32[gb + 34984 >> 2] = fb + 181;
 HEAP32[gb + 34988 >> 2] = fb + 182;
 HEAP32[gb + 34992 >> 2] = fb + 183;
 HEAP32[gb + 34996 >> 2] = fb + 199;
 HEAP32[gb + 35e3 >> 2] = fb + 16;
 HEAP32[gb + 35004 >> 2] = fb + 39;
 HEAP32[gb + 35008 >> 2] = fb + 40;
 HEAP32[gb + 35012 >> 2] = fb + 19;
 HEAP32[gb + 35016 >> 2] = fb + 130;
 HEAP32[gb + 35020 >> 2] = fb + 95;
 HEAP32[gb + 35024 >> 2] = fb + 40;
 HEAP32[gb + 35028 >> 2] = fb + 62;
 HEAP32[gb + 35032 >> 2] = fb + 28;
 HEAP32[gb + 35036 >> 2] = fb + 63;
 HEAP32[gb + 35040 >> 2] = fb + 29;
 HEAP32[gb + 35044 >> 2] = fb + 34;
 HEAP32[gb + 35048 >> 2] = fb + 200;
 HEAP32[gb + 35052 >> 2] = fb + 201;
 HEAP32[gb + 35056 >> 2] = fb + 202;
 HEAP32[gb + 35060 >> 2] = fb + 203;
 HEAP32[gb + 35064 >> 2] = fb + 204;
 HEAP32[gb + 35068 >> 2] = fb + 205;
 HEAP32[gb + 35072 >> 2] = fb + 36;
 HEAP32[gb + 35076 >> 2] = fb + 131;
 HEAP32[gb + 35080 >> 2] = fb + 81;
 HEAP32[gb + 35084 >> 2] = fb + 82;
 HEAP32[gb + 35096 >> 2] = (HEAP32[gb + 35096 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 35100 >> 2] = (HEAP32[gb + 35100 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 35136 >> 2] = fb + 184;
 HEAP32[gb + 35140 >> 2] = fb + 185;
 HEAP32[gb + 35144 >> 2] = fb + 38;
 HEAP32[gb + 35148 >> 2] = fb + 206;
 HEAP32[gb + 35152 >> 2] = fb + 16;
 HEAP32[gb + 35156 >> 2] = fb + 93;
 HEAP32[gb + 35160 >> 2] = fb + 40;
 HEAP32[gb + 35164 >> 2] = fb + 19;
 HEAP32[gb + 35168 >> 2] = fb + 132;
 HEAP32[gb + 35172 >> 2] = fb + 103;
 HEAP32[gb + 35176 >> 2] = fb + 101;
 HEAP32[gb + 35180 >> 2] = fb + 62;
 HEAP32[gb + 35184 >> 2] = fb + 28;
 HEAP32[gb + 35188 >> 2] = fb + 63;
 runPostSets16();
}

function __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i2 = i5;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } else {
  i6 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i7 = i2;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E(i3, i4);
  i2 = i6;
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 24 >> 2]);
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = i4 + 4 | 0;
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i4 + 8 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 4 >> 2]);
 f19 = Math_fround(f15 - f19);
 f16 = Math_fround(f10 - f16);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 8 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f10 * Math_fround(-2.0));
 f11 = Math_fround(f10 * Math_fround(2.0));
 f21 = Math_fround(f17 * f14);
 f18 = Math_fround(f22 * Math_fround(2.0));
 f20 = Math_fround(f22 * Math_fround(-2.0));
 f24 = Math_fround(f17 * f20);
 f9 = Math_fround(f15 * Math_fround(-2.0));
 f23 = Math_fround(f15 * Math_fround(2.0));
 f17 = Math_fround(f17 * f9);
 f12 = Math_fround(Math_fround(f19 + Math_fround(Math_fround(Math_fround(f10 * f14) - Math_fround(f22 * f18)) * f19)) + Math_fround(Math_fround(Math_fround(f24 - Math_fround(f10 * f9)) * f16) + Math_fround(Math_fround(Math_fround(f23 * f22) - f21) * f13)));
 f14 = Math_fround(Math_fround(f16 + Math_fround(Math_fround(Math_fround(f15 * f11) - f24) * f19)) + Math_fround(Math_fround(Math_fround(Math_fround(f22 * f20) - Math_fround(f15 * f23)) * f16) + Math_fround(Math_fround(f17 - Math_fround(f22 * f14)) * f13)));
 f13 = Math_fround(Math_fround(Math_fround(Math_fround(f21 - Math_fround(f15 * f20)) * f19) + f13) + Math_fround(Math_fround(Math_fround(Math_fround(f10 * f18) - f17) * f16) + Math_fround(Math_fround(Math_fround(f15 * f9) - Math_fround(f10 * f11)) * f13)));
 f11 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 32 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 36 >> 2]);
 i2 = Math_fround(Math_abs(Math_fround(f11))) < Math_fround(9.99999971e-10);
 i3 = Math_fround(Math_abs(Math_fround(f10))) < Math_fround(9.99999971e-10);
 i6 = Math_fround(Math_abs(Math_fround(f9))) < Math_fround(9.99999971e-10);
 f11 = Math_fround(Math_fround(1.0) / f11);
 f11 = i2 ? Math_fround(1.0) : f11;
 f10 = Math_fround(Math_fround(1.0) / f10);
 f10 = i3 ? Math_fround(1.0) : f10;
 f9 = Math_fround(Math_fround(1.0) / f9);
 f10 = Math_fround(f14 * f10);
 f9 = Math_fround(f13 * (i6 ? Math_fround(1.0) : f9));
 HEAPF32[i4 >> 2] = Math_fround(f12 * f11);
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f9;
 STACKTOP = i5;
 return;
}

function __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 88 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_17TransferMetaFlags(i17, i3, i1) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i2 = i16 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0);
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i16;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i14 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i8 = HEAP32[gb + 37300 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i12 = 9; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i12 = 9; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 9) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZN15CapsuleCollider9GetBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 24 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6;
 if (!(HEAP32[i2 + 36 >> 2] | 0)) {
  __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i5 = i1 + 12 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i6;
  return;
 } else {
  i16 = i2 + 28 | 0;
  __ZNK9Transform14TransformPointERK8Vector3f(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 72 | 0);
  __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 >> 2] | 0, gb + 28940 | 0) | 0);
  f13 = Math_fround(HEAPF32[i4 >> 2]);
  f13 = Math_fround(f13 * Math_fround(HEAPF32[gb + 62512 >> 2]));
  f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f11 = Math_fround(f11 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
  f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f9 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
  HEAPF32[i3 >> 2] = f13;
  HEAPF32[i3 + 4 >> 2] = f11;
  HEAPF32[i3 + 8 >> 2] = f9;
  f9 = Math_fround(HEAPF32[i2 + 64 >> 2]);
  i17 = HEAP32[i2 + 68 >> 2] | 0;
  f9 = Math_fround(f9 * Math_fround(HEAPF32[i3 + (i17 << 2) >> 2]));
  i15 = f9 < Math_fround(0.0);
  f11 = Math_fround(-f9);
  f9 = i15 ? f11 : f9;
  i15 = f9 < Math_fround(9.99999974e-06);
  f9 = i15 ? Math_fround(9.99999974e-06) : f9;
  f11 = Math_fround(HEAPF32[i3 + (((i17 + 1 | 0) % 3 | 0) << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i3 + (((i17 + 2 | 0) % 3 | 0) << 2) >> 2]);
  i15 = f11 < Math_fround(0.0);
  f8 = Math_fround(-f11);
  f11 = i15 ? f8 : f11;
  i15 = f13 < Math_fround(0.0);
  f8 = Math_fround(-f13);
  f13 = i15 ? f8 : f13;
  f11 = Math_fround(Math_fround(HEAPF32[i2 + 60 >> 2]) * (f11 < f13 ? f13 : f11));
  f9 = Math_fround(f9 - Math_fround(f11 * Math_fround(2.0)));
  i15 = f9 < Math_fround(9.99999974e-06);
  f9 = i15 ? Math_fround(9.99999974e-06) : f9;
  i15 = f11 < Math_fround(9.99999974e-06);
  f11 = i15 ? Math_fround(9.99999974e-06) : f11;
  HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
  i15 = i3 + 4 | 0;
  HEAP32[i15 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  i14 = i3 + 8 | 0;
  HEAP32[i14 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[i3 + (i17 << 2) >> 2] = Math_fround(f9 * Math_fround(.5));
  __ZNK9Transform18TransformDirectionERK8Vector3f(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 >> 2] | 0, gb + 28940 | 0) | 0, i3);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = f9 < Math_fround(0.0);
  f13 = Math_fround(-f9);
  f8 = Math_fround(HEAPF32[i15 >> 2]);
  i3 = f8 < Math_fround(0.0);
  f12 = Math_fround(-f8);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  i4 = f7 < Math_fround(0.0);
  f10 = Math_fround(-f7);
  f9 = Math_fround(f11 + (i2 ? f13 : f9));
  f8 = Math_fround(f11 + (i3 ? f12 : f8));
  f7 = Math_fround(f11 + (i4 ? f10 : f7));
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAPF32[i1 + 12 >> 2] = f9;
  HEAPF32[i1 + 16 >> 2] = f8;
  HEAPF32[i1 + 20 >> 2] = f7;
  STACKTOP = i6;
  return;
 }
}

function __ZN9Animation8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i10 = i3 + 16 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 i6 = i1 + 280 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896236 | 0, gb + 905722 | 0, i6, 0);
 i8 = i4 + 8 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i6, 1);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896248 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 284 | 0, 0);
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905722 | 0, i10, 0);
 i8 = i4 + 8 | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i10, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896261 | 0, i7, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896295 | 0, i8, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896315 | 0, i8, i1 + 41 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i1 = i1 + 44 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896332 | 0, i7, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5Umbra15OcclusionBuffer18setCameraTransformERKNS_15CameraTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 1424 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 1408 | 0;
 i12 = i13;
 i9 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 i10 = HEAP32[i9 + 1208 >> 2] | 0;
 i1 = i2 + 3 & -4;
 i2 = HEAP32[i9 + 1392 >> 2] | 0;
 i3 = HEAP32[i9 + 1396 >> 2] | 0;
 i4 = HEAP32[i9 + 1400 >> 2] | 0;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i12 + 20 >> 2] = Math_fround(1.0);
 i6 = i12 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i12 + 40 >> 2] = Math_fround(1.0);
 i6 = i12 + 44 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i12 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 64 >> 2] = Math_fround(1.0);
 i6 = i12 + 68 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i12 + 84 >> 2] = Math_fround(1.0);
 i7 = i12 + 88 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i12 + 104 >> 2] = Math_fround(1.0);
 i7 = i12 + 108 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i12 + 124 >> 2] = Math_fround(1.0);
 i7 = i12 + 1208 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i12 + 1376 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 _memset(i12 + 128 | 0, 0, 1068) | 0;
 i7 = i12 + 1316 | 0;
 i8 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i8 | 0));
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i11 + 8 >> 2] = i10;
 __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii(i12, i1, i11, i2, i3, i4);
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAP32[i12 + 32 >> 2];
 HEAP32[i9 + 36 >> 2] = HEAP32[i12 + 36 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i12 + 40 >> 2];
 HEAP32[i9 + 44 >> 2] = HEAP32[i12 + 44 >> 2];
 HEAP32[i9 + 48 >> 2] = HEAP32[i12 + 48 >> 2];
 HEAP32[i9 + 52 >> 2] = HEAP32[i12 + 52 >> 2];
 HEAP32[i9 + 56 >> 2] = HEAP32[i12 + 56 >> 2];
 HEAP32[i9 + 60 >> 2] = HEAP32[i12 + 60 >> 2];
 HEAP32[i9 + 64 >> 2] = HEAP32[i12 + 64 >> 2];
 HEAP32[i9 + 68 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 72 >> 2] = HEAP32[i12 + 72 >> 2];
 HEAP32[i9 + 76 >> 2] = HEAP32[i12 + 76 >> 2];
 HEAP32[i9 + 80 >> 2] = HEAP32[i12 + 80 >> 2];
 HEAP32[i9 + 84 >> 2] = HEAP32[i12 + 84 >> 2];
 HEAP32[i9 + 88 >> 2] = HEAP32[i12 + 88 >> 2];
 HEAP32[i9 + 92 >> 2] = HEAP32[i12 + 92 >> 2];
 HEAP32[i9 + 96 >> 2] = HEAP32[i12 + 96 >> 2];
 HEAP32[i9 + 100 >> 2] = HEAP32[i12 + 100 >> 2];
 HEAP32[i9 + 104 >> 2] = HEAP32[i12 + 104 >> 2];
 HEAP32[i9 + 108 >> 2] = HEAP32[i12 + 108 >> 2];
 HEAP32[i9 + 112 >> 2] = HEAP32[i12 + 112 >> 2];
 HEAP32[i9 + 116 >> 2] = HEAP32[i12 + 116 >> 2];
 HEAP32[i9 + 120 >> 2] = HEAP32[i12 + 120 >> 2];
 HEAP32[i9 + 124 >> 2] = HEAP32[i12 + 124 >> 2];
 _memcpy(i9 + 128 | 0, i12 + 128 | 0, 1276) | 0;
 STACKTOP = i13;
 return;
}

function __ZNK20ArchiveStorageReader9EnumerateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP13dynamic_arrayI13FileEntryInfoLj8EE19FileEnumerationFlag(i1, i14, i15, i16) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i18 = i21 + 12 | 0;
 if (!i15) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i19 = i1 + 120 | 0;
 i13 = i1 + 124 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i20 = 1;
  STACKTOP = i21;
  return i20 | 0;
 }
 i8 = i14 + 11 | 0;
 i9 = i14 + 4 | 0;
 i10 = i15 + 12 | 0;
 i11 = i15 + 16 | 0;
 i12 = i15 + 4 | 0;
 i6 = 0;
 i7 = 0;
 i3 = i2;
 L7 : while (1) {
  i5 = HEAP8[i8 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
  if (!i5) {
   i2 = i6;
   i20 = 9;
  } else {
   i2 = i1 + (i7 * 40 | 0) + 20 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   i5 = (_strncmp(i2, i4 ? HEAP32[i14 >> 2] | 0 : i14, i5) | 0) == 0;
   i2 = i6 | i5;
   switch ((i5 ? 0 : i6 ? 2 : 4) & 7) {
   case 0:
    {
     i20 = 9;
     break;
    }
   case 4:
    break;
   default:
    {
     i1 = 1;
     i20 = 21;
     break L7;
    }
   }
  }
  if ((i20 | 0) == 9) {
   i20 = 0;
   i6 = HEAP32[i10 >> 2] | 0;
   i3 = i6 + 1 | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i11 >> 2] = i1;
     HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 1088 | 0, 8, i12, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 1088 | 0, 8, i12, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 1088 | 0) | 0;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i15 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i10 >> 2] = i3;
   i3 = HEAP32[i15 >> 2] | 0;
   i4 = i3 + (i6 * 1088 | 0) | 0;
   i1 = (HEAP32[i19 >> 2] | 0) + (i7 * 40 | 0) + 20 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   _strncpy(i4, i1, 1040) | 0;
   HEAP8[i3 + (i6 * 1088 | 0) + 1039 >> 0] = 0;
   HEAP8[i3 + (i6 * 1088 | 0) + 1080 >> 0] = 0;
   __ZN8DateTimeC2Ev(i17);
   i22 = i17;
   i1 = HEAP32[i22 + 4 >> 2] | 0;
   i5 = i3 + (i6 * 1088 | 0) + 1072 | 0;
   HEAP32[i5 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i5 + 4 >> 2] = i1;
   HEAP8[i3 + (i6 * 1088 | 0) + 1081 >> 0] = 0;
   HEAP8[i3 + (i6 * 1088 | 0) + 1082 >> 0] = 0;
   HEAP32[i18 >> 2] = 0;
   HEAP32[i18 + 4 >> 2] = 0;
   HEAP32[i18 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i18, i4, _strlen(i4) | 0);
   __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i17, i18);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
   if (__Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i4, i17, i16) | 0) HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
   i3 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i19 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= ((i3 - i1 | 0) / 40 | 0) >>> 0) {
   i1 = 1;
   i20 = 21;
   break;
  } else i6 = i2;
 }
 if ((i20 | 0) == 21) {
  STACKTOP = i21;
  return i1 | 0;
 }
 return 0;
}

function __ZN12MeshRenderer16UpdateCachedMeshEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i4 = i8 + 376 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i3 = i8 + 340 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  if (i2 | 0) __ZN8Renderer20ResetStaticBatchInfoEv(i8);
  HEAP32[i3 >> 2] = i1;
  HEAP8[i8 + 272 >> 0] = 1;
  __ZN8Renderer13BoundsChangedEv(i8);
  i2 = i8 + 352 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i10 = i8 + 356 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + 232 | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i10 = i8 + 356 | 0;
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i4 + 4 >> 2] = i2;
    HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
   }
  }
 }
 i4 = i8 + 380 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 25; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 25; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 27;
   }
  }
  if ((i7 | 0) == 25) i7 = 27;
  if ((i7 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = i8 + 344 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i3 = i8 + 364 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i10 = i8 + 368 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 232 | 0;
 if ((i3 | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 i10 = i8 + 368 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[HEAP32[i10 >> 2] >> 2] = i3;
 STACKTOP = i9;
 return;
}

function __ZN11GPUProfiler14CollectGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EEb(i14, i3) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i1 = i3 ? 3 : 1;
 if (__Z12GetIVRDevicev() | 0) {
  i13 = __Z12GetIVRDevicev() | 0;
  i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 104 >> 2] | 0, i13 | 0) | 0;
  i1 = i13 ? 1 : i1;
 }
 i13 = i14 + 12 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 1;
  return i14 | 0;
 }
 if (i3) {
  i12 = 0;
  do {
   i4 = HEAP32[i14 >> 2] | 0;
   i11 = i4 + (i12 << 4) + 8 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   if (i3) {
    i2 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0) | 0;
    i3 = getTempRet0() | 0;
    if (i3 >>> 0 > 4294967295 | (i3 | 0) == -1 & i2 >>> 0 > 4294967293) i2 = -1; else {
     i2 = ___udivdi3(i2 | 0, i3 | 0, 1e3, 0) | 0;
     getTempRet0() | 0;
    }
    HEAP32[i4 + (i12 << 4) + 4 >> 2] = i2;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = HEAP32[gb + 1163260 >> 2] | 0;
    i5 = i4 + 12 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = i4 + 16 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    i10 = i9 & 2147483647;
    do if (i7 >>> 0 > i10 >>> 0) {
     i2 = i9 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
      HEAP32[i8 >> 2] = i2;
      HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
      HEAP32[i8 >> 2] = i2;
      HEAP32[i4 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i5 >> 2] = i7;
    HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
    HEAP32[i11 >> 2] = 0;
    i2 = HEAP32[i13 >> 2] | 0;
   }
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < i2 >>> 0);
  i1 = 1;
  return i1 | 0;
 } else i11 = 0;
 do {
  i5 = HEAP32[i14 >> 2] | 0;
  i12 = i5 + (i11 << 4) + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (i2 | 0) {
   i3 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
   i4 = getTempRet0() | 0;
   if (i4 >>> 0 > 4294967295 | (i4 | 0) == -1 & i3 >>> 0 > 4294967293) i2 = -1; else {
    i2 = ___udivdi3(i3 | 0, i4 | 0, 1e3, 0) | 0;
    getTempRet0() | 0;
   }
   HEAP32[i5 + (i11 << 4) + 4 >> 2] = i2;
   if ((i3 | 0) == -2 & (i4 | 0) == -1 | (i2 | 0) != -1) {
    i3 = HEAP32[i12 >> 2] | 0;
    i4 = HEAP32[gb + 1163260 >> 2] | 0;
    i5 = i4 + 12 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = i4 + 16 | 0;
    i9 = HEAP32[i8 >> 2] | 0;
    i10 = i9 & 2147483647;
    do if (i7 >>> 0 > i10 >>> 0) {
     i2 = i9 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
      HEAP32[i8 >> 2] = i2;
      HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
      HEAP32[i8 >> 2] = i2;
      HEAP32[i4 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i5 >> 2] = i7;
    HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
    HEAP32[i12 >> 2] = 0;
   }
  }
  i11 = i11 + 1 | 0;
 } while (i11 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN11LightProbes14LightProbeData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 24 | 0;
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378712 | 0, gb + 378733 | 0, i1, 0);
 __ZN26ProbeSetTetrahedralization8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378760 | 0, i9, i1 + 40 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 378809 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431143 | 0, gb + 455698 | 0, i6, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800947 | 0, i7, i6 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, i7, i6 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405193 | 0, i9, i1 + 60 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378772 | 0, HEAP32[gb + 37052 >> 2] | 0, i1 + 80 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, gb + 455698 | 0, i6, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, i7, i6 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function runPostSets81() {
 HEAP32[gb + 87140 >> 2] = fb + 23;
 HEAP32[gb + 87152 >> 2] = fb + 66;
 HEAP32[gb + 87156 >> 2] = fb + 28;
 HEAP32[gb + 87168 >> 2] = fb + 1103;
 HEAP32[gb + 87172 >> 2] = fb + 1104;
 HEAP32[gb + 87176 >> 2] = fb + 7;
 HEAP32[gb + 87180 >> 2] = fb + 8;
 HEAP32[gb + 87184 >> 2] = fb + 10;
 HEAP32[gb + 87188 >> 2] = fb + 1;
 HEAP32[gb + 87200 >> 2] = fb + 1105;
 HEAP32[gb + 87204 >> 2] = fb + 1106;
 HEAP32[gb + 87208 >> 2] = fb + 100;
 HEAP32[gb + 87212 >> 2] = fb + 1107;
 HEAP32[gb + 87216 >> 2] = fb + 820;
 HEAP32[gb + 87228 >> 2] = fb + 1108;
 HEAP32[gb + 87232 >> 2] = fb + 465;
 HEAP32[gb + 87236 >> 2] = fb + 821;
 HEAP32[gb + 87240 >> 2] = fb + 822;
 HEAP32[gb + 87244 >> 2] = fb + 1109;
 HEAP32[gb + 87248 >> 2] = fb + 1110;
 HEAP32[gb + 87252 >> 2] = fb + 1111;
 HEAP32[gb + 87264 >> 2] = fb + 1112;
 HEAP32[gb + 87268 >> 2] = fb + 1113;
 HEAP32[gb + 87272 >> 2] = fb + 823;
 HEAP32[gb + 87276 >> 2] = fb + 824;
 HEAP32[gb + 87288 >> 2] = fb + 825;
 HEAP32[gb + 87292 >> 2] = fb + 466;
 HEAP32[gb + 87296 >> 2] = fb + 1114;
 HEAP32[gb + 87300 >> 2] = fb + 1115;
 HEAP32[gb + 87304 >> 2] = fb + 1116;
 HEAP32[gb + 87308 >> 2] = fb + 826;
 HEAP32[gb + 87312 >> 2] = fb + 467;
 HEAP32[gb + 87324 >> 2] = fb + 1117;
 HEAP32[gb + 87328 >> 2] = fb + 1118;
 HEAP32[gb + 87332 >> 2] = fb + 29;
 HEAP32[gb + 87344 >> 2] = fb + 1119;
 HEAP32[gb + 87348 >> 2] = fb + 1120;
 HEAP32[gb + 87352 >> 2] = fb + 30;
 HEAP32[gb + 87364 >> 2] = fb + 1121;
 HEAP32[gb + 87368 >> 2] = fb + 1122;
 HEAP32[gb + 87372 >> 2] = fb + 26;
 HEAP32[gb + 87376 >> 2] = fb + 827;
 HEAP32[gb + 87388 >> 2] = fb + 828;
 HEAP32[gb + 87392 >> 2] = fb + 468;
 HEAP32[gb + 87396 >> 2] = fb + 1123;
 HEAP32[gb + 87400 >> 2] = fb + 1124;
 HEAP32[gb + 87412 >> 2] = fb + 1125;
 HEAP32[gb + 87416 >> 2] = fb + 1126;
 HEAP32[gb + 87420 >> 2] = fb + 1;
 HEAP32[gb + 87424 >> 2] = fb + 1;
 HEAP32[gb + 87428 >> 2] = fb + 1127;
 HEAP32[gb + 87432 >> 2] = fb + 1128;
 HEAP32[gb + 87436 >> 2] = fb + 469;
 HEAP32[gb + 87440 >> 2] = fb + 1129;
 HEAP32[gb + 87452 >> 2] = fb + 1125;
 HEAP32[gb + 87456 >> 2] = fb + 1130;
 HEAP32[gb + 87460 >> 2] = fb + 1131;
 HEAP32[gb + 87464 >> 2] = fb + 470;
 HEAP32[gb + 87468 >> 2] = fb + 1127;
 HEAP32[gb + 87472 >> 2] = fb + 1128;
 HEAP32[gb + 87476 >> 2] = fb + 469;
 HEAP32[gb + 87480 >> 2] = fb + 1129;
 HEAP32[gb + 87492 >> 2] = fb + 1132;
 HEAP32[gb + 87496 >> 2] = fb + 1133;
 HEAP32[gb + 87500 >> 2] = fb + 131;
 HEAP32[gb + 87512 >> 2] = fb + 829;
 HEAP32[gb + 87516 >> 2] = fb + 830;
 HEAP32[gb + 87520 >> 2] = fb + 831;
 HEAP32[gb + 87524 >> 2] = fb + 1134;
 HEAP32[gb + 87528 >> 2] = fb + 1135;
 HEAP32[gb + 87540 >> 2] = fb + 132;
 HEAP32[gb + 87544 >> 2] = fb + 1136;
 HEAP32[gb + 87548 >> 2] = fb + 1137;
 HEAP32[gb + 87552 >> 2] = fb + 471;
 HEAP32[gb + 87556 >> 2] = fb + 472;
 HEAP32[gb + 87568 >> 2] = fb + 133;
 HEAP32[gb + 87572 >> 2] = fb + 1138;
 HEAP32[gb + 87576 >> 2] = fb + 1139;
 HEAP32[gb + 87580 >> 2] = fb + 473;
 HEAP32[gb + 87584 >> 2] = fb + 832;
 HEAP32[gb + 87588 >> 2] = fb + 474;
 HEAP32[gb + 87600 >> 2] = fb + 134;
 HEAP32[gb + 87604 >> 2] = fb + 1140;
 HEAP32[gb + 87608 >> 2] = fb + 1141;
 HEAP32[gb + 87612 >> 2] = fb + 475;
 HEAP32[gb + 87624 >> 2] = fb + 135;
 HEAP32[gb + 87628 >> 2] = fb + 1142;
 HEAP32[gb + 87632 >> 2] = fb + 1143;
 HEAP32[gb + 87636 >> 2] = fb + 476;
 HEAP32[gb + 87640 >> 2] = fb + 833;
 HEAP32[gb + 87644 >> 2] = fb + 477;
 HEAP32[gb + 87648 >> 2] = fb + 24;
 HEAP32[gb + 87660 >> 2] = fb + 67;
 HEAP32[gb + 87664 >> 2] = fb + 31;
 HEAP32[gb + 87676 >> 2] = fb + 1144;
 HEAP32[gb + 87680 >> 2] = fb + 478;
 HEAP32[gb + 87684 >> 2] = fb + 456;
 HEAP32[gb + 87688 >> 2] = fb + 1145;
 HEAP32[gb + 87692 >> 2] = fb + 1146;
 HEAP32[gb + 87696 >> 2] = fb + 221;
 runPostSets82();
}

function __ZN13BuildSettingsD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i8 >> 2] = gb + 64212 + 8;
 i1 = i8 + 156 | 0;
 if ((HEAP32[i8 + 172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 160 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 140 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i8 + 152 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i1 = i8 + 124 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i8 + 136 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i1 = HEAP32[i8 + 96 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 100 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -32 - i2 | 0) >>> 5) << 5);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i8 + 80 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 84 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
  __ZdlPv(i1);
 }
 i4 = i8 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 68 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 56 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 44 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = gb + 28648 + 8;
  HEAP32[i8 >> 2] = gb + 28496 + 8;
  STACKTOP = i9;
  return;
 }
 i5 = i8 + 32 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i7 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i8 >> 2] = gb + 28648 + 8;
 HEAP32[i8 >> 2] = gb + 28496 + 8;
 STACKTOP = i9;
 return;
}

function __Z26EnsureQuaternionContinuityPP17AnimationCurveTplIfE(i24) {
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0;
 i22 = HEAP32[i24 >> 2] | 0;
 if (!i22) return;
 i25 = i24 + 4 | 0;
 i3 = HEAP32[i25 >> 2] | 0;
 if (!i3) return;
 i26 = i24 + 8 | 0;
 i2 = HEAP32[i26 >> 2] | 0;
 if (!i2) return;
 i28 = i24 + 12 | 0;
 i1 = HEAP32[i28 >> 2] | 0;
 if (!i1) return;
 i27 = HEAP32[i22 + 68 >> 2] | 0;
 if ((i27 | 0) != (HEAP32[i3 + 68 >> 2] | 0)) return;
 if ((i27 | 0) != (HEAP32[i2 + 68 >> 2] | 0)) return;
 if ((i27 | 0) == 0 ? 1 : (i27 | 0) != (HEAP32[i1 + 68 >> 2] | 0)) return;
 i4 = i27 + -1 | 0;
 i23 = (i27 | 0) > 0;
 if (!i23) return;
 i21 = HEAP32[i1 + 56 >> 2] | 0;
 i20 = HEAP32[i2 + 56 >> 2] | 0;
 i18 = HEAP32[i3 + 56 >> 2] | 0;
 i19 = HEAP32[i22 + 56 >> 2] | 0;
 i17 = 0;
 i3 = HEAP32[i19 + (i4 << 4) + 4 >> 2] | 0;
 i1 = HEAP32[i21 + (i4 << 4) + 4 >> 2] | 0;
 i2 = HEAP32[i18 + (i4 << 4) + 4 >> 2] | 0;
 i4 = HEAP32[i20 + (i4 << 4) + 4 >> 2] | 0;
 do {
  i13 = i19 + (i17 << 4) + 4 | 0;
  i8 = HEAP32[i13 >> 2] | 0;
  i14 = i18 + (i17 << 4) + 4 | 0;
  i12 = HEAP32[i14 >> 2] | 0;
  i15 = i20 + (i17 << 4) + 4 | 0;
  i10 = HEAP32[i15 >> 2] | 0;
  i16 = i21 + (i17 << 4) + 4 | 0;
  i11 = HEAP32[i16 >> 2] | 0;
  f9 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f9);
  f7 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 + Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
  f6 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f29 = Math_fround(f29 + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f6));
  f5 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(f29 + Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f5)) < Math_fround(0.0)) {
   f30 = Math_fround(-f9);
   f7 = Math_fround(-f7);
   f9 = Math_fround(-f6);
   f29 = Math_fround(-f5);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f30, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f29, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i3 = i8;
   i4 = i10;
   i1 = i11;
   i2 = i12;
  }
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i15 >> 2] = i4;
  HEAP32[i16 >> 2] = i1;
  i17 = i17 + 1 | 0;
 } while ((i17 | 0) != (i27 | 0));
 if (!i23) return;
 __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i22, 0, Math_fround(0.0));
 if ((i27 | 0) == 1) i1 = 0; else {
  i1 = 1;
  do {
   __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(HEAP32[i24 >> 2] | 0, i1, Math_fround(0.0));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i27 | 0));
  i1 = 0;
 }
 do {
  __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(HEAP32[i25 >> 2] | 0, i1, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 i1 = 0;
 do {
  __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(HEAP32[i26 >> 2] | 0, i1, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 i1 = 0;
 do {
  __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(HEAP32[i28 >> 2] | 0, i1, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i27 | 0));
 return;
}

function __ZN9AudioClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i5 = i6 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i7 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 66 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 __ZN16StreamedResource8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 72 | 0, i7);
 i1 = i6 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN13SpringJoint2D6CreateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i1 = i11;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i7 = 9; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 20;
   }
  }
  if ((i7 | 0) == 18) i7 = 20;
  if ((i7 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i10;
   return;
  }
 } while (0);
 i2 = i9 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP32[i9 >> 2] = 3;
 i2 = i9 + 20 | 0;
 i1 = i9 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i9 + 40 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i9 + 44 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i9 + 20 | 0;
 i5 = i9 + 28 | 0;
 __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i8, i4, i5);
 if (HEAP8[i8 + 108 >> 0] | 0) if (!(HEAP8[i8 + 52 >> 0] | 0)) {
  f12 = Math_fround(__ZN15AnchoredJoint2D17ConfigureDistanceERK6b2Vec2S2_(i8, i4, i5));
  i11 = f12 < Math_fround(.00499999989);
  i7 = f12 > Math_fround(1.0e6);
  f12 = i7 ? Math_fround(1.0e6) : f12;
  HEAPF32[i8 + 96 >> 2] = i11 ? Math_fround(.00499999989) : f12;
 }
 HEAP32[i3 >> 2] = HEAP32[i8 + 100 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 + 104 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 + 96 >> 2];
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN11TerrainDataC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i7 = i4 + 8 | 0;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 184376 + 8;
 i7 = i1 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 512;
 HEAP32[i1 + 72 >> 2] = 512;
 HEAP32[i1 + 76 >> 2] = -1;
 HEAP8[i1 + 80 >> 0] = 1;
 HEAP8[i1 + 81 >> 0] = 1;
 HEAP8[i1 + 82 >> 0] = 1;
 HEAP32[i1 + 64 >> 2] = i1;
 i7 = i1 + 84 | 0;
 __ZN12TreeDatabaseC2ER11TerrainData(i7, i1);
 i3 = i1 + 132 | 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 1;
 HEAP32[i1 + 224 >> 2] = 1812433254;
 HEAP32[i1 + 228 >> 2] = 1900727103;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = i1;
 HEAP32[i1 + 160 >> 2] = i7;
 HEAP32[i1 + 188 >> 2] = 1060320051;
 HEAP32[i1 + 192 >> 2] = 1058642330;
 HEAP32[i1 + 196 >> 2] = 1056964608;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAPF32[i1 + 204 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 208 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 212 >> 2] = Math_fround(.5);
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 8;
 HEAP8[i1 + 128 >> 0] = 1;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = i1;
 i7 = gb + 63616 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 256 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63616 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 276 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63616 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAP32[i1 + 308 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 296 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 312 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 316 >> 2] = i3;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAPF32[i1 + 332 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 336 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 340 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 348 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 364 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN9AudioClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i5 = i6 + 52 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
  i4 = i3;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 66 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN16StreamedResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 72 | 0, i7);
 i1 = i6 + 104 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i1 >> 2] = i10;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN10AudioMixer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i7 = i11 + 4 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 92 | 0, i10);
 __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 44 | 0, i10);
 i4 = i9 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 4);
 i1 = HEAP32[i9 + 48 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  __ZN4PPtrI18AudioMixerSnapshotE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN4PPtrI18AudioMixerSnapshotE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 68 | 0, i10);
 i1 = i9 + 96 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i9 + 100 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 4);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i4 = i9 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 128 >> 2] | 0, i9 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  if (!i1) {
   HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
   __Z6FormatPKcz(i7, gb + 863587 | 0, i8);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 861578 | 0, 107, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = i9 + 32 | 0;
   HEAP32[i10 + 4 >> 2] = i1;
   if (i2 | 0) {
    i9 = i2;
    __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
    __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
    STACKTOP = i11;
    return;
   }
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 80, 4) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i2 = i1 + 28 | 0;
   i3 = i2 + 52 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   HEAP32[i4 >> 2] = i1;
   i9 = i1;
   __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
   __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
   STACKTOP = i11;
   return;
  }
 }
 HEAP32[i10 + 4 >> 2] = i9 + 32;
 i9 = i1;
 __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i11;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j(i13, i11) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 24 | 0;
 i2 = i15 + 20 | 0;
 i10 = i15 + 8 | 0;
 i3 = i15 + 4 | 0;
 i4 = i15;
 i14 = i13 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i1 = i5 - i6 >> 3;
 i8 = i6;
 if (i1 >>> 0 < i11 >>> 0) {
  i8 = i13 + 8 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i6 >> 3 | 0) == (i11 | 0)) {
   __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj(i13, i11 - i1 | 0);
   STACKTOP = i15;
   return;
  }
  HEAP32[i10 >> 2] = 0;
  i9 = i10 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i7 = i10 + 8 | 0;
  if (i11 | 0) {
   i1 = __Znwj(i11 << 3) | 0;
   i16 = i1;
   HEAP32[i10 >> 2] = i16;
   HEAP32[i9 >> 2] = i16;
   HEAP32[i7 >> 2] = i1 + (i11 << 3);
  }
  HEAP32[i3 >> 2] = i6;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i10, i2, i12);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = i1 - i4 >> 3;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i11 >>> 0) {
   __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj(i10, i11 - i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else if (i2 >>> 0 > i11 >>> 0) {
   i2 = i3 + (i11 << 3) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -8 - i2 | 0) >>> 3) << 3) | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i13 >> 2] = i2;
  i2 = HEAP32[i14 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i14 >> 2] = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 } else {
  if (i1 >>> 0 <= i11 >>> 0) {
   STACKTOP = i15;
   return;
  }
  i5 = i8 + (i11 << 3) | 0;
  HEAP32[i12 >> 2] = 0;
  i9 = i12 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i1 = i11 << 3;
  i2 = i1 >> 3;
  if (!i2) {
   i4 = i12 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i4 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i4;
   HEAP32[i12 >> 2] = i4;
   i1 = i4 + (i2 << 3) | 0;
   i7 = i12 + 8 | 0;
   HEAP32[i7 >> 2] = i1;
   i6 = i4;
   if (!i11) {
    i4 = i7;
    i5 = i6;
    i2 = i6;
   } else {
    i1 = i8;
    i3 = i4;
    i2 = i4;
    while (1) {
     i10 = i1;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i16 = i3;
     HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i16 + 4 >> 2] = i11;
     i1 = i1 + 8 | 0;
     i2 = i2 + 8 | 0;
     HEAP32[i9 >> 2] = i2;
     if ((i1 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i4 = i7;
    i5 = i6;
    i1 = HEAP32[i7 >> 2] | 0;
   }
  }
  i3 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
  i16 = HEAP32[i14 >> 2] | 0;
  HEAP32[i9 >> 2] = i16;
  HEAP32[i14 >> 2] = i2;
  i2 = i13 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i16;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
   __ZdlPv(i1);
  }
  STACKTOP = i15;
  return;
 }
}

function __ZN9BoxPruner12updateObjectERK5IAABBt(i2, i9, i1) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 24 | 0;
 i6 = i1 & 65535;
 i7 = HEAP32[i2 + 76 >> 2] | 0;
 i8 = i7 + (i6 << 3) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!(HEAP32[i7 + (i6 << 3) + 4 >> 2] & 1)) {
  if (i1 >>> 0 >= (HEAP32[i2 + 120 >> 2] | 0) >>> 0) HEAP8[i2 + 169 >> 0] = 1;
  i4 = i2 + 116 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 100 >> 2] | 0;
  if (i1 >>> 0 < i5 >>> 0) {
   i11 = i6 + (i1 * 24 | 0) | 0;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   STACKTOP = i12;
   return;
  }
  i1 = HEAP32[i2 + 108 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i6 + (i5 * 24 | 0) | 0;
  if ((i2 | 0) == (i5 | 0)) {
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  } else {
   HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i11 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i11 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   i9 = i6 + (i2 * 24 | 0) | 0;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   i9 = i1 + (i5 << 1) | 0;
   i11 = HEAP16[i9 >> 1] | 0;
   i10 = i1 + (i2 << 1) | 0;
   HEAP16[i9 >> 1] = HEAP16[i10 >> 1] | 0;
   HEAP16[i10 >> 1] = i11;
   HEAP32[i7 + ((i11 & 65535) << 3) >> 2] = i2;
   HEAP32[i8 >> 2] = i5;
  }
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  STACKTOP = i12;
  return;
 }
 i5 = (HEAP32[i2 + 96 >> 2] | 0) + (i1 * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP8[i2 + 168 >> 0] = 1;
 i5 = i2 + 124 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i6 >>> 5;
 i3 = i2 + 128 | 0;
 if (i7 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) i1 = HEAP32[i5 >> 2] | 0; else {
  i4 = i6 + 128 | 0;
  i4 = ((i4 & 31 | 0) != 0 & 1) + (i4 >>> 5) | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11, i4 << 2, gb + 717183 | 0, 412) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) i2 = 0; else {
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  if ((i4 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
   HEAP32[i5 >> 2] = 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i4;
 }
 i11 = i1 + (i7 << 2) | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << (i6 & 31);
 STACKTOP = i12;
 return;
}

function _UNITY_png_write_zTXt(i12, i4, i6, i1, i2) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 1120 | 0;
 i7 = i11 + 1036 | 0;
 i9 = i11;
 switch (i2 | 0) {
 case -1:
  {
   _UNITY_png_write_tEXt(i12, i4, i6, 0);
   STACKTOP = i11;
   return;
  }
 case 0:
  {
   if (!i4) {
    HEAP8[i7 >> 0] = 0;
    _UNITY_png_error(i12, gb + 355429 | 0);
   }
   i3 = HEAP8[i4 >> 0] | 0;
   L10 : do if (!(i3 << 24 >> 24)) {
    i3 = 1;
    i1 = 0;
    i2 = i7;
   } else {
    i5 = 1;
    i1 = 0;
    i2 = i7;
    while (1) {
     L13 : do if (!i5) {
      i8 = (i3 & 255) > 160 | (i3 + -33 & 255) < 94;
      i5 = i8 & 1 ^ 1;
      i4 = i4 + 1 | 0;
      i3 = i8 ? i3 : 32;
     } else while (1) {
      i4 = i4 + 1 | 0;
      if ((i3 & 255) > 160 | (i3 + -33 & 255) < 94) {
       i5 = 0;
       break L13;
      }
      i3 = HEAP8[i4 >> 0] | 0;
      if (!(i3 << 24 >> 24)) {
       i3 = i5;
       break L10;
      }
     } while (0);
     HEAP8[i2 >> 0] = i3;
     i1 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
     i3 = HEAP8[i4 >> 0] | 0;
     if (!(i1 >>> 0 < 79 & i3 << 24 >> 24 != 0)) {
      i3 = i5;
      break;
     }
    }
   } while (0);
   i8 = (i1 | 0) != 0 & (i3 | 0) != 0;
   i1 = (i8 << 31 >> 31) + i1 | 0;
   HEAP8[(i8 ? i2 + -1 | 0 : i2) >> 0] = 0;
   if (!i1) _UNITY_png_error(i12, gb + 355429 | 0);
   HEAP8[i7 + (i1 + 1) >> 0] = 0;
   i3 = i1 + 2 | 0;
   if (!i6) i1 = 0; else i1 = _strlen(i6) | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i1;
   i6 = i9 + 8 | 0;
   HEAP32[i6 >> 2] = 0;
   if (_UNITY_png_text_compress(i12, 2052348020, i9, i3) | 0) _UNITY_png_error(i12, HEAP32[i12 + 244 >> 2] | 0);
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = i2 + i3 | 0;
   i8 = (i12 | 0) == 0;
   L29 : do if (i8) {
    i3 = HEAP32[69] | 0;
    i2 = i2 - (i2 >>> 0 < 1024 ? i2 : 1024) | 0;
    i1 = (i2 | 0) == 0;
    if (!((i3 | 0) == 0 | i1)) {
     i4 = HEAP32[70] | 0;
     do {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = i2 - (i4 >>> 0 > i2 >>> 0 ? i2 : i4) | 0;
      i1 = (i2 | 0) == 0;
     } while (!((i3 | 0) == 0 | i1));
    }
   } else {
    i5 = i12 + 656 | 0;
    HEAP32[i5 >> 2] = 34;
    HEAP8[i10 >> 0] = i1 >>> 24;
    HEAP8[i10 + 1 >> 0] = i1 >>> 16;
    HEAP8[i10 + 2 >> 0] = i1 >>> 8;
    HEAP8[i10 + 3 >> 0] = i1;
    i4 = i10 + 4 | 0;
    HEAP8[i4 >> 0] = 122;
    HEAP8[i10 + 5 >> 0] = 84;
    HEAP8[i10 + 6 >> 0] = 88;
    HEAP8[i10 + 7 >> 0] = 116;
    _UNITY_png_write_data(i12, i10, 8);
    HEAP32[i12 + 372 >> 2] = 2052348020;
    _UNITY_png_reset_crc(i12);
    _UNITY_png_calculate_crc(i12, i4, 4);
    HEAP32[i5 >> 2] = 66;
    if (i3 | 0) {
     _UNITY_png_write_data(i12, i7, i3);
     _UNITY_png_calculate_crc(i12, i7, i3);
    }
    i7 = i12 + 280 | 0;
    i1 = i12 + 276 | 0;
    i4 = 1024;
    i5 = i9 + 12 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i1 >> 2] | 0;
     i1 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
     if (i1 | 0) {
      _UNITY_png_write_data(i12, i5, i1);
      _UNITY_png_calculate_crc(i12, i5, i1);
     }
     i2 = i2 - i1 | 0;
     i1 = (i2 | 0) == 0;
     if ((i3 | 0) == 0 | i1) break L29;
     i1 = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     i5 = i3 + 4 | 0;
    }
   } while (0);
   if (!i1) _UNITY_png_error(i12, gb + 354991 | 0);
   if (!i8) {
    HEAP32[i12 + 656 >> 2] = 130;
    i9 = HEAP32[i12 + 408 >> 2] | 0;
    HEAP8[i10 >> 0] = i9 >>> 24;
    HEAP8[i10 + 1 >> 0] = i9 >>> 16;
    HEAP8[i10 + 2 >> 0] = i9 >>> 8;
    HEAP8[i10 + 3 >> 0] = i9;
    _UNITY_png_write_data(i12, i10, 4);
   }
   STACKTOP = i11;
   return;
  }
 default:
  _UNITY_png_error(i12, gb + 355398 | 0);
 }
}

function __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = i5 - i3 | 0;
 i7 = (i6 | 0) / 72 | 0;
 i9 = i10 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = i4;
 i11 = i5;
 if (i7 >>> 0 <= ((i1 - i4 | 0) / 72 | 0) >>> 0) {
  i8 = i10 + 4 | 0;
  i10 = ((HEAP32[i8 >> 2] | 0) - i4 | 0) / 72 | 0;
  i4 = i7 >>> 0 > i10 >>> 0;
  i7 = i4 ? i3 + (i10 * 72 | 0) | 0 : i5;
  if ((i3 | 0) != (i7 | 0)) while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   i1 = i2 + 32 | 0;
   i5 = i3 + 32 | 0;
   i6 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    i1 = i1 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i1 | 0) < (i6 | 0));
   i3 = i3 + 72 | 0;
   i1 = i2 + 72 | 0;
   if ((i3 | 0) == (i7 | 0)) {
    i2 = i1;
    break;
   } else i2 = i1;
  }
  if (!i4) {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i12;
    return;
   }
   do {
    HEAP32[i8 >> 2] = i1 + -72;
    i1 = HEAP32[i8 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   STACKTOP = i12;
   return;
  }
  if ((i7 | 0) == (i11 | 0)) {
   STACKTOP = i12;
   return;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i7;
  do {
   i5 = i2;
   i6 = i1 + 72 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    i1 = i1 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i1 | 0) < (i6 | 0));
   i2 = i2 + 72 | 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 72 | 0;
   HEAP32[i8 >> 2] = i1;
  } while ((i2 | 0) != (i11 | 0));
  STACKTOP = i12;
  return;
 }
 if (i4) {
  i4 = i10 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    HEAP32[i4 >> 2] = i1 + -72;
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i2 = HEAP32[i10 >> 2] | 0;
  }
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 72 | 0;
 i2 = i6 << 1;
 i2 = i6 >>> 0 < 1073741823 ? (i2 >>> 0 < i7 >>> 0 ? i7 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 72 | 0, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + (i2 * 72 | 0);
 if ((i3 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = i3;
 do {
  i5 = i2;
  i6 = i1 + 72 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   i1 = i1 + 4 | 0;
   i5 = i5 + 4 | 0;
  } while ((i1 | 0) < (i6 | 0));
  i2 = i2 + 72 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 72 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyIyEEvPKcRT_(i15, gb + 771708 | 0, i14);
 i1 = i14 + 8 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((HEAP8[i12 >> 0] | 0) != 0 | i2 >>> 0 < 4) {
  HEAP8[i12 >> 0] = 1;
  i3 = i14 + 16 | 0;
  i1 = i14 + 12 | 0;
  i11 = 5;
 } else {
  HEAP8[i1 >> 0] = HEAP8[HEAP32[i15 >> 2] >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i1 + 1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i1 + 2 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i1 + 3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1 + -1 | 0;
  HEAP32[i13 >> 2] = i2;
  i4 = i14 + 12 | 0;
  i3 = i14 + 16 | 0;
  if ((HEAP8[i12 >> 0] | 0) != 0 | i2 >>> 0 < 4) {
   i1 = i4;
   i11 = 5;
  } else {
   i5 = HEAP32[i15 >> 2] | 0;
   i9 = HEAP8[i5 >> 0] | 0;
   i8 = i5 + 1 | 0;
   HEAP32[i15 >> 2] = i8;
   HEAP32[i13 >> 2] = i1 + -2;
   i8 = HEAP8[i8 >> 0] | 0;
   i7 = i5 + 2 | 0;
   HEAP32[i15 >> 2] = i7;
   HEAP32[i13 >> 2] = i1 + -3;
   i7 = HEAP8[i7 >> 0] | 0;
   i6 = i5 + 3 | 0;
   HEAP32[i15 >> 2] = i6;
   HEAP32[i13 >> 2] = i1 + -4;
   i6 = HEAP8[i6 >> 0] | 0;
   i5 = i5 + 4 | 0;
   HEAP32[i15 >> 2] = i5;
   i2 = i1 + -5 | 0;
   HEAP32[i13 >> 2] = i2;
   i10 = i15;
   i1 = i4;
   i4 = 0;
  }
 }
 if ((i11 | 0) == 5) {
  HEAP8[i12 >> 0] = 1;
  i10 = i15;
  i6 = 0;
  i7 = 0;
  i8 = 0;
  i9 = 0;
  i5 = HEAP32[i15 >> 2] | 0;
  i4 = 1;
 }
 i11 = (i7 & 255) << 16 | (i6 & 255) << 24 | (i8 & 255) << 8 | i9 & 255;
 i11 = i11 >>> 0 < i2 >>> 0 ? i11 : i2;
 HEAP32[i3 >> 2] = i11;
 HEAP32[i1 >> 2] = i5;
 i1 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
 HEAP32[i10 >> 2] = i1;
 i11 = (HEAP32[i13 >> 2] | 0) - i11 | 0;
 HEAP32[i13 >> 2] = i11;
 if (i4 | i11 >>> 0 < 4) HEAP8[i12 >> 0] = 1; else {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i3 + 1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i3 + 2 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i3 + 3 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
  HEAP32[i15 >> 2] = i2;
  i11 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
  HEAP32[i13 >> 2] = i11;
  i1 = i14 + 20 | 0;
  if (!((HEAP8[i12 >> 0] | 0) != 0 | i11 >>> 0 < 4)) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i14 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i14;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   HEAP8[i1 + 1 >> 0] = HEAP8[i14 >> 0] | 0;
   i14 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i14;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   HEAP8[i1 + 2 >> 0] = HEAP8[i14 >> 0] | 0;
   i14 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
   HEAP32[i15 >> 2] = i14;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   HEAP8[i1 + 3 >> 0] = HEAP8[i14 >> 0] | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
   return;
  }
 }
 HEAP8[i12 >> 0] = 1;
 return;
}

function __Z38AnimationClip_CUSTOM_SetEventsInternalP12Il2CppObjectP11Il2CppArray(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i11 = i13 + 24 | 0;
 i12 = i13 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 L1 : do if (i6 | 0) {
  i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = i3 - i2 >> 6;
  if (i7 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i12, i7 - i1 | 0); else if (i7 >>> 0 < i1 >>> 0) {
   i2 = i2 + (i7 << 6) | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i4 = i11 + 4 | 0;
    i5 = i11 + 4 | 0;
    do {
     HEAP32[i10 >> 2] = i3 + -64;
     i1 = i3 + -44 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i1 = HEAP32[i1 >> 2] | 0;
      i14 = HEAP32[i3 + -32 >> 2] | 0;
      HEAP32[i11 >> 2] = 66;
      HEAP32[i4 >> 2] = i14;
      __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
     }
     i1 = i3 + -60 | 0;
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
      i14 = HEAP32[i1 >> 2] | 0;
      i3 = HEAP32[i3 + -48 >> 2] | 0;
      HEAP32[i11 >> 2] = 66;
      HEAP32[i5 >> 2] = i3;
      __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
     }
     i3 = HEAP32[i10 >> 2] | 0;
    } while ((i3 | 0) != (i2 | 0));
   }
  }
  if ((i7 | 0) > 0) {
   i5 = i11 + 36 | 0;
   i1 = 0;
   while (1) {
    i4 = i5;
    i3 = i4 + 36 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i3 | 0));
    i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i6, i1) | 0;
    if (!i2) break;
    i4 = i11;
    i2 = i2 + 8 | 0;
    i3 = i4 + 80 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i4 = i4 + 4 | 0;
     i2 = i2 + 4 | 0;
    } while ((i4 | 0) < (i3 | 0));
    __Z22AnimationEventFromMonoRK18MonoAnimationEventR14AnimationEvent(i11, (HEAP32[i12 >> 2] | 0) + (i1 << 6) | 0);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i7 | 0)) break L1;
   }
   HEAP32[i8 >> 2] = i1;
   __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 937647 | 0, i8);
  }
 } while (0);
 if (!i9) {
  i14 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i14);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) {
  i14 = i9;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i14);
 }
 __ZN13AnimationClip16SetRuntimeEventsERKNSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i1, i12);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i11 + 4 | 0;
  i5 = i11 + 4 | 0;
  do {
   HEAP32[i10 >> 2] = i2 + -64;
   i3 = i2 + -44 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i3 >> 2] | 0;
    i9 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
   }
   i3 = i2 + -60 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i3 >> 2] | 0;
    i9 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i5 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
   }
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i14 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 25;
 HEAP32[i11 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __Z40UnityAnalyticsHandler_CUSTOM_TransactionP12Il2CppObjectP12Il2CppStringdS2_(i1, i2, d7, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d7 = +d7;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 80 | 0;
 i4 = i14 + 76 | 0;
 i5 = i14 + 72 | 0;
 i11 = i14 + 56 | 0;
 i12 = i14 + 40 | 0;
 i13 = i14 + 24 | 0;
 i9 = i14 + 12 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 __ZN11ICallStringC2EP12Il2CppString(i5, i3);
 if (__ZNK11ICallString6IsNullEv(i4) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038856 | 0, i14);
 if (__ZNK11ICallString6IsNullEv(i5) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038874 | 0, i14 + 8 | 0);
 if (!i1) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i6) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i12, i4);
 i3 = HEAP8[i12 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
 i3 = i1 ? HEAP32[i12 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i8 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i8 = 12;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i4 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i8 = 12;
 }
 if ((i8 | 0) == 12) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i5);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i8 = 16;
 } else if (i4 >>> 0 < 11) {
  i2 = i13 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i13; else {
   i1 = i13;
   i8 = 18;
  }
 } else i8 = 16;
 if ((i8 | 0) == 16) {
  i2 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i4;
  i2 = i13 + 11 | 0;
  i8 = 18;
 }
 if ((i8 | 0) == 18) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_(i6, i11, d7, i13) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i8 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if ((HEAP8[i11 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i1, i2, i24) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i24 = i24 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i25 = 0, i26 = 0, f27 = f0, f28 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26;
 f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f6 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f7 = Math_fround(-f6);
 f10 = Math_fround(-f8);
 f11 = Math_fround(-f9);
 f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f15 - f18);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f14 - f17);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f13 - f16);
 HEAPF32[i25 >> 2] = f4;
 HEAPF32[i25 + 4 >> 2] = f5;
 HEAPF32[i25 + 8 >> 2] = f3;
 f15 = Math_fround(f18 + f15);
 HEAPF32[i25 + 12 >> 2] = f15;
 HEAPF32[i25 + 16 >> 2] = f5;
 HEAPF32[i25 + 20 >> 2] = f3;
 f14 = Math_fround(f17 + f14);
 HEAPF32[i25 + 24 >> 2] = f4;
 HEAPF32[i25 + 28 >> 2] = f14;
 HEAPF32[i25 + 32 >> 2] = f3;
 HEAPF32[i25 + 36 >> 2] = f15;
 HEAPF32[i25 + 40 >> 2] = f14;
 HEAPF32[i25 + 44 >> 2] = f3;
 f13 = Math_fround(f16 + f13);
 HEAPF32[i25 + 48 >> 2] = f4;
 HEAPF32[i25 + 52 >> 2] = f5;
 HEAPF32[i25 + 56 >> 2] = f13;
 HEAPF32[i25 + 60 >> 2] = f15;
 HEAPF32[i25 + 64 >> 2] = f5;
 HEAPF32[i25 + 68 >> 2] = f13;
 HEAPF32[i25 + 72 >> 2] = f4;
 HEAPF32[i25 + 76 >> 2] = f14;
 HEAPF32[i25 + 80 >> 2] = f13;
 HEAPF32[i25 + 84 >> 2] = f15;
 HEAPF32[i25 + 88 >> 2] = f14;
 HEAPF32[i25 + 92 >> 2] = f13;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f22 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 i2 = 0;
 while (1) {
  f28 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f14 * f5)) + Math_fround(f15 * f3)));
  f27 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f4 * f17) + Math_fround(f5 * f18)) + Math_fround(f3 * f19)));
  f5 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f4 * f21) + Math_fround(f5 * f22)) + Math_fround(f3 * f23)));
  f8 = f28 < f8 ? f28 : f8;
  f6 = f27 < f6 ? f27 : f6;
  f4 = f5 < f9 ? f5 : f9;
  f3 = f10 < f28 ? f28 : f10;
  f7 = f7 < f27 ? f27 : f7;
  f5 = f11 < f5 ? f5 : f11;
  i1 = i2 + 1 | 0;
  if ((i1 | 0) == 8) break;
  f27 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) >> 2]);
  f28 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 4 >> 2]);
  i2 = i1;
  f9 = f4;
  f10 = f3;
  f11 = f5;
  f4 = f27;
  f5 = f28;
  f3 = Math_fround(HEAPF32[i25 + (i1 * 12 | 0) + 8 >> 2]);
 }
 f21 = Math_fround(Math_fround(f6 + f7) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f4 + f5) * Math_fround(.5));
 f23 = Math_fround(Math_fround(f3 - f8) * Math_fround(.5));
 f27 = Math_fround(Math_fround(f7 - f6) * Math_fround(.5));
 f28 = Math_fround(Math_fround(f5 - f4) * Math_fround(.5));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(f8 + f3) * Math_fround(.5));
 HEAPF32[i24 + 4 >> 2] = f21;
 HEAPF32[i24 + 8 >> 2] = f22;
 HEAPF32[i24 + 12 >> 2] = f23;
 HEAPF32[i24 + 16 >> 2] = f27;
 HEAPF32[i24 + 20 >> 2] = f28;
 STACKTOP = i26;
 return;
}

function __ZN19ComputeShaderKernel8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i7 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1037646 | 0, gb + 469407 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i4, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 4 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469507 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469511 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469520 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469536 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469546 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469557 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 HEAP32[i7 >> 2] = 3;
 HEAP32[i7 + 4 >> 2] = i4 + 84;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469562 | 0, HEAP32[gb + 37256 >> 2] | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIjLi3EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i11, i9, i10) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = i11 + 56 | 0;
 if (HEAP32[i12 >> 2] & 15 | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 369889 | 0, 0, gb + 368833 | 0, 179, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i1 = i11 + 55 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 if (i2 << 24 >> 24 == -1) {
  i8 = __ZNK10GameObject8IsActiveEv(i11) | 0;
  i5 = 1;
 } else {
  HEAP8[i1 >> 0] = -1;
  i5 = __ZNK10GameObject8IsActiveEv(i11) | 0;
  i8 = i5;
  i5 = i2 << 24 >> 24 != 0 ^ i5;
 }
 HEAP32[i12 >> 2] = i8 ? 1 : 4;
 i6 = i11 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i11 + 40 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 3) | 0;
 L9 : do if (i4 | 0) {
  i3 = HEAP32[gb + 28940 + 24 >> 2] | 0;
  i4 = HEAP32[gb + 28940 + 28 >> 2] | 0;
  while (1) {
   if (((HEAP32[i1 >> 2] | 0) - i3 | 0) >>> 0 < i4 >>> 0) break;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i2 | 0)) break L9;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1 + 92 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i2 = i1 + 80 | 0;
    i1 = 0;
    do {
     __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, i9, i10);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
  }
 } while (0);
 do if (i5) {
  HEAP32[i12 >> 2] = i8 ? 2 : 8;
  if (HEAP32[i7 >> 2] | 0) if (i8) {
   i1 = 0;
   do {
    i9 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    HEAP32[i9 + 28 >> 2] = i11;
    __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode(i10, i9, 0, 0, -1);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  } else {
   i1 = 0;
   do {
    i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0, i9 | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
  if (!i8) {
   i1 = i11 + 68 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break;
   i11 = i11 + 72 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[HEAP32[i11 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   break;
  }
  i3 = i11 + 68 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i10 = i11 + 72 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
  }
  if (__ZNK10GameObject8IsActiveEv(i11) | 0) {
   i2 = HEAP32[gb + 1104660 >> 2] | 0;
   if (!(HEAP16[i11 + 52 >> 1] | 0)) {
    i2 = i2 + 8 | 0;
    if ((i3 | 0) == (i2 | 0)) break;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) i1 = i11 + 72 | 0; else {
     i11 = i11 + 72 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
     HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     i1 = i11;
    }
    i11 = HEAP32[i2 >> 2] | 0;
    HEAP32[i3 >> 2] = i11;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i11 + 4 >> 2] = i3;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
    break;
   } else {
    if ((i3 | 0) == (i2 | 0)) break;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) i1 = i11 + 72 | 0; else {
     i11 = i11 + 72 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
     HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
     HEAP32[i3 >> 2] = 0;
     HEAP32[i11 >> 2] = 0;
     i1 = i11;
    }
    i11 = HEAP32[i2 >> 2] | 0;
    HEAP32[i3 >> 2] = i11;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i11 + 4 >> 2] = i3;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
    break;
   }
  }
 } while (0);
 HEAP32[i12 >> 2] = 0;
 return;
}

function runPostSets110() {
 HEAP32[gb + 100368 >> 2] = fb + 1;
 HEAP32[gb + 100372 >> 2] = fb + 1;
 HEAP32[gb + 100376 >> 2] = fb + 1;
 HEAP32[gb + 100380 >> 2] = fb + 1;
 HEAP32[gb + 100384 >> 2] = fb + 1;
 HEAP32[gb + 100388 >> 2] = fb + 1;
 HEAP32[gb + 100392 >> 2] = fb + 1;
 HEAP32[gb + 100396 >> 2] = fb + 1;
 HEAP32[gb + 100400 >> 2] = fb + 1;
 HEAP32[gb + 100404 >> 2] = fb + 1;
 HEAP32[gb + 100408 >> 2] = fb + 1;
 HEAP32[gb + 100412 >> 2] = fb + 1;
 HEAP32[gb + 100416 >> 2] = fb + 1;
 HEAP32[gb + 100420 >> 2] = fb + 1;
 HEAP32[gb + 100424 >> 2] = fb + 1;
 HEAP32[gb + 100428 >> 2] = fb + 1;
 HEAP32[gb + 100432 >> 2] = fb + 1;
 HEAP32[gb + 100436 >> 2] = fb + 1;
 HEAP32[gb + 100440 >> 2] = fb + 1;
 HEAP32[gb + 100444 >> 2] = fb + 1;
 HEAP32[gb + 100448 >> 2] = fb + 1;
 HEAP32[gb + 100452 >> 2] = fb + 1;
 HEAP32[gb + 100456 >> 2] = fb + 1;
 HEAP32[gb + 100460 >> 2] = fb + 1;
 HEAP32[gb + 100464 >> 2] = fb + 1;
 HEAP32[gb + 100468 >> 2] = fb + 77;
 HEAP32[gb + 100472 >> 2] = fb + 1;
 HEAP32[gb + 100476 >> 2] = fb + 1;
 HEAP32[gb + 100480 >> 2] = fb + 1;
 HEAP32[gb + 100484 >> 2] = fb + 1;
 HEAP32[gb + 100488 >> 2] = fb + 1;
 HEAP32[gb + 100492 >> 2] = fb + 1;
 HEAP32[gb + 100496 >> 2] = fb + 1;
 HEAP32[gb + 100500 >> 2] = fb + 1;
 HEAP32[gb + 100504 >> 2] = fb + 1;
 HEAP32[gb + 100508 >> 2] = fb + 1;
 HEAP32[gb + 100512 >> 2] = fb + 1;
 HEAP32[gb + 100516 >> 2] = fb + 1;
 HEAP32[gb + 100520 >> 2] = fb + 1;
 HEAP32[gb + 100524 >> 2] = fb + 1;
 HEAP32[gb + 100528 >> 2] = fb + 1;
 HEAP32[gb + 100532 >> 2] = fb + 1;
 HEAP32[gb + 100536 >> 2] = fb + 1;
 HEAP32[gb + 100540 >> 2] = fb + 1;
 HEAP32[gb + 100544 >> 2] = fb + 1;
 HEAP32[gb + 100548 >> 2] = fb + 1;
 HEAP32[gb + 100560 >> 2] = fb + 1407;
 HEAP32[gb + 100564 >> 2] = fb + 1408;
 HEAP32[gb + 100568 >> 2] = fb + 1409;
 HEAP32[gb + 100572 >> 2] = fb + 211;
 HEAP32[gb + 100576 >> 2] = fb + 705;
 HEAP32[gb + 100580 >> 2] = fb + 1100;
 HEAP32[gb + 100584 >> 2] = fb + 1101;
 HEAP32[gb + 100588 >> 2] = fb + 706;
 HEAP32[gb + 100592 >> 2] = fb + 707;
 HEAP32[gb + 100596 >> 2] = fb + 1102;
 HEAP32[gb + 100600 >> 2] = fb + 212;
 HEAP32[gb + 100604 >> 2] = fb + 1103;
 HEAP32[gb + 100608 >> 2] = fb + 213;
 HEAP32[gb + 100612 >> 2] = fb + 214;
 HEAP32[gb + 100616 >> 2] = fb + 90;
 HEAP32[gb + 100620 >> 2] = fb + 1104;
 HEAP32[gb + 100624 >> 2] = fb + 215;
 HEAP32[gb + 100628 >> 2] = fb + 1105;
 HEAP32[gb + 100632 >> 2] = fb + 306;
 HEAP32[gb + 100636 >> 2] = fb + 53;
 HEAP32[gb + 100640 >> 2] = fb + 154;
 HEAP32[gb + 100644 >> 2] = fb + 708;
 HEAP32[gb + 100648 >> 2] = fb + 89;
 HEAP32[gb + 100652 >> 2] = fb + 709;
 HEAP32[gb + 100656 >> 2] = fb + 90;
 HEAP32[gb + 100660 >> 2] = fb + 710;
 HEAP32[gb + 100664 >> 2] = fb + 91;
 HEAP32[gb + 100668 >> 2] = fb + 91;
 HEAP32[gb + 100672 >> 2] = fb + 92;
 HEAP32[gb + 100676 >> 2] = fb + 711;
 HEAP32[gb + 100680 >> 2] = fb + 712;
 HEAP32[gb + 100684 >> 2] = fb + 713;
 HEAP32[gb + 100688 >> 2] = fb + 714;
 HEAP32[gb + 100692 >> 2] = fb + 216;
 HEAP32[gb + 100696 >> 2] = fb + 307;
 HEAP32[gb + 100700 >> 2] = fb + 114;
 HEAP32[gb + 100704 >> 2] = fb + 140;
 HEAP32[gb + 100708 >> 2] = fb + 115;
 HEAP32[gb + 100712 >> 2] = fb + 141;
 HEAP32[gb + 100716 >> 2] = fb + 1106;
 HEAP32[gb + 100720 >> 2] = fb + 715;
 HEAP32[gb + 100724 >> 2] = fb + 217;
 HEAP32[gb + 100728 >> 2] = fb + 308;
 HEAP32[gb + 100732 >> 2] = fb + 1107;
 HEAP32[gb + 100736 >> 2] = fb + 1108;
 HEAP32[gb + 100740 >> 2] = fb + 716;
 HEAP32[gb + 100744 >> 2] = fb + 717;
 HEAP32[gb + 100748 >> 2] = fb + 218;
 HEAP32[gb + 100752 >> 2] = fb + 309;
 HEAP32[gb + 100756 >> 2] = fb + 718;
 HEAP32[gb + 100760 >> 2] = fb + 719;
 HEAP32[gb + 100764 >> 2] = fb + 720;
 HEAP32[gb + 100768 >> 2] = fb + 721;
 HEAP32[gb + 100772 >> 2] = fb + 1109;
 runPostSets111();
}

function __ZN19SharedBillboardData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 16 | 0;
 i6 = i3;
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034504 | 0, i9, i1 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 422271 | 0, i9, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034510 | 0, i9, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 500475 | 0, i8, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37328 >> 2] | 0, i6, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 500490 | 0, i8, i1 + 48 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i9, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i9, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 753990 | 0, i8, i1 + 68 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37288 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function runPostSets88() {
 HEAP32[gb + 91040 >> 2] = fb + 150;
 HEAP32[gb + 91052 >> 2] = fb + 1247;
 HEAP32[gb + 91056 >> 2] = fb + 1248;
 HEAP32[gb + 91060 >> 2] = fb + 1245;
 HEAP32[gb + 91064 >> 2] = fb + 1246;
 HEAP32[gb + 91076 >> 2] = fb + 1249;
 HEAP32[gb + 91080 >> 2] = fb + 1250;
 HEAP32[gb + 91084 >> 2] = fb + 1245;
 HEAP32[gb + 91088 >> 2] = fb + 1246;
 HEAP32[gb + 91092 >> 2] = fb + 150;
 HEAP32[gb + 91104 >> 2] = fb + 1251;
 HEAP32[gb + 91108 >> 2] = fb + 1252;
 HEAP32[gb + 91112 >> 2] = fb + 1245;
 HEAP32[gb + 91116 >> 2] = fb + 1246;
 HEAP32[gb + 91120 >> 2] = fb + 150;
 HEAP32[gb + 91132 >> 2] = fb + 1253;
 HEAP32[gb + 91136 >> 2] = fb + 1254;
 HEAP32[gb + 91140 >> 2] = fb + 151;
 HEAP32[gb + 91144 >> 2] = fb + 548;
 HEAP32[gb + 91156 >> 2] = fb + 1255;
 HEAP32[gb + 91160 >> 2] = fb + 1256;
 HEAP32[gb + 91164 >> 2] = fb + 1245;
 HEAP32[gb + 91168 >> 2] = fb + 1246;
 HEAP32[gb + 91172 >> 2] = fb + 150;
 HEAP32[gb + 91184 >> 2] = fb + 1125;
 HEAP32[gb + 91188 >> 2] = fb + 1257;
 HEAP32[gb + 91192 >> 2] = fb + 1258;
 HEAP32[gb + 91196 >> 2] = fb + 549;
 HEAP32[gb + 91200 >> 2] = fb + 1127;
 HEAP32[gb + 91204 >> 2] = fb + 1128;
 HEAP32[gb + 91208 >> 2] = fb + 469;
 HEAP32[gb + 91212 >> 2] = fb + 1129;
 HEAP32[gb + 91216 >> 2] = fb + 1259;
 HEAP32[gb + 91228 >> 2] = fb + 1260;
 HEAP32[gb + 91232 >> 2] = fb + 1261;
 HEAP32[gb + 91236 >> 2] = fb + 1245;
 HEAP32[gb + 91240 >> 2] = fb + 1246;
 HEAP32[gb + 91244 >> 2] = fb + 150;
 HEAP32[gb + 91256 >> 2] = fb + 1262;
 HEAP32[gb + 91260 >> 2] = fb + 550;
 HEAP32[gb + 91264 >> 2] = fb + 456;
 HEAP32[gb + 91268 >> 2] = fb + 1263;
 HEAP32[gb + 91272 >> 2] = fb + 1264;
 HEAP32[gb + 91276 >> 2] = fb + 262;
 HEAP32[gb + 91280 >> 2] = fb + 551;
 HEAP32[gb + 91284 >> 2] = fb + 908;
 HEAP32[gb + 91288 >> 2] = fb + 552;
 HEAP32[gb + 91292 >> 2] = fb + 50;
 HEAP32[gb + 91296 >> 2] = fb + 75;
 HEAP32[gb + 91300 >> 2] = fb + 909;
 HEAP32[gb + 91304 >> 2] = fb + 553;
 HEAP32[gb + 91308 >> 2] = fb + 910;
 HEAP32[gb + 91312 >> 2] = fb + 554;
 HEAP32[gb + 91316 >> 2] = fb + 152;
 HEAP32[gb + 91320 >> 2] = fb + 153;
 HEAP32[gb + 91324 >> 2] = fb + 555;
 HEAP32[gb + 91328 >> 2] = fb + 51;
 HEAP32[gb + 91332 >> 2] = fb + 76;
 HEAP32[gb + 91336 >> 2] = fb + 52;
 HEAP32[gb + 91340 >> 2] = fb + 77;
 HEAP32[gb + 91344 >> 2] = fb + 53;
 HEAP32[gb + 91348 >> 2] = fb + 78;
 HEAP32[gb + 91352 >> 2] = fb + 1265;
 HEAP32[gb + 91356 >> 2] = fb + 1266;
 HEAP32[gb + 91360 >> 2] = fb + 142;
 HEAP32[gb + 91364 >> 2] = fb + 556;
 HEAP32[gb + 91368 >> 2] = fb + 143;
 HEAP32[gb + 91372 >> 2] = fb + 911;
 HEAP32[gb + 91376 >> 2] = fb + 557;
 HEAP32[gb + 91380 >> 2] = fb + 12;
 HEAP32[gb + 91384 >> 2] = fb + 558;
 HEAP32[gb + 91388 >> 2] = fb + 1;
 HEAP32[gb + 91392 >> 2] = fb + 1;
 HEAP32[gb + 91396 >> 2] = fb + 912;
 HEAP32[gb + 91400 >> 2] = fb + 36;
 HEAP32[gb + 91404 >> 2] = fb + 11;
 HEAP32[gb + 91408 >> 2] = fb + 913;
 HEAP32[gb + 91412 >> 2] = fb + 914;
 HEAP32[gb + 91424 >> 2] = fb + 1267;
 HEAP32[gb + 91428 >> 2] = fb + 559;
 HEAP32[gb + 91432 >> 2] = fb + 456;
 HEAP32[gb + 91436 >> 2] = fb + 1268;
 HEAP32[gb + 91440 >> 2] = fb + 1269;
 HEAP32[gb + 91444 >> 2] = fb + 263;
 HEAP32[gb + 91448 >> 2] = fb + 915;
 HEAP32[gb + 91452 >> 2] = fb + 916;
 HEAP32[gb + 91456 >> 2] = fb + 917;
 HEAP32[gb + 91460 >> 2] = fb + 918;
 HEAP32[gb + 91464 >> 2] = fb + 919;
 HEAP32[gb + 91468 >> 2] = fb + 920;
 HEAP32[gb + 91472 >> 2] = fb + 921;
 HEAP32[gb + 91476 >> 2] = fb + 922;
 HEAP32[gb + 91480 >> 2] = fb + 923;
 HEAP32[gb + 91484 >> 2] = fb + 560;
 HEAP32[gb + 91488 >> 2] = fb + 54;
 HEAP32[gb + 91492 >> 2] = fb + 79;
 HEAP32[gb + 91496 >> 2] = fb + 55;
 HEAP32[gb + 91500 >> 2] = fb + 80;
 HEAP32[gb + 91504 >> 2] = fb + 56;
 HEAP32[gb + 91508 >> 2] = fb + 81;
 runPostSets89();
}

function runPostSets62() {
 HEAP32[gb + 70508 >> 2] = fb + 31;
 HEAP32[gb + 70512 >> 2] = fb + 6;
 HEAP32[gb + 70516 >> 2] = fb + 6;
 HEAP32[gb + 70520 >> 2] = fb + 7;
 HEAP32[gb + 70524 >> 2] = fb + 7;
 HEAP32[gb + 70528 >> 2] = fb + 90;
 HEAP32[gb + 70532 >> 2] = fb + 16;
 HEAP32[gb + 70536 >> 2] = fb + 91;
 HEAP32[gb + 70540 >> 2] = fb + 32;
 HEAP32[gb + 70544 >> 2] = fb + 92;
 HEAP32[gb + 70548 >> 2] = fb + 93;
 HEAP32[gb + 70552 >> 2] = fb + 47;
 HEAP32[gb + 70556 >> 2] = fb + 94;
 HEAP32[gb + 70560 >> 2] = fb + 650;
 HEAP32[gb + 70564 >> 2] = fb + 651;
 HEAP32[gb + 70568 >> 2] = fb + 345;
 HEAP32[gb + 70572 >> 2] = fb + 50;
 HEAP32[gb + 70576 >> 2] = fb + 95;
 HEAP32[gb + 70580 >> 2] = fb + 96;
 HEAP32[gb + 70584 >> 2] = fb + 97;
 HEAP32[gb + 70588 >> 2] = fb + 98;
 HEAP32[gb + 70592 >> 2] = fb + 48;
 HEAP32[gb + 70596 >> 2] = fb + 99;
 HEAP32[gb + 70600 >> 2] = fb + 51;
 HEAP32[gb + 70604 >> 2] = fb + 33;
 HEAP32[gb + 70608 >> 2] = fb + 100;
 HEAP32[gb + 70612 >> 2] = fb + 101;
 HEAP32[gb + 70616 >> 2] = fb + 52;
 HEAP32[gb + 70620 >> 2] = fb + 102;
 HEAP32[gb + 70624 >> 2] = fb + 53;
 HEAP32[gb + 70628 >> 2] = fb + 54;
 HEAP32[gb + 70632 >> 2] = fb + 55;
 HEAP32[gb + 70636 >> 2] = fb + 56;
 HEAP32[gb + 70640 >> 2] = fb + 49;
 HEAP32[gb + 70644 >> 2] = fb + 57;
 HEAP32[gb + 70648 >> 2] = fb + 8;
 HEAP32[gb + 70652 >> 2] = fb + 103;
 HEAP32[gb + 70656 >> 2] = fb + 104;
 HEAP32[gb + 70668 >> 2] = fb + 791;
 HEAP32[gb + 70672 >> 2] = fb + 792;
 HEAP32[gb + 70676 >> 2] = fb + 346;
 HEAP32[gb + 70680 >> 2] = fb + 347;
 HEAP32[gb + 70684 >> 2] = fb + 3;
 HEAP32[gb + 70688 >> 2] = fb + 17;
 HEAP32[gb + 70692 >> 2] = fb + 4;
 HEAP32[gb + 70696 >> 2] = fb + 18;
 HEAP32[gb + 70700 >> 2] = fb + 34;
 HEAP32[gb + 70704 >> 2] = fb + 348;
 HEAP32[gb + 70708 >> 2] = fb + 58;
 HEAP32[gb + 70712 >> 2] = fb + 349;
 HEAP32[gb + 70716 >> 2] = fb + 350;
 HEAP32[gb + 70728 >> 2] = fb + 793;
 HEAP32[gb + 70732 >> 2] = fb + 794;
 HEAP32[gb + 70736 >> 2] = fb + 35;
 HEAP32[gb + 70740 >> 2] = fb + 8;
 HEAP32[gb + 70744 >> 2] = fb + 9;
 HEAP32[gb + 70748 >> 2] = fb + 9;
 HEAP32[gb + 70752 >> 2] = fb + 10;
 HEAP32[gb + 70756 >> 2] = fb + 105;
 HEAP32[gb + 70760 >> 2] = fb + 19;
 HEAP32[gb + 70764 >> 2] = fb + 106;
 HEAP32[gb + 70768 >> 2] = fb + 36;
 HEAP32[gb + 70772 >> 2] = fb + 107;
 HEAP32[gb + 70780 >> 2] = (HEAP32[gb + 70780 >> 2] | 0) + (gb + 489852 | 0);
 HEAP32[gb + 70816 >> 2] = fb + 795;
 HEAP32[gb + 70820 >> 2] = fb + 796;
 HEAP32[gb + 70824 >> 2] = (HEAP32[gb + 70824 >> 2] | 0) + (gb + 491448 | 0);
 HEAP32[gb + 70836 >> 2] = fb + 797;
 HEAP32[gb + 70840 >> 2] = fb + 798;
 HEAP32[gb + 70852 >> 2] = fb + 799;
 HEAP32[gb + 70856 >> 2] = fb + 800;
 HEAP32[gb + 70860 >> 2] = fb + 37;
 HEAP32[gb + 70864 >> 2] = fb + 10;
 HEAP32[gb + 70868 >> 2] = fb + 11;
 HEAP32[gb + 70872 >> 2] = fb + 11;
 HEAP32[gb + 70876 >> 2] = fb + 12;
 HEAP32[gb + 70880 >> 2] = fb + 108;
 HEAP32[gb + 70884 >> 2] = fb + 20;
 HEAP32[gb + 70888 >> 2] = fb + 109;
 HEAP32[gb + 70892 >> 2] = fb + 38;
 HEAP32[gb + 70896 >> 2] = fb + 110;
 HEAP32[gb + 70900 >> 2] = fb + 111;
 HEAP32[gb + 70904 >> 2] = fb + 50;
 HEAP32[gb + 70908 >> 2] = fb + 112;
 HEAP32[gb + 70912 >> 2] = fb + 652;
 HEAP32[gb + 70916 >> 2] = fb + 653;
 HEAP32[gb + 70920 >> 2] = fb + 351;
 HEAP32[gb + 70924 >> 2] = fb + 59;
 HEAP32[gb + 70928 >> 2] = fb + 113;
 HEAP32[gb + 70932 >> 2] = fb + 114;
 HEAP32[gb + 70936 >> 2] = fb + 115;
 HEAP32[gb + 70940 >> 2] = fb + 116;
 HEAP32[gb + 70944 >> 2] = fb + 51;
 HEAP32[gb + 70948 >> 2] = fb + 117;
 HEAP32[gb + 70952 >> 2] = fb + 60;
 HEAP32[gb + 70956 >> 2] = fb + 39;
 HEAP32[gb + 70960 >> 2] = fb + 118;
 HEAP32[gb + 70964 >> 2] = fb + 119;
 HEAP32[gb + 70968 >> 2] = fb + 61;
 HEAP32[gb + 70972 >> 2] = fb + 120;
 runPostSets63();
}

function __ZN7Terrain10FlushDirtyEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i7 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i5 = 10; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) i5 = 10;
 } while (0);
 if ((i5 | 0) == 10) __ZN7Terrain5FlushEv(i7);
 i6 = i7 + 224 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = (i4 & 1 | 0) == 0;
 i2 = (i4 & 3 | 0) == 0;
 if (i4 & 4 | 0) {
  i3 = i7 + 228 | 0;
  i4 = i7 + 240 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   do {
    __ZN15TerrainRenderer22ReloadPrecomputedErrorEv(HEAP32[i1 + 4 >> 2] | 0);
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 if (!i2) {
  i2 = i7 + 228 | 0;
  i3 = i7 + 240 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   do {
    __ZN12TreeRenderer11ReloadTreesEv(HEAP32[i1 + 8 >> 2] | 0);
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 if (!i5) {
  i2 = i7 + 228 | 0;
  i3 = i7 + 240 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   do {
    i9 = HEAP32[i1 + 12 >> 2] | 0;
    i4 = i9 + 64 | 0;
    i5 = i9 + 68 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i4, HEAP32[i5 >> 2] | 0);
    HEAP32[i9 + 72 >> 2] = 0;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i5 >> 2] = 0;
    i5 = i9 + 76 | 0;
    i4 = i9 + 80 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i5, HEAP32[i4 >> 2] | 0);
    HEAP32[i9 + 84 >> 2] = 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i4 >> 2] = 0;
    i4 = i9 + 88 | 0;
    i5 = i9 + 92 | 0;
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i4, HEAP32[i5 >> 2] | 0);
    HEAP32[i9 + 96 >> 2] = 0;
    HEAP32[i4 >> 2] = i5;
    HEAP32[i5 >> 2] = 0;
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 if (HEAP32[i6 >> 2] & 1 | 0) {
  i2 = i7 + 228 | 0;
  i3 = i7 + 240 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   do {
    __ZN15TerrainRenderer9ReloadAllEv(HEAP32[i1 + 4 >> 2] | 0);
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 i1 = HEAP32[i7 + 112 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 __ZN14SplatMaterials15UpdateMaterialsEv(i1);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function runPostSets5() {
 HEAP32[gb + 26988 >> 2] = fb + 67;
 HEAP32[gb + 26992 >> 2] = fb + 68;
 HEAP32[gb + 26996 >> 2] = fb + 69;
 HEAP32[gb + 27e3 >> 2] = fb + 70;
 HEAP32[gb + 27004 >> 2] = fb + 6;
 HEAP32[gb + 27008 >> 2] = fb + 7;
 HEAP32[gb + 27012 >> 2] = fb + 47;
 HEAP32[gb + 27016 >> 2] = fb + 43;
 HEAP32[gb + 27020 >> 2] = fb + 54;
 HEAP32[gb + 27024 >> 2] = fb + 38;
 HEAP32[gb + 27028 >> 2] = fb + 39;
 HEAP32[gb + 27032 >> 2] = fb + 22;
 HEAP32[gb + 27036 >> 2] = fb + 55;
 HEAP32[gb + 27040 >> 2] = fb + 71;
 HEAP32[gb + 27056 >> 2] = fb + 51;
 HEAP32[gb + 27060 >> 2] = fb + 52;
 HEAP32[gb + 27064 >> 2] = fb + 14;
 HEAP32[gb + 27068 >> 2] = fb + 7;
 HEAP32[gb + 27072 >> 2] = fb + 56;
 HEAP32[gb + 27076 >> 2] = fb + 40;
 HEAP32[gb + 27080 >> 2] = fb + 41;
 HEAP32[gb + 27084 >> 2] = fb + 42;
 HEAP32[gb + 27088 >> 2] = fb + 77;
 HEAP32[gb + 27092 >> 2] = fb + 78;
 HEAP32[gb + 27096 >> 2] = fb + 79;
 HEAP32[gb + 27100 >> 2] = fb + 80;
 HEAP32[gb + 27104 >> 2] = fb + 68;
 HEAP32[gb + 27108 >> 2] = fb + 81;
 HEAP32[gb + 27112 >> 2] = fb + 70;
 HEAP32[gb + 27116 >> 2] = fb + 6;
 HEAP32[gb + 27120 >> 2] = fb + 7;
 HEAP32[gb + 27124 >> 2] = fb + 57;
 HEAP32[gb + 27128 >> 2] = fb + 53;
 HEAP32[gb + 27132 >> 2] = fb + 58;
 HEAP32[gb + 27136 >> 2] = fb + 43;
 HEAP32[gb + 27140 >> 2] = fb + 44;
 HEAP32[gb + 27144 >> 2] = fb + 22;
 HEAP32[gb + 27148 >> 2] = fb + 59;
 HEAP32[gb + 27152 >> 2] = fb + 71;
 HEAP32[gb + 27164 >> 2] = fb + 54;
 HEAP32[gb + 27168 >> 2] = fb + 55;
 HEAP32[gb + 27172 >> 2] = fb + 15;
 HEAP32[gb + 27176 >> 2] = fb + 8;
 HEAP32[gb + 27180 >> 2] = fb + 60;
 HEAP32[gb + 27184 >> 2] = fb + 45;
 HEAP32[gb + 27188 >> 2] = fb + 46;
 HEAP32[gb + 27192 >> 2] = fb + 47;
 HEAP32[gb + 27196 >> 2] = fb + 64;
 HEAP32[gb + 27200 >> 2] = fb + 65;
 HEAP32[gb + 27204 >> 2] = fb + 82;
 HEAP32[gb + 27208 >> 2] = fb + 83;
 HEAP32[gb + 27212 >> 2] = fb + 68;
 HEAP32[gb + 27216 >> 2] = fb + 69;
 HEAP32[gb + 27220 >> 2] = fb + 70;
 HEAP32[gb + 27224 >> 2] = fb + 6;
 HEAP32[gb + 27228 >> 2] = fb + 7;
 HEAP32[gb + 27232 >> 2] = fb + 47;
 HEAP32[gb + 27236 >> 2] = fb + 43;
 HEAP32[gb + 27240 >> 2] = fb + 61;
 HEAP32[gb + 27244 >> 2] = fb + 48;
 HEAP32[gb + 27248 >> 2] = fb + 49;
 HEAP32[gb + 27252 >> 2] = fb + 22;
 HEAP32[gb + 27256 >> 2] = fb + 49;
 HEAP32[gb + 27260 >> 2] = fb + 71;
 HEAP32[gb + 27264 >> 2] = (HEAP32[gb + 27264 >> 2] | 0) + (gb + 365475 | 0);
 HEAP32[gb + 27276 >> 2] = fb + 56;
 HEAP32[gb + 27280 >> 2] = fb + 57;
 HEAP32[gb + 27284 >> 2] = fb + 38;
 HEAP32[gb + 27288 >> 2] = fb + 39;
 HEAP32[gb + 27292 >> 2] = fb + 16;
 HEAP32[gb + 27296 >> 2] = fb + 39;
 HEAP32[gb + 27300 >> 2] = fb + 40;
 HEAP32[gb + 27304 >> 2] = fb + 19;
 HEAP32[gb + 27308 >> 2] = fb + 84;
 HEAP32[gb + 27312 >> 2] = fb + 31;
 HEAP32[gb + 27316 >> 2] = fb + 27;
 HEAP32[gb + 27320 >> 2] = fb + 85;
 HEAP32[gb + 27324 >> 2] = fb + 28;
 HEAP32[gb + 27328 >> 2] = fb + 63;
 HEAP32[gb + 27332 >> 2] = fb + 29;
 HEAP32[gb + 27336 >> 2] = fb + 34;
 HEAP32[gb + 27340 >> 2] = fb + 62;
 HEAP32[gb + 27344 >> 2] = fb + 63;
 HEAP32[gb + 27348 >> 2] = fb + 64;
 HEAP32[gb + 27352 >> 2] = fb + 65;
 HEAP32[gb + 27356 >> 2] = fb + 66;
 HEAP32[gb + 27360 >> 2] = fb + 67;
 HEAP32[gb + 27364 >> 2] = fb + 36;
 HEAP32[gb + 27376 >> 2] = (HEAP32[gb + 27376 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 27380 >> 2] = (HEAP32[gb + 27380 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 27416 >> 2] = fb + 58;
 HEAP32[gb + 27420 >> 2] = fb + 59;
 HEAP32[gb + 27424 >> 2] = fb + 86;
 HEAP32[gb + 27428 >> 2] = fb + 4;
 HEAP32[gb + 27432 >> 2] = fb + 87;
 HEAP32[gb + 27436 >> 2] = fb + 68;
 HEAP32[gb + 27440 >> 2] = fb + 88;
 HEAP32[gb + 27444 >> 2] = fb + 69;
 HEAP32[gb + 27448 >> 2] = fb + 60;
 HEAP32[gb + 27452 >> 2] = fb + 1;
 runPostSets6();
}

function __ZN2UI14CanvasRenderer13SyncVertexPtrER8JobFenceNS0_8SyncFlagE(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i10 + 188 >> 2] | 0;
 if (i6 | 0) {
  if (!(HEAP8[i10 + 164 >> 0] | 0)) {
   i4 = HEAP32[i10 + 88 >> 2] | 0;
   if (!i4) {
    i2 = 0;
    i1 = 0;
   } else {
    i5 = HEAP32[i10 + 76 >> 2] | 0;
    i2 = 0;
    i1 = 0;
    i3 = 0;
    do {
     i1 = (HEAP32[i5 + (i3 * 52 | 0) + 48 >> 2] | 0) + i1 | 0;
     i2 = (HEAP32[i5 + (i3 * 52 | 0) + 36 >> 2] | 0) + i2 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < 8 & i3 >>> 0 < i4 >>> 0);
   }
  } else {
   i2 = 0;
   i1 = 0;
  }
  i4 = HEAPU8[i10 + 184 >> 0] | 0;
  i3 = i1 << i4;
  i4 = i2 << i4;
  i1 = i10 + 192 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i8 = i6 + 216 | 0;
   HEAP32[i8 >> 2] = i3 - i2 + (HEAP32[i8 >> 2] | 0);
   HEAP32[i1 >> 2] = i3;
  }
  i1 = i10 + 196 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i8 = i6 + 220 | 0;
   HEAP32[i8 >> 2] = i4 - i2 + (HEAP32[i8 >> 2] | 0);
   HEAP32[i1 >> 2] = i4;
  }
 }
 if (i9 & 1 | 0) {
  i6 = HEAP32[i10 + 204 >> 2] | 0;
  i5 = i6 + 112 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 2;
  i5 = HEAP32[i10 + 208 >> 2] | 0;
  i6 = HEAP32[i6 + 84 >> 2] | 0;
  i1 = HEAP32[i10 + 48 >> 2] | 0;
  i2 = i6 + (i5 * 672 | 0) + 476 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i8 = i3 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
   }
   HEAP32[i2 >> 2] = 0;
  }
  if (i1 | 0) {
   HEAP32[i2 >> 2] = i1;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  }
  i3 = i10 + 88 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
   i4 = i10 + 76 | 0;
   i2 = 0;
   do {
    i1 = i6 + (i5 * 672 | 0) + 32 + (i2 * 52 | 0) | 0;
    i7 = (HEAP32[i4 >> 2] | 0) + (i2 * 52 | 0) | 0;
    i8 = i1 + 52 | 0;
    do {
     HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
     i1 = i1 + 4 | 0;
     i7 = i7 + 4 | 0;
    } while ((i1 | 0) < (i8 | 0));
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) < 8 & i2 >>> 0 < i1 >>> 0);
  }
  i8 = HEAP32[i10 + 108 >> 2] | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
  HEAP32[i6 + (i5 * 672 | 0) + 448 >> 2] = (i8 | 0) > 8 ? 8 : i8;
  HEAP16[i6 + (i5 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!(i9 & 2)) return;
 i5 = HEAP32[i10 + 220 >> 2] | 0;
 i6 = i5 + 112 | 0;
 HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 2;
 i6 = HEAP32[i10 + 224 >> 2] | 0;
 i5 = HEAP32[i5 + 84 >> 2] | 0;
 i1 = HEAP32[i10 + 48 >> 2] | 0;
 i2 = i5 + (i6 * 672 | 0) + 476 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i9 = i3 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i9 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 i3 = i10 + 88 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i4 = i10 + 76 | 0;
  i2 = 0;
  do {
   i1 = i5 + (i6 * 672 | 0) + 32 + (i2 * 52 | 0) | 0;
   i7 = (HEAP32[i4 >> 2] | 0) + (i2 * 52 | 0) | 0;
   i8 = i1 + 52 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
    i1 = i1 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i1 | 0) < (i8 | 0));
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) < 8 & i2 >>> 0 < i1 >>> 0);
 }
 i10 = HEAP32[i10 + 128 >> 2] | 0;
 i10 = i1 >>> 0 < i10 >>> 0 ? i1 : i10;
 HEAP32[i5 + (i6 * 672 | 0) + 448 >> 2] = (i10 | 0) > 8 ? 8 : i10;
 HEAP16[i5 + (i6 * 672 | 0) + 664 >> 1] = 2;
 return;
}

function __ZN2UI19DistanceToRectangleEP8Vector3f8Vector2f(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 24 | 0;
 i10 = i16 + 12 | 0;
 i11 = i16;
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 i14 = f13 > f12;
 f7 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 i2 = f7 > f12;
 if (i2 ^ i14) {
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(f9 + Math_fround(Math_fround(Math_fround(f12 - f7) * Math_fround(f3 - f9)) / Math_fround(f13 - f7)))) i1 = 1; else i1 = 0;
 } else i1 = 0;
 f9 = Math_fround(HEAPF32[i5 + 28 >> 2]);
 i4 = f9 > f12;
 if (i4 ^ i2) {
  f17 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f3 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(f3 + Math_fround(Math_fround(Math_fround(f12 - f9) * Math_fround(f17 - f3)) / Math_fround(f7 - f9)))) i1 = i1 ^ 1;
 }
 f3 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 i2 = f3 > f12;
 if (i2 ^ i4) {
  f18 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(f17 + Math_fround(Math_fround(Math_fround(f12 - f3) * Math_fround(f18 - f17)) / Math_fround(f9 - f3)))) i1 = i1 ^ 1;
 }
 if (i14 ^ i2) {
  f17 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  f18 = Math_fround(HEAPF32[i5 >> 2]);
  if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(f18 + Math_fround(Math_fround(Math_fround(f12 - f13) * Math_fround(f17 - f18)) / Math_fround(f3 - f13)))) {
   if (!i1) {
    f18 = Math_fround(0.0);
    STACKTOP = i16;
    return Math_fround(f18);
   }
  } else i15 = 15;
 } else i15 = 15;
 if ((i15 | 0) == 15) if (i1) {
  f18 = Math_fround(0.0);
  STACKTOP = i16;
  return Math_fround(f18);
 }
 i20 = HEAP32[i6 >> 2] | 0;
 i19 = i8 + 4 | 0;
 i1 = i8 + 8 | 0;
 i2 = i10 + 4 | 0;
 i4 = i10 + 8 | 0;
 i14 = i11 + 4 | 0;
 i15 = i11 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i22 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = i20;
 HEAPF32[i19 >> 2] = f12;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 >> 2] = i6;
 HEAPF32[i2 >> 2] = f13;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = i22;
 HEAPF32[i14 >> 2] = f7;
 HEAP32[i15 >> 2] = 0;
 f18 = Math_fround(__ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_(i8, i10, i11));
 i21 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i8 >> 2] = i20;
 HEAPF32[i19 >> 2] = f12;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 >> 2] = i22;
 HEAPF32[i2 >> 2] = f7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = i21;
 HEAPF32[i14 >> 2] = f9;
 HEAP32[i15 >> 2] = 0;
 f17 = Math_fround(__ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_(i8, i10, i11));
 i22 = f18 < Math_fround(0.0) | f17 < f18;
 f18 = i22 ? f17 : f18;
 i5 = HEAP32[i5 + 36 >> 2] | 0;
 HEAP32[i8 >> 2] = i20;
 HEAPF32[i19 >> 2] = f12;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 >> 2] = i21;
 HEAPF32[i2 >> 2] = f9;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = i5;
 HEAPF32[i14 >> 2] = f3;
 HEAP32[i15 >> 2] = 0;
 f17 = Math_fround(__ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_(i8, i10, i11));
 i21 = f18 < Math_fround(0.0) | f17 < f18;
 f18 = i21 ? f17 : f18;
 HEAP32[i8 >> 2] = i20;
 HEAPF32[i19 >> 2] = f12;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 >> 2] = i5;
 HEAPF32[i2 >> 2] = f3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = i6;
 HEAPF32[i14 >> 2] = f13;
 HEAP32[i15 >> 2] = 0;
 f17 = Math_fround(__ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_(i8, i10, i11));
 i15 = f18 < Math_fround(0.0) | f17 < f18;
 f18 = i15 ? f17 : f18;
 STACKTOP = i16;
 return Math_fround(f18);
}

function __ZNK15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E13find_positionERS5_(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0;
 i32 = (HEAP32[i1 + 96 >> 2] | 0) + -1 | 0;
 i33 = HEAP32[i1 + 92 >> 2] | 0;
 i7 = HEAP32[i1 + 52 >> 2] | 0;
 i8 = i1 + 56 | 0;
 i9 = i1 + 60 | 0;
 i10 = i1 + 64 | 0;
 i11 = i1 + 68 | 0;
 i12 = i1 + 72 | 0;
 i13 = i1 + 76 | 0;
 i14 = i1 + 80 | 0;
 i15 = i1 + 8 | 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i17 = HEAP32[i2 + 4 >> 2] | 0;
 i18 = HEAP32[i2 + 8 >> 2] | 0;
 i19 = HEAP32[i2 + 12 >> 2] | 0;
 i20 = HEAP32[i2 + 16 >> 2] | 0;
 i21 = HEAP32[i2 + 20 >> 2] | 0;
 i22 = HEAP32[i2 + 24 >> 2] | 0;
 i23 = HEAP32[i2 + 28 >> 2] | 0;
 i24 = i1 + 4 | 0;
 i25 = i1 + 12 | 0;
 i26 = i1 + 16 | 0;
 i27 = i1 + 20 | 0;
 i28 = i1 + 24 | 0;
 i29 = i1 + 28 | 0;
 i30 = i1 + 32 | 0;
 i31 = i1 + 36 | 0;
 i5 = i1 + 40 | 0;
 i3 = 0;
 i4 = -1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 while (1) {
  i2 = i1 & i32;
  i1 = HEAP32[i33 + (i2 * 40 | 0) >> 2] | 0;
  if ((i7 | 0) == (i1 | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 4 >> 2] | 0)) if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 8 >> 2] | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 12 >> 2] | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 16 >> 2] | 0)) if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 20 >> 2] | 0)) if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 24 >> 2] | 0)) if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 28 >> 2] | 0)) break;
  if (!(HEAP8[i15 >> 0] | 0)) i34 = 24; else if (!(HEAP32[i24 >> 2] | 0)) i34 = 24; else if ((HEAP32[i25 >> 2] | 0) == (i1 | 0)) if ((HEAP32[i26 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 4 >> 2] | 0)) if ((HEAP32[i27 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 8 >> 2] | 0)) if ((HEAP32[i28 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 12 >> 2] | 0)) if ((HEAP32[i29 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 16 >> 2] | 0)) if ((HEAP32[i30 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 20 >> 2] | 0)) if ((HEAP32[i31 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 24 >> 2] | 0)) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 28 >> 2] | 0)) i1 = (i4 | 0) == -1 ? i2 : i4; else i34 = 24; else i34 = 24; else i34 = 24; else i34 = 24; else i34 = 24; else i34 = 24; else i34 = 24; else i34 = 24;
  if ((i34 | 0) == 24) {
   i34 = 0;
   if ((i16 | 0) == (i1 | 0)) if ((i17 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 4 >> 2] | 0)) if ((i18 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 8 >> 2] | 0)) if ((i19 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 12 >> 2] | 0)) if ((i20 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 16 >> 2] | 0)) if ((i21 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 20 >> 2] | 0)) if ((i22 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 24 >> 2] | 0)) if ((i23 | 0) == (HEAP32[i33 + (i2 * 40 | 0) + 28 >> 2] | 0)) {
    i34 = 32;
    break;
   } else i1 = i4; else i1 = i4; else i1 = i4; else i1 = i4; else i1 = i4; else i1 = i4; else i1 = i4; else i1 = i4;
  }
  i35 = i3 + 1 | 0;
  i3 = i35;
  i4 = i1;
  i1 = i35 + i2 | 0;
 }
 if ((i34 | 0) == 32) {
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i6 >> 2] = -1;
 i1 = i6 + 4 | 0;
 if ((i4 | 0) == -1) {
  HEAP32[i1 >> 2] = i2;
  return;
 } else {
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i4, i12) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i7 = i13;
 i8 = i4 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 9; else i10 = i1;
  }
 }
 if ((i9 | 0) == 7) i9 = 9;
 if ((i9 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i13;
   return;
  } else i10 = i1;
 }
 i4 = HEAP32[i4 + 100 >> 2] | 0;
 i11 = i4 + 164 | 0;
 if (!(HEAP8[i11 >> 0] & 1)) {
  STACKTOP = i13;
  return;
 }
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 19;
   }
  }
  if ((i9 | 0) == 17) i9 = 19;
  if ((i9 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 if (i5 | 0) {
  i7 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i5 + 772 >> 2] | 0;
  i6 = HEAP32[i5 + 776 >> 2] | 0;
  i1 = i6 - i2 >> 2;
  if (!i1) i1 = i2; else {
   i5 = i1;
   i1 = i2;
   while (1) {
    i9 = (i5 | 0) / 2 | 0;
    i4 = i2 + (i9 << 2) | 0;
    i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
    i4 = i4 + 4 | 0;
    i1 = i3 ? i4 : i1;
    i5 = i3 ? i5 + -1 - i9 | 0 : i9;
    if (!i5) break; else i2 = i3 ? i4 : i2;
   }
  }
  if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i7 | 0)) {
   HEAP8[i11 >> 0] = HEAP8[i11 >> 0] | 2;
   STACKTOP = i13;
   return;
  }
 }
 i10 = HEAP32[i10 + 32 >> 2] | 0;
 i1 = HEAP32[i10 + 72 >> 2] | 0;
 i10 = HEAP32[i10 + 84 >> 2] | 0;
 i3 = i1 + (i10 << 2) | 0;
 L45 : do if (i10) {
  i2 = HEAP32[i12 >> 2] | 0;
  do {
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break L45;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i13;
  return;
 } while (0);
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i13;
  return;
 }
 HEAP8[i11 >> 0] = HEAP8[i11 >> 0] | 2;
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation18ControllerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 24 | 0;
 i6 = i5 + 16 | 0;
 i2 = i5 + 12 | 0;
 i7 = i5;
 i9 = i3 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i1 + 4;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = i8;
 i8 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 910115 | 0, i8, i7, 0);
 HEAP32[i2 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 905830 | 0, i2, 0);
 i10 = i4 + 8 | 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP8[i4 + 37 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 904061 | 0, i4, 0);
 __ZN7mecanim9animation13LayerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i1 + 12;
 HEAP32[i7 + 4 >> 2] = i1 + 8;
 HEAP32[i7 + 8 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 902714 | 0, i8, i7, 0);
 HEAP32[i2 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 905830 | 0, i2, 0);
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 902839 | 0, i4, 0);
 __ZN7mecanim12statemachine20StateMachineConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 901491 | 0, gb + 905830 | 0, i1 + 16 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 899011 | 0, i4, 0);
 __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim13ValueConstantEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_(i4 + 4 | 0, gb + 899030 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 902734 | 0, gb + 905830 | 0, i1 + 20 | 0, 0);
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 913944 | 0, i4, 0);
 __ZN7mecanim10ValueArray8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 STACKTOP = i5;
 return;
}

function __ZNK8Animator26GetGlobalSpaceSkeletonPoseEPPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEEiRKNS3_7_float4E(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i10 = i11;
 i7 = i11 + 24 | 0;
 i8 = HEAP32[i1 + 132 >> 2] | 0;
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 if (!i9) {
  HEAP32[i2 >> 2] = 0;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = HEAP32[i1 + 124 >> 2] | 0;
 i1 = i1 + 136 | 0;
 if (!(HEAP8[(HEAP32[i1 >> 2] | 0) + 137 >> 0] | 0)) {
  i13 = gb + 64016 | 0;
  i9 = HEAP32[i13 + 4 >> 2] | 0;
  i8 = i10;
  HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i7 >> 2] = gb + 175924 + 8;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i10);
  i10 = i6;
  i8 = HEAP32[i10 + 4 >> 2] | 0;
  i9 = i7 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = HEAP32[i3 >> 2] | 0;
  i8 = i3;
  i9 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i9 | 0) == 0 ? 0 : i9 + i8 | 0, i7) | 0;
  i10 = HEAP32[i3 >> 2] | 0;
  i10 = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math7affineXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i10 | 0) == 0 ? 0 : i10 + i8 | 0, i7) | 0;
  i13 = i3 + 8 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE((i12 | 0) == 0 ? 0 : i12 + i13 | 0, i9);
  i13 = i9 + 4 | 0;
  i13 = (HEAP32[i13 >> 2] | 0) + i13 | 0;
  i12 = i13;
  i14 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i15 = HEAP32[i14 + 8 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i15;
  i15 = HEAP32[i14 + 16 >> 2] | 0;
  i1 = HEAP32[i14 + 20 >> 2] | 0;
  i13 = HEAP32[i14 + 24 >> 2] | 0;
  HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = i15;
  HEAP32[i12 + 20 >> 2] = i1;
  HEAP32[i12 + 24 >> 2] = i13;
  i13 = HEAP32[i14 + 32 >> 2] | 0;
  i1 = HEAP32[i14 + 36 >> 2] | 0;
  HEAP32[i12 + 28 >> 2] = HEAP32[i14 + 28 >> 2];
  HEAP32[i12 + 32 >> 2] = i13;
  HEAP32[i12 + 36 >> 2] = i1;
  __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EE(i9, i10);
  i1 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i1 | 0) == 0 ? 0 : i1 + i8 | 0, i10, i10);
  i3 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i6, (i3 | 0) == 0 ? 0 : i3 + i8 | 0, i9, i4);
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i5 + 8 >> 2] = i4;
  HEAP32[i5 + 12 >> 2] = i8;
  __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i9, i7);
  HEAP32[i2 >> 2] = i10;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i13 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i6, (i13 | 0) == 0 ? 0 : i13 + i3 | 0, HEAP32[i8 + 8 >> 2] | 0, i4);
  i13 = HEAP32[i6 + 4 >> 2] | 0;
  i14 = HEAP32[i6 + 8 >> 2] | 0;
  i15 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i13;
  HEAP32[i5 + 8 >> 2] = i14;
  HEAP32[i5 + 12 >> 2] = i15;
  HEAP32[i2 >> 2] = 0;
  i15 = i9;
  STACKTOP = i11;
  return i15 | 0;
 }
 return 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i15 = HEAP32[i5 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f18 = Math_fround(-f12);
 f28 = Math_fround(-f13);
 f29 = Math_fround(-f14);
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f33 = Math_fround(f22 * f18);
 f19 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f19 * f28));
 f6 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f6 * f29));
 f9 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f32 = Math_fround(f9 * f18);
 f11 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f11 * f28));
 f8 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f8 * f29));
 f23 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f18 = Math_fround(f23 * f18);
 f20 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f28 = Math_fround(f18 + Math_fround(f20 * f28));
 f18 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f29 = Math_fround(f28 + Math_fround(f18 * f29));
 f28 = Math_fround(HEAPF32[i15 + 96 >> 2]);
 f26 = Math_fround(HEAPF32[i15 + 100 >> 2]);
 f21 = Math_fround(HEAPF32[i15 + 104 >> 2]);
 f27 = Math_fround(HEAPF32[i15 + 112 >> 2]);
 f25 = Math_fround(HEAPF32[i15 + 116 >> 2]);
 f24 = Math_fround(HEAPF32[i15 + 120 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i15 + 132 >> 2]);
 f17 = Math_fround(HEAPF32[i15 + 136 >> 2]);
 f31 = Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(f32 * f26)) + Math_fround(f29 * f21));
 f30 = Math_fround(Math_fround(Math_fround(f33 * f27) + Math_fround(f32 * f25)) + Math_fround(f29 * f24));
 f29 = Math_fround(Math_fround(Math_fround(f33 * f7) + Math_fround(f32 * f10)) + Math_fround(f29 * f17));
 i1 = f31 > f30 & f31 > f29;
 i15 = f30 > f29;
 f7 = i1 ? f28 : i15 ? f27 : f7;
 f10 = i1 ? f26 : i15 ? f25 : f10;
 f17 = i1 ? f21 : i15 ? f24 : f17;
 f24 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f21 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f9 = Math_fround(f24 + Math_fround(Math_fround(f23 * f17) + Math_fround(Math_fround(f22 * f7) + Math_fround(f9 * f10))));
 f11 = Math_fround(f21 + Math_fround(Math_fround(f20 * f17) + Math_fround(Math_fround(f19 * f7) + Math_fround(f11 * f10))));
 f10 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f10))));
 i16 = HEAP32[i5 + 8 >> 2] | 0;
 i15 = f12 > Math_fround(0.0);
 i1 = f13 > Math_fround(0.0);
 i5 = f14 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f6 = Math_fround(-f12);
 f8 = i15 ? f14 : f8;
 f7 = i1 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i8, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 296 | 0;
 i10 = i11;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = i10 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 32 >> 2] = Math_fround(1.0);
 i1 = i10 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 52 >> 2] = Math_fround(1.0);
 i1 = i10 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 72 >> 2] = Math_fround(1.0);
 i1 = i10 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 92 >> 2] = Math_fround(1.0);
 i1 = i10 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 112 >> 2] = Math_fround(1.0);
 i1 = i10 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 132 >> 2] = Math_fround(1.0);
 i1 = i10 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 152 >> 2] = Math_fround(1.0);
 i1 = i10 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i10 + 172 >> 2] = Math_fround(1.0);
 i1 = i10 + 176 | 0;
 i2 = i10 + 249 | 0;
 i3 = i1;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i10 + 292 | 0;
 i3 = i10 + 252 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i10 + 293 >> 0] = 0;
 i2 = HEAP32[i8 + 20 >> 2] | 0;
 i3 = i6 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i8 + 4 | 0;
 i5 = i8 + 12 | 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i7 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(i10, HEAP32[i1 + 8 >> 2] | 0) | 0;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_(i10, i2); else {
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i2, i1);
  __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_(i10, i2);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i2);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i7 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i10) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i7) >> 2] = i1;
 if ((HEAP8[i10 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 STACKTOP = i11;
 return;
}

function _UNITY_FT_Matrix_Multiply(i5, i21) {
 i5 = i5 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0;
 if (!((i5 | 0) != 0 & (i21 | 0) != 0)) return;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 i30 = i1 >> 31;
 i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i22 = (i3 | 0) < 0;
 i23 = 0 - (i30 | 1) | 0;
 i3 = i22 ? 0 - i3 | 0 : i3;
 i4 = i3 >>> 8;
 if ((i4 + i1 | 0) >>> 0 < 8191) i19 = ((Math_imul(i3, i1) | 0) + 32768 | 0) >>> 16; else {
  i19 = i1 & 65535;
  i19 = (Math_imul(i3 >>> 16, i19) | 0) + (Math_imul(i1 >>> 16, i3) | 0) + (((Math_imul(i3 & 65535, i19) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i24 = i21 + 8 | 0;
 i7 = HEAP32[i24 >> 2] | 0;
 i25 = i2 >> 31;
 i2 = (i2 | 0) < 0 ? 0 - i2 | 0 : i2;
 i26 = (i7 | 0) < 0;
 i27 = 0 - (i25 | 1) | 0;
 i7 = i26 ? 0 - i7 | 0 : i7;
 i8 = i7 >>> 8;
 if ((i8 + i2 | 0) >>> 0 < 8191) i20 = ((Math_imul(i7, i2) | 0) + 32768 | 0) >>> 16; else {
  i20 = i2 & 65535;
  i20 = (Math_imul(i7 >>> 16, i20) | 0) + (Math_imul(i2 >>> 16, i7) | 0) + (((Math_imul(i7 & 65535, i20) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i28 = i21 + 4 | 0;
 i10 = HEAP32[i28 >> 2] | 0;
 i29 = (i10 | 0) < 0;
 i10 = i29 ? 0 - i10 | 0 : i10;
 i14 = i10 >>> 8;
 if ((i14 + i1 | 0) >>> 0 < 8191) i16 = ((Math_imul(i10, i1) | 0) + 32768 | 0) >>> 16; else {
  i16 = i1 & 65535;
  i16 = (Math_imul(i10 >>> 16, i16) | 0) + (Math_imul(i1 >>> 16, i10) | 0) + (((Math_imul(i10 & 65535, i16) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i17 = i21 + 12 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 i18 = (i9 | 0) < 0;
 i9 = i18 ? 0 - i9 | 0 : i9;
 i15 = i9 >>> 8;
 if ((i15 + i2 | 0) >>> 0 < 8191) i11 = ((Math_imul(i9, i2) | 0) + 32768 | 0) >>> 16; else {
  i11 = i2 & 65535;
  i11 = (Math_imul(i9 >>> 16, i11) | 0) + (Math_imul(i2 >>> 16, i9) | 0) + (((Math_imul(i9 & 65535, i11) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i12 = i2 >> 31;
 i2 = (i2 | 0) < 0 ? 0 - i2 | 0 : i2;
 i13 = 0 - (i12 | 1) | 0;
 if ((i4 + i2 | 0) >>> 0 < 8191) i6 = ((Math_imul(i3, i2) | 0) + 32768 | 0) >>> 16; else {
  i6 = i2 & 65535;
  i6 = (Math_imul(i3 >>> 16, i6) | 0) + (Math_imul(i2 >>> 16, i3) | 0) + (((Math_imul(i3 & 65535, i6) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i4 = i1 >> 31;
 i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i5 = 0 - (i4 | 1) | 0;
 if ((i8 + i1 | 0) >>> 0 < 8191) i3 = ((Math_imul(i7, i1) | 0) + 32768 | 0) >>> 16; else {
  i3 = i1 & 65535;
  i3 = (Math_imul(i7 >>> 16, i3) | 0) + (Math_imul(i1 >>> 16, i7) | 0) + (((Math_imul(i7 & 65535, i3) | 0) + 32768 | 0) >>> 16) | 0;
 }
 if ((i14 + i2 | 0) >>> 0 < 8191) i2 = ((Math_imul(i10, i2) | 0) + 32768 | 0) >>> 16; else {
  i14 = i2 & 65535;
  i2 = (Math_imul(i10 >>> 16, i14) | 0) + (Math_imul(i2 >>> 16, i10) | 0) + (((Math_imul(i10 & 65535, i14) | 0) + 32768 | 0) >>> 16) | 0;
 }
 if ((i15 + i1 | 0) >>> 0 < 8191) i1 = ((Math_imul(i9, i1) | 0) + 32768 | 0) >>> 16; else {
  i15 = i1 & 65535;
  i1 = (Math_imul(i9 >>> 16, i15) | 0) + (Math_imul(i1 >>> 16, i9) | 0) + (((Math_imul(i9 & 65535, i15) | 0) + 32768 | 0) >>> 16) | 0;
 }
 HEAP32[i21 >> 2] = (((i26 ? i27 : i25) | 0) < 0 ? 0 - i20 | 0 : i20) + (((i22 ? i23 : i30) | 0) < 0 ? 0 - i19 | 0 : i19);
 HEAP32[i28 >> 2] = (((i18 ? i27 : i25) | 0) < 0 ? 0 - i11 | 0 : i11) + (((i29 ? i23 : i30) | 0) < 0 ? 0 - i16 | 0 : i16);
 HEAP32[i24 >> 2] = (((i26 ? i5 : i4) | 0) < 0 ? 0 - i3 | 0 : i3) + (((i22 ? i13 : i12) | 0) < 0 ? 0 - i6 | 0 : i6);
 HEAP32[i17 >> 2] = (((i18 ? i5 : i4) | 0) < 0 ? 0 - i1 | 0 : i1) + (((i29 ? i13 : i12) | 0) < 0 ? 0 - i2 | 0 : i2);
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i3 = i10 + 24 | 0;
 i4 = i10 + 12 | 0;
 i2 = i10;
 i5 = i7 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 >> 2] = i6 + 4;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i2 + 8 >> 2] = i1;
 i1 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 901442 | 0, i1, i2, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i7, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, gb + 905830 | 0, i4, 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = -1;
 HEAP32[i8 + 24 >> 2] = -1;
 HEAP32[i8 + 28 >> 2] = 1;
 i2 = i8 + 32 | 0;
 i9 = i2;
 i11 = i9 + 52 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP16[i2 + 52 >> 1] = 0;
 HEAP8[i2 + 54 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, gb + 913925 | 0, i8, 0);
 __ZN7mecanim12statemachine18StateMachineMemory8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i6 + 12;
 HEAP32[i4 + 4 >> 2] = i6 + 8;
 HEAP32[i4 + 8 >> 2] = i2;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 901476 | 0, i1, i4, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i7, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0);
 i1 = i7 + 16 | 0;
 i2 = i7 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 901491 | 0, gb + 905830 | 0, i6 + 16 | 0, 0);
 i9 = i8;
 i11 = i9 + 48 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, gb + 913944 | 0, i8, 0);
 __ZN7mecanim10ValueArray8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 i11 = i6 + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 901500 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 901512 | 0, HEAP32[gb + 36972 >> 2] | 0, i6 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 STACKTOP = i10;
 return;
}

function runPostSets14() {
 HEAP32[gb + 33920 >> 2] = fb + 112;
 HEAP32[gb + 33924 >> 2] = fb + 113;
 HEAP32[gb + 33928 >> 2] = fb + 154;
 HEAP32[gb + 33932 >> 2] = fb + 155;
 HEAP32[gb + 33944 >> 2] = fb + 156;
 HEAP32[gb + 33948 >> 2] = fb + 157;
 HEAP32[gb + 33960 >> 2] = fb + 158;
 HEAP32[gb + 33964 >> 2] = fb + 159;
 HEAP32[gb + 33968 >> 2] = fb + 124;
 HEAP32[gb + 33980 >> 2] = fb + 160;
 HEAP32[gb + 33984 >> 2] = fb + 161;
 HEAP32[gb + 34356 >> 2] = fb + 162;
 HEAP32[gb + 34360 >> 2] = fb + 163;
 HEAP32[gb + 34364 >> 2] = fb + 38;
 HEAP32[gb + 34368 >> 2] = fb + 145;
 HEAP32[gb + 34372 >> 2] = fb + 16;
 HEAP32[gb + 34376 >> 2] = fb + 93;
 HEAP32[gb + 34380 >> 2] = fb + 40;
 HEAP32[gb + 34384 >> 2] = fb + 19;
 HEAP32[gb + 34388 >> 2] = fb + 125;
 HEAP32[gb + 34392 >> 2] = fb + 103;
 HEAP32[gb + 34396 >> 2] = fb + 101;
 HEAP32[gb + 34400 >> 2] = fb + 62;
 HEAP32[gb + 34404 >> 2] = fb + 28;
 HEAP32[gb + 34408 >> 2] = fb + 63;
 HEAP32[gb + 34412 >> 2] = fb + 29;
 HEAP32[gb + 34416 >> 2] = fb + 34;
 HEAP32[gb + 34420 >> 2] = fb + 146;
 HEAP32[gb + 34424 >> 2] = fb + 147;
 HEAP32[gb + 34428 >> 2] = fb + 148;
 HEAP32[gb + 34432 >> 2] = fb + 149;
 HEAP32[gb + 34436 >> 2] = fb + 150;
 HEAP32[gb + 34440 >> 2] = fb + 151;
 HEAP32[gb + 34444 >> 2] = fb + 36;
 HEAP32[gb + 34448 >> 2] = fb + 104;
 HEAP32[gb + 34452 >> 2] = fb + 108;
 HEAP32[gb + 34456 >> 2] = fb + 94;
 HEAP32[gb + 34460 >> 2] = fb + 130;
 HEAP32[gb + 34464 >> 2] = fb + 112;
 HEAP32[gb + 34468 >> 2] = fb + 113;
 HEAP32[gb + 34472 >> 2] = fb + 131;
 HEAP32[gb + 34476 >> 2] = fb + 111;
 HEAP32[gb + 34480 >> 2] = fb + 112;
 HEAP32[gb + 34484 >> 2] = fb + 113;
 HEAP32[gb + 34488 >> 2] = fb + 164;
 HEAP32[gb + 34492 >> 2] = fb + 165;
 HEAP32[gb + 34496 >> 2] = (HEAP32[gb + 34496 >> 2] | 0) + (gb + 378214 | 0);
 HEAP32[gb + 34508 >> 2] = fb + 166;
 HEAP32[gb + 34512 >> 2] = fb + 167;
 HEAP32[gb + 34516 >> 2] = fb + 168;
 HEAP32[gb + 34520 >> 2] = fb + 145;
 HEAP32[gb + 34524 >> 2] = fb + 16;
 HEAP32[gb + 34528 >> 2] = fb + 169;
 HEAP32[gb + 34532 >> 2] = fb + 170;
 HEAP32[gb + 34536 >> 2] = fb + 19;
 HEAP32[gb + 34540 >> 2] = fb + 126;
 HEAP32[gb + 34544 >> 2] = fb + 103;
 HEAP32[gb + 34548 >> 2] = fb + 101;
 HEAP32[gb + 34552 >> 2] = fb + 62;
 HEAP32[gb + 34556 >> 2] = fb + 28;
 HEAP32[gb + 34560 >> 2] = fb + 63;
 HEAP32[gb + 34564 >> 2] = fb + 29;
 HEAP32[gb + 34568 >> 2] = fb + 34;
 HEAP32[gb + 34572 >> 2] = fb + 173;
 HEAP32[gb + 34576 >> 2] = fb + 174;
 HEAP32[gb + 34580 >> 2] = fb + 175;
 HEAP32[gb + 34584 >> 2] = fb + 176;
 HEAP32[gb + 34588 >> 2] = fb + 177;
 HEAP32[gb + 34592 >> 2] = fb + 178;
 HEAP32[gb + 34596 >> 2] = fb + 36;
 HEAP32[gb + 34600 >> 2] = fb + 104;
 HEAP32[gb + 34604 >> 2] = fb + 108;
 HEAP32[gb + 34608 >> 2] = fb + 94;
 HEAP32[gb + 34612 >> 2] = fb + 130;
 HEAP32[gb + 34616 >> 2] = fb + 112;
 HEAP32[gb + 34620 >> 2] = fb + 113;
 HEAP32[gb + 34624 >> 2] = fb + 131;
 HEAP32[gb + 34628 >> 2] = fb + 111;
 HEAP32[gb + 34632 >> 2] = fb + 112;
 HEAP32[gb + 34636 >> 2] = fb + 113;
 HEAP32[gb + 34640 >> 2] = fb + 171;
 HEAP32[gb + 34644 >> 2] = fb + 172;
 HEAP32[gb + 34656 >> 2] = fb + 173;
 HEAP32[gb + 34660 >> 2] = fb + 174;
 HEAP32[gb + 34664 >> 2] = fb + 38;
 HEAP32[gb + 34668 >> 2] = fb + 179;
 HEAP32[gb + 34672 >> 2] = fb + 16;
 HEAP32[gb + 34676 >> 2] = fb + 39;
 HEAP32[gb + 34680 >> 2] = fb + 40;
 HEAP32[gb + 34684 >> 2] = fb + 19;
 HEAP32[gb + 34688 >> 2] = fb + 127;
 HEAP32[gb + 34692 >> 2] = fb + 31;
 HEAP32[gb + 34696 >> 2] = fb + 27;
 HEAP32[gb + 34700 >> 2] = fb + 62;
 HEAP32[gb + 34704 >> 2] = fb + 28;
 HEAP32[gb + 34708 >> 2] = fb + 63;
 HEAP32[gb + 34712 >> 2] = fb + 29;
 HEAP32[gb + 34716 >> 2] = fb + 34;
 HEAP32[gb + 34720 >> 2] = fb + 180;
 HEAP32[gb + 34724 >> 2] = fb + 181;
 runPostSets15();
}

function __ZL21stb__MatchColorsBlockPhS_i(i3, i4, i15) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i17 + 48 | 0;
 i16 = i17 + 32 | 0;
 i1 = i17;
 i14 = HEAPU8[i4 >> 0] | 0;
 i6 = HEAPU8[i4 + 4 >> 0] | 0;
 i7 = i14 - i6 | 0;
 i8 = HEAPU8[i4 + 1 >> 0] | 0;
 i9 = HEAPU8[i4 + 5 >> 0] | 0;
 i10 = i8 - i9 | 0;
 i11 = HEAPU8[i4 + 2 >> 0] | 0;
 i12 = HEAPU8[i4 + 6 >> 0] | 0;
 i13 = i11 - i12 | 0;
 i2 = 0;
 do {
  i18 = i2 << 2;
  i19 = Math_imul(HEAPU8[i3 + i18 >> 0] | 0, i7) | 0;
  i19 = (Math_imul(HEAPU8[i3 + (i18 | 1) >> 0] | 0, i10) | 0) + i19 | 0;
  HEAP32[i5 + (i2 << 2) >> 2] = i19 + (Math_imul(HEAPU8[i3 + (i18 | 2) >> 0] | 0, i13) | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 16);
 i19 = (Math_imul(i8, i10) | 0) + (Math_imul(i14, i7) | 0) + (Math_imul(i11, i13) | 0) | 0;
 HEAP32[i16 >> 2] = i19;
 i18 = (Math_imul(i9, i10) | 0) + (Math_imul(i6, i7) | 0) + (Math_imul(i12, i13) | 0) | 0;
 HEAP32[i16 + 4 >> 2] = i18;
 i6 = Math_imul(HEAPU8[i4 + 8 >> 0] | 0, i7) | 0;
 i6 = (Math_imul(HEAPU8[i4 + 9 >> 0] | 0, i10) | 0) + i6 | 0;
 i6 = i6 + (Math_imul(HEAPU8[i4 + 10 >> 0] | 0, i13) | 0) | 0;
 HEAP32[i16 + 8 >> 2] = i6;
 i3 = Math_imul(HEAPU8[i4 + 12 >> 0] | 0, i7) | 0;
 i3 = (Math_imul(HEAPU8[i4 + 13 >> 0] | 0, i10) | 0) + i3 | 0;
 i3 = i3 + (Math_imul(HEAPU8[i4 + 14 >> 0] | 0, i13) | 0) | 0;
 HEAP32[i16 + 12 >> 2] = i3;
 i4 = i3 + i18 >> 1;
 i3 = i6 + i3 >> 1;
 i6 = i19 + i6 >> 1;
 if (!i15) {
  i1 = 0;
  i2 = 15;
  while (1) {
   i19 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   i1 = ((i19 | 0) < (i3 | 0) ? ((i19 | 0) < (i4 | 0) ? 1 : 3) : (i19 | 0) < (i6 | 0) ? 2 : 0) | i1 << 2;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
  STACKTOP = i17;
  return i1 | 0;
 }
 i10 = i3 << 4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 i9 = i4 << 4;
 i8 = i6 << 4;
 i7 = 0;
 i6 = i1 + 16 | 0;
 i2 = 0;
 i3 = 0;
 i4 = 0;
 while (1) {
  i11 = HEAP32[i5 >> 2] | 0;
  i15 = (i3 * 3 | 0) + (i11 << 4) + (i4 * 5 | 0) | 0;
  i15 = (i15 | 0) < (i10 | 0) ? ((i15 | 0) < (i9 | 0) ? 1 : 3) : (i15 | 0) < (i8 | 0) ? 2 : 0;
  i14 = i4;
  i4 = i11 - (HEAP32[i16 + (i15 << 2) >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  i11 = HEAP32[i5 + 4 >> 2] | 0;
  i19 = i6 + 8 | 0;
  i18 = HEAP32[i6 + 4 >> 2] | 0;
  i14 = (i11 << 4) + (i4 * 7 | 0) + ((HEAP32[i19 >> 2] | 0) * 3 | 0) + (i18 * 5 | 0) + i14 | 0;
  i14 = (i14 | 0) < (i10 | 0) ? ((i14 | 0) < (i9 | 0) ? 1 : 3) : (i14 | 0) < (i8 | 0) ? 2 : 0;
  i3 = i11 - (HEAP32[i16 + (i14 << 2) >> 2] | 0) | 0;
  HEAP32[i1 + 4 >> 2] = i3;
  i11 = HEAP32[i5 + 8 >> 2] | 0;
  i12 = i6 + 12 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i18 = (i11 << 4) + (i3 * 7 | 0) + ((HEAP32[i12 >> 2] | 0) * 3 | 0) + (i19 * 5 | 0) + i18 | 0;
  i18 = (i18 | 0) < (i10 | 0) ? ((i18 | 0) < (i9 | 0) ? 1 : 3) : (i18 | 0) < (i8 | 0) ? 2 : 0;
  i11 = i11 - (HEAP32[i16 + (i18 << 2) >> 2] | 0) | 0;
  HEAP32[i1 + 8 >> 2] = i11;
  i13 = HEAP32[i5 + 12 >> 2] | 0;
  i19 = (i13 << 4) + (i11 * 7 | 0) + ((HEAP32[i12 >> 2] | 0) * 5 | 0) + i19 | 0;
  i19 = (i19 | 0) < (i10 | 0) ? ((i19 | 0) < (i9 | 0) ? 1 : 3) : (i19 | 0) < (i8 | 0) ? 2 : 0;
  HEAP32[i1 + 12 >> 2] = i13 - (HEAP32[i16 + (i19 << 2) >> 2] | 0);
  i2 = (i14 << 2 | i15 | i18 << 4 | i19 << 6) << (i7 << 3) | i2;
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == 4) break; else {
   i19 = i1;
   i5 = i5 + 16 | 0;
   i1 = i6;
   i6 = i19;
  }
 }
 i19 = i2;
 STACKTOP = i17;
 return i19 | 0;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i2, i14, i15, i6, i13) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 L1 : do if ((i2 | 0) == (HEAP32[i14 + 8 >> 2] | 0)) {
  if ((HEAP32[i14 + 4 >> 2] | 0) == (i15 | 0)) {
   i1 = i14 + 28 | 0;
   if ((HEAP32[i1 >> 2] | 0) != 1) HEAP32[i1 >> 2] = i6;
  }
 } else {
  if ((i2 | 0) != (HEAP32[i14 >> 2] | 0)) {
   i12 = HEAP32[i2 + 12 >> 2] | 0;
   i5 = i2 + 16 + (i12 << 3) | 0;
   __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i2 + 16 | 0, i14, i15, i6, i13);
   i1 = i2 + 24 | 0;
   if ((i12 | 0) <= 1) break;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if (!(i2 & 2)) {
    i4 = i14 + 36 | 0;
    if ((HEAP32[i4 >> 2] | 0) != 1) {
     if (!(i2 & 1)) {
      i2 = i14 + 54 | 0;
      while (1) {
       if (HEAP8[i2 >> 0] | 0) break L1;
       if ((HEAP32[i4 >> 2] | 0) == 1) break L1;
       __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i14, i15, i6, i13);
       i1 = i1 + 8 | 0;
       if (i1 >>> 0 >= i5 >>> 0) break L1;
      }
     }
     i2 = i14 + 24 | 0;
     i3 = i14 + 54 | 0;
     while (1) {
      if (HEAP8[i3 >> 0] | 0) break L1;
      if ((HEAP32[i4 >> 2] | 0) == 1) if ((HEAP32[i2 >> 2] | 0) == 1) break L1;
      __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i14, i15, i6, i13);
      i1 = i1 + 8 | 0;
      if (i1 >>> 0 >= i5 >>> 0) break L1;
     }
    }
   }
   i2 = i14 + 54 | 0;
   while (1) {
    if (HEAP8[i2 >> 0] | 0) break L1;
    __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i14, i15, i6, i13);
    i1 = i1 + 8 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break L1;
   }
  }
  if ((HEAP32[i14 + 16 >> 2] | 0) != (i15 | 0)) {
   i11 = i14 + 20 | 0;
   if ((HEAP32[i11 >> 2] | 0) != (i15 | 0)) {
    HEAP32[i14 + 32 >> 2] = i6;
    i12 = i14 + 44 | 0;
    if ((HEAP32[i12 >> 2] | 0) == 4) break;
    i5 = i2 + 16 + (HEAP32[i2 + 12 >> 2] << 3) | 0;
    i6 = i14 + 52 | 0;
    i7 = i14 + 53 | 0;
    i9 = i14 + 54 | 0;
    i8 = i2 + 8 | 0;
    i10 = i14 + 24 | 0;
    i1 = 0;
    i3 = i2 + 16 | 0;
    i4 = 0;
    L34 : while (1) {
     if (i3 >>> 0 >= i5 >>> 0) {
      i2 = 20;
      break;
     }
     HEAP8[i6 >> 0] = 0;
     HEAP8[i7 >> 0] = 0;
     __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i3, i14, i15, i15, 1, i13);
     if (HEAP8[i9 >> 0] | 0) {
      i2 = 20;
      break;
     }
     do if (!(HEAP8[i7 >> 0] | 0)) i2 = i4; else {
      if (!(HEAP8[i6 >> 0] | 0)) if (!(HEAP32[i8 >> 2] & 1)) {
       i1 = 1;
       i2 = 20;
       break L34;
      } else {
       i1 = 1;
       i2 = i4;
       break;
      }
      if ((HEAP32[i10 >> 2] | 0) == 1) {
       i2 = 25;
       break L34;
      }
      if (!(HEAP32[i8 >> 2] & 2)) {
       i2 = 25;
       break L34;
      } else {
       i1 = 1;
       i2 = 1;
      }
     } while (0);
     i3 = i3 + 8 | 0;
     i4 = i2;
    }
    do if ((i2 | 0) == 20) {
     if (!i4) {
      HEAP32[i11 >> 2] = i15;
      i15 = i14 + 40 | 0;
      HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
      if ((HEAP32[i14 + 36 >> 2] | 0) == 1) if ((HEAP32[i10 >> 2] | 0) == 2) {
       HEAP8[i9 >> 0] = 1;
       if (i1) {
        i2 = 25;
        break;
       } else {
        i1 = 4;
        break;
       }
      }
     }
     if (i1) i2 = 25; else i1 = 4;
    } while (0);
    if ((i2 | 0) == 25) i1 = 3;
    HEAP32[i12 >> 2] = i1;
    break;
   }
  }
  if ((i6 | 0) == 1) HEAP32[i14 + 32 >> 2] = 1;
 } while (0);
 return;
}

function __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i7, i19) {
 i7 = i7 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i20;
 i4 = i7 + 140 | 0;
 i5 = i7 + 144 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i7 + 156 >> 2] = 16;
 HEAP32[i7 + 152 >> 2] = 6;
 HEAP8[i7 + 160 >> 0] = 0;
 i6 = i7 + 164 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1280, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i18 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i18;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 HEAP32[i4 >> 2] = i1;
 i5 = i1 + ((HEAP32[i5 >> 2] | 0) * 40 | 0) | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i6 = i7 + 100 | 0;
  do {
   i2 = i1;
   i3 = i6;
   i4 = i2 + 40 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i7 + 148 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 0;
 i15 = i7 + 40 | 0;
 i16 = HEAP32[i19 + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i20;
  return;
 }
 i17 = i7 + 28 | 0;
 i18 = i7 + 8 | 0;
 i14 = i7 + 20 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i13 = 0;
 do {
  L14 : do if (!i1) i1 = 0; else {
   i2 = 0;
   while (1) {
    i12 = HEAP32[i19 >> 2] | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    i5 = HEAP32[i12 + (i13 << 5) >> 2] | 0;
    i6 = i12 + (i13 << 5) + 4 | 0;
    i7 = i12 + (i13 << 5) + 8 | 0;
    i8 = i12 + (i13 << 5) + 12 | 0;
    i9 = i12 + (i13 << 5) + 16 | 0;
    i10 = i12 + (i13 << 5) + 20 | 0;
    i11 = i12 + (i13 << 5) + 24 | 0;
    i12 = i12 + (i13 << 5) + 28 | 0;
    i3 = i2;
    while (1) {
     if ((i5 | 0) == (HEAP32[i4 + (i3 << 5) >> 2] | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 4 >> 2] | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 8 >> 2] | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 12 >> 2] | 0)) if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 16 >> 2] | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 20 >> 2] | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 24 >> 2] | 0)) if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i4 + (i3 << 5) + 28 >> 2] | 0)) break;
     i2 = i3 + 1 | 0;
     if ((i2 | 0) == (i1 | 0)) break L14; else i3 = i2;
    }
    i2 = HEAP32[i18 >> 2] | 0;
    if (HEAP32[i2 + (i3 << 2) >> 2] | 0) {
     i2 = __Z12GetGfxDevicev() | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0, HEAP32[(HEAP32[i18 >> 2] | 0) + (i3 << 2) >> 2] | 0);
     i2 = HEAP32[i18 >> 2] | 0;
    }
    i1 = i1 + -1 | 0;
    HEAP32[i2 + (i3 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
    i11 = HEAP32[i17 >> 2] | 0;
    i12 = i11 + (i3 << 5) | 0;
    i11 = i11 + (i1 << 5) | 0;
    HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
    HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
    HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
    HEAP32[i12 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
    HEAP32[i12 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    if ((i3 | 0) == (i1 | 0)) {
     i1 = i3;
     break;
    } else i2 = i3;
   }
  } while (0);
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != (i16 | 0));
 STACKTOP = i20;
 return;
}

function __ZN8Animator8GetStatsEv(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0, d5 = 0.0, d6 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 48 | 0;
 i13 = i15 + 16 | 0;
 i12 = i15;
 i9 = i15 + 120 | 0;
 i10 = i15 + 108 | 0;
 i11 = i15 + 96 | 0;
 i2 = i7 + 153 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) i1 = 3; else if (!(HEAP32[i7 + 168 >> 2] | 0)) i1 = 3;
 if ((i1 | 0) == 3) __ZN8Animator12CreateObjectEv(i7);
 if (HEAP32[i7 + 108 >> 2] | 0) {
  i1 = HEAP32[i7 + 624 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i7 + 420 >> 2];
  }
 }
 if (HEAP8[i2 >> 0] | 0) if (HEAP32[i7 + 168 >> 2] | 0) {
  __ZNK8Animator12GetClipStatsEv(i9, i7);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i3 = HEAP32[i9 + 32 >> 2] | 0;
  if ((i3 | 0) > 0) {
   f16 = Math_fround(i3 | 0);
   d4 = +Math_fround(Math_fround(Math_fround(HEAP32[i9 + 36 >> 2] | 0) / f16) * Math_fround(100.0));
   d5 = +Math_fround(Math_fround(Math_fround(HEAP32[i9 + 40 >> 2] | 0) / f16) * Math_fround(100.0));
   d6 = +Math_fround(Math_fround(Math_fround(HEAP32[i9 + 44 >> 2] | 0) / f16) * Math_fround(100.0));
  } else {
   d4 = 0.0;
   d5 = 0.0;
   d6 = 0.0;
  }
  i2 = i7 + 616 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN8Animator24SetupAnimationClipsCacheEv(i7);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i12 >> 2] = i1;
  __Z6FormatPKcz(i11, gb + 910894 | 0, i12);
  i18 = HEAP8[i11 + 11 >> 0] | 0;
  i17 = i18 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i17 ? HEAP32[i11 >> 2] | 0 : i11, i17 ? HEAP32[i11 + 4 >> 2] | 0 : i18 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i18 = HEAP32[i9 + 8 >> 2] | 0;
  i17 = HEAP32[i9 + 12 >> 2] | 0;
  i1 = HEAP32[i9 + 16 >> 2] | 0;
  i2 = HEAP32[i9 + 20 >> 2] | 0;
  i11 = HEAP32[i9 + 24 >> 2] | 0;
  i7 = HEAP32[i9 + 28 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i13 + 4 >> 2] = i18;
  HEAP32[i13 + 8 >> 2] = i17;
  HEAP32[i13 + 12 >> 2] = i1;
  HEAP32[i13 + 16 >> 2] = i2;
  HEAP32[i13 + 20 >> 2] = i11;
  HEAP32[i13 + 24 >> 2] = i7;
  __Z6FormatPKcz(i12, gb + 910910 | 0, i13);
  i7 = HEAP8[i12 + 11 >> 0] | 0;
  i11 = i7 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i11 ? HEAP32[i12 >> 2] | 0 : i12, i11 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i7 = HEAP32[i9 + 36 >> 2] | 0;
  i11 = HEAP32[i9 + 40 >> 2] | 0;
  i12 = HEAP32[i9 + 44 >> 2] | 0;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i14 + 4 >> 2] = i7;
  HEAPF64[i14 + 8 >> 3] = d4;
  HEAP32[i14 + 16 >> 2] = i11;
  HEAPF64[i14 + 24 >> 3] = d5;
  HEAP32[i14 + 32 >> 2] = i12;
  HEAPF64[i14 + 40 >> 3] = d6;
  __Z6FormatPKcz(i13, gb + 910988 | 0, i14);
  i14 = HEAP8[i13 + 11 >> 0] | 0;
  i12 = i14 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i12 ? HEAP32[i13 >> 2] | 0 : i13, i12 ? HEAP32[i13 + 4 >> 2] | 0 : i14 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i15;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 910878 | 0, 15);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn9XmlParser14processElementEPKcS3_RKNS_6shdfnd7FastXml14AttributePairsEi(i15, i4, i7, i14, i1) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = i15 + 12 | 0;
 i5 = (HEAP32[i12 >> 2] | 0) + 8 | 0;
 i13 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, 24) | 0;
 HEAP32[i13 >> 2] = gb + 1576256;
 i6 = i13 + 4 | 0;
 HEAP32[i6 >> 2] = gb + 1576256;
 i11 = i13 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 if (!i4) i1 = gb + 1576256 | 0; else if (!(HEAP8[i4 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i4;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i13 >> 2] = i1;
 if (!i7) i1 = gb + 1576256 | 0; else if (!(HEAP8[i7 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i7;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i7 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i6 >> 2] = i1;
 i11 = i15 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i13 + 20 >> 2] = i1;
  i1 = i1 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = i13;
   break;
  }
  while (1) {
   i1 = i2 + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  HEAP32[i1 >> 2] = i13;
  HEAP32[i13 + 12 >> 2] = i2;
 } while (0);
 HEAP32[i11 >> 2] = i13;
 if ((HEAP32[i14 >> 2] | 0) > 1) {
  i8 = i14 + 4 | 0;
  i10 = 0;
  do {
   i5 = i10 << 1;
   i6 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
   i5 = HEAP32[i6 + ((i5 | 1) << 2) >> 2] | 0;
   i6 = (HEAP32[i12 >> 2] | 0) + 8 | 0;
   i9 = __ZN5physx19CVariableMemoryPool8allocateEj(i6, 24) | 0;
   HEAP32[i9 >> 2] = gb + 1576256;
   i7 = i9 + 4 | 0;
   HEAP32[i7 >> 2] = gb + 1576256;
   i3 = i9 + 8 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   if (!i4) i1 = gb + 1576256 | 0; else if (!(HEAP8[i4 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
    i2 = i4;
    i1 = 0;
    while (1) {
     i3 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) {
      i2 = i3;
      break;
     } else i1 = i3;
    }
    i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i6, i1 + 2 | 0) | 0;
    _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
    HEAP8[i1 + i2 >> 0] = 0;
   }
   HEAP32[i9 >> 2] = i1;
   if (!i5) i1 = gb + 1576256 | 0; else if (!(HEAP8[i5 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
    i2 = i5;
    i1 = 0;
    while (1) {
     i3 = i1 + 1 | 0;
     i2 = i2 + 1 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) {
      i2 = i3;
      break;
     } else i1 = i3;
    }
    i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i6, i1 + 2 | 0) | 0;
    _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
    HEAP8[i1 + i2 >> 0] = 0;
   }
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i9 + 20 >> 2] = i1;
   i1 = i1 + 16 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) HEAP32[i1 >> 2] = i9; else {
    while (1) {
     i1 = i2 + 8 | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    HEAP32[i1 >> 2] = i9;
    HEAP32[i9 + 12 >> 2] = i2;
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) < ((HEAP32[i14 >> 2] | 0) / 2 | 0 | 0));
 }
 i1 = i15 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) return 1;
 HEAP32[i1 >> 2] = i13;
 return 1;
}

function _UNITY_png_set_text_2(i15, i3, i17, i18) {
 i15 = i15 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i19 = 0;
 if ((i17 | 0) == 0 | ((i15 | 0) == 0 | (i3 | 0) == 0 | (i18 | 0) < 1)) {
  i19 = 0;
  return i19 | 0;
 }
 i5 = i3 + 132 | 0;
 i16 = i3 + 128 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 do if (((HEAP32[i5 >> 2] | 0) - i1 | 0) < (i18 | 0)) {
  if ((2147483647 - i1 | 0) >= (i18 | 0)) {
   i2 = i1 + i18 | 0;
   i2 = (i2 | 0) < 2147483639 ? i2 + 8 & -8 : 2147483647;
   i4 = i3 + 136 | 0;
   i1 = _UNITY_png_realloc_array(i15, HEAP32[i4 >> 2] | 0, i1, i2 - i1 | 0, 28) | 0;
   if (i1 | 0) {
    _UNITY_png_free(i15, HEAP32[i4 >> 2] | 0);
    HEAP32[i4 >> 2] = i1;
    i14 = i3 + 220 | 0;
    HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 16384;
    HEAP32[i5 >> 2] = i2;
    break;
   }
  }
  _UNITY_png_chunk_report(i15, gb + 352301 | 0, 1);
  i19 = 1;
  return i19 | 0;
 } while (0);
 if ((i18 | 0) <= 0) {
  i19 = 0;
  return i19 | 0;
 }
 i11 = i3 + 136 | 0;
 i10 = 0;
 L15 : while (1) {
  i12 = HEAP32[i16 >> 2] | 0;
  i13 = HEAP32[i11 >> 2] | 0;
  i14 = i13 + (i12 * 28 | 0) | 0;
  i8 = i17 + (i10 * 28 | 0) + 4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (i1 | 0) {
   i9 = i17 + (i10 * 28 | 0) | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 > 3) {
    _UNITY_png_chunk_report(i15, gb + 352322 | 0, 1);
    break;
   }
   i6 = _strlen(i1) | 0;
   if ((i3 | 0) < 1) {
    i4 = 0;
    i2 = 0;
   } else {
    i1 = HEAP32[i17 + (i10 * 28 | 0) + 20 >> 2] | 0;
    if (!i1) i2 = 0; else i2 = _strlen(i1) | 0;
    i1 = HEAP32[i17 + (i10 * 28 | 0) + 24 >> 2] | 0;
    if (!i1) i4 = 0; else i4 = _strlen(i1) | 0;
   }
   i7 = i17 + (i10 * 28 | 0) + 8 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i19 = 19; else if (!(HEAP8[i1 >> 0] | 0)) i19 = 19; else {
    i5 = _strlen(i1) | 0;
    HEAP32[i14 >> 2] = i3;
   }
   do if ((i19 | 0) == 19) {
    i19 = 0;
    if ((i3 | 0) > 0) {
     HEAP32[i14 >> 2] = 1;
     i5 = 0;
     break;
    } else {
     HEAP32[i14 >> 2] = -1;
     i5 = 0;
     break;
    }
   } while (0);
   i1 = _UNITY_png_malloc_base(i15, i6 + 4 + i2 + i4 + i5 | 0) | 0;
   i3 = i13 + (i12 * 28 | 0) + 4 | 0;
   HEAP32[i3 >> 2] = i1;
   if (!i1) break L15;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, i6 | 0) | 0;
   HEAP8[(HEAP32[i3 >> 2] | 0) + i6 >> 0] = 0;
   if ((HEAP32[i9 >> 2] | 0) > 0) {
    i1 = (HEAP32[i3 >> 2] | 0) + i6 + 1 | 0;
    i9 = i13 + (i12 * 28 | 0) + 20 | 0;
    HEAP32[i9 >> 2] = i1;
    _memcpy(i1 | 0, HEAP32[i17 + (i10 * 28 | 0) + 20 >> 2] | 0, i2 | 0) | 0;
    HEAP8[(HEAP32[i9 >> 2] | 0) + i2 >> 0] = 0;
    i9 = (HEAP32[i9 >> 2] | 0) + i2 + 1 | 0;
    i1 = i13 + (i12 * 28 | 0) + 24 | 0;
    HEAP32[i1 >> 2] = i9;
    _memcpy(i9 | 0, HEAP32[i17 + (i10 * 28 | 0) + 24 >> 2] | 0, i4 | 0) | 0;
    HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = 0;
    i1 = (HEAP32[i1 >> 2] | 0) + i4 | 0;
   } else {
    HEAP32[i13 + (i12 * 28 | 0) + 20 >> 2] = 0;
    HEAP32[i13 + (i12 * 28 | 0) + 24 >> 2] = 0;
    i1 = (HEAP32[i3 >> 2] | 0) + i6 | 0;
   }
   i1 = i1 + 1 | 0;
   i2 = i13 + (i12 * 28 | 0) + 8 | 0;
   HEAP32[i2 >> 2] = i1;
   if (i5) {
    _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, i5 | 0) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
   i14 = (HEAP32[i14 >> 2] | 0) > 0;
   HEAP32[i13 + (i12 * 28 | 0) + 12 >> 2] = i14 ? 0 : i5;
   HEAP32[i13 + (i12 * 28 | 0) + 16 >> 2] = i14 ? i5 : 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  } while (0);
  i10 = i10 + 1 | 0;
  if ((i10 | 0) >= (i18 | 0)) {
   i1 = 0;
   i19 = 32;
   break;
  }
 }
 if ((i19 | 0) == 32) return i1 | 0;
 _UNITY_png_chunk_report(i15, gb + 352360 | 0, 1);
 i19 = 1;
 return i19 | 0;
}

function runPostSets87() {
 HEAP32[gb + 90216 >> 2] = fb + 252;
 HEAP32[gb + 90220 >> 2] = fb + 253;
 HEAP32[gb + 90224 >> 2] = fb + 254;
 HEAP32[gb + 90228 >> 2] = fb + 255;
 HEAP32[gb + 90232 >> 2] = fb + 542;
 HEAP32[gb + 90236 >> 2] = fb + 543;
 HEAP32[gb + 90240 >> 2] = fb + 73;
 HEAP32[gb + 90244 >> 2] = fb + 544;
 HEAP32[gb + 90248 >> 2] = fb + 545;
 HEAP32[gb + 90252 >> 2] = fb + 903;
 HEAP32[gb + 90256 >> 2] = fb + 904;
 HEAP32[gb + 90332 >> 2] = fb + 27;
 HEAP32[gb + 90336 >> 2] = fb + 28;
 HEAP32[gb + 90340 >> 2] = fb + 29;
 HEAP32[gb + 90344 >> 2] = fb + 30;
 HEAP32[gb + 90348 >> 2] = fb + 31;
 HEAP32[gb + 90352 >> 2] = fb + 32;
 HEAP32[gb + 90356 >> 2] = fb + 33;
 HEAP32[gb + 90364 >> 2] = fb + 34;
 HEAP32[gb + 90368 >> 2] = fb + 35;
 HEAP32[gb + 90372 >> 2] = fb + 36;
 HEAP32[gb + 90376 >> 2] = fb + 37;
 HEAP32[gb + 90380 >> 2] = fb + 38;
 HEAP32[gb + 90384 >> 2] = fb + 33;
 HEAP32[gb + 90396 >> 2] = fb + 39;
 HEAP32[gb + 90400 >> 2] = fb + 40;
 HEAP32[gb + 90404 >> 2] = fb + 41;
 HEAP32[gb + 90408 >> 2] = fb + 42;
 HEAP32[gb + 90412 >> 2] = fb + 33;
 HEAP32[gb + 90428 >> 2] = fb + 43;
 HEAP32[gb + 90432 >> 2] = fb + 44;
 HEAP32[gb + 90436 >> 2] = fb + 45;
 HEAP32[gb + 90440 >> 2] = fb + 33;
 HEAP32[gb + 90460 >> 2] = fb + 46;
 HEAP32[gb + 90464 >> 2] = fb + 47;
 HEAP32[gb + 90468 >> 2] = fb + 33;
 HEAP32[gb + 90492 >> 2] = fb + 48;
 HEAP32[gb + 90496 >> 2] = fb + 33;
 HEAP32[gb + 90524 >> 2] = fb + 33;
 HEAP32[gb + 90536 >> 2] = fb + 29;
 HEAP32[gb + 90540 >> 2] = fb + 1215;
 HEAP32[gb + 90544 >> 2] = fb + 1216;
 HEAP32[gb + 90556 >> 2] = fb + 139;
 HEAP32[gb + 90560 >> 2] = fb + 140;
 HEAP32[gb + 90564 >> 2] = fb + 141;
 HEAP32[gb + 90568 >> 2] = fb + 1217;
 HEAP32[gb + 90572 >> 2] = fb + 1218;
 HEAP32[gb + 90584 >> 2] = fb + 142;
 HEAP32[gb + 90588 >> 2] = fb + 143;
 HEAP32[gb + 90592 >> 2] = fb + 144;
 HEAP32[gb + 90596 >> 2] = fb + 1217;
 HEAP32[gb + 90600 >> 2] = fb + 1219;
 HEAP32[gb + 90648 >> 2] = fb + 145;
 HEAP32[gb + 90652 >> 2] = fb + 146;
 HEAP32[gb + 90656 >> 2] = fb + 147;
 HEAP32[gb + 90660 >> 2] = fb + 1217;
 HEAP32[gb + 90664 >> 2] = fb + 1220;
 HEAP32[gb + 90804 >> 2] = fb + 1221;
 HEAP32[gb + 90808 >> 2] = fb + 1222;
 HEAP32[gb + 90812 >> 2] = fb + 1223;
 HEAP32[gb + 90816 >> 2] = fb + 1224;
 HEAP32[gb + 90820 >> 2] = fb + 256;
 HEAP32[gb + 90824 >> 2] = fb + 257;
 HEAP32[gb + 90828 >> 2] = fb + 546;
 HEAP32[gb + 90832 >> 2] = fb + 905;
 HEAP32[gb + 90844 >> 2] = fb + 1225;
 HEAP32[gb + 90848 >> 2] = fb + 1226;
 HEAP32[gb + 90852 >> 2] = fb + 906;
 HEAP32[gb + 90856 >> 2] = fb + 547;
 HEAP32[gb + 90868 >> 2] = fb + 1221;
 HEAP32[gb + 90872 >> 2] = fb + 1227;
 HEAP32[gb + 90876 >> 2] = fb + 1228;
 HEAP32[gb + 90880 >> 2] = fb + 1229;
 HEAP32[gb + 90884 >> 2] = fb + 258;
 HEAP32[gb + 90888 >> 2] = fb + 259;
 HEAP32[gb + 90900 >> 2] = fb + 1221;
 HEAP32[gb + 90904 >> 2] = fb + 1230;
 HEAP32[gb + 90908 >> 2] = fb + 1231;
 HEAP32[gb + 90912 >> 2] = fb + 1232;
 HEAP32[gb + 90916 >> 2] = fb + 260;
 HEAP32[gb + 90920 >> 2] = fb + 261;
 HEAP32[gb + 90924 >> 2] = fb + 546;
 HEAP32[gb + 90936 >> 2] = fb + 1233;
 HEAP32[gb + 90940 >> 2] = fb + 1234;
 HEAP32[gb + 90944 >> 2] = fb + 907;
 HEAP32[gb + 90948 >> 2] = fb + 547;
 HEAP32[gb + 90960 >> 2] = fb + 1235;
 HEAP32[gb + 90964 >> 2] = fb + 1236;
 HEAP32[gb + 90976 >> 2] = fb + 1237;
 HEAP32[gb + 90980 >> 2] = fb + 1238;
 HEAP32[gb + 90984 >> 2] = fb + 148;
 HEAP32[gb + 90996 >> 2] = fb + 1239;
 HEAP32[gb + 91e3 >> 2] = fb + 1240;
 HEAP32[gb + 91004 >> 2] = fb + 1241;
 HEAP32[gb + 91008 >> 2] = fb + 1242;
 HEAP32[gb + 91012 >> 2] = fb + 149;
 HEAP32[gb + 91024 >> 2] = fb + 1243;
 HEAP32[gb + 91028 >> 2] = fb + 1244;
 HEAP32[gb + 91032 >> 2] = fb + 1245;
 HEAP32[gb + 91036 >> 2] = fb + 1246;
 runPostSets88();
}

function runPostSets100() {
 HEAP32[gb + 96232 >> 2] = fb + 661;
 HEAP32[gb + 96236 >> 2] = fb + 650;
 HEAP32[gb + 96240 >> 2] = fb + 1029;
 HEAP32[gb + 96244 >> 2] = fb + 651;
 HEAP32[gb + 96248 >> 2] = fb + 15;
 HEAP32[gb + 96252 >> 2] = fb + 185;
 HEAP32[gb + 96256 >> 2] = fb + 1030;
 HEAP32[gb + 96260 >> 2] = fb + 652;
 HEAP32[gb + 96264 >> 2] = fb + 1031;
 HEAP32[gb + 96268 >> 2] = fb + 653;
 HEAP32[gb + 96272 >> 2] = fb + 1032;
 HEAP32[gb + 96276 >> 2] = fb + 654;
 HEAP32[gb + 96280 >> 2] = fb + 1033;
 HEAP32[gb + 96284 >> 2] = fb + 655;
 HEAP32[gb + 96288 >> 2] = fb + 656;
 HEAP32[gb + 96292 >> 2] = fb + 294;
 HEAP32[gb + 96296 >> 2] = fb + 657;
 HEAP32[gb + 96300 >> 2] = fb + 295;
 HEAP32[gb + 96304 >> 2] = fb + 186;
 HEAP32[gb + 96308 >> 2] = fb + 1350;
 HEAP32[gb + 96312 >> 2] = fb + 78;
 HEAP32[gb + 96316 >> 2] = fb + 79;
 HEAP32[gb + 96320 >> 2] = fb + 80;
 HEAP32[gb + 96324 >> 2] = fb + 38;
 HEAP32[gb + 96328 >> 2] = fb + 108;
 HEAP32[gb + 96332 >> 2] = fb + 83;
 HEAP32[gb + 96336 >> 2] = fb + 1034;
 HEAP32[gb + 96340 >> 2] = fb + 1035;
 HEAP32[gb + 96344 >> 2] = fb + 187;
 HEAP32[gb + 96348 >> 2] = fb + 16;
 HEAP32[gb + 96352 >> 2] = fb + 109;
 HEAP32[gb + 96356 >> 2] = fb + 84;
 HEAP32[gb + 96360 >> 2] = fb + 110;
 HEAP32[gb + 96364 >> 2] = fb + 85;
 HEAP32[gb + 96368 >> 2] = fb + 111;
 HEAP32[gb + 96372 >> 2] = fb + 86;
 HEAP32[gb + 96376 >> 2] = fb + 112;
 HEAP32[gb + 96380 >> 2] = fb + 87;
 HEAP32[gb + 96384 >> 2] = fb + 1036;
 HEAP32[gb + 96388 >> 2] = fb + 1037;
 HEAP32[gb + 96392 >> 2] = fb + 1351;
 HEAP32[gb + 96396 >> 2] = fb + 188;
 HEAP32[gb + 96400 >> 2] = fb + 658;
 HEAP32[gb + 96404 >> 2] = fb + 659;
 HEAP32[gb + 96408 >> 2] = fb + 113;
 HEAP32[gb + 96412 >> 2] = fb + 88;
 HEAP32[gb + 96416 >> 2] = fb + 114;
 HEAP32[gb + 96420 >> 2] = fb + 89;
 HEAP32[gb + 96424 >> 2] = fb + 115;
 HEAP32[gb + 96428 >> 2] = fb + 90;
 HEAP32[gb + 96432 >> 2] = fb + 116;
 HEAP32[gb + 96436 >> 2] = fb + 91;
 HEAP32[gb + 96440 >> 2] = fb + 660;
 HEAP32[gb + 96444 >> 2] = fb + 189;
 HEAP32[gb + 96448 >> 2] = fb + 296;
 HEAP32[gb + 96452 >> 2] = fb + 662;
 HEAP32[gb + 96456 >> 2] = fb + 117;
 HEAP32[gb + 96460 >> 2] = fb + 92;
 HEAP32[gb + 96464 >> 2] = fb + 118;
 HEAP32[gb + 96468 >> 2] = fb + 93;
 HEAP32[gb + 96472 >> 2] = fb + 119;
 HEAP32[gb + 96476 >> 2] = fb + 94;
 HEAP32[gb + 96480 >> 2] = fb + 1040;
 HEAP32[gb + 96484 >> 2] = fb + 1039;
 HEAP32[gb + 96488 >> 2] = fb + 1041;
 HEAP32[gb + 96492 >> 2] = fb + 297;
 HEAP32[gb + 96496 >> 2] = fb + 298;
 HEAP32[gb + 96508 >> 2] = fb + 1354;
 HEAP32[gb + 96512 >> 2] = fb + 1355;
 HEAP32[gb + 96516 >> 2] = fb + 299;
 HEAP32[gb + 96520 >> 2] = fb + 190;
 HEAP32[gb + 96524 >> 2] = fb + 1356;
 HEAP32[gb + 96528 >> 2] = fb + 81;
 HEAP32[gb + 96532 >> 2] = fb + 82;
 HEAP32[gb + 96536 >> 2] = fb + 83;
 HEAP32[gb + 96540 >> 2] = fb + 84;
 HEAP32[gb + 96544 >> 2] = fb + 21;
 HEAP32[gb + 96548 >> 2] = fb + 1042;
 HEAP32[gb + 96552 >> 2] = fb + 663;
 HEAP32[gb + 96556 >> 2] = fb + 664;
 HEAP32[gb + 96568 >> 2] = fb + 665;
 HEAP32[gb + 96572 >> 2] = fb + 1357;
 HEAP32[gb + 96576 >> 2] = fb + 1341;
 HEAP32[gb + 96580 >> 2] = fb + 1358;
 HEAP32[gb + 96584 >> 2] = fb + 1043;
 HEAP32[gb + 96596 >> 2] = fb + 1359;
 HEAP32[gb + 96600 >> 2] = fb + 648;
 HEAP32[gb + 96604 >> 2] = fb + 456;
 HEAP32[gb + 96608 >> 2] = fb + 1360;
 HEAP32[gb + 96612 >> 2] = fb + 1361;
 HEAP32[gb + 96616 >> 2] = fb + 293;
 HEAP32[gb + 96620 >> 2] = fb + 1;
 HEAP32[gb + 96624 >> 2] = fb + 650;
 HEAP32[gb + 96628 >> 2] = fb + 1029;
 HEAP32[gb + 96632 >> 2] = fb + 651;
 HEAP32[gb + 96636 >> 2] = fb + 1;
 HEAP32[gb + 96640 >> 2] = fb + 185;
 HEAP32[gb + 96644 >> 2] = fb + 1030;
 HEAP32[gb + 96648 >> 2] = fb + 652;
 HEAP32[gb + 96652 >> 2] = fb + 1031;
 runPostSets101();
}

function __ZNSt3__227__insertion_sort_incompleteIR29ColliderHitsByDepthComparitorPP10Collider2DEEbT0_S6_T_(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 12 | 0;
 i14 = i15;
 switch (i12 - i11 >> 2 | 0) {
 case 2:
  {
   i1 = i12 + -4 | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   __ZNK9Transform11GetPositionEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f16 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   if (!(f16 < Math_fround(HEAPF32[i14 + 8 >> 2]))) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   i14 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i14;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i11, i11 + 4 | 0, i12 + -4 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_(i11, i11 + 4 | 0, i11 + 8 | 0, i12 + -4 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i11, i11 + 4 | 0, i11 + 8 | 0, i11 + 12 | 0, i12 + -4 | 0, i1) | 0;
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 case 1:
 case 0:
  {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
 default:
  {
   i3 = i11 + 8 | 0;
   __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i11, i11 + 4 | 0, i3, i1) | 0;
   i1 = i11 + 12 | 0;
   L3 : do if ((i1 | 0) == (i12 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i7 = i13 + 8 | 0;
    i8 = i14 + 8 | 0;
    i9 = i13 + 8 | 0;
    i10 = i14 + 8 | 0;
    i2 = 0;
    while (1) {
     i6 = HEAP32[i3 >> 2] | 0;
     __ZNK9Transform11GetPositionEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     f16 = Math_fround(HEAPF32[i7 >> 2]);
     __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
     if (f16 < Math_fround(HEAPF32[i8 >> 2])) {
      i5 = HEAP32[i1 >> 2] | 0;
      i6 = i5 + 28 | 0;
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       if ((i3 | 0) == (i11 | 0)) break;
       i4 = i3 + -4 | 0;
       i17 = HEAP32[i4 >> 2] | 0;
       __ZNK9Transform11GetPositionEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
       f16 = Math_fround(HEAPF32[i9 >> 2]);
       __ZNK9Transform11GetPositionEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
       if (f16 < Math_fround(HEAPF32[i10 >> 2])) {
        i17 = i3;
        i3 = i4;
        i4 = i17;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 4 | 0) == (i12 | 0);
       break L3;
      }
     }
     i3 = i1 + 4 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i17 = i1;
      i1 = i3;
      i3 = i17;
     }
    }
   } while (0);
   i17 = i1 | i2;
   STACKTOP = i15;
   return i17 | 0;
  }
 }
 return 0;
}

function __ZN19ShaderPropertySheet31SetTextureScaleAndOffsetIndexedERKN9ShaderLab16FastPropertyNameEif(i15, i16, i10, f1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17;
 i2 = HEAP32[i15 + 20 >> 2] | 0;
 i8 = HEAP32[i15 + 24 >> 2] | 0;
 L1 : do if ((i2 | 0) < (i8 | 0)) {
  i5 = HEAP32[i15 + 32 >> 2] | 0;
  i6 = HEAP32[i16 >> 2] | 0;
  while (1) {
   if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i6 | 0)) break;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i8 | 0)) {
    i9 = 7;
    break L1;
   }
  }
  if ((i2 | 0) > -1) i14 = HEAP32[(HEAP32[i15 + 52 >> 2] | 0) + (i2 << 2) >> 2] & 1048575; else i9 = 7;
 } else i9 = 7; while (0);
 if ((i9 | 0) == 7) i14 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i15, i16, 0) | 0;
 i9 = i15 + 72 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = HEAP32[i12 + i14 + 20 >> 2] | 0;
 if ((i13 | 0) > -1) {
  i2 = i12 + (HEAP32[(HEAP32[i15 + 52 >> 2] | 0) + ((HEAP32[i15 + 12 >> 2] | 0) + i13 << 2) >> 2] & 1048575) | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  i5 = i11 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2];
  i6 = i11 + 8 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 + 8 >> 2];
  i8 = i11 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = i11;
 } else {
  HEAPF32[i11 >> 2] = Math_fround(1.0);
  i5 = i11 + 4 | 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  i6 = i11 + 8 | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  i8 = i11 + 12 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i2 = i11;
 }
 HEAPF32[i11 + (i10 << 2) >> 2] = f1;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f18 = Math_fround(f4 + Math_fround(-1.0));
 i11 = f18 < Math_fround(0.0);
 f19 = Math_fround(-f18);
 if ((i11 ? f19 : f18) <= Math_fround(9.99999997e-07)) {
  f19 = Math_fround(f7 + Math_fround(-1.0));
  i11 = f19 < Math_fround(0.0);
  f18 = Math_fround(-f19);
  i11 = (i11 ? f18 : f19) <= Math_fround(9.99999997e-07);
  f4 = i11 ? Math_fround(1.0) : f4;
  f7 = i11 ? Math_fround(1.0) : f7;
 }
 i11 = f1 < Math_fround(0.0);
 f19 = Math_fround(-f1);
 if ((i11 ? f19 : f1) <= Math_fround(9.99999997e-07)) {
  i11 = f3 < Math_fround(0.0);
  f19 = Math_fround(-f3);
  i11 = (i11 ? f19 : f3) <= Math_fround(9.99999997e-07);
  f1 = i11 ? Math_fround(0.0) : f1;
  f3 = i11 ? Math_fround(0.0) : f3;
 }
 if ((i13 | 0) >= 0) {
  i16 = i13;
  i14 = i12;
  i13 = i15 + 12 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i16 = i13 + i16 | 0;
  i15 = i15 + 52 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i16 = i15 + (i16 << 2) | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  i16 = i16 & 1048575;
  i16 = i14 + i16 | 0;
  HEAPF32[i16 >> 2] = f4;
  i15 = i16 + 4 | 0;
  HEAPF32[i15 >> 2] = f7;
  i15 = i16 + 8 | 0;
  HEAPF32[i15 >> 2] = f1;
  i16 = i16 + 12 | 0;
  HEAPF32[i16 >> 2] = f3;
  STACKTOP = i17;
  return;
 }
 i16 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i15, i16, gb + 478716 | 0) | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 HEAP32[i13 + i14 + 20 >> 2] = i16;
 i14 = i13;
 i13 = i15 + 12 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i16 = i13 + i16 | 0;
 i15 = i15 + 52 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = i15 + (i16 << 2) | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i16 = i16 & 1048575;
 i16 = i14 + i16 | 0;
 HEAPF32[i16 >> 2] = f4;
 i15 = i16 + 4 | 0;
 HEAPF32[i15 >> 2] = f7;
 i15 = i16 + 8 | 0;
 HEAPF32[i15 >> 2] = f1;
 i16 = i16 + 12 | 0;
 HEAPF32[i16 >> 2] = f3;
 STACKTOP = i17;
 return;
}

function runPostSets96() {
 HEAP32[gb + 94564 >> 2] = fb + 1;
 HEAP32[gb + 94568 >> 2] = fb + 1;
 HEAP32[gb + 94572 >> 2] = fb + 1;
 HEAP32[gb + 94576 >> 2] = fb + 1;
 HEAP32[gb + 94580 >> 2] = fb + 1;
 HEAP32[gb + 94584 >> 2] = fb + 1;
 HEAP32[gb + 94596 >> 2] = fb + 1334;
 HEAP32[gb + 94600 >> 2] = fb + 621;
 HEAP32[gb + 94604 >> 2] = fb + 456;
 HEAP32[gb + 94608 >> 2] = fb + 1335;
 HEAP32[gb + 94612 >> 2] = fb + 1336;
 HEAP32[gb + 94616 >> 2] = fb + 286;
 HEAP32[gb + 94620 >> 2] = fb + 622;
 HEAP32[gb + 94624 >> 2] = fb + 623;
 HEAP32[gb + 94628 >> 2] = fb + 980;
 HEAP32[gb + 94632 >> 2] = fb + 624;
 HEAP32[gb + 94636 >> 2] = fb + 14;
 HEAP32[gb + 94640 >> 2] = fb + 174;
 HEAP32[gb + 94644 >> 2] = fb + 981;
 HEAP32[gb + 94648 >> 2] = fb + 625;
 HEAP32[gb + 94652 >> 2] = fb + 982;
 HEAP32[gb + 94656 >> 2] = fb + 626;
 HEAP32[gb + 94660 >> 2] = fb + 983;
 HEAP32[gb + 94664 >> 2] = fb + 627;
 HEAP32[gb + 94668 >> 2] = fb + 984;
 HEAP32[gb + 94672 >> 2] = fb + 628;
 HEAP32[gb + 94676 >> 2] = fb + 629;
 HEAP32[gb + 94680 >> 2] = fb + 630;
 HEAP32[gb + 94684 >> 2] = fb + 631;
 HEAP32[gb + 94688 >> 2] = fb + 287;
 HEAP32[gb + 94692 >> 2] = fb + 632;
 HEAP32[gb + 94696 >> 2] = fb + 175;
 HEAP32[gb + 94700 >> 2] = fb + 176;
 HEAP32[gb + 94704 >> 2] = fb + 985;
 HEAP32[gb + 94708 >> 2] = fb + 633;
 HEAP32[gb + 94712 >> 2] = fb + 986;
 HEAP32[gb + 94716 >> 2] = fb + 987;
 HEAP32[gb + 94720 >> 2] = fb + 988;
 HEAP32[gb + 94724 >> 2] = fb + 71;
 HEAP32[gb + 94728 >> 2] = fb + 97;
 HEAP32[gb + 94732 >> 2] = fb + 98;
 HEAP32[gb + 94736 >> 2] = fb + 72;
 HEAP32[gb + 94740 >> 2] = fb + 99;
 HEAP32[gb + 94744 >> 2] = fb + 989;
 HEAP32[gb + 94748 >> 2] = fb + 990;
 HEAP32[gb + 94752 >> 2] = fb + 991;
 HEAP32[gb + 94756 >> 2] = fb + 992;
 HEAP32[gb + 94760 >> 2] = fb + 993;
 HEAP32[gb + 94764 >> 2] = fb + 994;
 HEAP32[gb + 94768 >> 2] = fb + 73;
 HEAP32[gb + 94772 >> 2] = fb + 995;
 HEAP32[gb + 94776 >> 2] = fb + 996;
 HEAP32[gb + 94780 >> 2] = fb + 997;
 HEAP32[gb + 94784 >> 2] = fb + 998;
 HEAP32[gb + 94788 >> 2] = fb + 999;
 HEAP32[gb + 94792 >> 2] = fb + 1e3;
 HEAP32[gb + 94796 >> 2] = fb + 74;
 HEAP32[gb + 94800 >> 2] = fb + 1001;
 HEAP32[gb + 94804 >> 2] = fb + 1002;
 HEAP32[gb + 94808 >> 2] = fb + 1003;
 HEAP32[gb + 94812 >> 2] = fb + 288;
 HEAP32[gb + 94816 >> 2] = fb + 634;
 HEAP32[gb + 94820 >> 2] = fb + 1004;
 HEAP32[gb + 94824 >> 2] = fb + 289;
 HEAP32[gb + 94828 >> 2] = fb + 635;
 HEAP32[gb + 94832 >> 2] = fb + 1005;
 HEAP32[gb + 94836 >> 2] = fb + 1006;
 HEAP32[gb + 94840 >> 2] = fb + 1007;
 HEAP32[gb + 94844 >> 2] = fb + 290;
 HEAP32[gb + 94848 >> 2] = fb + 636;
 HEAP32[gb + 94852 >> 2] = fb + 1337;
 HEAP32[gb + 94856 >> 2] = fb + 177;
 HEAP32[gb + 94860 >> 2] = fb + 178;
 HEAP32[gb + 94864 >> 2] = fb + 1008;
 HEAP32[gb + 94868 >> 2] = fb + 1009;
 HEAP32[gb + 94872 >> 2] = fb + 1010;
 HEAP32[gb + 94876 >> 2] = fb + 1011;
 HEAP32[gb + 94880 >> 2] = fb + 179;
 HEAP32[gb + 94884 >> 2] = fb + 637;
 HEAP32[gb + 94888 >> 2] = fb + 180;
 HEAP32[gb + 94892 >> 2] = fb + 1012;
 HEAP32[gb + 94896 >> 2] = fb + 638;
 HEAP32[gb + 94900 >> 2] = fb + 1013;
 HEAP32[gb + 94904 >> 2] = fb + 1014;
 HEAP32[gb + 94908 >> 2] = fb + 181;
 HEAP32[gb + 94912 >> 2] = fb + 639;
 HEAP32[gb + 94916 >> 2] = fb + 1015;
 HEAP32[gb + 94920 >> 2] = fb + 1016;
 HEAP32[gb + 94924 >> 2] = fb + 640;
 HEAP32[gb + 94928 >> 2] = fb + 1017;
 HEAP32[gb + 94932 >> 2] = fb + 1018;
 HEAP32[gb + 94936 >> 2] = fb + 182;
 HEAP32[gb + 94940 >> 2] = fb + 641;
 HEAP32[gb + 94944 >> 2] = fb + 68;
 HEAP32[gb + 94948 >> 2] = fb + 37;
 HEAP32[gb + 94952 >> 2] = fb + 642;
 HEAP32[gb + 94956 >> 2] = fb + 1019;
 HEAP32[gb + 94960 >> 2] = fb + 643;
 HEAP32[gb + 94964 >> 2] = fb + 1020;
 HEAP32[gb + 94968 >> 2] = fb + 75;
 runPostSets97();
}

function __ZN21MinMaxAnimationCurvesaSERKS_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 i5 = i9 + 28 | 0;
 i8 = i10 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i5 = i9 + 56 | 0;
 i8 = (i10 | 0) == (i9 | 0);
 if (!i8) {
  i7 = HEAP32[i10 + 56 >> 2] | 0;
  i6 = i9 + 68 | 0;
  i1 = HEAP32[i10 + 68 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i6 >> 2] = i2;
  i3 = i9 + 72 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
 }
 i5 = i9 + 76 | 0;
 i7 = i10 + 76 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i5 = i9 + 88 | 0;
 i7 = i10 + 88 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i5 = i9 + 116 | 0;
 i7 = i10 + 116 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i5 = i9 + 144 | 0;
 if (i8) {
  i8 = i9 + 164 | 0;
  i10 = i10 + 164 | 0;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  return i9 | 0;
 }
 i6 = HEAP32[i10 + 144 >> 2] | 0;
 i7 = i9 + 156 | 0;
 i1 = HEAP32[i10 + 156 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 160 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i8 = i9 + 164 | 0;
 i10 = i10 + 164 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 return i9 | 0;
}

function __ZN19SharedRendererSceneC2ERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i10 = i3;
 i5 = i3 + 8 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 33972 + 8;
 __ZN15RenderNodeQueueC2ERK10MemLabelId(i1 + 8 | 0, i2);
 __ZN15RenderNodeQueueC2ERK10MemLabelId(i1 + 32820 | 0, i2);
 i6 = gb + 64024 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 HEAP32[i1 + 65632 >> 2] = 0;
 HEAP32[i1 + 65644 >> 2] = 0;
 HEAP32[i1 + 65648 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i11 = i4;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i1 + 65636 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP8[i1 + 65652 >> 0] = 0;
 i6 = i1 + 65656 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i1 + 65680 >> 2] = 0;
 HEAP32[i1 + 65684 >> 2] = 0;
 i6 = i2;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 HEAP32[i1 + 65688 >> 2] = 0;
 HEAP32[i1 + 65700 >> 2] = 0;
 HEAP32[i1 + 65704 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i11 = i4;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i1 + 65692 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 i6 = i2;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 HEAP32[i1 + 65708 >> 2] = 0;
 HEAP32[i1 + 65720 >> 2] = 0;
 HEAP32[i1 + 65724 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i11 = i4;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i1 + 65712 | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 i6 = i2;
 i8 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i1 + 65728 >> 2] = 0;
 HEAP32[i1 + 65740 >> 2] = 0;
 HEAP32[i1 + 65744 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i11 = i4;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1 + 65732 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i10;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i1 + 65748 >> 2] = 0;
 HEAP32[i1 + 65760 >> 2] = 0;
 HEAP32[i1 + 65764 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i9 = i4;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i1 + 65752 | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 i11 = i10;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i1 + 65768 >> 2] = 0;
 HEAP32[i1 + 65780 >> 2] = 0;
 HEAP32[i1 + 65784 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i11 = i4;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1 + 65772 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i10;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i1 + 65788 >> 2] = 0;
 HEAP32[i1 + 65800 >> 2] = 0;
 HEAP32[i1 + 65804 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i10);
 i10 = i4;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i1 + 65792 | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 i7 = i1 + 65808 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i6;
 __ZN16ReflectionSampleC2Ev(i1 + 65816 | 0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN28LightProbeProxyVolumeContextC2E10MemLabelId(i1 + 65940 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu17sweepSphereSphereERKNS_6PxVec3EfS3_fS3_RfRS1_(i15, f1, i18, f3, i20, i19, i2) {
 i15 = i15 | 0;
 f1 = Math_fround(f1);
 i18 = i18 | 0;
 f3 = Math_fround(f3);
 i20 = i20 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 f25 = Math_fround(HEAPF32[i18 >> 2]);
 f26 = Math_fround(f25 + Math_fround(HEAPF32[i20 >> 2]));
 i7 = i18 + 4 | 0;
 f23 = Math_fround(HEAPF32[i7 >> 2]);
 i13 = i20 + 4 | 0;
 f24 = Math_fround(f23 + Math_fround(HEAPF32[i13 >> 2]));
 i14 = i18 + 8 | 0;
 f12 = Math_fround(HEAPF32[i14 >> 2]);
 i6 = i20 + 8 | 0;
 f22 = Math_fround(f12 + Math_fround(HEAPF32[i6 >> 2]));
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i15 + 4 | 0;
 f10 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i15 + 8 | 0;
 f11 = Math_fround(HEAPF32[i17 >> 2]);
 f4 = Math_fround(f25 - f9);
 f5 = Math_fround(f23 - f10);
 f8 = Math_fround(f12 - f11);
 f9 = Math_fround(Math_fround(f26 - f25) - Math_fround(f9 - f9));
 f10 = Math_fround(Math_fround(f24 - f23) - Math_fround(f10 - f10));
 f11 = Math_fround(Math_fround(f22 - f12) - Math_fround(f11 - f11));
 f1 = Math_fround(f1 + f3);
 f12 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11));
 f1 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f8 * f8)) - Math_fround(f1 * f1));
 if (f1 <= Math_fround(0.0) | f12 == Math_fround(0.0)) {
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  i21 = 6;
 } else {
  f3 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f9) + Math_fround(f5 * f10)) + Math_fround(f8 * f11)) * Math_fround(2.0));
  f1 = Math_fround(Math_fround(f3 * f3) - Math_fround(f1 * Math_fround(f12 * Math_fround(4.0))));
  if (!(f1 >= Math_fround(0.0))) {
   i21 = 0;
   return i21 | 0;
  }
  f1 = Math_fround(Math_sqrt(Math_fround(f1)));
  f26 = Math_fround(Math_fround(1.0) / Math_fround(f12 * Math_fround(2.0)));
  f25 = Math_fround(Math_fround(f1 - f3) * f26);
  f26 = Math_fround(Math_fround(Math_fround(-f3) - f1) * f26);
  i27 = f25 > f26;
  f1 = i27 ? f26 : f25;
  HEAPF32[i19 >> 2] = f1;
  if (!(!((i27 ? f25 : f26) < Math_fround(0.0)) & !(f1 > Math_fround(1.0)))) {
   i27 = 0;
   return i27 | 0;
  }
  if (f1 == Math_fround(0.0)) i21 = 6; else {
   f3 = Math_fround(HEAPF32[i20 >> 2]);
   f4 = Math_fround(HEAPF32[i13 >> 2]);
   f3 = Math_fround(f1 * f3);
   f4 = Math_fround(f1 * f4);
   f5 = Math_fround(f1 * Math_fround(HEAPF32[i6 >> 2]));
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i18 >> 2]));
   f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
   f5 = Math_fround(f5 + Math_fround(HEAPF32[i14 >> 2]));
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i15 >> 2]));
   f4 = Math_fround(f4 - Math_fround(HEAPF32[i16 >> 2]));
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i17 >> 2]));
   HEAPF32[i2 >> 2] = f3;
   i6 = i2 + 4 | 0;
   HEAPF32[i6 >> 2] = f4;
   i7 = i2 + 8 | 0;
   HEAPF32[i7 >> 2] = f5;
  }
 }
 if ((i21 | 0) == 6) {
  f3 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
  f4 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
  f5 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i2 >> 2] = f3;
  i6 = i2 + 4 | 0;
  HEAPF32[i6 >> 2] = f4;
  i7 = i2 + 8 | 0;
  HEAPF32[i7 >> 2] = f5;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f5 * f5))));
 if (!(f1 > Math_fround(0.0))) {
  i27 = 1;
  return i27 | 0;
 }
 f26 = Math_fround(Math_fround(1.0) / f1);
 HEAPF32[i2 >> 2] = Math_fround(f3 * f26);
 HEAPF32[i6 >> 2] = Math_fround(f4 * f26);
 HEAPF32[i7 >> 2] = Math_fround(f5 * f26);
 i27 = 1;
 return i27 | 0;
}

function runPostSets38() {
 HEAP32[gb + 56544 >> 2] = fb + 71;
 HEAP32[gb + 56548 >> 2] = fb + 110;
 HEAP32[gb + 56552 >> 2] = fb + 105;
 HEAP32[gb + 56556 >> 2] = fb + 447;
 HEAP32[gb + 56568 >> 2] = fb + 448;
 HEAP32[gb + 56572 >> 2] = fb + 449;
 HEAP32[gb + 56584 >> 2] = fb + 450;
 HEAP32[gb + 56588 >> 2] = fb + 451;
 HEAP32[gb + 56600 >> 2] = fb + 452;
 HEAP32[gb + 56604 >> 2] = fb + 453;
 HEAP32[gb + 56612 >> 2] = fb + 454;
 HEAP32[gb + 56616 >> 2] = fb + 455;
 HEAP32[gb + 56620 >> 2] = fb + 456;
 HEAP32[gb + 56624 >> 2] = fb + 457;
 HEAP32[gb + 56628 >> 2] = fb + 458;
 HEAP32[gb + 56632 >> 2] = fb + 459;
 HEAP32[gb + 56636 >> 2] = fb + 460;
 HEAP32[gb + 56640 >> 2] = fb + 461;
 HEAP32[gb + 56648 >> 2] = fb + 462;
 HEAP32[gb + 56652 >> 2] = fb + 463;
 HEAP32[gb + 56656 >> 2] = fb + 464;
 HEAP32[gb + 56660 >> 2] = fb + 465;
 HEAP32[gb + 56664 >> 2] = fb + 466;
 HEAP32[gb + 56668 >> 2] = fb + 467;
 HEAP32[gb + 56672 >> 2] = fb + 468;
 HEAP32[gb + 56676 >> 2] = fb + 469;
 HEAP32[gb + 56684 >> 2] = fb + 470;
 HEAP32[gb + 56688 >> 2] = fb + 471;
 HEAP32[gb + 56692 >> 2] = fb + 472;
 HEAP32[gb + 56696 >> 2] = fb + 473;
 HEAP32[gb + 56700 >> 2] = fb + 474;
 HEAP32[gb + 56704 >> 2] = fb + 475;
 HEAP32[gb + 56708 >> 2] = fb + 476;
 HEAP32[gb + 56712 >> 2] = fb + 477;
 HEAP32[gb + 56720 >> 2] = fb + 478;
 HEAP32[gb + 56724 >> 2] = fb + 479;
 HEAP32[gb + 56728 >> 2] = fb + 480;
 HEAP32[gb + 56732 >> 2] = fb + 481;
 HEAP32[gb + 56736 >> 2] = fb + 482;
 HEAP32[gb + 56740 >> 2] = fb + 483;
 HEAP32[gb + 56744 >> 2] = fb + 484;
 HEAP32[gb + 56748 >> 2] = fb + 485;
 HEAP32[gb + 56756 >> 2] = fb + 486;
 HEAP32[gb + 56760 >> 2] = fb + 487;
 HEAP32[gb + 56764 >> 2] = fb + 488;
 HEAP32[gb + 56768 >> 2] = fb + 489;
 HEAP32[gb + 56772 >> 2] = fb + 490;
 HEAP32[gb + 56776 >> 2] = fb + 491;
 HEAP32[gb + 56780 >> 2] = fb + 492;
 HEAP32[gb + 56784 >> 2] = fb + 493;
 HEAP32[gb + 56792 >> 2] = fb + 494;
 HEAP32[gb + 56796 >> 2] = fb + 495;
 HEAP32[gb + 56800 >> 2] = fb + 496;
 HEAP32[gb + 56804 >> 2] = fb + 497;
 HEAP32[gb + 56808 >> 2] = fb + 498;
 HEAP32[gb + 56812 >> 2] = fb + 499;
 HEAP32[gb + 56816 >> 2] = fb + 500;
 HEAP32[gb + 56820 >> 2] = fb + 501;
 HEAP32[gb + 56828 >> 2] = fb + 502;
 HEAP32[gb + 56832 >> 2] = fb + 503;
 HEAP32[gb + 56836 >> 2] = fb + 504;
 HEAP32[gb + 56840 >> 2] = fb + 505;
 HEAP32[gb + 56844 >> 2] = fb + 506;
 HEAP32[gb + 56848 >> 2] = fb + 507;
 HEAP32[gb + 56852 >> 2] = fb + 508;
 HEAP32[gb + 56856 >> 2] = fb + 509;
 HEAP32[gb + 56864 >> 2] = fb + 510;
 HEAP32[gb + 56868 >> 2] = fb + 511;
 HEAP32[gb + 56872 >> 2] = fb + 512;
 HEAP32[gb + 56876 >> 2] = fb + 513;
 HEAP32[gb + 56880 >> 2] = fb + 514;
 HEAP32[gb + 56884 >> 2] = fb + 515;
 HEAP32[gb + 56888 >> 2] = fb + 516;
 HEAP32[gb + 56892 >> 2] = fb + 517;
 HEAP32[gb + 56960 >> 2] = fb + 518;
 HEAP32[gb + 56964 >> 2] = fb + 519;
 HEAP32[gb + 56972 >> 2] = fb + 520;
 HEAP32[gb + 56976 >> 2] = fb + 521;
 HEAP32[gb + 57028 >> 2] = fb + 522;
 HEAP32[gb + 57056 >> 2] = fb + 523;
 HEAP32[gb + 57068 >> 2] = fb + 524;
 HEAP32[gb + 57076 >> 2] = fb + 525;
 HEAP32[gb + 57080 >> 2] = fb + 526;
 HEAP32[gb + 57084 >> 2] = fb + 527;
 HEAP32[gb + 57108 >> 2] = fb + 528;
 HEAP32[gb + 57116 >> 2] = fb + 529;
 HEAP32[gb + 57128 >> 2] = fb + 530;
 HEAP32[gb + 57132 >> 2] = fb + 531;
 HEAP32[gb + 57212 >> 2] = fb + 532;
 HEAP32[gb + 57220 >> 2] = fb + 533;
 HEAP32[gb + 57224 >> 2] = fb + 534;
 HEAP32[gb + 57236 >> 2] = fb + 535;
 HEAP32[gb + 57244 >> 2] = fb + 536;
 HEAP32[gb + 57264 >> 2] = fb + 537;
 HEAP32[gb + 57268 >> 2] = fb + 538;
 HEAP32[gb + 57272 >> 2] = fb + 539;
 HEAP32[gb + 57276 >> 2] = fb + 540;
 HEAP32[gb + 57284 >> 2] = fb + 541;
 HEAP32[gb + 57292 >> 2] = fb + 542;
 HEAP32[gb + 57296 >> 2] = fb + 543;
 runPostSets39();
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i1, i11, i3) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i11 >> 2] = i2;
  i11 = i2;
  return i11 | 0;
 }
 i7 = HEAP8[i3 + 11 >> 0] | 0;
 i9 = i7 << 24 >> 24 < 0;
 i10 = i9 ? HEAP32[i3 >> 2] | 0 : i3;
 i7 = i9 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
 i9 = i10 + i7 | 0;
 L5 : do if (!i7) {
  i2 = i1 + 16 | 0;
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i3 << 24 >> 24 < 0;
  i2 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i3 = i8 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  if (!i3) i8 = 26; else {
   i7 = i2;
   i6 = i2 + i3 | 0;
   while (1) {
    i5 = i10;
    i2 = i7;
    while (1) {
     if ((i5 | 0) == (i9 | 0)) break;
     i4 = HEAP8[i5 >> 0] | 0;
     i8 = HEAP8[i2 >> 0] | 0;
     i3 = i4 & 255;
     i3 = ((i4 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255;
     i4 = i8 & 255;
     i4 = ((i8 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
     if ((i3 & 255) < (i4 & 255)) break;
     if ((i4 & 255) < (i3 & 255)) {
      i8 = 26;
      break L5;
     }
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i6 | 0)) {
      i8 = 26;
      break L5;
     } else i5 = i5 + 1 | 0;
    }
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     i8 = 18;
     break L5;
    }
    i3 = i2 + 16 | 0;
    i4 = HEAP8[i3 + 11 >> 0] | 0;
    i8 = i4 << 24 >> 24 < 0;
    i3 = i8 ? HEAP32[i3 >> 2] | 0 : i3;
    i4 = i8 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
    if (!i4) {
     i1 = i2;
     i8 = 26;
     break;
    } else {
     i1 = i2;
     i7 = i3;
     i6 = i3 + i4 | 0;
    }
   }
  }
 } else {
  while (1) {
   i4 = i1 + 16 | 0;
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i7 = i6 << 24 >> 24 < 0;
   i4 = i7 ? HEAP32[i4 >> 2] | 0 : i4;
   i6 = i7 ? HEAP32[i1 + 20 >> 2] | 0 : i6 & 255;
   i7 = i4 + i6 | 0;
   L19 : do if (!i6) {
    i5 = i10;
    i8 = 19;
   } else {
    i2 = i10;
    i3 = i4;
    while (1) {
     if ((i2 | 0) == (i9 | 0)) break;
     i6 = HEAP8[i2 >> 0] | 0;
     i12 = HEAP8[i3 >> 0] | 0;
     i5 = i6 & 255;
     i5 = ((i6 + -65 & 255) < 26 ? i5 + 32 | 0 : i5) & 255;
     i6 = i12 & 255;
     i6 = ((i12 + -65 & 255) < 26 ? i6 + 32 | 0 : i6) & 255;
     if ((i5 & 255) < (i6 & 255)) break;
     if ((i6 & 255) < (i5 & 255)) {
      i5 = i10;
      i8 = 19;
      break L19;
     }
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i7 | 0)) {
      i5 = i10;
      i8 = 19;
      break L19;
     } else i2 = i2 + 1 | 0;
    }
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     i8 = 18;
     break L5;
    } else i1 = i2;
   } while (0);
   if ((i8 | 0) == 19) {
    while (1) {
     i8 = 0;
     if ((i4 | 0) == (i7 | 0)) break;
     i3 = HEAP8[i4 >> 0] | 0;
     i12 = HEAP8[i5 >> 0] | 0;
     i2 = i3 & 255;
     i2 = ((i3 + -65 & 255) < 26 ? i2 + 32 | 0 : i2) & 255;
     i3 = i12 & 255;
     i3 = ((i12 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255;
     if ((i2 & 255) < (i3 & 255)) break;
     if ((i3 & 255) < (i2 & 255)) {
      i8 = 26;
      break L5;
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i9 | 0)) {
      i8 = 26;
      break L5;
     } else {
      i4 = i4 + 1 | 0;
      i8 = 19;
     }
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
  }
  HEAP32[i11 >> 2] = i1;
  i12 = i2;
  return i12 | 0;
 } while (0);
 if ((i8 | 0) == 18) {
  HEAP32[i11 >> 2] = i2;
  i12 = i1;
  return i12 | 0;
 } else if ((i8 | 0) == 26) {
  HEAP32[i11 >> 2] = i1;
  i12 = i11;
  return i12 | 0;
 }
 return 0;
}

function __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i10, i1, i4, i5, i6, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 8 | 0;
 i3 = i13;
 i9 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 80 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i9 >> 2] = 0;
  i11 = i2 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) - i4;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if (!(HEAP32[i2 >> 2] | 0)) {
   __ZN23AllocationRootReferenceD2Ev(i2);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63584 | 0);
  }
 }
 i7 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 i11 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63584 | 0, 16, gb + 461921 | 0, 360) | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i11 + 8 >> 2] = i6;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i11 + 24 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i5 = i8 | 0 ? i8 : gb + 1576256 | 0;
 i6 = _strlen(i5) | 0;
 i2 = i11 + 23 | 0;
 do if (i6 >>> 0 > 10) {
  if ((i6 + -10 | 0) >>> 0 > 2147483620) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i4 = i6 >>> 0 < 20 ? 20 : i6;
  i4 = i4 >>> 0 < 11 ? 11 : i4 + 16 & -16;
  HEAP32[i12 >> 2] = 58;
  HEAP32[i12 + 4 >> 2] = i1;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  _memcpy(i8 | 0, i5 | 0, i6 | 0) | 0;
  HEAP32[i7 >> 2] = i8;
  HEAP32[i11 + 20 >> 2] = i4 | -2147483648;
  HEAP32[i11 + 16 >> 2] = i6;
  HEAP8[i8 + i6 >> 0] = 0;
 } else {
  if (i6 | 0) _memmove(i7 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i7 + i6 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i11 + 16 >> 2] = i6;
   break;
  } else {
   HEAP8[i2 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i11;
 i6 = i11;
 i7 = HEAP32[i10 + 168 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i11 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 18;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i11 >>> 0) {
     i2 = 23;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 22;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 18) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 22) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 23) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i12 >> 2] = 58;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(20, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i12 = i7 + 12 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 }
 STACKTOP = i13;
 return;
}

function __ZN13TrailRenderer18TransferDeprecatedI14SafeBinaryReadEEvRT_(i6, i10) {
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 152 | 0;
 i7 = i12 + 144 | 0;
 i8 = i12 + 140 | 0;
 i11 = i12;
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i10, 1) | 0)) {
  STACKTOP = i12;
  return;
 }
 i4 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 421232 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 7; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i5 = 7; else {
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 421245 | 0, i4, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i10 + 16 | 0;
   i4 = HEAP32[i10 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 i2 = f13 < Math_fround(HEAPF32[i8 >> 2]);
 i7 = i2 ? i8 : i7;
 i2 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(1.0);
 i7 = HEAP32[(i2 ? i7 : i9) >> 2] | 0;
 i2 = i6 + 384 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = i7;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAPF32[i11 >> 2] = Math_fround(f13 / (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(0.0), i11);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i1 + 20 | 0, i9) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 HEAPF32[i11 >> 2] = Math_fround(f13 / Math_fround(HEAPF32[i1 + 16 >> 2]));
 __ZN11KeyframeTplIfEC2EfRKf(i9, Math_fround(1.0), i11);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i1 + 20 | 0, i9) | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 469900 | 0, gb + 421256 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN16DeprecatedColors8TransferI14SafeBinaryReadEEvRT_(i11, i10); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i11 | 0, i10 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i10);
 }
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj((HEAP32[i2 >> 2] | 0) + 108 | 0, i11, 5);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj((HEAP32[i2 >> 2] | 0) + 108 | 0, i11 + 100 | 0, 5);
 STACKTOP = i12;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i24 = HEAP32[i5 + 4 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(-f15);
 f28 = Math_fround(-f28);
 f29 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i16 >> 2]);
 f33 = Math_fround(f20 * f15);
 f17 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f17 * f28));
 f13 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f33 = Math_fround(f33 + Math_fround(f13 * f29));
 f10 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f32 = Math_fround(f10 * f15);
 f12 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f12 * f28));
 f9 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f32 = Math_fround(f32 + Math_fround(f9 * f29));
 f21 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f15 = Math_fround(f21 * f15);
 f18 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f28 = Math_fround(f15 + Math_fround(f18 * f28));
 f15 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f29 = Math_fround(f28 + Math_fround(f15 * f29));
 f28 = Math_fround(HEAPF32[i24 + 96 >> 2]);
 f26 = Math_fround(HEAPF32[i24 + 100 >> 2]);
 f19 = Math_fround(HEAPF32[i24 + 104 >> 2]);
 f27 = Math_fround(HEAPF32[i24 + 112 >> 2]);
 f25 = Math_fround(HEAPF32[i24 + 116 >> 2]);
 f22 = Math_fround(HEAPF32[i24 + 120 >> 2]);
 f8 = Math_fround(HEAPF32[i24 + 128 >> 2]);
 f7 = Math_fround(HEAPF32[i24 + 132 >> 2]);
 f14 = Math_fround(HEAPF32[i24 + 136 >> 2]);
 f31 = Math_fround(Math_fround(Math_fround(f33 * f28) + Math_fround(f32 * f26)) + Math_fround(f29 * f19));
 f30 = Math_fround(Math_fround(Math_fround(f33 * f27) + Math_fround(f32 * f25)) + Math_fround(f29 * f22));
 f29 = Math_fround(Math_fround(Math_fround(f33 * f8) + Math_fround(f32 * f7)) + Math_fround(f29 * f14));
 i24 = f31 > f30 & f31 > f29;
 i23 = f30 > f29;
 f8 = i24 ? f28 : i23 ? f27 : f8;
 f7 = i24 ? f26 : i23 ? f25 : f7;
 f14 = i24 ? f19 : i23 ? f22 : f14;
 f22 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f10 = Math_fround(f22 + Math_fround(Math_fround(f21 * f14) + Math_fround(Math_fround(f20 * f8) + Math_fround(f10 * f7))));
 f12 = Math_fround(f19 + Math_fround(Math_fround(f18 * f14) + Math_fround(Math_fround(f17 * f8) + Math_fround(f12 * f7))));
 f7 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f13 * f8) + Math_fround(f9 * f7))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc15ClothFabricCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 224 | 0;
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx2Sc19ClothFabricBulkData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i10 >> 2] = HEAP32[gb + 128388 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 128388 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 128388 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[gb + 128388 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[gb + 128388 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[gb + 128388 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[gb + 128388 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[gb + 128388 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 | 0, 32) | 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 128420 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 128420 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 128420 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 128420 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 128420 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 128420 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 128420 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 128420 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 128452 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 128452 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 128452 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 128452 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 128452 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 128452 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 128452 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 128452 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 1087820;
 HEAP32[i7 + 4 >> 2] = gb + 750032;
 HEAP32[i7 + 8 >> 2] = 8;
 HEAP32[i7 + 12 >> 2] = 4;
 HEAP32[i7 + 16 >> 2] = 1;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 8;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 827882;
 HEAP32[i6 + 4 >> 2] = gb + 750050;
 HEAP32[i6 + 8 >> 2] = 12;
 HEAP32[i6 + 12 >> 2] = 4;
 HEAP32[i6 + 16 >> 2] = 1;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 827882;
 HEAP32[i5 + 4 >> 2] = gb + 750068;
 HEAP32[i5 + 8 >> 2] = 16;
 HEAP32[i5 + 12 >> 2] = 4;
 HEAP32[i5 + 16 >> 2] = 1;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 2048;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 827882;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 12;
 HEAP32[i4 + 12 >> 2] = 4;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 16;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 128484 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 128484 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 128484 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 128484 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 128484 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 128484 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 128484 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 128484 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 28 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 72 | 0, 4) | 0;
  i2 = i4 + (i1 * 72 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    HEAP32[i1 + 40 >> 2] = 1;
    i9 = i1 + 44 | 0;
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i9 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i9 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    HEAP32[i9 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
    i1 = i1 + 72 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) * 72 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906336 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN4math8Collider8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 72 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906336 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4math8Collider8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 72 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function runPostSets83() {
 HEAP32[gb + 88124 >> 2] = fb + 1154;
 HEAP32[gb + 88128 >> 2] = fb + 854;
 HEAP32[gb + 88140 >> 2] = fb + 495;
 HEAP32[gb + 88144 >> 2] = fb + 65;
 HEAP32[gb + 88148 >> 2] = fb + 1155;
 HEAP32[gb + 88152 >> 2] = fb + 855;
 HEAP32[gb + 88156 >> 2] = fb + 856;
 HEAP32[gb + 88160 >> 2] = fb + 226;
 HEAP32[gb + 88164 >> 2] = fb + 496;
 HEAP32[gb + 88168 >> 2] = fb + 1156;
 HEAP32[gb + 88172 >> 2] = fb + 1157;
 HEAP32[gb + 88184 >> 2] = fb + 136;
 HEAP32[gb + 88188 >> 2] = fb + 114;
 HEAP32[gb + 88192 >> 2] = fb + 1158;
 HEAP32[gb + 88196 >> 2] = fb + 1159;
 HEAP32[gb + 88200 >> 2] = fb + 1160;
 HEAP32[gb + 88204 >> 2] = fb + 1161;
 HEAP32[gb + 88208 >> 2] = fb + 26;
 HEAP32[gb + 88220 >> 2] = fb + 69;
 HEAP32[gb + 88224 >> 2] = fb + 33;
 HEAP32[gb + 88236 >> 2] = fb + 1162;
 HEAP32[gb + 88240 >> 2] = fb + 497;
 HEAP32[gb + 88244 >> 2] = fb + 456;
 HEAP32[gb + 88248 >> 2] = fb + 1163;
 HEAP32[gb + 88252 >> 2] = fb + 1164;
 HEAP32[gb + 88256 >> 2] = fb + 227;
 HEAP32[gb + 88260 >> 2] = fb + 115;
 HEAP32[gb + 88264 >> 2] = fb + 116;
 HEAP32[gb + 88268 >> 2] = fb + 117;
 HEAP32[gb + 88272 >> 2] = fb + 118;
 HEAP32[gb + 88276 >> 2] = fb + 857;
 HEAP32[gb + 88280 >> 2] = fb + 858;
 HEAP32[gb + 88284 >> 2] = fb + 859;
 HEAP32[gb + 88288 >> 2] = fb + 5;
 HEAP32[gb + 88292 >> 2] = fb + 119;
 HEAP32[gb + 88296 >> 2] = fb + 860;
 HEAP32[gb + 88300 >> 2] = fb + 120;
 HEAP32[gb + 88304 >> 2] = fb + 498;
 HEAP32[gb + 88308 >> 2] = fb + 30;
 HEAP32[gb + 88312 >> 2] = fb + 51;
 HEAP32[gb + 88316 >> 2] = fb + 31;
 HEAP32[gb + 88320 >> 2] = fb + 52;
 HEAP32[gb + 88324 >> 2] = fb + 32;
 HEAP32[gb + 88328 >> 2] = fb + 53;
 HEAP32[gb + 88332 >> 2] = fb + 33;
 HEAP32[gb + 88336 >> 2] = fb + 54;
 HEAP32[gb + 88340 >> 2] = fb + 499;
 HEAP32[gb + 88344 >> 2] = fb + 861;
 HEAP32[gb + 88348 >> 2] = fb + 500;
 HEAP32[gb + 88352 >> 2] = fb + 501;
 HEAP32[gb + 88356 >> 2] = fb + 55;
 HEAP32[gb + 88360 >> 2] = fb + 56;
 HEAP32[gb + 88364 >> 2] = fb + 862;
 HEAP32[gb + 88368 >> 2] = fb + 863;
 HEAP32[gb + 88372 >> 2] = fb + 864;
 HEAP32[gb + 88376 >> 2] = fb + 121;
 HEAP32[gb + 88380 >> 2] = fb + 502;
 HEAP32[gb + 88384 >> 2] = fb + 34;
 HEAP32[gb + 88388 >> 2] = fb + 57;
 HEAP32[gb + 88392 >> 2] = fb + 35;
 HEAP32[gb + 88396 >> 2] = fb + 58;
 HEAP32[gb + 88400 >> 2] = fb + 865;
 HEAP32[gb + 88404 >> 2] = fb + 66;
 HEAP32[gb + 88408 >> 2] = fb + 866;
 HEAP32[gb + 88412 >> 2] = fb + 867;
 HEAP32[gb + 88416 >> 2] = fb + 503;
 HEAP32[gb + 88420 >> 2] = fb + 228;
 HEAP32[gb + 88424 >> 2] = fb + 504;
 HEAP32[gb + 88428 >> 2] = fb + 1165;
 HEAP32[gb + 88432 >> 2] = fb + 868;
 HEAP32[gb + 88444 >> 2] = fb + 505;
 HEAP32[gb + 88448 >> 2] = fb + 67;
 HEAP32[gb + 88452 >> 2] = fb + 1166;
 HEAP32[gb + 88456 >> 2] = fb + 869;
 HEAP32[gb + 88460 >> 2] = fb + 870;
 HEAP32[gb + 88464 >> 2] = fb + 229;
 HEAP32[gb + 88468 >> 2] = fb + 506;
 HEAP32[gb + 88472 >> 2] = fb + 1167;
 HEAP32[gb + 88476 >> 2] = fb + 1168;
 HEAP32[gb + 88480 >> 2] = fb + 27;
 HEAP32[gb + 88492 >> 2] = fb + 70;
 HEAP32[gb + 88496 >> 2] = fb + 34;
 HEAP32[gb + 88508 >> 2] = fb + 1169;
 HEAP32[gb + 88512 >> 2] = fb + 507;
 HEAP32[gb + 88516 >> 2] = fb + 456;
 HEAP32[gb + 88520 >> 2] = fb + 1170;
 HEAP32[gb + 88524 >> 2] = fb + 1171;
 HEAP32[gb + 88528 >> 2] = fb + 230;
 HEAP32[gb + 88532 >> 2] = fb + 122;
 HEAP32[gb + 88536 >> 2] = fb + 123;
 HEAP32[gb + 88540 >> 2] = fb + 124;
 HEAP32[gb + 88544 >> 2] = fb + 125;
 HEAP32[gb + 88548 >> 2] = fb + 871;
 HEAP32[gb + 88552 >> 2] = fb + 872;
 HEAP32[gb + 88556 >> 2] = fb + 873;
 HEAP32[gb + 88560 >> 2] = fb + 6;
 HEAP32[gb + 88564 >> 2] = fb + 126;
 HEAP32[gb + 88568 >> 2] = fb + 874;
 HEAP32[gb + 88572 >> 2] = fb + 127;
 HEAP32[gb + 88576 >> 2] = fb + 508;
 runPostSets84();
}

function __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_(i1, i13, i12, i7, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i14 = __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i1, i13, i12, i2) | 0;
 i5 = HEAP8[i7 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255;
 i8 = i12 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i9 = i12 + 4 | 0;
 i6 = i3 ? HEAP32[i9 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 3; else {
  i2 = _memcmp(i4 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i12 >> 2] | 0 : i12, i2) | 0;
  if (!i2) i16 = 3; else if ((i2 | 0) < 0) {
   i2 = i7;
   i11 = i12;
  } else {
   i16 = i14;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 3) if (i5 >>> 0 < i6 >>> 0) {
  i2 = i7;
  i11 = i12;
  break;
 } else {
  i16 = i14;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i7 = i14 + 1 | 0;
 i5 = HEAP8[i8 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
 i9 = i13 + 11 | 0;
 i6 = HEAP8[i9 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i10 = i13 + 4 | 0;
 i6 = i3 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 8; else {
  i2 = _memcmp(i4 ? HEAP32[i12 >> 2] | 0 : i11, i3 ? HEAP32[i13 >> 2] | 0 : i13, i2) | 0;
  if (!i2) i16 = 8; else if ((i2 | 0) < 0) i8 = i13; else {
   i16 = i7;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 8) if (i5 >>> 0 < i6 >>> 0) {
  i8 = i13;
  break;
 } else {
  i16 = i7;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i7 = i14 + 2 | 0;
 i5 = HEAP8[i9 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i10 >> 2] | 0 : i5 & 255;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i2 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
 if (!i2) i16 = 13; else {
  i2 = _memcmp(i4 ? HEAP32[i13 >> 2] | 0 : i8, i3 ? HEAP32[i1 >> 2] | 0 : i1, i2) | 0;
  if (!i2) i16 = 13; else if ((i2 | 0) >= 0) {
   i16 = i7;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 do if ((i16 | 0) == 13) if (i5 >>> 0 < i6 >>> 0) break; else {
  i16 = i7;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i16 = i14 + 3 | 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZL15NormalizeRobustRK8Vector3fRfS2_(i8, i1, i9, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 f5 = Math_fround(-f3);
 f5 = i1 ? f5 : f3;
 i1 = f5 <= Math_fround(9.99999974e-06);
 f3 = i1 ? Math_fround(0.0) : f3;
 f5 = i1 ? Math_fround(0.0) : f5;
 i1 = f7 < Math_fround(0.0);
 f4 = Math_fround(-f7);
 f4 = i1 ? f4 : f7;
 i1 = f4 <= Math_fround(9.99999974e-06);
 f7 = i1 ? Math_fround(0.0) : f7;
 f4 = i1 ? Math_fround(0.0) : f4;
 i1 = f6 < Math_fround(0.0);
 f2 = Math_fround(-f6);
 f2 = i1 ? f2 : f6;
 i1 = f2 <= Math_fround(9.99999974e-06);
 f6 = i1 ? Math_fround(0.0) : f6;
 f2 = i1 ? Math_fround(0.0) : f2;
 if (f4 > f5) if (f2 > f4) {
  f4 = Math_fround(f3 / f2);
  f5 = Math_fround(f7 / f2);
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(1.0)))));
  HEAPF32[i10 >> 2] = f2;
  f7 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(f4 * f7);
  f5 = Math_fround(f5 * f7);
  i10 = f7 < Math_fround(0.0);
  f7 = Math_fround(f7 * (i10 ? Math_fround(-1.0) : Math_fround(1.0)));
  i10 = f6 < Math_fround(0.0);
  f7 = Math_fround((i10 ? Math_fround(-1.0) : Math_fround(1.0)) * f7);
  HEAPF32[i8 >> 2] = f4;
  HEAPF32[i8 + 4 >> 2] = f5;
  HEAPF32[i8 + 8 >> 2] = f7;
  return;
 } else {
  f5 = Math_fround(f3 / f4);
  f3 = Math_fround(f6 / f4);
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3)) + Math_fround(1.0)))));
  HEAPF32[i10 >> 2] = f4;
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(f5 * f4);
  i10 = f4 < Math_fround(0.0);
  f6 = Math_fround(f4 * (i10 ? Math_fround(-1.0) : Math_fround(1.0)));
  i10 = f7 < Math_fround(0.0);
  f6 = Math_fround((i10 ? Math_fround(-1.0) : Math_fround(1.0)) * f6);
  f7 = Math_fround(f3 * f4);
  HEAPF32[i8 >> 2] = f5;
  HEAPF32[i8 + 4 >> 2] = f6;
  HEAPF32[i8 + 8 >> 2] = f7;
  return;
 }
 if (f2 > f5) {
  f4 = Math_fround(f3 / f2);
  f5 = Math_fround(f7 / f2);
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(1.0)))));
  HEAPF32[i10 >> 2] = f2;
  f7 = Math_fround(HEAPF32[i9 >> 2]);
  f4 = Math_fround(f4 * f7);
  f5 = Math_fround(f5 * f7);
  i10 = f7 < Math_fround(0.0);
  f7 = Math_fround(f7 * (i10 ? Math_fround(-1.0) : Math_fround(1.0)));
  i10 = f6 < Math_fround(0.0);
  f7 = Math_fround((i10 ? Math_fround(-1.0) : Math_fround(1.0)) * f7);
  HEAPF32[i8 >> 2] = f4;
  HEAPF32[i8 + 4 >> 2] = f5;
  HEAPF32[i8 + 8 >> 2] = f7;
  return;
 }
 if (!(f5 <= Math_fround(0.0))) {
  f2 = Math_fround(f7 / f5);
  f4 = Math_fround(f6 / f5);
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(1.0)))));
  HEAPF32[i10 >> 2] = f5;
  f7 = Math_fround(HEAPF32[i9 >> 2]);
  i10 = f7 < Math_fround(0.0);
  f5 = Math_fround(f7 * (i10 ? Math_fround(-1.0) : Math_fround(1.0)));
  i10 = f3 < Math_fround(0.0);
  f6 = Math_fround(f2 * f7);
  f7 = Math_fround(f4 * f7);
  HEAPF32[i8 >> 2] = Math_fround((i10 ? Math_fround(-1.0) : Math_fround(1.0)) * f5);
  HEAPF32[i8 + 4 >> 2] = f6;
  HEAPF32[i8 + 8 >> 2] = f7;
  return;
 } else {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  return;
 }
}

function runPostSets78() {
 HEAP32[gb + 85548 >> 2] = fb + 1009;
 HEAP32[gb + 85552 >> 2] = fb + 1032;
 HEAP32[gb + 85556 >> 2] = fb + 34;
 HEAP32[gb + 85560 >> 2] = fb + 25;
 HEAP32[gb + 85564 >> 2] = fb + 787;
 HEAP32[gb + 85576 >> 2] = fb + 986;
 HEAP32[gb + 85580 >> 2] = fb + 1033;
 HEAP32[gb + 85584 >> 2] = fb + 123;
 HEAP32[gb + 85596 >> 2] = fb + 15;
 HEAP32[gb + 85600 >> 2] = fb + 988;
 HEAP32[gb + 85604 >> 2] = fb + 1034;
 HEAP32[gb + 85616 >> 2] = fb + 124;
 HEAP32[gb + 85620 >> 2] = fb + 1035;
 HEAP32[gb + 85624 >> 2] = fb + 1036;
 HEAP32[gb + 85628 >> 2] = fb + 1037;
 HEAP32[gb + 85784 >> 2] = fb + 986;
 HEAP32[gb + 85788 >> 2] = fb + 1038;
 HEAP32[gb + 85792 >> 2] = fb + 125;
 HEAP32[gb + 85804 >> 2] = fb + 16;
 HEAP32[gb + 85808 >> 2] = fb + 1039;
 HEAP32[gb + 85812 >> 2] = fb + 1040;
 HEAP32[gb + 85824 >> 2] = fb + 17;
 HEAP32[gb + 85828 >> 2] = fb + 1041;
 HEAP32[gb + 85832 >> 2] = fb + 1042;
 HEAP32[gb + 85844 >> 2] = fb + 18;
 HEAP32[gb + 85848 >> 2] = fb + 1043;
 HEAP32[gb + 85852 >> 2] = fb + 1044;
 HEAP32[gb + 85864 >> 2] = fb + 19;
 HEAP32[gb + 85868 >> 2] = fb + 1045;
 HEAP32[gb + 85872 >> 2] = fb + 1046;
 HEAP32[gb + 85884 >> 2] = fb + 20;
 HEAP32[gb + 85888 >> 2] = fb + 1047;
 HEAP32[gb + 85892 >> 2] = fb + 1048;
 HEAP32[gb + 85904 >> 2] = fb + 21;
 HEAP32[gb + 85908 >> 2] = fb + 1049;
 HEAP32[gb + 85912 >> 2] = fb + 1050;
 HEAP32[gb + 85924 >> 2] = fb + 25;
 HEAP32[gb + 85928 >> 2] = fb + 126;
 HEAP32[gb + 85932 >> 2] = fb + 1051;
 HEAP32[gb + 85936 >> 2] = fb + 1052;
 HEAP32[gb + 85948 >> 2] = fb + 127;
 HEAP32[gb + 85952 >> 2] = fb + 1053;
 HEAP32[gb + 85956 >> 2] = fb + 1054;
 HEAP32[gb + 85960 >> 2] = fb + 1055;
 HEAP32[gb + 85964 >> 2] = fb + 1;
 HEAP32[gb + 85968 >> 2] = fb + 2;
 HEAP32[gb + 85972 >> 2] = fb + 3;
 HEAP32[gb + 85976 >> 2] = fb + 4;
 HEAP32[gb + 85980 >> 2] = fb + 5;
 HEAP32[gb + 85984 >> 2] = fb + 6;
 HEAP32[gb + 85988 >> 2] = fb + 7;
 HEAP32[gb + 86e3 >> 2] = fb + 22;
 HEAP32[gb + 86004 >> 2] = fb + 988;
 HEAP32[gb + 86008 >> 2] = fb + 1056;
 HEAP32[gb + 86020 >> 2] = fb + 58;
 HEAP32[gb + 86024 >> 2] = fb + 1057;
 HEAP32[gb + 86028 >> 2] = fb + 1058;
 HEAP32[gb + 86032 >> 2] = fb + 128;
 HEAP32[gb + 86044 >> 2] = fb + 129;
 HEAP32[gb + 86048 >> 2] = fb + 992;
 HEAP32[gb + 86052 >> 2] = fb + 1059;
 HEAP32[gb + 86056 >> 2] = fb + 1060;
 HEAP32[gb + 86068 >> 2] = fb + 1061;
 HEAP32[gb + 86072 >> 2] = fb + 1062;
 HEAP32[gb + 86076 >> 2] = fb + 26;
 HEAP32[gb + 86088 >> 2] = fb + 1063;
 HEAP32[gb + 86092 >> 2] = fb + 1064;
 HEAP32[gb + 86096 >> 2] = fb + 1;
 HEAP32[gb + 86108 >> 2] = fb + 431;
 HEAP32[gb + 86112 >> 2] = fb + 1065;
 HEAP32[gb + 86116 >> 2] = fb + 2;
 HEAP32[gb + 86120 >> 2] = fb + 205;
 HEAP32[gb + 86124 >> 2] = fb + 432;
 HEAP32[gb + 86128 >> 2] = fb + 206;
 HEAP32[gb + 86132 >> 2] = fb + 788;
 HEAP32[gb + 86136 >> 2] = fb + 433;
 HEAP32[gb + 86140 >> 2] = fb + 5;
 HEAP32[gb + 86144 >> 2] = fb + 19;
 HEAP32[gb + 86148 >> 2] = fb + 789;
 HEAP32[gb + 86152 >> 2] = fb + 434;
 HEAP32[gb + 86156 >> 2] = fb + 20;
 HEAP32[gb + 86160 >> 2] = fb + 6;
 HEAP32[gb + 86164 >> 2] = fb + 790;
 HEAP32[gb + 86168 >> 2] = fb + 791;
 HEAP32[gb + 86172 >> 2] = fb + 21;
 HEAP32[gb + 86176 >> 2] = fb + 7;
 HEAP32[gb + 86180 >> 2] = fb + 1066;
 HEAP32[gb + 86184 >> 2] = fb + 435;
 HEAP32[gb + 86188 >> 2] = fb + 436;
 HEAP32[gb + 86192 >> 2] = fb + 792;
 HEAP32[gb + 86196 >> 2] = fb + 793;
 HEAP32[gb + 86200 >> 2] = fb + 794;
 HEAP32[gb + 86204 >> 2] = fb + 8;
 HEAP32[gb + 86208 >> 2] = fb + 1067;
 HEAP32[gb + 86212 >> 2] = fb + 1068;
 HEAP32[gb + 86216 >> 2] = fb + 22;
 HEAP32[gb + 86220 >> 2] = fb + 4;
 HEAP32[gb + 86224 >> 2] = fb + 23;
 HEAP32[gb + 86228 >> 2] = fb + 5;
 HEAP32[gb + 86232 >> 2] = fb + 437;
 runPostSets79();
}

function __ZN9GfxDevice16DynamicBatchMeshERK10Matrix4x4fRK16VertexBufferDatajjPKtj25GfxTransformVerticesFlags(i13, i14, i15, i16, i17, i12, i9, i18) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 if (!(HEAP8[i13 + 4536 >> 0] | 0)) return;
 i2 = HEAP32[i13 + 4580 >> 2] | 0;
 if ((i2 | 0) == 2) {
  i4 = i9 >>> 2;
  i8 = i4 * 6 | 0;
  i3 = i4 * 12 | 0;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 2, gb + 64016 | 0, 0, gb + 392043 | 0, 628) | 0;
  if (i4 | 0) {
   i2 = 0;
   i1 = i12;
   while (1) {
    i12 = i2 * 6 | 0;
    HEAP16[i9 + (i12 << 1) >> 1] = HEAP16[i1 >> 1] | 0;
    HEAP16[i9 + ((i12 | 1) << 1) >> 1] = HEAP16[i1 + 2 >> 1] | 0;
    i11 = i1 + 4 | 0;
    HEAP16[i9 + (i12 + 2 << 1) >> 1] = HEAP16[i11 >> 1] | 0;
    HEAP16[i9 + (i12 + 3 << 1) >> 1] = HEAP16[i1 >> 1] | 0;
    HEAP16[i9 + (i12 + 4 << 1) >> 1] = HEAP16[i11 >> 1] | 0;
    HEAP16[i9 + (i12 + 5 << 1) >> 1] = HEAP16[i1 + 6 >> 1] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 8 | 0;
   }
  }
  i1 = i13 + 4608 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i2 = i13 + 4568 | 0;
  i7 = (HEAP32[i2 >> 2] | 0) - i16 | 0;
  i4 = (i8 | 0) == 0;
  if ((i7 | 0) > -1) {
   if (!i4) {
    i6 = 0;
    i4 = i5;
    i5 = i9;
    while (1) {
     HEAP16[i4 >> 1] = (HEAPU16[i5 >> 1] | 0) + i7;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i8 | 0)) break; else {
      i4 = i4 + 2 | 0;
      i5 = i5 + 2 | 0;
     }
    }
   }
  } else if (!i4) {
   i6 = 0;
   i4 = i5;
   i5 = i9;
   while (1) {
    HEAP16[i4 >> 1] = (HEAPU16[i5 >> 1] | 0) + i7;
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i8 | 0)) break; else {
     i4 = i4 + 2 | 0;
     i5 = i5 + 2 | 0;
    }
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64016 | 0);
 } else {
  i1 = i13 + 4608 | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  i11 = i13 + 4568 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i8 = (i2 | 0) == 1;
  if (i8 & (i3 | 0) != 0) {
   HEAP16[i10 >> 1] = HEAP16[i10 + -2 >> 1] | 0;
   i5 = i3 - i16 | 0;
   HEAP16[i10 + 2 >> 1] = (HEAPU16[i12 >> 1] | 0) + i5;
   i7 = i10 + 4 | 0;
  } else {
   i7 = i10;
   i5 = i3 - i16 | 0;
  }
  i2 = i9 >>> 1;
  i6 = i2 << 1;
  i2 = (i2 | 0) == 0;
  if ((i5 | 0) > -1) {
   if (!i2) {
    i2 = 0;
    i3 = i7;
    i4 = i12;
    while (1) {
     HEAP16[i3 >> 1] = (HEAPU16[i4 >> 1] | 0) + i5;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i6 | 0)) break; else {
      i3 = i3 + 2 | 0;
      i4 = i4 + 2 | 0;
     }
    }
   }
  } else if (!i2) {
   i2 = 0;
   i3 = i7;
   i4 = i12;
   while (1) {
    HEAP16[i3 >> 1] = (HEAPU16[i4 >> 1] | 0) + i5;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else {
     i3 = i3 + 2 | 0;
     i4 = i4 + 2 | 0;
    }
   }
  }
  if ((i6 | 0) != (i9 | 0)) {
   i6 = i9 + -1 | 0;
   HEAP16[i7 + (i6 << 1) >> 1] = (HEAPU16[i12 + (i6 << 1) >> 1] | 0) + i5;
  }
  i2 = i7 + (i9 << 1) | 0;
  if (!((i9 & 1 | 0) == 0 | i8 ^ 1)) {
   HEAP16[i2 >> 1] = HEAP16[i2 + -2 >> 1] | 0;
   i2 = i2 + 2 | 0;
  }
  i3 = i2 - i10 | 0;
  i2 = i11;
 }
 i12 = i3 >> 1;
 i11 = i13 + 4604 | 0;
 i18 = __Z17TransformVerticesPhRK10Matrix4x4fRK16VertexBufferDatajjj25GfxTransformVerticesFlags(HEAP32[i11 >> 2] | 0, i14, i15, i16, i17, HEAP32[i13 + 4556 >> 2] | 0, i18) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (i12 << 1);
 i17 = Math_imul(HEAP32[i13 + 4584 >> 2] | 0, i18) | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i17;
 i17 = i13 + 4572 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + i12;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i18;
 i18 = i13 + 4576 | 0;
 HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
 return;
}

function __ZN15SerializeTraitsIN2UI11CanvasGroupEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 i5 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1011557 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 40 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1011565 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 41 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1011580 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 42 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1011597 | 0, i4, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i1 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i7 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z16CalculateNormals14StrideIteratorI8Vector3fEPKjiiS1_(i9, i11, i14, i12, i13) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i10 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i15 = i13 + 4 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 if ((i14 | 0) > 0) {
  i3 = i14;
  i6 = i1;
  while (1) {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
   i1 = i6 + i8 | 0;
   if ((i3 | 0) > 1) {
    i3 = i3 + -1 | 0;
    i6 = i1;
   } else break;
  }
 }
 if ((i12 | 0) > 0) {
  i10 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  i8 = HEAP32[i13 >> 2] | 0;
  i9 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  i3 = 0;
  while (1) {
   i18 = HEAP32[i11 + (i3 << 2) >> 2] | 0;
   i17 = HEAP32[i11 + (i3 + 1 << 2) >> 2] | 0;
   i16 = HEAP32[i11 + (i3 + 2 << 2) >> 2] | 0;
   i23 = i10 + (Math_imul(i6, i18) | 0) | 0;
   i24 = i10 + (Math_imul(i6, i17) | 0) | 0;
   i19 = i10 + (Math_imul(i6, i16) | 0) | 0;
   f21 = Math_fround(HEAPF32[i24 >> 2]);
   f7 = Math_fround(HEAPF32[i23 >> 2]);
   f21 = Math_fround(f21 - f7);
   f2 = Math_fround(HEAPF32[i24 + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   f2 = Math_fround(f2 - f20);
   f22 = Math_fround(HEAPF32[i24 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   f22 = Math_fround(f22 - f5);
   f7 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f7);
   f20 = Math_fround(Math_fround(HEAPF32[i19 + 4 >> 2]) - f20);
   f5 = Math_fround(Math_fround(HEAPF32[i19 + 8 >> 2]) - f5);
   f4 = Math_fround(Math_fround(f2 * f5) - Math_fround(f22 * f20));
   f5 = Math_fround(Math_fround(f22 * f7) - Math_fround(f21 * f5));
   f7 = Math_fround(Math_fround(f21 * f20) - Math_fround(f2 * f7));
   i18 = i8 + (Math_imul(i9, i18) | 0) | 0;
   HEAPF32[i18 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i18 >> 2]));
   i19 = i18 + 4 | 0;
   HEAPF32[i19 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i19 >> 2]));
   i18 = i18 + 8 | 0;
   HEAPF32[i18 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i18 >> 2]));
   i17 = i8 + (Math_imul(i9, i17) | 0) | 0;
   HEAPF32[i17 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i17 >> 2]));
   i18 = i17 + 4 | 0;
   HEAPF32[i18 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i18 >> 2]));
   i17 = i17 + 8 | 0;
   HEAPF32[i17 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i17 >> 2]));
   i16 = i8 + (Math_imul(i9, i16) | 0) | 0;
   HEAPF32[i16 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i16 >> 2]));
   i17 = i16 + 4 | 0;
   HEAPF32[i17 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i17 >> 2]));
   i16 = i16 + 8 | 0;
   HEAPF32[i16 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i16 >> 2]));
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i12 | 0)) {
    i9 = i13;
    break;
   } else i3 = i3 + 3 | 0;
  }
 } else i9 = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i24 = Math_imul(HEAP32[i15 >> 2] | 0, i14) | 0;
 i8 = i1 + i24 | 0;
 if (!i24) return;
 do {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f2 = Math_fround(f4 * f4);
  i3 = i1 + 4 | 0;
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f5 * f5));
  i6 = i1 + 8 | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  f2 = Math_fround(f2 + Math_fround(f7 * f7));
  if (!(f2 == Math_fround(0.0))) f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
  f21 = Math_fround(f5 * f2);
  f22 = Math_fround(f7 * f2);
  HEAPF32[i1 >> 2] = Math_fround(f4 * f2);
  HEAPF32[i3 >> 2] = f21;
  HEAPF32[i6 >> 2] = f22;
  i1 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i15 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = i1;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i18, i19, i17, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = HEAP32[i19 >> 2] | 0;
 i15 = HEAP32[i18 >> 2] | 0;
 i11 = HEAP32[i12 + 32 >> 2] | 0;
 i1 = HEAP32[i15 + 32 >> 2] | 0;
 i13 = i12;
 i16 = i15;
 if ((i11 | 0) == (i1 | 0)) {
  i2 = i12 + 112 | 0;
  i3 = i15 + 112 | 0;
  i6 = HEAP8[i3 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i15 + 116 >> 2] | 0 : i6 & 255;
  i7 = HEAP8[i2 + 11 >> 0] | 0;
  i5 = i7 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i12 + 116 >> 2] | 0 : i7 & 255;
  i8 = i7 >>> 0 < i6 >>> 0;
  i1 = i8 ? i7 : i6;
  if (!i1) i14 = 5; else {
   i1 = _memcmp(i4 ? HEAP32[i3 >> 2] | 0 : i3, i5 ? HEAP32[i2 >> 2] | 0 : i2, i1) | 0;
   if (!i1) i14 = 5;
  }
  if ((i14 | 0) == 5) i1 = i6 >>> 0 < i7 >>> 0 ? -1 : i8 & 1;
  i9 = (i1 | 0) < 0;
 } else i9 = (i11 | 0) > (i1 | 0);
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 i10 = i2;
 if ((i1 | 0) == (i11 | 0)) {
  i5 = i2 + 112 | 0;
  i6 = i12 + 112 | 0;
  i8 = HEAP8[i6 + 11 >> 0] | 0;
  i7 = i8 << 24 >> 24 < 0;
  i8 = i7 ? HEAP32[i12 + 116 >> 2] | 0 : i8 & 255;
  i4 = HEAP8[i5 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i2 = i3 ? HEAP32[i2 + 116 >> 2] | 0 : i4 & 255;
  i4 = i2 >>> 0 < i8 >>> 0;
  i1 = i4 ? i2 : i8;
  if (!i1) i14 = 11; else {
   i1 = _memcmp(i7 ? HEAP32[i6 >> 2] | 0 : i6, i3 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
   if (!i1) i14 = 11;
  }
  if ((i14 | 0) == 11) i1 = i8 >>> 0 < i2 >>> 0 ? -1 : i4 & 1;
  i1 = (i1 | 0) < 0;
 } else i1 = (i1 | 0) > (i11 | 0);
 if (!i9) {
  if (!i1) {
   i19 = 0;
   return i19 | 0;
  }
  HEAP32[i19 >> 2] = i10;
  HEAP32[i17 >> 2] = i13;
  i4 = HEAP32[i19 >> 2] | 0;
  i3 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i4 + 32 >> 2] | 0;
  i2 = HEAP32[i3 + 32 >> 2] | 0;
  i9 = i3;
  i10 = i4;
  do if ((i1 | 0) == (i2 | 0)) {
   i5 = i4 + 112 | 0;
   i6 = i3 + 112 | 0;
   i8 = HEAP8[i6 + 11 >> 0] | 0;
   i7 = i8 << 24 >> 24 < 0;
   i8 = i7 ? HEAP32[i3 + 116 >> 2] | 0 : i8 & 255;
   i3 = HEAP8[i5 + 11 >> 0] | 0;
   i2 = i3 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i4 + 116 >> 2] | 0 : i3 & 255;
   i1 = i3 >>> 0 < i8 >>> 0 ? i3 : i8;
   if (i1 | 0) {
    i1 = _memcmp(i7 ? HEAP32[i6 >> 2] | 0 : i6, i2 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
    if (i1 | 0) {
     if ((i1 | 0) < 0) break; else i1 = 1;
     return i1 | 0;
    }
   }
   if (i8 >>> 0 >= i3 >>> 0) {
    i19 = 1;
    return i19 | 0;
   }
  } else if ((i1 | 0) <= (i2 | 0)) {
   i19 = 1;
   return i19 | 0;
  } while (0);
  HEAP32[i18 >> 2] = i10;
  HEAP32[i19 >> 2] = i9;
  i19 = 2;
  return i19 | 0;
 }
 if (i1) {
  HEAP32[i18 >> 2] = i10;
  HEAP32[i17 >> 2] = i16;
  i19 = 1;
  return i19 | 0;
 }
 HEAP32[i18 >> 2] = i13;
 HEAP32[i19 >> 2] = i16;
 i3 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i15 + 32 >> 2] | 0;
 i8 = i3;
 do if ((i1 | 0) == (i2 | 0)) {
  i4 = i3 + 112 | 0;
  i5 = i15 + 112 | 0;
  i7 = HEAP8[i5 + 11 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i15 + 116 >> 2] | 0 : i7 & 255;
  i1 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i3 + 116 >> 2] | 0 : i1 & 255;
  i1 = i3 >>> 0 < i7 >>> 0 ? i3 : i7;
  if (i1 | 0) {
   i1 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i2 ? HEAP32[i4 >> 2] | 0 : i4, i1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) < 0) break; else i1 = 1;
    return i1 | 0;
   }
  }
  if (i7 >>> 0 >= i3 >>> 0) {
   i19 = 1;
   return i19 | 0;
  }
 } else if ((i1 | 0) <= (i2 | 0)) {
  i19 = 1;
  return i19 | 0;
 } while (0);
 HEAP32[i19 >> 2] = i8;
 HEAP32[i17 >> 2] = i16;
 i19 = 2;
 return i19 | 0;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 108 | 0) + 1 | 0;
 if (i4 >>> 0 > 39768215) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i10 + 8 >> 2] | 0) - i2 | 0) / 108 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 19884107 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 39768215;
 i5 = (i1 - i2 | 0) / 108 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i10 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 108 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 108 | 0) | 0;
 i11 = i13 + 8 | 0;
 HEAP32[i11 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 108 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 108 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 108 | 0) + 12 >> 2] | 0;
  i8 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 10;
 } else i8 = 8;
 if ((i8 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 108 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 108 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i8 = 10;
 }
 if ((i8 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 * 108 | 0) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i6 + (i5 * 108 | 0) + 48 >> 2] = HEAP32[i9 + 48 >> 2];
 HEAP32[i6 + (i5 * 108 | 0) + 52 >> 2] = HEAP32[i9 + 52 >> 2];
 HEAP32[i6 + (i5 * 108 | 0) + 56 >> 2] = HEAP32[i9 + 56 >> 2];
 i3 = i6 + (i5 * 108 | 0) + 60 | 0;
 i1 = i9 + 60 | 0;
 i2 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 108;
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i10, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -108 | 0;
   HEAP32[i11 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -96 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i11 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i9, i12, i8, i1, i2, i3) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = i13 + 16 | 0;
 HEAP32[i12 + 56 >> 2] = i1;
 HEAP32[i12 + 24 >> 2] = i2;
 HEAP32[i12 + 44 >> 2] = i3;
 i1 = i12 + 64 | 0;
 do if ((i1 | 0) != (i8 | 0)) {
  i7 = HEAP8[i8 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
  i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i12 + 72 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i12 + 68 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i12 + 68 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i3 = i12 + 80 | 0;
 i1 = i8 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i3 = i12 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD5Sound11setUserDataEPv(i1, i12 + 12 | 0) | 0;
  if (i1 | 0) {
   i8 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i11 >> 2] = gb + 853741;
   HEAP32[i11 + 4 >> 2] = 932;
   HEAP32[i11 + 8 >> 2] = gb + 854532;
   HEAP32[i11 + 12 >> 2] = i8;
   __Z6FormatPKcz(i10, gb + 883334 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  }
 }
 i2 = i9 + 8 | 0;
 if ((i12 | 0) != (i2 | 0)) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) i1 = i12 + 4 | 0; else {
   i11 = i12 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = i11;
  }
  i11 = HEAP32[i2 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i12;
 }
 i2 = HEAP32[i12 + 36 >> 2] | 0;
 if (!i2) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i12 + 52 >> 2] | 0;
   if ((__ZNK10SampleClip20GetCompressionFormatEv(i2) | 0) == 7) {
    f14 = Math_fround(HEAPF32[i2 + 48 >> 2]);
    __ZN4FMOD5Sound13setLoopPointsEjjjj(i1, 2112, 2, ~~Math_fround(Math_fround(f14 * Math_fround(HEAP32[i2 + 32 >> 2] | 0)) + Math_fround(2112.0)) >>> 0, 2) | 0;
   }
  }
 } else {
  i1 = HEAP32[i12 + 52 >> 2] | 0;
  if ((__ZNK10SampleClip20GetCompressionFormatEv(i1) | 0) == 7) {
   f14 = Math_fround(HEAPF32[i1 + 48 >> 2]);
   __ZN4FMOD5Sound13setLoopPointsEjjjj(i2, 2112, 2, ~~Math_fround(Math_fround(f14 * Math_fround(HEAP32[i1 + 32 >> 2] | 0)) + Math_fround(2112.0)) >>> 0, 2) | 0;
  }
 }
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 i1 = HEAP32[i12 + 120 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 i12 = i1 + 4 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN10MonoScript8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i1 = i9 + 64 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 72 | 0, i10);
 i6 = i9 + 92 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 96 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 108 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 112 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 124 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 128 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 140 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  STACKTOP = i13;
  return;
 }
}

function __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE(i8, i1, i9, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i7 = i13 + 8 | 0;
 i11 = i8 + 52 | 0;
 if (!((HEAP8[i11 >> 0] | 0) != 0 | i1)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i12 = 10;
 }
 if ((i12 | 0) == 8) i12 = 10;
 if ((i12 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) {
  STACKTOP = i13;
  return;
 }
 i5 = i8 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i4 = i6;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i1 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i1 + 32 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
 }
 i4 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i12 = 20;
  }
 }
 if ((i12 | 0) == 18) i12 = 20;
 if ((i12 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 __ZN16SpriteRenderData14RecalculateUVsER13dynamic_arrayI12SpriteVertexLj4EER9Texture2DRK8Vector2fRK5RectTIfERK8Vector4fSC_S8_21SpritePackingRotation(i4, i1, i9, i10, i8 + 36 | 0, i8 + 8 | 0, i8 + 24 | 0, (HEAP32[i8 + 32 >> 2] | 0) >>> 2 & 15);
 HEAP8[i11 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 4 | 0, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 32 | 0, i4);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 48 | 0, i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZL15AddSliverCornerPjjii(i17, i18, i1, i3) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   i2 = 8;
   i16 = 0;
   i4 = 1;
   i5 = 1;
   i15 = 1;
   i6 = 1;
   break;
  }
 case 3:
  {
   i1 = 2;
   i2 = 8;
   i16 = 1;
   i4 = 1;
   i5 = -1;
   i15 = 1;
   i6 = 15;
   break;
  }
 case 0:
  {
   i1 = 1;
   i2 = 4;
   i16 = 1;
   i4 = -1;
   i5 = 1;
   i15 = 15;
   i6 = 1;
   break;
  }
 default:
  {
   i1 = 2;
   i2 = 4;
   i16 = 0;
   i4 = -1;
   i5 = -1;
   i15 = 15;
   i6 = 15;
  }
 }
 i1 = (i1 & i3 | 0) != 0 & 1;
 i1 = (i2 & i3 | 0) == 0 ? i1 : i1 | 2;
 if ((i1 | 0) == 1) {
  i9 = (i6 * 17 | 0) + i15 | 0;
  i10 = i17 + (i18 << 2) | 0;
  HEAP32[i10 >> 2] = i9;
  i1 = (i6 - i5 | 0) * 17 | 0;
  i4 = i15 - i4 | 0;
  i7 = i1 + i4 | 0;
  i8 = i17 + (i18 + 1 << 2) | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i17 + (i18 + 2 << 2) >> 2] = i1 + i15;
  i1 = (i5 + i6 | 0) * 17 | 0;
  i4 = i1 + i4 | 0;
  i5 = i17 + (i18 + 3 << 2) | 0;
  HEAP32[i5 >> 2] = i4;
  i6 = i17 + (i18 + 4 << 2) | 0;
  HEAP32[i6 >> 2] = i9;
  HEAP32[i17 + (i18 + 5 << 2) >> 2] = i1 + i15;
  i1 = i17 + (i18 + 6 << 2) | 0;
  HEAP32[i1 >> 2] = i9;
  i2 = i17 + (i18 + 7 << 2) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = i18 + 9 | 0;
  HEAP32[i17 + (i18 + 8 << 2) >> 2] = i7;
  if (!i16) {
   i18 = i3;
   return i18 | 0;
  }
  HEAP32[i10 >> 2] = i7;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i5 >> 2] = i9;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i2 >> 2] = i9;
  i18 = i3;
  return i18 | 0;
 }
 i14 = i6 * 17 | 0;
 if ((i1 | 0) == 2) {
  i3 = i4 + i15 | 0;
  i7 = i3 + i14 | 0;
  i8 = i17 + (i18 << 2) | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i14 + i15 | 0;
  i10 = i17 + (i18 + 1 << 2) | 0;
  HEAP32[i10 >> 2] = i9;
  i1 = (i6 - i5 | 0) * 17 | 0;
  i3 = i1 + i3 | 0;
  HEAP32[i17 + (i18 + 2 << 2) >> 2] = i3;
  i6 = i17 + (i18 + 3 << 2) | 0;
  HEAP32[i6 >> 2] = i9;
  i15 = i15 - i4 | 0;
  i1 = i1 + i15 | 0;
  i2 = i17 + (i18 + 4 << 2) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i17 + (i18 + 5 << 2) >> 2] = i3;
  i3 = i17 + (i18 + 6 << 2) | 0;
  HEAP32[i3 >> 2] = i1;
  i4 = i17 + (i18 + 7 << 2) | 0;
  HEAP32[i4 >> 2] = i9;
  i5 = i18 + 9 | 0;
  HEAP32[i17 + (i18 + 8 << 2) >> 2] = i15 + i14;
  if (!i16) {
   i18 = i5;
   return i18 | 0;
  }
  HEAP32[i8 >> 2] = i9;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i9;
  HEAP32[i4 >> 2] = i1;
  i18 = i5;
  return i18 | 0;
 } else {
  i10 = i14 + i15 | 0;
  i11 = i17 + (i18 << 2) | 0;
  HEAP32[i11 >> 2] = i10;
  i1 = (i6 - i5 | 0) * 17 | 0;
  i3 = i4 + i15 | 0;
  i12 = i1 + i3 | 0;
  i13 = i17 + (i18 + 1 << 2) | 0;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i17 + (i18 + 2 << 2) >> 2] = i3 + i14;
  i3 = (i5 + i6 | 0) * 17 | 0;
  i4 = i15 - i4 | 0;
  i7 = i3 + i4 | 0;
  i8 = i17 + (i18 + 3 << 2) | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i17 + (i18 + 4 << 2) | 0;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i17 + (i18 + 5 << 2) >> 2] = i3 + i15;
  i3 = i17 + (i18 + 6 << 2) | 0;
  HEAP32[i3 >> 2] = i10;
  i4 = i1 + i4 | 0;
  i5 = i17 + (i18 + 7 << 2) | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i17 + (i18 + 8 << 2) >> 2] = i12;
  i6 = i17 + (i18 + 9 << 2) | 0;
  HEAP32[i6 >> 2] = i10;
  i1 = i17 + (i18 + 10 << 2) | 0;
  HEAP32[i1 >> 2] = i7;
  i2 = i18 + 12 | 0;
  HEAP32[i17 + (i18 + 11 << 2) >> 2] = i4;
  if (!i16) {
   i18 = i2;
   return i18 | 0;
  }
  HEAP32[i11 >> 2] = i12;
  HEAP32[i13 >> 2] = i10;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i5 >> 2] = i10;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i1 >> 2] = i10;
  i18 = i2;
  return i18 | 0;
 }
 return 0;
}

function __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i26, i27, i28) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, f33 = f0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, f38 = f0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i32 + 16 | 0;
 i30 = i32;
 i31 = i27 + 192 | 0;
 i6 = HEAP32[i31 >> 2] | 0;
 L1 : do if (i6 >>> 0 > 1) {
  f5 = Math_fround(HEAPF32[i28 >> 2]);
  f2 = Math_fround(HEAPF32[i28 + 4 >> 2]);
  f3 = Math_fround(HEAPF32[i28 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i28 + 12 >> 2]);
  i1 = 1;
  do {
   f33 = Math_fround(HEAPF32[i27 + 64 + (i1 << 2) >> 2]);
   if (!(f5 > f33 & f2 > f33 & f3 > f33 & f4 > f33)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i6 >>> 0);
 } else i1 = 1; while (0);
 i23 = i26 + 4 | 0;
 i24 = i26 + 8 | 0;
 i25 = i26 + 12 | 0;
 HEAP32[i26 >> 2] = -1;
 HEAP32[i26 + 4 >> 2] = -1;
 HEAP32[i26 + 8 >> 2] = -1;
 HEAP32[i26 + 12 >> 2] = -1;
 if (i1 >>> 0 >= i6 >>> 0) {
  STACKTOP = i32;
  return;
 }
 i17 = i28 + 4 | 0;
 i18 = i28 + 8 | 0;
 i19 = i28 + 12 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29 + 8 | 0;
 i22 = i29 + 12 | 0;
 i14 = i30 + 4 | 0;
 i15 = i30 + 8 | 0;
 i16 = i30 + 12 | 0;
 i6 = 0;
 i7 = -1;
 i8 = 0;
 i9 = -1;
 i10 = -1;
 i11 = 0;
 i12 = -1;
 i13 = 0;
 while (1) {
  if ((i11 & i6 & i13 & i8 | 0) <= -1) {
   i1 = 9;
   break;
  }
  f33 = Math_fround(HEAPF32[i27 + 64 + (i1 << 2) >> 2]);
  i34 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i27 + 64 + (i34 << 2) >> 2]);
  f4 = Math_fround(HEAPF32[i27 + 128 + (i1 << 2) >> 2]);
  f5 = Math_fround(Math_fround(HEAPF32[i28 >> 2]) - f3);
  f38 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) - f3);
  f2 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f3);
  f3 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) - f3);
  i35 = f5 < Math_fround(0.0);
  f5 = i35 ? Math_fround(0.0) : f5;
  i35 = f38 < Math_fround(0.0);
  f38 = i35 ? Math_fround(0.0) : f38;
  i35 = f2 < Math_fround(0.0);
  f2 = i35 ? Math_fround(0.0) : f2;
  i35 = f3 < Math_fround(0.0);
  f3 = i35 ? Math_fround(0.0) : f3;
  i35 = f5 > Math_fround(1.0);
  f5 = i35 ? Math_fround(1.0) : f5;
  i35 = f38 > Math_fround(1.0);
  f38 = i35 ? Math_fround(1.0) : f38;
  i35 = f2 > Math_fround(1.0);
  f2 = i35 ? Math_fround(1.0) : f2;
  i35 = f3 > Math_fround(1.0);
  i37 = ~~Math_fround(Math_fround(f4 * f38) * Math_fround(255.0));
  i36 = ~~Math_fround(Math_fround(f4 * f2) * Math_fround(255.0));
  i35 = ~~Math_fround(Math_fround(f4 * (i35 ? Math_fround(1.0) : f3)) * Math_fround(255.0));
  HEAP32[i29 >> 2] = ~~Math_fround(Math_fround(f4 * f5) * Math_fround(255.0));
  HEAP32[i20 >> 2] = i37;
  HEAP32[i21 >> 2] = i36;
  HEAP32[i22 >> 2] = i35;
  __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i30, i27 + (i34 << 2) | 0, i27 + (i1 << 2) | 0, i29);
  i7 = i7 & i6 | HEAP32[i30 >> 2] & ~i6;
  i9 = i9 & i11 | HEAP32[i14 >> 2] & ~i11;
  i10 = i10 & i13 | HEAP32[i15 >> 2] & ~i13;
  i12 = i12 & i8 | HEAP32[i16 >> 2] & ~i8;
  HEAP32[i26 >> 2] = i7;
  HEAP32[i23 >> 2] = i9;
  HEAP32[i24 >> 2] = i10;
  HEAP32[i25 >> 2] = i12;
  i6 = (Math_fround(HEAPF32[i28 >> 2]) < f33) << 31 >> 31;
  i11 = (Math_fround(HEAPF32[i17 >> 2]) < f33) << 31 >> 31;
  i13 = (Math_fround(HEAPF32[i18 >> 2]) < f33) << 31 >> 31;
  i8 = (Math_fround(HEAPF32[i19 >> 2]) < f33) << 31 >> 31;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= (HEAP32[i31 >> 2] | 0) >>> 0) {
   i1 = 9;
   break;
  }
 }
 if ((i1 | 0) == 9) {
  STACKTOP = i32;
  return;
 }
}

function __ZN27AnimatorControllerParameter14SetDefaultBoolEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 switch (HEAP32[i1 + 16 >> 2] | 0) {
 case 9:
 case 4:
  break;
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 912032 | 0, 0, gb + 911526 | 0, 150, 1, 0, 0, 0);
   STACKTOP = i8;
   return;
  }
 }
 i3 = i1 + 28 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i3 >> 0] = i2 & 1;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 11;
 }
 if ((i7 | 0) == 9) i7 = 11;
 if ((i7 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 17; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 19;
  }
 }
 if ((i7 | 0) == 17) i7 = 19;
 if ((i7 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1);
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 25; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 25; else if (HEAP32[i1 + 4 >> 2] | 0) {
   STACKTOP = i8;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN12InputManagerC2E10MemLabelId18ObjectCreationMode(i14, i1, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 12 | 0;
 i13 = i17;
 i15 = i17 + 8 | 0;
 i3 = i1;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i16 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i14, i16, i2);
 HEAP32[i14 >> 2] = gb + 59752 + 8;
 HEAP32[i14 + 28 >> 2] = 0;
 HEAP32[i14 + 32 >> 2] = 0;
 HEAP32[i14 + 36 >> 2] = 0;
 i1 = i14 + 40 | 0;
 i13 = gb + 63160 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i13;
 HEAP32[i14 + 52 >> 2] = 0;
 HEAP32[i14 + 56 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 i2 = i14 + 60 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i13;
 HEAP32[i14 + 72 >> 2] = 0;
 HEAP32[i14 + 76 >> 2] = 0;
 HEAP32[i14 + 68 >> 2] = 0;
 i3 = i14 + 80 | 0;
 i12 = i3;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i14 + 92 >> 2] = 0;
 HEAP32[i14 + 96 >> 2] = 0;
 HEAP32[i14 + 88 >> 2] = 0;
 i12 = i14 + 124 | 0;
 i13 = i14 + 128 | 0;
 i4 = i12;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZN12InputManager11MakeDefaultEv(i14);
 __ZN14dynamic_bitset6resizeEjb(i1, 570, 0);
 __ZN14dynamic_bitset6resizeEjb(i2, 570, 0);
 __ZN14dynamic_bitset6resizeEjb(i3, 570, 0);
 i8 = i14 + 100 | 0;
 HEAP8[i14 + 189 >> 0] = 0;
 HEAP8[i14 + 188 >> 0] = 0;
 HEAP8[i14 + 168 >> 0] = 0;
 HEAP8[i14 + 176 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP8[i14 + 190 >> 0] = 1;
 i8 = i16 + 4 | 0;
 i9 = i16 + 8 | 0;
 i10 = i16 + 8 | 0;
 i11 = i14 + 132 | 0;
 i7 = 0;
 do {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
  while (1) {
   HEAPF32[i15 >> 2] = Math_fround(0.0);
   if ((i2 | 0) == (i3 | 0)) __ZNSt3__26vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIKfEEvRT_(i16, i15); else {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i8 >> 2] = i2 + 4;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 28) break;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
  }
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) {
   __ZNSt3__26vectorINS0_IfNS_9allocatorIfEEEENS1_IS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i12, i16);
   i1 = HEAP32[i16 >> 2] | 0;
  } else {
   HEAP32[i3 >> 2] = 0;
   i6 = i3 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i1 = HEAP32[i16 >> 2] | 0;
   i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
   i4 = i2 >> 2;
   if (i4) {
    if (i4 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
    i5 = __Znwj(i2) | 0;
    HEAP32[i6 >> 2] = i5;
    HEAP32[i3 >> 2] = i5;
    HEAP32[i3 + 8 >> 2] = i5 + (i4 << 2);
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i5 | 0, i1 | 0, i2 | 0) | 0;
     HEAP32[i6 >> 2] = i5 + (i2 >> 2 << 2);
    }
   }
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 12;
  }
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 12);
 HEAP8[i14 + 169 >> 0] = 1;
 HEAP32[i14 + 172 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_(i26, i27, i20, i8, i1) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28;
 i21 = __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_(i26, i27, i20, i1) | 0;
 f29 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 i7 = i20 + 28 | 0;
 if (!(f29 < Math_fround(HEAPF32[i7 >> 2]))) {
  i27 = i21;
  STACKTOP = i28;
  return i27 | 0;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 i15 = i20 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = i20 + 8 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i17 = i20 + 12 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i18 = i20 + 16 | 0;
 i5 = HEAP32[i18 >> 2] | 0;
 i19 = i20 + 20 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i14 = i20 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i22 = i20;
 i23 = i8;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = i6;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 f29 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i27 + 28 | 0;
 if (!(f29 < Math_fround(HEAPF32[i1 >> 2]))) {
  i27 = i21 + 1 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i2 = HEAP32[i27 >> 2] | 0;
 i9 = i27 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i27 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i27 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i27 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i27 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i27 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i22 = i27;
 i23 = i20;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i20 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i16 >> 2] = i4;
 HEAP32[i17 >> 2] = i5;
 HEAP32[i18 >> 2] = i6;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 f29 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f29 < Math_fround(HEAPF32[i26 + 28 >> 2]))) {
  i27 = i21 + 2 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 i2 = HEAP32[i26 + 4 >> 2] | 0;
 i3 = HEAP32[i26 + 8 >> 2] | 0;
 i4 = HEAP32[i26 + 12 >> 2] | 0;
 i5 = HEAP32[i26 + 16 >> 2] | 0;
 i6 = HEAP32[i26 + 20 >> 2] | 0;
 i22 = i26 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 i22 = i26;
 i23 = i27;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i27 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 i27 = i21 + 3 | 0;
 STACKTOP = i28;
 return i27 | 0;
}

function runPostSets102() {
 HEAP32[gb + 97064 >> 2] = fb + 1;
 HEAP32[gb + 97068 >> 2] = fb + 1;
 HEAP32[gb + 97072 >> 2] = fb + 1;
 HEAP32[gb + 97076 >> 2] = fb + 1;
 HEAP32[gb + 97080 >> 2] = fb + 1;
 HEAP32[gb + 97084 >> 2] = fb + 1;
 HEAP32[gb + 97088 >> 2] = fb + 1;
 HEAP32[gb + 97092 >> 2] = fb + 1;
 HEAP32[gb + 97096 >> 2] = fb + 1;
 HEAP32[gb + 97100 >> 2] = fb + 1;
 HEAP32[gb + 97104 >> 2] = fb + 1;
 HEAP32[gb + 97108 >> 2] = fb + 1;
 HEAP32[gb + 97112 >> 2] = fb + 1;
 HEAP32[gb + 97116 >> 2] = fb + 1;
 HEAP32[gb + 97120 >> 2] = fb + 1;
 HEAP32[gb + 97132 >> 2] = fb + 1363;
 HEAP32[gb + 97136 >> 2] = fb + 666;
 HEAP32[gb + 97140 >> 2] = fb + 456;
 HEAP32[gb + 97144 >> 2] = fb + 1364;
 HEAP32[gb + 97148 >> 2] = fb + 1365;
 HEAP32[gb + 97152 >> 2] = fb + 300;
 HEAP32[gb + 97156 >> 2] = fb + 667;
 HEAP32[gb + 97160 >> 2] = fb + 668;
 HEAP32[gb + 97164 >> 2] = fb + 1044;
 HEAP32[gb + 97168 >> 2] = fb + 669;
 HEAP32[gb + 97172 >> 2] = fb + 17;
 HEAP32[gb + 97176 >> 2] = fb + 191;
 HEAP32[gb + 97180 >> 2] = fb + 1045;
 HEAP32[gb + 97184 >> 2] = fb + 670;
 HEAP32[gb + 97188 >> 2] = fb + 1046;
 HEAP32[gb + 97192 >> 2] = fb + 671;
 HEAP32[gb + 97196 >> 2] = fb + 1047;
 HEAP32[gb + 97200 >> 2] = fb + 672;
 HEAP32[gb + 97204 >> 2] = fb + 1048;
 HEAP32[gb + 97208 >> 2] = fb + 673;
 HEAP32[gb + 97212 >> 2] = fb + 674;
 HEAP32[gb + 97216 >> 2] = fb + 301;
 HEAP32[gb + 97220 >> 2] = fb + 675;
 HEAP32[gb + 97224 >> 2] = fb + 302;
 HEAP32[gb + 97228 >> 2] = fb + 192;
 HEAP32[gb + 97232 >> 2] = fb + 1366;
 HEAP32[gb + 97236 >> 2] = fb + 85;
 HEAP32[gb + 97240 >> 2] = fb + 86;
 HEAP32[gb + 97244 >> 2] = fb + 87;
 HEAP32[gb + 97248 >> 2] = fb + 39;
 HEAP32[gb + 97252 >> 2] = fb + 120;
 HEAP32[gb + 97256 >> 2] = fb + 95;
 HEAP32[gb + 97260 >> 2] = fb + 1049;
 HEAP32[gb + 97264 >> 2] = fb + 1050;
 HEAP32[gb + 97268 >> 2] = fb + 193;
 HEAP32[gb + 97272 >> 2] = fb + 18;
 HEAP32[gb + 97276 >> 2] = fb + 121;
 HEAP32[gb + 97280 >> 2] = fb + 96;
 HEAP32[gb + 97284 >> 2] = fb + 122;
 HEAP32[gb + 97288 >> 2] = fb + 97;
 HEAP32[gb + 97292 >> 2] = fb + 123;
 HEAP32[gb + 97296 >> 2] = fb + 98;
 HEAP32[gb + 97300 >> 2] = fb + 124;
 HEAP32[gb + 97304 >> 2] = fb + 99;
 HEAP32[gb + 97308 >> 2] = fb + 1051;
 HEAP32[gb + 97312 >> 2] = fb + 1052;
 HEAP32[gb + 97316 >> 2] = fb + 1367;
 HEAP32[gb + 97320 >> 2] = fb + 194;
 HEAP32[gb + 97324 >> 2] = fb + 676;
 HEAP32[gb + 97328 >> 2] = fb + 677;
 HEAP32[gb + 97332 >> 2] = fb + 125;
 HEAP32[gb + 97336 >> 2] = fb + 100;
 HEAP32[gb + 97340 >> 2] = fb + 126;
 HEAP32[gb + 97344 >> 2] = fb + 101;
 HEAP32[gb + 97348 >> 2] = fb + 127;
 HEAP32[gb + 97352 >> 2] = fb + 102;
 HEAP32[gb + 97356 >> 2] = fb + 128;
 HEAP32[gb + 97360 >> 2] = fb + 103;
 HEAP32[gb + 97364 >> 2] = fb + 678;
 HEAP32[gb + 97368 >> 2] = fb + 195;
 HEAP32[gb + 97372 >> 2] = fb + 1053;
 HEAP32[gb + 97376 >> 2] = fb + 1054;
 HEAP32[gb + 97388 >> 2] = fb + 1363;
 HEAP32[gb + 97392 >> 2] = fb + 666;
 HEAP32[gb + 97396 >> 2] = fb + 456;
 HEAP32[gb + 97400 >> 2] = fb + 1368;
 HEAP32[gb + 97404 >> 2] = fb + 1369;
 HEAP32[gb + 97408 >> 2] = fb + 300;
 HEAP32[gb + 97412 >> 2] = fb + 679;
 HEAP32[gb + 97416 >> 2] = fb + 668;
 HEAP32[gb + 97420 >> 2] = fb + 1044;
 HEAP32[gb + 97424 >> 2] = fb + 669;
 HEAP32[gb + 97428 >> 2] = fb + 17;
 HEAP32[gb + 97432 >> 2] = fb + 191;
 HEAP32[gb + 97436 >> 2] = fb + 1045;
 HEAP32[gb + 97440 >> 2] = fb + 670;
 HEAP32[gb + 97444 >> 2] = fb + 1046;
 HEAP32[gb + 97448 >> 2] = fb + 671;
 HEAP32[gb + 97452 >> 2] = fb + 1047;
 HEAP32[gb + 97456 >> 2] = fb + 672;
 HEAP32[gb + 97460 >> 2] = fb + 1048;
 HEAP32[gb + 97464 >> 2] = fb + 673;
 HEAP32[gb + 97468 >> 2] = fb + 674;
 HEAP32[gb + 97472 >> 2] = fb + 301;
 HEAP32[gb + 97476 >> 2] = fb + 675;
 runPostSets103();
}

function __ZN5Unity12PhysicsQuery18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction(i1, i11, i12, f2, i15, i13, i14) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i15 = i15 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 96 | 0;
 i9 = i16 + 48 | 0;
 i10 = i16 + 24 | 0;
 i4 = i16 + 20 | 0;
 i5 = i16;
 i6 = i16 + 136 | 0;
 if (!i11) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = f2 == Math_fround(inf);
 f2 = i1 ? Math_fround(3402823469999999843913219.0e14) : f2;
 HEAP32[i9 >> 2] = 0;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i9 + 8 | 0;
 HEAP32[i3 >> 2] = -1;
 HEAP16[i9 + 12 >> 1] = 0;
 i17 = i9 + 16 | 0;
 i7 = i9 + 40 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i10 >> 2] = gb + 114012 + 8;
 HEAP32[i10 + 4 >> 2] = 2;
 HEAP32[i10 + 8 >> 2] = i11;
 HEAP32[i10 + 12 >> 2] = i13;
 switch (i14 | 0) {
 case 0:
  {
   HEAP8[i10 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i10 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i10 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP16[i5 + 16 >> 1] = 15;
 HEAP8[i5 + 18 >> 0] = 0;
 i14 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i17 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP16[i6 >> 1] = i14 ? 143 : 15;
 if (__ZN5physx14PxRigidBodyExt17linearSweepSingleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEERNS_10PxSweepHitERjRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf(i11, i17, i12, f2, i6, i9, i4, i5, i10, 0, Math_fround(0.0)) | 0) {
  i17 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = HEAP32[i17 + 8 >> 2];
  i14 = i9 + 16 | 0;
  HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  i14 = i15 + 12 | 0;
  i13 = i9 + 28 | 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i8 >> 2] = 5;
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 28 >> 2] = Math_fround(1.0);
  i14 = i8 + 32 | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 56 >> 2] | 0, i17 | 0, i8 | 0) | 0) {
   i1 = HEAP32[i8 + 36 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i1 + (HEAP32[i3 >> 2] << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i15 + 24 >> 2] = i1;
  i17 = HEAP32[i7 >> 2] | 0;
  HEAP32[i15 + 28 >> 2] = i17;
  HEAPF32[i15 + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 36 >> 2] = Math_fround(0.0);
  if (!((HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0))) i1 = 1; else {
   HEAP32[i15 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
   i1 = 1;
  }
 } else i1 = 0;
 i17 = i1;
 STACKTOP = i16;
 return i17 | 0;
}

function __Z12calculateMTDRKN5physx2Gu13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos12PsTransformVERKNS7_15PsMatTransformVEbRKNS7_6FloatVEPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS7_5Vec3VESN_SN_SL_RSD_(i26, i27, i15, i21, i19, i18, i29, i22, i28, i20, i24, i23, i13, i14, i17, i32) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i15 = i15 | 0;
 i21 = i21 | 0;
 i19 = i19 | 0;
 i18 = i18 | 0;
 i29 = i29 | 0;
 i22 = i22 | 0;
 i28 = i28 | 0;
 i20 = i20 | 0;
 i24 = i24 | 0;
 i23 = i23 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i32 = i32 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i25 = 0, i30 = 0, i31 = 0, i33 = 0, f34 = f0;
 i33 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i33 + 24 | 0;
 i25 = i33 + 12 | 0;
 i31 = i33;
 i2 = HEAP32[i32 >> 2] | 0;
 i30 = i32 + 4 | 0;
 HEAP32[i31 >> 2] = HEAP32[i30 >> 2];
 HEAP32[i31 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
 HEAP32[i31 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
 if (!i22) {
  i28 = i2;
  i29 = 0;
  HEAP32[i32 >> 2] = i28;
  HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
  HEAP32[i30 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
  HEAP32[i30 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
  STACKTOP = i33;
  return i29 | 0;
 }
 i9 = i20 + 44 | 0;
 i10 = i23 + 4 | 0;
 i11 = i23 + 8 | 0;
 i12 = i23 + 12 | 0;
 i1 = 0;
 i8 = 0;
 do {
  HEAP32[i24 >> 2] = 0;
  i7 = i8 + i28 | 0;
  __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj(i26, i27, i29 + (i8 * 40 | 0) | 0, i7, HEAP8[i29 + (i8 * 40 | 0) + 36 >> 0] | 0, i18, i19, i15, i21, i20, i24) | 0;
  i6 = HEAP32[i24 >> 2] | 0;
  if (i6) {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i6 >>> 0 > 1) {
    i4 = i1;
    i3 = 0;
    i5 = 1;
    while (1) {
     i1 = HEAP32[i20 + (i5 << 6) + 44 >> 2] | 0;
     f34 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     if (f34 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
      HEAP32[i16 >> 2] = HEAP32[i25 >> 2];
      HEAP32[i16 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
      HEAP32[i16 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
      i3 = i5;
     } else i1 = i4;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i6 | 0)) break; else i4 = i1;
    }
   } else i3 = 0;
   f34 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f34 > (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    HEAP32[i17 >> 2] = i7;
    HEAP32[i31 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i31 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i31 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    i7 = HEAP32[i20 + (i3 << 6) + 36 >> 2] | 0;
    i2 = HEAP32[i20 + (i3 << 6) + 40 >> 2] | 0;
    HEAP32[i23 >> 2] = HEAP32[i20 + (i3 << 6) + 32 >> 2];
    HEAP32[i10 >> 2] = i7;
    HEAP32[i11 >> 2] = i2;
    HEAPF32[i12 >> 2] = Math_fround(0.0);
    i2 = i20 + (i3 << 6) + 16 | 0;
    HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i2 = i20 + (i3 << 6) | 0;
    HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i2 = i1;
   }
   i1 = 1;
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i22 | 0));
 HEAP32[i32 >> 2] = i2;
 HEAP32[i30 >> 2] = HEAP32[i31 >> 2];
 HEAP32[i30 + 4 >> 2] = HEAP32[i31 + 4 >> 2];
 HEAP32[i30 + 8 >> 2] = HEAP32[i31 + 8 >> 2];
 STACKTOP = i33;
 return i1 | 0;
}

function __ZN8Animator15GetGoalRotationEi(i7, i1, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, f3 = f0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 if (i4 >>> 0 < 4) if (HEAP8[i1 + 153 >> 0] | 0) {
  i6 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) {
   i6 = i6 + i2 + 40 | 0;
   if (HEAP32[(HEAP32[i6 >> 2] | 0) + i6 >> 2] | 0) {
    i1 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
    __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE(i5, i4);
    f9 = Math_fround(HEAPF32[i1 + 68 + (i4 << 6) + 16 >> 2]);
    f16 = Math_fround(HEAPF32[i5 >> 2]);
    f11 = Math_fround(f9 * f16);
    f14 = Math_fround(HEAPF32[i1 + 68 + (i4 << 6) + 24 >> 2]);
    f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    f13 = Math_fround(f14 * f12);
    f15 = Math_fround(HEAPF32[i1 + 68 + (i4 << 6) + 20 >> 2]);
    f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
    f3 = Math_fround(f15 * f10);
    f18 = Math_fround(HEAPF32[i1 + 68 + (i4 << 6) + 12 >> 2]);
    f17 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f14 * f17)) - Math_fround(f12 * f15)) - Math_fround(f10 * f18));
    f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f16 * f18)) - Math_fround(f15 * f17)) - Math_fround(f9 * f10));
    f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f9 * f17)) - Math_fround(f16 * f14)) - Math_fround(f12 * f18));
    f12 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f10)) - Math_fround(f9 * f12));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
    f12 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f3 = Math_fround(f12 * f12);
    f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = Math_fround(f11 * f11);
    f10 = (HEAP32[tempDoublePtr >> 2] = i1 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f3 + f9) + Math_fround(Math_fround(f13 * f13) + Math_fround(f10 * f10))))));
    f12 = Math_fround(f9 * f12);
    f11 = Math_fround(f9 * f11);
    f10 = Math_fround(f9 * f10);
    f13 = Math_fround(f9 * f13);
    f9 = Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f13 * f13) + Math_fround(f10 * f10)));
    f3 = Math_fround(Math_sqrt(Math_fround(f9)));
    f12 = Math_fround(f12 / f3);
    f11 = Math_fround(f11 / f3);
    f10 = Math_fround(f10 / f3);
    f3 = Math_fround(f13 / f3);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = f9 > Math_fround(1.0e-30);
    i6 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
    HEAP32[i7 >> 2] = i5 ? i1 : 0;
    HEAP32[i7 + 4 >> 2] = i5 ? i2 : 0;
    HEAP32[i7 + 8 >> 2] = i5 ? i4 : 0;
    HEAP32[i7 + 12 >> 2] = i6;
    STACKTOP = i8;
    return;
   }
  }
 }
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __ZN25PathNamePersistentManager22InsertPathNameInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i11, i12, i4) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 60 | 0;
 i13 = i15 + 48 | 0;
 i8 = i15 + 32 | 0;
 i9 = i15 + 16 | 0;
 i10 = i15;
 i14 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i12);
 i3 = i13 + 11 | 0;
 i6 = HEAP8[i3 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i2 = i13 + 4 | 0;
 if ((i1 ? HEAP32[i2 >> 2] | 0 : i6 & 255) | 0) {
  i1 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
  do {
   i5 = HEAP8[i1 >> 0] | 0;
   i6 = i5 << 24 >> 24;
   HEAP8[i1 >> 0] = (i5 + -65 & 255) < 26 ? i6 + 32 | 0 : i6;
   i1 = i1 + 1 | 0;
   i6 = HEAP8[i3 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i5 ? HEAP32[i13 >> 2] | 0 : i13) + (i5 ? HEAP32[i2 >> 2] | 0 : i6 & 255) | 0));
 }
 i5 = i11 + 196 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i5, i13) | 0;
 if ((i1 | 0) == (i11 + 200 | 0)) if (i4) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i13);
  i4 = i11 + 208 | 0;
  i6 = i11 + 212 | 0;
  i2 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i10);
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i9);
  i2 = i8 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i5, i7, i8) | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(32) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i8);
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i5 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 200 >> 2] | 0, i1);
   i7 = i11 + 204 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i11 + 216 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i4, i12); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i12);
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 12;
  }
  __ZN17PersistentManager9AddStreamEv(i11);
  i1 = (((HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 12 | 0) + -1 | 0;
 } else i1 = -1; else i1 = HEAP32[i1 + 28 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if (!i14) {
  STACKTOP = i15;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN10GameObject13ComponentPairELj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = i10 + 12 | 0;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 3) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 368726 | 0, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i11 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i2 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i7 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = i1 + 4 | 0;
     i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 368740 | 0, gb + 619781 | 0, i9, 1) | 0;
     if (i2 | 0) {
      if ((i2 | 0) > 0) __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
       i2 = HEAP32[i9 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i11);
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = i2;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 368726 | 0, i4, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) {
     i3 = i1 + 4 | 0;
     i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 368740 | 0, gb + 619781 | 0, i9, 1) | 0;
     if (i2 | 0) {
      if ((i2 | 0) > 0) __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
       i2 = HEAP32[i9 >> 2] | 0;
       if (i2 | 0) mftCall_iii(i2 | 0, i3 | 0, i11 | 0) | 0;
      }
      __ZN14SafeBinaryRead11EndTransferEv(i11);
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) i2 = 0; else i2 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i1 >> 2] = i2;
    } else {
     i2 = HEAP32[i4 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function runPostSets91() {
 HEAP32[gb + 92336 >> 2] = fb + 64;
 HEAP32[gb + 92340 >> 2] = fb + 90;
 HEAP32[gb + 92344 >> 2] = fb + 1;
 HEAP32[gb + 92348 >> 2] = fb + 1;
 HEAP32[gb + 92352 >> 2] = fb + 1;
 HEAP32[gb + 92356 >> 2] = fb + 1;
 HEAP32[gb + 92360 >> 2] = fb + 934;
 HEAP32[gb + 92364 >> 2] = fb + 935;
 HEAP32[gb + 92368 >> 2] = fb + 936;
 HEAP32[gb + 92372 >> 2] = fb + 1275;
 HEAP32[gb + 92376 >> 2] = fb + 1276;
 HEAP32[gb + 92388 >> 2] = fb + 1279;
 HEAP32[gb + 92392 >> 2] = fb + 564;
 HEAP32[gb + 92396 >> 2] = fb + 456;
 HEAP32[gb + 92400 >> 2] = fb + 1280;
 HEAP32[gb + 92404 >> 2] = fb + 1281;
 HEAP32[gb + 92408 >> 2] = fb + 264;
 HEAP32[gb + 92412 >> 2] = fb + 576;
 HEAP32[gb + 92416 >> 2] = fb + 565;
 HEAP32[gb + 92420 >> 2] = fb + 928;
 HEAP32[gb + 92424 >> 2] = fb + 566;
 HEAP32[gb + 92428 >> 2] = fb + 13;
 HEAP32[gb + 92432 >> 2] = fb + 156;
 HEAP32[gb + 92436 >> 2] = fb + 929;
 HEAP32[gb + 92440 >> 2] = fb + 567;
 HEAP32[gb + 92444 >> 2] = fb + 930;
 HEAP32[gb + 92448 >> 2] = fb + 568;
 HEAP32[gb + 92452 >> 2] = fb + 931;
 HEAP32[gb + 92456 >> 2] = fb + 569;
 HEAP32[gb + 92460 >> 2] = fb + 932;
 HEAP32[gb + 92464 >> 2] = fb + 570;
 HEAP32[gb + 92468 >> 2] = fb + 571;
 HEAP32[gb + 92472 >> 2] = fb + 946;
 HEAP32[gb + 92476 >> 2] = fb + 160;
 HEAP32[gb + 92480 >> 2] = fb + 49;
 HEAP32[gb + 92484 >> 2] = fb + 937;
 HEAP32[gb + 92488 >> 2] = fb + 157;
 HEAP32[gb + 92492 >> 2] = fb + 572;
 HEAP32[gb + 92496 >> 2] = fb + 74;
 HEAP32[gb + 92500 >> 2] = fb + 573;
 HEAP32[gb + 92504 >> 2] = fb + 75;
 HEAP32[gb + 92508 >> 2] = fb + 947;
 HEAP32[gb + 92512 >> 2] = fb + 938;
 HEAP32[gb + 92516 >> 2] = fb + 62;
 HEAP32[gb + 92520 >> 2] = fb + 87;
 HEAP32[gb + 92524 >> 2] = fb + 88;
 HEAP32[gb + 92528 >> 2] = fb + 939;
 HEAP32[gb + 92532 >> 2] = fb + 940;
 HEAP32[gb + 92536 >> 2] = fb + 941;
 HEAP32[gb + 92540 >> 2] = fb + 942;
 HEAP32[gb + 92544 >> 2] = fb + 161;
 HEAP32[gb + 92548 >> 2] = fb + 943;
 HEAP32[gb + 92552 >> 2] = fb + 162;
 HEAP32[gb + 92556 >> 2] = fb + 73;
 HEAP32[gb + 92560 >> 2] = fb + 74;
 HEAP32[gb + 92564 >> 2] = fb + 948;
 HEAP32[gb + 92568 >> 2] = fb + 949;
 HEAP32[gb + 92572 >> 2] = fb + 158;
 HEAP32[gb + 92576 >> 2] = fb + 944;
 HEAP32[gb + 92580 >> 2] = fb + 159;
 HEAP32[gb + 92584 >> 2] = fb + 945;
 HEAP32[gb + 92588 >> 2] = fb + 574;
 HEAP32[gb + 92592 >> 2] = fb + 575;
 HEAP32[gb + 92596 >> 2] = fb + 63;
 HEAP32[gb + 92600 >> 2] = fb + 89;
 HEAP32[gb + 92604 >> 2] = fb + 64;
 HEAP32[gb + 92608 >> 2] = fb + 90;
 HEAP32[gb + 92612 >> 2] = fb + 577;
 HEAP32[gb + 92616 >> 2] = fb + 578;
 HEAP32[gb + 92620 >> 2] = fb + 579;
 HEAP32[gb + 92624 >> 2] = fb + 144;
 HEAP32[gb + 92628 >> 2] = fb + 950;
 HEAP32[gb + 92632 >> 2] = fb + 951;
 HEAP32[gb + 92636 >> 2] = fb + 952;
 HEAP32[gb + 92640 >> 2] = fb + 1275;
 HEAP32[gb + 92644 >> 2] = fb + 1276;
 HEAP32[gb + 92648 >> 2] = fb + 580;
 HEAP32[gb + 92652 >> 2] = fb + 953;
 HEAP32[gb + 92664 >> 2] = fb + 1282;
 HEAP32[gb + 92668 >> 2] = fb + 564;
 HEAP32[gb + 92672 >> 2] = fb + 456;
 HEAP32[gb + 92676 >> 2] = fb + 1283;
 HEAP32[gb + 92680 >> 2] = fb + 1284;
 HEAP32[gb + 92684 >> 2] = fb + 264;
 HEAP32[gb + 92688 >> 2] = fb + 1;
 HEAP32[gb + 92692 >> 2] = fb + 565;
 HEAP32[gb + 92696 >> 2] = fb + 928;
 HEAP32[gb + 92700 >> 2] = fb + 566;
 HEAP32[gb + 92704 >> 2] = fb + 1;
 HEAP32[gb + 92708 >> 2] = fb + 163;
 HEAP32[gb + 92712 >> 2] = fb + 954;
 HEAP32[gb + 92716 >> 2] = fb + 567;
 HEAP32[gb + 92720 >> 2] = fb + 930;
 HEAP32[gb + 92724 >> 2] = fb + 568;
 HEAP32[gb + 92728 >> 2] = fb + 931;
 HEAP32[gb + 92732 >> 2] = fb + 569;
 HEAP32[gb + 92736 >> 2] = fb + 955;
 HEAP32[gb + 92740 >> 2] = fb + 570;
 HEAP32[gb + 92744 >> 2] = fb + 571;
 HEAP32[gb + 92748 >> 2] = fb + 1;
 runPostSets92();
}

function runPostSets13() {
 HEAP32[gb + 33464 >> 2] = fb + 162;
 HEAP32[gb + 33468 >> 2] = fb + 163;
 HEAP32[gb + 33472 >> 2] = fb + 164;
 HEAP32[gb + 33476 >> 2] = fb + 165;
 HEAP32[gb + 33480 >> 2] = fb + 36;
 HEAP32[gb + 33484 >> 2] = fb + 104;
 HEAP32[gb + 33488 >> 2] = fb + 108;
 HEAP32[gb + 33492 >> 2] = fb + 94;
 HEAP32[gb + 33496 >> 2] = fb + 130;
 HEAP32[gb + 33500 >> 2] = fb + 112;
 HEAP32[gb + 33504 >> 2] = fb + 113;
 HEAP32[gb + 33508 >> 2] = fb + 131;
 HEAP32[gb + 33512 >> 2] = fb + 111;
 HEAP32[gb + 33516 >> 2] = fb + 112;
 HEAP32[gb + 33520 >> 2] = fb + 113;
 HEAP32[gb + 33524 >> 2] = fb + 134;
 HEAP32[gb + 33528 >> 2] = fb + 135;
 HEAP32[gb + 33540 >> 2] = fb + 136;
 HEAP32[gb + 33544 >> 2] = fb + 137;
 HEAP32[gb + 33548 >> 2] = fb + 20;
 HEAP32[gb + 33552 >> 2] = fb + 102;
 HEAP32[gb + 33556 >> 2] = fb + 103;
 HEAP32[gb + 33560 >> 2] = fb + 104;
 HEAP32[gb + 33564 >> 2] = fb + 119;
 HEAP32[gb + 33568 >> 2] = fb + 120;
 HEAP32[gb + 33572 >> 2] = fb + 53;
 HEAP32[gb + 33576 >> 2] = fb + 52;
 HEAP32[gb + 33580 >> 2] = fb + 110;
 HEAP32[gb + 33584 >> 2] = fb + 105;
 HEAP32[gb + 33588 >> 2] = fb + 138;
 HEAP32[gb + 33592 >> 2] = fb + 121;
 HEAP32[gb + 33596 >> 2] = fb + 139;
 HEAP32[gb + 33612 >> 2] = fb + 140;
 HEAP32[gb + 33616 >> 2] = fb + 141;
 HEAP32[gb + 33620 >> 2] = fb + 21;
 HEAP32[gb + 33624 >> 2] = fb + 102;
 HEAP32[gb + 33628 >> 2] = fb + 103;
 HEAP32[gb + 33632 >> 2] = fb + 104;
 HEAP32[gb + 33636 >> 2] = fb + 119;
 HEAP32[gb + 33640 >> 2] = fb + 120;
 HEAP32[gb + 33644 >> 2] = fb + 53;
 HEAP32[gb + 33648 >> 2] = fb + 54;
 HEAP32[gb + 33652 >> 2] = fb + 110;
 HEAP32[gb + 33656 >> 2] = fb + 105;
 HEAP32[gb + 33660 >> 2] = fb + 138;
 HEAP32[gb + 33664 >> 2] = fb + 121;
 HEAP32[gb + 33668 >> 2] = fb + 139;
 HEAP32[gb + 33672 >> 2] = fb + 122;
 HEAP32[gb + 33676 >> 2] = fb + 142;
 HEAP32[gb + 33688 >> 2] = fb + 143;
 HEAP32[gb + 33692 >> 2] = fb + 144;
 HEAP32[gb + 33708 >> 2] = fb + 145;
 HEAP32[gb + 33712 >> 2] = fb + 146;
 HEAP32[gb + 33716 >> 2] = fb + 22;
 HEAP32[gb + 33720 >> 2] = fb + 102;
 HEAP32[gb + 33724 >> 2] = fb + 103;
 HEAP32[gb + 33728 >> 2] = fb + 104;
 HEAP32[gb + 33732 >> 2] = fb + 119;
 HEAP32[gb + 33736 >> 2] = fb + 120;
 HEAP32[gb + 33740 >> 2] = fb + 53;
 HEAP32[gb + 33744 >> 2] = fb + 52;
 HEAP32[gb + 33748 >> 2] = fb + 110;
 HEAP32[gb + 33752 >> 2] = fb + 105;
 HEAP32[gb + 33756 >> 2] = fb + 138;
 HEAP32[gb + 33760 >> 2] = fb + 121;
 HEAP32[gb + 33764 >> 2] = fb + 139;
 HEAP32[gb + 33768 >> 2] = fb + 147;
 HEAP32[gb + 33780 >> 2] = fb + 148;
 HEAP32[gb + 33784 >> 2] = fb + 144;
 HEAP32[gb + 33796 >> 2] = fb + 149;
 HEAP32[gb + 33800 >> 2] = fb + 150;
 HEAP32[gb + 33804 >> 2] = fb + 151;
 HEAP32[gb + 33808 >> 2] = fb + 166;
 HEAP32[gb + 33812 >> 2] = fb + 16;
 HEAP32[gb + 33816 >> 2] = fb + 152;
 HEAP32[gb + 33820 >> 2] = fb + 153;
 HEAP32[gb + 33824 >> 2] = fb + 19;
 HEAP32[gb + 33828 >> 2] = fb + 123;
 HEAP32[gb + 33832 >> 2] = fb + 103;
 HEAP32[gb + 33836 >> 2] = fb + 101;
 HEAP32[gb + 33840 >> 2] = fb + 62;
 HEAP32[gb + 33844 >> 2] = fb + 28;
 HEAP32[gb + 33848 >> 2] = fb + 63;
 HEAP32[gb + 33852 >> 2] = fb + 29;
 HEAP32[gb + 33856 >> 2] = fb + 34;
 HEAP32[gb + 33860 >> 2] = fb + 167;
 HEAP32[gb + 33864 >> 2] = fb + 168;
 HEAP32[gb + 33868 >> 2] = fb + 169;
 HEAP32[gb + 33872 >> 2] = fb + 170;
 HEAP32[gb + 33876 >> 2] = fb + 171;
 HEAP32[gb + 33880 >> 2] = fb + 172;
 HEAP32[gb + 33884 >> 2] = fb + 36;
 HEAP32[gb + 33888 >> 2] = fb + 104;
 HEAP32[gb + 33892 >> 2] = fb + 108;
 HEAP32[gb + 33896 >> 2] = fb + 94;
 HEAP32[gb + 33900 >> 2] = fb + 130;
 HEAP32[gb + 33904 >> 2] = fb + 112;
 HEAP32[gb + 33908 >> 2] = fb + 113;
 HEAP32[gb + 33912 >> 2] = fb + 131;
 HEAP32[gb + 33916 >> 2] = fb + 111;
 runPostSets14();
}

function __ZN5physx24PxsComputeAABBLocalSpaceERKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 i25 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 f10 = Math_fround(-Math_fround(HEAPF32[i25 + 48 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[i25 + 52 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i25 + 56 >> 2]));
 i25 = i25 + 32 | 0;
 f19 = Math_fround(HEAPF32[i25 >> 2]);
 f14 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(Math_fround(f19 * f10) + Math_fround(f14 * f18)) + Math_fround(f12 * f13));
 f21 = Math_fround(Math_fround(Math_fround(f19 * f15) + Math_fround(Math_fround(f17 * f10) - Math_fround(f16 * Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f18))))) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(Math_fround(f14 * f15) + Math_fround(Math_fround(f17 * f18) - Math_fround(f16 * Math_fround(Math_fround(f12 * f10) - Math_fround(f19 * f13))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f13) - Math_fround(f16 * Math_fround(Math_fround(f19 * f18) - Math_fround(f14 * f10))))) * Math_fround(2.0));
 f19 = Math_fround(-f19);
 f14 = Math_fround(-f14);
 f12 = Math_fround(-f12);
 f18 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f18 * f19) + Math_fround(f13 * f14)) + Math_fround(f15 * f12));
 f11 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(Math_fround(f17 * f13) + Math_fround(f16 * Math_fround(Math_fround(f18 * f12) - Math_fround(f15 * f19))))) * Math_fround(2.0)));
 f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(Math_fround(f17 * f15) + Math_fround(f16 * Math_fround(Math_fround(f13 * f19) - Math_fround(f18 * f14)))) + Math_fround(f20 * f12)) * Math_fround(2.0)));
 f6 = Math_fround(Math_fround(f16 * f7) - Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f24 * f14)) + Math_fround(f22 * f12)));
 f9 = Math_fround(Math_fround(Math_fround(f22 * f14) - Math_fround(f24 * f12)) + Math_fround(Math_fround(f16 * f23) + Math_fround(f7 * f19)));
 f8 = Math_fround(Math_fround(Math_fround(f23 * f12) - Math_fround(f22 * f19)) + Math_fround(Math_fround(f16 * f24) + Math_fround(f7 * f14)));
 f7 = Math_fround(Math_fround(Math_fround(f24 * f19) - Math_fround(f23 * f14)) + Math_fround(Math_fround(f16 * f22) + Math_fround(f7 * f12)));
 HEAPF32[i5 + 16 >> 2] = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12))))) * Math_fround(2.0)));
 HEAPF32[i5 + 20 >> 2] = f11;
 HEAPF32[i5 + 24 >> 2] = f10;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = f6;
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i4 + 36 | 0, i2, i5, Math_fround(HEAPF32[i4 + 28 >> 2]), i1);
 STACKTOP = i3;
 return;
}

function __ZN5physx22PxSceneGeneratedValuesC2EPKNS_7PxSceneE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP16[i2 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i2 + 4 | 0, i1 | 0);
 HEAP32[i2 + 36 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 40 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 44 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 48 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 52 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 56 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 60 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 64 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 68 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 72 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 76 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 80 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 84 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 252 >> 2] | 0, i2 + 88 | 0, i1 | 0);
 HEAPF32[i2 + 100 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 104 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 268 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 108 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 112 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 276 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 116 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 280 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 120 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 288 >> 2] | 0, i1 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 304 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 124 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 128 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 136 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 140 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 144 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 148 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 316 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 152 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 320 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 156 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 340 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 160 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 360 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 164 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 364 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 168 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 172 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 176 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 180 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 428 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 184 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 432 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 188 >> 2] = HEAP32[i1 + 4 >> 2];
 i2 = i2 + 192 | 0;
 __ZN5physx22PxSimulationStatisticsC2Ev(i2);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 312 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z19sweepCCTBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i6, i7, i2, i12, f9, i11, i10, f1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 i11 = i11 | 0;
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i8 + 60 | 0;
 i14 = i8;
 i13 = i8 + 120 | 0;
 f25 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 i4 = i7 + 16 | 0;
 f25 = Math_fround(f25 - Math_fround(HEAPF32[i4 >> 2]));
 f18 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 i5 = i7 + 20 | 0;
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i5 >> 2]));
 f19 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 i3 = i7 + 24 | 0;
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i3 >> 2]));
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i15 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i15 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAPF32[i15 + 36 >> 2] = f25;
 HEAPF32[i15 + 40 >> 2] = f18;
 HEAPF32[i15 + 44 >> 2] = f19;
 HEAP32[i15 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i15 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i15 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i14 + 36 >> 2] = 0;
 HEAP32[i14 + 40 >> 2] = 0;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i14 + 52 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i14 + 56 >> 2] = HEAP32[i6 + 12 >> 2];
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 f18 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f1 = Math_fround(f19 + f19);
 f17 = Math_fround(f18 + f18);
 f22 = Math_fround(f25 + f25);
 f24 = Math_fround(f18 * f17);
 f23 = Math_fround(f25 * f22);
 f18 = Math_fround(f1 * f18);
 f26 = Math_fround(f1 * f25);
 f16 = Math_fround(f1 * f20);
 f25 = Math_fround(f17 * f25);
 f17 = Math_fround(f17 * f20);
 f20 = Math_fround(f22 * f20);
 f22 = Math_fround(f18 + f20);
 f21 = Math_fround(f26 - f17);
 f20 = Math_fround(f18 - f20);
 f1 = Math_fround(Math_fround(1.0) - Math_fround(f19 * f1));
 f19 = Math_fround(f1 - f23);
 f18 = Math_fround(f25 + f16);
 f17 = Math_fround(f26 + f17);
 f16 = Math_fround(f25 - f16);
 f1 = Math_fround(f1 - f24);
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f24) - f23);
 HEAPF32[i14 + 4 >> 2] = f22;
 HEAPF32[i14 + 8 >> 2] = f21;
 HEAPF32[i14 + 12 >> 2] = f20;
 HEAPF32[i14 + 16 >> 2] = f19;
 HEAPF32[i14 + 20 >> 2] = f18;
 HEAPF32[i14 + 24 >> 2] = f17;
 HEAPF32[i14 + 28 >> 2] = f16;
 HEAPF32[i14 + 32 >> 2] = f1;
 i2 = i11 + 16 | 0;
 HEAP16[i13 >> 1] = HEAP16[i10 >> 1] | 0;
 if (!(__ZN5physx2Gu11sweepBoxBoxERKNS0_3BoxES3_RKNS_6PxVec3EfRS4_S7_RfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i15, i14, i12, f9, i2, i11 + 28 | 0, i11 + 40 | 0, i13) | 0)) {
  i15 = 0;
  STACKTOP = i8;
  return i15 | 0;
 }
 f26 = Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i2 >> 2]));
 f26 = Math_fround(HEAPF32[i5 >> 2]);
 i15 = i11 + 20 | 0;
 HEAPF32[i15 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i15 >> 2]));
 f26 = Math_fround(HEAPF32[i3 >> 2]);
 i15 = i11 + 24 | 0;
 HEAPF32[i15 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[i15 >> 2]));
 HEAP16[i11 + 12 >> 1] = 7;
 i15 = 1;
 STACKTOP = i8;
 return i15 | 0;
}

function __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 24 | 0;
 i14 = i16;
 i5 = i10 + 12 | 0;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i13 = i1 - i2 | 0;
 i4 = ((i13 | 0) / 40 | 0) + 1 | 0;
 if ((i13 | 0) < -40) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i7 = ((HEAP32[i10 + 8 >> 2] | 0) - i2 | 0) / 40 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
 i7 = (i1 - i2 | 0) / 40 | 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i13 = i14 + 16 | 0;
 HEAP32[i13 >> 2] = i5;
 if (!i3) i6 = 0; else {
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i15 >> 2] = 54;
  HEAP32[i15 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 40 | 0, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i14 >> 2] = i6;
 i1 = i6 + (i7 * 40 | 0) | 0;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = i1;
 i8 = i14 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i14 + 12 >> 2] = i6 + (i3 * 40 | 0);
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 i1 = i6 + (i7 * 40 | 0) + 20 | 0;
 i3 = i9 + 20 | 0;
 i2 = HEAP32[i9 + 32 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i6 + (i7 * 40 | 0) + 32 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i9 + 24 >> 2] | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i4 >> 2] | 0;
   i12 = 10;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i12 = 12;
  } else i12 = 10;
  if ((i12 | 0) == 10) {
   i4 = i5 + 16 & -16;
   HEAP32[i15 >> 2] = 54;
   HEAP32[i15 + 4 >> 2] = i2;
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i6 + (i7 * 40 | 0) + 28 >> 2] = i4 | -2147483648;
   HEAP32[i6 + (i7 * 40 | 0) + 24 >> 2] = i5;
   i1 = i9;
   i12 = 12;
  }
  if ((i12 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 }
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 40;
 __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i10, i14);
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i15 + 4 | 0;
  do {
   i2 = i1 + -40 | 0;
   HEAP32[i11 >> 2] = i2;
   i3 = i1 + -20 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i15 >> 2] = 54;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i15);
    i1 = HEAP32[i11 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i14 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
 HEAP32[i15 >> 2] = 54;
 HEAP32[i15 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 STACKTOP = i16;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __Z40CalculateBoundingSphereFromFrustumPointsPK8Vector3fRS_Rf(i1, i20, i21) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22;
 HEAP32[i18 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i23 = i18 + 12 | 0;
 i24 = i1 + 36 | 0;
 HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i23 = i18 + 24 | 0;
 i24 = i1 + 60 | 0;
 HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i23 = i18 + 36 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f12 = Math_fround(HEAPF32[i18 + 24 >> 2]);
 f13 = Math_fround(HEAPF32[i18 + 28 >> 2]);
 f14 = Math_fround(HEAPF32[i18 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i18 + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i18 + 40 >> 2]);
 f17 = Math_fround(HEAPF32[i18 + 44 >> 2]);
 f2 = Math_fround(Math_fround(f12 + f15) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f13 + f16) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f14 + f17) * Math_fround(.5));
 f10 = Math_fround(f12 - f2);
 f9 = Math_fround(f13 - f3);
 f5 = Math_fround(f14 - f4);
 f5 = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f5 * f5));
 f9 = Math_fround(HEAPF32[i18 >> 2]);
 f10 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f6 = Math_fround(f9 - f2);
 f7 = Math_fround(f10 - f3);
 f8 = Math_fround(f11 - f4);
 if (!(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)) <= f5)) {
  f2 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  f3 = Math_fround(HEAPF32[i18 + 16 >> 2]);
  f4 = Math_fround(HEAPF32[i18 + 20 >> 2]);
  i19 = 4;
 } else {
  f8 = Math_fround(HEAPF32[i18 + 20 >> 2]);
  f7 = Math_fround(HEAPF32[i18 + 16 >> 2]);
  f6 = Math_fround(HEAPF32[i18 + 12 >> 2]);
  f25 = Math_fround(f6 - f2);
  f26 = Math_fround(f7 - f3);
  f27 = Math_fround(f8 - f4);
  if (!(Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25))) <= f5)) {
   f2 = f6;
   f3 = f7;
   f4 = f8;
   i19 = 4;
  }
 }
 do if ((i19 | 0) == 4) {
  f2 = Math_fround(Math_fround(f9 + f2) * Math_fround(.5));
  f3 = Math_fround(Math_fround(f10 + f3) * Math_fround(.5));
  f4 = Math_fround(Math_fround(f11 + f4) * Math_fround(.5));
  f26 = Math_fround(f9 - f2);
  f25 = Math_fround(f10 - f3);
  f5 = Math_fround(f11 - f4);
  f5 = Math_fround(Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25)) + Math_fround(f5 * f5));
  f25 = Math_fround(f12 - f2);
  f26 = Math_fround(f13 - f3);
  f27 = Math_fround(f14 - f4);
  if (Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f26 * f26)) + Math_fround(f27 * f27)) <= f5) {
   f27 = Math_fround(f15 - f2);
   f26 = Math_fround(f16 - f3);
   f25 = Math_fround(f17 - f4);
   if (Math_fround(Math_fround(f25 * f25) + Math_fround(Math_fround(f26 * f26) + Math_fround(f27 * f27))) <= f5) break;
  }
  __Z26CalculateSphereFrom4PointsPK8Vector3fRS_Rf(i18, i20, i21);
  STACKTOP = i22;
  return;
 } while (0);
 HEAPF32[i20 >> 2] = f2;
 HEAPF32[i20 + 4 >> 2] = f3;
 HEAPF32[i20 + 8 >> 2] = f4;
 HEAPF32[i21 >> 2] = Math_fround(Math_sqrt(Math_fround(f5)));
 STACKTOP = i22;
 return;
}

function __Z27CalculateAABBCornerVerticesR10GameObjectP8Vector3f(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 64 | 0;
 i6 = i8;
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 31312 | 0) | 0;
 if (!i3) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = __ZN8Renderer12GetTransformEv(i3) | 0;
 i2 = i3 + 32 | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31632 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31632 + 28 >> 2] | 0) >>> 0) {
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i2, i7);
  f1 = Math_fround(HEAPF32[i7 + 12 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  f12 = Math_fround(f11 - f1);
  f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f13 = Math_fround(f10 - f16);
  f9 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f15 = Math_fround(f9 - f14);
  HEAPF32[i5 >> 2] = f12;
  HEAPF32[i5 + 4 >> 2] = f13;
  HEAPF32[i5 + 8 >> 2] = f15;
  f11 = Math_fround(f1 + f11);
  HEAPF32[i5 + 12 >> 2] = f11;
  HEAPF32[i5 + 16 >> 2] = f13;
  HEAPF32[i5 + 20 >> 2] = f15;
  f10 = Math_fround(f16 + f10);
  HEAPF32[i5 + 24 >> 2] = f12;
  HEAPF32[i5 + 28 >> 2] = f10;
  HEAPF32[i5 + 32 >> 2] = f15;
  HEAPF32[i5 + 36 >> 2] = f11;
  HEAPF32[i5 + 40 >> 2] = f10;
  HEAPF32[i5 + 44 >> 2] = f15;
  f9 = Math_fround(f14 + f9);
  HEAPF32[i5 + 48 >> 2] = f12;
  HEAPF32[i5 + 52 >> 2] = f13;
  HEAPF32[i5 + 56 >> 2] = f9;
  HEAPF32[i5 + 60 >> 2] = f11;
  HEAPF32[i5 + 64 >> 2] = f13;
  HEAPF32[i5 + 68 >> 2] = f9;
  HEAPF32[i5 + 72 >> 2] = f12;
  HEAPF32[i5 + 76 >> 2] = f10;
  HEAPF32[i5 + 80 >> 2] = f9;
  HEAPF32[i5 + 84 >> 2] = f11;
  HEAPF32[i5 + 88 >> 2] = f10;
  HEAPF32[i5 + 92 >> 2] = f9;
 } else {
  __ZN12BaseRenderer12GetLocalAABBER4AABB(i2, i7);
  i3 = i7 + 12 | 0;
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  f12 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  f14 = Math_fround(f15 - f9);
  f16 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f13 = Math_fround(f16 - f10);
  f1 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f11 = Math_fround(f1 - f12);
  HEAPF32[i5 >> 2] = f14;
  HEAPF32[i5 + 4 >> 2] = f13;
  HEAPF32[i5 + 8 >> 2] = f11;
  f15 = Math_fround(f9 + f15);
  HEAPF32[i5 + 12 >> 2] = f15;
  HEAPF32[i5 + 16 >> 2] = f13;
  HEAPF32[i5 + 20 >> 2] = f11;
  f16 = Math_fround(f10 + f16);
  HEAPF32[i5 + 24 >> 2] = f14;
  HEAPF32[i5 + 28 >> 2] = f16;
  HEAPF32[i5 + 32 >> 2] = f11;
  HEAPF32[i5 + 36 >> 2] = f15;
  HEAPF32[i5 + 40 >> 2] = f16;
  HEAPF32[i5 + 44 >> 2] = f11;
  f1 = Math_fround(f12 + f1);
  HEAPF32[i5 + 48 >> 2] = f14;
  HEAPF32[i5 + 52 >> 2] = f13;
  HEAPF32[i5 + 56 >> 2] = f1;
  HEAPF32[i5 + 60 >> 2] = f15;
  HEAPF32[i5 + 64 >> 2] = f13;
  HEAPF32[i5 + 68 >> 2] = f1;
  HEAPF32[i5 + 72 >> 2] = f14;
  HEAPF32[i5 + 76 >> 2] = f16;
  HEAPF32[i5 + 80 >> 2] = f1;
  HEAPF32[i5 + 84 >> 2] = f15;
  HEAPF32[i5 + 88 >> 2] = f16;
  HEAPF32[i5 + 92 >> 2] = f1;
  __ZNK9Transform21GetLocalToWorldMatrixEv(i6, i4);
  __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fPS2_i(i6, i5, i5, 8);
  f1 = Math_fround(HEAPF32[i3 >> 2]);
 }
 if (!(f1 != Math_fround(HEAPF32[gb + 1162364 >> 2]))) {
  f16 = Math_fround(HEAPF32[i7 + 16 >> 2]);
  if (!(f16 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]))) {
   f16 = Math_fround(HEAPF32[i7 + 20 >> 2]);
   if (!(f16 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]))) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
  }
 }
 i7 = 1;
 STACKTOP = i8;
 return i7 | 0;
}

function runPostSets20() {
 HEAP32[gb + 37340 >> 2] = (HEAP32[gb + 37340 >> 2] | 0) + (gb + 388687 | 0);
 HEAP32[gb + 37352 >> 2] = fb + 248;
 HEAP32[gb + 37356 >> 2] = fb + 249;
 HEAP32[gb + 37360 >> 2] = fb + 250;
 HEAP32[gb + 37364 >> 2] = fb + 247;
 HEAP32[gb + 37368 >> 2] = fb + 16;
 HEAP32[gb + 37372 >> 2] = fb + 93;
 HEAP32[gb + 37376 >> 2] = fb + 40;
 HEAP32[gb + 37380 >> 2] = fb + 19;
 HEAP32[gb + 37384 >> 2] = fb + 141;
 HEAP32[gb + 37388 >> 2] = fb + 103;
 HEAP32[gb + 37392 >> 2] = fb + 101;
 HEAP32[gb + 37396 >> 2] = fb + 62;
 HEAP32[gb + 37400 >> 2] = fb + 28;
 HEAP32[gb + 37404 >> 2] = fb + 63;
 HEAP32[gb + 37408 >> 2] = fb + 29;
 HEAP32[gb + 37412 >> 2] = fb + 34;
 HEAP32[gb + 37416 >> 2] = fb + 248;
 HEAP32[gb + 37420 >> 2] = fb + 249;
 HEAP32[gb + 37424 >> 2] = fb + 250;
 HEAP32[gb + 37428 >> 2] = fb + 251;
 HEAP32[gb + 37432 >> 2] = fb + 252;
 HEAP32[gb + 37436 >> 2] = fb + 253;
 HEAP32[gb + 37440 >> 2] = fb + 36;
 HEAP32[gb + 37444 >> 2] = fb + 104;
 HEAP32[gb + 37448 >> 2] = fb + 108;
 HEAP32[gb + 37452 >> 2] = fb + 94;
 HEAP32[gb + 37456 >> 2] = fb + 130;
 HEAP32[gb + 37460 >> 2] = fb + 112;
 HEAP32[gb + 37464 >> 2] = fb + 113;
 HEAP32[gb + 37468 >> 2] = fb + 131;
 HEAP32[gb + 37472 >> 2] = fb + 111;
 HEAP32[gb + 37476 >> 2] = fb + 112;
 HEAP32[gb + 37480 >> 2] = fb + 113;
 HEAP32[gb + 37484 >> 2] = fb + 251;
 HEAP32[gb + 37488 >> 2] = fb + 252;
 HEAP32[gb + 37492 >> 2] = fb + 254;
 HEAP32[gb + 37496 >> 2] = fb + 3;
 HEAP32[gb + 37500 >> 2] = fb + 255;
 HEAP32[gb + 37504 >> 2] = fb + 142;
 HEAP32[gb + 37508 >> 2] = fb + 1;
 HEAP32[gb + 37512 >> 2] = fb + 2;
 HEAP32[gb + 37516 >> 2] = fb + 12;
 HEAP32[gb + 37520 >> 2] = fb + 253;
 HEAP32[gb + 37524 >> 2] = fb + 254;
 HEAP32[gb + 37544 >> 2] = fb + 255;
 HEAP32[gb + 37548 >> 2] = fb + 256;
 HEAP32[gb + 37552 >> 2] = fb + 143;
 HEAP32[gb + 37556 >> 2] = fb + 13;
 HEAP32[gb + 37560 >> 2] = fb + 2;
 HEAP32[gb + 37564 >> 2] = fb + 3;
 HEAP32[gb + 37568 >> 2] = fb + 3;
 HEAP32[gb + 37572 >> 2] = fb + 4;
 HEAP32[gb + 37576 >> 2] = fb + 256;
 HEAP32[gb + 37580 >> 2] = fb + 144;
 HEAP32[gb + 37584 >> 2] = fb + 4;
 HEAP32[gb + 37588 >> 2] = fb + 2;
 HEAP32[gb + 37592 >> 2] = fb + 145;
 HEAP32[gb + 37596 >> 2] = fb + 56;
 HEAP32[gb + 37600 >> 2] = fb + 257;
 HEAP32[gb + 37604 >> 2] = fb + 23;
 HEAP32[gb + 37608 >> 2] = fb + 24;
 HEAP32[gb + 37620 >> 2] = fb + 258;
 HEAP32[gb + 37624 >> 2] = fb + 259;
 HEAP32[gb + 37628 >> 2] = fb + 1;
 HEAP32[gb + 37640 >> 2] = fb + 260;
 HEAP32[gb + 37644 >> 2] = fb + 261;
 HEAP32[gb + 37648 >> 2] = fb + 262;
 HEAP32[gb + 37652 >> 2] = fb + 39;
 HEAP32[gb + 37656 >> 2] = fb + 16;
 HEAP32[gb + 37660 >> 2] = fb + 39;
 HEAP32[gb + 37664 >> 2] = fb + 40;
 HEAP32[gb + 37668 >> 2] = fb + 19;
 HEAP32[gb + 37672 >> 2] = fb + 146;
 HEAP32[gb + 37676 >> 2] = fb + 99;
 HEAP32[gb + 37680 >> 2] = fb + 40;
 HEAP32[gb + 37684 >> 2] = fb + 62;
 HEAP32[gb + 37688 >> 2] = fb + 28;
 HEAP32[gb + 37692 >> 2] = fb + 63;
 HEAP32[gb + 37696 >> 2] = fb + 29;
 HEAP32[gb + 37700 >> 2] = fb + 34;
 HEAP32[gb + 37704 >> 2] = fb + 85;
 HEAP32[gb + 37708 >> 2] = fb + 86;
 HEAP32[gb + 37712 >> 2] = fb + 87;
 HEAP32[gb + 37716 >> 2] = fb + 88;
 HEAP32[gb + 37720 >> 2] = fb + 89;
 HEAP32[gb + 37724 >> 2] = fb + 90;
 HEAP32[gb + 37728 >> 2] = fb + 36;
 HEAP32[gb + 37732 >> 2] = fb + 96;
 HEAP32[gb + 37736 >> 2] = fb + 81;
 HEAP32[gb + 37740 >> 2] = fb + 82;
 HEAP32[gb + 37744 >> 2] = fb + 257;
 HEAP32[gb + 37756 >> 2] = fb + 263;
 HEAP32[gb + 37760 >> 2] = fb + 264;
 HEAP32[gb + 37764 >> 2] = fb + 38;
 HEAP32[gb + 37768 >> 2] = fb + 145;
 HEAP32[gb + 37772 >> 2] = fb + 16;
 HEAP32[gb + 37776 >> 2] = fb + 93;
 HEAP32[gb + 37780 >> 2] = fb + 40;
 HEAP32[gb + 37784 >> 2] = fb + 19;
 runPostSets21();
}
function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i14, i13, i12) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 32 | 0;
 i7 = i15 + 28 | 0;
 i10 = i15 + 16 | 0;
 i11 = i15;
 i6 = i14 + 128 | 0;
 if ((i12 | 0) > -1) if ((HEAP32[i6 >> 2] | 0) > (i12 | 0)) {
  i1 = HEAP32[(HEAP32[i14 + 124 >> 2] | 0) + (i12 << 2) >> 2] | 0;
  if (i1 | 0) {
   i14 = i1;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 i5 = i14 + 160 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, HEAP32[i13 >> 2] | 0, i2 | 0) | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i8 = i13 + 4 | 0;
 i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, HEAP32[i8 >> 2] | 0, i2 | 0) | 0;
 i3 = i14 + 112 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) > (i12 | 0)) i1 = i14 + 124 | 0; else {
  i4 = i14 + 132 | 0;
  i1 = i14 + 124 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
    HEAP32[i6 >> 2] = i2;
   } else {
    __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i3, i7) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
  } while ((i2 | 0) <= (i12 | 0));
 }
 i6 = i14 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, 144, gb + 774534 | 0, gb + 774188 | 0, 640) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = i12;
 HEAP32[i7 + 16 >> 2] = -1;
 HEAP32[i7 + 20 >> 2] = -1;
 HEAP32[i7 + 24 >> 2] = -1;
 i4 = i7 + 28 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP32[i7 + 44 >> 2] = 0;
 i10 = i7 + 4 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i5;
 i10 = i7 + 48 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i7 + 60 >> 2] = 0;
 HEAP32[i7 + 64 >> 2] = 0;
 i11 = i7 + 68 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP32[i7 >> 2] = gb + 148256 + 8;
 i11 = i6;
 HEAP32[i7 + 76 >> 2] = i11;
 HEAP32[i7 + 80 >> 2] = gb + 774548;
 HEAP32[i7 + 84 >> 2] = 0;
 HEAP32[i7 + 88 >> 2] = 0;
 HEAP32[i7 + 92 >> 2] = 0;
 HEAP32[i7 + 72 >> 2] = gb + 148272 + 8;
 HEAP32[i7 + 100 >> 2] = i11;
 HEAP32[i7 + 104 >> 2] = gb + 774562;
 HEAP32[i7 + 108 >> 2] = 0;
 HEAP32[i7 + 112 >> 2] = 0;
 HEAP32[i7 + 116 >> 2] = 0;
 HEAP32[i7 + 96 >> 2] = gb + 148288 + 8;
 HEAP32[i7 + 124 >> 2] = i11;
 HEAP32[i7 + 128 >> 2] = gb + 774592;
 HEAP32[i7 + 132 >> 2] = 0;
 HEAP32[i7 + 136 >> 2] = 0;
 HEAP32[i7 + 140 >> 2] = 0;
 HEAP32[i7 + 120 >> 2] = gb + 148288 + 8;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i12 << 2) >> 2] = i7;
 __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i14 + 8 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + (i12 << 2) >> 2] | 0);
 i14 = i14 + 240 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i14 >> 2] = (i13 | 0) < (i11 | 0) ? i11 : i13;
 i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i12 << 2) >> 2] | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function runPostSets3() {
 HEAP32[gb + 26012 >> 2] = fb + 47;
 HEAP32[gb + 26016 >> 2] = fb + 48;
 HEAP32[gb + 26020 >> 2] = fb + 49;
 HEAP32[gb + 26024 >> 2] = fb + 38;
 HEAP32[gb + 26028 >> 2] = fb + 21;
 HEAP32[gb + 26032 >> 2] = fb + 3;
 HEAP32[gb + 26036 >> 2] = fb + 5;
 HEAP32[gb + 26040 >> 2] = fb + 22;
 HEAP32[gb + 26044 >> 2] = fb + 50;
 HEAP32[gb + 26048 >> 2] = fb + 23;
 HEAP32[gb + 26052 >> 2] = fb + 24;
 HEAP32[gb + 26056 >> 2] = fb + 25;
 HEAP32[gb + 26060 >> 2] = fb + 26;
 HEAP32[gb + 26064 >> 2] = fb + 27;
 HEAP32[gb + 26068 >> 2] = fb + 51;
 HEAP32[gb + 26072 >> 2] = fb + 28;
 HEAP32[gb + 26076 >> 2] = fb + 29;
 HEAP32[gb + 26080 >> 2] = fb + 52;
 HEAP32[gb + 26084 >> 2] = fb + 53;
 HEAP32[gb + 26088 >> 2] = fb + 54;
 HEAP32[gb + 26092 >> 2] = fb + 55;
 HEAP32[gb + 26096 >> 2] = fb + 20;
 HEAP32[gb + 26100 >> 2] = fb + 30;
 HEAP32[gb + 26104 >> 2] = fb + 56;
 HEAP32[gb + 26108 >> 2] = fb + 57;
 HEAP32[gb + 26120 >> 2] = (HEAP32[gb + 26120 >> 2] | 0) + (gb + 1047948 | 0);
 HEAP32[gb + 26124 >> 2] = (HEAP32[gb + 26124 >> 2] | 0) + (gb + 1576256 | 0);
 HEAP32[gb + 26160 >> 2] = fb + 31;
 HEAP32[gb + 26164 >> 2] = fb + 32;
 HEAP32[gb + 26168 >> 2] = fb + 15;
 HEAP32[gb + 26172 >> 2] = fb + 26;
 HEAP32[gb + 26176 >> 2] = fb + 16;
 HEAP32[gb + 26180 >> 2] = fb + 17;
 HEAP32[gb + 26184 >> 2] = fb + 18;
 HEAP32[gb + 26188 >> 2] = fb + 19;
 HEAP32[gb + 26192 >> 2] = fb + 58;
 HEAP32[gb + 26196 >> 2] = fb + 31;
 HEAP32[gb + 26200 >> 2] = fb + 27;
 HEAP32[gb + 26204 >> 2] = fb + 32;
 HEAP32[gb + 26208 >> 2] = fb + 28;
 HEAP32[gb + 26212 >> 2] = fb + 33;
 HEAP32[gb + 26216 >> 2] = fb + 29;
 HEAP32[gb + 26220 >> 2] = fb + 34;
 HEAP32[gb + 26224 >> 2] = fb + 30;
 HEAP32[gb + 26228 >> 2] = fb + 31;
 HEAP32[gb + 26232 >> 2] = fb + 32;
 HEAP32[gb + 26236 >> 2] = fb + 33;
 HEAP32[gb + 26240 >> 2] = fb + 34;
 HEAP32[gb + 26244 >> 2] = fb + 35;
 HEAP32[gb + 26248 >> 2] = fb + 36;
 HEAP32[gb + 26252 >> 2] = fb + 20;
 HEAP32[gb + 26256 >> 2] = fb + 35;
 HEAP32[gb + 26260 >> 2] = fb + 36;
 HEAP32[gb + 26264 >> 2] = fb + 37;
 HEAP32[gb + 26268 >> 2] = fb + 37;
 HEAP32[gb + 26272 >> 2] = fb + 38;
 HEAP32[gb + 26276 >> 2] = fb + 39;
 HEAP32[gb + 26280 >> 2] = fb + 40;
 HEAP32[gb + 26284 >> 2] = fb + 41;
 HEAP32[gb + 26288 >> 2] = fb + 42;
 HEAP32[gb + 26292 >> 2] = fb + 43;
 HEAP32[gb + 26296 >> 2] = fb + 44;
 HEAP32[gb + 26300 >> 2] = fb + 45;
 HEAP32[gb + 26304 >> 2] = fb + 46;
 HEAP32[gb + 26308 >> 2] = fb + 47;
 HEAP32[gb + 26312 >> 2] = fb + 48;
 HEAP32[gb + 26316 >> 2] = fb + 1;
 HEAP32[gb + 26320 >> 2] = fb + 38;
 HEAP32[gb + 26324 >> 2] = fb + 21;
 HEAP32[gb + 26328 >> 2] = fb + 3;
 HEAP32[gb + 26332 >> 2] = fb + 5;
 HEAP32[gb + 26336 >> 2] = fb + 22;
 HEAP32[gb + 26340 >> 2] = fb + 50;
 HEAP32[gb + 26344 >> 2] = fb + 23;
 HEAP32[gb + 26348 >> 2] = fb + 1;
 HEAP32[gb + 26352 >> 2] = fb + 33;
 HEAP32[gb + 26356 >> 2] = fb + 34;
 HEAP32[gb + 26360 >> 2] = fb + 35;
 HEAP32[gb + 26364 >> 2] = fb + 51;
 HEAP32[gb + 26368 >> 2] = fb + 28;
 HEAP32[gb + 26372 >> 2] = fb + 29;
 HEAP32[gb + 26376 >> 2] = fb + 52;
 HEAP32[gb + 26380 >> 2] = fb + 53;
 HEAP32[gb + 26384 >> 2] = fb + 59;
 HEAP32[gb + 26388 >> 2] = fb + 1;
 HEAP32[gb + 26400 >> 2] = fb + 36;
 HEAP32[gb + 26404 >> 2] = fb + 37;
 HEAP32[gb + 26408 >> 2] = fb + 38;
 HEAP32[gb + 26412 >> 2] = fb + 39;
 HEAP32[gb + 26416 >> 2] = fb + 16;
 HEAP32[gb + 26420 >> 2] = fb + 39;
 HEAP32[gb + 26424 >> 2] = fb + 40;
 HEAP32[gb + 26428 >> 2] = fb + 19;
 HEAP32[gb + 26432 >> 2] = fb + 60;
 HEAP32[gb + 26436 >> 2] = fb + 61;
 HEAP32[gb + 26440 >> 2] = fb + 40;
 HEAP32[gb + 26444 >> 2] = fb + 62;
 HEAP32[gb + 26448 >> 2] = fb + 28;
 HEAP32[gb + 26452 >> 2] = fb + 63;
 HEAP32[gb + 26456 >> 2] = fb + 29;
 runPostSets4();
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i17, i3, i1) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i2 = i16 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0);
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i16;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i14 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i8 = HEAP32[gb + 37300 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, 0, 0) | 0;
  i13 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i13 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i13 >> 2] | 0;
   i9 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i14 | 0)) {
    i4 = i17 + 16 | 0;
    i5 = i17 + 20 | 0;
    i6 = i17 + 32 | 0;
    i7 = i17 + 36 | 0;
    i8 = i17 + 24 | 0;
    i3 = 0;
    while (1) {
     i19 = (Math_imul(i3, i10) | 0) + i9 | 0;
     HEAP32[i2 + 20 >> 2] = i19;
     HEAP32[i2 + 12 >> 2] = i19;
     __ZNK16TypeTreeIterator8ChildrenEv(i15, i2);
     i19 = i15;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i3 + 4 >> 2] = i18;
     i3 = HEAP32[i11 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     i3 = HEAP32[i5 >> 2] | 0;
     i2 = i3 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i4 >> 2] = i2;
     if (i2 >>> 0 < i3 >>> 0) i12 = 9; else if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i12 = 9; else {
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     }
     if ((i12 | 0) == 9) {
      i12 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
     }
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i14 | 0)) break L8;
     i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i17);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i3 = i17 + 16 | 0;
   i4 = i17 + 20 | 0;
   i5 = i17 + 32 | 0;
   i6 = i17 + 36 | 0;
   i7 = i17 + 24 | 0;
   do {
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, i8, i15, 0) | 0;
    if (i2 | 0) {
     do if ((i2 | 0) > 0) {
      i19 = HEAP32[i4 >> 2] | 0;
      i2 = i19 + (HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, 0 - (HEAP32[i5 >> 2] | 0) | 0) | 0) | 0;
      HEAP32[i3 >> 2] = i2;
      if (i2 >>> 0 >= i19 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
       HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
       break;
      }
      __ZN12CachedReader15UpdateReadCacheEPvj(i3, i1, 1);
     } else {
      i2 = HEAP32[i15 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i17 | 0) | 0;
     } while (0);
     __ZN14SafeBinaryRead11EndTransferEv(i17);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i14 | 0));
  }
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZNK20LightPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) == (i1 | 0)) {
  i5 = (HEAP32[i6 + 44 >> 2] | 0) + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAPF32[i4 >> 2] = f3;
  __ZN5Light8SetColorERK10ColorRGBAf(i6, i4);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 8 >> 2] | 0) == (i1 | 0)) {
  i5 = (HEAP32[i6 + 44 >> 2] | 0) + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAPF32[i4 + 4 >> 2] = f3;
  __ZN5Light8SetColorERK10ColorRGBAf(i6, i4);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 | 0)) {
  i5 = (HEAP32[i6 + 44 >> 2] | 0) + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAPF32[i4 + 8 >> 2] = f3;
  __ZN5Light8SetColorERK10ColorRGBAf(i6, i4);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) == (i1 | 0)) {
  i5 = (HEAP32[i6 + 44 >> 2] | 0) + 20 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAPF32[i4 + 12 >> 2] = f3;
  __ZN5Light8SetColorERK10ColorRGBAf(i6, i4);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 20 >> 2] | 0) == (i1 | 0)) {
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 64 >> 2] = f3;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
  __ZN5Light7PrecalcEv(i6);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 24 >> 2] | 0) == (i1 | 0)) {
  i5 = f3 != Math_fround(0.0);
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAP8[(HEAP32[i6 + 44 >> 2] | 0) + 85 >> 0] = i5 & 1;
  __ZN5Light9SetupHaloEv(i6);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 28 >> 2] | 0) == (i1 | 0)) {
  __ZN5Light12SetIntensityEf(i6, f3);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 32 >> 2] | 0) == (i1 | 0)) {
  HEAPF32[i4 >> 2] = f3;
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i2 = f3 > Math_fround(0.0);
  i5 = HEAP32[(i2 ? i4 : i5) >> 2] | 0;
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAP32[(HEAP32[i6 + 44 >> 2] | 0) + 48 >> 2] = i5;
  __ZN5Light7PrecalcEv(i6);
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) == (i1 | 0)) {
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 108 >> 2] = f3;
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) {
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 112 >> 2] = f3;
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 44 >> 2] | 0) == (i1 | 0)) {
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 116 >> 2] = f3;
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 48 >> 2] | 0) == (i1 | 0)) {
  __ZNK5Light16UnshareLightDataEv(i6);
  HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 120 >> 2] = f3;
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i2 + 52 >> 2] | 0) != (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZNK5Light16UnshareLightDataEv(i6);
 HEAPF32[(HEAP32[i6 + 44 >> 2] | 0) + 60 >> 2] = f3;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 __ZN5Light7PrecalcEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i2 = i8 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 172 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034211 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 176 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034225 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 180 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034240 | 0, i5, i6, 0) | 0;
 if (!i1) {
  __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i8);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i6 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 34; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 34; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i8);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Cm20visualizeLinearLimitERNS0_12RenderOutputEfRKNS_11PxTransformES5_fb(i3, f4, i5, i1, f6, i2) {
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1 + 64 | 0;
 i17 = i1 + 36 | 0;
 i9 = i1 + 8 | 0;
 i7 = i1;
 i15 = i5 + 16 | 0;
 f23 = Math_fround(HEAPF32[i5 >> 2]);
 f21 = Math_fround(f23 * Math_fround(2.0));
 f24 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f20 = Math_fround(f24 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f23 * f21) + Math_fround(Math_fround(f24 * f20) + Math_fround(-1.0)));
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f14 * f20);
 f22 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(f11 * f6);
 f10 = Math_fround(Math_fround(f10 + Math_fround(f21 * f22)) * f6);
 f6 = Math_fround(Math_fround(Math_fround(f21 * f14) - Math_fround(f20 * f22)) * f6);
 f11 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f11);
 i16 = i5 + 20 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f10);
 i5 = i5 + 24 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f6);
 f20 = Math_fround(f24 * Math_fround(0.0));
 f21 = Math_fround(f23 * Math_fround(.707106769));
 f19 = Math_fround(f22 * Math_fround(0.0));
 f18 = Math_fround(f14 * Math_fround(.707106769));
 f24 = Math_fround(f24 * Math_fround(.707106769));
 f22 = Math_fround(f22 * Math_fround(.707106769));
 f14 = Math_fround(f14 * Math_fround(0.0));
 f23 = Math_fround(f23 * Math_fround(0.0));
 f12 = Math_fround(Math_fround(f14 + Math_fround(f24 + f22)) - f23);
 f13 = Math_fround(Math_fround(f21 + Math_fround(f20 + f18)) - f19);
 f14 = Math_fround(Math_fround(Math_fround(f24 - f23) - f22) - f14);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(f21 + f20) + f19) - f18);
 HEAPF32[i8 + 4 >> 2] = f12;
 HEAPF32[i8 + 8 >> 2] = f13;
 HEAPF32[i8 + 12 >> 2] = f14;
 HEAPF32[i8 + 16 >> 2] = f11;
 HEAPF32[i8 + 20 >> 2] = f10;
 HEAPF32[i8 + 24 >> 2] = f6;
 __ZN5physx2Cm12RenderOutputlsEj(i3, i2 ? -65536 : -8355712) | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i3, i17) | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i9 >> 2] = i15;
 i2 = HEAP32[i16 >> 2] | 0;
 HEAP32[i9 + 4 >> 2] = i2;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = i5;
 f14 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f11);
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f10);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
 HEAPF32[i9 + 12 >> 2] = f14;
 HEAPF32[i9 + 16 >> 2] = f13;
 HEAPF32[i9 + 20 >> 2] = f12;
 HEAPF32[i9 + 24 >> 2] = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f6 * f6)))) * Math_fround(.150000006));
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i3, i9) | 0;
 i5 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i3, i8) | 0;
 f6 = Math_fround(f4 * Math_fround(.300000012));
 HEAP32[i7 >> 2] = 20;
 HEAPF32[i7 + 4 >> 2] = f6;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i5, i7) | 0;
 STACKTOP = i1;
 return;
}

function __ZN16SpriteRenderData8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 932887 | 0, gb + 1034905 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 410538 | 0, gb + 1034905 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 56 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + 8 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 500490 | 0, i4, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i8, i3, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = (HEAP32[i2 >> 2] | 0) + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 753990 | 0, i4, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i8, i6 + 8 | 0, gb + 410551 | 0, 0);
 i2 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 410563 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 410581 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 36; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 36; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 410593 | 0, HEAP32[gb + 37328 >> 2] | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function runPostSets75() {
 HEAP32[gb + 83240 >> 2] = fb + 68;
 HEAP32[gb + 83244 >> 2] = fb + 69;
 HEAP32[gb + 83248 >> 2] = fb + 934;
 HEAP32[gb + 83252 >> 2] = fb + 355;
 HEAP32[gb + 83256 >> 2] = fb + 356;
 HEAP32[gb + 83260 >> 2] = fb + 108;
 HEAP32[gb + 83264 >> 2] = fb + 772;
 HEAP32[gb + 83268 >> 2] = fb + 773;
 HEAP32[gb + 83272 >> 2] = fb + 10;
 HEAP32[gb + 83284 >> 2] = fb + 935;
 HEAP32[gb + 83288 >> 2] = fb + 936;
 HEAP32[gb + 83292 >> 2] = fb + 109;
 HEAP32[gb + 83296 >> 2] = fb + 102;
 HEAP32[gb + 83300 >> 2] = fb + 937;
 HEAP32[gb + 83304 >> 2] = fb + 938;
 HEAP32[gb + 83308 >> 2] = fb + 209;
 HEAP32[gb + 83312 >> 2] = fb + 210;
 HEAP32[gb + 83316 >> 2] = fb + 70;
 HEAP32[gb + 83320 >> 2] = fb + 71;
 HEAP32[gb + 83324 >> 2] = fb + 110;
 HEAP32[gb + 83328 >> 2] = fb + 105;
 HEAP32[gb + 83332 >> 2] = fb + 939;
 HEAP32[gb + 83344 >> 2] = fb + 940;
 HEAP32[gb + 83348 >> 2] = fb + 941;
 HEAP32[gb + 83360 >> 2] = fb + 942;
 HEAP32[gb + 83364 >> 2] = fb + 943;
 HEAP32[gb + 83376 >> 2] = fb + 944;
 HEAP32[gb + 83380 >> 2] = fb + 945;
 HEAP32[gb + 83392 >> 2] = fb + 946;
 HEAP32[gb + 83396 >> 2] = fb + 947;
 HEAP32[gb + 83408 >> 2] = fb + 948;
 HEAP32[gb + 83412 >> 2] = fb + 949;
 HEAP32[gb + 83424 >> 2] = fb + 950;
 HEAP32[gb + 83428 >> 2] = fb + 951;
 HEAP32[gb + 83440 >> 2] = fb + 952;
 HEAP32[gb + 83444 >> 2] = fb + 953;
 HEAP32[gb + 83456 >> 2] = fb + 954;
 HEAP32[gb + 83460 >> 2] = fb + 955;
 HEAP32[gb + 83472 >> 2] = fb + 956;
 HEAP32[gb + 83476 >> 2] = fb + 957;
 HEAP32[gb + 83488 >> 2] = fb + 958;
 HEAP32[gb + 83492 >> 2] = fb + 959;
 HEAP32[gb + 83504 >> 2] = fb + 960;
 HEAP32[gb + 83508 >> 2] = fb + 961;
 HEAP32[gb + 83520 >> 2] = fb + 962;
 HEAP32[gb + 83524 >> 2] = fb + 963;
 HEAP32[gb + 83536 >> 2] = fb + 964;
 HEAP32[gb + 83540 >> 2] = fb + 965;
 HEAP32[gb + 83552 >> 2] = fb + 966;
 HEAP32[gb + 83556 >> 2] = fb + 967;
 HEAP32[gb + 83568 >> 2] = fb + 954;
 HEAP32[gb + 83572 >> 2] = fb + 968;
 HEAP32[gb + 83584 >> 2] = fb + 969;
 HEAP32[gb + 83588 >> 2] = fb + 970;
 HEAP32[gb + 83600 >> 2] = fb + 971;
 HEAP32[gb + 83604 >> 2] = fb + 972;
 HEAP32[gb + 83616 >> 2] = fb + 973;
 HEAP32[gb + 83620 >> 2] = fb + 974;
 HEAP32[gb + 83632 >> 2] = fb + 975;
 HEAP32[gb + 83636 >> 2] = fb + 976;
 HEAP32[gb + 83648 >> 2] = fb + 977;
 HEAP32[gb + 83660 >> 2] = fb + 423;
 HEAP32[gb + 83664 >> 2] = fb + 978;
 HEAP32[gb + 83668 >> 2] = fb + 1;
 HEAP32[gb + 83672 >> 2] = fb + 201;
 HEAP32[gb + 83676 >> 2] = fb + 424;
 HEAP32[gb + 83680 >> 2] = fb + 202;
 HEAP32[gb + 83684 >> 2] = fb + 774;
 HEAP32[gb + 83688 >> 2] = fb + 425;
 HEAP32[gb + 83692 >> 2] = fb + 1;
 HEAP32[gb + 83696 >> 2] = fb + 11;
 HEAP32[gb + 83700 >> 2] = fb + 775;
 HEAP32[gb + 83704 >> 2] = fb + 426;
 HEAP32[gb + 83708 >> 2] = fb + 12;
 HEAP32[gb + 83712 >> 2] = fb + 2;
 HEAP32[gb + 83716 >> 2] = fb + 776;
 HEAP32[gb + 83720 >> 2] = fb + 777;
 HEAP32[gb + 83724 >> 2] = fb + 13;
 HEAP32[gb + 83728 >> 2] = fb + 3;
 HEAP32[gb + 83732 >> 2] = fb + 979;
 HEAP32[gb + 83736 >> 2] = fb + 427;
 HEAP32[gb + 83740 >> 2] = fb + 428;
 HEAP32[gb + 83744 >> 2] = fb + 778;
 HEAP32[gb + 83748 >> 2] = fb + 779;
 HEAP32[gb + 83752 >> 2] = fb + 780;
 HEAP32[gb + 83756 >> 2] = fb + 4;
 HEAP32[gb + 83760 >> 2] = fb + 980;
 HEAP32[gb + 83764 >> 2] = fb + 981;
 HEAP32[gb + 83768 >> 2] = fb + 14;
 HEAP32[gb + 83772 >> 2] = fb + 15;
 HEAP32[gb + 83776 >> 2] = fb + 16;
 HEAP32[gb + 83780 >> 2] = fb + 1;
 HEAP32[gb + 83784 >> 2] = fb + 2;
 HEAP32[gb + 83788 >> 2] = fb + 3;
 HEAP32[gb + 83792 >> 2] = fb + 17;
 HEAP32[gb + 83796 >> 2] = fb + 203;
 HEAP32[gb + 83800 >> 2] = fb + 429;
 HEAP32[gb + 83812 >> 2] = fb + 61;
 HEAP32[gb + 83816 >> 2] = fb + 982;
 HEAP32[gb + 83820 >> 2] = fb + 983;
 runPostSets76();
}

function runPostSets106() {
 HEAP32[gb + 98712 >> 2] = fb + 1;
 HEAP32[gb + 98716 >> 2] = fb + 1072;
 HEAP32[gb + 98720 >> 2] = fb + 1;
 HEAP32[gb + 98724 >> 2] = fb + 1;
 HEAP32[gb + 98728 >> 2] = fb + 1;
 HEAP32[gb + 98732 >> 2] = fb + 1;
 HEAP32[gb + 98736 >> 2] = fb + 1;
 HEAP32[gb + 98740 >> 2] = fb + 199;
 HEAP32[gb + 98744 >> 2] = fb + 1073;
 HEAP32[gb + 98748 >> 2] = fb + 200;
 HEAP32[gb + 98752 >> 2] = fb + 1074;
 HEAP32[gb + 98756 >> 2] = fb + 690;
 HEAP32[gb + 98760 >> 2] = fb + 691;
 HEAP32[gb + 98764 >> 2] = fb + 105;
 HEAP32[gb + 98768 >> 2] = fb + 131;
 HEAP32[gb + 98772 >> 2] = fb + 106;
 HEAP32[gb + 98776 >> 2] = fb + 132;
 HEAP32[gb + 98780 >> 2] = fb + 1;
 HEAP32[gb + 98784 >> 2] = fb + 1;
 HEAP32[gb + 98788 >> 2] = fb + 1;
 HEAP32[gb + 98792 >> 2] = fb + 1;
 HEAP32[gb + 98796 >> 2] = fb + 1;
 HEAP32[gb + 98800 >> 2] = fb + 1;
 HEAP32[gb + 98804 >> 2] = fb + 1;
 HEAP32[gb + 98808 >> 2] = fb + 1;
 HEAP32[gb + 98812 >> 2] = fb + 1;
 HEAP32[gb + 98816 >> 2] = fb + 1;
 HEAP32[gb + 98820 >> 2] = fb + 1;
 HEAP32[gb + 98824 >> 2] = fb + 1;
 HEAP32[gb + 98828 >> 2] = fb + 1;
 HEAP32[gb + 98832 >> 2] = fb + 1;
 HEAP32[gb + 98836 >> 2] = fb + 1;
 HEAP32[gb + 98840 >> 2] = fb + 1;
 HEAP32[gb + 98844 >> 2] = fb + 1;
 HEAP32[gb + 98848 >> 2] = fb + 1;
 HEAP32[gb + 98852 >> 2] = fb + 1;
 HEAP32[gb + 98856 >> 2] = fb + 1;
 HEAP32[gb + 98860 >> 2] = fb + 1;
 HEAP32[gb + 98864 >> 2] = fb + 1063;
 HEAP32[gb + 98868 >> 2] = fb + 1064;
 HEAP32[gb + 98872 >> 2] = fb + 1065;
 HEAP32[gb + 98876 >> 2] = fb + 1377;
 HEAP32[gb + 98880 >> 2] = fb + 1378;
 HEAP32[gb + 98892 >> 2] = fb + 1381;
 HEAP32[gb + 98896 >> 2] = fb + 680;
 HEAP32[gb + 98900 >> 2] = fb + 456;
 HEAP32[gb + 98904 >> 2] = fb + 1382;
 HEAP32[gb + 98908 >> 2] = fb + 1383;
 HEAP32[gb + 98912 >> 2] = fb + 303;
 HEAP32[gb + 98916 >> 2] = fb + 692;
 HEAP32[gb + 98920 >> 2] = fb + 681;
 HEAP32[gb + 98924 >> 2] = fb + 1057;
 HEAP32[gb + 98928 >> 2] = fb + 682;
 HEAP32[gb + 98932 >> 2] = fb + 19;
 HEAP32[gb + 98936 >> 2] = fb + 197;
 HEAP32[gb + 98940 >> 2] = fb + 1058;
 HEAP32[gb + 98944 >> 2] = fb + 683;
 HEAP32[gb + 98948 >> 2] = fb + 1059;
 HEAP32[gb + 98952 >> 2] = fb + 684;
 HEAP32[gb + 98956 >> 2] = fb + 1060;
 HEAP32[gb + 98960 >> 2] = fb + 685;
 HEAP32[gb + 98964 >> 2] = fb + 1061;
 HEAP32[gb + 98968 >> 2] = fb + 686;
 HEAP32[gb + 98972 >> 2] = fb + 687;
 HEAP32[gb + 98976 >> 2] = fb + 1075;
 HEAP32[gb + 98980 >> 2] = fb + 201;
 HEAP32[gb + 98984 >> 2] = fb + 51;
 HEAP32[gb + 98988 >> 2] = fb + 1066;
 HEAP32[gb + 98992 >> 2] = fb + 198;
 HEAP32[gb + 98996 >> 2] = fb + 688;
 HEAP32[gb + 99e3 >> 2] = fb + 85;
 HEAP32[gb + 99004 >> 2] = fb + 689;
 HEAP32[gb + 99008 >> 2] = fb + 86;
 HEAP32[gb + 99012 >> 2] = fb + 1076;
 HEAP32[gb + 99016 >> 2] = fb + 1067;
 HEAP32[gb + 99020 >> 2] = fb + 104;
 HEAP32[gb + 99024 >> 2] = fb + 129;
 HEAP32[gb + 99028 >> 2] = fb + 130;
 HEAP32[gb + 99032 >> 2] = fb + 1068;
 HEAP32[gb + 99036 >> 2] = fb + 1069;
 HEAP32[gb + 99040 >> 2] = fb + 1070;
 HEAP32[gb + 99044 >> 2] = fb + 1071;
 HEAP32[gb + 99048 >> 2] = fb + 202;
 HEAP32[gb + 99052 >> 2] = fb + 1072;
 HEAP32[gb + 99056 >> 2] = fb + 203;
 HEAP32[gb + 99060 >> 2] = fb + 88;
 HEAP32[gb + 99064 >> 2] = fb + 89;
 HEAP32[gb + 99068 >> 2] = fb + 1077;
 HEAP32[gb + 99072 >> 2] = fb + 1078;
 HEAP32[gb + 99076 >> 2] = fb + 199;
 HEAP32[gb + 99080 >> 2] = fb + 1073;
 HEAP32[gb + 99084 >> 2] = fb + 200;
 HEAP32[gb + 99088 >> 2] = fb + 1074;
 HEAP32[gb + 99092 >> 2] = fb + 690;
 HEAP32[gb + 99096 >> 2] = fb + 691;
 HEAP32[gb + 99100 >> 2] = fb + 105;
 HEAP32[gb + 99104 >> 2] = fb + 131;
 HEAP32[gb + 99108 >> 2] = fb + 106;
 HEAP32[gb + 99112 >> 2] = fb + 132;
 HEAP32[gb + 99116 >> 2] = fb + 1079;
 runPostSets107();
}

function __ZN6Camera18RenderDepthTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE(i7, i8, i9, i10, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 4 | 0;
 i1 = i6;
 if ((HEAP16[gb + 1110520 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110520 | 0, i5);
  i2 = gb + 1110520 | 0;
 } else i2 = 0;
 i3 = HEAP32[gb + 1110520 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i3 | 0);
 i3 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 3;
 i4 = i7 + 1148 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = __Z22GetRenderBufferManagerv() | 0;
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i1, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, 2, 1, 0, 1, 0, 1) | 0;
 HEAP32[i4 >> 2] = i1;
 if (i1 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 376529 | 0);
  __ZN7Texture13SetFilterModeEi(HEAP32[i4 >> 2] | 0, 0);
  i1 = __Z12GetGfxDevicev() | 0;
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i4 >> 2] | 0, 0, -1, 0, 0);
  i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
  mftCall_viiifi(i11 | 0, i1 | 0, 7, i5 | 0, 1.0, 0);
  __Z15gpu_time_samplev();
  __ZNK6Camera28ExtractCameraRenderingParamsEv(i5, i7);
  __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i7, i10, i5, 0);
  __ZN15RenderNodeQueueC2ERK10MemLabelId(i5, gb + 64016 | 0);
  if (__Z12GetIVRDevicev() | 0) {
   i11 = __Z12GetIVRDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 56 >> 2] | 0, i11 | 0);
  }
  i12 = i7 + 1136 | 0;
  i11 = i7 + 4 | 0;
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i12, 0, i10, i5, gb + 1159956 | 0, HEAP32[i11 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i12, 0, i10, i5, gb + 1159956 | 0, HEAP32[i11 >> 2] | 0);
  __Z20RenderSceneDepthPassRK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext(i9, i8 + 1360 | 0, 0, i10);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, 0);
  i9 = i10 + 36 | 0;
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i9, gb + 1110556 | 0, HEAP32[i4 >> 2] | 0);
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i9, gb + 1110564 | 0, HEAP32[i4 >> 2] | 0);
  __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i12, 1, i10, i5, gb + 1159956 | 0, HEAP32[i11 >> 2] | 0);
  __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i12, 1, i10, i5, gb + 1159956 | 0, HEAP32[i11 >> 2] | 0);
  __ZN15RenderNodeQueueD2Ev(i5);
 }
 HEAP32[gb + 1163232 >> 2] = i3;
 i12 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 652 >> 2] | 0, i12 | 0);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN11TrailModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 12 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 276 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 280 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 284 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 285 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 286 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 287 >> 0] = i1;
 i1 = i6 + 288 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 292 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 448 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 712 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 292 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 448 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  i10 = i6 + 712 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i7 = (i4 - i3 | 0) / 40 | 0;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i2 = i3;
 i3 = i5;
 i10 = i4;
 if (i7 >>> 0 <= ((i1 - i5 | 0) / 40 | 0) >>> 0) {
  i6 = i9 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i5 | 0) / 40 | 0;
  i5 = i7 >>> 0 > i1 >>> 0;
  i1 = i5 ? i2 + (i1 * 40 | 0) | 0 : i4;
  if ((i2 | 0) == (i1 | 0)) i4 = i3; else {
   do {
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i3, i2);
    i9 = i3 + 32 | 0;
    i8 = i2 + 32 | 0;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP8[i9 + 4 >> 0] = HEAP8[i8 + 4 >> 0] | 0;
    i2 = i2 + 40 | 0;
    i3 = i3 + 40 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i4 = i3;
  }
  if (i5) {
   if ((i1 | 0) == (i10 | 0)) return;
   i2 = HEAP32[i6 >> 2] | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    i7 = i1 + 24 | 0;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i9 = i2 + 24 | 0;
    HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP8[i2 + 4 >> 0] = 0;
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i1);
    i9 = i2 + 32 | 0;
    i8 = i1 + 32 | 0;
    HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
    HEAP8[i9 + 4 >> 0] = HEAP8[i8 + 4 >> 0] | 0;
    i1 = i1 + 40 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 40 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) return;
  do {
   i2 = i1 + -40 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) i1 = i2; else if (!(HEAP32[i1 + -36 >> 2] | 0)) i1 = i2; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + -16 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   }
  } while ((i1 | 0) != (i4 | 0));
  return;
 }
 if (i5) {
  i6 = i9 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   i4 = i1;
   while (1) {
    i1 = i4 + -40 | 0;
    HEAP32[i6 >> 2] = i1;
    i5 = HEAP32[i1 >> 2] | 0;
    if (i5) if (HEAP32[i4 + -36 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i4 + -16 | 0);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i4 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i7 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else i3 = 0;
 i6 = (i1 - i3 | 0) / 40 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 53687091 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 107374182;
 if (i3 >>> 0 > 107374182) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i1 = __Znwj(i3 * 40 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 40 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i7 = i2 + 24 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1 + 24 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP8[i1 + 4 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i1, i2);
  i9 = i1 + 32 | 0;
  i8 = i2 + 32 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP8[i9 + 4 >> 0] = HEAP8[i8 + 4 >> 0] | 0;
  i2 = i2 + 40 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 40 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZN14DetailDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i12) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i5 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 52 | 0;
 HEAP32[i10 >> 2] = i6;
 i11 = i12 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i12 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN11DetailPatch8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 16 | 0;
 i7 = i8 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 136 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15DetailPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 136 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 40 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i12, i8 + 44 | 0, 0);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 60 | 0, i12);
 i1 = i8 + 76 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN12TreeDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i8 + 32 >> 2] | 0, i12);
 i6 = i8 + 104 | 0;
 i7 = i8 + 108 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 2;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i13;
 return;
}

function runPostSets84() {
 HEAP32[gb + 88580 >> 2] = fb + 36;
 HEAP32[gb + 88584 >> 2] = fb + 59;
 HEAP32[gb + 88588 >> 2] = fb + 37;
 HEAP32[gb + 88592 >> 2] = fb + 60;
 HEAP32[gb + 88596 >> 2] = fb + 38;
 HEAP32[gb + 88600 >> 2] = fb + 61;
 HEAP32[gb + 88604 >> 2] = fb + 39;
 HEAP32[gb + 88608 >> 2] = fb + 62;
 HEAP32[gb + 88612 >> 2] = fb + 509;
 HEAP32[gb + 88616 >> 2] = fb + 875;
 HEAP32[gb + 88620 >> 2] = fb + 510;
 HEAP32[gb + 88624 >> 2] = fb + 511;
 HEAP32[gb + 88628 >> 2] = fb + 63;
 HEAP32[gb + 88632 >> 2] = fb + 64;
 HEAP32[gb + 88636 >> 2] = fb + 876;
 HEAP32[gb + 88640 >> 2] = fb + 877;
 HEAP32[gb + 88644 >> 2] = fb + 40;
 HEAP32[gb + 88648 >> 2] = fb + 65;
 HEAP32[gb + 88652 >> 2] = fb + 41;
 HEAP32[gb + 88656 >> 2] = fb + 66;
 HEAP32[gb + 88660 >> 2] = fb + 42;
 HEAP32[gb + 88664 >> 2] = fb + 67;
 HEAP32[gb + 88668 >> 2] = fb + 878;
 HEAP32[gb + 88672 >> 2] = fb + 128;
 HEAP32[gb + 88676 >> 2] = fb + 512;
 HEAP32[gb + 88680 >> 2] = fb + 43;
 HEAP32[gb + 88684 >> 2] = fb + 68;
 HEAP32[gb + 88688 >> 2] = fb + 44;
 HEAP32[gb + 88692 >> 2] = fb + 69;
 HEAP32[gb + 88696 >> 2] = fb + 879;
 HEAP32[gb + 88700 >> 2] = fb + 68;
 HEAP32[gb + 88704 >> 2] = fb + 880;
 HEAP32[gb + 88708 >> 2] = fb + 881;
 HEAP32[gb + 88712 >> 2] = fb + 513;
 HEAP32[gb + 88716 >> 2] = fb + 231;
 HEAP32[gb + 88720 >> 2] = fb + 514;
 HEAP32[gb + 88724 >> 2] = fb + 1172;
 HEAP32[gb + 88728 >> 2] = fb + 882;
 HEAP32[gb + 88740 >> 2] = fb + 515;
 HEAP32[gb + 88744 >> 2] = fb + 69;
 HEAP32[gb + 88748 >> 2] = fb + 1173;
 HEAP32[gb + 88752 >> 2] = fb + 883;
 HEAP32[gb + 88756 >> 2] = fb + 884;
 HEAP32[gb + 88760 >> 2] = fb + 232;
 HEAP32[gb + 88764 >> 2] = fb + 516;
 HEAP32[gb + 88768 >> 2] = fb + 1174;
 HEAP32[gb + 88772 >> 2] = fb + 1175;
 HEAP32[gb + 88776 >> 2] = fb + 28;
 HEAP32[gb + 88788 >> 2] = fb + 71;
 HEAP32[gb + 88792 >> 2] = fb + 35;
 HEAP32[gb + 88804 >> 2] = fb + 1176;
 HEAP32[gb + 88808 >> 2] = fb + 517;
 HEAP32[gb + 88812 >> 2] = fb + 456;
 HEAP32[gb + 88816 >> 2] = fb + 1177;
 HEAP32[gb + 88820 >> 2] = fb + 1178;
 HEAP32[gb + 88824 >> 2] = fb + 233;
 HEAP32[gb + 88828 >> 2] = fb + 129;
 HEAP32[gb + 88832 >> 2] = fb + 130;
 HEAP32[gb + 88836 >> 2] = fb + 131;
 HEAP32[gb + 88840 >> 2] = fb + 132;
 HEAP32[gb + 88844 >> 2] = fb + 885;
 HEAP32[gb + 88848 >> 2] = fb + 886;
 HEAP32[gb + 88852 >> 2] = fb + 887;
 HEAP32[gb + 88856 >> 2] = fb + 7;
 HEAP32[gb + 88860 >> 2] = fb + 133;
 HEAP32[gb + 88864 >> 2] = fb + 888;
 HEAP32[gb + 88868 >> 2] = fb + 134;
 HEAP32[gb + 88872 >> 2] = fb + 518;
 HEAP32[gb + 88876 >> 2] = fb + 45;
 HEAP32[gb + 88880 >> 2] = fb + 70;
 HEAP32[gb + 88884 >> 2] = fb + 46;
 HEAP32[gb + 88888 >> 2] = fb + 71;
 HEAP32[gb + 88892 >> 2] = fb + 47;
 HEAP32[gb + 88896 >> 2] = fb + 72;
 HEAP32[gb + 88900 >> 2] = fb + 48;
 HEAP32[gb + 88904 >> 2] = fb + 73;
 HEAP32[gb + 88908 >> 2] = fb + 519;
 HEAP32[gb + 88912 >> 2] = fb + 889;
 HEAP32[gb + 88916 >> 2] = fb + 520;
 HEAP32[gb + 88920 >> 2] = fb + 521;
 HEAP32[gb + 88924 >> 2] = fb + 890;
 HEAP32[gb + 88928 >> 2] = fb + 891;
 HEAP32[gb + 88932 >> 2] = fb + 892;
 HEAP32[gb + 88936 >> 2] = fb + 135;
 HEAP32[gb + 88940 >> 2] = fb + 522;
 HEAP32[gb + 88944 >> 2] = fb + 49;
 HEAP32[gb + 88948 >> 2] = fb + 74;
 HEAP32[gb + 88952 >> 2] = fb + 893;
 HEAP32[gb + 88956 >> 2] = fb + 70;
 HEAP32[gb + 88960 >> 2] = fb + 894;
 HEAP32[gb + 88964 >> 2] = fb + 895;
 HEAP32[gb + 88968 >> 2] = fb + 523;
 HEAP32[gb + 88972 >> 2] = fb + 234;
 HEAP32[gb + 88976 >> 2] = fb + 524;
 HEAP32[gb + 88980 >> 2] = fb + 1179;
 HEAP32[gb + 88984 >> 2] = fb + 896;
 HEAP32[gb + 88996 >> 2] = fb + 525;
 HEAP32[gb + 89e3 >> 2] = fb + 71;
 HEAP32[gb + 89004 >> 2] = fb + 1180;
 HEAP32[gb + 89008 >> 2] = fb + 897;
 runPostSets85();
}

function runPostSets77() {
 HEAP32[gb + 84544 >> 2] = fb + 1;
 HEAP32[gb + 84548 >> 2] = fb + 2;
 HEAP32[gb + 84552 >> 2] = fb + 3;
 HEAP32[gb + 84556 >> 2] = fb + 8;
 HEAP32[gb + 84560 >> 2] = fb + 5;
 HEAP32[gb + 84564 >> 2] = fb + 6;
 HEAP32[gb + 84568 >> 2] = fb + 7;
 HEAP32[gb + 84572 >> 2] = fb + 9;
 HEAP32[gb + 84576 >> 2] = fb + 10;
 HEAP32[gb + 84580 >> 2] = fb + 11;
 HEAP32[gb + 84584 >> 2] = fb + 12;
 HEAP32[gb + 84588 >> 2] = fb + 13;
 HEAP32[gb + 84592 >> 2] = fb + 14;
 HEAP32[gb + 84596 >> 2] = fb + 15;
 HEAP32[gb + 84600 >> 2] = fb + 16;
 HEAP32[gb + 84604 >> 2] = fb + 10;
 HEAP32[gb + 84608 >> 2] = fb + 17;
 HEAP32[gb + 84612 >> 2] = fb + 18;
 HEAP32[gb + 84616 >> 2] = fb + 13;
 HEAP32[gb + 84620 >> 2] = fb + 14;
 HEAP32[gb + 84624 >> 2] = fb + 19;
 HEAP32[gb + 84628 >> 2] = fb + 1;
 HEAP32[gb + 84632 >> 2] = fb + 2;
 HEAP32[gb + 84636 >> 2] = fb + 3;
 HEAP32[gb + 84640 >> 2] = fb + 4;
 HEAP32[gb + 84644 >> 2] = fb + 5;
 HEAP32[gb + 84648 >> 2] = fb + 6;
 HEAP32[gb + 84652 >> 2] = fb + 7;
 HEAP32[gb + 84664 >> 2] = fb + 986;
 HEAP32[gb + 84668 >> 2] = fb + 1005;
 HEAP32[gb + 84672 >> 2] = fb + 115;
 HEAP32[gb + 84684 >> 2] = fb + 995;
 HEAP32[gb + 84688 >> 2] = fb + 1006;
 HEAP32[gb + 84692 >> 2] = fb + 88;
 HEAP32[gb + 84696 >> 2] = fb + 65;
 HEAP32[gb + 84700 >> 2] = fb + 18;
 HEAP32[gb + 84712 >> 2] = fb + 1007;
 HEAP32[gb + 84716 >> 2] = fb + 1008;
 HEAP32[gb + 84720 >> 2] = fb + 116;
 HEAP32[gb + 84732 >> 2] = fb + 1009;
 HEAP32[gb + 84736 >> 2] = fb + 1010;
 HEAP32[gb + 84740 >> 2] = fb + 28;
 HEAP32[gb + 84744 >> 2] = fb + 19;
 HEAP32[gb + 84748 >> 2] = fb + 781;
 HEAP32[gb + 84772 >> 2] = fb + 12;
 HEAP32[gb + 84776 >> 2] = fb + 988;
 HEAP32[gb + 84780 >> 2] = fb + 1011;
 HEAP32[gb + 84792 >> 2] = fb + 13;
 HEAP32[gb + 84796 >> 2] = fb + 1012;
 HEAP32[gb + 84800 >> 2] = fb + 1013;
 HEAP32[gb + 84812 >> 2] = fb + 1009;
 HEAP32[gb + 84816 >> 2] = fb + 1014;
 HEAP32[gb + 84820 >> 2] = fb + 29;
 HEAP32[gb + 84824 >> 2] = fb + 20;
 HEAP32[gb + 84828 >> 2] = fb + 782;
 HEAP32[gb + 84840 >> 2] = fb + 1009;
 HEAP32[gb + 84844 >> 2] = fb + 1015;
 HEAP32[gb + 84848 >> 2] = fb + 30;
 HEAP32[gb + 84852 >> 2] = fb + 21;
 HEAP32[gb + 84856 >> 2] = fb + 783;
 HEAP32[gb + 84868 >> 2] = fb + 1016;
 HEAP32[gb + 84872 >> 2] = fb + 1017;
 HEAP32[gb + 84876 >> 2] = fb + 117;
 HEAP32[gb + 85328 >> 2] = fb + 986;
 HEAP32[gb + 85332 >> 2] = fb + 1018;
 HEAP32[gb + 85336 >> 2] = fb + 118;
 HEAP32[gb + 85348 >> 2] = fb + 1009;
 HEAP32[gb + 85352 >> 2] = fb + 1019;
 HEAP32[gb + 85356 >> 2] = fb + 31;
 HEAP32[gb + 85360 >> 2] = fb + 22;
 HEAP32[gb + 85364 >> 2] = fb + 784;
 HEAP32[gb + 85376 >> 2] = fb + 14;
 HEAP32[gb + 85380 >> 2] = fb + 1020;
 HEAP32[gb + 85384 >> 2] = fb + 1021;
 HEAP32[gb + 85396 >> 2] = fb + 56;
 HEAP32[gb + 85400 >> 2] = fb + 1022;
 HEAP32[gb + 85404 >> 2] = fb + 1023;
 HEAP32[gb + 85408 >> 2] = fb + 119;
 HEAP32[gb + 85420 >> 2] = fb + 120;
 HEAP32[gb + 85424 >> 2] = fb + 992;
 HEAP32[gb + 85428 >> 2] = fb + 1024;
 HEAP32[gb + 85432 >> 2] = fb + 1025;
 HEAP32[gb + 85444 >> 2] = fb + 57;
 HEAP32[gb + 85448 >> 2] = fb + 1026;
 HEAP32[gb + 85452 >> 2] = fb + 1027;
 HEAP32[gb + 85456 >> 2] = fb + 121;
 HEAP32[gb + 85468 >> 2] = fb + 122;
 HEAP32[gb + 85472 >> 2] = fb + 992;
 HEAP32[gb + 85476 >> 2] = fb + 1028;
 HEAP32[gb + 85480 >> 2] = fb + 1029;
 HEAP32[gb + 85492 >> 2] = fb + 1009;
 HEAP32[gb + 85496 >> 2] = fb + 1030;
 HEAP32[gb + 85500 >> 2] = fb + 32;
 HEAP32[gb + 85504 >> 2] = fb + 23;
 HEAP32[gb + 85508 >> 2] = fb + 785;
 HEAP32[gb + 85520 >> 2] = fb + 1009;
 HEAP32[gb + 85524 >> 2] = fb + 1031;
 HEAP32[gb + 85528 >> 2] = fb + 33;
 HEAP32[gb + 85532 >> 2] = fb + 24;
 HEAP32[gb + 85536 >> 2] = fb + 786;
 runPostSets78();
}

function runPostSets37() {
 HEAP32[gb + 56104 >> 2] = fb + 258;
 HEAP32[gb + 56108 >> 2] = fb + 103;
 HEAP32[gb + 56112 >> 2] = fb + 101;
 HEAP32[gb + 56116 >> 2] = fb + 62;
 HEAP32[gb + 56120 >> 2] = fb + 28;
 HEAP32[gb + 56124 >> 2] = fb + 63;
 HEAP32[gb + 56128 >> 2] = fb + 29;
 HEAP32[gb + 56132 >> 2] = fb + 34;
 HEAP32[gb + 56136 >> 2] = fb + 419;
 HEAP32[gb + 56140 >> 2] = fb + 420;
 HEAP32[gb + 56144 >> 2] = fb + 421;
 HEAP32[gb + 56148 >> 2] = fb + 422;
 HEAP32[gb + 56152 >> 2] = fb + 423;
 HEAP32[gb + 56156 >> 2] = fb + 424;
 HEAP32[gb + 56160 >> 2] = fb + 36;
 HEAP32[gb + 56164 >> 2] = fb + 214;
 HEAP32[gb + 56168 >> 2] = fb + 360;
 HEAP32[gb + 56172 >> 2] = fb + 94;
 HEAP32[gb + 56176 >> 2] = fb + 109;
 HEAP32[gb + 56180 >> 2] = fb + 105;
 HEAP32[gb + 56184 >> 2] = fb + 106;
 HEAP32[gb + 56188 >> 2] = fb + 110;
 HEAP32[gb + 56208 >> 2] = fb + 432;
 HEAP32[gb + 56212 >> 2] = fb + 433;
 HEAP32[gb + 56224 >> 2] = fb + 434;
 HEAP32[gb + 56228 >> 2] = fb + 435;
 HEAP32[gb + 56232 >> 2] = fb + 436;
 HEAP32[gb + 56236 >> 2] = fb + 425;
 HEAP32[gb + 56240 >> 2] = fb + 16;
 HEAP32[gb + 56244 >> 2] = fb + 39;
 HEAP32[gb + 56248 >> 2] = fb + 437;
 HEAP32[gb + 56252 >> 2] = fb + 19;
 HEAP32[gb + 56256 >> 2] = fb + 259;
 HEAP32[gb + 56260 >> 2] = fb + 31;
 HEAP32[gb + 56264 >> 2] = fb + 27;
 HEAP32[gb + 56268 >> 2] = fb + 62;
 HEAP32[gb + 56272 >> 2] = fb + 28;
 HEAP32[gb + 56276 >> 2] = fb + 63;
 HEAP32[gb + 56280 >> 2] = fb + 29;
 HEAP32[gb + 56284 >> 2] = fb + 34;
 HEAP32[gb + 56288 >> 2] = fb + 426;
 HEAP32[gb + 56292 >> 2] = fb + 427;
 HEAP32[gb + 56296 >> 2] = fb + 428;
 HEAP32[gb + 56300 >> 2] = fb + 429;
 HEAP32[gb + 56304 >> 2] = fb + 430;
 HEAP32[gb + 56308 >> 2] = fb + 431;
 HEAP32[gb + 56312 >> 2] = fb + 36;
 HEAP32[gb + 56324 >> 2] = fb + 438;
 HEAP32[gb + 56328 >> 2] = fb + 439;
 HEAP32[gb + 56332 >> 2] = fb + 440;
 HEAP32[gb + 56336 >> 2] = fb + 432;
 HEAP32[gb + 56340 >> 2] = fb + 16;
 HEAP32[gb + 56344 >> 2] = fb + 364;
 HEAP32[gb + 56348 >> 2] = fb + 40;
 HEAP32[gb + 56352 >> 2] = fb + 349;
 HEAP32[gb + 56356 >> 2] = fb + 260;
 HEAP32[gb + 56360 >> 2] = fb + 103;
 HEAP32[gb + 56364 >> 2] = fb + 101;
 HEAP32[gb + 56368 >> 2] = fb + 62;
 HEAP32[gb + 56372 >> 2] = fb + 28;
 HEAP32[gb + 56376 >> 2] = fb + 63;
 HEAP32[gb + 56380 >> 2] = fb + 29;
 HEAP32[gb + 56384 >> 2] = fb + 34;
 HEAP32[gb + 56388 >> 2] = fb + 433;
 HEAP32[gb + 56392 >> 2] = fb + 434;
 HEAP32[gb + 56396 >> 2] = fb + 435;
 HEAP32[gb + 56400 >> 2] = fb + 436;
 HEAP32[gb + 56404 >> 2] = fb + 437;
 HEAP32[gb + 56408 >> 2] = fb + 438;
 HEAP32[gb + 56412 >> 2] = fb + 36;
 HEAP32[gb + 56416 >> 2] = fb + 104;
 HEAP32[gb + 56420 >> 2] = fb + 336;
 HEAP32[gb + 56424 >> 2] = fb + 94;
 HEAP32[gb + 56428 >> 2] = fb + 337;
 HEAP32[gb + 56432 >> 2] = fb + 205;
 HEAP32[gb + 56436 >> 2] = fb + 206;
 HEAP32[gb + 56440 >> 2] = fb + 338;
 HEAP32[gb + 56444 >> 2] = fb + 350;
 HEAP32[gb + 56448 >> 2] = fb + 351;
 HEAP32[gb + 56452 >> 2] = fb + 207;
 HEAP32[gb + 56456 >> 2] = fb + 441;
 HEAP32[gb + 56460 >> 2] = fb + 442;
 HEAP32[gb + 56464 >> 2] = fb + 261;
 HEAP32[gb + 56468 >> 2] = fb + 75;
 HEAP32[gb + 56472 >> 2] = fb + 69;
 HEAP32[gb + 56476 >> 2] = fb + 366;
 HEAP32[gb + 56480 >> 2] = fb + 355;
 HEAP32[gb + 56484 >> 2] = fb + 356;
 HEAP32[gb + 56488 >> 2] = fb + 32;
 HEAP32[gb + 56492 >> 2] = fb + 443;
 HEAP32[gb + 56496 >> 2] = fb + 444;
 HEAP32[gb + 56508 >> 2] = fb + 445;
 HEAP32[gb + 56512 >> 2] = fb + 446;
 HEAP32[gb + 56516 >> 2] = fb + 33;
 HEAP32[gb + 56520 >> 2] = fb + 102;
 HEAP32[gb + 56524 >> 2] = fb + 359;
 HEAP32[gb + 56528 >> 2] = fb + 360;
 HEAP32[gb + 56532 >> 2] = fb + 209;
 HEAP32[gb + 56536 >> 2] = fb + 262;
 HEAP32[gb + 56540 >> 2] = fb + 76;
 runPostSets38();
}

function __ZN16SpriteRenderData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10 + 4 | 0, i11);
 i7 = i10 + 56 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i2 + 20 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i3;
 i12 = i11 + 16 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i12 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + (i5 * 20 | 0) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i12 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i2, 4);
   i5 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i12 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i2, 4);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i8 << 1) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i12 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i11, i10 + 8 | 0, gb + 410551 | 0, 0);
 i1 = i10 + 24 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i12 = i10 + 36 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i11, i12, gb + 410593 | 0, 0);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i12 = i10 + 36 | 0;
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i11, i12, gb + 410593 | 0, 0);
  STACKTOP = i13;
  return;
 }
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i26, i27, i1) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 28 | 0;
 i21 = i25 + 24 | 0;
 i22 = i25;
 i23 = i27 + 8 | 0;
 HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i26, gb + 1041885 | 0, gb + 1041885 | 0, i21) | 0)) {
  STACKTOP = i25;
  return;
 }
 HEAP32[i22 >> 2] = -1;
 i24 = i22 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnvC2Ev(i24);
 i12 = i27 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i27, HEAP32[i12 >> 2] | 0);
 HEAP32[i23 >> 2] = 0;
 HEAP32[i27 >> 2] = i12;
 HEAP32[i12 >> 2] = 0;
 if ((HEAP32[i21 >> 2] | 0) > 0) {
  i13 = HEAP32[gb + 37152 >> 2] | 0;
  i14 = i22 + 8 | 0;
  i15 = i22 + 12 | 0;
  i16 = i22 + 16 | 0;
  i17 = i22 + 20 | 0;
  i18 = i12;
  i19 = i27 + 4 | 0;
  i11 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i26, gb + 1041891 | 0, i13, i20, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i22, i26); else {
     i1 = HEAP32[i20 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i22 | 0, i26 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i26);
   }
   i5 = HEAP32[i22 >> 2] | 0;
   i6 = HEAP32[i24 >> 2] | 0;
   i7 = HEAP32[i14 >> 2] | 0;
   i8 = HEAP32[i15 >> 2] | 0;
   i9 = HEAP32[i16 >> 2] | 0;
   i10 = HEAP32[i17 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   do if (!i1) {
    HEAP32[i20 >> 2] = i12;
    i4 = i18;
    i3 = i12;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 14;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 19;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 18;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 14) {
     HEAP32[i20 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 18) {
     HEAP32[i20 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i2 | 0) == 19) {
     HEAP32[i20 >> 2] = i1;
     i4 = i1;
     i3 = i20;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(40) | 0;
    HEAP32[i1 + 16 >> 2] = i5;
    HEAP32[i1 + 20 >> 2] = i6;
    HEAP32[i1 + 24 >> 2] = i7;
    HEAP32[i1 + 28 >> 2] = i8;
    HEAP32[i1 + 32 >> 2] = i9;
    HEAP32[i1 + 36 >> 2] = i10;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i27 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i27 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i19 >> 2] | 0, i1);
    HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) < (HEAP32[i21 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i26);
 STACKTOP = i25;
 return;
}

function __ZN5physx12NpConstraint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i9 >> 2] = HEAP32[gb + 122916 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 122916 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 122916 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 122916 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 122916 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 122916 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 122916 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 122916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = gb + 754692;
 HEAP32[i8 + 4 >> 2] = gb + 827530;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 132;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 1;
 HEAP32[i8 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 122948 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122948 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122948 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122948 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122948 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122948 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122948 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122980 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122980 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122980 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122980 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122980 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122980 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122980 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123012 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123012 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123012 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123012 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123012 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123012 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123012 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123044 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123044 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123044 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123044 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123044 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123044 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123044 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123076 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123076 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123076 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123076 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123076 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123076 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123076 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN11AudioSource27ForceRolloffCurveEvaluationEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 48 | 0;
 i11 = i15 + 32 | 0;
 i10 = i15 + 16 | 0;
 i9 = i15;
 i13 = i15 + 76 | 0;
 i12 = i15 + 64 | 0;
 i1 = HEAP32[i5 + 432 >> 2] | 0;
 i6 = i5 + 428 | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  i7 = i13 + 11 | 0;
  i8 = i13 + 11 | 0;
  do {
   i4 = i1 + 8 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 12 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
    i1 = __ZN20SoundChannelInstance20get3DConeOrientationEP11FMOD_VECTOR(i1, i12) | 0;
    if (i1 | 0) {
     i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
     HEAP32[i9 >> 2] = gb + 865340;
     HEAP32[i9 + 4 >> 2] = 101;
     HEAP32[i9 + 8 >> 2] = gb + 865420;
     HEAP32[i9 + 12 >> 2] = i3;
     __Z6FormatPKcz(i13, gb + 883334 | 0, i9);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    }
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
    i1 = __ZN20SoundChannelInstance20set3DConeOrientationEP11FMOD_VECTOR(i1, i12) | 0;
    if (i1 | 0) {
     i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
     HEAP32[i10 >> 2] = gb + 865340;
     HEAP32[i10 + 4 >> 2] = 102;
     HEAP32[i10 + 8 >> 2] = gb + 865464;
     HEAP32[i10 + 12 >> 2] = i4;
     __Z6FormatPKcz(i13, gb + 883334 | 0, i10);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    }
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i6 | 0));
 }
 i2 = i5 + 456 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZN20SoundChannelInstance20get3DConeOrientationEP11FMOD_VECTOR(i1, i12) | 0;
 if (i1 | 0) {
  i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
  HEAP32[i11 >> 2] = gb + 865340;
  HEAP32[i11 + 4 >> 2] = 108;
  HEAP32[i11 + 8 >> 2] = gb + 865508;
  HEAP32[i11 + 12 >> 2] = i10;
  __Z6FormatPKcz(i13, gb + 883334 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZN20SoundChannelInstance20set3DConeOrientationEP11FMOD_VECTOR(i1, i12) | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i12 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
 HEAP32[i14 >> 2] = gb + 865340;
 HEAP32[i14 + 4 >> 2] = 109;
 HEAP32[i14 + 8 >> 2] = gb + 865547;
 HEAP32[i14 + 12 >> 2] = i12;
 __Z6FormatPKcz(i13, gb + 883334 | 0, i14);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i15;
 return;
}

function runPostSets93() {
 HEAP32[gb + 93228 >> 2] = fb + 91;
 HEAP32[gb + 93232 >> 2] = fb + 266;
 HEAP32[gb + 93236 >> 2] = fb + 169;
 HEAP32[gb + 93240 >> 2] = fb + 961;
 HEAP32[gb + 93244 >> 2] = fb + 593;
 HEAP32[gb + 93256 >> 2] = fb + 1306;
 HEAP32[gb + 93260 >> 2] = fb + 1307;
 HEAP32[gb + 93272 >> 2] = fb + 1308;
 HEAP32[gb + 93276 >> 2] = fb + 1309;
 HEAP32[gb + 93288 >> 2] = fb + 1310;
 HEAP32[gb + 93292 >> 2] = fb + 594;
 HEAP32[gb + 93296 >> 2] = fb + 456;
 HEAP32[gb + 93300 >> 2] = fb + 1311;
 HEAP32[gb + 93304 >> 2] = fb + 1312;
 HEAP32[gb + 93308 >> 2] = fb + 267;
 HEAP32[gb + 93312 >> 2] = fb + 595;
 HEAP32[gb + 93316 >> 2] = fb + 66;
 HEAP32[gb + 93320 >> 2] = fb + 92;
 HEAP32[gb + 93324 >> 2] = fb + 67;
 HEAP32[gb + 93328 >> 2] = fb + 93;
 HEAP32[gb + 93332 >> 2] = fb + 68;
 HEAP32[gb + 93336 >> 2] = fb + 94;
 HEAP32[gb + 93340 >> 2] = fb + 170;
 HEAP32[gb + 93344 >> 2] = fb + 962;
 HEAP32[gb + 93348 >> 2] = fb + 596;
 HEAP32[gb + 93352 >> 2] = fb + 963;
 HEAP32[gb + 93356 >> 2] = fb + 597;
 HEAP32[gb + 93360 >> 2] = fb + 964;
 HEAP32[gb + 93364 >> 2] = fb + 598;
 HEAP32[gb + 93368 >> 2] = fb + 1313;
 HEAP32[gb + 93372 >> 2] = fb + 965;
 HEAP32[gb + 93376 >> 2] = fb + 966;
 HEAP32[gb + 93388 >> 2] = fb + 1314;
 HEAP32[gb + 93392 >> 2] = fb + 1315;
 HEAP32[gb + 93396 >> 2] = fb + 1316;
 HEAP32[gb + 93408 >> 2] = fb + 1317;
 HEAP32[gb + 93412 >> 2] = fb + 1318;
 HEAP32[gb + 93416 >> 2] = fb + 1319;
 HEAP32[gb + 93420 >> 2] = fb + 599;
 HEAP32[gb + 93424 >> 2] = fb + 600;
 HEAP32[gb + 93428 >> 2] = fb + 601;
 HEAP32[gb + 93432 >> 2] = fb + 602;
 HEAP32[gb + 93436 >> 2] = fb + 149;
 HEAP32[gb + 93440 >> 2] = fb + 603;
 HEAP32[gb + 93444 >> 2] = fb + 268;
 HEAP32[gb + 93448 >> 2] = fb + 604;
 HEAP32[gb + 93452 >> 2] = fb + 79;
 HEAP32[gb + 93456 >> 2] = fb + 269;
 HEAP32[gb + 93460 >> 2] = fb + 270;
 HEAP32[gb + 93464 >> 2] = fb + 605;
 HEAP32[gb + 93468 >> 2] = fb + 80;
 HEAP32[gb + 93472 >> 2] = fb + 271;
 HEAP32[gb + 93476 >> 2] = fb + 606;
 HEAP32[gb + 93480 >> 2] = fb + 81;
 HEAP32[gb + 93484 >> 2] = fb + 272;
 HEAP32[gb + 93488 >> 2] = fb + 273;
 HEAP32[gb + 93492 >> 2] = fb + 607;
 HEAP32[gb + 93496 >> 2] = fb + 150;
 HEAP32[gb + 93500 >> 2] = fb + 274;
 HEAP32[gb + 93504 >> 2] = fb + 608;
 HEAP32[gb + 93508 >> 2] = fb + 82;
 HEAP32[gb + 93512 >> 2] = fb + 275;
 HEAP32[gb + 93516 >> 2] = fb + 276;
 HEAP32[gb + 93520 >> 2] = fb + 151;
 HEAP32[gb + 93524 >> 2] = fb + 152;
 HEAP32[gb + 93528 >> 2] = fb + 50;
 HEAP32[gb + 93532 >> 2] = fb + 75;
 HEAP32[gb + 93536 >> 2] = fb + 609;
 HEAP32[gb + 93540 >> 2] = fb + 83;
 HEAP32[gb + 93544 >> 2] = fb + 76;
 HEAP32[gb + 93548 >> 2] = fb + 610;
 HEAP32[gb + 93552 >> 2] = fb + 1;
 HEAP32[gb + 93556 >> 2] = fb + 611;
 HEAP32[gb + 93560 >> 2] = fb + 84;
 HEAP32[gb + 93564 >> 2] = fb + 75;
 HEAP32[gb + 93568 >> 2] = fb + 967;
 HEAP32[gb + 93572 >> 2] = fb + 76;
 HEAP32[gb + 93576 >> 2] = fb + 77;
 HEAP32[gb + 93580 >> 2] = fb + 612;
 HEAP32[gb + 93584 >> 2] = fb + 613;
 HEAP32[gb + 93596 >> 2] = fb + 1;
 HEAP32[gb + 93600 >> 2] = fb + 594;
 HEAP32[gb + 93604 >> 2] = fb + 456;
 HEAP32[gb + 93608 >> 2] = fb + 1270;
 HEAP32[gb + 93612 >> 2] = fb + 1320;
 HEAP32[gb + 93616 >> 2] = fb + 267;
 HEAP32[gb + 93620 >> 2] = fb + 1;
 HEAP32[gb + 93624 >> 2] = fb + 1;
 HEAP32[gb + 93628 >> 2] = fb + 1;
 HEAP32[gb + 93632 >> 2] = fb + 1;
 HEAP32[gb + 93636 >> 2] = fb + 1;
 HEAP32[gb + 93640 >> 2] = fb + 1;
 HEAP32[gb + 93644 >> 2] = fb + 1;
 HEAP32[gb + 93648 >> 2] = fb + 1;
 HEAP32[gb + 93652 >> 2] = fb + 1;
 HEAP32[gb + 93656 >> 2] = fb + 1;
 HEAP32[gb + 93660 >> 2] = fb + 1;
 HEAP32[gb + 93664 >> 2] = fb + 1;
 HEAP32[gb + 93668 >> 2] = fb + 1;
 HEAP32[gb + 93672 >> 2] = fb + 1;
 runPostSets94();
}

function runPostSets82() {
 HEAP32[gb + 87700 >> 2] = fb + 101;
 HEAP32[gb + 87704 >> 2] = fb + 102;
 HEAP32[gb + 87708 >> 2] = fb + 103;
 HEAP32[gb + 87712 >> 2] = fb + 104;
 HEAP32[gb + 87716 >> 2] = fb + 834;
 HEAP32[gb + 87720 >> 2] = fb + 835;
 HEAP32[gb + 87724 >> 2] = fb + 836;
 HEAP32[gb + 87728 >> 2] = fb + 3;
 HEAP32[gb + 87732 >> 2] = fb + 105;
 HEAP32[gb + 87736 >> 2] = fb + 837;
 HEAP32[gb + 87740 >> 2] = fb + 106;
 HEAP32[gb + 87744 >> 2] = fb + 479;
 HEAP32[gb + 87748 >> 2] = fb + 15;
 HEAP32[gb + 87752 >> 2] = fb + 35;
 HEAP32[gb + 87756 >> 2] = fb + 16;
 HEAP32[gb + 87760 >> 2] = fb + 36;
 HEAP32[gb + 87764 >> 2] = fb + 17;
 HEAP32[gb + 87768 >> 2] = fb + 37;
 HEAP32[gb + 87772 >> 2] = fb + 18;
 HEAP32[gb + 87776 >> 2] = fb + 38;
 HEAP32[gb + 87780 >> 2] = fb + 480;
 HEAP32[gb + 87784 >> 2] = fb + 838;
 HEAP32[gb + 87788 >> 2] = fb + 481;
 HEAP32[gb + 87792 >> 2] = fb + 482;
 HEAP32[gb + 87796 >> 2] = fb + 39;
 HEAP32[gb + 87800 >> 2] = fb + 19;
 HEAP32[gb + 87804 >> 2] = fb + 40;
 HEAP32[gb + 87808 >> 2] = fb + 20;
 HEAP32[gb + 87812 >> 2] = fb + 41;
 HEAP32[gb + 87816 >> 2] = fb + 21;
 HEAP32[gb + 87820 >> 2] = fb + 42;
 HEAP32[gb + 87824 >> 2] = fb + 22;
 HEAP32[gb + 87828 >> 2] = fb + 43;
 HEAP32[gb + 87832 >> 2] = fb + 23;
 HEAP32[gb + 87836 >> 2] = fb + 44;
 HEAP32[gb + 87840 >> 2] = fb + 839;
 HEAP32[gb + 87844 >> 2] = fb + 107;
 HEAP32[gb + 87848 >> 2] = fb + 483;
 HEAP32[gb + 87852 >> 2] = fb + 840;
 HEAP32[gb + 87856 >> 2] = fb + 62;
 HEAP32[gb + 87860 >> 2] = fb + 841;
 HEAP32[gb + 87864 >> 2] = fb + 842;
 HEAP32[gb + 87868 >> 2] = fb + 484;
 HEAP32[gb + 87872 >> 2] = fb + 222;
 HEAP32[gb + 87876 >> 2] = fb + 485;
 HEAP32[gb + 87880 >> 2] = fb + 1147;
 HEAP32[gb + 87884 >> 2] = fb + 843;
 HEAP32[gb + 87896 >> 2] = fb + 486;
 HEAP32[gb + 87900 >> 2] = fb + 63;
 HEAP32[gb + 87904 >> 2] = fb + 1148;
 HEAP32[gb + 87908 >> 2] = fb + 844;
 HEAP32[gb + 87912 >> 2] = fb + 845;
 HEAP32[gb + 87916 >> 2] = fb + 223;
 HEAP32[gb + 87920 >> 2] = fb + 487;
 HEAP32[gb + 87924 >> 2] = fb + 1149;
 HEAP32[gb + 87928 >> 2] = fb + 1150;
 HEAP32[gb + 87932 >> 2] = fb + 25;
 HEAP32[gb + 87944 >> 2] = fb + 68;
 HEAP32[gb + 87948 >> 2] = fb + 32;
 HEAP32[gb + 87960 >> 2] = fb + 1151;
 HEAP32[gb + 87964 >> 2] = fb + 488;
 HEAP32[gb + 87968 >> 2] = fb + 456;
 HEAP32[gb + 87972 >> 2] = fb + 1152;
 HEAP32[gb + 87976 >> 2] = fb + 1153;
 HEAP32[gb + 87980 >> 2] = fb + 224;
 HEAP32[gb + 87984 >> 2] = fb + 108;
 HEAP32[gb + 87988 >> 2] = fb + 109;
 HEAP32[gb + 87992 >> 2] = fb + 110;
 HEAP32[gb + 87996 >> 2] = fb + 111;
 HEAP32[gb + 88e3 >> 2] = fb + 846;
 HEAP32[gb + 88004 >> 2] = fb + 847;
 HEAP32[gb + 88008 >> 2] = fb + 848;
 HEAP32[gb + 88012 >> 2] = fb + 4;
 HEAP32[gb + 88016 >> 2] = fb + 112;
 HEAP32[gb + 88020 >> 2] = fb + 849;
 HEAP32[gb + 88024 >> 2] = fb + 113;
 HEAP32[gb + 88028 >> 2] = fb + 489;
 HEAP32[gb + 88032 >> 2] = fb + 24;
 HEAP32[gb + 88036 >> 2] = fb + 45;
 HEAP32[gb + 88040 >> 2] = fb + 25;
 HEAP32[gb + 88044 >> 2] = fb + 46;
 HEAP32[gb + 88048 >> 2] = fb + 26;
 HEAP32[gb + 88052 >> 2] = fb + 47;
 HEAP32[gb + 88056 >> 2] = fb + 27;
 HEAP32[gb + 88060 >> 2] = fb + 48;
 HEAP32[gb + 88064 >> 2] = fb + 490;
 HEAP32[gb + 88068 >> 2] = fb + 850;
 HEAP32[gb + 88072 >> 2] = fb + 491;
 HEAP32[gb + 88076 >> 2] = fb + 492;
 HEAP32[gb + 88080 >> 2] = fb + 28;
 HEAP32[gb + 88084 >> 2] = fb + 49;
 HEAP32[gb + 88088 >> 2] = fb + 29;
 HEAP32[gb + 88092 >> 2] = fb + 50;
 HEAP32[gb + 88096 >> 2] = fb + 851;
 HEAP32[gb + 88100 >> 2] = fb + 64;
 HEAP32[gb + 88104 >> 2] = fb + 852;
 HEAP32[gb + 88108 >> 2] = fb + 853;
 HEAP32[gb + 88112 >> 2] = fb + 493;
 HEAP32[gb + 88116 >> 2] = fb + 225;
 HEAP32[gb + 88120 >> 2] = fb + 494;
 runPostSets83();
}

function __ZN20OverlapCircleQuery2D13ReportFixtureEP9b2Fixture(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 12 | 0;
 i7 = i12;
 if (HEAP8[i9 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 i4 = HEAP32[i9 + 60 >> 2] | 0;
 i11 = i4;
 if ((i4 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 if (!i4) {
  STACKTOP = i12;
  return 1;
 }
 i6 = i4 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 if (!(1 << HEAP32[i1 + 48 >> 2] & HEAP32[i8 + 4 >> 2])) {
  STACKTOP = i12;
  return 1;
 }
 f13 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 if (!(!(f14 > f15) & !(f14 < f13))) {
  STACKTOP = i12;
  return 1;
 }
 i10 = i8 + 80 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 L20 : do if (i3 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break L20;
  }
  __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f15 > Math_fround(HEAPF32[i7 + 8 >> 2]))) {
   STACKTOP = i12;
   return 1;
  }
  HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + (i1 << 2) >> 2] = i11;
  STACKTOP = i12;
  return 1;
 } while (0);
 L31 : do if (!(HEAP8[i8 + 84 >> 0] | 0)) {
  i5 = i8 + 28 | 0;
  i6 = HEAP32[i9 + 32 >> 2] | 0;
  i4 = i8 + 64 | 0;
  i2 = (HEAP32[i9 + 28 >> 2] | 0) + 12 | 0;
  if ((HEAP32[i6 + 4 >> 2] | 0) != 3) {
   if (__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, 0, i4, i2) | 0) break;
   STACKTOP = i12;
   return 1;
  }
  i3 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   STACKTOP = i12;
   return 1;
  }
  do {
   if (__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, i1, i4, i2) | 0) break L31;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i12;
  return 1;
 } else {
  i7 = HEAP32[i9 + 32 >> 2] | 0;
  if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, (HEAP32[i9 + 28 >> 2] | 0) + 12 | 0, i8 + 20 | 0) | 0)) {
   STACKTOP = i12;
   return 1;
  }
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
 STACKTOP = i12;
 return 1;
}

function __ZN9ShaderLab20SerializedSubProgram15AddTextureParamEPKcii16TextureDimension(i7, i1, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 48 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i9 = i7 + 132 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, _strlen(i1) | 0);
 i3 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i8 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i8 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i12 + 20 >> 2] = i4;
 HEAP32[i12 + 24 >> 2] = i5;
 HEAP32[i12 + 28 >> 2] = i6;
 i5 = i7 + 136 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i7 + 140 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i12);
  i1 = i12 + 11 | 0;
 } else {
  i1 = i12 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  i4 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i10 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i10 = 13;
   }
  } else i10 = 11;
  if ((i10 | 0) == 11) {
   i9 = i4 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i10 = 13;
  }
  if ((i10 | 0) == 13) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  STACKTOP = i14;
  return;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_15PxPlaneGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i9, i5, i8) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = i10 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = gb + 673012;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 + 4 >> 2] = i11;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i7;
  i11 = HEAP32[i4 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 HEAP32[i6 >> 2] = 1;
 __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_15PxPlaneGeometryE(i5, HEAP32[i9 + 8 >> 2] | 0, i6) | 0;
 i3 = i9 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i8 | 0, HEAP32[i1 + 20 >> 2] | 0);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation12IsCrc32ValidEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 32 | 0;
 i16 = i19 + 16 | 0;
 i9 = i19 + 8 | 0;
 i8 = i19;
 i18 = i19 + 36 | 0;
 i15 = i19 + 56 | 0;
 i10 = i14 + 80 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i13 = i14 + 88 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  i18 = 1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i1 = __Z8CRCBeginv() | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i3 + 108 >> 2] | 0;
 i3 = HEAP32[i3 + 104 >> 2] | 0;
 i6 = i3;
 if ((i2 | 0) == (i3 | 0)) {
  i3 = 0;
  i2 = 0;
 } else {
  i5 = (i2 - i3 | 0) / 12 | 0;
  i4 = 0;
  i3 = 0;
  i2 = 0;
  do {
   i3 = _i64Add(HEAP32[i6 + (i4 * 12 | 0) >> 2] | 0, 0, i3 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i5 >>> 0);
 }
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i18 >> 2] = 0;
 i7 = i18 + 12 | 0;
 i11 = i18 + 16 | 0;
 i12 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i6 = i9;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i7 >> 2] = 32768;
 HEAP32[i11 >> 2] = 32768;
 i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 32768, 1, i12, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i18 >> 2] = i4;
 L12 : do if (!((i3 | 0) == 0 & (i2 | 0) == 0)) {
  i6 = 0;
  i5 = 0;
  while (1) {
   i21 = _i64Subtract(i3 | 0, i2 | 0, i6 | 0, i5 | 0) | 0;
   i8 = getTempRet0() | 0;
   i22 = HEAP32[i7 >> 2] | 0;
   i20 = 0 < i8 >>> 0 | 0 == (i8 | 0) & i22 >>> 0 < i21 >>> 0;
   i8 = (__ZN20ArchiveStorageReader4ReadEyyPvPy(HEAP32[i10 >> 2] | 0, i6, i5, i20 ? i22 : i21, i20 ? 0 : i8, i4, i9) | 0) ^ 1;
   i20 = i9;
   i4 = HEAP32[i20 >> 2] | 0;
   if ((i4 | 0) == 0 & (HEAP32[i20 + 4 >> 2] | 0) == 0 | i8) break;
   i1 = __Z7CRCFeedjPKhj(i1, HEAP32[i18 >> 2] | 0, i4) | 0;
   i4 = i9;
   i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i6 | 0, i5 | 0) | 0;
   i5 = getTempRet0() | 0;
   if (!(i2 >>> 0 > i5 >>> 0 | (i2 | 0) == (i5 | 0) & i3 >>> 0 > i4 >>> 0)) break L12;
   i6 = i4;
   i4 = HEAP32[i18 >> 2] | 0;
  }
 } while (0);
 i4 = __Z7CRCDonej(i1) | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) i1 = 1; else {
  i1 = i14 + 112 | 0;
  i5 = i1 + 11 | 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  HEAP32[i16 >> 2] = i3;
  HEAP32[i16 + 4 >> 2] = i4;
  HEAP32[i16 + 8 >> 2] = i2;
  __Z6FormatPKcz(i15, gb + 368115 | 0, i16);
  i3 = (HEAP8[i15 + 11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15;
  i2 = i14 + 92 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP32[i2 >> 2] = 2;
   i2 = i14 + 96 | 0;
   if (!i3) {
    if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i17 >> 2] = i1;
    __Z6FormatPKcz(i16, gb + 367971 | 0, i17);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i16) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  i1 = 0;
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i12);
  HEAP32[i18 >> 2] = 0;
 }
 i22 = i1;
 STACKTOP = i19;
 return i22 | 0;
}

function runPostSets36() {
 HEAP32[gb + 46244 >> 2] = fb + 418;
 HEAP32[gb + 46248 >> 2] = fb + 19;
 HEAP32[gb + 46252 >> 2] = fb + 249;
 HEAP32[gb + 46256 >> 2] = fb + 31;
 HEAP32[gb + 46260 >> 2] = fb + 27;
 HEAP32[gb + 46264 >> 2] = fb + 32;
 HEAP32[gb + 46268 >> 2] = fb + 28;
 HEAP32[gb + 46272 >> 2] = fb + 250;
 HEAP32[gb + 46276 >> 2] = fb + 29;
 HEAP32[gb + 46280 >> 2] = fb + 34;
 HEAP32[gb + 46284 >> 2] = fb + 405;
 HEAP32[gb + 46288 >> 2] = fb + 406;
 HEAP32[gb + 46292 >> 2] = fb + 407;
 HEAP32[gb + 46296 >> 2] = fb + 408;
 HEAP32[gb + 46300 >> 2] = fb + 409;
 HEAP32[gb + 46304 >> 2] = fb + 410;
 HEAP32[gb + 46308 >> 2] = fb + 36;
 HEAP32[gb + 46312 >> 2] = fb + 20;
 HEAP32[gb + 46316 >> 2] = fb + 35;
 HEAP32[gb + 46320 >> 2] = fb + 36;
 HEAP32[gb + 46324 >> 2] = fb + 37;
 HEAP32[gb + 46328 >> 2] = fb + 37;
 HEAP32[gb + 46332 >> 2] = fb + 38;
 HEAP32[gb + 46336 >> 2] = fb + 39;
 HEAP32[gb + 46340 >> 2] = fb + 40;
 HEAP32[gb + 46344 >> 2] = fb + 41;
 HEAP32[gb + 46348 >> 2] = fb + 42;
 HEAP32[gb + 46352 >> 2] = fb + 251;
 HEAP32[gb + 46356 >> 2] = fb + 252;
 HEAP32[gb + 46360 >> 2] = fb + 253;
 HEAP32[gb + 46364 >> 2] = fb + 254;
 HEAP32[gb + 46368 >> 2] = fb + 255;
 HEAP32[gb + 46372 >> 2] = fb + 48;
 HEAP32[gb + 46376 >> 2] = fb + 256;
 HEAP32[gb + 46380 >> 2] = fb + 411;
 HEAP32[gb + 46384 >> 2] = fb + 419;
 HEAP32[gb + 46388 >> 2] = fb + 13;
 HEAP32[gb + 55836 >> 2] = fb + 420;
 HEAP32[gb + 55840 >> 2] = fb + 421;
 HEAP32[gb + 55844 >> 2] = fb + 346;
 HEAP32[gb + 55848 >> 2] = fb + 339;
 HEAP32[gb + 55852 >> 2] = fb + 16;
 HEAP32[gb + 55856 >> 2] = fb + 422;
 HEAP32[gb + 55860 >> 2] = fb + 423;
 HEAP32[gb + 55864 >> 2] = fb + 349;
 HEAP32[gb + 55868 >> 2] = fb + 257;
 HEAP32[gb + 55872 >> 2] = fb + 103;
 HEAP32[gb + 55876 >> 2] = fb + 101;
 HEAP32[gb + 55880 >> 2] = fb + 62;
 HEAP32[gb + 55884 >> 2] = fb + 28;
 HEAP32[gb + 55888 >> 2] = fb + 63;
 HEAP32[gb + 55892 >> 2] = fb + 29;
 HEAP32[gb + 55896 >> 2] = fb + 34;
 HEAP32[gb + 55900 >> 2] = fb + 412;
 HEAP32[gb + 55904 >> 2] = fb + 413;
 HEAP32[gb + 55908 >> 2] = fb + 414;
 HEAP32[gb + 55912 >> 2] = fb + 415;
 HEAP32[gb + 55916 >> 2] = fb + 416;
 HEAP32[gb + 55920 >> 2] = fb + 417;
 HEAP32[gb + 55924 >> 2] = fb + 36;
 HEAP32[gb + 55928 >> 2] = fb + 104;
 HEAP32[gb + 55932 >> 2] = fb + 336;
 HEAP32[gb + 55936 >> 2] = fb + 94;
 HEAP32[gb + 55940 >> 2] = fb + 337;
 HEAP32[gb + 55944 >> 2] = fb + 205;
 HEAP32[gb + 55948 >> 2] = fb + 206;
 HEAP32[gb + 55952 >> 2] = fb + 338;
 HEAP32[gb + 55956 >> 2] = fb + 350;
 HEAP32[gb + 55960 >> 2] = fb + 351;
 HEAP32[gb + 55964 >> 2] = fb + 207;
 HEAP32[gb + 55968 >> 2] = fb + 424;
 HEAP32[gb + 55972 >> 2] = fb + 353;
 HEAP32[gb + 55976 >> 2] = fb + 208;
 HEAP32[gb + 55980 >> 2] = fb + 68;
 HEAP32[gb + 55984 >> 2] = fb + 69;
 HEAP32[gb + 55988 >> 2] = fb + 425;
 HEAP32[gb + 55992 >> 2] = fb + 355;
 HEAP32[gb + 55996 >> 2] = fb + 356;
 HEAP32[gb + 56e3 >> 2] = fb + 30;
 HEAP32[gb + 56012 >> 2] = fb + 426;
 HEAP32[gb + 56016 >> 2] = fb + 427;
 HEAP32[gb + 56020 >> 2] = fb + 31;
 HEAP32[gb + 56024 >> 2] = fb + 102;
 HEAP32[gb + 56028 >> 2] = fb + 359;
 HEAP32[gb + 56032 >> 2] = fb + 360;
 HEAP32[gb + 56036 >> 2] = fb + 209;
 HEAP32[gb + 56040 >> 2] = fb + 210;
 HEAP32[gb + 56044 >> 2] = fb + 70;
 HEAP32[gb + 56048 >> 2] = fb + 71;
 HEAP32[gb + 56052 >> 2] = fb + 110;
 HEAP32[gb + 56056 >> 2] = fb + 105;
 HEAP32[gb + 56060 >> 2] = fb + 428;
 HEAP32[gb + 56072 >> 2] = fb + 429;
 HEAP32[gb + 56076 >> 2] = fb + 430;
 HEAP32[gb + 56080 >> 2] = fb + 376;
 HEAP32[gb + 56084 >> 2] = fb + 418;
 HEAP32[gb + 56088 >> 2] = fb + 16;
 HEAP32[gb + 56092 >> 2] = fb + 377;
 HEAP32[gb + 56096 >> 2] = fb + 431;
 HEAP32[gb + 56100 >> 2] = fb + 19;
 runPostSets37();
}

function __ZN27AnimatorControllerParameter15SetDefaultFloatEf(i1, f4) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 if ((HEAP32[i1 + 16 >> 2] | 0) != 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911616 | 0, 0, gb + 911526 | 0, 91, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 i2 = i1 + 20 | 0;
 if (!(Math_fround(HEAPF32[i2 >> 2]) != f4)) {
  STACKTOP = i9;
  return;
 }
 HEAPF32[i2 >> 2] = f4;
 i5 = i1 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 11;
 }
 if ((i8 | 0) == 9) i8 = 11;
 if ((i8 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 17; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 19;
  }
 }
 if ((i8 | 0) == 17) i8 = 19;
 if ((i8 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1);
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 25; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 25; else if (HEAP32[i1 + 4 >> 2] | 0) {
   STACKTOP = i9;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN21ArchiveStorageCreatorD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i8 + 1260 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i8 + 1264 >> 2] | 0;
  if (!i2) i4 = 4; else {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = 0; else i4 = 4;
  }
  if ((i4 | 0) == 4) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i8 + 1304 >> 2] | 0) > -1) {
  i7 = i8 + 1288 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 1292 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 if ((HEAP32[i8 + 1284 >> 2] | 0) > -1) {
  i7 = i8 + 1268 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 1272 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 i5 = i8 + 1208 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i8 + 1212 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i9 + 4 | 0;
   do {
    i3 = i2 + -40 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i2 = HEAP32[i2 + -8 >> 2] | 0;
     HEAP32[i9 >> 2] = 54;
     HEAP32[i7 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i7 = HEAP32[i8 + 1220 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i1 = HEAP32[i8 + 1192 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 1196 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  i7 = HEAP32[i8 + 1204 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 i2 = i8 + 1096 | 0;
 i1 = i8 + 1132 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 1144 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i1 = i8 + 1116 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 1128 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  i7 = i8 + 1080 | 0;
  i9 = i8 + 1084 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, i9);
  i9 = i8 + 12 | 0;
  __ZN12FileAccessorD2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i8 + 1108 >> 2] | 0;
 HEAP32[i9 >> 2] = 54;
 HEAP32[i9 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 i7 = i8 + 1080 | 0;
 i9 = i8 + 1084 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, i9);
 i9 = i8 + 12 | 0;
 __ZN12FileAccessorD2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZN13BoxCollider2D14CreateInternalEP11Rigidbody2D(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 224 | 0;
 i5 = i10 + 216 | 0;
 i6 = i10 + 184 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10;
 if ((HEAP16[gb + 1457896 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457896 | 0, i1);
  i2 = gb + 1457896 | 0;
 } else i2 = 0;
 i9 = HEAP32[i3 + 28 >> 2] | 0;
 if (i9 | 0) if (__ZNK10GameObject8IsActiveEv(i9) | 0) {
  __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i3, i5, i1, i4);
  f13 = Math_fround(HEAPF32[i3 + 160 >> 2]);
  f13 = Math_fround(f13 * Math_fround(.5));
  f20 = Math_fround(Math_fround(HEAPF32[i3 + 164 >> 2]) * Math_fround(.5));
  f24 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f17 = Math_fround(f24 - f13);
  f21 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f22 = Math_fround(f21 - f20);
  f24 = Math_fround(f13 + f24);
  f21 = Math_fround(f20 + f21);
  f20 = Math_fround(HEAPF32[i1 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f12 = Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) * Math_fround(0.0));
  f15 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f11 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) * Math_fround(0.0));
  f18 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f14 = Math_fround(f17 * f20);
  f23 = Math_fround(f22 * f13);
  f17 = Math_fround(f17 * f19);
  f22 = Math_fround(f22 * f16);
  f25 = Math_fround(f18 + Math_fround(Math_fround(f17 + f22) + f11));
  HEAPF32[i6 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f14 + f23) + f12));
  HEAPF32[i6 + 4 >> 2] = f25;
  f20 = Math_fround(f24 * f20);
  f19 = Math_fround(f24 * f19);
  f22 = Math_fround(f18 + Math_fround(Math_fround(f19 + f22) + f11));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f20 + f23) + f12));
  HEAPF32[i6 + 12 >> 2] = f22;
  f13 = Math_fround(f21 * f13);
  f16 = Math_fround(f21 * f16);
  f19 = Math_fround(f18 + Math_fround(Math_fround(f19 + f16) + f11));
  HEAPF32[i6 + 16 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f20 + f13) + f12));
  HEAPF32[i6 + 20 >> 2] = f19;
  f11 = Math_fround(f18 + Math_fround(Math_fround(f17 + f16) + f11));
  HEAPF32[i6 + 24 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f14 + f13) + f12));
  HEAPF32[i6 + 28 >> 2] = f11;
  if (__ZN17PolygonCollider2D20ValidatePolygonShapeEPK6b2Vec2i(i6, 4) | 0) {
   HEAP32[i7 >> 2] = gb + 151728 + 8;
   HEAP32[i7 + 4 >> 2] = 2;
   HEAP32[i7 + 8 >> 2] = HEAP32[gb + 151644 >> 2];
   HEAP32[i7 + 148 >> 2] = 0;
   HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i7 + 16 >> 2] = Math_fround(0.0);
   __ZN14b2PolygonShape3SetEPK6b2Vec2i(i7, i6, 4);
   HEAP16[i8 + 22 >> 1] = 1;
   HEAP16[i8 + 24 >> 1] = -1;
   HEAP16[i8 + 26 >> 1] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAPF32[i8 + 8 >> 2] = Math_fround(.200000003);
   HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
   HEAP8[i8 + 20 >> 0] = 0;
   HEAP32[i8 >> 2] = i7;
   __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i3, i1, i8, HEAP32[i5 >> 2] | 0, 0);
  } else HEAP32[i3 + 56 >> 2] = 1;
 }
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return;
}

function __ZN11PlayerPrefs4SyncEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 16 | 0;
 i1 = i10;
 i7 = i10 + 80 | 0;
 i8 = i10 + 68 | 0;
 i9 = i10 + 48 | 0;
 if (!(HEAP8[gb + 1544208 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, gb + 1103752 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 363730 | 0, 11);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i7, i6, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i5 = HEAP8[i7 + 11 >> 0] | 0;
 i5 = ((i5 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i5) {
  __ZN4FileC2Ev(i6);
  if (__ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i6, i7, 1, 0) | 0) {
   i5 = HEAP32[gb + 25444 >> 2] | 0;
   i3 = i5;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i4 = i1;
   HEAP32[i4 >> 2] = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
   HEAP32[i4 + 4 >> 2] = i5;
   i4 = i1 + 8 | 0;
   HEAP32[i4 >> 2] = 65536;
   i5 = i1 + 12 | 0;
   HEAP32[i5 >> 2] = HEAP32[gb + 1103832 >> 2];
   __ZN4File5WriteEPKvj(i6, i1, 8) | 0;
   __ZN4File5WriteEPKvj(i6, i4, 4) | 0;
   __ZN4File5WriteEPKvj(i6, i5, 4) | 0;
   i5 = HEAP32[gb + 1103788 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) != (i5 + 4 | 0)) {
    i3 = i9 + 8 | 0;
    i4 = i8 + 11 | 0;
    i5 = i8 + 4 | 0;
    i2 = i1;
    while (1) {
     HEAP32[i9 >> 2] = 128;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i2 + 16 | 0);
     __ZL11EncodeValueRK9PrefValue(i8, i9);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
     i1 = HEAP8[i4 >> 0] | 0;
     i11 = i1 << 24 >> 24 < 0;
     __ZN4File5WriteEPKvj(i6, i11 ? HEAP32[i8 >> 2] | 0 : i8, i11 ? HEAP32[i5 >> 2] | 0 : i1 & 255) | 0;
     __ZL11EncodeValueRK9PrefValue(i9, i2 + 28 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i9) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     i1 = HEAP8[i4 >> 0] | 0;
     i11 = i1 << 24 >> 24 < 0;
     __ZN4File5WriteEPKvj(i6, i11 ? HEAP32[i8 >> 2] | 0 : i8, i11 ? HEAP32[i5 >> 2] | 0 : i1 & 255) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
     i1 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i1) while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((i1 | 0) == ((HEAP32[gb + 1103788 >> 2] | 0) + 4 | 0)) break; else i2 = i1;
    }
   }
   __ZN4File5CloseEv(i6) | 0;
   _JS_FileSystem_Sync();
   HEAP8[gb + 1544208 >> 0] = 0;
  } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 363742 | 0, 0, gb + 363781 | 0, 347, 1, 0, 0, 0);
  __ZN4FileD2Ev(i6);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i10;
 return;
}

function runPostSets108() {
 HEAP32[gb + 99528 >> 2] = fb + 1;
 HEAP32[gb + 99532 >> 2] = fb + 1;
 HEAP32[gb + 99536 >> 2] = fb + 1083;
 HEAP32[gb + 99540 >> 2] = fb + 1084;
 HEAP32[gb + 99552 >> 2] = fb + 1;
 HEAP32[gb + 99556 >> 2] = fb + 694;
 HEAP32[gb + 99560 >> 2] = fb + 456;
 HEAP32[gb + 99564 >> 2] = fb + 1270;
 HEAP32[gb + 99568 >> 2] = fb + 1391;
 HEAP32[gb + 99572 >> 2] = fb + 305;
 HEAP32[gb + 99576 >> 2] = fb + 1;
 HEAP32[gb + 99580 >> 2] = fb + 1;
 HEAP32[gb + 99584 >> 2] = fb + 1;
 HEAP32[gb + 99588 >> 2] = fb + 1;
 HEAP32[gb + 99592 >> 2] = fb + 1;
 HEAP32[gb + 99596 >> 2] = fb + 1;
 HEAP32[gb + 99600 >> 2] = fb + 1;
 HEAP32[gb + 99604 >> 2] = fb + 1;
 HEAP32[gb + 99608 >> 2] = fb + 1;
 HEAP32[gb + 99612 >> 2] = fb + 1;
 HEAP32[gb + 99616 >> 2] = fb + 1;
 HEAP32[gb + 99620 >> 2] = fb + 1;
 HEAP32[gb + 99624 >> 2] = fb + 1;
 HEAP32[gb + 99628 >> 2] = fb + 1;
 HEAP32[gb + 99632 >> 2] = fb + 1;
 HEAP32[gb + 99636 >> 2] = fb + 1;
 HEAP32[gb + 99640 >> 2] = fb + 1;
 HEAP32[gb + 99644 >> 2] = fb + 1;
 HEAP32[gb + 99648 >> 2] = fb + 1;
 HEAP32[gb + 99652 >> 2] = fb + 1;
 HEAP32[gb + 99656 >> 2] = fb + 1;
 HEAP32[gb + 99660 >> 2] = fb + 1;
 HEAP32[gb + 99664 >> 2] = fb + 1;
 HEAP32[gb + 99668 >> 2] = fb + 1;
 HEAP32[gb + 99680 >> 2] = fb + 1392;
 HEAP32[gb + 99684 >> 2] = fb + 694;
 HEAP32[gb + 99688 >> 2] = fb + 456;
 HEAP32[gb + 99692 >> 2] = fb + 1393;
 HEAP32[gb + 99696 >> 2] = fb + 1394;
 HEAP32[gb + 99700 >> 2] = fb + 305;
 HEAP32[gb + 99704 >> 2] = fb + 1;
 HEAP32[gb + 99708 >> 2] = fb + 695;
 HEAP32[gb + 99712 >> 2] = fb + 1085;
 HEAP32[gb + 99716 >> 2] = fb + 696;
 HEAP32[gb + 99720 >> 2] = fb + 20;
 HEAP32[gb + 99724 >> 2] = fb + 207;
 HEAP32[gb + 99728 >> 2] = fb + 1086;
 HEAP32[gb + 99732 >> 2] = fb + 697;
 HEAP32[gb + 99736 >> 2] = fb + 1087;
 HEAP32[gb + 99740 >> 2] = fb + 698;
 HEAP32[gb + 99744 >> 2] = fb + 1088;
 HEAP32[gb + 99748 >> 2] = fb + 699;
 HEAP32[gb + 99752 >> 2] = fb + 1089;
 HEAP32[gb + 99756 >> 2] = fb + 700;
 HEAP32[gb + 99760 >> 2] = fb + 701;
 HEAP32[gb + 99764 >> 2] = fb + 1;
 HEAP32[gb + 99768 >> 2] = fb + 1;
 HEAP32[gb + 99772 >> 2] = fb + 1;
 HEAP32[gb + 99776 >> 2] = fb + 1090;
 HEAP32[gb + 99780 >> 2] = fb + 208;
 HEAP32[gb + 99784 >> 2] = fb + 702;
 HEAP32[gb + 99788 >> 2] = fb + 87;
 HEAP32[gb + 99792 >> 2] = fb + 703;
 HEAP32[gb + 99796 >> 2] = fb + 88;
 HEAP32[gb + 99800 >> 2] = fb + 1091;
 HEAP32[gb + 99804 >> 2] = fb + 1092;
 HEAP32[gb + 99808 >> 2] = fb + 1093;
 HEAP32[gb + 99812 >> 2] = fb + 1395;
 HEAP32[gb + 99816 >> 2] = fb + 1396;
 HEAP32[gb + 99828 >> 2] = fb + 1397;
 HEAP32[gb + 99832 >> 2] = fb + 694;
 HEAP32[gb + 99836 >> 2] = fb + 456;
 HEAP32[gb + 99840 >> 2] = fb + 1398;
 HEAP32[gb + 99844 >> 2] = fb + 1399;
 HEAP32[gb + 99848 >> 2] = fb + 305;
 HEAP32[gb + 99852 >> 2] = fb + 704;
 HEAP32[gb + 99856 >> 2] = fb + 695;
 HEAP32[gb + 99860 >> 2] = fb + 1085;
 HEAP32[gb + 99864 >> 2] = fb + 696;
 HEAP32[gb + 99868 >> 2] = fb + 20;
 HEAP32[gb + 99872 >> 2] = fb + 207;
 HEAP32[gb + 99876 >> 2] = fb + 1086;
 HEAP32[gb + 99880 >> 2] = fb + 697;
 HEAP32[gb + 99884 >> 2] = fb + 1087;
 HEAP32[gb + 99888 >> 2] = fb + 698;
 HEAP32[gb + 99892 >> 2] = fb + 1088;
 HEAP32[gb + 99896 >> 2] = fb + 699;
 HEAP32[gb + 99900 >> 2] = fb + 1089;
 HEAP32[gb + 99904 >> 2] = fb + 700;
 HEAP32[gb + 99908 >> 2] = fb + 701;
 HEAP32[gb + 99912 >> 2] = fb + 1094;
 HEAP32[gb + 99916 >> 2] = fb + 209;
 HEAP32[gb + 99920 >> 2] = fb + 52;
 HEAP32[gb + 99924 >> 2] = fb + 1090;
 HEAP32[gb + 99928 >> 2] = fb + 208;
 HEAP32[gb + 99932 >> 2] = fb + 702;
 HEAP32[gb + 99936 >> 2] = fb + 87;
 HEAP32[gb + 99940 >> 2] = fb + 703;
 HEAP32[gb + 99944 >> 2] = fb + 88;
 HEAP32[gb + 99948 >> 2] = fb + 1091;
 runPostSets109();
}

function __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 40 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i3;
 i3 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 40 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 40 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 * 40 | 0) | 0 : i5;
  if ((i2 | 0) == (i1 | 0)) i2 = i3; else {
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    i6 = i2 + 32 | 0;
    i8 = HEAP32[i6 + 4 >> 2] | 0;
    i9 = i3 + 32 | 0;
    HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    i2 = i2 + 40 | 0;
    i3 = i3 + 40 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i2 = i3;
  }
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i9 = i2 + 12 | 0;
   i8 = i1 + 12 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   i1 = i1 + 40 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 40 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 i5 = i6;
 if (i6) {
  i1 = i9 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i4 + (~(((i4 + -40 - i6 | 0) >>> 0) / 40 | 0) * 40 | 0);
  __ZdlPv(i5);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else i3 = 0;
 i6 = (i1 - i3 | 0) / 40 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 53687091 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 107374182;
 if (i3 >>> 0 > 107374182) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i1 = __Znwj(i3 * 40 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i7 >> 2] = i1 + (i3 * 40 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i9 = i1 + 12 | 0;
  i8 = i2 + 12 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  i2 = i2 + 40 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 40 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __Z26TransformVerticesInnerLoopILb0ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i6, i22, i2, i5, i8, i3, i4, i23, i9, i24, i7, i1) {
 i6 = i6 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 i9 = i9 | 0;
 i24 = i24 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i10 = (i7 | 0) / 4 | 0;
 i1 = i5 + -1 | 0;
 if (!i5) return;
 i11 = i22 + 16 | 0;
 i12 = i22 + 32 | 0;
 i13 = i22 + 48 | 0;
 i14 = i22 + 4 | 0;
 i15 = i22 + 20 | 0;
 i16 = i22 + 36 | 0;
 i17 = i22 + 52 | 0;
 i18 = i22 + 8 | 0;
 i19 = i22 + 24 | 0;
 i20 = i22 + 40 | 0;
 i21 = i22 + 56 | 0;
 if ((i7 | 0) > 3) {
  i2 = i6;
  i6 = i8;
  i3 = i9;
 } else {
  i4 = i6;
  i3 = i8;
  i2 = i9;
  while (1) {
   f28 = Math_fround(HEAPF32[i22 >> 2]);
   f28 = Math_fround(f28 * Math_fround(HEAPF32[i3 >> 2]));
   f27 = Math_fround(HEAPF32[i11 >> 2]);
   i10 = i3 + 4 | 0;
   f26 = Math_fround(HEAPF32[i10 >> 2]);
   f27 = Math_fround(f28 + Math_fround(f27 * f26));
   f28 = Math_fround(HEAPF32[i12 >> 2]);
   f25 = Math_fround(HEAPF32[i3 + 8 >> 2]);
   f28 = Math_fround(f27 + Math_fround(f28 * f25));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f28);
   f28 = Math_fround(HEAPF32[i14 >> 2]);
   f27 = Math_fround(HEAPF32[i3 >> 2]);
   f28 = Math_fround(f28 * f27);
   f26 = Math_fround(f28 + Math_fround(f26 * Math_fround(HEAPF32[i15 >> 2])));
   f26 = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i16 >> 2])));
   HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f26);
   f27 = Math_fround(f27 * Math_fround(HEAPF32[i18 >> 2]));
   f26 = Math_fround(HEAPF32[i19 >> 2]);
   f26 = Math_fround(f27 + Math_fround(f26 * Math_fround(HEAPF32[i10 >> 2])));
   f25 = Math_fround(f26 + Math_fround(f25 * Math_fround(HEAPF32[i20 >> 2])));
   HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f25);
   if (!i1) break; else {
    i4 = i4 + 12 | 0;
    i3 = i3 + i23 | 0;
    i2 = (i2 | 0) == 0 ? 0 : i2 + i24 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  return;
 }
 while (1) {
  f25 = Math_fround(HEAPF32[i22 >> 2]);
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i6 >> 2]));
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  i9 = i6 + 4 | 0;
  f27 = Math_fround(HEAPF32[i9 >> 2]);
  f26 = Math_fround(f25 + Math_fround(f26 * f27));
  f25 = Math_fround(HEAPF32[i12 >> 2]);
  f28 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f25 = Math_fround(f26 + Math_fround(f25 * f28));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f25);
  f25 = Math_fround(HEAPF32[i14 >> 2]);
  f26 = Math_fround(HEAPF32[i6 >> 2]);
  f25 = Math_fround(f25 * f26);
  f27 = Math_fround(f25 + Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2])));
  f27 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i16 >> 2])));
  HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) + f27);
  f26 = Math_fround(f26 * Math_fround(HEAPF32[i18 >> 2]));
  f27 = Math_fround(HEAPF32[i19 >> 2]);
  f27 = Math_fround(f26 + Math_fround(f27 * Math_fround(HEAPF32[i9 >> 2])));
  f28 = Math_fround(f27 + Math_fround(f28 * Math_fround(HEAPF32[i20 >> 2])));
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f28);
  i2 = i2 + 12 | 0;
  if (!i3) i3 = 0; else {
   i4 = i3;
   i5 = 0;
   while (1) {
    i9 = i2;
    i2 = i2 + 4 | 0;
    HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i10 | 0)) break; else i4 = i4 + 4 | 0;
   }
   i3 = i3 + i24 | 0;
  }
  if (!i1) break; else {
   i6 = i6 + i23 | 0;
   i1 = i1 + -1 | 0;
  }
 }
 return;
}

function __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 28 | 0, i8 + 2 | 0);
 i2 = i6 + 44 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj293ENS_22PxRepXPropertyAccessorILj293ES4_NS_19PxHeightFieldFormat4EnumESA_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj295ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 76 | 0, i8 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj296ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 92 | 0, i8 + 6 | 0);
 i2 = i6 + 108 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj297ENS_22PxRepXPropertyAccessorILj297ES4_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESC_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function runPostSets16() {
 HEAP32[gb + 35192 >> 2] = fb + 29;
 HEAP32[gb + 35196 >> 2] = fb + 34;
 HEAP32[gb + 35200 >> 2] = fb + 207;
 HEAP32[gb + 35204 >> 2] = fb + 208;
 HEAP32[gb + 35208 >> 2] = fb + 209;
 HEAP32[gb + 35212 >> 2] = fb + 210;
 HEAP32[gb + 35216 >> 2] = fb + 211;
 HEAP32[gb + 35220 >> 2] = fb + 212;
 HEAP32[gb + 35224 >> 2] = fb + 36;
 HEAP32[gb + 35228 >> 2] = fb + 104;
 HEAP32[gb + 35232 >> 2] = fb + 108;
 HEAP32[gb + 35236 >> 2] = fb + 94;
 HEAP32[gb + 35240 >> 2] = fb + 213;
 HEAP32[gb + 35244 >> 2] = fb + 105;
 HEAP32[gb + 35248 >> 2] = fb + 106;
 HEAP32[gb + 35252 >> 2] = fb + 110;
 HEAP32[gb + 35264 >> 2] = fb + 1;
 HEAP32[gb + 35268 >> 2] = fb + 1;
 HEAP32[gb + 35272 >> 2] = fb + 8;
 HEAP32[gb + 35276 >> 2] = fb + 55;
 HEAP32[gb + 35280 >> 2] = fb + 9;
 HEAP32[gb + 35284 >> 2] = fb + 10;
 HEAP32[gb + 35288 >> 2] = fb + 2;
 HEAP32[gb + 35292 >> 2] = fb + 9;
 HEAP32[gb + 35324 >> 2] = fb + 186;
 HEAP32[gb + 35328 >> 2] = fb + 187;
 HEAP32[gb + 35332 >> 2] = fb + 38;
 HEAP32[gb + 35336 >> 2] = fb + 145;
 HEAP32[gb + 35340 >> 2] = fb + 16;
 HEAP32[gb + 35344 >> 2] = fb + 188;
 HEAP32[gb + 35348 >> 2] = fb + 189;
 HEAP32[gb + 35352 >> 2] = fb + 19;
 HEAP32[gb + 35356 >> 2] = fb + 133;
 HEAP32[gb + 35360 >> 2] = fb + 103;
 HEAP32[gb + 35364 >> 2] = fb + 101;
 HEAP32[gb + 35368 >> 2] = fb + 62;
 HEAP32[gb + 35372 >> 2] = fb + 28;
 HEAP32[gb + 35376 >> 2] = fb + 63;
 HEAP32[gb + 35380 >> 2] = fb + 29;
 HEAP32[gb + 35384 >> 2] = fb + 34;
 HEAP32[gb + 35388 >> 2] = fb + 214;
 HEAP32[gb + 35392 >> 2] = fb + 215;
 HEAP32[gb + 35396 >> 2] = fb + 216;
 HEAP32[gb + 35400 >> 2] = fb + 217;
 HEAP32[gb + 35404 >> 2] = fb + 218;
 HEAP32[gb + 35408 >> 2] = fb + 219;
 HEAP32[gb + 35412 >> 2] = fb + 36;
 HEAP32[gb + 35416 >> 2] = fb + 104;
 HEAP32[gb + 35420 >> 2] = fb + 108;
 HEAP32[gb + 35424 >> 2] = fb + 94;
 HEAP32[gb + 35428 >> 2] = fb + 130;
 HEAP32[gb + 35432 >> 2] = fb + 112;
 HEAP32[gb + 35436 >> 2] = fb + 113;
 HEAP32[gb + 35440 >> 2] = fb + 131;
 HEAP32[gb + 35444 >> 2] = fb + 111;
 HEAP32[gb + 35448 >> 2] = fb + 112;
 HEAP32[gb + 35452 >> 2] = fb + 113;
 HEAP32[gb + 35456 >> 2] = fb + 190;
 HEAP32[gb + 35460 >> 2] = fb + 191;
 HEAP32[gb + 35472 >> 2] = fb + 192;
 HEAP32[gb + 35476 >> 2] = fb + 193;
 HEAP32[gb + 35480 >> 2] = fb + 38;
 HEAP32[gb + 35484 >> 2] = fb + 220;
 HEAP32[gb + 35488 >> 2] = fb + 16;
 HEAP32[gb + 35492 >> 2] = fb + 194;
 HEAP32[gb + 35496 >> 2] = fb + 195;
 HEAP32[gb + 35500 >> 2] = fb + 19;
 HEAP32[gb + 35504 >> 2] = fb + 134;
 HEAP32[gb + 35508 >> 2] = fb + 103;
 HEAP32[gb + 35512 >> 2] = fb + 101;
 HEAP32[gb + 35516 >> 2] = fb + 62;
 HEAP32[gb + 35520 >> 2] = fb + 28;
 HEAP32[gb + 35524 >> 2] = fb + 63;
 HEAP32[gb + 35528 >> 2] = fb + 29;
 HEAP32[gb + 35532 >> 2] = fb + 34;
 HEAP32[gb + 35536 >> 2] = fb + 221;
 HEAP32[gb + 35540 >> 2] = fb + 222;
 HEAP32[gb + 35544 >> 2] = fb + 223;
 HEAP32[gb + 35548 >> 2] = fb + 224;
 HEAP32[gb + 35552 >> 2] = fb + 225;
 HEAP32[gb + 35556 >> 2] = fb + 226;
 HEAP32[gb + 35560 >> 2] = fb + 36;
 HEAP32[gb + 35564 >> 2] = fb + 104;
 HEAP32[gb + 35568 >> 2] = fb + 108;
 HEAP32[gb + 35572 >> 2] = fb + 94;
 HEAP32[gb + 35576 >> 2] = fb + 130;
 HEAP32[gb + 35580 >> 2] = fb + 112;
 HEAP32[gb + 35584 >> 2] = fb + 113;
 HEAP32[gb + 35588 >> 2] = fb + 131;
 HEAP32[gb + 35592 >> 2] = fb + 111;
 HEAP32[gb + 35596 >> 2] = fb + 112;
 HEAP32[gb + 35600 >> 2] = fb + 113;
 HEAP32[gb + 35604 >> 2] = fb + 196;
 HEAP32[gb + 35608 >> 2] = fb + 197;
 HEAP32[gb + 35620 >> 2] = fb + 198;
 HEAP32[gb + 35624 >> 2] = fb + 199;
 HEAP32[gb + 35628 >> 2] = fb + 80;
 HEAP32[gb + 35632 >> 2] = fb + 227;
 HEAP32[gb + 35636 >> 2] = fb + 16;
 HEAP32[gb + 35640 >> 2] = fb + 200;
 runPostSets17();
}

function runPostSets12() {
 HEAP32[gb + 33040 >> 2] = fb + 29;
 HEAP32[gb + 33044 >> 2] = fb + 34;
 HEAP32[gb + 33048 >> 2] = fb + 139;
 HEAP32[gb + 33052 >> 2] = fb + 140;
 HEAP32[gb + 33056 >> 2] = fb + 141;
 HEAP32[gb + 33060 >> 2] = fb + 142;
 HEAP32[gb + 33064 >> 2] = fb + 143;
 HEAP32[gb + 33068 >> 2] = fb + 144;
 HEAP32[gb + 33072 >> 2] = fb + 36;
 HEAP32[gb + 33076 >> 2] = fb + 104;
 HEAP32[gb + 33080 >> 2] = fb + 108;
 HEAP32[gb + 33084 >> 2] = fb + 94;
 HEAP32[gb + 33088 >> 2] = fb + 130;
 HEAP32[gb + 33092 >> 2] = fb + 112;
 HEAP32[gb + 33096 >> 2] = fb + 113;
 HEAP32[gb + 33100 >> 2] = fb + 131;
 HEAP32[gb + 33104 >> 2] = fb + 111;
 HEAP32[gb + 33108 >> 2] = fb + 112;
 HEAP32[gb + 33112 >> 2] = fb + 113;
 HEAP32[gb + 33116 >> 2] = fb + 122;
 HEAP32[gb + 33120 >> 2] = fb + 123;
 HEAP32[gb + 33132 >> 2] = fb + 124;
 HEAP32[gb + 33136 >> 2] = fb + 125;
 HEAP32[gb + 33140 >> 2] = fb + 38;
 HEAP32[gb + 33144 >> 2] = fb + 145;
 HEAP32[gb + 33148 >> 2] = fb + 16;
 HEAP32[gb + 33152 >> 2] = fb + 93;
 HEAP32[gb + 33156 >> 2] = fb + 40;
 HEAP32[gb + 33160 >> 2] = fb + 19;
 HEAP32[gb + 33164 >> 2] = fb + 116;
 HEAP32[gb + 33168 >> 2] = fb + 103;
 HEAP32[gb + 33172 >> 2] = fb + 101;
 HEAP32[gb + 33176 >> 2] = fb + 62;
 HEAP32[gb + 33180 >> 2] = fb + 28;
 HEAP32[gb + 33184 >> 2] = fb + 63;
 HEAP32[gb + 33188 >> 2] = fb + 29;
 HEAP32[gb + 33192 >> 2] = fb + 34;
 HEAP32[gb + 33196 >> 2] = fb + 146;
 HEAP32[gb + 33200 >> 2] = fb + 147;
 HEAP32[gb + 33204 >> 2] = fb + 148;
 HEAP32[gb + 33208 >> 2] = fb + 149;
 HEAP32[gb + 33212 >> 2] = fb + 150;
 HEAP32[gb + 33216 >> 2] = fb + 151;
 HEAP32[gb + 33220 >> 2] = fb + 36;
 HEAP32[gb + 33224 >> 2] = fb + 104;
 HEAP32[gb + 33228 >> 2] = fb + 108;
 HEAP32[gb + 33232 >> 2] = fb + 94;
 HEAP32[gb + 33236 >> 2] = fb + 130;
 HEAP32[gb + 33240 >> 2] = fb + 112;
 HEAP32[gb + 33244 >> 2] = fb + 113;
 HEAP32[gb + 33248 >> 2] = fb + 131;
 HEAP32[gb + 33252 >> 2] = fb + 111;
 HEAP32[gb + 33256 >> 2] = fb + 112;
 HEAP32[gb + 33260 >> 2] = fb + 113;
 HEAP32[gb + 33264 >> 2] = fb + 126;
 HEAP32[gb + 33268 >> 2] = fb + 127;
 HEAP32[gb + 33280 >> 2] = fb + 128;
 HEAP32[gb + 33284 >> 2] = fb + 129;
 HEAP32[gb + 33288 >> 2] = fb + 80;
 HEAP32[gb + 33292 >> 2] = fb + 152;
 HEAP32[gb + 33296 >> 2] = fb + 16;
 HEAP32[gb + 33300 >> 2] = fb + 39;
 HEAP32[gb + 33304 >> 2] = fb + 40;
 HEAP32[gb + 33308 >> 2] = fb + 130;
 HEAP32[gb + 33312 >> 2] = fb + 117;
 HEAP32[gb + 33316 >> 2] = fb + 99;
 HEAP32[gb + 33320 >> 2] = fb + 40;
 HEAP32[gb + 33324 >> 2] = fb + 62;
 HEAP32[gb + 33328 >> 2] = fb + 28;
 HEAP32[gb + 33332 >> 2] = fb + 63;
 HEAP32[gb + 33336 >> 2] = fb + 29;
 HEAP32[gb + 33340 >> 2] = fb + 34;
 HEAP32[gb + 33344 >> 2] = fb + 153;
 HEAP32[gb + 33348 >> 2] = fb + 154;
 HEAP32[gb + 33352 >> 2] = fb + 155;
 HEAP32[gb + 33356 >> 2] = fb + 156;
 HEAP32[gb + 33360 >> 2] = fb + 157;
 HEAP32[gb + 33364 >> 2] = fb + 158;
 HEAP32[gb + 33368 >> 2] = fb + 36;
 HEAP32[gb + 33372 >> 2] = fb + 96;
 HEAP32[gb + 33376 >> 2] = fb + 81;
 HEAP32[gb + 33380 >> 2] = fb + 82;
 HEAP32[gb + 33392 >> 2] = fb + 131;
 HEAP32[gb + 33396 >> 2] = fb + 132;
 HEAP32[gb + 33400 >> 2] = fb + 38;
 HEAP32[gb + 33404 >> 2] = fb + 159;
 HEAP32[gb + 33408 >> 2] = fb + 16;
 HEAP32[gb + 33412 >> 2] = fb + 93;
 HEAP32[gb + 33416 >> 2] = fb + 133;
 HEAP32[gb + 33420 >> 2] = fb + 19;
 HEAP32[gb + 33424 >> 2] = fb + 118;
 HEAP32[gb + 33428 >> 2] = fb + 103;
 HEAP32[gb + 33432 >> 2] = fb + 101;
 HEAP32[gb + 33436 >> 2] = fb + 62;
 HEAP32[gb + 33440 >> 2] = fb + 28;
 HEAP32[gb + 33444 >> 2] = fb + 63;
 HEAP32[gb + 33448 >> 2] = fb + 29;
 HEAP32[gb + 33452 >> 2] = fb + 34;
 HEAP32[gb + 33456 >> 2] = fb + 160;
 HEAP32[gb + 33460 >> 2] = fb + 161;
 runPostSets13();
}

function runPostSets109() {
 HEAP32[gb + 99952 >> 2] = fb + 1092;
 HEAP32[gb + 99956 >> 2] = fb + 1095;
 HEAP32[gb + 99960 >> 2] = fb + 1400;
 HEAP32[gb + 99964 >> 2] = fb + 1401;
 HEAP32[gb + 99976 >> 2] = fb + 1402;
 HEAP32[gb + 99980 >> 2] = fb + 694;
 HEAP32[gb + 99984 >> 2] = fb + 456;
 HEAP32[gb + 99988 >> 2] = fb + 1403;
 HEAP32[gb + 99992 >> 2] = fb + 1404;
 HEAP32[gb + 99996 >> 2] = fb + 305;
 HEAP32[gb + 1e5 >> 2] = fb + 1;
 HEAP32[gb + 100004 >> 2] = fb + 695;
 HEAP32[gb + 100008 >> 2] = fb + 1085;
 HEAP32[gb + 100012 >> 2] = fb + 696;
 HEAP32[gb + 100016 >> 2] = fb + 1;
 HEAP32[gb + 100020 >> 2] = fb + 210;
 HEAP32[gb + 100024 >> 2] = fb + 1096;
 HEAP32[gb + 100028 >> 2] = fb + 697;
 HEAP32[gb + 100032 >> 2] = fb + 1087;
 HEAP32[gb + 100036 >> 2] = fb + 698;
 HEAP32[gb + 100040 >> 2] = fb + 1088;
 HEAP32[gb + 100044 >> 2] = fb + 699;
 HEAP32[gb + 100048 >> 2] = fb + 1097;
 HEAP32[gb + 100052 >> 2] = fb + 700;
 HEAP32[gb + 100056 >> 2] = fb + 701;
 HEAP32[gb + 100060 >> 2] = fb + 1;
 HEAP32[gb + 100064 >> 2] = fb + 1;
 HEAP32[gb + 100068 >> 2] = fb + 1;
 HEAP32[gb + 100072 >> 2] = fb + 1;
 HEAP32[gb + 100076 >> 2] = fb + 1;
 HEAP32[gb + 100080 >> 2] = fb + 1;
 HEAP32[gb + 100084 >> 2] = fb + 1;
 HEAP32[gb + 100088 >> 2] = fb + 1;
 HEAP32[gb + 100092 >> 2] = fb + 1;
 HEAP32[gb + 100096 >> 2] = fb + 1098;
 HEAP32[gb + 100100 >> 2] = fb + 1099;
 HEAP32[gb + 100112 >> 2] = fb + 1405;
 HEAP32[gb + 100116 >> 2] = fb + 1406;
 HEAP32[gb + 100120 >> 2] = fb + 1;
 HEAP32[gb + 100124 >> 2] = fb + 1;
 HEAP32[gb + 100128 >> 2] = fb + 1;
 HEAP32[gb + 100132 >> 2] = fb + 1;
 HEAP32[gb + 100136 >> 2] = fb + 1;
 HEAP32[gb + 100140 >> 2] = fb + 1;
 HEAP32[gb + 100144 >> 2] = fb + 1;
 HEAP32[gb + 100148 >> 2] = fb + 1;
 HEAP32[gb + 100152 >> 2] = fb + 1;
 HEAP32[gb + 100156 >> 2] = fb + 1;
 HEAP32[gb + 100160 >> 2] = fb + 1;
 HEAP32[gb + 100164 >> 2] = fb + 1;
 HEAP32[gb + 100168 >> 2] = fb + 1;
 HEAP32[gb + 100172 >> 2] = fb + 1;
 HEAP32[gb + 100176 >> 2] = fb + 1;
 HEAP32[gb + 100180 >> 2] = fb + 1;
 HEAP32[gb + 100184 >> 2] = fb + 1;
 HEAP32[gb + 100188 >> 2] = fb + 1;
 HEAP32[gb + 100192 >> 2] = fb + 1;
 HEAP32[gb + 100196 >> 2] = fb + 1;
 HEAP32[gb + 100200 >> 2] = fb + 1;
 HEAP32[gb + 100204 >> 2] = fb + 1;
 HEAP32[gb + 100208 >> 2] = fb + 1;
 HEAP32[gb + 100212 >> 2] = fb + 1;
 HEAP32[gb + 100216 >> 2] = fb + 1;
 HEAP32[gb + 100220 >> 2] = fb + 1;
 HEAP32[gb + 100224 >> 2] = fb + 1;
 HEAP32[gb + 100228 >> 2] = fb + 1;
 HEAP32[gb + 100232 >> 2] = fb + 1;
 HEAP32[gb + 100236 >> 2] = fb + 1;
 HEAP32[gb + 100240 >> 2] = fb + 1;
 HEAP32[gb + 100244 >> 2] = fb + 1;
 HEAP32[gb + 100248 >> 2] = fb + 1;
 HEAP32[gb + 100252 >> 2] = fb + 1;
 HEAP32[gb + 100256 >> 2] = fb + 1;
 HEAP32[gb + 100260 >> 2] = fb + 1;
 HEAP32[gb + 100264 >> 2] = fb + 1;
 HEAP32[gb + 100268 >> 2] = fb + 1;
 HEAP32[gb + 100272 >> 2] = fb + 1;
 HEAP32[gb + 100276 >> 2] = fb + 1;
 HEAP32[gb + 100280 >> 2] = fb + 1;
 HEAP32[gb + 100284 >> 2] = fb + 1;
 HEAP32[gb + 100288 >> 2] = fb + 1;
 HEAP32[gb + 100292 >> 2] = fb + 1;
 HEAP32[gb + 100296 >> 2] = fb + 1;
 HEAP32[gb + 100300 >> 2] = fb + 1;
 HEAP32[gb + 100304 >> 2] = fb + 1;
 HEAP32[gb + 100308 >> 2] = fb + 1;
 HEAP32[gb + 100312 >> 2] = fb + 1;
 HEAP32[gb + 100316 >> 2] = fb + 1;
 HEAP32[gb + 100320 >> 2] = fb + 1;
 HEAP32[gb + 100324 >> 2] = fb + 1;
 HEAP32[gb + 100328 >> 2] = fb + 1;
 HEAP32[gb + 100332 >> 2] = fb + 1;
 HEAP32[gb + 100336 >> 2] = fb + 1;
 HEAP32[gb + 100340 >> 2] = fb + 1;
 HEAP32[gb + 100344 >> 2] = fb + 1;
 HEAP32[gb + 100348 >> 2] = fb + 1;
 HEAP32[gb + 100352 >> 2] = fb + 1;
 HEAP32[gb + 100356 >> 2] = fb + 1;
 HEAP32[gb + 100360 >> 2] = fb + 1;
 HEAP32[gb + 100364 >> 2] = fb + 1;
 runPostSets110();
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i23, i7, i1) {
 i23 = i23 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 64 | 0;
 i3 = i22 + 60 | 0;
 i21 = i22;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = i23 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i23 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i14 = HEAP32[i4 + 4 >> 2] | 0;
 i15 = i21 + 24 | 0;
 HEAP8[i15 >> 0] = 1;
 i16 = i21 + 28 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i21 + 32 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i21 + 36 | 0;
 HEAP32[i18 >> 2] = -1;
 i19 = i21 + 44 | 0;
 HEAP32[i21 >> 2] = i4;
 i10 = i21 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i2 = i7 + 4 | 0;
 i11 = i21 + 4 | 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0) & 1;
 HEAP8[i11 >> 0] = i3;
 i12 = i21 + 8 | 0;
 HEAP32[i12 >> 2] = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) | 0) | 0;
 i13 = i21 + 16 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = i1;
 HEAP32[i21 + 40 >> 2] = i1;
 HEAP32[i21 + 48 >> 2] = i2;
 i2 = i2 - i1 >> 6;
 HEAP32[i21 + 56 >> 2] = i2;
 HEAP32[i21 + 52 >> 2] = i2;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i14 | 0)) {
  STACKTOP = i22;
  return;
 }
 i6 = i21 + 40 | 0;
 i7 = i21 + 20 | 0;
 i8 = i20 + 20 | 0;
 i9 = i20 + 16 | 0;
 while (1) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i7 >> 2] = i6;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i2) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i13 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, HEAP32[i10 >> 2] | 0, i1);
   }
   i3 = HEAP32[i13 >> 2] | 0;
   HEAP8[i15 >> 0] = 1;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i17 >> 2] = i3;
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = -1;
  } else {
   i5 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i12 >> 2] | 0, i2) | 0) + 16 | 0;
   HEAP8[i15 >> 0] = 0;
   HEAP32[i16 >> 2] = i5;
   HEAP32[i17 >> 2] = i3;
   i3 = i6;
  }
  HEAP32[i18 >> 2] = i1;
  HEAP32[i8 >> 2] = i23;
  HEAP32[i20 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i20 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i20 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  HEAP32[i9 >> 2] = i3;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = i3 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i3 = i3 + 12 | 0;
   do {
    i24 = i1 + 64 | 0;
    HEAP32[i4 >> 2] = i24;
    HEAP32[i3 >> 2] = i2 - i24 >> 6;
    mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i20 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
  if ((i2 | 0) == (i14 | 0)) break;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP8[i11 >> 0] | 0;
 }
 STACKTOP = i22;
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i2 = i8 + 120 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 140 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034211 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034225 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 148 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034240 | 0, i5, i6, 0) | 0;
 if (!i1) {
  __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i8);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i6 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 34; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 34; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i8);
 STACKTOP = i10;
 return;
}

function __ZN13MonoBehaviour18GetScriptClassNameEv(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i5 + 36 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i2 = 0; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i9 = HEAP32[i3 + 28 >> 2] | 0;
   i4 = HEAP32[i3 + 32 >> 2] | 0;
   i2 = i9 + (i4 << 3) | 0;
   i3 = i9;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i3, i2);
   i2 = HEAP32[i6 >> 2] | 0;
   i9 = HEAP32[i3 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i9 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 if (i2 | 0) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0) | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i9 = i4 << 24 >> 24 < 0;
  i3 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
  i4 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i7 = 12;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i7 = 14;
  } else i7 = 12;
  if ((i7 | 0) == 12) {
   i5 = i4 + 16 & -16;
   HEAP32[i6 >> 2] = 66;
   HEAP32[i6 + 4 >> 2] = i2;
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i9;
   i7 = 14;
  }
  if ((i7 | 0) == 14) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 + 56 >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i2 | 0) {
   i3 = __Z24scripting_class_get_nameP11Il2CppClass(i2) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   i4 = _strlen(i3) | 0;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i7 = 22;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i4;
    if (i4) i7 = 24;
   } else i7 = 22;
   if ((i7 | 0) == 22) {
    i5 = i4 + 16 & -16;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i6 + 4 >> 2] = i2;
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i9;
    HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i9;
    i7 = 24;
   }
   if ((i7 | 0) == 24) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   STACKTOP = i8;
   return;
  }
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb(i13, i2, i1, i14, i15) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 8 | 0;
 i17 = i19;
 i12 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i3 | 0) == (i8 | 0)) {
  STACKTOP = i19;
  return;
 }
 i9 = i14 + 12 | 0;
 i10 = i14 + 16 | 0;
 i11 = i14 + 4 | 0;
 i2 = i3;
 L4 : while (1) {
  i6 = i2 + 32 | 0;
  __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb(i13, i6, 1);
  i5 = i2 + 40 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (i2 | 0) {
   HEAP32[i17 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i18 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i2, i17);
     i3 = HEAP32[i16 >> 2] | 0;
     i7 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i18 = 9; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i18 = 11;
    }
   }
   if ((i18 | 0) == 9) i18 = 11;
   if ((i18 | 0) == 11) {
    i18 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) break;
   }
   i7 = i2;
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
   if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i2) | 0, i12) | 0) {
    __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb(i13, i6, 0);
    i3 = HEAP32[i9 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i2 = i5 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i10 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
      HEAP32[i10 >> 2] = i2;
      HEAP32[i14 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i9 >> 2] = i4;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i3 << 2) >> 2] = i7;
    if (i15) {
     i18 = 24;
     break L4;
    }
   }
  } while (0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i8 | 0)) {
   i18 = 24;
   break;
  } else i1 = i2;
 }
 if ((i18 | 0) == 24) {
  STACKTOP = i19;
  return;
 }
}

function __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i6 = i9 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i7 + 4;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i8 + 8 >> 2] = i4;
 __ZN15SerializeTraitsI22OffsetPtrArrayTransferIKN4math7_float3EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i8, i9);
 i4 = i7 + 12 | 0;
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 << 4) | 0;
 if (i5 | 0) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i7 + 20;
 HEAP32[i8 + 4 >> 2] = i7 + 16;
 HEAP32[i8 + 8 >> 2] = i1;
 __ZN15SerializeTraitsI22OffsetPtrArrayTransferIKN4math7_float3EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i8, i9);
 i1 = i7 + 28 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i7 + 36 | 0;
 i5 = i7 + 32 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i4 = i7 + 44 | 0;
 i5 = i7 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN14AnimationEvent8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i9 = i3 + 16 | 0;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034360 | 0, i7, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898233 | 0, i10, i1 + 4 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 1);
 i8 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i1 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i8, i9, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898246 | 0, HEAP32[gb + 37176 >> 2] | 0, i9, 0);
 i8 = i6 + 8 | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898271 | 0, i7, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898286 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898299 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f14 = Math_fround(f10 + f12);
 f6 = Math_fround(f9 + f7);
 f13 = Math_fround(f8 + f5);
 f3 = Math_fround(f4 + f15);
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f6 * f6)) + Math_fround(f13 * f13)))));
 HEAPF32[i2 >> 2] = Math_fround(f14 * f11);
 HEAPF32[i2 + 4 >> 2] = Math_fround(f6 * f11);
 HEAPF32[i2 + 8 >> 2] = Math_fround(f13 * f11);
 HEAPF32[i2 + 12 >> 2] = Math_fround(f11 * f3);
 f12 = Math_fround(f10 - f12);
 f7 = Math_fround(f9 - f7);
 f5 = Math_fround(f8 - f5);
 f15 = Math_fround(f4 - f15);
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f7 * f7)) + Math_fround(f5 * f5)))));
 HEAPF32[i2 + 16 >> 2] = Math_fround(f12 * f3);
 HEAPF32[i2 + 20 >> 2] = Math_fround(f7 * f3);
 HEAPF32[i2 + 24 >> 2] = Math_fround(f5 * f3);
 HEAPF32[i2 + 28 >> 2] = Math_fround(f3 * f15);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f12 = Math_fround(f10 + f15);
 f11 = Math_fround(f9 + f3);
 f13 = Math_fround(f8 + f5);
 f6 = Math_fround(f4 + f7);
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(f13 * f13)))));
 HEAPF32[i2 + 32 >> 2] = Math_fround(f12 * f14);
 HEAPF32[i2 + 36 >> 2] = Math_fround(f11 * f14);
 HEAPF32[i2 + 40 >> 2] = Math_fround(f13 * f14);
 HEAPF32[i2 + 44 >> 2] = Math_fround(f14 * f6);
 f15 = Math_fround(f10 - f15);
 f3 = Math_fround(f9 - f3);
 f5 = Math_fround(f8 - f5);
 f7 = Math_fround(f4 - f7);
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f3 * f3)) + Math_fround(f5 * f5)))));
 HEAPF32[i2 + 48 >> 2] = Math_fround(f15 * f6);
 HEAPF32[i2 + 52 >> 2] = Math_fround(f3 * f6);
 HEAPF32[i2 + 56 >> 2] = Math_fround(f5 * f6);
 HEAPF32[i2 + 60 >> 2] = Math_fround(f6 * f7);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f15 = Math_fround(f10 + f7);
 f14 = Math_fround(f9 + f6);
 f13 = Math_fround(f8 + f5);
 f11 = Math_fround(f4 + f3);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(f13 * f13)))));
 HEAPF32[i2 + 64 >> 2] = Math_fround(f15 * f12);
 HEAPF32[i2 + 68 >> 2] = Math_fround(f14 * f12);
 HEAPF32[i2 + 72 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i2 + 76 >> 2] = Math_fround(f12 * f11);
 f7 = Math_fround(f10 - f7);
 f6 = Math_fround(f9 - f6);
 f5 = Math_fround(f8 - f5);
 f3 = Math_fround(f4 - f3);
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)))));
 HEAPF32[i2 + 80 >> 2] = Math_fround(f7 * f4);
 HEAPF32[i2 + 84 >> 2] = Math_fround(f6 * f4);
 HEAPF32[i2 + 88 >> 2] = Math_fround(f5 * f4);
 HEAPF32[i2 + 92 >> 2] = Math_fround(f4 * f3);
 return;
}

function runPostSets42() {
 HEAP32[gb + 58956 >> 2] = fb + 480;
 HEAP32[gb + 58960 >> 2] = fb + 16;
 HEAP32[gb + 58964 >> 2] = fb + 364;
 HEAP32[gb + 58968 >> 2] = fb + 624;
 HEAP32[gb + 58972 >> 2] = fb + 625;
 HEAP32[gb + 58976 >> 2] = fb + 274;
 HEAP32[gb + 58980 >> 2] = fb + 103;
 HEAP32[gb + 58984 >> 2] = fb + 101;
 HEAP32[gb + 58988 >> 2] = fb + 62;
 HEAP32[gb + 58992 >> 2] = fb + 28;
 HEAP32[gb + 58996 >> 2] = fb + 63;
 HEAP32[gb + 59e3 >> 2] = fb + 29;
 HEAP32[gb + 59004 >> 2] = fb + 34;
 HEAP32[gb + 59008 >> 2] = fb + 481;
 HEAP32[gb + 59012 >> 2] = fb + 482;
 HEAP32[gb + 59016 >> 2] = fb + 483;
 HEAP32[gb + 59020 >> 2] = fb + 484;
 HEAP32[gb + 59024 >> 2] = fb + 485;
 HEAP32[gb + 59028 >> 2] = fb + 486;
 HEAP32[gb + 59032 >> 2] = fb + 36;
 HEAP32[gb + 59036 >> 2] = fb + 104;
 HEAP32[gb + 59040 >> 2] = fb + 336;
 HEAP32[gb + 59044 >> 2] = fb + 94;
 HEAP32[gb + 59048 >> 2] = fb + 337;
 HEAP32[gb + 59052 >> 2] = fb + 205;
 HEAP32[gb + 59056 >> 2] = fb + 206;
 HEAP32[gb + 59060 >> 2] = fb + 338;
 HEAP32[gb + 59064 >> 2] = fb + 350;
 HEAP32[gb + 59068 >> 2] = fb + 351;
 HEAP32[gb + 59072 >> 2] = fb + 207;
 HEAP32[gb + 59076 >> 2] = fb + 626;
 HEAP32[gb + 59080 >> 2] = fb + 627;
 HEAP32[gb + 59084 >> 2] = fb + 208;
 HEAP32[gb + 59088 >> 2] = fb + 68;
 HEAP32[gb + 59092 >> 2] = fb + 69;
 HEAP32[gb + 59096 >> 2] = fb + 366;
 HEAP32[gb + 59100 >> 2] = fb + 355;
 HEAP32[gb + 59104 >> 2] = fb + 356;
 HEAP32[gb + 59108 >> 2] = fb + 42;
 HEAP32[gb + 59120 >> 2] = fb + 628;
 HEAP32[gb + 59124 >> 2] = fb + 629;
 HEAP32[gb + 59128 >> 2] = fb + 43;
 HEAP32[gb + 59132 >> 2] = fb + 102;
 HEAP32[gb + 59136 >> 2] = fb + 359;
 HEAP32[gb + 59140 >> 2] = fb + 360;
 HEAP32[gb + 59144 >> 2] = fb + 209;
 HEAP32[gb + 59148 >> 2] = fb + 210;
 HEAP32[gb + 59152 >> 2] = fb + 70;
 HEAP32[gb + 59156 >> 2] = fb + 71;
 HEAP32[gb + 59160 >> 2] = fb + 110;
 HEAP32[gb + 59164 >> 2] = fb + 105;
 HEAP32[gb + 59168 >> 2] = fb + 630;
 HEAP32[gb + 59180 >> 2] = fb + 7;
 HEAP32[gb + 59184 >> 2] = fb + 7;
 HEAP32[gb + 59188 >> 2] = fb + 41;
 HEAP32[gb + 59192 >> 2] = fb + 78;
 HEAP32[gb + 59196 >> 2] = fb + 24;
 HEAP32[gb + 59200 >> 2] = fb + 25;
 HEAP32[gb + 59204 >> 2] = fb + 24;
 HEAP32[gb + 59208 >> 2] = fb + 9;
 HEAP32[gb + 59252 >> 2] = fb + 631;
 HEAP32[gb + 59256 >> 2] = fb + 632;
 HEAP32[gb + 59260 >> 2] = fb + 633;
 HEAP32[gb + 59264 >> 2] = fb + 487;
 HEAP32[gb + 59268 >> 2] = fb + 634;
 HEAP32[gb + 59272 >> 2] = fb + 39;
 HEAP32[gb + 59276 >> 2] = fb + 635;
 HEAP32[gb + 59280 >> 2] = fb + 19;
 HEAP32[gb + 59284 >> 2] = fb + 275;
 HEAP32[gb + 59288 >> 2] = fb + 31;
 HEAP32[gb + 59292 >> 2] = fb + 27;
 HEAP32[gb + 59296 >> 2] = fb + 62;
 HEAP32[gb + 59300 >> 2] = fb + 28;
 HEAP32[gb + 59304 >> 2] = fb + 276;
 HEAP32[gb + 59308 >> 2] = fb + 29;
 HEAP32[gb + 59312 >> 2] = fb + 34;
 HEAP32[gb + 59316 >> 2] = fb + 488;
 HEAP32[gb + 59320 >> 2] = fb + 489;
 HEAP32[gb + 59324 >> 2] = fb + 490;
 HEAP32[gb + 59328 >> 2] = fb + 491;
 HEAP32[gb + 59332 >> 2] = fb + 492;
 HEAP32[gb + 59336 >> 2] = fb + 493;
 HEAP32[gb + 59340 >> 2] = fb + 36;
 HEAP32[gb + 59352 >> 2] = fb + 636;
 HEAP32[gb + 59356 >> 2] = fb + 637;
 HEAP32[gb + 59368 >> 2] = fb + 638;
 HEAP32[gb + 59372 >> 2] = fb + 639;
 HEAP32[gb + 59376 >> 2] = fb + 640;
 HEAP32[gb + 59380 >> 2] = fb + 494;
 HEAP32[gb + 59384 >> 2] = fb + 641;
 HEAP32[gb + 59388 >> 2] = fb + 17;
 HEAP32[gb + 59392 >> 2] = fb + 18;
 HEAP32[gb + 59396 >> 2] = fb + 19;
 HEAP32[gb + 59400 >> 2] = fb + 277;
 HEAP32[gb + 59404 >> 2] = fb + 31;
 HEAP32[gb + 59408 >> 2] = fb + 27;
 HEAP32[gb + 59412 >> 2] = fb + 278;
 HEAP32[gb + 59416 >> 2] = fb + 28;
 HEAP32[gb + 59420 >> 2] = fb + 63;
 HEAP32[gb + 59424 >> 2] = fb + 29;
 runPostSets43();
}

function runPostSets35() {
 HEAP32[gb + 45580 >> 2] = fb + 406;
 HEAP32[gb + 45584 >> 2] = fb + 407;
 HEAP32[gb + 45588 >> 2] = fb + 315;
 HEAP32[gb + 45592 >> 2] = fb + 305;
 HEAP32[gb + 45596 >> 2] = fb + 316;
 HEAP32[gb + 45600 >> 2] = fb + 17;
 HEAP32[gb + 45604 >> 2] = fb + 317;
 HEAP32[gb + 45608 >> 2] = fb + 19;
 HEAP32[gb + 45612 >> 2] = fb + 239;
 HEAP32[gb + 45616 >> 2] = fb + 31;
 HEAP32[gb + 45620 >> 2] = fb + 27;
 HEAP32[gb + 45624 >> 2] = fb + 32;
 HEAP32[gb + 45628 >> 2] = fb + 28;
 HEAP32[gb + 45632 >> 2] = fb + 190;
 HEAP32[gb + 45636 >> 2] = fb + 29;
 HEAP32[gb + 45640 >> 2] = fb + 34;
 HEAP32[gb + 45644 >> 2] = fb + 389;
 HEAP32[gb + 45648 >> 2] = fb + 390;
 HEAP32[gb + 45652 >> 2] = fb + 391;
 HEAP32[gb + 45656 >> 2] = fb + 392;
 HEAP32[gb + 45660 >> 2] = fb + 393;
 HEAP32[gb + 45664 >> 2] = fb + 394;
 HEAP32[gb + 45668 >> 2] = fb + 36;
 HEAP32[gb + 45672 >> 2] = fb + 318;
 HEAP32[gb + 45676 >> 2] = fb + 191;
 HEAP32[gb + 45680 >> 2] = fb + 192;
 HEAP32[gb + 45684 >> 2] = fb + 193;
 HEAP32[gb + 45688 >> 2] = fb + 312;
 HEAP32[gb + 45692 >> 2] = fb + 38;
 HEAP32[gb + 45696 >> 2] = fb + 39;
 HEAP32[gb + 45700 >> 2] = fb + 40;
 HEAP32[gb + 45704 >> 2] = fb + 41;
 HEAP32[gb + 45708 >> 2] = fb + 194;
 HEAP32[gb + 45712 >> 2] = fb + 195;
 HEAP32[gb + 45716 >> 2] = fb + 196;
 HEAP32[gb + 45720 >> 2] = fb + 197;
 HEAP32[gb + 45724 >> 2] = fb + 46;
 HEAP32[gb + 45728 >> 2] = fb + 240;
 HEAP32[gb + 45732 >> 2] = fb + 48;
 HEAP32[gb + 45736 >> 2] = fb + 200;
 HEAP32[gb + 45740 >> 2] = fb + 313;
 HEAP32[gb + 45744 >> 2] = fb + 319;
 HEAP32[gb + 45748 >> 2] = fb + 6;
 HEAP32[gb + 45752 >> 2] = fb + 408;
 HEAP32[gb + 45756 >> 2] = fb + 395;
 HEAP32[gb + 45760 >> 2] = fb + 315;
 HEAP32[gb + 45764 >> 2] = fb + 201;
 HEAP32[gb + 45768 >> 2] = fb + 5;
 HEAP32[gb + 45772 >> 2] = fb + 321;
 HEAP32[gb + 45776 >> 2] = fb + 322;
 HEAP32[gb + 45780 >> 2] = fb + 409;
 HEAP32[gb + 46040 >> 2] = fb + 410;
 HEAP32[gb + 46044 >> 2] = fb + 411;
 HEAP32[gb + 46048 >> 2] = fb + 412;
 HEAP32[gb + 46052 >> 2] = fb + 396;
 HEAP32[gb + 46056 >> 2] = fb + 16;
 HEAP32[gb + 46060 >> 2] = fb + 17;
 HEAP32[gb + 46064 >> 2] = fb + 413;
 HEAP32[gb + 46068 >> 2] = fb + 19;
 HEAP32[gb + 46072 >> 2] = fb + 241;
 HEAP32[gb + 46076 >> 2] = fb + 31;
 HEAP32[gb + 46080 >> 2] = fb + 27;
 HEAP32[gb + 46084 >> 2] = fb + 32;
 HEAP32[gb + 46088 >> 2] = fb + 28;
 HEAP32[gb + 46092 >> 2] = fb + 242;
 HEAP32[gb + 46096 >> 2] = fb + 29;
 HEAP32[gb + 46100 >> 2] = fb + 34;
 HEAP32[gb + 46104 >> 2] = fb + 397;
 HEAP32[gb + 46108 >> 2] = fb + 398;
 HEAP32[gb + 46112 >> 2] = fb + 399;
 HEAP32[gb + 46116 >> 2] = fb + 400;
 HEAP32[gb + 46120 >> 2] = fb + 401;
 HEAP32[gb + 46124 >> 2] = fb + 402;
 HEAP32[gb + 46128 >> 2] = fb + 36;
 HEAP32[gb + 46132 >> 2] = fb + 20;
 HEAP32[gb + 46136 >> 2] = fb + 35;
 HEAP32[gb + 46140 >> 2] = fb + 36;
 HEAP32[gb + 46144 >> 2] = fb + 37;
 HEAP32[gb + 46148 >> 2] = fb + 37;
 HEAP32[gb + 46152 >> 2] = fb + 38;
 HEAP32[gb + 46156 >> 2] = fb + 39;
 HEAP32[gb + 46160 >> 2] = fb + 40;
 HEAP32[gb + 46164 >> 2] = fb + 41;
 HEAP32[gb + 46168 >> 2] = fb + 42;
 HEAP32[gb + 46172 >> 2] = fb + 243;
 HEAP32[gb + 46176 >> 2] = fb + 244;
 HEAP32[gb + 46180 >> 2] = fb + 245;
 HEAP32[gb + 46184 >> 2] = fb + 246;
 HEAP32[gb + 46188 >> 2] = fb + 247;
 HEAP32[gb + 46192 >> 2] = fb + 48;
 HEAP32[gb + 46196 >> 2] = fb + 248;
 HEAP32[gb + 46200 >> 2] = fb + 403;
 HEAP32[gb + 46204 >> 2] = fb + 414;
 HEAP32[gb + 46208 >> 2] = fb + 12;
 HEAP32[gb + 46220 >> 2] = fb + 415;
 HEAP32[gb + 46224 >> 2] = fb + 416;
 HEAP32[gb + 46228 >> 2] = fb + 417;
 HEAP32[gb + 46232 >> 2] = fb + 404;
 HEAP32[gb + 46236 >> 2] = fb + 16;
 HEAP32[gb + 46240 >> 2] = fb + 17;
 runPostSets36();
}

function __ZN15dtLocalBoundary6updateEyPKffPK14dtNavMeshQueryPK13dtQueryFilter(i11, i1, i2, i16, f3, i17, i18) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 f3 = Math_fround(f3);
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23 + 144 | 0;
 i20 = i23 + 712 | 0;
 i21 = i23 + 280 | 0;
 i12 = i23;
 i13 = i23 + 276 | 0;
 i14 = i23 + 272 | 0;
 i15 = HEAP32[i17 >> 2] | 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  HEAPF32[i11 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i11 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i11 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i11 + 236 >> 2] = 0;
  STACKTOP = i23;
  return;
 }
 HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i20 >> 2] = 0;
 __ZNK14dtNavMeshQuery22findLocalNeighbourhoodEyPKffPK13dtQueryFilterPyS5_Pii(i17, i1, i2, i16, f3, i18, i19, 0, i20, 16) | 0;
 i10 = i11 + 236 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if ((HEAP32[i20 >> 2] | 0) > 0) {
  f7 = Math_fround(f3 * f3);
  i8 = i11 + 12 | 0;
  i9 = i18 + 128 | 0;
  i6 = 0;
  do {
   i5 = i19 + (i6 << 3) | 0;
   __ZNK14dtNavMeshQuery19getPolyWallSegmentsEyPK13dtQueryFilterPfPyPii(i17, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i18, i21, i12, i13, 18) | 0;
   if ((HEAP32[i13 >> 2] | 0) > 0) {
    i5 = 0;
    do {
     i2 = i12 + (i5 << 3) | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if ((i1 | 0) == 0 & (i2 | 0) == 0) i22 = 10; else {
      i4 = __ZNK9dtNavMesh12getPolyFlagsEy(i15, i1, i2) | 0;
      if (!(HEAP32[i9 >> 2] & i4)) i22 = 10;
     }
     if ((i22 | 0) == 10) {
      i22 = 0;
      i4 = i21 + (i5 * 6 << 2) | 0;
      f3 = Math_fround(__Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i16, i4, i4 + 12 | 0, i14));
      L16 : do if (!(f3 > f7)) {
       i2 = HEAP32[i10 >> 2] | 0;
       do if (!i2) i1 = i8; else {
        if (Math_fround(HEAPF32[i11 + 12 + ((i2 + -1 | 0) * 28 | 0) + 24 >> 2]) <= f3) {
         if ((i2 | 0) > 7) break L16;
         i1 = i11 + 12 + (i2 * 28 | 0) | 0;
         break;
        }
        L24 : do if ((i2 | 0) > 0) {
         i1 = 0;
         do {
          if (Math_fround(HEAPF32[i11 + 12 + (i1 * 28 | 0) + 24 >> 2]) >= f3) break L24;
          i1 = i1 + 1 | 0;
         } while ((i1 | 0) < (i2 | 0));
        } else i1 = 0; while (0);
        if ((i2 | 0) == (i1 | 0)) break L16;
        i24 = i2 - i1 | 0;
        i2 = 7 - i1 | 0;
        i2 = (i24 | 0) < (i2 | 0) ? i24 : i2;
        if ((i2 | 0) > 0) {
         i24 = i11 + 12 + (i1 * 28 | 0) | 0;
         _memmove(i11 + 12 + ((i1 + 1 | 0) * 28 | 0) | 0, i24 | 0, i2 * 28 | 0) | 0;
         i1 = i24;
         break;
        } else {
         i1 = i11 + 12 + (i1 * 28 | 0) | 0;
         break;
        }
       } while (0);
       HEAPF32[i1 + 24 >> 2] = f3;
       HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
       HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
       HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
       HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
       HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
       HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
       i1 = HEAP32[i10 >> 2] | 0;
       if ((i1 | 0) < 8) HEAP32[i10 >> 2] = i1 + 1;
      } while (0);
     }
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) < (HEAP32[i13 >> 2] | 0));
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (HEAP32[i20 >> 2] | 0));
 }
 STACKTOP = i23;
 return;
}

function __ZN13RenderManager9AddCameraEP6Camera(i2, i9) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i3 = i14;
 i12 = (i9 | 0) == 0;
 if (i12) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 if (HEAP8[i2 + 52 >> 0] | 0) {
  __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i2 + 40 | 0, i3);
  i13 = i2 + 28 | 0;
  i12 = __Znwj(12) | 0;
  HEAP32[i12 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 + 4 >> 2] = i13;
  i11 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i13 >> 2] = i12;
  i13 = i2 + 36 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  STACKTOP = i14;
  return;
 }
 if (i12) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i2 + 28 | 0, i10);
 if (i12) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i2 + 40 | 0, i10);
 i1 = i2 + 4 | 0;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i1, i3);
 i8 = i2 + 16 | 0;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i8, i3);
 i2 = (__ZNK6Camera16GetTargetTextureEv(i9) | 0) == 0;
 i8 = i2 ? i1 : i8;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i1;
 L14 : do if ((i2 | 0) != (i8 | 0)) {
  i7 = i9 + 888 | 0;
  i6 = i2;
  L16 : while (1) {
   i5 = i1 + 8 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   do if (i2 | 0) {
    HEAP32[i11 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i13 = 17; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i11);
      i3 = HEAP32[i10 >> 2] | 0;
      i15 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 17; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i13 = 19;
     }
    }
    if ((i13 | 0) == 17) i13 = 19;
    if ((i13 | 0) == 19) {
     i13 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i2) break;
    }
    f16 = Math_fround(HEAPF32[i2 + 888 >> 2]);
    if (f16 > Math_fround(HEAPF32[i7 >> 2])) break L16;
   } while (0);
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i8 | 0)) break L14; else i6 = i2;
  }
  i13 = HEAP32[i9 + 4 >> 2] | 0;
  i15 = __Znwj(12) | 0;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = i13;
  i13 = HEAP32[i6 >> 2] | 0;
  HEAP32[i13 + 4 >> 2] = i15;
  HEAP32[i15 >> 2] = i13;
  HEAP32[i1 >> 2] = i15;
  HEAP32[i15 + 4 >> 2] = i6;
  i15 = i8 + 8 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  STACKTOP = i14;
  return;
 } while (0);
 if (i12) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = __Znwj(12) | 0;
 HEAP32[i15 + 8 >> 2] = i1;
 HEAP32[i15 + 4 >> 2] = i8;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i8 >> 2] = i15;
 i15 = i8 + 8 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN5audio5mixer14GetGroupVUInfoERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDbPNS0_6VUInfoE(i1, i11, i4, i10, i16) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i13 = i17 + 4 | 0;
 if (!(HEAP8[gb + 1553737 >> 0] | 0)) {
  f3 = Math_fround(_exp2f(Math_fround(Math_fround(_log2f(Math_fround(10.0))) * Math_fround(-4.0))));
  HEAPF32[gb + 1465156 >> 2] = f3;
  HEAP8[gb + 1553737 >> 0] = 1;
 }
 i9 = HEAP32[i1 >> 2] | 0;
 if (!i9) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i5 = i1 + 8 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i15 = 0;
 while (1) {
  if ((HEAP32[i5 + (i15 << 4) >> 2] | 0) == (i6 | 0)) if ((HEAP32[i5 + (i15 << 4) + 4 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i5 + (i15 << 4) + 8 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i5 + (i15 << 4) + 12 >> 2] | 0) == (i4 | 0)) break;
  i1 = i15 + 1 | 0;
  if (i1 >>> 0 < i9 >>> 0) i15 = i1; else {
   i1 = 0;
   i14 = 26;
   break;
  }
 }
 if ((i14 | 0) == 26) {
  STACKTOP = i17;
  return i1 | 0;
 }
 if ((i15 | 0) == -1) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 if (i10) {
  i1 = HEAP32[i11 + 8 >> 2] | 0;
  if (!(HEAP32[i1 + (i15 << 8) + 28 >> 2] & 1)) i14 = 13; else i4 = i1;
 } else i14 = 13;
 if ((i14 | 0) == 13) i4 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
 if (!i1) i14 = 16; else {
  __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(i1, i12) | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) i14 = 16; else {
   HEAP8[i13 >> 0] = 0;
   i12 = __ZN4FMOD3DSP9getActiveEPb(i1, i13) | 0;
   if ((i12 | 0) != 0 | (HEAP8[i13 >> 0] | 0) == 0) {
    HEAPF32[i16 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 36 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 4 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 40 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 8 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 44 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 12 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 48 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 16 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 52 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 20 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 56 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 24 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 60 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 28 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 64 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 32 >> 2] = Math_fround(-80.0);
    HEAPF32[i16 + 68 >> 2] = Math_fround(-80.0);
   } else i14 = 17;
  }
 }
 if ((i14 | 0) == 16) i14 = 17;
 if ((i14 | 0) == 17) {
  i1 = 0;
  f3 = Math_fround(HEAPF32[gb + 1465156 >> 2]);
  do {
   f2 = Math_fround(Math_sqrt(Math_fround(HEAPF32[i4 + (i15 << 8) + 36 + (i1 * 24 | 0) + 8 >> 2])));
   if (f2 < f3) f2 = Math_fround(-80.0); else f2 = Math_fround(Math_fround(_log10f(f2)) * Math_fround(20.0));
   HEAPF32[i16 + (i1 << 2) >> 2] = f2;
   f2 = Math_fround(Math_sqrt(Math_fround(HEAPF32[i4 + (i15 << 8) + 36 + (i1 * 24 | 0) + 12 >> 2])));
   f3 = Math_fround(HEAPF32[gb + 1465156 >> 2]);
   if (f2 < f3) f2 = Math_fround(-80.0); else f2 = Math_fround(Math_fround(_log10f(f2)) * Math_fround(20.0));
   HEAPF32[i16 + 36 + (i1 << 2) >> 2] = f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 9);
 }
 i16 = __ZNK12AudioManager15GetSpeakerCountEv(__Z15GetAudioManagerv() | 0) | 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __Z26GetHaloVertexPositionsMonoP8Vector3fRKS_ff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 f4 = Math_fround(Math_fround(f3 * Math_fround(.333000004)) + f4);
 i5 = i2 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAPF32[i1 + 8 >> 2] = f4;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = i7;
 HEAPF32[i1 + 20 >> 2] = f4;
 f8 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 8 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAP32[i1 + 28 >> 2] = i7;
 HEAP32[i1 + 32 >> 2] = i10;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 40 >> 2] = i10;
 HEAPF32[i1 + 44 >> 2] = f4;
 f8 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3);
 i10 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 48 >> 2] = f8;
 HEAPF32[i1 + 52 >> 2] = f9;
 HEAP32[i1 + 56 >> 2] = i10;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 64 >> 2] = i10;
 HEAPF32[i1 + 68 >> 2] = f4;
 f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3);
 i10 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 76 >> 2] = f9;
 HEAP32[i1 + 80 >> 2] = i10;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 88 >> 2] = i10;
 HEAPF32[i1 + 92 >> 2] = f4;
 f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f3);
 f8 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3);
 i10 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 96 >> 2] = f9;
 HEAPF32[i1 + 100 >> 2] = f8;
 HEAP32[i1 + 104 >> 2] = i10;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 108 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 112 >> 2] = i10;
 HEAPF32[i1 + 116 >> 2] = f4;
 f8 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f3);
 i10 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 120 >> 2] = f8;
 HEAP32[i1 + 124 >> 2] = i10;
 HEAP32[i1 + 128 >> 2] = i7;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 132 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 136 >> 2] = i7;
 HEAPF32[i1 + 140 >> 2] = f4;
 f8 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f3);
 f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f3);
 i7 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 144 >> 2] = f8;
 HEAPF32[i1 + 148 >> 2] = f9;
 HEAP32[i1 + 152 >> 2] = i7;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 156 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 160 >> 2] = i7;
 HEAPF32[i1 + 164 >> 2] = f4;
 f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f3);
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 + 168 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 172 >> 2] = f9;
 HEAP32[i1 + 176 >> 2] = i7;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 180 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 184 >> 2] = i7;
 HEAPF32[i1 + 188 >> 2] = f4;
 f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 f8 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f3);
 i7 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 192 >> 2] = f9;
 HEAPF32[i1 + 196 >> 2] = f8;
 HEAP32[i1 + 200 >> 2] = i7;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 204 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 208 >> 2] = i7;
 HEAPF32[i1 + 212 >> 2] = f4;
 f3 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i1 + 216 >> 2] = f3;
 HEAP32[i1 + 220 >> 2] = i7;
 HEAP32[i1 + 224 >> 2] = i6;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 228 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 232 >> 2] = i6;
 HEAPF32[i1 + 236 >> 2] = f4;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 240 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 244 >> 2] = i5;
 HEAPF32[i1 + 248 >> 2] = f4;
 return;
}

function __Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags(i8, i6, i9, i7, i2) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 >= i6 >>> 0) {
  i6 = i3;
  i10 = 0;
  i7 = i1;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i9 >> 2] = i7;
  return i10 | 0;
 }
 L4 : do if (!i2) {
  while (1) {
   i5 = i3 + 2 | 0;
   i2 = HEAP16[i3 >> 1] | 0;
   i4 = i2 & 65535;
   i2 = i2 & -1024;
   if (i5 >>> 0 < i6 >>> 0 & i2 << 16 >> 16 == -10240) {
    i2 = HEAP16[i5 >> 1] | 0;
    if ((i2 & -1024) << 16 >> 16 != -9216) {
     i2 = 3;
     i10 = 33;
     break;
    }
    i4 = (i4 << 10) + -56613888 + (i2 & 65535) | 0;
    i5 = i3 + 4 | 0;
   } else if (i2 << 16 >> 16 == -9216) {
    i2 = 3;
    i10 = 33;
    break;
   }
   if (i4 >>> 0 < 128) i2 = 1; else if (i4 >>> 0 < 2048) i2 = 2; else if (i4 >>> 0 < 65536) i2 = 3; else {
    i11 = i4 >>> 0 < 2097152;
    i2 = i11 ? 4 : 2;
    i4 = i11 ? i4 : 65533;
   }
   i1 = i1 + i2 | 0;
   if (i1 >>> 0 > i7 >>> 0) break L4;
   switch (i2 & 7) {
   case 4:
    {
     i1 = i1 + -1 | 0;
     HEAP8[i1 >> 0] = i4 & 63 | 128;
     i3 = i4 >>> 6;
     i10 = 14;
     break;
    }
   case 3:
    {
     i3 = i4;
     i10 = 14;
     break;
    }
   case 2:
    {
     i3 = i4;
     i10 = 15;
     break;
    }
   case 1:
    {
     i3 = i4;
     i10 = 16;
     break;
    }
   default:
    {}
   }
   if ((i10 | 0) == 14) {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i10 = 15;
   }
   if ((i10 | 0) == 15) {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i10 = 16;
   }
   if ((i10 | 0) == 16) {
    i10 = 0;
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = HEAPU8[gb + 584572 + i2 >> 0] | 0 | i3;
   }
   i1 = i1 + i2 | 0;
   if (i5 >>> 0 < i6 >>> 0) i3 = i5; else {
    i3 = i5;
    i2 = 0;
    i10 = 33;
    break;
   }
  }
  if ((i10 | 0) == 33) {
   HEAP32[i8 >> 2] = i3;
   HEAP32[i9 >> 2] = i1;
   return i2 | 0;
  }
 } else {
  while (1) {
   i5 = i3 + 2 | 0;
   i11 = HEAP16[i3 >> 1] | 0;
   i2 = i11 & 65535;
   if (i5 >>> 0 < i6 >>> 0 & (i11 & -1024) << 16 >> 16 == -10240) {
    i4 = HEAP16[i5 >> 1] | 0;
    if ((i4 & -1024) << 16 >> 16 == -9216) {
     i4 = (i2 << 10) + -56613888 + (i4 & 65535) | 0;
     i5 = i3 + 4 | 0;
    } else i4 = i2;
   } else i4 = i2;
   if (i4 >>> 0 < 128) i2 = 1; else if (i4 >>> 0 < 2048) i2 = 2; else if (i4 >>> 0 < 65536) i2 = 3; else {
    i11 = i4 >>> 0 < 2097152;
    i2 = i11 ? 4 : 2;
    i4 = i11 ? i4 : 65533;
   }
   i1 = i1 + i2 | 0;
   if (i1 >>> 0 > i7 >>> 0) break L4;
   switch (i2 & 7) {
   case 4:
    {
     i1 = i1 + -1 | 0;
     HEAP8[i1 >> 0] = i4 & 63 | 128;
     i3 = i4 >>> 6;
     i10 = 29;
     break;
    }
   case 3:
    {
     i3 = i4;
     i10 = 29;
     break;
    }
   case 2:
    {
     i3 = i4;
     i10 = 30;
     break;
    }
   case 1:
    {
     i3 = i4;
     i10 = 31;
     break;
    }
   default:
    {}
   }
   if ((i10 | 0) == 29) {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i10 = 30;
   }
   if ((i10 | 0) == 30) {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i10 = 31;
   }
   if ((i10 | 0) == 31) {
    i10 = 0;
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = HEAPU8[gb + 584572 + i2 >> 0] | 0 | i3;
   }
   i1 = i1 + i2 | 0;
   if (i5 >>> 0 < i6 >>> 0) i3 = i5; else {
    i3 = i5;
    i2 = 0;
    break;
   }
  }
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  return i2 | 0;
 } while (0);
 i7 = i3;
 i11 = 2;
 i10 = i1 + (0 - i2) | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i9 >> 2] = i10;
 return i11 | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i4, i15, i11, i1) {
 i4 = i4 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i3 = (i11 | 0) != 0;
 if (i3) i13 = i1; else i13 = HEAPU16[i4 + 24 >> 1] | 0;
 i2 = i13 << 2;
 i12 = i2 >>> 0 > 1024;
 i14 = i16 + 4 | 0;
 HEAP8[i14 >> 0] = i12 & 1;
 if (i12) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i17 + 8 | 0, i2, gb + 707831 | 0, 388) | 0;
  HEAP32[i16 >> 2] = i1;
  if (i1 | 0) {
   i12 = i16;
   i10 = 6;
  }
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i16 >> 2] = i1;
  i12 = i16;
  i10 = 6;
 }
 L7 : do if ((i10 | 0) == 6) {
  L9 : do if (i3) {
   if (!i13) break L7;
   i8 = i15 + 4 | 0;
   i9 = i15 + 8 | 0;
   i7 = i1;
   i1 = 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
    i6 = i3 + 32 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    L14 : do if (!(i4 & 8)) i10 = 18; else {
     i3 = HEAP32[i3 + 36 >> 2] | 0;
     if ((i3 & 251658240 | 0) == 16777216) if ((i3 & -1073741824 | 0) == 1073741824) break; else {
      i10 = 18;
      break;
     }
     i3 = HEAP32[i9 >> 2] | 0;
     if (!i3) {
      i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i4 >>> 24 & 15) | 0;
      HEAP32[i9 >> 2] = i3;
     }
     i5 = HEAP32[i3 + 28 >> 2] | 0;
     if (!i5) i10 = 18; else {
      i3 = HEAP32[i3 + 24 >> 2] | 0;
      i4 = 0;
      while (1) {
       if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == (i6 | 0)) break L14;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 >= i5 >>> 0) {
        i10 = 18;
        break;
       }
      }
     }
    } while (0);
    if ((i10 | 0) == 18) {
     i10 = 0;
     HEAP32[i7 + (i1 << 2) >> 2] = i6;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i13 | 0)) break L9;
    i7 = HEAP32[i12 >> 2] | 0;
   }
  } else {
   i1 = i4 + 20 | 0;
   if ((HEAP16[i4 + 24 >> 1] | 0) == 1) i9 = i1; else i9 = HEAP32[i1 >> 2] | 0;
   if (!i13) break L7;
   i7 = i15 + 4 | 0;
   i8 = i15 + 8 | 0;
   i1 = 0;
   i10 = 0;
   do {
    i11 = HEAP32[i9 + (i10 << 2) >> 2] | 0;
    i5 = i11 + 32 | 0;
    i2 = HEAP32[i11 + 36 >> 2] | 0;
    L38 : do if (HEAP8[((i2 & 64 | 0) == 0 ? i11 + 112 | 0 : (HEAP32[i11 + 40 >> 2] | 0) + 52 | 0) >> 0] & 5) {
     i6 = HEAP32[i12 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     do if (i3 & 8 | 0) {
      if ((i2 & 251658240 | 0) == 16777216) if ((i2 & -1073741824 | 0) == 1073741824) break L38; else break;
      i2 = HEAP32[i8 >> 2] | 0;
      if (!i2) {
       i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i3 >>> 24 & 15) | 0;
       HEAP32[i8 >> 2] = i2;
      }
      i4 = HEAP32[i2 + 28 >> 2] | 0;
      if (i4 | 0) {
       i2 = HEAP32[i2 + 24 >> 2] | 0;
       i3 = 0;
       do {
        if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i5 | 0)) break L38;
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i4 >>> 0);
      }
     } while (0);
     HEAP32[i6 + (i1 << 2) >> 2] = i5;
     i1 = i1 + 1 | 0;
    } while (0);
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i13 | 0));
  } while (0);
  if (i1 | 0) __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj(i15, HEAP32[i12 >> 2] | 0, i1);
 } while (0);
 if (!(HEAP8[i14 >> 0] | 0)) {
  STACKTOP = i17;
  return 1;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i17;
 return 1;
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES7_PNS8_IT0_EE(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = (i7 | 0) == 0 ? 0 : i7 + i8 | 0;
 i7 = i2 + 8 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = (i6 | 0) == 0 ? 0 : i6 + i7 | 0;
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i6 = (i2 | 0) == 0 ? 0 : i2 + i6 | 0;
 i2 = i4 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = (i5 | 0) == 0 ? 0 : i5 + i2 | 0;
 if (!i9) return;
 i4 = (i10 | 0) == 0;
 i3 = 0;
 do {
  L6 : do if (!i4) {
   i5 = HEAP32[i8 + (i3 << 2) >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((i5 | 0) == (HEAP32[i7 + (i1 << 2) >> 2] | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i10 >>> 0) break L6;
   }
   f30 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 28 >> 2]);
   f28 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 32 >> 2]);
   f23 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 36 >> 2]);
   f27 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 16 >> 2]);
   f19 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 12 >> 2]);
   f26 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 24 >> 2]);
   f14 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 20 >> 2]);
   f29 = Math_fround(f27 * Math_fround(-2.0));
   f24 = Math_fround(f27 * Math_fround(2.0));
   f22 = Math_fround(f27 * f29);
   f18 = Math_fround(f14 * Math_fround(-2.0));
   f16 = Math_fround(f14 * Math_fround(2.0));
   f17 = Math_fround(f14 * f18);
   f15 = Math_fround(f19 * Math_fround(2.0));
   f25 = Math_fround(f19 * Math_fround(-2.0));
   f13 = Math_fround(f19 * f25);
   f21 = Math_fround(f30 * Math_fround(Math_fround(f22 + f17) + Math_fround(1.0)));
   f20 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f19 * f24) + Math_fround(f26 * f16)) + Math_fround(0.0)));
   f19 = Math_fround(f30 * Math_fround(Math_fround(Math_fround(f29 * f26) + Math_fround(f19 * f16)) + Math_fround(0.0)));
   f18 = Math_fround(f28 * Math_fround(Math_fround(Math_fround(f27 * f15) + Math_fround(f26 * f18)) + Math_fround(0.0)));
   f17 = Math_fround(f28 * Math_fround(Math_fround(f13 + f17) + Math_fround(1.0)));
   f16 = Math_fround(f28 * Math_fround(Math_fround(Math_fround(f26 * f15) + Math_fround(f27 * f16)) + Math_fround(0.0)));
   f15 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f24 * f26) + Math_fround(f15 * f14)) + Math_fround(0.0)));
   f14 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f24 * f14)) + Math_fround(0.0)));
   f13 = Math_fround(f23 * Math_fround(Math_fround(f22 + f13) + Math_fround(1.0)));
   i12 = HEAP32[i6 + (i3 * 40 | 0) >> 2] | 0;
   i11 = HEAP32[i6 + (i3 * 40 | 0) + 4 >> 2] | 0;
   i5 = HEAP32[i6 + (i3 * 40 | 0) + 8 >> 2] | 0;
   HEAPF32[i2 + (i1 * 48 | 0) >> 2] = f21;
   HEAPF32[i2 + (i1 * 48 | 0) + 4 >> 2] = f20;
   HEAPF32[i2 + (i1 * 48 | 0) + 8 >> 2] = f19;
   HEAPF32[i2 + (i1 * 48 | 0) + 12 >> 2] = f18;
   HEAPF32[i2 + (i1 * 48 | 0) + 16 >> 2] = f17;
   HEAPF32[i2 + (i1 * 48 | 0) + 20 >> 2] = f16;
   HEAPF32[i2 + (i1 * 48 | 0) + 24 >> 2] = f15;
   HEAPF32[i2 + (i1 * 48 | 0) + 28 >> 2] = f14;
   HEAPF32[i2 + (i1 * 48 | 0) + 32 >> 2] = f13;
   HEAP32[i2 + (i1 * 48 | 0) + 36 >> 2] = i12;
   HEAP32[i2 + (i1 * 48 | 0) + 40 >> 2] = i11;
   HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] = i5;
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i9 | 0));
 return;
}

function __ZN13WheelCollider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i10 + 148 | 0;
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
  STACKTOP = i12;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) != -1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i1 | 0) if (HEAP32[i1 + 52 >> 2] | 0) if (HEAP32[i1 + 56 >> 2] | 0) {
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 168 >> 2] | 0, i10 | 0, 3);
   i7 = HEAP32[i2 + 52 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 284 >> 2] | 0, i7 | 0);
  }
 }
 __ZN13WheelCollider9SetRadiusEf(i10, Math_fround(HEAPF32[i10 + 72 >> 2]));
 __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring(i10, i10 + 76 | 0);
 __ZN13WheelCollider21SetSuspensionDistanceEf(i10, Math_fround(HEAPF32[i10 + 88 >> 2]));
 __ZN13WheelCollider24SetForceAppPointDistanceEf(i10, Math_fround(HEAPF32[i10 + 92 >> 2]));
 __ZN13WheelCollider7SetMassEf(i10, Math_fround(HEAPF32[i10 + 96 >> 2]));
 i7 = i10 + 100 | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (f3 != f3 | Math_fround(0.0) != Math_fround(0.0)) {
  i6 = f3 < Math_fround(.00100000005);
  HEAP32[i7 >> 2] = i6 ? 981668463 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) != -1) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i2 | 0) if (HEAP32[i2 + 52 >> 2] | 0) if (HEAP32[i2 + 56 >> 2] | 0) {
   i1 = i1 + 56 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
   i4 = i8;
   i5 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i2, HEAP32[i9 >> 2] | 0) | 0;
   i6 = i4 + 48 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 >> 2];
   __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i2, HEAP32[i9 >> 2] | 0, i8);
   i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 284 >> 2] | 0, i8 | 0);
  }
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) != -1) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
  if (i2 | 0) if (HEAP32[i2 + 52 >> 2] | 0) if (HEAP32[i2 + 56 >> 2] | 0) {
   i8 = HEAP32[(HEAP32[i1 + 56 >> 2] | 0) + 104 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 284 >> 2] | 0, i8 | 0);
  }
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
  STACKTOP = i12;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 if (!i1) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
  STACKTOP = i12;
  return;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
  STACKTOP = i12;
  return;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 284 >> 2] | 0, i9 | 0);
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i10, i11);
 STACKTOP = i12;
 return;
}

function _UNITY_FT_Glyph_To_Bitmap(i18, i9, i11, i10) {
 i18 = i18 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20 + 200 | 0;
 i15 = i20 + 40 | 0;
 i3 = i20;
 if (!i18) {
  i19 = 6;
  STACKTOP = i20;
  return i19 | 0;
 }
 i19 = HEAP32[i18 >> 2] | 0;
 if (!i19) {
  i19 = 6;
  STACKTOP = i20;
  return i19 | 0;
 }
 i16 = i19 + 4 | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 if (!((i4 | 0) != 0 & (i5 | 0) != 0)) {
  i19 = 6;
  STACKTOP = i20;
  return i19 | 0;
 }
 i6 = HEAP32[i5 + 188 >> 2] | 0;
 i7 = i6 + 36 | 0;
 if ((i4 | 0) == (i7 | 0)) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i8 = i4 + 28 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  i19 = 6;
  STACKTOP = i20;
  return i19 | 0;
 }
 _memset(i15 + 4 | 0, 0, 152) | 0;
 i1 = i3;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i13 = i15 + 156 | 0;
 HEAP32[i13 >> 2] = i3;
 HEAP32[i15 >> 2] = i5;
 i12 = i15 + 72 | 0;
 HEAP32[i12 >> 2] = HEAP32[i4 + 4 >> 2];
 i17 = _UNITY_ft_mem_alloc(HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14) | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i19 = i1;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i17 >> 2] = i5;
 i5 = i17 + 4 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i17 + 8 >> 2] = HEAP32[i6 + 40 >> 2];
 i4 = (i11 | 0) != 0;
 if (i4) {
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if (i1 | 0) mftCall_viii(i1 | 0, i19 | 0, 0, i11 | 0);
  }
 }
 i2 = mftCall_iii(HEAP32[i8 >> 2] | 0, i19 | 0, i15 | 0) | 0;
 if (!i2) i2 = _UNITY_FT_Render_Glyph_Internal(HEAP32[i19 >> 2] | 0, i15, i9) | 0;
 i3 = i10 << 24 >> 24 == 0;
 if (i4 & i3) {
  HEAP32[i14 >> 2] = 0 - (HEAP32[i11 >> 2] | 0);
  HEAP32[i14 + 4 >> 2] = 0 - (HEAP32[i11 + 4 >> 2] | 0);
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if (i1 | 0) mftCall_viii(i1 | 0, i19 | 0, 0, i14 | 0);
  }
 }
 do if (!i2) {
  i2 = HEAP32[i17 >> 2] | 0;
  if ((HEAP32[i12 >> 2] | 0) == 1651078259) {
   HEAP32[i17 + 20 >> 2] = HEAP32[i15 + 100 >> 2];
   HEAP32[i17 + 24 >> 2] = HEAP32[i15 + 104 >> 2];
   i1 = i17 + 28 | 0;
   if (!(HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] & 1)) {
    _UNITY_FT_Bitmap_Init(i1);
    i2 = _UNITY_FT_Bitmap_Copy(i2, i15 + 76 | 0, i1) | 0;
    if (i2 | 0) break;
   } else {
    i15 = i15 + 76 | 0;
    HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    i15 = (HEAP32[i13 >> 2] | 0) + 4 | 0;
    HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -2;
   }
   i13 = i19 + 12 | 0;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = i17 + 12 | 0;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = i14;
   if (!i3) {
    i2 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
    i1 = HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0;
    if (i1 | 0) mftCall_vi(i1 | 0, i19 | 0);
    _UNITY_ft_mem_free(i2, i19);
   }
   HEAP32[i18 >> 2] = i17;
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  } else i2 = 18;
 } while (0);
 if (!((i17 | 0) != 0 & (i2 | 0) != 0)) {
  i19 = i2;
  STACKTOP = i20;
  return i19 | 0;
 }
 i3 = HEAP32[HEAP32[i17 >> 2] >> 2] | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i17 | 0);
 _UNITY_ft_mem_free(i3, i17);
 i19 = i2;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN9Transform12RotateAroundERK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 48 | 0;
 i7 = i4 + 8 | 0;
 i5 = i4 + 32 | 0;
 i9 = i4 + 16 | 0;
 i8 = i4;
 i21 = i1 + 32 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 i21 = HEAP32[i21 + 4 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f15 * f15) + Math_fround(0.0)));
 f17 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f16))));
 f19 = Math_fround(Math_fround(f19 * f17) * f3);
 f13 = Math_fround(Math_fround(f13 * f17) * f3);
 f17 = Math_fround(Math_fround(f15 * f17) * f3);
 i2 = f16 > Math_fround(1.0e-30);
 f19 = i2 ? f19 : Math_fround(0.0);
 f13 = i2 ? f13 : Math_fround(0.0);
 f17 = i2 ? f17 : Math_fround(0.0);
 f16 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f17 * f17) + Math_fround(0.0)))));
 f15 = Math_fround(f16 * Math_fround(.5));
 f12 = Math_fround(+Math_sin(+f15));
 f15 = Math_fround(+Math_cos(+f15));
 f19 = Math_fround(Math_fround(f12 * f19) / f16);
 f13 = Math_fround(Math_fround(f12 * f13) / f16);
 f17 = Math_fround(Math_fround(f12 * f17) / f16);
 i2 = f16 == Math_fround(0.0);
 i20 = i7;
 HEAP32[i20 >> 2] = i22;
 HEAP32[i20 + 4 >> 2] = i21;
 i20 = i8;
 HEAP32[i20 >> 2] = i22;
 HEAP32[i20 + 4 >> 2] = i21;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z23CalculateGlobalRotation23TransformAccessReadOnly(i9, i6);
 f13 = i2 ? Math_fround(0.0) : f13;
 f16 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(f13 * f16);
 f15 = i2 ? Math_fround(1.0) : f15;
 f10 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f3 = Math_fround(f15 * f10);
 f17 = i2 ? Math_fround(0.0) : f17;
 f14 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f11 = Math_fround(f17 * f14);
 f19 = i2 ? Math_fround(0.0) : f19;
 f18 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f15 * f18)) - Math_fround(f17 * f10)) - Math_fround(f19 * f14));
 f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f19 * f16)) - Math_fround(f17 * f18)) - Math_fround(f13 * f14));
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f13 * f18)) - Math_fround(f15 * f16)) - Math_fround(f19 * f10));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f15 * f14)) - Math_fround(f13 * f10));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 HEAP32[i5 >> 2] = i9 ^ -2147483648;
 HEAP32[i5 + 4 >> 2] = i8;
 HEAP32[i5 + 8 >> 2] = i2 ^ -2147483648;
 HEAPF32[i5 + 12 >> 2] = f3;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 if (!(__Z10SetGlobalR15TransformAccessRKN4math7_float4E(i6, i5) | 0)) {
  STACKTOP = i4;
  return;
 }
 i22 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i22 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 2);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i22 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN2UI6Canvas27UpdateCanvasOverrideSortingEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = HEAP8[i10 + 375 >> 0] | 0;
 HEAP8[i10 + 413 >> 0] = i1;
 i7 = HEAP32[i10 + 344 >> 2] | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 if (!(i1 << 24 >> 24)) {
  HEAP32[i9 >> 2] = i10;
  i1 = HEAP32[i7 + 424 >> 2] | 0;
  i2 = i7 + 428 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i10;
  L6 : do if ((i1 | 0) == (i3 | 0)) i8 = 17; else while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) break L6;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i8 = 17;
    break;
   }
  } while (0);
  if ((i8 | 0) == 17) {
   if ((i3 | 0) == (HEAP32[i7 + 432 >> 2] | 0)) __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i7 + 424 | 0, i9); else {
    HEAP32[i3 >> 2] = i4;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
   }
   i7 = i7 + 224 | 0;
   HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 0 | 4;
  }
  i6 = HEAP32[gb + 1467948 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  i7 = i6 + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = i2;
  i5 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if ((i5 | 0) == (i2 | 0)) break;
   i4 = i5 + 4 | 0;
   if ((HEAP32[i5 >> 2] | 0) == (i10 | 0)) {
    i8 = 24;
    break;
   } else i5 = i4;
  }
  if ((i8 | 0) == 24) {
   i1 = i1 - i4 | 0;
   i3 = i1 >> 2;
   if (i3) {
    _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
    i2 = HEAP32[i7 >> 2] | 0;
   }
   i1 = i5 + (i3 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i6 + 12 | 0, i9) | 0;
  }
 } else {
  i6 = i7 + 428 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i2;
  i5 = HEAP32[i7 + 424 >> 2] | 0;
  while (1) {
   if ((i5 | 0) == (i2 | 0)) break;
   i4 = i5 + 4 | 0;
   if ((HEAP32[i5 >> 2] | 0) == (i10 | 0)) {
    i8 = 6;
    break;
   } else i5 = i4;
  }
  if ((i8 | 0) == 6) {
   i1 = i1 - i4 | 0;
   i3 = i1 >> 2;
   if (i3) {
    _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i1 = i5 + (i3 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   i1 = i7 + 224 | 0;
   HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4;
   i1 = HEAP32[gb + 1467948 >> 2] | 0;
   HEAP32[i9 >> 2] = i10;
   if (i10 | 0) __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i1 + 12 | 0, i9) | 0;
  }
  __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE(HEAP32[gb + 1467948 >> 2] | 0, i10);
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1106096 | 0, i9);
 i1 = i10;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i3 = i10 + 112 | 0;
 i1 = i9;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i10 = i10 + 224 | 0;
 HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 0 | 6;
 STACKTOP = i11;
 return;
}

function __ZN2UI6Canvas24DrawIntermediateRendererERNS_5BatchE10Matrix4x4fiP6Camerat(i16, i15, i4, i8, i10, i11) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17 + 56 | 0;
 i12 = i17 + 32 | 0;
 i13 = i17 + 8 | 0;
 i14 = i17;
 i1 = i16;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i2; else break;
 }
 __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv(i12, i1);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f9 == f5) {
  f7 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  if (f7 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   if (f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
    STACKTOP = i17;
    return;
   }
  }
 }
 f5 = Math_fround(-f5);
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 f7 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 if (f7 == f5) {
  f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f5 = Math_fround(HEAPF32[i12 + 16 >> 2]);
  if (f5 == f18) if (!(Math_fround(HEAPF32[i12 + 20 >> 2]) != f6)) {
   STACKTOP = i17;
   return;
  }
 } else f5 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 i20 = HEAP32[i16 + 316 >> 2] | 0;
 i2 = HEAP32[i16 + 320 >> 2] | 0;
 i19 = HEAP32[i16 + 328 >> 2] | 0;
 i1 = HEAP32[i16 + 324 >> 2] | 0;
 f24 = Math_fround(f9 + f7);
 f6 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f23 = Math_fround(f6 + f5);
 f18 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f23 = Math_fround(f23 * Math_fround(.5));
 f22 = Math_fround(Math_fround(f18 + f21) * Math_fround(.5));
 HEAPF32[i13 >> 2] = Math_fround(f24 * Math_fround(.5));
 HEAPF32[i13 + 4 >> 2] = f23;
 HEAPF32[i13 + 8 >> 2] = f22;
 f6 = Math_fround(Math_fround(f5 - f6) * Math_fround(.5));
 f18 = Math_fround(Math_fround(f21 - f18) * Math_fround(.5));
 HEAPF32[i13 + 12 >> 2] = Math_fround(Math_fround(f7 - f9) * Math_fround(.5));
 HEAPF32[i13 + 16 >> 2] = f6;
 HEAPF32[i13 + 20 >> 2] = f18;
 HEAP32[i14 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
 i8 = __Z29AddCanvasIntermediateRendererPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS3_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModebP6Camera(i16, i20, i19, i1, i2, i4, i11, i13, i3, i8, 0, 0, i10) | 0;
 i4 = i16;
 while (1) {
  if (HEAP8[i4 + 375 >> 0] | 0) break;
  i1 = HEAP32[i4 + 344 >> 2] | 0;
  if (!i1) break; else i4 = i1;
 }
 i2 = __Z13GetTagManagerv() | 0;
 i1 = i4;
 while (1) {
  i3 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i3) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i3; else break;
 }
 i3 = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i2, HEAP32[i1 + 368 >> 2] | 0) | 0;
 i1 = i4;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i2; else break;
 }
 HEAP32[i8 + 188 >> 2] = (HEAP16[i1 + 372 >> 1] | 0) + 32768 | i3 << 16 ^ -2147483648;
 i4 = i15 + 8 | 0;
 i3 = i15 + 12 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i2 = i16 + 248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do {
  i20 = HEAP32[i2 >> 2] | 0;
  __ZN31CanvasBatchIntermediateRenderer11AddSubBatchERK16DrawBuffersRangePK19ShaderPropertySheet(i8, i20 + (i1 * 36 | 0) + 4 | 0, HEAP32[i20 + (i1 * 36 | 0) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0));
 STACKTOP = i17;
 return;
}

function __ZN16Physics2DManager10OverlapBoxERK8Vector2fS2_fiffPK10Collider2D(i1, i11, i12, f3, i2, f5, f10, i4) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 f10 = Math_fround(f10);
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, f8 = f0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 216 | 0;
 i14 = i19;
 i18 = i19 + 224 | 0;
 if ((HEAP16[gb + 1457800 + 6 >> 1] | 0) > -1) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457800 | 0, i13);
  i15 = gb + 1457800 | 0;
 } else i15 = 0;
 i1 = gb + 64016 | 0;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i16 = i14;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i14);
 i1 = i13;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i17;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 f8 = Math_fround(f3 * Math_fround(.0174532924));
 HEAP32[i14 >> 2] = gb + 158756 + 8;
 HEAP32[i14 + 4 >> 2] = i2;
 i6 = i14 + 8 | 0;
 i7 = i14 + 12 | 0;
 HEAP32[i14 + 16 >> 2] = i4;
 i1 = i14 + 28 | 0;
 HEAP32[i1 >> 2] = gb + 151728 + 8;
 HEAP32[i14 + 32 >> 2] = 2;
 HEAP32[i14 + 36 >> 2] = HEAP32[gb + 151644 >> 2];
 HEAP32[i14 + 176 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 44 >> 2] = Math_fround(0.0);
 i4 = i14 + 180 | 0;
 i2 = i14 + 196 | 0;
 i9 = i14 + 212 | 0;
 HEAP32[i9 >> 2] = i18;
 i20 = f5 == Math_fround(-inf);
 f5 = i20 ? Math_fround(-3402823469999999843913219.0e14) : f5;
 HEAPF32[i6 >> 2] = f5;
 i20 = f10 == Math_fround(inf);
 f3 = i20 ? Math_fround(3402823469999999843913219.0e14) : f10;
 HEAPF32[i7 >> 2] = f3;
 if (!(f5 < f3)) {
  HEAPF32[i6 >> 2] = f3;
  HEAPF32[i7 >> 2] = f5;
 }
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 i20 = f5 > Math_fround(.0000999999974);
 f5 = i20 ? f5 : Math_fround(.0000999999974);
 f10 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 i20 = f10 > Math_fround(.0000999999974);
 f5 = Math_fround(f5 * Math_fround(.5));
 f10 = Math_fround((i20 ? f10 : Math_fround(.0000999999974)) * Math_fround(.5));
 i20 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i20;
 __ZN14b2PolygonShape8SetAsBoxEffRK6b2Vec2f(i1, f5, f10, i13, f8);
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 208 >> 2] = Math_fround(1.0);
 __ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib(i1, i4, i2, 0, 1);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i14, i4);
 i20 = HEAP32[i9 >> 2] | 0;
 i14 = HEAP32[i20 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i14, i14 + (HEAP32[i20 + 12 >> 2] << 2) | 0, i13);
 if ((HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0) > 0) i1 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0; else i1 = 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
  HEAP32[i18 >> 2] = 0;
 }
 if (!i15) {
  STACKTOP = i19;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i19;
 return i1 | 0;
}

function __ZN12CubemapArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i13 = i15;
 __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i12);
 i14 = i11 + 80 | 0;
 i7 = i12 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i12 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i14, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i8 = i11 + 84 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i4 = i11 + 88 | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i11 + 76 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i5 = i11 + 96 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4); else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11 + 32 | 0, i12);
 i1 = i11 + 60 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i11 + 105 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i12);
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i12, i13, gb + 411165 | 0, 1);
 i3 = i11 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i11 + 100 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i11 + 104 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i7 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 + 48 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  mftCall_vii(i6 | 0, i7 | 0, i9 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) i1 = 0; else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = (i2 >>> 0) / ((i1 * 6 | 0) >>> 0) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
 HEAP32[i3 >> 2] = i10;
 f16 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i14 >> 2] | 0));
 HEAPF32[i11 + 68 >> 2] = f16;
 HEAPF32[i11 + 72 >> 2] = f16;
 __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i12, HEAP32[i13 >> 2] | 0, i10, 0);
 STACKTOP = i15;
 return;
}

function __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 40 | 0, i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 364 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i6 + 360 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 362 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 375 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 361 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 404 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i2 = HEAP16[i7 >> 1] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i7 >> 1] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP16[i6 + 372 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i1 = i6 + 374 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN19UnityConnectService23RegisterGlobalCallbacksEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 36 | 0;
 HEAP8[i4 + 4 >> 0] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 19296 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 18528 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 18528 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 18528 + (i1 * 12 | 0) >> 2] = fb + 4429;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 20840 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 20072 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) >> 2] = fb + 3936;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 24700 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) >> 2] = fb + 3937;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 24 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 3938;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 4628 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i5 = i3 + 1 | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i1 + 3860 + (i3 * 12 | 0) | 0;
  i2 = i1 + 3860 + (i3 * 12 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = i4;
  i4 = i1 + 3860 + (i3 * 12 | 0) + 8 | 0;
  HEAP8[i4 >> 0] = 1;
  HEAP32[i5 >> 2] = fb + 330;
  STACKTOP = i6;
  return;
 }
 __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 32 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + 1 | 0;
 HEAP32[i2 >> 2] = i5;
 i5 = i1 + 3860 + (i3 * 12 | 0) | 0;
 i2 = i1 + 3860 + (i3 * 12 | 0) + 4 | 0;
 HEAP32[i2 >> 2] = i4;
 i4 = i1 + 3860 + (i3 * 12 | 0) + 8 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i5 >> 2] = fb + 330;
 STACKTOP = i6;
 return;
}

function __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i16, i14, i4, i5, i6, i7) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 48 | 0;
 i18 = i20;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i16 + 28 >> 2];
 i19 = i16 + 32 | 0;
 i1 = i18;
 i2 = i19;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i13 = i16 + 88 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i9 = i16 + 92 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i15 = i16 + 84 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i2 = i16 + 96 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i16, i14, i4, i5, i6, i7);
 i3 = HEAP32[i15 >> 2] | 0;
 i1 = (i3 | 0) != 0;
 if (!i14) {
  if (i1) __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  HEAP32[i15 >> 2] = 0;
  STACKTOP = i20;
  return;
 }
 do if (i1) if ((HEAP32[i17 >> 2] | 0) == (HEAP32[i16 >> 2] | 0)) if ((HEAP32[i17 + 4 >> 2] | 0) == (HEAP32[i16 + 4 >> 2] | 0)) if ((HEAP32[i17 + 8 >> 2] | 0) == (HEAP32[i16 + 8 >> 2] | 0)) if ((HEAP32[i17 + 12 >> 2] | 0) == (HEAP32[i16 + 12 >> 2] | 0)) if ((HEAP32[i17 + 16 >> 2] | 0) == (HEAP32[i16 + 16 >> 2] | 0)) if ((HEAP32[i17 + 20 >> 2] | 0) == (HEAP32[i16 + 20 >> 2] | 0)) if ((HEAP32[i17 + 24 >> 2] | 0) == (HEAP32[i16 + 24 >> 2] | 0)) if ((HEAP32[i17 + 28 >> 2] | 0) == (HEAP32[i16 + 28 >> 2] | 0)) if ((HEAP32[i18 >> 2] | 0) == (HEAP32[i19 >> 2] | 0)) if ((HEAP32[i18 + 4 >> 2] | 0) == (HEAP32[i19 + 4 >> 2] | 0)) if ((HEAP32[i18 + 8 >> 2] | 0) == (HEAP32[i19 + 8 >> 2] | 0)) if ((HEAP32[i18 + 12 >> 2] | 0) == (HEAP32[i16 + 44 >> 2] | 0)) if ((HEAP32[i18 + 16 >> 2] | 0) == (HEAP32[i19 + 16 >> 2] | 0)) if ((HEAP32[i18 + 20 >> 2] | 0) == (HEAP32[i19 + 20 >> 2] | 0)) if ((HEAP32[i18 + 24 >> 2] | 0) == (HEAP32[i16 + 56 >> 2] | 0)) if ((HEAP32[i18 + 28 >> 2] | 0) == (HEAP32[i19 + 28 >> 2] | 0)) if ((HEAP32[i18 + 32 >> 2] | 0) == (HEAP32[i19 + 32 >> 2] | 0)) {
  if ((HEAP32[i18 + 36 >> 2] | 0) != (HEAP32[i16 + 68 >> 2] | 0)) break;
  if ((HEAP32[i18 + 40 >> 2] | 0) != (HEAP32[i19 + 40 >> 2] | 0)) break;
  if ((HEAP32[i18 + 44 >> 2] | 0) != (HEAP32[i19 + 44 >> 2] | 0)) break;
  i2 = (HEAP32[i2 >> 2] | 0) + 16 | 0;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i2, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 554) | 0;
  HEAP32[i15 >> 2] = i1;
  if (!(i2 >>> 0 > i12 >>> 0 & (i1 | 0) != 0)) {
   STACKTOP = i20;
   return;
  }
  _memset(i1 + i12 | 0, 0, i2 - i12 | 0) | 0;
  STACKTOP = i20;
  return;
 } while (0);
 i1 = (HEAP32[i2 >> 2] | 0) + 16 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (i2 | 0) _memset(i2 | 0, 0, i1 | 0) | 0;
 HEAP32[i15 >> 2] = i2;
 if (!i11) {
  STACKTOP = i20;
  return;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph(i15 >>> 0 < i10 >>> 0 ? i15 : i10, HEAP32[i13 >> 2] & i8, i18, i17, i11, i19, i16, i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 63232 | 0);
 STACKTOP = i20;
 return;
}

function __ZN9WWWCachedC2EPKc7Hash128j(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i11 + 16 | 0;
 HEAP32[i6 >> 2] = gb + 73968 + 8;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP8[i6 + 8 >> 0] = 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i6 + 33 >> 0] = 0;
 i8 = i6 + 40 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i7 = i6 + 56 | 0;
 HEAP32[i7 >> 2] = i2;
 i4 = i6 + 60 | 0;
 HEAP32[i4 >> 2] = 2;
 i2 = i6 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 64912 + 8;
 i2 = (_strlen(i3) | 0) + 1 | 0;
 i1 = _malloc(i2) | 0;
 i5 = i6 + 80 | 0;
 HEAP32[i5 >> 2] = i1;
 _strncpy(i1, i3, i2) | 0;
 HEAP8[i6 + 85 >> 0] = 0;
 HEAP8[i6 + 84 >> 0] = 0;
 i2 = i6 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i6 + 92 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i6 + 96 >> 0] = 0;
 if (HEAP8[(__Z17GetCachingManagerv() | 0) + 8 >> 0] | 0) {
  i9 = __Znwj(224) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i3, _strlen(i3) | 0);
  __ZN38AssetBundleLoadFromCacheAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i10);
  HEAP32[i1 >> 2] = i9;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i9 = HEAP32[i1 >> 2] | 0;
  i3 = i8;
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i9 + 192 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i8;
  i4 = i6 + 48 | 0;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i9 + 200 | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i8, _strlen(i8) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9 + 208 | 0, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i10 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 + 88 >> 2] = HEAP32[i7 >> 2];
  __ZN38AssetBundleLoadFromCacheAsyncOperation7ExecuteEv(i10);
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN3WWW7ReleaseEv(i1);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 _printf_console(gb + 454504 | 0, i9);
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i6 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i6;
 i5 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i9 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i5, 0, 0, i10, 0, i9, i7) | 0;
 HEAP32[i2 >> 2] = i9;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i9 | 0, HEAP32[i4 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i10, HEAP32[i6 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i4, i15, i11, i1) {
 i4 = i4 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i3 = (i11 | 0) != 0;
 if (i3) i13 = i1; else i13 = HEAPU16[i4 + 24 >> 1] | 0;
 i2 = i13 << 2;
 i12 = i2 >>> 0 > 1024;
 i14 = i16 + 4 | 0;
 HEAP8[i14 >> 0] = i12 & 1;
 if (i12) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i17 + 8 | 0, i2, gb + 707831 | 0, 388) | 0;
  HEAP32[i16 >> 2] = i1;
  if (i1 | 0) {
   i12 = i16;
   i10 = 6;
  }
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i16 >> 2] = i1;
  i12 = i16;
  i10 = 6;
 }
 L7 : do if ((i10 | 0) == 6) {
  L9 : do if (i3) {
   if (!i13) break L7;
   i8 = i15 + 4 | 0;
   i9 = i15 + 8 | 0;
   i7 = i1;
   i1 = 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
    i6 = i3 + 32 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    L14 : do if (!(i4 & 8)) i10 = 18; else {
     i3 = HEAP32[i3 + 36 >> 2] | 0;
     if ((i3 & 251658240 | 0) == 16777216) if ((i3 & -1073741824 | 0) == 1073741824) break; else {
      i10 = 18;
      break;
     }
     i3 = HEAP32[i9 >> 2] | 0;
     if (!i3) {
      i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i4 >>> 24 & 15) | 0;
      HEAP32[i9 >> 2] = i3;
     }
     i5 = HEAP32[i3 + 28 >> 2] | 0;
     if (!i5) i10 = 18; else {
      i3 = HEAP32[i3 + 24 >> 2] | 0;
      i4 = 0;
      while (1) {
       if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == (i6 | 0)) break L14;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 >= i5 >>> 0) {
        i10 = 18;
        break;
       }
      }
     }
    } while (0);
    if ((i10 | 0) == 18) {
     i10 = 0;
     HEAP32[i7 + (i1 << 2) >> 2] = i6;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i13 | 0)) break L9;
    i7 = HEAP32[i12 >> 2] | 0;
   }
  } else {
   i1 = i4 + 20 | 0;
   if ((HEAP16[i4 + 24 >> 1] | 0) == 1) i9 = i1; else i9 = HEAP32[i1 >> 2] | 0;
   if (!i13) break L7;
   i7 = i15 + 4 | 0;
   i8 = i15 + 8 | 0;
   i1 = 0;
   i10 = 0;
   do {
    i11 = HEAP32[i9 + (i10 << 2) >> 2] | 0;
    i5 = i11 + 32 | 0;
    i2 = HEAP32[i11 + 36 >> 2] | 0;
    L38 : do if (HEAP8[((i2 & 64 | 0) == 0 ? i11 + 112 | 0 : (HEAP32[i11 + 40 >> 2] | 0) + 52 | 0) >> 0] & 5) {
     i6 = HEAP32[i12 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     do if (i3 & 8 | 0) {
      if ((i2 & 251658240 | 0) == 16777216) if ((i2 & -1073741824 | 0) == 1073741824) break L38; else break;
      i2 = HEAP32[i8 >> 2] | 0;
      if (!i2) {
       i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i3 >>> 24 & 15) | 0;
       HEAP32[i8 >> 2] = i2;
      }
      i4 = HEAP32[i2 + 28 >> 2] | 0;
      if (i4 | 0) {
       i2 = HEAP32[i2 + 24 >> 2] | 0;
       i3 = 0;
       do {
        if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i5 | 0)) break L38;
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i4 >>> 0);
      }
     } while (0);
     HEAP32[i6 + (i1 << 2) >> 2] = i5;
     i1 = i1 + 1 | 0;
    } while (0);
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i13 | 0));
  } while (0);
  if (i1 | 0) __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj(i15, HEAP32[i12 >> 2] | 0, i1);
 } while (0);
 if (!(HEAP8[i14 >> 0] | 0)) {
  STACKTOP = i17;
  return 1;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i17;
 return 1;
}

function __ZN21EnlightenSceneMapping8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i6 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i6 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + (i4 * 40 | 0) | 0;
 if (i4 | 0) do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i6, i1 + 4 | 0, gb + 402843 | 0, 0);
  i2 = i1 + 20 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 24 | 0, i6);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i5 | 0));
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i5 * 56 | 0) | 0;
 if (i5 | 0) do {
  __ZN26EnlightenSystemInformation8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  i1 = i1 + 56 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 40 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i5 << 4) | 0;
 if (i5 | 0) do {
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i6, i7 + 80 | 0, 0);
 i4 = i7 + 112 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 100 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i8 * 12 | 0) | 0;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i4, i15, i11, i1) {
 i4 = i4 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i3 = (i11 | 0) != 0;
 if (i3) i13 = i1; else i13 = HEAPU16[i4 + 24 >> 1] | 0;
 i2 = i13 << 2;
 i12 = i2 >>> 0 > 1024;
 i14 = i16 + 4 | 0;
 HEAP8[i14 >> 0] = i12 & 1;
 if (i12) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i17 + 8 | 0, i2, gb + 707831 | 0, 388) | 0;
  HEAP32[i16 >> 2] = i1;
  if (i1 | 0) {
   i12 = i16;
   i10 = 6;
  }
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i16 >> 2] = i1;
  i12 = i16;
  i10 = 6;
 }
 L7 : do if ((i10 | 0) == 6) {
  L9 : do if (i3) {
   if (!i13) break L7;
   i8 = i15 + 4 | 0;
   i9 = i15 + 8 | 0;
   i7 = i1;
   i1 = 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
    i6 = i3 + 32 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    L14 : do if (!(i4 & 8)) i10 = 18; else {
     i3 = HEAP32[i3 + 36 >> 2] | 0;
     if ((i3 & 251658240 | 0) == 16777216) if ((i3 & -1073741824 | 0) == 1073741824) break; else {
      i10 = 18;
      break;
     }
     i3 = HEAP32[i9 >> 2] | 0;
     if (!i3) {
      i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i4 >>> 24 & 15) | 0;
      HEAP32[i9 >> 2] = i3;
     }
     i5 = HEAP32[i3 + 28 >> 2] | 0;
     if (!i5) i10 = 18; else {
      i3 = HEAP32[i3 + 24 >> 2] | 0;
      i4 = 0;
      while (1) {
       if ((HEAP32[i3 + (i4 << 2) >> 2] | 0) == (i6 | 0)) break L14;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 >= i5 >>> 0) {
        i10 = 18;
        break;
       }
      }
     }
    } while (0);
    if ((i10 | 0) == 18) {
     i10 = 0;
     HEAP32[i7 + (i1 << 2) >> 2] = i6;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i13 | 0)) break L9;
    i7 = HEAP32[i12 >> 2] | 0;
   }
  } else {
   i1 = i4 + 20 | 0;
   if ((HEAP16[i4 + 24 >> 1] | 0) == 1) i9 = i1; else i9 = HEAP32[i1 >> 2] | 0;
   if (!i13) break L7;
   i7 = i15 + 4 | 0;
   i8 = i15 + 8 | 0;
   i1 = 0;
   i10 = 0;
   do {
    i11 = HEAP32[i9 + (i10 << 2) >> 2] | 0;
    i5 = i11 + 32 | 0;
    i2 = HEAP32[i11 + 36 >> 2] | 0;
    L38 : do if (HEAP8[((i2 & 64 | 0) == 0 ? i11 + 112 | 0 : (HEAP32[i11 + 40 >> 2] | 0) + 52 | 0) >> 0] & 5) {
     i6 = HEAP32[i12 >> 2] | 0;
     i3 = HEAP32[i7 >> 2] | 0;
     do if (i3 & 8 | 0) {
      if ((i2 & 251658240 | 0) == 16777216) if ((i2 & -1073741824 | 0) == 1073741824) break L38; else break;
      i2 = HEAP32[i8 >> 2] | 0;
      if (!i2) {
       i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i15 >> 2] | 0, i3 >>> 24 & 15) | 0;
       HEAP32[i8 >> 2] = i2;
      }
      i4 = HEAP32[i2 + 28 >> 2] | 0;
      if (i4 | 0) {
       i2 = HEAP32[i2 + 24 >> 2] | 0;
       i3 = 0;
       do {
        if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i5 | 0)) break L38;
        i3 = i3 + 1 | 0;
       } while (i3 >>> 0 < i4 >>> 0);
      }
     } while (0);
     HEAP32[i6 + (i1 << 2) >> 2] = i5;
     i1 = i1 + 1 | 0;
    } while (0);
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != (i13 | 0));
  } while (0);
  if (i1 | 0) __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj(i15, HEAP32[i12 >> 2] | 0, i1);
 } while (0);
 if (!(HEAP8[i14 >> 0] | 0)) {
  STACKTOP = i17;
  return 1;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i17;
 return 1;
}

function __ZN12ShaderErrors11ShaderErrorC2ERKS0_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 12;
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i2;
  i8 = 12;
 }
 if ((i8 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 32 | 0;
 i3 = i7 + 32 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 36 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 44 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 44 >> 2] | 0;
  i8 = 16;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i10 = i1;
   i10 = i10 + i4 | 0;
   HEAP8[i10 >> 0] = 0;
   i10 = i6 + 48 | 0;
   i8 = i7 + 48 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
   STACKTOP = i9;
   return;
  }
 } else i8 = 16;
 if ((i8 | 0) == 16) {
  i8 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i6 + 40 >> 2] = i8 | -2147483648;
  HEAP32[i6 + 36 >> 2] = i4;
  i1 = i10;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i10 = i1;
 i10 = i10 + i4 | 0;
 HEAP8[i10 >> 0] = 0;
 i10 = i6 + 48 | 0;
 i8 = i7 + 48 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP16[i10 + 8 >> 1] = HEAP16[i8 + 8 >> 1] | 0;
 STACKTOP = i9;
 return;
}

function runPostSets72() {
 HEAP32[gb + 78232 >> 2] = fb + 27;
 HEAP32[gb + 78236 >> 2] = fb + 17;
 HEAP32[gb + 78240 >> 2] = fb + 9;
 HEAP32[gb + 78244 >> 2] = fb + 897;
 HEAP32[gb + 78248 >> 2] = fb + 292;
 HEAP32[gb + 78252 >> 2] = fb + 285;
 HEAP32[gb + 78256 >> 2] = fb + 293;
 HEAP32[gb + 78260 >> 2] = fb + 294;
 HEAP32[gb + 78264 >> 2] = fb + 295;
 HEAP32[gb + 78268 >> 2] = fb + 296;
 HEAP32[gb + 78272 >> 2] = fb + 297;
 HEAP32[gb + 78276 >> 2] = fb + 298;
 HEAP32[gb + 78280 >> 2] = fb + 1;
 HEAP32[gb + 78284 >> 2] = fb + 286;
 HEAP32[gb + 78288 >> 2] = fb + 299;
 HEAP32[gb + 78292 >> 2] = fb + 22;
 HEAP32[gb + 78296 >> 2] = fb + 418;
 HEAP32[gb + 78300 >> 2] = fb + 730;
 HEAP32[gb + 78304 >> 2] = fb + 898;
 HEAP32[gb + 78308 >> 2] = fb + 899;
 HEAP32[gb + 78312 >> 2] = fb + 169;
 HEAP32[gb + 78316 >> 2] = fb + 23;
 HEAP32[gb + 78320 >> 2] = fb + 24;
 HEAP32[gb + 78324 >> 2] = fb + 25;
 HEAP32[gb + 78328 >> 2] = fb + 26;
 HEAP32[gb + 78332 >> 2] = fb + 287;
 HEAP32[gb + 78336 >> 2] = fb + 300;
 HEAP32[gb + 78340 >> 2] = fb + 170;
 HEAP32[gb + 78344 >> 2] = fb + 171;
 HEAP32[gb + 78348 >> 2] = fb + 172;
 HEAP32[gb + 78352 >> 2] = fb + 60;
 HEAP32[gb + 78356 >> 2] = fb + 61;
 HEAP32[gb + 78360 >> 2] = fb + 62;
 HEAP32[gb + 78364 >> 2] = fb + 63;
 HEAP32[gb + 78368 >> 2] = fb + 64;
 HEAP32[gb + 78372 >> 2] = fb + 288;
 HEAP32[gb + 78376 >> 2] = fb + 27;
 HEAP32[gb + 78380 >> 2] = fb + 173;
 HEAP32[gb + 78384 >> 2] = fb + 289;
 HEAP32[gb + 78388 >> 2] = fb + 11;
 HEAP32[gb + 78392 >> 2] = fb + 12;
 HEAP32[gb + 78396 >> 2] = fb + 28;
 HEAP32[gb + 78400 >> 2] = fb + 13;
 HEAP32[gb + 78404 >> 2] = fb + 29;
 HEAP32[gb + 78408 >> 2] = fb + 30;
 HEAP32[gb + 78412 >> 2] = fb + 301;
 HEAP32[gb + 78416 >> 2] = fb + 174;
 HEAP32[gb + 78420 >> 2] = fb + 27;
 HEAP32[gb + 78424 >> 2] = fb + 290;
 HEAP32[gb + 78428 >> 2] = fb + 1;
 HEAP32[gb + 78432 >> 2] = fb + 14;
 HEAP32[gb + 78436 >> 2] = fb + 31;
 HEAP32[gb + 78440 >> 2] = fb + 3;
 HEAP32[gb + 78444 >> 2] = fb + 291;
 HEAP32[gb + 78448 >> 2] = fb + 4;
 HEAP32[gb + 78452 >> 2] = fb + 3;
 HEAP32[gb + 78456 >> 2] = fb + 1;
 HEAP32[gb + 78460 >> 2] = fb + 292;
 HEAP32[gb + 78464 >> 2] = fb + 5;
 HEAP32[gb + 78468 >> 2] = fb + 15;
 HEAP32[gb + 78472 >> 2] = fb + 16;
 HEAP32[gb + 78476 >> 2] = fb + 17;
 HEAP32[gb + 78480 >> 2] = fb + 2;
 HEAP32[gb + 78484 >> 2] = fb + 6;
 HEAP32[gb + 78488 >> 2] = fb + 293;
 HEAP32[gb + 78492 >> 2] = fb + 294;
 HEAP32[gb + 78496 >> 2] = fb + 32;
 HEAP32[gb + 78500 >> 2] = fb + 175;
 HEAP32[gb + 78504 >> 2] = fb + 176;
 HEAP32[gb + 78508 >> 2] = fb + 18;
 HEAP32[gb + 78512 >> 2] = fb + 19;
 HEAP32[gb + 78516 >> 2] = fb + 177;
 HEAP32[gb + 78520 >> 2] = fb + 178;
 HEAP32[gb + 78524 >> 2] = fb + 295;
 HEAP32[gb + 78528 >> 2] = fb + 3;
 HEAP32[gb + 78532 >> 2] = fb + 419;
 HEAP32[gb + 78536 >> 2] = fb + 731;
 HEAP32[gb + 78540 >> 2] = fb + 296;
 HEAP32[gb + 78544 >> 2] = fb + 21;
 HEAP32[gb + 78548 >> 2] = fb + 900;
 HEAP32[gb + 78560 >> 2] = fb + 901;
 HEAP32[gb + 78564 >> 2] = fb + 902;
 HEAP32[gb + 78568 >> 2] = fb + 399;
 HEAP32[gb + 78572 >> 2] = fb + 854;
 HEAP32[gb + 78584 >> 2] = fb + 901;
 HEAP32[gb + 78588 >> 2] = fb + 903;
 HEAP32[gb + 78592 >> 2] = fb + 399;
 HEAP32[gb + 78596 >> 2] = fb + 854;
 HEAP32[gb + 78608 >> 2] = fb + 304;
 HEAP32[gb + 78612 >> 2] = fb + 904;
 HEAP32[gb + 78616 >> 2] = fb + 179;
 HEAP32[gb + 78620 >> 2] = fb + 82;
 HEAP32[gb + 78632 >> 2] = fb + 905;
 HEAP32[gb + 78636 >> 2] = fb + 906;
 HEAP32[gb + 78640 >> 2] = fb + 101;
 HEAP32[gb + 78656 >> 2] = fb + 907;
 HEAP32[gb + 78660 >> 2] = fb + 908;
 HEAP32[gb + 78664 >> 2] = fb + 102;
 HEAP32[gb + 78804 >> 2] = fb + 103;
 HEAP32[gb + 78808 >> 2] = fb + 732;
 runPostSets73();
}

function runPostSets64() {
 HEAP32[gb + 71392 >> 2] = fb + 19;
 HEAP32[gb + 71396 >> 2] = fb + 20;
 HEAP32[gb + 71400 >> 2] = fb + 21;
 HEAP32[gb + 71404 >> 2] = fb + 22;
 HEAP32[gb + 71408 >> 2] = fb + 23;
 HEAP32[gb + 71412 >> 2] = fb + 24;
 HEAP32[gb + 71416 >> 2] = fb + 25;
 HEAP32[gb + 71420 >> 2] = fb + 29;
 HEAP32[gb + 71424 >> 2] = fb + 10;
 HEAP32[gb + 71436 >> 2] = fb + 803;
 HEAP32[gb + 71440 >> 2] = fb + 804;
 HEAP32[gb + 71444 >> 2] = fb + 352;
 HEAP32[gb + 71448 >> 2] = fb + 353;
 HEAP32[gb + 71452 >> 2] = fb + 5;
 HEAP32[gb + 71456 >> 2] = fb + 21;
 HEAP32[gb + 71460 >> 2] = fb + 6;
 HEAP32[gb + 71464 >> 2] = fb + 22;
 HEAP32[gb + 71468 >> 2] = fb + 41;
 HEAP32[gb + 71472 >> 2] = fb + 354;
 HEAP32[gb + 71476 >> 2] = fb + 75;
 HEAP32[gb + 71480 >> 2] = fb + 355;
 HEAP32[gb + 71484 >> 2] = fb + 356;
 HEAP32[gb + 71500 >> 2] = fb + 805;
 HEAP32[gb + 71504 >> 2] = fb + 806;
 HEAP32[gb + 71508 >> 2] = fb + 42;
 HEAP32[gb + 71512 >> 2] = fb + 12;
 HEAP32[gb + 71516 >> 2] = fb + 14;
 HEAP32[gb + 71520 >> 2] = fb + 13;
 HEAP32[gb + 71524 >> 2] = fb + 15;
 HEAP32[gb + 71528 >> 2] = fb + 130;
 HEAP32[gb + 71532 >> 2] = fb + 23;
 HEAP32[gb + 71536 >> 2] = fb + 131;
 HEAP32[gb + 71540 >> 2] = fb + 43;
 HEAP32[gb + 71544 >> 2] = fb + 132;
 HEAP32[gb + 71548 >> 2] = fb + 133;
 HEAP32[gb + 71552 >> 2] = fb + 55;
 HEAP32[gb + 71556 >> 2] = fb + 134;
 HEAP32[gb + 71560 >> 2] = fb + 659;
 HEAP32[gb + 71564 >> 2] = fb + 660;
 HEAP32[gb + 71568 >> 2] = fb + 357;
 HEAP32[gb + 71572 >> 2] = fb + 76;
 HEAP32[gb + 71576 >> 2] = fb + 135;
 HEAP32[gb + 71580 >> 2] = fb + 136;
 HEAP32[gb + 71584 >> 2] = fb + 137;
 HEAP32[gb + 71588 >> 2] = fb + 138;
 HEAP32[gb + 71592 >> 2] = fb + 56;
 HEAP32[gb + 71596 >> 2] = fb + 139;
 HEAP32[gb + 71600 >> 2] = fb + 77;
 HEAP32[gb + 71604 >> 2] = fb + 44;
 HEAP32[gb + 71608 >> 2] = fb + 140;
 HEAP32[gb + 71612 >> 2] = fb + 141;
 HEAP32[gb + 71616 >> 2] = fb + 78;
 HEAP32[gb + 71620 >> 2] = fb + 142;
 HEAP32[gb + 71624 >> 2] = fb + 79;
 HEAP32[gb + 71628 >> 2] = fb + 80;
 HEAP32[gb + 71632 >> 2] = fb + 81;
 HEAP32[gb + 71636 >> 2] = fb + 82;
 HEAP32[gb + 71640 >> 2] = fb + 57;
 HEAP32[gb + 71644 >> 2] = fb + 83;
 HEAP32[gb + 71648 >> 2] = fb + 16;
 HEAP32[gb + 71652 >> 2] = fb + 143;
 HEAP32[gb + 71656 >> 2] = fb + 144;
 HEAP32[gb + 71668 >> 2] = fb + 807;
 HEAP32[gb + 71672 >> 2] = fb + 808;
 HEAP32[gb + 71676 >> 2] = fb + 145;
 HEAP32[gb + 71680 >> 2] = fb + 661;
 HEAP32[gb + 71684 >> 2] = fb + 17;
 HEAP32[gb + 71688 >> 2] = fb + 18;
 HEAP32[gb + 71692 >> 2] = fb + 58;
 HEAP32[gb + 71696 >> 2] = fb + 358;
 HEAP32[gb + 71700 >> 2] = fb + 359;
 HEAP32[gb + 71716 >> 2] = fb + 809;
 HEAP32[gb + 71720 >> 2] = fb + 810;
 HEAP32[gb + 71724 >> 2] = fb + 146;
 HEAP32[gb + 71728 >> 2] = fb + 662;
 HEAP32[gb + 71732 >> 2] = fb + 19;
 HEAP32[gb + 71736 >> 2] = fb + 20;
 HEAP32[gb + 71740 >> 2] = fb + 59;
 HEAP32[gb + 71744 >> 2] = fb + 360;
 HEAP32[gb + 71748 >> 2] = fb + 361;
 HEAP32[gb + 71760 >> 2] = fb + 811;
 HEAP32[gb + 71764 >> 2] = fb + 812;
 HEAP32[gb + 71768 >> 2] = fb + 147;
 HEAP32[gb + 71772 >> 2] = fb + 663;
 HEAP32[gb + 71776 >> 2] = fb + 21;
 HEAP32[gb + 71780 >> 2] = fb + 22;
 HEAP32[gb + 71784 >> 2] = fb + 60;
 HEAP32[gb + 71788 >> 2] = fb + 362;
 HEAP32[gb + 71792 >> 2] = fb + 363;
 HEAP32[gb + 71816 >> 2] = fb + 813;
 HEAP32[gb + 71820 >> 2] = fb + 814;
 HEAP32[gb + 71824 >> 2] = fb + 364;
 HEAP32[gb + 71828 >> 2] = fb + 815;
 HEAP32[gb + 71832 >> 2] = fb + 816;
 HEAP32[gb + 71836 >> 2] = fb + 365;
 HEAP32[gb + 71840 >> 2] = fb + 366;
 HEAP32[gb + 71844 >> 2] = fb + 367;
 HEAP32[gb + 71852 >> 2] = fb + 1;
 HEAP32[gb + 71856 >> 2] = fb + 3;
 HEAP32[gb + 71860 >> 2] = fb + 2;
 runPostSets65();
}

function _ccoshf(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 16 | 0;
 i4 = i14 + 8 | 0;
 i5 = i14;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 i6 = i3 + 4 | 0;
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = i13 & 2147483647;
 i8 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 i9 = i7 >>> 0 < 2139095040;
 do if (i9 & i8 >>> 0 < 2139095040) {
  if (!i8) {
   f12 = Math_fround(f11 * f12);
   HEAPF32[i10 >> 2] = Math_fround(_coshf(f11));
   HEAPF32[i10 + 4 >> 2] = f12;
   break;
  }
  if (i7 >>> 0 < 1091567616) {
   f1 = Math_fround(Math_fround(_coshf(f11)) * Math_fround(+Math_cos(+f12)));
   f12 = Math_fround(Math_fround(_sinhf(f11)) * Math_fround(+Math_sin(+f12)));
   HEAPF32[i10 >> 2] = f1;
   HEAPF32[i10 + 4 >> 2] = f12;
   break;
  }
  if (i7 >>> 0 < 1118925336) {
   f15 = Math_fround(Math_fround(+Math_exp(+Math_fround(Math_abs(Math_fround(f11))))) * Math_fround(.5));
   f1 = Math_fround(f15 * Math_fround(+Math_cos(+f12)));
   f12 = Math_fround(Math_fround(_copysignf(f15, f11)) * Math_fround(+Math_sin(+f12)));
   HEAPF32[i10 >> 2] = f1;
   HEAPF32[i10 + 4 >> 2] = f12;
   break;
  }
  if (i7 >>> 0 < 1128313319) {
   HEAPF32[i5 >> 2] = Math_fround(Math_abs(Math_fround(f11)));
   HEAPF32[i5 + 4 >> 2] = f12;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   ___ldexp_cexpf(i4, i2, -1);
   i13 = HEAP32[i4 >> 2] | 0;
   f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   HEAP32[i3 >> 2] = i13;
   HEAPF32[i6 >> 2] = f15;
   f15 = Math_fround(f15 * Math_fround(_copysignf(Math_fround(1.0), f11)));
   HEAP32[i10 >> 2] = i13;
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  } else {
   f11 = Math_fround(f11 * Math_fround(1701411830000000029203285.0e14));
   f15 = Math_fround(f11 * Math_fround(+Math_sin(+f12)));
   HEAPF32[i10 >> 2] = Math_fround(Math_fround(f11 * f11) * Math_fround(+Math_cos(+f12)));
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  }
 } else {
  i3 = i8 >>> 0 > 2139095039;
  if ((i7 | 0) == 0 & i3) {
   f12 = Math_fround(f12 - f12);
   f15 = Math_fround(_copysignf(Math_fround(0.0), Math_fround(f11 * f12)));
   HEAPF32[i10 >> 2] = f12;
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  }
  i2 = i7 >>> 0 > 2139095039;
  if (i2 & (i8 | 0) == 0) {
   f1 = Math_fround(f11 * f11);
   if (!(i13 & 8388607)) {
    f15 = Math_fround(f12 * Math_fround(_copysignf(Math_fround(0.0), f11)));
    HEAPF32[i10 >> 2] = f1;
    HEAPF32[i10 + 4 >> 2] = f15;
    break;
   } else {
    f15 = Math_fround(_copysignf(Math_fround(0.0), Math_fround(Math_fround(f11 + f11) * f12)));
    HEAPF32[i10 >> 2] = f1;
    HEAPF32[i10 + 4 >> 2] = f15;
    break;
   }
  }
  if (i9 & i3) {
   f12 = Math_fround(f12 - f12);
   f15 = Math_fround(f11 * f12);
   HEAPF32[i10 >> 2] = f12;
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  }
  f1 = Math_fround(f11 * f11);
  if (!(i2 & (i13 & 8388607 | 0) == 0)) {
   f12 = Math_fround(f12 - f12);
   f15 = Math_fround(Math_fround(f11 + f11) * f12);
   HEAPF32[i10 >> 2] = Math_fround(f1 * f12);
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  }
  if (i3) {
   f15 = Math_fround(f11 * Math_fround(f12 - f12));
   HEAPF32[i10 >> 2] = f1;
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  } else {
   f15 = Math_fround(f11 * Math_fround(+Math_sin(+f12)));
   HEAPF32[i10 >> 2] = Math_fround(f1 * Math_fround(+Math_cos(+f12)));
   HEAPF32[i10 + 4 >> 2] = f15;
   break;
  }
 } while (0);
 STACKTOP = i14;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 HEAP32[i8 + 4 >> 2] = 0;
 i1 = HEAP16[i9 + 8 >> 1] | 0;
 HEAP8[i8 + 8 >> 0] = i1;
 HEAP8[i8 + 9 >> 0] = (i1 & 65535) >>> 8;
 i1 = i8 + 12 | 0;
 i2 = i9 + 12 | 0;
 i3 = HEAP32[i9 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i8 + 24 | 0;
 HEAP32[i4 >> 2] = i3;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i9 + 16 >> 2] | 0;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i4 >> 2] | 0;
   i11 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i6;
   if (i6) i11 = 8;
  } else {
   i2 = i3;
   i11 = 6;
  }
  if ((i11 | 0) == 6) {
   i3 = i6 + 16 & -16;
   HEAP32[i7 >> 2] = 54;
   HEAP32[i7 + 4 >> 2] = i2;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i8 + 20 >> 2] = i3 | -2147483648;
   HEAP32[i8 + 16 >> 2] = i6;
   i1 = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 HEAP32[i8 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 i1 = i8 + 32 | 0;
 i2 = i9 + 32 | 0;
 i3 = HEAP32[i9 + 44 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i8 + 44 | 0;
 HEAP32[i4 >> 2] = i3;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i9 + 36 >> 2] | 0;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i4 >> 2] | 0;
   i11 = 15;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i6;
   if (i6) i11 = 17;
  } else {
   i2 = i3;
   i11 = 15;
  }
  if ((i11 | 0) == 15) {
   i4 = i6 + 16 & -16;
   HEAP32[i7 >> 2] = 54;
   HEAP32[i7 + 4 >> 2] = i2;
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i8 + 40 >> 2] = i4 | -2147483648;
   HEAP32[i8 + 36 >> 2] = i6;
   i1 = i7;
   i11 = 17;
  }
  if ((i11 | 0) == 17) _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 HEAP32[i8 + 48 >> 2] = HEAP32[i9 + 48 >> 2];
 HEAP32[i8 + 52 >> 2] = 0;
 i11 = i8 + 56 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f13 = Math_fround((HEAP32[i11 >> 2] | 0) >>> 0);
 HEAP32[i8 + 68 >> 2] = ~~Math_fround(f13 * Math_fround(.5)) >>> 0;
 HEAP32[i8 + 64 >> 2] = ~~Math_fround(f13 * Math_fround(.200000003)) >>> 0;
 HEAP8[i8 + 72 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9copy_fromERKSL_j(i8, i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN5physx32pcmDistanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES4_S4_S4_RNS1_6FloatVES6_(i1, i4, i2, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0;
 f17 = Math_fround(HEAPF32[i4 >> 2]);
 i22 = i4 + 4 | 0;
 f9 = Math_fround(HEAPF32[i22 >> 2]);
 i21 = i4 + 8 | 0;
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f30 = Math_fround(HEAPF32[i5 >> 2]);
 i18 = i5 + 4 | 0;
 f28 = Math_fround(HEAPF32[i18 >> 2]);
 i11 = i5 + 8 | 0;
 f30 = Math_fround(f17 - f30);
 f28 = Math_fround(f9 - f28);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i11 >> 2]));
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 i24 = i2 + 4 | 0;
 f17 = Math_fround(HEAPF32[i24 >> 2]);
 i23 = i2 + 8 | 0;
 f13 = Math_fround(HEAPF32[i23 >> 2]);
 f15 = Math_fround(f9 * f9);
 f10 = Math_fround(f17 * f17);
 f14 = Math_fround(f13 * f13);
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 i20 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i20 >> 2]);
 i19 = i3 + 8 | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(Math_fround(f15 + f10) + f14);
 f10 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f8 * f8)) + Math_fround(f12 * f12));
 f15 = Math_fround(Math_fround(Math_fround(f9 * f29) + Math_fround(f17 * f8)) + Math_fround(f13 * f12));
 f13 = Math_fround(Math_fround(Math_fround(f30 * f9) + Math_fround(f28 * f17)) + Math_fround(f16 * f13));
 i25 = f14 > Math_fround(1.1920929e-07);
 i26 = f10 > Math_fround(1.1920929e-07);
 f17 = Math_fround(Math_fround(1.0) / f14);
 f9 = Math_fround(Math_fround(1.0) / f10);
 f12 = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f28 * f8)) + Math_fround(f16 * f12));
 f14 = Math_fround(Math_fround(f14 * f10) - Math_fround(f15 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f15 * f12) - Math_fround(f13 * f10)) / f14);
 i27 = f10 > Math_fround(1.0);
 f10 = i27 ? Math_fround(1.0) : f10;
 i27 = f10 > Math_fround(0.0);
 f10 = i27 ? f10 : Math_fround(0.0);
 i27 = f14 < Math_fround(1.1920929e-07);
 f10 = Math_fround(f12 + Math_fround(f15 * (i27 ? Math_fround(.5) : f10)));
 f10 = Math_fround((i26 ? f9 : Math_fround(0.0)) * f10);
 i26 = f10 > Math_fround(1.0);
 f10 = i26 ? Math_fround(1.0) : f10;
 i26 = f10 > Math_fround(0.0);
 f10 = i26 ? f10 : Math_fround(0.0);
 f13 = Math_fround(Math_fround(f15 * f10) - f13);
 f13 = Math_fround((i25 ? f17 : Math_fround(0.0)) * f13);
 i25 = f13 > Math_fround(1.0);
 f13 = i25 ? Math_fround(1.0) : f13;
 i25 = f13 > Math_fround(0.0);
 f13 = i25 ? f13 : Math_fround(0.0);
 HEAPF32[i6 >> 2] = f13;
 HEAPF32[i7 >> 2] = f10;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(HEAPF32[i23 >> 2]);
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(HEAPF32[i22 >> 2]);
 f17 = Math_fround(f12 + Math_fround(f17 * f13));
 f15 = Math_fround(f14 + Math_fround(f15 * f13));
 f13 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + Math_fround(f9 * f13));
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i20 >> 2]);
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f9 = Math_fround(f17 - Math_fround(f16 + Math_fround(f9 * f10)));
 f8 = Math_fround(f15 - Math_fround(Math_fround(f14 * f10) + f8));
 f10 = Math_fround(f13 - Math_fround(Math_fround(f12 * f10) + Math_fround(HEAPF32[i11 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)));
 return;
}

function __ZN5physx2Gu29distanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_(i1, i4, i2, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0;
 f17 = Math_fround(HEAPF32[i4 >> 2]);
 i22 = i4 + 4 | 0;
 f9 = Math_fround(HEAPF32[i22 >> 2]);
 i21 = i4 + 8 | 0;
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f30 = Math_fround(HEAPF32[i5 >> 2]);
 i18 = i5 + 4 | 0;
 f28 = Math_fround(HEAPF32[i18 >> 2]);
 i11 = i5 + 8 | 0;
 f30 = Math_fround(f17 - f30);
 f28 = Math_fround(f9 - f28);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i11 >> 2]));
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 i24 = i2 + 4 | 0;
 f17 = Math_fround(HEAPF32[i24 >> 2]);
 i23 = i2 + 8 | 0;
 f13 = Math_fround(HEAPF32[i23 >> 2]);
 f15 = Math_fround(f9 * f9);
 f10 = Math_fround(f17 * f17);
 f14 = Math_fround(f13 * f13);
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 i20 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i20 >> 2]);
 i19 = i3 + 8 | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(Math_fround(f15 + f10) + f14);
 f10 = Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f8 * f8)) + Math_fround(f12 * f12));
 f15 = Math_fround(Math_fround(Math_fround(f9 * f29) + Math_fround(f17 * f8)) + Math_fround(f13 * f12));
 f13 = Math_fround(Math_fround(Math_fround(f30 * f9) + Math_fround(f28 * f17)) + Math_fround(f16 * f13));
 i25 = f14 > Math_fround(1.1920929e-07);
 i26 = f10 > Math_fround(1.1920929e-07);
 f17 = Math_fround(Math_fround(1.0) / f14);
 f9 = Math_fround(Math_fround(1.0) / f10);
 f12 = Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f28 * f8)) + Math_fround(f16 * f12));
 f14 = Math_fround(Math_fround(f14 * f10) - Math_fround(f15 * f15));
 f10 = Math_fround(Math_fround(Math_fround(f15 * f12) - Math_fround(f13 * f10)) / f14);
 i27 = f10 > Math_fround(1.0);
 f10 = i27 ? Math_fround(1.0) : f10;
 i27 = f10 > Math_fround(0.0);
 f10 = i27 ? f10 : Math_fround(0.0);
 i27 = f14 < Math_fround(1.1920929e-07);
 f10 = Math_fround(f12 + Math_fround(f15 * (i27 ? Math_fround(.5) : f10)));
 f10 = Math_fround((i26 ? f9 : Math_fround(0.0)) * f10);
 i26 = f10 > Math_fround(1.0);
 f10 = i26 ? Math_fround(1.0) : f10;
 i26 = f10 > Math_fround(0.0);
 f10 = i26 ? f10 : Math_fround(0.0);
 f13 = Math_fround(Math_fround(f15 * f10) - f13);
 f13 = Math_fround((i25 ? f17 : Math_fround(0.0)) * f13);
 i25 = f13 > Math_fround(1.0);
 f13 = i25 ? Math_fround(1.0) : f13;
 i25 = f13 > Math_fround(0.0);
 f13 = i25 ? f13 : Math_fround(0.0);
 HEAPF32[i6 >> 2] = f13;
 HEAPF32[i7 >> 2] = f10;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(HEAPF32[i23 >> 2]);
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f14 = Math_fround(HEAPF32[i22 >> 2]);
 f17 = Math_fround(f12 + Math_fround(f17 * f13));
 f15 = Math_fround(f14 + Math_fround(f15 * f13));
 f13 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + Math_fround(f9 * f13));
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i20 >> 2]);
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(HEAPF32[i18 >> 2]);
 f9 = Math_fround(f17 - Math_fround(f16 + Math_fround(f9 * f10)));
 f8 = Math_fround(f15 - Math_fround(Math_fround(f14 * f10) + f8));
 f10 = Math_fround(f13 - Math_fround(Math_fround(f12 * f10) + Math_fround(HEAPF32[i11 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)));
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5eraseERS7_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 12 | 0;
 i6 = i11;
 i10 = i9 + 4 | 0;
 if ((HEAP32[i9 + 92 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
  i1 = i9 + 84 | 0;
  i2 = i9 + 88 | 0;
  i8 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 36 | 0) | 0;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i6, i9, i8, i8, 1);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_(i7, i9, i1);
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = i9 + 84 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = i9 + 88 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == -1) {
   i8 = i4 + (i5 * 36 | 0) | 0;
   __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i6, i9, i8, i8, 1);
  } else {
   HEAP32[i6 >> 2] = i9;
   HEAP32[i6 + 4 >> 2] = i4 + (i3 * 36 | 0);
   HEAP32[i6 + 8 >> 2] = i4 + (i5 * 36 | 0);
  }
 }
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 36 | 0) | 0;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i7, i9, i6, i6, 1);
 if ((i8 | 0) == (HEAP32[i7 + 4 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = i9 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i8 + 24 | 0);
 HEAP32[i8 >> 2] = 0;
 i6 = i8 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i8 + 24 | 0;
 i5 = i9 + 36 | 0;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i8 | 0) != (i2 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  i7 = (i4 | 0) == 0;
  i4 = i7 ? i9 + 16 | 0 : i4;
  i5 = HEAP32[i9 + 32 >> 2] | 0;
  i2 = i8 + 4 | 0;
  if (!((HEAP32[i9 + 16 >> 2] | 0) != 0 | i7)) {
   HEAP32[i8 >> 2] = i4;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i5 >>> 0 > 15) {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i8 >> 2] = i7;
   HEAP32[i2 >> 2] = i5;
   i1 = (i7 | 0) == 0 ? i1 : i7;
  }
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i6 >> 2] = i5;
 } while (0);
 HEAP32[i8 + 32 >> 2] = HEAP32[i9 + 44 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 HEAP8[i9 + 104 >> 0] = 1;
 i10 = 1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN13TrailRenderer8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i8, i9);
 i4 = i8 + 388 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 421162 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = HEAP32[i8 + 384 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 421169 | 0, gb + 421182 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14LineParameters8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 392 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 421197 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i8 + 396 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 421217 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i7 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (HEAP8[i3 >> 0] | 0) {
  __ZN13TrailRenderer18TransferDeprecatedI14SafeBinaryReadEEvRT_(i8, i9);
  STACKTOP = i10;
  return;
 }
 HEAP8[i8 + 341 >> 0] = 0;
 __ZN13TrailRenderer18TransferDeprecatedI14SafeBinaryReadEEvRT_(i8, i9);
 STACKTOP = i10;
 return;
}

function runPostSets68() {
 HEAP32[gb + 76352 >> 2] = fb + 9;
 HEAP32[gb + 76356 >> 2] = fb + 389;
 HEAP32[gb + 76360 >> 2] = fb + 286;
 HEAP32[gb + 76364 >> 2] = fb + 837;
 HEAP32[gb + 76368 >> 2] = fb + 838;
 HEAP32[gb + 76372 >> 2] = fb + 839;
 HEAP32[gb + 76376 >> 2] = fb + 282;
 HEAP32[gb + 76380 >> 2] = fb + 283;
 HEAP32[gb + 76384 >> 2] = fb + 390;
 HEAP32[gb + 76388 >> 2] = fb + 391;
 HEAP32[gb + 76392 >> 2] = fb + 287;
 HEAP32[gb + 76396 >> 2] = fb + 840;
 HEAP32[gb + 76400 >> 2] = fb + 841;
 HEAP32[gb + 76404 >> 2] = fb + 166;
 HEAP32[gb + 76408 >> 2] = fb + 167;
 HEAP32[gb + 76412 >> 2] = fb + 284;
 HEAP32[gb + 76416 >> 2] = fb + 842;
 HEAP32[gb + 76420 >> 2] = fb + 843;
 HEAP32[gb + 76424 >> 2] = fb + 1;
 HEAP32[gb + 76428 >> 2] = fb + 1;
 HEAP32[gb + 76432 >> 2] = fb + 2;
 HEAP32[gb + 76436 >> 2] = fb + 2;
 HEAP32[gb + 76440 >> 2] = fb + 3;
 HEAP32[gb + 76444 >> 2] = fb + 1;
 HEAP32[gb + 76448 >> 2] = fb + 21;
 HEAP32[gb + 76452 >> 2] = fb + 291;
 HEAP32[gb + 76456 >> 2] = fb + 168;
 HEAP32[gb + 76460 >> 2] = fb + 26;
 HEAP32[gb + 76464 >> 2] = fb + 26;
 HEAP32[gb + 76468 >> 2] = fb + 16;
 HEAP32[gb + 76472 >> 2] = fb + 7;
 HEAP32[gb + 76476 >> 2] = fb + 844;
 HEAP32[gb + 76480 >> 2] = fb + 292;
 HEAP32[gb + 76484 >> 2] = fb + 693;
 HEAP32[gb + 76488 >> 2] = fb + 293;
 HEAP32[gb + 76492 >> 2] = fb + 294;
 HEAP32[gb + 76496 >> 2] = fb + 295;
 HEAP32[gb + 76500 >> 2] = fb + 296;
 HEAP32[gb + 76504 >> 2] = fb + 297;
 HEAP32[gb + 76508 >> 2] = fb + 298;
 HEAP32[gb + 76512 >> 2] = fb + 1;
 HEAP32[gb + 76516 >> 2] = fb + 694;
 HEAP32[gb + 76520 >> 2] = fb + 845;
 HEAP32[gb + 76524 >> 2] = fb + 22;
 HEAP32[gb + 76528 >> 2] = fb + 392;
 HEAP32[gb + 76532 >> 2] = fb + 695;
 HEAP32[gb + 76536 >> 2] = fb + 846;
 HEAP32[gb + 76540 >> 2] = fb + 847;
 HEAP32[gb + 76544 >> 2] = fb + 169;
 HEAP32[gb + 76548 >> 2] = fb + 69;
 HEAP32[gb + 76552 >> 2] = fb + 70;
 HEAP32[gb + 76556 >> 2] = fb + 71;
 HEAP32[gb + 76560 >> 2] = fb + 72;
 HEAP32[gb + 76564 >> 2] = fb + 287;
 HEAP32[gb + 76568 >> 2] = fb + 300;
 HEAP32[gb + 76572 >> 2] = fb + 393;
 HEAP32[gb + 76576 >> 2] = fb + 394;
 HEAP32[gb + 76580 >> 2] = fb + 172;
 HEAP32[gb + 76584 >> 2] = fb + 171;
 HEAP32[gb + 76588 >> 2] = fb + 172;
 HEAP32[gb + 76592 >> 2] = fb + 173;
 HEAP32[gb + 76596 >> 2] = fb + 174;
 HEAP32[gb + 76600 >> 2] = fb + 64;
 HEAP32[gb + 76604 >> 2] = fb + 288;
 HEAP32[gb + 76608 >> 2] = fb + 27;
 HEAP32[gb + 76612 >> 2] = fb + 173;
 HEAP32[gb + 76616 >> 2] = fb + 289;
 HEAP32[gb + 76620 >> 2] = fb + 46;
 HEAP32[gb + 76624 >> 2] = fb + 47;
 HEAP32[gb + 76628 >> 2] = fb + 73;
 HEAP32[gb + 76632 >> 2] = fb + 48;
 HEAP32[gb + 76636 >> 2] = fb + 74;
 HEAP32[gb + 76640 >> 2] = fb + 75;
 HEAP32[gb + 76644 >> 2] = fb + 848;
 HEAP32[gb + 76648 >> 2] = fb + 395;
 HEAP32[gb + 76652 >> 2] = fb + 95;
 HEAP32[gb + 76656 >> 2] = fb + 696;
 HEAP32[gb + 76660 >> 2] = fb + 4;
 HEAP32[gb + 76664 >> 2] = fb + 49;
 HEAP32[gb + 76668 >> 2] = fb + 76;
 HEAP32[gb + 76672 >> 2] = fb + 9;
 HEAP32[gb + 76676 >> 2] = fb + 697;
 HEAP32[gb + 76680 >> 2] = fb + 10;
 HEAP32[gb + 76684 >> 2] = fb + 6;
 HEAP32[gb + 76688 >> 2] = fb + 2;
 HEAP32[gb + 76692 >> 2] = fb + 292;
 HEAP32[gb + 76696 >> 2] = fb + 11;
 HEAP32[gb + 76700 >> 2] = fb + 50;
 HEAP32[gb + 76704 >> 2] = fb + 51;
 HEAP32[gb + 76708 >> 2] = fb + 52;
 HEAP32[gb + 76712 >> 2] = fb + 5;
 HEAP32[gb + 76716 >> 2] = fb + 12;
 HEAP32[gb + 76720 >> 2] = fb + 698;
 HEAP32[gb + 76724 >> 2] = fb + 294;
 HEAP32[gb + 76728 >> 2] = fb + 32;
 HEAP32[gb + 76732 >> 2] = fb + 175;
 HEAP32[gb + 76736 >> 2] = fb + 176;
 HEAP32[gb + 76740 >> 2] = fb + 18;
 HEAP32[gb + 76744 >> 2] = fb + 19;
 HEAP32[gb + 76748 >> 2] = fb + 177;
 runPostSets69();
}

function __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 24 | 0;
 i11 = i14;
 i12 = i10 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (((i1 - i2 | 0) / 88 | 0) >>> 0 >= i3 >>> 0) {
  do {
   i1 = i2 + 8 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP8[i2 + 4 >> 0] = 0;
   HEAP32[i2 + 52 >> 2] = 0;
   HEAP32[i2 + 56 >> 2] = 0;
   HEAP32[i2 + 60 >> 2] = 0;
   i5 = i2 + 72 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i5 = i1;
   i6 = i5 + 40 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i6 | 0));
   HEAP8[i1 + 40 >> 0] = 0;
   HEAP32[i2 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i12 = i2 + 64 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   i2 = (HEAP32[i13 >> 2] | 0) + 88 | 0;
   HEAP32[i13 >> 2] = i2;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i8 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i2 - i4 | 0) / 88 | 0) + i3 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i9 = (i1 - i4 | 0) / 88 | 0;
 i6 = i9 << 1;
 i6 = i9 >>> 0 < 1073741823 ? (i6 >>> 0 < i5 >>> 0 ? i5 : i6) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i8;
 if (!i6) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = 25;
  HEAP32[i7 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 88 | 0, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i5;
 i1 = i5 + (((i2 - i4 | 0) / 88 | 0) * 88 | 0) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i11 + 12 | 0;
 HEAP32[i9 >> 2] = i5 + (i6 * 88 | 0);
 i4 = i1;
 do {
  i2 = i4 + 8 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP8[i4 + 4 >> 0] = 0;
  HEAP32[i4 + 52 >> 2] = 0;
  HEAP32[i4 + 56 >> 2] = 0;
  HEAP32[i4 + 60 >> 2] = 0;
  i5 = i4 + 72 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i5 = i2;
  i6 = i5 + 40 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP8[i2 + 40 >> 0] = 0;
  HEAP32[i4 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i6 = i4 + 64 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  i4 = i4 + 88 | 0;
  HEAP32[i7 >> 2] = i4;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i2 = i2 + -88 | 0;
   __ZN24CompressedAnimationCurveC2ERKS_(i1 + -88 | 0, i2);
   i1 = (HEAP32[i8 >> 2] | 0) + -88 | 0;
   HEAP32[i8 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i2;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i13;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__214__split_bufferI24CompressedAnimationCurveR13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN7Cursors9SetCursorEP9Texture2D8Vector2f10CursorMode(i10, i3, i1) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 20 | 0;
 i12 = i13;
 i7 = i3;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = gb + 1100516 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[gb + 1100512 >> 2] = 0;
 if (!i10) {
  _JS_Cursor_SetShow(1);
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) == 1) {
  _JS_Cursor_SetShow(0);
  HEAP32[gb + 1100512 >> 2] = HEAP32[i10 + 4 >> 2];
  STACKTOP = i13;
  return;
 }
 i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 136 >> 2] | 0, i10 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0) | 0;
 i7 = i5 << 2;
 i2 = Math_imul(i6, i7) | 0;
 i8 = i2 + 64 | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 i14 = gb + 63160 | 0;
 i1 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 do if (!i8) i1 = 0; else if (i8 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i8 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, gb + 64016 | 0, 0, gb + 363629 | 0, 44) | 0;
  i4 = gb + 64016 | 0;
  i15 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  i14 = i9;
  HEAP32[i14 >> 2] = i15;
  HEAP32[i14 + 4 >> 2] = i4;
  break;
 } while (0);
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 1 >> 0] = 0;
 i4 = i1 + 2 | 0;
 HEAP8[i4 >> 0] = 2;
 HEAP8[i4 + 1 >> 0] = 0;
 i4 = i1 + 4 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP8[i4 + 1 >> 0] = 0;
 HEAP8[i1 + 6 >> 0] = i5;
 HEAP8[i1 + 7 >> 0] = i6;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 i4 = i1 + 10 | 0;
 i15 = ~~Math_fround(HEAPF32[i3 >> 2]);
 i14 = i5 + -1 | 0;
 i15 = (i15 | 0) < 0 ? 0 : ((i15 | 0) > (i14 | 0) ? i14 : i15) & 65535;
 HEAP8[i4 >> 0] = i15;
 HEAP8[i4 + 1 >> 0] = i15 >> 8;
 i4 = i1 + 12 | 0;
 i3 = ~~Math_fround(HEAPF32[i3 + 4 >> 2]);
 i15 = i6 + -1 | 0;
 i3 = (i3 | 0) < 0 ? 0 : ((i3 | 0) > (i15 | 0) ? i15 : i3) & 65535;
 HEAP8[i4 >> 0] = i3;
 HEAP8[i4 + 1 >> 0] = i3 >> 8;
 i3 = i1 + 14 | 0;
 i2 = i2 + 40 | 0;
 HEAP8[i3 >> 0] = i2;
 HEAP8[i3 + 1 >> 0] = i2 >> 8;
 HEAP8[i3 + 2 >> 0] = i2 >> 16;
 HEAP8[i3 + 3 >> 0] = i2 >> 24;
 i2 = i1 + 18 | 0;
 HEAP8[i2 >> 0] = 24;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 i2 = i1 + 22 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 i2 = i1 + 24 | 0;
 HEAP8[i2 >> 0] = 40;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 i2 = i1 + 28 | 0;
 HEAP8[i2 >> 0] = i5;
 HEAP8[i2 + 1 >> 0] = i5 >> 8;
 HEAP8[i2 + 2 >> 0] = i5 >> 16;
 HEAP8[i2 + 3 >> 0] = i5 >> 24;
 i2 = i1 + 32 | 0;
 i3 = i6 << 1;
 HEAP8[i2 >> 0] = i3;
 HEAP8[i2 + 1 >> 0] = i3 >> 8;
 HEAP8[i2 + 2 >> 0] = i3 >> 16;
 HEAP8[i2 + 3 >> 0] = i3 >> 24;
 i2 = i1 + 36 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP8[i2 + 1 >> 0] = 0;
 i2 = i1 + 38 | 0;
 HEAP8[i2 >> 0] = 32;
 HEAP8[i2 + 1 >> 0] = 0;
 i2 = i1 + 64 | 0;
 i3 = i1 + 40 | 0;
 i4 = i3 + 24 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i12, i5, i6, i7, 5, i2);
 mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 168 >> 2] | 0, i10 | 0, i12 | 0, 2, 1, 0) | 0;
 __Z13ConvertPixelsPKh13TextureFormatPhS1_j(i2, 5, i2, 14, Math_imul(i6, i5) | 0);
 _JS_Cursor_SetImage(i1 | 0, i8 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i9);
 STACKTOP = i13;
 return;
}

function runPostSets99() {
 HEAP32[gb + 95816 >> 2] = fb + 1;
 HEAP32[gb + 95820 >> 2] = fb + 1;
 HEAP32[gb + 95824 >> 2] = fb + 1;
 HEAP32[gb + 95828 >> 2] = fb + 1;
 HEAP32[gb + 95832 >> 2] = fb + 1;
 HEAP32[gb + 95836 >> 2] = fb + 1;
 HEAP32[gb + 95840 >> 2] = fb + 1;
 HEAP32[gb + 95844 >> 2] = fb + 1;
 HEAP32[gb + 95848 >> 2] = fb + 1;
 HEAP32[gb + 95852 >> 2] = fb + 1;
 HEAP32[gb + 95856 >> 2] = fb + 1;
 HEAP32[gb + 95860 >> 2] = fb + 1;
 HEAP32[gb + 95864 >> 2] = fb + 1;
 HEAP32[gb + 95868 >> 2] = fb + 1;
 HEAP32[gb + 95872 >> 2] = fb + 1;
 HEAP32[gb + 95876 >> 2] = fb + 1;
 HEAP32[gb + 95880 >> 2] = fb + 1;
 HEAP32[gb + 95884 >> 2] = fb + 1;
 HEAP32[gb + 95888 >> 2] = fb + 1;
 HEAP32[gb + 95892 >> 2] = fb + 1;
 HEAP32[gb + 95896 >> 2] = fb + 1;
 HEAP32[gb + 95900 >> 2] = fb + 1;
 HEAP32[gb + 95904 >> 2] = fb + 1;
 HEAP32[gb + 95908 >> 2] = fb + 1;
 HEAP32[gb + 95920 >> 2] = fb + 1347;
 HEAP32[gb + 95924 >> 2] = fb + 648;
 HEAP32[gb + 95928 >> 2] = fb + 456;
 HEAP32[gb + 95932 >> 2] = fb + 1348;
 HEAP32[gb + 95936 >> 2] = fb + 1349;
 HEAP32[gb + 95940 >> 2] = fb + 293;
 HEAP32[gb + 95944 >> 2] = fb + 649;
 HEAP32[gb + 95948 >> 2] = fb + 650;
 HEAP32[gb + 95952 >> 2] = fb + 1029;
 HEAP32[gb + 95956 >> 2] = fb + 651;
 HEAP32[gb + 95960 >> 2] = fb + 15;
 HEAP32[gb + 95964 >> 2] = fb + 185;
 HEAP32[gb + 95968 >> 2] = fb + 1030;
 HEAP32[gb + 95972 >> 2] = fb + 652;
 HEAP32[gb + 95976 >> 2] = fb + 1031;
 HEAP32[gb + 95980 >> 2] = fb + 653;
 HEAP32[gb + 95984 >> 2] = fb + 1032;
 HEAP32[gb + 95988 >> 2] = fb + 654;
 HEAP32[gb + 95992 >> 2] = fb + 1033;
 HEAP32[gb + 95996 >> 2] = fb + 655;
 HEAP32[gb + 96e3 >> 2] = fb + 656;
 HEAP32[gb + 96004 >> 2] = fb + 294;
 HEAP32[gb + 96008 >> 2] = fb + 657;
 HEAP32[gb + 96012 >> 2] = fb + 295;
 HEAP32[gb + 96016 >> 2] = fb + 186;
 HEAP32[gb + 96020 >> 2] = fb + 1350;
 HEAP32[gb + 96024 >> 2] = fb + 78;
 HEAP32[gb + 96028 >> 2] = fb + 79;
 HEAP32[gb + 96032 >> 2] = fb + 80;
 HEAP32[gb + 96036 >> 2] = fb + 38;
 HEAP32[gb + 96040 >> 2] = fb + 108;
 HEAP32[gb + 96044 >> 2] = fb + 83;
 HEAP32[gb + 96048 >> 2] = fb + 1034;
 HEAP32[gb + 96052 >> 2] = fb + 1035;
 HEAP32[gb + 96056 >> 2] = fb + 187;
 HEAP32[gb + 96060 >> 2] = fb + 16;
 HEAP32[gb + 96064 >> 2] = fb + 109;
 HEAP32[gb + 96068 >> 2] = fb + 84;
 HEAP32[gb + 96072 >> 2] = fb + 110;
 HEAP32[gb + 96076 >> 2] = fb + 85;
 HEAP32[gb + 96080 >> 2] = fb + 111;
 HEAP32[gb + 96084 >> 2] = fb + 86;
 HEAP32[gb + 96088 >> 2] = fb + 112;
 HEAP32[gb + 96092 >> 2] = fb + 87;
 HEAP32[gb + 96096 >> 2] = fb + 1036;
 HEAP32[gb + 96100 >> 2] = fb + 1037;
 HEAP32[gb + 96104 >> 2] = fb + 1351;
 HEAP32[gb + 96108 >> 2] = fb + 188;
 HEAP32[gb + 96112 >> 2] = fb + 658;
 HEAP32[gb + 96116 >> 2] = fb + 659;
 HEAP32[gb + 96120 >> 2] = fb + 113;
 HEAP32[gb + 96124 >> 2] = fb + 88;
 HEAP32[gb + 96128 >> 2] = fb + 114;
 HEAP32[gb + 96132 >> 2] = fb + 89;
 HEAP32[gb + 96136 >> 2] = fb + 115;
 HEAP32[gb + 96140 >> 2] = fb + 90;
 HEAP32[gb + 96144 >> 2] = fb + 116;
 HEAP32[gb + 96148 >> 2] = fb + 91;
 HEAP32[gb + 96152 >> 2] = fb + 660;
 HEAP32[gb + 96156 >> 2] = fb + 189;
 HEAP32[gb + 96160 >> 2] = fb + 1;
 HEAP32[gb + 96164 >> 2] = fb + 1;
 HEAP32[gb + 96168 >> 2] = fb + 1;
 HEAP32[gb + 96172 >> 2] = fb + 1;
 HEAP32[gb + 96176 >> 2] = fb + 1;
 HEAP32[gb + 96180 >> 2] = fb + 1;
 HEAP32[gb + 96184 >> 2] = fb + 1;
 HEAP32[gb + 96188 >> 2] = fb + 1;
 HEAP32[gb + 96192 >> 2] = fb + 1038;
 HEAP32[gb + 96196 >> 2] = fb + 1039;
 HEAP32[gb + 96208 >> 2] = fb + 1347;
 HEAP32[gb + 96212 >> 2] = fb + 648;
 HEAP32[gb + 96216 >> 2] = fb + 456;
 HEAP32[gb + 96220 >> 2] = fb + 1352;
 HEAP32[gb + 96224 >> 2] = fb + 1353;
 HEAP32[gb + 96228 >> 2] = fb + 293;
 runPostSets100();
}

function __ZN7mecanim21ValueArrayReverseCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi(i1, i3, i2, i4, i34) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i34 = i34 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i35 = HEAP32[i1 >> 2] | 0;
 if ((i35 | 0) <= 0) return;
 i32 = i1 + 4 | 0;
 i33 = i32;
 i31 = i2 + 4 | 0;
 i10 = i31;
 i11 = i3 + 4 | 0;
 i12 = i11;
 i13 = i4 + 4 | 0;
 i14 = i13;
 i15 = i3 + 12 | 0;
 i16 = i15;
 i17 = i4 + 12 | 0;
 i18 = i17;
 i19 = i3 + 20 | 0;
 i20 = i19;
 i21 = i4 + 20 | 0;
 i22 = i21;
 i23 = i3 + 28 | 0;
 i24 = i23;
 i25 = i4 + 28 | 0;
 i26 = i25;
 i27 = i3 + 36 | 0;
 i28 = i27;
 i29 = i4 + 36 | 0;
 i30 = i29;
 i8 = i3 + 44 | 0;
 i9 = i8;
 i2 = i4 + 44 | 0;
 i3 = i2;
 i1 = 0;
 do {
  i4 = HEAP32[i34 + (i1 << 2) >> 2] | 0;
  L6 : do if ((i4 | 0) != -1) {
   i5 = (HEAP32[i32 >> 2] | 0) + i33 | 0;
   i6 = HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i7 = (HEAP32[i31 >> 2] | 0) + i10 | 0;
   if ((i6 | 0) == (HEAP32[i7 + (i4 * 12 | 0) + 4 >> 2] | 0)) switch (i6 | 0) {
   case 6:
    {
     i37 = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i38 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
     i36 = HEAP32[i38 + (i37 * 12 | 0) + 4 >> 2] | 0;
     i5 = HEAP32[i38 + (i37 * 12 | 0) + 8 >> 2] | 0;
     i7 = HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i6 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
     HEAP32[i6 + (i7 * 12 | 0) >> 2] = HEAP32[i38 + (i37 * 12 | 0) >> 2];
     HEAP32[i6 + (i7 * 12 | 0) + 4 >> 2] = i36;
     HEAP32[i6 + (i7 * 12 | 0) + 8 >> 2] = i5;
     break L6;
    }
   case 7:
    {
     i39 = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i40 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
     i5 = HEAP32[i40 + (i39 << 4) + 4 >> 2] | 0;
     i6 = HEAP32[i40 + (i39 << 4) + 8 >> 2] | 0;
     i36 = HEAP32[i40 + (i39 << 4) + 12 >> 2] | 0;
     i38 = HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i37 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
     HEAP32[i37 + (i38 << 4) >> 2] = HEAP32[i40 + (i39 << 4) >> 2];
     HEAP32[i37 + (i38 << 4) + 4 >> 2] = i5;
     HEAP32[i37 + (i38 << 4) + 8 >> 2] = i6;
     HEAP32[i37 + (i38 << 4) + 12 >> 2] = i36;
     break L6;
    }
   case 8:
    {
     i36 = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i6 = (HEAP32[i19 >> 2] | 0) + i20 | 0;
     i37 = HEAP32[i6 + (i36 * 12 | 0) + 4 >> 2] | 0;
     i38 = HEAP32[i6 + (i36 * 12 | 0) + 8 >> 2] | 0;
     i40 = HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i39 = (HEAP32[i21 >> 2] | 0) + i22 | 0;
     HEAP32[i39 + (i40 * 12 | 0) >> 2] = HEAP32[i6 + (i36 * 12 | 0) >> 2];
     HEAP32[i39 + (i40 * 12 | 0) + 4 >> 2] = i37;
     HEAP32[i39 + (i40 * 12 | 0) + 8 >> 2] = i38;
     break L6;
    }
   case 1:
    {
     HEAP32[(HEAP32[i25 >> 2] | 0) + i26 + (HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[(HEAP32[i23 >> 2] | 0) + i24 + (HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2];
     break L6;
    }
   case 3:
    {
     HEAP32[(HEAP32[i29 >> 2] | 0) + i30 + (HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + i28 + (HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2];
     break L6;
    }
   case 4:
   case 9:
    {
     HEAP8[(HEAP32[i2 >> 2] | 0) + i3 + (HEAP32[i7 + (i4 * 12 | 0) + 8 >> 2] | 0) >> 0] = HEAP8[(HEAP32[i8 >> 2] | 0) + i9 + (HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0;
     break L6;
    }
   default:
    break L6;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i35 | 0));
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation22FinalizeArchiveCreatorEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16 | 0;
 i10 = i12;
 i4 = i12 + 44 | 0;
 i9 = i12 + 48 | 0;
 i5 = i12 + 32 | 0;
 i7 = i12 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i8 + 132 | 0;
 i2 = __ZN23ArchiveStorageConverter21FinalizeTargetArchiveEPj(HEAP32[i1 >> 2] | 0, i4) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) __ZN23ArchiveStorageConverterD2Ev(i3);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 if (!i2) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = i8 + 88 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  if (!i4) {
   i11 = HEAP32[gb + 27728 >> 2] | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, _strlen(i11) | 0);
   __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i8 + 64 | 0, i7);
   i11 = (__ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i8, i5, 0, 0) | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   if (!i11) {
    i11 = 0;
    STACKTOP = i12;
    return i11 | 0;
   }
   i1 = i8 + 80 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
    HEAP32[i1 >> 2] = 0;
   }
  } else if ((i6 | 0) != (i4 | 0)) {
   i1 = i8 + 112 | 0;
   i5 = i1 + 11 | 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i10 + 4 >> 2] = i4;
   HEAP32[i10 + 8 >> 2] = i2;
   __Z6FormatPKcz(i9, gb + 368115 | 0, i10);
   i3 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
   i2 = i8 + 92 | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = 2;
    i2 = i8 + 96 | 0;
    if (!i3) {
     if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i11 >> 2] = i1;
     __Z6FormatPKcz(i10, gb + 367971 | 0, i11);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i10) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i3) | 0;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
  HEAP32[i3 >> 2] = 0;
 }
 if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation20MoveFilesToCachePathEv(i8) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i11 = HEAP32[gb + 27728 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, _strlen(i11) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i8 + 64 | 0, i7);
 i11 = (__ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i8, i5, 0, 0) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i12;
 return i11 | 0;
}

function runPostSets92() {
 HEAP32[gb + 92752 >> 2] = fb + 1;
 HEAP32[gb + 92756 >> 2] = fb + 1;
 HEAP32[gb + 92760 >> 2] = fb + 1;
 HEAP32[gb + 92764 >> 2] = fb + 1;
 HEAP32[gb + 92768 >> 2] = fb + 1;
 HEAP32[gb + 92772 >> 2] = fb + 1;
 HEAP32[gb + 92776 >> 2] = fb + 1;
 HEAP32[gb + 92780 >> 2] = fb + 1;
 HEAP32[gb + 92784 >> 2] = fb + 1;
 HEAP32[gb + 92788 >> 2] = fb + 1;
 HEAP32[gb + 92792 >> 2] = fb + 1;
 HEAP32[gb + 92796 >> 2] = fb + 1;
 HEAP32[gb + 92800 >> 2] = fb + 1;
 HEAP32[gb + 92804 >> 2] = fb + 1;
 HEAP32[gb + 92808 >> 2] = fb + 1;
 HEAP32[gb + 92812 >> 2] = fb + 1;
 HEAP32[gb + 92816 >> 2] = fb + 1;
 HEAP32[gb + 92820 >> 2] = fb + 1;
 HEAP32[gb + 92824 >> 2] = fb + 1;
 HEAP32[gb + 92828 >> 2] = fb + 1;
 HEAP32[gb + 92832 >> 2] = fb + 1;
 HEAP32[gb + 92836 >> 2] = fb + 1;
 HEAP32[gb + 92840 >> 2] = fb + 1;
 HEAP32[gb + 92844 >> 2] = fb + 1;
 HEAP32[gb + 92848 >> 2] = fb + 1;
 HEAP32[gb + 92852 >> 2] = fb + 1;
 HEAP32[gb + 92856 >> 2] = fb + 1;
 HEAP32[gb + 92860 >> 2] = fb + 1;
 HEAP32[gb + 92864 >> 2] = fb + 1;
 HEAP32[gb + 92868 >> 2] = fb + 1;
 HEAP32[gb + 92872 >> 2] = fb + 1;
 HEAP32[gb + 92876 >> 2] = fb + 1;
 HEAP32[gb + 92880 >> 2] = fb + 1;
 HEAP32[gb + 92884 >> 2] = fb + 1;
 HEAP32[gb + 92888 >> 2] = fb + 1;
 HEAP32[gb + 92892 >> 2] = fb + 1;
 HEAP32[gb + 92896 >> 2] = fb + 1;
 HEAP32[gb + 92900 >> 2] = fb + 1;
 HEAP32[gb + 92904 >> 2] = fb + 956;
 HEAP32[gb + 92908 >> 2] = fb + 957;
 HEAP32[gb + 92924 >> 2] = fb + 1285;
 HEAP32[gb + 92928 >> 2] = fb + 581;
 HEAP32[gb + 92932 >> 2] = fb + 582;
 HEAP32[gb + 92936 >> 2] = fb + 583;
 HEAP32[gb + 92940 >> 2] = fb + 584;
 HEAP32[gb + 92944 >> 2] = fb + 585;
 HEAP32[gb + 92948 >> 2] = fb + 958;
 HEAP32[gb + 92952 >> 2] = fb + 586;
 HEAP32[gb + 92956 >> 2] = fb + 1286;
 HEAP32[gb + 92960 >> 2] = fb + 959;
 HEAP32[gb + 92964 >> 2] = fb + 587;
 HEAP32[gb + 92968 >> 2] = fb + 1;
 HEAP32[gb + 92972 >> 2] = fb + 12;
 HEAP32[gb + 92976 >> 2] = fb + 1;
 HEAP32[gb + 92980 >> 2] = fb + 1287;
 HEAP32[gb + 92984 >> 2] = fb + 1288;
 HEAP32[gb + 92988 >> 2] = fb + 588;
 HEAP32[gb + 93e3 >> 2] = fb + 145;
 HEAP32[gb + 93004 >> 2] = fb + 1289;
 HEAP32[gb + 93008 >> 2] = fb + 1054;
 HEAP32[gb + 93012 >> 2] = fb + 1290;
 HEAP32[gb + 93024 >> 2] = fb + 146;
 HEAP32[gb + 93028 >> 2] = fb + 1291;
 HEAP32[gb + 93032 >> 2] = fb + 1036;
 HEAP32[gb + 93036 >> 2] = fb + 1292;
 HEAP32[gb + 93048 >> 2] = fb + 147;
 HEAP32[gb + 93052 >> 2] = fb + 1293;
 HEAP32[gb + 93056 >> 2] = fb + 1294;
 HEAP32[gb + 93060 >> 2] = fb + 1295;
 HEAP32[gb + 93072 >> 2] = fb + 76;
 HEAP32[gb + 93076 >> 2] = fb + 1296;
 HEAP32[gb + 93080 >> 2] = fb + 1297;
 HEAP32[gb + 93092 >> 2] = fb + 148;
 HEAP32[gb + 93096 >> 2] = fb + 1298;
 HEAP32[gb + 93100 >> 2] = fb + 1294;
 HEAP32[gb + 93104 >> 2] = fb + 1299;
 HEAP32[gb + 93116 >> 2] = fb + 77;
 HEAP32[gb + 93120 >> 2] = fb + 1296;
 HEAP32[gb + 93124 >> 2] = fb + 1300;
 HEAP32[gb + 93136 >> 2] = fb + 78;
 HEAP32[gb + 93140 >> 2] = fb + 1296;
 HEAP32[gb + 93144 >> 2] = fb + 1301;
 HEAP32[gb + 93156 >> 2] = fb + 1302;
 HEAP32[gb + 93160 >> 2] = fb + 589;
 HEAP32[gb + 93164 >> 2] = fb + 456;
 HEAP32[gb + 93168 >> 2] = fb + 1303;
 HEAP32[gb + 93172 >> 2] = fb + 1304;
 HEAP32[gb + 93176 >> 2] = fb + 265;
 HEAP32[gb + 93180 >> 2] = fb + 590;
 HEAP32[gb + 93184 >> 2] = fb + 164;
 HEAP32[gb + 93188 >> 2] = fb + 165;
 HEAP32[gb + 93192 >> 2] = fb + 1305;
 HEAP32[gb + 93196 >> 2] = fb + 960;
 HEAP32[gb + 93200 >> 2] = fb + 591;
 HEAP32[gb + 93204 >> 2] = fb + 166;
 HEAP32[gb + 93208 >> 2] = fb + 167;
 HEAP32[gb + 93212 >> 2] = fb + 592;
 HEAP32[gb + 93216 >> 2] = fb + 10;
 HEAP32[gb + 93220 >> 2] = fb + 168;
 HEAP32[gb + 93224 >> 2] = fb + 65;
 runPostSets93();
}

function __ZN5physx14updateParticleERNS_16PxsFluidParticleERKNS_19PxsParticleCollDataEbRKNS_7PxPlaneERNS_9PxBounds3E(i2, i1, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 if (i3) {
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 80 >> 2]);
  f6 = Math_fround(f11 * f8);
  i13 = i4 + 4 | 0;
  f10 = Math_fround(HEAPF32[i13 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 84 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f10 * f7));
  i3 = i4 + 8 | 0;
  f12 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(HEAPF32[i1 + 88 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f12 * f9));
  f10 = Math_fround(f7 - Math_fround(f10 * f6));
  f12 = Math_fround(f9 - Math_fround(f12 * f6));
  HEAPF32[i2 + 16 >> 2] = Math_fround(f8 - Math_fround(f11 * f6));
  HEAPF32[i2 + 20 >> 2] = f10;
  HEAPF32[i2 + 24 >> 2] = f12;
  f12 = Math_fround(HEAPF32[i1 + 64 >> 2]);
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  f6 = Math_fround(f12 * f10);
  f11 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  f8 = Math_fround(HEAPF32[i13 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f11 * f8));
  f9 = Math_fround(HEAPF32[i1 + 72 >> 2]);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(f6 + Math_fround(f9 * f7));
  f6 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) + f6);
  f10 = Math_fround(f12 - Math_fround(f10 * f6));
  f8 = Math_fround(f11 - Math_fround(f8 * f6));
  f6 = Math_fround(f9 - Math_fround(f7 * f6));
  HEAPF32[i2 >> 2] = f10;
  HEAPF32[i2 + 4 >> 2] = f8;
  HEAPF32[i2 + 8 >> 2] = f6;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  i4 = i5 + 4 | 0;
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i5 + 8 | 0;
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  HEAPF32[i5 >> 2] = f7 < f10 ? f7 : f10;
  HEAPF32[i4 >> 2] = f9 < f8 ? f9 : f8;
  HEAPF32[i3 >> 2] = f11 < f6 ? f11 : f6;
  i3 = i5 + 12 | 0;
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i5 + 16 | 0;
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  i5 = i5 + 20 | 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i3 >> 2] = f11 > f10 ? f11 : f10;
  HEAPF32[i4 >> 2] = f9 > f8 ? f9 : f8;
  HEAPF32[i5 >> 2] = f7 > f6 ? f7 : f6;
  i5 = i2 + 28 | 0;
  i4 = i1 + 60 | 0;
  i4 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
  HEAP16[i5 >> 1] = i4;
  HEAP16[i5 + 2 >> 1] = i4 >>> 16;
  return;
 } else {
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 80 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 84 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 88 >> 2];
  i4 = i1 + 64 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i13 = i1 + 68 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i13 >> 2];
  i14 = i1 + 72 | 0;
  HEAP32[i2 + 8 >> 2] = HEAP32[i14 >> 2];
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  i15 = i5 + 4 | 0;
  f10 = Math_fround(HEAPF32[i15 >> 2]);
  f9 = Math_fround(HEAPF32[i13 >> 2]);
  i3 = i5 + 8 | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  f7 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i5 >> 2] = f12 < f11 ? f12 : f11;
  HEAPF32[i15 >> 2] = f10 < f9 ? f10 : f9;
  HEAPF32[i3 >> 2] = f8 < f7 ? f8 : f7;
  i3 = i5 + 12 | 0;
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i4 >> 2]);
  i4 = i5 + 16 | 0;
  f9 = Math_fround(HEAPF32[i4 >> 2]);
  f10 = Math_fround(HEAPF32[i13 >> 2]);
  i13 = i5 + 20 | 0;
  f11 = Math_fround(HEAPF32[i13 >> 2]);
  f12 = Math_fround(HEAPF32[i14 >> 2]);
  HEAPF32[i3 >> 2] = f7 > f8 ? f7 : f8;
  HEAPF32[i4 >> 2] = f9 > f10 ? f9 : f10;
  HEAPF32[i13 >> 2] = f11 > f12 ? f11 : f12;
  i13 = i2 + 28 | 0;
  i5 = i1 + 60 | 0;
  i5 = HEAPU16[i5 >> 1] | HEAPU16[i5 + 2 >> 1] << 16;
  HEAP16[i13 >> 1] = i5;
  HEAP16[i13 + 2 >> 1] = i5 >>> 16;
  return;
 }
}

function __ZN5physx2Gu22computeMTD_PlaneConvexERNS_6PxVec3ERfRKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i19, i18, i4, i1, i3) {
 i19 = i19 | 0;
 i18 = i18 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i20 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP8[i20 + 54 >> 0] | 0;
 i21 = HEAP32[i20 + 56 >> 2] | 0;
 i20 = (HEAPU8[i20 + 55 >> 0] | 0) * 20 | 0;
 i7 = i21 + i20 | 0;
 f13 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i21 + (i20 + 4) >> 2]) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(HEAPF32[i21 + (i20 + 8) >> 2]) * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f13 * f10);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f14 * f11));
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f6 * f12));
 f17 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f9) + Math_fround(f8 * Math_fround(Math_fround(f6 * f11) - Math_fround(f14 * f12)))));
 f2 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f14 * f9) + Math_fround(f8 * Math_fround(Math_fround(f13 * f12) - Math_fround(f6 * f10)))));
 f5 = Math_fround(Math_fround(Math_fround(f6 * f9) + Math_fround(f8 * Math_fround(Math_fround(f14 * f10) - Math_fround(f13 * f11)))) + Math_fround(f12 * f5));
 f13 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f17 = Math_fround(f13 + f17);
 f14 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f2 = Math_fround(f14 + f2);
 f6 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f5 = Math_fround(f6 + f5);
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f17 = Math_fround(f15 * f17);
 f16 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f2 = Math_fround(f17 + Math_fround(f16 * f2));
 f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f2 = Math_fround(Math_fround(f5 * f17) + f2);
 f5 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f2 = Math_fround(f5 + f2);
 if ((i1 & 255) > 1) {
  i3 = i1 & 255;
  i1 = 1;
  do {
   f23 = Math_fround(Math_fround(HEAPF32[i7 + (i1 * 12 | 0) >> 2]) * Math_fround(2.0));
   f24 = Math_fround(Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 4 >> 2]) * Math_fround(2.0));
   f22 = Math_fround(Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 8 >> 2]) * Math_fround(2.0));
   f25 = Math_fround(Math_fround(Math_fround(f23 * f10) + Math_fround(f24 * f11)) + Math_fround(f22 * f12));
   f22 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(f6 + Math_fround(Math_fround(Math_fround(f22 * f9) + Math_fround(f8 * Math_fround(Math_fround(f24 * f10) - Math_fround(f23 * f11)))) + Math_fround(f12 * f25))) * f17) + Math_fround(Math_fround(f15 * Math_fround(f13 + Math_fround(Math_fround(f10 * f25) + Math_fround(Math_fround(f23 * f9) + Math_fround(f8 * Math_fround(Math_fround(f22 * f11) - Math_fround(f24 * f12))))))) + Math_fround(f16 * Math_fround(f14 + Math_fround(Math_fround(f11 * f25) + Math_fround(Math_fround(f24 * f9) + Math_fround(f8 * Math_fround(Math_fround(f23 * f12) - Math_fround(f22 * f10))))))))));
   f2 = f2 < f22 ? f2 : f22;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 if (f2 > Math_fround(0.0)) {
  i21 = 0;
  return i21 | 0;
 }
 f24 = Math_fround(-f16);
 f25 = Math_fround(-f17);
 HEAPF32[i19 >> 2] = Math_fround(-f15);
 HEAPF32[i19 + 4 >> 2] = f24;
 HEAPF32[i19 + 8 >> 2] = f25;
 f25 = Math_fround(-f2);
 i21 = f2 < Math_fround(-0.0);
 HEAPF32[i18 >> 2] = i21 ? f25 : Math_fround(0.0);
 i21 = 1;
 return i21 | 0;
}

function __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i1, i24, i25) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27;
 i4 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i26 >> 2] = i4;
 HEAP32[i26 + 4 >> 2] = i9;
 HEAP32[i26 + 8 >> 2] = i2;
 i8 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i26 + 12 >> 2] = i8;
 HEAP32[i26 + 16 >> 2] = i9;
 HEAP32[i26 + 20 >> 2] = i2;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i26 + 24 >> 2] = i8;
 HEAP32[i26 + 28 >> 2] = i3;
 HEAP32[i26 + 32 >> 2] = i2;
 HEAP32[i26 + 36 >> 2] = i4;
 HEAP32[i26 + 40 >> 2] = i3;
 HEAP32[i26 + 44 >> 2] = i2;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i26 + 48 >> 2] = i4;
 HEAP32[i26 + 52 >> 2] = i9;
 HEAP32[i26 + 56 >> 2] = i2;
 HEAP32[i26 + 60 >> 2] = i8;
 HEAP32[i26 + 64 >> 2] = i9;
 HEAP32[i26 + 68 >> 2] = i2;
 HEAP32[i26 + 72 >> 2] = i8;
 HEAP32[i26 + 76 >> 2] = i3;
 HEAP32[i26 + 80 >> 2] = i2;
 HEAP32[i26 + 84 >> 2] = i4;
 HEAP32[i26 + 88 >> 2] = i3;
 HEAP32[i26 + 92 >> 2] = i2;
 HEAP32[i25 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i2 = i25 + 12 | 0;
 HEAPF32[i2 >> 2] = f5;
 i3 = i25 + 16 | 0;
 HEAPF32[i3 >> 2] = f6;
 i4 = i25 + 20 | 0;
 HEAPF32[i4 >> 2] = f7;
 i8 = i24 + 16 | 0;
 i9 = i24 + 32 | 0;
 i10 = i24 + 48 | 0;
 i11 = i24 + 4 | 0;
 i12 = i24 + 20 | 0;
 i13 = i24 + 36 | 0;
 i14 = i24 + 52 | 0;
 i15 = i24 + 8 | 0;
 i16 = i24 + 24 | 0;
 i17 = i24 + 40 | 0;
 i18 = i24 + 56 | 0;
 i19 = i25 + 4 | 0;
 i20 = i25 + 8 | 0;
 f21 = Math_fround(HEAPF32[i25 >> 2]);
 f22 = Math_fround(HEAPF32[i19 >> 2]);
 i1 = 0;
 f23 = Math_fround(HEAPF32[i20 >> 2]);
 do {
  f30 = Math_fround(HEAPF32[i24 >> 2]);
  f32 = Math_fround(HEAPF32[i26 + (i1 * 12 | 0) >> 2]);
  f30 = Math_fround(f30 * f32);
  f29 = Math_fround(HEAPF32[i8 >> 2]);
  f31 = Math_fround(HEAPF32[i26 + (i1 * 12 | 0) + 4 >> 2]);
  f29 = Math_fround(f30 + Math_fround(f29 * f31));
  f30 = Math_fround(HEAPF32[i9 >> 2]);
  f28 = Math_fround(HEAPF32[i26 + (i1 * 12 | 0) + 8 >> 2]);
  f30 = Math_fround(f29 + Math_fround(f30 * f28));
  f30 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f30);
  f29 = Math_fround(f32 * Math_fround(HEAPF32[i11 >> 2]));
  f29 = Math_fround(f29 + Math_fround(f31 * Math_fround(HEAPF32[i12 >> 2])));
  f29 = Math_fround(f29 + Math_fround(f28 * Math_fround(HEAPF32[i13 >> 2])));
  f29 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f29);
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i15 >> 2]));
  f31 = Math_fround(f32 + Math_fround(f31 * Math_fround(HEAPF32[i16 >> 2])));
  f28 = Math_fround(f31 + Math_fround(f28 * Math_fround(HEAPF32[i17 >> 2])));
  f28 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f28);
  f21 = f30 < f21 ? f30 : f21;
  f22 = f29 < f22 ? f29 : f22;
  f23 = f28 < f23 ? f28 : f23;
  HEAPF32[i25 >> 2] = f21;
  HEAPF32[i19 >> 2] = f22;
  HEAPF32[i20 >> 2] = f23;
  f5 = f5 < f30 ? f30 : f5;
  f6 = f6 < f29 ? f29 : f6;
  f7 = f7 < f28 ? f28 : f7;
  HEAPF32[i2 >> 2] = f5;
  HEAPF32[i3 >> 2] = f6;
  HEAPF32[i4 >> 2] = f7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 STACKTOP = i27;
 return;
}

function runPostSets80() {
 HEAP32[gb + 86708 >> 2] = fb + 1;
 HEAP32[gb + 86712 >> 2] = fb + 1;
 HEAP32[gb + 86716 >> 2] = fb + 1;
 HEAP32[gb + 86720 >> 2] = fb + 1;
 HEAP32[gb + 86724 >> 2] = fb + 1;
 HEAP32[gb + 86728 >> 2] = fb + 1;
 HEAP32[gb + 86732 >> 2] = fb + 1;
 HEAP32[gb + 86736 >> 2] = fb + 1;
 HEAP32[gb + 86740 >> 2] = fb + 1;
 HEAP32[gb + 86744 >> 2] = fb + 1;
 HEAP32[gb + 86748 >> 2] = fb + 1;
 HEAP32[gb + 86752 >> 2] = fb + 1;
 HEAP32[gb + 86756 >> 2] = fb + 1;
 HEAP32[gb + 86760 >> 2] = fb + 1;
 HEAP32[gb + 86764 >> 2] = fb + 1;
 HEAP32[gb + 86768 >> 2] = fb + 1;
 HEAP32[gb + 86772 >> 2] = fb + 1;
 HEAP32[gb + 86776 >> 2] = fb + 1087;
 HEAP32[gb + 86780 >> 2] = fb + 1089;
 HEAP32[gb + 86784 >> 2] = fb + 1;
 HEAP32[gb + 86788 >> 2] = fb + 1;
 HEAP32[gb + 86792 >> 2] = fb + 1;
 HEAP32[gb + 86796 >> 2] = fb + 1;
 HEAP32[gb + 86800 >> 2] = fb + 1;
 HEAP32[gb + 86804 >> 2] = fb + 1;
 HEAP32[gb + 86816 >> 2] = fb + 1090;
 HEAP32[gb + 86820 >> 2] = fb + 1091;
 HEAP32[gb + 86824 >> 2] = fb + 1092;
 HEAP32[gb + 86836 >> 2] = fb + 1093;
 HEAP32[gb + 86840 >> 2] = fb + 1094;
 HEAP32[gb + 86844 >> 2] = fb + 1095;
 HEAP32[gb + 86856 >> 2] = fb + 1096;
 HEAP32[gb + 86860 >> 2] = fb + 455;
 HEAP32[gb + 86864 >> 2] = fb + 456;
 HEAP32[gb + 86868 >> 2] = fb + 1097;
 HEAP32[gb + 86872 >> 2] = fb + 1098;
 HEAP32[gb + 86876 >> 2] = fb + 217;
 HEAP32[gb + 86880 >> 2] = fb + 89;
 HEAP32[gb + 86884 >> 2] = fb + 90;
 HEAP32[gb + 86888 >> 2] = fb + 91;
 HEAP32[gb + 86892 >> 2] = fb + 92;
 HEAP32[gb + 86896 >> 2] = fb + 801;
 HEAP32[gb + 86900 >> 2] = fb + 802;
 HEAP32[gb + 86904 >> 2] = fb + 803;
 HEAP32[gb + 86908 >> 2] = fb + 2;
 HEAP32[gb + 86912 >> 2] = fb + 93;
 HEAP32[gb + 86916 >> 2] = fb + 804;
 HEAP32[gb + 86920 >> 2] = fb + 94;
 HEAP32[gb + 86924 >> 2] = fb + 457;
 HEAP32[gb + 86928 >> 2] = fb + 9;
 HEAP32[gb + 86932 >> 2] = fb + 26;
 HEAP32[gb + 86936 >> 2] = fb + 10;
 HEAP32[gb + 86940 >> 2] = fb + 27;
 HEAP32[gb + 86944 >> 2] = fb + 11;
 HEAP32[gb + 86948 >> 2] = fb + 28;
 HEAP32[gb + 86952 >> 2] = fb + 12;
 HEAP32[gb + 86956 >> 2] = fb + 29;
 HEAP32[gb + 86960 >> 2] = fb + 458;
 HEAP32[gb + 86964 >> 2] = fb + 805;
 HEAP32[gb + 86968 >> 2] = fb + 459;
 HEAP32[gb + 86972 >> 2] = fb + 460;
 HEAP32[gb + 86976 >> 2] = fb + 95;
 HEAP32[gb + 86980 >> 2] = fb + 218;
 HEAP32[gb + 86984 >> 2] = fb + 30;
 HEAP32[gb + 86988 >> 2] = fb + 31;
 HEAP32[gb + 86992 >> 2] = fb + 32;
 HEAP32[gb + 86996 >> 2] = fb + 806;
 HEAP32[gb + 87e3 >> 2] = fb + 807;
 HEAP32[gb + 87004 >> 2] = fb + 808;
 HEAP32[gb + 87008 >> 2] = fb + 809;
 HEAP32[gb + 87012 >> 2] = fb + 810;
 HEAP32[gb + 87016 >> 2] = fb + 811;
 HEAP32[gb + 87020 >> 2] = fb + 96;
 HEAP32[gb + 87024 >> 2] = fb + 97;
 HEAP32[gb + 87028 >> 2] = fb + 812;
 HEAP32[gb + 87032 >> 2] = fb + 813;
 HEAP32[gb + 87036 >> 2] = fb + 98;
 HEAP32[gb + 87040 >> 2] = fb + 99;
 HEAP32[gb + 87044 >> 2] = fb + 13;
 HEAP32[gb + 87048 >> 2] = fb + 33;
 HEAP32[gb + 87052 >> 2] = fb + 14;
 HEAP32[gb + 87056 >> 2] = fb + 34;
 HEAP32[gb + 87060 >> 2] = fb + 814;
 HEAP32[gb + 87064 >> 2] = fb + 60;
 HEAP32[gb + 87068 >> 2] = fb + 815;
 HEAP32[gb + 87072 >> 2] = fb + 816;
 HEAP32[gb + 87076 >> 2] = fb + 461;
 HEAP32[gb + 87080 >> 2] = fb + 219;
 HEAP32[gb + 87084 >> 2] = fb + 462;
 HEAP32[gb + 87088 >> 2] = fb + 1099;
 HEAP32[gb + 87092 >> 2] = fb + 817;
 HEAP32[gb + 87104 >> 2] = fb + 463;
 HEAP32[gb + 87108 >> 2] = fb + 61;
 HEAP32[gb + 87112 >> 2] = fb + 1100;
 HEAP32[gb + 87116 >> 2] = fb + 818;
 HEAP32[gb + 87120 >> 2] = fb + 819;
 HEAP32[gb + 87124 >> 2] = fb + 220;
 HEAP32[gb + 87128 >> 2] = fb + 464;
 HEAP32[gb + 87132 >> 2] = fb + 1101;
 HEAP32[gb + 87136 >> 2] = fb + 1102;
 runPostSets81();
}

function __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i12, i2, i1, i3) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0;
 i11 = i1 + 4 | 0;
 i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
 i10 = i11 + (i3 * 40 | 0) + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i10 = i2 + 4 | 0;
 i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
 i1 = HEAP32[i10 + (i3 << 3) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i7 = i12 + 4 | 0;
 i8 = i12 + 8 | 0;
 i9 = i12 + 12 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 while (1) {
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i11 + (i1 * 40 | 0) + 28 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i11 + (i1 * 40 | 0) + 32 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i11 + (i1 * 40 | 0) + 36 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f17 * f21);
  f21 = Math_fround(f19 * f21);
  f17 = Math_fround(f19 * f17);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i25 = i25 & -2147483648 ^ i3;
  i24 = i24 & -2147483648 ^ i5;
  i14 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i6;
  HEAP32[i12 >> 2] = i25;
  HEAP32[i7 >> 2] = i24;
  HEAP32[i8 >> 2] = i14;
  HEAP32[i9 >> 2] = i2;
  f17 = Math_fround(HEAPF32[i11 + (i1 * 40 | 0) + 16 >> 2]);
  f21 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f17 * f21);
  f19 = Math_fround(HEAPF32[i11 + (i1 * 40 | 0) + 24 >> 2]);
  f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = Math_fround(f19 * f13);
  f20 = Math_fround(HEAPF32[i11 + (i1 * 40 | 0) + 20 >> 2]);
  f18 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f20 * f18);
  f23 = Math_fround(HEAPF32[i11 + (i1 * 40 | 0) + 12 >> 2]);
  f22 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f19 * f22)) - Math_fround(f13 * f20)) - Math_fround(f18 * f23));
  f4 = Math_fround(Math_fround(Math_fround(f4 - Math_fround(f21 * f23)) - Math_fround(f20 * f22)) - Math_fround(f17 * f18));
  f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f17 * f22)) - Math_fround(f21 * f19)) - Math_fround(f13 * f23));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f19 * f18)) - Math_fround(f17 * f13));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = i14 ^ -2147483648;
  i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i6 = i2 ^ -2147483648;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i6;
  HEAPF32[i9 >> 2] = f4;
  i1 = HEAP32[i10 + (i1 << 3) >> 2] | 0;
  if ((i1 | 0) <= -1) break; else i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 }
 return;
}

function runPostSets67() {
 HEAP32[gb + 75952 >> 2] = fb + 381;
 HEAP32[gb + 75956 >> 2] = fb + 672;
 HEAP32[gb + 75960 >> 2] = fb + 673;
 HEAP32[gb + 75964 >> 2] = fb + 674;
 HEAP32[gb + 75968 >> 2] = fb + 382;
 HEAP32[gb + 75972 >> 2] = fb + 14;
 HEAP32[gb + 75976 >> 2] = fb + 675;
 HEAP32[gb + 75980 >> 2] = fb + 676;
 HEAP32[gb + 75984 >> 2] = fb + 677;
 HEAP32[gb + 75988 >> 2] = fb + 281;
 HEAP32[gb + 75992 >> 2] = fb + 152;
 HEAP32[gb + 75996 >> 2] = fb + 153;
 HEAP32[gb + 76e3 >> 2] = fb + 154;
 HEAP32[gb + 76004 >> 2] = fb + 155;
 HEAP32[gb + 76008 >> 2] = fb + 156;
 HEAP32[gb + 76012 >> 2] = fb + 6;
 HEAP32[gb + 76016 >> 2] = fb + 678;
 HEAP32[gb + 76020 >> 2] = fb + 679;
 HEAP32[gb + 76024 >> 2] = fb + 680;
 HEAP32[gb + 76028 >> 2] = fb + 681;
 HEAP32[gb + 76032 >> 2] = fb + 836;
 HEAP32[gb + 76036 >> 2] = fb + 383;
 HEAP32[gb + 76040 >> 2] = fb + 682;
 HEAP32[gb + 76044 >> 2] = fb + 41;
 HEAP32[gb + 76048 >> 2] = fb + 1;
 HEAP32[gb + 76052 >> 2] = fb + 683;
 HEAP32[gb + 76056 >> 2] = fb + 267;
 HEAP32[gb + 76060 >> 2] = fb + 12;
 HEAP32[gb + 76064 >> 2] = fb + 20;
 HEAP32[gb + 76068 >> 2] = fb + 167;
 HEAP32[gb + 76072 >> 2] = fb + 684;
 HEAP32[gb + 76076 >> 2] = fb + 685;
 HEAP32[gb + 76080 >> 2] = fb + 42;
 HEAP32[gb + 76084 >> 2] = fb + 384;
 HEAP32[gb + 76088 >> 2] = fb + 385;
 HEAP32[gb + 76092 >> 2] = fb + 6;
 HEAP32[gb + 76096 >> 2] = fb + 48;
 HEAP32[gb + 76100 >> 2] = fb + 63;
 HEAP32[gb + 76104 >> 2] = fb + 686;
 HEAP32[gb + 76108 >> 2] = fb + 168;
 HEAP32[gb + 76112 >> 2] = fb + 7;
 HEAP32[gb + 76116 >> 2] = fb + 8;
 HEAP32[gb + 76120 >> 2] = fb + 2;
 HEAP32[gb + 76124 >> 2] = fb + 270;
 HEAP32[gb + 76128 >> 2] = fb + 282;
 HEAP32[gb + 76132 >> 2] = fb + 283;
 HEAP32[gb + 76136 >> 2] = fb + 3;
 HEAP32[gb + 76140 >> 2] = fb + 2;
 HEAP32[gb + 76144 >> 2] = fb + 3;
 HEAP32[gb + 76148 >> 2] = fb + 271;
 HEAP32[gb + 76152 >> 2] = fb + 284;
 HEAP32[gb + 76156 >> 2] = fb + 272;
 HEAP32[gb + 76160 >> 2] = fb + 273;
 HEAP32[gb + 76164 >> 2] = fb + 274;
 HEAP32[gb + 76168 >> 2] = fb + 386;
 HEAP32[gb + 76172 >> 2] = fb + 687;
 HEAP32[gb + 76176 >> 2] = fb + 43;
 HEAP32[gb + 76180 >> 2] = fb + 4;
 HEAP32[gb + 76184 >> 2] = fb + 1;
 HEAP32[gb + 76188 >> 2] = fb + 3;
 HEAP32[gb + 76192 >> 2] = fb + 276;
 HEAP32[gb + 76196 >> 2] = fb + 64;
 HEAP32[gb + 76200 >> 2] = fb + 65;
 HEAP32[gb + 76204 >> 2] = fb + 688;
 HEAP32[gb + 76208 >> 2] = fb + 285;
 HEAP32[gb + 76212 >> 2] = fb + 277;
 HEAP32[gb + 76216 >> 2] = fb + 169;
 HEAP32[gb + 76220 >> 2] = fb + 387;
 HEAP32[gb + 76224 >> 2] = fb + 388;
 HEAP32[gb + 76228 >> 2] = fb + 160;
 HEAP32[gb + 76232 >> 2] = fb + 161;
 HEAP32[gb + 76236 >> 2] = fb + 162;
 HEAP32[gb + 76240 >> 2] = fb + 163;
 HEAP32[gb + 76244 >> 2] = fb + 66;
 HEAP32[gb + 76248 >> 2] = fb + 170;
 HEAP32[gb + 76252 >> 2] = fb + 59;
 HEAP32[gb + 76256 >> 2] = fb + 278;
 HEAP32[gb + 76260 >> 2] = fb + 93;
 HEAP32[gb + 76264 >> 2] = fb + 94;
 HEAP32[gb + 76268 >> 2] = fb + 689;
 HEAP32[gb + 76272 >> 2] = fb + 18;
 HEAP32[gb + 76276 >> 2] = fb + 67;
 HEAP32[gb + 76280 >> 2] = fb + 4;
 HEAP32[gb + 76284 >> 2] = fb + 44;
 HEAP32[gb + 76288 >> 2] = fb + 164;
 HEAP32[gb + 76292 >> 2] = fb + 279;
 HEAP32[gb + 76296 >> 2] = fb + 45;
 HEAP32[gb + 76300 >> 2] = fb + 690;
 HEAP32[gb + 76304 >> 2] = fb + 1;
 HEAP32[gb + 76308 >> 2] = fb + 2;
 HEAP32[gb + 76312 >> 2] = fb + 2;
 HEAP32[gb + 76316 >> 2] = fb + 3;
 HEAP32[gb + 76320 >> 2] = fb + 691;
 HEAP32[gb + 76324 >> 2] = fb + 3;
 HEAP32[gb + 76328 >> 2] = fb + 4;
 HEAP32[gb + 76332 >> 2] = fb + 692;
 HEAP32[gb + 76336 >> 2] = fb + 68;
 HEAP32[gb + 76340 >> 2] = fb + 5;
 HEAP32[gb + 76344 >> 2] = fb + 2;
 HEAP32[gb + 76348 >> 2] = fb + 8;
 runPostSets68();
}

function __ZN17SurfaceEffector2D21ContactUpdateCallbackEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, f28 = f0, f29 = f0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i27;
 i23 = i2 + 36 | 0;
 i24 = i2 + 48 | 0;
 if (!(HEAP32[i24 >> 2] | 0)) {
  STACKTOP = i27;
  return;
 }
 i25 = i2 + 92 | 0;
 i26 = i2 + 96 | 0;
 i16 = i2 + 76 | 0;
 i17 = i2 + 80 | 0;
 i18 = i2 + 84 | 0;
 i19 = i2 + 88 | 0;
 i20 = i22 + 4 | 0;
 i21 = i2 + 100 | 0;
 i13 = i2 + 104 | 0;
 i14 = i22 + 8 | 0;
 i12 = HEAP32[i23 >> 2] | 0;
 do {
  i15 = HEAP32[i12 + 16 >> 2] | 0;
  i8 = HEAP32[i12 + 32 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i8 + 128 >> 2]);
  __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i22, i8 + 64 | 0, (HEAP32[(HEAP32[i8 + 48 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, f11, (HEAP32[(HEAP32[i8 + 52 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, Math_fround(HEAPF32[i8 + 132 >> 2]));
  f11 = Math_fround(HEAPF32[i25 >> 2]);
  f1 = Math_fround(HEAPF32[i26 >> 2]);
  i8 = HEAP32[i16 >> 2] | 0;
  i8 = i8 << 11 ^ i8;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
  i10 = HEAP32[i19 >> 2] | 0;
  HEAP32[i18 >> 2] = i10;
  i10 = i8 >>> 8 ^ i8 ^ i10 ^ i10 >>> 19;
  HEAP32[i19 >> 2] = i10;
  f1 = Math_fround(f11 + Math_fround(f1 * Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
  if (!(HEAP8[i12 + 36 >> 0] | 0)) {
   f9 = Math_fround(-Math_fround(HEAPF32[i22 >> 2]));
   f11 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  } else {
   i2 = HEAP32[i22 >> 2] | 0;
   i3 = HEAP32[i20 >> 2] | 0;
  }
  f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f5 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
  i8 = i15 + 64 | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  f6 = Math_fround(f7 * f9);
  i10 = i15 + 68 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  f6 = Math_fround(f1 - Math_fround(f6 + Math_fround(f11 * f5)));
  f6 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f6);
  f6 = Math_fround(Math_fround(HEAPF32[i15 + 116 >> 2]) * f6);
  f1 = Math_fround(f7 * f6);
  f5 = Math_fround(f6 * f5);
  i4 = (HEAP8[i13 >> 0] | 0) == 0 ? i15 + 44 | 0 : i14;
  f6 = Math_fround(HEAPF32[i4 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  if ((HEAP32[i15 >> 2] | 0) == 2) {
   i3 = i15 + 4 | 0;
   i2 = HEAP16[i3 >> 1] | 0;
   if (!(i2 & 2)) {
    i4 = i2 & 65535;
    if (!(i4 & 2)) {
     i2 = (i4 | 2) & 65535;
     HEAP16[i3 >> 1] = i2;
     HEAPF32[i15 + 144 >> 2] = Math_fround(0.0);
    }
   }
   if (i2 & 2) {
    f29 = Math_fround(HEAPF32[i15 + 120 >> 2]);
    f28 = Math_fround(f5 * f29);
    HEAPF32[i8 >> 2] = Math_fround(Math_fround(f1 * f29) + f9);
    HEAPF32[i10 >> 2] = Math_fround(f28 + f11);
    f9 = Math_fround(HEAPF32[i15 + 128 >> 2]);
    f11 = Math_fround(f6 - Math_fround(HEAPF32[i15 + 44 >> 2]));
    f11 = Math_fround(f9 * Math_fround(Math_fround(f5 * f11) - Math_fround(f1 * Math_fround(f7 - Math_fround(HEAPF32[i15 + 48 >> 2])))));
    i15 = i15 + 72 | 0;
    HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f11);
   }
  }
  i12 = i12 + 40 | 0;
 } while ((i12 | 0) != ((HEAP32[i23 >> 2] | 0) + ((HEAP32[i24 >> 2] | 0) * 40 | 0) | 0));
 STACKTOP = i27;
 return;
}

function __ZN12LightsModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, i7, i1 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619503 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619509 | 0, gb + 619515 | 0, i9, 0);
 i8 = i6 + 8 | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619527 | 0, i7, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 945665 | 0, i7, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620185 | 0, i7, i1 + 21 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619546 | 0, i7, i1 + 22 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619556 | 0, gb + 620173 | 0, i7, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 288 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619567 | 0, gb + 620173 | 0, i7, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619582 | 0, i6, i1 + 552 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z18UpdateProximityJobP9CrowdInfoj(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 4 | 0;
 i2 = i16;
 i5 = i8 + 320 | 0;
 i15 = HEAP32[i8 + 256 + (i3 << 2) >> 2] | 0;
 if ((HEAP16[gb + 1459308 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459308 | 0, i1);
  i12 = gb + 1459308 | 0;
 } else i12 = 0;
 i14 = HEAP32[i8 + (i3 << 4) + 12 >> 2] | 0;
 if ((i14 | 0) > 0) {
  i13 = i8 + (i3 << 4) + 8 | 0;
  i11 = i8 + (i3 << 4) | 0;
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = i3 + (i2 * 608 | 0) | 0;
   if ((HEAP8[i3 + (i2 * 608 | 0) + 601 >> 0] | 0) == 2) i7 = 8; else if (!(HEAP8[i3 + (i2 * 608 | 0) + 317 >> 0] & 1)) i7 = 8; else __Z25CollectNeighbourObstaclesR12dtCrowdAgentRK17ReadonlyCrowdInfo(i4, i5);
   if ((i7 | 0) == 8) {
    i7 = 0;
    HEAP32[i3 + (i2 * 608 | 0) + 384 >> 2] = 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i14 | 0));
  i10 = i8 + 360 | 0;
  i7 = i8 + 332 | 0;
  i5 = 0;
  do {
   i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i9 = HEAP32[i11 >> 2] | 0;
   L17 : do if ((HEAP8[i9 + (i8 * 608 | 0) + 601 >> 0] | 0) != 2) if (HEAP8[i9 + (i8 * 608 | 0) + 317 >> 0] & 1) {
    i1 = HEAP32[i9 + (i8 * 608 | 0) + 32 >> 2] | 0;
    do if (i1 | 0) {
     i2 = HEAP32[i9 + (i8 * 608 | 0) + 28 >> 2] | 0;
     i4 = i2 + (i1 + -1 << 3) | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!((HEAP32[i4 >> 2] | 0) == (i1 | 0) ? (HEAP32[i4 + 4 >> 2] | 0) == (i2 | 0) : 0)) {
      if (HEAP32[i9 + (i8 * 608 | 0) + 476 >> 2] | 0) if (HEAP8[i9 + (i8 * 608 | 0) + 472 >> 0] & 6) break;
      f18 = Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 292 >> 2]);
      f19 = Math_fround(HEAPF32[i10 >> 2]);
      f6 = Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 516 >> 2]);
      f6 = Math_fround(f6 * f6);
      f17 = Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 520 >> 2]);
      f17 = Math_fround(f6 + Math_fround(f17 * f17));
      f6 = Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 524 >> 2]);
      f6 = Math_fround(f18 + Math_fround(f19 * Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f6 * f6))))));
      f17 = Math_fround(f6 * Math_fround(.25));
      i3 = i9 + (i8 * 608 | 0) + 480 | 0;
      i4 = i9 + (i8 * 608 | 0) + 52 | 0;
      f19 = Math_fround(HEAPF32[i4 >> 2]);
      f19 = Math_fround(f19 - Math_fround(HEAPF32[i3 >> 2]));
      f18 = Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 60 >> 2]);
      f18 = Math_fround(f18 - Math_fround(HEAPF32[i9 + (i8 * 608 | 0) + 488 >> 2]));
      if (Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)) < Math_fround(f17 * f17)) break L17;
      __ZN15dtLocalBoundary6updateEyPKffPK14dtNavMeshQueryPK13dtQueryFilter(i4, i1, i2, i3, f6, i15, (HEAP32[i7 >> 2] | 0) + (i8 * 132 | 0) | 0);
      break L17;
     }
    } while (0);
    HEAPF32[i9 + (i8 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i9 + (i8 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i9 + (i8 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAP32[i9 + (i8 * 608 | 0) + 288 >> 2] = 0;
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i14 | 0));
 }
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i11 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = (i6 - i7 | 0) / 12 | 0;
 i3 = i7;
 if (i1 >>> 0 >= i12 >>> 0) {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i6 = i3 + (i12 * 12 | 0) | 0;
  HEAP32[i13 >> 2] = 0;
  i8 = i13 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 * 12 | 0;
  i2 = (i1 | 0) / 12 | 0;
  if (!i1) {
   i4 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i5 = __Znwj(i1) | 0;
   HEAP32[i8 >> 2] = i5;
   HEAP32[i13 >> 2] = i5;
   i1 = i5 + (i2 * 12 | 0) | 0;
   i4 = i13 + 8 | 0;
   HEAP32[i4 >> 2] = i1;
   i7 = i5;
   if (!i12) {
    i5 = i7;
    i2 = i7;
   } else {
    i2 = i5;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i3 = i3 + 12 | 0;
     i2 = i2 + 12 | 0;
    } while ((i3 | 0) != (i6 | 0));
    HEAP32[i8 >> 2] = i2;
    i5 = i7;
   }
  }
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
  i2 = i13;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 8 | 0;
 if ((((HEAP32[i9 >> 2] | 0) - i7 | 0) / 12 | 0 | 0) == (i12 | 0)) {
  __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj(i14, i12 - i1 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i8 = i11 + 8 | 0;
 if (i12 | 0) {
  i3 = __Znwj(i12 * 12 | 0) | 0;
  i1 = i3;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i3 + (i12 * 12 | 0);
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i2, i13);
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = (i1 - i4 | 0) / 12 | 0;
 i3 = i4;
 i5 = i1;
 if (i2 >>> 0 < i12 >>> 0) {
  __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj(i11, i12 - i2 | 0);
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } else if (i2 >>> 0 > i12 >>> 0) {
  i2 = i3 + (i12 * 12 | 0) | 0;
  if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
   i1 = i5 + (~(((i5 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i4;
  }
 } else i2 = i4;
 i3 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 296 | 0;
 i9 = i13 + 288 | 0;
 i10 = i13 + 8 | 0;
 i1 = i13;
 if ((HEAP16[gb + 1155168 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155168 | 0, i11);
  i8 = gb + 1155168 | 0;
 } else i8 = 0;
 i5 = gb + 64016 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i10, i11);
 i7 = i2 + 8 | 0;
 __ZN18AwakeFromLoadQueue7ReserveEj(i10, (HEAP32[i7 >> 2] | 0) - (HEAP32[i2 + 4 >> 2] | 0) >> 3);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) do {
  i6 = i1 + 4 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i12 = 13; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i9);
    i3 = HEAP32[i11 >> 2] | 0;
    i14 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 13; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i12 = 15;
   }
  }
  if ((i12 | 0) == 13) i12 = 15;
  if ((i12 | 0) == 15) {
   i12 = 0;
   i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
  }
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 0);
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i12 = 21; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i2, i9);
    i3 = HEAP32[i11 >> 2] | 0;
    i14 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 21; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i12 = 23;
   }
  }
  if ((i12 | 0) == 21) i12 = 23;
  if ((i12 | 0) == 23) {
   i12 = 0;
   i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
  }
  __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode(i10, i2, 0, 0, -1);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (HEAP32[i7 >> 2] | 0));
 __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i10, 4, 0);
 __ZN18AwakeFromLoadQueueD2Ev(i10);
 if (!i8) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i13;
 return;
}

function __Z27UploadSparseTextureTileGLES9TextureIDiiiPKhii(i8, i5, i6, i18, i19, i1, i2) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 24 | 0;
 i11 = i17;
 i15 = i17 + 16 | 0;
 i7 = i17 + 4 | 0;
 i1 = HEAP32[gb + 1451152 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = gb + 1451152 + 4 | 0;
 L4 : while (1) {
  i2 = i1;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) {
    i13 = i3;
    break L4;
   } else i2 = i1;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i13 = i2;
   break;
  } else i3 = i2;
 }
 if ((i13 | 0) == (gb + 1451152 + 4 | 0)) {
  STACKTOP = i17;
  return;
 }
 if (i4 >>> 0 < (HEAP32[i13 + 16 >> 2] | 0) >>> 0) {
  STACKTOP = i17;
  return;
 }
 i12 = i13 + 28 | 0;
 i9 = Math_imul(HEAP32[i12 >> 2] | 0, i5) | 0;
 i10 = i13 + 32 | 0;
 i6 = Math_imul(HEAP32[i10 >> 2] | 0, i6) | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = i4;
 i5 = __Z16GetRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 176 >> 2] | 0, i5 | 0, 2, 1, i7 | 0);
 i5 = HEAP32[gb + 1451080 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i14, i1, i11);
  i2 = HEAP32[i14 >> 2] | 0;
  i11 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 15; else {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) i16 = 15;
 }
 if ((i16 | 0) == 15) {
  i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 17) | 0;
  HEAP32[i2 >> 2] = 0;
  i16 = i2 + 8 | 0;
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 2;
  HEAP32[i2 + 20 >> 2] = 3;
  HEAP32[i2 + 24 >> 2] = 1;
  HEAP32[i2 + 28 >> 2] = 1;
  HEAP32[i2 + 32 >> 2] = 1;
  HEAP32[i2 + 36 >> 2] = 1;
  HEAP32[i15 >> 2] = i4;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i14, i2);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN7ApiGLES10GenTextureE16TextureDimension(i5, 2) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 16 >> 2] = 2;
 }
 if ((HEAP32[i13 + 36 >> 2] | 0) > (i18 | 0)) __ZN7ApiGLES24CommitSparseTexturePagesEj16TextureDimensioniiiiiiih(HEAP32[gb + 1451080 >> 2] | 0, i1, 2, i18, i9, i6, 0, HEAP32[i12 >> 2] | 0, HEAP32[i10 >> 2] | 0, 1, (i19 | 0) != 0 & 1);
 if (i19 | 0) {
  i14 = HEAP32[i13 + 20 >> 2] >> i18;
  i14 = (i14 | 0) > 1 ? i14 : 1;
  i16 = HEAP32[i13 + 24 >> 2] >> i18;
  i16 = (i16 | 0) > 1 ? i16 : 1;
  i12 = HEAP32[i12 >> 2] | 0;
  i15 = HEAP32[i10 >> 2] | 0;
  __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i2 >> 2] | 0, 2, HEAP32[i13 + 40 >> 2] | 0, i18, i9, i6, 0, (i12 | 0) < (i14 | 0) ? i12 : i14, (i15 | 0) < (i16 | 0) ? i15 : i16, 1, 0, i19);
 }
 STACKTOP = i17;
 return;
}

function __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 i1 = (i3 & 1 | 0) == 0;
 if (!i2) {
  if (i1) i1 = 0; else {
   i1 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8;
   i1 = Math_imul((i1 & 65535) >>> 8 & 65535, HEAPU8[(i1 & 255) + (gb + 430676) >> 0] | 0) | 0;
  }
  if (i3 & 2) {
   i2 = i4 + 2 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 4) {
   i2 = i4 + 4 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 8) {
   i2 = i4 + 6 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 16) {
   i2 = i4 + 8 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 32) {
   i2 = i4 + 10 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 64) {
   i2 = i4 + 12 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   i1 = (Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (!(i3 & 128)) {
   i4 = i1;
   return i4 | 0;
  }
  i4 = i4 + 14 | 0;
  i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8;
  i4 = (Math_imul((i4 & 65535) >>> 8 & 65535, HEAPU8[(i4 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  return i4 | 0;
 } else {
  if (i1) i1 = 0; else {
   HEAP32[i2 >> 2] = 0;
   i1 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8;
   i1 = Math_imul((i1 & 65535) >>> 8 & 65535, HEAPU8[(i1 & 255) + (gb + 430676) >> 0] | 0) | 0;
  }
  if (i3 & 2) {
   HEAP32[i2 + 4 >> 2] = i1;
   i5 = i4 + 2 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 4) {
   HEAP32[i2 + 8 >> 2] = i1;
   i5 = i4 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 8) {
   HEAP32[i2 + 12 >> 2] = i1;
   i5 = i4 + 6 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 16) {
   HEAP32[i2 + 16 >> 2] = i1;
   i5 = i4 + 8 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 32) {
   HEAP32[i2 + 20 >> 2] = i1;
   i5 = i4 + 10 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (i3 & 64) {
   HEAP32[i2 + 24 >> 2] = i1;
   i5 = i4 + 12 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
   i1 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  if (!(i3 & 128)) {
   i5 = i1;
   return i5 | 0;
  }
  HEAP32[i2 + 28 >> 2] = i1;
  i5 = i4 + 14 | 0;
  i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
  i5 = (Math_imul((i5 & 65535) >>> 8 & 65535, HEAPU8[(i5 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  return i5 | 0;
 }
 return 0;
}

function runPostSets79() {
 HEAP32[gb + 86236 >> 2] = fb + 207;
 HEAP32[gb + 86240 >> 2] = fb + 24;
 HEAP32[gb + 86244 >> 2] = fb + 208;
 HEAP32[gb + 86248 >> 2] = fb + 438;
 HEAP32[gb + 86260 >> 2] = fb + 61;
 HEAP32[gb + 86264 >> 2] = fb + 1069;
 HEAP32[gb + 86268 >> 2] = fb + 1070;
 HEAP32[gb + 86272 >> 2] = fb + 25;
 HEAP32[gb + 86276 >> 2] = fb + 209;
 HEAP32[gb + 86280 >> 2] = fb + 439;
 HEAP32[gb + 86292 >> 2] = fb + 1071;
 HEAP32[gb + 86296 >> 2] = fb + 1072;
 HEAP32[gb + 86300 >> 2] = fb + 27;
 HEAP32[gb + 86312 >> 2] = fb + 1073;
 HEAP32[gb + 86316 >> 2] = fb + 440;
 HEAP32[gb + 86320 >> 2] = fb + 441;
 HEAP32[gb + 86324 >> 2] = fb + 210;
 HEAP32[gb + 86328 >> 2] = fb + 211;
 HEAP32[gb + 86332 >> 2] = fb + 59;
 HEAP32[gb + 86336 >> 2] = fb + 1074;
 HEAP32[gb + 86340 >> 2] = fb + 442;
 HEAP32[gb + 86344 >> 2] = fb + 795;
 HEAP32[gb + 86348 >> 2] = fb + 443;
 HEAP32[gb + 86352 >> 2] = fb + 212;
 HEAP32[gb + 86356 >> 2] = fb + 444;
 HEAP32[gb + 86360 >> 2] = fb + 1;
 HEAP32[gb + 86364 >> 2] = fb + 11;
 HEAP32[gb + 86368 >> 2] = fb + 796;
 HEAP32[gb + 86372 >> 2] = fb + 797;
 HEAP32[gb + 86376 >> 2] = fb + 798;
 HEAP32[gb + 86380 >> 2] = fb + 799;
 HEAP32[gb + 86384 >> 2] = fb + 1075;
 HEAP32[gb + 86388 >> 2] = fb + 1076;
 HEAP32[gb + 86400 >> 2] = fb + 1077;
 HEAP32[gb + 86404 >> 2] = fb + 1078;
 HEAP32[gb + 86416 >> 2] = fb + 1079;
 HEAP32[gb + 86420 >> 2] = fb + 1080;
 HEAP32[gb + 86432 >> 2] = fb + 1081;
 HEAP32[gb + 86436 >> 2] = fb + 1082;
 HEAP32[gb + 86440 >> 2] = fb + 1083;
 HEAP32[gb + 86444 >> 2] = fb + 445;
 HEAP32[gb + 86448 >> 2] = fb + 213;
 HEAP32[gb + 86452 >> 2] = fb + 214;
 HEAP32[gb + 86456 >> 2] = fb + 130;
 HEAP32[gb + 86460 >> 2] = fb + 446;
 HEAP32[gb + 86464 >> 2] = fb + 215;
 HEAP32[gb + 86468 >> 2] = fb + 216;
 HEAP32[gb + 86480 >> 2] = fb + 1084;
 HEAP32[gb + 86484 >> 2] = fb + 1085;
 HEAP32[gb + 86488 >> 2] = fb + 447;
 HEAP32[gb + 86492 >> 2] = fb + 448;
 HEAP32[gb + 86496 >> 2] = fb + 449;
 HEAP32[gb + 86500 >> 2] = fb + 450;
 HEAP32[gb + 86504 >> 2] = fb + 451;
 HEAP32[gb + 86508 >> 2] = fb + 452;
 HEAP32[gb + 86512 >> 2] = fb + 453;
 HEAP32[gb + 86516 >> 2] = fb + 454;
 HEAP32[gb + 86520 >> 2] = fb + 800;
 HEAP32[gb + 86524 >> 2] = fb + 1086;
 HEAP32[gb + 86536 >> 2] = fb + 1;
 HEAP32[gb + 86540 >> 2] = fb + 1;
 HEAP32[gb + 86544 >> 2] = fb + 1;
 HEAP32[gb + 86548 >> 2] = fb + 1;
 HEAP32[gb + 86552 >> 2] = fb + 1;
 HEAP32[gb + 86556 >> 2] = fb + 1;
 HEAP32[gb + 86560 >> 2] = fb + 1;
 HEAP32[gb + 86564 >> 2] = fb + 1;
 HEAP32[gb + 86568 >> 2] = fb + 1;
 HEAP32[gb + 86572 >> 2] = fb + 1;
 HEAP32[gb + 86576 >> 2] = fb + 1;
 HEAP32[gb + 86580 >> 2] = fb + 1;
 HEAP32[gb + 86584 >> 2] = fb + 1;
 HEAP32[gb + 86588 >> 2] = fb + 1;
 HEAP32[gb + 86592 >> 2] = fb + 1;
 HEAP32[gb + 86596 >> 2] = fb + 1;
 HEAP32[gb + 86600 >> 2] = fb + 1;
 HEAP32[gb + 86604 >> 2] = fb + 1;
 HEAP32[gb + 86608 >> 2] = fb + 1;
 HEAP32[gb + 86612 >> 2] = fb + 1;
 HEAP32[gb + 86616 >> 2] = fb + 1;
 HEAP32[gb + 86620 >> 2] = fb + 1;
 HEAP32[gb + 86624 >> 2] = fb + 1;
 HEAP32[gb + 86628 >> 2] = fb + 1;
 HEAP32[gb + 86632 >> 2] = fb + 1;
 HEAP32[gb + 86636 >> 2] = fb + 1087;
 HEAP32[gb + 86640 >> 2] = fb + 1088;
 HEAP32[gb + 86644 >> 2] = fb + 1;
 HEAP32[gb + 86648 >> 2] = fb + 1;
 HEAP32[gb + 86652 >> 2] = fb + 1;
 HEAP32[gb + 86656 >> 2] = fb + 1;
 HEAP32[gb + 86660 >> 2] = fb + 1;
 HEAP32[gb + 86664 >> 2] = fb + 1;
 HEAP32[gb + 86676 >> 2] = fb + 1;
 HEAP32[gb + 86680 >> 2] = fb + 1;
 HEAP32[gb + 86684 >> 2] = fb + 1;
 HEAP32[gb + 86688 >> 2] = fb + 1;
 HEAP32[gb + 86692 >> 2] = fb + 1;
 HEAP32[gb + 86696 >> 2] = fb + 1;
 HEAP32[gb + 86700 >> 2] = fb + 1;
 HEAP32[gb + 86704 >> 2] = fb + 1;
 runPostSets80();
}

function __ZN7mecanim9animation13LayerConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904075 | 0, i6, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904095 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904124 | 0, gb + 904135 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904295 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904301 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904307 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904149 | 0, gb + 905830 | 0, i1 + 20 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899001 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904164 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904190 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904206 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 904215 | 0, i6, i1 + 37 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN29AssetBundleLoadAssetOperation15GetLoadedAssetsER13dynamic_arrayIP6ObjectLj4EEb(i1, i10, i13) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 8 | 0;
 i15 = i18;
 i16 = i10 + 16 | 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i10 + 4 | 0);
  HEAP32[i10 >> 2] = 0;
 }
 HEAP32[i10 >> 2] = 0;
 i11 = i10 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) __ZN29AssetBundleLoadAssetOperation15ForceLoadAssetsEv(i1);
 i12 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(HEAP32[i1 + 180 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 184 >> 2] | 0;
 i8 = i1 + 188 | 0;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i18;
  return;
 }
 i9 = i10 + 4 | 0;
 L10 : while (1) {
  i5 = i2 + 40 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i15 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
     i3 = HEAP32[i14 >> 2] | 0;
     i7 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i17 = 13; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 15;
    }
   }
   if ((i17 | 0) == 13) i17 = 15;
   if ((i17 | 0) == 15) {
    i17 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i7 = i1;
   i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
   if (i1 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i12) | 0) {
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i16 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i16 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i16 >> 2] = i1;
      HEAP32[i10 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i7;
    if (i13) {
     i17 = 29;
     break L10;
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i8 | 0)) {
   i17 = 29;
   break;
  } else i2 = i1;
 }
 if ((i17 | 0) == 29) {
  STACKTOP = i18;
  return;
 }
}

function __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE(i3, i2, i10, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i10 = HEAP32[i10 >> 2] & 255;
   i6 = HEAP32[i3 >> 2] | 0;
   i9 = i6 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i7 = i6 + 8 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i11 = i4;
   i8 = i1 - i11 | 0;
   i2 = i8 + 1 | 0;
   i5 = i6 + 16 | 0;
   if (((HEAP32[i5 >> 2] | 0) - i11 | 0) >>> 0 <= i2 >>> 0) {
    i3 = i2 << 1;
    if (!i3) {
     i2 = 0;
     i1 = i4;
    } else {
     i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i6 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     if (i1 | 0) {
      i11 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
    }
    HEAP32[i7 >> 2] = i2;
    i1 = i2 + i8 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i5 >> 2] = i2 + i3;
   }
   HEAP8[i1 >> 0] = i10;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   return;
  }
 case 1:
  {
   i11 = HEAP32[i10 >> 2] | 0;
   i10 = i11 & 255;
   i11 = (i11 & 65535) >>> 8 & 255;
   i5 = HEAP32[i3 >> 2] | 0;
   i9 = i5 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i4 = i3;
   i7 = i1 - i4 | 0;
   i2 = i7 + 2 | 0;
   i8 = i5 + 16 | 0;
   if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) {
      i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
     }
    }
    HEAP32[i6 >> 2] = i2;
    i1 = i2 + i7 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i8 >> 2] = i2 + i4;
   }
   HEAP8[i1 >> 0] = i10;
   HEAP8[i1 + 1 >> 0] = i11;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 2;
   return;
  }
 default:
  {
   i5 = HEAP32[i3 >> 2] | 0;
   i9 = i5 + 12 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = i5 + 8 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i11 = i3;
   i7 = i1 - i11 | 0;
   i2 = i7 + 4 | 0;
   i8 = i5 + 16 | 0;
   if (((HEAP32[i8 >> 2] | 0) - i11 | 0) >>> 0 <= i2 >>> 0) {
    i4 = i2 << 1;
    if (!i4) {
     i2 = 0;
     i1 = i3;
    } else {
     i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
     i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if (i1 | 0) {
     _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) {
      i11 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
     }
    }
    HEAP32[i6 >> 2] = i2;
    i1 = i2 + i7 | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i8 >> 2] = i2 + i4;
   }
   HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i10 + 3 >> 0] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 4;
   return;
  }
 }
}

function __ZN8UVModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 272 | 0, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 536 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 540 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 544 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 548 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 552 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 560 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 564 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 568 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 556 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 409;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i6 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i1;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i5 = i1 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i5;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN4math4Axes8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906532 | 0, gb + 906539 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i5, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906546 | 0, gb + 906539 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906554 | 0, gb + 906560 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906567 | 0, gb + 906575 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4math5Limit8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906581 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 913271 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 41; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 41; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E15insert_noresizeERKSA_(i13, i14, i15) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16;
 __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_(i1, i14, i15);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i12 = HEAP32[i14 + 84 >> 2] | 0;
  i15 = i12 + ((HEAP32[i14 + 88 >> 2] | 0) * 36 | 0) | 0;
  HEAP32[i13 >> 2] = i14;
  HEAP32[i13 + 4 >> 2] = i12 + (i2 * 36 | 0);
  HEAP32[i13 + 8 >> 2] = i15;
  HEAP8[i13 + 12 >> 0] = 0;
  STACKTOP = i16;
  return;
 }
 i11 = i1 + 4 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 L5 : do if (!(HEAP8[i14 + 8 >> 0] | 0)) i10 = 11; else {
  i5 = i14 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (!i6) i10 = 11; else {
   i7 = i14 + 84 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i14 + 32 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i8 + (i12 * 36 | 0) + 20 >> 2] | 0)) {
    i2 = HEAP32[i8 + (i12 * 36 | 0) >> 2] | 0;
    i4 = HEAP32[i14 + 12 >> 2] | 0;
    if (i1 | 0) {
     i3 = i1;
     i2 = (i2 | 0) == 0 ? i8 + (i12 * 36 | 0) + 4 | 0 : i2;
     i1 = (i4 | 0) == 0 ? i14 + 16 | 0 : i4;
     while (1) {
      if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
       i10 = 11;
       break L5;
      }
      i3 = i3 + -1 | 0;
      if (!i3) break; else {
       i2 = i2 + 1 | 0;
       i1 = i1 + 1 | 0;
      }
     }
    }
    HEAP32[i5 >> 2] = i6 + -1;
    i9 = i7;
   } else i10 = 11;
  }
 } while (0);
 if ((i10 | 0) == 11) {
  i8 = i14 + 92 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i8 = i14 + 84 | 0;
  i9 = i8;
  i8 = HEAP32[i8 >> 2] | 0;
 }
 i4 = i8 + (i12 * 36 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + (i12 * 36 | 0) + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i8 + (i12 * 36 | 0) + 24 | 0);
 HEAP32[i4 >> 2] = 0;
 i5 = i8 + (i12 * 36 | 0) + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = i8 + (i12 * 36 | 0) + 24 | 0;
 i7 = i15 + 24 | 0;
 i10 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i8 + (i12 * 36 | 0) + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i4 | 0) != (i15 | 0)) {
  i6 = HEAP32[i15 >> 2] | 0;
  i10 = (i6 | 0) == 0;
  i6 = i10 ? i15 + 4 | 0 : i6;
  i7 = HEAP32[i15 + 20 >> 2] | 0;
  i3 = i8 + (i12 * 36 | 0) + 4 | 0;
  if (!((HEAP32[i15 + 4 >> 2] | 0) != 0 | i10)) {
   HEAP32[i4 >> 2] = i6;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i3 >> 2] = 0;
   break;
  }
  if (i7 >>> 0 > 15) {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i2, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i4 >> 2] = i10;
   HEAP32[i3 >> 2] = i7;
   i1 = (i10 | 0) == 0 ? i1 : i10;
  }
  _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  HEAP32[i5 >> 2] = i7;
 } while (0);
 HEAP32[i8 + (i12 * 36 | 0) + 32 >> 2] = HEAP32[i15 + 32 >> 2];
 i15 = HEAP32[i9 >> 2] | 0;
 i12 = i15 + ((HEAP32[i11 >> 2] | 0) * 36 | 0) | 0;
 i15 = i15 + ((HEAP32[i14 + 88 >> 2] | 0) * 36 | 0) | 0;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i13 + 8 >> 2] = i15;
 HEAP8[i13 + 12 >> 0] = 1;
 STACKTOP = i16;
 return;
}

function __ZN28LightProbeProxyVolumeManager16UpdateResolutionER21LightProbeProxyVolume(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 f7 = Math_fround(HEAPF32[i9 + 104 >> 2]);
 f2 = Math_fround(HEAPF32[i9 + 108 >> 2]);
 f7 = Math_fround(f7 * Math_fround(2.0));
 f2 = Math_fround(f2 * Math_fround(2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i9 + 112 >> 2]) * Math_fround(2.0));
 switch (HEAP32[i9 + 36 >> 2] | 0) {
 case 2:
 case 0:
  {
   __ZNK9Transform13GetLocalScaleEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   f7 = Math_fround(f7 * Math_fround(HEAPF32[i1 >> 2]));
   f2 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 4 >> 2]));
   f5 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 8 >> 2]));
   i3 = f7 < Math_fround(0.0);
   f12 = Math_fround(-f7);
   i6 = f2 < Math_fround(0.0);
   f10 = Math_fround(-f2);
   i4 = f5 < Math_fround(0.0);
   f11 = Math_fround(-f5);
   f7 = i3 ? f12 : f7;
   f5 = i4 ? f11 : f5;
   f2 = i6 ? f10 : f2;
   break;
  }
 default:
  {}
 }
 if (!(HEAP32[i9 + 40 >> 2] | 0)) {
  f12 = Math_fround(HEAPF32[i9 + 60 >> 2]);
  i3 = f12 < Math_fround(.00999999977);
  f12 = i3 ? Math_fround(.00999999977) : f12;
  i3 = f12 > Math_fround(1.0);
  f12 = i3 ? Math_fround(1.0) : f12;
  i3 = ~~Math_fround(Math_fround(f7 * f12) + Math_fround(.5)) >>> 0;
  i1 = i3 + -1 | 0;
  i1 = i1 >>> 16 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = (i1 >>> 1 | i1) + 1 | 0;
  i4 = i1 >>> 1;
  i1 = (i3 - i4 | 0) >>> 0 < (i1 - i3 | 0) >>> 0 ? i4 : i1;
  i4 = ~~Math_fround(Math_fround(f2 * f12) + Math_fround(.5)) >>> 0;
  i3 = i4 + -1 | 0;
  i3 = i3 >>> 16 | i3;
  i3 = i3 >>> 8 | i3;
  i3 = i3 >>> 4 | i3;
  i3 = i3 >>> 2 | i3;
  i3 = (i3 >>> 1 | i3) + 1 | 0;
  i13 = i3 >>> 1;
  i3 = (i4 - i13 | 0) >>> 0 < (i3 - i4 | 0) >>> 0 ? i13 : i3;
  i13 = ~~Math_fround(Math_fround(f5 * f12) + Math_fround(.5)) >>> 0;
  i4 = i13 + -1 | 0;
  i4 = i4 >>> 16 | i4;
  i4 = i4 >>> 8 | i4;
  i4 = i4 >>> 4 | i4;
  i4 = i4 >>> 2 | i4;
  i4 = (i4 >>> 1 | i4) + 1 | 0;
  i6 = i4 >>> 1;
  i4 = (i13 - i6 | 0) >>> 0 < (i4 - i13 | 0) >>> 0 ? i6 : i4;
  i1 = i1 >>> 0 > 1 ? i1 : 1;
  i3 = i3 >>> 0 > 1 ? i3 : 1;
  i4 = i4 >>> 0 > 1 ? i4 : 1;
 } else {
  i1 = HEAP32[i9 + 48 >> 2] | 0;
  i3 = HEAP32[i9 + 52 >> 2] | 0;
  i4 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = i1 >>> 0 > 1 ? i1 : 1;
  i3 = i3 >>> 0 > 1 ? i3 : 1;
  i4 = i4 >>> 0 > 1 ? i4 : 1;
 }
 i6 = i9 + 140 | 0;
 if (HEAP32[i9 + 44 >> 2] | 0) {
  i13 = i1 >>> 0 < 32;
  i13 = i13 ? i1 : 32;
  HEAP32[i6 >> 2] = i13;
  i13 = i3 >>> 0 < 32;
  i13 = i13 ? i3 : 32;
  i6 = i9 + 144 | 0;
  HEAP32[i6 >> 2] = i13;
  i6 = i4 >>> 0 < 32;
  i6 = i6 ? i4 : 32;
  i13 = i9 + 148 | 0;
  HEAP32[i13 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) if ((i3 | 0) == (HEAP32[i9 + 144 >> 2] | 0)) if ((i4 | 0) == (HEAP32[i9 + 148 >> 2] | 0)) {
  i13 = i1 >>> 0 < 32;
  i13 = i13 ? i1 : 32;
  HEAP32[i6 >> 2] = i13;
  i13 = i3 >>> 0 < 32;
  i13 = i13 ? i3 : 32;
  i6 = i9 + 144 | 0;
  HEAP32[i6 >> 2] = i13;
  i6 = i4 >>> 0 < 32;
  i6 = i6 ? i4 : 32;
  i13 = i9 + 148 | 0;
  HEAP32[i13 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
 HEAP8[i9 + 154 >> 0] = 1;
 i13 = i1 >>> 0 < 32;
 i13 = i13 ? i1 : 32;
 HEAP32[i6 >> 2] = i13;
 i13 = i3 >>> 0 < 32;
 i13 = i13 ? i3 : 32;
 i6 = i9 + 144 | 0;
 HEAP32[i6 >> 2] = i13;
 i6 = i4 >>> 0 < 32;
 i6 = i6 ? i4 : 32;
 i13 = i9 + 148 | 0;
 HEAP32[i13 >> 2] = i6;
 STACKTOP = i8;
 return;
}

function __ZN24CompressedAnimationCurve8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i2 = i6 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899417 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899424 | 0, gb + 899432 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 901491 | 0, gb + 899432 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN16PackedQuatVector8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899448 | 0, gb + 899432 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 64 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034211 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 30; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034225 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 41; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 41; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 41) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i10 = i16 + 8 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16;
 i15 = i14 + 4 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i1 = i5 - i11 >> 2;
 i9 = i11;
 if (i1 >>> 0 < i12 >>> 0) {
  i7 = i14 + 8 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i11 >> 2 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i10 >> 2] = 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i6 = i10 + 8 | 0;
  if (i12 | 0) {
   i9 = __Znwj(i12 << 2) | 0;
   i1 = i9;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i6 >> 2] = i9 + (i12 << 2);
  }
  HEAP32[i3 >> 2] = i11;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i2, i13);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = i1 - i4 >> 2;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i10, i12 - i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 << 2) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
    HEAP32[i8 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i9 + (i12 << 2) | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 << 2;
  i2 = i1 >> 2;
  if (!i2) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i6 = __Znwj(i1) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i2 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i8 = i6;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i5 = i7 + -4 | 0;
    i2 = i9;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i11 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i8;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5Unity10FixedJoint6CreateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 28 | 0;
 i9 = i11;
 i10 = i7 + 32 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) __ZN5Unity5Joint7CleanupEv(i7);
  if (HEAP32[i10 >> 2] | 0) {
   __ZN5Unity5Joint14FinalizeCreateEb(i7, 0);
   STACKTOP = i11;
   return;
  }
 }
 i5 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 67048 | 0) | 0) + 52 >> 2] | 0;
 i4 = i7 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 13;
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
   i1 = 0;
   break;
  }
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
    i2 = HEAP32[i8 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 21;
   }
  }
  if ((i6 | 0) == 19) i6 = 21;
  if ((i6 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 52 >> 2] | 0;
 } while (0);
 i12 = __Z14GetDynamicsSDKv() | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = __ZN5physx18PxFixedJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i12, i5, i8, i1, i9) | 0;
 __ZN5Unity5Joint14FinalizeCreateEb(i7, 0);
 STACKTOP = i11;
 return;
}

function __ZN27AnimatorControllerParameter13SetDefaultIntEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 if ((HEAP32[i1 + 16 >> 2] | 0) != 3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911804 | 0, 0, gb + 911526 | 0, 121, 1, 0, 0, 0);
  STACKTOP = i8;
  return;
 }
 i3 = i1 + 24 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 11;
 }
 if ((i7 | 0) == 9) i7 = 11;
 if ((i7 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 17; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 19;
  }
 }
 if ((i7 | 0) == 17) i7 = 19;
 if ((i7 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1);
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 25; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 25; else if (HEAP32[i1 + 4 >> 2] | 0) {
   STACKTOP = i8;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE6RemoveES4_(i15, i13) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 i11 = i15 + 12 | 0;
 i17 = i15 + 20 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) != (i12 | 0)) {
  i9 = i15 + 16 | 0;
  i10 = i16 + 4 | 0;
  while (1) {
   i5 = HEAP32[i2 + 4 >> 2] | 0;
   i6 = (i5 | 0) == 0;
   if (i6) {
    i4 = i1;
    while (1) {
     i3 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
    }
   } else {
    i3 = i5;
    while (1) {
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else i3 = i4;
    }
   }
   i7 = i2 + 16 | 0;
   if ((HEAP32[i2 + 32 >> 2] | 0) == (HEAP32[i13 >> 2] | 0)) {
    i8 = i1;
    if (i6) {
     i5 = i8;
     while (1) {
      i4 = HEAP32[i5 + 8 >> 2] | 0;
      if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) break; else i5 = i4;
     }
    } else {
     i4 = i5;
     while (1) {
      i5 = HEAP32[i4 >> 2] | 0;
      if (!i5) break; else i4 = i5;
     }
    }
    if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) HEAP32[i11 >> 2] = i4;
    HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
    __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i8);
    if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
     i8 = HEAP32[i7 >> 2] | 0;
     i7 = HEAP32[i2 + 28 >> 2] | 0;
     HEAP32[i16 >> 2] = 66;
     HEAP32[i10 >> 2] = i7;
     __Z19free_alloc_internalPvRK10MemLabelId(i8, i16);
    }
    __ZdlPv(i1);
   }
   i1 = i3;
   if ((i3 | 0) == (i12 | 0)) break; else i2 = i3;
  }
 }
 i1 = i15 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 L28 : do if (!i3) i14 = 28; else {
  i4 = HEAP32[i13 >> 2] | 0;
  L30 : while (1) {
   i2 = i3;
   while (1) {
    i3 = HEAP32[i2 + 16 >> 2] | 0;
    if ((i4 | 0) < (i3 | 0)) break;
    if ((i3 | 0) >= (i4 | 0)) break L30;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) {
     i14 = 28;
     break L28;
    }
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    i14 = 28;
    break L28;
   } else i1 = i2;
  }
  i3 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i2) {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  i2 = i3;
 } while (0);
 if ((i14 | 0) == 28) i2 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i17 = HEAP32[i17 >> 2] | 0;
  i18 = (i18 | 0) != (i17 | 0);
  STACKTOP = i19;
  return i18 | 0;
 }
 i5 = i15 + 8 | 0;
 i6 = i15 + 4 | 0;
 i7 = i16 + 4 | 0;
 while (1) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) {
   i4 = i2;
   while (1) {
    i3 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
   }
  } else while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) break; else i3 = i4;
  }
  if ((HEAP32[i15 >> 2] | 0) == (i2 | 0)) HEAP32[i15 >> 2] = i3;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i2);
  i4 = i2 + 20 | 0;
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i14 = HEAP32[i4 >> 2] | 0;
   i13 = HEAP32[i2 + 32 >> 2] | 0;
   HEAP32[i16 >> 2] = 66;
   HEAP32[i7 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i14, i16);
  }
  __ZdlPv(i2);
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i3;
 }
 i17 = HEAP32[i17 >> 2] | 0;
 i18 = (i18 | 0) != (i17 | 0);
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN14RotationModule16UpdateProceduralERK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4E(i23, i1, i24, i25) {
 i23 = i23 | 0;
 i1 = i1 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f26 = f0, i27 = 0, i28 = 0, i29 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 8 | 0;
 i1 = i22;
 if ((HEAP16[gb + 1452116 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452116 | 0, i21);
  i2 = gb + 1452116 | 0;
 } else i2 = 0;
 i3 = i21 + 80 | 0;
 i4 = i21 + 4 | 0;
 i5 = i21 + 8 | 0;
 i6 = i21 + 12 | 0;
 i7 = i21 + 16 | 0;
 i8 = i21 + 20 | 0;
 i9 = i21 + 24 | 0;
 i10 = i21 + 28 | 0;
 i11 = i21 + 32 | 0;
 i12 = i21 + 40 | 0;
 i13 = i21 + 44 | 0;
 i14 = i21 + 48 | 0;
 i15 = i21 + 52 | 0;
 i16 = i21 + 56 | 0;
 i17 = i21 + 60 | 0;
 i18 = i21 + 64 | 0;
 i19 = i21 + 68 | 0;
 i20 = i21 + 72 | 0;
 i1 = HEAP8[i23 + 800 >> 0] | 0 ? 0 : 2;
 do {
  if (!(HEAP8[i23 + 8 + (i1 * 264 | 0) + 86 >> 0] | 0)) {
   f26 = Math_fround(HEAPF32[i23 + 8 + (i1 * 264 | 0) + 80 >> 2]);
   __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i3, i23 + 8 + (i1 * 264 | 0) + 88 | 0, f26, HEAP16[i23 + 8 + (i1 * 264 | 0) + 84 >> 1] | 0);
   __ZN16MinMaxPolyCurves9IntegrateEv(i3);
   __Z19UpdateProceduralTplILb0EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E(i21, i24, HEAP32[i24 + 300 + (i1 * 20 | 0) >> 2] | 0, i25);
  } else {
   i27 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 4 >> 2] | 0;
   i28 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 8 >> 2] | 0;
   i29 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 12 >> 2] | 0;
   HEAP32[i21 >> 2] = HEAP32[i23 + 8 + (i1 * 264 | 0) >> 2];
   HEAP32[i4 >> 2] = i27;
   HEAP32[i5 >> 2] = i28;
   HEAP32[i6 >> 2] = i29;
   i29 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 20 >> 2] | 0;
   i28 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 24 >> 2] | 0;
   i27 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 28 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i23 + 8 + (i1 * 264 | 0) + 16 >> 2];
   HEAP32[i8 >> 2] = i29;
   HEAP32[i9 >> 2] = i28;
   HEAP32[i10 >> 2] = i27;
   i27 = i23 + 8 + (i1 * 264 | 0) + 32 | 0;
   i28 = HEAP32[i27 + 4 >> 2] | 0;
   i29 = i11;
   HEAP32[i29 >> 2] = HEAP32[i27 >> 2];
   HEAP32[i29 + 4 >> 2] = i28;
   i29 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 44 >> 2] | 0;
   i28 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 48 >> 2] | 0;
   i27 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 52 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i23 + 8 + (i1 * 264 | 0) + 40 >> 2];
   HEAP32[i13 >> 2] = i29;
   HEAP32[i14 >> 2] = i28;
   HEAP32[i15 >> 2] = i27;
   i27 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 60 >> 2] | 0;
   i28 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 64 >> 2] | 0;
   i29 = HEAP32[i23 + 8 + (i1 * 264 | 0) + 68 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i23 + 8 + (i1 * 264 | 0) + 56 >> 2];
   HEAP32[i17 >> 2] = i27;
   HEAP32[i18 >> 2] = i28;
   HEAP32[i19 >> 2] = i29;
   i29 = i23 + 8 + (i1 * 264 | 0) + 72 | 0;
   i28 = HEAP32[i29 + 4 >> 2] | 0;
   i27 = i20;
   HEAP32[i27 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i27 + 4 >> 2] = i28;
   __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i21);
   __Z19UpdateProceduralTplILb1EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E(i21, i24, HEAP32[i24 + 300 + (i1 * 20 | 0) >> 2] | 0, i25);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 if (!i2) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i22;
 return;
}

function __ZN11DynamicMesh24CollapsePolygonUnorderedEj(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i23 + 24 | 0;
 i17 = i23;
 i20 = HEAP32[i18 >> 2] | 0;
 i21 = i20 + (i19 * 26 | 0) | 0;
 i2 = i16;
 i3 = i21;
 i4 = i2 + 26 | 0;
 do {
  HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
  i2 = i2 + 2 | 0;
  i3 = i3 + 2 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i15 = i16 + 24 | 0;
 i2 = HEAP8[i15 >> 0] | 0;
 L1 : do if (!(i2 << 24 >> 24)) i22 = 5; else {
  i4 = i2 & 255;
  i3 = HEAP32[i18 + 20 >> 2] | 0;
  i1 = 0;
  do {
   i12 = i1;
   i1 = i1 + 1 | 0;
   i13 = (i1 | 0) < (i4 | 0);
   i10 = HEAPU16[i16 + 12 + (i12 << 1) >> 1] | 0;
   i11 = HEAPU16[i16 + 12 + ((i13 ? i1 : 0) << 1) >> 1] | 0;
   f24 = Math_fround(HEAPF32[i3 + (i10 * 12 | 0) >> 2]);
   f24 = Math_fround(f24 - Math_fround(HEAPF32[i3 + (i11 * 12 | 0) >> 2]));
   f5 = Math_fround(HEAPF32[i3 + (i10 * 12 | 0) + 4 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + (i11 * 12 | 0) + 4 >> 2]));
   f14 = Math_fround(HEAPF32[i3 + (i10 * 12 | 0) + 8 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i3 + (i11 * 12 | 0) + 8 >> 2]));
   HEAPF32[i17 + (i12 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f5 * f5)) + Math_fround(f14 * f14));
  } while (i13);
  if ((i2 & 255) > 2) {
   f14 = Math_fround(HEAPF32[i18 + 8280 >> 2]);
   f14 = Math_fround(f14 * f14);
   i1 = i18 + 12 | 0;
   do {
    i13 = i2 & 255;
    f5 = Math_fround(HEAPF32[i17 >> 2]);
    i3 = 0;
    i4 = 1;
    do {
     f24 = Math_fround(HEAPF32[i17 + (i4 << 2) >> 2]);
     i12 = f24 < f5;
     i3 = i12 ? i4 : i3;
     f5 = i12 ? f24 : f5;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (i13 | 0));
    if (f5 > f14) break L1;
    i10 = i3 + 1 | 0;
    i9 = HEAP16[i16 + 12 + (i3 << 1) >> 1] | 0;
    i10 = HEAP16[i16 + 12 + (((i10 | 0) < (i13 | 0) ? i10 : 0) << 1) >> 1] | 0;
    if (i9 << 16 >> 16 != i10 << 16 >> 16) {
     i11 = HEAP32[i1 >> 2] | 0;
     if (i11 | 0) {
      i7 = 0;
      do {
       i12 = i20 + (i7 * 26 | 0) + 24 | 0;
       i4 = HEAP8[i12 >> 0] | 0;
       if (i4 << 24 >> 24) {
        i8 = 0;
        do {
         i6 = i20 + (i7 * 26 | 0) + 12 + (i8 << 1) | 0;
         if ((HEAP16[i6 >> 1] | 0) == i9 << 16 >> 16) {
          HEAP16[i6 >> 1] = i10;
          i4 = HEAP8[i12 >> 0] | 0;
         }
         i8 = i8 + 1 | 0;
        } while ((i8 | 0) < (i4 & 255 | 0));
       }
       i7 = i7 + 1 | 0;
      } while ((i7 | 0) != (i11 | 0));
     }
    }
    if ((i3 | 0) < (i13 + -1 | 0)) do {
     i2 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i17 + (i2 << 2) >> 2] = HEAP32[i17 + (i3 << 2) >> 2];
     HEAP16[i16 + 12 + (i2 << 1) >> 1] = HEAP16[i16 + 12 + (i3 << 1) >> 1] | 0;
     i2 = HEAP8[i15 >> 0] | 0;
    } while ((i3 | 0) < ((i2 & 255) + -1 | 0));
    i2 = i2 + -1 << 24 >> 24;
    HEAP8[i15 >> 0] = i2;
   } while ((i2 & 255) > 2);
  } else i22 = 5;
 } while (0);
 if ((i22 | 0) == 5) i1 = i18 + 12 | 0;
 i2 = i21;
 i3 = i20 + (((HEAP32[i1 >> 2] | 0) + -1 | 0) * 26 | 0) | 0;
 i4 = i2 + 26 | 0;
 do {
  HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
  i2 = i2 + 2 | 0;
  i3 = i3 + 2 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i22 = i18 + 52 | 0;
 i21 = HEAP32[i18 + 40 >> 2] | 0;
 HEAP32[i21 + (i19 << 2) >> 2] = HEAP32[i21 + ((HEAP32[i22 >> 2] | 0) + -1 << 2) >> 2];
 HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + -1;
 STACKTOP = i23;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i9, i1, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 32 | 0;
 i15 = i19 + 16 | 0;
 i16 = i19;
 i17 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i17) {
  STACKTOP = i19;
  return;
 }
 i18 = i1 + 520 | 0;
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 i12 = i14 + 12 | 0;
 i2 = i1 + 500 | 0;
 i3 = i15 + 4 | 0;
 i4 = i15 + 8 | 0;
 i5 = i15 + 12 | 0;
 i6 = i16 + 4 | 0;
 i7 = i16 + 8 | 0;
 i8 = i16 + 12 | 0;
 i1 = 0;
 do {
  i20 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f30 = Math_fround(HEAPF32[i20 >> 2]);
  f28 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f28 = Math_fround(f28 * Math_fround(.00999999977));
  f32 = Math_fround(f32 * Math_fround(.00999999977));
  f31 = Math_fround(Math_fround(HEAPF32[i20 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i14 >> 2] = Math_fround(f30 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f28;
  HEAPF32[i11 >> 2] = f32;
  HEAPF32[i12 >> 2] = f31;
  i20 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i24 = (HEAP32[i20 >> 2] | 0) + -1926462415 | 0;
  i35 = (HEAP32[i20 + 4 >> 2] | 0) + -1926462415 | 0;
  i33 = (HEAP32[i20 + 8 >> 2] | 0) + -1926462415 | 0;
  i20 = (HEAP32[i20 + 12 >> 2] | 0) + -1926462415 | 0;
  i26 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i29 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i22 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
  i24 = i24 << 11 ^ i24;
  i35 = i35 << 11 ^ i35;
  i33 = i33 << 11 ^ i33;
  i20 = i20 << 11 ^ i20;
  f31 = Math_fround(Math_fround((i34 ^ i35 ^ i35 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f32 = Math_fround(Math_fround((i29 ^ i33 ^ i33 >>> 8) & 8388607 ^ i29 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f28 = Math_fround(Math_fround((i22 ^ i20 ^ i20 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i15 >> 2] = Math_fround(Math_fround((i26 ^ i24 ^ i24 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f31;
  HEAPF32[i4 >> 2] = f32;
  HEAPF32[i5 >> 2] = f28;
  i26 = i13 + (i1 << 2) | 0;
  f28 = Math_fround(HEAPF32[i26 >> 2]);
  i24 = i26 + 4 | 0;
  f32 = Math_fround(HEAPF32[i24 >> 2]);
  i22 = i26 + 8 | 0;
  f31 = Math_fround(HEAPF32[i22 >> 2]);
  i20 = i26 + 12 | 0;
  f30 = Math_fround(HEAPF32[i20 >> 2]);
  __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i16, i9, i14, i15);
  f27 = Math_fround(HEAPF32[i16 >> 2]);
  i29 = f27 < Math_fround(0.0);
  f27 = i29 ? Math_fround(0.0) : f27;
  f25 = Math_fround(HEAPF32[i6 >> 2]);
  i29 = f25 < Math_fround(0.0);
  f25 = i29 ? Math_fround(0.0) : f25;
  f23 = Math_fround(HEAPF32[i7 >> 2]);
  i29 = f23 < Math_fround(0.0);
  f23 = i29 ? Math_fround(0.0) : f23;
  f21 = Math_fround(HEAPF32[i8 >> 2]);
  i29 = f21 < Math_fround(0.0);
  f25 = Math_fround(f32 * f25);
  f23 = Math_fround(f31 * f23);
  f21 = Math_fround(f30 * (i29 ? Math_fround(0.0) : f21));
  HEAPF32[i26 >> 2] = Math_fround(f28 * f27);
  HEAPF32[i24 >> 2] = f25;
  HEAPF32[i22 >> 2] = f23;
  HEAPF32[i20 >> 2] = f21;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i17 >>> 0);
 STACKTOP = i19;
 return;
}

function __ZN7mecanim9animation27GetWeightsSimpleDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb(i5, i17, i1, i3, f12, f13, i4) {
 i5 = i5 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 i4 = i4 | 0;
 var f2 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0;
 i11 = i5 + 4 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 i11 = (i16 | 0) == 0 ? 0 : i16 + i11 | 0;
 i16 = HEAP32[i5 >> 2] | 0;
 if ((i17 | 0) == 0 | (i11 | 0) == 0) return;
 i15 = (i16 | 0) == 0;
 if (i15) return;
 _memset(i17 | 0, 0, i16 << 2 | 0) | 0;
 if ((i16 | 0) == 1) {
  HEAPF32[i17 >> 2] = Math_fround(1.0);
  return;
 }
 f9 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
 f10 = Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]);
 if (f9 == f12 & f10 == f13) {
  i1 = 0;
  do {
   if (Math_fround(HEAPF32[i11 + (i1 << 3) >> 2]) == f9) if (Math_fround(HEAPF32[i11 + (i1 << 3) + 4 >> 2]) == f10) {
    i14 = 8;
    break;
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i16 >>> 0);
  if ((i14 | 0) == 8) {
   HEAPF32[i17 + (i1 << 2) >> 2] = Math_fround(1.0);
   return;
  }
  f2 = Math_fround(Math_fround(1.0) / Math_fround(i16 >>> 0));
  if (i15) return; else i1 = 0;
  do {
   HEAPF32[i17 + (i1 << 2) >> 2] = f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
  return;
 } else {
  i3 = -1;
  i5 = 0;
  f7 = Math_fround(-1.0e5);
  f8 = Math_fround(-1.0e5);
  i1 = -1;
  i4 = -1;
 }
 L26 : while (1) {
  f2 = Math_fround(HEAPF32[i11 + (i5 << 3) >> 2]);
  f6 = Math_fround(HEAPF32[i11 + (i5 << 3) + 4 >> 2]);
  do if (f2 == f9 & f6 == f10) if ((i1 | 0) > -1) {
   i14 = 31;
   break L26;
  } else {
   i1 = i5;
   f6 = f7;
   f2 = f8;
  } else {
   f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(f6 * f6))));
   f18 = Math_fround(f2 / f19);
   f6 = Math_fround(f6 / f19);
   f2 = Math_fround(Math_fround(f18 * f12) + Math_fround(f6 * f13));
   if (Math_fround(Math_fround(f18 * f13) - Math_fround(f6 * f12)) > Math_fround(0.0)) {
    if (!(f2 > f7)) {
     f6 = f7;
     f2 = f8;
     break;
    }
    i3 = i5;
    f6 = f2;
    f2 = f8;
    break;
   } else {
    if (!(f2 > f8)) {
     f6 = f7;
     f2 = f8;
     break;
    }
    f6 = f7;
    i4 = i5;
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i16 >>> 0) break; else {
   f7 = f6;
   f8 = f2;
  }
 }
 if ((i14 | 0) == 31) return;
 if ((i3 | i4 | 0) < 0) f2 = Math_fround(1.0); else {
  f19 = Math_fround(HEAPF32[i11 + (i3 << 3) >> 2]);
  f2 = Math_fround(HEAPF32[i11 + (i3 << 3) + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i11 + (i4 << 3) >> 2]);
  f18 = Math_fround(HEAPF32[i11 + (i4 << 3) + 4 >> 2]);
  f6 = Math_fround(Math_fround(f19 * f18) - Math_fround(f2 * f7));
  f7 = Math_fround(Math_fround(Math_fround(f18 * f12) - Math_fround(f7 * f13)) / f6);
  f6 = Math_fround(Math_fround(Math_fround(f19 * f13) - Math_fround(f2 * f12)) / f6);
  f2 = Math_fround(Math_fround(Math_fround(1.0) - f7) - f6);
  if (f2 < Math_fround(0.0)) {
   f2 = Math_fround(f7 + f6);
   f6 = Math_fround(f6 / f2);
   f7 = Math_fround(f7 / f2);
   f2 = Math_fround(0.0);
  } else if (f2 > Math_fround(1.0)) {
   f6 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f2 = Math_fround(1.0);
  }
  HEAPF32[i17 + (i3 << 2) >> 2] = f7;
  HEAPF32[i17 + (i4 << 2) >> 2] = f6;
 }
 if ((i1 | 0) > -1) {
  HEAPF32[i17 + (i1 << 2) >> 2] = f2;
  return;
 }
 if (i15) return;
 f2 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(i16 >>> 0)) * f2);
 i1 = 0;
 do {
  i15 = i17 + (i1 << 2) | 0;
  HEAPF32[i15 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i15 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i16 | 0));
 return;
}

function runPostSets76() {
 HEAP32[gb + 83824 >> 2] = fb + 18;
 HEAP32[gb + 83828 >> 2] = fb + 204;
 HEAP32[gb + 83832 >> 2] = fb + 430;
 HEAP32[gb + 83844 >> 2] = fb + 61;
 HEAP32[gb + 83848 >> 2] = fb + 984;
 HEAP32[gb + 83852 >> 2] = fb + 985;
 HEAP32[gb + 83856 >> 2] = fb + 1;
 HEAP32[gb + 83860 >> 2] = fb + 1;
 HEAP32[gb + 83864 >> 2] = fb + 1;
 HEAP32[gb + 83892 >> 2] = fb + 29;
 HEAP32[gb + 83896 >> 2] = fb + 30;
 HEAP32[gb + 83900 >> 2] = fb + 31;
 HEAP32[gb + 83904 >> 2] = fb + 32;
 HEAP32[gb + 83908 >> 2] = fb + 33;
 HEAP32[gb + 83912 >> 2] = fb + 34;
 HEAP32[gb + 83916 >> 2] = fb + 35;
 HEAP32[gb + 83920 >> 2] = fb + 36;
 HEAP32[gb + 83924 >> 2] = fb + 37;
 HEAP32[gb + 83928 >> 2] = fb + 38;
 HEAP32[gb + 83932 >> 2] = fb + 39;
 HEAP32[gb + 83936 >> 2] = fb + 40;
 HEAP32[gb + 83940 >> 2] = fb + 41;
 HEAP32[gb + 83944 >> 2] = fb + 42;
 HEAP32[gb + 83948 >> 2] = fb + 43;
 HEAP32[gb + 83952 >> 2] = fb + 44;
 HEAP32[gb + 83956 >> 2] = fb + 45;
 HEAP32[gb + 83960 >> 2] = fb + 46;
 HEAP32[gb + 83964 >> 2] = fb + 47;
 HEAP32[gb + 83972 >> 2] = fb + 48;
 HEAP32[gb + 83976 >> 2] = fb + 49;
 HEAP32[gb + 83980 >> 2] = fb + 50;
 HEAP32[gb + 83984 >> 2] = fb + 51;
 HEAP32[gb + 83988 >> 2] = fb + 48;
 HEAP32[gb + 83992 >> 2] = fb + 48;
 HEAP32[gb + 84004 >> 2] = fb + 52;
 HEAP32[gb + 84008 >> 2] = fb + 53;
 HEAP32[gb + 84012 >> 2] = fb + 54;
 HEAP32[gb + 84016 >> 2] = fb + 55;
 HEAP32[gb + 84020 >> 2] = fb + 56;
 HEAP32[gb + 84036 >> 2] = fb + 57;
 HEAP32[gb + 84040 >> 2] = fb + 58;
 HEAP32[gb + 84044 >> 2] = fb + 59;
 HEAP32[gb + 84048 >> 2] = fb + 60;
 HEAP32[gb + 84068 >> 2] = fb + 61;
 HEAP32[gb + 84072 >> 2] = fb + 62;
 HEAP32[gb + 84076 >> 2] = fb + 63;
 HEAP32[gb + 84100 >> 2] = fb + 48;
 HEAP32[gb + 84104 >> 2] = fb + 48;
 HEAP32[gb + 84132 >> 2] = fb + 48;
 HEAP32[gb + 84144 >> 2] = fb + 986;
 HEAP32[gb + 84148 >> 2] = fb + 987;
 HEAP32[gb + 84152 >> 2] = fb + 110;
 HEAP32[gb + 84164 >> 2] = fb + 8;
 HEAP32[gb + 84168 >> 2] = fb + 988;
 HEAP32[gb + 84172 >> 2] = fb + 989;
 HEAP32[gb + 84184 >> 2] = fb + 55;
 HEAP32[gb + 84188 >> 2] = fb + 990;
 HEAP32[gb + 84192 >> 2] = fb + 991;
 HEAP32[gb + 84196 >> 2] = fb + 111;
 HEAP32[gb + 84208 >> 2] = fb + 112;
 HEAP32[gb + 84212 >> 2] = fb + 992;
 HEAP32[gb + 84216 >> 2] = fb + 993;
 HEAP32[gb + 84220 >> 2] = fb + 994;
 HEAP32[gb + 84232 >> 2] = fb + 995;
 HEAP32[gb + 84236 >> 2] = fb + 996;
 HEAP32[gb + 84240 >> 2] = fb + 85;
 HEAP32[gb + 84244 >> 2] = fb + 62;
 HEAP32[gb + 84248 >> 2] = fb + 15;
 HEAP32[gb + 84260 >> 2] = fb + 995;
 HEAP32[gb + 84264 >> 2] = fb + 997;
 HEAP32[gb + 84268 >> 2] = fb + 86;
 HEAP32[gb + 84272 >> 2] = fb + 63;
 HEAP32[gb + 84276 >> 2] = fb + 16;
 HEAP32[gb + 84384 >> 2] = fb + 995;
 HEAP32[gb + 84388 >> 2] = fb + 998;
 HEAP32[gb + 84392 >> 2] = fb + 87;
 HEAP32[gb + 84396 >> 2] = fb + 64;
 HEAP32[gb + 84400 >> 2] = fb + 17;
 HEAP32[gb + 84412 >> 2] = fb + 986;
 HEAP32[gb + 84416 >> 2] = fb + 999;
 HEAP32[gb + 84420 >> 2] = fb + 113;
 HEAP32[gb + 84444 >> 2] = fb + 9;
 HEAP32[gb + 84448 >> 2] = fb + 988;
 HEAP32[gb + 84452 >> 2] = fb + 1e3;
 HEAP32[gb + 84464 >> 2] = fb + 986;
 HEAP32[gb + 84468 >> 2] = fb + 1001;
 HEAP32[gb + 84472 >> 2] = fb + 114;
 HEAP32[gb + 84484 >> 2] = fb + 10;
 HEAP32[gb + 84488 >> 2] = fb + 1002;
 HEAP32[gb + 84492 >> 2] = fb + 1003;
 HEAP32[gb + 84504 >> 2] = fb + 11;
 HEAP32[gb + 84508 >> 2] = fb + 1002;
 HEAP32[gb + 84512 >> 2] = fb + 1004;
 HEAP32[gb + 84516 >> 2] = fb + 1;
 HEAP32[gb + 84520 >> 2] = fb + 2;
 HEAP32[gb + 84524 >> 2] = fb + 3;
 HEAP32[gb + 84528 >> 2] = fb + 4;
 HEAP32[gb + 84532 >> 2] = fb + 5;
 HEAP32[gb + 84536 >> 2] = fb + 6;
 HEAP32[gb + 84540 >> 2] = fb + 7;
 runPostSets77();
}

function runPostSets21() {
 HEAP32[gb + 37788 >> 2] = fb + 147;
 HEAP32[gb + 37792 >> 2] = fb + 103;
 HEAP32[gb + 37796 >> 2] = fb + 101;
 HEAP32[gb + 37800 >> 2] = fb + 62;
 HEAP32[gb + 37804 >> 2] = fb + 28;
 HEAP32[gb + 37808 >> 2] = fb + 63;
 HEAP32[gb + 37812 >> 2] = fb + 29;
 HEAP32[gb + 37816 >> 2] = fb + 34;
 HEAP32[gb + 37820 >> 2] = fb + 146;
 HEAP32[gb + 37824 >> 2] = fb + 147;
 HEAP32[gb + 37828 >> 2] = fb + 148;
 HEAP32[gb + 37832 >> 2] = fb + 149;
 HEAP32[gb + 37836 >> 2] = fb + 150;
 HEAP32[gb + 37840 >> 2] = fb + 151;
 HEAP32[gb + 37844 >> 2] = fb + 36;
 HEAP32[gb + 37848 >> 2] = fb + 104;
 HEAP32[gb + 37852 >> 2] = fb + 108;
 HEAP32[gb + 37856 >> 2] = fb + 94;
 HEAP32[gb + 37860 >> 2] = fb + 130;
 HEAP32[gb + 37864 >> 2] = fb + 112;
 HEAP32[gb + 37868 >> 2] = fb + 113;
 HEAP32[gb + 37872 >> 2] = fb + 131;
 HEAP32[gb + 37876 >> 2] = fb + 111;
 HEAP32[gb + 37880 >> 2] = fb + 112;
 HEAP32[gb + 37884 >> 2] = fb + 113;
 HEAP32[gb + 37888 >> 2] = fb + 1;
 HEAP32[gb + 37892 >> 2] = fb + 1;
 HEAP32[gb + 37904 >> 2] = fb + 258;
 HEAP32[gb + 37908 >> 2] = fb + 265;
 HEAP32[gb + 37912 >> 2] = fb + 266;
 HEAP32[gb + 37924 >> 2] = fb + 258;
 HEAP32[gb + 37928 >> 2] = fb + 267;
 HEAP32[gb + 37932 >> 2] = fb + 268;
 HEAP32[gb + 37944 >> 2] = fb + 258;
 HEAP32[gb + 37948 >> 2] = fb + 269;
 HEAP32[gb + 37952 >> 2] = fb + 270;
 HEAP32[gb + 37964 >> 2] = fb + 258;
 HEAP32[gb + 37968 >> 2] = fb + 271;
 HEAP32[gb + 37972 >> 2] = fb + 272;
 HEAP32[gb + 37984 >> 2] = fb + 25;
 HEAP32[gb + 37996 >> 2] = fb + 273;
 HEAP32[gb + 38e3 >> 2] = fb + 274;
 HEAP32[gb + 38004 >> 2] = fb + 57;
 HEAP32[gb + 38008 >> 2] = fb + 11;
 HEAP32[gb + 38012 >> 2] = fb + 5;
 HEAP32[gb + 38016 >> 2] = fb + 258;
 HEAP32[gb + 38020 >> 2] = fb + 148;
 HEAP32[gb + 38024 >> 2] = fb + 259;
 HEAP32[gb + 38028 >> 2] = fb + 149;
 HEAP32[gb + 38032 >> 2] = fb + 150;
 HEAP32[gb + 38144 >> 2] = fb + 275;
 HEAP32[gb + 38148 >> 2] = fb + 276;
 HEAP32[gb + 38152 >> 2] = fb + 277;
 HEAP32[gb + 38156 >> 2] = fb + 278;
 HEAP32[gb + 38160 >> 2] = fb + 279;
 HEAP32[gb + 38164 >> 2] = fb + 151;
 HEAP32[gb + 38168 >> 2] = fb + 260;
 HEAP32[gb + 38172 >> 2] = fb + 261;
 HEAP32[gb + 38176 >> 2] = fb + 1;
 HEAP32[gb + 38180 >> 2] = fb + 262;
 HEAP32[gb + 38184 >> 2] = fb + 280;
 HEAP32[gb + 38188 >> 2] = fb + 1;
 HEAP32[gb + 38192 >> 2] = fb + 1;
 HEAP32[gb + 38196 >> 2] = fb + 1;
 HEAP32[gb + 38200 >> 2] = fb + 1;
 HEAP32[gb + 38204 >> 2] = fb + 1;
 HEAP32[gb + 38208 >> 2] = fb + 1;
 HEAP32[gb + 38212 >> 2] = fb + 1;
 HEAP32[gb + 38216 >> 2] = fb + 1;
 HEAP32[gb + 38220 >> 2] = fb + 263;
 HEAP32[gb + 38224 >> 2] = fb + 1;
 HEAP32[gb + 38228 >> 2] = fb + 1;
 HEAP32[gb + 38232 >> 2] = fb + 1;
 HEAP32[gb + 38236 >> 2] = fb + 1;
 HEAP32[gb + 38240 >> 2] = fb + 1;
 HEAP32[gb + 38244 >> 2] = fb + 1;
 HEAP32[gb + 38248 >> 2] = fb + 14;
 HEAP32[gb + 38252 >> 2] = fb + 264;
 HEAP32[gb + 38256 >> 2] = fb + 265;
 HEAP32[gb + 38260 >> 2] = fb + 266;
 HEAP32[gb + 38264 >> 2] = fb + 281;
 HEAP32[gb + 38268 >> 2] = fb + 152;
 HEAP32[gb + 38272 >> 2] = fb + 153;
 HEAP32[gb + 38276 >> 2] = fb + 154;
 HEAP32[gb + 38280 >> 2] = fb + 155;
 HEAP32[gb + 38284 >> 2] = fb + 156;
 HEAP32[gb + 38288 >> 2] = fb + 6;
 HEAP32[gb + 38292 >> 2] = fb + 1;
 HEAP32[gb + 38296 >> 2] = fb + 1;
 HEAP32[gb + 38300 >> 2] = fb + 1;
 HEAP32[gb + 38304 >> 2] = fb + 1;
 HEAP32[gb + 38308 >> 2] = fb + 1;
 HEAP32[gb + 38312 >> 2] = fb + 1;
 HEAP32[gb + 38316 >> 2] = fb + 1;
 HEAP32[gb + 38320 >> 2] = fb + 1;
 HEAP32[gb + 38324 >> 2] = fb + 1;
 HEAP32[gb + 38328 >> 2] = fb + 1;
 HEAP32[gb + 38332 >> 2] = fb + 267;
 HEAP32[gb + 38336 >> 2] = fb + 12;
 HEAP32[gb + 38340 >> 2] = fb + 1;
 runPostSets22();
}

function runPostSets103() {
 HEAP32[gb + 97480 >> 2] = fb + 302;
 HEAP32[gb + 97484 >> 2] = fb + 192;
 HEAP32[gb + 97488 >> 2] = fb + 1366;
 HEAP32[gb + 97492 >> 2] = fb + 85;
 HEAP32[gb + 97496 >> 2] = fb + 86;
 HEAP32[gb + 97500 >> 2] = fb + 87;
 HEAP32[gb + 97504 >> 2] = fb + 39;
 HEAP32[gb + 97508 >> 2] = fb + 120;
 HEAP32[gb + 97512 >> 2] = fb + 95;
 HEAP32[gb + 97516 >> 2] = fb + 1049;
 HEAP32[gb + 97520 >> 2] = fb + 1050;
 HEAP32[gb + 97524 >> 2] = fb + 193;
 HEAP32[gb + 97528 >> 2] = fb + 18;
 HEAP32[gb + 97532 >> 2] = fb + 121;
 HEAP32[gb + 97536 >> 2] = fb + 96;
 HEAP32[gb + 97540 >> 2] = fb + 122;
 HEAP32[gb + 97544 >> 2] = fb + 97;
 HEAP32[gb + 97548 >> 2] = fb + 123;
 HEAP32[gb + 97552 >> 2] = fb + 98;
 HEAP32[gb + 97556 >> 2] = fb + 124;
 HEAP32[gb + 97560 >> 2] = fb + 99;
 HEAP32[gb + 97564 >> 2] = fb + 1051;
 HEAP32[gb + 97568 >> 2] = fb + 1052;
 HEAP32[gb + 97572 >> 2] = fb + 1367;
 HEAP32[gb + 97576 >> 2] = fb + 194;
 HEAP32[gb + 97580 >> 2] = fb + 676;
 HEAP32[gb + 97584 >> 2] = fb + 677;
 HEAP32[gb + 97588 >> 2] = fb + 125;
 HEAP32[gb + 97592 >> 2] = fb + 100;
 HEAP32[gb + 97596 >> 2] = fb + 126;
 HEAP32[gb + 97600 >> 2] = fb + 101;
 HEAP32[gb + 97604 >> 2] = fb + 127;
 HEAP32[gb + 97608 >> 2] = fb + 102;
 HEAP32[gb + 97612 >> 2] = fb + 128;
 HEAP32[gb + 97616 >> 2] = fb + 103;
 HEAP32[gb + 97620 >> 2] = fb + 678;
 HEAP32[gb + 97624 >> 2] = fb + 196;
 HEAP32[gb + 97628 >> 2] = fb + 1055;
 HEAP32[gb + 97632 >> 2] = fb + 1054;
 HEAP32[gb + 97636 >> 2] = fb + 1056;
 HEAP32[gb + 97648 >> 2] = fb + 1370;
 HEAP32[gb + 97652 >> 2] = fb + 666;
 HEAP32[gb + 97656 >> 2] = fb + 456;
 HEAP32[gb + 97660 >> 2] = fb + 1371;
 HEAP32[gb + 97664 >> 2] = fb + 1372;
 HEAP32[gb + 97668 >> 2] = fb + 300;
 HEAP32[gb + 97672 >> 2] = fb + 1;
 HEAP32[gb + 97676 >> 2] = fb + 668;
 HEAP32[gb + 97680 >> 2] = fb + 1044;
 HEAP32[gb + 97684 >> 2] = fb + 669;
 HEAP32[gb + 97688 >> 2] = fb + 1;
 HEAP32[gb + 97692 >> 2] = fb + 191;
 HEAP32[gb + 97696 >> 2] = fb + 1045;
 HEAP32[gb + 97700 >> 2] = fb + 670;
 HEAP32[gb + 97704 >> 2] = fb + 1046;
 HEAP32[gb + 97708 >> 2] = fb + 671;
 HEAP32[gb + 97712 >> 2] = fb + 1047;
 HEAP32[gb + 97716 >> 2] = fb + 672;
 HEAP32[gb + 97720 >> 2] = fb + 1048;
 HEAP32[gb + 97724 >> 2] = fb + 673;
 HEAP32[gb + 97728 >> 2] = fb + 674;
 HEAP32[gb + 97732 >> 2] = fb + 1;
 HEAP32[gb + 97736 >> 2] = fb + 1;
 HEAP32[gb + 97740 >> 2] = fb + 1;
 HEAP32[gb + 97744 >> 2] = fb + 1;
 HEAP32[gb + 97748 >> 2] = fb + 1;
 HEAP32[gb + 97752 >> 2] = fb + 1;
 HEAP32[gb + 97756 >> 2] = fb + 1;
 HEAP32[gb + 97760 >> 2] = fb + 1;
 HEAP32[gb + 97764 >> 2] = fb + 1;
 HEAP32[gb + 97768 >> 2] = fb + 1;
 HEAP32[gb + 97772 >> 2] = fb + 1;
 HEAP32[gb + 97776 >> 2] = fb + 1;
 HEAP32[gb + 97780 >> 2] = fb + 1;
 HEAP32[gb + 97784 >> 2] = fb + 1;
 HEAP32[gb + 97788 >> 2] = fb + 1;
 HEAP32[gb + 97792 >> 2] = fb + 1;
 HEAP32[gb + 97796 >> 2] = fb + 1;
 HEAP32[gb + 97800 >> 2] = fb + 1;
 HEAP32[gb + 97804 >> 2] = fb + 1;
 HEAP32[gb + 97808 >> 2] = fb + 1;
 HEAP32[gb + 97812 >> 2] = fb + 1;
 HEAP32[gb + 97816 >> 2] = fb + 1;
 HEAP32[gb + 97820 >> 2] = fb + 1;
 HEAP32[gb + 97824 >> 2] = fb + 1;
 HEAP32[gb + 97828 >> 2] = fb + 1;
 HEAP32[gb + 97832 >> 2] = fb + 1;
 HEAP32[gb + 97836 >> 2] = fb + 1;
 HEAP32[gb + 97840 >> 2] = fb + 1;
 HEAP32[gb + 97844 >> 2] = fb + 1;
 HEAP32[gb + 97848 >> 2] = fb + 1;
 HEAP32[gb + 97852 >> 2] = fb + 1;
 HEAP32[gb + 97856 >> 2] = fb + 1;
 HEAP32[gb + 97860 >> 2] = fb + 1;
 HEAP32[gb + 97864 >> 2] = fb + 1;
 HEAP32[gb + 97868 >> 2] = fb + 1;
 HEAP32[gb + 97872 >> 2] = fb + 1;
 HEAP32[gb + 97876 >> 2] = fb + 1;
 HEAP32[gb + 97880 >> 2] = fb + 1;
 HEAP32[gb + 97884 >> 2] = fb + 1;
 runPostSets104();
}

function __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i21, i3, i1, i23, i22) {
 i21 = i21 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i23 = i23 | 0;
 i22 = i22 | 0;
 var i2 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i24 = 0, f25 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i24;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i19 = i3 + 96 | 0;
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 i20 = i3 + 100 | 0;
 f9 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 i12 = i3 + 104 | 0;
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i3 + 112 | 0;
 f10 = Math_fround(f4 * Math_fround(HEAPF32[i13 >> 2]));
 i14 = i3 + 116 | 0;
 f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 i15 = i3 + 120 | 0;
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2])));
 i16 = i3 + 128 | 0;
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2]));
 i17 = i3 + 132 | 0;
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 i18 = i3 + 136 | 0;
 f11 = Math_fround(f6 + Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2])));
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f10;
 HEAPF32[i2 + 8 >> 2] = f11;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f9);
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f10));
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f11));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f25 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f25 * f9) + Math_fround(f4 * f10)) + Math_fround(Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]) * f11));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i2) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 HEAP32[i22 >> 2] = i2;
 f6 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f25 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f10 = Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f25 * Math_fround(HEAPF32[i16 >> 2])));
 f11 = Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f25 * Math_fround(HEAPF32[i17 >> 2])));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2]));
 f9 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2])));
 f25 = Math_fround(f9 + Math_fround(f25 * Math_fround(HEAPF32[i18 >> 2])));
 HEAPF32[i21 >> 2] = f10;
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f25;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i23 + 12 >> 2] = HEAP32[i21 + 12 >> 2];
 STACKTOP = i24;
 return;
}

function __ZN20ArchiveStorageReader20FillChunkCachedBlockEPNS_11CachedBlockE(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 8 | 0;
 i13 = i16;
 i14 = i16 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i6 = i11 + 104 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = (HEAPU16[i3 + (i2 * 12 | 0) + 8 >> 1] | 0) & 63;
 i5 = i11 + 2392 + (i4 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = gb + 63552 | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i13;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  i1 = __Z18CreateDecompressor15CompressionType10MemLabelId(i4, i15) | 0;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (!i1) if (!(HEAP16[i3 + (i2 * 12 | 0) + 8 >> 1] & 63)) {
   i1 = 0;
   i5 = 1;
  } else {
   i15 = -1;
   STACKTOP = i16;
   return i15 | 0;
  } else i5 = 0;
 } else i5 = 0;
 i9 = (HEAP32[i11 + 156 >> 2] | 0) + (i2 << 3) | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i10 = HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
 i7 = i12 + 8 | 0;
 i2 = i12 + 20 | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i12 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i6, 1, i12 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 1, i12 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i7 >> 2] = i4;
  break;
 } while (0);
 do if (i5 | (i10 | 0) == (i6 | 0)) if (__ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy(i11, i8, i9, i10, 0, HEAP32[i7 >> 2] | 0, i15) | 0) {
  if ((HEAP32[i15 + 4 >> 2] | 0) == 0 ? (HEAP32[i15 >> 2] | 0) == (i10 | 0) : 0) break; else i1 = 1;
  STACKTOP = i16;
  return i1 | 0;
 } else {
  i15 = -2;
  STACKTOP = i16;
  return i15 | 0;
 } else {
  i5 = i12 + 44 | 0;
  i2 = i12 + 56 | 0;
  HEAP32[i2 >> 2] = i10;
  i3 = i12 + 60 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i10 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i10;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i10, 1, i12 + 48 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i2;
   i3 = i5;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 1, i12 + 48 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i5 >> 2] = i4;
   i3 = i5;
   i2 = i4;
   break;
  } else {
   i3 = i5;
   i2 = HEAP32[i5 >> 2] | 0;
  } while (0);
  if (__ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy(i11, i8, i9, i10, 0, i2, i15) | 0) if ((HEAP32[i15 + 4 >> 2] | 0) == 0 ? (HEAP32[i15 >> 2] | 0) == (i10 | 0) : 0) {
   HEAP32[i13 >> 2] = i10;
   HEAP32[i14 >> 2] = i6;
   i15 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, i13 | 0, HEAP32[i7 >> 2] | 0, i14 | 0) | 0;
   if (i15 & (HEAP32[i14 >> 2] | 0) == (i6 | 0)) break; else i1 = -1;
  } else i1 = 1; else i1 = -2;
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 } while (0);
 HEAP32[i12 + 4 >> 2] = 0;
 i15 = 0;
 STACKTOP = i16;
 return i15 | 0;
}

function runPostSets94() {
 HEAP32[gb + 93684 >> 2] = fb + 1321;
 HEAP32[gb + 93688 >> 2] = fb + 1322;
 HEAP32[gb + 93692 >> 2] = fb + 1323;
 HEAP32[gb + 93704 >> 2] = fb + 1;
 HEAP32[gb + 93708 >> 2] = fb + 614;
 HEAP32[gb + 93712 >> 2] = fb + 456;
 HEAP32[gb + 93716 >> 2] = fb + 1270;
 HEAP32[gb + 93720 >> 2] = fb + 1324;
 HEAP32[gb + 93724 >> 2] = fb + 277;
 HEAP32[gb + 93728 >> 2] = fb + 1;
 HEAP32[gb + 93732 >> 2] = fb + 1;
 HEAP32[gb + 93736 >> 2] = fb + 1;
 HEAP32[gb + 93740 >> 2] = fb + 1;
 HEAP32[gb + 93744 >> 2] = fb + 1;
 HEAP32[gb + 93748 >> 2] = fb + 1;
 HEAP32[gb + 93752 >> 2] = fb + 1;
 HEAP32[gb + 93756 >> 2] = fb + 1;
 HEAP32[gb + 93760 >> 2] = fb + 1;
 HEAP32[gb + 93764 >> 2] = fb + 1;
 HEAP32[gb + 93768 >> 2] = fb + 1;
 HEAP32[gb + 93772 >> 2] = fb + 1;
 HEAP32[gb + 93776 >> 2] = fb + 1;
 HEAP32[gb + 93780 >> 2] = fb + 1;
 HEAP32[gb + 93784 >> 2] = fb + 1;
 HEAP32[gb + 93788 >> 2] = fb + 1;
 HEAP32[gb + 93792 >> 2] = fb + 1;
 HEAP32[gb + 93796 >> 2] = fb + 1;
 HEAP32[gb + 93800 >> 2] = fb + 1;
 HEAP32[gb + 93804 >> 2] = fb + 1;
 HEAP32[gb + 93808 >> 2] = fb + 1;
 HEAP32[gb + 93812 >> 2] = fb + 1;
 HEAP32[gb + 93816 >> 2] = fb + 1;
 HEAP32[gb + 93820 >> 2] = fb + 1;
 HEAP32[gb + 93824 >> 2] = fb + 1;
 HEAP32[gb + 93828 >> 2] = fb + 1;
 HEAP32[gb + 93832 >> 2] = fb + 1;
 HEAP32[gb + 93836 >> 2] = fb + 1;
 HEAP32[gb + 93840 >> 2] = fb + 1;
 HEAP32[gb + 93844 >> 2] = fb + 1;
 HEAP32[gb + 93848 >> 2] = fb + 1;
 HEAP32[gb + 93852 >> 2] = fb + 1;
 HEAP32[gb + 93864 >> 2] = fb + 1325;
 HEAP32[gb + 93868 >> 2] = fb + 614;
 HEAP32[gb + 93872 >> 2] = fb + 456;
 HEAP32[gb + 93876 >> 2] = fb + 1326;
 HEAP32[gb + 93880 >> 2] = fb + 1327;
 HEAP32[gb + 93884 >> 2] = fb + 277;
 HEAP32[gb + 93888 >> 2] = fb + 615;
 HEAP32[gb + 93892 >> 2] = fb + 968;
 HEAP32[gb + 93896 >> 2] = fb + 969;
 HEAP32[gb + 93900 >> 2] = fb + 278;
 HEAP32[gb + 93904 >> 2] = fb + 279;
 HEAP32[gb + 93908 >> 2] = fb + 280;
 HEAP32[gb + 93912 >> 2] = fb + 281;
 HEAP32[gb + 93916 >> 2] = fb + 282;
 HEAP32[gb + 93920 >> 2] = fb + 283;
 HEAP32[gb + 93924 >> 2] = fb + 284;
 HEAP32[gb + 93928 >> 2] = fb + 616;
 HEAP32[gb + 93932 >> 2] = fb + 970;
 HEAP32[gb + 93936 >> 2] = fb + 971;
 HEAP32[gb + 93940 >> 2] = fb + 972;
 HEAP32[gb + 93944 >> 2] = fb + 973;
 HEAP32[gb + 93948 >> 2] = fb + 1328;
 HEAP32[gb + 93952 >> 2] = fb + 974;
 HEAP32[gb + 93956 >> 2] = fb + 975;
 HEAP32[gb + 93960 >> 2] = fb + 171;
 HEAP32[gb + 93964 >> 2] = fb + 617;
 HEAP32[gb + 93968 >> 2] = fb + 153;
 HEAP32[gb + 93972 >> 2] = fb + 285;
 HEAP32[gb + 93976 >> 2] = fb + 69;
 HEAP32[gb + 93980 >> 2] = fb + 95;
 HEAP32[gb + 93984 >> 2] = fb + 70;
 HEAP32[gb + 93988 >> 2] = fb + 96;
 HEAP32[gb + 93992 >> 2] = fb + 172;
 HEAP32[gb + 93996 >> 2] = fb + 976;
 HEAP32[gb + 94e3 >> 2] = fb + 618;
 HEAP32[gb + 94004 >> 2] = fb + 619;
 HEAP32[gb + 94008 >> 2] = fb + 977;
 HEAP32[gb + 94012 >> 2] = fb + 620;
 HEAP32[gb + 94016 >> 2] = fb + 978;
 HEAP32[gb + 94020 >> 2] = fb + 979;
 HEAP32[gb + 94024 >> 2] = fb + 1329;
 HEAP32[gb + 94028 >> 2] = fb + 173;
 HEAP32[gb + 94040 >> 2] = fb + 1330;
 HEAP32[gb + 94044 >> 2] = fb + 1331;
 HEAP32[gb + 94048 >> 2] = fb + 1332;
 HEAP32[gb + 94108 >> 2] = fb + 1;
 HEAP32[gb + 94112 >> 2] = fb + 621;
 HEAP32[gb + 94116 >> 2] = fb + 456;
 HEAP32[gb + 94120 >> 2] = fb + 1270;
 HEAP32[gb + 94124 >> 2] = fb + 1333;
 HEAP32[gb + 94128 >> 2] = fb + 286;
 HEAP32[gb + 94132 >> 2] = fb + 1;
 HEAP32[gb + 94136 >> 2] = fb + 1;
 HEAP32[gb + 94140 >> 2] = fb + 1;
 HEAP32[gb + 94144 >> 2] = fb + 1;
 HEAP32[gb + 94148 >> 2] = fb + 1;
 HEAP32[gb + 94152 >> 2] = fb + 1;
 HEAP32[gb + 94156 >> 2] = fb + 1;
 HEAP32[gb + 94160 >> 2] = fb + 1;
 runPostSets95();
}

function runPostSets71() {
 HEAP32[gb + 77832 >> 2] = fb + 56;
 HEAP32[gb + 77836 >> 2] = fb + 192;
 HEAP32[gb + 77840 >> 2] = fb + 724;
 HEAP32[gb + 77844 >> 2] = fb + 725;
 HEAP32[gb + 77848 >> 2] = fb + 7;
 HEAP32[gb + 77852 >> 2] = fb + 412;
 HEAP32[gb + 77856 >> 2] = fb + 413;
 HEAP32[gb + 77860 >> 2] = fb + 8;
 HEAP32[gb + 77864 >> 2] = fb + 50;
 HEAP32[gb + 77868 >> 2] = fb + 79;
 HEAP32[gb + 77872 >> 2] = fb + 726;
 HEAP32[gb + 77876 >> 2] = fb + 193;
 HEAP32[gb + 77880 >> 2] = fb + 1;
 HEAP32[gb + 77884 >> 2] = fb + 8;
 HEAP32[gb + 77888 >> 2] = fb + 2;
 HEAP32[gb + 77892 >> 2] = fb + 270;
 HEAP32[gb + 77896 >> 2] = fb + 282;
 HEAP32[gb + 77900 >> 2] = fb + 283;
 HEAP32[gb + 77904 >> 2] = fb + 3;
 HEAP32[gb + 77908 >> 2] = fb + 2;
 HEAP32[gb + 77912 >> 2] = fb + 3;
 HEAP32[gb + 77916 >> 2] = fb + 271;
 HEAP32[gb + 77920 >> 2] = fb + 284;
 HEAP32[gb + 77924 >> 2] = fb + 272;
 HEAP32[gb + 77928 >> 2] = fb + 273;
 HEAP32[gb + 77932 >> 2] = fb + 274;
 HEAP32[gb + 77936 >> 2] = fb + 159;
 HEAP32[gb + 77940 >> 2] = fb + 275;
 HEAP32[gb + 77944 >> 2] = fb + 9;
 HEAP32[gb + 77948 >> 2] = fb + 1;
 HEAP32[gb + 77952 >> 2] = fb + 1;
 HEAP32[gb + 77956 >> 2] = fb + 3;
 HEAP32[gb + 77960 >> 2] = fb + 276;
 HEAP32[gb + 77964 >> 2] = fb + 80;
 HEAP32[gb + 77968 >> 2] = fb + 16;
 HEAP32[gb + 77972 >> 2] = fb + 727;
 HEAP32[gb + 77976 >> 2] = fb + 285;
 HEAP32[gb + 77980 >> 2] = fb + 277;
 HEAP32[gb + 77984 >> 2] = fb + 194;
 HEAP32[gb + 77988 >> 2] = fb + 414;
 HEAP32[gb + 77992 >> 2] = fb + 415;
 HEAP32[gb + 77996 >> 2] = fb + 160;
 HEAP32[gb + 78e3 >> 2] = fb + 161;
 HEAP32[gb + 78004 >> 2] = fb + 162;
 HEAP32[gb + 78008 >> 2] = fb + 163;
 HEAP32[gb + 78012 >> 2] = fb + 17;
 HEAP32[gb + 78016 >> 2] = fb + 195;
 HEAP32[gb + 78020 >> 2] = fb + 59;
 HEAP32[gb + 78024 >> 2] = fb + 278;
 HEAP32[gb + 78028 >> 2] = fb + 99;
 HEAP32[gb + 78032 >> 2] = fb + 100;
 HEAP32[gb + 78036 >> 2] = fb + 728;
 HEAP32[gb + 78040 >> 2] = fb + 18;
 HEAP32[gb + 78044 >> 2] = fb + 19;
 HEAP32[gb + 78048 >> 2] = fb + 4;
 HEAP32[gb + 78052 >> 2] = fb + 57;
 HEAP32[gb + 78056 >> 2] = fb + 164;
 HEAP32[gb + 78060 >> 2] = fb + 279;
 HEAP32[gb + 78064 >> 2] = fb + 10;
 HEAP32[gb + 78068 >> 2] = fb + 280;
 HEAP32[gb + 78072 >> 2] = fb + 2;
 HEAP32[gb + 78076 >> 2] = fb + 4;
 HEAP32[gb + 78080 >> 2] = fb + 5;
 HEAP32[gb + 78084 >> 2] = fb + 6;
 HEAP32[gb + 78088 >> 2] = fb + 729;
 HEAP32[gb + 78092 >> 2] = fb + 1;
 HEAP32[gb + 78096 >> 2] = fb + 1;
 HEAP32[gb + 78100 >> 2] = fb + 281;
 HEAP32[gb + 78104 >> 2] = fb + 20;
 HEAP32[gb + 78108 >> 2] = fb + 2;
 HEAP32[gb + 78112 >> 2] = fb + 1;
 HEAP32[gb + 78116 >> 2] = fb + 4;
 HEAP32[gb + 78120 >> 2] = fb + 5;
 HEAP32[gb + 78124 >> 2] = fb + 416;
 HEAP32[gb + 78128 >> 2] = fb + 286;
 HEAP32[gb + 78132 >> 2] = fb + 892;
 HEAP32[gb + 78136 >> 2] = fb + 893;
 HEAP32[gb + 78140 >> 2] = fb + 894;
 HEAP32[gb + 78144 >> 2] = fb + 282;
 HEAP32[gb + 78148 >> 2] = fb + 283;
 HEAP32[gb + 78152 >> 2] = fb + 417;
 HEAP32[gb + 78156 >> 2] = fb + 165;
 HEAP32[gb + 78160 >> 2] = fb + 287;
 HEAP32[gb + 78164 >> 2] = fb + 288;
 HEAP32[gb + 78168 >> 2] = fb + 895;
 HEAP32[gb + 78172 >> 2] = fb + 166;
 HEAP32[gb + 78176 >> 2] = fb + 167;
 HEAP32[gb + 78180 >> 2] = fb + 284;
 HEAP32[gb + 78184 >> 2] = fb + 289;
 HEAP32[gb + 78188 >> 2] = fb + 290;
 HEAP32[gb + 78192 >> 2] = fb + 1;
 HEAP32[gb + 78196 >> 2] = fb + 4;
 HEAP32[gb + 78200 >> 2] = fb + 5;
 HEAP32[gb + 78204 >> 2] = fb + 4;
 HEAP32[gb + 78208 >> 2] = fb + 6;
 HEAP32[gb + 78212 >> 2] = fb + 2;
 HEAP32[gb + 78216 >> 2] = fb + 81;
 HEAP32[gb + 78220 >> 2] = fb + 896;
 HEAP32[gb + 78224 >> 2] = fb + 168;
 HEAP32[gb + 78228 >> 2] = fb + 26;
 runPostSets72();
}

function __ZNSt3__218__insertion_sort_3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i2 = i11 + 40 | 0;
 __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_(i11, i11 + 20 | 0, i2, i1) | 0;
 i1 = i11 + 60 | 0;
 if ((i1 | 0) == (i12 | 0)) {
  STACKTOP = i14;
  return;
 }
 while (1) {
  i9 = HEAP32[i1 + 16 >> 2] | 0;
  i8 = i9 & 255;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i4 = i3 & 255;
  i7 = (i9 & 65535) >>> 8 & 255;
  i5 = (i3 & 65535) >>> 8 & 255;
  do if (i8 << 24 >> 24 == i4 << 24 >> 24) if (i7 << 24 >> 24 == i5 << 24 >> 24) if ((i9 & 65536 | 0) == 0 & (i3 & 65536 | 0) != 0) {
   i13 = 8;
   break;
  } else break; else if ((i7 & 255) < (i5 & 255)) {
   i13 = 8;
   break;
  } else break; else if ((i8 & 255) < (i4 & 255)) i13 = 8; while (0);
  if ((i13 | 0) == 8) {
   i13 = 0;
   HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP16[i1 + 16 >> 1] = HEAP16[i2 + 16 >> 1] | 0;
   HEAP8[i1 + 18 >> 0] = HEAP8[i2 + 18 >> 0] | 0;
   L13 : do if ((i2 | 0) == (i11 | 0)) i3 = i11; else {
    if (i9 & 65536) while (1) {
     i5 = i2 + -20 | 0;
     i3 = HEAP32[i2 + -4 >> 2] | 0;
     i4 = i3 & 255;
     if (i8 << 24 >> 24 == i4 << 24 >> 24) {
      if ((i7 & 255) >= ((i3 & 65535) >>> 8 & 255)) {
       i3 = i2;
       break L13;
      }
     } else if ((i8 & 255) >= (i4 & 255)) {
      i3 = i2;
      break L13;
     };
     HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     HEAP16[i2 + 16 >> 1] = HEAP16[i5 + 16 >> 1] | 0;
     HEAP8[i2 + 18 >> 0] = HEAP8[i5 + 18 >> 0] | 0;
     if ((i5 | 0) == (i11 | 0)) {
      i3 = i11;
      i2 = i5;
      break L13;
     } else i2 = i5;
    }
    while (1) {
     i6 = i2 + -20 | 0;
     i3 = HEAP32[i2 + -4 >> 2] | 0;
     i4 = i3 & 255;
     i5 = (i3 & 65535) >>> 8 & 255;
     do if (i8 << 24 >> 24 == i4 << 24 >> 24) if (i7 << 24 >> 24 == i5 << 24 >> 24) if (!(i3 & 65536)) {
      i3 = i2;
      break L13;
     } else break; else if ((i7 & 255) < (i5 & 255)) break; else {
      i3 = i2;
      break L13;
     } else if ((i8 & 255) >= (i4 & 255)) {
      i3 = i2;
      break L13;
     } while (0);
     HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
     HEAP16[i2 + 16 >> 1] = HEAP16[i6 + 16 >> 1] | 0;
     HEAP8[i2 + 18 >> 0] = HEAP8[i6 + 18 >> 0] | 0;
     if ((i6 | 0) == (i11 | 0)) {
      i3 = i11;
      i2 = i6;
      break;
     } else i2 = i6;
    }
   } while (0);
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i8 = i3 + 16 | 0;
   HEAP16[i8 >> 1] = i9;
   HEAP8[i8 + 2 >> 0] = i9 >>> 16;
  }
  i2 = i1 + 20 | 0;
  if ((i2 | 0) == (i12 | 0)) break; else {
   i9 = i1;
   i1 = i2;
   i2 = i9;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN2UI6CanvasC2E10MemLabelId18ObjectCreationMode(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i9 = i8;
 i11 = i1;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i7, i6, i2);
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP8[i7 + 32 >> 0] = 1;
 HEAP8[i7 + 33 >> 0] = 0;
 HEAP32[i7 >> 2] = gb + 186552 + 8;
 HEAP32[i7 + 36 >> 2] = 2;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP8[i7 + 44 >> 0] = 1;
 HEAP32[i7 + 176 >> 2] = 0;
 HEAP32[i7 + 188 >> 2] = 0;
 HEAP32[i7 + 192 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = i6;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i7 + 180 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i7 + 196 >> 2] = 0;
 HEAP32[i7 + 208 >> 2] = 0;
 HEAP32[i7 + 212 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i9 = i6;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7 + 200 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i7 + 228 >> 2] = 0;
 HEAP32[i7 + 240 >> 2] = 0;
 HEAP32[i7 + 244 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = i6;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i7 + 232 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i7 + 248 >> 2] = 0;
 HEAP32[i7 + 260 >> 2] = 0;
 HEAP32[i7 + 264 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i9 = i6;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7 + 252 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i7 + 268 >> 2] = 0;
 HEAP32[i7 + 280 >> 2] = 0;
 HEAP32[i7 + 284 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i7 + 272 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i7 + 288 >> 2] = 0;
 i1 = i7 + 292 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f3 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i7 + 304 >> 2] = f3;
 HEAPF32[i7 + 308 >> 2] = f4;
 HEAPF32[i7 + 312 >> 2] = f5;
 i1 = i7 + 352 | 0;
 i2 = i7 + 316 | 0;
 i6 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 356 >> 2] = Math_fround(100.0);
 HEAP8[i7 + 360 >> 0] = 0;
 HEAP8[i7 + 361 >> 0] = 0;
 HEAP8[i7 + 362 >> 0] = 1;
 HEAPF32[i7 + 364 >> 2] = Math_fround(100.0);
 i11 = i7 + 376 | 0;
 i10 = i7 + 368 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i7 + 388 >> 2] = f3;
 HEAPF32[i7 + 392 >> 2] = f4;
 HEAPF32[i7 + 396 >> 2] = f5;
 HEAP8[i7 + 400 >> 0] = 1;
 HEAPF32[i7 + 404 >> 2] = Math_fround(0.0);
 HEAP16[i7 + 420 >> 1] = 0;
 HEAP32[i7 + 424 >> 2] = 0;
 HEAP32[i7 + 428 >> 2] = 0;
 HEAP32[i7 + 432 >> 2] = 0;
 i11 = i7 + 436 | 0;
 HEAP32[i11 >> 2] = i11;
 HEAP32[i7 + 440 >> 2] = i11;
 HEAP8[i7 + 413 >> 0] = 0;
 HEAP8[i7 + 412 >> 0] = 0;
 HEAP32[i7 + 408 >> 2] = 1120403456;
 HEAP32[i7 + 416 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2588;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI19StreamedBinaryWriteILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI19StreamedBinaryWriteILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZNK5physx2Gu18ConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVE(i21, i3, i1, i20) {
 i21 = i21 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 var i2 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i22;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i20 >> 2]));
 i19 = i20 + 4 | 0;
 f9 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2])));
 i12 = i20 + 8 | 0;
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i20 + 16 | 0;
 f10 = Math_fround(f4 * Math_fround(HEAPF32[i13 >> 2]));
 i14 = i20 + 20 | 0;
 f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 i15 = i20 + 24 | 0;
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2])));
 i16 = i20 + 32 | 0;
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2]));
 i17 = i20 + 36 | 0;
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 i18 = i20 + 40 | 0;
 f11 = Math_fround(f6 + Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2])));
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f10;
 HEAPF32[i2 + 8 >> 2] = f11;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f9);
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f10));
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f11));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f23 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f23 * f9) + Math_fround(f4 * f10)) + Math_fround(Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]) * f11));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i2) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 f25 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f6 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i20 + 48 >> 2]);
 f24 = Math_fround(HEAPF32[i20 + 52 >> 2]);
 f4 = Math_fround(HEAPF32[i20 + 56 >> 2]);
 f10 = Math_fround(f25 * Math_fround(HEAPF32[i20 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f23 * Math_fround(HEAPF32[i16 >> 2])));
 f11 = Math_fround(f25 * Math_fround(HEAPF32[i19 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f23 * Math_fround(HEAPF32[i17 >> 2])));
 f25 = Math_fround(f25 * Math_fround(HEAPF32[i12 >> 2]));
 f6 = Math_fround(f25 + Math_fround(f6 * Math_fround(HEAPF32[i15 >> 2])));
 f11 = Math_fround(f24 + f11);
 f23 = Math_fround(f4 + Math_fround(f6 + Math_fround(f23 * Math_fround(HEAPF32[i18 >> 2]))));
 HEAPF32[i21 >> 2] = Math_fround(f9 + f10);
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f23;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i22;
 return;
}

function __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb(i8, i9, i3, i12, i13) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i14 = i15;
 i2 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i2) {
  __ZNK6Camera13GetCameraRectEb(i1, i8, 1);
  __Z14RectfToRectIntRK5RectTIfE(i14, i1);
  i6 = i14 + 8 | 0;
  i7 = i14 + 12 | 0;
  i10 = i7;
  i11 = i6;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 + 80 >> 2] | 0;
  i7 = HEAP32[i2 + 84 >> 2] | 0;
  HEAP32[i14 >> 2] = 0;
  i11 = i14 + 8 | 0;
  HEAP32[i11 >> 2] = i6;
  HEAP32[i14 + 4 >> 2] = 0;
  i10 = i14 + 12 | 0;
  HEAP32[i10 >> 2] = i7;
 }
 HEAP8[i13 >> 0] = 0;
 i5 = __Z22GetRenderBufferManagerv() | 0;
 L5 : do if (i3) {
  i1 = HEAP32[gb + 1166496 >> 2] | 0;
  if (i1 | 0) {
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i5, i1);
   HEAP32[gb + 1166496 >> 2] = 0;
  }
  i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i5, i6, i7, 0, HEAP8[i8 + 1092 >> 0] | 0 ? 9 : 7, 0, 0, 0, 1) | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 480376 | 0);
  HEAP32[gb + 1166496 >> 2] = i1;
 } else {
  i2 = HEAP32[gb + 1166496 + 16 >> 2] | 0;
  L14 : do if ((i2 | 0) > 0) {
   i3 = HEAP32[gb + 1166496 + 4 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i4 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) break L14;
   }
   i1 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   HEAP8[i13 >> 0] = 1;
   if (i1 | 0) break L5;
  } while (0);
  i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i5, i6, i7, 0, HEAP8[i8 + 1092 >> 0] | 0 ? 9 : 7, 0, 0, 0, 1) | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 480376 | 0);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i1;
  i5 = HEAP32[gb + 1166496 + 16 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = HEAP32[gb + 1166496 + 20 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i6 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[gb + 1166496 + 20 >> 2] = i2;
    i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1166496 + 4 >> 2] | 0, i2 << 3, 4, gb + 1166496 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[gb + 1166496 + 4 >> 2] = i9;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, gb + 1166496 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[gb + 1166496 + 4 >> 2] | 0, HEAP32[gb + 1166496 + 16 >> 2] << 3 | 0) | 0;
    HEAP32[gb + 1166496 + 20 >> 2] = i2;
    HEAP32[gb + 1166496 + 4 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[gb + 1166496 + 16 >> 2] = i6;
  i9 = (HEAP32[gb + 1166496 + 4 >> 2] | 0) + (i5 << 3) | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = i4;
 } while (0);
 if (!((i1 | 0) != 0 & (HEAP8[i13 >> 0] | 0) == 0)) {
  STACKTOP = i15;
  return i1 | 0;
 }
 __ZN13RenderTexture6CreateEv(i1) | 0;
 __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, 0);
 if (i12) __ZN13RenderTexture10GrabPixelsEiiii(i1, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 __ZN7Texture13SetFilterModeEi(i1, 1);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN5physx2Gu19computePlane_BoxMTDERKNS_7PxPlaneERKNS0_3BoxERNS_10PxSweepHitE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i8, i1 + 36 | 0, i1 + 48 | 0, i1, i1 + 12 | 0, i1 + 24 | 0);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f5 * f18);
 f17 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 i10 = i3 + 4 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f17 = Math_fround(f5 + Math_fround(f17 * f6));
 f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i9 = i3 + 8 | 0;
 f7 = Math_fround(HEAPF32[i9 >> 2]);
 f5 = Math_fround(f17 + Math_fround(f5 * f7));
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f17 + f5);
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 12 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 20 >> 2]) * f7)));
 i1 = f5 > f19;
 f5 = i1 ? f19 : f5;
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 28 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 32 >> 2]) * f7)));
 i12 = f5 > f19;
 f5 = i12 ? f19 : f5;
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 36 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 40 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 44 >> 2]) * f7)));
 i13 = f5 > f19;
 f5 = i13 ? f19 : f5;
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 56 >> 2]) * f7)));
 i14 = f5 > f19;
 f5 = i14 ? f19 : f5;
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 60 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 64 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 68 >> 2]) * f7)));
 i15 = f5 > f19;
 f5 = i15 ? f19 : f5;
 f19 = Math_fround(Math_fround(HEAPF32[i8 + 72 >> 2]) * f18);
 f19 = Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 76 >> 2]) * f6));
 f19 = Math_fround(f17 + Math_fround(f19 + Math_fround(Math_fround(HEAPF32[i8 + 80 >> 2]) * f7)));
 i16 = f5 > f19;
 f5 = i16 ? f19 : f5;
 f18 = Math_fround(Math_fround(HEAPF32[i8 + 84 >> 2]) * f18);
 f6 = Math_fround(f18 + Math_fround(Math_fround(HEAPF32[i8 + 88 >> 2]) * f6));
 f7 = Math_fround(f17 + Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i8 + 92 >> 2]) * f7)));
 i11 = f5 > f7;
 i1 = i11 ? 7 : i16 ? 6 : i15 ? 5 : i14 ? 4 : i13 ? 3 : i12 ? 2 : i1 & 1;
 f5 = i11 ? f7 : f5;
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i9 >> 2];
 HEAPF32[i2 + 40 >> 2] = f5;
 f7 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i10 >> 2]));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2]));
 f7 = Math_fround(Math_fround(HEAPF32[i8 + (i1 * 12 | 0) >> 2]) - f7);
 f6 = Math_fround(Math_fround(HEAPF32[i8 + (i1 * 12 | 0) + 4 >> 2]) - f6);
 f5 = Math_fround(Math_fround(HEAPF32[i8 + (i1 * 12 | 0) + 8 >> 2]) - f5);
 HEAPF32[i2 + 16 >> 2] = f7;
 HEAPF32[i2 + 20 >> 2] = f6;
 HEAPF32[i2 + 24 >> 2] = f5;
 STACKTOP = i4;
 return 1;
}

function __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 i5 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 864119 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 946425 | 0, gb + 801759 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 52 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 800918 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 53 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 800930 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 800947 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN18AsyncUploadManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 1352 | 0;
 __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv(i2);
 i3 = i1 + 1328 | 0;
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i3);
 i4 = i1 + 1340 | 0;
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i4);
 i5 = i1 + 1324 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 | 0) if (HEAP8[i6 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i6 + 8 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63304 | 0);
 HEAP32[i5 >> 2] = 0;
 __Z23DestroyMutexLockedQueueP16MutexLockedQueue(HEAP32[i1 + 36 >> 2] | 0);
 __Z23DestroyMutexLockedQueueP16MutexLockedQueue(HEAP32[i1 + 32 >> 2] | 0);
 __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv(i2);
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i4);
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1284 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1244 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1204 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1164 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1124 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1084 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1044 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 1004 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 964 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 924 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 884 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 844 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 804 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 764 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 724 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 684 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 644 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 604 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 564 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 524 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 484 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 444 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 404 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 364 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 324 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 284 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 244 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 204 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 164 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 124 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 84 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 44 | 0);
 return;
}

function __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN14SafeBinaryRead10SetVersionEi(i9, 2);
 i2 = i8 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 76 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034211 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034225 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i7 = 23; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i8 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034240 | 0, i5, i6, 0) | 0;
 if (!i1) {
  __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i8);
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i6 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 34; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i7 = 34; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 34) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i8);
 STACKTOP = i10;
 return;
}

function runPostSets34() {
 HEAP32[gb + 45148 >> 2] = fb + 32;
 HEAP32[gb + 45152 >> 2] = fb + 28;
 HEAP32[gb + 45156 >> 2] = fb + 63;
 HEAP32[gb + 45160 >> 2] = fb + 29;
 HEAP32[gb + 45164 >> 2] = fb + 34;
 HEAP32[gb + 45168 >> 2] = fb + 375;
 HEAP32[gb + 45172 >> 2] = fb + 376;
 HEAP32[gb + 45176 >> 2] = fb + 377;
 HEAP32[gb + 45180 >> 2] = fb + 378;
 HEAP32[gb + 45184 >> 2] = fb + 379;
 HEAP32[gb + 45188 >> 2] = fb + 380;
 HEAP32[gb + 45192 >> 2] = fb + 36;
 HEAP32[gb + 45196 >> 2] = fb + 20;
 HEAP32[gb + 45200 >> 2] = fb + 35;
 HEAP32[gb + 45204 >> 2] = fb + 36;
 HEAP32[gb + 45208 >> 2] = fb + 37;
 HEAP32[gb + 45212 >> 2] = fb + 37;
 HEAP32[gb + 45216 >> 2] = fb + 38;
 HEAP32[gb + 45220 >> 2] = fb + 39;
 HEAP32[gb + 45224 >> 2] = fb + 40;
 HEAP32[gb + 45228 >> 2] = fb + 41;
 HEAP32[gb + 45232 >> 2] = fb + 42;
 HEAP32[gb + 45236 >> 2] = fb + 43;
 HEAP32[gb + 45240 >> 2] = fb + 234;
 HEAP32[gb + 45244 >> 2] = fb + 235;
 HEAP32[gb + 45248 >> 2] = fb + 46;
 HEAP32[gb + 45252 >> 2] = fb + 236;
 HEAP32[gb + 45256 >> 2] = fb + 48;
 HEAP32[gb + 45260 >> 2] = fb + 237;
 HEAP32[gb + 45264 >> 2] = fb + 381;
 HEAP32[gb + 45268 >> 2] = fb + 398;
 HEAP32[gb + 45272 >> 2] = fb + 11;
 HEAP32[gb + 45284 >> 2] = fb + 399;
 HEAP32[gb + 45288 >> 2] = fb + 400;
 HEAP32[gb + 45292 >> 2] = fb + 401;
 HEAP32[gb + 45296 >> 2] = fb + 382;
 HEAP32[gb + 45300 >> 2] = fb + 16;
 HEAP32[gb + 45304 >> 2] = fb + 39;
 HEAP32[gb + 45308 >> 2] = fb + 40;
 HEAP32[gb + 45312 >> 2] = fb + 19;
 HEAP32[gb + 45316 >> 2] = fb + 238;
 HEAP32[gb + 45320 >> 2] = fb + 31;
 HEAP32[gb + 45324 >> 2] = fb + 27;
 HEAP32[gb + 45328 >> 2] = fb + 62;
 HEAP32[gb + 45332 >> 2] = fb + 28;
 HEAP32[gb + 45336 >> 2] = fb + 63;
 HEAP32[gb + 45340 >> 2] = fb + 29;
 HEAP32[gb + 45344 >> 2] = fb + 34;
 HEAP32[gb + 45348 >> 2] = fb + 383;
 HEAP32[gb + 45352 >> 2] = fb + 384;
 HEAP32[gb + 45356 >> 2] = fb + 385;
 HEAP32[gb + 45360 >> 2] = fb + 386;
 HEAP32[gb + 45364 >> 2] = fb + 387;
 HEAP32[gb + 45368 >> 2] = fb + 388;
 HEAP32[gb + 45372 >> 2] = fb + 36;
 HEAP32[gb + 45384 >> 2] = fb + 402;
 HEAP32[gb + 45388 >> 2] = fb + 403;
 HEAP32[gb + 45400 >> 2] = fb + 390;
 HEAP32[gb + 45404 >> 2] = fb + 404;
 HEAP32[gb + 45408 >> 2] = fb + 405;
 HEAP32[gb + 45412 >> 2] = fb + 39;
 HEAP32[gb + 45416 >> 2] = fb + 16;
 HEAP32[gb + 45420 >> 2] = fb + 17;
 HEAP32[gb + 45424 >> 2] = fb + 18;
 HEAP32[gb + 45428 >> 2] = fb + 19;
 HEAP32[gb + 45432 >> 2] = fb + 228;
 HEAP32[gb + 45436 >> 2] = fb + 31;
 HEAP32[gb + 45440 >> 2] = fb + 27;
 HEAP32[gb + 45444 >> 2] = fb + 32;
 HEAP32[gb + 45448 >> 2] = fb + 28;
 HEAP32[gb + 45452 >> 2] = fb + 63;
 HEAP32[gb + 45456 >> 2] = fb + 29;
 HEAP32[gb + 45460 >> 2] = fb + 34;
 HEAP32[gb + 45464 >> 2] = fb + 30;
 HEAP32[gb + 45468 >> 2] = fb + 31;
 HEAP32[gb + 45472 >> 2] = fb + 32;
 HEAP32[gb + 45476 >> 2] = fb + 33;
 HEAP32[gb + 45480 >> 2] = fb + 34;
 HEAP32[gb + 45484 >> 2] = fb + 35;
 HEAP32[gb + 45488 >> 2] = fb + 36;
 HEAP32[gb + 45492 >> 2] = fb + 20;
 HEAP32[gb + 45496 >> 2] = fb + 35;
 HEAP32[gb + 45500 >> 2] = fb + 36;
 HEAP32[gb + 45504 >> 2] = fb + 37;
 HEAP32[gb + 45508 >> 2] = fb + 37;
 HEAP32[gb + 45512 >> 2] = fb + 38;
 HEAP32[gb + 45516 >> 2] = fb + 39;
 HEAP32[gb + 45520 >> 2] = fb + 40;
 HEAP32[gb + 45524 >> 2] = fb + 41;
 HEAP32[gb + 45528 >> 2] = fb + 42;
 HEAP32[gb + 45532 >> 2] = fb + 43;
 HEAP32[gb + 45536 >> 2] = fb + 1;
 HEAP32[gb + 45540 >> 2] = fb + 1;
 HEAP32[gb + 45544 >> 2] = fb + 46;
 HEAP32[gb + 45548 >> 2] = fb + 1;
 HEAP32[gb + 45552 >> 2] = fb + 48;
 HEAP32[gb + 45556 >> 2] = fb + 1;
 HEAP32[gb + 45560 >> 2] = fb + 1;
 HEAP32[gb + 45564 >> 2] = fb + 1;
 HEAP32[gb + 45568 >> 2] = fb + 1;
 runPostSets35();
}

function __ZN24BuiltinShaderParamValuesC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 2976 >> 2] = 0;
 HEAP32[i1 + 2980 >> 2] = 0;
 HEAP32[i1 + 2984 >> 2] = 1;
 HEAP32[i1 + 2988 >> 2] = 0;
 HEAP32[i1 + 2992 >> 2] = -1;
 HEAP32[i1 + 2996 >> 2] = 0;
 HEAP32[i1 + 3e3 >> 2] = 0;
 HEAP32[i1 + 3004 >> 2] = 1;
 HEAP32[i1 + 3008 >> 2] = 0;
 HEAP32[i1 + 3012 >> 2] = -1;
 HEAP32[i1 + 3016 >> 2] = 0;
 HEAP32[i1 + 3020 >> 2] = 0;
 HEAP32[i1 + 3024 >> 2] = 1;
 HEAP32[i1 + 3028 >> 2] = 0;
 HEAP32[i1 + 3032 >> 2] = -1;
 HEAP32[i1 + 3036 >> 2] = 0;
 HEAP32[i1 + 3040 >> 2] = 0;
 HEAP32[i1 + 3044 >> 2] = 1;
 HEAP32[i1 + 3048 >> 2] = 0;
 HEAP32[i1 + 3052 >> 2] = -1;
 HEAP32[i1 + 3056 >> 2] = 0;
 HEAP32[i1 + 3060 >> 2] = 0;
 HEAP32[i1 + 3064 >> 2] = 1;
 HEAP32[i1 + 3068 >> 2] = 0;
 HEAP32[i1 + 3072 >> 2] = -1;
 HEAP32[i1 + 3076 >> 2] = 0;
 HEAP32[i1 + 3080 >> 2] = 0;
 HEAP32[i1 + 3084 >> 2] = 1;
 HEAP32[i1 + 3088 >> 2] = 0;
 HEAP32[i1 + 3092 >> 2] = -1;
 HEAP32[i1 + 3096 >> 2] = 0;
 HEAP32[i1 + 3100 >> 2] = 0;
 HEAP32[i1 + 3104 >> 2] = 1;
 HEAP32[i1 + 3108 >> 2] = 0;
 HEAP32[i1 + 3112 >> 2] = -1;
 HEAP32[i1 + 3116 >> 2] = 0;
 HEAP32[i1 + 3120 >> 2] = 0;
 HEAP32[i1 + 3124 >> 2] = 1;
 HEAP32[i1 + 3128 >> 2] = 0;
 HEAP32[i1 + 3132 >> 2] = -1;
 HEAP32[i1 + 3136 >> 2] = 0;
 HEAP32[i1 + 3140 >> 2] = 0;
 HEAP32[i1 + 3144 >> 2] = 1;
 HEAP32[i1 + 3148 >> 2] = 0;
 HEAP32[i1 + 3152 >> 2] = -1;
 HEAP32[i1 + 3156 >> 2] = 0;
 HEAP32[i1 + 3160 >> 2] = 0;
 HEAP32[i1 + 3164 >> 2] = 1;
 HEAP32[i1 + 3168 >> 2] = 0;
 HEAP32[i1 + 3172 >> 2] = -1;
 HEAP32[i1 + 3176 >> 2] = 0;
 HEAP32[i1 + 3180 >> 2] = 0;
 HEAP32[i1 + 3184 >> 2] = 1;
 HEAP32[i1 + 3188 >> 2] = 0;
 HEAP32[i1 + 3192 >> 2] = -1;
 HEAP32[i1 + 3196 >> 2] = 0;
 HEAP32[i1 + 3200 >> 2] = 0;
 HEAP32[i1 + 3204 >> 2] = 1;
 HEAP32[i1 + 3208 >> 2] = 0;
 HEAP32[i1 + 3212 >> 2] = -1;
 HEAP32[i1 + 3216 >> 2] = 0;
 HEAP32[i1 + 3220 >> 2] = 0;
 HEAP32[i1 + 3224 >> 2] = 1;
 HEAP32[i1 + 3228 >> 2] = 0;
 HEAP32[i1 + 3232 >> 2] = -1;
 HEAP32[i1 + 3236 >> 2] = 0;
 HEAP32[i1 + 3240 >> 2] = 0;
 HEAP32[i1 + 3244 >> 2] = 1;
 HEAP32[i1 + 3248 >> 2] = 0;
 HEAP32[i1 + 3252 >> 2] = -1;
 HEAP32[i1 + 3256 >> 2] = 0;
 HEAP32[i1 + 3260 >> 2] = 0;
 HEAP32[i1 + 3264 >> 2] = 1;
 HEAP32[i1 + 3268 >> 2] = 0;
 HEAP32[i1 + 3272 >> 2] = -1;
 HEAP32[i1 + 3276 >> 2] = 0;
 HEAP32[i1 + 3280 >> 2] = 0;
 HEAP32[i1 + 3284 >> 2] = 1;
 HEAP32[i1 + 3288 >> 2] = 0;
 HEAP32[i1 + 3292 >> 2] = -1;
 HEAP32[i1 + 3296 >> 2] = 0;
 HEAP32[i1 + 3300 >> 2] = 0;
 HEAP32[i1 + 3304 >> 2] = 1;
 HEAP32[i1 + 3308 >> 2] = 0;
 HEAP32[i1 + 3312 >> 2] = -1;
 HEAP32[i1 + 3316 >> 2] = 0;
 HEAP32[i1 + 3320 >> 2] = 0;
 HEAP32[i1 + 3324 >> 2] = 1;
 HEAP32[i1 + 3328 >> 2] = 0;
 HEAP32[i1 + 3332 >> 2] = -1;
 HEAP32[i1 + 3336 >> 2] = 0;
 HEAP32[i1 + 3340 >> 2] = 0;
 HEAP32[i1 + 3344 >> 2] = 1;
 HEAP32[i1 + 3348 >> 2] = 0;
 HEAP32[i1 + 3352 >> 2] = -1;
 HEAP32[i1 + 3356 >> 2] = 0;
 HEAP32[i1 + 3360 >> 2] = 0;
 HEAP32[i1 + 3364 >> 2] = 1;
 HEAP32[i1 + 3368 >> 2] = 0;
 HEAP32[i1 + 3372 >> 2] = -1;
 HEAP32[i1 + 3376 >> 2] = 0;
 HEAP32[i1 + 3380 >> 2] = 0;
 HEAP32[i1 + 3384 >> 2] = 1;
 HEAP32[i1 + 3388 >> 2] = 0;
 HEAP32[i1 + 3392 >> 2] = -1;
 HEAP32[i1 + 3396 >> 2] = 0;
 HEAP32[i1 + 3400 >> 2] = 0;
 HEAP32[i1 + 3404 >> 2] = 1;
 HEAP32[i1 + 3408 >> 2] = 0;
 HEAP32[i1 + 3412 >> 2] = -1;
 _memset(i1 | 0, 0, 2976) | 0;
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 240 >> 2] = Math_fround(1.0);
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2533;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI24GenerateTypeTreeTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI24GenerateTypeTreeTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2699;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI18StreamedBinaryReadILb1EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb1EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2643;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI18StreamedBinaryReadILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZN18DeferredRenderLoop15RenderFinalPassEP13RenderTextureS1_(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 20 | 0;
 i3 = i11 + 16 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 i6 = i1 + 8 | 0;
 if ((HEAP16[gb + 1114636 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114636 | 0, i2);
  i1 = gb + 1114636 | 0;
 } else i1 = 0;
 i2 = HEAP32[gb + 1114636 >> 2] | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 648 >> 2] | 0, i3 | 0, i2 | 0);
 i2 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 1;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0, 0);
 i3 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i7, 0, -1, 0, 0);
 i5 = __Z12GetGfxDevicev() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0, i5 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0, 0);
 i5 = i3 + 36 | 0;
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, gb + 1114744 | 0, Math_fround(128.0), 0);
 __ZN6Camera13ClearNoSkyboxEb(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, 1);
 if (!i8) {
  i8 = __ZN10builtintex15GetWhiteTextureEv() | 0;
  HEAP32[i9 >> 2] = HEAP32[gb + 62472 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
  HEAP32[i10 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i5, gb + 1114736 | 0, i8, i9, i10);
 } else __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i8, gb + 1114736 | 0, i3);
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i10 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i9 + 1136 | 0, 8, i3, HEAP32[i10 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i9 + 4 >> 2] | 0);
 i9 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i9 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i10 + 1136 | 0, 8, i3, HEAP32[i9 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i10 + 4 >> 2] | 0);
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(i3, 0, i7, HEAP32[gb + 1115120 >> 2] | 0, 1, 0, -1, gb + 62472 | 0, gb + 1162356 | 0);
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i10 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i9 + 1136 | 0, 9, i3, HEAP32[i10 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i9 + 4 >> 2] | 0);
 i9 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i9 + 8 >> 2] | 0;
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i10 + 1136 | 0, 9, i3, HEAP32[i9 + 1836 >> 2] | 0, gb + 1159956 | 0, HEAP32[i10 + 4 >> 2] | 0);
 i10 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 96 >> 2] | 0, i10 | 0, i4 | 0);
 HEAP32[gb + 1163232 >> 2] = i2;
 i10 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 652 >> 2] | 0, i10 | 0);
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i2, i1, i18, i3, i17, i19) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 var i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 8 | 0;
 i15 = i20 + 4 | 0;
 i4 = i20;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i20;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i19; else {
  HEAP32[gb + 1457180 >> 2] = (HEAP32[gb + 1457180 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = gb + 1576256 | 0;
   i14 = 7;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   if (!i1) {
    i1 = 0;
    i14 = 8;
   } else i14 = 7;
  }
  if ((i14 | 0) == 7) {
   i13 = _strlen(i1) | 0;
   i10 = i1 + i13 | 0;
   if ((i13 | 0) > 0) {
    i11 = i16 + 255 | 0;
    i12 = i16;
    i5 = i1;
    i13 = 0;
    i9 = 0;
    i2 = 0;
    f6 = Math_fround(0.0);
    while (1) {
     if (!i5) i5 = 0; else {
      i4 = HEAP8[i5 >> 0] | 0;
      if (i4 << 24 >> 24) {
       i3 = i5;
       do {
        if (!(_isspace(i4 & 255) | 0)) break;
        i3 = i3 + 1 | 0;
        i4 = HEAP8[i3 >> 0] | 0;
       } while (i4 << 24 >> 24 != 0);
       _memset(i16 | 0, 0, 256) | 0;
       HEAP32[i15 >> 2] = i11;
       i4 = HEAP8[i3 >> 0] | 0;
       L23 : do if (!(i4 << 24 >> 24)) i4 = i16; else if (!(_isspace(i4 & 255) | 0)) {
        i7 = i3;
        i5 = i16;
        while (1) {
         i4 = i5 + 1 | 0;
         HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
         i7 = i7 + 1 | 0;
         i5 = HEAP8[i7 >> 0] | 0;
         if (!(i5 << 24 >> 24)) break L23;
         i8 = HEAP32[i15 >> 2] | 0;
         if (!(i4 >>> 0 < i8 >>> 0 & (_isspace(i5 & 255) | 0) == 0)) break; else i5 = i4;
        }
       } else i4 = i16; while (0);
       HEAP8[i4 >> 0] = 0;
       f6 = Math_fround(+_strtod(i16, i15));
       i5 = i3 + ((HEAP32[i15 >> 2] | 0) - i12) | 0;
      }
     }
     i3 = i13 + 4 | 0;
     if (i9 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i7 = mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i4 | 0) | 0;
      if (i13 | 0) _memcpy(i7 | 0, i2 | 0, i13 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i2 | 0);
      i8 = i7;
      i2 = i7;
     } else {
      i8 = i2;
      i4 = i9;
     }
     i13 = i8 + i13 | 0;
     HEAPF32[tempDoublePtr >> 2] = f6;
     HEAP8[i13 >> 0] = HEAP8[tempDoublePtr >> 0];
     HEAP8[i13 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
     HEAP8[i13 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
     HEAP8[i13 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
     if (i5 >>> 0 < i10 >>> 0) {
      i13 = i3;
      i9 = i4;
     } else break;
    }
    i4 = i1;
    i3 = i3 >>> 2;
    i1 = i19;
   } else i14 = 8;
  }
  if ((i14 | 0) == 8) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i19;
  }
  HEAP32[i18 >> 2] = i2;
  HEAP32[i17 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, 0);
 STACKTOP = i20;
 return;
}

function __ZN5physx2Sc10NPhaseCore21filterRbCollisionPairERKNS0_8ShapeSimES4_PNS0_10FilterPairE(i18, i20, i23, i24, i19) {
 i18 = i18 | 0;
 i20 = i20 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, i25 = 0, i26 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i26 + 8 | 0;
 i21 = i26;
 HEAP16[i18 >> 1] = 0;
 i25 = i18 + 2 | 0;
 HEAP16[i25 >> 1] = 0;
 i22 = i18 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i16 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i23) | 0;
 i17 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i24) | 0;
 i14 = i16 + 50 | 0;
 i11 = HEAP8[i14 >> 0] | 0;
 i3 = i11 << 24 >> 24 == 1 | i11 << 24 >> 24 == 4;
 i15 = i17 + 50 | 0;
 i8 = HEAP8[i15 >> 0] | 0;
 i4 = i8 << 24 >> 24 == 1 | i8 << 24 >> 24 == 4;
 i9 = i3 ? i16 : 0;
 i10 = i4 ? i17 : 0;
 i1 = HEAP8[(HEAP32[i23 + 28 >> 2] | 0) + 64 >> 0] | 0;
 i2 = HEAP8[(HEAP32[i24 + 28 >> 2] | 0) + 64 >> 0] | 0;
 switch (i11 << 24 >> 24) {
 case 1:
 case 4:
  {
   i6 = (HEAP8[(HEAP32[i9 + 52 >> 2] | 0) + 44 >> 0] & 1) != 0;
   break;
  }
 default:
  i6 = 0;
 }
 switch (i8 << 24 >> 24) {
 case 1:
 case 4:
  {
   i7 = (HEAP8[(HEAP32[i10 + 52 >> 2] | 0) + 44 >> 0] & 1) != 0;
   break;
  }
 default:
  i7 = 0;
 }
 i5 = HEAPU16[(HEAP32[i20 >> 2] | 0) + 1192 >> 1] | 0;
 i1 = (i2 | i1) & 4;
 if (!(i1 | i5 & 32)) {
  i3 = (i6 | i7) & (i3 & i4 ^ 1);
  i2 = i3 ? 2 : 0;
 } else {
  i2 = 0;
  i3 = 0;
 }
 i1 = i7 & (i6 & (i1 | i5 & 64 | 0) == 0);
 L10 : do if (i1 | i3) i1 = i1 ? 2 : i2; else {
  HEAP8[i12 >> 0] = 0;
  switch (i11 << 24 >> 24) {
  case 1:
  case 4:
   {
    if (!(HEAP16[i9 + 144 >> 1] & 256)) i13 = 11; else i1 = __ZNK5physx2Sc7BodySim13isConnectedToERKNS0_8RigidSimERb(i9, i17, i12) | 0;
    break;
   }
  default:
   i13 = 11;
  }
  L15 : do if ((i13 | 0) == 11) {
   switch (i8 << 24 >> 24) {
   case 1:
   case 4:
    break;
   default:
    {
     i1 = 0;
     break L15;
    }
   }
   if (!(HEAP16[i10 + 144 >> 1] & 256)) i1 = 0; else i1 = __ZNK5physx2Sc7BodySim13isConnectedToERKNS0_8RigidSimERb(i10, i16, i12) | 0;
  } while (0);
  i4 = i1 & (HEAP8[i12 >> 0] | 0) != 0;
  if ((HEAP8[i14 >> 0] | 0) == 4 & (HEAP8[i15 >> 0] | 0) == 4) {
   i1 = HEAP32[i16 + 20 >> 2] | 0;
   i16 = HEAP32[i16 + 28 >> 2] | 0;
   i3 = i1 + (i16 << 2) | 0;
   if ((i16 | 0) > 0) do {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((HEAP8[i2 + 20 >> 0] | 0) == 5) {
     if ((HEAP32[i2 + 4 >> 2] | 0) == (i17 | 0)) {
      i1 = 1;
      break L10;
     }
     if ((HEAP32[i2 + 8 >> 2] | 0) == (i17 | 0)) {
      i1 = 1;
      break L10;
     }
    }
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  }
  if (i4) i1 = 2; else {
   __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE(i21, i20, i23, i24, i19);
   i2 = HEAP32[i21 >> 2] | 0;
   i20 = i2 & 65535;
   HEAP16[i18 >> 1] = i20;
   i2 = i2 >>> 16;
   i1 = i2 & 65535;
   HEAP16[i25 >> 1] = i1;
   HEAP32[i22 >> 2] = HEAP32[i21 + 4 >> 2];
   if (!(i20 & 3)) if (__ZNK5physx2Sc8ShapeSim10getBodySimEv(i23) | 0) if (HEAP8[(HEAP32[(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i23) | 0) + 52 >> 2] | 0) + 44 >> 0] & 1) if (__ZNK5physx2Sc8ShapeSim10getBodySimEv(i24) | 0) if (!((HEAP8[(HEAP32[(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i24) | 0) + 52 >> 2] | 0) + 44 >> 0] & 1) == 0 | (i2 & 1 | 0) == 0)) i1 = i2 & 65534;
   HEAP16[i25 >> 1] = i1;
   STACKTOP = i26;
   return;
  }
 } while (0);
 if (i19 | 0) __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i20, i19);
 HEAP16[i18 >> 1] = i1;
 STACKTOP = i26;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j(i15, i10) {
 i15 = i15 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 40 | 0;
 i11 = i17 + 36 | 0;
 i13 = i17 + 16 | 0;
 i6 = i17 + 12 | 0;
 i7 = i17 + 32 | 0;
 i8 = i17 + 28 | 0;
 i14 = i17;
 i16 = i15 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i1 = (i3 - i4 | 0) / 36 | 0;
 i2 = i4;
 if (i1 >>> 0 < i10 >>> 0) {
  i2 = i15 + 8 | 0;
  if ((((HEAP32[i2 >> 2] | 0) - i4 | 0) / 36 | 0 | 0) == (i10 | 0)) {
   __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6resizeEj(i15, i10);
   STACKTOP = i17;
   return;
  }
  HEAP32[i13 >> 2] = 0;
  i5 = i13 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  i1 = i13 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  i6 = i13 + 8 | 0;
  if (i10) {
   HEAP32[i12 + 16 >> 2] = i1;
   i4 = __Znwj(i10 * 36 | 0) | 0;
   HEAP32[i12 >> 2] = i4;
   HEAP32[i12 + 8 >> 2] = i4;
   HEAP32[i12 + 4 >> 2] = i4;
   HEAP32[i12 + 12 >> 2] = i4 + (i10 * 36 | 0);
   __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i13, i12);
   __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev(i12);
   i4 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i16 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i13, i11, i12);
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6resizeEj(i13, i10);
  i14 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i14;
  i15 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i16 >> 2] = i15;
  i16 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i16;
  __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev(i13);
  STACKTOP = i17;
  return;
 }
 if (i1 >>> 0 <= i10 >>> 0) {
  STACKTOP = i17;
  return;
 }
 i5 = i2 + (i10 * 36 | 0) | 0;
 HEAP32[i14 >> 2] = 0;
 i9 = i14 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = i10 * 36 | 0;
 i2 = (i1 | 0) / 36 | 0;
 if (!i1) {
  i6 = i14;
  i7 = i9;
  i8 = i14 + 8 | 0;
  i5 = 0;
  i1 = 0;
  i2 = 0;
 } else {
  if (i2 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i7 = __Znwj(i1) | 0;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i14 >> 2] = i7;
  i10 = i14 + 8 | 0;
  HEAP32[i10 >> 2] = i7 + (i2 * 36 | 0);
  HEAP32[i13 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i14, i11, i12, i2);
  i6 = i14;
  i7 = i9;
  i8 = i10;
  i4 = HEAP32[i15 >> 2] | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i4;
 HEAP32[i15 >> 2] = i5;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i16 >> 2] = i1;
 i16 = i15 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i2;
 __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev(i14);
 STACKTOP = i17;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 20 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i12 = 0;
  return i12 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = _i64Add(i4 | 0, i3 | 0, -1, ~i4 | 0) | 0;
 i9 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i1 | 0, i9 | 0, 22) | 0;
 i1 = i10 ^ i1;
 i9 = (getTempRet0() | 0) ^ i9;
 i10 = _bitshift64Shl(i1 | 0, i9 | 0, 13) | 0;
 i10 = _i64Add(i1 | 0, i9 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i9 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i10 | 0, i9 | 0, 8) | 0;
 i9 = ___muldi3(i1 ^ i10 | 0, (getTempRet0() | 0) ^ i9 | 0, 9, 0) | 0;
 i10 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i9 | 0, i10 | 0, 15) | 0;
 i9 = i1 ^ i9;
 i10 = (getTempRet0() | 0) ^ i10;
 i1 = _bitshift64Shl(i9 | 0, i10 | 0, 27) | 0;
 i1 = _i64Add(i9 | 0, i10 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i10 = getTempRet0() | 0;
 i9 = _bitshift64Lshr(i1 | 0, i10 | 0, 31) | 0;
 (getTempRet0() | 0) ^ i10;
 i10 = i12 + 12 | 0;
 i1 = (HEAP32[i10 >> 2] | 0) + (((i9 ^ i1) & i2 + -1) << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = i12 + 4 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i12 + 8 | 0;
 while (1) {
  if ((HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i3 | 0)) {
   i9 = i2;
   break;
  }
  i1 = (HEAP32[i6 >> 2] | 0) + (i2 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i8 = 12;
   break;
  }
 }
 if ((i8 | 0) == 12) return i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i9 << 2) >> 2];
 i3 = i12 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i8 = i12 + 32 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 if ((i9 | 0) != (i1 | 0)) {
  i2 = i5 + (i1 * 12 | 0) | 0;
  i8 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + (i9 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i8;
  HEAP32[i5 + (i9 * 12 | 0) + 8 >> 2] = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2];
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 + (i9 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 >> 2] << 2) >> 2];
  i8 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 + (i9 * 12 | 0) >> 2] | 0;
  i2 = _i64Add(i2 | 0, HEAP32[i8 + (i9 * 12 | 0) + 4 >> 2] | 0, -1, ~i2 | 0) | 0;
  i11 = getTempRet0() | 0;
  i8 = _bitshift64Lshr(i2 | 0, i11 | 0, 22) | 0;
  i2 = i8 ^ i2;
  i11 = (getTempRet0() | 0) ^ i11;
  i8 = _bitshift64Shl(i2 | 0, i11 | 0, 13) | 0;
  i8 = _i64Add(i2 | 0, i11 | 0, ~i8 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i8 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i2 ^ i8 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i8 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i11 | 0, i8 | 0, 15) | 0;
  i11 = i2 ^ i11;
  i8 = (getTempRet0() | 0) ^ i8;
  i2 = _bitshift64Shl(i11 | 0, i8 | 0, 27) | 0;
  i2 = _i64Add(i11 | 0, i8 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i8 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i2 | 0, i8 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i8;
  i1 = (HEAP32[i10 >> 2] | 0) + (((i11 ^ i2) & i1 + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i9;
 }
 i12 = i12 + 28 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i12 = 1;
 return i12 | 0;
}

function __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i3 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, i2, gb + 735408 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  __ZN14SafeBinaryRead10SetVersionEi(i10, 3);
  i5 = HEAP32[gb + 37012 >> 2] | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 735419 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i4 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i8 = 8; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 8; else {
      HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 4 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 735434 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i3 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i8 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 19; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  i4 = i6 + 8 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i10, gb + 735449 | 0, i5, i7, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i10 + 16 | 0;
    i7 = HEAP32[i10 + 20 >> 2] | 0;
    i2 = i7 + (HEAP32[(HEAP32[i10 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i10 + 36 >> 2] | 0, 0 - (HEAP32[i10 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i7 >>> 0) i8 = 30; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) i8 = 30; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i8 | 0) == 30) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i10 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i10 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i10);
  }
  if (__ZN14SafeBinaryRead12IsOldVersionEi(i10, 1) | 0) HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i10 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i10);
 STACKTOP = i9;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i10 = i16 + 8 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16;
 i15 = i14 + 4 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i1 = i5 - i11 >> 2;
 i9 = i11;
 if (i1 >>> 0 < i12 >>> 0) {
  i7 = i14 + 8 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i11 >> 2 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i10 >> 2] = 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i6 = i10 + 8 | 0;
  if (i12 | 0) {
   i9 = __Znwj(i12 << 2) | 0;
   i1 = i9;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i6 >> 2] = i9 + (i12 << 2);
  }
  HEAP32[i3 >> 2] = i11;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i2, i13);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = i1 - i4 >> 2;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE8__appendEj(i10, i12 - i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 << 2) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
    HEAP32[i8 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i9 + (i12 << 2) | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 << 2;
  i2 = i1 >> 2;
  if (!i2) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i6 = __Znwj(i1) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i2 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i8 = i6;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i5 = i7 + -4 | 0;
    i2 = i9;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i11 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i8;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx15PxsParticleDataC2ERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E(i5, i14, i1) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 HEAP32[i5 >> 2] = gb + 96500 + 8;
 i10 = i5 + 56 | 0;
 i7 = i5 + 60 | 0;
 HEAP8[i5 + 4 >> 0] = 1;
 i6 = HEAP32[i14 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i6;
 i12 = i14 + 40 | 0;
 i4 = (HEAP32[i12 >> 2] | 0) != 0;
 i13 = i5 + 12 | 0;
 HEAP8[i13 >> 0] = i4 & 1;
 HEAP32[i5 + 20 >> 2] = HEAP32[i14 + 4 >> 2];
 i9 = i5 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 32 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 36 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i5 + 40 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i1 + 20 >> 2];
 i1 = i5 + 80 | 0;
 i3 = (i6 + 31 | 0) >>> 5;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i7 >> 2] = i3 | -2147483648;
 i8 = (i3 << 2) + 15 & 1073741808;
 i11 = i5 + 48 | 0;
 HEAP32[i11 >> 2] = i1 + i8;
 i15 = i5 + 52 | 0;
 HEAP32[i15 >> 2] = i4 ? i1 + (i8 + (i6 << 5)) | 0 : 0;
 i6 = HEAP32[i14 + 12 >> 2] | 0;
 if (!i6) _memset(i1 | 0, 0, i3 << 2 | 0) | 0; else {
  i8 = i6 + 4 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = i2 & 134217727;
  if (i4 >>> 0 > i3 >>> 0) {
   HEAP32[i7 >> 2] = i4;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5 + 64 | 0, i4 << 2, gb + 769739 | 0, 352) | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, i2 << 2 | 0) | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1 & 2147483647;
  if ((i3 & 2147483647) >>> 0 > i2 >>> 0) _memset((HEAP32[i10 >> 2] | 0) + (i2 << 2) | 0, 0, i3 - i1 << 2 | 0) | 0;
 }
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = 0;
 do {
  HEAP16[i1 + (i2 << 5) + 28 >> 1] = 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 i10 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i14 + 16 >> 2] | 0;
 i6 = HEAP32[i14 + 20 >> 2] | 0;
 i7 = HEAP32[i14 + 24 >> 2] | 0;
 i8 = HEAP32[i14 + 28 >> 2] | 0;
 i9 = ((i3 + -1 | 0) >>> 5) + 1 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[i10 + (i4 << 2) >> 2] | 0;
  if (i1 | 0) {
   i2 = i4 << 5;
   i3 = HEAP32[i11 >> 2] | 0;
   do {
    i16 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i16 = HEAP32[gb + 90668 + (i16 << 2) >> 2] | i2;
    i17 = Math_imul(i6, i16) | 0;
    HEAP32[i3 + (i16 << 5) >> 2] = HEAP32[i5 + i17 >> 2];
    HEAP32[i3 + (i16 << 5) + 4 >> 2] = HEAP32[i5 + (i17 + 4) >> 2];
    HEAP32[i3 + (i16 << 5) + 8 >> 2] = HEAP32[i5 + (i17 + 8) >> 2];
    i17 = Math_imul(i8, i16) | 0;
    HEAP32[i3 + (i16 << 5) + 16 >> 2] = HEAP32[i7 + i17 >> 2];
    HEAP32[i3 + (i16 << 5) + 20 >> 2] = HEAP32[i7 + (i17 + 4) >> 2];
    HEAP32[i3 + (i16 << 5) + 24 >> 2] = HEAP32[i7 + (i17 + 8) >> 2];
    HEAPF32[i3 + (i16 << 5) + 12 >> 2] = Math_fround(0.0);
    HEAP16[i3 + (i16 << 5) + 30 >> 1] = 0;
    HEAP16[i3 + (i16 << 5) + 28 >> 1] = 1;
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i9 | 0));
 if (!(HEAP8[i13 >> 0] | 0)) return;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i14 + 44 >> 2] | 0;
 i5 = 0;
 do {
  i1 = HEAP32[i10 + (i5 << 2) >> 2] | 0;
  if (i1 | 0) {
   i3 = i5 << 5;
   i4 = HEAP32[i15 >> 2] | 0;
   do {
    i17 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i17 = HEAP32[gb + 90668 + (i17 << 2) >> 2] | i3;
    HEAP32[i4 + (i17 << 2) >> 2] = HEAP32[i6 + (Math_imul(i2, i17) | 0) >> 2];
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i9 | 0));
 return;
}

function __ZN7mecanim14ValueArrayCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi(i1, i3, i2, i4, i34) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i34 = i34 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0;
 i35 = HEAP32[i2 >> 2] | 0;
 if ((i35 | 0) <= 0) return;
 i32 = i1 + 4 | 0;
 i33 = i32;
 i31 = i2 + 4 | 0;
 i10 = i31;
 i11 = i3 + 4 | 0;
 i12 = i11;
 i13 = i4 + 4 | 0;
 i14 = i13;
 i15 = i3 + 12 | 0;
 i16 = i15;
 i17 = i4 + 12 | 0;
 i18 = i17;
 i19 = i3 + 20 | 0;
 i20 = i19;
 i21 = i4 + 20 | 0;
 i22 = i21;
 i23 = i3 + 28 | 0;
 i24 = i23;
 i25 = i4 + 28 | 0;
 i26 = i25;
 i27 = i3 + 36 | 0;
 i28 = i27;
 i29 = i4 + 36 | 0;
 i30 = i29;
 i8 = i3 + 44 | 0;
 i9 = i8;
 i2 = i4 + 44 | 0;
 i3 = i2;
 i1 = 0;
 do {
  i4 = HEAP32[i34 + (i1 << 2) >> 2] | 0;
  L6 : do if ((i4 | 0) != -1) {
   i5 = (HEAP32[i32 >> 2] | 0) + i33 | 0;
   i6 = HEAP32[i5 + (i4 * 12 | 0) + 4 >> 2] | 0;
   i7 = (HEAP32[i31 >> 2] | 0) + i10 | 0;
   if ((i6 | 0) == (HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2] | 0)) switch (i6 | 0) {
   case 6:
    {
     i36 = HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i37 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
     i4 = HEAP32[i37 + (i36 * 12 | 0) + 4 >> 2] | 0;
     i5 = HEAP32[i37 + (i36 * 12 | 0) + 8 >> 2] | 0;
     i7 = HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i6 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
     HEAP32[i6 + (i7 * 12 | 0) >> 2] = HEAP32[i37 + (i36 * 12 | 0) >> 2];
     HEAP32[i6 + (i7 * 12 | 0) + 4 >> 2] = i4;
     HEAP32[i6 + (i7 * 12 | 0) + 8 >> 2] = i5;
     break L6;
    }
   case 7:
    {
     i38 = HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i39 = (HEAP32[i15 >> 2] | 0) + i16 | 0;
     i4 = HEAP32[i39 + (i38 << 4) + 4 >> 2] | 0;
     i5 = HEAP32[i39 + (i38 << 4) + 8 >> 2] | 0;
     i6 = HEAP32[i39 + (i38 << 4) + 12 >> 2] | 0;
     i37 = HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i36 = (HEAP32[i17 >> 2] | 0) + i18 | 0;
     HEAP32[i36 + (i37 << 4) >> 2] = HEAP32[i39 + (i38 << 4) >> 2];
     HEAP32[i36 + (i37 << 4) + 4 >> 2] = i4;
     HEAP32[i36 + (i37 << 4) + 8 >> 2] = i5;
     HEAP32[i36 + (i37 << 4) + 12 >> 2] = i6;
     break L6;
    }
   case 8:
    {
     i6 = HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] | 0;
     i5 = (HEAP32[i19 >> 2] | 0) + i20 | 0;
     i36 = HEAP32[i5 + (i6 * 12 | 0) + 4 >> 2] | 0;
     i37 = HEAP32[i5 + (i6 * 12 | 0) + 8 >> 2] | 0;
     i39 = HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] | 0;
     i38 = (HEAP32[i21 >> 2] | 0) + i22 | 0;
     HEAP32[i38 + (i39 * 12 | 0) >> 2] = HEAP32[i5 + (i6 * 12 | 0) >> 2];
     HEAP32[i38 + (i39 * 12 | 0) + 4 >> 2] = i36;
     HEAP32[i38 + (i39 * 12 | 0) + 8 >> 2] = i37;
     break L6;
    }
   case 1:
    {
     HEAP32[(HEAP32[i25 >> 2] | 0) + i26 + (HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[(HEAP32[i23 >> 2] | 0) + i24 + (HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2];
     break L6;
    }
   case 3:
    {
     HEAP32[(HEAP32[i29 >> 2] | 0) + i30 + (HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[(HEAP32[i27 >> 2] | 0) + i28 + (HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2];
     break L6;
    }
   case 4:
   case 9:
    {
     HEAP8[(HEAP32[i2 >> 2] | 0) + i3 + (HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] | 0) >> 0] = HEAP8[(HEAP32[i8 >> 2] | 0) + i9 + (HEAP32[i5 + (i4 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0;
     break L6;
    }
   default:
    break L6;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i35 | 0));
 return;
}

function __ZN7mecanim9animation18ControllerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i6 = i10 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) {
  i5 = i10 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 40, 4) | 0;
    i3 = i2 + 8 | 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i3 + 12 >> 2] = 0;
    HEAP8[i2 + 36 >> 0] = 1;
    HEAP8[i2 + 37 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim9animation13LayerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i10);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i8 + 12 | 0;
 i5 = i8 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) {
  i5 = i10 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i5 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 32, 4) | 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine20StateMachineConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i10);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i10 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 } else i3 = i10 + 4 | 0;
 i1 = i2 + i1 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 >> 2] = i1 + 4;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = i4;
 __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i9, i10);
 i4 = i8 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i2 = i1;
  i3 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i9 = i4;
  i8 = i1 | 0 ? i1 - i9 | 0 : 0;
  HEAP32[i4 >> 2] = i8;
  i9 = i8 + i9 | 0;
  __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
  STACKTOP = i11;
  return;
 } else {
  i9 = i4;
  i8 = i1;
  i9 = i8 + i9 | 0;
  __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
  STACKTOP = i11;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService16SessionContainer12IsDispatchedERK8UnityStr(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 64 | 0;
 i11 = i12 + 48 | 0;
 i5 = i12 + 36 | 0;
 i6 = i12 + 24 | 0;
 i7 = i12;
 i8 = i12 + 12 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, i1);
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i6, i7);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i11 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i11; else {
   i1 = i11;
   i9 = 9;
  }
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i4;
  i2 = i11 + 11 | 0;
  i9 = 9;
 }
 if ((i9 | 0) == 9) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i1 = HEAP8[i2 >> 0] | 0;
 i7 = i1 << 24 >> 24 < 0;
 i9 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
 i1 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i1 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i9, i1);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1086046 | 0, 1);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i5, i6);
 __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = __ZNK15FileSystemEntry6ExistsEv(i10) | 0;
 __ZN13FileEntryDataD2Ev(i10);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return i1 | 0;
}

function runPostSets25() {
 HEAP32[gb + 39576 >> 2] = fb + 1;
 HEAP32[gb + 39580 >> 2] = fb + 286;
 HEAP32[gb + 39584 >> 2] = fb + 1;
 HEAP32[gb + 39588 >> 2] = fb + 1;
 HEAP32[gb + 39592 >> 2] = fb + 1;
 HEAP32[gb + 39596 >> 2] = fb + 282;
 HEAP32[gb + 39600 >> 2] = fb + 283;
 HEAP32[gb + 39604 >> 2] = fb + 1;
 HEAP32[gb + 39608 >> 2] = fb + 165;
 HEAP32[gb + 39612 >> 2] = fb + 287;
 HEAP32[gb + 39616 >> 2] = fb + 288;
 HEAP32[gb + 39620 >> 2] = fb + 1;
 HEAP32[gb + 39624 >> 2] = fb + 166;
 HEAP32[gb + 39628 >> 2] = fb + 167;
 HEAP32[gb + 39632 >> 2] = fb + 284;
 HEAP32[gb + 39636 >> 2] = fb + 289;
 HEAP32[gb + 39640 >> 2] = fb + 290;
 HEAP32[gb + 39644 >> 2] = fb + 1;
 HEAP32[gb + 39648 >> 2] = fb + 1;
 HEAP32[gb + 39652 >> 2] = fb + 2;
 HEAP32[gb + 39656 >> 2] = fb + 2;
 HEAP32[gb + 39660 >> 2] = fb + 3;
 HEAP32[gb + 39664 >> 2] = fb + 1;
 HEAP32[gb + 39668 >> 2] = fb + 21;
 HEAP32[gb + 39672 >> 2] = fb + 291;
 HEAP32[gb + 39676 >> 2] = fb + 168;
 HEAP32[gb + 39680 >> 2] = fb + 26;
 HEAP32[gb + 39684 >> 2] = fb + 1;
 HEAP32[gb + 39688 >> 2] = fb + 1;
 HEAP32[gb + 39692 >> 2] = fb + 1;
 HEAP32[gb + 39696 >> 2] = fb + 1;
 HEAP32[gb + 39700 >> 2] = fb + 292;
 HEAP32[gb + 39704 >> 2] = fb + 285;
 HEAP32[gb + 39708 >> 2] = fb + 293;
 HEAP32[gb + 39712 >> 2] = fb + 294;
 HEAP32[gb + 39716 >> 2] = fb + 295;
 HEAP32[gb + 39720 >> 2] = fb + 296;
 HEAP32[gb + 39724 >> 2] = fb + 297;
 HEAP32[gb + 39728 >> 2] = fb + 298;
 HEAP32[gb + 39732 >> 2] = fb + 1;
 HEAP32[gb + 39736 >> 2] = fb + 286;
 HEAP32[gb + 39740 >> 2] = fb + 299;
 HEAP32[gb + 39744 >> 2] = fb + 22;
 HEAP32[gb + 39748 >> 2] = fb + 1;
 HEAP32[gb + 39752 >> 2] = fb + 1;
 HEAP32[gb + 39756 >> 2] = fb + 1;
 HEAP32[gb + 39760 >> 2] = fb + 1;
 HEAP32[gb + 39764 >> 2] = fb + 169;
 HEAP32[gb + 39768 >> 2] = fb + 23;
 HEAP32[gb + 39772 >> 2] = fb + 24;
 HEAP32[gb + 39776 >> 2] = fb + 25;
 HEAP32[gb + 39780 >> 2] = fb + 26;
 HEAP32[gb + 39784 >> 2] = fb + 287;
 HEAP32[gb + 39788 >> 2] = fb + 300;
 HEAP32[gb + 39792 >> 2] = fb + 170;
 HEAP32[gb + 39796 >> 2] = fb + 171;
 HEAP32[gb + 39800 >> 2] = fb + 172;
 HEAP32[gb + 39804 >> 2] = fb + 60;
 HEAP32[gb + 39808 >> 2] = fb + 61;
 HEAP32[gb + 39812 >> 2] = fb + 62;
 HEAP32[gb + 39816 >> 2] = fb + 63;
 HEAP32[gb + 39820 >> 2] = fb + 64;
 HEAP32[gb + 39824 >> 2] = fb + 288;
 HEAP32[gb + 39828 >> 2] = fb + 27;
 HEAP32[gb + 39832 >> 2] = fb + 173;
 HEAP32[gb + 39836 >> 2] = fb + 289;
 HEAP32[gb + 39840 >> 2] = fb + 11;
 HEAP32[gb + 39844 >> 2] = fb + 12;
 HEAP32[gb + 39848 >> 2] = fb + 28;
 HEAP32[gb + 39852 >> 2] = fb + 13;
 HEAP32[gb + 39856 >> 2] = fb + 29;
 HEAP32[gb + 39860 >> 2] = fb + 30;
 HEAP32[gb + 39864 >> 2] = fb + 301;
 HEAP32[gb + 39868 >> 2] = fb + 174;
 HEAP32[gb + 39872 >> 2] = fb + 27;
 HEAP32[gb + 39876 >> 2] = fb + 290;
 HEAP32[gb + 39880 >> 2] = fb + 1;
 HEAP32[gb + 39884 >> 2] = fb + 14;
 HEAP32[gb + 39888 >> 2] = fb + 31;
 HEAP32[gb + 39892 >> 2] = fb + 3;
 HEAP32[gb + 39896 >> 2] = fb + 291;
 HEAP32[gb + 39900 >> 2] = fb + 4;
 HEAP32[gb + 39904 >> 2] = fb + 3;
 HEAP32[gb + 39908 >> 2] = fb + 1;
 HEAP32[gb + 39912 >> 2] = fb + 292;
 HEAP32[gb + 39916 >> 2] = fb + 5;
 HEAP32[gb + 39920 >> 2] = fb + 15;
 HEAP32[gb + 39924 >> 2] = fb + 16;
 HEAP32[gb + 39928 >> 2] = fb + 17;
 HEAP32[gb + 39932 >> 2] = fb + 2;
 HEAP32[gb + 39936 >> 2] = fb + 6;
 HEAP32[gb + 39940 >> 2] = fb + 293;
 HEAP32[gb + 39944 >> 2] = fb + 294;
 HEAP32[gb + 39948 >> 2] = fb + 32;
 HEAP32[gb + 39952 >> 2] = fb + 175;
 HEAP32[gb + 39956 >> 2] = fb + 176;
 HEAP32[gb + 39960 >> 2] = fb + 18;
 HEAP32[gb + 39964 >> 2] = fb + 19;
 HEAP32[gb + 39968 >> 2] = fb + 177;
 HEAP32[gb + 39972 >> 2] = fb + 178;
 runPostSets26();
}

function _ps_dimension_end(i3, i1, i16) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 if (i2 | 0) HEAP32[(HEAP32[i3 + 20 >> 2] | 0) + (i2 << 4) + -16 + 12 >> 2] = i1;
 i15 = i3 + 24 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) <= 1) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i14 = i3 + 32 | 0;
 i13 = i1;
 L7 : while (1) {
  i2 = i13 + -2 | 0;
  i13 = i13 + -1 | 0;
  L9 : do if ((i2 | 0) > -1) {
   i12 = HEAP32[i14 >> 2] | 0;
   i6 = HEAP32[i12 + (i13 << 4) + 8 >> 2] | 0;
   i7 = HEAP32[i12 + (i13 << 4) >> 2] | 0;
   L11 : while (1) {
    i3 = HEAP32[i12 + (i2 << 4) + 8 >> 2] | 0;
    i4 = HEAP32[i12 + (i2 << 4) >> 2] | 0;
    i4 = i7 >>> 0 < i4 >>> 0 ? i7 : i4;
    if (i4 >>> 0 > 7) {
     i5 = i6;
     do {
      if ((HEAP8[i3 >> 0] & HEAP8[i5 >> 0]) << 24 >> 24) break L11;
      i5 = i5 + 1 | 0;
      i3 = i3 + 1 | 0;
      i4 = i4 + -8 | 0;
     } while (i4 >>> 0 > 7);
    } else i5 = i6;
    if (i4 | 0) if (HEAP8[i3 >> 0] & HEAP8[i5 >> 0] & 255 & ~(255 >>> i4) | 0) break;
    if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break L9;
   }
   i9 = i2 >>> 0 > i13 >>> 0;
   i11 = i9 ? i2 : i13;
   i9 = i9 ? i13 : i2;
   if (i9 >>> 0 < i11 >>> 0 & i11 >>> 0 < i1 >>> 0) {
    i10 = i12 + (i11 << 4) | 0;
    i7 = i12 + (i9 << 4) | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    if (i8 | 0) {
     if (i8 >>> 0 > i2 >>> 0) {
      i5 = i12 + (i9 << 4) + 4 | 0;
      i4 = ((HEAP32[i5 >> 2] | 0) + 7 | 0) >>> 3;
      i1 = (i8 + 7 | 0) >>> 3;
      HEAP32[i17 >> 2] = 0;
      if (i1 >>> 0 > i4 >>> 0) {
       i6 = i1 + 7 & 1073741816;
       i3 = i12 + (i9 << 4) + 8 | 0;
       HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i16, 1, i4, i6, HEAP32[i3 >> 2] | 0, i17) | 0;
       i4 = HEAP32[i17 >> 2] | 0;
       if (i4 | 0) break L7;
       HEAP32[i5 >> 2] = i6 << 3;
      } else i3 = i12 + (i9 << 4) + 8 | 0;
      do {
       if ((HEAP32[i7 >> 2] | 0) >>> 0 > i2 >>> 0) {
        i6 = (HEAP32[i3 >> 2] | 0) + (i2 >>> 3) | 0;
        HEAP8[i6 >> 0] = (HEAPU8[i6 >> 0] | 0) & (128 >>> (i2 & 7) ^ 255);
       }
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i8 | 0));
     } else i1 = (i8 + 7 | 0) >>> 3;
     if (i1 | 0) {
      i2 = HEAP32[i12 + (i9 << 4) + 8 >> 2] | 0;
      i3 = HEAP32[i12 + (i11 << 4) + 8 >> 2] | 0;
      while (1) {
       HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | HEAP8[i2 >> 0];
       i1 = i1 + -1 | 0;
       if (!i1) break; else {
        i2 = i2 + 1 | 0;
        i3 = i3 + 1 | 0;
       }
      }
     }
    }
    HEAP32[i10 >> 2] = 0;
    HEAP32[i12 + (i11 << 4) + 12 >> 2] = 0;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = i1 + ~i11 | 0;
    if ((i2 | 0) > 0) {
     HEAP32[i17 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     _memmove(i10 | 0, i10 + 16 | 0, i2 << 4 | 0) | 0;
     i1 = i10 + (i2 << 4) | 0;
     HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     i1 = HEAP32[i15 >> 2] | 0;
    }
    i1 = i1 + -1 | 0;
    HEAP32[i15 >> 2] = i1;
   }
  } while (0);
  if ((i13 | 0) <= 1) {
   i1 = 0;
   i18 = 33;
   break;
  }
 }
 if ((i18 | 0) == 33) {
  STACKTOP = i19;
  return i1 | 0;
 }
 i18 = i4;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN14ParticleSystem22AllocateParticleArraysEv(i5);
 i1 = HEAP32[i5 + 276 >> 2] | 0;
 i2 = HEAP32[i5 + 280 >> 2] | 0;
 i3 = HEAP32[i5 + 284 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 + 272 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 i3 = HEAP32[i5 + 292 >> 2] | 0;
 i2 = HEAP32[i5 + 296 >> 2] | 0;
 i1 = HEAP32[i5 + 300 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 288 >> 2];
 HEAP32[i4 + 20 >> 2] = i3;
 HEAP32[i4 + 24 >> 2] = i2;
 HEAP32[i4 + 28 >> 2] = i1;
 i1 = i5 + 304 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i4 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = HEAP32[i5 + 316 >> 2] | 0;
 i2 = HEAP32[i5 + 320 >> 2] | 0;
 i1 = HEAP32[i5 + 324 >> 2] | 0;
 HEAP32[i4 + 40 >> 2] = HEAP32[i5 + 312 >> 2];
 HEAP32[i4 + 44 >> 2] = i3;
 HEAP32[i4 + 48 >> 2] = i2;
 HEAP32[i4 + 52 >> 2] = i1;
 i1 = HEAP32[i5 + 332 >> 2] | 0;
 i2 = HEAP32[i5 + 336 >> 2] | 0;
 i3 = HEAP32[i5 + 340 >> 2] | 0;
 HEAP32[i4 + 56 >> 2] = HEAP32[i5 + 328 >> 2];
 HEAP32[i4 + 60 >> 2] = i1;
 HEAP32[i4 + 64 >> 2] = i2;
 HEAP32[i4 + 68 >> 2] = i3;
 i3 = i5 + 344 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i4 + 80 | 0;
 i2 = i5 + 352 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i2 + 6 >> 0] | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4 + 88 | 0, i5 + 360 | 0) | 0;
 i1 = HEAP32[i5 + 540 >> 2] | 0;
 i2 = HEAP32[i5 + 544 >> 2] | 0;
 i3 = HEAP32[i5 + 548 >> 2] | 0;
 HEAP32[i4 + 264 >> 2] = HEAP32[i5 + 536 >> 2];
 HEAP32[i4 + 268 >> 2] = i1;
 HEAP32[i4 + 272 >> 2] = i2;
 HEAP32[i4 + 276 >> 2] = i3;
 i3 = HEAP32[i5 + 556 >> 2] | 0;
 i2 = HEAP32[i5 + 560 >> 2] | 0;
 i1 = HEAP32[i5 + 564 >> 2] | 0;
 HEAP32[i4 + 280 >> 2] = HEAP32[i5 + 552 >> 2];
 HEAP32[i4 + 284 >> 2] = i3;
 HEAP32[i4 + 288 >> 2] = i2;
 HEAP32[i4 + 292 >> 2] = i1;
 i1 = i5 + 568 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i4 + 296 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = HEAP32[i5 + 580 >> 2] | 0;
 i2 = HEAP32[i5 + 584 >> 2] | 0;
 i1 = HEAP32[i5 + 588 >> 2] | 0;
 HEAP32[i4 + 304 >> 2] = HEAP32[i5 + 576 >> 2];
 HEAP32[i4 + 308 >> 2] = i3;
 HEAP32[i4 + 312 >> 2] = i2;
 HEAP32[i4 + 316 >> 2] = i1;
 i1 = HEAP32[i5 + 596 >> 2] | 0;
 i2 = HEAP32[i5 + 600 >> 2] | 0;
 i3 = HEAP32[i5 + 604 >> 2] | 0;
 HEAP32[i4 + 320 >> 2] = HEAP32[i5 + 592 >> 2];
 HEAP32[i4 + 324 >> 2] = i1;
 HEAP32[i4 + 328 >> 2] = i2;
 HEAP32[i4 + 332 >> 2] = i3;
 i3 = i5 + 608 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 336 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i4 + 344 | 0;
 i2 = i5 + 616 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i2 + 6 >> 0] | 0;
 __ZN21MinMaxAnimationCurvesaSERKS_(i4 + 352 | 0, i5 + 624 | 0) | 0;
 i1 = i4 + 528 | 0;
 i2 = i5 + 800 | 0;
 i3 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP8[i1 + 13 >> 0] = 1;
 HEAP8[i1 + 26 >> 0] = 1;
 HEAP8[i1 + 24 >> 0] = 1;
 if (!(HEAP8[i5 + 52 >> 0] | 0)) {
  i3 = i4 + 592 | 0;
  HEAP32[i3 >> 2] = i6;
  i6 = i4 + 596 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f(i5 + 48 | 0, i1 + 180 | 0);
 i3 = i4 + 592 | 0;
 HEAP32[i3 >> 2] = i6;
 i6 = i4 + 596 | 0;
 HEAP32[i6 >> 2] = i5;
 return;
}

function __ZN12b2WheelJoint24SolvePositionConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i10 = i1 + 132 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i5 = i2 + 24 | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) >> 2]);
 f23 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) + 8 >> 2]);
 i2 = i1 + 136 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) >> 2]);
 f19 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i12 + (i7 * 12 | 0) + 8 >> 2]);
 f15 = Math_fround(+Math_sin(+f22));
 f11 = Math_fround(+Math_cos(+f22));
 f3 = Math_fround(+Math_sin(+f17));
 f13 = Math_fround(+Math_cos(+f17));
 f4 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 140 >> 2]));
 f21 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i1 + 144 >> 2]));
 f6 = Math_fround(Math_fround(f11 * f4) - Math_fround(f15 * f21));
 f21 = Math_fround(Math_fround(f15 * f4) + Math_fround(f11 * f21));
 f4 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 148 >> 2]));
 f16 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i1 + 152 >> 2]));
 f8 = Math_fround(Math_fround(f13 * f4) - Math_fround(f3 * f16));
 f16 = Math_fround(Math_fround(f3 * f4) + Math_fround(f13 * f16));
 f13 = Math_fround(Math_fround(Math_fround(f20 - f14) + f8) - f6);
 f4 = Math_fround(Math_fround(Math_fround(f19 - f23) + f16) - f21);
 f3 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f9 = Math_fround(f11 * f3);
 f18 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f15 * f18));
 f18 = Math_fround(Math_fround(f15 * f3) + Math_fround(f11 * f18));
 f21 = Math_fround(Math_fround(f18 * Math_fround(f6 + f13)) - Math_fround(f9 * Math_fround(f21 + f4)));
 f16 = Math_fround(Math_fround(f8 * f18) - Math_fround(f16 * f9));
 f4 = Math_fround(Math_fround(f9 * f13) + Math_fround(f18 * f4));
 f13 = Math_fround(HEAPF32[i1 + 156 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 160 >> 2]);
 f6 = Math_fround(f13 + f8);
 f11 = Math_fround(HEAPF32[i1 + 164 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 196 >> 2]);
 f3 = Math_fround(f6 + Math_fround(f3 * Math_fround(f11 * f3)));
 f6 = Math_fround(HEAPF32[i1 + 168 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 200 >> 2]);
 f15 = Math_fround(f3 + Math_fround(f15 * Math_fround(f6 * f15)));
 i7 = f15 != Math_fround(0.0);
 f3 = Math_fround(-f4);
 f15 = Math_fround(f3 / f15);
 f15 = i7 ? f15 : Math_fround(0.0);
 f9 = Math_fround(f9 * f15);
 f18 = Math_fround(f18 * f15);
 f14 = Math_fround(f14 - Math_fround(f9 * f13));
 f13 = Math_fround(f23 - Math_fround(f18 * f13));
 f11 = Math_fround(f22 - Math_fround(Math_fround(f21 * f15) * f11));
 f9 = Math_fround(f20 + Math_fround(f9 * f8));
 f8 = Math_fround(f19 + Math_fround(f18 * f8));
 f6 = Math_fround(f17 + Math_fround(Math_fround(f16 * f15) * f6));
 i7 = HEAP32[i10 >> 2] | 0;
 HEAPF32[i12 + (i7 * 12 | 0) >> 2] = f14;
 HEAPF32[i12 + (i7 * 12 | 0) + 4 >> 2] = f13;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAPF32[i7 + ((HEAP32[i10 >> 2] | 0) * 12 | 0) + 8 >> 2] = f11;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i7 + (i1 * 12 | 0) >> 2] = f9;
 HEAPF32[i7 + (i1 * 12 | 0) + 4 >> 2] = f8;
 HEAPF32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 >> 2] = f6;
 i2 = f4 > Math_fround(0.0);
 return (i2 ? f4 : f3) <= Math_fround(.00499999989) | 0;
}

function runPostSets97() {
 HEAP32[gb + 94972 >> 2] = fb + 100;
 HEAP32[gb + 94976 >> 2] = fb + 76;
 HEAP32[gb + 94980 >> 2] = fb + 101;
 HEAP32[gb + 94984 >> 2] = fb + 77;
 HEAP32[gb + 94988 >> 2] = fb + 102;
 HEAP32[gb + 94992 >> 2] = fb + 78;
 HEAP32[gb + 94996 >> 2] = fb + 103;
 HEAP32[gb + 95e3 >> 2] = fb + 183;
 HEAP32[gb + 95004 >> 2] = fb + 291;
 HEAP32[gb + 95008 >> 2] = fb + 644;
 HEAP32[gb + 95012 >> 2] = fb + 1021;
 HEAP32[gb + 95016 >> 2] = fb + 292;
 HEAP32[gb + 95020 >> 2] = fb + 645;
 HEAP32[gb + 95024 >> 2] = fb + 1022;
 HEAP32[gb + 95028 >> 2] = fb + 1023;
 HEAP32[gb + 95032 >> 2] = fb + 79;
 HEAP32[gb + 95036 >> 2] = fb + 104;
 HEAP32[gb + 95040 >> 2] = fb + 80;
 HEAP32[gb + 95044 >> 2] = fb + 105;
 HEAP32[gb + 95048 >> 2] = fb + 81;
 HEAP32[gb + 95052 >> 2] = fb + 106;
 HEAP32[gb + 95056 >> 2] = fb + 82;
 HEAP32[gb + 95060 >> 2] = fb + 107;
 HEAP32[gb + 95064 >> 2] = fb + 1338;
 HEAP32[gb + 95068 >> 2] = fb + 1339;
 HEAP32[gb + 95072 >> 2] = fb + 646;
 HEAP32[gb + 95076 >> 2] = fb + 1024;
 HEAP32[gb + 95080 >> 2] = fb + 1025;
 HEAP32[gb + 95084 >> 2] = fb + 1026;
 HEAP32[gb + 95088 >> 2] = fb + 184;
 HEAP32[gb + 95100 >> 2] = fb + 647;
 HEAP32[gb + 95104 >> 2] = fb + 1340;
 HEAP32[gb + 95108 >> 2] = fb + 1341;
 HEAP32[gb + 95112 >> 2] = fb + 1342;
 HEAP32[gb + 95144 >> 2] = fb + 1343;
 HEAP32[gb + 95148 >> 2] = fb + 621;
 HEAP32[gb + 95152 >> 2] = fb + 456;
 HEAP32[gb + 95156 >> 2] = fb + 1344;
 HEAP32[gb + 95160 >> 2] = fb + 1345;
 HEAP32[gb + 95164 >> 2] = fb + 286;
 HEAP32[gb + 95168 >> 2] = fb + 1;
 HEAP32[gb + 95172 >> 2] = fb + 623;
 HEAP32[gb + 95176 >> 2] = fb + 980;
 HEAP32[gb + 95180 >> 2] = fb + 624;
 HEAP32[gb + 95184 >> 2] = fb + 1;
 HEAP32[gb + 95188 >> 2] = fb + 174;
 HEAP32[gb + 95192 >> 2] = fb + 981;
 HEAP32[gb + 95196 >> 2] = fb + 625;
 HEAP32[gb + 95200 >> 2] = fb + 982;
 HEAP32[gb + 95204 >> 2] = fb + 626;
 HEAP32[gb + 95208 >> 2] = fb + 983;
 HEAP32[gb + 95212 >> 2] = fb + 627;
 HEAP32[gb + 95216 >> 2] = fb + 984;
 HEAP32[gb + 95220 >> 2] = fb + 628;
 HEAP32[gb + 95224 >> 2] = fb + 629;
 HEAP32[gb + 95228 >> 2] = fb + 1;
 HEAP32[gb + 95232 >> 2] = fb + 1;
 HEAP32[gb + 95236 >> 2] = fb + 1;
 HEAP32[gb + 95240 >> 2] = fb + 1;
 HEAP32[gb + 95244 >> 2] = fb + 1;
 HEAP32[gb + 95248 >> 2] = fb + 1;
 HEAP32[gb + 95252 >> 2] = fb + 1;
 HEAP32[gb + 95256 >> 2] = fb + 1;
 HEAP32[gb + 95260 >> 2] = fb + 1;
 HEAP32[gb + 95264 >> 2] = fb + 1;
 HEAP32[gb + 95268 >> 2] = fb + 1;
 HEAP32[gb + 95272 >> 2] = fb + 1;
 HEAP32[gb + 95276 >> 2] = fb + 1;
 HEAP32[gb + 95280 >> 2] = fb + 1;
 HEAP32[gb + 95284 >> 2] = fb + 1;
 HEAP32[gb + 95288 >> 2] = fb + 1;
 HEAP32[gb + 95292 >> 2] = fb + 1;
 HEAP32[gb + 95296 >> 2] = fb + 1;
 HEAP32[gb + 95300 >> 2] = fb + 1;
 HEAP32[gb + 95304 >> 2] = fb + 1;
 HEAP32[gb + 95308 >> 2] = fb + 1;
 HEAP32[gb + 95312 >> 2] = fb + 1;
 HEAP32[gb + 95316 >> 2] = fb + 1;
 HEAP32[gb + 95320 >> 2] = fb + 1;
 HEAP32[gb + 95324 >> 2] = fb + 1;
 HEAP32[gb + 95328 >> 2] = fb + 1;
 HEAP32[gb + 95332 >> 2] = fb + 1;
 HEAP32[gb + 95336 >> 2] = fb + 1;
 HEAP32[gb + 95340 >> 2] = fb + 1;
 HEAP32[gb + 95344 >> 2] = fb + 1;
 HEAP32[gb + 95348 >> 2] = fb + 1;
 HEAP32[gb + 95352 >> 2] = fb + 1;
 HEAP32[gb + 95356 >> 2] = fb + 1;
 HEAP32[gb + 95360 >> 2] = fb + 1;
 HEAP32[gb + 95364 >> 2] = fb + 1;
 HEAP32[gb + 95368 >> 2] = fb + 1;
 HEAP32[gb + 95372 >> 2] = fb + 1;
 HEAP32[gb + 95376 >> 2] = fb + 1;
 HEAP32[gb + 95380 >> 2] = fb + 1;
 HEAP32[gb + 95384 >> 2] = fb + 1;
 HEAP32[gb + 95388 >> 2] = fb + 1;
 HEAP32[gb + 95392 >> 2] = fb + 1;
 HEAP32[gb + 95396 >> 2] = fb + 1;
 HEAP32[gb + 95400 >> 2] = fb + 1;
 HEAP32[gb + 95404 >> 2] = fb + 1;
 runPostSets98();
}

function __ZN19CollisionListener2DC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 56 | 0;
 i2 = i15;
 HEAP32[i3 >> 2] = gb + 154588 + 8;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 i1 = i3 + 13 | 0;
 HEAP8[i1 >> 0] = 0;
 i14 = i3 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = 0;
 i14 = i3 + 168 | 0;
 i4 = i14;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i3 + 176 | 0;
 HEAP32[i4 >> 2] = 0;
 i10 = i3 + 88 | 0;
 i11 = i10 + 40 | 0;
 do {
  HEAP32[i10 >> 2] = 0;
  i10 = i10 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i13 = i3 + 4 | 0;
 i5 = i3 + 180 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i3 + 184 >> 2] = 0;
 HEAP32[i3 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f16 = Math_fround((HEAP32[i5 >> 2] | 0) >>> 0);
 HEAP32[i3 + 192 >> 2] = ~~Math_fround(f16 * Math_fround(.5)) >>> 0;
 HEAP32[i3 + 188 >> 2] = ~~Math_fround(f16 * Math_fround(.200000003)) >>> 0;
 HEAP8[i3 + 196 >> 0] = 0;
 HEAP32[i3 + 204 >> 2] = 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 220 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i10 = i12;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3 + 208 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP8[i1 >> 0] = 1;
 i8 = i3 + 96 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i9 = i3 + 104 | 0;
 i10 = i9;
 i11 = i10 + 56 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  i10 = i10 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i10 | 0) < (i11 | 0));
 i6 = i3 + 160 | 0;
 i7 = i3 + 164 | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = (HEAP32[i5 >> 2] | 0) * 80 | 0;
 i3 = HEAP32[i3 + 200 >> 2] | 0;
 HEAP32[i12 >> 2] = 65;
 HEAP32[i12 + 4 >> 2] = i3;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 >> 2] = i1;
 i3 = i1 + ((HEAP32[i5 >> 2] | 0) * 80 | 0) | 0;
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i12 >> 2] = -1;
  i14 = i12 + 4 | 0;
  HEAP32[i14 >> 2] = -1;
  __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERSB_(i13, i12);
  STACKTOP = i15;
  return;
 }
 do {
  i11 = i8;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = i1;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = i2;
  i10 = i1 + 8 | 0;
  i2 = i9;
  i11 = i10 + 56 | 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
   i10 = i10 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i10 | 0) < (i11 | 0));
  HEAP32[i1 + 64 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 68 >> 2] = HEAP32[i7 >> 2];
  i5 = i14;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i11 = i1 + 72 | 0;
  HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i12 >> 2] = -1;
 i14 = i12 + 4 | 0;
 HEAP32[i14 >> 2] = -1;
 __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERSB_(i13, i12);
 STACKTOP = i15;
 return;
}

function __ZL26SelectClosestEdgeCB_ConvexRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i2 >> 2]));
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f6 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 f4 = Math_fround(f12 + f4);
 f6 = Math_fround(f11 + f6);
 f3 = Math_fround(f9 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 20 >> 2])));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 28 >> 2]));
 f11 = Math_fround(f4 + f11);
 f12 = Math_fround(f6 + f12);
 f9 = Math_fround(f3 + Math_fround(f9 * Math_fround(HEAPF32[i2 + 32 >> 2])));
 i10 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 f3 = Math_fround(f11 * Math_fround(HEAPF32[i10 >> 2]));
 f3 = Math_fround(f3 + Math_fround(f12 * Math_fround(HEAPF32[i10 + 4 >> 2])));
 f3 = Math_fround(f3 + Math_fround(f9 * Math_fround(HEAPF32[i10 + 8 >> 2])));
 if (i2 >>> 0 > 1) {
  i1 = 0;
  i5 = 1;
  do {
   f6 = Math_fround(f11 * Math_fround(HEAPF32[i10 + (i5 * 20 | 0) >> 2]));
   f6 = Math_fround(f6 + Math_fround(f12 * Math_fround(HEAPF32[i10 + (i5 * 20 | 0) + 4 >> 2])));
   f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i10 + (i5 * 20 | 0) + 8 >> 2])));
   i8 = f6 > f3;
   i1 = i8 ? i5 : i1;
   f3 = i8 ? f6 : f3;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i2 | 0));
  i8 = i1;
 } else i8 = 0;
 i5 = HEAP32[i7 + 20 >> 2] | 0;
 i7 = HEAP32[i7 + 36 >> 2] | 0;
 if (!i5) {
  i10 = i8;
  return i10 | 0;
 }
 i1 = -1;
 i2 = 0;
 f3 = Math_fround(f3 * f3);
 do {
  i15 = i2 << 1;
  i16 = HEAPU8[i7 + i15 >> 0] | 0;
  i15 = HEAPU8[i7 + (i15 | 1) >> 0] | 0;
  f14 = Math_fround(HEAPF32[i10 + (i16 * 20 | 0) >> 2]);
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i10 + (i15 * 20 | 0) >> 2]));
  f13 = Math_fround(HEAPF32[i10 + (i16 * 20 | 0) + 4 >> 2]);
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i10 + (i15 * 20 | 0) + 4 >> 2]));
  f4 = Math_fround(HEAPF32[i10 + (i16 * 20 | 0) + 8 >> 2]);
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i10 + (i15 * 20 | 0) + 8 >> 2]));
  f6 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(f4 * f4));
  f4 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f13)) + Math_fround(f9 * f4));
  if (f4 >= Math_fround(0.0)) {
   f4 = Math_fround(f4 * f4);
   if (f4 > Math_fround(f3 * f6)) {
    i1 = i2;
    f3 = Math_fround(f4 / f6);
   }
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 if ((i1 | 0) == -1) {
  i16 = i8;
  return i16 | 0;
 }
 i16 = i1 << 1;
 i15 = HEAPU8[i7 + i16 >> 0] | 0;
 i16 = HEAPU8[i7 + (i16 | 1) >> 0] | 0;
 f13 = Math_fround(f11 * Math_fround(HEAPF32[i10 + (i15 * 20 | 0) >> 2]));
 f13 = Math_fround(f13 + Math_fround(f12 * Math_fround(HEAPF32[i10 + (i15 * 20 | 0) + 4 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f9 * Math_fround(HEAPF32[i10 + (i15 * 20 | 0) + 8 >> 2])));
 f14 = Math_fround(f11 * Math_fround(HEAPF32[i10 + (i16 * 20 | 0) >> 2]));
 f14 = Math_fround(f14 + Math_fround(f12 * Math_fround(HEAPF32[i10 + (i16 * 20 | 0) + 4 >> 2])));
 i10 = f13 > Math_fround(f14 + Math_fround(f9 * Math_fround(HEAPF32[i10 + (i16 * 20 | 0) + 8 >> 2])));
 i16 = i10 ? i15 : i16;
 return i16 | 0;
}

function __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i22 + 8 | 0;
 i19 = i22;
 i20 = i22 + 16 | 0;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i19;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i20 >> 2] = 0;
 i15 = i20 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i20 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i18, i19);
 i9 = i18;
 i14 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i17;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i11 + 4 | 0;
 L1 : do if ((HEAP32[i13 >> 2] | 0) > 0) {
  i14 = i10 + 48 | 0;
  i1 = 0;
  i5 = 0;
  i8 = 0;
  i9 = 0;
  i4 = 0;
  while (1) {
   i6 = HEAP32[(HEAP32[i14 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) + i1 << 2) >> 2] | 0;
   i7 = i8 + 1 | 0;
   i3 = i9 & 2147483647;
   do if (i7 >>> 0 > i3 >>> 0) {
    i2 = i9 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i3 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
     HEAP32[i16 >> 2] = i2;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i2 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i20 >> 2] = i2;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
     HEAP32[i16 >> 2] = i2;
     HEAP32[i20 >> 2] = i9;
     i2 = i9;
     break;
    } else i2 = i5;
   } else i2 = i5; while (0);
   HEAP32[i15 >> 2] = i7;
   HEAP32[i2 + (i8 << 2) >> 2] = i6;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i13 >> 2] | 0)) break L1;
   i5 = i2;
   i8 = HEAP32[i15 >> 2] | 0;
   i9 = HEAP32[i16 >> 2] | 0;
   i4 = i2;
  }
 } while (0);
 __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE(HEAP32[gb + 1104056 >> 2] | 0, i10, i10 + 172 | 0, i12, i20);
 if (HEAP32[i15 >> 2] | 0) {
  i4 = 0;
  do {
   i5 = HEAP32[(HEAP32[i20 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   do if (i5 | 0) {
    HEAP32[i19 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i21 = 21; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i19);
      i2 = HEAP32[i18 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i21 = 21; else if (HEAP32[i1 + 4 >> 2] | 0) break;
    }
    if ((i21 | 0) == 21) i21 = 0;
    __Z31ReadObjectFromPersistentManageri(i5) | 0;
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i22;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i17);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i22;
 return;
}

function runPostSets23() {
 HEAP32[gb + 38744 >> 2] = fb + 1;
 HEAP32[gb + 38748 >> 2] = fb + 1;
 HEAP32[gb + 38752 >> 2] = fb + 1;
 HEAP32[gb + 38756 >> 2] = fb + 292;
 HEAP32[gb + 38760 >> 2] = fb + 285;
 HEAP32[gb + 38764 >> 2] = fb + 293;
 HEAP32[gb + 38768 >> 2] = fb + 294;
 HEAP32[gb + 38772 >> 2] = fb + 295;
 HEAP32[gb + 38776 >> 2] = fb + 296;
 HEAP32[gb + 38780 >> 2] = fb + 297;
 HEAP32[gb + 38784 >> 2] = fb + 298;
 HEAP32[gb + 38788 >> 2] = fb + 1;
 HEAP32[gb + 38792 >> 2] = fb + 286;
 HEAP32[gb + 38796 >> 2] = fb + 299;
 HEAP32[gb + 38800 >> 2] = fb + 22;
 HEAP32[gb + 38804 >> 2] = fb + 1;
 HEAP32[gb + 38808 >> 2] = fb + 1;
 HEAP32[gb + 38812 >> 2] = fb + 1;
 HEAP32[gb + 38816 >> 2] = fb + 1;
 HEAP32[gb + 38820 >> 2] = fb + 169;
 HEAP32[gb + 38824 >> 2] = fb + 23;
 HEAP32[gb + 38828 >> 2] = fb + 24;
 HEAP32[gb + 38832 >> 2] = fb + 25;
 HEAP32[gb + 38836 >> 2] = fb + 26;
 HEAP32[gb + 38840 >> 2] = fb + 287;
 HEAP32[gb + 38844 >> 2] = fb + 300;
 HEAP32[gb + 38848 >> 2] = fb + 170;
 HEAP32[gb + 38852 >> 2] = fb + 171;
 HEAP32[gb + 38856 >> 2] = fb + 172;
 HEAP32[gb + 38860 >> 2] = fb + 60;
 HEAP32[gb + 38864 >> 2] = fb + 61;
 HEAP32[gb + 38868 >> 2] = fb + 62;
 HEAP32[gb + 38872 >> 2] = fb + 63;
 HEAP32[gb + 38876 >> 2] = fb + 64;
 HEAP32[gb + 38880 >> 2] = fb + 288;
 HEAP32[gb + 38884 >> 2] = fb + 27;
 HEAP32[gb + 38888 >> 2] = fb + 173;
 HEAP32[gb + 38892 >> 2] = fb + 289;
 HEAP32[gb + 38896 >> 2] = fb + 11;
 HEAP32[gb + 38900 >> 2] = fb + 12;
 HEAP32[gb + 38904 >> 2] = fb + 28;
 HEAP32[gb + 38908 >> 2] = fb + 13;
 HEAP32[gb + 38912 >> 2] = fb + 29;
 HEAP32[gb + 38916 >> 2] = fb + 30;
 HEAP32[gb + 38920 >> 2] = fb + 301;
 HEAP32[gb + 38924 >> 2] = fb + 174;
 HEAP32[gb + 38928 >> 2] = fb + 27;
 HEAP32[gb + 38932 >> 2] = fb + 290;
 HEAP32[gb + 38936 >> 2] = fb + 1;
 HEAP32[gb + 38940 >> 2] = fb + 14;
 HEAP32[gb + 38944 >> 2] = fb + 31;
 HEAP32[gb + 38948 >> 2] = fb + 3;
 HEAP32[gb + 38952 >> 2] = fb + 291;
 HEAP32[gb + 38956 >> 2] = fb + 4;
 HEAP32[gb + 38960 >> 2] = fb + 3;
 HEAP32[gb + 38964 >> 2] = fb + 1;
 HEAP32[gb + 38968 >> 2] = fb + 292;
 HEAP32[gb + 38972 >> 2] = fb + 5;
 HEAP32[gb + 38976 >> 2] = fb + 15;
 HEAP32[gb + 38980 >> 2] = fb + 16;
 HEAP32[gb + 38984 >> 2] = fb + 17;
 HEAP32[gb + 38988 >> 2] = fb + 2;
 HEAP32[gb + 38992 >> 2] = fb + 6;
 HEAP32[gb + 38996 >> 2] = fb + 293;
 HEAP32[gb + 39e3 >> 2] = fb + 294;
 HEAP32[gb + 39004 >> 2] = fb + 32;
 HEAP32[gb + 39008 >> 2] = fb + 175;
 HEAP32[gb + 39012 >> 2] = fb + 176;
 HEAP32[gb + 39016 >> 2] = fb + 18;
 HEAP32[gb + 39020 >> 2] = fb + 19;
 HEAP32[gb + 39024 >> 2] = fb + 177;
 HEAP32[gb + 39028 >> 2] = fb + 178;
 HEAP32[gb + 39032 >> 2] = fb + 295;
 HEAP32[gb + 39036 >> 2] = fb + 3;
 HEAP32[gb + 39040 >> 2] = fb + 1;
 HEAP32[gb + 39044 >> 2] = fb + 1;
 HEAP32[gb + 39060 >> 2] = fb + 4;
 HEAP32[gb + 39064 >> 2] = fb + 302;
 HEAP32[gb + 39088 >> 2] = fb + 275;
 HEAP32[gb + 39092 >> 2] = fb + 303;
 HEAP32[gb + 39096 >> 2] = fb + 277;
 HEAP32[gb + 39100 >> 2] = fb + 278;
 HEAP32[gb + 39104 >> 2] = fb + 279;
 HEAP32[gb + 39108 >> 2] = fb + 151;
 HEAP32[gb + 39112 >> 2] = fb + 260;
 HEAP32[gb + 39116 >> 2] = fb + 261;
 HEAP32[gb + 39120 >> 2] = fb + 1;
 HEAP32[gb + 39124 >> 2] = fb + 262;
 HEAP32[gb + 39128 >> 2] = fb + 280;
 HEAP32[gb + 39132 >> 2] = fb + 1;
 HEAP32[gb + 39136 >> 2] = fb + 1;
 HEAP32[gb + 39140 >> 2] = fb + 1;
 HEAP32[gb + 39144 >> 2] = fb + 1;
 HEAP32[gb + 39148 >> 2] = fb + 1;
 HEAP32[gb + 39152 >> 2] = fb + 1;
 HEAP32[gb + 39156 >> 2] = fb + 1;
 HEAP32[gb + 39160 >> 2] = fb + 1;
 HEAP32[gb + 39164 >> 2] = fb + 263;
 HEAP32[gb + 39168 >> 2] = fb + 1;
 HEAP32[gb + 39172 >> 2] = fb + 1;
 runPostSets24();
}

function __ZN9b2Simplex6Solve3Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f16 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 i1 = i3 + 36 | 0;
 f13 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 i2 = i3 + 72 | 0;
 f17 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 92 >> 2]);
 f19 = Math_fround(f13 - f16);
 f10 = Math_fround(f15 - f14);
 f4 = Math_fround(Math_fround(f16 * f19) + Math_fround(f14 * f10));
 f5 = Math_fround(Math_fround(f13 * f19) + Math_fround(f15 * f10));
 f12 = Math_fround(f17 - f16);
 f18 = Math_fround(f11 - f14);
 f6 = Math_fround(Math_fround(f16 * f12) + Math_fround(f14 * f18));
 f7 = Math_fround(Math_fround(f17 * f12) + Math_fround(f11 * f18));
 f20 = Math_fround(f17 - f13);
 f9 = Math_fround(f11 - f15);
 f8 = Math_fround(Math_fround(f13 * f20) + Math_fround(f15 * f9));
 f9 = Math_fround(Math_fround(f17 * f20) + Math_fround(f11 * f9));
 f12 = Math_fround(Math_fround(f19 * f18) - Math_fround(f10 * f12));
 f10 = Math_fround(Math_fround(Math_fround(f13 * f11) - Math_fround(f15 * f17)) * f12);
 f11 = Math_fround(Math_fround(Math_fround(f14 * f17) - Math_fround(f16 * f11)) * f12);
 f12 = Math_fround(Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13)) * f12);
 if (f4 >= Math_fround(-0.0) & f6 >= Math_fround(-0.0)) {
  HEAPF32[i3 + 24 >> 2] = Math_fround(1.0);
  HEAP32[i3 + 108 >> 2] = 1;
  return;
 }
 if (f5 > Math_fround(0.0) & f4 < Math_fround(-0.0) & f12 <= Math_fround(0.0)) {
  f20 = Math_fround(Math_fround(1.0) / Math_fround(f5 - f4));
  HEAPF32[i3 + 24 >> 2] = Math_fround(f5 * f20);
  HEAPF32[i3 + 60 >> 2] = Math_fround(-Math_fround(f4 * f20));
  HEAP32[i3 + 108 >> 2] = 2;
  return;
 }
 if (f7 > Math_fround(0.0) & f6 < Math_fround(-0.0) & f11 <= Math_fround(0.0)) {
  f20 = Math_fround(Math_fround(1.0) / Math_fround(f7 - f6));
  HEAPF32[i3 + 24 >> 2] = Math_fround(f7 * f20);
  HEAPF32[i3 + 96 >> 2] = Math_fround(-Math_fround(f6 * f20));
  HEAP32[i3 + 108 >> 2] = 2;
  i3 = i1;
  i1 = i2;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 }
 if (f5 <= Math_fround(0.0) & f8 >= Math_fround(-0.0)) {
  HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
  HEAP32[i3 + 108 >> 2] = 1;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 }
 if (f7 <= Math_fround(0.0) & f9 <= Math_fround(0.0)) {
  HEAPF32[i3 + 96 >> 2] = Math_fround(1.0);
  HEAP32[i3 + 108 >> 2] = 1;
  i1 = i2;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 }
 if (f9 > Math_fround(0.0) & f8 < Math_fround(-0.0) & f10 <= Math_fround(0.0)) {
  f20 = Math_fround(Math_fround(1.0) / Math_fround(f9 - f8));
  HEAPF32[i3 + 60 >> 2] = Math_fround(f9 * f20);
  HEAPF32[i3 + 96 >> 2] = Math_fround(-Math_fround(f8 * f20));
  HEAP32[i3 + 108 >> 2] = 2;
  i1 = i2;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 } else {
  f20 = Math_fround(Math_fround(1.0) / Math_fround(f12 + Math_fround(f10 + f11)));
  HEAPF32[i3 + 24 >> 2] = Math_fround(f10 * f20);
  HEAPF32[i3 + 60 >> 2] = Math_fround(f11 * f20);
  HEAPF32[i3 + 96 >> 2] = Math_fround(f12 * f20);
  HEAP32[i3 + 108 >> 2] = 3;
  return;
 }
}

function __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = HEAP32[i7 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = i1 + -12 | 0;
  HEAP32[i9 >> 2] = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i9 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 & i1;
 i1 = i2 ^ i1;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = i1 ^ i2;
 i11 = HEAP32[i6 + 12 >> 2] | 0;
 i2 = i5 & i11 | i1 & i2;
 i11 = i5 ^ i11;
 i5 = i2 & i4;
 i4 = i2 ^ i4;
 i5 = i5 - (i5 >>> 1 & 1431655765) | 0;
 i5 = (i5 >>> 2 & 858993459) + (i5 & 858993459) | 0;
 i5 = (Math_imul((i5 >>> 4) + i5 & 252645135, 16843009) | 0) >>> 24;
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 i1 = i2 ^ i11;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 i11 = i1 & i12 | i2 & i11;
 i12 = i1 ^ i12;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i12 ^ i1;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = i2 & i3 | i12 & i1;
 i3 = i2 ^ i3;
 i2 = i11 ^ i4;
 i4 = i1 & i2 | i11 & i4;
 i2 = i1 ^ i2;
 i4 = i4 - (i4 >>> 1 & 1431655765) | 0;
 i4 = (i4 >>> 2 & 858993459) + (i4 & 858993459) | 0;
 i2 = i2 - (i2 >>> 1 & 1431655765) | 0;
 i2 = (i2 >>> 2 & 858993459) + (i2 & 858993459) | 0;
 i3 = i3 - (i3 >>> 1 & 1431655765) | 0;
 i3 = (i3 >>> 2 & 858993459) + (i3 & 858993459) | 0;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj(i7, ((Math_imul((i2 >>> 4) + i2 & 252645135, 16843009) | 0) >>> 24 << 1) + ((Math_imul((i3 >>> 4) + i3 & 252645135, 16843009) | 0) >>> 24) + (((Math_imul((i4 >>> 4) + i4 & 252645135, 16843009) | 0) >>> 24) + i5 << 2) | 0);
 i5 = i7 + 8 | 0;
 i4 = 0;
 do {
  if (HEAP32[i6 + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31) | 0) {
   i3 = HEAP32[gb + 1166252 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i3 = i3 + 4 | 0;
   i2 = i1;
   L9 : do if ((i2 | 0) == (i3 | 0)) i1 = gb + 1576256 | 0; else {
    while (1) {
     if ((HEAP32[i2 + 20 >> 2] | 0) == (i4 | 0)) break;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (i3 | 0)) {
      i1 = gb + 1576256 | 0;
      break L9;
     } else i1 = i2;
    }
    i1 = HEAP32[i2 + 16 >> 2] | 0;
   } while (0);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, _strlen(i1) | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i7, i8); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i8);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 256);
 __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] | 0, i8);
 STACKTOP = i10;
 return;
}

function __Z23VehicleComputeTireForcePKvffffffffffffRfS1_S1_S1_(i13, f1, f10, f11, f4, f5, f18, f6, f7, f8, f12, f2, f3, i14, i15, i16, i17) {
 i13 = i13 | 0;
 f1 = Math_fround(f1);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f18 = Math_fround(f18);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f12 = Math_fround(f12);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i9 = 0, i19 = 0;
 i9 = i13 + 20 | 0;
 f4 = Math_fround(Math_abs(Math_fround(f10)));
 i19 = f10 >= Math_fround(0.0);
 f5 = i19 ? Math_fround(1.0) : Math_fround(-1.0);
 f2 = Math_fround(HEAPF32[i13 >> 2]);
 if (f4 < f2) {
  f8 = Math_fround(f4 / f2);
  f10 = Math_fround(f8 * f8);
  f1 = Math_fround(f8 * f10);
  f1 = Math_fround(Math_fround(f8 + Math_fround(f10 - f1)) * Math_fround(HEAPF32[i13 + 4 >> 2]));
 } else {
  f3 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f1 = Math_fround(HEAPF32[i13 + 12 >> 2]);
  if (f4 < f3) {
   f8 = Math_fround(Math_fround(f4 - f2) / Math_fround(f3 - f2));
   f10 = Math_fround(f8 * f8);
   f8 = Math_fround(f8 * f10);
   f7 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f1 = Math_fround(f1 - f7);
   f1 = Math_fround(f7 + Math_fround(Math_fround(f8 * Math_fround(f1 * Math_fround(-2.0))) + Math_fround(f10 * Math_fround(f1 * Math_fround(3.0)))));
  }
 }
 f6 = Math_fround(f5 * f1);
 f4 = Math_fround(Math_abs(Math_fround(f11)));
 i19 = f11 >= Math_fround(0.0);
 f5 = i19 ? Math_fround(1.0) : Math_fround(-1.0);
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 do if (f4 < f2) {
  f10 = Math_fround(f4 / f2);
  f11 = Math_fround(f10 * f10);
  f1 = Math_fround(f10 * f11);
  f4 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  f1 = Math_fround(Math_fround(f10 + Math_fround(f11 - f1)) * f4);
 } else {
  f3 = Math_fround(HEAPF32[i13 + 28 >> 2]);
  f1 = Math_fround(HEAPF32[i13 + 32 >> 2]);
  if (f4 < f3) {
   f10 = Math_fround(Math_fround(f4 - f2) / Math_fround(f3 - f2));
   f11 = Math_fround(f10 * f10);
   f10 = Math_fround(f10 * f11);
   f4 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   f1 = Math_fround(f1 - f4);
   f1 = Math_fround(f4 + Math_fround(Math_fround(f10 * Math_fround(f1 * Math_fround(-2.0))) + Math_fround(f11 * Math_fround(f1 * Math_fround(3.0)))));
   break;
  } else {
   f4 = Math_fround(HEAPF32[i13 + 24 >> 2]);
   break;
  }
 } while (0);
 f1 = Math_fround(-Math_fround(f5 * f1));
 f3 = Math_fround(f6 * f12);
 f2 = Math_fround(f12 * f1);
 f12 = Math_fround(f6 / Math_fround(HEAPF32[i13 + 4 >> 2]));
 f1 = Math_fround(f1 / f4);
 f1 = Math_fround(Math_fround(f12 * f12) + Math_fround(f1 * f1));
 if (!(f1 > Math_fround(1.0))) {
  f10 = f3;
  f11 = f2;
  i19 = i13 + 16 | 0;
  f12 = Math_fround(HEAPF32[i19 >> 2]);
  f12 = Math_fround(f10 * f12);
  HEAPF32[i15 >> 2] = f12;
  i19 = i13 + 36 | 0;
  f12 = Math_fround(HEAPF32[i19 >> 2]);
  f12 = Math_fround(f11 * f12);
  HEAPF32[i16 >> 2] = f12;
  f12 = Math_fround(HEAPF32[i15 >> 2]);
  f18 = Math_fround(f12 * f18);
  f18 = Math_fround(-f18);
  HEAPF32[i14 >> 2] = f18;
  HEAPF32[i17 >> 2] = Math_fround(0.0);
  return;
 }
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f1))));
 f10 = Math_fround(f3 * f11);
 f11 = Math_fround(f2 * f11);
 i19 = i13 + 16 | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(f10 * f12);
 HEAPF32[i15 >> 2] = f12;
 i19 = i13 + 36 | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f12 = Math_fround(f11 * f12);
 HEAPF32[i16 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i15 >> 2]);
 f18 = Math_fround(f12 * f18);
 f18 = Math_fround(-f18);
 HEAPF32[i14 >> 2] = f18;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 return;
}

function runPostSets105() {
 HEAP32[gb + 98304 >> 2] = fb + 1;
 HEAP32[gb + 98308 >> 2] = fb + 1;
 HEAP32[gb + 98312 >> 2] = fb + 1;
 HEAP32[gb + 98316 >> 2] = fb + 1062;
 HEAP32[gb + 98320 >> 2] = fb + 198;
 HEAP32[gb + 98324 >> 2] = fb + 688;
 HEAP32[gb + 98328 >> 2] = fb + 85;
 HEAP32[gb + 98332 >> 2] = fb + 689;
 HEAP32[gb + 98336 >> 2] = fb + 86;
 HEAP32[gb + 98340 >> 2] = fb + 1;
 HEAP32[gb + 98344 >> 2] = fb + 1;
 HEAP32[gb + 98348 >> 2] = fb + 1;
 HEAP32[gb + 98352 >> 2] = fb + 1;
 HEAP32[gb + 98356 >> 2] = fb + 1;
 HEAP32[gb + 98360 >> 2] = fb + 1;
 HEAP32[gb + 98364 >> 2] = fb + 1;
 HEAP32[gb + 98368 >> 2] = fb + 1;
 HEAP32[gb + 98372 >> 2] = fb + 1;
 HEAP32[gb + 98376 >> 2] = fb + 1;
 HEAP32[gb + 98380 >> 2] = fb + 1;
 HEAP32[gb + 98384 >> 2] = fb + 1;
 HEAP32[gb + 98388 >> 2] = fb + 1;
 HEAP32[gb + 98392 >> 2] = fb + 1;
 HEAP32[gb + 98396 >> 2] = fb + 1;
 HEAP32[gb + 98400 >> 2] = fb + 1;
 HEAP32[gb + 98404 >> 2] = fb + 1;
 HEAP32[gb + 98408 >> 2] = fb + 1;
 HEAP32[gb + 98412 >> 2] = fb + 1;
 HEAP32[gb + 98416 >> 2] = fb + 1;
 HEAP32[gb + 98420 >> 2] = fb + 1;
 HEAP32[gb + 98424 >> 2] = fb + 1;
 HEAP32[gb + 98428 >> 2] = fb + 1;
 HEAP32[gb + 98432 >> 2] = fb + 1;
 HEAP32[gb + 98436 >> 2] = fb + 1;
 HEAP32[gb + 98440 >> 2] = fb + 1;
 HEAP32[gb + 98444 >> 2] = fb + 1;
 HEAP32[gb + 98448 >> 2] = fb + 1;
 HEAP32[gb + 98452 >> 2] = fb + 1;
 HEAP32[gb + 98456 >> 2] = fb + 1;
 HEAP32[gb + 98460 >> 2] = fb + 1;
 HEAP32[gb + 98464 >> 2] = fb + 1;
 HEAP32[gb + 98468 >> 2] = fb + 1;
 HEAP32[gb + 98472 >> 2] = fb + 1;
 HEAP32[gb + 98476 >> 2] = fb + 1;
 HEAP32[gb + 98480 >> 2] = fb + 1;
 HEAP32[gb + 98484 >> 2] = fb + 1;
 HEAP32[gb + 98488 >> 2] = fb + 1;
 HEAP32[gb + 98492 >> 2] = fb + 1;
 HEAP32[gb + 98496 >> 2] = fb + 1;
 HEAP32[gb + 98500 >> 2] = fb + 1;
 HEAP32[gb + 98504 >> 2] = fb + 1;
 HEAP32[gb + 98508 >> 2] = fb + 1;
 HEAP32[gb + 98512 >> 2] = fb + 1;
 HEAP32[gb + 98516 >> 2] = fb + 1;
 HEAP32[gb + 98520 >> 2] = fb + 1;
 HEAP32[gb + 98524 >> 2] = fb + 1;
 HEAP32[gb + 98528 >> 2] = fb + 1063;
 HEAP32[gb + 98532 >> 2] = fb + 1064;
 HEAP32[gb + 98536 >> 2] = fb + 1065;
 HEAP32[gb + 98540 >> 2] = fb + 1377;
 HEAP32[gb + 98544 >> 2] = fb + 1378;
 HEAP32[gb + 98556 >> 2] = fb + 1374;
 HEAP32[gb + 98560 >> 2] = fb + 680;
 HEAP32[gb + 98564 >> 2] = fb + 456;
 HEAP32[gb + 98568 >> 2] = fb + 1379;
 HEAP32[gb + 98572 >> 2] = fb + 1380;
 HEAP32[gb + 98576 >> 2] = fb + 303;
 HEAP32[gb + 98580 >> 2] = fb + 1;
 HEAP32[gb + 98584 >> 2] = fb + 681;
 HEAP32[gb + 98588 >> 2] = fb + 1057;
 HEAP32[gb + 98592 >> 2] = fb + 682;
 HEAP32[gb + 98596 >> 2] = fb + 19;
 HEAP32[gb + 98600 >> 2] = fb + 197;
 HEAP32[gb + 98604 >> 2] = fb + 1058;
 HEAP32[gb + 98608 >> 2] = fb + 683;
 HEAP32[gb + 98612 >> 2] = fb + 1059;
 HEAP32[gb + 98616 >> 2] = fb + 684;
 HEAP32[gb + 98620 >> 2] = fb + 1060;
 HEAP32[gb + 98624 >> 2] = fb + 685;
 HEAP32[gb + 98628 >> 2] = fb + 1061;
 HEAP32[gb + 98632 >> 2] = fb + 686;
 HEAP32[gb + 98636 >> 2] = fb + 687;
 HEAP32[gb + 98640 >> 2] = fb + 1;
 HEAP32[gb + 98644 >> 2] = fb + 1;
 HEAP32[gb + 98648 >> 2] = fb + 51;
 HEAP32[gb + 98652 >> 2] = fb + 1066;
 HEAP32[gb + 98656 >> 2] = fb + 198;
 HEAP32[gb + 98660 >> 2] = fb + 688;
 HEAP32[gb + 98664 >> 2] = fb + 85;
 HEAP32[gb + 98668 >> 2] = fb + 689;
 HEAP32[gb + 98672 >> 2] = fb + 86;
 HEAP32[gb + 98676 >> 2] = fb + 1;
 HEAP32[gb + 98680 >> 2] = fb + 1067;
 HEAP32[gb + 98684 >> 2] = fb + 104;
 HEAP32[gb + 98688 >> 2] = fb + 129;
 HEAP32[gb + 98692 >> 2] = fb + 130;
 HEAP32[gb + 98696 >> 2] = fb + 1068;
 HEAP32[gb + 98700 >> 2] = fb + 1069;
 HEAP32[gb + 98704 >> 2] = fb + 1070;
 HEAP32[gb + 98708 >> 2] = fb + 1071;
 runPostSets106();
}

function runPostSets90() {
 HEAP32[gb + 91928 >> 2] = fb + 570;
 HEAP32[gb + 91932 >> 2] = fb + 571;
 HEAP32[gb + 91936 >> 2] = fb + 1;
 HEAP32[gb + 91940 >> 2] = fb + 1;
 HEAP32[gb + 91944 >> 2] = fb + 1;
 HEAP32[gb + 91948 >> 2] = fb + 933;
 HEAP32[gb + 91952 >> 2] = fb + 157;
 HEAP32[gb + 91956 >> 2] = fb + 572;
 HEAP32[gb + 91960 >> 2] = fb + 74;
 HEAP32[gb + 91964 >> 2] = fb + 573;
 HEAP32[gb + 91968 >> 2] = fb + 75;
 HEAP32[gb + 91972 >> 2] = fb + 1;
 HEAP32[gb + 91976 >> 2] = fb + 1;
 HEAP32[gb + 91980 >> 2] = fb + 1;
 HEAP32[gb + 91984 >> 2] = fb + 1;
 HEAP32[gb + 91988 >> 2] = fb + 1;
 HEAP32[gb + 91992 >> 2] = fb + 1;
 HEAP32[gb + 91996 >> 2] = fb + 1;
 HEAP32[gb + 92e3 >> 2] = fb + 1;
 HEAP32[gb + 92004 >> 2] = fb + 1;
 HEAP32[gb + 92008 >> 2] = fb + 1;
 HEAP32[gb + 92012 >> 2] = fb + 1;
 HEAP32[gb + 92016 >> 2] = fb + 1;
 HEAP32[gb + 92020 >> 2] = fb + 1;
 HEAP32[gb + 92024 >> 2] = fb + 1;
 HEAP32[gb + 92028 >> 2] = fb + 1;
 HEAP32[gb + 92032 >> 2] = fb + 1;
 HEAP32[gb + 92036 >> 2] = fb + 1;
 HEAP32[gb + 92040 >> 2] = fb + 1;
 HEAP32[gb + 92044 >> 2] = fb + 1;
 HEAP32[gb + 92048 >> 2] = fb + 1;
 HEAP32[gb + 92052 >> 2] = fb + 1;
 HEAP32[gb + 92056 >> 2] = fb + 1;
 HEAP32[gb + 92060 >> 2] = fb + 1;
 HEAP32[gb + 92064 >> 2] = fb + 1;
 HEAP32[gb + 92068 >> 2] = fb + 1;
 HEAP32[gb + 92072 >> 2] = fb + 1;
 HEAP32[gb + 92076 >> 2] = fb + 1;
 HEAP32[gb + 92080 >> 2] = fb + 1;
 HEAP32[gb + 92084 >> 2] = fb + 1;
 HEAP32[gb + 92088 >> 2] = fb + 1;
 HEAP32[gb + 92092 >> 2] = fb + 934;
 HEAP32[gb + 92096 >> 2] = fb + 935;
 HEAP32[gb + 92100 >> 2] = fb + 936;
 HEAP32[gb + 92104 >> 2] = fb + 1275;
 HEAP32[gb + 92108 >> 2] = fb + 1276;
 HEAP32[gb + 92120 >> 2] = fb + 1272;
 HEAP32[gb + 92124 >> 2] = fb + 564;
 HEAP32[gb + 92128 >> 2] = fb + 456;
 HEAP32[gb + 92132 >> 2] = fb + 1277;
 HEAP32[gb + 92136 >> 2] = fb + 1278;
 HEAP32[gb + 92140 >> 2] = fb + 264;
 HEAP32[gb + 92144 >> 2] = fb + 1;
 HEAP32[gb + 92148 >> 2] = fb + 565;
 HEAP32[gb + 92152 >> 2] = fb + 928;
 HEAP32[gb + 92156 >> 2] = fb + 566;
 HEAP32[gb + 92160 >> 2] = fb + 13;
 HEAP32[gb + 92164 >> 2] = fb + 156;
 HEAP32[gb + 92168 >> 2] = fb + 929;
 HEAP32[gb + 92172 >> 2] = fb + 567;
 HEAP32[gb + 92176 >> 2] = fb + 930;
 HEAP32[gb + 92180 >> 2] = fb + 568;
 HEAP32[gb + 92184 >> 2] = fb + 931;
 HEAP32[gb + 92188 >> 2] = fb + 569;
 HEAP32[gb + 92192 >> 2] = fb + 932;
 HEAP32[gb + 92196 >> 2] = fb + 570;
 HEAP32[gb + 92200 >> 2] = fb + 571;
 HEAP32[gb + 92204 >> 2] = fb + 1;
 HEAP32[gb + 92208 >> 2] = fb + 1;
 HEAP32[gb + 92212 >> 2] = fb + 49;
 HEAP32[gb + 92216 >> 2] = fb + 937;
 HEAP32[gb + 92220 >> 2] = fb + 157;
 HEAP32[gb + 92224 >> 2] = fb + 572;
 HEAP32[gb + 92228 >> 2] = fb + 74;
 HEAP32[gb + 92232 >> 2] = fb + 573;
 HEAP32[gb + 92236 >> 2] = fb + 75;
 HEAP32[gb + 92240 >> 2] = fb + 1;
 HEAP32[gb + 92244 >> 2] = fb + 938;
 HEAP32[gb + 92248 >> 2] = fb + 62;
 HEAP32[gb + 92252 >> 2] = fb + 87;
 HEAP32[gb + 92256 >> 2] = fb + 88;
 HEAP32[gb + 92260 >> 2] = fb + 939;
 HEAP32[gb + 92264 >> 2] = fb + 940;
 HEAP32[gb + 92268 >> 2] = fb + 941;
 HEAP32[gb + 92272 >> 2] = fb + 942;
 HEAP32[gb + 92276 >> 2] = fb + 1;
 HEAP32[gb + 92280 >> 2] = fb + 943;
 HEAP32[gb + 92284 >> 2] = fb + 1;
 HEAP32[gb + 92288 >> 2] = fb + 1;
 HEAP32[gb + 92292 >> 2] = fb + 1;
 HEAP32[gb + 92296 >> 2] = fb + 1;
 HEAP32[gb + 92300 >> 2] = fb + 1;
 HEAP32[gb + 92304 >> 2] = fb + 158;
 HEAP32[gb + 92308 >> 2] = fb + 944;
 HEAP32[gb + 92312 >> 2] = fb + 159;
 HEAP32[gb + 92316 >> 2] = fb + 945;
 HEAP32[gb + 92320 >> 2] = fb + 574;
 HEAP32[gb + 92324 >> 2] = fb + 575;
 HEAP32[gb + 92328 >> 2] = fb + 63;
 HEAP32[gb + 92332 >> 2] = fb + 89;
 runPostSets91();
}

function runPostSets33() {
 HEAP32[gb + 44692 >> 2] = fb + 19;
 HEAP32[gb + 44696 >> 2] = fb + 11;
 HEAP32[gb + 44700 >> 2] = fb + 20;
 HEAP32[gb + 44704 >> 2] = fb + 12;
 HEAP32[gb + 44708 >> 2] = fb + 21;
 HEAP32[gb + 44712 >> 2] = fb + 373;
 HEAP32[gb + 44716 >> 2] = fb + 1;
 HEAP32[gb + 44720 >> 2] = fb + 1;
 HEAP32[gb + 44724 >> 2] = fb + 9;
 HEAP32[gb + 44728 >> 2] = fb + 3;
 HEAP32[gb + 44732 >> 2] = fb + 227;
 HEAP32[gb + 44736 >> 2] = fb + 25;
 HEAP32[gb + 44740 >> 2] = fb + 26;
 HEAP32[gb + 44744 >> 2] = fb + 14;
 HEAP32[gb + 44748 >> 2] = fb + 27;
 HEAP32[gb + 44752 >> 2] = fb + 15;
 HEAP32[gb + 44756 >> 2] = fb + 1;
 HEAP32[gb + 44760 >> 2] = fb + 10;
 HEAP32[gb + 44772 >> 2] = fb + 386;
 HEAP32[gb + 44776 >> 2] = fb + 387;
 HEAP32[gb + 44788 >> 2] = fb + 388;
 HEAP32[gb + 44792 >> 2] = fb + 389;
 HEAP32[gb + 44804 >> 2] = fb + 3;
 HEAP32[gb + 44808 >> 2] = fb + 3;
 HEAP32[gb + 44812 >> 2] = fb + 35;
 HEAP32[gb + 44816 >> 2] = fb + 72;
 HEAP32[gb + 44820 >> 2] = fb + 16;
 HEAP32[gb + 44824 >> 2] = fb + 17;
 HEAP32[gb + 44828 >> 2] = fb + 23;
 HEAP32[gb + 44832 >> 2] = fb + 36;
 HEAP32[gb + 44844 >> 2] = fb + 4;
 HEAP32[gb + 44848 >> 2] = fb + 4;
 HEAP32[gb + 44852 >> 2] = fb + 37;
 HEAP32[gb + 44856 >> 2] = fb + 73;
 HEAP32[gb + 44860 >> 2] = fb + 18;
 HEAP32[gb + 44864 >> 2] = fb + 19;
 HEAP32[gb + 44868 >> 2] = fb + 24;
 HEAP32[gb + 44872 >> 2] = fb + 9;
 HEAP32[gb + 44884 >> 2] = fb + 5;
 HEAP32[gb + 44888 >> 2] = fb + 5;
 HEAP32[gb + 44892 >> 2] = fb + 38;
 HEAP32[gb + 44896 >> 2] = fb + 74;
 HEAP32[gb + 44900 >> 2] = fb + 20;
 HEAP32[gb + 44904 >> 2] = fb + 21;
 HEAP32[gb + 44908 >> 2] = fb + 24;
 HEAP32[gb + 44912 >> 2] = fb + 9;
 HEAP32[gb + 44924 >> 2] = fb + 390;
 HEAP32[gb + 44928 >> 2] = fb + 391;
 HEAP32[gb + 44932 >> 2] = fb + 392;
 HEAP32[gb + 44936 >> 2] = fb + 39;
 HEAP32[gb + 44940 >> 2] = fb + 16;
 HEAP32[gb + 44944 >> 2] = fb + 17;
 HEAP32[gb + 44948 >> 2] = fb + 18;
 HEAP32[gb + 44952 >> 2] = fb + 19;
 HEAP32[gb + 44956 >> 2] = fb + 228;
 HEAP32[gb + 44960 >> 2] = fb + 31;
 HEAP32[gb + 44964 >> 2] = fb + 27;
 HEAP32[gb + 44968 >> 2] = fb + 32;
 HEAP32[gb + 44972 >> 2] = fb + 28;
 HEAP32[gb + 44976 >> 2] = fb + 63;
 HEAP32[gb + 44980 >> 2] = fb + 29;
 HEAP32[gb + 44984 >> 2] = fb + 34;
 HEAP32[gb + 44988 >> 2] = fb + 30;
 HEAP32[gb + 44992 >> 2] = fb + 31;
 HEAP32[gb + 44996 >> 2] = fb + 32;
 HEAP32[gb + 45e3 >> 2] = fb + 33;
 HEAP32[gb + 45004 >> 2] = fb + 34;
 HEAP32[gb + 45008 >> 2] = fb + 35;
 HEAP32[gb + 45012 >> 2] = fb + 36;
 HEAP32[gb + 45016 >> 2] = fb + 393;
 HEAP32[gb + 45020 >> 2] = fb + 35;
 HEAP32[gb + 45024 >> 2] = fb + 36;
 HEAP32[gb + 45028 >> 2] = fb + 37;
 HEAP32[gb + 45032 >> 2] = fb + 37;
 HEAP32[gb + 45036 >> 2] = fb + 38;
 HEAP32[gb + 45040 >> 2] = fb + 39;
 HEAP32[gb + 45044 >> 2] = fb + 40;
 HEAP32[gb + 45048 >> 2] = fb + 41;
 HEAP32[gb + 45052 >> 2] = fb + 42;
 HEAP32[gb + 45056 >> 2] = fb + 43;
 HEAP32[gb + 45060 >> 2] = fb + 229;
 HEAP32[gb + 45064 >> 2] = fb + 230;
 HEAP32[gb + 45068 >> 2] = fb + 46;
 HEAP32[gb + 45072 >> 2] = fb + 231;
 HEAP32[gb + 45076 >> 2] = fb + 48;
 HEAP32[gb + 45080 >> 2] = fb + 232;
 HEAP32[gb + 45084 >> 2] = fb + 374;
 HEAP32[gb + 45088 >> 2] = fb + 394;
 HEAP32[gb + 45092 >> 2] = fb + 10;
 HEAP32[gb + 45104 >> 2] = fb + 395;
 HEAP32[gb + 45108 >> 2] = fb + 396;
 HEAP32[gb + 45112 >> 2] = fb + 397;
 HEAP32[gb + 45116 >> 2] = fb + 39;
 HEAP32[gb + 45120 >> 2] = fb + 16;
 HEAP32[gb + 45124 >> 2] = fb + 17;
 HEAP32[gb + 45128 >> 2] = fb + 18;
 HEAP32[gb + 45132 >> 2] = fb + 19;
 HEAP32[gb + 45136 >> 2] = fb + 233;
 HEAP32[gb + 45140 >> 2] = fb + 31;
 HEAP32[gb + 45144 >> 2] = fb + 27;
 runPostSets34();
}

function __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i20, i18, i19, i6) {
 i20 = i20 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i21 + 8 | 0;
 i1 = i21 + 78 | 0;
 i5 = i21 + 32 | 0;
 i9 = i21 + 12 | 0;
 i10 = i21 + 40 | 0;
 i13 = i21 + 77 | 0;
 i16 = i21;
 i17 = i21 + 76 | 0;
 i7 = (i19 | 0) == 0;
 i8 = i20 + 72 + (i18 << 2) | 0;
 do if (i7) {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 < 65) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * (i3 << 4) | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i14 = i1;
   i15 = 1;
   break;
  }
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i1, (i2 << 4) + 16 | 0, gb + 704671 | 0, 171) | 0;
  if (!i1) {
   HEAP8[i20 + 116 + i18 >> 0] = 1;
   i20 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i20, 16, gb + 704671 | 0, 175, gb + 704825 | 0, i4);
   i20 = 3;
   STACKTOP = i21;
   return i20 | 0;
  } else {
   i14 = i1;
   i15 = 0;
  }
 } else {
  i14 = i19;
  i15 = 0;
 } while (0);
 i11 = i20 + 84 + (i18 * 12 | 0) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i11, 0, i5);
 i12 = (i18 | 0) != 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP16[i9 + 16 >> 1] = i12 ? 2 : 1;
 HEAP8[i9 + 18 >> 0] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = -1;
 i2 = i10 + 20 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i10 + 24 >> 2] = i14;
 HEAP32[i10 + 28 >> 2] = i1 + 1;
 i3 = i10 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 >> 2] = gb + 85608 + 8;
 if (i7) {
  i1 = __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i20 + 80 >> 2] | 0) | 0;
  mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 356 >> 2] | 0, i1 | 0, i20 + 4 | 0, i20 + 44 | 0, i10 | 0, i9 | 0, 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i6 = (HEAPU8[i2 >> 0] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
 }
 if ((i6 | 0) > (i1 | 0)) {
  if (!(i15 | (i14 | 0) == (i19 | 0))) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i13, i14);
  HEAP8[i20 + 116 + i18 >> 0] = 1;
  i1 = 1;
 } else {
  if ((i6 | 0) > 0) {
   i1 = i16 + 4 | 0;
   i2 = i20 + 84 + (i18 * 12 | 0) + 8 | 0;
   i3 = i20 + 84 + (i18 * 12 | 0) + 4 | 0;
   i5 = 0;
   do {
    HEAP32[i16 >> 2] = HEAP32[i14 + (i5 << 4) >> 2];
    HEAP32[i1 >> 2] = HEAP32[i14 + (i5 << 4) + 4 >> 2];
    i4 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     i9 = i16;
     i10 = HEAP32[i9 + 4 >> 2] | 0;
     i13 = (HEAP32[i11 >> 2] | 0) + (i4 << 3) | 0;
     HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i13 + 4 >> 2] = i10;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11, i16) | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i6 | 0));
  }
  i1 = HEAP32[i20 + 80 >> 2] | 0;
  if (i12) HEAP32[i20 + 112 >> 2] = HEAP32[i1 + 24 >> 2]; else HEAP32[i20 + 108 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP8[i20 + 116 + i18 >> 0] = 0;
  if (i15 | (i14 | 0) == (i19 | 0)) i1 = 0; else {
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i17, i14);
   i1 = 0;
  }
 }
 i20 = i1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6insertIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPjEEE4typeENSD_IPKjEES9_S9_(i13, i1, i2, i9) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i6 = HEAP32[i13 >> 2] | 0;
 i5 = i6;
 i1 = i6 + ((HEAP32[i1 >> 2] | 0) - i5 >> 2 << 2) | 0;
 i6 = i2;
 i15 = i9 - i6 | 0;
 i8 = i15 >> 1;
 if ((i15 | 0) <= 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i12 = i13 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i15 = i13 + 4 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i4 = i11;
 if ((i8 | 0) > (i3 - i4 >> 2 | 0)) {
  i11 = i13 + 12 | 0;
  i4 = (i4 - i5 >> 2) + i8 | 0;
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i3 = HEAP32[i12 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
  }
  i7 = i3 - i5 | 0;
  i3 = i7 >> 1;
  i3 = i7 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
  i7 = i1;
  if (!i3) i4 = 0; else {
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP32[i14 >> 2] = 1;
   HEAP32[i14 + 4 >> 2] = i4;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  }
  i10 = i4 + (i7 - i5 >> 2 << 2) | 0;
  i8 = i4 + (i3 << 2) | 0;
  if ((i2 | 0) == (i9 | 0)) i4 = i10; else {
   i4 = (i9 + -2 - i6 | 0) >>> 1;
   i3 = i10;
   while (1) {
    HEAP32[i3 >> 2] = HEAPU16[i2 >> 1];
    i2 = i2 + 2 | 0;
    if ((i2 | 0) == (i9 | 0)) break; else i3 = i3 + 4 | 0;
   }
   i4 = i10 + (i4 + 1 << 2) | 0;
  }
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = i7 - i2 | 0;
  i5 = i10 + (0 - (i3 >> 2) << 2) | 0;
  if ((i3 | 0) > 0) _memcpy(i5 | 0, i2 | 0, i3 | 0) | 0;
  i2 = (HEAP32[i15 >> 2] | 0) - i7 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = i4 + (i2 >> 2 << 2) | 0;
  } else i1 = i4;
  i2 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = i5;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i12 >> 2] = i8;
  if (!i2) {
   i15 = i10;
   STACKTOP = i16;
   return i15 | 0;
  }
  i15 = HEAP32[i11 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
  i15 = i10;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i1;
 i7 = i4 - i10 | 0;
 i3 = i7 >> 2;
 if ((i8 | 0) > (i3 | 0)) {
  i6 = i2 + (i3 << 1) | 0;
  if ((i6 | 0) == (i9 | 0)) i3 = i11; else {
   i4 = i9 + -2 - i6 | 0;
   i3 = i6;
   i5 = i11;
   while (1) {
    HEAP32[i5 >> 2] = HEAPU16[i3 >> 1];
    i3 = i3 + 2 | 0;
    if ((i3 | 0) == (i9 | 0)) break; else i5 = i5 + 4 | 0;
   }
   i3 = i11 + ((i4 >>> 1) + 1 << 2) | 0;
   HEAP32[i15 >> 2] = i3;
  }
  if ((i7 | 0) > 0) i9 = i6; else {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  }
 } else i3 = i11;
 i7 = i3 - (i1 + (i8 << 2)) | 0;
 i8 = i7 >> 2;
 i4 = i1 + (i8 << 2) | 0;
 if (i4 >>> 0 < i11 >>> 0) {
  i6 = (i11 + (0 - i8 << 2) + ~i10 | 0) >>> 2;
  i5 = i3;
  while (1) {
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   i4 = i4 + 4 | 0;
   if (i4 >>> 0 >= i11 >>> 0) break; else i5 = i5 + 4 | 0;
  }
  HEAP32[i15 >> 2] = i3 + (i6 + 1 << 2);
 }
 if (i8 | 0) _memmove(i3 + (0 - i8 << 2) | 0, i1 | 0, i7 | 0) | 0;
 if ((i9 | 0) == (i2 | 0)) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 } else i3 = i1;
 while (1) {
  HEAP32[i3 >> 2] = HEAPU16[i2 >> 1];
  i2 = i2 + 2 | 0;
  if ((i2 | 0) == (i9 | 0)) break; else i3 = i3 + 4 | 0;
 }
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN11AssetBundle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 24 | 0;
 i4 = i12 + 8 | 0;
 i5 = i12;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i8, i7 + 48 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i8, i7 + 68 | 0, 0);
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i8 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i7 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i7 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 44 | 0, i8);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i11, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i4, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i6 = i4 + 11 | 0;
 i3 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i13 = gb + 63648 | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i7 + 168 | 0, i3, i11);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i13 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i11);
 }
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i8, i7 + 172 | 0, 0);
 i1 = i7 + 184 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i11, 1);
  i13 = HEAP8[i11 >> 0] | 0;
  HEAP8[i1 >> 0] = i13;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i7);
  STACKTOP = i12;
  return;
 } else {
  i13 = HEAP8[i2 >> 0] | 0;
  HEAP8[i11 >> 0] = i13;
  HEAP32[i10 >> 2] = i3;
  HEAP8[i1 >> 0] = i13;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i7);
  STACKTOP = i12;
  return;
 }
}

function runPostSets107() {
 HEAP32[gb + 99120 >> 2] = fb + 304;
 HEAP32[gb + 99124 >> 2] = fb + 107;
 HEAP32[gb + 99128 >> 2] = fb + 133;
 HEAP32[gb + 99132 >> 2] = fb + 108;
 HEAP32[gb + 99136 >> 2] = fb + 134;
 HEAP32[gb + 99140 >> 2] = fb + 109;
 HEAP32[gb + 99144 >> 2] = fb + 135;
 HEAP32[gb + 99148 >> 2] = fb + 693;
 HEAP32[gb + 99152 >> 2] = fb + 110;
 HEAP32[gb + 99156 >> 2] = fb + 136;
 HEAP32[gb + 99160 >> 2] = fb + 111;
 HEAP32[gb + 99164 >> 2] = fb + 137;
 HEAP32[gb + 99168 >> 2] = fb + 112;
 HEAP32[gb + 99172 >> 2] = fb + 138;
 HEAP32[gb + 99176 >> 2] = fb + 1384;
 HEAP32[gb + 99180 >> 2] = fb + 1385;
 HEAP32[gb + 99184 >> 2] = fb + 204;
 HEAP32[gb + 99188 >> 2] = fb + 205;
 HEAP32[gb + 99192 >> 2] = fb + 139;
 HEAP32[gb + 99196 >> 2] = fb + 113;
 HEAP32[gb + 99200 >> 2] = fb + 1063;
 HEAP32[gb + 99204 >> 2] = fb + 1064;
 HEAP32[gb + 99208 >> 2] = fb + 1080;
 HEAP32[gb + 99212 >> 2] = fb + 1386;
 HEAP32[gb + 99216 >> 2] = fb + 1387;
 HEAP32[gb + 99228 >> 2] = fb + 1388;
 HEAP32[gb + 99232 >> 2] = fb + 680;
 HEAP32[gb + 99236 >> 2] = fb + 456;
 HEAP32[gb + 99240 >> 2] = fb + 1389;
 HEAP32[gb + 99244 >> 2] = fb + 1390;
 HEAP32[gb + 99248 >> 2] = fb + 303;
 HEAP32[gb + 99252 >> 2] = fb + 1;
 HEAP32[gb + 99256 >> 2] = fb + 681;
 HEAP32[gb + 99260 >> 2] = fb + 1057;
 HEAP32[gb + 99264 >> 2] = fb + 682;
 HEAP32[gb + 99268 >> 2] = fb + 1;
 HEAP32[gb + 99272 >> 2] = fb + 206;
 HEAP32[gb + 99276 >> 2] = fb + 1081;
 HEAP32[gb + 99280 >> 2] = fb + 683;
 HEAP32[gb + 99284 >> 2] = fb + 1059;
 HEAP32[gb + 99288 >> 2] = fb + 684;
 HEAP32[gb + 99292 >> 2] = fb + 1060;
 HEAP32[gb + 99296 >> 2] = fb + 685;
 HEAP32[gb + 99300 >> 2] = fb + 1082;
 HEAP32[gb + 99304 >> 2] = fb + 686;
 HEAP32[gb + 99308 >> 2] = fb + 687;
 HEAP32[gb + 99312 >> 2] = fb + 1;
 HEAP32[gb + 99316 >> 2] = fb + 1;
 HEAP32[gb + 99320 >> 2] = fb + 1;
 HEAP32[gb + 99324 >> 2] = fb + 1;
 HEAP32[gb + 99328 >> 2] = fb + 1;
 HEAP32[gb + 99332 >> 2] = fb + 1;
 HEAP32[gb + 99336 >> 2] = fb + 1;
 HEAP32[gb + 99340 >> 2] = fb + 1;
 HEAP32[gb + 99344 >> 2] = fb + 1;
 HEAP32[gb + 99348 >> 2] = fb + 1;
 HEAP32[gb + 99352 >> 2] = fb + 1;
 HEAP32[gb + 99356 >> 2] = fb + 1;
 HEAP32[gb + 99360 >> 2] = fb + 1;
 HEAP32[gb + 99364 >> 2] = fb + 1;
 HEAP32[gb + 99368 >> 2] = fb + 1;
 HEAP32[gb + 99372 >> 2] = fb + 1;
 HEAP32[gb + 99376 >> 2] = fb + 1;
 HEAP32[gb + 99380 >> 2] = fb + 1;
 HEAP32[gb + 99384 >> 2] = fb + 1;
 HEAP32[gb + 99388 >> 2] = fb + 1;
 HEAP32[gb + 99392 >> 2] = fb + 1;
 HEAP32[gb + 99396 >> 2] = fb + 1;
 HEAP32[gb + 99400 >> 2] = fb + 1;
 HEAP32[gb + 99404 >> 2] = fb + 1;
 HEAP32[gb + 99408 >> 2] = fb + 1;
 HEAP32[gb + 99412 >> 2] = fb + 1;
 HEAP32[gb + 99416 >> 2] = fb + 1;
 HEAP32[gb + 99420 >> 2] = fb + 1;
 HEAP32[gb + 99424 >> 2] = fb + 1;
 HEAP32[gb + 99428 >> 2] = fb + 1;
 HEAP32[gb + 99432 >> 2] = fb + 1;
 HEAP32[gb + 99436 >> 2] = fb + 1;
 HEAP32[gb + 99440 >> 2] = fb + 1;
 HEAP32[gb + 99444 >> 2] = fb + 1;
 HEAP32[gb + 99448 >> 2] = fb + 1;
 HEAP32[gb + 99452 >> 2] = fb + 1;
 HEAP32[gb + 99456 >> 2] = fb + 1;
 HEAP32[gb + 99460 >> 2] = fb + 1;
 HEAP32[gb + 99464 >> 2] = fb + 1;
 HEAP32[gb + 99468 >> 2] = fb + 1;
 HEAP32[gb + 99472 >> 2] = fb + 1;
 HEAP32[gb + 99476 >> 2] = fb + 1;
 HEAP32[gb + 99480 >> 2] = fb + 1;
 HEAP32[gb + 99484 >> 2] = fb + 1;
 HEAP32[gb + 99488 >> 2] = fb + 1;
 HEAP32[gb + 99492 >> 2] = fb + 1;
 HEAP32[gb + 99496 >> 2] = fb + 1;
 HEAP32[gb + 99500 >> 2] = fb + 1;
 HEAP32[gb + 99504 >> 2] = fb + 1;
 HEAP32[gb + 99508 >> 2] = fb + 1;
 HEAP32[gb + 99512 >> 2] = fb + 1;
 HEAP32[gb + 99516 >> 2] = fb + 1;
 HEAP32[gb + 99520 >> 2] = fb + 1;
 HEAP32[gb + 99524 >> 2] = fb + 1;
 runPostSets108();
}

function __ZN17ProceduralTexture20UploadWaitingTextureEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 12 | 0;
 i1 = i13;
 i2 = i13 + 8 | 0;
 i11 = i13 + 4 | 0;
 i12 = i10 + 160 | 0;
 if (!(HEAP32[i12 >> 2] & 2)) i9 = i10 + 48 | 0; else {
  i7 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 452 >> 2] | 0;
  i9 = i10 + 48 | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  mftCall_vii(i6 | 0, i7 | 0, i8 | 0);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -3;
  HEAP32[i10 + 208 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = -16776961;
 i7 = __Z12GetGfxDevicev() | 0;
 i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 436 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 i6 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 148 >> 2] | 0, i10 | 0) | 0;
 i5 = HEAP32[i10 + 56 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 mftCall_viiiiiiiiiiii(i4 | 0, i7 | 0, i8 | 0, i6 | 0, i1 | 0, 4, 1, 1, 5, 1, 1, i5 | 0, 0);
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i10;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 7;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 12;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 11;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 7) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 11) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 12) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i8;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  i9 = i5;
  i7 = HEAP32[i12 >> 2] | 0;
  i7 = i7 | 2;
  HEAP32[i12 >> 2] = i7;
  i7 = i10 + 208 | 0;
  HEAP32[i7 >> 2] = 1;
  i7 = i10 + 32 | 0;
  HEAP32[i11 >> 2] = i9;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 + 148 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = mftCall_ii(i9 | 0, i10 | 0) | 0;
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + 120 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i12 = mftCall_ii(i12 | 0, i10 | 0) | 0;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i8, i9, 0, 0, i12, 0);
  STACKTOP = i13;
  return;
 }
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i9 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i7 = i7 | 2;
 HEAP32[i12 >> 2] = i7;
 i7 = i10 + 208 | 0;
 HEAP32[i7 >> 2] = 1;
 i7 = i10 + 32 | 0;
 HEAP32[i11 >> 2] = i9;
 i9 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + 148 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, i10 | 0) | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i12 = i12 + 120 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = mftCall_ii(i12 | 0, i10 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i8, i9, 0, 0, i12, 0);
 STACKTOP = i13;
 return;
}

function __ZN5Cache10AddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i8, i2, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 52 | 0;
 i9 = i12 + 40 | 0;
 i10 = i12 + 16 | 0;
 i11 = i12;
 HEAP32[i3 >> 2] = 0;
 __ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE(i2, i3, 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i7 = _time(0) | 0;
  if ((i1 | 0) < (i7 - (HEAP32[i8 + 48 >> 2] | 0) | 0)) {
   __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
   STACKTOP = i12;
   return;
  }
 }
 i1 = i8 + 24 | 0;
 i6 = i1;
 i6 = _i64Add(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0) | 0;
 i7 = getTempRet0() | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9, i2);
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i9, 64, -1) | 0;
 if ((i1 | 0) == -1) i1 = 0; else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i10, i9, i1 + 1 | 0, -1, i9);
  i7 = __Z11StringToIntPKc((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i10, i9, 0, i1, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = i7;
 }
 i7 = i8 + 56 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i2);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i11) | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i10 + 16 >> 2] = i1;
 HEAP32[i10 + 20 >> 2] = i5;
 i2 = i8 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i4 = i2;
  i3 = i2;
 } else {
  while (1) if ((i5 | 0) < (HEAP32[i1 + 36 >> 2] | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = 9;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 12;
    break;
   } else i1 = i2;
  }
  if ((i2 | 0) == 9) {
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 12) {
   i4 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(40) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i10);
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 60 >> 2] | 0, i1);
 i8 = i8 + 64 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 _JS_FileSystem_Sync();
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i12;
 return;
}

function __ZN2UI13DepthSortGrid17AddAndGetDepthForERKNS_23RenderableUIInstructionEPS2_i(i17, i18, i14, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i22 + 8 | 0;
 i9 = i22;
 i21 = i22 + 16 | 0;
 f23 = Math_fround(i1 | 0);
 f26 = Math_fround(Math_fround(HEAPF32[i18 + 152 >> 2]) / f23);
 f25 = Math_fround(Math_fround(HEAPF32[i18 + 156 >> 2]) / f23);
 f24 = Math_fround(Math_fround(HEAPF32[i18 + 160 >> 2]) / f23);
 i2 = ~~Math_fround(Math_floor(Math_fround(f26)));
 i11 = ~~Math_fround(Math_floor(Math_fround(f25)));
 i12 = 0 - ~~Math_fround(Math_floor(Math_fround(f24))) | 0;
 i13 = 0 - ~~Math_fround(Math_floor(Math_fround(Math_fround(HEAPF32[i18 + 164 >> 2]) / f23))) | 0;
 i20 = gb + 64016 | 0;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i16 = i9;
 HEAP32[i16 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i16 + 4 >> 2] = i19;
 HEAP32[i21 >> 2] = 0;
 i16 = i21 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i19 = i21 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i21 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, i9);
 i9 = i15;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = Math_imul(i13 - i11 | 0, i12 - i2 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i19 >> 2] = i1;
  HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
 }
 if ((i2 | 0) < (i12 | 0)) {
  i10 = i15 + 4 | 0;
  if ((i11 | 0) < (i13 | 0)) {
   i1 = 0;
   do {
    i9 = i11;
    do {
     HEAP32[i15 >> 2] = i2;
     HEAP32[i10 >> 2] = i9;
     i4 = __ZNSt3__23mapINS_4pairIKiS2_EEN2UI14DepthSortLayerENS_4lessIS3_EE13stl_allocatorINS1_IKS3_S5_EEL18MemLabelIdentifier1ELi16EEEixERS9_(i17, i15) | 0;
     i5 = __ZN2UI14DepthSortLayer11GetDepthForERKNS_23RenderableUIInstructionEPS2_(i4, i18, i14) | 0;
     i1 = (i1 | 0) < (i5 | 0) ? i5 : i1;
     i5 = HEAP32[i16 >> 2] | 0;
     i6 = i5 + 1 | 0;
     i7 = HEAP32[i19 >> 2] | 0;
     i8 = i7 & 2147483647;
     do if (i6 >>> 0 > i8 >>> 0) {
      i3 = i7 << 1;
      i3 = (i3 | 0) == 0 ? 1 : i3;
      if (i8 >>> 0 < i3 >>> 0) if ((i7 | 0) > -1) {
       HEAP32[i19 >> 2] = i3;
       HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i3 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i8 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
       HEAP32[i19 >> 2] = i3;
       HEAP32[i21 >> 2] = i8;
       break;
      }
     } while (0);
     HEAP32[i16 >> 2] = i6;
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i5 << 2) >> 2] = i4;
     i9 = i9 + 1 | 0;
    } while ((i9 | 0) != (i13 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i12 | 0));
  } else i1 = 0;
 } else i1 = 0;
 if (HEAP32[i16 >> 2] | 0) {
  i2 = 0;
  do {
   __ZN2UI14DepthSortLayer12AddWithDepthERKNS_23RenderableUIInstructionEi(HEAP32[(HEAP32[i21 >> 2] | 0) + (i2 << 2) >> 2] | 0, i18, i1);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
 }
 i1 = (HEAP32[i17 + 16 >> 2] | 0) + i1 | 0;
 if ((HEAP32[i19 >> 2] | 0) <= -1) {
  STACKTOP = i22;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i21 >> 2] | 0, i20);
 HEAP32[i21 >> 2] = 0;
 STACKTOP = i22;
 return i1 | 0;
}

function __ZN23CloudWebServicesManager15ThreadedCleanupEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i18 + 24 | 0;
 i6 = i18 + 20 | 0;
 i9 = i18 + 16 | 0;
 i16 = i18;
 i17 = i13 + 28 | 0;
 i12 = HEAP32[i13 + 36 >> 2] | 0;
 i10 = i16 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = i12;
 i12 = i16 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i14 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i14;
 i1 = HEAP32[i17 >> 2] | 0;
 i15 = i13 + 32 | 0;
 i7 = i14;
 if ((i1 | 0) != (i15 | 0)) {
  i8 = i5 + 4 | 0;
  i2 = i1;
  while (1) {
   i3 = i2 + 16 | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
   i4 = __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_(i16, i5, i6, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i5 >> 2] = 85;
    HEAP32[i8 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
    i20 = i3;
    i19 = HEAP32[i20 + 4 >> 2] | 0;
    i3 = i2 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i3 + 4 >> 2] = i19;
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i16 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i2);
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i15 | 0)) break; else i2 = i1;
  }
  i1 = HEAP32[i16 >> 2] | 0;
  if ((i1 | 0) != (i14 | 0)) {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 + 20 >> 2] | 0;
    i20 = i1 + 1148 | 0;
    HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + -1;
    if (!(HEAP32[i20 >> 2] | 0)) {
     __ZN19CloudServiceHandler12CloseServiceEv(i1) | 0;
     __ZN19CloudServiceHandlerD2Ev(i1);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
    }
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i14 | 0)) break; else i2 = i1;
   }
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i17, HEAP32[i15 >> 2] | 0);
 HEAP32[i13 + 40 >> 2] = 0;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i15 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i16, HEAP32[i14 >> 2] | 0);
 STACKTOP = i18;
 return;
}

function __ZN16Physics2DManager13OverlapCircleERK8Vector2ffiffPK10Collider2D(i1, i9, f10, i2, f4, f8, i3) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f8 = Math_fround(f8);
 i3 = i3 | 0;
 var f5 = f0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 88 | 0;
 i14 = i19;
 i18 = i19 + 96 | 0;
 if ((HEAP16[gb + 1457776 + 6 >> 1] | 0) > -1) {
  HEAP32[i14 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457776 | 0, i13);
  i15 = gb + 1457776 | 0;
 } else i15 = 0;
 i1 = gb + 64016 | 0;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i16 = i14;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = i17;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i14);
 i1 = i13;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i17;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i14 >> 2] = gb + 158736 + 8;
 HEAP32[i14 + 4 >> 2] = i2;
 i6 = i14 + 8 | 0;
 i7 = i14 + 12 | 0;
 HEAP32[i14 + 16 >> 2] = i3;
 i1 = i14 + 20 | 0;
 i2 = i14 + 28 | 0;
 HEAP32[i2 >> 2] = gb + 151824 + 8;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i11 = i14 + 48 | 0;
 i3 = i14 + 64 | 0;
 i12 = i14 + 80 | 0;
 HEAP32[i12 >> 2] = i18;
 i20 = f4 == Math_fround(-inf);
 f5 = i20 ? Math_fround(-3402823469999999843913219.0e14) : f4;
 HEAPF32[i6 >> 2] = f5;
 i20 = f8 == Math_fround(inf);
 f4 = i20 ? Math_fround(3402823469999999843913219.0e14) : f8;
 HEAPF32[i7 >> 2] = f4;
 if (!(f5 < f4)) {
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 >> 2] = f5;
 }
 if (f10 < Math_fround(9.99999974e-06)) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i14 + 24 >> 2] = i2;
  i2 = i1;
  i20 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = i14 + 56 | 0;
  HEAP32[i1 >> 2] = i20;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = i11;
  HEAP32[i1 >> 2] = i20;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = 1;
  i2 = i18;
 } else {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i14 + 40 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i14 + 44 >> 2] = i1;
  HEAPF32[i14 + 36 >> 2] = f10;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i14 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i14 + 72 >> 2] = Math_fround(0.0);
  HEAPF32[i14 + 76 >> 2] = Math_fround(1.0);
  __ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i2, i11, i3, 0, 1);
  i1 = 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP8[i14 + 84 >> 0] = i1;
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i14, i11);
 i20 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i20 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i14, i14 + (HEAP32[i20 + 12 >> 2] << 2) | 0, i13);
 if ((HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0) > 0) i1 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0; else i1 = 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
  HEAP32[i18 >> 2] = 0;
 }
 if (!i15) {
  STACKTOP = i19;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i19;
 return i1 | 0;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = __ZN21LinearCollectionField15GetElementClassEv(i3) | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 4372;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI9JSONWrite23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI9JSONWriteEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 48 | 0;
 i11 = i14 + 32 | 0;
 i3 = i14 + 8 | 0;
 i4 = i14 + 24 | 0;
 i5 = i14;
 i13 = i12 + 4 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i6 | 0) / 132 | 0;
 i1 = i6;
 if (i2 >>> 0 < i9 >>> 0) {
  i1 = i12 + 8 | 0;
  if ((((HEAP32[i1 >> 2] | 0) - i6 | 0) / 132 | 0 | 0) == (i9 | 0)) {
   __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i12, i9);
   STACKTOP = i14;
   return;
  } else {
   i8 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   i10 = i3 + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = i8;
   __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i3, i9);
   HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i3, i11, i7);
   __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i3, i9);
   i11 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i11;
   i12 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i13 >> 2] = i12;
   i12 = i3 + 8 | 0;
   i13 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i13;
   __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i3);
   STACKTOP = i14;
   return;
  }
 }
 if (i2 >>> 0 <= i9 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i8 = i1 + (i9 * 132 | 0) | 0;
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = i11 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i9 * 132 | 0;
 i5 = (i4 | 0) / 132 | 0;
 if (!i4) {
  i3 = i11 + 8 | 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = 25;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  i6 = i2 + (i5 * 132 | 0) | 0;
  i7 = i11 + 8 | 0;
  HEAP32[i7 >> 2] = i6;
  i5 = i2;
  if (!i9) {
   i3 = i7;
   i4 = i5;
   i2 = i5;
   i1 = i6;
  } else {
   do {
    __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i1);
    i1 = i1 + 132 | 0;
    i2 = (HEAP32[i10 >> 2] | 0) + 132 | 0;
    HEAP32[i10 >> 2] = i2;
   } while ((i1 | 0) != (i8 | 0));
   i3 = i7;
   i4 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i13 = i12 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i17, i18, i15, i5, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i16 = __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i15, i1) | 0;
 i1 = i5 + 8 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 20 | 0;
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i9 = i15 + 8 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i15 + 20 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i18 = i16;
  return i18 | 0;
 }
 i21 = HEAP32[i15 >> 2] | 0;
 i11 = i15 + 4 | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 16 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 24 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i5 >> 2] = i21;
 HEAP32[i5 + 4 >> 2] = i20;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 12 >> 2] = i6;
 HEAP32[i5 + 16 >> 2] = i7;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 24 >> 2] = i8;
 f19 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
 i1 = i18 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i18 + 20 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i21 = i16 + 1 | 0;
  return i21 | 0;
 }
 i24 = HEAP32[i18 >> 2] | 0;
 i5 = i18 + 4 | 0;
 i23 = HEAP32[i5 >> 2] | 0;
 i6 = i18 + 12 | 0;
 i22 = HEAP32[i6 >> 2] | 0;
 i7 = i18 + 16 | 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i8 = i18 + 24 | 0;
 i21 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i15 >> 2] = i24;
 HEAP32[i11 >> 2] = i23;
 HEAPF32[i9 >> 2] = f2;
 HEAP32[i12 >> 2] = i22;
 HEAP32[i13 >> 2] = i20;
 HEAPF32[i10 >> 2] = f3;
 HEAP32[i14 >> 2] = i21;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i24 = i16 + 2 | 0;
  return i24 | 0;
 }
 i20 = HEAP32[i17 >> 2] | 0;
 i21 = HEAP32[i17 + 4 >> 2] | 0;
 i22 = HEAP32[i17 + 12 >> 2] | 0;
 i23 = HEAP32[i17 + 16 >> 2] | 0;
 i24 = HEAP32[i17 + 24 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i18 >> 2] = i20;
 HEAP32[i5 >> 2] = i21;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i6 >> 2] = i22;
 HEAP32[i7 >> 2] = i23;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i8 >> 2] = i24;
 i24 = i16 + 3 | 0;
 return i24 | 0;
}

function __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i17, i18, i15, i5, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i16 = __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i17, i18, i15, i1) | 0;
 i1 = i5 + 4 | 0;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i5 + 16 | 0;
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i9 = i15 + 4 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i15 + 16 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i18 = i16;
  return i18 | 0;
 }
 i21 = HEAP32[i15 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i20 = HEAP32[i11 >> 2] | 0;
 i12 = i15 + 12 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i14 = i15 + 24 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i15 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i5 >> 2] = i21;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 + 8 >> 2] = i20;
 HEAP32[i5 + 12 >> 2] = i6;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i5 + 20 >> 2] = i7;
 HEAP32[i5 + 24 >> 2] = i8;
 f19 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i10 >> 2])) * Math_fround(.5));
 i1 = i18 + 4 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i18 + 16 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i21 = i16 + 1 | 0;
  return i21 | 0;
 }
 i24 = HEAP32[i18 >> 2] | 0;
 i5 = i18 + 8 | 0;
 i23 = HEAP32[i5 >> 2] | 0;
 i6 = i18 + 12 | 0;
 i22 = HEAP32[i6 >> 2] | 0;
 i7 = i18 + 20 | 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i8 = i18 + 24 | 0;
 i21 = HEAP32[i8 >> 2] | 0;
 HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i18 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i15 >> 2] = i24;
 HEAPF32[i9 >> 2] = f2;
 HEAP32[i11 >> 2] = i23;
 HEAP32[i12 >> 2] = i22;
 HEAPF32[i10 >> 2] = f3;
 HEAP32[i13 >> 2] = i20;
 HEAP32[i14 >> 2] = i21;
 f19 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(Math_fround(f19 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 16 >> 2]);
 if (!(f19 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i24 = i16 + 2 | 0;
  return i24 | 0;
 }
 i20 = HEAP32[i17 >> 2] | 0;
 i21 = HEAP32[i17 + 8 >> 2] | 0;
 i22 = HEAP32[i17 + 12 >> 2] | 0;
 i23 = HEAP32[i17 + 20 >> 2] | 0;
 i24 = HEAP32[i17 + 24 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
 HEAP32[i18 >> 2] = i20;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i5 >> 2] = i21;
 HEAP32[i6 >> 2] = i22;
 HEAPF32[i4 >> 2] = f3;
 HEAP32[i7 >> 2] = i23;
 HEAP32[i8 >> 2] = i24;
 i24 = i16 + 3 | 0;
 return i24 | 0;
}

function __Z18MurmurHashAligned2PKvij(i4, i7, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = i1 ^ i7;
 i2 = i4;
 i12 = i2 & 3;
 i3 = (i7 | 0) > 3;
 if (!(i3 & (i12 | 0) != 0)) {
  if (i3) {
   i5 = i7 + -4 | 0;
   i6 = i5 & -4;
   i3 = i4 + (i6 + 4) | 0;
   i2 = i7;
   while (1) {
    i12 = Math_imul(HEAP32[i4 >> 2] | 0, 1540483477) | 0;
    i1 = (Math_imul(i12 >>> 24 ^ i12, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
    i2 = i2 + -4 | 0;
    if ((i2 | 0) <= 3) break; else i4 = i4 + 4 | 0;
   }
   i2 = i5 - i6 | 0;
  } else {
   i2 = i7;
   i3 = i4;
  }
  switch (i2 | 0) {
  case 3:
   {
    i1 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 ^ i1;
    i13 = 31;
    break;
   }
  case 2:
   {
    i13 = 31;
    break;
   }
  case 1:
   {
    i13 = 32;
    break;
   }
  default:
   {}
  }
  if ((i13 | 0) == 31) {
   i1 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 ^ i1;
   i13 = 32;
  }
  if ((i13 | 0) == 32) i1 = Math_imul((HEAPU8[i3 >> 0] | 0) ^ i1, 1540483477) | 0;
  i13 = Math_imul(i1 >>> 13 ^ i1, 1540483477) | 0;
  i13 = i13 >>> 15 ^ i13;
  return i13 | 0;
 }
 i9 = i2 & 255;
 switch (i9 & 3) {
 case 1:
  {
   i2 = (HEAPU8[i4 + 2 >> 0] | 0) << 16;
   i13 = 6;
   break;
  }
 case 2:
  {
   i2 = 0;
   i13 = 6;
   break;
  }
 case 3:
  {
   i2 = 0;
   i13 = 7;
   break;
  }
 default:
  i2 = 0;
 }
 if ((i13 | 0) == 6) {
  i2 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | i2;
  i13 = 7;
 }
 if ((i13 | 0) == 7) i2 = HEAPU8[i4 >> 0] | 0 | i2;
 i11 = i12 << 3;
 i5 = i2 << i11;
 i10 = 4 - i12 | 0;
 i3 = i4 + i10 | 0;
 i2 = i7 - i10 | 0;
 i10 = i10 << 3;
 if ((i2 | 0) > 3) {
  i6 = i12 + i7 + -8 | 0;
  i7 = i6 & -4;
  i8 = i7 + 8 - i12 | 0;
  while (1) {
   i14 = i5;
   i5 = HEAP32[i3 >> 2] | 0;
   i14 = Math_imul(i5 << i10 | i14 >>> i11, 1540483477) | 0;
   i1 = (Math_imul(i14 >>> 24 ^ i14, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
   i2 = i2 + -4 | 0;
   if ((i2 | 0) <= 3) break; else i3 = i3 + 4 | 0;
  }
  i6 = i6 - i7 | 0;
  i3 = i4 + i8 | 0;
  i4 = i5;
 } else {
  i6 = i2;
  i4 = i5;
 }
 L31 : do if ((i6 | 0) < (i12 | 0)) {
  switch (i6 | 0) {
  case 3:
   {
    i2 = (HEAPU8[i3 + 2 >> 0] | 0) << 16;
    i13 = 23;
    break;
   }
  case 2:
   {
    i2 = 0;
    i13 = 23;
    break;
   }
  case 1:
   {
    i2 = 0;
    i13 = 24;
    break;
   }
  case 0:
   {
    i2 = 0;
    break;
   }
  default:
   break L31;
  }
  if ((i13 | 0) == 23) {
   i2 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | i2;
   i13 = 24;
  }
  if ((i13 | 0) == 24) i2 = HEAPU8[i3 >> 0] | 0 | i2;
  i1 = Math_imul((i2 << i10 | i4 >>> i11) ^ i1, 1540483477) | 0;
 } else {
  switch (i9 & 3) {
  case 3:
   {
    i2 = (HEAPU8[i3 + 2 >> 0] | 0) << 16;
    i13 = 15;
    break;
   }
  case 2:
   {
    i2 = 0;
    i13 = 15;
    break;
   }
  case 1:
   {
    i2 = 0;
    i13 = 16;
    break;
   }
  default:
   i2 = 0;
  }
  if ((i13 | 0) == 15) {
   i2 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | i2;
   i13 = 16;
  }
  if ((i13 | 0) == 16) i2 = HEAPU8[i3 >> 0] | 0 | i2;
  i2 = Math_imul(i2 << i10 | i4 >>> i11, 1540483477) | 0;
  i1 = (Math_imul(i2 >>> 24 ^ i2, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
  i2 = i3 + i12 | 0;
  switch (i6 - i12 | 0) {
  case 3:
   {
    i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 ^ i1;
    i13 = 19;
    break;
   }
  case 2:
   {
    i13 = 19;
    break;
   }
  case 1:
   break;
  default:
   break L31;
  }
  if ((i13 | 0) == 19) i1 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 ^ i1;
  i1 = Math_imul((HEAPU8[i2 >> 0] | 0) ^ i1, 1540483477) | 0;
 } while (0);
 i14 = Math_imul(i1 >>> 13 ^ i1, 1540483477) | 0;
 i14 = i14 >>> 15 ^ i14;
 return i14 | 0;
}

function _UNITY_png_free_data(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0;
 if ((i4 | 0) == 0 | (i5 | 0) == 0) return;
 i8 = i5 + 220 | 0;
 do if (i6 & 16384 & HEAP32[i8 >> 2] | 0) if ((i7 | 0) == -1) {
  i2 = i5 + 128 | 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    _UNITY_png_free_data(i4, i5, 16384, i1);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
  }
  i3 = i5 + 136 | 0;
  _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  break;
 } else {
  i2 = i5 + 136 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) break;
  i1 = HEAP32[i1 + (i7 * 28 | 0) + 4 >> 2] | 0;
  if (!i1) break;
  _UNITY_png_free(i4, i1);
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i7 * 28 | 0) + 4 >> 2] = 0;
  break;
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i6 & 8192 & i1) {
  i1 = i5 + 148 | 0;
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i5 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -17;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (i6 & 256 & i1) {
  i3 = i5 + 236 | 0;
  _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
  i1 = i5 + 240 | 0;
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = i5 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16385;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (i6 & 128 & i1) {
  i1 = i5 + 196 | 0;
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  i3 = i5 + 208 | 0;
  _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i5 + 212 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i2 = i5 + 217 | 0;
   if (HEAP8[i2 >> 0] | 0) {
    _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
    HEAP32[HEAP32[i3 >> 2] >> 2] = 0;
    if ((HEAPU8[i2 >> 0] | 0) > 1) {
     i1 = 1;
     do {
      _UNITY_png_free(i4, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
      HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < (HEAPU8[i2 >> 0] | 0) >>> 0);
    }
    i1 = HEAP32[i3 >> 2] | 0;
   }
   _UNITY_png_free(i4, i1);
   HEAP32[i3 >> 2] = 0;
  }
  i1 = i5 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -1025;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (i6 & 16 & i1) {
  i3 = i5 + 116 | 0;
  _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
  i1 = i5 + 120 | 0;
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = i5 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -4097;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 do if (i6 & 32 & i1 | 0) {
  if ((i7 | 0) != -1) {
   i1 = i5 + 224 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break;
   _UNITY_png_free(i4, HEAP32[i2 + (i7 << 4) >> 2] | 0);
   _UNITY_png_free(i4, HEAP32[(HEAP32[i1 >> 2] | 0) + (i7 << 4) + 8 >> 2] | 0);
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i3 + (i7 << 4) >> 2] = 0;
   HEAP32[i3 + (i7 << 4) + 8 >> 2] = 0;
   break;
  }
  i2 = i5 + 228 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = 0;
    do {
     _UNITY_png_free_data(i4, i5, 32, i1);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
   }
   i3 = i5 + 224 | 0;
   _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
  }
  i3 = i5 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -8193;
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i6 & 4096 & i1) {
  i1 = i5 + 16 | 0;
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i5 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -9;
  HEAP16[i5 + 20 >> 1] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1 & ~((i7 | 0) == -1 ? i6 : i6 & -16929);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 435;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 400;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE16dispatchAccessorILj435ENS0_26PxPvdRangePropertyAccessorILj435ES4_NS_6PxVec3EEEEEvjRKT0_bbb(i11, HEAP32[i8 >> 2] | 0, i9, 0, 0, 0);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 412;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE16dispatchAccessorILj435ENS0_26PxPvdRangePropertyAccessorILj435ES4_NS_6PxVec3EEEEEvjRKT0_bbb(i11, HEAP32[i8 >> 2] | 0, i9, 0, 0, 0);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN11AudioSource19CreateOpenALRolloffEfff(i2, f8, f10, f12) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 f10 = Math_fround(f10);
 f12 = Math_fround(f12);
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 16 | 0;
 i7 = i15;
 i14 = i2 + 300 | 0;
 i9 = HEAP32[i2 + 356 >> 2] | 0;
 __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_(i14, i9, i9 + (HEAP32[i2 + 368 >> 2] << 4) | 0);
 i9 = i2 + 412 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 f1 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(Math_fround(1.0) - f8);
 i11 = f3 > Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f3);
 f1 = Math_fround((i11 ? f3 : Math_fround(1.0)) * f1);
 f1 = f1 > f12 ? f12 : f1;
 i11 = i13 + 4 | 0;
 HEAPF32[i11 >> 2] = f1 < f10 ? f10 : f1;
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i14, i13) | 0;
 i6 = i2 + 400 | 0;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f1 > Math_fround(.100000001))) {
  HEAPF32[i13 >> 2] = f1;
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  f1 = Math_fround(f1 + Math_fround(-1.0));
  f8 = Math_fround(f1 * f8);
  f8 = Math_fround(f8 + Math_fround(1.0));
  i9 = f8 > Math_fround(0.0);
  f8 = Math_fround(Math_fround(1.0) / f8);
  f8 = i9 ? f8 : Math_fround(1.0);
  f8 = Math_fround(f3 * f8);
  i9 = f8 > f12;
  f12 = i9 ? f12 : f8;
  i9 = f12 < f10;
  f12 = i9 ? f10 : f12;
  HEAPF32[i11 >> 2] = f12;
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i14, i13) | 0;
  STACKTOP = i15;
  return;
 }
 i2 = i7 + 4 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7 + 12 | 0;
 f3 = Math_fround(.100000001);
 do {
  HEAPF32[i7 >> 2] = f3;
  f17 = Math_fround(HEAPF32[i9 >> 2]);
  f16 = Math_fround(Math_fround(Math_fround(f3 + Math_fround(-1.0)) * f8) + Math_fround(1.0));
  i19 = f16 > Math_fround(0.0);
  f16 = Math_fround(Math_fround(1.0) / f16);
  f16 = Math_fround((i19 ? f16 : Math_fround(1.0)) * f17);
  f16 = f16 > f12 ? f12 : f16;
  f16 = f16 < f10 ? f10 : f16;
  HEAPF32[i2 >> 2] = f16;
  f1 = Math_fround(f3 / Math_fround(10.0));
  f18 = Math_fround(Math_fround(Math_fround(Math_fround(f3 - f1) + Math_fround(-1.0)) * f8) + Math_fround(1.0));
  i19 = f18 > Math_fround(0.0);
  f18 = Math_fround(Math_fround(1.0) / f18);
  f18 = Math_fround((i19 ? f18 : Math_fround(1.0)) * f17);
  f18 = f18 > f12 ? f12 : f18;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(f16 - (f18 < f10 ? f10 : f18)) / f1);
  f18 = Math_fround(Math_fround(Math_fround(Math_fround(f3 + f1) + Math_fround(-1.0)) * f8) + Math_fround(1.0));
  i19 = f18 > Math_fround(0.0);
  f18 = Math_fround(Math_fround(1.0) / f18);
  f17 = Math_fround((i19 ? f18 : Math_fround(1.0)) * f17);
  f17 = f17 > f12 ? f12 : f17;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround((f17 < f10 ? f10 : f17) - f16) / f1);
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i14, i7) | 0;
  f3 = Math_fround(f3 * Math_fround(2.0));
  f1 = Math_fround(HEAPF32[i6 >> 2]);
 } while (f3 < f1);
 HEAPF32[i13 >> 2] = f1;
 f17 = Math_fround(HEAPF32[i9 >> 2]);
 f18 = Math_fround(f1 + Math_fround(-1.0));
 f18 = Math_fround(f18 * f8);
 f18 = Math_fround(f18 + Math_fround(1.0));
 i19 = f18 > Math_fround(0.0);
 f18 = Math_fround(Math_fround(1.0) / f18);
 f18 = i19 ? f18 : Math_fround(1.0);
 f18 = Math_fround(f17 * f18);
 i19 = f18 > f12;
 f18 = i19 ? f12 : f18;
 i19 = f18 < f10;
 f18 = i19 ? f10 : f18;
 HEAPF32[i11 >> 2] = f18;
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i14, i13) | 0;
 STACKTOP = i15;
 return;
}

function __ZL18AddSliverTrianglesPjjii(i4, i1, i5, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(1 << i5 & i2)) {
  i2 = 2;
  i3 = i1;
  while (1) {
   switch (i5 | 0) {
   case 0:
    {
     HEAP32[i4 + (i3 << 2) >> 2] = i2 + 17;
     HEAP32[i4 + (i3 + 1 << 2) >> 2] = i2;
     i6 = (i2 | 1) + 17 | 0;
     HEAP32[i4 + (i3 + 2 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 3 << 2) >> 2] = i2;
     i7 = i2 + 2 | 0;
     HEAP32[i4 + (i3 + 4 << 2) >> 2] = i7;
     HEAP32[i4 + (i3 + 5 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 6 << 2) >> 2] = i7;
     HEAP32[i4 + (i3 + 7 << 2) >> 2] = i2 + 19;
     HEAP32[i4 + (i3 + 8 << 2) >> 2] = i6;
     break;
    }
   case 1:
    {
     HEAP32[i4 + (i3 << 2) >> 2] = i2 + 255;
     i7 = (i2 | 1) + 255 | 0;
     HEAP32[i4 + (i3 + 1 << 2) >> 2] = i7;
     i6 = i2 + 272 | 0;
     HEAP32[i4 + (i3 + 2 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 3 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 4 << 2) >> 2] = i7;
     i6 = i2 + 274 | 0;
     HEAP32[i4 + (i3 + 5 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 6 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 7 << 2) >> 2] = i7;
     HEAP32[i4 + (i3 + 8 << 2) >> 2] = i2 + 257;
     break;
    }
   case 3:
    {
     i7 = i2 * 17 | 0;
     HEAP32[i4 + (i3 << 2) >> 2] = i7;
     HEAP32[i4 + (i3 + 1 << 2) >> 2] = i7 | 1;
     i6 = ((i2 | 1) * 17 | 0) + 1 | 0;
     HEAP32[i4 + (i3 + 2 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 3 << 2) >> 2] = i6;
     i8 = i7 + 34 | 0;
     HEAP32[i4 + (i3 + 4 << 2) >> 2] = i8;
     HEAP32[i4 + (i3 + 5 << 2) >> 2] = i7;
     HEAP32[i4 + (i3 + 6 << 2) >> 2] = i8;
     HEAP32[i4 + (i3 + 7 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 8 << 2) >> 2] = i7 + 35;
     break;
    }
   default:
    {
     i7 = i2 * 17 | 0;
     i6 = i7 + 16 | 0;
     HEAP32[i4 + (i3 << 2) >> 2] = i6;
     i8 = ((i2 | 1) * 17 | 0) + 15 | 0;
     HEAP32[i4 + (i3 + 1 << 2) >> 2] = i8;
     HEAP32[i4 + (i3 + 2 << 2) >> 2] = i7 + 15;
     HEAP32[i4 + (i3 + 3 << 2) >> 2] = i8;
     HEAP32[i4 + (i3 + 4 << 2) >> 2] = i6;
     i6 = i7 + 50 | 0;
     HEAP32[i4 + (i3 + 5 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 6 << 2) >> 2] = i6;
     HEAP32[i4 + (i3 + 7 << 2) >> 2] = i7 + 49;
     HEAP32[i4 + (i3 + 8 << 2) >> 2] = i8;
    }
   }
   i2 = i2 + 2 | 0;
   if ((i2 | 0) >= 14) break; else i3 = i3 + 9 | 0;
  }
  i8 = i1 + 54 | 0;
  return i8 | 0;
 }
 switch (i5 | 0) {
 case 0:
  {
   i8 = __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, i1, 0, 2) | 0, 0, 3) | 0, 0, 4) | 0, 0, 5) | 0, 0, 6) | 0, 0, 7) | 0, 0, 8) | 0, 0, 9) | 0, 0, 10) | 0, 0, 11) | 0, 0, 12) | 0, 0, 13) | 0;
   return i8 | 0;
  }
 case 1:
  {
   i8 = __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, __ZL7AddQuadPjjii(i4, i1, 15, 2) | 0, 15, 3) | 0, 15, 4) | 0, 15, 5) | 0, 15, 6) | 0, 15, 7) | 0, 15, 8) | 0, 15, 9) | 0, 15, 10) | 0, 15, 11) | 0, 15, 12) | 0, 15, 13) | 0;
   return i8 | 0;
  }
 default:
  {
   i2 = 2;
   do {
    switch (i5 | 0) {
    case 3:
     {
      i1 = __ZL7AddQuadPjjii(i4, i1, i2, 0) | 0;
      break;
     }
    case 2:
     {
      i1 = __ZL7AddQuadPjjii(i4, i1, i2, 15) | 0;
      break;
     }
    default:
     {}
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 14);
   return i1 | 0;
  }
 }
 return 0;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = __ZN21LinearCollectionField15GetElementClassEv(i3) | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 4316;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI8JSONRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI8JSONReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2478;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI17RemapPPtrTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI17RemapPPtrTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_15AllocationEventEEEvT_(i23, i22) {
 i23 = i23 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = i22 + 12 | 0;
 i20 = HEAP32[i17 >> 2] | 0;
 i20 = i20 >>> 0 < 256 ? 2 : i20 >>> 0 < 65536 ? 66 : 130;
 i21 = i22 + 16 | 0;
 i16 = HEAP32[i21 >> 2] | 0;
 i16 = i16 >>> 0 < 256 ? 0 : i16 >>> 0 < 65536 ? 256 : 512;
 i18 = i22 + 8 | 0;
 i15 = HEAP32[i18 >> 2] | 0;
 i15 = i15 >>> 0 < 256 ? 0 : i15 >>> 0 < 65536 ? 1024 : 2048;
 i19 = i22 + 20 | 0;
 i14 = HEAP32[i19 >> 2] | 0;
 i14 = i14 >>> 0 < 256 ? 0 : i14 >>> 0 < 65536 ? 4096 : 8192;
 i3 = i16 | i20 | i15;
 i2 = i22;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 256) i1 = 0; else if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 65536) i1 = 16; else i1 = i2 >>> 0 < 1 | (i2 | 0) == 1 & i1 >>> 0 < 0 ? 32 : 48;
 i11 = i3 | i14;
 i9 = i1 | i11;
 i10 = i9 & 255;
 i11 = (i11 & 65535) >>> 8 & 255;
 i12 = i23 + 80 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i13 = i5 + 12 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3;
 i7 = i1 - i4 | 0;
 i2 = i7 + 2 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i10;
 HEAP8[i1 + 1 >> 0] = i11;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 2;
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 773720 | 0, i18, i15 >>> 10);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 773725 | 0, i17, i20 >>> 6);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 773730 | 0, i21, i16 >>> 8);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 773735 | 0, i19, i14 >>> 12);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 773712 | 0, i22, i9 >>> 4 & 3);
 i7 = i23 + 20 | 0;
 i4 = i23 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i5;
 i6 = (HEAP32[i7 >> 2] | 0) - i1 | 0;
 if (i6 >>> 0 < (HEAP32[i23 + 44 >> 2] | 0) >>> 0) return;
 i3 = HEAP32[i23 + 36 >> 2] | 0;
 if (i3) {
  i1 = i23 + 32 | 0;
  i2 = 0;
  do {
   i22 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2] | 0, i22 | 0, i5 | 0, i6 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0, i23 | 0);
 return;
}

function __ZN27TrailModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 do switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 8 >> 2] = f4;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 908 >> 2] | 0;
   HEAPF32[i3 + 92 >> 2] = f4;
   HEAP8[i3 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 12 | 0, i3 + 100 | 0, f4, HEAP16[i3 + 96 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 276 >> 2] = f4;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 285 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 286 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 287 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 288 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 436 >> 0] = ~~f4;
   return;
  }
 case 8:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 437 >> 0] = ~~f4;
   return;
  }
 case 9:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 438 >> 0] = ~~f4;
   return;
  }
 case 10:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 439 >> 0] = ~~f4;
   return;
  }
 case 11:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 440 >> 0] = ~~f4;
   return;
  }
 case 12:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 441 >> 0] = ~~f4;
   return;
  }
 case 13:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 442 >> 0] = ~~f4;
   return;
  }
 case 14:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 443 >> 0] = ~~f4;
   return;
  }
 case 15:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 908 >> 2] | 0;
   HEAPF32[i3 + 528 >> 2] = f4;
   HEAP8[i3 + 534 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 448 | 0, i3 + 536 | 0, f4, HEAP16[i3 + 532 >> 1] | 0) | 0) & 1;
   return;
  }
 case 16:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 856 >> 0] = ~~f4;
   return;
  }
 case 17:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 857 >> 0] = ~~f4;
   return;
  }
 case 18:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 858 >> 0] = ~~f4;
   return;
  }
 case 19:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 859 >> 0] = ~~f4;
   return;
  }
 case 20:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 860 >> 0] = ~~f4;
   return;
  }
 case 21:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 861 >> 0] = ~~f4;
   return;
  }
 case 22:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 862 >> 0] = ~~f4;
   return;
  }
 case 23:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 863 >> 0] = ~~f4;
   return;
  }
 default:
  return;
 } while (0);
}

function _fmod(d12, d1) {
 d12 = +d12;
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 HEAPF64[tempDoublePtr >> 3] = d12;
 i6 = HEAP32[tempDoublePtr >> 2] | 0;
 i8 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i11 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = _bitshift64Lshr(i6 | 0, i8 | 0, 52) | 0;
 getTempRet0() | 0;
 i3 = i3 & 2047;
 i9 = _bitshift64Lshr(i10 | 0, i11 | 0, 52) | 0;
 getTempRet0() | 0;
 i9 = i9 & 2047;
 i13 = i8 & -2147483648;
 i5 = _bitshift64Shl(i10 | 0, i11 | 0, 1) | 0;
 i7 = getTempRet0() | 0;
 L1 : do if ((i5 | 0) == 0 & (i7 | 0) == 0) i14 = 3; else {
  i4 = i11 & 2147483647;
  if (i4 >>> 0 > 2146435072 | (i4 | 0) == 2146435072 & i10 >>> 0 > 0 | (i3 | 0) == 2047) i14 = 3; else {
   i2 = _bitshift64Shl(i6 | 0, i8 | 0, 1) | 0;
   i4 = getTempRet0() | 0;
   if (!(i4 >>> 0 > i7 >>> 0 | (i4 | 0) == (i7 | 0) & i2 >>> 0 > i5 >>> 0)) return +((i2 | 0) == (i5 | 0) & (i4 | 0) == (i7 | 0) ? d12 * 0.0 : d12);
   if (!i3) {
    i2 = _bitshift64Shl(i6 | 0, i8 | 0, 12) | 0;
    i4 = getTempRet0() | 0;
    if ((i4 | 0) > -1 | (i4 | 0) == -1 & i2 >>> 0 > 4294967295) {
     i3 = 0;
     do {
      i3 = i3 + -1 | 0;
      i2 = _bitshift64Shl(i2 | 0, i4 | 0, 1) | 0;
      i4 = getTempRet0() | 0;
     } while ((i4 | 0) > -1 | (i4 | 0) == -1 & i2 >>> 0 > 4294967295);
    } else i3 = 0;
    i6 = _bitshift64Shl(i6 | 0, i8 | 0, 1 - i3 | 0) | 0;
    i5 = getTempRet0() | 0;
   } else i5 = i8 & 1048575 | 1048576;
   if (!i9) {
    i4 = _bitshift64Shl(i10 | 0, i11 | 0, 12) | 0;
    i7 = getTempRet0() | 0;
    if ((i7 | 0) > -1 | (i7 | 0) == -1 & i4 >>> 0 > 4294967295) {
     i2 = 0;
     do {
      i2 = i2 + -1 | 0;
      i4 = _bitshift64Shl(i4 | 0, i7 | 0, 1) | 0;
      i7 = getTempRet0() | 0;
     } while ((i7 | 0) > -1 | (i7 | 0) == -1 & i4 >>> 0 > 4294967295);
    } else i2 = 0;
    i10 = _bitshift64Shl(i10 | 0, i11 | 0, 1 - i2 | 0) | 0;
    i9 = i2;
    i8 = getTempRet0() | 0;
   } else i8 = i11 & 1048575 | 1048576;
   i4 = _i64Subtract(i6 | 0, i5 | 0, i10 | 0, i8 | 0) | 0;
   i2 = getTempRet0() | 0;
   i7 = (i2 | 0) > -1 | (i2 | 0) == -1 & i4 >>> 0 > 4294967295;
   L23 : do if ((i3 | 0) > (i9 | 0)) {
    while (1) {
     if (i7) {
      if ((i4 | 0) == 0 & (i2 | 0) == 0) break;
     } else {
      i4 = i6;
      i2 = i5;
     }
     i6 = _bitshift64Shl(i4 | 0, i2 | 0, 1) | 0;
     i5 = getTempRet0() | 0;
     i3 = i3 + -1 | 0;
     i4 = _i64Subtract(i6 | 0, i5 | 0, i10 | 0, i8 | 0) | 0;
     i2 = getTempRet0() | 0;
     i7 = (i2 | 0) > -1 | (i2 | 0) == -1 & i4 >>> 0 > 4294967295;
     if ((i3 | 0) <= (i9 | 0)) break L23;
    }
    d1 = d12 * 0.0;
    break L1;
   } while (0);
   if (i7) {
    if ((i4 | 0) == 0 & (i2 | 0) == 0) {
     d1 = d12 * 0.0;
     break;
    }
   } else {
    i2 = i5;
    i4 = i6;
   }
   if (i2 >>> 0 < 1048576 | (i2 | 0) == 1048576 & i4 >>> 0 < 0) do {
    i4 = _bitshift64Shl(i4 | 0, i2 | 0, 1) | 0;
    i2 = getTempRet0() | 0;
    i3 = i3 + -1 | 0;
   } while (i2 >>> 0 < 1048576 | (i2 | 0) == 1048576 & i4 >>> 0 < 0);
   if ((i3 | 0) > 0) {
    i11 = _i64Add(i4 | 0, i2 | 0, 0, -1048576) | 0;
    i2 = getTempRet0() | 0;
    i3 = _bitshift64Shl(i3 | 0, 0, 52) | 0;
    i2 = i2 | (getTempRet0() | 0);
    i3 = i11 | i3;
   } else {
    i3 = _bitshift64Lshr(i4 | 0, i2 | 0, 1 - i3 | 0) | 0;
    i2 = getTempRet0() | 0;
   }
   HEAP32[tempDoublePtr >> 2] = i3;
   HEAP32[tempDoublePtr + 4 >> 2] = i2 | i13;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 } while (0);
 if ((i14 | 0) == 3) {
  d1 = d12 * d1;
  d1 = d1 / d1;
 }
 return +d1;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i1 = i8 * 28 | 0;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 722497 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 * 28 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i11 = i2 + 4 | 0;
   i13 = i11;
   i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
   i11 = i11 + 4 | 0;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i12 = i1 + 4 | 0;
   i10 = i12;
   HEAP16[i10 >> 1] = i13;
   HEAP16[i10 + 2 >> 1] = i13 >>> 16;
   i12 = i12 + 4 | 0;
   HEAP16[i12 >> 1] = i11;
   HEAP16[i12 + 2 >> 1] = i11 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i12 = i1 + 12 | 0;
   i11 = i2 + 12 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 >> 2] = gb + 106576 + 8;
   i12 = i2 + 20 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + (i1 * 28 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 106664 + 8;
 i12 = i4 + 4 | 0;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i13 = i5 + (i1 * 28 | 0) + 4 | 0;
 i11 = i13;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i13 = i13 + 4 | 0;
 HEAP16[i13 >> 1] = i12;
 HEAP16[i13 + 2 >> 1] = i12 >>> 16;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 i13 = i5 + (i1 * 28 | 0) + 12 | 0;
 i12 = i4 + 12 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 >> 2] = gb + 106576 + 8;
 i2 = i4 + 20 | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i5 + (i1 * 28 | 0) + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i13 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i13 * 28 | 0) | 0;
 if ((i13 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i7 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i5 + (i13 * 28 | 0) | 0;
 return i13 | 0;
}

function __Z23LODGroup_CUSTOM_GetLODsP12Il2CppObject(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 8 | 0;
 i15 = i17;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 256 >> 2] | 0;
 if (!i13) {
  i12 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
 if (!i2) {
  i12 = i13;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 i12 = __Z19scripting_array_newP11Il2CppClassjj(i1, 12, ((HEAP32[i2 + 60 >> 2] | 0) - (HEAP32[i2 + 56 >> 2] | 0) | 0) / 28 | 0) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 i11 = 0;
 while (1) {
  if ((i11 | 0) >= (((HEAP32[i1 + 60 >> 2] | 0) - (HEAP32[i1 + 56 >> 2] | 0) | 0) / 28 | 0 | 0)) {
   i16 = 8;
   break;
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
  if (!i1) {
   i16 = 10;
   break;
  }
  i1 = __ZNK8LODGroup6GetLODEi(i1, i11) | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i10 = __Z19GetScriptingManagerv() | 0;
  i9 = i1 + 20 | 0;
  i10 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i10 + 168 >> 2] | 0) + (HEAP32[gb + 31312 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i9 >> 2] | 0) | 0;
  if (HEAP32[i9 >> 2] | 0) {
   i6 = i1 + 8 | 0;
   i5 = 0;
   do {
    i4 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i15 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i16 = 20; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
       i2 = HEAP32[i14 >> 2] | 0;
       i18 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i18 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i18 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 20; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i16 = 22;
      }
     }
     if ((i16 | 0) == 20) i16 = 22;
     if ((i16 | 0) == 22) {
      i16 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     }
    }
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i10, i5, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  }
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i12, i11, 12) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i10;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
  if (!i1) {
   i16 = 6;
   break;
  } else i11 = i11 + 1 | 0;
 }
 if ((i16 | 0) == 6) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13); else if ((i16 | 0) == 8) {
  STACKTOP = i17;
  return i12 | 0;
 } else if ((i16 | 0) == 10) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 return 0;
}

function __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i2 - i1 | 0) / 136 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAPF32[i1 + 32 >> 2] = Math_fround(.262745112);
   HEAPF32[i1 + 36 >> 2] = Math_fround(.976470589);
   HEAPF32[i1 + 40 >> 2] = Math_fround(.164705887);
   HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 48 >> 2] = Math_fround(.80392158);
   HEAPF32[i1 + 52 >> 2] = Math_fround(.737254917);
   HEAPF32[i1 + 56 >> 2] = Math_fround(.101960786);
   HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
   i2 = i1 + 8 | 0;
   i6 = i1 + 76 | 0;
   i7 = i6 + 60 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   HEAPF32[i2 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 12 >> 2] = Math_fround(2.0);
   HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 20 >> 2] = Math_fround(2.0);
   HEAPF32[i1 + 24 >> 2] = Math_fround(10.0);
   HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
   HEAP32[i1 + 68 >> 2] = 2;
   HEAP32[i1 + 72 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 136 | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 136 | 0) + i3 | 0;
 if (i5 >>> 0 > 31580641) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 136 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 15790320 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 31580641;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 136 | 0) | 0;
 i2 = i6 + (((i1 - i4 | 0) / 136 | 0) * 136 | 0) | 0;
 i8 = i2;
 i5 = i6 + (i5 * 136 | 0) | 0;
 i9 = i8;
 i1 = i2;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAPF32[i1 + 32 >> 2] = Math_fround(.262745112);
  HEAPF32[i1 + 36 >> 2] = Math_fround(.976470589);
  HEAPF32[i1 + 40 >> 2] = Math_fround(.164705887);
  HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 48 >> 2] = Math_fround(.80392158);
  HEAPF32[i1 + 52 >> 2] = Math_fround(.737254917);
  HEAPF32[i1 + 56 >> 2] = Math_fround(.101960786);
  HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
  i4 = i1 + 8 | 0;
  i6 = i1 + 76 | 0;
  i7 = i6 + 60 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i7 | 0));
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(2.0);
  HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(2.0);
  HEAPF32[i1 + 24 >> 2] = Math_fround(10.0);
  HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
  HEAP32[i1 + 68 >> 2] = 2;
  HEAP32[i1 + 72 >> 2] = 0;
  i1 = i9 + 136 | 0;
  i9 = i1;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i8;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i8;
  do {
   i1 = i1 + -136 | 0;
   __ZN15DetailPrototypeC2ERKS_(i2 + -136 | 0, i1);
   i2 = i3 + -136 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i11 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -136 | 0;
  __ZN15DetailPrototypeD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i4 = i7 + 8 | 0;
 i2 = i7;
 i6 = i7 + 32 | 0;
 i3 = i7 + 20 | 0;
 if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation22TryInitializeDiskCacheEv(i8) | 0)) if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation24TryInitializeMemoryCacheEv(i8) | 0)) {
  i1 = i8 + 92 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  HEAP32[i1 >> 2] = 3;
  i1 = i8 + 112 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  __Z6FormatPKcz(i6, gb + 366806 | 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + 96 | 0, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i1 = i8 + 64 | 0;
 __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i1, 3, 3) | 0;
 i2 = i8 + 144 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 444372 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i1, i3);
 i9 = __ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i2, i6, 1, 1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (!i9) {
  i1 = i8 + 92 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i9 = 0;
   STACKTOP = i7;
   return i9 | 0;
  }
  HEAP32[i1 >> 2] = 3;
  i1 = i8 + 112 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  __Z6FormatPKcz(i6, gb + 366806 | 0, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + 96 | 0, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 __ZN4File4LockENS_8LockModeEb(i2, 2, 0) | 0;
 i9 = (HEAP8[(__Z17GetCachingManagerv() | 0) + 9 >> 0] | 0) != 0;
 i4 = HEAP32[i8 + 132 >> 2] | 0;
 i2 = HEAP32[gb + 27728 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i2, _strlen(i2) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i1, i3);
 i9 = __ZN23ArchiveStorageConverter23InitializeTargetArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15CompressionTypej(i4, i6, i9 ? 2 : 0, 131072) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (i9) {
  i9 = 1;
  STACKTOP = i7;
  return i9 | 0;
 }
 i1 = i8 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 HEAP32[i1 >> 2] = 9;
 i1 = i8 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 __Z6FormatPKcz(i6, gb + 366859 | 0, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8 + 96 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i9 = 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i9, i1, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, i29 = 0, f30 = f0, f31 = f0, f32 = f0, i33 = 0, i34 = 0, i35 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 32 | 0;
 i15 = i19 + 16 | 0;
 i16 = i19;
 i17 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i17) {
  STACKTOP = i19;
  return;
 }
 i18 = i1 + 520 | 0;
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 i12 = i14 + 12 | 0;
 i2 = i1 + 500 | 0;
 i3 = i15 + 4 | 0;
 i4 = i15 + 8 | 0;
 i5 = i15 + 12 | 0;
 i6 = i16 + 4 | 0;
 i7 = i16 + 8 | 0;
 i8 = i16 + 12 | 0;
 i1 = 0;
 do {
  i20 = (HEAP32[i18 >> 2] | 0) + (i1 << 2) | 0;
  f30 = Math_fround(HEAPF32[i20 >> 2]);
  f28 = Math_fround(HEAPF32[i20 + 4 >> 2]);
  f32 = Math_fround(HEAPF32[i20 + 8 >> 2]);
  f28 = Math_fround(f28 * Math_fround(.00999999977));
  f32 = Math_fround(f32 * Math_fround(.00999999977));
  f31 = Math_fround(Math_fround(HEAPF32[i20 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i14 >> 2] = Math_fround(f30 * Math_fround(.00999999977));
  HEAPF32[i10 >> 2] = f28;
  HEAPF32[i11 >> 2] = f32;
  HEAPF32[i12 >> 2] = f31;
  i20 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
  i24 = (HEAP32[i20 >> 2] | 0) + -1926462415 | 0;
  i35 = (HEAP32[i20 + 4 >> 2] | 0) + -1926462415 | 0;
  i33 = (HEAP32[i20 + 8 >> 2] | 0) + -1926462415 | 0;
  i20 = (HEAP32[i20 + 12 >> 2] | 0) + -1926462415 | 0;
  i26 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i34 = (Math_imul(i35, 1790253981) | 0) + 1900727103 | 0;
  i29 = (Math_imul(i33, 1790253981) | 0) + 1900727103 | 0;
  i22 = (Math_imul(i20, 1790253981) | 0) + 1900727103 | 0;
  i24 = i24 << 11 ^ i24;
  i35 = i35 << 11 ^ i35;
  i33 = i33 << 11 ^ i33;
  i20 = i20 << 11 ^ i20;
  f31 = Math_fround(Math_fround((i34 ^ i35 ^ i35 >>> 8) & 8388607 ^ i34 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f32 = Math_fround(Math_fround((i29 ^ i33 ^ i33 >>> 8) & 8388607 ^ i29 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f28 = Math_fround(Math_fround((i22 ^ i20 ^ i20 >>> 8) & 8388607 ^ i22 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i15 >> 2] = Math_fround(Math_fround((i26 ^ i24 ^ i24 >>> 8) & 8388607 ^ i26 >>> 19 | 0) * Math_fround(1.19209304e-07));
  HEAPF32[i3 >> 2] = f31;
  HEAPF32[i4 >> 2] = f32;
  HEAPF32[i5 >> 2] = f28;
  i26 = i13 + (i1 << 2) | 0;
  f28 = Math_fround(HEAPF32[i26 >> 2]);
  i24 = i26 + 4 | 0;
  f32 = Math_fround(HEAPF32[i24 >> 2]);
  i22 = i26 + 8 | 0;
  f31 = Math_fround(HEAPF32[i22 >> 2]);
  i20 = i26 + 12 | 0;
  f30 = Math_fround(HEAPF32[i20 >> 2]);
  __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i16, i9, i14, i15);
  f27 = Math_fround(HEAPF32[i16 >> 2]);
  i29 = f27 < Math_fround(0.0);
  f27 = i29 ? Math_fround(0.0) : f27;
  f25 = Math_fround(HEAPF32[i6 >> 2]);
  i29 = f25 < Math_fround(0.0);
  f25 = i29 ? Math_fround(0.0) : f25;
  f23 = Math_fround(HEAPF32[i7 >> 2]);
  i29 = f23 < Math_fround(0.0);
  f23 = i29 ? Math_fround(0.0) : f23;
  f21 = Math_fround(HEAPF32[i8 >> 2]);
  i29 = f21 < Math_fround(0.0);
  f25 = Math_fround(f32 * f25);
  f23 = Math_fround(f31 * f23);
  f21 = Math_fround(f30 * (i29 ? Math_fround(0.0) : f21));
  HEAPF32[i26 >> 2] = Math_fround(f28 * f27);
  HEAPF32[i24 >> 2] = f25;
  HEAPF32[i22 >> 2] = f23;
  HEAPF32[i20 >> 2] = f21;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i17 >>> 0);
 STACKTOP = i19;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i5 + 44 | 0;
 i4 = i5 + 4 | 0;
 i2 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i9 = i5 + 48 | 0;
 if (i2 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
  i9 = i5 + 56 | 0;
  HEAP8[i9 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i7 = i5 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 <= 32) {
  i9 = i5 + 56 | 0;
  HEAP8[i9 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 f3 = Math_fround(i2 >>> 0);
 do {
  i2 = i1;
  i1 = i1 >>> 1;
  if (i2 >>> 0 < 66) break;
 } while (f3 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
 i16 = i6 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i6 + 8 | 0;
 i18 = i5 + 8 | 0;
 i15 = HEAP16[i18 >> 1] | 0;
 HEAP8[i17 >> 0] = i15;
 i2 = i6 + 9 | 0;
 HEAP8[i2 >> 0] = (i15 & 65535) >>> 8;
 i15 = i6 + 12 | 0;
 i14 = i5 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i13 = i6 + 24 | 0;
 i12 = i5 + 24 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 i11 = i6 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP8[i11 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j(i6, i5, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i1;
 i1 = HEAP8[i18 >> 0] | 0;
 i16 = HEAP16[i17 >> 1] | 0;
 HEAP8[i18 >> 0] = i16;
 HEAP8[i17 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = (i16 & 65535) >>> 8;
 HEAP8[i2 >> 0] = i4;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = i1;
 HEAP32[i6 + 20 >> 2] = i2;
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 24 >> 2] = i2;
 HEAP32[i6 + 28 >> 2] = i1;
 HEAP32[i6 + 32 >> 2] = i4;
 i4 = i5 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i1;
 i11 = i6 + 40 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i11 >> 2] = i4;
 i7 = i6 + 44 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i11;
 f3 = Math_fround(i2 >>> 0);
 HEAP32[i5 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i9 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 56 >> 0] = 0;
 f3 = Math_fround(i4 >>> 0);
 HEAP32[i6 + 52 >> 2] = ~~Math_fround(f3 * Math_fround(.5)) >>> 0;
 HEAP32[i6 + 48 >> 2] = ~~Math_fround(f3 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 + 56 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 i18 = i5 + 56 | 0;
 HEAP8[i18 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN14PhysicsManager19ProcessTriggerStaysEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 4 | 0;
 i1 = i16;
 if ((HEAP16[gb + 1452560 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452560 | 0, i14);
  i12 = gb + 1452560 | 0;
 } else i12 = 0;
 i1 = HEAP32[i4 + 104 >> 2] | 0;
 i13 = i4 + 108 | 0;
 i3 = i1;
 i2 = i1;
 if ((i3 | 0) != (i13 | 0)) if (HEAP8[i3 + 24 >> 0] | 0) while (1) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i13 | 0)) {
   i1 = i13;
   break;
  }
  if (!(HEAP8[i1 + 24 >> 0] | 0)) break; else i2 = i1;
 }
 i2 = i1;
 L18 : do if ((i2 | 0) != (i13 | 0)) {
  i9 = i4 + 116 | 0;
  i10 = i4 + 128 | 0;
  i11 = i4 + 132 | 0;
  i8 = i4 + 120 | 0;
  i6 = i2;
  while (1) {
   i2 = HEAP32[i6 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
   i4 = HEAP32[i6 + 32 >> 2] | 0;
   i5 = HEAP32[i4 + 36 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) if ((i3 | 0) == 0 | (i5 | 0) == 0 | (i5 | 0) != (HEAP32[i6 + 20 >> 2] | 0)) i15 = 19; else {
    HEAP32[i14 >> 2] = HEAP32[gb + 1104776 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[gb + 1104776 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[gb + 1104776 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[gb + 1104776 + 12 >> 2];
    HEAP32[i14 + 16 >> 2] = HEAP32[gb + 1104776 + 16 >> 2];
    __ZL16SendTriggerEventP8ColliderS0_17MessageIdentifier(i2, i4, i14);
   } else i15 = 19;
   if ((i15 | 0) == 19) {
    i15 = 0;
    i2 = i6 + 24 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) {
     HEAP8[i2 >> 0] = 1;
     i3 = i6 + 16 | 0;
     i4 = HEAP32[i10 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i11 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i11 >> 2] = i2;
       HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 3, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
       HEAP32[i11 >> 2] = i2;
       HEAP32[i9 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i5;
     i5 = i3;
     i6 = HEAP32[i5 + 4 >> 2] | 0;
     i7 = (HEAP32[i9 >> 2] | 0) + (i4 << 3) | 0;
     HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i7 + 4 >> 2] = i6;
    }
   }
   while (1) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) while (1) {
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
    } else {
     i1 = i2;
     while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = i1;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == (i13 | 0)) break L18;
    if (!(HEAP8[i2 + 24 >> 0] | 0)) break; else i1 = i2;
   }
   if ((i2 | 0) == (i13 | 0)) break; else {
    i1 = i2;
    i6 = i2;
   }
  }
 } while (0);
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return;
}

function __ZN12UnityVersionC2EPKc(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i11 = i14 + 8 | 0;
 i10 = i14;
 i8 = i14 + 24 | 0;
 i9 = i7 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i6 = 0;
 L1 : while (1) {
  L3 : do switch (i6 | 0) {
  case 2:
  case 1:
   {
    i2 = HEAP8[i1 >> 0] | 0;
    switch (i2 << 24 >> 24) {
    case 0:
     {
      i13 = 6;
      break L3;
     }
    case 46:
     break;
    default:
     {
      i13 = 5;
      break L1;
     }
    }
    i1 = i1 + 1 | 0;
    i13 = 6;
    break;
   }
  case 4:
  case 0:
   {
    i13 = 6;
    break;
   }
  case 3:
   {
    i5 = HEAP8[i1 >> 0] | 0;
    i2 = i5 << 24 >> 24;
    switch (((i5 + -65 & 255) < 26 ? i2 + 32 | 0 : i2) << 24 >> 24 | 0) {
    case 120:
     {
      i13 = 19;
      break L1;
     }
    case 97:
     {
      i2 = 0;
      i1 = i1 + 1 | 0;
      break;
     }
    case 98:
     {
      i2 = 1;
      i1 = i1 + 1 | 0;
      break;
     }
    case 102:
     {
      i2 = 2;
      i1 = i1 + 1 | 0;
      break;
     }
    case 112:
     {
      i2 = 3;
      i1 = i1 + 1 | 0;
      break;
     }
    case 0:
     {
      i2 = 2;
      break;
     }
    default:
     {
      i13 = 17;
      break L1;
     }
    }
    HEAP32[i9 >> 2] = i2;
    break;
   }
  default:
   {}
  } while (0);
  if ((i13 | 0) == 6) {
   i13 = 0;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = (i2 << 24 >> 24) + -48 | 0;
   if (i3 >>> 0 < 10) {
    i5 = 0;
    i4 = 0;
    while (1) {
     i4 = (i4 * 10 | 0) + i3 | 0;
     i1 = i1 + 1 | 0;
     i2 = HEAP8[i1 >> 0] | 0;
     i3 = (i2 << 24 >> 24) + -48 | 0;
     if (i3 >>> 0 >= 10) break; else i5 = i5 + 1 | 0;
    }
    if ((i5 | 0) > -1) i2 = i4; else i13 = 9;
   } else {
    i4 = 0;
    i13 = 9;
   }
   if ((i13 | 0) == 9) {
    i13 = 0;
    if (!(i2 << 24 >> 24)) i2 = i4; else {
     i13 = 10;
     break;
    }
   }
   HEAP32[i7 + (i6 << 2) >> 2] = i2;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) >= 5) {
   i13 = 21;
   break;
  }
 }
 if ((i13 | 0) == 5) {
  HEAP32[i10 >> 2] = gb + 488968;
  HEAP32[i10 + 4 >> 2] = i2 << 24 >> 24;
  __Z6FormatPKcz(i8, gb + 488904 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 488982 | 0, 39, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i14;
  return;
 } else if ((i13 | 0) == 10) {
  HEAP32[i11 >> 2] = gb + 489057;
  HEAP32[i11 + 4 >> 2] = i2 << 24 >> 24;
  __Z6FormatPKcz(i8, gb + 488904 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 488982 | 0, 24, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i14;
  return;
 } else if ((i13 | 0) == 17) {
  HEAP32[i12 >> 2] = gb + 489077;
  HEAP32[i12 + 4 >> 2] = i2;
  __Z6FormatPKcz(i8, gb + 488904 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 488982 | 0, 55, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i14;
  return;
 } else if ((i13 | 0) == 19) {
  HEAP32[i9 >> 2] = 4;
  STACKTOP = i14;
  return;
 } else if ((i13 | 0) == 21) {
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 76;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 71;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet(i2, i1, i16, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 if (!((i1 | 0) != 0 & i16 >>> 0 < 13)) {
  i18 = 0;
  return i18 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i2 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i18 = 0;
  return i18 | 0;
 } else {
  i3 = i4;
  i2 = i1;
 }
 L6 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i3;
    break L6;
   }
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i3 = i1;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i18 = 0;
  return i18 | 0;
 }
 if ((i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
  i18 = 0;
  return i18 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 i14 = HEAP32[i6 + 8 >> 2] | 0;
 i13 = HEAP32[i6 + 12 >> 2] | 0;
 i12 = HEAP32[i6 + 16 >> 2] | 0;
 i11 = HEAP32[i6 + 20 >> 2] | 0;
 i10 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i6 + 28 >> 2] | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i17 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = i17 - i3 | 0;
 if (!i1) i1 = i3; else {
  i8 = (i1 | 0) / 36 | 0;
  i1 = i3;
  i4 = i3;
  while (1) {
   i3 = (i8 | 0) / 2 | 0;
   i7 = i4 + (i3 * 36 | 0) | 0;
   i5 = HEAP32[i4 + (i3 * 36 | 0) + 32 >> 2] | 0;
   do if ((i5 | 0) == (i16 | 0)) {
    i5 = HEAP32[i4 + (i3 * 36 | 0) + 28 >> 2] | 0;
    if ((i5 | 0) == (i9 | 0)) {
     i5 = HEAP32[i4 + (i3 * 36 | 0) + 24 >> 2] | 0;
     if ((i5 | 0) == (i10 | 0)) {
      i5 = HEAP32[i4 + (i3 * 36 | 0) + 20 >> 2] | 0;
      if ((i5 | 0) == (i11 | 0)) {
       i5 = HEAP32[i4 + (i3 * 36 | 0) + 16 >> 2] | 0;
       if ((i5 | 0) == (i12 | 0)) {
        i5 = HEAP32[i4 + (i3 * 36 | 0) + 12 >> 2] | 0;
        if ((i5 | 0) == (i13 | 0)) {
         i5 = HEAP32[i4 + (i3 * 36 | 0) + 8 >> 2] | 0;
         if ((i5 | 0) == (i14 | 0)) {
          i5 = HEAP32[i4 + (i3 * 36 | 0) + 4 >> 2] | 0;
          if ((i5 | 0) == (i15 | 0)) {
           i5 = HEAP32[i7 >> 2] | 0;
           if ((i5 | 0) == (i2 | 0)) break; else i6 = i2;
          } else i6 = i15;
         } else i6 = i14;
        } else i6 = i13;
       } else i6 = i12;
      } else i6 = i11;
     } else i6 = i10;
    } else i6 = i9;
    if (i5 >>> 0 < i6 >>> 0) i18 = 23;
   } else if ((i5 | 0) < (i16 | 0)) i18 = 23; while (0);
   if ((i18 | 0) == 23) {
    i18 = 0;
    i4 = i7 + 36 | 0;
    i3 = i8 + -1 - i3 | 0;
    i1 = i4;
   }
   if (!i3) break; else i8 = i3;
  }
 }
 do if ((i1 | 0) == (i17 | 0)) i18 = 36; else {
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  if ((i3 | 0) != (i16 | 0)) if ((i3 | 0) > (i16 | 0)) {
   i18 = 36;
   break;
  } else break;
  i3 = HEAP32[i1 + 28 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   i3 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i10 | 0) == (i3 | 0)) {
    i3 = HEAP32[i1 + 20 >> 2] | 0;
    if ((i11 | 0) == (i3 | 0)) {
     i3 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i12 | 0) == (i3 | 0)) {
      i3 = HEAP32[i1 + 12 >> 2] | 0;
      if ((i13 | 0) == (i3 | 0)) {
       i3 = HEAP32[i1 + 8 >> 2] | 0;
       if ((i14 | 0) == (i3 | 0)) {
        i3 = HEAP32[i1 + 4 >> 2] | 0;
        if ((i15 | 0) == (i3 | 0)) {
         i3 = HEAP32[i1 >> 2] | 0;
         if ((i2 | 0) == (i3 | 0)) break;
        } else i2 = i15;
       } else i2 = i14;
      } else i2 = i13;
     } else i2 = i12;
    } else i2 = i11;
   } else i2 = i10;
  } else i2 = i9;
  if (i2 >>> 0 < i3 >>> 0) i18 = 36;
 } while (0);
 if ((i18 | 0) == 36) i1 = i17;
 i18 = (i1 | 0) != (i17 | 0);
 return i18 | 0;
}

function __ZN5physx7profile23EventContextInformation9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i13, i12, i11) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i13 + 8 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i5 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4;
 i8 = i1 - i3 | 0;
 i2 = i8 + 4 | 0;
 i6 = i5 + 16 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i7 >> 2] = i2;
  i1 = i2 + i8 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = HEAP8[i9 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i9 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i9 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i9 + 3 >> 0] | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i12, gb + 660697 | 0, i13, i11);
 i5 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP8[i13 + 12 >> 0] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i11 = i3;
 i7 = i1 - i11 | 0;
 i2 = i7 + 1 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i11 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i11 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i9;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i9 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP8[i13 + 13 >> 0] | 0;
 i6 = i9 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i13 = i1;
 i8 = i2 - i13 | 0;
 i3 = i8 + 1 | 0;
 i4 = i9 + 16 | 0;
 if (((HEAP32[i4 >> 2] | 0) - i13 | 0) >>> 0 > i3 >>> 0) {
  i13 = i2;
  HEAP8[i13 >> 0] = i5;
  i13 = HEAP32[i6 >> 2] | 0;
  i13 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i13;
  return;
 }
 i3 = i3 << 1;
 if (!i3) i2 = 0; else {
  i2 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i9 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (i1 | 0) {
  _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i13 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  }
 }
 HEAP32[i7 >> 2] = i2;
 i13 = i2 + i8 | 0;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i4 >> 2] = i2 + i3;
 HEAP8[i13 >> 0] = i5;
 i13 = HEAP32[i6 >> 2] | 0;
 i13 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i13;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i1 = i8 * 28 | 0;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 722272 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 * 28 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i11 = i2 + 4 | 0;
   i13 = i11;
   i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
   i11 = i11 + 4 | 0;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i12 = i1 + 4 | 0;
   i10 = i12;
   HEAP16[i10 >> 1] = i13;
   HEAP16[i10 + 2 >> 1] = i13 >>> 16;
   i12 = i12 + 4 | 0;
   HEAP16[i12 >> 1] = i11;
   HEAP16[i12 + 2 >> 1] = i11 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i12 = i1 + 12 | 0;
   i11 = i2 + 12 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 >> 2] = gb + 106620 + 8;
   i12 = i2 + 20 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + (i1 * 28 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 106664 + 8;
 i12 = i4 + 4 | 0;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i13 = i5 + (i1 * 28 | 0) + 4 | 0;
 i11 = i13;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i13 = i13 + 4 | 0;
 HEAP16[i13 >> 1] = i12;
 HEAP16[i13 + 2 >> 1] = i12 >>> 16;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 i13 = i5 + (i1 * 28 | 0) + 12 | 0;
 i12 = i4 + 12 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 >> 2] = gb + 106620 + 8;
 i2 = i4 + 20 | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i5 + (i1 * 28 | 0) + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i13 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i13 * 28 | 0) | 0;
 if ((i13 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i7 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i5 + (i13 * 28 | 0) | 0;
 return i13 | 0;
}

function __ZN10AudioMixer24ReassignAllChannelGroupsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i10;
  return;
 }
 i5 = i8 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i7 >> 2] = i1;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i9 = 8; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i2 = i11;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 10;
  }
  if ((i9 | 0) == 8) i9 = 10;
  if ((i9 | 0) == 10) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  if (!i2) i9 = 17; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i2 = i11;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 19;
   }
  }
  if ((i9 | 0) == 17) i9 = 19;
  if ((i9 | 0) == 19) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  i4 = HEAP32[i1 + 52 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  if (!i2) i9 = 25; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i11 + (i3 << 3) | 0;
    i2 = i11;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
    i1 = HEAP32[i6 >> 2] | 0;
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i1 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 25; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 27;
   }
  }
  if ((i9 | 0) == 25) i9 = 27;
  if ((i9 | 0) == 27) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  __ZN10AudioMixer11SetupGroupsEv(i1);
 } while (0);
 __ZN10AudioMixer11SetupGroupsEv(i8);
 STACKTOP = i10;
 return;
}

function _UNITY_FT_Request_Metrics(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = HEAP32[i11 + 88 >> 2] | 0;
 i13 = i12 + 12 | 0;
 if (!(HEAP32[i11 + 8 >> 2] & 1)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  HEAP32[i13 + 20 >> 2] = 0;
  HEAP32[i13 + 24 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 65536;
  HEAP32[i12 + 20 >> 2] = 65536;
  return;
 }
 L5 : do switch (HEAP32[i10 >> 2] | 0) {
 case 0:
  {
   i1 = HEAPU16[i11 + 68 >> 1] | 0;
   i2 = i1;
   i9 = 11;
   break;
  }
 case 1:
  {
   i1 = (HEAP16[i11 + 70 >> 1] | 0) - (HEAP16[i11 + 72 >> 1] | 0) | 0;
   i2 = i1;
   i9 = 11;
   break;
  }
 case 2:
  {
   i2 = (HEAP32[i11 + 64 >> 2] | 0) - (HEAP32[i11 + 56 >> 2] | 0) | 0;
   i1 = (HEAP32[i11 + 60 >> 2] | 0) - (HEAP32[i11 + 52 >> 2] | 0) | 0;
   i9 = 11;
   break;
  }
 case 3:
  {
   i2 = (HEAP16[i11 + 70 >> 1] | 0) - (HEAP16[i11 + 72 >> 1] | 0) | 0;
   i1 = HEAP16[i11 + 76 >> 1] | 0;
   i9 = 11;
   break;
  }
 case 4:
  {
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   i2 = i12 + 16 | 0;
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[i10 + 8 >> 2] | 0;
   i4 = i12 + 20 | 0;
   HEAP32[i4 >> 2] = i3;
   if (!i1) {
    HEAP32[i2 >> 2] = i3;
    i4 = 0;
    i1 = 0;
    i9 = 19;
    break L5;
   }
   if (!i3) {
    HEAP32[i4 >> 2] = i1;
    i4 = 0;
    i1 = 0;
    i9 = 19;
   } else {
    i4 = 0;
    i1 = 0;
    i9 = 19;
   }
   break;
  }
 default:
  {
   i2 = 0;
   i1 = 0;
   i9 = 11;
  }
 } while (0);
 do if ((i9 | 0) == 11) {
  i6 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
  i5 = (i2 | 0) < 0 ? 0 - i2 | 0 : i2;
  i3 = HEAP32[i10 + 12 >> 2] | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = ((Math_imul(i7, i3) | 0) + 36 | 0) / 72 | 0;
  i1 = (i3 | 0) == 0 ? i7 : i1;
  i3 = HEAP32[i10 + 16 >> 2] | 0;
  i2 = i10 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i8 = ((Math_imul(i4, i3) | 0) + 36 | 0) / 72 | 0;
  i8 = (i3 | 0) == 0 ? i4 : i8;
  if (!i7) {
   i4 = _UNITY_FT_DivFix(i8, i5) | 0;
   HEAP32[i12 + 20 >> 2] = i4;
   HEAP32[i12 + 16 >> 2] = i4;
   i4 = i8;
   i1 = _UNITY_FT_MulDiv(i8, i6, i5) | 0;
   i9 = 19;
   break;
  }
  i3 = _UNITY_FT_DivFix(i1, i6) | 0;
  i7 = i12 + 16 | 0;
  HEAP32[i7 >> 2] = i3;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP32[i12 + 20 >> 2] = i3;
   i4 = _UNITY_FT_MulDiv(i1, i5, i6) | 0;
   i9 = 19;
   break;
  }
  i3 = _UNITY_FT_DivFix(i8, i5) | 0;
  i4 = i12 + 20 | 0;
  HEAP32[i4 >> 2] = i3;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) == 3) {
   i2 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) > (i2 | 0)) {
    HEAP32[i4 >> 2] = i2;
    i4 = i8;
    i9 = 19;
    break;
   } else {
    HEAP32[i7 >> 2] = i3;
    i4 = i8;
    i9 = 19;
    break;
   }
  } else i4 = i8;
 } while (0);
 if ((i9 | 0) == 19) i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i2 = i12 + 16 | 0;
  i3 = i12 + 20 | 0;
 } else {
  i4 = i11 + 68 | 0;
  i2 = i12 + 16 | 0;
  i1 = _UNITY_FT_MulFix(HEAPU16[i4 >> 1] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i3 = i12 + 20 | 0;
  i4 = _UNITY_FT_MulFix(HEAPU16[i4 >> 1] | 0, HEAP32[i3 >> 2] | 0) | 0;
 }
 HEAP16[i13 >> 1] = (i1 + 32 | 0) >>> 6;
 HEAP16[i12 + 14 >> 1] = (i4 + 32 | 0) >>> 6;
 HEAP32[i12 + 24 >> 2] = (_UNITY_FT_MulFix(HEAP16[i11 + 70 >> 1] | 0, HEAP32[i3 >> 2] | 0) | 0) + 63 & -64;
 HEAP32[i12 + 28 >> 2] = (_UNITY_FT_MulFix(HEAP16[i11 + 72 >> 1] | 0, HEAP32[i3 >> 2] | 0) | 0) & -64;
 HEAP32[i12 + 32 >> 2] = (_UNITY_FT_MulFix(HEAP16[i11 + 74 >> 1] | 0, HEAP32[i3 >> 2] | 0) | 0) + 32 & -64;
 HEAP32[i12 + 36 >> 2] = (_UNITY_FT_MulFix(HEAP16[i11 + 76 >> 1] | 0, HEAP32[i2 >> 2] | 0) | 0) + 32 & -64;
 return;
}

function __ZN11NoiseModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i3 = i1 + 352 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i3 = i1 + 616 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i3 = i1 + 800 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 808 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 1 ? 1 : (i4 | 0) > 4 ? 4 : i4;
 i3 = i1 + 812 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 816 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(1.0);
 i5 = f2 > Math_fround(4.0);
 f2 = i5 ? Math_fround(4.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(1.0) : f2;
 i3 = i1 + 820 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 0 ? 0 : (i4 | 0) > 2 ? 2 : i4;
 i3 = i1 + 904 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 910 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 824 | 0, i1 + 912 | 0, f2, HEAP16[i1 + 908 >> 1] | 0) | 0) & 1;
 i3 = i1 + 1172 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 1178 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1092 | 0, i1 + 1180 | 0, f2, HEAP16[i1 + 1176 >> 1] | 0) | 0) & 1;
 i3 = i1 + 1436 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 1442 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1356 | 0, i1 + 1444 | 0, f2, HEAP16[i1 + 1440 >> 1] | 0) | 0) & 1;
 i3 = i1 + 1700 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 1706 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1620 | 0, i1 + 1708 | 0, f2, HEAP16[i1 + 1704 >> 1] | 0) | 0) & 1;
 return;
}

function __Z49EmitSerializationCommandsForLinearCollectionFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 120 | 0;
 i8 = i12;
 i11 = i12 + 56 | 0;
 i9 = i12 + 168 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = -1;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i8, HEAP32[i1 >> 2] | 0);
 i5 = i8;
 i2 = i1;
 i6 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i1;
 i2 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0;
 i3 = i8 + 48 | 0;
 HEAP32[i3 >> 2] = i2;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i11 + 8 + 16 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i11 >> 2] = fb + 2423;
 i16 = i4;
 i15 = __Z24scripting_field_get_nameP9FieldInfo(i16) | 0;
 i13 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i4 = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i16) | 0) | 0;
 i5 = __Z26scripting_field_get_offsetP9FieldInfo(i16) | 0;
 i14 = __Z24scripting_class_get_nameP11Il2CppClass(i13) | 0;
 i6 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i11 + 4 >> 2] = i16;
 HEAP32[i11 + 8 >> 2] = i15;
 HEAP32[i11 + 12 >> 2] = i14;
 HEAP32[i11 + 16 >> 2] = i13;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i5;
 HEAP32[i11 + 28 >> 2] = i6;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i2;
 i1 = __ZN6HelperI14SafeBinaryRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i8, i11 + 4 | 0, i9) | 0;
 if (!i1) {
  if (((HEAP32[i3 >> 2] | 0) + -17 | 0) >>> 0 >= 2) {
   STACKTOP = i12;
   return;
  }
  __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI14SafeBinaryReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i8, i11, i10, i7);
  STACKTOP = i12;
  return;
 }
 if (((HEAP8[i9 >> 0] ^ 1) & HEAP8[i8 + 25 >> 0]) << 24 >> 24) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 + 44 >> 2] = i1;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i5 = (HEAP32[i10 >> 2] | 0) + (i3 << 6) | 0;
 i2 = i11;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i1 = i8 * 28 | 0;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 722990 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 * 28 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i11 = i2 + 4 | 0;
   i13 = i11;
   i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
   i11 = i11 + 4 | 0;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i12 = i1 + 4 | 0;
   i10 = i12;
   HEAP16[i10 >> 1] = i13;
   HEAP16[i10 + 2 >> 1] = i13 >>> 16;
   i12 = i12 + 4 | 0;
   HEAP16[i12 >> 1] = i11;
   HEAP16[i12 + 2 >> 1] = i11 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i12 = i1 + 12 | 0;
   i11 = i2 + 12 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 >> 2] = gb + 106532 + 8;
   i12 = i2 + 20 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + (i1 * 28 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 106664 + 8;
 i12 = i4 + 4 | 0;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i13 = i5 + (i1 * 28 | 0) + 4 | 0;
 i11 = i13;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i13 = i13 + 4 | 0;
 HEAP16[i13 >> 1] = i12;
 HEAP16[i13 + 2 >> 1] = i12 >>> 16;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 i13 = i5 + (i1 * 28 | 0) + 12 | 0;
 i12 = i4 + 12 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 >> 2] = gb + 106532 + 8;
 i2 = i4 + 20 | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i5 + (i1 * 28 | 0) + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = HEAP32[i9 >> 2] | 0;
 i13 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i13 * 28 | 0) | 0;
 if ((i13 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i5 + (i13 * 28 | 0) | 0;
  return i13 | 0;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i7 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i5 + (i13 * 28 | 0) | 0;
 return i13 | 0;
}

function __ZN5physx13ActorAABBTask11runInternalEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 24 | 0;
 i12 = i15;
 i2 = i14 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 268 | 0;
 i5 = HEAP32[i3 + 41556 >> 2] | 0;
 i9 = HEAP32[i3 + 41568 >> 2] | 0;
 i1 = 0;
 while (1) {
  i11 = i14 + 44 + (i1 * 40 | 0) | 0;
  HEAP16[i14 + 44 + (i1 * 40 | 0) + 4 >> 1] = -1;
  HEAP16[i14 + 44 + (i1 * 40 | 0) + 6 >> 1] = 0;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 8 >> 2] = 0;
  HEAP32[i11 >> 2] = gb + 87404 + 8;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 12 >> 2] = 0;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 16 >> 2] = 0;
  HEAP32[i11 >> 2] = gb + 104500 + 8;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 20 >> 2] = i3;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 24 >> 2] = i5;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 28 >> 2] = i4;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 32 >> 2] = 0;
  HEAP32[i14 + 44 + (i1 * 40 | 0) + 36 >> 2] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 6) break;
  i3 = HEAP32[i2 >> 2] | 0;
 }
 i11 = HEAP32[i14 + 24 >> 2] | 0;
 i7 = i11 >>> 0 > 6 ? 6 : i11;
 do if (i9 | 0) {
  i8 = i9 >>> 0 > 32 & i7 >>> 0 > 1;
  if (!i8) {
   HEAP32[i14 + 76 >> 2] = 0;
   HEAP32[i14 + 80 >> 2] = i9;
   break;
  }
  i1 = (i9 + 31 | 0) >>> 5;
  i3 = (i1 >>> 0) / (i7 >>> 0) | 0;
  i6 = i3 << 5;
  i2 = (Math_imul(i3, i7) | 0) - i1 + i7 | 0;
  if (!i2) {
   i1 = 0;
   i3 = 0;
  } else {
   i4 = (Math_imul(i3 + 1 | 0, i7) | 0) - i1 | 0;
   i3 = 0;
   i5 = 0;
   while (1) {
    HEAP32[i13 + (i5 << 2) >> 2] = i3;
    HEAP32[i12 + (i5 << 2) >> 2] = i6;
    i1 = i3 + i6 | 0;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i4 | 0)) break; else i3 = i1;
   }
  }
  i4 = i6 + 32 | 0;
  if (i2 >>> 0 < i7 >>> 0) while (1) {
   HEAP32[i13 + (i2 << 2) >> 2] = i1;
   HEAP32[i12 + (i2 << 2) >> 2] = i4;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + i4 | 0;
  } else i1 = i3;
  HEAP32[i12 + (i7 + -1 << 2) >> 2] = i9 - i1;
  if (i7 >>> 0 < 6) {
   i9 = i11 >>> 0 < 6 ? ~i11 : -7;
   i6 = ~i9;
   i9 = (i9 << 2) + 28 | 0;
   _memset(i13 + (i6 << 2) | 0, 0, i9 | 0) | 0;
   _memset(i12 + (i6 << 2) | 0, 0, i9 | 0) | 0;
   if (i7 | 0) i10 = 13;
  } else i10 = 13;
  if ((i10 | 0) == 13) {
   i1 = i11 >>> 0 < 6 ? i11 : 6;
   i2 = 0;
   do {
    i10 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
    HEAP32[i14 + 44 + (i2 * 40 | 0) + 32 >> 2] = HEAP32[i13 + (i2 << 2) >> 2];
    HEAP32[i14 + 44 + (i2 * 40 | 0) + 36 >> 2] = i10;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  if (i8) {
   i1 = (i7 | 0) == 0;
   if (i1) {
    STACKTOP = i15;
    return;
   }
   i2 = i14 + 12 | 0;
   i3 = i11 >>> 0 < 6 ? i11 : 6;
   i6 = 0;
   do {
    i4 = HEAP32[i2 >> 2] | 0;
    HEAP32[i14 + 44 + (i6 * 40 | 0) + 16 >> 2] = 1;
    i5 = i14 + 44 + (i6 * 40 | 0) + 12 | 0;
    HEAP32[i5 >> 2] = i4;
    if (i4 | 0) {
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
     HEAP32[i14 + 44 + (i6 * 40 | 0) + 8 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i3 | 0));
   if (i1) {
    STACKTOP = i15;
    return;
   }
   i1 = i11 >>> 0 < 6 ? i11 : 6;
   i2 = 0;
   do {
    i13 = i14 + 44 + (i2 * 40 | 0) | 0;
    mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   STACKTOP = i15;
   return;
  }
 } while (0);
 i14 = i14 + 44 | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0);
 STACKTOP = i15;
 return;
}

function __ZN31TransformFeedbackSkinPoseBuffer6UpdateEPK10Matrix4x4fi(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = i3 + 7 & -8;
 i4 = i1 + 4 | 0;
 i5 = i1 + 8 | 0;
 if ((i2 | 0) != (HEAP32[i4 >> 2] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0) | 0)) {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
   HEAP32[i5 >> 2] = 0;
  }
 }
 HEAP32[i4 >> 2] = i2;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  if (((((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 580 >> 2] | 0) / 4 | 0) + -10 | 0) / 3 | 0) >>> 0 > i2 >>> 0) {
   i1 = __Znwj(20) | 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 >> 2] = gb + 77360 + 8;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
   HEAP32[i5 >> 2] = i1;
   break;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 661 >> 0] | 0) if ((((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 576 >> 2] | 0) >>> 0) / 48 | 0) >>> 0 >= i1 >>> 0) {
   i1 = __Znwj(12) | 0;
   HEAP32[i1 + 4 >> 2] = 1;
   HEAP32[i1 >> 2] = gb + 77396 + 8;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
   HEAP32[i5 >> 2] = i1;
   break;
  }
  i1 = __Znwj(52) | 0;
  HEAP32[i1 + 4 >> 2] = 2;
  HEAP32[i1 >> 2] = gb + 77432 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, 2) | 0;
  HEAP32[i1 + 24 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, 2) | 0;
  HEAP32[i1 + 28 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, 2) | 0;
  i2 = i1 + 40 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!((i2 | 0) == (i1 | 0) | (i2 | 0) == 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i5 >> 2] = i1;
 } while (0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = (i4 | 0) < (i3 | 0) ? i4 : i3;
 if ((i3 | 0) > 0) i2 = 0; else {
  i6 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 12 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(i5 | 0, i6 | 0);
  return;
 }
 while (1) {
  HEAP32[i1 >> 2] = HEAP32[i6 + (i2 << 6) >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + (i2 << 6) + 16 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + (i2 << 6) + 32 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + (i2 << 6) + 48 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 + (i2 << 6) + 4 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 + (i2 << 6) + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i6 + (i2 << 6) + 36 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i6 + (i2 << 6) + 52 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i6 + (i2 << 6) + 8 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i6 + (i2 << 6) + 24 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i6 + (i2 << 6) + 40 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i6 + (i2 << 6) + 56 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i3 | 0)) break; else i1 = i1 + 48 | 0;
 }
 i6 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + 12 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(i5 | 0, i6 | 0);
 return;
}

function __ZL12TouchHandleriPK20EmscriptenTouchEventPv(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f9 = f0, f10 = f0, i11 = 0;
 HEAP32[gb + 1101424 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) <= 0) return 1;
 if ((i7 | 0) == 22) {
  i6 = 0;
  do {
   if (HEAP32[i8 + 20 + (i6 * 52 | 0) + 28 >> 2] | 0) {
    f3 = Math_fround(HEAP32[i8 + 20 + (i6 * 52 | 0) + 44 >> 2] | 0);
    i7 = __Z16GetScreenManagerv() | 0;
    i7 = (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i7 | 0) | 0) + -1 | 0;
    f4 = Math_fround(i7 - (HEAP32[i8 + 20 + (i6 * 52 | 0) + 48 >> 2] | 0) | 0);
    i7 = (HEAP8[gb + 1544207 >> 0] | 0) == 0;
    d2 = +_emscripten_get_now();
    if (i7) {
     HEAPF64[gb + 1097984 >> 3] = d2;
     HEAP8[gb + 1544207 >> 0] = 1;
     d2 = 0.0;
    } else d2 = (d2 - +HEAPF64[gb + 1097984 >> 3]) * .001;
    f5 = Math_fround(d2);
    HEAP32[gb + 1101428 + (i6 * 68 | 0) >> 2] = HEAP32[i8 + 20 + (i6 * 52 | 0) >> 2];
    i7 = gb + 1101428 + (i6 * 68 | 0) + 4 | 0;
    f10 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f3);
    i1 = gb + 1101428 + (i6 * 68 | 0) + 8 | 0;
    f9 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f4);
    HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 20 >> 2] = f10;
    HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 24 >> 2] = f9;
    HEAPF32[i7 >> 2] = f3;
    HEAPF32[i1 >> 2] = f4;
    HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 12 >> 2] = f3;
    HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 16 >> 2] = f4;
    i1 = gb + 1103604 + (i6 << 2) | 0;
    f4 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
    HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 28 >> 2] = f4;
    HEAP32[gb + 1101428 + (i6 * 68 | 0) + 36 >> 2] = 0;
    HEAPF32[i1 >> 2] = f5;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i1 | 0));
  return 1;
 } else i6 = 0;
 do {
  if (HEAP32[i8 + 20 + (i6 * 52 | 0) + 28 >> 2] | 0) {
   f4 = Math_fround(HEAP32[i8 + 20 + (i6 * 52 | 0) + 44 >> 2] | 0);
   i1 = __Z16GetScreenManagerv() | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0) + -1 | 0;
   f5 = Math_fround(i1 - (HEAP32[i8 + 20 + (i6 * 52 | 0) + 48 >> 2] | 0) | 0);
   i1 = (HEAP8[gb + 1544207 >> 0] | 0) == 0;
   d2 = +_emscripten_get_now();
   if (i1) {
    HEAPF64[gb + 1097984 >> 3] = d2;
    HEAP8[gb + 1544207 >> 0] = 1;
    d2 = 0.0;
   } else d2 = (d2 - +HEAPF64[gb + 1097984 >> 3]) * .001;
   f3 = Math_fround(d2);
   HEAP32[gb + 1101428 + (i6 * 68 | 0) >> 2] = HEAP32[i8 + 20 + (i6 * 52 | 0) >> 2];
   i11 = gb + 1101428 + (i6 * 68 | 0) + 4 | 0;
   f9 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f4);
   i1 = gb + 1101428 + (i6 * 68 | 0) + 8 | 0;
   f10 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
   HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 20 >> 2] = f9;
   HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 24 >> 2] = f10;
   HEAPF32[i11 >> 2] = f4;
   HEAPF32[i1 >> 2] = f5;
   HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 12 >> 2] = f4;
   HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 16 >> 2] = f5;
   i1 = gb + 1103604 + (i6 << 2) | 0;
   f10 = Math_fround(f3 - Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[gb + 1101428 + (i6 * 68 | 0) + 28 >> 2] = f10;
   switch (i7 | 0) {
   case 25:
    {
     HEAP32[gb + 1101428 + (i6 * 68 | 0) + 36 >> 2] = 4;
     break;
    }
   case 23:
    {
     HEAP32[gb + 1101428 + (i6 * 68 | 0) + 36 >> 2] = 3;
     break;
    }
   case 24:
    {
     HEAP32[gb + 1101428 + (i6 * 68 | 0) + 36 >> 2] = 1;
     break;
    }
   default:
    {}
   }
   HEAPF32[i1 >> 2] = f3;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i1 | 0));
 return 1;
}

function runPostSets22() {
 HEAP32[gb + 38344 >> 2] = fb + 1;
 HEAP32[gb + 38348 >> 2] = fb + 1;
 HEAP32[gb + 38352 >> 2] = fb + 268;
 HEAP32[gb + 38356 >> 2] = fb + 7;
 HEAP32[gb + 38360 >> 2] = fb + 157;
 HEAP32[gb + 38364 >> 2] = fb + 158;
 HEAP32[gb + 38368 >> 2] = fb + 1;
 HEAP32[gb + 38372 >> 2] = fb + 13;
 HEAP32[gb + 38376 >> 2] = fb + 15;
 HEAP32[gb + 38380 >> 2] = fb + 269;
 HEAP32[gb + 38384 >> 2] = fb + 58;
 HEAP32[gb + 38388 >> 2] = fb + 1;
 HEAP32[gb + 38392 >> 2] = fb + 8;
 HEAP32[gb + 38396 >> 2] = fb + 2;
 HEAP32[gb + 38400 >> 2] = fb + 270;
 HEAP32[gb + 38404 >> 2] = fb + 282;
 HEAP32[gb + 38408 >> 2] = fb + 283;
 HEAP32[gb + 38412 >> 2] = fb + 3;
 HEAP32[gb + 38416 >> 2] = fb + 2;
 HEAP32[gb + 38420 >> 2] = fb + 3;
 HEAP32[gb + 38424 >> 2] = fb + 271;
 HEAP32[gb + 38428 >> 2] = fb + 284;
 HEAP32[gb + 38432 >> 2] = fb + 272;
 HEAP32[gb + 38436 >> 2] = fb + 273;
 HEAP32[gb + 38440 >> 2] = fb + 274;
 HEAP32[gb + 38444 >> 2] = fb + 159;
 HEAP32[gb + 38448 >> 2] = fb + 275;
 HEAP32[gb + 38452 >> 2] = fb + 9;
 HEAP32[gb + 38456 >> 2] = fb + 1;
 HEAP32[gb + 38460 >> 2] = fb + 1;
 HEAP32[gb + 38464 >> 2] = fb + 3;
 HEAP32[gb + 38468 >> 2] = fb + 276;
 HEAP32[gb + 38472 >> 2] = fb + 1;
 HEAP32[gb + 38476 >> 2] = fb + 16;
 HEAP32[gb + 38480 >> 2] = fb + 1;
 HEAP32[gb + 38484 >> 2] = fb + 285;
 HEAP32[gb + 38488 >> 2] = fb + 277;
 HEAP32[gb + 38492 >> 2] = fb + 1;
 HEAP32[gb + 38496 >> 2] = fb + 1;
 HEAP32[gb + 38500 >> 2] = fb + 1;
 HEAP32[gb + 38504 >> 2] = fb + 160;
 HEAP32[gb + 38508 >> 2] = fb + 161;
 HEAP32[gb + 38512 >> 2] = fb + 162;
 HEAP32[gb + 38516 >> 2] = fb + 163;
 HEAP32[gb + 38520 >> 2] = fb + 17;
 HEAP32[gb + 38524 >> 2] = fb + 1;
 HEAP32[gb + 38528 >> 2] = fb + 59;
 HEAP32[gb + 38532 >> 2] = fb + 278;
 HEAP32[gb + 38536 >> 2] = fb + 1;
 HEAP32[gb + 38540 >> 2] = fb + 1;
 HEAP32[gb + 38544 >> 2] = fb + 1;
 HEAP32[gb + 38548 >> 2] = fb + 18;
 HEAP32[gb + 38552 >> 2] = fb + 19;
 HEAP32[gb + 38556 >> 2] = fb + 4;
 HEAP32[gb + 38560 >> 2] = fb + 1;
 HEAP32[gb + 38564 >> 2] = fb + 164;
 HEAP32[gb + 38568 >> 2] = fb + 279;
 HEAP32[gb + 38572 >> 2] = fb + 10;
 HEAP32[gb + 38576 >> 2] = fb + 280;
 HEAP32[gb + 38580 >> 2] = fb + 1;
 HEAP32[gb + 38584 >> 2] = fb + 1;
 HEAP32[gb + 38588 >> 2] = fb + 1;
 HEAP32[gb + 38592 >> 2] = fb + 1;
 HEAP32[gb + 38596 >> 2] = fb + 1;
 HEAP32[gb + 38600 >> 2] = fb + 1;
 HEAP32[gb + 38604 >> 2] = fb + 1;
 HEAP32[gb + 38608 >> 2] = fb + 281;
 HEAP32[gb + 38612 >> 2] = fb + 20;
 HEAP32[gb + 38616 >> 2] = fb + 2;
 HEAP32[gb + 38620 >> 2] = fb + 1;
 HEAP32[gb + 38624 >> 2] = fb + 4;
 HEAP32[gb + 38628 >> 2] = fb + 5;
 HEAP32[gb + 38632 >> 2] = fb + 1;
 HEAP32[gb + 38636 >> 2] = fb + 286;
 HEAP32[gb + 38640 >> 2] = fb + 1;
 HEAP32[gb + 38644 >> 2] = fb + 1;
 HEAP32[gb + 38648 >> 2] = fb + 1;
 HEAP32[gb + 38652 >> 2] = fb + 282;
 HEAP32[gb + 38656 >> 2] = fb + 283;
 HEAP32[gb + 38660 >> 2] = fb + 1;
 HEAP32[gb + 38664 >> 2] = fb + 165;
 HEAP32[gb + 38668 >> 2] = fb + 287;
 HEAP32[gb + 38672 >> 2] = fb + 288;
 HEAP32[gb + 38676 >> 2] = fb + 1;
 HEAP32[gb + 38680 >> 2] = fb + 166;
 HEAP32[gb + 38684 >> 2] = fb + 167;
 HEAP32[gb + 38688 >> 2] = fb + 284;
 HEAP32[gb + 38692 >> 2] = fb + 289;
 HEAP32[gb + 38696 >> 2] = fb + 290;
 HEAP32[gb + 38700 >> 2] = fb + 1;
 HEAP32[gb + 38704 >> 2] = fb + 1;
 HEAP32[gb + 38708 >> 2] = fb + 2;
 HEAP32[gb + 38712 >> 2] = fb + 2;
 HEAP32[gb + 38716 >> 2] = fb + 3;
 HEAP32[gb + 38720 >> 2] = fb + 1;
 HEAP32[gb + 38724 >> 2] = fb + 21;
 HEAP32[gb + 38728 >> 2] = fb + 291;
 HEAP32[gb + 38732 >> 2] = fb + 168;
 HEAP32[gb + 38736 >> 2] = fb + 26;
 HEAP32[gb + 38740 >> 2] = fb + 1;
 runPostSets23();
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwiw(i10, i2, i8, i7) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 1);
 i6 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i6 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i5 = 29;
 } else do if (HEAP8[i1 >> 0] | 0) {
  i6 = i8 + -1 | 0;
  while (1) {
   i1 = HEAP32[i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (i5 & 1) {
     i5 = 9;
     break;
    }
   } else i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i1 = 2;
    i5 = 24;
    break;
   }
   if ((i1 | 0) == (i7 | 0)) {
    i5 = 12;
    break;
   }
   i4 = HEAP32[i9 >> 2] | 0;
   if ((i4 | 0) >= (i6 | 0)) {
    i1 = 4;
    i5 = 24;
    break;
   }
   i5 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = i1;
   i1 = HEAP32[i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i5 = 16;
     break;
    }
    i1 = HEAP32[i9 >> 2] | 0;
   } else {
    HEAP32[i2 >> 2] = i3 + 4;
    i1 = i4;
   }
   HEAP32[i9 >> 2] = i1 + 1;
   i2 = i5;
  }
  do if ((i5 | 0) == 9) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else if ((i5 | 0) == 12) {
   i1 = HEAP32[i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = i1 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    }
   } else HEAP32[i3 >> 2] = i4 + 4;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i1 = 0;
   i5 = 24;
  } else if ((i5 | 0) == 16) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  if ((i5 | 0) == 24) {
   if ((i8 | 0) > 0) HEAP32[i2 >> 2] = 0;
   i8 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] | ((HEAP32[i9 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (!(i9 & 1)) break;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  }
  i2 = i10;
  i3 = i10;
  i5 = 29;
  break L1;
 } while (0); while (0);
 do if ((i5 | 0) == 29) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (!(i9 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 136 | 0;
 i6 = i14 + 116 | 0;
 i3 = i14;
 i4 = i14 + 112 | 0;
 i8 = i14 + 48 | 0;
 i9 = i14 + 32 | 0;
 i10 = i14 + 8 | 0;
 i12 = i14 + 44 | 0;
 i13 = __ZN20TextRenderingPrivate8TextMesh7GetMeshEv(i5) | 0;
 i7 = HEAP32[(__ZNK20TextRenderingPrivate8TextMesh7GetFontEv(i5) | 0) + 48 >> 2] | 0;
 i1 = i5 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i18 = gb + 63672 | 0;
 i19 = HEAP32[i18 + 4 >> 2] | 0;
 i20 = i3;
 HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i20 + 4 >> 2] = i19;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i6, i1, i11);
 i20 = HEAP16[i5 + 58 >> 1] | 0;
 i3 = i5 + 56 | 0;
 i19 = HEAP16[i3 >> 1] | 0;
 f16 = Math_fround(HEAPF32[i5 + 68 >> 2]);
 f2 = Math_fround(HEAPF32[i5 + 64 >> 2]);
 i18 = (HEAP8[i5 + 84 >> 0] | 0) != 0;
 HEAP32[i4 >> 2] = HEAP32[i5 + 80 >> 2];
 i17 = HEAP32[i5 + 72 >> 2] | 0;
 i1 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 i1 = __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i6, i7, i20, i19, Math_fround(0.0), f16, f2, i18, 0, i11, Math_fround(1.0), i17, i1) | 0;
 __ZN11UTF16StringD2Ev(i6);
 f2 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f16 = Math_fround(-f2);
 f15 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 8 >> 2] = f16;
 HEAPF32[i11 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = f15;
 __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i6, i1, i11);
 switch (HEAP16[i3 >> 1] | 0) {
 case 2:
  {
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i6 >> 2]));
   HEAPF32[i6 >> 2] = f2;
   break;
  }
 case 1:
  {
   f2 = Math_fround(Math_fround(f2 * Math_fround(.5)) + Math_fround(HEAPF32[i6 >> 2]));
   HEAPF32[i6 >> 2] = f2;
   break;
  }
 default:
  f2 = Math_fround(HEAPF32[i6 >> 2]);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i5 + 60 >> 2]);
 f16 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f15 = Math_fround(f16 * f21);
 HEAPF32[i9 >> 2] = f15;
 f16 = Math_fround(-Math_fround(f21 * f16));
 HEAPF32[i9 + 4 >> 2] = f16;
 HEAPF32[i9 + 8 >> 2] = f15;
 f15 = Math_fround(f2 * f15);
 f16 = Math_fround(-Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * f16));
 i20 = HEAP32[i5 + 52 >> 2] | 0;
 HEAPF32[i11 >> 2] = f15;
 HEAPF32[i11 + 4 >> 2] = f16;
 HEAP32[i11 + 8 >> 2] = i20;
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i8, i11) | 0;
 __ZN10Matrix4x4f5ScaleERK8Vector3f(i8, i9) | 0;
 __ZN4Mesh15CopyTransformedERKS_RK10Matrix4x4f(i13, i1, i8);
 i1 = i13 + 48 | 0;
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i8, i10);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 30912 | 0) | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i12 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 __ZN12MeshRenderer13SetSharedMeshE4PPtrI4MeshE(i1, i11);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_(i26, i27, i20, i8, i1) {
 i26 = i26 | 0;
 i27 = i27 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, f29 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i28;
 i21 = __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_(i26, i27, i20, i1) | 0;
 f29 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 i7 = i20 + 28 | 0;
 if (!(f29 < Math_fround(HEAPF32[i7 >> 2]))) {
  i27 = i21;
  STACKTOP = i28;
  return i27 | 0;
 }
 i1 = HEAP32[i20 >> 2] | 0;
 i15 = i20 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = i20 + 8 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i17 = i20 + 12 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 i18 = i20 + 16 | 0;
 i5 = HEAP32[i18 >> 2] | 0;
 i19 = i20 + 20 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i14 = i20 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 i22 = i20;
 i23 = i8;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = i6;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 f29 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = i27 + 28 | 0;
 if (!(f29 < Math_fround(HEAPF32[i1 >> 2]))) {
  i27 = i21 + 1 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i2 = HEAP32[i27 >> 2] | 0;
 i9 = i27 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i27 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i11 = i27 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i12 = i27 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = i27 + 20 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i8 = i27 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i22 = i27;
 i23 = i20;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i20 >> 2] = i2;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i16 >> 2] = i4;
 HEAP32[i17 >> 2] = i5;
 HEAP32[i18 >> 2] = i6;
 HEAP32[i19 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 f29 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f29 < Math_fround(HEAPF32[i26 + 28 >> 2]))) {
  i27 = i21 + 2 | 0;
  STACKTOP = i28;
  return i27 | 0;
 }
 i1 = HEAP32[i26 >> 2] | 0;
 i2 = HEAP32[i26 + 4 >> 2] | 0;
 i3 = HEAP32[i26 + 8 >> 2] | 0;
 i4 = HEAP32[i26 + 12 >> 2] | 0;
 i5 = HEAP32[i26 + 16 >> 2] | 0;
 i6 = HEAP32[i26 + 20 >> 2] | 0;
 i22 = i26 + 24 | 0;
 HEAP32[i25 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i25 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i25 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 i22 = i26;
 i23 = i27;
 i24 = i22 + 36 | 0;
 do {
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  i22 = i22 + 4 | 0;
  i23 = i23 + 4 | 0;
 } while ((i22 | 0) < (i24 | 0));
 HEAP32[i27 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
 i27 = i21 + 3 | 0;
 STACKTOP = i28;
 return i27 | 0;
}

function __ZN5physx12PxsRigidBody12advanceToToiEffb(i17, f1, f4, i6) {
 i17 = i17 | 0;
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i12 = HEAP32[i17 + 64 >> 2] | 0;
 if (Math_fround(HEAPF32[i12 + 124 >> 2]) == Math_fround(0.0)) return;
 i10 = i12 + 16 | 0;
 i13 = i17 + 32 | 0;
 i14 = i17 + 36 | 0;
 i15 = i17 + 40 | 0;
 i16 = i17 + 44 | 0;
 i7 = HEAP32[i17 + 48 >> 2] | 0;
 i8 = HEAP32[i17 + 52 >> 2] | 0;
 i9 = HEAP32[i17 + 56 >> 2] | 0;
 if (i6) {
  HEAP32[i10 >> 2] = i7;
  HEAP32[i12 + 20 >> 2] = i8;
  HEAP32[i12 + 24 >> 2] = i9;
  i14 = HEAP32[i14 >> 2] | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = i14;
  HEAP32[i12 + 8 >> 2] = i15;
  HEAP32[i12 + 12 >> 2] = i16;
  f1 = Math_fround(Math_fround(1.0) - f1);
 } else {
  f11 = Math_fround(Math_fround(HEAPF32[i12 + 64 >> 2]) * f4);
  f3 = Math_fround(Math_fround(HEAPF32[i12 + 68 >> 2]) * f4);
  f1 = Math_fround(Math_fround(1.0) - f1);
  f11 = Math_fround(f1 * f11);
  f3 = Math_fround(f1 * f3);
  f2 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i12 + 72 >> 2]) * f4));
  f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f11);
  f3 = Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f3);
  f2 = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f2);
  HEAPF32[i10 >> 2] = f11;
  HEAPF32[i12 + 20 >> 2] = f3;
  HEAPF32[i12 + 24 >> 2] = f2;
  f2 = Math_fround(Math_fround(HEAPF32[i12 + 80 >> 2]) * f4);
  f3 = Math_fround(Math_fround(HEAPF32[i12 + 84 >> 2]) * f4);
  f2 = Math_fround(f1 * f2);
  f3 = Math_fround(f1 * f3);
  f4 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i12 + 88 >> 2]) * f4));
  f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4))));
  if (f11 > Math_fround(9.99999968e-21)) {
   f18 = Math_fround(Math_fround(1.0) / f11);
   f5 = Math_fround(f2 * f18);
   f3 = Math_fround(f3 * f18);
   f2 = Math_fround(f4 * f18);
  } else {
   f5 = Math_fround(1.0);
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
  f21 = Math_fround(f11 * Math_fround(.5));
  f23 = Math_fround(+Math_sin(+f21));
  f21 = Math_fround(+Math_cos(+f21));
  f19 = Math_fround(f5 * f23);
  f3 = Math_fround(f3 * f23);
  f23 = Math_fround(f2 * f23);
  f20 = Math_fround(HEAPF32[i13 >> 2]);
  f22 = Math_fround(HEAPF32[i14 >> 2]);
  f4 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = Math_fround(Math_fround(Math_fround(f19 * f4) + Math_fround(Math_fround(f21 * f22) + Math_fround(f3 * f2))) - Math_fround(f23 * f20));
  f11 = Math_fround(Math_fround(Math_fround(f3 * f20) + Math_fround(Math_fround(f21 * f4) + Math_fround(f23 * f2))) - Math_fround(f19 * f22));
  f18 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f2) - Math_fround(f19 * f20)) - Math_fround(f3 * f22)) - Math_fround(f23 * f4));
  HEAPF32[i12 >> 2] = Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f2))) - Math_fround(f3 * f4));
  HEAPF32[i12 + 4 >> 2] = f5;
  HEAPF32[i12 + 8 >> 2] = f11;
  HEAPF32[i12 + 12 >> 2] = f18;
 }
 i17 = (HEAP32[i17 + 60 >> 2] | 0) + 4 | 0;
 f23 = Math_fround(f1 * Math_fround(HEAPF32[i17 >> 2]));
 i16 = f23 > Math_fround(.00999999977);
 HEAPF32[i17 >> 2] = i16 ? f23 : Math_fround(.00999999977);
 return;
}

function __ZN15AudioMixerGroup27GetGroupInGUIDListRecursiveERKNSt3__26vectorI9UnityGUIDNS0_9allocatorIS2_EEEER13dynamic_arrayI4PPtrIS_ELj4EE(i17, i18, i19) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23 + 8 | 0;
 i21 = i23;
 i15 = i18 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i16 = i17 + 56 | 0;
  i8 = i17 + 60 | 0;
  i9 = i17 + 64 | 0;
  i10 = i17 + 68 | 0;
  i11 = i17 + 4 | 0;
  i12 = i19 + 12 | 0;
  i13 = i19 + 16 | 0;
  i14 = i19 + 4 | 0;
  i7 = 0;
  i3 = i2;
  while (1) {
   i2 = i3;
   if ((HEAP32[i2 + (i7 << 4) >> 2] | 0) == (HEAP32[i16 >> 2] | 0)) if ((HEAP32[i2 + (i7 << 4) + 4 >> 2] | 0) == (HEAP32[i8 >> 2] | 0)) if ((HEAP32[i2 + (i7 << 4) + 8 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i2 + (i7 << 4) + 12 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i13 >> 2] = i1;
      HEAP32[i19 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i19 >> 2] | 0, i1 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
      HEAP32[i13 >> 2] = i1;
      HEAP32[i19 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i4;
    HEAP32[(HEAP32[i19 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    i1 = HEAP32[i15 >> 2] | 0;
    i2 = HEAP32[i18 >> 2] | 0;
   } else i2 = i3; else i2 = i3; else i2 = i3; else i2 = i3;
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 >= i1 - i2 >> 4 >>> 0) break; else i3 = i2;
  }
 }
 i7 = i17 + 44 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i23;
  return;
 }
 i6 = i17 + 32 | 0;
 i5 = 0;
 do {
  i4 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
  HEAP32[i21 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i22 = 22; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i20, i1, i21);
    i2 = HEAP32[i20 >> 2] | 0;
    i17 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i22 = 22; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i22 = 24;
   }
  }
  if ((i22 | 0) == 22) i22 = 24;
  if ((i22 | 0) == 24) {
   i22 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
  __ZN15AudioMixerGroup27GetGroupInGUIDListRecursiveERKNSt3__26vectorI9UnityGUIDNS0_9allocatorIS2_EEEER13dynamic_arrayI4PPtrIS_ELj4EE(i1, i18, i19);
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 STACKTOP = i23;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx19ActorAABBUpdateTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 3584 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 3072 | 0;
 i13 = i15;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i9 = (HEAP32[i1 + 36 >> 2] | 0) + i2 | 0;
 if (i2 >>> 0 >= i9 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i10 = i1 + 24 | 0;
 i11 = i1 + 20 | 0;
 i8 = i1 + 28 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 do {
  i3 = HEAP32[(HEAP32[i1 + 180 >> 2] | 0) + ((HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] | 0) * 1048 | 0) + 1032 >> 2] | 0;
  if ((i3 | 0) != 1073741823) {
   i5 = 0;
   do {
    i7 = HEAP32[(HEAP32[i1 + 312 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i4 = i7 >>> 1;
    if (HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + (i7 >>> 6 << 2) >> 2] & 1 << (i4 & 31)) {
     i7 = HEAP32[i1 + 248 >> 2] | 0;
     HEAP32[i7 + (i4 * 24 | 0) >> 2] = 2122317823;
     HEAP32[i7 + (i4 * 24 | 0) + 4 >> 2] = 2122317823;
     HEAP32[i7 + (i4 * 24 | 0) + 8 >> 2] = 2122317823;
     HEAP32[i7 + (i4 * 24 | 0) + 12 >> 2] = -25165825;
     HEAP32[i7 + (i4 * 24 | 0) + 16 >> 2] = -25165825;
     HEAP32[i7 + (i4 * 24 | 0) + 20 >> 2] = -25165825;
     i7 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if ((i7 | 0) != 1073741823) {
      HEAP32[i12 + (i5 << 2) >> 2] = i4;
      i6 = HEAP32[(HEAP32[i1 + 320 >> 2] | 0) + (i3 << 2) >> 2] | 0;
      if (!i7) i14 = 10; else {
       i4 = HEAP32[i1 + 344 >> 2] | 0;
       if (!(HEAP32[i4 + (i6 << 4) + 4 >> 2] | 0)) i14 = 10; else __ZN5physx24PxsComputeAABBLocalSpaceERKNS_18PxcAABBDataDynamicERNS_9PxBounds3E(i4 + (i6 << 4) | 0, i13 + (i5 * 24 | 0) | 0);
      }
      if ((i14 | 0) == 10) {
       i14 = 0;
       __ZN5physx24PxsComputeAABBLocalSpaceERKNS_17PxcAABBDataStaticERNS_9PxBounds3E((HEAP32[i1 + 332 >> 2] | 0) + (i6 << 3) | 0, i13 + (i5 * 24 | 0) | 0);
      }
      i1 = HEAP32[i11 >> 2] | 0;
      i5 = i5 + 1 | 0;
     }
    }
    i3 = HEAP32[(HEAP32[i1 + 316 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   } while ((i3 | 0) != 1073741823);
   if (i5) {
    i3 = HEAP32[i1 + 248 >> 2] | 0;
    i4 = 0;
    do {
     i7 = HEAP32[i12 + (i4 << 2) >> 2] | 0;
     i23 = i3 + (i7 * 24 | 0) | 0;
     f16 = Math_fround(HEAPF32[i23 >> 2]);
     f17 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) >> 2]);
     i6 = i3 + (i7 * 24 | 0) + 4 | 0;
     f18 = Math_fround(HEAPF32[i6 >> 2]);
     f19 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) + 4 >> 2]);
     i20 = i3 + (i7 * 24 | 0) + 8 | 0;
     f21 = Math_fround(HEAPF32[i20 >> 2]);
     f22 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) + 8 >> 2]);
     HEAPF32[i23 >> 2] = f16 < f17 ? f16 : f17;
     HEAPF32[i6 >> 2] = f18 < f19 ? f18 : f19;
     HEAPF32[i20 >> 2] = f21 < f22 ? f21 : f22;
     i20 = i3 + (i7 * 24 | 0) + 12 | 0;
     f22 = Math_fround(HEAPF32[i20 >> 2]);
     f21 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) + 12 >> 2]);
     i6 = i3 + (i7 * 24 | 0) + 16 | 0;
     f19 = Math_fround(HEAPF32[i6 >> 2]);
     f18 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) + 16 >> 2]);
     i7 = i3 + (i7 * 24 | 0) + 20 | 0;
     f17 = Math_fround(HEAPF32[i7 >> 2]);
     f16 = Math_fround(HEAPF32[i13 + (i4 * 24 | 0) + 20 >> 2]);
     HEAPF32[i20 >> 2] = f22 > f21 ? f22 : f21;
     HEAPF32[i6 >> 2] = f19 > f18 ? f19 : f18;
     HEAPF32[i7 >> 2] = f17 > f16 ? f17 : f16;
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i5 | 0));
   }
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i9 | 0));
 STACKTOP = i15;
 return;
}

function __ZN26AnimatorOverrideController7SetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI13AnimationClipEb(i14, i2, i12, i15) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16;
 i7 = i16 + 8 | 0;
 i5 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i14) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i5 + 12 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + (i11 << 2) | 0;
 HEAP32[i6 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 if (!i11) i2 = 0; else {
  while (1) {
   if (__ZN8FindClipclERK4PPtrI13AnimationClipE(i6, i1) | 0) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i1 = i3;
    break;
   }
  }
  i2 = HEAP32[i4 >> 2] | 0;
 }
 if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + (i2 << 2) | 0)) {
  STACKTOP = i16;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 if (!i11) {
  STACKTOP = i16;
  return;
 }
 HEAP32[i7 >> 2] = i11;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 12; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 12; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i13 = 14;
 }
 if ((i13 | 0) == 12) i13 = 14;
 if ((i13 | 0) == 14) if (!(__Z31ReadObjectFromPersistentManageri(i11) | 0)) {
  STACKTOP = i16;
  return;
 }
 i8 = i14 + 84 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i14 + 96 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + (i10 << 3) | 0;
 L26 : do if (!i10) {
  i2 = i1;
  i13 = 19;
 } else {
  i2 = i1;
  do {
   if ((HEAP32[i2 >> 2] | 0) == (i11 | 0)) {
    i13 = 19;
    break L26;
   }
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i2 = i12;
  i13 = 21;
 } while (0);
 if ((i13 | 0) == 19) if ((i2 | 0) == (i3 | 0)) {
  i2 = i12;
  i13 = 21;
 } else HEAP32[i2 + 4 >> 2] = HEAP32[i12 >> 2];
 if ((i13 | 0) == 21) {
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = i10 + 1 | 0;
  i3 = i14 + 100 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i7 >>> 0 > i5 >>> 0) {
   i2 = i4 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 3, 4, i14 + 88 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i8 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i14 + 88 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i8 >> 2] = i1;
    break;
   }
  } while (0);
  HEAP32[i9 >> 2] = i7;
  i13 = i1 + (i10 << 3) | 0;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i6;
 }
 if (i15) mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i14, gb + 1105796 | 0);
 STACKTOP = i16;
 return;
}

function __ZN7mecanim9animation13LayerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i7 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = i1;
  i2 = i2 | 0 ? i2 - i4 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i4;
 } else i3 = i7 + 4 | 0;
 i4 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = i4 + 4;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i5 + 8 >> 2] = i1;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i7, i5, 0);
 i1 = i6 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 37 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function runPostSets24() {
 HEAP32[gb + 39176 >> 2] = fb + 1;
 HEAP32[gb + 39180 >> 2] = fb + 1;
 HEAP32[gb + 39184 >> 2] = fb + 1;
 HEAP32[gb + 39188 >> 2] = fb + 1;
 HEAP32[gb + 39192 >> 2] = fb + 14;
 HEAP32[gb + 39196 >> 2] = fb + 264;
 HEAP32[gb + 39200 >> 2] = fb + 265;
 HEAP32[gb + 39204 >> 2] = fb + 266;
 HEAP32[gb + 39208 >> 2] = fb + 281;
 HEAP32[gb + 39212 >> 2] = fb + 152;
 HEAP32[gb + 39216 >> 2] = fb + 153;
 HEAP32[gb + 39220 >> 2] = fb + 154;
 HEAP32[gb + 39224 >> 2] = fb + 155;
 HEAP32[gb + 39228 >> 2] = fb + 156;
 HEAP32[gb + 39232 >> 2] = fb + 6;
 HEAP32[gb + 39236 >> 2] = fb + 1;
 HEAP32[gb + 39240 >> 2] = fb + 1;
 HEAP32[gb + 39244 >> 2] = fb + 1;
 HEAP32[gb + 39248 >> 2] = fb + 1;
 HEAP32[gb + 39252 >> 2] = fb + 1;
 HEAP32[gb + 39256 >> 2] = fb + 1;
 HEAP32[gb + 39260 >> 2] = fb + 1;
 HEAP32[gb + 39264 >> 2] = fb + 1;
 HEAP32[gb + 39268 >> 2] = fb + 1;
 HEAP32[gb + 39272 >> 2] = fb + 1;
 HEAP32[gb + 39276 >> 2] = fb + 267;
 HEAP32[gb + 39280 >> 2] = fb + 12;
 HEAP32[gb + 39284 >> 2] = fb + 20;
 HEAP32[gb + 39288 >> 2] = fb + 1;
 HEAP32[gb + 39292 >> 2] = fb + 1;
 HEAP32[gb + 39296 >> 2] = fb + 268;
 HEAP32[gb + 39300 >> 2] = fb + 7;
 HEAP32[gb + 39304 >> 2] = fb + 157;
 HEAP32[gb + 39308 >> 2] = fb + 158;
 HEAP32[gb + 39312 >> 2] = fb + 1;
 HEAP32[gb + 39316 >> 2] = fb + 13;
 HEAP32[gb + 39320 >> 2] = fb + 15;
 HEAP32[gb + 39324 >> 2] = fb + 269;
 HEAP32[gb + 39328 >> 2] = fb + 58;
 HEAP32[gb + 39332 >> 2] = fb + 1;
 HEAP32[gb + 39336 >> 2] = fb + 8;
 HEAP32[gb + 39340 >> 2] = fb + 2;
 HEAP32[gb + 39344 >> 2] = fb + 270;
 HEAP32[gb + 39348 >> 2] = fb + 282;
 HEAP32[gb + 39352 >> 2] = fb + 283;
 HEAP32[gb + 39356 >> 2] = fb + 3;
 HEAP32[gb + 39360 >> 2] = fb + 2;
 HEAP32[gb + 39364 >> 2] = fb + 3;
 HEAP32[gb + 39368 >> 2] = fb + 271;
 HEAP32[gb + 39372 >> 2] = fb + 284;
 HEAP32[gb + 39376 >> 2] = fb + 272;
 HEAP32[gb + 39380 >> 2] = fb + 273;
 HEAP32[gb + 39384 >> 2] = fb + 274;
 HEAP32[gb + 39388 >> 2] = fb + 159;
 HEAP32[gb + 39392 >> 2] = fb + 275;
 HEAP32[gb + 39396 >> 2] = fb + 9;
 HEAP32[gb + 39400 >> 2] = fb + 1;
 HEAP32[gb + 39404 >> 2] = fb + 1;
 HEAP32[gb + 39408 >> 2] = fb + 3;
 HEAP32[gb + 39412 >> 2] = fb + 276;
 HEAP32[gb + 39416 >> 2] = fb + 1;
 HEAP32[gb + 39420 >> 2] = fb + 16;
 HEAP32[gb + 39424 >> 2] = fb + 1;
 HEAP32[gb + 39428 >> 2] = fb + 285;
 HEAP32[gb + 39432 >> 2] = fb + 277;
 HEAP32[gb + 39436 >> 2] = fb + 1;
 HEAP32[gb + 39440 >> 2] = fb + 1;
 HEAP32[gb + 39444 >> 2] = fb + 1;
 HEAP32[gb + 39448 >> 2] = fb + 160;
 HEAP32[gb + 39452 >> 2] = fb + 161;
 HEAP32[gb + 39456 >> 2] = fb + 162;
 HEAP32[gb + 39460 >> 2] = fb + 163;
 HEAP32[gb + 39464 >> 2] = fb + 17;
 HEAP32[gb + 39468 >> 2] = fb + 1;
 HEAP32[gb + 39472 >> 2] = fb + 59;
 HEAP32[gb + 39476 >> 2] = fb + 278;
 HEAP32[gb + 39480 >> 2] = fb + 1;
 HEAP32[gb + 39484 >> 2] = fb + 1;
 HEAP32[gb + 39488 >> 2] = fb + 1;
 HEAP32[gb + 39492 >> 2] = fb + 18;
 HEAP32[gb + 39496 >> 2] = fb + 19;
 HEAP32[gb + 39500 >> 2] = fb + 4;
 HEAP32[gb + 39504 >> 2] = fb + 1;
 HEAP32[gb + 39508 >> 2] = fb + 164;
 HEAP32[gb + 39512 >> 2] = fb + 279;
 HEAP32[gb + 39516 >> 2] = fb + 10;
 HEAP32[gb + 39520 >> 2] = fb + 280;
 HEAP32[gb + 39524 >> 2] = fb + 1;
 HEAP32[gb + 39528 >> 2] = fb + 1;
 HEAP32[gb + 39532 >> 2] = fb + 1;
 HEAP32[gb + 39536 >> 2] = fb + 1;
 HEAP32[gb + 39540 >> 2] = fb + 1;
 HEAP32[gb + 39544 >> 2] = fb + 1;
 HEAP32[gb + 39548 >> 2] = fb + 1;
 HEAP32[gb + 39552 >> 2] = fb + 281;
 HEAP32[gb + 39556 >> 2] = fb + 20;
 HEAP32[gb + 39560 >> 2] = fb + 2;
 HEAP32[gb + 39564 >> 2] = fb + 1;
 HEAP32[gb + 39568 >> 2] = fb + 4;
 HEAP32[gb + 39572 >> 2] = fb + 5;
 runPostSets25();
}

function __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEEC2ERNS_7profile12ProfileArrayINS0_14NameStackEntryEEERNS_9XmlWriterEPKS2_RNS_12MemoryBufferERNS_12PxCollectionEPNS4_14ProfileHashMapIKyPKNS_18PxArticulationLinkENS_6shdfnd4HashISI_EEEE(i3, i2, i4, i7, i6, i1, i5) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22;
 i19 = i22 + 564 | 0;
 i21 = i22 + 288 | 0;
 i10 = i22 + 12 | 0;
 i20 = i22 + 16 | 0;
 i18 = i22 + 8 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = i7;
 HEAP32[i3 + 12 >> 2] = i6;
 HEAP32[i3 + 16 >> 2] = i1;
 i16 = i3 + 20 | 0;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i21 >> 2] = HEAP32[i6 + 8 >> 2];
 i14 = i21 + 260 | 0;
 i11 = i21 + 264 | 0;
 HEAP32[i21 + 268 >> 2] = 0;
 i12 = i21 + 272 | 0;
 HEAP8[i14 >> 0] = 1;
 i15 = i21 + 4 | 0;
 HEAP32[i11 >> 2] = i15;
 HEAP32[i12 >> 2] = 64;
 i13 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i21, i13, i10);
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0, HEAP32[i11 >> 2] | 0, i13 | 0) | 0;
 if (i13 | 0) {
  i6 = i20 + 256 | 0;
  i7 = i20 + 260 | 0;
  i8 = i20 + 264 | 0;
  i9 = i20 + 268 | 0;
  i10 = 0;
  do {
   i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP8[i6 >> 0] = 1;
   HEAP32[i7 >> 2] = i20;
   HEAP32[i9 >> 2] = 64;
   i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0) | 0;
   HEAP32[i18 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i20, i5, i18);
   mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i5 | 0) | 0;
   if (i5 | 0) {
    i4 = 0;
    do {
     i3 = HEAP32[i16 >> 2] | 0;
     i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     i23 = i17;
     HEAP32[i23 >> 2] = i2;
     HEAP32[i23 + 4 >> 2] = 0;
     i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE6createERS4_Rb(i3, i17, i19) | 0;
     if (!(HEAP8[i19 >> 0] | 0)) {
      i23 = i3;
      HEAP32[i23 >> 2] = i2;
      HEAP32[i23 + 4 >> 2] = 0;
      HEAP32[i3 + 8 >> 2] = i1;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i5 | 0));
   }
   i23 = HEAP32[i9 >> 2] | 0;
   do if ((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0) {
    i1 = HEAP32[i7 >> 2] | 0;
    if ((i20 | 0) == (i1 | 0)) {
     HEAP8[i6 >> 0] = 0;
     break;
    }
    if (i1 | 0) {
     i23 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
    }
   } while (0);
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i13 | 0));
 }
 i23 = HEAP32[i12 >> 2] | 0;
 if (!((i23 | 0) > -1 & (i23 & 2147483647 | 0) != 0)) {
  STACKTOP = i22;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i15 | 0) == (i1 | 0)) {
  HEAP8[i14 >> 0] = 0;
  STACKTOP = i22;
  return;
 }
 if (!i1) {
  STACKTOP = i22;
  return;
 }
 i23 = HEAP32[HEAP32[i21 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i23 >> 2] | 0) + 12 >> 2] | 0, i23 | 0, i1 | 0);
 STACKTOP = i22;
 return;
}

function __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i8, i2, i10) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = (i10 - i2 | 0) / 40 | 0;
 i9 = i8 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i3 = i6;
 if (i7 >>> 0 <= ((i1 - i6 | 0) / 40 | 0) >>> 0) {
  i8 = i8 + 4 | 0;
  i1 = ((HEAP32[i8 >> 2] | 0) - i6 | 0) / 40 | 0;
  i5 = i7 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 40 | 0) | 0;
  i4 = i5 ? i1 : i10;
  if ((i4 | 0) == (i2 | 0)) i2 = i3; else {
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    i6 = i2 + 32 | 0;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i9 = i3 + 32 | 0;
    HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i9 + 4 >> 2] = i7;
    i2 = i2 + 40 | 0;
    i3 = i3 + 40 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i2 = i3;
  }
  if (!i5) {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i8 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
   return;
  }
  if ((i4 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i8 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i9 = i2 + 12 | 0;
   i7 = i1 + 12 | 0;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i9 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   i1 = i1 + 40 | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + 40 | 0;
   HEAP32[i8 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 i5 = i6;
 if (i6) {
  i1 = i8 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i4 + (~(((i4 + -40 - i6 | 0) >>> 0) / 40 | 0) * 40 | 0);
  __ZdlPv(i5);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  i1 = 0;
 }
 if (i7 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else i3 = 0;
 i6 = (i1 - i3 | 0) / 40 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 53687091 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 107374182;
 if (i3 >>> 0 > 107374182) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
 i1 = __Znwj(i3 * 40 | 0) | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + (i3 * 40 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i9 = i1 + 12 | 0;
  i8 = i2 + 12 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  i2 = i2 + 40 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 40 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN14SerializedFile10ReadHeaderEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19 + 8 | 0;
 i12 = i19;
 i2 = i19 + 36 | 0;
 i17 = i19 + 16 | 0;
 i5 = i16 + 24 | 0;
 if ((HEAP32[i5 >> 2] | 0) >>> 0 < 20) {
  i18 = -1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i14 = i16 + 128 | 0;
 i15 = i16 + 20 | 0;
 __Z13ReadFileCacheR15CacheReaderBasePvjj(HEAP32[i14 >> 2] | 0, i2, HEAP32[i15 >> 2] | 0, 20);
 i3 = HEAP32[i2 >> 2] | 0;
 i8 = _llvm_bswap_i32(i3 | 0) | 0;
 HEAP32[i2 >> 2] = i8;
 i13 = i2 + 4 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i7 = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i13 >> 2] = i7;
 i13 = i2 + 8 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i1 = _llvm_bswap_i32(i10 | 0) | 0;
 HEAP32[i13 >> 2] = i1;
 i9 = i2 + 12 | 0;
 i6 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = i6;
 if ((i3 | 0) == -1 | (i10 | 0) == 16777216) {
  i18 = -1;
  STACKTOP = i19;
  return i18 | 0;
 }
 if (i1 >>> 0 > 17) {
  i18 = 1;
  STACKTOP = i19;
  return i18 | 0;
 }
 do if (i1 >>> 0 > 8) {
  if (i6 >>> 0 > i7 >>> 0 ? 1 : (i7 + (HEAP32[i15 >> 2] | 0) | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   i18 = -1;
   STACKTOP = i19;
   return i18 | 0;
  }
  switch (i7 | 0) {
  case 0:
  case -1:
   {
    i18 = -1;
    STACKTOP = i19;
    return i18 | 0;
   }
  default:
   {}
  }
  i1 = HEAP8[i2 + 16 >> 0] | 0;
  i2 = i16 + 44 | 0;
  HEAP8[i2 >> 0] = i1;
  if (!i4) {
   i18 = -1;
   STACKTOP = i19;
   return i18 | 0;
  } else {
   i5 = 20;
   i3 = i8;
   i10 = i2;
  }
 } else {
  i2 = i7 - i8 | 0;
  if (!i3) {
   i18 = -1;
   STACKTOP = i19;
   return i18 | 0;
  }
  i1 = HEAP32[i15 >> 2] | 0;
  if (i2 >>> 0 > i7 >>> 0 ? 1 : (i1 + i7 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   i18 = -1;
   STACKTOP = i19;
   return i18 | 0;
  } else {
   i9 = i16 + 44 | 0;
   __Z13ReadFileCacheR15CacheReaderBasePvjj(HEAP32[i14 >> 2] | 0, i9, i1 + i2 | 0, 1);
   i7 = i2;
   i6 = 0;
   i5 = i2 + 1 | 0;
   i3 = i8 + -1 | 0;
   i10 = i9;
   i1 = HEAP8[i9 >> 0] | 0;
   break;
  }
 } while (0);
 if ((i1 & 255) >= 2) {
  i18 = -1;
  STACKTOP = i19;
  return i18 | 0;
 }
 i9 = gb + 63416 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i17 >> 2] = 0;
 i4 = i17 + 12 | 0;
 i8 = i17 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i12);
 i2 = i11;
 i11 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i4 >> 2] = i3;
 if (!i3) i1 = 0; else {
  HEAP32[i8 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i3, 1, i9, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i17 >> 2] = i1;
 }
 __Z13ReadFileCacheR15CacheReaderBasePvjj(HEAP32[i14 >> 2] | 0, i1, (HEAP32[i15 >> 2] | 0) + i5 | 0, i3);
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[i10 >> 0] | 0)) if (__ZN14SerializedFile12ReadMetadataILb0EEEbijPKhjj(i16, i2, i6, i3, i1, i7) | 0) i18 = 17; else i1 = -1; else if (__ZN14SerializedFile12ReadMetadataILb1EEEbijPKhjj(i16, i2, i6, i3, i1, i7) | 0) i18 = 17; else i1 = -1;
 if ((i18 | 0) == 17) {
  __ZN14SerializedFile27PatchRemapDeprecatedClassesEv(i16);
  i1 = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i9);
  HEAP32[i17 >> 2] = 0;
 }
 i18 = i1;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(i4, i22, i23) {
 i4 = i4 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24;
 i1 = i24 + 4 | 0;
 i5 = HEAP32[gb + 1104264 >> 2] | 0;
 if ((HEAP16[gb + 1104676 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i21 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104676 | 0, i21);
  i17 = gb + 1104676 | 0;
 } else i17 = 0;
 L4 : do if (i4 | 0) {
  i20 = i5 + 28 | 0;
  i1 = HEAP32[i20 >> 2] | 0;
  i18 = i5 + 32 | 0;
  i16 = HEAP32[i18 >> 2] | 0;
  i19 = i1 + (i16 << 3) | 0;
  L6 : do if (i16) {
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i2 = HEAP32[i5 + 12 >> 2] | 0;
   if ((HEAP8[i5 + 8 >> 0] | 0) != 0 & (HEAP32[i5 + 4 >> 2] | 0) != 0) while (1) {
    i16 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i16 | 0) | (i2 | 0) == (i16 | 0))) break L6;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i19 | 0)) break L4;
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L6;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i19 | 0)) break L4;
   }
  } while (0);
  if ((i1 | 0) != (i19 | 0)) {
   i16 = i4 + 24 | 0;
   i9 = i4 + 28 | 0;
   i10 = i22 + 12 | 0;
   i11 = i22 + 16 | 0;
   i12 = i22 + 4 | 0;
   i13 = i5 + 20 | 0;
   i14 = i5 + 8 | 0;
   i15 = i5 + 4 | 0;
   i8 = i5 + 12 | 0;
   do {
    i3 = i1 + 4 | 0;
    if ((((HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0) >>> 21) - (HEAP32[i16 >> 2] | 0) | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
     i4 = HEAP32[i10 >> 2] | 0;
     i5 = i4 + 1 | 0;
     i6 = HEAP32[i11 >> 2] | 0;
     i7 = i6 & 2147483647;
     do if (i5 >>> 0 > i7 >>> 0) {
      i2 = i6 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
       HEAP32[i11 >> 2] = i2;
       HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i7 | 0, HEAP32[i22 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
       HEAP32[i11 >> 2] = i2;
       HEAP32[i22 >> 2] = i7;
       break;
      }
     } while (0);
     HEAP32[i10 >> 2] = i5;
     HEAP32[(HEAP32[i22 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
    }
    i1 = i1 + 8 | 0;
    L29 : do if ((i1 | 0) == (i19 | 0)) i1 = i19; else {
     i3 = HEAP32[i13 >> 2] | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if ((HEAP8[i14 >> 0] | 0) != 0 & (HEAP32[i15 >> 2] | 0) != 0) while (1) {
      i7 = HEAP32[i1 >> 2] | 0;
      if (!((i3 | 0) == (i7 | 0) | (i2 | 0) == (i7 | 0))) break L29;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i19 | 0)) {
       i1 = i19;
       break;
      }
     } else while (1) {
      if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L29;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i19 | 0)) {
       i1 = i19;
       break;
      }
     }
    } while (0);
   } while ((i1 | 0) != ((HEAP32[i20 >> 2] | 0) + (HEAP32[i18 >> 2] << 3) | 0));
  }
 } while (0);
 if (i17 | 0) __Z12profiler_endP19ProfilerInformation(i17);
 if (!i23) {
  STACKTOP = i24;
  return;
 }
 i23 = HEAP32[i22 >> 2] | 0;
 __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_(i23, i23 + (HEAP32[i22 + 12 >> 2] << 2) | 0, i21);
 STACKTOP = i24;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23setIjNS1_4lessIjEENS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i21, i22, i1) {
 i21 = i21 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 8 | 0;
 i16 = i20 + 4 | 0;
 i17 = i20;
 i18 = i22 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i21, gb + 1041885 | 0, gb + 1041885 | 0, i16) | 0)) {
  STACKTOP = i20;
  return;
 }
 i19 = i22 + 4 | 0;
 __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i22, HEAP32[i19 >> 2] | 0);
 HEAP32[i18 >> 2] = 0;
 HEAP32[i22 >> 2] = i19;
 HEAP32[i19 >> 2] = 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i6 = HEAP32[gb + 37304 >> 2] | 0;
  i7 = i19;
  i8 = i22 + 4 | 0;
  i9 = i21 + 16 | 0;
  i10 = i21 + 80 | 0;
  i11 = i21 + 20 | 0;
  i12 = i21 + 32 | 0;
  i13 = i21 + 36 | 0;
  i14 = i21 + 24 | 0;
  i5 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i21, gb + 1041891 | 0, i6, i15, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i3 = HEAP32[i11 >> 2] | 0;
     i1 = i3 + (HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i13 >> 2] | 0, 0 - (HEAP32[i12 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i9 >> 2] = i1;
     if (i1 >>> 0 < i3 >>> 0) i4 = 10; else {
      i2 = i1 + 4 | 0;
      if (i2 >>> 0 > (HEAP32[i14 >> 2] | 0) >>> 0) i4 = 10; else {
       HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
       HEAP32[i9 >> 2] = i2;
      }
     }
     if ((i4 | 0) == 10) {
      i4 = 0;
      __ZN12CachedReader15UpdateReadCacheEPvj(i9, i17, 4);
     }
     if (HEAP32[i21 >> 2] & 512 | 0) HEAP32[i17 >> 2] = _llvm_bswap_i32(HEAP32[i17 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i15 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i17 | 0, i21 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i21);
   }
   i1 = HEAP32[i19 >> 2] | 0;
   do if (!i1) {
    HEAP32[i15 >> 2] = i19;
    i2 = i7;
    i3 = i19;
   } else {
    i4 = HEAP32[i17 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i4 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 20;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i4 >>> 0) {
       i4 = 25;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 24;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 20) {
     i4 = 0;
     HEAP32[i15 >> 2] = i1;
     i2 = i1;
     i3 = i1;
     break;
    } else if ((i4 | 0) == 24) {
     i4 = 0;
     HEAP32[i15 >> 2] = i1;
     i2 = i1;
     break;
    } else if ((i4 | 0) == 25) {
     i4 = 0;
     HEAP32[i15 >> 2] = i1;
     i2 = i1;
     i3 = i15;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(20) | 0;
    HEAP32[i1 + 16 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i22 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i22 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i1);
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i16 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i21);
 STACKTOP = i20;
 return;
}

function __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj(i10, i12, i11) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 4 | 0;
 i5 = i14;
 i6 = i14 + 8 | 0;
 i13 = i10 + 4 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i10 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 3;
   break;
  }
 default:
  i1 = 3;
 }
 if ((i1 | 0) == 3) {
  if (!i11) {
   STACKTOP = i14;
   return;
  }
  i3 = i10;
  i2 = i4;
  i1 = 0;
  while (1) {
   i9 = (HEAP32[gb + 90260 + 24 + ((i2 >>> 24 & 15) << 2) >> 2] | 0) + i3 | 0;
   i10 = (HEAP32[i12 + (i1 << 2) >> 2] | 0) + 16 | 0;
   HEAP32[i5 >> 2] = 128;
   HEAP8[i6 >> 0] = 0;
   __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i9, i10, i5, i6);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i11 | 0)) break;
   i2 = HEAP32[i13 >> 2] | 0;
  }
  STACKTOP = i14;
  return;
 }
 i1 = i10 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i10 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i9 = i2 + 88 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  if ((i11 | 0) == 1) {
   HEAP32[i2 + 84 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i9 >> 2] = 1;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i10 >> 2] | 0, i10);
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 32;
   STACKTOP = i14;
   return;
  }
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4 + 2516 | 0;
  i4 = HEAP32[i4 + 2520 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i4 + i11 | 0, i3);
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i1 + (i4 << 2) | 0)) {
   STACKTOP = i14;
   return;
  }
  if (i11 | 0) {
   i3 = 0;
   do {
    HEAP32[i1 + (i3 + i4 << 2) >> 2] = HEAP32[i12 + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i11 | 0));
  }
  HEAP32[i2 + 84 >> 2] = i4;
  HEAP32[i9 >> 2] = i11;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i10 >> 2] | 0, i10);
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 32;
  STACKTOP = i14;
  return;
 }
 i7 = i1 + i11 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i6 = i8 + 2516 | 0;
 i8 = HEAP32[i8 + 2520 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i6, i8 + i7 | 0, i3);
 i6 = HEAP32[i6 >> 2] | 0;
 i3 = i6 + (i8 << 2) | 0;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) == 1) {
  i1 = i2 + 84 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  if (i11) {
   i2 = i8 + 1 | 0;
   i3 = 0;
   do {
    HEAP32[i6 + (i2 + i3 << 2) >> 2] = HEAP32[i12 + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i11 | 0));
  }
 } else {
  i1 = i2 + 84 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + 2516 >> 2] | 0;
  if (i5 | 0) {
   i4 = 0;
   do {
    HEAP32[i6 + (i4 + i8 << 2) >> 2] = HEAP32[i3 + (i4 + i2 << 2) >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
  }
  if (i11) {
   i2 = i5 + i8 | 0;
   i3 = 0;
   do {
    HEAP32[i6 + (i2 + i3 << 2) >> 2] = HEAP32[i12 + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i11 | 0));
  }
 }
 HEAP32[i1 >> 2] = i8;
 HEAP32[i9 >> 2] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i10 >> 2] | 0, i10);
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 32;
 STACKTOP = i14;
 return;
}

function __ZN5physx16AggregateManager6resizeEj(i17, i16) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i14 = i17 + 20 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i15 = (i16 + 31 | 0) >>> 5;
 i5 = (i16 * 1048 | 0) + 15 & -16;
 i7 = (i16 << 2) + 15 & -16;
 i9 = i16 << 4;
 i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i18 + 1 | 0, ((i15 << 3) + 30 & 2147483616) + i5 + (i7 << 1) + (i16 << 5) | 0, gb + 717789 | 0, 462) | 0;
 i13 = i17 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) _memcpy(i11 | 0, i1 | 0, i10 * 1048 | 0) | 0;
 i8 = i16 - i10 | 0;
 _memset(i11 + (i10 * 1048 | 0) | 0, 0, i8 * 1048 | 0) | 0;
 i6 = i11 + i5 | 0;
 HEAP32[i13 >> 2] = i11;
 L4 : do if (i10 >>> 0 < i16 >>> 0) {
  i2 = i11;
  i1 = i10;
  while (1) {
   _memset(i2 + (i1 * 1048 | 0) | 0, 0, 1024) | 0;
   HEAP8[i2 + (i1 * 1048 | 0) + 1024 >> 0] = 1;
   HEAP8[i2 + (i1 * 1048 | 0) + 1025 >> 0] = 0;
   HEAP8[i2 + (i1 * 1048 | 0) + 1026 >> 0] = 0;
   HEAP32[i2 + (i1 * 1048 | 0) + 1028 >> 2] = 1073741823;
   HEAP32[i2 + (i1 * 1048 | 0) + 1032 >> 2] = 1073741823;
   HEAP32[i2 + (i1 * 1048 | 0) + 1036 >> 2] = 1073741823;
   HEAP32[i2 + (i1 * 1048 | 0) + 1040 >> 2] = 1073741823;
   HEAP32[i2 + (i1 * 1048 | 0) + 1044 >> 2] = 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i16 | 0)) break L4;
   i2 = HEAP32[i13 >> 2] | 0;
  }
 } while (0);
 i3 = i17 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i6 | 0, i1 | 0, i10 << 2 | 0) | 0;
 i4 = i8 << 2;
 _memset(i6 + (i10 << 2) | 0, 0, i4 | 0) | 0;
 i2 = i5 + i7 | 0;
 i5 = i11 + i2 | 0;
 HEAP32[i3 >> 2] = i6;
 i3 = i17 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i5 | 0, i1 | 0, i10 << 2 | 0) | 0;
 _memset(i5 + (i10 << 2) | 0, 0, i4 | 0) | 0;
 i2 = i2 + i7 | 0;
 i6 = i11 + i2 | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = i17 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i6 | 0, i1 | 0, i10 << 4 | 0) | 0;
 i4 = i8 << 4;
 _memset(i6 + (i10 << 4) | 0, 0, i4 | 0) | 0;
 i2 = i2 + i9 | 0;
 i5 = i11 + i2 | 0;
 HEAP32[i3 >> 2] = i6;
 i3 = i17 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i5 | 0, i1 | 0, i10 << 4 | 0) | 0;
 _memset(i5 + (i10 << 4) | 0, 0, i4 | 0) | 0;
 i4 = i2 + i9 | 0;
 i6 = i11 + i4 | 0;
 HEAP32[i3 >> 2] = i5;
 i5 = i17 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i17 + 44 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) _memcpy(i6 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i6 + ((i1 & 2147483647) << 2) | 0, 0, i15 - i1 << 2 | 0) | 0;
 i7 = i11 + (i4 + ((i15 << 2) + 15 & 1073741808)) | 0;
 HEAP32[i3 >> 2] = i6;
 i6 = i15 | -2147483648;
 HEAP32[i5 >> 2] = i6;
 i1 = i17 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 & 2147483647;
 i4 = i17 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  i11 = i7 + (i3 << 2) | 0;
  i15 = i15 - i2 | 0;
  i15 = i15 << 2;
  _memset(i11 | 0, 0, i15 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i14 >> 2] = i16;
  i16 = HEAP32[i17 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, i16);
  i16 = HEAP32[i13 >> 2] | 0;
  HEAP32[i17 >> 2] = i16;
  STACKTOP = i18;
  return;
 }
 _memcpy(i7 | 0, i5 | 0, i2 << 2 | 0) | 0;
 i11 = i7 + (i3 << 2) | 0;
 i15 = i15 - i2 | 0;
 i15 = i15 << 2;
 _memset(i11 | 0, 0, i15 | 0) | 0;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i14 >> 2] = i16;
 i16 = HEAP32[i17 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, i16);
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i17 >> 2] = i16;
 STACKTOP = i18;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 48 | 0;
 i11 = i14 + 32 | 0;
 i3 = i14 + 8 | 0;
 i4 = i14 + 24 | 0;
 i5 = i14;
 i13 = i12 + 4 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i6 | 0) / 60 | 0;
 i1 = i6;
 if (i2 >>> 0 < i9 >>> 0) {
  i1 = i12 + 8 | 0;
  if ((((HEAP32[i1 >> 2] | 0) - i6 | 0) / 60 | 0 | 0) == (i9 | 0)) {
   __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i12, i9);
   STACKTOP = i14;
   return;
  } else {
   i8 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   i10 = i3 + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = i8;
   __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i3, i9);
   HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i3, i11, i7);
   __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i3, i9);
   i11 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i11;
   i12 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i13 >> 2] = i12;
   i12 = i3 + 8 | 0;
   i13 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i13;
   __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i3);
   STACKTOP = i14;
   return;
  }
 }
 if (i2 >>> 0 <= i9 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i8 = i1 + (i9 * 60 | 0) | 0;
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = i11 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i9 * 60 | 0;
 i5 = (i4 | 0) / 60 | 0;
 if (!i4) {
  i3 = i11 + 8 | 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = 25;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  i6 = i2 + (i5 * 60 | 0) | 0;
  i7 = i11 + 8 | 0;
  HEAP32[i7 >> 2] = i6;
  i5 = i2;
  if (!i9) {
   i3 = i7;
   i4 = i5;
   i2 = i5;
   i1 = i6;
  } else {
   do {
    __ZN13AnimationClip9PPtrCurveC2ERKS0_(i2, i1);
    i1 = i1 + 60 | 0;
    i2 = (HEAP32[i10 >> 2] | 0) + 60 | 0;
    HEAP32[i10 >> 2] = i2;
   } while ((i1 | 0) != (i8 | 0));
   i3 = i7;
   i4 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i13 = i12 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_(i16, i17, i14, i4, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i15 = __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_(i16, i17, i14, i1) | 0;
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i4 + 12 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i14 >> 2]);
 i1 = i14 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i17 = i15;
  return i17 | 0;
 }
 i9 = i14 + 4 | 0;
 i19 = HEAP32[i9 >> 2] | 0;
 i10 = i14 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i11 = i14 + 16 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i12 = i14 + 20 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i13 = i14 + 24 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i4 + 4 >> 2] = i19;
 HEAP32[i4 + 8 >> 2] = i5;
 HEAPF32[i4 + 12 >> 2] = f3;
 HEAP32[i4 + 16 >> 2] = i6;
 HEAP32[i4 + 20 >> 2] = i7;
 HEAP32[i4 + 24 >> 2] = i8;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i17 >> 2]);
 i1 = i17 + 12 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i19 = i15 + 1 | 0;
  return i19 | 0;
 }
 i4 = i17 + 4 | 0;
 i23 = HEAP32[i4 >> 2] | 0;
 i5 = i17 + 8 | 0;
 i22 = HEAP32[i5 >> 2] | 0;
 i6 = i17 + 16 | 0;
 i21 = HEAP32[i6 >> 2] | 0;
 i7 = i17 + 20 | 0;
 i20 = HEAP32[i7 >> 2] | 0;
 i8 = i17 + 24 | 0;
 i19 = HEAP32[i8 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
 HEAPF32[i14 >> 2] = f2;
 HEAP32[i9 >> 2] = i23;
 HEAP32[i10 >> 2] = i22;
 HEAPF32[i14 + 12 >> 2] = f3;
 HEAP32[i11 >> 2] = i21;
 HEAP32[i12 >> 2] = i20;
 HEAP32[i13 >> 2] = i19;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 if (!(f18 < Math_fround(Math_fround(f2 + f3) * Math_fround(.5)))) {
  i23 = i15 + 2 | 0;
  return i23 | 0;
 }
 i19 = HEAP32[i16 + 4 >> 2] | 0;
 i20 = HEAP32[i16 + 8 >> 2] | 0;
 i21 = HEAP32[i16 + 16 >> 2] | 0;
 i22 = HEAP32[i16 + 20 >> 2] | 0;
 i23 = HEAP32[i16 + 24 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i16 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
 HEAPF32[i17 >> 2] = f2;
 HEAP32[i4 >> 2] = i19;
 HEAP32[i5 >> 2] = i20;
 HEAPF32[i17 + 12 >> 2] = f3;
 HEAP32[i6 >> 2] = i21;
 HEAP32[i7 >> 2] = i22;
 HEAP32[i8 >> 2] = i23;
 i23 = i15 + 3 | 0;
 return i23 | 0;
}

function __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS4_RS6_EEPS4_(i14, i15, i13) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0;
 i16 = i15 + 4 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 if ((i10 | 0) == (i13 | 0)) i1 = i17; else {
  i9 = i13;
  i1 = i17;
  do {
   i6 = i9;
   i9 = i9 + -40 | 0;
   HEAP32[i1 + -40 >> 2] = HEAP32[i9 >> 2];
   i3 = i1 + -32 | 0;
   i4 = i6 + -32 | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   i3 = i1 + -16 | 0;
   i4 = i6 + -16 | 0;
   HEAP32[i3 >> 2] = 0;
   i8 = i1 + -12 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i1 + -8 >> 2] = 0;
   i6 = i6 + -12 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
   i5 = i2 >> 2;
   if (i5 | 0) {
    if (i5 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
    i7 = __Znwj(i2) | 0;
    HEAP32[i8 >> 2] = i7;
    HEAP32[i3 >> 2] = i7;
    HEAP32[i1 + -8 >> 2] = i7 + (i5 << 2);
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i7 | 0, i2 | 0, i1 | 0) | 0;
     HEAP32[i8 >> 2] = i7 + (i1 >> 2 << 2);
    }
   }
   i1 = (HEAP32[i16 >> 2] | 0) + -40 | 0;
   HEAP32[i16 >> 2] = i1;
  } while ((i9 | 0) != (i10 | 0));
 }
 i10 = i14 + 4 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i15 + 8 | 0;
 if ((i11 | 0) == (i13 | 0)) {
  i11 = i1;
  i13 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i11;
  HEAP32[i16 >> 2] = i13;
  i13 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i12 >> 2] = i13;
  i12 = i14 + 8 | 0;
  i14 = i15 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i16 = HEAP32[i16 >> 2] | 0;
  HEAP32[i15 >> 2] = i16;
  return i17 | 0;
 }
 i8 = i13;
 i2 = HEAP32[i12 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  i3 = i2 + 8 | 0;
  i4 = i8 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i3 = i2 + 24 | 0;
  i4 = i8 + 24 | 0;
  HEAP32[i3 >> 2] = 0;
  i9 = i2 + 28 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 + 32 >> 2] = 0;
  i6 = i8 + 28 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = i1 >> 2;
  if (i5 | 0) {
   if (i5 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i7 = __Znwj(i1) | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i2 + 32 >> 2] = i7 + (i5 << 2);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i6 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i7 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i9 >> 2] = i7 + (i1 >> 2 << 2);
   }
  }
  i8 = i8 + 40 | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 40 | 0;
  HEAP32[i12 >> 2] = i2;
 } while ((i8 | 0) != (i11 | 0));
 i13 = i16;
 i11 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = i11;
 HEAP32[i13 >> 2] = i16;
 i16 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i12 >> 2] = i16;
 i12 = i14 + 8 | 0;
 i16 = i15 + 12 | 0;
 i14 = HEAP32[i12 >> 2] | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i16 >> 2] = i14;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i15 >> 2] = i16;
 return i17 | 0;
}

function __ZN18ProceduralMaterial8TransferI17RemapPPtrTransferEEvRT_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i13 = i14;
 __ZN8Material8TransferI17RemapPPtrTransferEEvRT_(i11, i1);
 i2 = HEAP32[i11 + 124 >> 2] | 0;
 i3 = HEAP32[i11 + 128 >> 2] | 0;
 i6 = i1 + 16 | 0;
 i7 = i1 + 36 | 0;
 i5 = i1 + 40 | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = i11 + 108 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i11 + 176 >> 2] | 0;
 i4 = HEAP32[i11 + 180 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1 + 84 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i7 = i11 + 156 | 0;
 i8 = i7 + 11 | 0;
 i6 = HEAP8[i8 >> 0] | 0;
 i9 = i11 + 160 | 0;
 if ((i6 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i6 & 255) | 0) {
  STACKTOP = i14;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i13 + 12 >> 2] | 0;
  i10 = 15;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i13 + 11 >> 0] = i3;
  if (!i3) i1 = i13; else {
   i1 = i13;
   i10 = 17;
  }
 } else i10 = 15;
 if ((i10 | 0) == 15) {
  i6 = i3 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i13 + 4 >> 2] = i3;
  i10 = 17;
 }
 if ((i10 | 0) == 17) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i13 + 11 | 0;
 do if ((i7 | 0) != (i13 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i1 = i6 << 24 >> 24 < 0;
  i5 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
  i6 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i6 & 255;
  i1 = HEAP8[i8 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i11 + 164 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i6 - i3 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   HEAP32[i9 >> 2] = i6;
   break;
  } else {
   HEAP8[i8 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i11 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i13;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
 }
 STACKTOP = i14;
 return;
}

function _UNITY_png_write_iCCP(i11, i4, i6) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 1120 | 0;
 i9 = i13 + 1036 | 0;
 i10 = i13;
 if (!i6) _UNITY_png_error(i11, gb + 354872 | 0);
 i1 = HEAPU8[i6 + 3 >> 0] | 0;
 i7 = (HEAPU8[i6 + 1 >> 0] | 0) << 16 | (HEAPU8[i6 >> 0] | 0) << 24 | (HEAPU8[i6 + 2 >> 0] | 0) << 8 | i1;
 if (i7 >>> 0 < 132) _UNITY_png_error(i11, gb + 354898 | 0);
 if (i1 & 3 | 0) _UNITY_png_error(i11, gb + 354920 | 0);
 if (!i4) {
  HEAP8[i9 >> 0] = 0;
  _UNITY_png_error(i11, gb + 354969 | 0);
 }
 i3 = HEAP8[i4 >> 0] | 0;
 L14 : do if (!(i3 << 24 >> 24)) {
  i3 = 1;
  i1 = 0;
  i2 = i9;
 } else {
  i5 = 1;
  i1 = 0;
  i2 = i9;
  while (1) {
   L17 : do if (!i5) {
    i8 = (i3 & 255) > 160 | (i3 + -33 & 255) < 94;
    i5 = i8 & 1 ^ 1;
    i4 = i4 + 1 | 0;
    i3 = i8 ? i3 : 32;
   } else while (1) {
    i4 = i4 + 1 | 0;
    if ((i3 & 255) > 160 | (i3 + -33 & 255) < 94) {
     i5 = 0;
     break L17;
    }
    i3 = HEAP8[i4 >> 0] | 0;
    if (!(i3 << 24 >> 24)) {
     i3 = i5;
     break L14;
    }
   } while (0);
   HEAP8[i2 >> 0] = i3;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i1 >>> 0 < 79 & i3 << 24 >> 24 != 0)) {
    i3 = i5;
    break;
   }
  }
 } while (0);
 i8 = (i1 | 0) != 0 & (i3 | 0) != 0;
 i1 = (i8 << 31 >> 31) + i1 | 0;
 HEAP8[(i8 ? i2 + -1 | 0 : i2) >> 0] = 0;
 if (!i1) _UNITY_png_error(i11, gb + 354969 | 0);
 HEAP8[i9 + (i1 + 1) >> 0] = 0;
 i3 = i1 + 2 | 0;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i10 + 4 >> 2] = i7;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 if (_UNITY_png_text_compress(i11, 1766015824, i10, i3) | 0) _UNITY_png_error(i11, HEAP32[i11 + 244 >> 2] | 0);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i2 + i3 | 0;
 i8 = (i11 | 0) == 0;
 L30 : do if (i8) {
  i3 = HEAP32[69] | 0;
  i2 = i2 - (i2 >>> 0 < 1024 ? i2 : 1024) | 0;
  i1 = (i2 | 0) == 0;
  if (!((i3 | 0) == 0 | i1)) {
   i4 = HEAP32[70] | 0;
   do {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = i2 - (i4 >>> 0 > i2 >>> 0 ? i2 : i4) | 0;
    i1 = (i2 | 0) == 0;
   } while (!((i3 | 0) == 0 | i1));
  }
 } else {
  i7 = i11 + 656 | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP8[i12 >> 0] = i1 >>> 24;
  HEAP8[i12 + 1 >> 0] = i1 >>> 16;
  HEAP8[i12 + 2 >> 0] = i1 >>> 8;
  HEAP8[i12 + 3 >> 0] = i1;
  i5 = i12 + 4 | 0;
  HEAP8[i5 >> 0] = 105;
  HEAP8[i12 + 5 >> 0] = 67;
  HEAP8[i12 + 6 >> 0] = 67;
  HEAP8[i12 + 7 >> 0] = 80;
  _UNITY_png_write_data(i11, i12, 8);
  HEAP32[i11 + 372 >> 2] = 1766015824;
  _UNITY_png_reset_crc(i11);
  _UNITY_png_calculate_crc(i11, i5, 4);
  HEAP32[i7 >> 2] = 66;
  if (i3 | 0) {
   _UNITY_png_write_data(i11, i9, i3);
   _UNITY_png_calculate_crc(i11, i9, i3);
  }
  i7 = i11 + 280 | 0;
  i1 = i11 + 276 | 0;
  i4 = 1024;
  i5 = i10 + 12 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
   if (i1 | 0) {
    _UNITY_png_write_data(i11, i5, i1);
    _UNITY_png_calculate_crc(i11, i5, i1);
   }
   i2 = i2 - i1 | 0;
   i1 = (i2 | 0) == 0;
   if ((i3 | 0) == 0 | i1) break L30;
   i1 = i3;
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = i3 + 4 | 0;
  }
 } while (0);
 if (!i1) _UNITY_png_error(i11, gb + 354991 | 0);
 if (i8) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i11 + 656 >> 2] = 130;
 i10 = HEAP32[i11 + 408 >> 2] | 0;
 HEAP8[i12 >> 0] = i10 >>> 24;
 HEAP8[i12 + 1 >> 0] = i10 >>> 16;
 HEAP8[i12 + 2 >> 0] = i10 >>> 8;
 HEAP8[i12 + 3 >> 0] = i10;
 _UNITY_png_write_data(i11, i12, 4);
 STACKTOP = i13;
 return;
}

function runPostSets89() {
 HEAP32[gb + 91512 >> 2] = fb + 57;
 HEAP32[gb + 91516 >> 2] = fb + 82;
 HEAP32[gb + 91520 >> 2] = fb + 8;
 HEAP32[gb + 91524 >> 2] = fb + 154;
 HEAP32[gb + 91528 >> 2] = fb + 58;
 HEAP32[gb + 91532 >> 2] = fb + 83;
 HEAP32[gb + 91536 >> 2] = fb + 59;
 HEAP32[gb + 91540 >> 2] = fb + 84;
 HEAP32[gb + 91544 >> 2] = fb + 60;
 HEAP32[gb + 91548 >> 2] = fb + 85;
 HEAP32[gb + 91552 >> 2] = fb + 924;
 HEAP32[gb + 91556 >> 2] = fb + 561;
 HEAP32[gb + 91560 >> 2] = fb + 9;
 HEAP32[gb + 91564 >> 2] = fb + 155;
 HEAP32[gb + 91568 >> 2] = fb + 925;
 HEAP32[gb + 91572 >> 2] = fb + 562;
 HEAP32[gb + 91576 >> 2] = fb + 61;
 HEAP32[gb + 91580 >> 2] = fb + 86;
 HEAP32[gb + 91584 >> 2] = fb + 926;
 HEAP32[gb + 91588 >> 2] = fb + 927;
 HEAP32[gb + 91592 >> 2] = fb + 563;
 HEAP32[gb + 91604 >> 2] = fb + 1;
 HEAP32[gb + 91608 >> 2] = fb + 564;
 HEAP32[gb + 91612 >> 2] = fb + 456;
 HEAP32[gb + 91616 >> 2] = fb + 1270;
 HEAP32[gb + 91620 >> 2] = fb + 1271;
 HEAP32[gb + 91624 >> 2] = fb + 264;
 HEAP32[gb + 91628 >> 2] = fb + 1;
 HEAP32[gb + 91632 >> 2] = fb + 1;
 HEAP32[gb + 91636 >> 2] = fb + 1;
 HEAP32[gb + 91640 >> 2] = fb + 1;
 HEAP32[gb + 91644 >> 2] = fb + 1;
 HEAP32[gb + 91648 >> 2] = fb + 1;
 HEAP32[gb + 91652 >> 2] = fb + 1;
 HEAP32[gb + 91656 >> 2] = fb + 1;
 HEAP32[gb + 91660 >> 2] = fb + 1;
 HEAP32[gb + 91664 >> 2] = fb + 1;
 HEAP32[gb + 91668 >> 2] = fb + 1;
 HEAP32[gb + 91672 >> 2] = fb + 1;
 HEAP32[gb + 91676 >> 2] = fb + 1;
 HEAP32[gb + 91680 >> 2] = fb + 1;
 HEAP32[gb + 91684 >> 2] = fb + 1;
 HEAP32[gb + 91688 >> 2] = fb + 1;
 HEAP32[gb + 91692 >> 2] = fb + 1;
 HEAP32[gb + 91696 >> 2] = fb + 1;
 HEAP32[gb + 91700 >> 2] = fb + 1;
 HEAP32[gb + 91704 >> 2] = fb + 1;
 HEAP32[gb + 91708 >> 2] = fb + 1;
 HEAP32[gb + 91712 >> 2] = fb + 1;
 HEAP32[gb + 91716 >> 2] = fb + 1;
 HEAP32[gb + 91720 >> 2] = fb + 1;
 HEAP32[gb + 91724 >> 2] = fb + 1;
 HEAP32[gb + 91728 >> 2] = fb + 1;
 HEAP32[gb + 91732 >> 2] = fb + 1;
 HEAP32[gb + 91736 >> 2] = fb + 1;
 HEAP32[gb + 91740 >> 2] = fb + 1;
 HEAP32[gb + 91744 >> 2] = fb + 1;
 HEAP32[gb + 91748 >> 2] = fb + 1;
 HEAP32[gb + 91752 >> 2] = fb + 1;
 HEAP32[gb + 91756 >> 2] = fb + 1;
 HEAP32[gb + 91760 >> 2] = fb + 1;
 HEAP32[gb + 91764 >> 2] = fb + 1;
 HEAP32[gb + 91768 >> 2] = fb + 1;
 HEAP32[gb + 91772 >> 2] = fb + 1;
 HEAP32[gb + 91776 >> 2] = fb + 1;
 HEAP32[gb + 91780 >> 2] = fb + 1;
 HEAP32[gb + 91784 >> 2] = fb + 1;
 HEAP32[gb + 91788 >> 2] = fb + 1;
 HEAP32[gb + 91792 >> 2] = fb + 1;
 HEAP32[gb + 91796 >> 2] = fb + 1;
 HEAP32[gb + 91800 >> 2] = fb + 1;
 HEAP32[gb + 91804 >> 2] = fb + 1;
 HEAP32[gb + 91808 >> 2] = fb + 1;
 HEAP32[gb + 91812 >> 2] = fb + 1;
 HEAP32[gb + 91816 >> 2] = fb + 1;
 HEAP32[gb + 91820 >> 2] = fb + 1;
 HEAP32[gb + 91824 >> 2] = fb + 1;
 HEAP32[gb + 91828 >> 2] = fb + 1;
 HEAP32[gb + 91832 >> 2] = fb + 1;
 HEAP32[gb + 91836 >> 2] = fb + 1;
 HEAP32[gb + 91840 >> 2] = fb + 1;
 HEAP32[gb + 91852 >> 2] = fb + 1272;
 HEAP32[gb + 91856 >> 2] = fb + 564;
 HEAP32[gb + 91860 >> 2] = fb + 456;
 HEAP32[gb + 91864 >> 2] = fb + 1273;
 HEAP32[gb + 91868 >> 2] = fb + 1274;
 HEAP32[gb + 91872 >> 2] = fb + 264;
 HEAP32[gb + 91876 >> 2] = fb + 1;
 HEAP32[gb + 91880 >> 2] = fb + 565;
 HEAP32[gb + 91884 >> 2] = fb + 928;
 HEAP32[gb + 91888 >> 2] = fb + 566;
 HEAP32[gb + 91892 >> 2] = fb + 13;
 HEAP32[gb + 91896 >> 2] = fb + 156;
 HEAP32[gb + 91900 >> 2] = fb + 929;
 HEAP32[gb + 91904 >> 2] = fb + 567;
 HEAP32[gb + 91908 >> 2] = fb + 930;
 HEAP32[gb + 91912 >> 2] = fb + 568;
 HEAP32[gb + 91916 >> 2] = fb + 931;
 HEAP32[gb + 91920 >> 2] = fb + 569;
 HEAP32[gb + 91924 >> 2] = fb + 932;
 runPostSets90();
}

function __ZN7mecanim5human9HumanPose8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i7 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 906072 | 0, gb + 905989 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i4, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899117 | 0, gb + 906560 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899134 | 0, gb + 906539 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 HEAP32[i7 >> 2] = 4;
 HEAP32[i7 + 4 >> 2] = i4 + 68;
 i3 = HEAP32[gb + 37256 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899149 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIN7mecanim5human9HumanGoalELi4EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 324 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899161 | 0, gb + 899176 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7mecanim4hand8HandPose8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 460 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899185 | 0, gb + 899176 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7mecanim4hand8HandPose8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 HEAP32[i7 >> 2] = 52;
 HEAP32[i7 + 4 >> 2] = i4 + 596;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899201 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi52EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 HEAP32[i7 >> 2] = 7;
 HEAP32[i7 + 4 >> 2] = i4 + 804;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899212 | 0, i3, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN20LocalFileSystemPosix8IsLockedERK13FileEntryData(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 24 | 0;
 i1 = i7 + 12 | 0;
 i2 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i5, _strlen(i5) | 0);
 i3 = __Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i3) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i5, _strlen(i5) | 0);
  i3 = __Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  if (!i3) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  i3 = i6 + 1040 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 + 1040 >> 2];
  HEAP32[i6 + 1044 >> 2] = HEAP32[i5 + 1044 >> 2];
  HEAP32[i6 + 1048 >> 2] = 0;
  i2 = i6 + 1052 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 + 1056 >> 2] = 0;
  _strncpy(i6, i5, 1040) | 0;
  HEAP8[i6 + 1039 >> 0] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i6 | 0);
  HEAP32[i2 >> 2] = 0;
  if (mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0, 0, 0) | 0) {
   i5 = _fileno(HEAP32[i2 >> 2] | 0) | 0;
   i2 = (_flock(i5 | 0, 6) | 0) != 0;
   _flock(i5 | 0, 12) | 0;
   mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  } else i2 = 1;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i6 | 0);
  i6 = i2;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, i6, 0, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 L17 : do if (i5) {
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   while (1) {
    if (__Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2 + 16 | 0) | 0) break;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i3 | 0)) break L17; else i2 = i1;
   }
   __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, HEAP32[i3 >> 2] | 0);
   i6 = 1;
   STACKTOP = i7;
   return i6 | 0;
  }
 } while (0);
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, HEAP32[i3 >> 2] | 0);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13ComputeShader14BeforeDispatchEj(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 20 | 0;
 i2 = i9 + 8 | 0;
 i1 = i9;
 i3 = i9 + 12 | 0;
 i8 = i9 + 16 | 0;
 if (!(HEAP8[(HEAP32[gb + 1166136 >> 2] | 0) + 494 >> 0] | 0)) {
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 476943 | 0, 0, gb + 476838 | 0, 430, 1, i1, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((HEAP32[i6 + 48 >> 2] | 0) >>> 0 <= i7 >>> 0) {
  HEAP32[i1 >> 2] = i7;
  __Z6FormatPKcz(i5, gb + 476912 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 476838 | 0, 436, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = i6 + 44 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 * 976 | 0) >> 2] | 0)) {
  HEAP32[i2 >> 2] = i7;
  __Z6FormatPKcz(i5, gb + 476985 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 476838 | 0, 442, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[gb + 1163232 >> 2] | 0;
 HEAP32[gb + 1163232 >> 2] = 0;
 if ((HEAP16[gb + 1166268 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166268 | 0, i5);
  i1 = gb + 1166268 | 0;
 } else i1 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i3 >> 2] | 0) + 824 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 * 976 | 0) >> 2];
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i10 | 0, i3 | 0, i5 | 0);
 i8 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i6, 22, 0) | 0;
 i5 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i6, 22, 0) | 0;
 mftCall_viiiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 816 >> 2] | 0, i3 | 0, ((HEAP32[i5 + 24 >> 2] | 0) - (HEAP32[i5 + 20 >> 2] | 0) | 0) / 20 | 0 | 0, i6 + 192 | 0, HEAP32[i6 + 60 >> 2] | 0, HEAP32[i6 + 56 >> 2] | 0, HEAP32[i6 + 52 >> 2] | 0, i6 + 128 | 0, i6 + 64 | 0, (HEAP32[i4 >> 2] | 0) + (i7 * 976 | 0) + 4 | 0);
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 mftCall_viiiiiiiiiiiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 820 >> 2] | 0, i3 | 0, ((HEAP32[i6 + (i7 * 96 | 0) + 20 >> 2] | 0) - (HEAP32[i6 + (i7 * 96 | 0) + 16 >> 2] | 0) | 0) / 20 | 0 | 0, i8 + (i7 * 976 | 0) + 132 | 0, i8 + (i7 * 976 | 0) + 196 | 0, i8 + (i7 * 976 | 0) + 68 | 0, (HEAP32[i6 + (i7 * 96 | 0) + 32 >> 2] | 0) - (HEAP32[i6 + (i7 * 96 | 0) + 28 >> 2] | 0) >> 3 | 0, i8 + (i7 * 976 | 0) + 260 | 0, ((HEAP32[i6 + (i7 * 96 | 0) + 44 >> 2] | 0) - (HEAP32[i6 + (i7 * 96 | 0) + 40 >> 2] | 0) | 0) / 20 | 0 | 0, i8 + (i7 * 976 | 0) + 516 | 0, i8 + (i7 * 976 | 0) + 324 | 0, i8 + (i7 * 976 | 0) + 388 | 0, ((HEAP32[i6 + (i7 * 96 | 0) + 56 >> 2] | 0) - (HEAP32[i6 + (i7 * 96 | 0) + 52 >> 2] | 0) | 0) / 20 | 0 | 0, i8 + (i7 * 976 | 0) + 772 | 0, i8 + (i7 * 976 | 0) + 836 | 0, i8 + (i7 * 976 | 0) + 900 | 0, i8 + (i7 * 976 | 0) + 580 | 0, i8 + (i7 * 976 | 0) + 644 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 HEAP32[gb + 1163232 >> 2] = i2;
 i10 = 1;
 STACKTOP = i9;
 return i10 | 0;
}

function runPostSets63() {
 HEAP32[gb + 70976 >> 2] = fb + 62;
 HEAP32[gb + 70980 >> 2] = fb + 63;
 HEAP32[gb + 70984 >> 2] = fb + 64;
 HEAP32[gb + 70988 >> 2] = fb + 65;
 HEAP32[gb + 70992 >> 2] = fb + 52;
 HEAP32[gb + 70996 >> 2] = fb + 66;
 HEAP32[gb + 71e3 >> 2] = fb + 13;
 HEAP32[gb + 71004 >> 2] = fb + 121;
 HEAP32[gb + 71008 >> 2] = fb + 122;
 HEAP32[gb + 71020 >> 2] = fb + 793;
 HEAP32[gb + 71024 >> 2] = fb + 801;
 HEAP32[gb + 71028 >> 2] = fb + 1;
 HEAP32[gb + 71032 >> 2] = fb + 1;
 HEAP32[gb + 71036 >> 2] = fb + 1;
 HEAP32[gb + 71040 >> 2] = fb + 1;
 HEAP32[gb + 71044 >> 2] = fb + 1;
 HEAP32[gb + 71048 >> 2] = fb + 1;
 HEAP32[gb + 71052 >> 2] = fb + 1;
 HEAP32[gb + 71056 >> 2] = fb + 1;
 HEAP32[gb + 71060 >> 2] = fb + 1;
 HEAP32[gb + 71064 >> 2] = fb + 1;
 HEAP32[gb + 71068 >> 2] = fb + 8;
 HEAP32[gb + 71072 >> 2] = fb + 53;
 HEAP32[gb + 71076 >> 2] = fb + 9;
 HEAP32[gb + 71080 >> 2] = fb + 16;
 HEAP32[gb + 71084 >> 2] = fb + 17;
 HEAP32[gb + 71088 >> 2] = fb + 28;
 HEAP32[gb + 71092 >> 2] = fb + 67;
 HEAP32[gb + 71096 >> 2] = fb + 123;
 HEAP32[gb + 71100 >> 2] = fb + 1;
 HEAP32[gb + 71104 >> 2] = fb + 124;
 HEAP32[gb + 71108 >> 2] = fb + 125;
 HEAP32[gb + 71112 >> 2] = fb + 54;
 HEAP32[gb + 71116 >> 2] = fb + 126;
 HEAP32[gb + 71120 >> 2] = fb + 3;
 HEAP32[gb + 71124 >> 2] = fb + 40;
 HEAP32[gb + 71128 >> 2] = fb + 127;
 HEAP32[gb + 71132 >> 2] = fb + 1;
 HEAP32[gb + 71136 >> 2] = fb + 1;
 HEAP32[gb + 71140 >> 2] = fb + 17;
 HEAP32[gb + 71144 >> 2] = fb + 68;
 HEAP32[gb + 71148 >> 2] = fb + 69;
 HEAP32[gb + 71152 >> 2] = fb + 70;
 HEAP32[gb + 71156 >> 2] = fb + 56;
 HEAP32[gb + 71160 >> 2] = fb + 4;
 HEAP32[gb + 71164 >> 2] = fb + 9;
 HEAP32[gb + 71168 >> 2] = fb + 1;
 HEAP32[gb + 71172 >> 2] = fb + 128;
 HEAP32[gb + 71176 >> 2] = fb + 1;
 HEAP32[gb + 71180 >> 2] = fb + 1;
 HEAP32[gb + 71184 >> 2] = fb + 1;
 HEAP32[gb + 71188 >> 2] = fb + 654;
 HEAP32[gb + 71192 >> 2] = fb + 655;
 HEAP32[gb + 71196 >> 2] = fb + 656;
 HEAP32[gb + 71200 >> 2] = fb + 657;
 HEAP32[gb + 71204 >> 2] = fb + 658;
 HEAP32[gb + 71208 >> 2] = fb + 25;
 HEAP32[gb + 71212 >> 2] = fb + 29;
 HEAP32[gb + 71216 >> 2] = fb + 71;
 HEAP32[gb + 71228 >> 2] = fb + 11;
 HEAP32[gb + 71232 >> 2] = fb + 802;
 HEAP32[gb + 71236 >> 2] = fb + 1;
 HEAP32[gb + 71240 >> 2] = fb + 1;
 HEAP32[gb + 71244 >> 2] = fb + 1;
 HEAP32[gb + 71248 >> 2] = fb + 2;
 HEAP32[gb + 71252 >> 2] = fb + 2;
 HEAP32[gb + 71256 >> 2] = fb + 129;
 HEAP32[gb + 71260 >> 2] = fb + 2;
 HEAP32[gb + 71264 >> 2] = fb + 6;
 HEAP32[gb + 71268 >> 2] = fb + 2;
 HEAP32[gb + 71272 >> 2] = fb + 7;
 HEAP32[gb + 71276 >> 2] = fb + 8;
 HEAP32[gb + 71280 >> 2] = fb + 2;
 HEAP32[gb + 71284 >> 2] = fb + 9;
 HEAP32[gb + 71288 >> 2] = fb + 16;
 HEAP32[gb + 71292 >> 2] = fb + 17;
 HEAP32[gb + 71296 >> 2] = fb + 28;
 HEAP32[gb + 71300 >> 2] = fb + 2;
 HEAP32[gb + 71304 >> 2] = fb + 10;
 HEAP32[gb + 71308 >> 2] = fb + 11;
 HEAP32[gb + 71312 >> 2] = fb + 12;
 HEAP32[gb + 71316 >> 2] = fb + 13;
 HEAP32[gb + 71320 >> 2] = fb + 3;
 HEAP32[gb + 71324 >> 2] = fb + 14;
 HEAP32[gb + 71328 >> 2] = fb + 3;
 HEAP32[gb + 71332 >> 2] = fb + 3;
 HEAP32[gb + 71336 >> 2] = fb + 15;
 HEAP32[gb + 71340 >> 2] = fb + 16;
 HEAP32[gb + 71344 >> 2] = fb + 72;
 HEAP32[gb + 71348 >> 2] = fb + 17;
 HEAP32[gb + 71352 >> 2] = fb + 5;
 HEAP32[gb + 71356 >> 2] = fb + 6;
 HEAP32[gb + 71360 >> 2] = fb + 73;
 HEAP32[gb + 71364 >> 2] = fb + 74;
 HEAP32[gb + 71368 >> 2] = fb + 4;
 HEAP32[gb + 71372 >> 2] = fb + 9;
 HEAP32[gb + 71376 >> 2] = fb + 3;
 HEAP32[gb + 71380 >> 2] = fb + 18;
 HEAP32[gb + 71384 >> 2] = fb + 19;
 HEAP32[gb + 71388 >> 2] = fb + 18;
 runPostSets64();
}

function __ZN9Transform8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9);
 if (HEAP32[i8 + 32 >> 2] | 0) {
  i2 = i8 + 32 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i7 = i8 + 56 | 0;
  i6 = HEAP32[i2 + (i3 * 40 | 0) + 4 >> 2] | 0;
  i1 = HEAP32[i2 + (i3 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 + (i3 * 40 | 0) >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i7 + 8 >> 2] = i1;
  i7 = i8 + 40 | 0;
  i1 = HEAP32[i2 + (i3 * 40 | 0) + 16 >> 2] | 0;
  i6 = HEAP32[i2 + (i3 * 40 | 0) + 20 >> 2] | 0;
  i4 = HEAP32[i2 + (i3 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 + (i3 * 40 | 0) + 12 >> 2];
  HEAP32[i7 + 4 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i6;
  HEAP32[i7 + 12 >> 2] = i4;
  i7 = i8 + 68 | 0;
  i4 = HEAP32[i2 + (i3 * 40 | 0) + 32 >> 2] | 0;
  i6 = HEAP32[i2 + (i3 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 + (i3 * 40 | 0) + 28 >> 2];
  HEAP32[i7 + 4 >> 2] = i4;
  HEAP32[i7 + 8 >> 2] = i6;
 }
 __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i9, i8 + 40 | 0, gb + 896768 | 0, 0);
 i1 = i8 + 56 | 0;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 60 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 64 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 68 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 72 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 if (HEAP32[i9 >> 2] & 16384 | 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i8 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
 i1 = HEAP32[i8 + 80 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 100 | 0, i9);
 STACKTOP = i10;
 return;
}

function __ZN13TextRendering4Font8TransferI14SafeBinaryReadEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i8 = i12;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i10, i11);
 __ZN14SafeBinaryRead10SetVersionEi(i11, 5);
 i5 = i10 + 32 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 946508 | 0, i6, i9, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i4 = i11 + 16 | 0;
   i3 = HEAP32[i11 + 20 >> 2] | 0;
   i1 = i3 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   if (i1 >>> 0 < i3 >>> 0) i7 = 6; else {
    i3 = i1 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i4 >> 2] = i3;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i5, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 i3 = i10 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 944562 | 0, gb + 946436 | 0, i9, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
 }
 if (__ZN14SafeBinaryRead12IsOldVersionEi(i11, 1) | 0) HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(1.0));
 i5 = i10 + 36 | 0;
 f2 = Math_fround(HEAP32[i5 >> 2] | 0);
 HEAPF32[i8 >> 2] = f2;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1034730 | 0, i6, i9, 0) | 0;
 if (i1) {
  if ((i1 | 0) > 0) {
   i1 = i11 + 16 | 0;
   i6 = HEAP32[i11 + 20 >> 2] | 0;
   i3 = i6 + (HEAP32[(HEAP32[i11 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i11 + 36 >> 2] | 0, 0 - (HEAP32[i11 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i3;
   if (i3 >>> 0 < i6 >>> 0) i7 = 25; else {
    i4 = i3 + 4 | 0;
    if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) i7 = 25; else {
     HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i1 >> 2] = i4;
    }
   }
   if ((i7 | 0) == 25) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
   if (HEAP32[i11 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i11 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  f2 = Math_fround(HEAPF32[i8 >> 2]);
 }
 HEAP32[i5 >> 2] = ~~f2;
 i3 = i10 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 944580 | 0, gb + 944590 | 0, i9, 1) | 0;
 if (!i1) {
  i10 = i10 + 48 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN20TextRenderingPrivate8FontImpl8TransferI14SafeBinaryReadEEvRT_(i10, i11);
  STACKTOP = i12;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i3, i11); else {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i11 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i11);
 i10 = i10 + 48 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN20TextRenderingPrivate8FontImpl8TransferI14SafeBinaryReadEEvRT_(i10, i11);
 STACKTOP = i12;
 return;
}

function __ZL28CheckCopyTextureMipArgumentsP7TextureiiS0_ii(i5, i6, i7, i8, i9, i10) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i12 = i14 + 24 | 0;
 i4 = i14 + 16 | 0;
 i3 = i14 + 8 | 0;
 i2 = i14;
 i11 = i14 + 48 | 0;
 if (!i5) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 398064 | 0, 0, gb + 398117 | 0, 15, 1, 0, 0, 0);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!i8) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 398190 | 0, 0, gb + 398117 | 0, 20, 1, 0, 0, 0);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0) | 0;
 if (!((i7 | 0) > -1 & (i1 | 0) > (i7 | 0))) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i2 + 4 >> 2] = i1;
  __Z6FormatPKcz(i11, gb + 398890 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 398117 | 0, 36, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 116 >> 2] | 0, i8 | 0) | 0;
 if (!((i10 | 0) > -1 & (i1 | 0) > (i10 | 0))) {
  HEAP32[i3 >> 2] = i10;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z6FormatPKcz(i11, gb + 398971 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 398117 | 0, 42, 1, HEAP32[i8 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i5 | 0) | 0;
 if (!((i6 | 0) > -1 & (i1 | 0) > (i6 | 0))) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z6FormatPKcz(i11, gb + 399057 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 398117 | 0, 50, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0) | 0;
 if (!((i9 | 0) > -1 & (i1 | 0) > (i9 | 0))) {
  HEAP32[i12 >> 2] = i9;
  HEAP32[i12 + 4 >> 2] = i1;
  __Z6FormatPKcz(i11, gb + 399153 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 398117 | 0, 56, 1, HEAP32[i8 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!((i7 | 0) == (i10 | 0) & ((i6 | 0) == (i9 | 0) ? (HEAP32[i5 + 48 >> 2] | 0) == (HEAP32[i8 + 48 >> 2] | 0) : 0))) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i7;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i7;
 __Z6FormatPKcz(i11, gb + 399254 | 0, i13);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 398117 | 0, 65, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z29RegisterModuleClasses_Physicsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 853;
 HEAP32[i2 + 8 >> 2] = gb + 737574;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 54;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67048;
 HEAP32[i2 + 44 >> 2] = fb + 223;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 224;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 852;
 HEAP32[i2 + 8 >> 2] = gb + 737328;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 55;
 HEAP32[i2 + 20 >> 2] = 800;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113316;
 HEAP32[i2 + 44 >> 2] = fb + 221;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 222;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI8ColliderEvv();
 __Z13RegisterClassIN5Unity5JointEEvv();
 __Z13RegisterClassIN5Unity10HingeJointEEvv();
 __Z13RegisterClassI12MeshColliderEvv();
 __Z13RegisterClassI11BoxColliderEvv();
 __Z13RegisterClassI13ConstantForceEvv();
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 851;
 HEAP32[i2 + 8 >> 2] = gb + 737107;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 134;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113108;
 HEAP32[i2 + 44 >> 2] = fb + 215;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 216;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 854;
 HEAP32[i2 + 8 >> 2] = gb + 737689;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 135;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113668;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI15CapsuleColliderEvv();
 __Z13RegisterClassIN5Unity10FixedJointEEvv();
 __Z13RegisterClassI19CharacterControllerEvv();
 __Z13RegisterClassIN5Unity14CharacterJointEEvv();
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 855;
 HEAP32[i2 + 8 >> 2] = gb + 738002;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 145;
 HEAP32[i2 + 20 >> 2] = 116;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113868;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassIN5Unity17ConfigurableJointEEvv();
 STACKTOP = i1;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 48 | 0;
 i11 = i14 + 32 | 0;
 i3 = i14 + 8 | 0;
 i4 = i14 + 24 | 0;
 i5 = i14;
 i13 = i12 + 4 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = ((HEAP32[i13 >> 2] | 0) - i6 | 0) / 88 | 0;
 i1 = i6;
 if (i2 >>> 0 < i9 >>> 0) {
  i1 = i12 + 8 | 0;
  if ((((HEAP32[i1 >> 2] | 0) - i6 | 0) / 88 | 0 | 0) == (i9 | 0)) {
   __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj(i12, i9);
   STACKTOP = i14;
   return;
  } else {
   i8 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   i10 = i3 + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = i8;
   __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj(i3, i9);
   HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i3, i11, i7);
   __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj(i3, i9);
   i11 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i12 >> 2] = i11;
   i12 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i13 >> 2] = i12;
   i12 = i3 + 8 | 0;
   i13 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i13;
   __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i3);
   STACKTOP = i14;
   return;
  }
 }
 if (i2 >>> 0 <= i9 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i8 = i1 + (i9 * 88 | 0) | 0;
 i2 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = i11 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i9 * 88 | 0;
 i5 = (i4 | 0) / 88 | 0;
 if (!i4) {
  i3 = i11 + 8 | 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = 25;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  i6 = i2 + (i5 * 88 | 0) | 0;
  i7 = i11 + 8 | 0;
  HEAP32[i7 >> 2] = i6;
  i5 = i2;
  if (!i9) {
   i3 = i7;
   i4 = i5;
   i2 = i5;
   i1 = i6;
  } else {
   do {
    __ZN24CompressedAnimationCurveC2ERKS_(i2, i1);
    i1 = i1 + 88 | 0;
    i2 = (HEAP32[i10 >> 2] | 0) + 88 | 0;
    HEAP32[i10 >> 2] = i2;
   } while ((i1 | 0) != (i8 | 0));
   i3 = i7;
   i4 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i2;
 i13 = i12 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 4 | 0;
 i7 = i8;
 i1 = HEAP32[gb + 1157916 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1046327 | 0, 26);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1157916 >> 2] = i1;
 }
 if (!(HEAP8[gb + 1545906 >> 0] | 0)) {
  HEAP32[gb + 1157920 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1157920 | 0, gb + 1046318 | 0);
  HEAP8[gb + 1545906 >> 0] = 1;
 }
 HEAP32[i7 >> 2] = HEAP32[gb + 1157920 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i1, i2, i4);
 i4 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, 0, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 580 >> 2] | 0, i7 | 0, 2, i4 | 0);
 f11 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.5));
 f12 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * Math_fround(.5));
 f10 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * Math_fround(.5));
 mftCall_viffff(HEAP32[(HEAP32[i7 >> 2] | 0) + 568 >> 2] | 0, i7 | 0, +f11, +f12, +f10, +Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) * Math_fround(.5)));
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * Math_fround(.5));
 f10 = Math_fround(f10 + f12);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * Math_fround(.5));
 f11 = Math_fround(f11 + f13);
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = i6 + 4 | 0;
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 572 >> 2] | 0, i7 | 0, +f14, +Math_fround(HEAPF32[i5 >> 2]), 0.0);
 f14 = Math_fround(f10 - f12);
 f9 = Math_fround(f11 - f13);
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 560 >> 2] | 0, i7 | 0, +f14, +f9, 0.0);
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = i6 + 12 | 0;
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 572 >> 2] | 0, i7 | 0, +f16, +Math_fround(f15 + Math_fround(HEAPF32[i3 >> 2])), 0.0);
 f11 = Math_fround(f13 + f11);
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 560 >> 2] | 0, i7 | 0, +f14, +f11, 0.0);
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i6 + 8 | 0;
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i4 >> 2]));
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 572 >> 2] | 0, i7 | 0, +f14, +Math_fround(f13 + Math_fround(HEAPF32[i3 >> 2])), 0.0);
 f10 = Math_fround(f12 + f10);
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 560 >> 2] | 0, i7 | 0, +f10, +f11, 0.0);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 572 >> 2] | 0, i7 | 0, +f11, +Math_fround(HEAPF32[i5 >> 2]), 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i7 >> 2] | 0) + 560 >> 2] | 0, i7 | 0, +f10, +f9, 0.0);
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 584 >> 2] | 0, i7 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_(i10, i9, i8, i7, i12, i11) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0;
 HEAPF32[i12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i11 >> 2] = Math_fround(3402823469999999843913219.0e14);
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 if (f1 > Math_fround(-1.1920929e-07) & f1 < Math_fround(1.1920929e-07)) {
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  i5 = f6 < Math_fround(HEAPF32[i10 >> 2]);
  if (i5 | f6 > Math_fround(HEAPF32[i9 >> 2])) return -1; else {
   f1 = Math_fround(3402823469999999843913219.0e14);
   i3 = -1;
  }
 } else {
  f4 = Math_fround(Math_fround(1.0) / f1);
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  f2 = Math_fround(f4 * Math_fround(f2 - f6));
  f6 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f6));
  i3 = f2 > f6;
  f4 = i3 ? f6 : f2;
  f6 = i3 ? f2 : f6;
  f2 = Math_fround(HEAPF32[i12 >> 2]);
  if (f4 > f2) {
   HEAPF32[i12 >> 2] = f4;
   f1 = Math_fround(HEAPF32[i11 >> 2]);
   f2 = f4;
   i3 = i3 ? 3 : 0;
  } else {
   f1 = Math_fround(3402823469999999843913219.0e14);
   i3 = -1;
  }
  if (f6 < f1) {
   HEAPF32[i11 >> 2] = f6;
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   f1 = f6;
  }
  if (f2 > f1 | f1 < Math_fround(1.1920929e-07)) return -1;
 }
 f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 if (f2 > Math_fround(-1.1920929e-07) & f2 < Math_fround(1.1920929e-07)) {
  f2 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  if (f2 < Math_fround(HEAPF32[i10 + 4 >> 2])) return -1;
  if (f2 > Math_fround(HEAPF32[i9 + 4 >> 2])) return -1;
 } else {
  f4 = Math_fround(Math_fround(1.0) / f2);
  f2 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f2 = Math_fround(f4 * Math_fround(f2 - f6));
  f6 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i9 + 4 >> 2]) - f6));
  i5 = f2 > f6;
  f4 = i5 ? f6 : f2;
  f6 = i5 ? f2 : f6;
  f2 = Math_fround(HEAPF32[i12 >> 2]);
  if (f4 > f2) {
   HEAPF32[i12 >> 2] = f4;
   f1 = Math_fround(HEAPF32[i11 >> 2]);
   f2 = f4;
   i3 = i5 ? 4 : 1;
  }
  if (f6 < f1) {
   HEAPF32[i11 >> 2] = f6;
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   f1 = f6;
  }
  if (f2 > f1 | f1 < Math_fround(1.1920929e-07)) return -1;
 }
 f2 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 if (f2 > Math_fround(-1.1920929e-07) & f2 < Math_fround(1.1920929e-07)) {
  f2 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  if (f2 < Math_fround(HEAPF32[i10 + 8 >> 2])) return -1;
  if (f2 > Math_fround(HEAPF32[i9 + 8 >> 2])) return -1; else {
   f6 = f1;
   i11 = i3;
   f4 = Math_fround(HEAPF32[i12 >> 2]);
   i10 = f4 > f6;
   i12 = f6 < Math_fround(1.1920929e-07);
   i12 = i10 | i12;
   i12 = i12 ? -1 : i11;
   return i12 | 0;
  }
 }
 f4 = Math_fround(Math_fround(1.0) / f2);
 f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f2 = Math_fround(f4 * Math_fround(f2 - f6));
 f6 = Math_fround(f4 * Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) - f6));
 i5 = f2 > f6;
 f4 = i5 ? f6 : f2;
 f6 = i5 ? f2 : f6;
 f2 = Math_fround(HEAPF32[i12 >> 2]);
 if (f4 > f2) {
  HEAPF32[i12 >> 2] = f4;
  f1 = Math_fround(HEAPF32[i11 >> 2]);
  f2 = f4;
  i3 = i5 ? 5 : 2;
 }
 if (f6 < f1) {
  HEAPF32[i11 >> 2] = f6;
  f2 = Math_fround(HEAPF32[i12 >> 2]);
  f1 = f6;
 }
 if (f2 > f1 | f1 < Math_fround(1.1920929e-07)) return -1; else {
  f6 = f1;
  i11 = i3;
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  i10 = f4 > f6;
  i12 = f6 < Math_fround(1.1920929e-07);
  i12 = i10 | i12;
  i12 = i12 ? -1 : i11;
  return i12 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_(i14, i15, i7, i1, i2, i16) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_(i14, i15, i7, i1, i16) | 0;
 if (!(mftCall_iii(HEAP32[i16 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return i17 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 4 | 0;
 i9 = i2 + 4 | 0;
 i18 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 8 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + 12 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + 16 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i8 = i1 + 20 | 0;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i9 >> 2] = i18;
 HEAP32[i2 + 8 >> 2] = i10;
 HEAP32[i2 + 12 >> 2] = i11;
 HEAP32[i2 + 16 >> 2] = i12;
 HEAP32[i2 + 20 >> 2] = i13;
 if (!(mftCall_iii(HEAP32[i16 >> 2] | 0, i1 | 0, i7 | 0) | 0)) {
  i18 = i17 + 1 | 0;
  return i18 | 0;
 }
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i9;
 i9 = i7 + 4 | 0;
 i20 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 8 | 0;
 i19 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i7 + 20 | 0;
 i18 = HEAP32[i13 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i3 >> 2] = i20;
 HEAP32[i4 >> 2] = i19;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i8 >> 2] = i18;
 if (!(mftCall_iii(HEAP32[i16 >> 2] | 0, i7 | 0, i15 | 0) | 0)) {
  i20 = i17 + 2 | 0;
  return i20 | 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i1 = i15 + 4 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i15 + 8 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i3 = i15 + 12 | 0;
 i18 = HEAP32[i3 >> 2] | 0;
 i4 = i15 + 16 | 0;
 i19 = HEAP32[i4 >> 2] | 0;
 i5 = i15 + 20 | 0;
 i20 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i11 >> 2] = i18;
 HEAP32[i12 >> 2] = i19;
 HEAP32[i13 >> 2] = i20;
 if (!(mftCall_iii(HEAP32[i16 >> 2] | 0, i15 | 0, i14 | 0) | 0)) {
  i20 = i17 + 3 | 0;
  return i20 | 0;
 }
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i13;
 i13 = i14 + 4 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i14 + 8 >> 2] | 0;
 i18 = HEAP32[i14 + 12 >> 2] | 0;
 i19 = HEAP32[i14 + 16 >> 2] | 0;
 i20 = HEAP32[i14 + 20 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 >> 2] = i15;
 HEAP32[i2 >> 2] = i16;
 HEAP32[i3 >> 2] = i18;
 HEAP32[i4 >> 2] = i19;
 HEAP32[i5 >> 2] = i20;
 i20 = i17 + 4 | 0;
 return i20 | 0;
}

function __ZN15QualitySettings5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 656 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 648 | 0;
 i5 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 i2 = i5 + 648 | 0;
 i3 = i5;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i3 + 11 >> 0] = 7;
  HEAP8[i3 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
  HEAP8[i3 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
  HEAP8[i3 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
  HEAP8[i3 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
  HEAP8[i3 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
  HEAP8[i3 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
  HEAP8[i3 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
  HEAP8[i3 + 7 >> 0] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 1;
  HEAP32[i3 + 32 >> 2] = 1;
  HEAPF32[i3 + 36 >> 2] = Math_fround(15.0);
  HEAPF32[i3 + 40 >> 2] = Math_fround(3.0);
  HEAPF32[i3 + 44 >> 2] = Math_fround(.333333343);
  HEAPF32[i3 + 48 >> 2] = Math_fround(.0666666701);
  HEAPF32[i3 + 52 >> 2] = Math_fround(.200000003);
  HEAPF32[i3 + 56 >> 2] = Math_fround(.466666669);
  HEAP32[i3 + 60 >> 2] = 1;
  HEAP32[i3 + 64 >> 2] = 1;
  i8 = i3 + 68 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAPF32[i3 + 84 >> 2] = Math_fround(.300000012);
  HEAP32[i3 + 88 >> 2] = 0;
  HEAP32[i3 + 92 >> 2] = 4;
  HEAPF32[i3 + 96 >> 2] = Math_fround(512.0);
  HEAP32[i3 + 100 >> 2] = 2;
  HEAP32[i3 + 104 >> 2] = 4;
  i3 = i3 + 108 | 0;
 } while ((i3 | 0) != (i2 | 0));
 __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE(i5);
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1 + 28 | 0, i5, i2);
 HEAP32[i1 + 44 >> 2] = 5;
 i2 = i4 + 4 | 0;
 i1 = i5 + 540 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 552 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 i1 = i5 + 432 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 444 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 i1 = i5 + 324 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 336 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 i1 = i5 + 216 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 228 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 i1 = i5 + 108 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 120 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i2 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function runPostSets2() {
 HEAP32[gb + 25532 >> 2] = fb + 13;
 HEAP32[gb + 25536 >> 2] = fb + 22;
 HEAP32[gb + 25540 >> 2] = fb + 23;
 HEAP32[gb + 25544 >> 2] = fb + 9;
 HEAP32[gb + 25548 >> 2] = fb + 3;
 HEAP32[gb + 25552 >> 2] = fb + 24;
 HEAP32[gb + 25556 >> 2] = fb + 25;
 HEAP32[gb + 25560 >> 2] = fb + 26;
 HEAP32[gb + 25564 >> 2] = fb + 14;
 HEAP32[gb + 25568 >> 2] = fb + 27;
 HEAP32[gb + 25572 >> 2] = fb + 15;
 HEAP32[gb + 25576 >> 2] = fb + 1;
 HEAP32[gb + 25580 >> 2] = fb + 10;
 HEAP32[gb + 25592 >> 2] = fb + 11;
 HEAP32[gb + 25596 >> 2] = fb + 12;
 HEAP32[gb + 25600 >> 2] = fb + 1;
 HEAP32[gb + 25604 >> 2] = fb + 1;
 HEAP32[gb + 25608 >> 2] = fb + 1;
 HEAP32[gb + 25612 >> 2] = fb + 2;
 HEAP32[gb + 25616 >> 2] = fb + 2;
 HEAP32[gb + 25620 >> 2] = fb + 5;
 HEAP32[gb + 25624 >> 2] = fb + 2;
 HEAP32[gb + 25628 >> 2] = fb + 6;
 HEAP32[gb + 25632 >> 2] = fb + 2;
 HEAP32[gb + 25636 >> 2] = fb + 7;
 HEAP32[gb + 25640 >> 2] = fb + 8;
 HEAP32[gb + 25644 >> 2] = fb + 2;
 HEAP32[gb + 25648 >> 2] = fb + 9;
 HEAP32[gb + 25652 >> 2] = fb + 16;
 HEAP32[gb + 25656 >> 2] = fb + 17;
 HEAP32[gb + 25660 >> 2] = fb + 28;
 HEAP32[gb + 25664 >> 2] = fb + 2;
 HEAP32[gb + 25668 >> 2] = fb + 10;
 HEAP32[gb + 25672 >> 2] = fb + 11;
 HEAP32[gb + 25676 >> 2] = fb + 12;
 HEAP32[gb + 25680 >> 2] = fb + 13;
 HEAP32[gb + 25684 >> 2] = fb + 3;
 HEAP32[gb + 25688 >> 2] = fb + 14;
 HEAP32[gb + 25692 >> 2] = fb + 3;
 HEAP32[gb + 25696 >> 2] = fb + 3;
 HEAP32[gb + 25700 >> 2] = fb + 15;
 HEAP32[gb + 25704 >> 2] = fb + 16;
 HEAP32[gb + 25708 >> 2] = fb + 4;
 HEAP32[gb + 25712 >> 2] = fb + 17;
 HEAP32[gb + 25716 >> 2] = fb + 5;
 HEAP32[gb + 25720 >> 2] = fb + 6;
 HEAP32[gb + 25724 >> 2] = fb + 7;
 HEAP32[gb + 25728 >> 2] = fb + 8;
 HEAP32[gb + 25732 >> 2] = fb + 4;
 HEAP32[gb + 25736 >> 2] = fb + 9;
 HEAP32[gb + 25740 >> 2] = fb + 3;
 HEAP32[gb + 25744 >> 2] = fb + 18;
 HEAP32[gb + 25748 >> 2] = fb + 19;
 HEAP32[gb + 25752 >> 2] = fb + 18;
 HEAP32[gb + 25756 >> 2] = fb + 19;
 HEAP32[gb + 25760 >> 2] = fb + 20;
 HEAP32[gb + 25764 >> 2] = fb + 21;
 HEAP32[gb + 25768 >> 2] = fb + 22;
 HEAP32[gb + 25772 >> 2] = fb + 23;
 HEAP32[gb + 25776 >> 2] = fb + 24;
 HEAP32[gb + 25780 >> 2] = fb + 25;
 HEAP32[gb + 25784 >> 2] = fb + 29;
 HEAP32[gb + 25788 >> 2] = fb + 10;
 HEAP32[gb + 25864 >> 2] = fb + 13;
 HEAP32[gb + 25868 >> 2] = fb + 14;
 HEAP32[gb + 25872 >> 2] = fb + 15;
 HEAP32[gb + 25876 >> 2] = fb + 26;
 HEAP32[gb + 25880 >> 2] = fb + 16;
 HEAP32[gb + 25884 >> 2] = fb + 17;
 HEAP32[gb + 25888 >> 2] = fb + 18;
 HEAP32[gb + 25892 >> 2] = fb + 19;
 HEAP32[gb + 25896 >> 2] = fb + 30;
 HEAP32[gb + 25900 >> 2] = fb + 31;
 HEAP32[gb + 25904 >> 2] = fb + 27;
 HEAP32[gb + 25908 >> 2] = fb + 32;
 HEAP32[gb + 25912 >> 2] = fb + 28;
 HEAP32[gb + 25916 >> 2] = fb + 33;
 HEAP32[gb + 25920 >> 2] = fb + 29;
 HEAP32[gb + 25924 >> 2] = fb + 34;
 HEAP32[gb + 25928 >> 2] = fb + 30;
 HEAP32[gb + 25932 >> 2] = fb + 31;
 HEAP32[gb + 25936 >> 2] = fb + 32;
 HEAP32[gb + 25940 >> 2] = fb + 33;
 HEAP32[gb + 25944 >> 2] = fb + 34;
 HEAP32[gb + 25948 >> 2] = fb + 35;
 HEAP32[gb + 25952 >> 2] = fb + 36;
 HEAP32[gb + 25956 >> 2] = fb + 20;
 HEAP32[gb + 25960 >> 2] = fb + 35;
 HEAP32[gb + 25964 >> 2] = fb + 36;
 HEAP32[gb + 25968 >> 2] = fb + 37;
 HEAP32[gb + 25972 >> 2] = fb + 37;
 HEAP32[gb + 25976 >> 2] = fb + 38;
 HEAP32[gb + 25980 >> 2] = fb + 39;
 HEAP32[gb + 25984 >> 2] = fb + 40;
 HEAP32[gb + 25988 >> 2] = fb + 41;
 HEAP32[gb + 25992 >> 2] = fb + 42;
 HEAP32[gb + 25996 >> 2] = fb + 43;
 HEAP32[gb + 26e3 >> 2] = fb + 44;
 HEAP32[gb + 26004 >> 2] = fb + 45;
 HEAP32[gb + 26008 >> 2] = fb + 46;
 runPostSets3();
}

function __ZN9ShaderLab9SubShader20IsSubShaderSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i12, i14) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 8 | 0;
 i15 = i17;
 i13 = i12 + 12 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i10 = i12 + 20 | 0;
  i2 = 0;
  i1 = 0;
  i3 = 0;
  i9 = HEAP32[i12 >> 2] | 0;
  L3 : while (1) {
   i7 = i9;
   i9 = i9 + 4 | 0;
   i8 = i9;
   i11 = i1;
   while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    __ZN9ShaderLab4Pass16SetupPassOptionsEv(i6);
    if (__ZN9ShaderLab4Pass15IsPassSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i6, i14) | 0) break;
    i5 = i6 + 760 | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if (!i3) {
     i1 = 0;
     i4 = 29;
     break L3;
    } else i1 = i5;
    L8 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= 0) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) break L8; else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i1 = i4;
      break;
     } else i1 = i4;
    }
    if ((i1 | 0) == (i5 | 0)) {
     i1 = 0;
     i4 = 29;
     break L3;
    }
    if ((HEAP32[i1 + 16 >> 2] | 0) > 0) {
     i1 = 0;
     i4 = 29;
     break L3;
    }
    if (((HEAP32[i1 + 20 >> 2] | 0) + -3 | 0) >>> 0 <= 2) {
     i1 = 0;
     i4 = 29;
     break L3;
    }
    i1 = HEAP32[i6 + 696 >> 2] | 0;
    i3 = 1 << i1 | i11;
    if (5374 >>> i1 & 1) i2 = 1 << HEAP32[gb + 68916 + (i1 << 2) >> 2] | i2;
    __ZN9ShaderLab4Pass7ReleaseEv(i6);
    _memmove(i7 | 0, i9 | 0, (HEAP32[i12 >> 2] | 0) + (HEAP32[i13 >> 2] << 2) - i8 | 0) | 0;
    i1 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
    if ((i7 | 0) == ((HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0)) {
     i11 = i3;
     i3 = 1;
     i4 = 18;
     break L3;
    } else {
     i11 = i3;
     i3 = 1;
    }
   }
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i9 | 0) == ((HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0)) {
    i4 = 17;
    break;
   } else i1 = i11;
  }
  if ((i4 | 0) == 17) {
   if (i11) i4 = 18;
  } else if ((i4 | 0) == 29) {
   STACKTOP = i17;
   return i1 | 0;
  }
  L28 : do if ((i4 | 0) == 18) if (!i1) i1 = 0; else {
   i4 = HEAP32[i12 >> 2] | 0;
   i10 = i12 + 20 | 0;
   i9 = i4;
   do {
    i7 = i9;
    i9 = i9 + 4 | 0;
    i8 = i9;
    while (1) {
     i5 = HEAP32[i7 >> 2] | 0;
     i6 = HEAP32[i5 + 696 >> 2] | 0;
     if (!(1 << HEAP32[gb + 68916 + (i6 << 2) >> 2] & i2)) if (!(1 << i6 & i11)) break;
     __ZN9ShaderLab4Pass7ReleaseEv(i5);
     _memmove(i7 | 0, i9 | 0, (HEAP32[i12 >> 2] | 0) + (HEAP32[i13 >> 2] << 2) - i8 | 0) | 0;
     i1 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
     i4 = HEAP32[i12 >> 2] | 0;
     if ((i7 | 0) == (i4 + (i1 << 2) | 0)) break L28;
    }
   } while ((i9 | 0) != (i4 + (i1 << 2) | 0));
  } while (0);
  i2 = i12 + 52 | 0;
  if (!((HEAP32[i2 >> 2] | 0) < 0 | i3 ^ 1)) {
   HEAP32[i2 >> 2] = __ZN9ShaderLabL17FindLightModePassEPNS_9SubShaderE14ShaderPassType(i12) | 0;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  if (i1 | 0) {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 _printf_console(gb + 480440 | 0, i15);
 HEAP32[i16 >> 2] = (HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
 _printf_console(gb + 480457 | 0, i16);
 i16 = 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE15set_deleted_keyERSE_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 40 | 0;
 i12 = i14;
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 i13 = i12 + 24 | 0;
 i7 = i1 + 24 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i12 + 4 | 0;
 HEAP8[i9 >> 0] = 0;
 do if ((i12 | 0) != (i1 | 0)) {
  i3 = HEAP32[i1 >> 2] | 0;
  i8 = (i3 | 0) == 0;
  i3 = i8 ? i1 + 4 | 0 : i3;
  i4 = HEAP32[i1 + 20 >> 2] | 0;
  i2 = i12 + 4 | 0;
  if (!((HEAP32[i1 + 4 >> 2] | 0) != 0 | i8)) {
   HEAP32[i12 >> 2] = i3;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i4 >>> 0 > 15) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i13, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i2 >> 2] = i4;
   i1 = (i1 | 0) == 0 ? i9 : i1;
  } else i1 = i9;
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  HEAP32[i10 >> 2] = i4;
 } while (0);
 i8 = i12 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 if (HEAP32[i11 + 4 >> 2] | 0) {
  __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j(i5, i11, 0);
  __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_(i11, i5);
  __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev(i5);
 }
 HEAP8[i11 + 8 >> 0] = 1;
 i6 = i11 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i11 + 16 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i11 + 36 | 0);
 HEAP32[i6 >> 2] = 0;
 i7 = i11 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i11 + 36 | 0;
 i3 = i13;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i11 + 16 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i6 | 0) != (i12 | 0)) {
  i5 = HEAP32[i12 >> 2] | 0;
  i15 = (i5 | 0) == 0;
  i5 = i15 ? i9 : i5;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = i11 + 16 | 0;
  if (!((HEAP32[i12 + 4 >> 2] | 0) != 0 | i15)) {
   HEAP32[i6 >> 2] = i5;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i3 >>> 0 > 15) {
   i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i6 >> 2] = i15;
   HEAP32[i2 >> 2] = i3;
   i1 = (i15 | 0) == 0 ? i1 : i15;
  }
  _memcpy(i1 | 0, i5 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i7 >> 2] = i3;
 } while (0);
 HEAP32[i11 + 44 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if (!(HEAP32[i12 + 4 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
 STACKTOP = i14;
 return;
}

function __ZNK6b2AABB7RayCastEP15b2RayCastOutputRK14b2RayCastInput(i8, i13, i14) {
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i4 = i14;
 f1 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f1 = Math_fround(f1 - f2);
 f9 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i14 + 4 >> 2]));
 i6 = f1 > Math_fround(0.0);
 f12 = Math_fround(-f1);
 i11 = f9 > Math_fround(0.0);
 f10 = Math_fround(-f9);
 f10 = i11 ? f9 : f10;
 i11 = i8 + 8 | 0;
 i5 = i15 + 4 | 0;
 i6 = (i6 ? f1 : f12) < Math_fround(1.1920929e-07);
 f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 if (i6) {
  if (f2 < Math_fround(HEAPF32[i8 >> 2])) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  if (Math_fround(HEAPF32[i11 >> 2]) < f2) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  } else {
   f7 = Math_fround(3402823469999999843913219.0e14);
   f1 = Math_fround(-3402823469999999843913219.0e14);
  }
 } else {
  f1 = Math_fround(Math_fround(1.0) / f1);
  f7 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f2));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f2));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f7 > f1;
  f1 = (HEAP32[tempDoublePtr >> 2] = i4 ? i3 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f1 > Math_fround(-3402823469999999843913219.0e14)) {
   f7 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   HEAPF32[i15 >> 2] = f7;
  } else f1 = Math_fround(-3402823469999999843913219.0e14);
  f2 = (HEAP32[tempDoublePtr >> 2] = i4 ? i6 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = f2 > Math_fround(3402823469999999843913219.0e14);
  f2 = i6 ? Math_fround(3402823469999999843913219.0e14) : f2;
  if (f1 > f2) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  } else f7 = f2;
 }
 if (f10 < Math_fround(1.1920929e-07)) {
  if (f12 < Math_fround(HEAPF32[i8 + 4 >> 2])) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  if (Math_fround(HEAPF32[i11 + 4 >> 2]) < f12) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 } else {
  f2 = Math_fround(Math_fround(1.0) / f9);
  f10 = Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f12));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f2 = Math_fround(f2 * Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) - f12));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = f10 > f2;
  f2 = (HEAP32[tempDoublePtr >> 2] = i4 ? i3 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f2 > f1) {
   f1 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
   HEAPF32[i15 >> 2] = Math_fround(0.0);
   HEAPF32[i15 + 4 >> 2] = f1;
   f1 = f2;
  }
  f12 = (HEAP32[tempDoublePtr >> 2] = i4 ? i5 : i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f1 > (f7 < f12 ? f7 : f12)) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 if (f1 < Math_fround(0.0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 if (Math_fround(HEAPF32[i14 + 16 >> 2]) < f1) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAPF32[i13 + 8 >> 2] = f1;
 i11 = i15;
 i14 = HEAP32[i11 + 4 >> 2] | 0;
 i15 = i13;
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = i14;
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN9Animation4StopERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i12 = i17 + 104 | 0;
 i13 = i17 + 108 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i14 = i18 + 11 | 0;
  i15 = i18 + 4 | 0;
  i11 = 0;
  do {
   i9 = HEAP32[i2 + (i11 << 2) >> 2] | 0;
   i10 = i9 + 56 | 0;
   i8 = HEAP16[i10 >> 1] | 0;
   if (!(i8 & 256)) {
    i3 = i9 + 112 | 0;
    i7 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    if (i4) i5 = HEAP32[i9 + 116 >> 2] | 0; else i5 = i7 & 255;
    i19 = HEAP8[i14 >> 0] | 0;
    i6 = i19 << 24 >> 24 < 0;
    if ((i5 | 0) == ((i6 ? HEAP32[i15 >> 2] | 0 : i19 & 255) | 0)) {
     if (i4) {
      i5 = HEAP32[i3 >> 2] | 0;
      i4 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
      i3 = HEAP32[i9 + 116 >> 2] | 0;
     } else {
      i5 = i3;
      i4 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
      i3 = i7 & 255;
     }
     if (!(_strncmp(i5, i4, i3) | 0)) i16 = 22;
    }
   } else {
    i3 = i9 + 128 | 0;
    i7 = HEAP8[i3 + 11 >> 0] | 0;
    i4 = i7 << 24 >> 24 < 0;
    if (i4) i5 = HEAP32[i9 + 132 >> 2] | 0; else i5 = i7 & 255;
    i19 = HEAP8[i14 >> 0] | 0;
    i6 = i19 << 24 >> 24 < 0;
    if ((i5 | 0) == ((i6 ? HEAP32[i15 >> 2] | 0 : i19 & 255) | 0)) {
     if (i4) {
      i5 = HEAP32[i3 >> 2] | 0;
      i4 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
      i3 = HEAP32[i9 + 132 >> 2] | 0;
     } else {
      i5 = i3;
      i4 = i6 ? HEAP32[i18 >> 2] | 0 : i18;
      i3 = i7 & 255;
     }
     if (!(_strncmp(i5, i4, i3) | 0)) i16 = 22;
    }
   }
   if ((i16 | 0) == 22) {
    i16 = 0;
    i1 = i8 | 64;
    if ((i8 & 10) == 10) HEAP16[i10 >> 1] = i1; else i1 = i8;
    HEAP16[i10 >> 1] = i1 & -3;
    __ZN14AnimationState7SetTimeEf(i9, Math_fround(0.0));
    HEAP16[i10 >> 1] = HEAP16[i10 >> 1] & -6;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < i1 - i2 >> 2 >>> 0);
 }
 i15 = i17 + 316 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i12 = i17 + 320 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 i13 = i18 + 11 | 0;
 i14 = i18 + 4 | 0;
 i4 = i3;
 L36 : while (1) {
  i11 = i2 + 12 | 0;
  i10 = i3;
  while (1) {
   i8 = HEAP32[i11 >> 2] | 0;
   i6 = i8 + 128 | 0;
   i9 = HEAP8[i6 + 11 >> 0] | 0;
   i5 = i9 << 24 >> 24 < 0;
   if (i5) i3 = HEAP32[i8 + 132 >> 2] | 0; else i3 = i9 & 255;
   i19 = HEAP8[i13 >> 0] | 0;
   i7 = i19 << 24 >> 24 < 0;
   if ((i3 | 0) != ((i7 ? HEAP32[i14 >> 2] | 0 : i19 & 255) | 0)) break;
   if (i5) {
    i6 = HEAP32[i6 >> 2] | 0;
    i5 = i7 ? HEAP32[i18 >> 2] | 0 : i18;
    i3 = HEAP32[i8 + 132 >> 2] | 0;
   } else {
    i5 = i7 ? HEAP32[i18 >> 2] | 0 : i18;
    i3 = i9 & 255;
   }
   if (_strncmp(i6, i5, i3) | 0) break;
   i6 = HEAP32[i15 >> 2] | 0;
   i6 = i6 + (i1 - i6 >> 4 << 4) | 0;
   i3 = i6 + 16 | 0;
   i5 = i4 - i3 | 0;
   i7 = i5 >> 4;
   if (!i7) {
    i5 = i4;
    i3 = i10;
   } else {
    _memmove(i6 | 0, i3 | 0, i5 | 0) | 0;
    i3 = HEAP32[i12 >> 2] | 0;
    i5 = i3;
   }
   i4 = i6 + (i7 << 4) | 0;
   if ((i5 | 0) != (i4 | 0)) {
    i3 = i5 + (~((i5 + -16 - i4 | 0) >>> 4) << 4) | 0;
    HEAP32[i12 >> 2] = i3;
   }
   if ((i2 | 0) == (i3 | 0)) {
    i16 = 41;
    break L36;
   } else {
    i10 = i3;
    i4 = i3;
   }
  }
  i2 = i2 + 16 | 0;
  if ((i2 | 0) == (i10 | 0)) {
   i16 = 41;
   break;
  } else {
   i1 = i2;
   i3 = i10;
  }
 }
 if ((i16 | 0) == 41) return;
}

function __ZN8Material8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 6);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469700 | 0, gb + 479385 | 0, i6, 0);
 i8 = i5 + 8 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i6, 1);
 i6 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469709 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 80 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469726 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469742 | 0, i7, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i4 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469762 | 0, HEAP32[gb + 37052 >> 2] | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i5, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469844 | 0, gb + 469862 | 0, i1, 0);
 __ZN18UnityPropertySheet8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i5, HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE(i1, i2, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 20, 4) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 >> 2] = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i1, i9) | 0;
 HEAP32[i10 + 4 >> 2] = __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i1, i9) | 0;
 if (!(i2 | i7)) return i10 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 332, 4) | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i2 = i1 + 4 | 0;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 1065353216;
 HEAP32[i1 + 56 >> 2] = 1065353216;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 HEAP32[i1 + 64 >> 2] = 1065353216;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 1065353216;
 HEAP32[i1 + 96 >> 2] = 1065353216;
 HEAP32[i1 + 100 >> 2] = 1065353216;
 HEAP32[i1 + 104 >> 2] = 1065353216;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 1065353216;
 HEAP32[i1 + 136 >> 2] = 1065353216;
 HEAP32[i1 + 140 >> 2] = 1065353216;
 HEAP32[i1 + 144 >> 2] = 1065353216;
 i3 = i1 + 148 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 1065353216;
 HEAP32[i1 + 176 >> 2] = 1065353216;
 HEAP32[i1 + 180 >> 2] = 1065353216;
 HEAP32[i1 + 184 >> 2] = 1065353216;
 i3 = i1 + 188 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 1065353216;
 HEAP32[i1 + 216 >> 2] = 1065353216;
 HEAP32[i1 + 220 >> 2] = 1065353216;
 HEAP32[i1 + 224 >> 2] = 1065353216;
 i3 = i1 + 228 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 1065353216;
 HEAP32[i1 + 256 >> 2] = 1065353216;
 HEAP32[i1 + 260 >> 2] = 1065353216;
 HEAP32[i1 + 264 >> 2] = 1065353216;
 i3 = i1 + 320 | 0;
 i4 = i1 + 316 | 0;
 i5 = i1 + 268 | 0;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i4 >> 2] = 1065353216;
 HEAP32[i3 >> 2] = 1065353216;
 HEAP32[i1 + 324 >> 2] = 1065353216;
 HEAP32[i1 + 328 >> 2] = 1065353216;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = i1;
 if (!i7) return i10 | 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 888, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i7);
 HEAP32[i10 + 12 >> 2] = i7;
 if (i8) return i10 | 0;
 i9 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 888, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i9);
 HEAP32[i10 + 16 >> 2] = i9;
 return i10 | 0;
}

function runPostSets104() {
 HEAP32[gb + 97888 >> 2] = fb + 1053;
 HEAP32[gb + 97892 >> 2] = fb + 1054;
 HEAP32[gb + 97904 >> 2] = fb + 1;
 HEAP32[gb + 97908 >> 2] = fb + 680;
 HEAP32[gb + 97912 >> 2] = fb + 456;
 HEAP32[gb + 97916 >> 2] = fb + 1270;
 HEAP32[gb + 97920 >> 2] = fb + 1373;
 HEAP32[gb + 97924 >> 2] = fb + 303;
 HEAP32[gb + 97928 >> 2] = fb + 1;
 HEAP32[gb + 97932 >> 2] = fb + 1;
 HEAP32[gb + 97936 >> 2] = fb + 1;
 HEAP32[gb + 97940 >> 2] = fb + 1;
 HEAP32[gb + 97944 >> 2] = fb + 1;
 HEAP32[gb + 97948 >> 2] = fb + 1;
 HEAP32[gb + 97952 >> 2] = fb + 1;
 HEAP32[gb + 97956 >> 2] = fb + 1;
 HEAP32[gb + 97960 >> 2] = fb + 1;
 HEAP32[gb + 97964 >> 2] = fb + 1;
 HEAP32[gb + 97968 >> 2] = fb + 1;
 HEAP32[gb + 97972 >> 2] = fb + 1;
 HEAP32[gb + 97976 >> 2] = fb + 1;
 HEAP32[gb + 97980 >> 2] = fb + 1;
 HEAP32[gb + 97984 >> 2] = fb + 1;
 HEAP32[gb + 97988 >> 2] = fb + 1;
 HEAP32[gb + 97992 >> 2] = fb + 1;
 HEAP32[gb + 97996 >> 2] = fb + 1;
 HEAP32[gb + 98e3 >> 2] = fb + 1;
 HEAP32[gb + 98004 >> 2] = fb + 1;
 HEAP32[gb + 98008 >> 2] = fb + 1;
 HEAP32[gb + 98012 >> 2] = fb + 1;
 HEAP32[gb + 98016 >> 2] = fb + 1;
 HEAP32[gb + 98020 >> 2] = fb + 1;
 HEAP32[gb + 98024 >> 2] = fb + 1;
 HEAP32[gb + 98028 >> 2] = fb + 1;
 HEAP32[gb + 98032 >> 2] = fb + 1;
 HEAP32[gb + 98036 >> 2] = fb + 1;
 HEAP32[gb + 98040 >> 2] = fb + 1;
 HEAP32[gb + 98044 >> 2] = fb + 1;
 HEAP32[gb + 98048 >> 2] = fb + 1;
 HEAP32[gb + 98052 >> 2] = fb + 1;
 HEAP32[gb + 98056 >> 2] = fb + 1;
 HEAP32[gb + 98060 >> 2] = fb + 1;
 HEAP32[gb + 98064 >> 2] = fb + 1;
 HEAP32[gb + 98068 >> 2] = fb + 1;
 HEAP32[gb + 98072 >> 2] = fb + 1;
 HEAP32[gb + 98076 >> 2] = fb + 1;
 HEAP32[gb + 98080 >> 2] = fb + 1;
 HEAP32[gb + 98084 >> 2] = fb + 1;
 HEAP32[gb + 98088 >> 2] = fb + 1;
 HEAP32[gb + 98092 >> 2] = fb + 1;
 HEAP32[gb + 98096 >> 2] = fb + 1;
 HEAP32[gb + 98100 >> 2] = fb + 1;
 HEAP32[gb + 98104 >> 2] = fb + 1;
 HEAP32[gb + 98108 >> 2] = fb + 1;
 HEAP32[gb + 98112 >> 2] = fb + 1;
 HEAP32[gb + 98116 >> 2] = fb + 1;
 HEAP32[gb + 98120 >> 2] = fb + 1;
 HEAP32[gb + 98124 >> 2] = fb + 1;
 HEAP32[gb + 98128 >> 2] = fb + 1;
 HEAP32[gb + 98132 >> 2] = fb + 1;
 HEAP32[gb + 98136 >> 2] = fb + 1;
 HEAP32[gb + 98140 >> 2] = fb + 1;
 HEAP32[gb + 98144 >> 2] = fb + 1;
 HEAP32[gb + 98148 >> 2] = fb + 1;
 HEAP32[gb + 98152 >> 2] = fb + 1;
 HEAP32[gb + 98156 >> 2] = fb + 1;
 HEAP32[gb + 98160 >> 2] = fb + 1;
 HEAP32[gb + 98164 >> 2] = fb + 1;
 HEAP32[gb + 98168 >> 2] = fb + 1;
 HEAP32[gb + 98172 >> 2] = fb + 1;
 HEAP32[gb + 98176 >> 2] = fb + 1;
 HEAP32[gb + 98180 >> 2] = fb + 1;
 HEAP32[gb + 98184 >> 2] = fb + 1;
 HEAP32[gb + 98188 >> 2] = fb + 1;
 HEAP32[gb + 98192 >> 2] = fb + 1;
 HEAP32[gb + 98196 >> 2] = fb + 1;
 HEAP32[gb + 98200 >> 2] = fb + 1;
 HEAP32[gb + 98204 >> 2] = fb + 1;
 HEAP32[gb + 98208 >> 2] = fb + 1;
 HEAP32[gb + 98220 >> 2] = fb + 1374;
 HEAP32[gb + 98224 >> 2] = fb + 680;
 HEAP32[gb + 98228 >> 2] = fb + 456;
 HEAP32[gb + 98232 >> 2] = fb + 1375;
 HEAP32[gb + 98236 >> 2] = fb + 1376;
 HEAP32[gb + 98240 >> 2] = fb + 303;
 HEAP32[gb + 98244 >> 2] = fb + 1;
 HEAP32[gb + 98248 >> 2] = fb + 681;
 HEAP32[gb + 98252 >> 2] = fb + 1057;
 HEAP32[gb + 98256 >> 2] = fb + 682;
 HEAP32[gb + 98260 >> 2] = fb + 19;
 HEAP32[gb + 98264 >> 2] = fb + 197;
 HEAP32[gb + 98268 >> 2] = fb + 1058;
 HEAP32[gb + 98272 >> 2] = fb + 683;
 HEAP32[gb + 98276 >> 2] = fb + 1059;
 HEAP32[gb + 98280 >> 2] = fb + 684;
 HEAP32[gb + 98284 >> 2] = fb + 1060;
 HEAP32[gb + 98288 >> 2] = fb + 685;
 HEAP32[gb + 98292 >> 2] = fb + 1061;
 HEAP32[gb + 98296 >> 2] = fb + 686;
 HEAP32[gb + 98300 >> 2] = fb + 687;
 runPostSets105();
}

function __Z19InitShaderCacheGLESv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 40 | 0;
 i5 = i6 + 20 | 0;
 i1 = i6;
 if (HEAP32[gb + 1451144 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 i2 = __Znwj(12) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[gb + 1451144 >> 2] = i2;
 __Z40GetTemporaryCachePathApplicationSpecificv(i5);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i7 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i7 << 24 >> 24 < 0;
 i7 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i7 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i8 ? HEAP32[i5 >> 2] | 0 : i5, i7, i7 + 18 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, gb + 605895 | 0, 18) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 do if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(HEAP32[gb + 1451144 >> 2] | 0) | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i8 = HEAP32[gb + 1451144 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i2 = HEAP8[i8 + 11 >> 0] | 0;
  i7 = i2 << 24 >> 24 < 0;
  i2 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i7 ? HEAP32[i8 >> 2] | 0 : i8, i2, i2 + 7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, gb + 1039677 | 0, 7) | 0;
  i2 = _fopen((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, gb + 945625 | 0) | 0;
  if (!i2) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   i3 = 6;
  } else {
   _fread(i1, 20, 1, i2) | 0;
   _fclose(i2) | 0;
   i8 = (HEAP32[i1 >> 2] | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   if (i8) i3 = 6;
  }
  if ((i3 | 0) == 6) if (!(HEAP32[i1 + 4 >> 2] | 0)) if (!(HEAP32[i1 + 8 >> 2] | 0)) if (!(HEAP32[i1 + 12 >> 2] | 0)) if (!(HEAP32[i1 + 16 >> 2] | 0)) break;
  __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(HEAP32[gb + 1451144 >> 2] | 0) | 0;
  i3 = 12;
 } else i3 = 12; while (0);
 if ((i3 | 0) == 12) {
  __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(HEAP32[gb + 1451144 >> 2] | 0) | 0;
  i8 = HEAP32[gb + 1451144 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i1 = HEAP8[i8 + 11 >> 0] | 0;
  i7 = i1 << 24 >> 24 < 0;
  i1 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i7 ? HEAP32[i8 >> 2] | 0 : i8, i1, i1 + 7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, gb + 1039677 | 0, 7) | 0;
  i1 = _fopen((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, gb + 777169 | 0) | 0;
  if (i1 | 0) {
   _fwrite(i5, 20, 1, i1) | 0;
   _fclose(i1) | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(i1, f14) {
 i1 = i1 | 0;
 f14 = Math_fround(f14);
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i3 = i1 + 52 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 144 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(i2 & 4)) {
  HEAP32[i13 + 80 >> 2] = 0;
  HEAP32[i13 + 84 >> 2] = 0;
  HEAP32[i13 + 88 >> 2] = 0;
  HEAP32[i13 + 96 >> 2] = 0;
  HEAP32[i13 + 100 >> 2] = 0;
  HEAP32[i13 + 104 >> 2] = 0;
  return;
 }
 HEAP16[i1 >> 1] = i2 & 65023;
 __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i13, 1) | 0;
 i2 = HEAP32[i13 + 156 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 i3 = HEAP32[i3 >> 2] | 0;
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i3 + 32 >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i3 + 36 >> 2]));
 f10 = Math_fround(f10 * f14);
 f11 = Math_fround(f11 * f14);
 f12 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i3 + 40 >> 2])) * f14);
 f16 = Math_fround(-Math_fround(HEAPF32[i3 + 16 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i3 + 20 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i3 + 24 >> 2]));
 f18 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(Math_fround(f19 * f16) + Math_fround(f17 * f18))) - Math_fround(f9 * f8));
 f7 = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(Math_fround(f19 * f8) + Math_fround(f15 * f18))) - Math_fround(f17 * f4));
 f5 = Math_fround(Math_fround(Math_fround(f17 * f8) + Math_fround(Math_fround(f19 * f4) + Math_fround(f9 * f18))) - Math_fround(f15 * f16));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f15 * f8)) - Math_fround(f9 * f4));
 if (f4 < Math_fround(0.0)) {
  f4 = Math_fround(-f4);
  f5 = Math_fround(-f5);
  f7 = Math_fround(-f7);
  f6 = Math_fround(-f6);
 }
 f8 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)));
 if (f8 < Math_fround(1.00000002e-16)) {
  i3 = 1065353216;
  f4 = Math_fround(0.0);
  i2 = 0;
  i1 = 0;
 } else {
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8))));
  f17 = Math_fround(f6 * f9);
  f18 = Math_fround(f7 * f9);
  f19 = Math_fround(f5 * f9);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  if (Math_fround(Math_abs(Math_fround(f4))) < Math_fround(9.99999993e-09)) f4 = Math_fround(3.14159274); else f4 = Math_fround(Math_fround(+Math_atan2(+Math_fround(f8 * f9), +f4)) * Math_fround(2.0));
 }
 f17 = Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f18 = Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(f17 * f14);
 f18 = Math_fround(f18 * f14);
 f19 = Math_fround(Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * f14);
 HEAPF32[i13 + 80 >> 2] = f10;
 HEAPF32[i13 + 84 >> 2] = f11;
 HEAPF32[i13 + 88 >> 2] = f12;
 HEAPF32[i13 + 96 >> 2] = f17;
 HEAPF32[i13 + 100 >> 2] = f18;
 HEAPF32[i13 + 104 >> 2] = f19;
 return;
}

function __ZN5physx19TriangleMeshBuilder10importMeshERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb(i8, i10, i14, i15) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i12 = i17 + 16 | 0;
 i13 = i17 + 4 | 0;
 i11 = i8 + 16 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i11);
 i2 = __ZN5physx20InternalTriangleMesh16allocateVerticesEj(i11, HEAP32[i10 + 8 >> 2] | 0) | 0;
 i9 = __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb(i11, HEAP32[i10 + 20 >> 2] | 0, 1) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i10 + 4 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   i4 = i2;
   i5 = i3;
   i6 = i4 + 12 | 0;
   do {
    HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
    i4 = i4 + 1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i4 | 0) < (i6 | 0));
   if (!i1) break; else {
    i2 = i2 + 12 | 0;
    i3 = i3 + i7 | 0;
   }
  }
 }
 i8 = i8 + 20 | 0;
 i6 = i9 + ((HEAP32[i8 >> 2] | 0) * 12 | 0) | 0;
 i7 = i10 + 12 | 0;
 i5 = HEAP32[i10 + 16 >> 2] | 0;
 i4 = HEAPU16[i10 + 24 >> 1] | 0;
 i2 = i4 & 1;
 i1 = i9 >>> 0 < i6 >>> 0;
 if (!(i4 & 2)) {
  if (i1) {
   i4 = i2 + 1 | 0;
   i3 = 2 - i2 | 0;
   i2 = i9;
   i1 = i5;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + (i4 << 2) >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + (i3 << 2) >> 2];
    i2 = i2 + 12 | 0;
    if (i2 >>> 0 >= i6 >>> 0) break; else i1 = i1 + (HEAP32[i7 >> 2] | 0) | 0;
   }
  }
 } else if (i1) {
  i4 = i2 + 1 | 0;
  i3 = 2 - i2 | 0;
  i2 = i9;
  i1 = i5;
  while (1) {
   HEAP32[i2 >> 2] = HEAPU16[i1 >> 1];
   HEAP32[i2 + 4 >> 2] = HEAPU16[i1 + (i4 << 1) >> 1];
   HEAP32[i2 + 8 >> 2] = HEAPU16[i1 + (i3 << 1) >> 1];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i1 = i1 + (HEAP32[i7 >> 2] | 0) | 0;
  }
 }
 i5 = i10 + 32 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = __ZN5physx20InternalTriangleMesh17allocateMaterialsEv(i11) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1;
   i1 = HEAP32[i5 >> 2] | 0;
   while (1) {
    i3 = i3 + -1 | 0;
    i10 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8;
    HEAP8[i2 >> 0] = i10;
    HEAP8[i2 + 1 >> 0] = i10 >> 8;
    if (!i3) break; else {
     i2 = i2 + 2 | 0;
     i1 = i1 + i4 | 0;
    }
   }
  }
 }
 if (!((HEAP32[i14 + 28 >> 2] & 8 | 0) == 0 | i15)) {
  if (HEAP8[i14 + 12 >> 0] | 0) {
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
  __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE(i13, i11, i14);
  __ZN5physx27InternalTriangleMeshBuilder14fillRemapTableEv(i13);
  __ZN5physx27InternalTriangleMeshBuilderD2Ev(i13);
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE(i12, i11, i14);
 if (__ZN5physx27InternalTriangleMeshBuilder9cleanMeshEb(i12, i15) | 0) {
  __ZN5physx27InternalTriangleMeshBuilderD2Ev(i12);
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 if (i15) {
  __ZN5physx27InternalTriangleMeshBuilderD2Ev(i12);
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 730694 | 0, 264, gb + 731812 | 0, i16);
  __ZN5physx27InternalTriangleMeshBuilderD2Ev(i12);
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 return 0;
}

function __Z20CalculateSurfaceAreaRK10Matrix4x4fRKNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEER13dynamic_arrayI8Vector3fLj4EE(i3, i17, i18) {
 i3 = i3 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f1 = f0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i12 = i18 + 12 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i13 = HEAP32[i18 >> 2] | 0;
  i14 = i3 + 16 | 0;
  i15 = i3 + 32 | 0;
  i16 = i3 + 48 | 0;
  i4 = i3 + 4 | 0;
  i5 = i3 + 20 | 0;
  i6 = i3 + 36 | 0;
  i7 = i3 + 52 | 0;
  i8 = i3 + 8 | 0;
  i9 = i3 + 24 | 0;
  i10 = i3 + 40 | 0;
  i11 = i3 + 56 | 0;
  i2 = 0;
  do {
   f23 = Math_fround(HEAPF32[i3 >> 2]);
   i22 = i13 + (i2 * 12 | 0) | 0;
   f25 = Math_fround(HEAPF32[i22 >> 2]);
   f23 = Math_fround(f23 * f25);
   f21 = Math_fround(HEAPF32[i14 >> 2]);
   i20 = i13 + (i2 * 12 | 0) + 4 | 0;
   f24 = Math_fround(HEAPF32[i20 >> 2]);
   f21 = Math_fround(f23 + Math_fround(f21 * f24));
   f23 = Math_fround(HEAPF32[i15 >> 2]);
   i19 = i13 + (i2 * 12 | 0) + 8 | 0;
   f1 = Math_fround(HEAPF32[i19 >> 2]);
   f23 = Math_fround(f21 + Math_fround(f23 * f1));
   f23 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) + f23);
   f21 = Math_fround(f25 * Math_fround(HEAPF32[i4 >> 2]));
   f21 = Math_fround(f21 + Math_fround(f24 * Math_fround(HEAPF32[i5 >> 2])));
   f21 = Math_fround(f21 + Math_fround(f1 * Math_fround(HEAPF32[i6 >> 2])));
   f21 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f21);
   f25 = Math_fround(f25 * Math_fround(HEAPF32[i8 >> 2]));
   f24 = Math_fround(f25 + Math_fround(f24 * Math_fround(HEAPF32[i9 >> 2])));
   f1 = Math_fround(f24 + Math_fround(f1 * Math_fround(HEAPF32[i10 >> 2])));
   f1 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f1);
   HEAPF32[i22 >> 2] = f23;
   HEAPF32[i20 >> 2] = f21;
   HEAPF32[i19 >> 2] = f1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 }
 i3 = HEAP32[i17 + 4 >> 2] | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i5 = i2;
 if (i3 - i2 >> 2 >>> 0 <= 2) {
  f25 = Math_fround(0.0);
  return Math_fround(f25);
 }
 i4 = HEAP32[i18 >> 2] | 0;
 i3 = (i3 - i2 >> 2 >>> 0) / 3 | 0;
 f1 = Math_fround(0.0);
 i2 = 0;
 do {
  i22 = i2 * 3 | 0;
  i20 = HEAP32[i5 + (i22 << 2) >> 2] | 0;
  f23 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) >> 2]);
  f26 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) + 8 >> 2]);
  i20 = HEAP32[i5 + (i22 + 1 << 2) >> 2] | 0;
  f27 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) >> 2]);
  f21 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i4 + (i20 * 12 | 0) + 8 >> 2]);
  i22 = HEAP32[i5 + (i22 + 2 << 2) >> 2] | 0;
  f29 = Math_fround(HEAPF32[i4 + (i22 * 12 | 0) >> 2]);
  f24 = Math_fround(HEAPF32[i4 + (i22 * 12 | 0) + 4 >> 2]);
  f27 = Math_fround(f27 - f23);
  f21 = Math_fround(f21 - f26);
  f28 = Math_fround(f28 - f25);
  f23 = Math_fround(f29 - f23);
  f26 = Math_fround(f24 - f26);
  f25 = Math_fround(Math_fround(HEAPF32[i4 + (i22 * 12 | 0) + 8 >> 2]) - f25);
  f24 = Math_fround(Math_fround(f21 * f25) - Math_fround(f28 * f26));
  f25 = Math_fround(Math_fround(f28 * f23) - Math_fround(f27 * f25));
  f23 = Math_fround(Math_fround(f27 * f26) - Math_fround(f21 * f23));
  f1 = Math_fround(f1 + Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25))))) * Math_fround(.5)));
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return Math_fround(f1);
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN10HumanTrait19GetMuscleDefaultMinEi(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0;
 do if ((i7 | 0) < 0) {
  i4 = -1;
  i3 = -1;
  i2 = -1;
  i1 = -1;
 } else {
  i4 = (i7 | 0) < 52;
  do if (i4) {
   i5 = __ZN7mecanim5human14BoneFromMuscleEi(i7) | 0;
   i6 = 8;
  } else {
   if ((i7 | 0) < 72) {
    i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i7 + -52 | 0) | 0;
    if ((i1 | 0) == -1) {
     i4 = -1;
     i3 = -1;
     i2 = -1;
     i1 = -1;
     i6 = 23;
     break;
    } else {
     i5 = i1 + 24 | 0;
     i6 = 8;
     break;
    }
   }
   if ((i7 | 0) < 92) {
    i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i7 + -72 | 0) | 0;
    if ((i1 | 0) == -1) {
     i4 = -1;
     i3 = -1;
     i2 = -1;
     i1 = -1;
     i6 = 29;
     break;
    } else {
     i5 = i1 + 39 | 0;
     i6 = 8;
     break;
    }
   } else {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
  } while (0);
  if ((i6 | 0) == 8) {
   do if ((i5 | 0) < 0) {
    i1 = -1;
    i3 = -1;
    i2 = -1;
   } else {
    if ((i5 | 0) < 24) {
     i1 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 0) | 0;
     i3 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 1) | 0;
     i2 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 2) | 0;
     break;
    }
    if ((i5 | 0) < 39) {
     i2 = i5 + -24 | 0;
     i1 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 0) | 0;
     i3 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 1) | 0;
     i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 2) | 0;
     i1 = (i1 | 0) != -1 ? i1 + 52 | 0 : -1;
     i3 = (i3 | 0) != -1 ? i3 + 52 | 0 : -1;
     i2 = (i2 | 0) != -1 ? i2 + 52 | 0 : -1;
     break;
    }
    if ((i5 | 0) < 54) {
     i2 = i5 + -39 | 0;
     i1 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 0) | 0;
     i3 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 1) | 0;
     i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 2) | 0;
     i1 = (i1 | 0) != -1 ? i1 + 72 | 0 : -1;
     i3 = (i3 | 0) != -1 ? i3 + 72 | 0 : -1;
     i2 = (i2 | 0) != -1 ? i2 + 72 | 0 : -1;
    } else {
     i1 = -1;
     i3 = -1;
     i2 = -1;
    }
   } while (0);
   if (i4) {
    i4 = i1;
    i1 = i5;
    break;
   }
   if ((i7 | 0) < 72) {
    i4 = i1;
    i1 = i5;
    i6 = 23;
   } else {
    i4 = i1;
    i1 = i5;
    i6 = 29;
   }
  }
  if ((i6 | 0) == 23) {
   i1 = __ZN7mecanim4hand10GetAxeInfoEj(i1 + -24 | 0) | 0;
   if ((i4 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 32 >> 2]);
    return Math_fround(f8);
   }
   if ((i3 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 36 >> 2]);
    return Math_fround(f8);
   }
   if ((i2 | 0) != (i7 | 0)) {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
   f8 = Math_fround(HEAPF32[i1 + 40 >> 2]);
   return Math_fround(f8);
  } else if ((i6 | 0) == 29) {
   i1 = __ZN7mecanim4hand10GetAxeInfoEj(i1 + -39 | 0) | 0;
   if ((i4 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 32 >> 2]);
    return Math_fround(f8);
   }
   if ((i3 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 36 >> 2]);
    return Math_fround(f8);
   }
   if ((i2 | 0) != (i7 | 0)) {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
   f8 = Math_fround(HEAPF32[i1 + 40 >> 2]);
   return Math_fround(f8);
  }
 } while (0);
 i1 = __ZN7mecanim5human10GetAxeInfoEj(i1) | 0;
 if ((i4 | 0) == (i7 | 0)) {
  f8 = Math_fround(HEAPF32[i1 + 32 >> 2]);
  return Math_fround(f8);
 }
 if ((i3 | 0) == (i7 | 0)) {
  f8 = Math_fround(HEAPF32[i1 + 36 >> 2]);
  return Math_fround(f8);
 }
 if ((i2 | 0) != (i7 | 0)) {
  f8 = Math_fround(0.0);
  return Math_fround(f8);
 }
 f8 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 return Math_fround(f8);
}

function __ZN10HumanTrait19GetMuscleDefaultMaxEi(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0;
 do if ((i7 | 0) < 0) {
  i4 = -1;
  i3 = -1;
  i2 = -1;
  i1 = -1;
 } else {
  i4 = (i7 | 0) < 52;
  do if (i4) {
   i5 = __ZN7mecanim5human14BoneFromMuscleEi(i7) | 0;
   i6 = 8;
  } else {
   if ((i7 | 0) < 72) {
    i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i7 + -52 | 0) | 0;
    if ((i1 | 0) == -1) {
     i4 = -1;
     i3 = -1;
     i2 = -1;
     i1 = -1;
     i6 = 23;
     break;
    } else {
     i5 = i1 + 24 | 0;
     i6 = 8;
     break;
    }
   }
   if ((i7 | 0) < 92) {
    i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i7 + -72 | 0) | 0;
    if ((i1 | 0) == -1) {
     i4 = -1;
     i3 = -1;
     i2 = -1;
     i1 = -1;
     i6 = 29;
     break;
    } else {
     i5 = i1 + 39 | 0;
     i6 = 8;
     break;
    }
   } else {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
  } while (0);
  if ((i6 | 0) == 8) {
   do if ((i5 | 0) < 0) {
    i1 = -1;
    i3 = -1;
    i2 = -1;
   } else {
    if ((i5 | 0) < 24) {
     i1 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 0) | 0;
     i3 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 1) | 0;
     i2 = __ZN7mecanim5human14MuscleFromBoneEii(i5, 2) | 0;
     break;
    }
    if ((i5 | 0) < 39) {
     i2 = i5 + -24 | 0;
     i1 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 0) | 0;
     i3 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 1) | 0;
     i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 2) | 0;
     i1 = (i1 | 0) != -1 ? i1 + 52 | 0 : -1;
     i3 = (i3 | 0) != -1 ? i3 + 52 | 0 : -1;
     i2 = (i2 | 0) != -1 ? i2 + 52 | 0 : -1;
     break;
    }
    if ((i5 | 0) < 54) {
     i2 = i5 + -39 | 0;
     i1 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 0) | 0;
     i3 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 1) | 0;
     i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i2, 2) | 0;
     i1 = (i1 | 0) != -1 ? i1 + 72 | 0 : -1;
     i3 = (i3 | 0) != -1 ? i3 + 72 | 0 : -1;
     i2 = (i2 | 0) != -1 ? i2 + 72 | 0 : -1;
    } else {
     i1 = -1;
     i3 = -1;
     i2 = -1;
    }
   } while (0);
   if (i4) {
    i4 = i1;
    i1 = i5;
    break;
   }
   if ((i7 | 0) < 72) {
    i4 = i1;
    i1 = i5;
    i6 = 23;
   } else {
    i4 = i1;
    i1 = i5;
    i6 = 29;
   }
  }
  if ((i6 | 0) == 23) {
   i1 = __ZN7mecanim4hand10GetAxeInfoEj(i1 + -24 | 0) | 0;
   if ((i4 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 48 >> 2]);
    return Math_fround(f8);
   }
   if ((i3 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 52 >> 2]);
    return Math_fround(f8);
   }
   if ((i2 | 0) != (i7 | 0)) {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
   f8 = Math_fround(HEAPF32[i1 + 56 >> 2]);
   return Math_fround(f8);
  } else if ((i6 | 0) == 29) {
   i1 = __ZN7mecanim4hand10GetAxeInfoEj(i1 + -39 | 0) | 0;
   if ((i4 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 48 >> 2]);
    return Math_fround(f8);
   }
   if ((i3 | 0) == (i7 | 0)) {
    f8 = Math_fround(HEAPF32[i1 + 52 >> 2]);
    return Math_fround(f8);
   }
   if ((i2 | 0) != (i7 | 0)) {
    f8 = Math_fround(0.0);
    return Math_fround(f8);
   }
   f8 = Math_fround(HEAPF32[i1 + 56 >> 2]);
   return Math_fround(f8);
  }
 } while (0);
 i1 = __ZN7mecanim5human10GetAxeInfoEj(i1) | 0;
 if ((i4 | 0) == (i7 | 0)) {
  f8 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  return Math_fround(f8);
 }
 if ((i3 | 0) == (i7 | 0)) {
  f8 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  return Math_fround(f8);
 }
 if ((i2 | 0) != (i7 | 0)) {
  f8 = Math_fround(0.0);
  return Math_fround(f8);
 }
 f8 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 return Math_fround(f8);
}

function __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i3 - i6 | 0;
 i8 = i5 >> 5;
 i12 = i13 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 i2 = i6;
 i10 = i9;
 i14 = i3;
 if (i8 >>> 0 <= i1 - i9 >> 5 >>> 0) {
  i5 = i13 + 4 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i9 >> 5;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 << 5) | 0 : i3;
  i2 = i1 - i6 | 0;
  i3 = i2 >> 5;
  if (i3 | 0) _memmove(i9 | 0, i6 | 0, i2 | 0) | 0;
  i2 = i10 + (i3 << 5) | 0;
  if (!i4) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i5 >> 2] = i1 + (~((i1 + -32 - i2 | 0) >>> 5) << 5);
   STACKTOP = i15;
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i15;
   return;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   i12 = i1 + 24 | 0;
   i13 = HEAP32[i12 + 4 >> 2] | 0;
   i14 = i2 + 24 | 0;
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i1 = i1 + 32 | 0;
   i2 = (HEAP32[i5 >> 2] | 0) + 32 | 0;
   HEAP32[i5 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i1 = i13 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -32 - i9 | 0) >>> 5) << 5);
  i10 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 73;
  HEAP32[i11 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  i1 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
 } else i3 = 0;
 i10 = i1 - i3 | 0;
 i3 = i10 >> 4;
 i3 = i10 >> 5 >>> 0 < 1073741823 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
 i1 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 73;
 HEAP32[i11 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 5, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i12 >> 2] = i1 + (i3 << 5);
 if ((i2 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  i11 = i2 + 24 | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i1 + 24 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  i2 = i2 + 32 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZN11NoiseModule6UpdateERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjjfRKN4math7_float4E(i6, i7, i8, i9, i10, f1, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 32 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 if ((HEAP16[gb + 1451824 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451824 | 0, i4);
  i5 = gb + 1451824 | 0;
 } else i5 = 0;
 f1 = Math_fround(f1 / Math_fround(HEAPF32[i7 + 264 >> 2]));
 i2 = i6 + 824 | 0;
 HEAPF32[i4 + 12 >> 2] = f1;
 HEAPF32[i4 + 8 >> 2] = f1;
 HEAPF32[i4 + 4 >> 2] = f1;
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i12 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 i3 = HEAP32[i6 + 908 >> 2] | 0;
 L4 : do switch ((i3 & 65535) << 16 >> 16) {
 case 0:
  {
   i12 = HEAP32[i6 + 904 >> 2] | 0;
   HEAP32[i13 + 12 >> 2] = i12;
   HEAP32[i13 + 8 >> 2] = i12;
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i13 >> 2] = i12;
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i6 + 1056 >> 2] | 0) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i6 + 904 >> 2]);
   f1 = Math_fround(f1 * f15);
   f1 = Math_fround(f1 + Math_fround(Math_fround(f15 * Math_fround(HEAPF32[(HEAP32[i6 + 968 >> 2] | 0) + 4 >> 2])) - f1));
   HEAPF32[i13 >> 2] = f1;
   HEAPF32[i13 + 4 >> 2] = f1;
   HEAPF32[i13 + 8 >> 2] = f1;
   HEAPF32[i13 + 12 >> 2] = f1;
   break;
  }
 default:
  if (!(i3 & 16711680)) {
   __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i13, i2, i4, i12);
   break L4;
  } else {
   __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i13, i2, i4, i12);
   break L4;
  }
 } while (0);
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i11 >> 2]));
 i13 = i6 + 1088 | 0;
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f15);
 L12 : do switch (HEAP32[i6 + 820 >> 2] | 0) {
 case 0:
  if (!(HEAP8[i6 + 804 >> 0] | 0)) {
   __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  } else {
   __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  }
 case 1:
  if (!(HEAP8[i6 + 804 >> 0] | 0)) {
   __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  } else {
   __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  }
 case 2:
  if (!(HEAP8[i6 + 804 >> 0] | 0)) {
   __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  } else {
   __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj(i6, i8, i7, i9, i10);
   break L12;
  }
 default:
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 613414 | 0, 0, gb + 613471 | 0, 706, 1, 0, 0, 0);
 } while (0);
 if (!i5) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i14;
 return;
}

function _tt_sbit_decoder_load_byte_aligned(i2, i1, i5, i8, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i19 = HEAP32[i7 + 8 >> 2] | 0;
 i16 = HEAP32[i7 + 12 >> 2] | 0;
 i9 = HEAP32[i2 + 12 >> 2] | 0;
 i4 = HEAPU16[i9 + 2 >> 1] | 0;
 i9 = HEAP16[i9 >> 1] | 0;
 i3 = i9 & 65535;
 i18 = Math_imul(HEAPU8[i2 + 18 >> 0] | 0, i4) | 0;
 if ((i8 | 0) < 0) {
  i19 = 3;
  return i19 | 0;
 }
 if ((i3 + i6 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0 | ((i6 | 0) < 0 ? 1 : (i4 + i8 | 0) >>> 0 > (HEAP32[i7 + 4 >> 2] | 0) >>> 0)) {
  i19 = 3;
  return i19 | 0;
 }
 if ((i1 + (Math_imul((i18 + 7 | 0) >>> 3, i3) | 0) | 0) >>> 0 > i5 >>> 0) {
  i19 = 3;
  return i19 | 0;
 }
 i5 = Math_imul(i19, i6) | 0;
 i6 = i8 >> 3;
 i2 = i16 + (i5 + i6) | 0;
 i17 = i8 & 7;
 i4 = i9 << 16 >> 16 != 0;
 if (!i17) {
  if (!i4) {
   i19 = 0;
   return i19 | 0;
  }
  if (i18 >>> 0 <= 7) {
   i5 = (i18 | 0) == 0;
   i4 = 65280 >>> i18;
   while (1) {
    if (!i5) {
     HEAP8[i2 >> 0] = (HEAPU8[i1 >> 0] | 0) & i4 | (HEAPU8[i2 >> 0] | 0);
     i1 = i1 + 1 | 0;
    }
    if ((i3 | 0) > 1) {
     i3 = i3 + -1 | 0;
     i2 = i2 + i19 | 0;
    } else {
     i1 = 0;
     break;
    }
   }
   return i1 | 0;
  }
  i8 = i18 + -8 | 0;
  i12 = i8 >>> 3;
  i11 = i12 << 3;
  i9 = i12 + 1 | 0;
  i10 = (i18 - i11 | 0) > 8;
  i11 = 65280 >>> (i8 - i11 | 0);
  i8 = i16 + (i6 + i12 + i5 + 1) | 0;
  while (1) {
   i7 = i1 + i12 | 0;
   i4 = i18;
   i5 = i2;
   i6 = i1;
   while (1) {
    HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | HEAP8[i5 >> 0];
    i4 = i4 + -8 | 0;
    if ((i4 | 0) <= 7) break; else {
     i5 = i5 + 1 | 0;
     i6 = i6 + 1 | 0;
    }
   }
   i1 = i1 + i9 | 0;
   if (i10) {
    HEAP8[i8 >> 0] = (HEAPU8[i1 >> 0] | 0) & i11 | (HEAPU8[i8 >> 0] | 0);
    i1 = i7 + 2 | 0;
   }
   if ((i3 | 0) > 1) {
    i3 = i3 + -1 | 0;
    i2 = i2 + i19 | 0;
    i8 = i8 + i19 | 0;
   } else {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 }
 if (!i4) {
  i19 = 0;
  return i19 | 0;
 }
 if (i18 >>> 0 <= 7) {
  i6 = (i18 | 0) == 0;
  i7 = (i18 + i17 | 0) >>> 0 > 8;
  i5 = 65280 >>> i18;
  while (1) {
   if (i6) i4 = 0; else {
    i4 = (HEAPU8[i1 >> 0] | 0) & i5;
    i1 = i1 + 1 | 0;
   }
   HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | i4 >>> i17;
   if (i7) {
    i18 = i2 + 1 | 0;
    HEAP8[i18 >> 0] = HEAPU8[i18 >> 0] | 0 | i4 << 8 >>> i17;
   }
   if ((i3 | 0) > 1) {
    i3 = i3 + -1 | 0;
    i2 = i2 + i19 | 0;
   } else {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 }
 i14 = i18 + -8 | 0;
 i15 = i14 >>> 3;
 i12 = i15 << 3;
 i9 = i6 + i15 + i5 | 0;
 i11 = i15 + 1 | 0;
 i14 = i14 - i12 | 0;
 i12 = (i18 - i12 | 0) > 8;
 i13 = 65280 >>> i14;
 i14 = (i14 + i17 | 0) > 8;
 i10 = i16 + i9 | 0;
 i9 = i16 + (i9 + 1) | 0;
 while (1) {
  i8 = i1 + i15 | 0;
  i5 = i18;
  i6 = i2;
  i4 = 0;
  i7 = i1;
  while (1) {
   i16 = HEAPU8[i7 >> 0] | 0 | i4;
   HEAP8[i6 >> 0] = i16 >>> i17 | (HEAPU8[i6 >> 0] | 0);
   i4 = i16 << 8;
   i5 = i5 + -8 | 0;
   if ((i5 | 0) <= 7) break; else {
    i6 = i6 + 1 | 0;
    i7 = i7 + 1 | 0;
   }
  }
  i1 = i1 + i11 | 0;
  if (i12) {
   i4 = (HEAPU8[i1 >> 0] | 0) & i13 | i4;
   i1 = i8 + 2 | 0;
  }
  HEAP8[i9 >> 0] = HEAPU8[i9 >> 0] | 0 | i4 >>> i17;
  if (i14) {
   i16 = i10 + 2 | 0;
   HEAP8[i16 >> 0] = HEAPU8[i16 >> 0] | 0 | i4 << 8 >>> i17;
  }
  if ((i3 | 0) > 1) {
   i3 = i3 + -1 | 0;
   i2 = i2 + i19 | 0;
   i10 = i10 + i19 | 0;
   i9 = i9 + i19 | 0;
  } else {
   i1 = 0;
   break;
  }
 }
 return i1 | 0;
}

function __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 12 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 16 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i7 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = i1;
  i2 = i2 | 0 ? i2 - i4 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i4;
 } else i3 = i7 + 4 | 0;
 i4 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = i4 + 4;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i5 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i7, i5, 0);
 i1 = i6 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 32 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 37 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_(i3, i24, i2, i1) {
 i3 = i3 | 0;
 i24 = i24 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(f22 * f22);
 i23 = i3 + 32 | 0;
 i1 = HEAP8[i23 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i19 = i3 + 44 | 0;
 i20 = i24 + 48 | 0;
 i21 = i24 + 52 | 0;
 i10 = i24 + 56 | 0;
 i11 = i24 + 16 | 0;
 i12 = i24 + 32 | 0;
 i13 = i24 + 4 | 0;
 i14 = i24 + 20 | 0;
 i15 = i24 + 36 | 0;
 i16 = i24 + 8 | 0;
 i17 = i24 + 24 | 0;
 i18 = i24 + 40 | 0;
 i9 = i1 & 255;
 do {
  i9 = i9 + -1 | 0;
  i8 = HEAP32[i19 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i20 >> 2]);
  f29 = Math_fround(HEAPF32[i21 >> 2]);
  f31 = Math_fround(HEAPF32[i10 >> 2]);
  f34 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) >> 2]);
  f33 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) + 8 >> 2]);
  f32 = Math_fround(f34 * Math_fround(HEAPF32[i24 >> 2]));
  f32 = Math_fround(f32 + Math_fround(f33 * Math_fround(HEAPF32[i11 >> 2])));
  f32 = Math_fround(f32 + Math_fround(f28 * Math_fround(HEAPF32[i12 >> 2])));
  f30 = Math_fround(f34 * Math_fround(HEAPF32[i13 >> 2]));
  f30 = Math_fround(f30 + Math_fround(f33 * Math_fround(HEAPF32[i14 >> 2])));
  f30 = Math_fround(f30 + Math_fround(f28 * Math_fround(HEAPF32[i15 >> 2])));
  f34 = Math_fround(f34 * Math_fround(HEAPF32[i16 >> 2]));
  f33 = Math_fround(f34 + Math_fround(f33 * Math_fround(HEAPF32[i17 >> 2])));
  f32 = Math_fround(f27 + f32);
  f30 = Math_fround(f29 + f30);
  f28 = Math_fround(f31 + Math_fround(f33 + Math_fround(f28 * Math_fround(HEAPF32[i18 >> 2]))));
  f33 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) + 16 >> 2]);
  f31 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) + 20 >> 2]);
  f29 = Math_fround(HEAPF32[i8 + (i9 * 48 | 0) + 24 >> 2]);
  f27 = Math_fround(f32 - f33);
  f34 = Math_fround(f30 - f31);
  f7 = Math_fround(f28 - f29);
  i1 = i8 + (i9 * 48 | 0) + 32 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i8 + (i9 * 48 | 0) + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i8 + (i9 * 48 | 0) + 40 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  f26 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f27 = Math_fround(f27 * f26);
  f25 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f34 = Math_fround(f27 + Math_fround(f34 * f25));
  f27 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = Math_fround(f34 + Math_fround(f7 * f27));
  f26 = Math_fround(f33 - Math_fround(f32 - Math_fround(f26 * f7)));
  f25 = Math_fround(f31 - Math_fround(f30 - Math_fround(f25 * f7)));
  f27 = Math_fround(f29 - Math_fround(f28 - Math_fround(f27 * f7)));
  if (Math_fround(Math_fround(f27 * f27) + Math_fround(Math_fround(f26 * f26) + Math_fround(f25 * f25))) > f22) {
   i1 = (HEAP8[i23 >> 0] | 0) + -1 << 24 >> 24;
   HEAP8[i23 >> 0] = i1;
   i3 = i8 + (i9 * 48 | 0) | 0;
   i1 = i8 + ((i1 & 255) * 48 | 0) | 0;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  } else {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i5 >> 2] = i6;
   HEAPF32[i8 + (i9 * 48 | 0) + 44 >> 2] = f7;
  }
 } while ((i9 | 0) != 0);
 return;
}

function __Z11SkinGenericILi4ELb1ELb1EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, i33 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i9 = HEAP32[i1 + 24 >> 2] | 0;
 i10 = HEAP32[i1 + 68 >> 2] | 0;
 i11 = HEAP32[i1 + 40 >> 2] | 0;
 i12 = HEAP32[i1 + 44 >> 2] | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 i7 = HEAP32[i1 + 48 >> 2] | 0;
 i8 = HEAP32[i1 + 52 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 i3 = i9;
 while (1) {
  i33 = __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence(i5, 4, i10, i9, i9, i3) | 0;
  i14 = i4 + i7 | 0;
  i15 = i4 + i8 | 0;
  f16 = Math_fround(HEAPF32[i33 >> 2]);
  f25 = Math_fround(HEAPF32[i4 >> 2]);
  f24 = Math_fround(f16 * f25);
  f32 = Math_fround(HEAPF32[i33 + 16 >> 2]);
  f26 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f32 * f26));
  f18 = Math_fround(HEAPF32[i33 + 32 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f18 * f22));
  f24 = Math_fround(Math_fround(HEAPF32[i33 + 48 >> 2]) + f24);
  f31 = Math_fround(HEAPF32[i33 + 4 >> 2]);
  f23 = Math_fround(f25 * f31);
  f30 = Math_fround(HEAPF32[i33 + 20 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f26 * f30));
  f17 = Math_fround(HEAPF32[i33 + 36 >> 2]);
  f23 = Math_fround(f23 + Math_fround(f22 * f17));
  f23 = Math_fround(Math_fround(HEAPF32[i33 + 52 >> 2]) + f23);
  f29 = Math_fround(HEAPF32[i33 + 8 >> 2]);
  f25 = Math_fround(f25 * f29);
  f27 = Math_fround(HEAPF32[i33 + 24 >> 2]);
  f26 = Math_fround(f25 + Math_fround(f26 * f27));
  f25 = Math_fround(HEAPF32[i33 + 40 >> 2]);
  f22 = Math_fround(f26 + Math_fround(f22 * f25));
  f22 = Math_fround(Math_fround(HEAPF32[i33 + 56 >> 2]) + f22);
  f26 = Math_fround(HEAPF32[i14 >> 2]);
  f21 = Math_fround(f16 * f26);
  f28 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f32 * f28));
  f19 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f18 * f19));
  f20 = Math_fround(Math_fround(Math_fround(f31 * f26) + Math_fround(f30 * f28)) + Math_fround(f17 * f19));
  f19 = Math_fround(Math_fround(Math_fround(f29 * f26) + Math_fround(f27 * f28)) + Math_fround(f25 * f19));
  f28 = Math_fround(HEAPF32[i15 >> 2]);
  f16 = Math_fround(f16 * f28);
  f26 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f32 = Math_fround(f16 + Math_fround(f32 * f26));
  f16 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f18 = Math_fround(f32 + Math_fround(f18 * f16));
  f17 = Math_fround(Math_fround(Math_fround(f31 * f28) + Math_fround(f30 * f26)) + Math_fround(f17 * f16));
  f16 = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(f27 * f26)) + Math_fround(f25 * f16));
  HEAPF32[i1 >> 2] = f24;
  HEAPF32[i1 + 4 >> 2] = f23;
  HEAPF32[i1 + 8 >> 2] = f22;
  i14 = i1 + i7 | 0;
  HEAPF32[i14 >> 2] = f21;
  HEAPF32[i14 + 4 >> 2] = f20;
  HEAPF32[i14 + 8 >> 2] = f19;
  i14 = i1 + i8 | 0;
  HEAPF32[i14 >> 2] = f18;
  HEAPF32[i14 + 4 >> 2] = f17;
  HEAPF32[i14 + 8 >> 2] = f16;
  HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) break; else {
   i4 = i4 + i11 | 0;
   i1 = i1 + i12 | 0;
   i3 = i3 + 32 | 0;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i7 = i4 - i3 | 0;
 i8 = (i7 | 0) / 296 | 0;
 i9 = i10 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i2 = i5;
 i11 = i4;
 if (i8 >>> 0 <= ((i1 - i5 | 0) / 296 | 0) >>> 0) {
  i6 = i10 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i5 | 0) / 296 | 0;
  i5 = i8 >>> 0 > i1 >>> 0;
  i1 = i5 ? i3 + (i1 * 296 | 0) | 0 : i4;
  if ((i3 | 0) == (i1 | 0)) i4 = i2; else {
   do {
    __ZN8GUIStyleaSERKS_(i2, i3) | 0;
    i3 = i3 + 296 | 0;
    i2 = i2 + 296 | 0;
   } while ((i3 | 0) != (i1 | 0));
   i4 = i2;
  }
  if (i5) {
   if ((i1 | 0) == (i11 | 0)) {
    STACKTOP = i13;
    return;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   do {
    __ZN8GUIStyleC2ERKS_(i2, i1);
    i1 = i1 + 296 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 296 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i1 | 0) != (i11 | 0));
   STACKTOP = i13;
   return;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) {
   STACKTOP = i13;
   return;
  }
  i3 = i12 + 4 | 0;
  do {
   i2 = i1 + -296 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -284 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i3 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i13;
  return;
 }
 if (i5) {
  i6 = i10 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i5; else {
   i5 = i12 + 4 | 0;
   i4 = i1;
   while (1) {
    i1 = i4 + -296 | 0;
    HEAP32[i6 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i4 = HEAP32[i4 + -284 >> 2] | 0;
     HEAP32[i12 >> 2] = 66;
     HEAP32[i5 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 | 0)) break; else i4 = i1;
   }
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i5 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i1 = 0;
 }
 if ((i7 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else i2 = 0;
 i7 = (i1 - i2 | 0) / 296 | 0;
 i1 = i7 << 1;
 i1 = i7 >>> 0 < 1073741823 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 2147483647;
 if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i2 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 296 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 + (i1 * 296 | 0);
 if ((i3 | 0) == (i11 | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = i3;
 do {
  __ZN8GUIStyleC2ERKS_(i2, i1);
  i1 = i1 + 296 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 296 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i13;
 return;
}

function __ZN6Skybox12RenderSkyboxEP8MaterialRK6Camera(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 272 | 0;
 i9 = i11 + 208 | 0;
 i3 = i11 + 196 | 0;
 i10 = i11;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 if ((HEAP16[gb + 1113452 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1113452 | 0, i4);
  i5 = gb + 1113452 | 0;
 } else i5 = 0;
 i8 = HEAP32[gb + 1113452 >> 2] | 0;
 i12 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 648 >> 2] | 0, i12 | 0, i8 | 0);
 i8 = __Z12GetGfxDevicev() | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i10, __Z12GetGfxDevicev() | 0);
 if (__ZNK6Camera16GetStereoEnabledEv(i7) | 0) if (!(__Z12GetIVRDevicev() | 0)) i2 = 8; else {
  i12 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 112 >> 2] | 0, i12 | 0) | 0) i2 = 8; else {
   f1 = Math_fround(Math_fround(Math_fround(__ZNK6Camera6GetFarEv(i7)) * Math_fround(.990000009)) * Math_fround(.577350259));
   __ZN10Matrix4x4f11SetIdentityEv(i4) | 0;
   HEAPF32[i9 >> 2] = f1;
   HEAPF32[i9 + 4 >> 2] = f1;
   HEAPF32[i9 + 8 >> 2] = f1;
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i4, i9) | 0;
   __ZNK6Camera11GetPositionEv(i9, i7);
   HEAP32[i4 + 48 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 52 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i4 + 56 >> 2] = HEAP32[i9 + 8 >> 2];
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 108 >> 2] | 0, i8 | 0, i4 | 0);
  }
 } else i2 = 8;
 if ((i2 | 0) == 8) {
  i2 = __Z12GetGfxDevicev() | 0;
  f1 = Math_fround(Math_fround(__ZNK6Camera6GetFarEv(i7)) * Math_fround(10.0));
  HEAPF32[i3 >> 2] = f1;
  HEAPF32[i3 + 4 >> 2] = f1;
  HEAPF32[i3 + 8 >> 2] = f1;
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i4, i3) | 0;
  __ZNK6Camera11GetPositionEv(i3, i7);
  HEAP32[i4 + 48 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 52 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 56 >> 2] = HEAP32[i3 + 8 >> 2];
  f1 = Math_fround(Math_fround(__ZNK6Camera7GetNearEv(i7)) * Math_fround(.00999999977));
  if (!(HEAP8[i7 + 1088 >> 0] | 0)) __ZNK6Camera25GetSkyboxProjectionMatrixEfR10Matrix4x4f(i7, f1, i9); else __ZN10Matrix4x4f11SetIdentityEv(i9) | 0;
  HEAPF32[i9 + 40 >> 2] = Math_fround(-.999998986);
  HEAPF32[i9 + 56 >> 2] = Math_fround(f1 * Math_fround(-1.99999905));
  HEAPF32[i9 + 44 >> 2] = Math_fround(-1.0);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i9 | 0);
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i4 | 0);
 }
 __ZN6Skybox8SetupSunERK6CameraR9GfxDevice(0, i8);
 i12 = (__ZNK8Material12GetPassCountEv(i6) | 0) == 6;
 if (!((HEAPU8[(HEAP32[(__ZN8Material9GetShaderEv(i6) | 0) + 32 >> 2] | 0) + 68 >> 0] ^ 1) & (i12 & 1))) __ZN6Skybox14RenderAllFacesEP8Material(i6); else {
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 0);
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 1);
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 2);
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 3);
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 4);
  __ZN6Skybox16RenderSingleFaceEP8Materiali(i6, 5);
 }
 __ZN22DeviceMVPMatricesStateD2Ev(i10);
 i12 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 652 >> 2] | 0, i12 | 0);
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i11;
 return;
}

function _unzLocateFile(i11, i12, i5) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i23;
 i13 = i23 + 80 | 0;
 if (!i11) {
  i22 = -102;
  STACKTOP = i23;
  return i22 | 0;
 }
 if ((_strlen(i12) | 0) >>> 0 > 255) {
  i22 = -102;
  STACKTOP = i23;
  return i22 | 0;
 }
 i14 = i11 + 56 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) {
  i22 = -100;
  STACKTOP = i23;
  return i22 | 0;
 }
 i17 = i11 + 48 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i19 = i11 + 52 | 0;
 i20 = HEAP32[i19 >> 2] | 0;
 i21 = i11 + 72 | 0;
 i2 = i22;
 i3 = i21;
 i4 = i2 + 80 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i15 = i11 + 152 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 HEAP32[i19 >> 2] = HEAP32[i11 + 68 >> 2];
 HEAP32[i17 >> 2] = 0;
 i1 = _unzlocal_GetCurrentFileInfoInternal(i11, i21, i15, 0, 0, 0, 0, 0, 0) | 0;
 i9 = (i1 | 0) == 0;
 HEAP32[i14 >> 2] = i9 & 1;
 L10 : do if (i9) {
  i6 = i11 + 36 | 0;
  i7 = i11 + 104 | 0;
  i8 = i11 + 108 | 0;
  i9 = i11 + 112 | 0;
  L12 : do if ((i5 | 1 | 0) == 1) {
   while (1) {
    i1 = _unzlocal_GetCurrentFileInfoInternal(i11, 0, 0, i13, 256, 0, 0, 0, 0) | 0;
    if (i1 | 0) break;
    if (!(_strcmp(i13, i12) | 0)) break L12;
    if (!(HEAP32[i14 >> 2] | 0)) {
     i1 = -100;
     break;
    }
    i10 = HEAP32[i6 >> 2] | 0;
    i1 = (HEAP32[i17 >> 2] | 0) + 1 | 0;
    if ((i10 | 0) != 65535 & (i1 | 0) == (i10 | 0)) {
     i1 = -100;
     break;
    }
    HEAP32[i19 >> 2] = (HEAP32[i7 >> 2] | 0) + 46 + (HEAP32[i8 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i19 >> 2] | 0);
    HEAP32[i17 >> 2] = i1;
    i1 = _unzlocal_GetCurrentFileInfoInternal(i11, i21, i15, 0, 0, 0, 0, 0, 0) | 0;
    HEAP32[i14 >> 2] = (i1 | 0) == 0 & 1;
    if (i1 | 0) break L10;
   }
   break L10;
  } else {
   while (1) {
    i1 = _unzlocal_GetCurrentFileInfoInternal(i11, 0, 0, i13, 256, 0, 0, 0, 0) | 0;
    if (!i1) {
     i3 = i12;
     i4 = i13;
    } else break;
    while (1) {
     i2 = HEAP8[i4 >> 0] | 0;
     i1 = HEAP8[i3 >> 0] | 0;
     i2 = (i2 + -97 & 255) < 26 ? (i2 & 255) + 224 & 255 : i2;
     i1 = (i1 + -97 & 255) < 26 ? (i1 & 255) + 224 & 255 : i1;
     i5 = i1 << 24 >> 24 == 0;
     if (!(i2 << 24 >> 24)) {
      i10 = 14;
      break;
     }
     if (i2 << 24 >> 24 != i1 << 24 >> 24 | i5) break; else {
      i3 = i3 + 1 | 0;
      i4 = i4 + 1 | 0;
     }
    }
    if ((i10 | 0) == 14) {
     i10 = 0;
     if (i5) break L12;
    }
    if (!(HEAP32[i14 >> 2] | 0)) {
     i1 = -100;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i1 = (HEAP32[i17 >> 2] | 0) + 1 | 0;
    if ((i5 | 0) != 65535 & (i1 | 0) == (i5 | 0)) {
     i1 = -100;
     break;
    }
    HEAP32[i19 >> 2] = (HEAP32[i7 >> 2] | 0) + 46 + (HEAP32[i8 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + (HEAP32[i19 >> 2] | 0);
    HEAP32[i17 >> 2] = i1;
    i1 = _unzlocal_GetCurrentFileInfoInternal(i11, i21, i15, 0, 0, 0, 0, 0, 0) | 0;
    HEAP32[i14 >> 2] = (i1 | 0) == 0 & 1;
    if (i1 | 0) break L10;
   }
   break L10;
  } while (0);
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 } while (0);
 HEAP32[i17 >> 2] = i18;
 HEAP32[i19 >> 2] = i20;
 i2 = i21;
 i3 = i22;
 i4 = i2 + 80 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i15 >> 2] = i16;
 i22 = i1;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN23ParticleSystemParticles13SetUses3DSizeEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 HEAP8[i9 + 871 >> 0] = 1;
 i11 = HEAP32[i9 + 16 >> 2] | 0;
 i10 = i11 & 2147483647;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 i11 = i11 << 2;
 i8 = i7 << 2;
 i6 = i9 + 420 | 0;
 if (!i7) {
  i1 = i9 + 440 | 0;
  i2 = i9 + 456 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i10 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i10;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i11, 4, i9 + 444 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 4, i9 + 444 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 + 452 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i10;
   HEAP32[i1 >> 2] = i8;
   break;
  } while (0);
  HEAP32[i9 + 452 >> 2] = 0;
  i1 = HEAP32[i9 + 476 >> 2] | 0;
  i2 = i9 + 460 | 0;
  i3 = i9 + 476 | 0;
  do if ((i1 & 2147483647) >>> 0 < i10 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i3 >> 2] = i10;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i11, 4, i9 + 464 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 4, i9 + 464 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i9 + 472 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i2 >> 2] = i11;
   break;
  } while (0);
  HEAP32[i9 + 472 >> 2] = 0;
  return;
 } else i5 = 1;
 do {
  i3 = i9 + 420 + (i5 * 20 | 0) | 0;
  i4 = i9 + 420 + (i5 * 20 | 0) + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i10 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i4 >> 2] = i10;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i11, 4, i9 + 420 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 4, i9 + 420 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i9 + 420 + (i5 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i10;
   HEAP32[i3 >> 2] = i1;
   i1 = i10;
   break;
  } while (0);
  i2 = i9 + 420 + (i5 * 20 | 0) + 12 | 0;
  HEAP32[i2 >> 2] = i7;
  do if ((i1 & 2147483647) >>> 0 < i7 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i4 >> 2] = i7;
   i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i8, 4, i9 + 420 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i3 >> 2] = i4;
   i3 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, i9 + 420 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i3 >> 2] = i1;
   i3 = i1;
   break;
  } else i3 = HEAP32[i3 >> 2] | 0; while (0);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   i15 = i2 + (i1 << 2) | 0;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i13 = HEAP32[i15 + 8 >> 2] | 0;
   i12 = HEAP32[i15 + 12 >> 2] | 0;
   i4 = i3 + (i1 << 2) | 0;
   HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i4 + 4 >> 2] = i14;
   HEAP32[i4 + 8 >> 2] = i13;
   HEAP32[i4 + 12 >> 2] = i12;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i7 >>> 0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 3);
 return;
}

function __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i12, i2, i10, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 i9 = i2 + 11 | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
   i1 = HEAP32[i4 >> 2] | 0;
   i8 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i12 + 11 >> 0] = i6;
   if (!i6) i1 = i12; else {
    i1 = i12;
    i8 = 8;
   }
  } else {
   i1 = i3;
   i8 = 6;
  }
  if ((i8 | 0) == 6) {
   i4 = i6 + 16 & -16;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i4 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i6;
   i8 = 8;
  }
  if ((i8 | 0) == 8) _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i2 + 4 | 0;
 }
 i8 = i11 + 11 | 0;
 do if (!((i1 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i1 & 255) | 0)) i1 = i11 + 4 | 0; else {
  i9 = HEAP8[i8 >> 0] | 0;
  i1 = i11 + 4 | 0;
  if ((i9 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i9 & 255) | 0) {
   i5 = HEAP8[i10 + 11 >> 0] | 0;
   i7 = i5 << 24 >> 24 < 0;
   i6 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
   i5 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i5 & 255;
   i7 = i12 + 11 | 0;
   i2 = HEAP8[i7 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) {
    i4 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
    i2 = HEAP32[i12 + 4 >> 2] | 0;
   } else {
    i4 = 10;
    i2 = i2 & 255;
   }
   if ((i4 - i2 | 0) >>> 0 < i5 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i4, i5 - i4 + i2 | 0, i2, i2, 0, i5, i6);
    break;
   }
   if (i5) {
    if (i3) i3 = HEAP32[i12 >> 2] | 0; else i3 = i12;
    _memcpy(i3 + i2 | 0, i6 | 0, i5 | 0) | 0;
    i2 = i2 + i5 | 0;
    if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i2; else HEAP8[i7 >> 0] = i2;
    HEAP8[i3 + i2 >> 0] = 0;
   }
  }
 } while (0);
 i4 = HEAP8[i8 >> 0] | 0;
 i6 = i4 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i6 ? HEAP32[i1 >> 2] | 0 : i4 & 255;
 i6 = i12 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i4 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i4 - i3 + i1 | 0, i1, i1, 0, i4, i5);
  STACKTOP = i13;
  return;
 }
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 if (i2) i2 = HEAP32[i12 >> 2] | 0; else i2 = i12;
 _memcpy(i2 + i1 | 0, i5 | 0, i4 | 0) | 0;
 i1 = i1 + i4 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i1; else HEAP8[i6 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i11 + 24 | 0;
 i10 = i7 + 11 | 0;
 if (!(HEAP8[i1 + 28 >> 0] | 0)) {
  i4 = HEAP8[i10 >> 0] | 0;
  if (((i4 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255) | 0) != 8) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 453292 | 0, 8) | 0) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 i2 = __ZNK13sorted_vectorIN22BuiltinResourceManager8ResourceENSt3__24lessIS1_EENS2_9allocatorIS1_EEE4findIS1_EENS2_11__wrap_iterIPKS1_EERKT_(i1, i8) | 0;
 do if ((i2 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
  i4 = HEAP32[i2 + 16 >> 2] | 0;
  if (i4 | 0) {
   HEAP32[i9 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i5 = 14;
    }
   }
   if ((i5 | 0) == 12) i5 = 14;
   if ((i5 | 0) == 14) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[i6 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i6 + 28 >> 2] | 0) >>> 0) {
    i12 = i1;
    STACKTOP = i11;
    return i12 | 0;
   }
  }
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = HEAP8[i10 >> 0] | 0;
 i12 = i12 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, gb + 454275 | 0, 13, i12 + 13 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i12) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i12 = HEAP8[i9 + 11 >> 0] | 0;
 i10 = i12 << 24 >> 24 < 0;
 i12 = i10 ? HEAP32[i9 + 4 >> 2] | 0 : i12 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i10 ? HEAP32[i9 >> 2] | 0 : i9, i12, i12 + 44 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, gb + 454289 | 0, 44) | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 451357 | 0, 1088, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i12 = 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN11DynamicMesh20RemoveUnusedVerticesEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i19 + 8 | 0;
 i4 = i19;
 i14 = i19 + 36 | 0;
 i15 = i19 + 16 | 0;
 i13 = i12 + 20 | 0;
 i16 = i12 + 32 | 0;
 i11 = HEAP32[i16 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = i11;
 i17 = i14 + 16 | 0;
 HEAP32[i17 >> 2] = i11;
 i18 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 64016 | 0);
 i10 = i3;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i18;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i11 << 2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i14 >> 2] = i2;
 if (i11 | 0) _memset(i2 | 0, -1, i1 | 0) | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i15 >> 2] = 0;
 i9 = i15 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i15 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i7 = i3;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = HEAP32[i16 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 * 12 | 0, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
 }
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 if (i8 | 0) {
  i7 = 0;
  i1 = HEAP32[i12 >> 2] | 0;
  do {
   if (HEAP8[i1 + (i7 * 26 | 0) + 24 >> 0] | 0) {
    i6 = 0;
    i2 = 0;
    while (1) {
     i2 = i1 + (i7 * 26 | 0) + 12 + (i2 << 1) | 0;
     i3 = HEAPU16[i2 >> 1] | 0;
     i4 = (HEAP32[i14 >> 2] | 0) + (i3 << 2) | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((i5 | 0) == -1) {
      HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
      HEAP16[i2 >> 1] = HEAP32[i9 >> 2];
      __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i15, (HEAP32[i13 >> 2] | 0) + (i3 * 12 | 0) | 0);
      i1 = HEAP32[i12 >> 2] | 0;
     } else HEAP16[i2 >> 1] = i5;
     i2 = i6 + 1 << 24 >> 24;
     if ((i2 & 255) < (HEAPU8[i1 + (i7 * 26 | 0) + 24 >> 0] | 0)) {
      i6 = i2;
      i2 = i2 & 255;
     } else break;
    }
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i8 | 0));
 }
 if ((i15 | 0) != (i13 | 0)) {
  i5 = HEAP32[i15 >> 2] | 0;
  i1 = (HEAP32[i9 >> 2] | 0) * 12 | 0;
  i2 = (i1 | 0) / 12 | 0;
  HEAP32[i16 >> 2] = i2;
  i3 = i12 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1, 4, i12 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i13 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i12 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i16 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i13 >> 2] = i1;
   break;
  } else i1 = HEAP32[i13 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i5 | 0, (HEAP32[i16 >> 2] | 0) * 12 | 0) | 0;
 }
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i18);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCacheC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i9 = i13;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i1 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i1 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i1 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i5 = i13;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 52 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i1 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i14 = i13;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 i2 = HEAP32[gb + 1111240 + 584 >> 2] ^ 16777215;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 95) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 73) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 115) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 65) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 99) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 116) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 105) << 2) >> 2] ^ i2 >>> 8;
 i2 = HEAP32[gb + 1111240 + ((i2 & 255 ^ 118) << 2) >> 2] ^ i2 >>> 8;
 HEAP32[i1 + 80 >> 2] = ~(HEAP32[gb + 1111240 + ((i2 & 255 ^ 101) << 2) >> 2] ^ i2 >>> 8);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 364;
 i2 = HEAP32[i5 >> 2] | 0;
 do if ((i2 & 2147483644) >>> 0 < 364) if ((i2 | 0) > -1) {
  HEAP32[i5 >> 2] = 364;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, 1456, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1456, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i5 >> 2] = 364;
  HEAP32[i3 >> 2] = i14;
  break;
 } while (0);
 if (i1 >>> 0 < 364) _memset((HEAP32[i3 >> 2] | 0) + (i1 << 2) | 0, 0, 1456 - (i1 << 2) | 0) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = 31;
 i2 = HEAP32[i9 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < 31) if ((i2 | 0) > -1) {
  HEAP32[i9 >> 2] = 31;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 124, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(124, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = 31;
  HEAP32[i7 >> 2] = i14;
  break;
 } while (0);
 if (i1 >>> 0 >= 31) {
  STACKTOP = i11;
  return;
 }
 _memset((HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0, 0, 124 - (i1 << 2) | 0) | 0;
 STACKTOP = i11;
 return;
}

function __ZNK5Umbra9UnionFindIjE8getIndexERKj(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i4 = i11 + 4 | 0;
 i5 = i11 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L1 : do if (i6 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i11 + 8 >> 2] | 0) + (((i3 >>> 5) + i3 + (i3 >>> 10) + (i3 >>> 20) & i6 + -1) << 2) | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) != -1) {
    i2 = HEAP32[i11 + 12 >> 2] | 0;
    while (1) {
     if ((HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i3 | 0)) break;
     i1 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
     if ((i1 | 0) == -1) break L1;
    }
    i12 = HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0;
    return i12 | 0;
   }
  }
 } while (0);
 i9 = i11 + 40 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i11 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  if (__ZN5Umbra4HashIjiE6rehashEj(i4, 0) | 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i10 = 11;
  }
 } else {
  i2 = i1;
  i1 = i6;
  i10 = 11;
 }
 if ((i10 | 0) == 11) {
  i5 = HEAP32[i11 + 12 >> 2] | 0;
  i6 = i5 + (i2 * 12 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] = i8;
  HEAP32[i5 + (i2 * 12 | 0) + 8 >> 2] = i12;
  i8 = (HEAP32[i11 + 8 >> 2] | 0) + (((i8 >>> 5) + i8 + (i8 >>> 10) + (i8 >>> 20) & i1 + -1) << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i11 + 24 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i3 = i11 + 36 | 0;
 if ((HEAP32[i3 >> 2] | 0) > (i7 | 0)) {
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  i10 = 21;
 } else {
  i2 = i8 << 1;
  i2 = (i2 | 0) > 16 ? i2 : 16;
  i6 = i11 + 28 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
  if (i1 | 0) {
   HEAP32[i1 >> 2] = i2;
   i1 = i1 + 16 | 0;
   HEAP32[i3 >> 2] = i2;
   i4 = i11 + 32 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    i2 = HEAP32[i9 >> 2] | 0;
    if (i2 | 0) {
     i3 = (i2 | 0) <= (i8 | 0) ? i2 : i8;
     if ((i3 | 0) > 0) {
      i2 = 0;
      do {
       HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i3 | 0));
     }
    }
    i10 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i5 + -16 | 0);
   }
   HEAP32[i4 >> 2] = i1;
   i10 = 21;
  }
 }
 if ((i10 | 0) == 21) {
  HEAP32[i9 >> 2] = i8;
  HEAP32[i1 + (i7 << 2) >> 2] = i12;
 }
 i7 = i11 + 56 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i3 = i11 + 52 | 0;
 if ((HEAP32[i3 >> 2] | 0) > (i8 | 0)) i1 = HEAP32[i11 + 48 >> 2] | 0; else {
  i2 = i9 << 1;
  i2 = (i2 | 0) > 16 ? i2 : 16;
  i6 = i11 + 44 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
  if (!i1) return i12 | 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i11 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    i3 = (i2 | 0) <= (i9 | 0) ? i2 : i9;
    if ((i3 | 0) > 0) {
     i2 = 0;
     do {
      HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
    }
   }
   i11 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i5 + -16 | 0);
  }
  HEAP32[i4 >> 2] = i1;
 }
 HEAP32[i7 >> 2] = i9;
 HEAP32[i1 + (i8 << 2) >> 2] = 1;
 return i12 | 0;
}

function __ZN6b2Rope7SolveC3Ev(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i30 = HEAP32[i1 >> 2] | 0;
 i27 = i30 + -2 | 0;
 if ((i30 | 0) <= 2) return;
 i28 = i1 + 4 | 0;
 i29 = i1 + 16 | 0;
 i30 = i1 + 24 | 0;
 i25 = i1 + 44 | 0;
 i13 = 0;
 do {
  i31 = HEAP32[i28 >> 2] | 0;
  i26 = i31 + (i13 << 3) | 0;
  f15 = Math_fround(HEAPF32[i26 >> 2]);
  i14 = i31 + (i13 << 3) + 4 | 0;
  f16 = Math_fround(HEAPF32[i14 >> 2]);
  i1 = i13;
  i13 = i13 + 1 | 0;
  f17 = Math_fround(HEAPF32[i31 + (i13 << 3) >> 2]);
  f18 = Math_fround(HEAPF32[i31 + (i13 << 3) + 4 >> 2]);
  i19 = i1 + 2 | 0;
  f20 = Math_fround(HEAPF32[i31 + (i19 << 3) >> 2]);
  f21 = Math_fround(HEAPF32[i31 + (i19 << 3) + 4 >> 2]);
  i31 = HEAP32[i29 >> 2] | 0;
  f22 = Math_fround(HEAPF32[i31 + (i1 << 2) >> 2]);
  f23 = Math_fround(HEAPF32[i31 + (i13 << 2) >> 2]);
  f24 = Math_fround(HEAPF32[i31 + (i19 << 2) >> 2]);
  f4 = Math_fround(f17 - f15);
  f2 = Math_fround(f18 - f16);
  f7 = Math_fround(f20 - f17);
  f5 = Math_fround(f21 - f18);
  f3 = Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2));
  f6 = Math_fround(Math_fround(f7 * f7) + Math_fround(f5 * f5));
  if (!(Math_fround(f3 * f6) == Math_fround(0.0))) {
   f8 = Math_fround(+Math_atan2(+Math_fround(Math_fround(f4 * f5) - Math_fround(f2 * f7)), +Math_fround(Math_fround(f4 * f7) + Math_fround(f2 * f5))));
   f11 = Math_fround(Math_fround(-1.0) / f3);
   f12 = Math_fround(f2 * f11);
   f11 = Math_fround(f4 * f11);
   f6 = Math_fround(Math_fround(1.0) / f6);
   f10 = Math_fround(f5 * f6);
   f6 = Math_fround(f7 * f6);
   f7 = Math_fround(f10 - f12);
   f9 = Math_fround(f11 - f6);
   f2 = Math_fround(Math_fround(f24 * Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6))) + Math_fround(Math_fround(f22 * Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11))) + Math_fround(f23 * Math_fround(Math_fround(f7 * f7) + Math_fround(f9 * f9)))));
   if (!(f2 == Math_fround(0.0))) {
    f5 = Math_fround(Math_fround(1.0) / f2);
    f4 = Math_fround(HEAPF32[(HEAP32[i30 >> 2] | 0) + (i1 << 2) >> 2]);
    f2 = Math_fround(f8 - f4);
    if (f2 > Math_fround(3.14159274)) {
     f2 = f8;
     while (1) {
      f3 = Math_fround(f2 + Math_fround(-6.28318548));
      f2 = Math_fround(f3 - f4);
      if (f2 > Math_fround(3.14159274)) f2 = f3; else break;
     }
    } else f3 = f8;
    if (f2 < Math_fround(-3.14159274)) do {
     f3 = Math_fround(f3 + Math_fround(6.28318548));
     f2 = Math_fround(f3 - f4);
    } while (f2 < Math_fround(-3.14159274));
    f5 = Math_fround(-Math_fround(f2 * Math_fround(f5 * Math_fround(HEAPF32[i25 >> 2]))));
    f8 = Math_fround(f22 * f5);
    f16 = Math_fround(f16 - Math_fround(f11 * f8));
    f22 = Math_fround(f23 * f5);
    f17 = Math_fround(f17 + Math_fround(f7 * f22));
    f22 = Math_fround(f18 + Math_fround(f9 * f22));
    f24 = Math_fround(f24 * f5);
    f23 = Math_fround(f20 - Math_fround(f10 * f24));
    f24 = Math_fround(f21 + Math_fround(f6 * f24));
    HEAPF32[i26 >> 2] = Math_fround(f15 + Math_fround(f12 * f8));
    HEAPF32[i14 >> 2] = f16;
    i31 = HEAP32[i28 >> 2] | 0;
    HEAPF32[i31 + (i13 << 3) >> 2] = f17;
    HEAPF32[i31 + (i13 << 3) + 4 >> 2] = f22;
    i31 = HEAP32[i28 >> 2] | 0;
    HEAPF32[i31 + (i19 << 3) >> 2] = f23;
    HEAPF32[i31 + (i19 << 3) + 4 >> 2] = f24;
   }
  }
 } while ((i13 | 0) != (i27 | 0));
 return;
}

function __ZN5physx2GuL32fullContactsGenerationCapsuleBoxERKNS0_8CapsuleVERKNS0_4BoxVENS_6PxVec3ERKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVESF_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS9_5Vec3VERKNS9_6FloatVEb(i8, i1, i3, i4, i12, i13, i2, i7, i9, i10, i11, i5, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i14 + 336 | 0;
 i18 = i14 + 112 | 0;
 i17 = i14 + 64 | 0;
 i15 = i14;
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i18, i3);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i18, i16);
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i3 = i17 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i17 + 20 >> 2] = Math_fround(1.0);
 i3 = i17 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i17 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i15 + 32 >> 2] = i13;
 HEAP32[i15 + 36 >> 2] = i17;
 HEAP32[i15 + 40 >> 2] = i17;
 HEAP8[i15 + 44 >> 0] = 1;
 HEAP32[i15 >> 2] = gb + 84376 + 8;
 HEAP32[i15 + 48 >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!(__ZN5physx2Gu37generateCapsuleBoxFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb(i8, i16, i15, i4, i2, i7, i5, i11, i6) | 0)) {
  i18 = 0;
  STACKTOP = i14;
  return i18 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i3) if ((i1 | 0) == (i3 | 0)) i1 = i3; else {
  i1 = i1 + -1 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i2 + 48 | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold25addBatchManifoldContacts2EPKNS0_17PersistentContactEj(i10, i2, i1);
 f29 = Math_fround(HEAPF32[i13 >> 2]);
 f24 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f25 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f27 = Math_fround(HEAPF32[i11 >> 2]);
 i17 = i11 + 4 | 0;
 f21 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i11 + 8 | 0;
 f23 = Math_fround(HEAPF32[i18 >> 2]);
 f26 = Math_fround(Math_fround(f25 * f25) + Math_fround(-.5));
 f28 = Math_fround(Math_fround(Math_fround(f29 * f27) + Math_fround(f24 * f21)) + Math_fround(f22 * f23));
 f20 = Math_fround(Math_fround(Math_fround(f24 * f28) + Math_fround(Math_fround(f26 * f21) + Math_fround(f25 * Math_fround(Math_fround(f22 * f27) - Math_fround(f29 * f23))))) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f25 * Math_fround(Math_fround(f29 * f21) - Math_fround(f24 * f27)))) + Math_fround(f22 * f28)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f29 * f28) + Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * Math_fround(Math_fround(f24 * f23) - Math_fround(f22 * f21))))) * Math_fround(2.0));
 HEAPF32[i17 >> 2] = f20;
 HEAPF32[i18 >> 2] = f19;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i10, i9, i11, i12, i8 + 128 | 0);
 i18 = 1;
 STACKTOP = i14;
 return i18 | 0;
}

function __ZN5physx14PxRigidBodyExt26getLocalVelocityAtLocalPosERKNS_11PxRigidBodyERKNS_6PxVec3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 56 | 0;
 i21 = i4 + 28 | 0;
 i22 = i4;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i21 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i22 | 0, i2 | 0);
 f20 = Math_fround(Math_fround(HEAPF32[i22 + 16 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i22 + 20 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(HEAPF32[i22 + 24 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i21 >> 2]);
 f6 = Math_fround(f20 * f14);
 f9 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f19 * f9));
 f7 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f18 * f7));
 f5 = Math_fround(Math_fround(f14 * f6) + Math_fround(Math_fround(f20 * f17) + Math_fround(f15 * Math_fround(Math_fround(f18 * f9) - Math_fround(f19 * f7)))));
 f10 = Math_fround(Math_fround(f9 * f6) + Math_fround(Math_fround(f19 * f17) + Math_fround(f15 * Math_fround(Math_fround(f20 * f7) - Math_fround(f18 * f14)))));
 f6 = Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f15 * Math_fround(Math_fround(f19 * f14) - Math_fround(f20 * f9)))) + Math_fround(f7 * f6));
 f20 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f5 = Math_fround(f20 + f5);
 f19 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f10 = Math_fround(f19 + f10);
 f18 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 f6 = Math_fround(f18 + f6);
 f11 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f9 * f13)) + Math_fround(f7 * f16));
 f5 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(f17 * f11) + Math_fround(f15 * Math_fround(Math_fround(f9 * f16) - Math_fround(f7 * f13)))))) - f5);
 f10 = Math_fround(Math_fround(f19 + Math_fround(Math_fround(f9 * f8) + Math_fround(Math_fround(f17 * f13) + Math_fround(f15 * Math_fround(Math_fround(f7 * f11) - Math_fround(f14 * f16)))))) - f10);
 f6 = Math_fround(Math_fround(f18 + Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * Math_fround(Math_fround(f14 * f13) - Math_fround(f9 * f11)))) + Math_fround(f7 * f8))) - f6);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i12 | 0, i2 | 0);
 f8 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f7 = Math_fround(f6 * f8);
 f11 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f10 * f11));
 f11 = Math_fround(f5 * f11);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(f11 - Math_fround(f6 * f9));
 f5 = Math_fround(Math_fround(f10 * f9) - Math_fround(f8 * f5));
 HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
 STACKTOP = i4;
 return;
}

function __ZN11OffMeshLink8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842690 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 88 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 48 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898897 | 0, gb + 842702 | 0, i7, 0);
 i8 = i10 + 8 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843739 | 0, gb + 842702 | 0, i8, 0);
 i6 = i10 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842718 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842733 | 0, i6, i1 + 98 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842749 | 0, i6, i1 + 99 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842761 | 0, i6, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i2 = i16 + 20 | 0;
 i10 = i16 + 8 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16;
 i15 = i14 + 4 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i1 = i5 - i11 >> 2;
 i9 = i11;
 if (i1 >>> 0 < i12 >>> 0) {
  i7 = i14 + 8 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i11 >> 2 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj(i14, i12 - i1 | 0);
   STACKTOP = i16;
   return;
  }
  HEAP32[i10 >> 2] = 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  i6 = i10 + 8 | 0;
  if (i12 | 0) {
   i9 = __Znwj(i12 << 2) | 0;
   i1 = i9;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i6 >> 2] = i9 + (i12 << 2);
  }
  HEAP32[i3 >> 2] = i11;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  __ZNSt3__26vectorIjNS_9allocatorIjEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i2, i13);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = i1 - i4 >> 2;
  i3 = i4;
  i5 = i1;
  if (i2 >>> 0 < i12 >>> 0) {
   __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj(i10, i12 - i2 | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else if (i2 >>> 0 > i12 >>> 0) {
   i2 = i3 + (i12 << 2) | 0;
   if ((i5 | 0) == (i2 | 0)) i2 = i4; else {
    i1 = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2) | 0;
    HEAP32[i8 >> 2] = i1;
    i2 = i4;
   }
  } else i2 = i4;
  i3 = HEAP32[i14 >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
  if (i3 | 0) {
   if ((i2 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 } else {
  if (i1 >>> 0 <= i12 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i7 = i9 + (i12 << 2) | 0;
  HEAP32[i13 >> 2] = 0;
  i10 = i13 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i1 = i12 << 2;
  i2 = i1 >> 2;
  if (!i2) {
   i3 = i13 + 8 | 0;
   i5 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i6 = __Znwj(i1) | 0;
   HEAP32[i10 >> 2] = i6;
   HEAP32[i13 >> 2] = i6;
   i1 = i6 + (i2 << 2) | 0;
   i3 = i13 + 8 | 0;
   HEAP32[i3 >> 2] = i1;
   i8 = i6;
   if (!i12) {
    i5 = i8;
    i2 = i8;
   } else {
    i5 = i7 + -4 | 0;
    i2 = i9;
    i4 = i6;
    while (1) {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i7 | 0)) break; else i4 = i4 + 4 | 0;
    }
    i2 = i6 + (((i5 - i11 | 0) >>> 2) + 1 << 2) | 0;
    HEAP32[i10 >> 2] = i2;
    i5 = i8;
   }
  }
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i4;
  HEAP32[i14 >> 2] = i5;
  i13 = HEAP32[i15 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i2;
  i2 = i14 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
  i2 = i13;
  if (i4 | 0) {
   if ((i2 | 0) != (i4 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
}

function __ZN5physx14PxsAABBManager9visualizeERNS_2Cm12RenderOutputE(i1, i23) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 56 | 0;
 i4 = i24 + 28 | 0;
 i5 = i24;
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i22 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i22 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i23, i22) | 0;
 i22 = HEAP32[i1 + 196 >> 2] | 0;
 if (!i22) {
  STACKTOP = i24;
  return;
 }
 i6 = i1 + 180 | 0;
 i7 = i1 + 356 | 0;
 i8 = i1 + 12 | 0;
 i9 = i4 + 4 | 0;
 i10 = i4 + 8 | 0;
 i11 = i4 + 12 | 0;
 i12 = i4 + 16 | 0;
 i13 = i4 + 20 | 0;
 i14 = i4 + 24 | 0;
 i15 = i1 + 300 | 0;
 i16 = i5 + 4 | 0;
 i17 = i5 + 8 | 0;
 i18 = i5 + 12 | 0;
 i19 = i5 + 16 | 0;
 i20 = i5 + 20 | 0;
 i21 = i5 + 24 | 0;
 i2 = i1 + 316 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  if (HEAP8[i1 + (i3 * 1048 | 0) + 1025 >> 0] | 0) {
   if (!(HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) __ZN5physx2Cm12RenderOutputlsEj(i23, -16711936) | 0; else __ZN5physx2Cm12RenderOutputlsEj(i23, -65536) | 0;
   i25 = HEAP32[i1 + (i3 * 1048 | 0) + 1028 >> 2] | 0;
   i31 = HEAP32[i8 >> 2] | 0;
   i30 = HEAP32[i31 + (i25 * 24 | 0) >> 2] | 0;
   i29 = HEAP32[i31 + (i25 * 24 | 0) + 4 >> 2] | 0;
   i28 = HEAP32[i31 + (i25 * 24 | 0) + 8 >> 2] | 0;
   i27 = HEAP32[i31 + (i25 * 24 | 0) + 12 >> 2] | 0;
   i26 = HEAP32[i31 + (i25 * 24 | 0) + 16 >> 2] | 0;
   i25 = HEAP32[i31 + (i25 * 24 | 0) + 20 >> 2] | 0;
   HEAP32[i4 >> 2] = (i30 | 0) < 0 ? i30 & 2147483647 : ~i30;
   HEAP32[i9 >> 2] = (i29 | 0) < 0 ? i29 & 2147483647 : ~i29;
   HEAP32[i10 >> 2] = (i28 | 0) < 0 ? i28 & 2147483647 : ~i28;
   HEAP32[i11 >> 2] = (i27 | 0) < 0 ? i27 & 2147483647 : ~i27;
   HEAP32[i12 >> 2] = (i26 | 0) < 0 ? i26 & 2147483647 : ~i26;
   HEAP32[i13 >> 2] = (i25 | 0) < 0 ? i25 & 2147483647 : ~i25;
   HEAP8[i14 >> 0] = 1;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i4) | 0;
   i1 = HEAP32[i1 + (i3 * 1048 | 0) + 1032 >> 2] | 0;
   if ((i1 | 0) != 1073741823) do {
    __ZN5physx2Cm12RenderOutputlsEj(i23, -16711681) | 0;
    i31 = HEAP32[i15 >> 2] | 0;
    i26 = HEAP32[i31 + (i1 * 24 | 0) >> 2] | 0;
    i27 = HEAP32[i31 + (i1 * 24 | 0) + 4 >> 2] | 0;
    i28 = HEAP32[i31 + (i1 * 24 | 0) + 8 >> 2] | 0;
    i29 = HEAP32[i31 + (i1 * 24 | 0) + 12 >> 2] | 0;
    i30 = HEAP32[i31 + (i1 * 24 | 0) + 16 >> 2] | 0;
    i31 = HEAP32[i31 + (i1 * 24 | 0) + 20 >> 2] | 0;
    HEAP32[i5 >> 2] = (i26 | 0) < 0 ? i26 & 2147483647 : ~i26;
    HEAP32[i16 >> 2] = (i27 | 0) < 0 ? i27 & 2147483647 : ~i27;
    HEAP32[i17 >> 2] = (i28 | 0) < 0 ? i28 & 2147483647 : ~i28;
    HEAP32[i18 >> 2] = (i29 | 0) < 0 ? i29 & 2147483647 : ~i29;
    HEAP32[i19 >> 2] = (i30 | 0) < 0 ? i30 & 2147483647 : ~i30;
    HEAP32[i20 >> 2] = (i31 | 0) < 0 ? i31 & 2147483647 : ~i31;
    HEAP8[i21 >> 0] = 1;
    __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i23, i5) | 0;
    i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   } while ((i1 | 0) != 1073741823);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i22 | 0));
 STACKTOP = i24;
 return;
}

function __ZN5Unity10HingeJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 736317 | 0, i5, i1 + 158 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 116 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738014 | 0, gb + 827201 | 0, i7, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827416 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827423 | 0, i6, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827430 | 0, i6, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803251 | 0, i5, i1 + 157 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803262 | 0, gb + 736329 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 750887 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048292 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 736399 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 136 | 0, 256);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802926 | 0, i5, i1 + 156 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i3 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 736340 | 0, gb + 736349 | 0, i3, 0);
 __ZN11JointLimits8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i5 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i7 + 264 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i7 + 268 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i7 + 277 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i7 + 278 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i7 + 279 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i7 + 276 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i5);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 + 280 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 288 | 0, i5);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i7 + 284 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i7 + 272 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i9 = i7;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN16UniformCacheGLES6CreateERK20GpuProgramParameters(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i5) | 0) + 12 >> 2] | 0;
 i7 = i5 + 80 | 0;
 i6 = i5 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3;
 if ((i2 | 0) != (i3 | 0)) {
  i3 = (i2 - i3 | 0) / 52 | 0;
  i2 = 0;
  do {
   i1 = (HEAP32[i4 + (i2 * 52 | 0) + 16 >> 2] | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i11 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i10;
  break;
 } while (0);
 if (!(HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i5) | 0) + 12 >> 2] | 0)) {
  i4 = 0;
  i1 = 0;
 } else {
  i2 = 0;
  i1 = 0;
  while (1) {
   i10 = HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i5) | 0) >> 2] | 0;
   i3 = i2 + 1 | 0;
   HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   i9 = HEAP32[i10 + (i2 * 20 | 0) + 8 >> 2] | 0;
   i9 = Math_imul((i9 | 0) < 1 ? 1 : i9, HEAPU8[i10 + (i2 * 20 | 0) + 17 >> 0] | 0) | 0;
   i1 = (Math_imul(i9, HEAPU8[i10 + (i2 * 20 | 0) + 16 >> 0] | 0) | 0) + i1 | 0;
   if (i3 >>> 0 < (HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i5) | 0) + 12 >> 2] | 0) >>> 0) i2 = i3; else {
    i4 = i3;
    break;
   }
  }
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i10 = i2;
 if ((i3 | 0) != (i2 | 0)) {
  i9 = (i3 - i2 | 0) / 52 | 0;
  i8 = 0;
  i2 = i4;
  do {
   i5 = i10 + (i8 * 52 | 0) + 16 | 0;
   if (HEAP32[i5 >> 2] | 0) {
    i6 = HEAP32[i10 + (i8 * 52 | 0) + 4 >> 2] | 0;
    i7 = HEAP32[i11 >> 2] | 0;
    i4 = 0;
    while (1) {
     i3 = i2 + 1 | 0;
     HEAP32[i7 + (i2 << 2) >> 2] = i1;
     i2 = HEAP32[i6 + (i4 * 20 | 0) + 8 >> 2] | 0;
     i2 = Math_imul((i2 | 0) < 1 ? 1 : i2, HEAPU8[i6 + (i4 * 20 | 0) + 17 >> 0] | 0) | 0;
     i1 = (Math_imul(i2, HEAPU8[i6 + (i4 * 20 | 0) + 16 >> 0] | 0) | 0) + i1 | 0;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
      i2 = i3;
      break;
     } else i2 = i3;
    }
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < i9 >>> 0);
 }
 i2 = i11 + 20 | 0;
 i3 = i11 + 32 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i11 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 16, i11 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 16, i11 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = i11;
  break;
 } while (0);
 if (i1 >>> 0 <= i6 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i6 << 2) | 0;
 i2 = i1 - i6 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = 2143289344;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function _ft_black_render(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 17408 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16384 | 0;
 i5 = i12;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i11 = 96;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!i6) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP16[i6 + 2 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = HEAP16[i6 >> 1] | 0;
 if (i2 << 16 >> 16 < 1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i3) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!(HEAP32[i6 + 4 >> 2] | 0)) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((i1 << 16 >> 16 | 0) != ((HEAP16[i3 + ((i2 << 16 >> 16) + -1 << 1) >> 1] | 0) + 1 | 0)) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (HEAP32[i4 + 8 >> 2] & 3 | 0) {
  i11 = 19;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!i7) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!(HEAP32[i7 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!(HEAP32[i7 + 12 >> 2] | 0)) {
  i11 = 20;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = i11 + 128 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 i3 = i11 + 104 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i11 + 28 >> 2] = i5;
 HEAP32[i11 + 32 >> 2] = i5 + 16384;
 i3 = HEAP32[i11 + 144 >> 2] | 0;
 i9 = (i3 & 256 | 0) == 0;
 i10 = i9 ? 6 : 12;
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 16 >> 2] = i9 ? 32 : 256;
 HEAP32[i11 + 20 >> 2] = i9 ? 2 : 30;
 i9 = 1 << i10;
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i11 + 8 >> 2] = i9 >>> 1;
 i10 = i10 + -6 | 0;
 HEAP32[i11 + 12 >> 2] = i10;
 HEAP32[i11 + 24 >> 2] = i10;
 if (!(i3 & 8)) {
  i1 = i11 + 176 | 0;
  i2 = (i3 & 16) >>> 2;
  HEAP8[i1 >> 0] = i2;
  if (!(i3 & 32)) HEAP8[i1 >> 0] = i2 & 255 | 1;
 } else HEAP8[i11 + 176 >> 0] = 2;
 i10 = i11 + 177 | 0;
 HEAP8[i10 >> 0] = i3 >>> 9 & 1 ^ 1;
 i1 = i11 + 160 | 0;
 HEAP32[i1 >> 2] = fb + 966;
 i2 = i11 + 164 | 0;
 HEAP32[i2 >> 2] = fb + 195;
 i3 = i11 + 168 | 0;
 HEAP32[i3 >> 2] = fb + 196;
 i4 = i11 + 172 | 0;
 HEAP32[i4 >> 2] = fb + 3855;
 i5 = i11 + 1020 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i11 + 956 | 0;
 HEAP16[i6 >> 1] = 0;
 i7 = i11 + 958 | 0;
 HEAP16[i7 >> 1] = (HEAP32[i11 + 104 >> 2] | 0) + 65535;
 i8 = i11 + 108 | 0;
 HEAP16[i11 + 56 >> 1] = HEAP32[i8 >> 2];
 HEAP32[i11 + 60 >> 2] = HEAP32[i11 + 116 >> 2];
 i9 = _Render_Single_Pass(i11, 0) | 0;
 if (i9 | 0) {
  i11 = i9;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (HEAP8[i10 >> 0] | 0) if ((HEAP8[i11 + 176 >> 0] | 0) != 2) {
  HEAP32[i1 >> 2] = fb + 967;
  HEAP32[i2 >> 2] = fb + 197;
  HEAP32[i3 >> 2] = fb + 198;
  HEAP32[i4 >> 2] = fb + 3856;
  HEAP32[i5 >> 2] = 0;
  HEAP16[i6 >> 1] = 0;
  HEAP16[i7 >> 1] = (HEAP32[i8 >> 2] | 0) + 65535;
  i1 = _Render_Single_Pass(i11, 1) | 0;
  if (i1 | 0) {
   i11 = i1;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function _common_163(i4, f10, i2) {
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f8 = Math_fround(+Math_sin(+f10));
 f1 = Math_fround(+Math_cos(+f10));
 i2 = (i2 | 0) != 0;
 f9 = Math_fround(-f1);
 f1 = i2 ? f9 : f1;
 f9 = Math_fround(f8 + f1);
 if (i4 >>> 0 < 2130706432) {
  f3 = Math_fround(f8 - f1);
  f5 = Math_fround(-Math_fround(+Math_cos(+Math_fround(f10 * Math_fround(2.0)))));
  if (Math_fround(f8 * f1) < Math_fround(0.0)) f1 = Math_fround(f5 / f3); else {
   f1 = f9;
   f3 = Math_fround(f5 / f9);
  }
  if (i4 >>> 0 < 1484783616) {
   f9 = Math_fround(-f3);
   f3 = i2 ? f9 : f3;
   i6 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
   i7 = i6 >>> 0 > 1090519039;
   if (i7) {
    i2 = gb + 207196 | 0;
    i4 = gb + 207156 | 0;
   } else if (i6 >>> 0 > 1089936471) {
    i2 = gb + 207220 | 0;
    i4 = gb + 207176 | 0;
   } else {
    i4 = i6 >>> 0 > 1077336935;
    i2 = i4 ? gb + 207108 | 0 : gb + 207132 | 0;
    i4 = i4 ? gb + 207068 | 0 : gb + 207088 | 0;
   }
   f5 = Math_fround(Math_fround(1.0) / Math_fround(f10 * f10));
   f9 = Math_fround(HEAPF32[i2 >> 2]);
   f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f13 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f13 = Math_fround(f9 + Math_fround(f5 * Math_fround(f8 + Math_fround(f5 * Math_fround(f11 + Math_fround(f5 * Math_fround(f12 + Math_fround(f5 * Math_fround(f13 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 20 >> 2])))))))))));
   f12 = Math_fround(HEAPF32[i4 >> 2]);
   f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f1 = Math_fround(f1 * Math_fround(Math_fround(f13 / Math_fround(Math_fround(f5 * Math_fround(f12 + Math_fround(f5 * Math_fround(f11 + Math_fround(f5 * Math_fround(f8 + Math_fround(f5 * Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i4 + 16 >> 2])))))))))) + Math_fround(1.0))) + Math_fround(1.0)));
   if (i7) {
    i2 = gb + 207388 | 0;
    i4 = gb + 207340 | 0;
   } else if (i6 >>> 0 > 1089936471) {
    i2 = gb + 207412 | 0;
    i4 = gb + 207364 | 0;
   } else {
    i4 = i6 >>> 0 > 1077336935;
    i2 = i4 ? gb + 207292 | 0 : gb + 207316 | 0;
    i4 = i4 ? gb + 207244 | 0 : gb + 207268 | 0;
   }
   f12 = Math_fround(HEAPF32[i2 >> 2]);
   f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f14 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f14 = Math_fround(f12 + Math_fround(f5 * Math_fround(f11 + Math_fround(f5 * Math_fround(f9 + Math_fround(f5 * Math_fround(f8 + Math_fround(f5 * Math_fround(f14 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 20 >> 2])))))))))));
   f8 = Math_fround(HEAPF32[i4 >> 2]);
   f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f12 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f13 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   f1 = Math_fround(f1 - Math_fround(f3 * Math_fround(Math_fround(Math_fround(f14 / Math_fround(Math_fround(f5 * Math_fround(f8 + Math_fround(f5 * Math_fround(f9 + Math_fround(f5 * Math_fround(f11 + Math_fround(f5 * Math_fround(f12 + Math_fround(f5 * Math_fround(f13 + Math_fround(f5 * Math_fround(HEAPF32[i4 + 20 >> 2])))))))))))) + Math_fround(1.0))) + Math_fround(-.125)) / f10)));
  }
 } else f1 = f9;
 return Math_fround(Math_fround(f1 * Math_fround(.564189613)) / Math_fround(Math_sqrt(Math_fround(f10))));
}

function __ZN9ShaderLab20SerializedSubProgram11AddUAVParamEPKcii(i7, i1, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 40 | 0;
 i12 = i14 + 12 | 0;
 i13 = i14;
 i9 = i7 + 144 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, _strlen(i1) | 0);
 i3 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i8 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i8 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i12 + 20 >> 2] = i4;
 HEAP32[i12 + 24 >> 2] = i5;
 i5 = i7 + 148 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i7 + 152 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i12);
  i1 = i12 + 11 | 0;
 } else {
  i1 = i12 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  i4 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i10 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i10 = 13;
   }
  } else i10 = 11;
  if ((i10 | 0) == 11) {
   i9 = i4 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i10 = 13;
  }
  if ((i10 | 0) == 13) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 28;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  STACKTOP = i14;
  return;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i14;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefINS0_12StringHandleEEE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = (HEAP32[i10 + 4 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
 i13 = i14 >> 2;
 i11 = i1 + 4 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i12 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i9 >> 2] = i2 + 4;
 i12 = i1 + i8 | 0;
 HEAP8[i12 >> 0] = i13;
 HEAP8[i12 + 1 >> 0] = i13 >> 8;
 HEAP8[i12 + 2 >> 0] = i13 >> 16;
 HEAP8[i12 + 3 >> 0] = i13 >> 24;
 i10 = HEAP32[i10 >> 2] | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i7 = (i10 | 0) != 0;
 if ((i13 | 0) != 0 & i7) {
  i8 = i12 + 16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i5 = i12 + 12 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1;
  i9 = i2 - i3 | 0;
  i4 = i9 + i14 | 0;
  if (i4) {
   i6 = i12 + 20 | 0;
   if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
    i1 = i4 << 1;
    if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
    i2 = i12 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i12 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if (i3 | 0) {
     _memcpy(i1 | 0, i3 | 0, i9 | 0) | 0;
     i11 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i5 >> 2] | 0);
    }
    HEAP32[i5 >> 2] = i1;
    i2 = i1 + i9 | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i6 >> 2] = i1 + i4;
   }
  }
  HEAP32[i8 >> 2] = i2 + i14;
  _memcpy(i1 + i9 | 0, i10 | 0, i14 | 0) | 0;
 }
 if ((i13 & 1073741823 | 0) == 0 | i7) return;
 i8 = i12 + 16 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 20 | 0;
 i11 = i12 + 4 | 0;
 i6 = i12 + 8 | 0;
 i7 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = i1;
  i5 = i2 - i3 | 0;
  i4 = i5 + 1 | 0;
  if (i4) if (((HEAP32[i10 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i6 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i3 | 0, i2 | 0, i5 | 0) | 0;
    i13 = HEAP32[i11 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, HEAP32[i9 >> 2] | 0);
   }
   HEAP32[i9 >> 2] = i3;
   i2 = i3 + i5 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i10 >> 2] = i3 + i1;
   i1 = i3;
  }
  HEAP32[i8 >> 2] = i2 + 1;
  HEAP8[i1 + i5 >> 0] = 0;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i14 | 0));
 return;
}

function __ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = i1 + 40 | 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i6 = i1 + 28 | 0;
  i1 = i10 + 4 | 0;
  i7 = i10 + 8 | 0;
  if (i2) {
   i5 = 0;
   do {
    HEAP32[i9 >> 2] = 0;
    i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
    do if ((i3 | 0) == 0 ? 1 : (((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) i3 = 9; else {
     i4 = i3 + 40 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (!i2) {
      __ZN11AudioFilter4InitEv(i3);
      i2 = HEAP32[i4 >> 2] | 0;
      HEAP32[i9 >> 2] = i2;
      if (!i2) {
       i3 = 9;
       break;
      } else {
       i3 = 11;
       break;
      }
     } else {
      HEAP32[i9 >> 2] = i2;
      i3 = 11;
      break;
     }
    } while (0);
    if ((i3 | 0) == 9) {
     i3 = 0;
     i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     if (!((i2 | 0) == 0 ? 1 : (((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
      i2 = __ZN13MonoBehaviour14GetOrCreateDSPEv(i2) | 0;
      HEAP32[i9 >> 2] = i2;
      if (i2 | 0) i3 = 11;
     }
    }
    do if ((i3 | 0) == 11) {
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
      __ZNSt3__26vectorIPN4FMOD3DSPENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i9);
      break;
     } else {
      HEAP32[i3 >> 2] = i2;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
      break;
     }
    } while (0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i8 >> 2] | 0));
  } else {
   i5 = 0;
   do {
    HEAP32[i9 >> 2] = 0;
    i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
    do if ((i3 | 0) == 0 ? 1 : (((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) i3 = 20; else {
     i4 = i3 + 40 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (!i2) {
      __ZN11AudioFilter4InitEv(i3);
      i2 = HEAP32[i4 >> 2] | 0;
      HEAP32[i9 >> 2] = i2;
      if (!i2) {
       i3 = 20;
       break;
      } else {
       i3 = 22;
       break;
      }
     } else {
      HEAP32[i9 >> 2] = i2;
      i3 = 22;
      break;
     }
    } while (0);
    if ((i3 | 0) == 20) {
     i3 = 0;
     i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
     if (!((i2 | 0) == 0 ? 1 : (((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
      i2 = __ZNK13MonoBehaviour6GetDSPEv(i2) | 0;
      HEAP32[i9 >> 2] = i2;
      if (i2 | 0) i3 = 22;
     }
    }
    do if ((i3 | 0) == 22) {
     i3 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
      __ZNSt3__26vectorIPN4FMOD3DSPENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i9);
      break;
     } else {
      HEAP32[i3 >> 2] = i2;
      HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
      break;
     }
    } while (0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (HEAP32[i8 >> 2] | 0));
  }
 } else i1 = i10 + 4 | 0;
 i10 = (HEAP32[i10 >> 2] | 0) != (HEAP32[i1 >> 2] | 0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i1, i7, i3, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 switch ((HEAP32[i7 + 16 >> 2] & 255) << 24 >> 24) {
 case 3:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   i1 = i3;
   while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
   i4 = i5 + 16 | 0;
   i2 = i1 - i3 | 0;
   if (i2 >>> 0 < 12) {
    HEAP32[i4 >> 2] = 7340037;
    HEAP8[i5 + 11 >> 0] = 11 - i2;
    i1 = i5;
   } else {
    HEAP32[i4 >> 2] = 3145733;
    HEAP32[i5 + 4 >> 2] = i2;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
    HEAP32[i5 >> 2] = i1;
   }
   _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
   HEAP8[i1 + i2 >> 0] = 0;
   i3 = i7 + 4 | 0;
   i1 = i7 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if ((HEAP32[i3 >> 2] | 0) >>> 0 < i2 >>> 0) i1 = HEAP32[i7 >> 2] | 0; else if (!i2) {
    HEAP32[i1 >> 2] = 16;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(768, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
    HEAP32[i7 >> 2] = i1;
    break;
   } else {
    i2 = ((i2 + 1 | 0) >>> 1) + i2 | 0;
    HEAP32[i1 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 * 48 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
    HEAP32[i7 >> 2] = i1;
    break;
   } while (0);
   i2 = HEAP32[i3 >> 2] | 0;
   i9 = i1 + (i2 * 48 | 0) | 0;
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i1 + (i2 * 48 | 0) + 16 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   i2 = i7 + (i4 * 48 | 0) + 24 | 0;
   HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i8 = i8 + 16 | 0;
   HEAP32[i7 + (i4 * 48 | 0) + 40 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i5);
   STACKTOP = i6;
   return;
  }
 case 4:
  {
   i5 = i7 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i3 = i7 + 8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i2 = (i4 | 0) == 0 ? 16 : ((i4 + 1 | 0) >>> 1) + i4 | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 * 24 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i3 >> 2] = i2;
     i1 = HEAP32[i5 >> 2] | 0;
    }
   }
   HEAP32[i5 >> 2] = i1 + 1;
   i7 = HEAP32[i7 >> 2] | 0;
   i9 = i7 + (i1 * 24 | 0) | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i9 = i8 + 16 | 0;
   HEAP32[i7 + (i1 * 24 | 0) + 16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = 0;
   STACKTOP = i6;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1035011 | 0, 31, 1, 0, 0, 0);
   STACKTOP = i6;
   return;
  }
 }
}

function __ZN13SweepCallback14processTouchesEPKN5physx10PxSweepHitEj(i1, i26, i27) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i30 + 48 | 0;
 i29 = i30;
 i25 = i1 + 68 | 0;
 i24 = HEAP32[i25 >> 2] | 0;
 __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE7reserveEj(i24, (((HEAP32[i24 + 4 >> 2] | 0) - (HEAP32[i24 >> 2] | 0) | 0) / 44 | 0) + i27 | 0);
 if (!i27) {
  STACKTOP = i30;
  return 1;
 }
 i5 = i29 + 40 | 0;
 i6 = i29 + 12 | 0;
 i7 = i28 + 4 | 0;
 i8 = i28 + 8 | 0;
 i9 = i28 + 12 | 0;
 i10 = i28 + 16 | 0;
 i11 = i28 + 20 | 0;
 i12 = i28 + 24 | 0;
 i13 = i28 + 28 | 0;
 i14 = i28 + 32 | 0;
 i15 = i28 + 36 | 0;
 i16 = i29 + 24 | 0;
 i17 = i29 + 28 | 0;
 i18 = i29 + 32 | 0;
 i19 = i29 + 36 | 0;
 i20 = i29 + 4 | 0;
 i21 = i29 + 8 | 0;
 i22 = i29 + 16 | 0;
 i23 = i29 + 20 | 0;
 i24 = i29 + 32 | 0;
 i4 = 0;
 do {
  i3 = HEAP32[i26 + (i4 * 48 | 0) + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
  i2 = i26 + (i4 * 48 | 0) + 16 | 0;
  HEAP32[i29 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i29 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i29 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i26 + (i4 * 48 | 0) + 28 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i28 >> 2] = 5;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  i2 = i14;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i28 | 0) | 0) {
   i1 = HEAP32[i15 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i1 + (HEAP32[i26 + (i4 * 48 | 0) + 8 >> 2] << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i16 >> 2] = i1;
  i3 = HEAP32[i26 + (i4 * 48 | 0) + 40 >> 2] | 0;
  HEAP32[i17 >> 2] = i3;
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  if ((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) {
   HEAP32[i29 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i29 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i29 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  }
  i1 = HEAP32[i25 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i29); else {
   HEAP32[i3 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i23 >> 2];
   i32 = i16;
   i31 = HEAP32[i32 + 4 >> 2] | 0;
   i1 = i3 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i32 >> 2];
   HEAP32[i1 + 4 >> 2] = i31;
   HEAP32[i3 + 32 >> 2] = HEAP32[i24 >> 2];
   HEAP32[i3 + 36 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 40 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 44;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i27 | 0));
 STACKTOP = i30;
 return 1;
}

function __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i1, i2, i3, i4);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj644ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 24 | 0, i2 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj645ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 40 | 0, i2 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj646ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 56 | 0, i2 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 72 | 0, i2 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 88 | 0, i2 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj649ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 104 | 0, i2 + 6 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 120 | 0, i2 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj651ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 136 | 0, i2 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj652ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 152 | 0, i2 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj653ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 168 | 0, i2 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj654ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 184 | 0, i2 + 11 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj655ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 200 | 0, i2 + 12 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 216 | 0, i2 + 13 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 232 | 0, i2 + 14 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj658ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 248 | 0, i2 + 15 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj659ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 264 | 0, i2 + 16 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj660ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i1, i3 + 280 | 0, i2 + 17 | 0);
 STACKTOP = i4;
 return i2 + 18 | 0;
}

function _jpeg_make_d_derived_tbl(i17, i1, i2, i3) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1296 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i18 + 1028 | 0;
 i16 = i18;
 if (i2 >>> 0 > 3) {
  i15 = HEAP32[i17 >> 2] | 0;
  HEAP32[i15 + 20 >> 2] = 50;
  HEAP32[i15 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i15 >> 2] | 0, i17 | 0);
 }
 i14 = i1 << 24 >> 24 == 0;
 i15 = HEAP32[(i14 ? i17 + 176 + (i2 << 2) | 0 : i17 + 160 + (i2 << 2) | 0) >> 2] | 0;
 if (!i15) {
  i13 = HEAP32[i17 >> 2] | 0;
  HEAP32[i13 + 20 >> 2] = 50;
  HEAP32[i13 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i13 >> 2] | 0, i17 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i12 = mftCall_iiii(HEAP32[HEAP32[i17 + 4 >> 2] >> 2] | 0, i17 | 0, 1, 1172) | 0;
  HEAP32[i3 >> 2] = i12;
  i13 = i17;
 } else {
  i13 = i17;
  i12 = i1;
 }
 HEAP32[i12 + 144 >> 2] = i15;
 i5 = 1;
 i1 = 0;
 while (1) {
  i2 = HEAP8[i15 + i5 >> 0] | 0;
  i3 = i2 & 255;
  i4 = i3 + i1 | 0;
  if ((i4 | 0) > 256) {
   i11 = HEAP32[i17 >> 2] | 0;
   HEAP32[i11 + 20 >> 2] = 8;
   mftCall_vi(HEAP32[i11 >> 2] | 0, i13 | 0);
  }
  if (!(i2 << 24 >> 24)) i4 = i1; else _memset(i7 + i1 | 0, i5 & 255 | 0, i3 | 0) | 0;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 17) break; else i1 = i4;
 }
 HEAP8[i7 + i4 >> 0] = 0;
 i2 = HEAP8[i7 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i3 = 1;
  i1 = 0;
 } else {
  i3 = 0;
  i6 = i2 << 24 >> 24;
  i1 = 0;
  while (1) {
   if ((i2 << 24 >> 24 | 0) == (i6 | 0)) {
    i2 = i3;
    while (1) {
     i5 = i1 + 1 | 0;
     HEAP32[i16 + (i1 << 2) >> 2] = i2;
     i1 = i2 + 1 | 0;
     i2 = HEAP8[i7 + i5 >> 0] | 0;
     if ((i2 << 24 >> 24 | 0) == (i6 | 0)) {
      i2 = i1;
      i1 = i5;
     } else {
      i3 = i1;
      i1 = i5;
      break;
     }
    }
   }
   if ((i3 | 0) >= (1 << i6 | 0)) {
    i11 = HEAP32[i17 >> 2] | 0;
    HEAP32[i11 + 20 >> 2] = 8;
    mftCall_vi(HEAP32[i11 >> 2] | 0, i13 | 0);
   }
   if (!(i2 << 24 >> 24)) {
    i3 = 1;
    i1 = 0;
    break;
   } else {
    i3 = i3 << 1;
    i6 = i6 + 1 | 0;
   }
  }
 }
 do {
  i2 = i15 + i3 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i2 = -1; else {
   HEAP32[i12 + 72 + (i3 << 2) >> 2] = i1 - (HEAP32[i16 + (i1 << 2) >> 2] | 0);
   i2 = (HEAPU8[i2 >> 0] | 0) + i1 | 0;
   i1 = i2;
   i2 = HEAP32[i16 + (i2 + -1 << 2) >> 2] | 0;
  }
  HEAP32[i12 + (i3 << 2) >> 2] = i2;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 17);
 HEAP32[i12 + 140 >> 2] = 0;
 HEAP32[i12 + 68 >> 2] = 1048575;
 i1 = 0;
 do {
  HEAP32[i12 + 148 + (i1 << 2) >> 2] = 2304;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 i11 = 1;
 i1 = 0;
 do {
  i7 = i15 + i11 | 0;
  if (HEAP8[i7 >> 0] | 0) {
   i8 = 8 - i11 | 0;
   i9 = 1 << i8;
   i10 = i11 << 8;
   i6 = 1;
   while (1) {
    i5 = i15 + 17 + i1 | 0;
    i2 = i9;
    i3 = HEAP32[i16 + (i1 << 2) >> 2] << i8;
    while (1) {
     HEAP32[i12 + 148 + (i3 << 2) >> 2] = HEAPU8[i5 >> 0] | i10;
     if ((i2 | 0) > 1) {
      i2 = i2 + -1 | 0;
      i3 = i3 + 1 | 0;
     } else break;
    }
    i1 = i1 + 1 | 0;
    if ((i6 | 0) < (HEAPU8[i7 >> 0] | 0)) i6 = i6 + 1 | 0; else break;
   }
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != 9);
 if ((i4 | 0) > 0 & (i14 ^ 1)) i1 = 0; else {
  STACKTOP = i18;
  return;
 }
 do {
  if ((HEAPU8[i15 + 17 + i1 >> 0] | 0) > 15) {
   i16 = HEAP32[i17 >> 2] | 0;
   HEAP32[i16 + 20 >> 2] = 8;
   mftCall_vi(HEAP32[i16 >> 2] | 0, i13 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i18;
 return;
}

function __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 52 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i8 = i9;
   i10 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i11 = i1 + 24 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i11 + 24 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 52 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 52 | 0) + i2 | 0;
 if (i5 >>> 0 > 82595524) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 52 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 41297762 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 82595524;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 52 | 0) | 0;
 i7 = i6 + (((i1 - i4 | 0) / 52 | 0) * 52 | 0) | 0;
 i3 = i7;
 i4 = i6 + (i5 * 52 | 0) | 0;
 i8 = i3;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i14 = i9;
  i5 = HEAP32[i14 + 4 >> 2] | 0;
  i6 = i1 + 8 | 0;
  HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i6 = i1 + 24 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  i1 = i8 + 52 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i9 = i1;
   i1 = i1 + -52 | 0;
   HEAP32[i2 + -52 >> 2] = HEAP32[i1 >> 2];
   __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i2 + -48 | 0, i9 + -48 | 0);
   i14 = i2 + -28 | 0;
   i9 = i9 + -28 | 0;
   HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i14 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   i2 = i3 + -52 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -48 | 0;
  if ((HEAP32[i1 + -32 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -44 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -52 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i5);
 STACKTOP = i13;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPcic(i9, i2, i7, i6) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i9 | 0, 1);
 i4 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i5 = 28;
 } else do if (HEAP8[i1 >> 0] | 0) {
  i5 = i7 + -1 | 0;
  while (1) {
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i5 = 9;
     break;
    }
    if ((i1 | 0) == -1) {
     i1 = 2;
     i5 = 23;
     break;
    }
   } else i1 = HEAPU8[i3 >> 0] | 0;
   i1 = i1 & 255;
   if (i1 << 24 >> 24 == i6 << 24 >> 24) {
    i5 = 12;
    break;
   }
   if ((HEAP32[i8 >> 2] | 0) >= (i5 | 0)) {
    i1 = 4;
    i5 = 23;
    break;
   }
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = i1;
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i5 = 16;
     break;
    }
   } else HEAP32[i2 >> 2] = i3 + 1;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i2 = i4;
  }
  do if ((i5 | 0) == 9) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else if ((i5 | 0) == 12) {
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = i1 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    }
   } else HEAP32[i3 >> 2] = i4 + 1;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i1 = 0;
   i5 = 23;
  } else if ((i5 | 0) == 16) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  if ((i5 | 0) == 23) {
   if ((i7 | 0) > 0) HEAP8[i2 >> 0] = 0;
   i7 = i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | ((HEAP32[i8 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) break;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  }
  i2 = i9;
  i3 = i9;
  i5 = 28;
  break L1;
 } while (0); while (0);
 do if ((i5 | 0) == 28) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmPKcSC_(i8, i15, i9, i10, i11, i1, i12) {
 i8 = i8 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 4 | 0;
 i13 = i16;
 i2 = __ZNKSt3__28ios_base6getlocEv(i9) | 0;
 HEAP32[i7 >> 2] = i2;
 __THREW__ = 0;
 i14 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474556 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i16 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  ___resumeException(i16 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
 L4 : while (1) {
  if ((i1 | 0) == (i12 | 0)) {
   i2 = 31;
   break;
  }
  do if ((mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0, HEAP8[i1 >> 0] | 0, 0) | 0) << 24 >> 24 == 37) {
   i6 = i1 + 1 | 0;
   if ((i6 | 0) == (i12 | 0)) {
    i2 = 6;
    break L4;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0, HEAP8[i6 >> 0] | 0, 0) | 0;
   switch (i2 << 24 >> 24) {
   case 79:
   case 69:
    {
     i4 = i1 + 2 | 0;
     if ((i4 | 0) == (i12 | 0)) {
      i2 = 14;
      break L4;
     }
     i3 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0, HEAP8[i4 >> 0] | 0, 0) | 0;
     i1 = i4;
     break;
    }
   default:
    {
     i3 = i2;
     i2 = 0;
     i1 = i6;
    }
   }
   i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 >> 2] = mftCall_iiiiiiii(i6 | 0, i8 | 0, i7 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0, i2 | 0) | 0;
  } else {
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3) {
    i4 = i3 + 24 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (HEAP32[i3 + 28 >> 2] | 0)) {
     HEAP32[i4 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i2;
     break;
    }
    if ((mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i2 & 255 | 0) | 0) == -1) HEAP32[i15 >> 2] = 0;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 }
 do if ((i2 | 0) == 6) {
  i2 = HEAP8[i1 >> 0] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = i1 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != (HEAP32[i1 + 28 >> 2] | 0)) {
    HEAP32[i3 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i2;
    break;
   }
   if ((mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 & 255 | 0) | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i1 = 0;
   }
  }
 } else if ((i2 | 0) == 14) {
  i2 = HEAP8[i1 >> 0] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i4 = i1 + 24 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i5 = i1 + 28 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) {
    if ((mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 & 255 | 0) | 0) == -1) {
     HEAP32[i15 >> 2] = 0;
     i1 = 0;
     break;
    }
   } else {
    HEAP32[i4 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i2;
   }
   i2 = HEAP8[i6 >> 0] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i5 >> 2] | 0)) {
    HEAP32[i4 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i2;
    break;
   }
   if ((mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 & 255 | 0) | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i1 = 0;
   }
  }
 } else if ((i2 | 0) == 31) i1 = HEAP32[i15 >> 2] | 0; while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb(i8, i2, i9, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i1 = i10;
 if ((HEAP16[gb + 1466980 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466980 | 0, i7);
  i6 = gb + 1466980 | 0;
 } else i6 = 0;
 HEAP32[i9 >> 2] = i2;
 if (!i2) {
  if (HEAP8[i8 + 561 >> 0] | 0) {
   HEAP8[i9 + 28 >> 0] = 1;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = 1065353216;
   HEAP32[i7 + 28 >> 2] = 1065353216;
   HEAP32[i7 + 32 >> 2] = 1065353216;
   HEAP32[i7 + 36 >> 2] = 1065353216;
   i5 = i9 + 32 | 0;
   i2 = __ZN7mecanim9animation20CreateAvatarConstantEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEES8_PNS_5human5HumanES3_iRKS6_RNS_6memory9AllocatorE(0, 0, 0, 0, 0, -1, i7, i5) | 0;
   HEAP32[i9 >> 2] = i2;
   i3 = 7;
  }
 } else {
  i5 = i9 + 32 | 0;
  i3 = 7;
 }
 if ((i3 | 0) == 7) {
  HEAP32[i9 + 24 >> 2] = 0;
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = __ZN7mecanim9animation18CreateAvatarMemoryEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(i2, i5) | 0;
  HEAP32[i9 + 4 >> 2] = __ZN7mecanim9animation17CreateAvatarInputEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(HEAP32[i9 >> 2] | 0, i5) | 0;
  HEAP32[i9 + 16 >> 2] = __ZN7mecanim9animation21CreateAvatarWorkspaceEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(HEAP32[i9 >> 2] | 0, i5) | 0;
  if (i4) i1 = 1; else i1 = (HEAP8[i8 + 561 >> 0] | 0) != 0;
  if (!(HEAP8[i8 + 417 >> 0] | 0)) i2 = (HEAP32[(HEAP32[i8 + 28 >> 2] | 0) + 60 >> 2] & 64 | 0) != 0; else i2 = 1;
  HEAP32[i9 + 8 >> 2] = __ZN7mecanim9animation18CreateAvatarOutputEPKNS0_14AvatarConstantEbbRNS_6memory9AllocatorE(HEAP32[i9 >> 2] | 0, i1, i2, i5) | 0;
  i1 = __ZN8Animator13GetAvatarRootEv(i8) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (!(HEAP8[i8 + 561 >> 0] | 0)) i1 = __ZN11UnityEngine9Animation30CreateAvatarBindingConstantOptER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE(i1, i2, i5) | 0; else i1 = __ZN11UnityEngine9Animation27CreateAvatarBindingConstantER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE(i1, i2, i5) | 0;
  HEAP32[i9 + 20 >> 2] = i1;
  i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  __ZNK9Transform11GetPositionEv(i7, i4);
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = i1;
  i8 = HEAP32[i3 >> 2] | 0;
  __ZNK9Transform11GetRotationEv(i7, i4);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i5 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i8 + 12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 16 >> 2] = i1;
  HEAP32[i8 + 20 >> 2] = i2;
  HEAP32[i8 + 24 >> 2] = i5;
  i8 = HEAP32[i3 >> 2] | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i7, i4);
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i8 + 28 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 32 >> 2] = i4;
  HEAP32[i8 + 36 >> 2] = i5;
  HEAP8[i9 + 29 >> 0] = 1;
 }
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc8ClothSim18addCollisionSphereEPKNS0_8ShapeSimE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 88 | 0;
 i1 = i11 + 60 | 0;
 i2 = i11 + 32 | 0;
 i6 = i11 + 16 | 0;
 i3 = i11 + 8 | 0;
 i4 = HEAP32[i9 + 52 >> 2] | 0;
 i7 = i9 + 84 | 0;
 i5 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i4 + 72 >> 2] | 0) | 0;
 if (i5 >>> 0 > 31) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 719453 | 0, 177, gb + 719787 | 0, i11);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i15 = HEAP32[i10 + 28 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i1, i4);
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i2, i10);
 f19 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f17 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f21 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f20 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f22 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f18 = Math_fround(f18 * Math_fround(2.0));
 f20 = Math_fround(f20 * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(2.0));
 f23 = Math_fround(Math_fround(f21 * f21) + Math_fround(-.5));
 f16 = Math_fround(Math_fround(Math_fround(f18 * f19) + Math_fround(f20 * f17)) + Math_fround(f22 * f12));
 f14 = Math_fround(Math_fround(f16 * f19) + Math_fround(Math_fround(f23 * f18) + Math_fround(f21 * Math_fround(Math_fround(f22 * f17) - Math_fround(f20 * f12)))));
 f13 = Math_fround(Math_fround(f16 * f17) + Math_fround(Math_fround(f23 * f20) + Math_fround(f21 * Math_fround(Math_fround(f18 * f12) - Math_fround(f22 * f19)))));
 f12 = Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)))) + Math_fround(f16 * f12));
 i1 = HEAP32[i15 + 72 >> 2] | 0;
 HEAPF32[i6 >> 2] = f14;
 HEAPF32[i6 + 4 >> 2] = f13;
 HEAPF32[i6 + 8 >> 2] = f12;
 HEAP32[i6 + 12 >> 2] = i1;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i6 + 16;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 mftCall_viiii(i2 | 0, i1 | 0, i8 | 0, i5 | 0, i5 | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 1;
 i1 = i9 + 116 | 0;
 HEAP32[i8 >> 2] = 0;
 i3 = i9 + 120 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i9 + 124 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  i2 = i2 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i8) | 0;
  i4 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  i3 = i1;
  i1 = i2;
  while (1) {
   i15 = HEAP32[i4 >> 2] | 0;
   HEAP32[i15 + (i3 << 2) >> 2] = HEAP32[i15 + (i1 + -2 << 2) >> 2];
   i1 = i3 + -1 | 0;
   if (i1 >>> 0 > i5 >>> 0) {
    i15 = i3;
    i3 = i1;
    i1 = i15;
   } else break;
  }
 }
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] = i10;
 i15 = 1;
 STACKTOP = i11;
 return i15 | 0;
}

function __ZN24CompressedAnimationCurveC2ERKS_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP8[i8 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
 i2 = i8 + 8 | 0;
 i3 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 i4 = i7 + 12 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i5 = __Znwj(i1) | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i8 + 16 >> 2] = i5 + i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i5 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = i5 + i1;
  }
 }
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i1 = i8 + 24 | 0;
 i2 = i7 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i8 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 0;
 i4 = i7 + 28 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 if (i3 | 0) {
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i6 = __Znwj(i3) | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 + 32 >> 2] = i6 + i3;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = i6 + i1;
  }
 }
 i1 = i8 + 36 | 0;
 i2 = i7 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i1 + 12 >> 0] = HEAP8[i2 + 12 >> 0] | 0;
 i1 = i8 + 52 | 0;
 i2 = i7 + 52 | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i8 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 i4 = i7 + 56 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 if (i3 | 0) {
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i6 = __Znwj(i3) | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 + 60 >> 2] = i6 + i3;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = i6 + i1;
  }
 }
 i3 = i7 + 64 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i8 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i8 + 72 | 0;
 i4 = i7 + 72 | 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i2 ? HEAP32[i7 + 76 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 84 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i8 + 84 >> 2] | 0;
  i10 = 19;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i10 = i1;
   i10 = i10 + i3 | 0;
   HEAP8[i10 >> 0] = 0;
   STACKTOP = i11;
   return;
  }
 } else i10 = 19;
 if ((i10 | 0) == 19) {
  i7 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i8 + 80 >> 2] = i7 | -2147483648;
  HEAP32[i8 + 76 >> 2] = i3;
  i1 = i10;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 i10 = i1;
 i10 = i10 + i3 | 0;
 HEAP8[i10 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 __ZN14SafeBinaryRead10SetVersionEi(i9, 4);
 i3 = i6 + 40 | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800723 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i6 + 36 | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800741 | 0, gb + 800762 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI11Rigidbody2DE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800780 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 21; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 21; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 21) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800793 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 32; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 32; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 32) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(i4, i21, i22) {
 i4 = i4 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i23;
 i1 = i23 + 4 | 0;
 i5 = HEAP32[gb + 1104264 >> 2] | 0;
 if ((HEAP16[gb + 1104676 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104676 | 0, i20);
  i16 = gb + 1104676 | 0;
 } else i16 = 0;
 L4 : do if (i4 | 0) {
  i19 = i5 + 28 | 0;
  i1 = HEAP32[i19 >> 2] | 0;
  i17 = i5 + 32 | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i18 = i1 + (i15 << 3) | 0;
  L6 : do if (i15) {
   i3 = HEAP32[i5 + 20 >> 2] | 0;
   i2 = HEAP32[i5 + 12 >> 2] | 0;
   if ((HEAP8[i5 + 8 >> 0] | 0) != 0 & (HEAP32[i5 + 4 >> 2] | 0) != 0) while (1) {
    i15 = HEAP32[i1 >> 2] | 0;
    if (!((i3 | 0) == (i15 | 0) | (i2 | 0) == (i15 | 0))) break L6;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i18 | 0)) break L4;
   } else while (1) {
    if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L6;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i18 | 0)) break L4;
   }
  } while (0);
  if ((i1 | 0) != (i18 | 0)) {
   i15 = i4 + 24 | 0;
   i8 = i4 + 28 | 0;
   i9 = i21 + 12 | 0;
   i10 = i21 + 16 | 0;
   i11 = i21 + 4 | 0;
   i12 = i5 + 20 | 0;
   i13 = i5 + 8 | 0;
   i14 = i5 + 4 | 0;
   i7 = i5 + 12 | 0;
   do {
    if ((((HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0) >>> 21) - (HEAP32[i15 >> 2] | 0) | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
     i3 = HEAP32[i9 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i10 >> 2] = i2;
       HEAP32[i21 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i21 >> 2] | 0, i2 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i21 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
       HEAP32[i10 >> 2] = i2;
       HEAP32[i21 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i9 >> 2] = i4;
     HEAP32[(HEAP32[i21 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
    }
    i1 = i1 + 8 | 0;
    L29 : do if ((i1 | 0) == (i18 | 0)) i1 = i18; else {
     i3 = HEAP32[i12 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
     if ((HEAP8[i13 >> 0] | 0) != 0 & (HEAP32[i14 >> 2] | 0) != 0) while (1) {
      i6 = HEAP32[i1 >> 2] | 0;
      if (!((i3 | 0) == (i6 | 0) | (i2 | 0) == (i6 | 0))) break L29;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i18 | 0)) {
       i1 = i18;
       break;
      }
     } else while (1) {
      if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) break L29;
      i1 = i1 + 8 | 0;
      if ((i1 | 0) == (i18 | 0)) {
       i1 = i18;
       break;
      }
     }
    } while (0);
   } while ((i1 | 0) != ((HEAP32[i19 >> 2] | 0) + (HEAP32[i17 >> 2] << 3) | 0));
  }
 } while (0);
 if (i16 | 0) __Z12profiler_endP19ProfilerInformation(i16);
 if (!i22) {
  STACKTOP = i23;
  return;
 }
 i22 = HEAP32[i21 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i22, i22 + (HEAP32[i21 + 12 >> 2] << 2) | 0, i20);
 STACKTOP = i23;
 return;
}

function __ZN5physx17PxsFluidCollision23updateOverflowParticlesEv(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i2 = HEAP32[i27 + 96 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 i15 = HEAP32[HEAP32[i2 + 72 >> 2] >> 2] | 0;
 i26 = HEAP32[i1 + 48 >> 2] | 0;
 i14 = HEAP32[i2 + 36 >> 2] | 0;
 i1 = HEAP32[i15 + 16396 >> 2] | 0;
 i15 = (HEAP32[i15 + 16392 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= i15 >>> 0) return;
 i16 = i27 + 4 | 0;
 i17 = i27 + 8 | 0;
 f18 = Math_fround(HEAPF32[i27 + 56 >> 2]);
 f19 = Math_fround(HEAPF32[i27 + 12 >> 2]);
 f20 = Math_fround(HEAPF32[i27 + 64 >> 2]);
 i21 = i27 + 88 | 0;
 i22 = i27 + 72 | 0;
 i23 = i27 + 76 | 0;
 i24 = i27 + 80 | 0;
 i25 = i27 + 84 | 0;
 do {
  i11 = HEAP32[i14 + (i1 << 2) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i27 >> 2]);
  f5 = Math_fround(HEAPF32[i16 >> 2]);
  f3 = Math_fround(f3 * f20);
  f5 = Math_fround(f5 * f20);
  f6 = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f20);
  i2 = i26 + (i11 << 5) + 16 | 0;
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
  i12 = i26 + (i11 << 5) + 20 | 0;
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i12 >> 2]));
  i13 = i26 + (i11 << 5) + 24 | 0;
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i13 >> 2]));
  f3 = Math_fround(f19 * f3);
  HEAPF32[i2 >> 2] = f3;
  f5 = Math_fround(f19 * f5);
  HEAPF32[i12 >> 2] = f5;
  f6 = Math_fround(f19 * f6);
  HEAPF32[i13 >> 2] = f6;
  f4 = Math_fround(f20 * Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5))))));
  if (f4 > f18) {
   f10 = Math_fround(f18 / f4);
   f3 = Math_fround(f3 * f10);
   HEAPF32[i2 >> 2] = f3;
   f5 = Math_fround(f5 * f10);
   HEAPF32[i12 >> 2] = f5;
   f6 = Math_fround(f6 * f10);
   HEAPF32[i13 >> 2] = f6;
  }
  f4 = Math_fround(f20 * f3);
  f8 = Math_fround(f20 * f5);
  f10 = Math_fround(f20 * f6);
  i2 = i26 + (i11 << 5) | 0;
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  i7 = i26 + (i11 << 5) + 4 | 0;
  f8 = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
  i9 = i26 + (i11 << 5) + 8 | 0;
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i9 >> 2]));
  HEAPF32[i2 >> 2] = f4;
  HEAPF32[i7 >> 2] = f8;
  HEAPF32[i9 >> 2] = f10;
  if (HEAP32[i21 >> 2] & 8 | 0) {
   f30 = Math_fround(HEAPF32[i22 >> 2]);
   f29 = Math_fround(f30 * f3);
   f28 = Math_fround(HEAPF32[i23 >> 2]);
   f29 = Math_fround(f29 + Math_fround(f28 * f5));
   f31 = Math_fround(HEAPF32[i24 >> 2]);
   f29 = Math_fround(f29 + Math_fround(f31 * f6));
   f28 = Math_fround(f5 - Math_fround(f28 * f29));
   f5 = Math_fround(f6 - Math_fround(f31 * f29));
   HEAPF32[i26 + (i11 << 5) + 16 >> 2] = Math_fround(f3 - Math_fround(f30 * f29));
   HEAPF32[i12 >> 2] = f28;
   HEAPF32[i13 >> 2] = f5;
   f5 = Math_fround(HEAPF32[i22 >> 2]);
   f6 = Math_fround(f4 * f5);
   f28 = Math_fround(HEAPF32[i23 >> 2]);
   f6 = Math_fround(f6 + Math_fround(f8 * f28));
   f3 = Math_fround(HEAPF32[i24 >> 2]);
   f6 = Math_fround(f6 + Math_fround(f10 * f3));
   f6 = Math_fround(Math_fround(HEAPF32[i25 >> 2]) + f6);
   f8 = Math_fround(f8 - Math_fround(f28 * f6));
   f10 = Math_fround(f10 - Math_fround(f3 * f6));
   HEAPF32[i2 >> 2] = Math_fround(f4 - Math_fround(f5 * f6));
   HEAPF32[i7 >> 2] = f8;
   HEAPF32[i9 >> 2] = f10;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i15 >>> 0);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 64 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i19 = i4 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i11 = i4 + 8 | 0;
 i20 = i2 + 8 | 0;
 i18 = HEAP16[i20 >> 1] | 0;
 HEAP8[i11 >> 0] = i18;
 i10 = i4 + 9 | 0;
 HEAP8[i10 >> 0] = (i18 & 65535) >>> 8;
 i18 = i4 + 12 | 0;
 i17 = i2 + 12 | 0;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 i16 = i4 + 24 | 0;
 i15 = i2 + 24 | 0;
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i13 = i4 + 36 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 40 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 44 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 52 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 56 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i4, i2, 0);
 i21 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i19 >> 2] = i21;
 i1 = HEAP8[i20 >> 0] | 0;
 i19 = HEAP16[i11 >> 1] | 0;
 HEAP8[i20 >> 0] = i19;
 HEAP8[i11 >> 0] = i1;
 i11 = i2 + 9 | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 HEAP8[i11 >> 0] = (i19 & 65535) >>> 8;
 HEAP8[i10 >> 0] = i1;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i11 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i11;
 i11 = HEAP32[i2 + 24 >> 2] | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i10 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i4 + 24 >> 2] = i11;
 HEAP32[i4 + 28 >> 2] = i1;
 HEAP32[i4 + 32 >> 2] = i10;
 i10 = i2 + 36 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 40 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 44 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 52 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 48 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 56 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_(i2, i7, i1, i8) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = i2 + (i1 >> 1 << 2) | 0;
 if ((i1 | 0) < 65) {
  if (mftCall_iii(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i6;
  }
  if (mftCall_iii(i8 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i1;
  } else i1 = HEAP32[i9 >> 2] | 0;
  if (!(mftCall_iii(i8 | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0)) {
   i8 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i7 >> 2] = i8;
   return;
  }
  i8 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i8;
  i8 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i7 >> 2] = i8;
  return;
 }
 i3 = i1 >> 3;
 i5 = i3 << 1;
 i6 = i2 + (i3 << 2) | 0;
 i1 = i2 + (i5 << 2) | 0;
 if (mftCall_iii(i8 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
 }
 if (mftCall_iii(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i4;
  i1 = i4;
 } else i1 = HEAP32[i6 >> 2] | 0;
 if (mftCall_iii(i8 | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
 }
 i4 = 0 - i3 | 0;
 i2 = i9 + (i4 << 2) | 0;
 i1 = i9 + (i3 << 2) | 0;
 if (mftCall_iii(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i3;
 }
 if (mftCall_iii(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i3;
  i1 = i3;
 } else i1 = HEAP32[i9 >> 2] | 0;
 if (mftCall_iii(i8 | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i3;
 }
 i3 = i7 + (0 - i5 << 2) | 0;
 i1 = i7 + (i4 << 2) | 0;
 if (mftCall_iii(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i5;
 }
 if (mftCall_iii(i8 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
 } else i2 = HEAP32[i1 >> 2] | 0;
 if (mftCall_iii(i8 | 0, i2 | 0, HEAP32[i3 >> 2] | 0) | 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i5;
 }
 if (mftCall_iii(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i5;
 }
 if (mftCall_iii(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i5;
  i1 = i5;
 } else i1 = HEAP32[i9 >> 2] | 0;
 if (!(mftCall_iii(i8 | 0, i1 | 0, HEAP32[i6 >> 2] | 0) | 0)) {
  i8 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i7 >> 2] = i8;
  return;
 }
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i8;
 i8 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = 414;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i4 : i1;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i9, HEAP32[i8 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i9, HEAP32[i8 + 8 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +f11, +Math_fround(HEAPF32[i6 >> 2]));
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i9, HEAP32[i8 + 12 >> 2] | 0);
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i9, i7) | 0) {
  i4 = HEAP32[i9 + 24 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  mftCall_viii(HEAP32[i8 + 20 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
  mftCall_viff(HEAP32[i8 + 16 >> 2] | 0, i4 | 0, +Math_fround(HEAPF32[i5 >> 2]), +f11);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i9 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i9 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i9 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i9 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i9 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i10;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i10;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 }
 HEAP8[i9 + 36 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth17UnalignedIteratorIS1_Lj3EEEEEvPNS3_12TriangleDataERKT0_j(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i36 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i35 = i36 + 496 | 0;
 i32 = i36 + 480 | 0;
 i33 = i36 + 464 | 0;
 i34 = i36 + 448 | 0;
 i25 = i36 + 432 | 0;
 i28 = i36 + 416 | 0;
 i30 = i36 + 400 | 0;
 i27 = i36 + 384 | 0;
 i29 = i36 + 368 | 0;
 i26 = i36 + 352 | 0;
 i31 = i36 + 336 | 0;
 i4 = i36 + 320 | 0;
 i24 = i36 + 304 | 0;
 i5 = i36 + 288 | 0;
 i14 = i36 + 272 | 0;
 i23 = i36 + 256 | 0;
 i15 = i36 + 240 | 0;
 i16 = i36 + 224 | 0;
 i22 = i36 + 208 | 0;
 i17 = i36 + 192 | 0;
 i18 = i36 + 176 | 0;
 i19 = i36 + 160 | 0;
 i20 = i36 + 144 | 0;
 i21 = i36 + 128 | 0;
 i6 = i36 + 112 | 0;
 i7 = i36 + 96 | 0;
 i8 = i36 + 80 | 0;
 i9 = i36 + 64 | 0;
 i10 = i36 + 48 | 0;
 i11 = i36 + 32 | 0;
 i12 = i36 + 16 | 0;
 i13 = i36;
 HEAP32[i35 >> 2] = HEAP32[i3 >> 2];
 if (!i1) {
  STACKTOP = i36;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv(i32, i35);
  __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i35) | 0;
  __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv(i33, i35);
  __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i35) | 0;
  __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv(i34, i35);
  __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i35) | 0;
  __ZmiRK8Scalar4fS1_(i25, i33, i32);
  __ZmiRK8Scalar4fS1_(i28, i34, i32);
  __Z6cross3RK8Scalar4fS1_(i30, i25, i28);
  __Z4dot3RK8Scalar4fS1_(i27, i25, i25);
  __Z4dot3RK8Scalar4fS1_(i29, i28, i28);
  __Z4dot3RK8Scalar4fS1_(i26, i25, i28);
  __Z4dot3RK8Scalar4fS1_(i4, i30, i30);
  __Z5rsqrtRK8Scalar4f(i31, i4);
  __ZmlRK8Scalar4fS1_(i5, i27, i29);
  __ZmlRK8Scalar4fS1_(i14, i26, i26);
  __ZmiRK8Scalar4fS1_(i24, i5, i14);
  __ZplRK8Scalar4fS1_(i16, i27, i29);
  __ZmiRK8Scalar4fS1_(i15, i16, i26);
  __ZmiRK8Scalar4fS1_(i23, i15, i26);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i17, gb + 1097824 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i22, i17, i24, i23);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i19, gb + 1097808 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i18, i19, i27, i22);
  __ZN8Scalar4faSERKS_(i22, i18) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i21, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i20, i21, i29, i22);
  __ZN8Scalar4faSERKS_(i22, i20) | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i7, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i6, i7, i26, i32);
  __Z12storeAlignedPfRK8Scalar4f(i2, i6);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i9, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i8, i9, i27, i25);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 16 | 0, i8);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i11, gb + 1097792 | 0);
  __Z6selectRK8Scalar4fS1_S1_(i10, i11, i29, i28);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 32 | 0, i10);
  __ZmlRK8Scalar4fS1_(i12, i30, i31);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 48 | 0, i12);
  __Z6recipTILi1EE8Scalar4fRKS0_(i13, i22);
  __Z12storeAlignedPfRK8Scalar4f(i2 + 64 | 0, i13);
  if (!i1) break; else i2 = i2 + 80 | 0;
 }
 STACKTOP = i36;
 return;
}

function __ZN11NavMeshData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 32 | 0;
 i8 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i9 = i1 + 52 | 0;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843578 | 0, i6, i9, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i2, i9, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843593 | 0, gb + 843609 | 0, i9, 0);
 __ZN13NavMeshParams8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843676 | 0, i6, i1 + 68 | 0, 0);
 HEAP32[i8 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 843857 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i8, gb + 932479 | 0, 0);
 i8 = i8 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843871 | 0, HEAP32[gb + 37176 >> 2] | 0, i8, 0);
 i9 = i5 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 1);
 i8 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 88 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843689 | 0, i6, i7, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843704 | 0, i6, i1 + 104 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 843719 | 0, i4, 0);
 __ZN19AutoOffMeshLinkData8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN10VertexData4SwapERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i7 = i1 + 4 | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 8 | 0;
 i4 = i2 + 8 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i4 = i1 + 12 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + 16 | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 20 | 0;
 i4 = i2 + 20 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i4 = i1 + 24 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + 28 | 0;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 32 | 0;
 i4 = i2 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i4 = i1 + 44 | 0;
 i5 = i2 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i5 = i1 + 56 | 0;
 i4 = i2 + 56 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i4 = i1 + 68 | 0;
 i5 = i2 + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i5 = i1 + 88 | 0;
 i6 = i2 + 88 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 80 | 0;
 i4 = i2 + 80 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 92 | 0;
 i5 = i2 + 92 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 96 | 0;
 i6 = i2 + 96 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 84 | 0;
 i4 = i2 + 84 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 100 | 0;
 i2 = i2 + 100 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i1;
 STACKTOP = i3;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i13, i1, i14) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i11 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 i8 = i2 + 520 | 0;
 i2 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 i4 = i9 + 12 | 0;
 i5 = i10 + 4 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 12 | 0;
 i1 = 0;
 do {
  i32 = (HEAP32[i8 >> 2] | 0) + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i32 >> 2]);
  f38 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f37 = Math_fround(HEAPF32[i32 + 8 >> 2]);
  f38 = Math_fround(f38 * Math_fround(.00999999977));
  f37 = Math_fround(f37 * Math_fround(.00999999977));
  f36 = Math_fround(Math_fround(HEAPF32[i32 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i9 >> 2] = Math_fround(f39 * Math_fround(.00999999977));
  HEAPF32[i2 >> 2] = f38;
  HEAPF32[i3 >> 2] = f37;
  HEAPF32[i4 >> 2] = f36;
  __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i10, i14, i9);
  i32 = HEAP32[i10 >> 2] | 0;
  i27 = HEAP32[i5 >> 2] | 0;
  i22 = HEAP32[i6 >> 2] | 0;
  i17 = HEAP32[i7 >> 2] | 0;
  i30 = i13 + (i1 << 2) | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i30 + 4 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i30 + 8 | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  i15 = i30 + 12 | 0;
  i35 = HEAP32[i15 >> 2] | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i18 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i18 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i18 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i18 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  i18 = (Math_imul(i35 & 255, i17 & 255) | 0) + 128 | 0;
  i19 = (Math_imul(i35 >>> 8 & 255, i17 >>> 8 & 255) | 0) + 128 | 0;
  i16 = (Math_imul(i35 >>> 16 & 255, i17 >>> 16 & 255) | 0) + 128 | 0;
  i17 = (Math_imul(i35 >>> 24, i17 >>> 24) | 0) + 128 | 0;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  HEAP32[i15 >> 2] = (i19 >>> 8) + i19 & 261888 | ((i18 >>> 8) + i18 | 0) >>> 8 | ((i17 >>> 8) + i17 | 0) >>> 8 << 24 | ((i16 >>> 8) + i16 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 STACKTOP = i12;
 return;
}

function __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i2, i13, i1, i14) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i11 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 i8 = i2 + 520 | 0;
 i2 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 i4 = i9 + 12 | 0;
 i5 = i10 + 4 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 12 | 0;
 i1 = 0;
 do {
  i32 = (HEAP32[i8 >> 2] | 0) + (i1 << 2) | 0;
  f39 = Math_fround(HEAPF32[i32 >> 2]);
  f38 = Math_fround(HEAPF32[i32 + 4 >> 2]);
  f37 = Math_fround(HEAPF32[i32 + 8 >> 2]);
  f38 = Math_fround(f38 * Math_fround(.00999999977));
  f37 = Math_fround(f37 * Math_fround(.00999999977));
  f36 = Math_fround(Math_fround(HEAPF32[i32 + 12 >> 2]) * Math_fround(.00999999977));
  HEAPF32[i9 >> 2] = Math_fround(f39 * Math_fround(.00999999977));
  HEAPF32[i2 >> 2] = f38;
  HEAPF32[i3 >> 2] = f37;
  HEAPF32[i4 >> 2] = f36;
  __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i10, i14, i9);
  i32 = HEAP32[i10 >> 2] | 0;
  i27 = HEAP32[i5 >> 2] | 0;
  i22 = HEAP32[i6 >> 2] | 0;
  i17 = HEAP32[i7 >> 2] | 0;
  i30 = i13 + (i1 << 2) | 0;
  i28 = HEAP32[i30 >> 2] | 0;
  i25 = i30 + 4 | 0;
  i23 = HEAP32[i25 >> 2] | 0;
  i20 = i30 + 8 | 0;
  i18 = HEAP32[i20 >> 2] | 0;
  i15 = i30 + 12 | 0;
  i35 = HEAP32[i15 >> 2] | 0;
  i33 = (Math_imul(i28 & 255, i32 & 255) | 0) + 128 | 0;
  i34 = (Math_imul(i28 >>> 8 & 255, i32 >>> 8 & 255) | 0) + 128 | 0;
  i31 = (Math_imul(i28 >>> 16 & 255, i32 >>> 16 & 255) | 0) + 128 | 0;
  i32 = (Math_imul(i28 >>> 24, i32 >>> 24) | 0) + 128 | 0;
  i28 = (Math_imul(i23 & 255, i27 & 255) | 0) + 128 | 0;
  i29 = (Math_imul(i23 >>> 8 & 255, i27 >>> 8 & 255) | 0) + 128 | 0;
  i26 = (Math_imul(i23 >>> 16 & 255, i27 >>> 16 & 255) | 0) + 128 | 0;
  i27 = (Math_imul(i23 >>> 24, i27 >>> 24) | 0) + 128 | 0;
  i23 = (Math_imul(i18 & 255, i22 & 255) | 0) + 128 | 0;
  i24 = (Math_imul(i18 >>> 8 & 255, i22 >>> 8 & 255) | 0) + 128 | 0;
  i21 = (Math_imul(i18 >>> 16 & 255, i22 >>> 16 & 255) | 0) + 128 | 0;
  i22 = (Math_imul(i18 >>> 24, i22 >>> 24) | 0) + 128 | 0;
  i18 = (Math_imul(i35 & 255, i17 & 255) | 0) + 128 | 0;
  i19 = (Math_imul(i35 >>> 8 & 255, i17 >>> 8 & 255) | 0) + 128 | 0;
  i16 = (Math_imul(i35 >>> 16 & 255, i17 >>> 16 & 255) | 0) + 128 | 0;
  i17 = (Math_imul(i35 >>> 24, i17 >>> 24) | 0) + 128 | 0;
  HEAP32[i30 >> 2] = (i34 >>> 8) + i34 & 261888 | ((i33 >>> 8) + i33 | 0) >>> 8 | ((i32 >>> 8) + i32 | 0) >>> 8 << 24 | ((i31 >>> 8) + i31 | 0) >>> 8 << 16;
  HEAP32[i25 >> 2] = (i29 >>> 8) + i29 & 261888 | ((i28 >>> 8) + i28 | 0) >>> 8 | ((i27 >>> 8) + i27 | 0) >>> 8 << 24 | ((i26 >>> 8) + i26 | 0) >>> 8 << 16;
  HEAP32[i20 >> 2] = (i24 >>> 8) + i24 & 261888 | ((i23 >>> 8) + i23 | 0) >>> 8 | ((i22 >>> 8) + i22 | 0) >>> 8 << 24 | ((i21 >>> 8) + i21 | 0) >>> 8 << 16;
  HEAP32[i15 >> 2] = (i19 >>> 8) + i19 & 261888 | ((i18 >>> 8) + i18 | 0) >>> 8 | ((i17 >>> 8) + i17 | 0) >>> 8 << 24 | ((i16 >>> 8) + i16 | 0) >>> 8 << 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 STACKTOP = i12;
 return;
}

function __ZNK5physx20BigConvexDataBuilder7ComputeERKNS_15VALENCIESCREATEE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i4 = i8;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 i3 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
 if (!i3) i3 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i3 = mftCall_iiiiii(i9 | 0, i1 | 0, i3 | 0, (i2 ? gb + 729305 | 0 : gb + 837976 | 0) | 0, gb + 729209 | 0, 209) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 16 >> 2] = i3;
 _memset(i3 | 0, 0, i2 << 2 | 0) | 0;
 __ZN5physx2Gu15EdgeListBuilderC2Ev(i7);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP16[i4 + 12 >> 1] = 0;
 HEAPF32[i4 + 20 >> 2] = Math_fround(.100000001);
 HEAP32[i4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP8[i4 + 12 >> 0] = 1;
 if (!(__ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE(i7, i4) | 0)) {
  i9 = 0;
  __ZN5physx2Gu8EdgeListD2Ev(i7);
  STACKTOP = i8;
  return i9 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
  i4 = 0;
  do {
   i9 = i3 + (HEAP32[i2 + (i4 << 3) >> 2] << 2) | 0;
   HEAP16[i9 >> 1] = (HEAP16[i9 >> 1] | 0) + 1 << 16 >> 16;
   i9 = i3 + (HEAP32[i2 + (i4 << 3) + 4 >> 2] << 2) | 0;
   HEAP16[i9 >> 1] = (HEAP16[i9 >> 1] | 0) + 1 << 16 >> 16;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 if (!(HEAP8[i5 + 16 >> 0] | 0)) {
  i9 = 1;
  __ZN5physx2Gu8EdgeListD2Ev(i7);
  STACKTOP = i8;
  return i9 | 0;
 }
 __ZN5physx13BigConvexData13CreateOffsetsEv(HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = (HEAP32[i1 + 8 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = (HEAPU16[i9 + (i2 << 2) >> 1] | 0) + (HEAPU16[i9 + (i2 << 2) + 2 >> 1] | 0) | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (!i2) i2 = 0; else {
  i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i5 | 0, i9 | 0, i2 | 0, (i1 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 729209 | 0, 252) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i1 + 20 >> 2] = i2;
 L18 : do if (HEAP32[i7 >> 2] | 0) {
  i4 = i7 + 4 | 0;
  i3 = 0;
  while (1) {
   i10 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i10 + (i3 << 3) >> 2] | 0;
   i10 = HEAP32[i10 + (i3 << 3) + 4 >> 2] | 0;
   i1 = (HEAP32[i1 + 16 >> 2] | 0) + (i5 << 2) + 2 | 0;
   i9 = HEAP16[i1 >> 1] | 0;
   HEAP16[i1 >> 1] = i9 + 1 << 16 >> 16;
   HEAP8[i2 + (i9 & 65535) >> 0] = i10;
   i9 = HEAP32[i6 >> 2] | 0;
   i2 = (HEAP32[i9 + 16 >> 2] | 0) + (i10 << 2) + 2 | 0;
   i1 = HEAP16[i2 >> 1] | 0;
   HEAP16[i2 >> 1] = i1 + 1 << 16 >> 16;
   HEAP8[(HEAP32[i9 + 20 >> 2] | 0) + (i1 & 65535) >> 0] = i5;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i3 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break L18;
   i2 = HEAP32[i1 + 20 >> 2] | 0;
  }
 } while (0);
 __ZN5physx13BigConvexData13CreateOffsetsEv(i1);
 i10 = 1;
 __ZN5physx2Gu8EdgeListD2Ev(i7);
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN5physx14PxsAABBManager25removeAggregateSinglePairEjPNS_9AggregateEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i20, i1, i2, i8) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 9 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21;
 i16 = HEAP32[(HEAP32[i20 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i5 = HEAP32[i2 + 1032 >> 2] | 0;
 i1 = HEAP8[i2 + 1025 >> 0] | 0;
 i6 = i1 & 255;
 i15 = i19 + 4 | 0;
 HEAP8[i15 >> 0] = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i6 << 2) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i19 >> 2] = i7;
 if (i1 << 24 >> 24) {
  i4 = i20 + 316 | 0;
  i3 = HEAP32[i20 + 308 >> 2] | 0;
  i1 = i5;
  i2 = 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == 1073741823) {
    i14 = (HEAP32[i8 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & ~HEAP32[i20 + 384 + ((i2 & 31) << 2) >> 2];
   }
   HEAP32[i7 + (i2 << 2) >> 2] = i1;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i6 | 0)) break; else i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  }
 }
 i14 = HEAP32[i8 + 4 >> 2] & 2147483647;
 L9 : do if (i14 | 0) {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i14 >>> 0) break L9;
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L15 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i14 >>> 0) {
    i2 = 0;
    break L15;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i3 | 0) != -1) {
   i9 = HEAP32[i8 >> 2] | 0;
   i10 = i20 + 304 | 0;
   i11 = i20 + 49848 | 0;
   i12 = i20 + 49852 | 0;
   i13 = i20 + 49844 | 0;
   do {
    i8 = i1 << 5;
    while (1) {
     i7 = i9 + (i3 >>> 5 << 2) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~HEAP32[i20 + 384 + ((i3 & 31) << 2) >> 2];
     i7 = HEAP32[(HEAP32[i10 >> 2] | 0) + (HEAP32[(HEAP32[i19 >> 2] | 0) + (i3 << 2) >> 2] << 2) >> 2] | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
      i5 = (i4 | 0) == 0 ? 32 : i4 << 1;
      i6 = HEAP32[i13 >> 2] | 0;
      i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i5 << 3, gb + 717789 | 0, 59) | 0;
      if (i6 | 0) _memcpy(i3 | 0, i6 | 0, i4 << 3 | 0) | 0;
      _memset(i3 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
      __ZN5physx6shdfnd9Allocator10deallocateEPv(i18, i6);
      HEAP32[i13 >> 2] = i3;
      HEAP32[i12 >> 2] = i5;
      i4 = HEAP32[i11 >> 2] | 0;
     } else i3 = HEAP32[i13 >> 2] | 0;
     HEAP32[i11 >> 2] = i4 + 1;
     HEAP32[i3 + (i4 << 3) >> 2] = i16;
     HEAP32[i3 + (i4 << 3) + 4 >> 2] = i7;
     if (!i2) break L9;
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i8;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i3 | 0) == -1) break L9;
    }
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i14 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i3 | 0) != -1);
  }
 } while (0);
 if (!(HEAP8[i15 >> 0] | 0)) {
  STACKTOP = i21;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 STACKTOP = i21;
 return;
}

function __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i2 + 20 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i1 = i1 >>> 0 < 4 ? i1 : 4;
 i6 = i2 + 28 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i7 + 24 | 0;
 i11 = HEAP32[i7 + 16 >> 2] | 0;
 i10 = i11 - (HEAP32[i4 >> 2] | 0) + (HEAP32[i7 + 20 >> 2] | 0) | 0;
 i4 = i11 + -1 & HEAP32[i4 >> 2];
 i11 = i11 - i4 | 0;
 i10 = i11 >>> 0 < i10 >>> 0 ? i11 : i10;
 i1 = i10 >>> 0 < i1 >>> 0 ? i10 : i1;
 switch (i1 | 0) {
 case 4:
  {
   HEAP32[(HEAP32[i7 >> 2] | 0) + i4 >> 2] = HEAP32[i3 >> 2];
   i11 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
   i11 = HEAP32[i6 >> 2] | 0;
   if (((HEAP32[i11 + 16 >> 2] | 0) - (HEAP32[i11 + 24 >> 2] | 0) | 0) != (0 - (HEAP32[i11 + 20 >> 2] | 0) | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
    i11 = 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i7 = __Znwj(32) | 0;
   i3 = i2 + 8 | 0;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i11 = i2 + 16 | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i10 = i8;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = i5;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = 0;
   i4 = 1 << 31 - (Math_clz32((i4 << 1) + -1 | 0) | 0);
   i10 = i7 + 16 | 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i8, 0, gb + 584872 | 0, 112) | 0;
   HEAP8[i7 + 4 >> 0] = 1;
   i4 = i8;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i8 = i7 + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = i5;
   HEAP32[i7 + 28 >> 2] = 0;
   HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] = i7;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 case 0:
  {
   i11 = 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 default:
  {
   i11 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
   i11 = HEAP32[i6 >> 2] | 0;
   if (((HEAP32[i11 + 16 >> 2] | 0) - (HEAP32[i11 + 24 >> 2] | 0) | 0) == (0 - (HEAP32[i11 + 20 >> 2] | 0) | 0)) if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
    i7 = __Znwj(32) | 0;
    i1 = i2 + 8 | 0;
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    i11 = i2 + 16 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i10 = i8;
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = i5;
    HEAP32[i7 + 20 >> 2] = 0;
    HEAP32[i7 + 24 >> 2] = 0;
    i4 = 1 << 31 - (Math_clz32((i4 << 1) + -1 | 0) | 0);
    i10 = i7 + 16 | 0;
    HEAP32[i10 >> 2] = i4;
    HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i8, 0, gb + 584872 | 0, 112) | 0;
    HEAP8[i7 + 4 >> 0] = 1;
    i4 = i8;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i8 = i7 + 8 | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i8 + 4 >> 2] = i5;
    HEAP32[i7 + 28 >> 2] = 0;
    HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] = i7;
    HEAP32[i6 >> 2] = i7;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
   }
   i11 = __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_(i2, i3) | 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZL12edgeEdgeDistRN5physx6PxVec3ES1_RKS0_S3_S3_S3_(i19, i20, f15, f16, f17, f11, f12, f13, i18, i14) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 f15 = Math_fround(f15);
 f16 = Math_fround(f16);
 f17 = Math_fround(f17);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 i18 = i18 | 0;
 i14 = i14 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f24 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f15);
 i9 = i18 + 4 | 0;
 f22 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f16);
 i10 = i18 + 8 | 0;
 f1 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f17);
 f4 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13));
 f23 = Math_fround(HEAPF32[i14 >> 2]);
 f2 = Math_fround(f23 * f23);
 i7 = i14 + 4 | 0;
 f21 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f21 * f21));
 i8 = i14 + 8 | 0;
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f3 * f3));
 f5 = Math_fround(Math_fround(Math_fround(f23 * f11) + Math_fround(f21 * f12)) + Math_fround(f3 * f13));
 f6 = Math_fround(Math_fround(Math_fround(f24 * f11) + Math_fround(f22 * f12)) + Math_fround(f1 * f13));
 f3 = Math_fround(Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * f21)) + Math_fround(f1 * f3));
 f1 = Math_fround(Math_fround(f4 * f2) - Math_fround(f5 * f5));
 if (f1 != Math_fround(0.0)) {
  f1 = Math_fround(Math_fround(Math_fround(f6 * f2) - Math_fround(f3 * f5)) / f1);
  if (f1 < Math_fround(0.0)) f1 = Math_fround(0.0); else if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(0.0);
 do if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(Math_fround(f5 * f1) - f3) / f2);
  if (f2 < Math_fround(0.0)) {
   if (!(f4 != Math_fround(0.0))) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(0.0);
    break;
   }
   f1 = Math_fround(f6 / f4);
   if (f1 < Math_fround(0.0)) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(0.0);
    break;
   }
   if (!(f1 > Math_fround(1.0))) {
    f2 = Math_fround(0.0);
    break;
   }
   f1 = Math_fround(1.0);
   f2 = Math_fround(0.0);
   break;
  }
  if (f2 > Math_fround(1.0)) if (f4 != Math_fround(0.0)) {
   f1 = Math_fround(Math_fround(f6 + f5) / f4);
   if (f1 < Math_fround(0.0)) {
    f1 = Math_fround(0.0);
    f2 = Math_fround(1.0);
   } else if (f1 > Math_fround(1.0)) {
    f1 = Math_fround(1.0);
    f2 = Math_fround(1.0);
   } else f2 = Math_fround(1.0);
  } else {
   f1 = Math_fround(0.0);
   f2 = Math_fround(1.0);
  }
 } else if (f4 != Math_fround(0.0)) {
  f1 = Math_fround(f6 / f4);
  if (f1 < Math_fround(0.0)) {
   f1 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  } else if (f1 > Math_fround(1.0)) {
   f1 = Math_fround(1.0);
   f2 = Math_fround(0.0);
  } else f2 = Math_fround(0.0);
 } else {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } while (0);
 f23 = Math_fround(Math_fround(f1 * f12) + f16);
 f22 = Math_fround(Math_fround(f1 * f13) + f17);
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(f1 * f11) + f15);
 HEAPF32[i19 + 4 >> 2] = f23;
 HEAPF32[i19 + 8 >> 2] = f22;
 f22 = Math_fround(f2 * Math_fround(HEAPF32[i14 >> 2]));
 f23 = Math_fround(f2 * Math_fround(HEAPF32[i7 >> 2]));
 f24 = Math_fround(f2 * Math_fround(HEAPF32[i8 >> 2]));
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i18 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i9 >> 2]));
 f24 = Math_fround(f24 + Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i20 >> 2] = f22;
 HEAPF32[i20 + 4 >> 2] = f23;
 HEAPF32[i20 + 8 >> 2] = f24;
 return;
}

function __Z4swapR10VertexDataS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i7 = i1 + 4 | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 8 | 0;
 i4 = i2 + 8 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i4 = i1 + 12 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + 16 | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 20 | 0;
 i4 = i2 + 20 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i4 = i1 + 24 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + 28 | 0;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i4;
 i5 = i1 + 32 | 0;
 i4 = i2 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i4 = i1 + 44 | 0;
 i5 = i2 + 44 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i5 = i1 + 56 | 0;
 i4 = i2 + 56 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i4 = i1 + 68 | 0;
 i5 = i2 + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i5 = i1 + 88 | 0;
 i6 = i2 + 88 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 80 | 0;
 i4 = i2 + 80 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 92 | 0;
 i5 = i2 + 92 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 96 | 0;
 i6 = i2 + 96 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 84 | 0;
 i4 = i2 + 84 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 100 | 0;
 i2 = i2 + 100 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i1;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmPKwSC_(i8, i15, i9, i10, i11, i1, i12) {
 i8 = i8 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 4 | 0;
 i13 = i16;
 i2 = __ZNKSt3__28ios_base6getlocEv(i9) | 0;
 HEAP32[i7 >> 2] = i2;
 __THREW__ = 0;
 i14 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474588 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i16 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  ___resumeException(i16 | 0);
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
 L4 : while (1) {
  if ((i1 | 0) == (i12 | 0)) {
   i2 = 35;
   break;
  }
  if ((mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i14 | 0, HEAP32[i1 >> 2] | 0, 0) | 0) << 24 >> 24 == 37) {
   i6 = i1 + 4 | 0;
   if ((i6 | 0) == (i12 | 0)) {
    i2 = 6;
    break;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i14 | 0, HEAP32[i6 >> 2] | 0, 0) | 0;
   switch (i2 << 24 >> 24) {
   case 79:
   case 69:
    {
     i4 = i1 + 8 | 0;
     if ((i4 | 0) == (i12 | 0)) {
      i2 = 15;
      break L4;
     }
     i3 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i14 | 0, HEAP32[i4 >> 2] | 0, 0) | 0;
     i1 = i4;
     break;
    }
   default:
    {
     i3 = i2;
     i2 = 0;
     i1 = i6;
    }
   }
   i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 >> 2] = mftCall_iiiiiiii(i6 | 0, i8 | 0, i7 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0, i2 | 0) | 0;
  } else {
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3) {
    i4 = i3 + 24 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) i2 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i2 | 0) | 0; else {
     HEAP32[i4 >> 2] = i5 + 4;
     HEAP32[i5 >> 2] = i2;
    }
    if ((i2 | 0) == -1) HEAP32[i15 >> 2] = 0;
   }
  }
  i1 = i1 + 4 | 0;
 }
 do if ((i2 | 0) == 6) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = i1 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0) | 0; else {
    HEAP32[i3 >> 2] = i4 + 4;
    HEAP32[i4 >> 2] = i2;
   }
   if ((i2 | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i1 = 0;
   }
  }
 } else if ((i2 | 0) == 15) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i4 = i1 + 24 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i5 = i1 + 28 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0) | 0; else {
    HEAP32[i4 >> 2] = i3 + 4;
    HEAP32[i3 >> 2] = i2;
   }
   if ((i2 | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i1 = 0;
    break;
   }
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0) | 0; else {
    HEAP32[i4 >> 2] = i3 + 4;
    HEAP32[i3 >> 2] = i2;
   }
   if ((i2 | 0) == -1) {
    HEAP32[i15 >> 2] = 0;
    i1 = 0;
   }
  }
 } else if ((i2 | 0) == 35) i1 = HEAP32[i15 >> 2] | 0; while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE6createERS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i9 = i12 + 24 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i5 = i11;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i4 | 0, i5 | 0, -1, ~i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 8 >> 2] | 0;
   i3 = i12 + 12 | 0;
   while (1) {
    i13 = i6 + (i2 << 4) | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i4 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i5 | 0) : 0) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i13 = i6 + (i1 << 4) | 0;
   return i13 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 20 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i13 = HEAP32[i11 >> 2] | 0;
  i13 = _i64Add(i13 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i13 | 0) | 0;
  i11 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i13 | 0, i11 | 0, 22) | 0;
  i13 = i10 ^ i13;
  i11 = (getTempRet0() | 0) ^ i11;
  i10 = _bitshift64Shl(i13 | 0, i11 | 0, 13) | 0;
  i10 = _i64Add(i13 | 0, i11 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i13 ^ i10 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i11 | 0, i10 | 0, 15) | 0;
  i11 = i13 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i13 = _bitshift64Shl(i11 | 0, i10 | 0, 27) | 0;
  i13 = _i64Add(i11 | 0, i10 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i13 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i1 = (i11 ^ i13) & i1 + -1;
 }
 i11 = i12 + 32 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i13 + 1;
 i11 = (HEAP32[i12 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i13;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i13 = (HEAP32[i12 + 8 >> 2] | 0) + (i13 << 4) | 0;
 return i13 | 0;
}

function __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i1, i11, i12, i2, i13, i14, i15, i3) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 >> 2] = i2;
 if (!(i3 & 4)) i2 = i11; else {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i11;
  if ((i2 - i1 | 0) > 2) if ((HEAP8[i1 >> 0] | 0) == -17) if ((HEAP8[i1 + 1 >> 0] | 0) == -69) if ((HEAP8[i1 + 2 >> 0] | 0) == -65) HEAP32[i12 >> 2] = i1 + 3;
 }
 i9 = i13;
 L9 : while (1) {
  i5 = HEAP32[i12 >> 2] | 0;
  i1 = i5 >>> 0 < i11 >>> 0;
  if (!i1) {
   i16 = 41;
   break;
  }
  i10 = HEAP32[i14 >> 2] | 0;
  if (i10 >>> 0 >= i13 >>> 0) {
   i16 = 41;
   break;
  }
  i4 = HEAP8[i5 >> 0] | 0;
  i8 = i4 & 255;
  if (i8 >>> 0 > i15 >>> 0) {
   i1 = 2;
   break;
  }
  do if (i4 << 24 >> 24 > -1) {
   HEAP16[i10 >> 1] = i4 & 255;
   HEAP32[i12 >> 2] = i5 + 1;
  } else {
   if ((i4 & 255) < 194) {
    i1 = 2;
    break L9;
   }
   if ((i4 & 255) < 224) {
    if ((i2 - i5 | 0) < 2) {
     i1 = 1;
     break L9;
    }
    i1 = HEAPU8[i5 + 1 >> 0] | 0;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = i1 & 63 | i8 << 6 & 1984;
    if (i1 >>> 0 > i15 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP16[i10 >> 1] = i1;
    HEAP32[i12 >> 2] = i5 + 2;
    break;
   }
   if ((i4 & 255) < 240) {
    if ((i2 - i5 | 0) < 3) {
     i1 = 1;
     break L9;
    }
    i3 = HEAP8[i5 + 1 >> 0] | 0;
    i1 = HEAP8[i5 + 2 >> 0] | 0;
    switch (i4 << 24 >> 24) {
    case -32:
     {
      if ((i3 & -32) << 24 >> 24 != -96) {
       i1 = 2;
       break L9;
      }
      break;
     }
    case -19:
     {
      if ((i3 & -32) << 24 >> 24 != -128) {
       i1 = 2;
       break L9;
      }
      break;
     }
    default:
     if ((i3 & -64) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
    }
    i1 = i1 & 255;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = (i3 & 255) << 6 & 4032 | i8 << 12 | i1 & 63;
    if ((i1 & 65535) >>> 0 > i15 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP16[i10 >> 1] = i1;
    HEAP32[i12 >> 2] = i5 + 3;
    break;
   }
   if ((i4 & 255) >= 245) {
    i1 = 2;
    break L9;
   }
   if ((i2 - i5 | 0) < 4) {
    i1 = 1;
    break L9;
   }
   i6 = HEAP8[i5 + 1 >> 0] | 0;
   i1 = HEAP8[i5 + 2 >> 0] | 0;
   i3 = HEAP8[i5 + 3 >> 0] | 0;
   switch (i4 << 24 >> 24) {
   case -16:
    {
     if ((i6 + 112 & 255) >= 48) {
      i1 = 2;
      break L9;
     }
     break;
    }
   case -12:
    {
     if ((i6 & -16) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
     break;
    }
   default:
    if ((i6 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     break L9;
    }
   }
   i7 = i1 & 255;
   if ((i7 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   i1 = i3 & 255;
   if ((i1 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   if ((i9 - i10 | 0) < 4) {
    i1 = 1;
    break L9;
   }
   i5 = i8 & 7;
   i3 = i6 & 255;
   i4 = i7 << 6;
   i1 = i1 & 63;
   if ((i3 << 12 & 258048 | i5 << 18 | i4 & 4032 | i1) >>> 0 > i15 >>> 0) {
    i1 = 2;
    break L9;
   }
   HEAP16[i10 >> 1] = i3 << 2 & 60 | i7 >>> 4 & 3 | ((i3 >>> 4 & 3 | i5 << 2) << 6) + 16320 | 55296;
   i10 = i10 + 2 | 0;
   HEAP32[i14 >> 2] = i10;
   HEAP16[i10 >> 1] = i1 | i4 & 960 | 56320;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 4;
  } while (0);
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 2;
 }
 if ((i16 | 0) == 41) i1 = i1 & 1;
 return i1 | 0;
}

function runPostSets101() {
 HEAP32[gb + 96656 >> 2] = fb + 653;
 HEAP32[gb + 96660 >> 2] = fb + 1032;
 HEAP32[gb + 96664 >> 2] = fb + 654;
 HEAP32[gb + 96668 >> 2] = fb + 1033;
 HEAP32[gb + 96672 >> 2] = fb + 655;
 HEAP32[gb + 96676 >> 2] = fb + 656;
 HEAP32[gb + 96680 >> 2] = fb + 1;
 HEAP32[gb + 96684 >> 2] = fb + 1;
 HEAP32[gb + 96688 >> 2] = fb + 1;
 HEAP32[gb + 96692 >> 2] = fb + 1;
 HEAP32[gb + 96696 >> 2] = fb + 1;
 HEAP32[gb + 96700 >> 2] = fb + 1;
 HEAP32[gb + 96704 >> 2] = fb + 1;
 HEAP32[gb + 96708 >> 2] = fb + 1;
 HEAP32[gb + 96712 >> 2] = fb + 1;
 HEAP32[gb + 96716 >> 2] = fb + 1;
 HEAP32[gb + 96720 >> 2] = fb + 1;
 HEAP32[gb + 96724 >> 2] = fb + 1;
 HEAP32[gb + 96728 >> 2] = fb + 1;
 HEAP32[gb + 96732 >> 2] = fb + 1;
 HEAP32[gb + 96736 >> 2] = fb + 1;
 HEAP32[gb + 96740 >> 2] = fb + 1;
 HEAP32[gb + 96744 >> 2] = fb + 1;
 HEAP32[gb + 96748 >> 2] = fb + 1;
 HEAP32[gb + 96752 >> 2] = fb + 1;
 HEAP32[gb + 96756 >> 2] = fb + 1;
 HEAP32[gb + 96760 >> 2] = fb + 1;
 HEAP32[gb + 96764 >> 2] = fb + 1;
 HEAP32[gb + 96768 >> 2] = fb + 1;
 HEAP32[gb + 96772 >> 2] = fb + 1;
 HEAP32[gb + 96776 >> 2] = fb + 1;
 HEAP32[gb + 96780 >> 2] = fb + 1;
 HEAP32[gb + 96784 >> 2] = fb + 1;
 HEAP32[gb + 96788 >> 2] = fb + 1;
 HEAP32[gb + 96792 >> 2] = fb + 1;
 HEAP32[gb + 96796 >> 2] = fb + 1;
 HEAP32[gb + 96800 >> 2] = fb + 1;
 HEAP32[gb + 96804 >> 2] = fb + 1;
 HEAP32[gb + 96808 >> 2] = fb + 1;
 HEAP32[gb + 96812 >> 2] = fb + 1;
 HEAP32[gb + 96816 >> 2] = fb + 1;
 HEAP32[gb + 96820 >> 2] = fb + 1;
 HEAP32[gb + 96824 >> 2] = fb + 1;
 HEAP32[gb + 96828 >> 2] = fb + 1;
 HEAP32[gb + 96832 >> 2] = fb + 1;
 HEAP32[gb + 96836 >> 2] = fb + 1;
 HEAP32[gb + 96840 >> 2] = fb + 1;
 HEAP32[gb + 96844 >> 2] = fb + 1;
 HEAP32[gb + 96848 >> 2] = fb + 1;
 HEAP32[gb + 96852 >> 2] = fb + 1;
 HEAP32[gb + 96856 >> 2] = fb + 1;
 HEAP32[gb + 96860 >> 2] = fb + 1;
 HEAP32[gb + 96864 >> 2] = fb + 1;
 HEAP32[gb + 96868 >> 2] = fb + 1038;
 HEAP32[gb + 96872 >> 2] = fb + 1039;
 HEAP32[gb + 96884 >> 2] = fb + 1;
 HEAP32[gb + 96888 >> 2] = fb + 666;
 HEAP32[gb + 96892 >> 2] = fb + 456;
 HEAP32[gb + 96896 >> 2] = fb + 1270;
 HEAP32[gb + 96900 >> 2] = fb + 1362;
 HEAP32[gb + 96904 >> 2] = fb + 300;
 HEAP32[gb + 96908 >> 2] = fb + 1;
 HEAP32[gb + 96912 >> 2] = fb + 1;
 HEAP32[gb + 96916 >> 2] = fb + 1;
 HEAP32[gb + 96920 >> 2] = fb + 1;
 HEAP32[gb + 96924 >> 2] = fb + 1;
 HEAP32[gb + 96928 >> 2] = fb + 1;
 HEAP32[gb + 96932 >> 2] = fb + 1;
 HEAP32[gb + 96936 >> 2] = fb + 1;
 HEAP32[gb + 96940 >> 2] = fb + 1;
 HEAP32[gb + 96944 >> 2] = fb + 1;
 HEAP32[gb + 96948 >> 2] = fb + 1;
 HEAP32[gb + 96952 >> 2] = fb + 1;
 HEAP32[gb + 96956 >> 2] = fb + 1;
 HEAP32[gb + 96960 >> 2] = fb + 1;
 HEAP32[gb + 96964 >> 2] = fb + 1;
 HEAP32[gb + 96968 >> 2] = fb + 1;
 HEAP32[gb + 96972 >> 2] = fb + 1;
 HEAP32[gb + 96976 >> 2] = fb + 1;
 HEAP32[gb + 96980 >> 2] = fb + 1;
 HEAP32[gb + 96984 >> 2] = fb + 1;
 HEAP32[gb + 96988 >> 2] = fb + 1;
 HEAP32[gb + 96992 >> 2] = fb + 1;
 HEAP32[gb + 96996 >> 2] = fb + 1;
 HEAP32[gb + 97e3 >> 2] = fb + 1;
 HEAP32[gb + 97004 >> 2] = fb + 1;
 HEAP32[gb + 97008 >> 2] = fb + 1;
 HEAP32[gb + 97012 >> 2] = fb + 1;
 HEAP32[gb + 97016 >> 2] = fb + 1;
 HEAP32[gb + 97020 >> 2] = fb + 1;
 HEAP32[gb + 97024 >> 2] = fb + 1;
 HEAP32[gb + 97028 >> 2] = fb + 1;
 HEAP32[gb + 97032 >> 2] = fb + 1;
 HEAP32[gb + 97036 >> 2] = fb + 1;
 HEAP32[gb + 97040 >> 2] = fb + 1;
 HEAP32[gb + 97044 >> 2] = fb + 1;
 HEAP32[gb + 97048 >> 2] = fb + 1;
 HEAP32[gb + 97052 >> 2] = fb + 1;
 HEAP32[gb + 97056 >> 2] = fb + 1;
 HEAP32[gb + 97060 >> 2] = fb + 1;
 runPostSets102();
}

function __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i18, i19, i6) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i20 = HEAP32[i19 + 224 >> 2] | 0;
 L1 : do if (!i20) i1 = 0; else {
  f4 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i6 + 12 >> 2]);
  i1 = 0;
  do {
   f17 = Math_fround(HEAPF32[i19 + 192 + (i1 << 2) >> 2]);
   if (!(f4 > f17 & f5 > f17 & f2 > f17 & f3 > f17)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i20 >>> 0);
 } while (0);
 i14 = i18 + 12 | 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i15 = i18 + 8 | 0;
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i16 = i18 + 4 | 0;
 HEAPF32[i16 >> 2] = Math_fround(1.0);
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 if (i1 >>> 0 >= i20 >>> 0) return;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 i7 = 0;
 i8 = 0;
 i9 = 0;
 i6 = 0;
 i10 = 1065353216;
 i11 = 1065353216;
 i12 = 1065353216;
 i13 = 1065353216;
 while (1) {
  if ((i9 & i7 & i6 & i8 | 0) <= -1) {
   i1 = 11;
   break;
  }
  if (!i1) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i19 + 192 + (i1 + -1 << 2) >> 2]);
  f32 = Math_fround(f4 - f2);
  f31 = Math_fround(f5 - f2);
  f30 = Math_fround(f17 - f2);
  f28 = Math_fround(f3 - f2);
  f29 = Math_fround(HEAPF32[i19 + 128 + (i1 << 2) >> 2]);
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) >> 2]);
  f26 = Math_fround(f32 * f27);
  f25 = Math_fround(f31 * f27);
  f24 = Math_fround(f30 * f27);
  f27 = Math_fround(f28 * f27);
  f2 = Math_fround(HEAPF32[i19 + (i1 << 4) + 4 >> 2]);
  f26 = Math_fround(f32 * Math_fround(f26 + f2));
  f25 = Math_fround(f31 * Math_fround(f25 + f2));
  f24 = Math_fround(f30 * Math_fround(f24 + f2));
  f2 = Math_fround(f28 * Math_fround(f27 + f2));
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) + 8 >> 2]);
  f26 = Math_fround(f32 * Math_fround(f27 + f26));
  f25 = Math_fround(f31 * Math_fround(f27 + f25));
  f24 = Math_fround(f30 * Math_fround(f27 + f24));
  f2 = Math_fround(f28 * Math_fround(f27 + f2));
  f27 = Math_fround(HEAPF32[i19 + (i1 << 4) + 12 >> 2]);
  f26 = Math_fround(f29 + Math_fround(f32 * Math_fround(f27 + f26)));
  f25 = Math_fround(f29 + Math_fround(f31 * Math_fround(f27 + f25)));
  f24 = Math_fround(f29 + Math_fround(f30 * Math_fround(f27 + f24)));
  f2 = Math_fround(f29 + Math_fround(f28 * Math_fround(f27 + f2)));
  i23 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i21 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = i23 & ~i7 | i13 & i7;
  i10 = i22 & ~i9 | i10 & i9;
  i11 = i21 & ~i6 | i11 & i6;
  i12 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & ~i8 | i12 & i8;
  HEAP32[i18 >> 2] = i13;
  HEAP32[i16 >> 2] = i10;
  HEAP32[i15 >> 2] = i11;
  HEAP32[i14 >> 2] = i12;
  f2 = Math_fround(HEAPF32[i19 + 192 + (i1 << 2) >> 2]);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i20 >>> 0) {
   i1 = 11;
   break;
  } else {
   i7 = (f4 <= f2) << 31 >> 31;
   i8 = (f3 <= f2) << 31 >> 31;
   i9 = (f5 <= f2) << 31 >> 31;
   i6 = (f17 <= f2) << 31 >> 31;
  }
 }
 if ((i1 | 0) == 11) return;
}

function __ZN8Animator15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105016 | 0, fb + 918 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105796 | 0, fb + 919 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105816 | 0, fb + 920 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105836 | 0, fb + 921 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105876 | 0, fb + 922 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67008 | 0, gb + 1105256 | 0, fb + 923 | 0, gb + 29020 | 0);
 __ZN7mecanim9animation18ControllerConstant15InitializeClassEv();
 __ZN7mecanim9animation14AvatarConstant15InitializeClassEv();
 __ZN7mecanim12statemachine13StateConstant15InitializeClassEv();
 __ZN7mecanim13crc32_table_tILj79764919EE10init_tableEv();
 __ZN7mecanim9animation26InitializeMuscleClipTablesEv();
 __ZN10HumanTrait15InitializeClassEv();
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(20, fb + 307 | 0, gb + 908316 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(21, fb + 307 | 0, gb + 908329 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(22, fb + 307 | 0, gb + 908341 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(23, fb + 307 | 0, gb + 908355 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(24, fb + 307 | 0, gb + 908367 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(25, fb + 308 | 0, gb + 908377 | 0);
 __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(26, fb + 308 | 0, gb + 908397 | 0);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 <= 63) {
  i1 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 772 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 772 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i2 + 772 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 308;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i1, gb + 1048800 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 + 1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i2 + 772 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 772 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i2 + 772 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 308;
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue19GetEventsAsJsonDataEjR8UnityStrPj(i8, i1, i10, i11) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 136 | 0;
 i13 = i16;
 i14 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = gb + 77468 + 12;
 i15 = i13 + 56 | 0;
 HEAP32[i15 >> 2] = gb + 77468 + 32;
 __ZNSt3__28ios_base4initEPv(i13 + 56 | 0, i14);
 HEAP32[i13 + 128 >> 2] = 0;
 HEAP32[i13 + 132 >> 2] = -1;
 HEAP32[i13 >> 2] = gb + 77508 + 12;
 HEAP32[i13 + 56 >> 2] = gb + 77508 + 32;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i14);
 HEAP32[i14 >> 2] = gb + 77548 + 8;
 i9 = i13 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i13 + 52 >> 2] = 16;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i14, i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i3 = HEAP32[i8 >> 2] | 0;
 i7 = (HEAP32[i8 + 4 >> 2] | 0) - i3 >> 2;
 i7 = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
 L1 : do if (!i7) {
  i3 = 0;
  i2 = 0;
 } else {
  i2 = 0;
  i6 = 0;
  i5 = 0;
  i1 = i3;
  while (1) {
   i4 = HEAP32[i1 + (i6 << 2) >> 2] | 0;
   i1 = HEAP8[i4 + 11 >> 0] | 0;
   i3 = i1 << 24 >> 24 < 0;
   if (i3) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = i1 & 255;
   if (!i1) i3 = i5; else {
    if (i3) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
    __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i13, i1, _strlen(i1) | 0) | 0;
    HEAP8[i12 >> 0] = 10;
    __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i13, i12, 1) | 0;
    i3 = i5 + 1 | 0;
    i2 = (HEAP32[i4 + 32 >> 2] & 1) + i2 | 0;
   }
   i1 = i6 + 1 | 0;
   if (i1 >>> 0 >= i7 >>> 0) break L1;
   i6 = i1;
   i5 = i3;
   i1 = HEAP32[i8 >> 2] | 0;
  }
 } while (0);
 __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i12, i14);
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i8 = i7 << 24 >> 24 < 0;
 i6 = i8 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i8 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 i8 = i10 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 if (i4) i5 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  i8 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i10, i5, i7 - i5 | 0, i8, 0, i8, i7, i6);
 } else {
  i1 = i4 ? HEAP32[i10 >> 2] | 0 : i10;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   HEAP32[i10 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i8 >> 0] = i7;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = gb + 77508 + 12;
 HEAP32[i15 >> 2] = gb + 77508 + 32;
 HEAP32[i14 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i14);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i13, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i15);
 STACKTOP = i16;
 return i3 | 0;
}

function __Z37RegisterModuleClasses_ParticlesLegacyv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1133;
 HEAP32[i2 + 8 >> 2] = gb + 1048111;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 12;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190916;
 HEAP32[i2 + 44 >> 2] = fb + 438;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 439;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 190576;
 HEAP32[i2 + 4 >> 2] = fb + 1131;
 HEAP32[i2 + 8 >> 2] = gb + 1047658;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 15;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190404;
 HEAP32[i2 + 44 >> 2] = fb + 433;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 434;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 1135;
 HEAP32[i2 + 8 >> 2] = gb + 1048432;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 26;
 HEAP32[i2 + 20 >> 2] = 380;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 191192;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1136;
 HEAP32[i2 + 8 >> 2] = gb + 1048607;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 76;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 191360;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 190576;
 HEAP32[i2 + 4 >> 2] = fb + 1132;
 HEAP32[i2 + 8 >> 2] = gb + 1047979;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 87;
 HEAP32[i2 + 20 >> 2] = 240;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190748;
 HEAP32[i2 + 44 >> 2] = fb + 436;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 437;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1134;
 HEAP32[i2 + 8 >> 2] = gb + 1047963;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 88;
 HEAP32[i2 + 20 >> 2] = 220;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190576;
 HEAP32[i2 + 44 >> 2] = fb + 442;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 443;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZN11TrailModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619503 | 0, i5, i1 + 8 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619251 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619260 | 0, i5, i1 + 276 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619278 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 280 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619290 | 0, i5, i1 + 284 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619301 | 0, i5, i1 + 285 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619318 | 0, i5, i1 + 286 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619335 | 0, i5, i1 + 287 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619355 | 0, i5, i1 + 288 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i3 = i1 + 292 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619376 | 0, gb + 620954 | 0, i3, 0);
 __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 448 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619394 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 712 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619409 | 0, gb + 620954 | 0, i1, 0);
 __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i9 + 28 | 0;
 i12 = i9 + 40 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i8 = i9 + 44 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i5;
 i7 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i2 = __Znwj(1) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i9 + 32 >> 2] = i2;
   }
   i1 = HEAP32[i9 + 48 >> 2] | 0;
  } else {
   i1 = i2 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i7 - i5 | 0;
  i7 = i5 + 24 | 0;
  i7 = i1 >>> 0 < i7 >>> 0 ? i7 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i7, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i8 >> 2] = i6 + i7;
 }
 HEAP32[i12 >> 2] = i1 + 24;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 4;
 i1 = HEAP32[i11 >> 2] | 0;
 L11 : while (1) {
  i2 = i1;
  switch (HEAP8[i2 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L11;
  }
  i1 = i2 + 1 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 if ((HEAP8[i2 >> 0] | 0) == 93) {
  HEAP32[i11 >> 2] = i2 + 1;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 + -8 >> 2] = 4;
  HEAP32[i12 + -24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i12 + -16 >> 2] = 0;
  HEAP32[i12 + -20 >> 2] = 0;
  return;
 }
 __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9);
 i4 = i10 + 24 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) i3 = 0; else return;
 L21 : while (1) {
  i1 = HEAP32[i11 >> 2] | 0;
  L23 : while (1) {
   switch (HEAP8[i1 >> 0] | 0) {
   case 9:
   case 13:
   case 10:
   case 32:
    break;
   default:
    break L23;
   }
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
  i2 = i1 + 1 | 0;
  HEAP32[i11 >> 2] = i2;
  switch (HEAP8[i1 >> 0] | 0) {
  case 93:
   {
    i1 = 21;
    break L21;
   }
  case 44:
   {
    i1 = i2;
    break;
   }
  default:
   {
    i1 = 22;
    break L21;
   }
  }
  L27 : while (1) {
   i2 = i1;
   switch (HEAP8[i2 >> 0] | 0) {
   case 9:
   case 13:
   case 10:
   case 32:
    break;
   default:
    break L27;
   }
   i1 = i2 + 1 | 0;
  }
  HEAP32[i11 >> 2] = i1;
  __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9);
  if (HEAP32[i4 >> 2] | 0) {
   i1 = 23;
   break;
  }
 }
 if ((i1 | 0) == 21) {
  i10 = (HEAP32[i12 >> 2] | 0) + (Math_imul(i3, -24) | 0) | 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i10 + -24 | 0;
  HEAP32[i12 + 16 >> 2] = 4;
  i11 = i3 * 24 | 0;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i12 >> 2] = i9;
  _memcpy(i9 | 0, i10 | 0, i11 | 0) | 0;
  HEAP32[i12 + 8 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i3;
  return;
 } else if ((i1 | 0) == 22) {
  i12 = i2 - (HEAP32[i11 + 4 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = 7;
  HEAP32[i10 + 28 >> 2] = i12;
  return;
 } else if ((i1 | 0) == 23) return;
}

function __ZN9Heightmap8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 4 | 0;
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932165 | 0, i9, i1 + 4 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37240 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932175 | 0, i9, i1 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932194 | 0, i9, i1 + 44 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i6, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932232 | 0, i7, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932244 | 0, i6, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 88 | 0, gb + 932253 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN13WheelCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 60 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 64 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 68 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 88 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 92 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN18WheelFrictionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 104 | 0, i6);
 __ZN18WheelFrictionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 124 | 0, i6);
 i1 = i5 + 41 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function _unity_z_tr_align(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 5820 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 5816 | 0;
 i1 = HEAPU16[i7 >> 1] | 0 | 2 << i3;
 i2 = i1 & 65535;
 HEAP16[i7 >> 1] = i2;
 if ((i3 | 0) > 13) {
  i3 = i5 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i4 + 1;
  i2 = i5 + 8 | 0;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = i1;
  i4 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = i4;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = 2 >>> (16 - i1 | 0) & 65535;
  HEAP16[i7 >> 1] = i2;
  i1 = i1 + -13 | 0;
 } else i1 = i3 + 3 | 0;
 HEAP32[i6 >> 2] = i1;
 if ((i1 | 0) > 9) {
  i3 = i5 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  i4 = i5 + 8 | 0;
  HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = i2;
  i2 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = i2;
  HEAP16[i7 >> 1] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + -9 | 0;
  i2 = 0;
 } else i1 = i1 + 7 | 0;
 HEAP32[i6 >> 2] = i1;
 if ((i1 | 0) == 16) {
  i3 = i5 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  i4 = i5 + 8 | 0;
  HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = i2;
  i2 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = i2;
  HEAP16[i7 >> 1] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
  i2 = 0;
 } else if ((i1 | 0) > 7) {
  i4 = i5 + 20 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i5 + 8 >> 2] | 0) + i1 >> 0] = i2;
  i2 = (HEAPU16[i7 >> 1] | 0) >>> 8;
  HEAP16[i7 >> 1] = i2;
  i1 = (HEAP32[i6 >> 2] | 0) + -8 | 0;
  HEAP32[i6 >> 2] = i1;
 }
 i4 = i5 + 5812 | 0;
 if ((11 - i1 + (HEAP32[i4 >> 2] | 0) | 0) >= 9) {
  HEAP32[i4 >> 2] = 7;
  return;
 }
 i2 = i2 & 65535 | 2 << i1;
 HEAP16[i7 >> 1] = i2;
 if ((i1 | 0) > 13) {
  i8 = i5 + 20 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i3 + 1;
  i1 = i5 + 8 | 0;
  HEAP8[(HEAP32[i1 >> 2] | 0) + i3 >> 0] = i2;
  i2 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i3 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i3 + 1;
  HEAP8[(HEAP32[i1 >> 2] | 0) + i3 >> 0] = i2;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = 2 >>> (16 - i3 | 0);
  HEAP16[i7 >> 1] = i2;
  i3 = i3 + -13 | 0;
 } else i3 = i1 + 3 | 0;
 i1 = i2 & 255;
 HEAP32[i6 >> 2] = i3;
 if ((i3 | 0) > 9) {
  i3 = i5 + 20 | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i8 + 1;
  i2 = i5 + 8 | 0;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i8 >> 0] = i1;
  i8 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = i8;
  HEAP16[i7 >> 1] = 0;
  i1 = 0;
  i2 = (HEAP32[i6 >> 2] | 0) + -9 | 0;
 } else i2 = i3 + 7 | 0;
 HEAP32[i6 >> 2] = i2;
 if ((i2 | 0) == 16) {
  i2 = i5 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i3 + 1;
  i5 = i5 + 8 | 0;
  HEAP8[(HEAP32[i5 >> 2] | 0) + i3 >> 0] = i1;
  i3 = (HEAPU16[i7 >> 1] | 0) >>> 8 & 255;
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i8 + 1;
  HEAP8[(HEAP32[i5 >> 2] | 0) + i8 >> 0] = i3;
  HEAP16[i7 >> 1] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i4 >> 2] = 7;
  return;
 }
 if ((i2 | 0) <= 7) {
  HEAP32[i4 >> 2] = 7;
  return;
 }
 i3 = i5 + 20 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i8 + 1;
 HEAP8[(HEAP32[i5 + 8 >> 2] | 0) + i8 >> 0] = i1;
 HEAP16[i7 >> 1] = (HEAPU16[i7 >> 1] | 0) >>> 8;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -8;
 HEAP32[i4 >> 2] = 7;
 return;
}

function __ZN11TypeManager25InitializeDerivedFromInfoEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 8 | 0;
 i15 = i19;
 i12 = i19 + 16 | 0;
 i13 = gb + 64016 | 0;
 i11 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i15;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i15);
 i15 = i16;
 i13 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i11;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 i14 = __ZN11TypeManager7Builder5BuildERK14dense_hash_mapIiP4RTTINS_27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS5_4pairIKiS3_EEL18MemLabelIdentifier6ELi16EEE(i12, i8 + 120 | 0) | 0;
 i13 = i8 + 44 | 0;
 HEAP32[HEAP32[i13 >> 2] >> 2] = i14;
 HEAP32[i16 >> 2] = -2147483648;
 HEAP32[i16 + 4 >> 2] = 0;
 i14 = i8 + 4 | 0;
 __ZN13dynamic_arrayIN4RTTI15DerivedFromInfoELj4EE18resize_initializedEjRKS1_12ResizePolicy(i14, 365, i16, 1);
 i15 = i8 + 24 | 0;
 __ZN13dynamic_arrayIN4RTTI15DerivedFromInfoELj4EE18resize_initializedEjRKS1_12ResizePolicy(i15, 12, i16, 1);
 i16 = i8 + 148 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i17 = i8 + 152 | 0;
 i9 = HEAP32[i17 >> 2] | 0;
 i18 = i1 + (i9 << 3) | 0;
 L1 : do if (!i9) i7 = 8; else {
  i3 = HEAP32[i8 + 140 >> 2] | 0;
  i4 = i8 + 128 | 0;
  i5 = i8 + 124 | 0;
  i6 = i8 + 132 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    if (!(HEAP8[i4 >> 0] | 0)) {
     i7 = 8;
     break L1;
    }
    if (!(HEAP32[i5 >> 2] | 0)) {
     i7 = 8;
     break L1;
    }
    if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
     i7 = 8;
     break L1;
    }
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i18 | 0));
 } while (0);
 if ((i7 | 0) == 8) if ((i1 | 0) != (i18 | 0)) {
  i6 = i8 + 140 | 0;
  i7 = i8 + 128 | 0;
  i9 = i8 + 124 | 0;
  i5 = i8 + 132 | 0;
  do {
   i4 = i1 + 4 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!(HEAP8[i2 + 36 >> 0] | 0)) {
    i3 = i2 + 24 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) < 365) {
     i21 = i3;
     i20 = HEAP32[i21 + 4 >> 2] | 0;
     i8 = (HEAP32[i14 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i8 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i8 + 4 >> 2] = i20;
    } else {
     i2 = i2 + -1e5 | 0;
     if (i2 >>> 0 < 12) {
      i8 = i3;
      i20 = HEAP32[i8 + 4 >> 2] | 0;
      i21 = (HEAP32[i15 >> 2] | 0) + (i2 << 3) | 0;
      HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i21 + 4 >> 2] = i20;
     }
    }
    HEAP32[(HEAP32[i13 >> 2] | 0) + 4 + (HEAP32[i3 >> 2] << 2) >> 2] = HEAP32[i4 >> 2];
   }
   i1 = i1 + 8 | 0;
   L23 : do if ((i1 | 0) == (i18 | 0)) i1 = i18; else {
    i3 = HEAP32[i6 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i3 | 0) != (i2 | 0)) {
      if (!(HEAP8[i7 >> 0] | 0)) break L23;
      if (!(HEAP32[i9 >> 2] | 0)) break L23;
      if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) break L23;
     }
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i18 | 0)) {
      i1 = i18;
      break;
     }
    }
   } while (0);
  } while ((i1 | 0) != ((HEAP32[i16 >> 2] | 0) + (HEAP32[i17 >> 2] << 3) | 0));
 }
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb(i17, f2, f11, i19, i12, f20, f21, i22) {
 i17 = i17 | 0;
 f2 = Math_fround(f2);
 f11 = Math_fround(f11);
 i19 = i19 | 0;
 i12 = i12 | 0;
 f20 = Math_fround(f20);
 f21 = Math_fround(f21);
 i22 = i22 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i18 = 0, i23 = 0;
 i6 = HEAP32[i17 + 96 >> 2] | 0;
 i10 = i6 + 196 | 0;
 i18 = i17 + 56 | 0;
 i1 = HEAP16[i18 >> 1] | 0;
 i13 = i17 + 12 | 0;
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 if ((i1 & 1536) == 512) {
  i5 = HEAP32[i10 >> 2] | 0;
  i3 = (HEAP32[i6 + 200 >> 2] | 0) - i5 >> 6;
  L3 : do if (i19) {
   if (i3) {
    i4 = 0;
    while (1) {
     if (Math_fround(HEAPF32[i5 + (i4 << 6) >> 2]) >= f14) break;
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= i3 >>> 0) break L3;
    }
    HEAP32[i17 + 60 >> 2] = i4;
    i1 = i1 & -1537;
    HEAP16[i18 >> 1] = i1;
   }
  } else {
   do {
    i9 = i3;
    i3 = i3 + -1 | 0;
    if ((i9 | 0) <= 0) break L3;
   } while (!(Math_fround(HEAPF32[i5 + (i3 << 6) >> 2]) <= f14));
   HEAP32[i17 + 60 >> 2] = i3;
   i1 = i1 & -1537;
   HEAP16[i18 >> 1] = i1;
  } while (0);
  if ((i1 & 1536) == 512) HEAP16[i18 >> 1] = i1 & -1537 | 1024;
 }
 i7 = i17 + 40 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i17 + 60 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i23 = 1;
  return i23 | 0;
 }
 i4 = i6 + 200 | 0;
 i5 = i19 ? 1 : -1;
 L19 : do if (i19) {
  while (1) {
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) >= ((HEAP32[i4 >> 2] | 0) - i3 >> 6 | 0)) {
    i1 = 1;
    i3 = 28;
    break;
   }
   i3 = i3 + (i1 << 6) | 0;
   f2 = Math_fround(HEAPF32[i3 >> 2]);
   if (f2 > f11) {
    i1 = 1;
    i3 = 28;
    break;
   }
   __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo(i3, i12, i17, 0, 0) | 0;
   i3 = HEAP16[i18 >> 1] | 0;
   if ((i3 & 1536) == 512) {
    f15 = f2;
    i16 = i1;
    i23 = i3;
    break L19;
   }
   i1 = (HEAP32[i9 >> 2] | 0) + i5 | 0;
   HEAP32[i9 >> 2] = i1;
   if ((i1 | 0) < 0) {
    i1 = 1;
    i3 = 28;
    break;
   }
  }
  if ((i3 | 0) == 28) return i1 | 0;
 } else {
  while (1) {
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) >= ((HEAP32[i4 >> 2] | 0) - i3 >> 6 | 0)) {
    i1 = 1;
    i3 = 28;
    break;
   }
   i3 = i3 + (i1 << 6) | 0;
   f2 = Math_fround(HEAPF32[i3 >> 2]);
   if (f2 < f11) {
    i1 = 1;
    i3 = 28;
    break;
   }
   __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo(i3, i12, i17, 0, 0) | 0;
   i3 = HEAP16[i18 >> 1] | 0;
   if ((i3 & 1536) == 512) {
    f15 = f2;
    i16 = i1;
    i23 = i3;
    break L19;
   }
   i1 = (HEAP32[i9 >> 2] | 0) + i5 | 0;
   HEAP32[i9 >> 2] = i1;
   if ((i1 | 0) < 0) {
    i1 = 1;
    i3 = 28;
    break;
   }
  }
  if ((i3 | 0) == 28) return i1 | 0;
 } while (0);
 i6 = f8 == Math_fround(0.0);
 i10 = f8 > Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 i1 = f11 == Math_fround(0.0);
 i12 = f11 > Math_fround(0.0);
 if (((i6 ? 0 : i10 ? 1 : -1) | 0) == ((i1 ? 0 : i12 ? 1 : -1) | 0)) {
  i23 = 0;
  return i23 | 0;
 }
 if (!(Math_fround(HEAPF32[i13 >> 2]) == f14)) {
  i23 = 0;
  return i23 | 0;
 }
 f20 = Math_fround(f15 - f20);
 f14 = Math_fround(-f20);
 HEAPF64[i17 + 16 >> 3] = +Math_fround((i22 ? f14 : f20) + f21);
 HEAPF32[i13 >> 2] = f15;
 if (i1) {
  HEAP32[i9 >> 2] = i16;
  i1 = i23 | 1536;
 } else {
  HEAP32[i9 >> 2] = i16 + (i19 ? -1 : 1);
  i1 = i23 & -1537;
 }
 HEAP16[i18 >> 1] = i1;
 i23 = 0;
 return i23 | 0;
}

function __ZN14NavMeshManager17UnloadNavMeshDataEi(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 i14 = i19 + 28 | 0;
 i15 = i19 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 i16 = i14 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i14 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i9 = i13;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i12 = i18;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = i8;
 i12 = i11 + 136 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i9 = i8 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i7 = 0;
  i2 = i1;
  i6 = 0;
  while (1) {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i1 + (i7 << 3) >> 2] | 0) == (i10 | 0)) {
    i3 = i1 + (i7 << 3) + 4 | 0;
    i1 = i6 + 1 | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i1 >>> 0 > i5 >>> 0) {
     i2 = i4 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i18, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i2;
      HEAP32[i14 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i1;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i6 << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = HEAP32[i9 >> 2] | 0;
   } else i1 = i6;
   i7 = i7 + 1 | 0;
   if (i7 >>> 0 >= i2 >>> 0) break; else i6 = i1;
  }
  i5 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  i6 = i5 + 12 | 0;
  if (i2) {
   i1 = 0;
   do {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = i3 + (i1 << 3) | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i10 | 0)) {
     i2 = i2 + -1 | 0;
     i7 = i3 + (i2 << 3) | 0;
     i8 = HEAP32[i7 + 4 >> 2] | 0;
     i9 = i4;
     HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i9 + 4 >> 2] = i8;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
     i1 = i1 + -1 | 0;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
   i1 = HEAP32[i16 >> 2] | 0;
  }
  if (i1 | 0) {
   i2 = i15 + 12 | 0;
   i3 = i15 + 16 | 0;
   i4 = i15 + 4 | 0;
   i1 = 0;
   do {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
    i8 = i13;
    i9 = HEAP32[i8 + 4 >> 2] | 0;
    i10 = i4;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
    __ZNK24NavMeshSceneDataRegistry9GetScenesER13dynamic_arrayIiLj4EEPK11NavMeshData(HEAP32[i12 >> 2] | 0, i15, HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    if (!(HEAP32[i2 >> 2] | 0)) __ZN14NavMeshManager9PurgeDataEPK11NavMeshData(i11, HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    if ((HEAP32[i3 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i4);
     HEAP32[i15 >> 2] = 0;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0);
  }
 }
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i18);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __Z29Animator_CUSTOM_GetBehavioursP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 40 | 0;
 i10 = i15 + 32 | 0;
 i14 = i15 + 12 | 0;
 i12 = i15;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 i13 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 if (!i2) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i8 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 __ZN8Animator13GetBehavioursEP11Il2CppClass(i14, i1, i13);
 HEAP32[i12 >> 2] = 0;
 i8 = i12 + 4 | 0;
 i1 = gb + 63160 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i14 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = i3 << 2;
 do if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 918602 | 0, 545) | 0;
   i3 = gb + 64016 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i2;
   i1 = i8;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i2;
   i3 = HEAP32[i7 >> 2] | 0;
   break;
  }
 } while (0);
 i6 = i1 + 3 & -4;
 if (!i3) i1 = 0; else {
  i1 = 0;
  do {
   i5 = (HEAP32[i14 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i10 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i11 = 20; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
      i3 = HEAP32[i9 >> 2] | 0;
      i16 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i16 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 20; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i11 = 22;
     }
    }
    if ((i11 | 0) == 20) i11 = 22;
    if ((i11 | 0) == 22) {
     i11 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
   __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i5);
   i16 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + (i16 << 2) >> 2] = i5;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = __ZN9Scripting40CreateScriptingArrayFromScriptingObjectsEPP12Il2CppObjectiP11Il2CppClass(i6, i1, i13) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
 if ((HEAP32[i14 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i14 + 4 | 0);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return i1 | 0;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_(i11, i1, i14, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i15 = HEAP32[i11 >> 2] | 0;
 i3 = i15;
 i15 = i15 + ((HEAP32[i1 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i13 = i14;
 i16 = i7 - i13 | 0;
 i6 = i16 >> 2;
 if ((i16 | 0) <= 0) {
  i16 = i15;
  STACKTOP = i17;
  return i16 | 0;
 }
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i16 = i11 + 4 | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i2 = i9;
 if ((i6 | 0) > (i1 - i2 >> 2 | 0)) {
  i9 = i11 + 12 | 0;
  i2 = (i2 - i3 >> 2) + i6 | 0;
  if ((i2 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  i5 = i1 - i3 | 0;
  i1 = i5 >> 1;
  i1 = i5 >> 2 >>> 0 < 1073741823 ? (i1 >>> 0 < i2 >>> 0 ? i2 : i1) : 2147483647;
  i5 = i15;
  if (!i1) i2 = 0; else {
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP32[i12 >> 2] = 85;
   HEAP32[i12 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  }
  i8 = i2 + (i5 - i3 >> 2 << 2) | 0;
  i6 = i2 + (i1 << 2) | 0;
  if ((i14 | 0) == (i7 | 0)) i1 = i8; else {
   i3 = (i7 + -4 - i13 | 0) >>> 2;
   i1 = i14;
   i2 = i8;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else i2 = i2 + 4 | 0;
   }
   i1 = i8 + (i3 + 1 << 2) | 0;
  }
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = i5 - i3 | 0;
  i4 = i8 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
  i2 = (HEAP32[i16 >> 2] | 0) - i5 | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i1 | 0, i15 | 0, i2 | 0) | 0;
   i1 = i1 + (i2 >> 2 << 2) | 0;
  }
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i10 >> 2] = i6;
  if (!i2) {
   i16 = i8;
   STACKTOP = i17;
   return i16 | 0;
  }
  i16 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 85;
  HEAP32[i12 + 4 >> 2] = i16;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i12);
  i16 = i8;
  STACKTOP = i17;
  return i16 | 0;
 }
 i8 = i15;
 i5 = i2 - i8 | 0;
 i1 = i5 >> 2;
 if ((i6 | 0) > (i1 | 0)) {
  i4 = i14 + (i1 << 2) | 0;
  if ((i4 | 0) == (i7 | 0)) i1 = i9; else {
   i2 = i7 + -4 - i4 | 0;
   i1 = i4;
   i3 = i9;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i7 | 0)) break; else i3 = i3 + 4 | 0;
   }
   i1 = i9 + ((i2 >>> 2) + 1 << 2) | 0;
   HEAP32[i16 >> 2] = i1;
  }
  if ((i5 | 0) > 0) i7 = i4; else {
   i16 = i15;
   STACKTOP = i17;
   return i16 | 0;
  }
 } else i1 = i9;
 i5 = i1 - (i15 + (i6 << 2)) | 0;
 i6 = i5 >> 2;
 i2 = i15 + (i6 << 2) | 0;
 if (i2 >>> 0 < i9 >>> 0) {
  i4 = (i9 + (0 - i6 << 2) + ~i8 | 0) >>> 2;
  i3 = i1;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i9 >>> 0) break; else i3 = i3 + 4 | 0;
  }
  HEAP32[i16 >> 2] = i1 + (i4 + 1 << 2);
 }
 if (i6 | 0) _memmove(i1 + (0 - i6 << 2) | 0, i15 | 0, i5 | 0) | 0;
 i1 = i7 - i13 | 0;
 if (!i1) {
  i16 = i15;
  STACKTOP = i17;
  return i16 | 0;
 }
 _memmove(i15 | 0, i14 | 0, i1 | 0) | 0;
 i16 = i15;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i11, i12, i2, i13, i14, i15, i3) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 >> 2] = i2;
 if (!(i3 & 4)) i2 = i11; else {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i11;
  if ((i2 - i1 | 0) > 2) if ((HEAP8[i1 >> 0] | 0) == -17) if ((HEAP8[i1 + 1 >> 0] | 0) == -69) if ((HEAP8[i1 + 2 >> 0] | 0) == -65) HEAP32[i12 >> 2] = i1 + 3;
 }
 i9 = i13;
 L9 : while (1) {
  i5 = HEAP32[i12 >> 2] | 0;
  i1 = i5 >>> 0 < i11 >>> 0;
  if (!i1) {
   i16 = 41;
   break;
  }
  i10 = HEAP32[i14 >> 2] | 0;
  if (i10 >>> 0 >= i13 >>> 0) {
   i16 = 41;
   break;
  }
  i4 = HEAP8[i5 >> 0] | 0;
  i8 = i4 & 255;
  if (i8 >>> 0 > i15 >>> 0) {
   i1 = 2;
   break;
  }
  do if (i4 << 24 >> 24 > -1) {
   HEAP32[i10 >> 2] = i8;
   HEAP32[i12 >> 2] = i5 + 1;
  } else {
   if ((i4 & 255) < 194) {
    i1 = 2;
    break L9;
   }
   if ((i4 & 255) < 224) {
    if ((i2 - i5 | 0) < 2) {
     i1 = 1;
     break L9;
    }
    i1 = HEAPU8[i5 + 1 >> 0] | 0;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = i1 & 63 | i8 << 6 & 1984;
    if (i1 >>> 0 > i15 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP32[i10 >> 2] = i1;
    HEAP32[i12 >> 2] = i5 + 2;
    break;
   }
   if ((i4 & 255) < 240) {
    if ((i2 - i5 | 0) < 3) {
     i1 = 1;
     break L9;
    }
    i3 = HEAP8[i5 + 1 >> 0] | 0;
    i1 = HEAP8[i5 + 2 >> 0] | 0;
    switch (i4 << 24 >> 24) {
    case -32:
     {
      if ((i3 & -32) << 24 >> 24 != -96) {
       i1 = 2;
       break L9;
      }
      break;
     }
    case -19:
     {
      if ((i3 & -32) << 24 >> 24 != -128) {
       i1 = 2;
       break L9;
      }
      break;
     }
    default:
     if ((i3 & -64) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
    }
    i1 = i1 & 255;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = (i3 & 255) << 6 & 4032 | i8 << 12 & 61440 | i1 & 63;
    if (i1 >>> 0 > i15 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP32[i10 >> 2] = i1;
    HEAP32[i12 >> 2] = i5 + 3;
    break;
   }
   if ((i4 & 255) >= 245) {
    i1 = 2;
    break L9;
   }
   if ((i2 - i5 | 0) < 4) {
    i1 = 1;
    break L9;
   }
   i6 = HEAP8[i5 + 1 >> 0] | 0;
   i1 = HEAP8[i5 + 2 >> 0] | 0;
   i3 = HEAP8[i5 + 3 >> 0] | 0;
   switch (i4 << 24 >> 24) {
   case -16:
    {
     if ((i6 + 112 & 255) >= 48) {
      i1 = 2;
      break L9;
     }
     break;
    }
   case -12:
    {
     if ((i6 & -16) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
     break;
    }
   default:
    if ((i6 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     break L9;
    }
   }
   i7 = i1 & 255;
   if ((i7 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   i1 = i3 & 255;
   if ((i1 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   if ((i9 - i10 | 0) < 8) {
    i1 = 1;
    break L9;
   }
   i5 = i8 & 7;
   i3 = i6 & 255;
   i4 = i7 << 6;
   i1 = i1 & 63;
   if ((i3 << 12 & 258048 | i5 << 18 | i4 & 4032 | i1) >>> 0 > i15 >>> 0) {
    i1 = 2;
    break L9;
   }
   HEAP32[i10 >> 2] = i3 << 2 & 60 | i7 >>> 4 & 3 | ((i3 >>> 4 & 3 | i5 << 2) << 6) + -64 | 55296;
   i10 = i10 + 4 | 0;
   HEAP32[i14 >> 2] = i10;
   HEAP32[i10 >> 2] = i1 | i4 & 960 | 56320;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 4;
  } while (0);
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 4;
 }
 if ((i16 | 0) == 41) i1 = i1 & 1;
 return i1 | 0;
}

function __ZN5physx2Sc5Scene11preAllocateEjjjjj(i13, i10, i12, i15, i14, i11) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 12 | 0;
 i17 = i18;
 i1 = HEAP32[i13 + 1216 >> 2] | 0;
 if (i10 | 0) {
  i7 = i1 + 12 | 0;
  i8 = i1 + 16 | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i2 = Math_imul(i9, HEAP32[i8 >> 2] | 0) | 0;
  if (i2 >>> 0 < i10 >>> 0) {
   i4 = i17 + 4 | 0;
   i5 = i17 + 8 | 0;
   i6 = Math_imul(HEAP32[i1 + 4 >> 2] | 0, i9) | 0;
   i3 = i1 + 20 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, i6, gb + 681700 | 0, 43) | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i1 = (HEAP32[i7 >> 2] | 0) + (i1 * 12 | 0) | 0;
     HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i7, i17) | 0;
    i2 = i2 + i9 | 0;
   } while (i2 >>> 0 < i10 >>> 0);
  }
 }
 i1 = HEAP32[i13 + 1220 >> 2] | 0;
 if (i12 | 0) {
  i4 = i1 + 12 | 0;
  i5 = i1 + 16 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i2 = Math_imul(i6, HEAP32[i5 >> 2] | 0) | 0;
  if (i2 >>> 0 < i12 >>> 0) {
   i7 = i17 + 4 | 0;
   i8 = i17 + 8 | 0;
   i9 = Math_imul(HEAP32[i1 + 4 >> 2] | 0, i6) | 0;
   i3 = i1 + 20 | 0;
   do {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, i9, gb + 681700 | 0, 43) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i10 = (HEAP32[i4 >> 2] | 0) + (i1 * 12 | 0) | 0;
     HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i10 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i10 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i17) | 0;
    i2 = i2 + i6 | 0;
   } while (i2 >>> 0 < i12 >>> 0);
  }
 }
 __ZN5physx2Sc16InteractionScene11preAllocateEjjjj(HEAP32[i13 + 1204 >> 2] | 0, i12, i15, i14, i11);
 i2 = HEAP32[i13 + 1212 >> 2] | 0;
 i4 = i14 + i15 | 0;
 if (!i4) {
  STACKTOP = i18;
  return;
 }
 i5 = i2 + 12 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = Math_imul(i7, HEAP32[i6 >> 2] | 0) | 0;
 if (i1 >>> 0 >= i4 >>> 0) {
  STACKTOP = i18;
  return;
 }
 i8 = i17 + 4 | 0;
 i9 = i17 + 8 | 0;
 i10 = Math_imul(HEAP32[i2 + 4 >> 2] | 0, i7) | 0;
 i3 = i2 + 20 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i17 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, i10, gb + 681700 | 0, 43) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i15 = (HEAP32[i5 >> 2] | 0) + (i2 * 12 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i17) | 0;
  i1 = i1 + i7 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 STACKTOP = i18;
 return;
}

function __ZN14ParticleSystem8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 i3 = i1 + 36 | 0;
 __ZN27ParticleSystemReadOnlyState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN19ParticleSystemState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 40 >> 2] | 0, i2);
 i3 = i1 + 44 | 0;
 __ZN13InitialModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 48 | 0;
 __ZN11ShapeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i2);
 __ZN11ShapeModule16CheckConsistencyEv(i3);
 i3 = i1 + 264 | 0;
 __ZN14EmissionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i2);
 __ZN14EmissionModule16CheckConsistencyEv(i3);
 __ZN10SizeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 852 >> 2] | 0, i2);
 __ZN14RotationModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 856 >> 2] | 0, i2);
 __ZN11ColorModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 860 >> 2] | 0, i2);
 i3 = i1 + 864 | 0;
 __ZN8UVModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN14VelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 868 >> 2] | 0, i2);
 i3 = i1 + 872 | 0;
 __ZN21InheritVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN11ForceModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 876 >> 2] | 0, i2);
 __ZN20ExternalForcesModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 880 >> 2] | 0, i2);
 i3 = i1 + 884 | 0;
 __ZN19ClampVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 888 | 0;
 __ZN11NoiseModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 892 | 0;
 __ZN17SizeBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 896 | 0;
 __ZN21RotationBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 900 | 0;
 __ZN18ColorBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 904 | 0;
 __ZN15CollisionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 912 | 0;
 __ZN13TriggerModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN9SubModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 916 >> 2] | 0, i2);
 i3 = i1 + 920 | 0;
 __ZN12LightsModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 908 | 0;
 __ZN11TrailModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 >> 2] | 0, i2);
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 do switch (i2 | 0) {
 case 5:
  {
   HEAP32[i3 >> 2] = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | (HEAPU8[i1 + 3 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24;
   STACKTOP = i5;
   return;
  }
 case 4:
  {
   HEAP32[i3 >> 2] = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) | (HEAPU8[i1 + 2 >> 0] | 0) << 16 | (HEAPU8[i1 + 3 >> 0] | 0) << 24;
   STACKTOP = i5;
   return;
  }
 case 14:
  {
   HEAP32[i3 >> 2] = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 + 2 >> 0] | 0) | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 3 >> 0] | 0) << 24;
   STACKTOP = i5;
   return;
  }
 case 3:
  {
   HEAP32[i3 >> 2] = HEAPU8[i1 >> 0] | 0 | (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 + 2 >> 0] | 0) << 16 | -16777216;
   STACKTOP = i5;
   return;
  }
 case 8:
  {
   HEAP32[i3 >> 2] = HEAPU8[i1 + 2 >> 0] | 0 | (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | -16777216;
   STACKTOP = i5;
   return;
  }
 case 1:
  {
   HEAP32[i3 >> 2] = (HEAPU8[i1 >> 0] | 0) << 24 | 16777215;
   STACKTOP = i5;
   return;
  }
 case 13:
  {
   i1 = HEAP16[i1 >> 1] | 0;
   i2 = i1 & 65535;
   i1 = (i1 & 65535) >>> 12 & 65535;
   i4 = i2 >>> 8;
   HEAP32[i3 >> 2] = i1 << 4 | i1 | (i2 & 15 | i2 << 4) << 24 | (i2 >>> 4 & 15 | i2 & 240) << 16 | (i4 << 4 & 240 | i4 & 15) << 8;
   STACKTOP = i5;
   return;
  }
 case 2:
  {
   i2 = HEAP16[i1 >> 1] | 0;
   i4 = i2 & 65535;
   i2 = (i2 & 65535) >>> 12 & 65535;
   i1 = i4 >>> 8;
   HEAP32[i3 >> 2] = i1 << 4 & 240 | i1 & 15 | (i4 << 4 & 240 | i4 & 15) << 16 | (i2 << 4 | i2) << 24 | (i4 >>> 4 & 15 | i4 & 240) << 8;
   STACKTOP = i5;
   return;
  }
 case 7:
  {
   i2 = HEAP16[i1 >> 1] | 0;
   i4 = i2 & 65535;
   i2 = (i2 & 65535) >>> 11 & 65535;
   HEAP32[i3 >> 2] = i2 >>> 2 | i2 << 3 | (i4 >>> 3 & 252 | i4 >>> 9 & 3) << 8 | (i4 << 3 & 248 | i4 >>> 2 & 7) << 16 | -16777216;
   STACKTOP = i5;
   return;
  }
 case 17:
 case 16:
 case 15:
 case 6:
 case 20:
 case 23:
 case 19:
 case 18:
  {
   __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i1, i2, i4);
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   i2 = f6 < Math_fround(0.0);
   f6 = i2 ? Math_fround(0.0) : f6;
   i2 = f6 > Math_fround(1.0);
   HEAP8[i3 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   i2 = f6 < Math_fround(0.0);
   f6 = i2 ? Math_fround(0.0) : f6;
   i2 = f6 > Math_fround(1.0);
   HEAP8[i3 + 1 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   i2 = f6 < Math_fround(0.0);
   f6 = i2 ? Math_fround(0.0) : f6;
   i2 = f6 > Math_fround(1.0);
   HEAP8[i3 + 2 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   i4 = f6 < Math_fround(0.0);
   f6 = i4 ? Math_fround(0.0) : f6;
   i4 = f6 > Math_fround(1.0);
   HEAP8[i3 + 3 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   STACKTOP = i5;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43068 >> 2] | 0, 0, gb + 404494 | 0, 1486, 1, 0, 0, 0);
   STACKTOP = i5;
   return;
  }
 } while (0);
}

function __ZN6Sprite15GenerateOutlineEfhbRNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEi(i2, f6, i3, i4, i8, i1) {
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i5 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i5 = i9 + 8 | 0;
 if (!(HEAP8[i2 + 148 >> 0] | 0)) {
  if ((i1 | 0) < 0) i1 = HEAP32[i2 + 144 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 + 80 >> 2];
  i10 = i2 + 140 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  __Z21GenerateSpriteOutline4PPtrI9Texture2DEfRK5RectTIfERK8Vector2ffhbjibPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENS9_9allocatorISC_EEEEPSB_I12SpriteVertexLj4EEPSB_ItLj2EEPS3_P8Vector4f(i7, f11, i2 + 32 | 0, i2 + 48 | 0, f6, i3, i4, i1, 1, 1, i8, 0, 0, 0, 0);
  f6 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 >> 2]));
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i8 + 4 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) {
   STACKTOP = i9;
   return;
  }
  do {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (i2 | 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i3 = i10 + (i2 << 3) | 0;
    i2 = i10;
    do {
     HEAPF32[i2 >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2]));
     i10 = i2 + 4 | 0;
     HEAPF32[i10 >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2]));
     i2 = i2 + 8 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i9;
  return;
 }
 i5 = i2 + 136 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
  i3 = i7;
  i10 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i1 + 12 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i10;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
  i4 = i7;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  i10 = i1 + 32 | 0;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
 }
 i7 = i8 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i10 = i4 - i3 | 0;
 i2 = (i10 | 0) / 20 | 0;
 if (!i10) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i8, 1 - i2 | 0); else if (i2 >>> 0 > 1) {
  i5 = i3 + 20 | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i3 = i4;
   while (1) {
    i2 = i3 + -20 | 0;
    HEAP32[i7 >> 2] = i2;
    if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -16 | 0);
     HEAP32[i2 >> 2] = 0;
     i2 = HEAP32[i7 >> 2] | 0;
    }
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
  }
 }
 i8 = HEAP32[i8 >> 2] | 0;
 i10 = i1 + 4 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 __Z27GenerateOutlineFromMeshDataRK13dynamic_arrayItLj2EERKS_I12SpriteVertexLj4EERS_I8Vector2fLj4EE(i1 + 28 | 0, i1 + 8 | 0, i8);
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 if (HEAP32[i10 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63744 | 0);
 STACKTOP = i9;
 return;
}

function _examine_app0(i12, i10, i2, i1) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i1 + i2 | 0;
 if (i2 >>> 0 > 13) {
  if ((HEAP8[i10 >> 0] | 0) == 74) if ((HEAP8[i10 + 1 >> 0] | 0) == 70) if ((HEAP8[i10 + 2 >> 0] | 0) == 73) if ((HEAP8[i10 + 3 >> 0] | 0) == 70) if (!(HEAP8[i10 + 4 >> 0] | 0)) {
   HEAP8[i12 + 256 >> 0] = 1;
   i3 = HEAP8[i10 + 5 >> 0] | 0;
   i6 = i12 + 257 | 0;
   HEAP8[i6 >> 0] = i3;
   i7 = HEAP8[i10 + 6 >> 0] | 0;
   i4 = i12 + 258 | 0;
   HEAP8[i4 >> 0] = i7;
   i1 = HEAP8[i10 + 7 >> 0] | 0;
   HEAP8[i12 + 259 >> 0] = i1;
   i8 = HEAPU8[i10 + 8 >> 0] << 8 | HEAPU8[i10 + 9 >> 0];
   i5 = i12 + 260 | 0;
   HEAP16[i5 >> 1] = i8;
   i2 = HEAPU8[i10 + 10 >> 0] << 8 | HEAPU8[i10 + 11 >> 0];
   HEAP16[i12 + 262 >> 1] = i2;
   if (i3 << 24 >> 24 == 1) {
    i9 = i12;
    i5 = 1;
    i4 = i7;
    i3 = i8;
   } else {
    i1 = HEAP32[i12 >> 2] | 0;
    HEAP32[i1 + 20 >> 2] = 119;
    HEAP32[i1 + 24 >> 2] = i3 & 255;
    HEAP32[i1 + 28 >> 2] = i7 & 255;
    mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i12 | 0, -1);
    i1 = HEAP16[i4 >> 1] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = i12;
    i5 = HEAP8[i6 >> 0] | 0;
    i4 = i1 & 255;
    i3 = i2;
    i2 = i2 >>> 16;
    i1 = (i1 & 65535) >>> 8 & 255;
   }
   i8 = HEAP32[i12 >> 2] | 0;
   HEAP32[i8 + 24 >> 2] = i5 & 255;
   HEAP32[i8 + 28 >> 2] = i4 & 255;
   HEAP32[i8 + 32 >> 2] = i3 & 65535;
   HEAP32[i8 + 36 >> 2] = i2 & 65535;
   HEAP32[i8 + 40 >> 2] = i1 & 255;
   HEAP32[i8 + 20 >> 2] = 87;
   mftCall_vii(HEAP32[i8 + 4 >> 2] | 0, i9 | 0, 1);
   i1 = i10 + 12 | 0;
   i3 = HEAP8[i1 >> 0] | 0;
   i4 = i10 + 13 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if ((i2 | i3) << 24 >> 24) {
    i3 = HEAP32[i12 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 90;
    HEAP32[i3 + 24 >> 2] = HEAPU8[i1 >> 0];
    HEAP32[i3 + 28 >> 2] = HEAPU8[i4 >> 0];
    mftCall_vii(HEAP32[i3 + 4 >> 2] | 0, i9 | 0, 1);
    i3 = HEAP8[i1 >> 0] | 0;
    i2 = HEAP8[i4 >> 0] | 0;
   }
   i1 = i11 + -14 | 0;
   if ((i1 | 0) == (Math_imul((i3 & 255) * 3 | 0, i2 & 255) | 0)) return;
   i12 = HEAP32[i12 >> 2] | 0;
   HEAP32[i12 + 20 >> 2] = 88;
   HEAP32[i12 + 24 >> 2] = i1;
   mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i9 | 0, 1);
   return;
  } else i3 = 16; else i3 = 16; else i3 = 16; else i3 = 16;
 } else if (i2 >>> 0 > 5) if ((HEAP8[i10 >> 0] | 0) == 74) i3 = 16;
 if ((i3 | 0) == 16) if ((HEAP8[i10 + 1 >> 0] | 0) == 70) if ((HEAP8[i10 + 2 >> 0] | 0) == 88) if ((HEAP8[i10 + 3 >> 0] | 0) == 88) if (!(HEAP8[i10 + 4 >> 0] | 0)) {
  i1 = i10 + 5 | 0;
  switch (HEAP8[i1 >> 0] | 0) {
  case 16:
   {
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 108;
    HEAP32[i10 + 24 >> 2] = i11;
    mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i12 | 0, 1);
    return;
   }
  case 17:
   {
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 109;
    HEAP32[i10 + 24 >> 2] = i11;
    mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i12 | 0, 1);
    return;
   }
  case 19:
   {
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 110;
    HEAP32[i10 + 24 >> 2] = i11;
    mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i12 | 0, 1);
    return;
   }
  default:
   {
    i10 = HEAP32[i12 >> 2] | 0;
    HEAP32[i10 + 20 >> 2] = 89;
    HEAP32[i10 + 24 >> 2] = HEAPU8[i1 >> 0];
    HEAP32[i10 + 28 >> 2] = i11;
    mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i12 | 0, 1);
    return;
   }
  }
 }
 i10 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 + 20 >> 2] = 77;
 HEAP32[i10 + 24 >> 2] = i11;
 mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i12 | 0, 1);
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i9 = i12 + 24 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i5 = i11;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i4 | 0, i5 | 0, -1, ~i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 8 >> 2] | 0;
   i3 = i12 + 12 | 0;
   while (1) {
    i13 = i6 + (i2 << 5) | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i4 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i5 | 0) : 0) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i13 = i6 + (i1 << 5) | 0;
   return i13 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 20 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i13 = HEAP32[i11 >> 2] | 0;
  i13 = _i64Add(i13 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i13 | 0) | 0;
  i11 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i13 | 0, i11 | 0, 22) | 0;
  i13 = i10 ^ i13;
  i11 = (getTempRet0() | 0) ^ i11;
  i10 = _bitshift64Shl(i13 | 0, i11 | 0, 13) | 0;
  i10 = _i64Add(i13 | 0, i11 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i13 ^ i10 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i11 | 0, i10 | 0, 15) | 0;
  i11 = i13 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i13 = _bitshift64Shl(i11 | 0, i10 | 0, 27) | 0;
  i13 = _i64Add(i11 | 0, i10 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i13 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i1 = (i11 ^ i13) & i1 + -1;
 }
 i11 = i12 + 32 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i13 + 1;
 i11 = (HEAP32[i12 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i13;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i13 = (HEAP32[i12 + 8 >> 2] | 0) + (i13 << 5) | 0;
 return i13 | 0;
}

function runPostSets98() {
 HEAP32[gb + 95408 >> 2] = fb + 1;
 HEAP32[gb + 95412 >> 2] = fb + 1;
 HEAP32[gb + 95416 >> 2] = fb + 1;
 HEAP32[gb + 95420 >> 2] = fb + 1;
 HEAP32[gb + 95424 >> 2] = fb + 1;
 HEAP32[gb + 95428 >> 2] = fb + 1;
 HEAP32[gb + 95432 >> 2] = fb + 1;
 HEAP32[gb + 95436 >> 2] = fb + 1;
 HEAP32[gb + 95440 >> 2] = fb + 1;
 HEAP32[gb + 95444 >> 2] = fb + 1;
 HEAP32[gb + 95448 >> 2] = fb + 1;
 HEAP32[gb + 95452 >> 2] = fb + 1;
 HEAP32[gb + 95456 >> 2] = fb + 1;
 HEAP32[gb + 95460 >> 2] = fb + 1;
 HEAP32[gb + 95464 >> 2] = fb + 1;
 HEAP32[gb + 95468 >> 2] = fb + 1;
 HEAP32[gb + 95472 >> 2] = fb + 1;
 HEAP32[gb + 95476 >> 2] = fb + 1;
 HEAP32[gb + 95480 >> 2] = fb + 1;
 HEAP32[gb + 95484 >> 2] = fb + 1;
 HEAP32[gb + 95488 >> 2] = fb + 1;
 HEAP32[gb + 95492 >> 2] = fb + 1;
 HEAP32[gb + 95496 >> 2] = fb + 1;
 HEAP32[gb + 95500 >> 2] = fb + 1;
 HEAP32[gb + 95504 >> 2] = fb + 1;
 HEAP32[gb + 95508 >> 2] = fb + 1;
 HEAP32[gb + 95512 >> 2] = fb + 1;
 HEAP32[gb + 95516 >> 2] = fb + 1;
 HEAP32[gb + 95520 >> 2] = fb + 1;
 HEAP32[gb + 95524 >> 2] = fb + 1;
 HEAP32[gb + 95528 >> 2] = fb + 1;
 HEAP32[gb + 95532 >> 2] = fb + 1;
 HEAP32[gb + 95536 >> 2] = fb + 1;
 HEAP32[gb + 95540 >> 2] = fb + 1;
 HEAP32[gb + 95544 >> 2] = fb + 1;
 HEAP32[gb + 95548 >> 2] = fb + 1;
 HEAP32[gb + 95552 >> 2] = fb + 1;
 HEAP32[gb + 95556 >> 2] = fb + 1;
 HEAP32[gb + 95560 >> 2] = fb + 1;
 HEAP32[gb + 95564 >> 2] = fb + 1;
 HEAP32[gb + 95568 >> 2] = fb + 1;
 HEAP32[gb + 95572 >> 2] = fb + 1;
 HEAP32[gb + 95576 >> 2] = fb + 1;
 HEAP32[gb + 95580 >> 2] = fb + 1;
 HEAP32[gb + 95584 >> 2] = fb + 1;
 HEAP32[gb + 95588 >> 2] = fb + 1;
 HEAP32[gb + 95592 >> 2] = fb + 1;
 HEAP32[gb + 95596 >> 2] = fb + 1;
 HEAP32[gb + 95600 >> 2] = fb + 1;
 HEAP32[gb + 95604 >> 2] = fb + 1;
 HEAP32[gb + 95608 >> 2] = fb + 1;
 HEAP32[gb + 95612 >> 2] = fb + 1;
 HEAP32[gb + 95616 >> 2] = fb + 1;
 HEAP32[gb + 95620 >> 2] = fb + 1;
 HEAP32[gb + 95624 >> 2] = fb + 1027;
 HEAP32[gb + 95628 >> 2] = fb + 1028;
 HEAP32[gb + 95640 >> 2] = fb + 1;
 HEAP32[gb + 95644 >> 2] = fb + 648;
 HEAP32[gb + 95648 >> 2] = fb + 456;
 HEAP32[gb + 95652 >> 2] = fb + 1270;
 HEAP32[gb + 95656 >> 2] = fb + 1346;
 HEAP32[gb + 95660 >> 2] = fb + 293;
 HEAP32[gb + 95664 >> 2] = fb + 1;
 HEAP32[gb + 95668 >> 2] = fb + 1;
 HEAP32[gb + 95672 >> 2] = fb + 1;
 HEAP32[gb + 95676 >> 2] = fb + 1;
 HEAP32[gb + 95680 >> 2] = fb + 1;
 HEAP32[gb + 95684 >> 2] = fb + 1;
 HEAP32[gb + 95688 >> 2] = fb + 1;
 HEAP32[gb + 95692 >> 2] = fb + 1;
 HEAP32[gb + 95696 >> 2] = fb + 1;
 HEAP32[gb + 95700 >> 2] = fb + 1;
 HEAP32[gb + 95704 >> 2] = fb + 1;
 HEAP32[gb + 95708 >> 2] = fb + 1;
 HEAP32[gb + 95712 >> 2] = fb + 1;
 HEAP32[gb + 95716 >> 2] = fb + 1;
 HEAP32[gb + 95720 >> 2] = fb + 1;
 HEAP32[gb + 95724 >> 2] = fb + 1;
 HEAP32[gb + 95728 >> 2] = fb + 1;
 HEAP32[gb + 95732 >> 2] = fb + 1;
 HEAP32[gb + 95736 >> 2] = fb + 1;
 HEAP32[gb + 95740 >> 2] = fb + 1;
 HEAP32[gb + 95744 >> 2] = fb + 1;
 HEAP32[gb + 95748 >> 2] = fb + 1;
 HEAP32[gb + 95752 >> 2] = fb + 1;
 HEAP32[gb + 95756 >> 2] = fb + 1;
 HEAP32[gb + 95760 >> 2] = fb + 1;
 HEAP32[gb + 95764 >> 2] = fb + 1;
 HEAP32[gb + 95768 >> 2] = fb + 1;
 HEAP32[gb + 95772 >> 2] = fb + 1;
 HEAP32[gb + 95776 >> 2] = fb + 1;
 HEAP32[gb + 95780 >> 2] = fb + 1;
 HEAP32[gb + 95784 >> 2] = fb + 1;
 HEAP32[gb + 95788 >> 2] = fb + 1;
 HEAP32[gb + 95792 >> 2] = fb + 1;
 HEAP32[gb + 95796 >> 2] = fb + 1;
 HEAP32[gb + 95800 >> 2] = fb + 1;
 HEAP32[gb + 95804 >> 2] = fb + 1;
 HEAP32[gb + 95808 >> 2] = fb + 1;
 HEAP32[gb + 95812 >> 2] = fb + 1;
 runPostSets99();
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 49;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 176;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj49ES2_jEEEEvjRT_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 180;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj49ES2_jEEEEvjRT_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN15TerrainRenderer20GetPatchVertexStreamEiiiPP15SharedGfxBuffer(i11, i12, i13, i14, i15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i21 + 32 | 0;
 i17 = i21 + 24 | 0;
 i18 = i21 + 8 | 0;
 i19 = i21;
 i2 = i11 + 128 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i10 = __Z12GetGfxDevicev() | 0;
  i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 220 >> 2] | 0, i10 | 0) | 0;
  i7 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63248 | 0, 16, gb + 1012378 | 0, 14) | 0;
  HEAP32[i7 + 4 >> 2] = 1;
  HEAP32[i7 >> 2] = gb + 58920 + 8;
  HEAP32[i7 + 8 >> 2] = i10;
 } else {
  i10 = HEAP32[i11 + 116 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  _memmove(i10 | 0, i10 + 4 | 0, (i1 << 2) + -4 | 0) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 }
 i8 = i11 + 236 | 0;
 i9 = (HEAP32[i8 >> 2] | 0) * 289 | 0;
 HEAP32[i18 >> 2] = 0;
 i10 = i18 + 4 | 0;
 i4 = gb + 63160 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 do if (!i9) i1 = 0; else {
  i2 = i9 + 31 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 32, gb + 64016 | 0, 0, gb + 930611 | 0, 175) | 0;
   i5 = gb + 64016 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i18 >> 2] = i1;
   i6 = i10;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i5;
   break;
  }
 } while (0);
 i5 = i1 + 31 & -32;
 i6 = i5;
 i4 = i11 + 72 | 0;
 HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i20 = 13; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i16, i1, i17);
   i2 = HEAP32[i16 >> 2] | 0;
   i22 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i22 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i22 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i20 = 13; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i20 = 15;
  }
 }
 if ((i20 | 0) == 13) i20 = 15;
 if ((i20 | 0) == 15) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i4 = HEAPU8[i11 + 205 >> 0] | 0;
 i20 = HEAPU8[i11 + 213 >> 0] | 0;
 i22 = HEAP32[i8 >> 2] | 0;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i22;
 HEAP32[i17 >> 2] = i6 + i4;
 HEAP32[i17 + 4 >> 2] = i22;
 HEAP32[i19 >> 2] = i6 + i20;
 HEAP32[i19 + 4 >> 2] = i22;
 __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fES4_RKS0_I8Vector2fEiiiPK15TerrainRenderer(i1 + 248 | 0, i16, i17, i19, i12, i13, i14, i11);
 i22 = __Z12GetGfxDevicev() | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i22 >> 2] | 0) + 224 >> 2] | 0, i22 | 0, HEAP32[i7 + 8 >> 2] | 0, 1, 0, i9 | 0, i6 | 0, 0);
 HEAP32[i15 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i10);
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i4 = i9;
 i8 = (HEAP32[i1 >> 2] | 0) - i4 >> 3;
 i1 = i9 + (i8 << 3) | 0;
 i12 = i11 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i6 = i11 + 8 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i5 = i3;
 i7 = i10;
 if (i3 >>> 0 < i10 >>> 0) {
  if ((i1 | 0) == (i3 | 0)) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i11 = i9 + (i8 << 3) + 4 | 0;
   HEAP32[i11 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i11, i2 + 4 | 0);
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 8;
   i12 = i1;
   return i12 | 0;
  }
  i6 = i5 - (i1 + 8) >> 3;
  i4 = i1 + (i6 << 3) | 0;
  if (i4 >>> 0 < i3 >>> 0) {
   i5 = i4;
   i7 = i3;
   do {
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    i11 = i7 + 4 | 0;
    HEAP32[i11 >> 2] = 0;
    __ZN14ConstantString6assignERKS_(i11, i5 + 4 | 0);
    i5 = i5 + 8 | 0;
    i7 = (HEAP32[i12 >> 2] | 0) + 8 | 0;
    HEAP32[i12 >> 2] = i7;
   } while (i5 >>> 0 < i3 >>> 0);
  }
  if (i6 | 0) do {
   i10 = i3;
   i3 = i3 + -8 | 0;
   i11 = i4;
   i4 = i4 + -8 | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   __ZN14ConstantStringaSERKS_(i10 + -4 | 0, i11 + -4 | 0);
  } while ((i4 | 0) != (i1 | 0));
  if (i1 >>> 0 <= i2 >>> 0) i2 = (HEAP32[i12 >> 2] | 0) >>> 0 > i2 >>> 0 ? i2 + 8 | 0 : i2;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __ZN14ConstantStringaSERKS_(i9 + (i8 << 3) + 4 | 0, i2 + 4 | 0);
  i12 = i1;
  return i12 | 0;
 }
 i5 = (i5 - i4 >> 3) + 1 | 0;
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i10 = i6;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  i10 = i6;
  i3 = i7;
 }
 i6 = i3 - i4 | 0;
 i8 = i6 >> 2;
 i8 = i6 >> 3 >>> 0 < 268435455 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 536870911;
 i5 = i1 - i4 | 0;
 i6 = i5 >> 3;
 if (!i8) i9 = 0; else i9 = __Znwj(i8 << 3) | 0;
 i7 = i9 + (i6 << 3) | 0;
 i4 = i7;
 i3 = i9 + (i8 << 3) | 0;
 do if ((i6 | 0) == (i8 | 0)) {
  if ((i5 | 0) > 0) {
   i4 = i7 + (((i8 + 1 | 0) / -2 | 0) << 3) | 0;
   break;
  }
  i3 = i8 << 3 >> 2;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i8 = __Znwj(i3 << 3) | 0;
  i4 = i8 + (i3 >>> 2 << 3) | 0;
  i3 = i8 + (i3 << 3) | 0;
  if (i9) __ZdlPv(i9);
 } while (0);
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 i9 = i5 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i9, i2 + 4 | 0);
 i2 = i5 + 8 | 0;
 i5 = i2;
 i9 = i4;
 i8 = HEAP32[i11 >> 2] | 0;
 if ((i8 | 0) == (i1 | 0)) i6 = i9; else {
  i7 = i1;
  i6 = i9;
  do {
   i13 = i7;
   i7 = i7 + -8 | 0;
   HEAP32[i6 + -8 >> 2] = HEAP32[i7 >> 2];
   i6 = i6 + -4 | 0;
   HEAP32[i6 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i6, i13 + -4 | 0);
   i6 = i4 + -8 | 0;
   i4 = i6;
  } while ((i7 | 0) != (i8 | 0));
 }
 i7 = HEAP32[i12 >> 2] | 0;
 if ((i7 | 0) == (i1 | 0)) i4 = i6; else {
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i13 = i2 + 4 | 0;
   HEAP32[i13 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i13, i1 + 4 | 0);
   i1 = i1 + 8 | 0;
   i2 = i5 + 8 | 0;
   i5 = i2;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i10 >> 2] = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14ConstantStringD2Ev(i1 + -4 | 0);
  i1 = i1 + -8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i2) {
  i13 = i9;
  return i13 | 0;
 }
 __ZdlPv(i2);
 i13 = i9;
 return i13 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12;
 HEAP32[i1 >> 2] = 87;
 i8 = HEAP32[i11 + 44 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 i1 = HEAP32[i11 + 48 >> 2] | 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i11, HEAP32[i10 >> 2] | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i11, HEAP32[i10 + 8 >> 2] | 0);
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = i10;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 20;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj87ES2_jEEEEvjRT_(i11, HEAP32[i8 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i11, HEAP32[i10 + 12 >> 2] | 0);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i5 >> 2] = i7 + 24;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj87ES2_jEEEEvjRT_(i11, HEAP32[i8 >> 2] | 0, i9);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i11 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i11 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = i11 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i1 | 0) {
   if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
   i3 = i1 + -1 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
    i1 = HEAP32[i11 + 20 >> 2] | 0;
    mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i2 = i1;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
   }
   HEAP32[i2 + 8 >> 2] = i1 + -1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   i1 = i11 + 36 | 0;
   HEAP8[i1 >> 0] = 1;
   if (!i3) {
    STACKTOP = i12;
    return;
   }
   if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
    STACKTOP = i12;
    return;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 }
 HEAP8[i11 + 36 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator21makeNeighborBitvectorEiRKNS_5ArrayIiEEbRNS1_IjEEPKNS0_6ResultE(i14, i1, i9, i15, i8, i4) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i7 = i8 + 8 | 0;
 if ((HEAP32[i7 >> 2] | 0) < 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = i8 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i16 = HEAP32[i8 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i5 = 6;
  }
 } else i5 = 6;
 if ((i5 | 0) == 6) HEAP32[i8 + 12 >> 2] = 0;
 i16 = i9 + 12 | 0;
 if (!(HEAP32[i16 >> 2] | 0)) return;
 if (!(HEAP32[i14 + 256 >> 2] | 0)) return;
 i1 = (((HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 44 >> 2] | 0) >>> 5) + 31 | 0) >>> 5;
 do if ((HEAP32[i7 >> 2] | 0) < (i1 | 0)) {
  i3 = i1 << 1;
  i3 = i3 >>> 0 > 16 ? i3 : 16;
  i2 = HEAP32[i8 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, (i3 << 2) + 16 | 0, 0) | 0;
  if (!i2) {
   i1 = HEAP32[i8 + 12 >> 2] | 0;
   break;
  }
  HEAP32[i2 >> 2] = i3;
  i6 = i2 + 16 | 0;
  HEAP32[i7 >> 2] = i3;
  i4 = i8 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i2 = HEAP32[i8 + 12 >> 2] | 0;
   if (i2 | 0) {
    i3 = (i2 | 0) <= (i1 | 0) ? i2 : i1;
    if ((i3 | 0) > 0) {
     i2 = 0;
     do {
      HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
    }
   }
   i13 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i5 + -16 | 0);
  }
  HEAP32[i4 >> 2] = i6;
  i5 = 18;
 } else i5 = 18; while (0);
 if ((i5 | 0) == 18) HEAP32[i8 + 12 >> 2] = i1;
 i2 = i8 + 4 | 0;
 _memset(HEAP32[i2 >> 2] | 0, 0, i1 << 2 | 0) | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i10 = HEAP32[i14 + 148 >> 2] | 0;
 i13 = i14 + 248 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i8 = i14 + 76 | 0;
 i9 = i14 + 68 | 0;
 i7 = i14 + 164 | 0;
 if (i15) i5 = 0; else {
  i3 = 0;
  do {
   i2 = HEAP32[i12 + (i3 << 2) >> 2] | 0;
   if ((i2 | 0) != -1) {
    i15 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i1 = i11 + (i15 >> 5 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i15 & 31);
    i1 = HEAP32[i16 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  return;
 }
 do {
  i1 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
  i3 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  L44 : do if ((i1 | 0) != -1) {
   i6 = HEAP32[i13 >> 2] | 0;
   i15 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
   i2 = i11 + (i15 >> 5 << 2) | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i15 & 31);
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) > (i3 | 0)) {
    i4 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i4 + (i3 << 5) + 12 >> 2] | 0;
    if ((i1 | 0) != -1) while (1) {
     if ((i1 | 0) < (i2 | 0)) i2 = i4 + (i1 << 5) + 4 | 0; else i2 = (HEAP32[i7 >> 2] | 0) + ((i1 - i2 | 0) * 40 | 0) + 24 | 0;
     i14 = HEAP32[i6 + (HEAP32[i2 >> 2] << 2) >> 2] | 0;
     i15 = i11 + (i14 >> 5 << 2) | 0;
     HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 1 << (i14 & 31);
     i1 = HEAP32[i4 + (i1 << 5) + 12 >> 2] | 0;
     if ((i1 | 0) == -1) break L44;
     i2 = HEAP32[i8 >> 2] | 0;
    }
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i16 >> 2] | 0));
 return;
}

function __ZN5physx14PxsAABBManager12createBPElemEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 1 | 0;
 i9 = i12;
 i10 = i11 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != 1073741823) {
  i9 = i11 + 20 | 0;
  HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2];
  i10 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 + (i1 * 24 | 0) + 8 >> 2] = -8388609;
  HEAP32[i10 + (i1 * 24 | 0) + 4 >> 2] = -8388609;
  HEAP32[i10 + (i1 * 24 | 0) >> 2] = -8388609;
  HEAP32[i10 + (i1 * 24 | 0) + 20 >> 2] = 8388608;
  HEAP32[i10 + (i1 * 24 | 0) + 16 >> 2] = 8388608;
  HEAP32[i10 + (i1 * 24 | 0) + 12 >> 2] = 8388608;
  HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i11 + 32 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i11 + 28 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i8 = HEAP32[i11 + 36 >> 2] | 0;
 i8 = (i8 | 0) == 0 ? 32 : i8 << 1;
 __ZN5physx5Elems4growEj(i11 + 8 | 0, i8);
 i1 = i11 + 68 | 0;
 i8 = ((i8 + 31 | 0) >>> 5) + 3 & 268435452;
 i2 = i11 + 72 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i8 >>> 0 > i4 >>> 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i8 << 2, gb + 717789 | 0, 59) | 0;
  if (i5 | 0) _memcpy(i6 | 0, i5 | 0, i3 << 2 | 0) | 0;
  _memset(i6 + (i4 << 2) | 0, 0, i8 - i3 << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i5);
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i8 | -2147483648;
 }
 i1 = i11 + 96 | 0;
 i2 = i11 + 100 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i8 >>> 0 > i4 >>> 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i8 << 2, gb + 717789 | 0, 59) | 0;
  if (i5 | 0) _memcpy(i6 | 0, i5 | 0, i3 << 2 | 0) | 0;
  _memset(i6 + (i4 << 2) | 0, 0, i8 - i3 << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i5);
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i8 | -2147483648;
 }
 i2 = i11 + 124 | 0;
 i3 = i11 + 128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 if (i8 >>> 0 > i5 >>> 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i8 << 2, gb + 717789 | 0, 59) | 0;
  if (i6 | 0) _memcpy(i1 | 0, i6 | 0, i4 << 2 | 0) | 0;
  _memset(i1 + (i5 << 2) | 0, 0, i8 - i4 << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i6);
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i8 | -2147483648;
 }
 i9 = HEAP32[i10 >> 2] | 0;
 i8 = i11 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i9 << 2) >> 2];
 i10 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 + (i9 * 24 | 0) + 8 >> 2] = -8388609;
 HEAP32[i10 + (i9 * 24 | 0) + 4 >> 2] = -8388609;
 HEAP32[i10 + (i9 * 24 | 0) >> 2] = -8388609;
 HEAP32[i10 + (i9 * 24 | 0) + 20 >> 2] = 8388608;
 HEAP32[i10 + (i9 * 24 | 0) + 16 >> 2] = 8388608;
 HEAP32[i10 + (i9 * 24 | 0) + 12 >> 2] = 8388608;
 HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i9 << 2) >> 2] = 0;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i9 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i9 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i11 + 32 >> 2] | 0) + (i9 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i11 + 28 >> 2] | 0) + (i9 << 2) >> 2] = 1073741823;
 i11 = i9;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5Umbra17ImpTomeCollection5buildEPPKNS_7ImpTomeEiRKNS_4AABBEPNS_9AllocatorEPKS0_(i19, i22, i23, i24, i1, i21) {
 i19 = i19 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i20 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i25;
 HEAP32[i2 >> 2] = gb + 80192 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 do if (!i1) if (!(HEAP32[i19 + 4 >> 2] | 0)) {
  i24 = 2;
  STACKTOP = i25;
  return i24 | 0;
 } else {
  i2 = i19;
  break;
 } while (0);
 i20 = i19 + 28 | 0;
 i18 = i19 + 24 | 0;
 if (!(HEAP8[i18 >> 0] | 0)) {
  i1 = i19 + 32 | 0;
  i3 = i20;
 } else {
  i3 = HEAP32[i20 >> 2] | 0;
  i1 = i19 + 32 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if (!i4) i3 = i20; else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 + (0 - (HEAP32[i4 + -4 >> 2] | 0)) | 0);
   i3 = i20;
  }
 }
 HEAP32[i19 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i19 + 36 >> 2] = 0;
 HEAP32[i19 + 40 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i18 >> 0] = 0;
 if ((i23 | 0) < 1) {
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 }
 L16 : do if ((i23 | 0) == 1) {
  i3 = HEAP32[i22 >> 2] | 0;
  i4 = i3;
  if (!i3) {
   i24 = 2;
   STACKTOP = i25;
   return i24 | 0;
  }
  i5 = HEAP32[i3 >> 2] | 0;
  i1 = i5 & 65535;
  if ((i5 & -65536 | 0) == -704643072) if ((i1 | 0) == 18) i1 = (i4 & 15 | 0) == 0 ? 0 : 6; else i1 = i1 >>> 0 > 18 ? 4 : 3; else i1 = (i1 | 0) == 214 ? 5 : 2;
  switch (i1 & 7) {
  case 0:
   {
    f13 = Math_fround(HEAPF32[i3 + 20 >> 2]);
    f14 = Math_fround(HEAPF32[i3 + 24 >> 2]);
    f15 = Math_fround(HEAPF32[i3 + 28 >> 2]);
    f16 = Math_fround(HEAPF32[i3 + 32 >> 2]);
    f17 = Math_fround(HEAPF32[i3 + 36 >> 2]);
    f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
    f7 = Math_fround(HEAPF32[i24 >> 2]);
    f8 = Math_fround(HEAPF32[i24 + 12 >> 2]);
    if (f7 <= f8) {
     f9 = Math_fround(HEAPF32[i24 + 4 >> 2]);
     f10 = Math_fround(HEAPF32[i24 + 16 >> 2]);
     if (f9 <= f10) {
      f11 = Math_fround(HEAPF32[i24 + 8 >> 2]);
      f12 = Math_fround(HEAPF32[i24 + 20 >> 2]);
      if (f11 <= f12) if (!(f7 >= f13) | !(f8 <= f16) | !(f9 >= f14) | !(f10 <= f17) | !(f11 >= f15) | !(f12 <= f6)) break L16;
     }
    }
    HEAP32[i19 + 32 >> 2] = i4;
    i24 = 0;
    STACKTOP = i25;
    return i24 | 0;
   }
  case 2:
   {
    i24 = 4;
    STACKTOP = i25;
    return i24 | 0;
   }
  default:
   {
    i24 = 2;
    STACKTOP = i25;
    return i24 | 0;
   }
  }
 } while (0);
 i3 = (i21 | 0) != 0;
 if (i3) if (!(HEAP32[i21 + 32 >> 2] | 0)) i5 = 0; else i5 = HEAP8[i21 + 24 >> 0] | 0 ? i21 + 28 | 0 : 0; else i5 = 0;
 HEAP8[i18 >> 0] = 1;
 i4 = i19 + 16 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) i1 = i19; else {
  i1 = i19 + 8 | 0;
  if (i3) if ((HEAP32[i21 + 12 >> 2] | 0) == (HEAP32[i19 + 12 >> 2] | 0)) {
   i24 = 2;
   STACKTOP = i25;
   return i24 | 0;
  }
 }
 i3 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 468, 0) | 0;
 if (!i3) {
  i24 = 1;
  STACKTOP = i25;
  return i24 | 0;
 }
 __ZN5Umbra20RuntimeTomeGeneratorC2EPNS_9AllocatorES2_jPPKNS_7ImpTomeEiRKNS_4AABBE(i3, i2, i1, 0, i22, i23, i24);
 i24 = __ZN5Umbra20RuntimeTomeGenerator9buildTomeERNS0_6ResultEPKS1_j(i3, i20, i5, HEAP32[i4 >> 2] | 0) | 0;
 __ZN5Umbra20RuntimeTomeGeneratorD2Ev(i3);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 STACKTOP = i25;
 return i24 | 0;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14VRSplashScreenC2Ebf10ColorRGBAfif8Vector3f(i9, i1, f2, i10, i11, f3, i4) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i10 = i10 | 0;
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 16 | 0;
 i12 = i15;
 i5 = i15 + 28 | 0;
 HEAP32[i9 >> 2] = gb + 189684 + 8;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 HEAP8[i9 + 17 >> 0] = 1;
 HEAP8[i9 + 18 >> 0] = i1 & 1;
 HEAPF64[i9 + 24 >> 3] = 0.0;
 HEAPF64[i9 + 32 >> 3] = +f2;
 HEAPF32[i9 + 40 >> 2] = f3;
 HEAP8[i9 + 45 >> 0] = 0;
 i7 = i9 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1044248 | 0, 6);
 HEAP32[i12 >> 2] = gb + 1044265;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i5, gb + 1044255 | 0, i12) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 >> 2] | 0, gb + 29832 | 0) | 0;
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZN9Transform11SetPositionERK8Vector3f(i8, i4);
 __ZN6Camera13SetClearFlagsEi(i7, 2);
 i6 = HEAP32[(__Z17GetPlayerSettingsv() | 0) + 260 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i5);
    i4 = HEAP32[i12 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i4 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 + (i5 << 3) | 0)) i14 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i14 = 9;
  }
  if ((i14 | 0) == 7) i14 = 9;
  if ((i14 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
 } while (0);
 __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i7, i10);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 1044272 | 0, 16);
 HEAP32[i13 >> 2] = 0;
 i16 = i9 + 8 | 0;
 HEAP32[i16 >> 2] = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i12, gb + 1044255 | 0, i13) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i16 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i13, i8);
 __ZN9Transform11SetPositionERK8Vector3f(i16, i13);
 HEAP8[i9 + 44 >> 0] = (i11 | 0) == 1 & 1;
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertENS_11__wrap_iterIPKS6_EERSA_(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i7 = i11;
 i11 = i11 + ((((HEAP32[i2 >> 2] | 0) - i7 | 0) / 12 | 0) * 12 | 0) | 0;
 i12 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i10 + 8 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i3 = i2;
 i5 = i9;
 if (i2 >>> 0 < i9 >>> 0) {
  if ((i11 | 0) == (i2 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i1);
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 12;
   i12 = i11;
   return i12 | 0;
  }
  i5 = i3 - (i11 + 12) | 0;
  i3 = i11 + (((i5 | 0) / 12 | 0) * 12 | 0) | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   i4 = i3;
   i6 = i2;
   do {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i4);
    i4 = i4 + 12 | 0;
    i6 = (HEAP32[i12 >> 2] | 0) + 12 | 0;
    HEAP32[i12 >> 2] = i6;
   } while (i4 >>> 0 < i2 >>> 0);
  }
  if (i5 | 0) do {
   i2 = i2 + -12 | 0;
   i3 = i3 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
  } while ((i3 | 0) != (i11 | 0));
  if (i11 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i12 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 12 | 0 : i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i11, i1) | 0;
  i12 = i11;
  return i12 | 0;
 }
 i6 = ((i3 - i7 | 0) / 12 | 0) + 1 | 0;
 if (i6 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i9 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = i4;
  i2 = i5;
  i3 = i7;
 }
 i4 = (i2 - i3 | 0) / 12 | 0;
 i7 = i4 << 1;
 i7 = i4 >>> 0 < 178956970 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 357913941;
 i3 = i11 - i3 | 0;
 i4 = (i3 | 0) / 12 | 0;
 if (!i7) i8 = 0; else i8 = __Znwj(i7 * 12 | 0) | 0;
 i6 = i8 + (i4 * 12 | 0) | 0;
 i5 = i6;
 i2 = i8 + (i7 * 12 | 0) | 0;
 do if ((i4 | 0) == (i7 | 0)) {
  if ((i3 | 0) > 0) {
   i5 = i6 + (((i7 + 1 | 0) / -2 | 0) * 12 | 0) | 0;
   break;
  }
  i2 = i7 * 12 | 0;
  i2 = (i2 | 0) == 0 ? 1 : ((i2 | 0) / 12 | 0) << 1;
  if (!i2) i3 = 0; else i3 = __Znwj(i2 * 12 | 0) | 0;
  i4 = i3 + ((i2 >>> 2) * 12 | 0) | 0;
  i2 = i3 + (i2 * 12 | 0) | 0;
  if (!i8) i5 = i4; else {
   __ZdlPv(i8);
   i5 = i4;
  }
 } while (0);
 i3 = i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i1);
 i1 = i3 + 12 | 0;
 i3 = i1;
 i8 = i5;
 i7 = HEAP32[i10 >> 2] | 0;
 if ((i7 | 0) == (i11 | 0)) {
  i4 = i8;
  i6 = i5;
 } else {
  i6 = i11;
  i4 = i8;
  do {
   i6 = i6 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4 + -12 | 0, i6);
   i4 = i5 + -12 | 0;
   i5 = i4;
  } while ((i6 | 0) != (i7 | 0));
  i6 = i5;
 }
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) == (i11 | 0)) {
  i5 = i3;
  i1 = i11;
 } else {
  i4 = i11;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
   i4 = i4 + 12 | 0;
   i1 = i3 + 12 | 0;
   i3 = i1;
  } while ((i4 | 0) != (i5 | 0));
  i5 = i3;
  i4 = i6;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i9 >> 2] = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i3 | 0));
 if (!i3) {
  i12 = i8;
  return i12 | 0;
 }
 __ZdlPv(i3);
 i12 = i8;
 return i12 | 0;
}

function __ZN5physx24PxcArticulationFnsScalar8multiplyERKNS_12PxcFsInertiaERKNS_2Cm13SpatialVectorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f26 = Math_fround(f17 * Math_fround(HEAPF32[i2 >> 2]));
 f16 = Math_fround(f17 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f22 = Math_fround(f17 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f21 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 f6 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 20 >> 2]));
 f21 = Math_fround(f26 + f21);
 f6 = Math_fround(f16 + f6);
 f22 = Math_fround(f22 + Math_fround(f14 * Math_fround(HEAPF32[i2 + 24 >> 2])));
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f26 = Math_fround(f16 * Math_fround(HEAPF32[i2 + 32 >> 2]));
 f24 = Math_fround(f16 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f26 = Math_fround(f21 + f26);
 f24 = Math_fround(f6 + f24);
 f22 = Math_fround(f22 + Math_fround(f16 * Math_fround(HEAPF32[i2 + 40 >> 2])));
 f6 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f12 = Math_fround(f6 * f21);
 f20 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f4 = Math_fround(f6 * f20);
 f15 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f7 = Math_fround(f6 * f15);
 f10 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f25 = Math_fround(f10 * f19);
 f18 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f23 = Math_fround(f10 * f18);
 f13 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f25 = Math_fround(f12 + f25);
 f23 = Math_fround(f4 + f23);
 f7 = Math_fround(f7 + Math_fround(f10 * f13));
 f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f9 = Math_fround(f4 * f12);
 f5 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f8 = Math_fround(f4 * f5);
 f11 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f9 = Math_fround(f26 + Math_fround(f25 + f9));
 f8 = Math_fround(f24 + Math_fround(f23 + f8));
 f7 = Math_fround(f22 + Math_fround(f7 + Math_fround(f4 * f11)));
 f15 = Math_fround(Math_fround(Math_fround(f17 * f21) + Math_fround(f14 * f20)) + Math_fround(f16 * f15));
 f13 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(f14 * f18)) + Math_fround(f16 * f13));
 f11 = Math_fround(Math_fround(Math_fround(f17 * f12) + Math_fround(f14 * f5)) + Math_fround(f16 * f11));
 f16 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 96 >> 2]));
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 100 >> 2]));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 104 >> 2]));
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 112 >> 2]));
 f12 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 116 >> 2]));
 f14 = Math_fround(f16 + f14);
 f12 = Math_fround(f5 + f12);
 f10 = Math_fround(f6 + Math_fround(f10 * Math_fround(HEAPF32[i2 + 120 >> 2])));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 128 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 132 >> 2]));
 f6 = Math_fround(f15 + Math_fround(f14 + f6));
 f5 = Math_fround(f13 + Math_fround(f12 + f5));
 f4 = Math_fround(f11 + Math_fround(f10 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 136 >> 2]))));
 HEAPF32[i1 >> 2] = f9;
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f1 = Math_fround(HEAPF32[i11 >> 2]);
 f2 = Math_fround(HEAPF32[i11 + 48 >> 2]);
 if (f1 > f2) {
  f2 = Math_fround(-3402823469999999843913219.0e14);
  f4 = Math_fround(-3402823469999999843913219.0e14);
  f6 = Math_fround(-3402823469999999843913219.0e14);
  f7 = Math_fround(3402823469999999843913219.0e14);
  f5 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i12 = f1 > Math_fround(3402823469999999843913219.0e14);
  f7 = i12 ? Math_fround(3402823469999999843913219.0e14) : f1;
  f5 = Math_fround(HEAPF32[i11 + 16 >> 2]);
  i12 = f5 > Math_fround(3402823469999999843913219.0e14);
  f5 = i12 ? Math_fround(3402823469999999843913219.0e14) : f5;
  f3 = Math_fround(HEAPF32[i11 + 32 >> 2]);
  i12 = f3 > Math_fround(3402823469999999843913219.0e14);
  f3 = i12 ? Math_fround(3402823469999999843913219.0e14) : f3;
  i12 = f2 < Math_fround(-3402823469999999843913219.0e14);
  f2 = i12 ? Math_fround(-3402823469999999843913219.0e14) : f2;
  f4 = Math_fround(HEAPF32[i11 + 64 >> 2]);
  i12 = f4 < Math_fround(-3402823469999999843913219.0e14);
  f4 = i12 ? Math_fround(-3402823469999999843913219.0e14) : f4;
  f6 = Math_fround(HEAPF32[i11 + 80 >> 2]);
  i12 = f6 < Math_fround(-3402823469999999843913219.0e14);
  f6 = i12 ? Math_fround(-3402823469999999843913219.0e14) : f6;
 }
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i11 + 52 >> 2]);
 if (!(f8 > f1)) {
  f13 = Math_fround(HEAPF32[i11 + 20 >> 2]);
  f9 = Math_fround(HEAPF32[i11 + 36 >> 2]);
  f15 = Math_fround(HEAPF32[i11 + 68 >> 2]);
  f14 = Math_fround(HEAPF32[i11 + 84 >> 2]);
  f2 = f2 > f1 ? f2 : f1;
  f4 = f4 > f15 ? f4 : f15;
  f6 = f6 > f14 ? f6 : f14;
  f7 = f7 < f8 ? f7 : f8;
  f5 = f5 < f13 ? f5 : f13;
  f3 = f3 < f9 ? f3 : f9;
 }
 f8 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f1 = Math_fround(HEAPF32[i11 + 56 >> 2]);
 if (f8 > f1) f9 = f2; else {
  f14 = Math_fround(HEAPF32[i11 + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i11 + 40 >> 2]);
  f16 = Math_fround(HEAPF32[i11 + 72 >> 2]);
  f13 = Math_fround(HEAPF32[i11 + 88 >> 2]);
  f9 = f2 > f1 ? f2 : f1;
  f4 = f4 > f16 ? f4 : f16;
  f6 = f6 > f13 ? f6 : f13;
  f7 = f7 < f8 ? f7 : f8;
  f5 = f5 < f14 ? f5 : f14;
  f3 = f3 < f15 ? f3 : f15;
 }
 f1 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f2 = Math_fround(HEAPF32[i11 + 60 >> 2]);
 if (f1 > f2) {
  f14 = f9;
  f15 = f4;
  f16 = f6;
  f8 = f7;
  f9 = f5;
  f13 = f3;
  HEAPF32[i10 >> 2] = f8;
  i12 = i10 + 4 | 0;
  HEAPF32[i12 >> 2] = f9;
  i12 = i10 + 8 | 0;
  HEAPF32[i12 >> 2] = f13;
  i12 = i10 + 12 | 0;
  HEAPF32[i12 >> 2] = f14;
  i12 = i10 + 16 | 0;
  HEAPF32[i12 >> 2] = f15;
  i12 = i10 + 20 | 0;
  HEAPF32[i12 >> 2] = f16;
  return;
 }
 f17 = Math_fround(HEAPF32[i11 + 28 >> 2]);
 f13 = Math_fround(HEAPF32[i11 + 44 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 76 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + 92 >> 2]);
 f14 = f9 > f2 ? f9 : f2;
 f15 = f4 > f15 ? f4 : f15;
 f16 = f6 > f16 ? f6 : f16;
 f8 = f7 < f1 ? f7 : f1;
 f9 = f5 < f17 ? f5 : f17;
 f13 = f3 < f13 ? f3 : f13;
 HEAPF32[i10 >> 2] = f8;
 i12 = i10 + 4 | 0;
 HEAPF32[i12 >> 2] = f9;
 i12 = i10 + 8 | 0;
 HEAPF32[i12 >> 2] = f13;
 i12 = i10 + 12 | 0;
 HEAPF32[i12 >> 2] = f14;
 i12 = i10 + 16 | 0;
 HEAPF32[i12 >> 2] = f15;
 i12 = i10 + 20 | 0;
 HEAPF32[i12 >> 2] = f16;
 return;
}

function __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf(i3, i1, i2, f27) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f27 = Math_fround(f27);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0, i41 = 0, i42 = 0, i43 = 0, i44 = 0;
 i24 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i26 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = i24 >> 2;
 i22 = i4 >> 2;
 i23 = i26 + 3 >> 2;
 i24 = HEAP32[gb + 78976 + ((i24 & 3) << 2) >> 2] | 0;
 i25 = HEAP32[gb + 78992 + ((i19 & 3) << 2) >> 2] | 0;
 i26 = HEAP32[gb + 79008 + ((i26 & 3) << 2) >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (i22 << 10) | 0;
 i17 = i5 + (i23 - i22 << 10) | 0;
 i18 = i1 << 6;
 i19 = (i19 + 3 >> 2) - i1 | 0;
 i20 = i19 + -1 | 0;
 if ((i23 | 0) <= (i22 | 0)) {
  i26 = 0;
  return i26 | 0;
 }
 i21 = HEAP32[i3 + 4 >> 2] | 0;
 i16 = HEAP16[i3 >> 1] | 0;
 i14 = i16 & 255;
 i15 = (HEAPU8[i3 + 2 >> 0] | 0) - i14 << 1;
 i16 = (i16 & 65535) >>> 8 & 65535;
 i14 = i1 - (i14 << 1) | 0;
 i11 = HEAP32[gb + 79024 + ((i4 & 3) << 2) >> 2] & 65535;
 i12 = i23 + -1 | 0;
 i13 = (i19 | 0) == 0;
 i10 = i22;
 i3 = i5 + i18 | 0;
 i2 = i20;
 i1 = i5;
 while (1) {
  i9 = ((i10 | 0) == (i22 | 0) ? i11 : 65535) & ((i10 | 0) == (i12 | 0) ? i26 : -1);
  if (!i13) {
   i6 = i19;
   i7 = i9 & i24;
   i5 = 0;
   i4 = i21 + (i14 + (Math_imul(i15, i10 - i16 | 0) | 0) << 1) | 0;
   L8 : while (1) {
    while (1) {
     i44 = i6;
     i6 = i6 + -1 | 0;
     i8 = i4 + 2 | 0;
     i28 = i3;
     i42 = Math_fround(HEAPF32[i28 >> 2]) >= f27;
     i43 = Math_fround(HEAPF32[i28 + 4 >> 2]) >= f27;
     i41 = Math_fround(HEAPF32[i28 + 8 >> 2]) >= f27;
     i40 = Math_fround(HEAPF32[i28 + 12 >> 2]) >= f27;
     i38 = Math_fround(HEAPF32[i28 + 16 >> 2]) >= f27;
     i39 = Math_fround(HEAPF32[i28 + 20 >> 2]) >= f27;
     i37 = Math_fround(HEAPF32[i28 + 24 >> 2]) >= f27;
     i36 = Math_fround(HEAPF32[i28 + 28 >> 2]) >= f27;
     i34 = Math_fround(HEAPF32[i28 + 32 >> 2]) >= f27;
     i35 = Math_fround(HEAPF32[i28 + 36 >> 2]) >= f27;
     i33 = Math_fround(HEAPF32[i28 + 40 >> 2]) >= f27;
     i32 = Math_fround(HEAPF32[i28 + 44 >> 2]) >= f27;
     i30 = Math_fround(HEAPF32[i28 + 48 >> 2]) >= f27;
     i31 = Math_fround(HEAPF32[i28 + 52 >> 2]) >= f27;
     i29 = Math_fround(HEAPF32[i28 + 56 >> 2]) >= f27;
     i28 = Math_fround(HEAPF32[i28 + 60 >> 2]) >= f27;
     i5 = (1 - i44 >> 31 | i25) & i7 & (HEAPU16[i4 >> 1] | 0) & ((i43 ? 2 : 0) | i42 << 31 >> 31 >>> 31 | (i41 ? 4 : 0) | (i40 ? 8 : 0) | ((i39 ? 2 : 0) | i38 << 31 >> 31 >>> 31 | (i37 ? 4 : 0) | (i36 ? 8 : 0)) << 4 | ((i35 ? 2 : 0) | i34 << 31 >> 31 >>> 31 | (i33 ? 4 : 0) | (i32 ? 8 : 0)) << 8 | ((i31 ? 2 : 0) | i30 << 31 >> 31 >>> 31 | (i29 ? 4 : 0) | (i28 ? 8 : 0)) << 12) | i5;
     if (!i2) break;
     i3 = i3 + 64 | 0;
     i2 = i2 + -1 | 0;
     if (!i6) break L8; else {
      i7 = i9;
      i4 = i8;
     }
    }
    i1 = i1 + 1024 | 0;
    i2 = i1 >>> 0 < i17 >>> 0;
    i3 = i2 ? i1 + i18 | 0 : i3;
    i2 = i2 ? i20 : 0;
    if (!i6) break; else {
     i7 = i9;
     i4 = i8;
    }
   }
   if (i5) {
    i1 = 1;
    i2 = 11;
    break;
   }
  }
  i10 = i10 + 1 | 0;
  if ((i10 | 0) >= (i23 | 0)) {
   i1 = 0;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) return i1 | 0;
 return 0;
}

function __ZNK5physx7NpScene9getActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEjj(i9, i1, i10, i11, i12) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i8 = HEAP16[i1 >> 1] | 0;
 L1 : do if (!(i8 & 3)) {
  i2 = 0;
  i1 = 0;
 } else {
  i6 = HEAP32[i9 + 3556 >> 2] | 0;
  if ((i6 | 0) != 0 & (i11 | 0) != 0) {
   i7 = i9 + 3552 | 0;
   i5 = (i8 & 2) == 0;
   if (!(i8 & 1)) {
    i4 = 0;
    i2 = 0;
    i1 = 0;
    while (1) {
     if (!i5) {
      i13 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i3 = i13;
      if (!((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 5)) {
       if (i2 >>> 0 >= i12 >>> 0) {
        HEAP32[i10 + (i1 << 2) >> 2] = i3;
        i1 = i1 + 1 | 0;
       }
       i2 = i2 + 1 | 0;
      }
     }
     i4 = i4 + 1 | 0;
     if (!(i4 >>> 0 < i6 >>> 0 & i1 >>> 0 < i11 >>> 0)) break L1;
    }
   } else {
    i4 = 0;
    i2 = 0;
    i1 = 0;
   }
   do {
    i13 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i3 = i13;
    if ((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 6) {
     if (!i5) {
      i13 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i3 = i13;
      if (!((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 5)) {
       if (i2 >>> 0 >= i12 >>> 0) {
        HEAP32[i10 + (i1 << 2) >> 2] = i3;
        i1 = i1 + 1 | 0;
       }
       i2 = i2 + 1 | 0;
      }
     }
    } else {
     if (i2 >>> 0 >= i12 >>> 0) {
      HEAP32[i10 + (i1 << 2) >> 2] = i3;
      i1 = i1 + 1 | 0;
     }
     i2 = i2 + 1 | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i6 >>> 0 & i1 >>> 0 < i11 >>> 0);
  } else {
   i2 = 0;
   i1 = 0;
  }
 } while (0);
 L29 : do if (i8 & 12) {
  i5 = HEAP32[i9 + 3644 >> 2] | 0;
  if ((i5 | 0) != 0 & i1 >>> 0 < i11 >>> 0) {
   i6 = i9 + 3640 | 0;
   i7 = (i8 & 8) == 0;
   if (!(i8 & 4)) {
    i4 = 0;
    while (1) {
     if (!i7) {
      i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i3 = i13;
      if (!((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 12)) {
       if (i2 >>> 0 >= i12 >>> 0) {
        HEAP32[i10 + (i1 << 2) >> 2] = i3;
        i1 = i1 + 1 | 0;
       }
       i2 = i2 + 1 | 0;
      }
     }
     i4 = i4 + 1 | 0;
     if (!(i4 >>> 0 < i5 >>> 0 & i1 >>> 0 < i11 >>> 0)) break L29;
    }
   } else i4 = 0;
   do {
    i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i3 = i13;
    if ((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 11) {
     if (!i7) {
      i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i3 = i13;
      if (!((i13 | 0) == 0 ? 1 : (HEAP16[i13 + 4 >> 1] | 0) != 12)) {
       if (i2 >>> 0 >= i12 >>> 0) {
        HEAP32[i10 + (i1 << 2) >> 2] = i3;
        i1 = i1 + 1 | 0;
       }
       i2 = i2 + 1 | 0;
      }
     }
    } else {
     if (i2 >>> 0 >= i12 >>> 0) {
      HEAP32[i10 + (i1 << 2) >> 2] = i3;
      i1 = i1 + 1 | 0;
     }
     i2 = i2 + 1 | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i5 >>> 0 & i1 >>> 0 < i11 >>> 0);
  }
 } while (0);
 if (!(i8 & 32)) {
  i13 = i1;
  return i13 | 0;
 }
 i5 = HEAP32[i9 + 3656 >> 2] | 0;
 if (!(i1 >>> 0 < i11 >>> 0 & (i5 | 0) != 0)) {
  i13 = i1;
  return i13 | 0;
 }
 i3 = i9 + 3652 | 0;
 i4 = 0;
 while (1) {
  if (i2 >>> 0 >= i12 >>> 0) {
   HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = i1 + 1 | 0;
  }
  i4 = i4 + 1 | 0;
  if (!(i1 >>> 0 < i11 >>> 0 & i4 >>> 0 < i5 >>> 0)) break; else i2 = i2 + 1 | 0;
 }
 return i1 | 0;
}

function __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE(i19, i20, i1) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i21 + 3 | 0;
 i7 = i21 + 2 | 0;
 i14 = i21 + 1 | 0;
 i15 = i21;
 i16 = i19 + 12 | 0;
 i17 = i19 + 40 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i22 = 0;
  STACKTOP = i21;
  return i22 | 0;
 }
 i18 = i19 + 1644 | 0;
 i9 = i19 + 36 | 0;
 i10 = i19 + 24 | 0;
 i11 = i19 + 28 | 0;
 i12 = i19 + 4 | 0;
 i13 = i19 + 8 | 0;
 while (1) {
  do if (!(HEAP8[i18 >> 0] | 0)) i22 = 8; else {
   f25 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) >> 2]);
   f2 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 8 >> 2]);
   f23 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 16 >> 2]);
   f4 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 24 >> 2]);
   f24 = Math_fround(HEAPF32[i19 >> 2]);
   if (!(!(f24 >= f25) | !(f24 <= f23))) {
    f25 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 20 >> 2]);
    f23 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 4 >> 2]);
    f24 = Math_fround(HEAPF32[i12 >> 2]);
    if (!(!(f24 >= f23) | !(f24 <= f25))) {
     f25 = Math_fround(HEAPF32[i13 >> 2]);
     HEAP8[i18 >> 0] = 0;
     if (f25 >= f2 & f25 <= f4) {
      i22 = 8;
      break;
     }
     i1 = i1 + -1 | 0;
     HEAP32[i17 >> 2] = i1;
     break;
    }
   }
   HEAP8[i18 >> 0] = 0;
   i1 = i1 + -1 | 0;
   HEAP32[i17 >> 2] = i1;
  } while (0);
  if ((i22 | 0) == 8) {
   i22 = 0;
   i3 = HEAP8[i19 + 44 + (i1 * 40 | 0) + 29 >> 0] | 0;
   if (i3 << 24 >> 24 == 3) break;
   i5 = i3 & 255;
   f2 = Math_fround(HEAPF32[i19 + (i5 << 2) >> 2]);
   i6 = HEAP32[i19 + 44 + (i1 * 40 | 0) + 12 >> 2] | 0;
   if ((HEAP32[i9 >> 2] | 0) > (i6 | 0)) {
    i3 = f2 < Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2]);
    i3 = i3 ? 1 : 2;
    f2 = Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2]);
   } else {
    f25 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + (i5 << 2) >> 2]);
    i3 = f2 < Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 16 + (i5 << 2) >> 2])) * Math_fround(.5));
    f2 = Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + (i5 << 2) >> 2]);
    i3 = i3 ? 1 : 2;
    f2 = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i19 + 44 + (i1 * 40 | 0) + 16 + (i5 << 2) >> 2])) * Math_fround(.5));
   };
   HEAP8[i7 >> 0] = HEAP8[i14 >> 0] | 0;
   HEAP8[i8 >> 0] = HEAP8[i15 >> 0] | 0;
   __ZN5Umbra15KDTraverseStackINS_10NoUserDataEE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbS1_S1_(i16, i3, f2, 1, i7, i8);
   i1 = HEAP32[i17 >> 2] | 0;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i22 = 16;
   break;
  }
 }
 if ((i22 | 0) == 16) {
  STACKTOP = i21;
  return i1 | 0;
 }
 i22 = i19 + 44 + (i1 * 40 | 0) | 0;
 HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
 HEAP32[i20 + 12 >> 2] = HEAP32[i22 + 12 >> 2];
 HEAP32[i20 + 16 >> 2] = HEAP32[i22 + 16 >> 2];
 HEAP32[i20 + 20 >> 2] = HEAP32[i22 + 20 >> 2];
 HEAP32[i20 + 24 >> 2] = HEAP32[i22 + 24 >> 2];
 HEAP32[i20 + 28 >> 2] = HEAP32[i22 + 28 >> 2];
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
 i22 = 1;
 STACKTOP = i21;
 return i22 | 0;
}

function __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE(i8, i1, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i7 << 24 >> 24 < 0;
 L1 : do switch ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255) | 0) {
 case 8:
  {
   if (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489801 | 0, 8) | 0) if (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489810 | 0, 8) | 0) break L1;
   i9 = __Z37ReadDirectoryInfo_UnityWebAndUnityRawR12FileAccessorRKN20ArchiveStorageHeader6HeaderERNS1_13DirectoryInfoE(i8, 0, i6) | 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 12:
  {
   if (!(_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489819 | 0, 12) | 0)) {
    i9 = -1;
    STACKTOP = i10;
    return i9 | 0;
   }
   break;
  }
 default:
  {}
 } while (0);
 i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 4, 0, i3, i9) | 0;
 i7 = i9;
 L10 : do if (i5 & ((HEAP32[i7 >> 2] | 0) == 4 & (HEAP32[i7 + 4 >> 2] | 0) == 0)) {
  i4 = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i4;
  i7 = i6 + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = (i2 - i3 | 0) / 40 | 0;
  if (i4 >>> 0 > i1 >>> 0) {
   __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i6, i4 - i1 | 0);
   i2 = HEAP32[i7 >> 2] | 0;
  } else if (i4 >>> 0 < i1 >>> 0) {
   i4 = i3 + (i4 * 40 | 0) | 0;
   if ((i2 | 0) != (i4 | 0)) {
    i5 = i9 + 4 | 0;
    do {
     i1 = i2 + -40 | 0;
     HEAP32[i7 >> 2] = i1;
     i3 = i2 + -20 | 0;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i2 + -8 >> 2] | 0;
      HEAP32[i9 >> 2] = 54;
      HEAP32[i5 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
      i2 = HEAP32[i7 >> 2] | 0;
     } else i2 = i1;
    } while ((i2 | 0) != (i4 | 0));
    i2 = i4;
   }
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = 0; else {
   i2 = i1;
   while (1) {
    i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 8, 0, i2, i9) | 0;
    i6 = i9;
    if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 8 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
     i1 = 1;
     break L10;
    }
    i5 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
    i1 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    HEAP32[i1 >> 2] = i5;
    i1 = i2 + 8 | 0;
    i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 8, 0, i1, i9) | 0;
    i6 = i9;
    if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 8 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
     i1 = 1;
     break L10;
    }
    i6 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    i5 = i1 + 4 | 0;
    HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
    HEAP32[i5 >> 2] = i6;
    i1 = i2 + 16 | 0;
    i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 4, 0, i1, i9) | 0;
    i6 = i9;
    if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 4 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
     i1 = 1;
     break L10;
    }
    HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i8, i2 + 20 | 0) | 0)) {
     i1 = 1;
     break L10;
    }
    i2 = i2 + 40 | 0;
    if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
     i1 = 0;
     break;
    }
   }
  }
 } else i1 = 1; while (0);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN12FixedJoint2D6CreateEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i6 = i11;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i9 + 36 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i5 = HEAP32[i1 + 32 >> 2] | 0;
    i3 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i6);
    i3 = HEAP32[i10 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i12 = HEAP32[gb + 1104264 >> 2] | 0;
    i3 = (i3 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i3 << 3) | 0;
    i4 = HEAP32[i12 + 28 >> 2] | 0;
    i5 = HEAP32[i12 + 32 >> 2] | 0;
    i1 = i12;
   }
   if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i8 = 9; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i8 = 11;
  }
  if ((i8 | 0) == 9) i8 = 11;
  if ((i8 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i8 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i6);
    i3 = HEAP32[i10 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i8 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 20;
   }
  }
  if ((i8 | 0) == 18) i8 = 20;
  if ((i8 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i11;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i11;
   return;
  }
 } while (0);
 i12 = i10 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP8[i12 + 12 >> 0] = 0;
 HEAP32[i10 >> 2] = 8;
 i12 = i10 + 20 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i10 + 44 >> 2] = HEAP32[i9 + 96 >> 2];
 HEAP32[i10 + 40 >> 2] = HEAP32[i9 + 100 >> 2];
 if (!(HEAP8[i9 + 104 >> 0] | 0)) {
  f2 = Math_fround(HEAPF32[(__ZNK7Joint2D10FetchBodyBEv(i9) | 0) + 56 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[(__ZNK7Joint2D10FetchBodyAEv(i9) | 0) + 56 >> 2]));
 } else f2 = Math_fround(HEAPF32[i9 + 108 >> 2]);
 HEAPF32[i10 + 36 >> 2] = f2;
 __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i9, i10 + 20 | 0, i10 + 28 | 0);
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i9, i10);
 STACKTOP = i11;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EEc(i9, i6, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i9 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i4 = 23;
 } else do if (HEAP8[i1 >> 0] | 0) {
  i5 = i6 + 24 | 0;
  i4 = i6 + 28 | 0;
  while (1) {
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 9;
     break;
    }
    if ((i1 | 0) == -1) {
     i1 = 2;
     i4 = 17;
     break;
    }
   } else i1 = HEAPU8[i2 >> 0] | 0;
   i2 = i1 & 255;
   if (i2 << 24 >> 24 == i7 << 24 >> 24) {
    i1 = 0;
    i4 = 17;
    break;
   }
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i1 & 255 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 15;
     break;
    }
    if ((i1 | 0) == -1) {
     i1 = 0;
     i4 = 17;
     break;
    }
   } else {
    HEAP32[i5 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i2;
   }
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 15;
     break;
    } else continue;
   } else {
    HEAP32[i2 >> 2] = i3 + 1;
    continue;
   }
  }
  if ((i4 | 0) == 9) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i4 = 16;
  } else if ((i4 | 0) == 15) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i4 = 16;
  }
  if ((i4 | 0) == 16) {
   ___cxa_begin_catch(i1 | 0) | 0;
   __THREW__ = 0;
   invoke_v(fb + 458 | 0);
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    i1 = 0;
    i4 = 17;
   }
  }
  if ((i4 | 0) == 17) {
   i7 = i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | ((HEAP32[i8 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) break;
  }
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i4 = 23;
  break L1;
 } while (0); while (0);
 do if ((i4 | 0) == 23) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i9 | 0;
}

function __Z19sweepConvex_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i2, i3, i4, i9, f5, i8, i6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 f5 = Math_fround(f5);
 i8 = i8 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i10 + 12 | 0;
 i12 = i10;
 i11 = i10 + 72 | 0;
 HEAP32[i13 + 36 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i13 + 40 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i13 + 44 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i13 + 48 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 52 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 56 >> 2] = HEAP32[i1 + 12 >> 2];
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(f18 + f18);
 f14 = Math_fround(f17 + f17);
 f21 = Math_fround(f24 + f24);
 f23 = Math_fround(f17 * f14);
 f22 = Math_fround(f24 * f21);
 f17 = Math_fround(f16 * f17);
 f25 = Math_fround(f16 * f24);
 f15 = Math_fround(f16 * f19);
 f24 = Math_fround(f14 * f24);
 f14 = Math_fround(f14 * f19);
 f19 = Math_fround(f21 * f19);
 f21 = Math_fround(f17 + f19);
 f20 = Math_fround(f25 - f14);
 f19 = Math_fround(f17 - f19);
 f16 = Math_fround(Math_fround(1.0) - Math_fround(f18 * f16));
 f18 = Math_fround(f16 - f22);
 f17 = Math_fround(f24 + f15);
 f14 = Math_fround(f25 + f14);
 f15 = Math_fround(f24 - f15);
 f16 = Math_fround(f16 - f23);
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f23) - f22);
 HEAPF32[i13 + 4 >> 2] = f21;
 HEAPF32[i13 + 8 >> 2] = f20;
 HEAPF32[i13 + 12 >> 2] = f19;
 HEAPF32[i13 + 16 >> 2] = f18;
 HEAPF32[i13 + 20 >> 2] = f17;
 HEAPF32[i13 + 24 >> 2] = f14;
 HEAPF32[i13 + 28 >> 2] = f15;
 HEAPF32[i13 + 32 >> 2] = f16;
 f16 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
 i1 = i9 + 4 | 0;
 f15 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 i2 = i9 + 8 | 0;
 f14 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i12 >> 2] = f16;
 HEAPF32[i12 + 4 >> 2] = f15;
 HEAPF32[i12 + 8 >> 2] = f14;
 HEAP16[i11 >> 1] = HEAP16[i6 >> 1] | 0;
 if (!(__Z19sweepBox_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i3, i4, i13, i12, f5, i8, i11, f7) | 0)) {
  i13 = 0;
  STACKTOP = i10;
  return i13 | 0;
 }
 if (HEAP16[i8 + 12 >> 1] & 1) {
  f25 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  f23 = Math_fround(f25 * Math_fround(HEAPF32[i9 >> 2]));
  f24 = Math_fround(f25 * Math_fround(HEAPF32[i1 >> 2]));
  f25 = Math_fround(f25 * Math_fround(HEAPF32[i2 >> 2]));
  i13 = i8 + 16 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f23 + Math_fround(HEAPF32[i13 >> 2]));
  i13 = i8 + 20 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f24 + Math_fround(HEAPF32[i13 >> 2]));
  i13 = i8 + 24 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f25 + Math_fround(HEAPF32[i13 >> 2]));
 }
 i11 = i8 + 28 | 0;
 f23 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 i12 = i8 + 32 | 0;
 f24 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 i13 = i8 + 36 | 0;
 f25 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i11 >> 2] = f23;
 HEAPF32[i12 >> 2] = f24;
 HEAPF32[i13 >> 2] = f25;
 HEAP32[i8 + 8 >> 2] = -1;
 i13 = 1;
 STACKTOP = i10;
 return i13 | 0;
}

function __ZNK7Terrain12GetWorldAABBEv(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 4 | 0;
 i10 = i11;
 i4 = i8 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  i5 = i1 + 248 | 0;
  i4 = HEAP32[i5 + 80 >> 2] | 0;
  i6 = 1 << i4;
  if ((i4 | 0) > 0) {
   i1 = i6;
   i2 = 0;
   i3 = 0;
   while (1) {
    i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i1 = i1 >> 1;
   }
   i1 = i2 << 1;
  } else i1 = 0;
  i4 = HEAP32[i5 + 44 >> 2] | 0;
  f17 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
  f16 = Math_fround(HEAPF32[i4 + ((i1 | 1) << 2) >> 2]);
  f20 = Math_fround(HEAPF32[i5 + 88 >> 2]);
  f13 = Math_fround(f20 * Math_fround(0.0));
  f18 = Math_fround(HEAPF32[i5 + 96 >> 2]);
  f12 = Math_fround(f18 * Math_fround(0.0));
  f19 = Math_fround(HEAPF32[i5 + 92 >> 2]);
  f17 = Math_fround(f17 * f19);
  f15 = Math_fround(i6 << 4 | 0);
  f20 = Math_fround(f15 * f20);
  f18 = Math_fround(f15 * f18);
  f19 = Math_fround(f16 * f19);
  f16 = Math_fround(Math_fround(f13 + f20) * Math_fround(.5));
  f15 = Math_fround(Math_fround(f17 + f19) * Math_fround(.5));
  f14 = Math_fround(Math_fround(f12 + f18) * Math_fround(.5));
  f13 = Math_fround(Math_fround(f20 - f13) * Math_fround(.5));
  f17 = Math_fround(Math_fround(f19 - f17) * Math_fround(.5));
  f12 = Math_fround(Math_fround(f18 - f12) * Math_fround(.5));
  HEAPF32[i10 >> 2] = f17;
  HEAPF32[i9 >> 2] = Math_fround(.0000999999974);
  i6 = f17 < Math_fround(.0000999999974);
  i10 = HEAP32[(i6 ? i9 : i10) >> 2] | 0;
  HEAPF32[i7 >> 2] = f16;
  HEAPF32[i7 + 4 >> 2] = f15;
  HEAPF32[i7 + 8 >> 2] = f14;
  HEAPF32[i7 + 12 >> 2] = f13;
  HEAP32[i7 + 16 >> 2] = i10;
  HEAPF32[i7 + 20 >> 2] = f12;
 } while (0);
 __ZNK9Transform11GetPositionEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f20 = Math_fround(HEAPF32[i9 >> 2]);
 HEAPF32[i7 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i7 >> 2]));
 f20 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i10 = i7 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i10 >> 2]));
 f20 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i10 = i7 + 8 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i10 >> 2]));
 STACKTOP = i11;
 return;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK8GUIStyle10DrawCursorER8GUIStateRK5RectTIfER10GUIContentiRK10ColorRGBAf(i5, i6, i8, i9, i10, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 20 | 0;
 i12 = i15;
 i13 = i15 + 16 | 0;
 if (!(HEAP32[i6 + 60 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i7 = __ZN10builtintex15GetWhiteTextureEv() | 0;
 i1 = __ZNK8GUIStyle14GetCurrentFontEv(i5) | 0;
 do if (!i1) f2 = Math_fround(0.0); else {
  i3 = HEAP32[i5 + 284 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i1 + 36 >> 2] | 0;
   if (i4 | 0) {
    f2 = Math_fround(Math_fround(Math_fround(((i3 | 0) > 500 ? 500 : i3) | 0) * Math_fround(HEAPF32[i1 + 32 >> 2])) / Math_fround(i4 | 0));
    break;
   }
  }
  f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 } while (0);
 i1 = HEAP32[gb + 1468864 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 1017441 | 0, 30);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1468864 >> 2] = i1;
  __Z24InitializeGUIClipTexturev();
  i1 = HEAP32[gb + 1468864 >> 2] | 0;
 }
 f19 = Math_fround(HEAPF32[i11 >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i6 + 12 >> 2]));
 f18 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i6 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i6 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i6 + 24 >> 2]));
 i4 = f19 < Math_fround(0.0);
 f19 = i4 ? Math_fround(0.0) : f19;
 i4 = f19 > Math_fround(1.0);
 i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f18 < Math_fround(0.0);
 f18 = i3 ? Math_fround(0.0) : f18;
 i3 = f18 > Math_fround(1.0);
 i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i6 = f16 < Math_fround(0.0);
 f16 = i6 ? Math_fround(0.0) : f16;
 i6 = f16 > Math_fround(1.0);
 i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f16) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i11 = f17 < Math_fround(0.0);
 f17 = i11 ? Math_fround(0.0) : f17;
 i11 = f17 > Math_fround(1.0);
 i11 = ~~Math_fround(Math_fround((i11 ? Math_fround(1.0) : f17) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i14, i5, i8, i9, i10);
 f17 = Math_fround(HEAPF32[i14 >> 2]);
 f17 = Math_fround(f17 - Math_fround(HEAPF32[i5 + 268 >> 2]));
 f16 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i5 + 272 >> 2]));
 HEAPF32[i12 >> 2] = f17;
 HEAPF32[i12 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 4 >> 2] = f16;
 HEAPF32[i12 + 12 >> 2] = f2;
 HEAP32[i13 >> 2] = i3 << 8 & 65280 | i4 & 255 | i6 << 16 & 16711680 | i11 << 24;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i12, i7, i14, i1, -1);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES6_EELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI14SafeBinaryReadEEvRS5_RT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI14SafeBinaryReadEEvRS5_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE(i13, i9, i10, i12, i2, i11, i14) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 152 | 0;
 i3 = i15 + 88 | 0;
 i4 = i15 + 12 | 0;
 i5 = i15 + 8 | 0;
 i1 = i15;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 if (!(_strcmp(i7 | 0 ? i7 : gb + 1576256 | 0, gb + 776443 | 0) | 0)) HEAP32[i1 + 4 >> 2] = gb + 776451;
 i2 = HEAP32[i13 + 64 >> 2] | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i16 | 0, i1 | 0);
 i18 = HEAP32[i8 + 12 >> 2] | 0;
 i6 = i1;
 i19 = (i18 | 0) == 77;
 i1 = i19 ? gb + 776461 | 0 : HEAP32[i6 + 4 >> 2] | 0;
 i6 = i19 ? gb + 776474 | 0 : HEAP32[i6 >> 2] | 0;
 i7 = i1;
 i20 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i20 + 40 >> 2] | 0;
 mftCall_viii(HEAP32[i20 + 16 >> 2] | 0, i4 | 0, i16 | 0, i9 | 0);
 HEAP32[i3 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 >> 2] = i19 ? 78 : i18;
 mftCall_viiiiiii(i17 | 0, i15 + 96 | 0, i16 | 0, i3 | 0, i10 | 0, i12 | 0, i5 | 0, i11 | 0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 if ((i11 | 0) == 2) if (!(_strcmp(i1 | 0 ? i7 : gb + 1576256 | 0, gb + 776461 | 0) | 0)) {
  i20 = 2;
  STACKTOP = i15;
  return i20 | 0;
 }
 i4 = (HEAP32[i14 + 4 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) >> 3;
 i1 = i4 * 12 | 0;
 if (i1 >>> 0 > (HEAP32[i13 + 88 >> 2] | 0) >>> 0) {
  HEAP8[i8 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i13 + 72 | 0, i1, i8);
 }
 i3 = HEAP32[i13 + 84 >> 2] | 0;
 i1 = (i4 | 0) == 0;
 if (!i1) {
  i2 = 0;
  do {
   HEAP32[i3 + (i2 * 12 | 0) >> 2] = gb + 149900 + 8;
   HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i1) {
   i1 = 0;
   do {
    i18 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 3) >> 2] | 0) | 0;
    i19 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
    i20 = i3 + (i1 * 12 | 0) + 4 | 0;
    HEAP32[i20 >> 2] = i18;
    HEAP32[i20 + 4 >> 2] = i19;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 i5 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, HEAP32[i9 >> 2] | 0) | 0;
 i14 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, HEAP32[i9 + 4 >> 2] | 0) | 0;
 i17 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, i10) | 0;
 i20 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, i12) | 0;
 i18 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, i6) | 0;
 i19 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i13, i7) | 0;
 HEAP32[i8 >> 2] = gb + 149920 + 8;
 i16 = i8 + 4 | 0;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i16 + 4 >> 2] = i14;
 HEAP32[i8 + 12 >> 2] = i17;
 HEAP32[i8 + 16 >> 2] = i20;
 i20 = i8 + 20 | 0;
 HEAP32[i20 >> 2] = i18;
 HEAP32[i20 + 4 >> 2] = i19;
 HEAP32[i8 + 28 >> 2] = i11;
 HEAP32[i8 + 32 >> 2] = i3;
 HEAP32[i8 + 36 >> 2] = i3 + (i4 * 12 | 0);
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i13, i8, 4);
 i20 = (HEAPU8[i13 + 392 >> 0] | 0) ^ 1;
 STACKTOP = i15;
 return i20 | 0;
}

function __ZN5physx2Cm12RenderOutputlsERKNS0_9DebugTextE(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 i11 = _strlen(i13) | 0;
 i12 = i14 + 100 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 52 | 0;
 i4 = HEAP32[i1 + 56 >> 2] | 0;
 i3 = i11 + 1 + i4 | 0;
 if ((HEAP32[i1 + 60 >> 2] & 2147483647) >>> 0 < i3 >>> 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i2, i3);
  i1 = HEAP32[i12 >> 2] | 0;
  i3 = (HEAP32[i1 + 52 >> 2] | 0) - i9 | 0;
  if (HEAP32[i1 + 44 >> 2] | 0) {
   i2 = 0;
   do {
    i1 = (HEAP32[i1 + 40 >> 2] | 0) + (i2 * 24 | 0) + 20 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i3;
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   } while (i2 >>> 0 < (HEAP32[i1 + 44 >> 2] | 0) >>> 0);
  }
  i9 = i1;
  i4 = HEAP32[i1 + 56 >> 2] | 0;
 } else i9 = i1;
 i5 = i9 + 40 | 0;
 f17 = Math_fround(HEAPF32[i13 + 1008 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + 1012 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 1016 >> 2]);
 f19 = Math_fround(f17 * Math_fround(HEAPF32[i14 + 36 >> 2]));
 f16 = Math_fround(f17 * Math_fround(HEAPF32[i14 + 40 >> 2]));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i14 + 44 >> 2]));
 f18 = Math_fround(f6 * Math_fround(HEAPF32[i14 + 52 >> 2]));
 f7 = Math_fround(f6 * Math_fround(HEAPF32[i14 + 56 >> 2]));
 f18 = Math_fround(f19 + f18);
 f7 = Math_fround(f16 + f7);
 f6 = Math_fround(f17 + Math_fround(f6 * Math_fround(HEAPF32[i14 + 60 >> 2])));
 f17 = Math_fround(f8 * Math_fround(HEAPF32[i14 + 68 >> 2]));
 f16 = Math_fround(f8 * Math_fround(HEAPF32[i14 + 72 >> 2]));
 f17 = Math_fround(f18 + f17);
 f16 = Math_fround(f7 + f16);
 f8 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i14 + 76 >> 2])));
 f6 = Math_fround(HEAPF32[i14 + 84 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 88 >> 2]);
 f6 = Math_fround(f17 + f6);
 f7 = Math_fround(f16 + f7);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i14 + 92 >> 2]));
 i1 = (HEAP32[i9 + 52 >> 2] | 0) + i4 | 0;
 HEAPF32[i10 >> 2] = f6;
 HEAPF32[i10 + 4 >> 2] = f7;
 HEAPF32[i10 + 8 >> 2] = f8;
 i3 = i10 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i13 + 1020 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 20 >> 2] = i1;
 i1 = i9 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i9 + 48 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAPF32[i5 + (i2 * 24 | 0) >> 2] = f6;
  HEAPF32[i5 + (i2 * 24 | 0) + 4 >> 2] = f7;
  HEAPF32[i5 + (i2 * 24 | 0) + 8 >> 2] = f8;
  i5 = i5 + (i2 * 24 | 0) + 12 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i5 = 0;
 } else {
  __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i5, i10) | 0;
  i5 = 0;
 }
 do {
  i10 = HEAP32[i12 >> 2] | 0;
  i1 = i10 + 52 | 0;
  i2 = i13 + i5 | 0;
  i3 = i10 + 56 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i10 + 60 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP8[(HEAP32[i1 >> 2] | 0) + i4 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i1, i2) | 0;
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 <= i11 >>> 0);
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i6 = i9 + 28 | 0;
 i12 = i9 + 40 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i8 = i9 + 44 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i5;
 i7 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i2 = __Znwj(1) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i9 + 32 >> 2] = i2;
   }
   i1 = HEAP32[i9 + 48 >> 2] | 0;
  } else {
   i1 = i2 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i7 - i5 | 0;
  i7 = i5 + 24 | 0;
  i7 = i1 >>> 0 < i7 >>> 0 ? i7 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i7, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i8 >> 2] = i6 + i7;
 }
 HEAP32[i12 >> 2] = i1 + 24;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 4;
 i1 = HEAP32[i11 >> 2] | 0;
 L11 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L11;
  }
  i1 = i1 + 1 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 if ((HEAP8[i1 >> 0] | 0) == 93) {
  HEAP32[i11 >> 2] = i1 + 1;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 + -8 >> 2] = 4;
  HEAP32[i12 + -24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i12 + -16 >> 2] = 0;
  HEAP32[i12 + -20 >> 2] = 0;
  return;
 }
 __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9);
 i4 = i10 + 24 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) i3 = 0; else return;
 L21 : while (1) {
  i2 = HEAP32[i11 >> 2] | 0;
  L23 : while (1) {
   switch (HEAP8[i2 >> 0] | 0) {
   case 9:
   case 13:
   case 10:
   case 32:
    break;
   default:
    break L23;
   }
   i2 = i2 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
  i1 = i2 + 1 | 0;
  HEAP32[i11 >> 2] = i1;
  switch (HEAP8[i2 >> 0] | 0) {
  case 93:
   {
    i2 = 21;
    break L21;
   }
  case 44:
   break;
  default:
   {
    i2 = 22;
    break L21;
   }
  }
  L27 : while (1) {
   switch (HEAP8[i1 >> 0] | 0) {
   case 9:
   case 13:
   case 10:
   case 32:
    break;
   default:
    break L27;
   }
   i1 = i1 + 1 | 0;
  }
  HEAP32[i11 >> 2] = i1;
  __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i10, i11, i9);
  if (HEAP32[i4 >> 2] | 0) {
   i2 = 23;
   break;
  }
 }
 if ((i2 | 0) == 21) {
  i10 = (HEAP32[i12 >> 2] | 0) + (Math_imul(i3, -24) | 0) | 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i10 + -24 | 0;
  HEAP32[i12 + 16 >> 2] = 4;
  i11 = i3 * 24 | 0;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i12 >> 2] = i9;
  _memcpy(i9 | 0, i10 | 0, i11 | 0) | 0;
  HEAP32[i12 + 8 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i3;
  return;
 } else if ((i2 | 0) == 22) {
  i12 = i1 - (HEAP32[i11 + 8 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = 7;
  HEAP32[i10 + 28 >> 2] = i12;
  return;
 } else if ((i2 | 0) == 23) return;
}

function __ZN5physx6shdfnd12PxRingBuffer8sendDataENS1_11MessageTypeEPKvjb(i13, i16, i14, i15, i9) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17;
 i11 = i15 + 8 | 0;
 i12 = i13 + 24 | 0;
 do if (i11 >>> 0 > ((HEAP32[i12 >> 2] | 0) + 8 | 0) >>> 0) {
  i4 = 0;
  i5 = 5;
 } else {
  i8 = i13 + 16 | 0;
  i7 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  i2 = HEAP32[HEAP32[i13 + 20 >> 2] >> 2] | 0;
  if (i2 >>> 0 > i7 >>> 0) {
   if (i11 >>> 0 >= (i2 - i7 | 0) >>> 0) {
    i4 = 0;
    i5 = 3;
    break;
   }
   i5 = HEAP32[i13 + 4 >> 2] | 0;
  } else {
   i1 = HEAP32[i13 + 4 >> 2] | 0;
   i6 = i1 - i7 | 0;
   if (i11 >>> 0 < (i6 >>> 0 > i2 >>> 0 ? i6 : i2) >>> 0) i5 = i1; else {
    i4 = 0;
    i5 = 3;
    break;
   }
  }
  i4 = i7 + i11 | 0;
  i6 = (i5 - i4 | 0) >>> 0 < 17;
  if ((i2 | 0) == 0 & (i5 >>> 0 >= i4 >>> 0 & i6)) {
   i4 = 0;
   i5 = 3;
  } else if (!(HEAP32[i13 + 28 >> 2] | 0)) {
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = i2 + i7 | 0;
   i1 = i13 + 4 | 0;
   if (i5 >>> 0 < i4 >>> 0) {
    HEAP32[i3 >> 2] = i5 - i7;
    HEAP32[i2 + (i7 + 4) >> 2] = -2147483647;
    HEAP32[i2 >> 2] = i11;
    i16 = (i5 - i11 | 0) >>> 0 < 17 ? i16 | -2147483648 : i16;
    HEAP32[i2 + 4 >> 2] = i16;
    _memcpy(i2 + 8 | 0, i14 | 0, i15 | 0) | 0;
    i1 = ((i16 | 0) < 0 ? 1 : (HEAP32[i1 >> 2] | 0) >>> 0 <= i11 >>> 0) ? 0 : i11;
   } else {
    HEAP32[i3 >> 2] = i11;
    i16 = i6 ? i16 | -2147483648 : i16;
    HEAP32[i2 + (i7 + 4) >> 2] = i16;
    _memcpy(i2 + (i7 + 8) | 0, i14 | 0, i15 | 0) | 0;
    i1 = ((i16 | 0) < 0 ? 1 : i4 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) ? 0 : i4;
   }
   HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
   i16 = 0;
   STACKTOP = i17;
   return i16 | 0;
  } else {
   i4 = 1;
   i5 = 0;
  }
 } while (0);
 i6 = i13 + 28 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) if (!(HEAP8[i13 + 36 >> 0] | 0)) i3 = 15; else {
  i1 = i13 + 44 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else i3 = 15;
 do if ((i3 | 0) == 15) {
  i3 = HEAP8[i13 + 37 >> 0] | 0;
  if (!(i3 << 24 >> 24 == 0 | i9 ^ 1)) {
   i2 = i13 + 44 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 + i11 | 0) >>> 0 < (HEAP32[i13 + 40 >> 2] | 0) >>> 0) break;
  }
  if (!i4) {
   i16 = i5;
   STACKTOP = i17;
   return i16 | 0;
  }
  i16 = i3 << 24 >> 24 ? 7 : 4;
  STACKTOP = i17;
  return i16 | 0;
 } while (0);
 HEAP32[i2 >> 2] = i1 + i15;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i11 | 0, i1 | 0, 40, (i3 ? gb + 778179 | 0 : gb + 837976 | 0) | 0, gb + 778098 | 0, 215) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i16;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i3 + 20 >> 2] = i15;
 HEAP32[i3 + 4 >> 2] = i13;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i15, gb + 778098 | 0, 474) | 0;
 HEAP32[i3 + 28 >> 2] = i1;
 HEAP32[i3 + 16 >> 2] = i1;
 _memcpy(i1 | 0, i14 | 0, i15 | 0) | 0;
 HEAP32[i3 + 24 >> 2] = i15;
 HEAP8[i3 + 36 >> 0] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i3;
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 HEAP32[i1 >> 2] = i3;
 i16 = 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN13WheelCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 60 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 64 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 68 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 80 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 84 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 88 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 92 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 96 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 100 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 104 | 0, i6);
 __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 124 | 0, i6);
 i1 = i5 + 41 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function runPostSets95() {
 HEAP32[gb + 94164 >> 2] = fb + 1;
 HEAP32[gb + 94168 >> 2] = fb + 1;
 HEAP32[gb + 94172 >> 2] = fb + 1;
 HEAP32[gb + 94176 >> 2] = fb + 1;
 HEAP32[gb + 94180 >> 2] = fb + 1;
 HEAP32[gb + 94184 >> 2] = fb + 1;
 HEAP32[gb + 94188 >> 2] = fb + 1;
 HEAP32[gb + 94192 >> 2] = fb + 1;
 HEAP32[gb + 94196 >> 2] = fb + 1;
 HEAP32[gb + 94200 >> 2] = fb + 1;
 HEAP32[gb + 94204 >> 2] = fb + 1;
 HEAP32[gb + 94208 >> 2] = fb + 1;
 HEAP32[gb + 94212 >> 2] = fb + 1;
 HEAP32[gb + 94216 >> 2] = fb + 1;
 HEAP32[gb + 94220 >> 2] = fb + 1;
 HEAP32[gb + 94224 >> 2] = fb + 1;
 HEAP32[gb + 94228 >> 2] = fb + 1;
 HEAP32[gb + 94232 >> 2] = fb + 1;
 HEAP32[gb + 94236 >> 2] = fb + 1;
 HEAP32[gb + 94240 >> 2] = fb + 1;
 HEAP32[gb + 94244 >> 2] = fb + 1;
 HEAP32[gb + 94248 >> 2] = fb + 1;
 HEAP32[gb + 94252 >> 2] = fb + 1;
 HEAP32[gb + 94256 >> 2] = fb + 1;
 HEAP32[gb + 94260 >> 2] = fb + 1;
 HEAP32[gb + 94264 >> 2] = fb + 1;
 HEAP32[gb + 94268 >> 2] = fb + 1;
 HEAP32[gb + 94272 >> 2] = fb + 1;
 HEAP32[gb + 94276 >> 2] = fb + 1;
 HEAP32[gb + 94280 >> 2] = fb + 1;
 HEAP32[gb + 94284 >> 2] = fb + 1;
 HEAP32[gb + 94288 >> 2] = fb + 1;
 HEAP32[gb + 94292 >> 2] = fb + 1;
 HEAP32[gb + 94296 >> 2] = fb + 1;
 HEAP32[gb + 94300 >> 2] = fb + 1;
 HEAP32[gb + 94304 >> 2] = fb + 1;
 HEAP32[gb + 94308 >> 2] = fb + 1;
 HEAP32[gb + 94312 >> 2] = fb + 1;
 HEAP32[gb + 94316 >> 2] = fb + 1;
 HEAP32[gb + 94320 >> 2] = fb + 1;
 HEAP32[gb + 94324 >> 2] = fb + 1;
 HEAP32[gb + 94328 >> 2] = fb + 1;
 HEAP32[gb + 94332 >> 2] = fb + 1;
 HEAP32[gb + 94336 >> 2] = fb + 1;
 HEAP32[gb + 94340 >> 2] = fb + 1;
 HEAP32[gb + 94344 >> 2] = fb + 1;
 HEAP32[gb + 94348 >> 2] = fb + 1;
 HEAP32[gb + 94352 >> 2] = fb + 1;
 HEAP32[gb + 94356 >> 2] = fb + 1;
 HEAP32[gb + 94360 >> 2] = fb + 1;
 HEAP32[gb + 94364 >> 2] = fb + 1;
 HEAP32[gb + 94368 >> 2] = fb + 1;
 HEAP32[gb + 94372 >> 2] = fb + 1;
 HEAP32[gb + 94376 >> 2] = fb + 1;
 HEAP32[gb + 94380 >> 2] = fb + 1;
 HEAP32[gb + 94384 >> 2] = fb + 1;
 HEAP32[gb + 94388 >> 2] = fb + 1;
 HEAP32[gb + 94392 >> 2] = fb + 1;
 HEAP32[gb + 94396 >> 2] = fb + 1;
 HEAP32[gb + 94400 >> 2] = fb + 1;
 HEAP32[gb + 94404 >> 2] = fb + 1;
 HEAP32[gb + 94408 >> 2] = fb + 1;
 HEAP32[gb + 94412 >> 2] = fb + 1;
 HEAP32[gb + 94416 >> 2] = fb + 1;
 HEAP32[gb + 94420 >> 2] = fb + 1;
 HEAP32[gb + 94424 >> 2] = fb + 1;
 HEAP32[gb + 94428 >> 2] = fb + 1;
 HEAP32[gb + 94432 >> 2] = fb + 1;
 HEAP32[gb + 94436 >> 2] = fb + 1;
 HEAP32[gb + 94440 >> 2] = fb + 1;
 HEAP32[gb + 94444 >> 2] = fb + 1;
 HEAP32[gb + 94448 >> 2] = fb + 1;
 HEAP32[gb + 94452 >> 2] = fb + 1;
 HEAP32[gb + 94456 >> 2] = fb + 1;
 HEAP32[gb + 94460 >> 2] = fb + 1;
 HEAP32[gb + 94464 >> 2] = fb + 1;
 HEAP32[gb + 94468 >> 2] = fb + 1;
 HEAP32[gb + 94472 >> 2] = fb + 1;
 HEAP32[gb + 94476 >> 2] = fb + 1;
 HEAP32[gb + 94480 >> 2] = fb + 1;
 HEAP32[gb + 94484 >> 2] = fb + 1;
 HEAP32[gb + 94488 >> 2] = fb + 1;
 HEAP32[gb + 94492 >> 2] = fb + 1;
 HEAP32[gb + 94496 >> 2] = fb + 1;
 HEAP32[gb + 94500 >> 2] = fb + 1;
 HEAP32[gb + 94504 >> 2] = fb + 1;
 HEAP32[gb + 94508 >> 2] = fb + 1;
 HEAP32[gb + 94512 >> 2] = fb + 1;
 HEAP32[gb + 94516 >> 2] = fb + 1;
 HEAP32[gb + 94520 >> 2] = fb + 1;
 HEAP32[gb + 94524 >> 2] = fb + 1;
 HEAP32[gb + 94528 >> 2] = fb + 1;
 HEAP32[gb + 94532 >> 2] = fb + 1;
 HEAP32[gb + 94536 >> 2] = fb + 1;
 HEAP32[gb + 94540 >> 2] = fb + 1;
 HEAP32[gb + 94544 >> 2] = fb + 1;
 HEAP32[gb + 94548 >> 2] = fb + 1;
 HEAP32[gb + 94552 >> 2] = fb + 1;
 HEAP32[gb + 94556 >> 2] = fb + 1;
 HEAP32[gb + 94560 >> 2] = fb + 1;
 runPostSets96();
}

function __ZN5physx2Gu3Box6createERKNS0_7CapsuleE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i12 = i1 + 12 | 0;
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i12 >> 2]));
 i9 = i1 + 4 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 i11 = i1 + 16 | 0;
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i11 >> 2]));
 i2 = i1 + 8 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i8 = i1 + 20 | 0;
 f4 = Math_fround(f4 * Math_fround(.5));
 f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
 HEAPF32[i5 + 36 >> 2] = Math_fround(f3 * Math_fround(.5));
 HEAPF32[i5 + 40 >> 2] = f4;
 HEAPF32[i5 + 44 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i11 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i9 >> 2]));
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 >> 2]));
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4)) + Math_fround(f3 * f3))));
 f7 = Math_fround(Math_fround(1.0) / f10);
 f6 = Math_fround(f6 * f7);
 f4 = Math_fround(f4 * f7);
 f7 = Math_fround(f3 * f7);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i5 + 4 >> 2] = f4;
 HEAPF32[i5 + 8 >> 2] = f7;
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 HEAPF32[i5 + 48 >> 2] = Math_fround(Math_fround(f10 * Math_fround(.5)) + f3);
 HEAPF32[i5 + 52 >> 2] = f3;
 HEAPF32[i5 + 56 >> 2] = f3;
 i1 = i5 + 12 | 0;
 i2 = i5 + 24 | 0;
 i8 = Math_fround(Math_abs(Math_fround(f4))) > Math_fround(Math_abs(Math_fround(f6))) & 1;
 f3 = Math_fround(Math_abs(Math_fround(f7)));
 i9 = f3 > Math_fround(Math_abs(Math_fround(HEAPF32[i5 + (i8 << 2) >> 2])));
 switch ((i9 ? 2 : i8) | 0) {
 case 0:
  {
   f10 = Math_fround(-f4);
   HEAPF32[i1 >> 2] = f10;
   i11 = i5 + 16 | 0;
   HEAPF32[i11 >> 2] = f6;
   i12 = i5 + 20 | 0;
   HEAPF32[i12 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(-Math_fround(f7 * f6));
   HEAPF32[i5 + 28 >> 2] = Math_fround(-Math_fround(f7 * f4));
   HEAPF32[i5 + 32 >> 2] = Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4));
   i2 = i11;
   i5 = i12;
   f7 = f10;
   f4 = Math_fround(0.0);
   break;
  }
 case 1:
  {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   f10 = Math_fround(-f7);
   i11 = i5 + 16 | 0;
   HEAPF32[i11 >> 2] = f10;
   i12 = i5 + 20 | 0;
   HEAPF32[i12 >> 2] = f4;
   HEAPF32[i2 >> 2] = Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7));
   HEAPF32[i5 + 28 >> 2] = Math_fround(-Math_fround(f4 * f6));
   HEAPF32[i5 + 32 >> 2] = Math_fround(-Math_fround(f7 * f6));
   i2 = i11;
   i5 = i12;
   f7 = Math_fround(0.0);
   f6 = f10;
   break;
  }
 default:
  {
   HEAPF32[i1 >> 2] = f7;
   i11 = i5 + 16 | 0;
   HEAPF32[i11 >> 2] = Math_fround(0.0);
   f10 = Math_fround(-f6);
   i12 = i5 + 20 | 0;
   HEAPF32[i12 >> 2] = f10;
   HEAPF32[i2 >> 2] = Math_fround(-Math_fround(f6 * f4));
   HEAPF32[i5 + 28 >> 2] = Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6));
   HEAPF32[i5 + 32 >> 2] = Math_fround(-Math_fround(f7 * f4));
   i2 = i11;
   i5 = i12;
   f6 = Math_fround(0.0);
   f4 = f10;
  }
 }
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f4 * f4))));
 if (!(f3 > Math_fround(0.0))) return;
 f10 = Math_fround(Math_fround(1.0) / f3);
 HEAPF32[i1 >> 2] = Math_fround(f7 * f10);
 HEAPF32[i2 >> 2] = Math_fround(f6 * f10);
 HEAPF32[i5 >> 2] = Math_fround(f4 * f10);
 return;
}

function __ZN13RenderManager28AreCamerasUsingMotionVectorsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i6 = i7 + 4 | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i6 | 0)) {
  L3 : while (1) {
   i5 = i1 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i10 = 9; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i3 = HEAP32[i8 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 9; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i10 = 11;
     }
    }
    if ((i10 | 0) == 9) i10 = 11;
    if ((i10 | 0) == 11) {
     i10 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i1) break;
    }
    if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) if (HEAP32[i1 + 1072 >> 2] & 4 | 0) {
     i1 = 1;
     break L3;
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i6 | 0)) break L1;
  }
  STACKTOP = i11;
  return i1 | 0;
 } while (0);
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i6 = i7 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 L26 : while (1) {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 25;
    }
   }
   if ((i10 | 0) == 23) i10 = 25;
   if ((i10 | 0) == 25) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i1) break;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) if (HEAP32[i1 + 1072 >> 2] & 4 | 0) {
    i1 = 1;
    i10 = 29;
    break L26;
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 0;
   i10 = 29;
   break;
  }
 }
 if ((i10 | 0) == 29) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function _sfnt_get_ps_name(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i9 + 664 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP16[i9 + 340 >> 1] | 0;
 do if (!(i1 << 16 >> 16)) i1 = 0; else {
  i5 = HEAP32[i9 + 356 >> 2] | 0;
  i4 = i1 & 65535;
  i3 = 0;
  i2 = -1;
  i1 = -1;
  while (1) {
   L8 : do if ((HEAP16[i5 + (i3 * 20 | 0) + 6 >> 1] | 0) == 6) if (!(HEAP16[i5 + (i3 * 20 | 0) + 8 >> 1] | 0)) i8 = i1; else switch (HEAP16[i5 + (i3 * 20 | 0) >> 1] | 0) {
   case 3:
    {
     if ((HEAP16[i5 + (i3 * 20 | 0) + 2 >> 1] | 0) != 1) {
      i8 = i1;
      break L8;
     }
     i8 = i1;
     i2 = (HEAP16[i5 + (i3 * 20 | 0) + 4 >> 1] | 0) == 1033 ? i3 : i2;
     break L8;
    }
   case 1:
    {
     if (HEAP16[i5 + (i3 * 20 | 0) + 2 >> 1] | 0) {
      i8 = i1;
      break L8;
     }
     i8 = (HEAP16[i5 + (i3 * 20 | 0) + 4 >> 1] | 0) == 0 ? i3 : i1;
     break L8;
    }
   default:
    {
     i8 = i1;
     break L8;
    }
   } else i8 = i1; while (0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i4 | 0)) break; else i1 = i8;
  }
  if ((i2 | 0) == -1) {
   if ((i8 | 0) == -1) {
    i1 = 0;
    break;
   }
   i4 = HEAP32[i9 + 100 >> 2] | 0;
   i5 = HEAP32[i9 + 356 >> 2] | 0;
   i6 = i5 + (i8 * 20 | 0) + 8 | 0;
   i7 = HEAPU16[i6 >> 1] | 0;
   HEAP32[i10 >> 2] = 0;
   i1 = _UNITY_ft_mem_alloc(i4, i7 + 1 | 0, i10) | 0;
   do if (!(HEAP32[i10 >> 2] | 0)) {
    i2 = HEAP32[i9 + 360 >> 2] | 0;
    i3 = i5 + (i8 * 20 | 0) + 12 | 0;
    i9 = _UNITY_FT_Stream_Seek(i2, HEAP32[i3 >> 2] | 0) | 0;
    HEAP32[i10 >> 2] = i9;
    if (!i9) {
     i9 = _UNITY_FT_Stream_Read(i2, i1, i7) | 0;
     HEAP32[i10 >> 2] = i9;
     if (!i9) {
      HEAP8[i1 + i7 >> 0] = 0;
      break;
     }
    }
    HEAP32[i3 >> 2] = 0;
    HEAP16[i6 >> 1] = 0;
    i10 = i5 + (i8 * 20 | 0) + 16 | 0;
    _UNITY_ft_mem_free(i4, HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = 0;
    _UNITY_ft_mem_free(i4, i1);
    i1 = 0;
   } while (0);
   break;
  }
  i5 = HEAP32[i9 + 100 >> 2] | 0;
  i6 = HEAP32[i9 + 356 >> 2] | 0;
  i7 = i6 + (i2 * 20 | 0) + 8 | 0;
  i1 = HEAP16[i7 >> 1] | 0;
  i8 = (i1 & 65535) >>> 1;
  i4 = i8 & 65535;
  HEAP32[i10 >> 2] = 0;
  i1 = _UNITY_ft_mem_alloc(i5, (i1 & 65535) + 1 | 0, i10) | 0;
  do if (!(HEAP32[i10 >> 2] | 0)) {
   i9 = HEAP32[i9 + 360 >> 2] | 0;
   i3 = i6 + (i2 * 20 | 0) + 12 | 0;
   i13 = _UNITY_FT_Stream_Seek(i9, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i10 >> 2] = i13;
   if (!i13) {
    i13 = _UNITY_FT_Stream_EnterFrame(i9, HEAPU16[i7 >> 1] | 0) | 0;
    HEAP32[i10 >> 2] = i13;
    if (!i13) {
     if (!(i8 << 16 >> 16)) i2 = i1; else {
      i5 = HEAP32[i9 + 32 >> 2] | 0;
      i2 = i1;
      while (1) {
       if (!(HEAP8[i5 >> 0] | 0)) {
        i3 = HEAP8[i5 + 1 >> 0] | 0;
        if (i3 << 24 >> 24 > 31) {
         HEAP8[i2 >> 0] = i3;
         i2 = i2 + 1 | 0;
        }
       }
       i4 = i4 + -1 | 0;
       if (!i4) break; else i5 = i5 + 2 | 0;
      }
     }
     HEAP8[i2 >> 0] = 0;
     _UNITY_FT_Stream_ExitFrame(i9);
     break;
    }
   }
   _UNITY_ft_mem_free(i5, i1);
   HEAP16[i7 >> 1] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i6 + (i2 * 20 | 0) + 16 | 0;
   _UNITY_ft_mem_free(i5, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   i1 = 0;
  } while (0);
 } while (0);
 HEAP32[i11 >> 2] = i1;
 i13 = i1;
 STACKTOP = i12;
 return i13 | 0;
}

function _csinhf(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 16 | 0;
 i3 = i13 + 8 | 0;
 i4 = i13;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = i2 + 4 | 0;
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = i12 & 2147483647;
 i8 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 i9 = i6 >>> 0 < 2139095040;
 do if (i9 & i8 >>> 0 < 2139095040) {
  if (!i8) {
   HEAPF32[i7 >> 2] = Math_fround(_sinhf(f10));
   HEAPF32[i7 + 4 >> 2] = f11;
   break;
  }
  if (i6 >>> 0 < 1091567616) {
   f14 = Math_fround(Math_fround(_sinhf(f10)) * Math_fround(+Math_cos(+f11)));
   f11 = Math_fround(Math_fround(_coshf(f10)) * Math_fround(+Math_sin(+f11)));
   HEAPF32[i7 >> 2] = f14;
   HEAPF32[i7 + 4 >> 2] = f11;
   break;
  }
  if (i6 >>> 0 < 1118925336) {
   f15 = Math_fround(Math_fround(+Math_exp(+Math_fround(Math_abs(Math_fround(f10))))) * Math_fround(.5));
   f14 = Math_fround(f15 * Math_fround(+Math_sin(+f11)));
   HEAPF32[i7 >> 2] = Math_fround(Math_fround(_copysignf(f15, f10)) * Math_fround(+Math_cos(+f11)));
   HEAPF32[i7 + 4 >> 2] = f14;
   break;
  }
  if (i6 >>> 0 < 1128313319) {
   HEAPF32[i4 >> 2] = Math_fround(Math_abs(Math_fround(f10)));
   HEAPF32[i4 + 4 >> 2] = f11;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   ___ldexp_cexpf(i3, i1, -1);
   i9 = HEAP32[i3 >> 2] | 0;
   i12 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i5 >> 2] = i12;
   f15 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAPF32[i7 >> 2] = Math_fround(f15 * Math_fround(_copysignf(Math_fround(1.0), f10)));
   HEAP32[i7 + 4 >> 2] = i12;
   break;
  } else {
   f14 = Math_fround(f10 * Math_fround(1701411830000000029203285.0e14));
   f15 = Math_fround(Math_fround(f14 * f14) * Math_fround(+Math_sin(+f11)));
   HEAPF32[i7 >> 2] = Math_fround(f14 * Math_fround(+Math_cos(+f11)));
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
 } else {
  i2 = i8 >>> 0 > 2139095039;
  if ((i6 | 0) == 0 & i2) {
   f15 = Math_fround(f11 - f11);
   HEAPF32[i7 >> 2] = Math_fround(_copysignf(Math_fround(0.0), Math_fround(f10 * f15)));
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
  i1 = i6 >>> 0 > 2139095039;
  if (i1 & (i8 | 0) == 0) if (!(i12 & 8388607)) {
   HEAPF32[i7 >> 2] = f10;
   HEAPF32[i7 + 4 >> 2] = f11;
   break;
  } else {
   f15 = Math_fround(_copysignf(Math_fround(0.0), f11));
   HEAPF32[i7 >> 2] = f10;
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
  if (i9 & i2) {
   f14 = Math_fround(f11 - f11);
   f15 = Math_fround(f10 * f14);
   HEAPF32[i7 >> 2] = f14;
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
  if (!(i1 & (i12 & 8388607 | 0) == 0)) {
   f14 = Math_fround(f11 - f11);
   f15 = Math_fround(Math_fround(f10 + f10) * f14);
   HEAPF32[i7 >> 2] = Math_fround(Math_fround(f10 * f10) * f14);
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
  if (i2) {
   f15 = Math_fround(f10 * Math_fround(f11 - f11));
   HEAPF32[i7 >> 2] = Math_fround(f10 * f10);
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  } else {
   f14 = Math_fround(f10 * Math_fround(+Math_cos(+f11)));
   f15 = Math_fround(Math_fround(+Math_sin(+f11)) * Math_fround(inf));
   HEAPF32[i7 >> 2] = f14;
   HEAPF32[i7 + 4 >> 2] = f15;
   break;
  }
 } while (0);
 STACKTOP = i13;
 return;
}

function __ZN22UnityAnalyticsSettings8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = i5 + 8 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047713 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 9 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041805 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 10 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041676 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 12 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041687 | 0, i3, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041702 | 0, i3, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i23 = HEAP32[i5 + 4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(-f17);
 f24 = Math_fround(-f16);
 f25 = Math_fround(-f15);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 f27 = Math_fround(f20 * f8);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f7 * f24));
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f12 * f25));
 f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f26 = Math_fround(f9 * f8);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f11 * f24));
 f14 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f14 * f25));
 f21 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f8 = Math_fround(f21 * f8);
 f6 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f24 = Math_fround(f8 + Math_fround(f6 * f24));
 f8 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f25 = Math_fround(f24 + Math_fround(f8 * f25));
 f24 = Math_fround(HEAPF32[i23 + 96 >> 2]);
 f19 = Math_fround(HEAPF32[i23 + 100 >> 2]);
 f22 = Math_fround(HEAPF32[i23 + 104 >> 2]);
 f28 = Math_fround(Math_fround(Math_fround(f27 * f24) + Math_fround(f26 * f19)) + Math_fround(f25 * f22));
 f13 = Math_fround(HEAPF32[i23 + 112 >> 2]);
 f10 = Math_fround(HEAPF32[i23 + 116 >> 2]);
 f18 = Math_fround(HEAPF32[i23 + 120 >> 2]);
 i23 = f28 > Math_fround(Math_fround(Math_fround(f27 * f13) + Math_fround(f26 * f10)) + Math_fround(f25 * f18));
 f13 = i23 ? f24 : f13;
 f10 = i23 ? f19 : f10;
 f18 = i23 ? f22 : f18;
 f22 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f9 = Math_fround(f22 + Math_fround(Math_fround(f21 * f18) + Math_fround(Math_fround(f20 * f13) + Math_fround(f9 * f10))));
 f11 = Math_fround(f19 + Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f7 * f13) + Math_fround(f11 * f10))));
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) + Math_fround(Math_fround(f8 * f18) + Math_fround(Math_fround(f12 * f13) + Math_fround(f14 * f10))));
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i5 + 96 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 100 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 104 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * f13)) + Math_fround(f15 * f12));
 f8 = Math_fround(HEAPF32[i5 + 112 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 116 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 120 >> 2]);
 i5 = f18 > Math_fround(Math_fround(Math_fround(f17 * f8) + Math_fround(f16 * f7)) + Math_fround(f15 * f6));
 f8 = i5 ? f14 : f8;
 f7 = i5 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN12AudioManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i6 = i5;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i4, i3);
 HEAP32[i1 >> 2] = gb + 171696 + 8;
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 40 >> 0] = 0;
 HEAP8[i1 + 41 >> 0] = 0;
 i6 = i1 + 44 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 48 >> 2] = i6;
 i6 = i1 + 52 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 56 >> 2] = i6;
 i6 = i1 + 60 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 64 >> 2] = i6;
 i6 = i1 + 68 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 72 >> 2] = i6;
 i6 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 84 >> 2] = i6;
 i6 = i1 + 88 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 2;
 i6 = i1 + 140 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 2;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 512;
 HEAP32[i1 + 172 >> 2] = 32;
 HEAP8[i1 + 176 >> 0] = 0;
 i6 = i1 + 180 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i6 = i1 + 200 | 0;
 HEAP8[i1 + 226 >> 0] = 0;
 HEAP8[i1 + 227 >> 0] = 0;
 HEAP8[i1 + 228 >> 0] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 244 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 292 >> 2] = 1;
 HEAP32[i1 + 296 >> 2] = 0;
 i2 = i1 + 276 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[gb + 1459924 >> 2] = i1;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 1540 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i8 = i3;
  i7 = i8 + 1 | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i1 + 772 + (i8 * 12 | 0) + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  i7 = i1 + 772 + (i8 * 12 | 0) + 8 | 0;
  HEAP8[i7 >> 0] = 0;
  i8 = i1 + 772 + (i8 * 12 | 0) | 0;
  HEAP32[i8 >> 2] = fb + 284;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i8 = HEAP32[i2 >> 2] | 0;
 i7 = i8 + 1 | 0;
 HEAP32[i2 >> 2] = i7;
 i7 = i1 + 772 + (i8 * 12 | 0) + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i7 = i1 + 772 + (i8 * 12 | 0) + 8 | 0;
 HEAP8[i7 >> 0] = 0;
 i8 = i1 + 772 + (i8 * 12 | 0) | 0;
 HEAP32[i8 >> 2] = fb + 284;
 STACKTOP = i5;
 return;
}

function _jpeg_consume_input(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 switch (i1 | 0) {
 case 200:
  {
   i1 = i4 + 400 | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
   mftCall_vi(HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
   HEAP32[i5 >> 2] = 201;
   break;
  }
 case 201:
  {
   i1 = i4 + 400 | 0;
   break;
  }
 case 210:
 case 208:
 case 207:
 case 206:
 case 205:
 case 204:
 case 203:
  {
   i5 = mftCall_ii(HEAP32[HEAP32[i4 + 400 >> 2] >> 2] | 0, i4 | 0) | 0;
   return i5 | 0;
  }
 case 202:
  {
   i5 = 1;
   return i5 | 0;
  }
 default:
  {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 + 20 >> 2] = 20;
   HEAP32[i5 + 24 >> 2] = i1;
   mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
   i5 = 0;
   return i5 | 0;
  }
 }
 i1 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i4 | 0) | 0;
 if ((i1 | 0) != 1) {
  i5 = i1;
  return i5 | 0;
 }
 switch (HEAP32[i4 + 36 >> 2] | 0) {
 case 1:
  {
   HEAP32[i4 + 40 >> 2] = 1;
   HEAP32[i4 + 44 >> 2] = 1;
   break;
  }
 case 3:
  {
   L17 : do if (!(HEAP8[i4 + 256 >> 0] | 0)) {
    i3 = HEAP16[i4 + 264 >> 1] | 0;
    i1 = (i3 & 65535) >>> 8;
    if ((i3 & 255) << 24 >> 24) switch ((i1 & 255) << 24 >> 24) {
    case 0:
     {
      HEAP32[i4 + 40 >> 2] = 2;
      break L17;
     }
    case 1:
     {
      HEAP32[i4 + 40 >> 2] = 3;
      break L17;
     }
    default:
     {
      i3 = HEAP32[i4 >> 2] | 0;
      HEAP32[i3 + 20 >> 2] = 114;
      HEAP32[i3 + 24 >> 2] = i1 & 65535;
      mftCall_vii(HEAP32[i3 + 4 >> 2] | 0, i4 | 0, -1);
      HEAP32[i4 + 40 >> 2] = 3;
      break L17;
     }
    }
    i3 = HEAP32[i4 + 196 >> 2] | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i3 + 84 >> 2] | 0;
    i3 = HEAP32[i3 + 168 >> 2] | 0;
    if ((i1 | 0) == 1 & (i2 | 0) == 2 & (i3 | 0) == 3) {
     HEAP32[i4 + 40 >> 2] = 3;
     break;
    }
    if ((i1 | 0) == 82 & (i2 | 0) == 71 & (i3 | 0) == 66) {
     HEAP32[i4 + 40 >> 2] = 2;
     break;
    } else {
     i6 = HEAP32[i4 >> 2] | 0;
     HEAP32[i6 + 24 >> 2] = i1;
     HEAP32[i6 + 28 >> 2] = i2;
     HEAP32[i6 + 32 >> 2] = i3;
     HEAP32[i6 + 20 >> 2] = 111;
     mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i4 | 0, 1);
     HEAP32[i4 + 40 >> 2] = 3;
     break;
    }
   } else HEAP32[i4 + 40 >> 2] = 3; while (0);
   HEAP32[i4 + 44 >> 2] = 2;
   break;
  }
 case 4:
  {
   i6 = HEAP16[i4 + 264 >> 1] | 0;
   i1 = (i6 & 65535) >>> 8;
   L35 : do if (!((i6 & 255) << 24 >> 24)) HEAP32[i4 + 40 >> 2] = 4; else switch ((i1 & 255) << 24 >> 24) {
   case 0:
    {
     HEAP32[i4 + 40 >> 2] = 4;
     break L35;
    }
   case 2:
    {
     HEAP32[i4 + 40 >> 2] = 5;
     break L35;
    }
   default:
    {
     i6 = HEAP32[i4 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 114;
     HEAP32[i6 + 24 >> 2] = i1 & 65535;
     mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i4 | 0, -1);
     HEAP32[i4 + 40 >> 2] = 5;
     break L35;
    }
   } while (0);
   HEAP32[i4 + 44 >> 2] = 4;
   break;
  }
 default:
  {
   HEAP32[i4 + 40 >> 2] = 0;
   HEAP32[i4 + 44 >> 2] = 0;
  }
 }
 HEAP32[i4 + 48 >> 2] = 1;
 HEAP32[i4 + 52 >> 2] = 1;
 HEAPF64[i4 + 56 >> 3] = 1.0;
 HEAP8[i4 + 64 >> 0] = 0;
 HEAP8[i4 + 65 >> 0] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP8[i4 + 72 >> 0] = 1;
 HEAP8[i4 + 73 >> 0] = 1;
 HEAP8[i4 + 74 >> 0] = 0;
 HEAP32[i4 + 76 >> 2] = 2;
 HEAP8[i4 + 80 >> 0] = 0;
 HEAP32[i4 + 84 >> 2] = 256;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 0;
 HEAP8[i4 + 90 >> 0] = 0;
 HEAP32[i5 >> 2] = 202;
 i6 = 1;
 return i6 | 0;
}

function __ZN5physx2Sc13ClothBulkDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 152 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 144 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 140 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 132 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 128 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 120 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 116 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 108 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 104 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 96 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 84 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 80 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 72 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 56 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 48 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 44 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 36 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 24 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN15CapsuleCollider8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i7, i9);
 i4 = i7 + 60 | 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843745 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 932223 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801063 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1034411 | 0, HEAP32[gb + 37324 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z23RandomPointInsideCircleR5RandNRKfS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 __Z17RandomUnitVector2R5RandN(i1, i2);
 i24 = HEAP32[i2 >> 2] | 0;
 i10 = i2 + 4 | 0;
 i23 = HEAP32[i10 >> 2] | 0;
 i12 = i2 + 8 | 0;
 i22 = HEAP32[i12 >> 2] | 0;
 i28 = i2 + 12 | 0;
 i21 = HEAP32[i28 >> 2] | 0;
 i24 = i24 << 11 ^ i24;
 i23 = i23 << 11 ^ i23;
 i22 = i22 << 11 ^ i22;
 i21 = i21 << 11 ^ i21;
 i14 = i2 + 16 | 0;
 i18 = i2 + 20 | 0;
 i25 = HEAP32[i18 >> 2] | 0;
 i19 = i2 + 24 | 0;
 i26 = HEAP32[i19 >> 2] | 0;
 i20 = i2 + 28 | 0;
 i27 = HEAP32[i20 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 >> 2] = i25;
 HEAP32[i12 >> 2] = i26;
 HEAP32[i28 >> 2] = i27;
 i28 = i2 + 32 | 0;
 i27 = i2 + 36 | 0;
 i12 = HEAP32[i27 >> 2] | 0;
 i26 = i2 + 40 | 0;
 i10 = HEAP32[i26 >> 2] | 0;
 i25 = i2 + 44 | 0;
 i8 = HEAP32[i25 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i28 >> 2];
 HEAP32[i18 >> 2] = i12;
 HEAP32[i19 >> 2] = i10;
 HEAP32[i20 >> 2] = i8;
 i20 = i2 + 48 | 0;
 i8 = HEAP32[i20 >> 2] | 0;
 i19 = i2 + 52 | 0;
 i10 = HEAP32[i19 >> 2] | 0;
 i18 = i2 + 56 | 0;
 i12 = HEAP32[i18 >> 2] | 0;
 i2 = i2 + 60 | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 HEAP32[i28 >> 2] = i8;
 HEAP32[i27 >> 2] = i10;
 HEAP32[i26 >> 2] = i12;
 HEAP32[i25 >> 2] = i14;
 i8 = i24 >>> 8 ^ i24 ^ i8 ^ i8 >>> 19;
 i10 = i23 >>> 8 ^ i23 ^ i10 ^ i10 >>> 19;
 i12 = i22 >>> 8 ^ i22 ^ i12 ^ i12 >>> 19;
 i14 = i21 >>> 8 ^ i21 ^ i14 ^ i14 >>> 19;
 HEAP32[i20 >> 2] = i8;
 HEAP32[i19 >> 2] = i10;
 HEAP32[i18 >> 2] = i12;
 HEAP32[i2 >> 2] = i14;
 f9 = Math_fround(Math_fround(i8 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(i10 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(i12 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f16 = Math_fround(Math_fround(i14 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(f9 * f15);
 f11 = Math_fround(f7 * f15);
 f13 = Math_fround(f6 * f15);
 f15 = Math_fround(f16 * f15);
 f9 = Math_fround(Math_fround(1.0) - f9);
 f7 = Math_fround(Math_fround(1.0) - f7);
 f6 = Math_fround(Math_fround(1.0) - f6);
 f16 = Math_fround(Math_fround(1.0) - f16);
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(Math_sqrt(Math_fround(f17 + Math_fround(f9 * f5))));
 f7 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f7 * f5))));
 f6 = Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f6 * f5))));
 f5 = Math_fround(Math_sqrt(Math_fround(f15 + Math_fround(f16 * f5))));
 f16 = Math_fround(f9 * Math_fround(HEAPF32[i1 >> 2]));
 i14 = i1 + 4 | 0;
 f15 = Math_fround(f7 * Math_fround(HEAPF32[i14 >> 2]));
 i12 = i1 + 8 | 0;
 f13 = Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2]));
 i10 = i1 + 12 | 0;
 f11 = Math_fround(f5 * Math_fround(HEAPF32[i10 >> 2]));
 i8 = i1 + 16 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i8 >> 2]));
 i2 = i1 + 20 | 0;
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i2 >> 2]));
 i3 = i1 + 24 | 0;
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2]));
 i4 = i1 + 28 | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i1 >> 2] = f16;
 HEAPF32[i14 >> 2] = f15;
 HEAPF32[i12 >> 2] = f13;
 HEAPF32[i10 >> 2] = f11;
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i3 >> 2] = f6;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN8LODGroup11LODStruct508TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425174 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425273 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425195 | 0, i5, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i5 >>> 0) i6 = 28; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 28; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425215 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(f17 + f21);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f15 = Math_fround(f14 + f20);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f8 = Math_fround(Math_fround(f8 * Math_fround(.5)) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(f15 * Math_fround(.5)) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(Math_fround(f7 + f9) * Math_fround(.5)) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f23 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f8 * f22);
 f19 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f15 * f19));
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * f13));
 f10 = Math_fround(Math_fround(f22 * f11) + Math_fround(Math_fround(f8 * f23) + Math_fround(f18 * Math_fround(Math_fround(f4 * f19) - Math_fround(f15 * f13)))));
 f12 = Math_fround(Math_fround(f19 * f11) + Math_fround(Math_fround(f15 * f23) + Math_fround(f18 * Math_fround(Math_fround(f8 * f13) - Math_fround(f22 * f4)))));
 f11 = Math_fround(Math_fround(Math_fround(f4 * f23) + Math_fround(f18 * Math_fround(Math_fround(f15 * f22) - Math_fround(f8 * f19)))) + Math_fround(f13 * f11));
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f10);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f12);
 f11 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f11);
 f8 = Math_fround(f22 + f22);
 f15 = Math_fround(f19 + f19);
 f23 = Math_fround(f13 + f13);
 f4 = Math_fround(f19 * f15);
 f5 = Math_fround(f13 * f23);
 f19 = Math_fround(f8 * f19);
 f16 = Math_fround(f8 * f13);
 f6 = Math_fround(f8 * f18);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(f15 * f18);
 f18 = Math_fround(f23 * f18);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f22 * f8));
 f17 = Math_fround(Math_fround(f21 - f17) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f20 - f14) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f9 - f7) * Math_fround(.5));
 f9 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f17 * Math_fround(Math_fround(Math_fround(1.0) - f4) - f5)))) + Math_fround(Math_abs(Math_fround(f14 * Math_fround(f19 - f18))))) + Math_fround(Math_abs(Math_fround(f7 * Math_fround(f16 + f15)))));
 f5 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f17 * Math_fround(f19 + f18)))) + Math_fround(Math_abs(Math_fround(f14 * Math_fround(f8 - f5))))) + Math_fround(Math_abs(Math_fround(f7 * Math_fround(f13 - f6)))));
 f4 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f17 * Math_fround(f16 - f15)))) + Math_fround(Math_abs(Math_fround(f14 * Math_fround(f13 + f6))))) + Math_fround(Math_abs(Math_fround(f7 * Math_fround(f8 - f4)))));
 f8 = Math_fround(f12 - f5);
 f7 = Math_fround(f11 - f4);
 f6 = Math_fround(f10 + f9);
 f5 = Math_fround(f12 + f5);
 f4 = Math_fround(f11 + f4);
 HEAPF32[i1 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f4;
 return;
}

function __ZL11AddSentinelP14TESStesselatorfff(i10, f7, f8, f9) {
 i10 = i10 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i5 = HEAP32[i10 + 76 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i3 = 4; else {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i3 = 4; else {
   HEAP32[i5 >> 2] = i2;
   i11 = i1;
  }
 }
 if ((i3 | 0) == 4) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i6 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i6 = i10 + 144 | 0;
   _longjmp(i6 | 0, 1);
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i1 = i1 - i3 | 0;
   i6 = i2;
   i2 = i4 + i1 | 0;
   HEAP32[i2 >> 2] = i6;
  } while ((i1 | 0) != 4);
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  if (!i2) {
   i6 = i10 + 144 | 0;
   _longjmp(i6 | 0, 1);
  } else i11 = i2;
 }
 i1 = __Z16tessMeshMakeEdgeP8TESSmesh(HEAP32[i10 >> 2] | 0) | 0;
 if (!i1) _longjmp(i10 + 144 | 0, 1);
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 HEAPF32[i2 + 24 >> 2] = f8;
 HEAPF32[i2 + 28 >> 2] = f9;
 i2 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 16 >> 2] | 0;
 HEAPF32[i2 + 24 >> 2] = f7;
 HEAPF32[i2 + 28 >> 2] = f9;
 HEAP32[i10 + 72 >> 2] = i2;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 1;
 HEAP32[i11 + 20 >> 2] = 0;
 i1 = HEAP32[i10 + 64 >> 2] | 0;
 i2 = i1 + 20 | 0;
 i3 = i1 + 12 | 0;
 i6 = i1;
 do {
  i6 = HEAP32[i6 + 8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (!i4) break;
 } while (!(mftCall_iiii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0, i11 | 0) | 0));
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i5 >> 2] = i2;
   i10 = i1;
   HEAP32[i10 >> 2] = i11;
   i5 = i6 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i4 = i10 + 4 | 0;
   HEAP32[i4 >> 2] = i3;
   i4 = HEAP32[i5 >> 2] | 0;
   i4 = i4 + 8 | 0;
   HEAP32[i4 >> 2] = i10;
   i4 = i10 + 8 | 0;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i5 >> 2] = i10;
   i11 = i11 + 4 | 0;
   HEAP32[i11 >> 2] = i10;
   return;
  }
 }
 i1 = i5 + 8 | 0;
 i2 = i5 + 12 | 0;
 i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, i4 | 0) | 0;
 if (!i4) {
  i3 = i11 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i10 + 144 | 0;
  _longjmp(i3 | 0, 1);
 }
 i3 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do {
  i1 = i1 - i3 | 0;
  i12 = i2;
  i2 = i4 + i1 | 0;
  HEAP32[i2 >> 2] = i12;
 } while ((i1 | 0) != 4);
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 if (!i2) {
  i12 = i11 + 4 | 0;
  HEAP32[i12 >> 2] = 0;
  i12 = i10 + 144 | 0;
  _longjmp(i12 | 0, 1);
 } else {
  i10 = i2;
  HEAP32[i10 >> 2] = i11;
  i12 = i6 + 4 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  i5 = HEAP32[i12 >> 2] | 0;
  i5 = i5 + 8 | 0;
  HEAP32[i5 >> 2] = i10;
  i5 = i10 + 8 | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i12 >> 2] = i10;
  i12 = i11 + 4 | 0;
  HEAP32[i12 >> 2] = i10;
  return;
 }
}

function __ZN15b2ContactSolver9WarmStartEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i22 = i1 + 48 | 0;
 if ((HEAP32[i22 >> 2] | 0) <= 0) return;
 i23 = i1 + 40 | 0;
 i20 = i1 + 28 | 0;
 i16 = 0;
 i5 = HEAP32[i20 >> 2] | 0;
 do {
  i15 = HEAP32[i23 >> 2] | 0;
  i21 = HEAP32[i15 + (i16 * 156 | 0) + 112 >> 2] | 0;
  i18 = HEAP32[i15 + (i16 * 156 | 0) + 116 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 120 >> 2]);
  f11 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 128 >> 2]);
  f12 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 124 >> 2]);
  f13 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 132 >> 2]);
  i14 = HEAP32[i15 + (i16 * 156 | 0) + 148 >> 2] | 0;
  i19 = i5 + (i21 * 12 | 0) | 0;
  i3 = HEAP32[i19 >> 2] | 0;
  i17 = i5 + (i21 * 12 | 0) + 4 | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i5 + (i21 * 12 | 0) + 8 >> 2]);
  i4 = HEAP32[i5 + (i18 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i5 + (i18 * 12 | 0) + 4 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i5 + (i18 * 12 | 0) + 8 >> 2]);
  f8 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 72 >> 2]);
  f9 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + 76 >> 2]);
  if ((i14 | 0) > 0) {
   i5 = 0;
   do {
    f27 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) + 16 >> 2]);
    f25 = Math_fround(f8 * f27);
    f27 = Math_fround(f9 * f27);
    f24 = Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) + 20 >> 2]);
    f25 = Math_fround(f25 + Math_fround(f9 * f24));
    f24 = Math_fround(f27 - Math_fround(f8 * f24));
    f27 = Math_fround(Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) >> 2]) * f24);
    f6 = Math_fround(f6 - Math_fround(f11 * Math_fround(f27 - Math_fround(Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) + 4 >> 2]) * f25))));
    f27 = Math_fround(f10 * f25);
    f26 = Math_fround(f10 * f24);
    f27 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f27);
    i3 = (HEAPF32[tempDoublePtr >> 2] = f27, HEAP32[tempDoublePtr >> 2] | 0);
    f26 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f26);
    i1 = (HEAPF32[tempDoublePtr >> 2] = f26, HEAP32[tempDoublePtr >> 2] | 0);
    f26 = Math_fround(f24 * Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) + 8 >> 2]));
    f7 = Math_fround(f7 + Math_fround(f13 * Math_fround(f26 - Math_fround(f25 * Math_fround(HEAPF32[i15 + (i16 * 156 | 0) + (i5 * 36 | 0) + 12 >> 2])))));
    f25 = Math_fround(f12 * f25);
    f24 = Math_fround(f12 * f24);
    f25 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f25);
    i4 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
    f24 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f24);
    i2 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i14 | 0));
  }
  HEAP32[i19 >> 2] = i3;
  HEAP32[i17 >> 2] = i1;
  i5 = HEAP32[i20 >> 2] | 0;
  HEAPF32[i5 + (i21 * 12 | 0) + 8 >> 2] = f6;
  HEAP32[i5 + (i18 * 12 | 0) >> 2] = i4;
  HEAP32[i5 + (i18 * 12 | 0) + 4 >> 2] = i2;
  i5 = HEAP32[i20 >> 2] | 0;
  HEAPF32[i5 + (i18 * 12 | 0) + 8 >> 2] = f7;
  i16 = i16 + 1 | 0;
 } while ((i16 | 0) < (HEAP32[i22 >> 2] | 0));
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 24 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = -1;
  HEAP32[i10 + 4 >> 2] = -1;
  HEAP32[i10 + 8 >> 2] = -1;
  HEAP32[i10 + 12 >> 2] = -1;
  HEAP32[i10 + 16 >> 2] = -1;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 5 | 0, 4) | 0;
  i2 = i4 + (i1 << 5) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = 0;
    i1 = i1 + 32 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 5) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863393 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN5audio5mixer14EffectConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863393 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN5audio5mixer14EffectConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN21BillboardBatchManager17BillboardBatchJobEP25DynamicVBOGeometryJobDataj(i3, i21) {
 i3 = i3 | 0;
 i21 = i21 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i22 + 4 | 0;
 i2 = i22;
 if ((HEAP16[gb + 1159924 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159924 | 0, i1);
  i20 = gb + 1159924 | 0;
 } else i20 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i19 = HEAP32[i3 + 4 >> 2] | 0;
 i18 = i19 + (i21 * 20 | 0) | 0;
 i15 = HEAP32[i1 + (i21 * 20 | 0) >> 2] | 0;
 if (i15 | 0) {
  i1 = HEAP32[i1 + (i21 * 20 | 0) + 4 >> 2] | 0;
  if (i1 | 0) {
   i9 = HEAP32[i18 >> 2] | 0;
   i11 = HEAP32[(HEAP32[i19 + (i21 * 20 | 0) + 4 >> 2] | 0) + 4 >> 2] | 0;
   i12 = HEAP32[i19 + (i21 * 20 | 0) + 8 >> 2] | 0;
   i10 = HEAP32[i19 + (i21 * 20 | 0) + 12 >> 2] | 0;
   i16 = HEAP32[i9 + 48 >> 2] | 0;
   i17 = HEAP32[i9 + 60 >> 2] | 0;
   i8 = HEAP32[i9 + 68 >> 2] | 0;
   i9 = (HEAP32[i9 + 80 >> 2] | 0) >>> 1;
   if (!(i12 >>> 0 >= i10 >>> 0 | (i9 | 0) == 0)) {
    i2 = HEAP32[i19 + (i21 * 20 | 0) + 16 >> 2] | 0;
    i4 = i12;
    while (1) {
     i7 = i2 << 16 | i2;
     i3 = 0;
     i5 = i8;
     i6 = i1;
     while (1) {
      HEAP32[i6 >> 2] = (HEAP32[i5 >> 2] | 0) + i7;
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (i9 | 0)) break; else {
       i5 = i5 + 4 | 0;
       i6 = i6 + 4 | 0;
      }
     }
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i10 | 0)) break; else {
      i1 = i1 + (i9 << 2) | 0;
      i2 = i2 + i17 | 0;
     }
    }
   }
   i14 = i11 + (i10 << 5) | 0;
   if (!((i12 | 0) >= (i10 | 0) | (i17 | 0) == 0)) {
    i13 = i17 * 9 | 0;
    i11 = i11 + (i12 << 5) | 0;
    i1 = i15;
    while (1) {
     i4 = i11 + 4 | 0;
     i5 = i11 + 8 | 0;
     i6 = i11 + 12 | 0;
     i7 = i11 + 16 | 0;
     i8 = i11 + 20 | 0;
     i9 = i11 + 24 | 0;
     i10 = i11 + 28 | 0;
     i2 = 0;
     i3 = i1;
     while (1) {
      HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i6 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i16 + (i2 << 3) >> 2];
      HEAP32[i3 + 16 >> 2] = HEAP32[i16 + (i2 << 3) + 4 >> 2];
      HEAP32[i3 + 20 >> 2] = HEAP32[i7 >> 2];
      HEAP32[i3 + 24 >> 2] = HEAP32[i8 >> 2];
      HEAP32[i3 + 28 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i3 + 32 >> 2] = HEAP32[i10 >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i17 | 0)) break; else i3 = i3 + 36 | 0;
     }
     i11 = i11 + 32 | 0;
     if (i11 >>> 0 >= i14 >>> 0) break; else i1 = i1 + (i13 << 2) | 0;
    }
   }
  }
 }
 i1 = HEAP32[i18 >> 2] | 0;
 i18 = i1 + 4 | 0;
 HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + -1;
 if (!(HEAP32[i18 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 i1 = HEAP32[i19 + (i21 * 20 | 0) + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = i1 + 4 | 0;
  if ((HEAP32[i1 + 20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 8 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 }
 if (!i20) {
  STACKTOP = i22;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i20);
 STACKTOP = i22;
 return;
}

function __ZN5physx12NpConstraint22setConstraintFunctionsERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableE(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i10 + 16 | 0;
 HEAP32[i10 + 56 >> 2] = i1;
 HEAP32[i10 + 64 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 68 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 72 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 60 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i10 + 76 >> 2] = HEAP32[i2 + 16 >> 2];
 i3 = i10 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i2 = 0; else if ((__ZNK5physx7NpActor13findConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseE(i1 + (HEAP32[gb + 1457020 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10) | 0) == -1) {
  i2 = HEAP32[i3 >> 2] | 0;
  __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i2 + (HEAP32[gb + 1457020 + ((HEAPU16[i2 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10, gb + 688433 | 0);
  i2 = 1;
 } else i2 = 0;
 i4 = i10 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = 7; else if ((__ZNK5physx7NpActor13findConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseE(i1 + (HEAP32[gb + 1457020 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10) | 0) == -1) {
  i7 = HEAP32[i4 >> 2] | 0;
  __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i7 + (HEAP32[gb + 1457020 + ((HEAPU16[i7 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10, gb + 688433 | 0);
 } else i5 = 7;
 if ((i5 | 0) == 7) if (!i2) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = (i1 | 0) == 0;
 if (i5) i4 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0) & 8)) i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0; else i4 = 0;
 i3 = (i2 | 0) == 0;
 if (i3) i2 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0) & 8)) i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0; else i2 = 0;
 i1 = (i4 | 0) != 0;
 if (i5 | i1) i7 = i3 | (i2 | 0) != 0 ? (i1 ? i4 : i2) : 0; else i7 = 0;
 if ((((HEAP32[i10 + 20 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i10 + 16 >> 2] | 0;
  if (!i1) i3 = 0; else i3 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 } else i3 = 0;
 if ((i3 | 0) == (i7 | 0)) {
  STACKTOP = i11;
  return;
 }
 if (i3 | 0) {
  i4 = i3 + 3540 | 0;
  i5 = i3 + 3544 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  L32 : do if (!i6) i1 = 0; else {
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = 0;
   do {
    if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i10 | 0)) break L32;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
  } while (0);
  if ((i1 | 0) != (i6 | 0)) {
   i2 = i6 + -1 | 0;
   HEAP32[i5 >> 2] = i2;
   i6 = HEAP32[i4 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i2 << 2) >> 2];
  }
  __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i3 + 16 | 0, i9);
 }
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 i1 = i7 + 3540 | 0;
 HEAP32[i8 >> 2] = i10;
 i2 = i7 + 3544 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 3548 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i10;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i8) | 0;
 __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE(i7 + 16 | 0, i9);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext19InternalBoxObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 72 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 658162 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 72 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i10 = i1 + 8 | 0;
   i11 = i2 + 8 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 72 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 72 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i11 = i4 + (i1 * 72 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 i10 = i4 + (i1 * 72 | 0) + 8 | 0;
 i3 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 48 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 52 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 56 >> 2] = HEAP32[i6 + 56 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 60 >> 2] = HEAP32[i6 + 60 >> 2];
 HEAP32[i4 + (i1 * 72 | 0) + 64 >> 2] = HEAP32[i6 + 64 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i11 = HEAP32[i5 >> 2] | 0;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i4 + (i11 * 72 | 0) | 0;
  return i11 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i11 = HEAP32[i5 >> 2] | 0;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i4 + (i11 * 72 | 0) | 0;
  return i11 | 0;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i11 = HEAP32[i5 >> 2] | 0;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i4 + (i11 * 72 | 0) | 0;
 return i11 | 0;
}

function _ft_stroker_inside(i10, i11, i3) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i12 = i14;
 i5 = (Math_imul(i11, -11796480) | 0) + 5898240 | 0;
 i6 = i10 + 4 | 0;
 i8 = _UNITY_FT_Angle_Diff(HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i2 = (i8 | 0) / 2 | 0;
 i13 = i10 + 64 + (i11 << 5) + 16 | 0;
 i1 = i10 + 60 | 0;
 if ((i8 + 11763713 | 0) >>> 0 > 23527426 | ((i3 | 0) == 0 | (HEAP8[i13 >> 0] | 0) == 0)) i7 = 4; else {
  i4 = HEAP32[i1 >> 2] | 0;
  i4 = _UNITY_FT_MulFix(i4, _UNITY_FT_Tan(i2) | 0) | 0;
  i4 = (i4 | 0) > -1 ? i4 : 0 - i4 | 0;
  if (!i4) i7 = 4; else if ((i4 | 0) > (i3 | 0) ? 1 : (HEAP32[i10 + 16 >> 2] | 0) < (i4 | 0)) i7 = 4; else {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = _UNITY_FT_Cos(i2) | 0;
   _UNITY_FT_Vector_From_Polar(i12, _UNITY_FT_DivFix(HEAP32[i1 >> 2] | 0, i4) | 0, i2 + i5 + i3 | 0);
   i3 = (HEAP32[i12 >> 2] | 0) + (HEAP32[i10 + 8 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = i3;
   i1 = i12 + 4 | 0;
   i4 = (HEAP32[i1 >> 2] | 0) + (HEAP32[i10 + 12 >> 2] | 0) | 0;
   HEAP32[i1 >> 2] = i4;
   i1 = i10 + 64 + (i11 << 5) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP8[i13 >> 0] | 0)) {
    i8 = i1;
    i5 = i3;
    i7 = 7;
   } else {
    i9 = i12;
    i12 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = (HEAP32[i10 + 64 + (i11 << 5) + 8 >> 2] | 0) + (i2 + -1 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = 0;
   }
  }
 }
 if ((i7 | 0) == 4) {
  _UNITY_FT_Vector_From_Polar(i12, HEAP32[i1 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + i5 | 0);
  i5 = (HEAP32[i12 >> 2] | 0) + (HEAP32[i10 + 8 >> 2] | 0) | 0;
  HEAP32[i12 >> 2] = i5;
  i2 = i12 + 4 | 0;
  i4 = (HEAP32[i2 >> 2] | 0) + (HEAP32[i10 + 12 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP8[i13 >> 0] = 0;
  i2 = i10 + 64 + (i11 << 5) | 0;
  i8 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i7 = 7;
 }
 L8 : do if ((i7 | 0) == 7) {
  if (i2 | 0) {
   i1 = i2 + -1 | 0;
   i3 = HEAP32[i10 + 64 + (i11 << 5) + 8 >> 2] | 0;
   if (((HEAP32[i3 + (i1 << 3) >> 2] | 0) + 1 - i5 | 0) >>> 0 < 3) if (((HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) + 1 - i4 | 0) >>> 0 < 3) {
    i13 = 0;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
  i6 = i10 + 64 + (i11 << 5) + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = i2 + 1 | 0;
  HEAP32[i9 >> 2] = 0;
  do if (i1 >>> 0 > i4 >>> 0) {
   i2 = HEAP32[i10 + 64 + (i11 << 5) + 24 >> 2] | 0;
   i5 = i4;
   do i5 = i5 + 16 + (i5 >>> 1) | 0; while (i5 >>> 0 < i1 >>> 0);
   i3 = i10 + 64 + (i11 << 5) + 8 | 0;
   HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 8, i4, i5, HEAP32[i3 >> 2] | 0, i9) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if (!i1) {
    i1 = i10 + 64 + (i11 << 5) + 12 | 0;
    i4 = _UNITY_ft_mem_realloc(i2, 1, i4, i5, HEAP32[i1 >> 2] | 0, i9) | 0;
    HEAP32[i1 >> 2] = i4;
    i1 = HEAP32[i9 >> 2] | 0;
    if (!i1) {
     HEAP32[i6 >> 2] = i5;
     i2 = HEAP32[i8 >> 2] | 0;
     i1 = i4;
     break;
    }
   }
   break L8;
  } else {
   i3 = i10 + 64 + (i11 << 5) + 8 | 0;
   i1 = HEAP32[i10 + 64 + (i11 << 5) + 12 >> 2] | 0;
  } while (0);
  i10 = i12;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP8[i1 + i2 >> 0] = 1;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i1 = 0;
 } while (0);
 HEAP8[i13 >> 0] = 0;
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function _unity_z_deflateInit2_(i10, i3, i5, i4, i9, i11, i1, i2) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 if (!i1) {
  i14 = -6;
  return i14 | 0;
 }
 if ((i2 | 0) != 56 | (HEAP8[i1 >> 0] | 0) != 49) {
  i14 = -6;
  return i14 | 0;
 }
 if (!i10) {
  i14 = -2;
  return i14 | 0;
 }
 i8 = i10 + 24 | 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i10 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = fb + 334;
  HEAP32[i10 + 40 >> 2] = 0;
  i1 = fb + 334 | 0;
 }
 i14 = i10 + 36 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) HEAP32[i14 >> 2] = fb + 2370;
 i6 = (i3 | 0) == -1 ? 6 : i3;
 if ((i4 | 0) < 0) {
  i3 = 0;
  i2 = 0 - i4 | 0;
 } else {
  i2 = (i4 | 0) > 15;
  i3 = i2 ? 2 : 1;
  i2 = i2 ? i4 + -16 | 0 : i4;
 }
 if (i11 >>> 0 > 4 | (i6 >>> 0 > 9 | ((i5 | 0) != 8 | (i9 + -1 | 0) >>> 0 > 8 | (i2 & -8 | 0) != 8))) {
  i14 = -2;
  return i14 | 0;
 }
 i2 = (i2 | 0) == 8 ? 9 : i2;
 i13 = i10 + 40 | 0;
 i5 = mftCall_iiii(i1 | 0, HEAP32[i13 >> 2] | 0, 1, 5824) | 0;
 if (!i5) {
  i14 = -4;
  return i14 | 0;
 }
 i12 = i10 + 28 | 0;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i5 >> 2] = i10;
 HEAP32[i5 + 24 >> 2] = i3;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = i2;
 i3 = 1 << i2;
 i4 = i5 + 44 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i5 + 52 >> 2] = i3 + -1;
 i15 = i9 + 7 | 0;
 HEAP32[i5 + 80 >> 2] = i15;
 i15 = 1 << i15;
 i1 = i5 + 76 | 0;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i5 + 84 >> 2] = i15 + -1;
 HEAP32[i5 + 88 >> 2] = ((i9 + 9 | 0) >>> 0) / 3 | 0;
 i15 = i5 + 56 | 0;
 HEAP32[i15 >> 2] = mftCall_iiii(HEAP32[i7 >> 2] | 0, HEAP32[i13 >> 2] | 0, i3 | 0, 2) | 0;
 i3 = i5 + 64 | 0;
 HEAP32[i3 >> 2] = mftCall_iiii(HEAP32[i7 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i4 >> 2] | 0, 2) | 0;
 i4 = i5 + 68 | 0;
 HEAP32[i4 >> 2] = mftCall_iiii(HEAP32[i7 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i1 >> 2] | 0, 2) | 0;
 i1 = 1 << i9 + 6;
 i2 = i5 + 5788 | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = mftCall_iiii(HEAP32[i7 >> 2] | 0, HEAP32[i13 >> 2] | 0, i1 | 0, 4) | 0;
 HEAP32[i5 + 8 >> 2] = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 + 12 >> 2] = i2 << 2;
 if (HEAP32[i15 >> 2] | 0) if (HEAP32[i3 >> 2] | 0) if (!((HEAP32[i4 >> 2] | 0) == 0 | (i1 | 0) == 0)) {
  HEAP32[i5 + 5796 >> 2] = i1 + (i2 >>> 1 << 1);
  HEAP32[i5 + 5784 >> 2] = i1 + (i2 * 3 | 0);
  HEAP32[i5 + 132 >> 2] = i6;
  HEAP32[i5 + 136 >> 2] = i11;
  HEAP8[i5 + 36 >> 0] = 8;
  i15 = _unity_z_deflateReset(i10) | 0;
  return i15 | 0;
 }
 HEAP32[i5 + 4 >> 2] = 666;
 HEAP32[i8 >> 2] = HEAP32[gb + 16328 + 24 >> 2];
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i15 = -4;
  return i15 | 0;
 }
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 42:
 case 69:
 case 73:
 case 91:
 case 103:
 case 113:
 case 666:
  break;
 default:
  {
   i15 = -4;
   return i15 | 0;
  }
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 mftCall_vii(HEAP32[i14 >> 2] | 0, HEAP32[i13 >> 2] | 0, i1 | 0);
 HEAP32[i12 >> 2] = 0;
 i15 = -4;
 return i15 | 0;
}

function __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE(i2, i1, i16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 16 | 0;
 i15 = i21;
 i19 = i21 + 24 | 0;
 i20 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i20 | 0) == -1) {
  STACKTOP = i21;
  return;
 }
 i18 = gb + 64016 | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i13 = i15;
 HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i13 + 4 >> 2] = i17;
 HEAP32[i19 >> 2] = 0;
 i13 = i19 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i15);
 i10 = i14;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i18;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 __ZN17PersistentManager13GetAllFileIDsERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EE(i2, i1, i19);
 if (!(HEAP32[i13 >> 2] | 0)) i1 = i2 + 56 | 0; else {
  i12 = i15 + 8 | 0;
  i1 = i2 + 56 | 0;
  i8 = i16 + 4 | 0;
  i9 = i8;
  i10 = i16 + 4 | 0;
  i11 = i16 + 8 | 0;
  i7 = HEAP32[i19 >> 2] | 0;
  do {
   i5 = i7;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i15 >> 2] = i20;
   i6 = i12;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i5;
   i6 = __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(HEAP32[i1 >> 2] | 0, i15) | 0;
   if (i6 | 0) {
    i2 = HEAP32[i8 >> 2] | 0;
    do if (!i2) {
     HEAP32[i14 >> 2] = i8;
     i5 = i9;
     i4 = i8;
    } else {
     while (1) {
      i3 = HEAP32[i2 + 16 >> 2] | 0;
      if ((i6 | 0) < (i3 | 0)) {
       i3 = HEAP32[i2 >> 2] | 0;
       if (!i3) {
        i3 = 12;
        break;
       } else i2 = i3;
      } else {
       if ((i3 | 0) >= (i6 | 0)) {
        i3 = 17;
        break;
       }
       i4 = i2 + 4 | 0;
       i3 = HEAP32[i4 >> 2] | 0;
       if (!i3) {
        i3 = 16;
        break;
       } else i2 = i3;
      }
     }
     if ((i3 | 0) == 12) {
      HEAP32[i14 >> 2] = i2;
      i5 = i2;
      i4 = i2;
      break;
     } else if ((i3 | 0) == 16) {
      HEAP32[i14 >> 2] = i2;
      i5 = i2;
      break;
     } else if ((i3 | 0) == 17) {
      HEAP32[i14 >> 2] = i2;
      i5 = i2;
      i4 = i14;
      break;
     }
    } while (0);
    if (!(HEAP32[i4 >> 2] | 0)) {
     i2 = __Znwj(20) | 0;
     HEAP32[i2 + 16 >> 2] = i6;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = i5;
     HEAP32[i4 >> 2] = i2;
     i3 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
     if (i3) {
      HEAP32[i16 >> 2] = i3;
      i2 = HEAP32[i4 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i2);
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    }
   }
   i7 = i7 + 8 | 0;
  } while ((i7 | 0) != ((HEAP32[i19 >> 2] | 0) + (HEAP32[i13 >> 2] << 3) | 0));
 }
 __ZN8Remapper41GetAllLoadedObjectsForSerializedFileIndexEiPNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(HEAP32[i1 >> 2] | 0, i20, i16);
 if ((HEAP32[i17 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i18);
  HEAP32[i19 >> 2] = 0;
 }
 STACKTOP = i21;
 return;
}

function _UNITY_png_do_read_interlace(i15, i9, i2, i1) {
 i15 = i15 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 if (!((i15 | 0) != 0 & (i9 | 0) != 0)) {
  STACKTOP = i14;
  return;
 }
 i10 = HEAP32[i15 >> 2] | 0;
 i12 = HEAP32[gb + 14668 + (i2 << 2) >> 2] | 0;
 i13 = Math_imul(i12, i10) | 0;
 i11 = i15 + 11 | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 switch (i1 << 24 >> 24) {
 case 1:
  {
   if (i10 | 0) {
    i8 = i9 + ((i10 + -1 | 0) >>> 3) | 0;
    i3 = i9 + ((i13 + -1 | 0) >>> 3) | 0;
    i6 = i10 + 7 & 7 ^ 7;
    i1 = i13 + 7 & 7 ^ 7;
    i7 = 0;
    while (1) {
     i5 = (HEAPU8[i8 >> 0] | 0) >>> i6 & 1;
     i2 = 0;
     i4 = i1;
     do {
      HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 32639 >>> (7 - i4 | 0) | i5 << i4;
      i10 = (i4 | 0) == 7;
      i4 = i10 ? 0 : i4 + 1 | 0;
      i3 = i10 ? i3 + -1 | 0 : i3;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i12 | 0));
     i1 = (i6 | 0) == 7;
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else {
      i8 = i1 ? i8 + -1 | 0 : i8;
      i6 = i1 ? 0 : i6 + 1 | 0;
      i1 = i4;
     }
    }
   }
   break;
  }
 case 2:
  {
   if (i10 | 0) {
    i8 = i9 + ((i10 + -1 | 0) >>> 2) | 0;
    i3 = i9 + ((i13 + -1 | 0) >>> 2) | 0;
    i6 = (i10 << 1) + 6 & 6 ^ 6;
    i1 = (i13 << 1) + 6 & 6 ^ 6;
    i7 = 0;
    while (1) {
     i5 = (HEAPU8[i8 >> 0] | 0) >>> i6 & 3;
     i2 = 0;
     i4 = i1;
     do {
      HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 16191 >>> (6 - i4 | 0) | i5 << i4;
      i10 = (i4 | 0) == 6;
      i4 = i10 ? 0 : i4 + 2 | 0;
      i3 = i10 ? i3 + -1 | 0 : i3;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i12 | 0));
     i1 = (i6 | 0) == 6;
     i7 = i7 + 1 | 0;
     if (i7 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else {
      i8 = i1 ? i8 + -1 | 0 : i8;
      i6 = i1 ? 0 : i6 + 2 | 0;
      i1 = i4;
     }
    }
   }
   break;
  }
 case 4:
  {
   if (i10 | 0) {
    i6 = 0;
    i2 = i13 << 2 & 4;
    i7 = i10 << 2 & 4;
    i3 = i9 + ((i13 + -1 | 0) >>> 1) | 0;
    i5 = i9 + ((i10 + -1 | 0) >>> 1) | 0;
    while (1) {
     i4 = (HEAPU8[i5 >> 0] | 0) >>> i7 & 15;
     i1 = 0;
     do {
      HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 3855 >>> (4 - i2 | 0) | i4 << i2;
      i10 = (i2 | 0) == 4;
      i3 = i10 ? i3 + -1 | 0 : i3;
      i2 = i10 ? 0 : i2 + 4 | 0;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i12 | 0));
     i1 = (i7 | 0) == 4;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else {
      i7 = i1 ? 0 : i7 + 4 | 0;
      i5 = i1 ? i5 + -1 | 0 : i5;
     }
    }
   }
   break;
  }
 default:
  {
   i5 = (i1 & 255) >>> 3;
   if (i10 | 0) {
    i6 = 0 - i5 | 0;
    i4 = 0;
    i1 = i9 + (Math_imul(i5, i13 + -1 | 0) | 0) | 0;
    i2 = i9 + (Math_imul(i5, i10 + -1 | 0) | 0) | 0;
    while (1) {
     _memcpy(i7 | 0, i2 | 0, i5 | 0) | 0;
     i3 = 0;
     do {
      _memcpy(i1 | 0, i7 | 0, i5 | 0) | 0;
      i1 = i1 + i6 | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i12 | 0));
     i4 = i4 + 1 | 0;
     if (i4 >>> 0 >= (HEAP32[i15 >> 2] | 0) >>> 0) break; else i2 = i2 + i6 | 0;
    }
   }
  }
 }
 HEAP32[i15 >> 2] = i13;
 i12 = HEAP8[i11 >> 0] | 0;
 i1 = i12 & 255;
 if ((i12 & 255) > 7) i1 = Math_imul(i1 >>> 3, i13) | 0; else i1 = ((Math_imul(i1, i13) | 0) + 7 | 0) >>> 3;
 HEAP32[i15 + 4 >> 2] = i1;
 STACKTOP = i14;
 return;
}

function __ZNK14MemoryProfiler22GetMemLabelAllocationsER13dynamic_arrayINSt3__24pairIijEELj4EEPKS0_IiLj4EE(i1, i17, i10) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i15 = i17 + 16 | 0;
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  i11 = i17 + 4 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i11);
  HEAP32[i17 >> 2] = 0;
 } else i11 = i17 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i16 = i17 + 12 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i12 = __Z16GetMemoryManagerv() | 0;
 i13 = i14 + 4 | 0;
 i8 = i10 + 12 | 0;
 if (!i10) {
  i1 = 0;
  i8 = 0;
  do {
   HEAP32[i14 >> 2] = i8;
   HEAP32[i13 >> 2] = 0;
   i3 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(i12, i14) | 0;
   if (i3) {
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i15 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i15 >> 2] = i2;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2 << 3, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i10 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
      HEAP32[i15 >> 2] = i2;
      HEAP32[i17 >> 2] = i10;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i5;
    i10 = (HEAP32[i17 >> 2] | 0) + (i4 << 3) | 0;
    HEAP32[i10 >> 2] = i8;
    HEAP32[i10 + 4 >> 2] = i3;
    i1 = i3 + i1 | 0;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != 128);
  STACKTOP = i18;
  return i1 | 0;
 } else {
  i1 = 0;
  i9 = 0;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i4 = i2 + (i7 << 2) | 0;
  L21 : do if (!i7) i3 = 17; else while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
    i3 = 17;
    break L21;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i3 = 18;
    break;
   }
  } while (0);
  if ((i3 | 0) == 17) {
   i3 = 0;
   if ((i2 | 0) == (i4 | 0)) i3 = 18;
  }
  if ((i3 | 0) == 18) {
   HEAP32[i14 >> 2] = i9;
   HEAP32[i13 >> 2] = 0;
   i3 = __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(i12, i14) | 0;
   if (i3) {
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i15 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i2 = i6 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i15 >> 2] = i2;
      HEAP32[i17 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i17 >> 2] | 0, i2 << 3, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i17 >> 2] | 0, HEAP32[i16 >> 2] << 3 | 0) | 0;
      HEAP32[i15 >> 2] = i2;
      HEAP32[i17 >> 2] = i7;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i5;
    i7 = (HEAP32[i17 >> 2] | 0) + (i4 << 3) | 0;
    HEAP32[i7 >> 2] = i9;
    HEAP32[i7 + 4 >> 2] = i3;
    i1 = i3 + i1 | 0;
   }
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != 128);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14AddBufferParamEPKci(i7, i1, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 40 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i9 = i7 + 156 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, _strlen(i1) | 0);
 i3 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i8 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i8 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i12 + 20 >> 2] = i4;
 i5 = i7 + 160 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i7 + 164 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i12);
  i1 = i12 + 11 | 0;
 } else {
  i1 = i12 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  i4 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i10 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i10 = 13;
   }
  } else i10 = 11;
  if ((i10 | 0) == 11) {
   i9 = i4 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i10 = 13;
  }
  if ((i10 | 0) == 13) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  STACKTOP = i14;
  return;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i14;
 return;
}

function __ZN28HasInvalidBehaviourPredicateclERK4PPtrI13MonoBehaviourE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i7 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 9;
 }
 if ((i9 | 0) == 7) i9 = 9;
 do if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) {
  i10 = 1;
  STACKTOP = i8;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 if (i4 | 0) {
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 25; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 25; else if (HEAP32[i1 + 4 >> 2] | 0) {
    i10 = 0;
    STACKTOP = i8;
    return i10 | 0;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(i4) | 0) {
   i10 = 0;
   STACKTOP = i8;
   return i10 | 0;
  }
 }
 i10 = 1;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN11ColorModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i1 = i8 + 416 | 0;
 if ((HEAP16[gb + 1452328 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452328 | 0, i4);
  i2 = gb + 1452328 | 0;
 } else i2 = 0;
 i3 = i5 + 8 | 0;
 __ZN14MinMaxGradient19InitializeOptimizedER23OptimizedMinMaxGradient(i3, i4);
 L4 : do switch (HEAP16[i5 + 160 >> 1] | 0) {
 case 1:
  {
   i1 = (HEAP32[i5 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i5 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   }
  }
 case 3:
  {
   i1 = (HEAP32[i5 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i5 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   }
  }
 default:
  {
   i1 = (HEAP32[i5 + 76 >> 2] | 0) == 0;
   if (!(HEAP32[i5 + 148 >> 2] | 0)) if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else if (i1) {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   } else {
    __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient(i6, i7, i3, i4);
    break L4;
   }
  }
 } while (0);
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 i17 = HEAP32[i16 + 200 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2]);
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 96 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 112 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 128 >> 2])));
 f14 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 100 >> 2]));
 f14 = Math_fround(f14 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 116 >> 2])));
 f14 = Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 132 >> 2])));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i16 + 104 >> 2]));
 f9 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i16 + 120 >> 2])));
 f11 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 136 >> 2])));
 f9 = Math_fround(HEAPF32[i15 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 f14 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f13 + Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE21__push_back_slow_pathIKS9_EEvRT_(i12, i7) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 24 | 0;
 i15 = i17;
 i5 = i12 + 12 | 0;
 i3 = i12 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = i1 - i2 | 0;
 i4 = ((i14 | 0) / 20 | 0) + 1 | 0;
 if ((i14 | 0) < -20) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = ((HEAP32[i12 + 8 >> 2] | 0) - i2 | 0) / 20 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
 i9 = (i1 - i2 | 0) / 20 | 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i14 = i15 + 16 | 0;
 HEAP32[i14 >> 2] = i5;
 if (!i3) i8 = 0; else {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i16 >> 2] = 37;
  HEAP32[i16 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 20 | 0, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i15 >> 2] = i8;
 i5 = i8 + (i9 * 20 | 0) | 0;
 i13 = i15 + 8 | 0;
 HEAP32[i13 >> 2] = i5;
 i11 = i15 + 4 | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i15 + 12 >> 2] = i8 + (i3 * 20 | 0);
 HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
 i5 = i8 + (i9 * 20 | 0) + 4 | 0;
 i6 = i7 + 4 | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 i10 = i8 + (i9 * 20 | 0) + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i8 + (i9 * 20 | 0) + 12 >> 2] = 0;
 i2 = i8 + (i9 * 20 | 0) + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 i7 = i7 + 8 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 i4 = i3 >> 3;
 if (i4 | 0) {
  if ((i3 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i16 >> 2] = 37;
  HEAP32[i16 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 + (i9 * 20 | 0) + 12 >> 2] = i3 + (i4 << 3);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i1 >> 3 << 3);
  }
 }
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 20;
 __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS9_RSA_EE(i12, i15);
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i16 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i13 >> 2] = i2;
   i4 = HEAP32[i1 + -16 >> 2] | 0;
   i5 = i4;
   if (!i4) i1 = i2; else {
    i2 = i1 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i5 | 0) >>> 3) << 3);
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i16 >> 2] = 37;
    HEAP32[i7 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i16);
    i1 = HEAP32[i13 >> 2] | 0;
   }
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i15 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
 HEAP32[i16 >> 2] = 37;
 HEAP32[i16 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i16);
 STACKTOP = i17;
 return;
}

function __ZN7mecanim5human5Human8TransferI8BlobSizeEEvRT_(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 20 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i4 = i6 + 16 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = (0 - i3 & 3) + i3;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i1, i6);
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = (0 - i3 & 3) + i3;
 } else HEAP8[i7 >> 0] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 & 65535;
 if (!((i1 & 255) << 24 >> 24)) {
  i3 = i6 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = i4 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i4 & 3) | 0;
  i4 = (i2 & 65535) < 256 ? i4 : i4 + 4 | 0;
  HEAP32[i3 >> 2] = (0 - i4 & 3) + i4;
  i3 = 0;
 } else {
  HEAP8[i7 >> 0] = 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 & 255;
  i1 = i2;
  i2 = i2 & 65535;
 }
 if (!((i1 & 255) << 24 >> 24)) {
  i4 = i6 + 16 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i8 = i8 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i8 & 3) | 0;
  i8 = (i2 & 65535) < 256 ? i8 : i8 + 4 | 0;
  HEAP32[i4 >> 2] = (0 - i8 & 3) + i8;
 } else {
  HEAP8[i7 >> 0] = 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 & 255;
  i1 = i2;
  i2 = i2 & 65535;
 }
 if (!((i1 & 255) << 24 >> 24)) {
  i4 = i6 + 16 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i8 = i8 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i8 & 3) | 0;
  i8 = (i2 & 65535) < 256 ? i8 : i8 + 4 | 0;
  HEAP32[i4 >> 2] = (0 - i8 & 3) + i8;
  i4 = i3;
  i3 = i2;
 } else {
  HEAP8[i7 >> 0] = 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 & 255;
  i1 = i3;
  i3 = i3 & 65535;
 }
 if (!((i1 & 255) << 24 >> 24)) {
  i2 = i6 + 16 | 0;
  i8 = HEAP32[i2 >> 2] | 0;
  i1 = i8 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i8 & 3) | 0;
  i1 = (i3 & 65535) < 256 ? i1 : i1 + 4 | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(i4 << 24 >> 24)) i5 = 17; else HEAP8[i7 >> 0] = 0;
 } else {
  HEAP8[i7 >> 0] = 0;
  i1 = i6 + 16 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = 17;
 }
 if ((i5 | 0) == 17) {
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i3 = i6 + 16 | 0;
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i7 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  HEAP8[i7 >> 0] = 0;
  i3 = i6 + 16 | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i7 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i7 >> 0] = 0;
 i8 = (0 - i1 & 3) + i1 | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 96 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 96 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 96 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = (0 - i8 & 3) + i8 | 0;
 HEAP32[i3 >> 2] = i8 + 4 + (0 - i8 & 3) + 3;
 return;
}

function __ZN18CrashReportHandlerC2ERK8UnityStrS2_(i13, i11, i9) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i14 = i15 + 8 | 0;
 i1 = i13 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i13 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i13 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i13 + 40 >> 2] = i13 + 44;
 HEAP8[i13 >> 0] = 1;
 HEAP8[i13 + 1 >> 0] = 1;
 i10 = i9 + 11 | 0;
 do if ((i2 | 0) == (i9 | 0)) {
  i3 = i9;
  i2 = i9;
 } else {
  i8 = HEAP8[i10 >> 0] | 0;
  i5 = i8 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i9 >> 2] | 0 : i9;
  i8 = i5 ? HEAP32[i9 + 4 >> 2] | 0 : i8 & 255;
  i5 = i2 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i6 = (HEAP32[i13 + 28 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  if (i8 >>> 0 > i6 >>> 0) {
   if (i4) i3 = HEAP32[i13 + 24 >> 2] | 0; else i3 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i6, i8 - i6 | 0, i3, 0, i3, i8, i7);
   i3 = i9;
   i2 = i9;
   break;
  }
  if (i4) i2 = HEAP32[i2 >> 2] | 0;
  if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i2 + i8 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i13 + 24 >> 2] = i8;
   i3 = i9;
   i2 = i9;
   break;
  } else {
   HEAP8[i5 >> 0] = i8;
   i3 = i9;
   i2 = i9;
   break;
  }
 } while (0);
 i7 = (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i3;
 HEAP32[i12 >> 2] = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
 HEAP32[i12 + 4 >> 2] = i7;
 __Z6FormatPKcz(i14, gb + 1039786 | 0, i12);
 i7 = HEAP8[i14 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i14 >> 2] | 0 : i14;
 i7 = i4 ? HEAP32[i14 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i13 + 12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i13 + 8 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZN18CrashReportHandler23RegisterGlobalCallbacksEv(i13);
  STACKTOP = i15;
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i13 + 8 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZN18CrashReportHandler23RegisterGlobalCallbacksEv(i13);
  STACKTOP = i15;
  return;
 } else {
  HEAP8[i4 >> 0] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  __ZN18CrashReportHandler23RegisterGlobalCallbacksEv(i13);
  STACKTOP = i15;
  return;
 }
}

function __ZNK5Umbra10PortalInfo7getAABBERNS_7Vector3ES2_(i1, i26, i27) {
 i1 = i1 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0;
 i28 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i28 + 32 | 0;
 i24 = i28 + 28 | 0;
 i19 = i28 + 24 | 0;
 i21 = i28 + 20 | 0;
 i22 = i28 + 16 | 0;
 i23 = i28 + 12 | 0;
 i17 = i28 + 8 | 0;
 i25 = i28 + 4 | 0;
 i20 = i28;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 if (!(HEAP8[i1 + 144 >> 0] | 0)) {
  i25 = i1 + 12 | 0;
  HEAP32[i26 >> 2] = HEAP32[i25 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i25 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i25 + 8 >> 2];
  i26 = i1 + 24 | 0;
  HEAP32[i27 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i27 + 4 >> 2] = HEAP32[i26 + 4 >> 2];
  HEAP32[i27 + 8 >> 2] = HEAP32[i26 + 8 >> 2];
  STACKTOP = i28;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 + 112 >> 2] | 0;
 HEAP32[i18 >> 2] = 2139095039;
 HEAP32[i24 >> 2] = 2139095039;
 HEAP32[i19 >> 2] = 2139095039;
 HEAP32[i21 >> 2] = -8388609;
 HEAP32[i22 >> 2] = -8388609;
 HEAP32[i23 >> 2] = -8388609;
 i16 = HEAP32[i1 + 72 >> 2] | 0;
 if ((i16 | 0) > 0) {
  i15 = HEAP32[i1 + 76 >> 2] | 0;
  i14 = i2 + i3 | 0;
  i7 = 0;
  f8 = Math_fround(3402823469999999843913219.0e14);
  f9 = Math_fround(3402823469999999843913219.0e14);
  f10 = Math_fround(-3402823469999999843913219.0e14);
  f11 = Math_fround(-3402823469999999843913219.0e14);
  f12 = Math_fround(-3402823469999999843913219.0e14);
  f13 = Math_fround(3402823469999999843913219.0e14);
  do {
   i5 = i15 + i7 | 0;
   i6 = HEAP32[i14 + (i5 * 12 | 0) >> 2] | 0;
   HEAP32[i17 >> 2] = i6;
   i1 = HEAP32[i14 + (i5 * 12 | 0) + 4 >> 2] | 0;
   HEAP32[i25 >> 2] = i1;
   f29 = Math_fround(HEAPF32[i14 + (i5 * 12 | 0) + 8 >> 2]);
   HEAPF32[i20 >> 2] = f29;
   f31 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i6 = HEAP32[(f8 <= f31 ? i18 : i17) >> 2] | 0;
   f30 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i1 = HEAP32[(f13 <= f30 ? i24 : i25) >> 2] | 0;
   i5 = HEAP32[(f9 <= f29 ? i19 : i20) >> 2] | 0;
   HEAP32[i18 >> 2] = i6;
   HEAP32[i24 >> 2] = i1;
   HEAP32[i19 >> 2] = i5;
   i4 = HEAP32[(f10 >= f31 ? i21 : i17) >> 2] | 0;
   i3 = HEAP32[(f11 >= f30 ? i22 : i25) >> 2] | 0;
   i2 = HEAP32[(f12 >= f29 ? i23 : i20) >> 2] | 0;
   HEAP32[i21 >> 2] = i4;
   HEAP32[i22 >> 2] = i3;
   HEAP32[i23 >> 2] = i2;
   i7 = i7 + 1 | 0;
   f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f9 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f11 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  } while ((i7 | 0) < (i16 | 0));
 } else {
  i6 = 2139095039;
  i5 = 2139095039;
  i4 = -8388609;
  i3 = -8388609;
  i2 = -8388609;
  i1 = 2139095039;
 }
 HEAP32[i26 >> 2] = i6;
 HEAP32[i26 + 4 >> 2] = i1;
 HEAP32[i26 + 8 >> 2] = i5;
 HEAP32[i27 >> 2] = i4;
 HEAP32[i27 + 4 >> 2] = i3;
 HEAP32[i27 + 8 >> 2] = i2;
 STACKTOP = i28;
 return;
}

function __ZN21LightProbeProxyVolume13GetRenderDataER27LightProbeProxyVolumeSample(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i3 = i9;
 i5 = i7 + 156 + (HEAP32[i7 + 164 >> 2] << 2) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if (i2 | 0) {
  HEAP32[i3 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i6 = 7; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i2, i3);
    i3 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i10 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i6 = 7; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i6 = 9;
   }
  }
  if ((i6 | 0) == 7) i6 = 9;
  if ((i6 | 0) == 9) {
   i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   if (!i2) break;
  }
  HEAP32[i8 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 68 >> 2];
  i5 = HEAP32[i7 + 96 >> 2] | 0;
  i6 = HEAP32[i7 + 100 >> 2] | 0;
  i4 = HEAP32[i7 + 104 >> 2] | 0;
  i2 = HEAP32[i7 + 108 >> 2] | 0;
  i3 = HEAP32[i7 + 112 >> 2] | 0;
  if (!(HEAP32[i7 + 88 >> 2] | 0)) {
   f13 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f14 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = HEAP32[i7 + 140 >> 2] | 0;
   i2 = HEAP32[i7 + 144 >> 2] | 0;
   i3 = HEAP32[i7 + 148 >> 2] | 0;
   f12 = Math_fround(i4 >>> 0);
   i4 = i4 + -1 | 0;
   f11 = Math_fround(i4 >>> 0);
   f11 = Math_fround(f15 * Math_fround(f12 / ((i4 | 0) == 0 ? Math_fround(1.0) : f11)));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
   f11 = Math_fround(i2 >>> 0);
   i2 = i2 + -1 | 0;
   f12 = Math_fround(i2 >>> 0);
   f12 = Math_fround(f14 * Math_fround(f11 / ((i2 | 0) == 0 ? Math_fround(1.0) : f12)));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
   f12 = Math_fround(i3 >>> 0);
   i3 = i3 + -1 | 0;
   f11 = Math_fround(i3 >>> 0);
   f11 = Math_fround(f13 * Math_fround(f12 / ((i3 | 0) == 0 ? Math_fround(1.0) : f11)));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  }
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 92 >> 2];
  HEAP32[i8 + 12 >> 2] = i5;
  HEAP32[i8 + 16 >> 2] = i6;
  HEAP32[i8 + 20 >> 2] = i4;
  HEAP32[i8 + 24 >> 2] = i2;
  HEAP32[i8 + 28 >> 2] = i3;
  i3 = HEAP32[i7 + 36 >> 2] | 0;
  HEAP8[i8 + 96 >> 0] = (i3 | 0) == 2 ? 1 : (i3 | 0) == 0 & 1;
  __ZN21LightProbeProxyVolume21GetWorldToLocalMatrixEv(i1, i7);
  i3 = i8 + 32 | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i9;
  return;
 } while (0);
 __ZN27LightProbeProxyVolumeSample10InvalidateEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEEEEvRT_17TransferMetaFlags(i18, i19, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 40 | 0;
 i13 = i17 + 36 | 0;
 i14 = i17 + 16 | 0;
 i7 = i17;
 i15 = i19 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i18, gb + 1041885 | 0, gb + 1041885 | 0, i13) | 0)) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i14 >> 2] = -1;
 i16 = i19 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i19, HEAP32[i16 >> 2] | 0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i19 >> 2] = i16;
 HEAP32[i16 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i9 = HEAP32[gb + 37152 >> 2] | 0;
  i8 = i14 + 4 | 0;
  i10 = i16;
  i11 = i19 + 4 | 0;
  i6 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i9, i12, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEE8TransferI14SafeBinaryReadEEvRS5_RT_(i14, i18); else {
     i1 = HEAP32[i12 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i18 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i18);
   }
   i5 = HEAP32[i14 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i1 = HEAP32[i16 >> 2] | 0;
   do if (!i1) {
    HEAP32[i12 >> 2] = i16;
    i4 = i10;
    i3 = i16;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 14;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 19;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 18;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 14) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 18) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i2 | 0) == 19) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i12;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(36) | 0;
    HEAP32[i1 + 16 >> 2] = i5;
    i2 = i1 + 20 | 0;
    HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i19 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i1);
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i18);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sc10NPhaseCore28fireCustomFilteringCallbacksEv(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i19 = i22 + 32 | 0;
 i14 = i22 + 38 | 0;
 i18 = i22 + 36 | 0;
 i15 = i22 + 24 | 0;
 i16 = i22 + 16 | 0;
 i17 = i22 + 4 | 0;
 i11 = HEAP32[(HEAP32[i20 >> 2] | 0) + 1120 >> 2] | 0;
 if (!i11) {
  STACKTOP = i22;
  return;
 }
 HEAP16[i14 >> 1] = 0;
 HEAP16[i18 >> 1] = 0;
 if (!(mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i19 | 0, i18 | 0, i14 | 0) | 0)) {
  STACKTOP = i22;
  return;
 }
 i12 = i20 + 108 | 0;
 i13 = i15 + 2 | 0;
 i6 = i15 + 4 | 0;
 i7 = i16 + 2 | 0;
 i8 = i16 + 4 | 0;
 i9 = i17 + 4 | 0;
 i10 = i17 + 8 | 0;
 do {
  i4 = HEAP32[i19 >> 2] | 0;
  i3 = i4 & 31;
  i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 >>> 5 << 2) >> 2] | 0;
  i5 = i4 + (i3 * 12 | 0) | 0;
  i1 = HEAP16[i14 >> 1] | 0;
  if ((i1 & 3) == 3) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 701939 | 0, 850, gb + 702085 | 0, i21);
   i1 = i1 & 65534;
  }
  HEAP16[i14 >> 1] = i1;
  i2 = i4 + (i3 * 12 | 0) + 4 | 0;
  if (!(HEAP8[i4 + (i3 * 12 | 0) + 8 >> 0] | 0)) {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP16[i15 >> 1] = i1;
   HEAP16[i13 >> 1] = HEAP16[i18 >> 1] | 0;
   HEAP32[i6 >> 2] = i5;
   if ((__ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i20, i2, i15, 1) | 0) == (i2 | 0)) {
    i1 = i2 + 4 | 0;
    HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 1;
    i1 = i2 + 6 | 0;
    if (!(HEAP16[i1 >> 1] & 2)) {
     __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i2);
     HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 2;
    }
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 1);
   }
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP16[i16 >> 1] = 0;
   HEAP16[i7 >> 1] = 0;
   HEAP32[i8 >> 2] = 0;
   if ((i1 & 12) == 12) HEAP32[i8 >> 2] = i5; else {
    __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i20, i5);
    HEAP8[i2 + 18 >> 0] = 0;
    i1 = HEAP16[i14 >> 1] | 0;
   }
   HEAP16[i16 >> 1] = i1;
   i5 = HEAP16[i18 >> 1] | 0;
   HEAP16[i7 >> 1] = i5;
   HEAP16[i2 + 8 >> 1] = i5;
   i1 = i1 & 65535;
   if (!(i1 & 1)) {
    if (i1 & 2 | 0) HEAP8[i2 + 19 >> 0] = 1;
   } else HEAP8[i2 + 20 >> 0] = 1;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   i5 = HEAP32[i1 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[i1 + 28 >> 2] << 2) | 0;
   HEAP32[i17 >> 2] = i5;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
   i1 = __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv(i17) | 0;
   if (i1 | 0) do {
    if (HEAP8[i1 + 21 >> 0] & 8) {
     i1 = i1 + -8 | 0;
     if ((HEAP32[i1 + 36 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 | 0)) if ((__ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i20, i1, i16, 1) | 0) == (i1 | 0)) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 1);
    }
    i1 = __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv(i17) | 0;
   } while ((i1 | 0) != 0);
  }
 } while (mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i19 | 0, i18 | 0, i14 | 0) | 0);
 STACKTOP = i22;
 return;
}

function __ZN18GfxFramebufferGLES25CleanupFBOMapForTextureIDERK9TextureID(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 16 | 0;
 i11 = i18 + 8 | 0;
 i12 = i18;
 i1 = HEAP32[i8 >> 2] | 0;
 i13 = i8 + 4 | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i18;
  return;
 }
 i14 = i8 + 336 | 0;
 i15 = i8 + 376 | 0;
 i16 = i8 + 8 | 0;
 i10 = i8 + 4 | 0;
 do {
  i2 = i1 + 16 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i6 = i1 + 108 | 0;
  if (!(HEAP8[i6 >> 0] | 0)) i7 = 7; else if ((HEAP32[i1 + 84 >> 2] | 0) == (i4 | 0)) i7 = 10; else i7 = 7;
  L9 : do if ((i7 | 0) == 7) {
   i7 = 0;
   i5 = HEAP32[i2 >> 2] | 0;
   if (i5 | 0) {
    i3 = 0;
    do {
     if ((HEAP32[i1 + 20 + (i3 << 2) >> 2] | 0) == (i4 | 0)) {
      i7 = 10;
      break L9;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i5 >>> 0);
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (i2 | 0) {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break L9; else i1 = i2;
    }
   }
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  } while (0);
  if ((i7 | 0) == 10) {
   i5 = HEAP32[i14 >> 2] | 0;
   i4 = i1 + 112 | 0;
   i19 = i4;
   i7 = HEAP32[i19 + 4 >> 2] | 0;
   i3 = i11;
   HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 4 >> 2] = i7;
   HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i5, 0, i17);
   i5 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 668 >> 2] | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i2 = 0;
    do {
     mftCall_viiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i2 + 36064 | 0, 3553, 0, 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
   if (HEAP8[i6 >> 0] | 0) {
    mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, 36096, 36161, 0);
    mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, 36128, 36161, 0);
   }
   i2 = HEAP32[i14 >> 2] | 0;
   i7 = i15;
   i19 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = i12;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = i19;
   HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_(i2, i4, i17);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i5 = (i2 | 0) == 0;
   if (i5) {
    i4 = i1;
    while (1) {
     i3 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) {
      i6 = i1;
      break;
     } else i4 = i3;
    }
   } else {
    i3 = i2;
    while (1) {
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else i3 = i4;
    }
    i6 = i1;
   }
   if (i5) {
    i4 = i6;
    while (1) {
     i2 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break; else i4 = i2;
    }
   } else while (1) {
    i4 = HEAP32[i2 >> 2] | 0;
    if (!i4) break; else i2 = i4;
   }
   if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) HEAP32[i8 >> 2] = i2;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i6);
   __ZdlPv(i1);
   i1 = i3;
  }
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEbT0_S7_T_(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0;
 switch (i12 - i13 >> 3 | 0) {
 case 2:
  {
   i5 = i12 + -8 | 0;
   f7 = Math_fround(HEAPF32[i5 >> 2]);
   f8 = Math_fround(HEAPF32[i13 >> 2]);
   if (f7 < f8) {
    i2 = i13 + 4 | 0;
    i4 = i12 + -4 | 0;
    i1 = i2;
    i3 = i4;
    i4 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i2 >> 2] | 0;
   } else {
    if (f8 < f7) {
     i13 = 1;
     return i13 | 0;
    }
    i3 = i12 + -4 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i1 = i13 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i4 >>> 0 >= i2 >>> 0) {
     i13 = 1;
     return i13 | 0;
    }
   }
   HEAPF32[i13 >> 2] = f7;
   HEAPF32[i5 >> 2] = f8;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i3 >> 2] = i2;
   i13 = 1;
   return i13 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i13, i13 + 8 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i13, i13 + 8 | 0, i13 + 16 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i13, i13 + 8 | 0, i13 + 16 | 0, i13 + 24 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 1:
 case 0:
  {
   i13 = 1;
   return i13 | 0;
  }
 default:
  {
   i3 = i13 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i13, i13 + 8 | 0, i3, i1) | 0;
   i1 = i13 + 24 | 0;
   L3 : do if ((i1 | 0) == (i12 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     f8 = Math_fround(HEAPF32[i1 >> 2]);
     f7 = Math_fround(HEAPF32[i3 >> 2]);
     if (f8 < f7) {
      i9 = i1 + 4 | 0;
      i6 = i3 + 4 | 0;
      i4 = i6;
      i5 = i9;
      i6 = HEAP32[i6 >> 2] | 0;
      i9 = HEAP32[i9 >> 2] | 0;
      i11 = 15;
     } else if (!(f7 < f8)) {
      i5 = i1 + 4 | 0;
      i9 = HEAP32[i5 >> 2] | 0;
      i4 = i3 + 4 | 0;
      i6 = HEAP32[i4 >> 2] | 0;
      if (i9 >>> 0 < i6 >>> 0) i11 = 15;
     }
     if ((i11 | 0) == 15) {
      i11 = 0;
      HEAPF32[i1 >> 2] = f7;
      HEAP32[i5 >> 2] = i6;
      L12 : do if ((i3 | 0) != (i13 | 0)) {
       i10 = i3;
       i6 = i4;
       while (1) {
        i3 = i10 + -8 | 0;
        f7 = Math_fround(HEAPF32[i3 >> 2]);
        if (f8 < f7) {
         i5 = i10 + -4 | 0;
         i4 = i5;
         i5 = HEAP32[i5 >> 2] | 0;
        } else {
         if (f7 < f8) {
          i4 = i6;
          i3 = i10;
          break L12;
         }
         i4 = i10 + -4 | 0;
         i5 = HEAP32[i4 >> 2] | 0;
         if (i9 >>> 0 >= i5 >>> 0) {
          i4 = i6;
          i3 = i10;
          break L12;
         }
        }
        HEAPF32[i10 >> 2] = f7;
        HEAP32[i10 + 4 >> 2] = i5;
        if ((i3 | 0) == (i13 | 0)) break; else {
         i10 = i3;
         i6 = i4;
        }
       }
      } while (0);
      HEAPF32[i3 >> 2] = f8;
      HEAP32[i4 >> 2] = i9;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i12 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i13 = i1 | i2;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN9Projector8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380721 | 0, i7, i1 + 36 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380737 | 0, i7, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380752 | 0, i7, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380766 | 0, i7, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380780 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380795 | 0, i7, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 64 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946425 | 0, gb + 946436 | 0, i7, 0);
 i6 = i8 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380814 | 0, gb + 1048681 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 4194305);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i6 + 32 | 0;
 i25 = i6 + 16 | 0;
 i11 = i6;
 i27 = HEAP32[i5 + 4 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(-f9);
 f17 = Math_fround(-f17);
 f15 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 i24 = HEAP32[i5 + 12 >> 2] | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i24 >> 2]) * f9);
 i21 = i24 + 4 | 0;
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i21 >> 2]) * f17));
 i18 = i24 + 8 | 0;
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i18 >> 2]) * f15));
 i23 = i24 + 16 | 0;
 f14 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) * f9);
 i20 = i24 + 20 | 0;
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f17));
 i16 = i24 + 24 | 0;
 f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f15));
 i22 = i24 + 32 | 0;
 f9 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) * f9);
 i19 = i24 + 36 | 0;
 f17 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f17));
 i13 = i24 + 40 | 0;
 f15 = Math_fround(f17 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f15));
 HEAPF32[i26 >> 2] = f8;
 HEAPF32[i26 + 4 >> 2] = f14;
 HEAPF32[i26 + 8 >> 2] = f15;
 HEAPF32[i26 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i25, i27, i26);
 f15 = Math_fround(HEAPF32[i24 + 48 >> 2]);
 f14 = Math_fround(HEAPF32[i24 + 52 >> 2]);
 f8 = Math_fround(HEAPF32[i24 + 56 >> 2]);
 f17 = Math_fround(HEAPF32[i25 >> 2]);
 f9 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 f10 = Math_fround(f17 * Math_fround(HEAPF32[i24 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i23 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f7 * Math_fround(HEAPF32[i22 >> 2])));
 f12 = Math_fround(f17 * Math_fround(HEAPF32[i21 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f7 * Math_fround(HEAPF32[i19 >> 2])));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i18 >> 2]));
 f9 = Math_fround(f17 + Math_fround(f9 * Math_fround(HEAPF32[i16 >> 2])));
 f10 = Math_fround(f15 + f10);
 f12 = Math_fround(f14 + f12);
 f7 = Math_fround(f8 + Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i13 >> 2]))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram6BindCBEPKci(i7, i1, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 40 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i9 = i7 + 180 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, _strlen(i1) | 0);
 i3 = HEAP8[i13 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i13 >> 2] | 0 : i13;
 i3 = i1 ? HEAP32[i13 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i8 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i8 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i12 + 20 >> 2] = i4;
 i5 = i7 + 184 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i7 + 188 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i12);
  i1 = i12 + 11 | 0;
 } else {
  i1 = i12 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i12 >> 2] | 0 : i12;
  i4 = i2 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i10 = 11;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i10 = 13;
   }
  } else i10 = 11;
  if ((i10 | 0) == 11) {
   i9 = i4 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i11 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i10 = 13;
  }
  if ((i10 | 0) == 13) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 24;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  STACKTOP = i14;
  return;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i14;
 return;
}

function __ZN15b2DistanceJoint24SolvePositionConstraintsERK12b2SolverData(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0;
 if (Math_fround(HEAPF32[i18 + 68 >> 2]) > Math_fround(0.0)) {
  i19 = 1;
  return i19 | 0;
 }
 i19 = i18 + 108 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 i16 = i1 + 24 | 0;
 i21 = HEAP32[i16 >> 2] | 0;
 i17 = i21 + (i8 * 12 | 0) | 0;
 f5 = Math_fround(HEAPF32[i17 >> 2]);
 i1 = i21 + (i8 * 12 | 0) + 4 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i21 + (i8 * 12 | 0) + 8 >> 2]);
 i8 = i18 + 112 | 0;
 i20 = HEAP32[i8 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) >> 2]);
 f10 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) + 8 >> 2]);
 f14 = Math_fround(+Math_sin(+f7));
 f2 = Math_fround(+Math_cos(+f7));
 f3 = Math_fround(+Math_sin(+f11));
 f4 = Math_fround(+Math_cos(+f11));
 f15 = Math_fround(HEAPF32[i18 + 80 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i18 + 140 >> 2]));
 f13 = Math_fround(HEAPF32[i18 + 84 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i18 + 144 >> 2]));
 f12 = Math_fround(Math_fround(f2 * f15) - Math_fround(f14 * f13));
 f13 = Math_fround(Math_fround(f14 * f15) + Math_fround(f2 * f13));
 f2 = Math_fround(HEAPF32[i18 + 88 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i18 + 148 >> 2]));
 f15 = Math_fround(HEAPF32[i18 + 92 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i18 + 152 >> 2]));
 f14 = Math_fround(Math_fround(f4 * f2) - Math_fround(f3 * f15));
 f15 = Math_fround(Math_fround(f3 * f2) + Math_fround(f4 * f15));
 f4 = Math_fround(Math_fround(Math_fround(f9 + f14) - f5) - f12);
 f2 = Math_fround(Math_fround(Math_fround(f10 + f15) - f6) - f13);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2))));
 if (f3 < Math_fround(1.1920929e-07)) f3 = Math_fround(0.0); else {
  f22 = Math_fround(Math_fround(1.0) / f3);
  f4 = Math_fround(f22 * f4);
  f2 = Math_fround(f22 * f2);
 }
 f22 = Math_fround(f3 - Math_fround(HEAPF32[i18 + 104 >> 2]));
 f3 = Math_fround(HEAPF32[gb + 151880 >> 2]);
 f23 = Math_fround(-f3);
 f3 = f22 < f3 ? f22 : f3;
 f3 = f3 < f23 ? f23 : f3;
 f23 = Math_fround(-Math_fround(Math_fround(HEAPF32[i18 + 172 >> 2]) * f3));
 f22 = Math_fround(f4 * f23);
 f4 = Math_fround(f2 * f23);
 f2 = Math_fround(HEAPF32[i18 + 156 >> 2]);
 f5 = Math_fround(f5 - Math_fround(f2 * f22));
 f6 = Math_fround(f6 - Math_fround(f2 * f4));
 f7 = Math_fround(f7 - Math_fround(Math_fround(HEAPF32[i18 + 164 >> 2]) * Math_fround(Math_fround(f12 * f4) - Math_fround(f13 * f22))));
 f13 = Math_fround(HEAPF32[i18 + 160 >> 2]);
 f12 = Math_fround(f9 + Math_fround(f13 * f22));
 f13 = Math_fround(f10 + Math_fround(f13 * f4));
 f22 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i18 + 168 >> 2]) * Math_fround(Math_fround(f14 * f4) - Math_fround(f15 * f22))));
 HEAPF32[i17 >> 2] = f5;
 HEAPF32[i1 >> 2] = f6;
 i20 = HEAP32[i16 >> 2] | 0;
 HEAPF32[i20 + ((HEAP32[i19 >> 2] | 0) * 12 | 0) + 8 >> 2] = f7;
 i21 = HEAP32[i8 >> 2] | 0;
 HEAPF32[i20 + (i21 * 12 | 0) >> 2] = f12;
 HEAPF32[i20 + (i21 * 12 | 0) + 4 >> 2] = f13;
 HEAPF32[(HEAP32[i16 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 12 | 0) + 8 >> 2] = f22;
 i21 = f3 > Math_fround(0.0);
 f22 = Math_fround(-f3);
 i21 = (i21 ? f3 : f22) < Math_fround(.00499999989);
 return i21 | 0;
}

function __ZN10GameObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 if (!(HEAP32[i8 >> 2] & 16384)) {
  i3 = i11 + 28 | 0;
  i4 = i8 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i2 + 4 | 0;
  i5 = i8 + 24 | 0;
  if (i1 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i4, i12, 4);
   i1 = HEAP32[i12 >> 2] | 0;
  } else {
   i7 = HEAP32[i2 >> 2] | 0;
   HEAP32[i12 >> 2] = i7;
   HEAP32[i4 >> 2] = i1;
   i1 = i7;
  }
  __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i8 + 8 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i11 + 40 >> 2] | 0;
  i3 = i1 + (i7 << 3) | 0;
  if (!i7) {
   i7 = i4;
   i6 = i4;
  } else {
   do {
    i2 = i1 + 4 | 0;
    __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2, i8);
    i2 = HEAP32[i2 >> 2] | 0;
    if (!i2) i2 = 0; else i2 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = i2;
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i7 = i4;
   i6 = i4;
  }
 } else {
  i6 = i8 + 16 | 0;
  i7 = i6;
  i5 = i8 + 24 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i12, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i11 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i9, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i8 = i9 + 11 | 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 i1 = gb + 63648 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i11 + 64 | 0, i4, i12);
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i10 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i12, 2);
  i1 = HEAP16[i12 >> 1] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i12 >> 1] = i1;
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 HEAP16[i11 + 52 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i11 + 54 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i12, 1);
  i12 = HEAP8[i12 >> 0] | 0;
  HEAP8[i1 >> 0] = i12;
  STACKTOP = i13;
  return;
 } else {
  i11 = HEAP8[i4 >> 0] | 0;
  HEAP8[i12 >> 0] = i11;
  HEAP32[i7 >> 2] = i2;
  i12 = i11;
  HEAP8[i1 >> 0] = i12;
  STACKTOP = i13;
  return;
 }
}

function __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_(i7, i3, i5) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i4 = (i3 | 0) == -1;
 if (i4) {
  i1 = 0;
  i6 = 3;
 } else if ((i3 | 0) == 1001) {
  i1 = 13;
  i6 = 3;
 } else if ((i3 | 0) == 1) {
  i1 = 26;
  i6 = 3;
 } else if ((i3 | 0) == 7) {
  i1 = 39;
  i6 = 3;
 } else if ((i3 | 0) == 3) {
  i1 = 52;
  i6 = 3;
 } else if ((i3 | 0) == 2) {
  i1 = 78;
  i6 = 3;
 } else if ((i3 | 0) == 5) {
  i1 = 91;
  i6 = 3;
 } else if ((i3 | 0) == 8) {
  i1 = 104;
  i6 = 3;
 } else if ((i3 | 0) == 1e3) {
  i1 = 117;
  i6 = 3;
 } else if ((i3 | 0) == 13) {
  i1 = 130;
  i6 = 3;
 } else if ((i3 | 0) == 14) {
  i1 = 143;
  i6 = 3;
 } else switch (i3 | 0) {
 case 4:
  {
   i1 = 156;
   i6 = 3;
   break;
  }
 case 1001:
  {
   i1 = 20;
   i6 = 29;
   break;
  }
 default:
  i6 = 30;
 }
 if ((i6 | 0) == 3) {
  if ((i5 | 0) == -1) {
   i2 = 0;
   i6 = 25;
  } else if ((i5 | 0) == 1001) {
   i2 = 1;
   i6 = 25;
  } else if ((i5 | 0) == 1) {
   i2 = 2;
   i6 = 25;
  } else if ((i5 | 0) == 7) {
   i2 = 3;
   i6 = 25;
  } else if ((i5 | 0) == 3) {
   i2 = 4;
   i6 = 25;
  } else if ((i5 | 0) == 2) {
   i2 = 6;
   i6 = 25;
  } else if ((i5 | 0) == 5) {
   i2 = 7;
   i6 = 25;
  } else if ((i5 | 0) == 8) {
   i2 = 8;
   i6 = 25;
  } else if ((i5 | 0) == 1e3) {
   i2 = 9;
   i6 = 25;
  } else if ((i5 | 0) == 13) {
   i2 = 10;
   i6 = 25;
  } else if ((i5 | 0) == 14) {
   i2 = 11;
   i6 = 25;
  } else if ((i5 | 0) == 4) {
   i2 = 12;
   i6 = 25;
  }
  if ((i6 | 0) == 25) {
   i1 = HEAP32[gb + 56896 + (i2 + i1 << 2) >> 2] | 0;
   if (i1 | 0) {
    HEAP8[i7 >> 0] = 0;
    HEAP32[i7 + 4 >> 2] = i1;
    i7 = i7 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    return;
   }
  }
  if (i4) {
   i1 = 7;
   i6 = 29;
  } else if ((i3 | 0) == 1001) {
   i1 = 20;
   i6 = 29;
  } else i6 = 30;
 }
 if ((i6 | 0) == 30) if ((i3 | 0) == 1) {
  i1 = 33;
  i6 = 29;
 } else if ((i3 | 0) == 7) {
  i1 = 46;
  i6 = 29;
 } else if ((i3 | 0) == 3) {
  i1 = 59;
  i6 = 29;
 } else if ((i3 | 0) == 2) {
  i1 = 85;
  i6 = 29;
 } else if ((i3 | 0) == 5) {
  i1 = 98;
  i6 = 29;
 } else if ((i3 | 0) == 8) {
  i1 = 111;
  i6 = 29;
 } else if ((i3 | 0) == 1e3) {
  i1 = 124;
  i6 = 29;
 } else if ((i3 | 0) == 13) {
  i1 = 137;
  i6 = 29;
 } else if ((i3 | 0) == 14) {
  i1 = 150;
  i6 = 29;
 } else if ((i3 | 0) == 4) {
  i1 = 163;
  i6 = 29;
 } else i2 = 0;
 if ((i6 | 0) == 29) i2 = HEAP32[gb + 56896 + (i1 << 2) >> 2] | 0;
 if ((i5 | 0) == -1) {
  i1 = 91;
  i6 = 42;
 } else if ((i5 | 0) == 1001) {
  i1 = 92;
  i6 = 42;
 } else if ((i5 | 0) == 1) {
  i1 = 93;
  i6 = 42;
 } else if ((i5 | 0) == 7) {
  i1 = 94;
  i6 = 42;
 } else if ((i5 | 0) == 3) {
  i1 = 95;
  i6 = 42;
 } else if ((i5 | 0) == 2) {
  i1 = 97;
  i6 = 42;
 } else if ((i5 | 0) == 5) {
  i1 = 98;
  i6 = 42;
 } else if ((i5 | 0) == 8) {
  i1 = 99;
  i6 = 42;
 } else if ((i5 | 0) == 1e3) {
  i1 = 100;
  i6 = 42;
 } else if ((i5 | 0) == 13) {
  i1 = 101;
  i6 = 42;
 } else if ((i5 | 0) == 14) {
  i1 = 102;
  i6 = 42;
 } else if ((i5 | 0) == 4) {
  i1 = 103;
  i6 = 42;
 } else i1 = 0;
 if ((i6 | 0) == 42) i1 = HEAP32[gb + 56896 + (i1 << 2) >> 2] | 0;
 i6 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(5) | 0) + 4 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = i6;
 return;
}

function __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i8, i9, i1, i3, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10 + 4 | 0;
 i7 = i10;
 i4 = i10 + 12 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 if ((i1 | 0) != 0 & (i3 | 0) != 0) {
  i11 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  i12 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i11 >>> 0 < i12 >>> 0 ? i12 : i11;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 if (i2) {
  i2 = i8 + 92 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + -1 | 0;
   i4 = HEAP32[(HEAP32[i8 + 88 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = i9 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    HEAP32[i1 >> 2] = i2 + 1;
    i12 = i3;
    i11 = HEAP32[i8 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
    STACKTOP = i10;
    return i12 | 0;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i5) | 0;
    i12 = i3;
    i11 = HEAP32[i8 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
    STACKTOP = i10;
    return i12 | 0;
   }
  }
 }
 i2 = i8 + 116 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[(HEAP32[i8 + 112 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
  i1 = i9 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   HEAP32[i1 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) | 0;
  i12 = i8 + 152 | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  i9 = i8 + 156 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i11 >>> 0 < i7 >>> 0 ? i7 : i11;
  HEAP32[i12 >> 2] = i11;
  i12 = i3;
  i11 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i10;
  return i12 | 0;
 }
 i2 = i8 + 140 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i8 + 144 >> 2] | 0)) {
  i12 = 0;
  i11 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i10;
  return i12 | 0;
 }
 HEAP32[i2 >> 2] = i1 + 1;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 16384, gb + 703366 | 0, 218) | 0;
 HEAP32[i7 >> 2] = i3;
 if (!i3) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i12 = i3;
  i11 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i10;
  return i12 | 0;
 }
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i3;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i7) | 0;
 i12 = i8 + 152 | 0;
 i11 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
 i9 = i8 + 156 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i11 >>> 0 < i7 >>> 0 ? i7 : i11;
 HEAP32[i12 >> 2] = i11;
 i12 = i3;
 i11 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 STACKTOP = i10;
 return i12 | 0;
}

function __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i5 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 4;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 8;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i2 = i4 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 16;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 20;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i4 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 36;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 40;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 48;
 HEAP32[i6 + 4 >> 2] = i4 + 44;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i5, i6, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 56;
 HEAP32[i6 + 4 >> 2] = i4 + 52;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i5, i6, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 64;
 HEAP32[i6 + 4 >> 2] = i4 + 60;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i5, i6, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i3 = i4 + 68 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 72;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 76;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i7;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i5, i6, 0);
 STACKTOP = i8;
 return;
}

function __Z48AssetBundleManifest_CUSTOM_GetDirectDependenciesP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 48 | 0;
 i3 = i12 + 44 | 0;
 i11 = i12 + 32 | 0;
 i6 = i12 + 16 | 0;
 i7 = i12;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK11ICallString6ToUTF8Ev(i7, i3);
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 7;
 } else if (i4 >>> 0 < 11) {
  i1 = i6 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i6; else {
   i2 = i6;
   i8 = 9;
  }
 } else i8 = 7;
 if ((i8 | 0) == 7) {
  i13 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = i13 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i4;
  i1 = i6 + 11 | 0;
  i8 = 9;
 }
 if ((i8 | 0) == 9) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN19AssetBundleManifest25CollectDirectDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE(i5, i6, i11);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i13 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i9 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i8 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i8 + 11 >> 0] | 0;
   i13 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i13 ? HEAP32[i8 >> 2] | 0 : i8, i13 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i12;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i10 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i9 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
    i2 = HEAP32[i9 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i12;
 return i5 | 0;
}

function __Z15GetMeshForPatchiiiR9HeightmapPK15TerrainRenderer(i2, i3, i5, i7, i10) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i6 = i14;
 i11 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 930611 | 0, 768) | 0;
 i1 = gb + 63520 | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i4, i13, 0);
 __Z19pop_allocation_rootv();
 i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 4);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, 61);
 i6 = i4 + 32 | 0;
 __ZN4Mesh14ResizeVerticesEjj(i4, 289, HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 11);
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = i8 + 8 | 0;
 i1 = HEAP16[i8 + 10 >> 1] | 0;
 do if ((i1 & 65535) < 768 | (i1 & 255) != 0) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (i1 | 0) if (HEAP8[i8 + 11 >> 0] | 0) {
   i15 = HEAPU8[i9 + 32 + ((HEAPU8[i9 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i16 = HEAP16[i9 >> 1] | 0;
   HEAP32[i13 >> 2] = i1 + (((i16 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i16 & 255) * 12 | 0) + 4 >> 2] | 0));
   HEAP32[i13 + 4 >> 2] = i15;
   break;
  }
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 1;
 } while (0);
 i16 = HEAP16[i8 + 14 >> 1] | 0;
 do if ((i16 & 65535) < 768 | (i16 & 255) != 0) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (i1 | 0) if (HEAP8[i8 + 15 >> 0] | 0) {
   i16 = HEAPU8[i9 + 32 + ((HEAPU8[i8 + 12 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i15 = HEAP16[i8 + 12 >> 1] | 0;
   HEAP32[i11 >> 2] = i1 + (((i15 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i15 & 255) * 12 | 0) + 4 >> 2] | 0));
   HEAP32[i11 + 4 >> 2] = i16;
   break;
  }
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 1;
 } while (0);
 i16 = HEAP16[i8 + 22 >> 1] | 0;
 do if ((i16 & 65535) < 512 | (i16 & 255) != 0) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
 } else {
  i1 = HEAP32[i8 + 92 >> 2] | 0;
  if (i1 | 0) if (HEAP8[i8 + 23 >> 0] | 0) {
   i16 = HEAPU8[i9 + 32 + ((HEAPU8[i8 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i15 = HEAP16[i8 + 20 >> 1] | 0;
   HEAP32[i12 >> 2] = i1 + (((i15 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i15 & 255) * 12 | 0) + 4 >> 2] | 0));
   HEAP32[i12 + 4 >> 2] = i16;
   break;
  }
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 1;
 } while (0);
 __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fES4_RKS0_I8Vector2fEiiiPK15TerrainRenderer(i7, i13, i11, i12, i2, i3, i5, i10);
 __ZNK9Heightmap15CalculateBoundsEiii(i13, i7, i2, i3, i5);
 __ZN4Mesh9SetBoundsERK4AABB(i4, i13);
 __ZN4Mesh16SetChannelsDirtyEjb(i4, HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, 0);
 i16 = __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj(15, i13) | 0;
 __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i4, i16, HEAP32[i13 >> 2] | 0, 0, 1, 17) | 0;
 __ZN4Mesh17RecalculateBoundsEv(i4);
 STACKTOP = i14;
 return i4 | 0;
}

function __ZNK20TextRenderingPrivate8FontImpl22GetCharacterRenderInfoEjijfR5RectTIfES3_RbPj(i6, i2, i1, i4, f12, i13, i14, i15, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = HEAP32[i6 + 32 >> 2] | 0;
 switch (i3 | 0) {
 case 1:
  {
   i11 = i2 << 24 >> 24;
   i11 = ((((i2 & 255) + -97 & 255) < 26 ? i11 + 224 | 0 : i11) << 24 >> 24) - (HEAP32[i6 + 28 >> 2] | 0) | 0;
   break;
  }
 case 2:
  {
   i11 = i2 << 24 >> 24;
   i11 = ((((i2 & 255) + -65 & 255) < 26 ? i11 + 32 | 0 : i11) << 24 >> 24) - (HEAP32[i6 + 28 >> 2] | 0) | 0;
   break;
  }
 default:
  i11 = i2 - (HEAP32[i6 + 28 >> 2] | 0) | 0;
 }
 if (!i1) i1 = HEAP32[(HEAP32[i6 + 76 >> 2] | 0) + 36 >> 2] | 0;
 i1 = (i1 | 0) > 500 ? 500 : i1;
 do if ((i3 | 0) == -2) i8 = i1; else {
  if ((i1 | 0) != (HEAP32[(HEAP32[i6 + 76 >> 2] | 0) + 36 >> 2] | 0)) {
   if (!i5) {
    i4 = 0;
    i8 = 0;
    break;
   }
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1;
   i1 = 0;
  }
  if ((i4 | 0) == 0 | (i5 | 0) == 0) {
   i4 = 0;
   i8 = i1;
  } else {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i4 = 0;
   i8 = i1;
  }
 } while (0);
 i3 = HEAP32[i6 + 60 >> 2] | 0;
 i9 = HEAP32[i6 + 64 >> 2] | 0;
 i1 = i9 - i3 | 0;
 if (!i1) i2 = i3; else {
  i1 = (i1 | 0) / 60 | 0;
  i2 = i3;
  do {
   i6 = (i1 | 0) / 2 | 0;
   i7 = i3 + (i6 * 60 | 0) | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   do if ((i5 | 0) == (i11 | 0)) {
    i5 = HEAP32[i3 + (i6 * 60 | 0) + 40 >> 2] | 0;
    if ((i5 | 0) != (i8 | 0)) if ((i5 | 0) < (i8 | 0)) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    }
    i5 = HEAP32[i3 + (i6 * 60 | 0) + 44 >> 2] | 0;
    if ((i5 | 0) == (i4 | 0)) if (Math_fround(HEAPF32[i3 + (i6 * 60 | 0) + 48 >> 2]) < f12) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    } else if (i4 >>> 0 < i5 >>> 0) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    }
   } else if (i5 >>> 0 < i11 >>> 0) i10 = 23; else i1 = i6; while (0);
   if ((i10 | 0) == 23) {
    i10 = 0;
    i3 = i7 + 60 | 0;
    i1 = i1 + -1 - i6 | 0;
    i2 = i3;
   }
  } while ((i1 | 0) != 0);
 }
 L34 : do if ((i2 | 0) != (i9 | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if ((i11 | 0) == (i1 | 0)) {
   i1 = HEAP32[i2 + 40 >> 2] | 0;
   if ((i8 | 0) != (i1 | 0)) if ((i8 | 0) < (i1 | 0) | (i2 | 0) == (i9 | 0)) break L34; else break;
   i1 = HEAP32[i2 + 44 >> 2] | 0;
   if ((i4 | 0) == (i1 | 0)) if ((i2 | 0) == (i9 | 0) ? 1 : Math_fround(HEAPF32[i2 + 48 >> 2]) > f12) break L34; else break; else if (i1 >>> 0 < i4 >>> 0 | (i2 | 0) == (i9 | 0)) break L34; else break;
  } else if (i11 >>> 0 < i1 >>> 0 | (i2 | 0) == (i9 | 0)) break L34; while (0);
  i11 = i2 + 20 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i13 = i2 + 4 | 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  i14 = HEAP8[i2 + 56 >> 0] | 0;
  HEAP8[i15 >> 0] = i14;
  return;
 } while (0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i14 = 0;
 HEAP8[i15 >> 0] = i14;
 return;
}

function __ZN5physx2Gu34checkOverlapSphere_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 24 | 0;
 i6 = i4;
 f10 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f20 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f10 = Math_fround(f10 * Math_fround(-2.0));
 f20 = Math_fround(f20 * Math_fround(-2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(-2.0));
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(Math_fround(f9 * f9) + Math_fround(-.5));
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f10 * f7);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f20 * f11));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f13 * f19));
 f16 = Math_fround(Math_fround(f7 * f12) + Math_fround(Math_fround(f10 * f8) - Math_fround(f9 * Math_fround(Math_fround(f13 * f11) - Math_fround(f20 * f19)))));
 f14 = Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(f20 * f8) - Math_fround(f9 * Math_fround(Math_fround(f10 * f19) - Math_fround(f13 * f7)))));
 f12 = Math_fround(Math_fround(Math_fround(f13 * f8) - Math_fround(f9 * Math_fround(Math_fround(f20 * f7) - Math_fround(f10 * f11)))) + Math_fround(f19 * f12));
 f10 = Math_fround(-f7);
 f20 = Math_fround(-f11);
 f8 = Math_fround(-f19);
 f7 = Math_fround(f10 - f7);
 f11 = Math_fround(f20 - f11);
 f19 = Math_fround(f8 - f19);
 f13 = Math_fround(f9 * f7);
 f21 = Math_fround(f9 * f11);
 f9 = Math_fround(f9 * f19);
 f22 = Math_fround(f11 * f10);
 f15 = Math_fround(f19 * f10);
 f11 = Math_fround(f11 * f20);
 f20 = Math_fround(f19 * f20);
 f8 = Math_fround(f19 * f8);
 f19 = Math_fround(Math_fround(Math_fround(1.0) - f11) - f8);
 f18 = Math_fround(f22 + f9);
 f17 = Math_fround(f15 - f21);
 f9 = Math_fround(f22 - f9);
 f10 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f10));
 f8 = Math_fround(f10 - f8);
 f7 = Math_fround(f13 + f20);
 f15 = Math_fround(f21 + f15);
 f13 = Math_fround(f20 - f13);
 f11 = Math_fround(f10 - f11);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(f10 * f19);
 f18 = Math_fround(f10 * f18);
 f17 = Math_fround(f10 * f17);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(f19 + Math_fround(f10 * f9));
 f8 = Math_fround(f18 + Math_fround(f10 * f8));
 f7 = Math_fround(f17 + Math_fround(f10 * f7));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(f16 + Math_fround(Math_fround(f10 * f15) + f9));
 f8 = Math_fround(f14 + Math_fround(Math_fround(f10 * f13) + f8));
 f7 = Math_fround(f12 + Math_fround(Math_fround(f11 * f10) + f7));
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAP32[i5 + 12 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 16 >> 2] = i1;
 HEAPF32[i6 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 12 >> 2]));
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 16 >> 2]));
 i3 = __ZN5physx2Gu26intersectHeightFieldSphereERKNS0_15HeightFieldUtilERKNS0_6SphereE(i6, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EEw(i9, i6, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i9 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i4 = 23;
 } else do if (HEAP8[i1 >> 0] | 0) {
  i5 = i6 + 24 | 0;
  i4 = i6 + 28 | 0;
  while (1) {
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 9;
     break;
    }
   } else i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i1 = 2;
    i4 = 17;
    break;
   }
   if ((i1 | 0) == (i7 | 0)) {
    i1 = 0;
    i4 = 17;
    break;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 15;
     break;
    }
    if ((i1 | 0) == -1) {
     i1 = 0;
     i4 = 17;
     break;
    }
   } else {
    HEAP32[i5 >> 2] = i2 + 4;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) {
     i4 = 15;
     break;
    } else continue;
   } else {
    HEAP32[i2 >> 2] = i3 + 4;
    continue;
   }
  }
  if ((i4 | 0) == 9) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i4 = 16;
  } else if ((i4 | 0) == 15) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i4 = 16;
  }
  if ((i4 | 0) == 16) {
   ___cxa_begin_catch(i1 | 0) | 0;
   __THREW__ = 0;
   invoke_v(fb + 458 | 0);
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    i1 = 0;
    i4 = 17;
   }
  }
  if ((i4 | 0) == 17) {
   i7 = i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | ((HEAP32[i8 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) break;
  }
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i4 = 23;
  break L1;
 } while (0); while (0);
 do if ((i4 | 0) == 23) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx9NpFactory11createShapeERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKPNS_10PxMaterialEtb(i11, i5, i7, i3, i8, i6) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 34 | 0;
 i10 = i17;
 i16 = i17 + 8 | 0;
 i4 = i17 + 32 | 0;
 i15 = i16 + 8 | 0;
 i13 = i16 + 12 | 0;
 HEAP32[i16 + 16 >> 2] = 0;
 i14 = i16 + 20 | 0;
 HEAP8[i15 >> 0] = 1;
 HEAP32[i13 >> 2] = i16;
 HEAP32[i14 >> 2] = 4;
 i9 = i8 & 65535;
 HEAP16[i4 >> 1] = 0;
 __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE6resizeEjRKt(i16, i9, i4);
 if (i8 << 16 >> 16 == 1) HEAP16[HEAP32[i13 >> 2] >> 1] = HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2]; else {
  i1 = HEAP32[i13 >> 2] | 0;
  if (i8 << 16 >> 16) {
   i2 = 0;
   do {
    HEAP16[i1 + (i2 << 1) >> 1] = HEAP32[(HEAP32[i3 + (i2 << 2) >> 2] | 0) + 52 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i9 | 0));
  }
 }
 i4 = i11 + 1540 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = i11 + 1536 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i11 + 1244 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 i3 = i11 + 1524 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i11 + 1528 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!i2) i2 = 0; else {
  HEAP8[i12 >> 0] = HEAP8[i7 >> 0] | 0;
  __ZN5physx7NpShapeC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKttb(i2, i5, i12, i1, i8, i6);
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 if (!i2) i2 = 0; else {
  if (i8 << 16 >> 16) {
   i4 = i2 + 36 | 0;
   i5 = i2 + 48 | 0;
   i6 = i2 + 40 | 0;
   i7 = i2 + 32 | 0;
   i8 = 0;
   do {
    i3 = HEAP32[gb + 1457324 >> 2] | 0;
    if (!(HEAP32[i4 >> 2] & 2)) {
     i1 = HEAPU16[(__ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i5) | 0) + (i8 << 1) >> 1] | 0;
     i1 = (HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) | 0;
    } else {
     i1 = HEAP32[i6 >> 2] | 0;
     if ((HEAP16[i1 + 116 >> 1] | 0) == 1) i1 = i1 + 112 | 0; else i1 = (HEAP32[(HEAP32[i7 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
     i1 = (HEAP32[i3 + 52 >> 2] | 0) + (HEAPU16[i1 + (i8 << 1) >> 1] << 2) | 0;
    }
    __ZN5physx6shdfnd15atomicIncrementEPVi((HEAP32[i1 >> 2] | 0) + 16 | 0) | 0;
    i8 = i8 + 1 | 0;
   } while ((i8 | 0) != (i9 | 0));
  }
  HEAP32[i10 >> 2] = i2;
  i3 = i11 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb(i11 + 604 | 0, i10, i12) | 0;
  if (!(HEAP8[i12 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 }
 i14 = HEAP32[i14 >> 2] | 0;
 if (!((i14 | 0) > -1 & (i14 & 2147483647 | 0) != 0)) {
  STACKTOP = i17;
  return i2 | 0;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i16 | 0) == (i1 | 0)) {
  HEAP8[i15 >> 0] = 0;
  STACKTOP = i17;
  return i2 | 0;
 }
 if (!i1) {
  STACKTOP = i17;
  return i2 | 0;
 }
 i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i17;
 return i2 | 0;
}

function __ZNK5physx15PxsArticulation16computeResidualsEPKNS_2Cm13SpatialVectorEPKNS_30PxcArticulationJointTransformsEb(i4, i8, i7, i2) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, d11 = 0.0, d12 = 0.0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP16[i4 + 36 >> 1] | 0;
 if ((i2 & 65535) <= 1) {
  d12 = 0.0;
  d11 = 0.0;
  HEAPF64[i9 >> 3] = d12;
  i8 = i9 + 8 | 0;
  HEAPF64[i8 >> 3] = d11;
  _printf(gb + 773327 | 0, i9) | 0;
  STACKTOP = i10;
  return;
 }
 i6 = i2 & 65535;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 f1 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 i4 = 1;
 do {
  i22 = HEAP32[i5 + (i4 << 5) + 28 >> 2] | 0;
  f15 = Math_fround(HEAPF32[i2 + (i4 * 28 | 0) + 16 >> 2]);
  f26 = Math_fround(HEAPF32[i7 + (i4 * 84 | 0) + 44 >> 2]);
  f15 = Math_fround(f15 - f26);
  f23 = Math_fround(HEAPF32[i2 + (i4 * 28 | 0) + 20 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + (i4 * 84 | 0) + 48 >> 2]);
  f23 = Math_fround(f23 - f16);
  f24 = Math_fround(HEAPF32[i2 + (i4 * 28 | 0) + 24 >> 2]);
  f17 = Math_fround(HEAPF32[i7 + (i4 * 84 | 0) + 52 >> 2]);
  f24 = Math_fround(f24 - f17);
  f19 = Math_fround(HEAPF32[i8 + (i4 << 5) + 24 >> 2]);
  f25 = Math_fround(f23 * f19);
  f20 = Math_fround(HEAPF32[i8 + (i4 << 5) + 20 >> 2]);
  f25 = Math_fround(f25 - Math_fround(f24 * f20));
  f21 = Math_fround(HEAPF32[i8 + (i4 << 5) + 16 >> 2]);
  f24 = Math_fround(Math_fround(f24 * f21) - Math_fround(f15 * f19));
  f23 = Math_fround(Math_fround(f15 * f20) - Math_fround(f23 * f21));
  f25 = Math_fround(f25 + Math_fround(HEAPF32[i8 + (i4 << 5) >> 2]));
  f24 = Math_fround(Math_fround(HEAPF32[i8 + (i4 << 5) + 4 >> 2]) + f24);
  f23 = Math_fround(f23 + Math_fround(HEAPF32[i8 + (i4 << 5) + 8 >> 2]));
  f26 = Math_fround(Math_fround(HEAPF32[i2 + (i22 * 28 | 0) + 16 >> 2]) - f26);
  f16 = Math_fround(Math_fround(HEAPF32[i2 + (i22 * 28 | 0) + 20 >> 2]) - f16);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + (i22 * 28 | 0) + 24 >> 2]) - f17);
  f15 = Math_fround(HEAPF32[i8 + (i22 << 5) + 24 >> 2]);
  f18 = Math_fround(f16 * f15);
  f14 = Math_fround(HEAPF32[i8 + (i22 << 5) + 20 >> 2]);
  f18 = Math_fround(f18 - Math_fround(f17 * f14));
  f13 = Math_fround(HEAPF32[i8 + (i22 << 5) + 16 >> 2]);
  f17 = Math_fround(Math_fround(f17 * f13) - Math_fround(f26 * f15));
  f16 = Math_fround(Math_fround(f26 * f14) - Math_fround(f16 * f13));
  f18 = Math_fround(f18 + Math_fround(HEAPF32[i8 + (i22 << 5) >> 2]));
  f17 = Math_fround(Math_fround(HEAPF32[i8 + (i22 << 5) + 4 >> 2]) + f17);
  f18 = Math_fround(f25 - f18);
  f17 = Math_fround(f24 - f17);
  f16 = Math_fround(f23 - Math_fround(f16 + Math_fround(HEAPF32[i8 + (i22 << 5) + 8 >> 2])));
  f13 = Math_fround(f21 - f13);
  f14 = Math_fround(f20 - f14);
  f15 = Math_fround(f19 - f15);
  f3 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f16 * f16)));
  f1 = Math_fround(f1 + Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13))));
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i6 >>> 0);
 d11 = +f1;
 d12 = +f3;
 HEAPF64[i9 >> 3] = d11;
 i22 = i9 + 8 | 0;
 HEAPF64[i22 >> 3] = d12;
 _printf(gb + 773327 | 0, i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i1, i10, i2, i7, i5, i3, i4, i6) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i11 = i15 + 64 | 0;
 i14 = i15 + 88 | 0;
 i9 = i15 + 8 | 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i9 + 4 >> 2] = i2;
 i13 = i9 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i13 = i9 + 20 | 0;
 HEAP32[i13 >> 2] = i7;
 HEAP32[i9 + 24 >> 2] = i5;
 HEAP32[i9 + 28 >> 2] = i3;
 HEAP32[i9 + 32 >> 2] = i4;
 i12 = i9 + 36 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 + 40 >> 2] = i14;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 i5 = i6 + 12 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i2 = 1;
  i1 = 0;
 } else {
  i2 = i1 + -1 | 0;
  i3 = i10 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i4 + (i2 << 3) + 4 >> 0] | 0)) {
   i2 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, HEAP32[i4 + (i2 << 3) >> 2] | 0) | 0) & 1;
   HEAP8[i12 >> 0] = i2;
   i1 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP8[i7 + (i1 + -1 << 3) + 5 >> 0] = i2;
   HEAP8[i7 + (i1 + -1 << 3) + 4 >> 0] = i2;
  } else i2 = 1;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP8[i8 + 5 >> 0] = i2;
 if ((HEAP32[i10 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i10 + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_(i9, i11);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = i2 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP8[i12 >> 0] = 1;
  i14 = HEAP8[i14 >> 0] | 0;
  i14 = i14 << 24 >> 24 == 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = i2 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (HEAP8[i2 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i2 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i13 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i13 = i1 + -1 | 0;
 HEAP32[i5 >> 2] = i13;
 HEAP8[i12 >> 0] = 1;
 if (!i13) {
  i14 = HEAP8[i14 >> 0] | 0;
  i14 = i14 << 24 >> 24 == 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i4 >> 2] | 0) + (i1 + -2 << 3) + 5 >> 0] | 0) {
  i14 = HEAP8[i14 >> 0] | 0;
  i14 = i14 << 24 >> 24 == 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP8[i12 >> 0] = 0;
 i14 = HEAP8[i14 >> 0] | 0;
 i14 = i14 << 24 >> 24 == 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx17PxcNpMemBlockPool23releaseConstraintMemoryEv(i18) {
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 5 | 0;
 i15 = i20;
 i16 = i20 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i18 >> 2] | 0);
 HEAP32[i18 + 176 >> 2] = 0;
 HEAP32[i18 + 172 >> 2] = 0;
 i12 = i18 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i13 = i18 + 4 | 0;
  i14 = i18 + 168 | 0;
  i5 = i18 + 112 | 0;
  i6 = i18 + 120 | 0;
  i7 = i18 + 116 | 0;
  i8 = i18 + 152 | 0;
  i9 = i18 + 88 | 0;
  i10 = i18 + 96 | 0;
  i11 = i18 + 92 | 0;
  do {
   i2 = i1 + -1 | 0;
   i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i15 >> 2] = i1;
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   i4 = i1;
   do if (i3 >>> 0 > i1 >>> 0) i19 = 10; else if ((i3 + (HEAP32[i2 + 20 >> 2] | 0) | 0) >>> 0 > i1 >>> 0) {
    i1 = HEAP32[i11 >> 2] | 0;
    if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i4;
     HEAP32[i11 >> 2] = i1 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i15) | 0;
     break;
    }
   } else i19 = 10; while (0);
   if ((i19 | 0) == 10) {
    i19 = 0;
    i1 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i4;
     HEAP32[i7 >> 2] = i1 + 1;
    } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i15) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = i18 + 104 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i18 + 100 | 0;
  i3 = 0;
  do {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i18 + 92 >> 2] = 0;
 i9 = i18 + 160 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i19 = HEAP32[i18 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
  STACKTOP = i20;
  return;
 }
 i10 = HEAP32[i18 + 168 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 if (i1 >>> 0 > i4 >>> 0) i19 = 19; else if ((i1 + (HEAP32[i10 + 20 >> 2] | 0) | 0) >>> 0 > i4 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
  i6 = i10 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i5 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i4 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 } else i19 = 19;
 if ((i19 | 0) == 19) __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, i4);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i18 + 164 >> 2] = 0;
 i19 = HEAP32[i18 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i19);
 STACKTOP = i20;
 return;
}

function __ZN15AABBTreeOverlapIN5physx2Gu14SphereAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i1, i19, i21, i20, i22) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, i31 = 0, i32 = 0, i33 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i23 + 8 | 0;
 i18 = i23;
 i13 = HEAP32[i21 + 4 >> 2] | 0;
 HEAP32[i17 >> 2] = i13;
 i14 = i20 + 4 | 0;
 i15 = i20 + 8 | 0;
 i16 = i20 + 16 | 0;
 i1 = 1;
 while (1) {
  i1 = i1 + -1 | 0;
  i8 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f5 = Math_fround(Math_fround(i2 & 255 | 0) * f7);
  f6 = Math_fround(Math_fround(i3 & 255 | 0) * f7);
  f7 = Math_fround(Math_fround(i4 & 255 | 0) * f7);
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  f10 = Math_fround(HEAPF32[i14 >> 2]);
  f11 = Math_fround(HEAPF32[i15 >> 2]);
  f12 = Math_fround(HEAPF32[i16 >> 2]);
  while (1) {
   f30 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f28 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = Math_fround(f9 - f30);
   f28 = Math_fround(f10 - f28);
   f26 = Math_fround(f11 - (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   f29 = Math_fround(-f5);
   f27 = Math_fround(-f6);
   f25 = Math_fround(-f7);
   f5 = f30 < f5 ? f30 : f5;
   f6 = f28 < f6 ? f28 : f6;
   f7 = f26 < f7 ? f26 : f7;
   f5 = Math_fround(f30 - (f5 > f29 ? f5 : f29));
   f6 = Math_fround(f28 - (f6 > f27 ? f6 : f27));
   f7 = Math_fround(f26 - (f7 > f25 ? f7 : f25));
   if (!(f12 >= Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f7 * f7)))) break;
   i2 = i8 + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!((i3 & 1 | 0) == 0 & 0 == 0)) {
    i24 = 5;
    break;
   }
   i2 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   i2 = i2 & 524287;
   i8 = i13 + (i2 * 24 | 0) | 0;
   HEAP32[i17 + (i1 << 2) >> 2] = i13 + ((i2 + 1 | 0) * 24 | 0);
   i33 = HEAP32[i8 >> 2] | 0;
   i32 = HEAP32[i13 + (i2 * 24 | 0) + 4 >> 2] | 0;
   i31 = HEAP32[i13 + (i2 * 24 | 0) + 8 >> 2] | 0;
   f7 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i13 + (i2 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   i2 = i33;
   i3 = i32;
   i4 = i31;
   f5 = Math_fround(Math_fround(i33 & 255 | 0) * f7);
   f6 = Math_fround(Math_fround(i32 & 255 | 0) * f7);
   f7 = Math_fround(Math_fround(i31 & 255 | 0) * f7);
   i1 = i1 + 1 | 0;
  }
  if ((i24 | 0) == 5) {
   i24 = 0;
   i32 = HEAP32[i21 >> 2] | 0;
   i33 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   if (!(mftCall_iiiii(HEAP32[HEAP32[i22 >> 2] >> 2] | 0, i22 | 0, i18 | 0, i19 + (HEAP32[i32 + ((i33 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
    i1 = 0;
    i24 = 8;
    break;
   }
  }
  if (!i1) {
   i1 = 1;
   i24 = 8;
   break;
  }
 }
 if ((i24 | 0) == 8) {
  STACKTOP = i23;
  return i1 | 0;
 }
 return 0;
}

function __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 56 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i6 + 116 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function _UNITY_tt_face_build_cmaps(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i23 + 64 | 0;
 i13 = i23 + 60 | 0;
 i14 = i23 + 48 | 0;
 i15 = i23 + 44 | 0;
 i19 = i23 + 40 | 0;
 i7 = i23 + 36 | 0;
 i6 = i23 + 32 | 0;
 i20 = i23 + 8 | 0;
 i21 = i23 + 4 | 0;
 i22 = i23;
 i10 = HEAP32[i8 + 500 >> 2] | 0;
 i11 = i8 + 504 | 0;
 i12 = i10 + (HEAP32[i11 >> 2] | 0) | 0;
 HEAP32[i13 >> 2] = i10;
 i1 = HEAP32[(HEAP32[i8 + 96 >> 2] | 0) + 4 >> 2] | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  i22 = 8;
  STACKTOP = i23;
  return i22 | 0;
 }
 if (((HEAP32[i13 >> 2] | 0) + 4 | 0) >>> 0 > i12 >>> 0) {
  i22 = 8;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 2;
 if (HEAPU8[(HEAP32[i13 >> 2] | 0) + -1 >> 0] | 0 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -2 >> 0] | 0) << 8 | 0) {
  i22 = 8;
  STACKTOP = i23;
  return i22 | 0;
 }
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 2;
 HEAP32[i9 >> 2] = HEAPU8[(HEAP32[i13 >> 2] | 0) + -1 >> 0] | 0 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -2 >> 0] | 0) << 8;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i22 = 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i16 = i14 + 8 | 0;
 i17 = i14 + 10 | 0;
 i18 = i14 + 4 | 0;
 i1 = i1 + 212 | 0;
 i2 = i8 + 264 | 0;
 i3 = i20 + 20 | 0;
 i4 = i20 + 16 | 0;
 while (1) {
  if (((HEAP32[i13 >> 2] | 0) + 8 | 0) >>> 0 > i12 >>> 0) {
   i1 = 0;
   i2 = 19;
   break;
  }
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 2;
  HEAP16[i16 >> 1] = HEAPU8[(HEAP32[i13 >> 2] | 0) + -1 >> 0] | 0 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -2 >> 0] | 0) << 8;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 2;
  HEAP16[i17 >> 1] = HEAPU8[(HEAP32[i13 >> 2] | 0) + -1 >> 0] | 0 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -2 >> 0] | 0) << 8;
  HEAP32[i14 >> 2] = i8;
  HEAP32[i18 >> 2] = 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
  i5 = (HEAPU8[(HEAP32[i13 >> 2] | 0) + -3 >> 0] | 0) << 16 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -4 >> 0] | 0) << 24 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -2 >> 0] | 0) << 8 | (HEAPU8[(HEAP32[i13 >> 2] | 0) + -1 >> 0] | 0);
  if (i5 | 0) if (i5 >>> 0 <= ((HEAP32[i11 >> 2] | 0) + -2 | 0) >>> 0) {
   HEAP32[i15 >> 2] = i10 + i5;
   HEAP32[i19 >> 2] = HEAPU8[(HEAP32[i15 >> 2] | 0) + 1 >> 0] | 0 | (HEAPU8[HEAP32[i15 >> 2] >> 0] | 0) << 8;
   HEAP32[i7 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2];
   L19 : do if (HEAP32[HEAP32[i7 >> 2] >> 2] | 0) {
    while (1) {
     HEAP32[i6 >> 2] = HEAP32[HEAP32[i7 >> 2] >> 2];
     if ((HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0) == (HEAP32[i19 >> 2] | 0)) break;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
     if (!(HEAP32[HEAP32[i7 >> 2] >> 2] | 0)) break L19;
    }
    HEAP32[i21 >> 2] = 0;
    _UNITY_ft_validator_init(i20, HEAP32[i15 >> 2] | 0, i12, 0);
    HEAP32[i3 >> 2] = HEAPU16[i2 >> 1];
    HEAP32[i21 >> 2] = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, HEAP32[i15 >> 2] | 0, i20 | 0) | 0;
    if (!(HEAP32[i4 >> 2] | 0)) if (!(_UNITY_FT_CMap_New(HEAP32[i6 >> 2] | 0, HEAP32[i15 >> 2] | 0, i14, i22) | 0)) HEAP32[(HEAP32[i22 >> 2] | 0) + 20 >> 2] = HEAP32[i21 >> 2];
   } while (0);
  }
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   i1 = 0;
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) {
  STACKTOP = i23;
  return i1 | 0;
 }
 return 0;
}

function __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim6bitsetILj66EEEEEvRT_PKc17TransferMetaFlags(i5, i4 + 8 | 0, gb + 904124 | 0, 0);
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i5 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i10 = i1;
  i2 = i2 | 0 ? i2 - i10 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i10;
 } else i3 = i5 + 4 | 0;
 i2 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 >> 2] = i2 + 4;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i10;
  HEAP32[i7 >> 2] = i1;
  i1 = i10;
 }
 HEAP8[i4 + 36 >> 0] = i1;
 i1 = i4 + 37 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i10 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i10;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx7NpCloth17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i2 + 192 | 0;
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i9 >> 2] = HEAP32[gb + 124004 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 124004 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 124004 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 124004 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 124004 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 124004 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 124004 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 124004 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i9 | 0, 32) | 0;
 HEAP32[i8 >> 2] = gb + 754771;
 HEAP32[i8 + 4 >> 2] = gb + 827530;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 152;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 1;
 HEAP32[i8 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 754771;
 HEAP32[i7 + 4 >> 2] = gb + 747076;
 HEAP32[i7 + 8 >> 2] = 12;
 HEAP32[i7 + 12 >> 2] = 152;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 124036 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 124036 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 124036 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 124036 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 124036 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 124036 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 124036 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 124036 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 124068 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 124068 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 124068 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 124068 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 124068 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 124068 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 124068 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 124068 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124100 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124100 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124100 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124100 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124100 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124100 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124100 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124100 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN17PersistentManager22CheckInstanceIDsLoadedEPii(i9, i15, i16) {
 i9 = i9 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19;
 i17 = i19 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i18 = i17 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 i13 = i9 + 120 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i1 = (HEAP32[i9 + 176 >> 2] | 0) - i2 | 0;
 i12 = i17 + 8 | 0;
 if (!i1) {
  i3 = 0;
  i4 = 0;
 } else {
  i4 = __Znwj(i1 << 2) | 0;
  i11 = i4;
  i3 = i4 + (i1 << 2) | 0;
  HEAP32[i17 >> 2] = i11;
  HEAP32[i18 >> 2] = i11;
  HEAP32[i12 >> 2] = i3;
 }
 i1 = HEAP32[i9 + 168 >> 2] | 0;
 i8 = HEAP32[i9 + 172 >> 2] | 0;
 i11 = i1 + (i8 * 20 | 0) | 0;
 L4 : do if (!i8) i10 = 9; else {
  i6 = HEAP32[i9 + 148 >> 2] | 0;
  i7 = i9 + 124 | 0;
  i8 = i9 + 128 | 0;
  i5 = (i2 | 0) == 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i6 | 0) != (i2 | 0)) {
    if ((HEAP8[i7 >> 0] | 0) == 0 | i5) {
     i10 = 9;
     break L4;
    }
    if ((HEAP32[i8 >> 2] | 0) != (i2 | 0)) {
     i10 = 9;
     break L4;
    }
   }
   i1 = i1 + 20 | 0;
   if ((i1 | 0) == (i11 | 0)) {
    i2 = i4;
    i1 = i4;
    break;
   }
  }
 } while (0);
 if ((i10 | 0) == 9) if ((i1 | 0) == (i11 | 0)) {
  i2 = i4;
  i1 = i4;
 } else {
  i6 = i9 + 148 | 0;
  i7 = i9 + 124 | 0;
  i5 = i9 + 128 | 0;
  L15 : while (1) {
   i2 = i1 + 4 | 0;
   if ((i4 | 0) == (i3 | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i17, i2); else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i18 >> 2] = i4 + 4;
   }
   i1 = i1 + 20 | 0;
   if ((i1 | 0) == (i11 | 0)) break;
   i3 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) != (i2 | 0)) {
     if (!(HEAP8[i7 >> 0] | 0)) break;
     if (!(HEAP32[i13 >> 2] | 0)) break;
     if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) break;
    }
    i1 = i1 + 20 | 0;
    if ((i1 | 0) == (i11 | 0)) break L15;
   }
   if ((i1 | 0) == (i11 | 0)) break;
   i4 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
  }
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i18 >> 2] | 0;
 }
 __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_(i2, i1, i14);
 L33 : do if ((i16 | 0) > 0) {
  i11 = HEAP32[i17 >> 2] | 0;
  i5 = HEAP32[i18 >> 2] | 0;
  i4 = i5 - i11 >> 2;
  if (!i4) {
   i2 = (i11 | 0) == (i5 | 0);
   i1 = 0;
   while (1) {
    i3 = i15 + (i1 << 2) | 0;
    if (!i2) if ((HEAP32[i3 >> 2] | 0) >= (HEAP32[i11 >> 2] | 0)) HEAP32[i3 >> 2] = 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i16 | 0)) break L33;
   }
  } else i2 = 0;
  do {
   i6 = i15 + (i2 << 2) | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i1 = i4;
   i3 = i11;
   i8 = i11;
   while (1) {
    i14 = (i1 | 0) / 2 | 0;
    i10 = i8 + (i14 << 2) | 0;
    i9 = (HEAP32[i10 >> 2] | 0) < (i7 | 0);
    i10 = i10 + 4 | 0;
    i3 = i9 ? i10 : i3;
    i1 = i9 ? i1 + -1 - i14 | 0 : i14;
    if (!i1) break; else i8 = i9 ? i10 : i8;
   }
   if ((i3 | 0) != (i5 | 0)) if ((i7 | 0) >= (HEAP32[i3 >> 2] | 0)) HEAP32[i6 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i16 | 0));
 } while (0);
 __ZN6Object22CheckInstanceIDsLoadedEPii(i15, i16);
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i2 = HEAP32[i18 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i18 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i19;
 return;
}

function __ZN6Camera17MainThreadCleanupEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i10 = i11 + 16 | 0;
 __ZN19RenderEventsContext23RemoveAllCommandBuffersEv(i9 + 1136 | 0);
 i4 = i9 + 744 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 9;
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) break;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 17;
   }
  }
  if ((i5 | 0) == 15) i5 = 17;
  if ((i5 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  __ZN13RenderTexture7ReleaseEv(i1);
 } while (0);
 __ZN6Camera21CleanupAfterRenderingEPK11CullResults(i9, 0);
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i10 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i8);
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 __ZN15LODGroupManager26CollectAllLODGroupManagersEPK6CameraR13dynamic_arrayIPS_Lj4EEb(i9, i10, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) {
    __ZN15LODGroupManager20DestroyCameraLODDataEPK6Camera(i2, i9);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN12TreeDatabase17RefreshPrototypesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i11 = i15;
 i12 = i8 + 28 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i8 + 32 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  HEAP32[i13 >> 2] = i1 + -156;
  i2 = i1 + -40 | 0;
  if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -36 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -60 | 0;
  if ((HEAP32[i1 + -44 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -56 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -80 | 0;
  if ((HEAP32[i1 + -64 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -76 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -100 | 0;
  if ((HEAP32[i1 + -84 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -96 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = HEAP32[i13 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 i6 = i8 + 4 | 0;
 __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE6resizeEj(i12, (HEAP32[i8 + 8 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 3);
 if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) {
  i14 = HEAP32[i8 >> 2] | 0;
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i14, 8);
  STACKTOP = i15;
  return;
 }
 i7 = i8 + 40 | 0;
 i5 = 0;
 do {
  i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) >> 2] | 0;
  HEAP32[i11 >> 2] = i4;
  do if (!i4) i14 = 23; else {
   HEAP32[i10 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 20; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 20; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i14 = 22;
   }
   if ((i14 | 0) == 20) i14 = 22;
   if ((i14 | 0) == 22) {
    i14 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
     i14 = 23;
     break;
    }
   }
   f17 = Math_fround(HEAPF32[(HEAP32[i6 >> 2] | 0) + (i5 << 3) + 4 >> 2]);
   __ZN12TreeDatabase9Prototype3SetERK4PPtrI10GameObjectEfb((HEAP32[i12 >> 2] | 0) + (i5 * 156 | 0) | 0, i11, f17, (HEAP8[i7 >> 0] | 0) != 0);
  } while (0);
  if ((i14 | 0) == 23) {
   i14 = 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 933316 | 0, 0, gb + 933103 | 0, 289, 1, i1, 0, 0);
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (((HEAP32[i13 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0) / 156 | 0) >>> 0);
 i16 = HEAP32[i8 >> 2] | 0;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i16, 8);
 STACKTOP = i15;
 return;
}

function __Z45AssetBundleManifest_CUSTOM_GetAllDependenciesP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 48 | 0;
 i3 = i12 + 44 | 0;
 i11 = i12 + 32 | 0;
 i6 = i12 + 16 | 0;
 i7 = i12;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 HEAP32[i11 >> 2] = 0;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK11ICallString6ToUTF8Ev(i7, i3);
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 7;
 } else if (i4 >>> 0 < 11) {
  i1 = i6 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i6; else {
   i2 = i6;
   i8 = 9;
  }
 } else i8 = 7;
 if ((i8 | 0) == 7) {
  i13 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = i13 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i4;
  i1 = i6 + 11 | 0;
  i8 = 9;
 }
 if ((i8 | 0) == 9) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN19AssetBundleManifest22CollectAllDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE(i5, i6, i11);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i13 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i9 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i8 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i8 + 11 >> 0] | 0;
   i13 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i13 ? HEAP32[i8 >> 2] | 0 : i8, i13 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i12;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i10 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i9 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i13 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
    i2 = HEAP32[i9 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i12;
 return i5 | 0;
}

function __ZN15SerializeTraitsI11ChannelInfoE8TransferI14SafeBinaryReadEEvRS0_RT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 430659 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i3 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 1 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 744923 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 752357 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i4 + 3 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 430666 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function _UNITY_png_write_bKGD(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i7 = i8;
 if ((i1 | 0) == 3) {
  i3 = HEAP16[i5 + 416 >> 1] | 0;
  if (!(i3 << 16 >> 16)) if (!(HEAP32[i5 + 596 >> 2] & 1)) i4 = 5; else i1 = HEAP8[i2 >> 0] | 0; else i4 = 5;
  if ((i4 | 0) == 5) {
   i1 = HEAP8[i2 >> 0] | 0;
   if ((i1 & 255) >>> 0 >= (i3 & 65535) >>> 0) {
    STACKTOP = i8;
    return;
   }
  }
  HEAP8[i7 >> 0] = i1;
  i4 = i5 + 656 | 0;
  HEAP32[i4 >> 2] = 34;
  HEAP8[i6 >> 0] = 0;
  HEAP8[i6 + 1 >> 0] = 0;
  HEAP8[i6 + 2 >> 0] = 0;
  HEAP8[i6 + 3 >> 0] = 1;
  i3 = i6 + 4 | 0;
  HEAP8[i3 >> 0] = 98;
  HEAP8[i6 + 5 >> 0] = 75;
  HEAP8[i6 + 6 >> 0] = 71;
  HEAP8[i6 + 7 >> 0] = 68;
  _UNITY_png_write_data(i5, i6, 8);
  HEAP32[i5 + 372 >> 2] = 1649100612;
  _UNITY_png_reset_crc(i5);
  _UNITY_png_calculate_crc(i5, i3, 4);
  HEAP32[i4 >> 2] = 66;
  _UNITY_png_write_data(i5, i7, 1);
  _UNITY_png_calculate_crc(i5, i7, 1);
  HEAP32[i4 >> 2] = 130;
  i7 = HEAP32[i5 + 408 >> 2] | 0;
  HEAP8[i6 >> 0] = i7 >>> 24;
  HEAP8[i6 + 1 >> 0] = i7 >>> 16;
  HEAP8[i6 + 2 >> 0] = i7 >>> 8;
  HEAP8[i6 + 3 >> 0] = i7;
  _UNITY_png_write_data(i5, i6, 4);
  STACKTOP = i8;
  return;
 }
 if (!(i1 & 2)) {
  i1 = HEAP16[i2 + 8 >> 1] | 0;
  if ((i1 & 65535 | 0) >= (1 << (HEAPU8[i5 + 432 >> 0] | 0) | 0)) {
   STACKTOP = i8;
   return;
  }
  HEAP8[i7 >> 0] = (i1 & 65535) >>> 8;
  HEAP8[i7 + 1 >> 0] = i1;
  i4 = i5 + 656 | 0;
  HEAP32[i4 >> 2] = 34;
  HEAP8[i6 >> 0] = 0;
  HEAP8[i6 + 1 >> 0] = 0;
  HEAP8[i6 + 2 >> 0] = 0;
  HEAP8[i6 + 3 >> 0] = 2;
  i3 = i6 + 4 | 0;
  HEAP8[i3 >> 0] = 98;
  HEAP8[i6 + 5 >> 0] = 75;
  HEAP8[i6 + 6 >> 0] = 71;
  HEAP8[i6 + 7 >> 0] = 68;
  _UNITY_png_write_data(i5, i6, 8);
  HEAP32[i5 + 372 >> 2] = 1649100612;
  _UNITY_png_reset_crc(i5);
  _UNITY_png_calculate_crc(i5, i3, 4);
  HEAP32[i4 >> 2] = 66;
  _UNITY_png_write_data(i5, i7, 2);
  _UNITY_png_calculate_crc(i5, i7, 2);
  HEAP32[i4 >> 2] = 130;
  i7 = HEAP32[i5 + 408 >> 2] | 0;
  HEAP8[i6 >> 0] = i7 >>> 24;
  HEAP8[i6 + 1 >> 0] = i7 >>> 16;
  HEAP8[i6 + 2 >> 0] = i7 >>> 8;
  HEAP8[i6 + 3 >> 0] = i7;
  _UNITY_png_write_data(i5, i6, 4);
  STACKTOP = i8;
  return;
 } else {
  i4 = HEAP16[i2 + 2 >> 1] | 0;
  i3 = (i4 & 65535) >>> 8;
  HEAP8[i7 >> 0] = i3;
  HEAP8[i7 + 1 >> 0] = i4;
  i4 = HEAP16[i2 + 4 >> 1] | 0;
  i1 = (i4 & 65535) >>> 8;
  HEAP8[i7 + 2 >> 0] = i1;
  HEAP8[i7 + 3 >> 0] = i4;
  i2 = HEAP16[i2 + 6 >> 1] | 0;
  i4 = (i2 & 65535) >>> 8;
  HEAP8[i7 + 4 >> 0] = i4;
  HEAP8[i7 + 5 >> 0] = i2;
  if ((i5 | 0) == 0 ? 1 : (i1 | i3 | i4) << 16 >> 16 != 0) {
   STACKTOP = i8;
   return;
  }
  i4 = i5 + 656 | 0;
  HEAP32[i4 >> 2] = 34;
  HEAP8[i6 >> 0] = 0;
  HEAP8[i6 + 1 >> 0] = 0;
  HEAP8[i6 + 2 >> 0] = 0;
  HEAP8[i6 + 3 >> 0] = 6;
  i3 = i6 + 4 | 0;
  HEAP8[i3 >> 0] = 98;
  HEAP8[i6 + 5 >> 0] = 75;
  HEAP8[i6 + 6 >> 0] = 71;
  HEAP8[i6 + 7 >> 0] = 68;
  _UNITY_png_write_data(i5, i6, 8);
  HEAP32[i5 + 372 >> 2] = 1649100612;
  _UNITY_png_reset_crc(i5);
  _UNITY_png_calculate_crc(i5, i3, 4);
  HEAP32[i4 >> 2] = 66;
  _UNITY_png_write_data(i5, i7, 6);
  _UNITY_png_calculate_crc(i5, i7, 6);
  HEAP32[i4 >> 2] = 130;
  i7 = HEAP32[i5 + 408 >> 2] | 0;
  HEAP8[i6 >> 0] = i7 >>> 24;
  HEAP8[i6 + 1 >> 0] = i7 >>> 16;
  HEAP8[i6 + 2 >> 0] = i7 >>> 8;
  HEAP8[i6 + 3 >> 0] = i7;
  _UNITY_png_write_data(i5, i6, 4);
  STACKTOP = i8;
  return;
 }
}

function __ZN20TextRenderingPrivate17TextMeshGenerator24GetCursorIndexAtPositionERK5RectTIfERK8Vector2f(i9, i1, i3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 8 | 0;
 i5 = i15;
 i14 = (HEAP32[i9 + 100 >> 2] | 0) + -1 | 0;
 __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i4, i9, i1);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i4 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i4 + 4 >> 2]));
 i12 = HEAP32[i9 + 88 >> 2] | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 if (!i7) i1 = 0; else {
  HEAP32[i5 >> 2] = i7;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i3 = HEAP32[i4 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 9;
   }
  }
  if ((i10 | 0) == 7) i10 = 9;
  if ((i10 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
 }
 i3 = HEAP32[i9 + 52 >> 2] | 0;
 if (!i3) i10 = 13; else {
  i4 = HEAP32[i1 + 36 >> 2] | 0;
  if (!i4) i10 = 13; else f2 = Math_fround(Math_fround(Math_fround(((i3 | 0) > 500 ? 500 : i3) | 0) * Math_fround(HEAPF32[i1 + 32 >> 2])) / Math_fround(i4 | 0));
 }
 if ((i10 | 0) == 13) f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 if (HEAP8[i9 + 28 >> 0] | 0) f2 = Math_fround(Math_floor(Math_fround(f2 + Math_fround(.5))));
 L25 : do if ((i14 | 0) < 0) i1 = i14; else {
  f8 = Math_fround(f11 - f2);
  i3 = 0;
  i1 = i14;
  while (1) {
   while (1) {
    i5 = i3 + i1 >> 1;
    f2 = Math_fround(HEAPF32[i12 + (i5 << 3) + 4 >> 2]);
    if (!(f2 <= f8)) {
     if (f2 > f11) {
      i10 = 26;
      break;
     }
     f6 = Math_fround(HEAPF32[i12 + (i5 << 3) >> 2]);
     i4 = i5 + 1 | 0;
     i10 = (i5 | 0) != (i14 | 0) ? i4 : i14;
     f16 = Math_fround(HEAPF32[i12 + (i10 << 3) >> 2]);
     i10 = Math_fround(HEAPF32[i12 + (i10 << 3) + 4 >> 2]) == f2;
     if (Math_fround(Math_fround(f6 + (i10 ? f16 : Math_fround(1.0e4))) * Math_fround(.5)) < f13) i3 = i4; else {
      i10 = 24;
      break;
     }
    } else i3 = i5 + 1 | 0;
    if ((i5 | 0) >= (i1 | 0)) break L25;
   }
   if ((i10 | 0) == 24) {
    i1 = i5 + -1 | 0;
    i10 = i5 | 0 ? i1 : 0;
    f16 = Math_fround(HEAPF32[i12 + (i10 << 3) >> 2]);
    i10 = Math_fround(HEAPF32[i12 + (i10 << 3) + 4 >> 2]) == f2;
    if (!(Math_fround(Math_fround(f6 + (i10 ? f16 : Math_fround(-1.0e4))) * Math_fround(.5)) > f13)) {
     i1 = i5;
     break;
    }
   } else if ((i10 | 0) == 26) i1 = i5 + -1 | 0;
   if ((i3 | 0) >= (i5 | 0)) break L25;
  }
  STACKTOP = i15;
  return i1 | 0;
 } while (0);
 i14 = (i1 | 0) < 0 ? 0 : i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN12TreeInstance8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932479 | 0, HEAP32[gb + 37324 >> 2] | 0, i1, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i1, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932488 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932499 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932511 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 24 | 0;
 i7 = HEAP32[gb + 36980 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 945665 | 0, i7, i5, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i6, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932520 | 0, i7, i5, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, i6, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944884 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function _jpeg_gen_optimal_table(i9, i11, i7) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 2096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 2056 | 0;
 i12 = i13 + 1028 | 0;
 i8 = i13;
 i2 = i10;
 i3 = i2 + 33 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 _memset(i12 | 0, 0, 1028) | 0;
 _memset(i8 | 0, -1, 1028) | 0;
 HEAP32[i7 + 1024 >> 2] = 1;
 L1 : while (1) {
  i1 = 1e9;
  i5 = -1;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
   i4 = (i3 | 0) == 0 | (i3 | 0) > (i1 | 0);
   i5 = i4 ? i5 : i2;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 257) {
    i6 = -1;
    i1 = 1e9;
    i2 = 0;
    break;
   } else i1 = i4 ? i1 : i3;
  }
  while (1) {
   i3 = HEAP32[i7 + (i2 << 2) >> 2] | 0;
   i4 = (i2 | 0) == (i5 | 0) | ((i3 | 0) == 0 | (i3 | 0) > (i1 | 0));
   i6 = i4 ? i6 : i2;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 257) break; else i1 = i4 ? i1 : i3;
  }
  if ((i6 | 0) < 0) break;
  i1 = i7 + (i6 << 2) | 0;
  i2 = i7 + (i5 << 2) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i12 + (i5 << 2) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i8 + (i5 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) > -1) do {
   i1 = i12 + (i2 << 2) | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = i8 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) > -1);
  HEAP32[i1 >> 2] = i6;
  i1 = i12 + (i6 << 2) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
  if ((i1 | 0) <= -1) continue;
  while (1) {
   i6 = i12 + (i1 << 2) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i1 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   if ((i1 | 0) <= -1) continue L1;
  }
 }
 i1 = 0;
 do {
  i2 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 32) {
    i8 = HEAP32[i9 >> 2] | 0;
    HEAP32[i8 + 20 >> 2] = 39;
    mftCall_vi(HEAP32[i8 >> 2] | 0, i9 | 0);
   }
   i8 = i10 + i2 | 0;
   HEAP8[i8 >> 0] = (HEAP8[i8 >> 0] | 0) + 1 << 24 >> 24;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 257);
 i1 = 32;
 do {
  i6 = i10 + i1 | 0;
  i2 = HEAP8[i6 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i1 = i1 + -1 | 0; else {
   i7 = i1 + -2 | 0;
   i1 = i1 + -1 | 0;
   i5 = i10 + i1 | 0;
   do {
    i3 = i7;
    while (1) {
     i4 = i10 + i3 | 0;
     if (!(HEAP8[i4 >> 0] | 0)) i3 = i3 + -1 | 0; else break;
    }
    HEAP8[i6 >> 0] = (i2 & 255) + 254;
    HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) + 1 << 24 >> 24;
    i9 = i10 + (i3 + 1) | 0;
    HEAP8[i9 >> 0] = (HEAPU8[i9 >> 0] | 0) + 2;
    HEAP8[i4 >> 0] = (HEAP8[i4 >> 0] | 0) + -1 << 24 >> 24;
    i2 = HEAP8[i6 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
  }
 } while ((i1 | 0) > 16);
 i1 = 16;
 while (1) {
  i2 = i10 + i1 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  if (!(i3 << 24 >> 24)) i1 = i1 + -1 | 0; else break;
 }
 HEAP8[i2 >> 0] = i3 + -1 << 24 >> 24;
 i2 = i11;
 i1 = i10;
 i3 = i2 + 17 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = 0;
 i3 = 1;
 do {
  i2 = 0;
  do {
   if ((HEAP32[i12 + (i2 << 2) >> 2] | 0) == (i3 | 0)) {
    HEAP8[i11 + 17 + i1 >> 0] = i2;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 256);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 33);
 HEAP8[i11 + 273 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN19SkinnedMeshRenderer8SkinMeshEP12SkinMeshInfobR9GfxDeviceP22GeometryJobInstructionRi(i6, i9, i7, i8, i1, i2) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 4 | 0;
 i4 = i10;
 i3 = i6 + 348 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i11 = __Z12GetGfxDevicev() | 0;
  i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 256 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  mftCall_vii(i12 | 0, i11 | 0, i5 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 if (!(HEAP8[i9 + 93 >> 0] | 0)) {
  __ZN17UniqueIDGenerator8CreateIDEv(i5, i8 + 4448 | 0);
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i12 + 1;
  i8 = HEAP32[(HEAP32[i6 + 468 >> 2] | 0) + 8 >> 2] | 0;
  i11 = HEAP32[i8 + 24 >> 2] | 0;
  HEAP32[i1 + (i12 << 5) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + (i12 << 5) + 4 >> 2] = i9;
  HEAP32[i1 + (i12 << 5) + 8 >> 2] = i8;
  HEAP32[i1 + (i12 << 5) + 12 >> 2] = 0;
  HEAP32[i1 + (i12 << 5) + 16 >> 2] = i11;
  HEAP32[i1 + (i12 << 5) + 20 >> 2] = 0;
  HEAP32[i1 + (i12 << 5) + 24 >> 2] = 0;
  HEAP32[i1 + (i12 << 5) + 28 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 i3 = i9 + 84 | 0;
 if (HEAP32[i3 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i3);
 i12 = __Z12GetGfxDevicev() | 0;
 i1 = i6 + 508 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 308 >> 2] | 0, i12 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 + 68 >> 2] | 0, HEAP32[i9 + 28 >> 2] | 0);
 if ((HEAP16[gb + 1161592 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161592 | 0, i5);
  i2 = gb + 1161592 | 0;
 } else i2 = 0;
 i12 = HEAP32[gb + 1161592 >> 2] | 0;
 i11 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 648 >> 2] | 0, i11 | 0, i12 | 0);
 i12 = HEAP32[i6 + 356 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i12 + 32 >> 2] | 0) + 40 >> 2] | 0;
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i12, i5, i11, 0, 0) | 0;
 i12 = i9 + 60 | 0;
 mftCall_viiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 312 >> 2] | 0, i8 | 0, i5 + 8 | 0, HEAP32[i9 + 96 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[(HEAP32[i6 + 468 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 + 20 >> 2] | 0, i11 | 0, i7 | 0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (HEAP8[i8 + 3896 >> 0] | 0) {
  i12 = i8 + 3644 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  i12 = i8 + 3648 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i1;
  i12 = i8 + 3656 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i1;
  i12 = i8 + 3652 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i1;
  i12 = i8 + 3640 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 }
 __Z15gpu_time_samplev();
 if (HEAP32[i3 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i3);
 i1 = HEAP32[i9 + 100 >> 2] | 0;
 if (i1 | 0) {
  i12 = i1 + 4 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  if (!(HEAP32[i12 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64024 | 0);
 i12 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 652 >> 2] | 0, i12 | 0);
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return;
}

function __ZN16BaseVideoTexture8YuvToRgbEPK8YuvFrame(i1, i22) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i1 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i14, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0) | 0;
 i14 = i22 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 if (!i5) return;
 i15 = i22 + 16 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i16 = 0 - i1 | 0;
 i17 = i22 + 20 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 i21 = HEAP32[i22 + 32 >> 2] | 0;
 i18 = Math_imul(i21, i7) | 0;
 i20 = HEAP32[i22 + 28 >> 2] | 0;
 i18 = i18 + i20 | 0;
 i19 = i22 + 24 | 0;
 i4 = HEAP32[i19 >> 2] | 0;
 i20 = (Math_imul(i4, (i21 | 0) / 2 | 0) | 0) + ((i20 | 0) / 2 | 0) | 0;
 i21 = HEAP32[i22 + 36 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i11 = i2 + (Math_imul(i3 + -1 | 0, i1) | 0) | 0;
 i12 = i22 + 8 | 0;
 i13 = i22 + 12 | 0;
 i1 = 0;
 i2 = i3;
 i3 = HEAP32[i13 >> 2] | 0;
 while (1) {
  i10 = i11 + i16 | 0;
  i6 = (HEAP32[i22 >> 2] | 0) + i18 | 0;
  i4 = (Math_imul(i4, i1) | 0) >> 1;
  if ((i3 | 0) > 0) {
   i9 = i6 + (Math_imul(i7, i1) | 0) | 0;
   i8 = i6 + (Math_imul(i7, i1 | 1) | 0) | 0;
   i7 = i5 + i20 + i4 | 0;
   i4 = (HEAP32[i12 >> 2] | 0) + i20 + i4 | 0;
   i5 = 0;
   i6 = i10;
   i2 = i11;
   while (1) {
    i27 = HEAP32[gb + 1464132 + ((HEAPU8[i9 >> 0] | 0) << 2) >> 2] | 0;
    i26 = HEAP32[gb + 1464132 + ((HEAPU8[i9 + 1 >> 0] | 0) << 2) >> 2] | 0;
    i25 = HEAP32[gb + 1464132 + ((HEAPU8[i8 >> 0] | 0) << 2) >> 2] | 0;
    i3 = HEAP32[gb + 1464132 + ((HEAPU8[i8 + 1 >> 0] | 0) << 2) >> 2] | 0;
    i23 = HEAPU8[i4 >> 0] | 0;
    i11 = HEAPU8[i7 >> 0] | 0;
    i24 = HEAP32[gb + 1460036 + (i23 << 2) >> 2] | 0;
    i23 = (HEAP32[gb + 1462084 + (i11 << 2) >> 2] | 0) + (HEAP32[gb + 1461060 + (i23 << 2) >> 2] | 0) | 0;
    i11 = HEAP32[gb + 1463108 + (i11 << 2) >> 2] | 0;
    HEAP8[i2 + 1 >> 0] = HEAP8[i24 + i27 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i2 + 2 >> 0] = HEAP8[i27 - i23 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i2 + 3 >> 0] = HEAP8[i11 + i27 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i2 + 5 >> 0] = HEAP8[i24 + i26 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i2 + 6 >> 0] = HEAP8[i26 - i23 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i2 + 7 >> 0] = HEAP8[i11 + i26 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 1 >> 0] = HEAP8[i24 + i25 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 2 >> 0] = HEAP8[i25 - i23 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 3 >> 0] = HEAP8[i11 + i25 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 5 >> 0] = HEAP8[i24 + i3 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 6 >> 0] = HEAP8[i3 - i23 + (gb + 1552713 + 384) >> 0] | 0;
    HEAP8[i6 + 7 >> 0] = HEAP8[i11 + i3 + (gb + 1552713 + 384) >> 0] | 0;
    i5 = i5 + 2 | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else {
     i9 = i9 + 2 | 0;
     i8 = i8 + 2 | 0;
     i7 = i7 + i21 | 0;
     i4 = i4 + i21 | 0;
     i6 = i6 + 8 | 0;
     i2 = i2 + 8 | 0;
    }
   }
   i2 = HEAP32[i15 >> 2] | 0;
  }
  i1 = i1 + 2 | 0;
  if ((i1 | 0) >= (i2 | 0)) break;
  i11 = i10 + i16 | 0;
  i4 = HEAP32[i19 >> 2] | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i7 = HEAP32[i17 >> 2] | 0;
 }
 return;
}

function _gray_cubic_to(i2, i3, i1, i20) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] << 2;
 HEAP32[i20 + 68 >> 2] = i4;
 i1 = i17 << 2;
 HEAP32[i20 + 72 >> 2] = i1;
 HEAP32[i20 + 76 >> 2] = HEAP32[i3 >> 2] << 2;
 i17 = HEAP32[i3 + 4 >> 2] << 2;
 HEAP32[i20 + 80 >> 2] = i17;
 HEAP32[i20 + 84 >> 2] = HEAP32[i2 >> 2] << 2;
 i18 = HEAP32[i2 + 4 >> 2] << 2;
 HEAP32[i20 + 88 >> 2] = i18;
 HEAP32[i20 + 92 >> 2] = HEAP32[i20 + 60 >> 2];
 i3 = HEAP32[i20 + 64 >> 2] | 0;
 HEAP32[i20 + 96 >> 2] = i3;
 i19 = (i17 | 0) < (i1 | 0) ? i17 : i1;
 i2 = (i17 | 0) > (i1 | 0) ? i17 : i1;
 i19 = (i18 | 0) < (i19 | 0) ? i18 : i19;
 i2 = (i18 | 0) > (i2 | 0) ? i18 : i2;
 if ((((i3 | 0) < (i19 | 0) ? i3 : i19) >> 8 | 0) < (HEAP32[i20 + 24 >> 2] | 0)) if ((((i3 | 0) > (i2 | 0) ? i3 : i2) >> 8 | 0) < (HEAP32[i20 + 20 >> 2] | 0)) {
  i3 = 0;
  i2 = i4;
  i21 = 12;
 } else i3 = 0; else {
  i3 = 0;
  i2 = i4;
  i21 = 12;
 }
 while (1) {
  if ((i21 | 0) == 12) {
   i21 = 0;
   _gray_render_line(i20, i2, i1);
   if (!i3) break;
   i3 = i3 + -3 | 0;
  }
  i16 = i20 + 68 + (i3 << 3) | 0;
  i15 = i3 + 3 | 0;
  i17 = HEAP32[i20 + 68 + (i15 << 3) >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
  i12 = i17 - i2 | 0;
  i18 = i16 + 28 | 0;
  i19 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i20 + 68 + (i3 << 3) + 4 >> 2] | 0;
  i13 = i19 - i1 | 0;
  i4 = (i12 | 0) < 0 ? 0 - i12 | 0 : i12;
  i5 = (i13 | 0) < 0 ? 0 - i13 | 0 : i13;
  if ((i4 | 0) > (i5 | 0)) i4 = (i5 * 3 >> 3) + i4 | 0; else i4 = i5 + (i4 * 3 >> 3) | 0;
  if ((i4 | 0) > 32767) {
   i4 = i16 + 8 | 0;
   i3 = i16 + 12 | 0;
   i6 = i4;
   i5 = i3;
   i4 = HEAP32[i4 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
  } else {
   i7 = i4 * 42 | 0;
   i6 = i16 + 8 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i8 = i4 - i2 | 0;
   i5 = i16 + 12 | 0;
   i14 = HEAP32[i5 >> 2] | 0;
   i9 = i14 - i1 | 0;
   i11 = (Math_imul(i8, i13) | 0) - (Math_imul(i9, i12) | 0) | 0;
   if ((((i11 | 0) < 0 ? 0 - i11 | 0 : i11) | 0) > (i7 | 0)) i3 = i14; else {
    i10 = (HEAP32[i16 + 16 >> 2] | 0) - i2 | 0;
    i11 = (HEAP32[i16 + 20 >> 2] | 0) - i1 | 0;
    i22 = (Math_imul(i10, i13) | 0) - (Math_imul(i11, i12) | 0) | 0;
    if ((((i22 | 0) < 0 ? 0 - i22 | 0 : i22) | 0) > (i7 | 0)) i3 = i14; else if (((Math_imul(i9 - i13 | 0, i9) | 0) + (Math_imul(i8 - i12 | 0, i8) | 0) | 0) > 0 ? 1 : ((Math_imul(i11 - i13 | 0, i11) | 0) + (Math_imul(i10 - i12 | 0, i10) | 0) | 0) > 0) i3 = i14; else {
     i21 = 12;
     continue;
    }
   }
  }
  HEAP32[i16 + 48 >> 2] = i17;
  i13 = i16 + 16 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i14 = (i4 + i2 | 0) / 2 | 0;
  HEAP32[i6 >> 2] = i14;
  i22 = (i12 + i17 | 0) / 2 | 0;
  HEAP32[i16 + 40 >> 2] = i22;
  i17 = (i12 + i4 | 0) / 2 | 0;
  i14 = (i17 + i14 | 0) / 2 | 0;
  HEAP32[i13 >> 2] = i14;
  i17 = (i22 + i17 | 0) / 2 | 0;
  HEAP32[i16 + 32 >> 2] = i17;
  HEAP32[i16 + 24 >> 2] = (i14 + i17 | 0) / 2 | 0;
  HEAP32[i16 + 52 >> 2] = i19;
  i17 = i16 + 20 | 0;
  i14 = HEAP32[i17 >> 2] | 0;
  i22 = (i3 + i1 | 0) / 2 | 0;
  HEAP32[i5 >> 2] = i22;
  i19 = (i14 + i19 | 0) / 2 | 0;
  HEAP32[i16 + 44 >> 2] = i19;
  i3 = (i14 + i3 | 0) / 2 | 0;
  i22 = (i3 + i22 | 0) / 2 | 0;
  HEAP32[i17 >> 2] = i22;
  i3 = (i19 + i3 | 0) / 2 | 0;
  HEAP32[i16 + 36 >> 2] = i3;
  HEAP32[i18 >> 2] = (i22 + i3 | 0) / 2 | 0;
  i3 = i15;
 }
 return 0;
}

function __ZN5physx20addConstraintDynamicERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_PKNS_11PxsBodyCoreERNS_25PxsFluidConstraintDynamicES9_(i4, i1, i2, i23, i20, i21, i22) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var f3 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, f24 = f0, f25 = f0, f26 = f0;
 i18 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = HEAP32[i1 + 8 >> 2] | 0;
 f10 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 + Math_fround(f16 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f3 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 8 >> 2])));
 i8 = i4 + 62 | 0;
 i9 = HEAPU16[i8 >> 1] | 0;
 if (!(i9 & 1)) {
  i22 = HEAP32[i4 + 140 >> 2] | 0;
  HEAP32[i22 >> 2] = i18;
  HEAP32[i22 + 4 >> 2] = i19;
  HEAP32[i22 + 8 >> 2] = i17;
  HEAPF32[i22 + 12 >> 2] = f7;
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = i20;
  HEAP16[i8 >> 1] = i9 | 5;
  return;
 }
 if (!(i9 & 2)) {
  i21 = HEAP32[i4 + 156 >> 2] | 0;
  HEAP32[i21 >> 2] = i18;
  HEAP32[i21 + 4 >> 2] = i19;
  HEAP32[i21 + 8 >> 2] = i17;
  HEAPF32[i21 + 12 >> 2] = f7;
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = i20;
  HEAP16[i8 >> 1] = i9 | 10;
  return;
 }
 i11 = HEAP32[i4 + 140 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i11 >> 2]);
 f26 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f15 = Math_fround(f15 * f26);
 i12 = i11 + 4 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f25 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f6 = Math_fround(f15 + Math_fround(f6 * f25));
 i13 = i11 + 8 | 0;
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 f15 = Math_fround(f6 + Math_fround(f15 * f24));
 i14 = i11 + 12 | 0;
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i14 >> 2]));
 i1 = HEAP32[i4 + 156 >> 2] | 0;
 f6 = Math_fround(f26 * Math_fround(HEAPF32[i1 >> 2]));
 i2 = i1 + 4 | 0;
 f6 = Math_fround(f6 + Math_fround(f25 * Math_fround(HEAPF32[i2 >> 2])));
 i4 = i1 + 8 | 0;
 f6 = Math_fround(f6 + Math_fround(f24 * Math_fround(HEAPF32[i4 >> 2])));
 i5 = i1 + 12 | 0;
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f10 * f26) + Math_fround(f16 * f25)) + Math_fround(f3 * f24)) - f7);
 if (f15 < f6) {
  if (!(f3 < f6)) return;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i2 >> 2] = i19;
  HEAP32[i4 >> 2] = i17;
  HEAPF32[i5 >> 2] = f7;
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i22 + 12 >> 2] = i20;
  HEAP16[i8 >> 1] = i9 | 8;
  return;
 } else {
  if (!(f3 < f15)) return;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i12 >> 2] = i19;
  HEAP32[i13 >> 2] = i17;
  HEAPF32[i14 >> 2] = f7;
  HEAP32[i21 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i21 + 12 >> 2] = i20;
  HEAP16[i8 >> 1] = i9 | 4;
  return;
 }
}

function __ZN27AnimatorControllerParameter7SetTypeE31AnimatorControllerParameterType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 i3 = i1 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i2;
 i6 = i1 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 10;
 }
 if ((i7 | 0) == 8) i7 = 10;
 if ((i7 | 0) == 10) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 18;
  }
 }
 if ((i7 | 0) == 16) i7 = 18;
 if ((i7 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1);
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 24; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 24; else if (HEAP32[i1 + 4 >> 2] | 0) {
   STACKTOP = i8;
   return;
  }
 }
 __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i3 = i8;
 i4 = i7 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i5 + 4;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i2;
 i2 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 901442 | 0, i2, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i7, i3, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i5 + 12;
 HEAP32[i3 + 4 >> 2] = i5 + 8;
 HEAP32[i3 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 901476 | 0, i2, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i7, i3, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 901491 | 0, gb + 905830 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i4 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
    i3 = i1;
    i4 = i3 + 48 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    i4 = i2;
    i1 = i1 | 0 ? i1 - i4 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i4;
   }
   i3 = i1 + i2 | 0;
   i1 = i3;
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041891 | 0, gb + 913944 | 0, i6, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim10ValueArray8TransferI14SafeBinaryReadEEvRT_(i1, i7); else {
     i1 = HEAP32[i6 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i7);
   }
  } else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7mecanim12statemachine22StateMachineEvaluationEEvRT_RT0_PKc17TransferMetaFlags(i7, i5 + 20 | 0, gb + 901500 | 0, 0);
 i3 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 901512 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i3 = i6 + 32 | 0;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 44 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 48 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 52 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 56 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 60 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i6 + 64 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 68 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 84 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i10) {
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 8 | 0;
 i5 = i11;
 i7 = i10 + 360 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 do if (i3 | 0) {
  HEAP32[i5 >> 2] = i3;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i9 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[i3 + 32 >> 2] | 0;
    i3 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i3, i5);
    i4 = HEAP32[i4 >> 2] | 0;
    i12 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i3 = (i4 | 0) == -1 ? i12 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i12 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i9 = 7; else if (!(HEAP32[i3 + 4 >> 2] | 0)) i9 = 9;
  }
  if ((i9 | 0) == 7) i9 = 9;
  if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
  f2 = Math_fround(HEAPF32[i10 + 76 >> 2]);
  f1 = Math_fround(HEAPF32[i10 + 112 >> 2]);
  f6 = Math_fround(HEAPF32[i10 + 148 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 364 >> 2]);
  f2 = Math_fround(f2 * f8);
  f1 = Math_fround(f1 * f8);
  f6 = Math_fround(f6 * f8);
  do if (!(__Z19GetActiveColorSpacev() | 0)) {
   do if (!(f2 <= Math_fround(0.0))) {
    if (f2 <= Math_fround(.00313080009)) {
     f2 = Math_fround(f2 * Math_fround(12.9200001));
     break;
    }
    if (f2 < Math_fround(1.0)) {
     f2 = Math_fround(Math_fround(Math_fround(+Math_pow(+f2, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f2 == Math_fround(1.0)) f2 = Math_fround(1.0); else f2 = Math_fround(+Math_pow(+f2, .454545468));
   } else f2 = Math_fround(0.0); while (0);
   do if (!(f1 <= Math_fround(0.0))) {
    if (f1 <= Math_fround(.00313080009)) {
     f1 = Math_fround(f1 * Math_fround(12.9200001));
     break;
    }
    if (f1 < Math_fround(1.0)) {
     f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
   } else f1 = Math_fround(0.0); while (0);
   if (!(f6 <= Math_fround(0.0))) {
    if (f6 <= Math_fround(.00313080009)) {
     f6 = Math_fround(f6 * Math_fround(12.9200001));
     break;
    }
    if (f6 < Math_fround(1.0)) {
     f6 = Math_fround(Math_fround(Math_fround(+Math_pow(+f6, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f6 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f6, .454545468));
   } else f6 = Math_fround(0.0);
  } while (0);
  HEAPF32[i10 + 392 >> 2] = f2;
  HEAPF32[i10 + 396 >> 2] = f1;
  HEAPF32[i10 + 400 >> 2] = f6;
  HEAPF32[i10 + 404 >> 2] = f8;
  STACKTOP = i11;
  return;
 } while (0);
 HEAPF32[i10 + 392 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 396 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 404 >> 2] = Math_fround(1.0);
 STACKTOP = i11;
 return;
}

function __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i14, i15, i16, i17) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = HEAP8[i15 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i4 = i1 ? HEAP32[i15 + 4 >> 2] | 0 : i4 & 255;
 if (!i4) {
  i17 = 32;
  return i17 | 0;
 }
 i2 = i1 ? HEAP32[i15 >> 2] | 0 : i15;
 i1 = 0;
 L4 : while (1) {
  i3 = HEAP8[i2 + i1 >> 0] | 0;
  if (i3 << 24 >> 24 < 32 | i3 << 24 >> 24 == 127) {
   i9 = 32;
   i6 = 24;
   break;
  }
  switch (i3 << 24 >> 24) {
  case 9:
  case 32:
   {
    i9 = 32;
    i6 = 24;
    break L4;
   }
  default:
   {}
  }
  i1 = i1 + 1 | 0;
  if (_memchr(gb + 1026921 | 0, i3 << 24 >> 24, 18) | 0) {
   i9 = 32;
   i6 = 24;
   break;
  }
  if (i1 >>> 0 >= i4 >>> 0) {
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) {
  i4 = HEAP8[i16 + 11 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  i4 = i5 ? HEAP32[i16 + 4 >> 2] | 0 : i4 & 255;
  i5 = i5 ? HEAP32[i16 >> 2] | 0 : i16;
  do if (!i4) i8 = 0; else {
   i2 = 0;
   i3 = 0;
   L13 : while (1) {
    i1 = HEAP8[i5 + i3 >> 0] | 0;
    L15 : do switch (i1 << 24 >> 24) {
    case 92:
     {
      i10 = i2;
      i12 = i2 ? 4 : 1;
      i13 = i3 + (i2 & 1) | 0;
      i6 = 18;
      break;
     }
    case 34:
     {
      i11 = i2 ^ 1;
      i7 = i3;
      break;
     }
    default:
     {
      if (i2) {
       if (i1 << 24 >> 24 != 13) i6 = 17;
      } else switch (i1 << 24 >> 24) {
      case 41:
       {
        i9 = 33;
        i6 = 24;
        break L13;
       }
      case 40:
       {
        i10 = 0;
        i12 = 1;
        i13 = i3;
        i6 = 18;
        break L15;
       }
      case 13:
       break;
      default:
       i6 = 17;
      }
      if ((i6 | 0) == 17) {
       i10 = i2;
       i12 = (i1 << 24 >> 24 < 32 | i1 << 24 >> 24 == 127) & 1;
       i13 = i3;
       i6 = 18;
       break L15;
      }
      i1 = i3 + 2 | 0;
      if (i1 >>> 0 >= i4 >>> 0) {
       i9 = 33;
       i6 = 24;
       break L13;
      }
      if ((HEAP8[i5 + (i3 + 1) >> 0] | 0) != 10) {
       i9 = 33;
       i6 = 24;
       break L13;
      }
      switch (HEAP8[i5 + i1 >> 0] | 0) {
      case 9:
      case 32:
       {
        i11 = i2;
        i7 = i1;
        break;
       }
      default:
       {
        i9 = 33;
        i6 = 24;
        break L13;
       }
      }
     }
    } while (0);
    if ((i6 | 0) == 18) {
     i6 = 0;
     switch (i12 & 7) {
     case 4:
     case 0:
      {
       i11 = i10;
       i7 = i13;
       break;
      }
     default:
      {
       i9 = 33;
       i6 = 24;
       break L13;
      }
     }
    }
    i3 = i7 + 1 | 0;
    if (i3 >>> 0 >= i4 >>> 0) {
     i6 = 20;
     break;
    } else i2 = i11;
   }
   if ((i6 | 0) == 20) {
    if (i11) i9 = 33; else {
     i8 = 0;
     break;
    }
    return i9 | 0;
   } else if ((i6 | 0) == 24) return i9 | 0;
  } while (0);
  do {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i15, HEAP32[gb + 188128 + (i8 << 2) >> 2] | 0) | 0)) {
    i9 = 34;
    i6 = 24;
    break;
   }
   i8 = i8 + 1 | 0;
  } while (i8 >>> 0 < 19);
  if ((i6 | 0) == 24) return i9 | 0;
  __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i14, i15, i16, i17) | 0;
  i17 = 0;
  return i17 | 0;
 } else if ((i6 | 0) == 24) return i9 | 0;
 return 0;
}

function _UNITY_png_write_pCAL(i15, i3, i10, i11, i12, i16, i13, i17) {
 i15 = i15 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 96 | 0;
 i14 = i19 + 80 | 0;
 i9 = i19;
 if ((i12 | 0) > 3) _UNITY_png_error(i15, gb + 355554 | 0);
 if (!i3) {
  HEAP8[i9 >> 0] = 0;
  _UNITY_png_error(i15, gb + 355596 | 0);
 }
 i4 = HEAP8[i3 >> 0] | 0;
 L8 : do if (!(i4 << 24 >> 24)) {
  i3 = 1;
  i2 = 0;
  i1 = i9;
 } else {
  i5 = 1;
  i2 = 0;
  i1 = i9;
  while (1) {
   L11 : do if (!i5) {
    i8 = (i4 & 255) > 160 | (i4 + -33 & 255) < 94;
    i5 = i8 & 1 ^ 1;
    i3 = i3 + 1 | 0;
    i4 = i8 ? i4 : 32;
   } else while (1) {
    i3 = i3 + 1 | 0;
    if ((i4 & 255) > 160 | (i4 + -33 & 255) < 94) {
     i5 = 0;
     break L11;
    }
    i4 = HEAP8[i3 >> 0] | 0;
    if (!(i4 << 24 >> 24)) {
     i3 = i5;
     break L8;
    }
   } while (0);
   HEAP8[i1 >> 0] = i4;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   if (!(i2 >>> 0 < 79 & i4 << 24 >> 24 != 0)) {
    i3 = i5;
    break;
   }
  }
 } while (0);
 i8 = (i2 | 0) != 0 & (i3 | 0) != 0;
 i2 = (i8 << 31 >> 31) + i2 | 0;
 HEAP8[(i8 ? i1 + -1 | 0 : i1) >> 0] = 0;
 if (!i2) _UNITY_png_error(i15, gb + 355596 | 0);
 i5 = i2 + 1 | 0;
 i7 = (_strlen(i13) | 0) + ((i16 | 0) != 0 & 1) | 0;
 i1 = i2 + 11 + i7 | 0;
 i8 = _UNITY_png_malloc(i15, i16 << 2) | 0;
 i6 = (i16 | 0) > 0;
 if (i6) {
  i3 = i16 + -1 | 0;
  i2 = 0;
  do {
   i4 = (_strlen(HEAP32[i17 + (i2 << 2) >> 2] | 0) | 0) + ((i2 | 0) != (i3 | 0) & 1) | 0;
   HEAP32[i8 + (i2 << 2) >> 2] = i4;
   i1 = i4 + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i16 | 0));
 }
 i4 = (i15 | 0) == 0;
 if (i4) i1 = 0; else {
  i3 = i15 + 656 | 0;
  HEAP32[i3 >> 2] = 34;
  HEAP8[i18 >> 0] = i1 >>> 24;
  HEAP8[i18 + 1 >> 0] = i1 >>> 16;
  HEAP8[i18 + 2 >> 0] = i1 >>> 8;
  HEAP8[i18 + 3 >> 0] = i1;
  i2 = i18 + 4 | 0;
  HEAP8[i2 >> 0] = 112;
  HEAP8[i18 + 5 >> 0] = 67;
  HEAP8[i18 + 6 >> 0] = 65;
  HEAP8[i18 + 7 >> 0] = 76;
  _UNITY_png_write_data(i15, i18, 8);
  HEAP32[i15 + 372 >> 2] = 1883455820;
  _UNITY_png_reset_crc(i15);
  _UNITY_png_calculate_crc(i15, i2, 4);
  HEAP32[i3 >> 2] = 66;
  if (!i5) i1 = 1; else {
   _UNITY_png_write_data(i15, i9, i5);
   _UNITY_png_calculate_crc(i15, i9, i5);
   i1 = 1;
  }
 }
 _UNITY_png_save_int_32(i14, i10);
 _UNITY_png_save_int_32(i14 + 4 | 0, i11);
 HEAP8[i14 + 8 >> 0] = i12;
 HEAP8[i14 + 9 >> 0] = i16;
 if (i1) {
  _UNITY_png_write_data(i15, i14, 10);
  _UNITY_png_calculate_crc(i15, i14, 10);
  if ((i7 | 0) != 0 & (i13 | 0) != 0) {
   _UNITY_png_write_data(i15, i13, i7);
   _UNITY_png_calculate_crc(i15, i13, i7);
  }
 }
 if (i6 & i1) {
  i1 = 0;
  do {
   i2 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) != 0 & (i3 | 0) != 0) {
    _UNITY_png_write_data(i15, i2, i3);
    _UNITY_png_calculate_crc(i15, i2, i3);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i16 | 0));
 }
 _UNITY_png_free(i15, i8);
 if (i4) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i15 + 656 >> 2] = 130;
 i17 = HEAP32[i15 + 408 >> 2] | 0;
 HEAP8[i18 >> 0] = i17 >>> 24;
 HEAP8[i18 + 1 >> 0] = i17 >>> 16;
 HEAP8[i18 + 2 >> 0] = i17 >>> 8;
 HEAP8[i18 + 3 >> 0] = i17;
 _UNITY_png_write_data(i15, i18, 4);
 STACKTOP = i19;
 return;
}

function _UNITY_FT_GlyphLoader_CheckPoints(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i9 = HEAP32[i12 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 i13 = i12 + 22 | 0;
 i1 = (HEAP16[i13 >> 1] | 0) + i1 + (HEAP16[i12 + 58 >> 1] | 0) | 0;
 i11 = i12 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 do if (i1 >>> 0 > i4 >>> 0) {
  i1 = i1 + 7 & -8;
  if (i1 >>> 0 > 32767) {
   i14 = 10;
   STACKTOP = i15;
   return i14 | 0;
  }
  i7 = i12 + 24 | 0;
  HEAP32[i7 >> 2] = _UNITY_ft_mem_realloc(i9, 8, i4, i1, HEAP32[i7 >> 2] | 0, i14) | 0;
  if (!(HEAP32[i14 >> 2] | 0)) {
   i7 = i12 + 28 | 0;
   HEAP32[i7 >> 2] = _UNITY_ft_mem_realloc(i9, 1, i4, i1, HEAP32[i7 >> 2] | 0, i14) | 0;
   if (!(HEAP32[i14 >> 2] | 0)) {
    if (HEAP8[i12 + 16 >> 0] | 0) {
     i2 = i12 + 40 | 0;
     i3 = _UNITY_ft_mem_realloc(i9, 8, i4 << 1, i1 << 1, HEAP32[i2 >> 2] | 0, i14) | 0;
     HEAP32[i2 >> 2] = i3;
     if (HEAP32[i14 >> 2] | 0) break;
     _memmove(i3 + (i1 << 3) | 0, i3 + (i4 << 3) | 0, i4 << 3 | 0) | 0;
     HEAP32[i12 + 44 >> 2] = (HEAP32[i2 >> 2] | 0) + (i1 << 3);
    }
    HEAP32[i11 >> 2] = i1;
    i4 = 1;
    i10 = 9;
   }
  }
 } else {
  i4 = 0;
  i10 = 9;
 } while (0);
 do if ((i10 | 0) == 9) {
  i6 = i12 + 8 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i7 = i12 + 20 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (i2 << 16 >> 16) + i8 + (HEAP16[i12 + 56 >> 1] | 0) | 0;
  i3 = i2 >>> 16 & 65535;
  if (i1 >>> 0 > i5 >>> 0) {
   i2 = i1 + 3 & -4;
   if (i2 >>> 0 > 32767) {
    i14 = 10;
    STACKTOP = i15;
    return i14 | 0;
   }
   i10 = i12 + 32 | 0;
   i1 = _UNITY_ft_mem_realloc(i9, 2, i5, i2, HEAP32[i10 >> 2] | 0, i14) | 0;
   HEAP32[i10 >> 2] = i1;
   if (HEAP32[i14 >> 2] | 0) break;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP16[i13 >> 1] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i10 = 15;
  } else if (i4 << 24 >> 24) {
   i1 = HEAP32[i12 + 32 >> 2] | 0;
   i10 = 15;
  }
  if ((i10 | 0) == 15) {
   i10 = i3 << 16 >> 16;
   HEAP32[i12 + 60 >> 2] = (HEAP32[i12 + 24 >> 2] | 0) + (i10 << 3);
   HEAP32[i12 + 64 >> 2] = (HEAP32[i12 + 28 >> 2] | 0) + i10;
   HEAP32[i12 + 68 >> 2] = i1 + (i2 << 16 >> 16 << 1);
   if (HEAP8[i12 + 16 >> 0] | 0) {
    i10 = i2 >> 16;
    HEAP32[i12 + 76 >> 2] = (HEAP32[i12 + 40 >> 2] | 0) + (i10 << 3);
    HEAP32[i12 + 80 >> 2] = (HEAP32[i12 + 44 >> 2] | 0) + (i10 << 3);
   }
  }
  if (!(HEAP32[i14 >> 2] | 0)) {
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
 } while (0);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i12 + 24 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i12 + 28 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i12 + 32 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i12 + 40 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i12 + 52 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i12 + 44 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i2 = i12 + 20 | 0;
 HEAP16[i13 >> 1] = 0;
 HEAP16[i2 >> 1] = 0;
 HEAP32[i12 + 48 >> 2] = 0;
 i1 = i12 + 56 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i14 = HEAP32[i14 >> 2] | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZNSt3__218__insertion_sort_3IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i4 + 24 | 0;
 i2 = i4 + 12 | 0;
 i9 = mftCall_iii(HEAP32[i6 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 i3 = mftCall_iii(HEAP32[i6 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 do if (i9) {
  if (i3) {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if (mftCall_iii(HEAP32[i6 >> 2] | 0, i1 | 0, i2 | 0) | 0) {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
 } else if (i3) {
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  if (mftCall_iii(HEAP32[i6 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
 } while (0);
 i2 = i4 + 36 | 0;
 if ((i2 | 0) == (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 while (1) {
  if (mftCall_iii(HEAP32[i6 >> 2] | 0, i2 | 0, i1 | 0) | 0) {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i3 = i2;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    if ((i1 | 0) == (i4 | 0)) break;
    i3 = i1 + -12 | 0;
    if (mftCall_iii(HEAP32[i6 >> 2] | 0, i7 | 0, i3 | 0) | 0) {
     i9 = i1;
     i1 = i3;
     i3 = i9;
    } else break;
   }
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
  i1 = i2 + 12 | 0;
  if ((i1 | 0) == (i5 | 0)) break; else {
   i9 = i2;
   i2 = i1;
   i1 = i9;
  }
 }
 STACKTOP = i8;
 return;
}

function __ZN5physx9NpPhysicsD2Ev(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 HEAP32[i11 >> 2] = gb + 93400 + 8;
 i10 = i11 + 4 | 0;
 i1 = i11 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 | 0) {
  i6 = 0;
  do {
   i4 = i3 + (i6 << 2) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
   HEAP32[i4 >> 2] = 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i2 | 0));
 }
 HEAP32[i1 >> 2] = 0;
 __ZN5physx17NpMaterialManager16releaseMaterialsEv(i11 + 36 | 0);
 i1 = i11 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i11 + 124 >> 2] = 0;
 i1 = HEAP32[i11 + 72 >> 2] | 0;
 i8 = i11 + 68 | 0;
 i7 = i11 + 104 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i5 = 0;
  do {
   i3 = HEAP32[i1 + (i5 << 3) + 4 >> 2] | 0;
   if (i3 | 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i4);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i3);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i2 | 0));
 }
 i1 = HEAP32[i11 + 88 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i7 >> 2] | 0) {
  _memset(HEAP32[i11 + 80 >> 2] | 0, -1, i1 << 2 | 0) | 0;
  i6 = i11 + 84 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + -1 | 0;
  i4 = i11 + 76 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = i3 + 1 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 << 2) >> 2] = i2;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
   }
   i2 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
  HEAP32[i11 + 96 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 }
 i2 = i11 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i11 + 116 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i1);
 i1 = i11 + 64 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 }
 i9 = HEAP32[i11 + 48 >> 2] | 0;
 if ((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i11 + 40 >> 2] | 0;
  if (i1 | 0) {
   i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
  }
 }
 __ZN5physx2Sc7PhysicsD2Ev(i11 + 20 | 0);
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 if (!((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i13, i1, i3, i4, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i1 = i12;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i13, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = 426;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? i1 : i10;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = i13; else {
  i8 = i13 + 36 | 0;
  i9 = i13 + 20 | 0;
  i7 = i13 + 24 | 0;
  i6 = i3 + 8 | 0;
  i5 = i4;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i13, i1);
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = 0;
   if (HEAP8[i8 >> 0] | 0) {
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
    i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i11 | 0) | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    if (!((i2 | 0) == 0 | i3 ^ 1)) if (HEAP8[i2 >> 0] | 0) {
     L14 : do if (!(gb + 759891 | 0)) i1 = 0; else {
      i3 = gb + 759891 | 0;
      i1 = 0;
      while (1) {
       if (!(_strcasecmp(i3, i2) | 0)) break;
       i1 = i1 + 1 | 0;
       i3 = HEAP32[gb + 115792 + (i1 << 3) >> 2] | 0;
       if (!i3) {
        i1 = 0;
        break L14;
       }
      }
      i1 = HEAP32[gb + 115792 + (i1 << 3) + 4 >> 2] | 0;
     } while (0);
     mftCall_viii(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0);
    }
   }
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i8 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i8 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i8 >> 0] = 0;
   }
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i5 = i5 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) {
    i5 = i13;
    break;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i13 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i13 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i13 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0, f26 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23;
 i20 = i23 + 8 | 0;
 i16 = i22 + 32 | 0;
 i12 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i16 >> 2] | 0) | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i22 + 36 >> 2] | 0;
 i18 = HEAP8[(HEAP32[i16 + 8 >> 2] | 0) + 50 >> 0] | 0;
 i10 = HEAP8[(HEAP32[i17 + 8 >> 2] | 0) + 50 >> 0] | 0;
 i1 = HEAP32[i22 + 44 >> 2] | 0;
 i15 = i1 & 262144;
 i9 = i15 >>> 18;
 i11 = i1 >>> 10 & 1 ^ 1;
 i13 = i1 >>> 11 & 1 ^ 1;
 i14 = (i1 & 131584 | 0) != 0 & 1;
 i15 = (i15 | 0) == 0 & (i1 & 448 | 0) != 0 & 1;
 if (!(i1 & 98304)) i21 = 0; else i21 = (i1 >>> 14 & 2) + -1 | 0;
 i4 = i1 >>> 1 & 1;
 i5 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(i16) | 0;
 i6 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(i17) | 0;
 i7 = (i5 | 0) != 0;
 if (i7) i1 = HEAP8[(HEAP32[i5 + 52 >> 2] | 0) + 12 >> 0] | 0; else i1 = 0;
 i8 = (i6 | 0) != 0;
 if (i8) i2 = HEAP8[(HEAP32[i6 + 52 >> 2] | 0) + 12 >> 0] | 0; else i2 = 0;
 __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh(i19, i12, i1, i2);
 i3 = i12 + 1204 | 0;
 i1 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0) + 7612 | 0;
 __ZN5physx2Sc8ShapeSim20createTransformCacheERNS_17PxsTransformCacheE(i16, i1);
 __ZN5physx2Sc8ShapeSim20createTransformCacheERNS_17PxsTransformCacheE(i17, i1);
 i1 = i20;
 i2 = i1 + 84 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i25 = i20 + 4 | 0;
 HEAPF32[i25 >> 2] = Math_fround(1.0);
 i24 = i20 + 8 | 0;
 HEAPF32[i24 >> 2] = Math_fround(1.0);
 i2 = i16 + 28 | 0;
 f26 = Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + 128 >> 2]);
 i1 = i17 + 28 | 0;
 HEAPF32[i20 + 48 >> 2] = Math_fround(f26 + Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + 128 >> 2]));
 HEAP32[i20 + 12 >> 2] = i7 ? i5 + 64 | 0 : 0;
 HEAP32[i20 + 16 >> 2] = i8 ? i6 + 64 | 0 : 0;
 HEAP32[i20 + 36 >> 2] = i14;
 HEAP32[i20 + 40 >> 2] = i15;
 HEAP32[i20 + 44 >> 2] = i4;
 HEAP32[i20 + 52 >> 2] = i9;
 HEAP32[i20 + 56 >> 2] = i11;
 HEAP32[i20 + 60 >> 2] = i13;
 HEAP32[i25 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i24 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i20 + 20 >> 2] = (HEAP32[i2 >> 2] | 0) + 32;
 HEAP32[i20 + 24 >> 2] = (HEAP32[i1 >> 2] | 0) + 32;
 HEAP32[i20 + 64 >> 2] = (i10 << 24 >> 24 == 4 & 1) << 1 | i18 << 24 >> 24 == 4;
 HEAP32[i20 + 68 >> 2] = (i10 << 24 >> 24 != 0 & 1) << 1 | i18 << 24 >> 24 != 0;
 HEAP32[i20 + 72 >> 2] = i21;
 HEAP32[i20 + 28 >> 2] = __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv(i16) | 0;
 HEAP32[i20 + 32 >> 2] = __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv(i17) | 0;
 HEAP32[i20 + 76 >> 2] = HEAP32[i16 + 24 >> 2];
 HEAP32[i20 + 80 >> 2] = HEAP32[i17 + 24 >> 2];
 HEAP32[i20 >> 2] = i22;
 i21 = __ZN5physx10PxsContext20createContactManagerERKNS_24PxvManagerDescRigidRigidEPNS_18PxsMaterialManagerE(HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0, i20, i12) | 0;
 i1 = i22 + 56 | 0;
 HEAP32[i1 >> 2] = i21;
 if (!i21) {
  STACKTOP = i23;
  return;
 }
 i25 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx16PxsIslandManager14setEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_17PxsContactManagerE(i25, i22 + 60 | 0, HEAP32[i1 >> 2] | 0);
 STACKTOP = i23;
 return;
}

function __ZN18GlslGpuProgramGLESC2E20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i4, i1, i2, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 24 | 0;
 i9 = i10 + 16 | 0;
 i5 = i10 + 8 | 0;
 i7 = i10;
 __ZN10GpuProgramC2Ev(i4);
 HEAP32[i4 >> 2] = gb + 77020 + 8;
 i6 = i4 + 16 | 0;
 i11 = gb + 63280 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i14 = i7;
 HEAP32[i14 >> 2] = i12;
 HEAP32[i14 + 4 >> 2] = i11;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i7);
 i14 = i5;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i4 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = i7;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i1 + 4 >> 2] = i11;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i7);
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i4 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i4 + 88 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 i7 = i4 + 56 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP16[i7 + 28 >> 1] = 0;
 HEAP32[i4 + 4 >> 2] = 6;
 if (!(HEAP32[i2 + 12 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = i4 + 8 | 0;
 HEAP8[i7 >> 0] = 1;
 if (!(__ZN18GlslGpuProgramGLES6CreateE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER14ChannelAssigns(i4, 0, i2, __ZN22CreateGpuProgramOutput20CreateChannelAssignsEv(i8) | 0) | 0)) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  do if (!i1) i1 = gb + 604454 | 0; else if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   break;
  } else break; while (0);
  HEAP32[i3 >> 2] = i1;
  _printf_console(gb + 604553 | 0, i3);
  STACKTOP = i10;
  return;
 }
 i5 = __ZN22CreateGpuProgramOutput12CreateParamsEv(i8) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 if (i1 | 0) {
  if (!(HEAP8[i4 + 84 >> 0] | 0)) i3 = (HEAP8[i4 + 85 >> 0] | 0) != 0; else i3 = 1;
  __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, i1, i3, HEAP32[i4 + 96 >> 2] | 0);
  __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet(i1, i5, i2);
  i2 = i5 + 80 | 0;
  i14 = (HEAP32[i5 + 84 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
  i3 = (i14 | 0) / 52 | 0;
  if ((i14 | 0) > 0) {
   i1 = 0;
   do {
    i13 = __Z16GetRealGfxDevicev() | 0;
    i14 = HEAP32[i2 >> 2] | 0;
    mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 212 >> 2] | 0, i13 | 0, HEAP32[i14 + (i1 * 52 | 0) >> 2] | 0, HEAP32[i14 + (i1 * 52 | 0) + 24 >> 2] | 0, 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
 }
 __ZN16UniformCacheGLES6CreateERK20GpuProgramParameters(i6, i5);
 i14 = (HEAP32[i5 + 40 >> 2] | 0) - (HEAP32[i5 + 36 >> 2] | 0) >> 4;
 if ((i14 | 0) <= (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0)) {
  HEAP8[i7 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 do if (!i1) i1 = gb + 604454 | 0; else if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  break;
 } else break; while (0);
 HEAP32[i9 >> 2] = i1;
 _printf_console(gb + 604464 | 0, i9);
 STACKTOP = i10;
 return;
}

function __Z11EvalSHBasisPKfPd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, i16 = 0, d17 = 0.0, d18 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 96 | 0;
 i4 = i6 + 48 | 0;
 i5 = i6;
 if (!(HEAP8[gb + 1544240 >> 0] | 0)) {
  HEAPF64[gb + 1098056 >> 3] = 1.7724538509055159;
  HEAP8[gb + 1544240 >> 0] = 1;
 }
 d15 = +Math_fround(HEAPF32[i1 >> 2]);
 d18 = +Math_fround(HEAPF32[i1 + 4 >> 2]);
 d11 = +Math_fround(HEAPF32[i1 + 8 >> 2]);
 HEAPF64[i5 >> 3] = 1.0;
 HEAPF64[i4 >> 3] = 1.0;
 HEAPF64[i3 >> 3] = 1.0;
 HEAPF64[i3 + 8 >> 3] = d15;
 HEAPF64[i4 + 8 >> 3] = d18;
 HEAPF64[i5 + 8 >> 3] = d11;
 d8 = d15 * d15;
 i23 = i3 + 16 | 0;
 HEAPF64[i23 >> 3] = d8;
 d10 = d18 * d18;
 i22 = i4 + 16 | 0;
 HEAPF64[i22 >> 3] = d10;
 d7 = d11 * d11;
 i19 = i5 + 16 | 0;
 HEAPF64[i19 >> 3] = d7;
 d12 = d15 * d8;
 i21 = i3 + 24 | 0;
 HEAPF64[i21 >> 3] = d12;
 d13 = d18 * d10;
 i20 = i4 + 24 | 0;
 HEAPF64[i20 >> 3] = d13;
 d17 = d11 * d7;
 HEAPF64[i5 + 24 >> 3] = d17;
 d12 = d15 * d12;
 i1 = i3 + 32 | 0;
 HEAPF64[i1 >> 3] = d12;
 d14 = d18 * d13;
 i9 = i4 + 32 | 0;
 HEAPF64[i9 >> 3] = d14;
 d17 = d11 * d17;
 i16 = i5 + 32 | 0;
 HEAPF64[i16 >> 3] = d17;
 HEAPF64[i3 + 40 >> 3] = d15 * d12;
 HEAPF64[i4 + 40 >> 3] = d18 * d14;
 HEAPF64[i5 + 40 >> 3] = d11 * d17;
 HEAPF64[i2 >> 3] = 1.0 / (+HEAPF64[gb + 1098056 >> 3] * 2.0);
 HEAPF64[i2 + 8 >> 3] = d18 * .9772050238058398 * -.5;
 HEAPF64[i2 + 16 >> 3] = d11 * .9772050238058398 * .5;
 HEAPF64[i2 + 24 >> 3] = d15 * .9772050238058398 * -.5;
 d17 = d15 * 2.1850968611841584;
 HEAPF64[i2 + 32 >> 3] = d17 * d18 * .5;
 HEAPF64[i2 + 40 >> 3] = d18 * 2.1850968611841584 * d11 * -.5;
 HEAPF64[i2 + 48 >> 3] = (d7 * 3.0 + -1.0) * 1.2615662610100802 * .25;
 HEAPF64[i2 + 56 >> 3] = d17 * d11 * -.5;
 HEAPF64[i2 + 64 >> 3] = (d8 - d10) * 2.1850968611841584 * .25;
 HEAPF64[i2 + 72 >> 3] = (d13 + d18 * (d8 * -3.0)) * 2.360174359706574 * .25;
 HEAPF64[i2 + 80 >> 3] = d15 * 5.781222885281108 * d18 * d11 * .5;
 d7 = d7 * 5.0;
 d8 = d7 + -1.0;
 HEAPF64[i2 + 88 >> 3] = d18 * 1.828183197857863 * d8 * -.25;
 HEAPF64[i2 + 96 >> 3] = d11 * 1.4927053303604616 * (d7 + -3.0) * .25;
 HEAPF64[i2 + 104 >> 3] = d15 * 1.828183197857863 * d8 * -.25;
 d8 = +HEAPF64[i23 >> 3];
 d7 = +HEAPF64[i22 >> 3];
 d13 = d8 - d7;
 HEAPF64[i2 + 112 >> 3] = d11 * (d13 * 5.781222885281108) * .25;
 d10 = +HEAPF64[i21 >> 3] - d15 * 3.0 * d7;
 HEAPF64[i2 + 120 >> 3] = d10 * 2.360174359706574 * -.25;
 HEAPF64[i2 + 128 >> 3] = d15 * 10.013371767186818 * d18 * d13 * .25;
 HEAPF64[i2 + 136 >> 3] = d11 * ((d18 * (d8 * 3.0) - +HEAPF64[i20 >> 3]) * -7.080523079119722) * .25;
 d17 = +HEAPF64[i19 >> 3];
 d14 = d17 * 7.0;
 d12 = d14 + -1.0;
 HEAPF64[i2 + 144 >> 3] = d15 * 3.7846987830302403 * d18 * d12 * .25;
 d14 = d14 + -3.0;
 HEAPF64[i2 + 152 >> 3] = d18 * -2.676186174229157 * d11 * d14 * .25;
 HEAPF64[i2 + 160 >> 3] = (3.0 - d17 * 30.0 + +HEAPF64[i16 >> 3] * 35.0) * 3.0 / (+HEAPF64[gb + 1098056 >> 3] * 16.0);
 HEAPF64[i2 + 168 >> 3] = d15 * -2.676186174229157 * d11 * d14 * .25;
 HEAPF64[i2 + 176 >> 3] = d13 * 3.7846987830302403 * d12 * .125;
 HEAPF64[i2 + 184 >> 3] = d11 * (d10 * -7.080523079119722) * .25;
 HEAPF64[i2 + 192 >> 3] = (+HEAPF64[i9 >> 3] + (+HEAPF64[i1 >> 3] - d8 * 6.0 * d7)) * 10.013371767186818 * .0625;
 STACKTOP = i6;
 return;
}

function __ZN19SpriteMeshGenerator4pathC2ERKNSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEiiiff(i13, i2, i1, i4, i5, f3, f6) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 f6 = Math_fround(f6);
 var i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0;
 HEAP32[i13 >> 2] = 0;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i14 = i13 + 44 | 0;
 i11 = i13 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i11 >> 2] = i1;
 i12 = i13 + 16 | 0;
 HEAP32[i12 >> 2] = i4;
 HEAPF32[i13 + 24 >> 2] = f3;
 HEAP32[i13 + 20 >> 2] = i5;
 if ((i13 | 0) != (i2 | 0)) __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i13, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 __ZN19SpriteMeshGenerator4path3optEf(i13, f6) | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i4 = i7 - i5 | 0;
 i2 = i4 >> 5;
 if ((i4 | 0) > 0) {
  f6 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(1.17549435e-38);
  f9 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
  do {
   f16 = Math_fround(HEAPF32[i5 + (i1 << 5) >> 2]);
   f15 = Math_fround(HEAPF32[i5 + (i1 << 5) + 4 >> 2]);
   f6 = f16 < f6 ? f16 : f6;
   f3 = f15 < f3 ? f15 : f3;
   f9 = f16 > f9 ? f16 : f9;
   f8 = f15 > f8 ? f15 : f8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  if (f6 < Math_fround(0.0)) i4 = 0; else i10 = 6;
 } else {
  f6 = Math_fround(3402823469999999843913219.0e14);
  f8 = Math_fround(1.17549435e-38);
  f9 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i10 = 6;
 }
 if ((i10 | 0) == 6) {
  f16 = Math_fround(HEAP32[i11 >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6 > f16 ? f16 : f6, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f3 < Math_fround(0.0)) i2 = 0; else {
  f16 = Math_fround(HEAP32[i12 >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3 > f16 ? f16 : f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f9 < Math_fround(0.0)) i1 = 0; else {
  f16 = Math_fround(HEAP32[i11 >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9 > f16 ? f16 : f9, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f8 < Math_fround(0.0)) {
  i12 = 0;
  i11 = i13 + 28 | 0;
  HEAP32[i11 >> 2] = i4;
  i11 = i13 + 32 | 0;
  HEAP32[i11 >> 2] = i2;
  i11 = i13 + 36 | 0;
  HEAP32[i11 >> 2] = i1;
  i13 = i13 + 40 | 0;
  HEAP32[i13 >> 2] = i12;
  __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i14, i5, i7);
  return;
 }
 f16 = Math_fround(HEAP32[i12 >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f8 > f16 ? f16 : f8, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = i13 + 28 | 0;
 HEAP32[i11 >> 2] = i4;
 i11 = i13 + 32 | 0;
 HEAP32[i11 >> 2] = i2;
 i11 = i13 + 36 | 0;
 HEAP32[i11 >> 2] = i1;
 i13 = i13 + 40 | 0;
 HEAP32[i13 >> 2] = i12;
 __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i14, i5, i7);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 48 | 0, 4) | 0;
  i2 = i4 + (i1 * 48 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    i9 = i1 + 40 | 0;
    HEAP32[i9 >> 2] = -1;
    HEAP32[i9 + 4 >> 2] = -1;
    i1 = i1 + 48 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) * 48 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906439 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN7mecanim5human6HandleEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12);
     i1 = i1 + 48 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906439 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN7mecanim5human6HandleEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 48 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN26AnimatorOverrideController10BuildAssetEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 136 >> 2] | 0, i9 | 0);
 i7 = i9 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i1 = i11;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i8 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 21;
   }
  }
  if ((i8 | 0) == 19) i8 = 21;
  if ((i8 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
  if (i1 | 0) {
   mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 124 >> 2] | 0, i9 | 0);
   HEAP32[i9 + 104 >> 2] = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE(i1, mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 100 >> 2] | 0, i9 | 0) | 0, i9 + 108 | 0) | 0;
   STACKTOP = i10;
   return;
  }
  i1 = i9 + 84 | 0;
  i2 = i9 + 100 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 88 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 + 96 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i10;
  return;
 } while (0);
 i1 = i9 + 84 | 0;
 i2 = i9 + 100 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 88 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 96 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN22ParticleSystemRendererC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i4, 7, i5, i2);
 HEAP32[i4 >> 2] = gb + 83088 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 83088 + 196;
 i1 = i4 + 484 | 0;
 i2 = i4 + 424 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 488 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i4 + 476 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 + 492 >> 2] = 0;
 HEAP32[i4 + 504 >> 2] = 0;
 HEAP32[i4 + 508 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4 + 496 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i4 + 512 >> 2] = 0;
 HEAP32[i4 + 524 >> 2] = 0;
 HEAP32[i4 + 528 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i4 + 516 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 + 532 >> 2] = 0;
 HEAP32[i4 + 544 >> 2] = 0;
 HEAP32[i4 + 548 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4 + 536 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i4 + 552 | 0;
 HEAP32[i4 + 592 >> 2] = 0;
 HEAP32[i4 + 596 >> 2] = 0;
 HEAP32[i4 + 600 >> 2] = -1;
 HEAP32[i4 + 604 >> 2] = 0;
 HEAP32[i4 + 1012 >> 2] = 0;
 HEAP32[i4 + 1016 >> 2] = 0;
 HEAP32[i4 + 1020 >> 2] = -1;
 HEAP32[i4 + 1024 >> 2] = 0;
 HEAP16[i4 + 340 >> 1] = 0;
 HEAPF32[i4 + 360 >> 2] = Math_fround(2.0);
 HEAPF32[i4 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 348 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 364 >> 2] = Math_fround(0.0);
 HEAP16[i4 + 342 >> 1] = 0;
 HEAPF32[i4 + 368 >> 2] = Math_fround(1.0);
 i7 = i4 + 372 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP16[i7 + 16 >> 1] = 0;
 HEAP32[i4 + 392 >> 2] = 27;
 HEAP32[i4 + 396 >> 2] = 0;
 HEAP16[i4 + 400 >> 1] = 0;
 HEAPF32[i4 + 404 >> 2] = Math_fround(0.0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i8 = i4 + 568 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i8 = i4 + 580 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i8 = i4 + 268 | 0;
 i7 = (HEAPU16[i8 >> 1] | 0 | (HEAPU8[i8 + 2 >> 0] | 0) << 16) & 16727615;
 HEAP16[i8 >> 1] = i7;
 HEAP8[i8 + 2 >> 0] = i7 >>> 16;
 __ZN8Renderer10SetVisibleEb(i4, 0);
 HEAP32[i4 + 432 >> 2] = i4;
 HEAP32[i4 + 444 >> 2] = i4;
 HEAP32[i4 + 456 >> 2] = i4;
 HEAP32[i4 + 468 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN11Rigidbody2D4CastERK8Vector2ffP12RaycastHit2Di(i1, i7, f9, i2, i13) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 f9 = Math_fround(f9);
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i21 + 24 | 0;
 i10 = i21 + 8 | 0;
 i3 = i21;
 i20 = i21 + 48 | 0;
 i17 = i21 + 28 | 0;
 i14 = i21 + 68 | 0;
 i19 = gb + 64016 | 0;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i8 + 4 >> 2] = i18;
 HEAP32[i20 >> 2] = 0;
 i8 = i20 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i18 = i20 + 16 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i20 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i3);
 i12 = i10;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i19;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 + 4 >> 2] = i15;
 if (!(__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i20) | 0)) i1 = 0; else {
  i16 = gb + 64016 | 0;
  i15 = HEAP32[i16 + 4 >> 2] | 0;
  i12 = i3;
  HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i12 + 4 >> 2] = i15;
  HEAP32[i17 >> 2] = 0;
  i12 = i17 + 12 | 0;
  HEAP32[i12 >> 2] = 0;
  i15 = i17 + 16 | 0;
  HEAP32[i15 >> 2] = 0;
  i16 = i17 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i3);
  i4 = i10;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i16;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  if (!(HEAP32[i8 >> 2] | 0)) {
   i3 = 0;
   i1 = 0;
  } else {
   i5 = i10 + 11 | 0;
   i4 = HEAP32[i20 >> 2] | 0;
   do {
    i6 = HEAP32[i4 >> 2] | 0;
    i1 = HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + 48 >> 2] | 0;
    i3 = __Z21GetManagerFromContexti(16) | 0;
    if (i1 >>> 0 > 31) {
     HEAP32[i11 >> 2] = 31;
     __Z6FormatPKcz(i10, gb + 805697 | 0, i11);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 805767 | 0, 452, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
     i1 = -1;
    } else i1 = HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    __ZN16Physics2DManager15ColliderCastAllEPK10Collider2DRK8Vector2ffibP13dynamic_arrayI12RaycastHit2DLj4EE(0, i6, i7, f9, i1, 1, i17) | 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != ((HEAP32[i20 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
   i3 = HEAP32[i17 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i1 = i3 + (i1 * 36 | 0) | 0;
  i6 = i14;
  i7 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i7 | 0));
  __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_(i3, i1, i14);
  i1 = HEAP32[i12 >> 2] | 0;
  i1 = (i1 | 0) > (i13 | 0) ? i13 : i1;
  if ((i1 | 0) > 0) {
   i5 = HEAP32[i17 >> 2] | 0;
   i3 = 0;
   do {
    i6 = i2;
    i2 = i2 + 36 | 0;
    i4 = i5 + (i3 * 36 | 0) | 0;
    i7 = i6 + 36 | 0;
    do {
     HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
     i6 = i6 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i6 | 0) < (i7 | 0));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
  }
  if ((HEAP32[i15 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16);
   HEAP32[i17 >> 2] = 0;
  }
 }
 if ((HEAP32[i18 >> 2] | 0) <= -1) {
  STACKTOP = i21;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i19);
 HEAP32[i20 >> 2] = 0;
 STACKTOP = i21;
 return i1 | 0;
}

function __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 12 | 0, i8 + 1 | 0);
 i2 = i6 + 28 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 44 | 0, i8 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i6 + 60 | 0, i8 + 4 | 0);
 i2 = i6 + 76 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 8 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i6 + 96 | 0, gb + 734686 | 0, 0);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 116 | 0, i7);
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 128 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 148 | 0, i7);
 __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 160 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 172 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 176 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __Z11SkinGenericILi2ELb0ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0;
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 i6 = HEAP32[i1 + 40 >> 2] | 0;
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = HEAP32[i1 + 60 >> 2] | 0;
 if ((i8 | 0) <= 0) return;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 while (1) {
  f17 = Math_fround(HEAPF32[i1 >> 2]);
  f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  i24 = HEAP32[i1 + 8 >> 2] | 0;
  i23 = HEAP32[i1 + 12 >> 2] | 0;
  f11 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) >> 2]));
  f11 = Math_fround(f11 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) >> 2])));
  f21 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 4 >> 2]));
  f21 = Math_fround(f21 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 4 >> 2])));
  f18 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 8 >> 2]));
  f18 = Math_fround(f18 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 8 >> 2])));
  f13 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 16 >> 2]));
  f13 = Math_fround(f13 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 16 >> 2])));
  f20 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 20 >> 2]));
  f20 = Math_fround(f20 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 20 >> 2])));
  f16 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 24 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 24 >> 2])));
  f12 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 32 >> 2]));
  f12 = Math_fround(f12 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 32 >> 2])));
  f10 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 36 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 36 >> 2])));
  f9 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 40 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 40 >> 2])));
  f14 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 48 >> 2]));
  f14 = Math_fround(f14 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 48 >> 2])));
  f22 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 52 >> 2]));
  f22 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 52 >> 2])));
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i5 + (i24 << 6) + 56 >> 2]));
  f19 = Math_fround(f17 + Math_fround(f19 * Math_fround(HEAPF32[i5 + (i23 << 6) + 56 >> 2])));
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(f11 * f17);
  f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f13 = Math_fround(f11 + Math_fround(f13 * f15));
  f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f10 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f21 * f17) + Math_fround(f20 * f15)) + Math_fround(f10 * f11)));
  f9 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f15)) + Math_fround(f9 * f11)));
  HEAPF32[i3 >> 2] = Math_fround(f14 + Math_fround(f13 + Math_fround(f12 * f11)));
  HEAPF32[i3 + 4 >> 2] = f10;
  HEAPF32[i3 + 8 >> 2] = f9;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i8 | 0)) break; else {
   i2 = i2 + i6 | 0;
   i3 = i3 + i7 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i25 + 48 | 0;
 i20 = i25 + 32 | 0;
 i21 = i25 + 24 | 0;
 i22 = i25 + 16 | 0;
 i23 = i25;
 i24 = i11 + 4 | 0;
 HEAPF32[i24 >> 2] = Math_fround(0.0);
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 i13 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP32[i21 + 4 >> 2] = i13;
 HEAP32[i22 >> 2] = i13;
 HEAPF32[i22 + 4 >> 2] = Math_fround(1.0);
 i13 = i19 + 12 | 0;
 i14 = i19 + 8 | 0;
 i15 = i19 + 4 | 0;
 i16 = i19 + 12 | 0;
 i17 = i19 + 8 | 0;
 i18 = i19 + 4 | 0;
 i10 = 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 do {
  f5 = Math_fround(HEAPF32[i12 + (i10 << 4) >> 2]);
  f6 = Math_fround(HEAPF32[i12 + (i10 << 4) + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i12 + (i10 << 4) + 8 >> 2]);
  i8 = __Z27CubicPolynomialRootsGenericPfdddd(i23, +Math_fround(f5 * Math_fround(4.0)), +Math_fround(f6 * Math_fround(3.0)), +Math_fround(f9 * Math_fround(2.0)), +Math_fround(HEAPF32[i12 + (i10 << 4) + 12 >> 2])) | 0;
  if ((i8 | 0) > 0) {
   f9 = Math_fround(HEAPF32[i21 + (i10 << 2) >> 2]);
   i3 = i22 + (i10 << 2) | 0;
   i7 = 0;
   f4 = f2;
   f6 = f1;
   while (1) {
    f5 = Math_fround(Math_fround(HEAPF32[i23 + (i7 << 2) >> 2]) + f9);
    if (!(f5 >= f9)) f5 = f6; else if (f5 < Math_fround(HEAPF32[i3 >> 2])) {
     HEAPF32[i16 >> 2] = f5;
     HEAPF32[i17 >> 2] = f5;
     HEAPF32[i18 >> 2] = f5;
     HEAPF32[i19 >> 2] = f5;
     __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i20, i12, i19);
     f5 = Math_fround(HEAPF32[i20 >> 2]);
     f1 = Math_fround(_fminf(f5, f5));
     HEAPF32[i11 >> 2] = Math_fround(_fminf(f4, Math_fround(_fminf(f1, f1))));
     f4 = Math_fround(_fmaxf(f5, f5));
     HEAPF32[i24 >> 2] = Math_fround(_fmaxf(f6, Math_fround(_fmaxf(f4, f4))));
     i26 = i11;
     i27 = HEAP32[i26 >> 2] | 0;
     i26 = HEAP32[i26 + 4 >> 2] | 0;
     HEAP32[i11 >> 2] = i27;
     HEAP32[i24 >> 2] = i26;
     f4 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f5 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f1 = f5;
     f2 = f4;
    } else f5 = f6;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i8 | 0)) break; else f6 = f5;
   }
  } else i3 = i22 + (i10 << 2) | 0;
  i27 = HEAP32[i3 >> 2] | 0;
  HEAP32[i13 >> 2] = i27;
  HEAP32[i14 >> 2] = i27;
  HEAP32[i15 >> 2] = i27;
  HEAP32[i19 >> 2] = i27;
  __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i20, i12, i19);
  f9 = Math_fround(HEAPF32[i20 >> 2]);
  f6 = Math_fround(_fminf(f9, f9));
  HEAPF32[i11 >> 2] = Math_fround(_fminf(f2, Math_fround(_fminf(f6, f6))));
  f2 = Math_fround(_fmaxf(f9, f9));
  HEAPF32[i24 >> 2] = Math_fround(_fmaxf(f1, Math_fround(_fmaxf(f2, f2))));
  i27 = i11;
  i26 = HEAP32[i27 >> 2] | 0;
  i27 = HEAP32[i27 + 4 >> 2] | 0;
  HEAP32[i11 >> 2] = i26;
  HEAP32[i24 >> 2] = i27;
  i10 = i10 + 1 | 0;
  f2 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i27, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i10 | 0) != 2);
 STACKTOP = i25;
 return;
}

function __ZN9b2Contact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i1, i2, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[gb + 1552703 >> 0] | 0)) {
  HEAP32[gb + 1458112 >> 2] = fb + 145;
  HEAP32[gb + 1458112 + 4 >> 2] = fb + 3823;
  HEAP8[gb + 1458112 + 8 >> 0] = 1;
  HEAP32[gb + 1458112 + 120 >> 2] = fb + 146;
  HEAP32[gb + 1458112 + 124 >> 2] = fb + 3824;
  HEAP8[gb + 1458112 + 128 >> 0] = 1;
  HEAP32[gb + 1458112 + 24 >> 2] = fb + 146;
  HEAP32[gb + 1458112 + 28 >> 2] = fb + 3824;
  HEAP8[gb + 1458112 + 32 >> 0] = 0;
  HEAP32[gb + 1458112 + 144 >> 2] = fb + 147;
  HEAP32[gb + 1458112 + 148 >> 2] = fb + 3825;
  HEAP8[gb + 1458112 + 152 >> 0] = 1;
  HEAP32[gb + 1458112 + 60 >> 2] = fb + 148;
  HEAP32[gb + 1458112 + 64 >> 2] = fb + 3826;
  HEAP8[gb + 1458112 + 68 >> 0] = 1;
  HEAP32[gb + 1458112 + 12 >> 2] = fb + 148;
  HEAP32[gb + 1458112 + 16 >> 2] = fb + 3826;
  HEAP8[gb + 1458112 + 20 >> 0] = 0;
  HEAP32[gb + 1458112 + 84 >> 2] = fb + 149;
  HEAP32[gb + 1458112 + 88 >> 2] = fb + 3827;
  HEAP8[gb + 1458112 + 92 >> 0] = 1;
  HEAP32[gb + 1458112 + 132 >> 2] = fb + 149;
  HEAP32[gb + 1458112 + 136 >> 2] = fb + 3827;
  HEAP8[gb + 1458112 + 140 >> 0] = 0;
  HEAP32[gb + 1458112 + 180 >> 2] = fb + 150;
  HEAP32[gb + 1458112 + 184 >> 2] = fb + 3828;
  HEAP8[gb + 1458112 + 188 >> 0] = 1;
  HEAP32[gb + 1458112 + 36 >> 2] = fb + 150;
  HEAP32[gb + 1458112 + 40 >> 2] = fb + 3828;
  HEAP8[gb + 1458112 + 44 >> 0] = 0;
  HEAP32[gb + 1458112 + 204 >> 2] = fb + 151;
  HEAP32[gb + 1458112 + 208 >> 2] = fb + 3829;
  HEAP8[gb + 1458112 + 212 >> 0] = 1;
  HEAP32[gb + 1458112 + 156 >> 2] = fb + 151;
  HEAP32[gb + 1458112 + 160 >> 2] = fb + 3829;
  HEAP8[gb + 1458112 + 164 >> 0] = 0;
  HEAP32[gb + 1458112 + 288 >> 2] = fb + 152;
  HEAP32[gb + 1458112 + 292 >> 2] = fb + 3830;
  HEAP8[gb + 1458112 + 296 >> 0] = 1;
  HEAP32[gb + 1458112 + 240 >> 2] = fb + 153;
  HEAP32[gb + 1458112 + 244 >> 2] = fb + 3831;
  HEAP8[gb + 1458112 + 248 >> 0] = 1;
  HEAP32[gb + 1458112 + 48 >> 2] = fb + 153;
  HEAP32[gb + 1458112 + 52 >> 2] = fb + 3831;
  HEAP8[gb + 1458112 + 56 >> 0] = 0;
  HEAP32[gb + 1458112 + 168 >> 2] = fb + 154;
  HEAP32[gb + 1458112 + 172 >> 2] = fb + 3832;
  HEAP8[gb + 1458112 + 176 >> 0] = 1;
  HEAP32[gb + 1458112 + 264 >> 2] = fb + 154;
  HEAP32[gb + 1458112 + 268 >> 2] = fb + 3832;
  HEAP8[gb + 1458112 + 272 >> 0] = 0;
  HEAP32[gb + 1458112 + 108 >> 2] = fb + 155;
  HEAP32[gb + 1458112 + 112 >> 2] = fb + 3833;
  HEAP8[gb + 1458112 + 116 >> 0] = 1;
  HEAP32[gb + 1458112 + 252 >> 2] = fb + 155;
  HEAP32[gb + 1458112 + 256 >> 2] = fb + 3833;
  HEAP8[gb + 1458112 + 260 >> 0] = 0;
  HEAP32[gb + 1458112 + 228 >> 2] = fb + 156;
  HEAP32[gb + 1458112 + 232 >> 2] = fb + 3834;
  HEAP8[gb + 1458112 + 236 >> 0] = 1;
  HEAP32[gb + 1458112 + 276 >> 2] = fb + 156;
  HEAP32[gb + 1458112 + 280 >> 2] = fb + 3834;
  HEAP8[gb + 1458112 + 284 >> 0] = 0;
  HEAP8[gb + 1552703 >> 0] = 1;
 }
 i3 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 4 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 4 >> 2] | 0;
 i5 = HEAP32[gb + 1458112 + (i3 * 60 | 0) + (i4 * 12 | 0) >> 2] | 0;
 if (!i5) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP8[gb + 1458112 + (i3 * 60 | 0) + (i4 * 12 | 0) + 8 >> 0] | 0)) {
  i8 = mftCall_iiiiii(i5 | 0, i6 | 0, i7 | 0, i1 | 0, i2 | 0, i8 | 0) | 0;
  return i8 | 0;
 } else {
  i8 = mftCall_iiiiii(i5 | 0, i1 | 0, i2 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 56 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 116 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEbT0_S7_T_(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 switch (i12 - i13 >> 3 | 0) {
 case 2:
  {
   i3 = i12 + -8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   if (i4 >>> 0 < i5 >>> 0) {
    i2 = i13 + 4 | 0;
    i1 = i12 + -4 | 0;
   } else {
    if (i5 >>> 0 < i4 >>> 0) {
     i13 = 1;
     return i13 | 0;
    }
    i1 = i12 + -4 | 0;
    i2 = i13 + 4 | 0;
    if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
     i13 = 1;
     return i13 | 0;
    }
   }
   HEAP32[i13 >> 2] = i4;
   HEAP32[i3 >> 2] = i5;
   i13 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i13;
   i13 = 1;
   return i13 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i13, i13 + 8 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i13, i13 + 8 | 0, i13 + 16 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i13, i13 + 8 | 0, i13 + 16 | 0, i13 + 24 | 0, i12 + -8 | 0, i1) | 0;
   i13 = 1;
   return i13 | 0;
  }
 case 1:
 case 0:
  {
   i13 = 1;
   return i13 | 0;
  }
 default:
  {
   i3 = i13 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i13, i13 + 8 | 0, i3, i1) | 0;
   i1 = i13 + 24 | 0;
   L3 : do if ((i1 | 0) == (i12 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i4 = HEAP32[i1 >> 2] | 0;
     i7 = HEAP32[i3 >> 2] | 0;
     if (i4 >>> 0 < i7 >>> 0) {
      i6 = i3 + 4 | 0;
      i4 = i1 + 4 | 0;
      i5 = i6;
      i6 = HEAP32[i6 >> 2] | 0;
      i11 = 15;
     } else if (i7 >>> 0 >= i4 >>> 0) {
      i4 = i1 + 4 | 0;
      i5 = i3 + 4 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0) i11 = 15;
     }
     if ((i11 | 0) == 15) {
      i11 = 0;
      i10 = i1;
      i9 = HEAP32[i10 >> 2] | 0;
      i10 = HEAP32[i10 + 4 >> 2] | 0;
      HEAP32[i1 >> 2] = i7;
      HEAP32[i4 >> 2] = i6;
      L12 : do if ((i3 | 0) != (i13 | 0)) {
       i8 = i3;
       i6 = i5;
       while (1) {
        i3 = i8 + -8 | 0;
        i7 = HEAP32[i3 >> 2] | 0;
        if (i9 >>> 0 < i7 >>> 0) {
         i4 = i8 + -4 | 0;
         i5 = i4;
         i4 = HEAP32[i4 >> 2] | 0;
        } else {
         if (i7 >>> 0 < i9 >>> 0) {
          i5 = i6;
          i3 = i8;
          break L12;
         }
         i5 = i8 + -4 | 0;
         i4 = HEAP32[i5 >> 2] | 0;
         if (i10 >>> 0 >= i4 >>> 0) {
          i5 = i6;
          i3 = i8;
          break L12;
         }
        }
        HEAP32[i8 >> 2] = i7;
        HEAP32[i8 + 4 >> 2] = i4;
        if ((i3 | 0) == (i13 | 0)) break; else {
         i8 = i3;
         i6 = i5;
        }
       }
      } while (0);
      HEAP32[i3 >> 2] = i9;
      HEAP32[i5 >> 2] = i10;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i12 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i13 = i1 | i2;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN5physx17PxsThresholdTable5buildERKNS_18PxsThresholdStreamE(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i17 + 2 | 0;
 i3 = i17 + 1 | 0;
 i4 = i17;
 i15 = HEAP32[i8 + 4 >> 2] | 0;
 if (!i15) {
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i17;
  return;
 }
 i14 = i15 << 1 | 1;
 i1 = i6 + 28 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 if (i15 >>> 0 > i13 >>> 0 | i15 >>> 0 < i13 >>> 2 >>> 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  i13 = i14 << 2;
  i2 = i15 * 12 | 0;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i13 + i2 | 0, gb + 721862 | 0, 84) | 0;
  HEAP32[i6 >> 2] = i3;
  i5 = i6 + 16 | 0;
  HEAP32[i5 >> 2] = i3;
  i4 = i6 + 20 | 0;
  HEAP32[i4 >> 2] = i3 + (i15 << 3);
  i2 = i3 + i2 | 0;
  i3 = i6 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i15;
  HEAP32[i6 + 12 >> 2] = i14;
  i1 = i13;
 } else {
  i2 = i6 + 4 | 0;
  i1 = i14 << 2;
  i4 = i6 + 20 | 0;
  i5 = i6 + 16 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 _memset(i2 | 0, -1, i1 | 0) | 0;
 i13 = i6 + 24 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = i14;
 i12 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = 0;
 i1 = 0;
 do {
  i4 = HEAP32[i8 + (i9 << 4) >> 2] | 0;
  i5 = HEAP32[i8 + (i9 << 4) + 4 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i8 + (i9 << 4) + 8 >> 2]);
  i3 = i5;
  i3 = _i64Add(i3 | 0, i4 | 0, -1, ~i3 | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i3 | 0, i6 | 0, 22) | 0;
  i3 = i2 ^ i3;
  i6 = (getTempRet0() | 0) ^ i6;
  i2 = _bitshift64Shl(i3 | 0, i6 | 0, 13) | 0;
  i2 = _i64Add(i3 | 0, i6 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i3 = _bitshift64Lshr(i2 | 0, i6 | 0, 8) | 0;
  i6 = ___muldi3(i3 ^ i2 | 0, (getTempRet0() | 0) ^ i6 | 0, 9, 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = _bitshift64Lshr(i6 | 0, i2 | 0, 15) | 0;
  i6 = i3 ^ i6;
  i2 = (getTempRet0() | 0) ^ i2;
  i3 = _bitshift64Shl(i6 | 0, i2 | 0, 27) | 0;
  i3 = _i64Add(i6 | 0, i2 | 0, ~i3 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i3 | 0, i2 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i2;
  i3 = ((i6 ^ i3) >>> 0) % (i14 >>> 0) | 0;
  i6 = i12 + (i3 << 2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  L17 : do if ((i2 | 0) == -1) {
   if ((i3 | 0) != -1) i16 = 17;
  } else {
   while (1) {
    i3 = HEAP32[i10 + (i2 << 3) >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i8 + (i3 << 4) >> 2] | 0)) if ((i5 | 0) == (HEAP32[i8 + (i3 << 4) + 4 >> 2] | 0)) break;
    i2 = HEAP32[i11 + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i16 = 17;
     break L17;
    }
   }
   i6 = i10 + (i2 << 3) + 4 | 0;
   HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
  } while (0);
  if ((i16 | 0) == 17) {
   i16 = 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 + (i1 << 2) >> 2] = -1;
   HEAP32[i10 + (i1 << 3) >> 2] = i9;
   HEAPF32[i10 + (i1 << 3) + 4 >> 2] = f7;
   i1 = i1 + 1 | 0;
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i15 | 0));
 HEAP32[i13 >> 2] = i1;
 STACKTOP = i17;
 return;
}

function __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i8 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i8 + 56 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i8 + 64 | 0, gb + 378329 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i8 + 76 | 0, gb + 378347 | 0, 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 88 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i8 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = i10 + 4 | 0;
 i4 = i9 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 67088 | 0) | 0;
 if (i1 | 0) __ZN11Rigidbody2D6CreateEv(i1);
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 i7 = __ZNK7Joint2D10FetchBodyBEv(i9) | 0;
 if ((i3 | 0) == (i7 | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __Z6FormatPKcz(i6, gb + 801141 | 0, i5);
  if (!i9) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 801199 | 0, 259, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i10;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 148 >> 2] | 0, i9 | 0) | 0;
 HEAP32[i2 + 8 >> 2] = i1 ? i7 : i3;
 i1 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 148 >> 2] | 0, i9 | 0) | 0;
 HEAP32[i2 + 12 >> 2] = i1 ? i3 : i7;
 HEAP8[i2 + 16 >> 0] = HEAP8[i9 + 40 >> 0] | 0;
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i9 + 60 >> 2] = __ZN7b2World11CreateJointEPK10b2JointDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i2) | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i6 = i3 + 64 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = i7 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
  i7 = i7 + 64 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
 }
 if (Math_fround(HEAPF32[i9 + 44 >> 2]) == Math_fround(inf)) if (Math_fround(HEAPF32[i9 + 48 >> 2]) == Math_fround(inf)) {
  i1 = i9 + 64 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = i9 + 68 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 } else i8 = 21; else i8 = 21;
 if ((i8 | 0) == 21) {
  i2 = (HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0) + 588 | 0;
  i3 = i9 + 64 | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i9 + 68 | 0; else {
    i8 = i9 + 68 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
    HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    i1 = i8;
   }
   i8 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i8 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  }
 }
 HEAP8[i9 + 52 >> 0] = (__Z14IsWorldPlayingv() | 0) & 1;
 STACKTOP = i10;
 return;
}

function __ZN6Sprite16OverrideGeometryEPK8Vector2fjPKtj(i6, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i2 = i13 + 8 | 0;
 i1 = i13;
 i12 = i13 + 32 | 0;
 if (i8 >>> 0 > 65535) {
  HEAP32[i1 >> 2] = 65535;
  __Z12FormatStringPKcz(i12, gb + 416173 | 0, i1);
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i11 | 0) == 0 ? i12 + 4 | 0 : i11, 0, gb + 412121 | 0, 633, 1, i1, 0, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i12 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12 + 24 | 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((i10 >>> 0) % 3 | 0 | 0) {
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416250 | 0, 0, gb + 412121 | 0, 640, 1, i1, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 L19 : do if (i10 | 0) {
  i1 = 0;
  while (1) {
   if ((HEAPU16[i9 + (i1 << 1) >> 1] | 0) >>> 0 >= i8 >>> 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i10 >>> 0) break L19;
  }
  HEAP32[i2 >> 2] = i10;
  HEAP32[i2 + 4 >> 2] = i8;
  __Z12FormatStringPKcz(i12, gb + 416345 | 0, i2);
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i11 | 0) == 0 ? i12 + 4 | 0 : i11, 0, gb + 412121 | 0, 647, 1, i1, 0, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i12 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12 + 24 | 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 f3 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 44 >> 2]);
 L33 : do if (i8 | 0) {
  i1 = 0;
  while (1) {
   f5 = Math_fround(HEAPF32[i7 + (i1 << 3) >> 2]);
   if (f5 < Math_fround(0.0)) break;
   f14 = Math_fround(HEAPF32[i7 + (i1 << 3) + 4 >> 2]);
   i1 = i1 + 1 | 0;
   if (f14 > f4 | (f5 > f3 | f14 < Math_fround(0.0))) break;
   if (i1 >>> 0 >= i8 >>> 0) break L33;
  }
  HEAPF64[i11 >> 3] = +f3;
  HEAPF64[i11 + 8 >> 3] = +f4;
  __Z12FormatStringPKcz(i12, gb + 416461 | 0, i11);
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((i11 | 0) == 0 ? i12 + 4 | 0 : i11, 0, gb + 412121 | 0, 655, 1, i1, 0, 0);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i12 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i12 + 24 | 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } while (0);
 f5 = Math_fround(f3 * Math_fround(.5));
 f14 = Math_fround(f4 * Math_fround(.5));
 i11 = HEAP32[i6 + 140 >> 2] | 0;
 i12 = i6 + 80 | 0;
 HEAP32[i6 + 116 >> 2] = i11;
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i6 + 32 >> 2]));
 HEAPF32[i6 + 120 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i6 + 48 >> 2]));
 HEAP32[i6 + 124 >> 2] = i11;
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i6 + 36 >> 2]));
 HEAPF32[i6 + 128 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i6 + 52 >> 2]));
 __ZN16SpriteRenderData11SetVerticesEPK8Vector2fjRK6Sprite(i12, i7, i8, i6);
 __ZN16SpriteRenderData10SetIndicesEPKtj(i12, i9, i10);
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN4FMOD8ChannelI18UpdateDopplerPitchEv(i16) {
 i16 = i16 | 0;
 var f1 = f0, d2 = 0.0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0;
 i3 = HEAP32[i16 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i3 + 332 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 336 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 340 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f10 = Math_fround(f6 * Math_fround(f10 * Math_fround(HEAPF32[i16 + 144 >> 2])));
 if (f10 > Math_fround(0.0)) {
  f5 = Math_fround(HEAPF32[i3 + 328 >> 2]);
  f4 = Math_fround(HEAPF32[i3 + 324 >> 2]);
  f1 = Math_fround(HEAPF32[i3 + 320 >> 2]);
  f1 = Math_fround(Math_fround(HEAPF32[i16 + 76 >> 2]) - f1);
  f4 = Math_fround(Math_fround(HEAPF32[i16 + 80 >> 2]) - f4);
  f5 = Math_fround(Math_fround(HEAPF32[i16 + 84 >> 2]) - f5);
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f4 * f4)) + Math_fround(f5 * f5))));
  if (f6 > Math_fround(0.0)) {
   f18 = Math_fround(HEAPF32[i16 + 96 >> 2]);
   f17 = Math_fround(HEAPF32[i16 + 92 >> 2]);
   f1 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(f18 - f9)) + Math_fround(Math_fround(f4 * Math_fround(f17 - f8)) + Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i16 + 88 >> 2]) - f7)))) / f6);
  } else f1 = Math_fround(0.0);
  f18 = Math_fround(f12 * Math_fround(340.0));
  f1 = Math_fround(Math_fround(f18 - Math_fround(f10 * f1)) / f18);
 } else f1 = Math_fround(1.0);
 i11 = f1 < Math_fround(9.99999997e-07);
 f5 = i11 ? Math_fround(9.99999997e-07) : f1;
 i11 = i16 + 152 | 0;
 f1 = Math_fround(HEAPF32[i11 >> 2]);
 if (!(f5 != f1)) return;
 i13 = i16 + 140 | 0;
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 i3 = i16 + 161 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  d2 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i15 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
  f4 = Math_fround(HEAPF32[i13 >> 2]);
  i3 = (HEAP8[i3 >> 0] | 0) == 0;
  i14 = ~~d2 >>> 0;
  f1 = Math_fround(HEAPF32[i11 >> 2]);
 } else {
  i15 = i16 + 120 | 0;
  i3 = 0;
  i14 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 4 >> 2] | 0;
  f4 = f6;
 }
 i19 = i16 + 104 | 0;
 i20 = i19;
 i20 = _i64Subtract(i14 | 0, i15 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0) | 0;
 f18 = Math_fround(Math_fround(+(i20 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * Math_fround(Math_fround(f4 * f1) / Math_fround(44100.0)));
 i20 = +Math_abs(+f18) >= 1.0 ? (+f18 > 0.0 ? ~~+Math_min(+Math_floor(+f18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f18 - +(~~+f18 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAPF32[i13 >> 2] = f6;
 HEAPF32[i11 >> 2] = f5;
 f1 = Math_fround(f5 * f6);
 f18 = Math_fround(Math_fround(+(i14 >>> 0) + 4294967296.0 * +(i15 >>> 0)) - Math_fround(Math_fround(Math_fround(44100.0) / f1) * Math_fround(+(~~+f18 >>> 0 >>> 0) + 4294967296.0 * +(i20 >>> 0))));
 i14 = +Math_abs(+f18) >= 1.0 ? (+f18 > 0.0 ? ~~+Math_min(+Math_floor(+f18 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f18 - +(~~+f18 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i15 = i19;
 HEAP32[i15 >> 2] = ~~+f18 >>> 0;
 HEAP32[i15 + 4 >> 2] = i14;
 if (i3) d2 = +Math_fround(f1 / Math_fround(44100.0)); else d2 = 1.0e-07;
 _JS_Sound_SetPitch(HEAP32[i16 + 164 >> 2] | 0, +d2);
 return;
}

function __ZN14AnimationState12UpdateFadingEf(i13, f11) {
 i13 = i13 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, f3 = f0, d4 = 0.0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i12 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0;
 i14 = i13 + 56 | 0;
 i8 = HEAP16[i14 >> 1] | 0;
 do if (!(i8 & 32)) if ((HEAP32[i13 + 68 >> 2] | 1 | 0) == 1) {
  i10 = !(Math_fround(HEAPF32[i13 + 36 >> 2]) >= Math_fround(0.0));
  f3 = Math_fround(HEAPF32[i13 + 44 >> 2]);
  i2 = i13 + 48 | 0;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  d4 = +HEAPF64[i13 + 16 >> 3];
  if (i10) d4 = +Math_fround(f3 + f6) - d4; else d4 = d4 - +Math_fround(f3 - f6);
  f9 = Math_fround(d4);
  if (f9 > Math_fround(0.0)) {
   i10 = i13 + 8 | 0;
   f3 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = Math_fround(Math_fround(0.0) - f3);
   f7 = Math_fround(f5 / f6);
   f5 = Math_fround(f5 * Math_fround(1.0e5));
   f5 = +f6 > .001 ? f7 : f5;
   if (!(i8 & 1)) i12 = 10; else {
    f7 = Math_fround(HEAPF32[i13 + 52 >> 2]);
    i1 = f7 < Math_fround(0.0);
    f15 = Math_fround(-f7);
    if (!((i1 ? f15 : f7) <= Math_fround(.0000999999974))) i12 = 10; else {
     i1 = i13 + 76 | 0;
     f7 = Math_fround(HEAPF32[i1 >> 2]);
     i18 = f7 < Math_fround(0.0);
     f17 = Math_fround(-f7);
     i16 = f5 < Math_fround(0.0);
     f15 = Math_fround(-f5);
     if ((i18 ? f17 : f7) > (i16 ? f15 : f5)) f5 = f7; else i12 = 10;
    }
   }
   if ((i12 | 0) == 10) {
    i1 = i13 + 76 | 0;
    HEAPF32[i1 >> 2] = f5;
   }
   i18 = f5 < Math_fround(0.0);
   f17 = Math_fround(-f5);
   if ((i18 ? f17 : f5) <= Math_fround(.0000999999974)) {
    HEAPF32[i1 >> 2] = Math_fround(1.0e5);
    f6 = Math_fround(HEAPF32[i2 >> 2]);
    f5 = Math_fround(HEAPF32[i13 + 76 >> 2]);
    f3 = Math_fround(HEAPF32[i10 >> 2]);
   }
   HEAPF32[i13 + 52 >> 2] = Math_fround(0.0);
   i2 = i8 | 37;
   HEAP16[i14 >> 1] = i2;
   i18 = f6 == Math_fround(0.0);
   f3 = Math_fround(f3 + Math_fround(f9 * f5));
   HEAPF32[i10 >> 2] = f3;
   if (!i18) if (!(f5 > Math_fround(0.0) & f3 > Math_fround(0.0))) if (!(f5 <= Math_fround(0.0) & f3 < Math_fround(0.0))) {
    i1 = 0;
    i8 = i2;
    break;
   }
   HEAP32[i10 >> 2] = 0;
   i1 = i2 & -34;
   HEAP16[i14 >> 1] = i1;
   HEAP32[i13 + 80 >> 2] = HEAP32[i13 + 12 >> 2];
   i2 = i1 | 64;
   if ((i8 & 10) == 10) {
    HEAP16[i14 >> 1] = i2;
    i1 = i2;
   }
   HEAP16[i14 >> 1] = i1 & -3;
   __ZN14AnimationState7SetTimeEf(i13, Math_fround(0.0));
   i8 = HEAP16[i14 >> 1] & -6;
   HEAP16[i14 >> 1] = i8;
   i1 = 1;
  } else i1 = 0;
 } else i1 = 0; else i1 = 0; while (0);
 if (!(i8 & 1)) {
  i18 = i1;
  return i18 | 0;
 }
 f5 = Math_fround(HEAPF32[i13 + 76 >> 2]);
 f6 = Math_fround(f5 * f11);
 i1 = i13 + 8 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f6);
 HEAPF32[i1 >> 2] = f6;
 if (f5 > Math_fround(0.0)) {
  f3 = Math_fround(HEAPF32[i13 + 52 >> 2]);
  if (!(f6 > f3)) i12 = 22;
 } else i12 = 22;
 if ((i12 | 0) == 22) {
  if (!(f5 <= Math_fround(0.0))) {
   i18 = 0;
   return i18 | 0;
  }
  f3 = Math_fround(HEAPF32[i13 + 52 >> 2]);
  if (!(f6 < f3)) {
   i18 = 0;
   return i18 | 0;
  }
 }
 HEAPF32[i1 >> 2] = f3;
 i2 = i8 & -34;
 HEAP16[i14 >> 1] = i2;
 if (!(i8 & 4)) {
  i18 = 0;
  return i18 | 0;
 }
 HEAP32[i13 + 80 >> 2] = HEAP32[i13 + 12 >> 2];
 i1 = i2 | 64;
 if ((i8 & 10) == 10) HEAP16[i14 >> 1] = i1; else i1 = i2;
 HEAP16[i14 >> 1] = i1 & -3;
 __ZN14AnimationState7SetTimeEf(i13, Math_fround(0.0));
 HEAP16[i14 >> 1] = HEAP16[i14 >> 1] & -6;
 i18 = 1;
 return i18 | 0;
}

function __ZN12SoundManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 24700 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 23932 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 277 | 0)) {
    i4 = i6 + 23932 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 23932 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 23932 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 23932 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 23932 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 23932 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 23932 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = i8 + 12 | 0;
 i2 = i8 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) do {
  __ZN12SoundManager6UpdateEv(i8);
  __ZN4FMOD6System6updateEv(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0) | 0;
 } while ((HEAP32[i1 >> 2] | 0) != (i2 | 0));
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 i5 = i8 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) != (i5 | 0)) {
  i6 = i8 + 24 | 0;
  do {
   i3 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[i3 + 8 >> 2] | 0;
   i4 = i3 + 116 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) {
    if ((i3 | 0) != (i6 | 0)) {
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) i2 = i3 + 4 | 0; else {
      i7 = i3 + 4 | 0;
      HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
      HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
      HEAP32[i3 >> 2] = 0;
      HEAP32[i7 >> 2] = 0;
      i2 = i7;
     }
     i7 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = i7;
     HEAP32[i2 >> 2] = i6;
     HEAP32[i7 + 4 >> 2] = i3;
     HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
    }
    HEAP8[i4 >> 0] = 1;
   }
   i2 = i1;
  } while ((i2 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 i3 = i8 + 24 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i7 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  __ZN11SoundHandle8InstanceD2Ev(i7);
  __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63328 | 0);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) do {
  i7 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 } while ((i1 | 0) != (i8 | 0));
 HEAP32[i2 >> 2] = i8;
 HEAP32[i8 >> 2] = i8;
 i2 = i8 + 48 | 0;
 i3 = i8 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
  HEAP32[i8 + 28 >> 2] = 0;
  return;
 }
 do {
  i7 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 return;
}

function __ZN9AudioClip11CreateSoundEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i5 = i11 + 160 | 0;
 i9 = i11 + 16 | 0;
 i4 = i11 + 24 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  __ZN11SoundHandleC2Ev(i9);
  i10 = HEAP32[i9 >> 2] | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 i2 = i8 + 124 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 do if (!i6) i3 = 16; else {
  if (!(HEAP8[i6 + 40 >> 0] | 0)) {
   if (!(HEAP8[i6 + 24 >> 0] | 0)) {
    i3 = 16;
    break;
   }
   i1 = i4 + 4 + 4 | 0;
   i2 = i1 + 128 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[i4 >> 2] = 136;
   HEAP32[i4 + 72 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 32 >> 2];
   i1 = HEAP32[i8 + 36 >> 2] | 0;
   HEAP32[i4 + 12 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = Math_imul(i1 << 2, HEAP32[i6 + 28 >> 2] | 0) | 0;
   HEAP32[i4 + 44 >> 2] = fb + 428;
   HEAP32[i4 + 48 >> 2] = fb + 165;
   i1 = HEAP8[i6 + 32 >> 0] | 0 ? 1234 : 1362;
   i6 = __Z15GetSoundManagerv() | 0;
   i1 = __ZN12SoundManager19CreateSoundInternalEPKcjP22FMOD_CREATESOUNDEXINFOR11SoundHandlejP10SampleClip(i6, mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0, i1, i4, i8 + 56 | 0, 0, i8) | 0;
   if (i1 | 0) {
    i6 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
    HEAP32[i7 >> 2] = gb + 854464;
    HEAP32[i7 + 4 >> 2] = 867;
    HEAP32[i7 + 8 >> 2] = gb + 854667;
    HEAP32[i7 + 12 >> 2] = i6;
    __Z6FormatPKcz(i5, gb + 883334 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   i3 = 17;
   break;
  }
  i1 = HEAP32[i6 + 36 >> 2] | 0;
  if (!i1) {
   if (!(HEAP32[i6 + 44 >> 2] | 0)) {
    i3 = 17;
    break;
   }
   i7 = __ZN12AudioManager24CreateFMODSoundFromMovieEP9AudioClip(__Z21GetManagerFromContexti(3) | 0, i8) | 0;
   HEAP32[i9 >> 2] = __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip(__Z15GetSoundManagerv() | 0, i7, 0, i8) | 0;
   break;
  }
  if (!(HEAP8[i6 + 80 >> 0] | 0)) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
   __ZN11SoundHandleC2Ev(i9);
   break;
  }
  i5 = __Z21GetManagerFromContexti(3) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP16[i6 + 80 >> 1] | 0;
  i7 = __ZN12AudioManager22CreateFMODSoundFromWWWEP10IWWWStream15FMOD_SOUND_TYPE17FMOD_SOUND_FORMATjjbbP10SampleClip(i5, HEAP32[i6 + 36 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i8 + 32 >> 2] | 0, HEAP32[i8 + 36 >> 2] | 0, (i7 & 255) << 24 >> 24 != 0, (i7 & 65535) > 255, i8) | 0;
  HEAP32[i9 >> 2] = __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip(__Z15GetSoundManagerv() | 0, i7, 0, i8) | 0;
 } while (0);
 if ((i3 | 0) == 16) {
  __ZN10SampleClip13LoadBaseSoundEv(i8);
  i3 = 17;
 }
 if ((i3 | 0) == 17) __ZN11SoundHandleC2ERKS_(i9, i8 + 56 | 0);
 if (!i10) {
  i10 = HEAP32[i9 >> 2] | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 __Z19pop_allocation_rootv();
 i10 = HEAP32[i9 >> 2] | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z23CalculateGlobalRotation23TransformAccessReadOnly(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i10 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i12 + (i1 * 40 | 0) + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i1 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i7 = i11 + 4 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11 + 12 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 while (1) {
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i1 * 40 | 0) + 28 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i1 * 40 | 0) + 32 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i12 + (i1 * 40 | 0) + 36 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f17 * f21);
  f21 = Math_fround(f19 * f21);
  f17 = Math_fround(f19 * f17);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i24 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i6;
  f17 = Math_fround(HEAPF32[i12 + (i1 * 40 | 0) + 16 >> 2]);
  f21 = (HEAP32[tempDoublePtr >> 2] = i25 & -2147483648 ^ i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(f17 * f21);
  f19 = Math_fround(HEAPF32[i12 + (i1 * 40 | 0) + 24 >> 2]);
  f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = Math_fround(f19 * f13);
  f20 = Math_fround(HEAPF32[i12 + (i1 * 40 | 0) + 20 >> 2]);
  f18 = (HEAP32[tempDoublePtr >> 2] = i24 & -2147483648 ^ i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f20 * f18);
  f23 = Math_fround(HEAPF32[i12 + (i1 * 40 | 0) + 12 >> 2]);
  f22 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f16 = Math_fround(Math_fround(Math_fround(f16 - Math_fround(f19 * f22)) - Math_fround(f13 * f20)) - Math_fround(f18 * f23));
  f3 = Math_fround(Math_fround(Math_fround(f3 - Math_fround(f21 * f23)) - Math_fround(f20 * f22)) - Math_fround(f17 * f18));
  f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f17 * f22)) - Math_fround(f21 * f19)) - Math_fround(f13 * f23));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20)) - Math_fround(f19 * f18)) - Math_fround(f17 * f13));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = i14 ^ -2147483648;
  i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  i6 = i2 ^ -2147483648;
  i1 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) <= -1) break; else i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP32[i11 >> 2] = i4;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = i6;
 HEAPF32[i9 >> 2] = f3;
 return;
}

function __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i7, i6) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 296 | 0;
 i9 = i10;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(1.0);
 i1 = i9 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 52 >> 2] = Math_fround(1.0);
 i1 = i9 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 72 >> 2] = Math_fround(1.0);
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 112 >> 2] = Math_fround(1.0);
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 132 >> 2] = Math_fround(1.0);
 i1 = i9 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 152 >> 2] = Math_fround(1.0);
 i1 = i9 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 172 >> 2] = Math_fround(1.0);
 i1 = i9 + 176 | 0;
 i2 = i9 + 249 | 0;
 i3 = i1;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i9 + 292 | 0;
 i3 = i9 + 252 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i9 + 293 >> 0] = 0;
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i5 + 4 >> 2] | 0, gb + 1034552 | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_(i9, i2); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) {
  i2 = i5 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = i7 + 4 | 0;
  i4 = i7 + 12 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
  if (!i1) {
   i1 = _il2cpp_object_new(HEAP32[i6 >> 2] | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  }
  __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i9) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i6) >> 2] = i1;
 }
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 STACKTOP = i10;
 return;
}

function __ZN8Animator11MatchTargetERK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff(i16, i8, i14, i17, i9, f4, f10) {
 i16 = i16 | 0;
 i8 = i8 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 f10 = Math_fround(f10);
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, f13 = f0, f15 = f0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18 + 36 | 0;
 i11 = i18;
 if (i17 >>> 0 >= 6) {
  STACKTOP = i18;
  return;
 }
 i12 = i16 + 364 | 0;
 if (Math_fround(HEAPF32[i12 >> 2]) >= Math_fround(0.0)) {
  STACKTOP = i18;
  return;
 }
 if (!(HEAP8[i16 + 153 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 if (!(HEAP32[i16 + 168 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i5 = i16 + 624 | 0;
 if (__ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi(HEAP32[i5 >> 2] | 0, 0) | 0) {
  STACKTOP = i18;
  return;
 }
 f3 = Math_fround(HEAPF32[(__ZNK26AnimatorControllerPlayable21GetStateMachineMemoryEi(HEAP32[i5 >> 2] | 0, 0) | 0) + 32 >> 2]);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 f3 = Math_fround(_modff(f3, i6));
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = Math_fround(f2 + f10);
 do if (!(f3 <= f4)) if (f3 > f4 & f3 < f10) {
  f15 = f1;
  f13 = Math_fround(f3 + f2);
  break;
 } else {
  f15 = Math_fround(f1 + Math_fround(1.0));
  f13 = Math_fround(Math_fround(f2 + f4) + Math_fround(1.0));
  break;
 } else {
  f15 = f1;
  f13 = Math_fround(f2 + f4);
 } while (0);
 i5 = i11;
 i6 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i5 = i16 + 628 | 0;
 do if (__ZNK9HPlayable7IsValidEv(i5) | 0) {
  i6 = i16 + 596 | 0;
  if (__ZNK9HPlayable7IsValidEv(i5) | 0) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i7 = HEAP32[(HEAP32[i16 + 628 >> 2] | 0) + 20 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 92 >> 2] | 0, i7 | 0, i16 + 584 | 0);
    i7 = 15;
   }
  } else i7 = 15;
  if ((i7 | 0) == 15) if (!(HEAP32[i6 >> 2] | 0)) {
   i5 = 1;
   break;
  }
  __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(HEAP32[HEAP32[i16 + 584 >> 2] >> 2] | 0, 0, 0, i11) | 0;
  i5 = (HEAP32[i11 + 32 >> 2] | 0) == 0;
 } else i5 = 1; while (0);
 if (!(f13 > f10 & i5)) {
  i7 = i16 + 400 | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAPF32[i12 >> 2] = f13;
  HEAP32[i16 + 368 >> 2] = HEAP32[i11 >> 2];
  i12 = i16 + 372 | 0;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  f3 = Math_fround(HEAPF32[i14 >> 2]);
  f10 = Math_fround(f3 * f3);
  f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f4 * f4));
  f2 = Math_fround(HEAPF32[i14 + 8 >> 2]);
  f10 = Math_fround(f10 + Math_fround(f2 * f2));
  f1 = Math_fround(HEAPF32[i14 + 12 >> 2]);
  if (!(Math_fround(f10 + Math_fround(f1 * f1)) > Math_fround(0.0))) {
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f1 = Math_fround(1.0);
  }
  HEAPF32[i16 + 384 >> 2] = f3;
  HEAPF32[i16 + 388 >> 2] = f4;
  HEAPF32[i16 + 392 >> 2] = f2;
  HEAPF32[i16 + 396 >> 2] = f1;
  i16 = HEAP32[i16 + 128 >> 2] | 0;
  HEAP32[i16 + 4 >> 2] = i17;
  f10 = Math_fround(f15 + Math_fround(1.0));
  HEAPF32[i16 + 8 >> 2] = f15 < f13 ? f10 : f15;
 }
 STACKTOP = i18;
 return;
}

function __Z36UnityPropertySheet_MakeSortedTexEnvsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEER10vector_mapIS2_S4_S6_NS7_INS8_IS2_S4_EEEEE(i10, i13) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i5 = HEAP32[i10 + 8 >> 2] | 0;
 i11 = i13 + 4 | 0;
 i12 = i13 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = i1;
 if ((((HEAP32[i12 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0 < i5 >>> 0) {
  i9 = i13 + 8 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2;
  if (!i5) i4 = 0; else i4 = __Znwj(i5 * 24 | 0) | 0;
  i6 = i4 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
  i8 = i6;
  i4 = i4 + (i5 * 24 | 0) | 0;
  if ((i3 | 0) == (i7 | 0)) i2 = i8; else {
   i2 = i8;
   i1 = i6;
   do {
    i6 = i3;
    i3 = i3 + -24 | 0;
    HEAP32[i1 + -24 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i1 + -20 >> 2] = HEAP32[i6 + -20 >> 2];
    HEAP32[i1 + -16 >> 2] = HEAP32[i6 + -16 >> 2];
    HEAP32[i1 + -12 >> 2] = HEAP32[i6 + -12 >> 2];
    HEAP32[i1 + -8 >> 2] = HEAP32[i6 + -8 >> 2];
    HEAP32[i1 + -4 >> 2] = HEAP32[i6 + -4 >> 2];
    i1 = i2 + -24 | 0;
    i2 = i1;
   } while ((i3 | 0) != (i7 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i11 >> 2] = i2;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i12 >> 2] = i4;
  if (i1 | 0) __ZdlPv(i1);
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = i10 + 4 | 0;
 if ((i3 | 0) == (i5 | 0)) {
  i11 = i13 + 8 | 0;
  i12 = i13 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i13 = HEAP32[i11 >> 2] | 0;
  HEAP32[i14 >> 2] = fb + 606;
  __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_(i12, i13, i14);
  STACKTOP = i15;
  return;
 }
 i6 = i14 + 4 | 0;
 i7 = i14 + 8 | 0;
 i8 = i14 + 12 | 0;
 i9 = i14 + 16 | 0;
 i10 = i14 + 20 | 0;
 i1 = i13 + 8 | 0;
 while (1) {
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  i19 = HEAP32[i3 + 20 >> 2] | 0;
  i18 = HEAP32[i3 + 24 >> 2] | 0;
  i17 = HEAP32[i3 + 28 >> 2] | 0;
  i16 = HEAP32[i3 + 32 >> 2] | 0;
  i4 = HEAP32[i3 + 36 >> 2] | 0;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i6 >> 2] = i19;
  HEAP32[i7 >> 2] = i18;
  HEAP32[i8 >> 2] = i17;
  HEAP32[i9 >> 2] = i16;
  HEAP32[i10 >> 2] = i4;
  i4 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_9allocatorIS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i11, i14); else {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
 }
 i18 = i13 + 4 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = fb + 606;
 __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_(i18, i19, i14);
 STACKTOP = i15;
 return;
}

function _ps_unicode_value(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i2 = HEAP8[i6 >> 0] | 0;
 L1 : do if (i2 << 24 >> 24 == 117) {
  i5 = HEAP8[i6 + 1 >> 0] | 0;
  L3 : do if (i5 << 24 >> 24 == 110) if ((HEAP8[i6 + 2 >> 0] | 0) == 105) {
   i3 = HEAPU8[i6 + 3 >> 0] | 0;
   i1 = i3 + -48 | 0;
   if (i1 >>> 0 > 9) {
    i1 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
    if (i1 >>> 0 > 15) break;
   }
   i3 = HEAPU8[i6 + 4 >> 0] | 0;
   i4 = i3 + -48 | 0;
   if (i4 >>> 0 > 9) {
    i3 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
    if (i3 >>> 0 > 15) break; else i4 = i3 + (i1 << 4) | 0;
   } else i4 = i4 + (i1 << 4) | 0;
   i1 = HEAPU8[i6 + 5 >> 0] | 0;
   i3 = i1 + -48 | 0;
   if (i3 >>> 0 > 9) {
    i1 = (i1 + -65 | 0) >>> 0 > 5 ? 16 : i1 + -55 | 0;
    if (i1 >>> 0 > 15) break; else i4 = i1 + (i4 << 4) | 0;
   } else i4 = i3 + (i4 << 4) | 0;
   i1 = HEAPU8[i6 + 6 >> 0] | 0;
   i3 = i1 + -48 | 0;
   if (i3 >>> 0 > 9) {
    i1 = (i1 + -65 | 0) >>> 0 > 5 ? 16 : i1 + -55 | 0;
    if (i1 >>> 0 > 15) break; else i1 = i1 + (i4 << 4) | 0;
   } else i1 = i3 + (i4 << 4) | 0;
   switch (HEAP8[i6 + 7 >> 0] | 0) {
   case 46:
    break;
   case 0:
    {
     i7 = i1;
     return i7 | 0;
    }
   default:
    break L3;
   }
   i7 = i1 | -2147483648;
   return i7 | 0;
  } while (0);
  i3 = i5 & 255;
  i1 = i3 + -48 | 0;
  if (i1 >>> 0 > 9) {
   i1 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
   if (i1 >>> 0 > 15) {
    i1 = i6;
    break;
   }
  }
  i3 = HEAPU8[i6 + 2 >> 0] | 0;
  i4 = i3 + -48 | 0;
  if (i4 >>> 0 > 9) {
   i3 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
   if (i3 >>> 0 > 15) {
    i1 = i6;
    break;
   } else i4 = i3 + (i1 << 4) | 0;
  } else i4 = i4 + (i1 << 4) | 0;
  i1 = HEAPU8[i6 + 3 >> 0] | 0;
  i3 = i1 + -48 | 0;
  if (i3 >>> 0 > 9) {
   i1 = (i1 + -65 | 0) >>> 0 > 5 ? 16 : i1 + -55 | 0;
   if (i1 >>> 0 > 15) {
    i1 = i6;
    break;
   } else i4 = i1 + (i4 << 4) | 0;
  } else i4 = i3 + (i4 << 4) | 0;
  i1 = HEAPU8[i6 + 4 >> 0] | 0;
  i3 = i1 + -48 | 0;
  if (i3 >>> 0 > 9) {
   i1 = (i1 + -65 | 0) >>> 0 > 5 ? 16 : i1 + -55 | 0;
   if (i1 >>> 0 > 15) {
    i1 = i6;
    break;
   } else i1 = i1 + (i4 << 4) | 0;
  } else i1 = i3 + (i4 << 4) | 0;
  i5 = i6 + 5 | 0;
  i3 = HEAPU8[i5 >> 0] | 0;
  i4 = i3 + -48 | 0;
  if (i4 >>> 0 > 9) {
   i3 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
   if (i3 >>> 0 <= 15) {
    i1 = i3 + (i1 << 4) | 0;
    i7 = 32;
   }
  } else {
   i1 = i4 + (i1 << 4) | 0;
   i7 = 32;
  }
  do if ((i7 | 0) == 32) {
   i5 = i6 + 6 | 0;
   i3 = HEAPU8[i5 >> 0] | 0;
   i4 = i3 + -48 | 0;
   if (i4 >>> 0 > 9) {
    i3 = (i3 + -65 | 0) >>> 0 > 5 ? 16 : i3 + -55 | 0;
    if (i3 >>> 0 > 15) break; else i1 = i3 + (i1 << 4) | 0;
   } else i1 = i4 + (i1 << 4) | 0;
   i5 = i6 + 7 | 0;
  } while (0);
  switch (HEAP8[i5 >> 0] | 0) {
  case 46:
   break;
  case 0:
   {
    i7 = i1;
    return i7 | 0;
   }
  default:
   {
    i1 = i6;
    break L1;
   }
  }
  i7 = i1 | -2147483648;
  return i7 | 0;
 } else i1 = i6; while (0);
 L55 : while (1) {
  switch (i2 << 24 >> 24) {
  case 0:
   break L55;
  case 46:
   {
    if (i1 >>> 0 > i6 >>> 0) {
     i7 = 17;
     break L55;
    }
    break;
   }
  default:
   {}
  }
  i2 = i1 + 1 | 0;
  i1 = i2;
  i2 = HEAP8[i2 >> 0] | 0;
 }
 if ((i7 | 0) == 17) if (!i1) i1 = 0; else {
  i7 = _ft_get_adobe_glyph_index(i6, i1) | 0 | -2147483648;
  return i7 | 0;
 }
 i7 = _ft_get_adobe_glyph_index(i6, i1) | 0;
 return i7 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i5 = i11;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i4 | 0, i5 | 0, -1, ~i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i12 + 8 | 0;
   while (1) {
    i13 = i6 + (i2 << 4) | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i4 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i5 | 0) : 0) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i13 = i6 + (i1 << 4) | 0;
   return i13 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i13 = HEAP32[i11 >> 2] | 0;
  i13 = _i64Add(i13 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i13 | 0) | 0;
  i11 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i13 | 0, i11 | 0, 22) | 0;
  i13 = i10 ^ i13;
  i11 = (getTempRet0() | 0) ^ i11;
  i10 = _bitshift64Shl(i13 | 0, i11 | 0, 13) | 0;
  i10 = _i64Add(i13 | 0, i11 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i13 ^ i10 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i11 | 0, i10 | 0, 15) | 0;
  i11 = i13 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i13 = _bitshift64Shl(i11 | 0, i10 | 0, 27) | 0;
  i13 = _i64Add(i11 | 0, i10 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i13 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i1 = (i11 ^ i13) & i1 + -1;
 }
 i11 = i12 + 28 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i13 + 1;
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i13;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i13 = (HEAP32[i12 + 4 >> 2] | 0) + (i13 << 4) | 0;
 return i13 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i3 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = _i64Add(i3 | 0, i5 | 0, -1, ~i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i4 = i12 + 8 | 0;
   while (1) {
    if ((HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i5 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i6 + (i1 * 12 | 0) | 0;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = _i64Add(i10 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i10 | 0) | 0;
  i10 = getTempRet0() | 0;
  i9 = _bitshift64Lshr(i11 | 0, i10 | 0, 22) | 0;
  i11 = i9 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i9 = _bitshift64Shl(i11 | 0, i10 | 0, 13) | 0;
  i9 = _i64Add(i11 | 0, i10 | 0, ~i9 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i9 | 0, i10 | 0, 8) | 0;
  i10 = ___muldi3(i11 ^ i9 | 0, (getTempRet0() | 0) ^ i10 | 0, 9, 0) | 0;
  i9 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i10 | 0, i9 | 0, 15) | 0;
  i10 = i11 ^ i10;
  i9 = (getTempRet0() | 0) ^ i9;
  i11 = _bitshift64Shl(i10 | 0, i9 | 0, 27) | 0;
  i11 = _i64Add(i10 | 0, i9 | 0, ~i11 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i9 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i11 | 0, i9 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i9;
  i1 = (i10 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 * 12 | 0) | 0;
 return i12 | 0;
}

function __ZN23ParticleSystemParticles17SetUses3DRotationEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 HEAP8[i8 + 870 >> 0] = 1;
 i10 = HEAP32[i8 + 16 >> 2] | 0;
 i9 = i10 & 2147483647;
 i6 = HEAP32[i8 + 12 >> 2] | 0;
 i10 = i10 << 2;
 i7 = i6 << 2;
 if (!i6) {
  i1 = i8 + 300 | 0;
  i2 = i8 + 316 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i9 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i9;
   HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10, 4, i8 + 304 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 304 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 + 312 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i1 >> 2] = i7;
   break;
  } while (0);
  HEAP32[i8 + 312 >> 2] = 0;
  i1 = HEAP32[i8 + 336 >> 2] | 0;
  i2 = i8 + 320 | 0;
  i3 = i8 + 336 | 0;
  do if ((i1 & 2147483647) >>> 0 < i9 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i3 >> 2] = i9;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i10, 4, i8 + 324 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 324 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 + 332 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i9;
   HEAP32[i2 >> 2] = i10;
   break;
  } while (0);
  HEAP32[i8 + 332 >> 2] = 0;
 } else {
  i5 = 0;
  do {
   i3 = i8 + 300 + (i5 * 20 | 0) | 0;
   i4 = i8 + 300 + (i5 * 20 | 0) + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if ((i1 & 2147483647) >>> 0 < i9 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i4 >> 2] = i9;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i10, 4, i8 + 300 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, i8 + 300 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 + 300 + (i5 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i9;
    HEAP32[i3 >> 2] = i1;
    i1 = i9;
    break;
   } while (0);
   i2 = i8 + 300 + (i5 * 20 | 0) + 12 | 0;
   HEAP32[i2 >> 2] = i6;
   do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
    HEAP32[i4 >> 2] = i6;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i7, 4, i8 + 300 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i3 >> 2] = i2;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 4, i8 + 300 + (i5 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i1;
    i2 = i1;
    break;
   } else i2 = HEAP32[i3 >> 2] | 0; while (0);
   i1 = 0;
   do {
    i4 = i2 + (i1 << 2) | 0;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 2);
 }
 if (!(HEAP8[i8 + 869 >> 0] | 0)) return;
 __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i8);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 * 40 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 40 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 * 40 | 0) | 0, 0, (i5 - i4 | 0) * 40 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + ((HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034351 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN11KeyframeTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034351 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11KeyframeTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNSt3__218__time_get_storageIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 __ZNSt3__210__time_getC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i10);
 i15 = i14 + 4 | 0;
 i1 = i14 + 172 | 0;
 i3 = i15;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) == 3) break;
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  }
  i3 = i3 + 12 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i13 = i14 + 172 | 0;
 i2 = i14 + 460 | 0;
 i4 = i13;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = 0;
  while (1) {
   if ((i3 | 0) == 3) break;
   HEAP32[i4 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  }
  i4 = i4 + 12 | 0;
 } while ((i4 | 0) != (i2 | 0));
 i9 = i14 + 460 | 0;
 i3 = i14 + 484 | 0;
 i5 = i9;
 do {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i4 = 0;
  while (1) {
   if ((i4 | 0) == 3) break;
   HEAP32[i5 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  }
  i5 = i5 + 12 | 0;
 } while ((i5 | 0) != (i3 | 0));
 i8 = i14 + 484 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i8 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i7 = i14 + 496 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i7 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i6 = i14 + 508 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i6 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i5 = i14 + 520 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i5 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4525 | 0, i11 | 0, i10 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 do if (i10 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4523 | 0, i14 | 0, i11 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i4 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212ctype_bynameIwED2Ev(i11);
   break;
  } else {
   __ZNSt3__212ctype_bynameIwED2Ev(i11);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i7);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
 do {
  i3 = i3 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
 } while ((i3 | 0) != (i9 | 0));
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i13 | 0));
 do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1);
 } while ((i1 | 0) != (i15 | 0));
 __ZNSt3__210__time_getD2Ev(i14);
 ___resumeException(i4 | 0);
}

function __ZNSt3__218__time_get_storageIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 __ZNSt3__210__time_getC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14, i10);
 i15 = i14 + 4 | 0;
 i1 = i14 + 172 | 0;
 i3 = i15;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) == 3) break;
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  }
  i3 = i3 + 12 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i13 = i14 + 172 | 0;
 i2 = i14 + 460 | 0;
 i4 = i13;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = 0;
  while (1) {
   if ((i3 | 0) == 3) break;
   HEAP32[i4 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  }
  i4 = i4 + 12 | 0;
 } while ((i4 | 0) != (i2 | 0));
 i9 = i14 + 460 | 0;
 i3 = i14 + 484 | 0;
 i5 = i9;
 do {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i4 = 0;
  while (1) {
   if ((i4 | 0) == 3) break;
   HEAP32[i5 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  }
  i5 = i5 + 12 | 0;
 } while ((i5 | 0) != (i3 | 0));
 i8 = i14 + 484 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i8 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i7 = i14 + 496 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i7 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i6 = i14 + 508 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i6 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i5 = i14 + 520 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i5 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4520 | 0, i11 | 0, i10 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 do if (i10 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4517 | 0, i14 | 0, i11 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i4 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212ctype_bynameIcED2Ev(i11);
   break;
  } else {
   __ZNSt3__212ctype_bynameIcED2Ev(i11);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 do {
  i3 = i3 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 } while ((i3 | 0) != (i9 | 0));
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i13 | 0));
 do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i15 | 0));
 __ZNSt3__210__time_getD2Ev(i14);
 ___resumeException(i4 | 0);
}

function __ZN5physx2Sn25readStridedBufferPropertyINS0_8TriangleIjEEEEvRNS_9XmlReaderEPKcRPvRjSA_RNS_18XmlMemoryAllocatorE(i2, i1, i15, i3, i14, i16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i17 + 4 | 0;
 i13 = i17;
 HEAP32[i3 >> 2] = 12;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i16; else {
  HEAP32[gb + 1457164 >> 2] = (HEAP32[gb + 1457164 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i13 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i12 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i13 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i12 = 9;
   } else i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i11 = _strlen(i1) | 0;
   i10 = i1 + i11 | 0;
   if ((i11 | 0) > 0) {
    i4 = i1;
    i11 = 0;
    i5 = 0;
    i2 = 0;
    while (1) {
     if (!i4) {
      i4 = 0;
      i9 = 0;
      i8 = 0;
     } else if (!(HEAP8[i4 >> 0] | 0)) {
      i4 = 0;
      i9 = 0;
      i8 = 0;
     } else {
      i4 = _strtoul(i4, i13, 10) | 0;
      i3 = HEAP32[i13 >> 2] | 0;
      if (!i3) {
       i9 = 0;
       i8 = 0;
      } else if (!(HEAP8[i3 >> 0] | 0)) {
       i9 = 0;
       i8 = 0;
      } else {
       i3 = _strtoul(i3, i13, 10) | 0;
       i6 = HEAP32[i13 >> 2] | 0;
       if (!i6) {
        i9 = i3;
        i8 = 0;
       } else if (!(HEAP8[i6 >> 0] | 0)) {
        i9 = i3;
        i8 = 0;
       } else {
        i9 = i3;
        i8 = _strtoul(i6, i13, 10) | 0;
       }
      }
     }
     i3 = i11 + 12 | 0;
     if (i5 >>> 0 < i3 >>> 0) {
      i5 = 32;
      while (1) if (i5 >>> 0 < i3 >>> 0) i5 = i5 << 1; else break;
      i6 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i5 | 0) | 0;
      if (i11 | 0) _memcpy(i6 | 0, i2 | 0, i11 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 | 0);
      i7 = i6;
      i2 = i6;
     } else i7 = i2;
     i6 = i7 + i11 | 0;
     HEAP8[i6 >> 0] = i4;
     HEAP8[i6 + 1 >> 0] = i4 >> 8;
     HEAP8[i6 + 2 >> 0] = i4 >> 16;
     HEAP8[i6 + 3 >> 0] = i4 >> 24;
     i4 = i7 + (i11 + 4) | 0;
     HEAP8[i4 >> 0] = i9;
     HEAP8[i4 + 1 >> 0] = i9 >> 8;
     HEAP8[i4 + 2 >> 0] = i9 >> 16;
     HEAP8[i4 + 3 >> 0] = i9 >> 24;
     i4 = i7 + (i11 + 8) | 0;
     HEAP8[i4 >> 0] = i8;
     HEAP8[i4 + 1 >> 0] = i8 >> 8;
     HEAP8[i4 + 2 >> 0] = i8 >> 16;
     HEAP8[i4 + 3 >> 0] = i8 >> 24;
     i4 = HEAP32[i13 >> 2] | 0;
     if (i4 >>> 0 >= i10 >>> 0) break; else i11 = i3;
    }
    i4 = i1;
    i3 = (i3 >>> 0) / 12 | 0;
    i1 = i16;
   } else i12 = 9;
  }
  if ((i12 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i16;
  }
  HEAP32[i15 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, 0);
 STACKTOP = i17;
 return;
}

function __ZN19CollisionListener2D8PreSolveEP9b2ContactPK10b2Manifold(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 16 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1458028 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458028 | 0, i1);
  i9 = gb + 1458028 | 0;
 } else i9 = 0;
 i5 = i7 + 48 | 0;
 i6 = i7 + 52 | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 60 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 60 >> 2] | 0;
 i12 = i4;
 i11 = i8;
 i13 = (HEAP32[i4 + 4 >> 2] | 0) > (HEAP32[i8 + 4 >> 2] | 0);
 HEAP32[i1 >> 2] = i13 ? i11 : i12;
 HEAP32[i1 + 4 >> 2] = i13 ? i12 : i11;
 __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_(i2, i3 + 4 | 0, i1);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i7 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 64)) {
  __ZN10Effector2D15PreSolveContactEP9b2Contact(i7);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i13 = i2 & -5;
  HEAP32[i1 >> 2] = i13;
  i1 = i13;
 }
 HEAP8[i3 + 79 >> 0] = i1 >>> 2 & 1;
 switch (HEAP32[i3 + 72 >> 2] | 0) {
 case 5:
 case 4:
 case 1:
  {
   HEAP32[i3 + 24 >> 2] = HEAP32[i7 + 124 >> 2];
   f14 = Math_fround(HEAPF32[i7 + 128 >> 2]);
   __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f(i3 + 32 | 0, i7 + 64 | 0, (HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, f14, (HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0) + 12 | 0, Math_fround(HEAPF32[i7 + 132 >> 2]));
   if (!i4) i2 = 0; else if ((HEAP32[i4 + 72 >> 2] | 0) > 0) {
    i1 = HEAP32[(HEAP32[HEAP32[i4 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
    if (!i1) i2 = 0; else i2 = HEAP32[i1 + 148 >> 2] | 0;
   } else i2 = 0;
   if (!i8) i1 = 0; else if ((HEAP32[i8 + 72 >> 2] | 0) > 0) {
    i1 = HEAP32[(HEAP32[HEAP32[i8 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 148 >> 2] | 0;
   } else i1 = 0;
   if (!i2) i2 = __Z22GetPhysicsGroundBody2Dv() | 0; else i2 = HEAP32[i2 + 92 >> 2] | 0;
   if (!i1) i1 = __Z22GetPhysicsGroundBody2Dv() | 0; else i1 = HEAP32[i1 + 92 >> 2] | 0;
   f18 = Math_fround(HEAPF32[i2 + 72 >> 2]);
   f17 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   f14 = Math_fround(f17 - Math_fround(HEAPF32[i2 + 44 >> 2]));
   f16 = Math_fround(HEAPF32[i3 + 44 >> 2]);
   f15 = Math_fround(f18 * Math_fround(f16 - Math_fround(HEAPF32[i2 + 48 >> 2])));
   f14 = Math_fround(f18 * f14);
   f15 = Math_fround(Math_fround(HEAPF32[i2 + 64 >> 2]) - f15);
   f14 = Math_fround(f14 + Math_fround(HEAPF32[i2 + 68 >> 2]));
   f18 = Math_fround(HEAPF32[i1 + 72 >> 2]);
   f17 = Math_fround(f17 - Math_fround(HEAPF32[i1 + 44 >> 2]));
   f16 = Math_fround(f18 * Math_fround(f16 - Math_fround(HEAPF32[i1 + 48 >> 2])));
   f17 = Math_fround(f18 * f17);
   f16 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) - f16);
   f14 = Math_fround(Math_fround(f17 + Math_fround(HEAPF32[i1 + 68 >> 2])) - f14);
   HEAPF32[i3 + 64 >> 2] = Math_fround(f16 - f15);
   HEAPF32[i3 + 68 >> 2] = f14;
   break;
  }
 default:
  {}
 }
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i10;
 return;
}

function __Z56TextGenerator_CUSTOM_INTERNAL_CALL_Populate_Internal_cppP12Il2CppObjectP12Il2CppStringS0_RK10ColorRGBAfiffihhiiiihiffffhhPj(i1, i2, i17, i25, i26, f27, f28, i29, i30, i31, i11, i12, i13, i14, i15, i16, f4, f5, f6, f7, i18, i19, i20) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 f27 = Math_fround(f27);
 f28 = Math_fround(f28);
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i32 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i32 + 52 | 0;
 i9 = i32;
 i8 = i32 + 48 | 0;
 i21 = i32 + 40 | 0;
 i22 = i32 + 32 | 0;
 i23 = i32 + 16 | 0;
 i24 = i32 + 12 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i8, i2);
 HEAPF32[i21 >> 2] = f4;
 HEAPF32[i21 + 4 >> 2] = f5;
 HEAPF32[i22 >> 2] = f6;
 HEAPF32[i22 + 4 >> 2] = f7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i23, i8);
 if (!i17) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i17) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i17);
 i1 = HEAP32[i1 + 48 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i25 >> 2]);
 i17 = f7 < Math_fround(0.0);
 f7 = i17 ? Math_fround(0.0) : f7;
 i17 = f7 > Math_fround(1.0);
 HEAP8[i24 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i25 + 4 >> 2]);
 i17 = f7 < Math_fround(0.0);
 f7 = i17 ? Math_fround(0.0) : f7;
 i17 = f7 > Math_fround(1.0);
 HEAP8[i24 + 1 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i25 + 8 >> 2]);
 i17 = f7 < Math_fround(0.0);
 f7 = i17 ? Math_fround(0.0) : f7;
 i17 = f7 > Math_fround(1.0);
 HEAP8[i24 + 2 >> 0] = ~~Math_fround(Math_fround((i17 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i25 + 12 >> 2]);
 i25 = f7 < Math_fround(0.0);
 f7 = i25 ? Math_fround(0.0) : f7;
 i25 = f7 > Math_fround(1.0);
 HEAP8[i24 + 3 >> 0] = ~~Math_fround(Math_fround((i25 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 HEAP32[i10 >> 2] = HEAP32[i24 >> 2];
 __ZN20TextRenderingPrivate22ScriptingTextGenerator19GetStringRenderInfoERS0_RKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEPNS_8FontImplE11ColorRGBA32iffibbiiNS0_16VerticalWrapModeENS0_18HorizontalWrapModeEbiRK8Vector2fSI_bbbPj(i3, i23, i1, i10, i26, f27, f28, i29, i30 << 24 >> 24 != 0, i31 << 24 >> 24 != 0, i11, i12, i13, i14, i15 << 24 >> 24 != 0, i16, i21, i22, 0, i18 << 24 >> 24 != 0, i19 << 24 >> 24 != 0, i20);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i23);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i32 + 8 | 0); else {
  STACKTOP = i32;
  return HEAP8[i1 + 60 >> 0] | 0;
 }
 return 0;
}

function __Z36Cloth_Get_Custom_PropSphereCollidersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i11 = i13;
 if (!i1) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i9 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = HEAP32[i2 + 180 >> 2] | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z24GetClothScriptingClassesv() | 0) + 4 >> 2] | 0, 8, i9) | 0;
 if (!i9) {
  STACKTOP = i13;
  return i8 | 0;
 }
 i7 = i2 + 168 | 0;
 i6 = 0;
 do {
  i4 = (HEAP32[i7 >> 2] | 0) + (i6 << 3) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i11 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 13; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 15;
    }
   }
   if ((i12 | 0) == 13) i12 = 15;
   if ((i12 | 0) == 15) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  i4 = (HEAP32[i7 >> 2] | 0) + (i6 << 3) + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i11 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i2 = HEAP32[i10 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 25;
    }
   }
   if ((i12 | 0) == 23) i12 = 25;
   if ((i12 | 0) == 25) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  i14 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, i6, 8) | 0;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i14 + 4 >> 2] = i4;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i9 | 0));
 STACKTOP = i13;
 return i8 | 0;
}

function __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb(i5, i19, i20, i26, i27, i1, i2, i23, i25, i3, i4, i29, i22, i6, i28) {
 i5 = i5 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i29 = i29 | 0;
 i22 = i22 | 0;
 i6 = i6 | 0;
 i28 = i28 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i24 = 0, i30 = 0, i31 = 0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i30;
 i16 = i28 ? i4 : i3;
 i24 = i28 ? i23 : i25;
 i18 = i28 ? i1 : i2;
 i1 = i28 ? i2 : i1;
 i17 = i1 + (i16 << 4) | 0;
 if ((i16 | 0) <= 0) {
  STACKTOP = i30;
  return;
 }
 i15 = (i28 ? i3 : i4) + -1 | 0;
 i16 = i6 + 8 | 0;
 i13 = (i5 | 0) == 0;
 i14 = i6 + 28 | 0;
 i12 = i6 + 32 | 0;
 i11 = i1;
 do {
  i10 = i11 + 8 | 0;
  do if ((HEAP32[i10 >> 2] | 0) != -1) {
   i6 = HEAPU16[i11 >> 1] | 0;
   i7 = HEAPU16[i11 + 2 >> 1] | 0;
   i8 = HEAPU16[i11 + 4 >> 1] | 0;
   i9 = 0;
   do {
    i1 = (HEAPU16[gb + 222952 + (i9 * 6 | 0) >> 1] | 0) + i6 | 0;
    i3 = i1 & 65535;
    i31 = (HEAPU16[gb + 222952 + (i9 * 6 | 0) + 2 >> 1] | 0) + i7 | 0;
    i4 = i31 & 65535;
    i2 = (HEAPU16[gb + 222952 + (i9 * 6 | 0) + 4 >> 1] | 0) + i8 | 0;
    i5 = i2 & 65535;
    i2 = ((i31 << 16 >> 16) * 101 | 0) + (i1 << 16 >> 16) + ((i2 << 16 >> 16) * 7919 | 0) & i15;
    i1 = HEAP32[i18 + (i2 << 4) + 8 >> 2] | 0;
    L10 : do if ((i1 | 0) == -1) i1 = -1; else while (1) {
     if (i3 << 16 >> 16 == (HEAP16[i18 + (i2 << 4) >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i18 + (i2 << 4) + 2 >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i18 + (i2 << 4) + 4 >> 1] | 0)) break L10;
     i2 = i2 + 1 & i15;
     i1 = HEAP32[i18 + (i2 << 4) + 8 >> 2] | 0;
     if ((i1 | 0) == -1) {
      i1 = -1;
      break;
     }
    } while (0);
    HEAP32[i21 + (i9 << 2) >> 2] = (i1 | 0) == -1 ? 0 : i18 + (i2 << 4) | 0;
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != 27);
   i7 = HEAP32[i16 >> 2] | 0;
   i1 = 0;
   i6 = 0;
   do {
    i2 = HEAP32[i21 + (i6 << 2) >> 2] | 0;
    if (i2) {
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     i4 = HEAP32[i2 + 8 >> 2] | 0;
     i5 = i4 + i3 | 0;
     if (i3 >>> 0 < i5 >>> 0) {
      i2 = i1;
      while (1) {
       HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[i24 + (i3 << 2) >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 1 | 0;
      }
      i1 = i1 + i4 | 0;
     }
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != 27);
   i2 = i1;
   if (i2 | 0) {
    i1 = HEAP32[i11 + 12 >> 2] | 0;
    if (i28) {
     __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i19, i20, i26, i27, i7, i2, i25 + (i1 << 2) | 0, HEAP32[i10 >> 2] | 0, i29, i13, i22, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] | 0);
     break;
    } else {
     __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i19, i20, i26, i27, i23 + (i1 << 2) | 0, HEAP32[i10 >> 2] | 0, i7, i2, i29, i13, i22, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] | 0);
     break;
    }
   }
  } while (0);
  i11 = i11 + 16 | 0;
 } while (i11 >>> 0 < i17 >>> 0);
 STACKTOP = i30;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i8 = i11 + 8 | 0;
 i4 = i9 + 4 | 0;
 i7 = i9 + 8 | 0;
 HEAP32[i8 >> 2] = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 40 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i8) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = (i5 - i3 | 0) / 40 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj(i4, i1 - i2 | 0);
  i5 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 < i2 >>> 0) {
  i6 = i3 + (i1 * 40 | 0) | 0;
  if ((i5 | 0) != (i6 | 0)) {
   i2 = i5;
   while (1) {
    i1 = i2 + -40 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = HEAP32[i2 + -16 >> 2] | 0;
    i4 = i3;
    if (i3) {
     i1 = i2 + -12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
     __ZdlPv(i3);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i6 | 0)) {
     i5 = i6;
     break;
    } else i2 = i1;
   }
  }
 }
 do if (HEAP32[i8 >> 2] | 0) {
  i1 = i9 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i9 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i9 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L21 : do if ((i1 | 0) != (i5 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i8 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i1, i12);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i5 | 0)) break L21;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i5 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii(i1, i3, i2, i5, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i7 = i1 + 4 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i6 = i2 + 4 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i4 = i3 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i1 = i5;
 while (1) {
  i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
  i3 = i6 + (i1 * 40 | 0) + 12 | 0;
  if ((i2 | 0) == -1) break;
  f18 = Math_fround(HEAPF32[i4 + (i2 * 40 | 0) + 24 >> 2]);
  f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i2 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 12 >> 2]);
  f12 = Math_fround(f14 * f20);
  f13 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 24 >> 2]);
  f10 = Math_fround(f18 * f13);
  f19 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i2 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 16 >> 2]);
  f15 = Math_fround(f19 * f11);
  f22 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i4 + (i2 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f21 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 20 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f18 * f21)) - Math_fround(f19 * f13)) - Math_fround(f22 * f11));
  f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f22 * f20)) - Math_fround(f19 * f21)) - Math_fround(f14 * f11));
  f15 = Math_fround(Math_fround(Math_fround(f15 - Math_fround(f14 * f21)) - Math_fround(f18 * f20)) - Math_fround(f22 * f13));
  f13 = Math_fround(Math_fround(Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f19)) - Math_fround(f18 * f11)) - Math_fround(f14 * f13));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i17 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
  i16 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f13 = (HEAP32[tempDoublePtr >> 2] = i17 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f15 = Math_fround(f13 * f13);
  f12 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(f12 * f12);
  f11 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f15 + f14) + Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11))))));
  f12 = Math_fround(f14 * f12);
  f11 = Math_fround(f14 * f11);
  f10 = Math_fround(f14 * f10);
  HEAPF32[i3 >> 2] = Math_fround(f14 * f13);
  HEAPF32[i6 + (i1 * 40 | 0) + 16 >> 2] = f12;
  HEAPF32[i6 + (i1 * 40 | 0) + 20 >> 2] = f11;
  HEAPF32[i6 + (i1 * 40 | 0) + 24 >> 2] = f10;
  if ((i1 | 0) == (i8 | 0)) {
   i9 = 5;
   break;
  } else i1 = i2;
 }
 if ((i9 | 0) == 5) return;
 i9 = HEAP32[i4 + (i1 * 40 | 0) + 16 >> 2] | 0;
 i16 = HEAP32[i4 + (i1 * 40 | 0) + 20 >> 2] | 0;
 i17 = HEAP32[i4 + (i1 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + (i1 * 40 | 0) + 12 >> 2];
 HEAP32[i6 + (i1 * 40 | 0) + 16 >> 2] = i9;
 HEAP32[i6 + (i1 * 40 | 0) + 20 >> 2] = i16;
 HEAP32[i6 + (i1 * 40 | 0) + 24 >> 2] = i17;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i5 = i11;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i4 | 0, i5 | 0, -1, ~i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i12 + 8 | 0;
   while (1) {
    i13 = i6 + (i2 << 4) | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i4 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i5 | 0) : 0) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i13 = i6 + (i1 << 4) | 0;
   return i13 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i13 = HEAP32[i11 >> 2] | 0;
  i13 = _i64Add(i13 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i13 | 0) | 0;
  i11 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i13 | 0, i11 | 0, 22) | 0;
  i13 = i10 ^ i13;
  i11 = (getTempRet0() | 0) ^ i11;
  i10 = _bitshift64Shl(i13 | 0, i11 | 0, 13) | 0;
  i10 = _i64Add(i13 | 0, i11 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i13 ^ i10 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i11 | 0, i10 | 0, 15) | 0;
  i11 = i13 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i13 = _bitshift64Shl(i11 | 0, i10 | 0, 27) | 0;
  i13 = _i64Add(i11 | 0, i10 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i13 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i1 = (i11 ^ i13) & i1 + -1;
 }
 i11 = i12 + 28 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i13 + 1;
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i13;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i13 = (HEAP32[i12 + 4 >> 2] | 0) + (i13 << 4) | 0;
 return i13 | 0;
}

function __ZN5physx3Ext20DefaultCpuDispatcherC2EjPj(i9, i11, i2) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i4 = i13 + 6 | 0;
 i8 = i13 + 5 | 0;
 i10 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = gb + 87280 + 8;
 __ZN5physx3Ext20SharedQueueEntryPoolINS_6shdfnd19ReflectionAllocatorINS0_16SharedQueueEntryEEEEC2EjRKS5_(i9 + 8 | 0, 128, i13 + 8 | 0);
 i1 = HEAP32[(__ZN5physx6shdfnd9SListImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 741043 | 0 : gb + 837976 | 0) | 0, gb + 741165 | 0, 86) | 0;
 }
 HEAP32[i9 + 16 >> 2] = i1;
 __ZN5physx6shdfnd9SListImplC2Ev(i1);
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i9 + 20 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 i3 = i9 + 28 | 0;
 HEAP32[i3 >> 2] = i11;
 HEAP8[i9 + 32 >> 0] = 0;
 HEAP8[i9 + 33 >> 0] = 0;
 if (!i2) {
  i1 = i11 << 2;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13 + 7 | 0, i1, gb + 740948 | 0, 56) | 0;
  if (!i11) {
   i7 = i2;
   i6 = i2;
  } else {
   _memset(i2 | 0, 0, i1 | 0) | 0;
   i7 = i2;
   i6 = i2;
  }
 } else {
  i7 = i2;
  i6 = 0;
 }
 i5 = i9 + 4 | 0;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i11 * 28 | 0, gb + 740948 | 0, 63) | 0;
 i4 = i9 + 24 | 0;
 HEAP32[i4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, i11 << 5, gb + 740948 | 0, 65) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i2 = (i11 | 0) == 0;
 if (!i2) {
  __ZN5physx3Ext15CpuWorkerThreadC2Ev(i1);
  __ZN5physx3Ext15CpuWorkerThread10initializeEPNS0_20DefaultCpuDispatcherE(HEAP32[i5 >> 2] | 0, i9);
  if ((i11 | 0) != 1) {
   i1 = 1;
   do {
    __ZN5physx3Ext15CpuWorkerThreadC2Ev((HEAP32[i5 >> 2] | 0) + (i1 * 28 | 0) | 0);
    __ZN5physx3Ext15CpuWorkerThread10initializeEPNS0_20DefaultCpuDispatcherE((HEAP32[i5 >> 2] | 0) + (i1 * 28 | 0) | 0, i9);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i11 | 0));
  }
  if (!i2) {
   i2 = 0;
   do {
    __ZN5physx6shdfnd10ThreadImpl15setAffinityMaskEj(HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 * 28 | 0) + 4 >> 2] | 0, HEAP32[i7 + (i2 << 2) >> 2] | 0) | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i9 = __ZN5physx6shdfnd10ThreadImpl19getDefaultStackSizeEv() | 0;
    __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE(HEAP32[i1 + (i2 * 28 | 0) + 4 >> 2] | 0, i9, i1 + (i2 * 28 | 0) | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     HEAP32[i12 >> 2] = i2;
     __ZN5physx6string9sprintf_sEPcjPKcz(i1 + (i2 << 5) | 0, 32, gb + 741241 | 0, i12) | 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i11 | 0));
  }
 }
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i6);
 STACKTOP = i13;
 return;
}

function __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv(i23, i7) {
 i23 = i23 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, i25 = 0, f26 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i25;
 i24 = i7 + 400 | 0;
 i16 = i7 + 376 | 0;
 if (!(HEAP8[i24 >> 0] | 0)) {
  i24 = HEAP32[i16 >> 2] | 0;
  i18 = HEAP32[i7 + 380 >> 2] | 0;
  i19 = HEAP32[i7 + 384 >> 2] | 0;
  i20 = HEAP32[i7 + 388 >> 2] | 0;
  i21 = HEAP32[i7 + 392 >> 2] | 0;
  i22 = HEAP32[i7 + 396 >> 2] | 0;
  HEAP32[i23 >> 2] = i24;
  i24 = i23 + 4 | 0;
  HEAP32[i24 >> 2] = i18;
  i24 = i23 + 8 | 0;
  HEAP32[i24 >> 2] = i19;
  i24 = i23 + 12 | 0;
  HEAP32[i24 >> 2] = i20;
  i24 = i23 + 16 | 0;
  HEAP32[i24 >> 2] = i21;
  i24 = i23 + 20 | 0;
  HEAP32[i24 >> 2] = i22;
  STACKTOP = i25;
  return;
 }
 i1 = HEAP32[i7 + 292 >> 2] | 0;
 i2 = HEAP32[i7 + 296 >> 2] | 0;
 i3 = HEAP32[i7 + 300 >> 2] | 0;
 i4 = HEAP32[i7 + 304 >> 2] | 0;
 i5 = HEAP32[i7 + 308 >> 2] | 0;
 i6 = HEAP32[i7 + 312 >> 2] | 0;
 HEAP32[i16 >> 2] = i1;
 i17 = i7 + 380 | 0;
 HEAP32[i17 >> 2] = i2;
 i18 = i7 + 384 | 0;
 HEAP32[i18 >> 2] = i3;
 HEAP32[i7 + 388 >> 2] = i4;
 i19 = i7 + 392 | 0;
 HEAP32[i19 >> 2] = i5;
 i20 = i7 + 396 | 0;
 HEAP32[i20 >> 2] = i6;
 i13 = HEAP32[i7 + 424 >> 2] | 0;
 i22 = i7 + 428 | 0;
 if ((i13 | 0) != (HEAP32[i22 >> 2] | 0)) {
  i6 = i21 + 4 | 0;
  i14 = i21 + 8 | 0;
  i2 = i7 + 388 | 0;
  i3 = i21 + 12 | 0;
  i4 = i21 + 16 | 0;
  i5 = i21 + 20 | 0;
  i1 = i13;
  do {
   __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv(i21, HEAP32[i1 >> 2] | 0);
   f15 = Math_fround(HEAPF32[i16 >> 2]);
   f11 = Math_fround(HEAPF32[i21 >> 2]);
   f15 = f11 < f15 ? f11 : f15;
   f11 = Math_fround(HEAPF32[i17 >> 2]);
   f9 = Math_fround(HEAPF32[i6 >> 2]);
   f11 = f9 < f11 ? f9 : f11;
   f9 = Math_fround(HEAPF32[i18 >> 2]);
   f8 = Math_fround(HEAPF32[i14 >> 2]);
   f9 = f8 < f9 ? f8 : f9;
   HEAPF32[i16 >> 2] = f15;
   HEAPF32[i17 >> 2] = f11;
   HEAPF32[i18 >> 2] = f9;
   f8 = Math_fround(HEAPF32[i2 >> 2]);
   f12 = Math_fround(HEAPF32[i3 >> 2]);
   f8 = f8 < f12 ? f12 : f8;
   f12 = Math_fround(HEAPF32[i19 >> 2]);
   f10 = Math_fround(HEAPF32[i4 >> 2]);
   f12 = f12 < f10 ? f10 : f12;
   f10 = Math_fround(HEAPF32[i20 >> 2]);
   f26 = Math_fround(HEAPF32[i5 >> 2]);
   f10 = f10 < f26 ? f26 : f10;
   HEAPF32[i2 >> 2] = f8;
   HEAPF32[i19 >> 2] = f12;
   HEAPF32[i20 >> 2] = f10;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i22 >> 2] | 0));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP8[i24 >> 0] = 0;
 i24 = i1;
 i18 = i2;
 i19 = i3;
 i20 = i4;
 i21 = i5;
 i22 = i6;
 HEAP32[i23 >> 2] = i24;
 i24 = i23 + 4 | 0;
 HEAP32[i24 >> 2] = i18;
 i24 = i23 + 8 | 0;
 HEAP32[i24 >> 2] = i19;
 i24 = i23 + 12 | 0;
 HEAP32[i24 >> 2] = i20;
 i24 = i23 + 16 | 0;
 HEAP32[i24 >> 2] = i21;
 i24 = i23 + 20 | 0;
 HEAP32[i24 >> 2] = i22;
 STACKTOP = i25;
 return;
}

function __ZN17GenericDynamicVBO10AllocateVBEjR21DynamicVBOChunkHandle(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0, i1 | 0, 0) | 0;
 i9 = i14 + 32 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i11 = i14 + 84 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 do if ((i5 | 0) == 2) {
  if ((i4 | 0) == -1) {
   HEAP32[i11 >> 2] = 0;
   i1 = 0;
   break;
  }
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = i14 + 76 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = i2 + -1 + i1 | 0;
   i1 = i1 - ((i1 >>> 0) % (i2 >>> 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
  }
  if ((i1 + i15 | 0) >>> 0 < (HEAP32[(HEAP32[(HEAP32[i14 + 36 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 24 >> 2] | 0) >>> 0) i1 = i4; else {
   i1 = i4 + 1 | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
  }
 } else {
  i1 = i4 + 1 | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i14 + 76 >> 2] = 0;
 } while (0);
 i10 = i14 + 36 | 0;
 i8 = i14 + 48 | 0;
 if ((HEAP32[i8 >> 2] | 0) >>> 0 > i1 >>> 0) i4 = i5; else {
  i2 = HEAP32[i14 + 28 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 220 >> 2] | 0, i2 | 0) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i14 + 52 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i14 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i8 >> 2] = i4;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i5 = HEAP32[i14 + 92 >> 2] | 0;
 i5 = i5 >>> 0 > i15 >>> 0 ? i5 : i15;
 i1 = HEAP32[(HEAP32[i14 + 36 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 switch (i4 | 0) {
 case 4:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i2 | 0) != (i5 | 0)) {
    i3 = i5;
    i13 = 21;
   }
   break;
  }
 case 1:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i2 | 0) != (i5 | 0)) {
    i3 = i5;
    i13 = 21;
   }
   break;
  }
 default:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if (i2 >>> 0 < i5 >>> 0) {
    i3 = i5 + -1 | 0;
    i3 = i3 >>> 16 | i3;
    i3 = i3 >>> 8 | i3;
    i3 = i3 >>> 4 | i3;
    i3 = i3 >>> 2 | i3;
    i3 = (i3 >>> 1 | i3) + 1 | 0;
    i13 = 21;
   } else {
    i1 = i2;
    i13 = 23;
   }
  }
 }
 if ((i13 | 0) == 21) if (!i3) {
  i1 = i2;
  i13 = 23;
 } else {
  i13 = HEAP32[i14 + 28 >> 2] | 0;
  mftCall_viiiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 224 >> 2] | 0, i13 | 0, i1 | 0, i4 | 0, 1, i3 | 0, 0, 0);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  i13 = 23;
 }
 do if ((i13 | 0) == 23) if (i1 >>> 0 < i5 >>> 0) {
  i15 = 0;
  return i15 | 0;
 } else {
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) >> 2] | 0;
  break;
 } while (0);
 HEAP32[i12 + 20 >> 2] = i1;
 i13 = HEAP32[i14 + 28 >> 2] | 0;
 i15 = mftCall_iiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 228 >> 2] | 0, i13 | 0, i1 | 0, HEAP32[i14 + 76 >> 2] | 0, i15 | 0) | 0;
 return i15 | 0;
}

function __ZN17GenericDynamicVBO10AllocateIBEjR21DynamicVBOChunkHandle(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0, i1 | 0, 0) | 0;
 i9 = i14 + 32 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i11 = i14 + 88 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 do if ((i5 | 0) == 2) {
  if ((i4 | 0) == -1) {
   HEAP32[i11 >> 2] = 0;
   i1 = 0;
   break;
  }
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = i14 + 80 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i1 = i2 + -1 + i1 | 0;
   i1 = i1 - ((i1 >>> 0) % (i2 >>> 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
  }
  if ((i1 + i15 | 0) >>> 0 < (HEAP32[(HEAP32[(HEAP32[i14 + 56 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 24 >> 2] | 0) >>> 0) i1 = i4; else {
   i1 = i4 + 1 | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
  }
 } else {
  i1 = i4 + 1 | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i14 + 80 >> 2] = 0;
 } while (0);
 i10 = i14 + 56 | 0;
 i8 = i14 + 68 | 0;
 if ((HEAP32[i8 >> 2] | 0) >>> 0 > i1 >>> 0) i4 = i5; else {
  i2 = HEAP32[i14 + 28 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 216 >> 2] | 0, i2 | 0) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i14 + 72 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i14 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i8 >> 2] = i4;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i5 = HEAP32[i14 + 96 >> 2] | 0;
 i5 = i5 >>> 0 > i15 >>> 0 ? i5 : i15;
 i1 = HEAP32[(HEAP32[i14 + 56 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 switch (i4 | 0) {
 case 4:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i2 | 0) != (i5 | 0)) {
    i3 = i5;
    i13 = 21;
   }
   break;
  }
 case 1:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if ((i2 | 0) != (i5 | 0)) {
    i3 = i5;
    i13 = 21;
   }
   break;
  }
 default:
  {
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if (i2 >>> 0 < i5 >>> 0) {
    i3 = i5 + -1 | 0;
    i3 = i3 >>> 16 | i3;
    i3 = i3 >>> 8 | i3;
    i3 = i3 >>> 4 | i3;
    i3 = i3 >>> 2 | i3;
    i3 = (i3 >>> 1 | i3) + 1 | 0;
    i13 = 21;
   } else {
    i1 = i2;
    i13 = 23;
   }
  }
 }
 if ((i13 | 0) == 21) if (!i3) {
  i1 = i2;
  i13 = 23;
 } else {
  i13 = HEAP32[i14 + 28 >> 2] | 0;
  mftCall_viiiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 224 >> 2] | 0, i13 | 0, i1 | 0, i4 | 0, 1, i3 | 0, 0, 0);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  i13 = 23;
 }
 do if ((i13 | 0) == 23) if (i1 >>> 0 < i5 >>> 0) {
  i15 = 0;
  return i15 | 0;
 } else {
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) >> 2] | 0;
  break;
 } while (0);
 HEAP32[i12 + 24 >> 2] = i1;
 i13 = HEAP32[i14 + 28 >> 2] | 0;
 i15 = mftCall_iiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 228 >> 2] | 0, i13 | 0, i1 | 0, HEAP32[i14 + 80 >> 2] | 0, i15 | 0) | 0;
 return i15 | 0;
}

function __ZN12VRGfxHelpers13BlitLeftRightEP13RenderTextureS1_S1_(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19 + 212 | 0;
 i13 = i19 + 208 | 0;
 i14 = i19 + 204 | 0;
 i15 = i19 + 200 | 0;
 i16 = i19 + 4 | 0;
 i17 = i19;
 i18 = __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0;
 if (!i18) {
  STACKTOP = i19;
  return;
 }
 i12 = __Z12GetGfxDevicev() | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 i7 = 0;
 do {
  i1 = (i7 | 0) == 0 ? i10 : i11;
  i2 = (i1 | 0) != 0;
  if (i2) {
   HEAP32[i13 >> 2] = HEAP32[gb + 1469332 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
   if (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i18, i9) | 0) {
    HEAP32[i14 >> 2] = HEAP32[gb + 1469332 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
    __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i18, i9, i1);
    HEAP32[i15 >> 2] = HEAP32[gb + 1469332 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
    __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i18, i9, gb + 62472 | 0, gb + 1162356 | 0);
    i8 = 1;
   } else i8 = 0;
  } else i8 = 0;
  __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i16, __Z12GetGfxDevicev() | 0);
  __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
  f3 = Math_fround(Math_fround(i7 | 0) * Math_fround(.5));
  if (i2) i1 = Math_fround(HEAPF32[i1 + 72 >> 2]) < Math_fround(0.0); else i1 = 0;
  f6 = i1 ? Math_fround(1.0) : Math_fround(0.0);
  f4 = i1 ? Math_fround(0.0) : Math_fround(1.0);
  i2 = __ZNK8Material12GetPassCountEv(i18) | 0;
  if ((i2 | 0) > 0) {
   f5 = Math_fround(f3 + Math_fround(0.0));
   f3 = Math_fround(f3 + Math_fround(.5));
   i1 = 0;
   do {
    i20 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i18, i1, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
    mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 580 >> 2] | 0, i12 | 0, 2, i20 | 0);
    mftCall_viffff(HEAP32[(HEAP32[i12 >> 2] | 0) + 568 >> 2] | 0, i12 | 0, 1.0, 1.0, 1.0, 1.0);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 572 >> 2] | 0, i12 | 0, 0.0, +f6, 0.0);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 560 >> 2] | 0, i12 | 0, +f5, 0.0, .100000001);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 572 >> 2] | 0, i12 | 0, 0.0, +f4, 0.0);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 560 >> 2] | 0, i12 | 0, +f5, 1.0, .100000001);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 572 >> 2] | 0, i12 | 0, 1.0, +f4, 0.0);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 560 >> 2] | 0, i12 | 0, +f3, 1.0, .100000001);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 572 >> 2] | 0, i12 | 0, 1.0, +f6, 0.0);
    mftCall_vifff(HEAP32[(HEAP32[i12 >> 2] | 0) + 560 >> 2] | 0, i12 | 0, +f3, 0.0, .100000001);
    mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 584 >> 2] | 0, i12 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  if (i8) {
   HEAP32[i17 >> 2] = HEAP32[gb + 1469332 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i17 >> 2];
   __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i18, i9, 0);
  }
  __ZN22DeviceMVPMatricesStateD2Ev(i16);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 2);
 STACKTOP = i19;
 return;
}

function __Z11SkinGenericILi1ELb1ELb1EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, i30 = 0;
 i7 = HEAP32[i1 + 68 >> 2] | 0;
 i8 = HEAP32[i1 + 40 >> 2] | 0;
 i9 = HEAP32[i1 + 44 >> 2] | 0;
 i10 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 if ((i10 | 0) <= 0) return;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 while (1) {
  i30 = HEAP32[i1 >> 2] | 0;
  i11 = i2 + i5 | 0;
  i12 = i2 + i6 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i30 << 6) >> 2]);
  f22 = Math_fround(HEAPF32[i2 >> 2]);
  f21 = Math_fround(f13 * f22);
  f29 = Math_fround(HEAPF32[i7 + (i30 << 6) + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f29 * f23));
  f15 = Math_fround(HEAPF32[i7 + (i30 << 6) + 32 >> 2]);
  f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f21 = Math_fround(f21 + Math_fround(f15 * f19));
  f21 = Math_fround(Math_fround(HEAPF32[i7 + (i30 << 6) + 48 >> 2]) + f21);
  f28 = Math_fround(HEAPF32[i7 + (i30 << 6) + 4 >> 2]);
  f20 = Math_fround(f22 * f28);
  f27 = Math_fround(HEAPF32[i7 + (i30 << 6) + 20 >> 2]);
  f20 = Math_fround(f20 + Math_fround(f23 * f27));
  f14 = Math_fround(HEAPF32[i7 + (i30 << 6) + 36 >> 2]);
  f20 = Math_fround(f20 + Math_fround(f19 * f14));
  f20 = Math_fround(Math_fround(HEAPF32[i7 + (i30 << 6) + 52 >> 2]) + f20);
  f26 = Math_fround(HEAPF32[i7 + (i30 << 6) + 8 >> 2]);
  f22 = Math_fround(f22 * f26);
  f24 = Math_fround(HEAPF32[i7 + (i30 << 6) + 24 >> 2]);
  f23 = Math_fround(f22 + Math_fround(f23 * f24));
  f22 = Math_fround(HEAPF32[i7 + (i30 << 6) + 40 >> 2]);
  f19 = Math_fround(f23 + Math_fround(f19 * f22));
  f19 = Math_fround(Math_fround(HEAPF32[i7 + (i30 << 6) + 56 >> 2]) + f19);
  f23 = Math_fround(HEAPF32[i11 >> 2]);
  f18 = Math_fround(f13 * f23);
  f25 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f29 * f25));
  f16 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f15 * f16));
  f17 = Math_fround(Math_fround(Math_fround(f28 * f23) + Math_fround(f27 * f25)) + Math_fround(f14 * f16));
  f16 = Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f24 * f25)) + Math_fround(f22 * f16));
  f25 = Math_fround(HEAPF32[i12 >> 2]);
  f13 = Math_fround(f13 * f25);
  f23 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f29 = Math_fround(f13 + Math_fround(f29 * f23));
  f13 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f15 = Math_fround(f29 + Math_fround(f15 * f13));
  f14 = Math_fround(Math_fround(Math_fround(f28 * f25) + Math_fround(f27 * f23)) + Math_fround(f14 * f13));
  f13 = Math_fround(Math_fround(Math_fround(f26 * f25) + Math_fround(f24 * f23)) + Math_fround(f22 * f13));
  HEAPF32[i3 >> 2] = f21;
  HEAPF32[i3 + 4 >> 2] = f20;
  HEAPF32[i3 + 8 >> 2] = f19;
  i11 = i3 + i5 | 0;
  HEAPF32[i11 >> 2] = f18;
  HEAPF32[i11 + 4 >> 2] = f17;
  HEAPF32[i11 + 8 >> 2] = f16;
  i11 = i3 + i6 | 0;
  HEAPF32[i11 >> 2] = f15;
  HEAPF32[i11 + 4 >> 2] = f14;
  HEAPF32[i11 + 8 >> 2] = f13;
  HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i10 | 0)) break; else {
   i2 = i2 + i8 | 0;
   i3 = i3 + i9 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPcic(i8, i3, i1, i6) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i2 | 0, i8 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i4 = 23;
 } else L4 : do if (HEAP8[i2 >> 0] | 0) {
  do if ((i1 | 0) > 0) {
   i5 = i1 + -1 | 0;
   while (1) {
    if ((HEAP32[i7 >> 2] | 0) >= (i5 | 0)) {
     i1 = 0;
     i4 = 19;
     break;
    }
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (i4 & 1) {
      i4 = 12;
      break;
     }
     if ((i1 | 0) == -1) {
      i1 = 2;
      i4 = 19;
      break;
     }
    } else i1 = HEAPU8[i2 >> 0] | 0;
    i1 = i1 & 255;
    if (i1 << 24 >> 24 == i6 << 24 >> 24) {
     i1 = 0;
     i4 = 19;
     break;
    }
    i4 = i3 + 1 | 0;
    HEAP8[i3 >> 0] = i1;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i3 = __THREW__;
     __THREW__ = 0;
     if (i3 & 1) {
      i4 = 18;
      break;
     } else {
      i3 = i4;
      continue;
     }
    } else {
     HEAP32[i2 >> 2] = i3 + 1;
     i3 = i4;
     continue;
    }
   }
   if ((i4 | 0) == 12) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   } else if ((i4 | 0) == 18) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   } else if ((i4 | 0) == 19) {
    HEAP8[i3 >> 0] = 0;
    i6 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | ((HEAP32[i7 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break L4;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   }
  } else {
   i7 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 4 | 0);
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) break L4;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  i4 = 23;
  break L1;
 } while (0); while (0);
 do if ((i4 | 0) == 23) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 L16 : do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 425225 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (i8 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferIN8LODGroup11LODRendererEEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i8 | 0)) break L16;
   }
  }
  i2 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  L23 : do if ((i1 | 0) != (i8 | 0)) {
   i3 = 0;
   while (1) {
    i3 = (Math_imul(i3, i5) | 0) + i7 | 0;
    HEAP32[i2 + 20 >> 2] = i3;
    HEAP32[i2 + 12 >> 2] = i3;
    __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
    i3 = i10;
    i9 = HEAP32[i3 + 4 >> 2] | 0;
    i2 = i2 + 24 | 0;
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = i9;
    i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 425237 | 0, gb + 425246 | 0, i10, 1) | 0;
    if (i2 | 0) {
     if ((i2 | 0) > 0) __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
      i2 = HEAP32[i10 >> 2] | 0;
      if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i12);
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i8 | 0)) break L23;
    i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi(i7, i1, i2, i8, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i9;
 i6 = i7 + 12 | 0;
 HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i1 = i7 + 16 | 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i2 = i7 + 20 | 0;
 HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i3 = i7 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i4 = i7 + 28 | 0;
 HEAPF32[i4 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i5 = i7 + 32 | 0;
 HEAPF32[i5 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAP32[i7 + 36 >> 2] = i8;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP32[i7 + 40 >> 2] = (i13 | 0) == 0 ? 0 : (HEAP32[i8 + 28 >> 2] | 0) + i13 | 0;
 i13 = HEAP32[i8 + 52 >> 2] | 0;
 HEAP32[i7 + 44 >> 2] = i13;
 i24 = i8 + 56 | 0;
 HEAP32[i6 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i23 = i7 + 24 | 0;
 i21 = i8 + 68 | 0;
 HEAP32[i23 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i23 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i23 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i7 + 48 >> 2] = (1 << i13) + -1;
 i23 = i9 >>> 1 & 3;
 i21 = ((i23 + 1 | 0) >>> 0) % 3 | 0;
 i20 = ((i23 + 2 | 0) >>> 0) % 3 | 0;
 HEAP32[i7 + 56 + (i23 << 2) >> 2] = -1;
 HEAP32[i7 + 56 + (i21 << 2) >> 2] = 0;
 HEAP32[i7 + 56 + (i20 << 2) >> 2] = 1;
 i9 = i9 >> 1;
 i23 = (i9 + 1 | 0) % 3 | 0;
 f14 = Math_fround(HEAPF32[i24 + (i23 << 2) >> 2]);
 i9 = (i9 + 2 | 0) % 3 | 0;
 f19 = Math_fround(HEAPF32[i24 + (i9 << 2) >> 2]);
 i8 = i8 + 68 | 0;
 f15 = Math_fround(HEAPF32[i8 + (i23 << 2) >> 2]);
 f17 = Math_fround(HEAPF32[i8 + (i9 << 2) >> 2]);
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i6 >> 2]));
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i1 >> 2]));
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i10 >> 2] = f22;
 HEAPF32[i10 + 4 >> 2] = f18;
 HEAPF32[i10 + 8 >> 2] = f16;
 f16 = Math_fround(HEAPF32[i6 + (i21 << 2) >> 2]);
 f14 = Math_fround(f14 - f16);
 f18 = Math_fround(HEAPF32[i10 + (i21 << 2) >> 2]);
 f14 = Math_fround(f14 / f18);
 f18 = Math_fround(Math_fround(f15 - f16) / f18);
 f16 = Math_fround(HEAPF32[i6 + (i20 << 2) >> 2]);
 f19 = Math_fround(f19 - f16);
 f15 = Math_fround(HEAPF32[i10 + (i20 << 2) >> 2]);
 i6 = ~~Math_fround(Math_fround(f19 / f15) * Math_fround(65535.0));
 i8 = ~~Math_fround(f18 * Math_fround(65535.0));
 i9 = ~~Math_fround(Math_fround(Math_fround(f17 - f16) / f15) * Math_fround(65535.0));
 i10 = i11;
 HEAP32[i10 >> 2] = ~~Math_fround(f14 * Math_fround(65535.0));
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = i11 + 8 | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 if (i13 | 0) __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE(i7, 0, i11);
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, -1, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 471352 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN9ShaderLab21SerializedBindChannel8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 471352 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab21SerializedBindChannel8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorINS_4pairI14ConstantStringP11AssetBundleEENS_9allocatorIS5_EEE6insertENS_11__wrap_iterIPKS5_EERSA_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i4 = i9;
 i8 = (HEAP32[i1 >> 2] | 0) - i4 >> 3;
 i1 = i9 + (i8 << 3) | 0;
 i12 = i11 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i6 = i11 + 8 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i5 = i3;
 i7 = i10;
 if (i3 >>> 0 < i10 >>> 0) {
  if ((i1 | 0) == (i3 | 0)) {
   HEAP32[i1 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i1, i2);
   HEAP32[i9 + (i8 << 3) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 8;
   i12 = i1;
   return i12 | 0;
  }
  i6 = i5 - (i1 + 8) >> 3;
  i4 = i1 + (i6 << 3) | 0;
  if (i4 >>> 0 < i3 >>> 0) {
   i5 = i4;
   i7 = i3;
   do {
    HEAP32[i7 >> 2] = 0;
    __ZN14ConstantString6assignERKS_(i7, i5);
    HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    i5 = i5 + 8 | 0;
    i7 = (HEAP32[i12 >> 2] | 0) + 8 | 0;
    HEAP32[i12 >> 2] = i7;
   } while (i5 >>> 0 < i3 >>> 0);
  }
  if (i6 | 0) do {
   i11 = i3;
   i3 = i3 + -8 | 0;
   i10 = i4;
   i4 = i4 + -8 | 0;
   __ZN14ConstantStringaSERKS_(i3, i4);
   HEAP32[i11 + -4 >> 2] = HEAP32[i10 + -4 >> 2];
  } while ((i4 | 0) != (i1 | 0));
  if (i1 >>> 0 <= i2 >>> 0) i2 = (HEAP32[i12 >> 2] | 0) >>> 0 > i2 >>> 0 ? i2 + 8 | 0 : i2;
  __ZN14ConstantStringaSERKS_(i1, i2);
  HEAP32[i9 + (i8 << 3) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i12 = i1;
  return i12 | 0;
 }
 i5 = (i5 - i4 >> 3) + 1 | 0;
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i10 = i6;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  i10 = i6;
  i3 = i7;
 }
 i6 = i3 - i4 | 0;
 i8 = i6 >> 2;
 i8 = i6 >> 3 >>> 0 < 268435455 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 536870911;
 i5 = i1 - i4 | 0;
 i6 = i5 >> 3;
 if (!i8) i9 = 0; else i9 = __Znwj(i8 << 3) | 0;
 i7 = i9 + (i6 << 3) | 0;
 i4 = i7;
 i3 = i9 + (i8 << 3) | 0;
 do if ((i6 | 0) == (i8 | 0)) {
  if ((i5 | 0) > 0) {
   i4 = i7 + (((i8 + 1 | 0) / -2 | 0) << 3) | 0;
   break;
  }
  i3 = i8 << 3 >> 2;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i8 = __Znwj(i3 << 3) | 0;
  i4 = i8 + (i3 >>> 2 << 3) | 0;
  i3 = i8 + (i3 << 3) | 0;
  if (i9) __ZdlPv(i9);
 } while (0);
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i5, i2);
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i5 + 8 | 0;
 i5 = i2;
 i9 = i4;
 i8 = HEAP32[i11 >> 2] | 0;
 if ((i8 | 0) == (i1 | 0)) i6 = i9; else {
  i7 = i1;
  i6 = i9;
  do {
   i14 = i6 + -8 | 0;
   i13 = i7;
   i7 = i7 + -8 | 0;
   HEAP32[i14 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i14, i7);
   HEAP32[i6 + -4 >> 2] = HEAP32[i13 + -4 >> 2];
   i6 = i4 + -8 | 0;
   i4 = i6;
  } while ((i7 | 0) != (i8 | 0));
 }
 i7 = HEAP32[i12 >> 2] | 0;
 if ((i7 | 0) == (i1 | 0)) i4 = i6; else {
  do {
   HEAP32[i2 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i2, i1);
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i1 = i1 + 8 | 0;
   i2 = i5 + 8 | 0;
   i5 = i2;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i10 >> 2] = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -8 | 0;
  __ZN14ConstantStringD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i2) {
  i14 = i9;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i9;
 return i14 | 0;
}

function __ZNK8VRDevice13GetViewMatrixEPK6Camera21MonoOrStereoscopicEye(i11, i4, i12, i5) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 88 | 0;
 i1 = i14 + 16 | 0;
 i13 = i14;
 i7 = i14 + 80 | 0;
 if ((HEAP16[gb + 1469216 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i12;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469216 | 0, i9);
  i10 = gb + 1469216 | 0;
 } else i10 = 0;
 i6 = HEAP32[i4 + 280 >> 2] | 0;
 if (!i6) {
  i3 = i11;
  i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i12) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  if ((i5 | 0) != 2) {
   f16 = Math_fround(Math_fround(Math_fround(i5 >>> 0) * Math_fround(2.0)) + Math_fround(-1.0));
   f15 = HEAP8[i4 + 165 >> 0] | 0 ? Math_fround(-1.0) : Math_fround(1.0);
   f16 = Math_fround(f16 * Math_fround(.5));
   f15 = Math_fround(Math_fround(f16 * Math_fround(__ZNK6Camera19GetStereoSeparationEv(i12))) * f15);
   i13 = i11 + 48 | 0;
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f15);
  }
 } else {
  switch (i5 | 0) {
  case 0:
   {
    i4 = gb + 1044481 | 0;
    break;
   }
  case 1:
   {
    i4 = gb + 1044494 | 0;
    break;
   }
  case 3:
  case 2:
   {
    i4 = gb + 1044508 | 0;
    break;
   }
  case 4:
   {
    i4 = gb + 1044304 | 0;
    break;
   }
  case 5:
   {
    i4 = gb + 1044289 | 0;
    break;
   }
  default:
   i4 = gb + 1576256 | 0;
  }
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i13 + 12 >> 2] = i2;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i13);
   i2 = HEAP32[i13 + 12 >> 2] | 0;
   i8 = 13;
  } else if (i5 >>> 0 < 11) {
   i3 = i13 + 11 | 0;
   HEAP8[i3 >> 0] = i5;
   if (!i5) {
    i2 = i13;
    i4 = i3;
   } else {
    i2 = i13;
    i8 = 15;
   }
  } else i8 = 13;
  if ((i8 | 0) == 13) {
   i3 = i5 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i13 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i13 + 4 >> 2] = i5;
   i3 = i13 + 11 | 0;
   i8 = 15;
  }
  if ((i8 | 0) == 15) {
   _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   i4 = i3;
  }
  HEAP8[i2 + i5 >> 0] = 0;
  HEAP32[i7 >> 2] = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i12 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 4 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  __ZNK7VRInput22GetWorldToCameraMatrixERK8UnityStr4PPtrI9TransformE(i1, i6, i13, i9);
  i3 = i11;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i12 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i9 + 4 >> 2] = i13;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
  }
 }
 if (!i10) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext23InternalCapsuleObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 6;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 657984 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 6) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i12 = i1 + 8 | 0;
   i11 = i2 + 8 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i12 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   HEAP32[i12 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   i12 = i2 + 56 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 56 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 64 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 64 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i12 = i4 + (i1 << 6) | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 i3 = i4 + (i1 << 6) + 8 | 0;
 i10 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i4 + (i1 << 6) + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i4 + (i1 << 6) + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i4 + (i1 << 6) + 48 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i4 + (i1 << 6) + 52 >> 2] = HEAP32[i6 + 52 >> 2];
 i3 = i6 + 56 | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i4 + (i1 << 6) + 56 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 6) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 6) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 6) | 0;
 return i12 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 450610 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI16SplashScreenLogoE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 450610 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI16SplashScreenLogoE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN15AABBTreeOverlapIN5physx2Gu12AABBAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE(i1, i23, i25, i24, i26) {
 i1 = i1 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i27 = 0, i28 = 0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, i35 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i27 + 8 | 0;
 i22 = i27;
 i15 = HEAP32[i25 + 4 >> 2] | 0;
 HEAP32[i21 >> 2] = i15;
 i16 = i24 + 16 | 0;
 i17 = i24 + 20 | 0;
 i18 = i24 + 24 | 0;
 i19 = i24 + 4 | 0;
 i20 = i24 + 8 | 0;
 i1 = 1;
 while (1) {
  i1 = i1 + -1 | 0;
  i8 = HEAP32[i21 + (i1 << 2) >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i7 = HEAP32[i8 + 8 >> 2] | 0;
  f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i8 + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
  f4 = Math_fround(Math_fround(i2 & 255 | 0) * f6);
  f5 = Math_fround(Math_fround(i3 & 255 | 0) * f6);
  f6 = Math_fround(Math_fround(i7 & 255 | 0) * f6);
  f9 = Math_fround(HEAPF32[i16 >> 2]);
  f10 = Math_fround(HEAPF32[i17 >> 2]);
  f11 = Math_fround(HEAPF32[i18 >> 2]);
  f12 = Math_fround(HEAPF32[i24 >> 2]);
  f13 = Math_fround(HEAPF32[i19 >> 2]);
  f14 = Math_fround(HEAPF32[i20 >> 2]);
  while (1) {
   f34 = Math_fround(f4 + f9);
   f31 = Math_fround(f5 + f10);
   f4 = Math_fround(f6 + f11);
   f33 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f30 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f33 = Math_fround(f33 - f12);
   f30 = Math_fround(f30 - f13);
   f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f14);
   f32 = Math_fround(-f33);
   f29 = Math_fround(-f30);
   f6 = Math_fround(-f5);
   if (!((f34 >= (f33 > f32 ? f33 : f32) ? f31 >= (f30 > f29 ? f30 : f29) : 0) & f4 >= (f5 > f6 ? f5 : f6))) break;
   i2 = i8 + 16 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!((i3 & 1 | 0) == 0 & 0 == 0)) {
    i28 = 5;
    break;
   }
   i35 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   i35 = i35 & 524287;
   i8 = i15 + (i35 * 24 | 0) | 0;
   HEAP32[i21 + (i1 << 2) >> 2] = i15 + ((i35 + 1 | 0) * 24 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i15 + (i35 * 24 | 0) + 4 >> 2] | 0;
   i7 = HEAP32[i15 + (i35 * 24 | 0) + 8 >> 2] | 0;
   f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = HEAP32[i15 + (i35 * 24 | 0) + 16 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.0000999999974));
   f4 = Math_fround(Math_fround(i2 & 255 | 0) * f6);
   f5 = Math_fround(Math_fround(i3 & 255 | 0) * f6);
   f6 = Math_fround(Math_fround(i7 & 255 | 0) * f6);
   i1 = i1 + 1 | 0;
  }
  if ((i28 | 0) == 5) {
   i28 = 0;
   i8 = HEAP32[i25 >> 2] | 0;
   i35 = _bitshift64Lshr(i3 | 0, i2 | 0, 21) | 0;
   getTempRet0() | 0;
   if (!(mftCall_iiiii(HEAP32[HEAP32[i26 >> 2] >> 2] | 0, i26 | 0, i22 | 0, i23 + (HEAP32[i8 + ((i35 & 524287) << 2) >> 2] << 3) | 0, 1) | 0)) {
    i1 = 0;
    i28 = 8;
    break;
   }
  }
  if (!i1) {
   i1 = 1;
   i28 = 8;
   break;
  }
 }
 if ((i28 | 0) == 8) {
  STACKTOP = i27;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP8[i11 >> 0] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i5 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4;
 i8 = i1 - i3 | 0;
 i2 = i8 + 1 | 0;
 i6 = i5 + 16 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i7 >> 2] = i2;
  i1 = i2 + i8 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = i9;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i5 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP8[i11 + 1 >> 0] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3;
 i7 = i1 - i4 | 0;
 i2 = i7 + 1 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i9;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i9 = i11 + 2 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i12 = i1;
 i7 = i2 - i12 | 0;
 i3 = i7 + 2 | 0;
 i8 = i4 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i12 | 0) >>> 0 > i3 >>> 0) {
  i12 = i2;
  i11 = HEAP8[i9 >> 0] | 0;
  HEAP8[i12 >> 0] = i11;
  i11 = i9 + 1 | 0;
  i11 = HEAP8[i11 >> 0] | 0;
  i12 = i12 + 1 | 0;
  HEAP8[i12 >> 0] = i11;
  i12 = HEAP32[i5 >> 2] | 0;
  i12 = i12 + 2 | 0;
  HEAP32[i5 >> 2] = i12;
  return;
 }
 i3 = i3 << 1;
 if (!i3) i2 = 0; else {
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i4 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (i1 | 0) {
  _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i12 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
  }
 }
 HEAP32[i6 >> 2] = i2;
 i12 = i2 + i7 | 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i8 >> 2] = i2 + i3;
 i11 = HEAP8[i9 >> 0] | 0;
 HEAP8[i12 >> 0] = i11;
 i11 = i9 + 1 | 0;
 i11 = HEAP8[i11 >> 0] | 0;
 i12 = i12 + 1 | 0;
 HEAP8[i12 >> 0] = i11;
 i12 = HEAP32[i5 >> 2] | 0;
 i12 = i12 + 2 | 0;
 HEAP32[i5 >> 2] = i12;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j(i18, i2, i3, i1) {
 i18 = i18 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 56 | 0;
 i5 = i19 + 24 | 0;
 i10 = i19 + 16 | 0;
 i4 = i19 + 8 | 0;
 i14 = i19;
 i8 = i19 + 44 | 0;
 i9 = i19 + 32 | 0;
 i6 = i1 * 3 | 0;
 i16 = i18 + 432 | 0;
 i17 = i18 + 436 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 i13 = i2;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = i7 - i6 | 0;
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj(i5, i15, i11);
 i10 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i3;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i14;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj(i4, i15, i11);
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i11;
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = HEAP32[i17 >> 2] | 0;
 i4 = i5;
 i15 = i10;
 i10 = (i5 - i10 | 0) / 12 | 0;
 i5 = i6 - i7 + i3 + i10 | 0;
 if (!(i5 | i3)) {
  STACKTOP = i19;
  return;
 }
 i12 = i18 + 440 | 0;
 i2 = HEAP32[i12 >> 2] & 2147483647;
 i13 = i18 + 444 | 0;
 i14 = i18 + 452 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i20 = i1 & 2147483647;
 if (i5 >>> 0 > (i2 >>> 0 < i20 >>> 0 ? i2 : i20) >>> 0) {
  if (i2 >>> 0 < i5 >>> 0) {
   __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i16, i5);
   i1 = HEAP32[i14 >> 2] | 0;
  }
  if ((i1 & 2147483647) >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i13, i5);
 }
 i20 = i3 - i7 + i6 | 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i16, i20, i8);
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i13, i20, i9);
 if ((i4 | 0) != (i15 | 0)) {
  i3 = i18 + 448 | 0;
  i4 = 0;
  do {
   i1 = i15 + (i4 * 12 | 0) | 0;
   i2 = HEAP32[i17 >> 2] | 0;
   if ((HEAP32[i12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i20 = HEAP32[i16 >> 2] | 0;
    HEAP32[i20 + (i2 * 12 | 0) >> 2] = HEAP32[i1 >> 2];
    HEAP32[i20 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i15 + (i4 * 12 | 0) + 4 >> 2];
    HEAP32[i20 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i15 + (i4 * 12 | 0) + 8 >> 2];
    HEAP32[i17 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_(i16, i1) | 0;
   i1 = i11 + (i4 * 12 | 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i14 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    i20 = HEAP32[i13 >> 2] | 0;
    HEAP32[i20 + (i2 * 12 | 0) >> 2] = HEAP32[i1 >> 2];
    HEAP32[i20 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i11 + (i4 * 12 | 0) + 4 >> 2];
    HEAP32[i20 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i11 + (i4 * 12 | 0) + 8 >> 2];
    HEAP32[i3 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_(i13, i1) | 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i10 >>> 0);
 }
 HEAP32[i18 + 540 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZN21ArchiveStorageCreator10AppendDataEPKvj(i1, i12, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14;
 i2 = i14 + 4 | 0;
 if (!(HEAP8[i1 + 1320 >> 0] | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 490305 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 490375 | 0, 655, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i11 = i1 + 1280 | 0;
 L9 : do if (!(HEAP16[i1 + 1316 >> 1] & 64)) {
  i7 = i1 + 1256 | 0;
  i8 = i1 + 1284 | 0;
  i9 = i1 + 1268 | 0;
  i10 = i1 + 1272 | 0;
  i5 = 0;
  while (1) {
   if (i5 >>> 0 >= i13 >>> 0) break L9;
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i6 = i3 - i4 | 0;
   i2 = i13 - i5 | 0;
   i6 = i2 >>> 0 < i6 >>> 0 ? i2 : i6;
   if ((i4 | 0) != 0 | i6 >>> 0 < i3 >>> 0) {
    i2 = i6 + i4 | 0;
    HEAP32[i11 >> 2] = i2;
    i3 = HEAP32[i8 >> 2] | 0;
    do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
     HEAP32[i8 >> 2] = i2;
     i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2, 1, i10, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i9 >> 2] = i2;
     break;
    } else {
     i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i3 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
     HEAP32[i8 >> 2] = i2;
     HEAP32[i9 >> 2] = i3;
     i2 = i3;
     break;
    } else i2 = HEAP32[i9 >> 2] | 0; while (0);
    _memcpy(i2 + i4 | 0, i12 + i5 | 0, i6 | 0) | 0;
    i2 = HEAP32[i11 >> 2] | 0;
   } else {
    if ((HEAP32[i8 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i10);
     HEAP32[i9 >> 2] = 0;
    }
    HEAP32[i11 >> 2] = i6;
    HEAP32[i8 >> 2] = i6 | -2147483648;
    HEAP32[i9 >> 2] = i12 + i5;
    i2 = i6;
   }
   if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) i2 = __ZN21ArchiveStorageCreator10StoreChunkEv(i1) | 0; else i2 = 1;
   if ((HEAP32[i8 >> 2] | 0) <= -1) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
   }
   if (i2) i5 = i6 + i5 | 0; else {
    i1 = 0;
    break;
   }
  }
  STACKTOP = i14;
  return i1 | 0;
 } else {
  if (HEAP32[i11 >> 2] | 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 491320 | 0, 0, gb + 490375 | 0, 307, 1, 0, 0, 0);
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
  i3 = i1 + 1284 | 0;
  i4 = i1 + 1268 | 0;
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + 1272 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i11 >> 2] = i13;
  HEAP32[i3 >> 2] = i13 | -2147483648;
  HEAP32[i4 >> 2] = i12;
  i2 = __ZN21ArchiveStorageCreator11StoreStreamEb(i1, 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1 + 1272 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i11 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  if (!i2) {
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 } while (0);
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function _unity_z_adler32(i1, i4, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i2 = i1 >>> 16;
 i1 = i1 & 65535;
 if ((i3 | 0) == 1) {
  i8 = (HEAPU8[i4 >> 0] | 0) + i1 | 0;
  i8 = i8 >>> 0 > 65520 ? i8 + -65521 | 0 : i8;
  i7 = i8 + i2 | 0;
  i8 = (i7 >>> 0 > 65520 ? i7 + 15 | 0 : i7) << 16 | i8;
  return i8 | 0;
 }
 if (!i4) {
  i8 = 1;
  return i8 | 0;
 }
 if (i3 >>> 0 < 16) {
  if (i3) while (1) {
   i3 = i3 + -1 | 0;
   i1 = (HEAPU8[i4 >> 0] | 0) + i1 | 0;
   i2 = i1 + i2 | 0;
   if (!i3) break; else i4 = i4 + 1 | 0;
  }
  i8 = ((i2 >>> 0) % 65521 | 0) << 16 | (i1 >>> 0 > 65520 ? i1 + -65521 | 0 : i1);
  return i8 | 0;
 }
 if (i3 >>> 0 > 5551) {
  do {
   i3 = i3 + -5552 | 0;
   i5 = 347;
   i6 = i4;
   while (1) {
    i22 = (HEAPU8[i6 >> 0] | 0) + i1 | 0;
    i21 = i22 + (HEAPU8[i6 + 1 >> 0] | 0) | 0;
    i20 = i21 + (HEAPU8[i6 + 2 >> 0] | 0) | 0;
    i19 = i20 + (HEAPU8[i6 + 3 >> 0] | 0) | 0;
    i18 = i19 + (HEAPU8[i6 + 4 >> 0] | 0) | 0;
    i17 = i18 + (HEAPU8[i6 + 5 >> 0] | 0) | 0;
    i16 = i17 + (HEAPU8[i6 + 6 >> 0] | 0) | 0;
    i15 = i16 + (HEAPU8[i6 + 7 >> 0] | 0) | 0;
    i14 = i15 + (HEAPU8[i6 + 8 >> 0] | 0) | 0;
    i13 = i14 + (HEAPU8[i6 + 9 >> 0] | 0) | 0;
    i12 = i13 + (HEAPU8[i6 + 10 >> 0] | 0) | 0;
    i11 = i12 + (HEAPU8[i6 + 11 >> 0] | 0) | 0;
    i10 = i11 + (HEAPU8[i6 + 12 >> 0] | 0) | 0;
    i9 = i10 + (HEAPU8[i6 + 13 >> 0] | 0) | 0;
    i8 = i9 + (HEAPU8[i6 + 14 >> 0] | 0) | 0;
    i1 = i8 + (HEAPU8[i6 + 15 >> 0] | 0) | 0;
    i2 = i22 + i2 + i21 + i20 + i19 + i18 + i17 + i16 + i15 + i14 + i13 + i12 + i11 + i10 + i9 + i8 + i1 | 0;
    i5 = i5 + -1 | 0;
    if (!i5) break; else i6 = i6 + 16 | 0;
   }
   i4 = i4 + 5552 | 0;
   i1 = (i1 >>> 0) % 65521 | 0;
   i2 = (i2 >>> 0) % 65521 | 0;
  } while (i3 >>> 0 > 5551);
  if (i3) if (i3 >>> 0 > 15) i7 = 14; else i7 = 17;
 } else i7 = 14;
 if ((i7 | 0) == 14) {
  i6 = i3 + -16 | 0;
  i7 = i6 & -16;
  i8 = i7 + 16 | 0;
  i5 = i4;
  while (1) {
   i3 = i3 + -16 | 0;
   i23 = (HEAPU8[i5 >> 0] | 0) + i1 | 0;
   i9 = i23 + (HEAPU8[i5 + 1 >> 0] | 0) | 0;
   i10 = i9 + (HEAPU8[i5 + 2 >> 0] | 0) | 0;
   i11 = i10 + (HEAPU8[i5 + 3 >> 0] | 0) | 0;
   i12 = i11 + (HEAPU8[i5 + 4 >> 0] | 0) | 0;
   i13 = i12 + (HEAPU8[i5 + 5 >> 0] | 0) | 0;
   i14 = i13 + (HEAPU8[i5 + 6 >> 0] | 0) | 0;
   i15 = i14 + (HEAPU8[i5 + 7 >> 0] | 0) | 0;
   i16 = i15 + (HEAPU8[i5 + 8 >> 0] | 0) | 0;
   i17 = i16 + (HEAPU8[i5 + 9 >> 0] | 0) | 0;
   i18 = i17 + (HEAPU8[i5 + 10 >> 0] | 0) | 0;
   i19 = i18 + (HEAPU8[i5 + 11 >> 0] | 0) | 0;
   i20 = i19 + (HEAPU8[i5 + 12 >> 0] | 0) | 0;
   i21 = i20 + (HEAPU8[i5 + 13 >> 0] | 0) | 0;
   i22 = i21 + (HEAPU8[i5 + 14 >> 0] | 0) | 0;
   i1 = i22 + (HEAPU8[i5 + 15 >> 0] | 0) | 0;
   i2 = i23 + i2 + i9 + i10 + i11 + i12 + i13 + i14 + i15 + i16 + i17 + i18 + i19 + i20 + i21 + i22 + i1 | 0;
   if (i3 >>> 0 <= 15) break; else i5 = i5 + 16 | 0;
  }
  i3 = i6 - i7 | 0;
  if (!i3) i7 = 18; else {
   i4 = i4 + i8 | 0;
   i7 = 17;
  }
 }
 if ((i7 | 0) == 17) while (1) {
  i3 = i3 + -1 | 0;
  i1 = (HEAPU8[i4 >> 0] | 0) + i1 | 0;
  i2 = i1 + i2 | 0;
  if (!i3) {
   i7 = 18;
   break;
  } else {
   i4 = i4 + 1 | 0;
   i7 = 17;
  }
 }
 if ((i7 | 0) == 18) {
  i2 = (i2 >>> 0) % 65521 | 0;
  i1 = (i1 >>> 0) % 65521 | 0;
 }
 i23 = i2 << 16 | i1;
 return i23 | 0;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_RNS3_18ImpulseAccumulatorE(i2, i1, i35, i29) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i35 = i35 | 0;
 i29 = i29 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i36 = 0, i37 = 0, i38 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i40 + 448 | 0;
 i4 = i40 + 432 | 0;
 i37 = i40 + 416 | 0;
 i6 = i40 + 408 | 0;
 i31 = i40 + 392 | 0;
 i17 = i40 + 376 | 0;
 i32 = i40 + 360 | 0;
 i22 = i40 + 344 | 0;
 i33 = i40 + 328 | 0;
 i23 = i40 + 312 | 0;
 i38 = i40 + 296 | 0;
 i24 = i40 + 280 | 0;
 i25 = i40 + 264 | 0;
 i26 = i40 + 248 | 0;
 i27 = i40 + 232 | 0;
 i28 = i40 + 216 | 0;
 i7 = i40 + 200 | 0;
 i34 = i40 + 184 | 0;
 i8 = i40 + 168 | 0;
 i9 = i40 + 465 | 0;
 i10 = i40 + 152 | 0;
 i11 = i40 + 136 | 0;
 i12 = i40 + 120 | 0;
 i30 = i40 + 104 | 0;
 i13 = i40 + 88 | 0;
 i14 = i40 + 464 | 0;
 i36 = i40 + 72 | 0;
 i15 = i40 + 64 | 0;
 i39 = i40 + 48 | 0;
 i16 = i40 + 32 | 0;
 i18 = i40 + 16 | 0;
 i19 = i40;
 i20 = __ZN5physx5cloth5arrayERNS_6PxVec3E(HEAP32[i2 + 424 >> 2] | 0) | 0;
 i21 = Math_fround(HEAPF32[(HEAP32[i2 + 432 >> 2] | 0) + 216 >> 2]) > Math_fround(0.0);
 __ZN8Scalar4fC2ERKS_(i4, i1);
 __ZN5physx5cloth12horizontalOrE8Scalar4f(i5, i4);
 i1 = HEAP32[(__ZN5simdi5arrayER8Scalar4f(i5) | 0) >> 2] | 0;
 if (!i1) {
  STACKTOP = i40;
  return;
 }
 i4 = i35 + 16 | 0;
 i5 = i35 + 32 | 0;
 i3 = i2 + 416 | 0;
 do {
  i2 = (__ZN5physx5cloth10findBitSetEj(i1 & 0 - i1) | 0) << 4;
  i1 = i1 + -1 & i1;
  __Z11loadAlignedPKfj(i6, i20, i2);
  __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i37, i6);
  __Z5splatILj0EE8Scalar4fRKS0_(i17, i37);
  __ZmiRK8Scalar4fS1_(i31, i35, i17);
  __Z5splatILj1EE8Scalar4fRKS0_(i22, i37);
  __ZmiRK8Scalar4fS1_(i32, i4, i22);
  __Z5splatILj2EE8Scalar4fRKS0_(i23, i37);
  __ZmiRK8Scalar4fS1_(i33, i5, i23);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i26, gb + 1097856 | 0);
  __ZmlRK8Scalar4fS1_(i27, i31, i31);
  __ZplRK8Scalar4fS1_(i25, i26, i27);
  __ZmlRK8Scalar4fS1_(i28, i32, i32);
  __ZplRK8Scalar4fS1_(i24, i25, i28);
  __ZmlRK8Scalar4fS1_(i7, i33, i33);
  __ZplRK8Scalar4fS1_(i38, i24, i7);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i8, i9);
  __Z5rsqrtRK8Scalar4f(i11, i38);
  __Z5splatILj3EE8Scalar4fRKS0_(i12, i37);
  __ZmlRK8Scalar4fS1_(i10, i11, i12);
  __ZmiRK8Scalar4fS1_(i34, i8, i10);
  __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i13, i14);
  if (__Z10anyGreaterRK8Scalar4fS1_RS_(i13, i34, i30) | 0) {
   __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_(i29, i31, i32, i33, i34, i30);
   if (i21) {
    __Z11loadAlignedPKfj(i15, __ZN5physx5cloth5arrayERNS_6PxVec3E(HEAP32[i3 >> 2] | 0) | 0, i2);
    __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i36, i15);
    __ZmiRK8Scalar4fS1_(i39, i37, i36);
    __Z5splatILj0EE8Scalar4fRKS0_(i16, i39);
    __Z5splatILj1EE8Scalar4fRKS0_(i18, i39);
    __Z5splatILj2EE8Scalar4fRKS0_(i19, i39);
    __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_(i29, i16, i18, i19, i30);
   }
  }
 } while ((i1 | 0) != 0);
 STACKTOP = i40;
 return;
}

function __ZN9Animation10RemoveClipERK19ShouldRemoveFunctorPKc(i15, i16, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14;
 if ((HEAP16[gb + 1467052 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = i15;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467052 | 0, i8);
  i13 = gb + 1467052 | 0;
 } else i13 = 0;
 i10 = i15 + 284 | 0;
 i11 = i15 + 288 | 0;
 i7 = 0;
 i1 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) >> 2;
 L4 : while (1) {
  do {
   i6 = i1;
   i1 = i1 + -1 | 0;
   if (!i6) break L4;
   i6 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i5 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i9 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i12 = 12; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
      i3 = HEAP32[i8 >> 2] | 0;
      i17 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i17 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i17 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 12; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i12 = 14;
     }
    }
    if ((i12 | 0) == 12) i12 = 14;
    if ((i12 | 0) == 14) {
     i12 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
  } while (!(mftCall_iii(i6 | 0, i16 | 0, i2 | 0) | 0));
  i5 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  i2 = i5 + 4 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 - i2 | 0;
  i6 = i4 >> 2;
  if (i6) {
   _memmove(i5 | 0, i2 | 0, i4 | 0) | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  i2 = i5 + (i6 << 2) | 0;
  if ((i3 | 0) == (i2 | 0)) {
   i7 = 1;
   continue;
  }
  HEAP32[i11 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i7 = 1;
 }
 if (i7) {
  i7 = i15 + 104 | 0;
  i8 = i15 + 108 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = (HEAP32[i8 >> 2] | 0) - i2 >> 2;
  L32 : do if (i1 | 0) while (1) {
   i1 = i1 + -1 | 0;
   i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   if (mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0, i16 | 0, i2 | 0) | 0) {
    if (i2 | 0) {
     __ZN14AnimationStateD2Ev(i2);
     __ZdlPv(i2);
    }
    i5 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
    i2 = i5 + 4 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i4 = i3 - i2 | 0;
    i6 = i4 >> 2;
    if (i6) {
     _memmove(i5 | 0, i2 | 0, i4 | 0) | 0;
     i3 = HEAP32[i8 >> 2] | 0;
    }
    i2 = i5 + (i6 << 2) | 0;
    if ((i3 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   }
   if (!i1) break L32;
   i2 = HEAP32[i7 >> 2] | 0;
  } while (0);
  i17 = i15 + 252 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | 1;
 }
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return;
}

function __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf(i3, i1, i20, i18, i7, i19, i17, i21) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i18 = i18 | 0;
 i7 = i7 | 0;
 i19 = i19 | 0;
 i17 = i17 | 0;
 i21 = i21 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, i16 = 0;
 i10 = i18 + (i3 << 2) | 0;
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i19 + (i3 << 2) | 0;
 f2 = Math_fround(HEAPF32[i11 >> 2]);
 f12 = Math_fround(f12 - f2);
 i13 = i18 + (i1 << 2) | 0;
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 i14 = i19 + (i1 << 2) | 0;
 f4 = Math_fround(HEAPF32[i14 >> 2]);
 f15 = Math_fround(f15 - f4);
 i16 = i7 + (i1 << 2) | 0;
 f9 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
 i1 = i7 + (i3 << 2) | 0;
 f8 = Math_fround(f15 * Math_fround(HEAPF32[i1 >> 2]));
 do if (!(f9 >= f8)) {
  HEAPF32[i13 >> 2] = f4;
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i11 >> 2]));
  f4 = Math_fround(HEAPF32[i16 >> 2]);
  f6 = Math_fround(f8 - Math_fround(f4 * f5));
  if (!(f6 >= Math_fround(0.0))) {
   if (!i17) break;
   f12 = Math_fround(Math_fround(1.0) / f4);
   HEAPF32[i10 >> 2] = Math_fround(f2 - Math_fround(f8 * f12));
   HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f15 * f12));
   break;
  } else {
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2)));
   f12 = Math_fround(Math_fround(f6 * f6) * f2);
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f12);
   if (!i17) break;
   HEAPF32[i10 >> 2] = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
   f12 = Math_fround(f5 * Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f2 * Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i16 >> 2])))));
   break;
  }
 } else {
  HEAPF32[i10 >> 2] = f2;
  f2 = Math_fround(HEAPF32[i13 >> 2]);
  f5 = Math_fround(f2 + Math_fround(HEAPF32[i14 >> 2]));
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f6 = Math_fround(f9 - Math_fround(f4 * f5));
  if (!(f6 >= Math_fround(0.0))) {
   if (!i17) break;
   f15 = Math_fround(Math_fround(1.0) / f4);
   HEAPF32[i13 >> 2] = Math_fround(f2 - Math_fround(f9 * f15));
   HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f12 * f15));
   break;
  } else {
   f15 = Math_fround(f4 * f4);
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   f2 = Math_fround(Math_fround(1.0) / Math_fround(f15 + Math_fround(f2 * f2)));
   f15 = Math_fround(Math_fround(f6 * f6) * f2);
   HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f15);
   if (!i17) break;
   HEAPF32[i13 >> 2] = Math_fround(-Math_fround(HEAPF32[i14 >> 2]));
   f15 = Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2]));
   HEAPF32[i17 >> 2] = Math_fround(-Math_fround(f2 * Math_fround(f15 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])))));
   break;
  }
 } while (0);
 i3 = i18 + (i20 << 2) | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = i19 + (i20 << 2) | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f4 < Math_fround(-f2)) {
  f15 = Math_fround(f4 + f2);
  f15 = Math_fround(f15 * f15);
  HEAPF32[i21 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i21 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  return;
 }
 if (!(f4 > f2)) return;
 f15 = Math_fround(f4 - f2);
 f15 = Math_fround(f15 * f15);
 HEAPF32[i21 >> 2] = Math_fround(f15 + Math_fround(HEAPF32[i21 >> 2]));
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i5 + -108 | 0;
  i7 = i1;
  i1 = i1 + -108 | 0;
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i7 + -104 >> 2] | 0 : i6 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + -96 >> 2] = i3;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i5 + -96 >> 2] | 0;
   i15 = 7;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i6;
   if (i6) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i6 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i5 + -100 >> 2] = i17 | -2147483648;
   HEAP32[i5 + -104 >> 2] = i6;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i6 | 0) | 0;
  }
  HEAP8[i2 + i6 >> 0] = 0;
  i4 = i5 + -92 | 0;
  i2 = i7 + -92 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i5 + -60 >> 2] = HEAP32[i7 + -60 >> 2];
  HEAP32[i5 + -56 >> 2] = HEAP32[i7 + -56 >> 2];
  HEAP32[i5 + -52 >> 2] = HEAP32[i7 + -52 >> 2];
  i4 = i5 + -48 | 0;
  i2 = i7 + -48 | 0;
  i3 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   i4 = i4 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  i5 = (HEAP32[i13 >> 2] | 0) + -108 | 0;
  HEAP32[i13 >> 2] = i5;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i5;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE(i1, i7, i24, i25, i17) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i17 = i17 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0;
 i23 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i23 >> 2] = HEAP32[i7 >> 2];
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i23 + 4 | 0;
 HEAP32[i9 >> 2] = i8;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i10 = i23 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i4 = HEAP32[i7 + 12 >> 2] | 0;
 i11 = i23 + 12 | 0;
 HEAP32[i11 >> 2] = i4;
 i12 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i23 + 16 >> 2] = i12;
 HEAP32[i23 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i5 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i23 + 24 >> 2] = i5;
 i6 = HEAP32[i7 + 28 >> 2] | 0;
 HEAP32[i23 + 28 >> 2] = i6;
 i19 = HEAP32[i7 + 32 >> 2] | 0;
 HEAP32[i23 + 32 >> 2] = i19;
 i16 = HEAP32[i7 + 36 >> 2] | 0;
 HEAP32[i23 + 36 >> 2] = i16;
 i26 = HEAP32[i7 + 40 >> 2] | 0;
 HEAP32[i23 + 40 >> 2] = i26;
 i13 = HEAP32[i7 + 44 >> 2] | 0;
 HEAP32[i23 + 44 >> 2] = i13;
 i18 = HEAP32[i7 + 48 >> 2] | 0;
 HEAP32[i23 + 48 >> 2] = i18;
 i14 = HEAP32[i7 + 52 >> 2] | 0;
 HEAP32[i23 + 52 >> 2] = i14;
 i15 = HEAP32[i7 + 56 >> 2] | 0;
 HEAP32[i23 + 56 >> 2] = i15;
 i7 = HEAP32[i7 + 60 >> 2] | 0;
 HEAP32[i23 + 60 >> 2] = i7;
 f21 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (!i17) {
  HEAP32[i9 >> 2] = i12;
  HEAP32[i23 + 16 >> 2] = i8;
  HEAP32[i10 >> 2] = i19;
  HEAP32[i23 + 32 >> 2] = i1;
  HEAP32[i11 >> 2] = i18;
  HEAP32[i23 + 48 >> 2] = i4;
  HEAP32[i23 + 24 >> 2] = i16;
  HEAP32[i23 + 36 >> 2] = i5;
  HEAP32[i23 + 28 >> 2] = i14;
  HEAP32[i23 + 52 >> 2] = i6;
  HEAP32[i23 + 44 >> 2] = i15;
  HEAP32[i23 + 56 >> 2] = i13;
  f3 = f20;
 } else {
  i6 = i14;
  i5 = i16;
  i4 = i18;
  i1 = i19;
  f3 = f2;
  f2 = f20;
 }
 if ((i25 | 0) != 1) {
  i26 = i23 + 320 | 0;
  HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
  HEAP32[i26 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
  HEAP32[i26 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
  i26 = i23 + 436 | 0;
  HEAP8[i26 >> 0] = 0;
  i26 = i23 + 336 | 0;
  HEAP32[i26 >> 2] = i25;
  return;
 }
 f29 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f28 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f27 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i23 + 32 >> 2] = Math_fround(Math_fround(f29 + f28) * Math_fround(.5));
 HEAPF32[i23 + 36 >> 2] = Math_fround(Math_fround(f27 + f20) * Math_fround(.5));
 HEAPF32[i23 + 40 >> 2] = Math_fround(Math_fround(f21 + f3) * Math_fround(.5));
 HEAPF32[i23 + 44 >> 2] = Math_fround(Math_fround(f2 + f22) * Math_fround(.5));
 i26 = i23 + 320 | 0;
 HEAP32[i26 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i26 + 4 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i26 + 8 >> 2] = HEAP32[i24 + 8 >> 2];
 i26 = i23 + 436 | 0;
 HEAP8[i26 >> 0] = 0;
 i26 = i23 + 336 | 0;
 HEAP32[i26 >> 2] = i25;
 return;
}

function __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali(i8, i5, i4) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i6 = i11 + 24 | 0;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i10);
   i2 = HEAP32[i6 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 9; else i3 = i1;
  }
 }
 if ((i9 | 0) == 7) i9 = 9;
 if ((i9 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i11;
   return;
  } else i3 = i1;
 }
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (HEAP32[i1 + 4 >> 2] | 0)) if ((HEAP32[(HEAP32[i2 + (HEAP32[i1 + 48 >> 2] << 2) >> 2] | 0) + 20 >> 2] | 0) >= (i4 | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = __ZN8Material14CreateMaterialER6Shaderib(i3, 61, 0) | 0;
   STACKTOP = i11;
   return;
  }
  if ((__ZN8Material9GetShaderEv(i1) | 0) == (i3 | 0)) {
   STACKTOP = i11;
   return;
  }
  __ZN8Material9SetShaderEP6Shader(HEAP32[i5 >> 2] | 0, i3);
  STACKTOP = i11;
  return;
 }
 HEAP32[i7 >> 2] = i4;
 __Z6FormatPKcz(i10, gb + 376153 | 0, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i6);
    i2 = HEAP32[i7 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 20;
   }
  }
  if ((i9 | 0) == 18) i9 = 20;
  if ((i9 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 376218 | 0, 34, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i11;
 return;
}

function __ZN21OverlapCapsuleQuery2D13ReportFixtureEP9b2Fixture(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 12 | 0;
 i7 = i12;
 if (HEAP8[i9 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 i4 = HEAP32[i9 + 60 >> 2] | 0;
 i11 = i4;
 if ((i4 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 if (!i4) {
  STACKTOP = i12;
  return 1;
 }
 i6 = i4 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 if (!(1 << HEAP32[i1 + 48 >> 2] & HEAP32[i8 + 4 >> 2])) {
  STACKTOP = i12;
  return 1;
 }
 f13 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 if (!(!(f14 > f15) & !(f14 < f13))) {
  STACKTOP = i12;
  return 1;
 }
 i10 = i8 + 240 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 L20 : do if (i3 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break L20;
  }
  __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f15 > Math_fround(HEAPF32[i7 + 8 >> 2]))) {
   STACKTOP = i12;
   return 1;
  }
  HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + (i1 << 2) >> 2] = i11;
  STACKTOP = i12;
  return 1;
 } while (0);
 i5 = i8 + 28 | 0;
 i6 = HEAP32[i9 + 32 >> 2] | 0;
 i4 = i8 + 224 | 0;
 i2 = (HEAP32[i9 + 28 >> 2] | 0) + 12 | 0;
 L31 : do if ((HEAP32[i6 + 4 >> 2] | 0) == 3) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   STACKTOP = i12;
   return 1;
  }
  do {
   if (__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, i1, i4, i2) | 0) break L31;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i12;
  return 1;
 } else if (!(__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, 0, i4, i2) | 0)) {
  STACKTOP = i12;
  return 1;
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
 STACKTOP = i12;
 return 1;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(i1, i2, i3, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 56 | 0;
 i10 = i12 + 40 | 0;
 i5 = i12 + 24 | 0;
 i6 = i12 + 12 | 0;
 i7 = i12;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i13 = i4 << 24 >> 24 < 0;
 i1 = i13 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i13 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, i4);
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i6, i7);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i11 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i10 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i11 = 6;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i2 = i10 + 11 | 0;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (__Z23CreateAsFileIfNotExistsPKc((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0) {
  i1 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
  __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i9, 10, 10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZN15FileSystemEntryC2EPKc(i9, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10);
  i1 = __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i8, i9, 2, 1) | 0;
  __ZN13FileEntryDataD2Ev(i9);
 } else i1 = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i13 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i9);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN14ManagerContext17InitializeClassesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 112 | 0;
 i3 = i2;
 i4 = i3 + 112 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 448085 | 0, 0) | 0;
 HEAP32[i1 + 116 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 434516 | 0, 0) | 0;
 HEAP32[i1 + 120 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 370841 | 0, 0) | 0;
 HEAP32[i1 + 124 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 855932 | 0, 0) | 0;
 HEAP32[i1 + 128 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 476527 | 0, 0) | 0;
 HEAP32[i1 + 132 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 463981 | 0, 0) | 0;
 HEAP32[i1 + 136 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 373756 | 0, 0) | 0;
 HEAP32[i1 + 140 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 441051 | 0, 0) | 0;
 HEAP32[i1 + 144 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 391228 | 0, 0) | 0;
 HEAP32[i1 + 148 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 737328 | 0, 0) | 0;
 HEAP32[i1 + 152 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 443248 | 0, 0) | 0;
 HEAP32[i1 + 156 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 405349 | 0, 0) | 0;
 HEAP32[i1 + 160 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 450701 | 0, 0) | 0;
 HEAP32[i1 + 164 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 370094 | 0, 0) | 0;
 HEAP32[i1 + 168 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 370109 | 0, 0) | 0;
 HEAP32[i1 + 172 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 844212 | 0, 0) | 0;
 HEAP32[i1 + 176 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 801731 | 0, 0) | 0;
 HEAP32[i1 + 180 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 1037316 | 0, 0) | 0;
 HEAP32[i1 + 184 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 370131 | 0, 0) | 0;
 HEAP32[i1 + 208 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 379149 | 0, 0) | 0;
 HEAP32[i1 + 212 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 381335 | 0, 0) | 0;
 HEAP32[i1 + 216 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 402133 | 0, 0) | 0;
 HEAP32[i1 + 220 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 844275 | 0, 0) | 0;
 HEAP32[i1 + 188 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 450783 | 0, 0) | 0;
 HEAP32[i1 + 192 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 1046572 | 0, 0) | 0;
 HEAP32[i1 + 196 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 1037672 | 0, 0) | 0;
 HEAP32[i1 + 200 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 1041655 | 0, 0) | 0;
 HEAP32[i1 + 204 >> 2] = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(gb + 1039541 | 0, 0) | 0;
 return;
}

function __Z16HasPathComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 24 | 0;
 i15 = i16 + 12 | 0;
 i13 = i16;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i1);
 i3 = i14 + 11 | 0;
 i12 = HEAP8[i3 >> 0] | 0;
 i1 = i12 << 24 >> 24 < 0;
 i4 = i14 + 4 | 0;
 if ((i1 ? HEAP32[i4 >> 2] | 0 : i12 & 255) | 0) {
  i1 = i1 ? HEAP32[i14 >> 2] | 0 : i14;
  do {
   i11 = HEAP8[i1 >> 0] | 0;
   i12 = i11 << 24 >> 24;
   HEAP8[i1 >> 0] = (i11 + -65 & 255) < 26 ? i12 + 32 | 0 : i12;
   i1 = i1 + 1 | 0;
   i12 = HEAP8[i3 >> 0] | 0;
   i11 = i12 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i11 ? HEAP32[i14 >> 2] | 0 : i14) + (i11 ? HEAP32[i4 >> 2] | 0 : i12 & 255) | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i15, i2);
 i5 = i15 + 11 | 0;
 i12 = HEAP8[i5 >> 0] | 0;
 i1 = i12 << 24 >> 24 < 0;
 i6 = i15 + 4 | 0;
 if ((i1 ? HEAP32[i6 >> 2] | 0 : i12 & 255) | 0) {
  i1 = i1 ? HEAP32[i15 >> 2] | 0 : i15;
  do {
   i11 = HEAP8[i1 >> 0] | 0;
   i12 = i11 << 24 >> 24;
   HEAP8[i1 >> 0] = (i11 + -65 & 255) < 26 ? i12 + 32 | 0 : i12;
   i1 = i1 + 1 | 0;
   i12 = HEAP8[i5 >> 0] | 0;
   i11 = i12 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i11 ? HEAP32[i15 >> 2] | 0 : i15) + (i11 ? HEAP32[i6 >> 2] | 0 : i12 & 255) | 0));
 }
 i1 = HEAP8[i3 >> 0] | 0;
 i12 = i1 << 24 >> 24 < 0;
 __Z27FindSeparatedPathComponentsPKcjc(i13, i12 ? HEAP32[i14 >> 2] | 0 : i14, i12 ? HEAP32[i4 >> 2] | 0 : i1 & 255, 47);
 i1 = HEAP32[i13 >> 2] | 0;
 i12 = i13 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i11 = (i1 | 0) == (i2 | 0);
 L11 : do if (i11) i3 = i1; else {
  i8 = HEAP8[i5 >> 0] | 0;
  i9 = i8 << 24 >> 24 < 0;
  i8 = i9 ? HEAP32[i6 >> 2] | 0 : i8 & 255;
  i9 = i9 ? HEAP32[i15 >> 2] | 0 : i15;
  i10 = (i8 | 0) == 0;
  i3 = i1;
  while (1) {
   i4 = HEAP8[i3 + 11 >> 0] | 0;
   i5 = i4 << 24 >> 24 < 0;
   i4 = i4 & 255;
   do if (((i5 ? HEAP32[i3 + 4 >> 2] | 0 : i4) | 0) == (i8 | 0)) {
    i6 = HEAP32[i3 >> 2] | 0;
    i7 = i5 ? i6 : i3;
    if (i5) {
     if (i10) break L11;
     if (!(_memcmp(i7, i9, i8) | 0)) break L11; else break;
    }
    if (i10) break L11;
    if ((i6 & 255) << 24 >> 24 == (HEAP8[i9 >> 0] | 0)) {
     i6 = i3;
     i5 = i9;
     do {
      i4 = i4 + -1 | 0;
      i6 = i6 + 1 | 0;
      if (!i4) break L11;
      i5 = i5 + 1 | 0;
     } while ((HEAP8[i6 >> 0] | 0) == (HEAP8[i5 >> 0] | 0));
    }
   } while (0);
   i3 = i3 + 12 | 0;
   if ((i3 | 0) == (i2 | 0)) {
    i3 = i2;
    break;
   }
  }
 } while (0);
 i3 = (i3 | 0) != (i2 | 0);
 if (!i1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  STACKTOP = i16;
  return i3 | 0;
 }
 if (!i11) {
  do {
   i11 = i2 + -12 | 0;
   HEAP32[i12 >> 2] = i11;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = HEAP32[i12 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 __ZdlPv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 STACKTOP = i16;
 return i3 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = i13 + 20 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i2) {
  i13 = 0;
  return i13 | 0;
 }
 i7 = i1;
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = _i64Add(i5 | 0, i7 | 0, -1, ~i5 | 0) | 0;
 i9 = getTempRet0() | 0;
 i10 = _bitshift64Lshr(i1 | 0, i9 | 0, 22) | 0;
 i1 = i10 ^ i1;
 i9 = (getTempRet0() | 0) ^ i9;
 i10 = _bitshift64Shl(i1 | 0, i9 | 0, 13) | 0;
 i10 = _i64Add(i1 | 0, i9 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i9 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i10 | 0, i9 | 0, 8) | 0;
 i9 = ___muldi3(i1 ^ i10 | 0, (getTempRet0() | 0) ^ i9 | 0, 9, 0) | 0;
 i10 = getTempRet0() | 0;
 i1 = _bitshift64Lshr(i9 | 0, i10 | 0, 15) | 0;
 i9 = i1 ^ i9;
 i10 = (getTempRet0() | 0) ^ i10;
 i1 = _bitshift64Shl(i9 | 0, i10 | 0, 27) | 0;
 i1 = _i64Add(i9 | 0, i10 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i10 = getTempRet0() | 0;
 i9 = _bitshift64Lshr(i1 | 0, i10 | 0, 31) | 0;
 (getTempRet0() | 0) ^ i10;
 i10 = HEAP32[i13 + 12 >> 2] | 0;
 i2 = i10 + (((i9 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i13 = 0;
  return i13 | 0;
 }
 i9 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = HEAP32[i13 + 8 >> 2] | 0;
 while (1) {
  i4 = i9 + (i1 << 4) | 0;
  i14 = i4;
  i3 = i2;
  i2 = i6 + (i1 << 2) | 0;
  i8 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i14 >> 2] | 0) == (i5 | 0) ? (HEAP32[i14 + 4 >> 2] | 0) == (i7 | 0) : 0) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i13 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i14 = i13 + 32 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 if ((i8 | 0) != (i1 | 0)) {
  i11 = i9 + (i1 << 4) | 0;
  i14 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = i4;
  HEAP32[i7 >> 2] = i14;
  HEAP32[i7 + 4 >> 2] = i11;
  HEAP32[i9 + (i8 << 4) + 8 >> 2] = HEAP32[i9 + (i1 << 4) + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = _i64Add(i14 | 0, i11 | 0, -1, ~i14 | 0) | 0;
  i14 = getTempRet0() | 0;
  i12 = _bitshift64Lshr(i2 | 0, i14 | 0, 22) | 0;
  i2 = i12 ^ i2;
  i14 = (getTempRet0() | 0) ^ i14;
  i12 = _bitshift64Shl(i2 | 0, i14 | 0, 13) | 0;
  i12 = _i64Add(i2 | 0, i14 | 0, ~i12 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i14 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i12 | 0, i14 | 0, 8) | 0;
  i14 = ___muldi3(i2 ^ i12 | 0, (getTempRet0() | 0) ^ i14 | 0, 9, 0) | 0;
  i12 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i14 | 0, i12 | 0, 15) | 0;
  i14 = i2 ^ i14;
  i12 = (getTempRet0() | 0) ^ i12;
  i2 = _bitshift64Shl(i14 | 0, i12 | 0, 27) | 0;
  i2 = _i64Add(i14 | 0, i12 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i12 = getTempRet0() | 0;
  i14 = _bitshift64Lshr(i2 | 0, i12 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i12;
  i1 = i10 + (((i14 ^ i2) & i1 + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i6 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i8;
 }
 i14 = i13 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx21PxcArticulationHelper22createTangentialSpringERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Efff(i4, i6, i5, i7, i1, f8, f2, f3) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i9 + 32 | 0;
 i16 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = HEAP32[i1 >> 2];
 i15 = i1 + 4 | 0;
 HEAP32[i7 + 36 >> 2] = HEAP32[i15 >> 2];
 i14 = i1 + 8 | 0;
 HEAP32[i7 + 40 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i14 >> 2];
 HEAPF32[i7 + 96 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i7 + 100 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 108 >> 2] = 0;
 HEAPF32[i7 + 104 >> 2] = Math_fround(0.0);
 i20 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i15 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 i6 = HEAP32[i6 + (i5 << 5) + 28 >> 2] | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = i20;
 HEAP32[i17 + 20 >> 2] = i19;
 HEAP32[i17 + 24 >> 2] = i18;
 HEAPF32[i17 + 28 >> 2] = Math_fround(0.0);
 f11 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f13 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAP32[i16 >> 2] = -2147483648;
 HEAP32[i16 + 4 >> 2] = -2147483648;
 HEAP32[i16 + 8 >> 2] = -2147483648;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 16 >> 2] = f11;
 HEAPF32[i16 + 20 >> 2] = f12;
 HEAPF32[i16 + 24 >> 2] = f13;
 HEAPF32[i16 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i4, i6, i17, i7 + 112 | 0, i5, i16, i7 + 144 | 0);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f13 * Math_fround(HEAPF32[i7 + 128 >> 2]));
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i7 + 132 >> 2])));
 f10 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i7 + 136 >> 2])));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i7 + 160 >> 2]));
 f11 = Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i7 + 164 >> 2])));
 f10 = Math_fround(f12 - Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i7 + 168 >> 2]))));
 i6 = f10 <= Math_fround(0.0);
 f10 = Math_fround(Math_fround(1.0) / f10);
 f10 = i6 ? Math_fround(0.0) : f10;
 f3 = Math_fround(Math_fround(f2 * f3) + Math_fround(Math_fround(f3 * f3) * f8));
 f8 = Math_fround(Math_fround(1.0) / Math_fround(f3 + Math_fround(1.0)));
 HEAPF32[i7 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 44 >> 2] = Math_fround(-Math_fround(f3 * Math_fround(f8 * f10)));
 HEAPF32[i7 + 60 >> 2] = Math_fround(Math_fround(1.0) - f8);
 STACKTOP = i9;
 return;
}

function __ZN17OverlapBoxQuery2D13ReportFixtureEP9b2Fixture(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 12 | 0;
 i7 = i12;
 if (HEAP8[i9 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 i4 = HEAP32[i9 + 60 >> 2] | 0;
 i11 = i4;
 if ((i4 | 0) == (HEAP32[i8 + 16 >> 2] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 if (!i4) {
  STACKTOP = i12;
  return 1;
 }
 i6 = i4 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 if (!(1 << HEAP32[i1 + 48 >> 2] & HEAP32[i8 + 4 >> 2])) {
  STACKTOP = i12;
  return 1;
 }
 f13 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 if (!(!(f14 > f15) & !(f14 < f13))) {
  STACKTOP = i12;
  return 1;
 }
 i10 = i8 + 212 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 L20 : do if (i3 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break L20;
  }
  __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f15 > Math_fround(HEAPF32[i7 + 8 >> 2]))) {
   STACKTOP = i12;
   return 1;
  }
  HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + (i1 << 2) >> 2] = i11;
  STACKTOP = i12;
  return 1;
 } while (0);
 i5 = i8 + 28 | 0;
 i6 = HEAP32[i9 + 32 >> 2] | 0;
 i4 = i8 + 196 | 0;
 i2 = (HEAP32[i9 + 28 >> 2] | 0) + 12 | 0;
 L31 : do if ((HEAP32[i6 + 4 >> 2] | 0) == 3) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   STACKTOP = i12;
   return 1;
  }
  do {
   if (__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, i1, i4, i2) | 0) break L31;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i12;
  return 1;
 } else if (!(__Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_(i5, 0, i6, 0, i4, i2) | 0)) {
  STACKTOP = i12;
  return 1;
 } while (0);
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
 STACKTOP = i12;
 return 1;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 430636 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI11ChannelInfoE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 430636 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI11ChannelInfoE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE6createERS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i5 = i11;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = _i64Add(i4 | 0, i5 | 0, -1, ~i4 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 22) | 0;
  i1 = i6 ^ i1;
  i2 = (getTempRet0() | 0) ^ i2;
  i6 = _bitshift64Shl(i1 | 0, i2 | 0, 13) | 0;
  i6 = _i64Add(i1 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i6 | 0, i2 | 0, 8) | 0;
  i2 = ___muldi3(i1 ^ i6 | 0, (getTempRet0() | 0) ^ i2 | 0, 9, 0) | 0;
  i6 = getTempRet0() | 0;
  i1 = _bitshift64Lshr(i2 | 0, i6 | 0, 15) | 0;
  i2 = i1 ^ i2;
  i6 = (getTempRet0() | 0) ^ i6;
  i1 = _bitshift64Shl(i2 | 0, i6 | 0, 27) | 0;
  i1 = _i64Add(i2 | 0, i6 | 0, ~i1 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i6 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i1 | 0, i6 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i6;
  i1 = (i2 ^ i1) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i12 + 8 | 0;
   while (1) {
    i13 = i6 + (i2 << 4) | 0;
    if ((HEAP32[i13 >> 2] | 0) == (i4 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i5 | 0) : 0) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i13 = i6 + (i1 << 4) | 0;
   return i13 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i13 = HEAP32[i11 >> 2] | 0;
  i13 = _i64Add(i13 | 0, HEAP32[i11 + 4 >> 2] | 0, -1, ~i13 | 0) | 0;
  i11 = getTempRet0() | 0;
  i10 = _bitshift64Lshr(i13 | 0, i11 | 0, 22) | 0;
  i13 = i10 ^ i13;
  i11 = (getTempRet0() | 0) ^ i11;
  i10 = _bitshift64Shl(i13 | 0, i11 | 0, 13) | 0;
  i10 = _i64Add(i13 | 0, i11 | 0, ~i10 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i11 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i10 | 0, i11 | 0, 8) | 0;
  i11 = ___muldi3(i13 ^ i10 | 0, (getTempRet0() | 0) ^ i11 | 0, 9, 0) | 0;
  i10 = getTempRet0() | 0;
  i13 = _bitshift64Lshr(i11 | 0, i10 | 0, 15) | 0;
  i11 = i13 ^ i11;
  i10 = (getTempRet0() | 0) ^ i10;
  i13 = _bitshift64Shl(i11 | 0, i10 | 0, 27) | 0;
  i13 = _i64Add(i11 | 0, i10 | 0, ~i13 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = _bitshift64Lshr(i13 | 0, i10 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i10;
  i1 = (i11 ^ i13) & i1 + -1;
 }
 i11 = i12 + 28 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i13 + 1;
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i13 << 2) >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i13;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i13 = (HEAP32[i12 + 4 >> 2] | 0) + (i13 << 4) | 0;
 return i13 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEs(i12, i5) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i8 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i10 | 0, i12 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   i7 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i6 = HEAP32[i7 + 4 >> 2] & 74;
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i7) | 0;
   __THREW__ = 0;
   i7 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i9 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i8 >> 2] = i9;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
     i1 = invoke_iiiiii(i14 | 0, i7 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, ((i6 | 0) == 64 | (i6 | 0) == 8 ? i5 & 65535 : i5 << 16 >> 16) | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN7mecanim9animation19Blend2dDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i4 = i8 + 4 | 0;
 i11 = i9 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 >> 2] = i1;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 << 3 | 0, 4) | 0;
  i2 = i4;
  i3 = i3 | 0 ? i3 - i2 | 0 : 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i3 + i2 | 0, i1 << 3);
 }
 i5 = i8 + 12 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 8 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i4 | 0, i1 << 2);
 }
 i4 = i8 + 20 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 16 >> 2] = i1;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 << 3 | 0, 4) | 0;
  i2 = i4;
  i3 = i3 | 0 ? i3 - i2 | 0 : 0;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i3 + i2 | 0, i1 << 3);
 }
 i5 = i8 + 28 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 24 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i4 | 0, i1 << 2);
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i8 + 36;
 HEAP32[i10 + 4 >> 2] = i8 + 32;
 HEAP32[i10 + 8 >> 2] = i11;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i9, i10, 0);
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863052 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863052 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNKSt3__220__time_get_c_storageIcE7__weeksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099872 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099872 | 0) | 0) {
  if (!(HEAP8[gb + 1099880 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099880 | 0) | 0) {
   i2 = gb + 1475260 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1475260 + 168 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1149 | 0, gb + 1475260 | 0, gb + 1078636 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, gb + 1475260 + 12 | 0, gb + 1078643 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __THREW__ = 0;
    invoke_iii(fb + 1149 | 0, gb + 1475260 + 24 | 0, gb + 1078650 | 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_iii(fb + 1149 | 0, gb + 1475260 + 36 | 0, gb + 1078658 | 0) | 0;
     i2 = __THREW__;
     __THREW__ = 0;
     if (!(i2 & 1)) {
      __THREW__ = 0;
      invoke_iii(fb + 1149 | 0, gb + 1475260 + 48 | 0, gb + 1078668 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (!(i2 & 1)) {
       __THREW__ = 0;
       invoke_iii(fb + 1149 | 0, gb + 1475260 + 60 | 0, gb + 1078677 | 0) | 0;
       i2 = __THREW__;
       __THREW__ = 0;
       if (!(i2 & 1)) {
        __THREW__ = 0;
        invoke_iii(fb + 1149 | 0, gb + 1475260 + 72 | 0, gb + 1078684 | 0) | 0;
        i2 = __THREW__;
        __THREW__ = 0;
        if (!(i2 & 1)) {
         __THREW__ = 0;
         invoke_iii(fb + 1149 | 0, gb + 1475260 + 84 | 0, gb + 1078693 | 0) | 0;
         i2 = __THREW__;
         __THREW__ = 0;
         if (!(i2 & 1)) {
          __THREW__ = 0;
          invoke_iii(fb + 1149 | 0, gb + 1475260 + 96 | 0, gb + 1078697 | 0) | 0;
          i2 = __THREW__;
          __THREW__ = 0;
          if (!(i2 & 1)) {
           __THREW__ = 0;
           invoke_iii(fb + 1149 | 0, gb + 1475260 + 108 | 0, gb + 1078701 | 0) | 0;
           i2 = __THREW__;
           __THREW__ = 0;
           if (!(i2 & 1)) {
            __THREW__ = 0;
            invoke_iii(fb + 1149 | 0, gb + 1475260 + 120 | 0, gb + 1078705 | 0) | 0;
            i2 = __THREW__;
            __THREW__ = 0;
            if (!(i2 & 1)) {
             __THREW__ = 0;
             invoke_iii(fb + 1149 | 0, gb + 1475260 + 132 | 0, gb + 1078709 | 0) | 0;
             i2 = __THREW__;
             __THREW__ = 0;
             if (!(i2 & 1)) {
              __THREW__ = 0;
              invoke_iii(fb + 1149 | 0, gb + 1475260 + 144 | 0, gb + 1078713 | 0) | 0;
              i2 = __THREW__;
              __THREW__ = 0;
              if (!(i2 & 1)) {
               __THREW__ = 0;
               invoke_iii(fb + 1149 | 0, gb + 1475260 + 156 | 0, gb + 1078717 | 0) | 0;
               i2 = __THREW__;
               __THREW__ = 0;
               if (!(i2 & 1)) {
                HEAP32[gb + 1475428 >> 2] = gb + 1475260;
                break;
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1475428 >> 2] | 0;
}

function __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 i1 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i1 | 0) > -1) i1 = HEAP32[gb + 1468320 + (i1 << 2) >> 2] | 0; else i1 = 0;
 i9 = HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0;
 f17 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i9 + 44 >> 2]));
 f10 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i9 + 48 >> 2]));
 f19 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i9 + 52 >> 2]));
 f18 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i9 + 56 >> 2]));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i2 + 20 >> 2]));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i2 + 28 >> 2]));
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i2 + 32 >> 2]));
 f20 = Math_fround(f18 * Math_fround(.5));
 f18 = (HEAP32[i9 + 60 >> 2] | 0) == 0 ? f20 : f18;
 i15 = f17 < Math_fround(0.0);
 f17 = i15 ? Math_fround(0.0) : f17;
 i15 = f17 > Math_fround(1.0);
 i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f17) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i16 = f10 < Math_fround(0.0);
 f10 = i16 ? Math_fround(0.0) : f10;
 i16 = f10 > Math_fround(1.0);
 i16 = ~~Math_fround(Math_fround((i16 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i14 = f19 < Math_fround(0.0);
 f19 = i14 ? Math_fround(0.0) : f19;
 i14 = f19 > Math_fround(1.0);
 i14 = ~~Math_fround(Math_fround((i14 ? Math_fround(1.0) : f19) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = f18 < Math_fround(0.0);
 f18 = i1 ? Math_fround(0.0) : f18;
 i1 = f18 > Math_fround(1.0);
 i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f18) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(f18 + Math_fround(HEAP32[i2 + 208 >> 2] | 0));
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(f10 + Math_fround(HEAP32[i2 + 216 >> 2] | 0));
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f18 = Math_fround(f18 - Math_fround(HEAP32[i2 + 212 >> 2] | 0));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 f18 = Math_fround(f18 - f19);
 f10 = Math_fround(Math_fround(f10 - Math_fround(HEAP32[i2 + 220 >> 2] | 0)) - f17);
 HEAPF32[i5 >> 2] = f19;
 HEAPF32[i5 + 8 >> 2] = f18;
 HEAPF32[i5 + 4 >> 2] = f17;
 HEAPF32[i5 + 12 >> 2] = f10;
 i13 = __ZNK8GUIStyle14GetCurrentFontEv(i2) | 0;
 i12 = HEAP32[i2 + 244 >> 2] | 0;
 i11 = HEAP16[i2 + 248 >> 1] | 0;
 HEAP32[i6 >> 2] = i16 << 8 & 65280 | i15 & 255 | i14 << 16 & 16711680 | i1 << 24;
 f10 = Math_fround(HEAPF32[i9 + 344 >> 2]);
 i9 = HEAP32[i2 + 284 >> 2] | 0;
 i1 = HEAP32[i2 + 288 >> 2] | 0;
 i3 = HEAP32[i2 + 256 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 i7 = __ZN5IMGUI12GetGeneratorERK5RectTIfERK10GUIContentPN13TextRendering4FontE10TextAnchorbb11ColorRGBA32fii13ImagePosition(i5, i4, i13, i12, (i11 & 255) << 24 >> 24 != 0, (i11 & 65535) > 255, i7, f10, i9, i1, i3) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx2Sc5Scene19startBatchInsertionERNS0_19BatchInsertionStateE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i7 + 1212 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 i3 = i1;
 i6 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 31, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i6 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 HEAP32[i8 + 8 >> 2] = i1;
 i6 = HEAP32[i7 + 1216 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 i3 = i1;
 i6 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 59, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i6 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 HEAP32[i8 + 4 >> 2] = i1;
 i6 = HEAP32[i7 + 1220 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 i3 = i1;
 i7 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 191, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i7 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 * 20 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 20 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 * 20 | 0) | 0, 0, (i5 - i4 | 0) * 20 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + ((HEAP32[i6 >> 2] | 0) * 20 | 0) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 410605 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN12SpriteVertex8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 410605 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN12SpriteVertex8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 842702 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 842702 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx5cloth16TripletScheduler4simdEjj(i4, i2, i18) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20 + 24 | 0;
 i16 = i20 + 8 | 0;
 i1 = i20 + 4 | 0;
 i17 = i20;
 i3 = i4 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i1 >> 2] = -1;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 i15 = i16 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i16, i2, i1);
 HEAP32[i17 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i14 = i1 + (i13 << 4) | 0;
 if (i13 | 0) {
  i11 = i14;
  i12 = i4 + 12 | 0;
  i13 = i4 + 20 | 0;
  i9 = i4 + 16 | 0;
  i2 = 0;
  i10 = 0;
  while (1) {
   i8 = i11 - i1 >> 4;
   i8 = i8 >>> 0 > i18 >>> 0 ? i18 : i8;
   i7 = i1 + (i8 << 4) | 0;
   L8 : do if ((i8 | 0) == 0 | (i1 | 0) == (i14 | 0)) {
    i3 = i14;
    i4 = 14;
   } else {
    i8 = HEAP32[i16 >> 2] | 0;
    i3 = i14;
    while (1) {
     i5 = i1 + 8 | 0;
     i6 = i1 + 4 | 0;
     while (1) {
      i4 = i8 + (HEAP32[i1 >> 2] << 2) | 0;
      if ((HEAP32[i4 >> 2] | 0) != (i10 | 0)) if ((HEAP32[i8 + (HEAP32[i6 >> 2] << 2) >> 2] | 0) != (i10 | 0)) if ((HEAP32[i8 + (HEAP32[i5 >> 2] << 2) >> 2] | 0) != (i10 | 0)) break;
      i3 = i3 + -16 | 0;
      if ((i1 | 0) == (i3 | 0)) {
       i3 = i1;
       break;
      };
      HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i19 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
      HEAP32[i19 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
      HEAP32[i19 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
      HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
      HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
      HEAP32[i3 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
      HEAP32[i3 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
      HEAP32[i3 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
     }
     if ((i1 | 0) == (i3 | 0)) {
      i4 = 15;
      break L8;
     }
     HEAP32[i4 >> 2] = i10;
     HEAP32[i8 + (HEAP32[i6 >> 2] << 2) >> 2] = i10;
     HEAP32[i8 + (HEAP32[i5 >> 2] << 2) >> 2] = i10;
     i1 = i1 + 16 | 0;
     i2 = i2 + 1 | 0;
     HEAP32[i17 >> 2] = i2;
     if ((i1 | 0) == (i7 | 0) | (i1 | 0) == (i3 | 0)) {
      i4 = 14;
      break;
     }
    }
   } while (0);
   if ((i4 | 0) == 14) {
    i4 = 0;
    if ((i1 | 0) == (i3 | 0)) i4 = 15;
   }
   if ((i4 | 0) == 15) {
    if (i2 >>> 0 > i18 >>> 0) {
     i3 = (i2 >>> 0) % (i18 >>> 0) | 0;
     i2 = i2 - i3 | 0;
     HEAP32[i17 >> 2] = i2;
     i3 = i1 + (0 - i3 << 4) | 0;
    } else i3 = i1;
    i1 = HEAP32[i9 >> 2] | 0;
    if ((HEAP32[i13 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] = i2;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj(i12, i17) | 0;
    HEAP32[i17 >> 2] = 0;
    i2 = 0;
    i1 = i3;
   }
   if ((i1 | 0) == (i14 | 0)) break; else i10 = i10 + 1 | 0;
  }
 }
 i19 = HEAP32[i15 >> 2] | 0;
 if (!((i19 | 0) > -1 & (i19 & 2147483647 | 0) != 0)) {
  STACKTOP = i20;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[i16 >> 2] | 0);
 STACKTOP = i20;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i6 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i4 - i6 | 0;
 i10 = (i5 | 0) / 24 | 0;
 i12 = i13 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i1 = i6;
 i9 = i8;
 i14 = i4;
 if (i10 >>> 0 > ((i2 - i8 | 0) / 24 | 0) >>> 0) {
  i4 = i8;
  if (i8) {
   i2 = i13 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i9 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i8 | 0) >>> 0) / 24 | 0) * 24 | 0);
   i9 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 2;
   HEAP32[i11 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   i2 = 0;
  }
  if ((i5 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  } else i3 = 0;
  i9 = (i2 - i3 | 0) / 24 | 0;
  i3 = i9 << 1;
  i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i10 >>> 0 ? i10 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 2;
  HEAP32[i11 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i13 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i12 >> 2] = i2 + (i3 * 24 | 0);
  if ((i1 | 0) == (i14 | 0)) {
   STACKTOP = i15;
   return;
  }
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   i1 = i1 + 24 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 24 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 } else {
  i5 = i13 + 4 | 0;
  i2 = ((HEAP32[i5 >> 2] | 0) - i8 | 0) / 24 | 0;
  i3 = i10 >>> 0 > i2 >>> 0;
  i1 = i3 ? i1 + (i2 * 24 | 0) | 0 : i4;
  i2 = i1 - i6 | 0;
  if (i2 | 0) _memmove(i8 | 0, i6 | 0, i2 | 0) | 0;
  i2 = i9 + (((i2 | 0) / 24 | 0) * 24 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i5 >> 2] = i1 + (~(((i1 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
   STACKTOP = i15;
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i15;
   return;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   i1 = i1 + 24 | 0;
   i2 = (HEAP32[i5 >> 2] | 0) + 24 | 0;
   HEAP32[i5 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i15;
  return;
 }
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9constructERNS2_11ConstructorEiPS1_(i10, i13, i9, i5) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 HEAP32[i10 + 36 >> 2] = -1;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 i6 = (i5 | 0) == 0;
 if (i6) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i4 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 } else i1 = i5;
 i11 = i10 + 12 | 0;
 i8 = i9 << 3;
 if ((HEAP32[i11 >> 2] | 0) < (i9 | 0)) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 + 16 | 0, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = i9;
   HEAP32[i11 >> 2] = i9;
   i1 = i10 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i12 = HEAP32[i4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i7 = 10;
  }
 } else i7 = 10;
 if ((i7 | 0) == 10) HEAP32[i10 + 16 >> 2] = i9;
 i12 = i10 + 8 | 0;
 _memset(HEAP32[i12 >> 2] | 0, 0, i8 | 0) | 0;
 i4 = i10 + 20 | 0;
 HEAP32[i4 >> 2] = i5;
 if (i6) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i4 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 } else i1 = i5;
 i2 = i10 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) < (i9 | 0)) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 + 16 | 0, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = i9;
   HEAP32[i2 >> 2] = i9;
   i1 = i10 + 24 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i8 = HEAP32[i4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i7 = 20;
  }
 } else i7 = 20;
 if ((i7 | 0) == 20) HEAP32[i10 + 32 >> 2] = i9;
 i6 = i10;
 i7 = i10 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) > 0) {
  i12 = i6;
  HEAP32[i13 >> 2] = i12;
  i12 = i13 + 4 | 0;
  HEAP32[i12 >> 2] = 0;
  i13 = i13 + 8 | 0;
  HEAP32[i13 >> 2] = 0;
  return;
 }
 if ((HEAP32[i11 >> 2] | 0) > 0) i1 = HEAP32[i12 >> 2] | 0; else {
  i5 = i10 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 144, 0) | 0;
  if (!i1) {
   i12 = 0;
   HEAP32[i13 >> 2] = i12;
   i12 = i13 + 4 | 0;
   HEAP32[i12 >> 2] = 0;
   i13 = i13 + 8 | 0;
   HEAP32[i13 >> 2] = 0;
   return;
  }
  HEAP32[i1 >> 2] = 16;
  i1 = i1 + 16 | 0;
  HEAP32[i11 >> 2] = 16;
  i2 = HEAP32[i12 >> 2] | 0;
  do if (i2 | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   if (i3) {
    i4 = (i3 | 0) > 1 ? 1 : i3;
    if ((i3 | 0) > 0) {
     i3 = 0;
     do {
      i9 = i2 + (i3 << 3) | 0;
      i10 = HEAP32[i9 + 4 >> 2] | 0;
      i11 = i1 + (i3 << 3) | 0;
      HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i11 + 4 >> 2] = i10;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i4 | 0));
     i2 = HEAP32[i12 >> 2] | 0;
     if (!i2) break;
    }
   }
   i11 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i2 + -16 | 0);
  } while (0);
  HEAP32[i12 >> 2] = i1;
 }
 HEAP32[i7 >> 2] = 1;
 _memset(i1 + (i8 << 3) | 0, 0, 1 - i8 << 2 | 0) | 0;
 i12 = i6;
 HEAP32[i13 >> 2] = i12;
 i12 = i13 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i13 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1048681 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1048681 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL44CreateObjectToIndexMappingFromNonRootObjectsR21GarbageCollectorState(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 8 | 0;
 i16 = i18;
 HEAP8[i13 + 53 >> 0] = 1;
 i3 = i13 + 64 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i13 + 76 | 0;
 i1 = HEAP32[i2 >> 2] << 3;
 i15 = HEAP32[i13 + 96 >> 2] | 0;
 HEAP32[i14 >> 2] = 1;
 HEAP32[i14 + 4 >> 2] = i15;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 i15 = i13 + 72 | 0;
 HEAP32[i15 >> 2] = i1;
 i2 = i1 + (HEAP32[i2 >> 2] << 3) | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i10 = i3;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i1;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i9 = i13 + 44 | 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv(i9);
 i10 = i13 + 52 | 0;
 HEAP8[i10 >> 0] = 1;
 i11 = i13 + 56 | 0;
 HEAP32[i11 >> 2] = -2;
 HEAP32[i11 + 4 >> 2] = 0;
 i11 = i13 + 12 | 0;
 i1 = HEAP32[i11 >> 2] << 1;
 if ((i1 | 0) == 0 | (HEAP8[i13 + 92 >> 0] | 0) != 0) __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv(i9);
 i12 = i13 + 80 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj(i9, i1 - i2 | 0, 0);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 i5 = i16 + 4 | 0;
 i6 = i14 + 4 | 0;
 i7 = i13 + 48 | 0;
 i8 = i13 + 56 | 0;
 i4 = 0;
 do {
  i2 = HEAP32[i13 >> 2] | 0;
  if (!(HEAP32[i2 + (i4 << 3) + 4 >> 2] & 536870912)) {
   HEAP32[i16 >> 2] = HEAP32[(HEAP32[i2 + (i4 << 3) >> 2] | 0) + 4 >> 2];
   HEAP32[i5 >> 2] = i4;
   __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj(i9, 1, 0);
   __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i14, i9, i16);
   if ((HEAP32[i14 >> 2] | 0) == -1) {
    i3 = HEAP32[i6 >> 2] | 0;
    if (!(HEAP8[i10 >> 0] | 0)) i17 = 16; else {
     i2 = HEAP32[i7 >> 2] | 0;
     if (!i2) i17 = 16; else {
      i1 = HEAP32[i15 >> 2] | 0;
      if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i1 + (i3 << 3) >> 2] | 0)) HEAP32[i7 >> 2] = i2 + -1; else i17 = 16;
     }
    }
    if ((i17 | 0) == 16) {
     i17 = 0;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
     i1 = HEAP32[i15 >> 2] | 0;
    }
    i19 = i16;
    i2 = HEAP32[i19 + 4 >> 2] | 0;
    i3 = i1 + (i3 << 3) | 0;
    HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i3 + 4 >> 2] = i2;
   }
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 STACKTOP = i18;
 return;
}

function __ZNK32RendererMaterialAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i3, i2, i11) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i8 = i10;
 if (i2) {
  i12 = 0;
  STACKTOP = i10;
  return i12 | 0;
 }
 i1 = i3 + 11 | 0;
 if (!(__Z10BeginsWithPKcS0_((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, HEAP32[gb + 44624 >> 2] | 0) | 0)) {
  i12 = 0;
  STACKTOP = i10;
  return i12 | 0;
 }
 i7 = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 i7 = i7 + (_strlen(HEAP32[gb + 44624 >> 2] | 0) | 0) | 0;
 i3 = i7;
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i12 = 6; else {
  i5 = -1;
  i6 = i7;
  while (1) {
   i5 = (i5 | 0) == -1 & i1 << 24 >> 24 == 46 ? i6 - i3 | 0 : i5;
   i2 = i6 + 1 | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break; else i6 = i2;
  }
  if ((i5 | 0) == -1) i12 = 6; else {
   i4 = i7 + i5 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   if (i5 >>> 0 > 4294967279) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
    i12 = 10;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i9 + 11 >> 0] = i5;
    if (!i5) {
     i1 = i9;
     i2 = 2;
    } else {
     i1 = i9;
     i12 = 12;
    }
   } else i12 = 10;
   if ((i12 | 0) == 10) {
    i3 = i5 + 16 & -16;
    i1 = __Znwj(i3) | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i9 + 8 >> 2] = i3 | -2147483648;
    HEAP32[i9 + 4 >> 2] = i5;
    i12 = 12;
   }
   if ((i12 | 0) == 12) {
    i2 = i1;
    i3 = i7;
    while (1) {
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + 1 | 0;
    }
    i1 = i1 + i5 | 0;
    i2 = i5 + 2 | 0;
   }
   HEAP8[i1 >> 0] = 0;
   i5 = i9 + 11 | 0;
   i1 = (__ZN9ShaderLab33GenerateFastPropertyName28BitHashEPKc((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0) & 268435455;
   i5 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
   HEAP32[i8 >> 2] = -1;
   __ZN9ShaderLab16FastPropertyName4InitEPKc(i8, i5);
   L24 : do if ((i2 | 0) == (_strlen(i7) | 0)) {
    i2 = HEAP8[i6 >> 0] | 0;
    switch (i2 | 0) {
    case 97:
    case 98:
    case 103:
    case 114:
     {
      i1 = i1 | 1073741824;
      break;
     }
    default:
     {}
    }
    switch (i2 | 0) {
    case 120:
    case 114:
     {
      i2 = 1;
      i1 = i1 & -805306369;
      break L24;
     }
    case 121:
    case 103:
     {
      i2 = 1;
      i1 = i1 & -805306369 | 268435456;
      break L24;
     }
    case 122:
    case 98:
     {
      i2 = 1;
      i1 = i1 & -805306369 | 536870912;
      break L24;
     }
    case 119:
    case 97:
     {
      i2 = 1;
      i1 = i1 | 805306368;
      break L24;
     }
    default:
     {
      i2 = 0;
      break L24;
     }
    }
   } else i2 = 0; while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   if (!i2) {
    i12 = 0;
    STACKTOP = i10;
    return i12 | 0;
   }
  }
 }
 if ((i12 | 0) == 6) {
  i1 = (__ZN9ShaderLab33GenerateFastPropertyName28BitHashEPKc(i7) | 0) & 268435455;
  HEAP32[i9 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(i9, i7);
  i1 = i1 | -2147483648;
 }
 HEAP32[i11 + 4 >> 2] = i1;
 i12 = 1;
 STACKTOP = i10;
 return i12 | 0;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = i1 + 4 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i20 | 0)) return;
 i14 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i14 + 56 >> 2] | 0;
 i15 = i14 + 4 | 0;
 i16 = i14 + 12 | 0;
 i17 = i14 + 20 | 0;
 i18 = i14 + 24 | 0;
 i10 = i14 + 60 | 0;
 i11 = i14 + 64 | 0;
 i12 = i14 + 68 | 0;
 i13 = i14 + 8 | 0;
 i14 = i14 + 16 | 0;
 L4 : while (1) {
  i6 = HEAP32[i2 >> 2] | 0;
  L6 : do if ((i9 | 0) == (i6 | 0)) {
   i7 = HEAP32[i10 >> 2] | 0;
   switch (i7 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i7;
   }
   i8 = HEAP32[i2 + 4 >> 2] | 0;
   switch (i8 | 0) {
   case 2:
   case 4:
    {
     i3 = 2;
     break;
    }
   default:
    i3 = i8;
   }
   if ((i1 | 0) == (i3 | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    i4 = i1 >>> 24 & 255;
    i5 = i3 >>> 24 & 255;
    if ((i1 & 65535) << 16 >> 16 == (i3 & 65535) << 16 >> 16) {
     if ((i1 >>> 16 & 255) << 24 >> 24 != (i3 >>> 16 & 255) << 24 >> 24) {
      switch (i7 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i21 = 15;
        break L6;
       }
      }
      switch (i8 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i21 = 15;
        break L6;
       }
      }
     }
     if (i4 << 24 >> 24 != i5 << 24 >> 24) i21 = 15;
    } else i21 = 15;
   } else i21 = 15; else i21 = 15;
  } else i21 = 15; while (0);
  if ((i21 | 0) == 15) {
   i21 = 0;
   if (!(HEAP8[i13 >> 0] | 0)) {
    i21 = 30;
    break;
   }
   if (!(HEAP32[i15 >> 2] | 0)) {
    i21 = 30;
    break;
   }
   if ((HEAP32[i16 >> 2] | 0) != (i6 | 0)) {
    i21 = 30;
    break;
   }
   i6 = HEAP32[i14 >> 2] | 0;
   switch (i6 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i6;
   }
   i7 = HEAP32[i2 + 4 >> 2] | 0;
   switch (i7 | 0) {
   case 2:
   case 4:
    {
     i3 = 2;
     break;
    }
   default:
    i3 = i7;
   }
   if ((i1 | 0) != (i3 | 0)) {
    i21 = 30;
    break;
   }
   if ((HEAP32[i17 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
    i21 = 30;
    break;
   }
   i1 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i4 = i1 >>> 24 & 255;
   i5 = i3 >>> 24 & 255;
   if ((i1 & 65535) << 16 >> 16 != (i3 & 65535) << 16 >> 16) {
    i21 = 30;
    break;
   }
   if ((i1 >>> 16 & 255) << 24 >> 24 != (i3 >>> 16 & 255) << 24 >> 24) {
    switch (i6 | 0) {
    case 2:
    case 4:
     break;
    default:
     {
      i21 = 30;
      break L4;
     }
    }
    switch (i7 | 0) {
    case 2:
    case 4:
     break;
    default:
     {
      i21 = 30;
      break L4;
     }
    }
   }
   if (i4 << 24 >> 24 != i5 << 24 >> 24) {
    i21 = 30;
    break;
   }
  }
  i2 = i2 + 44 | 0;
  HEAP32[i19 >> 2] = i2;
  if ((i2 | 0) == (i20 | 0)) {
   i21 = 30;
   break;
  }
 }
 if ((i21 | 0) == 30) return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 379401 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI15OcclusionPortalE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 379401 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI15OcclusionPortalE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 839370 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI15CapsuleColliderE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 839370 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI15CapsuleColliderE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863920 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863920 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 HEAP32[i14 >> 2] = i14;
 i10 = i14 + 4 | 0;
 HEAP32[i10 >> 2] = i14;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i15;
  return;
 }
 i9 = i12 + 8 | 0;
 if ((i14 | 0) == (i12 | 0)) {
  i5 = i2;
  do {
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   i2 = i5 + 4 | 0;
   if ((i4 | 0) == (HEAP32[i13 >> 2] | 0)) {
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = i3;
    L9 : do if ((i3 | 0) == (i12 | 0)) {
     i4 = 0;
     i3 = i12;
    } else while (1) {
     if ((HEAP32[i2 + 8 >> 2] | 0) != (i4 | 0)) {
      i4 = 1;
      break L9;
     }
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i3 = i2;
     if ((i3 | 0) == (i12 | 0)) {
      i4 = 0;
      i3 = i12;
      break;
     }
    } while (0);
    if ((i5 | 0) != (i3 | 0)) {
     i10 = HEAP32[i2 >> 2] | 0;
     i11 = i10 + 4 | 0;
     i9 = HEAP32[i5 >> 2] | 0;
     HEAP32[i9 + 4 >> 2] = HEAP32[i11 >> 2];
     HEAP32[HEAP32[i11 >> 2] >> 2] = i9;
     i9 = HEAP32[i14 >> 2] | 0;
     HEAP32[i9 + 4 >> 2] = i5;
     HEAP32[i1 >> 2] = i9;
     HEAP32[i14 >> 2] = i10;
     HEAP32[i11 >> 2] = i14;
    }
    if (i4) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i2;
   } else i1 = HEAP32[i2 >> 2] | 0;
   i5 = i1;
  } while ((i5 | 0) != (i12 | 0));
  STACKTOP = i15;
  return;
 } else {
  i3 = i14;
  i8 = 0;
 }
 while (1) {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i4 = i2 + 4 | 0;
  if ((i7 | 0) == (HEAP32[i13 >> 2] | 0)) {
   i5 = HEAP32[i4 >> 2] | 0;
   i4 = i5;
   L25 : do if ((i5 | 0) == (i12 | 0)) {
    i7 = 0;
    i6 = i12;
   } else {
    i6 = i5;
    while (1) {
     if ((HEAP32[i4 + 8 >> 2] | 0) != (i7 | 0)) {
      i7 = 1;
      break L25;
     }
     i4 = HEAP32[i6 + 4 >> 2] | 0;
     i6 = i4;
     if ((i6 | 0) == (i12 | 0)) {
      i7 = 0;
      i6 = i12;
      break;
     }
    }
   } while (0);
   if ((i2 | 0) == (i6 | 0)) i2 = i8; else {
    if ((i5 | 0) == (i6 | 0)) i3 = 1; else {
     i3 = 1;
     do {
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      i3 = i3 + 1 | 0;
     } while ((i5 | 0) != (i6 | 0));
    }
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i3;
    i8 = i8 + i3 | 0;
    HEAP32[i11 >> 2] = i8;
    i3 = HEAP32[i4 >> 2] | 0;
    i5 = i3 + 4 | 0;
    i16 = HEAP32[i2 >> 2] | 0;
    HEAP32[i16 + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[HEAP32[i5 >> 2] >> 2] = i16;
    i16 = HEAP32[i14 >> 2] | 0;
    HEAP32[i16 + 4 >> 2] = i2;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i5 >> 2] = i14;
    i2 = i8;
   }
   if (i7) {
    i1 = HEAP32[i6 + 4 >> 2] | 0;
    i4 = i2;
   } else {
    i1 = i4;
    i4 = i2;
   }
  } else {
   i1 = HEAP32[i4 >> 2] | 0;
   i4 = i8;
  }
  i2 = i1;
  if ((i2 | 0) == (i12 | 0)) break; else i8 = i4;
 }
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i16 = i3 + 4 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[HEAP32[i16 >> 2] >> 2] = i13;
 HEAP32[i11 >> 2] = 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 do {
  i16 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZdlPv(i16);
 } while ((i1 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZN15LODGroupManager21CalculateLODDataArrayERK13LODParametersPK6Cameraf(i12, i14, i15, i7, f16) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i7 = i7 | 0;
 f16 = Math_fround(f16);
 var i1 = 0, d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17;
 i1 = i17 + 8 | 0;
 if ((HEAP16[gb + 1161208 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161208 | 0, i6);
  i13 = gb + 1161208 | 0;
 } else i13 = 0;
 i10 = i14 + 36 | 0;
 i11 = i14 + 48 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 L4 : do if (!i4) i8 = 8; else {
  i5 = HEAP32[i10 >> 2] | 0;
  i3 = 0;
  while (1) {
   i1 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
   i3 = i3 + 1 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) break;
   if (i3 >>> 0 >= i4 >>> 0) {
    i8 = 8;
    break L4;
   }
  }
  if (!i1) i8 = 8;
 } while (0);
 if ((i8 | 0) == 8) {
  i9 = i14 + 40 | 0;
  i1 = __ZnwjRK10MemLabelIdiPKci(56, i9, 16, gb + 425023 | 0, 390) | 0;
  i8 = HEAP32[i14 + 16 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAPF64[i1 + 8 >> 3] = 0.0;
  HEAP32[i1 + 28 >> 2] = i8;
  HEAP32[i1 + 32 >> 2] = i8;
  i4 = i1 + 20 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i9);
  i18 = i6;
  i7 = HEAP32[i18 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i5 + 4 >> 2] = i7;
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, i4, 0, gb + 1047584 | 0, 446) | 0;
  i4 = i1 + 36 | 0;
  HEAP32[i1 + 48 >> 2] = i8;
  HEAP32[i1 + 52 >> 2] = i8;
  i7 = i1 + 40 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i9);
  i18 = i6;
  i3 = HEAP32[i18 + 4 >> 2] | 0;
  i6 = i7;
  HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 2, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
  HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
  HEAPF32[HEAP32[i4 >> 2] >> 2] = Math_fround(0.0);
  i4 = HEAP32[i11 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i14 + 52 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i3 = i7 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i8 >>> 0 < i3 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i3;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i3 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i18 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i10 >> 2] = i18;
    break;
   }
  } while (0);
  HEAP32[i11 >> 2] = i5;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = HEAP32[i1 + 28 >> 2];
 d2 = +__Z19GetTimeSinceStartupv();
 i1 = i1 + 8 | 0;
 if (d2 - +HEAPF64[i1 >> 3] > 1.0000000474974513e-03) {
  HEAPF64[i1 >> 3] = d2;
  __ZNK15LODGroupManager17CalculateLODMasksERK13LODParametersfPhPf(i14, i15, f16, i3, i4);
 }
 if (!i13) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i17;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwiw(i8, i3, i1, i6) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i2 | 0, i8 | 0, 1);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i4 = 23;
 } else L4 : do if (HEAP8[i2 >> 0] | 0) {
  do if ((i1 | 0) > 0) {
   i5 = i1 + -1 | 0;
   while (1) {
    if ((HEAP32[i7 >> 2] | 0) >= (i5 | 0)) {
     i1 = 0;
     i4 = 19;
     break;
    }
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (i4 & 1) {
      i4 = 12;
      break;
     }
    } else i1 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) == -1) {
     i1 = 2;
     i4 = 19;
     break;
    }
    if ((i1 | 0) == (i6 | 0)) {
     i1 = 0;
     i4 = 19;
     break;
    }
    i4 = i3 + 4 | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i3 = __THREW__;
     __THREW__ = 0;
     if (i3 & 1) {
      i4 = 18;
      break;
     } else {
      i3 = i4;
      continue;
     }
    } else {
     HEAP32[i2 >> 2] = i3 + 4;
     i3 = i4;
     continue;
    }
   }
   if ((i4 | 0) == 12) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   } else if ((i4 | 0) == 18) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   } else if ((i4 | 0) == 19) {
    HEAP32[i3 >> 2] = 0;
    i6 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | ((HEAP32[i7 >> 2] | 0) == 0 ? i1 | 4 : i1) | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break L4;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    break;
   }
  } else {
   i7 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 4 | 0);
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) break L4;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  i4 = 23;
  break L1;
 } while (0); while (0);
 do if ((i4 | 0) == 23) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore19getParticleReadDataERNS_23PxParticleFluidReadDataE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 40 | 0;
 i17 = i18;
 i16 = ((mftCall_ii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0) | 0) & 4) != 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 20 >> 2] = 12;
 HEAP32[i15 + 24 >> 2] = 0;
 HEAP32[i15 + 28 >> 2] = 12;
 HEAP32[i15 + 32 >> 2] = 0;
 i12 = i15 + 36 | 0;
 HEAP32[i12 >> 2] = 4;
 HEAP32[i15 + 40 >> 2] = 0;
 HEAP32[i15 + 44 >> 2] = 4;
 i13 = i7 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) i1 = HEAP32[i7 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i15 | 0, 0, i16 | 0);
 HEAP32[i6 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 i2 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = i2;
 i1 = HEAP32[i15 + 12 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 12;
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 12;
 i5 = i6 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 4;
 i8 = i6 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i6 + 44 | 0;
 HEAP32[i9 >> 2] = 2;
 i10 = i6 + 48 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = 12;
 i11 = i6 + 56 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i6 + 60 >> 2] = 12;
 i14 = i6 + 64 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 4;
 if (!i2) {
  STACKTOP = i18;
  return;
 }
 i2 = i7 + 132 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 if (i1 & 1) {
  i6 = i15 + 16 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i3;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = HEAP16[i2 >> 1] | 0;
 }
 if (i1 & 2) {
  i6 = i15 + 24 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = HEAP16[i2 >> 1] | 0;
 }
 if (i1 & 4) {
  i6 = i15 + 40 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = HEAP16[i2 >> 1] | 0;
 }
 if (i1 & 8) {
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i15 + 32 >> 2];
  HEAP32[i9 >> 2] = i12;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i18;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 4;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 12;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 12;
 HEAP32[i17 + 24 >> 2] = 0;
 HEAP32[i17 + 28 >> 2] = 12;
 HEAP32[i17 + 32 >> 2] = 0;
 HEAP32[i17 + 36 >> 2] = 4;
 __ZNK5physx2Sc17ParticleSystemSim18getSimParticleDataERNS_28PxvParticleSystemSimDataDescEb(i1, i17, i16);
 i1 = HEAP16[i2 >> 1] | 0;
 if (i1 & 16) {
  i15 = i17 + 8 | 0;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i1 = i10;
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 4 >> 2] = i16;
  i1 = HEAP16[i2 >> 1] | 0;
 }
 if (i1 & 32) {
  i15 = i17 + 16 | 0;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 4 >> 2] = i16;
  i1 = HEAP16[i2 >> 1] | 0;
 }
 if (i1 & 64) {
  i15 = i17;
  i16 = HEAP32[i15 + 4 >> 2] | 0;
  i17 = i14;
  HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
 }
 STACKTOP = i18;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905685 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN21AnimationClipOverride8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905685 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN21AnimationClipOverride8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_(i31, i32, i25, i10, i29) {
 i31 = i31 | 0;
 i32 = i32 | 0;
 i25 = i25 | 0;
 i10 = i10 | 0;
 i29 = i29 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0, i28 = 0, i30 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0;
 i33 = __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_(i31, i32, i25, i29) | 0;
 if (!(mftCall_iii(HEAP32[i29 >> 2] | 0, i10 | 0, i25 | 0) | 0)) {
  i36 = i33;
  return i36 | 0;
 }
 i11 = HEAP32[i25 >> 2] | 0;
 i30 = i25 + 4 | 0;
 i1 = HEAP32[i30 >> 2] | 0;
 i20 = i25 + 8 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i21 = i25 + 12 | 0;
 i3 = HEAP32[i21 >> 2] | 0;
 i22 = i25 + 16 | 0;
 i4 = HEAP32[i22 >> 2] | 0;
 i23 = i25 + 20 | 0;
 i5 = HEAP32[i23 >> 2] | 0;
 i24 = i25 + 24 | 0;
 i6 = HEAP32[i24 >> 2] | 0;
 i26 = i25 + 28 | 0;
 i7 = HEAP32[i26 >> 2] | 0;
 i27 = i25 + 32 | 0;
 i8 = HEAP32[i27 >> 2] | 0;
 i28 = i25 + 36 | 0;
 i9 = HEAP32[i28 >> 2] | 0;
 i34 = i25;
 i35 = i10;
 i36 = i34 + 40 | 0;
 do {
  HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
  i34 = i34 + 4 | 0;
  i35 = i35 + 4 | 0;
 } while ((i34 | 0) < (i36 | 0));
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = i2;
 HEAP32[i10 + 12 >> 2] = i3;
 HEAP32[i10 + 16 >> 2] = i4;
 HEAP32[i10 + 20 >> 2] = i5;
 HEAP32[i10 + 24 >> 2] = i6;
 HEAP32[i10 + 28 >> 2] = i7;
 HEAP32[i10 + 32 >> 2] = i8;
 HEAP32[i10 + 36 >> 2] = i9;
 if (!(mftCall_iii(HEAP32[i29 >> 2] | 0, i25 | 0, i32 | 0) | 0)) {
  i36 = i33 + 1 | 0;
  return i36 | 0;
 }
 i1 = HEAP32[i32 >> 2] | 0;
 i11 = i32 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i32 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i32 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i14 = i32 + 16 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i15 = i32 + 20 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i16 = i32 + 24 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 i17 = i32 + 28 | 0;
 i8 = HEAP32[i17 >> 2] | 0;
 i18 = i32 + 32 | 0;
 i9 = HEAP32[i18 >> 2] | 0;
 i19 = i32 + 36 | 0;
 i10 = HEAP32[i19 >> 2] | 0;
 i34 = i32;
 i35 = i25;
 i36 = i34 + 40 | 0;
 do {
  HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
  i34 = i34 + 4 | 0;
  i35 = i35 + 4 | 0;
 } while ((i34 | 0) < (i36 | 0));
 HEAP32[i25 >> 2] = i1;
 HEAP32[i30 >> 2] = i2;
 HEAP32[i20 >> 2] = i3;
 HEAP32[i21 >> 2] = i4;
 HEAP32[i22 >> 2] = i5;
 HEAP32[i23 >> 2] = i6;
 HEAP32[i24 >> 2] = i7;
 HEAP32[i26 >> 2] = i8;
 HEAP32[i27 >> 2] = i9;
 HEAP32[i28 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i29 >> 2] | 0, i32 | 0, i31 | 0) | 0)) {
  i36 = i33 + 2 | 0;
  return i36 | 0;
 }
 i1 = HEAP32[i31 >> 2] | 0;
 i2 = HEAP32[i31 + 4 >> 2] | 0;
 i3 = HEAP32[i31 + 8 >> 2] | 0;
 i4 = HEAP32[i31 + 12 >> 2] | 0;
 i5 = HEAP32[i31 + 16 >> 2] | 0;
 i6 = HEAP32[i31 + 20 >> 2] | 0;
 i7 = HEAP32[i31 + 24 >> 2] | 0;
 i8 = HEAP32[i31 + 28 >> 2] | 0;
 i9 = HEAP32[i31 + 32 >> 2] | 0;
 i10 = HEAP32[i31 + 36 >> 2] | 0;
 i34 = i31;
 i35 = i32;
 i36 = i34 + 40 | 0;
 do {
  HEAP32[i34 >> 2] = HEAP32[i35 >> 2];
  i34 = i34 + 4 | 0;
  i35 = i35 + 4 | 0;
 } while ((i34 | 0) < (i36 | 0));
 HEAP32[i32 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i15 >> 2] = i6;
 HEAP32[i16 >> 2] = i7;
 HEAP32[i17 >> 2] = i8;
 HEAP32[i18 >> 2] = i9;
 HEAP32[i19 >> 2] = i10;
 i36 = i33 + 3 | 0;
 return i36 | 0;
}

function __ZN4math8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i6 + 12 | 0, i1);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6 + 28 | 0, gb + 1085935 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = i1 + 4 | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i20 | 0)) return;
 i14 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i14 + 56 >> 2] | 0;
 i15 = i14 + 4 | 0;
 i16 = i14 + 12 | 0;
 i17 = i14 + 20 | 0;
 i18 = i14 + 24 | 0;
 i10 = i14 + 60 | 0;
 i11 = i14 + 64 | 0;
 i12 = i14 + 68 | 0;
 i13 = i14 + 8 | 0;
 i14 = i14 + 16 | 0;
 L4 : while (1) {
  i6 = HEAP32[i2 >> 2] | 0;
  L6 : do if ((i9 | 0) == (i6 | 0)) {
   i7 = HEAP32[i10 >> 2] | 0;
   switch (i7 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i7;
   }
   i8 = HEAP32[i2 + 4 >> 2] | 0;
   switch (i8 | 0) {
   case 2:
   case 4:
    {
     i3 = 2;
     break;
    }
   default:
    i3 = i8;
   }
   if ((i1 | 0) == (i3 | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    i4 = i1 >>> 24 & 255;
    i5 = i3 >>> 24 & 255;
    if ((i1 & 65535) << 16 >> 16 == (i3 & 65535) << 16 >> 16) {
     if ((i1 >>> 16 & 255) << 24 >> 24 != (i3 >>> 16 & 255) << 24 >> 24) {
      switch (i7 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i21 = 15;
        break L6;
       }
      }
      switch (i8 | 0) {
      case 2:
      case 4:
       break;
      default:
       {
        i21 = 15;
        break L6;
       }
      }
     }
     if (i4 << 24 >> 24 != i5 << 24 >> 24) i21 = 15;
    } else i21 = 15;
   } else i21 = 15; else i21 = 15;
  } else i21 = 15; while (0);
  if ((i21 | 0) == 15) {
   i21 = 0;
   if (!(HEAP8[i13 >> 0] | 0)) {
    i21 = 30;
    break;
   }
   if (!(HEAP32[i15 >> 2] | 0)) {
    i21 = 30;
    break;
   }
   if ((HEAP32[i16 >> 2] | 0) != (i6 | 0)) {
    i21 = 30;
    break;
   }
   i6 = HEAP32[i14 >> 2] | 0;
   switch (i6 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    i1 = i6;
   }
   i7 = HEAP32[i2 + 4 >> 2] | 0;
   switch (i7 | 0) {
   case 2:
   case 4:
    {
     i3 = 2;
     break;
    }
   default:
    i3 = i7;
   }
   if ((i1 | 0) != (i3 | 0)) {
    i21 = 30;
    break;
   }
   if ((HEAP32[i17 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
    i21 = 30;
    break;
   }
   i1 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i4 = i1 >>> 24 & 255;
   i5 = i3 >>> 24 & 255;
   if ((i1 & 65535) << 16 >> 16 != (i3 & 65535) << 16 >> 16) {
    i21 = 30;
    break;
   }
   if ((i1 >>> 16 & 255) << 24 >> 24 != (i3 >>> 16 & 255) << 24 >> 24) {
    switch (i6 | 0) {
    case 2:
    case 4:
     break;
    default:
     {
      i21 = 30;
      break L4;
     }
    }
    switch (i7 | 0) {
    case 2:
    case 4:
     break;
    default:
     {
      i21 = 30;
      break L4;
     }
    }
   }
   if (i4 << 24 >> 24 != i5 << 24 >> 24) {
    i21 = 30;
    break;
   }
  }
  i2 = i2 + 44 | 0;
  HEAP32[i19 >> 2] = i2;
  if ((i2 | 0) == (i20 | 0)) {
   i21 = 30;
   break;
  }
 }
 if ((i21 | 0) == 30) return;
}

function __ZN5physx2Sc5Scene29processNarrowPhaseTouchEventsEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i7 = i16 + 24 | 0;
 i11 = i16 + 20 | 0;
 i6 = i16 + 16 | 0;
 i13 = i16 + 8 | 0;
 i12 = i16;
 i4 = i16 + 48 | 0;
 i5 = HEAP32[(HEAP32[i15 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_(i5, i7, i11, 0) | 0;
 i2 = HEAP32[i7 >> 2] << 3;
 i9 = i2 >>> 0 > 1024;
 i10 = i13 + 4 | 0;
 HEAP8[i10 >> 0] = i9 & 1;
 if (i9) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i16 + 49 | 0, i2, gb + 680241 | 0, 1224) | 0;
  HEAP32[i13 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i13 >> 2] = i1;
 }
 i3 = HEAP32[i11 >> 2] << 3;
 i8 = i3 >>> 0 > 1024;
 i9 = i12 + 4 | 0;
 HEAP8[i9 >> 0] = i8 & 1;
 if (i8) {
  i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i4, i3, gb + 680241 | 0, 1225) | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = i13;
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i12 >> 2] = i2;
  i3 = i13;
 }
 __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_(i5, i1, i7, i2, i11, 0, i6) | 0;
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, 0, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 }
 if ((HEAP32[i11 >> 2] | 0) > 0) {
  i2 = i14 + 4 | 0;
  i3 = i14 + 8 | 0;
  i4 = i14 + 12 | 0;
  i5 = i15 + 1240 | 0;
  i6 = i15 + 1248 | 0;
  i7 = i15 + 1244 | 0;
  i8 = 0;
  do {
   i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 3) + 4 >> 2] | 0;
   if (__ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb(i1, 0, 1) | 0) if (!(HEAP32[i1 + 44 >> 2] & 262144)) {
    i17 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 + 32 >> 2] | 0) | 0;
    i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
    HEAP32[i14 >> 2] = i17;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i3 >> 2] = HEAP32[i17 + 56 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i1 + 56 >> 2];
    i1 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     i17 = (HEAP32[i5 >> 2] | 0) + (i1 << 4) | 0;
     HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i17 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i17 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP32[i17 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    } else __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i14) | 0;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) < (HEAP32[i11 >> 2] | 0));
 }
 __ZN5physx2Sc10NPhaseCore30processPersistentContactEventsEv(HEAP32[i15 + 1104 >> 2] | 0);
 if (HEAP8[i9 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = i14 + 8 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i16 = i14 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (((i3 - i1 | 0) / 40 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i15 = i1 + 8 | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   HEAP32[i15 + 12 >> 2] = 0;
   HEAP32[i15 + 16 >> 2] = 0;
   HEAP32[i15 + 20 >> 2] = 0;
   HEAP32[i15 + 24 >> 2] = 0;
   HEAP32[i15 + 28 >> 2] = 0;
   i1 = (HEAP32[i16 >> 2] | 0) + 40 | 0;
   HEAP32[i16 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 40 | 0) + i2 | 0;
 if (i5 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i3 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 i13 = (i3 - i4 | 0) / 40 | 0;
 i3 = i13 << 1;
 i3 = i13 >>> 0 < 53687091 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 107374182;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 40 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 40 | 0) * 40 | 0) | 0;
 i4 = i6;
 i3 = i5 + (i3 * 40 | 0) | 0;
 i13 = i4;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  i12 = i1 + 8 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  i1 = i13 + 40 | 0;
  i13 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i12 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i12 | 0)) {
  i2 = i4;
  i7 = i12;
  i1 = i12;
 } else {
  i2 = i4;
  i5 = i6;
  do {
   i9 = i1;
   i1 = i1 + -40 | 0;
   HEAP32[i5 + -40 >> 2] = HEAP32[i1 >> 2];
   i6 = i5 + -32 | 0;
   i7 = i9 + -32 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = i5 + -16 | 0;
   i7 = i9 + -16 | 0;
   HEAP32[i6 >> 2] = 0;
   i11 = i5 + -12 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i5 + -8 >> 2] = 0;
   i9 = i9 + -12 | 0;
   i4 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = i4 >> 2;
   if (i8 | 0) {
    if (i8 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
    i10 = __Znwj(i4) | 0;
    HEAP32[i11 >> 2] = i10;
    HEAP32[i6 >> 2] = i10;
    HEAP32[i5 + -8 >> 2] = i10 + (i8 << 2);
    i5 = HEAP32[i7 >> 2] | 0;
    i4 = (HEAP32[i9 >> 2] | 0) - i5 | 0;
    if ((i4 | 0) > 0) {
     _memcpy(i10 | 0, i5 | 0, i4 | 0) | 0;
     HEAP32[i11 >> 2] = i10 + (i4 >> 2 << 2);
    }
   }
   i5 = i2 + -40 | 0;
   i2 = i5;
  } while ((i1 | 0) != (i12 | 0));
  i7 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i15 >> 2] = i3;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) do {
  i2 = HEAP32[i1 + -16 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + -12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i2);
  }
  i1 = i1 + -40 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if (!i7) return;
 __ZdlPv(i7);
 return;
}

function __ZN5physx2Sc9ClothCore12initLowLevelERKNS_11PxTransformEPKNS_15PxClothParticleE(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 40 | 0;
 i5 = i14 + 16 | 0;
 i2 = i14 + 8 | 0;
 i8 = i14;
 i4 = i12 + 32 | 0;
 i9 = __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv(HEAP32[i4 >> 2] | 0) | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14 + 48 | 0, i9 * 20 | 0, gb + 690557 | 0, 125) | 0;
 i10 = i12 + 40 | 0;
 HEAP32[i10 >> 2] = i6;
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 if (i9 | 0) {
  i3 = 0;
  i6 = 0;
  do {
   __ZN5physx5cloth11PhaseConfigC2Et(i5, i6);
   i15 = (HEAP32[i10 >> 2] | 0) + (i3 * 20 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   i6 = i6 + 1 << 16 >> 16;
   i3 = i6 & 65535;
  } while (i3 >>> 0 < i9 >>> 0);
 }
 i3 = i7 + ((__ZNK5physx2Sc15ClothFabricCore14getNbParticlesEv(HEAP32[i4 >> 2] | 0) | 0) << 4) | 0;
 i15 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i3;
 i3 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = mftCall_iiii(i6 | 0, i15 | 0, i13 | 0, i3 | 0) | 0;
 i3 = i12 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i11 + 16 | 0);
 i15 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 56 >> 2] | 0, i15 | 0, i11 | 0);
 i15 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 68 >> 2] | 0, i15 | 0);
 i10 = HEAP32[i10 >> 2] | 0;
 i15 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i15 >> 2] | 0) + 160 >> 2] | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i10 + (i9 * 20 | 0);
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 mftCall_vii(i11 | 0, i15 | 0, i13 | 0);
 i15 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 212 >> 2] | 0, i15 | 0, (HEAP16[i12 + 60 >> 1] & 2) != 0 | 0);
 i15 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 400 >> 2] | 0, i15 | 0, i12 | 0);
 f1 = Math_fround(HEAPF32[gb + 92912 >> 2]);
 if (f1 > Math_fround(4294967.0)) {
  i15 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 368 >> 2] | 0, i15 | 0, -1);
  STACKTOP = i14;
  return;
 }
 i12 = ~~Math_fround(f1 * Math_fround(1.0e3)) >>> 0;
 i13 = (i12 >>> 0) / 5 | 0;
 i13 = i13 >>> 0 < 200 ? i13 : 200;
 i13 = i13 >>> 0 > 1 ? i13 : 1;
 i15 = HEAP32[i3 >> 2] | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 388 >> 2] | 0, i15 | 0) | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 368 >> 2] | 0, i11 | 0, i13 | 0);
 i11 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 376 >> 2] | 0, i11 | 0, (i12 >>> 0) / (i13 >>> 0) | 0 | 0);
 if (!(f1 == Math_fround(0.0) & i15)) {
  STACKTOP = i14;
  return;
 }
 i15 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 392 >> 2] | 0, i15 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5Umbra20RuntimeTomeGeneratorC2EPNS_9AllocatorES2_jPPKNS_7ImpTomeEiRKNS_4AABBE(i7, i1, i2, i3, i4, i5, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i1 = i7 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = i3;
 HEAP32[i7 + 56 >> 2] = i4;
 HEAP32[i7 + 60 >> 2] = i5;
 i1 = i7 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
 }
 HEAP32[i1 >> 2] = gb + 1451688;
 HEAP32[i7 + 68 >> 2] = 0;
 HEAP32[i7 + 72 >> 2] = 0;
 HEAP32[i7 + 76 >> 2] = 0;
 HEAP32[i7 + 80 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 84 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 88 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 92 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 96 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 100 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAPF32[i7 + 104 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 112 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 116 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i7 + 120 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i7 + 124 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAP32[i7 + 128 >> 2] = gb + 1451688;
 i5 = i7 + 132 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 + 144 >> 2] = gb + 1451688;
 i5 = i7 + 148 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 + 160 >> 2] = gb + 1451688;
 i5 = i7 + 164 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 + 176 >> 2] = gb + 1451688;
 i5 = i7 + 180 | 0;
 i8 = i7 + 212 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i5 + 16 >> 0] = 0;
 HEAP32[i7 + 228 >> 2] = gb + 1451688;
 i5 = i7 + 232 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 + 244 >> 2] = gb + 1451688;
 i5 = i7 + 248 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i7 + 268 >> 2] = gb + 1451688;
 i5 = i7 + 272 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 + 284 >> 2] = gb + 1451688;
 HEAP32[i7 + 288 >> 2] = 0;
 HEAP32[i7 + 292 >> 2] = 0;
 HEAP32[i7 + 296 >> 2] = 0;
 HEAP32[i7 + 440 >> 2] = gb + 1451688;
 i5 = i7 + 444 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i7 + 200 >> 2] = 1;
 HEAP32[i7 + 204 >> 2] = gb + 78644;
 HEAP32[i7 + 208 >> 2] = gb + 78644 + 4;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 902577 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI13MonoBehaviourE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 902577 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI13MonoBehaviourE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905722 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905722 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14Texture2DArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9);
 i1 = i8 + 80 | 0;
 i11 = i9 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 88 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i6 = i8 + 92 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
  i5 = i2;
  i3 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i5 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 i1 = i8 + 76 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i8 + 100 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
 __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 32 | 0, i9);
 i1 = i8 + 60 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 109 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  i11 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = i11;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i9, i10, gb + 411165 | 0, 1);
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i8 + 96 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i9, i10, i11, 0);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  i11 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = i11;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i9, i10, gb + 411165 | 0, 1);
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i8 + 96 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i9, i10, i11, 0);
  STACKTOP = i12;
  return;
 }
}

function __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(i6, i11) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = HEAP32[i6 + 132 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i10 = 4; else {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i10 = 4; else {
   HEAP32[i5 >> 2] = i2;
   i9 = i1;
  }
 }
 if ((i10 | 0) == 4) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i9 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i11 = 0;
   return i11 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i1 = i1 - i3 | 0;
   i9 = i2;
   i2 = i4 + i1 | 0;
   HEAP32[i2 >> 2] = i9;
  } while ((i1 | 0) != 4);
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  if (!i2) {
   i11 = 0;
   return i11 | 0;
  } else i9 = i2;
 }
 i8 = i9 + 32 | 0;
 i1 = i11 + 4 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i7 = i7 >>> 0 < i11 >>> 0 ? i7 : i11;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[HEAP32[i3 + 4 >> 2] >> 2] = i9;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = i8;
 i2 = i9 + 8 | 0;
 HEAP32[i2 >> 2] = i9;
 HEAP32[i9 + 12 >> 2] = i8;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = i9;
 HEAP32[i9 + 40 >> 2] = i8;
 HEAP32[i9 + 44 >> 2] = i9;
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = HEAP32[i11 + 12 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + 12 >> 2] = i3;
 HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i9;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i5 >> 2] = i9;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i5 = HEAP32[i6 + 136 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i10 = 11; else {
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i10 = 11; else HEAP32[i5 >> 2] = i3;
 }
 do if ((i10 | 0) == 11) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i10 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i11 = 0;
   return i11 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   i1 = i1 - i3 | 0;
   i10 = i2;
   i2 = i4 + i1 | 0;
   HEAP32[i2 >> 2] = i10;
  } while ((i1 | 0) != 4);
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  if (!i2) {
   i11 = 0;
   return i11 | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  }
 } while (0);
 i10 = i1 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i2 + 8 >> 2] = i8;
 i1 = i8;
 do {
  HEAP32[i1 + 16 >> 2] = i2;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 } while ((i1 | 0) != (i8 | 0));
 i11 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i9 + 52 >> 2] = i11;
 HEAP32[i9 + 20 >> 2] = i11;
 i11 = i9;
 return i11 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_(i3, i1, i7, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = i5;
 if ((i5 | 0) != (i4 | 0)) {
  i2 = i5 + 16 | 0;
  if (!(__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0)) {
   if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
    HEAP32[i7 >> 2] = i1;
    return i7 | 0;
   }
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i5;
    while (1) {
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
   if ((i2 | 0) != (i4 | 0)) if (!(__ZNK18VertexChannelsInfoltERKS_(i6, i2 + 16 | 0) | 0)) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) {
     HEAP32[i7 >> 2] = i4;
     i7 = i4;
     return i7 | 0;
    }
    while (1) {
     i2 = i1 + 16 | 0;
     if (__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 34;
       break;
      } else i1 = i2;
     } else {
      if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
       i4 = 39;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 38;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 34) {
     HEAP32[i7 >> 2] = i1;
     i7 = i1;
     return i7 | 0;
    } else if ((i4 | 0) == 38) {
     HEAP32[i7 >> 2] = i1;
     i7 = i3;
     return i7 | 0;
    } else if ((i4 | 0) == 39) {
     HEAP32[i7 >> 2] = i1;
     return i7 | 0;
    }
   }
   i1 = i5 + 4 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    HEAP32[i7 >> 2] = i5;
    i7 = i1;
    return i7 | 0;
   } else {
    HEAP32[i7 >> 2] = i2;
    i7 = i2;
    return i7 | 0;
   }
  }
 }
 if ((i5 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i2 = i5;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if (!(__ZNK18VertexChannelsInfoltERKS_(i1 + 16 | 0, i6) | 0)) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    HEAP32[i7 >> 2] = i4;
    i7 = i4;
    return i7 | 0;
   }
   while (1) {
    i2 = i1 + 16 | 0;
    if (__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 14;
      break;
     } else i1 = i2;
    } else {
     if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
      i4 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 14) {
    HEAP32[i7 >> 2] = i1;
    i7 = i1;
    return i7 | 0;
   } else if ((i4 | 0) == 18) {
    HEAP32[i7 >> 2] = i1;
    i7 = i3;
    return i7 | 0;
   } else if ((i4 | 0) == 19) {
    HEAP32[i7 >> 2] = i1;
    return i7 | 0;
   }
  }
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP32[i7 >> 2] = i5;
  i7 = i5;
  return i7 | 0;
 } else {
  i6 = i1;
  HEAP32[i7 >> 2] = i6;
  i7 = i6 + 4 | 0;
  return i7 | 0;
 }
 return 0;
}

function __ZNKSt3__220__time_get_c_storageIwE7__weeksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099952 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099952 | 0) | 0) {
  if (!(HEAP8[gb + 1099960 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099960 | 0) | 0) {
   i2 = gb + 1476072 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1476072 + 168 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1150 | 0, gb + 1476072 | 0, gb + 210784 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1150 | 0, gb + 1476072 + 12 | 0, gb + 210812 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __THREW__ = 0;
    invoke_iii(fb + 1150 | 0, gb + 1476072 + 24 | 0, gb + 210840 | 0) | 0;
    i2 = __THREW__;
    __THREW__ = 0;
    if (!(i2 & 1)) {
     __THREW__ = 0;
     invoke_iii(fb + 1150 | 0, gb + 1476072 + 36 | 0, gb + 210872 | 0) | 0;
     i2 = __THREW__;
     __THREW__ = 0;
     if (!(i2 & 1)) {
      __THREW__ = 0;
      invoke_iii(fb + 1150 | 0, gb + 1476072 + 48 | 0, gb + 210912 | 0) | 0;
      i2 = __THREW__;
      __THREW__ = 0;
      if (!(i2 & 1)) {
       __THREW__ = 0;
       invoke_iii(fb + 1150 | 0, gb + 1476072 + 60 | 0, gb + 210948 | 0) | 0;
       i2 = __THREW__;
       __THREW__ = 0;
       if (!(i2 & 1)) {
        __THREW__ = 0;
        invoke_iii(fb + 1150 | 0, gb + 1476072 + 72 | 0, gb + 210976 | 0) | 0;
        i2 = __THREW__;
        __THREW__ = 0;
        if (!(i2 & 1)) {
         __THREW__ = 0;
         invoke_iii(fb + 1150 | 0, gb + 1476072 + 84 | 0, gb + 211012 | 0) | 0;
         i2 = __THREW__;
         __THREW__ = 0;
         if (!(i2 & 1)) {
          __THREW__ = 0;
          invoke_iii(fb + 1150 | 0, gb + 1476072 + 96 | 0, gb + 211028 | 0) | 0;
          i2 = __THREW__;
          __THREW__ = 0;
          if (!(i2 & 1)) {
           __THREW__ = 0;
           invoke_iii(fb + 1150 | 0, gb + 1476072 + 108 | 0, gb + 211044 | 0) | 0;
           i2 = __THREW__;
           __THREW__ = 0;
           if (!(i2 & 1)) {
            __THREW__ = 0;
            invoke_iii(fb + 1150 | 0, gb + 1476072 + 120 | 0, gb + 211060 | 0) | 0;
            i2 = __THREW__;
            __THREW__ = 0;
            if (!(i2 & 1)) {
             __THREW__ = 0;
             invoke_iii(fb + 1150 | 0, gb + 1476072 + 132 | 0, gb + 211076 | 0) | 0;
             i2 = __THREW__;
             __THREW__ = 0;
             if (!(i2 & 1)) {
              __THREW__ = 0;
              invoke_iii(fb + 1150 | 0, gb + 1476072 + 144 | 0, gb + 211092 | 0) | 0;
              i2 = __THREW__;
              __THREW__ = 0;
              if (!(i2 & 1)) {
               __THREW__ = 0;
               invoke_iii(fb + 1150 | 0, gb + 1476072 + 156 | 0, gb + 211108 | 0) | 0;
               i2 = __THREW__;
               __THREW__ = 0;
               if (!(i2 & 1)) {
                HEAP32[gb + 1476240 >> 2] = gb + 1476072;
                break;
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1476240 >> 2] | 0;
}

function __ZN14MessageHandler16ResolveCallbacksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i12 = i15 + 16 | 0;
 i13 = i8 + 28 | 0;
 i6 = i8 + 32 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i2 = i3;
  i1 = i3;
 } else {
  i7 = (HEAP32[i8 >> 2] | 0) + 44 | 0;
  i5 = 0;
  i2 = i3;
  do {
   i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + 4 + (i5 << 2) >> 2] | 0;
   if (i3) {
    i4 = i1;
    i3 = HEAP32[i3 >> 2] | 0;
    if (i3) {
     __ZN16MessageForwarder15AddBaseMessagesERKS_(i4 + (i5 << 5) | 0, i4 + (HEAP32[i3 + 24 >> 2] << 5) | 0);
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) do {
      i11 = HEAP32[i13 >> 2] | 0;
      __ZN16MessageForwarder15AddBaseMessagesERKS_(i11 + (i5 << 5) | 0, i11 + (HEAP32[i1 + 24 >> 2] << 5) | 0);
      i1 = HEAP32[i1 >> 2] | 0;
     } while ((i1 | 0) != 0);
     i2 = HEAP32[i6 >> 2] | 0;
     i1 = HEAP32[i13 >> 2] | 0;
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 - i1 >> 5 >>> 0);
 }
 i10 = HEAP32[i8 + 72 >> 2] | 0;
 i11 = i8 + 48 | 0;
 HEAP32[i11 >> 2] = i10;
 i1 = i2 - i1 >> 5;
 i9 = i8 + 44 | 0;
 HEAP32[i9 >> 2] = i1;
 __ZN14dynamic_bitset6resizeEjb(i8 + 8 | 0, Math_imul(i1, i10) | 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i10 = i8 + 52 | 0;
 i8 = i8 + 16 | 0;
 i7 = 0;
 i2 = i1;
 i1 = HEAP32[i11 >> 2] | 0;
 do {
  if ((i1 | 0) > 0) {
   i6 = 0;
   do {
    i3 = HEAP32[i13 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i1 = HEAP32[i5 + (i6 * 20 | 0) + 8 >> 2] | 0;
    i2 = HEAP32[i3 + (i7 << 5) >> 2] | 0;
    i4 = (HEAP32[i3 + (i7 << 5) + 4 >> 2] | 0) - i2 >> 2;
    if ((i1 | 0) < (i4 | 0)) if (!(HEAP32[i2 + (i1 << 2) >> 2] | 0)) i2 = 17; else i2 = 19; else i2 = 17;
    if ((i2 | 0) == 17) if (!(HEAP32[i3 + (i7 << 5) + 24 >> 2] | 0)) i2 = 25; else if (!(HEAP32[i5 + (i6 * 20 | 0) + 16 >> 2] & 1)) i2 = 25; else i2 = 19;
    do if ((i2 | 0) == 19) {
     i2 = 0;
     if ((i4 | 0) > (i6 | 0)) {
      i1 = HEAP32[(HEAP32[i3 + (i7 << 5) + 12 >> 2] | 0) + (i6 << 2) >> 2] | 0;
      i3 = HEAP32[i5 + (i6 * 20 | 0) + 12 >> 2] | 0;
      if (!((i1 | 0) == 0 | (i3 | 0) == (i1 | 0))) {
       i2 = HEAP32[i1 + 8 >> 2] | 0;
       if (!i3) i1 = gb + 448034 | 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
       HEAP32[i14 >> 2] = HEAP32[i5 + (i6 * 20 | 0) >> 2];
       HEAP32[i14 + 4 >> 2] = i7;
       HEAP32[i14 + 8 >> 2] = i2;
       HEAP32[i14 + 12 >> 2] = i1;
       _snprintf(i12, 4096, gb + 370616 | 0, i14) | 0;
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i12, 0, gb + 370750 | 0, 245, 1, 0, 0, 0);
       i2 = 25;
       break;
      }
     }
     i4 = (Math_imul(HEAP32[i9 >> 2] | 0, i6) | 0) + i7 | 0;
     i5 = (HEAP32[i8 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1 << (i4 & 31);
    } while (0);
    if ((i2 | 0) == 25) {
     i4 = (Math_imul(HEAP32[i9 >> 2] | 0, i6) | 0) + i7 | 0;
     i5 = (HEAP32[i8 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~(1 << (i4 & 31));
    }
    i6 = i6 + 1 | 0;
    i1 = HEAP32[i11 >> 2] | 0;
   } while ((i6 | 0) < (i1 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i2 | 0));
 STACKTOP = i15;
 return;
}

function __ZNK5physx33PxConvexMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEEEEjT_j(i13, i11, i12) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i9 = i14 + 92 | 0;
 i10 = i14 + 64 | 0;
 i6 = i14 + 32 | 0;
 i7 = HEAP32[i13 + 8 >> 2] | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i15 = i8;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i15 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i15;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i13 = i13 + 16 | 0;
  i15 = i12 + 1 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i13, i15);
  i15 = i12 + 2 | 0;
  STACKTOP = i14;
  return i15 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i13 = i13 + 16 | 0;
 i15 = i12 + 1 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i13, i15);
 i15 = i12 + 2 | 0;
 STACKTOP = i14;
 return i15 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i18 = i4 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i4 + 8 | 0;
 i20 = i2 + 8 | 0;
 i10 = HEAP16[i20 >> 1] | 0;
 HEAP8[i19 >> 0] = i10;
 i17 = i4 + 9 | 0;
 HEAP8[i17 >> 0] = (i10 & 65535) >>> 8;
 i10 = i4 + 12 | 0;
 i16 = i2 + 12 | 0;
 i12 = i16;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = i15;
 i11 = i4 + 20 | 0;
 i15 = i2 + 20 | 0;
 i12 = i15;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j(i4, i2, 0);
 i21 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i18 >> 2] = i21;
 i1 = HEAP8[i20 >> 0] | 0;
 i18 = HEAP16[i19 >> 1] | 0;
 HEAP8[i20 >> 0] = i18;
 HEAP8[i19 >> 0] = i1;
 i19 = i2 + 9 | 0;
 i1 = HEAP8[i19 >> 0] | 0;
 HEAP8[i19 >> 0] = (i18 & 65535) >>> 8;
 HEAP8[i17 >> 0] = i1;
 i17 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i19 = i10;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i16 + 4 >> 2] = i18;
 HEAP32[i10 >> 2] = i17;
 HEAP32[i4 + 16 >> 2] = i1;
 i1 = HEAP32[i15 >> 2] | 0;
 i10 = HEAP32[i2 + 24 >> 2] | 0;
 i17 = i11;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = i10;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __Z18WWW_CUSTOM_InitWWWP12Il2CppObjectP12Il2CppStringP11Il2CppArrayS4_(i13, i1, i11, i8) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 16 | 0;
 i7 = i17 + 68 | 0;
 i14 = i17 + 56 | 0;
 i15 = i17 + 44 | 0;
 i9 = i17 + 32 | 0;
 i16 = i17;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i14, i7);
 i7 = i15 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i15 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i10 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i10;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0;
 i6 = i4 + -1 | 0;
 if ((i4 | 0) > 1) {
  i4 = 0;
  do {
   __Z24scripting_cpp_string_forP12Il2CppString(i9, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i8, i4) | 0);
   i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES6_NS_4lessIS6_EENS4_INS_4pairIKS6_S6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i15, i12, i9) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = __Znwj(40) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i9);
    i2 = i1 + 28 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i2;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
    if (!i2) i2 = i1; else {
     HEAP32[i15 >> 2] = i2;
     i2 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i2);
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   }
   __Z24scripting_cpp_string_forP12Il2CppString(i12, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i8, i4 | 1) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 28 | 0, i12) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i4 = i4 + 2 | 0;
  } while ((i4 | 0) < (i6 | 0));
 }
 if (!i11) {
  i2 = 0;
  i1 = -1;
 } else {
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i11, 0, 1) | 0;
  i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 }
 i11 = (HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i12 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i13 + 8 >> 2] = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i11, i2, i1, i15, 0, i12, 0) | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i15, HEAP32[i10 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 STACKTOP = i17;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i3 + 32 | 0;
 i20 = i3;
 i19 = i2 + -12 | 0;
 i4 = HEAP32[i19 + 80 >> 2] | 0;
 i2 = i19 + 76 | 0;
 i22 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i22 >> 2] | 0) + 28 >> 2] | 0, i22 | 0, i21 | 0, i21 + 4 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i20, i19, HEAP32[i21 + (i1 << 2) >> 2] | 0);
 f15 = Math_fround(-Math_fround(HEAPF32[i20 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i20 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[i20 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i20 + 16 >> 2]));
 f13 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 20 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i20 + 20 >> 2]));
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i20 + 24 >> 2])) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f5 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f13 * f14)) + Math_fround(f17 * f11));
 f7 = Math_fround(Math_fround(f5 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f18 * Math_fround(Math_fround(f17 * f14) - Math_fround(f13 * f11)))));
 f6 = Math_fround(Math_fround(f5 * f14) + Math_fround(Math_fround(f8 * f13) + Math_fround(f18 * Math_fround(Math_fround(f16 * f11) - Math_fround(f17 * f15)))));
 f5 = Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f18 * Math_fround(Math_fround(f13 * f15) - Math_fround(f16 * f14)))) + Math_fround(f5 * f11));
 f16 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) >> 2]);
 f13 = Math_fround(f18 * f16);
 f17 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f15));
 f8 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f14));
 f12 = Math_fround(HEAPF32[i19 + 20 + (i1 * 28 | 0) + 4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(Math_fround(f17 * f14) + Math_fround(f18 * f12))) - Math_fround(f8 * f15));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f17 * f11) + Math_fround(f18 * f8))) - Math_fround(f16 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f12 * f14)) - Math_fround(f8 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) >> 2] = Math_fround(f13 - Math_fround(f12 * f11));
 HEAPF32[i4 + (i1 * 28 | 0) + 4 >> 2] = f10;
 HEAPF32[i4 + (i1 * 28 | 0) + 8 >> 2] = f9;
 HEAPF32[i4 + (i1 * 28 | 0) + 12 >> 2] = f8;
 HEAPF32[i4 + (i1 * 28 | 0) + 16 >> 2] = f7;
 HEAPF32[i4 + (i1 * 28 | 0) + 20 >> 2] = f6;
 HEAPF32[i4 + (i1 * 28 | 0) + 24 >> 2] = f5;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i3, i1, i7, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = i5;
 if ((i5 | 0) != (i4 | 0)) {
  i2 = i5 + 16 | 0;
  if (!(__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0)) {
   if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
    HEAP32[i7 >> 2] = i1;
    return i7 | 0;
   }
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i5;
    while (1) {
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
   if ((i2 | 0) != (i4 | 0)) if (!(__ZNK18VertexChannelsInfoltERKS_(i6, i2 + 16 | 0) | 0)) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) {
     HEAP32[i7 >> 2] = i4;
     i7 = i4;
     return i7 | 0;
    }
    while (1) {
     i2 = i1 + 16 | 0;
     if (__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i4 = 34;
       break;
      } else i1 = i2;
     } else {
      if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
       i4 = 39;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i4 = 38;
       break;
      } else i1 = i2;
     }
    }
    if ((i4 | 0) == 34) {
     HEAP32[i7 >> 2] = i1;
     i7 = i1;
     return i7 | 0;
    } else if ((i4 | 0) == 38) {
     HEAP32[i7 >> 2] = i1;
     i7 = i3;
     return i7 | 0;
    } else if ((i4 | 0) == 39) {
     HEAP32[i7 >> 2] = i1;
     return i7 | 0;
    }
   }
   i1 = i5 + 4 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    HEAP32[i7 >> 2] = i5;
    i7 = i1;
    return i7 | 0;
   } else {
    HEAP32[i7 >> 2] = i2;
    i7 = i2;
    return i7 | 0;
   }
  }
 }
 if ((i5 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i2 = i5;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if (!(__ZNK18VertexChannelsInfoltERKS_(i1 + 16 | 0, i6) | 0)) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) {
    HEAP32[i7 >> 2] = i4;
    i7 = i4;
    return i7 | 0;
   }
   while (1) {
    i2 = i1 + 16 | 0;
    if (__ZNK18VertexChannelsInfoltERKS_(i6, i2) | 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 14;
      break;
     } else i1 = i2;
    } else {
     if (!(__ZNK18VertexChannelsInfoltERKS_(i2, i6) | 0)) {
      i4 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 14) {
    HEAP32[i7 >> 2] = i1;
    i7 = i1;
    return i7 | 0;
   } else if ((i4 | 0) == 18) {
    HEAP32[i7 >> 2] = i1;
    i7 = i3;
    return i7 | 0;
   } else if ((i4 | 0) == 19) {
    HEAP32[i7 >> 2] = i1;
    return i7 | 0;
   }
  }
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP32[i7 >> 2] = i5;
  i7 = i5;
  return i7 | 0;
 } else {
  i6 = i1;
  HEAP32[i7 >> 2] = i6;
  i7 = i6 + 4 | 0;
  return i7 | 0;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i17 = i4 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i19 = i4 + 8 | 0;
 i21 = i2 + 8 | 0;
 i16 = HEAP16[i21 >> 1] | 0;
 HEAP8[i19 >> 0] = i16;
 i11 = i4 + 9 | 0;
 HEAP8[i11 >> 0] = (i16 & 65535) >>> 8;
 i16 = i4 + 12 | 0;
 i20 = i2 + 12 | 0;
 i12 = i20;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i15;
 i10 = i4 + 20 | 0;
 i15 = i2 + 20 | 0;
 i12 = i15;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i10;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i4, i2, 0);
 i18 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i18;
 i17 = HEAP8[i21 >> 0] | 0;
 i18 = HEAP16[i19 >> 1] | 0;
 HEAP8[i21 >> 0] = i18;
 HEAP8[i19 >> 0] = i17;
 i19 = i2 + 9 | 0;
 i17 = HEAP8[i19 >> 0] | 0;
 HEAP8[i19 >> 0] = (i18 & 65535) >>> 8;
 HEAP8[i11 >> 0] = i17;
 i11 = i20;
 i17 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i19 = i16;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = i16;
 HEAP32[i1 >> 2] = i17;
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = i15;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = i10;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i1;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZN12BaseRenderer25FlattenSharedMaterialDataILb1EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i6, i2, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 8 | 0;
 i8 = i12;
 i9 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i5 + 244 >> 2] = i9;
 if ((i9 | 0) <= 0) {
  HEAP32[i5 + 324 >> 2] = 0;
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = i9 << 3;
 i4 = i2 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 + i3 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, i3 >>> 0 < 32768 ? 32768 : i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i11 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i4 >> 2] = i1 + i3;
 HEAP32[i5 + 324 >> 2] = i11;
 i4 = 0;
 while (1) {
  i1 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0, i4 | 0) | 0;
  if (!i1) {
   HEAP32[i11 + (i4 << 3) >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(__ZN8Material10GetDefaultEv() | 0) | 0;
   HEAP32[i11 + (i4 << 3) + 4 >> 2] = -1;
  } else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) {
    i10 = 11;
    break;
   }
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
    i10 = 11;
    break;
   }
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break;
   i5 = __ZNK8Material32AcquireSharedMaterialDataFromJobEv(i1) | 0;
   HEAP32[i11 + (i4 << 3) >> 2] = i5;
   if (!i5) {
    i10 = 18;
    break;
   }
   HEAP32[i11 + (i4 << 3) + 4 >> 2] = HEAP32[i1 + 36 >> 2];
  }
  i1 = i4 + 1 | 0;
  if ((i1 | 0) < (i9 | 0)) i4 = i1; else {
   i1 = 1;
   i10 = 26;
   break;
  }
 }
 if ((i10 | 0) != 11) if ((i10 | 0) == 18) {
  if (!i4) {
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  } else i1 = 0;
  do {
   i2 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
   i10 = i2 + 4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   if (!(HEAP32[i10 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63288 | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = 0;
  STACKTOP = i12;
  return i1 | 0;
 } else if ((i10 | 0) == 26) {
  STACKTOP = i12;
  return i1 | 0;
 }
 if (!i4) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 } else i1 = 0;
 do {
  i2 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
  i10 = i2 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  if (!(HEAP32[i10 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63288 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = 0;
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = i12 + 11 | 0;
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i12 >> 2] >> 0] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i7 = 0;
   i5 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
   i4 = 1;
  } else i11 = 5;
 } else {
  HEAP8[i12 >> 0] = 0;
  HEAP8[i8 >> 0] = 0;
  i1 = 0;
  i11 = 5;
 }
 if ((i11 | 0) == 5) {
  i7 = i1 & 255;
  i5 = 10;
  i4 = 0;
 }
 i2 = i7 >>> 0 < 11;
 i6 = i2 ? 10 : (i7 + 16 & 496) + -1 | 0;
 L8 : do if ((i6 | 0) != (i5 | 0)) {
  do if (i2) {
   i2 = HEAP32[i12 >> 2] | 0;
   if (i4) {
    i1 = 0;
    i3 = i12;
    i11 = 13;
   } else {
    i4 = 0;
    i5 = 1;
    i3 = i12;
    i11 = 14;
   }
  } else {
   i3 = _malloc(i6 + 1 | 0) | 0;
   if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L8;
   if (i4) {
    i1 = 1;
    i2 = HEAP32[i12 >> 2] | 0;
    i11 = 13;
    break;
   } else {
    i4 = 1;
    i5 = 0;
    i2 = i12;
    i11 = 14;
    break;
   }
  } while (0);
  if ((i11 | 0) == 13) {
   i4 = i1;
   i5 = 1;
   i1 = HEAP32[i12 + 4 >> 2] | 0;
  } else if ((i11 | 0) == 14) i1 = i1 & 255;
  i1 = i1 + 1 | 0;
  if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
  if (i5) _free(i2);
  if (i4) {
   HEAP32[i12 + 8 >> 2] = i6 + 1 | -2147483648;
   HEAP32[i12 + 4 >> 2] = i7;
   HEAP32[i12 >> 2] = i3;
   break;
  } else {
   HEAP8[i8 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i10 = i12 + 12 | 0;
 i9 = i9 + 12 | 0;
 i7 = i10 + 11 | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  i1 = HEAP8[i7 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i8 = 0;
   i5 = (HEAP32[i12 + 20 >> 2] & 2147483647) + -1 | 0;
   i4 = 1;
  } else i11 = 29;
 } else {
  HEAP8[i10 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
  i1 = 0;
  i11 = 29;
 }
 if ((i11 | 0) == 29) {
  i8 = i1 & 255;
  i5 = 10;
  i4 = 0;
 }
 i2 = i8 >>> 0 < 11;
 i6 = i2 ? 10 : (i8 + 16 & 496) + -1 | 0;
 L42 : do if ((i6 | 0) != (i5 | 0)) {
  do if (i2) {
   i2 = HEAP32[i10 >> 2] | 0;
   if (i4) {
    i1 = 0;
    i3 = i10;
    i11 = 37;
   } else {
    i4 = 0;
    i5 = 1;
    i3 = i10;
    i11 = 38;
   }
  } else {
   i3 = _malloc(i6 + 1 | 0) | 0;
   if (i6 >>> 0 <= i5 >>> 0 & (i3 | 0) == 0) break L42;
   if (i4) {
    i1 = 1;
    i2 = HEAP32[i10 >> 2] | 0;
    i11 = 37;
    break;
   } else {
    i4 = 1;
    i5 = 0;
    i2 = i10;
    i11 = 38;
    break;
   }
  } while (0);
  if ((i11 | 0) == 37) {
   i4 = i1;
   i5 = 1;
   i1 = HEAP32[i12 + 16 >> 2] | 0;
  } else if ((i11 | 0) == 38) i1 = i1 & 255;
  i1 = i1 + 1 | 0;
  if (i1 | 0) _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
  if (i5) _free(i2);
  if (i4) {
   HEAP32[i12 + 20 >> 2] = i6 + 1 | -2147483648;
   HEAP32[i12 + 16 >> 2] = i8;
   HEAP32[i10 >> 2] = i3;
   break;
  } else {
   HEAP8[i7 >> 0] = i8;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK13WheelCollider12GetLocalPoseER8Vector3fR11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i6 = i1 + 148 | 0;
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 i19 = i1 + 8 | 0;
 i20 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i19, HEAP32[i6 >> 2] | 0) | 0;
 f15 = Math_fround(HEAPF32[i20 >> 2]);
 f13 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 i19 = __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i19, HEAP32[i6 >> 2] | 0) | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f17 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 i19 = i5 + 60 | 0;
 f16 = Math_fround(HEAPF32[(HEAP32[i19 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 148 | 0) + 76 >> 2]);
 f12 = Math_fround(f15 - Math_fround(f12 * f16));
 f17 = Math_fround(f13 - Math_fround(f17 * f16));
 f16 = Math_fround(f14 - Math_fround(f18 * f16));
 __ZNK9Rigidbody15GetCenterOfMassEv(i4, i5);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i4 >> 2]));
 f17 = Math_fround(f17 + Math_fround(HEAPF32[i4 + 4 >> 2]));
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 HEAPF32[i2 >> 2] = f12;
 HEAPF32[i2 + 4 >> 2] = f17;
 HEAPF32[i2 + 8 >> 2] = f16;
 i6 = HEAP32[i6 >> 2] | 0;
 f16 = Math_fround(HEAPF32[(HEAP32[i19 >> 2] | 0) + (i6 * 148 | 0) + 116 >> 2]);
 f17 = Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj(i1 + 72 | 0, i6));
 f16 = Math_fround(f16 * Math_fround(.5));
 f12 = Math_fround(+Math_sin(+f16));
 f16 = Math_fround(+Math_cos(+f16));
 f18 = Math_fround(f12 * Math_fround(HEAPF32[gb + 62536 >> 2]));
 f14 = Math_fround(f12 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2]));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]));
 f17 = Math_fround(f17 * Math_fround(.5));
 f13 = Math_fround(+Math_sin(+f17));
 f17 = Math_fround(+Math_cos(+f17));
 f15 = Math_fround(f13 * Math_fround(HEAPF32[gb + 62524 >> 2]));
 f11 = Math_fround(f13 * Math_fround(HEAPF32[gb + 62524 + 4 >> 2]));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[gb + 62524 + 8 >> 2]));
 f10 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f14 * f17) + Math_fround(f16 * f11))) - Math_fround(f18 * f13));
 f9 = Math_fround(Math_fround(Math_fround(f18 * f11) + Math_fround(Math_fround(f12 * f17) + Math_fround(f16 * f13))) - Math_fround(f14 * f15));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f17) - Math_fround(f18 * f15)) - Math_fround(f14 * f11)) - Math_fround(f12 * f13));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f15)) + Math_fround(f14 * f13)) - Math_fround(f12 * f11));
 HEAPF32[i3 + 4 >> 2] = f10;
 HEAPF32[i3 + 8 >> 2] = f9;
 HEAPF32[i3 + 12 >> 2] = f8;
 STACKTOP = i7;
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation22TryInitializeDiskCacheEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i5 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 44 | 0;
 i10 = i12 + 32 | 0;
 i8 = i12 + 20 | 0;
 i3 = i7 + 176 | 0;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i7 + 180 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = __Z17GetCachingManagerv() | 0;
 __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i11, __ZN14CachingManager15GetCurrentCacheEv(i2) | 0, i3, 0);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11) | 0) if (__Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11) | 0) i6 = 8; else {
  HEAP32[i4 >> 2] = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
  __Z6FormatPKcz(i10, gb + 366935 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 366978 | 0, 255, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = 0;
 } else i6 = 8;
 do if ((i6 | 0) == 8) {
  i1 = __ZNK23ArchiveStorageConverter26GetUncompressedArchiveSizeEv(HEAP32[i7 + 132 >> 2] | 0) | 0;
  i3 = getTempRet0() | 0;
  i6 = __ZN5Cache32GetCachingDiskSpaceFreeAndUsableEv(__ZN14CachingManager15GetCurrentCacheEv(i2) | 0) | 0;
  i4 = getTempRet0() | 0;
  if (i3 >>> 0 > i4 >>> 0 | (i3 | 0) == (i4 | 0) & i1 >>> 0 > i6 >>> 0) if (!(__ZN5Cache15FreeUsableSpaceEj(__ZN14CachingManager15GetCurrentCacheEv(i2) | 0, i1) | 0)) {
   __Z6FormatPKcz(i10, gb + 367083 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 366978 | 0, 265, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i1 = 0;
   break;
  }
  __ZN14CachingManager13GetTempFolderEv(i10, i2);
  i1 = i10 + 11 | 0;
  i6 = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i6, _strlen(i6) | 0);
  i6 = __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  if (i6) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7 + 64 | 0, i10) | 0;
   HEAP8[i7 + 76 >> 0] = 1;
   i1 = 1;
  } else {
   HEAP32[i9 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
   __Z6FormatPKcz(i8, gb + 367124 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 366978 | 0, 274, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i11 = i1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 i12 = i8 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i8 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i11, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (i7 | 0) {
  i7 = i8 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = HEAP32[i7 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 88, 4) | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = -1;
    HEAP32[i2 + 24 >> 2] = -1;
    HEAP32[i2 + 28 >> 2] = 1;
    i3 = i2 + 32 | 0;
    i4 = i3;
    i5 = i4 + 52 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i5 | 0));
    HEAP16[i3 + 52 >> 1] = 0;
    HEAP8[i3 + 54 >> 0] = 0;
    i3 = i1;
    i2 = i2 | 0 ? i2 - i3 | 0 : 0;
    HEAP32[i1 >> 2] = i2;
   } else i3 = i1;
   __ZN7mecanim12statemachine18StateMachineMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i8);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = i10 + 12 | 0;
 i5 = i10 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i11, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i2 = i10 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i4 = i1;
  i5 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i5 | 0));
  i7 = i2;
  i1 = i1 | 0 ? i1 - i7 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i7;
 }
 __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + i2 | 0, i8);
 i5 = i10 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i11, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 i1 = i10 + 24 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i21, i12, i13, i11) {
 i21 = i21 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 f4 = Math_fround(HEAPF32[i12 >> 2]);
 f18 = Math_fround(f6 - f4);
 i7 = i13 + 4 | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = i12 + 4 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 f19 = Math_fround(f5 - f2);
 i10 = i13 + 8 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 i16 = i12 + 8 | 0;
 f1 = Math_fround(HEAPF32[i16 >> 2]);
 f20 = Math_fround(f3 - f1);
 f17 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)) + Math_fround(f20 * f20))));
 if (i11) {
  HEAPF32[i11 >> 2] = Math_fround(f17 * Math_fround(.5));
  f6 = Math_fround(HEAPF32[i13 >> 2]);
  f4 = Math_fround(HEAPF32[i12 >> 2]);
  f5 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i9 >> 2]);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f1 = Math_fround(HEAPF32[i16 >> 2]);
 }
 f15 = Math_fround(Math_fround(f6 + f4) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f5 + f2) * Math_fround(.5));
 f8 = Math_fround(Math_fround(f3 + f1) * Math_fround(.5));
 if (f17 < Math_fround(9.99999997e-07)) {
  i16 = 0;
  i11 = 0;
  i12 = 0;
  i13 = 1065353216;
  HEAP32[i21 >> 2] = i16;
  i16 = i21 + 4 | 0;
  HEAP32[i16 >> 2] = i11;
  i16 = i21 + 8 | 0;
  HEAP32[i16 >> 2] = i12;
  i16 = i21 + 12 | 0;
  HEAP32[i16 >> 2] = i13;
  i16 = i21 + 16 | 0;
  HEAPF32[i16 >> 2] = f15;
  i16 = i21 + 20 | 0;
  HEAPF32[i16 >> 2] = f14;
  i21 = i21 + 24 | 0;
  HEAPF32[i21 >> 2] = f8;
  return;
 }
 f3 = Math_fround(Math_fround(1.0) / f17);
 f4 = Math_fround(f18 * f3);
 f5 = Math_fround(f19 * f3);
 f3 = Math_fround(f20 * f3);
 f1 = Math_fround(f5 * Math_fround(0.0));
 f2 = Math_fround(f3 * Math_fround(0.0));
 f6 = Math_fround(f2 + Math_fround(f4 + f1));
 if (f6 > Math_fround(-1.0)) {
  f20 = Math_fround(f4 * Math_fround(0.0));
  f4 = Math_fround(f2 - f1);
  f3 = Math_fround(f20 - f3);
  f2 = Math_fround(f5 - f20);
  f1 = Math_fround(f6 + Math_fround(1.0));
 } else if (Math_fround(Math_abs(Math_fround(1.0))) < Math_fround(.100000001)) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(-0.0);
  f1 = Math_fround(0.0);
 } else {
  f4 = Math_fround(0.0);
  f3 = Math_fround(-1.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f20 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)))))));
 f17 = Math_fround(f4 * f20);
 f18 = Math_fround(f3 * f20);
 f19 = Math_fround(f2 * f20);
 f20 = Math_fround(f1 * f20);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i21 >> 2] = i16;
 i16 = i21 + 4 | 0;
 HEAP32[i16 >> 2] = i11;
 i16 = i21 + 8 | 0;
 HEAP32[i16 >> 2] = i12;
 i16 = i21 + 12 | 0;
 HEAP32[i16 >> 2] = i13;
 i16 = i21 + 16 | 0;
 HEAPF32[i16 >> 2] = f15;
 i16 = i21 + 20 | 0;
 HEAPF32[i16 >> 2] = f14;
 i21 = i21 + 24 | 0;
 HEAPF32[i21 >> 2] = f8;
 return;
}

function __ZN30ReportScriptingObjectsTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i26, i2, i1) {
 i26 = i26 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i25 + 60 | 0;
 i19 = i25;
 i20 = i19 + 24 | 0;
 HEAP8[i20 >> 0] = 1;
 i21 = i19 + 28 | 0;
 HEAP32[i21 >> 2] = 0;
 i22 = i19 + 32 | 0;
 HEAP32[i22 >> 2] = 0;
 i23 = i19 + 36 | 0;
 HEAP32[i23 >> 2] = -1;
 i24 = i19 + 44 | 0;
 HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
 i14 = i19 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i7 = i2 + 4 | 0;
 i15 = i19 + 4 | 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i7 >> 2] | 0) | 0) & 1;
 HEAP8[i15 >> 0] = i3;
 i16 = i19 + 8 | 0;
 HEAP32[i16 >> 2] = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) | 0) | 0;
 i17 = i19 + 16 | 0;
 HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i24 >> 2] = i1;
 HEAP32[i19 + 40 >> 2] = i1;
 HEAP32[i19 + 48 >> 2] = i7;
 i7 = i7 - i1 >> 6;
 HEAP32[i19 + 56 >> 2] = i7;
 HEAP32[i19 + 52 >> 2] = i7;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0;
 if (!i7) {
  STACKTOP = i25;
  return;
 }
 i8 = i19 + 40 | 0;
 i9 = i19 + 20 | 0;
 i10 = i19 + 24 | 0;
 i11 = i26 + 16 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 16 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i24 >> 2] = i1;
  HEAP32[i9 >> 2] = i8;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i2) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i17 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, HEAP32[i14 >> 2] | 0, i1);
   }
   i2 = HEAP32[i17 >> 2] | 0;
   HEAP8[i20 >> 0] = 1;
   HEAP32[i21 >> 2] = i1;
   i1 = -1;
  } else {
   i5 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
   i6 = HEAP32[i17 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i16 >> 2] | 0, i2) | 0) + 16 | 0;
   HEAP8[i20 >> 0] = 0;
   HEAP32[i21 >> 2] = i5;
   i2 = i6;
  }
  HEAP32[i22 >> 2] = i2;
  HEAP32[i23 >> 2] = i1;
  mftCall_vi(HEAP32[i11 >> 2] | 0, i10 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = i26;
  HEAP32[i18 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i18 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i13 >> 2] = i1;
  i5 = i1 + 4 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i6 = i1 + 8 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i4 = i1 + 12 | 0;
   i1 = i3;
   do {
    i3 = i1 + 64 | 0;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i4 >> 2] = i2 - i3 >> 6;
    mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i18 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
  HEAP32[i14 >> 2] = i2;
  if ((i2 | 0) == (i7 | 0)) break;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP8[i15 >> 0] | 0;
 }
 STACKTOP = i25;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i25, i26, i1) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24 + 24 | 0;
 i23 = i24;
 i1 = i25 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i25 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i22, 4);
  i1 = HEAP32[i22 >> 2] | 0;
 } else {
  i21 = HEAP32[i2 >> 2] | 0;
  HEAP32[i22 >> 2] = i21;
  HEAP32[i1 >> 2] = i3;
  i1 = i21;
 }
 i12 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i23 >> 2] = -1;
 i13 = i23 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnvC2Ev(i13);
 i14 = i26 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i26, HEAP32[i14 >> 2] | 0);
 i15 = i26 + 8 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i26 >> 2] = i14;
 HEAP32[i14 >> 2] = 0;
 if ((i12 | 0) <= 0) {
  STACKTOP = i24;
  return;
 }
 i16 = i23 + 8 | 0;
 i17 = i23 + 12 | 0;
 i18 = i23 + 16 | 0;
 i19 = i23 + 20 | 0;
 i20 = i14;
 i21 = i26 + 4 | 0;
 i11 = 0;
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags(i25, i23, gb + 1041891 | 0, 0);
  i5 = HEAP32[i23 >> 2] | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  i7 = HEAP32[i16 >> 2] | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i9 = HEAP32[i18 >> 2] | 0;
  i10 = HEAP32[i19 >> 2] | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  do if (!i1) {
   HEAP32[i22 >> 2] = i14;
   i4 = i20;
   i3 = i14;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i22 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i22 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i22 >> 2] = i1;
    i4 = i1;
    i3 = i22;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(40) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   HEAP32[i1 + 20 >> 2] = i6;
   HEAP32[i1 + 24 >> 2] = i7;
   HEAP32[i1 + 28 >> 2] = i8;
   HEAP32[i1 + 32 >> 2] = i9;
   HEAP32[i1 + 36 >> 2] = i10;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i26 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i21 >> 2] | 0, i1);
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i12 | 0));
 STACKTOP = i24;
 return;
}

function __ZN11b2RopeJoint24SolvePositionConstraintsERK12b2SolverData(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0;
 i19 = i18 + 96 | 0;
 i6 = HEAP32[i19 >> 2] | 0;
 i12 = i1 + 24 | 0;
 i21 = HEAP32[i12 >> 2] | 0;
 i15 = i21 + (i6 * 12 | 0) | 0;
 f16 = Math_fround(HEAPF32[i15 >> 2]);
 i1 = i21 + (i6 * 12 | 0) + 4 | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i21 + (i6 * 12 | 0) + 8 >> 2]);
 i6 = i18 + 100 | 0;
 i20 = HEAP32[i6 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) >> 2]);
 f8 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i21 + (i20 * 12 | 0) + 8 >> 2]);
 f13 = Math_fround(+Math_sin(+f5));
 f2 = Math_fround(+Math_cos(+f5));
 f3 = Math_fround(+Math_sin(+f9));
 f4 = Math_fround(+Math_cos(+f9));
 f14 = Math_fround(HEAPF32[i18 + 68 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i18 + 128 >> 2]));
 f11 = Math_fround(HEAPF32[i18 + 72 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i18 + 132 >> 2]));
 f10 = Math_fround(Math_fround(f2 * f14) - Math_fround(f13 * f11));
 f11 = Math_fround(Math_fround(f13 * f14) + Math_fround(f2 * f11));
 f2 = Math_fround(HEAPF32[i18 + 76 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i18 + 136 >> 2]));
 f14 = Math_fround(HEAPF32[i18 + 80 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i18 + 140 >> 2]));
 f13 = Math_fround(Math_fround(f4 * f2) - Math_fround(f3 * f14));
 f14 = Math_fround(Math_fround(f3 * f2) + Math_fround(f4 * f14));
 f4 = Math_fround(Math_fround(Math_fround(f7 + f13) - f16) - f10);
 f2 = Math_fround(Math_fround(Math_fround(f8 + f14) - f17) - f11);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2))));
 if (f3 < Math_fround(1.1920929e-07)) f3 = Math_fround(0.0); else {
  f22 = Math_fround(Math_fround(1.0) / f3);
  f4 = Math_fround(f22 * f4);
  f2 = Math_fround(f22 * f2);
 }
 i21 = i18 + 84 | 0;
 f22 = Math_fround(f3 - Math_fround(HEAPF32[i21 >> 2]));
 f23 = Math_fround(HEAPF32[gb + 151880 >> 2]);
 f23 = f22 < f23 ? f22 : f23;
 i20 = f23 < Math_fround(0.0);
 f23 = i20 ? Math_fround(0.0) : f23;
 f23 = Math_fround(-Math_fround(Math_fround(HEAPF32[i18 + 160 >> 2]) * f23));
 f22 = Math_fround(f4 * f23);
 f23 = Math_fround(f2 * f23);
 f4 = Math_fround(HEAPF32[i18 + 144 >> 2]);
 f2 = Math_fround(f16 - Math_fround(f4 * f22));
 f4 = Math_fround(f17 - Math_fround(f4 * f23));
 f11 = Math_fround(f5 - Math_fround(Math_fround(HEAPF32[i18 + 152 >> 2]) * Math_fround(Math_fround(f10 * f23) - Math_fround(f11 * f22))));
 f17 = Math_fround(HEAPF32[i18 + 148 >> 2]);
 f16 = Math_fround(f7 + Math_fround(f17 * f22));
 f17 = Math_fround(f8 + Math_fround(f17 * f23));
 f22 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i18 + 156 >> 2]) * Math_fround(Math_fround(f13 * f23) - Math_fround(f14 * f22))));
 HEAPF32[i15 >> 2] = f2;
 HEAPF32[i1 >> 2] = f4;
 i18 = HEAP32[i12 >> 2] | 0;
 HEAPF32[i18 + ((HEAP32[i19 >> 2] | 0) * 12 | 0) + 8 >> 2] = f11;
 i20 = HEAP32[i6 >> 2] | 0;
 HEAPF32[i18 + (i20 * 12 | 0) >> 2] = f16;
 HEAPF32[i18 + (i20 * 12 | 0) + 4 >> 2] = f17;
 HEAPF32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 12 | 0) + 8 >> 2] = f22;
 return Math_fround(f3 - Math_fround(HEAPF32[i21 >> 2])) < Math_fround(.00499999989) | 0;
}

function __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i11, i6, i7, i8) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i15 = i16 + 12 | 0;
 i9 = i16;
 i2 = gb + 64016 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i14 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i3 = HEAP32[gb + 1163236 >> 2] | 0;
 if ((i4 | 0) < 4 | (i2 | 0) != 0 | (i3 | 0) == 0) {
  i5 = i4;
  i1 = i2;
 } else {
  i2 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
  i1 = gb + 64016 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1163236 >> 2] | 0;
 }
 HEAP32[i14 + 4 >> 2] = i4;
 HEAP32[i14 + 8 >> 2] = i2;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i10 = i15 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 if (!((i5 | 0) < 4 | (i1 | 0) != 0 | (i3 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
 HEAP32[i15 + 4 >> 2] = i5;
 HEAP32[i15 + 8 >> 2] = i1;
 i7 = __ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE(i11, i6, i7, i14, i15, i8) | 0;
 L7 : do if ((HEAP32[i12 >> 2] | 0) != 0 & i7) {
  i5 = i9 + 11 | 0;
  i6 = i9 + 4 | 0;
  if (!i8) {
   i4 = 0;
   while (1) {
    i3 = HEAP32[i14 >> 2] | 0;
    i2 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
    i3 = HEAP32[i3 + (i4 << 3) + 4 >> 2] | 0;
    if (!i3) i1 = 0; else i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i3) | 0;
    i1 = __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i11, i2, i3, i1, 0) | 0;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) break L7;
   }
  } else i4 = 0;
  do {
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   i2 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
   i3 = HEAP32[i3 + (i4 << 3) + 4 >> 2] | 0;
   if (!i3) i1 = 0; else i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i3) | 0;
   i1 = __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i11, i2, i3, i1, i9) | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   i2 = i3 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i6 >> 2] | 0 : i3 & 255;
   if (i3 | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, i2 ? HEAP32[i9 >> 2] | 0 : i9, i3) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 } else i1 = 0; while (0);
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i15 + 4 | 0);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i14 + 4 | 0);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i3 = i9 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 24 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i2 + (i4 * 24 | 0) >> 2] = 0;
 HEAP32[i2 + (i4 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i2 + (i4 * 24 | 0) + 8 >> 2] = -1;
 i5 = i2 + (i4 * 24 | 0) + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP8[i2 + (i4 * 24 | 0) + 20 >> 0] = 0;
 i2 = i2 + (i4 * 24 | 0) + 21 | 0;
 HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[i1 + 2 >> 0] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i3 + (i2 * 24 | 0) >> 2] = i10;
 HEAP32[i3 + (i2 * 24 | 0) + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0;
 i2 = i9 + 20 | 0;
 i3 = i9 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 36 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i1 = (HEAP32[i2 >> 2] | 0) + (i4 * 24 | 0) | 0;
 i2 = i10 + 240 | 0;
 i9 = HEAP16[i2 >> 1] | 0;
 if (!((i9 & 65535) > 255 | (i9 & 255) << 24 >> 24 != 0)) {
  i10 = i10 + 132 | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  STACKTOP = i11;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0);
 HEAP8[i2 >> 0] = 0;
 HEAP8[i10 + 241 >> 0] = 0;
 i10 = i10 + 132 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 5, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 5, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 5) | 0, 0, i5 - i4 << 5 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 5) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843832 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN16HeightMeshBVNode8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843832 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN16HeightMeshBVNode8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z12pqHeapDeleteP13PriorityQHeapi(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i16 = HEAP32[i11 + 4 >> 2] | 0;
 i17 = i16 + (i12 << 3) + 4 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i7 = i11 + 8 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 i13 = HEAP32[i15 + (i10 << 2) >> 2] | 0;
 HEAP32[i15 + (i1 << 2) >> 2] = i13;
 i14 = i16 + (i13 << 3) + 4 | 0;
 HEAP32[i14 >> 2] = i1;
 i9 = i10 + -1 | 0;
 HEAP32[i7 >> 2] = i9;
 if ((i1 | 0) >= (i10 | 0)) {
  i16 = i16 + (i12 << 3) | 0;
  HEAP32[i16 >> 2] = 0;
  i16 = i11 + 16 | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  HEAP32[i17 >> 2] = i15;
  HEAP32[i16 >> 2] = i12;
  return;
 }
 do if ((i1 | 0) < 2) i5 = i16 + (i13 << 3) | 0; else {
  i7 = i1 >> 1;
  i2 = HEAP32[i15 + (i7 << 2) >> 2] | 0;
  i4 = HEAP32[i16 + (i2 << 3) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  i5 = i16 + (i13 << 3) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  if (!(f3 < f8)) {
   if (f3 == f8) {
    f3 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    if (f3 <= Math_fround(HEAPF32[i6 + 28 >> 2])) break;
   }
   L11 : do if (i7) {
    i6 = i6 + 28 | 0;
    i4 = HEAP32[i16 + (i2 << 3) >> 2] | 0;
    f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
    if (!(f3 < f8)) {
     i5 = i7;
     while (1) {
      if (f3 == f8) {
       f3 = Math_fround(HEAPF32[i4 + 28 >> 2]);
       if (f3 <= Math_fround(HEAPF32[i6 >> 2])) break L11;
      }
      HEAP32[i15 + (i1 << 2) >> 2] = i2;
      HEAP32[i16 + (i2 << 3) + 4 >> 2] = i1;
      i1 = i5 >> 1;
      if (!i1) {
       i1 = i5;
       break L11;
      }
      i2 = HEAP32[i15 + (i1 << 2) >> 2] | 0;
      i4 = HEAP32[i16 + (i2 << 3) >> 2] | 0;
      f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
      if (f3 < f8) {
       i1 = i5;
       break;
      } else {
       i10 = i5;
       i5 = i1;
       i1 = i10;
      }
     }
    }
   } while (0);
   HEAP32[i15 + (i1 << 2) >> 2] = i13;
   HEAP32[i14 >> 2] = i1;
   i16 = i16 + (i12 << 3) | 0;
   HEAP32[i16 >> 2] = 0;
   i16 = i11 + 16 | 0;
   i15 = HEAP32[i16 >> 2] | 0;
   HEAP32[i17 >> 2] = i15;
   HEAP32[i16 >> 2] = i12;
   return;
  }
 } while (0);
 while (1) {
  i2 = i1 << 1;
  do if ((i2 | 0) < (i9 | 0)) {
   i4 = i2 | 1;
   i6 = HEAP32[i16 + (HEAP32[i15 + (i4 << 2) >> 2] << 3) >> 2] | 0;
   f3 = Math_fround(HEAPF32[i6 + 24 >> 2]);
   i7 = HEAP32[i16 + (HEAP32[i15 + (i2 << 2) >> 2] << 3) >> 2] | 0;
   f8 = Math_fround(HEAPF32[i7 + 24 >> 2]);
   if (!(f3 < f8)) {
    if (!(f3 == f8)) break;
    f8 = Math_fround(HEAPF32[i6 + 28 >> 2]);
    if (!(f8 <= Math_fround(HEAPF32[i7 + 28 >> 2]))) break;
   }
   i2 = i4;
  } while (0);
  i4 = HEAP32[i15 + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) >= (i10 | 0)) break;
  i6 = HEAP32[i5 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  i7 = HEAP32[i16 + (i4 << 3) >> 2] | 0;
  f8 = Math_fround(HEAPF32[i7 + 24 >> 2]);
  if (f3 < f8) break;
  if (f3 == f8) {
   f8 = Math_fround(HEAPF32[i6 + 28 >> 2]);
   if (f8 <= Math_fround(HEAPF32[i7 + 28 >> 2])) break;
  }
  HEAP32[i15 + (i1 << 2) >> 2] = i4;
  HEAP32[i16 + (i4 << 3) + 4 >> 2] = i1;
  i1 = i2;
 }
 HEAP32[i15 + (i1 << 2) >> 2] = i13;
 HEAP32[i14 >> 2] = i1;
 i16 = i16 + (i12 << 3) | 0;
 HEAP32[i16 >> 2] = 0;
 i16 = i11 + 16 | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i16 >> 2] = i12;
 return;
}

function __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i21, i3, i1) {
 i21 = i21 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, f23 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i22;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i19 = i3 + 96 | 0;
 f9 = Math_fround(f4 * Math_fround(HEAPF32[i19 >> 2]));
 i20 = i3 + 100 | 0;
 f9 = Math_fround(f9 + Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2])));
 i12 = i3 + 104 | 0;
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i12 >> 2])));
 i13 = i3 + 112 | 0;
 f10 = Math_fround(f4 * Math_fround(HEAPF32[i13 >> 2]));
 i14 = i3 + 116 | 0;
 f10 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i14 >> 2])));
 i15 = i3 + 120 | 0;
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 >> 2])));
 i16 = i3 + 128 | 0;
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i16 >> 2]));
 i17 = i3 + 132 | 0;
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 i18 = i3 + 136 | 0;
 f11 = Math_fround(f6 + Math_fround(f11 * Math_fround(HEAPF32[i18 >> 2])));
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f10;
 HEAPF32[i2 + 8 >> 2] = f11;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f9);
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f10));
   f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f11));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f23 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f23 * f9) + Math_fround(f4 * f10)) + Math_fround(Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]) * f11));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i2) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 f6 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f10 = Math_fround(f6 * Math_fround(HEAPF32[i19 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i13 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f23 * Math_fround(HEAPF32[i16 >> 2])));
 f11 = Math_fround(f6 * Math_fround(HEAPF32[i20 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i14 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f23 * Math_fround(HEAPF32[i17 >> 2])));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2]));
 f9 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2])));
 f23 = Math_fround(f9 + Math_fround(f23 * Math_fround(HEAPF32[i18 >> 2])));
 HEAPF32[i21 >> 2] = f10;
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f23;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i22;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i3 = HEAP32[gb + 37176 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 842702 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 842702 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 8 | 0;
 i17 = i13;
 i6 = i13 + 64 | 0;
 i10 = i6 + 12 | 0;
 HEAP32[i10 >> 2] = 1;
 i8 = i6 + 16 | 0;
 HEAP32[i8 >> 2] = 1;
 i9 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63720 | 0);
 i3 = i12;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
 i5 = gb + 63720 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i17;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i6 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = 0;
 i4 = i6 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i17);
 i14 = i12;
 i7 = HEAP32[i14 + 4 >> 2] | 0;
 i16 = i5;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = i7;
 i16 = gb + 63720 | 0;
 i7 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i17;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i7;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = 0;
 i14 = i6 + 56 | 0;
 HEAP32[i14 >> 2] = 0;
 i7 = i6 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i17);
 i17 = i12;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i7;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 i10 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 HEAP8[i15 + (i10 * 24 | 0) + 2 >> 0] = 0;
 HEAP32[i15 + (i10 * 24 | 0) + 8 >> 2] = 0;
 HEAP32[i15 + (i10 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i15 + (i10 * 24 | 0) + 16 >> 2] = -1;
 HEAP8[i15 + (i10 * 24 | 0) + 3 >> 0] = 0;
 HEAP16[i15 + (i10 * 24 | 0) >> 1] = 1;
 HEAP32[i15 + (i10 * 24 | 0) + 20 >> 2] = 0;
 HEAP32[i15 + (i10 * 24 | 0) + 12 >> 2] = -1;
 __ZN8TypeTreeaSERKS_(i1, i6) | 0;
 i10 = i6 + 40 | 0;
 if ((HEAP32[i14 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i7);
  HEAP32[i10 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i5);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i9);
  HEAP32[i6 >> 2] = 0;
 }
 i17 = i11 + 8 | 0;
 __ZN24GenerateTypeTreeTransferC2ER8TypeTree24TransferInstructionFlagsPvi(i12, i1, i2, i11, HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i17 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 20 >> 2] | 0);
 if (((HEAP32[i17 >> 2] | 0) >>> 21 | 0) != (HEAP32[gb + 27592 + 24 >> 2] | 0)) {
  i17 = HEAP32[i11 >> 2] | 0;
  i17 = i17 + 76 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  mftCall_vii(i17 | 0, i11 | 0, i12 | 0);
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __Z29scripting_class_instance_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0) | 0;
 __ZN24GenerateTypeTreeTransfer18SetScriptingObjectEP12Il2CppObjecti(i12, i1, i2);
 i17 = HEAP32[i11 >> 2] | 0;
 i17 = i17 + 76 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 mftCall_vii(i17 | 0, i11 | 0, i12 | 0);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i8 = i4 - i5 >> 5;
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i3 = i5;
 i2 = i6;
 i11 = i4;
 if (i8 >>> 0 > i1 - i6 >> 5 >>> 0) {
  i5 = i6;
  if (i6) {
   i1 = i10 + 4 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   if ((i4 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i4 + (~((i4 + -32 - i6 | 0) >>> 5) << 5);
   __ZdlPv(i5);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
  }
  if (i8 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } else i2 = 0;
  i9 = i1 - i2 | 0;
  i1 = i9 >> 4;
  i1 = i9 >> 5 >>> 0 < 67108863 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 134217727;
  if (i1 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = __Znwj(i1 << 5) | 0;
  i4 = i10 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 << 5);
  if ((i3 | 0) == (i11 | 0)) return; else i1 = i3;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i1 = i1 + 32 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i11 | 0));
  return;
 }
 i7 = i10 + 4 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) - i6 >> 5;
 i6 = i8 >>> 0 > i1 >>> 0;
 i1 = i6 ? i3 + (i1 << 5) | 0 : i4;
 if ((i3 | 0) != (i1 | 0)) {
  i5 = (i1 + -32 - i5 | 0) >>> 5;
  i4 = i2;
  while (1) {
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i8 = HEAP32[i3 + 16 >> 2] | 0;
   i10 = HEAP32[i3 + 20 >> 2] | 0;
   i11 = HEAP32[i3 + 24 >> 2] | 0;
   HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = i8;
   HEAP32[i4 + 20 >> 2] = i10;
   HEAP32[i4 + 24 >> 2] = i11;
   HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   i3 = i3 + 32 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else i4 = i4 + 32 | 0;
  }
  i2 = i2 + (i5 + 1 << 5) | 0;
 }
 if (!i6) {
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
  HEAP32[i7 >> 2] = i1 + (~((i1 + -32 - i2 | 0) >>> 5) << 5);
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 i3 = HEAP32[i7 >> 2] | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  i1 = i1 + 32 | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + 32 | 0;
  HEAP32[i7 >> 2] = i3;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES17RenderSurfaceType16TextureDimension9TextureIDjN2gl9TexFormatEjRK17RenderSurfaceDesc(i6, i11, i1, i2, i3, i7, i9, i4, i5) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i8 = 0, i10 = 0;
 i1 = (i1 | 0) == 1;
 if (i4 & 64 | 0) if (!i11) {
  i2 = __Z16GetRealGfxDevicev() | 0;
  i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 384 >> 2] | 0, i2 | 0, i1 | 0) | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i10 = HEAP32[i5 + 4 >> 2] | 0;
  i11 = (HEAP32[i5 + 16 >> 2] | 0) != 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 1;
  HEAP32[i2 + 24 >> 2] = 2;
  HEAP8[i2 + 30 >> 0] = i1 & 1;
  HEAP32[i2 + 4 >> 2] = i9;
  HEAP32[i2 + 8 >> 2] = i10;
  HEAP8[i2 + 31 >> 0] = i11 & 1;
  HEAP32[i2 + 20 >> 2] = 64;
  i1 = i2 + 32 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i11 = i2;
   return i11 | 0;
  }
  i11 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 118) | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i1 >> 2] = i11;
  i11 = i2;
  return i11 | 0;
 } else {
  i8 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = (HEAP32[i5 + 16 >> 2] | 0) != 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i11 + 16 >> 2] = 0;
  HEAP32[i11 + 20 >> 2] = 0;
  HEAP32[i11 + 24 >> 2] = 0;
  HEAP32[i11 + 28 >> 2] = 0;
  HEAP32[i11 + 16 >> 2] = 1;
  HEAP32[i11 + 24 >> 2] = 2;
  HEAP8[i11 + 30 >> 0] = i1 & 1;
  HEAP32[i11 + 4 >> 2] = i8;
  HEAP32[i11 + 8 >> 2] = i9;
  HEAP8[i11 + 31 >> 0] = i10 & 1;
  HEAP32[i11 + 20 >> 2] = 64;
  i1 = i11 + 32 | 0;
  if (HEAP32[i1 >> 2] | 0) return i11 | 0;
  i10 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 118) | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i1 >> 2] = i10;
  return i11 | 0;
 }
 i8 = (i11 | 0) != 0;
 if (i8) i10 = i11; else {
  i10 = __Z16GetRealGfxDevicev() | 0;
  i10 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 384 >> 2] | 0, i10 | 0, i1 | 0) | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i10 + 20 >> 2] = i4;
 HEAP32[i10 + 24 >> 2] = i2;
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 i3 = i10 + 16 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP8[i10 + 31 >> 0] = (HEAP32[i5 + 16 >> 2] | 0) != 0 & 1;
 i1 = i10 + 32 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 264) | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = i2;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 12 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) HEAP32[i3 >> 2] = i1;
 HEAP32[i10 + 36 >> 2] = i7;
 HEAP32[i10 + 40 >> 2] = i9;
 HEAP32[i10 + 44 >> 2] = 0;
 i3 = __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES(i6, i10) | 0;
 if (!i3) {
  i11 = i10;
  return i11 | 0;
 }
 HEAP32[i3 + 20 >> 2] = i9;
 if (i8) {
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = HEAP32[i11 + 8 >> 2] | 0;
 } else {
  i2 = 1;
  i1 = 1;
 }
 HEAP32[i3 + 24 >> 2] = i2;
 HEAP32[i3 + 28 >> 2] = i1;
 HEAP32[i3 + 32 >> 2] = 1;
 HEAP32[i3 + 36 >> 2] = 1;
 i11 = i10;
 return i11 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_(i9, i10, i11, i12) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = i10 + 4 | 0;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i9 + 4 | 0;
 i5 = f4 < Math_fround(HEAPF32[i7 >> 2]);
 i8 = i11 + 4 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 i2 = f1 < f4;
 do if (i5) {
  i5 = i9;
  i3 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i2) {
   i14 = i11;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i2 = i9;
   HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i2 + 4 >> 2] = i13;
   i2 = i11;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = 1;
   f1 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
  i2 = i10;
  i13 = HEAP32[i2 + 4 >> 2] | 0;
  i14 = i9;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  i14 = i10;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i14 + 4 >> 2] = i5;
  f1 = Math_fround(HEAPF32[i8 >> 2]);
  f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f1 < f4) {
   i13 = i11;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i2 = i10;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = i14;
   i2 = i11;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = 2;
   f1 = f4;
  } else i2 = 1;
 } else if (i2) {
  i13 = i10;
  i5 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i2 = i11;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i14 = i10;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i14 + 4 >> 2] = i3;
  i14 = i11;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i14 + 4 >> 2] = i13;
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  i14 = f1 < Math_fround(HEAPF32[i7 >> 2]);
  f1 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i14) {
   i14 = i9;
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i3 = i10;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i9;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i10;
   HEAP32[i2 >> 2] = i13;
   HEAP32[i2 + 4 >> 2] = i14;
   i2 = 2;
   f1 = Math_fround(HEAPF32[i8 >> 2]);
  } else i2 = 1;
 } else i2 = 0; while (0);
 if (!(Math_fround(HEAPF32[i12 + 4 >> 2]) < f1)) {
  i14 = i2;
  return i14 | 0;
 }
 i13 = i11;
 i5 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = i12;
 i3 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i11;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i3;
 i14 = i12;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i13;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(f4 < Math_fround(HEAPF32[i6 >> 2]))) {
  i15 = i2 + 1 | 0;
  return i15 | 0;
 }
 i14 = i10;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i8 = i11;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i15 = i10;
 HEAP32[i15 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i15 + 4 >> 2] = i12;
 i15 = i11;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i14;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f4 < Math_fround(HEAPF32[i7 >> 2]))) {
  i15 = i2 + 2 | 0;
  return i15 | 0;
 }
 i14 = i9;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i10;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i15 = i9;
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = i12;
 i15 = i10;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i14;
 i15 = i2 + 3 | 0;
 return i15 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEs(i12, i5) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i8 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i10 | 0, i12 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i9 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   i7 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i6 = HEAP32[i7 + 4 >> 2] & 74;
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i7) | 0;
   __THREW__ = 0;
   i7 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i9 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i8 >> 2] = i9;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
     i1 = invoke_iiiiii(i14 | 0, i7 | 0, i4 | 0, i2 | 0, i1 | 0, ((i6 | 0) == 64 | (i6 | 0) == 8 ? i5 & 65535 : i5 << 16 >> 16) | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx2Gu26checkOverlapOBB_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i1, i12, i11) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i7 = i13 + 16 | 0;
 i8 = i13;
 i9 = HEAP32[i1 + 32 >> 2] | 0;
 i10 = i1 + 4 | 0;
 L1 : do if (Math_fround(HEAPF32[i10 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(1.0)) {
  f16 = Math_fround(HEAPF32[i11 + 36 >> 2]);
  f16 = Math_fround(f16 - Math_fround(HEAPF32[i12 + 16 >> 2]));
  f18 = Math_fround(HEAPF32[i11 + 40 >> 2]);
  f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 20 >> 2]));
  f21 = Math_fround(HEAPF32[i11 + 44 >> 2]);
  f16 = Math_fround(f16 * Math_fround(2.0));
  f18 = Math_fround(f18 * Math_fround(2.0));
  f21 = Math_fround(Math_fround(f21 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
  f19 = Math_fround(HEAPF32[i12 + 12 >> 2]);
  f20 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
  f17 = Math_fround(HEAPF32[i12 >> 2]);
  f5 = Math_fround(f16 * f17);
  f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f18 * f15));
  f14 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f21 * f14));
  f3 = Math_fround(Math_fround(f17 * f5) + Math_fround(Math_fround(f16 * f20) - Math_fround(f19 * Math_fround(Math_fround(f21 * f15) - Math_fround(f18 * f14)))));
  f4 = Math_fround(Math_fround(f15 * f5) + Math_fround(Math_fround(f18 * f20) - Math_fround(f19 * Math_fround(Math_fround(f16 * f14) - Math_fround(f21 * f17)))));
  f5 = Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)))) + Math_fround(f14 * f5));
  i1 = HEAP8[i9 + 55 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
  i1 = i1 & 255;
  i2 = HEAP32[i9 + 56 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   f21 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
   f21 = Math_fround(f21 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 4 >> 2])));
   f21 = Math_fround(f21 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2])));
   if (Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f21) > Math_fround(0.0)) break L1;
   if (!i1) {
    i1 = 1;
    break;
   } else i2 = i2 + 20 | 0;
  }
  STACKTOP = i13;
  return i1 | 0;
 } while (0);
 i22 = HEAP32[i11 + 48 >> 2] | 0;
 i1 = HEAP32[i11 + 52 >> 2] | 0;
 i2 = HEAP32[i11 + 56 >> 2] | 0;
 HEAP32[i6 >> 2] = 3;
 HEAP32[i6 + 4 >> 2] = i22;
 HEAP32[i6 + 8 >> 2] = i1;
 HEAP32[i6 + 12 >> 2] = i2;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i8, i11);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i11 + 40 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i11 + 44 >> 2];
 i12 = __ZN5physx2Gu18intersectBoxConvexERKNS_13PxBoxGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i6, i7, i9, i10, i12, 0) | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx14SapPairManager12reallocPairsEb(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 7 | 0;
 i3 = i15 + 6 | 0;
 i5 = i15 + 5 | 0;
 i6 = i15 + 4 | 0;
 i7 = i15 + 3 | 0;
 i10 = i15 + 2 | 0;
 i11 = i15 + 1 | 0;
 i12 = i15;
 if (!i2) {
  i2 = i14 + 8 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = HEAP32[i14 >> 2] | 0;
   i3 = 0;
   do {
    HEAP32[i1 + (i3 << 2) >> 2] = 1073741823;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i14 + 28 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i14 + 20 >> 2] | 0;
  i5 = i14 + 36 | 0;
  i6 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i14 = HEAP32[i4 + (i2 << 3) + 4 >> 2] << 16 | HEAP32[i4 + (i2 << 3) >> 2];
   i14 = i14 + ~(i14 << 15) | 0;
   i14 = (i14 >> 10 ^ i14) * 9 | 0;
   i14 = i14 >> 6 ^ i14;
   i14 = i14 + ~(i14 << 11) | 0;
   i14 = i6 + (((i14 >> 16 ^ i14) & HEAP32[i5 >> 2]) << 2) | 0;
   HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i2;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  STACKTOP = i15;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i14 >> 2] | 0);
 i4 = i14 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i14 + 12 >> 2] = i2;
 HEAP32[i14 + 32 >> 2] = i2;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i2 << 2, gb + 716761 | 0, 439) | 0;
 HEAP32[i14 >> 2] = i2;
 if (!(HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = 1073741823;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = i1 << 3;
 }
 i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i1, gb + 716761 | 0, 447) | 0;
 i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, HEAP32[i4 >> 2] << 2, gb + 716761 | 0, 448) | 0;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, HEAP32[i4 >> 2] | 0, gb + 716761 | 0, 449) | 0;
 i6 = i14 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i13 = 10; else {
  _memcpy(i9 | 0, HEAP32[i14 + 20 >> 2] | 0, i1 << 3 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i13 = 10; else {
   _memcpy(i7 | 0, HEAP32[i14 + 24 >> 2] | 0, i1 | 0) | 0;
   if (!(HEAP32[i6 >> 2] | 0)) i13 = 10; else {
    i1 = i14 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i3 = i14 + 36 | 0;
    i4 = HEAP32[i14 >> 2] | 0;
    i5 = 0;
    do {
     i16 = HEAP32[i2 + (i5 << 3) + 4 >> 2] << 16 | HEAP32[i2 + (i5 << 3) >> 2];
     i16 = i16 + ~(i16 << 15) | 0;
     i16 = (i16 >> 10 ^ i16) * 9 | 0;
     i16 = i16 >> 6 ^ i16;
     i16 = i16 + ~(i16 << 11) | 0;
     i16 = i4 + (((i16 >> 16 ^ i16) & HEAP32[i3 >> 2]) << 2) | 0;
     HEAP32[i8 + (i5 << 2) >> 2] = HEAP32[i16 >> 2];
     HEAP32[i16 >> 2] = i5;
     i5 = i5 + 1 | 0;
    } while (i5 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
   }
  }
 }
 if ((i13 | 0) == 10) i1 = i14 + 20 | 0;
 i16 = i14 + 4 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i16 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i1 >> 2] | 0);
 i14 = i14 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = i9;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i16 >> 2] = i8;
 STACKTOP = i15;
 return;
}

function __ZN18ProceduralMaterial5CloneEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i5 = i11;
 i7 = gb + 63520 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i10 = __Z20CreateObjectFromCodeI18ProceduralMaterialEPT_17AwakeFromLoadMode10MemLabelId(4, i10) | 0;
 HEAP32[i10 + 108 >> 2] = HEAP32[i9 + 108 >> 2];
 i5 = i10 + 156 | 0;
 i1 = i9 + 156 | 0;
 i8 = (i10 | 0) == (i9 | 0);
 do if (!i8) {
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i9 + 160 >> 2] | 0 : i7 & 255;
  i3 = i5 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 164 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 160 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 160 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i10 + 112 >> 2] = HEAP32[i9 + 112 >> 2];
 HEAP32[i10 + 116 >> 2] = HEAP32[i9 + 116 >> 2];
 HEAP8[i10 + 120 >> 0] = HEAP8[i9 + 120 >> 0] | 0;
 if (i8) HEAP32[i10 + 264 >> 2] = HEAP32[i9 + 264 >> 2]; else {
  __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10 + 124 | 0, HEAP32[i9 + 124 >> 2] | 0, HEAP32[i9 + 128 >> 2] | 0);
  HEAP32[i10 + 264 >> 2] = HEAP32[i9 + 264 >> 2];
  __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i10 + 176 | 0, HEAP32[i9 + 176 >> 2] | 0, HEAP32[i9 + 180 >> 2] | 0);
 }
 i1 = i9 + 172 | 0;
 HEAP32[i10 + 172 >> 2] = HEAP32[i1 >> 2] & -169 | 136;
 i2 = HEAP32[i9 + 152 >> 2] | 0;
 if (i2 | 0) {
  i8 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i3 = i10 + 152 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i8 = i4 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  if (!(HEAP32[i8 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63736 | 0);
  }
 }
 HEAP32[i3 >> 2] = i2;
 HEAP32[i10 + 256 >> 2] = HEAP32[i9 + 256 >> 2];
 i6 = i9 + 240 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i10 + 240 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i9 + 248 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i10 + 248 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 if (HEAP32[i1 >> 2] & 262144 | 0) {
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN18ProceduralMaterial17AwakeDependenciesEb(i10, 0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 2) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 425246 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 425246 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z21DetailPrototypeToMonoRK15DetailPrototypeR19MonoDetailPrototype(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 }
 HEAP32[i9 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 19;
   }
  }
  if ((i7 | 0) == 17) i7 = 19;
  if ((i7 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 HEAP32[i9 + 4 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i7 = HEAP32[i8 + 36 >> 2] | 0;
 i6 = HEAP32[i8 + 40 >> 2] | 0;
 i5 = HEAP32[i8 + 44 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i9 + 12 >> 2] = i7;
 HEAP32[i9 + 16 >> 2] = i6;
 HEAP32[i9 + 20 >> 2] = i5;
 i5 = HEAP32[i8 + 52 >> 2] | 0;
 i6 = HEAP32[i8 + 56 >> 2] | 0;
 i7 = HEAP32[i8 + 60 >> 2] | 0;
 HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 48 >> 2];
 HEAP32[i9 + 28 >> 2] = i5;
 HEAP32[i9 + 32 >> 2] = i6;
 HEAP32[i9 + 36 >> 2] = i7;
 HEAP32[i9 + 40 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 44 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 48 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 52 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i9 + 56 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i9 + 60 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i9 + 64 >> 2] = HEAP32[i8 + 68 >> 2];
 HEAP32[i9 + 68 >> 2] = HEAP32[i8 + 72 >> 2];
 STACKTOP = i10;
 return;
}

function __Z10SetGlobalR15TransformAccessRKN4math7_float4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i3 = i11;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  i10 = i1;
  i1 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
 } else {
  i10 = i1;
  i1 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + (i10 << 2) >> 2] | 0;
  i9 = i3;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z24InverseTransformRotationRK23TransformAccessReadOnlyRKN4math7_float4E(i3, i5);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f17 = Math_fround(f15 * f15);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f4 = Math_fround(f14 * f14);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(f13 * f13);
 f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(Math_fround(f17 + f4) + Math_fround(f12 + Math_fround(f16 * f16)));
 f4 = Math_fround(Math_sqrt(Math_fround(f12)));
 f15 = Math_fround(f15 / f4);
 f14 = Math_fround(f14 / f4);
 f13 = Math_fround(f13 / f4);
 f4 = Math_fround(f16 / f4);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f12 > Math_fround(1.0e-30);
 i2 = i9 ? i2 : 0;
 i3 = i9 ? i3 : 0;
 i5 = i9 ? i5 : 0;
 i7 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i20 = i6 + (i10 * 40 | 0) + 12 | 0;
 f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f17 != Math_fround(HEAPF32[i20 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i19 = i6 + (i10 * 40 | 0) + 16 | 0;
 i21 = f17 != Math_fround(HEAPF32[i19 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = i6 + (i10 * 40 | 0) + 20 | 0;
 i22 = f17 != Math_fround(HEAPF32[i18 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i6 + (i10 * 40 | 0) + 24 | 0;
 i9 = f17 != Math_fround(HEAPF32[i8 >> 2]) | (i22 | (i21 | i9));
 HEAP32[i20 >> 2] = i2;
 HEAP32[i19 >> 2] = i3;
 HEAP32[i18 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 if (!i9) {
  i22 = 0;
  STACKTOP = i11;
  return i22 | 0;
 }
 i5 = HEAP32[i1 + 44 >> 2] | HEAP32[i1 + 40 >> 2];
 i6 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i10 << 2) >> 2] | 0;
 if (!i6) {
  i22 = 1;
  STACKTOP = i11;
  return i22 | 0;
 }
 i7 = HEAP32[i1 + 60 >> 2] | 0;
 i8 = HEAP32[i1 + 56 >> 2] | 0;
 i9 = i1 + 36 | 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i10;
 while (1) {
  i22 = HEAP32[i7 + (i1 << 2) >> 2] & i5;
  i21 = i8 + (i1 << 2) | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i22;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i22;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc(i8, i3, i7, i4, i1, i2, i11, i5, i9, i6) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i13 = i12;
 i16 = gb + 63520 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 i10 = __Z20CreateObjectFromCodeI13RenderTextureEPT_17AwakeFromLoadMode10MemLabelId(4, i10) | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, 4);
 __ZN13RenderTexture8SetWidthEi(i10, i1);
 __ZN13RenderTexture9SetHeightEi(i10, i2);
 __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i10, HEAP32[i8 + 72 >> 2] | 0);
 i1 = (HEAP8[i8 + 104 >> 0] | 0) != 0 & i7;
 if (!(HEAP8[i8 + 76 >> 0] | 0)) i2 = 2; else {
  i2 = (HEAP8[(__Z17GetPlayerSettingsv() | 0) + 383 >> 0] | 0) != 0;
  i2 = i2 ? 1 : 2;
 }
 __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat(i10, i1 ? 0 : i2);
 __ZN13RenderTexture16SetSRGBReadWriteEb(i10, (HEAP8[i8 + 105 >> 0] | 0) != 0);
 __ZN13RenderTexture15SetAntiAliasingEi(i10, i11);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, 61);
 __ZN13RenderTexture10SetVRUsageE14VRTextureUsage(i10, i4);
 __ZN13RenderTexture15SetAsEyeTextureEb(i10, 1);
 HEAP8[i10 + 123 >> 0] = HEAP8[i8 + 68 >> 0] ^ 1;
 if (i5) {
  __ZN13RenderTexture12SetDimensionE16TextureDimension(i10, 5);
  __ZN13RenderTexture14SetVolumeDepthEi(i10, 2);
 }
 if (i6 | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i6 | 0);
 HEAP32[i3 >> 2] = i10;
 f17 = Math_fround(HEAPF32[i8 + 96 >> 2]);
 i6 = ~~Math_fround(f17 * Math_fround((HEAP32[i8 + 56 >> 2] | 0) >>> 0));
 i13 = ~~Math_fround(f17 * Math_fround((HEAP32[i8 + 60 >> 2] | 0) >>> 0));
 i14 = HEAP32[i10 + 92 >> 2] | 0;
 i15 = HEAP32[i10 + 96 >> 2] | 0;
 i16 = HEAP32[i10 + 100 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 148 >> 2] | 0, i10 | 0) | 0;
 i1 = __Z25EstimateRenderTextureSizeiii19RenderTextureFormat17DepthBufferFormat16TextureDimensionb(i6, i13, i14, i15, i16, i1, (HEAP8[i10 + 116 >> 0] | 0) != 0) | 0;
 if ((i1 | 0) <= 0) {
  i16 = 0;
  STACKTOP = i12;
  return i16 | 0;
 }
 if ((Math_imul(HEAP32[i8 + 100 >> 2] | 0, i1) | 0) < 1) {
  i16 = 0;
  STACKTOP = i12;
  return i16 | 0;
 }
 if (i7) {
  i1 = i8 + 80 + (i9 << 2) | 0;
  i2 = i8 + 88 + (i9 << 2) | 0;
  if (!(__ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i10, i1, i2) | 0)) {
   i16 = 0;
   STACKTOP = i12;
   return i16 | 0;
  }
  if ((i11 | 0) > 1 & (HEAP32[i1 >> 2] | 0) == 0) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0)) HEAP32[i1 >> 2] = HEAP32[i10 + 128 >> 2];
  if (!(HEAP32[i2 >> 2] | 0)) {
   i1 = i10 + 136 | 0;
   i16 = HEAP32[i1 >> 2] | 0;
   HEAP32[i2 >> 2] = i16;
   if (!i16) HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  }
 } else if (!(__ZN13RenderTexture6CreateEv(i10) | 0)) {
  i16 = 0;
  STACKTOP = i12;
  return i16 | 0;
 }
 i16 = 1;
 STACKTOP = i12;
 return i16 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 4, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 4) | 0, 0, i5 - i4 << 4 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 4) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843857 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN13HeightmapData8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 843857 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13HeightmapData8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z28CalculatePositionAndVelocityR8Vector3fS0_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesj(i5, i6, i7, i8, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i4 = HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 i14 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2];
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i14;
 f12 = Math_fround(HEAPF32[(HEAP32[i1 + 60 >> 2] | 0) + (i2 << 2) >> 2]);
 f13 = Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + (i2 << 2) >> 2]);
 f9 = Math_fround(HEAPF32[(HEAP32[i1 + 100 >> 2] | 0) + (i2 << 2) >> 2]);
 f11 = Math_fround(HEAPF32[(HEAP32[i1 + 120 >> 2] | 0) + (i2 << 2) >> 2]);
 f10 = Math_fround(HEAPF32[(HEAP32[i1 + 140 >> 2] | 0) + (i2 << 2) >> 2]);
 f10 = Math_fround(f13 + f10);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[(HEAP32[i1 + 160 >> 2] | 0) + (i2 << 2) >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(f12 + f11);
 i1 = i6 + 4 | 0;
 HEAPF32[i1 >> 2] = f10;
 i2 = i6 + 8 | 0;
 HEAPF32[i2 >> 2] = f9;
 if ((HEAP32[i7 + 280 >> 2] | 0) == 1) return;
 i21 = i8 + 52 | 0;
 f12 = Math_fround(HEAPF32[i21 >> 2]);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(f12 * f13);
 i20 = i8 + 68 | 0;
 f9 = Math_fround(HEAPF32[i20 >> 2]);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f12 + Math_fround(f9 * f10));
 i19 = i8 + 84 | 0;
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f9 + Math_fround(f12 * f11));
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 100 >> 2]) + f12);
 i18 = i8 + 56 | 0;
 f9 = Math_fround(f13 * Math_fround(HEAPF32[i18 >> 2]));
 i17 = i8 + 72 | 0;
 f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2])));
 i16 = i8 + 88 | 0;
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i16 >> 2])));
 f9 = Math_fround(Math_fround(HEAPF32[i8 + 104 >> 2]) + f9);
 i15 = i8 + 60 | 0;
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i15 >> 2]));
 i7 = i8 + 76 | 0;
 f10 = Math_fround(f13 + Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2])));
 i14 = i8 + 92 | 0;
 f11 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2])));
 f11 = Math_fround(Math_fround(HEAPF32[i8 + 108 >> 2]) + f11);
 HEAPF32[i5 >> 2] = f12;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i4 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i21 >> 2]);
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(f11 * f9);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f11 + Math_fround(f12 * f10));
 f11 = Math_fround(HEAPF32[i19 >> 2]);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f12 + Math_fround(f11 * f13));
 f12 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i17 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i16 >> 2])));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2])));
 f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i14 >> 2])));
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i1 >> 2] = f12;
 HEAPF32[i2 >> 2] = f13;
 return;
}

function __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i12 >> 2] | 0;
 i3 = i14;
 i14 = i14 + ((HEAP32[i2 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i15 = i12 + 4 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i7;
 i5 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i14 | 0) == (i7 | 0)) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 >> 2] = i14 + 4;
   i15 = i14;
   STACKTOP = i16;
   return i15 | 0;
  }
  i4 = i2 - (i14 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i14 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i6 = (i7 + (0 - i5 << 2) + ~i14 | 0) >>> 2;
   i3 = i7;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
   }
   HEAP32[i15 >> 2] = i7 + (i6 + 1 << 2);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i14 | 0, i4 | 0) | 0;
  if (i14 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i15 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = i12 + 12 | 0;
 i10 = i2 - i3 | 0;
 i6 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i10 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else {
  i10 = i4;
  i2 = i5;
 }
 i9 = i2 - i3 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 2147483647;
 i9 = i14;
 i5 = i9 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 25;
  HEAP32[i13 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i8 + (i6 << 2) | 0;
 i4 = i2;
 i3 = i8 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i2 = i2 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i4 = i2;
   break;
  }
  i3 = i7 << 2 >> 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 25;
  HEAP32[i13 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i7 + (i3 >>> 2 << 2) | 0;
  i4 = i2;
  i3 = i7 + (i3 << 2) | 0;
  if (i8) {
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = 25;
   HEAP32[i13 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = i9 - i2 | 0;
 i6 = i4 + (0 - (i5 >> 2) << 2) | 0;
 if ((i5 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i5 | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i3;
 if (!i2) {
  i15 = i4;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = 25;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i4;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK6Sprite9GetBoundsE8Vector2fbb(i17, i1, i2, i7, i10) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 f21 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 140 >> 2]);
 f21 = Math_fround(Math_fround(f21 / f18) * Math_fround(.5));
 f19 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) / f18) * Math_fround(.5));
 f20 = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) / f18);
 f18 = Math_fround(Math_fround(HEAPF32[i1 + 52 >> 2]) / f18);
 f11 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f13 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f14 = Math_fround(-f11);
 f15 = Math_fround(-f13);
 f16 = Math_fround(-f12);
 f6 = Math_fround(Math_fround(-f21) - f20);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 + f5);
 f8 = Math_fround(f19 - f18);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f8 + f9);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = Math_fround(Math_fround(f21 - f20) + f5);
 f9 = Math_fround(Math_fround(Math_fround(-f19) - f18) + f9);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 if (i7 | i10) {
  if (i7) {
   f21 = Math_fround(-f5);
   i3 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   f21 = Math_fround(-f6);
   i4 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  }
  if (i10) {
   f21 = Math_fround(-f9);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
   f21 = Math_fround(-f8);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
  }
 }
 f18 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = f18 < f11 ? f18 : f11;
 f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = f11 < f13 ? f11 : f13;
 i10 = f12 > Math_fround(.100000001);
 f21 = i10 ? Math_fround(.100000001) : f12;
 f18 = f18 > f14 ? f18 : f14;
 f15 = f11 > f15 ? f11 : f15;
 i10 = f16 < Math_fround(.100000001);
 f16 = i10 ? Math_fround(.100000001) : f16;
 f14 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = f14 < f19 ? f14 : f19;
 f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f20 = f13 < f20 ? f13 : f20;
 i10 = f21 > Math_fround(-.100000001);
 f21 = i10 ? Math_fround(-.100000001) : f21;
 f18 = f18 < f14 ? f14 : f18;
 f15 = f15 < f13 ? f13 : f15;
 i10 = f16 < Math_fround(-.100000001);
 f16 = i10 ? Math_fround(-.100000001) : f16;
 f13 = Math_fround(Math_fround(f20 + f15) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f21 + f16) * Math_fround(.5));
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(f19 + f18) * Math_fround(.5));
 HEAPF32[i17 + 4 >> 2] = f13;
 HEAPF32[i17 + 8 >> 2] = f14;
 f20 = Math_fround(Math_fround(f15 - f20) * Math_fround(.5));
 f21 = Math_fround(Math_fround(f16 - f21) * Math_fround(.5));
 HEAPF32[i17 + 12 >> 2] = Math_fround(Math_fround(f18 - f19) * Math_fround(.5));
 HEAPF32[i17 + 16 >> 2] = f20;
 HEAPF32[i17 + 20 >> 2] = f21;
 return;
}

function __Z18AddGroupToWorkloadR26BlockRangeBalancedWorkloadjR13dynamic_arrayI10BlockRangeLj4EERS1_IjLj4EE(i1, i20, i21, i22, i23) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i24 = 0, i25 = 0;
 i24 = i22 + 12 | 0;
 i25 = HEAP32[i24 >> 2] | 0;
 HEAP32[i1 >> 2] = i25;
 i18 = i1 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 if (!i21) {
  i23 = i20 + 8 | 0;
  i24 = i25;
  i22 = HEAP32[i23 >> 2] | 0;
  i22 = i22 + 1 | 0;
  HEAP32[i23 >> 2] = i22;
  i25 = i24 - i25 | 0;
  HEAP32[i18 >> 2] = i25;
  return;
 }
 i19 = i20 + 4 | 0;
 i10 = i20 + 16 | 0;
 i11 = i20 + 12 | 0;
 i12 = i22 + 16 | 0;
 i13 = i22 + 4 | 0;
 i14 = i20 + 8 | 0;
 i15 = i23 + 12 | 0;
 i16 = i23 + 16 | 0;
 i17 = i23 + 4 | 0;
 i9 = 0;
 i2 = HEAP32[i19 >> 2] | 0;
 do {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i2 >>> 0 >= i1 >>> 0) {
   i1 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
   HEAP32[i20 >> 2] = i1;
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP32[i2 + (i1 * 12 | 0) >> 2] = HEAP32[i24 >> 2];
   HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i19 >> 2] = 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = 0;
  }
  i7 = HEAP32[i20 >> 2] | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  i6 = i21 - i9 | 0;
  i2 = i1 - i2 | 0;
  i6 = i2 >>> 0 < i6 >>> 0 ? i2 : i6;
  i2 = HEAP32[i24 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i12 >> 2] = i1;
    HEAP32[i22 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i22 >> 2] | 0, i1 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i22 >> 2] | 0, (HEAP32[i24 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i22 >> 2] = i5;
    break;
   }
  } while (0);
  HEAP32[i24 >> 2] = i3;
  i3 = HEAP32[i22 >> 2] | 0;
  HEAP32[i3 + (i2 * 12 | 0) >> 2] = i9;
  HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] = i6;
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i3 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i16 >> 2] = i1;
    HEAP32[i23 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i23 >> 2] | 0, i1 << 2, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i23 >> 2] | 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
    HEAP32[i16 >> 2] = i1;
    HEAP32[i23 >> 2] = i5;
    break;
   }
  } while (0);
  HEAP32[i15 >> 2] = i3;
  HEAP32[(HEAP32[i23 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i14 >> 2];
  i2 = i8 + (i7 * 12 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i9 = i6 + i9 | 0;
  i2 = (HEAP32[i19 >> 2] | 0) + i6 | 0;
  HEAP32[i19 >> 2] = i2;
 } while (i9 >>> 0 < i21 >>> 0);
 i23 = i14;
 i24 = HEAP32[i24 >> 2] | 0;
 i22 = HEAP32[i23 >> 2] | 0;
 i22 = i22 + 1 | 0;
 HEAP32[i23 >> 2] = i22;
 i25 = i24 - i25 | 0;
 HEAP32[i18 >> 2] = i25;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_(i9, i10, i11, i12, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = i10 + 4 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i9 + 4 | 0;
 i5 = f4 > Math_fround(HEAPF32[i8 >> 2]);
 i6 = i11 + 4 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = f2 > f4;
 do if (i5) {
  i5 = i9;
  i3 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i1) {
   i14 = i11;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i1 = i9;
   HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i1 + 4 >> 2] = i13;
   i1 = i11;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = 1;
   f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
  i1 = i10;
  i13 = HEAP32[i1 + 4 >> 2] | 0;
  i14 = i9;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  i14 = i10;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i14 + 4 >> 2] = i5;
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f2 > f4) {
   i13 = i11;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i1 = i10;
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 + 4 >> 2] = i14;
   i1 = i11;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = 2;
   f2 = f4;
  } else i1 = 1;
 } else if (i1) {
  i13 = i10;
  i5 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i1 = i11;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i14 = i10;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 + 4 >> 2] = i3;
  i14 = i11;
  HEAP32[i14 >> 2] = i5;
  HEAP32[i14 + 4 >> 2] = i13;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  i14 = f2 > Math_fround(HEAPF32[i8 >> 2]);
  f2 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i14) {
   i14 = i9;
   i13 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i3 = i10;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i1 = i9;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i10;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i1 + 4 >> 2] = i14;
   i1 = 2;
   f2 = Math_fround(HEAPF32[i6 >> 2]);
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(Math_fround(HEAPF32[i12 + 4 >> 2]) > f2)) {
  i14 = i1;
  return i14 | 0;
 }
 i13 = i11;
 i5 = HEAP32[i13 >> 2] | 0;
 i13 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = i12;
 i3 = HEAP32[i15 + 4 >> 2] | 0;
 i14 = i11;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = i3;
 i14 = i12;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i14 + 4 >> 2] = i13;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f4 > Math_fround(HEAPF32[i7 >> 2]))) {
  i15 = i1 + 1 | 0;
  return i15 | 0;
 }
 i14 = i10;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i6 = i11;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i15 = i10;
 HEAP32[i15 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i15 + 4 >> 2] = i12;
 i15 = i11;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i14;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f4 > Math_fround(HEAPF32[i8 >> 2]))) {
  i15 = i1 + 2 | 0;
  return i15 | 0;
 }
 i14 = i9;
 i13 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i10;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i15 = i9;
 HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i15 + 4 >> 2] = i12;
 i15 = i10;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i14;
 i15 = i1 + 3 | 0;
 return i15 | 0;
}

function __ZL22GeomMTDCallback_BoxBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 60 | 0;
 i8 = i7;
 HEAP32[i9 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i9 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i9 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i9 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f14 = Math_fround(f10 + f10);
 f20 = Math_fround(f15 + f15);
 f19 = Math_fround(f11 + f11);
 f21 = Math_fround(f15 * f20);
 f18 = Math_fround(f11 * f19);
 f15 = Math_fround(f14 * f15);
 f16 = Math_fround(f14 * f11);
 f13 = Math_fround(f14 * f12);
 f11 = Math_fround(f20 * f11);
 f20 = Math_fround(f20 * f12);
 f12 = Math_fround(f19 * f12);
 f19 = Math_fround(f15 + f12);
 f17 = Math_fround(f16 - f20);
 f12 = Math_fround(f15 - f12);
 f14 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f14));
 f10 = Math_fround(f14 - f18);
 f15 = Math_fround(f11 + f13);
 f20 = Math_fround(f16 + f20);
 f13 = Math_fround(f11 - f13);
 f14 = Math_fround(f14 - f21);
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f21) - f18);
 HEAPF32[i9 + 4 >> 2] = f19;
 HEAPF32[i9 + 8 >> 2] = f17;
 HEAPF32[i9 + 12 >> 2] = f12;
 HEAPF32[i9 + 16 >> 2] = f10;
 HEAPF32[i9 + 20 >> 2] = f15;
 HEAPF32[i9 + 24 >> 2] = f20;
 HEAPF32[i9 + 28 >> 2] = f13;
 HEAPF32[i9 + 32 >> 2] = f14;
 HEAP32[i8 + 36 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f10 = Math_fround(f14 + f14);
 f12 = Math_fround(f13 + f13);
 f17 = Math_fround(f20 + f20);
 f19 = Math_fround(f13 * f12);
 f18 = Math_fround(f20 * f17);
 f13 = Math_fround(f10 * f13);
 f21 = Math_fround(f10 * f20);
 f11 = Math_fround(f10 * f15);
 f20 = Math_fround(f12 * f20);
 f12 = Math_fround(f12 * f15);
 f15 = Math_fround(f17 * f15);
 f17 = Math_fround(f13 + f15);
 f16 = Math_fround(f21 - f12);
 f15 = Math_fround(f13 - f15);
 f10 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f10));
 f14 = Math_fround(f10 - f18);
 f13 = Math_fround(f20 + f11);
 f12 = Math_fround(f21 + f12);
 f11 = Math_fround(f20 - f11);
 f10 = Math_fround(f10 - f19);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f19) - f18);
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 HEAPF32[i8 + 12 >> 2] = f15;
 HEAPF32[i8 + 16 >> 2] = f14;
 HEAPF32[i8 + 20 >> 2] = f13;
 HEAPF32[i8 + 24 >> 2] = f12;
 HEAPF32[i8 + 28 >> 2] = f11;
 HEAPF32[i8 + 32 >> 2] = f10;
 i6 = __ZN5physx2Gu17computeMTD_BoxBoxERNS_6PxVec3ERfRKNS0_3BoxES6_(i4, i1, i9, i8) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Cm18visualizeLimitConeERNS0_12RenderOutputEfRKNS_11PxTransformEffb(i17, f18, i2, f19, f20, i1) {
 i17 = i17 | 0;
 f18 = Math_fround(f18);
 i2 = i2 | 0;
 f19 = Math_fround(f19);
 f20 = Math_fround(f20);
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 36 | 0;
 i14 = i21 + 24 | 0;
 i15 = i21 + 12 | 0;
 i16 = i21;
 i5 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i17, i2) | 0;
 __ZN5physx2Cm12RenderOutputlsEj(i5, i1 ? -65536 : -8355712) | 0;
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i17, 1) | 0;
 i5 = i13 + 4 | 0;
 i9 = i13 + 8 | 0;
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 i1 = i15 + 4 | 0;
 i2 = i15 + 8 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16 + 8 | 0;
 i6 = 0;
 i7 = 0;
 i8 = 0;
 i12 = 0;
 do {
  f32 = Math_fround(Math_fround(i12 >>> 0) * Math_fround(.196349546));
  f29 = Math_fround(Math_fround(+Math_sin(+f32)) * f20);
  f32 = Math_fround(Math_fround(+Math_cos(+f32)) * f19);
  f28 = Math_fround(Math_fround(f32 * f32) + Math_fround(Math_fround(f29 * f29) + Math_fround(0.0)));
  f25 = Math_fround(Math_fround(1.0) / Math_fround(f28 + Math_fround(1.0)));
  f34 = Math_fround(f25 * Math_fround(0.0));
  f29 = Math_fround(f25 * Math_fround(f29 * Math_fround(-2.0)));
  f32 = Math_fround(Math_fround(f32 * Math_fround(2.0)) * f25);
  f28 = Math_fround(f25 * Math_fround(Math_fround(1.0) - f28));
  f25 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
  f33 = Math_fround(f29 * Math_fround(0.0));
  f24 = Math_fround(f32 * Math_fround(0.0));
  f31 = Math_fround(f24 + Math_fround(Math_fround(f34 * Math_fround(2.0)) + f33));
  f23 = Math_fround(f25 * Math_fround(0.0));
  f30 = Math_fround(f34 * Math_fround(0.0));
  f25 = Math_fround(Math_fround(Math_fround(f34 * f31) + Math_fround(Math_fround(Math_fround(f33 - f24) * f28) + Math_fround(f25 * Math_fround(2.0)))) * f18);
  f24 = Math_fround(Math_fround(Math_fround(f29 * f31) + Math_fround(Math_fround(Math_fround(Math_fround(f32 * Math_fround(2.0)) - f30) * f28) + f23)) * f18);
  f23 = Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(Math_fround(Math_fround(f30 - Math_fround(f29 * Math_fround(2.0))) * f28) + f23)) * f18);
  i27 = i6;
  i6 = (HEAPF32[tempDoublePtr >> 2] = f25, HEAP32[tempDoublePtr >> 2] | 0);
  i26 = i7;
  i7 = (HEAPF32[tempDoublePtr >> 2] = f24, HEAP32[tempDoublePtr >> 2] | 0);
  i22 = i8;
  i8 = (HEAPF32[tempDoublePtr >> 2] = f23, HEAP32[tempDoublePtr >> 2] | 0);
  HEAP32[i13 >> 2] = i27;
  HEAP32[i5 >> 2] = i26;
  HEAP32[i9 >> 2] = i22;
  i22 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i17, i13) | 0;
  HEAPF32[i14 >> 2] = f25;
  HEAPF32[i10 >> 2] = f24;
  HEAPF32[i11 >> 2] = f23;
  i22 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i22, i14) | 0;
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  i22 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i22, i15) | 0;
  HEAPF32[i16 >> 2] = f25;
  HEAPF32[i3 >> 2] = f24;
  HEAPF32[i4 >> 2] = f23;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i22, i16) | 0;
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 33);
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i12 >> 2] | 0;
 i3 = i14;
 i14 = i14 + ((HEAP32[i2 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i15 = i12 + 4 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i7;
 i5 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i14 | 0) == (i7 | 0)) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 >> 2] = i14 + 4;
   i15 = i14;
   STACKTOP = i16;
   return i15 | 0;
  }
  i4 = i2 - (i14 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i14 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i6 = (i7 + (0 - i5 << 2) + ~i14 | 0) >>> 2;
   i3 = i7;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
   }
   HEAP32[i15 >> 2] = i7 + (i6 + 1 << 2);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i14 | 0, i4 | 0) | 0;
  if (i14 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i15 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = i12 + 12 | 0;
 i10 = i2 - i3 | 0;
 i6 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i10 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else {
  i10 = i4;
  i2 = i5;
 }
 i9 = i2 - i3 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 2147483647;
 i9 = i14;
 i5 = i9 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 76;
  HEAP32[i13 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i8 + (i6 << 2) | 0;
 i4 = i2;
 i3 = i8 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i2 = i2 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i4 = i2;
   break;
  }
  i3 = i7 << 2 >> 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 76;
  HEAP32[i13 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i7 + (i3 >>> 2 << 2) | 0;
  i4 = i2;
  i3 = i7 + (i3 << 2) | 0;
  if (i8) {
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = 76;
   HEAP32[i13 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = i9 - i2 | 0;
 i6 = i4 + (0 - (i5 >> 2) << 2) | 0;
 if ((i5 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i5 | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i3;
 if (!i2) {
  i15 = i4;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = 76;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i4;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i12 >> 2] | 0;
 i3 = i14;
 i14 = i14 + ((HEAP32[i2 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i15 = i12 + 4 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i7;
 i5 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i14 | 0) == (i7 | 0)) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 >> 2] = i14 + 4;
   i15 = i14;
   STACKTOP = i16;
   return i15 | 0;
  }
  i4 = i2 - (i14 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i14 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i6 = (i7 + (0 - i5 << 2) + ~i14 | 0) >>> 2;
   i3 = i7;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
   }
   HEAP32[i15 >> 2] = i7 + (i6 + 1 << 2);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i14 | 0, i4 | 0) | 0;
  if (i14 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i15 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = i12 + 12 | 0;
 i10 = i2 - i3 | 0;
 i6 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i10 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else {
  i10 = i4;
  i2 = i5;
 }
 i9 = i2 - i3 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 2147483647;
 i9 = i14;
 i5 = i9 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 62;
  HEAP32[i13 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i8 + (i6 << 2) | 0;
 i4 = i2;
 i3 = i8 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i2 = i2 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i4 = i2;
   break;
  }
  i3 = i7 << 2 >> 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 62;
  HEAP32[i13 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i7 + (i3 >>> 2 << 2) | 0;
  i4 = i2;
  i3 = i7 + (i3 << 2) | 0;
  if (i8) {
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = 62;
   HEAP32[i13 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = i9 - i2 | 0;
 i6 = i4 + (0 - (i5 >> 2) << 2) | 0;
 if ((i5 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i5 | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i3;
 if (!i2) {
  i15 = i4;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = 62;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i4;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 4 | 0;
 i12 = i15;
 i9 = i13 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i12 | 0, i2 | 0) | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP8[i12 >> 0] = i2 >>> 24;
 HEAP8[i12 + 3 >> 0] = i2;
 HEAP8[i12 + 1 >> 0] = i2 >>> 16;
 HEAP8[i12 + 2 >> 0] = (i2 & 65535) >>> 8;
 i2 = HEAP32[i12 >> 2] | 0;
 i9 = i2 << 5;
 i6 = HEAP32[i13 + 20 >> 2] | 0;
 i10 = i6 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i7 = i6 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1;
 i11 = i3 - i4 | 0;
 i5 = i11 + i9 | 0;
 if (i5) {
  i8 = i6 + 20 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i5 >>> 0) {
   i1 = i5 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i5 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i6 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i11 | 0) | 0;
    i6 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i3 = i1 + i11 | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i8 >> 2] = i1 + i4;
   i2 = HEAP32[i12 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i3 + i9;
 i3 = i1 + i11 | 0;
 if (!i2) {
  i13 = 0;
  i12 = i3;
  i13 = i3 + (i13 << 5) | 0;
  HEAP32[i14 >> 2] = i12;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = i13;
  STACKTOP = i15;
  return;
 }
 i2 = 0;
 do {
  i1 = i3 + (i2 << 5) | 0;
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 4 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 8 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 12 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 13 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 14 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 15 | 0);
  i1 = i3 + (i2 << 5) + 16 | 0;
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 4 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 8 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 28 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 29 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 30 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 5) + 31 | 0);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 i12 = i3;
 i13 = i3 + (i1 << 5) | 0;
 HEAP32[i14 >> 2] = i12;
 i14 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = i13;
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899355 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN12PPtrKeyframe8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899355 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN12PPtrKeyframe8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i9 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i4;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i8;
  i2 = i8;
  i1 = i8;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i8 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 590084 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L20 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i6 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN12LightmapData8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L20;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 590084 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN12LightmapData8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i5);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i6 + 36 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i6 + 54 | 0;
 i7 = i5 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 2 | 0;
 i8 = i5 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i6 + 52 | 0;
 i2 = i3 + 2 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 68 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i6 + 72 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 56 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i6 + 60 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 88 | 0, i5);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 92 | 0, i5);
 i1 = i6 + 76 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i6 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 64 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 }
}

function __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i7 = i10 + 8 | 0;
 __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i8, i5, i6, 3, 32, 0, 0);
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i5 + 72 | 0;
 i2 = (HEAP32[i9 >> 2] | 0) + i8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 1;
 HEAP32[i2 + 12 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i4 + 8 >> 2] = -1;
 HEAP32[i4 + 12 >> 2] = -1;
 if (i1 | 0) {
  __ZN9ShaderLab6TexEnvC2ERKNS_25SerializedTexturePropertyE(i7, i1);
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + i8 + 20 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i5, i6, gb + 478716 | 0) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + i8 + 20 >> 2] = i1;
 }
 i3 = i5 + 12 | 0;
 i4 = i5 + 52 | 0;
 i2 = i2 + (HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) + i1 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + i8 + 24 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i5, i6, gb + 478720 | 0) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + i8 + 24 >> 2] = i1;
 }
 i1 = i2 + (HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) + i1 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i7, 0, 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + i8 + 28 >> 2] | 0;
 if ((i2 | 0) >= 0) {
  i9 = i2;
  i6 = i1;
  i5 = HEAP32[i3 >> 2] | 0;
  i9 = i5 + i9 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i9 = i5 + (i9 << 2) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = i9 & 1048575;
  i9 = i6 + i9 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  STACKTOP = i10;
  return i8 | 0;
 }
 i5 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i5, i6, gb + 478731 | 0) | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i6 + i8 + 28 >> 2] = i5;
 i9 = i5;
 i5 = HEAP32[i3 >> 2] | 0;
 i9 = i5 + i9 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i9 = i5 + (i9 << 2) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i9 = i9 & 1048575;
 i9 = i6 + i9 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 STACKTOP = i10;
 return i8 | 0;
}

function __ZN9ShaderLab27SerializedShaderVectorValue8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 471434 | 0, i1, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085899 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i3, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN29AssetBundleLoadAssetOperation15ForceLoadAssetsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i12 = i14;
 i11 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i4 + 160 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i12);
   i2 = HEAP32[i10 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if ((HEAP16[gb + 1104172 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104172 | 0, i10);
  i6 = gb + 1104172 | 0;
 } else i6 = 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i12);
 i2 = i10;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 __ZN29AssetBundleLoadAssetOperation34CollectFullPreloadDataDependenciesER13dynamic_arrayIiLj4EE(i4, i11);
 if (HEAP32[i7 >> 2] | 0) {
  i4 = 0;
  do {
   i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   do if (i5 | 0) {
    HEAP32[i12 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 22; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i12);
      i2 = HEAP32[i10 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 22; else if (HEAP32[i1 + 4 >> 2] | 0) break;
    }
    if ((i13 | 0) == 22) i13 = 0;
    __Z31ReadObjectFromPersistentManageri(i5) | 0;
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i9);
  HEAP32[i11 >> 2] = 0;
 }
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i14;
 return;
}

function __ZN10Matrix3x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034440 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034444 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034448 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034452 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034456 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034460 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034464 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034468 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034472 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034476 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034480 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034484 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i12 = i1 + 16 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 32 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 4;
 i3 = i8 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 134217727;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 5) | 0;
 i7 = i5 + (i1 - i4 >> 5 << 5) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 5) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = i8 + 32 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i7 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -32 | 0;
   __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i2 + -32 | 0, i1);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i7 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i4 = i7;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  i6 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -32 | 0;
   i3 = i2 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -20 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i13;
 return;
}

function __ZN14UnityAnalytics23OnSceneLoadedAfterAwakeEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i8, i3, i1, i2) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 104 | 0;
 i10 = i11;
 i7 = i11 + 88 | 0;
 i5 = __Z15GetSceneManagerv() | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i3 | 0) | 0;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0) | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = i5 + 28 | 0;
 i1 = HEAP8[i6 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i5 + 32 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = -2147483632;
 HEAP32[i7 + 4 >> 2] = 15;
 i2 = i1;
 i3 = gb + 1037596 | 0;
 i4 = i2 + 15 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 15 >> 0] = 0;
 __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr(i10, i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
 }
 __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcRK8UnityStr(i10, gb + 1037612 | 0, i6) | 0;
 i1 = __ZNK10UnityScene13GetBuildIndexEv(i5) | 0;
 __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i10, gb + 1037623 | 0, i1) | 0;
 i1 = __Z16GetBuildSettingsv() | 0;
 __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcj(i10, gb + 1037633 | 0, (HEAP32[i1 + 32 >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) >> 4) | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i10, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i10 >> 2] = gb + 188456 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i10 + 64 | 0, HEAP32[i10 + 68 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i10 + 48 | 0, HEAP32[i10 + 52 >> 2] | 0);
 i1 = i10 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i10 + 44 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 HEAP32[i10 >> 2] = gb + 190148 + 8;
 i1 = i10 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i10 + 16 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 STACKTOP = i11;
 return;
}

function __ZNK20LocalFileSystemPosix9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag(i14, i1, i15, i4, i16, i17) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22;
 i20 = i22 + 84 | 0;
 i18 = i22 + 8 | 0;
 i21 = _opendir(i1) | 0;
 if (!i21) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 };
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i20, i1, _strlen(i1) | 0);
 i13 = i20 + 11 | 0;
 i2 = HEAP8[i13 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i20 + 4 >> 2] | 0 : i2 & 255;
 if (!i2) i3 = 4; else if ((HEAP8[(i1 ? HEAP32[i20 >> 2] | 0 : i20) + i2 + -1 >> 0] | 0) != 47) i3 = 4;
 if ((i3 | 0) == 4) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i20, gb + 1087627 | 0) | 0;
 i1 = _readdir(i21) | 0;
 L9 : do if (!i1) i1 = 1; else {
  i8 = i15 + 12 | 0;
  i9 = i15 + 16 | 0;
  i10 = i15 + 4 | 0;
  i11 = i18 + 12 | 0;
  i12 = i18 + 56 | 0;
  i7 = i4 ^ 1;
  while (1) {
   i5 = i1 + 11 | 0;
   if (_strcmp(i5, gb + 1087625 | 0) | 0) if (_strcmp(i5, gb + 491572 | 0) | 0) {
    i6 = HEAP32[i8 >> 2] | 0;
    i2 = i6 + 1 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    i4 = i3 & 2147483647;
    do if (i2 >>> 0 > i4 >>> 0) {
     i1 = i3 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
      HEAP32[i9 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 1088 | 0, 8, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 1088 | 0, 8, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i4 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 1088 | 0) | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i15 >> 2] = i4;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i2;
    i4 = HEAP32[i15 >> 2] | 0;
    i1 = i4 + (i6 * 1088 | 0) | 0;
    HEAP32[i19 >> 2] = (HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20;
    HEAP32[i19 + 4 >> 2] = i5;
    _sprintf(i1, gb + 491575 | 0, i19) | 0;
    _stat(i1, i18) | 0;
    i3 = HEAP32[i11 >> 2] & 61440;
    i2 = i4 + (i6 * 1088 | 0) + 1080 | 0;
    HEAP8[i2 >> 0] = (i3 | 0) == 16384 & 1;
    HEAP8[i4 + (i6 * 1088 | 0) + 1081 >> 0] = (i3 | 0) == 40960 & 1;
    HEAP8[i4 + (i6 * 1088 | 0) + 1082 >> 0] = (HEAP8[i5 >> 0] | 0) == 46 & 1;
    __Z19UnixTimeToUnityTimelR8DateTime(HEAP32[i12 >> 2] | 0, i4 + (i6 * 1088 | 0) + 1072 | 0);
    if (__Z16FlaggedAsSkippedIA256_cEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i1, i5, i17) | 0) HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1; else if (!((HEAP8[i2 >> 0] | 0) == 0 | i7)) if (!(mftCall_iiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 148 >> 2] | 0, i14 | 0, i1 | 0, i15 | 0, 1, i16 | 0, i17 | 0) | 0)) break;
   }
   i1 = _readdir(i21) | 0;
   if (!i1) {
    i1 = 1;
    break L9;
   }
  }
  i1 = 0;
 } while (0);
 _closedir(i21) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
 i21 = i1;
 STACKTOP = i22;
 return i21 | 0;
}

function __ZN5Unity17ConfigurableJoint5ResetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i2) i3 = 4; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i2, i1) | 0) {
  f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i1 + 16 >> 2]));
  HEAPF32[i4 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 44 >> 2] = f6;
  HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 } else i3 = 4;
 if ((i3 | 0) == 4) {
  i3 = i4 + 40 | 0;
  HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i1 = i4 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 i1 = i4 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP32[i4 + 96 >> 2] = 2;
 HEAP32[i4 + 100 >> 2] = 2;
 HEAP32[i4 + 104 >> 2] = 2;
 HEAP32[i4 + 108 >> 2] = 2;
 HEAP32[i4 + 112 >> 2] = 2;
 HEAP32[i4 + 116 >> 2] = 2;
 i1 = i4 + 212 | 0;
 i2 = i4 + 120 | 0;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 216 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 224 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 228 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 236 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 256 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 260 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 248 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 264 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 268 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 272 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i4 + 276 >> 2] = 0;
 HEAPF32[i4 + 280 >> 2] = Math_fround(.100000001);
 HEAPF32[i4 + 284 >> 2] = Math_fround(180.0);
 HEAP32[i4 + 288 >> 2] = 0;
 i3 = i4 + 296 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 308 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 312 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 316 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 320 >> 2] = Math_fround(1.0);
 i3 = i4 + 324 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i3 = i4 + 336 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i3 = i4 + 348 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62536 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
 HEAP8[i4 + 292 >> 0] = 0;
 HEAP8[i4 + 293 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN15NavMeshObstacle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i7);
 i6 = i9 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i10 = i7 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i7 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i9 + 56 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 68 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i9 + 69 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i9 + 44 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 }
}

function __ZN20ArchiveStorageHeader13IsArchiveFileER12FileAccessor(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i6 = i13 + 24 | 0;
 i12 = i13 + 8 | 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE7reserveEj(i12, 64);
 i9 = i12 + 11 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i12 >> 2] >> 0] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
 } else {
  HEAP8[i12 >> 0] = 0;
  HEAP8[i9 >> 0] = 0;
 }
 i7 = __ZN12FileAccessor4ReadEyPvPy(i4, 1, 0, i6, i11) | 0;
 i8 = i11;
 L5 : do if (i7 & ((HEAP32[i8 >> 2] | 0) == 1 & (HEAP32[i8 + 4 >> 2] | 0) == 0)) {
  i7 = i12 + 8 | 0;
  i5 = i12 + 4 | 0;
  do {
   i8 = HEAP8[i6 >> 0] | 0;
   if (!(i8 << 24 >> 24)) break L5;
   i1 = HEAP8[i9 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) {
    i3 = HEAP32[i5 >> 2] | 0;
    i1 = (HEAP32[i7 >> 2] & 2147483647) + -1 | 0;
   } else {
    i3 = i1 & 255;
    i1 = 10;
   }
   if ((i3 | 0) == (i1 | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i12, i1, 1, i1, i1, 0, 0);
    if ((HEAP8[i9 >> 0] | 0) > -1) i10 = 14; else i10 = 15;
   } else if (i2) i10 = 15; else i10 = 14;
   if ((i10 | 0) == 14) {
    i10 = 0;
    HEAP8[i9 >> 0] = i3 + 1;
    i1 = i12;
   } else if ((i10 | 0) == 15) {
    i10 = 0;
    i1 = HEAP32[i12 >> 2] | 0;
    HEAP32[i5 >> 2] = i3 + 1;
   }
   i3 = i1 + i3 | 0;
   HEAP8[i3 >> 0] = i8;
   HEAP8[i3 + 1 >> 0] = 0;
   i3 = __ZN12FileAccessor4ReadEyPvPy(i4, 1, 0, i6, i11) | 0;
   i8 = i11;
  } while (i3 & ((HEAP32[i8 >> 2] | 0) == 1 & (HEAP32[i8 + 4 >> 2] | 0) == 0));
 } else i5 = i12 + 4 | 0; while (0);
 i3 = HEAP32[gb + 70780 >> 2] | 0;
 i4 = _strlen(i3) | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 L23 : do if ((i4 | 0) == ((i1 << 24 >> 24 < 0 ? i2 : i1 & 255) | 0)) {
  switch (i4 | 0) {
  case 0:
   {
    i2 = i1;
    i1 = 1;
    break L23;
   }
  case -1:
   {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i12);
    break;
   }
  default:
   {}
  }
  if (!(_memcmp(i1 << 24 >> 24 < 0 ? HEAP32[i12 >> 2] | 0 : i12, i3, i4) | 0)) {
   i2 = i1;
   i1 = 1;
  } else {
   i3 = i1;
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = 22;
  }
 } else {
  i3 = i1;
  i10 = 22;
 } while (0);
 L29 : do if ((i10 | 0) == 22) {
  i1 = i3 << 24 >> 24 < 0;
  switch ((i1 ? i2 : i3 & 255) | 0) {
  case 8:
   break;
  case 12:
   {
    i2 = i3;
    i1 = (_memcmp(i1 ? HEAP32[i12 >> 2] | 0 : i12, gb + 489819 | 0, 12) | 0) == 0;
    break L29;
   }
  default:
   {
    i2 = i3;
    i1 = 0;
    break L29;
   }
  }
  if (!(_memcmp(i1 ? HEAP32[i12 >> 2] | 0 : i12, gb + 489810 | 0, 8) | 0)) {
   i2 = i3;
   i1 = 1;
  } else {
   i2 = i3;
   i1 = (_memcmp(i1 ? HEAP32[i12 >> 2] | 0 : i12, gb + 489801 | 0, 8) | 0) == 0;
  }
 } while (0);
 if (i2 << 24 >> 24 >= 0) {
  STACKTOP = i13;
  return i1 | 0;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_(i1, i3, i2, i4, i5, f15, i16, i17, i18, i19) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f15 = Math_fround(f15);
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(f14 * f10);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f12 = Math_fround(f14 / Math_fround(f12 * f8));
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(f14 * f9);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f7 = Math_fround(f12 / Math_fround(f14 / Math_fround(f7 * f6)));
 f14 = Math_fround(Math_fround(f10 * Math_fround(.5)) + Math_fround(HEAPF32[i3 >> 2]));
 f12 = Math_fround(Math_fround(f8 * Math_fround(.5)) + Math_fround(HEAPF32[i3 + 4 >> 2]));
 i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 f13 = Math_fround(Math_fround(f9 * Math_fround(.5)) + Math_fround(HEAPF32[i4 >> 2]));
 f11 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(HEAPF32[i4 + 4 >> 2]));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (i5 | 0) == 0;
 do if (f7 > Math_fround(1.0)) if (i5) {
  f10 = Math_fround(f6 / f7);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  break;
 } else {
  f10 = Math_fround(f10 / f7);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  break;
 } else if (i5) {
  f10 = Math_fround(f7 * f9);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  break;
 } else {
  f10 = Math_fround(f7 * f8);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  break;
 } while (0);
 f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f10 * Math_fround(.5));
 f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f14 - f8);
 f12 = Math_fround(f12 - Math_fround(f9 * Math_fround(.5)));
 HEAPF32[i16 >> 2] = f14;
 i3 = i16 + 4 | 0;
 HEAPF32[i3 >> 2] = f12;
 f12 = Math_fround(f9 + f12);
 HEAPF32[i17 >> 2] = Math_fround(f10 + f14);
 i5 = i17 + 4 | 0;
 HEAPF32[i5 >> 2] = f12;
 f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f12 * Math_fround(.5));
 f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f13 - f14);
 f14 = Math_fround(f11 - Math_fround(f10 * Math_fround(.5)));
 HEAPF32[i18 >> 2] = f13;
 HEAPF32[i18 + 4 >> 2] = f14;
 f14 = Math_fround(f10 + f14);
 HEAPF32[i19 >> 2] = Math_fround(f12 + f13);
 HEAPF32[i19 + 4 >> 2] = f14;
 HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f15);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f15);
 HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * f15);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f15);
 return;
}

function __ZNK5physx18NpArticulationLink13getGlobalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0;
 i18 = (HEAP32[i2 + 284 >> 2] & 512 | 0) == 0 ? i2 + 112 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 144 | 0;
 f13 = Math_fround(HEAPF32[i18 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i18 + 20 >> 2]);
 f13 = Math_fround(f13 * Math_fround(-2.0));
 f12 = Math_fround(f12 * Math_fround(-2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) * Math_fround(-2.0));
 f14 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f10 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 f6 = Math_fround(f13 * f3);
 f17 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f12 * f17));
 f16 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f5 * f16));
 f15 = Math_fround(-f3);
 f9 = Math_fround(-f17);
 f11 = Math_fround(-f16);
 f8 = Math_fround(Math_fround(Math_fround(f3 * f6) + Math_fround(Math_fround(f13 * f10) - Math_fround(f14 * Math_fround(Math_fround(f5 * f17) - Math_fround(f12 * f16))))) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(Math_fround(f12 * f10) - Math_fround(f14 * Math_fround(Math_fround(f13 * f16) - Math_fround(f5 * f3))))) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f10) - Math_fround(f14 * Math_fround(Math_fround(f12 * f3) - Math_fround(f13 * f17)))) + Math_fround(f16 * f6)) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i2 + 236 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f13 = Math_fround(HEAPF32[i2 + 224 >> 2]);
 f3 = Math_fround(f13 * f8);
 f12 = Math_fround(HEAPF32[i2 + 228 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f12 * f7));
 f10 = Math_fround(HEAPF32[i2 + 232 >> 2]);
 f3 = Math_fround(Math_fround(f10 * f6) + f3);
 f5 = Math_fround(Math_fround(f13 * f3) + Math_fround(Math_fround(f17 * f8) + Math_fround(f16 * Math_fround(Math_fround(f12 * f6) - Math_fround(f10 * f7)))));
 f4 = Math_fround(Math_fround(f12 * f3) + Math_fround(Math_fround(f17 * f7) + Math_fround(f16 * Math_fround(Math_fround(f10 * f8) - Math_fround(f13 * f6)))));
 f3 = Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(f16 * Math_fround(Math_fround(f13 * f7) - Math_fround(f12 * f8)))) + Math_fround(f10 * f3));
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 240 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 244 >> 2]) + f4);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 248 >> 2]) + f3);
 f8 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(Math_fround(f16 * f9) + Math_fround(f14 * f12))) - Math_fround(f13 * f11));
 f7 = Math_fround(Math_fround(Math_fround(f13 * f9) + Math_fround(Math_fround(f16 * f11) + Math_fround(f14 * f10))) - Math_fround(f12 * f15));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) - Math_fround(f13 * f15)) - Math_fround(f12 * f9)) - Math_fround(f10 * f11));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f12 * f11)) - Math_fround(f10 * f9));
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f4;
 HEAPF32[i1 + 24 >> 2] = f3;
 return;
}

function __ZN19SharedBillboardData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i1 = i7 + 16 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i9 + 24 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i5 = i7 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i6 << 4) | 0;
 if (i6 | 0) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i7 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i4 = i7 + 80 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = HEAP32[i7 + 68 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i8 << 1) | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN13MonoBehaviour26WillUnloadScriptableObjectEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 256 | 0;
 i8 = i12 + 248 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i4 = i7 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i8);
   i2 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i4 = i7 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | (i5 | 0) == 0) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i7 + 56 >> 2] | 0;
 do if (i1 | 0) {
  i2 = i1 + 36 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   if (((HEAP32[i1 + 28 >> 2] | 0) + -1 | 0) >>> 0 >= 2) i6 = 14;
  } else i6 = 14;
  if ((i6 | 0) == 14) {
   i1 = HEAP16[i2 >> 1] | 0;
   if (!((i1 & 255) << 24 >> 24)) break;
   if ((i1 & 65535) < 256) if (HEAP32[i7 + 8 >> 2] & 1048576 | 0) break;
  }
  i1 = i7 + 60 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 72 >> 2] | 0;
  i3 = HEAP32[i3 + 76 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i8 >> 2] = 0;
   i6 = i10;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i3;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i9, i5, i11);
   HEAP8[i9 + 233 >> 0] = 1;
   HEAP32[i9 + 216 >> 2] = HEAP32[i7 + 4 >> 2];
   __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i9);
   __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i9, i8) | 0;
  }
  if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 80 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAPU8[i2 + 84 >> 0] | i3 & -256;
    HEAP32[i8 >> 2] = 0;
    i6 = HEAP32[i4 >> 2] | 0;
    i4 = i10;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i4 + 4 >> 2] = i3;
    HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i9, i6, i11);
    HEAP8[i9 + 233 >> 0] = 1;
    HEAP32[i9 + 216 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i9);
    __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i9, i8) | 0;
   }
  }
 } while (0);
 i11 = (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0) != 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZL15SweepBoxUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, i24 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i12 + 80 | 0;
 i16 = i12 + 48 | 0;
 i15 = i12 + 32 | 0;
 i14 = i12;
 i11 = i12 + 96 | 0;
 i13 = i12 + 144 | 0;
 HEAP32[i17 >> 2] = 3;
 i24 = i4 + 40 | 0;
 d19 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d23 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAPF32[i16 + 16 >> 2] = Math_fround(d19 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d23 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 3;
 d23 = +HEAPF64[i3 + 40 >> 3];
 d21 = +HEAPF64[i3 + 48 >> 3];
 d19 = +HEAPF64[i3 + 56 >> 3];
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAPF32[i14 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i14 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i14 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i14 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 80 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 84 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 88 >> 2];
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i3 = i11 + 16 | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i11, i13, Math_fround(0.0)) | 0)) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i10 + 40 >> 2] = -1;
 HEAP32[i10 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i10 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
 HEAPF64[i10 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
 HEAPF64[i10 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i24 = 1;
 STACKTOP = i12;
 return i24 | 0;
}

function __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i6, i2, i10) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i2;
 i5 = (i10 - i3 | 0) / 56 | 0;
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = i8;
 if (i5 >>> 0 <= ((i1 - i8 | 0) / 56 | 0) >>> 0) {
  i6 = i6 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i8 | 0) / 56 | 0;
  i5 = i5 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 56 | 0) | 0;
  i4 = i5 ? i1 : i10;
  i3 = i4 - i3 | 0;
  if (i3 | 0) _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i7 + (((i3 | 0) / 56 | 0) * 56 | 0) | 0;
  if (!i5) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -56 - i2 | 0) >>> 0) / 56 | 0) * 56 | 0);
   return;
  }
  if ((i4 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
   HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
   i1 = i1 + 56 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 56 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 i4 = i8;
 if (i8) {
  i1 = i6 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -56 - i8 | 0) >>> 0) / 56 | 0) * 56 | 0);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
 }
 if (i5 >>> 0 > 76695844) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 56 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 38347922 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 76695844;
 if (i3 >>> 0 > 76695844) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i1 = __Znwj(i3 * 56 | 0) | 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + (i3 * 56 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
  i2 = i2 + 56 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 56 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __Z19TransferField_ArrayI8JSONRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i10, i8, i1) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 40 | 0;
 i9 = i14;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i11 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i4 = HEAP32[i10 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i15 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i15;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i15) {
   i15 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i15 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   i16 = i3 + 8 | 0;
   i4 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = i9;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = i4;
   HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags(i3, i11, i13, 0);
   HEAP8[i5 >> 0] = 1;
   i15 = i3 + 56 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  i6 = HEAP32[i8 + 24 >> 2] | 0;
  i1 = HEAP32[i10 + 28 >> 2] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) | 0;
  i5 = (i2 | 0) / 12 | 0;
  i3 = i6 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i5 | 0)) {
   HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i5) | 0;
   HEAP32[i3 >> 2] = i5;
  }
  if (i2 | 0) {
   i2 = i11 + 16 | 0;
   i3 = i11 + 24 | 0;
   i4 = i11 + 20 | 0;
   i1 = 0;
   do {
    i16 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i1) | 0;
    HEAP32[i16 >> 2] = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 } while (0);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i16 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
 STACKTOP = i14;
 return;
}

function __ZN7Terrain21GetEnlightenProxyMeshEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i2 = i9;
 i7 = i1 + 192 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = gb + 63520 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId(4, i8) | 0;
 HEAP32[i7 >> 2] = i5;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, 4);
 i5 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0, 61);
 __ZN4Mesh14ResizeVerticesEjj(HEAP32[i7 >> 2] | 0, 4, 9);
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i4 = HEAP16[i5 + 10 >> 1] | 0;
 if ((i4 & 65535) < 768 | (i4 & 255) != 0) {
  i3 = 0;
  i4 = 0;
 } else {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i3 = 0;
   i4 = 1;
  } else if (!(HEAP8[i5 + 11 >> 0] | 0)) {
   i3 = 0;
   i4 = 1;
  } else {
   i3 = HEAP16[i6 >> 1] | 0;
   i3 = i1 + (((i3 & 65535) >>> 8 & 65535) + (HEAP32[i6 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i4 = HEAPU8[i6 + 32 + ((HEAPU8[i6 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 i2 = HEAP16[i5 + 22 >> 1] | 0;
 if ((i2 & 65535) < 512 | (i2 & 255) != 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i2 = 0;
   i1 = 1;
  } else if (!(HEAP8[i5 + 23 >> 0] | 0)) {
   i2 = 0;
   i1 = 1;
  } else {
   i2 = HEAP16[i5 + 20 >> 1] | 0;
   i2 = i1 + (((i2 & 65535) >>> 8 & 65535) + (HEAP32[i6 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i1 = HEAPU8[i6 + 32 + ((HEAPU8[i5 + 20 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 i6 = i3 + i4 | 0;
 i5 = i3;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 i5 = i6 + i4 | 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 i6 = i5 + i4 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
 i6 = i2 + i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i5 = i6 + i1 | 0;
 HEAP32[i6 >> 2] = 1065353216;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i5 + i1 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 1065353216;
 HEAP32[i6 >> 2] = 1065353216;
 HEAP32[i6 + 4 >> 2] = 1065353216;
 HEAP16[i8 >> 1] = HEAP16[gb + 223204 >> 1] | 0;
 HEAP16[i8 + 2 >> 1] = HEAP16[gb + 223204 + 2 >> 1] | 0;
 HEAP16[i8 + 4 >> 1] = HEAP16[gb + 223204 + 4 >> 1] | 0;
 HEAP16[i8 + 6 >> 1] = HEAP16[gb + 223204 + 6 >> 1] | 0;
 HEAP16[i8 + 8 >> 1] = HEAP16[gb + 223204 + 8 >> 1] | 0;
 HEAP16[i8 + 10 >> 1] = HEAP16[gb + 223204 + 10 >> 1] | 0;
 __ZN4Mesh10SetIndicesEPKtjj16GfxPrimitiveTypeb(HEAP32[i7 >> 2] | 0, i8, 6, 0, 0, 1) | 0;
 __ZN4Mesh16SetChannelsDirtyEjb(HEAP32[i7 >> 2] | 0, 9, 1);
 i8 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK5physx14NpRigidDynamic13getGlobalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0;
 i18 = (HEAP32[i2 + 284 >> 2] & 512 | 0) == 0 ? i2 + 112 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 144 | 0;
 f13 = Math_fround(HEAPF32[i18 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i18 + 20 >> 2]);
 f13 = Math_fround(f13 * Math_fround(-2.0));
 f12 = Math_fround(f12 * Math_fround(-2.0));
 f5 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) * Math_fround(-2.0));
 f14 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f10 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 f6 = Math_fround(f13 * f3);
 f17 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f12 * f17));
 f16 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f5 * f16));
 f15 = Math_fround(-f3);
 f9 = Math_fround(-f17);
 f11 = Math_fround(-f16);
 f8 = Math_fround(Math_fround(Math_fround(f3 * f6) + Math_fround(Math_fround(f13 * f10) - Math_fround(f14 * Math_fround(Math_fround(f5 * f17) - Math_fround(f12 * f16))))) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(Math_fround(f12 * f10) - Math_fround(f14 * Math_fround(Math_fround(f13 * f16) - Math_fround(f5 * f3))))) * Math_fround(2.0));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f10) - Math_fround(f14 * Math_fround(Math_fround(f12 * f3) - Math_fround(f13 * f17)))) + Math_fround(f16 * f6)) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i2 + 236 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f13 = Math_fround(HEAPF32[i2 + 224 >> 2]);
 f3 = Math_fround(f13 * f8);
 f12 = Math_fround(HEAPF32[i2 + 228 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f12 * f7));
 f10 = Math_fround(HEAPF32[i2 + 232 >> 2]);
 f3 = Math_fround(Math_fround(f10 * f6) + f3);
 f5 = Math_fround(Math_fround(f13 * f3) + Math_fround(Math_fround(f17 * f8) + Math_fround(f16 * Math_fround(Math_fround(f12 * f6) - Math_fround(f10 * f7)))));
 f4 = Math_fround(Math_fround(f12 * f3) + Math_fround(Math_fround(f17 * f7) + Math_fround(f16 * Math_fround(Math_fround(f10 * f8) - Math_fround(f13 * f6)))));
 f3 = Math_fround(Math_fround(Math_fround(f17 * f6) + Math_fround(f16 * Math_fround(Math_fround(f13 * f7) - Math_fround(f12 * f8)))) + Math_fround(f10 * f3));
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 240 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 244 >> 2]) + f4);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 248 >> 2]) + f3);
 f8 = Math_fround(Math_fround(Math_fround(f10 * f15) + Math_fround(Math_fround(f16 * f9) + Math_fround(f14 * f12))) - Math_fround(f13 * f11));
 f7 = Math_fround(Math_fround(Math_fround(f13 * f9) + Math_fround(Math_fround(f16 * f11) + Math_fround(f14 * f10))) - Math_fround(f12 * f15));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f14 * f16) - Math_fround(f13 * f15)) - Math_fround(f12 * f9)) - Math_fround(f10 * f11));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f12 * f11)) - Math_fround(f10 * f9));
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f4;
 HEAPF32[i1 + 24 >> 2] = f3;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i10, i11, i13, i12, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 144 | 0;
 i4 = i9 + 136 | 0;
 i2 = i9 + 128 | 0;
 i7 = i9;
 i3 = HEAP32[i10 + 104 >> 2] | 0;
 i1 = i3;
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i3 | 0) | 0)) {
   i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i2 >> 2] = gb + 832239;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i2);
  }
  i5 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = (i5 | 0) == 0 & (i2 | 0) == 0;
  i1 = i6 ? i1 : i5;
  i2 = i6 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = gb + 832257;
 HEAP32[i7 + 4 >> 2] = i3;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i13 | 0, gb + 832239 | 0, i7 | 0);
 i1 = HEAP32[i10 + 48 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i4) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i4 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0, i4 | 0, 1) | 0;
 i1 = i12 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832272 | 0, HEAP32[i1 >> 2] | 0);
 i2 = i12 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i12 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i10 + 108 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP8[i8 >> 0] = 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
  i7 = HEAP32[i13 >> 2] | 0;
  i7 = i7 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  __ZN5physx2Sn18writeAllPropertiesINS_18PxVehicleDriveTankEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i7 = i7 + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn18writeAllPropertiesINS_18PxVehicleDriveTankEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
 STACKTOP = i9;
 return;
}

function __ZN5physx21constructBatchHeadersEPNS_23PxcSolverConstraintDescEjPKjRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS4_19ReflectionAllocatorIS6_EEEE(i18, i19, i13, i17) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 8 | 0;
 i16 = i20;
 i14 = i17 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 if (!i19) {
  STACKTOP = i20;
  return;
 }
 i15 = i17 + 8 | 0;
 if ((HEAP32[i15 >> 2] & 2147483392) >>> 0 < 256) __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i17, 256);
 i9 = i12 + 6 | 0;
 i10 = i12 + 4 | 0;
 i11 = 0;
 i1 = 0;
 i2 = i18;
 do {
  i8 = i13 + (i11 << 2) | 0;
  do if (HEAP32[i8 >> 2] | 0) {
   HEAP32[i12 >> 2] = i1;
   i4 = HEAPU8[HEAP32[i2 + 16 >> 2] >> 0] | 0;
   HEAP16[i9 >> 1] = i4;
   i7 = i1;
   i6 = 0;
   while (1) {
    i5 = i2 + 16 | 0;
    if ((HEAPU8[HEAP32[i5 >> 2] >> 0] | 0 | 0) == (i4 & 65535 | 0)) i3 = i7; else {
     i3 = i6 + i1 | 0;
     HEAP16[i10 >> 1] = i3 - i7;
     i4 = HEAP32[i14 >> 2] | 0;
     if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
      i22 = i12;
      i21 = HEAP32[i22 + 4 >> 2] | 0;
      i7 = (HEAP32[i17 >> 2] | 0) + (i4 << 3) | 0;
      HEAP32[i7 >> 2] = HEAP32[i22 >> 2];
      HEAP32[i7 + 4 >> 2] = i21;
      HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i17, i12) | 0;
     HEAP32[i12 >> 2] = i3;
     i4 = HEAPU8[HEAP32[i5 >> 2] >> 0] | 0;
     HEAP16[i9 >> 1] = i4;
    }
    i6 = i6 + 1 | 0;
    i2 = i2 + 32 | 0;
    i5 = HEAP32[i8 >> 2] | 0;
    if (i6 >>> 0 < i5 >>> 0) i7 = i3; else {
     i4 = i2;
     i2 = i5;
     break;
    }
   }
   i1 = i2 + i1 | 0;
   if (i1 >>> 0 > i3 >>> 0) {
    HEAP16[i10 >> 1] = i1 - i3;
    i2 = HEAP32[i14 >> 2] | 0;
    if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     i21 = i12;
     i22 = HEAP32[i21 + 4 >> 2] | 0;
     i2 = (HEAP32[i17 >> 2] | 0) + (i2 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
     HEAP32[i2 + 4 >> 2] = i22;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
     i2 = i4;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i17, i12) | 0;
     i2 = i4;
     break;
    }
   } else i2 = i4;
  } while (0);
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != 32);
 if (i1 >>> 0 >= i19 >>> 0) {
  STACKTOP = i20;
  return;
 }
 i4 = i16 + 6 | 0;
 i3 = i16 + 4 | 0;
 do {
  HEAP32[i16 >> 2] = i1;
  HEAP16[i4 >> 1] = HEAPU8[HEAP32[i18 + (i1 << 5) + 16 >> 2] >> 0] | 0;
  HEAP16[i3 >> 1] = 1;
  i2 = HEAP32[i14 >> 2] | 0;
  if ((HEAP32[i15 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i13 = i16;
   i21 = HEAP32[i13 + 4 >> 2] | 0;
   i22 = (HEAP32[i17 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i22 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i22 + 4 >> 2] = i21;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i17, i16) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i19 | 0));
 STACKTOP = i20;
 return;
}

function __ZN5physx20PxsParticleSystemSim5clearEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZN5physx16PxsFluidDynamics5clearEv(i4 + 80 | 0);
 i1 = i4 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx19PxsFluidSpatialHashD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 1 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i4 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i2 >> 2] = 0;
 i2 = i4 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i2 >> 2] = 0;
 i2 = i4 + 52 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i4 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i4 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i4 + 64 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i4 + 68 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i4 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i4 + 40 >> 2] = 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i4 + 16 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx15PxsParticleData7releaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN7mecanim10ValueArray8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i7 = i8;
 i3 = i6 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902750 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 12;
 HEAP32[i7 + 4 >> 2] = i2 + 8;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902767 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 20;
 HEAP32[i7 + 4 >> 2] = i2 + 16;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902786 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 28;
 HEAP32[i7 + 4 >> 2] = i2 + 24;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902800 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 36;
 HEAP32[i7 + 4 >> 2] = i2 + 32;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902814 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 44;
 HEAP32[i7 + 4 >> 2] = i2 + 40;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902826 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx20updateCellsSubpacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleEPKNS_15PxsParticleCellEPKjjRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersE(i1, i19, i24, i18, i23, i21, i22, i2) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i24 = i24 | 0;
 i18 = i18 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i25 = 0, i26 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25;
 if (!i21) {
  STACKTOP = i25;
  return;
 }
 i16 = i21 + -1 | 0;
 i17 = i2 + 8 | 0;
 i14 = (i1 | 0) == 0;
 i15 = i2 + 28 | 0;
 i11 = i2 + 32 | 0;
 i13 = 0;
 do {
  i12 = i18 + (i13 << 4) + 8 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i7 = HEAPU16[i18 + (i13 << 4) >> 1] | 0;
   i8 = HEAPU16[i18 + (i13 << 4) + 2 >> 1] | 0;
   i9 = HEAPU16[i18 + (i13 << 4) + 4 >> 1] | 0;
   i10 = 0;
   do {
    i2 = (HEAPU16[gb + 223114 + (i10 * 6 | 0) >> 1] | 0) + i7 | 0;
    i4 = i2 & 65535;
    i26 = (HEAPU16[gb + 223114 + (i10 * 6 | 0) + 2 >> 1] | 0) + i8 | 0;
    i5 = i26 & 65535;
    i3 = (HEAPU16[gb + 223114 + (i10 * 6 | 0) + 4 >> 1] | 0) + i9 | 0;
    i6 = i3 & 65535;
    i3 = ((i26 << 16 >> 16) * 101 | 0) + (i2 << 16 >> 16) + ((i3 << 16 >> 16) * 7919 | 0) & i16;
    i2 = HEAP32[i18 + (i3 << 4) + 8 >> 2] | 0;
    L10 : do if ((i2 | 0) == -1) i2 = -1; else while (1) {
     if (i4 << 16 >> 16 == (HEAP16[i18 + (i3 << 4) >> 1] | 0)) if (i5 << 16 >> 16 == (HEAP16[i18 + (i3 << 4) + 2 >> 1] | 0)) if (i6 << 16 >> 16 == (HEAP16[i18 + (i3 << 4) + 4 >> 1] | 0)) break L10;
     i3 = i3 + 1 & i16;
     i2 = HEAP32[i18 + (i3 << 4) + 8 >> 2] | 0;
     if ((i2 | 0) == -1) {
      i2 = -1;
      break;
     }
    } while (0);
    HEAP32[i20 + (i10 << 2) >> 2] = (i2 | 0) == -1 ? 0 : i18 + (i3 << 4) | 0;
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) != 13);
   if (i1 >>> 0 > 1) {
    i3 = i18 + (i13 << 4) + 12 | 0;
    i2 = 1;
    do {
     i26 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
     __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i19, i19, i24, i24, i23 + (i26 + -1 << 2) | 0, 1, i23 + (i26 << 2) | 0, i1 - i2 | 0, 1, i14, i22, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] | 0);
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i12 >> 2] | 0;
    } while (i1 >>> 0 > i2 >>> 0);
   }
   i7 = HEAP32[i17 >> 2] | 0;
   i6 = 0;
   i1 = 0;
   do {
    i2 = HEAP32[i20 + (i6 << 2) >> 2] | 0;
    if (i2) {
     i3 = HEAP32[i2 + 12 >> 2] | 0;
     i4 = HEAP32[i2 + 8 >> 2] | 0;
     i5 = i4 + i3 | 0;
     if (i3 >>> 0 < i5 >>> 0) {
      i2 = i1;
      while (1) {
       HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[i23 + (i3 << 2) >> 2];
       i3 = i3 + 1 | 0;
       if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + 1 | 0;
      }
      i1 = i1 + i4 | 0;
     }
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != 13);
   if (i1 | 0) __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i19, i19, i24, i24, i23 + (HEAP32[i18 + (i13 << 4) + 12 >> 2] << 2) | 0, HEAP32[i12 >> 2] | 0, i7, i1, 1, i14, i22, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] | 0);
  }
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != (i21 | 0));
 STACKTOP = i25;
 return;
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor14constructRightERS3_(i3, i13) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i12 = i6 + 8 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i5 + (i1 << 3) >> 2] | 0;
 i1 = i1 + 1 | 0;
 if ((i2 & 3 | 0) == 1) {
  i11 = (i2 >>> 4) + i1 | 0;
  i1 = i6;
  i10 = i3;
  i7 = i6 + 16 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  do if ((i8 | 0) <= (i11 | 0)) {
   i9 = i11 + 1 | 0;
   i4 = i6 + 12 | 0;
   if ((HEAP32[i4 >> 2] | 0) > (i11 | 0)) i2 = i5; else {
    i3 = i9 << 1;
    i3 = (i3 | 0) > 16 ? i3 : 16;
    i6 = i6 + 4 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, (i3 << 3) + 16 | 0, 0) | 0;
    if (!i2) {
     i1 = 0;
     break;
    }
    HEAP32[i2 >> 2] = i3;
    i2 = i2 + 16 | 0;
    HEAP32[i4 >> 2] = i3;
    i3 = HEAP32[i12 >> 2] | 0;
    do if (i3 | 0) {
     i4 = HEAP32[i7 >> 2] | 0;
     if (i4) {
      i5 = (i4 | 0) <= (i9 | 0) ? i4 : i9;
      if ((i5 | 0) > 0) {
       i4 = 0;
       do {
        i16 = i3 + (i4 << 3) | 0;
        i15 = HEAP32[i16 + 4 >> 2] | 0;
        i14 = i2 + (i4 << 3) | 0;
        HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
        HEAP32[i14 + 4 >> 2] = i15;
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i5 | 0));
       i3 = HEAP32[i12 >> 2] | 0;
       if (!i3) break;
      }
     }
     i16 = HEAP32[i6 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i3 + -16 | 0);
    } while (0);
    HEAP32[i12 >> 2] = i2;
   }
   HEAP32[i7 >> 2] = i9;
   _memset(i2 + (i8 << 3) | 0, 0, i9 - i8 << 2 | 0) | 0;
  } while (0);
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i10;
  HEAP32[i13 + 8 >> 2] = i11;
  return;
 } else {
  i11 = ((HEAP32[(HEAP32[i6 + 24 >> 2] | 0) + (i2 >>> 2 << 3) >> 2] | 0) >>> 2) + i1 | 0;
  i1 = i6;
  i10 = i3;
  i7 = i6 + 16 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  do if ((i8 | 0) <= (i11 | 0)) {
   i9 = i11 + 1 | 0;
   i4 = i6 + 12 | 0;
   if ((HEAP32[i4 >> 2] | 0) > (i11 | 0)) i2 = i5; else {
    i3 = i9 << 1;
    i3 = (i3 | 0) > 16 ? i3 : 16;
    i6 = i6 + 4 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, (i3 << 3) + 16 | 0, 0) | 0;
    if (!i2) {
     i1 = 0;
     break;
    }
    HEAP32[i2 >> 2] = i3;
    i2 = i2 + 16 | 0;
    HEAP32[i4 >> 2] = i3;
    i3 = HEAP32[i12 >> 2] | 0;
    do if (i3 | 0) {
     i4 = HEAP32[i7 >> 2] | 0;
     if (i4) {
      i5 = (i4 | 0) <= (i9 | 0) ? i4 : i9;
      if ((i5 | 0) > 0) {
       i4 = 0;
       do {
        i14 = i3 + (i4 << 3) | 0;
        i15 = HEAP32[i14 + 4 >> 2] | 0;
        i16 = i2 + (i4 << 3) | 0;
        HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
        HEAP32[i16 + 4 >> 2] = i15;
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i5 | 0));
       i3 = HEAP32[i12 >> 2] | 0;
       if (!i3) break;
      }
     }
     i16 = HEAP32[i6 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i3 + -16 | 0);
    } while (0);
    HEAP32[i12 >> 2] = i2;
   }
   HEAP32[i7 >> 2] = i9;
   _memset(i2 + (i8 << 3) | 0, 0, i9 - i8 << 2 | 0) | 0;
  } while (0);
  HEAP32[i13 >> 2] = i1;
  HEAP32[i13 + 4 >> 2] = i10;
  HEAP32[i13 + 8 >> 2] = i11;
  return;
 }
}

function __ZN11ForceModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i8, i2, i3, i11, i12, i13, i14) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 4 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1451800 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451800 | 0, i10);
  i9 = gb + 1451800 | 0;
 } else i9 = 0;
 i6 = __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_(i10, (HEAP32[i2 + 280 >> 2] | 0) == 1, (HEAP8[i8 + 800 >> 0] | 0) != 0, i3 + 52 | 0, i3 + 180 | 0) | 0;
 i7 = i8 + 8 | 0;
 i1 = HEAP32[i8 + 92 >> 2] | 0;
 i2 = i1 & 65535;
 if (!(i2 << 16 >> 16)) if (!(HEAP16[i8 + 356 >> 1] | 0)) i3 = (HEAP16[i8 + 620 >> 1] | 0) == 0; else i3 = 0; else i3 = 0;
 if (!(i1 & 16711680)) i5 = 0; else if (!(HEAP8[i8 + 358 >> 0] | 0)) i5 = 0; else i5 = (HEAP8[i8 + 622 >> 0] | 0) != 0;
 if ((i2 | 1) << 16 >> 16 == 3) if ((HEAP16[i8 + 356 >> 1] | 1) << 16 >> 16 == 3) i4 = (HEAP16[i8 + 620 >> 1] | 1) << 16 >> 16 != 3; else i4 = 1; else i4 = 1;
 do if (!(HEAP8[i8 + 801 >> 0] | 0)) {
  if (i3) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i7, i8 + 272 | 0, i8 + 536 | 0, i11, i12, i13, i6, i10, i14);
   break;
  }
  i2 = i8 + 272 | 0;
  i1 = i8 + 536 | 0;
  if (!(i4 | i5 ^ 1)) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i7, i2, i1, i11, i12, i13, i6, i10, i14);
   break;
  }
  if (i5) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i7, i2, i1, i11, i12, i13, i6, i10, i14);
   break;
  } else {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E(i7, i2, i1, i11, i12, i13, i6, i10, i14);
   break;
  }
 } else {
  if (i3) {
   __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i7, i8 + 272 | 0, i8 + 536 | 0, i8 + 804 | 0, i11, i12, i13, i6, i10, i14);
   break;
  }
  i2 = i8 + 272 | 0;
  i3 = i8 + 536 | 0;
  i1 = i8 + 804 | 0;
  if (!(i4 | i5 ^ 1)) {
   __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i7, i2, i3, i1, i11, i12, i13, i6, i10, i14);
   break;
  }
  if (i5) {
   __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i7, i2, i3, i1, i11, i12, i13, i6, i10, i14);
   break;
  } else {
   __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E(i7, i2, i3, i1, i11, i12, i13, i6, i10, i14);
   break;
  }
 } while (0);
 if (!i9) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i15;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i15 = HEAP32[i5 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f18 = Math_fround(-f12);
 f25 = Math_fround(-f13);
 f26 = Math_fround(-f14);
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f28 = Math_fround(f22 * f18);
 f19 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f19 * f25));
 f6 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f28 = Math_fround(f28 + Math_fround(f6 * f26));
 f9 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f27 = Math_fround(f9 * f18);
 f11 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f11 * f25));
 f8 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f8 * f26));
 f23 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f18 = Math_fround(f23 * f18);
 f20 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f25 = Math_fround(f18 + Math_fround(f20 * f25));
 f18 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f26 = Math_fround(f25 + Math_fround(f18 * f26));
 f25 = Math_fround(HEAPF32[i15 + 96 >> 2]);
 f21 = Math_fround(HEAPF32[i15 + 100 >> 2]);
 f24 = Math_fround(HEAPF32[i15 + 104 >> 2]);
 f29 = Math_fround(Math_fround(Math_fround(f28 * f25) + Math_fround(f27 * f21)) + Math_fround(f26 * f24));
 f7 = Math_fround(HEAPF32[i15 + 112 >> 2]);
 f10 = Math_fround(HEAPF32[i15 + 116 >> 2]);
 f17 = Math_fround(HEAPF32[i15 + 120 >> 2]);
 i15 = f29 > Math_fround(Math_fround(Math_fround(f28 * f7) + Math_fround(f27 * f10)) + Math_fround(f26 * f17));
 f7 = i15 ? f25 : f7;
 f10 = i15 ? f21 : f10;
 f17 = i15 ? f24 : f17;
 f24 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f21 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f9 = Math_fround(f24 + Math_fround(Math_fround(f23 * f17) + Math_fround(Math_fround(f22 * f7) + Math_fround(f9 * f10))));
 f11 = Math_fround(f21 + Math_fround(Math_fround(f20 * f17) + Math_fround(Math_fround(f19 * f7) + Math_fround(f11 * f10))));
 f10 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f6 * f7) + Math_fround(f8 * f10))));
 i16 = HEAP32[i5 + 8 >> 2] | 0;
 i15 = f12 > Math_fround(0.0);
 i1 = f13 > Math_fround(0.0);
 i5 = f14 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f6 = Math_fround(-f12);
 f8 = i15 ? f14 : f8;
 f7 = i1 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5Unity10HingeJoint16WriteJointLimitsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 32 | 0;
 i10 = i13 + 28 | 0;
 i11 = i13;
 f5 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f12 = Math_fround(-f5);
 i2 = f5 > Math_fround(177.0);
 i14 = f12 > Math_fround(177.0);
 f12 = Math_fround(Math_fround(Math_fround((i14 ? Math_fround(177.0) : f12) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f12 = i2 ? Math_fround(-3.08923292) : f12;
 f5 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f9 = Math_fround(-f5);
 i2 = f5 > Math_fround(177.0);
 i14 = f9 > Math_fround(177.0);
 f9 = Math_fround(Math_fround(Math_fround((i14 ? Math_fround(177.0) : f9) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f9 = i2 ? Math_fround(-3.08923292) : f9;
 f5 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(f5 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f7 = Math_fround(f9 - f12);
 i2 = f4 < Math_fround(0.0);
 f4 = i2 ? Math_fround(0.0) : f4 > f7 ? f7 : f4;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i11 + 20 >> 2] = f9;
 HEAPF32[i11 + 24 >> 2] = f12;
 if (f4 == Math_fround(-1.0)) {
  f3 = Math_fround(f7 * Math_fround(.49000001));
  i14 = f3 > Math_fround(.100000001);
  f3 = i14 ? Math_fround(.100000001) : f3;
 } else f3 = f4;
 i2 = i11 + 16 | 0;
 HEAPF32[i2 >> 2] = f3;
 i14 = HEAP32[i1 + 104 >> 2] | 0;
 HEAP32[i11 >> 2] = i14;
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 108 >> 2];
 f6 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i14 = f5 > Math_fround(0.0);
 f3 = i14 ? f4 : Math_fround(-1.0);
 if (f3 == Math_fround(-1.0)) {
  f3 = Math_fround(f7 * Math_fround(.49000001));
  i14 = f3 > Math_fround(.100000001);
  f3 = i14 ? Math_fround(.100000001) : f3;
 }
 i14 = f6 > Math_fround(0.0);
 i15 = f3 < Math_fround(.200000003);
 f7 = i15 ? Math_fround(.200000003) : f3;
 HEAPF32[i2 >> 2] = i14 ? Math_fround(9.99999974e-06) : f7;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP16[i2 + 4 >> 1] | 0) == 261) {
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 3, f12 != f9 | 0);
  i15 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 148 >> 2] | 0, i15 | 0, i11 | 0);
  i15 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  i14 = i14 + 28 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  mftCall_viii(i14 | 0, i15 | 0, i8 | 0, i10 | 0);
  i15 = HEAP32[i8 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i15);
  i15 = HEAP32[i10 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i15);
  STACKTOP = i13;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i11 | 0);
  i15 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  i14 = i14 + 28 | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  mftCall_viii(i14 | 0, i15 | 0, i8 | 0, i10 | 0);
  i15 = HEAP32[i8 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i15);
  i15 = HEAP32[i10 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i15);
  STACKTOP = i13;
  return;
 }
}

function __ZN7mecanim9animation4Clip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i7 = i3 + 12 | 0;
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898912 | 0, gb + 898927 | 0, i1, 0);
 i10 = i2 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 4;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i9;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 i11 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i11, i7, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898940 | 0, i11, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898951 | 0, gb + 898963 | 0, i11, 0);
 __ZN7mecanim9animation9DenseClip8TransferI24GenerateTypeTreeTransferEEvRT_(i11, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i11 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898973 | 0, gb + 898988 | 0, i11, 0);
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 + 40;
 HEAP32[i8 + 4 >> 2] = i11;
 HEAP32[i8 + 8 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899001 | 0, gb + 905830 | 0, i1 + 44 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899011 | 0, i4, 0);
 __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim13ValueConstantEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_(i4 + 4 | 0, gb + 899030 | 0, i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z33Font_Set_Custom_PropCharacterInfoP12Il2CppObjectP11Il2CppArray(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i9 = i10 + 12 | 0;
 i11 = i10 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 HEAP32[i9 >> 2] = i4;
 if (i4) {
  HEAP32[i11 >> 2] = i4;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i4 * 60 | 0, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 52) | 0;
  if ((i4 | 0) > 0) {
   i3 = HEAP32[i10 >> 2] | 0;
   i1 = 0;
   do {
    HEAP32[i3 + (i1 * 60 | 0) >> 2] = HEAP32[i2 + (i1 * 52 | 0) >> 2];
    i8 = i3 + (i1 * 60 | 0) + 4 | 0;
    i7 = i2 + (i1 * 52 | 0) + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    i8 = i3 + (i1 * 60 | 0) + 20 | 0;
    i7 = i2 + (i1 * 52 | 0) + 20 | 0;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i3 + (i1 * 60 | 0) + 36 >> 2] = HEAP32[i2 + (i1 * 52 | 0) + 36 >> 2];
    HEAP32[i3 + (i1 * 60 | 0) + 40 >> 2] = HEAP32[i2 + (i1 * 52 | 0) + 40 >> 2];
    HEAP32[i3 + (i1 * 60 | 0) + 44 >> 2] = HEAP32[i2 + (i1 * 52 | 0) + 44 >> 2];
    HEAP8[i3 + (i1 * 60 | 0) + 56 >> 0] = HEAP8[i2 + (i1 * 52 | 0) + 48 >> 0] | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 if (!i5) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i6 = HEAP32[i1 + 48 >> 2] | 0;
 i5 = i6 + 40 | 0;
 if ((i5 | 0) != (i10 | 0)) {
  i7 = HEAP32[i10 >> 2] | 0;
  i8 = i6 + 52 | 0;
  i1 = (HEAP32[i9 >> 2] | 0) * 60 | 0;
  i2 = (i1 | 0) / 60 | 0;
  HEAP32[i8 >> 2] = i2;
  i3 = i6 + 56 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i6 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 60 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, (HEAP32[i8 >> 2] | 0) * 60 | 0) | 0;
 }
 __ZN20TextRenderingPrivate8FontImpl10CacheRectsEv(i6);
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i12);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation24CreateClipMuscleConstantEPNS0_4ClipERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 1736, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i6);
 i3 = i6 + 888 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 912 >> 2] = 1065353216;
 HEAP32[i6 + 916 >> 2] = 1065353216;
 HEAP32[i6 + 920 >> 2] = 1065353216;
 HEAP32[i6 + 924 >> 2] = 1065353216;
 i3 = i6 + 928 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 952 >> 2] = 1065353216;
 HEAP32[i6 + 956 >> 2] = 1065353216;
 HEAP32[i6 + 960 >> 2] = 1065353216;
 HEAP32[i6 + 964 >> 2] = 1065353216;
 i3 = i6 + 968 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 992 >> 2] = 1065353216;
 HEAP32[i6 + 996 >> 2] = 1065353216;
 HEAP32[i6 + 1e3 >> 2] = 1065353216;
 HEAP32[i6 + 1004 >> 2] = 1065353216;
 i3 = i6 + 1008 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 1032 >> 2] = 1065353216;
 HEAP32[i6 + 1036 >> 2] = 1065353216;
 HEAP32[i6 + 1040 >> 2] = 1065353216;
 HEAP32[i6 + 1044 >> 2] = 1065353216;
 i3 = i6 + 1048 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i6 + 1072 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i6 + 1712 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 + 16 >> 1] = 0;
 HEAP8[i6 + 1730 >> 0] = 1;
 _memset(i6 + 1088 | 0, -1, 620) | 0;
 i3 = i6 + 1060 | 0;
 HEAP32[i3 >> 2] = i1 | 0 ? i1 - i3 | 0 : 0;
 HEAP8[i6 + 1724 >> 0] = 0;
 HEAPF32[i6 + 1064 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1068 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 1076 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1080 >> 2] = Math_fround(0.0);
 i3 = i6 + 1725 | 0;
 HEAP8[i6 + 1731 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP8[i3 + 4 >> 0] = 0;
 HEAP8[i6 + 1732 >> 0] = 1;
 HEAP8[i6 + 1733 >> 0] = 0;
 HEAP8[i6 + 1734 >> 0] = 0;
 i3 = (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i1 + 36 >> 2] | 0) | 0;
 HEAP32[i6 + 1708 >> 2] = i3;
 i4 = i6 + 1712 | 0;
 if (!i3) {
  i2 = 0;
  i3 = (i2 | 0) != 0;
  i5 = i4;
  i5 = i2 - i5 | 0;
  i5 = i3 ? i5 : 0;
  HEAP32[i4 >> 2] = i5;
  i5 = i6 + 1716 | 0;
  HEAP32[i5 >> 2] = 0;
  return i6 | 0;
 }
 i5 = i3 << 3;
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i5 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i3 << 3) | 0)) {
  i2 = i1;
  i3 = (i2 | 0) != 0;
  i5 = i4;
  i5 = i2 - i5 | 0;
  i5 = i3 ? i5 : 0;
  HEAP32[i4 >> 2] = i5;
  i5 = i6 + 1716 | 0;
  HEAP32[i5 >> 2] = 0;
  return i6 | 0;
 }
 _memset(i1 | 0, 0, i5 | 0) | 0;
 i2 = i1;
 i3 = (i2 | 0) != 0;
 i5 = i4;
 i5 = i2 - i5 | 0;
 i5 = i3 ? i5 : 0;
 HEAP32[i4 >> 2] = i5;
 i5 = i6 + 1716 | 0;
 HEAP32[i5 >> 2] = 0;
 return i6 | 0;
}

function __ZN9ShaderLab4Pass28CreateFromSerializedGrabPassERKNS_14SerializedPassE(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 8 | 0;
 i11 = i16 + 4 | 0;
 i12 = i16;
 i14 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1166404 >> 2] | 0, 0, 0) | 0;
 i15 = __ZnwjRK10MemLabelIdiPKci(784, gb + 63280 | 0, 16, gb + 472212 | 0, 400) | 0;
 __ZN9ShaderLab4PassC2ENS0_8PassTypeE(i15, 2);
 i7 = i15 + 728 | 0;
 i1 = i13 + 816 | 0;
 do if ((i7 | 0) != (i1 | 0)) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i13 + 820 >> 2] | 0 : i6 & 255;
  i3 = i15 + 739 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i15 + 736 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i15 + 732 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i15 + 732 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 i5 = i15 + 756 | 0;
 i1 = HEAP32[i13 + 848 >> 2] | 0;
 i6 = i13 + 852 | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i15 + 760 | 0;
  i8 = i7;
  i9 = i15 + 764 | 0;
  i2 = i1;
  while (1) {
   i3 = i2 + 16 | 0;
   HEAP32[i12 >> 2] = i8;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   i4 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i5, i10, i11, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = __Znwj(24) | 0;
    i18 = i3;
    i17 = HEAP32[i18 + 4 >> 2] | 0;
    i3 = i2 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i3 + 4 >> 2] = i17;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i5 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i2);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
  }
 }
 i1 = i13 + 832 | 0;
 i18 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i18 << 24 >> 24 < 0;
 if ((i2 ? HEAP32[i13 + 836 >> 2] | 0 : i18 & 255) | 0) __ZN9ShaderLab16FastPropertyName4InitEPKc(i15 + 768 | 0, i2 ? HEAP32[i1 >> 2] | 0 : i1);
 if (!i14) {
  STACKTOP = i16;
  return i15 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i16;
 return i15 | 0;
}

function __Z11Build3DLineP10LineVertexRK14LineParametersRKN4math8float4x4ES7_PKNS4_14float3_storageEj(i1, i4, i2, i19, i3, i20) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 var f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i25 + 560 | 0;
 i21 = i25 + 544 | 0;
 i22 = i25 + 540 | 0;
 i15 = i25 + 16 | 0;
 i23 = i25 + 12 | 0;
 i16 = i25 + 4 | 0;
 i17 = i25;
 i18 = i25 + 8 | 0;
 HEAP32[i22 >> 2] = i1;
 __ZN14BatchAllocatorC2Ev(i15);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i15, i23, -1, 28, 1, 4);
 HEAP32[i23 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i15, 0, 0, 16, i20, 16);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i15, (HEAP32[i23 >> 2] | 0) + 4 | 0, 0, 4, i20, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i15, (HEAP32[i23 >> 2] | 0) + 8 | 0, 0, 8, i20, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i15, (HEAP32[i23 >> 2] | 0) + 12 | 0, 0, 8, i20 + -2 | 0, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i15, gb + 64016 | 0);
 i15 = HEAP32[i23 >> 2] | 0;
 HEAP32[i15 + 16 >> 2] = HEAP32[i4 + 180 >> 2];
 HEAP32[i15 + 20 >> 2] = HEAP32[i4 + 184 >> 2];
 HEAP32[i15 + 24 >> 2] = i20;
 __Z13StoreLineDataP15LineBuilderDataRfRKN4math8float4x4EPKNS2_14float3_storageE(i15, i16, i2, i3);
 f10 = Math_fround(HEAPF32[i16 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / f10);
 f10 = (HEAP32[i4 + 192 >> 2] | 0) == 1 ? f10 : Math_fround(1.0);
 if (!i20) {
  i24 = HEAP32[i23 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i24, gb + 64016 | 0);
  STACKTOP = i25;
  return;
 }
 i11 = i4 + 108 | 0;
 i12 = i4 + 176 | 0;
 i13 = i24 + 12 | 0;
 i14 = i24 + 8 | 0;
 i15 = i24 + 4 | 0;
 i16 = i4 + 20 | 0;
 i3 = i4 + 16 | 0;
 i4 = i24 + 12 | 0;
 i6 = i24 + 8 | 0;
 i7 = i24 + 4 | 0;
 f5 = Math_fround(0.0);
 i2 = 0;
 do {
  f5 = Math_fround(f5 + Math_fround(HEAPF32[(HEAP32[(HEAP32[i23 >> 2] | 0) + 4 >> 2] | 0) + (i2 << 2) >> 2]));
  f8 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(f9 * f5)))));
  HEAPF32[i17 >> 2] = f8;
  if (!(HEAP32[i12 >> 2] | 0)) {
   HEAPF32[i13 >> 2] = f8;
   HEAPF32[i14 >> 2] = f8;
   HEAPF32[i15 >> 2] = f8;
   HEAPF32[i24 >> 2] = f8;
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i21, i11, i24);
   i1 = HEAP32[i21 >> 2] | 0;
  } else {
   HEAPF32[i4 >> 2] = f8;
   HEAPF32[i6 >> 2] = f8;
   HEAPF32[i7 >> 2] = f8;
   HEAPF32[i24 >> 2] = f8;
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i21, i11, i24);
   i1 = HEAP32[i21 >> 2] | 0;
  }
  f27 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i16, f8, 0));
  HEAPF32[i21 >> 2] = Math_fround(f27 * Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i17 >> 2] = Math_fround(f10 * f8);
  i26 = HEAP32[i23 >> 2] | 0;
  HEAP32[i18 >> 2] = i1;
  HEAP32[i24 >> 2] = HEAP32[i18 >> 2];
  __Z16BuildLineSegmentjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_11ColorRGBA32(i2, i22, i19, i26, i21, i17, i24);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i20 | 0));
 i26 = HEAP32[i23 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i26, gb + 64016 | 0);
 STACKTOP = i25;
 return;
}

function _UNITY_png_handle_sPLT(i10, i11, i7) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i1 = i10 + 632 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 switch (i2 | 0) {
 case 0:
  break;
 case 1:
  {
   _UNITY_png_crc_finish(i10, i7) | 0;
   STACKTOP = i13;
   return;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  i9 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i9;
  if ((i9 | 0) == 1) {
   _UNITY_png_crc_finish(i10, i7) | 0;
   STACKTOP = i13;
   return;
  }
 }
 i1 = HEAP32[i10 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i10, gb + 352205 | 0);
 if (i1 & 4 | 0) {
  _UNITY_png_crc_finish(i10, i7) | 0;
  _UNITY_png_chunk_benign_error(i10, gb + 352423 | 0);
  STACKTOP = i13;
  return;
 }
 i3 = i7 + 1 | 0;
 i4 = i10 + 644 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = 12; else {
  i2 = i10 + 648 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < i3 >>> 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   _UNITY_png_free(i10, i1);
   i5 = 12;
  }
 }
 do if ((i5 | 0) == 12) {
  i1 = _UNITY_png_malloc_base(i10, i3) | 0;
  if (i1 | 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i10 + 648 >> 2] = i3;
   break;
  }
  _UNITY_png_crc_finish(i10, i7) | 0;
  _UNITY_png_chunk_benign_error(i10, gb + 661520 | 0);
  STACKTOP = i13;
  return;
 } while (0);
 _UNITY_png_read_data(i10, i1, i7);
 _UNITY_png_calculate_crc(i10, i1, i7);
 if (_UNITY_png_crc_finish(i10, 0) | 0) {
  STACKTOP = i13;
  return;
 }
 i3 = i1 + i7 | 0;
 HEAP8[i3 >> 0] = 0;
 i2 = i1;
 while (1) {
  i4 = i2 + 1 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) break; else i2 = i4;
 }
 if (i4 >>> 0 > (i3 + -2 | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i6 = i2 + 2 | 0;
 i9 = HEAP8[i4 >> 0] | 0;
 HEAP8[i12 + 4 >> 0] = i9;
 i9 = i9 << 24 >> 24 == 8;
 i4 = i9 ? 6 : 10;
 i3 = i1 - i6 + i7 | 0;
 if ((i3 >>> 0) % (i4 >>> 0) | 0 | 0) {
  STACKTOP = i13;
  return;
 }
 i2 = (i3 >>> 0) / (i4 >>> 0) | 0;
 if (i2 >>> 0 > 429496729) {
  STACKTOP = i13;
  return;
 }
 i8 = i12 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = _UNITY_png_malloc_warn(i10, i2 * 10 | 0) | 0;
 i7 = i12 + 8 | 0;
 HEAP32[i7 >> 2] = i5;
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 L44 : do if (i4 >>> 0 <= i3 >>> 0) {
  i2 = 0;
  i4 = i6;
  i6 = i5;
  while (1) {
   i3 = i6 + (i2 * 10 | 0) | 0;
   if (i9) {
    HEAP16[i3 >> 1] = HEAPU8[i4 >> 0] | 0;
    HEAP16[i6 + (i2 * 10 | 0) + 2 >> 1] = HEAPU8[i4 + 1 >> 0] | 0;
    HEAP16[i6 + (i2 * 10 | 0) + 4 >> 1] = HEAPU8[i4 + 2 >> 0] | 0;
    i5 = i4 + 4 | 0;
    i3 = HEAPU8[i4 + 3 >> 0] | 0;
   } else {
    HEAP16[i3 >> 1] = HEAPU8[i4 >> 0] << 8 | HEAPU8[i4 + 1 >> 0];
    HEAP16[i6 + (i2 * 10 | 0) + 2 >> 1] = HEAPU8[i4 + 2 >> 0] << 8 | HEAPU8[i4 + 3 >> 0];
    HEAP16[i6 + (i2 * 10 | 0) + 4 >> 1] = HEAPU8[i4 + 4 >> 0] << 8 | HEAPU8[i4 + 5 >> 0];
    i5 = i4 + 8 | 0;
    i3 = (HEAPU8[i4 + 6 >> 0] << 8 | HEAPU8[i4 + 7 >> 0]) & 65535;
   }
   HEAP16[i6 + (i2 * 10 | 0) + 6 >> 1] = i3;
   HEAP16[i6 + (i2 * 10 | 0) + 8 >> 1] = HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (HEAP32[i8 >> 2] | 0)) break L44;
   i4 = i5 + 2 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
  }
 } while (0);
 HEAP32[i12 >> 2] = i1;
 _UNITY_png_set_sPLT(i10, i11, i12, 1);
 _UNITY_png_free(i10, HEAP32[i7 >> 2] | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i10, i11, i13, i12, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 144 | 0;
 i4 = i9 + 136 | 0;
 i2 = i9 + 128 | 0;
 i7 = i9;
 i3 = HEAP32[i10 + 104 >> 2] | 0;
 i1 = i3;
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i3 | 0) | 0)) {
   i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i2 >> 2] = gb + 832239;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i2);
  }
  i5 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = (i5 | 0) == 0 & (i2 | 0) == 0;
  i1 = i6 ? i1 : i5;
  i2 = i6 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = gb + 832257;
 HEAP32[i7 + 4 >> 2] = i3;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i13 | 0, gb + 832239 | 0, i7 | 0);
 i1 = HEAP32[i10 + 48 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i4) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i4 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0, i4 | 0, 1) | 0;
 i1 = i12 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832272 | 0, HEAP32[i1 >> 2] | 0);
 i2 = i12 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i12 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i10 + 108 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP8[i8 >> 0] = 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
  i7 = HEAP32[i13 >> 2] | 0;
  i7 = i7 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDriveNWEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i7 = i7 + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDriveNWEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
 STACKTOP = i9;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i10, i11, i13, i12, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 144 | 0;
 i4 = i9 + 136 | 0;
 i2 = i9 + 128 | 0;
 i7 = i9;
 i3 = HEAP32[i10 + 104 >> 2] | 0;
 i1 = i3;
 if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i3 | 0) | 0)) {
   i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i2 >> 2] = gb + 832239;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i2);
  }
  i5 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 52 >> 2] | 0, i11 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = (i5 | 0) == 0 & (i2 | 0) == 0;
  i1 = i6 ? i1 : i5;
  i2 = i6 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = gb + 832257;
 HEAP32[i7 + 4 >> 2] = i3;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i13 | 0, gb + 832239 | 0, i7 | 0);
 i1 = HEAP32[i10 + 48 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i4) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i4 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0, i4 | 0, 1) | 0;
 i1 = i12 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 832272 | 0, HEAP32[i1 >> 2] | 0);
 i2 = i12 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i12 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i10 + 108 >> 2] | 0;
 i5 = i7;
 i6 = i5 + 128 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP8[i8 >> 0] = 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
  i7 = HEAP32[i13 >> 2] | 0;
  i7 = i7 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDrive4WEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i12 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_iiii(i7 | 0, i12 | 0, i8 | 0, 1) | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i7 = i7 + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(i7 | 0, i13 | 0, gb + 832282 | 0, i8 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDrive4WEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i10, i13, i12, i11);
 STACKTOP = i9;
 return;
}

function __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i13, i5, i6) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i18 = HEAP32[i5 + 4 >> 2] | 0;
 i17 = HEAP32[i15 + 108 >> 2] | 0;
 i19 = HEAP32[i6 + 4 >> 2] | 0;
 i14 = HEAP32[i17 + (i18 << 5) + 8 >> 2] | 0;
 i15 = HEAP32[HEAP32[(HEAP32[i15 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
 i16 = HEAP32[i17 + (i19 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i15 + (i14 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i15 + (i16 * 360 | 0) + 184 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i19 = i1 >>> 0 < i2 >>> 0;
  return i19 | 0;
 }
 i1 = HEAP16[i17 + (i18 << 5) + 12 >> 1] | 0;
 i2 = HEAP16[i17 + (i19 << 5) + 12 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i19 = i1 << 16 >> 16 < i2 << 16 >> 16;
  return i19 | 0;
 }
 f3 = Math_fround(HEAPF32[i17 + (i18 << 5) + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i17 + (i19 << 5) + 20 >> 2]);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 if (f3 != f4) {
  i19 = f3 < f4;
  return i19 | 0;
 }
 i1 = HEAP16[i15 + (i14 * 360 | 0) + 270 >> 1] | 0;
 i2 = HEAP16[i15 + (i16 * 360 | 0) + 270 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i19 = (i1 & 65535) < (i2 & 65535);
  return i19 | 0;
 }
 i10 = HEAP32[i17 + (i18 << 5) + 4 >> 2] | 0;
 i11 = HEAP32[i17 + (i19 << 5) + 4 >> 2] | 0;
 i12 = (i10 | 0) == (i11 | 0);
 if (!i12) {
  i1 = HEAP16[i17 + (i18 << 5) + 18 >> 1] | 0;
  i2 = HEAP16[i17 + (i19 << 5) + 18 >> 1] | 0;
  if (i1 << 16 >> 16 != i2 << 16 >> 16) {
   i19 = (i1 & 65535) < (i2 & 65535);
   return i19 | 0;
  }
 }
 i7 = HEAP32[i5 + 8 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = i7 & 16777216;
 i2 = i6 & 16777216;
 if ((i1 | 0) != (i2 | 0)) {
  i19 = i1 >>> 0 > i2 >>> 0;
  return i19 | 0;
 }
 i2 = (HEAP16[i15 + (i14 * 360 | 0) + 182 >> 1] | 0) != 0;
 i5 = (HEAP16[i15 + (i16 * 360 | 0) + 182 >> 1] | 0) != 0;
 i1 = i5 ^ 1;
 if (!(i2 ^ 1 | i1)) {
  if (!i12) {
   i19 = i10 >>> 0 < i11 >>> 0;
   return i19 | 0;
  }
  i1 = HEAP32[i15 + (i14 * 360 | 0) + 248 >> 2] | 0;
  i2 = HEAP32[i15 + (i16 * 360 | 0) + 248 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i19 = (HEAPU16[i15 + (i14 * 360 | 0) + 180 >> 1] | 0) < (HEAPU16[i15 + (i16 * 360 | 0) + 180 >> 1] | 0);
   return i19 | 0;
  } else {
   i19 = (i1 | 0) < (i2 | 0);
   return i19 | 0;
  }
 }
 if (i2 ^ i5) {
  i19 = i2 & i1;
  return i19 | 0;
 }
 if (HEAP8[i13 + 4 >> 0] | 0) {
  i2 = i8 >>> 24;
  i1 = i9 >>> 24;
  if ((i2 | 0) != (i1 | 0)) {
   i19 = i2 >>> 0 < i1 >>> 0;
   return i19 | 0;
  }
 }
 i2 = HEAP32[i15 + (i14 * 360 | 0) + 224 >> 2] | 0;
 i1 = HEAP32[i15 + (i16 * 360 | 0) + 224 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i19 = i2 >>> 0 < i1 >>> 0;
  return i19 | 0;
 }
 i2 = HEAP32[i17 + (i18 << 5) >> 2] | 0;
 i1 = HEAP32[i17 + (i19 << 5) >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i19 = (HEAP32[i2 + 4 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0);
  return i19 | 0;
 }
 if (!i12) {
  i19 = (i10 | 0) < (i11 | 0);
  return i19 | 0;
 }
 i2 = i7 & 255;
 i1 = i6 & 255;
 if ((i2 | 0) == (i1 | 0)) {
  i19 = (i18 | 0) < (i19 | 0);
  return i19 | 0;
 } else {
  i19 = i2 >>> 0 < i1 >>> 0;
  return i19 | 0;
 }
 return 0;
}

function __Z33EmitSerializationCommandsForFieldI19StreamedBinaryWriteILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI19StreamedBinaryWriteILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __ZN32PlaneColliderCache_dense_hashmapC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16 + 8 | 0;
 i5 = i16;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP8[i2 + 8 >> 0] = 0;
 i8 = i2 + 9 | 0;
 HEAP8[i8 >> 0] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i2 + 56 | 0;
 i17 = i4;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 i17 = i2 + 96 | 0;
 HEAP32[i17 >> 2] = 0;
 i15 = i2 + 100 | 0;
 HEAP32[i15 >> 2] = 32;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f19 = Math_fround((HEAP32[i15 >> 2] | 0) >>> 0);
 HEAP32[i2 + 112 >> 2] = ~~Math_fround(f19 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 108 >> 2] = ~~Math_fround(f19 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 116 >> 0] = 0;
 i6 = i3 + 4 | 0;
 HEAP32[i6 >> 2] = 536870912;
 i7 = i3 + 8 | 0;
 i10 = __Z13MurmurHash64APKviy(i3, 12, 409413374, -559038737) | 0;
 i9 = getTempRet0() | 0;
 HEAP8[i8 >> 0] = 1;
 i8 = i4;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i2 + 64 | 0;
 i9 = i2 + 68 | 0;
 i10 = i2 + 72 | 0;
 i11 = i2 + 76 | 0;
 i12 = i2 + 80 | 0;
 i13 = i2 + 84 | 0;
 i14 = i2 + 88 | 0;
 i1 = (HEAP32[i15 >> 2] | 0) * 40 | 0;
 i18 = HEAP32[i2 + 120 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i18;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i17 >> 2] = i1;
 i15 = i1 + ((HEAP32[i15 >> 2] | 0) * 40 | 0) | 0;
 if ((i1 | 0) == (i15 | 0)) {
  HEAP32[i3 >> 2] = -2147483648;
  HEAP32[i6 >> 2] = -536870912;
  HEAP32[i7 >> 2] = -2147483648;
  i14 = __Z13MurmurHash64APKviy(i3, 12, 409413374, -559038737) | 0;
  i17 = getTempRet0() | 0;
  i14 = i14 ^ 1;
  i18 = i5;
  i15 = i18;
  HEAP32[i15 >> 2] = i14;
  i18 = i18 + 4 | 0;
  HEAP32[i18 >> 2] = i17;
  __ZN14dense_hash_mapIy9PlaneDataN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorENSt3__28equal_toIyEE13stl_allocatorINS3_4pairIKyS0_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERS8_(i2, i5);
  STACKTOP = i16;
  return;
 }
 do {
  i18 = i4;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i20 = i1;
  HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i20 + 4 >> 2] = i17;
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i13 >> 2];
  i20 = i14;
  i17 = HEAP32[i20 + 4 >> 2] | 0;
  i18 = i1 + 32 | 0;
  HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
  HEAP32[i18 + 4 >> 2] = i17;
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i15 | 0));
 HEAP32[i3 >> 2] = -2147483648;
 HEAP32[i6 >> 2] = -536870912;
 HEAP32[i7 >> 2] = -2147483648;
 i15 = __Z13MurmurHash64APKviy(i3, 12, 409413374, -559038737) | 0;
 i18 = getTempRet0() | 0;
 i15 = i15 ^ 1;
 i20 = i5;
 i17 = i20;
 HEAP32[i17 >> 2] = i15;
 i20 = i20 + 4 | 0;
 HEAP32[i20 >> 2] = i18;
 __ZN14dense_hash_mapIy9PlaneDataN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorENSt3__28equal_toIyEE13stl_allocatorINS3_4pairIKyS0_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERS8_(i2, i5);
 STACKTOP = i16;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 12 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP16[i10 + 8 >> 1] = 0;
  HEAP8[i10 + 10 >> 0] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = -1;
    i9 = i1 + 4 | 0;
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP16[i9 + 8 >> 1] = HEAP16[i10 + 8 >> 1] | 0;
    HEAP8[i9 + 10 >> 0] = HEAP8[i10 + 10 >> 0] | 0;
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 4) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863506 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN5audio5mixer13GroupConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863506 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN5audio5mixer13GroupConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx28PxRevoluteJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 742188;
 HEAP32[i1 + 240 >> 2] = 465;
 HEAP32[i1 + 244 >> 2] = fb + 430;
 HEAP32[i1 + 248 >> 2] = gb + 742194;
 HEAP32[i1 + 252 >> 2] = 466;
 HEAP32[i1 + 256 >> 2] = fb + 431;
 HEAP32[i1 + 260 >> 2] = gb + 906575;
 HEAP32[i1 + 264 >> 2] = 467;
 HEAP32[i1 + 268 >> 2] = fb + 3559;
 HEAP32[i1 + 272 >> 2] = fb + 3560;
 HEAP32[i1 + 276 >> 2] = gb + 742203;
 HEAP32[i1 + 280 >> 2] = 468;
 HEAP32[i1 + 284 >> 2] = fb + 432;
 HEAP32[i1 + 288 >> 2] = fb + 373;
 HEAP32[i1 + 292 >> 2] = gb + 742217;
 HEAP32[i1 + 296 >> 2] = 469;
 HEAP32[i1 + 300 >> 2] = fb + 433;
 HEAP32[i1 + 304 >> 2] = fb + 374;
 HEAP32[i1 + 308 >> 2] = gb + 742233;
 HEAP32[i1 + 312 >> 2] = 470;
 HEAP32[i1 + 316 >> 2] = fb + 434;
 HEAP32[i1 + 320 >> 2] = fb + 375;
 HEAP32[i1 + 324 >> 2] = gb + 742248;
 HEAP32[i1 + 328 >> 2] = 471;
 HEAP32[i1 + 332 >> 2] = fb + 2166;
 HEAP32[i1 + 336 >> 2] = fb + 3561;
 HEAP32[i1 + 340 >> 2] = gb + 741652;
 HEAP32[i1 + 344 >> 2] = 472;
 HEAP32[i1 + 348 >> 2] = fb + 435;
 HEAP32[i1 + 352 >> 2] = fb + 376;
 HEAP32[i1 + 356 >> 2] = gb + 742267;
 HEAP32[i1 + 360 >> 2] = 473;
 HEAP32[i1 + 364 >> 2] = fb + 436;
 HEAP32[i1 + 368 >> 2] = fb + 377;
 HEAP32[i1 + 372 >> 2] = gb + 831985;
 HEAP32[i1 + 376 >> 2] = 474;
 HEAP32[i1 + 380 >> 2] = fb + 2167;
 return;
}

function __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i8, i10, i11) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 16 | 0;
 i12 = i15;
 i6 = i15 + 8 | 0;
 i13 = i15 + 4 | 0;
 i7 = i8 + 16 | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i7 | 0)) do {
  i5 = i1 + 8 | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i12);
    i3 = HEAP32[i9 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 12;
   }
  }
  if ((i14 | 0) == 10) i14 = 12;
  if ((i14 | 0) == 12) {
   i14 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  __ZN6Camera24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i1, i9, i11);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 i6 = i8 + 4 | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i15;
  return;
 }
 do {
  i5 = i1 + 8 | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i14 = 20; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i12);
    i3 = HEAP32[i9 >> 2] | 0;
    i16 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 20; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i14 = 22;
   }
  }
  if ((i14 | 0) == 20) i14 = 22;
  if ((i14 | 0) == 22) {
   i14 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  }
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
  __ZN6Camera24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i1, i9, i11);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 STACKTOP = i15;
 return;
}

function __Z33EmitSerializationCommandsForFieldI24GenerateTypeTreeTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI24GenerateTypeTreeTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb1EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI18StreamedBinaryReadILb1EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI18StreamedBinaryReadILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh(i5, i2, f3, i7, i8) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i4 = i9 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 if (!(f3 > Math_fround(.0000999999974))) {
  STACKTOP = i9;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i6 = f3 > Math_fround(1.0);
 i4 = HEAP32[(i6 ? i4 : i1) >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 i6 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 40 | 0) | 0;
 i1 = HEAP16[i7 + 56 >> 1] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 255) << 24 >> 24) {
  if ((i1 & 65535) >= 256) {
   i4 = HEAP16[i5 + 8 >> 1] | 0;
   if (!((i4 & 255) << 24 >> 24 == 0 | (i4 & 65535) < 256)) {
    __Z19ApplyBlendShapeTmplILb1ELb1EEvPK16BlendShapeVertexjjfiiiPh(i6, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i7 + 60 >> 2] | 0, f3, HEAP32[i7 + 48 >> 2] | 0, HEAP32[i7 + 52 >> 2] | 0, HEAP32[i7 + 40 >> 2] | 0, i8);
    STACKTOP = i9;
    return;
   }
  }
  if (HEAP8[i5 + 8 >> 0] | 0) {
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i5 = HEAP32[i7 + 48 >> 2] | 0;
   i2 = HEAP32[i7 + 40 >> 2] | 0;
   if (!i4) {
    STACKTOP = i9;
    return;
   } else i1 = 0;
   do {
    i7 = i8 + (Math_imul(HEAP32[i6 + (i1 * 40 | 0) + 36 >> 2] | 0, i2) | 0) | 0;
    f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]));
    f12 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 4 >> 2]));
    f13 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 8 >> 2]));
    HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
    i11 = i7 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i11 >> 2]));
    i11 = i7 + 8 | 0;
    HEAPF32[i11 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
    i7 = i7 + i5 | 0;
    f13 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 12 >> 2]));
    f12 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 16 >> 2]));
    f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 20 >> 2]));
    HEAPF32[i7 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i7 >> 2]));
    i11 = i7 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i11 >> 2]));
    i7 = i7 + 8 | 0;
    HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   STACKTOP = i9;
   return;
  }
 }
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i7 + 40 >> 2] | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i11 = i8 + (Math_imul(HEAP32[i6 + (i1 * 40 | 0) + 36 >> 2] | 0, i2) | 0) | 0;
  f10 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]));
  f12 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 4 >> 2]));
  f13 = Math_fround(f3 * Math_fround(HEAPF32[i6 + (i1 * 40 | 0) + 8 >> 2]));
  HEAPF32[i11 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i11 >> 2]));
  i7 = i11 + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i7 >> 2]));
  i11 = i11 + 8 | 0;
  HEAPF32[i11 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZNK8WindZone16ComputeWindForceERK4AABBf(i6, i7, i3, f1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f4 = f0, i5 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i5 = i12;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f9 = Math_fround(f4 + Math_fround(Math_fround(Math_fround(f4 + f9) - Math_fround(f4 - f9)) * Math_fround(.25)));
 f4 = Math_fround(f1 * Math_fround(3.14159274));
 f4 = Math_fround(Math_fround(f8 * Math_fround(.100000001)) + Math_fround(Math_fround(f11 * Math_fround(.100000001)) + Math_fround(f4 * Math_fround(HEAPF32[i7 + 56 >> 2]))));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(+Math_cos(+f4)) + Math_fround(+Math_cos(+Math_fround(f4 * Math_fround(.375))))) + Math_fround(+Math_cos(+Math_fround(f4 * Math_fround(.0500000007))))) * Math_fround(.333000004));
 f4 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 + 52 >> 2]) * f4) + Math_fround(1.0));
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i10, i2);
 if (!(HEAP32[i7 + 36 >> 2] | 0)) {
  __ZNK9Transform18TransformDirectionERK8Vector3f(i5, i2, gb + 62548 | 0);
  f1 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(f1 * f1);
  f8 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f8 * f8));
  f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f11 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f9 * f9))));
  f1 = Math_fround(f1 / f11);
  f8 = Math_fround(f8 / f11);
  f11 = Math_fround(f9 / f11);
  f9 = Math_fround(HEAPF32[i7 + 44 >> 2]);
  f1 = Math_fround(f4 * Math_fround(f1 * f9));
  f8 = Math_fround(f4 * Math_fround(f8 * f9));
  f9 = Math_fround(f4 * Math_fround(f11 * f9));
  f11 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 48 >> 2]));
  HEAPF32[i6 >> 2] = f1;
  HEAPF32[i6 + 4 >> 2] = f8;
  HEAPF32[i6 + 8 >> 2] = f9;
  HEAPF32[i6 + 12 >> 2] = f11;
  STACKTOP = i12;
  return;
 }
 f13 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i10, i3));
 f1 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 f1 = Math_fround(Math_fround(1.0) - Math_fround(f13 / Math_fround(f1 * f1)));
 if (f1 > Math_fround(0.0)) {
  f13 = Math_fround(f4 * f1);
  f1 = Math_fround(f11 - Math_fround(HEAPF32[i10 >> 2]));
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i10 + 4 >> 2]));
  f11 = Math_fround(f8 - Math_fround(HEAPF32[i10 + 8 >> 2]));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f9 * f9)) + Math_fround(f11 * f11))));
  f8 = Math_fround(f1 / f4);
  f9 = Math_fround(f9 / f4);
  f4 = Math_fround(f11 / f4);
  f11 = Math_fround(HEAPF32[i7 + 44 >> 2]);
  f8 = Math_fround(f13 * Math_fround(f8 * f11));
  f9 = Math_fround(f13 * Math_fround(f9 * f11));
  f11 = Math_fround(f13 * Math_fround(f4 * f11));
  f13 = Math_fround(f13 * Math_fround(HEAPF32[i7 + 48 >> 2]));
  HEAPF32[i6 >> 2] = f8;
  HEAPF32[i6 + 4 >> 2] = f9;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f13;
  STACKTOP = i12;
  return;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
}

function __ZN16UnityAdsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i9 + 8 | 0;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 16 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 17 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i9 + 12 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i7 = i9 + 20 | 0;
 i1 = i7 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i8 = i9 + 24 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i5;
 i6 = i3 + 4 | 0;
 if (i6 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i6 = i9 + 36 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i9 + 40 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i1;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i10 = i2 << 24 >> 24 < 0;
 i1 = i10 ? HEAP32[i6 >> 2] | 0 : i6;
 i10 = i10 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i10 | 0;
 if (!i10) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 STACKTOP = i14;
 return;
}

function __Z18SplitRespectQuotesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorIS5_NS3_IS5_EEEE(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 24 | 0;
 i15 = i18 + 12 | 0;
 i16 = i18;
 i12 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i12 << 24 >> 24 < 0;
 i2 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i12 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i12 & 255;
 i7 = i2 + i12 | 0;
 if (!i12) {
  STACKTOP = i18;
  return;
 }
 i8 = i16 + 8 | 0;
 i9 = i16 + 4 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13 + 8 | 0;
 i12 = i16 + 11 | 0;
 i1 = i2;
 L4 : while (1) {
  i3 = i1;
  while (1) {
   i6 = (HEAP8[i3 >> 0] | 0) + -9 << 24 >> 24;
   if ((i6 & 255) > 23 | (8388639 >>> (i6 & 255) & 1 | 0) == 0) break;
   i1 = i3 + 1 | 0;
   if ((i1 | 0) == (i7 | 0)) {
    i17 = 25;
    break L4;
   } else i3 = i1;
  }
  i4 = i3;
  i6 = (i3 | 0) == (i7 | 0);
  if (i6) {
   i17 = 25;
   break;
  } else {
   i2 = 0;
   i1 = i3;
  }
  while (1) {
   i5 = HEAP8[i1 >> 0] | 0;
   if (i5 << 24 >> 24 == 34) i2 = i2 ^ 1; else {
    i5 = i5 + -9 << 24 >> 24;
    if ((i5 & 255) < 24) if (!(i2 | (8388639 >>> (i5 & 255) & 1 | 0) == 0)) break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i7 | 0)) {
    i1 = i7;
    break;
   }
  }
  if (!i6) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   i2 = i1 - i4 | 0;
   if (i2 >>> 0 > 4294967279) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i16);
    i17 = 18;
   } else if (i2 >>> 0 < 11) {
    HEAP8[i12 >> 0] = i2;
    i2 = i16;
   } else i17 = 18;
   if ((i17 | 0) == 18) {
    i17 = 0;
    i5 = i2 + 16 & -16;
    i6 = __Znwj(i5) | 0;
    HEAP32[i16 >> 2] = i6;
    HEAP32[i8 >> 2] = i5 | -2147483648;
    HEAP32[i9 >> 2] = i2;
    i2 = i6;
   }
   if ((i3 | 0) != (i1 | 0)) while (1) {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i3 = i4 + 1 | 0;
    i2 = i2 + 1 | 0;
    if ((i3 | 0) == (i1 | 0)) break; else i4 = i3;
   }
   HEAP8[i2 >> 0] = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 1046779 | 0, 1);
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i15, gb + 1576256 | 0, 0);
   __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRT_RKS7_SA_j(i16, i14, i15, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i2 = HEAP32[i10 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i11 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i13, i16); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i16);
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
  }
  if ((i1 | 0) == (i7 | 0)) {
   i17 = 25;
   break;
  }
 }
 if ((i17 | 0) == 25) {
  STACKTOP = i18;
  return;
 }
}

function __ZN7ApiGLES4InitERK14GfxContextGLESR16GfxDeviceLevelGL(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i11 + 4 | 0;
 HEAP32[i12 + 1988 >> 2] = __ZN2gl17GetCurrentContextEv() | 0;
 HEAP32[gb + 1451080 >> 2] = i12;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] = i7;
 __ZN7ApiGLES4LoadE16GfxDeviceLevelGL(i12, HEAP32[i2 >> 2] | 0);
 __ZN4gles8InitCapsEP7ApiGLESP12GraphicsCapsR16GfxDeviceLevelGL(i12, __Z15GetGraphicsCapsv() | 0, i2);
 i7 = HEAP32[i12 + 852 >> 2] | 0;
 i8 = __Z15GetGraphicsCapsv() | 0;
 __ZN13TranslateGLES4InitERK12GraphicsCaps16GfxDeviceLevelGL(i7, i8, HEAP32[i2 >> 2] | 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 713 >> 0] | 0) {
  i1 = i12 + 644 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[gb + 1451084 >> 2] | 0)) {
   HEAP32[gb + 1451084 >> 2] = i2;
   HEAP32[i1 >> 2] = fb + 3225;
  }
  if (i2 | 0) HEAP32[gb + 1451088 >> 2] = 0;
 }
 __ZN4gles30InitRenderTextureFormatSupportEP7ApiGLESP12GraphicsCaps(i12, __Z15GetGraphicsCapsv() | 0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 mftCall_vii(HEAP32[i12 + 804 >> 2] | 0, 1, i10 | 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i12 + 1992 | 0;
 i6 = i12 + 1600 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) i13 = 10; else if ((HEAP32[i12 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] | 0) == (i1 | 0)) i7 = i12 + 860 | 0; else i13 = 10;
 if ((i13 | 0) == 10) {
  i7 = i12 + 860 | 0;
  i5 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i7 >> 2] | 0, 2) | 0;
  mftCall_vii(HEAP32[i12 + 812 >> 2] | 0, i5 | 0, i1 | 0);
  HEAP32[i12 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] = i1;
  HEAP32[i12 + 1732 + (HEAP32[i6 >> 2] << 2) >> 2] = 2;
 }
 i2 = i12 + 84 | 0;
 mftCall_i(HEAP32[i2 >> 2] | 0) | 0;
 HEAP16[i9 >> 1] = 0;
 i3 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i7 >> 2] | 0, 19) | 0;
 i14 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1;
 i4 = HEAP32[i12 + 176 >> 2] | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 if (i14) mftCall_viiiiiiiii(i4 | 0, 3553, 0, 6408, 1, 1, 0, 6408, i5 | 0, i9 | 0); else mftCall_viiiiiiiii(i4 | 0, 3553, 0, HEAP32[i3 >> 2] | 0, 1, 1, 0, HEAP32[i3 + 4 >> 2] | 0, i5 | 0, i9 | 0);
 HEAP32[i10 >> 2] = i1;
 i1 = (mftCall_i(HEAP32[i2 >> 2] | 0) | 0) == 0;
 if (!(HEAP8[i8 >> 0] | 0)) i13 = 16; else if (HEAP32[i12 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] | 0) i13 = 16;
 if ((i13 | 0) == 16) {
  i14 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i7 >> 2] | 0, 2) | 0;
  mftCall_vii(HEAP32[i12 + 812 >> 2] | 0, i14 | 0, 0);
  HEAP32[i12 + 1604 + (HEAP32[i6 >> 2] << 2) >> 2] = 0;
  HEAP32[i12 + 1732 + (HEAP32[i6 >> 2] << 2) >> 2] = 2;
 }
 __ZN7ApiGLES13DeleteTextureERj(i12, i10);
 i14 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 186 >> 0] | 0) != 0;
 HEAP8[(__Z15GetGraphicsCapsv() | 0) + 186 >> 0] = i14 & 1;
 i14 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 187 >> 0] | 0) != 0;
 HEAP8[(__Z15GetGraphicsCapsv() | 0) + 187 >> 0] = i14 & 1;
 i14 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0) != 0;
 HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] = i14 & 1;
 STACKTOP = i11;
 return;
}

function __ZN5physx3Ext7D6JointC2ERKNS_17PxTolerancesScaleEPNS_12PxRigidActorERKNS_11PxTransformES6_S9_(i6, i5, i1, i3, i2, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, f9 = f0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8;
 HEAP16[i6 + 4 >> 1] = 261;
 HEAP16[i6 + 6 >> 1] = 3;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 86848 + 8;
 HEAP32[i6 + 12 >> 2] = gb + 86848 + 256;
 HEAP8[i6 + 84 >> 0] = 1;
 HEAP8[i6 + 85 >> 0] = 1;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8 + 16 | 0, 384, gb + 734589 | 0, 57) | 0;
 HEAP32[i6 + 80 >> 2] = i7;
 __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i6, i7, i1, i3, i2, i4);
 i1 = i7 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i7 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 124 >> 2] = Math_fround(.5);
 i1 = i7 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i7 + 136 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 140 >> 2] = Math_fround(1.57079637);
 HEAPF32[i7 + 144 >> 2] = Math_fround(-1.57079637);
 HEAPF32[i7 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 152 >> 2] = Math_fround(.5);
 i1 = i7 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i7 + 164 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 168 >> 2] = Math_fround(1.57079637);
 HEAPF32[i7 + 172 >> 2] = Math_fround(1.57079637);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.00999999977));
 i1 = i7 + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAPF32[i7 + 112 >> 2] = f9;
 HEAPF32[i7 + 116 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 372 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(9.99999997e-07));
 HEAP32[i7 + 176 >> 2] = 0;
 HEAP32[i7 + 180 >> 2] = 0;
 HEAP32[i7 + 184 >> 2] = 2139095039;
 HEAP32[i7 + 188 >> 2] = 0;
 HEAP32[i7 + 192 >> 2] = 0;
 HEAP32[i7 + 196 >> 2] = 0;
 HEAP32[i7 + 200 >> 2] = 2139095039;
 HEAP32[i7 + 204 >> 2] = 0;
 HEAP32[i7 + 208 >> 2] = 0;
 HEAP32[i7 + 212 >> 2] = 0;
 HEAP32[i7 + 216 >> 2] = 2139095039;
 HEAP32[i7 + 220 >> 2] = 0;
 HEAP32[i7 + 224 >> 2] = 0;
 HEAP32[i7 + 228 >> 2] = 0;
 HEAP32[i7 + 232 >> 2] = 2139095039;
 HEAP32[i7 + 236 >> 2] = 0;
 HEAP32[i7 + 240 >> 2] = 0;
 HEAP32[i7 + 244 >> 2] = 0;
 HEAP32[i7 + 248 >> 2] = 2139095039;
 HEAP32[i7 + 252 >> 2] = 0;
 HEAP32[i7 + 256 >> 2] = 0;
 HEAP32[i7 + 260 >> 2] = 0;
 HEAP32[i7 + 264 >> 2] = 2139095039;
 HEAP32[i7 + 268 >> 2] = 0;
 HEAP32[i7 + 272 >> 2] = 0;
 HEAP32[i7 + 276 >> 2] = 0;
 HEAP32[i7 + 280 >> 2] = 0;
 HEAP32[i7 + 284 >> 2] = 1065353216;
 i1 = i7 + 376 | 0;
 i2 = i7 + 288 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0e10);
 HEAPF32[i7 + 380 >> 2] = Math_fround(3.14159274);
 STACKTOP = i8;
 return;
}

function __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j(i14, i12) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i8 = i16 + 20 | 0;
 i9 = i16 + 4 | 0;
 i10 = i16 + 16 | 0;
 i11 = i16;
 i15 = i14 + 4 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i2 = (i7 - i6 | 0) / 108 | 0;
 i1 = i6;
 if (i2 >>> 0 < i12 >>> 0) {
  i4 = i14 + 8 | 0;
  if ((((HEAP32[i4 >> 2] | 0) - i6 | 0) / 108 | 0 | 0) == (i12 | 0)) {
   __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6resizeEj(i14, i12);
   STACKTOP = i16;
   return;
  }
  HEAP32[i9 >> 2] = 0;
  i1 = i9 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i9 + 8 | 0;
  HEAP32[i2 >> 2] = 0;
  i5 = i9 + 8 | 0;
  if (!i12) {
   i3 = i1;
   i2 = i6;
   i1 = i7;
  } else {
   HEAP32[i13 + 16 >> 2] = i2;
   i3 = __Znwj(i12 * 108 | 0) | 0;
   i2 = i3;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i13 + 8 >> 2] = 0;
   HEAP32[i5 >> 2] = i3 + (i12 * 108 | 0);
   HEAP32[i13 + 12 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev(i13);
   i3 = i1;
   i2 = HEAP32[i14 >> 2] | 0;
   i1 = HEAP32[i15 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = i2;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i8, i13);
  __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6resizeEj(i9, i12);
  i13 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i13;
  i14 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i14;
  i15 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i15;
  __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev(i9);
  STACKTOP = i16;
  return;
 }
 if (i2 >>> 0 <= i12 >>> 0) {
  STACKTOP = i16;
  return;
 }
 i4 = i1 + (i12 * 108 | 0) | 0;
 HEAP32[i13 >> 2] = 0;
 i8 = i13 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 i2 = i12 * 108 | 0;
 i3 = (i2 | 0) / 108 | 0;
 if (!i2) {
  i3 = i13 + 8 | 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  if (i3 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i2 = __Znwj(i2) | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i13 >> 2] = i2;
  i6 = i2 + (i3 * 108 | 0) | 0;
  i7 = i13 + 8 | 0;
  HEAP32[i7 >> 2] = i6;
  i5 = i2;
  if (!i12) {
   i3 = i7;
   i4 = i5;
   i2 = i5;
   i1 = i6;
  } else {
   do {
    __ZN9InputAxisC2ERKS_(i2, i1);
    i1 = i1 + 108 | 0;
    i2 = (HEAP32[i8 >> 2] | 0) + 108 | 0;
    HEAP32[i8 >> 2] = i2;
   } while ((i1 | 0) != (i4 | 0));
   i3 = i7;
   i4 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i4;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i2;
 i15 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = i1;
 __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev(i13);
 STACKTOP = i16;
 return;
}

function __ZN8Remapper33RemoveCompleteSerializedFileIndexEiRNSt3__26vectorIiNS0_9allocatorIiEEEE(i19, i16, i17) {
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0;
 i5 = i19 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i4 = i5;
  i3 = i2;
 }
 L3 : while (1) {
  i1 = i3;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i16 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   i4 = i1;
   break;
  } else i4 = i1;
 }
 i3 = i5;
 L10 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) > (i16 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L10;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 i10 = (i4 | 0) == (i3 | 0);
 if (i10) return;
 i11 = i19 + 12 | 0;
 i12 = i19 + 16 | 0;
 i13 = i19 + 20 | 0;
 i14 = i17 + 4 | 0;
 i15 = i17 + 8 | 0;
 i2 = i4;
 while (1) {
  if ((HEAP32[i2 + 16 >> 2] | 0) != (i16 | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467155 | 0, 0, gb + 467207 | 0, 67, 1, 0, 0, 0);
  i9 = i2 + 32 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  if (!i8) i18 = 32; else {
   i7 = HEAP32[i9 >> 2] | 0;
   i1 = i12;
   i6 = i8;
   L27 : while (1) {
    i5 = i6;
    while (1) {
     if ((HEAP32[i5 + 16 >> 2] | 0) >= (i7 | 0)) break;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i5) break L27;
    }
    i6 = HEAP32[i5 >> 2] | 0;
    if (!i6) {
     i1 = i5;
     break;
    } else i1 = i5;
   }
   if ((i1 | 0) == (i12 | 0)) i18 = 32; else if ((i7 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i18 = 32;
  }
  if ((i18 | 0) == 32) {
   i18 = 0;
   i1 = i12;
  }
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i5) {
   i6 = i1;
   while (1) {
    i5 = HEAP32[i6 + 8 >> 2] | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i6 | 0)) break; else i6 = i5;
   }
  } else while (1) {
   i6 = HEAP32[i5 >> 2] | 0;
   if (!i6) break; else i5 = i6;
  }
  if ((HEAP32[i11 >> 2] | 0) == (i1 | 0)) HEAP32[i11 >> 2] = i5;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i1);
  __ZdlPv(i1);
  i1 = HEAP32[i14 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i17, i9); else {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i14 >> 2] = i1 + 4;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 if (i10) return;
 i5 = i19 + 8 | 0;
 i6 = i19 + 4 | 0;
 while (1) {
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i4;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i19 >> 2] | 0) == (i4 | 0)) HEAP32[i19 >> 2] = i1;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i4);
  __ZdlPv(i4);
  if ((i1 | 0) == (i3 | 0)) break; else i4 = i1;
 }
 return;
}

function __ZN5physx2Gu13RTreeMidphase17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 134020 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 134020 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 134020 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 134020 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 134020 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 134020 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 134020 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 134020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 134052 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 134052 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 134052 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 134052 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 134052 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 134052 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 134052 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 134052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 134084 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 134084 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 134084 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 134084 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 134084 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 134084 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 134084 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 134084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 134116 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 134116 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 134116 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 134116 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 134116 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 134116 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 134116 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 134116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 134148 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 134148 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 134148 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 134148 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 134148 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 134148 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 134148 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 134148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 134180 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 134180 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 134180 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 134180 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 134180 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 134180 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 134180 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 134180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu13MeshInterface17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 133828 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 133828 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 133828 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 133828 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 133828 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 133828 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 133828 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 133828 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 133860 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 133860 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 133860 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 133860 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 133860 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 133860 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 133860 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 133860 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 133892 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 133892 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 133892 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 133892 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 133892 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 133892 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 133892 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 133892 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 133924 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 133924 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 133924 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 133924 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 133924 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 133924 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 133924 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 133924 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 133956 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 133956 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 133956 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 133956 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 133956 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 133956 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 133956 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 133956 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 133988 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 133988 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 133988 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 133988 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 133988 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 133988 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 133988 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 133988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z21GetBlendShapeVerticesP8Vector3fS0_S0_RK13dynamic_arrayI16BlendShapeVertexLj4EERK10BlendShapei(i10, i7, i8, i11, i12, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0;
 i1 = i1 * 12 | 0;
 _memset(i10 | 0, 0, i1 | 0) | 0;
 i2 = (i7 | 0) != 0;
 if (i2) _memset(i7 | 0, 0, i1 | 0) | 0;
 i3 = (i8 | 0) != 0;
 if (i3) _memset(i8 | 0, 0, i1 | 0) | 0;
 i9 = i12 + 4 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) return;
 i5 = i12 + 8 | 0;
 i6 = i12 + 9 | 0;
 if (!i2) {
  if (i3) i1 = 0; else {
   i1 = 0;
   do {
    i8 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    i7 = i6 + (i8 * 40 | 0) | 0;
    i8 = i10 + ((HEAP32[i6 + (i8 * 40 | 0) + 36 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   return;
  }
  do {
   i2 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i5 = i3 + (i2 * 40 | 0) | 0;
   i3 = HEAP32[i3 + (i2 * 40 | 0) + 36 >> 2] | 0;
   i7 = i10 + (i3 * 12 | 0) | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   if (HEAP8[i6 >> 0] | 0) {
    i7 = i8 + (i3 * 12 | 0) | 0;
    i5 = (HEAP32[i11 >> 2] | 0) + (i2 * 40 | 0) + 24 | 0;
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  return;
 }
 if (!i3) {
  i1 = 0;
  do {
   i2 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i6 = i3 + (i2 * 40 | 0) | 0;
   i3 = HEAP32[i3 + (i2 * 40 | 0) + 36 >> 2] | 0;
   i8 = i10 + (i3 * 12 | 0) | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   if (HEAP8[i5 >> 0] | 0) {
    i8 = i7 + (i3 * 12 | 0) | 0;
    i6 = (HEAP32[i11 >> 2] | 0) + (i2 * 40 | 0) + 12 | 0;
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  return;
 }
 i2 = 0;
 do {
  i3 = (HEAP32[i12 >> 2] | 0) + i2 | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i13 = i4 + (i3 * 40 | 0) | 0;
  i4 = HEAP32[i4 + (i3 * 40 | 0) + 36 >> 2] | 0;
  i1 = i10 + (i4 * 12 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  i1 = HEAP16[i5 >> 1] | 0;
  if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
   i1 = i7 + (i4 * 12 | 0) | 0;
   i13 = (HEAP32[i11 >> 2] | 0) + (i3 * 40 | 0) + 12 | 0;
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   i1 = HEAP8[i6 >> 0] | 0;
  }
  if (i1 << 24 >> 24) {
   i13 = i8 + (i4 * 12 | 0) | 0;
   i4 = (HEAP32[i11 >> 2] | 0) + (i3 * 40 | 0) + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 return;
}

function __Z15addImpulseAtPosRN5physx11PxsBodyCoreERKNS_6PxVec3ES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i1 + 16 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 20 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 24 >> 2]));
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f5 * f13);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f6 * f14));
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(Math_fround(f6 * f11) - Math_fround(f12 * f13));
 f5 = Math_fround(Math_fround(f12 * f14) - Math_fround(f5 * f11));
 f12 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f11 = Math_fround(f11 * f12);
 f14 = Math_fround(f14 * f12);
 f12 = Math_fround(f13 * f12);
 i3 = i1 + 64 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 68 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 72 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i3 >> 2]));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f6 = Math_fround(f6 * Math_fround(2.0));
 f5 = Math_fround(f5 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f4 * f11);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f6 * f9));
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f5 * f7));
 f8 = Math_fround(Math_fround(f11 * f13) + Math_fround(Math_fround(f4 * f14) - Math_fround(f12 * Math_fround(Math_fround(f5 * f9) - Math_fround(f6 * f7)))));
 f10 = Math_fround(Math_fround(f9 * f13) + Math_fround(Math_fround(f6 * f14) - Math_fround(f12 * Math_fround(Math_fround(f4 * f7) - Math_fround(f5 * f11)))));
 f13 = Math_fround(Math_fround(Math_fround(f5 * f14) - Math_fround(f12 * Math_fround(Math_fround(f6 * f11) - Math_fround(f4 * f9)))) + Math_fround(f7 * f13));
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 112 >> 2]) * f8);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 116 >> 2]) * f10);
 f8 = Math_fround(f8 * Math_fround(2.0));
 f10 = Math_fround(f10 * Math_fround(2.0));
 f13 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 120 >> 2]) * f13) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(f7 * f13) + Math_fround(Math_fround(f11 * f8) + Math_fround(f9 * f10)));
 f6 = Math_fround(Math_fround(f11 * f4) + Math_fround(Math_fround(f14 * f8) + Math_fround(f12 * Math_fround(Math_fround(f9 * f13) - Math_fround(f7 * f10)))));
 f5 = Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f14 * f10) + Math_fround(f12 * Math_fround(Math_fround(f7 * f8) - Math_fround(f11 * f13)))));
 f4 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f8)))) + Math_fround(f7 * f4));
 i3 = i1 + 80 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f6);
 i3 = i1 + 84 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
 i3 = i1 + 88 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f4);
 return;
}

function __ZL19SweepCapsuleUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i12 + 76 | 0;
 i16 = i12 + 48 | 0;
 i15 = i12 + 32 | 0;
 i14 = i12;
 i11 = i12 + 88 | 0;
 i13 = i12 + 136 | 0;
 HEAP32[i17 >> 2] = 2;
 d19 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d23 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAPF32[i17 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i16 + 16 >> 2] = Math_fround(d19 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d23 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 3;
 d23 = +HEAPF64[i3 + 40 >> 3];
 d21 = +HEAPF64[i3 + 48 >> 3];
 d19 = +HEAPF64[i3 + 56 >> 3];
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAPF32[i14 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i14 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i14 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i14 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 80 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 84 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 88 >> 2];
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i3 = i11 + 16 | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i11, i13, Math_fround(0.0)) | 0)) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i10 + 40 >> 2] = -1;
 HEAP32[i10 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i10 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
 HEAPF64[i10 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
 HEAPF64[i10 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i17 = 1;
 STACKTOP = i12;
 return i17 | 0;
}

function __Z28computeBlockStreamByteSizes4PN5physx21PxcSolverContact4DescERjPjRNS_18PxcNpThreadContextE(i17, i16, i12, i13) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 128 | 0;
 i15 = i18;
 i1 = i14;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i15;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i11 = 0;
 i1 = 0;
 i2 = 0;
 i10 = 0;
 while (1) {
  if (i1) i1 = 1; else i1 = (HEAP8[i17 + (i11 * 56 | 0) + 53 >> 0] | 0) != 0;
  if (i2) i2 = 1; else i2 = (HEAP8[i17 + (i11 * 56 | 0) + 54 >> 0] | 0) != 0;
  i3 = HEAP32[i17 + (i11 * 56 | 0) + 8 >> 2] | 0;
  if (!i3) {
   i3 = 0;
   i4 = 0;
  } else {
   i8 = HEAP32[i17 + (i11 * 56 | 0) + 4 >> 2] | 0;
   i4 = 0;
   i9 = 0;
   do {
    i6 = i8 + i9 | 0;
    if (!(HEAP16[i13 + 5264 + (i6 * 96 | 0) + 22 >> 1] & 1)) i7 = (HEAP16[i13 + 5264 + (i6 * 96 | 0) + 16 >> 1] | 0) != 0; else i7 = 0;
    i5 = HEAP32[i13 + 8336 + (i6 << 2) >> 2] | 0;
    if (i5) {
     i19 = i14 + (i9 << 2) | 0;
     i20 = HEAP32[i19 >> 2] | 0;
     HEAP32[i19 >> 2] = i5 >>> 0 < i20 >>> 0 ? i20 : i5;
     i4 = i5 + i4 | 0;
     if (i7) {
      i20 = HEAPU16[i13 + 5264 + (i6 * 96 | 0) + 16 >> 1] << 1;
      i19 = i15 + (i9 << 2) | 0;
      i7 = HEAP32[i19 >> 2] | 0;
      HEAP32[i19 >> 2] = i20 >>> 0 < i7 >>> 0 ? i7 : i20;
      i4 = i20 + i4 | 0;
     }
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i3 >>> 0);
  }
  i3 = i3 >>> 0 < i10 >>> 0 ? i10 : i3;
  HEAP32[i12 + (i11 << 2) >> 2] = i4;
  i11 = i11 + 1 | 0;
  if ((i11 | 0) == 4) {
   i7 = i1;
   i6 = i2;
   i5 = i3;
   break;
  } else i10 = i3;
 }
 i3 = (i5 | 0) == 0;
 if (i3) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
 } else {
  i2 = 0;
  i1 = 0;
  do {
   i1 = ((HEAP32[i15 + (i2 << 2) >> 2] | 0) != 0 & 1) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  i4 = i1 << 7;
  if (i3) {
   i3 = 0;
   i2 = 0;
  } else {
   i1 = 0;
   i3 = 0;
   i2 = 0;
   do {
    i3 = (HEAP32[i14 + (i1 << 2) >> 2] | 0) + i3 | 0;
    i2 = (HEAP32[i15 + (i1 << 2) >> 2] | 0) + i2 | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 i1 = i5 * 144 | 0;
 if (!((HEAP16[(HEAP32[i17 + 56 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i17 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i17 + 112 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i17 + 168 >> 2] | 0) + 22 >> 1]) & 64)) {
  i20 = (i2 << 7) + (i3 * 144 | 0) | 0;
  i17 = i2 + i3 | 0;
  i17 = i17 << 4;
  i15 = i3 << 4;
  i15 = i7 ? i15 : 0;
  i19 = i2 << 4;
  i19 = i6 ? i19 : 0;
  i14 = i1 | 15;
  i14 = i14 + i4 | 0;
  i15 = i14 + i15 | 0;
  i17 = i15 + i17 | 0;
  i19 = i17 + i19 | 0;
  i20 = i19 + i20 | 0;
  i20 = i20 & -16;
  HEAP32[i16 >> 2] = i20;
  STACKTOP = i18;
  return;
 } else {
  i20 = (i2 * 224 | 0) + (i3 * 240 | 0) | 0;
  i17 = i2 + i3 | 0;
  i17 = i17 << 4;
  i15 = i3 << 4;
  i15 = i7 ? i15 : 0;
  i19 = i2 << 4;
  i19 = i6 ? i19 : 0;
  i14 = i1 | 15;
  i14 = i14 + i4 | 0;
  i15 = i14 + i15 | 0;
  i17 = i15 + i17 | 0;
  i19 = i17 + i19 | 0;
  i20 = i19 + i20 | 0;
  i20 = i20 & -16;
  HEAP32[i16 >> 2] = i20;
  STACKTOP = i18;
  return;
 }
}

function __ZNSt3__24moveI10InputEventPS1_RS1_PS2_iLi0ES1_S2_S3_S4_iLi0EEENS_16__deque_iteratorIT5_T6_T7_T8_T9_XT10_EEENS5_IT_T0_T1_T2_T3_XT4_EEESH_SB_(i20, i17, i1, i18) {
 i20 = i20 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i21 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i19 = i17 + 4 | 0;
 i5 = HEAP32[i19 >> 2] | 0;
 i3 = i5;
 if ((i2 | 0) != (i5 | 0)) {
  i16 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i17 >> 2] | 0;
  i1 = ((i16 - i1 >> 2) * 78 | 0) + ((i2 - (HEAP32[i16 >> 2] | 0) | 0) / 52 | 0) + ((i3 - (HEAP32[i1 >> 2] | 0) | 0) / -52 | 0) | 0;
  if ((i1 | 0) > 0) {
   i4 = i18;
   i16 = i1;
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i4 = HEAP32[i17 >> 2] | 0;
   do {
    i12 = (HEAP32[i4 >> 2] | 0) + 4056 | 0;
    i15 = (i12 - i5 | 0) / 52 | 0;
    i14 = (i15 | 0) > (i16 | 0);
    i12 = i14 ? i5 + (i16 * 52 | 0) | 0 : i12;
    i15 = i14 ? i16 : i15;
    if ((i5 | 0) != (i12 | 0)) {
     i14 = i12;
     i13 = i5;
     i11 = i2;
     i10 = i1;
     i9 = i1;
     while (1) {
      i7 = ((HEAP32[i11 >> 2] | 0) + 4056 - i10 | 0) / 52 | 0;
      i8 = (i14 - i13 | 0) / 52 | 0;
      i21 = (i8 | 0) > (i7 | 0);
      i8 = i21 ? i7 : i8;
      i6 = i13;
      i13 = i21 ? i13 + (i7 * 52 | 0) | 0 : i12;
      if ((i6 | 0) != (i13 | 0)) {
       i7 = i10;
       while (1) {
        __ZN10InputEventaSERKS_(i7, i6);
        i6 = i6 + 52 | 0;
        if ((i6 | 0) == (i13 | 0)) break; else i7 = i7 + 52 | 0;
       }
      }
      do if (!i8) {
       i8 = i9;
       i6 = i11;
       i7 = i10;
      } else {
       i1 = ((i9 - (HEAP32[i11 >> 2] | 0) | 0) / 52 | 0) + i8 | 0;
       if ((i1 | 0) > 0) {
        i2 = i11 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
        i7 = (HEAP32[i2 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
        i1 = i7;
        i8 = i1;
        i6 = i2;
        break;
       } else {
        i7 = 77 - i1 | 0;
        i2 = i11 + (((i7 | 0) / -78 | 0) << 2) | 0;
        i7 = (HEAP32[i2 >> 2] | 0) + ((77 - ((i7 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
        i1 = i7;
        i8 = i1;
        i6 = i2;
        break;
       }
      } while (0);
      if ((i13 | 0) == (i12 | 0)) break; else {
       i11 = i6;
       i10 = i7;
       i9 = i8;
      }
     }
    }
    i21 = i18;
    HEAP32[i21 >> 2] = i2;
    HEAP32[i21 + 4 >> 2] = i1;
    i16 = i16 - i15 | 0;
    do if (i15) {
     i3 = ((i3 - (HEAP32[i4 >> 2] | 0) | 0) / 52 | 0) + i15 | 0;
     if ((i3 | 0) > 0) {
      i4 = i4 + (((i3 >>> 0) / 78 | 0) << 2) | 0;
      HEAP32[i17 >> 2] = i4;
      i5 = (HEAP32[i4 >> 2] | 0) + (((i3 >>> 0) % 78 | 0) * 52 | 0) | 0;
      HEAP32[i19 >> 2] = i5;
      i3 = i5;
      break;
     } else {
      i5 = 77 - i3 | 0;
      i4 = i4 + (((i5 | 0) / -78 | 0) << 2) | 0;
      HEAP32[i17 >> 2] = i4;
      i5 = (HEAP32[i4 >> 2] | 0) + ((77 - ((i5 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
      HEAP32[i19 >> 2] = i5;
      i3 = i5;
      break;
     }
    } while (0);
   } while ((i16 | 0) > 0);
   i21 = i20;
   i20 = i21;
   HEAP32[i20 >> 2] = i2;
   i21 = i21 + 4 | 0;
   HEAP32[i21 >> 2] = i1;
   return;
  }
 }
 i19 = i18;
 i18 = HEAP32[i19 >> 2] | 0;
 i19 = HEAP32[i19 + 4 >> 2] | 0;
 i21 = i20;
 i20 = i21;
 HEAP32[i20 >> 2] = i18;
 i21 = i21 + 4 | 0;
 HEAP32[i21 >> 2] = i19;
 return;
}

function __ZN15NavMeshSettings12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 2312 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 1544 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3770 | 0)) {
    i4 = i6 + 1544 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 1544 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 1544 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 1544 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 1544 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 1544 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 1544 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 1544 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 4628 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L12 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 3860 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 905 | 0)) {
    i4 = i6 + 3860 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 3860 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L12;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 3860 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 3860 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 3860 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 3860 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 6172 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L23 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 5404 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3771 | 0)) {
    i4 = i6 + 5404 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 5404 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L23;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 5404 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 5404 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 5404 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 5404 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 5404 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 5404 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = HEAP32[gb + 1459032 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63704 | 0);
  HEAP32[gb + 1459032 >> 2] = 0;
  return;
 }
 __ZN14NavMeshManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63704 | 0);
 HEAP32[gb + 1459032 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i7 = i9;
 i8 = (HEAP32[i1 >> 2] | 0) - i7 >> 4;
 i14 = i9 + (i8 << 4) | 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = i11 + 8 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 i6 = i10;
 if (i1 >>> 0 < i10 >>> 0) {
  if ((i14 | 0) == (i1 | 0)) {
   HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 16;
   return i14 | 0;
  }
  i5 = i2 - (i14 + 16) >> 4;
  i2 = i14 + (i5 << 4) | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   i4 = i2;
   i3 = i1;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    i4 = i4 + 16 | 0;
    i3 = (HEAP32[i13 >> 2] | 0) + 16 | 0;
    HEAP32[i13 >> 2] = i3;
   } while (i4 >>> 0 < i1 >>> 0);
  } else i3 = i1;
  if (i5 | 0) do {
   i13 = i1;
   i1 = i1 + -16 | 0;
   i11 = i2;
   i2 = i2 + -16 | 0;
   i6 = i2;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 4 >> 2] = i7;
   HEAP32[i13 + -8 >> 2] = HEAP32[i11 + -8 >> 2];
  } while ((i2 | 0) != (i14 | 0));
  i13 = i14 >>> 0 > i12 >>> 0 ? i12 : i3 >>> 0 > i12 >>> 0 ? i12 + 16 | 0 : i12;
  i10 = i13;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i14;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i9 + (i8 << 4) + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  return i14 | 0;
 }
 i3 = (i2 - i7 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 >> 2] | 0;
  i10 = i4;
  i5 = i2;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i10 = i4;
  i5 = i9;
  i1 = i6;
  i2 = i7;
 }
 i9 = i1 - i2 | 0;
 i7 = i9 >> 3;
 i7 = i9 >> 4 >>> 0 < 134217727 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 268435455;
 i9 = i14;
 i4 = i9 - i2 | 0;
 i6 = i4 >> 4;
 if (!i7) i8 = 0; else i8 = __Znwj(i7 << 4) | 0;
 i1 = i8 + (i6 << 4) | 0;
 i2 = i1;
 i3 = i8 + (i7 << 4) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i4 | 0) > 0) {
   i1 = i1 + (((i7 + 1 | 0) / -2 | 0) << 4) | 0;
   i2 = i1;
   break;
  }
  i3 = i7 << 4 >> 3;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  i7 = __Znwj(i3 << 4) | 0;
  i1 = i7 + (i3 >>> 2 << 4) | 0;
  i2 = i1;
  i3 = i7 + (i3 << 4) | 0;
  if (i8) {
   __ZdlPv(i8);
   i5 = HEAP32[i11 >> 2] | 0;
  }
 } while (0);
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i1 = i2 + 16 | 0;
 i4 = i2;
 i2 = i9 - i5 | 0;
 i6 = i4 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i6 | 0, i5 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 4 << 4) | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i10 >> 2] = i3;
 if (!i2) {
  i14 = i4;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i4;
 return i14 | 0;
}

function __ZN16Physics2DManager14CapsuleCastAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i3, i9, i11, f12, i2, f13, i14, f15, f16, i7, i8, i17) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i2 = i2 | 0;
 f13 = Math_fround(f13);
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 f16 = Math_fround(f16);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i17 = i17 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i10 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i20 + 568 | 0;
 i18 = i20;
 if ((HEAP16[gb + 1457716 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457716 | 0, i1);
  i19 = gb + 1457716 | 0;
 } else i19 = 0;
 if (!(Math_fround(HEAPF32[i9 >> 2]) <= Math_fround(.0000999999974))) if (!(Math_fround(HEAPF32[i9 + 4 >> 2]) <= Math_fround(.0000999999974))) {
  i10 = f13 == Math_fround(inf);
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f6 * f6);
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f5 * f5));
  if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f6 = Math_fround(f6 * f4);
  f5 = Math_fround(f5 * f4);
  f13 = i10 ? Math_fround(1.0e5) : f13;
  f6 = Math_fround(f13 * f6);
  f13 = Math_fround(f13 * f5);
  f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f6);
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i3 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i1 + 4 >> 2] = f13;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i18, i3, i1, Math_fround(f12 * Math_fround(.0174532924)), i14, f15, f16, i7, i8, i17);
  HEAP32[i18 >> 2] = gb + 158712 + 8;
  HEAP32[i18 + 372 >> 2] = gb + 151688 + 8;
  HEAP32[i18 + 400 >> 2] = gb + 151728 + 8;
  HEAP32[i18 + 404 >> 2] = 2;
  i14 = HEAP32[gb + 151644 >> 2] | 0;
  HEAP32[i18 + 408 >> 2] = i14;
  HEAP32[i18 + 548 >> 2] = 0;
  HEAPF32[i18 + 412 >> 2] = Math_fround(0.0);
  HEAPF32[i18 + 416 >> 2] = Math_fround(0.0);
  HEAP32[i18 + 376 >> 2] = 4;
  HEAP32[i18 + 380 >> 2] = i14;
  i14 = i18 + 384 | 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  i14 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = i18 + 552 | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = i14;
  HEAP32[i18 + 560 >> 2] = i11;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i18, 0) | 0;
  if (!((i1 | 0) == 0 | i10 ^ 1)) {
   i2 = HEAP32[i17 + 12 >> 2] | 0;
   if (i2 | 0) {
    i17 = HEAP32[i17 >> 2] | 0;
    i3 = i17 + (i2 * 36 | 0) | 0;
    i2 = i17;
    do {
     i17 = i2 + 28 | 0;
     HEAPF32[i17 >> 2] = Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(1.0e5));
     i2 = i2 + 36 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
  }
  HEAP32[i18 >> 2] = gb + 156124 + 8;
  i2 = i18 + 340 | 0;
  if ((HEAP32[i18 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i18 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i18 + 268 | 0);
 } else i1 = 0; else i1 = 0;
 if (!i19) {
  STACKTOP = i20;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN5physx2Cm8PtrTable17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 138980 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 138980 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 138980 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 138980 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 138980 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 138980 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 138980 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 138980 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 139012 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 139012 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 139012 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 139012 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 139012 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 139012 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 139012 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 139012 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 139044 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 139044 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 139044 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 139044 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 139044 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 139044 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 139044 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 139044 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 139076 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 139076 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 139076 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 139076 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 139076 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 139076 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 139076 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 139076 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 139108 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 139108 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 139108 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 139108 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 139108 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 139108 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 139108 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 139108 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 139140 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 139140 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 139140 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 139140 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 139140 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 139140 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 139140 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 139140 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4Tree18OnWillRenderObjectEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 40 | 0;
 i7 = i13 + 24 | 0;
 i8 = i13 + 12 | 0;
 i9 = i13;
 i10 = i6 + 28 | 0;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 31312 | 0) | 0;
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 i4 = i6 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i12 = 12; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
    i2 = HEAP32[i5 >> 2] | 0;
    i14 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i12 = 10;
   }
  }
  if ((i12 | 0) == 8) i12 = 10;
  if ((i12 | 0) == 10) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i12 = 12;
    break;
   }
  }
  i1 = (__ZN4Tree30ComputeSpeedTreeWindPropertiesERK18SpeedTreeWindAsset(i6, i1) | 0) & 1;
 } while (0);
 if ((i12 | 0) == 12) {
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i11 + 32 | 0, i5);
  __ZN11WindManager16ComputeWindForceERK4AABB(i7, __ZN11WindManager11GetInstanceEv() | 0, i5);
  i2 = __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i11) | 0;
  __ZN19ShaderPropertySheet5ClearEb(i2, 1);
  i14 = Math_fround(HEAPF32[i7 >> 2]) != Math_fround(0.0);
  i1 = i7 + 4 | 0;
  if (i14 | Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0)) i12 = 15; else if (Math_fround(HEAPF32[i7 + 8 >> 2]) != Math_fround(0.0)) i12 = 15; else if (Math_fround(HEAPF32[i7 + 12 >> 2]) != Math_fround(0.0)) i12 = 15;
  if ((i12 | 0) == 15) {
   i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0;
   i12 = HEAP32[i1 >> 2] | 0;
   i10 = i7 + 8 | 0;
   i14 = HEAP32[i10 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i12;
   HEAP32[i9 + 8 >> 2] = i14;
   __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i8, i6, i9);
   i6 = HEAP32[i8 + 4 >> 2] | 0;
   i9 = HEAP32[i8 + 8 >> 2] | 0;
   i14 = i7 + 12 | 0;
   i12 = HEAP32[i14 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 >> 2] = i6;
   HEAP32[i10 >> 2] = i9;
   HEAP32[i14 >> 2] = i12;
  }
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467736 | 0, i7, 0);
  __ZN19ShaderPropertySheet11ComputeHashEv(i2);
  i1 = 0;
 }
 if ((((HEAP32[i11 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30912 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30912 + 28 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 HEAP8[i11 + 348 >> 0] = i1;
 STACKTOP = i13;
 return;
}

function __ZN3MBP12addBoxPrunerERKN5physx18PxBroadPhaseRegionEb(i11, i10, i9) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12;
 i1 = i11 + 16 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == -1) {
  i5 = i11 + 8 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 > 255) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 717183 | 0, 2716, gb + 717647 | 0, i2);
   i11 = -1;
   STACKTOP = i12;
   return i11 | 0;
  }
  HEAP32[i5 >> 2] = i3 + 1;
  i2 = i11 + 20 | 0;
  i4 = i11 + 24 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 + 10 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
   __ZN5physx2Gu9Container6ResizeEj(i2, 10) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i8 = i11 + 28 | 0;
  i7 = (HEAP32[i8 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i4 >> 2] = i1 + 10;
 } else {
  i8 = i11 + 28 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i7 + (i3 * 40 | 0) + 36 >> 2];
  i5 = i11 + 8 | 0;
  i7 = i7 + (i3 * 40 | 0) | 0;
 }
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i2 | 0, i1 | 0, 13008, (i6 ? gb + 717697 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 2724) | 0;
 i1 = i6 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP8[i6 + 28 >> 0] = 0;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = -1;
 i1 = i6 + 132 | 0;
 i2 = i6 + 76 | 0;
 i4 = i2 + 56 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i1);
 HEAP8[i6 + 168 >> 0] = 0;
 HEAP8[i6 + 169 >> 0] = 1;
 i1 = i6 + 12976 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = i7 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 HEAP32[i1 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 i4 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 i4 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i7 + 16 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i7 + 20 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 i4 = HEAP32[i10 + 20 >> 2] | 0;
 HEAP32[i7 + 24 >> 2] = ((i4 | 0) < 0 ? i4 ^ -2 : i4 | -2147483648) >>> 1;
 HEAP32[i7 + 28 >> 2] = i6;
 HEAP32[i7 + 36 >> 2] = HEAP32[i10 + 24 >> 2];
 __ZL17setupOverlapFlagsjP13BoxPrunerData(HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 if (!i9) {
  i11 = i3;
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZN3MBP17populateNewRegionERK5IAABB(i11, i1);
 i11 = i3;
 STACKTOP = i12;
 return i11 | 0;
}

function __Z27CubicPolynomialRootsGenericPfdddd(i14, d11, d12, d13, d1) {
 i14 = i14 | 0;
 d11 = +d11;
 d12 = +d12;
 d13 = +d13;
 d1 = +d1;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 8 | 0;
 i3 = i15;
 if (!((d11 < 0.0 ? -d11 : d11) >= 9.999999747378752e-05)) {
  f6 = Math_fround(d12);
  f4 = Math_fround(d13);
  f2 = Math_fround(d1);
  i3 = i14 + 4 | 0;
  i5 = f6 < Math_fround(0.0);
  f16 = Math_fround(-f6);
  if ((i5 ? f16 : f6) < Math_fround(9.99999974e-06)) {
   i5 = f4 < Math_fround(0.0);
   f16 = Math_fround(-f4);
   if (!((i5 ? f16 : f4) > Math_fround(9.99999974e-06))) {
    i14 = 0;
    STACKTOP = i15;
    return i14 | 0;
   }
   HEAPF32[i14 >> 2] = Math_fround(Math_fround(-f2) / f4);
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  } else {
   f2 = Math_fround(Math_fround(f4 * f4) - Math_fround(Math_fround(f6 * Math_fround(4.0)) * f2));
   if (f2 < Math_fround(0.0)) {
    i14 = 0;
    STACKTOP = i15;
    return i14 | 0;
   }
   f6 = Math_fround(Math_fround(.5) / f6);
   f16 = Math_fround(Math_sqrt(Math_fround(f2)));
   HEAPF32[i14 >> 2] = Math_fround(f6 * Math_fround(f16 - f4));
   HEAPF32[i3 >> 2] = Math_fround(f6 * Math_fround(Math_fround(-f16) - f4));
   i14 = 2;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 d7 = d13 / d11;
 d10 = d12 / d11 * .3333333333333333;
 d9 = d10 * d10;
 d1 = d1 / d11 * .5 + (d10 * d9 - d10 * d7 * .5);
 d9 = d7 * .3333333333333333 - d9;
 d7 = d9 * (d9 * d9);
 d8 = d7 + d1 * d1;
 if (d8 > 0.0) {
  d1 = +Math_sqrt(+d8) - d1;
  if (d1 > 0.0) d1 = +Math_pow(+d1, .3333333333333333); else d1 = -+Math_pow(+-d1, .3333333333333333);
  d1 = d1 + (-d10 - d9 / d1);
  HEAPF64[i5 >> 3] = d1;
 } else {
  d7 = +Math_sqrt(+-d7);
  d1 = +Math_acos(+(-d1 / d7));
  d7 = +Math_pow(+d7, .3333333333333333);
  d7 = d7 - d9 / d7;
  d9 = +Math_cos(+(d1 * .3333333333333333)) * d7 - d10;
  HEAPF64[i5 >> 3] = d9;
  d8 = d7 * +Math_cos(+((d1 + 6.2831854820251465) * .3333333333333333)) - d10;
  HEAPF64[i3 >> 3] = d8;
  d1 = d7 * +Math_cos(+((d1 + 12.566370964050293) * .3333333333333333)) - d10;
  d1 = d8 < d1 ? d1 : +HEAPF64[i3 >> 3];
  d1 = d9 < d1 ? d1 : +HEAPF64[i5 >> 3];
 }
 f4 = Math_fround(d1);
 HEAPF32[i14 >> 2] = f4;
 d9 = +f4;
 d10 = d9 * d11;
 f4 = Math_fround(d11);
 f6 = Math_fround(d10 + d12);
 f2 = Math_fround(d9 * d12 + d13 + d9 * d10);
 i5 = i14 + 4 | 0;
 i3 = i14 + 8 | 0;
 i14 = f4 < Math_fround(0.0);
 f16 = Math_fround(-f4);
 if ((i14 ? f16 : f4) < Math_fround(9.99999974e-06)) {
  i14 = f6 < Math_fround(0.0);
  f16 = Math_fround(-f6);
  if (!((i14 ? f16 : f6) > Math_fround(9.99999974e-06))) {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(-f2) / f6);
  i14 = 2;
  STACKTOP = i15;
  return i14 | 0;
 } else {
  f2 = Math_fround(Math_fround(f6 * f6) - Math_fround(Math_fround(f4 * Math_fround(4.0)) * f2));
  if (f2 < Math_fround(0.0)) {
   i14 = 1;
   STACKTOP = i15;
   return i14 | 0;
  }
  f4 = Math_fround(Math_fround(.5) / f4);
  f16 = Math_fround(Math_sqrt(Math_fround(f2)));
  HEAPF32[i5 >> 2] = Math_fround(f4 * Math_fround(f16 - f6));
  HEAPF32[i3 >> 2] = Math_fround(f4 * Math_fround(Math_fround(-f16) - f6));
  i14 = 3;
  STACKTOP = i15;
  return i14 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIP18SpeedTreeLocalWind13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i12 >> 2] | 0;
 i3 = i14;
 i14 = i14 + ((HEAP32[i2 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i15 = i12 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i6;
 i5 = i11;
 if (i6 >>> 0 < i11 >>> 0) {
  if ((i14 | 0) == (i6 | 0)) {
   HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 4;
   i15 = i14;
   STACKTOP = i16;
   return i15 | 0;
  }
  i4 = i2 - (i14 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i14 + (i5 << 2) | 0;
  if (i2 >>> 0 < i6 >>> 0) {
   i3 = i6;
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    i3 = (HEAP32[i15 >> 2] | 0) + 4 | 0;
    HEAP32[i15 >> 2] = i3;
   } while (i2 >>> 0 < i6 >>> 0);
  }
  if (i5 | 0) _memmove(i6 + (0 - i5 << 2) | 0, i14 | 0, i4 | 0) | 0;
  if (i14 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i15 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = i12 + 12 | 0;
 i10 = i2 - i3 | 0;
 i6 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i10 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else {
  i10 = i4;
  i2 = i5;
 }
 i9 = i2 - i3 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i6 >>> 0 ? i6 : i7) : 2147483647;
 i9 = i14;
 i5 = i9 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i8 = 0; else {
  i8 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 62;
  HEAP32[i13 + 4 >> 2] = i8;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i8 + (i6 << 2) | 0;
 i3 = i2;
 i4 = i8 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i2 = i2 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i3 = i2;
   break;
  }
  i4 = i7 << 2 >> 1;
  i4 = (i4 | 0) == 0 ? 1 : i4;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = 62;
  HEAP32[i13 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i7 + (i4 >>> 2 << 2) | 0;
  i3 = i2;
  i4 = i7 + (i4 << 2) | 0;
  if (i8) {
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 >> 2] = 62;
   HEAP32[i13 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i13);
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i5 = i9 - i2 | 0;
 i6 = i3 + (0 - (i5 >> 2) << 2) | 0;
 if ((i5 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i5 | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 if (!i2) {
  i15 = i3;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = 62;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i3;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
 i5 = i8 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i9 >> 2] = i4;
  i1 = i3;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = i8 + 56 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i8 + 60 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i8 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 68 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 69 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx27PxsFluidParticleOpcodeCache5writeERtRKNS_9PxBounds3ERKNS0_18QuantizationParamsERKNS_2Gu13GeometryUnionEb(i13, i16, i10, i11, i17, i12) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0;
 i15 = i13 + 28 | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 if (i12) {
  i1 = HEAP8[i13 >> 0] | 0;
  if ((i1 & 255) < 2) {
   if (!(i1 << 24 >> 24)) i1 = 0; else i1 = HEAP32[i14 >> 2] & 65535;
   HEAP16[i13 + 2 >> 1] = i1;
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i10 + 16 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i10 + 20 >> 2];
  } else i2 = 6;
 } else i2 = 6;
 L7 : do if ((i2 | 0) == 6) {
  i2 = i13 + 1 | 0;
  i3 = i13 + 2 | 0;
  i1 = i13 + 16 | 0;
  f19 = Math_fround(HEAPF32[i10 >> 2]);
  i18 = i10 + 12 | 0;
  f19 = Math_fround(f19 + Math_fround(HEAPF32[i18 >> 2]));
  i6 = i10 + 4 | 0;
  f5 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i10 + 16 | 0;
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 >> 2]));
  i8 = i10 + 8 | 0;
  f4 = Math_fround(HEAPF32[i8 >> 2]);
  i9 = i10 + 20 | 0;
  f5 = Math_fround(f5 * Math_fround(.5));
  f4 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i9 >> 2])) * Math_fround(.5));
  HEAPF32[i13 + 4 >> 2] = Math_fround(f19 * Math_fround(.5));
  HEAPF32[i13 + 8 >> 2] = f5;
  HEAPF32[i13 + 12 >> 2] = f4;
  f4 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(HEAPF32[i18 >> 2]);
  if (f4 > f5) {
   HEAP8[i2 >> 0] = 0;
   HEAP8[i3 >> 0] = 0;
   i2 = 0;
  } else {
   f4 = Math_fround(f5 - f4);
   f5 = Math_fround(HEAPF32[i7 >> 2]);
   f5 = Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2]));
   f19 = Math_fround(HEAPF32[i9 >> 2]);
   f4 = Math_fround(f4 * Math_fround(.5));
   f5 = Math_fround(f5 * Math_fround(.5));
   f19 = Math_fround(Math_fround(f19 - Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
   i18 = i11 + 4 | 0;
   HEAP8[i2 >> 0] = ~~Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i18 >> 2])) + Math_fround(1.0));
   HEAP8[i3 >> 0] = ~~Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i18 >> 2])) + Math_fround(1.0));
   i2 = ~~Math_fround(Math_fround(f19 * Math_fround(HEAPF32[i18 >> 2])) + Math_fround(1.0)) & 255;
  }
  HEAP8[i13 + 3 >> 0] = i2;
  i2 = HEAP8[i13 >> 0] | 0;
  if (i12) {
   if ((i2 & 255) < 7) {
    i3 = i2 & 255;
    if (!(i2 << 24 >> 24)) break;
    i2 = 0;
    while (1) {
     HEAP16[i1 >> 1] = HEAP32[i14 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break L7; else i1 = i1 + 2 | 0;
    }
   }
   if ((i2 & 255) < 10) {
    if (__ZN5physx27PxsFluidParticleOpcodeCache28writeTriangles_BaseU16_9xU10EPhPKjj(i1, i14, i2 & 255) | 0) break;
    HEAP16[i16 >> 1] = (HEAPU16[i16 >> 1] | 0) & 65487;
    return;
   }
  } else if ((i2 & 255) < 4) {
   i3 = i2 & 255;
   if (!(i2 << 24 >> 24)) break;
   i2 = 0;
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i14 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break L7; else i1 = i1 + 4 | 0;
   }
  }
  HEAP16[i16 >> 1] = (HEAPU16[i16 >> 1] | 0) & 65487;
  return;
 } while (0);
 HEAP16[i16 >> 1] = HEAPU16[i16 >> 1] | 0 | 48;
 HEAP32[i15 >> 2] = i17;
 return;
}

function __ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i8 = i5 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i9 = i5 + 1636 | 0;
 i10 = i5 + 28 | 0;
 i11 = i5 + 16 | 0;
 i12 = i5 + 20 | 0;
 i13 = i5 + 4 | 0;
 i7 = i5 + 8 | 0;
 while (1) {
  if (HEAP8[i9 >> 0] | 0) HEAP8[i9 >> 0] = 0;
  i3 = HEAP8[i5 + 36 + (i1 * 40 | 0) + 29 >> 0] | 0;
  if (i3 << 24 >> 24 == 3) break;
  i3 = i3 & 255;
  i4 = HEAP32[i5 + 36 + (i1 * 40 | 0) + 12 >> 2] | 0;
  if ((HEAP32[i10 >> 2] | 0) > (i4 | 0)) f2 = Math_fround(HEAPF32[(HEAP32[i11 >> 2] | 0) + (HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2]); else {
   f2 = Math_fround(HEAPF32[i5 + 36 + (i1 * 40 | 0) + (i3 << 2) >> 2]);
   f2 = Math_fround(Math_fround(f2 + Math_fround(HEAPF32[i5 + 36 + (i1 * 40 | 0) + 16 + (i3 << 2) >> 2])) * Math_fround(.5));
  }
  i17 = i5 + 36 + ((i1 + 1 | 0) * 40 | 0) | 0;
  i1 = i5 + 36 + (i1 * 40 | 0) | 0;
  HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i17 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i17 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i17 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  i1 = HEAP32[i8 >> 2] | 0;
  i17 = i5 + 36 + (i1 * 40 | 0) + 12 | 0;
  i16 = __ZNK5Umbra6KDTree4rankEi(i13, HEAP32[i17 >> 2] | 0) | 0;
  i15 = i16 << 1;
  i4 = i5 + 36 + (i1 * 40 | 0) + 29 | 0;
  i3 = HEAPU8[i4 >> 0] | 0;
  HEAP32[i17 >> 2] = i15;
  i16 = i16 << 2;
  HEAP8[i4 >> 0] = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i16 >> 5 << 2) >> 2] | 0) >>> (i16 & 28) & 3;
  HEAP32[i5 + 36 + (i1 * 40 | 0) + 32 >> 2] = 2;
  HEAPF32[i5 + 36 + (i1 * 40 | 0) + (i3 << 2) >> 2] = f2;
  i4 = i5 + 36 + (i1 * 40 | 0) + 28 | 0;
  HEAP8[i4 >> 0] = (HEAP8[i4 >> 0] | 0) + 1 << 24 >> 24;
  i4 = i3 << 1;
  i1 = i5 + 36 + (i1 * 40 | 0) + 30 | 0;
  HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & (1 << i4 ^ 255);
  i1 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  i15 = i15 + -1 | 0;
  HEAP32[i5 + 36 + (i1 * 40 | 0) + 12 >> 2] = i15;
  i15 = i15 << 1;
  HEAP8[i5 + 36 + (i1 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i15 >> 5 << 2) >> 2] | 0) >>> (i15 & 30) & 3;
  HEAP32[i5 + 36 + (i1 * 40 | 0) + 32 >> 2] = 1;
  HEAPF32[i5 + 36 + (i1 * 40 | 0) + 16 + (i3 << 2) >> 2] = f2;
  i3 = i5 + 36 + (i1 * 40 | 0) + 28 | 0;
  HEAP8[i3 >> 0] = (HEAP8[i3 >> 0] | 0) + 1 << 24 >> 24;
  i1 = i5 + 36 + (i1 * 40 | 0) + 30 | 0;
  HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & (2 << i4 ^ 255);
  i1 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i1;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i14 = 11;
   break;
  }
 }
 if ((i14 | 0) == 11) return i1 | 0;
 i17 = i5 + 36 + (i1 * 40 | 0) | 0;
 HEAP32[i6 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 i17 = 1;
 return i17 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i17 = i4 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i19 = i4 + 8 | 0;
 i21 = i2 + 8 | 0;
 i16 = HEAP16[i21 >> 1] | 0;
 HEAP8[i19 >> 0] = i16;
 i11 = i4 + 9 | 0;
 HEAP8[i11 >> 0] = (i16 & 65535) >>> 8;
 i16 = i4 + 12 | 0;
 i20 = i2 + 12 | 0;
 i12 = i20;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i15;
 i10 = i4 + 20 | 0;
 i15 = i2 + 20 | 0;
 i12 = i15;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i10;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i4, i2, 0);
 i18 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i18;
 i17 = HEAP8[i21 >> 0] | 0;
 i18 = HEAP16[i19 >> 1] | 0;
 HEAP8[i21 >> 0] = i18;
 HEAP8[i19 >> 0] = i17;
 i19 = i2 + 9 | 0;
 i17 = HEAP8[i19 >> 0] | 0;
 HEAP8[i19 >> 0] = (i18 & 65535) >>> 8;
 HEAP8[i11 >> 0] = i17;
 i11 = i20;
 i17 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i19 = i16;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = i16;
 HEAP32[i1 >> 2] = i17;
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = i15;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = i10;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i1;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 127;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i19 = i4 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i17 = i4 + 8 | 0;
 i20 = i2 + 8 | 0;
 i18 = HEAP16[i20 >> 1] | 0;
 HEAP8[i17 >> 0] = i18;
 i10 = i4 + 9 | 0;
 HEAP8[i10 >> 0] = (i18 & 65535) >>> 8;
 i18 = i4 + 12 | 0;
 i15 = i2 + 12 | 0;
 i12 = i15;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 + 4 >> 2] = i11;
 i16 = i4 + 20 | 0;
 i11 = i2 + 20 | 0;
 i12 = i11;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i16;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j(i4, i2, 0);
 i21 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i19 >> 2] = i21;
 i1 = HEAP8[i20 >> 0] | 0;
 i19 = HEAP16[i17 >> 1] | 0;
 HEAP8[i20 >> 0] = i19;
 HEAP8[i17 >> 0] = i1;
 i17 = i2 + 9 | 0;
 i1 = HEAP8[i17 >> 0] | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 HEAP8[i10 >> 0] = i1;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i10 = HEAP32[i2 + 24 >> 2] | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i4 + 20 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = i10;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i17, i3, i1) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 8 | 0;
 i12 = i16 + 24 | 0;
 i13 = i16;
 i2 = i16 + 16 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i16;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i15 = HEAP32[i1 >> 2] | 0;
 L4 : do if (HEAP32[i2 >> 2] | 0) {
  i11 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, 0, 1) | 0;
  i8 = i17 + 80 | 0;
  i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i8 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i10 = i17 + 84 | 0;
  HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
  if ((i11 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) == (i15 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags(i17, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i15 | 0)) break L4;
   }
  }
  i2 = HEAP32[i8 >> 2] | 0;
  i11 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  L11 : do if ((i1 | 0) != (i15 | 0)) {
   i4 = i12 + 12 | 0;
   i5 = i12 + 11 | 0;
   i6 = i12 + 12 | 0;
   i7 = i14 + 4 | 0;
   i3 = 0;
   while (1) {
    i18 = (Math_imul(i3, i9) | 0) + i11 | 0;
    HEAP32[i2 + 20 >> 2] = i18;
    HEAP32[i2 + 12 >> 2] = i18;
    __ZNK16TypeTreeIterator8ChildrenEv(i14, i2);
    i18 = i14;
    i19 = HEAP32[i18 + 4 >> 2] | 0;
    i3 = i2 + 24 | 0;
    HEAP32[i3 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i3 + 4 >> 2] = i19;
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    HEAP32[i4 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i17, i12, 1);
    i3 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
    i19 = gb + 63648 | 0;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i2 = i13;
    HEAP32[i2 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i2 + 4 >> 2] = i18;
    HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    __ZN14ConstantString6assignEPKc10MemLabelId(i1, i3, i14);
    if ((HEAP8[i5 >> 0] | 0) < 0) {
     i19 = HEAP32[i12 >> 2] | 0;
     i18 = HEAP32[i6 >> 2] | 0;
     HEAP32[i14 >> 2] = 1;
     HEAP32[i7 >> 2] = i18;
     __Z19free_alloc_internalPvRK10MemLabelId(i19, i14);
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i15 | 0)) break L11;
    i3 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb(i8, f9, i3, i2, f11, i12, i13, i1) {
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i3 = i3 | 0;
 i2 = i2 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f4 = f0, i5 = 0, f6 = f0, i7 = 0, i10 = 0;
 i1 = HEAP32[i8 + 92 >> 2] | 0;
 if (i1 | 0) {
  HEAP8[i12 >> 0] = i1;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  return;
 }
 i5 = HEAP32[i8 + 20 >> 2] | 0;
 if (i5 >>> 0 > i3 >>> 0 ? !(Math_fround(HEAPF32[i8 + 16 >> 2]) <= f9) : 0) {
  i10 = i2;
  i1 = i3;
 } else {
  if (i5 | 0) if ((HEAP32[i8 + 56 + (i5 + -1 << 2) >> 2] & -3 | 0) == -2147483647) {
   i1 = 1 << i5 & 255;
   if (!(f11 <= Math_fround(0.0))) {
    i10 = (i1 & 255) >>> 1;
    i2 = HEAP8[i12 >> 0] | 0;
    i3 = i10 | i1;
    if (i2 << 24 >> 24 == i10 << 24 >> 24) {
     HEAP8[i12 >> 0] = i3;
     HEAPF32[i13 >> 2] = Math_fround(1.0);
     return;
    }
    if (i2 << 24 >> 24 == i3 << 24 >> 24) {
     f11 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
     HEAPF32[i13 >> 2] = f11;
     if (!(f11 <= Math_fround(0.0))) return;
     HEAP8[i12 >> 0] = i1;
     HEAPF32[i13 >> 2] = Math_fround(0.0);
     return;
    }
   }
   HEAP8[i12 >> 0] = i1;
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   return;
  }
  HEAP8[i12 >> 0] = 0;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  return;
 }
 while (1) {
  f4 = Math_fround(HEAPF32[i8 + 24 + (i1 << 2) >> 2]);
  if (!(f4 <= f9)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 < i5 >>> 0) i10 = (i10 & 255) << 1 & 255; else {
   i7 = 35;
   break;
  }
 }
 if ((i7 | 0) == 35) {
  HEAP8[i12 >> 0] = 0;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  return;
 }
 i2 = HEAP32[i8 + 56 + (i1 << 2) >> 2] | 0;
 f6 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f6 > Math_fround(0.0)) {
  f4 = Math_fround(f4 - f9);
  i1 = i10 & 255;
  if (f4 < f6) {
   HEAP8[i12 >> 0] = i1 << 1 | i1;
   HEAPF32[i13 >> 2] = Math_fround(f4 / f6);
   return;
  }
 } else {
  if ((i2 | 0) == -2147483648) {
   HEAP8[i12 >> 0] = i10;
   f11 = Math_fround(HEAPF32[((i1 | 0) == 0 ? i8 + 12 | 0 : i8 + 24 + (i1 + -1 << 2) | 0) >> 2]);
   HEAPF32[i13 >> 2] = Math_fround(Math_fround(f9 - f11) / Math_fround(f4 - f11));
   return;
  }
  if (!(f11 <= Math_fround(0.0)) & (i2 & -3 | 0) == -2147483647) {
   if (!(i2 & 2)) i1 = HEAP8[i12 >> 0] | 0; else {
    i8 = (i10 & 255) >>> 1;
    i1 = HEAP8[i12 >> 0] | 0;
    i2 = i8 | i10;
    if (i1 << 24 >> 24 == i8 << 24 >> 24) {
     HEAP8[i12 >> 0] = i2;
     HEAPF32[i13 >> 2] = Math_fround(1.0);
     return;
    }
    if (i1 << 24 >> 24 == i2 << 24 >> 24) {
     f11 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f11);
     HEAPF32[i13 >> 2] = f11;
     if (!(f11 <= Math_fround(0.0))) return;
     HEAP8[i12 >> 0] = i10;
     HEAPF32[i13 >> 2] = Math_fround(0.0);
     return;
    }
   }
   i3 = i10 & 255;
   i5 = i3 << 1;
   i1 = i1 & 255;
   i2 = i5 & 254;
   if ((i1 | 0) == (i2 | 0)) {
    HEAP8[i12 >> 0] = i5 | i3;
    HEAPF32[i13 >> 2] = Math_fround(0.0);
    return;
   }
   if ((i1 | 0) == (i2 | i3 | 0)) {
    f11 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f11);
    HEAPF32[i13 >> 2] = f11;
    if (!(f11 >= Math_fround(1.0))) return;
    HEAP8[i12 >> 0] = i10;
    HEAPF32[i13 >> 2] = Math_fround(0.0);
    return;
   }
  }
 }
 HEAP8[i12 >> 0] = i10;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i25, i26, i1) {
 i25 = i25 | 0;
 i26 = i26 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i24 + 28 | 0;
 i22 = i24 + 24 | 0;
 i23 = i24;
 i1 = i25 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i25 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i22, 4); else {
  HEAP32[i22 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i23 >> 2] = -1;
 i12 = i23 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnvC2Ev(i12);
 i13 = i26 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i26, HEAP32[i13 >> 2] | 0);
 i14 = i26 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i26 >> 2] = i13;
 HEAP32[i13 >> 2] = 0;
 if ((HEAP32[i22 >> 2] | 0) <= 0) {
  STACKTOP = i24;
  return;
 }
 i15 = i23 + 8 | 0;
 i16 = i23 + 12 | 0;
 i17 = i23 + 16 | 0;
 i18 = i23 + 20 | 0;
 i19 = i13;
 i20 = i26 + 4 | 0;
 i11 = 0;
 do {
  __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags(i25, i23, gb + 1041891 | 0, 0);
  i5 = HEAP32[i23 >> 2] | 0;
  i6 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i15 >> 2] | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i9 = HEAP32[i17 >> 2] | 0;
  i10 = HEAP32[i18 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  do if (!i1) {
   HEAP32[i21 >> 2] = i13;
   i4 = i19;
   i3 = i13;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i21 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i21 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i21 >> 2] = i1;
    i4 = i1;
    i3 = i21;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(40) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   HEAP32[i1 + 20 >> 2] = i6;
   HEAP32[i1 + 24 >> 2] = i7;
   HEAP32[i1 + 28 >> 2] = i8;
   HEAP32[i1 + 32 >> 2] = i9;
   HEAP32[i1 + 36 >> 2] = i10;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i26 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i20 >> 2] | 0, i1);
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) < (HEAP32[i22 >> 2] | 0));
 STACKTOP = i24;
 return;
}

function __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEEixERSE_(i15, i12) {
 i15 = i15 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16 + 12 | 0;
 i14 = i16;
 i2 = i15 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i13 = 24;
 } else {
  i11 = HEAP32[i12 + 20 >> 2] | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i10 = (i10 | 0) == 0 ? i12 + 4 | 0 : i10;
  while (1) {
   i8 = HEAP32[i1 + 16 >> 2] | 0;
   i9 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = i11 >>> 0 > i9 >>> 0 ? i9 : i11;
   L6 : do if (!i2) i13 = 5; else {
    i4 = (i8 | 0) == 0 ? i1 + 20 | 0 : i8;
    i5 = i10;
    while (1) {
     i6 = HEAP8[i5 >> 0] | 0;
     i7 = HEAP8[i4 >> 0] | 0;
     if (i6 << 24 >> 24 != i7 << 24 >> 24) break;
     i2 = i2 + -1 | 0;
     if (!i2) {
      i13 = 5;
      break L6;
     } else {
      i4 = i4 + 1 | 0;
      i5 = i5 + 1 | 0;
     }
    }
    i2 = (i6 & 255) - (i7 & 255) | 0;
   } while (0);
   if ((i13 | 0) == 5) {
    i13 = 0;
    i2 = i11 - i9 | 0;
   }
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i13 = 11;
     break;
    } else i1 = i2;
   } else {
    i2 = i9 >>> 0 > i11 >>> 0 ? i11 : i9;
    L18 : do if (!i2) i13 = 14; else {
     i7 = i10;
     i4 = (i8 | 0) == 0 ? i1 + 20 | 0 : i8;
     while (1) {
      i5 = HEAP8[i4 >> 0] | 0;
      i6 = HEAP8[i7 >> 0] | 0;
      if (i5 << 24 >> 24 != i6 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i13 = 14;
       break L18;
      } else {
       i7 = i7 + 1 | 0;
       i4 = i4 + 1 | 0;
      }
     }
     i2 = (i5 & 255) - (i6 & 255) | 0;
    } while (0);
    if ((i13 | 0) == 14) {
     i13 = 0;
     i2 = i9 - i11 | 0;
    }
    if ((i2 | 0) >= 0) {
     i13 = 22;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i13 = 21;
     break;
    } else i1 = i2;
   }
  }
  if ((i13 | 0) == 11) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i13 | 0) == 21) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i13 | 0) == 22) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i13 = 24;
   break;
  }
 } while (0);
 if ((i13 | 0) == 24) if (i1) {
  i15 = i1;
  i15 = i15 + 48 | 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEE25__construct_node_with_keyERSE_(i14, i15, i12);
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i15 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 + 4 >> 2] | 0, i1);
 i15 = i15 + 12 | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 i15 = i2;
 i15 = i15 + 48 | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i23 = HEAP32[i5 + 4 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(-f15);
 f24 = Math_fround(-f24);
 f25 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i16 >> 2]);
 f27 = Math_fround(f20 * f15);
 f17 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f17 * f24));
 f13 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f27 = Math_fround(f27 + Math_fround(f13 * f25));
 f10 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f26 = Math_fround(f10 * f15);
 f12 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f12 * f24));
 f9 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f26 = Math_fround(f26 + Math_fround(f9 * f25));
 f21 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f15 = Math_fround(f21 * f15);
 f18 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f24 = Math_fround(f15 + Math_fround(f18 * f24));
 f15 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 f25 = Math_fround(f24 + Math_fround(f15 * f25));
 f24 = Math_fround(HEAPF32[i23 + 96 >> 2]);
 f19 = Math_fround(HEAPF32[i23 + 100 >> 2]);
 f22 = Math_fround(HEAPF32[i23 + 104 >> 2]);
 f28 = Math_fround(Math_fround(Math_fround(f27 * f24) + Math_fround(f26 * f19)) + Math_fround(f25 * f22));
 f8 = Math_fround(HEAPF32[i23 + 112 >> 2]);
 f7 = Math_fround(HEAPF32[i23 + 116 >> 2]);
 f14 = Math_fround(HEAPF32[i23 + 120 >> 2]);
 i23 = f28 > Math_fround(Math_fround(Math_fround(f27 * f8) + Math_fround(f26 * f7)) + Math_fround(f25 * f14));
 f8 = i23 ? f24 : f8;
 f7 = i23 ? f19 : f7;
 f14 = i23 ? f22 : f14;
 f22 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f10 = Math_fround(f22 + Math_fround(Math_fround(f21 * f14) + Math_fround(Math_fround(f20 * f8) + Math_fround(f10 * f7))));
 f12 = Math_fround(f19 + Math_fround(Math_fround(f18 * f14) + Math_fround(Math_fround(f17 * f8) + Math_fround(f12 * f7))));
 f7 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f13 * f8) + Math_fround(f9 * f7))));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab10SubProgramC2EPKc20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EEP16PropertyNamesSetRK16ShaderKeywordSet(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i9 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i1 + 48 >> 2] = i3;
 __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 52 | 0, i4);
 i6 = i1 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, _strlen(i2) | 0);
 HEAP32[i1 + 84 >> 2] = i5;
 i6 = __Znwj(244) | 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i3 = i8;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i6 + 36 | 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i5 = i8;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i6 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i6 + 80 | 0;
 HEAP32[i6 + 104 >> 2] = 0;
 HEAP32[i6 + 108 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i3 = i8;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i6 + 96 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i6 + 112 >> 2] = 0;
 HEAP32[i6 + 116 >> 2] = 0;
 HEAP32[i6 + 120 >> 2] = 0;
 HEAP32[i6 + 124 >> 2] = -1;
 i5 = i6 + 128 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 + 144 >> 2] = -1;
 i5 = i6 + 148 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 + 164 >> 2] = -1;
 i5 = i6 + 168 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 + 184 >> 2] = -1;
 i5 = i6 + 188 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 + 204 >> 2] = -1;
 i5 = i6 + 208 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i6 + 224 >> 2] = -1;
 i5 = i6 + 228 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902127 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i4 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i4, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902137 | 0, gb + 905989 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1085944 | 0, 0);
 i4 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i4, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 68 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902149 | 0, gb + 905989 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1085944 | 0, 0);
 i4 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i4, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 108 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 120 | 0, gb + 902162 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902170 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 132 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901500 | 0, i5, i1 + 136 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902184 | 0, i5, i1 + 137 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 196 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 197 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i3 = i5 + 200 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i3, i1, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i3 = i5 + 216 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i3, i1, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN22CrashReportingSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 28 | 0, i6);
 i1 = i5 + 64 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 65 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 944884 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i5 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i8, i7 + 4 | 0, gb + 944890 | 0, 0);
 __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i8, i7 + 20 | 0, gb + 944893 | 0, 0);
 i5 = i7 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 946895 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i4 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i7 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 944898 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i6 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if (__ZN14SafeBinaryRead16IsCurrentVersionEv(i8) | 0) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i5 >> 2] = HEAP32[i7 + 28 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN15ParticleEmitter11CalcOffsetsEP8Vector3fP10Matrix3x3ff(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 if (!(HEAP8[i1 + 192 >> 0] | 0)) {
  __ZN10Matrix3x3f11SetIdentityEv(i3) | 0;
  i3 = i1 + 156 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i5, i6, i1 + 144 | 0);
  f4 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  f4 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  i6 = i2 + 4 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i6 >> 2]));
  f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  i6 = i2 + 8 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i6 >> 2]));
  STACKTOP = i7;
  return;
 } else {
  i14 = i1 + 32 | 0;
  __ZNK9Transform11GetPositionEv(i5, i6);
  HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  __ZNK9Transform11GetRotationEv(i5, i6);
  __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i5, i3);
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(HEAPF32[i1 + 156 >> 2]);
  f11 = Math_fround(f11 * f10);
  f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 160 >> 2]);
  f9 = Math_fround(f11 + Math_fround(f9 * f13));
  f11 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 164 >> 2]);
  f11 = Math_fround(f9 + Math_fround(f11 * f8));
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 4 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i3 + 16 >> 2])));
  f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 28 >> 2])));
  f10 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 8 >> 2]));
  f13 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i3 + 20 >> 2])));
  f8 = Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 32 >> 2])));
  HEAPF32[i2 >> 2] = f11;
  i5 = i2 + 4 | 0;
  HEAPF32[i5 >> 2] = f9;
  i6 = i2 + 8 | 0;
  HEAPF32[i6 >> 2] = f8;
  f11 = Math_fround(Math_fround(HEAPF32[i1 + 144 >> 2]) + f11);
  HEAPF32[i2 >> 2] = f11;
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 148 >> 2]) + f9);
  HEAPF32[i5 >> 2] = f9;
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 152 >> 2]) + f8);
  HEAPF32[i6 >> 2] = f8;
  f13 = Math_fround(HEAPF32[i14 >> 2]);
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i1 + 44 >> 2]));
  f10 = Math_fround(HEAPF32[i1 + 36 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i1 + 48 >> 2]));
  f12 = Math_fround(HEAPF32[i1 + 40 >> 2]);
  f13 = Math_fround(f13 * f4);
  f10 = Math_fround(f10 * f4);
  f4 = Math_fround(Math_fround(f12 - Math_fround(HEAPF32[i1 + 52 >> 2])) * f4);
  f12 = Math_fround(HEAPF32[i1 + 140 >> 2]);
  f10 = Math_fround(f10 * f12);
  f4 = Math_fround(f12 * f4);
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(f13 * f12) + f11);
  HEAPF32[i5 >> 2] = Math_fround(f10 + f9);
  HEAPF32[i6 >> 2] = Math_fround(f4 + f8);
  STACKTOP = i7;
  return;
 }
}

function __ZN14ParticleSystem8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = i1 + 36 | 0;
 __ZN27ParticleSystemReadOnlyState8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN19ParticleSystemState8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 40 >> 2] | 0, i2);
 i3 = i1 + 44 | 0;
 __ZN13InitialModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN13InitialModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 48 | 0;
 __ZN11ShapeModule8TransferI17RemapPPtrTransferEEvRT_(i3, i2);
 __ZN11ShapeModule16CheckConsistencyEv(i3);
 i3 = i1 + 264 | 0;
 __ZN14EmissionModule8TransferI17RemapPPtrTransferEEvRT_(i3, i2);
 __ZN14EmissionModule16CheckConsistencyEv(i3);
 __ZN10SizeModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 852 >> 2] | 0, i2);
 __ZN14RotationModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 856 >> 2] | 0, i2);
 __ZN11ColorModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 860 >> 2] | 0, i2);
 i3 = i1 + 864 | 0;
 __ZN8UVModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN8UVModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN14VelocityModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 868 >> 2] | 0, i2);
 i3 = i1 + 872 | 0;
 __ZN21InheritVelocityModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN21InheritVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN11ForceModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 876 >> 2] | 0, i2);
 __ZN20ExternalForcesModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 880 >> 2] | 0, i2);
 i3 = i1 + 884 | 0;
 __ZN19ClampVelocityModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN19ClampVelocityModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 888 | 0;
 __ZN11NoiseModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN11NoiseModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 892 | 0;
 __ZN17SizeBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN17SizeBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 896 | 0;
 __ZN21RotationBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN21RotationBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 900 | 0;
 __ZN18ColorBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN18ColorBySpeedModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 904 | 0;
 __ZN15CollisionModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN15CollisionModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 912 | 0;
 __ZN13TriggerModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN13TriggerModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 __ZN9SubModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 + 916 >> 2] | 0, i2);
 i3 = i1 + 920 | 0;
 __ZN12LightsModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i3 >> 2] | 0, i2);
 __ZN12LightsModule16CheckConsistencyEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 908 | 0;
 __ZN11TrailModule8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i1 >> 2] | 0, i2);
 __ZN11TrailModule16CheckConsistencyEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5Umbra12PortalCuller17nextCellToProcessERNS_16DoublyLinkedListINS0_8CellDataEtEE(i23, i22) {
 i23 = i23 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i20 = HEAP32[i22 + 4 >> 2] | 0;
 i1 = HEAP16[i20 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i23 = 0;
  return i23 | 0;
 }
 i2 = i1 & 65535;
 i19 = HEAP32[i22 >> 2] | 0;
 i13 = i19 + (i2 << 4) + 2 | 0;
 i2 = HEAP16[i19 + (i2 << 4) >> 1] | 0;
 HEAP16[i19 + ((i2 & 65535) << 4) + 2 >> 1] = HEAP16[i13 >> 1] | 0;
 HEAP16[i19 + (HEAPU16[i13 >> 1] << 4) >> 1] = i2;
 i13 = i23 + 7032 | 0;
 i2 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
 HEAP32[i13 >> 2] = i2;
 i13 = HEAP32[i23 + 2728 >> 2] | 0;
 L4 : do if (i2) {
  i14 = i23 + 2844 | 0;
  i15 = i23 + 4 | 0;
  i16 = i23 + 2656 | 0;
  i17 = i23 + 2672 | 0;
  i10 = HEAP32[i23 + 2300 >> 2] | 0;
  i11 = HEAP32[i23 + 2828 >> 2] | 0;
  i12 = HEAP32[i23 + 2720 >> 2] | 0;
  i18 = i12 + 60 | 0;
  do {
   i8 = i1 & 65535;
   i9 = HEAPU16[i10 + (i8 << 4) + 4 >> 1] | 0;
   i3 = i11 + (Math_imul(HEAP32[i14 >> 2] | 0, i9) | 0) | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (HEAP32[i18 >> 2] | 0) + (HEAP32[i3 >> 2] << 4) | 0;
   i3 = (i3 | 0) == 0 ? 0 : i12 + i3 | 0;
   if ((i3 | 0) == 0 | (i4 | 0) == 0) break L4;
   while (1) {
    i4 = i4 + -1 | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    if (!((i5 & 268435456 | 0) == 0 & (i5 & 67108863 | 0) == (i13 | 0))) break L4;
    i6 = i5 >>> 29;
    i7 = i5 >>> 30;
    if (!(HEAP8[(HEAP32[i15 >> 2] | 0) + 1365 >> 0] | 0)) {
     i6 = (i6 & 1) + -1 | 0;
     if (!((i5 & 134217728 | 0) == 0 ? (((HEAP32[i16 + (i7 << 2) >> 2] | 0) - (HEAP32[i3 + 4 >> 2] & 65535) ^ i6) - i6 | 0) <= (HEAP32[i17 + (i7 << 2) >> 2] | 0) : 0)) i21 = 10;
    } else if (!((i5 & 134217728 | 0) == 0 ? (i6 & 1 | 0) == (HEAP32[i23 + 300 + (i7 << 2) >> 2] | 0) : 0)) i21 = 10;
    if ((i21 | 0) == 10) {
     i21 = 0;
     i5 = i23 + 2936 + ((HEAP32[i3 + 4 >> 2] | 0) >>> 16 << 1) | 0;
     if ((HEAP16[i5 >> 1] & -16384) << 16 >> 16 == -32768) break;
    }
    i3 = i3 + 16 | 0;
    if (!i4) break L4;
   }
   HEAP16[i19 + (i8 << 4) >> 1] = HEAP16[i19 >> 1] | 0;
   HEAP16[i19 + (i8 << 4) + 2 >> 1] = 0;
   HEAP16[i19 + (HEAPU16[i19 >> 1] << 4) + 2 >> 1] = i1;
   HEAP16[i19 >> 1] = i1;
   HEAP16[i23 + 2936 + (i9 << 1) >> 1] = i8 | 49152;
   i8 = HEAPU16[i5 >> 1] & 16383;
   i1 = i8 & 65535;
   i9 = i19 + (i8 << 4) + 2 | 0;
   i8 = HEAP16[i19 + (i8 << 4) >> 1] | 0;
   HEAP16[i19 + ((i8 & 65535) << 4) + 2 >> 1] = HEAP16[i9 >> 1] | 0;
   HEAP16[i19 + (HEAPU16[i9 >> 1] << 4) >> 1] = i8;
   i9 = (HEAP32[(HEAP32[i23 >> 2] | 0) + 60 >> 2] | 0) + 16 | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   HEAP32[i9 >> 2] = ((i8 | 0) < 0 ? 0 : i8) + 1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 i2 = HEAP16[i20 >> 1] | 0;
 if (!(i2 << 16 >> 16)) {
  i23 = i1;
  return i23 | 0;
 }
 i5 = HEAP32[i22 >> 2] | 0;
 i4 = HEAP32[i23 + 2300 >> 2] | 0;
 while (1) {
  i2 = i2 & 65535;
  i3 = i23 + 2936 + (HEAPU16[i4 + (i2 << 4) + 4 >> 1] << 1) | 0;
  if ((HEAP16[i3 >> 1] & -16384) << 16 >> 16 == -32768) {
   i21 = 17;
   break;
  }
  HEAP16[i3 >> 1] = i2 | 32768;
  i2 = HEAP16[i5 + (i2 << 4) >> 1] | 0;
  if (!(i2 << 16 >> 16)) {
   i21 = 17;
   break;
  }
 }
 if ((i21 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZN20ArchiveStorageHeader19ReadHeaderSignatureER12FileAccessorRNS_6HeaderE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 __ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i12, i11) | 0;
 i1 = HEAP32[gb + 70780 >> 2] | 0;
 i2 = _strlen(i1) | 0;
 i9 = i11 + 11 | 0;
 i3 = HEAP8[i9 >> 0] | 0;
 i10 = i11 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 L1 : do if ((i2 | 0) == ((i3 << 24 >> 24 < 0 ? i4 : i3 & 255) | 0)) switch (i2 | 0) {
 case -1:
  {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i11);
   break;
  }
 case 0:
  {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 default:
  if (!(_memcmp(i3 << 24 >> 24 < 0 ? HEAP32[i11 >> 2] | 0 : i11, i1, i2) | 0)) {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  } else {
   i5 = i3;
   i6 = HEAP32[i10 >> 2] | 0;
   break L1;
  }
 } else {
  i5 = i3;
  i6 = i4;
 } while (0);
 i1 = i5 << 24 >> 24 < 0;
 switch ((i1 ? i6 : i5 & 255) | 0) {
 case 12:
  {
   if (_memcmp(i1 ? HEAP32[i11 >> 2] | 0 : i11, gb + 489819 | 0, 12) | 0) {
    i12 = -1;
    STACKTOP = i13;
    return i12 | 0;
   }
   i12 = i11 + 72 | 0;
   HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -128 | 64;
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 8:
  {
   if (_memcmp(i1 ? HEAP32[i11 >> 2] | 0 : i11, gb + 489810 | 0, 8) | 0) {
    if (_memcmp(i1 ? HEAP32[i11 >> 2] | 0 : i11, gb + 489801 | 0, 8) | 0) {
     i12 = -1;
     STACKTOP = i13;
     return i12 | 0;
    }
    i12 = i11 + 72 | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -128 | 64;
    i12 = 0;
    STACKTOP = i13;
    return i12 | 0;
   }
   i6 = __ZNK12FileAccessor8PositionEv(i12) | 0;
   i8 = getTempRet0() | 0;
   i1 = i11 + 16 | 0;
   i5 = i7;
   if ((__ZN12FileAccessor4ReadEyPvPy(i12, 4, 0, i1, i7) | 0) & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
    i7 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    HEAP32[i1 >> 2] = i7;
    i1 = i7;
   } else i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) == 6) {
    i4 = HEAP32[gb + 70780 >> 2] | 0;
    i5 = _strlen(i4) | 0;
    i1 = HEAP8[i9 >> 0] | 0;
    i2 = i1 << 24 >> 24 < 0;
    if (i2) i3 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
    do if (i5 >>> 0 > i3 >>> 0) {
     if (i2) i1 = HEAP32[i10 >> 2] | 0; else i1 = i1 & 255;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i5 - i3 | 0, i1, 0, i1, i5, i4);
    } else {
     if (i2) i1 = HEAP32[i11 >> 2] | 0; else i1 = i11;
     if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
     HEAP8[i1 + i5 >> 0] = 0;
     if ((HEAP8[i9 >> 0] | 0) < 0) {
      HEAP32[i10 >> 2] = i5;
      break;
     } else {
      HEAP8[i9 >> 0] = i5;
      break;
     }
    } while (0);
    i1 = i11 + 72 | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 256;
   } else i1 = i11 + 72 | 0;
   __ZN12FileAccessor4SeekEx10FileOrigin(i12, i6, i8, 1) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -128;
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 default:
  {
   i12 = -1;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN16Physics2DManager15IgnoreCollisionEP10Collider2DS1_b(i19, i1, i2, i5) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i21;
 i3 = i1;
 i4 = i2;
 if ((i1 | 0) == (i2 | 0) | ((i1 | 0) == 0 | (i2 | 0) == 0)) {
  STACKTOP = i21;
  return;
 }
 i17 = (HEAP32[i1 + 4 >> 2] | 0) > (HEAP32[i2 + 4 >> 2] | 0);
 i7 = i17 ? i3 : i4;
 i3 = i17 ? i4 : i3;
 i17 = i3;
 i18 = i7;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i7;
 i1 = i3;
 i2 = i7;
 if (i5) {
  HEAP32[(__ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EEjNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_jEEL18MemLabelIdentifier65ELi16EEEixERSA_(i19 + 4 | 0, i6) | 0) >> 2] = 1;
  __ZN10Collider2D19RecalculateContactsEv(i17);
  __ZN10Collider2D19RecalculateContactsEv(i18);
 } else {
  i15 = i19 + 8 | 0;
  i16 = HEAP32[i15 >> 2] | 0;
  if ((HEAP32[i19 + 48 >> 2] | 0) == (i16 | 0)) {
   i2 = HEAP32[i19 + 40 >> 2] | 0;
   i1 = HEAP32[i19 + 44 >> 2] | 0;
   i3 = i2 + (i1 * 12 | 0) | 0;
  } else {
   i14 = HEAP32[i19 + 44 >> 2] | 0;
   i13 = i14 + -1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i1 + 2127912214 + (i1 << 12) | 0;
   i1 = i1 ^ -949894596 ^ HEAP32[i2 + 4 >> 2] ^ i1 >>> 19;
   i1 = i1 + 374761393 + (i1 << 5) | 0;
   i2 = HEAP32[i19 + 40 >> 2] | 0;
   i10 = HEAP32[i19 + 28 >> 2] | 0;
   i11 = i19 + 32 | 0;
   i12 = i19 + 12 | 0;
   i8 = i19 + 16 | 0;
   i9 = i19 + 20 | 0;
   i6 = 0;
   i1 = i1 + -744332180 ^ i1 << 9;
   i4 = i16;
   while (1) {
    i1 = i1 & i13;
    i5 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
    if ((i10 | 0) == (i5 | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) {
     i1 = -1;
     break;
    }
    if (!(HEAP8[i12 >> 0] | 0)) i20 = 13; else if (!i4) {
     i4 = 0;
     i20 = 13;
    } else if ((HEAP32[i8 >> 2] | 0) == (i5 | 0)) {
     if ((HEAP32[i9 >> 2] | 0) != (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) i20 = 13;
    } else i20 = 13;
    if ((i20 | 0) == 13) {
     i20 = 0;
     if ((i3 | 0) == (i5 | 0)) if ((i7 | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) break;
    }
    i5 = i6 + 1 | 0;
    i6 = i5;
    i1 = i5 + i1 | 0;
   }
   i3 = (i1 | 0) == -1 ? i2 + (i14 * 12 | 0) | 0 : i2 + (i1 * 12 | 0) | 0;
   i1 = i14;
  }
  if ((i3 | 0) != (i2 + (i1 * 12 | 0) | 0)) {
   if ((HEAP8[i19 + 12 >> 0] | 0) == 0 | (i16 | 0) == 0) i20 = 20; else if ((HEAP32[i19 + 16 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) {
    i16 = (HEAP32[i19 + 20 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0);
    i14 = i19 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    if (!i16) i20 = 22;
   } else i20 = 20;
   if ((i20 | 0) == 20) {
    i16 = i19 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
    i20 = 22;
   }
   if ((i20 | 0) == 22) {
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
    HEAP8[i19 + 60 >> 0] = 1;
   }
   __ZN10Collider2D19RecalculateContactsEv(i17);
   __ZN10Collider2D19RecalculateContactsEv(i18);
  }
 }
 STACKTOP = i21;
 return;
}

function __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE(i14, i1, i12, i13, i11, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i10) return;
 i8 = i1 + 36 | 0;
 i9 = 0;
 do {
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i3 + (i9 << 5) | 0;
  i1 = HEAP32[i3 + (i9 << 5) + 24 >> 2] | 0;
  do if (!(i1 & 17)) {
   i5 = (HEAP32[i3 + (i9 << 5) + 8 >> 2] | 0) + i11 | 0;
   if (i1 & 256 | 0) {
    i7 = i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i7 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) + 32 >> 2] = i5;
    i7 = HEAP32[i13 >> 2] | 0;
    i6 = i12 + (i7 * 44 | 0) + 36 | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i13 >> 2] = i7 + 1;
    break;
   }
   if (i1 & 8 | 0) {
    i7 = i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i7 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i7 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i7 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) + 32 >> 2] = i5;
    i7 = HEAP32[i13 >> 2] | 0;
    i6 = i12 + (i7 * 44 | 0) + 36 | 0;
    HEAP32[i6 >> 2] = fb + 291;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i13 >> 2] = i7 + 1;
    break;
   }
   i7 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i14, HEAP32[i2 >> 2] | 0, i15) | 0;
   if (HEAP32[i7 + 4 >> 2] & 1 | HEAP32[i7 >> 2] | 0) {
    i4 = i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) | 0;
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
    HEAP32[i12 + ((HEAP32[i13 >> 2] | 0) * 44 | 0) + 32 >> 2] = i5;
    i4 = HEAP32[i7 + 4 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i5 = i12 + (i6 * 44 | 0) + 36 | 0;
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i5 + 4 >> 2] = i4;
    HEAP32[i13 >> 2] = i6 + 1;
    break;
   }
   i6 = i3 + (i9 << 5) + 16 | 0;
   if ((HEAP32[i6 >> 2] | 0) > 0) {
    i3 = i3 + (i9 << 5) + 12 | 0;
    i4 = 0;
    i2 = i5;
    while (1) {
     __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE(i14, i7, i12, i13, i2, i15);
     i1 = HEAP32[i6 >> 2] | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) >= (i1 | 0)) break; else i2 = ((HEAP32[i3 >> 2] | 0) / (i1 | 0) | 0) + i2 | 0;
    }
   }
  } while (0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i10 | 0));
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i17 = i4 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 i19 = i4 + 8 | 0;
 i21 = i2 + 8 | 0;
 i16 = HEAP16[i21 >> 1] | 0;
 HEAP8[i19 >> 0] = i16;
 i11 = i4 + 9 | 0;
 HEAP8[i11 >> 0] = (i16 & 65535) >>> 8;
 i16 = i4 + 12 | 0;
 i20 = i2 + 12 | 0;
 i12 = i20;
 i15 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i15;
 i10 = i4 + 20 | 0;
 i15 = i2 + 20 | 0;
 i12 = i15;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i10;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j(i4, i2, 0);
 i18 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i18;
 i17 = HEAP8[i21 >> 0] | 0;
 i18 = HEAP16[i19 >> 1] | 0;
 HEAP8[i21 >> 0] = i18;
 HEAP8[i19 >> 0] = i17;
 i19 = i2 + 9 | 0;
 i17 = HEAP8[i19 >> 0] | 0;
 HEAP8[i19 >> 0] = (i18 & 65535) >>> 8;
 HEAP8[i11 >> 0] = i17;
 i11 = i20;
 i17 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i19 = i16;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i20;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i1 + 4 >> 2] = i18;
 i1 = i16;
 HEAP32[i1 >> 2] = i17;
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = i15;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = i10;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i1;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __ZN6b2Rope10InitializeEPK9b2RopeDef(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i5;
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = __Z7b2Alloci(i5 << 3) | 0;
 i5 = i10 + 8 | 0;
 HEAP32[i5 >> 2] = __Z7b2Alloci(HEAP32[i10 >> 2] << 3) | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i6 >> 2] = __Z7b2Alloci(HEAP32[i10 >> 2] << 3) | 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = __Z7b2Alloci(HEAP32[i10 >> 2] << 2) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i4 = i11 + 8 | 0;
  i2 = 0;
  do {
   i8 = (HEAP32[i11 >> 2] | 0) + (i2 << 3) | 0;
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   i12 = (HEAP32[i9 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i12 + 4 >> 2] = i1;
   i12 = (HEAP32[i11 >> 2] | 0) + (i2 << 3) | 0;
   i1 = HEAP32[i12 + 4 >> 2] | 0;
   i8 = (HEAP32[i5 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i8 + 4 >> 2] = i1;
   i8 = HEAP32[i6 >> 2] | 0;
   HEAPF32[i8 + (i2 << 3) >> 2] = Math_fround(0.0);
   HEAPF32[i8 + (i2 << 3) + 4 >> 2] = Math_fround(0.0);
   f3 = Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2]);
   if (f3 > Math_fround(0.0)) {
    f3 = Math_fround(Math_fround(1.0) / f3);
    HEAPF32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = f3;
   } else HEAPF32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = Math_fround(0.0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 i6 = i1 + -1 | 0;
 i7 = i1 + -2 | 0;
 i2 = i10 + 20 | 0;
 HEAP32[i2 >> 2] = __Z7b2Alloci(i6 << 2) | 0;
 i8 = __Z7b2Alloci(i7 << 2) | 0;
 HEAP32[i10 + 24 >> 2] = i8;
 if ((i1 | 0) > 1) {
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i2 = 0;
  do {
   f14 = Math_fround(HEAPF32[i5 + (i2 << 3) >> 2]);
   f3 = Math_fround(HEAPF32[i5 + (i2 << 3) + 4 >> 2]);
   i12 = i2;
   i2 = i2 + 1 | 0;
   f13 = Math_fround(HEAPF32[i5 + (i2 << 3) >> 2]);
   f13 = Math_fround(f14 - f13);
   f3 = Math_fround(f3 - Math_fround(HEAPF32[i5 + (i2 << 3) + 4 >> 2]));
   HEAPF32[i4 + (i12 << 2) >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(f3 * f3))));
  } while ((i2 | 0) != (i6 | 0));
  if ((i1 | 0) > 2) {
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = 0;
   do {
    f15 = Math_fround(HEAPF32[i2 + (i1 << 3) >> 2]);
    f13 = Math_fround(HEAPF32[i2 + (i1 << 3) + 4 >> 2]);
    i12 = i1;
    i1 = i1 + 1 | 0;
    f3 = Math_fround(HEAPF32[i2 + (i1 << 3) >> 2]);
    f14 = Math_fround(HEAPF32[i2 + (i1 << 3) + 4 >> 2]);
    i9 = i12 + 2 | 0;
    f16 = Math_fround(HEAPF32[i2 + (i9 << 3) >> 2]);
    f15 = Math_fround(f3 - f15);
    f13 = Math_fround(f14 - f13);
    f3 = Math_fround(f16 - f3);
    f14 = Math_fround(Math_fround(HEAPF32[i2 + (i9 << 3) + 4 >> 2]) - f14);
    HEAPF32[i8 + (i12 << 2) >> 2] = Math_fround(+Math_atan2(+Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f3)), +Math_fround(Math_fround(f15 * f3) + Math_fround(f13 * f14))));
   } while ((i1 | 0) != (i7 | 0));
  }
 }
 i8 = i11 + 12 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i10 + 28 | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i10 + 36 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i10 + 40 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i10 + 44 >> 2] = HEAP32[i11 + 28 >> 2];
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i1, i10, i6, i5, i8, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 40 | 0;
 i13 = i12 + 16 | 0;
 i2 = i12 + 8 | 0;
 i3 = i12 + 12 | 0;
 i4 = i12 + 4 | 0;
 i9 = i12;
 L1 : do if (!(HEAP32[i5 + 4 >> 2] & 1)) {
  HEAP32[i2 >> 2] = -1;
  i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = mftCall_iiiiiii(i9 | 0, i1 | 0, i13 | 0, i7 | 0, i5 | 0, i8 | 0, i2 | 0) | 0;
  switch (HEAP32[i2 >> 2] | 0) {
  case 0:
   {
    HEAP8[i11 >> 0] = 0;
    break;
   }
  case 1:
   {
    HEAP8[i11 >> 0] = 1;
    break;
   }
  default:
   {
    HEAP8[i11 >> 0] = 1;
    HEAP32[i8 >> 2] = 4;
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = __ZNKSt3__28ios_base6getlocEv(i5) | 0;
  HEAP32[i7 >> 2] = i1;
  __THREW__ = 0;
  i3 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474588 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  do if (i4 & 1) {
   i13 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = i13;
  } else {
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = __ZNKSt3__28ios_base6getlocEv(i5) | 0;
   HEAP32[i7 >> 2] = i1;
   __THREW__ = 0;
   i2 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474596 | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i13 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
    i1 = i13;
    break;
   }
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i13 | 0, i2 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i13 + 12 | 0, i2 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i13);
    break;
   }
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i2 = i13 + 24 | 0;
   __THREW__ = 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   i1 = invoke_iiiiiiii(fb + 100 | 0, i10 | 0, i7 | 0, i13 | 0, i2 | 0, i3 | 0, i8 | 0, 1) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    i3 = getTempRet0() | 0;
    do {
     i2 = i2 + -12 | 0;
     __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
    } while ((i2 | 0) != (i13 | 0));
    break;
   } else {
    HEAP8[i11 >> 0] = (i1 | 0) == (i13 | 0) & 1;
    i1 = HEAP32[i10 >> 2] | 0;
    do {
     i2 = i2 + -12 | 0;
     __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
    } while ((i2 | 0) != (i13 | 0));
    break L1;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN14NavMeshManager22UpdateNavMeshObstaclesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i22 + 60 | 0;
 i13 = i22 + 48 | 0;
 i16 = i22 + 36 | 0;
 i17 = i22 + 24 | 0;
 i18 = i22 + 12 | 0;
 i19 = i22;
 i20 = i2 + 72 | 0;
 if (!(HEAP32[i20 >> 2] | 0)) {
  STACKTOP = i22;
  return;
 }
 if ((HEAP16[gb + 1459236 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459236 | 0, i12);
  if (!(HEAP32[i20 >> 2] | 0)) i1 = gb + 1459236 | 0; else {
   i1 = gb + 1459236 | 0;
   i21 = 5;
  }
 } else {
  i1 = 0;
  i21 = 5;
 }
 if ((i21 | 0) == 5) {
  i14 = i2 + 60 | 0;
  i15 = i2 + 104 | 0;
  i8 = i2 + 100 | 0;
  i9 = i13 + 4 | 0;
  i10 = i13 + 8 | 0;
  i7 = 0;
  do {
   i6 = HEAP32[i14 >> 2] | 0;
   i11 = i6 + (i7 * 12 | 0) | 0;
   __ZN15NavMeshObstacle11UpdateStateEv(HEAP32[i11 >> 2] | 0);
   i5 = HEAP32[i15 >> 2] | 0;
   L11 : do if (i5 | 0) {
    i3 = HEAP32[i11 >> 2] | 0;
    do if (!(HEAP8[i3 + 68 >> 0] | 0)) {
     i2 = i6 + (i7 * 12 | 0) + 4 | 0;
     if ((HEAP32[i2 >> 2] | 0) == -1) break L11;
    } else {
     i2 = i6 + (i7 * 12 | 0) + 4 | 0;
     i4 = (HEAP32[i2 >> 2] | 0) == -1;
     if (HEAP32[i3 + 140 >> 2] | 0) if (i4) break L11; else break;
     if (!i4) break L11;
     __ZN14NavMeshCarving11AddObstacleER15NavMeshObstacleRi(i5, i3, i2);
     break L11;
    } while (0);
    __ZN14NavMeshCarving14RemoveObstacleERi(i5, i2);
   } while (0);
   i5 = HEAP32[i8 >> 2] | 0;
   L22 : do if (i5 | 0) {
    i4 = HEAP32[i11 >> 2] | 0;
    do if (!(HEAP8[i4 + 68 >> 0] | 0)) {
     i2 = i6 + (i7 * 12 | 0) + 8 | 0;
     if ((HEAP32[i2 >> 2] | 0) == -1) i21 = 21; else i3 = i2;
    } else {
     i2 = i6 + (i7 * 12 | 0) + 8 | 0;
     i3 = (HEAP32[i2 >> 2] | 0) != -1;
     if ((HEAP32[i4 + 140 >> 2] | 0) == 1) if (i3) {
      i3 = i2;
      break;
     } else {
      i21 = 21;
      break;
     }
     if (!i3) break L22;
     __ZN7dtCrowd14RemoveObstacleER13dtCrowdHandle(i5, i2);
     break L22;
    } while (0);
    if ((i21 | 0) == 21) {
     i21 = 0;
     __ZN7dtCrowd11AddObstacleER13dtCrowdHandle(i5, i2) | 0;
     i4 = HEAP32[i11 >> 2] | 0;
     i3 = i2;
    }
    __ZNK15NavMeshObstacle15GetWorldExtentsEv(i12, i4);
    i2 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = HEAP32[i2 + 80 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i2 + 84 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i2 + 88 >> 2];
    __ZNK15NavMeshObstacle21GetWorldCenterAndAxesER8Vector3fS1_S1_S1_(i2, i16, i17, i18, i19);
    __ZN7dtCrowd30SetObstaclePositionAndVelocityERK13dtCrowdHandlePKfS4_(HEAP32[i8 >> 2] | 0, i3, i16, i13);
    i2 = HEAP32[i8 >> 2] | 0;
    if (!(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0)) __ZN7dtCrowd19SetObstacleCylinderERK13dtCrowdHandlePKfS4_S4_S4_(i2, i3, i12, i17, i18, i19); else __ZN7dtCrowd14SetObstacleBoxERK13dtCrowdHandlePKfS4_S4_S4_(i2, i3, i12, i17, i18, i19);
   } while (0);
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0);
  if (!i1) {
   STACKTOP = i22;
   return;
  }
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i22;
 return;
}

function __ZN13AnimationClip9PPtrCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i4 = i9 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
 i1 = HEAP32[i9 + 40 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i10);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = i9 + 16 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 20 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i6 = i9 + 4 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i9 >> 2] | 0 : i9;
 i8 = i8 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 32 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
  i12 = i9 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i12 = i9 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
  STACKTOP = i13;
  return;
 }
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb(i1, i10, i6, i5, i8, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 40 | 0;
 i13 = i12 + 16 | 0;
 i2 = i12 + 8 | 0;
 i3 = i12 + 12 | 0;
 i4 = i12 + 4 | 0;
 i9 = i12;
 L1 : do if (!(HEAP32[i5 + 4 >> 2] & 1)) {
  HEAP32[i2 >> 2] = -1;
  i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = mftCall_iiiiiii(i9 | 0, i1 | 0, i13 | 0, i7 | 0, i5 | 0, i8 | 0, i2 | 0) | 0;
  switch (HEAP32[i2 >> 2] | 0) {
  case 0:
   {
    HEAP8[i11 >> 0] = 0;
    break;
   }
  case 1:
   {
    HEAP8[i11 >> 0] = 1;
    break;
   }
  default:
   {
    HEAP8[i11 >> 0] = 1;
    HEAP32[i8 >> 2] = 4;
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = __ZNKSt3__28ios_base6getlocEv(i5) | 0;
  HEAP32[i7 >> 2] = i1;
  __THREW__ = 0;
  i3 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474556 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  do if (i4 & 1) {
   i13 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = i13;
  } else {
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = __ZNKSt3__28ios_base6getlocEv(i5) | 0;
   HEAP32[i7 >> 2] = i1;
   __THREW__ = 0;
   i2 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474572 | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i13 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
    i1 = i13;
    break;
   }
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i13 | 0, i2 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break;
   }
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i13 + 12 | 0, i2 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    break;
   }
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   i2 = i13 + 24 | 0;
   __THREW__ = 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   i1 = invoke_iiiiiiii(fb + 99 | 0, i10 | 0, i7 | 0, i13 | 0, i2 | 0, i3 | 0, i8 | 0, 1) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    i3 = getTempRet0() | 0;
    do {
     i2 = i2 + -12 | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
    } while ((i2 | 0) != (i13 | 0));
    break;
   } else {
    HEAP8[i11 >> 0] = (i1 | 0) == (i13 | 0) & 1;
    i1 = HEAP32[i10 >> 2] | 0;
    do {
     i2 = i2 + -12 | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
    } while ((i2 | 0) != (i13 | 0));
    break L1;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i1, i11, i2) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 8 | 0;
 i7 = i15;
 i14 = i15 + 44 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i4 = i14 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i7);
 i7 = i3;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 if (i2) {
  HEAP32[i3 >> 2] = i14;
  HEAP32[i3 + 4 >> 2] = i1 + 76;
  i9 = i3 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 256;
  HEAP8[i3 + 28 >> 0] = 0;
  HEAP8[i3 + 29 >> 0] = 32;
  HEAP32[i3 + 32 >> 2] = 4;
  __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1 + 80 | 0, i3) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 12 >> 2] | 0, gb + 64016 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 } else {
  HEAP32[i3 >> 2] = i14;
  HEAP32[i3 + 4 >> 2] = i1 + 76;
  i9 = i3 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 256;
  HEAP8[i3 + 28 >> 0] = 0;
  __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_(i1 + 80 | 0, i3) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 12 >> 2] | 0, gb + 64016 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 }
 i9 = HEAP32[i14 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 i7 = i11 + 4 | 0;
 i6 = i4 ? i7 : i3;
 if (i6 >>> 0 > i9 >>> 0) i10 = 13; else {
  i2 = i11 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i6 + i1 | 0) >>> 0 > i9 >>> 0) {
   i1 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
   if ((i6 | 0) != (i9 | 0)) _memmove(i6 | 0, i9 | 0, i1 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
  } else i10 = 13;
 }
 if ((i10 | 0) == 13) {
  i5 = i11 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = (i1 | 0) == 0;
  if (i2) if (i4) {
   i1 = 15;
   i10 = 16;
  } else i10 = 19; else {
   i1 = i4 ? 15 : i1;
   i10 = 16;
  }
  if ((i10 | 0) == 16) if (i1 >>> 0 < i8 >>> 0) if (i4 | i2) i10 = 19; else {
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i11 + 24 | 0);
   i10 = 19;
  } else i1 = i6;
  if ((i10 | 0) == 19) {
   if (i8 >>> 0 > 15) {
    i1 = i8;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 + 1 | 0, 16, i11 + 24 | 0, 0, gb + 1047486 | 0, 251) | 0;
   } else {
    i1 = 0;
    i2 = 0;
   }
   HEAP32[i11 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   i1 = (i2 | 0) == 0 ? i7 : i2;
  }
  _memcpy(i1 | 0, i9 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  HEAP32[i11 + 20 >> 2] = i8;
 }
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx22PxcHeightFieldAabbTestC2ERKNS_9PxBounds3ERKNS_2Gu15HeightFieldUtilE(i19, i1, i2) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f20 = f0, f21 = f0, f22 = f0;
 HEAP32[i19 >> 2] = i2;
 i18 = i19 + 4 | 0;
 HEAP8[i18 >> 0] = 0;
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(f22 * f7);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 * f16);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(f21 * f6);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f22, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f21, HEAP32[tempDoublePtr >> 2] | 0);
 f7 = Math_fround(f20 * f7);
 f16 = Math_fround(f3 * f16);
 f6 = Math_fround(f17 * f6);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 f6 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 i12 = f6 < Math_fround(0.0);
 i8 = i12 ? i10 : i11;
 f7 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 i5 = f7 < Math_fround(0.0);
 i9 = i5 ? i1 : i4;
 f17 = (HEAP32[tempDoublePtr >> 2] = i12 ? i11 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i11 = HEAP32[i10 + 16 >> 2] | 0;
 i12 = i11 + -1 | 0;
 i2 = f17 > Math_fround(i12 >>> 0);
 i13 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 if (!i2) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5 ? i4 : i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i1 + -1 | 0;
  if (!(f7 > Math_fround(i2 >>> 0))) {
   f6 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (!(f6 < Math_fround(0.0))) {
    f3 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (!(f3 < Math_fround(0.0))) {
     i8 = ~~Math_fround(Math_floor(Math_fround(f17)));
     i9 = i11 + -2 | 0;
     i8 = (i8 | 0) > 0 ? i8 : 0;
     i8 = (i8 | 0) > (i9 | 0) ? i9 : i8;
     HEAP32[i19 + 8 >> 2] = i8;
     i9 = ~~Math_fround(Math_ceil(Math_fround(f6)));
     i9 = (i9 | 0) > 0 ? i9 : 0;
     i9 = (i9 | 0) > (i12 | 0) ? i12 : i9;
     HEAP32[i19 + 12 >> 2] = i9;
     i11 = ~~Math_fround(Math_floor(Math_fround(f7)));
     i12 = i1 + -2 | 0;
     i11 = (i11 | 0) > 0 ? i11 : 0;
     i11 = (i11 | 0) > (i12 | 0) ? i12 : i11;
     HEAP32[i19 + 16 >> 2] = i11;
     i12 = ~~Math_fround(Math_ceil(Math_fround(f3)));
     i12 = (i12 | 0) > 0 ? i12 : 0;
     i12 = (i12 | 0) > (i2 | 0) ? i2 : i12;
     HEAP32[i19 + 20 >> 2] = i12;
     if ((i8 | 0) == (i9 | 0) | (i11 | 0) == (i12 | 0)) {
      HEAP8[i18 >> 0] = 1;
      return;
     } else {
      HEAPF32[i19 + 24 >> 2] = f15;
      HEAPF32[i19 + 28 >> 2] = f16;
      HEAP8[i19 + 32 >> 0] = (Math_fround(HEAPF32[i10 + 40 >> 2]) > Math_fround(0.0) | 0) != ((i14 ^ i13) & -2147483648 | 0) & 1;
      return;
     }
    }
   }
  }
 }
 HEAP8[i18 >> 0] = 1;
 return;
}

function __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i3, i11, i13) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 60 | 0;
 i18 = i20 + 32 | 0;
 i19 = i20;
 i1 = HEAP32[i11 + 24 >> 2] | 0;
 if (i1 >>> 0 < 32) {
  i19 = -1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i15 = i1 >>> 5;
 i12 = HEAP32[i11 + 28 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? 0 : i11 + i12 | 0;
 i17 = HEAP32[i11 + 40 >> 2] | 0;
 i14 = HEAP32[i11 + 36 >> 2] | 0;
 HEAP32[i18 >> 2] = i15;
 HEAP32[i18 + 4 >> 2] = i12;
 HEAP32[i18 + 8 >> 2] = i12 + (((i15 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i18 + 12 >> 2] = i11;
 HEAP32[i18 + 16 >> 2] = i17;
 HEAP32[i18 + 20 >> 2] = 4;
 HEAP32[i18 + 24 >> 2] = i14;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 8 >> 2] = Math_fround(0.0);
 i14 = i19 + 12 | 0;
 HEAP32[i14 >> 2] = -1;
 HEAPF32[i19 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 24 >> 2] = Math_fround(0.0);
 i17 = i3 + 16 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i2 = i1 + 1648 | 0;
 if (i2 >>> 0 > (HEAP32[i3 + 12 >> 2] | 0) >>> 0) i10 = 0; else {
  HEAP32[i17 >> 2] = i2;
  i10 = i1;
 }
 i8 = i10 + 44 | 0;
 i9 = i10 + 1644 | 0;
 _memset(i10 | 0, 0, 1648) | 0;
 i1 = i8;
 do {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 12 >> 2] = -1;
  HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i9 | 0));
 if (!i10) i1 = -1; else {
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i11 + 4 >> 2] | 0;
  i5 = HEAP32[i11 + 8 >> 2] | 0;
  i6 = HEAP32[i11 + 12 >> 2] | 0;
  i7 = HEAP32[i11 + 16 >> 2] | 0;
  i2 = HEAP32[i11 + 20 >> 2] | 0;
  i11 = HEAP32[i13 + 4 >> 2] | 0;
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i10 + 8 >> 2] = i1;
  i13 = i10 + 12 | 0;
  i1 = i10 + 40 | 0;
  HEAP32[i1 >> 2] = -1;
  HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
  HEAP32[i13 + 24 >> 2] = HEAP32[i18 + 24 >> 2];
  if (i15 | 0) {
   i15 = HEAP32[i12 >> 2] & 3;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i10 + 48 >> 2] = i4;
   HEAP32[i10 + 52 >> 2] = i5;
   HEAP32[i10 + 56 >> 2] = 0;
   HEAP32[i10 + 60 >> 2] = i6;
   HEAP32[i10 + 64 >> 2] = i7;
   HEAP32[i10 + 68 >> 2] = i2;
   HEAP8[i10 + 72 >> 0] = 0;
   HEAP8[i10 + 73 >> 0] = i15;
   HEAP8[i10 + 74 >> 0] = 63;
   HEAP8[i10 + 75 >> 0] = 0;
   HEAP32[i1 >> 2] = 0;
  }
  HEAP8[i9 >> 0] = 1;
  if (__ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE(i10, i19, i16) | 0) {
   i1 = HEAP32[i14 >> 2] | 0;
   i1 = i1 - (__ZNK5Umbra6KDTree4rankEi(i18, i1) | 0) | 0;
  } else i1 = -1;
  HEAP32[i17 >> 2] = i10;
 }
 i19 = i1;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZNSt3__218__time_get_storageIwEC2EPKc(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 __ZNSt3__210__time_getC2EPKc(i14, i10);
 i15 = i14 + 4 | 0;
 i1 = i14 + 172 | 0;
 i3 = i15;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) == 3) break;
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  }
  i3 = i3 + 12 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i13 = i14 + 172 | 0;
 i2 = i14 + 460 | 0;
 i4 = i13;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = 0;
  while (1) {
   if ((i3 | 0) == 3) break;
   HEAP32[i4 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  }
  i4 = i4 + 12 | 0;
 } while ((i4 | 0) != (i2 | 0));
 i9 = i14 + 460 | 0;
 i3 = i14 + 484 | 0;
 i5 = i9;
 do {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i4 = 0;
  while (1) {
   if ((i4 | 0) == 3) break;
   HEAP32[i5 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  }
  i5 = i5 + 12 | 0;
 } while ((i5 | 0) != (i3 | 0));
 i8 = i14 + 484 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i8 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i7 = i14 + 496 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i7 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i6 = i14 + 508 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i6 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i5 = i14 + 520 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i5 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4522 | 0, i11 | 0, i10 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 do if (i10 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4523 | 0, i14 | 0, i11 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i4 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212ctype_bynameIwED2Ev(i11);
   break;
  } else {
   __ZNSt3__212ctype_bynameIwED2Ev(i11);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i5);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i7);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
 do {
  i3 = i3 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
 } while ((i3 | 0) != (i9 | 0));
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i13 | 0));
 do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1);
 } while ((i1 | 0) != (i15 | 0));
 __ZNSt3__210__time_getD2Ev(i14);
 ___resumeException(i4 | 0);
}

function __ZNSt3__218__time_get_storageIcEC2EPKc(i14, i10) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 __ZNSt3__210__time_getC2EPKc(i14, i10);
 i15 = i14 + 4 | 0;
 i1 = i14 + 172 | 0;
 i3 = i15;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) == 3) break;
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  }
  i3 = i3 + 12 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i13 = i14 + 172 | 0;
 i2 = i14 + 460 | 0;
 i4 = i13;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = 0;
  while (1) {
   if ((i3 | 0) == 3) break;
   HEAP32[i4 + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  }
  i4 = i4 + 12 | 0;
 } while ((i4 | 0) != (i2 | 0));
 i9 = i14 + 460 | 0;
 i3 = i14 + 484 | 0;
 i5 = i9;
 do {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i4 = 0;
  while (1) {
   if ((i4 | 0) == 3) break;
   HEAP32[i5 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  }
  i5 = i5 + 12 | 0;
 } while ((i5 | 0) != (i3 | 0));
 i8 = i14 + 484 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i8 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i7 = i14 + 496 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i7 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i6 = i14 + 508 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i6 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 i5 = i14 + 520 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) == 3) break;
  HEAP32[i5 + (i4 << 2) >> 2] = 0;
  i4 = i4 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4516 | 0, i11 | 0, i10 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 do if (i10 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4517 | 0, i14 | 0, i11 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i4 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212ctype_bynameIcED2Ev(i11);
   break;
  } else {
   __ZNSt3__212ctype_bynameIcED2Ev(i11);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 do {
  i3 = i3 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 } while ((i3 | 0) != (i9 | 0));
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i13 | 0));
 do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i15 | 0));
 __ZNSt3__210__time_getD2Ev(i14);
 ___resumeException(i4 | 0);
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEy(i12, i5, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i10 | 0, i12 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0;
     HEAP32[i9 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     i1 = invoke_iiiiiii(i14 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0, i7 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEx(i12, i5, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i10 | 0, i12 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0;
     HEAP32[i9 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     i1 = invoke_iiiiiii(i14 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0, i7 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5IMGUI12GetGeneratorERK5RectTIfERK10GUIContentPN13TextRendering4FontE10TextAnchorbb11ColorRGBA32fii13ImagePosition(i10, i11, i14, i15, i4, i16, i17, f18, i19, i20, i8) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 f18 = Math_fround(f18);
 i19 = i19 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i5 = 0, f6 = f0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22 + 16 | 0;
 i5 = i22;
 i3 = i22 + 8 | 0;
 i12 = i22 + 4 | 0;
 i13 = __ZN13TextRendering17GetITextRenderingEv() | 0;
 if (!i13) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 if (!i4) {
  i12 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i21 >> 2] = HEAP32[i3 >> 2];
  i21 = mftCall_iiiiiifffiiifii(i12 | 0, i13 | 0, i11 | 0, i14 | 0, i15 | 0, 3, 0.0, 16.0, 1.0, i16 | 0, 1, i21 | 0, +f18, i19 | 0, i20 | 0) | 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i7 = i11 + 40 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) i3 = 0; else {
  HEAP32[i5 >> 2] = i3;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i9 = 10; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[i3 + 32 >> 2] | 0;
    i3 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i21, i3, i5);
    i4 = HEAP32[i21 >> 2] | 0;
    i23 = HEAP32[i3 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i3 = (i4 | 0) == -1 ? i23 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i23 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i9 = 10; else {
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) i9 = 12;
   }
  }
  if ((i9 | 0) == 10) i9 = 12;
  if ((i9 | 0) == 12) i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 }
 i4 = i10 + 8 | 0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 switch (i8 | 0) {
 case 0:
  {
   i9 = 15;
   break;
  }
 case 2:
  {
   i23 = 0;
   STACKTOP = i22;
   return i23 | 0;
  }
 default:
  {}
 }
 if ((i9 | 0) == 15) if (i3) {
  f6 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0);
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0;
  f2 = Math_fround(HEAPF32[gb + 1468168 >> 2]);
  if (f2 == Math_fround(0.0)) {
   f24 = Math_fround(i3 | 0);
   f2 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) / f6);
   f24 = Math_fround(Math_fround(HEAPF32[i10 + 12 >> 2]) / f24);
   f2 = f24 < f2 ? f24 : f2;
   i23 = f2 < Math_fround(0.0);
   i10 = f2 > Math_fround(1.0);
   f2 = i10 ? Math_fround(1.0) : f2;
   f2 = Math_fround(Math_floor(Math_fround(Math_fround(f6 * (i23 ? Math_fround(0.0) : f2)) + Math_fround(.5))));
  }
  f1 = Math_fround(f1 - f2);
 }
 i23 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i21 >> 2] = HEAP32[i12 >> 2];
 i23 = mftCall_iiiiiifffiiifii(i23 | 0, i13 | 0, i11 | 0, i14 | 0, i15 | 0, 3, +f1, 16.0, 1.0, i16 | 0, 1, i21 | 0, +f18, i19 | 0, i20 | 0) | 0;
 STACKTOP = i22;
 return i23 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj155ES2_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigEEEKNS_33PxClothStretchConfigGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i7, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 72 | 0;
 i6 = i9;
 i8 = i9 + 56 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = i11 + 24 | 0;
 i3 = i7 + 12 | 0;
 i1 = i7 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 i14 = i11 + 8 | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i13 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = HEAP32[i11 + 20 >> 2] | 0;
 i4 = HEAP32[i11 + 28 >> 2] | 0;
 i7 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i12;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj389ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj390ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj391ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj392ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 48 | 0, 3);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i15 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 mftCall_viii(i13 | 0, i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN22VertexCacheDeOptimizerIjLi16EE19DeOptimizeTrianglesEPjjPKjj(i13, i2, i1, i14, i15) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = __Znaj(i15) | 0;
 i17 = __Znaj(i1) | 0;
 _memset(i16 | 0, 0, i15 | 0) | 0;
 _memset(i17 | 0, 0, i1 | 0) | 0;
 i10 = (i15 | 0) == 0;
 i11 = i13 + 4 | 0;
 i12 = i13 + 8 | 0;
 i9 = i13 + 12 | 0;
 if (i10) {
  __ZdaPv(i16);
  __ZdaPv(i17);
  return;
 }
 while (1) {
  i1 = 0;
  i4 = 0;
  i5 = 4;
  i3 = 0;
  while (1) {
   if (!(HEAP8[i16 + i1 >> 0] | 0)) {
    i3 = i1 * 3 | 0;
    i3 = ((HEAP8[i17 + (HEAP32[i14 + (i3 + 1 << 2) >> 2] | 0) >> 0] | 0) != 0 & 1) + ((HEAP8[i17 + (HEAP32[i14 + (i3 << 2) >> 2] | 0) >> 0] | 0) != 0 & 1) + ((HEAP8[i17 + (HEAP32[i14 + (i3 + 2 << 2) >> 2] | 0) >> 0] | 0) != 0 & 1) | 0;
    i6 = i3 + 1 | 0;
    if (i6 >>> 0 > i5 >>> 0) i3 = 1; else if (!i3) break; else {
     i3 = 1;
     i5 = i6;
     i4 = i1;
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) {
    i18 = 7;
    break;
   }
  }
  if ((i18 | 0) == 7) {
   i18 = 0;
   if (!(i3 & 1)) {
    i18 = 30;
    break;
   } else i1 = i4;
  }
  HEAP8[i16 + i1 >> 0] = 1;
  i8 = i1 * 3 | 0;
  i4 = HEAP32[i14 + (i8 << 2) >> 2] | 0;
  i7 = HEAP32[i14 + (i8 + 1 << 2) >> 2] | 0;
  i8 = HEAP32[i14 + (i8 + 2 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i7;
  HEAP32[i2 + 8 >> 2] = i8;
  i2 = i2 + 12 | 0;
  i5 = i17 + i4 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i6 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i6 + (i1 << 2) >> 2] = i4;
   HEAP8[i5 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i4 = i17 + i7 | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i5 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i5 + (i1 << 2) >> 2] = i7;
   HEAP8[i4 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i5 = i17 + i8 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i4 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i4 + (i1 << 2) >> 2] = i8;
   HEAP8[i5 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  if (i10) {
   i18 = 30;
   break;
  }
 }
 if ((i18 | 0) == 30) {
  __ZdaPv(i16);
  __ZdaPv(i17);
  return;
 }
}

function __ZN7mecanim9animation30AllocateAvatarOuputForBindingsEPNS0_12AvatarOutputEbPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i7, i1, i8, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i6 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i8, i9) | 0;
  HEAP32[i7 >> 2] = i6;
  i8 = __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i8, i9) | 0;
  i9 = i7 + 4 | 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i3 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 332, 4) | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i3 + 4 | 0;
 i1 = i3 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 1065353216;
 HEAP32[i3 + 56 >> 2] = 1065353216;
 HEAP32[i3 + 60 >> 2] = 1065353216;
 HEAP32[i3 + 64 >> 2] = 1065353216;
 i1 = i3 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 1065353216;
 HEAP32[i3 + 96 >> 2] = 1065353216;
 HEAP32[i3 + 100 >> 2] = 1065353216;
 HEAP32[i3 + 104 >> 2] = 1065353216;
 i1 = i3 + 108 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 132 >> 2] = 1065353216;
 HEAP32[i3 + 136 >> 2] = 1065353216;
 HEAP32[i3 + 140 >> 2] = 1065353216;
 HEAP32[i3 + 144 >> 2] = 1065353216;
 i1 = i3 + 148 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 172 >> 2] = 1065353216;
 HEAP32[i3 + 176 >> 2] = 1065353216;
 HEAP32[i3 + 180 >> 2] = 1065353216;
 HEAP32[i3 + 184 >> 2] = 1065353216;
 i1 = i3 + 188 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 212 >> 2] = 1065353216;
 HEAP32[i3 + 216 >> 2] = 1065353216;
 HEAP32[i3 + 220 >> 2] = 1065353216;
 HEAP32[i3 + 224 >> 2] = 1065353216;
 i1 = i3 + 228 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 252 >> 2] = 1065353216;
 HEAP32[i3 + 256 >> 2] = 1065353216;
 HEAP32[i3 + 260 >> 2] = 1065353216;
 HEAP32[i3 + 264 >> 2] = 1065353216;
 i1 = i3 + 320 | 0;
 i2 = i3 + 316 | 0;
 i5 = i3 + 268 | 0;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i3 + 324 >> 2] = 1065353216;
 HEAP32[i3 + 328 >> 2] = 1065353216;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3;
 i6 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i8, i9) | 0;
 HEAP32[i7 >> 2] = i6;
 i8 = __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i8, i9) | 0;
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = i8;
 return;
}

function __ZN5physx31initCollDataAndApplyConstraintsERNS_19PxsParticleCollDataERKNS_16PxsFluidParticleERKNS_6PxVec3EfS7_S7_PKNS_11PxsBodyCoreESA_jRKNS_27PxsFluidCollisionParametersE(i21, i13, i19, f2, i16, i18, i15, i17, i20, i23) {
 i21 = i21 | 0;
 i13 = i13 | 0;
 i19 = i19 | 0;
 f2 = Math_fround(f2);
 i16 = i16 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 i20 = i20 | 0;
 i23 = i23 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i22 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24;
 i14 = i13 + 28 | 0;
 i5 = HEAPU16[i14 >> 1] | HEAPU16[i14 + 2 >> 1] << 16;
 i6 = i5 >>> 16;
 i1 = i21 + 44 | 0;
 i3 = i21;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i21 + 92 >> 2] = f2;
 i11 = i21 + 48 | 0;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 i12 = i21 + 52 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 + 4 >> 2];
 i9 = i21 + 56 | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 + 8 >> 2];
 i10 = i21 + 60 | 0;
 HEAP16[i10 >> 1] = i5 & 65529;
 HEAP16[i21 + 62 >> 1] = i5 >>> 17 & 16 | i6 & 65487;
 HEAP32[i21 + 76 >> 2] = i20;
 i3 = i21 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 f8 = Math_fround(HEAPF32[i23 + 64 >> 2]);
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i13 + 16 >> 2]));
 f7 = Math_fround(f8 * Math_fround(HEAPF32[i13 + 20 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i13 + 24 >> 2]));
 HEAPF32[i22 >> 2] = f2;
 i4 = i22 + 4 | 0;
 HEAPF32[i4 >> 2] = f7;
 i5 = i22 + 8 | 0;
 HEAPF32[i5 >> 2] = f8;
 if (HEAP16[i13 + 30 >> 1] & 3) {
  i1 = i21 + 108 | 0;
  if (__ZN5physx16applyConstraintsERKNS_6PxVec3ERS0_S2_RPKNS_11PxsBodyCoreES3_S3_PKNS_18PxsFluidConstraintESA_S6_S6_S2_S2_jRKNS_27PxsFluidCollisionParametersERKNS_16PxvParticleFlagsE(i11, i22, i19, i1, i21, i21 + 32 | 0, HEAP32[i21 + 140 >> 2] | 0, HEAP32[i21 + 156 >> 2] | 0, i15, i17, i16, i18, i20, i23, i14) | 0) {
   if (!(HEAP32[i1 >> 2] | 0)) i1 = HEAPU16[i10 >> 1] | 0 | 2; else {
    f25 = Math_fround(f2 - Math_fround(HEAPF32[i22 >> 2]));
    f7 = Math_fround(f7 - Math_fround(HEAPF32[i4 >> 2]));
    f8 = Math_fround(f8 - Math_fround(HEAPF32[i5 >> 2]));
    f2 = Math_fround(HEAPF32[i23 + 68 >> 2]);
    f7 = Math_fround(f7 * f2);
    f8 = Math_fround(f8 * f2);
    HEAPF32[i3 >> 2] = Math_fround(f25 * f2);
    HEAPF32[i21 + 100 >> 2] = f7;
    HEAPF32[i21 + 104 >> 2] = f8;
    i1 = HEAPU16[i10 >> 1] | 0 | 4;
   }
   HEAP16[i10 >> 1] = i1;
   i20 = i21 + 12 | 0;
   HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | 4;
  }
 }
 f27 = Math_fround(HEAPF32[i11 >> 2]);
 f7 = Math_fround(HEAPF32[i22 >> 2]);
 f27 = Math_fround(f27 + f7);
 f26 = Math_fround(HEAPF32[i12 >> 2]);
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f26 = Math_fround(f26 + f8);
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 f25 = Math_fround(HEAPF32[i5 >> 2]);
 f2 = Math_fround(f2 + f25);
 HEAPF32[i21 + 64 >> 2] = f27;
 HEAPF32[i21 + 68 >> 2] = f26;
 HEAPF32[i21 + 72 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i23 + 68 >> 2]);
 f8 = Math_fround(f2 * f8);
 f25 = Math_fround(f2 * f25);
 HEAPF32[i21 + 80 >> 2] = Math_fround(f2 * f7);
 HEAPF32[i21 + 84 >> 2] = f8;
 HEAPF32[i21 + 88 >> 2] = f25;
 STACKTOP = i24;
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 28 | 0;
 i2 = i4;
 if (!i5) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0;
 if ((HEAP16[i5 + 4 >> 1] | 0) == 6) {
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i5 | 0);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i5 | 0);
  f17 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
  f18 = Math_fround(HEAPF32[i1 >> 2]);
  f7 = Math_fround(f17 * f18);
  f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f15 * f16));
  f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(f10 * f14));
  f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
  f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
  f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
  f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
  f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(f20 * f17);
  f19 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f18 * f19));
  f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f16 * f10));
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
  f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
  HEAPF32[i6 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
  HEAPF32[i6 + 4 >> 2] = f12;
  HEAPF32[i6 + 8 >> 2] = f11;
  HEAPF32[i6 + 12 >> 2] = f10;
  HEAPF32[i6 + 16 >> 2] = f9;
  HEAPF32[i6 + 20 >> 2] = f8;
  HEAPF32[i6 + 24 >> 2] = f7;
  STACKTOP = i4;
  return;
 }
}

function __Z33EmitSerializationCommandsForFieldI17RemapPPtrTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI17RemapPPtrTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_(i5, i6, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 64 | 0;
 i9 = i10;
 i7 = __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_(i5, i6, i4, i3, i1) | 0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f11 < Math_fround(HEAPF32[i3 >> 2]))) {
  i9 = i7;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i9, i3);
 __ZN14AnimationEventaSERKS_(i3, i2) | 0;
 __ZN14AnimationEventaSERKS_(i2, i9) | 0;
 i1 = i9 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
 }
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f11 < Math_fround(HEAPF32[i4 >> 2]))) {
  i9 = i7 + 1 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i9, i4);
 __ZN14AnimationEventaSERKS_(i4, i3) | 0;
 __ZN14AnimationEventaSERKS_(i3, i9) | 0;
 i1 = i9 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
 }
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 if (!(f11 < Math_fround(HEAPF32[i6 >> 2]))) {
  i9 = i7 + 2 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i9, i6);
 __ZN14AnimationEventaSERKS_(i6, i4) | 0;
 __ZN14AnimationEventaSERKS_(i4, i9) | 0;
 i1 = i9 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
 }
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f11 < Math_fround(HEAPF32[i5 >> 2]))) {
  i9 = i7 + 3 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i9, i5);
 __ZN14AnimationEventaSERKS_(i5, i6) | 0;
 __ZN14AnimationEventaSERKS_(i6, i9) | 0;
 i1 = i9 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 + 32 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i9 = i7 + 4 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN22BaseUnityConnectClientD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 188820 + 8;
 i1 = HEAP32[i5 + 544 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  }
 }
 i1 = HEAP32[i5 + 664 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 668 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 676 >> 2] | 0;
  HEAP32[i6 >> 2] = 85;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 __ZN11UnityEngine7Connect13ConnectConfig11ConfigValueD2Ev(i5 + 552 | 0);
 __ZN11UnityEngine7Connect18ConnectSessionInfoD2Ev(i5 + 352 | 0);
 i2 = i5 + 296 | 0;
 i1 = i5 + 328 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 340 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 312 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 324 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i5 + 308 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 __ZN11UnityEngine15CloudWebService18CloudServiceConfigD2Ev(i5 + 164 | 0);
 i1 = i5 + 148 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 160 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 132 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 144 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 116 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 128 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 60 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 44 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 28 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 STACKTOP = i7;
 return;
}

function __ZL16SimplifyPolylineR13dynamic_arrayI8Vector2fLj4EEf(i13, f2) {
 i13 = i13 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i14 = 0, f15 = f0, i16 = 0, i17 = 0;
 i14 = i13 + 12 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 >>> 0 <= 2) return;
 f12 = Math_fround(f2 * f2);
 i3 = i1;
 i11 = 0;
 L4 : while (1) {
  i9 = i11;
  i11 = i11 + 1 | 0;
  L6 : do if (!i9) while (1) {
   i8 = i3;
   i3 = i3 + -1 | 0;
   i9 = HEAP32[i13 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i9 + (i3 << 3) >> 2]);
   f6 = Math_fround(HEAPF32[i9 + (i3 << 3) + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i9 >> 2]);
   f7 = Math_fround(HEAPF32[i9 + 4 >> 2]);
   i10 = (i11 | 0) == (i8 | 0) ? 0 : i11;
   f2 = Math_fround(HEAPF32[i9 + (i10 << 3) >> 2]);
   f2 = Math_fround(f2 - f5);
   f4 = Math_fround(Math_fround(HEAPF32[i9 + (i10 << 3) + 4 >> 2]) - f6);
   f5 = Math_fround(f15 - f5);
   f6 = Math_fround(f7 - f6);
   f7 = Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4));
   if (f7 == Math_fround(0.0)) f2 = Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)); else {
    f7 = Math_fround(Math_fround(Math_fround(f5 * f2) + Math_fround(f6 * f4)) / f7);
    i10 = f7 < Math_fround(0.0);
    i16 = f7 > Math_fround(1.0);
    f7 = i16 ? Math_fround(1.0) : f7;
    f7 = i10 ? Math_fround(0.0) : f7;
    f15 = Math_fround(Math_fround(f2 * f7) - f5);
    f2 = Math_fround(Math_fround(f4 * f7) - f6);
    f2 = Math_fround(Math_fround(f15 * f15) + Math_fround(f2 * f2));
   }
   if (!(f2 < f12)) {
    i3 = i8;
    break L6;
   }
   _memmove(i9 | 0, i9 + 8 | 0, (i1 << 3) + -8 | 0) | 0;
   i1 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
   HEAP32[i14 >> 2] = i1;
   if (i3 >>> 0 <= 2) {
    i1 = 16;
    break L4;
   }
  } else {
   i10 = i9 + -1 | 0;
   while (1) {
    i8 = HEAP32[i13 >> 2] | 0;
    f5 = Math_fround(HEAPF32[i8 + (i10 << 3) >> 2]);
    f6 = Math_fround(HEAPF32[i8 + (i10 << 3) + 4 >> 2]);
    f15 = Math_fround(HEAPF32[i8 + (i9 << 3) >> 2]);
    f7 = Math_fround(HEAPF32[i8 + (i9 << 3) + 4 >> 2]);
    i16 = (i11 | 0) == (i3 | 0) ? 0 : i11;
    f2 = Math_fround(HEAPF32[i8 + (i16 << 3) >> 2]);
    f2 = Math_fround(f2 - f5);
    f4 = Math_fround(Math_fround(HEAPF32[i8 + (i16 << 3) + 4 >> 2]) - f6);
    f5 = Math_fround(f15 - f5);
    f6 = Math_fround(f7 - f6);
    f7 = Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4));
    if (f7 == Math_fround(0.0)) f2 = Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)); else {
     f7 = Math_fround(Math_fround(Math_fround(f5 * f2) + Math_fround(f6 * f4)) / f7);
     i16 = f7 < Math_fround(0.0);
     i17 = f7 > Math_fround(1.0);
     f7 = i17 ? Math_fround(1.0) : f7;
     f7 = i16 ? Math_fround(0.0) : f7;
     f15 = Math_fround(Math_fround(f2 * f7) - f5);
     f2 = Math_fround(Math_fround(f4 * f7) - f6);
     f2 = Math_fround(Math_fround(f15 * f15) + Math_fround(f2 * f2));
    }
    if (!(f2 < f12)) break L6;
    i16 = i8 + (i9 << 3) | 0;
    i17 = i16 + 8 | 0;
    _memmove(i16 | 0, i17 | 0, i8 + (i1 << 3) - i17 | 0) | 0;
    i1 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
    HEAP32[i14 >> 2] = i1;
    i3 = i3 + -1 | 0;
    if (!(i9 >>> 0 < i3 >>> 0 & i3 >>> 0 > 2)) {
     i1 = 16;
     break L4;
    }
   }
  } while (0);
  if (!(i11 >>> 0 < i3 >>> 0 & i3 >>> 0 > 2)) {
   i1 = 16;
   break;
  }
 }
 if ((i1 | 0) == 16) return;
}

function __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 - i3 | 0;
 i5 = (i1 | 0) / 88 | 0;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4;
 i9 = i6;
 if (i5 >>> 0 > (((HEAP32[i7 >> 2] | 0) - i4 | 0) / 88 | 0) >>> 0) {
  __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i8);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i6 = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 88 | 0;
  i1 = i6 << 1;
  i1 = i6 >>> 0 < 1073741823 ? (i1 >>> 0 < i5 >>> 0 ? i5 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 88 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 * 88 | 0);
  if ((i3 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i1 = i3;
  do {
   __ZN24CompressedAnimationCurveC2ERKS_(i2, i1);
   i1 = i1 + 88 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 88 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 88 | 0;
 i4 = i5 >>> 0 > i1 >>> 0;
 i1 = i4 ? i3 + (i1 * 88 | 0) | 0 : i6;
 if ((i3 | 0) == (i1 | 0)) i5 = i2; else {
  do {
   __ZN24CompressedAnimationCurveaSERKS_(i2, i3) | 0;
   i3 = i3 + 88 | 0;
   i2 = i2 + 88 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i5 = i2;
 }
 if (i4) {
  if ((i1 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN24CompressedAnimationCurveC2ERKS_(i2, i1);
   i1 = i1 + 88 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = i10 + 4 | 0;
 do {
  HEAP32[i7 >> 2] = i1 + -88;
  i2 = i1 + -16 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + -4 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i2 = HEAP32[i1 + -36 >> 2] | 0;
  if (i2 | 0) {
   i3 = i1 + -32 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
   __ZdlPv(i2);
  }
  i2 = HEAP32[i1 + -64 >> 2] | 0;
  if (i2 | 0) {
   i3 = i1 + -60 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
   __ZdlPv(i2);
  }
  i2 = HEAP32[i1 + -80 >> 2] | 0;
  if (i2 | 0) {
   i1 = i1 + -76 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
   __ZdlPv(i2);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __Z14FindAvatarRootPKN7mecanim8skeleton8SkeletonEPKjR9Transformb(i14, i13, i1, i3) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i19 + 8 | 0;
 i12 = i19;
 i18 = i19 + 16 | 0;
 i17 = gb + 64016 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i12;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i18 >> 2] = 0;
 i15 = i18 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i12);
 i12 = i5;
 i4 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i17;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = HEAP32[i14 >> 2] | 0;
 i4 = i2 << 1;
 if (i4 | 0) {
  HEAP32[i16 >> 2] = i4;
  HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i2 << 3, 4, i17, 0, gb + 1047584 | 0, 464) | 0;
 }
 __Z18BuildTransformListR9TransformR13dynamic_arrayIPS_Lj4EE(i1, i18);
 L4 : do if ((HEAP32[i15 >> 2] | 0) > 0) {
  if (i3) {
   i4 = 0;
   i1 = 0;
   i2 = 0;
   while (1) {
    i3 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    HEAP32[i5 >> 2] = -1;
    i3 = __Z15HiearchyMatchesP9TransformPKN7mecanim8skeleton8SkeletonEiRKNS1_5crc32E(i3, i14, 0, i5) | 0;
    if ((i3 | 0) > (i2 | 0)) {
     i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     i2 = i3;
    }
    i13 = HEAP32[i15 >> 2] | 0;
    i12 = i4;
    i4 = i4 + 1 | 0;
    if (!(i2 >>> 0 < (i13 + ~i12 | 0) >>> 0 & (i4 | 0) < (i13 | 0))) break L4;
   }
  } else {
   i12 = 0;
   i1 = 0;
   i11 = 0;
  }
  while (1) {
   i10 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i12 << 2) >> 2] | 0;
   i9 = i10 + 80 | 0;
   i10 = i10 + 92 | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   if (!i3) i2 = 0; else {
    i5 = HEAP32[i9 >> 2] | 0;
    i8 = i5;
    i2 = 0;
    i4 = HEAP32[i14 >> 2] | 0;
    do {
     if (!i4) i4 = 0; else {
      i7 = 0;
      do {
       i6 = HEAP32[i13 + (i7 << 2) >> 2] | 0;
       i3 = HEAP32[i8 >> 2] | 0;
       i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
       i4 = _strlen(i3) | 0;
       i5 = i3 + i4 | 0;
       if ((i4 | 0) > 0) {
        i4 = -1;
        do {
         i4 = HEAP32[gb + 1111240 + (((HEAPU8[i3 >> 0] | 0) ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) != (i5 | 0));
        i3 = ~i4;
       } else i3 = 0;
       i2 = ((i6 | 0) == (i3 | 0) & 1) + i2 | 0;
       i7 = i7 + 1 | 0;
       i4 = HEAP32[i14 >> 2] | 0;
      } while (i7 >>> 0 < i4 >>> 0);
      i5 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i10 >> 2] | 0;
     }
     i8 = i8 + 4 | 0;
    } while ((i8 | 0) != (i5 + (i3 << 2) | 0));
   }
   if ((i2 | 0) > (i11 | 0)) i1 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i12 << 2) >> 2] | 0; else i2 = i11;
   i11 = HEAP32[i15 >> 2] | 0;
   i10 = i12;
   i12 = i12 + 1 | 0;
   if (!(i2 >>> 0 < (i11 + ~i10 | 0) >>> 0 & (i12 | 0) < (i11 | 0))) break; else i11 = i2;
  }
 } else i1 = 0; while (0);
 if ((HEAP32[i16 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
 HEAP32[i18 >> 2] = 0;
 STACKTOP = i19;
 return i1 | 0;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i15, i6) {
 i15 = i15 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = i15 + 4 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 20 | 0) + 1 | 0;
 if (i3 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i15 >> 2] | 0;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i14 = i15 + 8 | 0;
 i13 = ((HEAP32[i14 >> 2] | 0) - i1 | 0) / 20 | 0;
 i10 = i13 << 1;
 i3 = i13 >>> 0 < 107374182 ? (i10 >>> 0 < i3 >>> 0 ? i3 : i10) : 214748364;
 i10 = (i2 - i1 | 0) / 20 | 0;
 if (!i3) i11 = 0; else i11 = __Znwj(i3 * 20 | 0) | 0;
 i4 = i11 + (i10 * 20 | 0) | 0;
 i2 = i4;
 i13 = i11 + (i3 * 20 | 0) | 0;
 i12 = i6;
 i5 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i11 + (i10 * 20 | 0) + 8 | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 i12 = i11 + (i10 * 20 | 0) + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + (i10 * 20 | 0) + 16 >> 2] = 0;
 i6 = i6 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i7 = i1 - i3 | 0;
 i8 = (i7 | 0) / 24 | 0;
 if (i7 | 0) {
  if (i8 >>> 0 > 178956970) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } else i5 = i3;
  i3 = __Znwj(i7) | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i11 + (i10 * 20 | 0) + 16 >> 2] = i3 + (i8 * 24 | 0);
  i1 = i1 - i5 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i5 | 0, i1 | 0) | 0;
   HEAP32[i12 >> 2] = i3 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
  }
 }
 i12 = i4 + 20 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i7 = i11;
  i1 = i11;
 } else {
  do {
   i8 = i1;
   i1 = i1 + -20 | 0;
   i10 = i1;
   i6 = HEAP32[i10 + 4 >> 2] | 0;
   i5 = i4 + -20 | 0;
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i5 + 4 >> 2] = i6;
   i5 = i4 + -12 | 0;
   i6 = i8 + -12 | 0;
   HEAP32[i5 >> 2] = 0;
   i10 = i4 + -8 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i4 + -4 >> 2] = 0;
   i8 = i8 + -8 | 0;
   i3 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
   i7 = (i3 | 0) / 24 | 0;
   if (i3 | 0) {
    if (i7 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
    i9 = __Znwj(i3) | 0;
    HEAP32[i10 >> 2] = i9;
    HEAP32[i5 >> 2] = i9;
    HEAP32[i4 + -4 >> 2] = i9 + (i7 * 24 | 0);
    i4 = HEAP32[i6 >> 2] | 0;
    i3 = (HEAP32[i8 >> 2] | 0) - i4 | 0;
    if ((i3 | 0) > 0) {
     _memcpy(i9 | 0, i4 | 0, i3 | 0) | 0;
     HEAP32[i10 >> 2] = i9 + (((i3 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i4 = i2 + -20 | 0;
   i2 = i4;
  } while ((i1 | 0) != (i11 | 0));
  i7 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i2;
 HEAP32[i16 >> 2] = i12;
 HEAP32[i14 >> 2] = i13;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) do {
  i2 = HEAP32[i1 + -12 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + -8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i2);
  }
  i1 = i1 + -20 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if (!i7) return;
 __ZdlPv(i7);
 return;
}

function __ZN21ArchiveStorageCreator14StoreDirectoryEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i12 = i14 + 1084 | 0;
 i8 = i14;
 i13 = i14 + 16 | 0;
 i9 = i11 + 1176 | 0;
 i6 = ((((HEAP32[i11 + 1196 >> 2] | 0) - (HEAP32[i11 + 1192 >> 2] | 0) | 0) / 12 | 0) * 10 | 0) + 20 | 0;
 i7 = i11 + 1208 | 0;
 i1 = HEAP32[i11 + 1212 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) i1 = 4; else {
  i4 = (i1 - i2 | 0) / 40 | 0;
  i1 = 4;
  i3 = 0;
  do {
   i2 = HEAP8[i5 + (i3 * 40 | 0) + 20 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i2 = HEAP32[i5 + (i3 * 40 | 0) + 24 >> 2] | 0; else i2 = i2 & 255;
   i1 = i1 + 21 + i2 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 }
 i5 = i6 + i1 | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 64016 | 0, 0, gb + 490375 | 0, 583) | 0;
 i3 = gb + 64016 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN10MemoryFile21CreateFileSystemEntryE10MemLabelId14FilePermissionPvjb(i12, i10, 2, i1, i5, 0);
 __ZN12FileAccessorC2Ev(i13);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i13, i12, 1, 0) | 0)) {
  i11 = 0;
  __ZN12FileAccessorD2Ev(i13);
  __ZN13FileEntryDataD2Ev(i12);
  STACKTOP = i14;
  return i11 | 0;
 }
 if (!(__ZN12FileAccessor9SetLengthEy(i13, 0, 0) | 0)) {
  i11 = 0;
  __ZN12FileAccessorD2Ev(i13);
  __ZN13FileEntryDataD2Ev(i12);
  STACKTOP = i14;
  return i11 | 0;
 }
 if (!(__ZN20ArchiveStorageHeader15WriteBlocksInfoER12FileAccessorRKNS_10BlocksInfoE(i13, i9) | 0)) {
  i11 = 0;
  __ZN12FileAccessorD2Ev(i13);
  __ZN13FileEntryDataD2Ev(i12);
  STACKTOP = i14;
  return i11 | 0;
 }
 if (!(__ZN20ArchiveStorageHeader18WriteDirectoryInfoER12FileAccessorRKNS_13DirectoryInfoE(i13, i7) | 0)) {
  i11 = 0;
  __ZN12FileAccessorD2Ev(i13);
  __ZN13FileEntryDataD2Ev(i12);
  STACKTOP = i14;
  return i11 | 0;
 }
 i3 = __ZN12FileAccessor5WriteEyPKvPy(i11 + 12 | 0, i5, 0, i1, i10) | 0;
 i4 = i10;
 i4 = i3 & ((HEAP32[i4 + 4 >> 2] | 0) == 0 ? (HEAP32[i4 >> 2] | 0) == (i5 | 0) : 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 i1 = i11 + 1168 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 & -128 | 64;
 HEAP32[i11 + 1160 >> 2] = i5;
 HEAP32[i11 + 1164 >> 2] = i5;
 i1 = HEAP8[i11 + 1116 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i11 + 1120 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i11 + 1132 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i11 + 1136 >> 2] | 0; else i1 = i1 & 255;
 i2 = i2 + 5 + i1 | 0;
 if (!(i3 & 256)) {
  i1 = HEAP8[i11 + 1096 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i11 + 1100 >> 2] | 0; else i1 = i1 & 255;
  i1 = i2 + 22 + i1 | 0;
 } else i1 = i2 + 31 | 0;
 i9 = i11 + 1232 | 0;
 i9 = _i64Add(i1 + i5 | 0, 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0) | 0;
 i10 = getTempRet0() | 0;
 i11 = i11 + 1152 | 0;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = i4;
 __ZN12FileAccessorD2Ev(i13);
 __ZN13FileEntryDataD2Ev(i12);
 STACKTOP = i14;
 return i11 | 0;
}

function __ZL15SweepBoxCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i11) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, i24 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 88 | 0;
 i17 = i12 + 72 | 0;
 i16 = i12 + 40 | 0;
 i15 = i12 + 28 | 0;
 i14 = i12;
 i13 = i12 + 136 | 0;
 HEAP32[i17 >> 2] = 3;
 i24 = i4 + 40 | 0;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAPF32[i16 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 2;
 i1 = i15 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 64 >> 2];
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i3 + 40 | 0, i3 + 52 | 0, i1);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP16[i10 + 12 >> 1] = 0;
 i3 = i10 + 16 | 0;
 i1 = i10 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i11 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i10, i13, Math_fround(0.0)) | 0)) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 36 >> 2];
 HEAP32[i11 + 40 >> 2] = -1;
 HEAP32[i11 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i11 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i10 + 20 >> 2]);
 HEAPF64[i11 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i10 + 24 >> 2]);
 HEAPF64[i11 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i24 = 1;
 STACKTOP = i12;
 return i24 | 0;
}

function __Z41LightmapSettings_Get_Custom_PropLightmapsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15;
 i1 = __Z19GetLightmapSettingsv() | 0;
 i11 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 252 >> 2] | 0;
 i12 = i1 + 48 | 0;
 i13 = __Z19scripting_array_newP11Il2CppClassjj(i11, 4, HEAP32[i12 >> 2] | 0) | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i15;
  return i13 | 0;
 }
 i8 = i1 + 36 | 0;
 i7 = 0;
 do {
  i5 = HEAP32[i8 >> 2] | 0;
  i4 = i5 + (i7 << 3) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 11;
    }
   }
   if ((i14 | 0) == 9) i14 = 11;
   if ((i14 | 0) == 11) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  i4 = i5 + (i7 << 3) + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 19; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 19; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 21;
    }
   }
   if ((i14 | 0) == 19) i14 = 21;
   if ((i14 | 0) == 21) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  i5 = _il2cpp_object_new(i11 | 0) | 0;
  HEAP32[i5 + 8 >> 2] = i6;
  HEAP32[i5 + 12 >> 2] = i4;
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i13, i7, i5);
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 STACKTOP = i15;
 return i13 | 0;
}

function __Z34Sprite_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObjectRK5RectTIfERK13Vector2fIcallfj14SpriteMeshTypeRK8Vector4f(i6, i19, i12, f13, i14, i15, i16) {
 i6 = i6 | 0;
 i19 = i19 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0, i18 = 0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 56 | 0;
 i8 = i18 + 48 | 0;
 i10 = i18 + 8 | 0;
 i11 = i18 + 52 | 0;
 i7 = i18;
 HEAP32[i11 >> 2] = i6;
 if (!i6) {
  i19 = 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0)) {
  i19 = 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 f3 = Math_fround(HEAPF32[i19 >> 2]);
 i9 = i19 + 8 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 f4 = Math_fround(f3 + f4);
 i5 = i19 + 4 | 0;
 if (f4 > Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0)) i1 = i19 + 12 | 0; else {
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  i1 = i19 + 12 | 0;
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
  if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
  f4 = Math_fround(f3 + f4);
  if (!(f4 > Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0))) {
   if (f13 <= Math_fround(0.0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 568383 | 0, i8);
   i10 = gb + 63520 | 0;
   i1 = HEAP32[i10 + 4 >> 2] | 0;
   i2 = i7;
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   i2 = __Z20CreateObjectFromCodeI6SpriteEPT_17AwakeFromLoadMode10MemLabelId(4, i17) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
   HEAP32[i17 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   __ZN6Sprite10InitializeEP9Texture2DRK5RectTIfERK8Vector2ffj14SpriteMeshTypeRK8Vector4ffbPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENSD_9allocatorISG_EEEE(i2, i1, i19, i17, f13, i14, i15, i16, Math_fround(-1.0), 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 4);
   i19 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
   STACKTOP = i18;
   return i19 | 0;
  }
 }
 d23 = +Math_fround(HEAPF32[i19 >> 2]);
 d22 = +Math_fround(HEAPF32[i5 >> 2]);
 d21 = +Math_fround(HEAPF32[i9 >> 2]);
 d20 = +Math_fround(HEAPF32[i1 >> 2]);
 i18 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i11) | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 136 >> 2] | 0, i18 | 0) | 0;
 i19 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i11) | 0;
 i19 = mftCall_ii(HEAP32[(HEAP32[i19 >> 2] | 0) + 140 >> 2] | 0, i19 | 0) | 0;
 HEAPF64[i10 >> 3] = d23;
 HEAPF64[i10 + 8 >> 3] = d22;
 HEAPF64[i10 + 16 >> 3] = d21;
 HEAPF64[i10 + 24 >> 3] = d20;
 HEAP32[i10 + 32 >> 2] = i18;
 HEAP32[i10 + 36 >> 2] = i19;
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 568320 | 0, i10);
 return 0;
}

function __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i13, i10, i11, i12, i1) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10;
 if (!(i1 & 4)) {
  i1 = 0;
  i8 = i13;
 } else if ((i9 - i13 | 0) > 2) if ((HEAP8[i13 >> 0] | 0) == -17) if ((HEAP8[i13 + 1 >> 0] | 0) == -69) {
  i1 = 0;
  i8 = (HEAP8[i13 + 2 >> 0] | 0) == -65 ? i13 + 3 | 0 : i13;
 } else {
  i1 = 0;
  i8 = i13;
 } else {
  i1 = 0;
  i8 = i13;
 } else {
  i1 = 0;
  i8 = i13;
 }
 L6 : while (1) {
  if (!(i1 >>> 0 < i11 >>> 0 & i8 >>> 0 < i10 >>> 0)) {
   i2 = 39;
   break;
  }
  i6 = HEAP8[i8 >> 0] | 0;
  i7 = i6 & 255;
  if (i7 >>> 0 > i12 >>> 0) {
   i2 = 39;
   break;
  }
  do if (i6 << 24 >> 24 > -1) i2 = i8 + 1 | 0; else {
   if ((i6 & 255) < 194) {
    i2 = 39;
    break L6;
   }
   if ((i6 & 255) < 224) {
    if ((i9 - i8 | 0) < 2) {
     i2 = 39;
     break L6;
    }
    i2 = HEAPU8[i8 + 1 >> 0] | 0;
    if ((i2 & 192 | 0) != 128) {
     i2 = 39;
     break L6;
    }
    if ((i2 & 63 | i7 << 6 & 1984) >>> 0 > i12 >>> 0) {
     i2 = 39;
     break L6;
    } else {
     i2 = i8 + 2 | 0;
     break;
    }
   }
   if ((i6 & 255) < 240) {
    i3 = i8;
    if ((i9 - i3 | 0) < 3) {
     i2 = 39;
     break L6;
    }
    i4 = HEAP8[i8 + 1 >> 0] | 0;
    i2 = HEAP8[i8 + 2 >> 0] | 0;
    switch (i6 << 24 >> 24) {
    case -32:
     {
      if ((i4 & -32) << 24 >> 24 != -96) {
       i2 = 19;
       break L6;
      }
      break;
     }
    case -19:
     {
      if ((i4 & -32) << 24 >> 24 != -128) {
       i2 = 21;
       break L6;
      }
      break;
     }
    default:
     if ((i4 & -64) << 24 >> 24 != -128) {
      i2 = 23;
      break L6;
     }
    }
    i2 = i2 & 255;
    if ((i2 & 192 | 0) != 128) {
     i2 = 39;
     break L6;
    }
    if (((i4 & 255) << 6 & 4032 | i7 << 12 & 61440 | i2 & 63) >>> 0 > i12 >>> 0) {
     i2 = 39;
     break L6;
    } else {
     i2 = i8 + 3 | 0;
     break;
    }
   }
   if ((i6 & 255) >= 245) {
    i2 = 39;
    break L6;
   }
   i3 = i8;
   if ((i11 - i1 | 0) >>> 0 < 2 | (i9 - i3 | 0) < 4) {
    i2 = 39;
    break L6;
   }
   i5 = HEAP8[i8 + 1 >> 0] | 0;
   i2 = HEAP8[i8 + 2 >> 0] | 0;
   i4 = HEAP8[i8 + 3 >> 0] | 0;
   switch (i6 << 24 >> 24) {
   case -16:
    {
     if ((i5 + 112 & 255) >= 48) {
      i2 = 30;
      break L6;
     }
     break;
    }
   case -12:
    {
     if ((i5 & -16) << 24 >> 24 != -128) {
      i2 = 32;
      break L6;
     }
     break;
    }
   default:
    if ((i5 & -64) << 24 >> 24 != -128) {
     i2 = 34;
     break L6;
    }
   }
   i3 = i2 & 255;
   if ((i3 & 192 | 0) != 128) {
    i2 = 39;
    break L6;
   }
   i2 = i4 & 255;
   if ((i2 & 192 | 0) != 128) {
    i2 = 39;
    break L6;
   }
   if (((i5 & 255) << 12 & 258048 | i7 << 18 & 1835008 | i3 << 6 & 4032 | i2 & 63) >>> 0 > i12 >>> 0) {
    i2 = 39;
    break L6;
   } else {
    i1 = i1 + 1 | 0;
    i2 = i8 + 4 | 0;
   }
  } while (0);
  i1 = i1 + 1 | 0;
  i8 = i2;
 }
 if ((i2 | 0) == 19) i1 = i3 - i13 | 0; else if ((i2 | 0) == 21) i1 = i3 - i13 | 0; else if ((i2 | 0) == 23) i1 = i3 - i13 | 0; else if ((i2 | 0) == 30) i1 = i3 - i13 | 0; else if ((i2 | 0) == 32) i1 = i3 - i13 | 0; else if ((i2 | 0) == 34) i1 = i3 - i13 | 0; else if ((i2 | 0) == 39) i1 = i8 - i13 | 0;
 return i1 | 0;
}

function __ZNK5Umbra15IntersectFilter11boundsCheckERKNS_4AABBE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i1 >> 2]) >= Math_fround(HEAPF32[i8 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) <= Math_fround(HEAPF32[i8 + 12 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) >= Math_fround(HEAPF32[i8 + 4 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(Math_fround(HEAPF32[i1 + 16 >> 2]) <= Math_fround(HEAPF32[i8 + 16 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) >= Math_fround(HEAPF32[i8 + 8 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   i8 = Math_fround(HEAPF32[i1 + 20 >> 2]) <= Math_fround(HEAPF32[i8 + 20 >> 2]);
   return i8 | 0;
  }
 case 2:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i8 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(f2 <= Math_fround(HEAPF32[i8 + 12 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i8 + 4 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   if (!(f2 <= Math_fround(HEAPF32[i8 + 16 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i8 + 8 >> 2]))) {
    i8 = 0;
    return i8 | 0;
   }
   i8 = f2 <= Math_fround(HEAPF32[i8 + 20 >> 2]);
   return i8 | 0;
  }
 case 1:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   f6 = Math_fround(HEAPF32[i8 >> 2]);
   f7 = Math_fround(HEAPF32[i8 + 12 >> 2]);
   f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i8 + 16 >> 2]);
   f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i8 + 20 >> 2]);
   f9 = Math_fround(HEAPF32[i1 >> 2]);
   if (!(f9 >= f6) | !(f9 <= f7)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   if (!(f9 >= f3) | !(f9 <= f4)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (!(f9 >= f5) | !(f9 <= f2)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   if (!(f9 >= f6) | !(f9 <= f7)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   if (!(f9 >= f3) | !(f9 <= f4)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   if (!(f9 >= f5) | !(f9 <= f2)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   if (!(f9 >= f6) | !(f9 <= f7)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (!(f9 >= f3) | !(f9 <= f4)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 32 >> 2]);
   if (!(f9 >= f5) | !(f9 <= f2)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 36 >> 2]);
   if (!(f9 >= f6) | !(f9 <= f7)) {
    i8 = 0;
    return i8 | 0;
   }
   f9 = Math_fround(HEAPF32[i1 + 40 >> 2]);
   if (!(f9 >= f3) | !(f9 <= f4)) {
    i8 = 0;
    return i8 | 0;
   } else {
    f9 = Math_fround(HEAPF32[i1 + 44 >> 2]);
    return f9 <= f2 & f9 >= f5 | 0;
   }
  }
 default:
  {
   i8 = 1;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZN27ForceModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 615256 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615256 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615277 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615277 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615298 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615298 + 20 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 615319 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615319 + 29 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100001;
 HEAP32[i7 + 12 >> 2] = 3;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = (i4 - i5 | 0) / 44 | 0;
 i6 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i2 = i5;
 i8 = i10;
 i12 = i4;
 if (i9 >>> 0 <= ((i1 - i10 | 0) / 44 | 0) >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 44 | 0;
  i3 = i9 >>> 0 > i1 >>> 0;
  i1 = i3 ? i2 + (i1 * 44 | 0) | 0 : i4;
  i2 = i1 - i5 | 0;
  if (i2 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i8 + (((i2 | 0) / 44 | 0) * 44 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   i1 = i1 + 44 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 44 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i4 = i10;
 if (i10) {
  i1 = i11 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i8 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -44 - i10 | 0) >>> 0) / 44 | 0) * 44 | 0);
  __ZdlPv(i4);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if (i9 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i10 = (i1 - i3 | 0) / 44 | 0;
 i3 = i10 << 1;
 i3 = i10 >>> 0 < 48806446 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 97612893;
 if (i3 >>> 0 > 97612893) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = __Znwj(i3 * 44 | 0) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i1 + (i3 * 44 | 0);
 if ((i2 | 0) == (i12 | 0)) return;
 do {
  i9 = i2;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
  i2 = i2 + 44 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 44 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 return;
}

function __ZNSt3__218__insertion_sort_3IRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 24 | 0;
 i20 = i22;
 i2 = i17 + 40 | 0;
 __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_(i17, i17 + 20 | 0, i2, i1) | 0;
 i1 = i17 + 60 | 0;
 if ((i1 | 0) == (i18 | 0)) {
  STACKTOP = i22;
  return;
 }
 i16 = i20 + 4 | 0;
 i9 = i20 + 8 | 0;
 i10 = i20 + 12 | 0;
 i11 = i20 + 16 | 0;
 i12 = i19 + 4 | 0;
 i13 = i20 + 12 | 0;
 i14 = i20 + 4 | 0;
 i15 = i19 + 4 | 0;
 i8 = i1;
 while (1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) < (HEAP32[i2 >> 2] | 0)) {
   HEAP32[i20 >> 2] = i1;
   i5 = i8 + 4 | 0;
   i1 = HEAP32[i8 + 16 >> 2] | 0;
   HEAP32[i16 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i11 >> 2] = i1;
   i7 = i8 + 8 | 0;
   i3 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
   i6 = i3 >> 2;
   if (i6 | 0) {
    if ((i3 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i16);
     i1 = HEAP32[i11 >> 2] | 0;
    }
    HEAP32[i19 >> 2] = 51;
    HEAP32[i12 >> 2] = i1;
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i19, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i9 >> 2] = i4;
    HEAP32[i16 >> 2] = i4;
    HEAP32[i13 >> 2] = i4 + (i6 << 2);
    i3 = HEAP32[i5 >> 2] | 0;
    i1 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i4 | 0, i3 | 0, i1 | 0) | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (i1 >> 2 << 2);
    }
   }
   i4 = i2;
   i1 = i8;
   i3 = HEAP32[i2 >> 2] | 0;
   while (1) {
    HEAP32[i1 >> 2] = i3;
    __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i1 + 4 | 0, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0);
    if ((i4 | 0) == (i17 | 0)) {
     i21 = 12;
     break;
    }
    i2 = i4 + -20 | 0;
    i1 = HEAP32[i20 >> 2] | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i2 = i4;
     break;
    } else {
     i1 = i4;
     i4 = i2;
    }
   }
   if ((i21 | 0) == 12) {
    i21 = 0;
    i2 = i17;
    i1 = HEAP32[i20 >> 2] | 0;
   }
   HEAP32[i4 >> 2] = i1;
   if ((i2 | 0) != (i20 | 0)) __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i2 + 4 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i9 >> 2] | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = HEAP32[i9 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    i7 = HEAP32[i11 >> 2] | 0;
    HEAP32[i19 >> 2] = 51;
    HEAP32[i15 >> 2] = i7;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i19);
   }
  }
  i1 = i8 + 20 | 0;
  if ((i1 | 0) == (i18 | 0)) break; else {
   i2 = i8;
   i8 = i1;
  }
 }
 STACKTOP = i22;
 return;
}

function __ZN14PhysicsManager19CreateDynamicsSceneEbb(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 i5 = HEAP32[gb + 1457408 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0) | 0;
 i1 = i7 + 80 | 0;
 i2 = i7;
 i3 = i2 + 80 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f10 * Math_fround(.00999999977));
 HEAP32[i7 + 84 >> 2] = 0;
 HEAPF32[i7 + 88 >> 2] = Math_fround(f10 * Math_fround(.0250000004));
 HEAPF32[i7 + 92 >> 2] = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * Math_fround(.200000003));
 HEAPF32[i7 + 96 >> 2] = Math_fround(f10 * Math_fround(.0399999991));
 i2 = i7 + 100 | 0;
 HEAP16[i2 >> 1] = 0;
 i1 = i7 + 104 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 108 >> 2] = 0;
 HEAP32[i7 + 112 >> 2] = 0;
 HEAP32[i7 + 116 >> 2] = 1;
 HEAP32[i7 + 120 >> 2] = 1;
 HEAP32[i7 + 124 >> 2] = 100;
 HEAP32[i7 + 128 >> 2] = 0;
 HEAP32[i7 + 132 >> 2] = 32;
 HEAP32[i7 + 136 >> 2] = 0;
 HEAP32[i7 + 140 >> 2] = 65536;
 HEAP32[i7 + 144 >> 2] = 8192;
 HEAP32[i7 + 148 >> 2] = 1;
 HEAP32[i7 + 152 >> 2] = 0;
 HEAPF32[i7 + 156 >> 2] = Math_fround(.399999976);
 HEAP32[i7 + 160 >> 2] = -25165825;
 HEAP32[i7 + 164 >> 2] = -25165825;
 HEAP32[i7 + 168 >> 2] = -25165825;
 HEAP32[i7 + 172 >> 2] = 2122317823;
 HEAP32[i7 + 176 >> 2] = 2122317823;
 HEAP32[i7 + 180 >> 2] = 2122317823;
 i3 = i7 + 184 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = -1055066685;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 1452436;
 HEAP32[i7 + 32 >> 2] = fb + 96;
 i1 = i4 ? 20 : 4;
 if (i6) i1 = (i1 & 65535 | 512) & 65535;
 HEAP16[i2 >> 1] = i1;
 i1 = HEAP32[gb + 1457408 >> 2] | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i7 | 0) | 0;
 HEAP32[gb + 1457404 >> 2] = i1;
 __ZN19CharacterController23UpdateControllerManagerEv();
 __ZN14PhysicsManager19CreatePvdConnectionEv();
 i1 = HEAP32[gb + 1457404 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(-9.81000041);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 mftCall_vii(i7 | 0, i1 | 0, i8 | 0);
 i1 = HEAP32[gb + 1457420 >> 2] | 0;
 if (!i1) {
  i8 = HEAP32[gb + 1457408 >> 2] | 0;
  i8 = mftCall_iifff(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, 1.0, 1.0, .00999999977) | 0;
  HEAP32[gb + 1457420 >> 2] = i8;
 } else {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, 1.0);
  i8 = HEAP32[gb + 1457420 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, 1.0);
  i8 = HEAP32[gb + 1457420 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0, .00999999977);
 }
 if (__Z12GetIVehiclesv() | 0) {
  i8 = __Z12GetIVehiclesv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0);
 }
 if (!(__Z9GetIClothv() | 0)) {
  STACKTOP = i9;
  return;
 }
 i8 = __Z9GetIClothv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN14ParticleSystem13KillParticlesILb1EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj(i24, i1, i25, i26, i27, i3, i2) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i28 = 0, i29 = 0, i30 = 0, f31 = f0, f32 = f0, f33 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 16 | 0;
 i22 = i23;
 i1 = HEAP32[i24 >> 2] | 0;
 if (i1 >>> 0 <= i3 >>> 0) {
  i26 = i1;
  __ZN23ParticleSystemParticles12array_resizeEj(i27, i26);
  STACKTOP = i23;
  return;
 }
 i9 = i27 + 520 | 0;
 i10 = i22 + 4 | 0;
 i11 = i22 + 8 | 0;
 i12 = i22 + 12 | 0;
 i13 = i26 + 428 | 0;
 i14 = i26 + 496 | 0;
 i15 = i21 + 4 | 0;
 i16 = i21 + 8 | 0;
 i17 = i21 + 12 | 0;
 i18 = i21 + 16 | 0;
 i19 = i21 + 20 | 0;
 i20 = i26 + 424 | 0;
 i2 = i1;
 i8 = i3;
 i4 = i3;
 i5 = i3 + 2 | 0;
 i6 = i3 + 3 | 0;
 i7 = i3 + 1 | 0;
 while (1) {
  i3 = (HEAP32[i9 >> 2] | 0) + (i8 << 2) | 0;
  f33 = Math_fround(HEAPF32[i3 >> 2]);
  f32 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i29 = (f33 > Math_fround(100.0)) << 31 >> 31;
  i30 = (f32 > Math_fround(100.0)) << 31 >> 31;
  i28 = (f31 > Math_fround(100.0)) << 31 >> 31;
  i3 = (Math_fround(HEAPF32[i3 + 12 >> 2]) > Math_fround(100.0)) << 31 >> 31;
  i29 = (i4 | 0) < (i2 | 0) ? i29 : 0;
  i30 = (i7 | 0) < (i2 | 0) ? i30 : 0;
  i28 = (i5 | 0) < (i2 | 0) ? i28 : 0;
  i3 = (i6 | 0) < (i2 | 0) ? i3 : 0;
  HEAP32[i22 >> 2] = i29;
  HEAP32[i10 >> 2] = i30;
  HEAP32[i11 >> 2] = i28;
  HEAP32[i12 >> 2] = i3;
  if ((i30 | i29 | i28 | i3 | 0) > -1) {
   i3 = i8 + 4 | 0;
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
   i6 = i6 + 4 | 0;
   i7 = i7 + 4 | 0;
  } else {
   i3 = 3;
   while (1) {
    if (HEAP32[i22 + (i3 << 2) >> 2] | 0) {
     i2 = i3 + i8 | 0;
     if (HEAP32[i13 >> 2] | 0) {
      i1 = 0;
      do {
       i30 = HEAP32[i14 >> 2] | 0;
       HEAPF32[i21 >> 2] = Math_fround(0.0);
       HEAPF32[i15 >> 2] = Math_fround(0.0);
       HEAP32[i16 >> 2] = i30;
       i30 = (Math_imul(i30, 1812433253) | 0) + 1 | 0;
       HEAP32[i17 >> 2] = i30;
       i30 = (Math_imul(i30, 1812433253) | 0) + 1 | 0;
       HEAP32[i18 >> 2] = i30;
       HEAP32[i19 >> 2] = (Math_imul(i30, 1812433253) | 0) + 1;
       __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i21, (HEAP32[i20 >> 2] | 0) + (i1 * 600 | 0) | 0, i25, i26, i27, 2, i1, i2, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
      i1 = HEAP32[i24 >> 2] | 0;
     }
     __ZN23ParticleSystemParticles14element_assignEjj(i27, i2, i1 + -1 | 0);
     i1 = (HEAP32[i24 >> 2] | 0) + -1 | 0;
     HEAP32[i24 >> 2] = i1;
    }
    if ((i3 | 0) > 0) i3 = i3 + -1 | 0; else {
     i2 = i1;
     i3 = i8;
     break;
    }
   }
  }
  if (i3 >>> 0 < i1 >>> 0) i8 = i3; else break;
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i27, i1);
 STACKTOP = i23;
 return;
}

function __ZN12MeshCollider8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i3 = i6 + 60 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 737084 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i10 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 121 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 737093 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i10 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 124 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 734447 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i10 >>> 0) i5 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048075 | 0, gb + 1048082 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN5Umbra12QueryContext19addQueryDebugSphereERKNS_7Vector3EfRKNS_7Vector4E(i4, i5, f14, i19) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f14 = Math_fround(f14);
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26 + 36 | 0;
 i21 = i26 + 24 | 0;
 i22 = i26 + 12 | 0;
 i23 = i26;
 i24 = i5 + 4 | 0;
 i25 = i5 + 8 | 0;
 i6 = i20 + 4 | 0;
 i7 = i20 + 8 | 0;
 i8 = i21 + 4 | 0;
 i9 = i21 + 8 | 0;
 i10 = i22 + 4 | 0;
 i11 = i22 + 8 | 0;
 i12 = i23 + 4 | 0;
 i13 = i23 + 8 | 0;
 i2 = 0;
 do {
  f16 = Math_fround(Math_fround(i2 | 0) * Math_fround(.196349546));
  i2 = i2 + 1 | 0;
  f18 = Math_fround(Math_fround(i2 | 0) * Math_fround(.196349546));
  f15 = Math_fround(+Math_cos(+f16));
  f16 = Math_fround(+Math_sin(+f16));
  f17 = Math_fround(+Math_cos(+f18));
  f18 = Math_fround(+Math_sin(+f18));
  i3 = 0;
  do {
   f30 = Math_fround(Math_fround(i3 | 0) * Math_fround(.196349546));
   i3 = i3 + 1 | 0;
   f32 = Math_fround(Math_fround(i3 | 0) * Math_fround(.196349546));
   f33 = Math_fround(+Math_sin(+f30));
   f34 = Math_fround(Math_fround(f33 * f15) * f14);
   f31 = Math_fround(Math_fround(f33 * f16) * f14);
   f30 = Math_fround(Math_fround(+Math_cos(+f30)) * f14);
   f29 = Math_fround(HEAPF32[i5 >> 2]);
   f34 = Math_fround(f34 + f29);
   f28 = Math_fround(HEAPF32[i24 >> 2]);
   f31 = Math_fround(f31 + f28);
   f27 = Math_fround(HEAPF32[i25 >> 2]);
   f30 = Math_fround(f30 + f27);
   HEAPF32[i20 >> 2] = f34;
   HEAPF32[i6 >> 2] = f31;
   HEAPF32[i7 >> 2] = f30;
   f31 = Math_fround(f28 + Math_fround(Math_fround(f33 * f18) * f14));
   HEAPF32[i21 >> 2] = Math_fround(f29 + Math_fround(Math_fround(f33 * f17) * f14));
   HEAPF32[i8 >> 2] = f31;
   HEAPF32[i9 >> 2] = f30;
   f30 = Math_fround(+Math_sin(+f32));
   f31 = Math_fround(Math_fround(Math_fround(f18 * f30) * f14) + f28);
   f27 = Math_fround(Math_fround(Math_fround(+Math_cos(+f32)) * f14) + f27);
   HEAPF32[i22 >> 2] = Math_fround(f29 + Math_fround(Math_fround(f17 * f30) * f14));
   HEAPF32[i10 >> 2] = f31;
   HEAPF32[i11 >> 2] = f27;
   f28 = Math_fround(Math_fround(Math_fround(f16 * f30) * f14) + f28);
   HEAPF32[i23 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f30) * f14) + f29);
   HEAPF32[i12 >> 2] = f28;
   HEAPF32[i13 >> 2] = f27;
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0;
   if (i1 | 0) {
    mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i20 | 0, i21 | 0, i19 | 0);
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) {
     mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i21 | 0, i22 | 0, i19 | 0);
     i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0;
     if (i1 | 0) {
      mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i22 | 0, i23 | 0, i19 | 0);
      i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0;
      if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i23 | 0, i20 | 0, i19 | 0);
     }
    }
   }
  } while ((i3 | 0) != 16);
 } while ((i2 | 0) != 32);
 STACKTOP = i26;
 return;
}

function __ZN10MonoScript8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455664 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 64 | 0, 16);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455681 | 0, gb + 455698 | 0, i9, 16);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455706 | 0, i9, i1 + 92 | 0, 16);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455718 | 0, i9, i1 + 108 | 0, 16);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455730 | 0, i9, i1 + 124 | 0, 16);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455745 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 140 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i6 = i1;
 i7 = i11 + 36 | 0;
 i8 = i6 >>> 25;
 i9 = i6 >>> 18 & 127;
 i10 = i6 >>> 13 & 31;
 i5 = i6 >>> 9 & 15;
 i6 = i6 >>> 4 & 31;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i1 = __ZN13MemoryManager17LowLevelCAllocateEjj(129, 4) | 0;
  HEAP32[i7 >> 2] = i1;
  i4 = i11 + 28 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 516;
  HEAP32[i1 + 512 >> 2] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
 if (!i2) {
  i1 = __ZN13MemoryManager17LowLevelCAllocateEjj(129, 4) | 0;
  HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] = i1;
  i1 = i11 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 516;
  HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 512 >> 2] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
 }
 i3 = HEAP32[i2 + (i9 << 2) >> 2] | 0;
 if (!i3) {
  i1 = __ZN13MemoryManager17LowLevelCAllocateEjj(33, 4) | 0;
  HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0) + (i9 << 2) >> 2] = i1;
  i1 = i11 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 132;
  HEAP32[(HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0) + (i9 << 2) >> 2] | 0) + 128 >> 2] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
  i2 = i3;
  i3 = HEAP32[i3 + (i9 << 2) >> 2] | 0;
 }
 i4 = HEAP32[i3 + (i10 << 2) >> 2] | 0;
 if (!i4) {
  i4 = __ZN13MemoryManager17LowLevelCAllocateEjj(17, 4) | 0;
  HEAP32[(HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] | 0) + (i9 << 2) >> 2] | 0) + (i10 << 2) >> 2] = i4;
  i4 = i11 + 28 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 68;
  i7 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i7 + (i8 << 2) >> 2] | 0;
  i3 = HEAP32[i4 + (i9 << 2) >> 2] | 0;
  i1 = HEAP32[i3 + (i10 << 2) >> 2] | 0;
  HEAP32[i1 + 64 >> 2] = 0;
  i2 = 1;
  i11 = i7 + (i8 << 2) | 0;
  i8 = i1 + 64 | 0;
  HEAP32[i8 >> 2] = i2;
  i8 = i3 + 128 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i3 = i3 + 1 | 0;
  HEAP32[i8 >> 2] = i3;
  i8 = i4 + 512 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i8 >> 2] = i4;
  i8 = i7 + 512 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = 1 << i6;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i9 << 2) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i10 << 2) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i5 << 2) | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i10 = i10 | i8;
  HEAP32[i11 >> 2] = i10;
  return 1;
 } else {
  i7 = i1;
  i12 = i4;
  i1 = (HEAP32[i4 + 64 >> 2] | 0) + 1 | 0;
  i4 = i2;
  i11 = i7 + (i8 << 2) | 0;
  i8 = i12 + 64 | 0;
  HEAP32[i8 >> 2] = i1;
  i8 = i3 + 128 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i3 = i3 + 1 | 0;
  HEAP32[i8 >> 2] = i3;
  i8 = i4 + 512 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i8 >> 2] = i4;
  i8 = i7 + 512 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = 1 << i6;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i9 << 2) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i10 << 2) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i5 << 2) | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i10 = i10 | i8;
  HEAP32[i11 >> 2] = i10;
  return 1;
 }
 return 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_PKc17TransferMetaFlags(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6;
 i7 = i6 + 36 | 0;
 i4 = i6 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, i2, HEAP32[gb + 37052 >> 2] | 0, i1, i3);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 32 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, HEAP32[gb + 37008 >> 2] | 0, gb + 479385 | 0, i4, 0);
 i1 = i8 + 8 | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i2 = i5 + 16 | 0;
 i3 = i5 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 i3 = i4 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, HEAP32[gb + 37224 >> 2] | 0, gb + 479398 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 479409 | 0, HEAP32[gb + 37228 >> 2] | 0, i3, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, gb + 479418 | 0, i7, 0);
 __ZN23ShaderVariantCollection11VariantInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i3) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
  STACKTOP = i6;
  return;
 }
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -36 - i3 | 0) >>> 0) / 36 | 0) * 36 | 0);
 __ZdlPv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN17PackedFloatVector10PackFloatsEPKfiiiib(i12, i1, i18, i19, i8, i5, i7) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f6 = f0, f9 = f0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21;
 i20 = i1 + (Math_imul(i8, i19) | 0) | 0;
 i14 = (i20 | 0) == (i1 | 0);
 L1 : do if (i14) {
  f9 = Math_fround(inf);
  f6 = Math_fround(-inf);
 } else {
  if ((i18 | 0) > 0) {
   f4 = Math_fround(inf);
   i3 = i1;
   f6 = Math_fround(-inf);
  } else {
   i2 = i1;
   while (1) {
    i2 = i2 + i19 | 0;
    if ((i2 | 0) == (i20 | 0)) {
     f9 = Math_fround(inf);
     f6 = Math_fround(-inf);
     break L1;
    }
   }
  }
  do {
   i2 = 0;
   do {
    f9 = Math_fround(HEAPF32[i3 + (i2 << 2) >> 2]);
    f6 = f6 < f9 ? f9 : f6;
    f4 = f4 > f9 ? f9 : f4;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i18 | 0));
   i3 = i3 + i19 | 0;
  } while ((i3 | 0) != (i20 | 0));
  f9 = f4;
 } while (0);
 f4 = Math_fround(f6 - f9);
 i11 = i12 + 4 | 0;
 HEAPF32[i11 >> 2] = f4;
 if (f4 > Math_fround(0.0) & i7) i2 = ~~Math_fround(Math_ceil(Math_fround(_log2f(f4)))) + i5 | 0; else i2 = i5;
 i10 = f9 == f6 ? 0 : (i2 | 0) > 32 ? 32 : i2;
 i17 = i12 + 8 | 0;
 HEAPF32[i17 >> 2] = f9;
 i5 = Math_imul(i8, i18) | 0;
 HEAP32[i12 >> 2] = i5;
 i15 = i12 + 12 | 0;
 HEAP8[i15 >> 0] = i10;
 i16 = i12 + 16 | 0;
 i5 = ((Math_imul(i10, i5) | 0) + 7 | 0) >>> 3;
 HEAP8[i13 >> 0] = 0;
 i7 = i12 + 20 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i2 = i8 - i3 | 0;
 if (i5 >>> 0 > i2 >>> 0) __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh(i16, i5 - i2 | 0, i13); else if (i5 >>> 0 < i2 >>> 0) {
  i2 = i3 + i5 | 0;
  if ((i8 | 0) != (i2 | 0)) HEAP32[i7 >> 2] = i2;
 }
 if (!i10) {
  STACKTOP = i21;
  return;
 }
 f4 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = f4 > Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i13 ? f4 : Math_fround(0.0);
 if (i14) {
  STACKTOP = i21;
  return;
 }
 if ((i18 | 0) <= 0) {
  do i1 = i1 + i19 | 0; while ((i1 | 0) != (i20 | 0));
  STACKTOP = i21;
  return;
 }
 i3 = 0;
 i2 = 0;
 i5 = HEAP8[i15 >> 0] | 0;
 while (1) {
  i11 = 0;
  i7 = i5;
  do {
   f9 = Math_fround(HEAPF32[i1 + (i11 << 2) >> 2]);
   f9 = Math_fround(f4 * Math_fround(f9 - Math_fround(HEAPF32[i17 >> 2])));
   i10 = f9 < Math_fround(0.0);
   f9 = i10 ? Math_fround(0.0) : f9;
   i10 = f9 > Math_fround(1.0);
   i10 = ~~Math_fround(Math_fround(Math_fround((1 << (i5 & 255)) + -1 | 0) * (i10 ? Math_fround(1.0) : f9)) + Math_fround(.5)) >>> 0;
   if (!(i5 << 24 >> 24)) i5 = 0; else {
    i5 = 0;
    do {
     i8 = (HEAP32[i16 >> 2] | 0) + i2 | 0;
     HEAP8[i8 >> 0] = HEAPU8[i8 >> 0] | 0 | i10 >>> i5 << i3;
     i8 = HEAP8[i15 >> 0] | 0;
     i14 = i8 & 255;
     i13 = i14 - i5 | 0;
     i12 = 8 - i3 | 0;
     i13 = (i12 | 0) < (i13 | 0) ? i12 : i13;
     i3 = i13 + i3 | 0;
     i5 = i13 + i5 | 0;
     i13 = (i3 | 0) == 8;
     i2 = (i13 & 1) + i2 | 0;
     i3 = i13 ? 0 : i3;
    } while ((i5 | 0) < (i14 | 0));
    i7 = i8;
    i5 = i8;
   }
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i18 | 0));
  i1 = i1 + i19 | 0;
  if ((i1 | 0) == (i20 | 0)) break; else i5 = i7;
 }
 STACKTOP = i21;
 return;
}

function __Z33EmitSerializationCommandsForFieldI14SafeBinaryReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i6 = i11 + 112 | 0;
 i9 = i11;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i3) | 0) | 0) != 29) if (!(__ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i3) | 0)) {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
  i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i7;
  HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
  HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
  HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = i4 + 12 | 0;
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  i8 = __ZN6HelperI14SafeBinaryRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i4, i1, i6) | 0;
  if (!i8) {
   if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
  } else if (!((HEAP8[i4 + 25 >> 0] | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
   i3 = i9 + 48 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   i3 = i9;
   i2 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i2 = i10 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i10 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + (i3 << 6) >> 2] = i8;
   i3 = i1 + (i3 << 6) + 4 | 0;
   i1 = i9;
   i2 = i3 + 60 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
  STACKTOP = i11;
  return;
 }
 __Z49EmitSerializationCommandsForLinearCollectionFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i4, i10, i5);
 STACKTOP = i11;
 return;
}

function __ZN9GfxDeviceD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 HEAP32[i4 >> 2] = gb + 38136 + 8;
 i5 = i4 + 4412 | 0;
 if ((HEAP16[gb + 1157644 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157644 | 0, i1);
  i2 = gb + 1157644 | 0;
 } else i2 = 0;
 i3 = i4 + 4424 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i5, i4, i1);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 i3 = i4 + 4448 | 0;
 __ZN17UniqueIDGenerator17DestroyAllIndicesEv(i3);
 i1 = i4 + 4512 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 4516 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 4520 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i4 + 4524 | 0, HEAP32[i4 + 4528 >> 2] | 0);
 if ((HEAP32[i4 + 4508 >> 2] | 0) > -1) {
  i2 = i4 + 4492 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 4496 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i4 + 4472 | 0;
 if ((HEAP32[i4 + 4488 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 4476 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i4 + 4464 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i4 + 4452 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i4 + 4428 >> 2] | 0) <= -1) {
  i5 = i4 + 3904 | 0;
  HEAP32[i5 >> 2] = gb + 39052 + 8;
  i5 = i4 + 4024 | 0;
  i3 = i4 + 4028 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i5, i3);
  i3 = i4 + 3616 | 0;
  HEAP32[i3 >> 2] = gb + 39052 + 8;
  i3 = i4 + 3736 | 0;
  i5 = i4 + 3740 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i3, i5);
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 4416 | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i4 + 3904 | 0;
 HEAP32[i5 >> 2] = gb + 39052 + 8;
 i5 = i4 + 4024 | 0;
 i3 = i4 + 4028 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i5, i3);
 i3 = i4 + 3616 | 0;
 HEAP32[i3 >> 2] = gb + 39052 + 8;
 i3 = i4 + 3736 | 0;
 i5 = i4 + 3740 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i3, i5);
 STACKTOP = i6;
 return;
}

function __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 i5 = (i1 | 0) == 0;
 if ((i1 & 4 | 0) == 0 & (i5 ^ 1)) {
  HEAP32[i4 + 56 >> 2] = HEAP32[i4 + 36 >> 2];
  STACKTOP = i10;
  return;
 }
 HEAP8[i4 + 52 >> 0] = 0;
 i8 = i4 + 36 | 0;
 i1 = i4 + 56 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, (HEAP32[i8 >> 2] | 0) != (HEAP32[i1 >> 2] | 0) | 0);
 i2 = i4 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0);
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 if (!i5) {
  STACKTOP = i10;
  return;
 }
 __ZN11Rigidbody2D19RecalculateContactsEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 67088 | 0) | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 14; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i9 = 16;
 }
 if ((i9 | 0) == 14) i9 = 16;
 if ((i9 | 0) == 16) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 24;
  }
 }
 if ((i9 | 0) == 22) i9 = 24;
 if ((i9 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 __ZN11Rigidbody2D19RecalculateContactsEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67088 | 0) | 0);
 STACKTOP = i10;
 return;
}

function __ZN20TextRenderingPrivate15DynamicFontData28GetFaceForFontRefFromOSFontsERKNS_7FontRefE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i9 = i10;
 i1 = HEAP32[gb + 1467884 >> 2] | 0;
 if (!i1) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63392 | 0, 16, gb + 945383 | 0, 95) | 0;
  i2 = i4 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[gb + 1467884 >> 2] = i4;
  HEAP32[i5 >> 2] = 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i5);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = i3;
  if ((i2 | 0) != (i3 | 0)) {
   i3 = 0;
   do {
    __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + (i3 * 12 | 0) | 0);
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i11 = HEAP32[i5 >> 2] | 0;
    i1 = i11;
   } while (i3 >>> 0 < ((i2 - i11 | 0) / 12 | 0) >>> 0);
  }
  if (i1 | 0) {
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i11 = i2 + -12 | 0;
     HEAP32[i4 >> 2] = i11;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
     i2 = HEAP32[i4 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i5 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[gb + 1467884 >> 2] | 0;
 }
 i4 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i6 = 17; else {
  i1 = i4;
  L17 : while (1) {
   i3 = i2;
   while (1) {
    if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i3 + 16 | 0, i8) | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L17; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i4 | 0)) i6 = 17; else if (__ZNK20TextRenderingPrivate7FontRefltERKS0_(i8, i1 + 16 | 0) | 0) i6 = 17;
 }
 if ((i6 | 0) == 17) i1 = i4;
 if ((i1 | 0) == ((HEAP32[gb + 1467884 >> 2] | 0) + 4 | 0)) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i1 = i9 + 11 | 0;
  i2 = i9;
  i3 = 0;
  i4 = 0;
  i5 = 0;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i1 + 32 | 0);
  i5 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i9 + 12 >> 2] = i5;
  i3 = i9 + 11 | 0;
  i1 = i3;
  i2 = i9;
  i3 = HEAP8[i3 >> 0] | 0;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
 }
 if (!((i3 << 24 >> 24 < 0 ? i4 : i3 & 255) | 0)) {
  i11 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i10;
  return i11 | 0;
 }
 i6 = HEAP32[gb + 1467876 >> 2] | 0;
 i11 = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 _UNITY_FT_New_Face(i6, i11, i5, __ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i7, i8) | 0) | 0;
 i11 = HEAP32[(__ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i7, i8) | 0) >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN20VertexCacheOptimizerIjLi16EE17OptimizeTrianglesEPjjPKjj(i13, i2, i1, i14, i15) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = __Znaj(i15) | 0;
 i17 = __Znaj(i1) | 0;
 _memset(i16 | 0, 0, i15 | 0) | 0;
 _memset(i17 | 0, 0, i1 | 0) | 0;
 i10 = (i15 | 0) == 0;
 i11 = i13 + 4 | 0;
 i12 = i13 + 8 | 0;
 i9 = i13 + 12 | 0;
 if (i10) {
  __ZdaPv(i16);
  __ZdaPv(i17);
  return;
 }
 while (1) {
  i1 = 0;
  i4 = 0;
  i5 = 0;
  i3 = 0;
  while (1) {
   if (!(HEAP8[i16 + i1 >> 0] | 0)) {
    i6 = i1 * 3 | 0;
    i6 = (HEAP8[i17 + (HEAP32[i14 + (i6 << 2) >> 2] | 0) >> 0] | 0 ? 2 : 1) + ((HEAP8[i17 + (HEAP32[i14 + (i6 + 1 << 2) >> 2] | 0) >> 0] | 0) != 0 & 1) + ((HEAP8[i17 + (HEAP32[i14 + (i6 + 2 << 2) >> 2] | 0) >> 0] | 0) != 0 & 1) | 0;
    if (i6 >>> 0 > i5 >>> 0) if ((i6 | 0) == 4) break; else {
     i3 = 1;
     i5 = i6;
     i4 = i1;
    } else i3 = 1;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i15 >>> 0) {
    i18 = 7;
    break;
   }
  }
  if ((i18 | 0) == 7) {
   i18 = 0;
   if (!(i3 & 1)) {
    i18 = 30;
    break;
   } else i1 = i4;
  }
  HEAP8[i16 + i1 >> 0] = 1;
  i8 = i1 * 3 | 0;
  i4 = HEAP32[i14 + (i8 << 2) >> 2] | 0;
  i7 = HEAP32[i14 + (i8 + 1 << 2) >> 2] | 0;
  i8 = HEAP32[i14 + (i8 + 2 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i7;
  HEAP32[i2 + 8 >> 2] = i8;
  i2 = i2 + 12 | 0;
  i5 = i17 + i4 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i6 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i6 + (i1 << 2) >> 2] = i4;
   HEAP8[i5 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i4 = i17 + i7 | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i5 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i5 + (i1 << 2) >> 2] = i7;
   HEAP8[i4 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i5 = i17 + i8 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i4 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((i1 | 0) != -1) HEAP8[i17 + i1 >> 0] = 0;
   if ((HEAP32[i11 >> 2] | 0) == 1) i1 = 0; else {
    i3 = 0;
    do {
     i1 = i3;
     i3 = i3 + 1 | 0;
     HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
     i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
   }
   HEAP32[i4 + (i1 << 2) >> 2] = i8;
   HEAP8[i5 >> 0] = 1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  if (i10) {
   i18 = 30;
   break;
  }
 }
 if ((i18 | 0) == 30) {
  __ZdaPv(i16);
  __ZdaPv(i17);
  return;
 }
}

function __ZN7Striper10TrackStripEjjjPjS0_Pbb(i14, i1, i2, i3, i15, i4, i16, i5) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i15 + 4 >> 2] = i3;
 i6 = 1;
 i7 = 2;
 L1 : while (1) {
  i12 = i16 + i1 | 0;
  i10 = i7;
  while (1) {
   if (!i6) break L1;
   i13 = i5 ^ 1;
   i11 = HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0;
   i9 = i11 + (i1 * 24 | 0) | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i6 = (i8 | 0) == (i2 | 0);
   if (i6) if ((HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0) == (i3 | 0)) i8 = HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0; else i17 = 7; else i17 = 7;
   do if ((i17 | 0) == 7) {
    i17 = 0;
    i7 = (i8 | 0) == (i3 | 0);
    if (i7) if ((HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0) == (i2 | 0)) {
     i8 = HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0;
     break;
    }
    if (i6) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i3 | 0)) {
     i8 = HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0;
     break;
    }
    if (i7) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i2 | 0)) {
     i8 = HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0;
     break;
    }
    i6 = HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i3 | 0)) break;
    if ((i6 | 0) == (i3 | 0)) i8 = (HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i2 | 0) ? i8 : -1; else i8 = -1;
   } while (0);
   i7 = i10 + 1 | 0;
   HEAP32[i15 + (i10 << 2) >> 2] = i8;
   i2 = i4;
   i4 = i4 + 4 | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP8[i12 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i6 = (i2 | 0) == (i3 | 0);
   if (i6) if ((HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0) == (i8 | 0)) i2 = 0; else i17 = 22; else i17 = 22;
   do if ((i17 | 0) == 22) {
    i17 = 0;
    i2 = (i2 | 0) == (i8 | 0);
    if (i2) if ((HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0) == (i3 | 0)) {
     i2 = 0;
     break;
    }
    if (i6) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i8 | 0)) {
     i2 = 1;
     break;
    }
    if (i2) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i3 | 0)) {
     i2 = 1;
     break;
    }
    i2 = HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0;
    if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i8 | 0)) {
     i2 = 2;
     break;
    }
    if ((i2 | 0) == (i8 | 0)) i2 = (HEAP32[i11 + (i1 * 24 | 0) + 8 >> 2] | 0) == (i3 | 0) ? 2 : 255; else i2 = 255;
   } while (0);
   i2 = HEAP32[i11 + (i1 * 24 | 0) + 12 + (i2 << 2) >> 2] | 0;
   if ((i2 | 0) != -1) break; else {
    i2 = i3;
    i3 = i8;
    i6 = 0;
    i10 = i7;
    i5 = i13;
   }
  }
  i9 = i2 & 1073741823;
  i6 = i5 ? i3 : i8;
  i1 = i5 ? i8 : i3;
  i2 = HEAP32[i11 + (i9 * 24 | 0) >> 2] | 0;
  if ((i2 | 0) == (i6 | 0)) if ((HEAP32[i11 + (i9 * 24 | 0) + 4 >> 2] | 0) == (i1 | 0)) i5 = 0; else i17 = 35; else i17 = 35;
  if ((i17 | 0) == 35) {
   i17 = 0;
   i5 = HEAP32[i11 + (i9 * 24 | 0) + 8 >> 2] | 0;
   if ((i2 | 0) == (i1 | 0) & (i5 | 0) == (i6 | 0)) i5 = 1; else if ((HEAP32[i11 + (i9 * 24 | 0) + 4 >> 2] | 0) == (i6 | 0)) i5 = (i5 | 0) == (i1 | 0) ? 2 : -1; else i5 = -1;
  }
  i1 = i9;
  i2 = i3;
  i3 = i8;
  i6 = i5 << 24 >> 24 != -1 & (HEAP8[i16 + i9 >> 0] | 0) == 0;
  i5 = i13;
 }
 return i10 | 0;
}

function __ZN5physx2Gu24contactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 3424 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 36 | 0;
 i12 = i1 + 24 | 0;
 i9 = i1;
 i8 = i1 + 56 | 0;
 HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i10 + 16 >> 2] = i5;
 HEAPF32[i10 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 8 >> 2]));
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 12 >> 2]));
 HEAPF32[i10 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i7 + 16 >> 2]));
 f19 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f19 = Math_fround(f19 - Math_fround(HEAPF32[i7 + 20 >> 2]));
 f22 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f16 = Math_fround(f16 * Math_fround(2.0));
 f19 = Math_fround(f19 * Math_fround(2.0));
 f22 = Math_fround(Math_fround(f22 - Math_fround(HEAPF32[i7 + 24 >> 2])) * Math_fround(2.0));
 f20 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f21 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f13 = Math_fround(f16 * f15);
 f17 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f19 * f17));
 f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f22 * f11));
 f18 = Math_fround(Math_fround(f15 * f13) + Math_fround(Math_fround(f16 * f21) - Math_fround(f20 * Math_fround(Math_fround(f22 * f17) - Math_fround(f19 * f11)))));
 f14 = Math_fround(Math_fround(f17 * f13) + Math_fround(Math_fround(f19 * f21) - Math_fround(f20 * Math_fround(Math_fround(f16 * f11) - Math_fround(f22 * f15)))));
 f13 = Math_fround(Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * Math_fround(Math_fround(f19 * f15) - Math_fround(f16 * f17)))) + Math_fround(f11 * f13));
 HEAPF32[i12 >> 2] = f18;
 HEAPF32[i12 + 4 >> 2] = f14;
 HEAPF32[i12 + 8 >> 2] = f13;
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i3 >> 2]));
 f17 = Math_fround(f14 - f11);
 f16 = Math_fround(f13 - f11);
 f15 = Math_fround(f18 + f11);
 f14 = Math_fround(f11 + f14);
 f13 = Math_fround(f11 + f13);
 HEAPF32[i9 >> 2] = Math_fround(f18 - f11);
 HEAPF32[i9 + 4 >> 2] = f17;
 HEAPF32[i9 + 8 >> 2] = f16;
 HEAPF32[i9 + 12 >> 2] = f15;
 HEAPF32[i9 + 16 >> 2] = f14;
 HEAPF32[i9 + 20 >> 2] = f13;
 HEAP32[i8 >> 2] = gb + 84456 + 8;
 HEAP32[i8 + 4 >> 2] = i4;
 HEAP32[i8 + 8 >> 2] = i6;
 HEAP32[i8 + 12 >> 2] = i7;
 HEAP32[i8 + 16 >> 2] = i2;
 HEAP32[i8 + 20 >> 2] = i12;
 HEAPF32[i8 + 24 >> 2] = Math_fround(f11 * f11);
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 2592 >> 2] = 0;
 HEAP32[i8 + 3364 >> 2] = i10;
 __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE(i10, i7, i9, 0, i8) | 0;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i8 + 4 | 0);
 STACKTOP = i1;
 return (HEAP32[i2 + 4096 >> 2] | 0) != 0 | 0;
}

function _common_181(i4, f9, i2, i10) {
 i4 = i4 | 0;
 f9 = Math_fround(f9);
 i2 = i2 | 0;
 i10 = i10 | 0;
 var d1 = 0.0, d3 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 d1 = +Math_fround(+Math_sin(+f9));
 i2 = (i2 | 0) != 0;
 d1 = i2 ? -d1 : d1;
 d6 = +Math_fround(+Math_cos(+f9));
 d7 = d1 - d6;
 if (i4 >>> 0 < 2130706432) {
  d3 = -d1 - d6;
  d8 = +Math_fround(+Math_cos(+Math_fround(f9 * Math_fround(2.0))));
  if (d1 * d6 > 0.0) d1 = d8 / d3; else {
   d1 = d7;
   d3 = d8 / d7;
  }
  if (i4 >>> 0 < 1484783616) {
   d3 = i2 ? -d3 : d3;
   i5 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = i5 & 2147483647;
   if (i2 >>> 0 > 1090519039) {
    i2 = gb + 207564 | 0;
    i4 = gb + 207524 | 0;
   } else if (i2 >>> 0 > 1089936471) {
    i2 = gb + 207588 | 0;
    i4 = gb + 207544 | 0;
   } else {
    i4 = i2 >>> 0 > 1077336935;
    i2 = i4 ? gb + 207476 | 0 : gb + 207500 | 0;
    i4 = i4 ? gb + 207436 | 0 : gb + 207456 | 0;
   }
   f11 = Math_fround(Math_fround(1.0) / Math_fround(f9 * f9));
   f13 = Math_fround(HEAPF32[i2 >> 2]);
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f17 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   f17 = Math_fround(f13 + Math_fround(f11 * Math_fround(f14 + Math_fround(f11 * Math_fround(f15 + Math_fround(f11 * Math_fround(f16 + Math_fround(f11 * Math_fround(f17 + Math_fround(f11 * Math_fround(HEAPF32[i2 + 20 >> 2])))))))))));
   f16 = Math_fround(HEAPF32[i4 >> 2]);
   f15 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   d1 = d1 * +Math_fround(Math_fround(f17 / Math_fround(Math_fround(f11 * Math_fround(f16 + Math_fround(f11 * Math_fround(f15 + Math_fround(f11 * Math_fround(f14 + Math_fround(f11 * Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 16 >> 2])))))))))) + Math_fround(1.0))) + Math_fround(1.0));
   i4 = (i5 & 2145386496) >>> 0 > 1075838975;
   i5 = i4 ? gb + 207612 | 0 : gb + 207636 | 0;
   i4 = i4 ? gb + 207660 | 0 : gb + 207684 | 0;
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f16 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f17 = Math_fround(HEAPF32[i4 + 16 >> 2]);
   f17 = Math_fround(f13 + Math_fround(f11 * Math_fround(f14 + Math_fround(f11 * Math_fround(f15 + Math_fround(f11 * Math_fround(f16 + Math_fround(f11 * Math_fround(f17 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 20 >> 2])))))))))));
   f16 = Math_fround(HEAPF32[i5 >> 2]);
   f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   f13 = Math_fround(HEAPF32[i5 + 12 >> 2]);
   f12 = Math_fround(HEAPF32[i5 + 16 >> 2]);
   d1 = d1 - d3 * +Math_fround(Math_fround(Math_fround(f17 / Math_fround(Math_fround(f11 * Math_fround(f16 + Math_fround(f11 * Math_fround(f15 + Math_fround(f11 * Math_fround(f14 + Math_fround(f11 * Math_fround(f13 + Math_fround(f11 * Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i5 + 20 >> 2])))))))))))) + Math_fround(1.0))) + Math_fround(.375)) / f9);
  }
 } else d1 = d7;
 return Math_fround(((i10 | 0) == 0 ? d1 : -d1) * .564189612865448 / +Math_fround(Math_sqrt(Math_fround(f9))));
}

function __ZN16LightmapSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i4 = i3 + 16 | 0;
 __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i1);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i1, 7);
 i6 = i2 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402150 | 0, gb + 402174 | 0, i6, 0);
 __ZN21EnlightenSceneMapping8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i6 = i2 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402196 | 0, gb + 402210 | 0, i6, 0);
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, i7, i6, 1);
 i6 = i1 + 16 | 0;
 i5 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402228 | 0, HEAP32[gb + 37316 >> 2] | 0, i2 + 36 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 590084 | 0, i4, 0);
 __ZN12LightmapData8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i4 = i2 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402240 | 0, i7, (HEAP32[i4 >> 2] | 0) + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 i8 = i2 + 76 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402256 | 0, gb + 402269 | 0, i8, 0);
 __ZN10GISettings8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 402280 | 0, i7, i2 + 236 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i1 = (HEAP32[i4 >> 2] | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 HEAP8[i2 + 96 >> 0] = 1;
 HEAP8[i2 + 97 >> 0] = 0;
 STACKTOP = i3;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEf(i11, f5) {
 i11 = i11 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, +(+f5)) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEt(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 & 65535 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN18DeferredRenderLoop24AddReflectionsToEmissionEP13RenderTextureS1_(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 32 | 0;
 i8 = i13;
 i9 = i13 + 28 | 0;
 i10 = i13 + 24 | 0;
 i11 = i13 + 20 | 0;
 i12 = i13 + 16 | 0;
 i4 = i1 + 8 | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 if ((HEAP16[gb + 1114708 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = i3;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114708 | 0, i5);
  i2 = gb + 1114708 | 0;
 } else i2 = 0;
 i1 = HEAP32[gb + 1114708 >> 2] | 0;
 i14 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 648 >> 2] | 0, i14 | 0, i1 | 0);
 i1 = HEAP32[gb + 1115116 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[(HEAP32[HEAP32[HEAP32[(__ZN8Material9GetShaderEv(i1) | 0) + 32 >> 2] >> 2] >> 2] | 0) + 20 >> 2] | 0) >= 2) {
  i1 = HEAP32[gb + 1115116 >> 2] | 0;
  if (!(HEAP8[i3 + 1092 >> 0] | 0)) {
   HEAP32[i11 >> 2] = HEAP32[gb + 1114788 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i5, Math_fround(2.0));
   i14 = HEAP32[gb + 1115116 >> 2] | 0;
   HEAP32[i12 >> 2] = HEAP32[gb + 1114792 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i14, i5, Math_fround(0.0));
  } else {
   HEAP32[i9 >> 2] = HEAP32[gb + 1114788 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i1, i5, Math_fround(1.0));
   i14 = HEAP32[gb + 1115116 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[gb + 1114792 >> 2];
   HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i14, i5, Math_fround(1.0));
  }
  i14 = HEAP32[gb + 1166248 >> 2] | 0;
  i12 = i14 + 36 | 0;
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i12, gb + 1114768 | 0, i6);
  __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i12, gb + 1114740 | 0, Math_fround(1.0), 0);
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i7, 0, -1, 0, 0);
  __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i5, __Z12GetGfxDevicev() | 0);
  i12 = __Z12GetGfxDevicev() | 0;
  __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(0.0), Math_fround(__ZNK6Camera16GetProjectionFarEv(i3)), i12);
  i14 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(HEAP32[gb + 1115116 >> 2] | 0, 1, i14, 0, 1) | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i12, i3, i14, i8, Math_fround(Math_fround(__ZNK6Camera17GetProjectionNearEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0)) * Math_fround(1.00100005)), 0);
  __ZN27DeviceViewProjMatricesStateD2Ev(i5);
 }
 i14 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 652 >> 2] | 0, i14 | 0);
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 56 | 0;
 i4 = i5;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i19 = i4 + 4 | 0;
 HEAP32[i19 >> 2] = 0;
 i17 = i4 + 8 | 0;
 i20 = i2 + 8 | 0;
 i18 = HEAP16[i20 >> 1] | 0;
 HEAP8[i17 >> 0] = i18;
 i10 = i4 + 9 | 0;
 HEAP8[i10 >> 0] = (i18 & 65535) >>> 8;
 i18 = i4 + 12 | 0;
 i15 = i2 + 12 | 0;
 i12 = i15;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i16 = i18;
 HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i16 + 4 >> 2] = i11;
 i16 = i4 + 20 | 0;
 i11 = i2 + 20 | 0;
 i12 = i11;
 i14 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i16;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = i4 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i4 + 32 | 0;
 HEAP32[i14 >> 2] = 0;
 i12 = i4 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i4 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i4 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP8[i6 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j(i4, i2, 0);
 i21 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i19 >> 2] = i21;
 i1 = HEAP8[i20 >> 0] | 0;
 i19 = HEAP16[i17 >> 1] | 0;
 HEAP8[i20 >> 0] = i19;
 HEAP8[i17 >> 0] = i1;
 i17 = i2 + 9 | 0;
 i1 = HEAP8[i17 >> 0] | 0;
 HEAP8[i17 >> 0] = (i19 & 65535) >>> 8;
 HEAP8[i10 >> 0] = i1;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i10 = HEAP32[i2 + 24 >> 2] | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i4 + 20 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = i10;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i1;
 i13 = i2 + 32 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i14 >> 2] = i10;
 i14 = i2 + 36 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i13;
 f8 = Math_fround(i11 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f8 = Math_fround(i10 >>> 0);
 HEAP32[i9 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i7 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i6 >> 0] = 0;
 if (i1 | 0) {
  i21 = HEAP32[i4 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 65;
  HEAP32[i3 + 4 >> 2] = i21;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 STACKTOP = i5;
 return;
}

function __ZL23setMassAndUpdateInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(i13, i20, i12, i10, i2, i8) {
 i13 = i13 | 0;
 i20 = i20 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i23 + 8 | 0;
 i14 = i23;
 i11 = i23 + 136 | 0;
 i21 = i23 + 72 | 0;
 i22 = i23 + 56 | 0;
 i15 = i23 + 40 | 0;
 i9 = i23 + 84 | 0;
 i16 = i23 + 12 | 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 HEAPF32[i21 >> 2] = Math_fround(1.0);
 HEAPF32[i21 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i21 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 i17 = i22 + 4 | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 i18 = i22 + 8 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 i19 = i22 + 12 | 0;
 HEAPF32[i19 >> 2] = Math_fround(1.0);
 i7 = (i2 | 0) != 0;
 if (i7) {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i15 >> 2] = i5;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i4;
  i3 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i3;
 } else {
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
  i3 = 0;
  i4 = 0;
  i5 = 0;
 }
 if ((i12 | 0) != 0 & (i10 | 0) != 0) {
  i2 = i9;
  i3 = i2 + 52 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  do if (__ZL21computeMassAndInertiabRN5physx11PxRigidBodyEPKfS3_jbRNS_3Ext21InertiaTensorComputerE(i13, i20, 0, i12, i10, i8, i9) | 0) {
   if (Math_fround(HEAPF32[i9 + 48 >> 2]) != Math_fround(0.0)) __ZL25computeMassAndDiagInertiaRN5physx3Ext21InertiaTensorComputerERNS_6PxVec3ERNS_6PxQuatERfS4_bRKNS_11PxRigidBodyEPKc(i9, i21, i22, i11, i15, i7, i20, gb + 732883 | 0);
   if ((i10 | 0) == 1) {
    i2 = HEAP32[i12 >> 2] | 0;
    HEAP32[i11 >> 2] = i2;
    f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i2 = 1;
    break;
   } else {
    f1 = Math_fround(HEAPF32[i11 >> 2]);
    i2 = 1;
    break;
   }
  } else {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i14 >> 2] = gb + 732883;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 4, gb + 659217 | 0, 328, gb + 659304 | 0, i14);
   f1 = Math_fround(1.0);
   i2 = 0;
  } while (0);
  i5 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i15 + 4 >> 2] | 0;
  i3 = HEAP32[i15 + 8 >> 2] | 0;
 } else {
  i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i6 >> 2] = gb + 732883;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 4, gb + 659217 | 0, 336, gb + 732923 | 0, i6);
  f1 = Math_fround(1.0);
  i2 = 0;
 }
 mftCall_vif(HEAP32[(HEAP32[i20 >> 2] | 0) + 128 >> 2] | 0, i20 | 0, +f1);
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 140 >> 2] | 0, i20 | 0, i21 | 0);
 i21 = HEAP32[(HEAP32[i20 >> 2] | 0) + 120 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i16 + 16 >> 2] = i5;
 HEAP32[i16 + 20 >> 2] = i4;
 HEAP32[i16 + 24 >> 2] = i3;
 mftCall_vii(i21 | 0, i20 | 0, i16 | 0);
 STACKTOP = i23;
 return i2 | 0;
}

function __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKjRKNS_6PxVec3ES8_f(i14, i12, i1, i13, i15, f11) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 72 | 0;
 i6 = i16 + 40 | 0;
 i7 = i16 + 90 | 0;
 i8 = i16 + 28 | 0;
 i9 = i16;
 i10 = i16 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 & 65535;
 i4 = HEAP32[i14 + 36 >> 2] | 0;
 if (i3 >>> 0 >= i4 >>> 0) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i17 = HEAP16[(HEAP32[i14 + 40 >> 2] | 0) + (i3 << 1) >> 1] | 0;
 i1 = i17 & 65535;
 if (!(i17 << 16 >> 16 != -1 & i1 >>> 0 < i4 >>> 0)) {
  i17 = 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 if ((HEAPU16[(HEAP32[i14 + 48 >> 2] | 0) + (i3 << 1) >> 1] | 0 | 0) != (i2 >>> 16 | 0)) {
  i17 = 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 i1 = HEAP32[(HEAP32[i14 + 28 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i1) {
  i17 = 0;
  STACKTOP = i16;
  return i17 | 0;
 }
 i17 = i1;
 i1 = i17 >>> 16;
 if ((i17 & 65535 | 0) == 4) {
  i17 = HEAP32[i14 + 4 >> 2] | 0;
  i14 = HEAP32[(__ZN5physx2Gu19GetRaycastFuncTableEv() | 0) + 12 >> 2] | 0;
  i8 = HEAP32[i17 + (i1 * 72 | 0) + 56 >> 2] | 0;
  i9 = HEAP32[i17 + (i1 * 72 | 0) + 60 >> 2] | 0;
  i10 = HEAP32[i17 + (i1 * 72 | 0) + 64 >> 2] | 0;
  HEAP32[i5 >> 2] = 3;
  HEAP32[i5 + 4 >> 2] = i8;
  HEAP32[i5 + 8 >> 2] = i9;
  HEAP32[i5 + 12 >> 2] = i10;
  f20 = Math_fround(+HEAPF64[i17 + (i1 * 72 | 0) + 16 >> 3]);
  f19 = Math_fround(+HEAPF64[i17 + (i1 * 72 | 0) + 24 >> 3]);
  f18 = Math_fround(+HEAPF64[i17 + (i1 * 72 | 0) + 32 >> 3]);
  HEAP32[i6 >> 2] = HEAP32[i17 + (i1 * 72 | 0) + 40 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i17 + (i1 * 72 | 0) + 44 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i17 + (i1 * 72 | 0) + 48 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i17 + (i1 * 72 | 0) + 52 >> 2];
  HEAPF32[i6 + 16 >> 2] = f20;
  HEAPF32[i6 + 20 >> 2] = f19;
  HEAPF32[i6 + 24 >> 2] = f18;
  HEAP16[i7 >> 1] = 4;
  i15 = (mftCall_iiiiifiiiiii(i14 | 0, i5 | 0, i6 | 0, i13 | 0, i15 | 0, +f11, i7 | 0, 1, i12 | 0, 0, 0, 0) | 0) == 0;
  STACKTOP = i16;
  return (i15 ? 0 : i17 + (i1 * 72 | 0) + 8 | 0) | 0;
 }
 i17 = HEAP32[i14 + 16 >> 2] | 0;
 i14 = HEAP32[(__ZN5physx2Gu19GetRaycastFuncTableEv() | 0) + 8 >> 2] | 0;
 i6 = HEAP32[i17 + (i1 << 6) + 60 >> 2] | 0;
 i7 = HEAP32[i17 + (i1 << 6) + 56 >> 2] | 0;
 HEAP32[i8 >> 2] = 2;
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i7;
 f18 = Math_fround(+HEAPF64[i17 + (i1 << 6) + 16 >> 3]);
 f19 = Math_fround(+HEAPF64[i17 + (i1 << 6) + 24 >> 3]);
 f20 = Math_fround(+HEAPF64[i17 + (i1 << 6) + 32 >> 3]);
 HEAP32[i9 >> 2] = HEAP32[i17 + (i1 << 6) + 40 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i17 + (i1 << 6) + 44 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i17 + (i1 << 6) + 48 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i17 + (i1 << 6) + 52 >> 2];
 HEAPF32[i9 + 16 >> 2] = f18;
 HEAPF32[i9 + 20 >> 2] = f19;
 HEAPF32[i9 + 24 >> 2] = f20;
 HEAP16[i10 >> 1] = 4;
 i15 = (mftCall_iiiiifiiiiii(i14 | 0, i8 | 0, i9 | 0, i13 | 0, i15 | 0, +f11, i10 | 0, 1, i12 | 0, 0, 0, 0) | 0) == 0;
 i17 = i15 ? 0 : i17 + (i1 << 6) + 8 | 0;
 STACKTOP = i16;
 return i17 | 0;
}

function __ZN14ParticleSystem16TransformChangedEi(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 176 | 0;
 i6 = i13 + 136 | 0;
 i7 = i13 + 124 | 0;
 i8 = i13 + 112 | 0;
 i10 = i13 + 48 | 0;
 i11 = i13 + 24 | 0;
 i12 = i13;
 __ZN14ParticleSystem8SyncJobsEb(0);
 i4 = i9 + 28 | 0;
 if ((i1 & 80 | 0) == 64) {
  i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  L3 : do if (!i1) i1 = i9; else {
   i2 = i9;
   while (1) {
    i1 = i1 + 28 | 0;
    i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 80300 | 0) | 0;
    if (!i3) {
     i1 = i2;
     break L3;
    }
    i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
    if (!i1) {
     i1 = i3;
     break;
    } else i2 = i3;
   }
  } while (0);
  __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b(i1, (HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 279 >> 0] | 0) != 0);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i13;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 80260 | 0) | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0, i5, i6, i7, i8);
 i1 = i9 + 40 | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i5, (HEAP32[i1 >> 2] | 0) + 180 | 0, i10);
 i1 = HEAP32[i1 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i1 + 368 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 380 >> 2]);
 f22 = Math_fround(f16 + f17);
 f15 = Math_fround(HEAPF32[i1 + 372 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 384 >> 2]);
 f21 = Math_fround(f15 + f19);
 f14 = Math_fround(HEAPF32[i1 + 376 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 388 >> 2]);
 f21 = Math_fround(f21 * Math_fround(.5));
 f20 = Math_fround(Math_fround(f14 + f18) * Math_fround(.5));
 HEAPF32[i12 >> 2] = Math_fround(f22 * Math_fround(.5));
 HEAPF32[i12 + 4 >> 2] = f21;
 HEAPF32[i12 + 8 >> 2] = f20;
 f15 = Math_fround(Math_fround(f19 - f15) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f18 - f14) * Math_fround(.5));
 HEAPF32[i12 + 12 >> 2] = Math_fround(Math_fround(f17 - f16) * Math_fround(.5));
 HEAPF32[i12 + 16 >> 2] = f15;
 HEAPF32[i12 + 20 >> 2] = f14;
 if ((HEAP32[(HEAP32[i9 + 36 >> 2] | 0) + 280 >> 2] | 0) != 1) __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i12, i1 + 52 | 0, i12);
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i12, i10, i11);
 i12 = i2 + 568 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 __ZN8Renderer18UpdateManagerStateEb(i2, 1);
 STACKTOP = i13;
 return;
}

function __ZL19SweepCapsuleCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i11) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 80 | 0;
 i17 = i12 + 68 | 0;
 i16 = i12 + 40 | 0;
 i15 = i12 + 28 | 0;
 i14 = i12;
 i13 = i12 + 128 | 0;
 HEAP32[i17 >> 2] = 2;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAPF32[i17 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i16 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 2;
 i1 = i15 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 64 >> 2];
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i3 + 40 | 0, i3 + 52 | 0, i1);
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP16[i10 + 12 >> 1] = 0;
 i3 = i10 + 16 | 0;
 i1 = i10 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i11 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i10, i13, Math_fround(0.0)) | 0)) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 32 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 36 >> 2];
 HEAP32[i11 + 40 >> 2] = -1;
 HEAP32[i11 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i11 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i10 + 20 >> 2]);
 HEAPF64[i11 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i10 + 24 >> 2]);
 HEAPF64[i11 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i17 = 1;
 STACKTOP = i12;
 return i17 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPKv(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN6b2Body7SetTypeE10b2BodyType(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i8 + 88 | 0;
 if (HEAP32[(HEAP32[i7 >> 2] | 0) + 102868 >> 2] & 2 | 0) {
  STACKTOP = i9;
  return;
 }
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 __ZN6b2Body13ResetMassDataEv(i8);
 do if (!(HEAP32[i8 >> 2] | 0)) {
  i2 = i8 + 64 | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 72 >> 2] = Math_fround(0.0);
  i4 = HEAP32[i8 + 56 >> 2] | 0;
  HEAP32[i8 + 52 >> 2] = i4;
  i3 = i8 + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i15 = i8 + 36 | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i15 + 4 >> 2] = i3;
  f12 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = Math_fround(+Math_sin(+f12));
  HEAPF32[i5 + 8 >> 2] = f14;
  f12 = Math_fround(+Math_cos(+f12));
  HEAPF32[i5 + 12 >> 2] = f12;
  f13 = Math_fround(HEAPF32[i8 + 28 >> 2]);
  f11 = Math_fround(f12 * f13);
  f10 = Math_fround(HEAPF32[i8 + 32 >> 2]);
  f11 = Math_fround(f11 - Math_fround(f14 * f10));
  f10 = Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * f10));
  f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f11);
  f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f10);
  HEAPF32[i5 >> 2] = f11;
  HEAPF32[i5 + 4 >> 2] = f10;
  i3 = (HEAP32[i7 >> 2] | 0) + 102872 | 0;
  i1 = HEAP32[i8 + 100 >> 2] | 0;
  if (i1) {
   i4 = i8 + 12 | 0;
   do {
    __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i1, i3, i5, i4);
    i1 = HEAP32[i1 + 24 >> 2] | 0;
   } while ((i1 | 0) != 0);
   if (HEAP32[i8 >> 2] | 0) {
    i6 = 9;
    break;
   }
  }
  i15 = i8 + 4 | 0;
  HEAP16[i15 >> 1] = (HEAPU16[i15 >> 1] | 0) & 65533;
  HEAPF32[i8 + 144 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
 } else i6 = 9; while (0);
 if ((i6 | 0) == 9) {
  i1 = i8 + 4 | 0;
  i2 = HEAPU16[i1 >> 1] | 0;
  if (!(i2 & 2)) {
   HEAP16[i1 >> 1] = i2 | 2;
   HEAPF32[i8 + 144 >> 2] = Math_fround(0.0);
  }
 }
 HEAPF32[i8 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 84 >> 2] = Math_fround(0.0);
 i2 = i8 + 112 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i15 = i1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  __ZN16b2ContactManager7DestroyEP9b2Contact((HEAP32[i7 >> 2] | 0) + 102872 | 0, HEAP32[i15 + 4 >> 2] | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 i5 = (HEAP32[i7 >> 2] | 0) + 102872 | 0;
 i1 = HEAP32[i8 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do {
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i4 = i1 + 44 | 0;
   i2 = 0;
   do {
    __ZN12b2BroadPhase10TouchProxyEi(i5, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 28 | 0) + 24 >> 2] | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  i1 = HEAP32[i1 + 24 >> 2] | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu26computeSphereTriImpactDataERNS_6PxVec3ES2_RKS1_S4_fRKNS_10PxTriangleE(i3, i9, i1, i2, f4, i8) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 i8 = i8 | 0;
 var f5 = f0, f6 = f0, f7 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10 + 20 | 0;
 i15 = i10;
 f6 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f4);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f4);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f4);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i1 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i14 >> 2] = f6;
 i12 = i14 + 4 | 0;
 HEAPF32[i12 >> 2] = f5;
 i2 = i14 + 8 | 0;
 HEAPF32[i2 >> 2] = f4;
 __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_(i15, i14, i8, i8 + 12 | 0, i8 + 24 | 0, i10 + 16 | 0, i10 + 12 | 0);
 i13 = HEAP32[i15 >> 2] | 0;
 HEAP32[i3 >> 2] = i13;
 i11 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i11;
 i1 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i3 + 8 >> 2] = i1;
 f4 = Math_fround(HEAPF32[i14 >> 2]);
 f4 = Math_fround(f4 - (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 f5 = Math_fround(f5 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i9 >> 2] = f4;
 i1 = i9 + 4 | 0;
 HEAPF32[i1 >> 2] = f5;
 i2 = i9 + 8 | 0;
 HEAPF32[i2 >> 2] = f6;
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6))));
 if (f7 > Math_fround(0.0)) {
  f16 = Math_fround(Math_fround(1.0) / f7);
  HEAPF32[i9 >> 2] = Math_fround(f4 * f16);
  HEAPF32[i1 >> 2] = Math_fround(f5 * f16);
  HEAPF32[i2 >> 2] = Math_fround(f6 * f16);
 }
 if (!(f7 < Math_fround(.00100000005))) {
  STACKTOP = i10;
  return;
 }
 f17 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(f17 - f6);
 f7 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f7 = Math_fround(f7 - f16);
 f18 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f18 = Math_fround(f18 - f5);
 f6 = Math_fround(Math_fround(HEAPF32[i8 + 24 >> 2]) - f6);
 f16 = Math_fround(Math_fround(HEAPF32[i8 + 28 >> 2]) - f16);
 f5 = Math_fround(Math_fround(HEAPF32[i8 + 32 >> 2]) - f5);
 f4 = Math_fround(Math_fround(f7 * f5) - Math_fround(f18 * f16));
 f5 = Math_fround(Math_fround(f18 * f6) - Math_fround(f17 * f5));
 f6 = Math_fround(Math_fround(f17 * f16) - Math_fround(f7 * f6));
 HEAPF32[i9 >> 2] = f4;
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i2 >> 2] = f6;
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)))));
 if (!(f7 > Math_fround(0.0))) {
  STACKTOP = i10;
  return;
 }
 f18 = Math_fround(Math_fround(1.0) / f7);
 HEAPF32[i9 >> 2] = Math_fround(f4 * f18);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f18);
 HEAPF32[i2 >> 2] = Math_fround(f6 * f18);
 STACKTOP = i10;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii(i10, i4, i9, i1) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i11 = 0;
 if ((i9 | 0) < (i4 | 0)) return;
 i2 = i1 - i4 + 1 | 0;
 i11 = i4 << 2;
 i8 = HEAP32[i10 + 440 >> 2] | 0;
 i3 = i8 + (i11 * 60 | 0) | 0;
 i6 = HEAP32[i10 + 356 >> 2] | 0;
 i1 = i6 + (i4 << 3) | 0;
 i4 = (HEAP8[i10 + 254 >> 0] | 0) == 0;
 f7 = Math_fround(HEAPF32[(i4 ? i1 : i8 + (i11 * 60 | 0) | 0) >> 2]);
 if (i4) {
  f5 = Math_fround(HEAPF32[i6 + (i9 << 3) >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[(HEAP32[i10 + 376 >> 2] | 0) + (i9 << 2) >> 2]));
 } else f5 = Math_fround(HEAPF32[i8 + ((i9 << 2 | 1) * 60 | 0) >> 2]);
 switch (HEAP32[i10 + 216 >> 2] | 0) {
 case 0:
  {
   if (!(HEAP8[i10 + 229 >> 0] | 0)) f5 = f7; else {
    f5 = Math_fround(HEAPF32[i10 + 248 >> 2]);
    f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f7 * f5) + Math_fround(.5)))) / f5);
   }
   if (!i2) return;
   i4 = i2 << 2;
   while (1) {
    i4 = i4 + -1 | 0;
    HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f5);
    i11 = i3 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i4) break; else i3 = i3 + 60 | 0;
   }
   if (!i1) return;
   while (1) {
    i2 = i2 + -1 | 0;
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
    i11 = i1 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i2) break; else i1 = i1 + 8 | 0;
   }
   return;
  }
 case 2:
  {
   if (HEAP8[i10 + 229 >> 0] | 0) {
    f7 = Math_fround(HEAPF32[i10 + 248 >> 2]);
    f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f5 * f7) + Math_fround(.5)))) / f7);
   }
   if (!i2) return;
   i4 = i2 << 2;
   while (1) {
    i4 = i4 + -1 | 0;
    HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f5);
    i11 = i3 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i4) break; else i3 = i3 + 60 | 0;
   }
   if (!i1) return;
   while (1) {
    i2 = i2 + -1 | 0;
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
    i11 = i1 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i2) break; else i1 = i1 + 8 | 0;
   }
   return;
  }
 case 1:
  {
   f5 = Math_fround(Math_fround(f7 + f5) * Math_fround(.5));
   if (HEAP8[i10 + 229 >> 0] | 0) {
    f7 = Math_fround(HEAPF32[i10 + 248 >> 2]);
    f5 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f5 * f7) + Math_fround(.5)))) / f7);
   }
   if (!i2) return;
   i4 = i2 << 2;
   while (1) {
    i4 = i4 + -1 | 0;
    HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f5);
    i11 = i3 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i4) break; else i3 = i3 + 60 | 0;
   }
   if (!i1) return;
   while (1) {
    i2 = i2 + -1 | 0;
    HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
    i11 = i1 + 4 | 0;
    HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(0.0));
    if (!i2) break; else i1 = i1 + 8 | 0;
   }
   return;
  }
 default:
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 16 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 4) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863904 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863904 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEm(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEl(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEj(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i13, i9) {
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 HEAP32[i14 >> 2] = i14;
 i11 = i14 + 4 | 0;
 HEAP32[i11 >> 2] = i14;
 i12 = i14 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = i13 + 8 | 0;
 if ((i14 | 0) == (i13 | 0)) {
  i6 = HEAP32[i9 >> 2] | 0;
  i5 = i2;
  do {
   i2 = i5 + 4 | 0;
   if ((HEAP32[i1 + 8 >> 2] | 0) == (i6 | 0)) {
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = i3;
    L10 : do if ((i3 | 0) == (i13 | 0)) {
     i4 = 0;
     i3 = i13;
    } else while (1) {
     if ((HEAP32[i2 + 8 >> 2] | 0) != (i6 | 0)) {
      i4 = 1;
      break L10;
     }
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     i3 = i2;
     if ((i3 | 0) == (i13 | 0)) {
      i4 = 0;
      i3 = i13;
      break;
     }
    } while (0);
    if ((i5 | 0) != (i3 | 0)) {
     i11 = HEAP32[i2 >> 2] | 0;
     i12 = i11 + 4 | 0;
     i10 = HEAP32[i5 >> 2] | 0;
     HEAP32[i10 + 4 >> 2] = HEAP32[i12 >> 2];
     HEAP32[HEAP32[i12 >> 2] >> 2] = i10;
     i10 = HEAP32[i14 >> 2] | 0;
     HEAP32[i10 + 4 >> 2] = i5;
     HEAP32[i1 >> 2] = i10;
     HEAP32[i14 >> 2] = i11;
     HEAP32[i12 >> 2] = i14;
    }
    if (i4) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i2;
   } else i1 = HEAP32[i2 >> 2] | 0;
   i5 = i1;
  } while ((i5 | 0) != (i13 | 0));
  STACKTOP = i15;
  return;
 } else {
  i3 = i14;
  i8 = i2;
  i2 = 0;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i4 = i8 + 4 | 0;
  if ((i7 | 0) == (HEAP32[i9 >> 2] | 0)) {
   i5 = HEAP32[i4 >> 2] | 0;
   i4 = i5;
   L26 : do if ((i5 | 0) == (i13 | 0)) {
    i7 = 0;
    i6 = i13;
   } else {
    i6 = i5;
    while (1) {
     if ((HEAP32[i4 + 8 >> 2] | 0) != (i7 | 0)) {
      i7 = 1;
      break L26;
     }
     i4 = HEAP32[i6 + 4 >> 2] | 0;
     i6 = i4;
     if ((i6 | 0) == (i13 | 0)) {
      i7 = 0;
      i6 = i13;
      break;
     }
    }
   } while (0);
   if ((i8 | 0) != (i6 | 0)) {
    if ((i5 | 0) == (i6 | 0)) i3 = 1; else {
     i3 = 1;
     do {
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      i3 = i3 + 1 | 0;
     } while ((i5 | 0) != (i6 | 0));
    }
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) - i3;
    i2 = i2 + i3 | 0;
    HEAP32[i12 >> 2] = i2;
    i3 = HEAP32[i4 >> 2] | 0;
    i5 = i3 + 4 | 0;
    i16 = HEAP32[i8 >> 2] | 0;
    HEAP32[i16 + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[HEAP32[i5 >> 2] >> 2] = i16;
    i16 = HEAP32[i14 >> 2] | 0;
    HEAP32[i16 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i5 >> 2] = i14;
   }
   if (i7) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i4;
  } else i1 = HEAP32[i4 >> 2] | 0;
  i8 = i1;
 } while ((i8 | 0) != (i13 | 0));
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i16 = i3 + 4 | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[HEAP32[i16 >> 2] >> 2] = i13;
 HEAP32[i12 >> 2] = 0;
 if ((i1 | 0) == (i14 | 0)) {
  STACKTOP = i15;
  return;
 }
 do {
  i16 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZdlPv(i16);
 } while ((i1 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEy(i12, i5, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i10 | 0, i12 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0;
     HEAP32[i9 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     i1 = invoke_iiiiiii(i14 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0, i7 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEx(i12, i5, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 12 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i10 | 0, i12 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i12;
  i3 = i12;
  i11 = 19;
 } else {
  do if (HEAP8[i10 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i11 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i11 = 10; while (0);
    if ((i11 | 0) == 10) {
     i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0;
     HEAP32[i9 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
     i1 = invoke_iiiiiii(i14 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0, i7 | 0) | 0;
     i14 = __THREW__;
     __THREW__ = 0;
     if (!(i14 & 1)) {
      if (i1 | 0) break;
      i14 = i12 + (HEAP32[(HEAP32[i12 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | 5 | 0);
      i14 = __THREW__;
      __THREW__ = 0;
      if (!(i14 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
   i2 = i12;
   i3 = i12;
   i11 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i10);
 } while (0);
 do if ((i11 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx21PxcArticulationHelper13prepareFsDataERNS_9PxcFsDataEPKNS_19PxsArticulationLinkE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i7 = HEAP16[i1 + 8 >> 1] | 0;
 i4 = i7 & 65535;
 i8 = HEAPU16[i1 + 26 >> 1] | 0;
 i5 = i1 + (i8 + 144) | 0;
 i2 = i1 + ((HEAPU16[i1 + 24 >> 1] | 0) + (i4 * 432 | 0)) | 0;
 i3 = i1 + (HEAPU16[i1 + 10 >> 1] | 0) | 0;
 i11 = i6;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1 + (i8 + 288) | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i1 = i1 + (i8 + 296) | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 if ((i7 & 65535) > 1) i1 = 1; else return;
 do {
  i11 = i6 + (i1 << 5) | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i5 + (i1 * 160 | 0) + 144 | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  i9 = i6 + (i1 << 5) + 8 | 0;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i5 + (i1 * 160 | 0) + 152 | 0;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  f13 = Math_fround(HEAPF32[i3 + (i1 << 5) + 16 >> 2]);
  f15 = Math_fround(HEAPF32[i3 + (i1 << 5) + 20 >> 2]);
  f19 = Math_fround(HEAPF32[i3 + (i1 << 5) + 24 >> 2]);
  f12 = Math_fround(f15 * Math_fround(0.0));
  f14 = Math_fround(f19 * Math_fround(0.0));
  f16 = Math_fround(f13 * Math_fround(0.0));
  f17 = Math_fround(Math_fround(f19 - f16) + Math_fround(0.0));
  f18 = Math_fround(Math_fround(f16 - f15) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) >> 2] = Math_fround(Math_fround(f12 - f14) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) + 4 >> 2] = f17;
  HEAPF32[i2 + (i1 * 96 | 0) + 8 >> 2] = f18;
  HEAPF32[i2 + (i1 * 96 | 0) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 16 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 28 >> 2] = Math_fround(0.0);
  f18 = Math_fround(Math_fround(f14 - f16) + Math_fround(0.0));
  f17 = Math_fround(Math_fround(f13 - f12) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) + 32 >> 2] = Math_fround(Math_fround(f12 - f19) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) + 36 >> 2] = f18;
  HEAPF32[i2 + (i1 * 96 | 0) + 40 >> 2] = f17;
  HEAPF32[i2 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 52 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 56 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 60 >> 2] = Math_fround(0.0);
  f13 = Math_fround(Math_fround(f14 - f13) + Math_fround(0.0));
  f12 = Math_fround(Math_fround(f16 - f12) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) + 64 >> 2] = Math_fround(Math_fround(f15 - f14) + Math_fround(0.0));
  HEAPF32[i2 + (i1 * 96 | 0) + 68 >> 2] = f13;
  HEAPF32[i2 + (i1 * 96 | 0) + 72 >> 2] = f12;
  HEAPF32[i2 + (i1 * 96 | 0) + 76 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 88 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 92 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN20BaseBehaviourManager12CommonUpdateI21FixedBehaviourManagerEEvv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = i1 + 8 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  while (1) {
   i4 = HEAP32[i2 + 20 >> 2] | 0;
   i5 = HEAP32[i2 + 24 >> 2] | 0;
   i1 = i5 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i5 | 0)) {
    i9 = HEAP32[i4 >> 2] | 0;
    HEAP32[i9 + 4 >> 2] = i3;
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 >> 2] = i9;
    HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i5 >> 2] = i5;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i2 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 4 | 0;
 i7 = i11 + 8 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11;
 do {
  i4 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i11 >> 2] = i11;
  HEAP32[i6 >> 2] = i11;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i9;
  HEAP32[i11 >> 2] = i3;
  i5 = i4 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  if ((HEAP32[i4 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i4 >> 2] = i4;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  if ((i3 | 0) == (i4 | 0)) HEAP32[i11 >> 2] = i11;
  if ((HEAP32[i5 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i5 >> 2] = i4;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 | 0)) HEAP32[i6 >> 2] = i11;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
  HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] = i11;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 >> 2] = i11;
  L34 : do if ((i1 | 0) == (i11 | 0)) i12 = 27; else {
   i3 = i11;
   while (1) {
    HEAP32[i8 >> 2] = i1;
    if (i3 | 0) {
     i5 = i1 + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
    }
    i3 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) {
     if (!i1) break L34;
    } else {
     i5 = i1 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     HEAP32[i1 >> 2] = i4;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 + 4 >> 2] = i1;
     HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
    }
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i3 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) == (i11 | 0)) {
     i12 = 27;
     break L34;
    }
    i1 = i3;
    i3 = HEAP32[i3 >> 2] | 0;
   }
  } while (0);
  if ((i12 | 0) == 27) {
   i12 = 0;
   HEAP32[i8 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
    i2 = i1;
    break;
   } else i2 = i1;
  } else {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) break; else i2 = i1;
   }
  }
 } while ((i2 | 0) != (i10 | 0));
 STACKTOP = i13;
 return;
}

function __ZNK15PolynomialCurve20FindMinMaxIntegratedEv(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i24 + 32 | 0;
 i19 = i24 + 16 | 0;
 i20 = i24;
 i21 = i10 + 4 | 0;
 HEAPF32[i21 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 i22 = i11 + 224 | 0;
 if ((HEAP32[i22 >> 2] | 0) <= 0) {
  STACKTOP = i24;
  return;
 }
 i23 = i17 + 12 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17 + 4 | 0;
 i14 = i17 + 12 | 0;
 i15 = i17 + 8 | 0;
 i16 = i17 + 4 | 0;
 i9 = 0;
 f7 = Math_fround(0.0);
 f1 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 do {
  f3 = Math_fround(HEAPF32[i11 + (i9 << 4) >> 2]);
  f4 = Math_fround(HEAPF32[i11 + (i9 << 4) + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i11 + (i9 << 4) + 8 >> 2]);
  i8 = __Z27CubicPolynomialRootsGenericPfdddd(i20, +Math_fround(f3 * Math_fround(4.0)), +Math_fround(f4 * Math_fround(3.0)), +Math_fround(f5 * Math_fround(2.0)), +Math_fround(HEAPF32[i11 + (i9 << 4) + 12 >> 2])) | 0;
  i18 = i11 + 192 + (i9 << 2) | 0;
  if ((i8 | 0) > 0) {
   i6 = 0;
   f3 = f2;
   f5 = f1;
   while (1) {
    f4 = Math_fround(f7 + Math_fround(HEAPF32[i20 + (i6 << 2) >> 2]));
    if (!(f4 >= f7)) f4 = f5; else if (f4 < Math_fround(HEAPF32[i18 >> 2])) {
     HEAPF32[i14 >> 2] = f4;
     HEAPF32[i15 >> 2] = f4;
     HEAPF32[i16 >> 2] = f4;
     HEAPF32[i17 >> 2] = f4;
     __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i19, i11, i17);
     f4 = Math_fround(HEAPF32[i19 >> 2]);
     f1 = Math_fround(_fminf(f4, f4));
     HEAPF32[i10 >> 2] = Math_fround(_fminf(f3, Math_fround(_fminf(f1, f1))));
     f3 = Math_fround(_fmaxf(f4, f4));
     HEAPF32[i21 >> 2] = Math_fround(_fmaxf(f5, Math_fround(_fmaxf(f3, f3))));
     i25 = i10;
     i26 = HEAP32[i25 >> 2] | 0;
     i25 = HEAP32[i25 + 4 >> 2] | 0;
     HEAP32[i10 >> 2] = i26;
     HEAP32[i21 >> 2] = i25;
     f3 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f4 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     f1 = f4;
     f2 = f3;
    } else f4 = f5;
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i8 | 0)) break; else f5 = f4;
   }
  }
  i26 = HEAP32[i18 >> 2] | 0;
  HEAP32[i23 >> 2] = i26;
  HEAP32[i12 >> 2] = i26;
  HEAP32[i13 >> 2] = i26;
  HEAP32[i17 >> 2] = i26;
  __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i19, i11, i17);
  f7 = Math_fround(HEAPF32[i19 >> 2]);
  f5 = Math_fround(_fminf(f7, f7));
  HEAPF32[i10 >> 2] = Math_fround(_fminf(f2, Math_fround(_fminf(f5, f5))));
  f7 = Math_fround(_fmaxf(f7, f7));
  HEAPF32[i21 >> 2] = Math_fround(_fmaxf(f1, Math_fround(_fmaxf(f7, f7))));
  i26 = i10;
  i25 = HEAP32[i26 >> 2] | 0;
  i26 = HEAP32[i26 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = i25;
  HEAP32[i21 >> 2] = i26;
  f7 = Math_fround(HEAPF32[i18 >> 2]);
  i9 = i9 + 1 | 0;
  f2 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i26, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i9 | 0) < (HEAP32[i22 >> 2] | 0));
 STACKTOP = i24;
 return;
}

function __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 do switch (i2 | 0) {
 case 2:
 case 1:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 128, 16) | 0;
   i3 = i4 + 28 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP8[i4 + 52 >> 0] = 0;
   HEAP32[i4 + 56 >> 2] = -1;
   HEAP32[i4 + 112 >> 2] = 0;
   HEAP16[i4 + 116 >> 1] = 0;
   return i4 | 0;
  }
 case 3:
  {
   i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 272, 16) | 0;
   HEAP16[i2 >> 1] = 0;
   HEAP8[i2 + 3 >> 0] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP8[i2 + 20 >> 0] = 1;
   HEAP32[i2 + 24 >> 2] = i2 + 4;
   HEAP32[i2 + 32 >> 2] = 4;
   HEAP32[i2 + 76 >> 2] = 0;
   HEAP8[i2 + 68 >> 0] = 1;
   HEAP32[i2 + 72 >> 2] = i2 + 36;
   HEAP32[i2 + 80 >> 2] = 4;
   HEAP32[i2 + 84 >> 2] = 0;
   HEAP32[i2 + 88 >> 2] = 0;
   i1 = i2 + 220 | 0;
   i3 = i1;
   i4 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   HEAP8[i1 + 48 >> 0] = 0;
   i4 = i2;
   return i4 | 0;
  }
 case 4:
  {
   i1 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 272, 16) | 0;
   HEAP16[i1 >> 1] = 0;
   HEAP8[i1 + 3 >> 0] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP8[i1 + 20 >> 0] = 1;
   HEAP32[i1 + 24 >> 2] = i1 + 4;
   HEAP32[i1 + 32 >> 2] = 4;
   HEAP32[i1 + 76 >> 2] = 0;
   HEAP8[i1 + 68 >> 0] = 1;
   HEAP32[i1 + 72 >> 2] = i1 + 36;
   HEAP32[i1 + 80 >> 2] = 4;
   HEAP32[i1 + 84 >> 2] = 0;
   HEAP32[i1 + 88 >> 2] = 0;
   i2 = i1 + 220 | 0;
   i3 = i2;
   i4 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   HEAP8[i2 + 48 >> 0] = 0;
   i4 = i1;
   return i4 | 0;
  }
 case 5:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 128, 16) | 0;
   HEAP16[i4 >> 1] = 0;
   HEAP8[i4 + 3 >> 0] = 0;
   HEAP32[i4 + 28 >> 2] = 0;
   HEAP8[i4 + 20 >> 0] = 1;
   HEAP32[i4 + 24 >> 2] = i4 + 4;
   HEAP32[i4 + 32 >> 2] = 4;
   HEAP32[i4 + 76 >> 2] = 0;
   HEAP8[i4 + 68 >> 0] = 1;
   HEAP32[i4 + 72 >> 2] = i4 + 36;
   HEAP32[i4 + 80 >> 2] = 4;
   HEAP32[i4 + 84 >> 2] = 0;
   HEAP32[i4 + 88 >> 2] = 0;
   return i4 | 0;
  }
 case 6:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 24, 16) | 0;
   HEAP16[i4 + 16 >> 1] = 0;
   return i4 | 0;
  }
 case 7:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 80, 16) | 0;
   HEAP16[i4 >> 1] = 0;
   HEAP8[i4 + 3 >> 0] = 0;
   i3 = i4 + 60 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP16[i3 + 16 >> 1] = 0;
   return i4 | 0;
  }
 case 8:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 28, 16) | 0;
   return i4 | 0;
  }
 case 9:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 144, 16) | 0;
   return i4 | 0;
  }
 case 10:
  {
   i4 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i1 + 2436 | 0, 16, 16) | 0;
   HEAP32[i4 >> 2] = -1;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = -1;
   HEAP32[i4 + 12 >> 2] = 0;
   return i4 | 0;
  }
 default:
  {
   i4 = 0;
   return i4 | 0;
  }
 } while (0);
 return 0;
}

function __ZN20BaseBehaviourManager12CommonUpdateI20LateBehaviourManagerEEvv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = i1 + 8 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  while (1) {
   i4 = HEAP32[i2 + 20 >> 2] | 0;
   i5 = HEAP32[i2 + 24 >> 2] | 0;
   i1 = i5 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i5 | 0)) {
    i9 = HEAP32[i4 >> 2] | 0;
    HEAP32[i9 + 4 >> 2] = i3;
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 >> 2] = i9;
    HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i5 >> 2] = i5;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i2 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 4 | 0;
 i7 = i11 + 8 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11;
 do {
  i4 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i11 >> 2] = i11;
  HEAP32[i6 >> 2] = i11;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i9;
  HEAP32[i11 >> 2] = i3;
  i5 = i4 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  if ((HEAP32[i4 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i4 >> 2] = i4;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  if ((i3 | 0) == (i4 | 0)) HEAP32[i11 >> 2] = i11;
  if ((HEAP32[i5 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i5 >> 2] = i4;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 | 0)) HEAP32[i6 >> 2] = i11;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
  HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] = i11;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 >> 2] = i11;
  L34 : do if ((i1 | 0) == (i11 | 0)) i12 = 27; else {
   i3 = i11;
   while (1) {
    HEAP32[i8 >> 2] = i1;
    if (i3 | 0) {
     i5 = i1 + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
    }
    i3 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) {
     if (!i1) break L34;
    } else {
     i5 = i1 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     HEAP32[i1 >> 2] = i4;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 + 4 >> 2] = i1;
     HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
    }
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) == (i11 | 0)) {
     i12 = 27;
     break L34;
    }
    i1 = i3;
    i3 = HEAP32[i3 >> 2] | 0;
   }
  } while (0);
  if ((i12 | 0) == 27) {
   i12 = 0;
   HEAP32[i8 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
    i2 = i1;
    break;
   } else i2 = i1;
  } else {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) break; else i2 = i1;
   }
  }
 } while ((i2 | 0) != (i10 | 0));
 STACKTOP = i13;
 return;
}

function _unity_z_crc32(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i3) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = ~i1;
 L4 : do if (i2) {
  while (1) {
   if (!(i3 & 3)) break;
   i1 = HEAP32[gb + 16960 + (((HEAPU8[i3 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
   i2 = i2 + -1 | 0;
   if (!i2) break L4; else i3 = i3 + 1 | 0;
  }
  if (i2 >>> 0 > 31) {
   i5 = i2 + -32 | 0;
   i6 = i5 & -32;
   i4 = i3 + (i6 + 32) | 0;
   while (1) {
    i7 = HEAP32[i3 >> 2] ^ i1;
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 4 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 8 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 12 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 16 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 20 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 24 >> 2];
    i7 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2] ^ HEAP32[i3 + 28 >> 2];
    i1 = HEAP32[gb + 16960 + 2048 + ((i7 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i7 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i7 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i7 >>> 24 << 2) >> 2];
    i2 = i2 + -32 | 0;
    if (i2 >>> 0 <= 31) break; else i3 = i3 + 32 | 0;
   }
   i3 = i4;
   i2 = i5 - i6 | 0;
  }
  if (i2 >>> 0 > 3) {
   i6 = i2 + -4 | 0;
   i7 = i6 >>> 2;
   i5 = i7 + 1 | 0;
   i4 = i3;
   while (1) {
    i8 = HEAP32[i4 >> 2] ^ i1;
    i1 = HEAP32[gb + 16960 + 2048 + ((i8 >>> 8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 3072 + ((i8 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + 1024 + ((i8 >>> 16 & 255) << 2) >> 2] ^ HEAP32[gb + 16960 + (i8 >>> 24 << 2) >> 2];
    i2 = i2 + -4 | 0;
    if (i2 >>> 0 <= 3) break; else i4 = i4 + 4 | 0;
   }
   i3 = i3 + (i5 << 2) | 0;
   i2 = i6 - (i7 << 2) | 0;
  }
  if (i2) while (1) {
   i1 = HEAP32[gb + 16960 + (((HEAPU8[i3 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i3 = i3 + 1 | 0;
  }
 } while (0);
 i8 = ~i1;
 return i8 | 0;
}

function __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i10, i4, i9, i6, i2) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[i10 + 92 >> 2] | 0;
 if (!i8) {
  i9 = HEAP32[i10 + 276 >> 2] | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 + 1;
  return i10 | 0;
 }
 i5 = i10 + 280 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i1 = (i7 | 0) == 12;
 L5 : do if (i2) {
  if (i1) i1 = -1; else {
   i2 = i9 >>> 0 > 2;
   i3 = (i9 & 1 | 0) != 0;
   i1 = __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i8, i10, i4, i2 | i3) | 0;
   if ((i7 | 0) == 4) if (!((HEAP32[i10 + 60 >> 2] | 0) != 1 | (i2 | i3) ^ 1)) {
    L11 : do switch (HEAP32[i8 >> 2] | 0) {
    case 2:
     {
      HEAP32[i8 + 16 >> 2] = i1;
      HEAP32[i8 >> 2] = 3;
      break;
     }
    case 1:
     {
      i2 = i8 + 4 | 0;
      if ((HEAP32[i2 >> 2] | 0) == -1) HEAP32[i2 >> 2] = i1;
      if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) {
       HEAP32[i8 >> 2] = 2;
       HEAP8[i8 + 20 >> 0] = 1;
       break L11;
      } else {
       HEAP32[i8 + 12 >> 2] = i1;
       break L11;
      }
     }
    default:
     {}
    } while (0);
    HEAP32[i8 + 8 >> 2] = i1;
   }
  }
  switch (HEAP32[HEAP32[i5 >> 2] >> 2] | 0) {
  case 12:
  case 8:
   {
    i6 = i1;
    break L5;
   }
  default:
   {}
  }
  if (i9 >>> 0 > 2 | (i9 & 1 | 0) != 0) {
   i8 = (HEAP32[i8 + 24 >> 2] | 0) + (((HEAP32[i8 + 44 >> 2] | 0) + -1 | 0) * 28 | 0) + 12 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i6 = i1;
  } else i6 = i1;
 } else if (i1) i6 = -1; else {
  i1 = i9 >>> 0 > 2;
  i3 = (i9 & 1 | 0) != 0;
  i2 = __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i8, i10, i4, i1 | i3) | 0;
  if ((i7 | 0) == 4) if ((HEAP32[i10 + 60 >> 2] | 0) != 1 | (i1 | i3) ^ 1) i6 = i2; else {
   L28 : do switch (HEAP32[i8 >> 2] | 0) {
   case 2:
    {
     HEAP32[i8 + 16 >> 2] = i2;
     HEAP32[i8 >> 2] = 3;
     break;
    }
   case 1:
    {
     i1 = i8 + 4 | 0;
     if ((HEAP32[i1 >> 2] | 0) == -1) HEAP32[i1 >> 2] = i2;
     if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) {
      HEAP32[i8 >> 2] = 2;
      HEAP8[i8 + 20 >> 0] = 1;
      break L28;
     } else {
      HEAP32[i8 + 12 >> 2] = i2;
      break L28;
     }
    }
   default:
    {}
   } while (0);
   HEAP32[i8 + 8 >> 2] = i2;
   i6 = i2;
  } else i6 = i2;
 } while (0);
 if ((i9 | 0) == 2) {
  i10 = i6;
  return i10 | 0;
 }
 i5 = i10 + 80 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  i10 = i6;
  return i10 | 0;
 }
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 if (!i1) i3 = 0; else i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  i10 = i2 + 4 | 0;
  i9 = i10;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = i2;
 }
 if (!i3) i1 = -1; else i1 = HEAP32[i3 >> 2] | 0;
 __ZN5IMGUI19NamedKeyControlList15AddNamedControlERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEii(i2, i4, i6, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[i5 >> 2] = 0;
 i10 = i6;
 return i10 | 0;
}

function __ZN5Umbra20RuntimeTomeGenerator23combineHierarchyPortalsEi(i27, i1) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0;
 i32 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i32 + 32 | 0;
 i29 = i32 + 16 | 0;
 i30 = i32;
 i31 = i27 + 76 | 0;
 if ((HEAP32[i31 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[(HEAP32[i27 + 68 >> 2] | 0) + (i1 << 5) >> 2] | 0) + 52 >> 2] & 65535;
  if (!i1) {
   STACKTOP = i32;
   return;
  }
 } else i1 = 1;
 i19 = i27 + 288 | 0;
 i20 = i27 + 268 | 0;
 i21 = i27 + 272 | 0;
 i22 = i27 + 148 | 0;
 i23 = i27 + 68 | 0;
 i14 = i29 + 4 | 0;
 i16 = i29 + 8 | 0;
 i18 = i29 + 12 | 0;
 i13 = i30 + 4 | 0;
 i15 = i30 + 8 | 0;
 i17 = i30 + 12 | 0;
 i24 = i27 + 164 | 0;
 i25 = i29 + 8 | 0;
 i26 = i30 + 8 | 0;
 i12 = 0;
 i2 = HEAP32[i19 >> 2] | 0;
 do {
  i11 = HEAP32[i2 + (i12 << 2) >> 2] | 0;
  HEAP32[i28 >> 2] = i11;
  if (!i11) i3 = 0; else {
   i2 = i11;
   i3 = HEAP32[i21 >> 2] | 0;
   do {
    i10 = i2 + -1 | 0;
    i2 = HEAP32[i3 + (i10 * 28 | 0) >> 2] | 0;
    i4 = HEAP32[i3 + (i10 * 28 | 0) + 4 >> 2] | 0;
    if (!(i2 & 268435456)) {
     if (i2 & 67108864 | 0) break;
     i9 = HEAP32[(HEAP32[i22 >> 2] | 0) + ((i2 & 67108863) << 2) >> 2] | 0;
     if ((HEAP32[i31 >> 2] | 0) > (i9 | 0)) {
      i5 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i9 << 5) + 12 >> 2] | 0;
      if ((i5 | 0) != -1) {
       i8 = i4 >>> 16;
       i7 = i2 & -536870912;
       i6 = i4 & 65535;
       i3 = 0;
       while (1) {
        i4 = __ZN5Umbra20RuntimeTomeGenerator13getParentCellEiii(i27, i9, i8, i3) | 0;
        i2 = HEAP32[i31 >> 2] | 0;
        if ((i5 | 0) < (i2 | 0)) i2 = (HEAP32[i23 >> 2] | 0) + (i5 << 5) + 4 | 0; else i2 = (HEAP32[i24 >> 2] | 0) + ((i5 - i2 | 0) * 40 | 0) + 24 | 0;
        i2 = i7 | HEAP32[i2 >> 2] | 67108864;
        i34 = i25;
        HEAP32[i34 >> 2] = 0;
        HEAP32[i34 + 4 >> 2] = 0;
        i34 = i26;
        HEAP32[i34 >> 2] = 0;
        HEAP32[i34 + 4 >> 2] = 0;
        i34 = HEAP32[i21 >> 2] | 0;
        i33 = HEAP32[i34 + (i10 * 28 | 0) + 12 >> 2] | 0;
        HEAP32[i29 >> 2] = HEAP32[i34 + (i10 * 28 | 0) + 8 >> 2];
        HEAP32[i14 >> 2] = i33;
        HEAP32[i16 >> 2] = 0;
        HEAP32[i18 >> 2] = 0;
        i33 = HEAP32[i34 + (i10 * 28 | 0) + 20 >> 2] | 0;
        HEAP32[i30 >> 2] = HEAP32[i34 + (i10 * 28 | 0) + 16 >> 2];
        HEAP32[i13 >> 2] = i33;
        HEAP32[i15 >> 2] = 0;
        HEAP32[i17 >> 2] = 0;
        __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_(i20, i28, i11, i2, i4 << 16 | i6, i29, i30);
        i5 = HEAP32[(HEAP32[i23 >> 2] | 0) + (i5 << 5) + 12 >> 2] | 0;
        if ((i5 | 0) == -1) break; else i3 = i3 + 1 | 0;
       }
       i3 = HEAP32[i21 >> 2] | 0;
      }
     }
    }
    i2 = HEAP32[i3 + (i10 * 28 | 0) + 24 >> 2] | 0;
   } while ((i2 | 0) != 0);
   i2 = HEAP32[i19 >> 2] | 0;
   i3 = HEAP32[i28 >> 2] | 0;
  }
  HEAP32[i2 + (i12 << 2) >> 2] = i3;
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) < (i1 | 0));
 STACKTOP = i32;
 return;
}

function __ZN20SoundChannelInstance19FMODChannelCallbackEP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS3_(i7, i5, i1, i2) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i3 = i9;
 i8 = i9 + 36 | 0;
 i1 = i9 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = __ZN4FMOD7Channel11getUserDataEPPv(i7, i1) | 0;
 if (i2 | 0) {
  i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i2) | 0;
  HEAP32[i3 >> 2] = gb + 853918;
  HEAP32[i3 + 4 >> 2] = 18;
  HEAP32[i3 + 8 >> 2] = gb + 859244;
  HEAP32[i3 + 12 >> 2] = i4;
  __Z6FormatPKcz(i8, gb + 883334 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[gb + 1098888 >> 0] | 0)) {
  i1 = gb + 861196 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 861196 + 87 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459936 >> 2] = i1;
  i2 = gb + 1098888 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459936 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) {
  STACKTOP = i9;
  return 0;
 }
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return 0;
 }
 switch (i5 | 0) {
 case 0:
  {
   i1 = HEAP32[i3 + 240 >> 2] | 0;
   if (i1 | 0) __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i1, 0);
   i1 = __ZN4FMOD7Channel11setUserDataEPv(i7, 0) | 0;
   if (i1 | 0) {
    i7 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
    HEAP32[i6 >> 2] = gb + 853918;
    HEAP32[i6 + 4 >> 2] = 35;
    HEAP32[i6 + 8 >> 2] = gb + 859289;
    HEAP32[i6 + 12 >> 2] = i7;
    __Z6FormatPKcz(i8, gb + 883334 | 0, i6);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   }
   i2 = HEAP32[i3 + 168 >> 2] | 0;
   if (i2 | 0) {
    i1 = HEAP32[i2 + 16 >> 2] | 0;
    if (i1 | 0) if (HEAP32[i1 + 48 >> 2] & 128 | 0) {
     i7 = i1 + 88 | 0;
     if (!((HEAP32[i7 >> 2] | 0) == 0 & (HEAP32[i7 + 4 >> 2] | 0) == 0)) {
      i1 = HEAP32[i1 + 52 >> 2] | 0;
      if (i1 | 0) {
       HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
       HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
       i7 = i2 + 4 | 0;
       HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
       HEAP32[i8 >> 2] = i2;
       __ZN10SampleClip14ReleaseIfEqualE11SoundHandle(i1, i8);
       __ZN11SoundHandleD2Ev(i8);
      }
     }
    }
   }
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63328 | 0);
   STACKTOP = i9;
   return 0;
  }
 case 1:
  {
   i1 = HEAP32[i3 + 240 >> 2] | 0;
   if (!i1) {
    STACKTOP = i9;
    return 0;
   }
   __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i1, 0);
   STACKTOP = i9;
   return 0;
  }
 default:
  {
   STACKTOP = i9;
   return 0;
  }
 }
 return 0;
}

function __ZN12CullingGroup13NotifyVisibleEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 248 | 0;
 i11 = i18 + 8 | 0;
 i15 = i18;
 i16 = i18 + 256 | 0;
 i5 = HEAP32[i10 + 24 >> 2] | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i16 >> 2] = 0;
 i12 = i16 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i16 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i11);
 i7 = i17;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i14;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 if (!i5) {
  i1 = i16;
  i2 = 0;
 } else {
  HEAP32[i13 >> 2] = i5;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i5 << 3, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
  i3 = i10 + 28 | 0;
  i4 = i10 + 48 | 0;
  i1 = 0;
  do {
   i9 = HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0;
   if (i9 << 24 >> 24 < 0 ? i9 << 24 >> 24 != (HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] | 0) : 0) {
    i6 = HEAP32[i12 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = HEAP32[i13 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i7 >>> 0 > i9 >>> 0) {
     i2 = i8 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i13 >> 2] = i2;
      HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 3, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
      HEAP32[i13 >> 2] = i2;
      HEAP32[i16 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i7;
    i9 = HEAP32[i16 >> 2] | 0;
    i7 = HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] | 0;
    i8 = HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0;
    HEAP32[i9 + (i6 << 3) >> 2] = i1;
    HEAP8[i9 + (i6 << 3) + 4 >> 0] = i7;
    HEAP8[i9 + (i6 << 3) + 5 >> 0] = i8;
    HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  i1 = i16;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 i7 = (__Z23GetCoreScriptingClassesv() | 0) + 136 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i15;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i11, i17);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i11, __Z29scripting_gchandle_get_targetj(HEAP32[i10 >> 2] | 0) | 0);
 __ZN18ScriptingArguments9AddIntPtrEPv(i11, i2);
 __ZN18ScriptingArguments6AddIntEi(i11, i12);
 HEAP32[i17 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i11, i17, 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i14);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function _cff_index_access_element(i12, i2, i13, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 if (!i12) {
  i14 = 6;
  STACKTOP = i15;
  return i14 | 0;
 }
 i9 = i12 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 if (i5 >>> 0 <= i2 >>> 0) {
  i14 = 6;
  STACKTOP = i15;
  return i14 | 0;
 }
 i14 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 L7 : do if (!i4) {
  i7 = i12 + 12 | 0;
  i1 = Math_imul(HEAPU8[i7 >> 0] | 0, i2) | 0;
  i1 = _UNITY_FT_Stream_Seek(i14, (HEAP32[i12 + 4 >> 2] | 0) + 3 + i1 | 0) | 0;
  if (i1 | 0) {
   i14 = i1;
   STACKTOP = i15;
   return i14 | 0;
  }
  i1 = _UNITY_FT_Stream_Read(HEAP32[i12 >> 2] | 0, i8, HEAPU8[i7 >> 0] | 0) | 0;
  if (i1 | 0) {
   i14 = i1;
   STACKTOP = i15;
   return i14 | 0;
  }
  i3 = HEAP8[i7 >> 0] | 0;
  if (i3 << 24 >> 24) {
   i5 = i3 & 255;
   i1 = 0;
   i4 = 0;
   do {
    i1 = HEAPU8[i8 + i4 >> 0] | 0 | i1 << 8;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
   if (i1 | 0) while (1) {
    i6 = i2 + 1 | 0;
    i2 = _UNITY_FT_Stream_Read(HEAP32[i12 >> 2] | 0, i8, i3 & 255) | 0;
    if (!i2) {
     i3 = HEAP8[i7 >> 0] | 0;
     if (!(i3 << 24 >> 24)) i10 = 16; else {
      i5 = i3 & 255;
      i3 = 0;
      i4 = 0;
      do {
       i3 = HEAPU8[i8 + i4 >> 0] | 0 | i3 << 8;
       i4 = i4 + 1 | 0;
      } while ((i4 | 0) != (i5 | 0));
      if (i3 | 0) {
       i10 = 26;
       break L7;
      }
     }
    } else i10 = 16;
    if ((i10 | 0) == 16) i10 = 0;
    if (i6 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
     i10 = 25;
     break L7;
    }
    i2 = i6;
    i3 = HEAP8[i7 >> 0] | 0;
   }
  }
  i1 = 0;
  i2 = 0;
  i3 = 0;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i10 = 28;
 } else {
  i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 0;
   i3 = 0;
   i4 = HEAP32[i14 + 4 >> 2] | 0;
   i10 = 28;
   break;
  }
  while (1) {
   i2 = i2 + 1 | 0;
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) {
    i10 = 26;
    break L7;
   }
   if (i2 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    i10 = 25;
    break;
   }
  }
 } while (0);
 if ((i10 | 0) == 25) {
  i3 = 0;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i10 = 28;
 } else if ((i10 | 0) == 26) {
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  if (i3 >>> 0 > (i4 + 1 | 0) >>> 0) {
   i2 = 0;
   i3 = HEAP32[i12 + 16 >> 2] | 0;
   i10 = 29;
  } else {
   i2 = 0;
   i10 = 28;
  }
 }
 if ((i10 | 0) == 28) {
  i5 = HEAP32[i12 + 16 >> 2] | 0;
  if (i5 >>> 0 > (i4 + 1 - i3 | 0) >>> 0) {
   i3 = i5;
   i10 = 29;
  } else {
   i5 = i1;
   i1 = i3;
  }
 }
 if ((i10 | 0) == 29) {
  i5 = i1;
  i1 = i4 + 1 - i3 | 0;
 }
 if (!((i5 | 0) != 0 & i1 >>> 0 > i5 >>> 0)) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i14 = i2;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i1 - i5 | 0;
 HEAP32[i11 >> 2] = i3;
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i13 >> 2] = i1 + i5 + -1;
  i14 = i2;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = _UNITY_FT_Stream_Seek(i14, i5 + -1 + (HEAP32[i12 + 16 >> 2] | 0) | 0) | 0;
 if (i1 | 0) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i14 = _UNITY_FT_Stream_ExtractFrame(i14, i3, i13) | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx2Gu30checkOverlapCapsule_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i10, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 28 | 0;
 i8 = i12;
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 4 | 0;
 L1 : do if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(1.0)) {
  f15 = Math_fround(HEAPF32[i11 >> 2]);
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i11 + 12 >> 2]));
  f17 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i11 + 16 >> 2]));
  f20 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f15 = Math_fround(f15 * Math_fround(.5));
  f17 = Math_fround(f17 * Math_fround(.5));
  f20 = Math_fround(Math_fround(f20 + Math_fround(HEAPF32[i11 + 20 >> 2])) * Math_fround(.5));
  f15 = Math_fround(f15 - Math_fround(HEAPF32[i10 + 16 >> 2]));
  f17 = Math_fround(f17 - Math_fround(HEAPF32[i10 + 20 >> 2]));
  f15 = Math_fround(f15 * Math_fround(2.0));
  f17 = Math_fround(f17 * Math_fround(2.0));
  f20 = Math_fround(Math_fround(f20 - Math_fround(HEAPF32[i10 + 24 >> 2])) * Math_fround(2.0));
  f18 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
  f16 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(f15 * f16);
  f14 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f17 * f14));
  f13 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f20 * f13));
  f3 = Math_fround(Math_fround(f16 * f5) + Math_fround(Math_fround(f15 * f19) - Math_fround(f18 * Math_fround(Math_fround(f20 * f14) - Math_fround(f17 * f13)))));
  f4 = Math_fround(Math_fround(f14 * f5) + Math_fround(Math_fround(f17 * f19) - Math_fround(f18 * Math_fround(Math_fround(f15 * f13) - Math_fround(f20 * f16)))));
  f5 = Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)))) + Math_fround(f13 * f5));
  i1 = HEAP8[i6 + 55 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i11 = 1;
   STACKTOP = i12;
   return i11 | 0;
  }
  i1 = i1 & 255;
  i2 = HEAP32[i6 + 56 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   f20 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
   f20 = Math_fround(f20 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 4 >> 2])));
   f20 = Math_fround(f20 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2])));
   if (Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f20) > Math_fround(0.0)) break L1;
   if (!i1) {
    i1 = 1;
    break;
   } else i2 = i2 + 20 | 0;
  }
  STACKTOP = i12;
  return i1 | 0;
 } while (0);
 HEAP32[i9 >> 2] = 2;
 i2 = i9 + 8 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 24 >> 2];
 __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf(i8, i11, i2);
 i11 = __ZN5physx2Gu22intersectCapsuleConvexERKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i9, i8, i6, i7, i10, 0) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEe(i11, d5) {
 i11 = i11 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, +d5) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEd(i11, d5) {
 i11 = i11 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474612 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       i1 = i1 << 24 >> 24;
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 & 255 | 0, +d5) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN11AudioSource17UpdateSpatializerE12SoundChannelf(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 if (!(HEAP32[i3 + 540 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 i1 = i3 + 544 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i19);
 i18 = HEAP32[i1 >> 2] | 0;
 HEAP32[i18 + 64 >> 2] = HEAP32[i19 >> 2];
 i3 = i19 + 4 | 0;
 HEAP32[i18 + 68 >> 2] = HEAP32[i3 >> 2];
 i4 = i19 + 8 | 0;
 HEAP32[i18 + 72 >> 2] = HEAP32[i4 >> 2];
 i5 = i19 + 12 | 0;
 HEAP32[i18 + 76 >> 2] = HEAP32[i5 >> 2];
 i6 = i19 + 16 | 0;
 HEAP32[i18 + 80 >> 2] = HEAP32[i6 >> 2];
 i7 = i19 + 20 | 0;
 HEAP32[i18 + 84 >> 2] = HEAP32[i7 >> 2];
 i8 = i19 + 24 | 0;
 HEAP32[i18 + 88 >> 2] = HEAP32[i8 >> 2];
 i9 = i19 + 28 | 0;
 HEAP32[i18 + 92 >> 2] = HEAP32[i9 >> 2];
 i10 = i19 + 32 | 0;
 HEAP32[i18 + 96 >> 2] = HEAP32[i10 >> 2];
 i11 = i19 + 36 | 0;
 HEAP32[i18 + 100 >> 2] = HEAP32[i11 >> 2];
 i12 = i19 + 40 | 0;
 HEAP32[i18 + 104 >> 2] = HEAP32[i12 >> 2];
 i13 = i19 + 44 | 0;
 HEAP32[i18 + 108 >> 2] = HEAP32[i13 >> 2];
 i14 = i19 + 48 | 0;
 HEAP32[i18 + 112 >> 2] = HEAP32[i14 >> 2];
 i15 = i19 + 52 | 0;
 HEAP32[i18 + 116 >> 2] = HEAP32[i15 >> 2];
 i16 = i19 + 56 | 0;
 HEAP32[i18 + 120 >> 2] = HEAP32[i16 >> 2];
 i17 = i19 + 60 | 0;
 HEAP32[i18 + 124 >> 2] = HEAP32[i17 >> 2];
 i18 = __ZNK12AudioManager16GetAudioListenerEv(__Z15GetAudioManagerv() | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i18) {
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 56 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i1 + 60 >> 2] = HEAP32[i17 >> 2];
 } else {
  HEAP32[i1 >> 2] = HEAP32[i18 + 68 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i18 + 72 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i18 + 76 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i18 + 80 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i18 + 84 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i18 + 88 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i18 + 92 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i18 + 96 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i18 + 100 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i18 + 104 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i18 + 108 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i18 + 112 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i18 + 116 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i18 + 120 >> 2];
  HEAP32[i1 + 56 >> 2] = HEAP32[i18 + 124 >> 2];
  HEAP32[i1 + 60 >> 2] = HEAP32[i18 + 128 >> 2];
 }
 STACKTOP = i20;
 return;
}

function __ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib(i12, i13, i2, i1, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f16 = Math_fround(f11 * f7);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f16 = Math_fround(f16 - Math_fround(f9 * f15));
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(f10 + f16);
 f15 = Math_fround(Math_fround(f7 * f9) + Math_fround(f11 * f15));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 + f7);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = HEAP32[i12 + 148 >> 2] | 0;
 if ((i8 | 0) > 1) {
  i6 = 1;
  i4 = i1;
  i3 = i1;
  i2 = i5;
  i1 = i5;
  do {
   f15 = Math_fround(HEAPF32[i12 + 20 + (i6 << 3) >> 2]);
   f17 = Math_fround(f11 * f15);
   f16 = Math_fround(HEAPF32[i12 + 20 + (i6 << 3) + 4 >> 2]);
   f17 = Math_fround(f10 + Math_fround(f17 - Math_fround(f9 * f16)));
   f16 = Math_fround(Math_fround(Math_fround(f15 * f9) + Math_fround(f11 * f16)) + f7);
   f15 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f18 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i3 = (HEAPF32[tempDoublePtr >> 2] = f15 < f17 ? f15 : f17, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = (HEAPF32[tempDoublePtr >> 2] = f18 < f16 ? f18 : f16, HEAP32[tempDoublePtr >> 2] | 0);
   f18 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f15 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i4 = (HEAPF32[tempDoublePtr >> 2] = f18 > f17 ? f18 : f17, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f15 > f16 ? f15 : f16, HEAP32[tempDoublePtr >> 2] | 0);
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i8 | 0));
 } else {
  i4 = i1;
  i3 = i1;
  i2 = i5;
  i1 = i5;
 }
 if (!i14) {
  i8 = i4;
  i14 = i3;
  i12 = i2;
  i6 = i1;
  HEAP32[i13 >> 2] = i14;
  i14 = i13 + 4 | 0;
  HEAP32[i14 >> 2] = i6;
  i14 = i13 + 8 | 0;
  HEAP32[i14 >> 2] = i8;
  i14 = i13 + 12 | 0;
  HEAP32[i14 >> 2] = i12;
  return;
 }
 f18 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f18);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 f17 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f18);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
 f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f18);
 i12 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i13 >> 2] = i14;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = i6;
 i14 = i13 + 8 | 0;
 HEAP32[i14 >> 2] = i8;
 i14 = i13 + 12 | 0;
 HEAP32[i14 >> 2] = i12;
 return;
}

function __ZN20BaseBehaviourManager12CommonUpdateI16BehaviourManagerEEvv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = i1 + 8 | 0;
 if ((i2 | 0) != (i10 | 0)) {
  while (1) {
   i4 = HEAP32[i2 + 20 >> 2] | 0;
   i5 = HEAP32[i2 + 24 >> 2] | 0;
   i1 = i5 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i5 | 0)) {
    i9 = HEAP32[i4 >> 2] | 0;
    HEAP32[i9 + 4 >> 2] = i3;
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 >> 2] = i9;
    HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
    HEAP32[i1 >> 2] = i5;
    HEAP32[i5 >> 2] = i5;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i2 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 i6 = i11 + 4 | 0;
 i7 = i11 + 8 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11;
 do {
  i4 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i11 >> 2] = i11;
  HEAP32[i6 >> 2] = i11;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i9;
  HEAP32[i11 >> 2] = i3;
  i5 = i4 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i1;
  if ((HEAP32[i4 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i4 >> 2] = i4;
   i3 = HEAP32[i11 >> 2] | 0;
  }
  if ((i3 | 0) == (i4 | 0)) HEAP32[i11 >> 2] = i11;
  if ((HEAP32[i5 >> 2] | 0) == (i11 | 0)) {
   HEAP32[i5 >> 2] = i4;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 | 0)) HEAP32[i6 >> 2] = i11;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
  HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
  HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] = i11;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 >> 2] = i11;
  L34 : do if ((i1 | 0) == (i11 | 0)) i12 = 27; else {
   i3 = i11;
   while (1) {
    HEAP32[i8 >> 2] = i1;
    if (i3 | 0) {
     i5 = i1 + 4 | 0;
     HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
     HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
    }
    i3 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) {
     if (!i1) break L34;
    } else {
     i5 = i1 + 4 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     HEAP32[i1 >> 2] = i4;
     HEAP32[i5 >> 2] = i3;
     HEAP32[i4 + 4 >> 2] = i1;
     HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
    }
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) == (i11 | 0)) {
     i12 = 27;
     break L34;
    }
    i1 = i3;
    i3 = HEAP32[i3 >> 2] | 0;
   }
  } while (0);
  if ((i12 | 0) == 27) {
   i12 = 0;
   HEAP32[i8 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
    i2 = i1;
    break;
   } else i2 = i1;
  } else {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) break; else i2 = i1;
   }
  }
 } while ((i2 | 0) != (i10 | 0));
 STACKTOP = i13;
 return;
}

function __ZN14AnimationEvent8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i13 = i10 + 16 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i11 = i10 + 24 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i12, 4);
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i7 = i12 + 4 | 0;
 i1 = i7 + 11 | 0;
 i4 = HEAP8[i1 >> 0] | 0;
 i8 = i12 + 8 | 0;
 i5 = i4 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i4 & 255;
 HEAP32[i9 >> 2] = i5;
 i6 = i2 + 4 | 0;
 if (i6 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i12 + 20 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i12 + 24 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i3;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i13 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12 + 36 | 0, i10);
 i1 = i12 + 40 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i4 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i12 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i4 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i12 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i2;
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  STACKTOP = i14;
  return;
 }
}

function __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i12, i15, i1, i8, i16) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17;
 i10 = i12 + 4 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) if (HEAP32[i12 >> 2] | 0) __ZN4core20StringStorageDefaultIcE10reallocateEj(i12, HEAP32[i12 + 20 >> 2] | 0);
 i13 = i12 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 - i15 | 0;
 i14 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
 i1 = HEAP32[i12 >> 2] | 0;
 i11 = i12 + 4 | 0;
 i4 = (i1 | 0) == 0 ? i11 : i1;
 if (i4 >>> 0 > i8 >>> 0 | (i4 + i2 | 0) >>> 0 < i8 >>> 0) {
  i5 = i3 - i14 | 0;
  if (i14 >>> 0 > i16 >>> 0) {
   i2 = i4 + i15 | 0;
   _memmove(i2 + i16 | 0, i2 + i14 | 0, i5 | 0) | 0;
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i4 = i2 + (i16 - i14) | 0;
  if (!i1) i2 = 15; else {
   i10 = HEAP32[i10 >> 2] | 0;
   i2 = (i10 | 0) == 0 ? i2 : i10;
  }
  i3 = i2 << 1;
  if (i2 >>> 0 < i4 >>> 0) {
   __ZN4core20StringStorageDefaultIcE10reallocateEj(i12, i3 >>> 0 > i4 >>> 0 ? i3 : i4);
   i1 = HEAP32[i12 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i4;
  HEAP8[((i1 | 0) == 0 ? i11 : i1) + i4 >> 0] = 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? i11 : i1;
  if (i14 >>> 0 < i16 >>> 0) {
   i13 = i1 + i15 | 0;
   _memmove(i13 + i16 | 0, i13 + i14 | 0, i5 | 0) | 0;
  }
  if (!i8) {
   STACKTOP = i17;
   return;
  }
  _memcpy(i1 + i15 | 0, i8 | 0, i16 | 0) | 0;
  STACKTOP = i17;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 i4 = gb + 63160 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 do if (!i16) i6 = 0; else if (i16 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i16 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i6 = i1;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 1, gb + 64016 | 0, 0, gb + 1047486 | 0, 160) | 0;
  i4 = gb + 64016 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  i5 = i7;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i4;
  break;
 } while (0);
 _memcpy(i6 | 0, i8 | 0, i16 | 0) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i5 = i1 - i15 - i14 | 0;
 if (i14 >>> 0 > i16 >>> 0) {
  i2 = HEAP32[i12 >> 2] | 0;
  i2 = ((i2 | 0) == 0 ? i11 : i2) + i15 | 0;
  _memmove(i2 + i16 | 0, i2 + i14 | 0, i5 | 0) | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 } else i2 = i1;
 i4 = i2 + (i16 - i14) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i2 = 15; else {
  i10 = HEAP32[i10 >> 2] | 0;
  i2 = (i10 | 0) == 0 ? i2 : i10;
 }
 i3 = i2 << 1;
 if (i2 >>> 0 < i4 >>> 0) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i12, i3 >>> 0 > i4 >>> 0 ? i3 : i4);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i13 >> 2] = i4;
 HEAP8[((i1 | 0) == 0 ? i11 : i1) + i4 >> 0] = 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i11 : i1;
 if (i14 >>> 0 < i16 >>> 0) {
  i13 = i1 + i15 | 0;
  _memmove(i13 + i16 | 0, i13 + i14 | 0, i5 | 0) | 0;
 }
 if (i6 | 0) _memcpy(i1 + i15 | 0, i6 | 0, i16 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i7);
 STACKTOP = i17;
 return;
}

function __ZN12_GLOBAL__N_115StringTableImpl11strToHandleEPKc(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i11 + 4 | 0;
 i6 = i5 | 0 ? i5 : gb + 1576256 | 0;
 if ((HEAP8[i6 >> 0] | 0) <= 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i4 = HEAP32[i9 + 148 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i5;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i9 + 140 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i9 + 132 >> 2] | 0;
   i3 = i9 + 136 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L4;
   }
   if (i2 | 0) {
    i10 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    STACKTOP = i11;
    return i10 | 0;
   }
  }
 } while (0);
 i4 = HEAP32[i9 + 40 >> 2] | 0;
 L18 : do if (!i4) i7 = 19; else {
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i5;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i9 + 32 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i7 = 19; else {
   i4 = HEAP32[i9 + 24 >> 2] | 0;
   i3 = i9 + 28 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i7 = 19;
     break L18;
    }
   }
   if (!i2) i7 = 19; else i2 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
  }
 } while (0);
 if ((i7 | 0) == 19) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = _strlen(i6) | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 + 1 | 0, gb + 774868 | 0, gb + 774188 | 0, 178) | 0;
  _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
  HEAP8[i2 + i1 >> 0] = 0;
  HEAP32[i8 >> 2] = i2;
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i9 + 8 | 0, i8, i10) | 0;
  if (!(HEAP8[i10 >> 0] | 0)) {
   i7 = i2;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i1 + 4 >> 2] = i7;
  }
 }
 i1 = i9 + 60 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 1;
 HEAP32[i8 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i9 + 64 | 0, i8, i10) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i2;
 }
 HEAP32[i8 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i9 + 116 | 0, i8, i10) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i10 = i3;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN20NavMeshBuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845836 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845848 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845860 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845872 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845883 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845894 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845910 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845932 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845946 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843667 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 845961 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN14ParticleSystem27UpdateModulesNonIncrementalERK32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesR31ParticleSystemParticlesTempData(i8, i10, i9) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = HEAP32[i10 + 12 >> 2] | 0;
 i7 = (i6 | 0) == 0;
 if (!i7) {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 + 480 >> 2] | 0;
  i1 = 0;
  do {
   i5 = i2 + (i1 << 2) | 0;
   i13 = i3 + (i1 << 2) | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = HEAP32[i13 + 8 >> 2] | 0;
   i4 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = i12;
   HEAP32[i5 + 8 >> 2] = i11;
   HEAP32[i5 + 12 >> 2] = i4;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i6 >>> 0);
  if (!i7) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   i3 = HEAP32[i10 + 420 >> 2] | 0;
   i1 = 0;
   do {
    i13 = i2 + (i1 << 2) | 0;
    i4 = i3 + (i1 << 2) | 0;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i11 = HEAP32[i4 + 8 >> 2] | 0;
    i12 = HEAP32[i4 + 12 >> 2] | 0;
    HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i13 + 4 >> 2] = i5;
    HEAP32[i13 + 8 >> 2] = i11;
    HEAP32[i13 + 12 >> 2] = i12;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
   if ((HEAP8[i10 + 871 >> 0] | 0) != 0 & (i6 | 0) != 0) {
    i2 = HEAP32[i9 + 8 >> 2] | 0;
    i3 = HEAP32[i10 + 440 >> 2] | 0;
    i4 = HEAP32[i9 + 12 >> 2] | 0;
    i5 = HEAP32[i10 + 460 >> 2] | 0;
    i1 = 0;
    do {
     i13 = i2 + (i1 << 2) | 0;
     i12 = i3 + (i1 << 2) | 0;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     i14 = HEAP32[i12 + 8 >> 2] | 0;
     i15 = HEAP32[i12 + 12 >> 2] | 0;
     HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i13 + 4 >> 2] = i11;
     HEAP32[i13 + 8 >> 2] = i14;
     HEAP32[i13 + 12 >> 2] = i15;
     i13 = i4 + (i1 << 2) | 0;
     i15 = i5 + (i1 << 2) | 0;
     i14 = HEAP32[i15 + 4 >> 2] | 0;
     i11 = HEAP32[i15 + 8 >> 2] | 0;
     i12 = HEAP32[i15 + 12 >> 2] | 0;
     HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i13 + 4 >> 2] = i14;
     HEAP32[i13 + 8 >> 2] = i11;
     HEAP32[i13 + 12 >> 2] = i12;
     i1 = i1 + 4 | 0;
    } while (i1 >>> 0 < i6 >>> 0);
   }
  }
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN11ColorModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32(i1, i10, HEAP32[i9 >> 2] | 0);
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN18ColorBySpeedModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32(i1, i10, HEAP32[i9 >> 2] | 0);
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZNK10SizeModule6UpdateERK23ParticleSystemParticlesPPf(i1, i10, i9 + 4 | 0);
 i1 = HEAP32[i8 + 24 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZNK17SizeBySpeedModule6UpdateERK23ParticleSystemParticlesPPf(i1, i10, i9 + 4 | 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + (i6 << 2) | 0;
  if (!i7) do {
   i15 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] | i15 << 16 & 16711680 | i15 & -16777216;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i8 + 32 >> 2] | 0;
 if (!(HEAP8[i2 + 4 >> 0] | 0)) return;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) return;
 __ZN8UVModule6UpdateERK23ParticleSystemParticlesPf(i2, i10, i1);
 return;
}

function __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif(i17, i18, f19) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 f19 = Math_fround(f19);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i20 = 0;
 i1 = HEAP32[i17 + 164 >> 2] | 0;
 if ((i1 | 0) < 2) return;
 i20 = i18 + 1 | 0;
 i15 = (i18 | 0) == 0;
 i20 = i15 ? i20 : (i20 | 0) == (i1 | 0) ? 1 : i20;
 i1 = i15 ? i1 + -2 | 0 : i18 + -1 | 0;
 i15 = i17 + 152 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i16 + (i18 * 52 | 0) >> 2]);
 f6 = Math_fround(f13 - Math_fround(HEAPF32[i16 + (i1 * 52 | 0) >> 2]));
 f2 = Math_fround(HEAPF32[i16 + (i18 * 52 | 0) + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i16 + (i18 * 52 | 0) + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i16 + (i18 * 52 | 0) + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i16 + (i18 * 52 | 0) + 16 >> 2]);
 f13 = Math_fround(Math_fround(HEAPF32[i16 + (i20 * 52 | 0) >> 2]) - f13);
 f10 = Math_fround(HEAPF32[i16 + (i20 * 52 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i20 * 52 | 0) + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + (i20 * 52 | 0) + 12 >> 2]);
 f10 = Math_fround(f10 - f2);
 f11 = Math_fround(f11 - f4);
 f12 = Math_fround(f12 - f5);
 f14 = Math_fround(Math_fround(HEAPF32[i16 + (i20 * 52 | 0) + 16 >> 2]) - f3);
 i20 = f6 < Math_fround(0.0);
 f9 = Math_fround(-f6);
 if ((i20 ? f9 : f6) > Math_fround(9.99999974e-06)) {
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i16 + (i1 * 52 | 0) + 16 >> 2]));
  f9 = Math_fround(f5 - Math_fround(HEAPF32[i16 + (i1 * 52 | 0) + 12 >> 2]));
  f8 = Math_fround(f4 - Math_fround(HEAPF32[i16 + (i1 * 52 | 0) + 8 >> 2]));
  f7 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i16 + (i1 * 52 | 0) + 4 >> 2])) / f6);
  f8 = Math_fround(f8 / f6);
  f9 = Math_fround(f9 / f6);
  f6 = Math_fround(f3 / f6);
 } else {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f6 = Math_fround(0.0);
 }
 i20 = f13 < Math_fround(0.0);
 f5 = Math_fround(-f13);
 if ((i20 ? f5 : f13) > Math_fround(9.99999974e-06)) {
  f5 = Math_fround(f10 / f13);
  f4 = Math_fround(f11 / f13);
  f3 = Math_fround(f12 / f13);
  f2 = Math_fround(f14 / f13);
 } else {
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f11 = Math_fround(Math_fround(f19 + Math_fround(1.0)) * Math_fround(.5));
 f19 = Math_fround(Math_fround(Math_fround(1.0) - f19) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f11 * f7) + Math_fround(f19 * f5));
 f13 = Math_fround(Math_fround(f11 * f8) + Math_fround(f19 * f4));
 f14 = Math_fround(Math_fround(f11 * f9) + Math_fround(f19 * f3));
 f19 = Math_fround(Math_fround(f11 * f6) + Math_fround(f19 * f2));
 HEAPF32[i16 + (i18 * 52 | 0) + 20 >> 2] = f12;
 HEAPF32[i16 + (i18 * 52 | 0) + 24 >> 2] = f13;
 HEAPF32[i16 + (i18 * 52 | 0) + 28 >> 2] = f14;
 HEAPF32[i16 + (i18 * 52 | 0) + 32 >> 2] = f19;
 i20 = HEAP32[i15 >> 2] | 0;
 HEAPF32[i20 + (i18 * 52 | 0) + 36 >> 2] = f12;
 HEAPF32[i20 + (i18 * 52 | 0) + 40 >> 2] = f13;
 HEAPF32[i20 + (i18 * 52 | 0) + 44 >> 2] = f14;
 HEAPF32[i20 + (i18 * 52 | 0) + 48 >> 2] = f19;
 HEAPF32[i17 + 4 >> 2] = Math_fround(inf);
 HEAP32[i17 >> 2] = 0;
 HEAPF32[i17 + 80 >> 2] = Math_fround(inf);
 HEAP32[i17 + 76 >> 2] = 0;
 return;
}

function __ZN5Umbra18CellGraphTraversal12prefetchNodeERKNS_10PortalNodeE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i2 = i7 + 348 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) return;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(HEAP32[i7 >> 2] | 0, i7 + 352 | 0, i3);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i6 = i7 + 380 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 i4 = HEAP32[i5 + 52 >> 2] & 65535;
 HEAP32[i7 + 236 >> 2] = i4;
 HEAP32[i7 + 208 >> 2] = (i1 | 0) == 0 ? 0 : i5 + i1 | 0;
 i1 = HEAP32[i7 + 384 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i3 = 0;
   i2 = 0;
   i1 = 0;
  } else {
   i3 = HEAP32[i7 + 364 >> 2] | 0;
   i2 = i1;
   i1 = i4;
  }
 }
 HEAP32[i7 + 272 >> 2] = i1;
 HEAP32[i7 + 244 >> 2] = (i2 | 0) == 0 ? 0 : i3 + i2 | 0;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 i4 = i7 + 28 | 0;
 i5 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f8 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f16 = Math_fround(f10 - f13);
 f15 = Math_fround(f9 - f12);
 f14 = Math_fround(f8 - f11);
 f19 = Math_fround(f16 * Math_fround(.0000152590219));
 f18 = Math_fround(f15 * Math_fround(.0000152590219));
 f17 = Math_fround(f14 * Math_fround(.0000152590219));
 HEAPF32[i7 + 120 >> 2] = f19;
 HEAPF32[i7 + 124 >> 2] = f19;
 HEAPF32[i7 + 128 >> 2] = f19;
 HEAPF32[i7 + 132 >> 2] = f19;
 HEAPF32[i7 + 136 >> 2] = f18;
 HEAPF32[i7 + 140 >> 2] = f18;
 HEAPF32[i7 + 144 >> 2] = f18;
 HEAPF32[i7 + 148 >> 2] = f18;
 HEAPF32[i7 + 152 >> 2] = f17;
 HEAPF32[i7 + 156 >> 2] = f17;
 HEAPF32[i7 + 160 >> 2] = f17;
 HEAPF32[i7 + 164 >> 2] = f17;
 HEAPF32[i7 + 72 >> 2] = f13;
 HEAPF32[i7 + 76 >> 2] = f13;
 HEAPF32[i7 + 80 >> 2] = f13;
 HEAPF32[i7 + 84 >> 2] = f13;
 HEAPF32[i7 + 88 >> 2] = f12;
 HEAPF32[i7 + 92 >> 2] = f12;
 HEAPF32[i7 + 96 >> 2] = f12;
 HEAPF32[i7 + 100 >> 2] = f12;
 HEAPF32[i7 + 104 >> 2] = f11;
 HEAPF32[i7 + 108 >> 2] = f11;
 HEAPF32[i7 + 112 >> 2] = f11;
 HEAPF32[i7 + 116 >> 2] = f11;
 HEAP32[i7 + 392 >> 2] = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) - f13) * Math_fround(Math_fround(65535.0) / f16));
 HEAP32[i7 + 396 >> 2] = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) - f12) * Math_fround(Math_fround(65535.0) / f15));
 HEAP32[i7 + 400 >> 2] = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) - f11) * Math_fround(Math_fround(65535.0) / f14));
 HEAPF32[i7 + 40 >> 2] = f13;
 HEAPF32[i7 + 44 >> 2] = f12;
 HEAPF32[i7 + 48 >> 2] = f11;
 HEAPF32[i7 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 56 >> 2] = f10;
 HEAPF32[i7 + 60 >> 2] = f9;
 HEAPF32[i7 + 64 >> 2] = f8;
 HEAPF32[i7 + 68 >> 2] = Math_fround(1.0);
 HEAP32[i7 + 408 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2];
 return;
}

function __ZN8VRDevice22StartRenderingToDeviceEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i5 = i9;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i8 + 280 >> 2] | 0;
 if (i1 | 0) __ZN7VRInput27ResetAllReferenceTransformsEv(i1);
 if ((HEAP16[gb + 1469372 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469372 | 0, i6);
  i1 = gb + 1469372 | 0;
 } else i1 = 0;
 i3 = i8 + 297 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i8 + 4 | 0;
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 268 >> 2] | 0;
 if (i2 | 0) HEAP8[i3 >> 0] = (mftCall_i(i2 | 0) | 0) & 1;
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 HEAP8[i8 + 302 >> 0] = 1;
 __ZN8VRDevice14SetRenderScaleEf(i8, Math_fround(1.0));
 if (!(HEAP8[i8 + 330 >> 0] | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1044756 | 0, 0, gb + 1044184 | 0, 1253, 1, 0, 0, 0); else {
  i1 = i8 + 312 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-1.0));
  i3 = f10 < Math_fround(0.0);
  f11 = Math_fround(-f10);
  if (!((i3 ? f11 : f10) <= Math_fround(9.99999997e-07))) HEAPF32[i1 >> 2] = Math_fround(1.0);
 }
 HEAP32[i8 + 320 >> 2] = 0;
 i3 = HEAP16[i8 + 296 >> 1] | 0;
 if ((i3 & 255) << 24 >> 24 == 0 | (i3 & 65535) < 256) {
  STACKTOP = i9;
  return;
 }
 if (HEAP32[(HEAP32[i4 >> 2] | 0) + 272 >> 2] | 0) if (HEAP8[i8 + 329 >> 0] | 0) {
  __Z6FormatPKcz(i6, gb + 1044819 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 1044184 | 0, 176, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i5 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 860 >> 2] | 0, i5 | 0, 4, 0);
 if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i6);
  i1 = gb + 1469192 | 0;
 } else i1 = 0;
 i5 = __Z12GetGfxDevicev() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 536 >> 2] | 0, i5 | 0) | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 544 >> 2] | 0, i4 | 0, i5 | 0);
 __Z15gpu_time_samplev();
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i1 = HEAP32[i8 + 216 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(i1 | 0, i8 + 8 | 0);
  if ((HEAP32[(__Z17GetPlayerSettingsv() | 0) + 328 >> 2] | 0) == 2) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 504 >> 0] | 0) HEAP8[i8 + 120 >> 0] = 1;
 }
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i6);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i8 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 9, 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i7 = __ZN8VRDevice17CreateEyeTexturesEv(i8) | 0;
 HEAP8[i8 + 299 >> 0] = 1;
 if (i7) {
  STACKTOP = i9;
  return;
 }
 __ZN8VRDevice21StopRenderingToDeviceEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i12, i17, i8, i1, i16, i13, i14) {
 i12 = i12 | 0;
 i17 = i17 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i2 = i1 + 1 | 0;
 i3 = HEAP32[i17 + 8 + (i2 << 2) >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 if ((i2 | 0) < 6) {
  HEAP32[i17 + 8 + (i2 << 2) >> 2] = i3 + 1;
  i1 = i1 + 2 | 0;
  if ((i1 | 0) != 6) do {
   HEAP32[i17 + 8 + (i1 << 2) >> 2] = (HEAP32[i17 + 8 + (i1 << 2) >> 2] | 0) + 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 6);
 }
 i7 = i17 + 32 | 0;
 i15 = i3 << 2 >> 2;
 i2 = i17 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 - i15 | 0;
 i1 = i1 + 1 | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i17 + 48 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i1 >>> 0) {
  i11 = i5 << 1;
  i1 = i11 >>> 0 > i1 >>> 0 ? i11 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i17 + 36 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17 + 36 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i7 >> 2] = i11;
   break;
  }
 } while (0);
 i10 = (HEAP32[i7 >> 2] | 0) + (i15 << 2) | 0;
 _memmove(i10 + 4 | 0, i10 | 0, i3 << 2 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 i10 = i17 + 72 | 0;
 i11 = i17 + 84 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = i9;
 i2 = i13 << 20 | i14 | i9;
 i3 = i17 + 52 | 0;
 i4 = i17 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1 - i15 | 0;
 i1 = i1 + 1 | 0;
 HEAP32[i4 >> 2] = i1;
 i6 = i17 + 68 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i8 >>> 0 < i1 >>> 0) {
  i14 = i7 << 1;
  i1 = i14 >>> 0 > i1 >>> 0 ? i14 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i17 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i3 >> 2] = i14;
   break;
  }
 } while (0);
 i1 = (HEAP32[i3 >> 2] | 0) + (i15 << 2) | 0;
 _memmove(i1 + 4 | 0, i1 | 0, i5 << 2 | 0) | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = i9 + i16 | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = i17 + 88 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i1 >>> 0) return;
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 4, i17 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i17 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i17 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i17;
  return;
 }
}

function _UNITY_tt_face_get_name(i13, i10, i15) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i14 = HEAP32[i13 + 100 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 i11 = i13 + 356 | 0;
 i1 = HEAP16[i13 + 340 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i14 = 0;
  HEAP32[i15 >> 2] = i14;
  i16 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i8 = i1 & 65535;
 i2 = 0;
 i3 = -1;
 i4 = -1;
 i5 = -1;
 i1 = -1;
 i7 = HEAP32[i11 >> 2] | 0;
 i9 = 0;
 while (1) {
  L6 : do if ((HEAP16[i7 + 6 >> 1] | 0) == i10 << 16 >> 16) if (HEAP16[i7 + 8 >> 1] | 0) {
   i18 = HEAP32[i7 >> 2] | 0;
   i6 = i18 >>> 16 & 65535;
   switch ((i18 & 65535) << 16 >> 16) {
   case 2:
   case 0:
    {
     i3 = i9;
     break L6;
    }
   case 1:
    {
     if (!(HEAP16[i7 + 4 >> 1] | 0)) {
      i5 = i9;
      break L6;
     }
     i1 = i6 << 16 >> 16 == 0 ? i9 : i1;
     break L6;
    }
   case 3:
    {
     if ((i4 | 0) != -1) if ((HEAP16[i7 + 4 >> 1] & 1023) != 9) break L6;
     switch (i6 << 16 >> 16) {
     case 10:
     case 1:
     case 0:
      break;
     default:
      break L6;
     }
     i2 = (HEAP16[i7 + 4 >> 1] & 1023) == 9 & 1;
     i4 = i9;
     break L6;
    }
   default:
    break L6;
   }
  } while (0);
  i9 = i9 + 1 | 0;
  if (i9 >>> 0 >= i8 >>> 0) break; else i7 = i7 + 20 | 0;
 }
 i1 = (i5 | 0) > -1 ? i5 : i1;
 L20 : do if ((i4 | 0) > -1) if ((i1 | 0) < 0 | i2 << 24 >> 24 != 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  switch (HEAP16[i1 + (i4 * 20 | 0) + 2 >> 1] | 0) {
  case 10:
  case 0:
  case 1:
   {
    i5 = fb + 1078 | 0;
    i4 = i1 + (i4 * 20 | 0) | 0;
    break L20;
   }
  default:
   i1 = 0;
  }
  HEAP32[i15 >> 2] = i1;
  i18 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i17;
  return i18 | 0;
 } else i12 = 17; else i12 = 17; while (0);
 do if ((i12 | 0) == 17) {
  if ((i1 | 0) > -1) {
   i5 = fb + 1079 | 0;
   i4 = (HEAP32[i11 >> 2] | 0) + (i1 * 20 | 0) | 0;
   break;
  }
  if ((i3 | 0) > -1) {
   i5 = fb + 1078 | 0;
   i4 = (HEAP32[i11 >> 2] | 0) + (i3 * 20 | 0) | 0;
   break;
  } else {
   i18 = 0;
   HEAP32[i15 >> 2] = i18;
   i18 = HEAP32[i16 >> 2] | 0;
   STACKTOP = i17;
   return i18 | 0;
  }
 } while (0);
 if (!i4) {
  i18 = 0;
  HEAP32[i15 >> 2] = i18;
  i18 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i17;
  return i18 | 0;
 }
 i3 = i4 + 16 | 0;
 do if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i13 + 360 >> 2] | 0;
  i2 = i4 + 8 | 0;
  HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i14, 1, 0, HEAPU16[i2 >> 1] | 0, 0, i16) | 0;
  if (!(HEAP32[i16 >> 2] | 0)) {
   i18 = _UNITY_FT_Stream_Seek(i1, HEAP32[i4 + 12 >> 2] | 0) | 0;
   HEAP32[i16 >> 2] = i18;
   if (!i18) {
    i18 = _UNITY_FT_Stream_Read(i1, HEAP32[i3 >> 2] | 0, HEAPU16[i2 >> 1] | 0) | 0;
    HEAP32[i16 >> 2] = i18;
    if (!i18) break;
   }
  }
  _UNITY_ft_mem_free(i14, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP16[i2 >> 1] = 0;
  i18 = 0;
  HEAP32[i15 >> 2] = i18;
  i18 = HEAP32[i16 >> 2] | 0;
  STACKTOP = i17;
  return i18 | 0;
 } while (0);
 i18 = mftCall_iii(i5 | 0, i4 | 0, i14 | 0) | 0;
 HEAP32[i15 >> 2] = i18;
 i18 = HEAP32[i16 >> 2] | 0;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZNK6Camera18GetRenderRectangleEv(i19, i15) {
 i19 = i19 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 8 | 0;
 i2 = i20;
 i14 = i15 + 1144 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i15 + 788 >> 2] | 0;
 i12 = i15 + 744 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = i16;
 } else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i13 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i2);
    i2 = HEAP32[i18 >> 2] | 0;
    i21 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i21 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i21 + (i2 << 3) | 0;
    i2 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i13 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i13 = 9;
   }
  }
  if ((i13 | 0) == 7) i13 = 9;
  if ((i13 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i12 >> 2] | 0) | 0;
  i2 = i1;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if (!((i16 | 0) == (i2 | 0) | ((i16 | 0) == (i17 | 0) | (i1 | 0) == 0))) {
  f10 = Math_fround(HEAP32[i1 + 80 >> 2] | 0);
  f11 = Math_fround(HEAP32[i1 + 84 >> 2] | 0);
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 8 >> 2] = f10;
  HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 12 >> 2] = f11;
  STACKTOP = i20;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i18, i15, 0);
 i2 = i15 + 864 | 0;
 HEAP32[i19 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f10 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f6 = Math_fround(f10 * Math_fround(HEAPF32[i19 >> 2]));
 i2 = i19 + 8 | 0;
 f8 = Math_fround(f10 * Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i2 >> 2] = f8;
 i1 = i19 + 4 | 0;
 f7 = Math_fround(f11 * Math_fround(HEAPF32[i1 >> 2]));
 i4 = i19 + 12 | 0;
 f9 = Math_fround(f11 * Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i4 >> 2] = f9;
 f5 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f6 = Math_fround(f6 + f5);
 HEAPF32[i19 >> 2] = f6;
 f7 = Math_fround(f7 + f3);
 HEAPF32[i1 >> 2] = f7;
 f8 = Math_fround(f8 + f6);
 f9 = Math_fround(f9 + f7);
 f10 = Math_fround(f10 + f5);
 f11 = Math_fround(f11 + f3);
 if (f6 < f5) HEAPF32[i19 >> 2] = f5; else f5 = f6;
 if (f7 < f3) HEAPF32[i1 >> 2] = f3; else f3 = f7;
 f10 = Math_fround((f8 > f10 ? f10 : f8) - f5);
 i21 = f10 < Math_fround(0.0);
 HEAPF32[i2 >> 2] = i21 ? Math_fround(0.0) : f10;
 f11 = Math_fround((f9 > f11 ? f11 : f9) - f3);
 i21 = f11 < Math_fround(0.0);
 HEAPF32[i4 >> 2] = i21 ? Math_fround(0.0) : f11;
 STACKTOP = i20;
 return;
}

function __ZN17SizeBySpeedModule5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i29;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAPF32[i2 + 800 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 804 >> 2] = Math_fround(1.0);
 HEAP8[i2 + 808 >> 0] = 0;
 i25 = i3 + 4 | 0;
 i26 = i3 + 8 | 0;
 i27 = i3 + 12 | 0;
 i28 = i3 + 16 | 0;
 i4 = i3 + 20 | 0;
 i5 = i3 + 24 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3 + 32 | 0;
 i8 = i3 + 40 | 0;
 i9 = i3 + 44 | 0;
 i10 = i3 + 48 | 0;
 i11 = i3 + 52 | 0;
 i12 = i3 + 56 | 0;
 i13 = i3 + 60 | 0;
 i14 = i3 + 64 | 0;
 i15 = i3 + 68 | 0;
 i16 = i3 + 72 | 0;
 i17 = i3 + 80 | 0;
 i18 = i3 + 88 | 0;
 i19 = i3 + 232 | 0;
 i20 = i3 + 248 | 0;
 i21 = i3 + 236 | 0;
 i22 = i3 + 144 | 0;
 i23 = i3 + 160 | 0;
 i24 = i3 + 148 | 0;
 i1 = 0;
 do {
  __ZN11MinMaxCurveC2Ev(i3);
  i30 = HEAP32[i25 >> 2] | 0;
  i31 = HEAP32[i26 >> 2] | 0;
  i32 = HEAP32[i27 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 4 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 8 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 12 >> 2] = i32;
  i32 = HEAP32[i4 >> 2] | 0;
  i31 = HEAP32[i5 >> 2] | 0;
  i30 = HEAP32[i6 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 16 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 20 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 24 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 28 >> 2] = i30;
  i30 = i7;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i32 = i2 + 8 + (i1 * 264 | 0) + 32 | 0;
  HEAP32[i32 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i32 + 4 >> 2] = i31;
  i32 = HEAP32[i9 >> 2] | 0;
  i31 = HEAP32[i10 >> 2] | 0;
  i30 = HEAP32[i11 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 40 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 44 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 48 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 52 >> 2] = i30;
  i30 = HEAP32[i13 >> 2] | 0;
  i31 = HEAP32[i14 >> 2] | 0;
  i32 = HEAP32[i15 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 56 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 60 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 64 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 68 >> 2] = i32;
  i32 = i16;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  i30 = i2 + 8 + (i1 * 264 | 0) + 72 | 0;
  HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  i30 = i2 + 8 + (i1 * 264 | 0) + 80 | 0;
  HEAP32[i30 >> 2] = HEAP32[i17 >> 2];
  HEAP16[i30 + 4 >> 1] = HEAP16[i17 + 4 >> 1] | 0;
  HEAP8[i30 + 6 >> 0] = HEAP8[i17 + 6 >> 0] | 0;
  __ZN21MinMaxAnimationCurvesaSERKS_(i2 + 8 + (i1 * 264 | 0) + 88 | 0, i18) | 0;
  if ((HEAP32[i20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i21);
   HEAP32[i19 >> 2] = 0;
  }
  if ((HEAP32[i23 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i22 >> 2] | 0, i24);
   HEAP32[i22 >> 2] = 0;
  }
  HEAP16[i2 + 8 + (i1 * 264 | 0) + 84 >> 1] = 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 STACKTOP = i29;
 return;
}

function __ZN5physx16PxsIslandManager13updateIslandsEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18 + 1 | 0;
 i11 = i18;
 i5 = i9 + 308 | 0;
 i6 = i9 + 316 | 0;
 i7 = i9 + 320 | 0;
 i8 = i9 + 312 | 0;
 i12 = i9 + 332 | 0;
 i13 = i9 + 340 | 0;
 i1 = i9 + 344 | 0;
 i2 = i9 + 336 | 0;
 i14 = i9 + 348 | 0;
 i3 = i9 + 352 | 0;
 i15 = i9 + 356 | 0;
 i4 = i9 + 360 | 0;
 i16 = i9 + 268 | 0;
 i17 = i9 + 276 | 0;
 __ZN5physx17updateIslandsMainEjPKjjS1_jS1_jS1_jS1_jS1_jRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEES8_jS8_S8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS2_13EventProfilerE(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i15 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i9 + 264 >> 2] | 0, HEAP32[i16 >> 2] | 0, HEAP32[i9 + 452 >> 2] | 0, HEAP32[i9 + 272 >> 2] | 0, HEAP32[i17 >> 2] | 0, i9 + 12 | 0, i9 + 280 | 0, i9 + 372 | 0, i9 + 420 | 0, i9 + 480 | 0, i9 + 632 | 0, HEAP32[i9 + 8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i7 = i9 + 324 | 0;
 i8 = i9 + 328 | 0;
 if ((HEAP32[i7 >> 2] | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i19 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, HEAP32[i8 >> 2] << 3, gb + 681489 | 0, 1416) | 0;
  HEAP32[i5 >> 2] = i19;
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 >> 2] = i19 + (i8 << 2);
  HEAP32[i7 >> 2] = i8;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i9 + 364 | 0;
 i1 = i9 + 368 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 <= (HEAP32[i1 >> 2] | 0) >>> 0) {
  i19 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i19 >> 2] | 0;
  i19 = i19 + 4 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i19 = i19 << 2;
  _memset(i16 | 0, 0, i19 | 0) | 0;
  i19 = HEAP32[i17 >> 2] | 0;
  i17 = HEAP32[i19 >> 2] | 0;
  i19 = i19 + 4 | 0;
  i19 = HEAP32[i19 >> 2] | 0;
  i19 = i19 << 2;
  _memset(i17 | 0, 0, i19 | 0) | 0;
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, HEAP32[i1 >> 2] << 4, gb + 681489 | 0, 1546) | 0;
 HEAP32[i12 >> 2] = i11;
 i19 = HEAP32[i1 >> 2] | 0;
 HEAP32[i13 >> 2] = i11 + (i19 << 2);
 HEAP32[i15 >> 2] = i11 + (i19 * 3 << 2);
 HEAP32[i14 >> 2] = i11 + (i19 << 1 << 2);
 HEAP32[i2 >> 2] = i19;
 i19 = HEAP32[i16 >> 2] | 0;
 i16 = HEAP32[i19 >> 2] | 0;
 i19 = i19 + 4 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i19 = i19 << 2;
 _memset(i16 | 0, 0, i19 | 0) | 0;
 i19 = HEAP32[i17 >> 2] | 0;
 i17 = HEAP32[i19 >> 2] | 0;
 i19 = i19 + 4 | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i19 = i19 << 2;
 _memset(i17 | 0, 0, i19 | 0) | 0;
 STACKTOP = i18;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN5Umbra7ImpTome19getPrivateStatisticEPKS0_NS_16PrivateStatisticE(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 switch (i14 | 0) {
 case 0:
  {
   i15 = (HEAP32[i15 + 116 >> 2] | 0) * 12 | 0;
   return i15 | 0;
  }
 case 4:
 case 3:
 case 2:
 case 1:
  {
   i5 = HEAP32[i15 + 144 >> 2] | 0;
   if ((i5 | 0) <= 0) {
    i15 = 0;
    return i15 | 0;
   }
   i4 = i15 + (HEAP32[i15 + 160 >> 2] | 0) | 0;
   switch (i14 | 0) {
   case 1:
    {
     i1 = 0;
     i3 = 0;
     do {
      i14 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
      i2 = i15 + i14 | 0;
      if (!((i14 | 0) == 0 | (i2 | 0) == 0)) i1 = (HEAP32[i2 + 68 >> 2] << 3) + i1 | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i5 | 0));
     return i1 | 0;
    }
   case 2:
    {
     i1 = 0;
     i3 = 0;
     do {
      i14 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
      i2 = i15 + i14 | 0;
      if (!((i14 | 0) == 0 | (i2 | 0) == 0)) i1 = (HEAP32[i2 + 76 >> 2] << 4) + i1 | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i5 | 0));
     return i1 | 0;
    }
   default:
    {
     i1 = 0;
     i3 = 0;
     do {
      i13 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
      i2 = i15 + i13 | 0;
      L11 : do if (!((i13 | 0) == 0 | (i2 | 0) == 0)) switch (i14 | 0) {
      case 4:
       {
        i1 = (HEAP32[i2 + 44 >> 2] & 1 ^ 1) + i1 | 0;
        break L11;
       }
      case 3:
       {
        i1 = (HEAP32[i2 + 44 >> 2] & 1) + i1 | 0;
        break L11;
       }
      default:
       break L11;
      } while (0);
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) < (i5 | 0));
     return i1 | 0;
    }
   }
  }
 case 7:
 case 6:
 case 5:
  {
   i11 = HEAP32[i15 + 144 >> 2] | 0;
   if ((i11 | 0) <= 0) {
    i15 = 0;
    return i15 | 0;
   }
   i12 = i15 + (HEAP32[i15 + 160 >> 2] | 0) | 0;
   i13 = (i14 | 0) == 7;
   i10 = 0;
   i1 = 0;
   do {
    i9 = HEAP32[i12 + (i10 << 2) >> 2] | 0;
    i6 = i15 + i9 | 0;
    if (!((i9 | 0) == 0 | (i6 | 0) == 0)) {
     i7 = HEAP32[i6 + 52 >> 2] & 65535;
     if (i7) {
      i8 = i6 + (HEAP32[i6 + 56 >> 2] | 0) | 0;
      i9 = HEAP32[i6 + 60 >> 2] | 0;
      i5 = 0;
      do {
       i3 = HEAP32[i8 + (i5 * 36 | 0) + 4 >> 2] | 0;
       if ((i3 | 0) > 0) {
        i4 = i6 + (i9 + (HEAP32[i8 + (i5 * 36 | 0) >> 2] << 4)) | 0;
        switch (i14 | 0) {
        case 5:
         {
          i2 = 0;
          do {
           i1 = ((HEAP32[i4 + (i2 << 4) >> 2] & 201326592 | 0) == 0 & 1) + i1 | 0;
           i2 = i2 + 1 | 0;
          } while ((i2 | 0) != (i3 | 0));
          break;
         }
        case 6:
         {
          i2 = 0;
          do {
           i1 = ((HEAP32[i4 + (i2 << 4) >> 2] | 0) >>> 27 & 1) + i1 | 0;
           i2 = i2 + 1 | 0;
          } while ((i2 | 0) != (i3 | 0));
          break;
         }
        default:
         {
          i2 = 0;
          do {
           if (i13) i1 = ((HEAP32[i4 + (i2 << 4) >> 2] | 0) >>> 26 & 1) + i1 | 0;
           i2 = i2 + 1 | 0;
          } while ((i2 | 0) != (i3 | 0));
         }
        }
       }
       i5 = i5 + 1 | 0;
      } while ((i5 | 0) != (i7 | 0));
     }
    }
    i10 = i10 + 1 | 0;
   } while ((i10 | 0) < (i11 | 0));
   return i1 | 0;
  }
 default:
  {
   i15 = 0;
   return i15 | 0;
  }
 }
 return 0;
}

function __ZN11AudioSource21SetCustomRolloffCurveERK17AnimationCurveTplIfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 300 | 0;
 i5 = i9 + 68 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i12 = i8 + 368 | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
  if (i4 | 0) {
   i2 = HEAP32[i9 + 56 >> 2] | 0;
   i3 = HEAP32[i8 + 356 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]))) break L1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  if ((HEAP32[i9 + 76 >> 2] | 0) == (HEAP32[i8 + 376 >> 2] | 0)) if ((HEAP32[i9 + 80 >> 2] | 0) == (HEAP32[i8 + 380 >> 2] | 0)) if ((HEAP32[i9 + 84 >> 2] | 0) == (HEAP32[i8 + 384 >> 2] | 0)) {
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i6 = i8 + 328 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i6 = i8 + 356 | 0;
 if ((i11 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i12 >> 2] = i2;
  i3 = i8 + 372 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i8 + 360 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 360 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
 }
 i12 = i8 + 376 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK17AnimationCurveTplIfE8GetRangeEv(i10, i11);
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i11, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 + 4 >> 2])));
 __ZN11AudioSource27ForceRolloffCurveEvaluationEv(i8);
 STACKTOP = i13;
 return;
}

function __Z4SortRK10Matrix4x4fS1_R23ParticleSystemParticles22ParticleSystemSortModeR31ParticleSystemParticlesTempData(i3, i4, i11, i6, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 4 | 0;
 i2 = i15;
 if ((HEAP16[gb + 1452236 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452236 | 0, i1);
  i14 = gb + 1452236 | 0;
 } else i14 = 0;
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f16 * f16))));
 f8 = Math_fround(f8 / f10);
 f9 = Math_fround(f9 / f10);
 f10 = Math_fround(f16 / f10);
 f16 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f7 = Math_fround(Math_fround(Math_fround(f8 * f16) + Math_fround(f9 * f7)) + Math_fround(f10 * Math_fround(HEAPF32[i4 + 56 >> 2])));
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i13 = i5 + 20 | 0;
 i12 = HEAP32[i13 >> 2] | 0;
 switch (i6 | 0) {
 case 1:
  {
   if (i1 | 0) {
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i11 + 20 >> 2] | 0;
    i3 = HEAP32[i11 + 40 >> 2] | 0;
    i2 = 0;
    do {
     f17 = Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]);
     f16 = Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]);
     f16 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * f17) + Math_fround(f9 * f16)) + Math_fround(f10 * Math_fround(HEAPF32[i3 + (i2 << 2) >> 2]))) - f7);
     i11 = f16 < Math_fround(-1.1920929e-07);
     f16 = i11 ? f16 : Math_fround(-1.1920929e-07);
     HEAP32[i12 + (i2 << 3) >> 2] = i2;
     HEAPF32[i12 + (i2 << 3) + 4 >> 2] = f16;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
   break;
  }
 case 3:
  {
   if (i1 | 0) {
    i3 = HEAP32[i11 + 520 >> 2] | 0;
    i2 = 0;
    do {
     i11 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
     HEAP32[i12 + (i2 << 3) >> 2] = i2;
     HEAP32[i12 + (i2 << 3) + 4 >> 2] = i11;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
   break;
  }
 case 2:
  {
   if (i1 | 0) {
    i3 = HEAP32[i11 + 520 >> 2] | 0;
    i2 = 0;
    do {
     f17 = Math_fround(Math_fround(100.0) - Math_fround(HEAPF32[i3 + (i2 << 2) >> 2]));
     i11 = f17 < Math_fround(0.0);
     f17 = i11 ? Math_fround(0.0) : f17;
     HEAP32[i12 + (i2 << 3) >> 2] = i2;
     HEAPF32[i12 + (i2 << 3) + 4 >> 2] = f17;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i1 | 0));
   }
   break;
  }
 default:
  {}
 }
 __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_(i12, i12 + (i1 << 3) | 0, i1 << 3 >> 3, fb + 808 | 0);
 if (i1 & 3 | 0) {
  i2 = i1 + -1 | 0;
  do {
   i12 = HEAP32[i13 >> 2] | 0;
   i6 = i12 + (i2 << 3) | 0;
   i11 = HEAP32[i6 + 4 >> 2] | 0;
   i12 = i12 + (i1 << 3) | 0;
   HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i1 = i1 + 1 | 0;
  } while ((i1 & 3 | 0) != 0);
 }
 if (!i14) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i15;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E14squash_deletedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i14 = i3 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i10 = i3 + 8 | 0;
 i13 = i2 + 8 | 0;
 i12 = HEAP16[i13 >> 1] | 0;
 HEAP8[i10 >> 0] = i12;
 i7 = i3 + 9 | 0;
 HEAP8[i7 >> 0] = (i12 & 65535) >>> 8;
 i12 = i3 + 12 | 0;
 i11 = i2 + 12 | 0;
 i16 = i11;
 i9 = HEAP32[i16 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 i6 = i3 + 20 | 0;
 i9 = i2 + 20 | 0;
 i16 = i9;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = i15;
 i8 = i3 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i8 + 20 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j(i3, i2, 0);
 i15 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i15;
 i1 = HEAP8[i13 >> 0] | 0;
 i14 = HEAP16[i10 >> 1] | 0;
 HEAP8[i13 >> 0] = i14;
 HEAP8[i10 >> 0] = i1;
 i10 = i2 + 9 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 HEAP8[i10 >> 0] = (i14 & 65535) >>> 8;
 HEAP8[i7 >> 0] = i1;
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i10 = i7 >>> 8;
 i14 = i12;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i12 >> 2] = i1;
 HEAP8[i3 + 16 >> 0] = i7;
 i7 = i3 + 17 | 0;
 i1 = i10 & 65535;
 HEAP8[i7 >> 0] = i1;
 HEAP8[i7 + 1 >> 0] = i1 >> 8;
 HEAP8[i7 + 2 >> 0] = i10 >>> 16;
 i7 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[i2 + 24 >> 2] | 0;
 i1 = i10 >>> 8;
 i12 = i6;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i6 >> 2] = i7;
 HEAP8[i3 + 24 >> 0] = i10;
 i10 = i3 + 25 | 0;
 i6 = i1 & 65535;
 HEAP8[i10 >> 0] = i6;
 HEAP8[i10 + 1 >> 0] = i6 >> 8;
 HEAP8[i10 + 2 >> 0] = i1 >>> 16;
 i10 = i2 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i8 = i2 + 32 | 0;
 i10 = i3 + 32 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i10 >> 2] = i6;
 i10 = i2 + 36 | 0;
 i8 = i3 + 36 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i9;
 f5 = Math_fround(i7 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f5 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f5 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 f5 = Math_fround(i6 >>> 0);
 HEAP32[i3 + 44 >> 2] = ~~Math_fround(f5 * Math_fround(.5)) >>> 0;
 HEAP32[i3 + 40 >> 2] = ~~Math_fround(f5 * Math_fround(.200000003)) >>> 0;
 HEAP8[i3 + 48 >> 0] = 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE6assignINS_11__wrap_iterIPS5_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS5_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i7 = i4 - i3 >> 5;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i2 = i3;
 i3 = i5;
 i10 = i4;
 if (i7 >>> 0 <= i1 - i5 >> 5 >>> 0) {
  i6 = i9 + 4 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i5 >> 5;
  i5 = i7 >>> 0 > i1 >>> 0;
  i1 = i5 ? i2 + (i1 << 5) | 0 : i4;
  if ((i2 | 0) == (i1 | 0)) i4 = i3; else {
   do {
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i3, i2);
    i2 = i2 + 32 | 0;
    i3 = i3 + 32 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i4 = i3;
  }
  if (i5) {
   if ((i1 | 0) == (i10 | 0)) return;
   i2 = HEAP32[i6 >> 2] | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    i7 = i1 + 24 | 0;
    i8 = HEAP32[i7 + 4 >> 2] | 0;
    i9 = i2 + 24 | 0;
    HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i9 + 4 >> 2] = i8;
    HEAP8[i2 + 4 >> 0] = 0;
    __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i1);
    i1 = i1 + 32 | 0;
    i2 = (HEAP32[i6 >> 2] | 0) + 32 | 0;
    HEAP32[i6 >> 2] = i2;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) return;
  do {
   i2 = i1 + -32 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) i1 = i2; else if (!(HEAP32[i1 + -28 >> 2] | 0)) i1 = i2; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + -8 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   }
  } while ((i1 | 0) != (i4 | 0));
  return;
 }
 if (i5) {
  i6 = i9 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   i4 = i1;
   while (1) {
    i1 = i4 + -32 | 0;
    HEAP32[i6 >> 2] = i1;
    i5 = HEAP32[i1 >> 2] | 0;
    if (i5) if (HEAP32[i4 + -28 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i4 + -8 | 0);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i4 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i7 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else i3 = 0;
 i6 = i1 - i3 | 0;
 i3 = i6 >> 4;
 i3 = i6 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 134217727;
 if (i3 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i1 = __Znwj(i3 << 5) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 << 5);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i7 = i2 + 24 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1 + 24 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP8[i1 + 4 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i1, i2);
  i2 = i2 + 32 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if (i5 >>> 0 >= i2 >>> 0) {
   if (i2 >>> 0 >= i5 >>> 0) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SG_EEiEESJ_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZNK6Camera26CalculateAntiAliasingForRTEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((__ZNK6Camera22CalculateRenderingPathEv(i1) | 0 | 1 | 0) == 3) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i6 = i1 + 744 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 9; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 22; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 22; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 24;
   }
  }
  if ((i7 | 0) == 22) i7 = 24;
  if ((i7 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i9 = HEAP32[i1 + 88 >> 2] | 0;
  STACKTOP = i8;
  return i9 | 0;
 } while (0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0)) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = __Z18GetQualitySettingsv() | 0;
 if ((HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) <= 1) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 158 >> 0] | 0) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = __Z18GetQualitySettingsv() | 0;
 i9 = HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEf(i11, f5) {
 i11 = i11 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, +(+f5)) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_(i1, i11, i14, i15, i13) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 16 | 0;
 i3 = i16;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i11 >> 2]);
 i9 = i11 + 4 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i11 + 8 | 0;
 f4 = Math_fround(-f4);
 f6 = Math_fround(-Math_fround(HEAPF32[i10 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(-f17);
 HEAPF32[i3 + 4 >> 2] = f4;
 HEAPF32[i3 + 8 >> 2] = f6;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu18ConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVE(i12, i8, i3, HEAP32[i1 + 12 >> 2] | 0);
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
   f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f17 = Math_fround(f6 + Math_fround(f17 * Math_fround(HEAPF32[i9 >> 2])));
   f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f6 = Math_fround(f17 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f20 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f18 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i11 >> 2]);
    f17 = Math_fround(HEAPF32[i9 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * f17)) + Math_fround(f4 * Math_fround(HEAPF32[i10 >> 2])));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i11) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 i9 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i10 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i11 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i15 >> 2] = i9;
 HEAP32[i15 + 4 >> 2] = i10;
 HEAP32[i15 + 8 >> 2] = i11;
 HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
 f18 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f18 = Math_fround(f18 - (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f19 = Math_fround(f19 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f20 = Math_fround(f20 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i13 >> 2] = f18;
 HEAPF32[i13 + 4 >> 2] = f19;
 HEAPF32[i13 + 8 >> 2] = f20;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i16;
 return;
}

function __ZN8UVModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620385 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620399 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620410 | 0, i6, i1 + 536 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620417 | 0, i6, i1 + 540 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620424 | 0, i6, i1 + 544 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620438 | 0, i6, i1 + 548 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048600 | 0, i5, i1 + 552 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620447 | 0, i6, i1 + 560 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620461 | 0, i5, i1 + 564 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620467 | 0, i5, i1 + 568 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620473 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 556 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEt(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 & 65535 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__211__libcpp_db4swapEPvS1_(i3, i4, i10) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 24 | 0;
 i9 = i14 + 16 | 0;
 i8 = i14 + 8 | 0;
 i2 = i14;
 i5 = i14 + 28 | 0;
 i6 = i14 + 32 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 HEAP32[i5 >> 2] = i4;
 i12 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6, i5, 4) | 0;
 i7 = i3 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 + (((i12 >>> 0) % ((HEAP32[i7 >> 2] | 0) - i1 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
 do if (!i1) {
  i13 = HEAP32[gb + 191628 >> 2] | 0;
  HEAP32[i2 >> 2] = gb + 1076610;
  _fprintf(i13, gb + 1076431 | 0, i2) | 0;
  __THREW__ = 0;
  invoke_v(fb + 457 | 0);
  __THREW__ = 0;
  i13 = 3;
 } else {
  i12 = i1;
  while (1) {
   if ((HEAP32[i12 + 4 >> 2] | 0) == (i4 | 0)) break;
   i1 = HEAP32[i12 + 8 >> 2] | 0;
   if (!i1) {
    i13 = 6;
    break;
   } else i12 = i1;
  }
  if ((i13 | 0) == 6) {
   i14 = HEAP32[gb + 191628 >> 2] | 0;
   HEAP32[i8 >> 2] = gb + 1076649;
   _fprintf(i14, gb + 1076431 | 0, i8) | 0;
   __THREW__ = 0;
   invoke_v(fb + 457 | 0);
   __THREW__ = 0;
   i13 = 3;
   break;
  }
  HEAP32[i5 >> 2] = i10;
  i8 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6, i5, 4) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i1 + (((i8 >>> 0) % ((HEAP32[i7 >> 2] | 0) - i1 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
  do if (!i1) {
   i14 = HEAP32[gb + 191628 >> 2] | 0;
   HEAP32[i9 >> 2] = gb + 1076688;
   _fprintf(i14, gb + 1076431 | 0, i9) | 0;
   __THREW__ = 0;
   invoke_v(fb + 457 | 0);
   __THREW__ = 0;
  } else {
   i5 = i1;
   while (1) {
    if ((HEAP32[i5 + 4 >> 2] | 0) == (i10 | 0)) break;
    i1 = HEAP32[i5 + 8 >> 2] | 0;
    if (!i1) {
     i13 = 12;
     break;
    } else i5 = i1;
   }
   if ((i13 | 0) == 12) {
    i14 = HEAP32[gb + 191628 >> 2] | 0;
    HEAP32[i11 >> 2] = gb + 1076727;
    _fprintf(i14, gb + 1076431 | 0, i11) | 0;
    __THREW__ = 0;
    invoke_v(fb + 457 | 0);
    __THREW__ = 0;
    break;
   }
   i1 = i12 + 12 | 0;
   i4 = i5 + 12 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i2;
   i2 = i12 + 16 | 0;
   i3 = i5 + 16 | 0;
   i10 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i3 >> 2] = i10;
   i10 = i12 + 20 | 0;
   i13 = i5 + 20 | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i13 >> 2] = i11;
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   while (1) {
    if ((i1 | 0) == (i2 | 0)) break;
    HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] = i12;
    i1 = i1 + 4 | 0;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   while (1) {
    if ((i1 | 0) == (i2 | 0)) break;
    HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] = i5;
    i1 = i1 + 4 | 0;
   }
   __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
   STACKTOP = i14;
   return;
  } while (0);
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 if ((i13 | 0) == 3) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 ___resumeException(i1 | 0);
}

function __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback(i9, i10, i11, i12) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20;
 f26 = Math_fround(HEAPF32[i10 >> 2]);
 f22 = Math_fround(HEAPF32[i11 >> 2]);
 f25 = Math_fround(f26 - f22);
 f21 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f24 = Math_fround(f21 - f23);
 f22 = Math_fround(f26 + f22);
 f23 = Math_fround(f21 + f23);
 f21 = Math_fround(HEAPF32[i9 + 76 >> 2]);
 f25 = Math_fround(f25 / f21);
 i16 = f25 < Math_fround(-16777216.0);
 i15 = f25 > Math_fround(16777216.0);
 f25 = i15 ? Math_fround(16777216.0) : f25;
 f25 = i16 ? Math_fround(-16777216.0) : f25;
 f24 = Math_fround(f24 / f21);
 i16 = f24 < Math_fround(-16777216.0);
 i15 = f24 > Math_fround(16777216.0);
 f24 = i15 ? Math_fround(16777216.0) : f24;
 i15 = ~~Math_fround(Math_floor(Math_fround(f25)));
 i16 = ~~Math_fround(Math_floor(Math_fround(i16 ? Math_fround(-16777216.0) : f24)));
 f22 = Math_fround(f22 / f21);
 i19 = f22 < Math_fround(-16777216.0);
 i1 = f22 > Math_fround(16777216.0);
 f22 = i1 ? Math_fround(16777216.0) : f22;
 f22 = i19 ? Math_fround(-16777216.0) : f22;
 f21 = Math_fround(f23 / f21);
 i19 = f21 < Math_fround(-16777216.0);
 i1 = f21 > Math_fround(16777216.0);
 f21 = i1 ? Math_fround(16777216.0) : f21;
 i1 = ~~Math_fround(Math_floor(Math_fround(f22)));
 i19 = ~~Math_fround(Math_floor(Math_fround(i19 ? Math_fround(-16777216.0) : f21)));
 i14 = HEAP32[i9 + 60 >> 2] | 0;
 i14 = (i15 | 0) > (i14 | 0) ? i15 : i14;
 i15 = HEAP32[i9 + 68 >> 2] | 0;
 i15 = (i1 | 0) < (i15 | 0) ? i1 : i15;
 i1 = HEAP32[i9 + 64 >> 2] | 0;
 i1 = (i16 | 0) > (i1 | 0) ? i16 : i1;
 i16 = HEAP32[i9 + 72 >> 2] | 0;
 i16 = (i19 | 0) < (i16 | 0) ? i19 : i16;
 if ((i1 | 0) > (i16 | 0)) {
  STACKTOP = i20;
  return 1073741824;
 }
 i17 = i9 + 4 | 0;
 i18 = i9 + 8 | 0;
 i19 = i9 + 20 | 0;
 if ((i14 | 0) > (i15 | 0)) {
  STACKTOP = i20;
  return 1073741824;
 }
 while (1) {
  i8 = Math_imul(i1, -669632447) | 0;
  i7 = i14;
  while (1) {
   i2 = HEAP32[i17 >> 2] & (Math_imul(i7, -1918454973) | 0) + i8;
   i2 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i2 | 0) != -1) {
    i6 = HEAP32[i19 >> 2] | 0;
    i3 = 0;
    do {
     i4 = i6 + (i2 * 56 | 0) | 0;
     i5 = HEAP32[i6 + (i2 * 56 | 0) + 8 >> 2] | 0;
     if (i5) if ((HEAP32[i5 + 8 >> 2] | 0) == (i7 | 0)) if ((i3 | 0) < 32 ? (HEAP32[i5 + 12 >> 2] | 0) == (i1 | 0) : 0) {
      HEAP32[i13 + (i3 << 2) >> 2] = i4;
      i3 = i3 + 1 | 0;
     }
     i2 = HEAP32[i6 + (i2 * 56 | 0) + 52 >> 2] | 0;
    } while ((i2 | 0) != -1);
    if ((i3 | 0) > 0) {
     i2 = 0;
     do {
      __ZNK9dtNavMesh19queryPolygonsInTileEPK10dtMeshTilePKfS4_P15dtQueryCallback(i9, HEAP32[i13 + (i2 << 2) >> 2] | 0, i10, i11, i12);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
    }
   }
   if ((i7 | 0) < (i15 | 0)) i7 = i7 + 1 | 0; else break;
  }
  if ((i1 | 0) < (i16 | 0)) i1 = i1 + 1 | 0; else break;
 }
 STACKTOP = i20;
 return 1073741824;
}

function __ZN5Unity11Adjacencies14CreateDatabaseEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 12 | 0;
 i12 = i21;
 i19 = i18 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i18 + 16 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 >> 2] = __Znaj(4096) | 0;
 i17 = i18 + 4 | 0;
 HEAP32[i17 >> 2] = __Znaj(1024) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i16 = i1 >>> 0 > 1073741823 ? -1 : i1 << 2;
 i14 = __Znaj(i16) | 0;
 i15 = __Znaj(i16) | 0;
 i16 = __Znaj(i16) | 0;
 if (!i1) i1 = 0; else {
  i3 = HEAP32[i13 + 8 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i14 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 * 12 | 0) + 8 >> 2];
   HEAP32[i15 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 * 12 | 0) >> 2];
   HEAP32[i16 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 i10 = __ZN11RadixSorter4SortEPjjb(i18, i14, i1, 1) | 0;
 i10 = __ZN11RadixSorter4SortEPjjb(i10, i15, HEAP32[i13 >> 2] | 0, 1) | 0;
 i10 = HEAP32[(__ZN11RadixSorter4SortEPjjb(i10, i16, HEAP32[i13 >> 2] | 0, 1) | 0) + 12 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i15 + (i3 << 2) >> 2] | 0;
 i5 = HEAP32[i16 + (i3 << 2) >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 do if (!i2) {
  i3 = 1;
  i1 = 18;
 } else {
  i11 = i12 + 4 | 0;
  i1 = 0;
  i8 = 0;
  i6 = i5;
  i7 = i4;
  i9 = i4;
  while (1) {
   i4 = HEAP32[i14 + (i3 << 2) >> 2] | 0;
   if ((i9 | 0) == (i7 | 0) & (i5 | 0) == (i6 | 0)) {
    i3 = i8 + 1 | 0;
    HEAP32[i12 + (i8 << 2) >> 2] = i4;
    if ((i3 | 0) == 3) {
     i1 = 8;
     break;
    }
   } else {
    if ((i8 | 0) == 2) {
     if (!(__ZN5Unity11Adjacencies10UpdateLinkEjjjj(i13, HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] | 0, i7, i6) | 0)) {
      i1 = 12;
      break;
     }
     i2 = HEAP32[i13 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = i4;
    i3 = 1;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    i1 = 16;
    break;
   }
   i4 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
   i7 = i9;
   i6 = i5;
   i8 = i3;
   i3 = i4;
   i9 = HEAP32[i15 + (i4 << 2) >> 2] | 0;
   i5 = HEAP32[i16 + (i4 << 2) >> 2] | 0;
  }
  if ((i1 | 0) == 8) {
   __ZdaPv(i16);
   __ZdaPv(i15);
   __ZdaPv(i14);
   i2 = 0;
   break;
  } else if ((i1 | 0) == 12) {
   __ZdaPv(i16);
   __ZdaPv(i15);
   __ZdaPv(i14);
   i2 = 0;
   break;
  } else if ((i1 | 0) == 16) {
   if ((i3 | 0) != 2) {
    i3 = 1;
    i1 = 18;
    break;
   }
   i3 = __ZN5Unity11Adjacencies10UpdateLinkEjjjj(i13, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i9, i5) | 0;
   i1 = 18;
   break;
  }
 } while (0);
 if ((i1 | 0) == 18) {
  __ZdaPv(i16);
  __ZdaPv(i15);
  __ZdaPv(i14);
  i1 = i13 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
  HEAP32[i1 >> 2] = 0;
  i2 = i3;
 }
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i17 >> 2] = 0;
 i1 = HEAP32[i18 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i18 >> 2] = 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i20 >> 2] = 0;
 i1 = HEAP32[i19 >> 2] | 0;
 if (!i1) {
  STACKTOP = i21;
  return i2 | 0;
 }
 __ZdaPv(i1);
 STACKTOP = i21;
 return i2 | 0;
}

function __ZN11BoxCollider10SmartResetEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i1 = i7;
 i5 = i6 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i2, i3) | 0) {
  f10 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * Math_fround(2.0));
  f9 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) * Math_fround(2.0));
  f8 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) * Math_fround(2.0));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f9;
  HEAPF32[i1 + 8 >> 2] = f8;
  __ZN11BoxCollider7SetSizeERK8Vector3f(i6, i1);
  i1 = i6 + 60 | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  if (f8 != Math_fround(HEAPF32[i1 >> 2])) i4 = 6; else {
   f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   if (f10 != Math_fround(HEAPF32[i6 + 64 >> 2])) i4 = 6; else {
    f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    if (f10 != Math_fround(HEAPF32[i6 + 68 >> 2])) i4 = 6;
   }
  }
  if ((i4 | 0) == 6) {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  }
  i2 = i6 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 168 >> 2] | 0, i6 | 0, -2147483645);
  i3 = i6 + 108 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i4 = i6 + 112 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
   HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
  }
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 31312 | 0) | 0;
  if (!((i1 | 0) != 0 & (HEAP32[i2 >> 2] | 0) != 0)) {
   STACKTOP = i7;
   return;
  }
  i5 = i1 + 32 | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0) | 0)) {
   STACKTOP = i7;
   return;
  }
  HEAP32[i6 + 120 >> 2] = gb + 733469;
  HEAP32[i6 + 124 >> 2] = i6;
  HEAP8[i6 + 128 >> 0] = 1;
  i2 = (__Z17GetPhysicsManagerv() | 0) + 716 | 0;
  if ((i3 | 0) == (i2 | 0)) {
   STACKTOP = i7;
   return;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i6 + 112 | 0; else {
   i6 = i6 + 112 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i1 = i6;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  STACKTOP = i7;
  return;
 }
 __ZN11BoxCollider7SetSizeERK8Vector3f(i6, gb + 62512 | 0);
 i1 = i6 + 60 | 0;
 f10 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
 if (f10 != Math_fround(HEAPF32[i1 >> 2])) i4 = 21; else {
  f10 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
  if (f10 != Math_fround(HEAPF32[i6 + 64 >> 2])) i4 = 21; else {
   f10 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
   if (f10 != Math_fround(HEAPF32[i6 + 68 >> 2])) i4 = 21;
  }
 }
 if ((i4 | 0) == 21) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 if (!(HEAP32[i6 + 36 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 168 >> 2] | 0, i6 | 0, -2147483645);
 STACKTOP = i7;
 return;
}

function _expm1f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 & 2147483647;
 i3 = i3 >>> 31;
 do if (i2 >>> 0 > 1100331075) {
  if (i2 >>> 0 <= 2139095040) if (!i3) if (f1 > Math_fround(88.7216796)) f1 = Math_fround(f1 * Math_fround(1701411830000000029203285.0e14)); else i7 = 11; else f1 = Math_fround(-1.0);
 } else {
  if (i2 >>> 0 <= 1051816472) if (i2 >>> 0 < 855638016) break; else {
   f6 = Math_fround(0.0);
   i3 = 0;
   i7 = 14;
   break;
  }
  if (i2 >>> 0 < 1065686418) if (!i3) {
   i2 = 1;
   f4 = Math_fround(f1 + Math_fround(-.693138123));
   f5 = Math_fround(9.05800061e-06);
   i7 = 12;
   break;
  } else {
   i2 = -1;
   f4 = Math_fround(f1 + Math_fround(.693138123));
   f5 = Math_fround(-9.05800061e-06);
   i7 = 12;
   break;
  } else i7 = 11;
 } while (0);
 if ((i7 | 0) == 11) {
  f5 = Math_fround(f1 * Math_fround(1.44269502));
  i2 = ~~Math_fround(f5 + (i3 | 0 ? Math_fround(-.5) : Math_fround(.5)));
  f5 = Math_fround(i2 | 0);
  f4 = Math_fround(f1 - Math_fround(f5 * Math_fround(.693138123)));
  f5 = Math_fround(f5 * Math_fround(9.05800061e-06));
  i7 = 12;
 }
 if ((i7 | 0) == 12) {
  f6 = Math_fround(f4 - f5);
  f1 = f6;
  f6 = Math_fround(Math_fround(f4 - f6) - f5);
  i3 = i2;
  i7 = 14;
 }
 L18 : do if ((i7 | 0) == 14) {
  f5 = Math_fround(f1 * Math_fround(.5));
  f4 = Math_fround(f1 * f5);
  f8 = Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(.00158071704)) + Math_fround(-.0333332121))) + Math_fround(1.0));
  f5 = Math_fround(Math_fround(3.0) - Math_fround(f5 * f8));
  f5 = Math_fround(f4 * Math_fround(Math_fround(f8 - f5) / Math_fround(Math_fround(6.0) - Math_fround(f1 * f5))));
  if (!i3) {
   f1 = Math_fround(f1 - Math_fround(Math_fround(f1 * f5) - f4));
   break;
  }
  f4 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(f5 - f6)) - f6) - f4);
  switch (i3 | 0) {
  case -1:
   {
    f1 = Math_fround(Math_fround(Math_fround(f1 - f4) * Math_fround(.5)) + Math_fround(-.5));
    break L18;
   }
  case 1:
   if (f1 < Math_fround(-.25)) {
    f1 = Math_fround(Math_fround(f4 - Math_fround(f1 + Math_fround(.5))) * Math_fround(-2.0));
    break L18;
   } else {
    f1 = Math_fround(Math_fround(Math_fround(f1 - f4) * Math_fround(2.0)) + Math_fround(1.0));
    break L18;
   }
  default:
   {
    f5 = (HEAP32[tempDoublePtr >> 2] = (i3 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (i3 >>> 0 > 56) {
     f1 = Math_fround(Math_fround(f1 - f4) + Math_fround(1.0));
     f8 = Math_fround(Math_fround(f1 * Math_fround(2.0)) * Math_fround(1701411830000000029203285.0e14));
     f1 = Math_fround(f5 * f1);
     f1 = Math_fround(((i3 | 0) == 128 ? f8 : f1) + Math_fround(-1.0));
     break L18;
    }
    i2 = 127 - i3 << 23;
    if ((i3 | 0) < 23) {
     f1 = Math_fround(f1 - f4);
     f1 = Math_fround(Math_fround(Math_fround(1.0) - (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) + f1);
    } else f1 = Math_fround(Math_fround(f1 - Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f4)) + Math_fround(1.0));
    f1 = Math_fround(f5 * f1);
    break L18;
   }
  }
 } while (0);
 return Math_fround(f1);
}

function __ZN16PlayerConnection14ReadConfigFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 56 | 0;
 i10 = i14 + 16 | 0;
 i13 = i14;
 i4 = i14 + 92 | 0;
 i11 = i14 + 80 | 0;
 i12 = i14 + 64 | 0;
 i5 = i2 + 144 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i2 + 212 | 0;
 HEAP32[i6 >> 2] = -1;
 i7 = i2 + 216 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i2 + 148 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[gb + 65628 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i3, _strlen(i3) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i1, i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 if (!(__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11) | 0)) {
  i13 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i14;
  return i13 | 0;
 };
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE(i12, i11) | 0;
 i3 = i12 + 11 | 0;
 i1 = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i7;
 HEAP32[i13 + 8 >> 2] = i4;
 do if ((_sscanf(i1, gb + 460381 | 0, i13) | 0) == 3) {
  HEAP8[i8 >> 0] = (HEAP32[i4 >> 2] | 0) != 0 & 1;
  HEAP32[i5 >> 2] = 0;
  i1 = 1;
 } else {
  i8 = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  HEAP32[i10 >> 2] = i2 + 236;
  HEAP32[i10 + 4 >> 2] = i2 + 252;
  HEAP32[i10 + 8 >> 2] = i2 + 268;
  HEAP32[i10 + 12 >> 2] = i2 + 284;
  HEAP32[i10 + 16 >> 2] = i2 + 300;
  HEAP32[i10 + 20 >> 2] = i2 + 316;
  HEAP32[i10 + 24 >> 2] = i2 + 332;
  HEAP32[i10 + 28 >> 2] = i2 + 348;
  HEAP32[i10 + 32 >> 2] = i2 + 364;
  HEAP32[i10 + 36 >> 2] = i2 + 380;
  i8 = _sscanf(i8, gb + 460397 | 0, i10) | 0;
  HEAP32[i2 + 220 >> 2] = i8;
  if ((i8 | 0) > 0) {
   HEAP32[i5 >> 2] = 1;
   i1 = 1;
   break;
  } else {
   HEAP32[i9 >> 2] = gb + 460497;
   HEAP32[i9 + 4 >> 2] = gb + 460539;
   __Z6FormatPKcz(i10, gb + 460435 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 459789 | 0, 306, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   i1 = 0;
   break;
  }
 } while (0);
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i10 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = 1;
  HEAP32[i13 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i13);
 }
 i13 = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i14;
 return i13 | 0;
}

function __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_(i12, i13, i7, i1, i2, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i15 = __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_(i12, i13, i7, i1, i14) | 0;
 if (!(mftCall_iii(HEAP32[i14 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return i15 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i6;
 i6 = i1 + 4 | 0;
 i18 = i2 + 4 | 0;
 i19 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i17 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 12 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + 16 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i16 = i2 + 8 | 0;
 i21 = HEAP32[i16 >> 2] | 0;
 i9 = i2 + 12 | 0;
 i20 = HEAP32[i9 >> 2] | 0;
 i11 = i2 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i3 >> 2] = i21;
 HEAP32[i4 >> 2] = i20;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i18 >> 2] = i19;
 HEAP32[i16 >> 2] = i17;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i11 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i14 >> 2] | 0, i1 | 0, i7 | 0) | 0)) {
  i21 = i15 + 1 | 0;
  return i21 | 0;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i11;
 i11 = i7 + 4 | 0;
 i18 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 8 | 0;
 i19 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 12 | 0;
 i20 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 16 | 0;
 i21 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 i17 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i16;
 HEAP32[i10 >> 2] = i17;
 HEAP32[i6 >> 2] = i18;
 HEAP32[i3 >> 2] = i19;
 HEAP32[i4 >> 2] = i20;
 HEAP32[i5 >> 2] = i21;
 if (!(mftCall_iii(HEAP32[i14 >> 2] | 0, i7 | 0, i13 | 0) | 0)) {
  i21 = i15 + 2 | 0;
  return i21 | 0;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i4;
 i4 = i13 + 4 | 0;
 i18 = HEAP32[i4 >> 2] | 0;
 i1 = i13 + 8 | 0;
 i19 = HEAP32[i1 >> 2] | 0;
 i2 = i13 + 12 | 0;
 i20 = HEAP32[i2 >> 2] | 0;
 i3 = i13 + 16 | 0;
 i21 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i17 = HEAP32[i10 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i16;
 HEAP32[i3 >> 2] = i17;
 HEAP32[i11 >> 2] = i18;
 HEAP32[i8 >> 2] = i19;
 HEAP32[i9 >> 2] = i20;
 HEAP32[i10 >> 2] = i21;
 if (!(mftCall_iii(HEAP32[i14 >> 2] | 0, i13 | 0, i12 | 0) | 0)) {
  i21 = i15 + 3 | 0;
  return i21 | 0;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i10;
 i10 = i12 + 4 | 0;
 i18 = HEAP32[i10 >> 2] | 0;
 i11 = i12 + 8 | 0;
 i19 = HEAP32[i11 >> 2] | 0;
 i14 = i12 + 12 | 0;
 i20 = HEAP32[i14 >> 2] | 0;
 i17 = i12 + 16 | 0;
 i21 = HEAP32[i17 >> 2] | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i16 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i11 >> 2] = i12;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i4 >> 2] = i18;
 HEAP32[i1 >> 2] = i19;
 HEAP32[i2 >> 2] = i20;
 HEAP32[i3 >> 2] = i21;
 i21 = i15 + 4 | 0;
 return i21 | 0;
}

function _psh_globals_new(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = _UNITY_ft_mem_alloc(i1, 2496, i11) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i2 | 0) {
  i11 = i2;
  HEAP32[i10 >> 2] = i12;
  STACKTOP = i13;
  return i11 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 i8 = i12 + 4 | 0;
 i6 = i12 + 208 | 0;
 i5 = HEAP32[i9 + 120 >> 2] | 0;
 HEAP32[i12 + 212 >> 2] = i5 & 65535;
 i3 = HEAP16[i9 + 124 >> 1] | 0;
 i4 = i3 & 255;
 i5 = i5 >>> 16;
 i7 = (i3 & 65535) >>> 8;
 if ((i3 & 255) << 24 >> 24) {
  i1 = i4;
  i2 = i9 + 128 | 0;
  i3 = i12 + 224 | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP16[i2 >> 1];
   i1 = i1 + -1 | 0;
   if (!i1) break; else {
    i2 = i2 + 2 | 0;
    i3 = i3 + 12 | 0;
   }
  }
 }
 HEAP32[i6 >> 2] = i4 + 1;
 HEAP32[i12 + 8 >> 2] = i5;
 i4 = i7 & 65535;
 if (i7 << 16 >> 16) {
  i1 = i12 + 20 | 0;
  i2 = i4;
  i3 = i9 + 154 | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP16[i3 >> 1];
   i2 = i2 + -1 | 0;
   if (!i2) break; else {
    i1 = i1 + 12 | 0;
    i3 = i3 + 2 | 0;
   }
  }
 }
 HEAP32[i8 >> 2] = i4 + 1;
 i4 = i12 + 412 | 0;
 i2 = i9 + 8 | 0;
 i3 = HEAP16[i2 >> 1] | 0;
 i8 = i9 + 116 | 0;
 _psh_blues_set_zones(i4, i3 & 255, i9 + 12 | 0, (i3 & 65535) >>> 8 & 65535, i9 + 40 | 0, HEAP32[i8 >> 2] | 0, 0);
 i3 = HEAP16[i9 + 10 >> 1] | 0;
 _psh_blues_set_zones(i4, i3 & 255, i9 + 60 | 0, (i3 & 65535) >>> 8 & 65535, i9 + 88 | 0, HEAP32[i8 >> 2] | 0, 1);
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i2 & 255;
 i4 = (i2 & 65535) >>> 8;
 i5 = i2 >>> 16;
 i6 = i5 & 255;
 i7 = i2 >>> 24;
 if (!((i2 & 255) << 24 >> 24)) i1 = 1; else {
  i2 = 0;
  i1 = 1;
  do {
   i14 = (HEAPU16[i9 + 12 + ((i2 | 1) << 1) >> 1] | 0) - (HEAPU16[i9 + 12 + (i2 << 1) >> 1] | 0) | 0;
   i1 = (i14 << 16 >> 16 | 0) > (i1 << 16 >> 16 | 0) ? i14 & 65535 : i1;
   i2 = i2 + 2 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 i3 = i4 & 65535;
 if (i4 << 16 >> 16) {
  i2 = 0;
  do {
   i14 = (HEAPU16[i9 + 40 + ((i2 | 1) << 1) >> 1] | 0) - (HEAPU16[i9 + 40 + (i2 << 1) >> 1] | 0) | 0;
   i1 = (i14 << 16 >> 16 | 0) > (i1 << 16 >> 16 | 0) ? i14 & 65535 : i1;
   i2 = i2 + 2 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 i3 = i5 & 255;
 if (i6 << 24 >> 24) {
  i2 = 0;
  do {
   i14 = (HEAPU16[i9 + 60 + ((i2 | 1) << 1) >> 1] | 0) - (HEAPU16[i9 + 60 + (i2 << 1) >> 1] | 0) | 0;
   i1 = (i14 << 16 >> 16 | 0) > (i1 << 16 >> 16 | 0) ? i14 & 65535 : i1;
   i2 = i2 + 2 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 if (i7) {
  i2 = 0;
  do {
   i14 = (HEAPU16[i9 + 88 + ((i2 | 1) << 1) >> 1] | 0) - (HEAPU16[i9 + 88 + (i2 << 1) >> 1] | 0) | 0;
   i1 = (i14 << 16 >> 16 | 0) > (i1 << 16 >> 16 | 0) ? i14 & 65535 : i1;
   i2 = i2 + 2 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
 }
 i14 = _UNITY_FT_DivFix(1e3, i1 << 16 >> 16) | 0;
 i7 = HEAP32[i9 + 108 >> 2] | 0;
 HEAP32[i12 + 2476 >> 2] = (i7 | 0) < (i14 | 0) ? i7 : i14;
 HEAP32[i12 + 2480 >> 2] = HEAP32[i9 + 112 >> 2];
 HEAP32[i12 + 2488 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 200 >> 2] = 0;
 HEAP32[i12 + 204 >> 2] = 0;
 HEAP32[i12 + 404 >> 2] = 0;
 HEAP32[i12 + 408 >> 2] = 0;
 i14 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i12;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 - i3 | 0;
 i5 = (i1 | 0) / 132 | 0;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4;
 i9 = i6;
 if (i5 >>> 0 > (((HEAP32[i7 >> 2] | 0) - i4 | 0) / 132 | 0) >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i8);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i6 = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 132 | 0;
  i1 = i6 << 1;
  i1 = i6 >>> 0 < 1073741823 ? (i1 >>> 0 < i5 >>> 0 ? i5 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 132 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 * 132 | 0);
  if ((i3 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i1 = i3;
  do {
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i1);
   i1 = i1 + 132 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 132 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 132 | 0;
 i4 = i5 >>> 0 > i1 >>> 0;
 i1 = i4 ? i3 + (i1 * 132 | 0) | 0 : i6;
 if ((i3 | 0) != (i1 | 0)) do {
  __ZN13AnimationClip10FloatCurveaSERKS0_(i2, i3) | 0;
  i3 = i3 + 132 | 0;
  i2 = i2 + 132 | 0;
 } while ((i3 | 0) != (i1 | 0));
 if (i4) {
  if ((i1 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i1);
   i1 = i1 + 132 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 132 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i10 + 4 | 0;
 do {
  i4 = i1 + -132 | 0;
  HEAP32[i7 >> 2] = i4;
  i3 = i1 + -36 | 0;
  if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -32 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  i3 = i1 + -116 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i3 >> 2] | 0;
   i8 = HEAP32[i1 + -104 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i5 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i1 + -120 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i6 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN11AssetBundle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 24 | 0;
 i5 = i13 + 8 | 0;
 i6 = i13;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i10);
 i7 = i9 + 32 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i10, i9 + 48 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i10, i9 + 68 | 0, 0);
 i2 = i9 + 36 | 0;
 i12 = i10 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i1 = i3 + 4 | 0;
 i11 = i10 + 24 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i2, 4);
  i1 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 >> 2] = i1;
 }
 i2 = i9 + 40 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i12, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 }
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9 + 44 | 0, i10);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i12, i7, 4); else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 }
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i10, i5, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i7 = i5 + 11 | 0;
 i4 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 i1 = gb + 63648 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i9 + 168 | 0, i4, i8);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i9 + 172 | 0, 0);
 i1 = i9 + 184 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i12, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i9);
  STACKTOP = i13;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i9);
  STACKTOP = i13;
  return;
 }
}

function __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i3 = i1 + 4 | 0;
 i3 = HEAP32[(HEAP32[i3 >> 2] | 0) + i3 + (i5 << 3) >> 2] | 0;
 if ((i3 | 0) == -1) {
  i6 = i4 + 4 | 0;
  i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
  i1 = i2 + 4 | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  i2 = HEAP32[i1 + (i5 * 40 | 0) + 16 >> 2] | 0;
  i3 = HEAP32[i1 + (i5 * 40 | 0) + 20 >> 2] | 0;
  i4 = HEAP32[i1 + (i5 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i6 + (i5 * 40 | 0) + 12 >> 2] = HEAP32[i1 + (i5 * 40 | 0) + 12 >> 2];
  HEAP32[i6 + (i5 * 40 | 0) + 16 >> 2] = i2;
  HEAP32[i6 + (i5 * 40 | 0) + 20 >> 2] = i3;
  HEAP32[i6 + (i5 * 40 | 0) + 24 >> 2] = i4;
  return;
 }
 if ((i5 | 0) != (i6 | 0)) __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii(i1, i2, i4, i3, i6);
 i6 = i4 + 4 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i4 = i2 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 f11 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 12 >> 2]);
 f9 = Math_fround(f11 * f15);
 f13 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 24 >> 2]);
 f7 = Math_fround(f13 * f10);
 f14 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 16 >> 2]);
 f12 = Math_fround(f14 * f8);
 f17 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + (i5 * 40 | 0) + 20 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f13 * f16)) - Math_fround(f10 * f14)) - Math_fround(f8 * f17));
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f15 * f17)) - Math_fround(f14 * f16)) - Math_fround(f11 * f8));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f11 * f16)) - Math_fround(f15 * f13)) - Math_fround(f10 * f17));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)) - Math_fround(f13 * f8)) - Math_fround(f11 * f10));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f10 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f10 * f10);
 f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f9 * f9);
 f8 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f11) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
 f9 = Math_fround(f11 * f9);
 f8 = Math_fround(f11 * f8);
 f7 = Math_fround(f11 * f7);
 HEAPF32[i6 + (i5 * 40 | 0) + 12 >> 2] = Math_fround(f11 * f10);
 HEAPF32[i6 + (i5 * 40 | 0) + 16 >> 2] = f9;
 HEAPF32[i6 + (i5 * 40 | 0) + 20 >> 2] = f8;
 HEAPF32[i6 + (i5 * 40 | 0) + 24 >> 2] = f7;
 return;
}

function __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i7 = i10;
 i6 = i8 + 12 | 0;
 i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 30) | 0;
 getTempRet0() | 0;
 switch (i6 & 3 | 0) {
 case 0:
  {
   i2 = i1 | 3;
   i1 = HEAP32[i8 + 8 >> 2] | 0;
   i6 = HEAP32[i1 + 20 >> 2] | 0;
   i1 = i6 + (HEAP32[i1 + 28 >> 2] << 2) | 0;
   HEAP32[i3 >> 2] = i6;
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i3 + 8 >> 2] = i8;
   i1 = __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv(i3) | 0;
   if (i1 | 0) do {
    __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i9, i1 + -8 | 0, i2, 0, 1);
    i1 = __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv(i3) | 0;
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i9 + 2532 >> 2] | 0;
   if (!i1) {
    STACKTOP = i10;
    return;
   }
   i6 = i8;
   i6 = i6 + ~(i6 << 15) | 0;
   i6 = (i6 >>> 10 ^ i6) * 9 | 0;
   i6 = i6 >>> 6 ^ i6;
   i6 = i6 + ~(i6 << 11) | 0;
   i1 = HEAP32[(HEAP32[i9 + 2524 >> 2] | 0) + ((i1 + -1 & (i6 >>> 16 ^ i6)) << 2) >> 2] | 0;
   if ((i1 | 0) == -1) {
    STACKTOP = i10;
    return;
   }
   i4 = HEAP32[i9 + 2516 >> 2] | 0;
   i3 = i9 + 2520 | 0;
   while (1) {
    i2 = i4 + (i1 * 12 | 0) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i5 = 19;
     break;
    }
   }
   if ((i5 | 0) == 19) {
    STACKTOP = i10;
    return;
   }
   if (!i2) {
    STACKTOP = i10;
    return;
   }
   i1 = HEAP32[i4 + (i1 * 12 | 0) + 8 >> 2] | 0;
   if (i1 | 0) {
    i2 = i9 + 2496 | 0;
    i3 = i9 + 2508 | 0;
    i4 = i9 + 2500 | 0;
    i5 = i9 + 2492 | 0;
    i6 = i9 + 2216 | 0;
    do {
     __ZN5physx2Sc8ClothSim20removeCollisionShapeEPKNS0_8ShapeSimE(HEAP32[i1 >> 2] | 0, i8);
     i11 = i1;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i3 >> 2] = i11;
     i11 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i11 + 1;
     if ((i11 | 0) >= ((HEAP32[i5 >> 2] | 0) * 50 | 0)) {
      __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i6);
      HEAP32[i4 >> 2] = 0;
     }
    } while ((i1 | 0) != 0);
   }
   HEAP32[i7 >> 2] = i8;
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE5eraseERS8_(i9 + 2512 | 0, i7) | 0;
   STACKTOP = i10;
   return;
  }
 case 1:
  {
   i2 = i1 | 1;
   i3 = HEAP32[i8 + 36 >> 2] | 0;
   i1 = HEAP16[i8 + 42 >> 1] | 0;
   if (!(i1 << 16 >> 16)) {
    STACKTOP = i10;
    return;
   }
   i1 = i3 + ((i1 & 65535) << 2) | 0;
   do {
    i1 = i1 + -4 | 0;
    __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i9, HEAP32[i1 >> 2] | 0, i2, 0, 1);
   } while (i3 >>> 0 < i1 >>> 0);
   STACKTOP = i10;
   return;
  }
 default:
  {
   STACKTOP = i10;
   return;
  }
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_(i17, i18, i19) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = i18 + 176 | 0;
 i9 = HEAP32[i22 >> 2] | 0;
 i10 = i9 + -1 | 0;
 i11 = HEAP32[i19 >> 2] | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = HEAP32[i19 + 4 >> 2] | 0;
 i1 = i1 + 2127912214 + (i1 << 12) | 0;
 i1 = i1 ^ -949894596 ^ HEAP32[i6 + 4 >> 2] ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i20 = i18 + 172 | 0;
 i21 = HEAP32[i20 >> 2] | 0;
 i7 = HEAP32[i18 + 92 >> 2] | 0;
 i8 = i18 + 96 | 0;
 i12 = i18 + 8 | 0;
 i13 = i18 + 4 | 0;
 i14 = i18 + 12 | 0;
 i15 = i18 + 16 | 0;
 i5 = 0;
 i3 = -1;
 i1 = i1 + -744332180 ^ i1 << 9;
 while (1) {
  i4 = i1 & i10;
  i2 = HEAP32[i21 + (i4 * 80 | 0) >> 2] | 0;
  if ((i7 | 0) == (i2 | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i21 + (i4 * 80 | 0) + 4 >> 2] | 0)) {
   i16 = 4;
   break;
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i16 = 10; else if (!(HEAP32[i13 >> 2] | 0)) i16 = 10; else if ((HEAP32[i14 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i15 >> 2] | 0) == (HEAP32[i21 + (i4 * 80 | 0) + 4 >> 2] | 0)) i1 = (i3 | 0) == -1 ? i4 : i3; else i16 = 10; else i16 = 10;
  if ((i16 | 0) == 10) {
   i16 = 0;
   if ((i11 | 0) == (i2 | 0)) if ((i6 | 0) == (HEAP32[i21 + (i4 * 80 | 0) + 4 >> 2] | 0)) {
    i16 = 13;
    break;
   } else i1 = i3; else i1 = i3;
  }
  i2 = i5 + 1 | 0;
  i5 = i2;
  i3 = i1;
  i1 = i2 + i4 | 0;
 }
 if ((i16 | 0) == 4) {
  i4 = (i3 | 0) == -1 ? i4 : i3;
  i1 = HEAP8[i12 >> 0] | 0;
 } else if ((i16 | 0) == 13) if ((i4 | 0) == -1) i4 = -1; else {
  HEAP32[i17 >> 2] = i18;
  HEAP32[i17 + 4 >> 2] = i21 + (i4 * 80 | 0);
  HEAP32[i17 + 8 >> 2] = i21 + (i9 * 80 | 0);
  HEAP8[i17 + 12 >> 0] = 0;
  return;
 }
 if (!(i1 << 24 >> 24)) i16 = 20; else {
  i1 = HEAP32[i13 >> 2] | 0;
  if (!i1) i16 = 20; else if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i21 + (i4 * 80 | 0) >> 2] | 0)) if ((HEAP32[i15 >> 2] | 0) == (HEAP32[i21 + (i4 * 80 | 0) + 4 >> 2] | 0)) HEAP32[i13 >> 2] = i1 + -1; else i16 = 20; else i16 = 20;
 }
 if ((i16 | 0) == 20) {
  i16 = i18 + 180 | 0;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 }
 i3 = i19;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i21 + (i4 * 80 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i21 + (i4 * 80 | 0) + 8 | 0;
 i2 = i19 + 8 | 0;
 i3 = i1 + 56 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i21 + (i4 * 80 | 0) + 64 >> 2] = HEAP32[i19 + 64 >> 2];
 HEAP32[i21 + (i4 * 80 | 0) + 68 >> 2] = HEAP32[i19 + 68 >> 2];
 i16 = i19 + 72 | 0;
 i19 = HEAP32[i16 + 4 >> 2] | 0;
 i21 = i21 + (i4 * 80 | 0) + 72 | 0;
 HEAP32[i21 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i21 + 4 >> 2] = i19;
 i21 = HEAP32[i20 >> 2] | 0;
 i22 = i21 + ((HEAP32[i22 >> 2] | 0) * 80 | 0) | 0;
 HEAP32[i17 >> 2] = i18;
 HEAP32[i17 + 4 >> 2] = i21 + (i4 * 80 | 0);
 HEAP32[i17 + 8 >> 2] = i22;
 HEAP8[i17 + 12 >> 0] = 1;
 return;
}

function __Z26SkinVerticesGenericMathLibILi1ELb1ELb1EEvPKhiiiiPhiPKvS4_(i1, i4, i5, i6, i7, i2, i8, i9, i10) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 if ((i4 | 0) <= 0) return;
 i3 = 0;
 while (1) {
  i11 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
  f31 = Math_fround(HEAPF32[i9 + (i11 << 6) >> 2]);
  f29 = Math_fround(HEAPF32[i9 + (i11 << 6) + 4 >> 2]);
  f27 = Math_fround(HEAPF32[i9 + (i11 << 6) + 8 >> 2]);
  f30 = Math_fround(HEAPF32[i9 + (i11 << 6) + 16 >> 2]);
  f28 = Math_fround(HEAPF32[i9 + (i11 << 6) + 20 >> 2]);
  f25 = Math_fround(HEAPF32[i9 + (i11 << 6) + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i9 + (i11 << 6) + 32 >> 2]);
  f14 = Math_fround(HEAPF32[i9 + (i11 << 6) + 36 >> 2]);
  f23 = Math_fround(HEAPF32[i9 + (i11 << 6) + 40 >> 2]);
  f22 = Math_fround(HEAPF32[i9 + (i11 << 6) + 48 >> 2]);
  f21 = Math_fround(HEAPF32[i9 + (i11 << 6) + 52 >> 2]);
  f17 = Math_fround(HEAPF32[i9 + (i11 << 6) + 56 >> 2]);
  f26 = Math_fround(HEAPF32[i1 >> 2]);
  f24 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i11 = HEAP32[i1 + 12 >> 2] | 0;
  f22 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f31 * f26) + Math_fround(f30 * f24)) + Math_fround(f15 * f20)));
  f21 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f29 * f26) + Math_fround(f28 * f24)) + Math_fround(f14 * f20)));
  f20 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f24)) + Math_fround(f23 * f20)));
  i16 = i1 + i5 | 0;
  f24 = Math_fround(HEAPF32[i16 >> 2]);
  f26 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  i16 = HEAP32[i16 + 12 >> 2] | 0;
  f19 = Math_fround(Math_fround(Math_fround(f31 * f24) + Math_fround(f30 * f26)) + Math_fround(f15 * f17));
  f18 = Math_fround(Math_fround(Math_fround(f29 * f24) + Math_fround(f28 * f26)) + Math_fround(f14 * f17));
  f17 = Math_fround(Math_fround(Math_fround(f27 * f24) + Math_fround(f25 * f26)) + Math_fround(f23 * f17));
  i12 = i1 + i6 | 0;
  f26 = Math_fround(HEAPF32[i12 >> 2]);
  f24 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  i12 = HEAP32[i12 + 12 >> 2] | 0;
  f15 = Math_fround(Math_fround(Math_fround(f31 * f26) + Math_fround(f30 * f24)) + Math_fround(f15 * f13));
  f14 = Math_fround(Math_fround(Math_fround(f29 * f26) + Math_fround(f28 * f24)) + Math_fround(f14 * f13));
  f13 = Math_fround(Math_fround(Math_fround(f27 * f26) + Math_fround(f25 * f24)) + Math_fround(f23 * f13));
  HEAPF32[i2 >> 2] = f22;
  HEAPF32[i2 + 4 >> 2] = f21;
  HEAPF32[i2 + 8 >> 2] = f20;
  HEAP32[i2 + 12 >> 2] = i11;
  i11 = i2 + i5 | 0;
  HEAPF32[i11 >> 2] = f19;
  HEAPF32[i11 + 4 >> 2] = f18;
  HEAPF32[i11 + 8 >> 2] = f17;
  HEAP32[i11 + 12 >> 2] = i16;
  i11 = i2 + i6 | 0;
  HEAPF32[i11 >> 2] = f15;
  HEAPF32[i11 + 4 >> 2] = f14;
  HEAPF32[i11 + 8 >> 2] = f13;
  HEAP32[i11 + 12 >> 2] = i12;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + i7 | 0;
   i2 = i2 + i8 | 0;
  }
 }
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPKv(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN8Animator38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei(i8, i1, i2, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 624 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 84 >> 2] | 0)) return;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 __ZN8Animator11SetPlayableEP8Playablei(i8, i2, i3);
 i4 = i8 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) return;
 i7 = i8 + 628 | 0;
 i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0;
 i5 = i8 + 153 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0) | 0) if (HEAP8[i5 >> 0] | 0) {
  i1 = i8 + 168 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   __ZN8Animator25WriteDefaultValuesNoDirtyEv(i8);
   i2 = i8 + 604 | 0;
   i3 = i8 + 620 | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i8 + 608 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   HEAP32[i2 >> 2] = 0;
   HEAP32[i8 + 616 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i8 + 176 | 0);
   HEAP32[i8 + 172 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0);
    __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(HEAP32[i6 >> 2] | 0, 0);
   }
   if (__ZNK9HPlayable7IsValidEv(i4) | 0) {
    i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0;
    mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0, i6 | 0);
   }
   i1 = i8 + 584 | 0;
   i2 = i8 + 600 | 0;
   if ((HEAP32[i2 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 588 | 0);
    HEAP32[i1 >> 2] = 0;
   }
   HEAP32[i1 >> 2] = 0;
   HEAP32[i8 + 596 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   __ZN8Animator14CreateBindingsEv(i8);
   __ZN8Animator20CreatePlayableMemoryEv(i8);
  }
 }
 if (HEAP8[i5 >> 0] | 0) {
  i1 = HEAP32[i8 + 168 >> 2] | 0;
  if (i1 | 0) {
   i6 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i8 + 40 | 0;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 44 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 48 >> 2] = HEAP32[i8 + 124 >> 2];
   HEAP32[i8 + 52 >> 2] = HEAP32[i6 + 8 >> 2];
   i6 = HEAP32[(HEAP32[i8 + 172 >> 2] | 0) + 36 >> 2] | 0;
   HEAP32[i8 + 56 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i8 + 60 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 64 >> 2] = HEAP32[i6 + 28 >> 2];
   HEAP32[i8 + 68 >> 2] = HEAP32[i6 + 32 >> 2];
   HEAP8[i8 + 72 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
   if (__ZNK8Animator7IsHumanEv(i8) | 0) i1 = 0; else i1 = (HEAP32[(HEAP32[i8 + 132 >> 2] | 0) + 16 >> 2] | 0) != 0 & 1;
   HEAP8[i8 + 73 >> 0] = i1;
   HEAP8[i8 + 74 >> 0] = (__ZNK8Animator7IsHumanEv(i8) | 0) & 1;
   HEAP8[i8 + 75 >> 0] = HEAP8[(HEAP32[i8 + 128 >> 2] | 0) + 17 >> 0] | 0;
   __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i2);
  }
 }
 i7 = HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0;
 HEAP8[i8 + 76 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0) & 1;
 return;
}

function __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i3, i4, i5, i8, i9, i6, i7, i10) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i1 = i11;
 i2 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i11 + 36 >> 2] = i3;
 if ((i3 | 0) > 0) if (!(i10 & 4)) {
  i2 = 0;
  do {
   i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   if (!i1) {
    i1 = __Z12GetGfxDevicev() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
   }
   i13 = i11 + (i2 << 2) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP8[i11 + 56 + i2 >> 0] = HEAP8[i1 + 28 >> 0] | 0;
   HEAP8[i11 + 64 + i2 >> 0] = HEAP8[(HEAP32[i13 >> 2] | 0) + 29 >> 0] | 0;
   i1 = HEAP32[i13 >> 2] | 0;
   HEAP8[i1 + 29 >> 0] = 0;
   HEAP8[i1 + 28 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } else {
  i2 = 0;
  do {
   i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   if (!i1) {
    i1 = __Z12GetGfxDevicev() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
   }
   i13 = i11 + (i2 << 2) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP8[i11 + 56 + i2 >> 0] = 2;
   HEAP8[i11 + 64 + i2 >> 0] = HEAP8[(HEAP32[i13 >> 2] | 0) + 29 >> 0] | 0;
   i13 = HEAP32[i13 >> 2] | 0;
   HEAP8[i13 + 29 >> 0] = 0;
   HEAP8[i13 + 28 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i11 + 32 >> 2] = i1;
 i5 = i10 & 8;
 if (!i5) {
  i4 = i1 + 28 | 0;
  i3 = HEAP16[i4 >> 1] | 0;
  i1 = i1 + 29 | 0;
  i2 = i3 & 255;
  i3 = (i3 & 65535) >>> 8 & 255;
 } else {
  i3 = i1 + 29 | 0;
  i4 = i1 + 28 | 0;
  i1 = i3;
  i2 = 2;
  i3 = HEAP8[i3 >> 0] | 0;
 }
 HEAP8[i11 + 72 >> 0] = i2;
 HEAP8[i11 + 73 >> 0] = i3;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i11 + 44 >> 2] = i6;
 HEAP32[i11 + 48 >> 2] = i7;
 i1 = HEAP32[i11 >> 2] | 0;
 if (HEAP8[i1 + 31 >> 0] | 0) {
  i7 = 0;
  i13 = (i9 | 0) < 0;
  i6 = (i7 | 0) < (i9 | 0);
  i7 = i6 ? i7 : i9;
  i7 = i13 ? 0 : i7;
  i13 = i11 + 40 | 0;
  HEAP32[i13 >> 2] = i7;
  i13 = i10 >>> 2;
  i13 = i13 & 1;
  i7 = i5 >>> 2;
  i9 = i10 << 2;
  i9 = i9 & 8;
  i6 = i10 & 48;
  i7 = i6 | i7;
  i13 = i7 | i13;
  i9 = i13 | i9;
  i13 = i11 + 52 | 0;
  HEAP32[i13 >> 2] = i9;
  i13 = __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j(i11, i8, i10) | 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 i7 = (__Z22CalculateMipMapCount3Diii(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 1) | 0) + -1 | 0;
 i13 = (i9 | 0) < 0;
 i6 = (i7 | 0) < (i9 | 0);
 i7 = i6 ? i7 : i9;
 i7 = i13 ? 0 : i7;
 i13 = i11 + 40 | 0;
 HEAP32[i13 >> 2] = i7;
 i13 = i10 >>> 2;
 i13 = i13 & 1;
 i7 = i5 >>> 2;
 i9 = i10 << 2;
 i9 = i9 & 8;
 i6 = i10 & 48;
 i7 = i6 | i7;
 i13 = i7 | i13;
 i9 = i13 | i9;
 i13 = i11 + 52 | 0;
 HEAP32[i13 >> 2] = i9;
 i13 = __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j(i11, i8, i10) | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function _XXH32_update(i11, i1, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = i1 + i3 | 0;
 i10 = i11;
 i10 = _i64Add(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, i3 | 0, 0) | 0;
 i2 = getTempRet0() | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i2;
 i12 = i11 + 44 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + i3 | 0) >>> 0 < 16) {
  _memcpy(i11 + 28 + i2 | 0, i1 | 0, i3 | 0) | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
  return 0;
 }
 if (i2) {
  i10 = i11 + 28 | 0;
  _memcpy(i10 + i2 | 0, i1 | 0, 16 - i2 | 0) | 0;
  i9 = i11 + 12 | 0;
  i10 = (Math_imul(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24, -2048144777) | 0) + (HEAP32[i9 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = Math_imul(i10 << 13 | i10 >>> 19, -1640531535) | 0;
  i9 = i11 + 32 | 0;
  i10 = i11 + 16 | 0;
  i9 = (Math_imul(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24, -2048144777) | 0) + (HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = Math_imul(i9 << 13 | i9 >>> 19, -1640531535) | 0;
  i10 = i11 + 36 | 0;
  i9 = i11 + 20 | 0;
  i10 = (Math_imul(HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24, -2048144777) | 0) + (HEAP32[i9 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = Math_imul(i10 << 13 | i10 >>> 19, -1640531535) | 0;
  i9 = i11 + 40 | 0;
  i10 = i11 + 24 | 0;
  i9 = (Math_imul(HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24, -2048144777) | 0) + (HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = Math_imul(i9 << 13 | i9 >>> 19, -1640531535) | 0;
  i1 = i1 + (16 - (HEAP32[i12 >> 2] | 0)) | 0;
  HEAP32[i12 >> 2] = 0;
 }
 i6 = i13 + -16 | 0;
 if (i1 >>> 0 <= i6 >>> 0) {
  i7 = i11 + 12 | 0;
  i8 = i11 + 16 | 0;
  i9 = i11 + 20 | 0;
  i10 = i11 + 24 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  do {
   i14 = (Math_imul(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24, -2048144777) | 0) + i3 | 0;
   i3 = Math_imul(i14 << 13 | i14 >>> 19, -1640531535) | 0;
   i14 = i1 + 4 | 0;
   i14 = (Math_imul(HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24, -2048144777) | 0) + i5 | 0;
   i5 = Math_imul(i14 << 13 | i14 >>> 19, -1640531535) | 0;
   i14 = i1 + 8 | 0;
   i14 = (Math_imul(HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24, -2048144777) | 0) + i4 | 0;
   i4 = Math_imul(i14 << 13 | i14 >>> 19, -1640531535) | 0;
   i14 = i1 + 12 | 0;
   i14 = (Math_imul(HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8 | HEAPU8[i14 + 2 >> 0] << 16 | HEAPU8[i14 + 3 >> 0] << 24, -2048144777) | 0) + i2 | 0;
   i2 = Math_imul(i14 << 13 | i14 >>> 19, -1640531535) | 0;
   i1 = i1 + 16 | 0;
  } while (i1 >>> 0 <= i6 >>> 0);
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i2;
 }
 if (i1 >>> 0 >= i13 >>> 0) return 0;
 i14 = i13 - i1 | 0;
 _memcpy(i11 + 28 | 0, i1 | 0, i14 | 0) | 0;
 HEAP32[i12 >> 2] = i14;
 return 0;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15setActorSimFlagEb(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i8 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i11) | 0;
 i5 = i11 + 4 | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
 i1 = HEAP32[i11 + (i3 + 4) >> 2] | 0;
 i1 = HEAP16[((i1 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + (i11 + i3) + 8 | 0 : HEAP32[i11 + (i3 + 8) >> 2] | 0) >> 1] | 0;
 i6 = i1 & 65535;
 i2 = (i6 & 8 | 0) != 0;
 if (i4 | i2 ^ 1) {
  if (i2 | i4 ^ 1) {
   STACKTOP = i12;
   return;
  }
  if (i8) {
   __ZN5physx7NpActor26removeConstraintsFromSceneEv(i11 + 12 | 0);
   i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  }
  i6 = (i6 | 8) & 65535;
  i7 = i11 + i3 | 0;
  i8 = i11 + (i3 + 4) | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i5 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i5 << 2) >> 2] | 0) + i7 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i4 = i7;
    i9 = 19;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 18; else {
     i4 = i7;
     i9 = 19;
    }
    break;
   }
  default:
   i9 = 18;
  }
  if ((i9 | 0) == 18) {
   HEAP16[i10 >> 1] = i6;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 19) {
   i2 = i11 + (i3 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i6;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i7);
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
  }
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 252 >> 2] | 0, i11 | 0);
  STACKTOP = i12;
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 256 >> 2] | 0, i11 | 0);
  i7 = i1 & -9;
  i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  i5 = i11 + i2 | 0;
  i6 = i11 + (i2 + 4) | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i4 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i4 << 2) >> 2] | 0) + i5 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i3 = i5;
    i9 = 6;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 5; else {
     i3 = i5;
     i9 = 6;
    }
    break;
   }
  default:
   i9 = 5;
  }
  if ((i9 | 0) == 5) {
   HEAP16[i10 >> 1] = i7;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 6) {
   i2 = i11 + (i2 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i7;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
  }
  if (!i8) {
   STACKTOP = i12;
   return;
  }
  if (!(HEAP32[i11 + 16 >> 2] | 0)) {
   STACKTOP = i12;
   return;
  }
  __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i11 + 12 | 0);
  STACKTOP = i12;
  return;
 }
}

function __ZN13ConstantForce8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEm(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEl(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEj(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEi(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEb(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiii(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN22VertexDeclarationCache6CommitEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i20 + 8 | 0;
 i14 = i20;
 i15 = i8 + 20 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i16 = i8 + 24 | 0;
 if ((i1 | 0) == (i16 | 0)) {
  i19 = HEAP32[i16 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i15, i19);
  i19 = i8 + 32 | 0;
  HEAP32[i19 >> 2] = 0;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i16 >> 2] = 0;
  STACKTOP = i20;
  return;
 }
 i17 = i8 + 4 | 0;
 i18 = i8 + 8 | 0;
 i19 = i18;
 i10 = i8 + 12 | 0;
 i11 = i9 + 4 | 0;
 i12 = i8 + 8 | 0;
 i13 = i8 + 16 | 0;
 while (1) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   }
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  i5 = i1 + 16 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i18;
   i7 = i19;
   i4 = i18;
  } else {
   while (1) {
    i3 = i1 + 16 | 0;
    if (__ZNK18VertexChannelsInfoltERKS_(i5, i3) | 0) {
     i3 = HEAP32[i1 >> 2] | 0;
     if (!i3) {
      i3 = 10;
      break;
     } else i1 = i3;
    } else {
     if (!(__ZNK18VertexChannelsInfoltERKS_(i3, i5) | 0)) {
      i3 = 15;
      break;
     }
     i4 = i1 + 4 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i3 = 14;
      break;
     } else i1 = i3;
    }
   }
   if ((i3 | 0) == 10) {
    HEAP32[i14 >> 2] = i1;
    i7 = i1;
    i4 = i1;
    break;
   } else if ((i3 | 0) == 14) {
    HEAP32[i14 >> 2] = i1;
    i7 = i1;
    break;
   } else if ((i3 | 0) == 15) {
    HEAP32[i14 >> 2] = i1;
    i7 = i1;
    i4 = i14;
    break;
   }
  } while (0);
  if (!(HEAP32[i4 >> 2] | 0)) {
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i9 >> 2] = 14;
   HEAP32[i11 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   i6 = i1 + 16 | 0;
   i3 = i5;
   i5 = i6 + 36 | 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    i6 = i6 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i6 | 0) < (i5 | 0));
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i7;
   HEAP32[i4 >> 2] = i1;
   i3 = HEAP32[HEAP32[i17 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i17 >> 2] = i3;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i1);
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  }
  if ((i2 | 0) == (i16 | 0)) break; else i1 = i2;
 }
 i19 = HEAP32[i16 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i15, i19);
 i19 = i8 + 32 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZL11SweepBoxBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, i24 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i12 + 80 | 0;
 i16 = i12 + 48 | 0;
 i15 = i12 + 32 | 0;
 i14 = i12;
 i11 = i12 + 96 | 0;
 i13 = i12 + 144 | 0;
 HEAP32[i17 >> 2] = 3;
 i24 = i4 + 40 | 0;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAPF32[i16 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 3;
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 60 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i3 = i11 + 16 | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i11, i13, Math_fround(0.0)) | 0)) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i24 = 0;
  STACKTOP = i12;
  return i24 | 0;
 }
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i10 + 40 >> 2] = -1;
 HEAP32[i10 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i10 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
 HEAPF64[i10 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
 HEAPF64[i10 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i24 = 1;
 STACKTOP = i12;
 return i24 | 0;
}

function __ZN14CachingManager15ClearTempFolderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 36 | 0;
 i5 = i8 + 24 | 0;
 i6 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 444379 | 0, 4);
 __Z20GetPlatformCachePathv(i3);
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i3); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i3, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (!(__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i6, i3, 0, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (i2) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i2 = i1;
   while (1) {
    i1 = i2 + 16 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 444372 | 0, 6);
    __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i1, i7);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    if (__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) {
     if (!(__Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0)) i9 = 10;
    } else i9 = 10;
    if ((i9 | 0) == 10) {
     i9 = 0;
     __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i3, HEAP32[i4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __Z20ConvertContactToMonoP9Collision(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16;
 i14 = i1 + 4 | 0;
 if (!(HEAP8[i14 >> 0] | 0)) {
  i13 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 12 >> 2] | 0) | 0;
  i9 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 20 >> 2] | 0) | 0;
  f10 = Math_fround(-Math_fround(HEAPF32[i1 + 48 >> 2]));
  f11 = Math_fround(-Math_fround(HEAPF32[i1 + 52 >> 2]));
  f12 = Math_fround(-Math_fround(HEAPF32[i1 + 56 >> 2]));
 } else {
  i13 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 8 >> 2] | 0) | 0;
  i9 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 16 >> 2] | 0) | 0;
  f10 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f12 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 }
 i15 = i1 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i15 = HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 4 >> 2] | 0;
 i15 = __Z19scripting_array_newP11Il2CppClassjj(i15, 36, HEAP32[i1 + 68 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 i7 = i1 + 60 | 0;
 i1 = i2;
 if ((i1 | 0) != (i7 | 0)) {
  i6 = 0;
  while (1) {
   i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i15, i6, 36) | 0;
   i4 = i2 + 8 | 0;
   i3 = i2 + 16 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i5 + 32 >> 2] = HEAP32[i2 + 40 >> 2];
   if (!(HEAP8[i14 >> 0] | 0)) {
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i5 + 24 >> 2] = i3;
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i5 + 28 >> 2] = i3;
    i5 = i5 + 12 | 0;
    i4 = i2 + 28 | 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   } else {
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i5 + 24 >> 2] = i3;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i5 + 28 >> 2] = i3;
    f19 = Math_fround(-Math_fround(HEAPF32[i2 + 28 >> 2]));
    f18 = Math_fround(-Math_fround(HEAPF32[i2 + 32 >> 2]));
    f17 = Math_fround(-Math_fround(HEAPF32[i2 + 36 >> 2]));
    HEAPF32[i5 + 12 >> 2] = f19;
    HEAPF32[i5 + 16 >> 2] = f18;
    HEAPF32[i5 + 20 >> 2] = f17;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
   if ((i1 | 0) == (i7 | 0)) break; else i6 = i6 + 1 | 0;
  }
 }
 i14 = _il2cpp_object_new(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) >> 2] | 0) | 0;
 i7 = i14 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAPF32[i14 + 20 >> 2] = f10;
 HEAPF32[i14 + 24 >> 2] = f11;
 HEAPF32[i14 + 28 >> 2] = f12;
 HEAP32[i14 + 32 >> 2] = i13;
 HEAP32[i14 + 36 >> 2] = i9;
 HEAP32[i14 + 40 >> 2] = i15;
 STACKTOP = i16;
 return i14 | 0;
}

function __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i9, i5, i10) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12;
 i8 = i5;
 i11 = i10;
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i12;
  return;
 }
 i7 = i9 + 12 | 0;
 i2 = i9 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i6 = 14;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i5 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i6 = 7;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i6 = 13;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i6 = 11;
     break;
    } else i1 = i2;
   }
  }
  if ((i6 | 0) == 7) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i2 = i1;
   i6 = 14;
   break;
  } else if ((i6 | 0) == 11) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i2 = i4;
   i6 = 14;
   break;
  } else if ((i6 | 0) == 13) {
   HEAP32[i3 >> 2] = i1;
   if (!i1) {
    i5 = i1;
    i2 = i3;
    i6 = 14;
    break;
   } else {
    i8 = i1;
    break;
   }
  }
 } while (0);
 if ((i6 | 0) == 14) {
  i4 = __Znwj(32) | 0;
  HEAP32[i4 + 16 >> 2] = i8;
  i1 = i4 + 24 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 28 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (!i1) i1 = i4; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 16 >> 2] | 0, i1);
  i8 = i9 + 20 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i8 = i4;
 }
 i7 = i8 + 20 | 0;
 i2 = i8 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i10 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i6 = 20;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i10 >>> 0) {
     i6 = 25;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i6 = 24;
     break;
    } else i1 = i2;
   }
  }
  if ((i6 | 0) == 20) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i6 | 0) == 24) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i6 | 0) == 25) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = i11;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 24 >> 2] | 0, i1);
  i11 = i8 + 28 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 STACKTOP = i12;
 return;
}

function __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 118 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 116 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 104 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 117 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i8 + 108 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i8 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_(i6, i7, i8, i9, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i5 = f4 < Math_fround(HEAPF32[i6 >> 2]);
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 i1 = f2 < f4;
 do if (i5) {
  i3 = i6;
  i5 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (i1) {
   i11 = i8;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i1 = i6;
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 4 >> 2] = i10;
   i1 = i8;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = 1;
   f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
  i1 = i7;
  i10 = HEAP32[i1 + 4 >> 2] | 0;
  i11 = i6;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i11 = i7;
  HEAP32[i11 >> 2] = i5;
  HEAP32[i11 + 4 >> 2] = i3;
  f2 = Math_fround(HEAPF32[i8 >> 2]);
  f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f2 < f4) {
   i10 = i8;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i7;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i11;
   i1 = i8;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = 2;
   f2 = f4;
  } else i1 = 1;
 } else if (i1) {
  i5 = i7;
  i10 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i8;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i11 = i7;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = i3;
  i11 = i8;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i11 + 4 >> 2] = i5;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  i11 = f2 < Math_fround(HEAPF32[i6 >> 2]);
  f2 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (i11) {
   i11 = i6;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i7;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i1 = i6;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i7;
   HEAP32[i1 >> 2] = i10;
   HEAP32[i1 + 4 >> 2] = i11;
   i1 = 2;
   f2 = Math_fround(HEAPF32[i8 >> 2]);
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(Math_fround(HEAPF32[i9 >> 2]) < f2)) {
  i11 = i1;
  return i11 | 0;
 }
 i10 = i8;
 i5 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i9;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = i3;
 i11 = i9;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i11 + 4 >> 2] = i10;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(f4 < Math_fround(HEAPF32[i7 >> 2]))) {
  i12 = i1 + 1 | 0;
  return i12 | 0;
 }
 i11 = i7;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i8;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i7;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i8;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f4 < Math_fround(HEAPF32[i6 >> 2]))) {
  i12 = i1 + 2 | 0;
  return i12 | 0;
 }
 i11 = i6;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i7;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i7;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i1 + 3 | 0;
 return i12 | 0;
}

function __ZN5physx5cloth8SwSolver22CpuClothSimulationTask7releaseEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 48 | 0;
 i5 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i5 + 284 | 0;
 i2 = i5 + 288 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i8 = i5 + 272 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 276 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i2 >> 2] = i8;
  i8 = i5 + 280 | 0;
  i3 = i5 + 292 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i4);
 }
 i1 = i5 + 320 | 0;
 i2 = i5 + 324 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i9 = i5 + 308 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i8;
  i8 = i5 + 312 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i2 >> 2] = i9;
  i3 = i5 + 316 | 0;
  i9 = i5 + 328 | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i8;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i4);
 }
 i1 = i5 + 368 | 0;
 i2 = i5 + 372 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i5 + 356 | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 360 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i4 = i5 + 364 | 0;
  i9 = i5 + 376 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i8;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i7 + 32 | 0);
 }
 i1 = i5 + 404 | 0;
 i2 = i5 + 408 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i5 + 392 | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i9;
  i9 = i5 + 396 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i4 = i5 + 400 | 0;
  i9 = i5 + 412 | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i8;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i7 + 16 | 0);
 }
 i1 = i5 + 428 | 0;
 i2 = i5 + 432 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i9 = i6 + 24 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i8 = i8 + 20 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vi(i8 | 0, i9 | 0);
  STACKTOP = i7;
  return;
 }
 i4 = i5 + 416 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i9;
 i9 = i5 + 420 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i4;
 i4 = i5 + 424 | 0;
 i9 = i5 + 436 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i8;
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i1, 0, i7);
 i9 = i6 + 24 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i8 = i8 + 20 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vi(i8 | 0, i9 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15setActorSimFlagEb(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i8 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i11) | 0;
 i5 = i11 + 4 | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
 i1 = HEAP32[i11 + (i3 + 4) >> 2] | 0;
 i1 = HEAP16[((i1 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + (i11 + i3) + 8 | 0 : HEAP32[i11 + (i3 + 8) >> 2] | 0) >> 1] | 0;
 i6 = i1 & 65535;
 i2 = (i6 & 8 | 0) != 0;
 if (i4 | i2 ^ 1) {
  if (i2 | i4 ^ 1) {
   STACKTOP = i12;
   return;
  }
  if (i8) {
   __ZN5physx7NpActor26removeConstraintsFromSceneEv(i11 + 12 | 0);
   i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  }
  i6 = (i6 | 8) & 65535;
  i7 = i11 + i3 | 0;
  i8 = i11 + (i3 + 4) | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i5 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i5 << 2) >> 2] | 0) + i7 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i4 = i7;
    i9 = 19;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 18; else {
     i4 = i7;
     i9 = 19;
    }
    break;
   }
  default:
   i9 = 18;
  }
  if ((i9 | 0) == 18) {
   HEAP16[i10 >> 1] = i6;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 19) {
   i2 = i11 + (i3 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i6;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i7);
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
  }
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 320 >> 2] | 0, i11 | 0);
  STACKTOP = i12;
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 324 >> 2] | 0, i11 | 0);
  i7 = i1 & -9;
  i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  i5 = i11 + i2 | 0;
  i6 = i11 + (i2 + 4) | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i4 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i4 << 2) >> 2] | 0) + i5 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i3 = i5;
    i9 = 6;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 5; else {
     i3 = i5;
     i9 = 6;
    }
    break;
   }
  default:
   i9 = 5;
  }
  if ((i9 | 0) == 5) {
   HEAP16[i10 >> 1] = i7;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 6) {
   i2 = i11 + (i2 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i7;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
  }
  if (!i8) {
   STACKTOP = i12;
   return;
  }
  if (!(HEAP32[i11 + 16 >> 2] | 0)) {
   STACKTOP = i12;
   return;
  }
  __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i11 + 12 | 0);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15setActorSimFlagEb(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i8 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i11) | 0;
 i5 = i11 + 4 | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
 i1 = HEAP32[i11 + (i3 + 4) >> 2] | 0;
 i1 = HEAP16[((i1 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + (i11 + i3) + 8 | 0 : HEAP32[i11 + (i3 + 8) >> 2] | 0) >> 1] | 0;
 i6 = i1 & 65535;
 i2 = (i6 & 8 | 0) != 0;
 if (i4 | i2 ^ 1) {
  if (i2 | i4 ^ 1) {
   STACKTOP = i12;
   return;
  }
  if (i8) {
   __ZN5physx7NpActor26removeConstraintsFromSceneEv(i11 + 12 | 0);
   i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  }
  i6 = (i6 | 8) & 65535;
  i7 = i11 + i3 | 0;
  i8 = i11 + (i3 + 4) | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i5 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i5 << 2) >> 2] | 0) + i7 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i4 = i7;
    i9 = 19;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 18; else {
     i4 = i7;
     i9 = 19;
    }
    break;
   }
  default:
   i9 = 18;
  }
  if ((i9 | 0) == 18) {
   HEAP16[i10 >> 1] = i6;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 19) {
   i2 = i11 + (i3 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i6;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i7);
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
  }
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 132 >> 2] | 0, i11 | 0);
  STACKTOP = i12;
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 136 >> 2] | 0, i11 | 0);
  i7 = i1 & -9;
  i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 >> 1] << 2) >> 2] | 0;
  i5 = i11 + i2 | 0;
  i6 = i11 + (i2 + 4) | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i4 = i9 >>> 24 & 15;
  i1 = (HEAP32[gb + 90260 + 24 + (i4 << 2) >> 2] | 0) + i5 | 0;
  switch (i9 >>> 30 | 0) {
  case 3:
   {
    i3 = i5;
    i9 = 6;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i9 = 5; else {
     i3 = i5;
     i9 = 6;
    }
    break;
   }
  default:
   i9 = 5;
  }
  if ((i9 | 0) == 5) {
   HEAP16[i10 >> 1] = i7;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i10);
  } else if ((i9 | 0) == 6) {
   i2 = i11 + (i2 + 8) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   HEAP16[i1 >> 1] = i7;
   __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
  }
  if (!i8) {
   STACKTOP = i12;
   return;
  }
  if (!(HEAP32[i11 + 16 >> 2] | 0)) {
   STACKTOP = i12;
   return;
  }
  __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i11 + 12 | 0);
  STACKTOP = i12;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E5clearEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i7 = i13 + 52 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = i13 + 56 | 0;
 L1 : do if (i2 | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4 | 0) {
   i5 = i14 + 4 | 0;
   i1 = 0;
   while (1) {
    i3 = i2 + (i1 * 20 | 0) | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i3 >> 2] | 0;
     i11 = HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] | 0;
     HEAP32[i14 >> 2] = 54;
     HEAP32[i5 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i14);
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) break L1;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
 } while (0);
 HEAP32[i6 >> 2] = 32;
 HEAP32[i13 + 68 >> 2] = 16;
 HEAP32[i13 + 64 >> 2] = 6;
 HEAP8[i13 + 72 >> 0] = 0;
 i1 = i13 + 76 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 54;
 HEAP32[i14 + 4 >> 2] = i3;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(640, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i12 = HEAP32[i1 >> 2] | 0;
  HEAP32[i14 >> 2] = 54;
  HEAP32[i14 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i14);
 }
 HEAP32[i7 >> 2] = i3;
 i6 = i3 + ((HEAP32[i6 >> 2] | 0) * 20 | 0) | 0;
 i7 = i13 + 32 | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i15 = i13 + 60 | 0;
  HEAP32[i15 >> 2] = 0;
  i15 = i13 + 4 | 0;
  HEAP32[i15 >> 2] = 0;
  STACKTOP = i16;
  return;
 }
 i8 = i13 + 44 | 0;
 i9 = i7 + 11 | 0;
 i10 = i13 + 36 | 0;
 i11 = i14 + 4 | 0;
 i12 = i13 + 48 | 0;
 do {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i2 = i3 + 12 | 0;
  HEAP32[i2 >> 2] = i1;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
    i1 = HEAP32[i2 >> 2] | 0;
    i15 = 17;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i3 + 11 >> 0] = i5;
    if (!i5) i1 = i3; else {
     i1 = i3;
     i15 = 19;
    }
   } else i15 = 17;
   if ((i15 | 0) == 17) {
    i2 = i5 + 16 & -16;
    HEAP32[i14 >> 2] = 54;
    HEAP32[i11 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i3 + 8 >> 2] = i2 | -2147483648;
    HEAP32[i3 + 4 >> 2] = i5;
    i15 = 19;
   }
   if ((i15 | 0) == 19) {
    i15 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
  } else {
   HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
  HEAP32[i3 + 16 >> 2] = HEAP32[i12 >> 2];
  i3 = i3 + 20 | 0;
 } while ((i3 | 0) != (i6 | 0));
 i15 = i13 + 60 | 0;
 HEAP32[i15 >> 2] = 0;
 i15 = i13 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN5physx24NpPtrTableStorageManagerD0Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i6 >> 2] = gb + 146776 + 8;
 if (HEAP32[i6 + 880 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i6 + 600 | 0);
 i3 = i6 + 864 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 + 868 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 872 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 604 | 0) == (i1 | 0)) {
   HEAP8[i6 + 860 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 584 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i6 + 304 | 0);
 i3 = i6 + 568 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 572 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 576 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 308 | 0) == (i1 | 0)) {
   HEAP8[i6 + 564 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i6 + 288 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i6 + 8 | 0);
 i3 = i6 + 272 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i6 + 276 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i8 = HEAP32[i6 + 280 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i6 + 12 | 0) == (i1 | 0)) {
   HEAP8[i6 + 268 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } while (0);
 i1 = i6 + 4 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i6);
  STACKTOP = i7;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i6);
 STACKTOP = i7;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 4 | 0;
 i4 = i13;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = (i8 - i1 | 0) / 132 | 0;
 HEAP32[i4 >> 2] = i5;
 i10 = i14 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i14 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 40 | 0, i14);
  i7 = i1 + 16 | 0;
  i2 = i7 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i9 = i1 + 20 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
  HEAP32[i12 >> 2] = i4;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i10 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i7 >> 2] | 0 : i7;
  i9 = i4 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
  i4 = i2 + i9 | 0;
  if (i9 | 0) do {
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i14);
  i2 = i1 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i7 = i1 + 4 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  HEAP32[i12 >> 2] = i4;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i10 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i9 = i3 << 24 >> 24 < 0;
  i2 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
  i9 = i9 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  i4 = i2 + i9 | 0;
  if (i9 | 0) do {
   i3 = HEAP32[i10 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i14);
  i2 = i1 + 32 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 36 | 0, i14);
  i1 = i1 + 132 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function __ZN17ProfilerFrameDataC2Eii(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i12 = i10;
 HEAP32[i8 >> 2] = i1;
 i4 = i8 + 200 | 0;
 i1 = gb + 63576 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 i2 = i8 + 212 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i8 + 216 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i8 + 204 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i12);
 i12 = i6;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i11;
 i5 = i8 + 220 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i8 + 232 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 _memset(i8 + 12 | 0, 0, 188) | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1);
  i1 = i5 + 11 | 0;
  i12 = (HEAP8[i1 >> 0] | 0) < 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  if (i12) {
   HEAP8[HEAP32[i5 >> 2] >> 0] = 0;
   HEAP32[i8 + 224 >> 2] = 0;
  } else i7 = 5;
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i1 = i5 + 11 | 0;
  i7 = 5;
 }
 if ((i7 | 0) == 5) {
  HEAP8[i5 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 _memset(i8 + 236 | 0, 0, 884) | 0;
 HEAP32[i8 + 1148 >> 2] = 0;
 HEAP32[i8 + 1152 >> 2] = 0;
 HEAP32[i8 + 1164 >> 2] = 0;
 HEAP32[i8 + 1168 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i3 = i6;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i8 + 1156 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i8 + 1172 >> 2] = 0;
 HEAP32[i8 + 1184 >> 2] = 0;
 HEAP32[i8 + 1188 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i11 = i6;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i8 + 1176 | 0;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 HEAP32[i8 + 1192 >> 2] = 0;
 HEAP32[i8 + 1204 >> 2] = 0;
 HEAP32[i8 + 1208 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i3 = i6;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i8 + 1196 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i8 + 1212 >> 2] = 0;
 HEAP32[i8 + 1224 >> 2] = 0;
 HEAP32[i8 + 1228 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i11 = i6;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i8 + 1216 | 0;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 i3 = i9 * 144 | 0;
 i3 = __Znaj(i9 >>> 0 > 29826161 | i3 >>> 0 > 4294967291 ? -1 : i3 + 4 | 0) | 0;
 HEAP32[i3 >> 2] = i9;
 i3 = i3 + 4 | 0;
 if (!i9) {
  i12 = i8 + 1124 | 0;
  HEAP32[i12 >> 2] = i3;
  i12 = i8 + 1128 | 0;
  HEAP32[i12 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
 i1 = i3 + (i9 * 144 | 0) | 0;
 i2 = i3;
 do {
  __ZN17ProfilerFrameData10ThreadDataC2Ev(i2);
  i2 = i2 + 144 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i12 = i8 + 1124 | 0;
 HEAP32[i12 >> 2] = i3;
 i12 = i8 + 1128 | 0;
 HEAP32[i12 >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __ZN15RaycastCallback14processTouchesEPKN5physx12PxRaycastHitEj(i1, i25, i26) {
 i1 = i1 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i29 + 48 | 0;
 i28 = i29;
 i24 = i1 + 84 | 0;
 i23 = HEAP32[i24 >> 2] | 0;
 __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE7reserveEj(i23, (((HEAP32[i23 + 4 >> 2] | 0) - (HEAP32[i23 >> 2] | 0) | 0) / 44 | 0) + i26 | 0);
 if (!i26) {
  STACKTOP = i29;
  return 1;
 }
 i5 = i28 + 40 | 0;
 i6 = i28 + 12 | 0;
 i7 = i27 + 4 | 0;
 i8 = i27 + 8 | 0;
 i9 = i27 + 12 | 0;
 i10 = i27 + 16 | 0;
 i11 = i27 + 20 | 0;
 i12 = i27 + 24 | 0;
 i13 = i27 + 28 | 0;
 i14 = i27 + 32 | 0;
 i15 = i27 + 36 | 0;
 i16 = i28 + 24 | 0;
 i17 = i28 + 28 | 0;
 i18 = i28 + 32 | 0;
 i19 = i28 + 36 | 0;
 i20 = i28 + 4 | 0;
 i21 = i28 + 8 | 0;
 i22 = i28 + 16 | 0;
 i23 = i28 + 20 | 0;
 i4 = 0;
 do {
  i3 = HEAP32[i25 + (i4 << 6) + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 + 8 >> 2];
  i2 = i25 + (i4 << 6) + 16 | 0;
  HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i28 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i28 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i25 + (i4 << 6) + 28 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i27 >> 2] = 5;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  HEAPF32[i11 >> 2] = Math_fround(0.0);
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  i2 = i14;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i27 | 0) | 0) {
   i1 = HEAP32[i15 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i1 + (HEAP32[i25 + (i4 << 6) + 8 >> 2] << 2) >> 2] | 0;
  } else i1 = -1;
  HEAP32[i16 >> 2] = i1;
  HEAP32[i17 >> 2] = HEAP32[i25 + (i4 << 6) + 40 >> 2];
  HEAP32[i18 >> 2] = HEAP32[i25 + (i4 << 6) + 44 >> 2];
  HEAP32[i19 >> 2] = HEAP32[i25 + (i4 << 6) + 48 >> 2];
  i1 = HEAP32[i24 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i1, i28); else {
   HEAP32[i3 >> 2] = HEAP32[i28 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i21 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i22 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i23 >> 2];
   i31 = i16;
   i30 = HEAP32[i31 + 4 >> 2] | 0;
   i1 = i3 + 24 | 0;
   HEAP32[i1 >> 2] = HEAP32[i31 >> 2];
   HEAP32[i1 + 4 >> 2] = i30;
   HEAP32[i3 + 32 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i3 + 36 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i3 + 40 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 44;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i26 | 0));
 STACKTOP = i29;
 return 1;
}

function _UNITY_png_read_start_row(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 _UNITY_png_init_read_transformations(i8);
 i7 = i8 + 428 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = i6 >>> 8 & 255;
 i5 = i6 >>> 24 & 255;
 if (!((i6 & 255) << 24 >> 24)) {
  HEAP32[i8 + 352 >> 2] = HEAP32[i8 + 348 >> 2];
  i6 = HEAP32[i8 + 344 >> 2] | 0;
  HEAP32[i8 + 364 >> 2] = i6;
  i2 = i8 + 212 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i8 + 212 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i8 + 348 >> 2] | 0;
  HEAP32[i8 + 352 >> 2] = (i2 & 2 | 0) == 0 ? (i6 + 7 | 0) >>> 3 : i6;
  i6 = HEAP32[i8 + 344 >> 2] | 0;
  i4 = HEAPU8[gb + 353251 + i1 >> 0] | 0;
  HEAP32[i8 + 364 >> 2] = ((i6 + -1 + i4 - (HEAPU8[gb + 353258 + i1 >> 0] | 0) | 0) >>> 0) / (i4 >>> 0) | 0;
 }
 i1 = HEAPU8[i8 + 434 >> 0] | 0;
 if (i2 & 4) i1 = (HEAPU8[i8 + 432 >> 0] | 0) < 8 ? 8 : i1;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = (i4 & 4096 | 0) == 0;
 L8 : do if (!i3) switch (i5 << 24 >> 24) {
 case 3:
  {
   i1 = (HEAP16[i8 + 424 >> 1] | 0) == 0 ? 24 : 32;
   break L8;
  }
 case 0:
  {
   i1 = (i1 >>> 0 < 8 ? 8 : i1) << ((HEAP16[i8 + 424 >> 1] | 0) != 0 & 1);
   break L8;
  }
 case 2:
  {
   if (!(HEAP16[i8 + 424 >> 1] | 0)) break L8;
   i1 = (i1 << 2 >>> 0) / 3 | 0;
   break L8;
  }
 default:
  break L8;
 } while (0);
 i2 = (i4 & 32768 | 0) == 0;
 L16 : do if (!i2) switch (i5 << 24 >> 24) {
 case 0:
  {
   i1 = (i1 | 0) < 9 ? 16 : 32;
   break L16;
  }
 case 3:
 case 2:
  {
   i1 = (i1 | 0) < 33 ? 32 : 64;
   break L16;
  }
 default:
  break L16;
 } while (0);
 do if (i4 & 16384) {
  if (i5 << 24 >> 24 == 4 | i2 & (i3 | (HEAP16[i8 + 424 >> 1] | 0) == 0) ^ 1) {
   i1 = (i1 | 0) < 17 ? 32 : 64;
   break;
  }
  i2 = i5 << 24 >> 24 == 6;
  if ((i1 | 0) < 9) {
   i1 = i2 ? 32 : 24;
   break;
  } else {
   i1 = i2 ? 64 : 48;
   break;
  }
 } while (0);
 if (i4 & 1048576) {
  i5 = HEAP16[i8 + 200 >> 1] | 0;
  i5 = Math_imul((i5 & 65535) >>> 8 & 65535, i5 & 255) | 0;
  i1 = (i5 | 0) > (i1 | 0) ? i5 : i1;
 }
 HEAP8[i8 + 438 >> 0] = i1;
 HEAP8[i8 + 439 >> 0] = 0;
 i5 = i6 + 7 & -8;
 i2 = Math_imul(i5, i1 >>> 3) | 0;
 i5 = (Math_imul(i5, i1) | 0) >>> 3;
 i5 = (i1 + 7 >> 3) + 49 + ((i1 | 0) > 7 ? i2 : i5) | 0;
 i2 = i8 + 640 | 0;
 if (i5 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i3 = i8 + 616 | 0;
  _UNITY_png_free(i8, HEAP32[i3 >> 2] | 0);
  i4 = i8 + 660 | 0;
  _UNITY_png_free(i8, HEAP32[i4 >> 2] | 0);
  if (!(HEAP8[i7 >> 0] | 0)) i1 = _UNITY_png_malloc(i8, i5) | 0; else i1 = _UNITY_png_calloc(i8, i5) | 0;
  HEAP32[i3 >> 2] = i1;
  i7 = _UNITY_png_malloc(i8, i5) | 0;
  HEAP32[i4 >> 2] = i7;
  i6 = (HEAP32[i3 >> 2] | 0) + 32 | 0;
  HEAP32[i8 + 380 >> 2] = i6 + (0 - (i6 & 15)) + -1;
  i7 = i7 + 32 | 0;
  HEAP32[i8 + 376 >> 2] = i7 + (0 - (i7 & 15)) + -1;
  HEAP32[i2 >> 2] = i5;
 }
 i1 = HEAP32[i8 + 360 >> 2] | 0;
 if ((i1 | 0) == -1) _UNITY_png_error(i8, gb + 353265 | 0);
 _memset(HEAP32[i8 + 376 >> 2] | 0, 0, i1 + 1 | 0) | 0;
 i1 = i8 + 644 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i8 + 648 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  _UNITY_png_free(i8, i2);
 }
 if (!(_UNITY_png_inflate_claim(i8, 1229209940) | 0)) {
  i8 = i8 + 208 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 64;
  return;
 } else _UNITY_png_error(i8, HEAP32[i8 + 244 >> 2] | 0);
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEe(i11, d5) {
 i11 = i11 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, +d5) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEd(i11, d5) {
 i11 = i11 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i9 | 0, i11 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 19;
 } else {
  do if (HEAP8[i9 >> 0] | 0) {
   HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
   __THREW__ = 0;
   i6 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474620 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__26localeD2Ev(i4);
   } else {
    __ZNSt3__26localeD2Ev(i4);
    i2 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    i8 = HEAP32[i2 + 24 >> 2] | 0;
    i3 = i2 + 76 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    do if ((i1 | 0) == -1) {
     HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
     __THREW__ = 0;
     i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) {
       __ZNSt3__26localeD2Ev(i4);
       HEAP32[i3 >> 2] = i1;
       i10 = 10;
       break;
      }
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
    } else i10 = 10; while (0);
    if ((i10 | 0) == 10) {
     i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0;
     HEAP32[i7 >> 2] = i8;
     __THREW__ = 0;
     HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
     i1 = invoke_iiiiid(i13 | 0, i6 | 0, i4 | 0, i2 | 0, i1 | 0, +d5) | 0;
     i13 = __THREW__;
     __THREW__ = 0;
     if (!(i13 & 1)) {
      if (i1 | 0) break;
      i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
      __THREW__ = 0;
      invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | 5 | 0);
      i13 = __THREW__;
      __THREW__ = 0;
      if (!(i13 & 1)) break;
     }
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
    }
   }
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
   i2 = i11;
   i3 = i11;
   i10 = 19;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i9);
 } while (0);
 do if ((i10 | 0) == 19) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN6Sprite8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 32 | 0, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 56 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 148 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx7profile14parseEventDataILb1ENS0_17MemoryEventParserILb1EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_(i13, i2, i1, i12) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 32 | 0;
 i11 = i15 + 24 | 0;
 i10 = i15;
 i14 = i15 + 48 | 0;
 i1 = (i2 | 0) == 0 ? 0 : i1;
 i7 = i13 + 48 | 0;
 HEAP32[i7 >> 2] = i2;
 i2 = i13 + 52 | 0;
 HEAP32[i2 >> 2] = i1;
 i8 = i13 + 56 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP16[i14 >> 1] = 16368;
 if (!i1) {
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i14 + 1 | 0;
 i4 = i13 + 48 | 0;
 i5 = i12 + 131072 | 0;
 i6 = i12 + 131076 | 0;
 L4 : while (1) {
  if (i1 >>> 0 < 2) {
   i2 = 4;
   break;
  }
  i18 = HEAP32[i7 >> 2] | 0;
  i16 = HEAP8[i18 >> 0] | 0;
  i17 = i18 + 1 | 0;
  HEAP32[i7 >> 2] = i17;
  HEAP32[i2 >> 2] = i1 + -1;
  i17 = HEAP8[i17 >> 0] | 0;
  HEAP32[i7 >> 2] = i18 + 2;
  HEAP32[i2 >> 2] = i1 + -2;
  HEAP8[i14 >> 0] = i17;
  HEAP8[i3 >> 0] = i16;
  i1 = HEAPU16[i14 >> 1] | 0;
  switch (i1 & 15 | 0) {
  case 1:
   {
    __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_(i13, i10, i14, i12);
    if (HEAP8[i8 >> 0] | 0) {
     i2 = 12;
     break L4;
    }
    break;
   }
  case 2:
   {
    __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_(i13, i10, i14, i12);
    if (HEAP8[i8 >> 0] | 0) {
     i2 = 12;
     break L4;
    }
    break;
   }
  case 3:
   {
    __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 773712 | 0, i11, i1 >>> 4 & 3);
    i16 = i11;
    i1 = HEAP32[i16 >> 2] | 0;
    i16 = HEAP32[i16 + 4 >> 2] | 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    i18 = HEAP32[i5 >> 2] | 0;
    i17 = i12 + (i18 << 5) | 0;
    HEAP32[i17 >> 2] = i1;
    HEAP32[i17 + 4 >> 2] = i16;
    i17 = i12 + (i18 << 5) + 8 | 0;
    HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i17 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i17 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i17 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    HEAP32[i12 + (i18 << 5) + 24 >> 2] = 2;
    i18 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
    HEAP32[i5 >> 2] = i18;
    if ((i18 | 0) == 4096) {
     i18 = HEAP32[i6 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, i12 | 0, 4096);
     HEAP32[i5 >> 2] = 0;
    }
    if (HEAP8[i8 >> 0] | 0) {
     i2 = 12;
     break L4;
    }
    break;
   }
  case 4:
   break;
  default:
   {
    i2 = 12;
    break L4;
   }
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = 1;
   i2 = 13;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  HEAP8[i8 >> 0] = 1;
  i18 = 0;
  STACKTOP = i15;
  return i18 | 0;
 } else if ((i2 | 0) == 12) {
  HEAP8[i8 >> 0] = 1;
  i18 = 0;
  STACKTOP = i15;
  return i18 | 0;
 } else if ((i2 | 0) == 13) {
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE23buildSphereAccelerationEPKNS0_10SphereDataE(i33, i1) {
 i33 = i33 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i34 = 0, i35 = 0;
 i34 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i32 = i34 + 216 | 0;
 i4 = i34 + 208 | 0;
 i31 = i34 + 192 | 0;
 i29 = i34 + 176 | 0;
 i5 = i34 + 160 | 0;
 i11 = i34 + 144 | 0;
 i22 = i34 + 128 | 0;
 i23 = i34 + 112 | 0;
 i24 = i34 + 96 | 0;
 i30 = i34 + 80 | 0;
 i25 = i34 + 64 | 0;
 i26 = i34 + 48 | 0;
 i27 = i34 + 32 | 0;
 i28 = i34 + 16 | 0;
 i6 = i34;
 i21 = HEAP32[(HEAP32[i33 + 432 >> 2] | 0) + 152 >> 2] | 0;
 i7 = i1 + (i21 << 4) | 0;
 if (!i21) {
  STACKTOP = i34;
  return;
 }
 i8 = i33 + 384 | 0;
 i9 = i33 + 400 | 0;
 i10 = __ZN5simdi5arrayER8Scalar4f(i29) | 0;
 i12 = __ZN5simdi5arrayER8Scalar4f(i30) | 0;
 i13 = i33 + 96 | 0;
 i14 = i33 + 32 | 0;
 i15 = i33 + 128 | 0;
 i16 = i10 + 4 | 0;
 i17 = i12 + 4 | 0;
 i18 = i33 + 64 | 0;
 i19 = i33 + 160 | 0;
 i20 = i10 + 8 | 0;
 i21 = i12 + 8 | 0;
 i3 = 1;
 while (1) {
  HEAP32[i4 >> 2] = __Z11loadAlignedPKf(__ZN5physx5cloth5arrayERKNS_6PxVec3E(i1) | 0) | 0;
  __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i32, i4);
  __Z5splatILj3EE8Scalar4fRKS0_(i31, i32);
  __ZmiRK8Scalar4fS1_(i23, i32, i31);
  __ZmlRK8Scalar4fS1_(i22, i23, i8);
  __ZplRK8Scalar4fS1_(i11, i22, i9);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i24, gb + 1097776 | 0);
  __Z3maxRK8Scalar4fS1_(i5, i11, i24);
  __ZN5physx5cloth8intFloorERK8Scalar4f(i29, i5);
  __ZplRK8Scalar4fS1_(i28, i32, i31);
  __ZmlRK8Scalar4fS1_(i27, i28, i8);
  __ZplRK8Scalar4fS1_(i26, i27, i9);
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i6, gb + 1097696 | 0);
  __Z3minRK8Scalar4fS1_(i25, i26, i6);
  __ZN5physx5cloth8intFloorERK8Scalar4f(i30, i25);
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) < 8) do {
   i35 = i33 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 8);
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) > -1) while (1) {
   i35 = i13 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
  i2 = HEAP32[i16 >> 2] | 0;
  if ((i2 | 0) < 8) do {
   i35 = i14 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 8);
  i2 = HEAP32[i17 >> 2] | 0;
  if ((i2 | 0) > -1) while (1) {
   i35 = i15 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
  i2 = HEAP32[i20 >> 2] | 0;
  if ((i2 | 0) < 8) do {
   i35 = i18 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 8);
  i2 = HEAP32[i21 >> 2] | 0;
  if ((i2 | 0) > -1) while (1) {
   i35 = i19 + (i2 << 2) | 0;
   HEAP32[i35 >> 2] = HEAP32[i35 >> 2] | i3;
   if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
  }
  i1 = i1 + 16 | 0;
  if ((i1 | 0) == (i7 | 0)) break; else i3 = i3 << 1;
 }
 STACKTOP = i34;
 return;
}

function __ZN10TagManager8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i7, 2);
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 470740 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = i8 + 8 | 0;
 i1 = 0;
 do {
  i4 = i6 + 44 + (i1 << 5) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i8, i4); else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i14 = i6 + 44 + (i1 << 5) + 24 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i12 = i2 + 24 | 0;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP8[i2 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i4);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_PKc17TransferMetaFlags(i7, i8, gb + 370883 | 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 370890 | 0, HEAP32[gb + 37316 >> 2] | 0, i6 + 1068 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i1 = i8 + 24 | 0;
 i13 = gb + 63648 | 0;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i14;
 HEAP8[i8 + 4 >> 0] = 0;
 HEAP32[i8 + 32 >> 2] = 1;
 HEAP8[i8 + 36 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI17SortingLayerEntryEEvRT_17TransferMetaFlags(i7, i8, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i10 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i10 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __Z27CullLocalLightShadowCastersiibR11CullResults(i4, i17, i1, i3) {
 i4 = i4 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 4 | 0;
 i2 = i16;
 if ((HEAP16[gb + 1112888 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112888 | 0, i1);
  i12 = gb + 1112888 | 0;
 } else i12 = 0;
 if ((i4 | 0) < (i17 | 0)) {
  i14 = i3 + 360 | 0;
  i15 = i3 + 312 | 0;
  i13 = i3 + 1308 | 0;
  i11 = i3 + 8 | 0;
  do {
   i9 = HEAP32[i14 >> 2] | 0;
   i6 = HEAP32[i9 + (i4 * 960 | 0) >> 2] | 0;
   i7 = HEAP32[i15 >> 2] | 0;
   i10 = i9 + (i4 * 960 | 0) + 80 | 0;
   i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + 952 >> 2] | 0;
   _memcpy(i10 | 0, i2 | 0, 340) | 0;
   i1 = 0;
   do {
    i3 = HEAP32[i2 + 352 + (i1 << 4) + 4 >> 2] | 0;
    i5 = HEAP32[i2 + 352 + (i1 << 4) + 8 >> 2] | 0;
    i8 = HEAP32[i2 + 352 + (i1 << 4) + 12 >> 2] | 0;
    HEAP32[i9 + (i4 * 960 | 0) + 432 + (i1 << 4) >> 2] = HEAP32[i2 + 352 + (i1 << 4) >> 2];
    HEAP32[i9 + (i4 * 960 | 0) + 432 + (i1 << 4) + 4 >> 2] = i3;
    HEAP32[i9 + (i4 * 960 | 0) + 432 + (i1 << 4) + 8 >> 2] = i5;
    HEAP32[i9 + (i4 * 960 | 0) + 432 + (i1 << 4) + 12 >> 2] = i8;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 12);
   i8 = i7 + (i6 * 180 | 0) | 0;
   _memcpy(i9 + (i4 * 960 | 0) + 624 | 0, i2 + 544 | 0, 208) | 0;
   i3 = i9 + (i4 * 960 | 0) + 832 | 0;
   i1 = i2 + 752 | 0;
   i2 = i3 + 108 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   __Z34PrepareParametersCullShadowCastersRK11ActiveLightRK14ShadowCullDataR22SceneCullingParametersR13ShadowedLight(i8, HEAP32[i13 >> 2] | 0, i10, (HEAP32[i14 >> 2] | 0) + (i4 * 960 | 0) | 0);
   i5 = (HEAP32[i14 >> 2] | 0) + ((HEAP32[i7 + (i6 * 180 | 0) + 4 >> 2] | 0) * 960 | 0) + 72 | 0;
   i2 = i7 + (i6 * 180 | 0) + 136 | 0;
   i1 = 0;
   do {
    i3 = i9 + (i4 * 960 | 0) + 832 + (i1 * 12 | 0) + 8 | 0;
    if (HEAP32[i3 >> 2] | 0) {
     i6 = __ZnwjRK10MemLabelIdiPKci(232, gb + 64024 | 0, 16, gb + 384212 | 0, 489) | 0;
     HEAP32[i6 >> 2] = i10;
     HEAP32[i6 + 4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i6 + 28 >> 2] = i1;
     HEAP32[i6 + 8 >> 2] = HEAP32[i8 >> 2];
     i7 = i6 + 12 | 0;
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i6 + 32 >> 2] = (HEAP32[i14 >> 2] | 0) + (i4 * 960 | 0) + 4 + (i1 * 12 | 0);
     i7 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i6 + 36 | 0, HEAP32[i3 >> 2] | 0, 4096) | 0;
     HEAP32[i6 + 228 >> 2] = i7;
     __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i5, fb + 2386 | 0, i6, i7, i11, fb + 3335 | 0, 0);
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 5);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i17 | 0));
 }
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_mesh2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161568 | 0, gb + 429530 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161580 | 0, gb + 429548 | 0, 0, 0);
 HEAP32[gb + 1161716 >> 2] = 0;
 i3 = gb + 63160 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1161716 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1161716 + 12 >> 2] = 16;
 _strncpy(gb + 1161716 + 16 | 0, gb + 464723 | 0, 32) | 0;
 _strncpy(gb + 1161716 + 48 | 0, gb + 429570 | 0, 32) | 0;
 HEAP8[gb + 1161716 + 47 >> 0] = 0;
 HEAP8[gb + 1161716 + 79 >> 0] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3393 | 0, fb + 3394 | 0, 0, gb + 1161716 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161796 | 0, gb + 429594 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161544 | 0, gb + 429614 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161808 | 0, gb + 429643 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161556 | 0, gb + 429664 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161820 | 0, gb + 429684 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161592 | 0, gb + 429716 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161604 | 0, gb + 429739 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161616 | 0, gb + 429765 | 0, 0, 0);
 HEAP32[gb + 1161628 >> 2] = gb + 1161628;
 HEAP32[gb + 1161628 + 4 >> 2] = gb + 1161628;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161680 | 0, gb + 429796 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161692 | 0, gb + 429829 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161668 | 0, gb + 429851 | 0, 0, 0);
 HEAP32[gb + 1161704 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1161704 | 0, gb + 1046318 | 0);
 HEAP32[gb + 1161712 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1161712 | 0, gb + 1011800 | 0);
 HEAP32[gb + 1161708 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1161708 | 0, gb + 1011810 | 0);
 HEAP32[gb + 1161636 >> 2] = 13;
 HEAP32[gb + 1161636 + 4 >> 2] = 0;
 i1 = HEAP32[gb + 1161832 >> 2] | 0;
 HEAP32[gb + 1161836 + (i1 << 2) >> 2] = gb + 1161636;
 HEAP32[gb + 1161636 + 8 >> 2] = 15;
 HEAP32[gb + 1161636 + 12 >> 2] = 0;
 HEAP32[gb + 1161836 + (i1 + 1 << 2) >> 2] = gb + 1161636 + 8;
 HEAP32[gb + 1161636 + 16 >> 2] = 141;
 HEAP32[gb + 1161636 + 20 >> 2] = 0;
 HEAP32[gb + 1161836 + (i1 + 2 << 2) >> 2] = gb + 1161636 + 16;
 HEAP32[gb + 1161636 + 24 >> 2] = 143;
 HEAP32[gb + 1161636 + 28 >> 2] = 0;
 HEAP32[gb + 1161832 >> 2] = i1 + 4;
 HEAP32[gb + 1161836 + (i1 + 3 << 2) >> 2] = gb + 1161636 + 24;
 return;
}

function __ZN7mecanim9animation18ControllerConstant8TransferI14SafeBinaryReadEEvRT_(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i4 = i8;
 i5 = i7 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 4;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = i2;
 i2 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 910115 | 0, i2, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i7, i4, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 12;
 HEAP32[i4 + 4 >> 2] = i3 + 8;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 902714 | 0, i2, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i7, i4, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 901491 | 0, gb + 905830 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = HEAP32[i5 >> 2] | 0;
    i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i9 = i2;
    i1 = i1 | 0 ? i1 - i9 | 0 : 0;
    HEAP32[i2 >> 2] = i1;
    i2 = i9;
   }
   __ZN14SafeBinaryRead8TransferIN7mecanim18ValueArrayConstantEEEvRT_PKc17TransferMetaFlags(i7, i1 + i2 | 0, gb + 1041891 | 0, 0);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 902734 | 0, gb + 905830 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i5 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
   i3 = i1;
   i4 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   i9 = i2;
   i1 = i1 | 0 ? i1 - i9 | 0 : 0;
   HEAP32[i2 >> 2] = i1;
   i2 = i9;
  }
  i3 = i1 + i2 | 0;
  i1 = i3;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041891 | 0, gb + 913944 | 0, i6, 1) | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 0) __ZN7mecanim10ValueArray8TransferI14SafeBinaryReadEEvRT_(i1, i7); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN16LightmapSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 43312 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 60 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 __ZN10GISettingsC2Ev(i1 + 76 | 0);
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 124 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 184 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 204 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 224 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 25;
 i3 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 403085 | 0, 121) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 43424 + 8;
 HEAP32[i3 + 8 >> 2] = 1;
 HEAP32[i3 + 12 >> 2] = 1;
 i2 = i3 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN13RendererSceneC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i5 = i2;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i5 = i2;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i5 = i2;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1 + 104 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 124 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 i5 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i5 + 27788 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 <= 63) {
  i2 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i2;
  i3 = i5 + 27020 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i5 + 27020 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i5 = i5 + 27020 + (i4 * 12 | 0) | 0;
  HEAP32[i5 >> 2] = fb + 2379;
  i5 = i1 + 140 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP8[i5 + 12 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 __Z6FormatPKcz(i2, gb + 1048800 | 0, i6 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i4 + 1 | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i5 + 27020 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i5 + 27020 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i5 = i5 + 27020 + (i4 * 12 | 0) | 0;
 HEAP32[i5 >> 2] = fb + 2379;
 i5 = i1 + 140 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 1120 | 0;
 i8 = i11 + 1104 | 0;
 i9 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i5 = i11;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i4, i1);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i1 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, i3);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i9, i10, i5);
 i3 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i3 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i8 + 11 >> 0] = i3;
  if (!i3) i1 = i8; else {
   i1 = i8;
   i6 = 9;
  }
 } else i6 = 7;
 if ((i6 | 0) == 7) {
  i4 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i3;
  i6 = 9;
 }
 if ((i6 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZN12FileAccessorC2Ev(i9);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i10 + 11 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP8[i10 >> 0] = 100;
 HEAP8[i10 + 1 >> 0] = 0;
 i1 = __ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i8, i10, i9) | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 if (i1) __ZN12FileAccessor5CloseEv(i9) | 0;
 __ZN12FileAccessorD2Ev(i9);
 if ((HEAP8[i8 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return;
 }
 i10 = HEAP32[i8 >> 2] | 0;
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i7);
 STACKTOP = i11;
 return;
}

function _unity_z_crc32_combine(i1, i10, i6) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 128 | 0;
 i9 = i11;
 if (!i6) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = -306674912;
 HEAP32[i9 + 4 >> 2] = 1;
 HEAP32[i9 + 8 >> 2] = 2;
 HEAP32[i9 + 12 >> 2] = 4;
 HEAP32[i9 + 16 >> 2] = 8;
 HEAP32[i9 + 20 >> 2] = 16;
 HEAP32[i9 + 24 >> 2] = 32;
 HEAP32[i9 + 28 >> 2] = 64;
 HEAP32[i9 + 32 >> 2] = 128;
 HEAP32[i9 + 36 >> 2] = 256;
 HEAP32[i9 + 40 >> 2] = 512;
 HEAP32[i9 + 44 >> 2] = 1024;
 HEAP32[i9 + 48 >> 2] = 2048;
 HEAP32[i9 + 52 >> 2] = 4096;
 HEAP32[i9 + 56 >> 2] = 8192;
 HEAP32[i9 + 60 >> 2] = 16384;
 HEAP32[i9 + 64 >> 2] = 32768;
 HEAP32[i9 + 68 >> 2] = 65536;
 HEAP32[i9 + 72 >> 2] = 131072;
 HEAP32[i9 + 76 >> 2] = 262144;
 HEAP32[i9 + 80 >> 2] = 524288;
 HEAP32[i9 + 84 >> 2] = 1048576;
 HEAP32[i9 + 88 >> 2] = 2097152;
 HEAP32[i9 + 92 >> 2] = 4194304;
 HEAP32[i9 + 96 >> 2] = 8388608;
 HEAP32[i9 + 100 >> 2] = 16777216;
 HEAP32[i9 + 104 >> 2] = 33554432;
 HEAP32[i9 + 108 >> 2] = 67108864;
 HEAP32[i9 + 112 >> 2] = 134217728;
 HEAP32[i9 + 116 >> 2] = 268435456;
 HEAP32[i9 + 120 >> 2] = 536870912;
 HEAP32[i9 + 124 >> 2] = 1073741824;
 i5 = 0;
 i3 = -306674912;
 while (1) {
  if (!i3) i2 = 0; else {
   i2 = 0;
   i4 = i9;
   while (1) {
    if (i3 & 1) i2 = HEAP32[i4 >> 2] ^ i2;
    i3 = i3 >>> 1;
    if (!i3) break; else i4 = i4 + 4 | 0;
   }
  }
  HEAP32[i8 + (i5 << 2) >> 2] = i2;
  i2 = i5 + 1 | 0;
  if ((i2 | 0) == 32) break;
  i5 = i2;
  i3 = HEAP32[i9 + (i2 << 2) >> 2] | 0;
 }
 i5 = 0;
 do {
  i3 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
  if (!i3) i2 = 0; else {
   i2 = 0;
   i4 = i8;
   while (1) {
    if (i3 & 1) i2 = HEAP32[i4 >> 2] ^ i2;
    i3 = i3 >>> 1;
    if (!i3) break; else i4 = i4 + 4 | 0;
   }
  }
  HEAP32[i9 + (i5 << 2) >> 2] = i2;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 32);
 i7 = i6;
 do {
  i5 = 0;
  do {
   i3 = HEAP32[i9 + (i5 << 2) >> 2] | 0;
   if (!i3) i2 = 0; else {
    i2 = 0;
    i4 = i9;
    while (1) {
     if (i3 & 1) i2 = HEAP32[i4 >> 2] ^ i2;
     i3 = i3 >>> 1;
     if (!i3) break; else i4 = i4 + 4 | 0;
    }
   }
   HEAP32[i8 + (i5 << 2) >> 2] = i2;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 32);
  if (i7 & 1) if (!i1) i1 = 0; else {
   i2 = 0;
   i3 = i8;
   while (1) {
    if (i1 & 1) i2 = HEAP32[i3 >> 2] ^ i2;
    i1 = i1 >>> 1;
    if (!i1) {
     i1 = i2;
     break;
    } else i3 = i3 + 4 | 0;
   }
  }
  i6 = i7 >> 1;
  if (!i6) break; else i5 = 0;
  do {
   i3 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
   if (!i3) i2 = 0; else {
    i2 = 0;
    i4 = i8;
    while (1) {
     if (i3 & 1) i2 = HEAP32[i4 >> 2] ^ i2;
     i3 = i3 >>> 1;
     if (!i3) break; else i4 = i4 + 4 | 0;
    }
   }
   HEAP32[i9 + (i5 << 2) >> 2] = i2;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 32);
  if (i6 & 1) if (!i1) i1 = 0; else {
   i2 = 0;
   i3 = i1;
   i4 = i9;
   while (1) {
    if (!(i3 & 1)) i1 = i2; else i1 = HEAP32[i4 >> 2] ^ i2;
    i3 = i3 >>> 1;
    if (!i3) break; else {
     i2 = i1;
     i4 = i4 + 4 | 0;
    }
   }
  }
  i7 = i7 >> 2;
 } while ((i7 | 0) != 0);
 i10 = i1 ^ i10;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx14NpRigidDynamic26setKinematicTargetInternalERKNS_11PxTransformE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i6 = i4 + 284 | 0;
 i3 = i4 + 56 | 0;
 i21 = (HEAP32[i6 >> 2] & 512 | 0) == 0 ? i4 + 112 | 0 : (HEAP32[i3 >> 2] | 0) + 144 | 0;
 f17 = Math_fround(Math_fround(HEAPF32[i21 + 16 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f20 * f20) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f17 * f18);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f15 * f16));
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f10 * f14));
 f9 = Math_fround(Math_fround(f18 * f7) + Math_fround(Math_fround(f17 * f19) + Math_fround(f20 * Math_fround(Math_fround(f10 * f16) - Math_fround(f15 * f14)))));
 f8 = Math_fround(Math_fround(f16 * f7) + Math_fround(Math_fround(f15 * f19) + Math_fround(f20 * Math_fround(Math_fround(f17 * f14) - Math_fround(f10 * f18)))));
 f7 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f20 * Math_fround(Math_fround(f15 * f18) - Math_fround(f17 * f16)))) + Math_fround(f14 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) + f7);
 f17 = Math_fround(HEAPF32[i21 >> 2]);
 f15 = Math_fround(f20 * f17);
 f19 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f18 * f19));
 f10 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f16 * f10));
 f13 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f16 * f19) + Math_fround(f20 * f13))) - Math_fround(f18 * f10));
 f11 = Math_fround(Math_fround(Math_fround(f18 * f13) + Math_fround(Math_fround(f14 * f19) + Math_fround(f20 * f10))) - Math_fround(f16 * f17));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f14 * f10));
 HEAPF32[i2 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
 HEAPF32[i2 + 4 >> 2] = f12;
 HEAPF32[i2 + 8 >> 2] = f11;
 HEAPF32[i2 + 12 >> 2] = f10;
 HEAPF32[i2 + 16 >> 2] = f9;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f7;
 __ZN5physx3Scb4Body18setKinematicTargetERKNS_11PxTransformE(i4 + 48 | 0, i2);
 i2 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i4) | 0;
 if (!(HEAP32[i6 >> 2] & 4096)) i1 = i4 + 108 | 0; else i1 = (HEAP32[i3 >> 2] | 0) + 268 | 0;
 if (!((i2 | 0) != 0 & (HEAP8[i1 >> 0] & 2) != 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i4 + 20 | 0, i2 + 3392 | 0);
 i21 = i2 + 3416 | 0;
 HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15PlatformWrapper25GetApplicationInstallModeEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 switch (__ZN15ApplicationInfo14GetInstallModeEv(__Z18GetApplicationInfov() | 0) | 0) {
 case 1:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i5 + 11 >> 0] = 5;
   HEAP8[i5 >> 0] = HEAP8[gb + 1040539 >> 0] | 0;
   HEAP8[i5 + 1 >> 0] = HEAP8[gb + 1040539 + 1 >> 0] | 0;
   HEAP8[i5 + 2 >> 0] = HEAP8[gb + 1040539 + 2 >> 0] | 0;
   HEAP8[i5 + 3 >> 0] = HEAP8[gb + 1040539 + 3 >> 0] | 0;
   HEAP8[i5 + 4 >> 0] = HEAP8[gb + 1040539 + 4 >> 0] | 0;
   HEAP8[i5 + 5 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i5 + 12 >> 2] = i2;
   HEAP32[i1 >> 2] = 66;
   HEAP32[i1 + 4 >> 2] = i2;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = -2147483632;
   HEAP32[i5 + 4 >> 2] = 11;
   i2 = i1;
   i3 = gb + 1040545 | 0;
   i4 = i2 + 11 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i1 + 11 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i5 + 11 >> 0] = 5;
   HEAP8[i5 >> 0] = HEAP8[gb + 1040557 >> 0] | 0;
   HEAP8[i5 + 1 >> 0] = HEAP8[gb + 1040557 + 1 >> 0] | 0;
   HEAP8[i5 + 2 >> 0] = HEAP8[gb + 1040557 + 2 >> 0] | 0;
   HEAP8[i5 + 3 >> 0] = HEAP8[gb + 1040557 + 3 >> 0] | 0;
   HEAP8[i5 + 4 >> 0] = HEAP8[gb + 1040557 + 4 >> 0] | 0;
   HEAP8[i5 + 5 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 case 4:
  {
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i5 + 11 >> 0] = 10;
   i2 = i5;
   i3 = gb + 1040563 | 0;
   i4 = i2 + 10 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP8[i5 + 10 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 case 5:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i5 + 11 >> 0] = 6;
   HEAP8[i5 >> 0] = HEAP8[gb + 1040574 >> 0] | 0;
   HEAP8[i5 + 1 >> 0] = HEAP8[gb + 1040574 + 1 >> 0] | 0;
   HEAP8[i5 + 2 >> 0] = HEAP8[gb + 1040574 + 2 >> 0] | 0;
   HEAP8[i5 + 3 >> 0] = HEAP8[gb + 1040574 + 3 >> 0] | 0;
   HEAP8[i5 + 4 >> 0] = HEAP8[gb + 1040574 + 4 >> 0] | 0;
   HEAP8[i5 + 5 >> 0] = HEAP8[gb + 1040574 + 5 >> 0] | 0;
   HEAP8[i5 + 6 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 default:
  {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i5 + 11 >> 0] = 0;
   HEAP8[i5 >> 0] = 0;
   STACKTOP = i6;
   return;
  }
 }
}

function __ZN11MonoManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i8 = i5 + 36 | 0;
 i9 = i5 + 32 | 0;
 i4 = i5 + 16 | 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 463993 | 0, HEAP32[gb + 37228 >> 2] | 0, i1 + 28 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899338 | 0, i9, 0);
 i10 = i3 + 8 | 0;
 i7 = i10;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 1);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i10, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 464003 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 212 | 0, 0);
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  STACKTOP = i5;
  return;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i5;
 return;
}

function __Z24InverseTransformRotationRK23TransformAccessReadOnlyRKN4math7_float4E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (HEAP32[i1 + 4 >> 2] | 0) {
  i6 = i1;
  i7 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + (HEAP32[i6 + 4 >> 2] << 2) >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i5 + 4 >> 2] = i6;
  __Z24InverseTransformRotationRK23TransformAccessReadOnlyRKN4math7_float4E(i2, i3);
 }
 i9 = i1;
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i9 + (i11 * 40 | 0) + 24 >> 2]);
 f14 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f14 * f19);
 i7 = i3 + 12 | 0;
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f8 = Math_fround(f17 * f15);
 f18 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i2 = i3 + 4 | 0;
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f18 * f16);
 f21 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i3 + 8 | 0;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f17 * f20)) - Math_fround(f18 * f15)) - Math_fround(f21 * f16));
 f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f21 * f19)) - Math_fround(f18 * f20)) - Math_fround(f14 * f16));
 f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f14 * f20)) - Math_fround(f17 * f19)) - Math_fround(f21 * f15));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f21 * f20) - Math_fround(f19 * f18)) - Math_fround(f17 * f16)) - Math_fround(f14 * f15));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i10 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 28 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 32 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i9 + (i11 * 40 | 0) + 36 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f12 * f13);
 f13 = Math_fround(f15 * f13);
 f12 = Math_fround(f15 * f12);
 i11 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ (i5 ^ -2147483648);
 HEAP32[i3 >> 2] = i11 & -2147483648 ^ (i10 ^ -2147483648);
 HEAP32[i2 >> 2] = i9 & -2147483648 ^ i1;
 HEAP32[i6 >> 2] = i5;
 HEAPF32[i7 >> 2] = f8;
 STACKTOP = i4;
 return;
}

function _pre_process_context(i7, i8, i16, i21, i22, i23, i24) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i25 = 0, i26 = 0;
 i25 = HEAP32[i7 + 324 >> 2] | 0;
 i26 = i7 + 220 | 0;
 i9 = (HEAP32[i26 >> 2] | 0) * 3 | 0;
 i10 = i25 + 48 | 0;
 if ((HEAP32[i23 >> 2] | 0) >>> 0 >= i24 >>> 0) return;
 i11 = i25 + 60 | 0;
 i12 = i25 + 52 | 0;
 i13 = i7 + 336 | 0;
 i14 = i25 + 8 | 0;
 i15 = i7 + 32 | 0;
 i17 = i7 + 60 | 0;
 i18 = i7 + 28 | 0;
 i19 = i7 + 340 | 0;
 i20 = i25 + 56 | 0;
 while (1) {
  i1 = HEAP32[i16 >> 2] | 0;
  if (i1 >>> 0 < i21 >>> 0) {
   i5 = i21 - i1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i4 = (HEAP32[i11 >> 2] | 0) - i6 | 0;
   i5 = i4 >>> 0 < i5 >>> 0 ? i4 : i5;
   mftCall_viiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, i8 + (i1 << 2) | 0, i14 | 0, i6 | 0, i5 | 0);
   if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i15 >> 2] | 0)) {
    i1 = HEAP32[i17 >> 2] | 0;
    if ((i1 | 0) > 0) {
     i4 = 0;
     i2 = HEAP32[i26 >> 2] | 0;
     do {
      if ((i2 | 0) >= 1) {
       i3 = i25 + 8 + (i4 << 2) | 0;
       i1 = 1;
       while (1) {
        i2 = HEAP32[i3 >> 2] | 0;
        _jcopy_sample_rows(i2, 0, i2, 0 - i1 | 0, 1, HEAP32[i18 >> 2] | 0);
        i2 = HEAP32[i26 >> 2] | 0;
        if ((i1 | 0) < (i2 | 0)) i1 = i1 + 1 | 0; else break;
       }
       i1 = HEAP32[i17 >> 2] | 0;
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i1 | 0));
    }
   }
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + i5;
   i3 = (HEAP32[i12 >> 2] | 0) + i5 | 0;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) - i5;
   i1 = HEAP32[i11 >> 2] | 0;
   i2 = 24;
  } else {
   if (HEAP32[i10 >> 2] | 0) {
    i2 = 29;
    break;
   }
   i3 = HEAP32[i12 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i3 | 0) < (i1 | 0)) {
    i2 = HEAP32[i17 >> 2] | 0;
    if ((i2 | 0) > 0) {
     i6 = 0;
     while (1) {
      i4 = HEAP32[i25 + 8 + (i6 << 2) >> 2] | 0;
      i5 = HEAP32[i18 >> 2] | 0;
      if ((i3 | 0) < (i1 | 0)) {
       i2 = i3 + -1 | 0;
       do {
        _jcopy_sample_rows(i4, i2, i4, i3, 1, i5);
        i3 = i3 + 1 | 0;
       } while ((i3 | 0) != (i1 | 0));
       i2 = HEAP32[i17 >> 2] | 0;
      }
      i1 = i6 + 1 | 0;
      if ((i1 | 0) >= (i2 | 0)) break;
      i6 = i1;
      i3 = HEAP32[i12 >> 2] | 0;
      i1 = HEAP32[i11 >> 2] | 0;
     }
     i1 = HEAP32[i11 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = i1;
    i2 = 25;
   } else i2 = 24;
  }
  if ((i2 | 0) == 24) {
   i2 = 0;
   if ((i3 | 0) == (i1 | 0)) i2 = 25;
  }
  if ((i2 | 0) == 25) {
   mftCall_viiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, i14 | 0, HEAP32[i20 >> 2] | 0, i22 | 0, HEAP32[i23 >> 2] | 0);
   HEAP32[i23 >> 2] = (HEAP32[i23 >> 2] | 0) + 1;
   i2 = HEAP32[i26 >> 2] | 0;
   i1 = (HEAP32[i20 >> 2] | 0) + i2 | 0;
   HEAP32[i20 >> 2] = (i1 | 0) < (i9 | 0) ? i1 : 0;
   i1 = HEAP32[i12 >> 2] | 0;
   if ((i1 | 0) >= (i9 | 0)) {
    HEAP32[i12 >> 2] = 0;
    i1 = 0;
   }
   HEAP32[i11 >> 2] = i2 + i1;
  }
  if ((HEAP32[i23 >> 2] | 0) >>> 0 >= i24 >>> 0) {
   i2 = 29;
   break;
  }
 }
 if ((i2 | 0) == 29) return;
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SF_EEiEESI_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i13, i10, i11, i12, i1) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10;
 if (!(i1 & 4)) {
  i8 = 0;
  i1 = i13;
 } else if ((i9 - i13 | 0) > 2) if ((HEAP8[i13 >> 0] | 0) == -17) if ((HEAP8[i13 + 1 >> 0] | 0) == -69) {
  i8 = 0;
  i1 = (HEAP8[i13 + 2 >> 0] | 0) == -65 ? i13 + 3 | 0 : i13;
 } else {
  i8 = 0;
  i1 = i13;
 } else {
  i8 = 0;
  i1 = i13;
 } else {
  i8 = 0;
  i1 = i13;
 }
 L6 : while (1) {
  if (!(i8 >>> 0 < i11 >>> 0 & i1 >>> 0 < i10 >>> 0)) {
   i2 = 40;
   break;
  }
  i6 = HEAP8[i1 >> 0] | 0;
  i7 = i6 & 255;
  do if (i6 << 24 >> 24 > -1) {
   if (i7 >>> 0 > i12 >>> 0) {
    i2 = 40;
    break L6;
   }
   i1 = i1 + 1 | 0;
  } else {
   if ((i6 & 255) < 194) {
    i2 = 40;
    break L6;
   }
   if ((i6 & 255) < 224) {
    if ((i9 - i1 | 0) < 2) {
     i2 = 40;
     break L6;
    }
    i2 = HEAPU8[i1 + 1 >> 0] | 0;
    if ((i2 & 192 | 0) != 128) {
     i2 = 40;
     break L6;
    }
    if ((i2 & 63 | i7 << 6 & 1984) >>> 0 > i12 >>> 0) {
     i2 = 40;
     break L6;
    }
    i1 = i1 + 2 | 0;
    break;
   }
   if ((i6 & 255) < 240) {
    i3 = i1;
    if ((i9 - i3 | 0) < 3) {
     i2 = 40;
     break L6;
    }
    i4 = HEAP8[i1 + 1 >> 0] | 0;
    i2 = HEAP8[i1 + 2 >> 0] | 0;
    switch (i6 << 24 >> 24) {
    case -32:
     {
      if ((i4 & -32) << 24 >> 24 != -96) {
       i2 = 20;
       break L6;
      }
      break;
     }
    case -19:
     {
      if ((i4 & -32) << 24 >> 24 != -128) {
       i2 = 22;
       break L6;
      }
      break;
     }
    default:
     if ((i4 & -64) << 24 >> 24 != -128) {
      i2 = 24;
      break L6;
     }
    }
    i2 = i2 & 255;
    if ((i2 & 192 | 0) != 128) {
     i2 = 40;
     break L6;
    }
    if (((i4 & 255) << 6 & 4032 | i7 << 12 & 61440 | i2 & 63) >>> 0 > i12 >>> 0) {
     i2 = 40;
     break L6;
    } else {
     i1 = i1 + 3 | 0;
     break;
    }
   }
   if ((i6 & 255) >= 245) {
    i2 = 40;
    break L6;
   }
   i3 = i1;
   if ((i9 - i3 | 0) < 4) {
    i2 = 40;
    break L6;
   }
   i5 = HEAP8[i1 + 1 >> 0] | 0;
   i2 = HEAP8[i1 + 2 >> 0] | 0;
   i4 = HEAP8[i1 + 3 >> 0] | 0;
   switch (i6 << 24 >> 24) {
   case -16:
    {
     if ((i5 + 112 & 255) >= 48) {
      i2 = 31;
      break L6;
     }
     break;
    }
   case -12:
    {
     if ((i5 & -16) << 24 >> 24 != -128) {
      i2 = 33;
      break L6;
     }
     break;
    }
   default:
    if ((i5 & -64) << 24 >> 24 != -128) {
     i2 = 35;
     break L6;
    }
   }
   i3 = i2 & 255;
   if ((i3 & 192 | 0) != 128) {
    i2 = 40;
    break L6;
   }
   i2 = i4 & 255;
   if ((i2 & 192 | 0) != 128) {
    i2 = 40;
    break L6;
   }
   if (((i5 & 255) << 12 & 258048 | i7 << 18 & 1835008 | i3 << 6 & 4032 | i2 & 63) >>> 0 > i12 >>> 0) {
    i2 = 40;
    break L6;
   } else i1 = i1 + 4 | 0;
  } while (0);
  i8 = i8 + 1 | 0;
 }
 if ((i2 | 0) == 20) i1 = i3 - i13 | 0; else if ((i2 | 0) == 22) i1 = i3 - i13 | 0; else if ((i2 | 0) == 24) i1 = i3 - i13 | 0; else if ((i2 | 0) == 31) i1 = i3 - i13 | 0; else if ((i2 | 0) == 33) i1 = i3 - i13 | 0; else if ((i2 | 0) == 35) i1 = i3 - i13 | 0; else if ((i2 | 0) == 40) i1 = i1 - i13 | 0;
 return i1 | 0;
}

function __ZN5physx18ComputeSortedListsEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjPKjPPNS_8SapBox1DES7_PjSB_jRKNS_2Gu4AxesESB_RjSB_SG_RbSH_(i23, i3, i13, i12, i20, i21, i1, i22, i17, i2, i25, i24, i27, i26, i28, i29) {
 i23 = i23 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i25 = i25 | 0;
 i24 = i24 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i18 = HEAP32[i2 + 4 >> 2] | 0;
 i19 = HEAP32[i2 + 8 >> 2] | 0;
 if (i3 >>> 0 < i13 >>> 0) {
  i10 = HEAP32[i23 >> 2] | 0;
  i11 = HEAP32[i20 + (i16 << 2) >> 2] | 0;
  i8 = HEAP32[i20 + (i18 << 2) >> 2] | 0;
  i9 = HEAP32[i20 + (i19 << 2) >> 2] | 0;
  i5 = -1;
  i4 = 0;
  i6 = 0;
  i7 = 0;
  i1 = -1;
  i2 = -1;
  do {
   i15 = HEAP32[i12 + (i3 << 2) >> 2] | 0;
   i14 = i10 + (i15 >>> 5 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << (i15 & 31);
   i14 = HEAP32[i11 + (i15 << 3) >> 2] | 0;
   i5 = i5 >>> 0 < i14 >>> 0 ? i5 : i14;
   i14 = HEAP32[i8 + (i15 << 3) >> 2] | 0;
   i1 = i1 >>> 0 < i14 >>> 0 ? i1 : i14;
   i14 = HEAP32[i9 + (i15 << 3) >> 2] | 0;
   i2 = i2 >>> 0 < i14 >>> 0 ? i2 : i14;
   i14 = HEAP32[i11 + (i15 << 3) + 4 >> 2] | 0;
   i4 = i4 >>> 0 < i14 >>> 0 ? i14 : i4;
   i14 = HEAP32[i8 + (i15 << 3) + 4 >> 2] | 0;
   i6 = i6 >>> 0 < i14 >>> 0 ? i14 : i6;
   i15 = HEAP32[i9 + (i15 << 3) + 4 >> 2] | 0;
   i7 = i7 >>> 0 < i15 >>> 0 ? i15 : i7;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i13 | 0));
  i15 = i5;
  i14 = i4;
  i13 = i6;
  i12 = i7;
  i11 = i1;
  i10 = i2;
 } else {
  i15 = -1;
  i14 = 0;
  i13 = 0;
  i12 = 0;
  i11 = -1;
  i10 = -1;
 }
 i9 = i17 + -1 | 0;
 if (i9 >>> 0 <= 1) {
  i27 = 0;
  i26 = 0;
  i26 = (i26 | 0) == 0;
  i26 = i26 & 1;
  HEAP8[i29 >> 0] = i26;
  i29 = (i27 | 0) == 0;
  i29 = i29 & 1;
  HEAP8[i28 >> 0] = i29;
  return;
 }
 i8 = i20 + (i16 << 2) | 0;
 i7 = i20 + (i18 << 2) | 0;
 i5 = i20 + (i19 << 2) | 0;
 i6 = 1;
 i2 = 0;
 i1 = 0;
 do {
  i3 = HEAP32[i22 + (i6 << 2) >> 2] | 0;
  do if (!(i3 & 1)) {
   i4 = i3 >>> 1;
   if (HEAP32[(HEAP32[i23 >> 2] | 0) + (i3 >>> 6 << 2) >> 2] & 1 << (i4 & 31) | 0) {
    i20 = HEAP32[i24 >> 2] | 0;
    HEAP32[i25 + (i20 << 2) >> 2] = i4;
    HEAP32[i24 >> 2] = i20 + 1;
    i2 = (HEAP32[i21 + (i4 << 2) >> 2] | 0) + i2 | 0;
    break;
   }
   i18 = HEAP32[i8 >> 2] | 0;
   i19 = HEAP32[i7 >> 2] | 0;
   i20 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i20 + (i4 << 3) + 4 >> 2] | 0) >>> 0 >= i10 >>> 0 & (((i14 >>> 0 < (HEAP32[i18 + (i4 << 3) >> 2] | 0) >>> 0 ? 1 : (HEAP32[i18 + (i4 << 3) + 4 >> 2] | 0) >>> 0 < i15 >>> 0) | i13 >>> 0 < (HEAP32[i19 + (i4 << 3) >> 2] | 0) >>> 0 | (HEAP32[i19 + (i4 << 3) + 4 >> 2] | 0) >>> 0 < i11 >>> 0 | i12 >>> 0 < (HEAP32[i20 + (i4 << 3) >> 2] | 0) >>> 0) ^ 1)) {
    i20 = HEAP32[i26 >> 2] | 0;
    HEAP32[i27 + (i20 << 2) >> 2] = i4;
    HEAP32[i26 >> 2] = i20 + 1;
    i1 = (HEAP32[i21 + (i4 << 2) >> 2] | 0) + i1 | 0;
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i9 | 0));
 i27 = (i1 | 0) == 0;
 i27 = i27 & 1;
 HEAP8[i29 >> 0] = i27;
 i29 = (i2 | 0) == 0;
 i29 = i29 & 1;
 HEAP8[i28 >> 0] = i29;
 return;
}

function __ZN17PersistentManager14LoadFileStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_24TransferInstructionFlagsii(i12, i10, i2, i3, i4, i5) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 16 | 0;
 i11 = i14 + 12 | 0;
 i6 = i14;
 if ((HEAP16[gb + 1165980 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165980 | 0, i9);
  i13 = gb + 1165980 | 0;
 } else i13 = 0;
 i7 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i10 | 0, 1) | 0;
 do if ((i7 | 0) == -1) i1 = 0; else {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  i8 = i1 + (i7 * 24 | 0) | 0;
  if (HEAP32[i8 >> 2] | 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467729 | 0, 0, gb + 466878 | 0, 2055, 1, 0, 0, 0);
   i1 = 0;
   break;
  }
  if (__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i15 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, gb + 63416 | 0, 16, gb + 466989 | 0, gb + 1576256 | 0, gb + 466878 | 0, 2064) | 0;
   __ZN14SerializedFileC2Ev(i15);
   __Z19pop_allocation_rootv();
   HEAP32[i8 >> 2] = i15;
   i6 = __ZN14SerializedFile14InitializeReadERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER18ResourceImageGroupjj24TransferInstructionFlagsjj(i15, i2, i6, 7168, HEAP32[i12 + 80 >> 2] | 0, i3, i4, i5) | 0;
   HEAP32[i1 + (i7 * 24 | 0) + 20 >> 2] = i6;
   i1 = HEAP32[i8 >> 2] | 0;
   if (!i6) {
    HEAP8[i1 + 46 >> 0] = 1;
    __ZN17PersistentManager23PostLoadStreamNameSpaceER15StreamNameSpacei(i12, i8, i7);
    i3 = i12 + 96 | 0;
    i4 = __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESI_RKT_(i3, i11, i10) | 0;
    if (!(HEAP32[i4 >> 2] | 0)) {
     i1 = HEAP32[i12 + 104 >> 2] | 0;
     HEAP32[i9 >> 2] = 37;
     HEAP32[i9 + 4 >> 2] = i1;
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i10);
     i2 = HEAP32[i11 >> 2] | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = i2;
     HEAP32[i4 >> 2] = i1;
     i2 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
     if (i2) {
      HEAP32[i3 >> 2] = i2;
      i1 = HEAP32[i4 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 100 >> 2] | 0, i1);
     i15 = i12 + 108 | 0;
     HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
    }
    i1 = 1;
   } else if (!i1) i1 = 0; else {
    __ZN14SerializedFile7ReleaseEv(i1);
    HEAP32[i8 >> 2] = 0;
    i1 = 0;
   }
  } else i1 = 0;
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj(i19, i1) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0, i21 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i16 = i19 + 28 | 0;
 i11 = (HEAP32[i16 >> 2] | 0) == -1;
 i12 = i19 + 16 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 f20 = Math_fround(i1 >>> 0);
 i13 = ~~Math_fround(f20 * Math_fround(HEAPF32[i19 + 24 >> 2])) >>> 0;
 i10 = i1 << 2;
 i14 = i13 << 2;
 i15 = i14 + i10 | 0;
 i15 = (0 - i15 & 12) + i15 | 0;
 i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i19, i15 + i14 | 0, gb + 778479 | 0, 341) | 0;
 i18 = i14 + i10 | 0;
 i15 = i14 + i15 | 0;
 _memset(i14 | 0, -1, i10 | 0) | 0;
 if (i11) {
  i2 = i19 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = HEAP32[i19 + 4 >> 2] | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i11 = i3 + (i5 << 2) | 0;
    i10 = HEAP32[i11 >> 2] | 0;
    i10 = i10 + ~(i10 << 15) | 0;
    i10 = (i10 >>> 10 ^ i10) * 9 | 0;
    i10 = i10 >>> 6 ^ i10;
    i10 = i10 + ~(i10 << 11) | 0;
    i10 = i14 + (((i10 >>> 16 ^ i10) & i4) << 2) | 0;
    HEAP32[i18 + (i5 << 2) >> 2] = HEAP32[i10 >> 2];
    HEAP32[i10 >> 2] = i5;
    HEAP32[i15 + (i5 << 2) >> 2] = HEAP32[i11 >> 2];
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i19 + 8 | 0;
  i2 = i19 + 20 | 0;
 } else {
  i3 = i19 + 8 | 0;
  _memcpy(i18 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
  i2 = i19 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i10 = i19 + 4 | 0;
   i11 = i1 + -1 | 0;
   i9 = HEAP32[i19 + 12 >> 2] | 0;
   i8 = 0;
   do {
    i7 = HEAP32[i9 + (i8 << 2) >> 2] | 0;
    if ((i7 | 0) != -1) {
     i6 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     i4 = i7;
     do {
      i7 = i6 + (i4 << 2) | 0;
      i21 = HEAP32[i7 >> 2] | 0;
      i21 = i21 + ~(i21 << 15) | 0;
      i21 = (i21 >>> 10 ^ i21) * 9 | 0;
      i21 = i21 >>> 6 ^ i21;
      i21 = i21 + ~(i21 << 11) | 0;
      i21 = i14 + (((i21 >>> 16 ^ i21) & i11) << 2) | 0;
      HEAP32[i18 + (i4 << 2) >> 2] = HEAP32[i21 >> 2];
      HEAP32[i21 >> 2] = i4;
      HEAP32[i15 + (i4 << 2) >> 2] = HEAP32[i7 >> 2];
      i4 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i8 = i8 + 1 | 0;
   } while (i8 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i19, HEAP32[i19 >> 2] | 0);
 HEAP32[i19 >> 2] = i14;
 HEAP32[i19 + 12 >> 2] = i14;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i18;
 HEAP32[i19 + 4 >> 2] = i15;
 HEAP32[i12 >> 2] = i13;
 i1 = i13 + -1 | 0;
 if (i1 >>> 0 > i17 >>> 0) i2 = i17; else {
  i19 = HEAP32[i16 >> 2] | 0;
  i21 = i18 + (i1 << 2) | 0;
  HEAP32[i21 >> 2] = i19;
  HEAP32[i16 >> 2] = i17;
  return;
 }
 do {
  i21 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i18 + (i21 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i19 = HEAP32[i16 >> 2] | 0;
 i21 = i18 + (i1 << 2) | 0;
 HEAP32[i21 >> 2] = i19;
 HEAP32[i16 >> 2] = i17;
 return;
}

function __Z23sweepConvex_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i2, i3, i4, i9, f5, i8, i6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 f5 = Math_fround(f5);
 i8 = i8 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i10 + 12 | 0;
 i12 = i10;
 i11 = i10 + 40 | 0;
 f22 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(f22 * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(f14 * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f14 * f17) + Math_fround(-1.0)));
 f22 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(f22 * f17);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f19 * f16));
 f16 = Math_fround(Math_fround(f19 * f22) - Math_fround(f17 * f16));
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f14 = Math_fround(f17 * f14);
 f15 = Math_fround(f17 * f15);
 f16 = Math_fround(f17 * f16);
 f17 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f22 = Math_fround(f17 + f14);
 f19 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f21 = Math_fround(f19 + f15);
 f18 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f20 = Math_fround(f16 + f18);
 HEAPF32[i13 >> 2] = f22;
 HEAPF32[i13 + 4 >> 2] = f21;
 HEAPF32[i13 + 8 >> 2] = f20;
 f15 = Math_fround(f19 - f15);
 f16 = Math_fround(f18 - f16);
 HEAPF32[i13 + 12 >> 2] = Math_fround(f17 - f14);
 HEAPF32[i13 + 16 >> 2] = f15;
 HEAPF32[i13 + 20 >> 2] = f16;
 HEAP32[i13 + 24 >> 2] = HEAP32[i1 + 4 >> 2];
 f16 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
 i1 = i9 + 4 | 0;
 f15 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 i2 = i9 + 8 | 0;
 f14 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i12 >> 2] = f16;
 HEAPF32[i12 + 4 >> 2] = f15;
 HEAPF32[i12 + 8 >> 2] = f14;
 HEAP16[i11 >> 1] = HEAP16[i6 >> 1] | 0;
 if (!(__Z23sweepCapsule_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i3, i4, i13, i12, f5, i8, i11, f7) | 0)) {
  i13 = 0;
  STACKTOP = i10;
  return i13 | 0;
 }
 if (HEAP16[i8 + 12 >> 1] & 1) {
  f22 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  f20 = Math_fround(f22 * Math_fround(HEAPF32[i9 >> 2]));
  f21 = Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
  f22 = Math_fround(f22 * Math_fround(HEAPF32[i2 >> 2]));
  i13 = i8 + 16 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i13 >> 2]));
  i13 = i8 + 20 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f21 + Math_fround(HEAPF32[i13 >> 2]));
  i13 = i8 + 24 | 0;
  HEAPF32[i13 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i13 >> 2]));
 }
 i11 = i8 + 28 | 0;
 f20 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
 i12 = i8 + 32 | 0;
 f21 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
 i13 = i8 + 36 | 0;
 f22 = Math_fround(-Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i11 >> 2] = f20;
 HEAPF32[i12 >> 2] = f21;
 HEAPF32[i13 >> 2] = f22;
 HEAP32[i8 + 8 >> 2] = -1;
 i13 = 1;
 STACKTOP = i10;
 return i13 | 0;
}

function __ZN12CullingGroup15NotifyInvisibleEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 248 | 0;
 i11 = i18 + 8 | 0;
 i15 = i18;
 i16 = i18 + 256 | 0;
 i5 = HEAP32[i10 + 24 >> 2] | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i16 >> 2] = 0;
 i12 = i16 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i16 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i11);
 i7 = i17;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i14;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 if (!i5) {
  i1 = i16;
  i2 = 0;
 } else {
  HEAP32[i13 >> 2] = i5;
  HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i5 << 3, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
  i3 = i10 + 28 | 0;
  i4 = i10 + 48 | 0;
  i1 = 0;
  do {
   if ((HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0) != (HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] | 0)) {
    i6 = HEAP32[i12 >> 2] | 0;
    i7 = i6 + 1 | 0;
    i8 = HEAP32[i13 >> 2] | 0;
    i9 = i8 & 2147483647;
    do if (i7 >>> 0 > i9 >>> 0) {
     i2 = i8 << 1;
     i2 = (i2 | 0) == 0 ? 1 : i2;
     if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
      HEAP32[i13 >> 2] = i2;
      HEAP32[i16 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i16 >> 2] | 0, i2 << 3, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i9 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
      HEAP32[i13 >> 2] = i2;
      HEAP32[i16 >> 2] = i9;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i7;
    i9 = HEAP32[i16 >> 2] | 0;
    i7 = HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] | 0;
    i8 = HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0;
    HEAP32[i9 + (i6 << 3) >> 2] = i1;
    HEAP8[i9 + (i6 << 3) + 4 >> 0] = i7;
    HEAP8[i9 + (i6 << 3) + 5 >> 0] = i8;
    HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  i1 = i16;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 i7 = (__Z23GetCoreScriptingClassesv() | 0) + 136 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i15;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i11, i17);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i11, __Z29scripting_gchandle_get_targetj(HEAP32[i10 >> 2] | 0) | 0);
 __ZN18ScriptingArguments9AddIntPtrEPv(i11, i2);
 __ZN18ScriptingArguments6AddIntEi(i11, i12);
 HEAP32[i17 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i11, i17, 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i14);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN13UnityProfiler25SaveCurrentFrameRecordingEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, d9 = 0.0;
 i2 = i7 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i2 = i7 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i2 = i7 + 84 | 0;
   i1 = i7 + 68 | 0;
   i4 = 7;
  } else i4 = 4;
 } else i4 = 4;
 do if ((i4 | 0) == 4) {
  HEAP32[i2 >> 2] = 0;
  i3 = i7 + 68 | 0;
  if ((HEAP32[i1 + 1128 >> 2] | 0) < (HEAP32[i3 >> 2] | 0)) {
   __ZN17ProfilerFrameDataD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
   i1 = __ZnwjRK10MemLabelIdiPKci(1232, gb + 63576 | 0, 16, gb + 585151 | 0, 953) | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i2 = i7 + 84 | 0;
   i6 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
   HEAP32[i2 >> 2] = i6;
   __ZN17ProfilerFrameDataC2Eii(i1, i5, i6);
   if (!i1) {
    i1 = i3;
    i4 = 7;
    break;
   }
  } else i2 = i7 + 84 | 0;
  i6 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i1 >> 2] = i6;
 } while (0);
 if ((i4 | 0) == 7) {
  i6 = __ZnwjRK10MemLabelIdiPKci(1232, gb + 63576 | 0, 16, gb + 585151 | 0, 343) | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
  HEAP32[i2 >> 2] = i1;
  __ZN17ProfilerFrameDataC2Eii(i6, i5, i1);
  i1 = i6;
 }
 i2 = HEAP32[i7 + 60 >> 2] | 0;
 i5 = i7 + 56 | 0;
 i3 = i2;
 if ((i3 | 0) != (i5 | 0)) {
  i6 = i1 + 1124 | 0;
  i4 = 0;
  while (1) {
   i8 = i2 + 8 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc((HEAP32[i6 >> 2] | 0) + (i4 * 144 | 0) + 120 | 0, HEAP32[(HEAP32[i8 >> 2] | 0) + 268 >> 2] | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc((HEAP32[i6 >> 2] | 0) + (i4 * 144 | 0) + 132 | 0, HEAP32[(HEAP32[i8 >> 2] | 0) + 272 >> 2] | 0) | 0;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
   if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 1 | 0;
  }
 }
 i2 = HEAP32[i1 >> 2] | 0;
 __ZNK22UnityProfilerPerThread15SaveToFrameDataER17ProfilerFrameData(HEAP32[i7 + 72 >> 2] | 0, i1);
 __Z20CollectProfilerStatsR16AllProfilerStats(i1 + 12 | 0);
 if (__Z9GetIAudiov() | 0) {
  i8 = __Z9GetIAudiov() | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 68 >> 2] | 0, i8 | 0, i1 + 1152 | 0, i1 + 1172 | 0, i1 + 1192 | 0, i1 + 1212 | 0);
 }
 i8 = i7 + 8 | 0;
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 656 >> 2] | 0, i8 | 0, 1, i2 | 0);
 __ZN14PreloadManager16EndProfilerFrameEi(__Z17GetPreloadManagerv() | 0, i2);
 d9 = +_emscripten_get_now() * 1.0e6;
 i8 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i4 = i7 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = _i64Subtract(~~d9 >>> 0 | 0, i8 | 0, i5 | 0, i4 | 0) | 0;
 i8 = getTempRet0() | 0;
 i4 = __Z17TimeToNanosecondsy(i5, i4) | 0;
 i4 = ___udivdi3(i4 | 0, getTempRet0() | 0, 1e3, 0) | 0;
 i5 = getTempRet0() | 0;
 i6 = i1 + 1136 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i5;
 i8 = __Z17TimeToNanosecondsy(i7, i8) | 0;
 i8 = ___udivdi3(i8 | 0, getTempRet0() | 0, 1e3, 0) | 0;
 getTempRet0() | 0;
 HEAP32[i1 + 1144 >> 2] = i8;
 return i1 | 0;
}

function __ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = HEAP32[i6 + 100 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i9 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i9 = 3;
 if ((i9 | 0) == 3) __ZN8Material15BuildPropertiesEv(i6);
 i5 = i6 + 48 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = i5;
  L8 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L8;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if (!((i1 | 0) == (i5 | 0) ? 1 : (i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0))) {
   i4 = HEAP32[i1 + 36 >> 2] | 0;
   if (!i4) {
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
   HEAP32[i8 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 27; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i8 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 27; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 29;
    }
   }
   if ((i9 | 0) == 27) i9 = 29;
   if ((i9 | 0) == 29) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   i9 = i1;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i4 = i6 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) if (!(HEAP32[i1 + 4 >> 2] | 0)) {
   i9 = HEAP32[i4 >> 2] | 0;
   __Z31ReadObjectFromPersistentManageri(i9) | 0;
   STACKTOP = i10;
   return 0;
  } else {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i9 = HEAP32[i4 >> 2] | 0;
 __Z31ReadObjectFromPersistentManageri(i9) | 0;
 STACKTOP = i10;
 return 0;
}

function __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i4 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 48 >> 0] = i1;
 i1 = i4 + 49 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim25ValueArrayCopyInverseMaskEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE(i6, i8, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i6 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = (i3 | 0) == 0 ? 0 : i3 + i1 | 0;
 i3 = i8 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i7 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = (i5 | 0) == 0 ? 0 : i5 + i2 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (!(HEAP8[i2 + i4 >> 0] | 0)) {
    i10 = HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] | 0;
    i9 = HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i3 + (i4 * 12 | 0) >> 2] = HEAP32[i1 + (i4 * 12 | 0) >> 2];
    HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] = i10;
    HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] = i9;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 12 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (!(HEAP8[i1 + i4 >> 0] | 0)) {
    i11 = HEAP32[i3 + (i4 << 4) + 4 >> 2] | 0;
    i9 = HEAP32[i3 + (i4 << 4) + 8 >> 2] | 0;
    i10 = HEAP32[i3 + (i4 << 4) + 12 >> 2] | 0;
    HEAP32[i2 + (i4 << 4) >> 2] = HEAP32[i3 + (i4 << 4) >> 2];
    HEAP32[i2 + (i4 << 4) + 4 >> 2] = i11;
    HEAP32[i2 + (i4 << 4) + 8 >> 2] = i9;
    HEAP32[i2 + (i4 << 4) + 12 >> 2] = i10;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 20 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 20 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 16 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (!(HEAP8[i1 + i4 >> 0] | 0)) {
    i10 = HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] | 0;
    i11 = HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i2 + (i4 * 12 | 0) >> 2] = HEAP32[i3 + (i4 * 12 | 0) >> 2];
    HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] = i10;
    HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = i11;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 28 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 24 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (!(HEAP8[i1 + i4 >> 0] | 0)) HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[i3 + (i4 << 2) >> 2];
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i5 = i6 + 36 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = (i4 | 0) == 0 ? 0 : i4 + i5 | 0;
 i4 = i8 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = (i3 | 0) == 0 ? 0 : i3 + i4 | 0;
 i3 = i7 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = HEAP32[i8 + 32 >> 2] | 0;
 if (!i2) return; else i1 = 0;
 do {
  if (!(HEAP8[i3 + i1 >> 0] | 0)) HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx9PxTaskMgr15submitNamedTaskEPNS_6PxTaskEPKcNS_10PxTaskType4EnumE(i14, i11, i5, i12) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 24 | 0;
 i6 = i15 + 20 | 0;
 i10 = i15;
 HEAP32[i6 >> 2] = i5;
 i9 = (i11 | 0) != 0;
 i7 = i5;
 if (i9) {
  HEAP32[i11 + 8 >> 2] = i14;
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 32 >> 2] | 0, i11 | 0);
 }
 i13 = i14 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i13 >> 2] | 0);
 i4 = HEAP32[i14 + 36 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i5;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i14 + 28 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i14 + 20 >> 2] | 0;
   i3 = i14 + 24 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L4;
   }
   if (i2 | 0) {
    i1 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    if (!i9) {
     i14 = i1;
     i13 = HEAP32[i13 >> 2] | 0;
     __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
     STACKTOP = i15;
     return i14 | 0;
    }
    i14 = HEAP32[i14 + 76 >> 2] | 0;
    HEAP32[i14 + (i1 * 20 | 0) >> 2] = i11;
    HEAP32[i14 + (i1 * 20 | 0) + 8 >> 2] = i12;
    HEAP32[i11 + 12 >> 2] = i1;
    i14 = i1;
    i13 = HEAP32[i13 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
    STACKTOP = i15;
    return i14 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i14 + 56 | 0) | 0;
 i2 = i14 + 76 | 0;
 i3 = i14 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i14 + 16 | 0, i6, i8) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i7;
  i1 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
 } else i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (i9) HEAP32[i11 + 12 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = 1;
 HEAP32[i10 + 12 >> 2] = -1;
 HEAP32[i10 + 16 >> 2] = -1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 8 >> 2] = i12;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i14 + 84 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i14 = (HEAP32[i2 >> 2] | 0) + (i1 * 20 | 0) | 0;
  HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i14 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i14 = i4;
  i13 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
  STACKTOP = i15;
  return i14 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayINS_14PxTaskTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i2, i10) | 0;
  i14 = i4;
  i13 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i13);
  STACKTOP = i15;
  return i14 | 0;
 }
 return 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS7_(i14, i15, i13) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16;
 __ZNK15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E13find_positionERS5_(i1, i15, i13);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i12 = HEAP32[i15 + 100 >> 2] | 0;
  i13 = i12 + ((HEAP32[i15 + 104 >> 2] | 0) * 44 | 0) | 0;
  HEAP32[i14 >> 2] = i15;
  HEAP32[i14 + 4 >> 2] = i12 + (i2 * 44 | 0);
  HEAP32[i14 + 8 >> 2] = i13;
  HEAP8[i14 + 12 >> 0] = 0;
  STACKTOP = i16;
  return;
 }
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 L5 : do if (!(HEAP8[i15 + 8 >> 0] | 0)) i11 = 18; else {
  i7 = i15 + 4 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (!i8) i11 = 18; else {
   i4 = i15 + 100 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i15 + 12 >> 2] | 0) == (HEAP32[i1 + (i12 * 44 | 0) >> 2] | 0)) {
    i9 = HEAP32[i15 + 16 >> 2] | 0;
    switch (i9 | 0) {
    case 2:
    case 4:
     {
      i2 = 2;
      break;
     }
    default:
     i2 = i9;
    }
    i10 = HEAP32[i1 + (i12 * 44 | 0) + 4 >> 2] | 0;
    switch (i10 | 0) {
    case 2:
    case 4:
     {
      i3 = 2;
      break;
     }
    default:
     i3 = i10;
    }
    if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i15 + 20 >> 2] | 0) == (HEAP32[i1 + (i12 * 44 | 0) + 8 >> 2] | 0)) {
     i2 = HEAP32[i15 + 24 >> 2] | 0;
     i3 = HEAP32[i1 + (i12 * 44 | 0) + 12 >> 2] | 0;
     i5 = i2 >>> 24 & 255;
     i6 = i3 >>> 24 & 255;
     if ((i2 & 65535) << 16 >> 16 == (i3 & 65535) << 16 >> 16) {
      if ((i2 >>> 16 & 255) << 24 >> 24 != (i3 >>> 16 & 255) << 24 >> 24) {
       switch (i9 | 0) {
       case 2:
       case 4:
        break;
       default:
        {
         i11 = 18;
         break L5;
        }
       }
       switch (i10 | 0) {
       case 2:
       case 4:
        break;
       default:
        {
         i11 = 18;
         break L5;
        }
       }
      }
      if (i5 << 24 >> 24 == i6 << 24 >> 24) HEAP32[i7 >> 2] = i8 + -1; else i11 = 18;
     } else i11 = 18;
    } else i11 = 18; else i11 = 18;
   } else i11 = 18;
  }
 } while (0);
 if ((i11 | 0) == 18) {
  i1 = i15 + 108 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i15 + 100 | 0;
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i1 + (i12 * 44 | 0) | 0;
 i1 = i13;
 i2 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i11 = HEAP32[i4 >> 2] | 0;
 i13 = i11 + ((HEAP32[i15 + 104 >> 2] | 0) * 44 | 0) | 0;
 HEAP32[i14 >> 2] = i15;
 HEAP32[i14 + 4 >> 2] = i11 + (i12 * 44 | 0);
 HEAP32[i14 + 8 >> 2] = i13;
 HEAP8[i14 + 12 >> 0] = 1;
 STACKTOP = i16;
 return;
}

function __ZN14ParticleSystem4EmitEi(i17, i18) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 104 | 0;
 i16 = i19 + 40 | 0;
 i14 = i19;
 if ((i18 | 0) < 1) {
  STACKTOP = i19;
  return;
 }
 i13 = i17 + 28 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = HEAP32[i17 + 40 >> 2] | 0;
  i2 = i1 + 8 | 0;
  if ((HEAP32[i2 >> 2] | 0) != 1) {
   HEAP32[i2 >> 2] = 1;
   HEAP8[i1 + 13 >> 0] = 1;
  }
  __ZN14ParticleSystem12AddToManagerEv(i17);
 }
 i3 = i17 + 32 | 0;
 if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0)) __ZN14ParticleSystem22AllocateParticleArraysEv(i17);
 i4 = i17 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i10 = i15;
 i11 = i1 + 52 | 0;
 i12 = i10 + 64 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i16;
 i11 = i1 + 180 | 0;
 i12 = i10 + 64 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = i14;
 i11 = i1 + 244 | 0;
 i12 = i10 + 36 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i5 = HEAP32[i1 + 304 >> 2] | 0;
 i6 = HEAP32[i1 + 308 >> 2] | 0;
 i7 = HEAP32[i1 + 312 >> 2] | 0;
 i8 = HEAP32[i1 + 316 >> 2] | 0;
 i9 = HEAP32[i1 + 320 >> 2] | 0;
 i2 = HEAP32[i1 + 324 >> 2] | 0;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i17, i13, i1 + 52 | 0, i1 + 244 | 0, i1 + 304 | 0, i1 + 316 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i1 + 52 | 0, i1 + 180 | 0) | 0;
 i1 = i17 + 48 | 0;
 if (HEAP8[i17 + 52 >> 0] | 0) __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f(i1, (HEAP32[i4 >> 2] | 0) + 180 | 0);
 __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf(i17, HEAP32[i3 >> 2] | 0, Math_fround(0.0), Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + 396 >> 2]), Math_fround(0.0), 0, i18, Math_fround(0.0));
 i10 = (HEAP32[i4 >> 2] | 0) + 52 | 0;
 i11 = i15;
 i12 = i10 + 64 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = (HEAP32[i4 >> 2] | 0) + 180 | 0;
 i11 = i16;
 i12 = i10 + 64 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i10 = (HEAP32[i4 >> 2] | 0) + 244 | 0;
 i11 = i14;
 i12 = i10 + 36 | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  i10 = i10 + 4 | 0;
  i11 = i11 + 4 | 0;
 } while ((i10 | 0) < (i12 | 0));
 i18 = HEAP32[i4 >> 2] | 0;
 HEAP32[i18 + 304 >> 2] = i5;
 HEAP32[i18 + 308 >> 2] = i6;
 HEAP32[i18 + 312 >> 2] = i7;
 i18 = HEAP32[i4 >> 2] | 0;
 HEAP32[i18 + 316 >> 2] = i8;
 HEAP32[i18 + 320 >> 2] = i9;
 HEAP32[i18 + 324 >> 2] = i2;
 __ZN11ShapeModule15ReleaseMeshDataEv(i1);
 STACKTOP = i19;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN17PersistentManager25ExtractAwakeFromLoadQueueEPKijR18AwakeFromLoadQueue(i6, i15, i16, i17) {
 i6 = i6 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21 + 8 | 0;
 i19 = i21;
 i3 = i16 * 12 | 0;
 i1 = 0;
 while (1) {
  if (!i1) {
   i1 = 1;
   continue;
  }
  i4 = i17 + (i1 * 20 | 0) | 0;
  i5 = i17 + (i1 * 20 | 0) + 16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i16 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i16;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3, 4, i17 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 4, i17 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i17 + (i1 * 20 | 0) + 12 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i5 >> 2] = i16;
   HEAP32[i4 >> 2] = i14;
   break;
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 14) break;
 }
 if (!i16) {
  STACKTOP = i21;
  return;
 }
 i7 = i6 + 176 | 0;
 i8 = i6 + 120 | 0;
 i9 = i6 + 168 | 0;
 i10 = i6 + 172 | 0;
 i11 = i6 + 124 | 0;
 i12 = i6 + 128 | 0;
 i13 = i6 + 188 | 0;
 i14 = i6 + 128 | 0;
 i6 = i6 + 116 | 0;
 i4 = 0;
 do {
  HEAP32[i19 >> 2] = HEAP32[i15 + (i4 << 2) >> 2];
  if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i8 >> 2] | 0)) {
   i3 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i5 = i3 + (i1 * 20 | 0) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i18, i6, i19);
   i5 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i5 = (i5 | 0) == -1 ? i3 + (i1 * 20 | 0) | 0 : i3 + (i5 * 20 | 0) | 0;
  }
  do if ((i5 | 0) != (i3 + (i1 * 20 | 0) | 0)) {
   i2 = HEAP32[i5 + 12 >> 2] | 0;
   if (i2) {
    __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode(i17, i2, 0, 0, 0);
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i10 >> 2] | 0;
   }
   if ((i5 | 0) != (i3 + (i1 * 20 | 0) | 0)) {
    if (!(HEAP8[i11 >> 0] | 0)) i20 = 20; else if (!(HEAP32[i8 >> 2] | 0)) i20 = 20; else {
     i3 = (HEAP32[i14 >> 2] | 0) == (HEAP32[i5 >> 2] | 0);
     HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
     if (i3) break;
    }
    if ((i20 | 0) == 20) {
     i20 = 0;
     HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     HEAP32[i5 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
     HEAP32[i5 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
    }
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    HEAP8[i13 >> 0] = 1;
   }
  } while (0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i16 | 0));
 STACKTOP = i21;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZL15SweepCapsuleBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i12 + 76 | 0;
 i16 = i12 + 48 | 0;
 i15 = i12 + 32 | 0;
 i14 = i12;
 i11 = i12 + 88 | 0;
 i13 = i12 + 136 | 0;
 HEAP32[i17 >> 2] = 2;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAPF32[i17 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i16 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 3;
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i3 + 60 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i3 = i11 + 16 | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i11, i13, Math_fround(0.0)) | 0)) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i10 + 40 >> 2] = -1;
 HEAP32[i10 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i10 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
 HEAPF64[i10 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
 HEAPF64[i10 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i17 = 1;
 STACKTOP = i12;
 return i17 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SE_EEiEESH_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __Z26GetRegisteredWebCamDevicesRNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEEE(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i22;
 i1 = HEAP32[gb + 1459968 >> 2] | 0;
 if ((HEAP32[gb + 1459968 + 4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i22;
  return;
 }
 i16 = i14 + 4 | 0;
 i17 = i15 + 4 | 0;
 i18 = i14 + 8 | 0;
 i19 = i15 + 11 | 0;
 i20 = i15 + 4 | 0;
 i13 = 0;
 do {
  i2 = HEAP32[i14 >> 2] | 0;
  i10 = HEAP32[i16 >> 2] | 0;
  i11 = i1 + (i13 * 20 | 0) | 0;
  L6 : do if ((i2 | 0) == (i10 | 0)) i1 = i2; else {
   i12 = i11 + 11 | 0;
   i9 = i1 + (i13 * 20 | 0) + 4 | 0;
   i1 = i2;
   L8 : while (1) {
    __Z24scripting_cpp_string_forP12Il2CppString(i15, HEAP32[i1 >> 2] | 0);
    i3 = HEAP8[i19 >> 0] | 0;
    i5 = i3 << 24 >> 24 < 0;
    i3 = i3 & 255;
    i6 = i5 ? HEAP32[i20 >> 2] | 0 : i3;
    i8 = HEAP8[i12 >> 0] | 0;
    i2 = i8 << 24 >> 24 < 0;
    do if ((i6 | 0) == ((i2 ? HEAP32[i9 >> 2] | 0 : i8 & 255) | 0)) {
     i7 = HEAP32[i15 >> 2] | 0;
     i8 = i5 ? i7 : i15;
     i2 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
     i4 = (i6 | 0) == 0;
     if (i5) {
      if (i4) break L8;
      i8 = (_memcmp(i8, i2, i6) | 0) == 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      if (i8) break L6; else break;
     }
     if (i4) break L8;
     if ((i7 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
      i4 = i15;
      while (1) {
       i3 = i3 + -1 | 0;
       i4 = i4 + 1 | 0;
       if (!i3) break L8;
       i2 = i2 + 1 | 0;
       if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
        i21 = 14;
        break;
       }
      }
     } else i21 = 14;
    } else i21 = 14; while (0);
    if ((i21 | 0) == 14) {
     i21 = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
    }
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i10 | 0)) {
     i1 = i10;
     break L6;
    }
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  } while (0);
  if ((i1 | 0) == (HEAP32[i16 >> 2] | 0)) {
   i12 = HEAP32[gb + 1459968 >> 2] | 0;
   i10 = i12 + (i13 * 20 | 0) | 0;
   i1 = HEAP8[i10 + 11 >> 0] | 0;
   i11 = i1 << 24 >> 24 < 0;
   HEAP32[i15 >> 2] = __Z20scripting_string_newPKcj(i11 ? HEAP32[i10 >> 2] | 0 : i10, i11 ? HEAP32[i12 + (i13 * 20 | 0) + 4 >> 2] | 0 : i1 & 255) | 0;
   HEAP32[i17 >> 2] = HEAPU8[(HEAP32[gb + 1459968 >> 2] | 0) + (i13 * 20 | 0) + 12 >> 0];
   i1 = HEAP32[i16 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i18 >> 2] | 0)) __ZNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i14, i15); else {
    i10 = i15;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i1;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 8;
   }
  }
  i13 = i13 + 1 | 0;
  i1 = HEAP32[gb + 1459968 >> 2] | 0;
 } while (i13 >>> 0 < (((HEAP32[gb + 1459968 + 4 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0);
 STACKTOP = i22;
 return;
}

function __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i10, i11, i2, i12, i13, i14, i3) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 if (!(i3 & 4)) i2 = i10; else {
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i10;
  if ((i2 - i1 | 0) > 2) if ((HEAP8[i1 >> 0] | 0) == -17) if ((HEAP8[i1 + 1 >> 0] | 0) == -69) if ((HEAP8[i1 + 2 >> 0] | 0) == -65) HEAP32[i11 >> 2] = i1 + 3;
 }
 L9 : while (1) {
  i8 = HEAP32[i11 >> 2] | 0;
  i1 = i8 >>> 0 < i10 >>> 0;
  if (!i1) {
   i15 = 40;
   break;
  }
  i9 = HEAP32[i13 >> 2] | 0;
  if (i9 >>> 0 >= i12 >>> 0) {
   i15 = 40;
   break;
  }
  i5 = HEAP8[i8 >> 0] | 0;
  i7 = i5 & 255;
  do if (i5 << 24 >> 24 > -1) {
   if (i7 >>> 0 > i14 >>> 0) {
    i1 = 2;
    break L9;
   }
   HEAP32[i9 >> 2] = i7;
   HEAP32[i11 >> 2] = i8 + 1;
  } else {
   if ((i5 & 255) < 194) {
    i1 = 2;
    break L9;
   }
   if ((i5 & 255) < 224) {
    if ((i2 - i8 | 0) < 2) {
     i1 = 1;
     break L9;
    }
    i1 = HEAPU8[i8 + 1 >> 0] | 0;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = i1 & 63 | i7 << 6 & 1984;
    if (i1 >>> 0 > i14 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP32[i9 >> 2] = i1;
    HEAP32[i11 >> 2] = i8 + 2;
    break;
   }
   if ((i5 & 255) < 240) {
    if ((i2 - i8 | 0) < 3) {
     i1 = 1;
     break L9;
    }
    i3 = HEAP8[i8 + 1 >> 0] | 0;
    i1 = HEAP8[i8 + 2 >> 0] | 0;
    switch (i5 << 24 >> 24) {
    case -32:
     {
      if ((i3 & -32) << 24 >> 24 != -96) {
       i1 = 2;
       break L9;
      }
      break;
     }
    case -19:
     {
      if ((i3 & -32) << 24 >> 24 != -128) {
       i1 = 2;
       break L9;
      }
      break;
     }
    default:
     if ((i3 & -64) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
    }
    i1 = i1 & 255;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L9;
    }
    i1 = (i3 & 255) << 6 & 4032 | i7 << 12 & 61440 | i1 & 63;
    if (i1 >>> 0 > i14 >>> 0) {
     i1 = 2;
     break L9;
    }
    HEAP32[i9 >> 2] = i1;
    HEAP32[i11 >> 2] = i8 + 3;
    break;
   }
   if ((i5 & 255) >= 245) {
    i1 = 2;
    break L9;
   }
   if ((i2 - i8 | 0) < 4) {
    i1 = 1;
    break L9;
   }
   i6 = HEAP8[i8 + 1 >> 0] | 0;
   i1 = HEAP8[i8 + 2 >> 0] | 0;
   i4 = HEAP8[i8 + 3 >> 0] | 0;
   switch (i5 << 24 >> 24) {
   case -16:
    {
     if ((i6 + 112 & 255) >= 48) {
      i1 = 2;
      break L9;
     }
     break;
    }
   case -12:
    {
     if ((i6 & -16) << 24 >> 24 != -128) {
      i1 = 2;
      break L9;
     }
     break;
    }
   default:
    if ((i6 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     break L9;
    }
   }
   i3 = i1 & 255;
   if ((i3 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   i1 = i4 & 255;
   if ((i1 & 192 | 0) != 128) {
    i1 = 2;
    break L9;
   }
   i1 = (i6 & 255) << 12 & 258048 | i7 << 18 & 1835008 | i3 << 6 & 4032 | i1 & 63;
   if (i1 >>> 0 > i14 >>> 0) {
    i1 = 2;
    break L9;
   }
   HEAP32[i9 >> 2] = i1;
   HEAP32[i11 >> 2] = i8 + 4;
  } while (0);
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
 }
 if ((i15 | 0) == 40) i1 = i1 & 1;
 return i1 | 0;
}

function __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 - i3 | 0;
 i5 = (i1 | 0) / 60 | 0;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4;
 i9 = i6;
 if (i5 >>> 0 > (((HEAP32[i7 >> 2] | 0) - i4 | 0) / 60 | 0) >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i8);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i6 = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 60 | 0;
  i1 = i6 << 1;
  i1 = i6 >>> 0 < 1073741823 ? (i1 >>> 0 < i5 >>> 0 ? i5 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 60 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 * 60 | 0);
  if ((i3 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i1 = i3;
  do {
   __ZN13AnimationClip9PPtrCurveC2ERKS0_(i2, i1);
   i1 = i1 + 60 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 60 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 60 | 0;
 i4 = i5 >>> 0 > i1 >>> 0;
 i1 = i4 ? i3 + (i1 * 60 | 0) | 0 : i6;
 if ((i3 | 0) != (i1 | 0)) do {
  __ZN13AnimationClip9PPtrCurveaSERKS0_(i2, i3) | 0;
  i3 = i3 + 60 | 0;
  i2 = i2 + 60 | 0;
 } while ((i3 | 0) != (i1 | 0));
 if (i4) {
  if ((i1 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN13AnimationClip9PPtrCurveC2ERKS0_(i2, i1);
   i1 = i1 + 60 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 60 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i10 + 4 | 0;
 do {
  i4 = i1 + -60 | 0;
  HEAP32[i7 >> 2] = i4;
  i3 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  i3 = i1 + -44 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i3 >> 2] | 0;
   i8 = HEAP32[i1 + -32 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i5 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i1 + -48 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i6 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc13ConstraintSim9visualizeERNS_14PxRenderBufferE(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 44 | 0;
 i7 = i13 + 16 | 0;
 i10 = i13 + 72 | 0;
 i12 = i13;
 i8 = i11 + 100 | 0;
 if (!(HEAP16[HEAP32[i8 >> 2] >> 1] & 32)) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i11 + 68 >> 2] | 0;
 i1 = HEAP32[i11 + 72 >> 2] | 0;
 if (!i2) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 24 >> 2] = Math_fround(0.0);
 } else {
  i5 = HEAP32[i2 + 64 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 }
 if (!i1) {
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 24 >> 2] = Math_fround(0.0);
 } else {
  i5 = HEAP32[i1 + 64 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 }
 i1 = i11 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 1408 >> 2]);
 f3 = Math_fround(f3 * Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i2, 21)));
 i1 = HEAP32[i1 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i1 + 1408 >> 2]);
 f4 = Math_fround(f4 * Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i1, 22)));
 i1 = i10 + 36 | 0;
 i2 = i10;
 i5 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i5 = i10 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i10 + 56 >> 2] = Math_fround(1.0);
 i5 = i10 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i10 + 76 >> 2] = Math_fround(1.0);
 i5 = i10 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i10 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 100 >> 2] = i9;
 HEAP32[i12 >> 2] = gb + 101184 + 8;
 HEAPF32[i12 + 4 >> 2] = f3;
 HEAPF32[i12 + 8 >> 2] = f4;
 HEAP32[i12 + 12 >> 2] = i10;
 mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 48 >> 2] | 0, i12 | 0, HEAP32[i11 + 60 >> 2] | 0, i6 | 0, i7 | 0, 3);
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89888 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89888 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89888 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89888 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89888 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89888 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89888 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89888 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i10, i5, i1, i2) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 4 | 0;
 i4 = i11;
 i9 = HEAP32[i1 >> 2] | 0;
 i6 = i9;
 if ((((HEAP32[i1 + 4 >> 2] | 0) - i9 | 0) / 52 | 0) >>> 0 <= i5 >>> 0) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 switch (HEAP32[i6 + (i5 * 52 | 0) + 40 >> 2] | 0) {
 case 1:
  {
   i9 = HEAP32[i6 + (i5 * 52 | 0) + 32 >> 2] | 0;
   i8 = HEAP32[i2 + 112 >> 2] | 0;
   i7 = (HEAP32[i2 + 116 >> 2] | 0) - i8 | 0;
   __Z10DestripifyPKtiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE((i7 | 0) != 0 & i7 >>> 0 > i9 >>> 0 ? i8 + i9 | 0 : 0, HEAP32[i6 + (i5 * 52 | 0) + 36 >> 2] | 0, i10);
   i10 = 8;
   STACKTOP = i11;
   return i10 | 0;
  }
 case 2:
  {
   i9 = HEAP32[i6 + (i5 * 52 | 0) + 32 >> 2] | 0;
   i8 = HEAP32[i2 + 112 >> 2] | 0;
   i2 = (HEAP32[i2 + 116 >> 2] | 0) - i8 | 0;
   i9 = (i2 | 0) != 0 & i2 >>> 0 > i9 >>> 0 ? i8 + i9 | 0 : 0;
   i5 = HEAP32[i6 + (i5 * 52 | 0) + 36 >> 2] | 0;
   i2 = (i5 | 0) / 4 | 0;
   i8 = i2 << 2;
   i6 = i10 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i1 = i7 - i4 >> 2;
   i2 = i2 * 6 | 0;
   i3 = i1 + i2 | 0;
   if (i1 >>> 0 < i3 >>> 0) __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i10, i2); else if (i1 >>> 0 > i3 >>> 0) {
    i2 = i4 + (i3 << 2) | 0;
    if ((i7 | 0) != (i2 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -4 - i2 | 0) >>> 2) << 2);
   }
   if ((i5 | 0) <= 3) {
    i10 = 8;
    STACKTOP = i11;
    return i10 | 0;
   }
   i3 = HEAP32[i10 >> 2] | 0;
   i2 = 0;
   while (1) {
    i7 = HEAPU16[i9 + (i2 << 1) >> 1] | 0;
    HEAP32[i3 + (i1 << 2) >> 2] = i7;
    HEAP32[i3 + (i1 + 1 << 2) >> 2] = HEAPU16[i9 + ((i2 | 1) << 1) >> 1];
    i10 = HEAPU16[i9 + ((i2 | 2) << 1) >> 1] | 0;
    HEAP32[i3 + (i1 + 2 << 2) >> 2] = i10;
    HEAP32[i3 + (i1 + 3 << 2) >> 2] = i7;
    HEAP32[i3 + (i1 + 4 << 2) >> 2] = i10;
    HEAP32[i3 + (i1 + 5 << 2) >> 2] = HEAPU16[i9 + ((i2 | 3) << 1) >> 1];
    i2 = i2 + 4 | 0;
    if ((i2 | 0) >= (i8 | 0)) {
     i1 = 8;
     break;
    } else i1 = i1 + 6 | 0;
   }
   STACKTOP = i11;
   return i1 | 0;
  }
 case 0:
  {
   i8 = HEAP32[i6 + (i5 * 52 | 0) + 32 >> 2] | 0;
   i1 = HEAP32[i2 + 112 >> 2] | 0;
   i9 = (HEAP32[i2 + 116 >> 2] | 0) - i1 | 0;
   i1 = i1 + i8 | 0;
   if ((i1 | 0) == 0 | (i9 >>> 0 <= i8 >>> 0 | (i9 | 0) == 0)) {
    i10 = 8;
    STACKTOP = i11;
    return i10 | 0;
   }
   HEAP32[i4 >> 2] = HEAP32[i10 + 4 >> 2];
   i9 = i1 + (HEAP32[i6 + (i5 * 52 | 0) + 36 >> 2] << 1) | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6insertIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPjEEE4typeENSD_IPKjEES9_S9_(i10, i3, i1, i9) | 0;
   i10 = 8;
   STACKTOP = i11;
   return i10 | 0;
  }
 default:
  {
   i10 = 4;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN22VertexDeclarationCache13GetVertexDeclERK18VertexChannelsInfo(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 48 | 0;
 i11 = i13 + 40 | 0;
 i8 = i13 + 36 | 0;
 i3 = i13;
 i5 = i12 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i1 = i5;
  i4 = i2;
  L2 : while (1) {
   i2 = i4;
   while (1) {
    if (!(__ZNK18VertexChannelsInfoltERKS_(i2 + 16 | 0, i6) | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if (!(__ZNK18VertexChannelsInfoltERKS_(i6, i1 + 16 | 0) | 0)) {
   i12 = HEAP32[i1 + 48 >> 2] | 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 i7 = i12 + 20 | 0;
 i2 = i12 + 24 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) i9 = 16; else {
  i1 = i2;
  L15 : while (1) {
   i5 = i4;
   while (1) {
    if (!(__ZNK18VertexChannelsInfoltERKS_(i5 + 16 | 0, i6) | 0)) break;
    i4 = HEAP32[i5 + 4 >> 2] | 0;
    if (!i4) break L15; else i5 = i4;
   }
   i4 = HEAP32[i5 >> 2] | 0;
   if (!i4) {
    i1 = i5;
    break;
   } else i1 = i5;
  }
  i4 = i1;
  if ((i1 | 0) == (i2 | 0)) {
   i2 = i4;
   i9 = 16;
  } else if (__ZNK18VertexChannelsInfoltERKS_(i6, i1 + 16 | 0) | 0) {
   i2 = i4;
   i9 = 16;
  } else i1 = HEAP32[i1 + 48 >> 2] | 0;
 }
 if ((i9 | 0) == 16) {
  i1 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i6 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i3 + 32 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  i6 = __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_(i7, i10, i11, i3) | 0;
  if (!(HEAP32[i6 >> 2] | 0)) {
   i2 = HEAP32[i12 + 28 >> 2] | 0;
   HEAP32[i10 >> 2] = 14;
   HEAP32[i10 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   i5 = i2 + 16 | 0;
   i4 = i5 + 36 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    i5 = i5 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i5 | 0) < (i4 | 0));
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i6 >> 2] = i2;
   i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i7 >> 2] = i3;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 24 >> 2] | 0, i2);
   i12 = i12 + 32 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  }
 }
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12resize_deltaEjj(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i6 + 72 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i3 = (HEAP32[i6 + 60 >> 2] | 0) - (HEAP32[i6 + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 < (HEAP32[i6 + 64 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i6 + 56 >> 2] | 0;
   if (i1 >>> 0 > 32) {
    f2 = Math_fround(i3 >>> 0);
    do {
     i3 = i1;
     i1 = i1 >>> 1;
     if (i3 >>> 0 < 66) break;
    } while (f2 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j(i8, i6, i1);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_(i6, i8);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev(i8);
   }
  }
  HEAP8[i4 >> 0] = 0;
 }
 i4 = HEAP32[i6 + 56 >> 2] | 0;
 i1 = HEAP32[i6 + 60 >> 2] | 0;
 if (i4 >>> 0 > i7 >>> 0) if ((i1 + i5 | 0) >>> 0 <= (HEAP32[i6 + 68 >> 2] | 0) >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + i5 | 0;
 f2 = Math_fround(i3 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround((i3 - (HEAP32[i6 + 4 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j(i8, i6, i1);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_(i6, i8);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev(i8);
 STACKTOP = i9;
 return;
}

function _consume_data(i22) {
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0, i24 = 0, i25 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24;
 i21 = i22 + 392 | 0;
 i20 = HEAP32[i21 >> 2] | 0;
 i23 = i22 + 292 | 0;
 if ((HEAP32[i23 >> 2] | 0) > 0) {
  i2 = i22 + 4 | 0;
  i3 = i22 + 128 | 0;
  i1 = 0;
  do {
   i17 = HEAP32[i22 + 296 + (i1 << 2) >> 2] | 0;
   i18 = HEAP32[i17 + 12 >> 2] | 0;
   HEAP32[i19 + (i1 << 2) >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i22 | 0, HEAP32[i20 + 76 + (HEAP32[i17 + 4 >> 2] << 2) >> 2] | 0, Math_imul(i18, HEAP32[i3 >> 2] | 0) | 0, i18 | 0, 1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i23 >> 2] | 0));
 }
 i13 = i20 + 24 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i14 = i20 + 28 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 L6 : do if ((i1 | 0) < (i2 | 0)) {
  i15 = i20 + 20 | 0;
  i16 = i22 + 312 | 0;
  i17 = i22 + 408 | 0;
  i18 = i20 + 32 | 0;
  i4 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  L8 : while (1) {
   if (i4 >>> 0 < i3 >>> 0) {
    i2 = i4;
    do {
     i12 = HEAP32[i23 >> 2] | 0;
     if ((i12 | 0) > 0) {
      i3 = 0;
      i11 = 0;
      do {
       i9 = HEAP32[i22 + 296 + (i11 << 2) >> 2] | 0;
       i7 = HEAP32[i9 + 52 >> 2] | 0;
       i8 = Math_imul(i7, i2) | 0;
       i9 = HEAP32[i9 + 56 >> 2] | 0;
       if ((i9 | 0) > 0) {
        i10 = HEAP32[i19 + (i11 << 2) >> 2] | 0;
        if ((i7 | 0) > 0) {
         i6 = 0;
         do {
          i4 = 0;
          i5 = (HEAP32[i10 + (i6 + i1 << 2) >> 2] | 0) + (i8 << 7) | 0;
          while (1) {
           i25 = i3;
           i3 = i3 + 1 | 0;
           HEAP32[i20 + 32 + (i25 << 2) >> 2] = i5;
           i4 = i4 + 1 | 0;
           if ((i4 | 0) >= (i7 | 0)) break; else i5 = i5 + 128 | 0;
          }
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) < (i9 | 0));
        }
       }
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) < (i12 | 0));
     }
     if (!((mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 4 >> 2] | 0, i22 | 0, i18 | 0) | 0) << 24 >> 24)) break L8;
     i2 = i2 + 1 | 0;
     i3 = HEAP32[i16 >> 2] | 0;
    } while (i2 >>> 0 < i3 >>> 0);
    i2 = HEAP32[i14 >> 2] | 0;
   }
   HEAP32[i15 >> 2] = 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) < (i2 | 0)) i4 = 0; else break L6;
  }
  HEAP32[i13 >> 2] = i1;
  HEAP32[i15 >> 2] = i2;
  i25 = 0;
  STACKTOP = i24;
  return i25 | 0;
 } while (0);
 i4 = i22 + 128 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 i4 = HEAP32[i22 + 284 >> 2] | 0;
 if (i3 >>> 0 >= i4 >>> 0) {
  mftCall_vi(HEAP32[(HEAP32[i22 + 400 >> 2] | 0) + 12 >> 2] | 0, i22 | 0);
  i25 = 4;
  STACKTOP = i24;
  return i25 | 0;
 }
 i2 = HEAP32[i21 >> 2] | 0;
 do if ((HEAP32[i23 >> 2] | 0) > 1) HEAP32[i2 + 28 >> 2] = 1; else {
  i1 = HEAP32[i22 + 296 >> 2] | 0;
  if (i3 >>> 0 < (i4 + -1 | 0) >>> 0) {
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 i25 = 3;
 STACKTOP = i24;
 return i25 | 0;
}

function _compress_output(i25, i1) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i24;
 i21 = i25 + 328 | 0;
 i22 = HEAP32[i21 >> 2] | 0;
 i20 = i25 + 228 | 0;
 i1 = HEAP32[i20 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i3 = i25 + 4 | 0;
  i4 = i22 + 8 | 0;
  i2 = 0;
  do {
   i18 = HEAP32[i25 + 232 + (i2 << 2) >> 2] | 0;
   i1 = HEAP32[i18 + 12 >> 2] | 0;
   HEAP32[i19 + (i2 << 2) >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i25 | 0, HEAP32[i22 + 64 + (HEAP32[i18 + 4 >> 2] << 2) >> 2] | 0, Math_imul(i1, HEAP32[i4 >> 2] | 0) | 0, i1 | 0, 0) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i20 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 i17 = i22 + 16 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i18 = i22 + 20 | 0;
 i3 = HEAP32[i18 >> 2] | 0;
 do if ((i2 | 0) < (i3 | 0)) {
  i13 = i22 + 12 | 0;
  i14 = i25 + 248 | 0;
  i15 = i25 + 348 | 0;
  i16 = i22 + 24 | 0;
  i4 = i3;
  i1 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
  L8 : while (1) {
   if (i1 >>> 0 < i3 >>> 0) {
    do {
     i12 = HEAP32[i20 >> 2] | 0;
     if ((i12 | 0) > 0) {
      i3 = 0;
      i11 = 0;
      do {
       i9 = HEAP32[i25 + 232 + (i11 << 2) >> 2] | 0;
       i7 = HEAP32[i9 + 52 >> 2] | 0;
       i8 = Math_imul(i7, i1) | 0;
       i9 = HEAP32[i9 + 56 >> 2] | 0;
       if ((i9 | 0) > 0) {
        i10 = HEAP32[i19 + (i11 << 2) >> 2] | 0;
        if ((i7 | 0) > 0) {
         i6 = 0;
         do {
          i4 = 0;
          i5 = (HEAP32[i10 + (i6 + i2 << 2) >> 2] | 0) + (i8 << 7) | 0;
          while (1) {
           i26 = i3;
           i3 = i3 + 1 | 0;
           HEAP32[i22 + 24 + (i26 << 2) >> 2] = i5;
           i4 = i4 + 1 | 0;
           if ((i4 | 0) >= (i7 | 0)) break; else i5 = i5 + 128 | 0;
          }
          i6 = i6 + 1 | 0;
         } while ((i6 | 0) < (i9 | 0));
        }
       }
       i11 = i11 + 1 | 0;
      } while ((i11 | 0) < (i12 | 0));
     }
     if (!((mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 4 >> 2] | 0, i25 | 0, i16 | 0) | 0) << 24 >> 24)) break L8;
     i1 = i1 + 1 | 0;
     i3 = HEAP32[i14 >> 2] | 0;
    } while (i1 >>> 0 < i3 >>> 0);
    i1 = HEAP32[i18 >> 2] | 0;
   } else i1 = i4;
   HEAP32[i13 >> 2] = 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) < (i1 | 0)) {
    i4 = i1;
    i1 = 0;
   } else {
    i23 = 19;
    break;
   }
  }
  if ((i23 | 0) == 19) {
   i1 = HEAP32[i20 >> 2] | 0;
   break;
  }
  HEAP32[i17 >> 2] = i2;
  HEAP32[i13 >> 2] = i1;
  i26 = 0;
  STACKTOP = i24;
  return i26 | 0;
 } while (0);
 i2 = i22 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = HEAP32[i21 >> 2] | 0;
 do if ((i1 | 0) > 1) HEAP32[i2 + 20 >> 2] = 1; else {
  i1 = HEAP32[i25 + 232 >> 2] | 0;
  if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 < ((HEAP32[i25 + 224 >> 2] | 0) + -1 | 0) >>> 0) {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i26 = 1;
 STACKTOP = i24;
 return i26 | 0;
}

function __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 12 | 0;
 i5 = i8;
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 12 >> 2] | 0;
 if (!(i6 & 134217728)) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i15 = i4 + 4 | 0;
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  i13 = i4 + 8 | 0;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i14 = i5 + 4 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i12 = i5 + 8 | 0;
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  i19 = i6 >>> 30;
  f17 = Math_fround(HEAP32[i3 + 4 >> 2] & 65535 | 0);
  f18 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
  f17 = Math_fround(f18 * f17);
  f11 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
  f16 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[gb + 1451432 + 12 >> 2]);
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  f18 = Math_fround(f18 * Math_fround(i3 >>> 16 | 0));
  f11 = Math_fround(f11 * Math_fround(i3 & 65535 | 0));
  f16 = Math_fround(f16 * Math_fround(i7 >>> 16 | 0));
  f10 = Math_fround(f10 * Math_fround(i7 & 65535 | 0));
  i3 = i2 + 20 | 0;
  f9 = Math_fround(HEAPF32[i3 + (i19 << 2) >> 2]);
  i6 = i2 + 32 | 0;
  f17 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f17) * f9) + Math_fround(f17 * Math_fround(HEAPF32[i6 + (i19 << 2) >> 2])));
  HEAPF32[i5 + (i19 << 2) >> 2] = f17;
  HEAPF32[i4 + (i19 << 2) >> 2] = f17;
  i7 = ((i19 + 1 | 0) >>> 0) % 3 | 0;
  f17 = Math_fround(HEAPF32[i3 + (i7 << 2) >> 2]);
  f9 = Math_fround(HEAPF32[i6 + (i7 << 2) >> 2]);
  HEAPF32[i4 + (i7 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f18) * f17) + Math_fround(f18 * f9));
  HEAPF32[i5 + (i7 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f11) * f17) + Math_fround(f11 * f9)) + Math_fround(0.0));
  i7 = ((i7 + 1 | 0) >>> 0) % 3 | 0;
  f9 = Math_fround(HEAPF32[i3 + (i7 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i6 + (i7 << 2) >> 2]);
  HEAPF32[i4 + (i7 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f16) * f9) + Math_fround(f16 * f11));
  HEAPF32[i5 + (i7 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f10) * f9) + Math_fround(f10 * f11)) + Math_fround(0.0));
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i5 >> 2]));
  f10 = Math_fround(HEAPF32[i15 >> 2]);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i14 >> 2]));
  f9 = Math_fround(HEAPF32[i13 >> 2]);
  f10 = Math_fround(f10 * Math_fround(.5));
  f9 = Math_fround(Math_fround(f9 + Math_fround(HEAPF32[i12 >> 2])) * Math_fround(.5));
  HEAPF32[i1 >> 2] = Math_fround(f11 * Math_fround(.5));
  HEAPF32[i1 + 4 >> 2] = f10;
  HEAPF32[i1 + 8 >> 2] = f9;
  STACKTOP = i8;
  return;
 } else {
  i19 = i2 + (HEAP32[i2 + 112 >> 2] | 0) + ((i7 >>> 12) * 12 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = Math_fround(Math_abs(Math_fround(f2))) < Math_fround(.999899983);
 f3 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 if (i6) {
  f8 = Math_fround(-f3);
  i6 = HEAP32[i5 >> 2] | 0;
  f9 = Math_fround(Math_fround(1.0) / Math_fround(f2 + Math_fround(1.0)));
  f11 = Math_fround(f9 * f8);
  f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = Math_fround(f7 * f11);
  f9 = Math_fround(f2 + Math_fround(f9 * Math_fround(f7 * f7)));
  f7 = Math_fround(-f7);
  HEAPF32[i4 >> 2] = Math_fround(f2 + Math_fround(f11 * f8));
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAP32[i4 + 8 >> 2] = i6;
  HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 16 >> 2] = f10;
  HEAPF32[i4 + 20 >> 2] = f9;
  HEAPF32[i4 + 24 >> 2] = f3;
  HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i4 + 40 >> 2] = i1;
  f3 = f8;
  f2 = f7;
  i6 = i4 + 32 | 0;
  HEAPF32[i6 >> 2] = f2;
  i6 = i4 + 36 | 0;
  HEAPF32[i6 >> 2] = f3;
  i6 = i4 + 44 | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  return;
 } else {
  f15 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i5 >> 2]));
  f11 = Math_fround(Math_fround(1.0) - f3);
  f17 = Math_fround(Math_fround(0.0) - f2);
  f16 = Math_fround(-Math_fround(Math_fround(2.0) / Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f11 * f11)) + Math_fround(f17 * f17))));
  f9 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(f15 * Math_fround(0.0)) + f11) - f17) * f16));
  f14 = Math_fround(f15 * f16);
  f10 = Math_fround(f11 * f16);
  f16 = Math_fround(f17 * f16);
  f13 = Math_fround(f15 * f9);
  f7 = Math_fround(f11 * f9);
  f9 = Math_fround(f17 * f9);
  f12 = Math_fround(Math_fround(f11 * f14) + f13);
  f2 = Math_fround(Math_fround(Math_fround(f17 * f14) - f13) + Math_fround(0.0));
  f3 = Math_fround(Math_fround(f15 * f10) + Math_fround(f7 * Math_fround(0.0)));
  f8 = Math_fround(Math_fround(Math_fround(f17 * f10) - f7) + Math_fround(1.0));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f10) + f7) + Math_fround(-1.0)) + Math_fround(1.0));
  f10 = Math_fround(Math_fround(Math_fround(f15 * f16) + Math_fround(f9 * Math_fround(0.0))) + Math_fround(0.0));
  f11 = Math_fround(Math_fround(Math_fround(f11 * f16) + f9) + Math_fround(1.0));
  f9 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - f9) + Math_fround(-1.0)) + Math_fround(1.0));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * Math_fround(0.0))) + Math_fround(1.0));
  HEAPF32[i4 + 4 >> 2] = f12;
  HEAPF32[i4 + 8 >> 2] = f2;
  HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 16 >> 2] = f3;
  HEAPF32[i4 + 20 >> 2] = f7;
  HEAPF32[i4 + 24 >> 2] = f8;
  HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 40 >> 2] = f9;
  i6 = i4 + 32 | 0;
  HEAPF32[i6 >> 2] = f10;
  i6 = i4 + 36 | 0;
  HEAPF32[i6 >> 2] = f11;
  i6 = i4 + 44 | 0;
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  return;
 }
}

function __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i6, i4, i5, i1, i2, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f22 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
 f20 = Math_fround(f22 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f22 = Math_fround(f22 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(f14 * Math_fround(HEAPF32[i2 >> 2]));
 f15 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f11 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 i13 = i6 + 36 | 0;
 i3 = i6 + 48 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f25 = Math_fround(f12 - f18);
 f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f24 = Math_fround(f10 - f20);
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f23 = Math_fround(f8 - f22);
 i21 = i6 + 84 | 0;
 HEAPF32[i21 >> 2] = f25;
 i19 = i6 + 88 | 0;
 HEAPF32[i19 >> 2] = f24;
 i17 = i6 + 92 | 0;
 HEAPF32[i17 >> 2] = f23;
 HEAPF32[i3 >> 2] = f25;
 i4 = i6 + 52 | 0;
 HEAPF32[i4 >> 2] = f24;
 i5 = i6 + 56 | 0;
 HEAPF32[i5 >> 2] = f23;
 HEAPF32[i13 >> 2] = f25;
 i1 = i6 + 40 | 0;
 HEAPF32[i1 >> 2] = f24;
 i2 = i6 + 44 | 0;
 HEAPF32[i2 >> 2] = f23;
 f12 = Math_fround(f18 + f12);
 f10 = Math_fround(f20 + f10);
 f8 = Math_fround(f22 + f8);
 f22 = Math_fround(f16 + f11);
 f20 = Math_fround(f15 + f9);
 f18 = Math_fround(f14 + f7);
 HEAPF32[i6 >> 2] = Math_fround(f25 - f22);
 HEAPF32[i6 + 4 >> 2] = Math_fround(f24 - f20);
 HEAPF32[i6 + 8 >> 2] = Math_fround(f23 - f18);
 HEAPF32[i6 + 12 >> 2] = Math_fround(f12 - f22);
 HEAPF32[i6 + 16 >> 2] = Math_fround(f10 - f20);
 HEAPF32[i6 + 20 >> 2] = Math_fround(f8 - f18);
 HEAPF32[i6 + 72 >> 2] = Math_fround(f22 + f12);
 HEAPF32[i6 + 76 >> 2] = Math_fround(f20 + f10);
 HEAPF32[i6 + 80 >> 2] = Math_fround(f18 + f8);
 HEAPF32[i21 >> 2] = Math_fround(f22 + Math_fround(HEAPF32[i21 >> 2]));
 HEAPF32[i19 >> 2] = Math_fround(f20 + Math_fround(HEAPF32[i19 >> 2]));
 HEAPF32[i17 >> 2] = Math_fround(f18 + Math_fround(HEAPF32[i17 >> 2]));
 f11 = Math_fround(f16 - f11);
 f9 = Math_fround(f15 - f9);
 f7 = Math_fround(f14 - f7);
 HEAPF32[i6 + 24 >> 2] = Math_fround(f11 + f12);
 HEAPF32[i6 + 28 >> 2] = Math_fround(f9 + f10);
 HEAPF32[i6 + 32 >> 2] = Math_fround(f7 + f8);
 HEAPF32[i13 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f11);
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f7);
 HEAPF32[i6 + 60 >> 2] = Math_fround(f12 - f11);
 HEAPF32[i6 + 64 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i6 + 68 >> 2] = Math_fround(f8 - f7);
 return;
}

function __ZN13ConstantForce8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function _tre_match_empty(i10, i1, i11, i12, i13) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 4 | 0;
 i14 = i18;
 i15 = i10 + 12 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i17 = (i13 | 0) != 0;
 if (i17) HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
 i1 = _tre_stack_push(i10, i9) | 0;
 L4 : do if (!i1) {
  i5 = i10 + 16 | 0;
  i6 = (i11 | 0) == 0;
  i7 = (i12 | 0) == 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if ((i1 | 0) > (i16 | 0)) while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i15 >> 2] = i1;
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   L8 : do switch (HEAP32[i1 >> 2] | 0) {
   case 0:
    {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     switch (HEAP32[i1 >> 2] | 0) {
     case -3:
      break;
     case -2:
      {
       if (i7) break L8;
       HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | HEAP32[i1 + 4 >> 2];
       break L8;
      }
     default:
      break L8;
     }
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     if ((i4 | 0) > -1) {
      L15 : do if (!i6) {
       i1 = HEAP32[i11 >> 2] | 0;
       L17 : do if ((i1 | 0) > -1) {
        i2 = 0;
        i3 = i11;
        while (1) {
         if ((i1 | 0) == (i4 | 0)) break;
         i2 = i2 + 1 | 0;
         i3 = i11 + (i2 << 2) | 0;
         i1 = HEAP32[i3 >> 2] | 0;
         if ((i1 | 0) <= -1) {
          i1 = i3;
          break L17;
         }
        }
        if ((i4 | 0) < 0) i1 = i3; else break L15;
       } else {
        i2 = 0;
        i1 = i11;
       } while (0);
       HEAP32[i1 >> 2] = i4;
       HEAP32[i11 + (i2 + 1 << 2) >> 2] = -1;
      } while (0);
      if (i17) HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
     }
     break;
    }
   case 3:
    {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (HEAP32[i2 + 8 >> 2] | 0) {
      HEAP32[i14 >> 2] = i2;
      HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
      i1 = _tre_stack_push(i10, i9) | 0;
      i8 = 6;
      break L8;
     }
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (HEAP32[i1 + 8 >> 2] | 0) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
      i1 = _tre_stack_push(i10, i9) | 0;
      i8 = 6;
     }
     break;
    }
   case 1:
    {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
     i1 = _tre_stack_push(i10, i9) | 0;
     if (i1 | 0) break L4;
     HEAP32[i14 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
     i1 = _tre_stack_push(i10, i9) | 0;
     i8 = 6;
     break;
    }
   case 2:
    {
     i1 = HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0;
     if (HEAP32[i1 + 8 >> 2] | 0) {
      HEAP32[i14 >> 2] = i1;
      HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
      i1 = _tre_stack_push(i10, i9) | 0;
      i8 = 6;
     }
     break;
    }
   default:
    {}
   } while (0);
   if ((i8 | 0) == 6) {
    i8 = 0;
    if (i1 | 0) break L4;
   }
   i1 = HEAP32[i15 >> 2] | 0;
   if ((i1 | 0) <= (i16 | 0)) {
    i1 = 0;
    break L4;
   }
  } else i1 = 0;
 } while (0);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i11 = HEAP32[i9 >> 2] | 0;
 i12 = i9 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i8 = i13;
  i7 = i9;
  i13 = HEAP32[i13 >> 2] | 0;
  HEAP32[i7 >> 2] = i13;
  HEAP32[i8 >> 2] = i11;
  i11 = i10 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i11 >> 2] = i13;
  i11 = i9 + 8 | 0;
  i13 = i10 + 12 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[i11 >> 2] = i9;
  HEAP32[i13 >> 2] = i12;
  i13 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 >> 2] = i13;
  return;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 do {
  i8 = i2 + -72 | 0;
  i3 = i1;
  i1 = i1 + -72 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i2 + -48 >> 2] = HEAP32[i3 + -48 >> 2];
  HEAP32[i2 + -44 >> 2] = HEAP32[i3 + -44 >> 2];
  HEAP32[i2 + -40 >> 2] = HEAP32[i3 + -40 >> 2];
  HEAP32[i2 + -36 >> 2] = HEAP32[i3 + -36 >> 2];
  HEAP32[i2 + -32 >> 2] = HEAP32[i3 + -32 >> 2];
  HEAP32[i2 + -28 >> 2] = HEAP32[i3 + -28 >> 2];
  HEAP32[i2 + -24 >> 2] = HEAP32[i3 + -24 >> 2];
  HEAP32[i2 + -20 >> 2] = HEAP32[i3 + -20 >> 2];
  HEAP32[i2 + -16 >> 2] = HEAP32[i3 + -16 >> 2];
  i8 = i2 + -12 | 0;
  HEAP32[i8 >> 2] = i8;
  HEAP32[i2 + -8 >> 2] = i8;
  i6 = i2 + -4 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i3 + -12 | 0;
  i2 = HEAP32[i3 + -8 >> 2] | 0;
  i3 = i2;
  if ((i3 | 0) != (i7 | 0)) {
   i4 = i8;
   i5 = 0;
   do {
    i15 = i2;
    i14 = i4;
    i4 = __Znwj(44) | 0;
    i18 = i15 + 8 | 0;
    i17 = HEAP32[i18 + 4 >> 2] | 0;
    i16 = i4 + 8 | 0;
    HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i16 + 4 >> 2] = i17;
    HEAP32[i4 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
    HEAP32[i4 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
    HEAP32[i4 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
    HEAP32[i4 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
    HEAP32[i4 + 32 >> 2] = HEAP32[i15 + 32 >> 2];
    HEAP32[i4 + 36 >> 2] = HEAP32[i15 + 36 >> 2];
    HEAP32[i4 + 40 >> 2] = HEAP32[i15 + 40 >> 2];
    HEAP32[i4 + 4 >> 2] = i8;
    HEAP32[i4 >> 2] = i14;
    HEAP32[i14 + 4 >> 2] = i4;
    HEAP32[i8 >> 2] = i4;
    i5 = i5 + 1 | 0;
    HEAP32[i6 >> 2] = i5;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i3 = i2;
   } while ((i3 | 0) != (i7 | 0));
  }
  i2 = (HEAP32[i13 >> 2] | 0) + -72 | 0;
  HEAP32[i13 >> 2] = i2;
 } while ((i1 | 0) != (i11 | 0));
 i18 = i13;
 i17 = i9;
 i16 = i2;
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i17 >> 2] = i16;
 HEAP32[i18 >> 2] = i15;
 i15 = i10 + 8 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 HEAP32[i12 >> 2] = i16;
 HEAP32[i15 >> 2] = i17;
 i15 = i9 + 8 | 0;
 i17 = i10 + 12 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i14 = HEAP32[i17 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i16;
 i18 = HEAP32[i18 >> 2] | 0;
 HEAP32[i10 >> 2] = i18;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 if (!i8) {
  i10 = 1;
  return i10 | 0;
 }
 i10 = i9 + 57 | 0;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 i4 = i9 + 40 | 0;
 i2 = i1;
 L7 : do if ((i2 | 0) == (i4 | 0)) i7 = 8; else {
  i3 = i2;
  while (1) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (i2 >>> 0 <= i8 >>> 0) if ((i2 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i8 >>> 0) {
    i5 = i1;
    i7 = 12;
    break L7;
   }
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
   if ((i3 | 0) == (i4 | 0)) {
    i7 = 8;
    break;
   }
  }
 } while (0);
 L13 : do if ((i7 | 0) == 8) {
  i1 = HEAP32[i9 + 52 >> 2] | 0;
  i4 = i9 + 48 | 0;
  i2 = i1;
  if ((i2 | 0) != (i4 | 0)) do {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i8 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i8 >>> 0) {
    i5 = i1;
    i7 = 12;
    break L13;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i6 = i9 + 64 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i5 = 0;
   while (1) {
    if ((HEAP32[i1 + 8 >> 2] | 0) == (i8 | 0)) break;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i1 = 0;
     break L13;
    } else {
     i5 = i1;
     i1 = i2;
    }
   }
   i3 = i1 + 16 | 0;
   i11 = HEAP32[i3 >> 2] | 0;
   i4 = i1 + 12 | 0;
   i8 = HEAP32[i4 >> 2] | 0;
   i2 = i9 + 16 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i11;
   i2 = i9 + 28 | 0;
   HEAP32[i2 >> 2] = i11 - i8 + (HEAP32[i2 >> 2] | 0);
   i2 = i9 + 12 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i5) HEAP32[i6 >> 2] = i2; else HEAP32[i5 >> 2] = i2;
   i11 = i9 + 20 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) - (HEAP32[i3 >> 2] | 0);
   __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i4 >> 2] | 0);
   __ZN13MemoryManager12LowLevelFreeEPvj(i1, 20);
   i1 = 1;
  }
 } while (0);
 if ((i7 | 0) == 12) {
  i2 = i8 + -8 | 0;
  if (!(HEAP32[i2 >> 2] & 1)) {
   i1 = 0;
   i4 = i2;
  } else {
   i4 = HEAP32[i8 + -12 >> 2] | 0;
   i1 = i4;
   i4 = i2 + (0 - i4) | 0;
  }
  i3 = _tlsf_block_size(i2 + (0 - i1) | 0) | 0;
  if (!(HEAP32[i2 >> 2] & 1)) i1 = 0; else i1 = HEAP32[i8 + -12 >> 2] | 0;
  i11 = i9 + 16 | 0;
  HEAP32[i11 >> 2] = 8 - i3 + i1 + (HEAP32[i11 >> 2] | 0);
  i11 = i9 + 28 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -23;
  i11 = i9 + 12 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  i11 = i5 + 20 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  _tlsf_free(HEAP32[i5 + 8 >> 2] | 0, i4);
  if (!(HEAP32[i11 >> 2] | 0)) {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    i11 = i5 + 4 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
    HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
   }
   i11 = i5 + 16 | 0;
   __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i5 + 12 >> 2] | 0, HEAP32[i11 >> 2] | 0);
   i1 = i9 + 20 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i11 >> 2] | 0);
   __ZN13MemoryManager12LowLevelFreeEPvj(i5, 24);
   i1 = 1;
  } else i1 = 1;
 }
 if (!(HEAP8[i10 >> 0] | 0)) {
  i11 = i1;
  return i11 | 0;
 }
 i11 = i1;
 return i11 | 0;
}

function _glob(i6, i12, i4, i13) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i7 = i14 + 8 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = i11;
 if (!(i12 & 8)) i5 = 0; else i5 = HEAP32[i13 + 8 >> 2] | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 if (i2 << 24 >> 24 == 47) {
  i1 = i6;
  do {
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
  } while (i2 << 24 >> 24 == 47);
  i3 = gb + 1087627 | 0;
 } else {
  i3 = gb + 1576256 | 0;
  i1 = i6;
 }
 L8 : do if ((_strlen(i1) | 0) >>> 0 > 4096) i1 = 1; else {
  i9 = (i12 & 32 | 0) != 0;
  if (!i9) {
   HEAP32[i13 + 8 >> 2] = i5;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   i2 = HEAP8[i1 >> 0] | 0;
  }
  if (!(i2 << 24 >> 24)) {
   HEAP32[i7 >> 2] = 0;
   i1 = 0;
   i2 = i11;
   i3 = i7;
   i10 = 16;
  } else {
   i1 = _match_in_dir(i3, i1, i12, (i4 | 0) == 0 ? fb + 1139 | 0 : i4, i7) | 0;
   if ((i1 | 0) == 1) {
    i1 = HEAP32[i11 >> 2] | 0;
    if (!i1) {
     i1 = 1;
     break;
    }
    while (1) {
     i13 = i1;
     i1 = HEAP32[i1 >> 2] | 0;
     _free(i13);
     if (!i1) {
      i1 = 1;
      break L8;
     }
    }
   }
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   if (!i2) {
    i2 = i11;
    i3 = i7;
    i10 = 16;
   } else {
    i3 = 0;
    do {
     i2 = HEAP32[i2 >> 2] | 0;
     HEAP32[i7 >> 2] = i2;
     i3 = i3 + 1 | 0;
    } while ((i2 | 0) != 0);
    if (!i3) {
     i2 = i11;
     i3 = i7;
     i10 = 16;
    } else {
     i8 = i3;
     i6 = i11;
    }
   }
  }
  if ((i10 | 0) == 16) {
   if (!(i12 & 16)) {
    i1 = 3;
    break;
   }
   HEAP32[i7 >> 2] = i11;
   if (!(_append(i7, i6, _strlen(i6) | 0, 0) | 0)) {
    i8 = 1;
    i6 = i2;
    i7 = i3;
   } else {
    i1 = 1;
    break;
   }
  }
  do if (i9) {
   i2 = i13 + 4 | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = _realloc(HEAP32[i2 >> 2] | 0, (i8 + i5 + i3 << 2) + 4 | 0) | 0;
   if (i4 | 0) {
    HEAP32[i2 >> 2] = i4;
    i5 = i3 + i5 | 0;
    break;
   }
   i1 = HEAP32[i11 >> 2] | 0;
   if (!i1) {
    i1 = 1;
    break L8;
   }
   while (1) {
    i13 = i1;
    i1 = HEAP32[i1 >> 2] | 0;
    _free(i13);
    if (!i1) {
     i1 = 1;
     break L8;
    }
   }
  } else {
   i2 = _malloc((i8 + i5 << 2) + 4 | 0) | 0;
   HEAP32[i13 + 4 >> 2] = i2;
   if (!i2) {
    i1 = HEAP32[i11 >> 2] | 0;
    if (!i1) {
     i1 = 1;
     break L8;
    }
    while (1) {
     i13 = i1;
     i1 = HEAP32[i1 >> 2] | 0;
     _free(i13);
     if (!i1) {
      i1 = 1;
      break L8;
     }
    }
   } else {
    if (!i5) {
     i5 = 0;
     break;
    }
    _memset(i2 | 0, 0, i5 << 2 | 0) | 0;
    break;
   }
  } while (0);
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  i4 = HEAP32[i13 + 4 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i4 + (i2 + i5 << 2) >> 2] = i3 + 4;
   i3 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 >> 2] = i3;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i8 >>> 0);
  HEAP32[i4 + (i8 + i5 << 2) >> 2] = 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i8;
  if (!(i12 & 4)) _qsort(i4 + (i5 << 2) | 0, i8, 4, fb + 1140 | 0);
 } while (0);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth8SwSolver22CpuClothSimulationTaskENS0_9AllocatorEE15growAndPushBackERKS4_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = i9 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i5 = 0; else i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i7 * 40 | 0, gb + 838004 | 0, 543) | 0;
 i8 = i9 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i5 + (i1 * 40 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i11 = i2 + 4 | 0;
   i13 = i11;
   i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
   i11 = i11 + 4 | 0;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i10 = i1 + 4 | 0;
   i12 = i10;
   HEAP16[i12 >> 1] = i13;
   HEAP16[i12 + 2 >> 1] = i13 >>> 16;
   i10 = i10 + 4 | 0;
   HEAP16[i10 >> 1] = i11;
   HEAP16[i10 + 2 >> 1] = i11 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i10 = i1 + 12 | 0;
   i11 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 >> 2] = gb + 168492 + 8;
   i10 = i1 + 20 | 0;
   i11 = i2 + 20 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   i1 = i1 + 40 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 40 | 0;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i5 + (i1 * 40 | 0) | 0;
 HEAP32[i13 >> 2] = gb + 106664 + 8;
 i12 = i4 + 4 | 0;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i2 = i5 + (i1 * 40 | 0) + 4 | 0;
 i11 = i2;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i2 = i2 + 4 | 0;
 HEAP16[i2 >> 1] = i12;
 HEAP16[i2 + 2 >> 1] = i12 >>> 16;
 HEAP32[i13 >> 2] = gb + 87404 + 8;
 i2 = i5 + (i1 * 40 | 0) + 12 | 0;
 i12 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + (i1 * 40 | 0) + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 >> 2] = gb + 168492 + 8;
 i1 = i5 + (i1 * 40 | 0) + 20 | 0;
 i13 = i4 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i13 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + (i13 * 40 | 0) | 0;
 if ((i13 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 40 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i6 >> 2] = i7;
  i13 = HEAP32[i8 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i8 >> 2] = i12;
  i13 = i5 + (i13 * 40 | 0) | 0;
  return i13 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i6 >> 2] = i7;
 i13 = HEAP32[i8 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i8 >> 2] = i12;
 i13 = i5 + (i13 * 40 | 0) | 0;
 return i13 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj478ES3_NS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741678 | 0) {
   i1 = gb + 741678 | 0;
   i2 = gb + 115520 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115520 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115520 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj459ES3_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741678 | 0) {
   i1 = gb + 741678 | 0;
   i2 = gb + 115520 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115520 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115520 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN19SkinnedMeshRenderer17PrepareSkinCustomERK10Matrix4x4f(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 4 | 0;
 i13 = i18;
 i17 = i15 + 356 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (!i1) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i14 = HEAP32[i4 + 156 >> 2] | 0;
 i5 = i15 + 412 | 0;
 i3 = HEAP32[i15 + 428 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i12 = i15 + 416 | 0;
 i3 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
 while (1) {
  i2 = i3 + -1 | 0;
  if ((i2 | 0) <= -1) {
   i3 = 0;
   break;
  }
  if (Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2]) > Math_fround(.0000999999974)) break; else i3 = i2;
 }
 do if ((i14 | 0) > 0) if (!(HEAP32[i4 + 176 >> 2] | 0)) i6 = 12; else {
  if (!(HEAP32[i15 + 372 >> 2] | 0)) {
   i1 = i15 + 396 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) {
    __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i15);
    if (!(HEAP32[i1 >> 2] | 0)) {
     i1 = HEAP32[i5 >> 2] | 0;
     i6 = 12;
     break;
    }
   }
  }
  i10 = (i3 | 0) > 0;
  i8 = 1;
 } else i6 = 12; while (0);
 if ((i6 | 0) == 12) {
  i10 = (i1 | 0) != 0;
  i8 = 0;
 }
 i7 = (i3 | 0) == 0;
 i5 = (i3 | i14 | 0) == 0 ? 1 : i14;
 i6 = i5 << 6;
 i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i3 << 2) + 128 + i6 | 0, 64, gb + 64024 | 0, 0, gb + 428921 | 0, 170) | 0;
 i1 = i9 + 92 | 0;
 i2 = i9;
 i4 = i2 + 128 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 i1 = i9 + 128 | 0;
 if (i5) {
  HEAP32[i9 + 68 >> 2] = i1;
  i1 = i1 + i6 | 0;
 }
 if (!i7) HEAP32[i9 + 72 >> 2] = i1;
 HEAP32[i9 + 28 >> 2] = i14;
 i4 = i9 + 76 | 0;
 HEAP32[i4 >> 2] = i3;
 i2 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 + 60 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 100 >> 2];
 HEAP8[i9 + 93 >> 0] = 0;
 if (i8) {
  i1 = HEAP32[i15 + 460 >> 2] | 0;
  if (!i1) {
   i1 = __Z18GetQualitySettingsv() | 0;
   i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 60 >> 2] | 0;
   i2 = HEAP32[i17 >> 2] | 0;
  }
  HEAP32[i9 + 20 >> 2] = i1;
  HEAP32[i9 + 24 >> 2] = __ZN4Mesh16GetSkinInfluenceEi(i2, i1) | 0;
  i2 = HEAP32[i9 + 68 >> 2] | 0;
  if ((HEAP16[gb + 1161604 + 6 >> 1] | 0) > -1) {
   HEAP32[i13 >> 2] = i15;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161604 | 0, i11);
   i1 = gb + 1161604 | 0;
  } else i1 = 0;
  if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i15, i2, i14) | 0) {
   i15 = HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0;
   __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j(i16, i2, (HEAP32[i15 + 156 >> 2] | 0) == 0 ? 0 : HEAP32[i15 + 144 >> 2] | 0, i2, i14);
  }
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if (!i10) {
  i17 = i9;
  STACKTOP = i18;
  return i17 | 0;
 }
 _memcpy(HEAP32[i9 + 72 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 HEAP32[i9 + 80 >> 2] = (HEAP32[i17 >> 2] | 0) + 72;
 i17 = i9;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZL22addOrRemoveRigidObjectILb0ELb1ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 if (i1 | 0) {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i2, i15) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 + i7 >> 2] = i6;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if (!((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0)) {
   STACKTOP = i16;
   return;
  }
  i1 = HEAP32[i10 + 260 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0)) {
   HEAP8[i9 >> 0] = 0;
   STACKTOP = i16;
   return;
  }
  if (!i1) {
   STACKTOP = i16;
   return;
  }
  i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  STACKTOP = i16;
  return;
 }
 i12 = i14 + 256 | 0;
 i9 = i14 + 260 | 0;
 HEAP32[i14 + 264 >> 2] = 0;
 i10 = i14 + 268 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 >> 2] = i14;
 HEAP32[i10 >> 2] = 64;
 i11 = i13 + 256 | 0;
 HEAP8[i11 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
 i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i7 = i1 + -16 | 0;
 i8 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i2, i15) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 if (i8 | 0) {
  i1 = i1 + -12 | 0;
  i5 = 0;
  do {
   i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i2 + i1 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 & 251658240 | 0) == 16777216) {
    HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
    HEAP32[i2 + i7 >> 2] = i6;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 i15 = HEAP32[i13 + 268 >> 2] | 0;
 do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i13 + 260 >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) {
   HEAP8[i11 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 } while (0);
 i15 = HEAP32[i10 >> 2] | 0;
 do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i14 | 0) == (i1 | 0)) {
   HEAP8[i12 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZN7mecanim12statemachine17EvaluateSelectorsEPKNS0_20StateMachineConstantEPKNS_18ValueArrayConstantEPNS_10ValueArrayEjPKNS0_17StateMachineInputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceE(i2, i18, i19, i1, i4, i3, i5) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i4 + 32 | 0;
 i16 = i2 + 20 | 0;
 i17 = i16;
 i15 = i3 + 28 | 0;
 i12 = i4 + 36 | 0;
 i13 = i18 + 4 | 0;
 i14 = i13;
 i11 = i5 + 8 | 0;
 L1 : while (1) {
  i2 = HEAP32[i20 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = (__ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i2) | 0) ^ 1;
  if ((i1 | 0) == -1 | i2) {
   i1 = 0;
   i21 = 25;
   break;
  }
  if (i1 >>> 0 < 3e4) {
   i21 = 25;
   break;
  }
  i1 = (HEAP32[i16 >> 2] | 0) + i17 + (i1 + -3e4 << 2) | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  i6 = (i6 | 0) == 0 ? 0 : i1 + i6 | 0;
  i1 = i6 + 12 | 0;
  HEAP32[i15 >> 2] = ((HEAP8[i1 >> 0] | 0) == 0 ? 4 : 2) | HEAP32[i15 >> 2];
  i2 = HEAP32[i20 >> 2] | 0;
  if (i2 | 0) {
   i10 = HEAP32[i2 + 8 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i10 | 0) | 0) __ZNK27StateMachineBehaviourPlayer25FireStateMachineBehaviourEiiN7mecanim12statemachine19StateMachineMessageE(HEAP32[i20 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP8[i1 >> 0] | 0 ? 32 : 64) | 0;
   i1 = HEAP32[i20 >> 2] | 0;
   if (i1 | 0) if (!(__ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i1) | 0)) {
    i1 = 0;
    i21 = 25;
    break;
   }
  }
  if (!(HEAP32[i6 >> 2] | 0)) {
   i1 = 0;
   i21 = 25;
   break;
  }
  i3 = i6 + 4 | 0;
  i4 = i3;
  i2 = 0;
  L16 : while (1) {
   i5 = (HEAP32[i3 >> 2] | 0) + i4 + (i2 << 2) | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i7 = (i7 | 0) == 0 ? 0 : i5 + i7 | 0;
   i5 = i7 + 4 | 0;
   if (!(HEAP32[i5 >> 2] | 0)) break;
   i8 = i7 + 8 | 0;
   i9 = i8;
   i1 = 0;
   while (1) {
    i22 = (HEAP32[i8 >> 2] | 0) + i9 + (i1 << 2) | 0;
    i10 = HEAP32[i22 >> 2] | 0;
    i1 = i1 + 1 | 0;
    if (!(__ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE((i10 | 0) == 0 ? 0 : i22 + i10 | 0, i18, i19) | 0)) break;
    i10 = HEAP32[i5 >> 2] | 0;
    if (i1 >>> 0 >= i10 >>> 0) {
     i21 = 17;
     break L16;
    }
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
    i1 = 0;
    i21 = 25;
    break L1;
   }
  }
  if ((i21 | 0) == 17) {
   i21 = 0;
   if (i10 | 0) {
    i3 = 0;
    do {
     i22 = (HEAP32[i8 >> 2] | 0) + i9 + (i3 << 2) | 0;
     i1 = HEAP32[i22 >> 2] | 0;
     i1 = (i1 | 0) == 0 ? 0 : i22 + i1 | 0;
     if ((HEAP32[i1 >> 2] | 0) == 1) {
      i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i18, HEAP32[i1 + 4 >> 2] | 0) | 0;
      if ((i2 | 0) > -1) {
       i1 = (HEAP32[i13 >> 2] | 0) + i14 | 0;
       if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) == 9) HEAP8[(HEAP32[HEAP32[i11 >> 2] >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] = 1;
      }
     }
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i10 | 0));
   }
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if ((i21 | 0) == 25) return i1 | 0;
 return 0;
}

function __ZN5physx2Gu19computeMTD_PlaneBoxERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_3BoxE(i5, i4, i6, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i9, i1 + 36 | 0, i1 + 48 | 0, i1, i1 + 12 | 0, i1 + 24 | 0);
 f8 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(f8 * f12);
 f11 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i3 = i6 + 4 | 0;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f8 + Math_fround(f11 * f10));
 f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i1 = i6 + 8 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f11 + Math_fround(f8 * f2));
 f11 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f8 = Math_fround(f11 + f8);
 f13 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) * f12);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 16 >> 2]) * f10));
 f13 = Math_fround(f11 + Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 20 >> 2]) * f2)));
 f13 = f8 < f13 ? f8 : f13;
 f8 = Math_fround(Math_fround(HEAPF32[i9 + 24 >> 2]) * f12);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 28 >> 2]) * f10));
 f8 = Math_fround(f11 + Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 32 >> 2]) * f2)));
 f8 = f13 < f8 ? f13 : f8;
 f13 = Math_fround(Math_fround(HEAPF32[i9 + 36 >> 2]) * f12);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 40 >> 2]) * f10));
 f13 = Math_fround(f11 + Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 44 >> 2]) * f2)));
 f13 = f8 < f13 ? f8 : f13;
 f8 = Math_fround(Math_fround(HEAPF32[i9 + 48 >> 2]) * f12);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 52 >> 2]) * f10));
 f8 = Math_fround(f11 + Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 56 >> 2]) * f2)));
 f8 = f13 < f8 ? f13 : f8;
 f13 = Math_fround(Math_fround(HEAPF32[i9 + 60 >> 2]) * f12);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 64 >> 2]) * f10));
 f13 = Math_fround(f11 + Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i9 + 68 >> 2]) * f2)));
 f13 = f8 < f13 ? f8 : f13;
 f8 = Math_fround(Math_fround(HEAPF32[i9 + 72 >> 2]) * f12);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 76 >> 2]) * f10));
 f8 = Math_fround(f11 + Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i9 + 80 >> 2]) * f2)));
 f8 = f13 < f8 ? f13 : f8;
 f12 = Math_fround(Math_fround(HEAPF32[i9 + 84 >> 2]) * f12);
 f10 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i9 + 88 >> 2]) * f10));
 f2 = Math_fround(f11 + Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i9 + 92 >> 2]) * f2)));
 f2 = f8 < f2 ? f8 : f2;
 if (f2 > Math_fround(0.0)) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 f11 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i5 >> 2] = f11;
 HEAPF32[i5 + 4 >> 2] = f12;
 HEAPF32[i5 + 8 >> 2] = f13;
 f13 = Math_fround(-f2);
 i9 = f2 < Math_fround(-0.0);
 HEAPF32[i4 >> 2] = i9 ? f13 : Math_fround(0.0);
 i9 = 1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89888 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89888 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89888 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89888 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89888 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89888 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89888 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89888 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx14PxsAABBManager18setDynamicAABBDataEjRKNS_18PxcAABBDataDynamicE(i12, i1, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 1 | 0;
 i9 = i13;
 i10 = i1 >>> 1;
 if (!(i1 & 1)) {
  i7 = i12 + 56 | 0;
  i8 = i12 + 64 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) == 1073741823) {
   i6 = i12 + 60 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i4 << 1;
   i5 = i5 >>> 0 < 64 ? 64 : i5;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 4, gb + 717789 | 0, 1491) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    _memcpy(i2 | 0, i1 | 0, i4 << 4 | 0) | 0;
    _memset(i2 + (i4 << 4) | 0, 0, i5 - i4 << 4 | 0) | 0;
   }
   i3 = i5 + -1 | 0;
   HEAP32[i2 + (i3 << 4) >> 2] = HEAP32[i8 >> 2];
   if (i4 >>> 0 < i3 >>> 0) {
    i1 = i4;
    do {
     i4 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i2 + (i4 << 4) >> 2] = i1;
    } while ((i1 | 0) != (i3 | 0));
   }
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i7 >> 2] | 0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[i6 >> 2] = i5;
   i3 = i7;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i3 = i7;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i9 = i2 + (i1 << 4) | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i9 = (HEAP32[i3 >> 2] | 0) + (i1 << 4) | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[(HEAP32[i12 + 32 >> 2] | 0) + (i10 << 2) >> 2] = i1;
  STACKTOP = i13;
  return;
 } else {
  i7 = i12 + 344 | 0;
  i8 = i12 + 352 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) == 1073741823) {
   i5 = i12 + 348 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i6 = i4 << 1;
   i6 = i6 >>> 0 < 64 ? 64 : i6;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i6 << 4, gb + 717789 | 0, 1491) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    _memcpy(i2 | 0, i1 | 0, i4 << 4 | 0) | 0;
    _memset(i2 + (i4 << 4) | 0, 0, i6 - i4 << 4 | 0) | 0;
   }
   i3 = i6 + -1 | 0;
   HEAP32[i2 + (i3 << 4) >> 2] = HEAP32[i8 >> 2];
   if (i4 >>> 0 < i3 >>> 0) {
    i1 = i4;
    do {
     i4 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i2 + (i4 << 4) >> 2] = i1;
    } while ((i1 | 0) != (i3 | 0));
   }
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i7 >> 2] | 0);
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i6;
   i3 = i7;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i3 = i7;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i9 = i2 + (i1 << 4) | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i9 = (HEAP32[i3 >> 2] | 0) + (i1 << 4) | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[(HEAP32[i12 + 320 >> 2] | 0) + (i10 << 2) >> 2] = i1;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj471ES3_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741678 | 0) {
   i1 = gb + 741678 | 0;
   i2 = gb + 115472 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115472 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115472 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj447ES3_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 761946 | 0) {
   i1 = gb + 761946 | 0;
   i2 = gb + 115856 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115856 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115856 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i10 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i4 = i10 & 65535;
 if (i10 << 16 >> 16) {
  i3 = i8 + 12 | 0;
  if (gb + 741693 | 0) {
   i1 = gb + 741693 | 0;
   i2 = gb + 115344 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115344 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115344 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj279ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89472 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89472 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89472 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89472 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89768 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89768 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89768 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89768 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj287ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89472 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89472 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89472 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89472 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN20ArchiveStorageHeader11WriteHeaderER12FileAccessorRKNS_6HeaderE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 i1 = i4 + 11 | 0;
 i9 = HEAP8[i1 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i2 = i4 + 4 | 0;
 if (!(__ZN12FileAccessor5WriteEyPKvPy(i3, (i8 ? HEAP32[i2 >> 2] | 0 : i9 & 255) + 1 | 0, 0, i8 ? HEAP32[i4 >> 2] | 0 : i4, i5) | 0)) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 i8 = i5;
 i9 = HEAP8[i1 >> 0] | 0;
 if (!((HEAP32[i8 + 4 >> 2] | 0) == 0 ? (HEAP32[i8 >> 2] | 0) == ((i9 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i9 & 255) + 1 | 0) : 0)) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i4 + 16 >> 2] | 0) | 0;
 i8 = __ZN12FileAccessor5WriteEyPKvPy(i3, 4, 0, i5, i6) | 0;
 i9 = i6;
 if (!(i8 & ((HEAP32[i9 >> 2] | 0) == 4 & (HEAP32[i9 + 4 >> 2] | 0) == 0))) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 i9 = i4 + 20 | 0;
 i1 = i9 + 11 | 0;
 i10 = HEAP8[i1 >> 0] | 0;
 i8 = i10 << 24 >> 24 < 0;
 i2 = i4 + 24 | 0;
 if (!(__ZN12FileAccessor5WriteEyPKvPy(i3, (i8 ? HEAP32[i2 >> 2] | 0 : i10 & 255) + 1 | 0, 0, i8 ? HEAP32[i9 >> 2] | 0 : i9, i5) | 0)) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i9 = i5;
 i10 = HEAP8[i1 >> 0] | 0;
 if (!((HEAP32[i9 + 4 >> 2] | 0) == 0 ? (HEAP32[i9 >> 2] | 0) == ((i10 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i10 & 255) + 1 | 0) : 0)) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i10 = i4 + 36 | 0;
 i1 = i10 + 11 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i2 = i4 + 40 | 0;
 if (!(__ZN12FileAccessor5WriteEyPKvPy(i3, (i9 ? HEAP32[i2 >> 2] | 0 : i8 & 255) + 1 | 0, 0, i9 ? HEAP32[i10 >> 2] | 0 : i10, i5) | 0)) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i9 = i5;
 i10 = HEAP8[i1 >> 0] | 0;
 if (!((HEAP32[i9 + 4 >> 2] | 0) == 0 ? (HEAP32[i9 >> 2] | 0) == ((i10 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i10 & 255) + 1 | 0) : 0)) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i9 = i4 + 56 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i9 = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i10 | 0) | 0;
 HEAP32[i5 + 4 >> 2] = i9;
 i9 = __ZN12FileAccessor5WriteEyPKvPy(i3, 8, 0, i5, i6) | 0;
 i10 = i6;
 if (!(i9 & ((HEAP32[i10 >> 2] | 0) == 8 & (HEAP32[i10 + 4 >> 2] | 0) == 0))) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i4 + 64 >> 2] | 0) | 0;
 i9 = __ZN12FileAccessor5WriteEyPKvPy(i3, 4, 0, i5, i6) | 0;
 i10 = i6;
 if (!(i9 & ((HEAP32[i10 >> 2] | 0) == 4 & (HEAP32[i10 + 4 >> 2] | 0) == 0))) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i4 + 68 >> 2] | 0) | 0;
 i9 = __ZN12FileAccessor5WriteEyPKvPy(i3, 4, 0, i5, i6) | 0;
 i10 = i6;
 if (!(i9 & ((HEAP32[i10 >> 2] | 0) == 4 & (HEAP32[i10 + 4 >> 2] | 0) == 0))) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i4 + 72 >> 2] | 0) | 0;
 i9 = __ZN12FileAccessor5WriteEyPKvPy(i3, 4, 0, i5, i6) | 0;
 i10 = i6;
 i10 = i9 & ((HEAP32[i10 >> 2] | 0) == 4 & (HEAP32[i10 + 4 >> 2] | 0) == 0);
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_(i2, i5, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 2176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 1096 | 0;
 i14 = i15 + 36 | 0;
 i6 = i15 + 24 | 0;
 i12 = i15;
 i7 = i15 + 12 | 0;
 if (!(HEAP32[i2 + 1144 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 __ZN12FileAccessorC2Ev(i13);
 i1 = i2 + 36 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 40 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, i1);
 i10 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i10 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i5 >> 2] | 0 : i5;
 i10 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i9, i10);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i12, i7);
 __ZN15FileSystemEntryC2EPKc(i14, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i13, i14, 0, 1) | 0) {
  i7 = __ZNK12FileAccessor4SizeEv(i13) | 0;
  i8 = getTempRet0() | 0;
  if ((i7 | 0) == 0 & (i8 | 0) == 0) i1 = 0; else {
   i9 = i11 + 11 | 0;
   i1 = HEAP8[i9 >> 0] | 0;
   i3 = i1 << 24 >> 24 < 0;
   i10 = i11 + 4 | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = i1 & 255;
   i2 = i3 ? i4 : i5;
   do if (i7 >>> 0 > i2 >>> 0) {
    i6 = i7 - i2 | 0;
    if (i6 | 0) {
     if (i3) {
      i2 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
      i3 = i4;
     } else {
      i2 = 10;
      i3 = i5;
     }
     if ((i2 - i3 | 0) >>> 0 < i6 >>> 0) {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i11, i2, i6 - i2 + i3 | 0, i3, i3, 0, 0);
      i1 = HEAP8[i9 >> 0] | 0;
     }
     i2 = i1 << 24 >> 24 < 0 ? HEAP32[i11 >> 2] | 0 : i11;
     _memset(i2 + i3 | 0, 0, i6 | 0) | 0;
     i1 = i3 + i6 | 0;
     if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i10 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
     HEAP8[i2 + i1 >> 0] = 0;
    }
   } else if (i3) {
    HEAP8[(HEAP32[i11 >> 2] | 0) + i7 >> 0] = 0;
    HEAP32[i10 >> 2] = i7;
    break;
   } else {
    HEAP8[i11 + i7 >> 0] = 0;
    HEAP8[i9 >> 0] = i7;
    break;
   } while (0);
   i1 = i12;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = __ZN12FileAccessor4ReadEyPvPy(i13, i7, i8, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, i12) | 0;
  }
  __ZN12FileAccessor5CloseEv(i13) | 0;
 } else i1 = 0;
 __ZN13FileEntryDataD2Ev(i14);
 __ZN12FileAccessorD2Ev(i13);
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN18AudioLowPassFilter26SetCustomLowpassLevelCurveERK17AnimationCurveTplIfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 44 | 0;
 i5 = i9 + 68 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i12 = i8 + 112 | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
  if (i4 | 0) {
   i2 = HEAP32[i9 + 56 >> 2] | 0;
   i3 = HEAP32[i8 + 100 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]))) break L1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  if ((HEAP32[i9 + 76 >> 2] | 0) == (HEAP32[i8 + 120 >> 2] | 0)) if ((HEAP32[i9 + 80 >> 2] | 0) == (HEAP32[i8 + 124 >> 2] | 0)) if ((HEAP32[i9 + 84 >> 2] | 0) == (HEAP32[i8 + 128 >> 2] | 0)) {
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i6 = i8 + 72 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i6 = i8 + 100 | 0;
 if ((i11 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i12 >> 2] = i2;
  i3 = i8 + 116 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i8 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
 }
 i12 = i8 + 120 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK17AnimationCurveTplIfE8GetRangeEv(i10, i11);
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i11, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 + 4 >> 2])));
 STACKTOP = i13;
 return;
}

function __ZN17ProfilerFrameDataD2Ev(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i14 = i17 + 1128 | 0;
 i15 = i17 + 1124 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i13 = 0;
  do {
   i12 = i2 + (i13 * 144 | 0) + 32 | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   if (i1 | 0) {
    i11 = i2 + (i13 * 144 | 0) + 20 | 0;
    i10 = 0;
    do {
     i8 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 4) + 8 >> 2] | 0;
     i9 = i8;
     if (i8) {
      i2 = HEAP32[gb + 1163260 >> 2] | 0;
      i3 = i2 + 12 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      i5 = i4 + 1 | 0;
      i6 = i2 + 16 | 0;
      i7 = HEAP32[i6 >> 2] | 0;
      i8 = i7 & 2147483647;
      do if (i5 >>> 0 > i8 >>> 0) {
       i1 = i7 << 1;
       i1 = (i1 | 0) == 0 ? 1 : i1;
       if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
        HEAP32[i6 >> 2] = i1;
        HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
        HEAP32[i6 >> 2] = i1;
        HEAP32[i2 >> 2] = i8;
        break;
       }
      } while (0);
      HEAP32[i3 >> 2] = i5;
      HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i9;
      i1 = HEAP32[i12 >> 2] | 0;
     }
     i10 = i10 + 1 | 0;
    } while (i10 >>> 0 < i1 >>> 0);
   }
   i13 = i13 + 1 | 0;
   i2 = HEAP32[i15 >> 2] | 0;
  } while ((i13 | 0) < (HEAP32[i14 >> 2] | 0));
 }
 if (i2 | 0) {
  i3 = i2 + -4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i1 = i2 + (i1 * 144 | 0) | 0;
   do {
    i1 = i1 + -144 | 0;
    __ZN17ProfilerFrameData10ThreadDataD2Ev(i1);
   } while ((i1 | 0) != (i2 | 0));
  }
  __ZdaPv(i3);
 }
 if ((HEAP32[i17 + 1228 >> 2] | 0) > -1) {
  i15 = i17 + 1212 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i17 + 1216 | 0);
  HEAP32[i15 >> 2] = 0;
 }
 i1 = i17 + 1192 | 0;
 if ((HEAP32[i17 + 1208 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i17 + 1196 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i17 + 1172 | 0;
 if ((HEAP32[i17 + 1188 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i17 + 1176 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i17 + 1152 | 0;
 if ((HEAP32[i17 + 1168 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i17 + 1156 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i17 + 220 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i15 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i17 + 232 >> 2] | 0;
  HEAP32[i16 >> 2] = 59;
  HEAP32[i16 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i15, i16);
 }
 i1 = i17 + 200 | 0;
 if ((HEAP32[i17 + 216 >> 2] | 0) <= -1) {
  STACKTOP = i18;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i17 + 204 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN13RenderTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 116 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 117 >> 0] = i1;
 i1 = i4 + 118 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5Umbra16TileTraverseTree4nextERi(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i13 = i7 + 64 | 0;
 i14 = i7 + 92 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i19 = 0;
  return i19 | 0;
 }
 i15 = i7 + 52 | 0;
 i16 = i7 + 48 | 0;
 i17 = i7 + 36 | 0;
 i18 = i7 + 40 | 0;
 i9 = i7 + 19 | 0;
 i10 = i7 + 4 | 0;
 i11 = i7 + 20 | 0;
 i12 = i7 + 68 | 0;
 L4 : while (1) {
  i2 = HEAP32[i7 + 96 + (i1 * 40 | 0) + 36 >> 2] | 0;
  i6 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP16[i6 + (i2 << 1) >> 1] | 0;
  L6 : do if (!(i3 & 32767)) {
   i2 = i1;
   while (1) {
    if (i3 << 16 >> 16 > -1) {
     i6 = HEAP32[i7 + 96 + (i2 * 40 | 0) + 12 >> 2] | 0;
     i2 = (HEAP32[i11 >> 2] | 0) + (i6 >> 5 << 2) | 0;
     HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(1 << (i6 & 31));
     i2 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
    } else {
     i6 = i3 & 16383;
     i20 = i7 + 96 + (i2 * 40 | 0) + 12 | 0;
     i3 = __ZNK5Umbra6KDTree4rankEi(i13, HEAP32[i20 >> 2] | 0) | 0;
     i4 = i3 << 1;
     HEAP32[i20 >> 2] = i4;
     i3 = i3 << 2;
     HEAP8[i7 + 96 + (i2 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 >> 5 << 2) >> 2] | 0) >>> (i3 & 28) & 3;
     HEAP32[i7 + 96 + (i2 * 40 | 0) + 32 >> 2] = 2;
     HEAP32[i7 + 96 + (i2 * 40 | 0) + 36 >> 2] = i6 + 1;
     i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
     i4 = i4 + -1 | 0;
     HEAP32[i7 + 96 + (i2 * 40 | 0) + 12 >> 2] = i4;
     i4 = i4 << 1;
     HEAP8[i7 + 96 + (i2 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 >> 5 << 2) >> 2] | 0) >>> (i4 & 30) & 3;
     HEAP32[i7 + 96 + (i2 * 40 | 0) + 32 >> 2] = 1;
     HEAP32[i7 + 96 + (i2 * 40 | 0) + 36 >> 2] = i6;
     i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    }
    HEAP32[i14 >> 2] = i2;
    if ((i2 | 0) < (i1 | 0)) {
     i1 = i2;
     break L6;
    }
    i3 = HEAP16[(HEAP32[i15 >> 2] | 0) + (HEAP32[i7 + 96 + (i2 * 40 | 0) + 36 >> 2] << 1) >> 1] | 0;
   }
  } else {
   i4 = HEAP32[i7 + 96 + (i1 * 40 | 0) + 12 >> 2] | 0;
   if (i3 << 16 >> 16 > -1) break L4;
   if ((HEAP32[i16 >> 2] | 0) > (i4 | 0)) f5 = Math_fround(HEAPF32[(HEAP32[i17 >> 2] | 0) + (HEAP32[i18 >> 2] | 0) + (i4 << 2) >> 2]); else {
    i20 = HEAPU8[i7 + 96 + (i1 * 40 | 0) + 29 >> 0] | 0;
    f5 = Math_fround(HEAPF32[i7 + 96 + (i1 * 40 | 0) + (i20 << 2) >> 2]);
    f5 = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i7 + 96 + (i1 * 40 | 0) + 16 + (i20 << 2) >> 2])) * Math_fround(.5));
   }
   i2 = i3 & 16383;
   i3 = i2 + 1 | 0;
   do if (!(HEAP16[i6 + (i3 << 1) >> 1] & 32767)) i1 = 1; else if (!(HEAP16[i6 + (i2 << 1) >> 1] & 32767)) i1 = 0; else {
    i1 = HEAPU8[i7 + 96 + (i1 * 40 | 0) + 29 >> 0] | 0;
    if (!(HEAP8[i9 >> 0] | 0)) {
     i1 = (HEAP8[i7 + 16 + i1 >> 0] | 0) != 0;
     break;
    } else {
     i1 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]) < f5;
     break;
    }
   } while (0);
   __ZN5Umbra15KDTraverseStackIiE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbii(i13, 3, f5, i1, i2, i3);
   i1 = HEAP32[i14 >> 2] | 0;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = 0;
   i19 = 21;
   break;
  }
 }
 if ((i19 | 0) == 21) return i1 | 0;
 HEAP32[i8 >> 2] = i4;
 i20 = i2;
 return i20 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj297ES3_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89656 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89656 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89656 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89656 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN14Texture2DArray8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i8, i1 + 80 | 0, 16);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i8, i1 + 84 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853473 | 0, i8, i1 + 88 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 92 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410455 | 0, i8, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410444 | 0, i8, i1 + 76 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i9, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932818 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 109 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i2, i4, gb + 411165 | 0, 1);
 __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i2, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 96 >> 2] | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN11AudioSource27SetCustomReverbZoneMixCurveERK17AnimationCurveTplIfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 124 | 0;
 i5 = i9 + 68 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i12 = i8 + 192 | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
  if (i4 | 0) {
   i2 = HEAP32[i9 + 56 >> 2] | 0;
   i3 = HEAP32[i8 + 180 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]))) break L1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  if ((HEAP32[i9 + 76 >> 2] | 0) == (HEAP32[i8 + 200 >> 2] | 0)) if ((HEAP32[i9 + 80 >> 2] | 0) == (HEAP32[i8 + 204 >> 2] | 0)) if ((HEAP32[i9 + 84 >> 2] | 0) == (HEAP32[i8 + 208 >> 2] | 0)) {
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i6 = i8 + 152 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i6 = i8 + 180 | 0;
 if ((i11 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i12 >> 2] = i2;
  i3 = i8 + 196 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i8 + 184 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 184 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
 }
 i12 = i8 + 200 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK17AnimationCurveTplIfE8GetRangeEv(i10, i11);
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i11, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 + 4 >> 2])));
 STACKTOP = i13;
 return;
}

function __ZN5physx3Scb17ArticulationJoint9syncStateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = f0;
 i4 = i5 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i5 + 8 | 0;
 if (!(i1 & 16777215)) {
  i5 = i1;
  HEAP32[i3 >> 2] = 0;
  i5 = i5 & -16777216;
  HEAP32[i4 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i1 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 1) {
  __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE(i5 + 12 | 0, i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 2) {
  __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE(i5 + 12 | 0, i2 + 28 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 4) {
  __ZN5physx2Sc21ArticulationJointCore20setTargetOrientationERKNS_6PxQuatE(i5 + 12 | 0, i2 + 56 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 8) {
  __ZN5physx2Sc21ArticulationJointCore17setTargetVelocityERKNS_6PxVec3E(i5 + 12 | 0, i2 + 72 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 16) {
  __ZN5physx2Sc21ArticulationJointCore12setStiffnessEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 84 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 32) {
  __ZN5physx2Sc21ArticulationJointCore10setDampingEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 88 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 64) {
  __ZN5physx2Sc21ArticulationJointCore21setInternalComplianceEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 92 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 128) {
  __ZN5physx2Sc21ArticulationJointCore21setExternalComplianceEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 96 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 256) {
  __ZN5physx2Sc21ArticulationJointCore28setSwingLimitContactDistanceEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 100 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 512) {
  __ZN5physx2Sc21ArticulationJointCore20setSwingLimitEnabledEb(i5 + 12 | 0, (HEAP8[i2 + 104 >> 0] | 0) != 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 4096) {
  __ZN5physx2Sc21ArticulationJointCore28setTwistLimitContactDistanceEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 116 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 8192) {
  __ZN5physx2Sc21ArticulationJointCore20setTwistLimitEnabledEb(i5 + 12 | 0, (HEAP8[i2 + 120 >> 0] | 0) != 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 1024) {
  __ZN5physx2Sc21ArticulationJointCore22setTangentialStiffnessEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 108 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 2048) {
  __ZN5physx2Sc21ArticulationJointCore20setTangentialDampingEf(i5 + 12 | 0, Math_fround(HEAPF32[i2 + 112 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 32768) {
  f6 = Math_fround(HEAPF32[i2 + 128 >> 2]);
  __ZN5physx2Sc21ArticulationJointCore13setSwingLimitEff(i5 + 12 | 0, f6, Math_fround(HEAPF32[i2 + 132 >> 2]));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!(i1 & 65536)) {
  i5 = i1;
  HEAP32[i3 >> 2] = 0;
  i5 = i5 & -16777216;
  HEAP32[i4 >> 2] = i5;
  return;
 }
 f6 = Math_fround(HEAPF32[i2 + 136 >> 2]);
 __ZN5physx2Sc21ArticulationJointCore13setTwistLimitEff(i5 + 12 | 0, f6, Math_fround(HEAPF32[i2 + 140 >> 2]));
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i5 & -16777216;
 HEAP32[i4 >> 2] = i5;
 return;
}

function __ZN5physx23correlatePatchesCoulombERNS_27PxcCorrelationBufferCoulombERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjjj(i20, i19, i1, i2, f21, i22, i4, i23) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f21 = Math_fround(f21);
 i22 = i22 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 var i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i24 = 0, f25 = f0;
 i18 = i20 + 1796 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i17 = i20 + 1792 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  i3 = i1;
  i1 = 0;
 } else {
  i23 = i2;
  i24 = 0;
  HEAP32[i18 >> 2] = i23;
  return i24 | 0;
 }
 do {
  i12 = HEAPU16[i20 + (i4 * 12 | 0) >> 1] | 0;
  i16 = HEAP32[i19 + (i12 << 6) >> 2] | 0;
  i11 = HEAP32[i19 + (i12 << 6) + 4 >> 2] | 0;
  i12 = HEAP32[i19 + (i12 << 6) + 8 >> 2] | 0;
  i13 = i20 + (i4 * 12 | 0) + 2 | 0;
  i14 = HEAPU16[i13 >> 1] | 0;
  i15 = Math_imul(i14, i22) | 0;
  L5 : do if (i2 >>> 0 > i23 >>> 0) {
   f6 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f7 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f8 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   i9 = i20 + (i4 * 12 | 0) + 8 | 0;
   i10 = i20 + (i4 * 12 | 0) + 10 | 0;
   i5 = i23;
   do {
    f25 = Math_fround(f6 * Math_fround(HEAPF32[i20 + 768 + (i5 * 20 | 0) >> 2]));
    f25 = Math_fround(f25 + Math_fround(f7 * Math_fround(HEAPF32[i20 + 768 + (i5 * 20 | 0) + 4 >> 2])));
    if (!(Math_fround(f25 + Math_fround(f8 * Math_fround(HEAPF32[i20 + 768 + (i5 * 20 | 0) + 8 >> 2]))) < f21)) if ((HEAP16[i20 + 768 + (i5 * 20 | 0) + 12 >> 1] | 0) == (HEAP16[i9 >> 1] | 0)) if ((HEAP16[i20 + 768 + (i5 * 20 | 0) + 14 >> 1] | 0) == (HEAP16[i10 >> 1] | 0)) break L5;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i2 >>> 0);
  } else i5 = i23; while (0);
  if ((i5 | 0) == (i2 | 0)) if (i1 | (i2 | 0) == 32) i1 = 1; else {
   HEAP16[i20 + 768 + (i2 * 20 | 0) + 16 >> 1] = i15 & 255;
   HEAP32[i20 + 768 + (i2 * 20 | 0) >> 2] = i16;
   HEAP32[i20 + 768 + (i2 * 20 | 0) + 4 >> 2] = i11;
   HEAP32[i20 + 768 + (i2 * 20 | 0) + 8 >> 2] = i12;
   HEAP32[i20 + 1408 + (i2 << 2) >> 2] = HEAPU16[i13 >> 1];
   HEAP16[i20 + 768 + (i2 * 20 | 0) + 12 >> 1] = HEAP16[i20 + (i4 * 12 | 0) + 8 >> 1] | 0;
   HEAP16[i20 + 768 + (i2 * 20 | 0) + 14 >> 1] = HEAP16[i20 + (i4 * 12 | 0) + 10 >> 1] | 0;
   HEAP16[i20 + 768 + (i2 * 20 | 0) + 18 >> 1] = HEAP16[i20 + (i4 * 12 | 0) + 6 >> 1] | 0;
   HEAP16[i20 + 1664 + (i2 << 2) >> 1] = -1;
   HEAP16[i20 + 1664 + (i2 << 2) + 2 >> 1] = -1;
   HEAP16[i20 + (i4 * 12 | 0) + 4 >> 1] = -1;
   i3 = i20 + 1536 + (i5 << 2) | 0;
   i2 = i2 + 1 | 0;
   i1 = 0;
   i24 = 12;
  } else {
   i3 = i20 + 768 + (i5 * 20 | 0) + 16 | 0;
   HEAP16[i3 >> 1] = (HEAPU16[i3 >> 1] | 0) + (i15 & 255);
   i3 = i20 + 1408 + (i5 << 2) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i14;
   i3 = i20 + 1536 + (i5 << 2) | 0;
   HEAP16[i20 + (i4 * 12 | 0) + 4 >> 1] = HEAP32[i3 >> 2];
   i24 = 12;
  }
  if ((i24 | 0) == 12) {
   i24 = 0;
   HEAP32[i3 >> 2] = i4;
   i3 = HEAP32[i17 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i3 >>> 0);
 HEAP32[i18 >> 2] = i2;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
 }
 HEAP32[i8 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i8 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i8 + 88 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 104 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i8 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN22ScAfterIntegrationTask11runInternalEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = i3 + 40 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i16 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i15 | 0, i16 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i16 = i1 + 19 & -16;
   HEAP32[i16 + -4 >> 2] = i16 - i1;
   i1 = i16;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
 }
 i9 = i1 + 9156 | 0;
 i10 = i1 + 9160 | 0;
 _memset(HEAP32[i9 >> 2] | 0, 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
 i11 = i3 + 24 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  i17 = HEAP32[i17 >> 2] | 0;
  i17 = i17 + 224 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i17, i1);
  return;
 }
 i12 = i3 + 20 | 0;
 i13 = i3 + 28 | 0;
 i14 = i3 + 32 | 0;
 i15 = i3 + 36 | 0;
 i16 = i1 + 9164 | 0;
 i6 = i3 + 44 | 0;
 i2 = 0;
 i8 = 0;
 do {
  i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i8 << 2) >> 2] | 0;
  i7 = i3 + -64 | 0;
  f19 = Math_fround(HEAPF32[i13 >> 2]);
  f18 = Math_fround(HEAPF32[i14 >> 2]);
  __ZN5physx2Sc7BodySim10sleepCheckEffb(i7, f19, f18, (HEAP8[i15 >> 0] | 0) != 0);
  if (!(HEAP8[(HEAP32[i3 + -12 >> 2] | 0) + 45 >> 0] & 1)) {
   i5 = HEAP32[i3 + 72 >> 2] | 0;
   if ((i5 | 0) != 1073741823) {
    i3 = (i5 + 32 | 0) >>> 5;
    if (i3 >>> 0 > (HEAP32[i10 >> 2] & 2147483647) >>> 0) {
     i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16, i3 << 2, gb + 769739 | 0, 329) | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     if (i4 | 0) {
      _memcpy(i2 | 0, i4 | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
      if ((HEAP32[i10 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, HEAP32[i9 >> 2] | 0);
     }
     i4 = HEAP32[i10 >> 2] | 0;
     _memset(i2 + ((i4 & 2147483647) << 2) | 0, 0, i3 - i4 << 2 | 0) | 0;
     HEAP32[i9 >> 2] = i2;
     HEAP32[i10 >> 2] = i3;
    } else i2 = HEAP32[i9 >> 2] | 0;
    i2 = i2 + (i5 >>> 5 << 2) | 0;
    HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i5 & 31);
    i2 = 1;
   }
  }
  __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(i7, HEAP32[i6 >> 2] | 0);
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 if (!i2) {
  i17 = HEAP32[i17 >> 2] | 0;
  i17 = i17 + 224 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i17, i1);
  return;
 }
 i16 = (HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0) + 156 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i16 >> 2] | 0);
 __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj((HEAP32[i17 >> 2] | 0) + 5912 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] & 2147483647);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i16 >> 2] | 0);
 i17 = HEAP32[i17 >> 2] | 0;
 i17 = i17 + 224 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i17, i1);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if (i5 >>> 0 >= i2 >>> 0) {
   if (i2 >>> 0 >= i5 >>> 0) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__2L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i7, i8, i3, i2, i9, i10, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 if (!(i4 & 2)) i5 = 4; else if ((i2 - i3 | 0) < 3) i1 = 1; else {
  HEAP32[i9 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -17;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -69;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -65;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  i6 = i7;
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L4;
   }
   i3 = HEAP16[i1 >> 1] | 0;
   i5 = i3 & 65535;
   if (i5 >>> 0 > i10 >>> 0) {
    i1 = 2;
    break L4;
   }
   do if ((i3 & 65535) < 128) {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i2 - i1 | 0) < 1) {
     i1 = 1;
     break L4;
    }
    HEAP32[i9 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3;
   } else {
    if ((i3 & 65535) < 2048) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 2) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i5 >>> 6 | 192;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i5 & 63 | 128;
     break;
    }
    if ((i3 & 65535) < 55296) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 3) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i5 >>> 12 | 224;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i5 >>> 6 & 63 | 128;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i5 & 63 | 128;
     break;
    }
    if ((i3 & 65535) >= 56320) {
     if ((i3 & 65535) < 57344) {
      i1 = 2;
      break L4;
     }
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 3) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i5 >>> 12 | 224;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i5 >>> 6 & 63 | 128;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i5 & 63 | 128;
     break;
    }
    if ((i6 - i1 | 0) < 4) {
     i1 = 1;
     break L4;
    }
    i1 = i1 + 2 | 0;
    i3 = HEAPU16[i1 >> 1] | 0;
    if ((i3 & 64512 | 0) != 56320) {
     i1 = 2;
     break L4;
    }
    if ((i2 - (HEAP32[i9 >> 2] | 0) | 0) < 4) {
     i1 = 1;
     break L4;
    }
    i4 = i5 & 960;
    if (((i4 << 10) + 65536 | i5 << 10 & 64512 | i3 & 1023) >>> 0 > i10 >>> 0) {
     i1 = 2;
     break L4;
    }
    HEAP32[i8 >> 2] = i1;
    i1 = (i4 >>> 6) + 1 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i1 >>> 2 | 240;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i5 >>> 2 & 15 | i1 << 4 & 48 | 128;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i5 << 4 & 48 | i3 >>> 6 & 15 | 128;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i3 & 63 | 128;
   } while (0);
   i1 = (HEAP32[i8 >> 2] | 0) + 2 | 0;
   HEAP32[i8 >> 2] = i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i4 = i7 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i5 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i8 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i4 >> 2] = i1;
 __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 40 | 0, i5);
 i1 = i7 + 364 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 360 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 362 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 375 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 361 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 404 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 368 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 372 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 2);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 374 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  STACKTOP = i9;
  return;
 }
}

function __ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 48 | 0;
 i11 = i12;
 if ((i9 | 0) == 0 | (i1 & 64 | 0) == 0) {
  STACKTOP = i12;
  return i9 | 0;
 }
 HEAP32[i11 >> 2] = i9;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(i9) | 0;
  if (!i1) {
   STACKTOP = i12;
   return i9 | 0;
  }
 }
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i7 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do if (!i2) {
  HEAP32[i10 >> 2] = i3;
  i5 = i3;
  i4 = i3;
 } else {
  while (1) {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i3 | 0) > (i9 | 0)) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i6 = 13;
     break;
    } else i2 = i3;
   } else {
    if ((i3 | 0) >= (i9 | 0)) {
     i6 = 18;
     break;
    }
    i4 = i2 + 4 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) {
     i6 = 17;
     break;
    } else i2 = i3;
   }
  }
  if ((i6 | 0) == 13) {
   HEAP32[i10 >> 2] = i2;
   i5 = i2;
   i4 = i2;
   break;
  } else if ((i6 | 0) == 17) {
   HEAP32[i10 >> 2] = i2;
   i5 = i2;
   break;
  } else if ((i6 | 0) == 18) {
   HEAP32[i10 >> 2] = i2;
   i5 = i2;
   i4 = i10;
   break;
  }
 } while (0);
 if (HEAP32[i4 >> 2] | 0) {
  STACKTOP = i12;
  return i9 | 0;
 }
 i2 = __Znwj(20) | 0;
 HEAP32[i2 + 16 >> 2] = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i5;
 HEAP32[i4 >> 2] = i2;
 i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i3) {
  HEAP32[i7 >> 2] = i3;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i2);
 i2 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb(i11, 0, 0);
 HEAP32[i11 + 16 >> 2] = i8;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i11 | 0);
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i11 + 24 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i11 = HEAP32[i11 + 32 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 STACKTOP = i12;
 return i9 | 0;
}

function __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i6 = i7;
 i13 = i7 + ((((HEAP32[i2 >> 2] | 0) - i6 | 0) / 36 | 0) * 36 | 0) | 0;
 i14 = i12 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i3 = i12 + 8 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i2 = i5;
 i4 = i11;
 if (i5 >>> 0 < i11 >>> 0) {
  if ((i13 | 0) == (i5 | 0)) {
   i3 = i13;
   i6 = i1;
   i9 = i3 + 36 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
    i3 = i3 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i3 | 0) < (i9 | 0));
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 36;
   i14 = i13;
   return i14 | 0;
  }
  i4 = i2 - (i13 + 36) | 0;
  i2 = i13 + (((i4 | 0) / 36 | 0) * 36 | 0) | 0;
  if (i2 >>> 0 < i5 >>> 0) {
   i3 = i5;
   do {
    i6 = i2;
    i9 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
     i3 = i3 + 4 | 0;
     i6 = i6 + 4 | 0;
    } while ((i3 | 0) < (i9 | 0));
    i2 = i2 + 36 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 36 | 0;
    HEAP32[i14 >> 2] = i3;
   } while (i2 >>> 0 < i5 >>> 0);
  }
  if (i4 | 0) _memmove(i5 + (((i4 | 0) / -36 | 0) * 36 | 0) | 0, i13 | 0, i4 | 0) | 0;
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 36 | 0 : i1;
  i3 = i13;
  i6 = i1;
  i9 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   i3 = i3 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i3 | 0) < (i9 | 0));
  i14 = i13;
  return i14 | 0;
 }
 i5 = ((i2 - i6 | 0) / 36 | 0) + 1 | 0;
 if (i5 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i7 = HEAP32[i12 >> 2] | 0;
  i11 = i3;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i7;
 } else {
  i11 = i3;
  i2 = i4;
  i3 = i6;
 }
 i10 = (i2 - i3 | 0) / 36 | 0;
 i6 = i10 << 1;
 i6 = i10 >>> 0 < 59652323 ? (i6 >>> 0 < i5 >>> 0 ? i5 : i6) : 119304647;
 i10 = i13;
 i2 = i10 - i3 | 0;
 i4 = (i2 | 0) / 36 | 0;
 if (!i6) i9 = 0; else i9 = __Znwj(i6 * 36 | 0) | 0;
 i3 = i9 + (i4 * 36 | 0) | 0;
 i5 = i3;
 i8 = i9 + (i6 * 36 | 0) | 0;
 do if ((i4 | 0) == (i6 | 0)) {
  if ((i2 | 0) > 0) {
   i3 = i3 + (((i6 + 1 | 0) / -2 | 0) * 36 | 0) | 0;
   i5 = i3;
   break;
  }
  i2 = i6 * 36 | 0;
  i2 = (i2 | 0) == 0 ? 1 : ((i2 | 0) / 36 | 0) << 1;
  if (!i2) i4 = 0; else i4 = __Znwj(i2 * 36 | 0) | 0;
  i3 = i4 + ((i2 >>> 2) * 36 | 0) | 0;
  i5 = i3;
  i2 = i4 + (i2 * 36 | 0) | 0;
  if (!i9) i8 = i2; else {
   __ZdlPv(i9);
   i8 = i2;
   i7 = HEAP32[i12 >> 2] | 0;
  }
 } while (0);
 i6 = i1;
 i9 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  i3 = i3 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i3 | 0) < (i9 | 0));
 i1 = i5 + 36 | 0;
 i2 = i10 - i7 | 0;
 i3 = i5 + (((i2 | 0) / -36 | 0) * 36 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i7 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i13 | 0, i2 | 0) | 0;
  i1 = i1 + (((i2 >>> 0) / 36 | 0) * 36 | 0) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 if (!i2) {
  i14 = i5;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i5;
 return i14 | 0;
}

function __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStylei(i9, i13, i1, i7, i8, i11) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i10 = 0, i12 = 0;
 i12 = HEAP32[i9 + 280 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i10 = (HEAP32[i9 + 276 >> 2] | 0) + 4 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 L1 : do if (!i6) {
  if (!(HEAP32[i9 + 60 >> 2] | 0)) {
   switch (i5 | 0) {
   case 7:
   case 8:
   case 12:
    break L1;
   default:
    {}
   }
   return i1 | 0;
  }
  if (!(HEAP32[i9 + 268 >> 2] | 0)) {
   switch (i5 | 0) {
   case 0:
   case 1:
   case 9:
   case 10:
   case 16:
    break;
   default:
    break L1;
   }
   return i1 | 0;
  }
 } else switch (i5 | 0) {
 case 3:
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP32[i9 + 60 >> 2] | 0)) {
    i13 = i1;
    return i13 | 0;
   }
   if (HEAP32[i9 + 268 >> 2] | 0) break L1;
   i5 = (i6 | 0) == (i11 | 0) ? i5 : 11;
   break L1;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP32[i9 + 60 >> 2] | 0)) {
    i13 = i1;
    return i13 | 0;
   }
   if ((i6 | 0) == (i11 | 0) | (HEAP32[i9 + 268 >> 2] | 0) != 0) break L1;
   i5 = (HEAP32[i9 >> 2] | 0) == (i11 | 0) ? i5 : 11;
   break L1;
  }
 default:
  break L1;
 } while (0);
 switch (i5 | 0) {
 case 0:
  {
   f2 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f3 = Math_fround(HEAPF32[i13 >> 2]);
   if (!(f3 <= f2)) {
    i13 = i1;
    return i13 | 0;
   }
   if (!(Math_fround(f3 + Math_fround(HEAPF32[i13 + 8 >> 2])) > f2)) {
    i13 = i1;
    return i13 | 0;
   }
   f2 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   if (!(f2 <= f4)) {
    i13 = i1;
    return i13 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i13 + 12 >> 2])) > f4)) {
    i13 = i1;
    return i13 | 0;
   }
   HEAP32[i10 >> 2] = i11;
   HEAP32[i12 >> 2] = 12;
   i13 = i1;
   return i13 | 0;
  }
 case 4:
  {
   if ((HEAP16[i12 + 36 >> 1] | 0) != 32) {
    i13 = i1;
    return i13 | 0;
   }
   if ((HEAP32[i9 >> 2] | 0) != (i11 | 0)) {
    i13 = i1;
    return i13 | 0;
   }
   HEAP32[i12 >> 2] = 12;
   HEAP32[i9 + 64 >> 2] = 1;
   i13 = i1 ^ 1;
   return i13 | 0;
  }
 case 1:
  {
   if ((i6 | 0) != (i11 | 0)) {
    i13 = i1;
    return i13 | 0;
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i12 >> 2] = 12;
   f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i12 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i13 >> 2]);
   if (!(f2 <= f3)) {
    i13 = i1;
    return i13 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i13 + 8 >> 2])) > f3)) {
    i13 = i1;
    return i13 | 0;
   }
   f2 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   if (!(f2 <= f4)) {
    i13 = i1;
    return i13 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i13 + 12 >> 2])) > f4)) {
    i13 = i1;
    return i13 | 0;
   }
   HEAP32[i9 + 64 >> 2] = 1;
   i13 = i1 ^ 1;
   return i13 | 0;
  }
 case 3:
  {
   if ((i6 | 0) != (i11 | 0)) {
    i13 = i1;
    return i13 | 0;
   }
   HEAP32[i12 >> 2] = 12;
   i13 = i1;
   return i13 | 0;
  }
 case 7:
  {
   __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib(i8, i9, i13, i7, i11, i1);
   i13 = i1;
   return i13 | 0;
  }
 default:
  {
   i13 = i1;
   return i13 | 0;
  }
 }
 return 0;
}

function __ZN11AudioSource26SetCustomSpatialBlendCurveERK17AnimationCurveTplIfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 36 | 0;
 i5 = i9 + 68 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i12 = i8 + 104 | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
  if (i4 | 0) {
   i2 = HEAP32[i9 + 56 >> 2] | 0;
   i3 = HEAP32[i8 + 92 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]))) break L1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  if ((HEAP32[i9 + 76 >> 2] | 0) == (HEAP32[i8 + 112 >> 2] | 0)) if ((HEAP32[i9 + 80 >> 2] | 0) == (HEAP32[i8 + 116 >> 2] | 0)) if ((HEAP32[i9 + 84 >> 2] | 0) == (HEAP32[i8 + 120 >> 2] | 0)) {
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i6 = i8 + 64 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i6 = i8 + 92 | 0;
 if ((i11 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i12 >> 2] = i2;
  i3 = i8 + 108 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i8 + 96 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 96 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
 }
 i12 = i8 + 112 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK17AnimationCurveTplIfE8GetRangeEv(i10, i11);
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i11, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 + 4 >> 2])));
 STACKTOP = i13;
 return;
}

function __ZN11AudioSource20SetCustomSpreadCurveERK17AnimationCurveTplIfE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 212 | 0;
 i5 = i9 + 68 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i12 = i8 + 280 | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i12 >> 2] | 0)) {
  if (i4 | 0) {
   i2 = HEAP32[i9 + 56 >> 2] | 0;
   i3 = HEAP32[i8 + 268 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]))) break L1;
    f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
    if (!(f14 == Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]))) break L1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  if ((HEAP32[i9 + 76 >> 2] | 0) == (HEAP32[i8 + 288 >> 2] | 0)) if ((HEAP32[i9 + 80 >> 2] | 0) == (HEAP32[i8 + 292 >> 2] | 0)) if ((HEAP32[i9 + 84 >> 2] | 0) == (HEAP32[i8 + 296 >> 2] | 0)) {
   STACKTOP = i13;
   return;
  }
 } while (0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i6 = i8 + 240 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i6 = i8 + 268 | 0;
 if ((i11 | 0) != (i9 | 0)) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] << 4;
  i2 = i1 >> 4;
  HEAP32[i12 >> 2] = i2;
  i3 = i8 + 284 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i8 + 272 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 272 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i7 | 0, HEAP32[i12 >> 2] << 4 | 0) | 0;
 }
 i12 = i8 + 288 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK17AnimationCurveTplIfE8GetRangeEv(i10, i11);
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i11, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i10 + 4 >> 2])));
 STACKTOP = i13;
 return;
}

function __ZN10DynamicVBO9DrawChunkERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationPKNS_10DrawParamsEi(i12, i13, i14, i15, i16, i2, i4) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17 + 40 | 0;
 i11 = i17 + 28 | 0;
 i9 = i17;
 i10 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 24 >> 2] | 0, i12 | 0, i13 | 0, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) if (!(HEAP32[i10 + 12 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 if ((i2 | 0) == 0 | (i4 | 0) == 0) {
  HEAP32[i3 + 8 >> 2] = i1;
  HEAP32[i3 + 16 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i10 + 4 >> 2];
  i2 = i3;
  i4 = 1;
 }
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 i6 = gb + 63160 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i4 << 5;
 do if (!i1) {
  i3 = 0;
  i1 = 0;
 } else {
  i5 = (i1 | 4) + -1 | 0;
  if (i5 >>> 0 < 2e3) {
   i3 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i5 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 425574 | 0, 161) | 0;
   i7 = gb + 64016 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i3 = i8;
   HEAP32[i3 >> 2] = i6;
   HEAP32[i3 + 4 >> 2] = i7;
   i3 = i1;
   break;
  }
 } while (0);
 i7 = i3 + 3 & -4;
 if ((i4 | 0) > 0) {
  i5 = i10 + 16 | 0;
  i1 = 0;
  do {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i9 + 24 >> 2] = 0;
   i6 = i7 + (i1 << 5) | 0;
   HEAP32[i6 >> 2] = -1;
   i3 = i7 + (i1 << 5) + 4 | 0;
   HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + (i1 << 5) + 20 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 8 >> 2];
   i6 = HEAP32[i2 + (i1 * 20 | 0) + 4 >> 2] | 0;
   if (!(HEAP8[i10 >> 0] | 0)) HEAP32[i7 + (i1 << 5) + 16 >> 2] = i6; else {
    HEAP32[i7 + (i1 << 5) + 8 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 16 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2];
    HEAP32[i7 + (i1 << 5) + 12 >> 2] = i6;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 mftCall_viiiiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i7 | 0, i4 | 0, HEAP32[i2 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i17;
 return;
}

function __Z19DestroyWorldObjectsRK13dynamic_arrayIiLj4EE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i9 = i6 + 12 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if (!(HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0)) __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
    }
   }
   if ((i5 | 0) == 10) i5 = 0;
   i4 = i4 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i4 | 0) != (i1 + (i2 << 2) | 0));
  if (i2 | 0) {
   i4 = i1;
   do {
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i1 = 0; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i11 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
  }
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 3084 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + 2316 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __Z16CollectDrawStatsR9DrawStats(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0;
 HEAP32[i1 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3708 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3640 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3644 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3648 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3656 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3664 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3660 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3668 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3672 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3680 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3676 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3684 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3688 >> 2];
 HEAP8[i1 + 52 >> 0] = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0;
 HEAP32[i1 + 56 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3696 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3692 >> 2];
 HEAP32[i1 + 64 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3700 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3704 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3752 >> 2];
 i2 = (__Z12GetGfxDevicev() | 0) + 3616 | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 HEAP32[i1 + 76 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3728 >> 2];
 HEAP32[i1 + 80 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3732 >> 2];
 HEAP32[i1 + 84 >> 2] = __ZN13RenderTexture28GetCreatedRenderTextureCountEv() | 0;
 HEAP32[i1 + 88 >> 2] = __ZN13RenderTexture28GetCreatedRenderTextureBytesEv() | 0;
 HEAP32[i1 + 92 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3620 >> 2];
 HEAP32[i1 + 96 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3776 >> 2];
 HEAP32[i1 + 100 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3780 >> 2];
 HEAP32[i1 + 104 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3796 >> 2];
 HEAP32[i1 + 108 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3800 >> 2];
 HEAP32[i1 + 112 >> 2] = __ZNK9GfxDevice19GetTotalBufferCountEv(__Z12GetGfxDevicev() | 0) | 0;
 HEAP32[i1 + 116 >> 2] = __ZNK9GfxDevice19GetTotalBufferBytesEv(__Z12GetGfxDevicev() | 0) | 0;
 HEAP32[i1 + 120 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3624 >> 2];
 HEAP32[i1 + 124 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3628 >> 2];
 HEAP32[i1 + 128 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3632 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(__Z12GetGfxDevicev() | 0) + 3636 >> 2];
 f5 = Math_fround(Math_fround(HEAPF32[(__Z15GetGraphicsCapsv() | 0) + 100 >> 2]) + Math_fround(.5));
 i2 = f5 >= Math_fround(0.0);
 f4 = Math_fround(f5 + Math_fround(-.99999994));
 HEAP32[i1 + 140 >> 2] = ~~(i2 ? f5 : f4);
 HEAP32[i1 + 136 >> 2] = __ZN19SkinnedMeshRenderer34GetVisibleSkinnedMeshRendererCountEv() | 0;
 i1 = i1 + 144 | 0;
 i2 = (__Z12GetGfxDevicev() | 0) + 3816 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN5physx2Sn5ConvX20convertManifestTableEPKvRi(i18, i1, i17) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i19 + 56 | 0;
 i4 = i19 + 24 | 0;
 i16 = i19;
 i15 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i18, i1, 16) | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) - (0 - i1 & 15);
 i2 = i15 + 4 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i18, i15);
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -4;
 i13 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i18, gb + 744930 | 0, 1) | 0;
 i1 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i18, gb + 744930 | 0, 2) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __ZNK5physx2Sn9MetaClass14getFieldByNameEPKcRNS0_15PxMetaDataEntryE(i13, gb + 1047471 | 0, i3) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZNK5physx2Sn9MetaClass14getFieldByNameEPKcRNS0_15PxMetaDataEntryE(i1, gb + 744923 | 0, i4) | 0;
 L1 : do if ((i15 | 0) > 0) {
  i14 = i3 + 12 | 0;
  i10 = i3 + 8 | 0;
  i11 = i18 + 304 | 0;
  i12 = i18 + 312 | 0;
  i9 = i1 + 16 | 0;
  i6 = i4 + 12 | 0;
  i7 = i16 + 8 | 0;
  i8 = i13 + 16 | 0;
  i1 = 0;
  i5 = 0;
  while (1) {
   i4 = __ZN5physx2Sn4peekEiPKci(HEAP32[i14 >> 2] | 0, i2 + (HEAP32[i10 >> 2] | 0) | 0, 0) | 0;
   getTempRet0() | 0;
   i3 = _PxGetFoundation() | 0;
   __ZN5physx27PxDefaultMemoryOutputStreamC2ERNS_19PxAllocatorCallbackE(i16, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   i20 = HEAP32[i12 >> 2] | 0;
   HEAP32[i11 >> 2] = i16;
   HEAP32[i12 >> 2] = 0;
   __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i18, i2, i13, 0) | 0;
   HEAP32[i11 >> 2] = i3;
   HEAP32[i12 >> 2] = i20;
   __ZN5physx2Sn5ConvX6outputEi(i18, i1);
   i20 = HEAP32[i6 >> 2] | 0;
   i3 = (HEAP32[i9 >> 2] | 0) - i20 | 0;
   i21 = HEAP32[i11 >> 2] | 0;
   mftCall_iiii(HEAP32[HEAP32[i21 >> 2] >> 2] | 0, i21 | 0, (HEAP32[i7 >> 2] | 0) + i20 | 0, i3 | 0) | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) - i3;
   i4 = __ZN5physx2Sn5ConvX12getMetaClassENS_14PxConcreteType4EnumENS0_12MetaDataTypeE(i18, i4, 2) | 0;
   if (!i4) break;
   i2 = i2 + i3 | 0;
   i21 = HEAP32[i4 + 16 >> 2] | 0;
   i1 = i21 + i1 + (0 - i21 & 15) | 0;
   __ZN5physx27PxDefaultMemoryOutputStreamD2Ev(i16);
   i5 = i5 + 1 | 0;
   if ((i5 | 0) >= (i15 | 0)) break L1;
  }
  __ZN5physx27PxDefaultMemoryOutputStreamD2Ev(i16);
  i21 = 0;
  STACKTOP = i19;
  return i21 | 0;
 } else i1 = 0; while (0);
 __ZN5physx2Sn5ConvX6outputEi(i18, i1);
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -4;
 i21 = i2 + 4 | 0;
 STACKTOP = i19;
 return i21 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89808 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89808 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89808 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89808 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN13BatchRenderer3AddERK17BatchInstanceData(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i11 + 184 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  HEAP32[i11 + 132 >> 2] = 0;
  if (!(HEAP32[i11 + 52 >> 2] | 0)) return;
  __ZN19ShaderPropertySheet5ClearEb(i11 + 8 | 0, 1);
  return;
 }
 i1 = i11 + 8 | 0;
 if (!(HEAP32[i11 + 52 >> 2] | 0)) {
  if (HEAP32[i11 + 132 >> 2] | 0) i7 = 6;
 } else i7 = 6;
 if ((i7 | 0) == 6) {
  __ZN20DynamicPropertySheet10FlushQueueEv(i1);
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 184 >> 2] | 0, i10 | 0, i1 | 0);
  __ZN19ShaderPropertySheet5ClearEb(i1, 1);
 }
 i6 = i11 + 168 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 i3 = i10 + (i9 * 360 | 0) + 332 | 0;
 i4 = i11 + 172 | 0;
 i5 = i10 + (i9 * 360 | 0) + 340 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
  i1 = i11 + 176 | 0;
  if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
   i2 = HEAP32[i10 + (i9 * 360 | 0) + 348 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i11 + 180 >> 2] | 0)) i7 = 11;
  } else i7 = 11;
 } else {
  i1 = i11 + 176 | 0;
  i7 = 11;
 }
 if ((i7 | 0) == 11) {
  __ZN13BatchRenderer5FlushEv(i11);
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i2 = HEAP32[i10 + (i9 * 360 | 0) + 348 >> 2] | 0;
  HEAP32[i11 + 180 >> 2] = i2;
 }
 i1 = HEAP8[i11 + 188 >> 0] | 0;
 L20 : do if (!((i1 & 1) == 0 | (i2 & 1 | 0) == 0)) {
  switch ((i1 & 255) >>> 2 & 3) {
  case 1:
   break L20;
  case 2:
   {
    if (Math_fround(HEAPF32[i10 + (i9 * 360 | 0) + 252 >> 2]) != Math_fround(0.0)) break L20;
    break;
   }
  default:
   {}
  }
  i6 = i11 + 140 | 0;
  i7 = i11 + 152 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (!i8) HEAP32[i11 + 192 >> 2] = HEAP32[i10 + (i9 * 360 | 0) + 260 >> 2];
  i2 = i8 + 1 | 0;
  i3 = i11 + 156 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i2 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 3, 4, i11 + 144 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i11 + 144 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i6 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i7 >> 2] = i2;
  i10 = i12;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = (HEAP32[i6 >> 2] | 0) + (i8 << 3) | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  return;
 } while (0);
 __ZN13BatchRenderer5FlushEv(i11);
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 __Z17SetupObjectMatrixRK10Matrix4x4fi(i5 + (i7 * 360 | 0) | 0, HEAP32[i5 + (i7 * 360 | 0) + 176 >> 2] | 0);
 mftCall_viiii(HEAP32[i5 + (i7 * 360 | 0) + 332 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i12 >> 2] | 0, i8 | 0, HEAP32[i12 + 4 >> 2] | 0);
 HEAP32[i11 + 192 >> 2] = HEAP32[i10 + (i9 * 360 | 0) + 260 >> 2];
 return;
}

function __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb(i1, i2, i6, i11, i12, i14, i15, i13, i16, i17) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 16 | 0;
 i10 = i18;
 i8 = i18 + 44 | 0;
 i7 = i18 + 32 | 0;
 __ZNK5physx2Gu5Facet15getClosestPointEPKNS_6shdfnd3aos5Vec3VES6_RS4_S7_(i6, i1, i2, i9, i10);
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f4 = Math_fround(-f4);
 f5 = Math_fround(-f5);
 f3 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
 if (i17) {
  HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAPF32[i13 >> 2] = f4;
  HEAPF32[i13 + 4 >> 2] = f5;
  HEAPF32[i13 + 8 >> 2] = f3;
  HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
  f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i17 = i16 + 4 | 0;
  HEAP32[i17 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  f5 = Math_fround(-f5);
  HEAPF32[i16 >> 2] = f5;
  STACKTOP = i18;
  return;
 } else {
  f20 = Math_fround(HEAPF32[i11 + 16 >> 2]);
  f20 = HEAP32[i11 + 64 >> 2] | 0 ? f20 : Math_fround(0.0);
  f23 = Math_fround(HEAPF32[i12 + 16 >> 2]);
  f23 = HEAP32[i12 + 64 >> 2] | 0 ? f23 : Math_fround(0.0);
  f19 = Math_fround(f20 + f23);
  f24 = Math_fround(HEAPF32[i9 >> 2]);
  f21 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f21 = Math_fround(f21 - Math_fround(f20 * f5));
  f22 = Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) - Math_fround(f20 * f3));
  HEAPF32[i14 >> 2] = Math_fround(f24 - Math_fround(f20 * f4));
  HEAPF32[i14 + 4 >> 2] = f21;
  HEAPF32[i14 + 8 >> 2] = f22;
  HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
  f22 = Math_fround(HEAPF32[i10 >> 2]);
  f21 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f21 = Math_fround(Math_fround(f23 * f5) + f21);
  f20 = Math_fround(Math_fround(f23 * f3) + Math_fround(HEAPF32[i10 + 8 >> 2]));
  HEAPF32[i15 >> 2] = Math_fround(Math_fround(f23 * f4) + f22);
  HEAPF32[i15 + 4 >> 2] = f21;
  HEAPF32[i15 + 8 >> 2] = f20;
  HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i13 >> 2] = f4;
  HEAPF32[i13 + 4 >> 2] = f5;
  HEAPF32[i13 + 8 >> 2] = f3;
  HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
  f5 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f19);
  i17 = i16 + 4 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  f5 = Math_fround(-f5);
  HEAPF32[i16 >> 2] = f5;
  STACKTOP = i18;
  return;
 }
}

function __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE(i6, i8, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i6 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = (i3 | 0) == 0 ? 0 : i3 + i1 | 0;
 i3 = i8 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i7 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = (i5 | 0) == 0 ? 0 : i5 + i2 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (HEAP8[i2 + i4 >> 0] | 0) {
    i10 = HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] | 0;
    i9 = HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i3 + (i4 * 12 | 0) >> 2] = HEAP32[i1 + (i4 * 12 | 0) >> 2];
    HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] = i10;
    HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] = i9;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 12 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (HEAP8[i1 + i4 >> 0] | 0) {
    i11 = HEAP32[i3 + (i4 << 4) + 4 >> 2] | 0;
    i9 = HEAP32[i3 + (i4 << 4) + 8 >> 2] | 0;
    i10 = HEAP32[i3 + (i4 << 4) + 12 >> 2] | 0;
    HEAP32[i2 + (i4 << 4) >> 2] = HEAP32[i3 + (i4 << 4) >> 2];
    HEAP32[i2 + (i4 << 4) + 4 >> 2] = i11;
    HEAP32[i2 + (i4 << 4) + 8 >> 2] = i9;
    HEAP32[i2 + (i4 << 4) + 12 >> 2] = i10;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 20 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 20 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 16 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (HEAP8[i1 + i4 >> 0] | 0) {
    i10 = HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] | 0;
    i11 = HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] | 0;
    HEAP32[i2 + (i4 * 12 | 0) >> 2] = HEAP32[i3 + (i4 * 12 | 0) >> 2];
    HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] = i10;
    HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = i11;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i3 = i6 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = i8 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = i7 + 28 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i5 + i1 | 0;
 i5 = HEAP32[i8 + 24 >> 2] | 0;
 if (i5 | 0) {
  i4 = 0;
  do {
   if (HEAP8[i1 + i4 >> 0] | 0) HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[i3 + (i4 << 2) >> 2];
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i5 | 0));
 }
 i5 = i6 + 36 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = (i4 | 0) == 0 ? 0 : i4 + i5 | 0;
 i4 = i8 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = (i3 | 0) == 0 ? 0 : i3 + i4 | 0;
 i3 = i7 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? 0 : i2 + i3 | 0;
 i2 = HEAP32[i8 + 32 >> 2] | 0;
 if (!i2) return; else i1 = 0;
 do {
  if (HEAP8[i3 + i1 >> 0] | 0) HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx3Cct9SweepTest15onObstacleAddedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f(i12, i1, i2, i4, i9, f3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 f3 = Math_fround(f3);
 var i5 = 0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i8 = i13 + 8 | 0;
 HEAP32[i11 >> 2] = i1;
 i10 = i12 + 152 | 0;
 if ((HEAP32[i10 >> 2] | 0) == -1) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = -1;
 HEAP16[i8 + 12 >> 1] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i8 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 48 >> 2] = Math_fround(0.0);
 i5 = __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKjRKNS_6PxVec3ES8_f(i2, i8, i11, i4, i9, f3) | 0;
 if (i5 | 0) {
  f6 = Math_fround(HEAPF32[i8 + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i9 >> 2]);
  f16 = Math_fround(f6 * f17);
  f7 = Math_fround(HEAPF32[i8 + 20 >> 2]);
  f15 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f7 * f15));
  f3 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f14 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f3 * f14));
  i1 = i12 + 212 | 0;
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i1 >> 2]));
  i2 = i12 + 216 | 0;
  f15 = Math_fround(f17 + Math_fround(f15 * Math_fround(HEAPF32[i2 >> 2])));
  i4 = i12 + 220 | 0;
  if (f16 < Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i4 >> 2])))) {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAPF32[i1 >> 2] = f6;
   HEAPF32[i2 >> 2] = f7;
   HEAPF32[i4 >> 2] = f3;
   f20 = Math_fround(+HEAPF64[i5 + 8 >> 3]);
   f14 = Math_fround(+HEAPF64[i5 + 16 >> 3]);
   f16 = Math_fround(+HEAPF64[i5 + 24 >> 3]);
   f21 = Math_fround(HEAPF32[i5 + 32 >> 2]);
   f18 = Math_fround(HEAPF32[i5 + 36 >> 2]);
   f15 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   f19 = Math_fround(HEAPF32[i5 + 44 >> 2]);
   f20 = Math_fround(Math_fround(f6 - f20) * Math_fround(2.0));
   f14 = Math_fround(Math_fround(f7 - f14) * Math_fround(2.0));
   f7 = Math_fround(Math_fround(f3 - f16) * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f19 * f19) + Math_fround(-.5));
   f3 = Math_fround(Math_fround(Math_fround(f20 * f21) + Math_fround(f14 * f18)) + Math_fround(f7 * f15));
   f16 = Math_fround(Math_fround(f18 * f3) + Math_fround(Math_fround(f14 * f6) - Math_fround(f19 * Math_fround(Math_fround(f20 * f15) - Math_fround(f21 * f7)))));
   f17 = Math_fround(Math_fround(f15 * f3) + Math_fround(Math_fround(f7 * f6) - Math_fround(f19 * Math_fround(Math_fround(f21 * f14) - Math_fround(f20 * f18)))));
   HEAPF32[i12 + 200 >> 2] = Math_fround(Math_fround(f21 * f3) + Math_fround(Math_fround(f20 * f6) - Math_fround(f19 * Math_fround(Math_fround(f18 * f7) - Math_fround(f14 * f15)))));
   HEAPF32[i12 + 204 >> 2] = f16;
   HEAPF32[i12 + 208 >> 2] = f17;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj6ES3_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 89360 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89360 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89360 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89360 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 8 | 0;
 i15 = i17 + 4 | 0;
 i16 = i17;
 i1 = HEAP32[i2 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = i4 + 4 | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i17;
  return;
 }
 i11 = HEAP32[i12 >> 2] | 0;
 do {
  HEAP32[i11 >> 2] = 0;
  i5 = i11 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i4 = i1 + 4 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
  i3 = (i2 | 0) / 872 | 0;
  if (i2 | 0) {
   if (i3 >>> 0 > 4925421) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = __Znwj(i2) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i11 >> 2] = i2;
   HEAP32[i11 + 8 >> 2] = i2 + (i3 * 872 | 0);
   i3 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) != (i4 | 0)) do {
    __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i3);
    i3 = i3 + 872 | 0;
    i2 = (HEAP32[i5 >> 2] | 0) + 872 | 0;
    HEAP32[i5 >> 2] = i2;
   } while ((i3 | 0) != (i4 | 0));
  }
  i7 = i11 + 12 | 0;
  i8 = i11 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i11 + 20 | 0;
  HEAP32[i9 >> 2] = 0;
  i2 = i11 + 16 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  i10 = i1 + 16 | 0;
  if ((i3 | 0) != (i10 | 0)) {
   i4 = i3;
   while (1) {
    i5 = i4 + 16 | 0;
    HEAP32[i16 >> 2] = i2;
    HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
    i6 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i7, i14, i15, i5) | 0;
    if (!(HEAP32[i6 >> 2] | 0)) {
     i4 = __Znwj(24) | 0;
     i19 = i5;
     i18 = HEAP32[i19 + 4 >> 2] | 0;
     i5 = i4 + 16 | 0;
     HEAP32[i5 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i5 + 4 >> 2] = i18;
     i5 = HEAP32[i15 >> 2] | 0;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i4 + 4 >> 2] = 0;
     HEAP32[i4 + 8 >> 2] = i5;
     HEAP32[i6 >> 2] = i4;
     i5 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     if (i5) {
      HEAP32[i7 >> 2] = i5;
      i4 = HEAP32[i6 >> 2] | 0;
     }
     __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i4);
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    }
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i4) while (1) {
     i4 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) {
      i3 = i4;
      break;
     } else i3 = i4;
    } else {
     i3 = i4;
     while (1) {
      i4 = HEAP32[i3 >> 2] | 0;
      if (!i4) break; else i3 = i4;
     }
    }
    if ((i3 | 0) == (i10 | 0)) break; else i4 = i3;
   }
  }
  HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  i1 = i1 + 28 | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + 28 | 0;
  HEAP32[i12 >> 2] = i11;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i17;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 24 | 0;
 i13 = i15;
 i5 = i10 + 12 | 0;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i2 | 0;
 i4 = (i12 >> 4) + 1 | 0;
 if ((i12 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i6 = (HEAP32[i10 + 8 >> 2] | 0) - i2 | 0;
 i3 = i6 >> 3;
 i3 = i6 >> 4 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
 i6 = i1 - i2 >> 4;
 HEAP32[i13 + 12 >> 2] = 0;
 i12 = i13 + 16 | 0;
 HEAP32[i12 >> 2] = i5;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i14 >> 2] = 34;
  HEAP32[i14 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i13 >> 2] = i4;
 i1 = i4 + (i6 << 4) | 0;
 i9 = i13 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i4 + (i3 << 4);
 i5 = HEAP8[i8 + 11 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
 i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i4 + (i6 << 4) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (i5) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i16 = i5 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 + (i6 << 4) + 8 >> 2] = i16 | -2147483648;
  HEAP32[i4 + (i6 << 4) + 4 >> 2] = i5;
  i1 = i8;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 16;
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i10, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i14 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i9 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i14);
    i1 = HEAP32[i9 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 HEAP32[i14 >> 2] = 34;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 STACKTOP = i15;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher10InitializeERK8UnityStrPvjRNS0_18ICloudJobSchedulerE(i10, i8, i1, i2, i3) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 16 | 0;
 i5 = i12;
 i11 = i10 + 8 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i10 + 56 >> 2] = i1;
 HEAP32[i10 + 60 >> 2] = i2;
 HEAP32[i10 + 32 >> 2] = i3;
 HEAP32[i10 + 128 >> 2] = 0;
 i9 = i10 + 136 | 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i9);
 i1 = i10 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i5 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i5 >> 0] = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i10 + 40 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 }
 i7 = i10 + 16 | 0;
 do if ((i7 | 0) == (i8 | 0)) i1 = i7 + 11 | 0; else {
  i5 = HEAP8[i8 + 11 >> 0] | 0;
  i1 = i5 << 24 >> 24 < 0;
  i6 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  i5 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
  i1 = i7 + 11 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i10 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i5 - i4 | 0, i2, 0, i2, i5, i6);
   break;
  }
  if (i3) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
  if (i5 | 0) _memmove(i2 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i2 + i5 >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[i10 + 20 >> 2] = i5;
   break;
  } else {
   HEAP8[i1 >> 0] = i5;
   break;
  }
 } while (0);
 i6 = HEAP8[i1 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i3 ? HEAP32[i10 + 20 >> 2] | 0 : i6 & 255;
 i3 = i9 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i10 + 144 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i10 + 140 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 140 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 i9 = HEAP32[i10 + 96 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0, i10 + 100 | 0);
 HEAP32[i11 >> 2] = 3;
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN19RuntimeSceneManager18LoadSceneAsyncIntoER10UnitySceneRK8UnityStrNS_11LoadingModeEb(i14, i13, i8, i15, i10) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 i15 = i15 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i11 = i18 + 4 | 0;
 i16 = __Znwj(472) | 0;
 __ZN18LoadSceneOperationC2Ev(i16);
 HEAP32[i16 + 160 >> 2] = i13;
 i17 = i13 + 4 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 i1 = i16 + 164 | 0;
 i9 = i8 + 11 | 0;
 do if ((i1 | 0) == (i8 | 0)) {
  i2 = i8;
  i1 = i8;
 } else {
  i7 = HEAP8[i9 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
  i7 = i4 ? HEAP32[i8 + 4 >> 2] | 0 : i7 & 255;
  i4 = i16 + 175 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i16 + 172 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i16 + 168 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   i2 = i8;
   i1 = i8;
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i16 + 168 >> 2] = i7;
   i2 = i8;
   i1 = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   i2 = i8;
   i1 = i8;
   break;
  }
 } while (0);
 HEAP32[i16 + 460 >> 2] = i15;
 HEAP8[i16 + 470 >> 0] = i10 & 1;
 HEAP32[i12 >> 2] = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i1;
 __Z6FormatPKcz(i11, gb + 462868 | 0, i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i16 + 148 | 0, i11) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 HEAP32[i13 + 80 >> 2] = 1;
 i9 = i14 + 24 | 0;
 i2 = i13;
 i3 = i14 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i14 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i14 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i16);
 switch (i15 | 0) {
 case 0:
 case 3:
  break;
 default:
  {
   STACKTOP = i18;
   return i16 | 0;
  }
 }
 i17 = __Z33CreateUnloadUnusedAssetsOperationb(1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0, i17 | 0);
 STACKTOP = i18;
 return i16 | 0;
}

function __Z26InitializeDeveloperConsolev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i8 = i9 + 24 | 0;
 i1 = i9 + 16 | 0;
 i2 = i9 + 8 | 0;
 i3 = i9;
 i4 = __Znwj(192) | 0;
 HEAP8[i4 >> 0] = 0;
 i10 = i4 + 4 | 0;
 HEAP32[i10 >> 2] = i10;
 HEAP32[i4 + 8 >> 2] = i10;
 HEAP32[i4 + 12 >> 2] = 0;
 i10 = i4 + 16 | 0;
 HEAP32[i10 >> 2] = i10;
 HEAP32[i4 + 20 >> 2] = i10;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i10 = i7;
 i6 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i4 + 56 | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i4 + 72 | 0;
 i6 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i10 = gb + 63672 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP8[i4 + 84 >> 0] = 0;
 i6 = i4 + 88 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP8[i4 + 104 >> 0] = 0;
 i6 = i4 + 108 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 4 >> 2] = i10;
 i6 = i4 + 116 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i1;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i4 + 132 | 0, gb + 1017159 | 0, i7);
 i6 = gb + 63672 | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i4 + 152 | 0, gb + 1017179 | 0, i7);
 i10 = gb + 63672 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i4 + 172 | 0, gb + 1017185 | 0, i7);
 HEAP32[gb + 1468316 >> 2] = i4;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 36280 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i10 = i3;
  i8 = i10 + 1 | 0;
  HEAP32[i2 >> 2] = i8;
  i8 = i1 + 35512 + (i10 * 12 | 0) + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  i8 = i1 + 35512 + (i10 * 12 | 0) + 8 | 0;
  HEAP8[i8 >> 0] = 0;
  i10 = i1 + 35512 + (i10 * 12 | 0) | 0;
  HEAP32[i10 >> 2] = fb + 324;
  STACKTOP = i9;
  return;
 }
 __Z6FormatPKcz(i7, gb + 1048800 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i10 = HEAP32[i2 >> 2] | 0;
 i8 = i10 + 1 | 0;
 HEAP32[i2 >> 2] = i8;
 i8 = i1 + 35512 + (i10 * 12 | 0) + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i8 = i1 + 35512 + (i10 * 12 | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i10 = i1 + 35512 + (i10 * 12 | 0) | 0;
 HEAP32[i10 >> 2] = fb + 324;
 STACKTOP = i9;
 return;
}

function __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_(i13, i14, i2) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 i12 = i14 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) == (-559030611 | 0) & (i1 | 0) == -1) {
  STACKTOP = i16;
  return;
 }
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0) ? (i3 | 0) == (HEAP32[i2 + 4 >> 2] | 0) : 0) {
  i10 = 0;
  i7 = -1;
  i8 = 0;
  i9 = 0;
 } else {
  i7 = i2;
  i10 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = 0;
  i9 = 0;
 }
 i6 = i13 + 876 | 0;
 if ((HEAP32[i13 + 880 >> 2] | 0) == (i3 | 0)) if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i2 = i13 + 876 | 0;
  i3 = (i10 | 0) == 0;
  i4 = i7;
  if ((i10 | 0) == (i1 | 0) ? (HEAP32[i13 + 880 >> 2] | 0) == (i4 | 0) : 0) i11 = 14; else {
   i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i13 + 860 >> 2] | 0, 0) | 0;
   if ((i5 | 0) == 36160) {
    i17 = i8 | i10;
    i1 = i7 | i9;
    i2 = i6;
    HEAP32[i2 >> 2] = i17;
    HEAP32[i2 + 4 >> 2] = i1;
    i2 = i13 + 884 | 0;
    HEAP32[i2 >> 2] = i17;
    HEAP32[i2 + 4 >> 2] = i1;
   } else {
    i17 = i2;
    HEAP32[i17 >> 2] = i8 | i10;
    HEAP32[i17 + 4 >> 2] = i7 | i9;
   }
   i2 = HEAP32[i13 + 544 >> 2] | 0;
   if (i3) i11 = 13; else if ((HEAP32[i13 + 1988 >> 2] | 0) == (i4 | 0)) i11 = 13; else i1 = -1;
   if ((i11 | 0) == 13) i1 = i10;
   mftCall_vii(i2 | 0, i5 | 0, i1 | 0);
   i1 = HEAP32[i14 >> 2] | 0;
   i2 = i13 + 884 | 0;
   if (!i1) if (!(HEAP32[i2 >> 2] | 0)) {
    i1 = 0;
    i11 = 19;
   } else {
    i1 = 0;
    i11 = 17;
   } else i11 = 17;
  }
 } else i11 = 14; else i11 = 14;
 if ((i11 | 0) == 14) {
  i2 = i13 + 884 | 0;
  i11 = 17;
 }
 if ((i11 | 0) == 17) if ((HEAP32[i13 + 888 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) if ((i1 | 0) == (HEAP32[i13 + 884 >> 2] | 0)) i11 = 19;
 if ((i11 | 0) == 19) {
  i3 = (i10 | 0) == 0;
  if (i10 | i1) {
   i4 = i7;
   if (!((i10 | 0) == (i1 | 0) ? (HEAP32[i13 + 888 >> 2] | 0) == (i4 | 0) : 0)) {
    i5 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i13 + 860 >> 2] | 0, 1) | 0;
    if ((i5 | 0) == 36160) {
     i8 = i8 | i10;
     i9 = i7 | i9;
     i17 = i6;
     HEAP32[i17 >> 2] = i8;
     HEAP32[i17 + 4 >> 2] = i9;
     i17 = i2;
     HEAP32[i17 >> 2] = i8;
     HEAP32[i17 + 4 >> 2] = i9;
    } else {
     i17 = i2;
     HEAP32[i17 >> 2] = i8 | i10;
     HEAP32[i17 + 4 >> 2] = i7 | i9;
    }
    i2 = HEAP32[i13 + 544 >> 2] | 0;
    if (i3) i11 = 26; else if ((HEAP32[i13 + 1988 >> 2] | 0) == (i4 | 0)) i11 = 26; else i1 = -1;
    if ((i11 | 0) == 26) i1 = i10;
    mftCall_vii(i2 | 0, i5 | 0, i1 | 0);
    i1 = HEAP32[i14 >> 2] | 0;
   }
  }
 }
 if (!i1) i11 = 30; else if ((HEAP32[i13 + 1988 >> 2] | 0) == (HEAP32[i12 >> 2] | 0)) i11 = 30; else i1 = -1;
 HEAP32[i15 >> 2] = i1;
 mftCall_vii(HEAP32[i13 + 540 >> 2] | 0, 1, i15 | 0);
 i17 = i14;
 HEAP32[i17 >> 2] = -1;
 HEAP32[i17 + 4 >> 2] = -559030611;
 STACKTOP = i16;
 return;
}

function __ZN2UI6Canvas8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
 i2 = i8 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i6 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 __ZN4PPtrI6CameraE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 40 | 0, i6);
 i1 = i8 + 364 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 360 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 362 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 375 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 361 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i8 + 404 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i8 + 368 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 372 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 2);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 374 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  STACKTOP = i10;
  return;
 }
}

function __ZN19VREyeTextureManager17CreateEyeTexturesEf(i11, f2) {
 i11 = i11 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = f2 < Math_fround(.00999999977);
 i9 = f2 > Math_fround(10.0);
 f2 = i9 ? Math_fround(10.0) : f2;
 HEAPF32[i11 + 96 >> 2] = i8 ? Math_fround(.00999999977) : f2;
 i8 = HEAP32[i11 + 48 >> 2] | 0;
 i9 = i11 + 44 | 0;
 i10 = HEAP32[i9 >> 2] & i8;
 if (!i10) {
  HEAP8[i11 + 104 >> 0] = 1;
  i10 = i11 + 80 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
 } else {
  i7 = HEAP8[i11 + 52 >> 0] | 0;
  HEAP8[i11 + 104 >> 0] = i7;
  i6 = i11 + 80 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  if (!(i7 << 24 >> 24)) {
   i7 = HEAP32[i11 + 100 >> 2] | 0;
   i8 = i11 + 64 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i5 = i11 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = (i6 - i4 | 0) / 20 | 0;
   if (i1 >>> 0 > i3 >>> 0) {
    __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj(i11, i1 - i3 | 0);
    i1 = HEAP32[i8 >> 2] | 0;
   } else if (i1 >>> 0 < i3 >>> 0) {
    i3 = i4 + (i1 * 20 | 0) | 0;
    if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~(((i6 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
   }
   if ((i1 | 0) <= 0) {
    i10 = 1;
    __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags(i11, 7);
    return i10 | 0;
   }
   i4 = 1;
   i5 = 0;
   i3 = i1;
   while (1) {
    if (!(i4 << 24 >> 24)) i1 = 0; else {
     i1 = __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i11, i10, 1, i7, i5, (HEAP32[i11 >> 2] | 0) + (i5 * 20 | 0) | 0) | 0;
     i3 = HEAP32[i8 >> 2] | 0;
    }
    i5 = i5 + 1 | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else i4 = i1 & 1;
   }
   __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags(i11, 7);
   return i1 | 0;
  }
 }
 i7 = i11 + 64 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i11 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = (i6 - i4 | 0) / 20 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj(i11, i1 - i3 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 } else if (i1 >>> 0 < i3 >>> 0) {
  i3 = i4 + (i1 * 20 | 0) | 0;
  if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~(((i6 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
 }
 if ((i1 | 0) > 0) {
  i3 = 1;
  i4 = 0;
  while (1) {
   if (!(i3 << 24 >> 24)) i3 = 0; else {
    i3 = __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i11, i8, 1, 1, i4, (HEAP32[i11 >> 2] | 0) + (i4 * 20 | 0) | 0) | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i1 | 0)) break; else i3 = i3 & 1;
  }
  if (!i3) {
   i10 = 0;
   __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags(i11, 7);
   return i10 | 0;
  }
 }
 i10 = __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i11, HEAP32[i9 >> 2] | 0, 0, HEAP32[i11 + 100 >> 2] | 0, 0, i11 + 16 | 0) | 0;
 __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags(i11, 7);
 return i10 | 0;
}

function __ZN11SoundHandle8Instance15UpdateLoadStateEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 16 | 0;
 i8 = i13;
 i10 = i13 + 44 | 0;
 i7 = i13 + 40 | 0;
 i2 = i13 + 36 | 0;
 i3 = i13 + 32 | 0;
 i4 = i13 + 57 | 0;
 i5 = i13 + 56 | 0;
 i12 = i9 + 44 | 0;
 switch (HEAP32[i12 >> 2] | 0) {
 case 1:
  {
   i6 = i9 + 36 | 0;
   if (__ZN4FMOD5Sound12getOpenStateEP14FMOD_OPENSTATEPjPbS4_(HEAP32[i6 >> 2] | 0, i2, i3, i4, i5) | 0) {
    STACKTOP = i13;
    return;
   }
   switch (HEAP32[i2 >> 2] | 0) {
   case 2:
    {
     HEAP32[i12 >> 2] = 4;
     STACKTOP = i13;
     return;
    }
   case 0:
    {
     i1 = HEAP32[i6 >> 2] | 0;
     i2 = HEAP32[i9 + 24 >> 2] | 0;
     HEAP32[i7 >> 2] = 0;
     i3 = __ZN4FMOD5Sound15getNumSubSoundsEPi(i1, i7) | 0;
     if (i3 | 0) {
      i5 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i3) | 0;
      HEAP32[i8 >> 2] = gb + 853741;
      HEAP32[i8 + 4 >> 2] = 189;
      HEAP32[i8 + 8 >> 2] = gb + 859396;
      HEAP32[i8 + 12 >> 2] = i5;
      __Z6FormatPKcz(i10, gb + 883334 | 0, i8);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
     }
     if ((HEAP32[i7 >> 2] | 0) > 0) {
      HEAP32[i10 >> 2] = 0;
      i8 = __ZN4FMOD5Sound11getSubSoundEiPPS0_(i1, i2, i10) | 0;
      i2 = HEAP32[i10 >> 2] | 0;
      if (!i8) {
       i1 = i9 + 40 | 0;
       HEAP32[i1 >> 2] = i2;
       if (i2) {
        HEAP32[i12 >> 2] = 2;
        STACKTOP = i13;
        return;
       }
      } else i11 = 9;
     } else i11 = 9;
     if ((i11 | 0) == 9) {
      i1 = i9 + 40 | 0;
      HEAP32[i1 >> 2] = 0;
     }
     HEAP32[i12 >> 2] = 3;
     HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = 0;
     STACKTOP = i13;
     return;
    }
   default:
    {
     STACKTOP = i13;
     return;
    }
   }
  }
 case 2:
  {
   i1 = i9 + 40 | 0;
   if (__ZN4FMOD5Sound12getOpenStateEP14FMOD_OPENSTATEPjPbS4_(HEAP32[i1 >> 2] | 0, i2, i3, i4, i5) | 0) {
    STACKTOP = i13;
    return;
   }
   switch (HEAP32[i2 >> 2] | 0) {
   case 2:
    {
     HEAP32[i12 >> 2] = 4;
     STACKTOP = i13;
     return;
    }
   case 0:
    {
     i1 = __ZN4FMOD5Sound11setUserDataEPv(HEAP32[i1 >> 2] | 0, i9 + 12 | 0) | 0;
     if (i1 | 0) {
      i11 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
      HEAP32[i6 >> 2] = gb + 853741;
      HEAP32[i6 + 4 >> 2] = 250;
      HEAP32[i6 + 8 >> 2] = gb + 859435;
      HEAP32[i6 + 12 >> 2] = i11;
      __Z6FormatPKcz(i10, gb + 883334 | 0, i6);
      __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
     }
     HEAP32[i12 >> 2] = 3;
     STACKTOP = i13;
     return;
    }
   default:
    {
     STACKTOP = i13;
     return;
    }
   }
  }
 default:
  {
   STACKTOP = i13;
   return;
  }
 }
}

function __ZL22addOrRemoveRigidObjectILb0ELb1ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 816 | 0;
 i10 = i16 + 544 | 0;
 i14 = i16 + 272 | 0;
 i13 = i16;
 if (i1 | 0) {
  i9 = i10 + 256 | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i10, i1 + 272 | 0);
  i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
  i7 = i1 + -16 | 0;
  i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i2, i15) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  if (i8 | 0) {
   i1 = i1 + -12 | 0;
   i5 = 0;
   do {
    i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i3 = i2 + i1 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
     HEAP32[i2 + i7 >> 2] = i6;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i8 | 0));
  }
  i15 = HEAP32[i10 + 268 >> 2] | 0;
  if (!((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0)) {
   STACKTOP = i16;
   return;
  }
  i1 = HEAP32[i10 + 260 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0)) {
   HEAP8[i9 >> 0] = 0;
   STACKTOP = i16;
   return;
  }
  if (!i1) {
   STACKTOP = i16;
   return;
  }
  i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  STACKTOP = i16;
  return;
 }
 i12 = i14 + 256 | 0;
 i9 = i14 + 260 | 0;
 HEAP32[i14 + 264 >> 2] = 0;
 i10 = i14 + 268 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 >> 2] = i14;
 HEAP32[i10 >> 2] = 64;
 i11 = i13 + 256 | 0;
 HEAP8[i11 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i13, i14);
 i1 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i7 = i1 + -16 | 0;
 i8 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i2, i15) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 if (i8 | 0) {
  i1 = i1 + -12 | 0;
  i5 = 0;
  do {
   i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i3 = i2 + i1 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 & 251658240 | 0) == 16777216) {
    HEAP32[i3 >> 2] = i4 & 1073741823 | -2147483648;
    HEAP32[i2 + i7 >> 2] = i6;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 i15 = HEAP32[i13 + 268 >> 2] | 0;
 do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i13 + 260 >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) {
   HEAP8[i11 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 } while (0);
 i15 = HEAP32[i10 >> 2] | 0;
 do if ((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i14 | 0) == (i1 | 0)) {
   HEAP8[i12 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i15 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i16;
 return;
}

function _erfc2_142(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f4 = f0, f5 = f0;
 f4 = Math_fround(Math_abs(Math_fround(f1)));
 if (i3 >>> 0 < 1067450368) {
  f1 = Math_fround(f4 + Math_fround(-1.0));
  f1 = Math_fround(Math_fround(.154937088) - Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(.0354783051) - Math_fround(f1 * Math_fround(.00216637552)))) + Math_fround(-.110894695))) + Math_fround(.31834662))) + Math_fround(-.37220788))) + Math_fround(.414856106))) + Math_fround(-.00236211857)) / Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.0119845001)) + Math_fround(.0136370836))) + Math_fround(.126171216))) + Math_fround(.0718286559))) + Math_fround(.540397942))) + Math_fround(.106420882))) + Math_fround(1.0))));
 } else {
  f5 = Math_fround(Math_fround(1.0) / Math_fround(f4 * f4));
  if (i3 >>> 0 < 1077336941) {
   f1 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(-81.2874374) - Math_fround(f5 * Math_fround(9.81432914)))) + Math_fround(-184.605087))) + Math_fround(-162.396667))) + Math_fround(-62.3753319))) + Math_fround(-10.5586262))) + Math_fround(-.693858563))) + Math_fround(-.00986494403));
   f2 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(6.57024956) - Math_fround(f5 * Math_fround(.0604244135)))) + Math_fround(108.635002))) + Math_fround(429.008148))) + Math_fround(645.387268))) + Math_fround(434.565887))) + Math_fround(137.657761))) + Math_fround(19.6512718));
  } else {
   f1 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(-1025.09509) - Math_fround(f5 * Math_fround(483.519196)))) + Math_fround(-637.566467))) + Math_fround(-160.636383))) + Math_fround(-17.7579556))) + Math_fround(-.799283266))) + Math_fround(-.0098649431));
   f2 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(f5 * Math_fround(Math_fround(474.528534) - Math_fround(f5 * Math_fround(22.4409523)))) + Math_fround(2553.05029))) + Math_fround(3199.85815))) + Math_fround(1536.72961))) + Math_fround(325.792511))) + Math_fround(30.3380604));
  }
  f5 = Math_fround(Math_fround(f5 * f2) + Math_fround(1.0));
  f2 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -8192, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(Math_fround(Math_fround(+Math_exp(+Math_fround(Math_fround(-.5625) - Math_fround(f2 * f2)))) * Math_fround(+Math_exp(+Math_fround(Math_fround(Math_fround(f2 - f4) * Math_fround(f4 + f2)) + Math_fround(f1 / f5))))) / f4);
 }
 return Math_fround(f1);
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 24 | 0;
 i13 = i15;
 i5 = i10 + 12 | 0;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i2 | 0;
 i4 = (i12 >> 4) + 1 | 0;
 if ((i12 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i6 = (HEAP32[i10 + 8 >> 2] | 0) - i2 | 0;
 i3 = i6 >> 3;
 i3 = i6 >> 4 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
 i6 = i1 - i2 >> 4;
 HEAP32[i13 + 12 >> 2] = 0;
 i12 = i13 + 16 | 0;
 HEAP32[i12 >> 2] = i5;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i13 >> 2] = i4;
 i1 = i4 + (i6 << 4) | 0;
 i9 = i13 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i4 + (i3 << 4);
 i5 = HEAP8[i8 + 11 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
 i5 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i4 + (i6 << 4) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (i5) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i16 = i5 + 16 & -16;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i4 + (i6 << 4) + 8 >> 2] = i16 | -2147483648;
  HEAP32[i4 + (i6 << 4) + 4 >> 2] = i5;
  i1 = i8;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 16;
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i10, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i14 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i9 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i16 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i16, i14);
    i1 = HEAP32[i9 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i16 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 HEAP32[i14 >> 2] = 1;
 HEAP32[i14 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj139ES3_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 65535;
 if (i9 << 16 >> 16) {
  i1 = HEAP32[gb + 90152 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 90152 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 90152 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 90152 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (((i4 - i1 | 0) / 36 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i12 = i1 + 8 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 36 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 36 | 0) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i8 = (i4 - i7 | 0) / 36 | 0;
 i5 = i8 << 1;
 i5 = i8 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 36 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (((i1 - i7 | 0) / 36 | 0) * 36 | 0) | 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i3 + (i5 * 36 | 0);
 do {
  i9 = i1 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 36 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i10, i11);
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -28 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -16 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i13;
 return;
}

function __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i8, i5, i6) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 i11 = HEAP32[i15 + 108 >> 2] | 0;
 i14 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = HEAP32[i11 + (i13 << 5) + 8 >> 2] | 0;
 i15 = HEAP32[HEAP32[(HEAP32[i15 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
 i16 = HEAP32[i11 + (i14 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i15 + (i12 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i15 + (i16 * 360 | 0) + 184 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i16 = i1 >>> 0 < i2 >>> 0;
  return i16 | 0;
 }
 i1 = HEAP16[i11 + (i13 << 5) + 12 >> 1] | 0;
 i2 = HEAP16[i11 + (i14 << 5) + 12 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i16 = i1 << 16 >> 16 < i2 << 16 >> 16;
  return i16 | 0;
 }
 i9 = HEAP32[i5 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = i9 & 16777216;
 i2 = i10 & 16777216;
 if ((i1 | 0) != (i2 | 0)) {
  i16 = i1 >>> 0 > i2 >>> 0;
  return i16 | 0;
 }
 i6 = HEAP32[i11 + (i13 << 5) + 4 >> 2] | 0;
 i7 = HEAP32[i11 + (i14 << 5) + 4 >> 2] | 0;
 i2 = (HEAP16[i15 + (i12 * 360 | 0) + 182 >> 1] | 0) != 0;
 i5 = (HEAP16[i15 + (i16 * 360 | 0) + 182 >> 1] | 0) != 0;
 i1 = i5 ^ 1;
 if (!(i2 ^ 1 | i1)) {
  if ((i6 | 0) != (i7 | 0)) {
   i16 = i6 >>> 0 < i7 >>> 0;
   return i16 | 0;
  }
  i1 = HEAP32[i15 + (i12 * 360 | 0) + 248 >> 2] | 0;
  i2 = HEAP32[i15 + (i16 * 360 | 0) + 248 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i16 = (HEAPU16[i15 + (i12 * 360 | 0) + 180 >> 1] | 0) < (HEAPU16[i15 + (i16 * 360 | 0) + 180 >> 1] | 0);
   return i16 | 0;
  } else {
   i16 = (i1 | 0) < (i2 | 0);
   return i16 | 0;
  }
 }
 if (i2 ^ i5) {
  i16 = i2 & i1;
  return i16 | 0;
 }
 if (HEAP8[i8 + 4 >> 0] | 0) {
  i1 = (HEAP32[i11 + (i13 << 5) + 20 >> 2] | 0) >>> 24;
  i2 = (HEAP32[i11 + (i14 << 5) + 20 >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i2 | 0)) {
   i16 = i1 >>> 0 < i2 >>> 0;
   return i16 | 0;
  }
 }
 i1 = HEAP32[i15 + (i12 * 360 | 0) + 224 >> 2] | 0;
 i2 = HEAP32[i15 + (i16 * 360 | 0) + 224 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i16 = i1 >>> 0 < i2 >>> 0;
  return i16 | 0;
 }
 i1 = HEAP32[i11 + (i13 << 5) >> 2] | 0;
 i2 = HEAP32[i11 + (i14 << 5) >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i16 = (HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i2 + 4 >> 2] | 0);
  return i16 | 0;
 }
 if ((i6 | 0) != (i7 | 0)) {
  i16 = (i6 | 0) < (i7 | 0);
  return i16 | 0;
 }
 i2 = i9 & 255;
 i1 = i10 & 255;
 if ((i2 | 0) != (i1 | 0)) {
  i16 = i2 >>> 0 < i1 >>> 0;
  return i16 | 0;
 }
 i2 = HEAP32[i11 + (i13 << 5) + 28 >> 2] | 0;
 i1 = HEAP32[i11 + (i14 << 5) + 28 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i16 = i2 >>> 0 > i1 >>> 0;
  return i16 | 0;
 }
 f4 = Math_fround(HEAPF32[i11 + (i13 << 5) + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + (i14 << 5) + 20 >> 2]);
 if (f4 != f3) {
  i16 = f4 > f3;
  return i16 | 0;
 }
 i2 = HEAP16[i15 + (i12 * 360 | 0) + 270 >> 1] | 0;
 i1 = HEAP16[i15 + (i16 * 360 | 0) + 270 >> 1] | 0;
 if (i2 << 16 >> 16 == i1 << 16 >> 16) {
  i16 = (i13 | 0) < (i14 | 0);
  return i16 | 0;
 } else {
  i16 = (i2 & 65535) > (i1 & 65535);
  return i16 | 0;
 }
 return 0;
}

function __Z26PlayerInitEngineNoGraphicsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6 + 32 | 0;
 i3 = i6 + 20 | 0;
 __Z36GiveDebuggerChanceToAttachIfRequiredv();
 __ZN4File19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1);
 __Z29InitPathNamePersistentManagerv();
 __Z32AddPathRemapsForBuiltinResourcesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2);
 if (!(__Z26InitializeEngineNoGraphicsv() | 0)) {
  _printf_console(gb + 583378 | 0, i6);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = __Z13GetFileSystemv() | 0;
 i7 = HEAP32[gb + 73488 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i7, _strlen(i7) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i1, i3);
 __ZN10FileSystem25MountDataFolderFileSystemERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i2, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i2 = HEAP32[gb + 73492 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i2, _strlen(i2) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i1, i3);
 i2 = __Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (!i2) {
  _printf_console(gb + 583431 | 0, i6 + 8 | 0);
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = HEAP32[gb + 73492 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i7, _strlen(i7) | 0);
 __Z26PlayerLoadSettingsAndInputRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i7 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i7 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i5 + 4 >> 2] | 0 : i7 & 255) | 0)) {
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i3 = i2 + 8488 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i1 = 1; else {
   i1 = 0;
   do {
    i4 = i2 + 7720 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i2 + 7720 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 7720 + (i1 * 12 | 0) + 4 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   i1 = 1;
  }
 } else {
  HEAP32[i4 >> 2] = i1 ? HEAP32[i5 >> 2] | 0 : i5;
  _printf_console(gb + 583487 | 0, i4);
  i1 = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj622ES2_RKNS_27PxVehicleTireLoadFilterDataES6_EEKNS_40PxVehicleTireLoadFilterDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 32 | 0;
 i7 = i8 + 88 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj565ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 12 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj566ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 28 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj567ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 44 | 0, 3);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj568ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 60 | 0, 4);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj122ES3_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i12 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i9 = mftCall_ii(i9 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 i5 = i9 & 255;
 if (i9 << 24 >> 24) {
  i1 = HEAP32[gb + 89424 >> 2] | 0;
  i4 = i8 + 12 | 0;
  if (i1 | 0) {
   i2 = gb + 89424 | 0;
   i3 = 0;
   do {
    i9 = HEAP32[gb + 89424 + (i3 << 3) + 4 >> 2] | 0;
    do if ((i9 & i5 | 0) == (i9 | 0)) {
     if (HEAP32[i4 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i9 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i3 = i3 + 1 | 0;
    i2 = gb + 89424 + (i3 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN15FrictionJoint2D6CreateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i1 = i11;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i7 = 9; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i7 = 11;
  }
  if ((i7 | 0) == 9) i7 = 11;
  if ((i7 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  if (!i1) i7 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i5);
    i2 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 20;
   }
  }
  if ((i7 | 0) == 18) i7 = 20;
  if ((i7 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i10;
   return;
  }
 } while (0);
 i11 = i9 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP8[i11 + 12 >> 0] = 0;
 HEAP32[i9 >> 2] = 9;
 i11 = i9 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = HEAP32[i8 + 96 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i8 + 100 >> 2];
 __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_(i8, i9 + 20 | 0, i9 + 28 | 0);
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i8, i9);
 STACKTOP = i10;
 return;
}

function __ZN20ArchiveStorageReader4ReadEyyPvPy(i14, i15, i16, i11, i12, i17, i19) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i20;
 i1 = HEAP32[i14 + 148 >> 2] | 0;
 if (!i1) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i9 = ((HEAP32[i14 + 108 >> 2] | 0) - (HEAP32[i14 + 104 >> 2] | 0) | 0) / 12 | 0;
 i10 = i14 + 136 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = i1 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i6 = (i2 | 0) / 2 | 0;
   i8 = i1 + (i6 << 3) | 0;
   i7 = i8;
   i5 = HEAP32[i7 + 4 >> 2] | 0;
   i7 = i5 >>> 0 > i16 >>> 0 | ((i5 | 0) == (i16 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 > i15 >>> 0 : 0);
   i2 = i7 ? i6 : i2 + -1 - i6 | 0;
   i1 = i7 ? i1 : i8 + 8 | 0;
  } while ((i2 | 0) != 0);
 }
 i1 = i1 - i3 >> 3;
 if (i1 >>> 0 < i9 >>> 0) i8 = i1 + -1 | 0; else {
  i1 = i9 + -1 | 0;
  i8 = i3 + (i1 << 3) | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i7 >>> 0 > i16 >>> 0 | ((i7 | 0) == (i16 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 > i15 >>> 0 : 0)) {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
  i8 = i3 + (i9 << 3) | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  if (i7 >>> 0 > i16 >>> 0 | ((i7 | 0) == (i16 | 0) ? (HEAP32[i8 >> 2] | 0) >>> 0 > i15 >>> 0 : 0)) i8 = i1; else {
   i19 = 0;
   STACKTOP = i20;
   return i19 | 0;
  }
 }
 if (((i11 | 0) != 0 | (i12 | 0) != 0) & i8 >>> 0 < i9 >>> 0) {
  i4 = i8;
  i1 = 0;
  i5 = 0;
  i6 = 0;
  while (1) {
   i7 = i4 + 1 | 0;
   i2 = i3 + (i7 << 3) | 0;
   i22 = i3 + (i4 << 3) | 0;
   i23 = HEAP32[i22 >> 2] | 0;
   i22 = HEAP32[i22 + 4 >> 2] | 0;
   i2 = _i64Subtract(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i23 | 0, i22 | 0) | 0;
   i3 = getTempRet0() | 0;
   i21 = (i4 | 0) == (i8 | 0);
   i22 = _i64Subtract(i15 | 0, i16 | 0, i23 | 0, i22 | 0) | 0;
   getTempRet0() | 0;
   i22 = i21 ? i22 : 0;
   i21 = i21 ? 0 : 0;
   i3 = _i64Subtract(i2 | 0, i3 | 0, i22 | 0, i21 | 0) | 0;
   getTempRet0() | 0;
   i2 = _i64Subtract(i11 | 0, i12 | 0, i5 | 0, i6 | 0) | 0;
   getTempRet0() | 0;
   if (!(__ZN20ArchiveStorageReader9ReadBlockEjyyPvPy(i14, i4, i22, i21, i2 >>> 0 < i3 >>> 0 ? i2 : i3, 0, i17 + i1 | 0, i13) | 0)) {
    i18 = 15;
    break;
   }
   i3 = i13;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i18 = 12;
    break;
   }
   i2 = _i64Add(i2 | 0, i3 | 0, i5 | 0, i6 | 0) | 0;
   getTempRet0() | 0;
   if (!((0 < i12 >>> 0 | 0 == (i12 | 0) & i2 >>> 0 < i11 >>> 0) & i7 >>> 0 < i9 >>> 0)) {
    i1 = i2;
    break;
   }
   i4 = i7;
   i1 = i2;
   i3 = HEAP32[i10 >> 2] | 0;
   i5 = i2;
   i6 = 0;
  }
  if ((i18 | 0) != 12) if ((i18 | 0) == 15) {
   i23 = 0;
   STACKTOP = i20;
   return i23 | 0;
  }
  if ((i1 | 0) != 0 & (HEAP8[i14 + 184 >> 0] | 0) == 0) __ZN20ArchiveStorageReader31TryToReadDirectoryFromBlockDataEyPKvj(i14, i15, i16, i17, i1);
 } else i1 = 0;
 i23 = i19;
 HEAP32[i23 >> 2] = i1;
 HEAP32[i23 + 4 >> 2] = 0;
 i23 = 1;
 STACKTOP = i20;
 return i23 | 0;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 36 | 0;
 i15 = i16 + 16 | 0;
 i13 = i16;
 i1 = i17 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i17 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i14, 4);
  i1 = HEAP32[i14 >> 2] | 0;
 } else {
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i14 >> 2] = i12;
  HEAP32[i1 >> 2] = i3;
  i1 = i12;
 }
 i8 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i15 >> 2] = -1;
 i9 = i18 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i18, HEAP32[i9 >> 2] | 0);
 i10 = i18 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i18 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 if ((i8 | 0) <= 0) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + 4 | 0;
 i11 = i9;
 i12 = i18 + 4 | 0;
 i6 = 0;
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags(i17, i15, gb + 1041891 | 0, 0);
  i5 = HEAP32[i15 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  i1 = HEAP32[i9 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i9;
   i4 = i11;
   i3 = i9;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    i3 = i14;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(36) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   i2 = i1 + 20 | 0;
   HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i18 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 STACKTOP = i16;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXml8readDataEPc(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i6 = i11 + 1060 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i7 = i11 + 11312 | 0;
  i5 = 0;
  do {
   i2 = i11 + 9261 + i5 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i3 = i11 + 1064 + (i5 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4) {
     i1 = _strlen(i4) | 0;
     i10 = HEAP32[i7 >> 2] | 0;
     i1 = i1 + 1 | 0;
     i10 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0, i1 | 0) | 0;
     HEAP32[i3 >> 2] = i10;
     _memcpy(i10 | 0, i4 | 0, i1 | 0) | 0;
     HEAP8[i2 >> 0] = 1;
     i1 = HEAP32[i6 >> 2] | 0;
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (i1 + 1 | 0) >>> 0);
 }
 do if (!(HEAP8[i11 + 9260 >> 0] | 0)) if (!i8) {
  i9 = i11 + 1028 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 + 1044 >> 2] = (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0) | 0) - i10;
  break;
 } else {
  i11 = i8;
  return i11 | 0;
 } while (0);
 i10 = i11 + 1032 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i11 + 11312 >> 2] | 0;
  i9 = i11 + 1044 | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, (HEAP32[i9 >> 2] | 0) + 1 | 0) | 0;
  HEAP32[i10 >> 2] = i1;
 } else i9 = i11 + 1044 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i8) i4 = 0; else {
  i3 = i1 - i8 + i2 | 0;
  if (!i3) i4 = 0; else {
   _memmove(i1 | 0, i8 | 0, i3 | 0) | 0;
   HEAP8[(HEAP32[i10 >> 2] | 0) + i3 >> 0] = 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i4 = i3;
   i2 = (HEAP32[i9 >> 2] | 0) - i3 | 0;
  }
 }
 i8 = i11 + 1028 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i1 + i4 | 0, i2 | 0) | 0;
 L24 : do if (i1 | 0) {
  i5 = i11 + 1040 | 0;
  i6 = i11 + 1036 | 0;
  i7 = i11 + 11312 | 0;
  while (1) {
   i2 = i4 + i1 | 0;
   HEAP8[(HEAP32[i10 >> 2] | 0) + i2 >> 0] = 0;
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i6 >> 2] = i3 + i2;
   i2 = i3 + i4 | 0;
   L28 : while (1) {
    switch (HEAP8[i2 >> 0] | 0) {
    case 0:
     break L28;
    case 60:
     break;
    default:
     {
      i2 = i2 + 1 | 0;
      continue L28;
     }
    }
    i2 = i2 + 1 | 0;
    if ((HEAP8[i2 >> 0] | 0) == 47) continue;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   }
   if ((HEAP32[i5 >> 2] | 0) >>> 0 >= 2) break L24;
   i4 = i4 + i1 | 0;
   i2 = HEAP32[i9 >> 2] << 1;
   HEAP32[i9 >> 2] = i2;
   i12 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0, i2 | 1 | 0) | 0;
   HEAP32[i10 >> 2] = i2;
   _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i3 | 0);
   i3 = HEAP32[i8 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, (HEAP32[i10 >> 2] | 0) + i4 | 0, (HEAP32[i9 >> 2] | 0) - i4 | 0) | 0;
   if (!i1) break;
  }
 } while (0);
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 + 1048 >> 2] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0) | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 return i12 | 0;
}

function __ZN11TypeManager27FatalErrorOnClassIDConflictEiPKc(i6, i1, i11) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 16 | 0;
 i2 = i15;
 i12 = i15 + 28 | 0;
 i13 = i15 + 32 | 0;
 HEAP32[i12 >> 2] = i1;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i13, i6 + 120 | 0, i12);
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 if ((i1 | 0) != ((HEAP32[i6 + 148 >> 2] | 0) + (HEAP32[i6 + 152 >> 2] << 3) | 0)) {
  i10 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = i11;
  HEAP32[i2 + 8 >> 2] = i10;
  __Z6FormatPKcz(i13, gb + 373019 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 373107 | 0, 278, 32785, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 }
 i4 = HEAP32[i6 + 180 >> 2] | 0;
 if ((HEAP32[i6 + 212 >> 2] | 0) == (i4 | 0)) {
  i2 = HEAP32[i6 + 204 >> 2] | 0;
  i1 = HEAP32[i6 + 208 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i6 + 208 >> 2] | 0;
  i7 = i10 + -1 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i1 = (Math_imul((Math_imul((Math_imul((Math_imul(i8 >>> 24 ^ -2128831035, 16777619) | 0) ^ i8 >>> 16 & 255, 16777619) | 0) ^ i8 >>> 8 & 255, 16777619) | 0) ^ i8 & 255, 16777619) | 0) & i7;
  i2 = HEAP32[i6 + 204 >> 2] | 0;
  i9 = HEAP32[i6 + 196 >> 2] | 0;
  i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L7 : do if ((i9 | 0) == (i3 | 0)) i1 = -1; else {
   i5 = i6 + 188 | 0;
   if (!(HEAP8[i6 + 184 >> 0] | 0)) {
    i4 = 0;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L7;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) {
      i1 = -1;
      break L7;
     }
    }
   }
   if (!i4) {
    i4 = 0;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L7;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) {
      i1 = -1;
      break L7;
     }
    }
   }
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = 0;
   while (1) {
    if ((i5 | 0) != (i3 | 0) & (i8 | 0) == (i3 | 0)) break L7;
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i7;
    i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
    if ((i9 | 0) == (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i3 = (i1 | 0) == -1 ? i2 + (i10 << 3) | 0 : i2 + (i1 << 3) | 0;
  i1 = i10;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i11;
 HEAP32[i14 + 8 >> 2] = i10;
 __Z6FormatPKcz(i13, gb + 373019 | 0, i14);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 373107 | 0, 282, 32785, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i15;
 return;
}

function __ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_(i11, i10, i7, i2, i4) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f1 = f0, f3 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i7 + 4 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i7 + 8 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f12 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i2 + 40 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 44 >> 2])));
 f6 = Math_fround(f14 * Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f6 = Math_fround(Math_abs(Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 8 >> 2])))));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 48 >> 2]));
 f5 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f13 * Math_fround(HEAPF32[i2 + 16 >> 2])));
 f5 = Math_fround(Math_abs(Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 20 >> 2])))));
 f5 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 52 >> 2])));
 f6 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f13 * Math_fround(HEAPF32[i2 + 28 >> 2])));
 f6 = Math_fround(Math_abs(Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 32 >> 2])))));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 56 >> 2])));
 f5 = Math_fround(f12 - f6);
 f6 = Math_fround(f12 + f6);
 f12 = Math_fround(f14 * Math_fround(HEAPF32[i4 + 36 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i4 + 40 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 44 >> 2])));
 f15 = Math_fround(f14 * Math_fround(HEAPF32[i4 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f13 * Math_fround(HEAPF32[i4 + 4 >> 2])));
 f15 = Math_fround(Math_abs(Math_fround(f15 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 8 >> 2])))));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i4 + 48 >> 2]));
 f1 = Math_fround(f14 * Math_fround(HEAPF32[i4 + 12 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f13 * Math_fround(HEAPF32[i4 + 16 >> 2])));
 f1 = Math_fround(Math_abs(Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 20 >> 2])))));
 f1 = Math_fround(f15 + Math_fround(f1 * Math_fround(HEAPF32[i4 + 52 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i4 + 24 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i4 + 28 >> 2])));
 f3 = Math_fround(Math_abs(Math_fround(f13 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 32 >> 2])))));
 f3 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 56 >> 2])));
 f1 = Math_fround(f12 - f3);
 f3 = Math_fround(f12 + f3);
 if (f6 < f1 | f3 < f5) {
  i11 = 0;
  return i11 | 0;
 }
 f15 = Math_fround(f6 - f1);
 f1 = Math_fround(f3 - f5);
 f1 = f15 < f1 ? f15 : f1;
 if (!(f1 < Math_fround(HEAPF32[i10 >> 2]))) {
  i11 = 1;
  return i11 | 0;
 }
 HEAPF32[i10 >> 2] = f1;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 >> 2];
 i11 = 1;
 return i11 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 16 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i5 >> 2] >> 2] << 4) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906539 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906539 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN13AudioListener12ApplyFiltersEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 24 | 0;
 i14 = i17 + 8 | 0;
 i13 = i17;
 i10 = i17 + 44 | 0;
 i11 = i17 + 40 | 0;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 i12 = i1 + 40 | 0;
 if ((HEAP32[i12 >> 2] | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i7 = i1 + 28 | 0;
 i8 = i10 + 11 | 0;
 i4 = i10 + 11 | 0;
 i5 = i10 + 11 | 0;
 i6 = i9 + 4 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
  do if (i1 | 0) {
   if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) {
    i1 = __ZN11AudioFilter6GetDSPEv(i1) | 0;
    if (!i1) {
     i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
     if (!i1) break; else i16 = 8;
    }
   } else i16 = 8;
   if ((i16 | 0) == 8) {
    i16 = 0;
    if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) break;
    i1 = __ZN13MonoBehaviour14GetOrCreateDSPEv(i1) | 0;
    if (!i1) break;
   }
   HEAP32[i11 >> 2] = 0;
   __ZN4FMOD3DSP11getUserDataEPPv(i1, i11) | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   do if (!i2) i16 = 14; else if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    HEAP32[i2 + 20 >> 2] = i9;
    i16 = 14;
    break;
   } else {
    __Z6FormatPKcz(i10, gb + 864324 | 0, i13);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 855694 | 0, 160, 512, HEAP32[i6 >> 2] | 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    break;
   } while (0);
   if ((i16 | 0) == 14) {
    i16 = 0;
    i2 = __ZN4FMOD3DSP6removeEv(i1) | 0;
    if (i2 | 0) {
     i2 = __ZL16FMOD_ErrorString11FMOD_RESULT(i2) | 0;
     HEAP32[i14 >> 2] = gb + 855694;
     HEAP32[i14 + 4 >> 2] = 167;
     HEAP32[i14 + 8 >> 2] = gb + 855766;
     HEAP32[i14 + 12 >> 2] = i2;
     __Z6FormatPKcz(i10, gb + 883334 | 0, i14);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    }
    i1 = __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 96 >> 2] | 0, i1, 0) | 0;
    if (i1 | 0) {
     i2 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
     HEAP32[i15 >> 2] = gb + 855694;
     HEAP32[i15 + 4 >> 2] = 168;
     HEAP32[i15 + 8 >> 2] = gb + 855780;
     HEAP32[i15 + 12 >> 2] = i2;
     __Z6FormatPKcz(i10, gb + 883334 | 0, i15);
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    }
   }
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i12 >> 2] | 0));
 STACKTOP = i17;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i1, i12, i17, i18, i16) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i12 >> 2]);
 i10 = i12 + 4 | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i12 + 8 | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f24 = Math_fround(-f4);
 f23 = Math_fround(-f5);
 f22 = Math_fround(-f6);
 f21 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f20 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 f25 = Math_fround(Math_fround(Math_fround(f21 * f24) + Math_fround(f20 * f23)) + Math_fround(f19 * f22));
 f13 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 i3 = f25 > Math_fround(Math_fround(Math_fround(f13 * f24) + Math_fround(f14 * f23)) + Math_fround(f15 * f22));
 f13 = i3 ? f21 : f13;
 f14 = i3 ? f20 : f14;
 f15 = i3 ? f19 : f15;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i9 = i3 + 200 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i8 = i3 + 204 | 0;
  if ((HEAPU8[i8 >> 0] | 0) > 1) {
   f25 = Math_fround(f4 * Math_fround(HEAPF32[i1 >> 2]));
   f5 = Math_fround(f25 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 4 >> 2])));
   f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i1 + 8 >> 2])));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i9 >> 2] | 0;
    f22 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f24 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]);
    f23 = Math_fround(HEAPF32[i12 >> 2]);
    f25 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f22 * f23) + Math_fround(f24 * f25)) + Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2])));
    i7 = f4 > f5;
    i2 = i7 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i8 >> 0] | 0) >>> 0) f5 = i7 ? f4 : f5; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i12) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 i10 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i11 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i12 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAPF32[i17 >> 2] = f13;
 HEAPF32[i17 + 4 >> 2] = f14;
 HEAPF32[i17 + 8 >> 2] = f15;
 HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i18 >> 2] = i10;
 HEAP32[i18 + 4 >> 2] = i11;
 HEAP32[i18 + 8 >> 2] = i12;
 HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
 f23 = Math_fround(f13 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f24 = Math_fround(f14 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f25 = Math_fround(f15 - (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i16 >> 2] = f23;
 HEAPF32[i16 + 4 >> 2] = f24;
 HEAPF32[i16 + 8 >> 2] = f25;
 HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK5physx20PxsSolverCoreGeneral13solveVCoulombEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE(i3, f5, i4, i11, i7, i1, i2, i6, i10, i9, i14, i15, i16, i17, i8) {
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 i4 = i4 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i8 = i8 | 0;
 var i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((i4 | 0) > 0) {
  i1 = (i15 | 0) == 0;
  i3 = i4;
  while (1) {
   if (!i1) {
    i2 = 0;
    do {
     mftCall_vii(HEAP32[gb + 103700 + ((HEAPU8[HEAP32[i14 + (i2 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i2 << 5) | 0, i12 | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i15 | 0));
   }
   if ((i3 | 0) > 1) i3 = i3 + -1 | 0; else break;
  }
 }
 i1 = i4 << 1;
 if (!((i1 | 0) < 1 | (i17 | 0) == 0)) while (1) {
  i2 = 0;
  do {
   mftCall_vii(HEAP32[gb + 103700 + ((HEAPU8[HEAP32[i16 + (i2 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i16 + (i2 << 5) | 0, i12 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i17 | 0));
  if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
 }
 if (i6 | 0) {
  i1 = 0;
  do {
   HEAP32[i8 + (i1 << 5) >> 2] = HEAP32[i7 + (i1 << 5) >> 2];
   HEAP32[i8 + (i1 << 5) + 4 >> 2] = HEAP32[i7 + (i1 << 5) + 4 >> 2];
   HEAP32[i8 + (i1 << 5) + 8 >> 2] = HEAP32[i7 + (i1 << 5) + 8 >> 2];
   HEAP32[i8 + (i1 << 5) + 16 >> 2] = HEAP32[i7 + (i1 << 5) + 16 >> 2];
   HEAP32[i8 + (i1 << 5) + 20 >> 2] = HEAP32[i7 + (i1 << 5) + 20 >> 2];
   HEAP32[i8 + (i1 << 5) + 24 >> 2] = HEAP32[i7 + (i1 << 5) + 24 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (i9 | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i10 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i9 | 0));
 }
 i3 = (i15 | 0) == 0;
 if (!i3) {
  i1 = 0;
  do {
   mftCall_vii(HEAP32[gb + 103756 + ((HEAPU8[HEAP32[i14 + (i1 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i1 << 5) | 0, i12 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
 }
 i2 = 1 - i11 | 0;
 if ((i2 | 0) >= 1) {
  STACKTOP = i13;
  return;
 }
 i4 = (i17 | 0) != 0;
 if (i3) {
  while (1) {
   if (i4) {
    i1 = 0;
    do {
     mftCall_vii(HEAP32[gb + 103700 + ((HEAPU8[HEAP32[i16 + (i1 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i16 + (i1 << 5) | 0, i12 | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i17 | 0));
   }
   if ((i2 | 0) < 0) i2 = i2 + 1 | 0; else break;
  }
  STACKTOP = i13;
  return;
 }
 while (1) {
  i1 = 0;
  do {
   mftCall_vii(HEAP32[gb + 103700 + ((HEAPU8[HEAP32[i14 + (i1 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i1 << 5) | 0, i12 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
  if (i4) {
   i1 = 0;
   do {
    mftCall_vii(HEAP32[gb + 103700 + ((HEAPU8[HEAP32[i16 + (i1 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i16 + (i1 << 5) | 0, i12 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i17 | 0));
  }
  if ((i2 | 0) < 0) i2 = i2 + 1 | 0; else break;
 }
 STACKTOP = i13;
 return;
}

function __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6MotionC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 176240 + 8;
 HEAP32[i1 + 56 >> 2] = gb + 176376 + 8;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 4096;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 84 >> 2] = i6;
 HEAP8[i1 + 93 >> 0] = 1;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 196 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 212 >> 0] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 228 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 248 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAPF32[i1 + 264 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 268 >> 2] = Math_fround(0.0);
 i2 = i1 + 272 | 0;
 i3 = i1 + 284 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 88 >> 2] = Math_fround(60.0);
 HEAP8[i1 + 92 >> 0] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i6 = i4 - i5 | 0;
 i10 = (i6 | 0) / 60 | 0;
 i12 = i13 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i1 = i5;
 i9 = i8;
 i14 = i4;
 if (i10 >>> 0 > ((i2 - i8 | 0) / 60 | 0) >>> 0) {
  i4 = i8;
  if (i8) {
   i2 = i13 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i9 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -60 - i8 | 0) >>> 0) / 60 | 0) * 60 | 0);
   i9 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 1;
   HEAP32[i11 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   i2 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  } else i3 = 0;
  i9 = (i2 - i3 | 0) / 60 | 0;
  i3 = i9 << 1;
  i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i10 >>> 0 ? i10 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 60 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i6 = i13 + 4 | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i12 >> 2] = i2 + (i3 * 60 | 0);
  if ((i1 | 0) == (i14 | 0)) {
   STACKTOP = i15;
   return;
  }
  do {
   i4 = i1;
   i5 = i2 + 60 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    i2 = i2 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i2 | 0) < (i5 | 0));
   i1 = i1 + 60 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 60 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 } else {
  i6 = i13 + 4 | 0;
  i2 = ((HEAP32[i6 >> 2] | 0) - i8 | 0) / 60 | 0;
  i3 = i10 >>> 0 > i2 >>> 0;
  i1 = i3 ? i1 + (i2 * 60 | 0) | 0 : i4;
  i2 = i1 - i5 | 0;
  if (i2 | 0) _memmove(i8 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i9 + (((i2 | 0) / 60 | 0) * 60 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -60 - i2 | 0) >>> 0) / 60 | 0) * 60 | 0);
   STACKTOP = i15;
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i15;
   return;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i4 = i1;
   i5 = i2 + 60 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    i2 = i2 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i2 | 0) < (i5 | 0));
   i1 = i1 + 60 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 60 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i15;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN24EllipsoidParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3 + 8 | 0;
 i9 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(236, i1, 16, gb + 1048932 | 0, 0, gb + 1048940 | 0, 15) | 0;
 i11 = i1;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i10, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 190444 + 8;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i10 = i4 + 144 | 0;
 i9 = i4 + 156 | 0;
 i8 = i4 + 168 | 0;
 i1 = i4 + 180 | 0;
 HEAP32[i4 + 208 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = 0;
 HEAP32[i4 + 216 >> 2] = i4;
 HEAPF32[i4 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 205 >> 0] = 1;
 HEAP8[i4 + 204 >> 0] = 1;
 HEAP8[i4 + 206 >> 0] = 0;
 HEAP8[i4 + 109 >> 0] = 0;
 HEAP8[i4 + 110 >> 0] = 0;
 HEAPF32[i4 + 116 >> 2] = Math_fround(.100000001);
 HEAPF32[i4 + 120 >> 2] = Math_fround(.100000001);
 HEAPF32[i4 + 124 >> 2] = Math_fround(3.0);
 HEAPF32[i4 + 128 >> 2] = Math_fround(3.0);
 HEAPF32[i4 + 132 >> 2] = Math_fround(50.0);
 HEAPF32[i4 + 136 >> 2] = Math_fround(50.0);
 HEAP8[i4 + 192 >> 0] = 1;
 HEAPF32[i4 + 140 >> 2] = Math_fround(.0500000007);
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 200 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 193 >> 0] = 0;
 HEAP8[i4 + 207 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i4 + 84 >> 2] = f7;
 HEAPF32[i4 + 88 >> 2] = f6;
 HEAPF32[i4 + 92 >> 2] = f5;
 HEAP32[i4 >> 2] = gb + 190272 + 8;
 HEAPF32[i4 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 228 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 232 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL38FrustumAndOcculusionCullLocalLightsJobP21LocalLightCullJobDataj(i25, i1) {
 i25 = i25 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i27 + 4 | 0;
 i22 = i27;
 if ((HEAP16[gb + 1111076 + 6 >> 1] | 0) > -1) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111076 | 0, i20);
  i24 = gb + 1111076 | 0;
 } else i24 = 0;
 i26 = i25 + 44 + (i1 * 12 | 0) | 0;
 i23 = i25 + 236 + (i1 << 2) | 0;
 if ((HEAP16[gb + 1111112 + 6 >> 1] | 0) > -1) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111112 | 0, i20);
  i21 = gb + 1111112 | 0;
 } else i21 = 0;
 i14 = HEAP32[i25 + 32 >> 2] | 0;
 i15 = HEAP32[i25 + 36 >> 2] | 0;
 i16 = HEAP32[i25 + 40 >> 2] | 0;
 i17 = HEAP32[i25 + 16 >> 2] | 0;
 i18 = HEAP32[i25 + 20 >> 2] | 0;
 i4 = HEAP32[i26 >> 2] | 0;
 i19 = i25 + 44 + (i1 * 12 | 0) + 4 | 0;
 i9 = (HEAP32[i19 >> 2] | 0) + i4 | 0;
 i10 = HEAP8[i18 + 548 >> 0] | 0 ? 2 : 1;
 if (i4 >>> 0 < i9 >>> 0) {
  i11 = HEAP32[i25 + 28 >> 2] | 0;
  i12 = HEAP32[i25 + 24 >> 2] | 0;
  i13 = i25 + 4 | 0;
  i3 = i4;
  i2 = i4;
  i8 = i4;
  do {
   i7 = i16 + (i8 << 2) | 0;
   HEAP32[i7 >> 2] = 0;
   i4 = HEAP32[i25 >> 2] | 0;
   f5 = Math_fround(__Z22PointDistanceToFrustumRK8Vector4fPK5Planei((HEAP32[i13 >> 2] | 0) + (i8 << 4) | 0, i4 + 28 | 0, HEAP32[i4 + 188 >> 2] | 0));
   f6 = Math_fround(HEAPF32[(HEAP32[i13 >> 2] | 0) + (i8 << 4) + 12 >> 2]);
   if (f5 < f6) {
    i4 = i3 + 1 | 0;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i8;
    i1 = HEAP32[(HEAP32[i17 + (i8 << 2) >> 2] | 0) + 44 >> 2] | 0;
    if ((HEAP32[i1 + 40 >> 2] | 2 | 0) == 2) {
     __Z26CalculateLightScreenBoundsRK13ShadowJobDataRK15SharedLightDataP5RectTIfER13TargetEyeMask(i18, i1, i15 + ((Math_imul(i8, i10) | 0) << 4) | 0, i7);
     i3 = i4;
    } else i3 = i4;
   } else if (f5 < Math_fround(f6 + f6)) {
    HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] = i8;
    HEAPF32[i14 + (i2 << 2) >> 2] = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f5 - f6) / f6));
    i2 = i2 + 1 | 0;
   }
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i9 | 0));
  i1 = HEAP32[i26 >> 2] | 0;
 } else {
  i3 = i4;
  i2 = i4;
  i1 = i4;
 }
 HEAP32[i19 >> 2] = i3 - i1;
 HEAP32[i23 >> 2] = i2 - i1;
 if (i21 | 0) __Z12profiler_endP19ProfilerInformation(i21);
 if ((HEAP16[gb + 1111100 + 6 >> 1] | 0) > -1) {
  HEAP32[i22 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111100 | 0, i20);
  i1 = gb + 1111100 | 0;
 } else i1 = 0;
 i2 = __Z9GetIUmbrav() | 0;
 if (i2 | 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i25 | 0, i26 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if (!i24) {
  STACKTOP = i27;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i27;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 36 | 0) + 1 | 0;
 if (i4 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 36 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 59652323 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 119304647;
 i5 = (i1 - i2 | 0) / 36 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 36 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 36 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 36 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 36 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 * 36 | 0) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP8[i3 + 16 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 36;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 36 | 0) + 1 | 0;
 if (i4 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 36 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 59652323 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 119304647;
 i5 = (i1 - i2 | 0) / 36 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 36 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 36 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 36 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 36 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 * 36 | 0) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP8[i3 + 16 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 36;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZNSt3__2L13utf16_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i7, i8, i3, i2, i9, i10, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 if (!(i4 & 2)) i5 = 4; else if ((i2 - i3 | 0) < 3) i1 = 1; else {
  HEAP32[i9 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -17;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -69;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -65;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  i5 = i7;
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L4;
   }
   i6 = HEAP32[i1 >> 2] | 0;
   i3 = i6 & 65535;
   if (i3 >>> 0 > i10 >>> 0) {
    i1 = 2;
    break L4;
   }
   do if (i3 >>> 0 < 128) {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i2 - i1 | 0) < 1) {
     i1 = 1;
     break L4;
    }
    HEAP32[i9 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i6;
   } else {
    if (i3 >>> 0 < 2048) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 2) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i6 >>> 6 | 192;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i6 & 63 | 128;
     break;
    }
    if (i3 >>> 0 < 55296) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 3) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3 >>> 12 | 224;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i6 >>> 6 & 63 | 128;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i6 & 63 | 128;
     break;
    }
    if (i3 >>> 0 >= 56320) {
     if (i3 >>> 0 < 57344) {
      i1 = 2;
      break L4;
     }
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i2 - i1 | 0) < 3) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3 >>> 12 | 224;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i6 >>> 6 & 63 | 128;
     i4 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i4 + 1;
     HEAP8[i4 >> 0] = i6 & 63 | 128;
     break;
    }
    if ((i5 - i1 | 0) < 8) {
     i1 = 1;
     break L4;
    }
    i1 = i1 + 4 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if ((i3 & 64512 | 0) != 56320) {
     i1 = 2;
     break L4;
    }
    if ((i2 - (HEAP32[i9 >> 2] | 0) | 0) < 4) {
     i1 = 1;
     break L4;
    }
    i4 = i6 & 960;
    if (((i4 << 10) + 65536 | i6 << 10 & 64512 | i3 & 1023) >>> 0 > i10 >>> 0) {
     i1 = 2;
     break L4;
    }
    HEAP32[i8 >> 2] = i1;
    i1 = (i4 >>> 6) + 1 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i1 >>> 2 | 240;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i6 >>> 2 & 15 | i1 << 4 & 48 | 128;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i6 << 4 & 48 | i3 >>> 6 & 15 | 128;
    i6 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i6 + 1;
    HEAP8[i6 >> 0] = i3 & 63 | 128;
   } while (0);
   i1 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_12PxFixedJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 384 | 0;
 i13 = i11 + 436 | 0;
 i15 = i11 + 332 | 0;
 i21 = i11;
 i6 = i11 + 328 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i14 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx25PxFixedJointGeneratedInfoC2Ev(i14);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEEEEjT_j(i14, i20, 0) | 0;
 HEAP32[i15 >> 2] = i19;
 HEAP32[i15 + 4 >> 2] = i18;
 i3 = i15 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i17;
 HEAP32[i15 + 24 >> 2] = i16;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i4;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i5;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj451ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 236 | 0, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj452ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 252 | 0, 1);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEclILj510ES3_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i11 >> 2] = i5;
 HEAP8[i11 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i7 = i11;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i11) | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i9 = i12 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i12 + 12 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i6 = gb + 832307 | 0; else i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i4 = mftCall_ii(i10 | 0, HEAP32[i12 + 8 >> 2] | 0) | 0;
 if (i4 | 0) {
  i3 = i8 + 12 | 0;
  if (gb + 742740 | 0) {
   i1 = gb + 742740 | 0;
   i2 = gb + 115776 | 0;
   i5 = 0;
   do {
    i10 = HEAP32[gb + 115776 + (i5 << 3) + 4 >> 2] | 0;
    do if ((i10 & i4 | 0) == (i10 | 0)) {
     if (HEAP32[i3 >> 2] | 0) {
      mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, gb + 1087697 | 0, 1) | 0;
      i1 = HEAP32[i2 >> 2] | 0;
      if (!i1) break;
     }
     if (HEAP8[i1 >> 0] | 0) {
      i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
      mftCall_iiii(i10 | 0, i8 | 0, i1 | 0, _strlen(i1) | 0) | 0;
     }
    } while (0);
    i5 = i5 + 1 | 0;
    i2 = gb + 115776 + (i5 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
  HEAP8[i11 >> 0] = 0;
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i11 | 0, 1) | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 | 0, HEAP32[i8 + 20 >> 2] | 0);
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN16MemoryFileSystemC2EPKc(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 HEAP32[i8 >> 2] = gb + 71492 + 8;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = i8 + 8;
 i2 = i8 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 36 >> 2] = i1;
 i5 = _strlen(i4) | 0;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
  i1 = HEAP32[i8 + 36 >> 2] | 0;
  i6 = 4;
 } else if (i5 >>> 0 < 11) {
  i3 = i2 + 11 | 0;
  HEAP8[i3 >> 0] = i5;
  if (!i5) {
   i1 = i2;
   i7 = i3;
  } else {
   i1 = i2;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i7 = i5 + 16 & -16;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 + 32 >> 2] = i7 | -2147483648;
  HEAP32[i8 + 28 >> 2] = i5;
  i3 = i2 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  i7 = i3;
 }
 HEAP8[i1 + i5 >> 0] = 0;
 i6 = HEAP8[i7 >> 0] | 0;
 i5 = i6 << 24 >> 24 < 0;
 if (i5) i1 = HEAP32[i8 + 28 >> 2] | 0; else i1 = i6 & 255;
 if (!i1) {
  __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
  STACKTOP = i9;
  return;
 }
 if (i5) {
  i1 = HEAP32[i8 + 28 >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = i6 & 255;
  i3 = i2;
 }
 if ((HEAP8[i3 + (i1 + -1) >> 0] | 0) != 47) {
  __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
  STACKTOP = i9;
  return;
 }
 if (i5) {
  i3 = HEAP32[i8 + 28 >> 2] | 0;
  i1 = i3;
 } else {
  i1 = i6 & 255;
  i3 = i6 & 255;
 }
 i1 = i1 + -1 | 0;
 if (i1 >>> 0 <= i3 >>> 0) if (i5) {
  HEAP8[(HEAP32[i2 >> 2] | 0) + i1 >> 0] = 0;
  HEAP32[i8 + 28 >> 2] = i1;
  __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i2 + i1 >> 0] = 0;
  HEAP8[i7 >> 0] = i1;
  __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
  STACKTOP = i9;
  return;
 }
 i4 = i1 - i3 | 0;
 if (!i4) {
  __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
  STACKTOP = i9;
  return;
 }
 if (i5) {
  i1 = (HEAP32[i8 + 32 >> 2] & 2147483647) + -1 | 0;
  i3 = HEAP32[i8 + 28 >> 2] | 0;
 } else {
  i1 = 10;
  i3 = i6 & 255;
 }
 if ((i1 - i3 | 0) >>> 0 < i4 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj(i2, i1, i4 - i1 + i3 | 0, i3, i3, 0, 0);
  i1 = HEAP8[i7 >> 0] | 0;
 } else i1 = i6;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i2 >> 2] | 0;
 _memset(i2 + i3 | 0, 0, i4 | 0) | 0;
 i1 = i3 + i4 | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i8 + 28 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i8, gb + 1576256 | 0, 1) | 0;
 STACKTOP = i9;
 return;
}

function __ZN19CollisionListener2D10EndContactEP9b2Contact(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i12 = i14;
 if ((HEAP16[gb + 1458052 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458052 | 0, i10);
  i13 = gb + 1458052 | 0;
 } else i13 = 0;
 i8 = i7 + 48 | 0;
 i9 = i7 + 52 | 0;
 i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2] | 0;
 i1 = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + 60 >> 2] | 0) + 156 >> 2] | 0;
 L4 : do if (i1 | 0) {
  i5 = HEAP32[i1 + 36 >> 2] | 0;
  i2 = i1 + 48 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i4 = i5 + (i3 * 40 | 0) | 0;
   i1 = i5;
   while (1) {
    if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
    i1 = i1 + 40 | 0;
    if ((i1 | 0) == (i4 | 0)) break L4;
   }
   i4 = i3 + -1 | 0;
   HEAP32[i2 >> 2] = i4;
   i3 = i1;
   i1 = i5 + (i4 * 40 | 0) | 0;
   i2 = i3 + 40 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
 } while (0);
 i1 = HEAP32[i6 + 156 >> 2] | 0;
 L12 : do if (i1 | 0) {
  i5 = HEAP32[i1 + 36 >> 2] | 0;
  i2 = i1 + 48 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i4 = i5 + (i3 * 40 | 0) | 0;
   i1 = i5;
   while (1) {
    if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
    i1 = i1 + 40 | 0;
    if ((i1 | 0) == (i4 | 0)) break L12;
   }
   i6 = i3 + -1 | 0;
   HEAP32[i2 >> 2] = i6;
   i3 = i1;
   i1 = i5 + (i6 * 40 | 0) | 0;
   i2 = i3 + 40 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
 } while (0);
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -69 | 4;
 i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + 60 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2] | 0;
 i9 = i4;
 i2 = i5;
 i8 = (HEAP32[i4 + 4 >> 2] | 0) > (HEAP32[i5 + 4 >> 2] | 0);
 HEAP32[i10 >> 2] = i8 ? i2 : i9;
 HEAP32[i10 + 4 >> 2] = i8 ? i9 : i2;
 __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_(i12, i11 + 4 | 0, i10);
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i11 = i2 + 28 | 0;
 i12 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
 HEAP32[i11 >> 2] = i12;
 L20 : do if (!i12) {
  i3 = i2 + 72 | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) {
   i1 = HEAP32[i5 + 28 >> 2] | 0;
   if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0) {
    switch (HEAP32[i3 >> 2] | 0) {
    case 0:
    case 5:
     break L20;
    default:
     {}
    }
    HEAP32[i3 >> 2] = HEAP8[i2 + 78 >> 0] | 0 ? 2 : 3;
    break;
   }
  }
  HEAP32[i3 >> 2] = 0;
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return;
}

function __ZN9BoxPruner12removeObjectEt(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 1 | 0;
 i8 = i15;
 i10 = i1 & 65535;
 i11 = i14 + 76 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i2 + (i10 << 3) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i13 = i2 + (i10 << 3) + 4 | 0;
 if (!(HEAP32[i13 >> 2] & 1)) {
  HEAP32[i14 + 120 >> 2] = 0;
  HEAP8[i14 + 169 >> 0] = 1;
  i3 = i14 + 116 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i14 + 92 | 0;
  if (i9 >>> 0 < i1 >>> 0) {
   if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
    i2 = i1;
    i1 = i9;
   } else {
    i1 = i1 + -1 | 0;
    i7 = HEAP32[i14 + 108 >> 2] | 0;
    i5 = HEAP32[i14 + 100 >> 2] | 0;
    i8 = HEAP16[i7 + (i1 << 1) >> 1] | 0;
    i6 = i5 + (i9 * 24 | 0) | 0;
    i5 = i5 + (i1 * 24 | 0) | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP16[i7 + (i9 << 1) >> 1] = i8;
    HEAP32[i2 + ((i8 & 65535) << 3) >> 2] = i9;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i2 + -1;
  } else i1 = i9;
  i9 = HEAP32[i14 + 108 >> 2] | 0;
  i2 = HEAP32[i14 + 100 >> 2] | 0;
  i3 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i3;
  i4 = i9;
 } else {
  HEAP8[i14 + 168 >> 0] = 1;
  i4 = i14 + 124 | 0;
  i7 = i9 >>> 5;
  i5 = i14 + 128 | 0;
  if (i7 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) i1 = HEAP32[i4 >> 2] | 0; else {
   i6 = i9 + 128 | 0;
   i6 = ((i6 & 31 | 0) != 0 & 1) + (i6 >>> 5) | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i6 << 2, gb + 717183 | 0, 412) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, i2 << 2 | 0) | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   if ((i6 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i6 - i2 << 2 | 0) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
    HEAP32[i4 >> 2] = 0;
   }
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
  }
  i4 = i1 + (i7 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1 << (i9 & 31);
  i4 = HEAP32[i14 + 104 >> 2] | 0;
  i2 = HEAP32[i14 + 96 >> 2] | 0;
  i1 = i14 + 84 | 0;
  i3 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  HEAP32[i1 >> 2] = i3;
  i1 = i9;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP16[i4 + (i3 << 1) >> 1] | 0;
 i8 = i2 + (i1 * 24 | 0) | 0;
 i7 = i2 + (i3 * 24 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP16[i4 + (i1 << 1) >> 1] = i11;
 HEAP32[i9 + ((i11 & 65535) << 3) >> 2] = i1;
 i11 = i14 + 72 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 >> 2] = -1;
 HEAP32[i11 >> 2] = i10;
 i14 = i14 + 64 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 STACKTOP = i15;
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValues12ToJsonStringER8UnityStr(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 192 | 0;
 i12 = i14;
 i13 = i14 + 160 | 0;
 i11 = i14 + 144 | 0;
 __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i12, 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i12 | 0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 i9 = i13 + 24 | 0;
 i3 = gb + 64016 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i13 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i12, i13, 0);
 i2 = HEAP32[i13 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? i1 : i2;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i4 = i11 + 11 | 0;
 do if ((i11 | 0) != (i8 | 0)) {
  i6 = HEAP8[i4 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
  i6 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
  i7 = i8 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i7 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i6 - i3 | 0, i7, 0, i7, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i8 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  __ZN9JSONWriteD2Ev(i12);
  STACKTOP = i14;
  return;
 }
 if (!(HEAP32[i13 + 4 >> 2] | 0)) {
  __ZN9JSONWriteD2Ev(i12);
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 __ZN9JSONWriteD2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 4;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 4 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 4;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 4) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 4;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 4) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -16 - i2 | 0) >>> 4) << 4);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -16 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 16 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 4) + 1 << 4);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i9 | 0) >>> 4) << 4);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 3;
 i2 = i10 >> 4 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 4);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -16 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i1 = i1 + 16 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 16 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 4) + 1 << 4);
 STACKTOP = i15;
 return;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7GetFreeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i1 | 0) == (i3 + 16 | 0)) i2 = 5; else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i4 = i3 + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   }
  }
  do if ((i2 | 0) == 5) {
   i1 = i3 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
    i4 = __Znwj(176) | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = 0;
    i5 = i4 + 8 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP8[i4 + 16 >> 0] = 1;
    HEAP32[i4 + 20 >> 2] = 0;
    i2 = i4 + 24 | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i4 + 28 >> 2] = i2;
    HEAP32[i4 + 32 >> 2] = i2;
    i2 = i4 + 40 | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i4 + 44 >> 2] = i2;
    HEAP32[i4 + 48 >> 2] = i2;
    i2 = i4 + 52 | 0;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i4 + 56 >> 2] = i2;
    HEAP32[i4 + 60 >> 2] = i2;
    HEAP32[i4 + 64 >> 2] = 0;
    HEAP32[i4 + 68 >> 2] = 0;
    HEAP32[i4 + 72 >> 2] = 0;
    i2 = i4 + 104 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAPF32[i4 + 136 >> 2] = Math_fround(1.0);
    HEAPF32[i4 + 140 >> 2] = Math_fround(44100.0);
    HEAPF32[i4 + 144 >> 2] = Math_fround(1.0);
    HEAPF32[i4 + 148 >> 2] = Math_fround(1.0);
    HEAPF32[i4 + 152 >> 2] = Math_fround(1.0);
    i2 = i4 + 156 | 0;
    HEAP32[i4 + 168 >> 2] = 0;
    i6 = i4 + 76 | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    HEAP32[i6 + 20 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP16[i2 + 4 >> 1] = 0;
    HEAP8[i2 + 6 >> 0] = 0;
    HEAP32[i4 + 164 >> 2] = _JS_Sound_Create_Channel(fb + 3782 | 0, i4 | 0) | 0;
    HEAPF32[i4 + 36 >> 2] = Math_fround(Math_fround((_rand() | 0) % 1e3 | 0 | 0) * Math_fround(.00100000005));
    i2 = HEAP32[i1 >> 2] | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    i1 = i4;
    break;
   } else {
    i6 = 0;
    return i6 | 0;
   }
  } while (0);
  i5 = i3 + 12 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = i1 + 24 | 0;
  i4 = i1 + 32 | 0;
  i2 = i1 + 28 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i2 >> 2] = i5;
  i6 = i3 + 32 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = i3 + 28;
  HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] = i5;
  HEAP32[i6 >> 2] = i5;
 } else {
  i1 = HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = i4 << 16 & 268369920 | i5 << 28 | i6 & 65535;
 i6 = i1;
 return i6 | 0;
}

function __ZNK15CollisionEvents9GetEventsEiP26MonoParticleCollisionEventi(i16, i10, i17, i18) {
 i16 = i16 | 0;
 i10 = i10 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 8 | 0;
 i13 = i20;
 i19 = i16 + 12 | 0;
 if (!(HEAP32[i19 >> 2] | 0)) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i3 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 while (1) {
  i11 = i3 + 40 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  if (!i2) {
   i14 = 0;
   i15 = 8;
  } else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i6 = HEAP32[i2 + 32 >> 2] | 0;
    i4 = i5 + (i6 << 3) | 0;
    i8 = i2;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i2, i13);
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = HEAP32[i2 + 28 >> 2] | 0;
    i8 = HEAP32[gb + 1104264 >> 2] | 0;
    i4 = (i4 | 0) == -1 ? i5 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i5 + (i4 << 3) | 0;
    i5 = HEAP32[i8 + 28 >> 2] | 0;
    i6 = HEAP32[i8 + 32 >> 2] | 0;
   }
   if ((i4 | 0) == (i5 + (i6 << 3) | 0)) {
    i14 = i8;
    i15 = 8;
   } else {
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) {
     i7 = 0;
     i9 = i8;
    } else {
     i2 = HEAP32[i2 + 28 >> 2] | 0;
     if (!i2) {
      i7 = 0;
      i9 = i8;
     } else {
      i7 = HEAP32[i2 + 4 >> 2] | 0;
      i9 = i8;
     }
    }
   }
  }
  if ((i15 | 0) == 8) {
   i15 = 0;
   i7 = 0;
   i9 = i14;
  }
  if ((i7 | 0) == (i10 | 0)) break;
  i2 = i3 + 44 | 0;
  if ((i2 | 0) == ((HEAP32[i16 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 44 | 0) | 0)) {
   i1 = 0;
   i15 = 17;
   break;
  } else {
   i3 = i2;
   i2 = i9;
  }
 }
 if ((i15 | 0) == 17) {
  STACKTOP = i20;
  return i1 | 0;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 if ((i18 | 0) > 0 ? (i3 | 0) != ((HEAP32[i16 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 44 | 0) | 0) : 0) i1 = 0; else {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 while (1) {
  i2 = i17 + (i1 * 40 | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i2 = i17 + (i1 * 40 | 0) + 12 | 0;
  i15 = i3 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  i2 = i17 + (i1 * 40 | 0) + 24 | 0;
  i15 = i3 + 24 | 0;
  HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i17 + (i1 * 40 | 0) + 36 >> 2] = HEAP32[i3 + 36 >> 2];
  i1 = i1 + 1 | 0;
  i2 = i3;
  i3 = i3 + 44 | 0;
  if ((i3 | 0) == ((HEAP32[i16 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) * 44 | 0) | 0)) {
   i15 = 17;
   break;
  }
  if (!((i1 | 0) < (i18 | 0) ? (HEAP32[i2 + 84 >> 2] | 0) == (i4 | 0) : 0)) {
   i15 = 17;
   break;
  }
 }
 if ((i15 | 0) == 17) {
  STACKTOP = i20;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Sc13ConstraintSimC2ERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_RNS0_5SceneE(i17, i4, i14, i15, i16) {
 i17 = i17 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i18 + 4 | 0;
 i3 = i18;
 i11 = i17 + 96 | 0;
 HEAP32[i11 >> 2] = i16;
 i6 = i17 + 100 | 0;
 HEAP32[i6 >> 2] = i4;
 i2 = i17 + 116 | 0;
 HEAP8[i2 >> 0] = 0;
 i8 = i17 + 12 | 0;
 i13 = (i14 | 0) != 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 0;
 HEAP32[i17 + 20 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 0;
 if (i13) if (!(HEAP8[i14 + 10 >> 0] | 0)) i1 = 0; else i1 = __ZNK5physx2Sc9RigidCore6getSimEv(i14) | 0; else i1 = 0;
 i9 = i17 + 108 | 0;
 HEAP32[i9 >> 2] = i1;
 i12 = (i15 | 0) != 0;
 if (i12) if (!(HEAP8[i15 + 10 >> 0] | 0)) i1 = 0; else i1 = __ZNK5physx2Sc9RigidCore6getSimEv(i15) | 0; else i1 = 0;
 i7 = i17 + 112 | 0;
 HEAP32[i7 >> 2] = i1;
 if (!(__ZN5physx2Sc13ConstraintSim18createLLConstraintEv(i17) | 0)) {
  STACKTOP = i18;
  return;
 }
 i19 = i16 + 2396 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 HEAP32[i19 >> 2] = i1 + 1;
 HEAP32[i17 + 88 >> 2] = i1;
 __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_(i4, i5, i3);
 i5 = Math_fround(HEAPF32[i5 >> 2]) < Math_fround(3402823469999999843913219.0e14);
 if (i5 | Math_fround(HEAPF32[i3 >> 2]) < Math_fround(3402823469999999843913219.0e14)) HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 2;
 HEAP32[i4 + 68 >> 2] = i17;
 i3 = HEAP32[i16 + 96 >> 2] | 0;
 if (!(HEAP16[HEAP32[i6 >> 2] >> 1] & 6)) i10 = 12; else if (!(HEAP32[i8 >> 2] | 0)) __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE(i3, i17); else i10 = 12;
 if ((i10 | 0) == 12) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 60 >> 2] | 0;
   if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i17);
  }
  if (i2 | 0) {
   i1 = HEAP32[i2 + 60 >> 2] | 0;
   if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i17);
  }
 }
 i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + 1228 >> 2] | 0;
 if (i13) i4 = __ZNK5physx2Sc9RigidCore6getSimEv(i14) | 0; else i4 = HEAP32[i16 + 1208 >> 2] | 0;
 if (i12) i3 = __ZNK5physx2Sc9RigidCore6getSimEv(i15) | 0; else i3 = HEAP32[i16 + 1208 >> 2] | 0;
 i2 = i5 + 292 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i5);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i19 = i5 + 280 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 i19 = i5 + 284 | 0;
 HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + -1;
 if (!i1) i1 = 0; else __ZN5physx2Sc21ConstraintInteractionC2EPNS0_13ConstraintSimERNS0_8RigidSimES5_(i1, i17, i4, i3);
 HEAP32[i17 + 104 >> 2] = i1;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 STACKTOP = i18;
 return;
}

function __ZN24CompressedAnimationCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i6 = i3 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899417 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 72 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 899424 | 0, 0);
 i8 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 901491 | 0, gb + 899432 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899448 | 0, gb + 899432 | 0, i6, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034211 | 0, i6, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034225 | 0, i6, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13TargetJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 76 | 0;
 i8 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946522 | 0, i8, i6, 0);
 i7 = i2 + 20 | 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 84 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803176 | 0, i8, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803185 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802602 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803283 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853582 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5Cache9FreeSpaceEj(i2, i15) {
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i10 = i2 + 56 | 0;
 i13 = i2 + 60 | 0;
 i14 = i2 + 32 | 0;
 i4 = i14;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i2 + 24 | 0;
 i1 = i9;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i12 = _i64Subtract(i5 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
 i11 = getTempRet0() | 0;
 if (!((i11 | 0) < 0 | (i11 | 0) == 0 & i12 >>> 0 < i15 >>> 0)) {
  i11 = i5;
  i14 = i4;
  i13 = i3;
  i12 = i1;
  i12 = _i64Subtract(i11 | 0, i14 | 0, i13 | 0, i12 | 0) | 0;
  i13 = getTempRet0() | 0;
  i14 = (i13 | 0) > 0;
  i15 = i12 >>> 0 >= i15 >>> 0;
  i13 = (i13 | 0) == 0;
  i15 = i13 & i15;
  i15 = i14 | i15;
  return i15 | 0;
 }
 i11 = i2 + 68 | 0;
 i12 = i2 + 64 | 0;
 i8 = i2 + 60 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 while (1) {
  i6 = i7;
  if ((i6 | 0) == (i13 | 0)) {
   i2 = 19;
   break;
  }
  i3 = i6 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i2 = i7;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = i6 + 16 | 0;
  if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0) if (!(__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE14__count_uniqueIS7_EEjRKT_(i11, i4) | 0)) if (!(__Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0)) if (__Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4) | 0) {
   i16 = i9;
   i16 = _i64Subtract(HEAP32[i16 >> 2] | 0, HEAP32[i16 + 4 >> 2] | 0, HEAP32[i6 + 28 >> 2] | 0, 0) | 0;
   i2 = getTempRet0() | 0;
   i5 = i9;
   HEAP32[i5 >> 2] = i16;
   HEAP32[i5 + 4 >> 2] = i2;
   i5 = i7;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i3 = i5;
    while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    }
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   if ((HEAP32[i10 >> 2] | 0) == (i6 | 0)) HEAP32[i10 >> 2] = i2;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   __ZdlPv(i7);
  }
  i7 = i1;
  i4 = i14;
  i5 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i9;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i16 = _i64Subtract(i5 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
  i6 = getTempRet0() | 0;
  if (!((i6 | 0) < 0 | (i6 | 0) == 0 & i16 >>> 0 < i15 >>> 0)) {
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) {
  i16 = _i64Subtract(i5 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
  i13 = getTempRet0() | 0;
  i14 = (i13 | 0) > 0;
  i16 = i16 >>> 0 >= i15 >>> 0;
  i15 = (i13 | 0) == 0;
  i16 = i15 & i16;
  i16 = i14 | i16;
  return i16 | 0;
 }
 return 0;
}

function __ZN16SpriteRenderData11SetVerticesEPK8Vector2fjRK6Sprite(i6, i7, i11, i12) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f8 = f0, i9 = 0, f10 = f0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 f14 = Math_fround(HEAPF32[i12 + 140 >> 2]);
 f8 = Math_fround(HEAPF32[i12 + 40 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 44 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i12 + 72 >> 2]));
 i9 = i12 + 76 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i9 >> 2]));
 i5 = i6 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
  i4 = i13;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i1 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
  i2 = i13;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i1 + 32 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
 }
 i5 = i1 + 8 | 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = i11;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i11 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i11;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i11 * 20 | 0, 4, i1 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 * 20 | 0, 4, i1 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i3 >> 2] = i11;
  HEAP32[i5 >> 2] = i4;
  break;
 } while (0);
 if (!i11) {
  i11 = i12 + 72 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i13 >> 2] = i11;
  i11 = i13 + 4 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = i9;
  i12 = i12 + 32 | 0;
  __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE(i6, 1, i13, i12);
  STACKTOP = i15;
  return;
 }
 i1 = 0;
 do {
  i4 = HEAP32[i5 >> 2] | 0;
  f17 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 + (i1 << 3) >> 2]) - f8) / f14);
  f16 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 + (i1 << 3) + 4 >> 2]) - f10) / f14);
  HEAPF32[i4 + (i1 * 20 | 0) >> 2] = f17;
  HEAPF32[i4 + (i1 * 20 | 0) + 4 >> 2] = f16;
  HEAPF32[i4 + (i1 * 20 | 0) + 8 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 i11 = i12 + 72 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = i11;
 i11 = i13 + 4 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = i9;
 i12 = i12 + 32 | 0;
 __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE(i6, 1, i13, i12);
 STACKTOP = i15;
 return;
}

function __ZL14DidUnloadScenei(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 32 | 0;
 i13 = i15 + 24 | 0;
 i10 = i15 + 44 | 0;
 i11 = i15 + 16 | 0;
 i12 = i15 + 8 | 0;
 i5 = i15;
 i1 = (__Z21GetManagerFromContexti(26) | 0) + 100 | 0;
 i2 = __ZNK21EnlightenSceneMapping14FindSceneIndexEi(i1, i4) | 0;
 if ((i2 | 0) == -1) {
  i1 = -1;
  i3 = 0;
 } else {
  __ZN21EnlightenSceneMapping5EraseEi(i14, i1, i2);
  i3 = i14;
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = __Z13GetIEnlightenv() | 0;
  if (i2) {
   i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i14, gb + 1576256 | 0, 0);
   mftCall_vii(i9 | 0, i2 | 0, i14 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
 }
 __ZN16LightmapSettings15RemoveLightmapsEi(i5, __Z21GetManagerFromContexti(26) | 0, i4);
 i7 = i5;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 if (!(i7 | i3)) {
  STACKTOP = i15;
  return;
 }
 if ((HEAP16[gb + 1158128 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158128 | 0, i14);
  i5 = gb + 1158128 | 0;
 } else i5 = 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i13;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i2 = i10 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i17 = i14;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i4 + 4 >> 2] = i16;
 __Z26ExtractAllRenderersInSceneR13dynamic_arrayIP8RendererLj4EE(i10);
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i17 = HEAP32[i10 >> 2] | 0;
  i4 = i17 + (i2 << 2) | 0;
  i2 = i17;
  do {
   i17 = (HEAP32[i2 >> 2] | 0) + 260 | 0;
   i16 = HEAP32[i17 >> 2] | 0;
   i18 = i16 >>> 16;
   HEAP32[i17 >> 2] = (i18 >>> 0 >= i1 >>> 0 & (i18 & 65535) < 65534 ? i3 : 0) + i18 << 16 | ((i16 & 65535) < 65534 & (i16 & 65535) >>> 0 >= i6 >>> 0 ? i7 : 0) + i16 & 65535;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 i2 = __Z18GetITerrainManagerv() | 0;
 if (i2 | 0) {
  i18 = HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0;
  i17 = i11;
  HEAP32[i17 >> 2] = i6;
  HEAP32[i17 + 4 >> 2] = i7;
  i17 = i12;
  HEAP32[i17 >> 2] = i1;
  HEAP32[i17 + 4 >> 2] = i3;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  mftCall_viii(i18 | 0, i2 | 0, i13 | 0, i14 | 0);
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
  HEAP32[i10 >> 2] = 0;
 }
 if (!i5) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i15;
 return;
}

function _jpeg_fdct_islow(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i2 = i1;
 i3 = 7;
 while (1) {
  i4 = HEAP32[i2 >> 2] | 0;
  i14 = i2 + 28 | 0;
  i7 = HEAP32[i14 >> 2] | 0;
  i17 = i7 + i4 | 0;
  i7 = i4 - i7 | 0;
  i4 = i2 + 4 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i9 = i2 + 24 | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  i19 = i11 + i6 | 0;
  i11 = i6 - i11 | 0;
  i6 = i2 + 8 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i12 = i2 + 20 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i16 = i13 + i8 | 0;
  i13 = i8 - i13 | 0;
  i8 = i2 + 12 | 0;
  i18 = HEAP32[i8 >> 2] | 0;
  i5 = i2 + 16 | 0;
  i15 = HEAP32[i5 >> 2] | 0;
  i10 = i15 + i18 | 0;
  i15 = i18 - i15 | 0;
  i18 = i10 + i17 | 0;
  i10 = i17 - i10 | 0;
  i17 = i16 + i19 | 0;
  i16 = i19 - i16 | 0;
  HEAP32[i2 >> 2] = i18 + i17 << 2;
  HEAP32[i5 >> 2] = i18 - i17 << 2;
  i5 = (i10 + i16 | 0) * 4433 | 0;
  HEAP32[i6 >> 2] = (i10 * 6270 | 0) + 1024 + i5 >> 11;
  HEAP32[i9 >> 2] = (Math_imul(i16, -15137) | 0) + 1024 + i5 >> 11;
  i9 = i15 + i11 | 0;
  i5 = i13 + i7 | 0;
  i16 = (i9 + i5 | 0) * 9633 | 0;
  i6 = Math_imul(i15 + i7 | 0, -7373) | 0;
  i10 = Math_imul(i13 + i11 | 0, -20995) | 0;
  i9 = i16 + (Math_imul(i9, -16069) | 0) | 0;
  i5 = i16 + (Math_imul(i5, -3196) | 0) | 0;
  HEAP32[i14 >> 2] = (i15 * 2446 | 0) + 1024 + i6 + i9 >> 11;
  HEAP32[i12 >> 2] = (i13 * 16819 | 0) + 1024 + i10 + i5 >> 11;
  HEAP32[i8 >> 2] = (i11 * 25172 | 0) + 1024 + i10 + i9 >> 11;
  HEAP32[i4 >> 2] = (i7 * 12299 | 0) + 1024 + i6 + i5 >> 11;
  if ((i3 | 0) > 0) {
   i2 = i2 + 32 | 0;
   i3 = i3 + -1 | 0;
  } else {
   i2 = 7;
   break;
  }
 }
 while (1) {
  i19 = HEAP32[i1 >> 2] | 0;
  i9 = i1 + 224 | 0;
  i16 = HEAP32[i9 >> 2] | 0;
  i5 = i16 + i19 | 0;
  i16 = i19 - i16 | 0;
  i19 = i1 + 32 | 0;
  i17 = HEAP32[i19 >> 2] | 0;
  i14 = i1 + 192 | 0;
  i12 = HEAP32[i14 >> 2] | 0;
  i4 = i12 + i17 | 0;
  i12 = i17 - i12 | 0;
  i17 = i1 + 64 | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i11 = i1 + 160 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i7 = i10 + i15 | 0;
  i10 = i15 - i10 | 0;
  i15 = i1 + 96 | 0;
  i6 = HEAP32[i15 >> 2] | 0;
  i18 = i1 + 128 | 0;
  i8 = HEAP32[i18 >> 2] | 0;
  i13 = i8 + i6 | 0;
  i8 = i6 - i8 | 0;
  i6 = i13 + i5 | 0;
  i13 = i5 - i13 | 0;
  i5 = i7 + i4 | 0;
  i7 = i4 - i7 | 0;
  HEAP32[i1 >> 2] = i5 + 2 + i6 >> 2;
  HEAP32[i18 >> 2] = 2 - i5 + i6 >> 2;
  i18 = (i13 + i7 | 0) * 4433 | 0;
  HEAP32[i17 >> 2] = (i13 * 6270 | 0) + 16384 + i18 >> 15;
  HEAP32[i14 >> 2] = (Math_imul(i7, -15137) | 0) + 16384 + i18 >> 15;
  i14 = i8 + i12 | 0;
  i18 = i10 + i16 | 0;
  i7 = (i14 + i18 | 0) * 9633 | 0;
  i17 = Math_imul(i8 + i16 | 0, -7373) | 0;
  i13 = Math_imul(i10 + i12 | 0, -20995) | 0;
  i14 = i7 + (Math_imul(i14, -16069) | 0) | 0;
  i18 = i7 + (Math_imul(i18, -3196) | 0) | 0;
  HEAP32[i9 >> 2] = (i8 * 2446 | 0) + 16384 + i17 + i14 >> 15;
  HEAP32[i11 >> 2] = (i10 * 16819 | 0) + 16384 + i13 + i18 >> 15;
  HEAP32[i15 >> 2] = (i12 * 25172 | 0) + 16384 + i13 + i14 >> 15;
  HEAP32[i19 >> 2] = (i16 * 12299 | 0) + 16384 + i17 + i18 >> 15;
  if ((i2 | 0) > 0) {
   i1 = i1 + 4 | 0;
   i2 = i2 + -1 | 0;
  } else break;
 }
 return;
}

function __ZN12ShaderErrors21AddShaderCompileErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEib(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 88 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1576256 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1576256 | 0, 0);
 __ZN12ShaderErrors11ShaderErrorC2ERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_S9_iibb(i7, i1, i8, i9, -1, i2, i3, 0);
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if (__ZNK12ShaderErrors11ShaderErrorltERKS0_(i7, i2) | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if (!(__ZNK12ShaderErrors11ShaderErrorltERKS0_(i2, i7) | 0)) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i3 = i6;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(76) | 0;
  __ZN12ShaderErrors11ShaderErrorC2ERKS0_(i1 + 16 | 0, i7);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i5 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i1);
  i5 = i5 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 i1 = i7 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i7 + 44 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 i1 = i7 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i7 + 28 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 8 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 * 12 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 12 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  break;
 } while (0);
 i9 = i1 + ((HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i3 = HEAP32[gb + 37324 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L17;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i2 = i7;
 __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 72 | 0, i5);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i5);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2, i5);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 144 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 145 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 146 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 147 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 148 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 149 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i3 = f8 < Math_fround(0.0);
 f8 = i3 ? Math_fround(0.0) : f8;
 i3 = f8 > Math_fround(1.0);
 HEAP8[i1 + 150 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = f8 < Math_fround(0.0);
 f8 = i2 ? Math_fround(0.0) : f8;
 i2 = f8 > Math_fround(1.0);
 HEAP8[i1 + 151 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = i1 + 152 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 2);
  i6 = HEAP16[i6 >> 1] | 0;
  i6 = _llvm_bswap_i16(i6 | 0) | 0;
  HEAP16[i1 >> 1] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP16[i3 >> 1] | 0;
  HEAP16[i6 >> 1] = i3;
  HEAP32[i2 >> 2] = i4;
  i6 = i3;
  i6 = _llvm_bswap_i16(i6 | 0) | 0;
  HEAP16[i1 >> 1] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 }
}

function __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i10 = i1;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i9 = i1 + (i11 * 40 | 0) | 0;
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 i5 = i1 + (i11 * 40 | 0) + 4 | 0;
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 i2 = i1 + (i11 * 40 | 0) + 8 | 0;
 i6 = f14 != f13 | f17 != f4 | f15 != Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i9 >> 2] = f14;
 HEAPF32[i5 >> 2] = f17;
 HEAPF32[i2 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(f15 * f15);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(f14 * f14);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f13 * f13);
 f16 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f12 = Math_fround(Math_fround(f17 + f4) + Math_fround(f12 + Math_fround(f16 * f16)));
 f4 = Math_fround(Math_sqrt(Math_fround(f12)));
 f15 = Math_fround(f15 / f4);
 f14 = Math_fround(f14 / f4);
 f13 = Math_fround(f13 / f4);
 f4 = Math_fround(f16 / f4);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f12 > Math_fround(1.0e-30);
 i2 = i9 ? i2 : 0;
 i3 = i9 ? i3 : 0;
 i5 = i9 ? i5 : 0;
 i8 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i19 = i1 + (i11 * 40 | 0) + 12 | 0;
 f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i20 = f17 != Math_fround(HEAPF32[i19 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = i1 + (i11 * 40 | 0) + 16 | 0;
 i21 = f17 != Math_fround(HEAPF32[i18 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = i1 + (i11 * 40 | 0) + 20 | 0;
 i22 = f17 != Math_fround(HEAPF32[i7 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = i1 + (i11 * 40 | 0) + 24 | 0;
 i1 = f17 != Math_fround(HEAPF32[i9 >> 2]) | (i22 | (i21 | i20));
 HEAP32[i19 >> 2] = i2;
 HEAP32[i18 >> 2] = i3;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i9 >> 2] = i8;
 if (!(i6 | i1)) {
  i22 = 0;
  return i22 | 0;
 }
 i5 = (i1 ? HEAP32[i10 + 44 >> 2] | 0 : 0) | HEAP32[i10 + 40 >> 2];
 i6 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 if (!i6) {
  i22 = 1;
  return i22 | 0;
 }
 i7 = HEAP32[i10 + 60 >> 2] | 0;
 i8 = HEAP32[i10 + 56 >> 2] | 0;
 i9 = i10 + 36 | 0;
 i3 = HEAP32[i10 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i11;
 while (1) {
  i22 = HEAP32[i7 + (i1 << 2) >> 2] & i5;
  i21 = i8 + (i1 << 2) | 0;
  HEAP32[i21 >> 2] = HEAP32[i21 >> 2] | i22;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i22;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 return i1 | 0;
}

function __ZN19SpriteMeshGenerator4pathC2ERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i9 >> 2] = 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = i8 + 4 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
 i2 = i1 >> 5;
 if (i2 | 0) {
  if (i2 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = __Znwj(i1) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i1 + (i2 << 5);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i7 = i1 + 16 | 0;
   i6 = i2 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i2 = i2 + 32 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
 }
 i2 = i9 + 12 | 0;
 i3 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i9 + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 i2 = i9 + 44 | 0;
 i3 = i8 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i9 + 48 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 0;
 i5 = i8 + 48 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 >> 5;
 if (i4 | 0) {
  if (i4 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i1 = __Znwj(i1) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 + 52 >> 2] = i1 + (i4 << 5);
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i7 = i1 + 16 | 0;
   i5 = i2 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i2 = i2 + 32 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + 32 | 0;
   HEAP32[i6 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
 }
 i3 = i9 + 56 | 0;
 i4 = i8 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 60 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 i5 = i8 + 60 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 if (!i2) return;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
 i6 = __Znwj(i1) | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i9 + 64 >> 2] = i6 + (i2 << 2);
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) return;
 _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6 + (i1 >> 2 << 2);
 return;
}

function __Z22EdgeEdgeContactSpecialRKN5physx6PxVec3ERKNS_7PxPlaneES2_S2_S2_S2_S2_RfRS0_jjf(i19, i3, i23, i24, i20, i2, i7, i21, i22, i17, i18, f16) {
 i19 = i19 | 0;
 i3 = i3 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 f16 = Math_fround(f16);
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f14 * f11);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f15 * f13));
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f12 * f9));
 f6 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f10 = Math_fround(f6 + f10);
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f8 = Math_fround(f11 * f1);
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f13 * f4));
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 if (Math_fround(f10 * Math_fround(f6 + Math_fround(f8 + Math_fround(f9 * f5)))) > Math_fround(0.0)) {
  i24 = 0;
  return i24 | 0;
 }
 f8 = Math_fround(f1 - f14);
 f6 = Math_fround(f4 - f15);
 f4 = Math_fround(f5 - f12);
 f1 = Math_fround(Math_fround(Math_fround(f8 * f11) + Math_fround(f6 * f13)) + Math_fround(f4 * f9));
 if (f1 == Math_fround(0.0)) {
  i24 = 0;
  return i24 | 0;
 }
 f13 = Math_fround(f10 / f1);
 f1 = Math_fround(f15 - Math_fround(f6 * f13));
 f15 = Math_fround(f12 - Math_fround(f4 * f13));
 HEAPF32[i22 >> 2] = Math_fround(f14 - Math_fround(f8 * f13));
 i2 = i22 + 4 | 0;
 HEAPF32[i2 >> 2] = f1;
 i3 = i22 + 8 | 0;
 HEAPF32[i3 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i19 + (i17 << 2) >> 2]);
 f14 = Math_fround(HEAPF32[i22 + (i18 << 2) >> 2]);
 f14 = Math_fround(f15 * Math_fround(f14 - Math_fround(HEAPF32[i23 + (i18 << 2) >> 2])));
 f15 = Math_fround(HEAPF32[i19 + (i18 << 2) >> 2]);
 f1 = Math_fround(HEAPF32[i22 + (i17 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f14 - Math_fround(f15 * Math_fround(f1 - Math_fround(HEAPF32[i23 + (i17 << 2) >> 2])))) * f16);
 HEAPF32[i21 >> 2] = f1;
 if (f1 < Math_fround(0.0)) {
  i24 = 0;
  return i24 | 0;
 }
 f13 = Math_fround(HEAPF32[i20 >> 2]);
 f14 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f13 = Math_fround(f1 * f13);
 f14 = Math_fround(f1 * f14);
 f16 = Math_fround(f1 * Math_fround(HEAPF32[i20 + 8 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f13);
 HEAPF32[i22 >> 2] = f13;
 f14 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f14);
 HEAPF32[i2 >> 2] = f14;
 f16 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f16);
 HEAPF32[i3 >> 2] = f16;
 f15 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f13);
 f13 = Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f13));
 f15 = Math_fround(Math_fround(HEAPF32[i23 + 4 >> 2]) - f14);
 f14 = Math_fround(f13 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) - f14)));
 f15 = Math_fround(Math_fround(HEAPF32[i23 + 8 >> 2]) - f16);
 i24 = Math_fround(f14 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 + 8 >> 2]) - f16))) < Math_fround(0.0);
 return i24 | 0;
}

function __ZN5physx9NpPhysics14createInstanceEjRNS_12PxFoundationERKNS_17PxTolerancesScaleEbPNS_20PxProfileZoneManagerE(i4, i2, i7, i8, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 24 | 0;
 i6 = i9 + 8 | 0;
 if ((i4 | 0) != 50529024) {
  HEAP32[i3 >> 2] = 50529024;
  HEAP32[i3 + 4 >> 2] = i4;
  __ZN5physx6string9sprintf_sEPcjPKcz(i1, 256, gb + 768514 | 0, i3) | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0) | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, 4, i1 | 0, gb + 689263 | 0, 218);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0)) if (Math_fround(HEAPF32[i7 + 4 >> 2]) > Math_fround(0.0)) {
  i1 = HEAP32[gb + 1457336 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd10Foundation11incRefCountEv();
   HEAP32[gb + 1097392 >> 2] = -64;
   HEAP32[gb + 1097392 + 4 >> 2] = -64;
   HEAP32[gb + 1097392 + 8 >> 2] = -64;
   HEAP32[gb + 1097392 + 16 >> 2] = -24;
   HEAP32[gb + 1097392 + 20 >> 2] = -28;
   HEAP32[gb + 1097392 + 12 >> 2] = -48;
   HEAP32[gb + 1097392 + 24 >> 2] = -32;
   HEAP32[gb + 1097392 + 28 >> 2] = -32;
   HEAP32[gb + 1097392 + 32 >> 2] = -32;
   i1 = gb + 1457208 | 0;
   i2 = i1 + 68 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[gb + 1457208 + 24 >> 2] = 48;
   HEAP32[gb + 1457208 + 20 >> 2] = 48;
   HEAP32[gb + 1457208 + 44 >> 2] = 20;
   HEAP32[gb + 1457208 + 48 >> 2] = 20;
   HEAP32[gb + 1457208 + 60 >> 2] = 48;
   HEAP32[gb + 1457208 + 40 >> 2] = 20;
   i1 = gb + 1457208 + 68 | 0;
   i2 = i1 + 44 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   HEAP32[gb + 1457208 + 88 >> 2] = 16;
   HEAP32[gb + 1457208 + 80 >> 2] = 16;
   HEAP32[gb + 1457208 + 84 >> 2] = 16;
   HEAP32[gb + 1457208 + 96 >> 2] = 12;
   HEAP32[gb + 1457208 + 112 >> 2] = 12;
   HEAP32[i6 >> 2] = -80;
   HEAP32[i6 + 4 >> 2] = -80;
   HEAP32[i6 + 8 >> 2] = -80;
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i1 = _PxGetFoundation() | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, 128, (i1 ? gb + 768593 | 0 : gb + 837976 | 0) | 0, gb + 689263 | 0, 239) | 0;
   __ZN5physx9NpPhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableEbPNS_20PxProfileZoneManagerE(i1, i7, i6, i8, i5);
   HEAP32[gb + 1457324 >> 2] = i1;
   __ZN5physx9NpFactory14createInstanceEv();
   __ZN5physx13GuMeshFactory18addFactoryListenerERNS_21GuMeshFactoryListenerE(HEAP32[gb + 1457204 >> 2] | 0, (HEAP32[gb + 1457324 >> 2] | 0) + 108 | 0);
   i1 = HEAP32[gb + 1457336 >> 2] | 0;
  }
  HEAP32[gb + 1457336 >> 2] = i1 + 1;
  i8 = HEAP32[gb + 1457324 >> 2] | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0) | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, 4, gb + 768577 | 0, gb + 689263 | 0, 224);
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i6 = i12 + 20 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i7 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 28 >> 2])) >>> 0;
 i2 = i1 << 2;
 i10 = (i7 << 2) + i2 | 0;
 i10 = (0 - i10 & 12) + i10 | 0;
 i8 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i8 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i10 + (i7 << 5) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i9 = i8 + i2 | 0;
 i10 = i8 + i10 | 0;
 _memset(i8 | 0, -1, i2 | 0) | 0;
 i2 = i12 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i12 + 8 | 0;
  i4 = i1 + -1 | 0;
  i5 = 0;
  do {
   i15 = HEAP32[i3 >> 2] | 0;
   i16 = i15 + (i5 << 5) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i14 = _i64Add(i17 | 0, i16 | 0, -1, ~i17 | 0) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i14 | 0, i18 | 0, 22) | 0;
   i14 = i19 ^ i14;
   i18 = (getTempRet0() | 0) ^ i18;
   i19 = _bitshift64Shl(i14 | 0, i18 | 0, 13) | 0;
   i19 = _i64Add(i14 | 0, i18 | 0, ~i19 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i18 = getTempRet0() | 0;
   i14 = _bitshift64Lshr(i19 | 0, i18 | 0, 8) | 0;
   i18 = ___muldi3(i14 ^ i19 | 0, (getTempRet0() | 0) ^ i18 | 0, 9, 0) | 0;
   i19 = getTempRet0() | 0;
   i14 = _bitshift64Lshr(i18 | 0, i19 | 0, 15) | 0;
   i18 = i14 ^ i18;
   i19 = (getTempRet0() | 0) ^ i19;
   i14 = _bitshift64Shl(i18 | 0, i19 | 0, 27) | 0;
   i14 = _i64Add(i18 | 0, i19 | 0, ~i14 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i19 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i14 | 0, i19 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i19;
   i14 = i8 + (((i18 ^ i14) & i4) << 2) | 0;
   HEAP32[i9 + (i5 << 2) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i5;
   i14 = i10 + (i5 << 5) | 0;
   HEAP32[i14 >> 2] = i17;
   HEAP32[i14 + 4 >> 2] = i16;
   i14 = i10 + (i5 << 5) + 8 | 0;
   i15 = i15 + (i5 << 5) + 8 | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   HEAP32[i14 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
   HEAP32[i14 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i19 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i8;
 HEAP32[i12 + 16 >> 2] = i8;
 HEAP32[i12 + 24 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i7;
 i1 = i12 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN14dtPathCorridor22optimizePathVisibilityEPKffPK14dtNavMeshQueryPK13dtQueryFilter(i15, i1, f14, i4, i5) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 f14 = Math_fround(f14);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, i25 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i20 + 292 | 0;
 i19 = i20 + 32 | 0;
 i7 = i20 + 288 | 0;
 i8 = i20;
 i17 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = i17;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 i18 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = i18;
 f10 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f10 = Math_fround(f10 - f9);
 f12 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f12 = Math_fround(f12 - f11);
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f12 * f12))));
 if (f13 < Math_fround(.00999999977)) {
  STACKTOP = i20;
  return;
 }
 f23 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f22 = Math_fround(f13 + Math_fround(.00999999977));
 f21 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f13 = Math_fround(f23 - f21);
 f14 = Math_fround(f14 / (f22 < f14 ? f22 : f14));
 HEAPF32[i6 >> 2] = Math_fround(f9 + Math_fround(f10 * f14));
 HEAPF32[i3 >> 2] = Math_fround(f21 + Math_fround(f14 * f13));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f12 * f14) + f11);
 HEAP32[i7 >> 2] = 0;
 i1 = i15 + 28 | 0;
 i16 = HEAP32[i1 >> 2] | 0;
 __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i4, HEAP32[i16 >> 2] | 0, HEAP32[i16 + 4 >> 2] | 0, i15, i6, i5, i8, i19, i7, 32) | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 if ((i16 | 0) > 1) if (Math_fround(HEAPF32[i8 >> 2]) > Math_fround(.990000009)) {
  i17 = HEAP32[i1 >> 2] | 0;
  i18 = i15 + 32 | 0;
  i1 = HEAP32[i18 >> 2] | 0;
  i15 = HEAP32[i15 + 36 >> 2] | 0;
  i4 = -1;
  i6 = i1;
  i3 = -1;
  do {
   if ((i6 | 0) <= 0) break;
   i6 = i6 + -1 | 0;
   i8 = i17 + (i6 << 3) | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = i16;
   i5 = 0;
   do {
    i24 = i2;
    i2 = i2 + -1 | 0;
    i25 = i19 + (i2 << 3) | 0;
    i25 = (i7 | 0) == (HEAP32[i25 >> 2] | 0) ? (i8 | 0) == (HEAP32[i25 + 4 >> 2] | 0) : 0;
    i3 = i25 ? i2 : i3;
    i5 = i5 | i25;
    i4 = i25 ? i6 : i4;
   } while ((i24 | 0) > 1);
  } while (!i5);
  if (!((i3 | 0) < 1 | (i4 | 0) == -1)) {
   i2 = i1 - i4 | 0;
   i2 = (i2 | 0) < 0 ? 0 : i2;
   i2 = (i2 + i3 | 0) > (i15 | 0) ? i15 - i3 | 0 : i2;
   if (i2 | 0) _memmove(i17 + (i3 << 3) | 0, i17 + (i4 << 3) | 0, i2 << 3 | 0) | 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     i16 = i19 + (i1 << 3) | 0;
     i24 = HEAP32[i16 + 4 >> 2] | 0;
     i25 = i17 + (i1 << 3) | 0;
     HEAP32[i25 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i25 + 4 >> 2] = i24;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i1 = i2 + i3 | 0;
  }
  HEAP32[i18 >> 2] = i1;
 }
 STACKTOP = i20;
 return;
}

function __ZN14HeightMeshDataaSERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i9 | 0) == (i8 | 0)) {
  i7 = i8 + 60 | 0;
  i9 = i9 + 60 | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  return i8 | 0;
 }
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i8 + 12 | 0;
 i1 = (HEAP32[i9 + 12 >> 2] | 0) * 12 | 0;
 i2 = (i1 | 0) / 12 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  break;
 } else i1 = HEAP32[i8 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
 i2 = i8 + 20 | 0;
 i6 = HEAP32[i9 + 20 >> 2] | 0;
 i7 = i8 + 32 | 0;
 i1 = HEAP32[i9 + 32 >> 2] << 2;
 i3 = i1 >> 2;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 i2 = i8 + 40 | 0;
 i6 = HEAP32[i9 + 40 >> 2] | 0;
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i9 + 52 >> 2] << 5;
 i3 = i1 >> 5;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
 i7 = i8 + 60 | 0;
 i9 = i9 + 60 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 return i8 | 0;
}

function __ZN13ShadowJobDataC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 _memcpy(i1 | 0, i2 | 0, 516) | 0;
 HEAP32[i1 + 516 >> 2] = HEAP32[i2 + 516 >> 2];
 HEAP32[i1 + 520 >> 2] = HEAP32[i2 + 520 >> 2];
 HEAP32[i1 + 524 >> 2] = HEAP32[i2 + 524 >> 2];
 HEAP32[i1 + 528 >> 2] = HEAP32[i2 + 528 >> 2];
 HEAP32[i1 + 532 >> 2] = HEAP32[i2 + 532 >> 2];
 HEAP32[i1 + 536 >> 2] = HEAP32[i2 + 536 >> 2];
 i3 = i1 + 540 | 0;
 i4 = i2 + 540 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i1 + 564 >> 2] = HEAP32[i2 + 564 >> 2];
 HEAP32[i1 + 568 >> 2] = HEAP32[i2 + 568 >> 2];
 HEAP32[i1 + 572 >> 2] = HEAP32[i2 + 572 >> 2];
 HEAP32[i1 + 576 >> 2] = HEAP32[i2 + 576 >> 2];
 HEAP32[i1 + 580 >> 2] = HEAP32[i2 + 580 >> 2];
 HEAP32[i1 + 584 >> 2] = HEAP32[i2 + 584 >> 2];
 HEAP32[i1 + 588 >> 2] = HEAP32[i2 + 588 >> 2];
 HEAP32[i1 + 592 >> 2] = HEAP32[i2 + 592 >> 2];
 HEAP32[i1 + 596 >> 2] = HEAP32[i2 + 596 >> 2];
 HEAP32[i1 + 600 >> 2] = HEAP32[i2 + 600 >> 2];
 HEAP32[i1 + 604 >> 2] = HEAP32[i2 + 604 >> 2];
 HEAP32[i1 + 608 >> 2] = HEAP32[i2 + 608 >> 2];
 HEAP32[i1 + 612 >> 2] = HEAP32[i2 + 612 >> 2];
 HEAP32[i1 + 616 >> 2] = HEAP32[i2 + 616 >> 2];
 HEAP32[i1 + 620 >> 2] = HEAP32[i2 + 620 >> 2];
 HEAP32[i1 + 624 >> 2] = HEAP32[i2 + 624 >> 2];
 HEAP32[i1 + 628 >> 2] = HEAP32[i2 + 628 >> 2];
 HEAP32[i1 + 632 >> 2] = HEAP32[i2 + 632 >> 2];
 HEAP32[i1 + 636 >> 2] = HEAP32[i2 + 636 >> 2];
 HEAP32[i1 + 640 >> 2] = HEAP32[i2 + 640 >> 2];
 HEAP32[i1 + 644 >> 2] = HEAP32[i2 + 644 >> 2];
 HEAP32[i1 + 648 >> 2] = HEAP32[i2 + 648 >> 2];
 HEAP32[i1 + 652 >> 2] = HEAP32[i2 + 652 >> 2];
 HEAP32[i1 + 656 >> 2] = HEAP32[i2 + 656 >> 2];
 HEAP32[i1 + 660 >> 2] = HEAP32[i2 + 660 >> 2];
 HEAP32[i1 + 664 >> 2] = HEAP32[i2 + 664 >> 2];
 HEAP32[i1 + 668 >> 2] = HEAP32[i2 + 668 >> 2];
 HEAP32[i1 + 672 >> 2] = HEAP32[i2 + 672 >> 2];
 HEAP32[i1 + 676 >> 2] = HEAP32[i2 + 676 >> 2];
 HEAP32[i1 + 680 >> 2] = HEAP32[i2 + 680 >> 2];
 HEAP32[i1 + 684 >> 2] = HEAP32[i2 + 684 >> 2];
 HEAP32[i1 + 688 >> 2] = HEAP32[i2 + 688 >> 2];
 HEAP32[i1 + 692 >> 2] = HEAP32[i2 + 692 >> 2];
 HEAP32[i1 + 696 >> 2] = HEAP32[i2 + 696 >> 2];
 HEAP32[i1 + 700 >> 2] = HEAP32[i2 + 700 >> 2];
 HEAP32[i1 + 704 >> 2] = HEAP32[i2 + 704 >> 2];
 HEAP32[i1 + 708 >> 2] = HEAP32[i2 + 708 >> 2];
 HEAP32[i1 + 712 >> 2] = HEAP32[i2 + 712 >> 2];
 HEAP32[i1 + 716 >> 2] = HEAP32[i2 + 716 >> 2];
 HEAP32[i1 + 720 >> 2] = HEAP32[i2 + 720 >> 2];
 HEAP32[i1 + 724 >> 2] = HEAP32[i2 + 724 >> 2];
 HEAP32[i1 + 728 >> 2] = HEAP32[i2 + 728 >> 2];
 HEAP32[i1 + 732 >> 2] = HEAP32[i2 + 732 >> 2];
 HEAP32[i1 + 736 >> 2] = HEAP32[i2 + 736 >> 2];
 HEAP32[i1 + 740 >> 2] = HEAP32[i2 + 740 >> 2];
 HEAP32[i1 + 744 >> 2] = HEAP32[i2 + 744 >> 2];
 HEAP32[i1 + 748 >> 2] = HEAP32[i2 + 748 >> 2];
 HEAP32[i1 + 752 >> 2] = HEAP32[i2 + 752 >> 2];
 HEAP32[i1 + 756 >> 2] = HEAP32[i2 + 756 >> 2];
 HEAP32[i1 + 760 >> 2] = HEAP32[i2 + 760 >> 2];
 HEAP32[i1 + 764 >> 2] = HEAP32[i2 + 764 >> 2];
 _memcpy(i1 + 768 | 0, i2 + 768 | 0, 184) | 0;
 return;
}

function _zipWriteInFileInZip(i20, i1, i2) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 if (!i20) {
  i23 = -102;
  return i23 | 0;
 }
 if (!(HEAP32[i20 + 44 >> 2] | 0)) {
  i23 = -102;
  return i23 | 0;
 }
 i21 = i20 + 48 | 0;
 HEAP32[i21 >> 2] = i1;
 i22 = i20 + 52 | 0;
 HEAP32[i22 >> 2] = i2;
 i6 = i20 + 16524 | 0;
 HEAP32[i6 >> 2] = _unity_z_crc32(HEAP32[i6 >> 2] | 0, i1, i2) | 0;
 i6 = i20 + 64 | 0;
 i7 = i20 + 16528 | 0;
 i5 = i20 + 108 | 0;
 i8 = i20 + 8 | 0;
 i9 = i20 + 28 | 0;
 i10 = i20 + 32 | 0;
 i11 = i20 + 136 | 0;
 i12 = i20 + 60 | 0;
 i13 = i20 + 16532 | 0;
 i14 = i20 + 16544 | 0;
 i4 = i20 + 16540 | 0;
 i15 = i20 + 16536 | 0;
 i16 = i20 + 128 | 0;
 i17 = i20 + 132 | 0;
 i18 = i20 + 68 | 0;
 i19 = i20 + 56 | 0;
 if (!(HEAP32[i22 >> 2] | 0)) {
  i23 = 0;
  return i23 | 0;
 }
 while (1) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i5 >> 2] | 0;
   if (HEAP32[i7 >> 2] | 0) if (!i1) i1 = 0; else {
    i2 = 0;
    do {
     i24 = HEAP32[i4 >> 2] | 0;
     i3 = i24 & 65533;
     i3 = (Math_imul(i3 | 2, i3 ^ 3) | 0) >>> 8;
     i26 = HEAP32[i14 >> 2] | 0;
     i1 = i20 + 136 + i2 | 0;
     i25 = HEAP32[i13 >> 2] | 0;
     i25 = HEAP32[i26 + ((i25 & 255 ^ (HEAPU8[i1 >> 0] | 0)) << 2) >> 2] ^ i25 >>> 8;
     HEAP32[i13 >> 2] = i25;
     i25 = (Math_imul((HEAP32[i15 >> 2] | 0) + (i25 & 255) | 0, 134775813) | 0) + 1 | 0;
     HEAP32[i15 >> 2] = i25;
     HEAP32[i4 >> 2] = HEAP32[i26 + ((i25 >>> 24 ^ i24 & 255) << 2) >> 2] ^ i24 >>> 8;
     HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) ^ i3;
     i2 = i2 + 1 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
    } while (i2 >>> 0 < i1 >>> 0);
   }
   i26 = mftCall_iiiii(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, i11 | 0, i1 | 0) | 0;
   i26 = (i26 | 0) == (HEAP32[i5 >> 2] | 0);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = 16384;
   HEAP32[i12 >> 2] = i11;
   if (i26) i1 = 16384; else {
    i1 = -1;
    i23 = 17;
    break;
   }
  }
  if ((HEAP32[i16 >> 2] | 0) == 8) if (!(HEAP32[i17 >> 2] | 0)) {
   i26 = HEAP32[i18 >> 2] | 0;
   i1 = _unity_z_deflate(i21, 0) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i18 >> 2] | 0) - i26 + (HEAP32[i5 >> 2] | 0);
   if (i1 | 0) {
    i23 = 17;
    break;
   }
  } else i23 = 11; else i23 = 11;
  if ((i23 | 0) == 11) {
   i23 = 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i3 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
   if (i3) {
    i1 = 0;
    do {
     HEAP8[(HEAP32[i12 >> 2] | 0) + i1 >> 0] = HEAP8[(HEAP32[i21 >> 2] | 0) + i1 >> 0] | 0;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i3 >>> 0);
    i2 = HEAP32[i22 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i22 >> 2] = i2 - i3;
   HEAP32[i6 >> 2] = i1 - i3;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + i3;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i3;
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + i3;
   HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
  }
  if (!(HEAP32[i22 >> 2] | 0)) {
   i1 = 0;
   i23 = 17;
   break;
  }
 }
 if ((i23 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = HEAP32[i11 + 28 >> 2] | 0;
 L1 : do if (!i1) i3 = -2147483648; else {
  i2 = HEAP32[i11 + 24 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i4 | 0)) break L1;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) {
    i3 = -2147483648;
    break;
   }
  }
 } while (0);
 __ZN5physx2Sc7BodySim15setArticulationEPNS0_15ArticulationSimEfb(i4, 0, Math_fround(0.0), 1);
 i9 = i11 + 12 | 0;
 i2 = i3 + 1 | 0;
 i10 = i11 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  i6 = i11 + 24 | 0;
  i7 = i11 + 36 | 0;
  i1 = i3;
  i5 = i2;
  while (1) {
   i2 = HEAP32[i9 >> 2] | 0;
   i4 = i2 + (i1 << 5) | 0;
   i2 = i2 + (i5 << 5) | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i4 = HEAP32[i6 >> 2] | 0;
   HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
   i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | i1;
   i2 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0) + 1204 >> 2] | 0) | 0;
   i4 = i4 + 188 | 0;
   if (!(i1 & 63)) __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1, i11, i4); else __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1, i11, i4);
   i2 = i5 + 1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   if (i2 >>> 0 < i1 >>> 0) {
    i1 = i5;
    i5 = i2;
   } else break;
  }
 }
 i7 = _bitshift64Shl(1, 0, i3 | 0) | 0;
 i8 = getTempRet0() | 0;
 i5 = _i64Add(i7 | 0, i8 | 0, -1, -1) | 0;
 i6 = getTempRet0() | 0;
 i7 = ~(i5 | i7);
 i8 = ~(i6 | i8);
 if (!i1) {
  i9 = 0;
  i9 = i9 + -1 | 0;
  HEAP32[i10 >> 2] = i9;
  i11 = i11 + 160 | 0;
  HEAP8[i11 >> 0] = 1;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = 0;
 do {
  i9 = HEAP32[i2 + (i4 << 5) + 28 >> 2] | 0;
  if ((i9 | 0) != -1 & i9 >>> 0 > i3 >>> 0) {
   i9 = i2 + (i4 << 5) + 8 | 0;
   i12 = i9;
   i13 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i14 = _bitshift64Lshr(i13 & i7 | 0, i12 & i8 | 0, 1) | 0;
   i12 = getTempRet0() | 0 | i12 & i6;
   HEAP32[i9 >> 2] = i14 | i13 & i5;
   HEAP32[i9 + 4 >> 2] = i12;
  }
  i14 = i2 + (i4 << 5) | 0;
  i13 = i14;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i9 = _bitshift64Lshr(i12 & i7 | 0, i13 & i8 | 0, 1) | 0;
  i13 = getTempRet0() | 0 | i13 & i6;
  HEAP32[i14 >> 2] = i9 | i12 & i5;
  HEAP32[i14 + 4 >> 2] = i13;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 i14 = i1 + -1 | 0;
 HEAP32[i10 >> 2] = i14;
 i14 = i11 + 160 | 0;
 HEAP8[i14 >> 0] = 1;
 return;
}

function _jinit_upsampler(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i11 = i10 + 4 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i10 | 0, 1, 160) | 0;
 HEAP32[i10 + 416 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 3275;
 HEAP32[i1 + 4 >> 2] = fb + 22;
 i22 = i1 + 8 | 0;
 HEAP8[i22 >> 0] = 0;
 if (HEAP8[i10 + 266 >> 0] | 0) {
  i21 = HEAP32[i10 >> 2] | 0;
  HEAP32[i21 + 20 >> 2] = 25;
  mftCall_vi(HEAP32[i21 >> 2] | 0, i10 | 0);
 }
 if (!(HEAP8[i10 + 72 >> 0] | 0)) i12 = 0; else i12 = (HEAP32[i10 + 280 >> 2] | 0) > 1;
 i13 = i10 + 36 | 0;
 if ((HEAP32[i13 >> 2] | 0) <= 0) return;
 i14 = i10 + 280 | 0;
 i15 = i10 + 272 | 0;
 i16 = i10 + 276 | 0;
 i17 = i1 + 100 | 0;
 i18 = i1 + 52 | 0;
 i19 = i10 + 92 | 0;
 i20 = i1 + 12 | 0;
 i21 = i1 + 140 | 0;
 i9 = i1 + 150 | 0;
 i7 = 0;
 i8 = HEAP32[i10 + 196 >> 2] | 0;
 while (1) {
  i3 = HEAP32[i8 + 36 >> 2] | 0;
  i1 = Math_imul(i3, HEAP32[i8 + 8 >> 2] | 0) | 0;
  i2 = HEAP32[i14 >> 2] | 0;
  i1 = (i1 | 0) / (i2 | 0) | 0;
  i2 = (Math_imul(HEAP32[i8 + 12 >> 2] | 0, i3) | 0) / (i2 | 0) | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i16 >> 2] | 0;
  HEAP32[i17 + (i7 << 2) >> 2] = i2;
  do if (!(HEAP8[i8 + 48 >> 0] | 0)) HEAP32[i18 + (i7 << 2) >> 2] = fb + 197; else {
   i5 = (i2 | 0) == (i4 | 0);
   if ((i1 | 0) == (i3 | 0) & i5) {
    HEAP32[i18 + (i7 << 2) >> 2] = fb + 198;
    break;
   }
   i6 = (i1 << 1 | 0) == (i3 | 0);
   do if (i6 & i5) {
    if (i12) if ((HEAP32[i8 + 40 >> 2] | 0) >>> 0 > 2) {
     i1 = i18 + (i7 << 2) | 0;
     if (!(_jsimd_can_h2v1_fancy_upsample() | 0)) {
      HEAP32[i1 >> 2] = fb + 200;
      break;
     } else {
      HEAP32[i1 >> 2] = fb + 199;
      break;
     }
    }
    i1 = i18 + (i7 << 2) | 0;
    if (!(_jsimd_can_h2v1_upsample() | 0)) {
     HEAP32[i1 >> 2] = fb + 202;
     break;
    } else {
     HEAP32[i1 >> 2] = fb + 201;
     break;
    }
   } else {
    if (!(i6 & (i2 << 1 | 0) == (i4 | 0))) {
     if (!((i3 | 0) % (i1 | 0) | 0)) if (!((i4 | 0) % (i2 | 0) | 0)) {
      HEAP32[i18 + (i7 << 2) >> 2] = fb + 207;
      HEAP8[i21 + i7 >> 0] = (i3 | 0) / (i1 | 0) | 0;
      HEAP8[i9 + i7 >> 0] = (i4 | 0) / (i2 | 0) | 0;
      break;
     }
     i6 = HEAP32[i10 >> 2] | 0;
     HEAP32[i6 + 20 >> 2] = 38;
     mftCall_vi(HEAP32[i6 >> 2] | 0, i10 | 0);
     break;
    }
    if (i12) if ((HEAP32[i8 + 40 >> 2] | 0) >>> 0 > 2) {
     i6 = (_jsimd_can_h2v2_fancy_upsample() | 0) == 0;
     HEAP32[i18 + (i7 << 2) >> 2] = i6 ? fb + 203 | 0 : fb + 204 | 0;
     HEAP8[i22 >> 0] = 1;
     break;
    }
    i1 = i18 + (i7 << 2) | 0;
    if (!(_jsimd_can_h2v2_upsample() | 0)) {
     HEAP32[i1 >> 2] = fb + 206;
     break;
    } else {
     HEAP32[i1 >> 2] = fb + 205;
     break;
    }
   } while (0);
   i5 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _jround_up(HEAP32[i19 >> 2] | 0, HEAP32[i15 >> 2] | 0) | 0;
   HEAP32[i20 + (i7 << 2) >> 2] = mftCall_iiiii(i5 | 0, i10 | 0, 1, i6 | 0, HEAP32[i16 >> 2] | 0) | 0;
  } while (0);
  i7 = i7 + 1 | 0;
  if ((i7 | 0) >= (HEAP32[i13 >> 2] | 0)) break; else i8 = i8 + 84 | 0;
 }
 return;
}

function __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj0ES2_NS_19GenericStringStreamIS2_EEEERS4_RT1_(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i10 + 20 >> 2];
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 256;
 i4 = i8 + 24 | 0;
 i5 = i8 + 28 | 0;
 i6 = i8 + 24 | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 L1 : while (1) {
  i2 = i1;
  switch (HEAP8[i2 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L1;
  }
  i1 = i2 + 1 | 0;
 }
 i7 = i10 + 52 | 0;
 HEAP32[i3 >> 2] = i1;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i3 = i1 - (HEAP32[i3 + 4 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i5 >> 2] = i3;
 } else {
  __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i8, i3, i10);
  if (!(HEAP32[i4 >> 2] | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   L9 : while (1) {
    i2 = i1;
    switch (HEAP8[i2 >> 0] | 0) {
    case 9:
    case 13:
    case 10:
    case 32:
     break;
    default:
     break L9;
    }
    i1 = i2 + 1 | 0;
   }
   HEAP32[i3 >> 2] = i1;
   if (HEAP8[i2 >> 0] | 0) {
    i3 = i1 - (HEAP32[i3 + 4 >> 2] | 0) | 0;
    HEAP32[i4 >> 2] = 2;
    HEAP32[i5 >> 2] = i3;
   }
  }
 }
 i3 = i6;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i8 + 8 | 0;
 HEAP32[i8 + 12 >> 2] = HEAP32[i6 >> 2];
 i4 = i7;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = i10 + 40 | 0;
 if (!i5) {
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i3 + -24 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i3 = i3 + -8 | 0;
  HEAP32[i10 + 16 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = 0;
  i3 = i4;
 } else {
  i3 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i5 = i10 + 36 | 0;
 i1 = i2;
 if ((i2 | 0) != (HEAP32[i5 >> 2] | 0)) do {
  i2 = i1 + -24 | 0;
  HEAP32[i4 >> 2] = i2;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = i2;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 if ((i1 | 0) == (i2 | 0)) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
  i1 = 0;
 } else i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 + 44 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, gb + 64016 | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12resize_deltaEjj(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i6 + 104 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i3 = (HEAP32[i6 + 92 >> 2] | 0) - (HEAP32[i6 + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 < (HEAP32[i6 + 96 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i6 + 88 >> 2] | 0;
   if (i1 >>> 0 > 32) {
    f2 = Math_fround(i3 >>> 0);
    do {
     i3 = i1;
     i1 = i1 >>> 1;
     if (i3 >>> 0 < 66) break;
    } while (f2 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
    __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j(i8, i6, i1);
    __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_(i6, i8);
    __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev(i8);
   }
  }
  HEAP8[i4 >> 0] = 0;
 }
 i4 = HEAP32[i6 + 88 >> 2] | 0;
 i1 = HEAP32[i6 + 92 >> 2] | 0;
 if (i4 >>> 0 > i7 >>> 0) if ((i1 + i5 | 0) >>> 0 <= (HEAP32[i6 + 100 >> 2] | 0) >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + i5 | 0;
 f2 = Math_fround(i3 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround((i3 - (HEAP32[i6 + 4 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j(i8, i6, i1);
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_(i6, i8);
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN10SizeModule5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i29 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i29;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAP8[i2 + 800 >> 0] = 0;
 i23 = i3 + 4 | 0;
 i24 = i3 + 8 | 0;
 i25 = i3 + 12 | 0;
 i26 = i3 + 16 | 0;
 i27 = i3 + 20 | 0;
 i28 = i3 + 24 | 0;
 i4 = i3 + 28 | 0;
 i5 = i3 + 32 | 0;
 i6 = i3 + 40 | 0;
 i7 = i3 + 44 | 0;
 i8 = i3 + 48 | 0;
 i9 = i3 + 52 | 0;
 i10 = i3 + 56 | 0;
 i11 = i3 + 60 | 0;
 i12 = i3 + 64 | 0;
 i13 = i3 + 68 | 0;
 i14 = i3 + 72 | 0;
 i15 = i3 + 80 | 0;
 i16 = i3 + 88 | 0;
 i17 = i3 + 232 | 0;
 i18 = i3 + 248 | 0;
 i19 = i3 + 236 | 0;
 i20 = i3 + 144 | 0;
 i21 = i3 + 160 | 0;
 i22 = i3 + 148 | 0;
 i1 = 0;
 do {
  __ZN11MinMaxCurveC2Ev(i3);
  i30 = HEAP32[i23 >> 2] | 0;
  i31 = HEAP32[i24 >> 2] | 0;
  i32 = HEAP32[i25 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 4 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 8 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 12 >> 2] = i32;
  i32 = HEAP32[i27 >> 2] | 0;
  i31 = HEAP32[i28 >> 2] | 0;
  i30 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 16 >> 2] = HEAP32[i26 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 20 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 24 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 28 >> 2] = i30;
  i30 = i5;
  i31 = HEAP32[i30 + 4 >> 2] | 0;
  i32 = i2 + 8 + (i1 * 264 | 0) + 32 | 0;
  HEAP32[i32 >> 2] = HEAP32[i30 >> 2];
  HEAP32[i32 + 4 >> 2] = i31;
  i32 = HEAP32[i7 >> 2] | 0;
  i31 = HEAP32[i8 >> 2] | 0;
  i30 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 40 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 44 >> 2] = i32;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 48 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 52 >> 2] = i30;
  i30 = HEAP32[i11 >> 2] | 0;
  i31 = HEAP32[i12 >> 2] | 0;
  i32 = HEAP32[i13 >> 2] | 0;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 56 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 60 >> 2] = i30;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 64 >> 2] = i31;
  HEAP32[i2 + 8 + (i1 * 264 | 0) + 68 >> 2] = i32;
  i32 = i14;
  i31 = HEAP32[i32 + 4 >> 2] | 0;
  i30 = i2 + 8 + (i1 * 264 | 0) + 72 | 0;
  HEAP32[i30 >> 2] = HEAP32[i32 >> 2];
  HEAP32[i30 + 4 >> 2] = i31;
  i30 = i2 + 8 + (i1 * 264 | 0) + 80 | 0;
  HEAP32[i30 >> 2] = HEAP32[i15 >> 2];
  HEAP16[i30 + 4 >> 1] = HEAP16[i15 + 4 >> 1] | 0;
  HEAP8[i30 + 6 >> 0] = HEAP8[i15 + 6 >> 0] | 0;
  __ZN21MinMaxAnimationCurvesaSERKS_(i2 + 8 + (i1 * 264 | 0) + 88 | 0, i16) | 0;
  if ((HEAP32[i18 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i19);
   HEAP32[i17 >> 2] = 0;
  }
  if ((HEAP32[i21 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i20 >> 2] | 0, i22);
   HEAP32[i20 >> 2] = 0;
  }
  HEAP16[i2 + 8 + (i1 * 264 | 0) + 84 >> 1] = 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 STACKTOP = i29;
 return;
}

function __ZN5physx17PxsContactManager4initERKNS_24PxvManagerDescRigidRigidEPKNS_18PxsMaterialManagerE(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i13 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 16 >> 2];
 i4 = HEAP32[i12 + 20 >> 2] | 0;
 HEAP32[i13 + 88 >> 2] = i4;
 i11 = HEAP32[i12 + 24 >> 2] | 0;
 HEAP32[i13 + 92 >> 2] = i11;
 HEAP32[i13 + 80 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i13 + 84 >> 2] = HEAP32[i12 + 32 >> 2];
 HEAP32[i13 + 108 >> 2] = HEAP32[i12 + 48 >> 2];
 HEAP32[i13 + 100 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 104 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP8[i13 + 112 >> 0] = HEAP32[i4 + 36 >> 2];
 HEAP8[i13 + 113 >> 0] = HEAP32[i11 + 36 >> 2];
 HEAP32[i13 + 96 >> 2] = i1;
 HEAP32[i13 + 116 >> 2] = HEAP32[i12 + 76 >> 2];
 HEAP32[i13 + 120 >> 2] = HEAP32[i12 + 80 >> 2];
 i11 = i13 + 114 | 0;
 HEAP16[i11 >> 1] = 0;
 i4 = i13 + 36 | 0;
 i5 = i13 + 40 | 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 32 | 0;
 HEAP16[i7 >> 1] = 0;
 i8 = i13 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i13 + 44 | 0;
 i10 = i13 + 48 | 0;
 HEAP16[i4 >> 1] = 0;
 HEAP32[i13 + 64 >> 2] = 0;
 HEAP16[i13 + 72 >> 1] = 0;
 HEAP32[i13 + 68 >> 2] = 0;
 i1 = i13 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) i1 = 0; else if (!(i2 & 1)) {
  i1 = i2;
  HEAP8[i1 + 33 >> 0] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP32[i1 + 16 >> 2] = 2139095039;
  HEAP32[i1 + 20 >> 2] = 2139095039;
  HEAP32[i1 + 24 >> 2] = 2139095039;
  HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 1065353216;
  i1 = HEAP16[i11 >> 1] | 0;
  break;
 } else {
  HEAP32[i1 >> 2] = 1;
  i1 = 0;
  break;
 } while (0);
 HEAP16[i11 >> 1] = i1 & 65531;
 i2 = HEAP32[i12 + 64 >> 2] | 0;
 i1 = (i2 & 1) << 3 & 65535;
 if (i2 & 2) i1 = (i1 & 65535 | 16) & 65535;
 i2 = HEAP32[i12 + 68 >> 2] | 0;
 if (i2 & 1) i1 = (i1 & 65535 | 32) & 65535;
 if (i2 & 2) i1 = (i1 & 65535 | 64) & 65535;
 i2 = HEAP32[i12 + 52 >> 2] | 0;
 if (!i2) if (!(HEAP32[i12 + 44 >> 2] | 0)) i1 = (i1 & 65535 | 2) & 65535;
 if (!(HEAP32[i12 + 56 >> 2] | 0)) i1 = (i1 & 65535 | 512) & 65535;
 HEAP8[i13 + 34 >> 0] = (i2 | 0) != 0 & 1;
 HEAP8[i13 + 35 >> 0] = (HEAP32[i12 + 60 >> 2] | 0) != 0 & 1;
 if (!(HEAP32[i12 + 36 >> 2] | 0)) {
  if (HEAP32[i12 + 44 >> 2] | 0) i3 = 18;
 } else i3 = 18;
 if ((i3 | 0) == 18) i1 = (i1 & 65535 | 1) & 65535;
 if (HEAP32[i12 + 40 >> 2] | 0) i1 = (i1 & 65535 | 256) & 65535;
 i2 = HEAP32[i12 + 44 >> 2] | 0;
 if (i2) i1 = (i1 & 65535 | 128) & 65535;
 HEAP16[i13 + 38 >> 1] = i1;
 HEAP32[i13 + 8 >> 2] = (i2 | 0) != 0 & 1;
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 >> 2];
 HEAP16[i11 >> 1] = 0;
 HEAP16[i4 >> 1] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP16[i7 >> 1] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i1 = HEAP32[i12 + 72 >> 2] | 0;
 if ((i1 | 0) > 0) {
  HEAP16[i11 >> 1] = 2;
  return;
 }
 if ((i1 | 0) >= 0) return;
 HEAP16[i11 >> 1] = 1;
 return;
}

function __ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj(i12, i15, i6, i14, i7, i3, i13, i17) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 48 | 0;
 i8 = i18 + 32 | 0;
 i16 = i18 + 64 | 0;
 i10 = i18 + 16 | 0;
 i11 = i18;
 i1 = HEAP8[i14 + 18 >> 0] | 0;
 i2 = i12 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if (i1 << 24 >> 24 != (HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i5 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i5 + 13 >> 0] | 0)) {
  i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0) | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  if (!((i3 & 8 & HEAP8[((i4 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i4 >>> 24 & 15) << 2) >> 2] | 0) + i5 + 11 | 0 : (HEAP32[i5 + 8 >> 2] | 0) + 3 | 0) >> 0]) << 24 >> 24)) {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 i5 = (i13 | 0) != 0;
 if (!i5) {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i14 + 4 >> 2] | 0;
  i3 = HEAP32[i14 + 8 >> 2] | 0;
  i4 = HEAP32[i14 + 12 >> 2] | 0;
  if (i2 | i1 | i3 | i4 | 0) {
   i19 = HEAP32[i12 + 8 >> 2] | 0;
   if (!(HEAP32[i19 + 20 >> 2] & i2 | HEAP32[i19 + 16 >> 2] & i1 | HEAP32[i19 + 24 >> 2] & i3 | HEAP32[i19 + 28 >> 2] & i4)) {
    i19 = 0;
    STACKTOP = i18;
    return i19 | 0;
   }
  }
 }
 if (!(HEAP16[i6 >> 1] & 4)) {
  i19 = 1;
  STACKTOP = i18;
  return i19 | 0;
 }
 i1 = (i7 | 0) != 0;
 if (!(i1 | i5)) {
  i19 = 1;
  STACKTOP = i18;
  return i19 | 0;
 }
 HEAP16[i16 >> 1] = HEAP16[i17 >> 1] | 0;
 if (i1) HEAP32[i15 >> 2] = mftCall_iiiiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i14 | 0, HEAP32[i12 + 4 >> 2] | 0, HEAP32[i12 >> 2] | 0, i16 | 0) | 0; else {
  i1 = HEAP32[i13 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = (HEAP32[i12 + 8 >> 2] | 0) + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = HEAP32[i13 >> 2] | 0;
   i19 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i15 >> 2] = mftCall_iiiiii(i1 | 0, i8 | 0, i9 | 0, i14 | 0, i19 | 0, i16 | 0) | 0;
  }
 }
 HEAP16[i17 >> 1] = HEAPU16[i16 >> 1] & 432 | HEAP16[i17 >> 1] & -433;
 i19 = 1;
 STACKTOP = i18;
 return i19 | 0;
}

function __ZL17transformVerticesRfS_S_S_PfjPKN5physx6PxVec3EPKhRKNS1_7PxMat33E(i17, i18, i15, i16, i20, i19, i13, i12, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i14 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i14 = (i19 | 0) == 0;
 if (i14) {
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
 } else {
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  i1 = 0;
  f8 = Math_fround(-3402823469999999843913219.0e14);
  f9 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(3402823469999999843913219.0e14);
  do {
   i21 = HEAPU8[i12 + i1 >> 0] | 0;
   f25 = Math_fround(HEAPF32[i13 + (i21 * 12 | 0) >> 2]);
   f23 = Math_fround(f5 * f25);
   f24 = Math_fround(HEAPF32[i13 + (i21 * 12 | 0) + 4 >> 2]);
   f23 = Math_fround(f23 + Math_fround(f6 * f24));
   f22 = Math_fround(HEAPF32[i13 + (i21 * 12 | 0) + 8 >> 2]);
   f23 = Math_fround(f23 + Math_fround(f7 * f22));
   f22 = Math_fround(Math_fround(Math_fround(f25 * f10) + Math_fround(f24 * f11)) + Math_fround(f22 * f4));
   f2 = f2 < f23 ? f2 : f23;
   f3 = f3 < f22 ? f3 : f22;
   f8 = f8 > f23 ? f8 : f23;
   f9 = f9 > f22 ? f9 : f22;
   i21 = i1 << 1;
   HEAPF32[i20 + (i21 << 2) >> 2] = f23;
   HEAPF32[i20 + ((i21 | 1) << 2) >> 2] = f22;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i19 | 0));
 }
 f6 = Math_fround(Math_fround(f8 + f2) * Math_fround(.5));
 f7 = Math_fround(Math_fround(f9 + f3) * Math_fround(.5));
 f5 = Math_fround(f2 + Math_fround(-9.99999997e-07));
 f4 = Math_fround(f3 + Math_fround(-9.99999997e-07));
 f3 = Math_fround(f8 + Math_fround(9.99999997e-07));
 f2 = Math_fround(f9 + Math_fround(9.99999997e-07));
 if (i14) {
  f24 = Math_fround(f3 - f5);
  f25 = Math_fround(f2 - f4);
  HEAPF32[i17 >> 2] = f5;
  HEAPF32[i18 >> 2] = f4;
  HEAPF32[i15 >> 2] = f24;
  HEAPF32[i16 >> 2] = f25;
  return;
 } else i1 = 0;
 do {
  i21 = i1 << 1;
  i14 = i20 + (i21 << 2) | 0;
  f22 = Math_fround(HEAPF32[i14 >> 2]);
  i21 = i20 + ((i21 | 1) << 2) | 0;
  f25 = Math_fround(HEAPF32[i21 >> 2]);
  f24 = Math_fround(f25 - f7);
  f23 = Math_fround(f22 - f5);
  i13 = Math_fround(f22 - f6) >= Math_fround(0.0);
  HEAPF32[i14 >> 2] = Math_fround(f23 + (i13 ? Math_fround(9.99999997e-07) : Math_fround(-9.99999997e-07)));
  f25 = Math_fround(f25 - f4);
  i14 = f24 >= Math_fround(0.0);
  HEAPF32[i21 >> 2] = Math_fround(f25 + (i14 ? Math_fround(9.99999997e-07) : Math_fround(-9.99999997e-07)));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i19 | 0));
 f24 = Math_fround(f3 - f5);
 f25 = Math_fround(f2 - f4);
 HEAPF32[i17 >> 2] = f5;
 HEAPF32[i18 >> 2] = f4;
 HEAPF32[i15 >> 2] = f24;
 HEAPF32[i16 >> 2] = f25;
 return;
}

function __ZN14ParticleSystem19UpdateVelocityStateERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemState(i8, i1, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 64 | 0;
 i6 = i9;
 do if ((HEAP32[i1 + 280 >> 2] | 0) == 1) {
  i3 = i8 + 28 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(54) | 0;
  if (!i1) i4 = 4; else {
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, i1) | 0;
   if (!i1) i4 = 4; else i4 = 7;
  }
  do if ((i4 | 0) == 4) {
   i1 = __Z25FindAncestorComponentImplR10GameObjecti(i2, 54) | 0;
   if (!i1) {
    i2 = HEAP32[i3 >> 2] | 0;
    i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(50) | 0;
    if (!i1) i4 = 8; else {
     i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, i1) | 0;
     if (!i1) i4 = 8;
    }
    if ((i4 | 0) == 8) {
     i1 = __Z25FindAncestorComponentImplR10GameObjecti(i2, 50) | 0;
     if (!i1) {
      i4 = 16;
      break;
     }
    }
    i3 = __Z13GetIPhysics2Dv() | 0;
    if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i1 | 0) | 0) i4 = 16; else {
     HEAP8[i7 + 328 >> 0] = 1;
     i3 = __Z13GetIPhysics2Dv() | 0;
     mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i3 | 0, i1 | 0);
     i3 = HEAP32[i5 + 4 >> 2] | 0;
     HEAP32[i7 + 356 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i7 + 360 >> 2] = i3;
     HEAPF32[i7 + 364 >> 2] = Math_fround(0.0);
    }
   } else i4 = 7;
  } while (0);
  if ((i4 | 0) == 7) {
   i3 = __Z11GetIPhysicsv() | 0;
   if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i1 | 0) | 0) i4 = 16; else {
    HEAP8[i7 + 328 >> 0] = 1;
    i3 = i7 + 356 | 0;
    i2 = __Z11GetIPhysicsv() | 0;
    mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i2 | 0, i1 | 0);
    HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   }
  }
  if ((i4 | 0) == 16) {
   HEAP8[i7 + 328 >> 0] = 0;
   break;
  }
  __ZNK9Transform21GetLocalToWorldMatrixEv(i6, __ZNK10GameObject23QueryComponentTransformEv(HEAP32[i1 + 28 >> 2] | 0) | 0);
  i3 = HEAP32[i6 + 48 >> 2] | 0;
  i4 = HEAP32[i6 + 52 >> 2] | 0;
  i2 = HEAP32[i6 + 56 >> 2] | 0;
  i1 = i7 + 332 | 0;
  if (!(HEAP8[(HEAP32[i8 + 40 >> 2] | 0) + 31 >> 0] | 0)) {
   i6 = i7 + 344 | 0;
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i1 = i6;
  } else {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i7 + 336 >> 2] = i4;
   HEAP32[i7 + 340 >> 2] = i2;
   i1 = i7 + 344 | 0;
  }
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 + 348 >> 2] = i4;
  HEAP32[i7 + 352 >> 2] = i2;
 } else HEAP8[i7 + 328 >> 0] = 0; while (0);
 i1 = HEAP32[i8 + 872 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (HEAP32[i1 + 8 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 if (HEAP8[i1 + 872 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv(i1);
 STACKTOP = i9;
 return;
}

function __ZN12TreeRenderer20CollectTreeRenderersER13dynamic_arrayI9SceneNodeLj4EERS0_I4AABBLj4EE(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = i11 + 168 | 0;
 i10 = i11 + 412 | 0;
 i6 = i1 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) + i3 | 0;
 HEAP32[i6 >> 2] = i7;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i7 * 24 | 0, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  break;
 } while (0);
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = i7;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 do if ((i6 & 2147483647) >>> 0 < i7 >>> 0) if ((i6 | 0) > -1) {
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i7 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i8;
  break;
 } while (0);
 if (HEAP32[i9 >> 2] | 0) {
  i5 = i11 + 156 | 0;
  i6 = i11 + 236 | 0;
  i7 = i11 + 256 | 0;
  i8 = i11 + 276 | 0;
  i4 = 0;
  do {
   i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] << 2) >> 2] | 0;
   i12 = (HEAP32[i1 >> 2] | 0) + (i3 * 24 | 0) | 0;
   i14 = (HEAP32[i7 >> 2] | 0) + (i13 * 24 | 0) | 0;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP8[i12 + 20 >> 0] = HEAP8[i14 + 20 >> 0] | 0;
   i12 = (HEAP32[i2 >> 2] | 0) + (i3 * 24 | 0) | 0;
   i13 = (HEAP32[i8 >> 2] | 0) + (i13 * 24 | 0) | 0;
   HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   HEAP32[i12 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
   HEAP32[i12 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i14 = (HEAP32[i2 >> 2] | 0) + (i3 * 24 | 0) | 0;
 _memcpy((HEAP32[i1 >> 2] | 0) + (i3 * 24 | 0) | 0, HEAP32[i11 + 400 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
 _memcpy(i14 | 0, HEAP32[i11 + 420 >> 2] | 0, (HEAP32[i11 + 432 >> 2] | 0) * 24 | 0) | 0;
 i3 = HEAP32[i11 + 392 >> 2] | 0;
 if (!i3) return;
 i2 = HEAP32[i11 + 380 >> 2] | 0;
 i1 = 0;
 do {
  HEAP16[i2 + (i1 * 88 | 0) >> 1] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6ignoreEii(i9, i5, i6) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i9 | 0, 1);
 i4 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i9;
  i3 = i9;
  i8 = 24;
 } else do if (HEAP8[i1 >> 0] | 0) {
  L6 : do if ((i5 | 0) == 2147483647) {
   while (1) {
    i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) break;
     if ((i1 | 0) == -1) {
      i1 = 2;
      i8 = 22;
      break L6;
     }
    } else {
     HEAP32[i2 >> 2] = i3 + 1;
     i1 = HEAPU8[i3 >> 0] | 0;
    }
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = 0;
     i8 = 22;
     break L6;
    }
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   while (1) {
    if ((i2 | 0) >= (i5 | 0)) {
     i1 = 0;
     i8 = 22;
     break L6;
    }
    i1 = HEAP32[i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i3 = i1 + 12 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (i4 & 1) break;
     if ((i1 | 0) == -1) {
      i1 = 2;
      i8 = 22;
      break L6;
     }
     i2 = HEAP32[i7 >> 2] | 0;
    } else {
     HEAP32[i3 >> 2] = i4 + 1;
     i1 = HEAPU8[i4 >> 0] | 0;
    }
    i2 = i2 + 1 | 0;
    HEAP32[i7 >> 2] = i2;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = 0;
     i8 = 22;
     break L6;
    }
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  if ((i8 | 0) == 22) {
   i7 = i9 + (HEAP32[(HEAP32[i9 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | i1 | 0);
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) break;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  }
  i2 = i9;
  i3 = i9;
  i8 = 24;
  break L1;
 } while (0); while (0);
 do if ((i8 | 0) == 24) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx2Gu20sweepCCTBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i10, i12, i7, i1, i3, i6, f9, i15, i17, i14, i16, i5, f2, i8) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 f9 = Math_fround(f9);
 i15 = i15 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 i8 = i8 | 0;
 var i4 = 0, i11 = 0, i13 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i13 + 48 | 0;
 i11 = i13;
 i18 = i13 + 108 | 0;
 HEAP32[i19 + 36 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i19 + 40 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i19 + 44 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i19 + 48 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i19 + 52 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i19 + 56 >> 2] = HEAP32[i1 + 12 >> 2];
 f23 = Math_fround(HEAPF32[i3 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f29 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f24 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f2 = Math_fround(f23 + f23);
 f21 = Math_fround(f22 + f22);
 f26 = Math_fround(f29 + f29);
 f28 = Math_fround(f22 * f21);
 f27 = Math_fround(f29 * f26);
 f22 = Math_fround(f2 * f22);
 f30 = Math_fround(f2 * f29);
 f20 = Math_fround(f2 * f24);
 f29 = Math_fround(f21 * f29);
 f21 = Math_fround(f21 * f24);
 f24 = Math_fround(f26 * f24);
 f26 = Math_fround(f22 + f24);
 f25 = Math_fround(f30 - f21);
 f24 = Math_fround(f22 - f24);
 f2 = Math_fround(Math_fround(1.0) - Math_fround(f23 * f2));
 f23 = Math_fround(f2 - f27);
 f22 = Math_fround(f29 + f20);
 f21 = Math_fround(f30 + f21);
 f20 = Math_fround(f29 - f20);
 f2 = Math_fround(f2 - f28);
 HEAPF32[i19 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f28) - f27);
 HEAPF32[i19 + 4 >> 2] = f26;
 HEAPF32[i19 + 8 >> 2] = f25;
 HEAPF32[i19 + 12 >> 2] = f24;
 HEAPF32[i19 + 16 >> 2] = f23;
 HEAPF32[i19 + 20 >> 2] = f22;
 HEAPF32[i19 + 24 >> 2] = f21;
 HEAPF32[i19 + 28 >> 2] = f20;
 HEAPF32[i19 + 32 >> 2] = f2;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i3 = i11 + 8 | 0;
 HEAP32[i3 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i1 = i11 + 16 | 0;
 i4 = i11 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP16[i18 >> 1] = HEAP16[i8 >> 1] | 0;
 i1 = __ZL19sweepBoxVsTrianglesjPKN5physx10PxTriangleERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEbPKj(i10, i12, i19, i6, f9, i11, i18, i7, i5) | 0;
 if (!i1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 HEAP32[i15 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i13;
 return i1 | 0;
}

function __Z43TerrainData_Set_Custom_PropDetailPrototypesP12Il2CppObjectP11Il2CppArray(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 72 | 0;
 i15 = i19;
 i18 = i19 + 76 | 0;
 if (!i1) {
  i17 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i17);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i17 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i17);
 }
 i13 = i2 + 128 | 0;
 HEAP32[i18 >> 2] = 0;
 i17 = i18 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 L7 : do if (i14 | 0) {
  i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i14) | 0;
  if (i3 | 0) {
   __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj(i18, i3);
   if ((i3 | 0) > 0) {
    i4 = i15 + 8 | 0;
    i5 = i15 + 12 | 0;
    i6 = i15 + 16 | 0;
    i7 = i15 + 20 | 0;
    i8 = i15 + 24 | 0;
    i9 = i15 + 28 | 0;
    i10 = i15 + 32 | 0;
    i11 = i15 + 36 | 0;
    i12 = i15 + 40 | 0;
    i1 = 0;
    while (1) {
     i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i14, i1) | 0;
     if (!i2) break;
     i22 = i2 + 8 | 0;
     i21 = HEAP32[i22 + 4 >> 2] | 0;
     i20 = i15;
     HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
     HEAP32[i20 + 4 >> 2] = i21;
     i20 = HEAP32[i2 + 20 >> 2] | 0;
     i21 = HEAP32[i2 + 24 >> 2] | 0;
     i22 = HEAP32[i2 + 28 >> 2] | 0;
     HEAP32[i4 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i5 >> 2] = i20;
     HEAP32[i6 >> 2] = i21;
     HEAP32[i7 >> 2] = i22;
     i22 = HEAP32[i2 + 36 >> 2] | 0;
     i21 = HEAP32[i2 + 40 >> 2] | 0;
     i20 = HEAP32[i2 + 44 >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i2 + 32 >> 2];
     HEAP32[i9 >> 2] = i22;
     HEAP32[i10 >> 2] = i21;
     HEAP32[i11 >> 2] = i20;
     i2 = i2 + 48 | 0;
     HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i12 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i12 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     HEAP32[i12 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
     HEAP32[i12 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
     __Z20DetailPrototypeToCppRK19MonoDetailPrototypeR15DetailPrototype(i15, (HEAP32[i18 >> 2] | 0) + (i1 * 136 | 0) | 0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) break L7;
    }
    HEAP32[i16 >> 2] = i1;
    __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 937647 | 0, i16);
   }
  }
 } while (0);
 __ZN14DetailDatabase19SetDetailPrototypesERKNSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEE(i13, i18);
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 i2 = HEAP32[i17 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i22 = i2 + -136 | 0;
   HEAP32[i17 >> 2] = i22;
   __ZN15DetailPrototypeD2Ev(i22);
   i2 = HEAP32[i17 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i18 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i19;
 return;
}

function __Z17GenerateRandomNx3RKN4math5_int4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i24 = HEAP32[i2 >> 2] | 0;
 i21 = HEAP32[i2 + 4 >> 2] | 0;
 i18 = HEAP32[i2 + 8 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i23 = (Math_imul(i24, 1812433253) | 0) + 1 | 0;
 i28 = (Math_imul(i21, 1812433253) | 0) + 1 | 0;
 i27 = (Math_imul(i18, 1812433253) | 0) + 1 | 0;
 i26 = (Math_imul(i15, 1812433253) | 0) + 1 | 0;
 i25 = (Math_imul(i23, 1812433253) | 0) + 1 | 0;
 i22 = (Math_imul(i28, 1812433253) | 0) + 1 | 0;
 i19 = (Math_imul(i27, 1812433253) | 0) + 1 | 0;
 i16 = (Math_imul(i26, 1812433253) | 0) + 1 | 0;
 i2 = (Math_imul(i25, 1812433253) | 0) + 1 | 0;
 i20 = (Math_imul(i22, 1812433253) | 0) + 1 | 0;
 i17 = (Math_imul(i19, 1812433253) | 0) + 1 | 0;
 i14 = (Math_imul(i16, 1812433253) | 0) + 1 | 0;
 i24 = i24 << 11 ^ i24;
 i21 = i21 << 11 ^ i21;
 i18 = i18 << 11 ^ i18;
 i15 = i15 << 11 ^ i15;
 i24 = i24 >>> 8 ^ i24 ^ i2;
 i2 = i24 ^ i2 >>> 19;
 i21 = i21 >>> 8 ^ i21 ^ i20;
 i20 = i21 ^ i20 >>> 19;
 i18 = i18 >>> 8 ^ i18 ^ i17;
 i17 = i18 ^ i17 >>> 19;
 i15 = i15 >>> 8 ^ i15 ^ i14;
 i14 = i15 ^ i14 >>> 19;
 f13 = Math_fround(Math_fround(i20 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f12 = Math_fround(Math_fround(i17 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f11 = Math_fround(Math_fround(i14 & 8388607 | 0) * Math_fround(1.19209304e-07));
 i23 = i23 << 11 ^ i23;
 i28 = i28 << 11 ^ i28;
 i27 = i27 << 11 ^ i27;
 i26 = i26 << 11 ^ i26;
 i23 = i23 >>> 8 ^ i23 ^ i2;
 i24 = i23 ^ i24 >>> 19;
 i20 = i28 >>> 8 ^ i28 ^ i20;
 i21 = i20 ^ i21 >>> 19;
 i17 = i27 >>> 8 ^ i27 ^ i17;
 i18 = i17 ^ i18 >>> 19;
 i14 = i26 >>> 8 ^ i26 ^ i14;
 i15 = i14 ^ i15 >>> 19;
 f10 = Math_fround(Math_fround(i24 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f9 = Math_fround(Math_fround(i21 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(i18 & 8388607 | 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(i15 & 8388607 | 0) * Math_fround(1.19209304e-07));
 i25 = i25 << 11 ^ i25;
 i22 = i22 << 11 ^ i22;
 i19 = i19 << 11 ^ i19;
 i16 = i16 << 11 ^ i16;
 f6 = Math_fround(Math_fround((i25 >>> 8 ^ i25 ^ i24) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround((i22 >>> 8 ^ i22 ^ i21) & 8388607 ^ i20 >>> 19 | 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround((i19 >>> 8 ^ i19 ^ i18) & 8388607 ^ i17 >>> 19 | 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround((i16 >>> 8 ^ i16 ^ i15) & 8388607 ^ i14 >>> 19 | 0) * Math_fround(1.19209304e-07));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(i2 & 8388607 | 0) * Math_fround(1.19209304e-07));
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = f11;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 28 >> 2] = f7;
 HEAPF32[i1 + 32 >> 2] = f6;
 HEAPF32[i1 + 36 >> 2] = f5;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAPF32[i1 + 44 >> 2] = f3;
 return;
}

function __ZN7mecanim5human17ReachGoalRotationEPKNS0_5HumanERKN4math7_float4EiPNS_8skeleton13SkeletonPoseTINS4_4trsXEEESC_SC_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i7 = HEAP32[i1 + 72 + (HEAP32[gb + 179492 + (i3 << 4) >> 2] << 2) >> 2] | 0;
 i15 = i1 + 40 | 0;
 i15 = (HEAP32[i15 >> 2] | 0) + i15 + 4 | 0;
 i15 = HEAP32[i15 + (HEAP32[i15 >> 2] | 0) + (i7 << 3) >> 2] | 0;
 i8 = i4 + 4 | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
 i5 = i5 + 4 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 f16 = Math_fround(HEAPF32[i5 + (i15 * 40 | 0) + 24 >> 2]);
 f13 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i15 * 40 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f13 * f18);
 f12 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(f16 * f12);
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i15 * 40 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f14 = Math_fround(f17 * f10);
 f20 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + (i15 * 40 | 0) + 12 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f11 - Math_fround(f16 * f19)) - Math_fround(f17 * f12)) - Math_fround(f20 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f20 * f18)) - Math_fround(f17 * f19)) - Math_fround(f13 * f10));
 f14 = Math_fround(Math_fround(Math_fround(f14 - Math_fround(f13 * f19)) - Math_fround(f16 * f18)) - Math_fround(f20 * f12));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f10)) - Math_fround(f13 * f12));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f12 = (HEAP32[tempDoublePtr >> 2] = i15 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(f12 * f12);
 f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f11 * f11);
 f10 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f14 + f13) + Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10))))));
 f11 = Math_fround(f13 * f11);
 f10 = Math_fround(f13 * f10);
 f9 = Math_fround(f13 * f9);
 HEAPF32[i8 + (i7 * 40 | 0) + 12 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i8 + (i7 * 40 | 0) + 16 >> 2] = f11;
 HEAPF32[i8 + (i7 * 40 | 0) + 20 >> 2] = f10;
 HEAPF32[i8 + (i7 * 40 | 0) + 24 >> 2] = f9;
 __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi(i1, i4, i6, HEAP32[gb + 179492 + (i3 << 4) + 8 >> 2] | 0, HEAP32[gb + 179492 + (i3 << 4) + 12 >> 2] | 0, Math_fround(.0500000007), 1);
 return;
}

function __ZN5physx14NpRigidDynamic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i14, i13, i1) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, f16 = f0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 32 | 0;
 i12 = i15;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i14, i13, i1);
 i9 = HEAP32[i14 + 52 >> 2] | 0;
 i10 = i14 + 56 | 0;
 if (!(HEAP16[((i9 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i9 >>> 24 & 15) << 2) >> 2] | 0) + (i14 + 48) + 8 | 0 : HEAP32[i10 >> 2] | 0) >> 1] & 1)) {
  STACKTOP = i15;
  return;
 }
 f8 = Math_fround(+mftCall_fii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0, 0));
 if (!(Math_fround(f8 * Math_fround(+mftCall_fii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0, 3))) != Math_fround(0.0))) {
  STACKTOP = i15;
  return;
 }
 f8 = Math_fround(HEAPF32[i14 + 276 >> 2]);
 f8 = Math_fround(f8 / Math_fround(HEAPF32[i1 + 2876 >> 2]));
 i9 = f8 > Math_fround(1.0);
 i1 = ~~Math_fround(f8 * Math_fround(255.0)) >>> 0;
 i1 = i9 ? 255 : i1;
 if (!(HEAP32[i14 + 280 >> 2] | 0)) i9 = i1 << 8 | i1 | i1 << 16; else i9 = 16711680;
 i1 = i14 + 284 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 2)) {
  i3 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i14 + 64 | 0) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
 } else i3 = (HEAP32[i10 >> 2] | 0) + 96 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i1 = f5 == Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f5);
 i3 = f6 == Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / f6);
 i7 = f8 == Math_fround(0.0);
 f8 = Math_fround(Math_fround(1.0) / f8);
 if (!(i2 & 1)) f4 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i14 + 64 | 0)); else f4 = Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + 92 >> 2]);
 f17 = Math_fround(Math_fround(6.0) / Math_fround(Math_fround(1.0) / f4));
 f4 = Math_fround((i1 ? Math_fround(0.0) : f5) * f17);
 f16 = Math_fround((i3 ? Math_fround(0.0) : f6) * f17);
 f8 = Math_fround((i7 ? Math_fround(0.0) : f8) * f17);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(f8 + Math_fround(f16 - f4))))));
 f6 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(f8 + Math_fround(f4 - f16))))));
 f8 = Math_fround(Math_sqrt(Math_fround(Math_abs(Math_fround(Math_fround(f4 + f16) - f8)))));
 i13 = __ZN5physx2Cm12RenderOutputlsEj(i13, i9) | 0;
 __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i11, i14 + 224 | 0);
 i14 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i13, i11) | 0;
 f5 = Math_fround(f5 * Math_fround(.5));
 f6 = Math_fround(f6 * Math_fround(.5));
 f8 = Math_fround(f8 * Math_fround(.5));
 f16 = Math_fround(-f6);
 f4 = Math_fround(-f8);
 HEAPF32[i12 >> 2] = Math_fround(-f5);
 HEAPF32[i12 + 4 >> 2] = f16;
 HEAPF32[i12 + 8 >> 2] = f4;
 HEAPF32[i12 + 12 >> 2] = f5;
 HEAPF32[i12 + 16 >> 2] = f6;
 HEAPF32[i12 + 20 >> 2] = f8;
 HEAP8[i12 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i14, i12) | 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx10PxsContext23prepareCMDiscreteUpdateEPNS_10PxBaseTaskE(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i13 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i11 | 0, i12 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i12 = i1 + 19 & -16;
   HEAP32[i12 + -4 >> 2] = i12 - i1;
   i1 = i12;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i13);
 }
 i4 = i13 + 6976 | 0;
 HEAP32[i4 >> 2] = i1;
 i12 = i13 + 1344 | 0;
 i6 = HEAP32[i13 + 1336 >> 2] & 134217727;
 i5 = i13 + 1348 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i6 >>> 0 > (i2 & 2147483647) >>> 0) {
  i1 = i13 + 1352 | 0;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i6 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i12 >> 2] | 0);
  }
  i11 = HEAP32[i5 >> 2] | 0;
  _memset(i2 + ((i11 & 2147483647) << 2) | 0, 0, i6 - i11 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i5 >> 2] = i6;
  i11 = HEAP32[i4 >> 2] | 0;
  i3 = i11;
  i2 = i6;
 } else {
  i3 = i1;
  i11 = i1;
 }
 HEAP32[i3 + 8764 >> 2] = HEAP32[i13 + 7600 >> 2];
 i14 = HEAP8[i13 + 7604 >> 0] | 0;
 HEAP8[i3 + 8772 >> 0] = i14;
 HEAP8[i3 + 8775 >> 0] = HEAP8[i13 + 7606 >> 0] | 0;
 HEAP8[i3 + 8773 >> 0] = HEAP8[i13 + 7605 >> 0] | 0;
 i1 = i13 + 44 | 0;
 i3 = HEAP32[i13 + 1368 >> 2] | 0;
 i4 = HEAP32[i13 + 1372 >> 2] | 0;
 i5 = HEAP32[i13 + 1392 >> 2] | 0;
 i6 = HEAP32[i13 + 1396 >> 2] | 0;
 i7 = HEAP32[i13 + 1404 >> 2] | 0;
 i8 = HEAP32[i13 + 1408 >> 2] | 0;
 i9 = HEAP32[i13 + 1428 >> 2] | 0;
 i10 = HEAP32[i13 + 1432 >> 2] | 0;
 if (!(i14 << 24 >> 24)) {
  i14 = i13 + 6928 | 0;
  __ZN5physx13PxcRunNpBatchEjjjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE(0, 0, 0, 0, 0, i11, i1, 0, 0, i3, i4, HEAP32[i13 + 1380 >> 2] | 0, HEAP32[i13 + 1384 >> 2] | 0, i5, i6, i7, i8, HEAP32[i13 + 1416 >> 2] | 0, HEAP32[i13 + 1420 >> 2] | 0, i9, i10, HEAP32[i12 >> 2] | 0, i2 & 2147483647, i13 + 6968 | 0, i13 + 6972 | 0, i14, HEAP32[i13 + 6960 >> 2] | 0);
  i13 = HEAP32[i14 >> 2] | 0;
  i13 = i13 + 20 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  mftCall_vi(i13 | 0, i14 | 0);
  return;
 } else {
  i14 = i13 + 6928 | 0;
  __ZN5physx16PxcRunNpPCMBatchEjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE(0, 0, 0, i11, i1, 0, 0, i3, i4, i5, i6, i7, i8, i9, i10, HEAP32[i12 >> 2] | 0, i2 & 2147483647, i13 + 6968 | 0, i13 + 6972 | 0, i14, HEAP32[i13 + 6960 >> 2] | 0);
  i13 = HEAP32[i14 >> 2] | 0;
  i13 = i13 + 20 | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  mftCall_vi(i13 | 0, i14 | 0);
  return;
 }
}

function __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib(i13, i4, i5, i1, i9) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16;
 i7 = i16 + 36 | 0;
 i14 = i16 + 16 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i13 + 116 | 0;
 i11 = i13 + 176 | 0;
 i10 = i13 + 120 | 0;
 if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
  i12 = i13 + 168 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i13 + 172 >> 2] | 0;
  i3 = i1 + (i2 * 20 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i8, i6, i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i12 = i13 + 168 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i13 + 172 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i1 + (i2 * 20 | 0) | 0 : i1 + (i3 * 20 | 0) | 0;
 }
 if ((i3 | 0) != (i1 + (i2 * 20 | 0) | 0)) {
  i1 = i3 + 4 | 0;
  if (!i9) {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  }
  HEAP8[i3 + 18 >> 0] = 1;
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i1 = __ZN17PersistentManager21ProduceObjectInternalER14SerializedFile26SerializedObjectIdentifierii(i13, i4, i8, i1, 1) | 0;
 if (!i1) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i14 >> 2] = i7;
 HEAP32[i14 + 4 >> 2] = i7;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = i1;
 HEAP8[i14 + 16 >> 0] = 0;
 HEAP8[i14 + 17 >> 0] = 0;
 HEAP8[i14 + 18 >> 0] = i9 & 1;
 __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj(i6, 1, 0);
 __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i8, i6, i14);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  if (!(HEAP8[i13 + 124 >> 0] | 0)) i15 = 14; else {
   i2 = HEAP32[i10 >> 2] | 0;
   if (!i2) i15 = 14; else {
    i1 = HEAP32[i12 >> 2] | 0;
    if ((HEAP32[i13 + 128 >> 2] | 0) == (HEAP32[i1 + (i3 * 20 | 0) >> 2] | 0)) HEAP32[i10 >> 2] = i2 + -1; else i15 = 14;
   }
  }
  if ((i15 | 0) == 14) {
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i1 = i1 + (i3 * 20 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
  i1 = (HEAP32[i12 >> 2] | 0) + (i3 * 20 | 0) | 0;
 } else i1 = (HEAP32[i12 >> 2] | 0) + (i1 * 20 | 0) | 0;
 i15 = i1 + 4 | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN13RenderTexture10ForceClearEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 76 | 0;
 i13 = i15 + 72 | 0;
 i14 = i15 + 68 | 0;
 i8 = i15 + 32 | 0;
 i9 = i15;
 i10 = i15 + 64 | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 356 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 L1 : do if ((i7 | 0) > 0) {
  i2 = 0;
  while (1) {
   HEAP32[i8 + (i2 << 2) >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 348 >> 2] | 0, i3 | 0, i2 | 0) | 0;
   i1 = __Z12GetGfxDevicev() | 0;
   i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, i2 | 0) | 0;
   if (!i1) {
    i1 = __Z12GetGfxDevicev() | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 352 >> 2] | 0, i1 | 0) | 0;
    if (!i1) i1 = 0; else i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
   } else i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
   HEAP32[i9 + (i2 << 2) >> 2] = i1;
   i2 = i2 + 1 | 0;
   if ((i1 | 0) == (i11 | 0)) break;
   if ((i2 | 0) >= (i7 | 0)) break L1;
  }
  i1 = i11 + 128 | 0;
  i2 = i11 + 136 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i2 >> 2] | 0)) {
   STACKTOP = i15;
   return;
  }
  i3 = __Z12GetGfxDevicev() | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i10;
  i1 = HEAP32[i11 + 132 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  if (i10) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i12 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
  }
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i13 | 0);
  if (HEAP32[i14 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i14 | 0);
  STACKTOP = i15;
  return;
 } while (0);
 i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 352 >> 2] | 0, i3 | 0) | 0;
 i4 = HEAP32[i3 + 4196 >> 2] | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i11, HEAP32[i11 + 76 >> 2] | 0, -1, 0, 0);
 i1 = i11 + 128 | 0;
 i2 = i11 + 136 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  if (HEAP32[i2 >> 2] | 0) i6 = 20;
 } else i6 = 20;
 if ((i6 | 0) == 20) {
  i3 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i6;
  i1 = HEAP32[i11 + 132 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  if (i6) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i12 | 0);
   i1 = HEAP32[i13 >> 2] | 0;
  }
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i13 | 0);
  if (HEAP32[i14 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0, i3 | 0, i14 | 0);
 }
 HEAP32[i10 >> 2] = i5;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i7, i8, i12, i9, 0, i4, 0, 0) | 0;
 STACKTOP = i15;
 return;
}

function __ZNSt3__218__insertion_sort_3IR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i10 = i11 + 32 | 0;
 i7 = i11 + 16 | 0;
 i2 = i7;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i11;
 i3 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i10;
 i6 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i9 >>> 0 < i2 >>> 0 | (i9 | 0) == (i2 | 0) & i6 >>> 0 < i5 >>> 0;
 do if (i2 >>> 0 < i8 >>> 0 | (i2 | 0) == (i8 | 0) & i5 >>> 0 < i3 >>> 0) {
  if (i1) {
   i7 = i11;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i7 + 4 >> 2] = i9;
   i7 = i10;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = i8;
   i7 = i11 + 8 | 0;
   i2 = i11 + 40 | 0;
   i9 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i9;
   i2 = i8;
   break;
  }
  i1 = i11;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i2;
  i5 = i7;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i8;
  i5 = i11 + 8 | 0;
  i1 = i11 + 24 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  if (i9 >>> 0 < i8 >>> 0 | (i9 | 0) == (i8 | 0) & i6 >>> 0 < i3 >>> 0) {
   HEAP32[i7 >> 2] = i6;
   HEAP32[i7 + 4 >> 2] = i9;
   i9 = i10;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i9 + 4 >> 2] = i8;
   i9 = i11 + 40 | 0;
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i2;
   i2 = i8;
  } else {
   i3 = i6;
   i2 = i9;
  }
 } else if (i1) {
  i1 = i7;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 4 >> 2] = i9;
  i1 = i10;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = i11 + 24 | 0;
  i13 = i11 + 40 | 0;
  i14 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i13 >> 2] = i14;
  if (i9 >>> 0 < i8 >>> 0 | (i9 | 0) == (i8 | 0) & i6 >>> 0 < i3 >>> 0) {
   i14 = i11;
   HEAP32[i14 >> 2] = i6;
   HEAP32[i14 + 4 >> 2] = i9;
   i14 = i7;
   HEAP32[i14 >> 2] = i3;
   HEAP32[i14 + 4 >> 2] = i8;
   i14 = i11 + 8 | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = i4;
   HEAP32[i1 >> 2] = i3;
   i3 = i5;
  } else i3 = i5;
 } else {
  i3 = i6;
  i2 = i9;
 } while (0);
 i1 = i11 + 48 | 0;
 if ((i1 | 0) == (i12 | 0)) return; else {
  i9 = i1;
  i1 = i10;
 }
 while (1) {
  i8 = i9;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  if (i8 >>> 0 < i2 >>> 0 | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i3 >>> 0) {
   i6 = HEAP32[i9 + 8 >> 2] | 0;
   i4 = i9;
   while (1) {
    i5 = i4;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i2;
    i5 = i1 + 8 | 0;
    HEAP32[i4 + 8 >> 2] = HEAP32[i5 >> 2];
    if ((i1 | 0) == (i11 | 0)) break;
    i4 = i1 + -16 | 0;
    i2 = i4;
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!(i8 >>> 0 < i2 >>> 0 | (i8 | 0) == (i2 | 0) & i7 >>> 0 < i3 >>> 0)) break; else {
     i14 = i1;
     i1 = i4;
     i4 = i14;
    }
   }
   i14 = i1;
   HEAP32[i14 >> 2] = i7;
   HEAP32[i14 + 4 >> 2] = i8;
   HEAP32[i5 >> 2] = i6;
  }
  i1 = i9 + 16 | 0;
  if ((i1 | 0) == (i12 | 0)) break;
  i3 = i9;
  i14 = i9;
  i9 = i1;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i1 = i14;
 }
 return;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 8 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  break;
 } while (0);
 i9 = i1 + (HEAP32[i5 >> 2] << 2) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i3 = HEAP32[gb + 36980 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i9 | 0)) break L17;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12resize_deltaEjj(i6, i5, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i6 + 72 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i3 = (HEAP32[i6 + 60 >> 2] | 0) - (HEAP32[i6 + 4 >> 2] | 0) | 0;
  if (i3 >>> 0 < (HEAP32[i6 + 64 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i6 + 56 >> 2] | 0;
   if (i1 >>> 0 > 32) {
    f2 = Math_fround(i3 >>> 0);
    do {
     i3 = i1;
     i1 = i1 >>> 1;
     if (i3 >>> 0 < 66) break;
    } while (f2 < Math_fround(Math_fround(i1 >>> 0) * Math_fround(.200000003)));
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j(i8, i6, i1);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_(i6, i8);
    __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i8);
   }
  }
  HEAP8[i4 >> 0] = 0;
 }
 i4 = HEAP32[i6 + 56 >> 2] | 0;
 i1 = HEAP32[i6 + 60 >> 2] | 0;
 if (i4 >>> 0 > i7 >>> 0) if ((i1 + i5 | 0) >>> 0 <= (HEAP32[i6 + 68 >> 2] | 0) >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + i5 | 0;
 f2 = Math_fround(i3 >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 if (i1 >>> 0 <= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround((i3 - (HEAP32[i6 + 4 >> 2] | 0) | 0) >>> 0);
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i7 >>> 0) if (!(f2 >= Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)))) break;
  i1 = i1 << 1;
 }
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j(i8, i6, i1);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_(i6, i8);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17CUDAProfileBufferEyfPKhjj(i17, i1, i2, f4, i5, i6, i3) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i18;
 i11 = i18 + 24 | 0;
 i12 = i17 + 72 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i16 = (i15 | 0) == 0;
 if (!i16) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i15 + 4 >> 2] | 0);
 i14 = i10;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i2;
 HEAPF32[i10 + 8 >> 2] = f4;
 HEAP32[i10 + 12 >> 2] = i5;
 HEAP32[i10 + 16 >> 2] = i6;
 HEAP32[i10 + 20 >> 2] = i3;
 HEAP8[i11 >> 0] = 6;
 HEAP8[i11 + 1 >> 0] = -1;
 HEAP16[i11 + 2 >> 1] = 0;
 i14 = i17 + 20 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i13 = i17 + 16 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i9 = i17 + 44 | 0;
 if ((i1 + i6 - i2 | 0) >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = (i7 | 0) == 0;
  if (i8) i3 = i1; else {
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
   i3 = HEAP32[i14 >> 2] | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  }
  i1 = i2;
  i5 = i3 - i1 | 0;
  i6 = HEAP32[i17 + 36 >> 2] | 0;
  if (i6) {
   i1 = i17 + 32 | 0;
   i3 = 0;
   do {
    i19 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i2 | 0, i5 | 0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i6 | 0));
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0, i17 | 0);
  if (!i8) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 }
 i1 = i17 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i11, i1);
 __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE(i10, i1, i11);
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i1 - i3 | 0) >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) {
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = (i7 | 0) == 0;
  if (i8) i2 = i1; else {
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
   i2 = HEAP32[i14 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  }
  i1 = i3;
  i5 = i2 - i1 | 0;
  i6 = HEAP32[i17 + 36 >> 2] | 0;
  if (i6) {
   i1 = i17 + 32 | 0;
   i2 = 0;
   do {
    i19 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i3 | 0, i5 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i6 | 0));
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i17 >> 2] | 0) + 16 >> 2] | 0, i17 | 0);
  if (!i8) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 }
 if (i16) {
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i15 + 4 >> 2] | 0);
 STACKTOP = i18;
 return;
}

function __ZN5physx21PxcArticulationHelper15createHardLimitERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Eff(i3, i5, i4, i7, i1, f2, f6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f6 = Math_fround(f6);
 var i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i8 + 32 | 0;
 i15 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = HEAP32[i1 >> 2];
 i14 = i1 + 4 | 0;
 HEAP32[i7 + 36 >> 2] = HEAP32[i14 >> 2];
 i13 = i1 + 8 | 0;
 HEAP32[i7 + 40 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i13 >> 2];
 HEAPF32[i7 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 100 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i7 + 108 >> 2] = 0;
 HEAPF32[i7 + 104 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i5 + (i4 << 5) + 28 >> 2] | 0;
 i19 = HEAP32[i1 >> 2] | 0;
 i18 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i13 >> 2] | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 HEAP32[i16 + 16 >> 2] = i19;
 HEAP32[i16 + 20 >> 2] = i18;
 HEAP32[i16 + 24 >> 2] = i17;
 HEAPF32[i16 + 28 >> 2] = Math_fround(0.0);
 f10 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f11 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAPF32[i15 + 16 >> 2] = f10;
 HEAPF32[i15 + 20 >> 2] = f11;
 HEAPF32[i15 + 24 >> 2] = f12;
 HEAPF32[i15 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_(i3, i5, i16, i7 + 112 | 0, i4, i15, i7 + 144 | 0);
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f12 * Math_fround(HEAPF32[i7 + 128 >> 2]));
 f10 = Math_fround(HEAPF32[i14 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i7 + 132 >> 2])));
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f9 * Math_fround(HEAPF32[i7 + 136 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i7 + 160 >> 2]));
 f10 = Math_fround(f12 + Math_fround(f10 * Math_fround(HEAPF32[i7 + 164 >> 2])));
 f9 = Math_fround(f11 - Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i7 + 168 >> 2]))));
 i5 = f9 <= Math_fround(0.0);
 f9 = Math_fround(Math_fround(1.0) / f9);
 f9 = i5 ? Math_fround(0.0) : f9;
 f6 = Math_fround(-Math_fround(Math_fround(f9 * f2) * f6));
 HEAPF32[i7 + 12 >> 2] = f6;
 i5 = f2 > Math_fround(0.0);
 HEAPF32[i7 + 28 >> 2] = i5 ? f6 : Math_fround(0.0);
 HEAPF32[i7 + 44 >> 2] = Math_fround(-f9);
 HEAPF32[i7 + 60 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __Z31ReadVersionedTypeTreeFromVectorR8TypeTreeRPKhS2_b(i8, i2, i3, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i1 = i11;
 i10 = i11 + 16 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) {
  i1 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
  if (i4) {
   i10 = _llvm_bswap_i32(i1 | 0) | 0;
   HEAP32[i2 >> 2] = i5 + 4;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i9 + 4 >> 2] = 0;
   __ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i9, i2, i3, i10) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  } else {
   HEAP32[i2 >> 2] = i5 + 4;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i9 + 4 >> 2] = 0;
   __ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i8, i9, i2, i3, i1) | 0;
   i10 = 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i13 = i10 + 12 | 0;
 HEAP32[i13 >> 2] = 1;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = 1;
 i2 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63720 | 0);
 i3 = i9;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i2, 0, gb + 1047584 | 0, 446) | 0;
 i5 = gb + 63720 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i10 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 32 >> 2] = 0;
 i4 = i10 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i1);
 i12 = i9;
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i5;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i6;
 i14 = gb + 63720 | 0;
 i6 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i1;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i6;
 HEAP32[i10 + 40 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = 0;
 i12 = i10 + 56 | 0;
 HEAP32[i12 >> 2] = 0;
 i6 = i10 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i1);
 i14 = i9;
 i9 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = (HEAP32[i13 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP8[i9 + (i1 * 24 | 0) + 2 >> 0] = 0;
 HEAP32[i9 + (i1 * 24 | 0) + 8 >> 2] = 0;
 HEAP32[i9 + (i1 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i9 + (i1 * 24 | 0) + 16 >> 2] = -1;
 HEAP8[i9 + (i1 * 24 | 0) + 3 >> 0] = 0;
 HEAP16[i9 + (i1 * 24 | 0) >> 1] = 1;
 HEAP32[i9 + (i1 * 24 | 0) + 20 >> 2] = 0;
 HEAP32[i9 + (i1 * 24 | 0) + 12 >> 2] = -1;
 __ZN8TypeTreeaSERKS_(i8, i10) | 0;
 i1 = i10 + 40 | 0;
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i5);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i2);
  HEAP32[i10 >> 2] = 0;
 }
 i14 = 0;
 STACKTOP = i11;
 return i14 | 0;
}

function __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj1ES2_NS_25GenericInsituStringStreamIS2_EEEERS4_RT1_(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i10);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i10 + 20 >> 2];
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 256;
 i3 = i7 + 24 | 0;
 i4 = i7 + 28 | 0;
 i5 = i7 + 24 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 L1 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 9:
  case 13:
  case 10:
  case 32:
   break;
  default:
   break L1;
  }
  i1 = i1 + 1 | 0;
 }
 i6 = i10 + 52 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i8 = i1 - (HEAP32[i2 + 8 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i4 >> 2] = i8;
 } else {
  __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i7, i2, i10);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = HEAP32[i2 >> 2] | 0;
   L9 : while (1) {
    switch (HEAP8[i1 >> 0] | 0) {
    case 9:
    case 13:
    case 10:
    case 32:
     break;
    default:
     break L9;
    }
    i1 = i1 + 1 | 0;
   }
   HEAP32[i2 >> 2] = i1;
   if (HEAP8[i1 >> 0] | 0) {
    i8 = i1 - (HEAP32[i2 + 8 >> 2] | 0) | 0;
    HEAP32[i3 >> 2] = 2;
    HEAP32[i4 >> 2] = i8;
   }
  }
 }
 i3 = i5;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i7 + 8 | 0;
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 >> 2];
 i4 = i6;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = i10 + 40 | 0;
 if (!i5) {
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i3 + -24 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i3 = i3 + -8 | 0;
  HEAP32[i10 + 16 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = 0;
  i3 = i4;
 } else {
  i3 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i5 = i10 + 36 | 0;
 i1 = i2;
 if ((i2 | 0) != (HEAP32[i5 >> 2] | 0)) do {
  i2 = i1 + -24 | 0;
  HEAP32[i4 >> 2] = i2;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = i2;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 if ((i1 | 0) == (i2 | 0)) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
  i1 = 0;
 } else i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i10 + 44 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, gb + 64016 | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx22PxVehicleTelemetryData8allocateEj(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = (i8 * 15840 | 0) + 15872 | 0;
 i7 = i8 * 12 | 0;
 i6 = i5 + i7 | 0;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 + i7 | 0, gb + 835663 | 0, 493) | 0;
 i1 = i7 + 32 | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = i7 + 15840 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i7 + 15824 >> 2] = 1132396544;
 HEAP32[i7 + 15828 >> 2] = 1132396544;
 HEAP32[i7 + 15832 >> 2] = 1132396544;
 HEAPF32[i7 + 15836 >> 2] = Math_fround(1.0);
 i2 = 0;
 do {
  HEAPF32[i1 + (i2 << 2) >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 48 + (i2 << 2) >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 96 + (i2 << 2) >> 2] = Math_fround(0.0);
  HEAP32[i1 + 144 + (i2 * 12 | 0) >> 2] = 0;
  HEAP32[i1 + 144 + (i2 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i1 + 144 + (i2 * 12 | 0) + 8 >> 2] = 1132396544;
  HEAP32[i1 + 288 + (i2 * 12 | 0) >> 2] = 1132396544;
  HEAP32[i1 + 288 + (i2 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i1 + 288 + (i2 * 12 | 0) + 8 >> 2] = 0;
  _memset(i1 + 3504 + (i2 << 10) | 0, 0, 1024) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 12);
 HEAP32[i7 + 15860 >> 2] = 0;
 i1 = i7 + 15872 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 if (!i8) {
  i4 = i7 + i5 | 0;
  i5 = i7 + 12 | 0;
  HEAP32[i5 >> 2] = i4;
  i5 = i7 + i6 | 0;
  i6 = i7 + 8 | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i7 + 16 | 0;
  HEAP32[i6 >> 2] = i8;
  STACKTOP = i9;
  return i7 | 0;
 }
 i2 = 0;
 while (1) {
  i3 = i1 + (i2 * 15840 | 0) + 15808 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i1 + (i2 * 15840 | 0) + 15792 >> 2] = 1132396544;
  HEAP32[i1 + (i2 * 15840 | 0) + 15796 >> 2] = 1132396544;
  HEAP32[i1 + (i2 * 15840 | 0) + 15800 >> 2] = 1132396544;
  HEAPF32[i1 + (i2 * 15840 | 0) + 15804 >> 2] = Math_fround(1.0);
  i3 = 0;
  do {
   HEAPF32[i1 + (i2 * 15840 | 0) + (i3 << 2) >> 2] = Math_fround(0.0);
   HEAPF32[i1 + (i2 * 15840 | 0) + 48 + (i3 << 2) >> 2] = Math_fround(0.0);
   HEAPF32[i1 + (i2 * 15840 | 0) + 96 + (i3 << 2) >> 2] = Math_fround(0.0);
   HEAP32[i1 + (i2 * 15840 | 0) + 144 + (i3 * 12 | 0) >> 2] = 0;
   HEAP32[i1 + (i2 * 15840 | 0) + 144 + (i3 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i1 + (i2 * 15840 | 0) + 144 + (i3 * 12 | 0) + 8 >> 2] = 1132396544;
   HEAP32[i1 + (i2 * 15840 | 0) + 288 + (i3 * 12 | 0) >> 2] = 1132396544;
   HEAP32[i1 + (i2 * 15840 | 0) + 288 + (i3 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i1 + (i2 * 15840 | 0) + 288 + (i3 * 12 | 0) + 8 >> 2] = 0;
   _memset(i1 + (i2 * 15840 | 0) + 3504 + (i3 << 10) | 0, 0, 1024) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != 12);
  HEAP32[i1 + (i2 * 15840 | 0) + 15828 >> 2] = 0;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i8 | 0)) break;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i4 = i7 + i5 | 0;
 i5 = i7 + 12 | 0;
 HEAP32[i5 >> 2] = i4;
 i5 = i7 + i6 | 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i6 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = i8;
 STACKTOP = i9;
 return i7 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15insert_noresizeERKS9_(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19;
 __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_(i1, i16, i17);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i17 = HEAP32[i16 + 60 >> 2] | 0;
  i18 = i17 + ((HEAP32[i16 + 64 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i15 + 4 >> 2] = i17 + (i2 * 24 | 0);
  HEAP32[i15 + 8 >> 2] = i18;
  HEAP8[i15 + 12 >> 0] = 0;
  STACKTOP = i19;
  return;
 }
 i13 = i1 + 4 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 L5 : do if (!(HEAP8[i16 + 8 >> 0] | 0)) i18 = 14; else {
  i11 = i16 + 4 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  if (!i12) i18 = 14; else {
   i5 = i16 + 12 | 0;
   i2 = i16 + 60 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i1 + (i14 * 24 | 0) | 0;
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i8 = i4 << 24 >> 24 < 0;
   i4 = i4 & 255;
   i9 = i8 ? HEAP32[i16 + 16 >> 2] | 0 : i4;
   i10 = HEAP8[i3 + 11 >> 0] | 0;
   i6 = i10 << 24 >> 24 < 0;
   if ((i9 | 0) == ((i6 ? HEAP32[i1 + (i14 * 24 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
    i7 = HEAP32[i5 >> 2] | 0;
    i10 = i8 ? i7 : i5;
    i3 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
    i6 = (i9 | 0) == 0;
    L9 : do if (i8) {
     if (!i6) if (_memcmp(i10, i3, i9) | 0) {
      i18 = 14;
      break L5;
     }
    } else if (!i6) {
     if ((i7 & 255) << 24 >> 24 != (HEAP8[i3 >> 0] | 0)) {
      i18 = 14;
      break L5;
     }
     while (1) {
      i4 = i4 + -1 | 0;
      i5 = i5 + 1 | 0;
      if (!i4) break L9;
      i3 = i3 + 1 | 0;
      if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
       i18 = 14;
       break L5;
      }
     }
    } while (0);
    HEAP32[i11 >> 2] = i12 + -1;
   } else i18 = 14;
  }
 } while (0);
 if ((i18 | 0) == 14) {
  i1 = i16 + 68 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i16 + 60 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i18 = i1 + (i14 * 24 | 0) + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 i14 = i1 + (i14 * 24 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i14, i17);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i18, i17 + 12 | 0);
 i18 = HEAP32[i2 >> 2] | 0;
 i17 = i18 + ((HEAP32[i13 >> 2] | 0) * 24 | 0) | 0;
 i18 = i18 + ((HEAP32[i16 + 64 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i15 + 8 >> 2] = i18;
 HEAP8[i15 + 12 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i3) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i8 = i12;
 i6 = i12 + 24 | 0;
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[i3 >> 2] | 0;
 if (!(i7 & 1)) {
  i6 = i3 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i4 = i3 + 24 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
   i1 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = i2;
   i5 = i2;
  }
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = i5 + 8 | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 8);
   i5 = i10 + 4 | 0;
   i2 = i10;
   i3 = i5;
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i10;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i5;
   HEAP32[i6 >> 2] = i2;
   i2 = i10;
   i3 = i10 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = _llvm_bswap_i32(i5 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  i7 = i10;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i5 = i3 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i3 = i3 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 }
 HEAP32[i8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 8 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 8);
  i4 = i10 + 4 | 0;
  i1 = i10;
  i2 = i4;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i10;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
  i1 = i10;
  i2 = i10 + 4 | 0;
 }
 i5 = _llvm_bswap_i32(i3 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i2 >> 2] = i5;
 i4 = i10;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!(i7 & 8388608)) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS9_EEiEESC_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN22ProceduralMaterialDataD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   if (!(HEAP8[i2 + 16 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63736 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i5 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 80 | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 + 20 >> 2] | 0;
   if (i1 | 0) {
    i8 = i1 + 4 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
    if (!(HEAP32[i8 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
    }
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i3, HEAP32[i4 >> 2] | 0);
 HEAP32[i5 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i3, 0);
 i1 = HEAP32[i5 + 60 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 64 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -72 - i2 | 0) >>> 0) / 72 | 0) * 72 | 0);
  i8 = HEAP32[i5 + 72 >> 2] | 0;
  HEAP32[i6 >> 2] = 77;
  HEAP32[i6 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 __ZNSt3__213__vector_baseI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEED2Ev(i5 + 44 | 0);
 i3 = i5 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 36 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -156 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN14SubstanceInputD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i5 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i6);
 STACKTOP = i7;
 return;
}

function __ZN19CloudServiceHandler8SaveFileERK8UnityStrPKvj(i2, i5, i7, i8) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 2240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 2224 | 0;
 i14 = i15 + 56 | 0;
 i10 = i15 + 40 | 0;
 i11 = i15 + 24 | 0;
 i12 = i15 + 12 | 0;
 i13 = i15;
 if (!(HEAP32[i2 + 1144 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 __ZN11UnityEngine15CloudWebService18RestFileDownloaderC2EPNS0_23IRestDownloaderListenerE(i14, 0);
 i1 = i2 + 36 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 40 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i4, i1);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i3 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i11, i12, i13);
 i4 = HEAP8[i11 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i1 ? HEAP32[i11 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i6 = 8;
 } else if (i4 >>> 0 < 11) {
  i2 = i10 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i6 = 10;
  }
 } else i6 = 8;
 if ((i6 | 0) == 8) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i2 = i10 + 11 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr(i14, i10) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i9);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 if (i1) i1 = (__ZN11UnityEngine15CloudWebService18RestFileDownloader13OnReceiveDataEPKvj(i14, i7, i8) | 0) == (i8 | 0); else i1 = 0;
 __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev(i14);
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb1EEEvRPT_PKcRjS9_RT0_(i7, i1, i6, i2, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i6, i2);
 i6 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 1736, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i6);
 i3 = i6 + 888 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 912 >> 2] = 1065353216;
 HEAP32[i6 + 916 >> 2] = 1065353216;
 HEAP32[i6 + 920 >> 2] = 1065353216;
 HEAP32[i6 + 924 >> 2] = 1065353216;
 i3 = i6 + 928 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 952 >> 2] = 1065353216;
 HEAP32[i6 + 956 >> 2] = 1065353216;
 HEAP32[i6 + 960 >> 2] = 1065353216;
 HEAP32[i6 + 964 >> 2] = 1065353216;
 i3 = i6 + 968 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 992 >> 2] = 1065353216;
 HEAP32[i6 + 996 >> 2] = 1065353216;
 HEAP32[i6 + 1e3 >> 2] = 1065353216;
 HEAP32[i6 + 1004 >> 2] = 1065353216;
 i3 = i6 + 1008 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 1032 >> 2] = 1065353216;
 HEAP32[i6 + 1036 >> 2] = 1065353216;
 HEAP32[i6 + 1040 >> 2] = 1065353216;
 HEAP32[i6 + 1044 >> 2] = 1065353216;
 i3 = i6 + 1048 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAPF32[i6 + 1068 >> 2] = Math_fround(1.0);
 i3 = i6 + 1072 | 0;
 i4 = i6 + 1708 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP16[i4 + 20 >> 1] = 0;
 HEAP8[i6 + 1730 >> 0] = 1;
 HEAP8[i6 + 1731 >> 0] = 0;
 HEAP8[i6 + 1732 >> 0] = 1;
 HEAP8[i6 + 1733 >> 0] = 0;
 HEAP8[i6 + 1734 >> 0] = 0;
 _memset(i6 + 1088 | 0, -1, 620) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 STACKTOP = i5;
 return;
}

function __ZNK11NoiseModule12PreviewNoiseILi3EEEvP9Texture2DP10ColorRGBAf(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 20 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i14 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i7 = (i6 >>> 0) / 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i7 << 3;
 do if (i6 >>> 0 > 11) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 568) | 0;
   i3 = gb + 64016 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i8;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = gb + 63160 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i4;
 } while (0);
 i4 = i1 + 3 & -4;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 4 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i7 * 20 | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 571) | 0;
   i2 = gb + 64016 | 0;
   i16 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i5;
   HEAP32[i3 >> 2] = i16;
   HEAP32[i3 + 4 >> 2] = i2;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 if (i6 | 0) {
  i1 = 0;
  i2 = 0;
  while (1) {
   HEAP32[i4 + (i1 << 3) >> 2] = fb + 3716;
   HEAP32[i4 + (i1 << 3) + 4 >> 2] = i3 + (i1 * 20 | 0);
   HEAP32[i3 + (i1 * 20 | 0) >> 2] = i9;
   HEAP32[i3 + (i1 * 20 | 0) + 4 >> 2] = i2;
   HEAP32[i3 + (i1 * 20 | 0) + 8 >> 2] = i14;
   HEAP32[i3 + (i1 * 20 | 0) + 12 >> 2] = i6;
   HEAP32[i3 + (i1 * 20 | 0) + 16 >> 2] = i10;
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i1 = i1 + 1 | 0;
  }
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i13, i4, i7, 0);
 if (!(HEAP32[i13 >> 2] | 0)) {
  i16 = HEAP32[i12 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
  i16 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
  STACKTOP = i15;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i13);
 i16 = HEAP32[i12 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
 i16 = HEAP32[i11 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
 STACKTOP = i15;
 return;
}

function __ZNK11NoiseModule12PreviewNoiseILi2EEEvP9Texture2DP10ColorRGBAf(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 20 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i14 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i7 = (i6 >>> 0) / 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i7 << 3;
 do if (i6 >>> 0 > 11) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 568) | 0;
   i3 = gb + 64016 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i8;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = gb + 63160 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i4;
 } while (0);
 i4 = i1 + 3 & -4;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 4 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i7 * 20 | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 571) | 0;
   i2 = gb + 64016 | 0;
   i16 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i5;
   HEAP32[i3 >> 2] = i16;
   HEAP32[i3 + 4 >> 2] = i2;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 if (i6 | 0) {
  i1 = 0;
  i2 = 0;
  while (1) {
   HEAP32[i4 + (i1 << 3) >> 2] = fb + 3715;
   HEAP32[i4 + (i1 << 3) + 4 >> 2] = i3 + (i1 * 20 | 0);
   HEAP32[i3 + (i1 * 20 | 0) >> 2] = i9;
   HEAP32[i3 + (i1 * 20 | 0) + 4 >> 2] = i2;
   HEAP32[i3 + (i1 * 20 | 0) + 8 >> 2] = i14;
   HEAP32[i3 + (i1 * 20 | 0) + 12 >> 2] = i6;
   HEAP32[i3 + (i1 * 20 | 0) + 16 >> 2] = i10;
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i1 = i1 + 1 | 0;
  }
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i13, i4, i7, 0);
 if (!(HEAP32[i13 >> 2] | 0)) {
  i16 = HEAP32[i12 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
  i16 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
  STACKTOP = i15;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i13);
 i16 = HEAP32[i12 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
 i16 = HEAP32[i11 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
 STACKTOP = i15;
 return;
}

function __ZNK11NoiseModule12PreviewNoiseILi1EEEvP9Texture2DP10ColorRGBAf(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 20 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i14 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i7 = (i6 >>> 0) / 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 4 | 0;
 i4 = gb + 63160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i7 << 3;
 do if (i6 >>> 0 > 11) {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i2 = i4;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 568) | 0;
   i3 = gb + 64016 | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i8;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = gb + 63160 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } else {
  i1 = 0;
  i2 = i4;
 } while (0);
 i4 = i1 + 3 & -4;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 4 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i7 * 20 | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 571) | 0;
   i2 = gb + 64016 | 0;
   i16 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   i3 = i5;
   HEAP32[i3 >> 2] = i16;
   HEAP32[i3 + 4 >> 2] = i2;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 if (i6 | 0) {
  i1 = 0;
  i2 = 0;
  while (1) {
   HEAP32[i4 + (i1 << 3) >> 2] = fb + 3714;
   HEAP32[i4 + (i1 << 3) + 4 >> 2] = i3 + (i1 * 20 | 0);
   HEAP32[i3 + (i1 * 20 | 0) >> 2] = i9;
   HEAP32[i3 + (i1 * 20 | 0) + 4 >> 2] = i2;
   HEAP32[i3 + (i1 * 20 | 0) + 8 >> 2] = i14;
   HEAP32[i3 + (i1 * 20 | 0) + 12 >> 2] = i6;
   HEAP32[i3 + (i1 * 20 | 0) + 16 >> 2] = i10;
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i1 = i1 + 1 | 0;
  }
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i13, i4, i7, 0);
 if (!(HEAP32[i13 >> 2] | 0)) {
  i16 = HEAP32[i12 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
  i16 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
  STACKTOP = i15;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i13);
 i16 = HEAP32[i12 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i5);
 i16 = HEAP32[i11 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu5Debug9visualizeERKNS_13PxBoxGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i16, i17, i15, i11, i10, i1, f2, i3) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, f19 = f0, f20 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i12 = i14;
 do if ((i10 & 1073741824 | 0) == 0 & 0 == 0) if ((i10 & 8192 | 0) == 0 & 0 == 0) {
  STACKTOP = i14;
  return;
 } else {
  i6 = i16 + 8 | 0;
  i5 = i16 + 12 | 0;
  i4 = HEAP32[i15 + 36 >> 2] | 0;
  i3 = HEAP32[i15 + 40 >> 2] | 0;
  i1 = HEAP32[i15 + 44 >> 2] | 0;
  break;
 } else {
  f19 = Math_fround(HEAPF32[i15 + 36 >> 2]);
  f2 = Math_fround(HEAPF32[i15 + 40 >> 2]);
  f7 = Math_fround(HEAPF32[i15 + 44 >> 2]);
  i6 = i16 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i5 = i16 + 12 | 0;
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  i18 = f19 > Math_fround(HEAPF32[i11 + 12 >> 2]);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  if (i18) {
   STACKTOP = i14;
   return;
  }
  f19 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  if (Math_fround(HEAPF32[i11 >> 2]) > f19) {
   STACKTOP = i14;
   return;
  }
  if (f2 > Math_fround(HEAPF32[i11 + 16 >> 2])) {
   STACKTOP = i14;
   return;
  }
  if (Math_fround(HEAPF32[i11 + 4 >> 2]) > f8) {
   STACKTOP = i14;
   return;
  }
  if (f7 > Math_fround(HEAPF32[i11 + 20 >> 2])) {
   STACKTOP = i14;
   return;
  }
  if ((i10 & 8192 | 0) == 0 & 0 == 0 | Math_fround(HEAPF32[i11 + 8 >> 2]) > f9) {
   STACKTOP = i14;
   return;
  }
 } while (0);
 i11 = HEAP32[i15 + 4 >> 2] | 0;
 i18 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i18;
 HEAP32[i13 + 12 >> 2] = 0;
 i18 = HEAP32[i15 + 16 >> 2] | 0;
 i11 = HEAP32[i15 + 20 >> 2] | 0;
 HEAP32[i13 + 16 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i13 + 20 >> 2] = i18;
 HEAP32[i13 + 24 >> 2] = i11;
 HEAP32[i13 + 28 >> 2] = 0;
 i11 = HEAP32[i15 + 28 >> 2] | 0;
 i18 = HEAP32[i15 + 32 >> 2] | 0;
 HEAP32[i13 + 32 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i13 + 36 >> 2] = i11;
 HEAP32[i13 + 40 >> 2] = i18;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = i4;
 HEAP32[i13 + 52 >> 2] = i3;
 HEAP32[i13 + 56 >> 2] = i1;
 HEAP32[i13 + 60 >> 2] = 0;
 i18 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i17, -65281) | 0, i13) | 0;
 f8 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f20 = Math_fround(-f8);
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f2 = Math_fround(-f9);
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(-f19);
 HEAPF32[i12 >> 2] = f20;
 HEAPF32[i12 + 4 >> 2] = f2;
 HEAPF32[i12 + 8 >> 2] = f7;
 HEAPF32[i12 + 12 >> 2] = f8;
 HEAPF32[i12 + 16 >> 2] = f9;
 HEAPF32[i12 + 20 >> 2] = f19;
 HEAP8[i12 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i18, i12) | 0;
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu21closestPtPointSegmentERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_(i14, i13, i1, i9, i10, i11, i12, i17, i15, i16) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f4 = Math_fround(HEAPF32[i13 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 - f4);
 f6 = Math_fround(f6 - f7);
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f8);
 f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f2 * f2));
 if (f3 == Math_fround(0.0)) {
  HEAP32[i17 >> 2] = 1;
  HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  return;
 } else {
  f2 = Math_fround(Math_fround(Math_fround(-Math_fround(f7 * f6)) - Math_fround(f4 * f5)) - Math_fround(f8 * f2));
  f5 = Math_fround(HEAPF32[i10 >> 2]);
  f22 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f24 = Math_fround(HEAPF32[i9 >> 2]);
  f23 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f21 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f5 = Math_fround(f5 - f24);
  f22 = Math_fround(f22 - f23);
  f4 = Math_fround(f4 - f21);
  f6 = Math_fround(HEAPF32[i12 >> 2]);
  f7 = Math_fround(HEAPF32[i12 + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i12 + 8 >> 2]);
  f20 = Math_fround(HEAPF32[i11 >> 2]);
  f19 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f6 = Math_fround(f6 - f20);
  f7 = Math_fround(f7 - f19);
  f18 = Math_fround(f18 - f8);
  f2 = Math_fround(f2 / f3);
  i17 = f2 > Math_fround(1.0);
  f2 = i17 ? Math_fround(1.0) : f2;
  i17 = f2 > Math_fround(0.0);
  f2 = i17 ? f2 : Math_fround(0.0);
  f5 = Math_fround(f24 + Math_fround(f5 * f2));
  f3 = Math_fround(f23 + Math_fround(f22 * f2));
  f4 = Math_fround(f21 + Math_fround(f4 * f2));
  f6 = Math_fround(f20 + Math_fround(f6 * f2));
  f7 = Math_fround(f19 + Math_fround(f7 * f2));
  f8 = Math_fround(Math_fround(f18 * f2) + f8);
  HEAPF32[i15 >> 2] = f5;
  HEAPF32[i15 + 4 >> 2] = f3;
  HEAPF32[i15 + 8 >> 2] = f4;
  HEAPF32[i15 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i16 >> 2] = f6;
  HEAPF32[i16 + 4 >> 2] = f7;
  HEAPF32[i16 + 8 >> 2] = f8;
  HEAPF32[i16 + 12 >> 2] = Math_fround(0.0);
  f7 = Math_fround(f3 - f7);
  f8 = Math_fround(f4 - f8);
  HEAPF32[i14 >> 2] = Math_fround(f5 - f6);
  HEAPF32[i14 + 4 >> 2] = f7;
  HEAPF32[i14 + 8 >> 2] = f8;
  HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 12 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 12 | 0, 4) | 0;
  i2 = i4 + (i1 * 12 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906560 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906560 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 8 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 * 24 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 24 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  break;
 } while (0);
 i9 = i1 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034406 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i9 | 0)) break L17;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034406 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN9CGProgram12SetCGProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i11 = i12;
 i8 = i9 + 64 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 i5 = i8 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i9 + 72 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i4 >>> 0 > i3 >>> 0) {
  if (i2) i1 = HEAP32[i9 + 68 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i4 - i3 | 0, i1, 0, i1, i4, i6);
  i2 = HEAP8[i5 >> 0] | 0;
  i7 = 16;
 } else {
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i9 + 68 >> 2] = i4;
   i2 = i11;
   i4 = i10;
   i1 = i9 + 80 | 0;
   i7 = 17;
   break;
  } else {
   i2 = i4 & 255;
   HEAP8[i5 >> 0] = i2;
   i7 = 16;
   break;
  }
 } while (0);
 if ((i7 | 0) == 16) {
  i1 = i9 + 80 | 0;
  if (i2 << 24 >> 24 < 0) {
   i2 = i11;
   i4 = i10;
   i7 = 17;
  } else {
   i6 = i11;
   i5 = i8;
   i3 = i2 & 255;
   i2 = i10;
  }
 }
 if ((i7 | 0) == 17) {
  i6 = i2;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 + 68 >> 2] | 0;
  i2 = i4;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i5, i3);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i10, i11);
 i7 = HEAP8[i10 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i10 >> 2] | 0 : i2;
 i7 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i9 + 88 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i9 + 84 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i12;
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i9 + 84 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i4 >> 0] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i12;
  return;
 }
}

function __ZN22UnityAnalyticsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i1 = i8 + 8 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 10 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i8 + 12 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i8 + 16 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i8 + 28 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 32 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (!i9) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i13;
 return;
}

function __ZN14HeightMeshData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 32 | 0;
 i6 = i3;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843803 | 0, i9, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843814 | 0, i9, i1 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898103 | 0, gb + 1034406 | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i10, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843824 | 0, i9, i1 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 843832 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 843849 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i6 + 12 | 0, gb + 843853 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085953 | 0, i7, i6 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1086007 | 0, i7, i6 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN18GfxFramebufferGLESC2ER7ApiGLESPv(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = i7 + 4;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 168 >> 2] = 0;
 HEAP32[i7 + 172 >> 2] = -1;
 i4 = i7 + 176 | 0;
 HEAP32[i7 + 288 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 0;
 HEAP32[i7 + 292 >> 2] = -1;
 i4 = i7 + 296 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 0;
 HEAP8[i7 + 329 >> 0] = 1;
 HEAP32[i7 + 332 >> 2] = i2;
 HEAP32[i7 + 336 >> 2] = i1;
 i1 = i7 + 380 | 0;
 i4 = i7 + 340 | 0;
 i5 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = -1;
 i2 = i7 + 384 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i7 + 432 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 + 480 >> 2] = 0;
 HEAP32[i7 + 492 >> 2] = 0;
 HEAP32[i7 + 496 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i1 = i6;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i7 + 484 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i7 + 500 >> 2] = 0;
 HEAP32[i7 + 512 >> 2] = 0;
 HEAP32[i7 + 516 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i7 + 504 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i7 + 520 >> 0] = 0;
 i4 = i7 + 20 | 0;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 i1 = i7 + 16 | 0;
 i4 = i2;
 i5 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = i2;
 HEAP32[i7 + 48 >> 2] = i3;
 HEAP32[i7 + 52 >> 2] = 1;
 HEAP8[i7 + 72 >> 0] = 0;
 HEAP8[i7 + 80 >> 0] = 0;
 HEAP8[i7 + 88 >> 0] = 0;
 HEAP8[i7 + 89 >> 0] = 0;
 HEAP32[i7 + 60 >> 2] = -1;
 HEAP32[i7 + 56 >> 2] = 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i4 = i7 + 96 | 0;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i7 + 92 >> 2] = i2;
 HEAP32[i7 + 124 >> 2] = i3;
 HEAP32[i7 + 128 >> 2] = 1;
 HEAP8[i7 + 148 >> 0] = 0;
 HEAP8[i7 + 156 >> 0] = 0;
 HEAP8[i7 + 164 >> 0] = 0;
 HEAP8[i7 + 165 >> 0] = 0;
 HEAP32[i7 + 136 >> 2] = -1;
 HEAP32[i7 + 132 >> 2] = 0;
 HEAP32[i7 + 144 >> 2] = 0;
 i4 = i7 + 216 | 0;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i7 + 212 >> 2] = i2;
 HEAP32[i7 + 244 >> 2] = i3;
 HEAP32[i7 + 248 >> 2] = 1;
 HEAP8[i7 + 268 >> 0] = 0;
 HEAP8[i7 + 276 >> 0] = 0;
 HEAP8[i7 + 284 >> 0] = 0;
 HEAP8[i7 + 285 >> 0] = 0;
 HEAP32[i7 + 256 >> 2] = -1;
 HEAP32[i7 + 252 >> 2] = 0;
 HEAP32[i7 + 264 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i15, i10, f16) {
 i15 = i15 | 0;
 i10 = i10 | 0;
 f16 = Math_fround(f16);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i3 = HEAP32[i10 + 68 >> 2] | 0;
 i17 = i15 + 224 | 0;
 HEAP32[i17 >> 2] = 1;
 i1 = i15 + 192 | 0;
 _memset(i15 | 0, 0, 224) | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.00999999);
 switch (i3 | 0) {
 case 1:
  {
   HEAPF32[i15 + 12 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i10 + 56 >> 2] | 0) + 4 >> 2]) * f16);
   STACKTOP = i18;
   return 1;
  }
 case 0:
  {
   STACKTOP = i18;
   return 1;
  }
 default:
  {
   i14 = i3 + -1 | 0;
   HEAP32[i17 >> 2] = i14;
   i11 = i10 + 56 | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   if (Math_fround(HEAPF32[i2 >> 2]) != Math_fround(0.0)) {
    HEAP32[i15 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i13 = 1;
   } else i13 = 0;
   if ((i3 | 0) > 1) {
    i4 = i12 + 4 | 0;
    i5 = i12 + 8 | 0;
    i6 = i12 + 12 | 0;
    i7 = i12 + 16 | 0;
    i8 = i12 + 20 | 0;
    i9 = i12 + 24 | 0;
    i3 = 0;
    do {
     HEAPF32[i4 >> 2] = Math_fround(inf);
     HEAP32[i12 >> 2] = 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i5 + 4 >> 2] = 0;
     HEAP32[i5 + 8 >> 2] = 0;
     HEAP32[i5 + 12 >> 2] = 0;
     HEAP32[i5 + 16 >> 2] = 0;
     i1 = i3;
     i3 = i3 + 1 | 0;
     __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i10, i12, i1, i3, Math_fround(0.0));
     i1 = i1 + i13 | 0;
     i20 = HEAP32[i7 >> 2] | 0;
     i19 = HEAP32[i8 >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     HEAP32[i15 + (i1 << 4) >> 2] = HEAP32[i6 >> 2];
     HEAP32[i15 + (i1 << 4) + 4 >> 2] = i20;
     HEAP32[i15 + (i1 << 4) + 8 >> 2] = i19;
     HEAP32[i15 + (i1 << 4) + 12 >> 2] = i2;
     i2 = HEAP32[i11 >> 2] | 0;
     HEAP32[i15 + 192 + (i1 << 2) >> 2] = HEAP32[i2 + (i3 << 4) >> 2];
     i1 = HEAP32[i17 >> 2] | 0;
    } while ((i3 | 0) < (i1 | 0));
   } else i1 = i14;
   i1 = i1 + i13 | 0;
   HEAP32[i17 >> 2] = i1;
   if (Math_fround(HEAPF32[i2 + (i14 << 4) >> 2]) != Math_fround(1.0)) {
    HEAP32[i15 + (i1 << 4) + 12 >> 2] = HEAP32[i2 + (i14 << 4) + 4 >> 2];
    i1 = i1 + 1 | 0;
    HEAP32[i17 >> 2] = i1;
   }
   HEAPF32[i15 + 192 + (i1 + -1 << 2) >> 2] = Math_fround(1.00999999);
   if ((HEAP32[i17 >> 2] | 0) > 0) i1 = 0; else {
    STACKTOP = i18;
    return 1;
   }
   do {
    i13 = i15 + (i1 << 4) | 0;
    f24 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * f16);
    i14 = i15 + (i1 << 4) + 4 | 0;
    f23 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) * f16);
    i19 = i15 + (i1 << 4) + 8 | 0;
    f22 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) * f16);
    i20 = i15 + (i1 << 4) + 12 | 0;
    f21 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) * f16);
    HEAPF32[i13 >> 2] = f24;
    HEAPF32[i14 >> 2] = f23;
    HEAPF32[i19 >> 2] = f22;
    HEAPF32[i20 >> 2] = f21;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i17 >> 2] | 0));
   STACKTOP = i18;
   return 1;
  }
 }
 return 0;
}

function __Z35AllocExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei(i6, i1, i2, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i7 + 104 | 0;
 if ((i1 | 0) == 2) {
  i5 = (i2 | 0) == 0;
  i1 = __Z23GetCoreScriptingClassesv() | 0;
  i1 = i5 ? HEAP32[i1 + 120 >> 2] | 0 : HEAP32[i1 + 124 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 100 >> 2] | 0;
  if (i5) {
   i5 = __Z19scripting_array_newP11Il2CppClassjj(i1, 16, i2) | 0;
   __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf(i6, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 16) | 0);
   i6 = i5;
   STACKTOP = i7;
   return i6 | 0;
  } else {
   i5 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, i2) | 0;
   __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32(i6, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 4) | 0);
   i6 = i5;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 switch (i3 | 0) {
 case 2:
  {
   i3 = i6 + 32 | 0;
   i6 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0, 8, HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0) | 0;
   i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 8) | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i4);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i5 + 1 >> 0] = 2;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i8, i2, i1, i5);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i2, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i3 >> 2] | 0) + 8 | 0, i4);
   STACKTOP = i7;
   return i6 | 0;
  }
 case 3:
  {
   i6 = i6 + 32 | 0;
   i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0, 12, HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0) | 0;
   i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 12) | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i4);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i5 + 1 >> 0] = 3;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i2, i3, i1, i5);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i3, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + 8 | 0, i4);
   STACKTOP = i7;
   return i8 | 0;
  }
 case 4:
  {
   i6 = i6 + 32 | 0;
   i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 460 >> 2] | 0, 16, HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0) | 0;
   i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 16) | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i4);
   HEAP8[i5 >> 0] = 0;
   HEAP8[i5 + 1 >> 0] = 4;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i2, i3, i1, i5);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i3, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i6 >> 2] | 0) + 8 | 0, i4);
   STACKTOP = i7;
   return i8 | 0;
  }
 default:
  {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i6, i2, i10) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i2;
 i5 = (i10 - i3 | 0) / 44 | 0;
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = i8;
 if (i5 >>> 0 <= ((i1 - i8 | 0) / 44 | 0) >>> 0) {
  i6 = i6 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i8 | 0) / 44 | 0;
  i5 = i5 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 44 | 0) | 0;
  i4 = i5 ? i1 : i10;
  i3 = i4 - i3 | 0;
  if (i3 | 0) _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i7 + (((i3 | 0) / 44 | 0) * 44 | 0) | 0;
  if (!i5) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0);
   return;
  }
  if ((i4 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i7 = i1;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i2;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   i1 = i1 + 44 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 44 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 i4 = i8;
 if (i8) {
  i1 = i6 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -44 - i8 | 0) >>> 0) / 44 | 0) * 44 | 0);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
 }
 if (i5 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 44 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 48806446 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 97612893;
 if (i3 >>> 0 > 97612893) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i1 = __Znwj(i3 * 44 | 0) | 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + (i3 * 44 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  i7 = i2;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
  i2 = i2 + 44 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 44 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZN21AssetBundleFileSystemC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 24 | 0;
 i4 = i7 + 12 | 0;
 i5 = i7;
 HEAP32[i1 >> 2] = gb + 73776 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP8[i1 + 13 >> 0] = 0;
 i6 = i1 + 16 | 0;
 i8 = i6 + 52 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 i6 = i1 + 68 | 0;
 HEAP32[i6 >> 2] = 32;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f9 = Math_fround((HEAP32[i6 >> 2] | 0) >>> 0);
 HEAP32[i1 + 80 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i1 + 76 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i1 + 84 >> 0] = 0;
 i6 = i1 + 92 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1 + 96 | 0, i2, _strlen(i2) | 0);
 HEAP8[i1 + 108 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1576256 | 0, 0);
 i6 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i5);
 i8 = i3 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i4);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13set_empty_keyERKS9_(i6, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 585748 | 0, 2);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i5);
 i8 = i3 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i4);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15set_deleted_keyERKS9_(i6, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i7;
 return;
}

function __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i11, i3) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i8 = i12;
 i6 = i12 + 24 | 0;
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[i3 >> 2] | 0;
 if (!(i7 & 1)) {
  i6 = i3 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i4 = i3 + 24 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
   i1 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = i2;
   i5 = i2;
  }
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = i5 + 8 | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 8);
   i5 = i10 + 4 | 0;
   i2 = i10;
   i3 = i5;
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i10;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i5;
   HEAP32[i6 >> 2] = i2;
   i2 = i10;
   i3 = i10 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = _llvm_bswap_i32(i5 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  i7 = i10;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i5 = i3 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i3 = i3 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 }
 HEAP32[i8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 8 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 8);
  i4 = i10 + 4 | 0;
  i1 = i10;
  i2 = i4;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i10;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
  i1 = i10;
  i2 = i10 + 4 | 0;
 }
 i5 = _llvm_bswap_i32(i3 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i2 >> 2] = i5;
 i4 = i10;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!(i7 & 8388608)) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function _UNITY_png_write_info(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 if ((i7 | 0) == 0 | (i6 | 0) == 0) return;
 _UNITY_png_write_info_before_PLTE(i7, i6);
 i5 = i6 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!(i2 & 8)) if ((HEAP8[i6 + 25 >> 0] | 0) == 3) _UNITY_png_error(i7, gb + 355313 | 0); else i1 = i2; else {
  _UNITY_png_write_PLTE(i7, HEAP32[i6 + 16 >> 2] | 0, HEAPU16[i6 + 20 >> 1] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 16) {
  i2 = i6 + 25 | 0;
  if (HEAP32[i7 + 212 >> 2] & 524288 | 0) if ((HEAP8[i2 >> 0] | 0) == 3) {
   i3 = i6 + 22 | 0;
   if (HEAP16[i3 >> 1] | 0) {
    i4 = i6 + 148 | 0;
    i1 = 0;
    do {
     i8 = (HEAP32[i4 >> 2] | 0) + i1 | 0;
     HEAP8[i8 >> 0] = HEAPU8[i8 >> 0] ^ 255;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAPU16[i3 >> 1] | 0));
   }
  }
  _UNITY_png_write_tRNS(i7, HEAP32[i6 + 148 >> 2] | 0, i6 + 152 | 0, HEAPU16[i6 + 22 >> 1] | 0, HEAPU8[i2 >> 0] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 32) {
  _UNITY_png_write_bKGD(i7, i6 + 162 | 0, HEAPU8[i6 + 25 >> 0] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 256) {
  _UNITY_png_write_oFFs(i7, HEAP32[i6 + 172 >> 2] | 0, HEAP32[i6 + 176 >> 2] | 0, HEAPU8[i6 + 180 >> 0] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 1024) {
  i1 = HEAP16[i6 + 216 >> 1] | 0;
  _UNITY_png_write_pCAL(i7, HEAP32[i6 + 196 >> 2] | 0, HEAP32[i6 + 200 >> 2] | 0, HEAP32[i6 + 204 >> 2] | 0, i1 & 255, (i1 & 65535) >>> 8 & 65535, HEAP32[i6 + 208 >> 2] | 0, HEAP32[i6 + 212 >> 2] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 16384) {
  _UNITY_png_write_sCAL_s(i7, HEAPU8[i6 + 232 >> 0] | 0, HEAP32[i6 + 236 >> 2] | 0, HEAP32[i6 + 240 >> 2] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 128) {
  _UNITY_png_write_pHYs(i7, HEAP32[i6 + 184 >> 2] | 0, HEAP32[i6 + 188 >> 2] | 0, HEAPU8[i6 + 192 >> 0] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 8192 | 0) {
  i2 = i6 + 228 | 0;
  if ((HEAP32[i2 >> 2] | 0) > 0) {
   i3 = i6 + 224 | 0;
   i1 = 0;
   do {
    _UNITY_png_write_sPLT(i7, (HEAP32[i3 >> 2] | 0) + (i1 << 4) | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
  }
 }
 i5 = i6 + 128 | 0;
 if ((HEAP32[i5 >> 2] | 0) <= 0) return;
 i4 = i6 + 136 | 0;
 i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do {
  i2 = HEAP32[i1 + (i3 * 28 | 0) >> 2] | 0;
  L45 : do if ((i2 | 0) > 0) {
   _UNITY_png_write_iTXt(i7, i2, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 20 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 24 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0);
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + (i3 * 28 | 0) >> 2] = -3;
  } else switch (i2 | 0) {
  case 0:
   {
    _UNITY_png_write_zTXt(i7, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0, 0, 0);
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 * 28 | 0) >> 2] = -2;
    break L45;
   }
  case -1:
   {
    _UNITY_png_write_tEXt(i7, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0, 0);
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i1 + (i3 * 28 | 0) >> 2] = -3;
    break L45;
   }
  default:
   break L45;
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (((i4 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i12 = i1 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 24 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 24 | 0) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i8 = (i4 - i7 | 0) / 24 | 0;
 i5 = i8 << 1;
 i5 = i8 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 24 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (((i1 - i7 | 0) / 24 | 0) * 24 | 0) | 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i3 + (i5 * 24 | 0);
 do {
  i9 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i10, i11);
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1 + -24 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -20 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i13;
 return;
}

function __ZNK11UnityEngine9Animation28GenericAnimationBindingCache20CreateGenericBindingERK8UnityStri4PPtrI10MonoScriptES4_bRNS0_14GenericBindingE(i13, i1, i11, i4, i14, i15, i16) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i12 = _strlen(i1) | 0;
 i3 = i1 + i12 | 0;
 if ((i12 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 HEAP32[i16 >> 2] = i1;
 i1 = (HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14;
 i12 = _strlen(i1) | 0;
 i3 = i1 + i12 | 0;
 if ((i12 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 i2 = i16 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP16[i16 + 12 >> 1] = i11;
 i12 = i16 + 14 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i16 + 15 >> 0] = i15 & 1;
 HEAP32[i16 + 8 >> 2] = HEAP32[i4 >> 2];
 if ((i11 | 0) == 95 & (i15 ^ 1)) {
  i1 = __ZN7mecanim9animation15FindMuscleIndexEj(i1) | 0;
  if ((i1 | 0) != -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP8[i12 >> 0] = 8;
   return;
  }
 }
 if ((i11 | 0) <= -1) return;
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) < (i11 | 0)) return;
 i9 = i13 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) return;
 i10 = i13 + 20 | 0;
 i8 = i11 + -1e5 | 0;
 L25 : do if ((i11 | 0) > 99999) {
  i7 = 0;
  i4 = i1;
  while (1) {
   i3 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i3 + (i7 << 3) + 4 >> 2] | 0;
   i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i3 + (i7 << 3) >> 2] | 0;
   i6 = HEAP32[i4 + 24 >> 2] | 0;
   if ((i3 | 0) > 99999) i3 = i6 + (i3 + -1e5 << 3) | 0; else i3 = (HEAP32[i4 + 4 >> 2] | 0) + (i3 << 3) | 0;
   if (((HEAP32[i6 + (i8 << 3) >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
    if (mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i14 | 0, i15 | 0, i16 | 0) | 0) break L25;
    i2 = HEAP32[i9 >> 2] | 0;
   }
   i1 = i7 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break;
   i7 = i1;
   i4 = HEAP32[gb + 1110260 >> 2] | 0;
  }
  return;
 } else {
  i7 = 0;
  i6 = i1;
  while (1) {
   i3 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i3 + (i7 << 3) + 4 >> 2] | 0;
   i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i3 + (i7 << 3) >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i3 | 0) > 99999) i3 = (HEAP32[i6 + 24 >> 2] | 0) + (i3 + -1e5 << 3) | 0; else i3 = i5 + (i3 << 3) | 0;
   if (((HEAP32[i5 + (i11 << 3) >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
    if (mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, i14 | 0, i15 | 0, i16 | 0) | 0) break L25;
    i2 = HEAP32[i9 >> 2] | 0;
   }
   i1 = i7 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break;
   i7 = i1;
   i6 = HEAP32[gb + 1110260 >> 2] | 0;
  }
  return;
 } while (0);
 HEAP8[i12 >> 0] = i1;
 return;
}

function __ZN6Camera19UpdateDepthTexturesERK11CullResultsRK19SharedRendererSceneNS_10RenderFlagE(i14, i12, i13, i1) {
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, f16 = f0;
 i10 = HEAP32[gb + 1166248 >> 2] | 0;
 i11 = i10 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -1048577;
 i8 = i14 + 1088 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  i9 = __Z18GetQualitySettingsv() | 0;
  i9 = (HEAP8[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 80 >> 0] | 0) == 0;
 } else i9 = 1;
 i1 = HEAP32[i14 + 1072 >> 2] | 0;
 i7 = (__ZNK6Camera22CalculateRenderingPathEv(i14) | 0 | 1 | 0) == 3;
 i6 = i7 ^ 1;
 if (!(i9 | i6)) HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1048576;
 i5 = i1 | 1;
 i4 = i7 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) == 0;
 i1 = i4 ? i5 : i1;
 i4 = HEAP32[i12 + 1360 >> 2] | 0;
 if (!i4) i4 = 0; else i4 = (HEAP8[(HEAP32[i4 + 32 >> 2] | 0) + 68 >> 0] | 0) == 0;
 if (!i7) {
  i15 = __Z21GetManagerFromContexti(6) | 0;
  if (!(i4 | (HEAP8[i15 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) + 4 >> 0] | 0) == 0)) {
   i4 = (HEAP8[i12 + 356 >> 0] | 0) == 0;
   i15 = __Z16ShouldUseShadowsb(1) | 0;
   i1 = i4 ? i1 : i15 ? i5 : i1;
  }
 }
 if (!((i1 & 1 | 0) == 0 | i6)) {
  i15 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 506 >> 0] | 0) == 0;
  i1 = i15 ? i1 : i1 & -2;
 }
 i4 = (i1 & 2 | 0) == 0 ? i1 : i7 ? i1 & -3 : i1;
 if (!i4) return;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 234 >> 0] | 0)) return;
 f2 = Math_fround(HEAPF32[i14 + 872 >> 2]);
 if (f2 <= Math_fround(9.99999974e-06)) return;
 f3 = Math_fround(HEAPF32[i14 + 876 >> 2]);
 if (f3 <= Math_fround(9.99999974e-06)) return;
 f16 = Math_fround(HEAPF32[i14 + 864 >> 2]);
 if (!(!(f16 >= Math_fround(1.0)) & !(Math_fround(f2 + f16) <= Math_fround(0.0)))) return;
 f16 = Math_fround(HEAPF32[i14 + 868 >> 2]);
 if (!(!(f16 >= Math_fround(1.0)) & !(Math_fround(f3 + f16) <= Math_fround(0.0)))) return;
 f16 = Math_fround(HEAPF32[i14 + 924 >> 2]);
 f2 = Math_fround(HEAPF32[i14 + 920 >> 2]);
 if (f16 <= f2) return;
 if (!(HEAP8[i8 >> 0] | 0)) {
  if (f2 <= Math_fround(0.0)) return;
  f16 = Math_fround(HEAPF32[i14 + 292 >> 2]);
  i15 = f16 < Math_fround(0.0);
  f3 = Math_fround(-f16);
  if ((i15 ? f3 : f16) < Math_fround(9.99999997e-07)) return;
 } else {
  f16 = Math_fround(HEAPF32[i14 + 916 >> 2]);
  i15 = f16 < Math_fround(0.0);
  f3 = Math_fround(-f16);
  if ((i15 ? f3 : f16) < Math_fround(9.99999997e-07)) return;
 }
 i1 = (i4 & 1 | 0) == 0;
 if (!(i9 | i1)) HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1048576;
 if (!i1) __ZN6Camera18RenderDepthTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE(i14, i12, i13, i10, 0);
 if (i4 & 2 | 0) __ZN6Camera25RenderDepthNormalsTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE(i14, 0, i13, i10, 0);
 i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
 if (i1 >>> 0 >= 10) return;
 if ((i4 & 3 | 0) == 0 | (521 >>> (i1 & 1023) & 1) == 0) return;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(HEAP32[i14 + 1144 >> 2] | 0, 0, -1, 0, 0);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 8 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 << 4, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  break;
 } while (0);
 i9 = i1 + (HEAP32[i5 >> 2] << 4) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i3 = HEAP32[gb + 37328 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L17;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10ReallocateEPvji(i11, i7, i13, i6) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 if (!i7) {
  i13 = mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i13 | 0, i6 | 0) | 0;
  return i13 | 0;
 }
 if (!i13) {
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i7 | 0);
  i13 = 0;
  return i13 | 0;
 }
 i12 = i11 + 57 | 0;
 i1 = HEAP32[i11 + 44 >> 2] | 0;
 i4 = i11 + 40 | 0;
 i2 = i1;
 L12 : do if ((i2 | 0) == (i4 | 0)) i5 = 11; else while (1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if (i3 >>> 0 <= i7 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) {
   i5 = 15;
   break L12;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) {
   i5 = 11;
   break;
  }
 } while (0);
 L18 : do if ((i5 | 0) == 11) {
  i1 = HEAP32[i11 + 52 >> 2] | 0;
  i4 = i11 + 48 | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) i5 = 33; else while (1) {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i7 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) {
    i5 = 15;
    break L18;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i4 | 0)) {
    i5 = 33;
    break;
   }
  }
 } while (0);
 do if ((i5 | 0) == 15) {
  i3 = i7 + -8 | 0;
  if (!(HEAP32[i3 >> 2] & 1)) {
   i2 = 0;
   i4 = i3;
  } else {
   i4 = HEAP32[i7 + -12 >> 2] | 0;
   i2 = i4;
   i4 = i3 + (0 - i4) | 0;
  }
  i2 = (_tlsf_block_size(i3 + (0 - i2) | 0) | 0) + -8 | 0;
  if (!(HEAP32[i3 >> 2] & 1)) i10 = 0; else {
   i10 = HEAP32[i7 + -12 >> 2] | 0;
   i2 = i2 - i10 | 0;
  }
  i9 = _tlsf_realloc_align(HEAP32[i1 + 8 >> 2] | 0, i4, i6, i13 + 7 + i6 | 0) | 0;
  if (!i9) if (!i2) {
   i5 = 33;
   break;
  } else break;
  i7 = -8 - i9 & i6 + -1;
  i8 = i9 + i7 | 0;
  if (!i7) {
   HEAP32[i8 >> 2] = i13 << 1;
   i3 = i8;
   i1 = 0;
  } else {
   _memset(i9 | 0, -86, i7 | 0) | 0;
   HEAP32[i8 + -4 >> 2] = i7;
   HEAP32[i8 >> 2] = i13 << 1 | 1;
   i3 = i8;
   i1 = i7;
  }
  i4 = (_tlsf_block_size(i8 + (0 - i1) | 0) | 0) + -8 | 0;
  if (!(HEAP32[i3 >> 2] & 1)) i1 = 0; else i1 = HEAP32[i8 + -4 >> 2] | 0;
  i6 = i11 + 16 | 0;
  i4 = i4 - i1 + (HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i4;
  i5 = i11 + 28 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 + 23;
  i3 = i11 + 24 | 0;
  if (i4 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) HEAP32[i3 >> 2] = i4;
  i11 = i11 + 12 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = i4 - i2;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
  if ((i7 | 0) != (i10 | 0)) {
   i11 = i9 + 8 | 0;
   _memmove(i11 + i7 | 0, i11 + i10 | 0, (i2 >>> 0 > i13 >>> 0 ? i13 : i2) | 0) | 0;
  }
  i13 = i8 + 8 | 0;
  return i13 | 0;
 } while (0);
 if ((i5 | 0) == 33) i2 = (HEAP32[i7 + -8 >> 2] | 0) >>> 1;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i13 | 0, i6 | 0) | 0;
 if (i1 | 0) _memcpy(i1 | 0, i7 | 0, (i2 >>> 0 > i13 >>> 0 ? i13 : i2) | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i7 | 0);
 if (!(HEAP8[i12 >> 0] | 0)) {
  i13 = i1;
  return i13 | 0;
 }
 i13 = i1;
 return i13 | 0;
}

function __ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(i13, i6, i2, i3, f1, i5) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i5 = i5 | 0;
 var i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i2) i2 = HEAP32[(HEAP32[i13 + 76 >> 2] | 0) + 36 >> 2] | 0;
 i2 = (i2 | 0) > 500 ? 500 : i2;
 i4 = i13 + 32 | 0;
 L4 : do if ((HEAP32[i4 >> 2] | 0) == -2) i12 = 12; else {
  if ((i2 | 0) == (HEAP32[(HEAP32[i13 + 76 >> 2] | 0) + 36 >> 2] | 0)) i12 = 7; else if (!i5) i2 = 0; else {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1;
   i2 = 0;
   i12 = 7;
  }
  if ((i12 | 0) == 7) if (!((i3 | 0) == 0 | (i5 | 0) == 0)) HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
  switch (HEAP32[i4 >> 2] | 0) {
  case 1:
   {
    i11 = i6 << 24 >> 24;
    i11 = ((((i6 & 255) + -97 & 255) < 26 ? i11 + 224 | 0 : i11) << 24 >> 24) - (HEAP32[i13 + 28 >> 2] | 0) | 0;
    i3 = 0;
    i9 = i2;
    break L4;
   }
  case 2:
   {
    i11 = i6 << 24 >> 24;
    i11 = ((((i6 & 255) + -65 & 255) < 26 ? i11 + 32 | 0 : i11) << 24 >> 24) - (HEAP32[i13 + 28 >> 2] | 0) | 0;
    i3 = 0;
    i9 = i2;
    break L4;
   }
  default:
   {
    i3 = 0;
    i12 = 12;
    break L4;
   }
  }
 } while (0);
 if ((i12 | 0) == 12) {
  i11 = i6 - (HEAP32[i13 + 28 >> 2] | 0) | 0;
  i9 = i2;
 }
 i5 = HEAP32[i13 + 60 >> 2] | 0;
 i10 = HEAP32[i13 + 64 >> 2] | 0;
 i2 = i10 - i5 | 0;
 if (!i2) i4 = i5; else {
  i2 = (i2 | 0) / 60 | 0;
  i4 = i5;
  do {
   i7 = (i2 | 0) / 2 | 0;
   i8 = i5 + (i7 * 60 | 0) | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   do if ((i6 | 0) == (i11 | 0)) {
    i6 = HEAP32[i5 + (i7 * 60 | 0) + 40 >> 2] | 0;
    if ((i6 | 0) != (i9 | 0)) if ((i6 | 0) < (i9 | 0)) {
     i12 = 23;
     break;
    } else {
     i2 = i7;
     break;
    }
    i6 = HEAP32[i5 + (i7 * 60 | 0) + 44 >> 2] | 0;
    if ((i6 | 0) == (i3 | 0)) if (Math_fround(HEAPF32[i5 + (i7 * 60 | 0) + 48 >> 2]) < f1) {
     i12 = 23;
     break;
    } else {
     i2 = i7;
     break;
    } else if (i3 >>> 0 < i6 >>> 0) {
     i12 = 23;
     break;
    } else {
     i2 = i7;
     break;
    }
   } else if (i6 >>> 0 < i11 >>> 0) i12 = 23; else i2 = i7; while (0);
   if ((i12 | 0) == 23) {
    i12 = 0;
    i5 = i8 + 60 | 0;
    i2 = i2 + -1 - i7 | 0;
    i4 = i5;
   }
  } while ((i2 | 0) != 0);
 }
 if ((i4 | 0) == (i10 | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((i11 | 0) == (i2 | 0)) {
  i2 = HEAP32[i4 + 40 >> 2] | 0;
  if ((i9 | 0) != (i2 | 0)) {
   if ((i9 | 0) < (i2 | 0) | (i4 | 0) == (i10 | 0)) f1 = Math_fround(0.0); else break;
   return Math_fround(f1);
  }
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) {
   if ((i4 | 0) == (i10 | 0) ? 1 : Math_fround(HEAPF32[i4 + 48 >> 2]) > f1) f1 = Math_fround(0.0); else break;
   return Math_fround(f1);
  } else {
   if (i2 >>> 0 < i3 >>> 0 | (i4 | 0) == (i10 | 0)) f1 = Math_fround(0.0); else break;
   return Math_fround(f1);
  }
 } else if (i11 >>> 0 < i2 >>> 0 | (i4 | 0) == (i10 | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 } while (0);
 f1 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i13 + 16 >> 2]));
 return Math_fround(f1);
}

function __ZN30AudioEffectInternalDescriptionC2EP20FMOD_DSP_DESCRIPTION(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 HEAP32[i5 + 200 >> 2] = 0;
 i2 = i5;
 i1 = i6;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = i5 + 96 | 0;
 i2 = i1;
 i3 = i2 + 104 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 _strncpy(i5, i6, 32) | 0;
 i9 = i6 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 + 60 >> 2] = i3;
 i7 = i3 * 48 | 0;
 i3 = __Znaj(i3 >>> 0 > 89478485 ? -1 : i7) | 0;
 i10 = i5 + 64 | 0;
 HEAP32[i10 >> 2] = i3;
 _memset(i3 | 0, 0, i7 | 0) | 0;
 HEAP32[i5 + 40 >> 2] = fb + 2472;
 HEAP32[i5 + 44 >> 2] = fb + 2473;
 HEAP32[i5 + 48 >> 2] = fb + 2474;
 HEAP32[i5 + 52 >> 2] = fb + 138;
 HEAP32[i5 + 56 >> 2] = fb + 922;
 HEAP32[i5 + 68 >> 2] = fb + 3;
 HEAP32[i5 + 72 >> 2] = fb + 168;
 HEAP32[i1 >> 2] = 104;
 HEAP32[i5 + 100 >> 2] = 56;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = __Znaj(i1 >>> 0 > 76695844 ? -1 : i1 * 56 | 0) | 0;
 i8 = i5 + 180 | 0;
 HEAP32[i8 >> 2] = i7;
 i6 = i6 + 64 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 _memcpy(i3 | 0, i2 | 0, i1 * 48 | 0) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = 0;
 while (1) {
  HEAP32[i7 + (i1 * 56 | 0) + 44 >> 2] = HEAP32[i2 + (i1 * 48 | 0) + 8 >> 2];
  i5 = (_strlen(HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] | 0) | 0) + 1 | 0;
  i12 = __Znaj(i5) | 0;
  HEAP32[i7 + (i1 * 56 | 0) + 32 >> 2] = i12;
  HEAP32[i3 + (i1 * 48 | 0) + 44 >> 2] = i12;
  i3 = i3 + (i1 * 48 | 0) + 28 | 0;
  if (!(_strcmp(i3, gb + 873132 | 0) | 0)) {
   HEAP8[i3 >> 0] = HEAP8[gb + 873135 >> 0] | 0;
   HEAP8[i3 + 1 >> 0] = HEAP8[gb + 873135 + 1 >> 0] | 0;
   HEAP8[i3 + 2 >> 0] = HEAP8[gb + 873135 + 2 >> 0] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else i3 = i7;
  _strncpy(HEAP32[i3 + (i1 * 56 | 0) + 32 >> 2] | 0, HEAP32[i2 + (i1 * 48 | 0) + 44 >> 2] | 0, i5) | 0;
  _strncpy((HEAP32[i8 >> 2] | 0) + (i1 * 56 | 0) + 16 | 0, (HEAP32[i6 >> 2] | 0) + (i1 * 48 | 0) + 28 | 0, 16) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 + (i1 * 56 | 0) + 36 >> 2] = HEAP32[i2 + (i1 * 48 | 0) >> 2];
  HEAP32[i3 + (i1 * 56 | 0) + 40 >> 2] = HEAP32[i2 + (i1 * 48 | 0) + 4 >> 2];
  _strncpy(i3 + (i1 * 56 | 0) | 0, i2 + (i1 * 48 | 0) + 12 | 0, 16) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + (i1 * 56 | 0) + 16 | 0;
  if (!(_strcmp(i3, gb + 1087751 | 0) | 0)) if (Math_fround(HEAPF32[i2 + (i1 * 56 | 0) + 40 >> 2]) == Math_fround(1.0)) f4 = Math_fround(100.0); else f4 = Math_fround(1.0); else f4 = Math_fround(1.0);
  HEAPF32[i2 + (i1 * 56 | 0) + 48 >> 2] = f4;
  if (!(__Z7StrICmpPKcS0_(i3, gb + 873138 | 0) | 0)) i11 = 11; else if (!(__Z7StrICmpPKcS0_((HEAP32[i8 >> 2] | 0) + (i1 * 56 | 0) + 16 | 0, gb + 873135 | 0) | 0)) i11 = 11; else f4 = Math_fround(1.0);
  if ((i11 | 0) == 11) {
   i11 = 0;
   f4 = Math_fround(3.0);
  }
  i3 = HEAP32[i8 >> 2] | 0;
  HEAPF32[i3 + (i1 * 56 | 0) + 52 >> 2] = f4;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i9 >> 2] | 0)) break;
  i2 = HEAP32[i6 >> 2] | 0;
  i7 = i3;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 return;
}

function __ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i4, i11, i12) {
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i9 = i13;
 i1 = HEAP32[i4 + 372 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i4 + 356 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 156 >> 2] | 0) > 0) {
   i2 = i4 + 396 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i4);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   if ((i1 | 0) == 0 | (HEAP32[gb + 1162104 >> 2] | 0) == 0) {
    i12 = 0;
    STACKTOP = i13;
    return i12 | 0;
   }
   i3 = __ZnwjRK10MemLabelIdiPKci(28, gb + 64024 | 0, 16, gb + 429036 | 0, 351) | 0;
   i2 = i4 + 408 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i4);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = i1;
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 384 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAPU16[i4 + 404 >> 1];
   HEAP32[i3 + 12 >> 2] = i12;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP8[i3 + 20 >> 0] = 1;
   HEAP32[i3 + 24 >> 2] = i11;
   if (!i3) {
    i12 = 0;
    STACKTOP = i13;
    return i12 | 0;
   }
   mftCall_vi(HEAP32[gb + 1162104 >> 2] | 0, i3 | 0);
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 if (!(i1 >>> 0 >= i12 >>> 0 & (i12 | 0) != 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i7 = i4 + 360 | 0;
 i6 = 0;
 i1 = 0;
 do {
  i5 = (HEAP32[i7 >> 2] | 0) + (i6 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (!i2) {
   i2 = i11 + (i6 << 6) | 0;
   i10 = 25;
  } else {
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 20; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i14 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 20; else {
     i3 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i3) i10 = 23; else i1 = i11 + (i6 << 6) | 0;
    }
   }
   if ((i10 | 0) == 20) i10 = 23;
   if ((i10 | 0) == 23) {
    i10 = 0;
    i3 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    i2 = i11 + (i6 << 6) | 0;
    if (!i3) {
     i10 = 25;
     break;
    } else i1 = i2;
   }
   __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i3, i1);
   i1 = 1;
  } while (0);
  if ((i10 | 0) == 25) {
   i10 = 0;
   __ZN10Matrix4x4f11SetIdentityEv(i2) | 0;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i12 | 0));
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 8 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  break;
 } while (0);
 i9 = i1 + (HEAP32[i5 >> 2] << 3) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i3 = HEAP32[gb + 37320 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   L17 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L17;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN11AudioSource9SetVolumeEf(i6, f2) {
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i3 = i7 + 16 | 0;
 i1 = f2 < Math_fround(0.0);
 i8 = f2 > Math_fround(1.0);
 f5 = i8 ? Math_fround(1.0) : f2;
 f5 = i1 ? Math_fround(0.0) : f5;
 i1 = i6 + 412 | 0;
 if (f5 != Math_fround(HEAPF32[i1 >> 2])) HEAPF32[i1 >> 2] = f5;
 i1 = i6 + 544 | 0;
 do if (!(HEAP32[i1 >> 2] | 0)) f2 = Math_fround(1.0); else if (!(HEAP32[i6 + 540 >> 2] | 0)) f2 = Math_fround(1.0); else {
  f2 = Math_fround(Math_fround(__ZNK11AudioSource28CalculateDistanceAttenuationEv(i6)) + Math_fround(-1.0));
  f2 = Math_fround(Math_fround(f2 * Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + 128 >> 2])) + Math_fround(1.0));
  if (HEAP8[i6 + 423 >> 0] | 0) if (!(HEAP8[i6 + 424 >> 0] | 0)) {
   __ZN11AudioSource28SetSpatializePostEffectsGainEf(i6, f2);
   break;
  }
  __ZN11AudioSource28SetSpatializePostEffectsGainEf(i6, Math_fround(1.0));
  f5 = Math_fround(f5 * f2);
  f2 = Math_fround(1.0);
 } while (0);
 i1 = HEAP32[i6 + 488 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD12ChannelGroup19setAudibilityFactorEf(i1, f2) | 0;
  if (i1 | 0) {
   i8 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i4 >> 2] = gb + 855390;
   HEAP32[i4 + 4 >> 2] = 1199;
   HEAP32[i4 + 8 >> 2] = gb + 865798;
   HEAP32[i4 + 12 >> 2] = i8;
   __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  }
 }
 i1 = i6 + 456 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  HEAPF32[i1 + 216 >> 2] = f5;
  __ZN20SoundChannelInstance12UpdateVolumeEv(i1);
 }
 i1 = HEAP32[i6 + 432 >> 2] | 0;
 i6 = i6 + 428 | 0;
 i3 = i1;
 if ((i3 | 0) == (i6 | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if (!i1) {
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
  } else {
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = i1 + 16 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i8 = HEAP32[i4 >> 2] | 0;
    HEAPF32[i8 + 216 >> 2] = f5;
    __ZN20SoundChannelInstance12UpdateVolumeEv(i8);
   }
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
   }
  }
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i6 | 0));
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i6, i2, i8) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i8 - i2 | 0;
 i5 = (i1 | 0) / 132 | 0;
 i7 = i6 + 8 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4;
 if (i5 >>> 0 > (((HEAP32[i7 >> 2] | 0) - i4 | 0) / 132 | 0) >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i6);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i4 = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) / 132 | 0;
  i3 = i4 << 1;
  i3 = i4 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 25;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 132 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i6 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i1 + (i3 * 132 | 0);
  if ((i2 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  do {
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i1, i2);
   i2 = i2 + 132 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 132 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i7 = i6 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i4 | 0) / 132 | 0;
 i5 = i5 >>> 0 > i1 >>> 0;
 i1 = i2 + (i1 * 132 | 0) | 0;
 i4 = i5 ? i1 : i8;
 if ((i4 | 0) != (i2 | 0)) do {
  __ZN13AnimationClip10FloatCurveaSERKS0_(i3, i2) | 0;
  i2 = i2 + 132 | 0;
  i3 = i3 + 132 | 0;
 } while ((i2 | 0) != (i4 | 0));
 if (i5) {
  if ((i4 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i1);
   i1 = i1 + 132 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 132 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = i9 + 4 | 0;
 i6 = i9 + 4 | 0;
 do {
  i4 = i1 + -132 | 0;
  HEAP32[i7 >> 2] = i4;
  i2 = i1 + -36 | 0;
  if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -32 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -116 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i1 + -104 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i5 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i1 + -120 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i10;
 return;
}

function __ZN9AudioClip22GetFormatFromExtensionERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i1);
 i5 = i7 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i6 = i7 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i3 ? i1 : i2 & 255) | 0) {
  i3 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
  do {
   i9 = HEAP8[i3 >> 0] | 0;
   i2 = i9 << 24 >> 24;
   HEAP8[i3 >> 0] = (i9 + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i5 >> 0] | 0;
   i9 = i2 << 24 >> 24 < 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i3 | 0) != ((i9 ? HEAP32[i7 >> 2] | 0 : i7) + (i9 ? i1 : i2 & 255) | 0));
 }
 if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870737 | 0, 3) | 0)) i1 = 14; else {
  i2 = HEAP8[i5 >> 0] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = 7;
 } else i4 = 7;
 do if ((i4 | 0) == 7) {
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870741 | 0, 3) | 0)) {
    i1 = 13;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870745 | 0, 3) | 0)) {
    i1 = 13;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870749 | 0, 3) | 0)) {
    i1 = 20;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 2) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870753 | 0, 2) | 0)) {
    i1 = 10;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 2) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870756 | 0, 2) | 0)) {
    i1 = 21;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) {
   if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870759 | 0, 3) | 0)) {
    i1 = 17;
    break;
   }
   i2 = HEAP8[i5 >> 0] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) {
   i1 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i7, 0, -1, gb + 870763 | 0, 3) | 0) == 0;
   i1 = i1 ? 12 : 0;
  } else i1 = 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f10 = Math_fround(f10 * f11);
 f4 = Math_fround(f4 * f11);
 f11 = Math_fround(f9 * f11);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(f10 * f9) + Math_fround(f4 * f8)) + Math_fround(f11 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f8 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f8 = Math_fround(f8 * f10);
 f4 = Math_fround(f4 * f10);
 f10 = Math_fround(f9 * f10);
 f9 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f8 * f9) + Math_fround(f4 * f5)) + Math_fround(f10 * Math_fround(HEAPF32[i3 + 40 >> 2])));
 f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f8 = Math_fround(f5 * Math_fround(HEAPF32[i1 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 16 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[i1 + 32 >> 2])));
 f7 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i1 + 36 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 f4 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 24 >> 2])));
 f9 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[i1 + 40 >> 2])));
 f4 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f8 * f4) + Math_fround(f7 * f5)) + Math_fround(f9 * Math_fround(HEAPF32[i3 + 24 >> 2])));
 f5 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f8 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 48 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i1 + 64 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 80 >> 2])));
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 52 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i1 + 68 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 84 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 56 >> 2]));
 f7 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i1 + 72 >> 2])));
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 88 >> 2])));
 f7 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 return Math_fround(Math_fround(f11 + f10) + Math_fround(f9 + Math_fround(Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f5)) + Math_fround(f4 * Math_fround(HEAPF32[i3 + 56 >> 2])))));
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue16ExtractEventDataEPKcyR8UnityStr(i7, i1, i2, i3, i18) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i21 + 16 | 0;
 i13 = i21;
 if ((i2 | 0) == 0 & (i3 | 0) == 0) {
  STACKTOP = i21;
  return;
 }
 i8 = i13 + 12 | 0;
 i9 = i13 + 11 | 0;
 i10 = i13 + 12 | 0;
 i11 = i12 + 4 | 0;
 i19 = i18 + 11 | 0;
 i15 = i18 + 8 | 0;
 i20 = i18 + 4 | 0;
 i17 = i1;
 i16 = i2;
 while (1) {
  i1 = _memchr(i17, 10, i16) | 0;
  if (!i1) break;
  i5 = i1 - i17 | 0;
  i6 = ((i5 | 0) < 0) << 31 >> 31;
  do if (i5 | 0) {
   i1 = HEAP8[i19 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) {
    i4 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
    i1 = HEAP32[i20 >> 2] | 0;
   } else {
    i4 = 10;
    i1 = i1 & 255;
   }
   if ((i4 - i1 | 0) >>> 0 < i5 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i18, i4, i5 - i4 + i1 | 0, i1, i1, 0, i5, i17);
    break;
   }
   i2 = i2 ? HEAP32[i18 >> 2] | 0 : i18;
   _memcpy(i2 + i1 | 0, i17 | 0, i5 | 0) | 0;
   i1 = i1 + i5 | 0;
   if ((HEAP8[i19 >> 0] | 0) < 0) HEAP32[i20 >> 2] = i1; else HEAP8[i19 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  } while (0);
  __ZN11UnityEngine15CloudWebService17SessionEventQueue14ParseEventDataERK8UnityStr(i7, i18) | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i9 >> 0] = 0;
  HEAP8[i13 >> 0] = 0;
  HEAP8[((HEAP8[i19 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18) >> 0] = 0;
  if ((HEAP8[i19 >> 0] | 0) < 0) HEAP32[i20 >> 2] = 0; else HEAP8[i19 >> 0] = 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i4 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i11 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i12);
  }
  i2 = _i64Add(i5 | 0, i6 | 0, 1, 0) | 0;
  i1 = _i64Subtract(i16 | 0, i3 | 0, i2 | 0, getTempRet0() | 0) | 0;
  i3 = getTempRet0() | 0;
  if ((i1 | 0) == 0 & (i3 | 0) == 0) {
   i14 = 30;
   break;
  } else {
   i17 = i17 + i2 | 0;
   i16 = i1;
  }
 }
 if ((i14 | 0) == 30) {
  STACKTOP = i21;
  return;
 }
 i1 = HEAP8[i19 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) {
  i2 = (HEAP32[i15 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i20 >> 2] | 0;
 } else {
  i2 = 10;
  i1 = i1 & 255;
 }
 if ((i2 - i1 | 0) >>> 0 < i16 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i18, i2, i16 - i2 + i1 | 0, i1, i1, 0, i16, i17);
  STACKTOP = i21;
  return;
 }
 if (!i16) {
  STACKTOP = i21;
  return;
 }
 i2 = i3 ? HEAP32[i18 >> 2] | 0 : i18;
 _memcpy(i2 + i1 | 0, i17 | 0, i16 | 0) | 0;
 i1 = i1 + i16 | 0;
 if ((HEAP8[i19 >> 0] | 0) < 0) HEAP32[i20 >> 2] = i1; else HEAP8[i19 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i21;
 return;
}

function __ZN10Matrix3x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 12 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 24 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z33IntersectAABBPlaneBoundsOptimizedRK4AABBPKN4math7_float4Ei(i1, i2, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = i1 + 12 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if ((i9 | 0) > 0) i1 = 0; else {
  i9 = 1;
  return i9 | 0;
 }
 while (1) {
  f23 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
  f19 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
  i10 = i1 | 1;
  f24 = Math_fround(HEAPF32[i2 + (i10 << 4) >> 2]);
  f20 = Math_fround(HEAPF32[i2 + (i10 << 4) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i2 + (i10 << 4) + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i2 + (i10 << 4) + 12 >> 2]);
  i10 = i1 | 2;
  f25 = Math_fround(HEAPF32[i2 + (i10 << 4) >> 2]);
  f21 = Math_fround(HEAPF32[i2 + (i10 << 4) + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i2 + (i10 << 4) + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i2 + (i10 << 4) + 12 >> 2]);
  i10 = i1 | 3;
  f22 = Math_fround(HEAPF32[i2 + (i10 << 4) >> 2]);
  f18 = Math_fround(HEAPF32[i2 + (i10 << 4) + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i2 + (i10 << 4) + 8 >> 2]);
  i1 = i1 + 4 | 0;
  if ((Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(Math_abs(Math_fround(f23)))) + Math_fround(f3 * Math_fround(Math_abs(Math_fround(f24))))) + Math_fround(f4 * Math_fround(Math_abs(Math_fround(f25))))) + Math_fround(Math_fround(f7 * f25) + Math_fround(Math_fround(f6 * f24) + Math_fround(Math_fround(f8 * f23) + f22)))) < Math_fround(0.0) ? 1 : Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(Math_abs(Math_fround(f19)))) + Math_fround(f3 * Math_fround(Math_abs(Math_fround(f20))))) + Math_fround(f4 * Math_fround(Math_abs(Math_fround(f21))))) + Math_fround(Math_fround(f7 * f21) + Math_fround(Math_fround(f6 * f20) + Math_fround(Math_fround(f8 * f19) + f18)))) < Math_fround(0.0)) | Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(Math_abs(Math_fround(f15)))) + Math_fround(f3 * Math_fround(Math_abs(Math_fround(f16))))) + Math_fround(f4 * Math_fround(Math_abs(Math_fround(f17))))) + Math_fround(Math_fround(f7 * f17) + Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f8 * f15) + f14)))) < Math_fround(0.0) | Math_fround(Math_fround(Math_fround(Math_fround(f5 * Math_fround(Math_abs(Math_fround(f11)))) + Math_fround(f3 * Math_fround(Math_abs(Math_fround(f12))))) + Math_fround(f4 * Math_fround(Math_abs(Math_fround(f13))))) + Math_fround(Math_fround(f7 * f13) + Math_fround(Math_fround(f6 * f12) + Math_fround(Math_fround(f8 * f11) + Math_fround(HEAPF32[i2 + (i10 << 4) + 12 >> 2]))))) < Math_fround(0.0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
  if ((i1 | 0) >= (i9 | 0)) {
   i1 = 1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z20InverseTransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i5 + 16 | 0;
 i22 = i5;
 f6 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i3 + 4 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 HEAPF32[i22 >> 2] = f6;
 HEAPF32[i22 + 4 >> 2] = f13;
 HEAPF32[i22 + 8 >> 2] = f15;
 HEAP32[i22 + 12 >> 2] = i3;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i22, i21);
 f15 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(f15 * f16);
 i22 = f8 < Math_fround(0.0);
 f20 = Math_fround(-f8);
 f14 = Math_fround(HEAPF32[i21 + 12 >> 2]);
 f7 = Math_fround(f13 * f14);
 i3 = f7 < Math_fround(0.0);
 f12 = Math_fround(-f7);
 f7 = Math_fround((i22 ? f20 : f8) + (i3 ? f12 : f7));
 f12 = Math_fround(HEAPF32[i21 + 24 >> 2]);
 f8 = Math_fround(f6 * f12);
 i3 = f8 < Math_fround(0.0);
 f20 = Math_fround(-f8);
 f8 = Math_fround(f7 + (i3 ? f20 : f8));
 f20 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f7 = Math_fround(f15 * f20);
 i3 = f7 < Math_fround(0.0);
 f18 = Math_fround(-f7);
 f19 = Math_fround(HEAPF32[i21 + 16 >> 2]);
 f11 = Math_fround(f13 * f19);
 i22 = f11 < Math_fround(0.0);
 f10 = Math_fround(-f11);
 f11 = Math_fround((i3 ? f18 : f7) + (i22 ? f10 : f11));
 f10 = Math_fround(HEAPF32[i21 + 28 >> 2]);
 f7 = Math_fround(f6 * f10);
 i22 = f7 < Math_fround(0.0);
 f18 = Math_fround(-f7);
 f7 = Math_fround(f11 + (i22 ? f18 : f7));
 f18 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f15 = Math_fround(f15 * f18);
 i22 = f15 < Math_fround(0.0);
 f11 = Math_fround(-f15);
 f17 = Math_fround(HEAPF32[i21 + 20 >> 2]);
 f13 = Math_fround(f13 * f17);
 i3 = f13 < Math_fround(0.0);
 f9 = Math_fround(-f13);
 f13 = Math_fround((i22 ? f11 : f15) + (i3 ? f9 : f13));
 f9 = Math_fround(HEAPF32[i21 + 32 >> 2]);
 f6 = Math_fround(f6 * f9);
 i3 = f6 < Math_fround(0.0);
 f15 = Math_fround(-f6);
 f6 = Math_fround(f13 + (i3 ? f15 : f6));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i2 >> 2]));
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f10 = Math_fround(Math_fround(Math_fround(f20 * f15) + Math_fround(f19 * f13)) + Math_fround(f10 * f11));
 f9 = Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(f17 * f13)) + Math_fround(f9 * f11));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f12 * f11));
 HEAPF32[i4 + 4 >> 2] = f10;
 HEAPF32[i4 + 8 >> 2] = f9;
 HEAPF32[i4 + 12 >> 2] = f8;
 HEAPF32[i4 + 16 >> 2] = f7;
 HEAPF32[i4 + 20 >> 2] = f6;
 STACKTOP = i5;
 return;
}

function __ZN9allocutil14BuddyAllocator17FreeBlockRegistryC2E10MemLabelIdhj(i13, i4, i14, i15) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19 + 8 | 0;
 i17 = i19;
 i18 = i19 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i1 = i14 & 255;
 i5 = __Znaj(i1 << 5 | 4) | 0;
 HEAP32[i5 >> 2] = i1;
 i5 = i5 + 4 | 0;
 i3 = i14 << 24 >> 24 == 0;
 if (i3) {
  HEAP32[i13 >> 2] = i5;
  STACKTOP = i19;
  return;
 }
 i1 = i5 + (i1 << 5) | 0;
 i2 = i5;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
  i10 = i16;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i2 + 4 | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  i2 = i2 + 32 | 0;
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i13 >> 2] = i5;
 if (i3) {
  STACKTOP = i19;
  return;
 }
 i12 = HEAP32[i4 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i6 = i16 + 4 | 0;
 i8 = i18 + 12 | 0;
 i9 = i18 + 16 | 0;
 i10 = i18 + 4 | 0;
 i11 = i18 + 8 | 0;
 i1 = 0;
 while (1) {
  i4 = i5 + (i1 << 5) | 0;
  i20 = HEAP32[i7 >> 2] | 0;
  HEAP32[i16 >> 2] = i12;
  HEAP32[i6 >> 2] = i20;
  i20 = ((i15 >>> i1) + 31 | 0) >>> 5;
  HEAP32[i5 + (i1 << 5) + 24 >> 2] = i20;
  HEAP32[i8 >> 2] = i20;
  HEAP32[i9 >> 2] = i20;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i16);
  i21 = i17;
  i3 = HEAP32[i21 + 4 >> 2] | 0;
  i2 = i10;
  HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  i2 = i20 << 2;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  HEAP32[i18 >> 2] = i3;
  if (i20 | 0) _memset(i3 | 0, 0, i2 | 0) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i2, i5 + (i1 << 5) + 4 | 0, HEAP32[i11 >> 2] | 0);
  i2 = HEAP32[i18 >> 2] | 0;
  if (!i2) i3 = 0; else {
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i2, i10, HEAP32[i5 + (i1 << 5) + 8 >> 2] | 0);
   i3 = HEAP32[i18 >> 2] | 0;
  }
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i18 >> 2] = i2;
  i21 = i5 + (i1 << 5) + 12 | 0;
  i20 = HEAP32[i21 >> 2] | 0;
  HEAP32[i21 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i20;
  i20 = i5 + (i1 << 5) + 16 | 0;
  i21 = HEAP32[i20 >> 2] | 0;
  HEAP32[i20 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = i21;
  i20 = i5 + (i1 << 5) + 4 | 0;
  i5 = i20;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i22 = i10;
  i3 = HEAP32[i22 + 4 >> 2] | 0;
  HEAP32[i20 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i20 + 4 >> 2] = i3;
  i20 = i10;
  HEAP32[i20 >> 2] = i4;
  HEAP32[i20 + 4 >> 2] = i5;
  if ((i21 | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
   HEAP32[i18 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
  if ((i1 & 255) << 24 >> 24 == i14 << 24 >> 24) break;
  i5 = HEAP32[i13 >> 2] | 0;
 }
 STACKTOP = i19;
 return;
}

function __ZN11NoiseModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 4 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 8 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 272 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 536 | 0, i6);
 i1 = i5 + 804 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 800 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 805 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 808 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 812 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 816 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 820 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 824 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1092 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1356 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1620 | 0, i6);
 i1 = i5 + 1884 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  return;
 }
}

function __ZN13RenderManager22RenderOffscreenCamerasEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1392 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i12 + 1376 | 0;
 i9 = i7 + 52 | 0;
 HEAP8[i9 >> 0] = 1;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i10 = i7 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) == (i10 | 0)) {
  i11 = HEAP32[gb + 1112272 >> 2] | 0;
  __ZN16ReflectionProbes6UpdateEv(i11) | 0;
  HEAP8[i9 >> 0] = 0;
  __ZN13RenderManager23AddRemoveCamerasDelayedEv(i7);
  STACKTOP = i12;
  return;
 }
 i5 = i2;
 do {
  i4 = i1 + 8 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i8);
     i2 = HEAP32[i6 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 12;
    }
   }
   if ((i11 | 0) == 10) i11 = 12;
   if ((i11 | 0) == 12) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  if ((HEAP16[gb + 1112340 + 6 >> 1] | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112340 | 0, i6);
   i2 = gb + 1112340 | 0;
  } else i2 = 0;
  i13 = HEAP32[gb + 1112340 >> 2] | 0;
  i4 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i13 | 0);
  if (!i1) {
   HEAP32[i7 >> 2] = 0;
   __ZN11CullResultsC2Ev(i6);
  } else {
   HEAP32[i7 >> 2] = HEAP32[i1 + 4 >> 2];
   __ZN11CullResultsC2Ev(i6);
   if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) __ZN6Camera4CullER11CullResults8CullFlag(i1, i6, 0);
   if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) {
    __ZN6Camera14UpdateVelocityEv(i1);
    __ZN6Camera6RenderER11CullResultsR17ShaderPassContextNS_10RenderFlagE(i1, i6, HEAP32[gb + 1166248 >> 2] | 0, 4);
   }
  }
  __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
  __ZN11CullResultsD2Ev(i6);
  i13 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 652 >> 2] | 0, i13 | 0);
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i5 = i1;
 } while ((i5 | 0) != (i10 | 0));
 i13 = HEAP32[gb + 1112272 >> 2] | 0;
 __ZN16ReflectionProbes6UpdateEv(i13) | 0;
 HEAP8[i9 >> 0] = 0;
 __ZN13RenderManager23AddRemoveCamerasDelayedEv(i7);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i7 = i18 + 28 | 0;
 i17 = HEAP32[i7 >> 2] | 0;
 f19 = Math_fround(i1 >>> 0);
 i8 = ~~Math_fround(f19 * Math_fround(HEAPF32[i18 + 36 >> 2])) >>> 0;
 i13 = i1 << 2;
 i12 = (i8 << 2) + i13 | 0;
 i12 = (0 - i12 & 12) + i12 | 0;
 i9 = i18 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i10 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i12 + (i8 * 48 | 0) | 0, HEAP32[i18 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i11 = i10 + i13 | 0;
 i12 = i10 + i12 | 0;
 _memset(i10 | 0, -1, i13 | 0) | 0;
 i13 = i18 + 48 | 0;
 i6 = i18 + 16 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i14 = i1 + -1 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i16 = 0;
  do {
   i3 = HEAP32[i5 + (i16 * 48 | 0) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i15 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i10 + ((i2 & i14) << 2) | 0;
   HEAP32[i11 + (i16 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i16;
   HEAP32[i12 + (i16 * 48 | 0) >> 2] = i15;
   HEAP32[i12 + (i16 * 48 | 0) + 4 >> 2] = gb + 150368 + 8;
   i15 = i12 + (i16 * 48 | 0) + 8 | 0;
   i4 = i5 + (i16 * 48 | 0) + 8 | 0;
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 12 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 12 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 16 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 16 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 20 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 20 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 24 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 24 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 28 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 28 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 32 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 32 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 36 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 36 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 40 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 40 >> 2];
   HEAP32[i12 + (i16 * 48 | 0) + 44 >> 2] = HEAP32[i5 + (i16 * 48 | 0) + 44 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
   i16 = i16 + 1 | 0;
  } while (i16 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 i16 = i18 + 12 | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, HEAP32[i16 >> 2] | 0);
 HEAP32[i16 >> 2] = i10;
 HEAP32[i18 + 24 >> 2] = i10;
 HEAP32[i18 + 32 >> 2] = i1;
 HEAP32[i18 + 20 >> 2] = i11;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i7 >> 2] = i8;
 i1 = i18 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i17;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim18visualizeStartStepERNS_2Cm12RenderOutputE(i2, i17) {
 i2 = i2 | 0;
 i17 = i17 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 56 | 0;
 i15 = i18 + 28 | 0;
 i1 = i18;
 if (!(HEAP16[(HEAP32[i2 + 52 >> 2] | 0) + 8 >> 1] & 1)) {
  STACKTOP = i18;
  return;
 }
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i17, i1) | 0;
 if (Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0, 26)) > Math_fround(0.0)) {
  i14 = HEAP32[i2 + 56 >> 2] | 0;
  i14 = mftCall_ii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i16 | 0, i14 | 0);
  i14 = __ZN5physx2Cm12RenderOutputlsEj(i17, -65536) | 0;
  HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
  HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
  HEAP32[i15 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
  HEAP32[i15 + 20 >> 2] = HEAP32[i16 + 20 >> 2];
  HEAP8[i15 + 24 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i14, i15) | 0;
 }
 __ZN5physx2Sc17ParticleSystemSim18visualizeParticlesERNS_2Cm12RenderOutputE(i2, i17);
 if (Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0, 27)) > Math_fround(0.0)) __ZN5physx2Sc17ParticleSystemSim20visualizeSpatialGridERNS_2Cm12RenderOutputE(i2, i17);
 if (!(Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0, 28)) > Math_fround(0.0))) {
  STACKTOP = i18;
  return;
 }
 i14 = i2 + 360 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i1 = i2 + 356 | 0;
  i2 = i15 + 4 | 0;
  i3 = i16 + 4 | 0;
  i4 = i15 + 8 | 0;
  i5 = i16 + 8 | 0;
  i6 = i15 + 12 | 0;
  i7 = i16 + 12 | 0;
  i8 = i15 + 16 | 0;
  i9 = i16 + 16 | 0;
  i10 = i15 + 20 | 0;
  i11 = i16 + 20 | 0;
  i12 = i15 + 24 | 0;
  i13 = 0;
  do {
   i19 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i13 << 2) >> 2] | 0) + 44 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i19 | 0);
   i19 = __ZN5physx2Cm12RenderOutputlsEj(i17, -16776961) | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP8[i12 >> 0] = 1;
   __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i19, i15) | 0;
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 }
 STACKTOP = i18;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i5, i1, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = i11 + 216 | 0;
 i2 = i11 + 212 | 0;
 i10 = i11 + 8 | 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAPF32[i10 + 20 >> 2] = Math_fround(inf);
 HEAP32[i10 + 16 >> 2] = 0;
 i3 = i10 + 24 | 0;
 i4 = i3 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i10 + 96 >> 2] = Math_fround(inf);
 HEAP32[i10 + 92 >> 2] = 0;
 HEAP32[i10 + 180 >> 2] = 0;
 i6 = i10 + 184 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i10 + 172 | 0;
 i3 = i10 + 100 | 0;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i12 = i9;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i10 + 192 >> 2] = 2;
 HEAP32[i10 + 188 >> 2] = 2;
 HEAP32[i10 + 196 >> 2] = 4;
 HEAP32[i10 + 200 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i2, i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, gb + 899475 | 0, i10, 0);
 i8 = i10 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 899332 | 0, gb + 1034188 | 0, i8, 0);
 __ZN17AnimationCurveTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i1, 0);
 HEAP32[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i5 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 i1 = i10 + 168 | 0;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i10 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 STACKTOP = i11;
 return;
}

function _cf2_decoder_parse_charstrings(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i17 + 48 | 0;
 i13 = i17;
 i14 = i17 + 24 | 0;
 i15 = i17 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i8 + 76 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 2972 >> 2] | 0;
 do if (!i1) {
  HEAP32[i2 + 2976 >> 2] = fb + 3862;
  i1 = _UNITY_ft_mem_alloc(i4, 504, i3) | 0;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 2972 >> 2] = i1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i4;
   i11 = i1 + 108 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   HEAP32[i11 + 12 >> 2] = 0;
   HEAP32[i11 + 16 >> 2] = 0;
   HEAP32[i11 + 20 >> 2] = 0;
   HEAP32[i1 + 120 >> 2] = i4;
   HEAP32[i1 + 124 >> 2] = i1 + 4;
   HEAP32[i1 + 100 >> 2] = fb + 4204;
   HEAP32[i1 + 104 >> 2] = fb + 4205;
   HEAP32[i1 + 112 >> 2] = fb + 4206;
   i11 = i1;
   break;
  } else {
   i16 = 64;
   STACKTOP = i17;
   return i16 | 0;
  }
 } else i11 = i1; while (0);
 HEAP32[i11 + 132 >> 2] = i8;
 i12 = i11 + 128 | 0;
 HEAP32[i12 >> 2] = i8;
 i9 = i8 + 4 | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 96 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i6;
 HEAP32[i13 + 8 >> 2] = i6 + i7;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 i6 = i14 + 12 | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i4 = HEAP16[i1 + 160 >> 1] | 0;
 i2 = (i4 & 255) << 24 >> 24 == 0;
 if (i2) {
  HEAP32[i14 >> 2] = 1024;
  i5 = 1024;
  i1 = 1024;
 } else {
  i5 = ((HEAP32[i1 + 164 >> 2] | 0) + 32 | 0) / 64 | 0;
  HEAP32[i14 >> 2] = i5;
  i1 = ((HEAP32[i1 + 168 >> 2] | 0) + 32 | 0) / 64 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i3 = i11 + 8 | 0;
 i1 = i2 & 1 ^ 1;
 HEAP32[i3 >> 2] = i1;
 i4 = (i4 & 65535) < 256;
 if (!i4) if (!(HEAP8[i10 + 32 >> 0] | 0)) HEAP32[i3 >> 2] = i1 | 2;
 HEAP32[i11 + 144 >> 2] = HEAP32[i10 + 36 >> 2];
 HEAP32[i11 + 148 >> 2] = HEAP32[i10 + 40 >> 2];
 HEAP32[i11 + 152 >> 2] = HEAP32[i10 + 44 >> 2];
 HEAP32[i11 + 156 >> 2] = HEAP32[i10 + 48 >> 2];
 HEAP32[i11 + 160 >> 2] = HEAP32[i10 + 52 >> 2];
 HEAP32[i11 + 164 >> 2] = HEAP32[i10 + 56 >> 2];
 HEAP32[i11 + 168 >> 2] = HEAP32[i10 + 60 >> 2];
 HEAP32[i11 + 172 >> 2] = HEAP32[i10 + 64 >> 2];
 i1 = HEAP16[(HEAP32[i9 >> 2] | 0) + 68 >> 1] | 0;
 i2 = i1 & 65535;
 HEAP32[i11 + 88 >> 2] = i2;
 if (i4) i16 = 14; else if ((i5 | 0) < 1 | (HEAP32[i6 >> 2] | 0) < 1) i1 = 36; else if (i1 << 16 >> 16 < 0) i1 = 164; else {
  i10 = _UNITY_FT_DivFix(131072e3, i2 << 16) | 0;
  if ((HEAP32[i14 >> 2] | 0) > (i10 | 0) ? 1 : (HEAP32[i6 >> 2] | 0) > (i10 | 0)) i1 = 164; else i16 = 14;
 }
 if ((i16 | 0) == 14) if (!(_cf2_getGlyphOutline(i11, i13, i14, i15) | 0)) {
  HEAP32[(HEAP32[i12 >> 2] | 0) + 552 >> 2] = (HEAP32[i15 >> 2] | 0) + 32768 >> 16;
  i1 = 0;
 } else i1 = 3;
 i16 = i1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZNK10MonoScript22GetScriptFullClassNameEv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i6 = i10 + 16 | 0;
 i7 = i10;
 i3 = i4 + 108 | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i2 = HEAP32[i4 + 112 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) {
  i3 = i4 + 92 | 0;
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i7 = i2 << 24 >> 24 < 0;
  i3 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i7 ? HEAP32[i4 + 96 >> 2] | 0 : i2 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i9 = 8;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i9 = 10;
  } else i9 = 8;
  if ((i9 | 0) == 8) {
   i7 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i8 + 4 >> 2] = i2;
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i8;
   HEAP32[i1 + 8 >> 2] = i7 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i8;
   i9 = 10;
  }
  if ((i9 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i7, i3, gb + 1087625 | 0);
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i6, i7, i4 + 92 | 0);
 i4 = i6 + 11 | 0;
 i5 = HEAP8[i4 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = i2 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i9 = 15;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (i5) i9 = 17;
 } else i9 = 15;
 if ((i9 | 0) == 15) {
  i11 = i5 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i2;
  i9 = 17;
 }
 if ((i9 | 0) == 17) _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i11 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_fEEEEEEEEvRT_17TransferMetaFlags(i18, i19, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 12 | 0;
 i13 = i17 + 8 | 0;
 i14 = i17;
 i15 = i19 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i18, gb + 1041885 | 0, gb + 1041885 | 0, i13) | 0)) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i14 >> 2] = -1;
 i16 = i14 + 4 | 0;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 i8 = i19 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i19, HEAP32[i8 >> 2] | 0);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i19 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i13 >> 2] | 0) > 0) {
  i9 = HEAP32[gb + 37152 >> 2] | 0;
  i10 = i8;
  i11 = i19 + 4 | 0;
  i7 = 0;
  do {
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i18, gb + 1041891 | 0, i9, i12, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i14, i18); else {
     i1 = HEAP32[i12 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i14 | 0, i18 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i18);
   }
   i5 = HEAP32[i14 >> 2] | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   do if (!i1) {
    HEAP32[i12 >> 2] = i8;
    i4 = i10;
    i3 = i8;
   } else {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 14;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 19;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 18;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 14) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 18) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i2 | 0) == 19) {
     HEAP32[i12 >> 2] = i1;
     i4 = i1;
     i3 = i12;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    i1 = __Znwj(24) | 0;
    i2 = i1 + 16 | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i2 + 4 >> 2] = i6;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i19 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i19 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i1);
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (HEAP32[i13 >> 2] | 0));
 }
 __ZN14SafeBinaryRead16EndArrayTransferEv(i18);
 STACKTOP = i17;
 return;
}

function __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 HEAP32[i13 >> 2] = 0;
 i11 = i13 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = HEAP32[i9 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i15 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i15;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i15) {
   i15 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i15 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i13, 0);
   HEAP8[i5 >> 0] = 1;
   i15 = i3 + 56 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  i5 = HEAP32[i8 + 24 >> 2] | 0;
  i1 = HEAP32[i9 + 28 >> 2] | 0;
  i2 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
  i4 = (i2 | 0) / 88 | 0;
  i3 = i5 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) {
   HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i4) | 0;
   HEAP32[i3 >> 2] = i4;
  }
  if (i2 | 0) {
   i1 = 0;
   do {
    i15 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i5 >> 2] | 0, i1) | 0;
    __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i10, (HEAP32[i13 >> 2] | 0) + (i1 * 88 | 0) | 0, i15);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 } while (0);
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i11 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i11 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i15 = HEAP32[i13 + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 36 | 0) + 1 | 0;
 if (i4 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 36 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 59652323 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 119304647;
 i5 = (i1 - i2 | 0) / 36 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 36 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 36 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 36 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 36 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 36 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 * 36 | 0) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 36;
 __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Cm17FreeListAllocator9freeChunkEPNS0_5ChunkE(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i1 & 2147483647;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 if (!(i1 & 1073741824)) i9 = i8 + (0 - (i1 >>> 10 & 1023) << 4) | 0; else i9 = 0;
 i10 = (i1 & 536870912 | 0) == 0 ? i8 + (i1 << 4 & 16368) | 0 : 0;
 if (i9) {
  i7 = HEAP32[i9 >> 2] | 0;
  if ((i7 | 0) >= 0) {
   i3 = i7 & 1023;
   i4 = i11 + 148 + (i3 << 2) | 0;
   i5 = i9 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i1;
   i2 = i9 + 8 | 0;
   if (i1 | 0) HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) HEAP32[i4 >> 2] = i6; else HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i1 = i3 >>> 5;
    i6 = i11 + 16 + (i1 << 2) | 0;
    i7 = HEAP32[i6 >> 2] & ~(1 << (i7 & 31));
    HEAP32[i6 >> 2] = i7;
    if (!i7) {
     i7 = i11 + 144 | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << i1);
    }
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (i1 & 536870912 | i2 & 1074790399) + (i1 & 1023) | 0;
   HEAP32[i9 >> 2] = i1;
   if (!(i1 & 536870912)) {
    i8 = i9 + (i1 << 4 & 16368) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i2 << 10 & 1047552);
    i8 = i9;
   } else i8 = i9;
  }
 }
 if (i10 | 0) {
  i7 = HEAP32[i10 >> 2] | 0;
  if ((i7 | 0) >= 0) {
   i3 = i7 & 1023;
   i4 = i11 + 148 + (i3 << 2) | 0;
   i5 = i10 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i6 = i1;
   i2 = i10 + 8 | 0;
   if (i1 | 0) HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) HEAP32[i4 >> 2] = i6; else HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i1 = i3 >>> 5;
    i6 = i11 + 16 + (i1 << 2) | 0;
    i9 = HEAP32[i6 >> 2] & ~(1 << (i7 & 31));
    HEAP32[i6 >> 2] = i9;
    if (!i9) {
     i9 = i11 + 144 | 0;
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << i1);
    }
   }
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i1 = (i1 & 536870912 | i2 & 1074790399) + (i1 & 1023) | 0;
   HEAP32[i8 >> 2] = i1;
   if (!(i1 & 536870912)) {
    i10 = i8 + (i1 << 4 & 16368) | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i2 << 10 & 1047552);
   }
  }
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 & 1023;
 if ((i2 | 0) != 1023) {
  i3 = i11 + 148 + (i2 << 2) | 0;
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 >> 2];
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) HEAP32[i4 + 8 >> 2] = i8;
  HEAP32[i3 >> 2] = i8;
  i10 = i2 >>> 5;
  i9 = i11 + 16 + (i10 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1 << (i1 & 31);
  i11 = i11 + 144 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << i10;
  return;
 }
 i3 = i8 + -12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i1;
 i2 = i8 + -8 | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) HEAP32[i11 + 4240 >> 2] = i4; else HEAP32[i1 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i3 | 0);
 return;
}

function __ZN20SoundChannelInstanceC2E11SoundHandleb(i7, i3, i6) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i8 = i11 + 8 | 0;
 i10 = i11;
 HEAP32[i7 >> 2] = gb + 175464 + 8;
 _memset(i7 + 4 | 0, 0, 148) | 0;
 if (!(HEAP8[gb + 1098888 >> 0] | 0)) {
  i1 = gb + 861196 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 861196 + 87 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459936 >> 2] = i1;
  i5 = gb + 1098888 | 0;
  HEAP32[i5 >> 2] = 1;
  HEAP32[i5 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459936 >> 2] | 0;
 HEAP32[i7 + 152 >> 2] = i1;
 HEAP32[i7 + 156 >> 2] = i7;
 HEAP32[i7 + 160 >> 2] = gb + 861196;
 HEAP32[i7 + 164 >> 2] = 0;
 i2 = i7 + 168 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 + 172 >> 2] = 0;
 HEAP32[i7 + 176 >> 2] = 0;
 HEAP32[i7 + 180 >> 2] = i7;
 HEAP32[i7 + 184 >> 2] = 0;
 HEAP32[i7 + 188 >> 2] = 0;
 HEAP32[i7 + 192 >> 2] = i7;
 i4 = i7 + 196 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 200 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 204 >> 2] = i7;
 HEAPF32[i7 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 228 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 232 >> 2] = Math_fround(1.0);
 HEAP8[i7 + 236 >> 0] = i6 & 1;
 i1 = i7 + 248 | 0;
 i2 = i7 + 237 | 0;
 i3 = i2 + 11 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i3 = gb + 63328 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 i6 = __ZnwjRK10MemLabelIdiPKci(20, i10, 16, gb + 854186 | 0, 74) | 0;
 i2 = i10;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN17WeakPtrSharedDataC2E10MemLabelId(i6, i9);
 HEAP32[i6 >> 2] = gb + 175480 + 8;
 HEAP32[i6 + 16 >> 2] = i7;
 HEAP32[gb + 1460028 >> 2] = (HEAP32[gb + 1460028 >> 2] | 0) + 1;
 HEAP32[i1 >> 2] = i6;
 HEAP32[gb + 1460032 >> 2] = (HEAP32[gb + 1460032 >> 2] | 0) + 1;
 i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
 if ((i4 | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
 STACKTOP = i11;
 return;
}

function __ZNK15NavMeshObstacle12GetCarveDataER16NavMeshCarveData(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 40 | 0;
 i15 = i18;
 i16 = i12 + 40 | 0;
 HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
 i17 = i12 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i14, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 i1 = f5 < Math_fround(0.0);
 f9 = Math_fround(-f5);
 f5 = i1 ? f9 : f5;
 f9 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 i1 = f9 < Math_fround(0.0);
 f10 = Math_fround(-f9);
 f6 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 i7 = f6 < Math_fround(0.0);
 f8 = Math_fround(-f6);
 f6 = i7 ? f8 : f6;
 f8 = Math_fround(HEAPF32[i12 + 56 >> 2]);
 f11 = Math_fround(HEAPF32[i12 + 60 >> 2]);
 if (!(HEAP32[i16 >> 2] | 0)) {
  f6 = Math_fround(f8 * (f5 < f6 ? f6 : f5));
  f5 = f6;
 } else {
  f8 = Math_fround(f5 * f8);
  f5 = Math_fround(f6 * Math_fround(HEAPF32[i12 + 64 >> 2]));
  f6 = f8;
 }
 f11 = Math_fround((i1 ? f10 : f9) * f11);
 i7 = i13 + 16 | 0;
 HEAPF32[i7 >> 2] = f6;
 HEAPF32[i13 + 20 >> 2] = f11;
 HEAPF32[i13 + 24 >> 2] = f5;
 i1 = i13 + 4 | 0;
 i2 = i13 + 28 | 0;
 i3 = i13 + 40 | 0;
 i4 = i13 + 52 | 0;
 i17 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i14, i17, i12 + 44 | 0);
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 __ZNK9Transform11GetRotationEv(i14, i17);
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i14, i15);
 i12 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 32 >> 2] = i12;
 HEAP32[i13 + 36 >> 2] = i17;
 i17 = HEAP32[i15 + 16 >> 2] | 0;
 i12 = HEAP32[i15 + 20 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i13 + 44 >> 2] = i17;
 HEAP32[i13 + 48 >> 2] = i12;
 i12 = HEAP32[i15 + 28 >> 2] | 0;
 i17 = HEAP32[i15 + 32 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i13 + 56 >> 2] = i12;
 HEAP32[i13 + 60 >> 2] = i17;
 if (!(HEAP32[i16 >> 2] | 0)) __Z23CalcCapsuleWorldExtentsPfPKfS1_S1_S1_(i14, i7, i2, i3, i4); else __Z19CalcBoxWorldExtentsPfPKfS1_S1_S1_(i14, i7, i2, i3, i4);
 f21 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f5 = Math_fround(f21 - f9);
 f20 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f6 = Math_fround(f20 - f10);
 f19 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f8 = Math_fround(f19 - f11);
 f9 = Math_fround(f21 + f9);
 f10 = Math_fround(f20 + f10);
 f11 = Math_fround(f19 + f11);
 HEAPF32[i13 + 64 >> 2] = f5;
 HEAPF32[i13 + 68 >> 2] = f6;
 HEAPF32[i13 + 72 >> 2] = f8;
 HEAPF32[i13 + 76 >> 2] = f9;
 HEAPF32[i13 + 80 >> 2] = f10;
 HEAPF32[i13 + 84 >> 2] = f11;
 STACKTOP = i18;
 return;
}

function __ZN2UI26GetAvaliableShaderPropertyERNS_7BatchesE(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 8 | 0;
 i6 = i11;
 i9 = i8 + 40 | 0;
 i10 = i8 + 52 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 L1 : do if (i4 | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) < 2) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break L1;
  }
  STACKTOP = i11;
  return i1 | 0;
 } while (0);
 i2 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 1012173 | 0, 189) | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 33952 + 8;
 i7 = gb + 63536 | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i4 = i3;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i2 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = gb + 63536 | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i4 = i3;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i2 + 56 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = gb + 63536 | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 76 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 i5 = gb + 63536 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 100 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i2 + 108 >> 0] = 1;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 56 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i4;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i2;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i7 = i2 - i5 | 0;
 i8 = i7 >> 3;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i4 = i5;
 i3 = i6;
 i12 = i2;
 if (i8 >>> 0 > i1 - i6 >> 3 >>> 0) {
  i5 = i6;
  if (i6) {
   i1 = i11 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i6 | 0) >>> 3) << 3);
   i6 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 34;
   HEAP32[i9 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i9);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = 0;
  }
  if ((i7 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
  } else i2 = 0;
  i7 = i1 - i2 | 0;
  i1 = i7 >> 2;
  i1 = i7 >> 3 >>> 0 < 1073741823 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 34;
  HEAP32[i9 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  i3 = i11 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i10 >> 2] = i2 + (i1 << 3);
  if ((i4 | 0) == (i12 | 0)) {
   STACKTOP = i13;
   return;
  }
  i1 = i4;
  do {
   i9 = i1;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = i1 + 8 | 0;
   i2 = (HEAP32[i3 >> 2] | 0) + 8 | 0;
   HEAP32[i3 >> 2] = i2;
  } while ((i1 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 } else {
  i9 = i11 + 4 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i7 = i1 - i6 >> 3;
  i8 = i8 >>> 0 > i7 >>> 0;
  i2 = i8 ? i4 + (i7 << 3) | 0 : i2;
  i7 = i1;
  if ((i4 | 0) != (i2 | 0)) {
   i6 = i2 + -8 - i5 | 0;
   i5 = i3;
   while (1) {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    i4 = i4 + 8 | 0;
    if ((i4 | 0) == (i2 | 0)) break; else i5 = i5 + 8 | 0;
   }
   i3 = i3 + ((i6 >>> 3) + 1 << 3) | 0;
  }
  if (i8) {
   if ((i2 | 0) == (i12 | 0)) {
    STACKTOP = i13;
    return;
   }
   do {
    i8 = i2;
    i10 = HEAP32[i8 + 4 >> 2] | 0;
    i11 = i1;
    HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i11 + 4 >> 2] = i10;
    i2 = i2 + 8 | 0;
    i1 = (HEAP32[i9 >> 2] | 0) + 8 | 0;
    HEAP32[i9 >> 2] = i1;
   } while ((i2 | 0) != (i12 | 0));
   STACKTOP = i13;
   return;
  } else {
   if ((i7 | 0) == (i3 | 0)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i9 >> 2] = i7 + (~((i7 + -8 - i3 | 0) >>> 3) << 3);
   STACKTOP = i13;
   return;
  }
 }
}

function __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIjPNS_11__tree_nodeIjS8_EEiEESB_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if (i5 >>> 0 >= i2 >>> 0) {
   if (i2 >>> 0 >= i5 >>> 0) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i5 >>> 0 < i2 >>> 0) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if (i2 >>> 0 >= i5 >>> 0) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN18LoadSceneOperation19IntegrateMainThreadEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 4 | 0;
 i4 = i8;
 i3 = __Z15GetSceneManagerv() | 0;
 i7 = i6 + 160 | 0;
 __ZN19RuntimeSceneManager24BeginIntegrateMainThreadEP10UnityScene(i3, HEAP32[i7 >> 2] | 0);
 i3 = i6 + 108 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i6 + 140 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 i2 = i6 + 460 | 0;
 switch (HEAP32[i2 >> 2] | 0) {
 case 5:
 case 1:
  {
   if ((HEAP16[gb + 1163164 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163164 | 0, i5);
    i1 = gb + 1163164 | 0;
   } else i1 = 0;
   __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv(i6 + 180 | 0);
   __ZN18LoadSceneOperation21CompleteAwakeSequenceEv(i6);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   break;
  }
 case 0:
  {
   if ((HEAP16[gb + 1163164 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163164 | 0, i5);
    i1 = gb + 1163164 | 0;
   } else i1 = 0;
   __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv(i6);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   break;
  }
 case 2:
  {
   if ((HEAP16[gb + 1163164 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163164 | 0, i5);
    i1 = gb + 1163164 | 0;
   } else i1 = 0;
   __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv(i6);
   i2 = __Z22GetGameManagerIfExistsi(9) | 0;
   if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   break;
  }
 default:
  {}
 }
 i1 = i6 + 164 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i6 + 168 >> 2] | 0;
 } else i2 = i2 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = __Z15GetSceneManagerv() | 0;
 __ZN19RuntimeSceneManager22EndIntegrateMainThreadEP10UnityScene(i5, HEAP32[i7 >> 2] | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 HEAP32[i7 >> 2] = 0;
 __ZN18LoadSceneOperation13CleanupMemoryEv(i6);
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __ZL26GeomMTDCallback_CapsuleBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7;
 i8 = i7 + 28 | 0;
 f18 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(f18 * Math_fround(2.0));
 f20 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f15 = Math_fround(f20 * Math_fround(2.0));
 f20 = Math_fround(Math_fround(f18 * f12) + Math_fround(Math_fround(f20 * f15) + Math_fround(-1.0)));
 f18 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(f18 * f15);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f12 * f14));
 f14 = Math_fround(Math_fround(f12 * f18) - Math_fround(f15 * f14));
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f20 = Math_fround(f15 * f20);
 f13 = Math_fround(f15 * f13);
 f14 = Math_fround(f15 * f14);
 f15 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f18 = Math_fround(f15 + f20);
 f12 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f19 = Math_fround(f12 + f13);
 f10 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f17 = Math_fround(f14 + f10);
 HEAPF32[i9 >> 2] = f18;
 HEAPF32[i9 + 4 >> 2] = f19;
 HEAPF32[i9 + 8 >> 2] = f17;
 f13 = Math_fround(f12 - f13);
 f14 = Math_fround(f10 - f14);
 HEAPF32[i9 + 12 >> 2] = Math_fround(f15 - f20);
 HEAPF32[i9 + 16 >> 2] = f13;
 HEAPF32[i9 + 20 >> 2] = f14;
 HEAP32[i9 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 36 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f10 = Math_fround(f14 + f14);
 f12 = Math_fround(f13 + f13);
 f17 = Math_fround(f20 + f20);
 f19 = Math_fround(f13 * f12);
 f18 = Math_fround(f20 * f17);
 f13 = Math_fround(f10 * f13);
 f21 = Math_fround(f10 * f20);
 f11 = Math_fround(f10 * f15);
 f20 = Math_fround(f12 * f20);
 f12 = Math_fround(f12 * f15);
 f15 = Math_fround(f17 * f15);
 f17 = Math_fround(f13 + f15);
 f16 = Math_fround(f21 - f12);
 f15 = Math_fround(f13 - f15);
 f10 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f10));
 f14 = Math_fround(f10 - f18);
 f13 = Math_fround(f20 + f11);
 f12 = Math_fround(f21 + f12);
 f11 = Math_fround(f20 - f11);
 f10 = Math_fround(f10 - f19);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f19) - f18);
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 HEAPF32[i8 + 12 >> 2] = f15;
 HEAPF32[i8 + 16 >> 2] = f14;
 HEAPF32[i8 + 20 >> 2] = f13;
 HEAPF32[i8 + 24 >> 2] = f12;
 HEAPF32[i8 + 28 >> 2] = f11;
 HEAPF32[i8 + 32 >> 2] = f10;
 i6 = __ZN5physx2Gu21computeMTD_CapsuleBoxERNS_6PxVec3ERfRKNS0_7CapsuleERKNS0_3BoxE(i4, i1, i9, i8) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK6Sprite11GetOuterUVsEb(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i7 = i8;
 i6 = HEAP32[i10 + 80 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i11 = 9;
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 17;
   }
  }
  if ((i11 | 0) == 15) i11 = 17;
  if ((i11 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i1 | 0);
  f14 = Math_fround(HEAPF32[i10 + 88 >> 2]);
  f17 = Math_fround(HEAPF32[i10 + 92 >> 2]);
  f15 = Math_fround(HEAPF32[i10 + 96 >> 2]);
  f15 = Math_fround(f14 + f15);
  f13 = Math_fround(f17 + Math_fround(HEAPF32[i10 + 100 >> 2]));
  f16 = Math_fround(HEAPF32[i7 >> 2]);
  HEAPF32[i9 >> 2] = Math_fround(f16 * f14);
  f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  HEAPF32[i9 + 4 >> 2] = Math_fround(f14 * f17);
  HEAPF32[i9 + 8 >> 2] = Math_fround(f16 * f15);
  HEAPF32[i9 + 12 >> 2] = Math_fround(f14 * f13);
  STACKTOP = i8;
  return;
 } while (0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE10BeginWriteEjj(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) i1 = (HEAP32[i7 + 24 >> 2] | 0) - i8 | 0;
 i5 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 692 >> 0] | 0;
 HEAP8[i7 + 56 >> 0] = i5;
 if (!(i5 << 24 >> 24)) {
  i1 = i7 + 36 | 0;
  i2 = HEAP32[i7 + 24 >> 2] | 0;
  i3 = i7 + 48 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i7 + 52 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 4, i7 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i1 >> 2] = i6;
   i1 = i6;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i7 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP32[i7 + 60 >> 2] = i8;
  i8 = i1 + i8 | 0;
  return i8 | 0;
 }
 L15 : do switch (HEAP32[i7 + 16 >> 2] | 0) {
 case 2:
  {
   if (i8 | 0) {
    i3 = 50;
    i2 = i7 + 28 | 0;
    break L15;
   }
   i5 = HEAP32[i7 + 24 >> 2] | 0;
   i2 = i7 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if (!i3) i6 = 13; else {
    if ((HEAP32[i3 + 8 >> 2] | 0) >>> 0 >= i5 >>> 0) {
     i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i3) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i4) {
      if (!i3) {
       i6 = 13;
       break;
      }
      i4 = i7 + 32 | 0;
      break;
     }
    }
    __ZN14DataBufferGLES7ReleaseEv(i3);
    HEAP32[i2 >> 2] = 0;
    i6 = 13;
   } while (0);
   if ((i6 | 0) == 13) {
    i3 = __Z20GetBufferManagerGLESv() | 0;
    i4 = i7 + 32 | 0;
    i3 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i3, i5, HEAP32[i4 >> 2] | 0, 0) | 0;
    HEAP32[i2 >> 2] = i3;
   }
   if ((HEAP32[i4 >> 2] | 0) == 3) {
    __ZN14DataBufferGLES13EnsureStorageEi(i3, i5);
    i3 = 50;
   } else i3 = 50;
   break;
  }
 case 1:
  {
   i5 = i1 + i8 | 0;
   i2 = i7 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if (!i3) i6 = 22; else {
    if ((HEAP32[i3 + 8 >> 2] | 0) >>> 0 >= i5 >>> 0) {
     i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i3) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i4) {
      if (!i3) {
       i6 = 22;
       break;
      }
      i4 = i7 + 32 | 0;
      break;
     }
    }
    __ZN14DataBufferGLES7ReleaseEv(i3);
    HEAP32[i2 >> 2] = 0;
    i6 = 22;
   } while (0);
   if ((i6 | 0) == 22) {
    i3 = __Z20GetBufferManagerGLESv() | 0;
    i4 = i7 + 32 | 0;
    i3 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i3, i5, HEAP32[i4 >> 2] | 0, 0) | 0;
    HEAP32[i2 >> 2] = i3;
   }
   if ((HEAP32[i4 >> 2] | 0) == 3) {
    __ZN14DataBufferGLES13EnsureStorageEi(i3, i5);
    i3 = 58;
   } else i3 = 58;
   break;
  }
 default:
  {
   i8 = 0;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i7 + 60 >> 2] = i8;
 i8 = __ZN14DataBufferGLES3MapEiij(HEAP32[i2 >> 2] | 0, i8, i1, i3) | 0;
 return i8 | 0;
}

function _UNITY_png_set_keep_unknown_chunks(i13, i7, i2, i1) {
 i13 = i13 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i13) return;
 if (i7 >>> 0 > 3) {
  _UNITY_png_app_error(i13, gb + 354379 | 0);
  return;
 }
 if ((i1 | 0) < 1) {
  HEAP32[i13 + 584 >> 2] = i7;
  if (!i1) return; else {
   i1 = 17;
   i2 = gb + 354464 | 0;
  }
 } else if (!i2) {
  _UNITY_png_app_error(i13, gb + 354421 | 0);
  return;
 }
 i11 = i13 + 588 | 0;
 i12 = i13 + 592 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = (i3 | 0) == 0 ? 0 : HEAP32[i11 >> 2] | 0;
 i5 = i4 + i1 | 0;
 if (i5 >>> 0 > 858993459) {
  _UNITY_png_app_error(i13, gb + 354549 | 0);
  return;
 }
 i6 = (i7 | 0) == 0;
 if (i6) if (!i4) {
  i2 = 0;
  i1 = 0;
 } else i9 = 14; else {
  i3 = _UNITY_png_malloc(i13, i5 * 5 | 0) | 0;
  if (!i4) i9 = 14; else {
   _memcpy(i3 | 0, HEAP32[i12 >> 2] | 0, i4 * 5 | 0) | 0;
   i9 = 14;
  }
 }
 do if ((i9 | 0) == 14) if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  if (i1) {
   i10 = i7 & 255;
   if (i6) {
    i8 = (i4 | 0) == 0;
    i7 = 0;
    do {
     i9 = i2 + (i7 * 5 | 0) | 0;
     L32 : do if (!i8) {
      i5 = i3;
      i6 = 0;
      while (1) {
       if (!(_memcmp(i5, i9, 4) | 0)) break;
       i6 = i6 + 1 | 0;
       if (i6 >>> 0 >= i4 >>> 0) break L32; else i5 = i5 + 5 | 0;
      }
      HEAP8[i5 + 4 >> 0] = i10;
     } while (0);
     i7 = i7 + 1 | 0;
    } while ((i7 | 0) != (i1 | 0));
   } else {
    i8 = 0;
    do {
     i7 = i2 + (i8 * 5 | 0) | 0;
     L40 : do if (!i4) {
      i5 = i3;
      i9 = 28;
     } else {
      i5 = i3;
      i6 = 0;
      while (1) {
       if (!(_memcmp(i5, i7, 4) | 0)) break;
       i6 = i6 + 1 | 0;
       i5 = i5 + 5 | 0;
       if (i6 >>> 0 >= i4 >>> 0) {
        i9 = 28;
        break L40;
       }
      }
      HEAP8[i5 + 4 >> 0] = i10;
     } while (0);
     if ((i9 | 0) == 28) {
      i9 = 0;
      i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
      HEAP8[i5 >> 0] = i7;
      HEAP8[i5 + 1 >> 0] = i7 >> 8;
      HEAP8[i5 + 2 >> 0] = i7 >> 16;
      HEAP8[i5 + 3 >> 0] = i7 >> 24;
      HEAP8[i5 + 4 >> 0] = i10;
      i4 = i4 + 1 | 0;
     }
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i1 | 0));
   }
  }
  if (i4 | 0) {
   i2 = i3;
   i5 = i3;
   i1 = 0;
   i6 = 0;
   while (1) {
    if (HEAP8[i5 + 4 >> 0] | 0) {
     if ((i2 | 0) != (i5 | 0)) {
      HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
      HEAP8[i2 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
      HEAP8[i2 + 2 >> 0] = HEAP8[i5 + 2 >> 0] | 0;
      HEAP8[i2 + 3 >> 0] = HEAP8[i5 + 3 >> 0] | 0;
      HEAP8[i2 + 4 >> 0] = HEAP8[i5 + 4 >> 0] | 0;
     }
     i2 = i2 + 5 | 0;
     i1 = i1 + 1 | 0;
    }
    i6 = i6 + 1 | 0;
    if ((i6 | 0) == (i4 | 0)) break; else i5 = i5 + 5 | 0;
   }
   if (i1 | 0) {
    i2 = i3;
    break;
   }
  }
  if ((HEAP32[i12 >> 2] | 0) == (i3 | 0)) {
   i2 = 0;
   i1 = 0;
  } else {
   _UNITY_png_free(i13, i3);
   i2 = 0;
   i1 = 0;
  }
 } while (0);
 HEAP32[i11 >> 2] = i1;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 if (i1 | 0) _UNITY_png_free(i13, i1);
 HEAP32[i12 >> 2] = i2;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i5, i1, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = i11 + 184 | 0;
 i2 = i11 + 180 | 0;
 i10 = i11 + 8 | 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAPF32[i10 + 20 >> 2] = Math_fround(inf);
 HEAP32[i10 + 16 >> 2] = 0;
 i3 = i10 + 24 | 0;
 i4 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i10 + 80 >> 2] = Math_fround(inf);
 HEAP32[i10 + 76 >> 2] = 0;
 HEAP32[i10 + 148 >> 2] = 0;
 i6 = i10 + 152 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i10 + 140 | 0;
 i3 = i10 + 84 | 0;
 i4 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i12 = i9;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i10 + 160 >> 2] = 2;
 HEAP32[i10 + 156 >> 2] = 2;
 HEAP32[i10 + 164 >> 2] = 4;
 HEAP32[i10 + 168 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i2, i8);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, gb + 899379 | 0, i10, 0);
 i8 = i10 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 899332 | 0, gb + 1034188 | 0, i8, 0);
 __ZN17AnimationCurveTplI8Vector3fE8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i10, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i9, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i1, 0);
 HEAP32[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i5 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 i1 = i10 + 136 | 0;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP8[i10 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 STACKTOP = i11;
 return;
}

function __ZN22RenderingCommandBufferC2ERKS_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 8 | 0;
 i7 = i12;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 56592 + 8;
 i11 = i3 + 8 | 0;
 __ZN14GrowableBufferC2ERKS_(i11, i6 + 8 | 0);
 HEAP32[i3 + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP8[i3 + 36 >> 0] = HEAP8[i6 + 36 >> 0] | 0;
 i9 = i3 + 40 | 0;
 i10 = i6 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i3 + 52 >> 2] = i1;
 HEAP32[i3 + 56 >> 2] = i1;
 i2 = i3 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i6 + 44 | 0);
 i14 = i4;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i5 + 4 >> 2] = i13;
 HEAP32[i9 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2, 0, gb + 1047584 | 0, 446) | 0;
 i2 = i6 + 64 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i7);
 i5 = i4;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i3 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i6 + 84 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i7);
 i7 = i4;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3 + 84 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i3 + 164 | 0;
 i5 = i6 + 164 | 0;
 i7 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i7 << 24 >> 24 < 0;
 i5 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i7 = i2 ? HEAP32[i6 + 168 >> 2] | 0 : i7 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 + 176 >> 2] = i2;
 if (i7 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 + 176 >> 2] | 0;
  i8 = 4;
 } else if (i7 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i7;
  if (i7) i8 = 6;
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i13 = i7 + 16 & -16;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i14;
  HEAP32[i3 + 172 >> 2] = i13 | -2147483648;
  HEAP32[i3 + 168 >> 2] = i7;
  i1 = i14;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = i6 + 40 | 0;
 i1 = 0;
 do {
  i14 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 423766 | 0, 49) | 0;
  __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i14, i11, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i14;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 40 | 0;
 i14 = i16 + 36 | 0;
 i15 = i16 + 16 | 0;
 i12 = i16;
 i1 = i17 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i17 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i14, 4); else {
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i15 >> 2] = -1;
 i8 = i18 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i18, HEAP32[i8 >> 2] | 0);
 i9 = i18 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i18 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) <= 0) {
  STACKTOP = i16;
  return;
 }
 i7 = i15 + 4 | 0;
 i10 = i8;
 i11 = i18 + 4 | 0;
 i6 = 0;
 do {
  __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags(i17, i15, gb + 1041891 | 0, 0);
  i5 = HEAP32[i15 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i13 >> 2] = i8;
   i4 = i10;
   i3 = i8;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i13;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(36) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   i2 = i1 + 20 | 0;
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i18 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i1);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (HEAP32[i14 >> 2] | 0));
 STACKTOP = i16;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue10SaveToFileER12FileAccessor(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 8 | 0;
 i16 = i23 + 48 | 0;
 i18 = i23;
 i19 = i23 + 32 | 0;
 i20 = i23 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i8 = (HEAP32[i6 + 4 >> 2] | 0) - i2 >> 2;
 if (!i8) {
  i22 = (i8 | 0) != 0;
  STACKTOP = i23;
  return i22 | 0;
 }
 i9 = i20 + 11 | 0;
 i10 = i20 + 4 | 0;
 i11 = i19 + 12 | 0;
 i5 = i19 + 12 | 0;
 i12 = i16 + 4 | 0;
 i13 = i19 + 8 | 0;
 i14 = i19 + 4 | 0;
 i15 = i19 + 11 | 0;
 i17 = i16 + 4 | 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  i3 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = i18;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  if (!i3) {
   i3 = HEAP8[i2 + 11 >> 0] | 0;
   if (i3 << 24 >> 24 < 0) {
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = 0;
    i2 = HEAP32[i2 >> 2] | 0;
   } else {
    i3 = i3 & 255;
    i4 = 0;
   }
   __ZN12FileAccessor5WriteEyPKvPy(i7, i3, i4, i2, i18) | 0;
   __ZN12FileAccessor5WriteEyPKvPy(i7, 1, 0, gb + 1046952 | 0, i18) | 0;
  } else {
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i21 >> 2] = i3;
   HEAP32[i21 + 4 >> 2] = i2;
   __Z6FormatPKcz(i20, gb + 1046944 | 0, i21);
   i4 = HEAP8[i9 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i20 >> 2] | 0 : i20;
   i4 = i2 ? HEAP32[i10 >> 2] | 0 : i4 & 255;
   HEAP32[i19 >> 2] = 0;
   HEAP32[i19 + 4 >> 2] = 0;
   HEAP32[i19 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i11 >> 2] = i2;
   if (i4 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i19);
    i2 = HEAP32[i5 >> 2] | 0;
    i22 = 11;
   } else if (i4 >>> 0 < 11) {
    HEAP8[i15 >> 0] = i4;
    if (!i4) i2 = i19; else {
     i2 = i19;
     i22 = 13;
    }
   } else i22 = 11;
   if ((i22 | 0) == 11) {
    i24 = i4 + 16 & -16;
    HEAP32[i16 >> 2] = 66;
    HEAP32[i12 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i24, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i19 >> 2] = i2;
    HEAP32[i13 >> 2] = i24 | -2147483648;
    HEAP32[i14 >> 2] = i4;
    i22 = 13;
   }
   if ((i22 | 0) == 13) {
    i22 = 0;
    _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
   }
   HEAP8[i2 + i4 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
   i4 = HEAP8[i15 >> 0] | 0;
   i24 = i4 << 24 >> 24 < 0;
   __ZN12FileAccessor5WriteEyPKvPy(i7, i24 ? HEAP32[i14 >> 2] | 0 : i4 & 255, 0, i24 ? HEAP32[i19 >> 2] | 0 : i19, i18) | 0;
   if ((HEAP8[i15 >> 0] | 0) < 0) {
    i24 = HEAP32[i19 >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    HEAP32[i16 >> 2] = 66;
    HEAP32[i17 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i24, i16);
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i8 | 0)) break;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i24 = (i8 | 0) != 0;
 STACKTOP = i23;
 return i24 | 0;
}

function __ZN5physx2Sn17RepXVisitorReaderINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 352 | 0;
 i6 = i11 + 300 | 0;
 i9 = i11;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i10, gb + 780838 | 0);
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i10 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i7 = HEAP32[i10 + 20 >> 2] | 0;
    i7 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i7;
    i1 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i7;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i7 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP32[i7 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 i7 = i10 + 36 | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i1 = mftCall_ii(HEAP32[i5 + 8 >> 2] | 0, HEAP32[i10 + 24 >> 2] | 0) | 0;
  __ZN5physx32PxArticulationJointGeneratedInfoC2Ev(i9);
  i13 = i10 + 8 | 0;
  i14 = HEAP32[i10 >> 2] | 0;
  i12 = HEAP32[i10 + 4 >> 2] | 0;
  i3 = HEAP32[i10 + 20 >> 2] | 0;
  i4 = HEAP32[i10 + 28 >> 2] | 0;
  i2 = i10 + 32 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP32[i6 >> 2] = i14;
  HEAP32[i6 + 4 >> 2] = i12;
  i12 = i6 + 8 | 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i6 + 20 >> 2] = i3;
  HEAP32[i6 + 24 >> 2] = i1;
  HEAP32[i6 + 28 >> 2] = i4;
  HEAP32[i6 + 32 >> 2] = i5;
  HEAP8[i6 + 36 >> 0] = 1;
  HEAP32[i6 + 40 >> 2] = i8;
  HEAP32[i6 + 44 >> 2] = 0;
  HEAP32[i6 + 48 >> 2] = 0;
  __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEEEEjT_j(i9, i6, 0) | 0;
  if (HEAP8[i8 >> 0] | 0) HEAP8[HEAP32[i10 + 40 >> 2] >> 0] = 1;
  i14 = HEAP32[i2 >> 2] | 0;
  mftCall_viiii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i1 | 0, 0, 0);
 }
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i11;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i10 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5Cache18WriteCacheInfoFileEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 32 | 0;
 i5 = i9 + 92 | 0;
 i6 = i9;
 i2 = i9 + 80 | 0;
 i7 = i9 + 68 | 0;
 i3 = i9 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, i4 + 4 | 0, i3);
 __Z20GetPlatformCachePathv(i5);
 i10 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i10 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i5); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i5, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (!(__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i9;
  return;
 }
 if (i1) {
  i10 = _time(0) | 0;
  HEAP32[i4 + 16 >> 2] = (HEAP32[i4 + 48 >> 2] | 0) + i10;
 }
 i1 = HEAP32[i4 + 56 >> 2] | 0;
 if ((i1 | 0) == (i4 + 60 | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = i2;
  i2 = ((i2 | 0) < 0) << 31 >> 31;
 }
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
 HEAP32[i8 + 8 >> 2] = 1;
 i10 = i8 + 16 | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i2;
 __Z6FormatPKcz(i5, gb + 444391 | 0, i8);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 444384 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i7, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZN4FileC2Ev(i6);
 if (__ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i6, i8, 1, 3) | 0) {
  __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i8, 10, 10) | 0;
  i10 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i10 << 24 >> 24 < 0;
  __ZN4File5WriteEPKvj(i6, i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255) | 0;
  __ZN4File5CloseEv(i6) | 0;
 }
 __ZN4FileD2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE10BeginWriteEjj(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) i1 = (HEAP32[i7 + 24 >> 2] | 0) - i8 | 0;
 i5 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 692 >> 0] | 0;
 HEAP8[i7 + 56 >> 0] = i5;
 if (!(i5 << 24 >> 24)) {
  i1 = i7 + 36 | 0;
  i2 = HEAP32[i7 + 24 >> 2] | 0;
  i3 = i7 + 48 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i7 + 52 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 4, i7 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i1 >> 2] = i6;
   i1 = i6;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i7 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP32[i7 + 60 >> 2] = i8;
  i8 = i1 + i8 | 0;
  return i8 | 0;
 }
 L15 : do switch (HEAP32[i7 + 16 >> 2] | 0) {
 case 2:
  {
   if (i8 | 0) {
    i3 = 50;
    i2 = i7 + 28 | 0;
    break L15;
   }
   i5 = HEAP32[i7 + 24 >> 2] | 0;
   i2 = i7 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if (!i3) i6 = 13; else {
    if ((HEAP32[i3 + 8 >> 2] | 0) >>> 0 >= i5 >>> 0) {
     i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i3) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i4) {
      if (!i3) {
       i6 = 13;
       break;
      }
      i4 = i7 + 32 | 0;
      break;
     }
    }
    __ZN14DataBufferGLES7ReleaseEv(i3);
    HEAP32[i2 >> 2] = 0;
    i6 = 13;
   } while (0);
   if ((i6 | 0) == 13) {
    i3 = __Z20GetBufferManagerGLESv() | 0;
    i4 = i7 + 32 | 0;
    i3 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i3, i5, HEAP32[i4 >> 2] | 0, 0) | 0;
    HEAP32[i2 >> 2] = i3;
   }
   if ((HEAP32[i4 >> 2] | 0) == 3) {
    __ZN14DataBufferGLES13EnsureStorageEi(i3, i5);
    i3 = 50;
   } else i3 = 50;
   break;
  }
 case 1:
  {
   i5 = i1 + i8 | 0;
   i2 = i7 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if (!i3) i6 = 22; else {
    if ((HEAP32[i3 + 8 >> 2] | 0) >>> 0 >= i5 >>> 0) {
     i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i3) | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i4) {
      if (!i3) {
       i6 = 22;
       break;
      }
      i4 = i7 + 32 | 0;
      break;
     }
    }
    __ZN14DataBufferGLES7ReleaseEv(i3);
    HEAP32[i2 >> 2] = 0;
    i6 = 22;
   } while (0);
   if ((i6 | 0) == 22) {
    i3 = __Z20GetBufferManagerGLESv() | 0;
    i4 = i7 + 32 | 0;
    i3 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i3, i5, HEAP32[i4 >> 2] | 0, 0) | 0;
    HEAP32[i2 >> 2] = i3;
   }
   if ((HEAP32[i4 >> 2] | 0) == 3) {
    __ZN14DataBufferGLES13EnsureStorageEi(i3, i5);
    i3 = 58;
   } else i3 = 58;
   break;
  }
 default:
  {
   i8 = 0;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i7 + 60 >> 2] = i8;
 i8 = __ZN14DataBufferGLES3MapEiij(HEAP32[i2 >> 2] | 0, i8, i1, i3) | 0;
 return i8 | 0;
}

function __ZN7mecanim9animation19GetMuscleCurveValueERKNS_5human9HumanPoseERKN4math4trsXEi(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 L1 : do if ((i3 | 0) < 7) switch (i3 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i2 >> 2]);
   break L1;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   break L1;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   break L1;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   break L1;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   break L1;
  }
 case 5:
  {
   f1 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   break L1;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   break L1;
  }
 default:
  {
   f1 = Math_fround(0.0);
   break L1;
  }
 } else {
  if ((i3 | 0) < 14) switch (i3 | 0) {
  case 7:
   {
    f1 = Math_fround(HEAPF32[i4 >> 2]);
    break L1;
   }
  case 8:
   {
    f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
    break L1;
   }
  case 9:
   {
    f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
    break L1;
   }
  case 10:
   {
    f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    break L1;
   }
  case 11:
   {
    f1 = Math_fround(HEAPF32[i4 + 16 >> 2]);
    break L1;
   }
  case 12:
   {
    f1 = Math_fround(HEAPF32[i4 + 20 >> 2]);
    break L1;
   }
  case 13:
   {
    f1 = Math_fround(HEAPF32[i4 + 24 >> 2]);
    break L1;
   }
  default:
   {
    f1 = Math_fround(0.0);
    break L1;
   }
  }
  if ((i3 | 0) < 42) {
   i3 = i3 + -14 | 0;
   i2 = (i3 | 0) / 7 | 0;
   switch ((i3 | 0) % 7 | 0 | 0) {
   case 0:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) >> 2]);
     break L1;
    }
   case 1:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 4 >> 2]);
     break L1;
    }
   case 2:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 8 >> 2]);
     break L1;
    }
   case 3:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 12 >> 2]);
     break L1;
    }
   case 4:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 16 >> 2]);
     break L1;
    }
   case 5:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 20 >> 2]);
     break L1;
    }
   case 6:
    {
     f1 = Math_fround(HEAPF32[i4 + 68 + (i2 << 6) + 24 >> 2]);
     break L1;
    }
   default:
    {
     f1 = Math_fround(0.0);
     break L1;
    }
   }
  }
  if ((i3 | 0) < 94) {
   f1 = Math_fround(HEAPF32[i4 + 596 + (i3 + -42 << 2) >> 2]);
   break;
  }
  if ((i3 | 0) < 114) {
   f1 = Math_fround(HEAPF32[i4 + 364 + (i3 + -94 << 2) >> 2]);
   break;
  }
  if ((i3 | 0) < 134) {
   f1 = Math_fround(HEAPF32[i4 + 500 + (i3 + -114 << 2) >> 2]);
   break;
  }
  if ((i3 | 0) < 155) {
   i3 = i3 + -134 | 0;
   i2 = (i3 | 0) / 3 | 0;
   switch ((i3 | 0) % 3 | 0 | 0) {
   case 0:
    {
     f1 = Math_fround(HEAPF32[i4 + 804 + (i2 * 12 | 0) >> 2]);
     break L1;
    }
   case 1:
    {
     f1 = Math_fround(HEAPF32[i4 + 804 + (i2 * 12 | 0) + 4 >> 2]);
     break L1;
    }
   case 2:
    {
     f1 = Math_fround(HEAPF32[i4 + 804 + (i2 * 12 | 0) + 8 >> 2]);
     break L1;
    }
   default:
    {
     f1 = Math_fround(0.0);
     break L1;
    }
   }
  } else f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN5physx3Scb10Constraint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 125508 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 125508 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 125508 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 125508 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 125508 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 125508 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 125508 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 125508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 747864;
 HEAP32[i7 + 4 >> 2] = gb + 747700;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 112;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 125540 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 125540 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 125540 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 125540 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 125540 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 125540 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 125540 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 125540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 125572 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125572 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125572 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125572 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125572 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125572 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125572 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 125604 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 125604 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 125604 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 125604 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 125604 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 125604 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 125604 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 125604 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125636 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125636 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125636 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125636 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125636 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125636 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125636 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125636 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z17PrepareUDPAddressPKctP8sockaddrjih(i10, i2, i13, i14, i4, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 72 | 0;
 i11 = i15 + 64 | 0;
 i9 = i15 + 56 | 0;
 i5 = i15 + 48 | 0;
 i8 = i15;
 i6 = i15 + 88 | 0;
 i12 = i15 + 80 | 0;
 i7 = i15 + 120 | 0;
 if (!i10) {
  i14 = -1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = i2 & 65535;
 HEAP32[i8 >> 2] = i1;
 _snprintf(i7, 6, gb + 458892 | 0, i8) | 0;
 L4 : do switch (i4 | 0) {
 case 2:
  {
   i1 = i6 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 2;
   HEAP32[i6 >> 2] = 4;
   HEAP32[i6 + 8 >> 2] = 2;
   i1 = _getaddrinfo(i10 | 0, i7 | 0, i6 | 0, i12 | 0) | 0;
   if (!i1) {
    i12 = HEAP32[i12 >> 2] | 0;
    _memset(i13 | 0, 0, i14 | 0) | 0;
    i1 = i12 + 16 | 0;
    _memcpy(i13 | 0, HEAP32[i12 + 20 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    _freeaddrinfo(i12);
    break L4;
   } else {
    HEAP32[i5 >> 2] = _gai_strerror(i1 | 0) | 0;
    _printf_console(gb + 458896 | 0, i5);
    i1 = -1;
    break L4;
   }
  }
 case 10:
  {
   i1 = i6 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   i1 = i6 + 4 | 0;
   HEAP32[i1 >> 2] = 10;
   HEAP32[i6 >> 2] = 4;
   i2 = i6 + 8 | 0;
   HEAP32[i2 >> 2] = 2;
   if (!(_getaddrinfo(i10 | 0, i7 | 0, i6 | 0, i12 | 0) | 0)) {
    i12 = HEAP32[i12 >> 2] | 0;
    _memset(i13 | 0, 0, i14 | 0) | 0;
    i1 = i12 + 16 | 0;
    _memcpy(i13 | 0, HEAP32[i12 + 20 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    _freeaddrinfo(i12);
    break L4;
   }
   i3 = i8;
   i4 = i3 + 46 | 0;
   do {
    HEAP8[i3 >> 0] = 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i4 | 0));
   HEAP32[i9 >> 2] = i10;
   _snprintf(i8, 46, gb + 459096 | 0, i9) | 0;
   i10 = i6 + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   HEAP32[i10 + 24 >> 2] = 0;
   HEAP32[i1 >> 2] = 10;
   HEAP32[i6 >> 2] = 4;
   HEAP32[i2 >> 2] = 2;
   i1 = _getaddrinfo(i8 | 0, i7 | 0, i6 | 0, i12 | 0) | 0;
   if (!i1) {
    i12 = HEAP32[i12 >> 2] | 0;
    _memset(i13 | 0, 0, i14 | 0) | 0;
    i1 = i12 + 16 | 0;
    _memcpy(i13 | 0, HEAP32[i12 + 20 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    _freeaddrinfo(i12);
   } else {
    HEAP32[i11 >> 2] = _gai_strerror(i1 | 0) | 0;
    _printf_console(gb + 458896 | 0, i11);
    i1 = -1;
   }
   break;
  }
 default:
  {
   HEAP32[i3 >> 2] = i10;
   HEAP32[i3 + 4 >> 2] = i1;
   _printf_console(gb + 459106 | 0, i3);
   i1 = -1;
  }
 } while (0);
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN4FMOD7SystemIC2Ei(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 1;
 HEAP32[i2 + 20 >> 2] = 0;
 i3 = i2 + 24 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 + 28 >> 2] = i3;
 HEAP32[i2 + 32 >> 2] = i3;
 HEAP32[i2 + 36 >> 2] = 0;
 i3 = i2 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 1024;
 HEAP32[i2 + 48 >> 2] = 2;
 HEAPF32[i2 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 60 >> 2] = Math_fround(1.0);
 i1 = i2 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = i1;
 HEAP32[i2 + 72 >> 2] = i1;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = i2;
 i5 = i2 + 80 | 0;
 i4 = i2 + 92 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = i4;
 HEAP32[i2 + 100 >> 2] = i4;
 i4 = i2 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = i4;
 HEAP32[i2 + 112 >> 2] = i4;
 HEAP32[i2 + 116 >> 2] = 0;
 HEAP32[i2 + 120 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi(i1, 1024);
 i1 = i2 + 124 | 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i2 + 128 | 0;
 i5 = i2 + 140 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 + 144 >> 2] = i5;
 HEAP32[i2 + 148 >> 2] = i5;
 i5 = i2 + 152 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 156 >> 2] = i5;
 HEAP32[i2 + 160 >> 2] = i5;
 HEAP32[i2 + 164 >> 2] = 0;
 HEAP32[i2 + 168 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7SetSizeEi(i1, 512);
 i1 = i2 + 172 | 0;
 HEAP32[i1 >> 2] = i2;
 i5 = i2 + 176 | 0;
 i4 = i2 + 188 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i2 + 192 >> 2] = i4;
 HEAP32[i2 + 196 >> 2] = i4;
 i4 = i2 + 200 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 204 >> 2] = i4;
 HEAP32[i2 + 208 >> 2] = i4;
 HEAP32[i2 + 212 >> 2] = 0;
 HEAP32[i2 + 216 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7SetSizeEi(i1, 4096);
 i1 = i2 + 220 | 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i2 + 224 | 0;
 i5 = i2 + 236 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 + 240 >> 2] = i5;
 HEAP32[i2 + 244 >> 2] = i5;
 i5 = i2 + 248 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 252 >> 2] = i5;
 HEAP32[i2 + 256 >> 2] = i5;
 HEAP32[i2 + 260 >> 2] = 0;
 HEAP32[i2 + 264 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7SetSizeEi(i1, 1024);
 i1 = i2 + 268 | 0;
 HEAP32[i1 >> 2] = i2;
 i5 = i2 + 272 | 0;
 i4 = i2 + 284 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i2 + 288 >> 2] = i4;
 HEAP32[i2 + 292 >> 2] = i4;
 i4 = i2 + 296 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 300 >> 2] = i4;
 HEAP32[i2 + 304 >> 2] = i4;
 HEAP32[i2 + 308 >> 2] = 0;
 HEAP32[i2 + 312 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7SetSizeEi(i1, 1024);
 i1 = i2 + 316 | 0;
 i2 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i3 >> 2] = 32;
 return;
}

function _compress_first_pass(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = HEAP32[i14 + 328 >> 2] | 0;
 i22 = (HEAP32[i14 + 224 >> 2] | 0) + -1 | 0;
 i23 = i14 + 60 | 0;
 if ((HEAP32[i23 >> 2] | 0) <= 0) {
  i23 = _compress_output(i14, i15) | 0;
  return i23 | 0;
 }
 i16 = i14 + 4 | 0;
 i17 = i21 + 8 | 0;
 i18 = i14 + 344 | 0;
 i12 = HEAP32[i14 + 68 >> 2] | 0;
 i13 = 0;
 while (1) {
  i19 = i12 + 12 | 0;
  i20 = HEAP32[i19 >> 2] | 0;
  i20 = mftCall_iiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, HEAP32[i21 + 64 + (i13 << 2) >> 2] | 0, Math_imul(i20, HEAP32[i17 >> 2] | 0) | 0, i20 | 0, 1) | 0;
  if ((HEAP32[i17 >> 2] | 0) >>> 0 < i22 >>> 0) i1 = HEAP32[i19 >> 2] | 0; else {
   i11 = HEAP32[i19 >> 2] | 0;
   i1 = ((HEAP32[i12 + 32 >> 2] | 0) >>> 0) % (i11 >>> 0) | 0;
   i1 = (i1 | 0) == 0 ? i11 : i1;
  }
  i8 = HEAP32[i12 + 28 >> 2] | 0;
  i11 = HEAP32[i12 + 8 >> 2] | 0;
  i7 = (i8 >>> 0) % (i11 >>> 0) | 0;
  i7 = (i7 | 0) > 0 ? i11 - i7 | 0 : i7;
  L10 : do if ((i1 | 0) > 0) {
   i9 = i15 + (i13 << 2) | 0;
   i4 = i7 << 7;
   if ((i7 | 0) > 0) i2 = 0; else {
    i2 = 0;
    while (1) {
     mftCall_viiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 4 >> 2] | 0, i14 | 0, i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i20 + (i2 << 2) >> 2] | 0, i2 << 3 | 0, 0, i8 | 0);
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i1 | 0)) break L10;
    }
   }
   do {
    i5 = HEAP32[i20 + (i2 << 2) >> 2] | 0;
    mftCall_viiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 4 >> 2] | 0, i14 | 0, i12 | 0, HEAP32[i9 >> 2] | 0, i5 | 0, i2 << 3 | 0, 0, i8 | 0);
    i5 = i5 + (i8 << 7) | 0;
    _jzero_far(i5, i4);
    i6 = HEAP16[i5 + -128 >> 1] | 0;
    i3 = 0;
    do {
     HEAP16[i5 + (i3 << 7) >> 1] = i6;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i7 | 0));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  } while (0);
  L21 : do if ((HEAP32[i17 >> 2] | 0) == (i22 | 0)) {
   i2 = i7 + i8 | 0;
   i7 = (i2 >>> 0) / (i11 >>> 0) | 0;
   if ((i1 | 0) < (HEAP32[i19 >> 2] | 0)) {
    i10 = i2 << 7;
    i8 = i11 + -1 | 0;
    i9 = (i11 | 0) > 0;
    if (i11 >>> 0 > i2 >>> 0) while (1) {
     _jzero_far(HEAP32[i20 + (i1 << 2) >> 2] | 0, i10);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (HEAP32[i19 >> 2] | 0)) break L21;
    }
    do {
     i2 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
     i3 = HEAP32[i20 + (i1 + -1 << 2) >> 2] | 0;
     _jzero_far(i2, i10);
     if (i9) {
      i6 = 0;
      while (1) {
       i5 = HEAP16[i3 + (i8 << 7) >> 1] | 0;
       i4 = 0;
       do {
        HEAP16[i2 + (i4 << 7) >> 1] = i5;
        i4 = i4 + 1 | 0;
       } while ((i4 | 0) != (i11 | 0));
       i6 = i6 + 1 | 0;
       if (i6 >>> 0 >= i7 >>> 0) break; else {
        i2 = i2 + (i11 << 7) | 0;
        i3 = i3 + (i11 << 7) | 0;
       }
      }
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i19 >> 2] | 0));
   }
  } while (0);
  i13 = i13 + 1 | 0;
  if ((i13 | 0) >= (HEAP32[i23 >> 2] | 0)) break; else i12 = i12 + 84 | 0;
 }
 i23 = _compress_output(i14, i15) | 0;
 return i23 | 0;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 52 | 0) + 1 | 0;
 if ((i8 | 0) < -52) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 52 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 2147483647;
 i1 = (i2 - i1 | 0) / 52 | 0;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 16;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 52 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i3 + (i1 * 52 | 0) | 0;
 i2 = i4;
 i7 = i3 + (i5 * 52 | 0) | 0;
 i15 = i6;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i14;
 HEAP32[i3 + (i1 * 52 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + (i1 * 52 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + (i1 * 52 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + (i1 * 52 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + (i1 * 52 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + (i1 * 52 | 0) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 i5 = i3 + (i1 * 52 | 0) + 32 | 0;
 i1 = i6 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 i5 = i4 + 52 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  do {
   i14 = i3;
   i3 = i3 + -52 | 0;
   i16 = i3;
   i6 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = i4 + -52 | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = i6;
   HEAP32[i4 + -44 >> 2] = HEAP32[i14 + -44 >> 2];
   HEAP32[i4 + -40 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i4 + -36 >> 2] = HEAP32[i14 + -36 >> 2];
   HEAP32[i4 + -32 >> 2] = HEAP32[i14 + -32 >> 2];
   HEAP32[i4 + -28 >> 2] = HEAP32[i14 + -28 >> 2];
   HEAP32[i4 + -24 >> 2] = HEAP32[i14 + -24 >> 2];
   i15 = i4 + -20 | 0;
   i14 = i14 + -20 | 0;
   HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i15 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   i4 = i2 + -52 | 0;
   i2 = i4;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i16 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 16;
 HEAP32[i10 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i2 = i9 + 48 | 0;
 __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_(i9, i9 + 24 | 0, i2, i1) | 0;
 i1 = i9 + 72 | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i12;
  return;
 }
 i7 = i1;
 while (1) {
  i6 = HEAP32[i7 >> 2] | 0;
  i1 = _strcmp(i6, HEAP32[i2 >> 2] | 0) | 0;
  if (!i1) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAP32[i7 + 4 >> 2] | 0;
    if (!i3) {
     i3 = 0;
     i11 = 10;
    } else if ((HEAP32[i3 + 16 >> 2] | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i11 = 10;
   }
  } else if ((i1 | 0) < 0) {
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i11 = 10;
  }
  if ((i11 | 0) == 10) {
   i11 = 0;
   i5 = i7 + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i5 = i3 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   L14 : do if ((i2 | 0) == (i9 | 0)) i1 = i9; else {
    if (!i3) while (1) {
     i1 = i2;
     i2 = i2 + -24 | 0;
     i4 = _strcmp(i6, HEAP32[i2 >> 2] | 0) | 0;
     if (!i4) {
      if (!(HEAP32[i1 + -20 >> 2] | 0)) break L14;
     } else if ((i4 | 0) >= 0) break L14;
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     if ((i2 | 0) == (i9 | 0)) {
      i1 = i9;
      break L14;
     }
    }
    while (1) {
     i1 = i2;
     i2 = i2 + -24 | 0;
     i4 = _strcmp(i6, HEAP32[i2 >> 2] | 0) | 0;
     if (!i4) {
      i4 = HEAP32[i1 + -20 >> 2] | 0;
      if (!i4) break L14;
      if ((HEAP32[i5 >> 2] | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) break L14;
     } else if ((i4 | 0) >= 0) break L14;
     HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
     if ((i2 | 0) == (i9 | 0)) {
      i1 = i9;
      break;
     }
    }
   } while (0);
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i3;
   i6 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  }
  i1 = i7 + 24 | 0;
  if ((i1 | 0) == (i10 | 0)) break; else {
   i2 = i7;
   i7 = i1;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx2Gu5RTree4loadERNS_13PxInputStreamEj(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 5 | 0;
 i4 = i11 + 4 | 0;
 i5 = i11 + 3 | 0;
 i6 = i11 + 2 | 0;
 i7 = i11 + 1 | 0;
 i8 = i11;
 if (!(HEAP32[i9 + 84 >> 2] & 1)) {
  i2 = i9 + 92 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __ZN5physx9readChunkERaS0_S0_S0_RNS_13PxInputStreamE(i4, i5, i6, i7, i10);
 if (!((HEAP8[i4 >> 0] | 0) == 82 & (HEAP8[i5 >> 0] | 0) == 84 & (HEAP8[i6 >> 0] | 0) == 82 & (HEAP8[i7 >> 0] | 0) == 69)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i7 = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 if ((i7 | 0) != (HEAP32[gb + 107348 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i9, 4, 1, i10) | 0;
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i9 + 16 | 0, 4, 1, i10) | 0;
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i9 + 32 | 0, 4, 1, i10) | 0;
 __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i9 + 48 | 0, 4, 1, i10) | 0;
 HEAP32[i9 + 64 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 HEAP32[i9 + 68 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 HEAP32[i9 + 72 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 HEAP32[i9 + 76 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 i4 = i9 + 80 | 0;
 HEAP32[i4 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 HEAP32[i9 + 88 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE(1, i10) | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, ((HEAP32[i4 >> 2] | 0) * 112 | 0) + 131 | 0, gb + 725159 | 0, 121) | 0;
 if (!i1) i1 = 0; else {
  i8 = i1 + 131 & -128;
  HEAP32[i8 + -4 >> 2] = i8 - i1;
  i1 = i8;
 }
 i3 = i9 + 92 | 0;
 HEAP32[i3 >> 2] = i1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = 0;
 while (1) {
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i1 + (i2 * 112 | 0) | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 16 | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 32 | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 48 | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 64 | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 80 | 0, 4, 1, i10) | 0;
  __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE((HEAP32[i3 >> 2] | 0) + (i2 * 112 | 0) + 96 | 0, 4, 1, i10) | 0;
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
   i1 = 1;
   break;
  }
  i1 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx3Scb9Aggregate17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 125156 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 125156 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 125156 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 125156 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 125156 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 125156 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 125156 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 125156 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 747685;
 HEAP32[i7 + 4 >> 2] = gb + 747700;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 28;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 125188 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 125188 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 125188 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 125188 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 125188 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 125188 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 125188 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 125188 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 125220 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125220 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125220 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125220 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125220 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125220 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125220 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125220 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 125252 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 125252 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 125252 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 125252 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 125252 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 125252 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 125252 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 125252 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125284 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125284 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125284 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125284 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125284 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125284 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125284 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125284 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}
function __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 24 | 0;
 i11 = i12;
 i8 = i12 + 16 | 0;
 i3 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i9 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i11 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i11; else {
   i1 = i11;
   i9 = 6;
  }
 } else i9 = 4;
 if ((i9 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i4;
  i2 = i11 + 11 | 0;
  i9 = 6;
 }
 if ((i9 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i5 = _strlen(i6) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) {
  i4 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 } else {
  i4 = 10;
  i1 = i1 & 255;
 }
 if ((i4 - i1 | 0) >>> 0 < i5 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i4, i5 - i4 + i1 | 0, i1, i1, 0, i5, i6); else if (i5 | 0) {
  i3 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  _memcpy(i3 + i1 | 0, i6 | 0, i5 | 0) | 0;
  i1 = i1 + i5 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i2 >> 0] = i1;
  HEAP8[i3 + i1 >> 0] = 0;
 }
 i6 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
 HEAP32[i10 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i10, i6);
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 L23 : do if ((i1 | 0) < (i3 | 0)) {
  i4 = HEAP32[i7 + 32 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i9 = 22;
    break L23;
   }
  }
  if ((i1 | 0) < 0) i9 = 22; else {
   i8 = (HEAP32[i7 + 52 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | -2147483648;
  }
 } else i9 = 22; while (0);
 if ((i9 | 0) == 22) {
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i8, i7, i10, 1, 16, 0, -2147483648);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i1 - (HEAP32[i6 >> 2] | 0) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return i1 | 0;
}

function __Z33SwitchToStandaloneDefaultSettingsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 36 | 0;
 i4 = i9;
 i5 = i9 + 24 | 0;
 i7 = i9 + 12 | 0;
 i6 = __Z18GetQualitySettingsv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, 0);
 i6 = __Z17GetPlayerSettingsv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 583834 | 0, 30);
 i2 = __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, HEAP32[i6 + 300 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 583865 | 0, 31);
 i1 = __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, HEAP32[i6 + 304 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 583897 | 0, 32);
 i8 = (__ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, HEAPU8[i6 + 386 >> 0] | 0) | 0) != 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 do if (i8) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 583834 | 0, 30);
  if (__ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 583865 | 0, 31);
   i10 = __ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4) | 0;
   i6 = (HEAP8[i6 + 387 >> 0] | 0) != 0 & (i10 ^ 1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   if (!i6) break;
  } else {
   i10 = (HEAP8[i6 + 387 >> 0] | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   if (i10) break;
  }
  i2 = __Z16GetScreenManagerv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i2 | 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = __Z16GetScreenManagerv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i1 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 } while (0);
 i10 = __Z16GetScreenManagerv() | 0;
 i10 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0, i2 | 0, i1 | 0, i8 | 0, 0) | 0;
 i8 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, 1);
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6ignoreEij(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i8 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i8;
  i3 = i8;
  i7 = 23;
 } else do if (HEAP8[i1 >> 0] | 0) {
  L6 : do if ((i4 | 0) == 2147483647) {
   while (1) {
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (i4 & 1) break;
    } else {
     HEAP32[i2 >> 2] = i3 + 4;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    if ((i1 | 0) == -1) {
     i1 = 2;
     i7 = 21;
     break L6;
    }
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = 0;
     i7 = 21;
     break L6;
    }
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else {
   i2 = HEAP32[i6 >> 2] | 0;
   while (1) {
    if ((i2 | 0) >= (i4 | 0)) {
     i1 = 0;
     i7 = 21;
     break L6;
    }
    i1 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i2 = i1 + 12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i3 = __THREW__;
     __THREW__ = 0;
     if (i3 & 1) break;
    } else {
     HEAP32[i2 >> 2] = i3 + 4;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    if ((i1 | 0) == -1) {
     i1 = 2;
     i7 = 21;
     break L6;
    }
    i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
    HEAP32[i6 >> 2] = i2;
    if ((i1 | 0) == (i5 | 0)) {
     i1 = 0;
     i7 = 21;
     break L6;
    }
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } while (0);
  if ((i7 | 0) == 21) {
   i6 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | i1 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) break;
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  }
  i2 = i8;
  i3 = i8;
  i7 = 23;
  break L1;
 } while (0); while (0);
 do if ((i7 | 0) == 23) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx11NpAggregate17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 160 | 0;
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i8 >> 2] = HEAP32[gb + 123780 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 123780 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 123780 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[gb + 123780 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[gb + 123780 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[gb + 123780 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[gb + 123780 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[gb + 123780 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i8 | 0, 32) | 0;
 HEAP32[i7 >> 2] = gb + 754705;
 HEAP32[i7 + 4 >> 2] = gb + 827530;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 44;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 123812 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123812 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123812 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123812 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123812 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123812 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123812 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123812 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123844 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123844 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123844 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123844 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123844 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123844 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123844 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123844 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123876 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123876 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123876 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123876 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123876 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123876 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123876 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123876 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123908 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123908 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123908 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123908 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123908 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123908 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123908 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123908 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN11NavMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i12) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i12);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i12, i8 + 52 | 0, 0);
 __ZN13NavMeshParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 32 | 0, i12);
 i4 = i8 + 80 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i11 = i12 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i12 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
 i1 = HEAP32[i8 + 68 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
   i5 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 12 | 0, i12);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i3 = i8 + 88 | 0;
 i7 = i8 + 92 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 84 | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14HeightMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 84 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = i8 + 104 | 0;
 i7 = i8 + 108 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 5;
 HEAP32[i10 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i10, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN19AutoOffMeshLinkData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i13;
 return;
}

function __ZN9Texture2D34CreateFileTextureUploadInstructionEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i3 = i7 + 128 | 0;
 i4 = i3 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i7 + 132 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = __ZN18AsyncUploadManager17CreateInstructionEv(__Z21GetAsyncUploadManagerv() | 0) | 0;
 i6 = i5 + 76 | 0;
 i2 = i5 + 100 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i5 + 128 >> 2] = 0;
 i6 = i7 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i5 + 96 >> 2] = i2;
 HEAP32[i5 + 60 >> 2] = i2;
 i2 = __Z13GetFileSystemv() | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i3 >> 2] | 0; else i1 = i3;
 __ZNK10FileSystem10ToAbsoluteEPKc(i8, i2, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5 + 156 | 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5 + 168 | 0, mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0) | 0;
 HEAP32[i5 + 136 >> 2] = HEAP32[i7 + 120 >> 2];
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 136 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i5 + 48 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0) | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 116 >> 2] | 0, i7 | 0) | 0;
 i1 = i5 + 64 | 0;
 i4 = HEAP32[i1 >> 2] & -256 | i4 & 255;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 >> 2] = HEAP32[i7 + 56 >> 2] << 18 & 3932160 | i4 & -3932161;
 HEAP32[i5 + 52 >> 2] = 1;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i2 = HEAP32[i7 + 60 >> 2] << 27 & 402653184; else i2 = 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -402653185 | i2;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0, i7 | 0) | 0;
 i4 = HEAP32[i1 >> 2] & -245761 | i4 << 14 & 245760;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 >> 2] = ((HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0) > 1 & 1) << 31 | i4 & 2147483647;
 HEAP32[i5 + 132 >> 2] = i7;
 HEAP8[i5 + 180 >> 0] = 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 176 >> 2] | 0, i7 | 0, i5 | 0);
 i6 = HEAP32[i1 >> 2] & -29360129 | HEAP32[i7 + 32 >> 2] << 22 & 29360128;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 >> 2] = HEAP32[i7 + 36 >> 2] << 8 & 16128 | i6 & -16129;
 HEAP32[i5 + 56 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP8[i7 + 109 >> 0] = 1;
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 48 >> 2];
 __ZN18AsyncUploadManager22UploadStreamingTextureEP28FileTextureUploadInstruction(i8, __Z21GetAsyncUploadManagerv() | 0, i5);
 i5 = i8;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i7 + 144 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5Umbra12PortalCuller14findRemoteCellERNS0_4TileEiiRNS0_9CellStateE(i16, i13, i14, i17, i15) {
 i16 = i16 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i18 = 0;
 i1 = i16 + 2292 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i14 | 0)) i1 = HEAPU16[i16 + 2128 + (HEAP32[i16 + 2288 >> 2] << 2) >> 1] | 0; else {
  i4 = HEAP32[HEAP32[i16 + 432 >> 2] >> 2] | 0;
  i2 = HEAP32[i4 + 24 >> 2] | 0;
  i4 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = Math_imul(i4, i14) | 0;
  i12 = i16 + 2288 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = i14;
  if (!i4) {
   i2 = 1;
   i1 = 0;
  } else {
   i10 = HEAP32[i2 + 4 >> 2] | 0;
   i11 = i16 + 484 | 0;
   i9 = HEAP32[i2 + 20 >> 2] | 0;
   i8 = i3 >> 5;
   i2 = 1;
   i1 = 0;
   i6 = i3 & 31;
   while (1) {
    i5 = i8;
    i8 = i8 + 1 | 0;
    i3 = 32 - i6 | 0;
    i3 = (i3 | 0) <= (i4 | 0) ? i3 : i4;
    i4 = i4 - i3 | 0;
    if (i3) {
     i7 = i3;
     i6 = (HEAP32[i10 + (Math_imul(i5, i9) | 0) >> 2] | 0) >>> i6;
     while (1) {
      i7 = i7 + -1 | 0;
      i5 = i6 & 1;
      if (i1) {
       i3 = HEAP16[(HEAP32[i11 >> 2] | 0) + (i2 << 1) >> 1] | 0;
       if (!(i3 & 32767)) {
        i18 = HEAP32[i12 >> 2] | 0;
        HEAP32[i12 >> 2] = i18 + 1;
        HEAP16[i16 + 2128 + (i18 << 2) >> 1] = i2;
       }
       i2 = (i3 & 16383) + (i5 ^ 1) | 0;
      }
      i1 = i5 | i1;
      if (!i7) break; else i6 = i6 >>> 1;
     }
    }
    if (!i4) break; else i6 = 0;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  HEAP16[i16 + 2128 + (i1 << 2) >> 1] = i2;
  i1 = i2;
 }
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i14;
 i4 = i16 + 2300 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP16[(HEAP32[i16 + 484 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 L22 : do if (i1 << 16 >> 16) {
  while (1) {
   i2 = i1 & 65535;
   if ((HEAPU16[i3 + (i2 << 4) + 4 >> 1] | 0 | 0) == (i17 | 0)) break;
   i1 = HEAP16[i3 + (i2 << 4) >> 1] | 0;
   if (!(i1 << 16 >> 16)) break L22;
  }
  HEAP32[i15 >> 2] = 2;
  i18 = i1;
  return i18 | 0;
 } while (0);
 HEAP32[i15 >> 2] = 0;
 i2 = i16 + 2304 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 do if (!(i1 << 16 >> 16)) {
  i2 = i16 + 2306 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 << 16 >> 16)) {
   i18 = 0;
   return i18 | 0;
  } else {
   i18 = i1 & 65535;
   HEAP16[i2 >> 1] = HEAP16[(HEAP32[i4 >> 2] | 0) + (i18 << 4) >> 1] | 0;
   i2 = i16 + 7048 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   __ZN5Umbra12PortalCuller12finalizeCellEt(i16, i1);
   i2 = HEAP32[i4 >> 2] | 0;
   i15 = i2 + (i18 << 4) + 8 | 0;
   __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i16 + 292 >> 2] | 0, i15);
   HEAP8[i15 >> 0] = 0;
   HEAP8[i15 + 1 >> 0] = 0;
   HEAP8[i15 + 2 >> 0] = 0;
   HEAP8[i15 + 3 >> 0] = 0;
   HEAP32[i2 + (i18 << 4) + 12 >> 2] = 0;
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP16[i16 + 2936 + ((HEAPU16[i2 + (i18 << 4) + 4 >> 1] | 0) << 1) >> 1] = i1;
   break;
  }
 } else {
  i18 = HEAP32[i4 >> 2] | 0;
  HEAP16[i2 >> 1] = HEAP16[i18 + ((i1 & 65535) << 4) >> 1] | 0;
  i2 = i18;
 } while (0);
 HEAP16[i2 + ((i1 & 65535) << 4) + 4 >> 1] = i17;
 i18 = i1;
 return i18 | 0;
}

function __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi(i10, i1, i6, i8, i11, f12, i13) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i7 = i15 + 68 | 0;
 i14 = HEAP32[gb + 1451096 >> 2] | 0;
 if (i1) {
  i1 = HEAP32[i14 + 468 >> 2] | 0;
  i2 = i9;
  i3 = i1;
  i4 = i2 + 68 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  if ((HEAP8[i9 >> 0] | 0) == 15) i2 = 0; else {
   HEAP8[i9 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 8 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 16 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 24 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 32 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 40 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 48 | 0;
  if ((HEAP8[i3 >> 0] | 0) != 15) {
   HEAP8[i3 >> 0] = 15;
   i2 = 1;
  }
  i3 = i9 + 56 | 0;
  if ((HEAP8[i3 >> 0] | 0) == 15) {
   if (i2) i5 = 5;
  } else {
   HEAP8[i3 >> 0] = 15;
   i5 = 5;
  }
  if ((i5 | 0) == 5) i1 = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i14, i9) | 0;
  __ZN12_GLOBAL__N_113SetBlendStateER7ApiGLESR15DeviceStateGLESPK20DeviceBlendStateGLESi(i10, i14, i1, 1);
  i5 = HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 185 >> 0] | 0 ? 49152 : 16384;
 } else i5 = 0;
 if (i6) {
  i3 = i14 + 460 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i1 >> 0] & 1)) {
   i1 = HEAP8[i1 + 1 >> 0] | 0;
   HEAP8[i7 >> 0] = 1;
   HEAP8[i7 + 1 >> 0] = i1;
   HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP8[i9 + 1 >> 0] = HEAP8[i7 + 1 >> 0] | 0;
   i1 = __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i14, i9) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    HEAP32[i3 >> 2] = i1;
    if ((HEAP8[i2 + 1 >> 0] | 0) != (HEAP8[i1 + 1 >> 0] | 0)) mftCall_vi(HEAP32[i10 + 36 >> 2] | 0, HEAPU16[i1 + 2 >> 1] | 0);
    i1 = HEAP8[i1 >> 0] | 0;
    if (i1 << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) mftCall_vi(HEAP32[i10 + 40 >> 2] | 0, i1 | 0);
   }
  }
  i5 = i5 | 256;
 }
 if (!i8) {
  i14 = i5;
  __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi(i10, i14, i11, 0, f12, i13);
  STACKTOP = i15;
  return;
 }
 i3 = __Z16GetRealGfxDevicev() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0;
 i1 = HEAP32[i14 + 464 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i2 = i9 + 2 | 0;
 if ((HEAP8[i2 >> 0] | 0) != -1) {
  HEAP8[i2 >> 0] = -1;
  i1 = __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i14, i9) | 0;
 }
 mftCall_viii(i4 | 0, i3 | 0, i1 | 0, HEAP32[i14 + 564 >> 2] | 0);
 i14 = i5 | 1024;
 __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi(i10, i14, i11, 0, f12, i13);
 STACKTOP = i15;
 return;
}

function __ZN22UnityProfilerPerThread18BeginSampleDynamicERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i12, i1, i13) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i9 = i14 + 8 | 0;
 i5 = i14;
 if (!(HEAP8[i12 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i11 = i12 + 204 | 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i7 = i12 + 208 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) i6 = 9; else {
  i1 = i7;
  L5 : while (1) {
   i3 = i2;
   while (1) {
    if ((_strcmp(HEAP32[i3 + 16 >> 2] | 0, i4) | 0) >= 0) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L5; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i7 | 0)) i6 = 9; else if ((_strcmp(i4, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0 | (i1 | 0) == (i7 | 0)) i6 = 9;
 }
 if ((i6 | 0) == 9) {
  i8 = (_strlen(i4) | 0) + 1 | 0;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, gb + 63576 | 0, 0, gb + 461711 | 0, 48) | 0;
  _strncpy(i6, i4, i8) | 0;
  __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(i5, 0, 1, 0);
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i6;
  i1 = HEAP32[i7 >> 2] | 0;
  do if (!i1) {
   HEAP32[i9 >> 2] = i7;
   i2 = i7;
   i3 = i7;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((_strcmp(i6, i2) | 0) < 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i6 = 12;
      break;
     } else i1 = i2;
    } else {
     if ((_strcmp(i2, i6) | 0) >= 0) {
      i6 = 17;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i6 = 16;
      break;
     } else i1 = i2;
    }
   }
   if ((i6 | 0) == 12) {
    HEAP32[i9 >> 2] = i1;
    i2 = i1;
    i3 = i1;
    break;
   } else if ((i6 | 0) == 16) {
    HEAP32[i9 >> 2] = i1;
    i2 = i1;
    break;
   } else if ((i6 | 0) == 17) {
    HEAP32[i9 >> 2] = i1;
    i2 = i1;
    i3 = i9;
    break;
   }
  } while (0);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i12 + 212 >> 2] | 0;
   HEAP32[i10 >> 2] = 57;
   HEAP32[i10 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 + 16 >> 2] = i8;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i10 + 4 >> 2] = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i11 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 208 >> 2] | 0, i2);
   i11 = i12 + 216 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP16[i1 + 24 >> 1] = 1;
 }
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i12, i1 + 20 | 0, i13) | 0;
 STACKTOP = i14;
 return;
}

function __ZN10GameObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 24 | 0;
 i9 = i13 + 8 | 0;
 i10 = i13;
 if (!(HEAP32[i8 >> 2] & 16384)) {
  i3 = i12 + 28 | 0;
  i4 = i8 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i2 + 4 | 0;
  i5 = i8 + 24 | 0;
  if (i1 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i4, i11, 4);
   i1 = HEAP32[i11 >> 2] | 0;
  } else {
   i7 = HEAP32[i2 >> 2] | 0;
   HEAP32[i11 >> 2] = i7;
   HEAP32[i4 >> 2] = i1;
   i1 = i7;
  }
  __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, i1, i8 + 8 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i12 + 40 >> 2] | 0;
  i3 = i1 + (i7 << 3) | 0;
  if (i7 | 0) do {
   i2 = i1 + 4 | 0;
   __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2, i8);
   i2 = HEAP32[i2 >> 2] | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i7 = i4;
  i6 = i4;
 } else {
  i6 = i8 + 16 | 0;
  i7 = i6;
  i5 = i8 + 24 | 0;
 }
 i1 = i12 + 48 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i9, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i8 = i9 + 11 | 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 i1 = gb + 63648 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i12 + 64 | 0, i4, i11);
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i10 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i11);
 }
 i1 = i12 + 52 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 2);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i12 + 54 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  STACKTOP = i13;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EEjPKi(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 if (!i4) return; else i2 = 0;
 do {
  i6 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  f27 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 28 >> 2]);
  f25 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 32 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 36 >> 2]);
  f24 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 16 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 12 >> 2]);
  f23 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 24 >> 2]);
  f11 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 20 >> 2]);
  f26 = Math_fround(f24 * Math_fround(-2.0));
  f21 = Math_fround(f24 * Math_fround(2.0));
  f19 = Math_fround(f24 * f26);
  f15 = Math_fround(f11 * Math_fround(-2.0));
  f13 = Math_fround(f11 * Math_fround(2.0));
  f14 = Math_fround(f11 * f15);
  f12 = Math_fround(f16 * Math_fround(2.0));
  f22 = Math_fround(f16 * Math_fround(-2.0));
  f10 = Math_fround(f16 * f22);
  f18 = Math_fround(f27 * Math_fround(Math_fround(f19 + f14) + Math_fround(1.0)));
  f17 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(f16 * f21) + Math_fround(f23 * f13)) + Math_fround(0.0)));
  f16 = Math_fround(f27 * Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f16 * f13)) + Math_fround(0.0)));
  f15 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f24 * f12) + Math_fround(f23 * f15)) + Math_fround(0.0)));
  f14 = Math_fround(f25 * Math_fround(Math_fround(f10 + f14) + Math_fround(1.0)));
  f13 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f23 * f12) + Math_fround(f24 * f13)) + Math_fround(0.0)));
  f12 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(f21 * f23) + Math_fround(f12 * f11)) + Math_fround(0.0)));
  f11 = Math_fround(f20 * Math_fround(Math_fround(Math_fround(f23 * f22) + Math_fround(f21 * f11)) + Math_fround(0.0)));
  f10 = Math_fround(f20 * Math_fround(Math_fround(f19 + f10) + Math_fround(1.0)));
  i9 = HEAP32[i3 + (i2 * 40 | 0) >> 2] | 0;
  i8 = HEAP32[i3 + (i2 * 40 | 0) + 4 >> 2] | 0;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 8 >> 2] | 0;
  HEAPF32[i1 + (i6 * 48 | 0) >> 2] = f18;
  HEAPF32[i1 + (i6 * 48 | 0) + 4 >> 2] = f17;
  HEAPF32[i1 + (i6 * 48 | 0) + 8 >> 2] = f16;
  HEAPF32[i1 + (i6 * 48 | 0) + 12 >> 2] = f15;
  HEAPF32[i1 + (i6 * 48 | 0) + 16 >> 2] = f14;
  HEAPF32[i1 + (i6 * 48 | 0) + 20 >> 2] = f13;
  HEAPF32[i1 + (i6 * 48 | 0) + 24 >> 2] = f12;
  HEAPF32[i1 + (i6 * 48 | 0) + 28 >> 2] = f11;
  HEAPF32[i1 + (i6 * 48 | 0) + 32 >> 2] = f10;
  HEAP32[i1 + (i6 * 48 | 0) + 36 >> 2] = i9;
  HEAP32[i1 + (i6 * 48 | 0) + 40 >> 2] = i8;
  HEAP32[i1 + (i6 * 48 | 0) + 44 >> 2] = i7;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZL21ExecuteRenderQueueJobP29RenderNodeQueuePrepareContextj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i21 + 8 | 0;
 i1 = i21;
 if ((HEAP16[gb + 1112400 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112400 | 0, i20);
  i19 = gb + 1112400 | 0;
 } else i19 = 0;
 i5 = HEAP32[i3 + 1312 + (i4 * 12 | 0) >> 2] | 0;
 i2 = HEAP32[i3 + 1312 + (i4 * 12 | 0) + 4 >> 2] | 0;
 i1 = 0;
 do {
  if (!(HEAP32[gb + 1112412 + (i1 << 4) + 8 >> 2] | 0)) HEAP32[i20 + (i1 << 2) >> 2] = fb + 3331; else HEAP32[i20 + (i1 << 2) >> 2] = HEAP32[gb + 1112412 + (i1 << 4) + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 i18 = i3 + 24 + (i4 * 80 | 0) | 0;
 i8 = i2 + i5 | 0;
 if (i5 >>> 0 < i8 >>> 0) {
  i9 = i3 + 24 + (i4 * 80 | 0) + 32 | 0;
  i10 = i3 + 12 | 0;
  i11 = i3 + 24 + (i4 * 80 | 0) + 36 | 0;
  i12 = i3 + 24 + (i4 * 80 | 0) + 40 | 0;
  i13 = i3 + 24 + (i4 * 80 | 0) + 44 | 0;
  i14 = i3 + 8 | 0;
  i15 = i3 + 24 + (i4 * 80 | 0) + 8 | 0;
  i16 = i3 + 24 + (i4 * 80 | 0) + 12 | 0;
  i17 = i3 + 24 + (i4 * 80 | 0) + 32 | 0;
  i7 = i3 + 24 + (i4 * 80 | 0) + 48 | 0;
  i4 = 0;
  i6 = 0;
  i1 = i5;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   i3 = HEAP32[i2 + (i6 * 12 | 0) >> 2] | 0;
   HEAP32[i9 >> 2] = i3;
   i5 = HEAP32[i2 + (i6 * 12 | 0) + 4 >> 2] | 0;
   HEAP32[i11 >> 2] = i5;
   HEAP32[i12 >> 2] = HEAP32[i2 + (i6 * 12 | 0) + 8 >> 2];
   i2 = (HEAP32[i14 >> 2] | 0) + (i6 * 12 | 0) | 0;
   HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   if ((i5 | 0) > 0) {
    HEAP32[i15 >> 2] = i6;
    i1 = i1 - i4 | 0;
    HEAP32[i16 >> 2] = i1;
    i5 = i8 - i4 | 0;
    i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 * 12 | 0) + 4 >> 2] | 0;
    i5 = (i2 | 0) < (i5 | 0) ? i2 : i5;
    HEAP32[i11 >> 2] = i5;
    if (i1 >>> 0 < i5 >>> 0) {
     i1 = (HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[i3 + (i1 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
     mftCall_vi(HEAP32[i20 + (((HEAPU16[i1 >> 1] | HEAPU8[i1 + 2 >> 0] << 16) & 63) << 2) >> 2] | 0, i18 | 0);
     i1 = HEAP32[i16 >> 2] | 0;
     if (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) do {
      i1 = (HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[(HEAP32[i17 >> 2] | 0) + (i1 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
      mftCall_vi(HEAP32[i20 + (((HEAPU16[i1 >> 1] | HEAPU8[i1 + 2 >> 0] << 16) & 63) << 2) >> 2] | 0, i18 | 0);
      i1 = HEAP32[i16 >> 2] | 0;
     } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
    }
    i1 = i1 + i4 | 0;
   }
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i6 + 1 | 0;
   if ((i3 | 0) != 5 & i1 >>> 0 < i8 >>> 0) {
    i4 = (HEAP32[i2 + (i6 * 12 | 0) + 4 >> 2] | 0) + i4 | 0;
    i6 = i3;
   } else break;
  }
 }
 if (!i19) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i19);
 STACKTOP = i21;
 return;
}

function __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i2, i3, i4, i5, f6, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i1 = i1 | 0;
 var f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 24 | 0;
 i15 = i1 + 12 | 0;
 i16 = i1;
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(f11 + f8);
 f10 = Math_fround(f7 + Math_fround(HEAPF32[i5 + 12 >> 2]));
 HEAPF32[i16 >> 2] = f11;
 HEAPF32[i16 + 4 >> 2] = f7;
 HEAPF32[i16 + 8 >> 2] = f6;
 __ZNK6Camera21ViewportToCameraPointERK8Vector3f(i15, i3, i16);
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i14 = i9 + 12 | 0;
 HEAPF32[i16 >> 2] = f11;
 HEAPF32[i16 + 4 >> 2] = f10;
 HEAPF32[i16 + 8 >> 2] = f6;
 __ZNK6Camera21ViewportToCameraPointERK8Vector3f(i15, i3, i16);
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i12 = i9 + 24 | 0;
 HEAPF32[i16 >> 2] = f8;
 HEAPF32[i16 + 4 >> 2] = f10;
 HEAPF32[i16 + 8 >> 2] = f6;
 __ZNK6Camera21ViewportToCameraPointERK8Vector3f(i15, i3, i16);
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i5 = i9 + 36 | 0;
 HEAPF32[i16 >> 2] = f8;
 HEAPF32[i16 + 4 >> 2] = f7;
 HEAPF32[i16 + 8 >> 2] = f6;
 __ZNK6Camera21ViewportToCameraPointERK8Vector3f(i15, i3, i16);
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 580 >> 2] | 0, i2 | 0, 2, i4 | 0);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 564 >> 2] | 0, i2 | 0, +f6, +f13, +Math_fround(HEAPF32[i9 + 8 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 560 >> 2] | 0, i2 | 0, +f11, +f7, 0.0);
 f13 = Math_fround(HEAPF32[i14 >> 2]);
 f6 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 564 >> 2] | 0, i2 | 0, +f13, +f6, +Math_fround(HEAPF32[i9 + 20 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 560 >> 2] | 0, i2 | 0, +f11, +f10, 0.0);
 f11 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(HEAPF32[i9 + 28 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 564 >> 2] | 0, i2 | 0, +f11, +f6, +Math_fround(HEAPF32[i9 + 32 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 560 >> 2] | 0, i2 | 0, +f8, +f10, 0.0);
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = Math_fround(HEAPF32[i9 + 40 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 564 >> 2] | 0, i2 | 0, +f10, +f6, +Math_fround(HEAPF32[i9 + 44 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 560 >> 2] | 0, i2 | 0, +f8, +f7, 0.0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 584 >> 2] | 0, i2 | 0);
 __Z15gpu_time_samplev();
 STACKTOP = i1;
 return;
}

function _UNITY_FT_Stream_ReadFields(i10, i1, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!i1) {
  i13 = 6;
  return i13 | 0;
 }
 if (!i10) {
  i13 = 40;
  return i13 | 0;
 }
 i11 = i10 + 32 | 0;
 i12 = i10 + 36 | 0;
 i9 = 0;
 L7 : while (1) {
  i4 = HEAP32[i11 >> 2] | 0;
  i7 = i1;
  L9 : while (1) {
   i1 = HEAP16[i7 >> 1] | 0;
   i6 = i1 & 255;
   i1 = (i1 & 65535) >>> 8;
   i5 = i1 & 255;
   switch (i6 << 24 >> 24) {
   case 4:
    break L9;
   case 25:
   case 24:
    {
     i2 = i1 & 65535;
     i1 = i4 + i2 | 0;
     if (i1 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
      i1 = 85;
      break L7;
     }
     if (i6 << 24 >> 24 == 24) _memcpy(i8 + (HEAPU16[i7 + 2 >> 1] | 0) | 0, i4 | 0, i2 | 0) | 0;
     break;
    }
   case 9:
   case 8:
    {
     i2 = 24;
     i3 = HEAPU8[i4 >> 0] | 0;
     i1 = i4 + 1 | 0;
     i13 = 18;
     break;
    }
   case 12:
   case 13:
    {
     i2 = 16;
     i3 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
     i1 = i4 + 2 | 0;
     i13 = 18;
     break;
    }
   case 14:
   case 15:
    {
     i2 = 16;
     i3 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0);
     i1 = i4 + 2 | 0;
     i13 = 18;
     break;
    }
   case 16:
   case 17:
    {
     i2 = 0;
     i3 = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
     i1 = i4 + 4 | 0;
     i13 = 18;
     break;
    }
   case 18:
   case 19:
    {
     i2 = 0;
     i3 = (HEAPU8[i4 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 + 3 >> 0] | 0) << 24 | (HEAPU8[i4 + 1 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0);
     i1 = i4 + 4 | 0;
     i13 = 18;
     break;
    }
   case 20:
   case 21:
    {
     i2 = 8;
     i3 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0) << 16 | (HEAPU8[i4 + 2 >> 0] | 0);
     i1 = i4 + 3 | 0;
     i13 = 18;
     break;
    }
   case 22:
   case 23:
    {
     i2 = 8;
     i3 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | (HEAPU8[i4 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0);
     i1 = i4 + 3 | 0;
     i13 = 18;
     break;
    }
   default:
    {
     i13 = 17;
     break L7;
    }
   }
   L22 : do if ((i13 | 0) == 18) {
    i13 = 0;
    i2 = (i6 & 1) == 0 ? i3 : i3 << i2 >> i2;
    i3 = i8 + (HEAPU16[i7 + 2 >> 1] | 0) | 0;
    switch (i5 << 24 >> 24) {
    case 1:
     {
      HEAP8[i3 >> 0] = i2;
      break L22;
     }
    case 2:
     {
      HEAP16[i3 >> 1] = i2;
      break L22;
     }
    case 4:
     {
      HEAP32[i3 >> 2] = i2;
      break L22;
     }
    default:
     {
      HEAP32[i3 >> 2] = i2;
      break L22;
     }
    }
   } while (0);
   i4 = i1;
   i7 = i7 + 4 | 0;
  }
  i1 = _UNITY_FT_Stream_EnterFrame(i10, HEAPU16[i7 + 2 >> 1] | 0) | 0;
  if (!i1) {
   i9 = 1;
   i1 = i7 + 4 | 0;
  } else break;
 }
 if ((i13 | 0) == 17) {
  HEAP32[i11 >> 2] = i4;
  i1 = 0;
 }
 if (!(i9 << 24 >> 24)) {
  i13 = i1;
  return i13 | 0;
 }
 if (HEAP32[i10 + 20 >> 2] | 0) {
  _UNITY_ft_mem_free(HEAP32[i10 + 28 >> 2] | 0, HEAP32[i10 >> 2] | 0);
  HEAP32[i10 >> 2] = 0;
 }
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i1;
 return i13 | 0;
}

function __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEESB_RKT_(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 if ((i6 | 0) != (i7 | 0)) {
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  if ((i5 | 0) >= (i2 | 0)) {
   if ((i2 | 0) >= (i5 | 0)) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == 0;
   if (i4) {
    i2 = i6;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) != (i7 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     HEAP32[i8 >> 2] = i7;
     i8 = i7;
     return i8 | 0;
    }
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i5 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 33;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i5 | 0)) {
       i2 = 38;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 37;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 33) {
     HEAP32[i8 >> 2] = i1;
     i8 = i1;
     return i8 | 0;
    } else if ((i2 | 0) == 37) {
     HEAP32[i8 >> 2] = i1;
     i8 = i3;
     return i8 | 0;
    } else if ((i2 | 0) == 38) {
     HEAP32[i8 >> 2] = i1;
     return i8 | 0;
    }
   }
   if (i4) {
    HEAP32[i8 >> 2] = i6;
    i8 = i3;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   }
  }
 }
 if ((i6 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i2 = i6;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   }
  } else while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i4 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    HEAP32[i8 >> 2] = i7;
    i8 = i7;
    return i8 | 0;
   }
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i4 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i4 | 0)) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i8 >> 2] = i1;
    i8 = i1;
    return i8 | 0;
   } else if ((i2 | 0) == 18) {
    HEAP32[i8 >> 2] = i1;
    i8 = i3;
    return i8 | 0;
   } else if ((i2 | 0) == 19) {
    HEAP32[i8 >> 2] = i1;
    return i8 | 0;
   }
  }
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i8 >> 2] = i6;
  i8 = i6;
  return i8 | 0;
 } else {
  i7 = i1;
  HEAP32[i8 >> 2] = i7;
  i8 = i7 + 4 | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN8VRDevice8ShutdownEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 HEAP32[gb + 1115296 + 152 >> 2] = 0;
 HEAP32[gb + 1115296 + 100 >> 2] = 0;
 HEAP32[gb + 1115296 + 420 >> 2] = 0;
 HEAP32[gb + 1115296 + 424 >> 2] = 0;
 HEAP32[gb + 1115296 + 348 >> 2] = 0;
 i1 = i5 + 284 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63816 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN8VRDevice21StopRenderingToDeviceEv(i5);
 __ZN19RenderBufferManager14GarbageCollectEi(__Z22GetRenderBufferManagerv() | 0, 0);
 if (__Z11IsGfxDevicev() | 0) {
  if (HEAP32[i5 + 208 >> 2] | 0) {
   i2 = __Z12GetGfxDevicev() | 0;
   mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 860 >> 2] | 0, i2 | 0, 9, 0);
  }
  if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i3);
   i1 = gb + 1469192 | 0;
  } else i1 = 0;
  i2 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 536 >> 2] | 0, i2 | 0) | 0;
  i7 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 544 >> 2] | 0, i7 | 0, i2 | 0);
  __Z15gpu_time_samplev();
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 i1 = i5 + 280 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2 + 44 | 0, HEAP32[i2 + 48 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i2 + 20 | 0, HEAP32[i2 + 24 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2 + 4 | 0, HEAP32[i2 + 8 >> 2] | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63816 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 288 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN19VREyeTextureManagerD2Ev(i2);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63816 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i3);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i5 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 14, 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 __ZN21VRGlobalSettingsState18RestoreGlobalStateEv(i5 + 292 | 0);
 i1 = __Z9GetIAudiov() | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx20PxsParticleSystemSim20remapShapesToPacketsEPKPNS_16PxvParticleShapeEj(i17, i14, i13) {
 i17 = i17 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 if (!(HEAP32[(HEAP32[i17 + 8 >> 2] | 0) + 16 >> 2] | 0)) {
  if (!i13) {
   STACKTOP = i18;
   return;
  }
  i5 = i17 + 32 | 0;
  i3 = i17 + 24 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i4 = 0;
  while (1) {
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i14 + (i4 << 2) >> 2];
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i13 | 0)) break; else i2 = i2 + 1 | 0;
  }
  HEAP32[i5 >> 2] = i1 + i13;
  STACKTOP = i18;
  return;
 }
 HEAP32[i16 >> 2] = 0;
 i15 = i16 + 4 | 0;
 HEAP32[i15 >> 2] = 32;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16 + 8 | 0, 128, gb + 769739 | 0, 352) | 0;
 HEAP32[i16 >> 2] = i7;
 _memset(i7 | 0, 0, HEAP32[i15 >> 2] << 2 | 0) | 0;
 i7 = i17 + 72 | 0;
 i11 = i17 + 32 | 0;
 i12 = i17 + 24 | 0;
 if (i13 | 0) {
  i9 = 0;
  do {
   i8 = HEAP32[i14 + (i9 << 2) >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP16[i8 + 36 >> 1] | 0;
   i3 = HEAP16[i8 + 38 >> 1] | 0;
   i4 = HEAP16[i8 + 40 >> 1] | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i5 = (HEAP32[i5 + 8 >> 2] | 0) + -1 | 0;
   i2 = ((i3 << 16 >> 16) * 101 | 0) + (i1 << 16 >> 16) + ((i4 << 16 >> 16) * 7919 | 0) & i5;
   L14 : do if ((HEAP32[i6 + (i2 << 4) + 8 >> 2] | 0) == -1) i10 = 12; else {
    while (1) {
     if (i1 << 16 >> 16 == (HEAP16[i6 + (i2 << 4) >> 1] | 0)) if (i3 << 16 >> 16 == (HEAP16[i6 + (i2 << 4) + 2 >> 1] | 0)) if (i4 << 16 >> 16 == (HEAP16[i6 + (i2 << 4) + 4 >> 1] | 0)) break;
     i2 = i2 + 1 & i5;
     if ((HEAP32[i6 + (i2 << 4) + 8 >> 2] | 0) == -1) {
      i10 = 12;
      break L14;
     }
    }
    i1 = i6 + (i2 << 4) | 0;
    if (!i1) i10 = 12; else {
     HEAP32[i8 + 44 >> 2] = i1;
     i8 = (HEAP32[i16 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i2 & 31);
    }
   } while (0);
   if ((i10 | 0) == 12) {
    i10 = 0;
    i6 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = i6 + 1;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i6 << 2) >> 2] = i8;
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i13 | 0));
 }
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i2 = i17 + 4 | 0;
 i3 = i17 + 28 | 0;
 i5 = 0;
 do {
  if (!(HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31))) if ((HEAP32[i1 + (i5 << 4) + 8 >> 2] | 0) != -1) {
   i4 = __ZN5physx10PxsContext16createFluidShapeEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE(HEAP32[i2 >> 2] | 0, i17, i1 + (i5 << 4) | 0) | 0;
   if (i4 | 0) {
    i14 = HEAP32[i11 >> 2] | 0;
    i13 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i13 + 1;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i13 + i14 << 2) >> 2] = i4;
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 1024);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!((i1 | 0) != 0 & (HEAP32[i15 >> 2] | 0) > -1)) {
  STACKTOP = i18;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i16 + 8 | 0, i1);
 STACKTOP = i18;
 return;
}

function __ZN23CachedSerializationDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP8[i1 + 56 >> 0] = 0;
 HEAP8[i1 + 57 >> 0] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 80 >> 0] = 0;
 HEAP8[i1 + 81 >> 0] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 112 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 128 >> 0] = 0;
 HEAP8[i1 + 129 >> 0] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP8[i1 + 152 >> 0] = 0;
 HEAP8[i1 + 153 >> 0] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 160 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 176 >> 0] = 0;
 HEAP8[i1 + 177 >> 0] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 184 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP8[i1 + 200 >> 0] = 0;
 HEAP8[i1 + 201 >> 0] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 208 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i14 = i17 + 28 | 0;
 i9 = (HEAP32[i14 >> 2] | 0) == -1;
 i10 = i17 + 16 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i12 = i11 << 2;
 i13 = i12 + i8 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i13 + i12 | 0, gb + 778479 | 0, 341) | 0;
 i16 = i12 + i8 | 0;
 i13 = i12 + i13 | 0;
 _memset(i12 | 0, -1, i8 | 0) | 0;
 if (i9) {
  i2 = i17 + 36 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i17 + 4 | 0;
   i4 = i1 + -1 | 0;
   i5 = 0;
   do {
    i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
    i8 = i9 + ~(i9 << 15) | 0;
    i8 = (i8 >>> 10 ^ i8) * 9 | 0;
    i8 = i8 >>> 6 ^ i8;
    i8 = i8 + ~(i8 << 11) | 0;
    i8 = i12 + (((i8 >>> 16 ^ i8) & i4) << 2) | 0;
    HEAP32[i16 + (i5 << 2) >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i5;
    HEAP32[i13 + (i5 << 2) >> 2] = i9;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
  }
  i3 = i17 + 8 | 0;
  i2 = i17 + 20 | 0;
 } else {
  i3 = i17 + 8 | 0;
  _memcpy(i16 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
  i2 = i17 + 20 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4) {
   i7 = i17 + 12 | 0;
   i8 = i17 + 4 | 0;
   i9 = i1 + -1 | 0;
   i6 = 0;
   do {
    i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((i5 | 0) != -1) {
     i4 = i5;
     do {
      i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
      i19 = i5 + ~(i5 << 15) | 0;
      i19 = (i19 >>> 10 ^ i19) * 9 | 0;
      i19 = i19 >>> 6 ^ i19;
      i19 = i19 + ~(i19 << 11) | 0;
      i19 = i12 + (((i19 >>> 16 ^ i19) & i9) << 2) | 0;
      HEAP32[i16 + (i4 << 2) >> 2] = HEAP32[i19 >> 2];
      HEAP32[i19 >> 2] = i4;
      HEAP32[i13 + (i4 << 2) >> 2] = i5;
      i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i4 = HEAP32[i2 >> 2] | 0;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i4 >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i12;
 HEAP32[i17 + 12 >> 2] = i12;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i17 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 i1 = i11 + -1 | 0;
 if (i1 >>> 0 > i15 >>> 0) i2 = i15; else {
  i17 = HEAP32[i14 >> 2] | 0;
  i19 = i16 + (i1 << 2) | 0;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i14 >> 2] = i15;
  return;
 }
 do {
  i19 = i2;
  i2 = i2 + 1 | 0;
  HEAP32[i16 + (i19 << 2) >> 2] = i2;
 } while ((i2 | 0) != (i1 | 0));
 i17 = HEAP32[i14 >> 2] | 0;
 i19 = i16 + (i1 << 2) | 0;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i14 >> 2] = i15;
 return;
}

function __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf(i11, i1, i6) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 16 | 0;
 i10 = i13;
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 - f8);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 - f9);
 f2 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f2 - f4);
 f9 = Math_fround(Math_fround(f3 * Math_fround(.5)) + f9);
 f4 = Math_fround(Math_fround(f2 * Math_fround(.5)) + f4);
 HEAPF32[i11 + 16 >> 2] = Math_fround(Math_fround(f5 * Math_fround(.5)) + f8);
 HEAPF32[i11 + 20 >> 2] = f9;
 HEAPF32[i11 + 24 >> 2] = f4;
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3)) + Math_fround(f2 * f2))));
 if (f4 > Math_fround(0.0)) {
  f8 = Math_fround(Math_fround(1.0) / f4);
  f2 = Math_fround(f2 * f8);
  f9 = Math_fround(f3 * f8);
  f5 = Math_fround(f5 * f8);
 } else f9 = f3;
 f8 = Math_fround(f4 * Math_fround(.5));
 HEAPF32[i6 >> 2] = f8;
 if (!(f8 > Math_fround(1.1920929e-07))) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 1065353216;
  STACKTOP = i13;
  return;
 }
 i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = Math_fround(Math_abs(Math_fround(f5))) < Math_fround(.707106769);
 f3 = Math_fround(-f9);
 f4 = Math_fround(-f2);
 i1 = i6 ? i1 : 0;
 f4 = i6 ? f4 : f5;
 i6 = i6 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_fround(f4 * f4) + Math_fround(f8 * f8));
 f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + f3)));
 if (f3 > Math_fround(0.0)) {
  f14 = Math_fround(Math_fround(1.0) / f3);
  f3 = Math_fround(f8 * f14);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  f4 = Math_fround(f4 * f14);
  f8 = Math_fround(f7 * f14);
  f7 = f8;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 } else f3 = f8;
 f15 = Math_fround(Math_fround(f9 * f7) - Math_fround(f2 * f4));
 f8 = Math_fround(Math_fround(f2 * f3) - Math_fround(f5 * f7));
 f14 = Math_fround(Math_fround(f5 * f4) - Math_fround(f9 * f3));
 HEAPF32[i12 >> 2] = f5;
 HEAPF32[i12 + 4 >> 2] = f9;
 HEAPF32[i12 + 8 >> 2] = f2;
 HEAP32[i12 + 12 >> 2] = i6;
 HEAPF32[i12 + 16 >> 2] = f4;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAPF32[i12 + 24 >> 2] = f15;
 HEAPF32[i12 + 28 >> 2] = f8;
 HEAPF32[i12 + 32 >> 2] = f14;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i10, i12);
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 STACKTOP = i13;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_(i15, i16, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0;
 i2 = i15 + 64 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_(i15, i15 + 32 | 0, i2, i1) | 0;
 i1 = i15 + 96 | 0;
 if ((i1 | 0) == (i16 | 0)) return;
 while (1) {
  i10 = i1 + 4 | 0;
  i14 = HEAP32[i10 >> 2] | 0;
  i9 = i2 + 4 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  do if ((i14 | 0) == (i8 | 0)) {
   i6 = i1 + 8 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + 8 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i7 | 0) != (i3 | 0)) if ((i7 | 0) < (i3 | 0)) {
    i13 = i7;
    i17 = 11;
    break;
   } else break;
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i3 | 0) == (i4 | 0)) if ((HEAP32[i1 >> 2] | 0) < (HEAP32[i2 >> 2] | 0)) {
    i13 = i7;
    i3 = i7;
    i17 = 11;
    break;
   } else break; else if (i3 >>> 0 < i4 >>> 0) {
    i13 = i7;
    i3 = i7;
    i17 = 11;
    break;
   } else break;
  } else if ((i14 | 0) < (i8 | 0)) {
   i13 = i1 + 8 | 0;
   i3 = i2 + 8 | 0;
   i5 = i3;
   i6 = i13;
   i13 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   i17 = 11;
  } while (0);
  if ((i17 | 0) == 11) {
   i17 = 0;
   i11 = HEAP32[i1 >> 2] | 0;
   i7 = i1 + 12 | 0;
   i12 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i8;
   HEAP32[i6 >> 2] = i3;
   i3 = i2 + 12 | 0;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   L17 : do if ((i2 | 0) == (i15 | 0)) i4 = i9; else {
    i10 = i2;
    i8 = i5;
    while (1) {
     i2 = i10 + -32 | 0;
     i4 = i10 + -28 | 0;
     i7 = HEAP32[i4 >> 2] | 0;
     do if ((i14 | 0) == (i7 | 0)) {
      i5 = i10 + -24 | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i13 | 0) != (i6 | 0)) if ((i13 | 0) < (i6 | 0)) {
       i3 = i6;
       break;
      } else {
       i5 = i8;
       i4 = i9;
       i2 = i10;
       break L17;
      }
      i6 = HEAP32[i10 + -20 >> 2] | 0;
      if ((i12 | 0) == (i6 | 0)) if ((i11 | 0) < (HEAP32[i2 >> 2] | 0)) {
       i3 = i13;
       break;
      } else {
       i5 = i8;
       i4 = i9;
       i2 = i10;
       break L17;
      } else if (i12 >>> 0 < i6 >>> 0) {
       i3 = i13;
       break;
      } else {
       i5 = i8;
       i4 = i9;
       i2 = i10;
       break L17;
      }
     } else {
      if ((i14 | 0) >= (i7 | 0)) {
       i5 = i8;
       i4 = i9;
       i2 = i10;
       break L17;
      }
      i3 = i10 + -24 | 0;
      i5 = i3;
      i3 = HEAP32[i3 >> 2] | 0;
     } while (0);
     HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i10 + 4 >> 2] = i7;
     HEAP32[i10 + 8 >> 2] = i3;
     i3 = i10 + -20 | 0;
     HEAP32[i10 + 12 >> 2] = HEAP32[i3 >> 2];
     if ((i2 | 0) == (i15 | 0)) break; else {
      i10 = i2;
      i8 = i5;
      i9 = i4;
     }
    }
   } while (0);
   HEAP32[i2 >> 2] = i11;
   HEAP32[i4 >> 2] = i14;
   HEAP32[i5 >> 2] = i13;
   HEAP32[i3 >> 2] = i12;
  }
  i2 = i1 + 32 | 0;
  if ((i2 | 0) == (i16 | 0)) break; else {
   i14 = i1;
   i1 = i2;
   i2 = i14;
  }
 }
 return;
}

function __ZN4Mesh32RecalculateSubmeshBoundsInternalEj(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i11 = HEAP32[i5 + 128 >> 2] | 0;
 i12 = HEAP32[i11 + (i13 * 52 | 0) + 36 >> 2] | 0;
 if (!i12) {
  i13 = i11 + (i13 * 52 | 0) + 8 | 0;
  i12 = i2 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i12 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i13 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i13 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  STACKTOP = i14;
  return;
 }
 f8 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f7 = Math_fround(-f8);
 f6 = Math_fround(-f3);
 f4 = Math_fround(-f9);
 i10 = HEAP32[i11 + (i13 * 52 | 0) + 32 >> 2] | 0;
 i2 = HEAP32[i5 + 112 >> 2] | 0;
 i1 = (HEAP32[i5 + 116 >> 2] | 0) - i2 | 0;
 i10 = (i1 | 0) != 0 & i1 >>> 0 > i10 >>> 0 ? i2 + i10 | 0 : 0;
 i2 = i5 + 8 | 0;
 i1 = HEAP16[i5 + 10 >> 1] | 0;
 if ((i1 & 65535) < 768 | (i1 & 255) != 0) {
  i5 = 0;
  i2 = 0;
 } else {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i5 = 0;
   i2 = 1;
  } else if (!(HEAP8[i5 + 11 >> 0] | 0)) {
   i5 = 0;
   i2 = 1;
  } else {
   i5 = HEAP16[i2 >> 1] | 0;
   i5 = i1 + (((i5 & 65535) >>> 8 & 65535) + (HEAP32[i2 + 32 + ((i5 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i2 = HEAPU8[i2 + 32 + ((HEAPU8[i2 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
  }
 }
 i1 = 0;
 do {
  i18 = i5 + (Math_imul(HEAPU16[i10 + (i1 << 1) >> 1] | 0, i2) | 0) | 0;
  f17 = Math_fround(HEAPF32[i18 >> 2]);
  f8 = f17 < f8 ? f17 : f8;
  f16 = Math_fround(HEAPF32[i18 + 4 >> 2]);
  f3 = f16 < f3 ? f16 : f3;
  f15 = Math_fround(HEAPF32[i18 + 8 >> 2]);
  f9 = f15 < f9 ? f15 : f9;
  f7 = f7 < f17 ? f17 : f7;
  f6 = f6 < f16 ? f16 : f6;
  f4 = f4 < f15 ? f15 : f4;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 f20 = Math_fround(Math_fround(f3 + f6) * Math_fround(.5));
 f19 = Math_fround(Math_fround(f9 + f4) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f7 - f8) * Math_fround(.5));
 f16 = Math_fround(Math_fround(f6 - f3) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f4 - f9) * Math_fround(.5));
 HEAPF32[i11 + (i13 * 52 | 0) + 8 >> 2] = Math_fround(Math_fround(f8 + f7) * Math_fround(.5));
 HEAPF32[i11 + (i13 * 52 | 0) + 12 >> 2] = f20;
 HEAPF32[i11 + (i13 * 52 | 0) + 16 >> 2] = f19;
 HEAPF32[i11 + (i13 * 52 | 0) + 20 >> 2] = f15;
 HEAPF32[i11 + (i13 * 52 | 0) + 24 >> 2] = f16;
 HEAPF32[i11 + (i13 * 52 | 0) + 28 >> 2] = f17;
 STACKTOP = i14;
 return;
}

function __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i4 = i14;
 i10 = i14 + 12 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i12, gb + 28940 | 0) | 0;
 if (i1 | 0) {
  i3 = i1 + 80 | 0;
  i2 = i1 + 92 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   do {
    __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i13);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
  }
 }
 if (HEAP32[i12 + 56 >> 2] & 15 | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447028 | 0, 0, gb + 444974 | 0, 1305, 1, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i14;
  return;
 }
 i9 = i12 + 8 | 0;
 if (HEAP32[i9 >> 2] & 524288 | 0) {
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i12 | 0) | 0;
  __Z6FormatPKcz(i10, gb + 447098 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 444974 | 0, 1257, 1, HEAP32[i12 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 i4 = i12 + 40 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i5 = i12 + 28 | 0;
  i6 = i13 + 4 | 0;
  i7 = i10 + 11 | 0;
  i3 = 0;
  do {
   i8 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   i2 = i8 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 & 524288) {
    HEAP32[i11 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
    __Z6FormatPKcz(i10, gb + 447098 | 0, i11);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 444974 | 0, 1257, 1, HEAP32[i8 + 4 >> 2] | 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   if (i1 & 1048576 | 0) {
    i2 = __Z20GetPersistentManagerv() | 0;
    __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i2, HEAP32[i8 + 4 >> 2] | 0, 1);
   }
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
    __Z17CommitBatchDeleteR11BatchDelete(i13);
    HEAP32[i13 >> 2] = 256;
    HEAP32[i6 >> 2] = 0;
    i1 = 0;
   }
   HEAP32[i6 >> 2] = i1 + 1;
   HEAP32[i13 + 8 + (i1 << 2) >> 2] = i8;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 if (HEAP32[i9 >> 2] & 1048576 | 0) {
  i11 = __Z20GetPersistentManagerv() | 0;
  __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i11, HEAP32[i12 + 4 >> 2] | 0, 1);
 }
 i2 = i13 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
  __Z17CommitBatchDeleteR11BatchDelete(i13);
  HEAP32[i13 >> 2] = 256;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[i2 >> 2] = i1 + 1;
 HEAP32[i13 + 8 + (i1 << 2) >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = i3 >>> 0 < i4 >>> 0 ? i3 : i4;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 if (!i4) return; else i2 = 0;
 do {
  f25 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 28 >> 2]);
  f23 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 32 >> 2]);
  f18 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 36 >> 2]);
  f22 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 12 >> 2]);
  f21 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 24 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + (i2 * 40 | 0) + 20 >> 2]);
  f24 = Math_fround(f22 * Math_fround(-2.0));
  f19 = Math_fround(f22 * Math_fround(2.0));
  f17 = Math_fround(f22 * f24);
  f13 = Math_fround(f9 * Math_fround(-2.0));
  f11 = Math_fround(f9 * Math_fround(2.0));
  f12 = Math_fround(f9 * f13);
  f10 = Math_fround(f14 * Math_fround(2.0));
  f20 = Math_fround(f14 * Math_fround(-2.0));
  f8 = Math_fround(f14 * f20);
  f16 = Math_fround(f25 * Math_fround(Math_fround(f17 + f12) + Math_fround(1.0)));
  f15 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f14 * f19) + Math_fround(f21 * f11)) + Math_fround(0.0)));
  f14 = Math_fround(f25 * Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f14 * f11)) + Math_fround(0.0)));
  f13 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f22 * f10) + Math_fround(f21 * f13)) + Math_fround(0.0)));
  f12 = Math_fround(f23 * Math_fround(Math_fround(f8 + f12) + Math_fround(1.0)));
  f11 = Math_fround(f23 * Math_fround(Math_fround(Math_fround(f21 * f10) + Math_fround(f22 * f11)) + Math_fround(0.0)));
  f10 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f19 * f21) + Math_fround(f10 * f9)) + Math_fround(0.0)));
  f9 = Math_fround(f18 * Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f9)) + Math_fround(0.0)));
  f8 = Math_fround(f18 * Math_fround(Math_fround(f17 + f8) + Math_fround(1.0)));
  i7 = HEAP32[i3 + (i2 * 40 | 0) >> 2] | 0;
  i6 = HEAP32[i3 + (i2 * 40 | 0) + 4 >> 2] | 0;
  i5 = HEAP32[i3 + (i2 * 40 | 0) + 8 >> 2] | 0;
  HEAPF32[i1 + (i2 * 48 | 0) >> 2] = f16;
  HEAPF32[i1 + (i2 * 48 | 0) + 4 >> 2] = f15;
  HEAPF32[i1 + (i2 * 48 | 0) + 8 >> 2] = f14;
  HEAPF32[i1 + (i2 * 48 | 0) + 12 >> 2] = f13;
  HEAPF32[i1 + (i2 * 48 | 0) + 16 >> 2] = f12;
  HEAPF32[i1 + (i2 * 48 | 0) + 20 >> 2] = f11;
  HEAPF32[i1 + (i2 * 48 | 0) + 24 >> 2] = f10;
  HEAPF32[i1 + (i2 * 48 | 0) + 28 >> 2] = f9;
  HEAPF32[i1 + (i2 * 48 | 0) + 32 >> 2] = f8;
  HEAP32[i1 + (i2 * 48 | 0) + 36 >> 2] = i7;
  HEAP32[i1 + (i2 * 48 | 0) + 40 >> 2] = i6;
  HEAP32[i1 + (i2 * 48 | 0) + 44 >> 2] = i5;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return;
}

function __ZN13RenderManager30RemoveAllIntermediateRenderersEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 __ZN21IntermediateRenderers5ClearEj(HEAP32[gb + 1112704 >> 2] | 0, 0);
 i2 = HEAP32[gb + 1112268 >> 2] | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) != (i2 + 16 | 0)) do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i8 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 13;
    }
   }
   if ((i8 | 0) == 11) i8 = 13;
   if ((i8 | 0) == 13) {
    i8 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[gb + 1112268 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i2 + 16 | 0));
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i2 + 4 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i8 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 25;
    }
   }
   if ((i8 | 0) == 23) i8 = 25;
   if ((i8 | 0) == 25) {
    i8 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != ((HEAP32[gb + 1112268 >> 2] | 0) + 4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN11BoxCollider16TransformChangedEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 96 | 0;
 i6 = i9 + 64 | 0;
 i7 = i9;
 i8 = i3 + 36 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!((i4 & 64 | 0) == 0 | (i1 | 0) == 0)) {
  i2 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if ((__ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i3, 0) | 0) != (i2 | 0)) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (i4 & 8) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  __ZNK9Transform14TransformPointERK8Vector3f(i5, i4, i3 + 60 | 0);
  __ZNK9Transform11GetRotationEv(i6, i4);
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i5 + 8 >> 2];
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 64 >> 2] | 0, i8 | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 88 >> 2] | 0, i8 | 0, i7 | 0, 1);
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 28 | 0;
 if (__ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0, i7) | 0) {
  i10 = HEAP32[i8 >> 2] | 0;
  i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0;
  __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i7, i5);
  i13 = HEAP32[i7 + 48 >> 2] | 0;
  i12 = HEAP32[i7 + 52 >> 2] | 0;
  i7 = HEAP32[i7 + 56 >> 2] | 0;
  i16 = HEAP32[i5 + 4 >> 2] | 0;
  i15 = HEAP32[i5 + 8 >> 2] | 0;
  i14 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i16;
  HEAP32[i6 + 8 >> 2] = i15;
  HEAP32[i6 + 12 >> 2] = i14;
  HEAP32[i6 + 16 >> 2] = i13;
  HEAP32[i6 + 20 >> 2] = i12;
  HEAP32[i6 + 24 >> 2] = i7;
  mftCall_vii(i11 | 0, i10 | 0, i6 | 0);
  if (!((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 5)) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0) | 0) & 1)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
 }
 if (!((i4 & -2147483640 | 0) == 0 ? (HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 28 >> 2] | 0) : 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
   if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
  }
 }
 STACKTOP = i9;
 return;
}

function __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 12 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 24 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 28 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z19TransferField_ArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 24 | 0;
 i12 = i13;
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = HEAP32[i9 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i14;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i14) {
   i14 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i14 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i12, 0);
   HEAP8[i5 >> 0] = 1;
   i14 = i3 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  i4 = HEAP32[i8 + 24 >> 2] | 0;
  i1 = HEAP32[i9 + 28 >> 2] | 0;
  i3 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) >> 4;
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
   HEAP32[i4 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i3) | 0;
   HEAP32[i2 >> 2] = i3;
  }
  if (i3 | 0) {
   i1 = 0;
   do {
    i14 = __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(HEAP32[i4 >> 2] | 0, i1) | 0;
    i9 = (HEAP32[i12 >> 2] | 0) + (i1 << 4) | 0;
    HEAP32[i14 >> 2] = __Z20scripting_string_newPKc((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 } while (0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i11 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i10 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i11 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
    i2 = HEAP32[i10 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i14 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZN12_GLOBAL__N_110DataStreamD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 149264 + 8;
 HEAP32[i5 + 4 >> 2] = gb + 149264 + 152;
 i1 = HEAP32[i5 + 64 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i5 + 388 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i1 = i5 + 456 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i5 + 436 | 0;
  i3 = i5 + 452 | 0;
  i4 = 0;
  do {
   i6 = HEAP32[i2 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i5 + 440 >> 2] = gb + 149568 + 8;
 i6 = HEAP32[i5 + 460 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 444 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 452 >> 2] | 0);
 }
 HEAP32[i5 + 412 >> 2] = gb + 149584 + 8;
 i6 = HEAP32[i5 + 432 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 416 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 424 >> 2] | 0);
 }
 HEAP32[i5 + 356 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i5 + 368 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[i5 + 360 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 HEAP32[i5 + 212 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i5 + 224 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[i5 + 216 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 HEAP32[i5 + 96 >> 2] = gb + 149440 + 8;
 HEAP32[i5 + 180 >> 2] = gb + 149600 + 8;
 i6 = HEAP32[i5 + 200 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 184 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 192 >> 2] | 0);
 }
 HEAP32[i5 + 156 >> 2] = gb + 148928 + 8;
 i6 = HEAP32[i5 + 176 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 160 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 168 >> 2] | 0);
 }
 HEAP32[i5 + 132 >> 2] = gb + 148880 + 8;
 i6 = HEAP32[i5 + 152 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 136 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 144 >> 2] | 0);
 }
 HEAP32[i5 + 108 >> 2] = gb + 149616 + 8;
 i6 = HEAP32[i5 + 128 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 112 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 120 >> 2] | 0);
 }
 HEAP32[i5 + 72 >> 2] = gb + 148752 + 8;
 i6 = HEAP32[i5 + 92 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i6 = HEAP32[i5 + 76 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i5 + 84 >> 2] | 0);
 }
 HEAP32[i5 + 12 >> 2] = gb + 148580 + 8;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i5 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN6Avatar8SetAssetEPN7mecanim9animation14AvatarConstantERKNSt3__23mapIj8UnityStrNS4_4lessIjEENS4_9allocatorINS4_4pairIKjS6_EEEEEE(i11, i2, i5) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 24 | 0;
 i12 = i15 + 20 | 0;
 i13 = i15 + 16 | 0;
 i14 = i15 + 4 | 0;
 i3 = i15;
 i4 = i11 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) do {
  i9 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 i8 = i11 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 56 >> 2] = __Z8CopyBlobIN7mecanim9animation14AvatarConstantEEPT_RKS3_RNS0_6memory9AllocatorERj(i2, i11 + 32 | 0, i3) | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 i8 = i11 + 60 | 0;
 if ((i8 | 0) == (i5 | 0)) {
  i14 = i11 + 76 | 0;
  __ZN8UserList11SendMessageERK17MessageIdentifier(i14, gb + 1105876 | 0);
  STACKTOP = i15;
  return;
 }
 i1 = i11 + 64 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i8, HEAP32[i1 >> 2] | 0);
 i9 = i11 + 68 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  i14 = i11 + 76 | 0;
  __ZN8UserList11SendMessageERK17MessageIdentifier(i14, gb + 1105876 | 0);
  STACKTOP = i15;
  return;
 }
 i6 = i11 + 64 | 0;
 i3 = i2;
 while (1) {
  i3 = i3 + 16 | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  i5 = __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_(i8, i10, i12, i3) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i14, i8, i3);
   i3 = HEAP32[i14 >> 2] | 0;
   HEAP32[i14 >> 2] = 0;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   i4 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i8 >> 2] = i4;
    i3 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i3);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
    i2 = i3;
    break;
   } else i2 = i3;
  } else {
   i2 = i3;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
  }
  if ((i2 | 0) == (i7 | 0)) break; else i3 = i2;
 }
 i14 = i11 + 76 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i14, gb + 1105876 | 0);
 STACKTOP = i15;
 return;
}

function __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 112 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 116 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_(i3, i4, i5, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i3, i4, i5, i8) | 0;
 if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i6, i5) | 0) {
  i9 = i5;
  i10 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i12 = i6;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i11;
  i1 = i6;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i9;
  i1 = i2 + 1 | 0;
  if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i5, i4) | 0) {
   i11 = i4;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i1 = i5;
   i9 = HEAP32[i1 + 4 >> 2] | 0;
   i12 = i4;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = i9;
   i12 = i5;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   if (__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i4, i3) | 0) {
    i12 = i3;
    i11 = HEAP32[i12 >> 2] | 0;
    i12 = HEAP32[i12 + 4 >> 2] | 0;
    i9 = i4;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = i3;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i1 + 4 >> 2] = i10;
    i1 = i4;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = i2 + 3 | 0;
   } else i1 = i2 + 2 | 0;
  }
 } else i1 = i2;
 if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i7, i6) | 0)) {
  i12 = i1;
  return i12 | 0;
 }
 i11 = i6;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i7;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i7;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i6, i5) | 0)) {
  i12 = i1 + 1 | 0;
  return i12 | 0;
 }
 i11 = i5;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i6;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i5, i4) | 0)) {
  i12 = i1 + 2 | 0;
  return i12 | 0;
 }
 i11 = i4;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i5;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i5;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i8, i4, i3) | 0)) {
  i12 = i1 + 3 | 0;
  return i12 | 0;
 }
 i11 = i3;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i4;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i3;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i4;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i1 + 4 | 0;
 return i12 | 0;
}

function __ZNK4AABB17CalculateVerticesEP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 12 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 i9 = i1 + 16 | 0;
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = i1 + 20 | 0;
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 i7 = i1 + 4 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 i6 = i1 + 8 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f5);
 HEAPF32[i2 >> 2] = f3;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 f3 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f3);
 HEAPF32[i2 + 12 >> 2] = f5;
 HEAPF32[i2 + 16 >> 2] = f4;
 HEAPF32[i2 + 20 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f5);
 HEAPF32[i2 + 24 >> 2] = f3;
 HEAPF32[i2 + 28 >> 2] = f4;
 HEAPF32[i2 + 32 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f3 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f3);
 HEAPF32[i2 + 36 >> 2] = f5;
 HEAPF32[i2 + 40 >> 2] = f4;
 HEAPF32[i2 + 44 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i2 + 48 >> 2] = f3;
 HEAPF32[i2 + 52 >> 2] = f4;
 HEAPF32[i2 + 56 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i2 + 60 >> 2] = f5;
 HEAPF32[i2 + 64 >> 2] = f4;
 HEAPF32[i2 + 68 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i2 + 72 >> 2] = f3;
 HEAPF32[i2 + 76 >> 2] = f4;
 HEAPF32[i2 + 80 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i6 >> 2]));
 HEAPF32[i2 + 84 >> 2] = f5;
 HEAPF32[i2 + 88 >> 2] = f4;
 HEAPF32[i2 + 92 >> 2] = f3;
 return;
}

function __ZN9Transform20SetHierarchyCapacityEj(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 4 | 0;
 i3 = i16;
 i15 = HEAP32[i2 + 32 >> 2] | 0;
 if ((HEAP32[i15 >> 2] | 0) == (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 if ((HEAP16[gb + 1159864 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159864 | 0, i1);
  i13 = gb + 1159864 | 0;
 } else i13 = 0;
 i12 = __ZN17TransformInternal24CreateTransformHierarchyEj(i4) | 0;
 i9 = HEAP32[(HEAP32[gb + 1158396 >> 2] | 0) + 32 >> 2] | 0;
 i10 = HEAP32[HEAP32[i15 + 16 >> 2] >> 2] | 0;
 i11 = i12 + 68 | 0;
 i1 = (HEAP32[i11 >> 2] | 0) + (i10 + -1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = i2;
 if ((i2 | 0) != -1) HEAP32[(HEAP32[i12 + 72 >> 2] | 0) + (i2 << 2) >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 if (i10 | 0) {
  i3 = i12 + 56 | 0;
  i4 = i12 + 60 | 0;
  i5 = i15 + 68 | 0;
  i6 = i15 + 60 | 0;
  i7 = i15 + 56 | 0;
  i8 = i12 + 36 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i15, i1, i12, i2);
   i18 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i17 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | i18 & i9;
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = i17;
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] = i18;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i17;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i10 | 0)) break; else i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  }
 }
 i4 = HEAP32[HEAP32[i12 + 16 >> 2] >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = HEAP32[i12 + 12 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i3 + 32 >> 2] = i12;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i6 >> 2] = -1;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 > 1) {
  i1 = 1;
  i2 = 0;
  do {
   i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   i18 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   HEAP32[i18 + 32 >> 2] = i12;
   HEAP32[i18 + 36 >> 2] = i2;
   HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i18 + 100 >> 2] | 0) + 36 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  if (i15 | 0) i14 = 12;
 } else i14 = 12;
 if ((i14 | 0) == 12) {
  i1 = HEAP32[gb + 1158396 >> 2] | 0;
  i2 = i15 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != -1) {
   i14 = i1 + 12 | 0;
   i11 = (HEAP32[i14 >> 2] | 0) + -1 | 0;
   i18 = HEAP32[i1 >> 2] | 0;
   i17 = i18 + (i11 << 2) | 0;
   HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] = i3;
   i18 = i18 + (HEAP32[i2 >> 2] << 2) | 0;
   HEAP32[i14 >> 2] = i11;
   HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i2 >> 2] = -1;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i15, gb + 63160 | 0);
 }
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, i12);
 if (!i13) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i16;
 return;
}

function __ZN11NoiseModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 4 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 8 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 272 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 536 | 0, i6);
 i1 = i5 + 804 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 800 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 805 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 808 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 812 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 816 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 820 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 824 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1092 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1356 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1620 | 0, i6);
 i1 = i5 + 1884 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 }
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function _UNITY_png_xy_from_XYZ(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i11 + 4 | 0;
 i9 = (HEAP32[i4 >> 2] | 0) + i2 + (HEAP32[i11 + 8 >> 2] | 0) | 0;
 if (!i9) {
  i12 = 1;
  return i12 | 0;
 }
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i9 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i12 >> 2] = i2;
 i3 = i12 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i9 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 i6 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i5 = i11 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = i11 + 16 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + i2 + (HEAP32[i11 + 20 >> 2] | 0) | 0;
 i3 = i12 + 8 | 0;
 if (!i4) {
  i12 = 1;
  return i12 | 0;
 }
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i4 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 i3 = i12 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i4 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 i10 = i4 + i9 | 0;
 i9 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i7 | 0;
 i6 = i11 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i11 + 28 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) + i2 + (HEAP32[i11 + 32 >> 2] | 0) | 0;
 i3 = i12 + 16 | 0;
 if (!i4) {
  i12 = 1;
  return i12 | 0;
 }
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i4 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 i3 = i12 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i4 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 i5 = i10 + i4 | 0;
 i2 = i9 + (HEAP32[i6 >> 2] | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i12 + 24 | 0;
 if (!i5) {
  i12 = 1;
  return i12 | 0;
 }
 do if (!i2) i2 = 0; else {
  d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i5 | 0) + .5));
  if (d1 <= 2147483647.0 & d1 >= -2147483648.0) {
   i2 = ~~d1;
   break;
  } else {
   i12 = 1;
   return i12 | 0;
  }
 } while (0);
 HEAP32[i4 >> 2] = i2;
 i2 = i8 + i3 | 0;
 i3 = i12 + 28 | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  i12 = 0;
  return i12 | 0;
 }
 d1 = +Math_floor(+(+(i2 | 0) * 1.0e5 / +(i5 | 0) + .5));
 if (!(d1 <= 2147483647.0 & d1 >= -2147483648.0)) {
  i12 = 1;
  return i12 | 0;
 }
 HEAP32[i3 >> 2] = ~~d1;
 i12 = 0;
 return i12 | 0;
}

function __ZN5physx2Sn24isBinaryPlatformTagValidEj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if ((i1 | 0) < 945770583) {
  if ((i1 | 0) < 844125008) {
   if ((i1 | 0) >= 842227532) switch (i1 | 0) {
   case 842227533:
   case 842227532:
   case 842227543:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
   if ((i1 | 0) < 808858456) switch (i1 | 0) {
   case 808534594:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   } else switch (i1 | 0) {
   case 808858456:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
  }
  if ((i1 | 0) >= 875978572) switch (i1 | 0) {
  case 875978573:
  case 875978572:
  case 875978583:
   {
    i1 = 1;
    break L1;
   }
  default:
   {
    i2 = 3;
    break L1;
   }
  }
  if ((i1 | 0) < 861885264) switch (i1 | 0) {
  case 844125008:
   {
    i1 = 1;
    break L1;
   }
  default:
   {
    i2 = 3;
    break L1;
   }
  }
  if ((i1 | 0) < 875970881) switch (i1 | 0) {
  case 861885264:
   {
    i1 = 1;
    break L1;
   }
  default:
   {
    i2 = 3;
    break L1;
   }
  } else switch (i1 | 0) {
  case 875970881:
   {
    i1 = 1;
    break L1;
   }
  default:
   {
    i2 = 3;
    break L1;
   }
  }
 } else {
  if ((i1 | 0) < 1314539860) {
   if ((i1 | 0) < 1128484165) if ((i1 | 0) < 1094930253) switch (i1 | 0) {
   case 945770583:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   } else switch (i1 | 0) {
   case 1094930253:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
   if ((i1 | 0) < 1162760024) switch (i1 | 0) {
   case 1128484165:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
   if ((i1 | 0) < 1297236311) switch (i1 | 0) {
   case 1162760024:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   } else switch (i1 | 0) {
   case 1297236311:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
  }
  if ((i1 | 0) < 1397705025) {
   if ((i1 | 0) < 1380208193) switch (i1 | 0) {
   case 1314539860:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
   if ((i1 | 0) < 1396978510) switch (i1 | 0) {
   case 1380208193:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   } else switch (i1 | 0) {
   case 1396978510:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
  } else {
   if ((i1 | 0) < 1430866263) switch (i1 | 0) {
   case 1397705025:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
   if ((i1 | 0) < 1448370003) switch (i1 | 0) {
   case 1430866263:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   } else switch (i1 | 0) {
   case 1448370003:
    {
     i1 = 1;
     break L1;
    }
   default:
    {
     i2 = 3;
     break L1;
    }
   }
  }
 } while (0);
 if ((i2 | 0) == 3) i1 = 0;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 16 | 0;
 i6 = i5 + 12 | 0;
 i9 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 863333 | 0, i2, i4);
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 863350 | 0, i7, i2, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i11 = i1 + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i2 + 8;
 HEAP32[i9 + 4 >> 2] = i2 + 4;
 HEAP32[i9 + 8 >> 2] = i10;
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041262 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i12 = i2 + 16 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i2 + 20;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i13;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 863359 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i9 >> 2] = i2 + 24;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 863375 | 0, i10, i9, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i6 = i10 + 16 | 0;
  i7 = i9 + 1 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj560ES3_NS_27PxVehicleClutchAccuracyMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i6, i7);
  i7 = i10 + 32 | 0;
  i10 = i9 + 2 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i10);
  i10 = i9 + 3 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i6 = i10 + 16 | 0;
 i7 = i9 + 1 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj560ES3_NS_27PxVehicleClutchAccuracyMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i6, i7);
 i7 = i10 + 32 | 0;
 i10 = i9 + 2 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i10);
 i10 = i9 + 3 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7mecanim9animation30SkeletonPoseFromValueRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapEPKiRS8_ii(i1, i7, i8, i6, i2, i4, i9, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((i9 | 0) == -1 | (i9 | 0) == (i3 | 0)) return;
 i5 = i1 + 4 | 0;
 __ZN7mecanim9animation30SkeletonPoseFromValueRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapEPKiRS8_ii(i1, i7, i8, i6, i2, i4, HEAP32[(HEAP32[i5 >> 2] | 0) + i5 + (i9 << 3) >> 2] | 0, i3);
 i5 = HEAP32[i2 + (i9 << 2) >> 2] | 0;
 i2 = HEAP32[i6 + (i5 * 12 | 0) >> 2] | 0;
 i3 = i4 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i1 = i3 + (i9 * 40 | 0) | 0;
 if ((i2 | 0) == -1) {
  i10 = i7 + 4 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i2 = HEAP32[i10 + (i5 * 40 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i10 + (i5 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 + (i5 * 40 | 0) >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 4 >> 2] = i2;
  HEAP32[i3 + (i9 * 40 | 0) + 8 >> 2] = i4;
 } else {
  i11 = i8 + 4 | 0;
  i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
  i4 = HEAP32[i11 + (i2 * 12 | 0) + 4 >> 2] | 0;
  i10 = HEAP32[i11 + (i2 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 + (i2 * 12 | 0) >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 4 >> 2] = i4;
  HEAP32[i3 + (i9 * 40 | 0) + 8 >> 2] = i10;
 }
 i1 = HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] | 0;
 i2 = i3 + (i9 * 40 | 0) + 12 | 0;
 if ((i1 | 0) == -1) {
  i1 = i7 + 4 | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  i4 = HEAP32[i1 + (i5 * 40 | 0) + 16 >> 2] | 0;
  i10 = HEAP32[i1 + (i5 * 40 | 0) + 20 >> 2] | 0;
  i11 = HEAP32[i1 + (i5 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + (i5 * 40 | 0) + 12 >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 16 >> 2] = i4;
  HEAP32[i3 + (i9 * 40 | 0) + 20 >> 2] = i10;
  HEAP32[i3 + (i9 * 40 | 0) + 24 >> 2] = i11;
 } else {
  i12 = i8 + 12 | 0;
  i12 = (HEAP32[i12 >> 2] | 0) + i12 | 0;
  i4 = HEAP32[i12 + (i1 << 4) + 4 >> 2] | 0;
  i10 = HEAP32[i12 + (i1 << 4) + 8 >> 2] | 0;
  i11 = HEAP32[i12 + (i1 << 4) + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i12 + (i1 << 4) >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 16 >> 2] = i4;
  HEAP32[i3 + (i9 * 40 | 0) + 20 >> 2] = i10;
  HEAP32[i3 + (i9 * 40 | 0) + 24 >> 2] = i11;
 }
 i1 = HEAP32[i6 + (i5 * 12 | 0) + 8 >> 2] | 0;
 i2 = i3 + (i9 * 40 | 0) + 28 | 0;
 if ((i1 | 0) == -1) {
  i10 = i7 + 4 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i11 = HEAP32[i10 + (i5 * 40 | 0) + 32 >> 2] | 0;
  i12 = HEAP32[i10 + (i5 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i10 + (i5 * 40 | 0) + 28 >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 32 >> 2] = i11;
  HEAP32[i3 + (i9 * 40 | 0) + 36 >> 2] = i12;
  return;
 } else {
  i10 = i8 + 20 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i11 = HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2] | 0;
  i12 = HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i10 + (i1 * 12 | 0) >> 2];
  HEAP32[i3 + (i9 * 40 | 0) + 32 >> 2] = i11;
  HEAP32[i3 + (i9 * 40 | 0) + 36 >> 2] = i12;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E15insert_noresizeERKSC_(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19;
 __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E13find_positionERS9_(i1, i16, i17);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i17 = HEAP32[i16 + 52 >> 2] | 0;
  i18 = i17 + ((HEAP32[i16 + 56 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i15 + 4 >> 2] = i17 + (i2 * 20 | 0);
  HEAP32[i15 + 8 >> 2] = i18;
  HEAP8[i15 + 12 >> 0] = 0;
  STACKTOP = i19;
  return;
 }
 i13 = i1 + 4 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 L5 : do if (!(HEAP8[i16 + 8 >> 0] | 0)) i18 = 14; else {
  i11 = i16 + 4 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  if (!i12) i18 = 14; else {
   i5 = i16 + 12 | 0;
   i2 = i16 + 52 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i1 + (i14 * 20 | 0) | 0;
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i8 = i4 << 24 >> 24 < 0;
   i4 = i4 & 255;
   i9 = i8 ? HEAP32[i16 + 16 >> 2] | 0 : i4;
   i10 = HEAP8[i3 + 11 >> 0] | 0;
   i6 = i10 << 24 >> 24 < 0;
   if ((i9 | 0) == ((i6 ? HEAP32[i1 + (i14 * 20 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
    i7 = HEAP32[i5 >> 2] | 0;
    i10 = i8 ? i7 : i5;
    i3 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
    i6 = (i9 | 0) == 0;
    L9 : do if (i8) {
     if (!i6) if (_memcmp(i10, i3, i9) | 0) {
      i18 = 14;
      break L5;
     }
    } else if (!i6) {
     if ((i7 & 255) << 24 >> 24 != (HEAP8[i3 >> 0] | 0)) {
      i18 = 14;
      break L5;
     }
     while (1) {
      i4 = i4 + -1 | 0;
      i5 = i5 + 1 | 0;
      if (!i4) break L9;
      i3 = i3 + 1 | 0;
      if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
       i18 = 14;
       break L5;
      }
     }
    } while (0);
    HEAP32[i11 >> 2] = i12 + -1;
   } else i18 = 14;
  }
 } while (0);
 if ((i18 | 0) == 14) {
  i1 = i16 + 60 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i16 + 52 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i16, i1 + (i14 * 20 | 0) | 0, i17);
 i18 = HEAP32[i2 >> 2] | 0;
 i17 = i18 + ((HEAP32[i13 >> 2] | 0) * 20 | 0) | 0;
 i18 = i18 + ((HEAP32[i16 + 56 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i15 + 8 >> 2] = i18;
 HEAP8[i15 + 12 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZNSt3__26vectorIN5physx12PxRaycastHitENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 6 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = -1;
   HEAP16[i1 + 12 >> 1] = 0;
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAPF32[i1 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
   i1 = (HEAP32[i10 >> 2] | 0) + 64 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 6) + i2 | 0;
 if (i5 >>> 0 > 67108863) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i7 = i6 >> 5;
 i5 = i6 >> 6 >>> 0 < 33554431 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 67108863;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 << 6) | 0;
 i3 = i6 + (i1 - i4 >> 6 << 6) | 0;
 i7 = i3;
 i4 = i6 + (i5 << 6) | 0;
 i6 = i7;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = -1;
  HEAP16[i1 + 12 >> 1] = 0;
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAPF32[i1 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
  i1 = i6 + 64 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i7 = i3 + -64 | 0;
   i11 = i5;
   i5 = i5 + -64 | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP16[i3 + -52 >> 1] = HEAP16[i11 + -52 >> 1] | 0;
   HEAP32[i3 + -48 >> 2] = HEAP32[i11 + -48 >> 2];
   HEAP32[i3 + -44 >> 2] = HEAP32[i11 + -44 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i11 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i11 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i11 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i11 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i11 + -24 >> 2];
   i7 = i3 + -20 | 0;
   i11 = i11 + -20 | 0;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   i3 = i2 + -64 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0;
 i27 = HEAP32[i5 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(-f12);
 f21 = Math_fround(-f13);
 f25 = Math_fround(-f14);
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i16 >> 2]);
 f17 = Math_fround(f23 * f8);
 f20 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f20 * f21));
 f18 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f18 * f25));
 f22 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f24 = Math_fround(f22 * f8);
 f19 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f19 * f21));
 f6 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f24 = Math_fround(f24 + Math_fround(f6 * f25));
 f9 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f8 = Math_fround(f9 * f8);
 f11 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f21 = Math_fround(f8 + Math_fround(f11 * f21));
 f8 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 i26 = f17 > Math_fround(0.0);
 i1 = f24 > Math_fround(0.0);
 i15 = Math_fround(f21 + Math_fround(f8 * f25)) > Math_fround(0.0);
 f25 = Math_fround(HEAPF32[i27 + 144 >> 2]);
 f21 = Math_fround(HEAPF32[i27 + 148 >> 2]);
 f24 = Math_fround(HEAPF32[i27 + 152 >> 2]);
 f17 = Math_fround(-f25);
 f7 = Math_fround(-f21);
 f10 = Math_fround(-f24);
 f17 = i26 ? f25 : f17;
 f7 = i1 ? f21 : f7;
 f10 = i15 ? f24 : f10;
 f24 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f21 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f9 = Math_fround(f24 + Math_fround(Math_fround(Math_fround(f23 * f17) + Math_fround(f22 * f7)) + Math_fround(f9 * f10)));
 f11 = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f20 * f17) + Math_fround(f19 * f7)) + Math_fround(f11 * f10)));
 f10 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f6 * f7)) + Math_fround(f8 * f10)));
 i16 = HEAP32[i5 + 8 >> 2] | 0;
 i15 = f12 > Math_fround(0.0);
 i1 = f13 > Math_fround(0.0);
 i5 = f14 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f6 = Math_fround(-f12);
 f8 = i15 ? f14 : f8;
 f7 = i1 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __Z10md5_finishP11md5_contextPh(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13;
 i2 = HEAP32[i10 >> 2] | 0;
 i9 = i10 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 HEAP8[i3 >> 0] = i2 << 3;
 HEAP8[i3 + 1 >> 0] = i2 >>> 5;
 HEAP8[i3 + 2 >> 0] = i2 >>> 13;
 HEAP8[i3 + 3 >> 0] = i2 >>> 21;
 HEAP8[i3 + 4 >> 0] = i5 << 3 | i2 >>> 29;
 HEAP8[i3 + 5 >> 0] = i5 >>> 5;
 HEAP8[i3 + 6 >> 0] = i5 >>> 13;
 HEAP8[i3 + 7 >> 0] = i5 >>> 21;
 i4 = i2 & 63;
 i1 = (i4 >>> 0 < 56 ? 56 : 120) - i4 | 0;
 if ((i1 | 0) >= 1) {
  i6 = 64 - i4 | 0;
  i8 = i1 + i2 | 0;
  HEAP32[i10 >> 2] = i8;
  if (i8 >>> 0 < i1 >>> 0) HEAP32[i9 >> 2] = i5 + 1;
  if ((i4 | 0) == 0 | (i1 | 0) < (i6 | 0)) i2 = gb + 612001 | 0; else {
   i2 = gb + 612001 + i6 | 0;
   _memcpy(i10 + 24 + i4 | 0, gb + 612001 | 0, i6 | 0) | 0;
   __ZL11md5_processP11md5_contextPh(i10, i10 + 24 | 0);
   i4 = 0;
   i1 = i1 - i6 | 0;
  }
  if ((i1 | 0) > 63) {
   i7 = i1 + -64 | 0;
   i8 = i7 & -64;
   i6 = i8 + 64 | 0;
   i5 = i2;
   while (1) {
    __ZL11md5_processP11md5_contextPh(i10, i5);
    i1 = i1 + -64 | 0;
    if ((i1 | 0) <= 63) break; else i5 = i5 + 64 | 0;
   }
   i2 = i2 + i6 | 0;
   i1 = i7 - i8 | 0;
  }
  if ((i1 | 0) > 0) _memcpy(i10 + 24 + i4 | 0, i2 | 0, i1 | 0) | 0;
 }
 i8 = HEAP32[i10 >> 2] | 0;
 i5 = i8 & 63;
 i4 = 64 - i5 | 0;
 HEAP32[i10 >> 2] = i8 + 8;
 if (i8 >>> 0 > 4294967287) HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i2 = 8 - i4 | 0;
 i7 = i3 + i4 | 0;
 if ((i5 | 0) == 0 | i4 >>> 0 > 8) {
  i2 = 8;
  i1 = i10 + 24 + i5 | 0;
  i12 = 21;
 } else {
  i1 = i10 + 24 | 0;
  _memcpy(i10 + 24 + i5 | 0, i3 | 0, i4 | 0) | 0;
  __ZL11md5_processP11md5_contextPh(i10, i1);
  if ((i2 | 0) > 63) {
   i5 = i2 + -64 | 0;
   i6 = i5 & -64;
   i4 = i6 + 64 | 0;
   i3 = i7;
   while (1) {
    __ZL11md5_processP11md5_contextPh(i10, i3);
    i2 = i2 + -64 | 0;
    if ((i2 | 0) <= 63) break; else i3 = i3 + 64 | 0;
   }
   i3 = i7 + i4 | 0;
   i2 = i5 - i6 | 0;
  } else i3 = i7;
  if ((i2 | 0) > 0) i12 = 21;
 }
 if ((i12 | 0) == 21) _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 i12 = i10 + 8 | 0;
 HEAP8[i11 >> 0] = HEAP32[i12 >> 2];
 HEAP8[i11 + 1 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 8;
 HEAP8[i11 + 2 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 16;
 HEAP8[i11 + 3 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 24;
 i12 = i10 + 12 | 0;
 HEAP8[i11 + 4 >> 0] = HEAP32[i12 >> 2];
 HEAP8[i11 + 5 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 8;
 HEAP8[i11 + 6 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 16;
 HEAP8[i11 + 7 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 24;
 i12 = i10 + 16 | 0;
 HEAP8[i11 + 8 >> 0] = HEAP32[i12 >> 2];
 HEAP8[i11 + 9 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 8;
 HEAP8[i11 + 10 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 16;
 HEAP8[i11 + 11 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 24;
 i12 = i10 + 20 | 0;
 HEAP8[i11 + 12 >> 0] = HEAP32[i12 >> 2];
 HEAP8[i11 + 13 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 8;
 HEAP8[i11 + 14 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 16;
 HEAP8[i11 + 15 >> 0] = (HEAP32[i12 >> 2] | 0) >>> 24;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier27ELi16EEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueENS_11__wrap_iterIS6_EEE4typeENSC_IPKhEES8_S8_(i11, i1, i12, i5) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i11 >> 2] | 0;
 i3 = i14;
 i14 = i14 + ((HEAP32[i1 >> 2] | 0) - i3) | 0;
 i4 = i5;
 i7 = i12;
 i6 = i4 - i7 | 0;
 if ((i6 | 0) <= 0) {
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i15 = i11 + 4 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i2 = i8;
 if ((i6 | 0) <= (i1 - i2 | 0)) {
  i3 = i2 - i14 | 0;
  if ((i6 | 0) > (i3 | 0)) {
   i2 = i12 + i3 | 0;
   i1 = i4 - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i8 | 0, i2 | 0, i1 | 0) | 0;
    i1 = (HEAP32[i15 >> 2] | 0) + i1 | 0;
    HEAP32[i15 >> 2] = i1;
   } else i1 = i8;
   if ((i3 | 0) > 0) {
    i5 = i2;
    i4 = i1;
   } else {
    i15 = i14;
    STACKTOP = i16;
    return i15 | 0;
   }
  } else i4 = i8;
  i3 = i4 - (i14 + i6) | 0;
  i1 = i14 + i3 | 0;
  if (i1 >>> 0 < i8 >>> 0) {
   i2 = i4;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
    HEAP32[i15 >> 2] = i2;
   } while ((i1 | 0) != (i8 | 0));
  }
  if (i3 | 0) _memmove(i4 + (0 - i3) | 0, i14 | 0, i3 | 0) | 0;
  i1 = i5 - i7 | 0;
  if (!i1) {
   i15 = i14;
   STACKTOP = i16;
   return i15 | 0;
  }
  _memmove(i14 | 0, i12 | 0, i1 | 0) | 0;
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i11 + 12 | 0;
 i2 = i2 - i3 + i6 | 0;
 if ((i2 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i1 - i3 | 0;
 i6 = i8 << 1;
 i2 = i8 >>> 0 < 1073741823 ? (i6 >>> 0 < i2 >>> 0 ? i2 : i6) : 2147483647;
 i6 = i14;
 if (!i2) i4 = 0; else {
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i13 >> 2] = 27;
  HEAP32[i13 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i8 = i4 + (i6 - i3) | 0;
 i1 = i8;
 i7 = i4 + i2 | 0;
 if ((i12 | 0) != (i5 | 0)) {
  i3 = i12;
  i2 = i8;
  do {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i1 + 1 | 0;
   i1 = i2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i6 - i2 | 0;
 i4 = i8 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i4 | 0, i2 | 0, i3 | 0) | 0;
 i2 = (HEAP32[i15 >> 2] | 0) - i6 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + i2 | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i7;
 if (!i2) {
  i15 = i8;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i13 >> 2] = 27;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i8;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZN15ParticleEmitter13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = i5 + 32 | 0;
  if (!(HEAP8[i5 + 192 >> 0] | 0)) {
   HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  } else {
   __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0);
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  }
  i3 = i5 + 44 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 L9 : do if (HEAP8[i5 + 206 >> 0] | 0) {
  i1 = HEAP32[i5 + 56 >> 2] | 0;
  i2 = i5 + 60 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -48 - i1 | 0) >>> 0) / 48 | 0) * 48 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  do if (!i1) {
   i2 = i5 + 208 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) break L9;
  } else {
   i3 = __ZNK10GameObject8IsActiveEv(i1) | 0;
   i2 = i5 + 208 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!(i3 ^ (i1 | 0) != 0)) break L9;
   if (!i3) if (!i1) break L9; else break;
   if ((i2 | 0) == (gb + 1469400 | 0)) break L9;
   if (!i1) i1 = i5 + 212 | 0; else {
    i3 = i5 + 212 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = i3;
   }
   i3 = HEAP32[gb + 1469400 >> 2] | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i1 >> 2] = gb + 1469400;
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   break L9;
  } while (0);
  i3 = i5 + 212 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 } while (0);
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  i2 = i5 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   STACKTOP = i6;
   return;
  }
 } else {
  i3 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  i2 = i5 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(i3 ^ (i1 | 0) != 0)) {
   STACKTOP = i6;
   return;
  }
  if (!i3) {
   if (i1 | 0) break;
   STACKTOP = i6;
   return;
  }
  if ((i2 | 0) == (gb + 1469400 | 0)) {
   STACKTOP = i6;
   return;
  }
  if (!i1) i1 = i5 + 212 | 0; else {
   i5 = i5 + 212 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i5;
  }
  i5 = HEAP32[gb + 1469400 >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = gb + 1469400;
  HEAP32[i5 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  STACKTOP = i6;
  return;
 } while (0);
 i5 = i5 + 212 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN13BuildSettings34ConvertDisplayScenePathToScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10, i1, i7) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i7);
 i6 = i7 + 11 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i8 = i7 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i3 ? i1 : i5 & 255) >>> 0 < 7) {
  i1 = i7;
  i11 = 5;
 } else {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i3 ? i2 : i7;
  i13 = HEAP8[i3 >> 0] | 0;
  i12 = i13 << 24 >> 24;
  if ((((i13 + -65 & 255) < 26 ? i12 + 32 | 0 : i12) & 255) << 24 >> 24 == 97) {
   i12 = HEAP8[i3 + 1 >> 0] | 0;
   i13 = i12 << 24 >> 24;
   if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 115) {
    i12 = HEAP8[i3 + 2 >> 0] | 0;
    i13 = i12 << 24 >> 24;
    if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 115) {
     i12 = HEAP8[i3 + 3 >> 0] | 0;
     i13 = i12 << 24 >> 24;
     if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 101) {
      i12 = HEAP8[i3 + 4 >> 0] | 0;
      i13 = i12 << 24 >> 24;
      if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 116) {
       i12 = HEAP8[i3 + 5 >> 0] | 0;
       i13 = i12 << 24 >> 24;
       if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 115) {
        i12 = HEAP8[i3 + 6 >> 0] | 0;
        i13 = i12 << 24 >> 24;
        if ((((i12 + -65 & 255) < 26 ? i13 + 32 | 0 : i13) & 255) << 24 >> 24 == 47) {
         i4 = i7;
         i3 = i5;
        } else {
         i1 = i7;
         i11 = 5;
        }
       } else {
        i1 = i7;
        i11 = 5;
       }
      } else {
       i1 = i7;
       i11 = 5;
      }
     } else {
      i1 = i7;
      i11 = 5;
     }
    } else {
     i1 = i7;
     i11 = 5;
    }
   } else {
    i1 = i7;
    i11 = 5;
   }
  } else {
   i1 = i7;
   i11 = 5;
  }
 }
 if ((i11 | 0) == 5) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i2 = i10 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i3 = i3 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i3 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, gb + 443932 | 0, 7, i3 + 7 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i4 = i1;
  i3 = HEAP8[i6 >> 0] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i13 = i3 << 24 >> 24 < 0;
 if (__Z23EndsWithCaseInsensitivePKcjS0_j(i13 ? i2 : i4, i13 ? i1 : i3 & 255, gb + 443940 | 0, 6) | 0) {
  STACKTOP = i9;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, gb + 443940 | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer18DeleteArchivedFileERK8UnityStrS4_Rb(i1, i2, i3, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 56 | 0;
 i10 = i12 + 40 | 0;
 i5 = i12 + 24 | 0;
 i6 = i12 + 12 | 0;
 i7 = i12;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i13 = i4 << 24 >> 24 < 0;
 i1 = i13 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i13 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, i4);
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i6, i7);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i11 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i10 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i11 = 6;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i2 = i10 + 11 | 0;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZN15FileSystemEntryC2EPKc(i9, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10);
 HEAP8[i8 >> 0] = 0;
 if (__ZNK15FileSystemEntry6ExistsEv(i9) | 0) if (__ZN15FileSystemEntry6DeleteEb(i9, 0) | 0) i1 = 1; else {
  HEAP8[i8 >> 0] = (__ZN15FileSystemEntry8IsLockedEv(i9) | 0) & 1;
  __ZN11UnityEngine15CloudWebService16SessionContainer17ResetArchivedFileERK8UnityStr(0, i10);
  i1 = __ZN15FileSystemEntry6DeleteEb(i9, 0) | 0;
 } else i1 = 1;
 __ZN13FileEntryDataD2Ev(i9);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i13 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i9);
 STACKTOP = i12;
 return i1 | 0;
}

function _tt_cmap14_validate(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i2 = i13 + 10 | 0;
 i16 = i14 + 8 | 0;
 if (i2 >>> 0 > (HEAP32[i16 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i14, 8);
 i15 = (HEAPU8[i13 + 3 >> 0] | 0) << 16 | (HEAPU8[i13 + 2 >> 0] | 0) << 24 | (HEAPU8[i13 + 4 >> 0] | 0) << 8 | (HEAPU8[i13 + 5 >> 0] | 0);
 i17 = (HEAPU8[i13 + 7 >> 0] | 0) << 16 | (HEAPU8[i13 + 6 >> 0] | 0) << 24 | (HEAPU8[i13 + 8 >> 0] | 0) << 8 | (HEAPU8[i13 + 9 >> 0] | 0);
 if (i15 >>> 0 < 10 ? 1 : i15 >>> 0 > ((HEAP32[i16 >> 2] | 0) - i13 | 0) >>> 0) i1 = 5; else if ((((i15 + -10 | 0) >>> 0) / 11 | 0) >>> 0 < i17 >>> 0) i1 = 5;
 if ((i1 | 0) == 5) _UNITY_ft_validator_error(i14, 8);
 if (!i17) return 0;
 i11 = i14 + 12 | 0;
 i12 = i14 + 20 | 0;
 i9 = 0;
 i10 = 1;
 do {
  i1 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
  i3 = (HEAPU8[i2 + 4 >> 0] | 0) << 16 | (HEAPU8[i2 + 3 >> 0] | 0) << 24 | (HEAPU8[i2 + 5 >> 0] | 0) << 8 | (HEAPU8[i2 + 6 >> 0] | 0);
  i8 = (HEAPU8[i2 + 8 >> 0] | 0) << 16 | (HEAPU8[i2 + 7 >> 0] | 0) << 24 | (HEAPU8[i2 + 9 >> 0] | 0) << 8 | (HEAPU8[i2 + 10 >> 0] | 0);
  i2 = i2 + 11 | 0;
  if (!(i3 >>> 0 < i15 >>> 0 & i8 >>> 0 < i15 >>> 0)) _UNITY_ft_validator_error(i14, 8);
  if (i1 >>> 0 < i10 >>> 0) _UNITY_ft_validator_error(i14, 8);
  i10 = i1 + 1 | 0;
  if (i3 | 0) {
   i1 = i13 + i3 + 4 | 0;
   i7 = i1 + -4 | 0;
   i7 = (HEAPU8[i7 + 1 >> 0] | 0) << 16 | (HEAPU8[i7 >> 0] | 0) << 24 | (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
   if (i7 >>> 0 > ((HEAP32[i16 >> 2] | 0) - i1 | 0) >>> 2 >>> 0) _UNITY_ft_validator_error(i14, 8);
   if (i7 | 0) {
    i3 = 0;
    i4 = 0;
    while (1) {
     i5 = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0);
     i6 = i5 + (HEAPU8[i1 + 3 >> 0] | 0) | 0;
     if (i6 >>> 0 > 1114111) _UNITY_ft_validator_error(i14, 8);
     if (i5 >>> 0 < i4 >>> 0) _UNITY_ft_validator_error(i14, 8);
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i7 | 0)) break; else {
      i1 = i1 + 4 | 0;
      i4 = i6 + 1 | 0;
     }
    }
   }
  }
  if (i8 | 0) {
   i1 = i13 + i8 + 4 | 0;
   i7 = i1 + -4 | 0;
   i7 = (HEAPU8[i7 + 1 >> 0] | 0) << 16 | (HEAPU8[i7 >> 0] | 0) << 24 | (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
   if (i7 >>> 0 > ((HEAP32[i16 >> 2] | 0) - i1 | 0) >>> 2 >>> 0) _UNITY_ft_validator_error(i14, 8);
   if (i7 | 0) {
    i5 = 0;
    i6 = 0;
    do {
     i3 = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0);
     i4 = (HEAPU8[i1 + 3 >> 0] | 0) << 8 | (HEAPU8[i1 + 4 >> 0] | 0);
     i1 = i1 + 5 | 0;
     if (i3 >>> 0 > 1114111) _UNITY_ft_validator_error(i14, 8);
     if (i3 >>> 0 < i5 >>> 0) _UNITY_ft_validator_error(i14, 8);
     i5 = i3 + 1 | 0;
     if (HEAP32[i11 >> 2] | 0) if (i4 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i14, 16);
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != (i7 | 0));
   }
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i17 | 0));
 return 0;
}

function __ZNK14DetailDatabase8GetLayerEiiiiiPi(i3, i25, i27, i28, i2, i29, i30) {
 i3 = i3 | 0;
 i25 = i25 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i26 = 0, i31 = 0, i32 = 0;
 i31 = i3 + 36 | 0;
 i1 = HEAP32[i31 >> 2] | 0;
 if ((i1 | 0) < 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 936627 | 0, 0, gb + 932993 | 0, 179, 1, 0, 0, 0);
  return;
 }
 i26 = i3 + 40 | 0;
 i19 = HEAP32[i26 >> 2] | 0;
 i22 = (i25 | 0) / (i19 | 0) | 0;
 i21 = i1 + -1 | 0;
 i22 = (i22 | 0) < 0 ? 0 : (i22 | 0) > (i21 | 0) ? i21 : i22;
 i1 = (i27 | 0) / (i19 | 0) | 0;
 i1 = (i1 | 0) < 0 ? 0 : (i1 | 0) > (i21 | 0) ? i21 : i1;
 i24 = i28 + i25 | 0;
 i23 = (i24 | 0) / (i19 | 0) | 0;
 i23 = (i23 | 0) < 0 ? 0 : (i23 | 0) > (i21 | 0) ? i21 : i23;
 i20 = i2 + i27 | 0;
 i19 = (i20 | 0) / (i19 | 0) | 0;
 i19 = (i19 | 0) < 0 ? 0 : (i19 | 0) > (i21 | 0) ? i21 : i19;
 if ((i1 | 0) > (i19 | 0)) return;
 i21 = (i22 | 0) > (i23 | 0);
 i18 = i3 + 4 | 0;
 while (1) {
  if (!i21) {
   i17 = i22;
   while (1) {
    i16 = HEAP32[i26 >> 2] | 0;
    i3 = Math_imul(i16, i17) | 0;
    i12 = i25 - i3 | 0;
    i13 = i16 + -1 | 0;
    i12 = (i12 | 0) < 0 ? 0 : (i12 | 0) > (i13 | 0) ? i13 : i12;
    i2 = Math_imul(i16, i1) | 0;
    i11 = i27 - i2 | 0;
    i11 = (i11 | 0) < 0 ? 0 : (i11 | 0) > (i13 | 0) ? i13 : i11;
    i13 = i24 - i3 | 0;
    i14 = i20 - i2 | 0;
    i13 = ((i13 | 0) < 0 ? 0 : (i13 | 0) > (i16 | 0) ? i16 : i13) - i12 | 0;
    i14 = ((i14 | 0) < 0 ? 0 : (i14 | 0) > (i16 | 0) ? i16 : i14) - i11 | 0;
    L13 : do if (!((i13 | 0) == 0 | (i14 | 0) == 0)) {
     i5 = (Math_imul(HEAP32[i31 >> 2] | 0, i1) | 0) + i17 | 0;
     i16 = HEAP32[i18 >> 2] | 0;
     i15 = HEAP32[i16 + (i5 * 52 | 0) + 40 >> 2] | 0;
     i4 = HEAP32[i16 + (i5 * 52 | 0) + 32 >> 2] | 0;
     i5 = HEAP32[i16 + (i5 * 52 | 0) + 28 >> 2] | 0;
     i16 = i5;
     if ((i4 | 0) != (i5 | 0)) {
      i10 = i11 - i27 + i2 | 0;
      i9 = i12 - i25 + i3 | 0;
      i8 = i4 - i5 | 0;
      if ((i14 | 0) <= 0) {
       i2 = 0;
       while (1) {
        i2 = i2 + 1 | 0;
        if (i2 >>> 0 >= i8 >>> 0) break L13;
       }
      }
      i5 = (i13 | 0) < 1;
      i4 = 0;
      do {
       if (!((HEAPU8[i16 + i4 >> 0] | 0 | 0) != (i29 | 0) | i5)) {
        i3 = 0;
        do {
         i6 = i3 + i11 | 0;
         i7 = i9 + (Math_imul(i10 + i3 | 0, i28) | 0) | 0;
         i2 = 0;
         do {
          i32 = HEAP32[i26 >> 2] | 0;
          HEAP32[i30 + (i7 + i2 << 2) >> 2] = HEAPU8[i15 + (i2 + i12 + (Math_imul(i6 + (Math_imul(i32, i4) | 0) | 0, i32) | 0)) >> 0];
          i2 = i2 + 1 | 0;
         } while ((i2 | 0) != (i13 | 0));
         i3 = i3 + 1 | 0;
        } while ((i3 | 0) != (i14 | 0));
       }
       i4 = i4 + 1 | 0;
      } while (i4 >>> 0 < i8 >>> 0);
     }
    } while (0);
    if ((i17 | 0) < (i23 | 0)) i17 = i17 + 1 | 0; else break;
   }
  }
  if ((i1 | 0) < (i19 | 0)) i1 = i1 + 1 | 0; else break;
 }
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j(i9, i10, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, f13 = f0;
 HEAP32[i9 + 4 >> 2] = 0;
 i2 = HEAP16[i10 + 8 >> 1] | 0;
 HEAP8[i9 + 8 >> 0] = i2;
 HEAP8[i9 + 9 >> 0] = (i2 & 65535) >>> 8;
 i2 = i9 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i9 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i9 + 36 | 0;
 i7 = i10 + 36 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i9 + 16 | 0;
 HEAP8[i1 >> 0] = 0;
 i8 = (i9 | 0) == (i10 | 0);
 do if (!i8) {
  i6 = HEAP32[i10 + 12 >> 2] | 0;
  i12 = (i6 | 0) == 0;
  i6 = i12 ? i10 + 16 | 0 : i6;
  i7 = HEAP32[i10 + 32 >> 2] | 0;
  i4 = i9 + 16 | 0;
  if (!((HEAP32[i10 + 16 >> 2] | 0) != 0 | i12)) {
   HEAP32[i2 >> 2] = i6;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i4 >> 2] = 0;
   break;
  }
  if (i7 >>> 0 > 15) {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i2 >> 2] = i12;
   HEAP32[i4 >> 2] = i7;
   i1 = (i12 | 0) == 0 ? i1 : i12;
  }
  _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  HEAP32[i5 >> 2] = i7;
 } while (0);
 HEAP32[i9 + 44 >> 2] = HEAP32[i10 + 44 >> 2];
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 68 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i9 + 72 | 0;
 i6 = i10 + 72 | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = i9 + 52 | 0;
 HEAP8[i1 >> 0] = 0;
 do if (!i8) {
  i5 = HEAP32[i10 + 48 >> 2] | 0;
  i12 = (i5 | 0) == 0;
  i5 = i12 ? i10 + 52 | 0 : i5;
  i6 = HEAP32[i10 + 68 >> 2] | 0;
  i2 = i9 + 52 | 0;
  if (!((HEAP32[i10 + 52 >> 2] | 0) != 0 | i12)) {
   HEAP32[i3 >> 2] = i5;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i6 >>> 0 > 15) {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i3 >> 2] = i12;
   HEAP32[i2 >> 2] = i6;
   i1 = (i12 | 0) == 0 ? i1 : i12;
  }
  _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  HEAP32[i7 >> 2] = i6;
 } while (0);
 HEAP32[i9 + 80 >> 2] = HEAP32[i10 + 80 >> 2];
 HEAP32[i9 + 84 >> 2] = 0;
 i12 = i9 + 88 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i9 + 92 >> 2] = 0;
 HEAP32[i9 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f13 = Math_fround((HEAP32[i12 >> 2] | 0) >>> 0);
 HEAP32[i9 + 100 >> 2] = ~~Math_fround(f13 * Math_fround(.5)) >>> 0;
 HEAP32[i9 + 96 >> 2] = ~~Math_fround(f13 * Math_fround(.200000003)) >>> 0;
 HEAP8[i9 + 104 >> 0] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E9copy_fromERKSL_j(i9, i10, i11);
 return;
}

function __ZL52StaticUnregisterSceneLoadedCallback_LightmapSettingsPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 5400 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 4632 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 504 | 0)) {
    i4 = i6 + 4632 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 4632 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 4632 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 4632 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 4632 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 4632 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 2312 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L12 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 1544 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3375 | 0)) {
    i4 = i6 + 1544 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 1544 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L12;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 1544 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 1544 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 1544 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 1544 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 1544 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 1544 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 37052 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 36284 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 2402 | 0)) {
   i4 = i6 + 36284 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 36284 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i8 = 22;
   break;
  }
 }
 if ((i8 | 0) == 22) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (i8 >>> 0 <= i1 >>> 0) return;
 do {
  i8 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 36284 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + 36284 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 36284 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 36284 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 36284 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx2Sc13ClothBulkData15importExtraDataERNS_24PxDeserializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  if (i1 & 2147483647 | HEAP32[i4 + 4 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i2 + (i1 << 4);
   HEAP32[i4 >> 2] = i2;
  }
 }
 i1 = i4 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 16 >> 2] | 0) {
   i6 = i3 + 4 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i5 + (i2 << 2);
   HEAP32[i1 >> 2] = i5;
  }
 }
 i1 = i4 + 24 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 32 >> 2] & 2147483647;
  if (i2 | HEAP32[i4 + 28 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 * 12 | 0);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 36 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 40 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 4);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 48 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 56 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 52 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 60 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 68 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 64 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 4);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 72 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 80 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 76 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i2 = i4 + 84 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 92 >> 2] & 2147483647;
  if (i1 | HEAP32[i4 + 88 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i1 * 36 | 0);
   HEAP32[i2 >> 2] = i6;
  }
 }
 i1 = i4 + 96 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 104 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 100 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 4);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 108 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 116 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 112 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 4);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 120 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 128 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 124 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 4);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i4 + 152 >> 2] | 0;
 if (!(i2 & 2147483647 | HEAP32[i4 + 148 >> 2])) return;
 i5 = i3 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + (i2 << 4);
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN13MonoBehaviour17RenderImageFilterEPN5Unity9ComponentEP13RenderTextureS4_(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 272 | 0;
 i10 = i13 + 8 | 0;
 i4 = i13;
 i6 = i13 + 256 | 0;
 i11 = i13 + 248 | 0;
 i1 = HEAP32[i7 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) {
  STACKTOP = i13;
  return;
 }
 i5 = i7 + 20 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = i7 + 141 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  i1 = i7 + 60 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  if (i2) {
   i3 = HEAPU8[i3 + 100 >> 0] | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i10 + 4 >> 2] = i3;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i7, i12, 0) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
  }
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  if (i2) {
   i3 = HEAPU8[i3 + 92 >> 0] | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i7, i12, 0) | 0;
  }
 } else i1 = i7 + 60 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 + 104 >> 2] | 0;
 i3 = HEAP32[i3 + 108 >> 2] | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __ZN13MonoBehaviour18GetScriptClassNameEv(i6, i7);
 i1 = i6 + 11 | 0;
 i4 = __Z26profiler_get_info_for_namePKc13ProfilerGroup((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0) | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 if ((HEAP16[i4 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = i7;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i4, i12);
  i1 = i4;
 } else i1 = 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i6 | 0);
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i10, i6, i12);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i10, __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i10, __ZN9Scripting19ScriptingWrapperForEP6Object(i9) | 0);
 HEAP32[i10 + 216 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i12 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i10, i12, 0) | 0;
 i12 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 652 >> 2] | 0, i12 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i13;
 return;
}

function __ZN20OcclusionCullingData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i6 = i13;
 i12 = i13 + 16 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9);
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i6);
 i6 = i8;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i7 + 32 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i2 = __Z9GetIUmbrav() | 0;
  i1 = i3 + (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0) | 0) - i3 | 0;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[i10 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i10 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1, 1, i11, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i12 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i11, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i12 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = HEAP32[i12 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i3 | 0, HEAP32[i4 >> 2] | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1;
 i5 = i9 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i8, 4);
 i1 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + i4 | 0;
 if (i4 | 0) do {
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i4 = i7 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i8, 4);
 i1 = HEAP32[i7 + 36 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i8 << 5) | 0;
 if (i8 | 0) do {
  __ZN14OcclusionScene8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZL39PatchShaderSourceForAdrenoES3WorkaroundNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPS5_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 36 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP8[i1 >> 0] | 0;
 if (!(i3 << 24 >> 24)) {
  i1 = 0;
  i2 = 0;
  i3 = 0;
 } else {
  i2 = i1;
  L6 : while (1) {
   i4 = i2 + 1 | 0;
   if (_isspace(i3 << 24 >> 24) | 0) {
    i2 = i4;
    while (1) {
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = i2 + 1 | 0;
     if (!(_isspace(i3 << 24 >> 24) | 0)) break; else i2 = i4;
    }
   }
   if (i3 << 24 >> 24 != 35) break;
   switch (HEAP8[i4 >> 0] | 0) {
   case 118:
    {
     if ((HEAP8[i2 + 2 >> 0] | 0) != 101) break L6;
     if ((HEAP8[i2 + 3 >> 0] | 0) == 114) i3 = 35; else break L6;
     break;
    }
   case 101:
    {
     if ((HEAP8[i2 + 2 >> 0] | 0) != 120) break L6;
     if ((HEAP8[i2 + 3 >> 0] | 0) == 116) i3 = 35; else break L6;
     break;
    }
   default:
    break L6;
   }
   while (1) {
    switch (i3 << 24 >> 24) {
    case 13:
    case 10:
     continue L6;
    default:
     {}
    }
    i3 = i2 + 1 | 0;
    i2 = i3;
    i3 = HEAP8[i3 >> 0] | 0;
   }
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i6, i1, i2 - i1 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i7, i2) | 0;
  i1 = HEAP8[i6 + 11 >> 0] | 0;
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i4 = i1 << 24 >> 24 < 0;
 i2 = i4 ? i2 : i1 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i4 ? i3 : i6, i2, i2 + 27 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, gb + 605569 | 0, 27) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i2 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 i3 = i7 + 11 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 i4 = i4 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i1 ? HEAP32[i9 >> 2] | 0 : i9, i2, i4 + i2 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i10;
 return;
}

function __ZN13WheelCollider14FinalizeCreateEPK9Rigidbody(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i4 = i9;
 i1 = i5 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 67048 | 0) | 0;
 L1 : do if ((i2 | 0) == 0 | (i2 | 0) == (i3 | 0)) {
  i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  if (!i1) {
   STACKTOP = i9;
   return;
  }
  do {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if (i2 | 0) {
    i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
    if (!((i2 | 0) == 0 | (i2 | 0) == (i3 | 0))) break L1;
   }
   i1 = HEAP32[i1 + 100 >> 2] | 0;
  } while ((i1 | 0) != 0);
  STACKTOP = i9;
  return;
 } while (0);
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 if ((HEAP16[gb + 1458860 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458860 | 0, i7);
  i6 = gb + 1458860 | 0;
 } else i6 = 0;
 __ZN9Rigidbody6CreateEb(i2, 1);
 HEAP32[i5 + 144 >> 2] = i2;
 if (!(HEAP32[i2 + 52 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 826914 | 0, 0, gb + 826839 | 0, 486, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
  if (!i6) {
   STACKTOP = i9;
   return;
  }
  __Z12profiler_endP19ProfilerInformation(i6);
  STACKTOP = i9;
  return;
 }
 i4 = i2 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L25 : do if (!i1) i8 = 24; else {
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  if (!i3) i8 = 24; else {
   if (__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i1 + 8 | 0, 0) | 0) i1 = 0; else {
    i1 = 0;
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i3 >>> 0) {
      i8 = 24;
      break L25;
     }
    } while (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj((HEAP32[i4 >> 2] | 0) + 8 | 0, i1) | 0));
   }
   if ((i1 | 0) > -1) {
    __ZN13WheelCollider25AddWheelToExistingVehicleEP9RigidbodyPN5physx16PxVehicleNoDriveEi(i5, i2, HEAP32[i4 >> 2] | 0, i1);
    i2 = HEAP32[i2 + 64 >> 2] | 0;
    HEAP32[i7 >> 2] = i2;
    i1 = HEAP32[gb + 1458780 >> 2] | 0;
    if (!(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31))) {
     i3 = HEAP32[gb + 1458700 >> 2] | 0;
     i4 = i3 + 4 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
      __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i3, i7);
      i1 = HEAP32[gb + 1458780 >> 2] | 0;
     } else {
      HEAP32[i5 >> 2] = i2;
      HEAP32[i4 >> 2] = i5 + 4;
     }
     i5 = HEAP32[i7 >> 2] | 0;
     i7 = (HEAP32[i1 + 8 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i5 & 31);
    }
   } else i8 = 24;
  }
 } while (0);
 if ((i8 | 0) == 24) __ZN13WheelCollider26AddWheelToRecreatedVehicleEP9Rigidbody(i5, i2);
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i9;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, f25 = f0, i26 = 0, i27 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i27 = HEAP32[i5 + 4 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(-f9);
 f19 = Math_fround(-f19);
 f25 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 i16 = HEAP32[i5 + 12 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i16 >> 2]);
 f14 = Math_fround(f21 * f9);
 f18 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f18 * f19));
 f15 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f15 * f25));
 f20 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f22 = Math_fround(f20 * f9);
 f17 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f17 * f19));
 f13 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f13 * f25));
 f10 = Math_fround(HEAPF32[i16 + 32 >> 2]);
 f9 = Math_fround(f10 * f9);
 f12 = Math_fround(HEAPF32[i16 + 36 >> 2]);
 f19 = Math_fround(f9 + Math_fround(f12 * f19));
 f9 = Math_fround(HEAPF32[i16 + 40 >> 2]);
 i26 = f14 > Math_fround(0.0);
 i24 = f22 > Math_fround(0.0);
 i23 = Math_fround(f19 + Math_fround(f9 * f25)) > Math_fround(0.0);
 f25 = Math_fround(HEAPF32[i27 + 144 >> 2]);
 f19 = Math_fround(HEAPF32[i27 + 148 >> 2]);
 f22 = Math_fround(HEAPF32[i27 + 152 >> 2]);
 f14 = Math_fround(-f25);
 f8 = Math_fround(-f19);
 f7 = Math_fround(-f22);
 f14 = i26 ? f25 : f14;
 f8 = i24 ? f19 : f8;
 f7 = i23 ? f22 : f7;
 f22 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f19 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f10 = Math_fround(f22 + Math_fround(Math_fround(Math_fround(f21 * f14) + Math_fround(f20 * f8)) + Math_fround(f10 * f7)));
 f12 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f18 * f14) + Math_fround(f17 * f8)) + Math_fround(f12 * f7)));
 f7 = Math_fround(Math_fround(HEAPF32[i16 + 56 >> 2]) + Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f8)) + Math_fround(f9 * f7)));
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN19SpriteMeshGenerator4maskC2EP11ColorRGBA32iihj(i11, i3, i12, i14, i8, i9) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i10 = i11 + 8 | 0;
 i6 = gb + 63160 | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i13 = i10;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = i4;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 i13 = i11 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i11 >> 2] = i12;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i14;
 i6 = Math_imul(i14, i12) | 0;
 i2 = gb + 63160 | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i15;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 i5 = i15 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN14dynamic_bitset6resizeEjb(i15, i6, 0);
 i6 = (i14 | 0) > 0;
 if (i6 & (i12 | 0) > 0) {
  i2 = 0;
  do {
   i7 = Math_imul(i2, i12) | 0;
   i1 = 0;
   do {
    if ((HEAPU8[i3 + (i1 + i7 << 2) + 3 >> 0] | 0) > (i8 & 255)) {
     i18 = (Math_imul(HEAP32[i11 >> 2] | 0, i2) | 0) + i1 | 0;
     i17 = (HEAP32[i5 >> 2] | 0) + (i18 >>> 5 << 2) | 0;
     HEAP32[i17 >> 2] = 1 << (i18 & 31) | HEAP32[i17 >> 2];
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i12 | 0));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i14 | 0));
 }
 if (i9 | 0) __ZN19SpriteMeshGenerator4mask6dilateEiR14dynamic_bitset(i11, i9, i15) | 0;
 i18 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
 HEAP32[i11 >> 2] = i18;
 i17 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 HEAP32[i4 >> 2] = i17;
 __ZN14dynamic_bitset6resizeEjb(i10, Math_imul(i17, i18) | 0, 0);
 if (!i6) {
  i18 = HEAP32[i5 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
  STACKTOP = i16;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i12 | 0) > 0) i3 = 0; else {
  i18 = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i18, i15);
  STACKTOP = i16;
  return;
 }
 do {
  i5 = Math_imul(i3, i12) | 0;
  i4 = i3;
  i3 = i3 + 1 | 0;
  i2 = 0;
  do {
   i18 = i2 + i5 | 0;
   if (!(HEAP32[i1 + (i18 >>> 5 << 2) >> 2] & 1 << (i18 & 31))) i2 = i2 + 1 | 0; else {
    i10 = (Math_imul(HEAP32[i11 >> 2] | 0, i4) | 0) + i2 | 0;
    i18 = (HEAP32[i13 >> 2] | 0) + (i10 >>> 5 << 2) | 0;
    HEAP32[i18 >> 2] = 1 << (i10 & 31) | HEAP32[i18 >> 2];
    i18 = i2 + 1 | 0;
    i10 = (Math_imul(HEAP32[i11 >> 2] | 0, i3) | 0) + i18 | 0;
    i17 = (HEAP32[i13 >> 2] | 0) + (i10 >>> 5 << 2) | 0;
    HEAP32[i17 >> 2] = 1 << (i10 & 31) | HEAP32[i17 >> 2];
    i2 = (Math_imul(HEAP32[i11 >> 2] | 0, i3) | 0) + i2 | 0;
    i17 = (HEAP32[i13 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i17 >> 2] = 1 << (i2 & 31) | HEAP32[i17 >> 2];
    i17 = (Math_imul(HEAP32[i11 >> 2] | 0, i4) | 0) + i18 | 0;
    i2 = (HEAP32[i13 >> 2] | 0) + (i17 >>> 5 << 2) | 0;
    HEAP32[i2 >> 2] = 1 << (i17 & 31) | HEAP32[i2 >> 2];
    i2 = i18;
   }
  } while ((i2 | 0) != (i12 | 0));
 } while ((i3 | 0) != (i14 | 0));
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i15);
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = i5 + 16 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471202 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i5 + 20 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471088 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i5 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471073 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842535 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 29; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 29; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu21computeEdgeEdgeNormalERNS_6PxVec3ERKS1_S4_S4_S4_S4_f(i24, i3, i4, i5, i7, i2, f1) {
 i24 = i24 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f25 = f0;
 f19 = Math_fround(f1 + Math_fround(-.100000001));
 f22 = Math_fround(f19 * Math_fround(HEAPF32[i2 >> 2]));
 f23 = Math_fround(f19 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f22 = Math_fround(f22 + Math_fround(HEAPF32[i3 >> 2]));
 f23 = Math_fround(f23 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f19 = Math_fround(f19 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f25 = Math_fround(f16 - f22);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f1 = Math_fround(f17 - f23);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f8 = Math_fround(f13 - f19);
 f11 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f21 * f21)) + Math_fround(f18 * f18));
 f14 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(f14 * f14);
 f15 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f15 * f15));
 f12 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f12 * f12));
 f9 = Math_fround(Math_fround(Math_fround(f20 * f14) + Math_fround(f21 * f15)) + Math_fround(f18 * f12));
 f10 = Math_fround(Math_fround(Math_fround(f20 * f25) + Math_fround(f21 * f1)) + Math_fround(f18 * f8));
 f8 = Math_fround(Math_fround(Math_fround(f25 * f14) + Math_fround(f1 * f15)) + Math_fround(f8 * f12));
 f1 = Math_fround(Math_fround(f11 * f6) - Math_fround(f9 * f9));
 if (f1 != Math_fround(0.0)) {
  f1 = Math_fround(Math_fround(Math_fround(f10 * f6) - Math_fround(f8 * f9)) / f1);
  if (f1 < Math_fround(0.0)) f1 = Math_fround(0.0); else if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(Math_fround(f9 * f1) - f8) / f6);
 if (f6 < Math_fround(0.0)) {
  f1 = Math_fround(f10 / f11);
  if (f1 < Math_fround(0.0)) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(0.0);
  } else if (f1 > Math_fround(1.0)) {
   f1 = Math_fround(1.0);
   f6 = Math_fround(0.0);
  } else f6 = Math_fround(0.0);
 } else if (f6 > Math_fround(1.0)) {
  f1 = Math_fround(Math_fround(f10 + f9) / f11);
  if (f1 < Math_fround(0.0)) {
   f1 = Math_fround(0.0);
   f6 = Math_fround(1.0);
  } else if (f1 > Math_fround(1.0)) {
   f1 = Math_fround(1.0);
   f6 = Math_fround(1.0);
  } else f6 = Math_fround(1.0);
 }
 f23 = Math_fround(Math_fround(f23 + Math_fround(f21 * f1)) - Math_fround(Math_fround(f6 * f15) + f17));
 f25 = Math_fround(Math_fround(f19 + Math_fround(f18 * f1)) - Math_fround(Math_fround(f6 * f12) + f13));
 HEAPF32[i24 >> 2] = Math_fround(Math_fround(f22 + Math_fround(f20 * f1)) - Math_fround(Math_fround(f6 * f14) + f16));
 HEAPF32[i24 + 4 >> 2] = f23;
 HEAPF32[i24 + 8 >> 2] = f25;
 return;
}

function __ZN16HumanPoseHandlerC2EP6AvatarP9Transform(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i7 = i4;
 HEAP32[i1 >> 2] = gb + 178900 + 8;
 i5 = i1 + 4 | 0;
 i10 = gb + 63320 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = i1 + 16 | 0;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = __ZN11UnityEngine9Animation27CreateAvatarBindingConstantER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE(i3, i2, i5) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i3 + i2 | 0, i5) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i3 + i2 | 0, i5) | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i2 + i3 | 0, i5) | 0;
 i3 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 i3 = i3 + (HEAP32[i3 >> 2] | 0) + 40 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i2 | 0) == 0 ? 0 : i3 + i2 | 0, i5) | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 44 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i2 + i3 | 0, i5) | 0;
 i3 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 i3 = i3 + (HEAP32[i3 >> 2] | 0) + 40 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i2 | 0) == 0 ? 0 : i3 + i2 | 0, i5) | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i2 + i3 | 0, i5) | 0;
 STACKTOP = i4;
 return;
}

function __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i14, i9) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i3 = i16 + 20 | 0;
 i12 = i16 + 8 | 0;
 i4 = i16 + 4 | 0;
 i5 = i16;
 i15 = i14 + 4 | 0;
 i6 = HEAP32[i15 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i2 = i6 - i7 | 0;
 i1 = i7;
 if (i2 >>> 0 >= i9 >>> 0) {
  if (i2 >>> 0 <= i9 >>> 0) {
   STACKTOP = i16;
   return;
  }
  i2 = i1 + i9 | 0;
  HEAP32[i13 >> 2] = 0;
  i6 = i13 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  if (!i9) {
   i4 = i13 + 8 | 0;
   i2 = 0;
   i3 = 0;
   i1 = 0;
  } else {
   if ((i9 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i3 = __Znwj(i9) | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i13 >> 2] = i3;
   i5 = i13 + 8 | 0;
   HEAP32[i5 >> 2] = i3 + i9;
   do {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i3 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
    HEAP32[i6 >> 2] = i3;
   } while ((i1 | 0) != (i2 | 0));
   i4 = i5;
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i12 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = i2;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  i15 = i14 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i15 >> 2] = i1;
  i1 = i12;
  if (i12 | 0) {
   if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i1;
   __ZdlPv(i1);
  }
  STACKTOP = i16;
  return;
 }
 i10 = i14 + 8 | 0;
 if (((HEAP32[i10 >> 2] | 0) - i7 | 0) == (i9 | 0)) {
  __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj(i14, i9 - i2 | 0);
  STACKTOP = i16;
  return;
 }
 HEAP32[i12 >> 2] = 0;
 i11 = i12 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i8 = i12 + 8 | 0;
 if (i9 | 0) {
  i2 = __Znwj(i9) | 0;
  i1 = i2;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i9;
 }
 HEAP32[i4 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i12, i3, i13);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i4 = i2;
 i5 = i1;
 if (i3 >>> 0 < i9 >>> 0) {
  __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj(i12, i9 - i3 | 0);
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 } else if (i3 >>> 0 > i9 >>> 0) {
  i3 = i4 + i9 | 0;
  if ((i5 | 0) != (i3 | 0)) {
   HEAP32[i11 >> 2] = i3;
   i1 = i3;
  }
 }
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i14 >> 2] = i2;
 i2 = HEAP32[i15 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i15 >> 2] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i1;
 i1 = i13;
 if (i13 | 0) {
  if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i1;
  __ZdlPv(i1);
 }
 STACKTOP = i16;
 return;
}

function _unity_z_deflateCopy(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((i13 | 0) == 0 | (i1 | 0) == 0) {
  i13 = -2;
  return i13 | 0;
 }
 i10 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i10) {
  i13 = -2;
  return i13 | 0;
 }
 i3 = i13;
 i2 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i1 = i13 + 32 | 0;
 i12 = i13 + 40 | 0;
 i4 = mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, 1, 5824) | 0;
 if (!i4) {
  i13 = -4;
  return i13 | 0;
 }
 i11 = i13 + 28 | 0;
 HEAP32[i11 >> 2] = i4;
 _memcpy(i4 | 0, i10 | 0, 5824) | 0;
 HEAP32[i4 >> 2] = i13;
 i5 = i4 + 44 | 0;
 i3 = i4 + 56 | 0;
 HEAP32[i3 >> 2] = mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, 2) | 0;
 i6 = i4 + 64 | 0;
 HEAP32[i6 >> 2] = mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, 2) | 0;
 i7 = i4 + 76 | 0;
 i8 = i4 + 68 | 0;
 HEAP32[i8 >> 2] = mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i7 >> 2] | 0, 2) | 0;
 i9 = i4 + 5788 | 0;
 i1 = mftCall_iiii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] | 0, 4) | 0;
 i2 = i4 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = HEAP32[i3 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i6 >> 2] | 0) if (!((i1 | 0) == 0 | (HEAP32[i8 >> 2] | 0) == 0)) {
  _memcpy(i3 | 0, HEAP32[i10 + 56 >> 2] | 0, HEAP32[i5 >> 2] << 1 | 0) | 0;
  _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i10 + 64 >> 2] | 0, HEAP32[i5 >> 2] << 1 | 0) | 0;
  _memcpy(HEAP32[i8 >> 2] | 0, HEAP32[i10 + 68 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
  i13 = i10 + 8 | 0;
  _memcpy(HEAP32[i2 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0) | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + 16 >> 2] = i12 + ((HEAP32[i10 + 16 >> 2] | 0) - (HEAP32[i13 >> 2] | 0));
  i13 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + 5796 >> 2] = i1 + (i13 >>> 1 << 1);
  HEAP32[i4 + 5784 >> 2] = i12 + (i13 * 3 | 0);
  HEAP32[i4 + 2840 >> 2] = i4 + 148;
  HEAP32[i4 + 2852 >> 2] = i4 + 2440;
  HEAP32[i4 + 2864 >> 2] = i4 + 2684;
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i13 = -4;
  return i13 | 0;
 }
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 42:
 case 69:
 case 73:
 case 91:
 case 103:
 case 113:
 case 666:
  break;
 default:
  {
   i13 = -4;
   return i13 | 0;
  }
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i13 + 36 >> 2] | 0, HEAP32[i12 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i13 + 36 >> 2] | 0, HEAP32[i12 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i13 + 36 >> 2] | 0, HEAP32[i12 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i2) i2 = i13 + 36 | 0; else {
  i1 = i13 + 36 | 0;
  mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i12 >> 2] | 0, i2 | 0);
  i2 = i1;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i12 >> 2] | 0, i1 | 0);
 HEAP32[i11 >> 2] = 0;
 i13 = -4;
 return i13 | 0;
}

function __ZN12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj(i12, i7, i11, i8, i10) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 40 | 0;
 i6 = i13;
 i9 = i13 + 8 | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 i3 = i8 + 4 | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i12 + 64 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i14;
 mftCall_viiiiii(i5 | 0, i1 | 0, i2 | 0, i7 | 0, i11 | 0, i6 | 0, i10 | 0);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i6 = (i3 - i4 | 0) / 20 | 0;
 i2 = i6 * 24 | 0;
 if (i2 >>> 0 > (HEAP32[i12 + 88 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i12 + 72 | 0, i2, i1);
 }
 i5 = HEAP32[i12 + 84 >> 2] | 0;
 i1 = (i3 | 0) == (i4 | 0);
 if (!i1) {
  i2 = 0;
  do {
   HEAP32[i5 + (i2 * 24 | 0) >> 2] = gb + 149860 + 8;
   HEAP32[i5 + (i2 * 24 | 0) + 4 >> 2] = 0;
   HEAP32[i5 + (i2 * 24 | 0) + 8 >> 2] = 0;
   HEAP32[i5 + (i2 * 24 | 0) + 12 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  if (!i1) {
   i1 = 0;
   do {
    i4 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 * 20 | 0) >> 2] | 0) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i3 + (i1 * 20 | 0) + 4 >> 2] | 0) | 0;
    i3 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i3 + (i1 * 20 | 0) + 8 >> 2] | 0) | 0;
    i15 = HEAP32[i8 >> 2] | 0;
    i14 = HEAP32[i15 + (i1 * 20 | 0) + 12 >> 2] | 0;
    i15 = HEAP32[i15 + (i1 * 20 | 0) + 16 >> 2] | 0;
    HEAP32[i5 + (i1 * 24 | 0) + 4 >> 2] = i4;
    i4 = i5 + (i1 * 24 | 0) + 8 | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i4 + 4 >> 2] = i3;
    HEAP32[i5 + (i1 * 24 | 0) + 16 >> 2] = i14;
    HEAP32[i5 + (i1 * 24 | 0) + 20 >> 2] = i15;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i6 >>> 0);
  }
 }
 i4 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i7 >> 2] | 0) | 0;
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i7 + 4 >> 2] | 0) | 0;
 i8 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i11 >> 2] | 0) | 0;
 i14 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i12, HEAP32[i11 + 4 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = gb + 149880 + 8;
 i15 = i9 + 4 | 0;
 HEAP32[i15 >> 2] = i4;
 HEAP32[i15 + 4 >> 2] = i7;
 i15 = i9 + 12 | 0;
 HEAP32[i15 >> 2] = i8;
 HEAP32[i15 + 4 >> 2] = i14;
 HEAP32[i9 + 20 >> 2] = i5;
 HEAP32[i9 + 24 >> 2] = i5 + (i6 * 24 | 0);
 HEAP32[i9 + 28 >> 2] = i10;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i12, i9, 5);
 STACKTOP = i13;
 return (HEAPU8[i12 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN5physx7profile14parseEventDataILb0ENS0_17MemoryEventParserILb0EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_(i14, i2, i1, i13) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 32 | 0;
 i12 = i16 + 24 | 0;
 i11 = i16;
 i15 = i16 + 48 | 0;
 i1 = (i2 | 0) == 0 ? 0 : i1;
 i9 = i14 + 48 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i14 + 52 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i14 + 56 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP16[i15 >> 1] = 16368;
 i5 = i15 + 1 | 0;
 i6 = i14 + 48 | 0;
 i7 = i13 + 131072 | 0;
 i8 = i13 + 131076 | 0;
 if (!i1) {
  i15 = 1;
  STACKTOP = i16;
  return i15 | 0;
 } else i2 = i1;
 do {
  L5 : do if (i2 >>> 0 < 2) {
   HEAP8[i4 >> 0] = 1;
   i1 = 0;
  } else {
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP8[i15 >> 0] = HEAP8[i1 >> 0] | 0;
   i17 = i1 + 1 | 0;
   HEAP32[i9 >> 2] = i17;
   HEAP32[i3 >> 2] = i2 + -1;
   HEAP8[i5 >> 0] = HEAP8[i17 >> 0] | 0;
   HEAP32[i9 >> 2] = i1 + 2;
   HEAP32[i3 >> 2] = i2 + -2;
   i1 = HEAPU16[i15 >> 1] | 0;
   switch (i1 & 15 | 0) {
   case 4:
    {
     i1 = 1;
     break L5;
    }
   case 1:
    {
     __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_(i14, i11, i15, i13);
     if (!(HEAP8[i4 >> 0] | 0)) {
      i1 = 1;
      break L5;
     }
     break;
    }
   case 2:
    {
     __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_(i14, i11, i15, i13);
     if (!(HEAP8[i4 >> 0] | 0)) {
      i1 = 1;
      break L5;
     }
     break;
    }
   case 3:
    {
     __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i6, gb + 773712 | 0, i12, i1 >>> 4 & 3);
     i1 = i12;
     i18 = HEAP32[i1 >> 2] | 0;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     HEAP32[i10 >> 2] = 0;
     HEAP32[i10 + 4 >> 2] = 0;
     HEAP32[i10 + 8 >> 2] = 0;
     HEAP32[i10 + 12 >> 2] = 0;
     i17 = HEAP32[i7 >> 2] | 0;
     i2 = i13 + (i17 << 5) | 0;
     HEAP32[i2 >> 2] = i18;
     HEAP32[i2 + 4 >> 2] = i1;
     i2 = i13 + (i17 << 5) + 8 | 0;
     HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
     HEAP32[i13 + (i17 << 5) + 24 >> 2] = 2;
     i17 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
     HEAP32[i7 >> 2] = i17;
     if ((i17 | 0) == 4096) {
      i18 = HEAP32[i8 >> 2] | 0;
      mftCall_viii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, i13 | 0, 4096);
      HEAP32[i7 >> 2] = 0;
     }
     if (!(HEAP8[i4 >> 0] | 0)) {
      i1 = 1;
      break L5;
     }
     break;
    }
   default:
    {}
   }
   HEAP8[i4 >> 0] = 1;
   i1 = 0;
  } while (0);
  i2 = HEAP32[i3 >> 2] | 0;
 } while ((i2 | 0) != 0 & i1);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN5physx2Cm10Collection3addERNS_12PxCollectionE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 i10 = i4 + 44 | 0;
 i8 = HEAP32[i4 + 64 >> 2] | 0;
 i11 = i3 + 80 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + i8 | 0;
 if (i8 >>> 0 < i2 >>> 0) {
  __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i10, i2);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = HEAP32[i3 + 48 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i6 = i4 + 4 | 0;
 i7 = 0;
 do {
  i3 = i8 + (i7 << 4) | 0;
  i5 = i8 + (i7 << 4) + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i13;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = HEAP32[i3 >> 2] | 0;
  do if ((i4 | 0) == 0 & (i5 | 0) == 0) {
   HEAP32[i9 >> 2] = i2;
   i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i10, i9, i12) | 0;
   if (!(HEAP8[i12 >> 0] | 0)) {
    HEAP32[i1 >> 2] = i2;
    i5 = i1 + 8 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
   }
  } else {
   i1 = i9;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i6, i9, i12) | 0;
   if (!(HEAP8[i12 >> 0] | 0)) {
    i15 = i1;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i15 + 4 >> 2] = i5;
    HEAP32[i1 + 8 >> 2] = i2;
    i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i10, i3, i9) | 0;
    if (!(HEAP8[i9 >> 0] | 0)) {
     HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
     i1 = i1 + 8 | 0;
     i15 = i1;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i15 + 4 >> 2] = 0;
    } else i1 = i1 + 8 | 0;
    i15 = i1;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i15 + 4 >> 2] = i5;
    break;
   }
   i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i6, i13, i9) | 0;
   if (!(HEAP8[i9 >> 0] | 0)) {
    i15 = i1;
    HEAP32[i15 >> 2] = i4;
    HEAP32[i15 + 4 >> 2] = i5;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = 0;
   } else i1 = HEAP32[i1 + 8 >> 2] | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    HEAP32[i9 >> 2] = i2;
    i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i10, i9, i12) | 0;
    if (!(HEAP8[i12 >> 0] | 0)) {
     HEAP32[i1 >> 2] = i2;
     i15 = i1 + 8 | 0;
     HEAP32[i15 >> 2] = 0;
     HEAP32[i15 + 4 >> 2] = 0;
    }
   }
  } while (0);
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 STACKTOP = i14;
 return;
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 296 | 0;
 i9 = i10;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(1.0);
 i1 = i9 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 52 >> 2] = Math_fround(1.0);
 i1 = i9 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 72 >> 2] = Math_fround(1.0);
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 112 >> 2] = Math_fround(1.0);
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 132 >> 2] = Math_fround(1.0);
 i1 = i9 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 152 >> 2] = Math_fround(1.0);
 i1 = i9 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 172 >> 2] = Math_fround(1.0);
 i1 = i9 + 176 | 0;
 i2 = i9 + 249 | 0;
 i4 = i1;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i9 + 292 | 0;
 i4 = i9 + 252 | 0;
 i5 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i9 + 293 >> 0] = 0;
 __ZN8GUIStyle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, HEAP32[i7 + 20 >> 2] | 0);
 i2 = i3 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i7 + 4 | 0;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i6 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i9) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i6) >> 2] = i1;
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 STACKTOP = i10;
 return;
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i7, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 296 | 0;
 i9 = i10;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(1.0);
 i1 = i9 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 52 >> 2] = Math_fround(1.0);
 i1 = i9 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 72 >> 2] = Math_fround(1.0);
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 112 >> 2] = Math_fround(1.0);
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 132 >> 2] = Math_fround(1.0);
 i1 = i9 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 152 >> 2] = Math_fround(1.0);
 i1 = i9 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 172 >> 2] = Math_fround(1.0);
 i1 = i9 + 176 | 0;
 i2 = i9 + 249 | 0;
 i4 = i1;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i9 + 292 | 0;
 i4 = i9 + 252 | 0;
 i5 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i9 + 293 >> 0] = 0;
 __ZN8GUIStyle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, HEAP32[i7 + 20 >> 2] | 0);
 i2 = i3 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i7 + 4 | 0;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i6 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i9) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i6) >> 2] = i1;
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 STACKTOP = i10;
 return;
}

function __Z17DebugStringToFileRK21DebugStringToFileData(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 48 | 0;
 i6 = i12 + 36 | 0;
 i7 = i12 + 24 | 0;
 i8 = i12 + 12 | 0;
 i9 = i12;
 if ((HEAP16[gb + 1450772 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450772 | 0, i4);
  i5 = gb + 1450772 | 0;
 } else i5 = 0;
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i3 = i4;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 if (!(i2 & 131072)) if (!(i2 & 1059153)) if (!(i2 & 2097154)) i1 = (i2 & 4736 | 0) == 0 ? 3 : 2; else i1 = 1; else i1 = 0; else i1 = 4;
 L9 : do if (!(i2 & 262144)) {
  switch (HEAP32[gb + 73464 + (i1 << 2) >> 2] | 0) {
  case 0:
   {
    i11 = 9;
    break L9;
   }
  case 1:
   break;
  case 2:
   {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, gb + 582961 | 0) | 0) | 0;
    break L9;
   }
  default:
   break L9;
  }
  if (HEAP32[gb + 1450800 >> 2] | 0) {
   i3 = i4 + 16 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i8, HEAP32[i3 >> 2] | 0) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i1, _strlen(i1) | 0);
   mftCall_viiiiiiii(HEAP32[gb + 1450800 >> 2] | 0, i9 | 0, i7 | 0, i6 | 0, HEAP32[i4 + 12 >> 2] | 0, i8 | 0, i4 + 20 | 0, i2 | 0, HEAP32[i4 + 28 >> 2] | 0);
   HEAP32[i3 >> 2] = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  }
 } else i11 = 9; while (0);
 if ((i11 | 0) == 9) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, gb + 1576256 | 0) | 0) | 0;
 HEAP32[i4 + 4 >> 2] = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 HEAP32[i4 + 8 >> 2] = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (i10) __Z19pop_allocation_rootv();
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i12;
 return;
}

function __ZNK9Heightmap25ComputeMaximumHeightErrorEiii(i4, i2, i3, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var f1 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24 + 280 | 0;
 i20 = i24 + 8 | 0;
 i21 = i24;
 if (!i5) {
  f17 = Math_fround(0.0);
  STACKTOP = i24;
  return Math_fround(f17);
 }
 i22 = 1 << i5;
 i23 = i22 + -1 | 0;
 f16 = Math_fround(Math_fround(1.0) / Math_fround(i22 | 0));
 f17 = Math_fround(f16 * f16);
 i13 = i22 << 4;
 i2 = Math_imul(i13, i2) | 0;
 i18 = HEAP32[i4 + 76 >> 2] | 0;
 i2 = Math_imul(i2, i18) | 0;
 i11 = Math_imul(i18, i13) | 0;
 i19 = i2 + i11 | 0;
 i14 = i18 << i5;
 i12 = Math_imul(i13, i3) | 0;
 i13 = i12 + i13 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 _memset(i20 | 0, 0, 272) | 0;
 L4 : do if ((i11 | 0) < 0) f1 = Math_fround(0.0); else {
  i11 = i14 + i22 | 0;
  if ((i5 | 0) == 31) while (1) {
   i2 = i18 + i2 | 0;
   if ((i2 | 0) > (i19 | 0)) {
    f1 = Math_fround(0.0);
    break L4;
   }
  } else {
   f6 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
  do {
   i8 = (i2 | 0) == (i19 | 0) ? i22 : i2 & i23;
   f9 = Math_fround(i8 | 0);
   i5 = i10 + (i2 + i12 << 1) | 0;
   i4 = i20;
   i7 = i12;
   while (1) {
    i3 = (i7 | 0) == (i13 | 0) ? i22 : i7 & i23;
    if (!(i3 | i8)) {
     f28 = Math_fround(HEAP16[i5 >> 1] | 0);
     f26 = Math_fround(HEAP16[i5 + (i22 << 1) >> 1] | 0);
     f25 = Math_fround(HEAP16[i5 + (i14 << 1) >> 1] | 0);
     f27 = Math_fround(HEAP16[i5 + (i11 << 1) >> 1] | 0);
     i3 = i4 + 16 | 0;
     HEAPF32[i3 >> 2] = f28;
     f25 = Math_fround(f25 - f28);
     HEAPF32[i4 + 20 >> 2] = Math_fround(f16 * f25);
     HEAPF32[i4 + 24 >> 2] = Math_fround(f16 * Math_fround(f26 - f28));
     HEAPF32[i4 + 28 >> 2] = Math_fround(f17 * Math_fround(Math_fround(f27 - f26) - f25));
    } else {
     i4 = (i3 | 0) == 0 ? i4 + 16 | 0 : i4;
     f1 = Math_fround(HEAPF32[i4 >> 2]);
     f1 = Math_fround(f1 + Math_fround(f9 * Math_fround(HEAPF32[i4 + 4 >> 2])));
     f28 = Math_fround(i3 | 0);
     f28 = Math_fround(f1 + Math_fround(f28 * Math_fround(HEAPF32[i4 + 8 >> 2])));
     f1 = Math_fround(Math_imul(i3, i8) | 0);
     f1 = Math_fround(f28 + Math_fround(f1 * Math_fround(HEAPF32[i4 + 12 >> 2])));
     f1 = Math_fround(f1 - Math_fround(HEAP16[i5 >> 1] | 0));
     i3 = f1 < Math_fround(0.0);
     f28 = Math_fround(-f1);
     f1 = i3 ? f28 : f1;
     HEAPF32[i21 >> 2] = f1;
     i3 = HEAP32[(f6 < f1 ? i21 : i15) >> 2] | 0;
     HEAP32[i15 >> 2] = i3;
     f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
     i3 = i4;
     f6 = f1;
    }
    if ((i7 | 0) < (i13 | 0)) {
     i5 = i5 + 2 | 0;
     i4 = i3;
     i7 = i7 + 1 | 0;
    } else break;
   }
   i2 = i18 + i2 | 0;
  } while ((i2 | 0) <= (i19 | 0));
 } while (0);
 f28 = Math_fround(f1 / Math_fround(32766.0));
 STACKTOP = i24;
 return Math_fround(f28);
}

function __ZN5physx2Sc13ConstraintSim16postBodiesChangeEPNS0_9RigidCoreES3_(i12, i10, i11) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i9 = i12 + 108 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) i2 = 3; else {
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  if (!i1) i2 = 3; else i2 = 6;
 }
 do if ((i2 | 0) == 3) {
  i1 = HEAP32[i12 + 112 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 60 >> 2] | 0;
   if (i1 | 0) {
    i2 = 6;
    break;
   }
  }
  i8 = i12 + 96 | 0;
  i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 96 >> 2] | 0;
 } while (0);
 if ((i2 | 0) == 6) {
  i8 = i12 + 96 | 0;
  i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 96 >> 2] | 0;
  __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i12);
 }
 i6 = (i10 | 0) != 0;
 if (i6) if (!(HEAP8[i10 + 10 >> 0] | 0)) i4 = 0; else i4 = __ZNK5physx2Sc9RigidCore6getSimEv(i10) | 0; else i4 = 0;
 i7 = (i11 | 0) != 0;
 if (i7) if (!(HEAP8[i11 + 10 >> 0] | 0)) i5 = 0; else i5 = __ZNK5physx2Sc9RigidCore6getSimEv(i11) | 0; else i5 = 0;
 if (!(HEAP16[HEAP32[i12 + 100 >> 2] >> 1] & 6)) {
  if (i4 | 0) {
   i1 = HEAP32[i4 + 60 >> 2] | 0;
   if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i12);
  }
  if (i5 | 0) {
   i1 = HEAP32[i5 + 60 >> 2] | 0;
   if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i12);
  }
 } else if (!(HEAP8[i12 + 116 >> 0] & 1)) __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE(i3, i12);
 i13 = (i4 | 0) == 0;
 i1 = i13 ? 0 : i4 + 64 | 0;
 HEAP32[i12 + 68 >> 2] = i1;
 i2 = (i5 | 0) == 0;
 i3 = i2 ? 0 : i5 + 64 | 0;
 HEAP32[i12 + 72 >> 2] = i3;
 if (i13) i1 = 0; else i1 = HEAP32[i1 + 64 >> 2] | 0;
 HEAP32[i12 + 76 >> 2] = i1;
 if (i2) i1 = 0; else i1 = HEAP32[i3 + 64 >> 2] | 0;
 HEAP32[i12 + 80 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i12 + 112 >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i1 + 1228 >> 2] | 0;
 if (i6) i4 = __ZNK5physx2Sc9RigidCore6getSimEv(i10) | 0; else i4 = HEAP32[i1 + 1208 >> 2] | 0;
 if (i7) i3 = __ZNK5physx2Sc9RigidCore6getSimEv(i11) | 0; else i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 1208 >> 2] | 0;
 i2 = i5 + 292 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i5);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i13 = i5 + 280 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 i13 = i5 + 284 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
 if (!i1) {
  i13 = 0;
  i12 = i12 + 104 | 0;
  HEAP32[i12 >> 2] = i13;
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(i12 | 0, i13 | 0);
  return;
 }
 __ZN5physx2Sc21ConstraintInteractionC2EPNS0_13ConstraintSimERNS0_8RigidSimES5_(i1, i12, i4, i3);
 i13 = i1;
 i12 = i12 + 104 | 0;
 HEAP32[i12 >> 2] = i13;
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_vi(i12 | 0, i13 | 0);
 return;
}

function __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i13, i1, i7) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i6 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i4 - i6 | 0;
 i10 = (i5 | 0) / 12 | 0;
 i12 = i13 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i1 = i6;
 i9 = i8;
 i14 = i4;
 if (i10 >>> 0 > ((i2 - i8 | 0) / 12 | 0) >>> 0) {
  i4 = i8;
  if (i8) {
   i2 = i13 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i9 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i8 | 0) >>> 0) / 12 | 0) * 12 | 0);
   i9 = HEAP32[i13 + 12 >> 2] | 0;
   HEAP32[i11 >> 2] = 1;
   HEAP32[i11 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
   HEAP32[i12 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   i2 = 0;
  }
  if ((i5 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  } else i3 = 0;
  i9 = (i2 - i3 | 0) / 12 | 0;
  i3 = i9 << 1;
  i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i10 >>> 0 ? i10 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i2 = HEAP32[i13 + 12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i13 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i12 >> 2] = i2 + (i3 * 12 | 0);
  if ((i1 | 0) == (i14 | 0)) {
   STACKTOP = i15;
   return;
  }
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = i1 + 12 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 12 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i14 | 0));
  STACKTOP = i15;
  return;
 } else {
  i5 = i13 + 4 | 0;
  i2 = ((HEAP32[i5 >> 2] | 0) - i8 | 0) / 12 | 0;
  i3 = i10 >>> 0 > i2 >>> 0;
  i1 = i3 ? i1 + (i2 * 12 | 0) | 0 : i4;
  i2 = i1 - i6 | 0;
  if (i2 | 0) _memmove(i8 | 0, i6 | 0, i2 | 0) | 0;
  i2 = i9 + (((i2 | 0) / 12 | 0) * 12 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i5 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
   STACKTOP = i15;
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i15;
   return;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = i1 + 12 | 0;
   i2 = (HEAP32[i5 >> 2] | 0) + 12 | 0;
   HEAP32[i5 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i15;
  return;
 }
}

function __ZNK9DebugGLES14BufferBindingsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 1992 >> 0] | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP8[gb + 1548968 >> 0] | 0)) {
  HEAP32[gb + 1451056 >> 2] = 1;
  HEAP32[gb + 1451056 + 4 >> 2] = 1;
  i2 = HEAPU8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0;
  HEAP32[gb + 1451056 + 8 >> 2] = i2;
  i2 = HEAPU8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0;
  HEAP32[gb + 1451056 + 12 >> 2] = i2;
  i2 = HEAPU8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0;
  HEAP32[gb + 1451056 + 16 >> 2] = i2;
  i2 = HEAPU8[(__Z15GetGraphicsCapsv() | 0) + 697 >> 0] | 0;
  HEAP32[gb + 1451056 + 20 >> 2] = i2;
  HEAP8[gb + 1548968 >> 0] = 1;
 }
 i2 = 0;
 do {
  if (!(HEAP32[gb + 1451056 + (i2 << 2) >> 2] | 0)) i1 = 1; else {
   HEAP32[i4 >> 2] = 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 88 >> 2] | 0, HEAP32[gb + 74188 + (i2 << 2) >> 2] | 0, i4 | 0);
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 892 + (i2 << 2) >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 1 : (i1 | 0) == (HEAP32[i4 >> 2] | 0);
  }
  i2 = i2 + 1 | 0;
 } while (i1 & i2 >>> 0 < 6);
 if (i1 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 560 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i4 >> 2] = 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 680 >> 2] | 0, 35368, i2 | 0, i4 | 0);
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 916 + (i2 << 2) >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 1 : (i1 | 0) == (HEAP32[i4 >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i1 & (i2 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 560 >> 2] | 0));
 }
 if (i1 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 564 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i2) mftCall_vii(HEAP32[i1 + 88 >> 2] | 0, 35983, i4 | 0); else mftCall_viii(HEAP32[i1 + 680 >> 2] | 0, 35983, i2 | 0, i4 | 0);
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1172 + (i2 << 2) >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 1 : (i1 | 0) == (HEAP32[i4 >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i1 & (i2 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 564 >> 2] | 0));
 }
 if (i1 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 572 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i4 >> 2] = 0;
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 680 >> 2] | 0, 37569, i2 | 0, i4 | 0);
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1284 + (i2 << 2) >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 1 : (i1 | 0) == (HEAP32[i4 >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i1 & (i2 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 572 >> 2] | 0));
 }
 if (!(i1 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 568 >> 2] | 0) > 0)) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = 0;
 do {
  HEAP32[i4 >> 2] = 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 680 >> 2] | 0, 37075, i2 | 0, i4 | 0);
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1188 + (i2 << 2) >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 1 : (i1 | 0) == (HEAP32[i4 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i1 & (i2 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 568 >> 2] | 0));
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZN21OverlapCapsuleQuery2DC2ERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DR13dynamic_arrayIPS5_Lj4EE(i11, i12, i10, i14, f15, i3, f1, f7, i4, i5) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f7 = Math_fround(f7);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f2 = f0, i6 = 0, i8 = 0, i9 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 HEAP32[i11 >> 2] = gb + 158776 + 8;
 HEAP32[i11 + 4 >> 2] = i3;
 i3 = i11 + 8 | 0;
 i6 = i11 + 12 | 0;
 HEAP32[i11 + 16 >> 2] = i4;
 i4 = i11 + 28 | 0;
 HEAP32[i4 >> 2] = gb + 151688 + 8;
 HEAP32[i11 + 56 >> 2] = gb + 151728 + 8;
 HEAP32[i11 + 60 >> 2] = 2;
 i8 = HEAP32[gb + 151644 >> 2] | 0;
 HEAP32[i11 + 64 >> 2] = i8;
 HEAP32[i11 + 204 >> 2] = 0;
 HEAPF32[i11 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 72 >> 2] = Math_fround(0.0);
 HEAP32[i11 + 32 >> 2] = 4;
 HEAP32[i11 + 36 >> 2] = i8;
 i8 = i11 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i8 = i11 + 208 | 0;
 i9 = i11 + 224 | 0;
 HEAP32[i11 + 240 >> 2] = i5;
 i5 = f1 == Math_fround(-inf);
 f2 = i5 ? Math_fround(-3402823469999999843913219.0e14) : f1;
 HEAPF32[i3 >> 2] = f2;
 i5 = f7 == Math_fround(inf);
 f1 = i5 ? Math_fround(3402823469999999843913219.0e14) : f7;
 HEAPF32[i6 >> 2] = f1;
 if (!(f2 < f1)) {
  HEAPF32[i3 >> 2] = f1;
  HEAPF32[i6 >> 2] = f2;
 }
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 i6 = f2 > Math_fround(.0000999999974);
 f2 = i6 ? f2 : Math_fround(.0000999999974);
 f1 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 i10 = f1 > Math_fround(.0000999999974);
 f1 = i10 ? f1 : Math_fround(.0000999999974);
 if (!i14) {
  f7 = Math_fround(f1 - f2);
  i14 = f7 > Math_fround(.0000999999974);
  f7 = i14 ? f7 : Math_fround(.0000999999974);
  f2 = Math_fround(f2 * Math_fround(.5));
  i14 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = i14;
  __ZN14b2CapsuleShape13SetByExtentsYEffRK6b2Vec2f(i4, f2, f7, i13, f15);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i14 = i11 + 228 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i14 = i11 + 232 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i14 = i11 + 236 | 0;
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  __ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i4, i8, i9, 0, 1);
  STACKTOP = i16;
  return;
 } else {
  f7 = Math_fround(f2 - f1);
  i14 = f7 > Math_fround(.0000999999974);
  f7 = i14 ? f7 : Math_fround(.0000999999974);
  f2 = Math_fround(f1 * Math_fround(.5));
  i14 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = i14;
  __ZN14b2CapsuleShape13SetByExtentsYEffRK6b2Vec2f(i4, f2, f7, i13, f15);
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  i14 = i11 + 228 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i14 = i11 + 232 | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  i14 = i11 + 236 | 0;
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  __ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i4, i8, i9, 0, 1);
  STACKTOP = i16;
  return;
 }
}

function __ZL20updateMassAndInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(i13, i20, i8, i9, i1, i10) {
 i13 = i13 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i23 + 8 | 0;
 i14 = i23;
 i12 = i23 + 136 | 0;
 i21 = i23 + 72 | 0;
 i22 = i23 + 56 | 0;
 i15 = i23 + 40 | 0;
 i11 = i23 + 84 | 0;
 i16 = i23 + 12 | 0;
 HEAPF32[i12 >> 2] = Math_fround(1.0);
 HEAPF32[i21 >> 2] = Math_fround(1.0);
 HEAPF32[i21 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i21 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i22 >> 2] = Math_fround(0.0);
 i17 = i22 + 4 | 0;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 i18 = i22 + 8 | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 i19 = i22 + 12 | 0;
 HEAPF32[i19 >> 2] = Math_fround(1.0);
 i7 = (i1 | 0) != 0;
 if (i7) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i5;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i15 + 4 >> 2] = i3;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i15 + 8 >> 2] = i2;
 } else {
  HEAPF32[i15 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
  i2 = 0;
  i3 = 0;
  i5 = 0;
 }
 if ((i8 | 0) != 0 & (i9 | 0) != 0) {
  i1 = i11;
  i6 = i1 + 52 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i6 | 0));
  if (__ZL21computeMassAndInertiabRN5physx11PxRigidBodyEPKfS3_jbRNS_3Ext21InertiaTensorComputerE(i13, i20, i8, 0, i9, i10, i11) | 0) if (Math_fround(HEAPF32[i11 + 48 >> 2]) != Math_fround(0.0)) {
   __ZL25computeMassAndDiagInertiaRN5physx3Ext21InertiaTensorComputerERNS_6PxVec3ERNS_6PxQuatERfS4_bRKNS_11PxRigidBodyEPKc(i11, i21, i22, i12, i15, i7, i20, gb + 659180 | 0);
   f4 = Math_fround(HEAPF32[i12 >> 2]);
   i5 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i15 + 4 >> 2] | 0;
   i2 = HEAP32[i15 + 8 >> 2] | 0;
   i1 = 1;
  } else {
   f4 = Math_fround(1.0);
   i1 = 0;
  } else {
   i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i14 >> 2] = gb + 659180;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 4, gb + 659217 | 0, 266, gb + 659304 | 0, i14);
   f4 = Math_fround(1.0);
   i1 = 0;
  }
 } else {
  i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i6 >> 2] = gb + 659180;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 4, gb + 659217 | 0, 274, gb + 659386 | 0, i6);
  f4 = Math_fround(1.0);
  i1 = 0;
 }
 mftCall_vif(HEAP32[(HEAP32[i20 >> 2] | 0) + 128 >> 2] | 0, i20 | 0, +f4);
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 140 >> 2] | 0, i20 | 0, i21 | 0);
 i21 = HEAP32[(HEAP32[i20 >> 2] | 0) + 120 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i16 + 16 >> 2] = i5;
 HEAP32[i16 + 20 >> 2] = i3;
 HEAP32[i16 + 24 >> 2] = i2;
 mftCall_vii(i21 | 0, i20 | 0, i16 | 0);
 STACKTOP = i23;
 return i1 | 0;
}

function __ZNK26AnimatorControllerPlayable17ValidateGoToStateERiS0_(i10, i11, i2) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i15 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 180 >> 2] | 0, i10 | 0) | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i9 = i10 + 92 | 0;
 i14 = HEAP32[i9 >> 2] | 0;
 if (!i14) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 L7 : do if ((i1 | 0) == -1) {
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
   break;
  }
  i1 = HEAP32[i14 >> 2] | 0;
  L12 : do if ((i1 | 0) > 0) {
   i5 = i14 + 4 | 0;
   i6 = i5;
   i7 = i14 + 12 | 0;
   i8 = i7;
   i2 = 0;
   while (1) {
    i3 = (HEAP32[i5 >> 2] | 0) + i6 + (i2 << 2) | 0;
    i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
    if (!(HEAP32[i3 + 4 >> 2] | 0)) {
     i1 = (HEAP32[i7 >> 2] | 0) + i8 + (HEAP32[i3 >> 2] << 2) | 0;
     i3 = HEAP32[i1 >> 2] | 0;
     if ((__ZN7mecanim12statemachine13GetStateIndexEPKNS0_20StateMachineConstantEj((i3 | 0) == 0 ? 0 : i1 + i3 | 0, i4) | 0) != -1) break;
     i1 = HEAP32[i14 >> 2] | 0;
    }
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i1 | 0)) break L12;
   }
   HEAP32[i11 >> 2] = i2;
   break L7;
  } while (0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911179 | 0, 0, gb + 899812 | 0, 1172, 512, 0, 0, 0);
  i2 = HEAP32[i11 >> 2] | 0;
 } else i2 = i1; while (0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 180 >> 2] | 0, i10 | 0) | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((i2 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 180 >> 2] | 0, i10 | 0) | 0) i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i2 | 0)) {
   i1 = i14 + 4 | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 + (HEAP32[i11 >> 2] << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i14 = 0;
    STACKTOP = i15;
    return i14 | 0;
   }
   if (i2 >>> 0 >= (HEAP32[i14 + 8 >> 2] | 0) >>> 0) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911224 | 0, 0, gb + 899812 | 0, 1186, 512, 0, 0, 0);
    i14 = 0;
    STACKTOP = i15;
    return i14 | 0;
   }
   if (!(HEAP32[i1 + 4 >> 2] | 0)) {
    i14 = 1;
    STACKTOP = i15;
    return i14 | 0;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911269 | 0, 0, gb + 899812 | 0, 1193, 512, 0, 0, 0);
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 HEAP32[i12 >> 2] = i2;
 __Z6FormatPKcz(i13, gb + 902210 | 0, i12);
 i1 = HEAP32[i10 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i14 = 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN27AnimatorControllerParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i7, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913278 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913293 | 0, i7, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913306 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905632 | 0, gb + 913320 | 0, i6, 0);
 i1 = i8 + 8 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN23ForwardShaderRenderLoopC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i9 = i3;
 i5 = i3 + 8 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 36812 + 8;
 i7 = i1 + 8 | 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i14 = i9;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i7;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i14 = i4;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i8 = i1 + 112 | 0;
 HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 + 4 >> 2] = i13;
 i8 = i9;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i8 = i4;
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 i14 = i1 + 132 | 0;
 HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 i14 = i9;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i7;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i14 = i4;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i8 = i1 + 152 | 0;
 HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 + 4 >> 2] = i13;
 i8 = i9;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i8 = i4;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1 + 172 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 236 >> 2] = 0;
 i6 = i1 + 304 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 316 >> 2] = f12;
 HEAPF32[i1 + 320 >> 2] = f11;
 HEAPF32[i1 + 324 >> 2] = f10;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 i6 = i2;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i9);
 i9 = i4;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1 + 344 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i1 + 368 >> 2] = 0;
 i2 = i5;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN9ShaderLab10GrabPassesC2E10MemLabelId(i1 + 372 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN19SpriteMeshGenerator4path3decEi(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i1 >> 2] | 0;
 i11 = (HEAP32[i1 + 4 >> 2] | 0) - i14 | 0;
 i12 = i11 >> 5;
 if ((i11 | 0) < 96) {
  i14 = 0;
  return i14 | 0;
 }
 i1 = i13 + -1 | 0;
 if ((i12 | 0) < (i13 | 0)) i1 = (i1 | 0) % (i12 | 0) | 0; else if ((i13 | 0) <= 0) i1 = i12 + -1 - ((0 - i13 | 0) % (i12 | 0) | 0) | 0;
 f4 = Math_fround(HEAPF32[i14 + (i1 << 5) >> 2]);
 f5 = Math_fround(HEAPF32[i14 + (i1 << 5) + 4 >> 2]);
 i11 = (i12 | 0) > (i13 | 0);
 if (i11) if ((i13 | 0) > -1) i1 = i13; else i1 = i12 + -1 - ((~i13 | 0) % (i12 | 0) | 0) | 0; else i1 = (i13 | 0) % (i12 | 0) | 0;
 f6 = Math_fround(HEAPF32[i14 + (i1 << 5) >> 2]);
 f8 = Math_fround(HEAPF32[i14 + (i1 << 5) + 4 >> 2]);
 i1 = i13 + 1 | 0;
 if ((i1 | 0) < (i12 | 0)) {
  if ((i13 | 0) <= -2) i1 = i12 + -1 - ((-2 - i13 | 0) % (i12 | 0) | 0) | 0;
 } else i1 = (i1 | 0) % (i12 | 0) | 0;
 f10 = Math_fround(HEAPF32[i14 + (i1 << 5) >> 2]);
 f9 = Math_fround(f4 - f6);
 f5 = Math_fround(f5 - f8);
 f10 = Math_fround(f6 - f10);
 f6 = Math_fround(f8 - Math_fround(HEAPF32[i14 + (i1 << 5) + 4 >> 2]));
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(f5 * f5))));
 f8 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 if (f4 > f8) {
  f5 = Math_fround(Math_fround(-f5) / f4);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  f9 = Math_fround(f9 / f4);
  i7 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i3 = HEAP32[gb + 1162356 >> 2] | 0;
  i7 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 }
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f6 * f6))));
 if (f4 > f8) {
  f9 = Math_fround(Math_fround(-f6) / f4);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  f10 = Math_fround(f10 / f4);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = HEAP32[gb + 1162356 >> 2] | 0;
  i2 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 }
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f6);
 f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f4);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4))));
 if (f5 > f8) {
  f10 = Math_fround(f6 / f5);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  f10 = Math_fround(f4 / f5);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i2 = HEAP32[gb + 1162356 >> 2] | 0;
  i3 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 }
 if (i11) if ((i13 | 0) > -1) i1 = i13; else i1 = i12 + -1 - ((~i13 | 0) % (i12 | 0) | 0) | 0; else i1 = (i13 | 0) % (i12 | 0) | 0;
 HEAP32[i14 + (i1 << 5) + 8 >> 2] = i2;
 HEAP32[i14 + (i1 << 5) + 12 >> 2] = i3;
 i14 = 1;
 return i14 | 0;
}

function __ZN11TrailModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 8 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 12 | 0, i6);
 i1 = i5 + 276 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 280 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 284 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 285 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 286 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 287 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 288 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 292 | 0;
  __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 448 | 0;
  __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 712 | 0;
  __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 292 | 0;
  __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 448 | 0;
  __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  i8 = i5 + 712 | 0;
  __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZL23SelectClosestEdgeCB_BoxRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0;
 i8 = HEAP32[i1 + 24 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f5 * f9);
 f4 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(f5 + Math_fround(f4 * f10));
 f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f4 + Math_fround(f5 * f6));
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 20 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i8 + 24 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 28 >> 2])));
 i7 = f4 > f5;
 f5 = i7 ? f4 : f5;
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 40 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i8 + 44 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 48 >> 2])));
 i3 = f4 > f5;
 f5 = i3 ? f4 : f5;
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 60 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i8 + 64 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 68 >> 2])));
 i2 = f4 > f5;
 f5 = i2 ? f4 : f5;
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 80 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i8 + 84 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 88 >> 2])));
 i11 = f4 > f5;
 f5 = i11 ? f4 : f5;
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 100 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i8 + 104 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 108 >> 2])));
 i1 = f4 > f5;
 i7 = i1 ? 5 : i11 ? 4 : i2 ? 3 : i3 ? 2 : i7 & 1;
 f5 = i1 ? f4 : f5;
 i1 = -1;
 i3 = 0;
 while (1) {
  f4 = Math_fround(Math_fround(HEAPF32[gb + 84976 + (i3 * 12 | 0) >> 2]) * f9);
  f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[gb + 84976 + (i3 * 12 | 0) + 4 >> 2]) * f10));
  f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[gb + 84976 + (i3 * 12 | 0) + 8 >> 2]) * f6));
  i2 = f4 > f5;
  i1 = i2 ? i3 : i1;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 12) break; else f5 = i2 ? f4 : f5;
 }
 if ((i1 | 0) == -1) {
  i11 = i7;
  return i11 | 0;
 }
 i11 = HEAP32[gb + 84280 + (i1 << 3) + 4 >> 2] | 0;
 i7 = HEAPU8[gb + 656115 + i11 >> 0] | 0;
 i11 = HEAPU8[i11 + 1 + (gb + 656115) >> 0] | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i8 + (i7 * 20 | 0) >> 2]) * f9);
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i8 + (i7 * 20 | 0) + 4 >> 2]) * f10));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i8 + (i7 * 20 | 0) + 8 >> 2]) * f6));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i8 + (i11 * 20 | 0) >> 2]));
 f10 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i11 * 20 | 0) + 4 >> 2])));
 i8 = f5 > Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i8 + (i11 * 20 | 0) + 8 >> 2])));
 i11 = i8 ? i7 : i11;
 return i11 | 0;
}

function __ZN5physx28PxDistanceJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 742815;
 HEAP32[i1 + 240 >> 2] = 441;
 HEAP32[i1 + 244 >> 2] = fb + 452;
 HEAP32[i1 + 248 >> 2] = gb + 867786;
 HEAP32[i1 + 252 >> 2] = 442;
 HEAP32[i1 + 256 >> 2] = fb + 453;
 HEAP32[i1 + 260 >> 2] = fb + 388;
 HEAP32[i1 + 264 >> 2] = gb + 867798;
 HEAP32[i1 + 268 >> 2] = 443;
 HEAP32[i1 + 272 >> 2] = fb + 454;
 HEAP32[i1 + 276 >> 2] = fb + 389;
 HEAP32[i1 + 280 >> 2] = gb + 742824;
 HEAP32[i1 + 284 >> 2] = 444;
 HEAP32[i1 + 288 >> 2] = fb + 455;
 HEAP32[i1 + 292 >> 2] = fb + 390;
 HEAP32[i1 + 296 >> 2] = gb + 765184;
 HEAP32[i1 + 300 >> 2] = 445;
 HEAP32[i1 + 304 >> 2] = fb + 456;
 HEAP32[i1 + 308 >> 2] = fb + 391;
 HEAP32[i1 + 312 >> 2] = gb + 741403;
 HEAP32[i1 + 316 >> 2] = 446;
 HEAP32[i1 + 320 >> 2] = fb + 457;
 HEAP32[i1 + 324 >> 2] = fb + 392;
 HEAP32[i1 + 328 >> 2] = gb + 742834;
 HEAP32[i1 + 332 >> 2] = 447;
 HEAP32[i1 + 336 >> 2] = fb + 2172;
 HEAP32[i1 + 340 >> 2] = fb + 3574;
 HEAP32[i1 + 344 >> 2] = gb + 831985;
 HEAP32[i1 + 348 >> 2] = 448;
 HEAP32[i1 + 352 >> 2] = fb + 2173;
 return;
}

function __ZN11PreloadData23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = i3 + 24 | 0;
 i9 = i3 + 20 | 0;
 i4 = i3 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 461092 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i10 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 461104 | 0, i10, i1 + 32 | 0, 0);
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37176 >> 2] | 0, i9, 0);
 i11 = i8 + 8 | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 1);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i11, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470499 | 0, i10, i1 + 52 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i4);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN14ConstantStringD2Ev(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL24SendTransformChangedMaskRK18TransformHierarchyii(i4, i5, i11) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 12 | 0;
 i14 = i15;
 i12 = HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
 i9 = i4 + 28 | 0;
 i10 = (HEAP32[i9 >> 2] | 0) + i5 | 0;
 HEAP8[i10 >> 0] = HEAPU8[i10 >> 0] | 0 | i11 & 31;
 i10 = i4 + 68 | 0;
 if (i12 >>> 0 > 1) {
  i3 = i4 + 12 | 0;
  i1 = (HEAP32[i10 >> 2] | 0) + (i5 << 2) | 0;
  i2 = 1;
  while (1) {
   i1 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i8 = i6 + i1 | 0;
   i7 = HEAP8[i8 >> 0] | 0;
   HEAP8[i8 >> 0] = ((HEAP8[i6 + (HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) >> 0] | i7) & 255 | 17) & (i7 << 24 >> 24 ? 239 : 255);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i12 | 0)) break; else i1 = (HEAP32[i10 >> 2] | 0) + (i1 << 2) | 0;
  }
 }
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 4 | 0;
 i6 = gb + 63160 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i12 << 3;
 do if (!i1) i1 = 0; else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 421343 | 0, 935) | 0;
   i6 = gb + 64016 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i1;
   i7 = i8;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 } while (0);
 i7 = i1 + 3 & -4;
 if (!i12) {
  i14 = HEAP32[i14 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
  STACKTOP = i15;
  return;
 }
 i6 = i4 + 20 | 0;
 i4 = i4 + 24 | 0;
 i3 = 0;
 i2 = i5;
 i1 = 0;
 while (1) {
  if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31))) {
   i5 = i1;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   HEAP32[i7 + (i1 << 3) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2];
   i16 = HEAP32[i9 >> 2] | 0;
   HEAP32[i7 + (i1 << 3) + 4 >> 2] = HEAPU8[i16 + i2 >> 0] | 0 | i11;
   i5 = i1 + 1 | 0;
   i1 = i16;
  }
  HEAP8[i1 + i2 >> 0] = 0;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i12 | 0)) break; else {
   i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i1 = i5;
  }
 }
 if (!i5) {
  i16 = HEAP32[i14 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
  STACKTOP = i15;
  return;
 }
 i2 = i13 + 8 | 0;
 i3 = i13 + 4 | 0;
 i1 = 0;
 do {
  i12 = HEAP32[i7 + (i1 << 3) + 4 >> 2] | 0;
  i16 = HEAP32[(HEAP32[i7 + (i1 << 3) >> 2] | 0) + 28 >> 2] | 0;
  HEAP32[i13 >> 2] = gb + 29192;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = i12;
  __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i16, gb + 1105016 | 0, i13);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 i16 = HEAP32[i14 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i16, i8);
 STACKTOP = i15;
 return;
}

function __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 32 | 0;
 i12 = i14;
 HEAP32[i12 >> 2] = 0;
 i13 = i12 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i12 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i9 = HEAP32[i2 + 20 >> 2] | 0;
 i8 = i2 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i12, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i7 = HEAP32[i12 >> 2] | 0;
    HEAP32[i7 + (i1 * 12 | 0) >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i10 + 24 >> 2] | 0;
 i7 = (i1 | 0) != 0;
 if (i7) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i9, i1);
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 16 | 0;
  i5 = i9 + 36 | 0;
  i6 = i9 + 40 | 0;
  do {
   i2 = HEAP32[i4 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 if (i7) __ZN17RemapPPtrTransfer11PopMetaFlagEv(i9);
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 i5 = (i2 | 0) / 12 | 0;
 i3 = i6 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i5) | 0;
  HEAP32[i3 >> 2] = i5;
 }
 if (i2 | 0) {
  i2 = i12 + 16 | 0;
  i3 = i12 + 24 | 0;
  i4 = i12 + 20 | 0;
  i1 = 0;
  do {
   i10 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i1) | 0;
   HEAP32[i10 >> 2] = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i13 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sn20SerializationContextC2ERKNS_2Cm10CollectionEPS4_(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i9 = i11;
 HEAP32[i6 >> 2] = gb + 89224 + 8;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i6 + 28 >> 2] = Math_fround(.75);
 HEAP32[i6 + 32 >> 2] = -1;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i6 + 80 | 0;
 i2 = i6 + 44 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.75);
 HEAP32[i6 + 84 >> 2] = -1;
 HEAP32[i6 + 88 >> 2] = 0;
 HEAP32[i6 + 92 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i6 + 56 | 0, 64);
 i7 = i6 + 96 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAPF32[i6 + 120 >> 2] = Math_fround(.75);
 HEAP32[i6 + 124 >> 2] = -1;
 HEAP32[i6 + 128 >> 2] = 0;
 HEAP32[i6 + 132 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i7, 64);
 i7 = i6 + 136 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAPF32[i6 + 160 >> 2] = Math_fround(.75);
 HEAP32[i6 + 164 >> 2] = -1;
 HEAP32[i6 + 168 >> 2] = 0;
 HEAP32[i6 + 172 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i7, 64);
 i8 = i6 + 176 | 0;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i6 + 180 >> 2] = i5;
 i1 = _PxGetFoundation() | 0;
 __ZN5physx27PxDefaultMemoryOutputStreamC2ERNS_19PxAllocatorCallbackE(i6 + 184 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!(HEAP32[i1 + 80 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = 0;
 do {
  i1 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + (i3 << 4) >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS7_Rb(i7, i9, i10) | 0;
  if (!(HEAP8[i10 >> 0] | 0)) {
   HEAP32[i2 >> 2] = i1;
   i1 = i2 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
  } else i1 = i2 + 4 | 0;
  HEAP32[i1 >> 2] = i3;
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } while (i3 >>> 0 < (HEAP32[i1 + 80 >> 2] | 0) >>> 0);
 STACKTOP = i11;
 return;
}

function __ZN16MemoryFileSystem11CreateAsDirER13FileEntryData(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 48 | 0;
 i8 = i11 + 32 | 0;
 i10 = i11;
 i5 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, _strlen(i1) | 0);
 __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i8);
 i3 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i10 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i2 = i10 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i7, i1, i8);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i7 + 4 | 0, i8) | 0;
 if ((i1 | 0) == (i7 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i9);
 }
 if (!i1) i1 = (__ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i7, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 1) | 0) != 0; else i1 = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i8 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 STACKTOP = i11;
 return i1 | 0;
}

function _TT_Load_Composite_Glyph(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = i14 + 200 | 0;
 i16 = HEAP32[i14 + 204 >> 2] | 0;
 i17 = HEAP32[i14 + 12 >> 2] | 0;
 i12 = i17 + 88 | 0;
 i13 = 0;
 i5 = HEAP32[i15 >> 2] | 0;
 while (1) {
  i11 = i13;
  i13 = i13 + 1 | 0;
  i1 = _UNITY_FT_GlyphLoader_CheckSubGlyphs(i17, i13) | 0;
  if (i1 | 0) {
   i2 = 25;
   break;
  }
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i16 >>> 0) {
   i1 = 21;
   i2 = 25;
   break;
  }
  i9 = HEAP32[i12 >> 2] | 0;
  i4 = i9 + (i11 << 5) + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i6 = i9 + (i11 << 5) + 8 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = HEAPU8[i5 + 1 >> 0] | 0;
  i10 = (HEAPU8[i5 >> 0] << 8 | i7) & 65535;
  HEAP16[i9 + (i11 << 5) + 4 >> 1] = i10;
  HEAP32[i9 + (i11 << 5) >> 2] = HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0];
  i1 = i7 << 1 & 2;
  i2 = i1 + 2 | 0;
  i8 = (i7 & 8 | 0) == 0;
  do if (i8) if (!(i7 & 64)) {
   i1 = i2 | i7 >>> 4 & 8;
   break;
  } else {
   i1 = i1 + 6 | 0;
   break;
  } else i1 = i1 | 4; while (0);
  if ((i3 + i1 | 0) >>> 0 > i16 >>> 0) {
   i1 = 21;
   i2 = 25;
   break;
  }
  i1 = (i7 & 1 | 0) != 0;
  do if (!(i7 & 2)) if (i1) {
   HEAP32[i6 >> 2] = HEAPU8[i3 >> 0] << 8 | HEAPU8[i5 + 5 >> 0];
   HEAP32[i4 >> 2] = HEAPU8[i5 + 6 >> 0] << 8 | HEAPU8[i5 + 7 >> 0];
   i5 = i5 + 8 | 0;
   break;
  } else {
   HEAP32[i6 >> 2] = HEAPU8[i3 >> 0];
   HEAP32[i4 >> 2] = HEAPU8[i5 + 5 >> 0];
   i5 = i5 + 6 | 0;
   break;
  } else if (i1) {
   HEAP32[i6 >> 2] = (HEAPU8[i3 >> 0] << 8 | HEAPU8[i5 + 5 >> 0]) << 16 >> 16;
   HEAP32[i4 >> 2] = (HEAPU8[i5 + 6 >> 0] << 8 | HEAPU8[i5 + 7 >> 0]) << 16 >> 16;
   i5 = i5 + 8 | 0;
   break;
  } else {
   HEAP32[i6 >> 2] = HEAP8[i3 >> 0];
   HEAP32[i4 >> 2] = HEAP8[i5 + 5 >> 0];
   i5 = i5 + 6 | 0;
   break;
  } while (0);
  do if (i8) {
   if (i7 & 64 | 0) {
    i1 = 0;
    i2 = (HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0]) << 16 >> 14;
    i3 = 0;
    i4 = (HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0]) << 16 >> 14;
    i5 = i5 + 4 | 0;
    break;
   }
   if (!(i7 & 128)) {
    i1 = 0;
    i2 = 65536;
    i3 = 0;
    i4 = 65536;
   } else {
    i1 = (HEAPU8[i5 + 2 >> 0] << 8 | HEAPU8[i5 + 3 >> 0]) << 16 >> 14;
    i2 = (HEAPU8[i5 + 6 >> 0] << 8 | HEAPU8[i5 + 7 >> 0]) << 16 >> 14;
    i3 = (HEAPU8[i5 + 4 >> 0] << 8 | HEAPU8[i5 + 5 >> 0]) << 16 >> 14;
    i4 = (HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0]) << 16 >> 14;
    i5 = i5 + 8 | 0;
   }
  } else {
   i4 = (HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0]) << 16 >> 14;
   i1 = 0;
   i2 = i4;
   i3 = 0;
   i5 = i5 + 2 | 0;
  } while (0);
  HEAP32[i9 + (i11 << 5) + 16 >> 2] = i4;
  HEAP32[i9 + (i11 << 5) + 20 >> 2] = i3;
  HEAP32[i9 + (i11 << 5) + 24 >> 2] = i1;
  HEAP32[i9 + (i11 << 5) + 28 >> 2] = i2;
  if (!(i10 & 32)) {
   i2 = 24;
   break;
  }
 }
 if ((i2 | 0) == 24) {
  HEAP32[i17 + 84 >> 2] = i13;
  HEAP32[i14 + 168 >> 2] = i5 + (_UNITY_FT_Stream_Pos(HEAP32[i14 + 24 >> 2] | 0) | 0) - i16;
  HEAP32[i15 >> 2] = i5;
  i17 = 0;
  return i17 | 0;
 } else if ((i2 | 0) == 25) return i1 | 0;
 return 0;
}

function __ZNSt3__26vectorI11ImageFilterNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i6 = i7;
 i13 = i7 + ((((HEAP32[i2 >> 2] | 0) - i6 | 0) / 12 | 0) * 12 | 0) | 0;
 i14 = i12 + 4 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 i3 = i12 + 8 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i2 = i5;
 i4 = i11;
 if (i5 >>> 0 < i11 >>> 0) {
  if ((i13 | 0) == (i5 | 0)) {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 12;
   i14 = i13;
   return i14 | 0;
  }
  i4 = i2 - (i13 + 12) | 0;
  i2 = i13 + (((i4 | 0) / 12 | 0) * 12 | 0) | 0;
  if (i2 >>> 0 < i5 >>> 0) {
   i3 = i5;
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i2 = i2 + 12 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 12 | 0;
    HEAP32[i14 >> 2] = i3;
   } while (i2 >>> 0 < i5 >>> 0);
  }
  if (i4 | 0) _memmove(i5 + (((i4 | 0) / -12 | 0) * 12 | 0) | 0, i13 | 0, i4 | 0) | 0;
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 12 | 0 : i1;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP16[i13 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
  i14 = i13;
  return i14 | 0;
 }
 i5 = ((i2 - i6 | 0) / 12 | 0) + 1 | 0;
 if (i5 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i9 = HEAP32[i12 >> 2] | 0;
  i11 = i3;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i9;
 } else {
  i11 = i3;
  i2 = i4;
  i3 = i6;
  i9 = i7;
 }
 i10 = (i2 - i3 | 0) / 12 | 0;
 i7 = i10 << 1;
 i7 = i10 >>> 0 < 178956970 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 357913941;
 i10 = i13;
 i4 = i10 - i3 | 0;
 i6 = (i4 | 0) / 12 | 0;
 if (!i7) i8 = 0; else i8 = __Znwj(i7 * 12 | 0) | 0;
 i2 = i8 + (i6 * 12 | 0) | 0;
 i5 = i2;
 i3 = i8 + (i7 * 12 | 0) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i4 | 0) > 0) {
   i2 = i2 + (((i7 + 1 | 0) / -2 | 0) * 12 | 0) | 0;
   i5 = i2;
   i4 = i9;
   break;
  }
  i3 = i7 * 12 | 0;
  i3 = (i3 | 0) == 0 ? 1 : ((i3 | 0) / 12 | 0) << 1;
  if (!i3) i4 = 0; else i4 = __Znwj(i3 * 12 | 0) | 0;
  i2 = i4 + ((i3 >>> 2) * 12 | 0) | 0;
  i5 = i2;
  i3 = i4 + (i3 * 12 | 0) | 0;
  if (!i8) i4 = i9; else {
   __ZdlPv(i8);
   i4 = HEAP32[i12 >> 2] | 0;
  }
 } else i4 = i9; while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = i5 + 12 | 0;
 i2 = i10 - i4 | 0;
 i6 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i6 | 0, i4 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i13 | 0, i2 | 0) | 0;
  i1 = i1 + (((i2 >>> 0) / 12 | 0) * 12 | 0) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i3;
 if (!i2) {
  i14 = i5;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i5;
 return i14 | 0;
}

function __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471784 | 0, gb + 471434 | 0, i1, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471789 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471794 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471800 | 0, gb + 471434 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471805 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function _PxCloseVehicleSDK(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 __ZN5physx26resetVehicleToleranceScaleEv();
 if ((__ZN5physx29resetSerializationRegistryPtrEv() | 0) != (i2 | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 830816 | 0, 82, gb + 835173 | 0, i3);
  STACKTOP = i3;
  return;
 }
 if (!i2) {
  STACKTOP = i3;
  return;
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 513) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 515) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 512) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, 514) | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 513) | 0;
 if (i1 | 0) {
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 515) | 0;
 if (i1 | 0) {
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 512) | 0;
 if (i1 | 0) {
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 514) | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN9Texture3D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 80 | 0;
 i9 = i7 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i7 + 24 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i6 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i3 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i6 + 76 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i3 = i6 + 100 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i3, 4);
 __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 32 | 0, i7);
 i1 = i6 + 105 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i9 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i7, i8, gb + 411165 | 0, 1);
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i6 + 96 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i7, i9, i10, 0);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i9 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i7, i8, gb + 411165 | 0, 1);
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i6 + 96 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i7, i9, i10, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i8, i12, i6, i7, i10) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i9 = 0, i11 = 0;
 i11 = HEAP32[i8 + 280 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = (HEAP32[i8 + 276 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 L1 : do if (!i5) {
  if (!(HEAP32[i8 + 60 >> 2] | 0)) {
   switch (i1 | 0) {
   case 7:
   case 8:
   case 12:
    break L1;
   default:
    i1 = 0;
   }
   return i1 | 0;
  }
  if (i1 >>> 0 < 17 & (HEAP32[i8 + 268 >> 2] | 0) == 0) if (67075 >>> i1 & 1) {
   i12 = 0;
   return i12 | 0;
  }
 } else switch (i1 | 0) {
 case 3:
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP32[i8 + 60 >> 2] | 0)) {
    i12 = 0;
    return i12 | 0;
   }
   if (HEAP32[i8 + 268 >> 2] | 0) break L1;
   i1 = (i5 | 0) == (i10 | 0) ? i1 : 11;
   break L1;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP32[i8 + 60 >> 2] | 0)) {
    i12 = 0;
    return i12 | 0;
   }
   if ((i5 | 0) == (i10 | 0) | (HEAP32[i8 + 268 >> 2] | 0) != 0) break L1;
   i1 = (HEAP32[i8 >> 2] | 0) == (i10 | 0) ? i1 : 11;
   break L1;
  }
 default:
  break L1;
 } while (0);
 switch (i1 | 0) {
 case 0:
  {
   f2 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f3 = Math_fround(HEAPF32[i12 >> 2]);
   if (!(f3 <= f2)) {
    i12 = 0;
    return i12 | 0;
   }
   if (!(Math_fround(f3 + Math_fround(HEAPF32[i12 + 8 >> 2])) > f2)) {
    i12 = 0;
    return i12 | 0;
   }
   f2 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   if (!(f2 <= f4)) {
    i12 = 0;
    return i12 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i12 + 12 >> 2])) > f4)) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i9 >> 2] = i10;
   HEAP32[i11 >> 2] = 12;
   i12 = 0;
   return i12 | 0;
  }
 case 1:
  {
   if ((i5 | 0) != (i10 | 0)) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i9 >> 2] = 0;
   HEAP32[i11 >> 2] = 12;
   f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
   f4 = Math_fround(HEAPF32[i11 + 8 >> 2]);
   f2 = Math_fround(HEAPF32[i12 >> 2]);
   if (!(f2 <= f3)) {
    i12 = 0;
    return i12 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i12 + 8 >> 2])) > f3)) {
    i12 = 0;
    return i12 | 0;
   }
   f2 = Math_fround(HEAPF32[i12 + 4 >> 2]);
   if (!(f2 <= f4)) {
    i12 = 0;
    return i12 | 0;
   }
   if (!(Math_fround(f2 + Math_fround(HEAPF32[i12 + 12 >> 2])) > f4)) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i8 + 64 >> 2] = 1;
   i12 = 1;
   return i12 | 0;
  }
 case 4:
  {
   if ((HEAP16[i11 + 36 >> 1] | 0) != 32) {
    i12 = 0;
    return i12 | 0;
   }
   if ((HEAP32[i8 >> 2] | 0) != (i10 | 0)) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i11 >> 2] = 12;
   HEAP32[i8 + 64 >> 2] = 1;
   i12 = 1;
   return i12 | 0;
  }
 case 3:
  {
   if ((i5 | 0) != (i10 | 0)) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i11 >> 2] = 12;
   i12 = 0;
   return i12 | 0;
  }
 case 7:
  {
   __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib(i7, i8, i12, i6, i10, 0);
   i12 = 0;
   return i12 | 0;
  }
 default:
  {
   i12 = 0;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZN20NavMeshBuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
  i2 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 36 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __Z29BakePxMeshStreamFromUnityMeshP4MeshbbbR13dynamic_arrayIhLj1EE(i1, i2, i3, i4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 136 | 0;
 i5 = i9 + 92 | 0;
 i8 = i9 + 64 | 0;
 i10 = __Z10GetCookingv() | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 i11 = HEAP32[i10 + 28 >> 2] | 0;
 HEAP32[i7 + 28 >> 2] = i11;
 i12 = i7 + 32 | 0;
 i10 = i10 + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = i11;
 _memmove(i5 + 32 | 0, i10 | 0, 12) | 0;
 HEAP32[i5 >> 2] = i4 ? 2 : 0;
 i4 = __Z10GetCookingv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i5 | 0);
 __ZN12MemoryStreamC2EPhj(i8, 0, 0);
 if (!(__Z27CreatePxStreamFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypeR12MemoryStream(i1, i2, i3, i9, 0, i8) | 0)) {
  i1 = i6 + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i6 + 4 | 0);
   HEAP32[i6 >> 2] = 0;
  }
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i12 = __Z10GetCookingv() | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i11 = i11 + 4 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(i11 | 0, i12 | 0, i7 | 0);
  __ZN12MemoryStreamD2Ev(i8);
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = i12;
  i1 = i12;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i4 | 0, HEAP32[i5 >> 2] | 0) | 0;
 i12 = __Z10GetCookingv() | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i11 = i11 + 4 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vii(i11 | 0, i12 | 0, i7 | 0);
 __ZN12MemoryStreamD2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i4 = i9 + 104 | 0;
 i5 = i6 + 32 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP16[i7 + 18 >> 1] | 0;
 if ((i3 & 255) != 2) {
  i8 = HEAP32[i7 + 100 >> 2] | 0;
  __ZN14VertexDataInfoC2Ev(i1);
  HEAP8[i4 >> 0] = 2;
  HEAP8[i4 + 1 >> 0] = 4;
  __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i1, i2, i8, 2, i4);
  __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i8, HEAP32[i1 + 88 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + 8 | 0, i1);
  STACKTOP = i9;
  return;
 }
 i1 = (i3 & 65535) < 1024;
 if (!(HEAP8[i6 + 44 >> 0] & 16)) {
  if (i1) {
   STACKTOP = i9;
   return;
  }
  i1 = HEAP32[i7 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i7 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i3 = HEAP32[i7 + 16 >> 2] | 0;
   i1 = i1 + ((i3 >>> 8 & 255) + (HEAP32[i8 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i3 = i3 >>> 16 & 65535;
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) i3 = 0; else {
   i3 = HEAP32[i7 + 100 >> 2] | 0;
   i4 = HEAP32[i7 + 92 >> 2] | 0;
   if (!i4) i3 = 0; else if (!(HEAP8[i7 + 19 >> 0] | 0)) i3 = 0; else {
    i6 = HEAP16[i7 + 16 >> 1] | 0;
    i3 = i4 + ((Math_imul(HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i3) | 0) + (HEAP32[i8 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i9;
   return;
  }
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + i5 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 4 | 0;
  }
  STACKTOP = i9;
  return;
 } else {
  if (i1) {
   STACKTOP = i9;
   return;
  }
  i1 = HEAP32[i7 + 92 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 1;
  } else if (!(HEAP8[i7 + 19 >> 0] | 0)) {
   i1 = 0;
   i5 = 1;
  } else {
   i3 = HEAP32[i7 + 16 >> 2] | 0;
   i1 = i1 + ((i3 >>> 8 & 255) + (HEAP32[i8 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
   i5 = HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   i3 = i3 >>> 16 & 65535;
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) i3 = 0; else {
   i3 = HEAP32[i7 + 100 >> 2] | 0;
   i4 = HEAP32[i7 + 92 >> 2] | 0;
   if (!i4) i3 = 0; else if (!(HEAP8[i7 + 19 >> 0] | 0)) i3 = 0; else {
    i6 = HEAP16[i7 + 16 >> 1] | 0;
    i3 = i4 + ((Math_imul(HEAPU8[i8 + 32 + ((HEAPU8[i7 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i3) | 0) + (HEAP32[i8 + 32 + ((i6 & 255) * 12 | 0) + 4 >> 2] | 0) + ((i6 & 65535) >>> 8 & 65535)) | 0;
   }
  }
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i9;
   return;
  }
  while (1) {
   i8 = HEAP32[i1 >> 2] | 0;
   HEAP32[i2 >> 2] = i8 & -16777216 | HEAPU8[i1 + 2 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | i8 << 16 & 16711680;
   i1 = i1 + i5 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 4 | 0;
  }
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i10, f8, f5, f9, f3, i11, i16) {
 i10 = i10 | 0;
 f8 = Math_fround(f8);
 f5 = Math_fround(f5);
 f9 = Math_fround(f9);
 f3 = Math_fround(f3);
 i11 = i11 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, f7 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 f12 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 i13 = f12 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 i15 = f14 > Math_fround(0.0);
 f7 = i13 | i15 ? Math_fround(0.0) : f3;
 if (Math_fround(f7 + f5) > f8) {
  f19 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
  f18 = Math_fround(-Math_fround(HEAPF32[i11 + 4 >> 2]));
  f17 = Math_fround(-Math_fround(HEAPF32[i11 + 8 >> 2]));
  f3 = Math_fround(Math_fround(f5 - f8) * Math_fround(-4.0));
  i1 = i10 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i4 + 80;
  i1 = i4 + 78 | 0;
  HEAP16[i1 >> 1] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAPF32[i4 + 16 >> 2] = f19;
  HEAPF32[i4 + 20 >> 2] = f18;
  HEAPF32[i4 + 24 >> 2] = f17;
  HEAP32[i4 + 32 >> 2] = 0;
  HEAP32[i4 + 36 >> 2] = 0;
  HEAP32[i4 + 40 >> 2] = 0;
  HEAPF32[i4 + 48 >> 2] = f19;
  HEAPF32[i4 + 52 >> 2] = f18;
  HEAPF32[i4 + 56 >> 2] = f17;
  HEAPF32[i4 + 12 >> 2] = f3;
  i6 = i4 + 76 | 0;
  i2 = HEAPU16[i6 >> 1] | 0;
  if (i13 | i15) {
   HEAPF32[i4 + 64 >> 2] = f14;
   HEAPF32[i4 + 68 >> 2] = f12;
   i1 = i2 | 17;
  } else {
   HEAP16[i1 >> 1] = 1025;
   i20 = HEAP32[i16 >> 2] | 0;
   HEAP32[i4 + 64 >> 2] = i20;
   HEAP32[i4 + 68 >> 2] = HEAP32[i16 + 4 >> 2];
   i1 = f3 > Math_fround(0.0);
   i1 = i2 | (i1 ? 24 : 16);
   if ((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
  }
  HEAP16[i6 >> 1] = i1;
  HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 }
 if (!(Math_fround(f9 - f7) < f8)) return;
 f3 = Math_fround(Math_fround(f9 - f8) * Math_fround(4.0));
 i2 = i10 + 4 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6 + 80;
 i2 = i6 + 78 | 0;
 HEAP16[i2 >> 1] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i11 >> 2];
 i1 = i11 + 4 | 0;
 HEAP32[i6 + 20 >> 2] = HEAP32[i1 >> 2];
 i4 = i11 + 8 | 0;
 HEAP32[i6 + 24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i6 + 12 >> 2] = f3;
 i4 = i6 + 76 | 0;
 i1 = HEAPU16[i4 >> 1] | 0;
 if (i13 | i15) {
  HEAPF32[i6 + 64 >> 2] = f14;
  HEAPF32[i6 + 68 >> 2] = f12;
  i1 = i1 | 17;
 } else {
  HEAP16[i2 >> 1] = 1025;
  i20 = HEAP32[i16 >> 2] | 0;
  HEAP32[i6 + 64 >> 2] = i20;
  HEAP32[i6 + 68 >> 2] = HEAP32[i16 + 4 >> 2];
  i16 = f3 > Math_fround(0.0);
  i1 = i1 | (i16 ? 24 : 16);
  if ((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
 }
 HEAP16[i4 >> 1] = i1;
 HEAPF32[i6 + 44 >> 2] = Math_fround(0.0);
 return;
}

function _tt_cmap14_char_variants(i1, i2, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 i7 = HEAP32[i1 + 24 >> 2] | 0;
 i15 = i1 + 16 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i5 = i7 + 1 | 0;
 i6 = i1 + 28 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 do if (i3 >>> 0 < i5 >>> 0) {
  HEAP32[i1 + 36 >> 2] = i2;
  i13 = i1 + 32 | 0;
  i1 = _UNITY_ft_mem_realloc(i2, 4, i3, i5, HEAP32[i13 >> 2] | 0, i4) | 0;
  HEAP32[i13 >> 2] = i1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   HEAP32[i6 >> 2] = i5;
   i13 = i1;
   break;
  }
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 } else i13 = HEAP32[i1 + 32 >> 2] | 0; while (0);
 if (!i7) i1 = i13; else {
  i12 = i8 + 10 | 0;
  i1 = i13;
  do {
   i11 = (HEAPU8[i12 + 1 >> 0] | 0) << 8 | (HEAPU8[i12 >> 0] | 0) << 16 | (HEAPU8[i12 + 2 >> 0] | 0);
   i2 = (HEAPU8[i12 + 4 >> 0] | 0) << 16 | (HEAPU8[i12 + 3 >> 0] | 0) << 24 | (HEAPU8[i12 + 5 >> 0] | 0) << 8 | (HEAPU8[i12 + 6 >> 0] | 0);
   i9 = (HEAPU8[i12 + 8 >> 0] | 0) << 16 | (HEAPU8[i12 + 7 >> 0] | 0) << 24 | (HEAPU8[i12 + 9 >> 0] | 0) << 8 | (HEAPU8[i12 + 10 >> 0] | 0);
   i12 = i12 + 11 | 0;
   L13 : do if (!i2) i10 = 14; else {
    i2 = (HEAP32[i15 >> 2] | 0) + i2 | 0;
    i6 = i2 + 4 | 0;
    i2 = (HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0);
    i5 = 0;
    while (1) {
     while (1) {
      if (i5 >>> 0 >= i2 >>> 0) {
       i10 = 14;
       break L13;
      }
      i8 = (i2 + i5 | 0) >>> 1;
      i4 = i6 + (i8 << 2) + 3 | 0;
      i3 = i4 + -3 | 0;
      i3 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) << 16 | (HEAPU8[i3 + 2 >> 0] | 0);
      if (i3 >>> 0 > i14 >>> 0) i2 = i8; else break;
     }
     if (((HEAPU8[i4 >> 0] | 0) + i3 | 0) >>> 0 < i14 >>> 0) i5 = i8 + 1 | 0; else {
      i10 = 22;
      break;
     }
    }
   } while (0);
   L21 : do if ((i10 | 0) == 14) {
    i10 = 0;
    if (i9) {
     i8 = (HEAP32[i15 >> 2] | 0) + i9 | 0;
     i2 = (HEAPU8[i8 + 1 >> 0] | 0) << 16 | (HEAPU8[i8 >> 0] | 0) << 24 | (HEAPU8[i8 + 2 >> 0] | 0) << 8 | (HEAPU8[i8 + 3 >> 0] | 0);
     i8 = i8 + 4 | 0;
     if (i2) {
      i3 = 0;
      L24 : while (1) {
       while (1) {
        i6 = (i3 + i2 | 0) >>> 1;
        i4 = i8 + (i6 * 5 | 0) + 3 | 0;
        i5 = i4 + -3 | 0;
        i5 = (HEAPU8[i5 + 1 >> 0] | 0) << 8 | (HEAPU8[i5 >> 0] | 0) << 16 | (HEAPU8[i5 + 2 >> 0] | 0);
        if (i5 >>> 0 > i14 >>> 0) break;
        if (i5 >>> 0 >= i14 >>> 0) break L24;
        i3 = i6 + 1 | 0;
        if (i3 >>> 0 >= i2 >>> 0) break L21;
       }
       if (i3 >>> 0 < i6 >>> 0) i2 = i6; else break L21;
      }
      if ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0)) i10 = 22;
     }
    }
   } while (0);
   if ((i10 | 0) == 22) {
    HEAP32[i1 >> 2] = i11;
    i1 = i1 + 4 | 0;
   }
   i7 = i7 + -1 | 0;
  } while ((i7 | 0) != 0);
 }
 HEAP32[i1 >> 2] = 0;
 i15 = i13;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 28 | 0) + 1 | 0;
 if (i4 >>> 0 > 153391689) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 28 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 76695844 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 153391689;
 i5 = (i1 - i2 | 0) / 28 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 28 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 28 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 28 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 28 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 28 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 28 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 28 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 * 28 | 0) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 28;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -28 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -16 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN9InputAxisaSERKS_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i10 + 4 | 0;
 i1 = i9 + 4 | 0;
 i8 = (i10 | 0) == (i9 | 0);
 do if (!i8) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i9 + 8 >> 2] | 0 : i5 & 255;
  i3 = i6 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 8 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i5 - i4 | 0, i1, 0, i1, i5, i7);
   break;
  }
  if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  if (i5 | 0) _memmove(i1 | 0, i7 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i10 + 8 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 i7 = i10 + 24 | 0;
 i1 = i9 + 24 | 0;
 do if (!i8) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i9 + 28 >> 2] | 0 : i6 & 255;
  i3 = i7 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i10 + 32 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i10 + 28 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  } else {
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i10 + 28 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
  i1 = i10 + 40 | 0;
  i6 = i9 + 40 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i9 + 44 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i10 + 48 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i10 + 44 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i10 + 44 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i5 = i10 + 56 | 0;
 i1 = i9 + 56 | 0;
 i2 = i5;
 i3 = i1;
 i4 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP16[i5 + 48 >> 1] = HEAP16[i1 + 48 >> 1] | 0;
 return i10 | 0;
}

function __ZL16ClearFramebufferN6Camera9ClearModeE5RectTIfERK10ColorRGBAfbb(i1, i6, i12, i3, i13) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var d2 = 0.0, d4 = 0.0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i10 = i14;
 switch (i1 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 1:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 508 >> 0] | 0) != 0;
   i1 = i3 ? (i1 ? 7 : 6) : 7;
   break;
  }
 case 4:
  {
   STACKTOP = i14;
   return;
  }
 default:
  i1 = 7;
 }
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 if ((HEAP16[gb + 1110412 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110412 | 0, i11);
  i3 = gb + 1110412 | 0;
 } else i3 = 0;
 i6 = HEAP32[gb + 1110412 >> 2] | 0;
 i15 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 648 >> 2] | 0, i15 | 0, i6 | 0);
 i6 = __Z12GetGfxDevicev() | 0;
 f16 = Math_fround(f7 + Math_fround(.5));
 i15 = f16 >= Math_fround(0.0);
 f17 = Math_fround(f16 + Math_fround(-.99999994));
 i15 = ~~(i15 ? f16 : f17);
 HEAP32[i11 >> 2] = i15;
 f17 = Math_fround(f8 + Math_fround(.5));
 i10 = f17 >= Math_fround(0.0);
 f16 = Math_fround(f17 + Math_fround(-.99999994));
 i10 = ~~(i10 ? f17 : f16);
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i11 + 8 >> 2] = (~~Math_fround(Math_fround(f7 + f9) + Math_fround(.5)) >>> 0) - i15;
 HEAP32[i11 + 12 >> 2] = (~~Math_fround(Math_fround(f8 + f5) + Math_fround(.5)) >>> 0) - i10;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 160 >> 2] | 0, i6 | 0, i11 | 0);
 d4 = +_emscripten_get_now();
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i13 ? i1 & -7 : i1, i12, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
 __Z15gpu_time_samplev();
 i1 = __Z12GetGfxDevicev() | 0;
 d2 = +_emscripten_get_now();
 if (HEAP8[i1 + 3896 >> 0] | 0) {
  d2 = d2 * 1.0e6;
  i11 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
  d4 = d4 * 1.0e6;
  i11 = _i64Subtract(~~d2 >>> 0 | 0, i11 | 0, ~~d4 >>> 0 | 0, (+Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0) | 0;
  i13 = getTempRet0() | 0;
  i15 = i1 + 3768 | 0;
  i12 = i15;
  i12 = _i64Add(i11 | 0, i13 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
  i13 = getTempRet0() | 0;
  HEAP32[i15 >> 2] = i12;
  HEAP32[i15 + 4 >> 2] = i13;
 }
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0);
 i15 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i15 >> 2] | 0) + 652 >> 2] | 0, i15 | 0);
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i1, i16, i13, i15, i14) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0;
 i12 = i1 + 32 | 0;
 if (!(HEAP8[i12 >> 0] | 0)) {
  i15 = 0;
  i16 = i16 + 4096 | 0;
  HEAP32[i16 >> 2] = i15;
  return;
 }
 i4 = i1 + 44 | 0;
 i5 = i13 + 4 | 0;
 i6 = i13 + 8 | 0;
 i7 = i15 + 4 | 0;
 i8 = i15 + 8 | 0;
 i9 = i15 + 12 | 0;
 i10 = i15 + 16 | 0;
 i2 = i15 + 20 | 0;
 i3 = i15 + 24 | 0;
 i11 = 0;
 while (1) {
  i1 = HEAP32[i4 >> 2] | 0;
  f24 = Math_fround(HEAPF32[i13 >> 2]);
  f23 = Math_fround(HEAPF32[i5 >> 2]);
  f22 = Math_fround(HEAPF32[i6 >> 2]);
  f17 = Math_fround(HEAPF32[i14 >> 2]);
  f29 = Math_fround(HEAPF32[i15 >> 2]);
  f27 = Math_fround(HEAPF32[i7 >> 2]);
  f25 = Math_fround(HEAPF32[i8 >> 2]);
  f30 = Math_fround(HEAPF32[i9 >> 2]);
  f21 = Math_fround(HEAPF32[i10 >> 2]);
  f20 = Math_fround(HEAPF32[i2 >> 2]);
  f33 = Math_fround(HEAPF32[i3 >> 2]);
  f26 = Math_fround(HEAPF32[i1 + (i11 * 48 | 0) >> 2]);
  f28 = Math_fround(HEAPF32[i1 + (i11 * 48 | 0) + 4 >> 2]);
  f31 = Math_fround(HEAPF32[i1 + (i11 * 48 | 0) + 8 >> 2]);
  f32 = Math_fround(Math_fround(f30 * f30) + Math_fround(-.5));
  f19 = Math_fround(Math_fround(Math_fround(f29 * f26) + Math_fround(f27 * f28)) + Math_fround(f25 * f31));
  f21 = Math_fround(Math_fround(f21 + Math_fround(Math_fround(Math_fround(f29 * f19) + Math_fround(Math_fround(f32 * f26) + Math_fround(f30 * Math_fround(Math_fround(f27 * f31) - Math_fround(f25 * f28))))) * Math_fround(2.0))) - Math_fround(f24 * f17));
  f20 = Math_fround(Math_fround(f20 + Math_fround(Math_fround(Math_fround(f27 * f19) + Math_fround(Math_fround(f32 * f28) + Math_fround(f30 * Math_fround(Math_fround(f25 * f26) - Math_fround(f29 * f31))))) * Math_fround(2.0))) - Math_fround(f23 * f17));
  f19 = Math_fround(Math_fround(f33 + Math_fround(Math_fround(Math_fround(Math_fround(f32 * f31) + Math_fround(f30 * Math_fround(Math_fround(f29 * f28) - Math_fround(f27 * f26)))) + Math_fround(f25 * f19)) * Math_fround(2.0))) - Math_fround(f22 * f17));
  f17 = Math_fround(Math_fround(HEAPF32[i1 + (i11 * 48 | 0) + 44 >> 2]) - f17);
  i1 = i11 + 1 | 0;
  i18 = i16 + (i11 << 6) | 0;
  HEAPF32[i18 >> 2] = f24;
  HEAPF32[i18 + 4 >> 2] = f23;
  HEAPF32[i18 + 8 >> 2] = f22;
  HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
  i18 = i16 + (i11 << 6) + 16 | 0;
  HEAPF32[i18 >> 2] = f21;
  HEAPF32[i18 + 4 >> 2] = f20;
  HEAPF32[i18 + 8 >> 2] = f19;
  HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i16 + (i11 << 6) + 12 >> 2] = f17;
  HEAP32[i16 + (i11 << 6) + 48 >> 2] = -1;
  HEAP32[i16 + (i11 << 6) + 52 >> 2] = -1;
  if (i1 >>> 0 < 64 & i1 >>> 0 < (HEAPU8[i12 >> 0] | 0) >>> 0) i11 = i1; else break;
 }
 i18 = i16 + 4096 | 0;
 HEAP32[i18 >> 2] = i1;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15set_deleted_keyERKS9_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  i5 = i1 + 24 | 0;
  i3 = i1 + 12 | 0;
  i1 = i1 + 8 | 0;
  HEAP8[i1 >> 0] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i2);
  i3 = i2 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i3);
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i3 + 4 >> 2] = 0;
  i6 = i1 + 8 | 0;
  i5 = HEAP16[i6 >> 1] | 0;
  HEAP8[i3 + 8 >> 0] = i5;
  HEAP8[i3 + 9 >> 0] = (i5 & 65535) >>> 8;
  i5 = i1 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 12 | 0, i5);
  i7 = i1 + 24 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 24 | 0, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 36 | 0, i1 + 36 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 48 | 0, i1 + 48 | 0);
  HEAP32[i3 + 60 >> 2] = 0;
  i9 = i3 + 64 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i3 + 68 >> 2] = 0;
  HEAP32[i3 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  f8 = Math_fround((HEAP32[i9 >> 2] | 0) >>> 0);
  HEAP32[i3 + 76 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
  HEAP32[i3 + 72 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
  HEAP8[i3 + 80 >> 0] = 0;
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j(i3, i1, 0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_(i1, i3);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i3);
  i3 = i7;
  i1 = i6;
  HEAP8[i1 >> 0] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i2);
  i5 = i2 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i5);
  STACKTOP = i4;
  return;
 }
}

function __ZN7mecanim5human5Human8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 906072 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 906080 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 906091 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim4hand4HandEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 906106 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim4hand4HandEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 906117 | 0, 0);
 i7 = i1 + 56 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 912424 | 0, 0);
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 60;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906129 | 0, 0);
 i6 = i1 + 64 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 912439 | 0, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 68;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i5;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906139 | 0, 0);
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i1 + 72;
 __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi24EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906155 | 0, 0);
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i1 + 168;
 __ZN9BlobWrite8TransferI19StaticArrayTransferIfLi24EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906172 | 0, 0);
 HEAP32[i4 >> 2] = 24;
 HEAP32[i4 + 4 >> 2] = i1 + 264;
 __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi24EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906188 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 360 | 0, gb + 932253 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 364 | 0, gb + 906204 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 368 | 0, gb + 906215 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 372 | 0, gb + 906230 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 376 | 0, gb + 906246 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 380 | 0, gb + 906257 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 384 | 0, gb + 906270 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 388 | 0, gb + 906283 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 392 | 0, gb + 906297 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 393 | 0, gb + 906311 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 394 | 0, gb + 906326 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5joint16ConstraintHelper13halfAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE(i10, f8, f5, f9, f3, i11, i16) {
 i10 = i10 | 0;
 f8 = Math_fround(f8);
 f5 = Math_fround(f5);
 f9 = Math_fround(f9);
 f3 = Math_fround(f3);
 i11 = i11 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, f7 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 f12 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 i13 = f12 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 i15 = f14 > Math_fround(0.0);
 f7 = i13 | i15 ? Math_fround(0.0) : f3;
 if (Math_fround(f7 + f5) > f8) {
  f19 = Math_fround(-Math_fround(HEAPF32[i11 >> 2]));
  f18 = Math_fround(-Math_fround(HEAPF32[i11 + 4 >> 2]));
  f17 = Math_fround(-Math_fround(HEAPF32[i11 + 8 >> 2]));
  f3 = Math_fround(Math_fround(f5 - f8) * Math_fround(-2.0));
  i1 = i10 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i4 + 80;
  i1 = i4 + 78 | 0;
  HEAP16[i1 >> 1] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAPF32[i4 + 16 >> 2] = f19;
  HEAPF32[i4 + 20 >> 2] = f18;
  HEAPF32[i4 + 24 >> 2] = f17;
  HEAP32[i4 + 32 >> 2] = 0;
  HEAP32[i4 + 36 >> 2] = 0;
  HEAP32[i4 + 40 >> 2] = 0;
  HEAPF32[i4 + 48 >> 2] = f19;
  HEAPF32[i4 + 52 >> 2] = f18;
  HEAPF32[i4 + 56 >> 2] = f17;
  HEAPF32[i4 + 12 >> 2] = f3;
  i6 = i4 + 76 | 0;
  i2 = HEAPU16[i6 >> 1] | 0;
  if (i13 | i15) {
   HEAPF32[i4 + 64 >> 2] = f14;
   HEAPF32[i4 + 68 >> 2] = f12;
   i1 = i2 | 17;
  } else {
   HEAP16[i1 >> 1] = 1025;
   i20 = HEAP32[i16 >> 2] | 0;
   HEAP32[i4 + 64 >> 2] = i20;
   HEAP32[i4 + 68 >> 2] = HEAP32[i16 + 4 >> 2];
   i1 = f3 > Math_fround(0.0);
   i1 = i2 | (i1 ? 24 : 16);
   if ((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
  }
  HEAP16[i6 >> 1] = i1;
  HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 }
 if (!(Math_fround(f9 - f7) < f8)) return;
 f3 = Math_fround(Math_fround(f9 - f8) * Math_fround(2.0));
 i2 = i10 + 4 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6 + 80;
 i2 = i6 + 78 | 0;
 HEAP16[i2 >> 1] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i11 >> 2];
 i1 = i11 + 4 | 0;
 HEAP32[i6 + 20 >> 2] = HEAP32[i1 >> 2];
 i4 = i11 + 8 | 0;
 HEAP32[i6 + 24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i6 + 12 >> 2] = f3;
 i4 = i6 + 76 | 0;
 i1 = HEAPU16[i4 >> 1] | 0;
 if (i13 | i15) {
  HEAPF32[i6 + 64 >> 2] = f14;
  HEAPF32[i6 + 68 >> 2] = f12;
  i1 = i1 | 17;
 } else {
  HEAP16[i2 >> 1] = 1025;
  i20 = HEAP32[i16 >> 2] | 0;
  HEAP32[i6 + 64 >> 2] = i20;
  HEAP32[i6 + 68 >> 2] = HEAP32[i16 + 4 >> 2];
  i16 = f3 > Math_fround(0.0);
  i1 = i1 | (i16 ? 24 : 16);
  if ((HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) i1 = i1 | 4;
 }
 HEAP16[i4 >> 1] = i1;
 HEAPF32[i6 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E15insert_noresizeERKSC_(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19;
 __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_(i1, i16, i17);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i17 = HEAP32[i16 + 52 >> 2] | 0;
  i18 = i17 + ((HEAP32[i16 + 56 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i15 + 4 >> 2] = i17 + (i2 * 20 | 0);
  HEAP32[i15 + 8 >> 2] = i18;
  HEAP8[i15 + 12 >> 0] = 0;
  STACKTOP = i19;
  return;
 }
 i13 = i1 + 4 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 L5 : do if (!(HEAP8[i16 + 8 >> 0] | 0)) i18 = 14; else {
  i11 = i16 + 4 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  if (!i12) i18 = 14; else {
   i5 = i16 + 12 | 0;
   i2 = i16 + 52 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i1 + (i14 * 20 | 0) | 0;
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i8 = i4 << 24 >> 24 < 0;
   i4 = i4 & 255;
   i9 = i8 ? HEAP32[i16 + 16 >> 2] | 0 : i4;
   i10 = HEAP8[i3 + 11 >> 0] | 0;
   i6 = i10 << 24 >> 24 < 0;
   if ((i9 | 0) == ((i6 ? HEAP32[i1 + (i14 * 20 | 0) + 4 >> 2] | 0 : i10 & 255) | 0)) {
    i7 = HEAP32[i5 >> 2] | 0;
    i10 = i8 ? i7 : i5;
    i3 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
    i6 = (i9 | 0) == 0;
    L9 : do if (i8) {
     if (!i6) if (_memcmp(i10, i3, i9) | 0) {
      i18 = 14;
      break L5;
     }
    } else if (!i6) {
     if ((i7 & 255) << 24 >> 24 != (HEAP8[i3 >> 0] | 0)) {
      i18 = 14;
      break L5;
     }
     while (1) {
      i4 = i4 + -1 | 0;
      i5 = i5 + 1 | 0;
      if (!i4) break L9;
      i3 = i3 + 1 | 0;
      if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
       i18 = 14;
       break L5;
      }
     }
    } while (0);
    HEAP32[i11 >> 2] = i12 + -1;
   } else i18 = 14;
  }
 } while (0);
 if ((i18 | 0) == 14) {
  i1 = i16 + 60 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i16 + 52 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i16, i1 + (i14 * 20 | 0) | 0, i17);
 i18 = HEAP32[i2 >> 2] | 0;
 i17 = i18 + ((HEAP32[i13 >> 2] | 0) * 20 | 0) | 0;
 i18 = i18 + ((HEAP32[i16 + 56 >> 2] | 0) * 20 | 0) | 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i15 + 4 >> 2] = i17;
 HEAP32[i15 + 8 >> 2] = i18;
 HEAP8[i15 + 12 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __Z22AnimationEventFromMonoRK18MonoAnimationEventR14AnimationEvent(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 i4 = i10 + 4 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i8, HEAP32[i9 + 4 >> 2] | 0);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i7 = i4 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i10 + 12 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i6 >>> 0 > i3 >>> 0) {
  i7 = i2 ? HEAP32[i10 + 8 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i3, i6 - i3 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i10 + 8 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = i10 + 20 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i8, HEAP32[i9 + 8 >> 2] | 0);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i7 = i1 + 11 | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i10 + 28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  i7 = i3 ? HEAP32[i10 + 24 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i10 + 24 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i9 + 12 >> 2] | 0) | 0;
 if (!i1) {
  i7 = 0;
  i8 = i10 + 36 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = i9 + 16 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i7 = i10 + 40 | 0;
  HEAP32[i7 >> 2] = i8;
  i7 = i9 + 20 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = i10 + 44 | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i9 + 24 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i10 + 48 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i10 + 36 | 0;
 HEAP32[i8 >> 2] = i7;
 i8 = i9 + 16 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = i10 + 40 | 0;
 HEAP32[i7 >> 2] = i8;
 i7 = i9 + 20 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i10 + 44 | 0;
 HEAP32[i8 >> 2] = i7;
 i9 = i9 + 24 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 + 48 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE8__appendEj(i14, i2) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = i14 + 8 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i16 = i14 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i15 = i1 + 4 | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   i1 = (HEAP32[i16 >> 2] | 0) + 20 | 0;
   HEAP32[i16 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i14 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if (i5 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i3 = HEAP32[i15 >> 2] | 0;
  i4 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 i13 = (i3 - i4 | 0) / 20 | 0;
 i3 = i13 << 1;
 i3 = i13 >>> 0 < 107374182 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 214748364;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 20 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i4 = i6;
 i3 = i5 + (i3 * 20 | 0) | 0;
 i13 = i4;
 i1 = i6;
 do {
  i12 = i1 + 4 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i1 = i13 + 20 | 0;
  i13 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i12 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i12 | 0)) {
  i2 = i4;
  i7 = i12;
  i1 = i12;
 } else {
  i2 = i4;
  i5 = i6;
  do {
   i9 = i1;
   i1 = i1 + -20 | 0;
   i11 = i1;
   i7 = HEAP32[i11 + 4 >> 2] | 0;
   i6 = i5 + -20 | 0;
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i6 + 4 >> 2] = i7;
   i6 = i5 + -12 | 0;
   i7 = i9 + -12 | 0;
   HEAP32[i6 >> 2] = 0;
   i11 = i5 + -8 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i5 + -4 >> 2] = 0;
   i9 = i9 + -8 | 0;
   i4 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = (i4 | 0) / 24 | 0;
   if (i4 | 0) {
    if (i8 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
    i10 = __Znwj(i4) | 0;
    HEAP32[i11 >> 2] = i10;
    HEAP32[i6 >> 2] = i10;
    HEAP32[i5 + -4 >> 2] = i10 + (i8 * 24 | 0);
    i5 = HEAP32[i7 >> 2] | 0;
    i4 = (HEAP32[i9 >> 2] | 0) - i5 | 0;
    if ((i4 | 0) > 0) {
     _memcpy(i10 | 0, i5 | 0, i4 | 0) | 0;
     HEAP32[i11 >> 2] = i10 + (((i4 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i5 = i2 + -20 | 0;
   i2 = i5;
  } while ((i1 | 0) != (i12 | 0));
  i7 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i15 >> 2] = i3;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) do {
  i2 = HEAP32[i1 + -12 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + -8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i2);
  }
  i1 = i1 + -20 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if (!i7) return;
 __ZdlPv(i7);
 return;
}

function __ZN13InitialModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83624 + 8;
 i1 = i2 + 2508 | 0;
 if ((HEAP32[i2 + 2524 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 2512 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 2420 | 0;
 if ((HEAP32[i2 + 2436 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 2424 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 2244 | 0;
 if ((HEAP32[i2 + 2260 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 2248 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 2156 | 0;
 if ((HEAP32[i2 + 2172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 2160 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1980 | 0;
 if ((HEAP32[i2 + 1996 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1984 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1892 | 0;
 if ((HEAP32[i2 + 1908 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1896 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1716 | 0;
 if ((HEAP32[i2 + 1732 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1720 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1628 | 0;
 if ((HEAP32[i2 + 1644 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1632 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1452 | 0;
 if ((HEAP32[i2 + 1468 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1456 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1364 | 0;
 if ((HEAP32[i2 + 1380 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1368 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1188 | 0;
 if ((HEAP32[i2 + 1204 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1192 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1100 | 0;
 if ((HEAP32[i2 + 1116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 924 | 0;
 if ((HEAP32[i2 + 940 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 928 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 836 | 0;
 if ((HEAP32[i2 + 852 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 840 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = (i1 - i2 >> 5) + 1 | 0;
 if (i4 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = (HEAP32[i8 + 8 >> 2] | 0) - i2 | 0;
 i3 = i5 >> 4;
 i3 = i5 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 134217727;
 i5 = i1 - i2 >> 5;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 << 5) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 << 5) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 << 5);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 << 5) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 << 5) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 << 5) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 << 5) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i6 + (i5 << 5) + 16 | 0;
 i1 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 32;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -32 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -20 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE26getRelativeAngularVelocityEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 48 | 0;
 i10 = i13 + 36 | 0;
 i14 = i13 + 32 | 0;
 i5 = i13 + 28 | 0;
 i12 = i13;
 i15 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i15 >> 2] | 0) + 28 >> 2] | 0, i15 | 0, i14 | 0, i5 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i12, i1, HEAP32[i14 >> 2] | 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (!i1) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else if ((HEAP16[i1 + 4 >> 1] | 0) == 6) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 }
 f18 = Math_fround(f3 - f7);
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(f2 - f9);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i12 + 16 >> 2]));
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i12 + 20 >> 2]));
 f18 = Math_fround(f18 * Math_fround(2.0));
 f4 = Math_fround(f4 * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 - Math_fround(HEAPF32[i12 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f20 = Math_fround(HEAPF32[i12 >> 2]);
 f19 = Math_fround(f18 * f20);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f4 * f3));
 f7 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f2 * f7));
 f8 = Math_fround(Math_fround(f3 * f19) + Math_fround(Math_fround(f4 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f7) - Math_fround(f2 * f20)))));
 f9 = Math_fround(Math_fround(Math_fround(f2 * f17) - Math_fround(f16 * Math_fround(Math_fround(f4 * f20) - Math_fround(f18 * f3)))) + Math_fround(f7 * f19));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f2 * f3) - Math_fround(f4 * f7)))));
 HEAPF32[i11 + 4 >> 2] = f8;
 HEAPF32[i11 + 8 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS2_EE13stl_allocatorINS3_4pairIS2_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i11, i8, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i4 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 24 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (i6 - i2 | 0) / 24 | 0;
 if (i5 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj(i4, i5 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
 } else if (i5 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i5 * 24 | 0) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i5; else {
   i6 = i6 + (~(((i6 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i7 >> 2] = i6;
   i1 = i5;
  }
 } else i1 = i5;
 do if (i1 | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i11 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i6 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairI7Hash128iEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i6 | 0)) break L14;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI7Hash128iEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i6 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNK11AudioSource14GetSecPositionEv(i9) {
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i5 = i10;
 i2 = i9 + 456 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
  HEAP32[i6 >> 2] = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  if (!(__ZN20SoundChannelInstance13GetPositionMSEPj(i2, i6) | 0)) f1 = Math_fround(Math_fround((HEAP32[i6 >> 2] | 0) >>> 0) * Math_fround(.00100000005)); else f1 = Math_fround(0.0);
  STACKTOP = i10;
  return Math_fround(f1);
 }
 i7 = i9 + 436 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(0.0);
  STACKTOP = i10;
  return Math_fround(f1);
 }
 HEAP32[i5 >> 2] = i2;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i8 = 14; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i5);
   i3 = HEAP32[i6 >> 2] | 0;
   i11 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i3 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 14; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 16;
 }
 if ((i8 | 0) == 14) i8 = 16;
 if ((i8 | 0) == 16) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  f1 = Math_fround(0.0);
  STACKTOP = i10;
  return Math_fround(f1);
 }
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i8 = 22; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i5);
   i3 = HEAP32[i6 >> 2] | 0;
   i11 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i3 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 22; else {
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) i8 = 24;
  }
 }
 if ((i8 | 0) == 22) i8 = 24;
 if ((i8 | 0) == 24) i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i2 = __ZNK9AudioClip12GetFrequencyEv(i2) | 0;
 if (!i2) {
  f1 = Math_fround(0.0);
  STACKTOP = i10;
  return Math_fround(f1);
 }
 f1 = Math_fround(i2 >>> 0);
 f1 = Math_fround(Math_fround((HEAP32[i9 + 528 >> 2] | 0) >>> 0) / f1);
 STACKTOP = i10;
 return Math_fround(f1);
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS5_EENS7_9allocatorINS7_4pairIS5_S6_EEEEEEEvRT_17TransferMetaFlags(i11, i8, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i4 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = ((HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 24 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (i6 - i2 | 0) / 24 | 0;
 if (i5 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj(i4, i5 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
 } else if (i5 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i5 * 24 | 0) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i5; else {
   i6 = i6 + (~(((i6 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i7 >> 2] = i6;
   i1 = i5;
  }
 } else i1 = i5;
 do if (i1 | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i11 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i6 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairIPKN5Unity4TypeE7Hash128EEE8TransferI14SafeBinaryReadEEvRS7_RT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i6 | 0)) break L14;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIPKN5Unity4TypeE7Hash128EEE8TransferI14SafeBinaryReadEEvRS7_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i6 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13SplatDatabase16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 48 | 0;
 i16 = i18 + 8 | 0;
 i7 = i18;
 i13 = i18 + 32 | 0;
 i14 = i18 + 16 | 0;
 i8 = (HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 i8 = ((((i8 | 0) / 44 | 0) & 3 | 0) != 0 & 1) + ((i8 | 0) / 176 | 0) | 0;
 if (!i8) {
  STACKTOP = i18;
  return;
 }
 i9 = i1 + 12 | 0;
 i10 = i1 + 36 | 0;
 i11 = i1 + 16 | 0;
 i12 = i13 + 11 | 0;
 i6 = i1 + 50 | 0;
 i5 = 0;
 do {
  i4 = (HEAP32[i9 >> 2] | 0) + (i5 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (!i1) i17 = 13; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i15, i1, i7);
     i2 = HEAP32[i15 >> 2] | 0;
     i19 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i19 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i19 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 10; else if (HEAP32[i1 + 4 >> 2] | 0) break;
   }
   if ((i17 | 0) == 10) i17 = 0;
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) i17 = 13;
  } while (0);
  if ((i17 | 0) == 13) {
   i17 = 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   HEAP32[i14 + 12 >> 2] = 0;
   if (!i5) HEAPF32[i14 >> 2] = Math_fround(1.0);
   i2 = HEAP32[i9 >> 2] | 0;
   i4 = gb + 63520 | 0;
   i19 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i7;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = i19;
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   i1 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(0, i15) | 0;
   i19 = HEAP32[i10 >> 2] | 0;
   __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i1, i19, i19, 5, 1) | 0;
   __ZN7Texture11SetWrapModeEi(i1, 1);
   __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf(i1, i14);
   i19 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
   HEAP32[i16 >> 2] = (HEAP32[i11 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) >> 2;
   __Z6FormatPKcz(i13, gb + 934259 | 0, i16);
   mftCall_vii(i19 | 0, i1 | 0, ((HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i2 + (i5 << 2) >> 2] = i1;
   HEAP8[i6 >> 0] = 1;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i8 | 0));
 STACKTOP = i18;
 return;
}

function __ZN13AnimationClip10FloatCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = i3 + 16 | 0;
 i9 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, gb + 1034188 | 0, i9, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898367 | 0, i9, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i6 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i7, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898362 | 0, i9, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898384 | 0, i7, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898377 | 0, gb + 899338 | 0, i6, 0);
 i1 = i8 + 8 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13WheelCollider9SetRadiusEf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 48 | 0;
 i9 = i10;
 i4 = i5 + 72 | 0;
 if (Math_fround(HEAPF32[i4 >> 2]) != f1) HEAPF32[i4 >> 2] = f1;
 i3 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0;
 i8 = i5 + 148 | 0;
 if ((HEAP32[i8 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 52 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 56 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i5 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i7 + 4 >> 2]));
 i2 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 f1 = i2 ? f12 : f1;
 i2 = f1 < Math_fround(9.99999974e-06);
 f1 = i2 ? Math_fround(9.99999974e-06) : f1;
 __ZNK9Transform18GetWorldScaleLossyEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
 f12 = Math_fround(HEAPF32[i5 + 92 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 i5 = f11 < Math_fround(0.0);
 f13 = Math_fround(-f11);
 f11 = Math_fround(f12 * (i5 ? f13 : f11));
 i5 = i3 + 56 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + 8 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i6, HEAP32[i8 >> 2] | 0) | 0;
 i2 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i6, HEAP32[i8 >> 2] | 0) | 0;
 f11 = Math_fround(f1 - f11);
 f13 = Math_fround(f11 * Math_fround(HEAPF32[i3 >> 2]));
 f12 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i2 + 4 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i7 + 4 >> 2] = f12;
 HEAPF32[i7 + 8 >> 2] = f11;
 __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i6, HEAP32[i8 >> 2] | 0, i7);
 __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i6, HEAP32[i8 >> 2] | 0, i7);
 i2 = i9;
 i3 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i6, HEAP32[i8 >> 2] | 0) | 0;
 i4 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAPF32[i9 >> 2] = f1;
 HEAPF32[i9 + 12 >> 2] = Math_fround(f1 * Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i9 + 8 >> 2]) * Math_fround(.5))));
 __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i6, HEAP32[i8 >> 2] | 0, i9);
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 284 >> 2] | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim12statemachine16LeafInfoConstantEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = i5 * 12 | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 * 12 | 0) | 0)) _memset(i3 | 0, 0, i2 - (((i2 + -12 | 0) >>> 0) % 12 | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i4 >> 2] >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 903557 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN7mecanim12statemachine16LeafInfoConstantEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 903557 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN7mecanim12statemachine16LeafInfoConstantEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 HEAP32[i11 >> 2] = -1;
 i12 = i10 + 11 | 0;
 i3 = HEAP8[i12 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i5 = i4 ? i1 : i10;
 if ((HEAP8[i5 >> 0] | 0) != 35) {
  do if (!(__Z7StrICmpPKcS0_(i3 << 24 >> 24 < 0 ? i1 : i10, HEAP32[gb + 62276 >> 2] | 0) | 0)) i2 = 0; else {
   i1 = 0;
   while (1) {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= 22) {
     i6 = 0;
     i8 = 16;
     break;
    }
    if (!(__Z7StrICmpPKcS0_((HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, HEAP32[gb + 62276 + (i1 << 2) >> 2] | 0) | 0)) {
     i8 = 12;
     break;
    }
   }
   if ((i8 | 0) == 12) {
    i2 = i1 << 2;
    break;
   } else if ((i8 | 0) == 16) {
    STACKTOP = i13;
    return i6 | 0;
   }
  } while (0);
  HEAP32[i11 >> 2] = HEAP32[gb + 62364 + i2 >> 2];
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i7 = i10 + 4 | 0;
 i2 = i4 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
 if ((i2 + -2 | 0) >>> 0 < 8) i1 = 1; else {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 L15 : do {
  i3 = HEAP8[i5 + i1 >> 0] | 0;
  if ((i3 + -48 & 255) >= 10) switch (i3 << 24 >> 24) {
  case 65:
  case 66:
  case 67:
  case 68:
  case 69:
  case 70:
  case 97:
  case 98:
  case 99:
  case 100:
  case 101:
  case 102:
   break;
  default:
   {
    i6 = 0;
    i8 = 16;
    break L15;
   }
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((i8 | 0) == 16) {
  STACKTOP = i13;
  return i6 | 0;
 }
 switch (i2 | 0) {
 case 5:
 case 4:
  {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1075169 | 0, 1);
   i1 = HEAP8[i12 >> 0] | 0;
   if ((i1 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i1 & 255) >>> 0 > 1) {
    i2 = 1;
    do {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i9, HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10) + i2 >> 0] | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i9, HEAP8[((HEAP8[i12 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) + i2 >> 0] | 0);
     i2 = i2 + 1 | 0;
     i1 = HEAP8[i12 >> 0] | 0;
    } while (i2 >>> 0 < (i1 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i1 & 255) >>> 0);
   }
   i12 = HEAP8[i9 + 11 >> 0] | 0;
   i10 = i12 << 24 >> 24 < 0;
   __Z16HexStringToBytesPKcjPv(i10 ? (HEAP32[i9 >> 2] | 0) + 1 | 0 : i9 + 1 | 0, (i10 ? HEAP32[i9 + 4 >> 2] | 0 : i12 & 255) >>> 1, i11);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 9:
 case 7:
  {
   __Z16HexStringToBytesPKcjPv(i5 + 1 | 0, i2 >>> 1, i11);
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 default:
  {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 return 0;
}

function __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 688 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i13 + 656 | 0;
 i10 = i13 + 128 | 0;
 i6 = i13 + 64 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEclILj681ES3_KNS_30PxVehicleDriveTankControlModel4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i1 + 96 | 0, i12);
 i7 = HEAP32[i1 + 132 >> 2] | 0;
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i8;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveSimDataEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 3 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 3 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN29RenderNodeQueuePrepareContextC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i4 = i6;
 i2 = i5 + 1304 | 0;
 i3 = i5 + 24 | 0;
 do {
  __ZN22PerThreadPageAllocatorC2Ev(i3 + 16 | 0);
  i7 = i3 + 32 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  HEAP32[i7 + 20 >> 2] = 0;
  i7 = gb + 64024 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i3 + 56 >> 2] = 0;
  HEAP32[i3 + 68 >> 2] = 0;
  HEAP32[i3 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i4);
  i9 = i1;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i3 + 60 | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  i3 = i3 + 80 | 0;
 } while ((i3 | 0) != (i2 | 0));
 HEAP32[i5 + 1304 >> 2] = 0;
 HEAP32[i5 + 1308 >> 2] = 0;
 i1 = HEAP32[gb + 1112412 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1508 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 16 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1512 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 32 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1516 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1520 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 64 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1524 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 80 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1528 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 96 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1532 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 112 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1536 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 128 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1540 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 144 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1544 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 160 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1548 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 176 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1552 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 192 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1556 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 208 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1560 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 224 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_i(i1 | 0) | 0;
 HEAP32[i5 + 1564 >> 2] = i1;
 i1 = HEAP32[gb + 1112412 + 240 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  i9 = i5 + 1568 | 0;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i6;
  return;
 }
 i8 = mftCall_i(i1 | 0) | 0;
 i9 = i5 + 1568 | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i6;
 return;
}

function __ZN8LODGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i1 = i9 + 32 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i10 + 24 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i5 = i9 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 i1 = i9 + 52 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i3 = i9 + 56 | 0;
 i7 = i9 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 28 | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i11 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferIN8LODGroup3LODEEEvRT_PKc17TransferMetaFlags(i10, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 72 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 12 | 0, 4) | 0;
  i2 = i4 + (i1 * 12 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 10;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899043 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L16 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN7mecanim13ValueConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L16;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899043 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim13ValueConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 96 | 0;
 i4 = i8 + 32 | 0;
 i5 = i8;
 i1 = __ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i6, i1) | 0;
 if (!i1) {
  i1 = __Z14GetDynamicsSDKv() | 0;
  i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0;
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
  i1 = mftCall_iii(i5 | 0, i1 | 0, i3 | 0) | 0;
  if (i1 | 0) {
   HEAP32[i1 + 8 >> 2] = 0;
   __ZN8Collider19CreateShapeInternalERN5physx10PxGeometryEPNS0_12PxRigidActorEib(i6, i7, i1, 0, 0);
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 172 >> 2] | 0, i6 | 0);
   i7 = __Z16GetDynamicsScenev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0, i7 | 0, i1 | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + 60 >> 2] | 0);
   STACKTOP = i8;
   return;
  }
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 826914 | 0, 0, gb + 733088 | 0, 428, 1, i1, 0, 0);
  STACKTOP = i8;
  return;
 }
 __ZN9Rigidbody6CreateEb(i1, 1);
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i2) {
  if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 826914 | 0, 0, gb + 733088 | 0, 403, 1, i1, 0, 0);
  STACKTOP = i8;
  return;
 } else {
  i9 = i1 + 92 | 0;
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0, i2 | 0, 4, ((HEAP32[i9 >> 2] | 0) + -1 | 0) >>> 0 < 2 | 0);
  i9 = HEAP32[i9 >> 2] | 0;
  __ZN8Collider19CreateShapeInternalERN5physx10PxGeometryEPNS0_12PxRigidActorEib(i6, i7, i2, i9, (__ZNK9Rigidbody19GetDetectCollisionsEv(i1) | 0) ^ 1);
  if (__ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i4) | 0) {
   i9 = HEAP32[i6 + 36 >> 2] | 0;
   i7 = HEAP32[(HEAP32[i9 >> 2] | 0) + 68 >> 2] | 0;
   __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i4, i3);
   i10 = HEAP32[i4 + 48 >> 2] | 0;
   i2 = HEAP32[i4 + 52 >> 2] | 0;
   i6 = HEAP32[i4 + 56 >> 2] | 0;
   i12 = HEAP32[i3 + 4 >> 2] | 0;
   i11 = HEAP32[i3 + 8 >> 2] | 0;
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = i12;
   HEAP32[i5 + 8 >> 2] = i11;
   HEAP32[i5 + 12 >> 2] = i4;
   HEAP32[i5 + 16 >> 2] = i10;
   HEAP32[i5 + 20 >> 2] = i2;
   HEAP32[i5 + 24 >> 2] = i6;
   mftCall_vii(i7 | 0, i9 | 0, i5 | 0);
  }
  __ZN9Rigidbody22UpdateMassDistributionEv(i1);
  __ZN9Rigidbody27InvalidateAssociatedVehicleEv(i1);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx32PxVehicleComputeTireForceDefaultEPKvffffffffffffRfS2_S2_S2_(i13, f9, f4, f1, f5, f3, f17, f2, f7, f6, f10, f8, f12, i18, i16, i15, i14) {
 i13 = i13 | 0;
 f9 = Math_fround(f9);
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 f5 = Math_fround(f5);
 f3 = Math_fround(f3);
 f17 = Math_fround(f17);
 f2 = Math_fround(f2);
 f7 = Math_fround(f7);
 f6 = Math_fround(f6);
 f10 = Math_fround(f10);
 f8 = Math_fround(f8);
 f12 = Math_fround(f12);
 i18 = i18 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var f11 = f0, i19 = 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 f2 = Math_fround(Math_abs(Math_fround(f1)));
 f3 = Math_fround(HEAPF32[gb + 1458440 >> 2]);
 f2 = f2 >= f3 ? f1 : Math_fround(0.0);
 i19 = Math_fround(Math_abs(Math_fround(f4))) >= f3;
 f11 = i19 ? f4 : Math_fround(0.0);
 i19 = Math_fround(Math_abs(Math_fround(f5))) >= f3;
 f1 = i19 ? f5 : Math_fround(0.0);
 if (f2 == Math_fround(0.0) & f11 == Math_fround(0.0) & f1 == Math_fround(0.0)) return;
 f4 = Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) * f7);
 f6 = Math_fround(f6 * Math_fround(3.0));
 f6 = Math_fround(f6 / Math_fround(HEAPF32[i13 >> 2]));
 f6 = Math_fround(Math_fround(f6 - Math_fround(f6 * Math_fround(f6 * Math_fround(.333330005)))) + Math_fround(f6 * Math_fround(f6 * Math_fround(f6 * Math_fround(.0370370001)))));
 i19 = f6 > Math_fround(1.0);
 f6 = Math_fround(f4 * (i19 ? Math_fround(1.0) : f6));
 f4 = Math_fround(Math_fround(HEAPF32[i13 + 8 >> 2]) * f8);
 f5 = Math_fround(+Math_tan(+Math_fround(f2 - Math_fround(Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i13 + 12 >> 2]) * f8)) / f6))));
 f2 = Math_fround(f9 * f10);
 f1 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * Math_fround(f4 * Math_fround(f11 * f4))) + Math_fround(f5 * Math_fround(f6 * Math_fround(f5 * f6)))))) / f2);
 f10 = Math_fround(f1 * Math_fround(f1 * Math_fround(.333330005)));
 f4 = Math_fround(f1 * Math_fround(f1 * Math_fround(f1 * Math_fround(.0370370001))));
 f3 = Math_fround(Math_fround(f1 - f10) + f4);
 i19 = f3 > Math_fround(1.0);
 f3 = i19 ? Math_fround(1.0) : f3;
 f4 = Math_fround(Math_fround(Math_fround(f1 - Math_fround(f1 * f1)) + Math_fround(f1 * f10)) - Math_fround(f1 * f4));
 if (!(f1 <= Math_fround(6.28318548))) f1 = Math_fround(1.0); else {
  f12 = Math_fround(f6 * Math_fround(Math_fround(HEAPF32[i13 + 44 >> 2]) * f12));
  f1 = Math_fround(Math_fround(Math_fround(f12 + Math_fround(1.0)) - Math_fround(Math_fround(+Math_cos(+Math_fround(f1 * Math_fround(.5)))) * Math_fround(Math_fround(1.0) - f12))) * Math_fround(.5));
 }
 f9 = Math_fround(f5 * f1);
 f12 = Math_fround(f2 / Math_fround(Math_sqrt(Math_fround(Math_fround(f11 * f11) + Math_fround(f5 * Math_fround(f1 * f9))))));
 f10 = Math_fround(Math_fround(f11 * f3) * f12);
 f11 = Math_fround(-Math_fround(Math_fround(f3 * f9) * f12));
 f12 = Math_fround(Math_fround(f4 * f9) * f12);
 HEAPF32[i18 >> 2] = Math_fround(-Math_fround(f10 * f17));
 HEAPF32[i16 >> 2] = f10;
 HEAPF32[i15 >> 2] = f11;
 HEAPF32[i14 >> 2] = f12;
 return;
}

function __ZN10DebugStats9SerializeER13dynamic_arrayIiLj4EE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i11 + 12 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i2 = i5 + 1 | 0;
 i13 = i11 + 16 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i11 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i12 >> 2] = i2;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i10 >> 2];
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i7 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i11 >> 2] = i8;
   i9 = i8;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i11 >> 2] = i8;
   i9 = i8;
   break;
  } else {
   i9 = i4;
   i8 = i4;
  }
 } else {
  i9 = i4;
  i8 = i4;
 } while (0);
 HEAP32[i12 >> 2] = i7;
 HEAP32[i9 + (i6 << 2) >> 2] = HEAP32[i5 >> 2];
 i2 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i5 & 2147483647;
 if (i4 >>> 0 <= i6 >>> 0) {
  i13 = i9;
  HEAP32[i12 >> 2] = i4;
  i13 = i13 + (i3 << 2) | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 }
 i1 = i5 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i6 >>> 0 >= i1 >>> 0) {
  i13 = i9;
  HEAP32[i12 >> 2] = i4;
  i13 = i13 + (i3 << 2) | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 }
 if ((i5 | 0) > -1) {
  HEAP32[i13 >> 2] = i1;
  i13 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i8, i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i12 >> 2] = i4;
  i13 = i13 + (i3 << 2) | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i11 >> 2] = i10;
  i13 = i10;
  HEAP32[i12 >> 2] = i4;
  i13 = i13 + (i3 << 2) | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 }
}

function __ZN12CubemapArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 i1 = i7 + 80 | 0;
 i10 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i8 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i5 = i7 + 88 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i5 = i7 + 96 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
 __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 32 | 0, i8);
 i1 = i7 + 60 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 105 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i8, i9, gb + 411165 | 0, 1);
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i7 + 92 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i8, i9, i10, 0);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i8, i9, gb + 411165 | 0, 1);
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i7 + 92 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i8, i9, i10, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13set_empty_keyERKSA_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15;
 HEAP8[i6 + 9 >> 0] = 1;
 i14 = i6 + 48 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 52 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6 + 72 | 0);
 HEAP32[i14 >> 2] = 0;
 i11 = i6 + 68 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i6 + 72 | 0;
 i9 = i4 + 24 | 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i10;
 i13 = i6 + 52 | 0;
 HEAP8[i13 >> 0] = 0;
 do if ((i14 | 0) != (i4 | 0)) {
  i2 = HEAP32[i4 >> 2] | 0;
  i10 = (i2 | 0) == 0;
  i2 = i10 ? i4 + 4 | 0 : i2;
  i3 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = i6 + 52 | 0;
  if (!((HEAP32[i4 + 4 >> 2] | 0) != 0 | i10)) {
   HEAP32[i14 >> 2] = i2;
   HEAP32[i11 >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i3 >>> 0 > 15) {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i12, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i14 >> 2] = i10;
   HEAP32[i1 >> 2] = i3;
   i1 = (i10 | 0) == 0 ? i13 : i10;
  } else i1 = i13;
  _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i11 >> 2] = i3;
 } while (0);
 i10 = i6 + 80 | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 + 32 >> 2];
 i9 = i6 + 88 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) * 36 | 0;
 i8 = HEAP32[i6 + 108 >> 2] | 0;
 HEAP32[i5 >> 2] = 57;
 HEAP32[i5 + 4 >> 2] = i8;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i6 + 84 >> 2] = i1;
 i9 = i1 + ((HEAP32[i9 >> 2] | 0) * 36 | 0) | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i15;
  return;
 }
 i8 = i6 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i5 = i1 + 20 | 0;
  HEAP32[i5 >> 2] = 0;
  i3 = i1 + 24 | 0;
  i6 = i12;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i2 = i1 + 4 | 0;
  HEAP8[i2 >> 0] = 0;
  do if ((i1 | 0) != (i14 | 0)) {
   i6 = HEAP32[i14 >> 2] | 0;
   i16 = (i6 | 0) == 0;
   i6 = i16 ? i13 : i6;
   i7 = HEAP32[i11 >> 2] | 0;
   i4 = i1 + 4 | 0;
   if (!((HEAP32[i8 >> 2] | 0) != 0 | i16)) {
    HEAP32[i1 >> 2] = i6;
    HEAP32[i5 >> 2] = i7;
    HEAP32[i4 >> 2] = 0;
    break;
   }
   if (i7 >>> 0 > 15) {
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
    HEAP32[i1 >> 2] = i16;
    HEAP32[i4 >> 2] = i7;
    i2 = (i16 | 0) == 0 ? i2 : i16;
   }
   _memcpy(i2 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i2 + i7 >> 0] = 0;
   HEAP32[i5 >> 2] = i7;
  } while (0);
  HEAP32[i1 + 32 >> 2] = HEAP32[i10 >> 2];
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i15;
 return;
}

function __ZN5Unity10HingeJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 158 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 116 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 120 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 124 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 157 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 128 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 156 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i8 = i6 + 96 | 0;
  __ZN11JointLimits8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i8 = i6 + 96 | 0;
  __ZN11JointLimits8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __ZN13RenderManager15BatchModeUpdateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 __ZN13RendererScene22RecalculateDirtyBoundsEv(HEAP32[gb + 1112704 >> 2] | 0);
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i6 = i7 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 13;
    }
   }
   if ((i10 | 0) == 11) i10 = 13;
   if ((i10 | 0) == 13) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i6 = i7 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 25;
    }
   }
   if ((i10 | 0) == 23) i10 = 25;
   if ((i10 | 0) == 25) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __ZN6Camera26ClearIntermediateRenderersEj(i1, 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZN10DynamicVBO8GetChunkEjjj16GfxPrimitiveTypeP21DynamicVBOChunkHandle(i9, i3, i4, i8, i7, i10) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = i10 + 8 | 0;
 i2 = (HEAP8[i9 + 25 >> 0] | 0) == 0;
 do if ((HEAP32[i5 >> 2] | 0) == -1) if (i2) i6 = 7; else i6 = 6; else {
  i1 = HEAP32[i10 + 12 >> 2] & 2147483647;
  if (i2) if ((i1 | 0) == (HEAP32[gb + 1161244 >> 2] | 0)) break; else {
   i6 = 7;
   break;
  } else if ((i1 | 0) == (HEAP32[gb + 1161256 >> 2] | 0)) break; else {
   i6 = 6;
   break;
  }
 } while (0);
 if ((i6 | 0) == 6) {
  HEAP32[gb + 1161252 >> 2] = (HEAP32[gb + 1161252 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1161256 >> 2] | -2147483648;
  i2 = gb + 1161252 | 0;
  i6 = 8;
 } else if ((i6 | 0) == 7) {
  HEAP32[gb + 1161248 >> 2] = (HEAP32[gb + 1161248 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1161244 >> 2] & 2147483647;
  i2 = gb + 1161248 | 0;
  i6 = 8;
 }
 if ((i6 | 0) == 8) {
  i6 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i10 + 12 >> 2] = i1;
 }
 i6 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, i10 | 0, 1) | 0;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 16 >> 2] = i7;
 HEAP8[i6 >> 0] = (i8 | 0) != 0 & 1;
 HEAP32[i6 + 8 >> 2] = i4;
 HEAP32[i6 + 12 >> 2] = i8;
 i6 = Math_imul(i4, i3) | 0;
 i2 = i8 << 1;
 if ((i7 | 0) == 2) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 480 >> 0] | 0)) {
  i1 = i9 + 4 | 0;
  i3 = i9 + 16 | 0;
  HEAP32[i3 >> 2] = i8;
  i4 = i9 + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i8;
   i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 2, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i1 >> 2] = i7;
   i1 = i7;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 2, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i1 >> 2] = i7;
   i1 = i7;
   break;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP32[i10 + 4 >> 2] = i1;
  i2 = 0;
  i1 = (i8 | 0) == 0 | (i1 | 0) != 0;
 } else i1 = 1; else i1 = 1;
 if ((i6 | 0) != 0 & i1) {
  i1 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i6 | 0, i10 | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  i1 = (i1 | 0) != 0;
 }
 do if ((i2 | 0) != 0 & i1) {
  i8 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, i2 | 0, i10 | 0) | 0;
  i1 = i10 + 4 | 0;
  HEAP32[i1 >> 2] = i8;
  if (i8) {
   i10 = 1;
   i9 = i9 + 24 | 0;
   i8 = i10 & 1;
   HEAP8[i9 >> 0] = i8;
   return i10 | 0;
  }
 } else if (i1) {
  i10 = 1;
  i9 = i9 + 24 | 0;
  i8 = i10 & 1;
  HEAP8[i9 >> 0] = i8;
  return i10 | 0;
 } else {
  i1 = i10 + 4 | 0;
  break;
 } while (0);
 mftCall_viiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0, i10 | 0, 0, 0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i10 = 0;
 i9 = i9 + 24 | 0;
 i8 = i10 & 1;
 HEAP8[i9 >> 0] = i8;
 return i10 | 0;
}

function __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 24 | 0;
 i10 = i12;
 i1 = i9 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i8 = i9 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (((i4 - i2 | 0) / 40 | 0) >>> 0 >= i3 >>> 0) {
  do {
   i1 = i2 + 20 | 0;
   i4 = i2;
   i6 = i4 + 40 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   HEAP32[i2 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = (HEAP32[i8 >> 2] | 0) + 40 | 0;
   HEAP32[i8 >> 2] = i2;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i7 = i9 + 12 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = ((i2 - i5 | 0) / 40 | 0) + i3 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i8 = (i4 - i5 | 0) / 40 | 0;
 i4 = i8 << 1;
 i4 = i8 >>> 0 < 1073741823 ? (i4 >>> 0 < i6 >>> 0 ? i6 : i4) : 2147483647;
 HEAP32[i10 + 12 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = i7;
 if (!i4) i1 = 0; else {
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i11 >> 2] = 54;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 40 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i10 >> 2] = i1;
 i2 = i1 + (((i2 - i5 | 0) / 40 | 0) * 40 | 0) | 0;
 i7 = i10 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i10 + 12 >> 2] = i1 + (i4 * 40 | 0);
 do {
  i1 = i2 + 20 | 0;
  i4 = i2;
  i6 = i4 + 40 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i6 | 0));
  HEAP32[i2 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = i2 + 40 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i9, i10);
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i11 + 4 | 0;
  do {
   i2 = i1 + -40 | 0;
   HEAP32[i7 >> 2] = i2;
   i3 = i1 + -20 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i11 >> 2] = 54;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i11);
    i1 = HEAP32[i7 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i11 >> 2] = 54;
  HEAP32[i11 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 STACKTOP = i12;
 return;
}

function __ZN19TransportJavaScript10OnResponseEPviS0_jPc(i4, i5, i2, i6, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 if ((HEAP32[gb + 187800 >> 2] | 0) <= (i5 | 0) ? (HEAP32[gb + 187812 >> 2] | 0) >= (i5 | 0) : 0) switch (i5 | 0) {
 case 304:
 case 306:
  {
   i3 = 3;
   break;
  }
 default:
  i1 = 0;
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i6 | 0);
   mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i6 | 0) | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
  }
  if (i2 | 0) _free(i2);
  i1 = (i5 | 0) == 0 ? 10 : 0;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i4 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i9, _JS_WebRequest_GetResponseHeaders(HEAP32[i12 >> 2] | 0, 0, 0) | 0, 0);
 i3 = i9 + 11 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i11 = i2 << 24 >> 24 < 0;
 _JS_WebRequest_GetResponseHeaders(HEAP32[i12 >> 2] | 0, (i11 ? HEAP32[i9 >> 2] | 0 : i9) | 0, (i11 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
 HEAP32[i4 + 24 >> 2] = i6;
 HEAP32[i4 + 20 >> 2] = i6;
 i6 = i4 + 4 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 __ZN12HeaderHelper13SetAllHeadersEPKcj((HEAP32[i6 >> 2] | 0) + 8 | 0, i2 ? HEAP32[i9 >> 2] | 0 : i9, i2 ? HEAP32[i9 + 4 >> 2] | 0 : i3 & 255) | 0;
 __ZN12StatusHelper13SetStatusCodeEl(HEAP32[i6 >> 2] | 0, i5) | 0;
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 i5 = i6 + 104 | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  i1 = __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE11PostRequestEv(i6) | 0;
  HEAP32[i5 >> 2] = i1;
 }
 i2 = i6 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3) {
  _JS_WebRequest_Release(i3 | 0);
  HEAP32[i2 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 68 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 1 | 0) == 1) mftCall_vi(HEAP32[i3 + 24 >> 2] | 0, i2 | 0); else mftCall_vi(HEAP32[i3 + 48 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 1 | 0) == 1) {
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
  }
 }
 HEAP32[i6 + 108 >> 2] = (i1 | 1 | 0) == 1 ? 3 : 4;
 i1 = i6 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z19MainThreadSchedulerPFvPvES_10JobGroupID(fb + 3924 | 0, i2, i7);
 HEAP32[i1 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7, i6);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i5, i6 + 1 | 0, i7 + 24 | 0, gb + 115200 | 0, i2);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 i1 = i7 + 100 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 116 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 132 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 148 | 0, i6 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 164 | 0, i6 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 192 | 0, i6 + 12 | 0);
 STACKTOP = i8;
 return i6 + 15 | 0;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 36 | 0;
 i7 = i10 + 24 | 0;
 i4 = i10 + 12 | 0;
 i5 = i10;
 i2 = i3 + 176 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 180 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
 __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i8, i1, i2, 0);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255) | 0)) i9 = 16; else {
  HEAP32[i7 >> 2] = 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  do if (__ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE(i8, 0, i7) | 0) {
   i2 = __ZN14CachingManager17GenerateTimeStampEv() | 0;
   __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl(i8, i7, i2) | 0;
   __ZN5Cache15UpdateTimestampERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEl(i1, i8, i2);
   i2 = HEAP32[gb + 27728 >> 2] | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
   __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i4, i8, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (!(__ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i3, i4, 0, 0) | 0)) {
    __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i8);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3 + 64 | 0, i8) | 0;
    HEAP8[i3 + 76 >> 0] = 1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
    i3 = 1;
    break;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
    i3 = 0;
    break;
   }
  } else i3 = 0; while (0);
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i5 = i2 + -12 | 0;
     HEAP32[i6 >> 2] = i5;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
     i2 = HEAP32[i6 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  if (!i3) i9 = 16; else i1 = 1;
 }
 if ((i9 | 0) == 16) {
  __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8) | 0;
  i1 = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram12UAVParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = i5 + 16 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471202 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899057 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471214 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN13UnityProfiler8LogFrameEP17ProfilerFrameData(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i9 + 40 | 0;
 i6 = i9 + 28 | 0;
 i7 = i9 + 24 | 0;
 i1 = HEAP8[i3 + 88 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 92 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround(Math_fround(1.0e6) / Math_fround(HEAPF32[(HEAP32[HEAP32[i4 + 1124 >> 2] >> 2] | 0) + 8 >> 2]));
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 do if (f2 < Math_fround(10.0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, gb + 585401 | 0) | 0; else {
  if (f2 < Math_fround(20.0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, gb + 585410 | 0) | 0;
   break;
  }
  if (f2 < Math_fround(25.0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, gb + 585414 | 0) | 0;
   break;
  }
  if (f2 < Math_fround(40.0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, gb + 585419 | 0) | 0;
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, gb + 585424 | 0) | 0;
   break;
  }
 } while (0);
 i1 = i3 + 100 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i10;
 i1 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 HEAP32[i8 >> 2] = i10;
 HEAPF64[i8 + 8 >> 3] = +f2;
 HEAP32[i8 + 16 >> 2] = i1;
 __Z6FormatPKcz(i6, gb + 585434 | 0, i8);
 i1 = HEAP8[i6 + 11 >> 0] | 0;
 i10 = i1 << 24 >> 24 < 0;
 __ZN4File5WriteEPKvj(HEAP32[i3 + 108 >> 2] | 0, i10 ? HEAP32[i6 >> 2] | 0 : i6, i10 ? HEAP32[i6 + 4 >> 2] | 0 : i1 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!(HEAP8[i3 + 104 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 i11 = i5 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i10 = i5 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i14 = i8;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i1;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 __ZN13UnityProfiler18SerializeFrameDataER17ProfilerFrameDataR13dynamic_arrayIiLj4EE(i4, i5);
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2] << 2;
 HEAP32[i6 >> 2] = 1;
 i3 = i3 + 112 | 0;
 __ZN4File5WriteEPKvj(HEAP32[i3 >> 2] | 0, i6, 4) | 0;
 __ZN4File5WriteEPKvj(HEAP32[i3 >> 2] | 0, gb + 73676 | 0, 4) | 0;
 __ZN4File5WriteEPKvj(HEAP32[i3 >> 2] | 0, i8, 4) | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 + 1128 >> 2];
 __ZN4File5WriteEPKvj(HEAP32[i3 >> 2] | 0, i7, 4) | 0;
 __ZN4File5WriteEPKvj(HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = 0;
 }
 STACKTOP = i9;
 return;
}

function __ZN12MeshCollider11CreateShapeEPvPK9RigidbodyRK8Vector3f(i6, i2, i3, i4) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 i7 = i6 + 96 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i9 = i6 + 100 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
 }
 if (HEAP8[i6 + 60 >> 0] | 0) {
  HEAP32[i5 >> 2] = 4;
  HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 28 >> 2] = Math_fround(1.0);
  HEAP32[i5 + 32 >> 2] = i2;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 8 >> 2] = i7;
  HEAP32[i5 + 12 >> 2] = i9;
  __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i6, i5, i3);
  STACKTOP = i8;
  return;
 }
 i1 = __ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i6, i3) | 0;
 if (i1 | 0) {
  __ZN9Rigidbody16AddNonConvexMeshER8ListNodeI12MeshColliderE(i1, i6 + 84 | 0);
  if (!(__ZNK9Rigidbody14GetIsKinematicEv(i1) | 0)) {
   HEAP32[i6 + 108 >> 2] = gb + 736675;
   HEAP32[i6 + 112 >> 2] = i6;
   HEAP8[i6 + 116 >> 0] = 0;
   i2 = (__Z17GetPhysicsManagerv() | 0) + 716 | 0;
   if ((i7 | 0) == (i2 | 0)) {
    STACKTOP = i8;
    return;
   }
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i1 = i6 + 100 | 0; else {
    i9 = i6 + 100 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = i9;
   }
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i7;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
   STACKTOP = i8;
   return;
  }
 }
 if (!(HEAP8[i6 + 40 >> 0] | 0)) {
  HEAP32[i5 >> 2] = 5;
  HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 28 >> 2] = Math_fround(1.0);
  i7 = i5 + 32 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i5 + 36 >> 2] = i2;
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = HEAP32[i4 + 8 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 8 >> 2] = i7;
  HEAP32[i5 + 12 >> 2] = i9;
  __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i6, i5, i3);
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 + 108 >> 2] = gb + 736871;
 HEAP32[i6 + 112 >> 2] = i6;
 HEAP8[i6 + 116 >> 0] = 0;
 i2 = (__Z17GetPhysicsManagerv() | 0) + 716 | 0;
 if ((i7 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i1 = i6 + 100 | 0; else {
  i9 = i6 + 100 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = i9;
 }
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __Z19RecalculateAutoKeyTIfEvR17AnimationCurveTplIT_Eif(i9, i10, f5) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, i11 = 0, f12 = f0;
 i1 = HEAP32[i9 + 68 >> 2] | 0;
 if ((i1 | 0) < 2) return;
 do if (!i10) {
  i11 = HEAP32[i9 + 56 >> 2] | 0;
  HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 } else {
  i11 = HEAP32[i9 + 56 >> 2] | 0;
  if ((i1 + -1 | 0) == (i10 | 0)) {
   HEAPF32[i11 + (i10 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i11 + (i10 << 4) + 8 >> 2] = Math_fround(0.0);
   break;
  }
  f2 = Math_fround(HEAPF32[i11 + (i10 << 4) >> 2]);
  i1 = i10 + -1 | 0;
  f3 = Math_fround(f2 - Math_fround(HEAPF32[i11 + (i1 << 4) >> 2]));
  f6 = Math_fround(HEAPF32[i11 + (i10 << 4) + 4 >> 2]);
  f8 = Math_fround(f6 - Math_fround(HEAPF32[i11 + (i1 << 4) + 4 >> 2]));
  i1 = i10 + 1 | 0;
  f2 = Math_fround(Math_fround(HEAPF32[i11 + (i1 << 4) >> 2]) - f2);
  f6 = Math_fround(Math_fround(HEAPF32[i11 + (i1 << 4) + 4 >> 2]) - f6);
  f7 = Math_fround(f3 + f2);
  f4 = Math_fround(f8 + f6);
  i1 = f3 < Math_fround(0.0);
  f12 = Math_fround(-f3);
  i1 = (i1 ? f12 : f3) > Math_fround(9.99999974e-06);
  f3 = Math_fround(f8 / f3);
  f3 = i1 ? f3 : Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  f12 = Math_fround(-f2);
  i1 = (i1 ? f12 : f2) > Math_fround(9.99999974e-06);
  f2 = Math_fround(f6 / f2);
  f2 = i1 ? f2 : Math_fround(0.0);
  i1 = f7 < Math_fround(0.0);
  f6 = Math_fround(-f7);
  i1 = (i1 ? f6 : f7) > Math_fround(9.99999974e-06);
  f7 = Math_fround(f4 / f7);
  f7 = i1 ? f7 : Math_fround(0.0);
  if (!(f3 > Math_fround(0.0) & f2 > Math_fround(0.0))) if (!(f3 < Math_fround(0.0) & f2 < Math_fround(0.0))) {
   HEAPF32[i11 + (i10 << 4) + 12 >> 2] = Math_fround(0.0);
   HEAPF32[i11 + (i10 << 4) + 8 >> 2] = Math_fround(0.0);
   break;
  }
  f2 = Math_fround((1.0 - +f5) * .5);
  f6 = Math_fround(f2 * f4);
  f2 = Math_fround(Math_fround(f2 + f5) * f4);
  i1 = f8 < Math_fround(0.0);
  f3 = Math_fround(-f8);
  f3 = i1 ? f3 : f8;
  i1 = f2 < Math_fround(0.0);
  f12 = Math_fround(-f2);
  if (f3 >= (i1 ? f12 : f2)) {
   f12 = Math_fround(f8 - f2);
   i1 = f6 < Math_fround(0.0);
   f8 = Math_fround(-f6);
   i1 = (i1 ? f8 : f6) > Math_fround(9.99999974e-06);
   f12 = Math_fround(Math_fround(1.0) - Math_fround(f12 / f6));
   f12 = Math_fround(f7 * (i1 ? f12 : Math_fround(1.0)));
   HEAPF32[i11 + (i10 << 4) + 8 >> 2] = f12;
   HEAPF32[i11 + (i10 << 4) + 12 >> 2] = f12;
   break;
  }
  i1 = f6 < Math_fround(0.0);
  f2 = Math_fround(-f6);
  f2 = i1 ? f2 : f6;
  if (f3 < f2) {
   i1 = f2 > Math_fround(9.99999974e-06);
   f12 = Math_fround(f8 / f6);
   f12 = Math_fround(f7 * (i1 ? f12 : Math_fround(0.0)));
   HEAPF32[i11 + (i10 << 4) + 8 >> 2] = f12;
   HEAPF32[i11 + (i10 << 4) + 12 >> 2] = f12;
   break;
  } else {
   HEAPF32[i11 + (i10 << 4) + 8 >> 2] = f7;
   HEAPF32[i11 + (i10 << 4) + 12 >> 2] = f7;
   break;
  }
 } while (0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(inf);
 HEAP32[i9 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(inf);
 HEAP32[i9 + 28 >> 2] = 0;
 return;
}

function __Z14RegisterPluginPvR20UnityPluginFunctions(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = HEAP32[gb + 1162584 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i3 = (i1 | 0) / 24 | 0;
 L1 : do if ((i1 | 0) > 0) {
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 * 24 | 0) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L1;
  }
  STACKTOP = i9;
  return;
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 + 8 >> 2] | 0)) __ZNSt3__26vectorIN19UnityPluginRegistry6PluginENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i6, i5); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 24;
 }
 i1 = HEAP32[(HEAP32[gb + 1162584 >> 2] | 0) + 4 >> 2] | 0;
 HEAP32[i1 + -24 >> 2] = i4;
 i1 = i1 + -20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 i1 = i8 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = __Z26IsRealGfxDeviceThreadOwnerv() | 0;
  if (!i2) {
   i7 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 548 >> 2] | 0, i7 | 0);
  }
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(i7 | 0, __Z18GetUnityInterfacesv() | 0);
  if (__Z11IsGfxDevicev() | 0) {
   i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
   if (i1 >>> 0 < 10) if (521 >>> (i1 & 1023) & 1) {
    i7 = __Z12GetGfxDevicev() | 0;
    mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0);
   }
  }
  if (!i2) {
   i7 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 552 >> 2] | 0, i7 | 0);
  }
 }
 if (!(__Z11IsGfxDevicev() | 0)) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = __Z26IsRealGfxDeviceThreadOwnerv() | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 if (i7) {
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 712 >> 2] | 0, i1 | 0) | 0;
  mftCall_viii(i7 | 0, i8 | 0, HEAP32[i1 + 4388 >> 2] | 0, 0);
  STACKTOP = i9;
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 548 >> 2] | 0, i1 | 0);
  i7 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 712 >> 2] | 0, i7 | 0) | 0;
  mftCall_viii(i6 | 0, i8 | 0, HEAP32[i7 + 4388 >> 2] | 0, 0);
  i8 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 552 >> 2] | 0, i8 | 0);
  STACKTOP = i9;
  return;
 }
}

function _ccosh(i13, i3) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 var d1 = 0.0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d14 = 0.0, d15 = 0.0, i16 = 0, d17 = 0.0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 32 | 0;
 i4 = i16 + 16 | 0;
 i5 = i16;
 d14 = +HEAPF64[i3 >> 3];
 i6 = i3 + 8 | 0;
 d15 = +HEAPF64[i6 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d14;
 i11 = HEAP32[tempDoublePtr >> 2] | 0;
 i12 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d15;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i7 = i12 & 2147483647;
 i8 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 i9 = i7 >>> 0 < 2146435072;
 do if (i9 & i8 >>> 0 < 2146435072) {
  if (!(i8 | i10)) {
   HEAPF64[i13 >> 3] = +_cosh(d14);
   HEAPF64[i13 + 8 >> 3] = d14 * d15;
   break;
  }
  if (i7 >>> 0 < 1077280768) {
   d1 = +_cosh(d14) * +Math_cos(+d15);
   d15 = +_sinh(d14) * +Math_sin(+d15);
   HEAPF64[i13 >> 3] = d1;
   HEAPF64[i13 + 8 >> 3] = d15;
   break;
  }
  if (i7 >>> 0 < 1082535490) {
   d17 = +Math_exp(+(+Math_abs(+d14))) * .5;
   d1 = d17 * +Math_cos(+d15);
   d15 = +_copysign(d17, d14) * +Math_sin(+d15);
   HEAPF64[i13 >> 3] = d1;
   HEAPF64[i13 + 8 >> 3] = d15;
   break;
  }
  if (i7 >>> 0 < 1083620266) {
   HEAPF64[i5 >> 3] = +Math_abs(+d14);
   HEAPF64[i5 + 8 >> 3] = d15;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   ___ldexp_cexp(i4, i2, -1);
   d15 = +HEAPF64[i4 >> 3];
   d17 = +HEAPF64[i4 + 8 >> 3];
   HEAPF64[i3 >> 3] = d15;
   HEAPF64[i6 >> 3] = d17;
   d17 = d17 * +_copysign(1.0, d14);
   HEAPF64[i13 >> 3] = d15;
   HEAPF64[i13 + 8 >> 3] = d17;
   break;
  } else {
   d14 = d14 * 8988465674311579538646525.0e283;
   d17 = d14 * +Math_sin(+d15);
   HEAPF64[i13 >> 3] = d14 * d14 * +Math_cos(+d15);
   HEAPF64[i13 + 8 >> 3] = d17;
   break;
  }
 } else {
  i3 = i8 >>> 0 > 2146435071;
  if ((i7 | i11 | 0) == 0 & i3) {
   d15 = d15 - d15;
   d17 = +_copysign(0.0, d14 * d15);
   HEAPF64[i13 >> 3] = d15;
   HEAPF64[i13 + 8 >> 3] = d17;
   break;
  }
  i2 = i7 >>> 0 > 2146435071;
  if (i2 & (i8 | i10 | 0) == 0) {
   d1 = d14 * d14;
   if (!(i12 & 1048575 | i11)) {
    d17 = d15 * +_copysign(0.0, d14);
    HEAPF64[i13 >> 3] = d1;
    HEAPF64[i13 + 8 >> 3] = d17;
    break;
   } else {
    d17 = +_copysign(0.0, (d14 + d14) * d15);
    HEAPF64[i13 >> 3] = d1;
    HEAPF64[i13 + 8 >> 3] = d17;
    break;
   }
  }
  if (i9 & i3) {
   d17 = d15 - d15;
   HEAPF64[i13 >> 3] = d17;
   HEAPF64[i13 + 8 >> 3] = d14 * d17;
   break;
  }
  if (i2) if (!(i12 & 1048575 | i11)) {
   d1 = d14 * d14;
   if (i3) {
    HEAPF64[i13 >> 3] = d1;
    HEAPF64[i13 + 8 >> 3] = d14 * (d15 - d15);
    break;
   } else {
    d17 = d14 * +Math_sin(+d15);
    HEAPF64[i13 >> 3] = d1 * +Math_cos(+d15);
    HEAPF64[i13 + 8 >> 3] = d17;
    break;
   }
  }
  d17 = d15 - d15;
  HEAPF64[i13 >> 3] = d14 * d14 * d17;
  HEAPF64[i13 + 8 >> 3] = (d14 + d14) * d17;
 } while (0);
 STACKTOP = i16;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_(i2, i1, i7, i11, i8, i10, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, f12 = f0, f13 = f0;
 switch ((Math_imul(i7, -3) | 0) + i1 | 0) {
 case 0:
  {
   i6 = HEAP32[i2 + 16 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   i2 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 36 >> 2] | 0;
   f4 = Math_fround(f3 * Math_fround(HEAP16[i2 + (i7 << 2) >> 1] | 0));
   f3 = Math_fround(f3 * Math_fround(HEAP16[i2 + (i7 + 1 << 2) >> 1] | 0));
   f13 = Math_fround(Math_fround(i11 >>> 0) * Math_fround(HEAPF32[i6 + 12 >> 2]));
   f12 = Math_fround(i8 >>> 0);
   f5 = Math_fround(HEAPF32[i6 + 16 >> 2]);
   f12 = Math_fround(f12 * f5);
   HEAPF32[i10 >> 2] = f13;
   HEAPF32[i10 + 4 >> 2] = f4;
   HEAPF32[i10 + 8 >> 2] = f12;
   f4 = Math_fround(f3 - f4);
   HEAP32[i9 >> 2] = 0;
   HEAPF32[i9 + 4 >> 2] = f4;
   HEAPF32[i9 + 8 >> 2] = f5;
   return;
  }
 case 1:
  {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   i6 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   if ((HEAP8[i6 + (i7 << 2) + 2 >> 0] | 0) < 0) {
    f13 = Math_fround(f3 * Math_fround(HEAP16[i6 + (i7 << 2) >> 1] | 0));
    f12 = Math_fround(f3 * Math_fround(HEAP16[i6 + (i7 + 1 + i1 << 2) >> 1] | 0));
    f3 = Math_fround(Math_fround(i8 >>> 0) * f5);
    HEAPF32[i10 >> 2] = Math_fround(Math_fround(i11 >>> 0) * f4);
    HEAPF32[i10 + 4 >> 2] = f13;
    HEAPF32[i10 + 8 >> 2] = f3;
    f13 = Math_fround(f12 - f13);
    HEAPF32[i9 >> 2] = f4;
    HEAPF32[i9 + 4 >> 2] = f13;
    HEAPF32[i9 + 8 >> 2] = f5;
    return;
   } else {
    f12 = Math_fround(f3 * Math_fround(HEAP16[i6 + (i7 + 1 << 2) >> 1] | 0));
    f13 = Math_fround(f3 * Math_fround(HEAP16[i6 + (i1 + i7 << 2) >> 1] | 0));
    f3 = Math_fround(Math_fround((i8 + 1 | 0) >>> 0) * f5);
    HEAPF32[i10 >> 2] = Math_fround(Math_fround(i11 >>> 0) * f4);
    HEAPF32[i10 + 4 >> 2] = f12;
    HEAPF32[i10 + 8 >> 2] = f3;
    f12 = Math_fround(f13 - f12);
    f13 = Math_fround(-f5);
    HEAPF32[i9 >> 2] = f4;
    HEAPF32[i9 + 4 >> 2] = f12;
    HEAPF32[i9 + 8 >> 2] = f13;
    return;
   }
  }
 case 2:
  {
   i6 = HEAP32[i2 + 16 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
   i2 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i2 + 36 >> 2] | 0;
   f13 = Math_fround(f5 * Math_fround(HEAP16[i1 + (i7 << 2) >> 1] | 0));
   f5 = Math_fround(f5 * Math_fround(HEAP16[i1 + ((HEAP32[i2 + 20 >> 2] | 0) + i7 << 2) >> 1] | 0));
   f3 = Math_fround(i11 >>> 0);
   f12 = Math_fround(HEAPF32[i6 + 12 >> 2]);
   f3 = Math_fround(f3 * f12);
   f4 = Math_fround(Math_fround(i8 >>> 0) * Math_fround(HEAPF32[i6 + 16 >> 2]));
   HEAPF32[i10 >> 2] = f3;
   HEAPF32[i10 + 4 >> 2] = f13;
   HEAPF32[i10 + 8 >> 2] = f4;
   f13 = Math_fround(f5 - f13);
   HEAPF32[i9 >> 2] = f12;
   HEAPF32[i9 + 4 >> 2] = f13;
   HEAP32[i9 + 8 >> 2] = 0;
   return;
  }
 default:
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 3;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = i1 - i4 >> 3;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj(i5, i2 - i3 | 0);
  i9 = HEAP32[i6 >> 2] | 0;
 } else if (i2 >>> 0 < i3 >>> 0) {
  i2 = i4 + (i2 << 3) | 0;
  if ((i1 | 0) == (i2 | 0)) i9 = i1; else {
   do {
    HEAP32[i6 >> 2] = i1 + -8;
    __ZN14ConstantStringD2Ev(i1 + -4 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i9 = i2;
  }
 } else i9 = i1;
 do if (HEAP32[i7 >> 2] | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairIi14ConstantStringEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIi14ConstantStringEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN11TrailModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 8 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 12 | 0, i6);
 i1 = i5 + 276 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 280 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 284 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 285 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 286 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 287 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 288 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 292 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 448 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 712 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 292 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 448 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  i8 = i5 + 712 | 0;
  __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i6 = i8;
 i7 = (HEAP32[i1 >> 2] | 0) - i6 >> 3;
 i14 = i8 + (i7 << 3) | 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = i11 + 8 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 i5 = i10;
 if (i1 >>> 0 < i10 >>> 0) {
  if ((i14 | 0) == (i1 | 0)) {
   i10 = i12;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i14;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 8;
   return i14 | 0;
  }
  i5 = i2 - (i14 + 8) >> 3;
  i2 = i14 + (i5 << 3) | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   i4 = i2;
   i3 = i1;
   do {
    i10 = i4;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i3 + 4 >> 2] = i11;
    i4 = i4 + 8 | 0;
    i3 = (HEAP32[i13 >> 2] | 0) + 8 | 0;
    HEAP32[i13 >> 2] = i3;
   } while (i4 >>> 0 < i1 >>> 0);
  } else i3 = i1;
  if (i5 | 0) do {
   i13 = i1;
   i1 = i1 + -8 | 0;
   i11 = i2;
   i2 = i2 + -8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i13 + -4 >> 2] = HEAP32[i11 + -4 >> 2];
  } while ((i2 | 0) != (i14 | 0));
  i13 = i14 >>> 0 > i12 >>> 0 ? i12 : i3 >>> 0 > i12 >>> 0 ? i12 + 8 | 0 : i12;
  HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i8 + (i7 << 3) + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  return i14 | 0;
 }
 i3 = (i2 - i6 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i11 >> 2] | 0;
  i10 = i4;
  i8 = i2;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i10 = i4;
  i1 = i5;
  i2 = i6;
 }
 i9 = i1 - i2 | 0;
 i5 = i9 >> 2;
 i5 = i9 >> 3 >>> 0 < 268435455 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 536870911;
 i9 = i14;
 i2 = i9 - i2 | 0;
 i3 = i2 >> 3;
 if (!i5) i7 = 0; else i7 = __Znwj(i5 << 3) | 0;
 i1 = i7 + (i3 << 3) | 0;
 i4 = i1;
 i6 = i7 + (i5 << 3) | 0;
 do if ((i3 | 0) == (i5 | 0)) {
  if ((i2 | 0) > 0) {
   i1 = i1 + (((i5 + 1 | 0) / -2 | 0) << 3) | 0;
   i5 = i1;
   i4 = i8;
   break;
  }
  i2 = i5 << 3 >> 2;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  i6 = __Znwj(i2 << 3) | 0;
  i3 = i6 + (i2 >>> 2 << 3) | 0;
  i1 = i3;
  i2 = i6 + (i2 << 3) | 0;
  if (!i7) {
   i5 = i1;
   i6 = i2;
   i1 = i3;
   i4 = i8;
  } else {
   __ZdlPv(i7);
   i5 = i1;
   i6 = i2;
   i1 = i3;
   i4 = HEAP32[i11 >> 2] | 0;
  }
 } else {
  i5 = i4;
  i4 = i8;
 } while (0);
 i2 = i12;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i5 + 8 | 0;
 i3 = i5;
 i2 = i9 - i4 | 0;
 i5 = i3 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i5 | 0, i4 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i9 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i14 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 3 << 3) | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i10 >> 2] = i6;
 if (!i2) {
  i14 = i3;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i3;
 return i14 | 0;
}

function __ZN13RenderManager27UpdatePreviousFrameMatricesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i6 = i7 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 13;
    }
   }
   if ((i10 | 0) == 11) i10 = 13;
   if ((i10 | 0) == 13) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i1) break;
   }
   __ZN6Camera34UpdatePreviousViewProjectionMatrixEv(i1);
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i6 = i7 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i5 = i1 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 23; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 23; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 25;
    }
   }
   if ((i10 | 0) == 23) i10 = 25;
   if ((i10 | 0) == 25) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i1) break;
   }
   __ZN6Camera34UpdatePreviousViewProjectionMatrixEv(i1);
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZL18SweepCapsuleSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i9, i4, i3, i1, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var f2 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i12 + 68 | 0;
 i16 = i12 + 40 | 0;
 i15 = i12 + 32 | 0;
 i14 = i12;
 i11 = i12 + 80 | 0;
 i13 = i12 + 128 | 0;
 HEAP32[i17 >> 2] = 2;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i5 = i3 + 16 | 0;
 d22 = +HEAPF64[i5 >> 3];
 i6 = i3 + 24 | 0;
 d20 = +HEAPF64[i6 >> 3];
 i7 = i3 + 32 | 0;
 d18 = +HEAPF64[i7 >> 3];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAPF32[i17 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i4 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i16 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i16 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i16 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i16 >> 2] = HEAP32[i9 + 228 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i9 + 232 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i9 + 236 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i9 + 240 >> 2];
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i14 + 20 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i14 + 24 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 1065353216;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = -1;
 HEAP16[i11 + 12 >> 1] = 0;
 i3 = i11 + 16 | 0;
 i1 = i11 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i4 = i10 + 36 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 HEAP16[i13 >> 1] = (HEAP8[i9 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i8, f2, i17, i16, i15, i14, i11, i13, Math_fround(0.0)) | 0)) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 >= Math_fround(HEAPF32[i4 >> 2])) {
  i17 = 0;
  STACKTOP = i12;
  return i17 | 0;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 32 >> 2];
 HEAP32[i10 + 32 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP32[i10 + 40 >> 2] = -1;
 HEAP32[i10 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i3 >> 2]);
 HEAPF64[i10 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 20 >> 2]);
 HEAPF64[i10 + 8 >> 3] = d23 + +HEAPF64[i6 >> 3];
 d23 = +Math_fround(HEAPF32[i11 + 24 >> 2]);
 HEAPF64[i10 + 16 >> 3] = d23 + +HEAPF64[i7 >> 3];
 i17 = 1;
 STACKTOP = i12;
 return i17 | 0;
}

function __ZNK6Camera22CalculateFrustumPlanesEP5PlaneRK10Matrix4x4ffRfb(i13, i14, i1, f15, i16, i2) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 f15 = Math_fround(f15);
 i16 = i16 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i17 = 0, f18 = f0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 64 | 0;
 i12 = i17;
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i1, i14);
 i3 = HEAP8[i13 + 1080 >> 0] | 0;
 if (!(i3 << 24 >> 24 != 0 | i2)) {
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i14 + 92 >> 2]) - f15);
  STACKTOP = i17;
  return;
 }
 i1 = i13 + 36 | 0;
 i2 = i13 + 1076 | 0;
 if (!((HEAP8[i2 >> 0] | 0) == 0 | i3 << 24 >> 24 == 0)) {
  HEAPF32[i6 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i1, i6) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i13 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i1, i6) | 0;
  HEAP8[i2 >> 0] = 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i1, i12) | 0;
 f9 = Math_fround(HEAPF32[i12 + 48 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 52 >> 2]);
 f11 = Math_fround(HEAPF32[i12 + 56 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 32 >> 2]);
 f8 = Math_fround(HEAPF32[i12 + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 40 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f4 * f4))));
 if (f5 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f7 = Math_fround(f7 / f5);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = Math_fround(f8 / f5);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  f8 = Math_fround(f4 / f5);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i1 = HEAP32[gb + 1162364 >> 2] | 0;
  i2 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 }
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = Math_fround(-f5);
 f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(-f7);
 f8 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(-f8);
 HEAPF32[i14 + 64 >> 2] = f19;
 HEAPF32[i14 + 68 >> 2] = f18;
 HEAPF32[i14 + 72 >> 2] = f4;
 f4 = Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f19) + Math_fround(f10 * f18)) + Math_fround(f11 * f4)));
 HEAPF32[i14 + 76 >> 2] = Math_fround(f4 - Math_fround(HEAPF32[i13 + 920 >> 2]));
 HEAP32[i14 + 80 >> 2] = i1;
 HEAP32[i14 + 84 >> 2] = i2;
 HEAP32[i14 + 88 >> 2] = i3;
 f11 = Math_fround(-Math_fround(Math_fround(Math_fround(f9 * f5) + Math_fround(f10 * f7)) + Math_fround(f11 * f8)));
 i14 = i14 + 92 | 0;
 HEAPF32[i14 >> 2] = f11;
 HEAPF32[i16 >> 2] = f11;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f15);
 STACKTOP = i17;
 return;
}

function __ZN12AudioManager25RebindAudioSourcesToMixerEP10AudioMixer(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i11 = i1 + 44 | 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i1 = i2;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 if (!i7) {
  do {
   __ZN11AudioSource19ConfigureFMODGroupsEv(HEAP32[i2 + 8 >> 2] | 0);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
  } while ((i1 | 0) != (i11 | 0));
  STACKTOP = i12;
  return;
 }
 do {
  i6 = HEAP32[i2 + 8 >> 2] | 0;
  i5 = HEAP32[i6 + 440 >> 2] | 0;
  do if (i5 | 0) {
   HEAP32[i9 >> 2] = i5;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 11; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 11; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i10 = 13;
    }
   }
   if ((i10 | 0) == 11) i10 = 13;
   if ((i10 | 0) == 13) {
    i10 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i2) break;
   }
   i5 = HEAP32[i2 + 52 >> 2] | 0;
   if (!i5) i2 = 0; else {
    HEAP32[i9 >> 2] = i5;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i10 = 20; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
      i3 = HEAP32[i8 >> 2] | 0;
      i13 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 20; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i10 = 22;
     }
    }
    if ((i10 | 0) == 20) i10 = 22;
    if ((i10 | 0) == 22) {
     i10 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
   }
   if ((i2 | 0) == (i7 | 0)) __ZN11AudioSource19ConfigureFMODGroupsEv(i6);
  } while (0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __Z19UploadTexture2DDataRK23UploadTextureDataParams(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i25 + 52 | 0;
 i5 = i25 + 8 | 0;
 i11 = i25 + 48 | 0;
 i18 = i25 + 44 | 0;
 i3 = i25;
 i12 = i25 + 40 | 0;
 i16 = i25 + 36 | 0;
 i17 = i25 + 32 | 0;
 i14 = i25 + 28 | 0;
 i24 = i25 + 24 | 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 + 8 >> 2];
 i8 = HEAP32[i2 + 12 >> 2] | 0;
 i9 = HEAP32[i2 + 16 >> 2] | 0;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i18 >> 2] = i1;
 i7 = HEAP32[i2 + 28 >> 2] | 0;
 i22 = HEAP32[i2 + 32 >> 2] | 0;
 i23 = HEAP32[i2 + 36 >> 2] | 0;
 i10 = HEAP32[i2 + 40 >> 2] | 0;
 i19 = HEAP32[i2 + 44 >> 2] | 0;
 do if ((i1 | 1 | 0) == 29) {
  if (!i4) {
   i24 = 0;
   STACKTOP = i25;
   return i24 | 0;
  }
  i13 = gb + 64016 | 0;
  i15 = HEAP32[i13 + 4 >> 2] | 0;
  i1 = i3;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  HEAP32[i20 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i20 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  i1 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i4, i11, i18, i6, i8, i9, 1, i20) | 0;
  if (i1 | 0) {
   i15 = i1;
   i2 = i1;
   i13 = i7 & -2;
   i1 = HEAP32[i18 >> 2] | 0;
   break;
  }
  i24 = HEAP32[i18 >> 2] | 0;
  HEAP32[i5 >> 2] = i8;
  HEAP32[i5 + 4 >> 2] = i9;
  HEAP32[i5 + 8 >> 2] = i24;
  HEAP32[i5 + 12 >> 2] = i6;
  __Z6FormatPKcz(i20, gb + 410906 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i20 + 11 >> 0] | 0) < 0 ? HEAP32[i20 >> 2] | 0 : i20, 0, gb + 410978 | 0, 441, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i20);
  i24 = 0;
  STACKTOP = i25;
  return i24 | 0;
 } else {
  i15 = 0;
  i2 = i4;
  i13 = i7;
 } while (0);
 HEAP32[i12 >> 2] = i2;
 i4 = i6 + -1 | 0;
 HEAP32[i16 >> 2] = i8;
 HEAP32[i17 >> 2] = i9;
 HEAP32[i14 >> 2] = 0;
 i10 = __Z29SkipMipLevelsForTextureUploadi13TextureFormatiPPKhPiS3_S3_((i10 | 0) < (i4 | 0) ? i10 : i4, i1, i6, i12, i16, i17, i14) | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i10) {
  i7 = (HEAP32[i11 >> 2] | 0) + i2 - i4 | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i17 >> 2] | 0;
  i1 = HEAP32[i18 >> 2] | 0;
 } else {
  HEAP32[i12 >> 2] = gb + 411047;
  HEAP32[i16 >> 2] = 1;
  HEAP32[i17 >> 2] = 1;
  HEAP32[i18 >> 2] = 5;
  HEAP32[i14 >> 2] = 0;
  i7 = 4;
  i6 = 1;
  i5 = 0;
  i4 = gb + 411047 | 0;
  i3 = 1;
  i2 = 1;
  i1 = 5;
 }
 i18 = HEAP32[(HEAP32[i19 >> 2] | 0) + 436 >> 2] | 0;
 HEAP32[i24 >> 2] = i21;
 HEAP32[i20 >> 2] = HEAP32[i24 >> 2];
 mftCall_viiiiiiiiiiii(i18 | 0, i19 | 0, i20 | 0, 2, i4 | 0, i7 | 0, i3 | 0, i2 | 0, i1 | 0, i6 - i5 | 0, i13 | 0, i22 | 0, i23 | 0);
 if (i15 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i15, gb + 64016 | 0);
 i24 = 1;
 STACKTOP = i25;
 return i24 | 0;
}

function __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
  i2 = i3;
 }
 i3 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 32 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 36 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 40 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN15SerializeTraitsIN16ParticleRenderer11UVAnimationEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048586 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048593 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048600 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z33EmitSerializationCommandsForFieldI9JSONWriteEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i5 = i11 + 112 | 0;
 i9 = i11;
 i2 = i3 + 4 | 0;
 if (__Z18IsLinearCollectionP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0) {
  __Z49EmitSerializationCommandsForLinearCollectionFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4);
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
 i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
 HEAP32[i1 + 12 >> 2] = i7;
 HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
 HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
 HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
 i2 = i3 + 12 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
 i8 = __ZN6HelperI9JSONWrite18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i3, i1, i5) | 0;
 if (!i8) {
  if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4);
 } else if (!((HEAP8[i3 + 25 >> 0] | 0) != 0 & (HEAP8[i5 >> 0] | 0) == 0)) {
  i3 = i9 + 48 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i3 = i9;
  i2 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  i2 = i10 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i10 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 + (i3 << 6) >> 2] = i8;
  i3 = i1 + (i3 << 6) + 4 | 0;
  i1 = i9;
  i2 = i3 + 60 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc5Scene17finalizationPhaseEPNS_10PxBaseTaskE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = i9 + 1204 | 0;
 __ZN5physx16PxsIslandManager11freeBuffersEv(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i4 >> 2] | 0) | 0);
 i1 = HEAP32[i9 + 208 >> 2] | 0;
 if (i1 | 0) {
  i2 = i9 + 204 | 0;
  do {
   i1 = i1 + -1 | 0;
   __ZN5physx2Sc13ConstraintSim21checkMaxForceExceededEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  } while ((i1 | 0) != 0);
 }
 i1 = i9 + 148 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i9 + 144 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sc17ParticleSystemSim7endStepEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 if (Math_fround(HEAPF32[i9 + 1408 >> 2]) != Math_fround(0.0)) {
  i1 = (HEAP32[(HEAP32[i4 >> 2] | 0) + 1e3 >> 2] | 0) + 5924 | 0;
  i2 = i7 + 36 | 0;
  i3 = i7;
  i4 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  i6 = i7 + 40 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i7 + 56 >> 2] = Math_fround(1.0);
  i6 = i7 + 60 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i7 + 76 >> 2] = Math_fround(1.0);
  i6 = i7 + 80 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAPF32[i7 + 96 >> 2] = Math_fround(1.0);
  HEAP32[i7 + 100 >> 2] = i1;
  i1 = i9 + 136 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i2 = i9 + 132 | 0;
   i3 = 0;
   do {
    __ZN5physx2Sc17ParticleSystemSim16visualizeEndStepERNS_2Cm12RenderOutputE(__ZNK5physx2Sc18ParticleSystemCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0, i7);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
  }
 }
 i2 = i9 + 2360 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i9 + 2376 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 2 | 0;
 i5 = i9 + 2368 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= i4 >>> 0) {
  HEAP32[i3 >> 2] = 0;
  i7 = i9 + 2380 | 0;
  HEAP32[i7 >> 2] = 0;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  i9 = i9 + 80 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i9 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 i6 = i9 + 2364 | 0;
 do {
  i11 = i1 + -1 | 0;
  i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  HEAP32[i5 >> 2] = i11;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i10);
  i1 = HEAP32[i5 >> 2] | 0;
 } while (i1 >>> 0 > i4 >>> 0);
 HEAP32[i3 >> 2] = 0;
 i11 = i9 + 2380 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 i11 = i9 + 80 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i8;
 return;
}

function __ZN19MeshParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3 + 8 | 0;
 i9 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(240, i1, 16, gb + 1048932 | 0, 0, gb + 1049039 | 0, 13) | 0;
 i11 = i1;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i10, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 190444 + 8;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i10 = i4 + 144 | 0;
 i9 = i4 + 156 | 0;
 i8 = i4 + 168 | 0;
 i1 = i4 + 180 | 0;
 HEAP32[i4 + 208 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = 0;
 HEAP32[i4 + 216 >> 2] = i4;
 HEAPF32[i4 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 205 >> 0] = 1;
 HEAP8[i4 + 204 >> 0] = 1;
 HEAP8[i4 + 206 >> 0] = 0;
 HEAP8[i4 + 109 >> 0] = 0;
 HEAP8[i4 + 110 >> 0] = 0;
 HEAPF32[i4 + 116 >> 2] = Math_fround(.100000001);
 HEAPF32[i4 + 120 >> 2] = Math_fround(.100000001);
 HEAPF32[i4 + 124 >> 2] = Math_fround(3.0);
 HEAPF32[i4 + 128 >> 2] = Math_fround(3.0);
 HEAPF32[i4 + 132 >> 2] = Math_fround(50.0);
 HEAPF32[i4 + 136 >> 2] = Math_fround(50.0);
 HEAP8[i4 + 192 >> 0] = 1;
 HEAPF32[i4 + 140 >> 2] = Math_fround(.0500000007);
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 200 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 193 >> 0] = 0;
 HEAP8[i4 + 207 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i4 + 84 >> 2] = f7;
 HEAPF32[i4 + 88 >> 2] = f6;
 HEAPF32[i4 + 92 >> 2] = f5;
 HEAP32[i4 >> 2] = gb + 190616 + 8;
 HEAP32[i4 + 236 >> 2] = 0;
 HEAP32[i4 + 232 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 24 | 0) + 1 | 0;
 if (i4 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 24 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 89478485 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 178956970;
 i5 = (i1 - i2 | 0) / 24 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 24 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 24 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 24 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 24 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 24 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 24 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 24 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i15 = i9 + 16 | 0;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i3 = i6 + (i5 * 24 | 0) + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 24;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -24 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -12 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i7 + -40 | 0;
  i5 = i1;
  i1 = i1 + -40 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  i2 = i7 + -20 | 0;
  i4 = i5 + -20 | 0;
  i3 = HEAP32[i5 + -8 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i6 = i7 + -8 | 0;
  HEAP32[i6 >> 2] = i3;
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i4 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i5 + -16 >> 2] | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i3 = HEAP32[i6 >> 2] | 0;
    i15 = 9;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i5;
    if (i5) i15 = 11;
   } else i15 = 9;
   if ((i15 | 0) == 9) {
    i17 = i5 + 16 & -16;
    HEAP32[i10 >> 2] = 54;
    HEAP32[i14 >> 2] = i3;
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i7 + -12 >> 2] = i17 | -2147483648;
    HEAP32[i7 + -16 >> 2] = i5;
    i2 = i6;
    i15 = 11;
   }
   if ((i15 | 0) == 11) {
    i15 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  }
  i7 = (HEAP32[i13 >> 2] | 0) + -40 | 0;
  HEAP32[i13 >> 2] = i7;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i7;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZN8Gradient8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1, gb + 1033999 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 4 | 0, gb + 1034004 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 8 | 0, gb + 1034009 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 12 | 0, gb + 1034014 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 16 | 0, gb + 1034019 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 20 | 0, gb + 1034024 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 24 | 0, gb + 1034029 | 0, 1, 0);
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i2, i1 + 28 | 0, gb + 1034034 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 32 | 0, gb + 1034039 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 34 | 0, gb + 1034046 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 36 | 0, gb + 1034053 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 38 | 0, gb + 1034060 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 40 | 0, gb + 1034067 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 42 | 0, gb + 1034074 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 44 | 0, gb + 1034081 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 46 | 0, gb + 1034088 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 48 | 0, gb + 1034095 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 50 | 0, gb + 1034102 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 52 | 0, gb + 1034109 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 54 | 0, gb + 1034116 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 56 | 0, gb + 1034123 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 58 | 0, gb + 1034130 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 60 | 0, gb + 1034137 | 0, 1, 0);
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 62 | 0, gb + 1034144 | 0, 1, 0);
 i4 = i1 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i5, gb + 1034151 | 0, 1, 0);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 64 | 0, gb + 1034158 | 0, 1, 0);
 __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 65 | 0, gb + 1034173 | 0, 1, 0);
 __ZN8Gradient17ValidateColorKeysEv(i1);
 __ZN8Gradient17ValidateAlphaKeysEv(i1);
 STACKTOP = i3;
 return;
}

function __ZN12FlareManager8AddFlareEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i9 + 12 | 0;
 i7 = i9 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i8;
 i5 = i2;
 L1 : do if ((i2 | 0) != (i8 | 0)) {
  i1 = 0;
  while (1) {
   i3 = i2 + 49 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) break;
   i2 = i2 + 52 | 0;
   if ((i2 | 0) == (i8 | 0)) break L1; else i1 = i1 + 1 | 0;
  }
  HEAP8[i3 >> 0] = 1;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i9 + 4 | 0;
  if ((i3 | 0) == (i4 | 0)) {
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
  while (1) {
   HEAPF32[(HEAP32[i3 + 20 >> 2] | 0) + (i1 << 2) >> 2] = Math_fround(0.0);
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   } else while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
  }
  STACKTOP = i11;
  return i1 | 0;
 } while (0);
 i1 = (i4 - i5 | 0) / 52 | 0;
 i5 = i10 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i10 + 32 >> 2] = -1;
 HEAP32[i10 + 36 >> 2] = -1;
 HEAPF32[i10 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 44 >> 2] = Math_fround(3.0);
 HEAP8[i10 + 48 >> 0] = 0;
 HEAP8[i10 + 49 >> 0] = 1;
 if ((i8 | 0) == (HEAP32[i9 + 20 >> 2] | 0)) __ZNSt3__26vectorIN12FlareManager10FlareEntryENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i6, i10); else {
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  i8 = i8 + 28 | 0;
  i6 = i10 + 28 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP16[i8 + 20 >> 1] = HEAP16[i6 + 20 >> 1] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 52;
 }
 i3 = HEAP32[i9 >> 2] | 0;
 i5 = i9 + 4 | 0;
 if ((i3 | 0) == (i5 | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 while (1) {
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  i2 = i3 + 24 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) __ZNSt3__26vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIKfEEvRT_(i3 + 20 | 0, i10); else {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = i4 + 4;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __Z20SplatPrototypeToMonoRK14SplatPrototypeR18MonoSplatPrototype(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
 }
 HEAP32[i9 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 19;
   }
  }
  if ((i7 | 0) == 17) i7 = 19;
  if ((i7 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 HEAP32[i9 + 4 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i7 = i8 + 8 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i8 + 16 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i9 + 24 | 0;
 i6 = i8 + 24 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i9 + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN15LightProbeUtils34RemoveDuplicateLightProbePositionsEPK8Vector3fiR13dynamic_arrayIS0_Lj4EE(i17, i18, i19) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i20 + 4 | 0;
 i2 = i20;
 if ((HEAP16[gb + 1158104 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158104 | 0, i1);
  i13 = gb + 1158104 | 0;
 } else i13 = 0;
 i16 = i19 + 16 | 0;
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i19 + 4 | 0);
  HEAP32[i19 >> 2] = 0;
 }
 HEAP32[i19 >> 2] = 0;
 i14 = i19 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i16 >> 2] = 0;
 if ((i18 | 0) > 0) {
  i15 = i19 + 4 | 0;
  i12 = 0;
  i11 = 0;
  i10 = 0;
  i2 = 0;
  while (1) {
   i9 = i17 + (i12 * 12 | 0) | 0;
   L11 : do if ((i12 | 0) > 0) {
    f6 = Math_fround(HEAPF32[i9 >> 2]);
    f7 = Math_fround(HEAPF32[i17 + (i12 * 12 | 0) + 4 >> 2]);
    f8 = Math_fround(HEAPF32[i17 + (i12 * 12 | 0) + 8 >> 2]);
    i1 = 0;
    do {
     f23 = Math_fround(f6 - Math_fround(HEAPF32[i17 + (i1 * 12 | 0) >> 2]));
     f22 = Math_fround(f7 - Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2]));
     f21 = Math_fround(f8 - Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2]));
     if (Math_fround(Math_fround(Math_fround(f23 * f23) + Math_fround(f22 * f22)) + Math_fround(f21 * f21)) < Math_fround(.00250000018)) break L11;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i12 | 0));
   } else i1 = 0; while (0);
   if ((i1 | 0) == (i12 | 0)) {
    i1 = i11 + 1 | 0;
    i4 = HEAP32[i16 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i1 >>> 0 > i5 >>> 0) {
     i3 = i4 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i16 >> 2] = i3;
      i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i10, i3 * 12 | 0, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
      HEAP32[i19 >> 2] = i2;
      break;
     } else {
      i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i2 | 0, HEAP32[i19 >> 2] | 0, (HEAP32[i14 >> 2] | 0) * 12 | 0) | 0;
      HEAP32[i16 >> 2] = i3;
      HEAP32[i19 >> 2] = i2;
      break;
     }
    } while (0);
    HEAP32[i14 >> 2] = i1;
    HEAP32[i2 + (i11 * 12 | 0) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i2 + (i11 * 12 | 0) + 4 >> 2] = HEAP32[i17 + (i12 * 12 | 0) + 4 >> 2];
    HEAP32[i2 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i17 + (i12 * 12 | 0) + 8 >> 2];
    i3 = i2;
   } else {
    i3 = i2;
    i2 = i10;
    i1 = i11;
   }
   i12 = i12 + 1 | 0;
   if ((i12 | 0) == (i18 | 0)) break; else {
    i11 = i1;
    i10 = i2;
    i2 = i3;
   }
  }
 }
 if (!i13) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i20;
 return;
}

function __ZN11TypeManager41GetDeserializationStubForPersistentTypeIDEi(i4, i10) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i12 = i14;
 i13 = i4 + 236 | 0;
 i6 = HEAP32[i4 + 240 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] | 0) == (i6 | 0)) {
  i2 = HEAP32[i4 + 264 >> 2] | 0;
  i1 = HEAP32[i4 + 268 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i9 = HEAP32[i4 + 268 >> 2] | 0;
  i7 = i9 + -1 | 0;
  i1 = i7 & (Math_imul((Math_imul((Math_imul((Math_imul(i10 >>> 24 ^ -2128831035, 16777619) | 0) ^ i10 >>> 16 & 255, 16777619) | 0) ^ i10 >>> 8 & 255, 16777619) | 0) ^ i10 & 255, 16777619) | 0);
  i2 = HEAP32[i4 + 264 >> 2] | 0;
  i8 = HEAP32[i4 + 256 >> 2] | 0;
  i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L4 : do if ((i8 | 0) == (i3 | 0)) i1 = -1; else {
   i5 = i4 + 248 | 0;
   if (!(HEAP8[i4 + 244 >> 0] | 0)) {
    i4 = 0;
    while (1) {
     if ((i3 | 0) == (i10 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i8 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   if (!i6) {
    i4 = 0;
    while (1) {
     if ((i3 | 0) == (i10 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i8 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = 0;
   while (1) {
    if ((i5 | 0) != (i3 | 0) & (i3 | 0) == (i10 | 0)) break L4;
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i7;
    i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i3 = (i1 | 0) == -1 ? i2 + (i9 << 3) | 0 : i2 + (i1 << 3) | 0;
  i1 = i9;
 }
 if ((i3 | 0) != (i2 + (i1 << 3) | 0)) {
  i13 = HEAP32[i3 + 4 >> 2] | 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63520 | 0, 16, gb + 373107 | 0, 262) | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = gb + 1047948;
 HEAP32[i1 + 12 >> 2] = gb + 1576256;
 HEAP32[i1 + 20 >> 2] = -1;
 HEAP32[i1 + 24 >> 2] = -2147483648;
 i9 = i1 + 28 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = i10;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i1;
 __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i13, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_(i11, i13, i12);
 if (!(HEAP8[i11 + 12 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63520 | 0);
 i13 = HEAP32[(HEAP32[i11 + 4 >> 2] | 0) + 4 >> 2] | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z33EmitSerializationCommandsForFieldI8JSONReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i5 = i11 + 112 | 0;
 i9 = i11;
 i2 = i3 + 4 | 0;
 if (__Z18IsLinearCollectionP11Il2CppClass(HEAP32[i2 >> 2] | 0) | 0) {
  __Z49EmitSerializationCommandsForLinearCollectionFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4);
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i8) | 0;
 i7 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
 HEAP32[i1 + 12 >> 2] = i7;
 HEAP32[i1 + 16 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i8) | 0) | 0;
 HEAP32[i1 + 20 >> 2] = __Z26scripting_field_get_offsetP9FieldInfo(i8) | 0;
 HEAP32[i1 + 8 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i7) | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
 i2 = i3 + 12 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
 i8 = __ZN6HelperI8JSONRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb(i3, i1, i5) | 0;
 if (!i8) {
  if (((HEAP32[i2 >> 2] | 0) + -17 | 0) >>> 0 < 2) __Z46EmitSerializationCommandsForManagedObjectFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions(i3, i10, i4);
 } else if (!((HEAP8[i3 + 25 >> 0] | 0) != 0 & (HEAP8[i5 >> 0] | 0) == 0)) {
  i3 = i9 + 48 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i3 = i9;
  i2 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  i2 = i10 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = i10 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i10 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 + (i3 << 6) >> 2] = i8;
  i3 = i1 + (i3 << 6) + 4 | 0;
  i1 = i9;
  i2 = i3 + 60 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
 }
 STACKTOP = i11;
 return;
}

function __ZN5Unity14CharacterJoint17SetHighTwistLimitERK14SoftJointLimit(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i7 + 128 | 0;
 f2 = Math_fround(HEAPF32[i7 + 116 >> 2]);
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i8 = f2 < Math_fround(-177.0);
 i4 = f2 > Math_fround(177.0);
 f2 = i4 ? Math_fround(177.0) : f2;
 i8 = i8 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = f5 < Math_fround(-177.0);
 i1 = f5 > Math_fround(177.0);
 f5 = i1 ? Math_fround(177.0) : f5;
 f5 = i4 ? Math_fround(-177.0) : f5;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f5 < (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i12 = f3 < Math_fround(0.0);
 i13 = f3 > Math_fround(340282326000000008404918.0e15);
 f5 = i13 ? Math_fround(340282326000000008404918.0e15) : f3;
 f5 = i12 ? Math_fround(0.0) : f5;
 i12 = f6 < Math_fround(0.0);
 i13 = f6 > Math_fround(1.0);
 f6 = i13 ? Math_fround(1.0) : f6;
 f6 = i12 ? Math_fround(0.0) : f6;
 HEAP32[i9 >> 2] = i1 ? i8 : i4;
 i4 = i7 + 132 | 0;
 HEAPF32[i4 >> 2] = f6;
 i8 = i7 + 136 | 0;
 HEAPF32[i8 >> 2] = f5;
 i7 = i7 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i11;
  return;
 }
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0, i10 | 0, i13 | 0);
 i13 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i9 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i1 = i10 + 20 | 0;
 HEAPF32[i1 >> 2] = f3;
 i4 = i10 + 24 | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f6 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i13 = f6 > Math_fround(0.0);
 f2 = i13 ? f2 : Math_fround(-1.0);
 if (f2 == Math_fround(-1.0)) {
  f2 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.49000001));
  i13 = f2 > Math_fround(.100000001);
  f2 = i13 ? Math_fround(.100000001) : f2;
 }
 i13 = f5 > Math_fround(0.0);
 i12 = f2 < Math_fround(.200000003);
 f6 = i12 ? Math_fround(.200000003) : f2;
 HEAPF32[i10 + 16 >> 2] = i13 ? Math_fround(9.99999974e-06) : f6;
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 120 >> 2] | 0, i13 | 0, 3, 1);
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i13 | 0, i10 | 0);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 if (f6 == Math_fround(HEAPF32[i4 >> 2])) {
  i13 = HEAP32[i7 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 120 >> 2] | 0, i13 | 0, 3, 0);
 }
 STACKTOP = i11;
 return;
}

function __ZN5Unity14CharacterJoint16SetLowTwistLimitERK14SoftJointLimit(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i7 + 116 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + 128 >> 2]);
 i8 = f2 < Math_fround(-177.0);
 i5 = f2 > Math_fround(177.0);
 f2 = i5 ? Math_fround(177.0) : f2;
 i5 = i8 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f4 < Math_fround(-177.0);
 i1 = f4 > Math_fround(177.0);
 f4 = i1 ? Math_fround(177.0) : f4;
 f4 = i8 ? Math_fround(-177.0) : f4;
 i8 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f4 < (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i12 = f3 < Math_fround(0.0);
 i13 = f3 > Math_fround(340282326000000008404918.0e15);
 f4 = i13 ? Math_fround(340282326000000008404918.0e15) : f3;
 f4 = i12 ? Math_fround(0.0) : f4;
 i12 = f6 < Math_fround(0.0);
 i13 = f6 > Math_fround(1.0);
 f6 = i13 ? Math_fround(1.0) : f6;
 f6 = i12 ? Math_fround(0.0) : f6;
 HEAP32[i9 >> 2] = i1 ? i8 : i5;
 i5 = i7 + 120 | 0;
 HEAPF32[i5 >> 2] = f6;
 i8 = i7 + 124 | 0;
 HEAPF32[i8 >> 2] = f4;
 i7 = i7 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i11;
  return;
 }
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 152 >> 2] | 0, i10 | 0, i13 | 0);
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i13;
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i9 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i1 = i10 + 24 | 0;
 HEAPF32[i1 >> 2] = f3;
 i5 = i10 + 20 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f6 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i13 = f6 > Math_fround(0.0);
 f2 = i13 ? f2 : Math_fround(-1.0);
 if (f2 == Math_fround(-1.0)) {
  f2 = Math_fround(Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3) * Math_fround(.49000001));
  i13 = f2 > Math_fround(.100000001);
  f2 = i13 ? Math_fround(.100000001) : f2;
 }
 i13 = f4 > Math_fround(0.0);
 i12 = f2 < Math_fround(.200000003);
 f6 = i12 ? Math_fround(.200000003) : f2;
 HEAPF32[i10 + 16 >> 2] = i13 ? Math_fround(9.99999974e-06) : f6;
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 120 >> 2] | 0, i13 | 0, 3, 1);
 i13 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i13 | 0, i10 | 0);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 if (f6 == Math_fround(HEAPF32[i1 >> 2])) {
  i13 = HEAP32[i7 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 120 >> 2] | 0, i13 | 0, 3, 0);
 }
 STACKTOP = i11;
 return;
}

function __ZN14AnimationEventC2ERKS_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i1 = i6 + 4 | 0;
 i3 = i7 + 4 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 16 >> 2] | 0;
  i8 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 6;
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 12 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 8 >> 2] = i4;
  i1 = i2;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = i6 + 20 | 0;
 i3 = i7 + 20 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 24 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 32 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 32 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i10 = i1;
   i10 = i10 + i4 | 0;
   HEAP8[i10 >> 0] = 0;
   i10 = i6 + 36 | 0;
   i8 = i7 + 36 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   STACKTOP = i9;
   return;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i8 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i6 + 28 >> 2] = i8 | -2147483648;
  HEAP32[i6 + 24 >> 2] = i4;
  i1 = i10;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i10 = i1;
 i10 = i10 + i4 | 0;
 HEAP8[i10 >> 0] = 0;
 i10 = i6 + 36 | 0;
 i8 = i7 + 36 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 STACKTOP = i9;
 return;
}

function __Z25Mesh_CUSTOM_CombineMeshesP12Il2CppObjectP11Il2CppArrayhh(i12, i1, i13, i14) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17 + 16 | 0;
 i10 = i17 + 12 | 0;
 i15 = i17;
 HEAP32[i15 >> 2] = 0;
 i16 = i15 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 if (i2 | 0) __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj(i15, i2);
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 72) | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = 0;
  i3 = i1;
  do {
   i4 = i3;
   i1 = i4 + (i7 * 112 | 0) + 12 | 0;
   i5 = i8 + (i7 * 72 | 0) + 8 | 0;
   i6 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
    i1 = i1 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i1 | 0) < (i6 | 0));
   HEAP32[i4 + (i7 * 112 | 0) + 8 >> 2] = HEAP32[i8 + (i7 * 72 | 0) + 4 >> 2];
   i5 = HEAP32[i8 + (i7 * 72 | 0) >> 2] | 0;
   if (!i5) i1 = 0; else {
    HEAP32[i10 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 19; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 19; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 21;
     }
    }
    if ((i11 | 0) == 19) i11 = 21;
    if ((i11 | 0) == 21) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
    i3 = HEAP32[i15 >> 2] | 0;
    i4 = i3;
    i2 = HEAP32[i16 >> 2] | 0;
   }
   HEAP32[i4 + (i7 * 112 | 0) >> 2] = i1;
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < ((i2 - i3 | 0) / 112 | 0) >>> 0);
 }
 if (!i12) {
  i11 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i12) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 __Z13CombineMeshesRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb(i15, i1, i13 << 24 >> 24 != 0, i14 << 24 >> 24 != 0);
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 i2 = HEAP32[i16 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i16 >> 2] = i2 + (~(((i2 + -112 - i1 | 0) >>> 0) / 112 | 0) * 112 | 0);
 __ZdlPv(i1);
 STACKTOP = i17;
 return;
}

function __ZN11Rigidbody2D17UpdateConstraintsEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i9 = i2 + 92 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i6 = i2 + 52 | 0;
 __ZN6b2Body16SetFixedRotationEb(i1, (HEAP32[i6 >> 2] & 4 | 0) != 0);
 i4 = i2 + 96 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  __ZN7b2World12DestroyJointEP7b2Joint(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i1);
  HEAP32[i4 >> 2] = 0;
 }
 i5 = i2 + 100 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  __ZN7b2World12DestroyJointEP7b2Joint(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = 0;
 }
 if (!(__Z14IsWorldPlayingv() | 0)) __ZN16b2ContactManager20FlushPendingContactsEv((HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102872 | 0);
 if (i3) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i2 + 68 >> 2] | 0) == 2) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 & 1) {
  i1 = HEAP32[i9 >> 2] | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  i3 = i7 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i7 >> 2] = 7;
  i3 = i7 + 20 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAPF32[i7 + 36 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 60 >> 2] = Math_fround(.699999988);
  HEAPF32[i7 + 56 >> 2] = Math_fround(0.0);
  HEAP8[i7 + 44 >> 0] = 0;
  HEAP8[i7 + 16 >> 0] = 1;
  __ZN15b2WheelJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_(i7, HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 8 >> 2] | 0, i1, i1 + 44 | 0, i8);
  HEAP32[i4 >> 2] = __ZN7b2World11CreateJointEPK10b2JointDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i7) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (!(i1 & 2)) {
  STACKTOP = i10;
  return;
 }
 i9 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 7;
 i6 = i7 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i7 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 60 >> 2] = Math_fround(.699999988);
 HEAPF32[i7 + 56 >> 2] = Math_fround(0.0);
 HEAP8[i7 + 44 >> 0] = 0;
 HEAP8[i7 + 16 >> 0] = 1;
 __ZN15b2WheelJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_(i7, HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 8 >> 2] | 0, i9, i9 + 44 | 0, i8);
 HEAP32[i5 >> 2] = __ZN7b2World11CreateJointEPK10b2JointDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i7) | 0;
 STACKTOP = i10;
 return;
}

function __ZNK16CompareSceneNameclEPK10UnityScene(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 40 | 0;
 i14 = i15 + 24 | 0;
 i4 = i15 + 12 | 0;
 i5 = i15;
 i10 = i1 + 28 | 0;
 i11 = i10 + 11 | 0;
 i2 = HEAP8[i11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
 } else {
  i3 = i10;
  i1 = i2 & 255;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5);
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 + 12 >> 2] | 0;
  i12 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i14 + 11 >> 0] = i3;
  if (!i3) i1 = i14; else {
   i1 = i14;
   i12 = 9;
  }
 } else i12 = 7;
 if ((i12 | 0) == 7) {
  i8 = i3 + 16 & -16;
  HEAP32[i13 >> 2] = 66;
  HEAP32[i13 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i14 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i14 + 4 >> 2] = i3;
  i12 = 9;
 }
 if ((i12 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i6 = i9 + 16 | 0;
 i2 = HEAP8[i6 + 11 >> 0] | 0;
 i7 = i2 << 24 >> 24 < 0;
 if (i7) i1 = HEAP32[i9 + 20 >> 2] | 0; else i1 = i2 & 255;
 i5 = HEAP8[i9 + 11 >> 0] | 0;
 i8 = i5 << 24 >> 24 < 0;
 if ((i1 | 0) == ((i8 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  i5 = HEAP32[i9 >> 2] | 0;
  if (i7) {
   i3 = HEAP32[i6 >> 2] | 0;
   i4 = i8 ? i5 : i9;
   i1 = HEAP32[i9 + 20 >> 2] | 0;
  } else {
   i3 = i6;
   i4 = i8 ? i5 : i9;
   i1 = i2 & 255;
  }
  if (!(_strncmp(i3, i4, i1) | 0)) {
   i1 = i14 + 11 | 0;
   i2 = i1;
   i1 = __Z7StrICmpPKcS0_((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, i8 ? i5 : i9) | 0;
  } else i12 = 19;
 } else i12 = 19;
 if ((i12 | 0) == 19) {
  i2 = i14 + 11 | 0;
  i1 = __Z7StrICmpPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, i7 ? HEAP32[i6 >> 2] | 0 : i6) | 0;
 }
 i1 = (i1 | 0) == 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i15;
  return i1 | 0;
 }
 i12 = HEAP32[i14 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 66;
 HEAP32[i13 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN24EllipsoidParticleEmitterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i4 + 8 | 0;
 i9 = i4;
 i11 = i2;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i10, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i10 = i1 + 144 | 0;
 i9 = i1 + 156 | 0;
 i8 = i1 + 168 | 0;
 i2 = i1 + 180 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = i1;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 205 >> 0] = 1;
 HEAP8[i1 + 204 >> 0] = 1;
 HEAP8[i1 + 206 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 HEAP8[i1 + 110 >> 0] = 0;
 HEAPF32[i1 + 116 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 120 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 124 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(50.0);
 HEAP8[i1 + 192 >> 0] = 1;
 HEAPF32[i1 + 140 >> 2] = Math_fround(.0500000007);
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 193 >> 0] = 0;
 HEAP8[i1 + 207 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i1 + 84 >> 2] = f7;
 HEAPF32[i1 + 88 >> 2] = f6;
 HEAPF32[i1 + 92 >> 2] = f5;
 HEAP32[i1 >> 2] = gb + 190272 + 8;
 HEAPF32[i1 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 228 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 232 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 32 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i9 = i3 - i4 | 0;
 i3 = i9 >> 4;
 i3 = i9 >> 5 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = 6;
  HEAP32[i14 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 5, 8, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i5 + (i1 - i4 >> 5 << 5) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 5) | 0;
 i1 = i7;
 i8 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  i1 = i8 + 32 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i1 = i6;
  i9 = i4;
  i2 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -32 | 0;
   __ZN16MessageForwarderC2ERKS_(i2 + -32 | 0, i1);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i1 = i3;
  i9 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i5;
 i7 = i9;
 if ((i2 | 0) != (i7 | 0)) {
  i6 = i2;
  do {
   i5 = i6;
   i6 = i6 + -32 | 0;
   i1 = HEAP32[i5 + -20 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) {
    i3 = i5 + -16 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
    __ZdlPv(i1);
   }
   i3 = HEAP32[i6 >> 2] | 0;
   i4 = i3;
   if (i3 | 0) {
    i1 = i5 + -28 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
    __ZdlPv(i3);
   }
  } while ((i6 | 0) != (i7 | 0));
 }
 if (!i9) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = 6;
 HEAP32[i14 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Cct15ObstacleContext14updateObstacleEjRKNS_10PxObstacleE(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i1 = i4 & 65535;
 i2 = HEAP32[i6 + 36 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i7 = HEAP16[(HEAP32[i6 + 40 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 i3 = i7 & 65535;
 if (!(i7 << 16 >> 16 != -1 & i3 >>> 0 < i2 >>> 0)) {
  i7 = 0;
  return i7 | 0;
 }
 if ((HEAPU16[(HEAP32[i6 + 48 >> 2] | 0) + (i1 << 1) >> 1] | 0 | 0) != (i4 >>> 16 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = i1 & 65535;
 if ((i2 + -1 | 0) != (HEAP32[i5 >> 2] | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = i1 >>> 16;
 switch (i2 | 0) {
 case 4:
  {
   if (i1 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
    i7 = 0;
    return i7 | 0;
   }
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i7 + (i1 * 72 | 0) + 8 | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 40 >> 2] = HEAP32[i5 + 32 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 44 >> 2] = HEAP32[i5 + 36 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 48 >> 2] = HEAP32[i5 + 40 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 52 >> 2] = HEAP32[i5 + 44 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 56 >> 2] = HEAP32[i5 + 48 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 60 >> 2] = HEAP32[i5 + 52 >> 2];
   HEAP32[i7 + (i1 * 72 | 0) + 64 >> 2] = HEAP32[i5 + 56 >> 2];
   __ZNK5physx3Cct26CharacterControllerManager17onObstacleUpdatedEjPKNS_17PxObstacleContextE(HEAP32[i6 + 56 >> 2] | 0, i4, i6);
   i7 = 1;
   return i7 | 0;
  }
 case 3:
  {
   if (i1 >>> 0 >= (HEAP32[i6 + 20 >> 2] | 0) >>> 0) {
    i7 = 0;
    return i7 | 0;
   }
   i7 = HEAP32[i6 + 16 >> 2] | 0;
   i3 = i7 + (i1 << 6) + 8 | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
   HEAP32[i7 + (i1 << 6) + 40 >> 2] = HEAP32[i5 + 32 >> 2];
   HEAP32[i7 + (i1 << 6) + 44 >> 2] = HEAP32[i5 + 36 >> 2];
   HEAP32[i7 + (i1 << 6) + 48 >> 2] = HEAP32[i5 + 40 >> 2];
   HEAP32[i7 + (i1 << 6) + 52 >> 2] = HEAP32[i5 + 44 >> 2];
   i3 = i5 + 48 | 0;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i7 + (i1 << 6) + 56 | 0;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i5;
   __ZNK5physx3Cct26CharacterControllerManager17onObstacleUpdatedEjPKNS_17PxObstacleContextE(HEAP32[i6 + 56 >> 2] | 0, i4, i6);
   i7 = 1;
   return i7 | 0;
  }
 default:
  {
   i7 = 0;
   return i7 | 0;
  }
 }
 return 0;
}

function __ZN14RenderSettings17SetSkyboxMaterialEP8Material(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i4 = i9 + 360 | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  if (i1 | 0) {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 9; else if (HEAP32[i1 + 4 >> 2] | 0) {
     __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i9);
     STACKTOP = i11;
     return;
    }
   }
   if (__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0) {
    __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i9);
    STACKTOP = i11;
    return;
   }
  }
 }
 i4 = i9 + 368 | 0;
 if ((HEAP32[i4 >> 2] | 0) == 1) {
  __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i9);
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 384 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 do if (i6 | 0) {
  HEAP32[i8 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 19; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i10 = 21;
  }
  if ((i10 | 0) == 19) i10 = 21;
  if ((i10 | 0) == 21) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) break;
  HEAP32[i5 >> 2] = 0;
 } while (0);
 i10 = HEAP32[gb + 1112272 >> 2] | 0;
 i8 = HEAP32[i9 + 364 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[((HEAP32[i4 >> 2] | 0) == 0 ? i5 : i9 + 380 | 0) >> 2];
 HEAP32[i10 + 4 >> 2] = i8;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i10);
 __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i9);
 STACKTOP = i11;
 return;
}

function __ZN9Texture2D19InitTextureInternalEii13TextureFormatiNS_10EInitFlagsEii(i4, i5, i8, i9, i10, i11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 24 | 0;
 i14 = i17 + 16 | 0;
 i15 = i17;
 i6 = i17 + 8 | 0;
 i7 = i4 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (!(i11 & 8)) {
  if (!i2) {
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   if (!(HEAP32[i3 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
   }
   HEAP32[i7 >> 2] = 0;
  }
  __ZN9Texture2D16DeleteGfxTextureEv(i4);
 } else if (!i2) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
  }
  HEAP32[i7 >> 2] = 0;
 }
 i18 = (i11 & 1 | 0) != 0;
 HEAP32[i4 + 80 >> 2] = 2;
 HEAP32[i4 + 104 >> 2] = i11;
 HEAP32[i4 + 84 >> 2] = i5;
 HEAP32[i4 + 88 >> 2] = i8;
 HEAP32[i4 + 92 >> 2] = i9;
 i1 = i4 + 96 | 0;
 HEAP32[i1 >> 2] = __Z25GetNextAllowedTextureSizeib13TextureFormat(i5, i18, i9) | 0;
 i18 = __Z25GetNextAllowedTextureSizeib13TextureFormat(i8, i18, i9) | 0;
 i2 = i4 + 100 | 0;
 HEAP32[i2 >> 2] = i18;
 i3 = i4 + 76 | 0;
 HEAP32[i3 >> 2] = 1;
 i18 = (i13 | 0) < 1 | (__Z22CalculateMipMapCount3Diii(HEAP32[i1 >> 2] | 0, i18, 1) | 0) < (i13 | 0);
 HEAP32[i3 >> 2] = i18 ? 1 : i13;
 if (!(i11 & 16)) {
  __ZNK6Object14GetMemoryLabelEv(i16, i4);
  if ((HEAP32[i16 >> 2] | 0) == 22) __ZNK6Object14GetMemoryLabelEv(i15, i4); else {
   __ZNK6Object14GetMemoryLabelEv(i14, i4);
   i18 = HEAP32[i14 + 4 >> 2] | 0;
   HEAP32[i15 >> 2] = 19;
   HEAP32[i15 + 4 >> 2] = i18;
  }
  i18 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 428) | 0;
  i13 = i15;
  i14 = HEAP32[i13 + 4 >> 2] | 0;
  i15 = i6;
  HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i15 + 4 >> 2] = i14;
  i15 = HEAP32[i3 >> 2] | 0;
  HEAP32[i16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i18, i16, i5, i8, i9, i10, i12, i15, (i11 & 4 | 0) == 0, 1);
  HEAP32[i7 >> 2] = i18;
 }
 f20 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i1 >> 2] | 0));
 f19 = Math_fround(Math_fround(1.0) / Math_fround(HEAP32[i2 >> 2] | 0));
 HEAPF32[i4 + 68 >> 2] = f20;
 HEAPF32[i4 + 72 >> 2] = f19;
 i18 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if (i18 + -1 & i18 | 0) {
  i16 = 0;
  i18 = i4 + 108 | 0;
  HEAP8[i18 >> 0] = i16;
  STACKTOP = i17;
  return;
 }
 i16 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0) | 0;
 i16 = (i16 + -1 & i16 | 0) == 0 & 1;
 i18 = i4 + 108 | 0;
 HEAP8[i18 >> 0] = i16;
 STACKTOP = i17;
 return;
}

function __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai(i26, i1, i14) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i27 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i27 + 288 | 0;
 i3 = i27 + 280 | 0;
 i8 = i27;
 _memcpy(i8 | 0, i1 | 0, 280) | 0;
 i23 = HEAP32[i1 + 280 >> 2] | 0;
 i24 = HEAP32[i1 + 284 >> 2] | 0;
 i25 = HEAP32[i1 + 288 >> 2] | 0;
 i9 = HEAP32[i1 + 292 >> 2] | 0;
 i10 = HEAP32[i1 + 296 >> 2] | 0;
 i11 = HEAP32[i1 + 300 >> 2] | 0;
 i12 = HEAP32[i1 + 304 >> 2] | 0;
 i13 = HEAP32[i1 + 308 >> 2] | 0;
 i15 = HEAP32[i1 + 312 >> 2] | 0;
 i16 = HEAP32[i1 + 316 >> 2] | 0;
 i17 = HEAP32[i1 + 320 >> 2] | 0;
 i18 = HEAP32[i1 + 324 >> 2] | 0;
 i19 = HEAP32[i1 + 328 >> 2] | 0;
 i20 = HEAP32[i1 + 332 >> 2] | 0;
 i21 = HEAP32[i1 + 336 >> 2] | 0;
 i22 = HEAP32[i1 + 340 >> 2] | 0;
 i7 = HEAP32[i1 + 344 >> 2] | 0;
 i2 = i26 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i5 = i2;
  HEAP32[i3 >> 2] = i5;
  i3 = i2;
  i2 = i5;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i14 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i14 | 0)) {
     i5 = 9;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i5 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 4) {
   i2 = i1;
   HEAP32[i3 >> 2] = i2;
   i3 = i1;
   break;
  } else if ((i5 | 0) == 8) {
   i2 = i1;
   HEAP32[i3 >> 2] = i2;
   i3 = i4;
   break;
  } else if ((i5 | 0) == 9) {
   i2 = i1;
   HEAP32[i3 >> 2] = i2;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i27;
  return;
 }
 i1 = HEAP32[i26 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 64;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(368, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i1 + 16 >> 2] = i14;
 _memcpy(i1 + 20 | 0, i8 | 0, 280) | 0;
 HEAP32[i1 + 300 >> 2] = i23;
 HEAP32[i1 + 304 >> 2] = i24;
 HEAP32[i1 + 308 >> 2] = i25;
 HEAP32[i1 + 312 >> 2] = i9;
 HEAP32[i1 + 316 >> 2] = i10;
 HEAP32[i1 + 320 >> 2] = i11;
 HEAP32[i1 + 324 >> 2] = i12;
 HEAP32[i1 + 328 >> 2] = i13;
 HEAP32[i1 + 332 >> 2] = i15;
 HEAP32[i1 + 336 >> 2] = i16;
 HEAP32[i1 + 340 >> 2] = i17;
 HEAP32[i1 + 344 >> 2] = i18;
 HEAP32[i1 + 348 >> 2] = i19;
 HEAP32[i1 + 352 >> 2] = i20;
 HEAP32[i1 + 356 >> 2] = i21;
 HEAP32[i1 + 360 >> 2] = i22;
 HEAP32[i1 + 364 >> 2] = i7;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i26 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i26 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i26 + 4 >> 2] | 0, i1);
 i26 = i26 + 12 | 0;
 HEAP32[i26 >> 2] = (HEAP32[i26 >> 2] | 0) + 1;
 STACKTOP = i27;
 return;
}

function __ZN7mecanim8skeleton20SkeletonNodeEndPointEPKNS0_8SkeletonEiPKNS0_13SkeletonPoseTIN4math4trsXEEE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i4 = i4 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i2 = i2 + 16 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 f10 = Math_fround(HEAPF32[i2 + (i3 * 76 | 0) + 28 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + (i3 * 76 | 0) + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + (i3 * 76 | 0) + 20 >> 2]);
 f14 = Math_fround(f10 * f5);
 f17 = Math_fround(HEAPF32[i2 + (i3 * 76 | 0) + 24 >> 2]);
 f13 = Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f10 * f10) + Math_fround(-.5)));
 f10 = Math_fround(Math_fround(f9 * f5) + Math_fround(f10 * f17));
 f14 = Math_fround(Math_fround(f9 * f17) - f14);
 f13 = Math_fround(f13 + f13);
 f10 = Math_fround(f10 + f10);
 f14 = Math_fround(f14 + f14);
 f17 = Math_fround(HEAPF32[i2 + (i3 * 76 | 0) + 68 >> 2]);
 f13 = Math_fround(f13 * f17);
 f10 = Math_fround(f17 * f10);
 f14 = Math_fround(f17 * f14);
 f17 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 28 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 32 >> 2]);
 f17 = Math_fround(f13 * f17);
 f10 = Math_fround(f9 * f10);
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 36 >> 2]));
 f9 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 24 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 20 >> 2]);
 f19 = Math_fround(f9 * Math_fround(-2.0));
 f11 = Math_fround(f9 * Math_fround(2.0));
 f16 = Math_fround(f19 * f5);
 f8 = Math_fround(f18 * Math_fround(2.0));
 f15 = Math_fround(f18 * Math_fround(-2.0));
 f20 = Math_fround(f5 * f15);
 f12 = Math_fround(f13 * Math_fround(-2.0));
 f6 = Math_fround(f13 * Math_fround(2.0));
 f5 = Math_fround(f5 * f12);
 f7 = Math_fround(Math_fround(f17 + Math_fround(f17 * Math_fround(Math_fround(f9 * f19) - Math_fround(f18 * f8)))) + Math_fround(Math_fround(f14 * Math_fround(Math_fround(f6 * f18) - f16)) + Math_fround(f10 * Math_fround(f20 - Math_fround(f9 * f12)))));
 f6 = Math_fround(Math_fround(f10 + Math_fround(f17 * Math_fround(Math_fround(f13 * f11) - f20))) + Math_fround(Math_fround(f14 * Math_fround(f5 - Math_fround(f19 * f18))) + Math_fround(f10 * Math_fround(Math_fround(f18 * f15) - Math_fround(f13 * f6)))));
 f5 = Math_fround(Math_fround(f14 + Math_fround(f17 * Math_fround(f16 - Math_fround(f13 * f15)))) + Math_fround(Math_fround(f14 * Math_fround(Math_fround(f13 * f12) - Math_fround(f9 * f11))) + Math_fround(f10 * Math_fround(Math_fround(f9 * f8) - f5))));
 f8 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 4 >> 2]);
 f6 = Math_fround(f9 + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i4 + (i3 * 40 | 0) + 8 >> 2]) + f5);
 HEAPF32[i1 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 return;
}

function __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i2, i5, i13, i14, i15, i6, i7, i4, i16, i20) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 var i1 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i22 + 12 | 0;
 i18 = i22 + 8 | 0;
 i19 = i22 + 4 | 0;
 i12 = i22;
 i3 = (i4 | 0) > -1;
 if (i3) {
  i1 = HEAP32[i2 + 80 >> 2] | 0;
  i1 = HEAP32[i1 + (i4 * 52 | 0) + 24 >> 2] << 16 | HEAP32[i1 + (i4 * 52 | 0) >> 2];
 } else i1 = 0;
 if (__ZN25BuiltinShaderParamIndices16CheckMatrixParamEPKciiiib(i2 + 124 | 0, i5, i13, i6, i7, i1, (i16 & 2) != 0) | 0) {
  STACKTOP = i22;
  return;
 }
 if (i3) i11 = (HEAP32[i2 + 80 >> 2] | 0) + (i4 * 52 | 0) + 4 | 0; else i11 = i2 + 16 | 0;
 HEAP32[i12 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i12, i5);
 i10 = HEAP32[i12 >> 2] | 0;
 i9 = i6 & 255;
 i2 = i7 & 255;
 i3 = i11 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 + (i4 * 20 | 0) >> 2] = i10;
 HEAP32[i11 + (i4 * 20 | 0) + 4 >> 2] = i13;
 HEAP32[i11 + (i4 * 20 | 0) + 8 >> 2] = i14;
 HEAP32[i11 + (i4 * 20 | 0) + 12 >> 2] = i15;
 HEAP8[i11 + (i4 * 20 | 0) + 16 >> 0] = i9;
 HEAP8[i11 + (i4 * 20 | 0) + 17 >> 0] = i2;
 HEAP8[i11 + (i4 * 20 | 0) + 18 >> 0] = i16;
 if (i20 | 0) {
  i6 = HEAP32[i12 >> 2] | 0;
  if (!((i6 | 0) != -1 & i6 >>> 0 > 1073741823)) {
   HEAP32[i19 >> 2] = i6;
   i2 = HEAP32[i20 >> 2] | 0;
   i7 = HEAP32[i20 + 4 >> 2] | 0;
   i1 = i7 - i2 >> 2;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i16 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i16 << 2) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
     i4 = i4 + 4 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i16 | 0 : i16;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   i2 = i1;
   if ((i1 | 0) == (i7 | 0)) i21 = 17; else if ((HEAP32[i1 >> 2] | 0) > (i6 | 0)) i21 = 17;
   if ((i21 | 0) == 17) {
    HEAP32[i18 >> 2] = i2;
    HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
    __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i20, i17, i19) | 0;
   }
  }
 }
 STACKTOP = i22;
 return;
}

function __ZN24CompressedAnimationCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i6 = i12 + 72 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i12 + 76 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i13 = i10 + 16 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i9, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i10);
 i1 = i12 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i3;
  i8 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i8 = HEAP32[i13 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i2 = i12 + 24 | 0;
 i7 = i12 + 28 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = i3 - i1 | 0;
 HEAP32[i9 >> 2] = i5;
 i6 = i8 + 4 | 0;
 if (i6 >>> 0 < i4 >>> 0) {
  HEAP32[i8 >> 2] = i5;
  HEAP32[i13 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i9, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12 + 36 | 0, i10);
 i1 = i12 + 64 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  i4 = HEAP32[i13 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i12 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i13 >> 2] = i2;
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 88 | 0;
 i7 = i9 + 120 | 0;
 i6 = i9;
 i8 = i9 + 56 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 1, i10 + 12 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 2, i10 + 36 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 mftCall_vii(i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxPrismaticJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 440 | 0;
 i13 = i11 + 492 | 0;
 i14 = i11 + 388 | 0;
 i21 = i11;
 i6 = i11 + 384 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxPrismaticJointGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx2GuL35fullContactsGenerationCapsuleConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVESE_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb(i8, i1, i4, i12, i13, i2, i7, i9, i3, i10, i11, i5, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i14 + 64 | 0;
 i15 = i14;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i1, i3, i16);
 HEAP32[i15 + 32 >> 2] = i13;
 HEAP32[i15 + 36 >> 2] = i1 + 96;
 HEAP32[i15 + 40 >> 2] = i1 + 144;
 HEAP8[i15 + 44 >> 0] = i3 & 1;
 HEAP32[i15 >> 2] = i3 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i15 + 48 >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!(__ZN5physx2Gu27generateFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb(i8, i16, i15, i4, i2, i7, i5, i11, i6) | 0)) {
  i16 = 0;
  STACKTOP = i14;
  return i16 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 | 0) != (i3 | 0)) {
  i1 = i1 + -1 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i2 + 48 | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold25addBatchManifoldContacts2EPKNS0_17PersistentContactEj(i10, i2, i1);
 f27 = Math_fround(HEAPF32[i13 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f25 = Math_fround(HEAPF32[i11 >> 2]);
 i15 = i11 + 4 | 0;
 f19 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i11 + 8 | 0;
 f21 = Math_fround(HEAPF32[i16 >> 2]);
 f24 = Math_fround(Math_fround(f23 * f23) + Math_fround(-.5));
 f26 = Math_fround(Math_fround(Math_fround(f27 * f25) + Math_fround(f22 * f19)) + Math_fround(f20 * f21));
 f18 = Math_fround(Math_fround(Math_fround(f22 * f26) + Math_fround(Math_fround(f24 * f19) + Math_fround(f23 * Math_fround(Math_fround(f20 * f25) - Math_fround(f27 * f21))))) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * Math_fround(Math_fround(f27 * f19) - Math_fround(f22 * f25)))) + Math_fround(f20 * f26)) * Math_fround(2.0));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(Math_fround(f27 * f26) + Math_fround(Math_fround(f25 * f24) + Math_fround(f23 * Math_fround(Math_fround(f22 * f21) - Math_fround(f20 * f19))))) * Math_fround(2.0));
 HEAPF32[i15 >> 2] = f18;
 HEAPF32[i16 >> 2] = f17;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE(i10, i9, i11, i12, i8 + 128 | 0);
 i16 = 1;
 STACKTOP = i14;
 return i16 | 0;
}

function __Z24CollectLevelGameManagersR13dynamic_arrayIiLj4EEb(i12, i3) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1104712 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104712 | 0, i1);
  i8 = gb + 1104712 | 0;
 } else i8 = 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 16 | 0;
 i11 = i12 + 4 | 0;
 if (i3) {
  i7 = 0;
  do {
   i1 = HEAP32[gb + 1104348 + (i7 << 2) >> 2] | 0;
   if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28456 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28456 + 28 >> 2] | 0) >>> 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0) | 0) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i9 >> 2] = i4;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 28);
 } else {
  i7 = 0;
  do {
   i1 = HEAP32[gb + 1104348 + (i7 << 2) >> 2] | 0;
   if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28456 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28456 + 28 >> 2] | 0) >>> 0) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i9 >> 2] = i4;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 28);
 }
 if (!i8) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i13;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 52 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 58 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 56 | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 68 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 72 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 76 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 84 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 48 | 0, i6);
 i1 = i5 + 80 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 88 | 0;
 i7 = i9 + 120 | 0;
 i6 = i9;
 i8 = i9 + 56 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 1, i10 + 12 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 2, i10 + 36 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 mftCall_vii(i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 88 | 0;
 i7 = i9 + 120 | 0;
 i6 = i9;
 i8 = i9 + 56 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 1, i10 + 12 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 2, i10 + 36 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 mftCall_vii(i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 88 | 0;
 i7 = i9 + 120 | 0;
 i6 = i9;
 i8 = i9 + 56 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 1, i10 + 12 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i6, 2, i10 + 36 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 mftCall_vii(i14 | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_16PxParticleSystemEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 464 | 0;
 i14 = i11 + 412 | 0;
 i13 = i11 + 516 | 0;
 i21 = i11;
 i6 = i11 + 408 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxParticleSystemGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i5 = i20 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i3;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i4;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 i5 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i18 = i14 + 8 | 0;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i4;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j(i15, i14, i5) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 20 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 28 | 0;
  i5 = i6 + 24 | 0;
  i6 = i7 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = i8 + 8 | 0;
  HEAP32[i9 >> 2] = i6;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 28 | 0;
  i5 = i6 + 24 | 0;
  i6 = i7 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = i8 + 8 | 0;
  HEAP32[i9 >> 2] = i6;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN5Umbra12QueryContext14visualizeTilesEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 1696 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 48 | 0;
 i18 = i20 + 16 | 0;
 i19 = i20;
 i5 = HEAP32[i16 >> 2] | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i15 + 48 >> 2] | 0;
 i9 = (HEAP32[i15 + 44 >> 2] | 0) >>> 5;
 i1 = i15 + i4 | 0;
 i10 = HEAP32[i15 + 60 >> 2] | 0;
 i11 = ((i9 << 1) + 31 | 0) >>> 5;
 i12 = i17 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i17 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i17 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i2 = i17 + 1636 | 0;
 i3 = i17 + 36 | 0;
 do {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i3 + 12 >> 2] = -1;
  HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
  i3 = i3 + 40 | 0;
 } while ((i3 | 0) != (i2 | 0));
 i8 = (i4 | 0) == 0 ? 0 : i1;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i5 = HEAP32[i6 + 36 >> 2] | 0;
 i6 = HEAP32[i6 + 40 >> 2] | 0;
 i7 = i17 + 32 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i17 + 12 >> 2] = i8 + (i11 << 2);
 HEAP32[i14 >> 2] = i15;
 HEAP32[i17 + 20 >> 2] = i10;
 HEAP32[i17 + 24 >> 2] = 4;
 HEAP32[i17 + 28 >> 2] = i9;
 if (i9 | 0) {
  i15 = HEAP32[i8 >> 2] & 3;
  HEAP32[i17 + 36 >> 2] = i1;
  HEAP32[i17 + 40 >> 2] = i2;
  HEAP32[i17 + 44 >> 2] = i3;
  HEAP32[i17 + 48 >> 2] = 0;
  HEAP32[i17 + 52 >> 2] = i4;
  HEAP32[i17 + 56 >> 2] = i5;
  HEAP32[i17 + 60 >> 2] = i6;
  HEAP8[i17 + 64 >> 0] = 0;
  HEAP8[i17 + 65 >> 0] = i15;
  HEAP8[i17 + 66 >> 0] = 63;
  HEAP8[i17 + 67 >> 0] = 0;
  HEAP32[i7 >> 2] = 0;
 }
 HEAP8[i17 + 1636 >> 0] = 1;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i18 + 12 >> 2] = -1;
 HEAPF32[i18 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 24 >> 2] = Math_fround(0.0);
 if (!(__ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE(i17, i18) | 0)) {
  STACKTOP = i20;
  return;
 }
 i1 = i19 + 4 | 0;
 i2 = i19 + 8 | 0;
 i3 = i19 + 12 | 0;
 i4 = i18 + 16 | 0;
 do {
  HEAPF32[i19 >> 2] = Math_fround(1.0);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  i5 = HEAP32[(HEAP32[i16 >> 2] | 0) + 32 >> 2] | 0;
  if (i5 | 0) mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i18 | 0, i4 | 0, i19 | 0);
 } while (__ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE(i17, i18) | 0);
 STACKTOP = i20;
 return;
}

function __ZN9Rigidbody8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 68 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i6 + 83 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 84 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 102 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 158 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 116 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 120 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 124 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 157 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 128 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 132 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 136 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 156 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i8 = i6 + 96 | 0;
  __ZN11JointLimits8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i8 = i6 + 96 | 0;
  __ZN11JointLimits8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __ZN12HeaderHelper21ParseAndSetAllHeadersEPKcj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i11 = i12;
 if (!i1) {
  STACKTOP = i12;
  return 0;
 }
 while (1) {
  L6 : while (1) {
   i4 = i2;
   i3 = i2;
   L8 : while (1) {
    i5 = i3;
    if ((i5 - i4 | 0) >>> 0 >= i1 >>> 0) {
     i6 = i2;
     break L6;
    }
    if ((HEAP8[i3 >> 0] | 0) == 58) {
     i6 = i2;
     break L6;
    }
    i3 = i3 + 1 | 0;
    switch (HEAP8[i3 >> 0] | 0) {
    case 10:
    case 13:
     break L8;
    default:
     {}
    }
   }
   i1 = i1 + i4 - i3 | 0;
   i2 = i3;
  }
  L13 : while (1) {
   switch (HEAP8[i6 >> 0] | 0) {
   case 10:
   case 13:
    break;
   default:
    break L13;
   }
   i1 = i1 + -1 | 0;
   i6 = i6 + 1 | 0;
  }
  i8 = i6;
  i7 = i5 - i8 | 0;
  if (i7 >>> 0 < i1 >>> 0) {
   i2 = i3;
   i4 = i5;
  } else {
   i5 = 23;
   break;
  }
  L17 : do {
   switch (HEAP8[i2 >> 0] | 0) {
   case 10:
   case 13:
    break L17;
   default:
    {}
   }
   i2 = i2 + 1 | 0;
   i4 = i2;
  } while ((i4 - i8 | 0) >>> 0 < i1 >>> 0);
  while (1) {
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i2 >>> 0) {
    i5 = 17;
    break;
   }
   if (!(_isspace(HEAP8[i3 >> 0] | 0) | 0)) {
    i5 = 18;
    break;
   }
  }
  if ((i5 | 0) == 17) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i6, i7);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, gb + 1576256 | 0, 0);
   __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i9, i10, i11, 1) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  } else if ((i5 | 0) == 18) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i6, i7);
   HEAP32[i11 >> 2] = 0;
   HEAP32[i11 + 4 >> 2] = 0;
   HEAP32[i11 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i3, i4 - i3 | 0);
   __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i9, i10, i11, 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  }
  i3 = i2 - i8 | 0;
  L28 : do if (i1 >>> 0 > i3 >>> 0) while (1) {
   switch (HEAP8[i2 >> 0] | 0) {
   case 10:
   case 13:
    break;
   default:
    break L28;
   }
   i2 = i2 + 1 | 0;
   i3 = i2 - i8 | 0;
   if (i1 >>> 0 <= i3 >>> 0) break L28;
  } while (0);
  i1 = i1 - i3 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  if (!i1) {
   i5 = 23;
   break;
  }
 }
 if ((i5 | 0) == 23) {
  STACKTOP = i12;
  return 0;
 }
 return 0;
}

function __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 40 | 0;
 i5 = i14 + 36 | 0;
 i10 = i14 + 16 | 0;
 i11 = i14 + 32 | 0;
 i12 = i14 + 12 | 0;
 i2 = i14 + 8 | 0;
 i3 = i14;
 i4 = i14 + 4 | 0;
 i13 = i7 + 4 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i1 = ((HEAP32[i13 >> 2] | 0) - i9 | 0) / 84 | 0;
 if (i1 >>> 0 >= i8 >>> 0) {
  if (i1 >>> 0 <= i8 >>> 0) {
   STACKTOP = i14;
   return;
  }
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i9 + (i8 * 84 | 0);
  HEAP32[i4 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEEC2INS_11__wrap_iterIPS1_EEEET_SA_RKS4_PNS_9enable_ifIXaasr21__is_forward_iteratorISA_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeE(i10, i5, i6, i4, 0);
  i12 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i12;
  i12 = i10 + 4 | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i11;
  i11 = i10 + 8 | 0;
  i13 = i7 + 8 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i12;
  __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i10);
  STACKTOP = i14;
  return;
 }
 i1 = i7 + 8 | 0;
 if ((((HEAP32[i1 >> 2] | 0) - i9 | 0) / 84 | 0 | 0) == (i8 | 0)) {
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6resizeEj(i7, i8);
  STACKTOP = i14;
  return;
 } else {
  i4 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  i9 = i10 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = i4;
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i10, i8);
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i10, i5, i6);
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6resizeEj(i10, i8);
  i12 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i12;
  i12 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i12;
  i12 = i10 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i13;
  __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i10);
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx2Sn17readAllPropertiesINS_15PxRevoluteJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 488 | 0;
 i13 = i11 + 540 | 0;
 i14 = i11 + 436 | 0;
 i21 = i11;
 i6 = i11 + 432 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx28PxRevoluteJointGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_15PxDistanceJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 460 | 0;
 i13 = i11 + 512 | 0;
 i14 = i11 + 408 | 0;
 i21 = i11;
 i6 = i11 + 404 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx28PxDistanceJointGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN19ShaderPropertySheet5ClearEb(i1, 1);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (i2) {
  __ZN19ShaderPropertySheet20ReservePropertyCountEj(i1, 4);
  __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i1, gb + 1170752 | 0, Math_fround(0.0), 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170688 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170692 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170712 | 0, i3, 0);
  STACKTOP = i4;
  return;
 } else {
  __ZN19ShaderPropertySheet20ReservePropertyCountEj(i1, 16);
  __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i1, gb + 1170752 | 0, Math_fround(0.0), 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170688 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170692 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170696 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170700 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170704 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170708 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170712 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170716 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170720 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170724 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170728 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170732 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170736 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170740 | 0, i3, 0);
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170744 | 0, i3, 0);
  STACKTOP = i4;
  return;
 }
}

function __ZN12NavMeshAgent26ActivateCurrentOffMeshLinkEb(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i3 = i9;
 if ((HEAP32[i6 + 68 >> 2] | 0) == -1) {
  STACKTOP = i9;
  return;
 }
 i1 = i6 + 68 | 0;
 if ((HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 601 >> 0] | 0) != 2) {
  STACKTOP = i9;
  return;
 }
 if (i7) i5 = i6 + 72 | 0; else {
  i10 = (__ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 40 | 0;
  i5 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = i6 + 80 | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0;
  i5 = i6 + 72 | 0;
  __ZNK9dtNavMesh26getOffMeshConnectionUserIdEyPj(i1, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i5) | 0;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 do if (!i4) i8 = 19; else {
  HEAP32[i3 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 12; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 14;
   }
  }
  if ((i8 | 0) == 12) i8 = 14;
  if ((i8 | 0) == 14) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) {
    i8 = 19;
    break;
   }
  }
  if ((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 169336 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 169336 + 28 >> 2] | 0) >>> 0) i8 = 19; else {
   i2 = i1 + 99 | 0;
   if ((HEAPU8[i2 >> 0] | 0) != (i7 & 1 | 0)) {
    HEAP8[i2 >> 0] = i7 & 1;
    i1 = i1 + 40 | 0;
    i10 = i1;
    if (!((HEAP32[i10 >> 2] | 0) == 0 & (HEAP32[i10 + 4 >> 2] | 0) == 0)) {
     i4 = __Z17GetNavMeshManagerv() | 0;
     i10 = i1;
     __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb(i4, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, (HEAP8[i2 >> 0] | 0) != 0);
    }
   }
  }
 } while (0);
 if ((i8 | 0) == 19) {
  i8 = __Z17GetNavMeshManagerv() | 0;
  i10 = i6 + 80 | 0;
  __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb(i8, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, i7);
 }
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 i10 = i6 + 80 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i7 = i6 + 11 | 0;
 i4 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = (HEAP32[gb + 1166564 >> 2] | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i10 = 8; else {
  i2 = i5;
  i3 = i1;
  L2 : while (1) {
   i1 = i3;
   while (1) {
    if ((__Z7StrICmpPKcS0_(HEAP32[i1 + 16 >> 2] | 0, i4) | 0) >= 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    i2 = i1;
    break;
   } else i2 = i1;
  }
  if ((i2 | 0) == (i5 | 0)) i10 = 8; else if ((__Z7StrICmpPKcS0_(i4, HEAP32[i2 + 16 >> 2] | 0) | 0) < 0) i10 = 8;
 }
 if ((i10 | 0) == 8) i2 = i5;
 i1 = HEAP32[gb + 1166564 >> 2] | 0;
 if ((i2 | 0) != (i1 + 4 | 0)) {
  i11 = HEAP32[i2 + 20 >> 2] | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = HEAP8[i7 >> 0] | 0;
 i5 = (i5 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255) + 1 | 0;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 63280 | 0, 0, gb + 479994 | 0, 74) | 0;
 _memcpy(i8 | 0, ((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0, i5 | 0) | 0;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1166404 >> 2] | 0, 0, 0) | 0;
 i7 = HEAP32[gb + 1166564 >> 2] | 0;
 i5 = i8;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((__Z7StrICmpPKcS0_(i8, HEAP32[i2 >> 2] | 0) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i10 = 14;
     break;
    } else i1 = i2;
   } else {
    if ((__Z7StrICmpPKcS0_(HEAP32[i2 >> 2] | 0, i8) | 0) >= 0) {
     i10 = 19;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i10 = 18;
     break;
    } else i1 = i2;
   }
  }
  if ((i10 | 0) == 14) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i10 | 0) == 18) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i10 | 0) == 19) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i11;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  HEAP32[i1 + 16 >> 2] = i5;
  HEAP32[i1 + 20 >> 2] = i9;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i11 = i7 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 63280 | 0);
 if (!i6) {
  i11 = i9;
  STACKTOP = i12;
  return i11 | 0;
 }
 __Z19pop_allocation_rootv();
 i11 = i9;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i11 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 4 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = i3;
 if (((i2 - i3 | 0) / 112 | 0) >>> 0 >= i8 >>> 0) {
  i1 = i8;
  i2 = i6;
  while (1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAPF32[i2 + 76 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 80 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 84 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 88 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 92 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 96 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 100 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 104 >> 2] = Math_fround(0.0);
   HEAP32[i2 + 108 >> 2] = 0;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 112 | 0;
  }
  HEAP32[i13 >> 2] = i6 + (i8 * 112 | 0);
  return;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = ((i3 - i1 | 0) / 112 | 0) + i8 | 0;
 if (i5 >>> 0 > 38347922) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i13 >> 2] | 0;
  i7 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = i1;
 } else {
  i7 = i1;
  i4 = i3;
  i1 = i6;
 }
 i10 = i7;
 i9 = (i2 - i7 | 0) / 112 | 0;
 i2 = i9 << 1;
 i2 = i9 >>> 0 < 19173961 ? (i2 >>> 0 < i5 >>> 0 ? i5 : i2) : 38347922;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 * 112 | 0) | 0;
 i5 = i3 + (((i4 - i7 | 0) / 112 | 0) * 112 | 0) | 0;
 i4 = i3 + (i2 * 112 | 0) | 0;
 i2 = i8;
 i3 = i5;
 while (1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAPF32[i3 + 76 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 80 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 84 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 88 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 92 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 96 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 100 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 104 >> 2] = Math_fround(0.0);
  HEAP32[i3 + 108 >> 2] = 0;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 112 | 0;
 }
 i2 = i5;
 i9 = i5 + (i8 * 112 | 0) | 0;
 if ((i1 | 0) != (i10 | 0)) {
  do {
   i3 = i1;
   i1 = i1 + -112 | 0;
   i6 = i5 + -112 | 0;
   i7 = i1;
   i8 = i6 + 76 | 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
    i6 = i6 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i6 | 0) < (i8 | 0));
   HEAP32[i5 + -36 >> 2] = HEAP32[i3 + -36 >> 2];
   HEAP32[i5 + -32 >> 2] = HEAP32[i3 + -32 >> 2];
   HEAP32[i5 + -28 >> 2] = HEAP32[i3 + -28 >> 2];
   HEAP32[i5 + -24 >> 2] = HEAP32[i3 + -24 >> 2];
   HEAP32[i5 + -20 >> 2] = HEAP32[i3 + -20 >> 2];
   HEAP32[i5 + -16 >> 2] = HEAP32[i3 + -16 >> 2];
   HEAP32[i5 + -12 >> 2] = HEAP32[i3 + -12 >> 2];
   HEAP32[i5 + -8 >> 2] = HEAP32[i3 + -8 >> 2];
   HEAP32[i5 + -4 >> 2] = HEAP32[i3 + -4 >> 2];
   i5 = i2 + -112 | 0;
   i2 = i5;
  } while ((i1 | 0) != (i10 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i12 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9Rigidbody12MoveRotationERK11Quaternionf(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 28 | 0;
 i12 = i16;
 i13 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i14 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 8 | 0;
 i15 = HEAP32[i7 >> 2] | 0;
 i8 = i1 + 12 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i13 & 2139095040) >>> 0 < 2139095040) {
  f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if ((i14 & 2139095040) >>> 0 < 2139095040) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i15 & 2139095040) >>> 0 < 2139095040) {
    f5 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if ((i10 & 2139095040) >>> 0 < 2139095040) if (Math_fround(Math_abs(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(f4 * f4)) + Math_fround(f5 * f5)))) + Math_fround(-1.0)))) < Math_fround(.00999999977)) {
     if (!(HEAP8[i9 + 84 >> 0] | 0)) {
      i15 = HEAP32[i9 + 52 >> 2] | 0;
      i9 = HEAP32[i15 >> 2] | 0;
      i14 = HEAP32[i9 + 88 >> 2] | 0;
      mftCall_vii(HEAP32[i9 + 84 >> 2] | 0, i12 | 0, i15 | 0);
      i9 = HEAP32[i6 >> 2] | 0;
      i10 = HEAP32[i7 >> 2] | 0;
      i13 = HEAP32[i8 >> 2] | 0;
      HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
      HEAP32[i11 + 4 >> 2] = i9;
      HEAP32[i11 + 8 >> 2] = i10;
      HEAP32[i11 + 12 >> 2] = i13;
      HEAP32[i11 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
      HEAP32[i11 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
      HEAP32[i11 + 24 >> 2] = HEAP32[i12 + 24 >> 2];
      mftCall_viii(i14 | 0, i15 | 0, i11 | 0, 1);
      STACKTOP = i16;
      return;
     }
     if (HEAP8[i9 + 80 >> 0] | 0) {
      i1 = i9 + 52 | 0;
      i8 = HEAP32[i1 >> 2] | 0;
      if (!(mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 228 >> 2] | 0, i8 | 0, i12 | 0) | 0)) {
       i7 = HEAP32[i1 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i11 | 0, i7 | 0);
       i7 = HEAP32[i11 + 20 >> 2] | 0;
       i8 = HEAP32[i11 + 24 >> 2] | 0;
       HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
       HEAP32[i12 + 20 >> 2] = i7;
       HEAP32[i12 + 24 >> 2] = i8;
      }
      HEAP32[i12 >> 2] = i13;
      HEAP32[i12 + 4 >> 2] = i14;
      HEAP32[i12 + 8 >> 2] = i15;
      HEAP32[i12 + 12 >> 2] = i10;
      i15 = HEAP32[i1 >> 2] | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 224 >> 2] | 0, i15 | 0, i12 | 0);
     }
     i15 = i9 + 104 | 0;
     HEAP32[i15 >> 2] = HEAP32[i15 >> 2] & -2;
     STACKTOP = i16;
     return;
    }
   }
  }
 }
 if (!i9) i1 = 0; else i1 = HEAP32[i9 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 781850 | 0, 0, gb + 732812 | 0, 1400, 1, i1, 0, 0);
 STACKTOP = i16;
 return;
}

function __Z26SkinVerticesGenericMathLibILi4ELb1ELb0EEvPKhiiiiPhiPKvS4_(i4, i18, i19, i1, i20, i2, i21, i22, i23) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 if ((i18 | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i5 = i16 + 4 | 0;
 i6 = i16 + 8 | 0;
 i7 = i16 + 16 | 0;
 i8 = i16 + 20 | 0;
 i9 = i16 + 24 | 0;
 i10 = i16 + 32 | 0;
 i11 = i16 + 36 | 0;
 i12 = i16 + 40 | 0;
 i13 = i16 + 48 | 0;
 i14 = i16 + 52 | 0;
 i15 = i16 + 56 | 0;
 i3 = 0;
 i1 = i4;
 while (1) {
  __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i16, i22, i23, i3);
  f27 = Math_fround(HEAPF32[i1 >> 2]);
  f34 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  f39 = Math_fround(HEAPF32[i16 >> 2]);
  f26 = Math_fround(f27 * f39);
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f30 = Math_fround(f27 * f37);
  f35 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(f27 * f35);
  f38 = Math_fround(HEAPF32[i7 >> 2]);
  f25 = Math_fround(f34 * f38);
  f36 = Math_fround(HEAPF32[i8 >> 2]);
  f32 = Math_fround(f34 * f36);
  f33 = Math_fround(HEAPF32[i9 >> 2]);
  f25 = Math_fround(f26 + f25);
  f32 = Math_fround(f30 + f32);
  f34 = Math_fround(f27 + Math_fround(f34 * f33));
  f27 = Math_fround(HEAPF32[i10 >> 2]);
  f30 = Math_fround(f28 * f27);
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  f29 = Math_fround(f28 * f26);
  f31 = Math_fround(HEAPF32[i12 >> 2]);
  f30 = Math_fround(f25 + f30);
  f29 = Math_fround(f32 + f29);
  f28 = Math_fround(f34 + Math_fround(f28 * f31));
  f30 = Math_fround(f30 + Math_fround(HEAPF32[i13 >> 2]));
  f29 = Math_fround(f29 + Math_fround(HEAPF32[i14 >> 2]));
  f28 = Math_fround(f28 + Math_fround(HEAPF32[i15 >> 2]));
  i24 = i1 + i19 | 0;
  f34 = Math_fround(HEAPF32[i24 >> 2]);
  f32 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  i24 = HEAP32[i24 + 12 >> 2] | 0;
  f27 = Math_fround(Math_fround(Math_fround(f39 * f34) + Math_fround(f38 * f32)) + Math_fround(f27 * f25));
  f26 = Math_fround(Math_fround(Math_fround(f37 * f34) + Math_fround(f36 * f32)) + Math_fround(f26 * f25));
  f25 = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f33 * f32)) + Math_fround(f31 * f25));
  HEAPF32[i2 >> 2] = f30;
  HEAPF32[i2 + 4 >> 2] = f29;
  HEAPF32[i2 + 8 >> 2] = f28;
  HEAP32[i2 + 12 >> 2] = i4;
  i4 = i2 + i19 | 0;
  HEAPF32[i4 >> 2] = f27;
  HEAPF32[i4 + 4 >> 2] = f26;
  HEAPF32[i4 + 8 >> 2] = f25;
  HEAP32[i4 + 12 >> 2] = i24;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i18 | 0)) break; else {
   i2 = i2 + i21 | 0;
   i1 = i1 + i20 | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __Z26SkinVerticesGenericMathLibILi2ELb1ELb0EEvPKhiiiiPhiPKvS4_(i4, i18, i19, i1, i20, i2, i21, i22, i23) {
 i4 = i4 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 i20 = i20 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0, f35 = f0, f36 = f0, f37 = f0, f38 = f0, f39 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 if ((i18 | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i5 = i16 + 4 | 0;
 i6 = i16 + 8 | 0;
 i7 = i16 + 16 | 0;
 i8 = i16 + 20 | 0;
 i9 = i16 + 24 | 0;
 i10 = i16 + 32 | 0;
 i11 = i16 + 36 | 0;
 i12 = i16 + 40 | 0;
 i13 = i16 + 48 | 0;
 i14 = i16 + 52 | 0;
 i15 = i16 + 56 | 0;
 i3 = 0;
 i1 = i4;
 while (1) {
  __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj(i16, i22, i23, i3);
  f27 = Math_fround(HEAPF32[i1 >> 2]);
  f34 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f28 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  f39 = Math_fround(HEAPF32[i16 >> 2]);
  f26 = Math_fround(f27 * f39);
  f37 = Math_fround(HEAPF32[i5 >> 2]);
  f30 = Math_fround(f27 * f37);
  f35 = Math_fround(HEAPF32[i6 >> 2]);
  f27 = Math_fround(f27 * f35);
  f38 = Math_fround(HEAPF32[i7 >> 2]);
  f25 = Math_fround(f34 * f38);
  f36 = Math_fround(HEAPF32[i8 >> 2]);
  f32 = Math_fround(f34 * f36);
  f33 = Math_fround(HEAPF32[i9 >> 2]);
  f25 = Math_fround(f26 + f25);
  f32 = Math_fround(f30 + f32);
  f34 = Math_fround(f27 + Math_fround(f34 * f33));
  f27 = Math_fround(HEAPF32[i10 >> 2]);
  f30 = Math_fround(f28 * f27);
  f26 = Math_fround(HEAPF32[i11 >> 2]);
  f29 = Math_fround(f28 * f26);
  f31 = Math_fround(HEAPF32[i12 >> 2]);
  f30 = Math_fround(f25 + f30);
  f29 = Math_fround(f32 + f29);
  f28 = Math_fround(f34 + Math_fround(f28 * f31));
  f30 = Math_fround(f30 + Math_fround(HEAPF32[i13 >> 2]));
  f29 = Math_fround(f29 + Math_fround(HEAPF32[i14 >> 2]));
  f28 = Math_fround(f28 + Math_fround(HEAPF32[i15 >> 2]));
  i24 = i1 + i19 | 0;
  f34 = Math_fround(HEAPF32[i24 >> 2]);
  f32 = Math_fround(HEAPF32[i24 + 4 >> 2]);
  f25 = Math_fround(HEAPF32[i24 + 8 >> 2]);
  i24 = HEAP32[i24 + 12 >> 2] | 0;
  f27 = Math_fround(Math_fround(Math_fround(f39 * f34) + Math_fround(f38 * f32)) + Math_fround(f27 * f25));
  f26 = Math_fround(Math_fround(Math_fround(f37 * f34) + Math_fround(f36 * f32)) + Math_fround(f26 * f25));
  f25 = Math_fround(Math_fround(Math_fround(f35 * f34) + Math_fround(f33 * f32)) + Math_fround(f31 * f25));
  HEAPF32[i2 >> 2] = f30;
  HEAPF32[i2 + 4 >> 2] = f29;
  HEAPF32[i2 + 8 >> 2] = f28;
  HEAP32[i2 + 12 >> 2] = i4;
  i4 = i2 + i19 | 0;
  HEAPF32[i4 >> 2] = f27;
  HEAPF32[i4 + 4 >> 2] = f26;
  HEAPF32[i4 + 8 >> 2] = f25;
  HEAP32[i4 + 12 >> 2] = i24;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i18 | 0)) break; else {
   i2 = i2 + i21 | 0;
   i1 = i1 + i20 | 0;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZNK2UI6Canvas12GetPixelRectEv(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i5 = i9;
 do if ((__ZNK2UI6Canvas13GetRenderModeEv(i1) | 0) == 1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (i2 | 0) {
   __ZNK2UI6Canvas12GetPixelRectEv(i7, i2);
   STACKTOP = i9;
   return;
  }
  i6 = i1 + 40 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i5 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 12;
   }
   if ((i8 | 0) == 10) i8 = 12;
   if ((i8 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
     i2 = HEAP32[i4 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 20;
    }
   }
   if ((i8 | 0) == 18) i8 = 20;
   if ((i8 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   __ZNK6Camera13GetCameraRectEb(i7, i1, 1);
   STACKTOP = i9;
   return;
  }
 } while (0);
 i10 = __Z16GetScreenManagerv() | 0;
 f12 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 80 >> 2] | 0, i10 | 0) | 0);
 i10 = __Z16GetScreenManagerv() | 0;
 f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i10 | 0) | 0);
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = f12;
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = f11;
 STACKTOP = i9;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI19StreamedBinaryWriteILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2642;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __Z15ClearWithSkyboxbPK6Camera(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 160 | 0;
 i6 = i9 + 64 | 0;
 i7 = i9;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i8 = __ZNK6Camera17GetSkyboxMaterialEv(i2) | 0;
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __ZNK6Camera25GetSkyboxProjectionMatrixEfR10Matrix4x4f(i2, Math_fround(HEAPF32[i2 + 920 >> 2]), i7);
 i3 = i2 + 36 | 0;
 i4 = i2 + 1076 | 0;
 if (HEAP8[i4 >> 0] | 0) if (HEAP8[i2 + 1080 >> 0] | 0) {
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i3, i5) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i3, i5) | 0;
  HEAP8[i4 >> 0] = 0;
 }
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 116 >> 2] | 0, i4 | 0, i7 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, i3 | 0);
 i7 = __Z12GetGfxDevicev() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0) | 0, i4, i5);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i5, i6);
 i4 = i7 + 1364 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i4 = i6 + 16 | 0;
 i3 = i7 + 1380 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i3 = i6 + 32 | 0;
 i4 = i7 + 1396 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i4 = i6 + 48 | 0;
 i3 = i7 + 1412 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i3 = i6 + 64 | 0;
 i4 = i7 + 1428 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i6 = i6 + 80 | 0;
 i7 = i7 + 1444 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if (i1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(6, i5, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
  __Z15gpu_time_samplev();
 }
 __ZN6Skybox12RenderSkyboxEP8MaterialRK6Camera(i8, i2);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsI10JointMotorE8TransferI14SafeBinaryReadEEvRS0_RT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 750887 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1048292 | 0, i4, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 736399 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z12CollectPPtrsRK6ObjectRNSt3__26vectorIPS_NS2_9allocatorIS4_EEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 24 | 0;
 i10 = i15 + 16 | 0;
 i11 = i15 + 4 | 0;
 i12 = i15;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i13 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i9 >> 2] = gb + 67212 + 8;
 HEAP32[i9 + 4 >> 2] = i11;
 __ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags(i9, HEAP32[i1 + 4 >> 2] | 0, 64) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i14 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i11, i14);
  STACKTOP = i15;
  return;
 }
 i6 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 i2 = i1;
 while (1) {
  i5 = HEAP32[i2 + 16 >> 2] | 0;
  do if (!i5) i14 = 14; else {
   HEAP32[i10 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i14 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i16 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i14 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i14 = 12;
    }
   }
   if ((i14 | 0) == 10) i14 = 12;
   if ((i14 | 0) == 12) {
    i14 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) {
     i14 = 14;
     break;
    }
   }
   if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28304 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28304 + 28 >> 2] | 0) >>> 0) {
    HEAP32[i12 >> 2] = i1;
    i3 = HEAP32[i6 >> 2] | 0;
    if ((i3 | 0) == (HEAP32[i7 >> 2] | 0)) {
     __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i12);
     break;
    } else {
     HEAP32[i3 >> 2] = i1;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 4;
     break;
    }
   } else i14 = 14;
  } while (0);
  if ((i14 | 0) == 14) {
   i14 = 0;
   HEAP32[i12 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i1;
 }
 i16 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i11, i16);
 STACKTOP = i15;
 return;
}

function __ZN13SparseTexture17UploadTileColor32EiiiPK11ColorRGBA32j(i4, i5, i6, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 20 | 0;
 i10 = i13;
 if (!(__ZNK13SparseTexture20TileUploadErrorCheckEiii(i4, i5, i6, i7) | 0)) {
  STACKTOP = i13;
  return;
 }
 i11 = i4 + 96 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 do if ((i12 + -10 | 0) >>> 0 >= 3) if (((i12 | 1) + -25 | 0) >>> 0 >= 5) {
  i1 = i12 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i12 + -48 | 0) >>> 0 < 12 | ((i12 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
  } else if ((i12 + -45 | 0) >>> 0 < 3 | (i12 + -48 | 0) >>> 0 < 12) break;
  if (!i8) {
   if (__ZNK13SparseTexture20TileUploadErrorCheckEiii(i4, i5, i6, i7) | 0) {
    i8 = HEAP32[i4 + 80 >> 2] >> i7;
    i8 = (i8 | 0) > 1 ? i8 : 1;
    i2 = HEAP32[i4 + 84 >> 2] >> i7;
    i2 = (i2 | 0) > 1 ? i2 : 1;
    i9 = HEAP32[i4 + 88 >> 2] | 0;
    i12 = HEAP32[i4 + 92 >> 2] | 0;
    i12 = (i2 | 0) < (i12 | 0) ? i2 : i12;
    i12 = ((__Z18CalculateImageSizeii13TextureFormat((i8 | 0) < (i9 | 0) ? i8 : i9, i12, HEAP32[i11 >> 2] | 0) | 0) >>> 0) / (i12 >>> 0) | 0;
    i11 = __Z12GetGfxDevicev() | 0;
    i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + 484 >> 2] | 0;
    HEAP32[i10 >> 2] = HEAP32[i4 + 48 >> 2];
    HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
    mftCall_viiiiiiii(i9 | 0, i11 | 0, i3 | 0, i5 | 0, i6 | 0, i7 | 0, 0, 0, i12 | 0);
   }
   STACKTOP = i13;
   return;
  }
  i1 = HEAP32[i4 + 80 >> 2] >> i7;
  i1 = (i1 | 0) > 1 ? i1 : 1;
  i14 = HEAP32[i4 + 84 >> 2] >> i7;
  i14 = (i14 | 0) > 1 ? i14 : 1;
  i2 = HEAP32[i4 + 88 >> 2] | 0;
  i2 = (i1 | 0) < (i2 | 0) ? i1 : i2;
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  i1 = (i14 | 0) < (i1 | 0) ? i14 : i1;
  if ((Math_imul(i1, i2) | 0) >>> 0 > i9 >>> 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 412067 | 0, 0, gb + 411582 | 0, 170, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
   STACKTOP = i13;
   return;
  }
  if ((i12 | 0) == 4) {
   __ZN13SparseTexture10UploadTileEiiiPKhj(i4, i5, i6, i7, i8, i9 << 2);
   STACKTOP = i13;
   return;
  } else {
   i9 = Math_imul(HEAP32[gb + 45784 + (i12 << 2) >> 2] | 0, i2) | 0;
   i12 = Math_imul(i9, i1) | 0;
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 1, gb + 64016 | 0, 0, gb + 411582 | 0, 178) | 0;
   __ZN14ImageReferenceC2Eiii13TextureFormatPv(i3, i2, i1, i2 << 2, 4, i8);
   __ZN14ImageReferenceC2Eiii13TextureFormatPv(i10, i2, i1, i9, HEAP32[i11 >> 2] | 0, i14);
   __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i10, i3, 0);
   __ZN13SparseTexture10UploadTileEiiiPKhj(i4, i5, i6, i7, i14, i12);
   __Z19free_alloc_internalPvRK10MemLabelId(i14, gb + 64016 | 0);
   STACKTOP = i13;
   return;
  }
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 412010 | 0, 0, gb + 411582 | 0, 159, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i13;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI24GenerateTypeTreeTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2587;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb1EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2753;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2697;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 108 | 0;
 i6 = i7 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1;
 i8 = i5;
 if (i4 >>> 0 > (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 108 | 0) >>> 0) {
  __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE10deallocateEv(i7);
  if (i4 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i9 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0) / 108 | 0;
  i1 = i9 << 1;
  i1 = i9 >>> 0 < 19884107 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 39768215;
  if (i1 >>> 0 > 39768215) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i2 = __Znwj(i1 * 108 | 0) | 0;
  i4 = i7 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i2 + (i1 * 108 | 0);
  if ((i3 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  i1 = i3;
  do {
   __ZN9InputAxisC2ERKS_(i2, i1);
   i1 = i1 + 108 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 108 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i7 = i7 + 4 | 0;
 i1 = ((HEAP32[i7 >> 2] | 0) - i1 | 0) / 108 | 0;
 i4 = i4 >>> 0 > i1 >>> 0;
 i1 = i4 ? i3 + (i1 * 108 | 0) | 0 : i5;
 if ((i3 | 0) != (i1 | 0)) do {
  __ZN9InputAxisaSERKS_(i2, i3) | 0;
  i3 = i3 + 108 | 0;
  i2 = i2 + 108 | 0;
 } while ((i3 | 0) != (i1 | 0));
 if (i4) {
  if ((i1 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9InputAxisC2ERKS_(i2, i1);
   i1 = i1 + 108 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 108 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i9 + 4 | 0;
 i5 = i9 + 4 | 0;
 i6 = i9 + 4 | 0;
 do {
  i3 = i1 + -108 | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i3 >> 2] = gb + 59740 + 8;
  i3 = i1 + -68 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i1 + -56 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i3 = i1 + -84 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i1 + -72 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i5 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i3 = i1 + -104 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i1 + -92 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZNSt3__218__insertion_sort_3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i2 = i12 + 64 | 0;
 __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_(i12, i12 + 32 | 0, i2, i1) | 0;
 i1 = i12 + 96 | 0;
 if ((i1 | 0) == (i13 | 0)) return; else i5 = i2;
 while (1) {
  i11 = HEAP32[i1 + 24 >> 2] | 0;
  i2 = HEAP32[i5 + 24 >> 2] | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   i3 = HEAP32[i5 + 8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) i14 = 9; else if ((i2 | 0) <= (i3 | 0)) {
    i9 = i1 + 16 | 0;
    i7 = HEAP32[i9 + 4 >> 2] | 0;
    i10 = i5 + 16 | 0;
    i8 = HEAP32[i10 + 4 >> 2] | 0;
    if ((i7 | 0) < (i8 | 0) | ((i7 | 0) == (i8 | 0) ? (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0)) i14 = 9;
   }
  } else if ((i11 | 0) < (i2 | 0)) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   i14 = 9;
  }
  if ((i14 | 0) == 9) {
   i14 = 0;
   i8 = i1;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   i10 = i1 + 16 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
   L13 : do if ((i5 | 0) == (i12 | 0)) {
    i4 = i12;
    i3 = i5;
   } else while (1) {
    i3 = i5 + -32 | 0;
    i4 = HEAP32[i5 + -8 >> 2] | 0;
    if ((i11 | 0) == (i4 | 0)) {
     i4 = HEAP32[i5 + -24 >> 2] | 0;
     if ((i2 | 0) >= (i4 | 0)) {
      if ((i2 | 0) > (i4 | 0)) {
       i4 = i5;
       i3 = i5;
       break L13;
      }
      i4 = i5 + -16 | 0;
      i15 = HEAP32[i4 + 4 >> 2] | 0;
      if (!((i10 | 0) < (i15 | 0) | ((i10 | 0) == (i15 | 0) ? i9 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0 : 0))) {
       i4 = i5;
       i3 = i5;
       break L13;
      }
     }
    } else if ((i11 | 0) >= (i4 | 0)) {
     i4 = i5;
     i3 = i5;
     break L13;
    };
    HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
    HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
    HEAP32[i5 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
    HEAP32[i5 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
    if ((i3 | 0) == (i12 | 0)) {
     i4 = i12;
     break;
    } else i5 = i3;
   } while (0);
   i15 = i4;
   HEAP32[i15 >> 2] = i7;
   HEAP32[i15 + 4 >> 2] = i8;
   HEAP32[i4 + 8 >> 2] = i2;
   HEAP32[i3 + 12 >> 2] = i6;
   i15 = i4 + 16 | 0;
   HEAP32[i15 >> 2] = i9;
   HEAP32[i15 + 4 >> 2] = i10;
   HEAP32[i4 + 24 >> 2] = i11;
  }
  i2 = i1 + 32 | 0;
  if ((i2 | 0) == (i13 | 0)) break; else {
   i5 = i1;
   i1 = i2;
  }
 }
 return;
}

function __ZN15SerializeTraitsI33EnlightenTerrainChunksInformationE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402595 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402609 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 402622 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN11ForceModule8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i2 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1085989 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1085998 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1084342 | 0, gb + 620173 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 800 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 620372 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 801 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 620354 | 0, i4, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i5 = i1;
  i1 = i1 + -36 | 0;
  i7 = i1;
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = i6 + -36 | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  i2 = i6 + -28 | 0;
  i4 = i5 + -28 | 0;
  i7 = HEAP8[i4 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i4 >> 2] | 0 : i4;
  i7 = i3 ? HEAP32[i5 + -24 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -16 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -16 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -20 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -24 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -12 | 0;
  i7 = i5 + -12 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP8[i17 + 8 >> 0] = HEAP8[i7 + 8 >> 0] | 0;
  i6 = (HEAP32[i13 >> 2] | 0) + -36 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZN5physx16PxsThreadContext12resizeArraysEjjjjj(i9, i3, i7, i4, i6, i8) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = i9 + 8860 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i3 >>> 1 | i3;
 i2 = i2 >>> 2 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = (i2 >>> 16 | i2) + 1 | 0;
 i2 = i2 >>> 0 < 64 ? 64 : i2;
 if ((HEAP32[i9 + 8864 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_11PxsBodyCoreENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i9 + 8856 | 0, i2);
 HEAP32[i1 >> 2] = i3;
 i1 = i9 + 8872 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i3 + 63 & -64;
 if ((HEAP32[i9 + 8876 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Cm13SpatialVectorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i9 + 8868 | 0, i2);
 HEAP32[i1 >> 2] = i3;
 i1 = i9 + 8884 | 0;
 HEAP32[i1 >> 2] = 0;
 if ((HEAP32[i9 + 8888 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Cm13SpatialVectorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i9 + 8880 | 0, i2);
 HEAP32[i1 >> 2] = i3;
 i5 = i9 + 8892 | 0;
 HEAP32[i9 + 8896 >> 2] = 0;
 i1 = i4 + 63 & -64;
 if ((HEAP32[i9 + 8900 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i5, i1);
 HEAP32[i9 + 8932 >> 2] = 0;
 if ((HEAP32[i9 + 8936 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9 + 8928 | 0, i1);
 HEAP32[i9 + 8908 >> 2] = 0;
 if ((HEAP32[i9 + 8912 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9 + 8904 | 0, i1);
 i3 = i9 + 8916 | 0;
 HEAP32[i9 + 8920 >> 2] = 0;
 i1 = i6 + 63 & -64;
 if ((HEAP32[i9 + 8924 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i3, i1);
 i1 = i9 + 9116 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i7 >>> 1 | i7;
 i2 = i2 >>> 2 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = (i2 >>> 16 | i2) + 1 | 0;
 i2 = i2 >>> 0 < 64 ? 64 : i2;
 if ((HEAP32[i9 + 9120 >> 2] & 2147483647) >>> 0 < i2 >>> 0) __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9 + 9112 | 0, i2);
 HEAP32[i1 >> 2] = i7;
 i1 = i9 + 9128 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i8 >>> 1 | i8;
 i2 = i2 >>> 2 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = (i2 >>> 16 | i2) + 1 | 0;
 i2 = i2 >>> 0 < 16 ? 16 : i2;
 if ((HEAP32[i9 + 9132 >> 2] & 2147483647) >>> 0 >= i2 >>> 0) {
  HEAP32[i1 >> 2] = i8;
  i7 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 9068 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = HEAP32[i3 >> 2] | 0;
  i9 = i9 + 9076 | 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9 + 9124 | 0, i2);
 HEAP32[i1 >> 2] = i8;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 9068 | 0;
 HEAP32[i8 >> 2] = i7;
 i8 = HEAP32[i3 >> 2] | 0;
 i9 = i9 + 9076 | 0;
 HEAP32[i9 >> 2] = i8;
 return;
}

function __Z24tessMeshMergeConvexFacesP8TESSmeshi(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i13 = i11 + 44 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  i14 = 1;
  return i14 | 0;
 }
 L3 : while (1) {
  if (HEAP8[i1 + 21 >> 0] | 0) {
   i10 = i1 + 8 | 0;
   i7 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[i7 + 16 >> 2] | 0;
   while (1) {
    i6 = i7;
    i7 = HEAP32[i7 + 12 >> 2] | 0;
    i9 = HEAP32[i6 + 4 >> 2] | 0;
    if (!i9) i14 = 16; else {
     i4 = HEAP32[i9 + 20 >> 2] | 0;
     if (!i4) i14 = 16; else if (!(HEAP8[i4 + 21 >> 0] | 0)) i14 = 16; else {
      i2 = HEAP32[i10 >> 2] | 0;
      i5 = 0;
      i3 = i2;
      while (1) {
       i3 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i3 | 0) == (i2 | 0)) break; else i5 = i5 + 1 | 0;
      }
      i4 = HEAP32[i4 + 8 >> 2] | 0;
      i2 = 0;
      i3 = i4;
      while (1) {
       i3 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + 1 | 0;
      }
      if ((i5 + i2 | 0) > (i12 | 0)) i14 = 16; else {
       i5 = HEAP32[(HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] | 0;
       i4 = HEAP32[i6 + 16 >> 2] | 0;
       i2 = HEAP32[i9 + 12 >> 2] | 0;
       i6 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 16 >> 2] | 0;
       f19 = Math_fround(HEAPF32[i5 + 24 >> 2]);
       f16 = Math_fround(HEAPF32[i4 + 28 >> 2]);
       f15 = Math_fround(HEAPF32[i6 + 28 >> 2]);
       f19 = Math_fround(f19 * Math_fround(f16 - f15));
       f18 = Math_fround(HEAPF32[i4 + 24 >> 2]);
       f17 = Math_fround(HEAPF32[i5 + 28 >> 2]);
       f15 = Math_fround(f19 + Math_fround(f18 * Math_fround(f15 - f17)));
       if (Math_fround(Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(f17 - f16)) + f15) >= Math_fround(0.0)) {
        i5 = HEAP32[(HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 4 >> 2] | 0) + 16 >> 2] | 0;
        i4 = HEAP32[i9 + 16 >> 2] | 0;
        i6 = HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 16 >> 2] | 0;
        f15 = Math_fround(HEAPF32[i5 + 24 >> 2]);
        f18 = Math_fround(HEAPF32[i4 + 28 >> 2]);
        f19 = Math_fround(HEAPF32[i6 + 28 >> 2]);
        f15 = Math_fround(f15 * Math_fround(f18 - f19));
        f16 = Math_fround(HEAPF32[i4 + 24 >> 2]);
        f17 = Math_fround(HEAPF32[i5 + 28 >> 2]);
        f19 = Math_fround(f15 + Math_fround(f16 * Math_fround(f19 - f17)));
        if (Math_fround(Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(f17 - f18)) + f19) >= Math_fround(0.0)) if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(i11, i9) | 0)) {
         i1 = 0;
         i14 = 18;
         break L3;
        } else {
         i7 = i2;
         continue;
        }
       }
      }
     }
    }
    if ((i14 | 0) == 16) {
     i14 = 0;
     if (!i6) continue;
    }
    if ((HEAP32[i7 + 16 >> 2] | 0) == (i8 | 0)) break;
   }
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (i13 | 0)) {
   i1 = 1;
   i14 = 18;
   break;
  }
 }
 if ((i14 | 0) == 18) return i1 | 0;
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS2_EENS4_9allocatorINS4_4pairIS2_S3_EEEEEEEvRT_17TransferMetaFlags(i11, i8, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i4 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (i5 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj(i4, i5 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
 } else if (i5 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i5 << 4) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i5; else {
   i6 = i6 + (~((i6 + -16 - i1 | 0) >>> 4) << 4) | 0;
   HEAP32[i7 >> 2] = i6;
   i1 = i5;
  }
 } else i1 = i5;
 do if (i1 | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i11 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i6 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i6 | 0)) break L14;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i6 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13InitialModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i3 = i6 + 4 | 0;
 HEAP8[i3 >> 0] = 1;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i10 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i3 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 272 | 0, i7);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 536 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 692 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 956 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 1220 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 1484 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 1748 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 2012 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 2540 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i6 + 2548 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 2552 >> 0] = i1;
 i1 = i6 + 2553 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i10 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i10;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = i10;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i10 = i6 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij(i9, i5, i10, i2) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i6 = HEAP32[i5 + 12 >> 2] | 0;
 i3 = i1;
 i4 = i3 + 26 | 0;
 do {
  HEAP16[i3 >> 1] = 0;
  i3 = i3 + 2 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 24 >> 0] = i6;
 HEAP8[i1 + 25 >> 0] = i2;
 if (i6 | 0) {
  i3 = i9 + 60 | 0;
  i2 = 0;
  do {
   HEAP16[i1 + 12 + (i2 << 1) >> 1] = __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f(i3, (HEAP32[i5 >> 2] | 0) + (i2 * 12 | 0) | 0) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
 }
 i3 = i9 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 26 | 0, 2, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 26 | 0, 2, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 26 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i3 = (HEAP32[i9 >> 2] | 0) + (i4 * 26 | 0) | 0;
 i4 = i3 + 26 | 0;
 do {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  i3 = i3 + 2 | 0;
  i1 = i1 + 2 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i2 = i9 + 40 | 0;
 i3 = i9 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZL28HullProjectionCB_SmallConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_(i5, i11, i14, i3, i13, i12) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, i4 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f15 = f0, f16 = f0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i14 >> 2]);
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f7 = Math_fround(f7 * f8);
 f2 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 i10 = i11 + 4 | 0;
 f16 = Math_fround(HEAPF32[i10 >> 2]);
 f2 = Math_fround(f7 + Math_fround(f2 * f16));
 f7 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 i9 = i11 + 8 | 0;
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f7 = Math_fround(f2 + Math_fround(f7 * f6));
 f2 = Math_fround(f8 * Math_fround(HEAPF32[i14 + 12 >> 2]));
 f2 = Math_fround(f2 + Math_fround(f16 * Math_fround(HEAPF32[i14 + 16 >> 2])));
 f2 = Math_fround(f2 + Math_fround(f6 * Math_fround(HEAPF32[i14 + 20 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i14 + 24 >> 2]));
 f16 = Math_fround(f8 + Math_fround(f16 * Math_fround(HEAPF32[i14 + 28 >> 2])));
 f6 = Math_fround(f16 + Math_fround(f6 * Math_fround(HEAPF32[i14 + 32 >> 2])));
 f16 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f15 = Math_fround(f2 * Math_fround(HEAPF32[i3 + 12 >> 2]));
 f1 = Math_fround(f2 * Math_fround(HEAPF32[i3 + 16 >> 2]));
 f15 = Math_fround(f16 + f15);
 f1 = Math_fround(f8 + f1);
 f2 = Math_fround(f7 + Math_fround(f2 * Math_fround(HEAPF32[i3 + 20 >> 2])));
 f7 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 f8 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 28 >> 2]));
 f7 = Math_fround(f15 + f7);
 f8 = Math_fround(f1 + f8);
 f6 = Math_fround(f2 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 32 >> 2])));
 if (!i4) {
  f2 = Math_fround(-3402823469999999843913219.0e14);
  f1 = Math_fround(3402823469999999843913219.0e14);
 } else {
  i3 = HEAP32[i5 + 28 >> 2] | 0;
  f2 = Math_fround(-3402823469999999843913219.0e14);
  f1 = Math_fround(3402823469999999843913219.0e14);
  while (1) {
   i4 = i4 + -1 | 0;
   f16 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
   f16 = Math_fround(f16 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 4 >> 2])));
   f16 = Math_fround(f16 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 8 >> 2])));
   f1 = f1 < f16 ? f1 : f16;
   f2 = f2 > f16 ? f2 : f16;
   if (!i4) break; else i3 = i3 + 12 | 0;
  }
 }
 HEAPF32[i13 >> 2] = f1;
 HEAPF32[i12 >> 2] = f2;
 f16 = Math_fround(HEAPF32[i14 + 36 >> 2]);
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i11 >> 2]));
 f15 = Math_fround(HEAPF32[i14 + 40 >> 2]);
 f15 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i10 >> 2])));
 f16 = Math_fround(HEAPF32[i14 + 44 >> 2]);
 f16 = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i9 >> 2])));
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f16);
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f16);
 return;
}

function __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i12 = i14;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (((i4 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 20 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 20 | 0) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i11 = (i4 - i7 | 0) / 20 | 0;
 i5 = i11 << 1;
 i5 = i11 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i12 + 12 >> 2] = 0;
 i11 = i12 + 16 | 0;
 HEAP32[i11 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i13 >> 2] = 51;
  HEAP32[i13 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 20 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i12 >> 2] = i3;
 i1 = i3 + (((i1 - i7 | 0) / 20 | 0) * 20 | 0) | 0;
 i8 = i12 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 i4 = i12 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i3 + (i5 * 20 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i1 = (HEAP32[i8 >> 2] | 0) + 20 | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i10, i12);
 i6 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i13 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i8 >> 2] = i2;
   i4 = HEAP32[i1 + -16 >> 2] | 0;
   i5 = i4;
   if (!i4) i1 = i2; else {
    i2 = i1 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i13 >> 2] = 51;
    HEAP32[i7 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i13);
    i1 = HEAP32[i8 >> 2] | 0;
   }
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i12 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  HEAP32[i13 >> 2] = 51;
  HEAP32[i13 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_13PxRigidStaticEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 284 | 0;
 i14 = i11 + 232 | 0;
 i13 = i11 + 336 | 0;
 i21 = i11;
 i6 = i11 + 228 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx26PxRigidStaticGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i5 = i20 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i3;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i4;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 i5 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i18 = i14 + 8 | 0;
 HEAP32[i18 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i4;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j(i15, i14, i5) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN20ComputeShaderVariant8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead17GfxDeviceRendererEvRT_RT0_PKc17TransferMetaFlags(i8, i6, gb + 469322 | 0, 0);
 i5 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469337 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 8 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469349 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19ComputeShaderKernelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469357 | 0, i3, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469373 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN19SkinnedMeshRenderer29CalculateRootLocalSpaceBoundsER10MinMaxAABB(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 80 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13;
 i1 = HEAP32[i8 + 356 >> 2] | 0;
 if (!i1) i7 = 0; else i7 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 156 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 i6 = i12 + 4 | 0;
 i3 = gb + 63160 | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i7 << 6;
 do if (!i1) i1 = 0; else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 429036 | 0, 1246) | 0;
   i3 = gb + 64016 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   i5 = i6;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 + 4 >> 2] = i3;
   break;
  }
 } while (0);
 i5 = i1 + 3 & -4;
 HEAP32[i11 >> 2] = HEAP32[i8 + 380 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i4 = 12; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
   i2 = HEAP32[i10 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 12; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i4 = 15;
  }
 }
 if ((i4 | 0) == 12) i4 = 15;
 if ((i4 | 0) == 15) i1 = __ZN8Renderer12GetTransformEv(i8) | 0;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i11, i1);
 if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i8, i5, i7) | 0) {
  if (i7 | 0) {
   i1 = 0;
   do {
    i2 = i5 + (i1 << 6) | 0;
    __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i11, i2, i10);
    i3 = i10;
    i4 = i2 + 64 | 0;
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     i2 = i2 + 4 | 0;
     i3 = i3 + 4 | 0;
    } while ((i2 | 0) < (i4 | 0));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  if (__ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB(i8, i5, i7, i9) | 0) {
   i14 = 1;
   i12 = HEAP32[i12 >> 2] | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i6);
   STACKTOP = i13;
   return i14 | 0;
  }
 }
 i14 = 0;
 i12 = HEAP32[i12 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i6);
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN13BoneInfluence8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN10UnityScene14SetPathAndGUIDERK8UnityStrRK9UnityGUID(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 24 | 0;
 i11 = i13 + 12 | 0;
 i12 = i13;
 i2 = i8 + 12 | 0;
 do if ((i2 | 0) == (i1 | 0)) i1 = i2 + 11 | 0; else {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
  i1 = i2 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i5 = (HEAP32[i8 + 20 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i4) i3 = HEAP32[i8 + 16 >> 2] | 0; else i3 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i5, i6 - i5 | 0, i3, 0, i3, i6, i7);
   break;
  }
  if (i4) i3 = HEAP32[i2 >> 2] | 0; else i3 = i2;
  if (i6 | 0) _memmove(i3 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i3 + i6 >> 0] = 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP32[i8 + 16 >> 2] = i6;
   break;
  } else {
   HEAP8[i1 >> 0] = i6;
   break;
  }
 } while (0);
 i7 = i8 + 28 | 0;
 i1 = HEAP8[i1 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i8 + 16 >> 2] | 0;
 } else i1 = i1 & 255;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i2, i1);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i11, i12);
 __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i10, i11);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i3 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i8 + 36 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i8 + 32 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 32 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i12 = i8 + 60 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN9Texture3D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i5, i1 + 80 | 0, 16);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i5, i1 + 84 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853473 | 0, i5, i1 + 88 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 92 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410455 | 0, i5, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410444 | 0, i5, i1 + 76 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i8, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 105 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i2, i4, gb + 411165 | 0, 1);
 __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i2, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 96 >> 2] | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN22ProceduralMaterialData12SyncMaterialEP18ProceduralMaterial(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i8 = i9;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 i6 = i2 + 64 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i5 = i1;
 do {
  i4 = HEAP32[i5 >> 2] | 0;
  do if (i4 | 0) {
   HEAP32[i8 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 12;
    }
   }
   if ((i10 | 0) == 10) i10 = 12;
   if ((i10 | 0) == 12) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) break;
   }
   if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31192 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31192 + 28 >> 2] | 0) >>> 0)) {
    i11 = i1 + 160 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    HEAP32[i1 + 152 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i1 + 156 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i11 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i1 + 168 >> 2] = HEAP32[i5 + 16 >> 2];
    HEAP32[i1 + 172 >> 2] = HEAP32[i5 + 20 >> 2];
    HEAP32[i1 + 176 >> 2] = HEAP32[i5 + 24 >> 2];
    HEAP32[i1 + 164 >> 2] = HEAP32[i5 + 12 >> 2];
    i3 = i5 + 40 | 0;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    i12 = i1 + 192 | 0;
    HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i12 + 4 >> 2] = i2;
    i12 = i5 + 48 | 0;
    i2 = HEAP32[i12 + 4 >> 2] | 0;
    i3 = i1 + 200 | 0;
    HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i3 + 4 >> 2] = i2;
    i3 = HEAP16[i5 + 28 >> 1] | 0;
    HEAP8[i1 + 180 >> 0] = i3;
    HEAP8[i1 + 181 >> 0] = (i3 & 65535) >>> 8;
    HEAP32[i1 + 184 >> 2] = HEAP32[i5 + 32 >> 2];
    i3 = i5 + 60 | 0;
    i2 = i1 + 212 | 0;
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    HEAP32[i1 + 216 >> 2] = HEAP32[i5 + 64 >> 2];
    HEAP32[i11 >> 2] = i4;
    if (!(HEAP8[i1 + 224 >> 0] | 0)) {
     HEAP8[i2 >> 0] = 0;
     i1 = 0;
    } else {
     i1 = HEAP32[i1 + 88 >> 2] | 0;
     HEAP8[i2 >> 0] = (i1 | 0) != 0 & 1;
     i1 = (i1 | 0) != 0;
    }
    HEAP8[i3 >> 0] = i1 & 1;
   }
  } while (0);
  i5 = i5 + 72 | 0;
 } while ((i5 | 0) != (HEAP32[i6 >> 2] | 0));
 STACKTOP = i9;
 return;
}

function __ZN11TypeManager21FindAllDerivedClassesEPK4RTTIR13dynamic_arrayIS2_Lj4EEb(i3, i1, i13, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i11 = i2 + i5 | 0;
 i12 = i13 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i12 >> 2] = i2;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i13 >> 2] = i10;
  break;
 } while (0);
 i1 = i5 >>> 0 < i11 >>> 0;
 if (!i4) {
  if (!i1) return;
  i8 = i3 + 44 | 0;
  i9 = i13 + 12 | 0;
  i10 = i13 + 4 | 0;
  i1 = i5;
  i4 = HEAP32[i9 >> 2] | 0;
  do {
   i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 4 + (i1 << 2) >> 2] | 0;
   i5 = i4;
   i4 = i4 + 1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i4;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  return;
 }
 if (!i1) return;
 i8 = i3 + 44 | 0;
 i9 = i13 + 12 | 0;
 i10 = i13 + 4 | 0;
 i1 = i5;
 do {
  i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 4 + (i1 << 2) >> 2] | 0;
  i3 = i7;
  if (!(HEAP8[i7 + 32 >> 0] | 0)) {
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i13 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i5;
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] = i3;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 return;
}

function _UNITY_png_handle_cHRM(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 32 | 0;
 i6 = i7;
 i3 = HEAP32[i4 + 204 >> 2] | 0;
 if (!(i3 & 1)) _UNITY_png_chunk_error(i4, gb + 352205 | 0);
 if (i3 & 6 | 0) {
  _UNITY_png_crc_finish(i4, i1) | 0;
  _UNITY_png_chunk_benign_error(i4, gb + 352423 | 0);
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) != 32) {
  _UNITY_png_crc_finish(i4, i1) | 0;
  _UNITY_png_chunk_benign_error(i4, gb + 352446 | 0);
  STACKTOP = i7;
  return;
 }
 _UNITY_png_read_data(i4, i2, 32);
 _UNITY_png_calculate_crc(i4, i2, 32);
 if (_UNITY_png_crc_finish(i4, 0) | 0) {
  STACKTOP = i7;
  return;
 }
 i9 = (HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0);
 i11 = i6 + 24 | 0;
 HEAP32[i11 >> 2] = (i9 | 0) > -1 ? i9 : -1;
 i9 = (HEAPU8[i2 + 5 >> 0] | 0) << 16 | (HEAPU8[i2 + 4 >> 0] | 0) << 24 | (HEAPU8[i2 + 6 >> 0] | 0) << 8 | (HEAPU8[i2 + 7 >> 0] | 0);
 i10 = i6 + 28 | 0;
 HEAP32[i10 >> 2] = (i9 | 0) > -1 ? i9 : -1;
 i9 = (HEAPU8[i2 + 9 >> 0] | 0) << 16 | (HEAPU8[i2 + 8 >> 0] | 0) << 24 | (HEAPU8[i2 + 10 >> 0] | 0) << 8 | (HEAPU8[i2 + 11 >> 0] | 0);
 HEAP32[i6 >> 2] = (i9 | 0) > -1 ? i9 : -1;
 i9 = (HEAPU8[i2 + 13 >> 0] | 0) << 16 | (HEAPU8[i2 + 12 >> 0] | 0) << 24 | (HEAPU8[i2 + 14 >> 0] | 0) << 8 | (HEAPU8[i2 + 15 >> 0] | 0);
 i9 = (i9 | 0) > -1 ? i9 : -1;
 HEAP32[i6 + 4 >> 2] = i9;
 i8 = (HEAPU8[i2 + 17 >> 0] | 0) << 16 | (HEAPU8[i2 + 16 >> 0] | 0) << 24 | (HEAPU8[i2 + 18 >> 0] | 0) << 8 | (HEAPU8[i2 + 19 >> 0] | 0);
 i8 = (i8 | 0) > -1 ? i8 : -1;
 HEAP32[i6 + 8 >> 2] = i8;
 i1 = (HEAPU8[i2 + 21 >> 0] | 0) << 16 | (HEAPU8[i2 + 20 >> 0] | 0) << 24 | (HEAPU8[i2 + 22 >> 0] | 0) << 8 | (HEAPU8[i2 + 23 >> 0] | 0);
 i1 = (i1 | 0) > -1 ? i1 : -1;
 HEAP32[i6 + 12 >> 2] = i1;
 i3 = (HEAPU8[i2 + 25 >> 0] | 0) << 16 | (HEAPU8[i2 + 24 >> 0] | 0) << 24 | (HEAPU8[i2 + 26 >> 0] | 0) << 8 | (HEAPU8[i2 + 27 >> 0] | 0);
 i3 = (i3 | 0) > -1 ? i3 : -1;
 HEAP32[i6 + 16 >> 2] = i3;
 i2 = (HEAPU8[i2 + 29 >> 0] | 0) << 16 | (HEAPU8[i2 + 28 >> 0] | 0) << 24 | (HEAPU8[i2 + 30 >> 0] | 0) << 8 | (HEAPU8[i2 + 31 >> 0] | 0);
 i2 = (i2 | 0) > -1 ? i2 : -1;
 HEAP32[i6 + 20 >> 2] = i2;
 if ((i2 | 0) == -1 | ((HEAP32[i11 >> 2] | 0) == -1 | (HEAP32[i10 >> 2] | 0) == -1 | (HEAP32[i6 >> 2] | 0) == -1 | (i9 | 0) == -1 | (i8 | 0) == -1 | (i1 | 0) == -1 | (i3 | 0) == -1)) {
  _UNITY_png_chunk_benign_error(i4, gb + 352897 | 0);
  STACKTOP = i7;
  return;
 }
 i1 = i4 + 754 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (i2 & 32768 | 0) {
  STACKTOP = i7;
  return;
 }
 if (!(i2 & 16)) {
  HEAP16[i1 >> 1] = i2 | 16;
  _UNITY_png_colorspace_set_chromaticities(i4, i4 + 680 | 0, i6, 1) | 0;
  _UNITY_png_colorspace_sync(i4, i5);
  STACKTOP = i7;
  return;
 } else {
  HEAP16[i1 >> 1] = i2 | 32768;
  _UNITY_png_colorspace_sync(i4, i5);
  _UNITY_png_chunk_benign_error(i4, gb + 352436 | 0);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx3Scb14ParticleSystem9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEENS_11PxForceMode4EnumE(i7, i18, i8, i9, i5) {
 i7 = i7 | 0;
 i18 = i18 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i19 + 8 | 0;
 i3 = i19;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i4 = 3;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0) i4 = 3;
   break;
  }
 default:
  {}
 }
 if ((i4 | 0) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 203, gb + 699279 | 0, i3);
  STACKTOP = i19;
  return;
 }
 if (!(i1 & 1024)) f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv(i7 + 12 | 0)); else f2 = Math_fround(HEAPF32[(HEAP32[i7 + 8 >> 2] | 0) + 44 >> 2]);
 switch (i5 | 0) {
 case 0:
  {
   i1 = 1;
   f17 = Math_fround(Math_fround(1.0) / f2);
   break;
  }
 case 1:
  {
   i1 = 0;
   f17 = Math_fround(Math_fround(1.0) / f2);
   break;
  }
 case 2:
  {
   i1 = 0;
   f17 = Math_fround(1.0);
   break;
  }
 case 3:
  {
   i1 = 1;
   f17 = Math_fround(1.0);
   break;
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 699190 | 0, 233, gb + 699344 | 0, i6);
   i1 = 1;
   f17 = Math_fround(Math_fround(1.0) / f2);
  }
 }
 i16 = i1 ? i7 + 156 | 0 : i7 + 168 | 0;
 __ZN5physx3Scb14ParticleSystem12ForceUpdates10initializeEj(i16, __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv(i7 + 12 | 0) | 0);
 if (!i18) {
  STACKTOP = i19;
  return;
 }
 i13 = i8 + 4 | 0;
 i14 = i9 + 4 | 0;
 i15 = i16 + 4 | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
 i9 = 0;
 do {
  i4 = HEAP32[i12 + (Math_imul(HEAP32[i13 >> 2] | 0, i9) | 0) >> 2] | 0;
  i5 = Math_imul(HEAP32[i14 >> 2] | 0, i9) | 0;
  f2 = Math_fround(f17 * Math_fround(HEAPF32[i1 + i5 >> 2]));
  f10 = Math_fround(f17 * Math_fround(HEAPF32[i1 + (i5 + 4) >> 2]));
  f11 = Math_fround(f17 * Math_fround(HEAPF32[i1 + (i5 + 8) >> 2]));
  i5 = i3 + (i4 >>> 5 << 2) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = 1 << (i4 & 31);
  i8 = HEAP32[i15 >> 2] | 0;
  if (!(i6 & i7)) {
   HEAP32[i5 >> 2] = i6 | i7;
   HEAPF32[i8 + (i4 * 12 | 0) >> 2] = f2;
   HEAPF32[i8 + (i4 * 12 | 0) + 4 >> 2] = f10;
   HEAPF32[i8 + (i4 * 12 | 0) + 8 >> 2] = f11;
  } else {
   i7 = i8 + (i4 * 12 | 0) | 0;
   HEAPF32[i7 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i7 >> 2]));
   i7 = i8 + (i4 * 12 | 0) + 4 | 0;
   HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
   i8 = i8 + (i4 * 12 | 0) + 8 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i8 >> 2]));
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i18 | 0));
 HEAP8[i16 + 8 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZN14ParticleSystem35CalculateMaximumSubEmitterEmitCountERS_R19ParticleSystemStatefbi(i4, i5, f12, i2, i16) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f12 = Math_fround(f12);
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i1 = 0, f3 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19 + 32 | 0;
 i13 = i19 + 8 | 0;
 i14 = i19;
 i18 = i5 + 488 | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i18 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i18 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i18 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i18 + 20 >> 2];
 i15 = i4 + 36 | 0;
 i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + 272 >> 2] | 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i13 + 8 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i13 + 16 >> 2] = i1;
 HEAP32[i13 + 20 >> 2] = (Math_imul(i1, 1812433253) | 0) + 1;
 i1 = __Z14GetTimeManagerv() | 0;
 if (i2) f3 = Math_fround(HEAPF32[i1 + 48 >> 2]); else if (Math_fround(HEAPF32[i1 + 204 >> 2]) < f12) f3 = Math_fround(f12 / Math_fround(Math_ceil(Math_fround(f12 / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 204 >> 2]))))); else f3 = f12;
 f11 = Math_fround(f3 * Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 268 >> 2]));
 if (f11 < Math_fround(.0000999999974)) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i1 = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 12 >> 2] | 0;
 L9 : do if (!(HEAP8[i4 + 268 >> 0] | 0)) i2 = 0; else {
  i4 = i4 + 272 | 0;
  i10 = i5 + 292 | 0;
  f8 = Math_fround(HEAPF32[i5 + 396 >> 2]);
  f9 = f12;
  i2 = 0;
  while (1) {
   if (!(f9 >= f11)) break L9;
   f9 = Math_fround(f9 - f11);
   f3 = Math_fround(f8 + Math_fround(f12 - f9));
   i5 = HEAP32[i15 >> 2] | 0;
   f7 = Math_fround(HEAPF32[i5 + 264 >> 2]);
   if (!(HEAP8[i5 + 277 >> 0] | 0)) {
    f3 = f7 < f3 ? f7 : f3;
    f6 = Math_fround(f3 - f8);
   } else {
    f6 = f11;
    f3 = Math_fround(_fmodf(f3, f7));
   }
   i1 = (__ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff(i13, i4, i10, f8, f3, f6, f7) | 0) + i1 | 0;
   i1 = i1 + (__ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff(i13, i14, i4, f8, f3, Math_fround(HEAPF32[(HEAP32[i15 >> 2] | 0) + 264 >> 2])) | 0) | 0;
   i2 = i1 + i2 | 0;
   if ((Math_imul(i2, i16) | 0) >= 1024) break; else f8 = f3;
  }
 } while (0);
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
 HEAP32[i18 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
 HEAP32[i18 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
 i18 = Math_imul(i1 + 5 + i2 | 0, i16) | 0;
 i18 = (i18 | 0) > 1024 ? 1024 : i18;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN15SerializeTraitsIN4math14float3_storageEE8TransferI14SafeBinaryReadEEvRS1_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN8Animator13GetBehavioursEP11Il2CppClass(i11, i1, i12) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i21 + 8 | 0;
 i2 = i21;
 i17 = i21 + 28 | 0;
 HEAP32[i11 >> 2] = 0;
 i18 = i11 + 12 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i11 + 16 | 0;
 HEAP32[i19 >> 2] = 0;
 i20 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
 i14 = i13;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i16 = i20;
 HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i16 + 4 >> 2] = i15;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) {
  STACKTOP = i21;
  return;
 }
 i16 = gb + 64016 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i2;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i17 >> 2] = 0;
 i14 = i17 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i17 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i2);
 i8 = i13;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 92 >> 2] | 0, i10 | 0, i17 | 0);
 if (HEAP32[i14 >> 2] | 0) {
  i8 = i13 + 12 | 0;
  i9 = i13 + 16 | 0;
  i10 = i13 + 4 | 0;
  i7 = HEAP32[i17 >> 2] | 0;
  do {
   __ZN26AnimatorControllerPlayable13GetBehavioursEP11Il2CppClass(i13, HEAP32[i7 >> 2] | 0, i12);
   i1 = HEAP32[i13 >> 2] | 0;
   if (HEAP32[i8 >> 2] | 0) {
    do {
     i3 = HEAP32[i18 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i19 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i2 = i5 << 1;
      i2 = (i2 | 0) == 0 ? 1 : i2;
      if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i19 >> 2] = i2;
       HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 << 2, 4, i20, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i20, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
       HEAP32[i19 >> 2] = i2;
       HEAP32[i11 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i18 >> 2] = i4;
     HEAP32[(HEAP32[i11 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
     i1 = i1 + 4 | 0;
     i2 = HEAP32[i13 >> 2] | 0;
    } while ((i1 | 0) != (i2 + (HEAP32[i8 >> 2] << 2) | 0));
    i1 = i2;
   }
   if ((HEAP32[i9 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
    HEAP32[i13 >> 2] = 0;
   }
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) != ((HEAP32[i17 >> 2] | 0) + (HEAP32[i14 >> 2] << 2) | 0));
 }
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16);
  HEAP32[i17 >> 2] = 0;
 }
 STACKTOP = i21;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i16, i1, i14, i3, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 16 | 0;
 i13 = i15;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i16, HEAP32[i14 >> 2] | 0);
 HEAP32[i1 >> 2] = 410;
 i12 = HEAP32[i16 + 44 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? i1 : i12;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = i16; else {
  i7 = i13 + 4 | 0;
  i8 = i13 + 8 | 0;
  i9 = i13 + 12 | 0;
  i10 = i16 + 36 | 0;
  i11 = i16 + 20 | 0;
  i6 = i3;
  i5 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i16, i1);
   HEAP32[i8 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i9 >> 2] = i14;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i7 >> 2] = i5 + 8;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i16, HEAP32[i12 >> 2] | 0, i13);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i10 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i11 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i16 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i10 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i10 >> 0] = 0;
   }
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   i6 = i6 + 8 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i5 = i5 + 28 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i15;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i15;
 return;
}

function __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i2, i1, i3, i4, i8, i5, i6, i7, i9, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i15 + 8 | 0;
 i16 = i15;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 41960 + 8;
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i16;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i11;
 i14 = i2 + 8 | 0;
 HEAP32[i14 >> 2] = 0;
 i11 = i2 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i2 + 24 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i2 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i16);
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i1 + 4 >> 2] = i16;
 HEAP32[i2 + 28 >> 2] = i3;
 HEAP32[i2 + 32 >> 2] = i4;
 HEAP32[i2 + 36 >> 2] = i8;
 HEAP32[i2 + 40 >> 2] = i5;
 HEAP32[i2 + 44 >> 2] = i6;
 HEAP32[i2 + 48 >> 2] = i7;
 i2 = Math_imul(i6, i5) | 0;
 do if ((i8 + -10 | 0) >>> 0 < 3) i1 = 0; else if (((i8 | 1) + -25 | 0) >>> 0 < 5) i1 = 0; else {
  i1 = i8 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i8 + -48 | 0) >>> 0 < 12 | ((i8 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) {
    i1 = 0;
    break;
   }
  } else if ((i8 + -45 | 0) >>> 0 < 3 | (i8 + -48 | 0) >>> 0 < 12) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[gb + 45784 + (i8 << 2) >> 2] | 0;
 } while (0);
 i3 = i1 + i2 | 0;
 if (!i10) {
  STACKTOP = i15;
  return;
 }
 if (!i9) {
  HEAP32[i11 >> 2] = i3;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 & 2147483647) >>> 0 >= i3 >>> 0) {
   STACKTOP = i15;
   return;
  }
  if ((i1 | 0) > -1) {
   HEAP32[i12 >> 2] = i3;
   HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i3, 1, i13, 0, gb + 1047584 | 0, 464) | 0;
   STACKTOP = i15;
   return;
  } else {
   i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i13, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i17 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = i3;
   HEAP32[i14 >> 2] = i17;
   STACKTOP = i15;
   return;
  }
 }
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i3;
 i1 = HEAP32[i12 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i12 >> 2] = i3;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i3, 1, i13, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i13, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i17 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i14 >> 2] = i17;
  break;
 } while (0);
 if (i3 >>> 0 <= i2 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i1 = i3 - i2 | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 _memset((HEAP32[i14 >> 2] | 0) + i2 | 0, -51, i1 | 0) | 0;
 STACKTOP = i15;
 return;
}

function __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i3, i4, i12, i14, f15, i16) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18;
 i17 = (HEAP32[i12 + 324 >> 2] | 0) + (i14 << 3) | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i5 = __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(HEAP32[i5 + 8 >> 2] | 0, i16, i5) | 0;
 if ((i5 | 0) < 0) {
  STACKTOP = i18;
  return;
 }
 i6 = i3 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i7 = i3 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i10 = i3 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i13 = i11 & 2147483647;
 do if (i9 >>> 0 > i13 >>> 0) {
  i2 = i11 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i13 >>> 0 < i2 >>> 0) if ((i11 | 0) > -1) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 * 40 | 0, 8, i3 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 8, i3 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i6 >> 2] = i13;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 i13 = HEAP32[i6 >> 2] | 0;
 i11 = i13 + (i8 * 40 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i13 + (i8 * 40 | 0) + 28 >> 2] = -2147450880;
 i13 = i13 + (i8 * 40 | 0) + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 i13 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i12 + 248 >> 2] | 0;
 i9 = i5 << 24 | (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0) >>> 22 | (HEAP16[i12 + 182 >> 1] | 0 ? i8 << 10 & 16776192 : 16776192);
 i10 = i11 + (i13 * 40 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i17 >> 2] | 0) + 168 >> 2] << 23 & -16777216 | i8 & 65535 | HEAPU16[i12 + 180 >> 1] << 16 & 16711680;
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i11 + (i13 * 40 | 0) + 8 >> 2] = i4;
 HEAP32[i11 + (i13 * 40 | 0) + 20 >> 2] = i14;
 HEAP32[i11 + (i13 * 40 | 0) + 16 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i11 + (i13 * 40 | 0) + 12 >> 2] = i5;
 HEAP32[i11 + (i13 * 40 | 0) + 28 >> 2] = HEAP32[i12 + 184 >> 2];
 HEAP16[i11 + (i13 * 40 | 0) + 32 >> 1] = HEAP16[i12 + 270 >> 1] | 0;
 HEAP32[i11 + (i13 * 40 | 0) + 24 >> 2] = HEAP32[i12 + 252 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN19SkinnedMeshRenderer12UploadClothsERK13dynamic_arrayIPS_Lj4EE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i18 + 48 | 0;
 i11 = i18 + 24 | 0;
 i12 = i18;
 i13 = HEAP32[i6 + 12 >> 2] | 0;
 if ((i13 | 0) <= 0) {
  STACKTOP = i18;
  return;
 }
 i14 = i11 + 4 | 0;
 i15 = i11 + 8 | 0;
 i16 = i11 + 12 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 20 | 0;
 i5 = 0;
 do {
  i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i10 + 488 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i2 = __Z12GetGfxDevicev() | 0;
   i3 = i10 + 468 | 0;
   i4 = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 228 >> 2] | 0, i2 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, 0, 0) | 0;
   if (i4 | 0) {
    _memcpy(i4 | 0, HEAP32[i10 + 476 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
    mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 232 >> 2] | 0, i2 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i1 >> 2] | 0);
   }
   HEAP32[i11 >> 2] = HEAP32[i10 + 380 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i17 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i11);
     i2 = HEAP32[i7 >> 2] | 0;
     i4 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i17 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i17 = 15; else i2 = i10;
    }
   }
   if ((i17 | 0) == 12) i17 = 15;
   if ((i17 | 0) == 15) {
    i17 = 0;
    i1 = __ZN8Renderer12GetTransformEv(i10) | 0;
    i2 = i10;
   }
   __ZNK9Transform21GetWorldToLocalMatrixEv(i7, i1);
   i4 = HEAP32[i10 + 504 >> 2] | 0;
   HEAP32[i11 >> 2] = HEAP32[i4 + 96 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i4 + 100 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i4 + 104 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i4 + 108 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i4 + 112 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i4 + 116 >> 2];
   __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i11, i7, i12);
   i4 = i10 + 436 | 0;
   HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
   HEAP8[i10 + 466 >> 0] = 0;
   __ZN8Renderer13BoundsChangedEv(i2);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i13 | 0));
 STACKTOP = i18;
 return;
}

function __ZN15SerializeTraitsIN7mecanim6bitsetILj66EEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904295 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904301 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 904307 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _inet_ntop(i2, i12, i1, i15) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 48 | 0;
 i14 = i18 + 16 | 0;
 i3 = i18;
 i16 = i18 + 88 | 0;
 switch (i2 | 0) {
 case 2:
  {
   i13 = HEAPU8[i12 + 1 >> 0] | 0;
   i14 = HEAPU8[i12 + 2 >> 0] | 0;
   i16 = HEAPU8[i12 + 3 >> 0] | 0;
   HEAP32[i3 >> 2] = HEAPU8[i12 >> 0];
   HEAP32[i3 + 4 >> 2] = i13;
   HEAP32[i3 + 8 >> 2] = i14;
   HEAP32[i3 + 12 >> 2] = i16;
   if ((_snprintf(i1, i15, gb + 1074236 | 0, i3) | 0) >>> 0 >= i15 >>> 0) i17 = 15;
   break;
  }
 case 10:
  {
   i19 = (_memcmp(i12, gb + 1074248 | 0, 12) | 0) == 0;
   i3 = (HEAPU8[i12 >> 0] | 0) << 8 | (HEAPU8[i12 + 1 >> 0] | 0);
   i4 = (HEAPU8[i12 + 2 >> 0] | 0) << 8 | (HEAPU8[i12 + 3 >> 0] | 0);
   i5 = (HEAPU8[i12 + 4 >> 0] | 0) << 8 | (HEAPU8[i12 + 5 >> 0] | 0);
   i6 = (HEAPU8[i12 + 6 >> 0] | 0) << 8 | (HEAPU8[i12 + 7 >> 0] | 0);
   i7 = (HEAPU8[i12 + 8 >> 0] | 0) << 8 | (HEAPU8[i12 + 9 >> 0] | 0);
   i8 = (HEAPU8[i12 + 10 >> 0] | 0) << 8 | (HEAPU8[i12 + 11 >> 0] | 0);
   i9 = HEAPU8[i12 + 12 >> 0] | 0;
   i10 = HEAP8[i12 + 13 >> 0] | 0;
   i11 = HEAP8[i12 + 14 >> 0] | 0;
   i2 = HEAP8[i12 + 15 >> 0] | 0;
   if (i19) {
    HEAP32[i13 >> 2] = i3;
    HEAP32[i13 + 4 >> 2] = i4;
    HEAP32[i13 + 8 >> 2] = i5;
    HEAP32[i13 + 12 >> 2] = i6;
    HEAP32[i13 + 16 >> 2] = i7;
    HEAP32[i13 + 20 >> 2] = i8;
    HEAP32[i13 + 24 >> 2] = i9;
    HEAP32[i13 + 28 >> 2] = i10 & 255;
    HEAP32[i13 + 32 >> 2] = i11 & 255;
    HEAP32[i13 + 36 >> 2] = i2 & 255;
    _snprintf(i16, 100, gb + 1074285 | 0, i13) | 0;
   } else {
    HEAP32[i14 >> 2] = i3;
    HEAP32[i14 + 4 >> 2] = i4;
    HEAP32[i14 + 8 >> 2] = i5;
    HEAP32[i14 + 12 >> 2] = i6;
    HEAP32[i14 + 16 >> 2] = i7;
    HEAP32[i14 + 20 >> 2] = i8;
    HEAP32[i14 + 24 >> 2] = i10 & 255 | i9 << 8;
    HEAP32[i14 + 28 >> 2] = (i11 & 255) << 8 | i2 & 255;
    _snprintf(i16, 100, gb + 1074261 | 0, i14) | 0;
   }
   i2 = HEAP8[i16 >> 0] | 0;
   if (i2 << 24 >> 24) {
    i4 = 2;
    i7 = 0;
    i3 = 0;
    i6 = i16;
    while (1) {
     if ((i7 | 0) == 0 | i2 << 24 >> 24 == 58) {
      i19 = _strspn(i6, gb + 1074315 | 0) | 0;
      i14 = (i19 | 0) > (i4 | 0);
      i3 = i14 ? i7 : i3;
      i4 = i14 ? i19 : i4;
     }
     i5 = i7 + 1 | 0;
     i6 = i16 + i5 | 0;
     i2 = HEAP8[i6 >> 0] | 0;
     if (!(i2 << 24 >> 24)) break; else i7 = i5;
    }
    i2 = i16 + i3 | 0;
    if ((i4 | 0) > 2) {
     HEAP8[i16 + (i3 + 1) >> 0] = 58;
     HEAP8[i2 >> 0] = 58;
     _memmove(i2 + 2 | 0, i2 + i4 | 0, i7 + 2 - i4 - i3 | 0) | 0;
    }
   }
   if ((_strlen(i16) | 0) >>> 0 < i15 >>> 0) _strcpy(i1, i16) | 0; else i17 = 15;
   break;
  }
 default:
  {
   HEAP32[(___errno_location() | 0) >> 2] = 97;
   i1 = 0;
  }
 }
 if ((i17 | 0) == 15) {
  HEAP32[(___errno_location() | 0) >> 2] = 28;
  i1 = 0;
 }
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN19SkinnedMeshRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 460 | 0;
 i8 = i7 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 464 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 465 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 352 | 0, i7);
 i4 = i6 + 372 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
 i1 = HEAP32[i6 + 360 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i4 = i6 + 428 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
 i1 = HEAP32[i6 + 416 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 380 | 0, i7);
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 436 | 0, i7);
 i1 = i6 + 466 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN16CircleCollider2D14CreateInternalEP11Rigidbody2D(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i5 = i11 + 60 | 0;
 i6 = i11 + 48 | 0;
 i7 = i11 + 28 | 0;
 i8 = i11;
 if ((HEAP16[gb + 1457920 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457920 | 0, i1);
  i2 = gb + 1457920 | 0;
 } else i2 = 0;
 i9 = i3 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (i10 | 0) if (__ZNK10GameObject8IsActiveEv(i10) | 0) {
  __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i3, i5, i1, i4);
  f12 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f14 = Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2]));
  f14 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i1 + 16 >> 2])));
  f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) * Math_fround(0.0)));
  f14 = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) + f14);
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i1 + 4 >> 2]));
  f13 = Math_fround(f12 + Math_fround(f13 * Math_fround(HEAPF32[i1 + 20 >> 2])));
  f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) * Math_fround(0.0)));
  f13 = Math_fround(Math_fround(HEAPF32[i1 + 52 >> 2]) + f13);
  __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
  f12 = Math_fround(HEAPF32[i6 >> 2]);
  i10 = f12 < Math_fround(0.0);
  f15 = Math_fround(-f12);
  f12 = i10 ? f15 : f12;
  f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  i10 = f15 < Math_fround(0.0);
  f16 = Math_fround(-f15);
  f15 = i10 ? f16 : f15;
  f12 = Math_fround(Math_fround(HEAPF32[i3 + 160 >> 2]) * (f12 < f15 ? f15 : f12));
  i10 = f12 > Math_fround(.0000999999974);
  f12 = i10 ? f12 : Math_fround(.0000999999974);
  i10 = f12 < Math_fround(.0000999999974);
  i9 = f12 > Math_fround(1.0e6);
  f12 = i9 ? Math_fround(1.0e6) : f12;
  f12 = i10 ? Math_fround(.0000999999974) : f12;
  HEAP32[i7 >> 2] = gb + 151824 + 8;
  i10 = i7 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAPF32[i7 + 12 >> 2] = f14;
  HEAPF32[i7 + 16 >> 2] = f13;
  HEAPF32[i7 + 8 >> 2] = f12;
  HEAP16[i8 + 22 >> 1] = 1;
  HEAP16[i8 + 24 >> 1] = -1;
  HEAP16[i8 + 26 >> 1] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAPF32[i8 + 8 >> 2] = Math_fround(.200000003);
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
  HEAP8[i8 + 20 >> 0] = 0;
  HEAP32[i8 >> 2] = i7;
  __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i3, i1, i8, HEAP32[i5 >> 2] | 0, 0);
 }
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i11;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI17RemapPPtrTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2532;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESM_EERKT_(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 L1 : do if (i3) {
  i10 = HEAP8[i2 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
  i9 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i5 = i2 + 16 | 0;
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i4 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
    i7 = i4 >>> 0 < i10 >>> 0;
    i3 = i7 ? i4 : i10;
    if (!i3) i11 = 6; else {
     i3 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0;
     if (!i3) i11 = 6; else if ((i3 | 0) < 0) break;
    }
    if ((i11 | 0) == 6) {
     i11 = 0;
     if (i10 >>> 0 < i4 >>> 0) break;
    }
    i3 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
    if (!i3) i11 = 11; else {
     i3 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i3) | 0;
     if (!i3) i11 = 11; else if ((i3 | 0) >= 0) break L3;
    }
    if ((i11 | 0) == 11) {
     i11 = 0;
     if (!i7) break L3;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L1;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break L1;
   } else i1 = i2;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  L21 : do if (!i4) i3 = i2; else {
   i3 = i2;
   while (1) {
    i8 = i4;
    while (1) {
     i5 = i8 + 16 | 0;
     i7 = HEAP8[i5 + 11 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i7 = i6 ? HEAP32[i8 + 20 >> 2] | 0 : i7 & 255;
     i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
     if (!i4) i11 = 18; else {
      i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i4) | 0;
      if (!i4) i11 = 18; else if ((i4 | 0) >= 0) break;
     }
     if ((i11 | 0) == 18) {
      i11 = 0;
      if (i7 >>> 0 >= i10 >>> 0) break;
     }
     i4 = HEAP32[i8 + 4 >> 2] | 0;
     if (!i4) break L21; else i8 = i4;
    }
    i4 = HEAP32[i8 >> 2] | 0;
    if (!i4) {
     i3 = i8;
     break;
    } else i3 = i8;
   }
  } while (0);
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  L34 : do if (i4) while (1) {
   i2 = i4;
   while (1) {
    i5 = i2 + 16 | 0;
    i7 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i7 << 24 >> 24 < 0;
    i7 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i7 & 255;
    i4 = i7 >>> 0 < i10 >>> 0 ? i7 : i10;
    if (!i4) i11 = 26; else {
     i4 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i4) | 0;
     if (!i4) i11 = 26; else if ((i4 | 0) < 0) break;
    }
    if ((i11 | 0) == 26) {
     i11 = 0;
     if (i10 >>> 0 < i7 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L34;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  } while (0);
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i1;
  return;
 } while (0);
 i11 = i1;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i11;
 return;
}

function __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i16, i3, i12, i1) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i14 = i3;
 i15 = i12;
 i13 = i1;
 i10 = i16 + 32 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i9 = (i11 | 0) == 0;
 L1 : do if (i9) i1 = 0; else {
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 5381; else {
   i2 = 5381;
   i4 = i3;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i1 = HEAP8[i4 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i4 = 5381;
   i5 = i12;
   do {
    i4 = i4 * 33 ^ i1 << 24 >> 24;
    i5 = i5 + 1 | 0;
    i1 = HEAP8[i5 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i4;
  }
  i1 = (i1 ^ i2) & i11 + -1;
  i2 = HEAP32[(HEAP32[i16 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i16 + 16 >> 2] | 0;
   i6 = i3 | 0 ? i3 : gb + 1576256 | 0;
   i7 = i12 | 0 ? i12 : gb + 1576256 | 0;
   i8 = i16 + 20 | 0;
   while (1) {
    i17 = HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0;
    if (!(_strcmp(i17 | 0 ? i17 : gb + 1576256 | 0, i6) | 0)) if (!(_strcmp(i4 | 0 ? i4 : gb + 1576256 | 0, i7) | 0)) break;
    i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   return;
  }
 } while (0);
 i6 = i16 + 48 | 0;
 if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i16 + 28 >> 2] | 0)) {
  i1 = i9 ? 16 : i11 << 1;
  if (i11 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i16, i1);
   i5 = HEAP32[i10 >> 2] | 0;
  } else i5 = i11;
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 5381; else {
   i2 = 5381;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i4 = i1;
   i1 = 5381;
   i3 = i12;
   do {
    i1 = i1 * 33 ^ i4 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
   } while (i4 << 24 >> 24 != 0);
  }
  i1 = (i1 ^ i2) & i5 + -1;
 }
 i12 = i16 + 40 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i17 + 1;
 i12 = (HEAP32[i16 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i16 + 20 >> 2] | 0) + (i17 << 2) >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i17;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i12 = i16 + 44 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i16 = HEAP32[i16 + 16 >> 2] | 0;
 HEAP32[i16 + (i17 * 12 | 0) >> 2] = i14;
 HEAP32[i16 + (i17 * 12 | 0) + 4 >> 2] = i15;
 HEAP32[i16 + (i17 * 12 | 0) + 8 >> 2] = i13;
 return;
}

function __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i1, i12, i13, f3, i2, f4, f11, i5, i10) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f11 = Math_fround(f11);
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i6 = 0, i7 = 0, f8 = f0, i9 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17;
 i15 = i17 + 8 | 0;
 if ((HEAP16[gb + 1457812 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457812 | 0, i14);
  i16 = gb + 1457812 | 0;
 } else i16 = 0;
 f8 = Math_fround(f3 * Math_fround(.0174532924));
 HEAP32[i15 >> 2] = gb + 158756 + 8;
 HEAP32[i15 + 4 >> 2] = i2;
 i6 = i15 + 8 | 0;
 i7 = i15 + 12 | 0;
 HEAP32[i15 + 16 >> 2] = i5;
 i1 = i15 + 28 | 0;
 HEAP32[i1 >> 2] = gb + 151728 + 8;
 HEAP32[i15 + 32 >> 2] = 2;
 HEAP32[i15 + 36 >> 2] = HEAP32[gb + 151644 >> 2];
 HEAP32[i15 + 176 >> 2] = 0;
 HEAPF32[i15 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 44 >> 2] = Math_fround(0.0);
 i5 = i15 + 180 | 0;
 i2 = i15 + 196 | 0;
 i9 = i15 + 212 | 0;
 HEAP32[i9 >> 2] = i10;
 i10 = f4 == Math_fround(-inf);
 f4 = i10 ? Math_fround(-3402823469999999843913219.0e14) : f4;
 HEAPF32[i6 >> 2] = f4;
 i10 = f11 == Math_fround(inf);
 f3 = i10 ? Math_fround(3402823469999999843913219.0e14) : f11;
 HEAPF32[i7 >> 2] = f3;
 if (!(f4 < f3)) {
  HEAPF32[i6 >> 2] = f3;
  HEAPF32[i7 >> 2] = f4;
 }
 f4 = Math_fround(HEAPF32[i13 >> 2]);
 i10 = f4 > Math_fround(.0000999999974);
 f4 = i10 ? f4 : Math_fround(.0000999999974);
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 i13 = f11 > Math_fround(.0000999999974);
 f4 = Math_fround(f4 * Math_fround(.5));
 f11 = Math_fround((i13 ? f11 : Math_fround(.0000999999974)) * Math_fround(.5));
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 __ZN14b2PolygonShape8SetAsBoxEffRK6b2Vec2f(i1, f4, f11, i14, f8);
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 208 >> 2] = Math_fround(1.0);
 __ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib(i1, i5, i2, 0, 1);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i15, i5);
 i1 = HEAP32[i9 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i15, i15 + (HEAP32[i1 + 12 >> 2] << 2) | 0, i14);
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN9ShaderLab16SerializedShaderD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i5 = i10 + 72 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i10 + 76 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i9 + 4 | 0;
   i8 = i9 + 4 | 0;
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -16 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i12 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i7 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -20 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i8 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i10 + 56 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i10 + 68 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = i10 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i10 + 52 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i1 = i10 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i10 + 36 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i6 = i10 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i7 = i10 + 16 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i4 = i2 + -28 | 0;
    HEAP32[i7 >> 2] = i4;
    __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + -16 | 0, HEAP32[i2 + -12 >> 2] | 0);
    i5 = HEAP32[i4 >> 2] | 0;
    if (i5 | 0) {
     i3 = i2 + -24 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((i2 | 0) == (i5 | 0)) i2 = i5; else {
      do {
       i12 = i2 + -872 | 0;
       HEAP32[i3 >> 2] = i12;
       __ZN9ShaderLab14SerializedPassD2Ev(i12);
       i2 = HEAP32[i3 >> 2] | 0;
      } while ((i2 | 0) != (i5 | 0));
      i2 = HEAP32[i4 >> 2] | 0;
     }
     __ZdlPv(i2);
    }
    i2 = HEAP32[i7 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i12 = i2 + -88 | 0;
   HEAP32[i3 >> 2] = i12;
   __ZN9ShaderLab18SerializedPropertyD2Ev(i12);
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN22BaseUnityConnectClient17SaveSessionValuesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i6 = i9 + 16 | 0;
 i8 = i9;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZN11UnityEngine7Connect20BasePersistentValues12ToJsonStringER8UnityStr(HEAP32[i1 + 660 >> 2] | 0, i8);
 if (!(HEAP8[i1 + 109 >> 0] | 0)) {
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i3 = i2;
  i4 = gb + 1040123 | 0;
  i5 = i3 + 22 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP8[i2 + 22 >> 0] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, 22);
  i5 = i8 + 11 | 0;
  i4 = HEAP8[i5 >> 0] | 0;
  i10 = i4 << 24 >> 24 < 0;
  i3 = i10 ? HEAP32[i8 >> 2] | 0 : i8;
  i4 = i10 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i4);
  __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i7, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
  i1 = i5;
 } else {
  i5 = HEAP32[i1 + 280 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i10 = i6 + 11 | 0;
  HEAP8[i10 >> 0] = 6;
  HEAP8[i6 >> 0] = HEAP8[gb + 1041262 >> 0] | 0;
  HEAP8[i6 + 1 >> 0] = HEAP8[gb + 1041262 + 1 >> 0] | 0;
  HEAP8[i6 + 2 >> 0] = HEAP8[gb + 1041262 + 2 >> 0] | 0;
  HEAP8[i6 + 3 >> 0] = HEAP8[gb + 1041262 + 3 >> 0] | 0;
  HEAP8[i6 + 4 >> 0] = HEAP8[gb + 1041262 + 4 >> 0] | 0;
  HEAP8[i6 + 5 >> 0] = HEAP8[gb + 1041262 + 5 >> 0] | 0;
  HEAP8[i6 + 6 >> 0] = 0;
  __ZN19CloudServiceHandler8SaveFileERK8UnityStrS2_(i5, i6, i8) | 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   i10 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 66;
   HEAP32[i7 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i10, i7);
  }
  i1 = i8 + 11 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i10 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i7);
 STACKTOP = i9;
 return;
}

function __ZN21LoadResourceOperation12LoadResourceERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = i2 + 11 | 0;
 i7 = HEAP8[i3 >> 0] | 0;
 i4 = i2 + 4 | 0;
 if (!((i7 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i7 & 255) | 0)) {
  __ZN15ResourceManager6GetAllEv(i6, __Z18GetResourceManagerv() | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  __ZN15ResourceManager12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, __Z18GetResourceManagerv() | 0, i2);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
 }
 i7 = __Znwj(160) | 0;
 _memset(i7 | 0, 0, 160) | 0;
 __ZN13LoadOperationC2Ev(i7);
 HEAP32[i7 >> 2] = gb + 66208 + 8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i9 = HEAP8[i3 >> 0] | 0;
 i4 = i9 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i9 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 461356 | 0, 24, i4 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7 + 148 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i2 = i1;
 if ((i2 | 0) == (i5 | 0)) {
  HEAPF32[i7 + 60 >> 2] = Math_fround(1.0);
  i9 = i7 + 24 | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 >> 2] = 2;
  STACKTOP = i8;
  return i7 | 0;
 }
 i3 = i7 + 64 | 0;
 while (1) {
  i9 = __Z18GetResourceManagerv() | 0;
  __ZN15ResourceManager16FindDependenciesEiR13dynamic_arrayIiLj4EE(i9, HEAP32[i2 + 32 >> 2] | 0, i3);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i2;
 }
 i1 = HEAP32[gb + 1163176 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(56) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i4 = i6;
  i9 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i9;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i5 = i6;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i9 = i1 + 24 | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i6;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP8[i1 + 44 >> 0] = 0;
  HEAP32[i1 + 52 >> 2] = -1;
  HEAP32[i1 + 48 >> 2] = -1;
  HEAP32[gb + 1163176 >> 2] = i1;
 }
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(i1, i7);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN11delayed_setI4PPtrI10GUIElementENSt3__23setIS2_NS3_4lessIS2_EE11memory_poolIS2_EEEE13apply_delayedEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16 + 12 | 0;
 i9 = i16;
 i11 = i8 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i15 = i8 + 16 | 0;
 if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i12 = i8 + 4 | 0;
 i13 = i12;
 i14 = i8 + 4 | 0;
 i10 = i8 + 8 | 0;
 i7 = i1;
 while (1) {
  i5 = i7 + 4 | 0;
  if (!(HEAP8[i7 >> 0] | 0)) {
   i3 = HEAP32[i12 >> 2] | 0;
   if (i3 | 0) {
    i4 = HEAP32[i5 >> 2] | 0;
    i1 = i12;
    L10 : while (1) {
     i2 = i3;
     while (1) {
      if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) break L10;
     }
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i1 = i2;
      break;
     } else i1 = i2;
    }
    if ((i1 | 0) != (i12 | 0)) if ((i4 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i8, i6) | 0;
    }
   }
  } else {
   i1 = HEAP32[i12 >> 2] | 0;
   do if (!i1) {
    HEAP32[i6 >> 2] = i12;
    i4 = i13;
    i3 = i12;
   } else {
    i4 = HEAP32[i5 >> 2] | 0;
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if ((i4 | 0) < (i2 | 0)) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) {
       i2 = 8;
       break;
      } else i1 = i2;
     } else {
      if ((i2 | 0) >= (i4 | 0)) {
       i2 = 13;
       break;
      }
      i3 = i1 + 4 | 0;
      i2 = HEAP32[i3 >> 2] | 0;
      if (!i2) {
       i2 = 12;
       break;
      } else i1 = i2;
     }
    }
    if ((i2 | 0) == 8) {
     HEAP32[i6 >> 2] = i1;
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 12) {
     HEAP32[i6 >> 2] = i1;
     i4 = i1;
     break;
    } else if ((i2 | 0) == 13) {
     HEAP32[i6 >> 2] = i1;
     i4 = i1;
     i3 = i6;
     break;
    }
   } while (0);
   if (!(HEAP32[i3 >> 2] | 0)) {
    __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE16__construct_nodeERKS3_(i9, i8, i5);
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i4;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
    if (i2) {
     HEAP32[i8 >> 2] = i2;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i14 >> 2] | 0, i1);
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   }
  }
  i2 = i7 + 8 | 0;
  if ((i2 | 0) == (HEAP32[i15 >> 2] | 0)) break; else i7 = i2;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i16;
  return;
 }
 HEAP32[i15 >> 2] = i2 + (~((i7 - i1 | 0) >>> 3) << 3);
 STACKTOP = i16;
 return;
}

function __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864119 | 0, i6, i1 + 48 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946425 | 0, gb + 801759 | 0, i8, 0);
 i7 = i9 + 8 | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800918 | 0, i7, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800930 | 0, i7, i1 + 53 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800947 | 0, HEAP32[gb + 37320 >> 2] | 0, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15SerializeTraitsI17JointSuspension2DE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803283 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853582 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803298 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS2_9allocatorINS3_IS4_fEEEEEEEvRT_17TransferMetaFlags(i11, i8, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i4 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 3;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (i5 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj(i4, i5 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
 } else if (i5 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i5 << 3) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i5; else {
   i6 = i6 + (~((i6 + -8 - i1 | 0) >>> 3) << 3) | 0;
   HEAP32[i7 >> 2] = i6;
   i1 = i5;
  }
 } else i1 = i5;
 do if (i1 | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i11 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i6 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairINS1_IttEEfEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i6 | 0)) break L14;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairINS1_IttEEfEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i6 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13StreamingInfo8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 744923 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  i2 = i9 + 100 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i3 = i5 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i9 + 80 >> 2] = (i3 | 0) == 0 ? 0 : (HEAP32[i9 + 88 >> 2] | 0) + (i5 + -2 << 5) | 0;
  HEAP8[i9 + 128 >> 0] = 1;
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 945671 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  i4 = i9 + 100 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = i6 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i9 + 80 >> 2] = (i5 | 0) == 0 ? 0 : (HEAP32[i9 + 88 >> 2] | 0) + (i6 + -2 << 5) | 0;
  HEAP8[i9 + 128 >> 0] = 1;
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i8, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i2, 1); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 i6 = i9 + 100 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i9 + 80 >> 2] = (i7 | 0) == 0 ? 0 : (HEAP32[i9 + 88 >> 2] | 0) + (i8 + -2 << 5) | 0;
 HEAP8[i9 + 128 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI14SafeBinaryReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 2477;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE(i20, i2, i18, i10, i21, i1, i19) {
 i20 = i20 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i10 = i10 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i19 = i19 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i21 >> 2]);
 f13 = Math_fround(f11 - f12);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i15 = i21 + 4 | 0;
 f16 = Math_fround(HEAPF32[i15 >> 2]);
 f17 = Math_fround(f14 - f16);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i1 = i21 + 8 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f9 - f5);
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f4 = Math_fround(f13 * f7);
 f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f17 * f8));
 f3 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f6 * f3));
 if (f4 < Math_fround(0.0)) {
  f23 = Math_fround(HEAPF32[i19 + 20 >> 2]);
  f24 = Math_fround(HEAPF32[i19 + 24 >> 2]);
  f22 = Math_fround(HEAPF32[i19 + 16 >> 2]);
  f27 = Math_fround(f4 * f7);
  f26 = Math_fround(f4 * f8);
  f25 = Math_fround(f4 * f3);
  f11 = Math_fround(f13 - f27);
  f4 = Math_fround(f17 - f26);
  f13 = Math_fround(f6 - f25);
  f14 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) - f12);
  f9 = Math_fround(Math_fround(HEAPF32[i18 + 4 >> 2]) - f16);
  f9 = Math_fround(Math_fround(Math_fround(f7 * f14) + Math_fround(f8 * f9)) + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i18 + 8 >> 2]) - f5)));
  f14 = Math_fround(f7 * f9);
  f16 = Math_fround(f8 * f9);
  f17 = Math_fround(f3 * f9);
  f8 = Math_fround(f27 - f14);
  f12 = Math_fround(f26 - f16);
  f7 = Math_fround(f25 - f17);
  i18 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f4 * f4)) + Math_fround(f13 * f13)) - Math_fround(f24 * Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f8 * f8) + Math_fround(f12 * f12))))) >= Math_fround(0.0);
  f11 = i18 ? f11 : Math_fround(0.0);
  f12 = i18 ? f4 : Math_fround(0.0);
  f8 = Math_fround(Math_fround(1.0) - f23);
  f11 = Math_fround(f8 * f11);
  f12 = Math_fround(f8 * f12);
  f13 = Math_fround(f8 * (i18 ? f13 : Math_fround(0.0)));
  i18 = i20 + 4 | 0;
  i19 = i20 + 8 | 0;
  f14 = Math_fround(f11 - Math_fround(f22 * f14));
  f16 = Math_fround(f12 - Math_fround(f22 * f16));
  f17 = Math_fround(f13 - Math_fround(f22 * f17));
  i10 = f9 >= Math_fround(0.0);
  f14 = i10 ? f11 : f14;
  HEAPF32[i20 >> 2] = f14;
  f16 = i10 ? f12 : f16;
  HEAPF32[i18 >> 2] = f16;
  f17 = i10 ? f13 : f17;
  HEAPF32[i19 >> 2] = f17;
  HEAPF32[i20 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f14);
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f16);
  HEAPF32[i19 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f17);
  return;
 } else {
  HEAPF32[i20 >> 2] = f11;
  HEAPF32[i20 + 4 >> 2] = f14;
  HEAPF32[i20 + 8 >> 2] = f9;
  return;
 }
}

function __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 744104 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801720 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 744985 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK9Rigidbody(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 if (!i15) return;
 i16 = i1 + 136 | 0;
 i13 = i1 + 104 | 0;
 i12 = 0;
 do {
  i4 = (i12 | 0) == 0 ? i16 : i13;
  i1 = HEAP32[i4 >> 2] | 0;
  i14 = i4 + 4 | 0;
  i3 = i1;
  i2 = i1;
  if ((i3 | 0) != (i14 | 0)) if (HEAP8[i3 + 24 >> 0] | 0) while (1) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i14 | 0)) {
    i1 = i14;
    break;
   }
   if (!(HEAP8[i1 + 24 >> 0] | 0)) break; else i2 = i1;
  }
  i2 = i1;
  L20 : do if ((i2 | 0) != (i14 | 0)) {
   i9 = i4 + 12 | 0;
   i10 = i4 + 24 | 0;
   i11 = i4 + 28 | 0;
   i8 = i4 + 16 | 0;
   i4 = i2;
   while (1) {
    i2 = HEAP32[i4 + 32 >> 2] | 0;
    if (!i2) i3 = 0; else i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
    i2 = HEAP32[i4 + 28 >> 2] | 0;
    if (!i2) i2 = 0; else i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
    if ((i3 | 0) == (i15 | 0) | (i2 | 0) == (i15 | 0)) {
     i2 = i4 + 24 | 0;
     if (!(HEAP8[i2 >> 0] | 0)) {
      HEAP8[i2 >> 0] = 1;
      i3 = i4 + 16 | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i5 = i4 + 1 | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i5 >>> 0 > i7 >>> 0) {
       i2 = i6 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i11 >> 2] = i2;
        HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 3, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
        HEAP32[i11 >> 2] = i2;
        HEAP32[i9 >> 2] = i7;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = i5;
      i5 = i3;
      i6 = HEAP32[i5 + 4 >> 2] | 0;
      i7 = (HEAP32[i9 >> 2] | 0) + (i4 << 3) | 0;
      HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i7 + 4 >> 2] = i6;
     }
    }
    while (1) {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (i14 | 0)) break L20;
     if (!(HEAP8[i2 + 24 >> 0] | 0)) break; else i1 = i2;
    }
    if ((i2 | 0) == (i14 | 0)) break; else {
     i1 = i2;
     i4 = i2;
    }
   }
  } while (0);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 2);
 return;
}

function __ZL23OutOfBoundsReadingErroriiiR6Object(i1, i5, i6, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i11 = i12 + 8 | 0;
 i10 = i12;
 i7 = i12 + 72 | 0;
 i4 = i12 + 68 | 0;
 i8 = i12 + 56 | 0;
 i9 = i12 + 40 | 0;
 if ((i1 | 0) != 114) {
  HEAP32[i3 >> 2] = __ZN6Object15ClassIDToStringEi(i1) | 0;
  HEAP32[i3 + 4 >> 2] = i6;
  HEAP32[i3 + 8 >> 2] = i5;
  __Z6FormatPKcz(i7, gb + 589092 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 588245 | 0, 1812, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i12;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 588841 | 0, 32);
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i1 = 0; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i4);
    i2 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  if (i1 | 0) {
   __ZNK10MonoScript22GetScriptFullClassNameEv(i9, i1);
   i4 = i9 + 11 | 0;
   HEAP32[i10 >> 2] = (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
   __Z6FormatPKcz(i7, gb + 588874 | 0, i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i7) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i4 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 12 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i10 + 4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i10);
   }
  }
 }
 HEAP32[i11 >> 2] = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i11 + 8 >> 2] = i5;
 __Z6FormatPKcz(i7, gb + 588887 | 0, i11);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 588245 | 0, 1808, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i12;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 i17 = HEAP32[i16 + 200 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2]);
 f15 = Math_fround(f13 * Math_fround(HEAPF32[i16 + 96 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 112 >> 2])));
 f15 = Math_fround(f15 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 128 >> 2])));
 f11 = Math_fround(f13 * Math_fround(HEAPF32[i16 + 100 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 116 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 132 >> 2])));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i16 + 104 >> 2]));
 f14 = Math_fround(f13 + Math_fround(f14 * Math_fround(HEAPF32[i16 + 120 >> 2])));
 f7 = Math_fround(f14 + Math_fround(f7 * Math_fround(HEAPF32[i16 + 136 >> 2])));
 f14 = Math_fround(HEAPF32[i10 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i10 + 52 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 56 >> 2]);
 f9 = Math_fround(f15 * Math_fround(HEAPF32[i10 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 16 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 32 >> 2])));
 f8 = Math_fround(f15 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 20 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 36 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i10 + 8 >> 2]));
 f11 = Math_fround(f15 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 24 >> 2])));
 f9 = Math_fround(f14 + f9);
 f8 = Math_fround(f13 + f8);
 f7 = Math_fround(f12 + Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 40 >> 2]))));
 i6 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 200 >> 2] | 0;
 i10 = HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAPF32[i4 >> 2] = f9;
 HEAPF32[i4 + 4 >> 2] = f8;
 HEAPF32[i4 + 8 >> 2] = f7;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = i10;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i10 = 0, i11 = 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 i2 = i8 + 12 | 0;
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f1 + f3);
 i5 = i8 + 24 | 0;
 f6 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f7 = Math_fround(f4 + f6);
 if (f7 >= Math_fround(0.0)) {
  f6 = Math_fround(Math_sqrt(Math_fround(f7 + Math_fround(1.0))));
  HEAPF32[i9 + 12 >> 2] = Math_fround(f6 * Math_fround(.5));
  f6 = Math_fround(Math_fround(.5) / f6);
  f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  HEAPF32[i9 >> 2] = Math_fround(f6 * Math_fround(f7 - Math_fround(HEAPF32[i5 + 4 >> 2])));
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i9 + 4 >> 2] = Math_fround(f6 * Math_fround(f7 - Math_fround(HEAPF32[i8 + 8 >> 2])));
  f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  HEAPF32[i9 + 8 >> 2] = Math_fround(f6 * Math_fround(f7 - Math_fround(HEAPF32[i2 >> 2])));
  return;
 }
 i10 = f3 > f1 & 1;
 i11 = f6 > Math_fround(HEAPF32[i8 + (i10 * 12 | 0) + (i10 << 2) >> 2]);
 switch ((i11 ? 2 : i10) | 0) {
 case 0:
  {
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 - Math_fround(f3 + f6)) + Math_fround(1.0))));
   HEAPF32[i9 >> 2] = Math_fround(f7 * Math_fround(.5));
   f7 = Math_fround(Math_fround(.5) / f7);
   HEAPF32[i9 + 4 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(HEAPF32[i8 + 4 >> 2])));
   HEAPF32[i9 + 8 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) + Math_fround(HEAPF32[i5 >> 2])));
   HEAPF32[i9 + 12 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - Math_fround(HEAPF32[i5 + 4 >> 2])));
   return;
  }
 case 1:
  {
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 - Math_fround(f1 + f6)) + Math_fround(1.0))));
   HEAPF32[i9 + 4 >> 2] = Math_fround(f7 * Math_fround(.5));
   f7 = Math_fround(Math_fround(.5) / f7);
   HEAPF32[i9 + 8 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) + Math_fround(HEAPF32[i2 + 8 >> 2])));
   HEAPF32[i9 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(HEAPF32[i8 + 4 >> 2])));
   HEAPF32[i9 + 12 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i5 >> 2]) - Math_fround(HEAPF32[i8 + 8 >> 2])));
   return;
  }
 case 2:
  {
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 - f4) + Math_fround(1.0))));
   HEAPF32[i9 + 8 >> 2] = Math_fround(f7 * Math_fround(.5));
   f7 = Math_fround(Math_fround(.5) / f7);
   HEAPF32[i9 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) + Math_fround(HEAPF32[i5 >> 2])));
   HEAPF32[i9 + 4 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) + Math_fround(HEAPF32[i2 + 8 >> 2])));
   HEAPF32[i9 + 12 >> 2] = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - Math_fround(HEAPF32[i2 >> 2])));
   return;
  }
 default:
  {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   return;
  }
 }
}

function __ZN5physx33solveContact_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i13, i12, i11) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 if (i12 >>> 0 > 1) {
  i1 = 1;
  do {
   i9 = i1 + -1 | 0;
   __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i13 + (i9 << 5) | 0, i11);
   i2 = HEAP32[i13 + (i9 << 5) + 16 >> 2] | 0;
   i9 = HEAP16[i13 + (i9 << 5) + 26 >> 1] | 0;
   i10 = i2 + ((i9 & 65535) << 4) | 0;
   if (i9 << 16 >> 16) do {
    i5 = i2 + 32 | 0;
    i3 = HEAP8[i2 + 5 >> 0] | 0;
    i9 = HEAP8[i2 + 6 >> 0] | 0;
    i4 = HEAP8[i2 >> 0] | 0;
    i8 = i4 << 24 >> 24 == 3 ? 112 : 80;
    if (!(i3 << 24 >> 24)) {
     i8 = 32;
     i3 = i4;
     i4 = i5;
    } else {
     i7 = i3 & 255;
     i4 = i5;
     i5 = 0;
     while (1) {
      i3 = i4 + 44 | 0;
      f6 = Math_fround(HEAPF32[i3 >> 2]);
      i14 = f6 > Math_fround(0.0);
      HEAP32[i3 >> 2] = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i7 | 0)) break; else i4 = i4 + i8 | 0;
     }
     i4 = (Math_imul(i8, i7) | 0) + 32 | 0;
     i8 = i4;
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = i2 + i4 | 0;
    }
    i7 = i3 << 24 >> 24 == 3 ? 128 : 96;
    if (!(i9 << 24 >> 24)) i2 = i4; else {
     i5 = i9 & 255;
     i3 = i4;
     i4 = 0;
     while (1) {
      HEAP32[i3 + 44 >> 2] = 0;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i7 | 0;
     }
     i2 = i2 + ((Math_imul(i7, i5) | 0) + i8) | 0;
    }
   } while (i2 >>> 0 < i10 >>> 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 }
 i14 = i12 + -1 | 0;
 __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i13 + (i14 << 5) | 0, i11);
 i1 = HEAP32[i13 + (i14 << 5) + 16 >> 2] | 0;
 i14 = HEAP16[i13 + (i14 << 5) + 26 >> 1] | 0;
 i9 = i1 + ((i14 & 65535) << 4) | 0;
 if (!(i14 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i8 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i7 = 32;
   i2 = i3;
   i3 = i4;
  } else {
   i5 = i2 & 255;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f6 = Math_fround(HEAPF32[i2 >> 2]);
    i14 = f6 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i3 = (Math_imul(i7, i5) | 0) + 32 | 0;
   i7 = i3;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + i3 | 0;
  }
  i5 = i2 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i8 << 24 >> 24)) i1 = i3; else {
   i4 = i8 & 255;
   i2 = i3;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i5 | 0;
   }
   i1 = i1 + ((Math_imul(i5, i4) | 0) + i7) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj670ES2_RKNS_30PxVehicleAckermannGeometryDataES6_EEKNS_43PxVehicleAckermannGeometryDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 16 | 0;
 i7 = i8 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj553ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj554ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj555ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj556ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 48 | 0, 3);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = gb + 148336 + 8;
 i4 = HEAP32[i8 + 160 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0);
 i4 = i8 + 128 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 124 | 0;
  i6 = i8 + 4 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) {
    i1 = HEAP32[i6 >> 2] | 0;
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i4 >> 2] = 0;
 i5 = i8 + 152 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 4 | 0;
  i6 = i8 + 148 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if (i3) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 i5 = i8 + 232 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 4 | 0;
  i6 = i8 + 228 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if (i3) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 216 >> 2] = gb + 148628 + 8;
 i7 = HEAP32[i8 + 236 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i7 = HEAP32[i8 + 220 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i8 + 228 >> 2] | 0);
 }
 HEAP32[i8 + 164 >> 2] = gb + 148596 + 8;
 i1 = HEAP32[i8 + 176 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i8 + 168 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 HEAP32[i8 + 136 >> 2] = gb + 148320 + 8;
 i7 = HEAP32[i8 + 156 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i7 = HEAP32[i8 + 140 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i8 + 148 >> 2] | 0);
 }
 HEAP32[i8 + 112 >> 2] = gb + 148644 + 8;
 i7 = HEAP32[i8 + 132 >> 2] | 0;
 if ((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0) {
  i7 = HEAP32[i8 + 116 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i8 + 124 >> 2] | 0);
 }
 HEAP32[i8 + 60 >> 2] = gb + 148476 + 8;
 i1 = HEAP32[i8 + 72 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i8 + 64 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 HEAP32[i8 + 8 >> 2] = gb + 148460 + 8;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (!i1) return;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 return;
}

function __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 i11 = i1 & 2147483647;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 i12 = i9 + 880 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) >= (i10 | 0)) {
  HEAP32[i12 >> 2] = i10;
  return;
 }
 i8 = i1 << 2;
 i6 = i7 << 2;
 if (!i7) {
  i1 = i2;
  do {
   i2 = i9 + 560 + (i1 * 20 | 0) | 0;
   i3 = i9 + 560 + (i1 * 20 | 0) + 16 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i11 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i11;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i8, 4, i9 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, i9 + 560 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i9 + 560 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i11;
    HEAP32[i2 >> 2] = i7;
    break;
   } while (0);
   HEAP32[i9 + 560 + (i1 * 20 | 0) + 12 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
  HEAP32[i12 >> 2] = i10;
  return;
 }
 do {
  i4 = i9 + 560 + (i2 * 20 | 0) | 0;
  i5 = i9 + 560 + (i2 * 20 | 0) + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i11 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i5 >> 2] = i11;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i8, 4, i9 + 560 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, i9 + 560 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i9 + 560 + (i2 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i11;
   HEAP32[i4 >> 2] = i1;
   i1 = i11;
   break;
  } while (0);
  i3 = i9 + 560 + (i2 * 20 | 0) + 12 | 0;
  HEAP32[i3 >> 2] = i7;
  do if ((i1 & 2147483647) >>> 0 < i7 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i5 >> 2] = i7;
   i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i6, 4, i9 + 560 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i4 >> 2] = i3;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i9 + 560 + (i2 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i4 >> 2] = i1;
   i3 = i1;
   break;
  } else i3 = HEAP32[i4 >> 2] | 0; while (0);
  i1 = 0;
  do {
   i5 = i3 + (i1 << 2) | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i7 >>> 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 HEAP32[i12 >> 2] = i10;
 return;
}

function __ZN15SerializeTraitsI11JointSpringE8TransferI14SafeBinaryReadEEvRS0_RT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827416 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827423 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 827430 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z15CreateUdpSocketPKctRi(i1, i2, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 48 | 0;
 i8 = i13 + 40 | 0;
 i7 = i13 + 32 | 0;
 i5 = i13 + 24 | 0;
 i4 = i13 + 16 | 0;
 i3 = i13 + 8 | 0;
 i6 = i13;
 i9 = i13 + 56 | 0;
 i11 = i13 + 52 | 0;
 i14 = i13 + 88 | 0;
 HEAP32[i6 >> 2] = i2 & 65535;
 _snprintf(i14, 6, gb + 458892 | 0, i6) | 0;
 i2 = i9 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 2;
 HEAP32[i9 >> 2] = 1;
 i1 = _getaddrinfo(i1 | 0, i14 | 0, i9 | 0, i11 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = _gai_strerror(i1 | 0) | 0;
  _printf_console(gb + 458896 | 0, i3);
  i14 = -1;
  STACKTOP = i13;
  return i14 | 0;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i1 = i9;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) == 10) {
   i2 = _socket(10, HEAP32[i1 + 8 >> 2] | 524288, HEAP32[i1 + 12 >> 2] | 0) | 0;
   if ((i2 | 0) >= 0) {
    if (!i2) {
     i2 = 0;
     i3 = 10;
     break;
    }
    HEAP32[i6 >> 2] = 0;
    if (!(__Z15setsockopt_stubiiiPKvj(i2, 41, 26, i6, 4) | 0)) {
     i3 = 8;
     break;
    }
    _printf_console(gb + 458913 | 0, i4);
    _close(i2) | 0;
   }
  }
  i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
  if (!i1) {
   i3 = 13;
   break;
  }
 }
 L13 : do if ((i3 | 0) == 8) i3 = 10; else if ((i3 | 0) == 13) {
  HEAP32[i11 >> 2] = i9;
  i2 = i9;
  while (1) {
   i1 = _socket(HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 524288, HEAP32[i2 + 12 >> 2] | 0) | 0;
   if ((i1 | 0) >= 0) {
    if (!i1) {
     i1 = 0;
     break;
    }
    if ((HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0) != 10) break;
    HEAP32[i6 >> 2] = 0;
    if (!(__Z15setsockopt_stubiiiPKvj(i1, 41, 26, i6, 4) | 0)) {
     i3 = 18;
     break;
    }
    _printf_console(gb + 458913 | 0, i7);
    _close(i1) | 0;
    i1 = -1;
   }
   i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i11 >> 2] = i2;
   if (!i2) {
    i3 = 24;
    break L13;
   }
  }
  i14 = HEAP32[i11 >> 2] | 0;
  if (!(_bind(i1, HEAP32[i14 + 20 >> 2] | 0, HEAP32[i14 + 16 >> 2] | 0) | 0)) {
   i2 = i1;
   i3 = 23;
  } else {
   _printf_console(gb + 458947 | 0, i8);
   _close(i1) | 0;
   i2 = -1;
   i3 = 23;
  }
 } while (0);
 if ((i3 | 0) == 10) {
  i14 = HEAP32[i11 >> 2] | 0;
  if (!(_bind(i2, HEAP32[i14 + 20 >> 2] | 0, HEAP32[i14 + 16 >> 2] | 0) | 0)) i3 = 23; else {
   _printf_console(gb + 458947 | 0, i5);
   _close(i2) | 0;
   i2 = -1;
   i3 = 23;
  }
 }
 if ((i3 | 0) == 23) {
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) {
   i1 = i2;
   i3 = 24;
  }
 }
 if ((i3 | 0) == 24) {
  _printf_console(gb + 459069 | 0, i10);
  i2 = i1;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = HEAP32[i1 + 4 >> 2];
 _freeaddrinfo(i9);
 i14 = i2;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN6Camera8CopyFromERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i13 = i4;
 i5 = i1 + 28 | 0;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 28940 | 0) | 0;
 i3 = i2 + 28 | 0;
 i14 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform13GetLocalScaleEv(i6, i14);
 __ZN9Transform13SetLocalScaleERK8Vector3f(i7, i6);
 __ZNK9Transform11GetPositionEv(i6, i14);
 __ZN9Transform11SetPositionERK8Vector3f(i7, i6);
 __ZNK9Transform11GetRotationEv(i13, i14);
 f12 = Math_fround(HEAPF32[i13 >> 2]);
 f11 = Math_fround(f12 * f12);
 f10 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f10 * f10));
 f9 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f9 * f9));
 f8 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f11 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f8 * f8))));
 f10 = Math_fround(f10 / f11);
 f9 = Math_fround(f9 / f11);
 f8 = Math_fround(f8 / f11);
 HEAPF32[i6 >> 2] = Math_fround(f12 / f11);
 HEAPF32[i6 + 4 >> 2] = f10;
 HEAPF32[i6 + 8 >> 2] = f9;
 HEAPF32[i6 + 12 >> 2] = f8;
 __ZN9Transform11SetRotationERK11Quaternionf(i7, i6);
 __ZN10GameObject8SetLayerEi(HEAP32[i5 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0);
 i3 = i1 + 36 | 0;
 i5 = i2 + 36 | 0;
 i6 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i3 = i1 + 100 | 0;
 i5 = i2 + 100 | 0;
 i6 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i3 = i1 + 164 | 0;
 i5 = i2 + 164 | 0;
 i6 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i3 = i1 + 228 | 0;
 i5 = i2 + 228 | 0;
 i6 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 _memcpy(i1 + 292 | 0, i2 + 292 | 0, 388) | 0;
 i3 = i1 + 680 | 0;
 i5 = i2 + 680 | 0;
 i6 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 i3 = i1 + 744 | 0;
 i5 = i2 + 744 | 0;
 i6 = i3 + 88 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  i3 = i3 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i3 | 0) < (i6 | 0));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 832 | 0, i2 + 832 | 0) | 0;
 HEAP32[i1 + 844 >> 2] = HEAP32[i2 + 844 >> 2];
 i7 = HEAP32[i2 + 852 >> 2] | 0;
 i13 = HEAP32[i2 + 856 >> 2] | 0;
 i14 = HEAP32[i2 + 860 >> 2] | 0;
 HEAP32[i1 + 848 >> 2] = HEAP32[i2 + 848 >> 2];
 HEAP32[i1 + 852 >> 2] = i7;
 HEAP32[i1 + 856 >> 2] = i13;
 HEAP32[i1 + 860 >> 2] = i14;
 _memcpy(i1 + 864 | 0, i2 + 864 | 0, 249) | 0;
 STACKTOP = i4;
 return;
}

function __Z28Texture2D_CUSTOM_GetPixels32P12Il2CppObjecti(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i3 = i8;
 i1 = i8 + 24 | 0;
 i4 = i8 + 12 | 0;
 HEAP32[i1 >> 2] = i7;
 if (!i7) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i2) {
  i9 = i7;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 if ((i6 | 0) >= 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
  if ((__ZNK9Texture2D16CountDataMipmapsEv(i1) | 0) > (i6 | 0)) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
   i2 = HEAP32[i1 + 52 >> 2] | 0;
   if (!i2) {
    i1 = HEAP32[i1 + 92 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? 5 : i1;
   } else i1 = HEAP32[i2 + 36 >> 2] | 0;
   i3 = __Z33GetMinimumTextureMipSizeForFormat13TextureFormat(i1) | 0;
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
   i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i6;
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
   if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
   i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0) >> i6;
   i1 = Math_imul((i2 | 0) < (i3 | 0) ? i3 : i2, (i1 | 0) < (i3 | 0) ? i3 : i1) | 0;
   i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0, 4, i1) | 0;
   i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
   i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
   if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
   __ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i(i4, i6, i3, i1) | 0;
   i9 = i2;
   STACKTOP = i8;
   return i9 | 0;
  }
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 HEAP32[i5 >> 2] = __ZNK9Texture2D16CountDataMipmapsEv(i1) | 0;
 __Z6FormatPKcz(i4, gb + 570768 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 570137 | 0, 555, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i3 + 40 | 0;
 i18 = i3 + 24 | 0;
 i19 = i3 + 8 | 0;
 i21 = i3;
 i23 = i2 + 32 | 0;
 i22 = HEAP32[i23 + 4 >> 2] | 0;
 i2 = i21;
 HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i2 + 4 >> 2] = i22;
 HEAP32[i20 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i20, i18, i19);
 f5 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i19 >> 2]);
 f6 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f9 = Math_fround(f5 * Math_fround(-2.0));
 f4 = Math_fround(f5 * Math_fround(2.0));
 f17 = Math_fround(f5 * f9);
 f14 = Math_fround(f10 * Math_fround(-2.0));
 f8 = Math_fround(f10 * Math_fround(2.0));
 f11 = Math_fround(f10 * f14);
 f15 = Math_fround(Math_fround(f17 + f11) + Math_fround(1.0));
 f12 = Math_fround(Math_fround(Math_fround(f7 * f4) + Math_fround(f6 * f8)) + Math_fround(0.0));
 f9 = Math_fround(Math_fround(Math_fround(f9 * f6) + Math_fround(f7 * f8)) + Math_fround(0.0));
 f13 = Math_fround(f7 * Math_fround(2.0));
 f16 = Math_fround(f7 * Math_fround(-2.0));
 f7 = Math_fround(f7 * f16);
 f14 = Math_fround(Math_fround(Math_fround(f5 * f13) + Math_fround(f6 * f14)) + Math_fround(0.0));
 f11 = Math_fround(Math_fround(f7 + f11) + Math_fround(1.0));
 f8 = Math_fround(Math_fround(Math_fround(f6 * f13) + Math_fround(f5 * f8)) + Math_fround(0.0));
 f13 = Math_fround(Math_fround(Math_fround(f4 * f6) + Math_fround(f13 * f10)) + Math_fround(0.0));
 f10 = Math_fround(Math_fround(Math_fround(f6 * f16) + Math_fround(f4 * f10)) + Math_fround(0.0));
 f7 = Math_fround(Math_fround(f17 + f7) + Math_fround(1.0));
 f17 = Math_fround(HEAPF32[i18 >> 2]);
 f4 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f17 = Math_fround(-f17);
 f4 = Math_fround(-f4);
 f16 = Math_fround(-Math_fround(HEAPF32[i18 + 8 >> 2]));
 f6 = Math_fround(Math_fround(f15 * f17) + Math_fround(Math_fround(f9 * f16) + Math_fround(f12 * f4)));
 f5 = Math_fround(Math_fround(f14 * f17) + Math_fround(Math_fround(f8 * f16) + Math_fround(f11 * f4)));
 f4 = Math_fround(Math_fround(f13 * f17) + Math_fround(Math_fround(f7 * f16) + Math_fround(f10 * f4)));
 HEAPF32[i1 >> 2] = f15;
 HEAPF32[i1 + 4 >> 2] = f14;
 HEAPF32[i1 + 8 >> 2] = f13;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i1 + 16 >> 2] = f12;
 HEAPF32[i1 + 20 >> 2] = f11;
 HEAPF32[i1 + 24 >> 2] = f10;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = f9;
 HEAPF32[i1 + 36 >> 2] = f8;
 HEAPF32[i1 + 40 >> 2] = f7;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAPF32[i1 + 48 >> 2] = f6;
 HEAPF32[i1 + 52 >> 2] = f5;
 HEAPF32[i1 + 56 >> 2] = f4;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 STACKTOP = i3;
 return;
}

function __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i1, i12, i5) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (i4 | 0) == 0;
 if (i2) i11 = 4; else if (!(HEAP8[i4 + 24 >> 0] | 0)) i11 = 4; else {
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (Math_imul(HEAP32[i1 + 20 >> 2] | 0, i5) | 0) >> 2] | 0;
  i11 = 5;
 }
 if ((i11 | 0) == 4) {
  i1 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (Math_imul(HEAP32[i1 + 20 >> 2] | 0, i5) | 0) >> 2] | 0;
  if (i1 | 0) {
   i1 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
   i11 = 5;
  }
 }
 if ((i11 | 0) == 5) {
  i10 = i1;
  if (i1 | 0) {
   if (i2) i11 = 13; else {
    i1 = HEAP32[i4 + 36 >> 2] | 0;
    if (!i1) i11 = 13; else {
     i3 = HEAP32[i4 + 32 >> 2] | 0;
     i8 = i3 + (i1 + (i5 << 5)) | 0;
     if (!i8) i11 = 13; else {
      i2 = HEAP32[i8 >> 2] | 0;
      if ((i2 | 0) == -1) i11 = 12; else {
       i1 = i3 + ((HEAP32[i4 + 40 >> 2] | 0) + (i2 << 5)) | 0;
       if (!i1) i11 = 12; else {
        i9 = HEAP32[i1 >> 2] | 0;
        i7 = HEAP32[i6 >> 2] | 0;
        i5 = HEAP32[i7 + (HEAP32[i7 + 180 >> 2] | 0) + (i2 << 2) >> 2] | 0;
        i3 = i7 + (HEAP32[i7 + 184 >> 2] | 0) | 0;
        i4 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
        i3 = (HEAP32[i3 + (i2 + 1 << 2) >> 2] | 0) - i4 | 0;
        HEAP32[i6 + 92 >> 2] = i2;
        HEAP32[i6 + 96 >> 2] = i1;
        HEAP32[i6 + 100 >> 2] = i9;
        HEAP32[i6 + 104 >> 2] = i7;
        HEAP32[i6 + 108 >> 2] = i5;
        HEAP32[i6 + 112 >> 2] = i4;
        HEAP32[i6 + 116 >> 2] = i3;
        i6 = i9;
       }
      }
      if ((i11 | 0) == 12) {
       i7 = HEAP32[i6 >> 2] | 0;
       HEAP32[i6 + 92 >> 2] = 0;
       HEAP32[i6 + 96 >> 2] = 0;
       HEAP32[i6 + 100 >> 2] = i7;
       HEAP32[i6 + 104 >> 2] = i7;
       HEAP32[i6 + 108 >> 2] = 0;
       HEAP32[i6 + 112 >> 2] = 0;
       HEAP32[i6 + 116 >> 2] = 0;
       i2 = 0;
       i1 = 0;
       i6 = i7;
       i5 = 0;
       i4 = 0;
       i3 = 0;
      }
      i9 = i8;
      i8 = HEAP32[i8 + 16 >> 2] | 0;
     }
    }
   }
   if ((i11 | 0) == 13) {
    i7 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 + 92 >> 2] = 0;
    HEAP32[i6 + 96 >> 2] = 0;
    HEAP32[i6 + 100 >> 2] = i7;
    HEAP32[i6 + 104 >> 2] = i7;
    HEAP32[i6 + 108 >> 2] = 0;
    HEAP32[i6 + 112 >> 2] = 0;
    HEAP32[i6 + 116 >> 2] = 0;
    i9 = 0;
    i8 = i5;
    i2 = 0;
    i1 = 0;
    i6 = i7;
    i5 = 0;
    i4 = 0;
    i3 = 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i12 + 4 >> 2] = i1;
   HEAP32[i12 + 8 >> 2] = i6;
   HEAP32[i12 + 12 >> 2] = i7;
   HEAP32[i12 + 16 >> 2] = i5;
   HEAP32[i12 + 20 >> 2] = i4;
   HEAP32[i12 + 24 >> 2] = i3;
   HEAP32[i12 + 28 >> 2] = i10;
   HEAP32[i12 + 32 >> 2] = i9;
   HEAP32[i12 + 36 >> 2] = i8;
   return;
  }
 }
 HEAP32[i12 >> 2] = -1;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 28 >> 2] = 0;
 HEAP32[i12 + 32 >> 2] = 0;
 return;
}

function _cff_parse_private_dict(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i1 + 412 >> 2] | 0;
 i8 = i1 + 24 | 0;
 if ((HEAP32[i1 + 404 >> 2] | 0) >>> 0 < i8 >>> 0) {
  i10 = 161;
  return i10 | 0;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = i1 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP8[i3 >> 0] | 0;
 L4 : do if (i6 << 24 >> 24 == 30) {
  i1 = (_cff_parse_real(i3, i2, 0, 0) | 0) >> 16;
  i10 = 16;
 } else {
  i4 = i3 + 1 | 0;
  i5 = i6 & 255;
  switch (i6 << 24 >> 24) {
  case 28:
   {
    if ((i3 + 3 | 0) >>> 0 > i2 >>> 0) {
     i5 = i2;
     i1 = 0;
     break L4;
    }
    i1 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i3 + 2 >> 0] | 0)) << 16 >> 16;
    i10 = 16;
    break L4;
   }
  case 29:
   {
    if ((i3 + 5 | 0) >>> 0 > i2 >>> 0) {
     i5 = i2;
     i1 = 0;
     break L4;
    }
    i1 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i3 + 3 >> 0] | 0) << 8 | (HEAPU8[i3 + 4 >> 0] | 0);
    i10 = 16;
    break L4;
   }
  default:
   {
    if ((i6 & 255) < 247) {
     i1 = i5 + -139 | 0;
     i10 = 16;
     break L4;
    }
    i1 = (i3 + 2 | 0) >>> 0 > i2 >>> 0;
    if ((i6 & 255) < 251) {
     if (i1) {
      i5 = i2;
      i1 = 0;
      break L4;
     }
     i1 = (HEAPU8[i4 >> 0] | 0 | (i5 << 8) + -63232) + 108 | 0;
     i10 = 16;
     break L4;
    } else {
     if (i1) {
      i5 = i2;
      i1 = 0;
      break L4;
     }
     i1 = (251 - i5 << 8) + -108 - (HEAPU8[i4 >> 0] | 0) | 0;
     i10 = 16;
     break L4;
    }
   }
  }
 } while (0);
 do if ((i10 | 0) == 16) if ((i1 | 0) < 0) {
  i10 = 3;
  return i10 | 0;
 } else {
  i5 = HEAP32[i7 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i9 + 120 >> 2] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 L27 : do if (i2 << 24 >> 24 == 30) {
  i1 = (_cff_parse_real(i5, i1, 0, 0) | 0) >> 16;
  i10 = 32;
 } else {
  i3 = i5 + 1 | 0;
  i4 = i2 & 255;
  switch (i2 << 24 >> 24) {
  case 28:
   {
    if ((i5 + 3 | 0) >>> 0 > i1 >>> 0) {
     i1 = 0;
     break L27;
    }
    i1 = ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i5 + 2 >> 0] | 0)) << 16 >> 16;
    i10 = 32;
    break L27;
   }
  case 29:
   {
    if ((i5 + 5 | 0) >>> 0 > i1 >>> 0) {
     i1 = 0;
     break L27;
    }
    i1 = (HEAPU8[i5 + 2 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i5 + 3 >> 0] | 0) << 8 | (HEAPU8[i5 + 4 >> 0] | 0);
    i10 = 32;
    break L27;
   }
  default:
   {
    if ((i2 & 255) < 247) {
     i1 = i4 + -139 | 0;
     i10 = 32;
     break L27;
    }
    i1 = (i5 + 2 | 0) >>> 0 > i1 >>> 0;
    if ((i2 & 255) < 251) {
     if (i1) {
      i1 = 0;
      break L27;
     }
     i1 = (HEAPU8[i3 >> 0] | 0 | (i4 << 8) + -63232) + 108 | 0;
     i10 = 32;
     break L27;
    } else {
     if (i1) {
      i1 = 0;
      break L27;
     }
     i1 = (251 - i4 << 8) + -108 - (HEAPU8[i3 >> 0] | 0) | 0;
     i10 = 32;
     break L27;
    }
   }
  }
 } while (0);
 if ((i10 | 0) == 32) if ((i1 | 0) < 0) {
  i10 = 3;
  return i10 | 0;
 }
 HEAP32[i9 + 116 >> 2] = i1;
 i10 = 0;
 return i10 | 0;
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI9JSONWriteEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT__4448(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 4426;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __Z25GetTransformationMatricesPN4math8float3x3ES1_bbRK10Matrix4x4fS4_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!(i3 ^ i4)) {
  HEAP32[i1 >> 2] = 1065353216;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 1065353216;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 1065353216;
  HEAP32[i2 >> 2] = 1065353216;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 1065353216;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAP32[i2 + 32 >> 2] = 1065353216;
  i6 = 0;
  return i6 | 0;
 }
 if (i3) {
  i12 = HEAP32[i5 + 4 >> 2] | 0;
  i11 = HEAP32[i5 + 8 >> 2] | 0;
  i4 = HEAP32[i5 + 16 >> 2] | 0;
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  i7 = HEAP32[i5 + 24 >> 2] | 0;
  i8 = HEAP32[i5 + 32 >> 2] | 0;
  i9 = HEAP32[i5 + 36 >> 2] | 0;
  i10 = HEAP32[i5 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i12;
  HEAP32[i1 + 8 >> 2] = i11;
  HEAP32[i1 + 12 >> 2] = i4;
  HEAP32[i1 + 16 >> 2] = i3;
  HEAP32[i1 + 20 >> 2] = i7;
  HEAP32[i1 + 24 >> 2] = i8;
  HEAP32[i1 + 28 >> 2] = i9;
  HEAP32[i1 + 32 >> 2] = i10;
  i10 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = HEAP32[i6 + 8 >> 2] | 0;
  i8 = HEAP32[i6 + 16 >> 2] | 0;
  i7 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 + 24 >> 2] | 0;
  i3 = HEAP32[i6 + 32 >> 2] | 0;
  i4 = HEAP32[i6 + 36 >> 2] | 0;
  i5 = HEAP32[i6 + 40 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = i10;
  HEAP32[i2 + 8 >> 2] = i9;
  HEAP32[i2 + 12 >> 2] = i8;
  HEAP32[i2 + 16 >> 2] = i7;
  HEAP32[i2 + 20 >> 2] = i1;
  HEAP32[i2 + 24 >> 2] = i3;
  HEAP32[i2 + 28 >> 2] = i4;
  HEAP32[i2 + 32 >> 2] = i5;
  i6 = 1;
  return i6 | 0;
 } else {
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i12 = HEAP32[i6 + 8 >> 2] | 0;
  i11 = HEAP32[i6 + 16 >> 2] | 0;
  i10 = HEAP32[i6 + 20 >> 2] | 0;
  i9 = HEAP32[i6 + 24 >> 2] | 0;
  i8 = HEAP32[i6 + 32 >> 2] | 0;
  i7 = HEAP32[i6 + 36 >> 2] | 0;
  i4 = HEAP32[i6 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i1 + 8 >> 2] = i12;
  HEAP32[i1 + 12 >> 2] = i11;
  HEAP32[i1 + 16 >> 2] = i10;
  HEAP32[i1 + 20 >> 2] = i9;
  HEAP32[i1 + 24 >> 2] = i8;
  HEAP32[i1 + 28 >> 2] = i7;
  HEAP32[i1 + 32 >> 2] = i4;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = HEAP32[i5 + 8 >> 2] | 0;
  i7 = HEAP32[i5 + 16 >> 2] | 0;
  i8 = HEAP32[i5 + 20 >> 2] | 0;
  i9 = HEAP32[i5 + 24 >> 2] | 0;
  i10 = HEAP32[i5 + 32 >> 2] | 0;
  i11 = HEAP32[i5 + 36 >> 2] | 0;
  i12 = HEAP32[i5 + 40 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i6;
  HEAP32[i2 + 12 >> 2] = i7;
  HEAP32[i2 + 16 >> 2] = i8;
  HEAP32[i2 + 20 >> 2] = i9;
  HEAP32[i2 + 24 >> 2] = i10;
  HEAP32[i2 + 28 >> 2] = i11;
  HEAP32[i2 + 32 >> 2] = i12;
  i12 = 1;
  return i12 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
   i9 = i13;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i1 + 4 | 0;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i10;
   i1 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i12 = i9 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 20 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i12 >> 2] | 0;
  HEAP32[i13 >> 2] = 73;
  HEAP32[i13 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 20 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i5 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i4 = i7;
 i3 = i5 + (i3 * 20 | 0) | 0;
 i8 = i4;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, gb + 63664 | 0);
  i15 = i13;
  i5 = HEAP32[i15 + 4 >> 2] | 0;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i8 + 20 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i3;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i4;
  i4 = i5;
  i1 = i5;
 } else {
  i3 = i4;
  i2 = i7;
  do {
   i1 = i1 + -20 | 0;
   __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i2 + -20 | 0, i1);
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i2 = i3;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i6;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i15 = HEAP32[i12 >> 2] | 0;
 HEAP32[i13 >> 2] = 73;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i13);
 STACKTOP = i14;
 return;
}

function __ZN5physx7NpScene26removeArticulationInternalERNS_14PxArticulationEbb(i9, i11, i8, i1) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i2 = i13 + 8 | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 108 >> 2] | 0, i11 | 0) | 0;
 if (i1) if (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 128 >> 2] | 0, i11 | 0) | 0) __ZN5physx11NpAggregate29removeArticulationAndReinsertERNS_14PxArticulationEb(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 128 >> 2] | 0, i11 | 0) | 0, i11, 0) | 0;
 i3 = i7 << 2;
 i6 = i3 >>> 0 > 1024;
 i10 = i12 + 4 | 0;
 HEAP8[i10 >> 0] = i6 & 1;
 if (i6) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i2, i3, gb + 678666 | 0, 970) | 0;
  HEAP32[i12 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i12 >> 2] = i1;
 }
 HEAP32[i1 >> 2] = HEAP32[HEAP32[i11 + 88 >> 2] >> 2];
 i5 = i7 + -1 | 0;
 if (i5 | 0) {
  i6 = 0;
  i1 = 1;
  do {
   i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if (!(HEAP32[i2 + 324 >> 2] | 0)) i3 = 0; else i3 = HEAP32[i2 + 320 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 232 >> 2] | 0, i2 | 0) | 0) {
    i4 = 0;
    do {
     HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i3 + (i4 << 2) >> 2];
     i1 = i1 + 1 | 0;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 232 >> 2] | 0, i2 | 0) | 0) >>> 0);
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i5 | 0));
 }
 if ((i7 | 0) > 0) {
  i6 = i9 + 3392 | 0;
  i1 = i9 + 16 | 0;
  i2 = i7;
  do {
   i3 = i2;
   i2 = i2 + -1 | 0;
   i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 228 >> 2] | 0, i4 | 0) | 0;
   __ZN5physx7NpActor26removeConstraintsFromSceneEv(i4 + 12 | 0);
   __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i4 + 20 | 0, i6);
   if (i5 | 0) __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE(i1, i5 + 8 | 0);
   __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i1, i4 + 48 | 0, i8, 0);
  } while ((i3 | 0) > 1);
 } else i1 = i9 + 16 | 0;
 __ZN5physx3Scb5Scene18removeArticulationERNS0_12ArticulationE(i1, i11 + 12 | 0);
 i5 = i9 + 3564 | 0;
 i3 = i9 + 3568 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L29 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i11 | 0)) break L29;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) != (i4 | 0)) {
  i9 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i9;
  i11 = HEAP32[i5 >> 2] | 0;
  HEAP32[i11 + (i1 << 2) >> 2] = HEAP32[i11 + (i9 << 2) >> 2];
 }
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx3Scb5Scene22updateLowLevelMaterialEPPNS_10NpMaterialE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i1 + 2428 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i7 = i1 + 16 | 0;
 i8 = i1 + 2416 | 0;
 i9 = i1 + 2420 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i10 = i5;
  i9 = i10;
  HEAP32[i9 >> 2] = 0;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i8, 0, i5);
  i10 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  STACKTOP = i11;
  return;
 }
 i3 = i1 + 20 | 0;
 i4 = 0;
 do {
  i12 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 + (i4 << 3) >> 2] | 0;
  i2 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  switch (HEAP32[i12 + (i4 << 3) + 4 >> 2] | 0) {
  case 0:
   {
    if (i2 | 0) {
     i14 = i2 + 32 | 0;
     i12 = HEAP32[i2 + 52 >> 2] | 0;
     __ZN5physx18PxsMaterialManager6resizeEj(i7, i12 + 1 | 0);
     i13 = HEAP32[i7 >> 2] | 0;
     i1 = i13 + (i12 << 5) | 0;
     HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
     HEAP16[i13 + (i12 << 5) + 12 >> 1] = HEAP16[i2 + 44 >> 1] | 0;
     i1 = i13 + (i12 << 5) + 14 | 0;
     i14 = i2 + 46 | 0;
     i14 = HEAPU8[i14 >> 0] | HEAPU8[i14 + 1 >> 0] << 8;
     HEAP8[i1 >> 0] = i14;
     HEAP8[i1 + 1 >> 0] = i14 >> 8;
     i1 = i2 + 48 | 0;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     i12 = i13 + (i12 << 5) + 16 | 0;
     HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i12 + 4 >> 2] = i2;
    }
    break;
   }
  case 1:
   {
    if (i2 | 0) {
     i13 = i2 + 32 | 0;
     i14 = HEAP32[i2 + 52 >> 2] | 0;
     i1 = HEAP32[i7 >> 2] | 0;
     i12 = i1 + (i14 << 5) | 0;
     HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
     HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
     HEAP16[i1 + (i14 << 5) + 12 >> 1] = HEAP16[i2 + 44 >> 1] | 0;
     i12 = i1 + (i14 << 5) + 14 | 0;
     i13 = i2 + 46 | 0;
     i13 = HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8;
     HEAP8[i12 >> 0] = i13;
     HEAP8[i12 + 1 >> 0] = i13 >> 8;
     i12 = i2 + 48 | 0;
     i13 = HEAP32[i12 + 4 >> 2] | 0;
     i14 = i1 + (i14 << 5) + 16 | 0;
     HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i14 + 4 >> 2] = i13;
    }
    break;
   }
  case 2:
   {
    if (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 5) + 20 >> 2] = -1;
    break;
   }
  default:
   {}
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 i14 = i5;
 i13 = i14;
 HEAP32[i13 >> 2] = 0;
 i14 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i8, 0, i5);
 i14 = HEAP32[i6 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i14);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_9PxD6JointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 608 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 540 | 0;
 i13 = i11 + 592 | 0;
 i14 = i11 + 488 | 0;
 i21 = i11;
 i6 = i11 + 484 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx22PxD6JointGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN26AnimatorOverrideController7SetClipE4PPtrI13AnimationClipES2_b(i8, i1, i9, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 24 | 0;
 i5 = i14 + 16 | 0;
 i11 = i14;
 i12 = i14 + 12 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i13 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i5);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i15 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i15 + 28 >> 2] | 0;
   i4 = HEAP32[i15 + 32 >> 2] | 0;
   i1 = i15;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i13 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i13 = 9;
 }
 if ((i13 | 0) == 7) i13 = 9;
 do if ((i13 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
  STACKTOP = i14;
  return;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i5 >> 2] = i6;
 if (!i1) i13 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i5);
   i2 = HEAP32[i7 >> 2] | 0;
   i15 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i13 = 18;
  }
 }
 if ((i13 | 0) == 16) i13 = 18;
 if ((i13 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i15, _strlen(i15) | 0);
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 __ZN26AnimatorOverrideController7SetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI13AnimationClipEb(i8, i11, i7, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN15DistanceJoint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i6, i9);
 i10 = i6 + 101 | 0;
 i7 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803035 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i4 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i10, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803059 | 0, HEAP32[gb + 37012 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 15; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i5 = 15; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 15) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801285 | 0, i7, i8, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i8 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i9, 3) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i10 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler12onStartEventERKNS_16PxProfileEventIdEjyhhy(i10, i16, i5, i12, i13, i3, i6, i14, i15) {
 i10 = i10 | 0;
 i16 = i16 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i18 + 32 | 0;
 i17 = i18;
 do if ((i5 | 0) == 99999789) i4 = i10 + 4 | 0; else {
  i11 = i10 + 28 | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  i1 = i10 + 24 | 0;
  i2 = i8;
  while (1) {
   if (!i2) break;
   i2 = i2 + -1 | 0;
   i4 = (HEAP32[i1 >> 2] | 0) + (i2 * 20 | 0) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) {
    i7 = 6;
    break;
   }
  }
  if ((i7 | 0) == 6) if (i4 | 0) break;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP8[i9 + 5 >> 0] = i3;
  HEAP32[i9 >> 2] = i5;
  HEAP8[i9 + 4 >> 0] = i6;
  i2 = i10 + 24 | 0;
  if ((HEAP32[i10 + 32 >> 2] & 2147483647) >>> 0 > i8 >>> 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   i10 = i1 + (i8 * 20 | 0) | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP16[i10 + 4 >> 1] = HEAP16[i9 + 4 >> 1] | 0;
   __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE(i1 + (i8 * 20 | 0) + 8 | 0, i9 + 8 | 0);
   i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
   HEAP32[i11 >> 2] = i1;
  } else {
   __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i9) | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i3 = i1 + -1 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i1 + (i3 * 20 | 0) | 0;
  if ((HEAP32[i1 + (i3 * 20 | 0) + 16 >> 2] & 2147483136) >>> 0 < 512) {
   __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + (i3 * 20 | 0) + 8 | 0, 512);
   i4 = i2;
  } else i4 = i2;
 } while (0);
 HEAP16[i17 >> 1] = HEAP16[i16 >> 1] | 0;
 i1 = i17 + 8 | 0;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i1 + 4 >> 2] = i13;
 i1 = i17 + 16 | 0;
 HEAP32[i1 >> 2] = i14;
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = i17 + 24 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = -1;
 i1 = i4 + 8 | 0;
 i2 = i4 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 16 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i16 = (HEAP32[i1 >> 2] | 0) + (i3 << 5) | 0;
  HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i16 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i16 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i16 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i16 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  HEAP32[i16 + 24 >> 2] = HEAP32[i17 + 24 >> 2];
  HEAP32[i16 + 28 >> 2] = HEAP32[i17 + 28 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  STACKTOP = i18;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i17) | 0;
  STACKTOP = i18;
  return;
 }
}

function __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI8JSONReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions(i6, i1, i12, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 i4 = i15 + 32 | 0;
 i14 = i15 + 8 | 0;
 i5 = i6 + 44 | 0;
 if (!(__ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT__4448(HEAP32[i5 >> 2] | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i4 + 4 >> 2] = i11;
 HEAP32[i4 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP16[i4 + 16 >> 1] = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i13;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i14 + 20 | 0;
 i10 = i12 + 20 | 0;
 HEAP8[i9 >> 0] = HEAP8[i10 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i4, i14, i3, 0, i6);
 i2 = HEAP32[i8 >> 2] | 0;
 if (!((HEAP8[i6 + 25 >> 0] | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i1 + 44 >> 2] = fb + 4370;
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i1 + 40 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(HEAP32[i5 >> 2] | 0) | 0;
  i3 = i12 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i12 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i2 = i7 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 6, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i12 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i3 = (HEAP32[i12 >> 2] | 0) + (i4 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i12, i14);
  HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | HEAP8[i10 >> 0];
 }
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
  HEAP32[i14 >> 2] = 0;
 }
 STACKTOP = i15;
 return;
}

function __ZN12AudioManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 28 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 120 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 124 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 128 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 132 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 136 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 140 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 224 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 225 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN4math8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906345 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i5, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i5, i1 + 40 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906349 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906363 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906377 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906391 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906403 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906415 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906427 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11UmbraModule34CullShadowCastersWithUmbraThreadedER20ShadowCullingJobDataR10BlockRangei(i1, i3, i14, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0, f24 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 12 | 0;
 i11 = i15 + 24 | 0;
 i12 = i15;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i9 = i14 + 4 | 0;
 __ZN5Umbra9IndexListC2EPiii(i11, (HEAP32[HEAP32[i3 + 24 >> 2] >> 2] | 0) + (HEAP32[i14 >> 2] << 2) | 0, HEAP32[i9 >> 2] | 0, 0);
 i8 = HEAP32[i3 >> 2] | 0;
 i13 = __ZnwjRK10MemLabelIdiPKci(102400, gb + 64024 | 0, 16, gb + 612578 | 0, 19) | 0;
 __ZN5Umbra8QueryExtC2EPKNS_4TomeE(i13, HEAP32[i8 + 836 >> 2] | 0);
 __ZN5Umbra15GateStateVectorC2EPvjb(i10, HEAP32[i8 + 840 >> 2] | 0, 0, 0);
 __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE(i13, i10);
 __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE(i13, HEAP32[i8 + 844 >> 2] | 0);
 if (!i1) __ZN5Umbra8QueryExt24queryStaticShadowCastersERKNS_15ShadowCullerExtERNS_9IndexListEPKNS_20ObjectDistanceParamsEiiPS4_(i13, HEAP32[i3 + 8 >> 2] | 0, i11, 0, i2, HEAP32[i14 + 8 >> 2] | 0, 0) | 0; else {
  i4 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 752 + (i1 * 12 | 0) >> 2] | 0) + ((HEAP32[i14 >> 2] | 0) * 24 | 0) | 0;
  if (HEAP32[i9 >> 2] | 0) {
   i5 = i10 + 4 | 0;
   i6 = i10 + 8 | 0;
   i7 = i12 + 4 | 0;
   i8 = i12 + 8 | 0;
   i3 = i3 + 8 | 0;
   i1 = 0;
   i2 = 0;
   do {
    i21 = i4 + (i2 * 24 | 0) | 0;
    f24 = Math_fround(HEAPF32[i21 >> 2]);
    f18 = Math_fround(HEAPF32[i21 + 12 >> 2]);
    f24 = Math_fround(f24 - f18);
    i20 = i21 + 4 | 0;
    f23 = Math_fround(HEAPF32[i20 >> 2]);
    f17 = Math_fround(HEAPF32[i21 + 16 >> 2]);
    f23 = Math_fround(f23 - f17);
    i19 = i21 + 8 | 0;
    f22 = Math_fround(HEAPF32[i19 >> 2]);
    f16 = Math_fround(HEAPF32[i21 + 20 >> 2]);
    f22 = Math_fround(f22 - f16);
    HEAPF32[i10 >> 2] = f24;
    HEAPF32[i5 >> 2] = f23;
    HEAPF32[i6 >> 2] = f22;
    f18 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) + f18);
    f17 = Math_fround(Math_fround(HEAPF32[i20 >> 2]) + f17);
    f16 = Math_fround(Math_fround(HEAPF32[i19 >> 2]) + f16);
    HEAPF32[i12 >> 2] = f18;
    HEAPF32[i7 >> 2] = f17;
    HEAPF32[i8 >> 2] = f16;
    if (__ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_(HEAP32[i3 >> 2] | 0, i10, i12) | 0) {
     i21 = i1 + 1 | 0;
     __ZN5Umbra9IndexList7setSizeEi(i11, i21);
     i20 = (HEAP32[i14 >> 2] | 0) + i2 | 0;
     HEAP32[(__ZNK5Umbra9IndexList6getPtrEv(i11) | 0) + (i1 << 2) >> 2] = i20;
     i1 = i21;
    }
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
  }
 }
 i1 = __ZNK5Umbra9IndexList7getSizeEv(i11) | 0;
 if (!i13) {
  __Z19free_alloc_internalPvRK10MemLabelId(i13, gb + 64024 | 0);
  STACKTOP = i15;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i13, gb + 64024 | 0);
 STACKTOP = i15;
 return i1 | 0;
}

function _pat_next(i5, i6, i7, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 L1 : do if (!i6) i8 = 3; else if (!(HEAP8[i5 >> 0] | 0)) i8 = 3; else {
  HEAP32[i7 >> 2] = 1;
  i1 = HEAP8[i5 >> 0] | 0;
  switch (i1 << 24 >> 24) {
  case 42:
   {
    i1 = -5;
    break L1;
   }
  case 92:
   {
    i1 = i5 + 1 | 0;
    if ((i2 & 2 | 0) == 0 & (HEAP8[i1 >> 0] | 0) != 0) {
     HEAP32[i7 >> 2] = 2;
     i2 = i1;
     i3 = 1;
     i1 = HEAP8[i1 >> 0] | 0;
     i8 = 30;
    } else i1 = 92;
    break;
   }
  case 91:
   {
    L8 : do if (i6 >>> 0 > 1) {
     switch (HEAP8[i5 + 1 >> 0] | 0) {
     case 33:
     case 94:
      break;
     default:
      {
       i1 = 1;
       break L8;
      }
     }
     i1 = 2;
    } else i1 = 1; while (0);
    if (i1 >>> 0 < i6 >>> 0) i1 = ((HEAP8[i5 + i1 >> 0] | 0) == 93 & 1) + i1 | 0;
    L15 : do if (i1 >>> 0 < i6 >>> 0) while (1) {
     i3 = HEAP8[i5 + i1 >> 0] | 0;
     switch (i3 << 24 >> 24) {
     case 93:
     case 0:
      {
       i2 = i1;
       i8 = 26;
       break L15;
      }
     default:
      {}
     }
     i2 = i1 + 1 | 0;
     L19 : do if (i2 >>> 0 < i6 >>> 0) {
      i4 = HEAP8[i5 + i2 >> 0] | 0;
      if (i3 << 24 >> 24 == 91 & i4 << 24 >> 24 != 0) {
       switch (i4 << 24 >> 24) {
       case 61:
       case 46:
       case 58:
        break;
       default:
        break L19;
       }
       i2 = i1 + 2 | 0;
       if (i2 >>> 0 < i6 >>> 0) i1 = (HEAP8[i5 + i2 >> 0] | 0) == 0 ? i2 : i1 + 3 | 0; else i1 = i2;
       L26 : do if (i1 >>> 0 < i6 >>> 0) do {
        i2 = HEAP8[i5 + i1 >> 0] | 0;
        if (!(i2 << 24 >> 24)) break L26;
        if (!(i2 << 24 >> 24 != 93 ? 1 : (HEAP8[i5 + (i1 + -1) >> 0] | 0) != i4 << 24 >> 24)) break L26;
        i1 = i1 + 1 | 0;
       } while (i1 >>> 0 < i6 >>> 0); while (0);
       if ((i1 | 0) == (i6 | 0)) {
        i1 = 91;
        i2 = 1;
        break L15;
       }
       if (!(HEAP8[i5 + i1 >> 0] | 0)) {
        i2 = i1;
        i8 = 26;
        break L15;
       }
      }
     } while (0);
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i6 >>> 0) {
      i2 = i1;
      i8 = 26;
      break L15;
     }
    } else {
     i2 = i1;
     i8 = 26;
    } while (0);
    if ((i8 | 0) == 26) if ((i2 | 0) == (i6 | 0)) {
     i1 = 91;
     i2 = 1;
    } else {
     i6 = (HEAP8[i5 + i2 >> 0] | 0) == 0;
     i1 = i6 ? 91 : -3;
     i2 = i6 ? 1 : i2 + 1 | 0;
    }
    HEAP32[i7 >> 2] = i2;
    break L1;
   }
  case 63:
   {
    i1 = -4;
    break L1;
   }
  default:
   {
    i2 = i5;
    i3 = 0;
    i8 = 30;
   }
  }
  if ((i8 | 0) == 30) if (i1 << 24 >> 24 < 0) {
   i1 = _mbtowc(i4, i2, i6) | 0;
   if ((i1 | 0) < 0) {
    HEAP32[i7 >> 2] = 0;
    i1 = -2;
   } else {
    HEAP32[i7 >> 2] = i1 + i3;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   break;
  }
  i1 = i1 << 24 >> 24;
 } while (0);
 if ((i8 | 0) == 3) {
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN5physx17ConvexHullBuilder23CalculateVertexMapTableEjb(i2, i14, i17) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 8 | 0;
 i18 = i21;
 i13 = i21 + 12 | 0;
 i20 = i2 + 20 | 0;
 i1 = HEAP8[(HEAP32[i20 >> 2] | 0) + 38 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  HEAP32[i2 + 16 >> 2] = 0;
  i20 = 1;
  STACKTOP = i21;
  return i20 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i16 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 i11 = _PxGetFoundation() | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 24 >> 2] | 0, i11 | 0) | 0;
 i11 = mftCall_iiiiii(i16 | 0, i12 | 0, (i1 & 255) * 3 | 0, (i11 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1692) | 0;
 i12 = (HEAP8[(HEAP32[i20 >> 2] | 0) + 38 >> 0] | 0) == 0;
 i16 = i2 + 16 | 0;
 HEAP32[i16 >> 2] = i11;
 if (i12) {
  i20 = 1;
  STACKTOP = i21;
  return i20 | 0;
 }
 i12 = i2 + 4 | 0;
 i6 = i2 + 8 | 0;
 i7 = i13 + 1 | 0;
 i8 = i13 + 2 | 0;
 L8 : do if (i14 | 0) {
  i10 = 0;
  while (1) {
   i9 = HEAP32[i12 >> 2] | 0;
   i1 = 0;
   i11 = 0;
   while (1) {
    i2 = HEAP8[i9 + (i11 * 20 | 0) + 18 >> 0] | 0;
    if (i2 << 24 >> 24) {
     i4 = HEAPU16[i9 + (i11 * 20 | 0) + 16 >> 1] | 0;
     i5 = HEAP32[i6 >> 2] | 0;
     i2 = i2 & 255;
     i3 = 0;
     do {
      if ((i10 | 0) == (HEAPU8[i5 + (i4 + i3) >> 0] | 0)) {
       i15 = 11;
       break;
      }
      i3 = i3 + 1 | 0;
     } while (i3 >>> 0 < i2 >>> 0);
     if ((i15 | 0) == 11) {
      i15 = 0;
      HEAP8[i13 + i1 >> 0] = i11;
      i1 = i1 + 1 | 0;
     }
     if ((i1 | 0) == 3) break;
    }
    i11 = i11 + 1 | 0;
    if (i11 >>> 0 >= i14 >>> 0) break L8;
   }
   i11 = i10 * 3 | 0;
   HEAP8[(HEAP32[i16 >> 2] | 0) + i11 >> 0] = HEAP8[i13 >> 0] | 0;
   HEAP8[(HEAP32[i16 >> 2] | 0) + (i11 + 1) >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP8[(HEAP32[i16 >> 2] | 0) + (i11 + 2) >> 0] = HEAP8[i8 >> 0] | 0;
   i10 = i10 + 1 | 0;
   if (i10 >>> 0 >= (HEAPU8[(HEAP32[i20 >> 2] | 0) + 38 >> 0] | 0) >>> 0) {
    i1 = 1;
    break;
   }
  }
  STACKTOP = i21;
  return i1 | 0;
 } while (0);
 i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 if (i17) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 32, gb + 726825 | 0, 1737, gb + 727315 | 0, i19); else __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 32, gb + 726825 | 0, 1735, gb + 727198 | 0, i18);
 if (!(HEAP8[(HEAP32[i20 >> 2] | 0) + 38 >> 0] | 0)) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 } else i1 = 0;
 do {
  i19 = i1 * 3 | 0;
  HEAP8[(HEAP32[i16 >> 2] | 0) + i19 >> 0] = -1;
  HEAP8[(HEAP32[i16 >> 2] | 0) + (i19 + 1) >> 0] = -1;
  HEAP8[(HEAP32[i16 >> 2] | 0) + (i19 + 2) >> 0] = -1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAPU8[(HEAP32[i20 >> 2] | 0) + 38 >> 0] | 0) >>> 0);
 i1 = 0;
 STACKTOP = i21;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 L1 : do if (i3) {
  i10 = HEAP8[i2 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
  i9 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i5 = i2 + 16 | 0;
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i4 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
    i7 = i4 >>> 0 < i10 >>> 0;
    i3 = i7 ? i4 : i10;
    if (!i3) i11 = 6; else {
     i3 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0;
     if (!i3) i11 = 6; else if ((i3 | 0) < 0) break;
    }
    if ((i11 | 0) == 6) {
     i11 = 0;
     if (i10 >>> 0 < i4 >>> 0) break;
    }
    i3 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
    if (!i3) i11 = 11; else {
     i3 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i3) | 0;
     if (!i3) i11 = 11; else if ((i3 | 0) >= 0) break L3;
    }
    if ((i11 | 0) == 11) {
     i11 = 0;
     if (!i7) break L3;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L1;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break L1;
   } else i1 = i2;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  L21 : do if (!i4) i3 = i2; else {
   i3 = i2;
   while (1) {
    i8 = i4;
    while (1) {
     i5 = i8 + 16 | 0;
     i7 = HEAP8[i5 + 11 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i7 = i6 ? HEAP32[i8 + 20 >> 2] | 0 : i7 & 255;
     i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
     if (!i4) i11 = 18; else {
      i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i4) | 0;
      if (!i4) i11 = 18; else if ((i4 | 0) >= 0) break;
     }
     if ((i11 | 0) == 18) {
      i11 = 0;
      if (i7 >>> 0 >= i10 >>> 0) break;
     }
     i4 = HEAP32[i8 + 4 >> 2] | 0;
     if (!i4) break L21; else i8 = i4;
    }
    i4 = HEAP32[i8 >> 2] | 0;
    if (!i4) {
     i3 = i8;
     break;
    } else i3 = i8;
   }
  } while (0);
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  L34 : do if (i4) while (1) {
   i2 = i4;
   while (1) {
    i5 = i2 + 16 | 0;
    i7 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i7 << 24 >> 24 < 0;
    i7 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i7 & 255;
    i4 = i7 >>> 0 < i10 >>> 0 ? i7 : i10;
    if (!i4) i11 = 26; else {
     i4 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i4) | 0;
     if (!i4) i11 = 26; else if ((i4 | 0) < 0) break;
    }
    if ((i11 | 0) == 26) {
     i11 = 0;
     if (i10 >>> 0 < i7 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L34;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  } while (0);
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i1;
  return;
 } while (0);
 i11 = i1;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i11;
 return;
}

function __ZN18AnimatorController19TransferRuntimeDataI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i6 + 4 >> 2] = i4 + 104;
 __Z21TransferBlobSerializeIN7mecanim9animation18ControllerConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i4 + 128 | 0, gb + 905632 | 0, i4 + 132 | 0, gb + 902410 | 0, i6);
 i2 = i4 + 140 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 905786 | 0, HEAP32[gb + 37052 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 80 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902427 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 156 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902444 | 0, gb + 902485 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN38StateMachineBehaviourVectorDescription8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 192 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902524 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i3 = i4 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902549 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i5 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_f(i23, i24, i18, i2, i16, i17, f15, i19, f12, f13, f14, f1, f4, f7, i20, i21, f22) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 f15 = Math_fround(f15);
 i19 = i19 | 0;
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 f7 = Math_fround(f7);
 i20 = i20 | 0;
 i21 = i21 | 0;
 f22 = Math_fround(f22);
 var i3 = 0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f8 * f12);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f13));
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f11 * f14));
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(f6 + f9);
 if (Math_fround(f9 * Math_fround(f6 + Math_fround(Math_fround(Math_fround(f8 * f1) + Math_fround(f10 * f4)) + Math_fround(f11 * f7)))) > Math_fround(0.0)) {
  i24 = 0;
  return i24 | 0;
 }
 f6 = Math_fround(f1 - f12);
 f5 = Math_fround(f4 - f13);
 f4 = Math_fround(f7 - f14);
 f1 = Math_fround(Math_fround(Math_fround(f6 * f8) + Math_fround(f5 * f10)) + Math_fround(f4 * f11));
 if (f1 == Math_fround(0.0)) {
  i24 = 0;
  return i24 | 0;
 }
 f1 = Math_fround(f9 / f1);
 f13 = Math_fround(f13 - Math_fround(f5 * f1));
 f14 = Math_fround(f14 - Math_fround(f4 * f1));
 HEAPF32[i21 >> 2] = Math_fround(f12 - Math_fround(f6 * f1));
 i2 = i21 + 4 | 0;
 HEAPF32[i2 >> 2] = f13;
 i3 = i21 + 8 | 0;
 HEAPF32[i3 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i18 + (i16 << 2) >> 2]);
 f13 = Math_fround(HEAPF32[i21 + (i17 << 2) >> 2]);
 f13 = Math_fround(f14 * Math_fround(f13 - Math_fround(HEAPF32[i23 + (i17 << 2) >> 2])));
 f14 = Math_fround(HEAPF32[i18 + (i17 << 2) >> 2]);
 f1 = Math_fround(HEAPF32[i21 + (i16 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f13 - Math_fround(f14 * Math_fround(f1 - Math_fround(HEAPF32[i23 + (i16 << 2) >> 2])))) * f15);
 HEAPF32[i20 >> 2] = f1;
 if (f1 < f22) {
  i24 = 0;
  return i24 | 0;
 }
 f13 = Math_fround(HEAPF32[i19 >> 2]);
 f14 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f13 = Math_fround(f1 * f13);
 f14 = Math_fround(f1 * f14);
 f22 = Math_fround(f1 * Math_fround(HEAPF32[i19 + 8 >> 2]));
 f13 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f13);
 HEAPF32[i21 >> 2] = f13;
 f14 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f14);
 HEAPF32[i2 >> 2] = f14;
 f22 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f22);
 HEAPF32[i3 >> 2] = f22;
 f15 = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f13);
 f13 = Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 >> 2]) - f13));
 f15 = Math_fround(Math_fround(HEAPF32[i23 + 4 >> 2]) - f14);
 f14 = Math_fround(f13 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 + 4 >> 2]) - f14)));
 f15 = Math_fround(Math_fround(HEAPF32[i23 + 8 >> 2]) - f22);
 i24 = Math_fround(f14 + Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i24 + 8 >> 2]) - f22))) < Math_fround(0.0);
 return i24 | 0;
}

function __GLOBAL__sub_I_umbra_cpp() {
 HEAPF32[gb + 1451448 >> 2] = Math_fround(4.0);
 HEAPF32[gb + 1451448 + 4 >> 2] = Math_fround(4.0);
 HEAPF32[gb + 1451448 + 8 >> 2] = Math_fround(4.0);
 HEAPF32[gb + 1451448 + 12 >> 2] = Math_fround(4.0);
 HEAPF32[gb + 1451464 >> 2] = Math_fround(.03125);
 HEAPF32[gb + 1451464 + 4 >> 2] = Math_fround(.03125);
 HEAPF32[gb + 1451464 + 8 >> 2] = Math_fround(.03125);
 HEAPF32[gb + 1451464 + 12 >> 2] = Math_fround(.03125);
 HEAPF32[gb + 1451480 >> 2] = Math_fround(-31.5);
 HEAPF32[gb + 1451480 + 4 >> 2] = Math_fround(-31.5);
 HEAPF32[gb + 1451480 + 8 >> 2] = Math_fround(-31.5);
 HEAPF32[gb + 1451480 + 12 >> 2] = Math_fround(-31.5);
 HEAPF32[gb + 1451496 >> 2] = Math_fround(16.0);
 HEAPF32[gb + 1451496 + 4 >> 2] = Math_fround(16.0);
 HEAPF32[gb + 1451496 + 8 >> 2] = Math_fround(16.0);
 HEAPF32[gb + 1451496 + 12 >> 2] = Math_fround(16.0);
 HEAPF32[gb + 1451512 >> 2] = Math_fround(-.5);
 HEAPF32[gb + 1451512 + 4 >> 2] = Math_fround(-.5);
 HEAPF32[gb + 1451512 + 8 >> 2] = Math_fround(-.5);
 HEAPF32[gb + 1451512 + 12 >> 2] = Math_fround(-.5);
 HEAPF32[gb + 1451528 >> 2] = Math_fround(1.1920929e-07);
 HEAPF32[gb + 1451528 + 4 >> 2] = Math_fround(1.1920929e-07);
 HEAPF32[gb + 1451528 + 8 >> 2] = Math_fround(1.1920929e-07);
 HEAPF32[gb + 1451528 + 12 >> 2] = Math_fround(1.1920929e-07);
 HEAPF32[gb + 1451544 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1451544 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1451544 + 8 >> 2] = Math_fround(2.0);
 HEAPF32[gb + 1451544 + 12 >> 2] = Math_fround(3.0);
 HEAPF32[gb + 1451560 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451560 + 4 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451560 + 8 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451560 + 12 >> 2] = Math_fround(.0000152590219);
 HEAP32[gb + 1451576 >> 2] = 65535;
 HEAP32[gb + 1451576 + 4 >> 2] = 65535;
 HEAP32[gb + 1451576 + 8 >> 2] = 65535;
 HEAP32[gb + 1451576 + 12 >> 2] = 65535;
 HEAPF32[gb + 1451432 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451432 + 4 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451432 + 8 >> 2] = Math_fround(.0000152590219);
 HEAPF32[gb + 1451432 + 12 >> 2] = Math_fround(.0000152590219);
 HEAP32[gb + 1451592 >> 2] = -1;
 HEAP32[gb + 1451592 + 4 >> 2] = 0;
 HEAP32[gb + 1451592 + 8 >> 2] = 0;
 HEAP32[gb + 1451592 + 12 >> 2] = 0;
 HEAP32[gb + 1451608 >> 2] = 0;
 HEAP32[gb + 1451608 + 4 >> 2] = -1;
 HEAP32[gb + 1451608 + 8 >> 2] = 0;
 HEAP32[gb + 1451608 + 12 >> 2] = 0;
 HEAP32[gb + 1451624 >> 2] = -1;
 HEAP32[gb + 1451624 + 4 >> 2] = -1;
 HEAP32[gb + 1451624 + 8 >> 2] = 0;
 HEAP32[gb + 1451624 + 12 >> 2] = 0;
 HEAP32[gb + 1451640 >> 2] = 0;
 HEAP32[gb + 1451640 + 4 >> 2] = 0;
 HEAP32[gb + 1451640 + 8 >> 2] = -1;
 HEAP32[gb + 1451640 + 12 >> 2] = 0;
 HEAP32[gb + 1451656 >> 2] = -1;
 HEAP32[gb + 1451656 + 4 >> 2] = 0;
 HEAP32[gb + 1451656 + 8 >> 2] = -1;
 HEAP32[gb + 1451656 + 12 >> 2] = 0;
 HEAP32[gb + 1451672 >> 2] = 0;
 HEAP32[gb + 1451672 + 4 >> 2] = -1;
 HEAP32[gb + 1451672 + 8 >> 2] = -1;
 HEAP32[gb + 1451672 + 12 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9AnimationL24GenerateComponentBindingEiP12Il2CppObjectP11Il2CppClassP6Object(i6, i2, i7, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 48 | 0;
 i10 = i12 + 16 | 0;
 i13 = i12 + 40 | 0;
 __ZN8TypeTreeC2ERK10MemLabelId(i11, gb + 63720 | 0);
 __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags(i1, i11, 0);
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i5 = i10 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i15 = i4;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 4 >> 2] = i14;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i13 + 4 >> 2] = 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i4, i13);
 if (!(HEAP32[i4 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  do {
   __ZN11UnityEngine9AnimationL22GenerateBindingRecurseERK16TypeTreeIteratorP12Il2CppObjectN7mecanim5crc32ER13dynamic_arrayINS0_13CachedBindingELj4EE(i4, i2, -1, i10);
   __ZNK16TypeTreeIterator4NextEv(i3, i4);
   i13 = i3;
   i15 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   i14 = i4;
   HEAP32[i14 >> 2] = i15;
   HEAP32[i14 + 4 >> 2] = i13;
  } while ((i15 | 0) != 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_(i1, i1 + (i2 << 4) | 0, i4);
 i3 = (HEAP32[i5 >> 2] << 4) + 16 | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, gb + 63320 | 0, 0, gb + 896915 | 0, 441) | 0;
 i15 = i1;
 i4 = (0 - i15 & 3) + i15 | 0;
 i2 = i4 + 16 | 0;
 i3 = i1 + i3 | 0;
 i1 = i2 >>> 0 > i3 >>> 0;
 i2 = i1 ? i15 : i2;
 i4 = i1 ? 0 : i4;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = i7;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i15 = i1 << 4;
  i1 = (0 - i2 & 3) + i2 | 0;
  i1 = (i1 + i15 | 0) >>> 0 > i3 >>> 0 ? 0 : i1;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, i15 | 0) | 0;
 }
 HEAP32[i4 + 12 >> 2] = i1;
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
  HEAP32[i10 >> 2] = 0;
 }
 i1 = i11 + 40 | 0;
 if ((HEAP32[i11 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i11 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i11 + 36 >> 2] | 0) > -1) {
  i15 = i11 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11 + 24 | 0);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i11 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i4 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i11 + 4 | 0);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i4 | 0;
}

function __ZN7mecanim13ValueConstant8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 910040 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 913271 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899057 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_10MemLabelId17TransferMetaFlags(i8, i7, i2, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = i8 + 40 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i14 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i7 >> 2] | 0)) {
   i13 = i2;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = i7 + 4 | 0;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = i14;
  }
  HEAP32[i7 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i5 = HEAP32[i14 + 4 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 if (!i6) {
  i10 = i2;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i7 + 4 | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
 }
 i1 = i7 + 12 | 0;
 HEAP32[i1 >> 2] = i5;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i5, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i7 >> 2] = i12;
  i1 = i12;
  break;
 } else i1 = i6; while (0);
 i12 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i2 + (i12 * 24 | 0) | 0;
 if (i12 | 0) {
  i10 = HEAP32[gb + 37300 >> 2] | 0;
  i11 = i8 + 20 | 0;
  i12 = i8 + 56 | 0;
  i7 = i8 + 44 | 0;
  i6 = i1;
  while (1) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = i10;
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   if (!(i1 & 256)) i15 = 19; else if (!(HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 3) + 4 >> 2] & 256)) i15 = 19; else i1 = (i1 | 0) == 258 & 1;
   if ((i15 | 0) == 19) {
    i15 = 0;
    do if (!(i1 & 2048)) {
     if (!(i1 & 512)) {
      if (!(i1 & 1048576)) {
       i1 = 0;
       break;
      }
      if (!(i1 & 4194304)) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
      i1 = __Z11StringToIntPKc(i1) | 0;
      break;
     }
     do if (!(i1 & 16384)) {
      if (i1 & 1024 | 0) {
       d4 = +(HEAP32[i2 >> 2] | 0);
       break;
      }
      i5 = i2;
      i3 = HEAP32[i5 >> 2] | 0;
      i5 = HEAP32[i5 + 4 >> 2] | 0;
      if (!(i1 & 4096)) {
       d4 = +(i3 >>> 0) + 4294967296.0 * +(i5 >>> 0);
       break;
      } else {
       d4 = +(i3 >>> 0) + 4294967296.0 * +(i5 | 0);
       break;
      }
     } else d4 = +HEAPF64[i2 >> 3]; while (0);
     i1 = ~~d4 >>> 0;
    } else i1 = HEAP32[i2 >> 2] | 0; while (0);
    i1 = i1 & 255;
   }
   HEAP8[i6 >> 0] = i1;
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i9 | 0)) break; else i6 = i6 + 1 | 0;
  }
 }
 HEAP32[i13 >> 2] = i14;
 return;
}

function __ZN5physx9NpPhysics11createSceneERKNS_11PxSceneDescE(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 16 | 0;
 i12 = i14 + 20 | 0;
 i9 = i13 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 i10 = _PxGetFoundation() | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0;
 i10 = mftCall_iiiiii(i6 | 0, i11 | 0, 3904, (i10 ? gb + 701388 | 0 : gb + 837976 | 0) | 0, gb + 689263 | 0, 286) | 0;
 __ZN5physx7NpSceneC2ERKNS_11PxSceneDescE(i10, i1);
 HEAP32[i12 >> 2] = i10;
 i11 = i10;
 if (!i10) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 689263 | 0, 289, gb + 701490 | 0, i14);
  i13 = 0;
  i12 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 444 >> 2] | 0, i10 | 0) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 689263 | 0, 294, gb + 701514 | 0, i14 + 8 | 0);
  i13 = 0;
  i12 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i14;
  return i13 | 0;
 }
 __ZN5physx7NpScene12loadFromDescERKNS_11PxSceneDescE(i10, i1) | 0;
 i5 = i13 + 56 | 0;
 i6 = i13 + 52 | 0;
 i1 = 0;
 L9 : do {
  i3 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i8 = 11;
   break;
  }
  i4 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   i1 = i1 + 1 | 0;
   if (i2 | 0) break;
   if (i1 >>> 0 >= i3 >>> 0) {
    i8 = 11;
    break L9;
   }
  }
 } while (__ZN5physx7NpScene11addMaterialERNS_10NpMaterialE(i10, i2) | 0);
 if ((i8 | 0) == 11) if (__ZNK5physx2Sc5Scene7isValidEv(i10 + 32 | 0) | 0) {
  i1 = i13 + 4 | 0;
  i2 = i13 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i13 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i11;
   HEAP32[i2 >> 2] = i3 + 1;
   i13 = i10;
   i12 = HEAP32[i9 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
   STACKTOP = i14;
   return i13 | 0;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_7NpSceneENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i12) | 0;
   i13 = i10;
   i12 = HEAP32[i9 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 if (i10 | 0) mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i10 | 0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 689263 | 0, 328, gb + 701490 | 0, i7);
 i13 = 0;
 i12 = HEAP32[i9 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_7PxClothEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 736 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i11 + 676 | 0;
 i13 = i11 + 728 | 0;
 i14 = i11 + 624 | 0;
 i21 = i11;
 i6 = i11 + 620 | 0;
 i10 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i15 = i11 + 48 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx20PxClothGeneratedInfoC2Ev(i15);
 HEAP32[i21 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i13 >> 0] = 0;
 i19 = i10;
 i18 = i9;
 i17 = i5;
 i16 = i4;
 i4 = i3;
 i5 = i13;
 HEAP32[i20 >> 2] = i19;
 HEAP32[i20 + 4 >> 2] = i18;
 i3 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i20 + 20 >> 2] = i17;
 HEAP32[i20 + 24 >> 2] = i16;
 HEAP32[i20 + 28 >> 2] = i1;
 HEAP32[i20 + 32 >> 2] = i4;
 HEAP8[i20 + 36 >> 0] = 1;
 HEAP32[i20 + 40 >> 2] = i5;
 HEAP32[i20 + 44 >> 2] = 0;
 HEAP32[i20 + 48 >> 2] = 0;
 __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j(i15, i20, 0) | 0;
 HEAP32[i14 >> 2] = i19;
 HEAP32[i14 + 4 >> 2] = i18;
 i3 = i14 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i17;
 HEAP32[i14 + 24 >> 2] = i16;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i4;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i5;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i21 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
  }
 }
 i21 = HEAP32[i7 >> 2] | 0;
 if (!((i21 | 0) > -1 & (i21 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i21 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i21 >> 2] | 0) + 12 >> 2] | 0, i21 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN21TreeBinaryTreeBuilder17EncapsulateBoundsER10MinMaxAABBRK12TreeInstanceRKNSt3__26vectorIN12TreeDatabase9PrototypeENS5_9allocatorIS8_EEEERK8Vector3fSG_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 f21 = Math_fround(HEAPF32[i2 >> 2]);
 f21 = Math_fround(f21 * Math_fround(HEAPF32[i5 >> 2]));
 f20 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 * Math_fround(HEAPF32[i5 + 4 >> 2]));
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i5 + 8 >> 2]));
 f21 = Math_fround(f21 + Math_fround(HEAPF32[i4 >> 2]));
 f20 = Math_fround(f20 + Math_fround(HEAPF32[i4 + 4 >> 2]));
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 f17 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 i16 = HEAP32[i2 + 32 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i26 = i13 + (i16 * 156 | 0) + 20 | 0;
 f8 = Math_fround(HEAPF32[i26 >> 2]);
 i25 = i13 + (i16 * 156 | 0) + 32 | 0;
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i25 >> 2]));
 i24 = i13 + (i16 * 156 | 0) + 24 | 0;
 f6 = Math_fround(HEAPF32[i24 >> 2]);
 i23 = i13 + (i16 * 156 | 0) + 36 | 0;
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i23 >> 2]));
 i22 = i13 + (i16 * 156 | 0) + 28 | 0;
 f11 = Math_fround(HEAPF32[i22 >> 2]);
 i16 = i13 + (i16 * 156 | 0) + 40 | 0;
 f8 = Math_fround(f21 + Math_fround(f17 * f8));
 f6 = Math_fround(f20 + Math_fround(f19 * f6));
 f11 = Math_fround(f18 + Math_fround(f17 * Math_fround(f11 - Math_fround(HEAPF32[i16 >> 2]))));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = f8 < f15 ? f8 : f15;
 i13 = i1 + 4 | 0;
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 f14 = f6 < f14 ? f6 : f14;
 i2 = i1 + 8 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = f11 < f12 ? f11 : f12;
 HEAPF32[i1 >> 2] = f15;
 HEAPF32[i13 >> 2] = f14;
 HEAPF32[i2 >> 2] = f12;
 i3 = i1 + 12 | 0;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = f10 < f8 ? f8 : f10;
 i4 = i1 + 16 | 0;
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = f8 < f6 ? f6 : f8;
 i5 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = f6 < f11 ? f11 : f6;
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i5 >> 2] = f6;
 f11 = Math_fround(HEAPF32[i26 >> 2]);
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i25 >> 2]));
 f9 = Math_fround(HEAPF32[i24 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i23 >> 2]));
 f7 = Math_fround(HEAPF32[i22 >> 2]);
 f11 = Math_fround(f21 + Math_fround(f17 * f11));
 f9 = Math_fround(f20 + Math_fround(f19 * f9));
 f7 = Math_fround(f18 + Math_fround(f17 * Math_fround(f7 + Math_fround(HEAPF32[i16 >> 2]))));
 HEAPF32[i1 >> 2] = f11 < f15 ? f11 : f15;
 HEAPF32[i13 >> 2] = f9 < f14 ? f9 : f14;
 HEAPF32[i2 >> 2] = f7 < f12 ? f7 : f12;
 HEAPF32[i3 >> 2] = f10 < f11 ? f11 : f10;
 HEAPF32[i4 >> 2] = f8 < f9 ? f9 : f8;
 HEAPF32[i5 >> 2] = f6 < f7 ? f7 : f6;
 return;
}

function __ZN5physx2Sq10AABBPruner7releaseEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = i13 + 4 | 0;
 __ZN5physx2Sq16BucketPrunerCore7releaseEv(i12 + 144 | 0);
 i10 = i12 + 56 | 0;
 i1 = HEAP32[i12 + 76 >> 2] | 0;
 if (i1 | 0) {
  i7 = i12 + 92 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i12 + 68 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i12 + 72 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i12 + 64 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i12 + 84 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i7 = i12 + 100 | 0;
 i1 = HEAP32[i12 + 120 >> 2] | 0;
 if (i1 | 0) {
  i8 = i12 + 136 | 0;
  if (HEAP32[i8 >> 2] | 0) {
   _memset(HEAP32[i12 + 112 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i12 + 116 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i12 + 108 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i12 + 128 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
  }
 }
 HEAP32[i12 + 96 >> 2] = i10;
 HEAP32[i12 + 140 >> 2] = i7;
 i1 = i12 + 7796 | 0;
 HEAP32[i11 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i1, 0, i11);
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1, HEAP32[i12 + 7800 >> 2] | 0);
 i1 = i12 + 44 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i12 + 24 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i12 + 32 >> 2] = 0;
 HEAP32[i12 + 36 >> 2] = 0;
 i1 = i12 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx2Sq8AABBTreeD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i12 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i11 = i12 + 48 | 0;
  HEAP32[i11 >> 2] = 0;
  i11 = i12 + 7744 | 0;
  HEAP32[i11 >> 2] = 0;
  i11 = i12 + 7816 | 0;
  HEAP32[i11 >> 2] = 0;
  i11 = i12 + 7811 | 0;
  HEAP8[i11 >> 0] = 0;
  i12 = i12 + 7809 | 0;
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i13;
  return;
 }
 __ZN5physx2Sq8AABBTreeD2Ev(i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
 HEAP32[i1 >> 2] = 0;
 i11 = i12 + 48 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = i12 + 7744 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = i12 + 7816 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = i12 + 7811 | 0;
 HEAP8[i11 >> 0] = 0;
 i12 = i12 + 7809 | 0;
 HEAP8[i12 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN4FMOD7SystemID2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = i7 + 312 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 308 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i8 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i8 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i8;
    }
    __ZdlPv(i3);
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i7 + 296 | 0;
 i2 = i7 + 304 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 300 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i7 + 284 | 0;
 i2 = i7 + 292 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 288 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i5 = i7 + 264 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 260 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i8 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i8 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i8;
    }
    __ZdlPv(i3);
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i7 + 248 | 0;
 i2 = i7 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 252 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i7 + 236 | 0;
 i2 = i7 + 244 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 240 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEED2Ev(i7 + 172 | 0);
 __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEED2Ev(i7 + 124 | 0);
 __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEED2Ev(i7 + 76 | 0);
 i1 = i7 + 64 | 0;
 i2 = i7 + 72 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 68 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i7 + 24 | 0;
 i2 = i7 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i8 = i7 + 28 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i7;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN8Material26CopyPropertiesFromMaterialERS_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i8 = i12;
 __ZN18UnityPropertySheetaSERKS_(i5 + 44 | 0, i6 + 44 | 0) | 0;
 i11 = i5 + 100 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i3 = i7 + 12 | 0;
 i2 = i6 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i10 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i10 = 3;
 if ((i10 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i6);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZN19ShaderPropertySheet8CopyFromERKS_(i3, i1 + 12 | 0);
 i2 = i7 + 220 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i7 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i4 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i7 + 200 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i7 + 164 | 0;
 HEAP8[i4 >> 0] = HEAP8[i4 >> 0] | 1;
 __ZN8Material21CopySettingsFromOtherERKS_(i5, i6);
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  if (!(HEAP32[gb + 1166240 >> 2] | 0)) i10 = 17;
 } else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 13; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i8);
    i2 = HEAP32[i9 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 13; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  i8 = (__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0) == 0;
  if (i8 & (HEAP32[gb + 1166240 >> 2] | 0) == 0) i10 = 17;
 } while (0);
 if ((i10 | 0) == 17) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 469921 | 0, 27);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i9) | 0;
  HEAP32[gb + 1166240 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (i1 | 0) HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = i1 + 164 | 0;
 HEAP8[i11 >> 0] = HEAP8[i11 >> 0] | 2;
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = i5 * 28 | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 * 28 | 0) | 0)) _memset(i3 | 0, 0, i2 - (((i2 + -28 | 0) >>> 0) % 28 | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i4 >> 2] >> 2] | 0) * 28 | 0) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863333 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN5audio5mixer16SnapshotConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 28 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 863333 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN5audio5mixer16SnapshotConstant8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 28 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS3_EENS4_9allocatorIS3_EEEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 8 | 0;
 i6 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 36 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = (i5 - i2 | 0) / 36 | 0;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj(i9, i4 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 } else if (i4 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i4 * 36 | 0) | 0;
  if ((i5 | 0) == (i1 | 0)) i1 = i4; else {
   i5 = i5 + (~(((i5 + -36 - i1 | 0) >>> 0) / 36 | 0) * 36 | 0) | 0;
   HEAP32[i6 >> 2] = i5;
   i1 = i4;
  }
 } else i1 = i4;
 do if (i1 | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 479418 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i5 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN23ShaderVariantCollection11VariantInfo8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i5 | 0)) break L14;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 479418 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN23ShaderVariantCollection11VariantInfo8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i5 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN18CrashReportHandler23RegisterGlobalCallbacksEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 28 | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 20840 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 20072 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 20072 + (i1 * 12 | 0) >> 2] = fb + 3931;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 24700 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 23932 + (i1 * 12 | 0) >> 2] = fb + 3931;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 36280 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 35512 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + 35512 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 35512 + (i1 * 12 | 0) >> 2] = fb + 168;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 1540 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i5 = i3 + 1 | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i1 + 772 + (i3 * 12 | 0) | 0;
  i2 = i1 + 772 + (i3 * 12 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = i4;
  i4 = i1 + 772 + (i3 * 12 | 0) + 8 | 0;
  HEAP8[i4 >> 0] = 1;
  HEAP32[i5 >> 2] = fb + 3932;
  STACKTOP = i6;
  return;
 }
 __Z6FormatPKcz(i5, gb + 1048800 | 0, i6 + 24 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + 1 | 0;
 HEAP32[i2 >> 2] = i5;
 i5 = i1 + 772 + (i3 * 12 | 0) | 0;
 i2 = i1 + 772 + (i3 * 12 | 0) + 4 | 0;
 HEAP32[i2 >> 2] = i4;
 i4 = i1 + 772 + (i3 * 12 | 0) + 8 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i5 >> 2] = fb + 3932;
 STACKTOP = i6;
 return;
}

function __ZN10Collider2D9GetBoundsEv(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i19 + 32 | 0;
 i16 = i19 + 16 | 0;
 i17 = i19;
 __ZNK9Transform11GetPositionEv(i15, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i18 = i1 + 72 | 0;
 if (!(HEAP32[i18 >> 2] | 0)) {
  i18 = i14 + 12 | 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i18 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i18 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i18 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i19;
  return;
 }
 i6 = i1 + 60 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = (HEAP32[i2 + 28 >> 2] | 0) + 12 | 0;
 i8 = i16 + 4 | 0;
 i9 = i17 + 4 | 0;
 i10 = i16 + 8 | 0;
 i11 = i17 + 8 | 0;
 i12 = i16 + 12 | 0;
 i13 = i17 + 12 | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0;
  if ((i4 | 0) > 0) {
   i2 = 0;
   while (1) {
    if (i1) {
     mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i17 | 0, i7 | 0, i2 | 0, 0);
     f20 = Math_fround(HEAPF32[i16 >> 2]);
     f21 = Math_fround(HEAPF32[i17 >> 2]);
     f22 = Math_fround(HEAPF32[i8 >> 2]);
     f23 = Math_fround(HEAPF32[i9 >> 2]);
     HEAPF32[i16 >> 2] = f20 < f21 ? f20 : f21;
     HEAPF32[i8 >> 2] = f22 < f23 ? f22 : f23;
     f23 = Math_fround(HEAPF32[i10 >> 2]);
     f22 = Math_fround(HEAPF32[i11 >> 2]);
     f21 = Math_fround(HEAPF32[i12 >> 2]);
     f20 = Math_fround(HEAPF32[i13 >> 2]);
     HEAPF32[i10 >> 2] = f23 > f22 ? f23 : f22;
     HEAPF32[i12 >> 2] = f21 > f20 ? f21 : f20;
    } else mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i16 | 0, i7 | 0, i2 | 0, 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i1 = 1;
     break;
    } else i1 = 1;
   }
  }
  i2 = i5 + 4 | 0;
  if ((i2 | 0) == ((HEAP32[i6 >> 2] | 0) + (HEAP32[i18 >> 2] << 2) | 0)) break;
  i5 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 f22 = Math_fround(HEAPF32[i16 >> 2]);
 f25 = Math_fround(HEAPF32[i10 >> 2]);
 f23 = Math_fround(HEAPF32[i8 >> 2]);
 f24 = Math_fround(HEAPF32[i12 >> 2]);
 f20 = Math_fround(Math_fround(f22 + f25) * Math_fround(.5));
 f21 = Math_fround(Math_fround(f23 + f24) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f25 - f22) * Math_fround(.5));
 f23 = Math_fround(Math_fround(f24 - f23) * Math_fround(.5));
 i18 = HEAP32[i15 + 8 >> 2] | 0;
 HEAPF32[i14 >> 2] = f20;
 HEAPF32[i14 + 4 >> 2] = f21;
 HEAP32[i14 + 8 >> 2] = i18;
 HEAPF32[i14 + 12 >> 2] = f22;
 HEAPF32[i14 + 16 >> 2] = f23;
 HEAPF32[i14 + 20 >> 2] = Math_fround(0.0);
 STACKTOP = i19;
 return;
}

function __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 12 | 0, i9);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i8 + 40 | 0, gb + 899117 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i8 + 52 | 0, i9);
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i4 >>> 0 > 4 ? 4 : i4;
 i2 = i8 + 68 + (i4 << 6) | 0;
 if (i4 | 0) {
  i1 = i8 + 68 | 0;
  do {
   __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 324 | 0, i9);
 __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 460 | 0, i9);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i3 >>> 0 > 52 ? 52 : i3;
 i4 = i8 + 596 + (i3 << 2) | 0;
 if (i3 | 0) {
  i3 = i8 + 596 | 0;
  do {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
    i1 = HEAP32[i6 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i7 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 i7 = i7 >>> 0 > 7 ? 7 : i7;
 i2 = i8 + 804 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 i1 = i8 + 804 | 0;
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN9Scripting28CreateEnumInfoFromNativeEnumERKN10EnumTraits14ReflectionInfoE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 248 | 0;
 i7 = i12;
 i2 = i12 + 240 | 0;
 i11 = i12 + 256 | 0;
 i4 = (__Z23GetCoreScriptingClassesv() | 0) + 180 | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i7, i8);
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i4 = i8;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i5 = i5 << 2 >> 2;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i9 >> 2] = i5 | -2147483648;
 HEAP32[i11 >> 2] = i3;
 i3 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 84 >> 2] | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, HEAP32[i2 >> 2] | 0) | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i3, i1, __Z20scripting_string_newPKc(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i7, i3);
 i5 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 36 >> 2] | 0;
 i1 = (i5 | 0) == 0 ? 0 : i1;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, i1) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0, i5 | 0, i1 << 2 | 0) | 0;
 __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i7, i4);
 i4 = HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 84 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, HEAP32[i6 >> 2] | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i5 = i6 + 12 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) {
    __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i4, i3, __Z20scripting_string_newPKc(i2) | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i7, i4);
 __ZN18ScriptingArguments10AddBooleanEb(i7, (HEAP8[i6 + 16 >> 0] | 0) != 0);
 HEAP32[i8 >> 2] = 0;
 i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i7, i8, 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i1 | 0;
}

function __Z12StringToGUIDPKcj(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i12 = i13;
 if ((i1 | 0) != 32) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 if (!(HEAP8[gb + 1546622 >> 0] | 0)) {
  _memset(gb + 1546623 | 0, -1, 255) | 0;
  HEAP8[gb + 1546623 + 48 >> 0] = 0;
  HEAP8[gb + 1546623 + 49 >> 0] = 1;
  HEAP8[gb + 1546623 + 50 >> 0] = 2;
  HEAP8[gb + 1546623 + 51 >> 0] = 3;
  HEAP8[gb + 1546623 + 52 >> 0] = 4;
  HEAP8[gb + 1546623 + 53 >> 0] = 5;
  HEAP8[gb + 1546623 + 54 >> 0] = 6;
  HEAP8[gb + 1546623 + 55 >> 0] = 7;
  HEAP8[gb + 1546623 + 56 >> 0] = 8;
  HEAP8[gb + 1546623 + 57 >> 0] = 9;
  HEAP8[gb + 1546623 + 97 >> 0] = 10;
  HEAP8[gb + 1546623 + 98 >> 0] = 11;
  HEAP8[gb + 1546623 + 99 >> 0] = 12;
  HEAP8[gb + 1546623 + 100 >> 0] = 13;
  HEAP8[gb + 1546623 + 101 >> 0] = 14;
  HEAP8[gb + 1546623 + 102 >> 0] = 15;
  HEAP8[gb + 1546623 + 65 >> 0] = 10;
  HEAP8[gb + 1546623 + 66 >> 0] = 11;
  HEAP8[gb + 1546623 + 67 >> 0] = 12;
  HEAP8[gb + 1546623 + 68 >> 0] = 13;
  HEAP8[gb + 1546623 + 69 >> 0] = 14;
  HEAP8[gb + 1546623 + 70 >> 0] = 15;
  HEAP8[gb + 1546622 >> 0] = 1;
 }
 i1 = 0;
 do {
  HEAP32[i10 + (i1 << 2) >> 2] = HEAP8[(HEAP8[i2 + i1 >> 0] | 0) + (gb + 1546623) >> 0];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i2 = 0;
 while (1) {
  i1 = i2 << 3;
  i3 = HEAP32[i10 + ((i1 | 7) << 2) >> 2] | 0;
  if ((i3 | 0) == -1) {
   i1 = 10;
   break;
  }
  i4 = HEAP32[i10 + ((i1 | 6) << 2) >> 2] | 0;
  if ((i4 | 0) == -1) {
   i1 = 10;
   break;
  }
  i5 = HEAP32[i10 + ((i1 | 5) << 2) >> 2] | 0;
  if ((i5 | 0) == -1) {
   i1 = 10;
   break;
  }
  i6 = HEAP32[i10 + ((i1 | 4) << 2) >> 2] | 0;
  if ((i6 | 0) == -1) {
   i1 = 10;
   break;
  }
  i7 = HEAP32[i10 + ((i1 | 3) << 2) >> 2] | 0;
  if ((i7 | 0) == -1) {
   i1 = 10;
   break;
  }
  i8 = HEAP32[i10 + ((i1 | 2) << 2) >> 2] | 0;
  if ((i8 | 0) == -1) {
   i1 = 10;
   break;
  }
  i9 = HEAP32[i10 + ((i1 | 1) << 2) >> 2] | 0;
  if ((i9 | 0) == -1) {
   i1 = 10;
   break;
  }
  i1 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 10;
   break;
  }
  HEAP32[i12 + (i2 << 2) >> 2] = i1 | (i9 << 4 | (i8 << 8 | (i7 << 12 | (i6 << 16 | (i5 << 20 | (i4 << 24 | i3 << 28))))));
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= 4) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 10) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
 } else if ((i1 | 0) == 11) {
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 }
 STACKTOP = i13;
 return;
}

function __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i2 = i6;
 __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 72 | 0, i5);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i5);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2, i5);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f7 < Math_fround(0.0);
 f7 = i4 ? Math_fround(0.0) : f7;
 i4 = f7 > Math_fround(1.0);
 HEAP8[i1 + 144 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i4 = f7 < Math_fround(0.0);
 f7 = i4 ? Math_fround(0.0) : f7;
 i4 = f7 > Math_fround(1.0);
 HEAP8[i1 + 145 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i4 = f7 < Math_fround(0.0);
 f7 = i4 ? Math_fround(0.0) : f7;
 i4 = f7 > Math_fround(1.0);
 HEAP8[i1 + 146 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 HEAP8[i1 + 147 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 HEAP8[i1 + 148 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 HEAP8[i1 + 149 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 HEAP8[i1 + 150 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = f7 < Math_fround(0.0);
 f7 = i2 ? Math_fround(0.0) : f7;
 i2 = f7 > Math_fround(1.0);
 HEAP8[i1 + 151 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i1 = i1 + 152 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 2);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  STACKTOP = i6;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESL_EERKT_(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 L1 : do if (i3) {
  i10 = HEAP8[i2 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
  i9 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i5 = i2 + 16 | 0;
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i4 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
    i7 = i4 >>> 0 < i10 >>> 0;
    i3 = i7 ? i4 : i10;
    if (!i3) i11 = 6; else {
     i3 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0;
     if (!i3) i11 = 6; else if ((i3 | 0) < 0) break;
    }
    if ((i11 | 0) == 6) {
     i11 = 0;
     if (i10 >>> 0 < i4 >>> 0) break;
    }
    i3 = i10 >>> 0 < i4 >>> 0 ? i10 : i4;
    if (!i3) i11 = 11; else {
     i3 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i3) | 0;
     if (!i3) i11 = 11; else if ((i3 | 0) >= 0) break L3;
    }
    if ((i11 | 0) == 11) {
     i11 = 0;
     if (!i7) break L3;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L1;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break L1;
   } else i1 = i2;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  L21 : do if (!i4) i3 = i2; else {
   i3 = i2;
   while (1) {
    i8 = i4;
    while (1) {
     i5 = i8 + 16 | 0;
     i7 = HEAP8[i5 + 11 >> 0] | 0;
     i6 = i7 << 24 >> 24 < 0;
     i7 = i6 ? HEAP32[i8 + 20 >> 2] | 0 : i7 & 255;
     i4 = i10 >>> 0 < i7 >>> 0 ? i10 : i7;
     if (!i4) i11 = 18; else {
      i4 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i9, i4) | 0;
      if (!i4) i11 = 18; else if ((i4 | 0) >= 0) break;
     }
     if ((i11 | 0) == 18) {
      i11 = 0;
      if (i7 >>> 0 >= i10 >>> 0) break;
     }
     i4 = HEAP32[i8 + 4 >> 2] | 0;
     if (!i4) break L21; else i8 = i4;
    }
    i4 = HEAP32[i8 >> 2] | 0;
    if (!i4) {
     i3 = i8;
     break;
    } else i3 = i8;
   }
  } while (0);
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  L34 : do if (i4) while (1) {
   i2 = i4;
   while (1) {
    i5 = i2 + 16 | 0;
    i7 = HEAP8[i5 + 11 >> 0] | 0;
    i6 = i7 << 24 >> 24 < 0;
    i7 = i6 ? HEAP32[i2 + 20 >> 2] | 0 : i7 & 255;
    i4 = i7 >>> 0 < i10 >>> 0 ? i7 : i10;
    if (!i4) i11 = 26; else {
     i4 = _memcmp(i9, i6 ? HEAP32[i5 >> 2] | 0 : i5, i4) | 0;
     if (!i4) i11 = 26; else if ((i4 | 0) < 0) break;
    }
    if ((i11 | 0) == 26) {
     i11 = 0;
     if (i10 >>> 0 < i7 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L34;
   }
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) {
    i1 = i2;
    break;
   } else i1 = i2;
  } while (0);
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i1;
  return;
 } while (0);
 i11 = i1;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i11;
 return;
}

function __ZN8Animator15SetGoalRotationEiRK11Quaternionf(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 i6 = i6 + i3 + 40 | 0;
 if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + i6 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE(i5, i2);
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f12 * f15);
 f8 = Math_fround(f14 * f11);
 f9 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + 4 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f16 * f9);
 f17 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i5 + 8 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f14 * f17)) - Math_fround(f16 * f11)) - Math_fround(f18 * f9));
 f8 = Math_fround(Math_fround(Math_fround(f8 - Math_fround(f18 * f15)) - Math_fround(f16 * f17)) - Math_fround(f12 * f9));
 f13 = Math_fround(Math_fround(Math_fround(f13 - Math_fround(f12 * f17)) - Math_fround(f14 * f15)) - Math_fround(f18 * f11));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * f15)) - Math_fround(f14 * f9)) - Math_fround(f12 * f11));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f11 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f11 * f11);
 f10 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f10 * f10);
 f9 = (HEAP32[tempDoublePtr >> 2] = i5 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 + f12) + Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9))))));
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f8 = Math_fround(f12 * f8);
 HEAPF32[i6 + 68 + (i2 << 6) + 12 >> 2] = Math_fround(f12 * f11);
 HEAPF32[i6 + 68 + (i2 << 6) + 16 >> 2] = f10;
 HEAPF32[i6 + 68 + (i2 << 6) + 20 >> 2] = f9;
 HEAPF32[i6 + 68 + (i2 << 6) + 24 >> 2] = f8;
 STACKTOP = i7;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128S2_NSt3__24lessIS2_EENS3_9allocatorINS3_4pairIS2_S2_EEEEEEEvRT_17TransferMetaFlags(i11, i8, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i10 + 8 | 0;
 i4 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i6 - i2 >> 5;
 if (i5 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj(i4, i5 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
 } else if (i5 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i5 << 5) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i5; else {
   i6 = i6 + (~((i6 + -32 - i1 | 0) >>> 5) << 5) | 0;
   HEAP32[i7 >> 2] = i6;
   i1 = i5;
  }
 } else i1 = i5;
 do if (i1 | 0) {
  i1 = i8 + 4 | 0;
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i11 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i11 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i6 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i8 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairI7Hash128S2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i6 | 0)) break L14;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, i3, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairI7Hash128S2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i6 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN5physx25solveContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i13, i12, i11) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 if (i12 >>> 0 > 1) {
  i1 = 1;
  do {
   i9 = i1 + -1 | 0;
   __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i13 + (i9 << 5) | 0, i11);
   i2 = HEAP32[i13 + (i9 << 5) + 16 >> 2] | 0;
   i9 = HEAP16[i13 + (i9 << 5) + 26 >> 1] | 0;
   i10 = i2 + ((i9 & 65535) << 4) | 0;
   if (i9 << 16 >> 16) do {
    i5 = i2 + 32 | 0;
    i3 = HEAP8[i2 + 5 >> 0] | 0;
    i9 = HEAP8[i2 + 6 >> 0] | 0;
    i4 = HEAP8[i2 >> 0] | 0;
    i8 = i4 << 24 >> 24 == 3 ? 112 : 80;
    if (!(i3 << 24 >> 24)) {
     i8 = 32;
     i3 = i4;
     i4 = i5;
    } else {
     i7 = i3 & 255;
     i4 = i5;
     i5 = 0;
     while (1) {
      i3 = i4 + 44 | 0;
      f6 = Math_fround(HEAPF32[i3 >> 2]);
      i14 = f6 > Math_fround(0.0);
      HEAP32[i3 >> 2] = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
      i5 = i5 + 1 | 0;
      if ((i5 | 0) == (i7 | 0)) break; else i4 = i4 + i8 | 0;
     }
     i4 = (Math_imul(i8, i7) | 0) + 32 | 0;
     i8 = i4;
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = i2 + i4 | 0;
    }
    i7 = i3 << 24 >> 24 == 3 ? 128 : 96;
    if (!(i9 << 24 >> 24)) i2 = i4; else {
     i5 = i9 & 255;
     i3 = i4;
     i4 = 0;
     while (1) {
      HEAP32[i3 + 44 >> 2] = 0;
      i4 = i4 + 1 | 0;
      if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i7 | 0;
     }
     i2 = i2 + ((Math_imul(i7, i5) | 0) + i8) | 0;
    }
   } while (i2 >>> 0 < i10 >>> 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 }
 i14 = i12 + -1 | 0;
 __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i13 + (i14 << 5) | 0, i11);
 i1 = HEAP32[i13 + (i14 << 5) + 16 >> 2] | 0;
 i14 = HEAP16[i13 + (i14 << 5) + 26 >> 1] | 0;
 i9 = i1 + ((i14 & 65535) << 4) | 0;
 if (!(i14 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i8 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i7 = 32;
   i2 = i3;
   i3 = i4;
  } else {
   i5 = i2 & 255;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f6 = Math_fround(HEAPF32[i2 >> 2]);
    i14 = f6 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i14 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i3 = (Math_imul(i7, i5) | 0) + 32 | 0;
   i7 = i3;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + i3 | 0;
  }
  i5 = i2 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i8 << 24 >> 24)) i1 = i3; else {
   i4 = i8 & 255;
   i2 = i3;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i5 | 0;
   }
   i1 = i1 + ((Math_imul(i5, i4) | 0) + i7) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN14SplatPrototype8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932887 | 0, gb + 1034905 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i4, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932895 | 0, gb + 1034905 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 8 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932905 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932914 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932925 | 0, HEAP32[gb + 37328 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 932942 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 36; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 36; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 36) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f11 = f0, f12 = f0, d13 = 0.0;
 f1 = Math_fround(HEAPF32[i9 >> 2]);
 i4 = i10 + 1484 | 0;
 i3 = i9 + 4 | 0;
 if (f1 != Math_fround(HEAPF32[i4 >> 2])) {
  i2 = i10 + 1488 | 0;
  i5 = 5;
 } else {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i10 + 1488 | 0;
  if (f8 != Math_fround(HEAPF32[i2 >> 2])) i5 = 5; else {
   f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   if (f8 != Math_fround(HEAPF32[i10 + 1492 >> 2])) i5 = 5;
  }
 }
 if ((i5 | 0) == 5) {
  HEAPF32[i4 >> 2] = f1;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 + 1492 >> 2] = i4;
  f8 = Math_fround(HEAPF32[i10 + 1380 >> 2]);
  f11 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
  f6 = Math_fround(HEAPF32[i10 + 1384 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2])));
  f7 = Math_fround(HEAPF32[i10 + 1388 >> 2]);
  f11 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i2 >> 2]))) + Math_fround(1.0)) * Math_fround(.5)));
  d13 = +HEAPF64[i10 + 1392 >> 3];
  HEAPF64[i10 + 1512 >> 3] = d13;
  f12 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  HEAPF64[i10 + 1520 >> 3] = d13 + +Math_fround(Math_fround(f12 * f11) + Math_fround(Math_fround(f12 * Math_fround(.5)) * Math_fround(Math_fround(1.0) - f11)));
  HEAPF32[i10 + 1528 >> 2] = f8;
  HEAPF32[i10 + 1532 >> 2] = f6;
  HEAPF32[i10 + 1536 >> 2] = f7;
  f1 = Math_fround(Math_fround(f8 + f1) * Math_fround(.5));
  i2 = i10 + 1496 | 0;
  HEAPF32[i2 >> 2] = f1;
  f6 = Math_fround(Math_fround(f6 + (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
  i3 = i10 + 1500 | 0;
  HEAPF32[i3 >> 2] = f6;
  f7 = Math_fround(Math_fround(f7 + (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]))) * Math_fround(.5));
  i4 = i10 + 1504 | 0;
  HEAPF32[i4 >> 2] = f7;
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f6 * f6)) + Math_fround(f7 * f7))));
  if (f8 != Math_fround(0.0)) {
   HEAPF32[i2 >> 2] = Math_fround(f1 / f8);
   HEAPF32[i3 >> 2] = Math_fround(f6 / f8);
   f1 = Math_fround(f7 / f8);
  } else {
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
  HEAPF32[i4 >> 2] = f1;
 }
 f1 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 i2 = i10 + 1456 | 0;
 if (!(f1 != Math_fround(HEAPF32[i2 >> 2]))) return;
 d13 = +HEAPF64[i10 + 1392 >> 3];
 HEAPF64[i10 + 1464 >> 3] = d13;
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f8 = Math_fround(f7 * Math_fround(.5));
 f12 = Math_fround(HEAPF32[i10 + 1376 >> 2]);
 f11 = Math_fround(Math_abs(Math_fround(f1 - f12)));
 HEAPF64[i10 + 1472 >> 3] = d13 + +Math_fround(Math_fround(f7 * f11) + Math_fround(f8 * Math_fround(Math_fround(1.0) - f11)));
 HEAPF32[i10 + 1480 >> 2] = f12;
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z31GetAllAssetNamesFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 if (HEAP8[i1 + 184 >> 0] | 0) {
  STACKTOP = i18;
  return;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i14 = i1 + 72 | 0;
 i3 = i2;
 if ((i3 | 0) == (i14 | 0)) {
  STACKTOP = i18;
  return;
 }
 i11 = i15 + 4 | 0;
 i12 = i15 + 8 | 0;
 i13 = i16 + 4 | 0;
 i1 = i2;
 while (1) {
  i2 = HEAP32[i11 >> 2] | 0;
  i10 = i3 + 16 | 0;
  if ((HEAP32[i15 >> 2] | 0) == (i2 | 0)) i17 = 13; else {
   i6 = i2 + -16 | 0;
   i9 = HEAP8[i10 + 11 >> 0] | 0;
   i5 = i9 << 24 >> 24 < 0;
   if (i5) i4 = HEAP32[i3 + 20 >> 2] | 0; else i4 = i9 & 255;
   i8 = HEAP8[i6 + 11 >> 0] | 0;
   i7 = i8 << 24 >> 24 < 0;
   if ((i4 | 0) == ((i7 ? HEAP32[i2 + -12 >> 2] | 0 : i8 & 255) | 0)) {
    i4 = HEAP32[i6 >> 2] | 0;
    if (i5) {
     i8 = HEAP32[i10 >> 2] | 0;
     i5 = i7 ? i4 : i6;
     i4 = HEAP32[i3 + 20 >> 2] | 0;
    } else {
     i8 = i10;
     i5 = i7 ? i4 : i6;
     i4 = i9 & 255;
    }
    if (_strncmp(i8, i5, i4) | 0) i17 = 13;
   } else i17 = 13;
  }
  do if ((i17 | 0) == 13) {
   i17 = 0;
   if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) {
    __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i15, i10);
    break;
   }
   i5 = HEAP8[i10 + 11 >> 0] | 0;
   i9 = i5 << 24 >> 24 < 0;
   i4 = i9 ? HEAP32[i3 + 16 >> 2] | 0 : i10;
   i5 = i9 ? HEAP32[i3 + 20 >> 2] | 0 : i5 & 255;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + 12 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    i17 = 17;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i5;
    if (i5) i17 = 19;
   } else i17 = 17;
   if ((i17 | 0) == 17) {
    i9 = i5 + 16 & -16;
    HEAP32[i16 >> 2] = 66;
    HEAP32[i13 >> 2] = i3;
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i16, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i10;
    HEAP32[i2 + 8 >> 2] = i9 | -2147483648;
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = i10;
    i17 = 19;
   }
   if ((i17 | 0) == 19) {
    i17 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 16;
  } while (0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i14 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 STACKTOP = i18;
 return;
}

function _jpeg_make_c_derived_tbl(i11, i1, i2, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 1296 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 1028 | 0;
 i13 = i15;
 if (i2 >>> 0 > 3) {
  i10 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = 50;
  HEAP32[i10 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i10 >> 2] | 0, i11 | 0);
 }
 i8 = i1 << 24 >> 24 != 0;
 i10 = HEAP32[(i8 ? i11 + 88 + (i2 << 2) | 0 : i11 + 104 + (i2 << 2) | 0) >> 2] | 0;
 if (!i10) {
  i9 = HEAP32[i11 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 50;
  HEAP32[i9 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i11 | 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i11 + 4 >> 2] >> 2] | 0, i11 | 0, 1, 1280) | 0;
  HEAP32[i3 >> 2] = i1;
  i9 = i11;
 } else i9 = i11;
 i6 = 1;
 i2 = 0;
 while (1) {
  i3 = HEAP8[i10 + i6 >> 0] | 0;
  i4 = i3 & 255;
  i5 = i4 + i2 | 0;
  if ((i5 | 0) > 256) {
   i7 = HEAP32[i11 >> 2] | 0;
   HEAP32[i7 + 20 >> 2] = 8;
   mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
  }
  if (!(i3 << 24 >> 24)) i7 = i2; else {
   _memset(i12 + i2 | 0, i6 & 255 | 0, i4 | 0) | 0;
   i7 = i5;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 17) break; else i2 = i7;
 }
 HEAP8[i12 + i7 >> 0] = 0;
 i3 = HEAP8[i12 >> 0] | 0;
 if (i3 << 24 >> 24) {
  i6 = i3 << 24 >> 24;
  i4 = 0;
  i2 = 0;
  while (1) {
   if ((i3 << 24 >> 24 | 0) == (i6 | 0)) {
    i3 = i4;
    while (1) {
     i5 = i2 + 1 | 0;
     HEAP32[i13 + (i2 << 2) >> 2] = i3;
     i2 = i3 + 1 | 0;
     i3 = HEAP8[i12 + i5 >> 0] | 0;
     if ((i3 << 24 >> 24 | 0) == (i6 | 0)) {
      i3 = i2;
      i2 = i5;
     } else {
      i4 = i2;
      i2 = i5;
      break;
     }
    }
   }
   if ((i4 | 0) >= (1 << i6 | 0)) {
    i5 = HEAP32[i11 >> 2] | 0;
    HEAP32[i5 + 20 >> 2] = 8;
    mftCall_vi(HEAP32[i5 >> 2] | 0, i9 | 0);
   }
   if (!(i3 << 24 >> 24)) break; else {
    i6 = i6 + 1 | 0;
    i4 = i4 << 1;
   }
  }
 }
 _memset(i1 + 1024 | 0, 0, 256) | 0;
 i4 = i8 ? 15 : 255;
 if ((i7 | 0) > 0) {
  i2 = 0;
  do {
   i5 = HEAPU8[i10 + 17 + i2 >> 0] | 0;
   i3 = i1 + 1024 + i5 | 0;
   if (i5 >>> 0 > i4 >>> 0) i14 = 24; else if (HEAP8[i3 >> 0] | 0) i14 = 24;
   if ((i14 | 0) == 24) {
    i14 = 0;
    i8 = HEAP32[i11 >> 2] | 0;
    HEAP32[i8 + 20 >> 2] = 8;
    mftCall_vi(HEAP32[i8 >> 2] | 0, i9 | 0);
   }
   HEAP32[i1 + (i5 << 2) >> 2] = HEAP32[i13 + (i2 << 2) >> 2];
   HEAP8[i3 >> 0] = HEAP8[i12 + i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
 }
 if (!(HEAP32[gb + 1100504 >> 2] | 0)) i3 = 0; else {
  STACKTOP = i15;
  return;
 }
 while (1) {
  if (!i3) {
   HEAP8[gb + 1478668 + i3 >> 0] = 0;
   i3 = 1;
   continue;
  } else {
   i1 = i3;
   i2 = 0;
  }
  do {
   i1 = i1 >> 1;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) != 0);
  HEAP8[gb + 1478668 + i3 >> 0] = i2;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 65536) break;
 }
 HEAP32[gb + 1100504 >> 2] = 1;
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i7, i12, i3) {
 i7 = i7 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i9 = i3;
 i10 = i9 - i12 | 0;
 i8 = (i10 | 0) / 24 | 0;
 i11 = i7 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = i5;
 if (i8 >>> 0 <= ((i2 - i5 | 0) / 24 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i4 = (i6 - i5 | 0) / 24 | 0;
  i5 = i8 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 * 24 | 0) | 0 : i3;
  i3 = i6;
  if ((i4 | 0) != (i12 | 0)) {
   i2 = i12;
   do {
    i12 = i2;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i1;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = i2 + 8 | 0;
    i11 = HEAP32[i10 + 4 >> 2] | 0;
    i12 = i1 + 8 | 0;
    HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
    i2 = i2 + 24 | 0;
    i1 = i1 + 24 | 0;
   } while ((i2 | 0) != (i4 | 0));
  }
  if (i5) {
   i1 = i9 - i4 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i13;
    return;
   }
   _memcpy(i6 | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (((i1 >>> 0) / 24 | 0) * 24 | 0);
   STACKTOP = i13;
   return;
  } else {
   if ((i3 | 0) == (i1 | 0)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i7 >> 2] = i3 + (~(((i3 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
   STACKTOP = i13;
   return;
  }
 }
 i4 = i5;
 if (!i5) i1 = i2; else {
  i2 = i7 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i5 | 0) >>> 0) / 24 | 0) * 24 | 0);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 79;
  HEAP32[i6 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if ((i10 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else i2 = 0;
 i9 = (i1 - i2 | 0) / 24 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 79;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 * 24 | 0);
 if ((i10 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 _memcpy(i1 | 0, i12 | 0, i10 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (((i10 >>> 0) / 24 | 0) * 24 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i14, i13) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 4 >> 2] | 0, i13 | 0) | 0;
 i11 = i14 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (!i3) {
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = i12 + 16 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  mftCall_vii(i12 | 0, i13 | 0, i14 | 0);
  return;
 }
 i12 = HEAP32[i3 + 40 >> 2] | 0;
 i5 = (i12 | 0) == 0;
 if (i5) i4 = 0; else {
  i2 = 0;
  i1 = 0;
  do {
   i1 = ((mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, HEAP32[(HEAP32[i3 + 36 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0) | 0) & 1 ^ 1) + i1 | 0;
   i2 = i2 + 1 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  } while ((i2 | 0) != (i12 | 0));
  i4 = (i1 | 0) != 0;
  if (i4) {
   i3 = __ZN5physx9NpFactory21acquireConnectorArrayEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
   if (i12 >>> 0 > i1 >>> 0) {
    i1 = i12 - i1 | 0;
    i9 = i3 + 44 | 0;
    if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i3, i1);
    if (!i5) {
     i1 = i3 + 40 | 0;
     i2 = i3 + 36 | 0;
     i8 = 0;
     do {
      i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0;
      i5 = i6 + (i8 << 3) | 0;
      i6 = i6 + (i8 << 3) + 4 | 0;
      do if (mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, HEAP32[i6 >> 2] | 0) | 0) {
       i7 = HEAP32[i1 >> 2] | 0;
       if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
        i15 = (HEAP32[i2 >> 2] | 0) + (i7 << 3) | 0;
        HEAP8[i15 >> 0] = HEAP8[i5 >> 0] | 0;
        HEAP32[i15 + 4 >> 2] = HEAP32[i6 >> 2];
        HEAP32[i1 >> 2] = i7 + 1;
        break;
       } else {
        __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i3, i5) | 0;
        break;
       }
      } while (0);
      i8 = i8 + 1 | 0;
     } while ((i8 | 0) != (i12 | 0));
    }
   } else i4 = 1;
  } else i4 = 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i3 | 0, 48);
 if (!(HEAP8[i3 + 32 >> 0] | 0)) {
  i1 = HEAP32[i3 + 36 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i3 + 44 >> 2] | 0;
   if (i2 & 2147483647 | HEAP32[i3 + 40 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i1 | 0, i2 << 3 | 0);
  }
 }
 if (!i4) {
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = i12 + 16 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i15 = HEAP32[i14 >> 2] | 0;
  mftCall_vii(i12 | 0, i13 | 0, i15 | 0);
  return;
 }
 __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(HEAP32[gb + 1457204 >> 2] | 0, i3);
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = i12 + 16 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 mftCall_vii(i12 | 0, i13 | 0, i15 | 0);
 return;
}

function __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085989 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i4 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085998 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1084342 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 28; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 28; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 28) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc8BodyCore8setFlagsEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i8, i7, i3) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i8 + 44 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 if (i2 << 24 >> 24 == i1 << 24 >> 24) return;
 i1 = (i1 & 1) != 0;
 i4 = (i2 & 1) != 0;
 i6 = i4 & (i1 ^ 1);
 i4 = i1 & (i4 ^ 1);
 if (i6) {
  __ZN5physx2Sc8BodyCore10putToSleepEv(i8);
  i1 = HEAP8[i3 >> 0] | 0;
 } else i1 = i2;
 HEAP8[i5 >> 0] = i1;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 if (!i5) return;
 if (i6) {
  i4 = i8 + 156 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i2 = i7 + 292 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i7);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i6 = i7 + 280 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i7 = i7 + 284 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  }
  i2 = i1;
  i3 = i2 + 56 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP8[i1 + 31 >> 0] = 1;
  HEAP8[i1 + 28 >> 0] = 0;
  i6 = i8 + 120 | 0;
  HEAP32[i1 + 48 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i8 + 124 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i8 + 128 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i8 + 132 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i8 + 136 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i8 + 140 >> 2];
  i7 = i8 + 112 | 0;
  HEAP32[i1 + 56 >> 2] = HEAP32[i7 >> 2];
  i8 = i8 + 116 | 0;
  HEAP32[i1 + 60 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i8 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i4 >> 2] = i1;
  __ZN5physx2Sc7BodySim21postSwitchToKinematicEv(i5);
  return;
 }
 if (!i4) return;
 i2 = i8 + 156 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i8 + 140 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i8 + 128 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i8 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i8 + 136 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i8 + 120 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i8 + 124 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i8 + 112 >> 2] = HEAP32[i1 + 56 >> 2];
  HEAP32[i8 + 116 >> 2] = HEAP32[i1 + 60 >> 2];
  i8 = i7 + 280 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  i8 = i7 + 292 | 0;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i1;
  i1 = i7 + 284 | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i8 + 1;
  if ((i8 | 0) >= ((HEAP32[i7 + 276 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i7);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i2 >> 2] = 0;
 }
 __ZN5physx2Sc7BodySim19postSwitchToDynamicEv(i5);
 return;
}

function __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator9EmptyTileEE6updateEibbb(i8, i7, i5, i1, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i9 = 0;
 if (!((i7 | 0) != 0 | i1 ^ 1)) {
  i1 = i8 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i8 = 1;
  return i8 | 0;
 }
 i3 = i8 + 8 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) < (i7 | 0) | (i6 | 0) > (i7 | 0) & i1) {
  if (i2) i2 = i7; else {
   i2 = i7 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 * 40 | 0) + 16 | 0, 0) | 0;
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i6 = i1 + 16 | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    HEAPF32[i6 + (i1 * 40 | 0) >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i6 + (i1 * 40 | 0) + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i6 + (i1 * 40 | 0) + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
    HEAPF32[i6 + (i1 * 40 | 0) + 12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i6 + (i1 * 40 | 0) + 16 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i6 + (i1 * 40 | 0) + 20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAP32[i6 + (i1 * 40 | 0) + 24 >> 2] = -1;
    HEAP32[i6 + (i1 * 40 | 0) + 28 >> 2] = 63;
    HEAP32[i6 + (i1 * 40 | 0) + 32 >> 2] = 0;
    HEAP32[i6 + (i1 * 40 | 0) + 36 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i2;
  i4 = i8 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   if (i5) {
    i2 = HEAP32[i8 + 12 >> 2] | 0;
    if (i2) {
     i3 = (i2 | 0) <= (i7 | 0) ? i2 : i7;
     if ((i3 | 0) > 0) {
      i2 = 0;
      do {
       i5 = i6 + (i2 * 40 | 0) | 0;
       i9 = i1 + (i2 * 40 | 0) | 0;
       HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       i5 = i6 + (i2 * 40 | 0) + 12 | 0;
       i9 = i1 + (i2 * 40 | 0) + 12 | 0;
       HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       i5 = i6 + (i2 * 40 | 0) + 24 | 0;
       i9 = i1 + (i2 * 40 | 0) + 24 | 0;
       HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i3 | 0));
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) break;
     }
    }
   }
   i9 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 + -16 | 0);
  } while (0);
  HEAP32[i4 >> 2] = i6;
 }
 HEAP32[i8 + 12 >> 2] = i7;
 i9 = 1;
 return i9 | 0;
}

function __ZN15SerializeTraitsIN18UnityPropertySheet11UnityTexEnvEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944580 | 0, gb + 944590 | 0, i5, 0);
 i9 = i4 + 8 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932253 | 0, i9, i1, 0);
 i8 = i2 + 20 | 0;
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i1, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800947 | 0, i9, i7, 0);
 i8 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i8) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function _open_face(i1, i4, i2, i5, i6, i7, i12) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i8 = HEAP32[i1 + 12 >> 2] | 0;
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = _UNITY_ft_mem_alloc(i9, HEAP32[i8 + 36 >> 2] | 0, i10) | 0;
 do if (!(HEAP32[i10 >> 2] | 0)) {
  HEAP32[i11 + 96 >> 2] = i1;
  HEAP32[i11 + 100 >> 2] = i9;
  i3 = i11 + 104 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  if (i2 << 24 >> 24) {
   i2 = i11 + 8 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1024;
  }
  i2 = _UNITY_ft_mem_alloc(i9, 56, i10) | 0;
  if (!(HEAP32[i10 >> 2] | 0)) {
   HEAP32[i11 + 128 >> 2] = i2;
   i1 = HEAP32[i8 + 48 >> 2] | 0;
   if (!i1) HEAP32[i4 >> 2] = HEAP32[i3 >> 2]; else {
    i7 = mftCall_iiiiii(i1 | 0, HEAP32[i4 >> 2] | 0, i11 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
    HEAP32[i10 >> 2] = i7;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    if (i7 | 0) {
     i3 = 21;
     break;
    }
   }
   i5 = HEAP32[i11 + 40 >> 2] | 0;
   L11 : do if (i5 | 0) {
    i1 = i5 + (HEAP32[i11 + 36 >> 2] << 2) | 0;
    i2 = i1 + -4 | 0;
    L13 : do if (i2 >>> 0 >= i5 >>> 0) {
     L14 : while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      L16 : do if ((HEAP32[i3 + 4 >> 2] | 0) == 1970170211) {
       i10 = HEAP32[i3 + 8 >> 2] | 0;
       i4 = i10 >>> 16 & 65535;
       switch ((i10 & 65535) << 16 >> 16) {
       case 3:
        if (i4 << 16 >> 16 == 10) break L14; else break L16;
       case 0:
        if (i4 << 16 >> 16 == 4) break L14; else break L16;
       default:
        break L16;
       }
      } while (0);
      i2 = i2 + -4 | 0;
      if (i2 >>> 0 < i5 >>> 0) break L13;
     }
     HEAP32[i11 + 92 >> 2] = i3;
     break L11;
    } while (0);
    do {
     i1 = i1 + -4 | 0;
     if (i1 >>> 0 < i5 >>> 0) break L11;
     i2 = HEAP32[i1 >> 2] | 0;
    } while ((HEAP32[i2 + 4 >> 2] | 0) != 1970170211);
    HEAP32[i11 + 92 >> 2] = i2;
   } while (0);
   HEAP32[i12 >> 2] = i11;
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  } else i3 = 21;
 } else if (!i11) i2 = 0; else {
  i2 = 0;
  i3 = 21;
 } while (0);
 if ((i3 | 0) == 21) {
  i3 = i11 + 36 | 0;
  i4 = i11 + 40 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
    i7 = HEAP32[(HEAP32[i5 + 12 >> 2] | 0) + 8 >> 2] | 0;
    if (i7 | 0) mftCall_vi(i7 | 0, i5 | 0);
    _UNITY_ft_mem_free(i6, i5);
    HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  _UNITY_ft_mem_free(i9, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = HEAP32[i8 + 52 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i11 | 0);
 _UNITY_ft_mem_free(i9, i2);
 _UNITY_ft_mem_free(i9, i11);
 HEAP32[i12 >> 2] = 0;
 i12 = HEAP32[i10 >> 2] | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_(i16, i3, i12, i1) {
 i16 = i16 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i14 = i3;
 i15 = i12;
 i13 = i1;
 i10 = i16 + 32 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i9 = (i11 | 0) == 0;
 L1 : do if (i9) i1 = 0; else {
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 5381; else {
   i2 = 5381;
   i4 = i3;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i1 = HEAP8[i4 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i4 = 5381;
   i5 = i12;
   do {
    i4 = i4 * 33 ^ i1 << 24 >> 24;
    i5 = i5 + 1 | 0;
    i1 = HEAP8[i5 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i4;
  }
  i1 = (i1 ^ i2) & i11 + -1;
  i2 = HEAP32[(HEAP32[i16 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i16 + 16 >> 2] | 0;
   i6 = i3 | 0 ? i3 : gb + 1576256 | 0;
   i7 = i12 | 0 ? i12 : gb + 1576256 | 0;
   i8 = i16 + 20 | 0;
   while (1) {
    i17 = HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0;
    if (!(_strcmp(i17 | 0 ? i17 : gb + 1576256 | 0, i6) | 0)) if (!(_strcmp(i4 | 0 ? i4 : gb + 1576256 | 0, i7) | 0)) break;
    i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   return;
  }
 } while (0);
 i6 = i16 + 48 | 0;
 if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i16 + 28 >> 2] | 0)) {
  i1 = i9 ? 16 : i11 << 1;
  if (i11 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i16, i1);
   i5 = HEAP32[i10 >> 2] | 0;
  } else i5 = i11;
  i1 = HEAP8[i3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 5381; else {
   i2 = 5381;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i4 = i1;
   i1 = 5381;
   i3 = i12;
   do {
    i1 = i1 * 33 ^ i4 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
   } while (i4 << 24 >> 24 != 0);
  }
  i1 = (i1 ^ i2) & i5 + -1;
 }
 i12 = i16 + 40 | 0;
 i17 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i17 + 1;
 i12 = (HEAP32[i16 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i16 + 20 >> 2] | 0) + (i17 << 2) >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i17;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i12 = i16 + 44 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 i16 = HEAP32[i16 + 16 >> 2] | 0;
 HEAP32[i16 + (i17 * 12 | 0) >> 2] = i14;
 HEAP32[i16 + (i17 * 12 | 0) + 4 >> 2] = i15;
 HEAP32[i16 + (i17 * 12 | 0) + 8 >> 2] = i13;
 return;
}

function __ZN14SpriteRenderer15GetSpriteBoundsEv(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 16 | 0;
 i6 = i12 + 8 | 0;
 i10 = i12;
 i7 = i9 + 340 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i13 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i13 + 28 >> 2] | 0;
    i4 = HEAP32[i13 + 32 >> 2] | 0;
    i1 = i13;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i11 = 9;
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i11 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 18;
   }
  }
  if ((i11 | 0) == 16) i11 = 18;
  if ((i11 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
  i13 = HEAP16[i9 + 360 >> 1] | 0;
  __ZNK6Sprite9GetBoundsE8Vector2fbb(i8, i1, i10, (i13 & 255) << 24 >> 24 != 0, (i13 & 65535) > 255);
  STACKTOP = i12;
  return;
 } while (0);
 i13 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i13 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 STACKTOP = i12;
 return;
}

function __Z18ConvertUTF8toUTF32PPKhS0_PPmS2_15ConversionFlags(i9, i8, i10, i1, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 L1 : do if (i1 >>> 0 < i8 >>> 0) while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  i5 = HEAP8[(i3 & 255) + (gb + 584316) >> 0] | 0;
  i6 = i5 << 24 >> 24 & 65535;
  if ((i1 + i6 | 0) >>> 0 >= i8 >>> 0) {
   i3 = i2;
   i2 = 1;
   break L1;
  }
  i4 = i1 + (i6 + 1) | 0;
  i5 = i5 << 24 >> 24;
  switch (i5 << 16 >> 16) {
  case 3:
   {
    i4 = i4 + -1 | 0;
    i7 = HEAP8[i4 >> 0] | 0;
    if (i7 << 24 >> 24 > -1 | (i7 & 255) > 191) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else i7 = 5;
    break;
   }
  case 2:
   {
    i7 = 5;
    break;
   }
  case 1:
   {
    i7 = 6;
    break;
   }
  case 0:
   {
    i4 = i3;
    break;
   }
  default:
   {
    i3 = i2;
    i2 = 3;
    break L1;
   }
  }
  if ((i7 | 0) == 5) {
   i4 = i4 + -1 | 0;
   i7 = HEAP8[i4 >> 0] | 0;
   if (i7 << 24 >> 24 > -1 | (i7 & 255) > 191) {
    i3 = i2;
    i2 = 3;
    break L1;
   } else i7 = 6;
  }
  L9 : do if ((i7 | 0) == 6) {
   i7 = 0;
   i4 = HEAP8[i4 + -1 >> 0] | 0;
   if ((i4 & 255) > 191) {
    i3 = i2;
    i2 = 3;
    break L1;
   }
   switch (i3 << 24 >> 24) {
   case -32:
    if ((i4 & 255) < 160) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else {
     i4 = -32;
     break L9;
    }
   case -19:
    if ((i4 & 255) > 159) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else {
     i4 = -19;
     break L9;
    }
   case -16:
    if ((i4 & 255) < 144) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else {
     i4 = -16;
     break L9;
    }
   case -12:
    if ((i4 & 255) > 143) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else {
     i4 = -12;
     break L9;
    }
   default:
    if (i4 << 24 >> 24 > -1) {
     i3 = i2;
     i2 = 3;
     break L1;
    } else {
     i4 = i3;
     break L9;
    }
   }
  } while (0);
  if (!((i4 & 255) < 245 & ((i4 & 255) > 193 | i4 << 24 >> 24 > -1))) {
   i3 = i2;
   i2 = 3;
   break L1;
  }
  switch (i5 << 16 >> 16) {
  case 1:
   {
    i4 = 0;
    i7 = 17;
    break;
   }
  case 0:
   {
    i4 = 0;
    i7 = 18;
    break;
   }
  case 3:
   {
    i3 = i1 + 1 | 0;
    i1 = i3;
    i3 = HEAP8[i3 >> 0] | 0;
    i7 = 16;
    break;
   }
  case 2:
   {
    i7 = 16;
    break;
   }
  default:
   i4 = 0;
  }
  if ((i7 | 0) == 16) {
   i5 = i1 + 1 | 0;
   i4 = (i3 & 255) << 6;
   i1 = i5;
   i3 = HEAP8[i5 >> 0] | 0;
   i7 = 17;
  }
  if ((i7 | 0) == 17) {
   i5 = i1 + 1 | 0;
   i4 = (i3 & 255) + i4 << 6;
   i1 = i5;
   i3 = HEAP8[i5 >> 0] | 0;
   i7 = 18;
  }
  if ((i7 | 0) == 18) {
   i7 = 0;
   i4 = (i3 & 255) + i4 | 0;
   i1 = i1 + 1 | 0;
  }
  i3 = i2 + 4 | 0;
  HEAP32[i2 >> 2] = i4 - (HEAP32[gb + 73500 + (i6 << 2) >> 2] | 0) & 65535;
  if (i1 >>> 0 < i8 >>> 0) i2 = i3; else {
   i2 = 0;
   break L1;
  }
 } else {
  i3 = i2;
  i2 = 0;
 } while (0);
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = i3;
 return i2 | 0;
}

function __ZN16Physics2DManager10BoxCastAllERK8Vector2fS2_fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i3, i8, f10, i2, f11, i12, f13, f14, i15, i7, i16) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 f10 = Math_fround(f10);
 i2 = i2 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 i15 = i15 | 0;
 i7 = i7 | 0;
 i16 = i16 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i9 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19 + 536 | 0;
 i17 = i19;
 if ((HEAP16[gb + 1457692 + 6 >> 1] | 0) > -1) {
  HEAP32[i17 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i17 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457692 | 0, i1);
  i18 = gb + 1457692 | 0;
 } else i18 = 0;
 if (!(Math_fround(HEAPF32[i8 >> 2]) <= Math_fround(.0000999999974))) if (!(Math_fround(HEAPF32[i8 + 4 >> 2]) <= Math_fround(.0000999999974))) {
  i9 = f11 == Math_fround(inf);
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f6 * f6);
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f5 * f5));
  if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f6 = Math_fround(f6 * f4);
  f5 = Math_fround(f5 * f4);
  f11 = i9 ? Math_fround(1.0e5) : f11;
  f6 = Math_fround(f11 * f6);
  f11 = Math_fround(f11 * f5);
  f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f6);
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i3 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i1 + 4 >> 2] = f11;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i17, i3, i1, Math_fround(f10 * Math_fround(.0174532924)), i12, f13, f14, i15, i7, i16);
  HEAP32[i17 >> 2] = gb + 158688 + 8;
  HEAP32[i17 + 372 >> 2] = gb + 151728 + 8;
  HEAP32[i17 + 376 >> 2] = 2;
  HEAP32[i17 + 380 >> 2] = HEAP32[gb + 151644 >> 2];
  HEAP32[i17 + 520 >> 2] = 0;
  HEAPF32[i17 + 384 >> 2] = Math_fround(0.0);
  HEAPF32[i17 + 388 >> 2] = Math_fround(0.0);
  i12 = i8;
  i15 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i17 + 524 | 0;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i15;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i17, 0) | 0;
  if (!((i1 | 0) == 0 | i9 ^ 1)) {
   i2 = HEAP32[i16 + 12 >> 2] | 0;
   if (i2 | 0) {
    i16 = HEAP32[i16 >> 2] | 0;
    i3 = i16 + (i2 * 36 | 0) | 0;
    i2 = i16;
    do {
     i16 = i2 + 28 | 0;
     HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * Math_fround(1.0e5));
     i2 = i2 + 36 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
  }
  HEAP32[i17 >> 2] = gb + 156124 + 8;
  i2 = i17 + 340 | 0;
  if ((HEAP32[i17 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i17 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i17 + 268 | 0);
 } else i1 = 0; else i1 = 0;
 if (!i18) {
  STACKTOP = i19;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i18);
 STACKTOP = i19;
 return i1 | 0;
}

function __Z24CheckValidFileNameDetailRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = i6 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i7 = i1 << 24 >> 24 < 0;
 i5 = i6 + 4 | 0;
 i4 = i7 ? HEAP32[i6 >> 2] | 0 : i6;
 i1 = i7 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 L1 : do if (i1 | 0) {
  i2 = i4 + i1 | 0;
  i1 = i4;
  L3 : while (1) {
   switch (HEAP8[i1 >> 0] | 0) {
   case 92:
   case 47:
    break L3;
   default:
    {}
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i2 | 0)) break L1;
  }
  if (!((i1 | 0) == (i2 | 0) | (i1 - i4 | 0) == -1)) {
   i7 = 1;
   return i7 | 0;
  }
 } while (0);
 L9 : do switch (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i6, 46, 0) | 0) {
 case 4:
  {
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i6;
   switch (HEAP8[i2 >> 0] | 0) {
   case 99:
    {
     if ((HEAP8[i2 + 1 >> 0] | 0) != 111) break L9;
     if ((HEAP8[i2 + 2 >> 0] | 0) != 109) break L9;
     if (((HEAP8[i2 + 3 >> 0] | 0) + -48 & 255) < 10) i1 = 1; else break L9;
     return i1 | 0;
    }
   case 108:
    {
     if ((HEAP8[i2 + 1 >> 0] | 0) != 112) break L9;
     if ((HEAP8[i2 + 2 >> 0] | 0) != 116) break L9;
     if (((HEAP8[i2 + 3 >> 0] | 0) + -48 & 255) < 10) i1 = 1; else break L9;
     return i1 | 0;
    }
   default:
    break L9;
   }
  }
 case 3:
  {
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i6;
   switch (HEAP8[i2 >> 0] | 0) {
   case 99:
    {
     if ((HEAP8[i2 + 1 >> 0] | 0) != 111) break L9;
     if ((HEAP8[i2 + 2 >> 0] | 0) == 110) i1 = 1; else break L9;
     return i1 | 0;
    }
   case 110:
    {
     if ((HEAP8[i2 + 1 >> 0] | 0) != 117) break L9;
     if ((HEAP8[i2 + 2 >> 0] | 0) == 108) i1 = 1; else break L9;
     return i1 | 0;
    }
   case 112:
    {
     if ((HEAP8[i2 + 1 >> 0] | 0) != 114) break L9;
     if ((HEAP8[i2 + 2 >> 0] | 0) == 110) i1 = 1; else break L9;
     return i1 | 0;
    }
   default:
    break L9;
   }
  }
 case 0:
  {
   i7 = 1;
   return i7 | 0;
  }
 default:
  i1 = HEAP8[i3 >> 0] | 0;
 } while (0);
 i3 = i1 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 i5 = (i4 | 0) == 0;
 if (i5) i1 = HEAP32[i6 >> 2] | 0; else {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i3 ? i1 : i6;
  switch (HEAP8[i2 + (i4 + -1) >> 0] | 0) {
  case 46:
  case 32:
   {
    i7 = 1;
    return i7 | 0;
   }
  default:
   {}
  }
  if ((HEAP8[i2 >> 0] | 0) == 32) {
   i7 = 2;
   return i7 | 0;
  }
 }
 i7 = HEAP32[gb + 70304 >> 2] | 0;
 i6 = i3 ? i1 : i6;
 i1 = _strlen(i7) | 0;
 if (i5 | (i1 | 0) == 0) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = i6 + i4 | 0;
 i3 = i7 + i1 | 0;
 i1 = i6;
 L45 : while (1) {
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i7;
  do {
   if (i4 << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) break L45;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i5 | 0)) {
   i1 = i5;
   break;
  }
 }
 i7 = (i1 | 0) == (i5 | 0) | (i1 - i6 | 0) == -1 ? 0 : 2;
 return i7 | 0;
}

function __ZN14ParticleSystem10ResetSeedsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 i10 = i1 + 36 | 0;
 __ZN13InitialModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i1 + 44 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 __ZN11ShapeModule9ResetSeedERK27ParticleSystemReadOnlyState(i1 + 48 | 0, HEAP32[i10 >> 2] | 0);
 __ZN15CollisionModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i1 + 904 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 __ZN12LightsModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i1 + 920 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 __ZN11ForceModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i1 + 876 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 __ZN11NoiseModule11ResetScrollEv(HEAP32[i1 + 888 >> 2] | 0);
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 i3 = gb + 63160 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 916 | 0;
 i1 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i5 >> 2] | 0) | 0) << 2;
 do if (!i1) {
  i1 = 0;
  i4 = 0;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 1284) | 0;
   i3 = gb + 64016 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = i4;
   i1 = i10;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i4;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 i2 = __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_(HEAP32[i5 >> 2] | 0, i3, 0, i6, i7, i8) | 0;
 if ((i2 | 0) > 0) i1 = 0; else {
  i9 = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  STACKTOP = i11;
  return;
 }
 do {
  i8 = i3 + (i1 << 2) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  __ZN13InitialModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i7 + 44 >> 2] | 0, HEAP32[i7 + 36 >> 2] | 0);
  i7 = HEAP32[i8 >> 2] | 0;
  __ZN11ShapeModule9ResetSeedERK27ParticleSystemReadOnlyState(i7 + 48 | 0, HEAP32[i7 + 36 >> 2] | 0);
  i7 = HEAP32[i8 >> 2] | 0;
  __ZN15CollisionModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i7 + 904 >> 2] | 0, HEAP32[i7 + 36 >> 2] | 0);
  i7 = HEAP32[i8 >> 2] | 0;
  __ZN12LightsModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i7 + 920 >> 2] | 0, HEAP32[i7 + 36 >> 2] | 0);
  i7 = HEAP32[i8 >> 2] | 0;
  __ZN11ForceModule9ResetSeedERK27ParticleSystemReadOnlyState(HEAP32[i7 + 876 >> 2] | 0, HEAP32[i7 + 36 >> 2] | 0);
  __ZN11NoiseModule11ResetScrollEv(HEAP32[(HEAP32[i8 >> 2] | 0) + 888 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i9 = HEAP32[i9 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i11;
 return;
}

function __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_(i22, i23, i18, i2, i16, i17, f15, i19, f12, f13, f14, f1, f4, f7, i20, i21) {
 i22 = i22 | 0;
 i23 = i23 | 0;
 i18 = i18 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 f15 = Math_fround(f15);
 i19 = i19 | 0;
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 f7 = Math_fround(f7);
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i3 = 0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f8 * f12);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f13));
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f11 * f14));
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(f6 + f9);
 if (Math_fround(f9 * Math_fround(f6 + Math_fround(Math_fround(Math_fround(f8 * f1) + Math_fround(f10 * f4)) + Math_fround(f11 * f7)))) > Math_fround(0.0)) {
  i23 = 0;
  return i23 | 0;
 }
 f6 = Math_fround(f1 - f12);
 f5 = Math_fround(f4 - f13);
 f4 = Math_fround(f7 - f14);
 f1 = Math_fround(Math_fround(Math_fround(f6 * f8) + Math_fround(f5 * f10)) + Math_fround(f4 * f11));
 if (f1 == Math_fround(0.0)) {
  i23 = 0;
  return i23 | 0;
 }
 f1 = Math_fround(f9 / f1);
 f13 = Math_fround(f13 - Math_fround(f5 * f1));
 f14 = Math_fround(f14 - Math_fround(f4 * f1));
 HEAPF32[i21 >> 2] = Math_fround(f12 - Math_fround(f6 * f1));
 i2 = i21 + 4 | 0;
 HEAPF32[i2 >> 2] = f13;
 i3 = i21 + 8 | 0;
 HEAPF32[i3 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i18 + (i16 << 2) >> 2]);
 f13 = Math_fround(HEAPF32[i21 + (i17 << 2) >> 2]);
 f13 = Math_fround(f14 * Math_fround(f13 - Math_fround(HEAPF32[i22 + (i17 << 2) >> 2])));
 f14 = Math_fround(HEAPF32[i18 + (i17 << 2) >> 2]);
 f1 = Math_fround(HEAPF32[i21 + (i16 << 2) >> 2]);
 f1 = Math_fround(Math_fround(f13 - Math_fround(f14 * Math_fround(f1 - Math_fround(HEAPF32[i22 + (i16 << 2) >> 2])))) * f15);
 HEAPF32[i20 >> 2] = f1;
 if (f1 < Math_fround(0.0)) {
  i23 = 0;
  return i23 | 0;
 }
 f12 = Math_fround(HEAPF32[i19 >> 2]);
 f13 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f12 = Math_fround(f1 * f12);
 f13 = Math_fround(f1 * f13);
 f15 = Math_fround(f1 * Math_fround(HEAPF32[i19 + 8 >> 2]));
 f12 = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f12);
 HEAPF32[i21 >> 2] = f12;
 f13 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f13);
 HEAPF32[i2 >> 2] = f13;
 f15 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f15);
 HEAPF32[i3 >> 2] = f15;
 f14 = Math_fround(Math_fround(HEAPF32[i22 >> 2]) - f12);
 f12 = Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f12));
 f14 = Math_fround(Math_fround(HEAPF32[i22 + 4 >> 2]) - f13);
 f13 = Math_fround(f12 + Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i23 + 4 >> 2]) - f13)));
 f14 = Math_fround(Math_fround(HEAPF32[i22 + 8 >> 2]) - f15);
 i23 = Math_fround(f13 + Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i23 + 8 >> 2]) - f15))) < Math_fround(0.0);
 return i23 | 0;
}

function __Z45Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiff(i1, i2, i3, f6, i4, f7, i5, f8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f6 = Math_fround(f6);
 i4 = i4 | 0;
 f7 = Math_fround(f7);
 i5 = i5 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i14 + 8 | 0;
 i16 = i14;
 i11 = i14 + 24 | 0;
 i15 = i14 + 16 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i16;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i12 = i11 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i17, i16);
 i20 = i17;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i13;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 i18 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 do if (!(__ZN16Physics2DManager14CapsuleCastAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i18, i17, i16, i3, f6, i15, f7, i5, f8, f9, 0, 0, i11) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i5) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i5) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i3 = 0;
  while (1) {
   i18 = i2;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i20 = i4;
   HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   i20 = i2 + 8 | 0;
   i19 = HEAP32[i20 + 4 >> 2] | 0;
   i18 = i4 + 8 | 0;
   HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i18 + 4 >> 2] = i19;
   i18 = i2 + 16 | 0;
   i19 = HEAP32[i18 + 4 >> 2] | 0;
   i20 = i4 + 16 | 0;
   HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i20 + 4 >> 2] = i19;
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i5 | 0)) break; else {
    i4 = i4 + 36 | 0;
    i2 = i2 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i13);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i20, i1) {
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f21 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i9 = i20 + 28 | 0;
 i19 = HEAP32[i9 >> 2] | 0;
 f21 = Math_fround(i1 >>> 0);
 i10 = ~~Math_fround(f21 * Math_fround(HEAPF32[i20 + 36 >> 2])) >>> 0;
 i15 = i1 << 2;
 i14 = (i10 << 2) + i15 | 0;
 i14 = (0 - i14 & 12) + i14 | 0;
 i11 = i20 + 4 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i14 + (i10 << 4) | 0, HEAP32[i20 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i13 = i12 + i15 | 0;
 i14 = i12 + i14 | 0;
 _memset(i12 | 0, -1, i15 | 0) | 0;
 i15 = i20 + 48 | 0;
 i8 = i20 + 16 | 0;
 if (HEAP32[i15 >> 2] | 0) {
  i16 = i1 + -1 | 0;
  i18 = 0;
  do {
   i17 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i17 + (i18 << 4) >> 2] | 0;
   i6 = HEAP32[i17 + (i18 << 4) + 4 >> 2] | 0;
   i7 = HEAP32[i17 + (i18 << 4) + 8 >> 2] | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i3 = 5381; else {
    i3 = 5381;
    do {
     i3 = i3 * 33 ^ i2 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
    } while (i2 << 24 >> 24 != 0);
   }
   i2 = HEAP8[i6 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i5 = i2;
    i2 = 5381;
    i4 = i6;
    do {
     i2 = i2 * 33 ^ i5 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
    } while (i5 << 24 >> 24 != 0);
   }
   i5 = i2 ^ i3;
   i2 = HEAP8[i7 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    i3 = i7;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i7 = i12 + (((i5 ^ i2) & i16) << 2) | 0;
   HEAP32[i13 + (i18 << 2) >> 2] = HEAP32[i7 >> 2];
   HEAP32[i7 >> 2] = i18;
   i7 = i14 + (i18 << 4) | 0;
   i6 = i17 + (i18 << 4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i14 + (i18 << 4) + 12 >> 2] = HEAP32[i17 + (i18 << 4) + 12 >> 2];
   i18 = i18 + 1 | 0;
  } while (i18 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 i18 = i20 + 12 | 0;
 i17 = HEAP32[i11 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, HEAP32[i18 >> 2] | 0);
 HEAP32[i18 >> 2] = i12;
 HEAP32[i20 + 24 >> 2] = i12;
 HEAP32[i20 + 32 >> 2] = i1;
 HEAP32[i20 + 20 >> 2] = i13;
 HEAP32[i8 >> 2] = i14;
 HEAP32[i9 >> 2] = i10;
 i1 = i20 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i19;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i5 = mftCall_ii(i6 | 0, HEAP32[i10 + 8 >> 2] | 0) | 0;
 i7 = i10 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i5;
 if (!i5) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i8 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i8);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i5 | 0) | 0;
  i2 = getTempRet0() | 0;
  i8 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i8 ? i1 : i4;
  i2 = i8 ? 0 : i2;
 }
 i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = gb + 753858;
 HEAP32[i9 + 4 >> 2] = i5;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 mftCall_viii(i8 | 0, i6 | 0, i3 | 0, i9 | 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i11;
 return;
}

function __ZN24MaterialDisplayListCache16CachedShaderPass9FindEntryERK16ShaderKeywordSet(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if ((HEAP8[i11 + 240 >> 0] | 0) >= 0) {
  i11 = 0;
  return i11 | 0;
 }
 if ((HEAP32[i11 + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i11 + 8 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i11 + 12 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i11 + 16 >> 2] | 0) == (i9 | 0)) if ((HEAP32[i11 + 20 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i11 + 24 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i11 + 28 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i11 + 32 >> 2] | 0) == (i1 | 0)) return i11 | 0;
 i3 = HEAP8[i11 + 241 >> 0] | 0;
 if (i3 << 24 >> 24 >= 0) {
  i11 = 0;
  return i11 | 0;
 }
 if ((HEAP32[i11 + 64 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i11 + 68 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i11 + 72 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i11 + 76 >> 2] | 0) == (i9 | 0)) if ((HEAP32[i11 + 80 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i11 + 84 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i11 + 88 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i11 + 92 >> 2] | 0) == (i1 | 0)) i2 = 1; else i10 = 23; else i10 = 23; else i10 = 23; else i10 = 23; else i10 = 23; else i10 = 23; else i10 = 23; else i10 = 23;
 do if ((i10 | 0) == 23) {
  i3 = HEAP8[i11 + 242 >> 0] | 0;
  if (i3 << 24 >> 24 >= 0) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 124 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i11 + 128 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i11 + 132 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i11 + 136 >> 2] | 0) == (i9 | 0)) if ((HEAP32[i11 + 140 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i11 + 144 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i11 + 148 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i11 + 152 >> 2] | 0) == (i1 | 0)) {
   i2 = 2;
   break;
  }
  i3 = HEAP8[i11 + 243 >> 0] | 0;
  if (i3 << 24 >> 24 >= 0) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 184 >> 2] | 0) != (i6 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 188 >> 2] | 0) != (i7 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 192 >> 2] | 0) != (i8 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 196 >> 2] | 0) != (i9 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 200 >> 2] | 0) != (i2 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 204 >> 2] | 0) != (i4 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 208 >> 2] | 0) != (i5 | 0)) {
   i11 = 0;
   return i11 | 0;
  }
  if ((HEAP32[i11 + 212 >> 2] | 0) == (i1 | 0)) i2 = 3; else {
   i11 = 0;
   return i11 | 0;
  }
 } while (0);
 i1 = i11 + (i2 * 60 | 0) | 0;
 do {
  i10 = i2;
  i2 = i2 + -1 | 0;
  i8 = i11 + 240 + i2 | 0;
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i8 >> 0] = i3;
  HEAP8[i11 + 240 + i10 >> 0] = i9;
 } while ((i10 | 0) > 1);
 return i1 | 0;
}

function __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE15set_deleted_keyERSF_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 24 | 0;
 i7 = i10;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i7 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i8 >> 2] | 0;
   i9 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i7 + 11 >> 0] = i4;
   if (!i4) i1 = i7; else {
    i1 = i7;
    i9 = 8;
   }
  } else {
   i1 = i2;
   i9 = 6;
  }
  if ((i9 | 0) == 6) {
   i2 = i4 + 16 & -16;
   HEAP32[i6 >> 2] = 54;
   HEAP32[i6 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i7 + 4 >> 2] = i4;
   i9 = 8;
  }
  if ((i9 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 HEAP32[i7 + 16 >> 2] = 0;
 if (HEAP32[i5 + 4 >> 2] | 0) {
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j(i6, i5, 0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_(i5, i6);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev(i6);
 }
 HEAP8[i5 + 8 >> 0] = 1;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i5, i5 + 12 | 0, i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 54;
 HEAP32[i6 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
 STACKTOP = i10;
 return;
}

function __ZL26ExtractScriptTypeReferenceRK16TypeTreeIteratorjR15CacheReaderBasebR31LocalSerializedObjectIdentifier(i1, i8, i9, i10, i12) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i11 = i13;
 __ZNK16TypeTreeIterator8ChildrenEv(i6, i1);
 if (!(HEAP32[i6 >> 2] | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i5 = HEAP32[gb + 36932 >> 2] | 0;
 i3 = HEAP32[gb + 36936 >> 2] | 0;
 i4 = i5 >>> 0 > (gb + 588832 | 0) >>> 0;
 L4 : do if (i3 >>> 0 > (gb + 588832 | 0) >>> 0) {
  i1 = 0;
  while (1) {
   if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 12 >> 2] | 0) == -1) {
    i1 = 0;
    i2 = 17;
    break;
   }
   i2 = __ZNK16TypeTreeIterator4NameEv(i6) | 0;
   do if (i2 | 0) if (i4 | (i5 >>> 0 > i2 >>> 0 | i3 >>> 0 <= i2 >>> 0)) if (!(_strcmp(gb + 588832 | 0, i2) | 0)) {
    i7 = i1;
    break L4;
   } else break; else if ((i2 | 0) == (gb + 588832 | 0)) {
    i7 = i1;
    break L4;
   } else break; while (0);
   i1 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 12 >> 2] | 0) + i1 | 0;
   i2 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 20 >> 2] & 16384 | 0) == 0;
   __ZNK16TypeTreeIterator4NextEv(i11, i6);
   i16 = i11;
   i14 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = i6;
   HEAP32[i15 >> 2] = i14;
   HEAP32[i15 + 4 >> 2] = i16;
   if (!i14) {
    i1 = 0;
    i2 = 17;
    break;
   } else i1 = i2 ? i1 : i1 + 3 & -4;
  }
  if ((i2 | 0) == 17) {
   STACKTOP = i13;
   return i1 | 0;
  }
 } else {
  i1 = 0;
  while (1) {
   if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 12 >> 2] | 0) == -1) {
    i1 = 0;
    i2 = 17;
    break;
   }
   i2 = __ZNK16TypeTreeIterator4NameEv(i6) | 0;
   if (i2 | 0) if (!(_strcmp(gb + 588832 | 0, i2) | 0)) {
    i7 = i1;
    break L4;
   }
   i1 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 12 >> 2] | 0) + i1 | 0;
   i2 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i6) | 0) + 20 >> 2] & 16384 | 0) == 0;
   __ZNK16TypeTreeIterator4NextEv(i11, i6);
   i14 = i11;
   i16 = HEAP32[i14 >> 2] | 0;
   i14 = HEAP32[i14 + 4 >> 2] | 0;
   i15 = i6;
   HEAP32[i15 >> 2] = i16;
   HEAP32[i15 + 4 >> 2] = i14;
   if (!i16) {
    i1 = 0;
    i2 = 17;
    break;
   } else i1 = i2 ? i1 : i1 + 3 & -4;
  }
  if ((i2 | 0) == 17) {
   STACKTOP = i13;
   return i1 | 0;
  }
 } while (0);
 __Z13ReadFileCacheR15CacheReaderBasePvjj(i9, i11, i7 + i8 | 0, 8);
 i1 = HEAP32[i11 >> 2] | 0;
 if (i10) {
  i2 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i11 >> 2] = i2;
  i16 = i11 + 4 | 0;
  i1 = _llvm_bswap_i32(HEAP32[i16 >> 2] | 0) | 0;
  HEAP32[i16 >> 2] = i1;
 } else {
  i2 = i1;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 i16 = i12 + 8 | 0;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i16 + 4 >> 2] = ((i1 | 0) < 0) << 31 >> 31;
 i16 = 1;
 STACKTOP = i13;
 return i16 | 0;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i4 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 16 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = (i1 - i5 >> 4) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i8 = i4 - i7 | 0;
 i5 = i8 >> 3;
 i5 = i8 >> 4 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (i1 - i7 >> 4 << 4) | 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i3 + (i5 << 4);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS7_RS8_EE(i10, i11);
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 1;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i13;
 return;
}

function __ZN16Physics2DManager16OverlapCircleAllERK8Vector2ffiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i1, i10, f12, i3, f5, f9, i4, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 f12 = Math_fround(f12);
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 f9 = Math_fround(f9);
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17;
 i15 = i17 + 8 | 0;
 if ((HEAP16[gb + 1457788 + 6 >> 1] | 0) > -1) {
  HEAP32[i15 >> 2] = 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457788 | 0, i14);
  i16 = gb + 1457788 | 0;
 } else i16 = 0;
 HEAP32[i15 >> 2] = gb + 158736 + 8;
 HEAP32[i15 + 4 >> 2] = i3;
 i7 = i15 + 8 | 0;
 i8 = i15 + 12 | 0;
 HEAP32[i15 + 16 >> 2] = i4;
 i1 = i15 + 20 | 0;
 i3 = i15 + 28 | 0;
 HEAP32[i3 >> 2] = gb + 151824 + 8;
 i11 = i15 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i11 = i15 + 48 | 0;
 i4 = i15 + 64 | 0;
 i13 = i15 + 80 | 0;
 HEAP32[i13 >> 2] = i2;
 i18 = f5 == Math_fround(-inf);
 f6 = i18 ? Math_fround(-3402823469999999843913219.0e14) : f5;
 HEAPF32[i7 >> 2] = f6;
 i18 = f9 == Math_fround(inf);
 f5 = i18 ? Math_fround(3402823469999999843913219.0e14) : f9;
 HEAPF32[i8 >> 2] = f5;
 if (!(f6 < f5)) {
  HEAPF32[i7 >> 2] = f5;
  HEAPF32[i8 >> 2] = f6;
 }
 if (f12 < Math_fround(9.99999974e-06)) {
  i18 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i15 + 24 >> 2] = i18;
  i18 = i1;
  i10 = HEAP32[i18 >> 2] | 0;
  i18 = HEAP32[i18 + 4 >> 2] | 0;
  i1 = i15 + 56 | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i18;
  i1 = i11;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i18;
  i1 = 1;
 } else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i15 + 40 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i15 + 44 >> 2] = i1;
  HEAPF32[i15 + 36 >> 2] = f12;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 72 >> 2] = Math_fround(0.0);
  HEAPF32[i15 + 76 >> 2] = Math_fround(1.0);
  __ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i3, i11, i4, 0, 1);
  i1 = 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 HEAP8[i15 + 84 >> 0] = i1;
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i15, i11);
 i1 = HEAP32[i13 >> 2] | 0;
 i18 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i18, i18 + (HEAP32[i1 + 12 >> 2] << 2) | 0, i14);
 i1 = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0;
 if (!i16) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i8 = i9;
   i10 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i1 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = (HEAP32[i12 >> 2] | 0) + 32 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = i3 - i4 | 0;
 i8 = i7 >> 4;
 i5 = i7 >> 5 >>> 0 < 67108863 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 134217727;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 << 5) | 0;
 i7 = i6 + (i1 - i4 >> 5 << 5) | 0;
 i3 = i7;
 i4 = i6 + (i5 << 5) | 0;
 i8 = i3;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i14 = i9;
  i5 = HEAP32[i14 + 4 >> 2] | 0;
  i6 = i1 + 16 | 0;
  HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i8 + 32 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i9 = i2 + -32 | 0;
   i14 = i1;
   i1 = i1 + -32 | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + -20 | 0, i14 + -20 | 0);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -32 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i5);
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i5 = mftCall_ii(i6 | 0, HEAP32[i10 + 8 >> 2] | 0) | 0;
 i7 = i10 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i5;
 if (!i5) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i8 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i8);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i5 | 0) | 0;
  i2 = getTempRet0() | 0;
  i8 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i8 ? i1 : i4;
  i2 = i8 ? 0 : i2;
 }
 i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = gb + 753780;
 HEAP32[i9 + 4 >> 2] = i5;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 mftCall_viii(i8 | 0, i6 | 0, i3 | 0, i9 | 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i11;
 return;
}

function __Z23AssignGlobalGameManagerP6Object(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 4 | 0;
 if (!i4) {
  STACKTOP = i7;
  return;
 }
 i2 = (HEAP32[i4 + 8 >> 2] | 0) >>> 21;
 if ((i2 - (HEAP32[gb + 28760 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28760 + 28 >> 2] | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[gb + 1106156 + 4 + (i2 << 2) >> 2] | 0;
 do if ((HEAP32[gb + 1104348 + 112 >> 2] | 0) == (i1 | 0)) i1 = 0; else if ((HEAP32[gb + 1104348 + 116 >> 2] | 0) == (i1 | 0)) i1 = 1; else if ((HEAP32[gb + 1104348 + 120 >> 2] | 0) == (i1 | 0)) i1 = 2; else if ((HEAP32[gb + 1104348 + 124 >> 2] | 0) == (i1 | 0)) i1 = 3; else if ((HEAP32[gb + 1104348 + 128 >> 2] | 0) == (i1 | 0)) i1 = 4; else if ((HEAP32[gb + 1104348 + 132 >> 2] | 0) == (i1 | 0)) i1 = 5; else if ((HEAP32[gb + 1104348 + 136 >> 2] | 0) == (i1 | 0)) i1 = 6; else if ((HEAP32[gb + 1104348 + 140 >> 2] | 0) == (i1 | 0)) i1 = 7; else if ((HEAP32[gb + 1104348 + 144 >> 2] | 0) == (i1 | 0)) i1 = 8; else if ((HEAP32[gb + 1104348 + 148 >> 2] | 0) == (i1 | 0)) i1 = 9; else if ((HEAP32[gb + 1104348 + 152 >> 2] | 0) == (i1 | 0)) i1 = 10; else if ((HEAP32[gb + 1104348 + 156 >> 2] | 0) == (i1 | 0)) i1 = 11; else if ((HEAP32[gb + 1104348 + 160 >> 2] | 0) == (i1 | 0)) i1 = 12; else if ((HEAP32[gb + 1104348 + 164 >> 2] | 0) == (i1 | 0)) i1 = 13; else if ((HEAP32[gb + 1104348 + 168 >> 2] | 0) == (i1 | 0)) i1 = 14; else if ((HEAP32[gb + 1104348 + 172 >> 2] | 0) == (i1 | 0)) i1 = 15; else if ((HEAP32[gb + 1104348 + 176 >> 2] | 0) == (i1 | 0)) i1 = 16; else {
  if ((HEAP32[gb + 1104348 + 180 >> 2] | 0) == (i1 | 0)) {
   i1 = 17;
   break;
  }
  if ((HEAP32[gb + 1104348 + 184 >> 2] | 0) == (i1 | 0)) {
   i1 = 18;
   break;
  }
  if ((HEAP32[gb + 1104348 + 188 >> 2] | 0) == (i1 | 0)) {
   i1 = 19;
   break;
  }
  if ((HEAP32[gb + 1104348 + 192 >> 2] | 0) == (i1 | 0)) {
   i1 = 20;
   break;
  }
  if ((HEAP32[gb + 1104348 + 196 >> 2] | 0) == (i1 | 0)) {
   i1 = 21;
   break;
  }
  if ((HEAP32[gb + 1104348 + 200 >> 2] | 0) == (i1 | 0)) {
   i1 = 22;
   break;
  }
  if ((HEAP32[gb + 1104348 + 204 >> 2] | 0) == (i1 | 0)) {
   i1 = 23;
   break;
  }
  STACKTOP = i7;
  return;
 } while (0);
 i3 = gb + 1104348 + (i1 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!((i1 | 0) == 0 | (i1 | 0) == (i4 | 0))) {
  i1 = HEAP32[gb + 1110260 >> 2] | 0;
  i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + (i2 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
  if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  __Z6FormatPKcz(i5, gb + 370569 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 370483 | 0, 193, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 HEAP32[i3 >> 2] = i4;
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i1, i8, i12) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L1 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L1;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i10 | 0, 0, 256) | 0;
 i6 = i10 + 255 | 0;
 HEAP32[i9 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L6 : do if (!(i2 << 24 >> 24)) i2 = i10; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i10;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L6;
   i7 = HEAP32[i9 >> 2] | 0;
   if (!(i2 >>> 0 < i7 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i10; while (0);
 HEAP8[i2 >> 0] = 0;
 f13 = Math_fround(+_strtod(i10, i9));
 i7 = i10;
 i1 = i1 + ((HEAP32[i9 >> 2] | 0) - i7) | 0;
 HEAP32[i12 >> 2] = i1;
 HEAPF32[i8 >> 2] = f13;
 i5 = i8 + 4 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L12 : do if (i2 << 24 >> 24) do {
  if (!(_isspace(i2 & 255) | 0)) break L12;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0); while (0);
 _memset(i10 | 0, 0, 256) | 0;
 HEAP32[i9 >> 2] = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 L17 : do if (!(i2 << 24 >> 24)) i2 = i10; else if (!(_isspace(i2 & 255) | 0)) {
  i4 = i1;
  i3 = i10;
  while (1) {
   i2 = i3 + 1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i3 << 24 >> 24)) break L17;
   i14 = HEAP32[i9 >> 2] | 0;
   if (!(i2 >>> 0 < i14 >>> 0 & (_isspace(i3 & 255) | 0) == 0)) break; else i3 = i2;
  }
 } else i2 = i10; while (0);
 HEAP8[i2 >> 0] = 0;
 f13 = Math_fround(+_strtod(i10, i9));
 i1 = i1 + ((HEAP32[i9 >> 2] | 0) - i7) | 0;
 HEAP32[i12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f13;
 i5 = i8 + 8 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 L23 : do if (!(i2 << 24 >> 24)) i4 = i1; else while (1) {
  if (!(_isspace(i2 & 255) | 0)) {
   i4 = i1;
   break L23;
  }
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   i4 = i1;
   break;
  }
 } while (0);
 _memset(i10 | 0, 0, 256) | 0;
 HEAP32[i9 >> 2] = i6;
 i1 = HEAP8[i4 >> 0] | 0;
 L28 : do if (!(i1 << 24 >> 24)) i1 = i10; else if (!(_isspace(i1 & 255) | 0)) {
  i3 = i4;
  i2 = i10;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L28;
   i14 = HEAP32[i9 >> 2] | 0;
   if (!(i1 >>> 0 < i14 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i10; while (0);
 HEAP8[i1 >> 0] = 0;
 f13 = Math_fround(+_strtod(i10, i9));
 HEAP32[i12 >> 2] = i4 + ((HEAP32[i9 >> 2] | 0) - i7);
 HEAPF32[i5 >> 2] = f13;
 STACKTOP = i11;
 return;
}

function __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i5 = i8 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i8 + 16 | 0;
 if (!i1) i1 = i7; else {
  i6 = i7;
  i4 = 0;
  do {
   i2 = (HEAP32[i7 >> 2] | 0) + i6 + (i4 << 5) + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i3 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  i1 = i7;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i1 + i7 | 0);
 i1 = i8 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i5 = i8 + 32 | 0;
 i7 = i8 + 36 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) i1 = i7; else {
  i6 = i7;
  i4 = 0;
  do {
   i3 = (HEAP32[i7 >> 2] | 0) + i6 | 0;
   i1 = i3 + (i4 * 28 | 0) + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i1 + i2 | 0);
   i1 = i3 + (i4 * 28 | 0) + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
   i1 = i3 + (i4 * 28 | 0) + 24 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
  i1 = i7;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i1 + i7 | 0);
 i1 = i8 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i1 = i8 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i7 = HEAP32[i9 >> 2] | 0;
  i7 = i7 + 4 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vii(i7 | 0, i9 | 0, i8 | 0);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i2 + i1 | 0);
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = i7 + 4 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_vii(i7 | 0, i9 | 0, i8 | 0);
 return;
}

function __ZN7mecanim9animation4Clip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i7 = i9 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i10, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN7mecanim9animation9DenseClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 12 | 0, i9);
 i1 = i6 + 40 | 0;
 i5 = i6 + 36 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i10, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i7 = i9 + 4 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, 8, 4) | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i6 = i1;
  i8 = i8 | 0 ? i8 - i6 | 0 : 0;
  HEAP32[i1 >> 2] = i8;
  i6 = i8 + i6 | 0;
  i8 = i6 + 4 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 >> 2] = i8;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i10 + 8 | 0;
  HEAP32[i8 >> 2] = i7;
  __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i10, i9);
  STACKTOP = i11;
  return;
 } else {
  i6 = i1;
  i7 = i9 + 4 | 0;
  i8 = i2;
  i6 = i8 + i6 | 0;
  i8 = i6 + 4 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 >> 2] = i8;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i10 + 8 | 0;
  HEAP32[i8 >> 2] = i7;
  __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i10, i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i10 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i10 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i5;
 HEAP8[i9 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i9) | 0;
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i5 = mftCall_ii(i6 | 0, HEAP32[i10 + 8 >> 2] | 0) | 0;
 i7 = i10 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i5;
 if (!i5) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i8 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i8);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i5 | 0) | 0;
  i2 = getTempRet0() | 0;
  i8 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i8 ? i1 : i4;
  i2 = i8 ? 0 : i2;
 }
 i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = gb + 753930;
 HEAP32[i9 + 4 >> 2] = i5;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 mftCall_viii(i8 | 0, i6 | 0, i3 | 0, i9 | 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine7Connect13ConfigHandler13ConfigChangedERK8UnityStr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 192 | 0;
 i14 = i17;
 i15 = i17 + 176 | 0;
 __ZN8JSONReadC2EPKc24TransferInstructionFlagsRK10MemLabelIdbPNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEi(i14, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 64016 | 0, 0, 0, 0);
 i1 = HEAP32[i2 >> 2] | 0;
 i6 = i2 + 4 | 0;
 if ((i1 | 0) == (i6 | 0)) {
  __ZN8JSONReadD2Ev(i14);
  STACKTOP = i17;
  return;
 }
 i7 = i15 + 12 | 0;
 i5 = i15 + 12 | 0;
 i8 = i13 + 4 | 0;
 i9 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i11 = i15 + 11 | 0;
 i12 = i13 + 4 | 0;
 i2 = i1;
 while (1) {
  i3 = i2 + 16 | 0;
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i3 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
  HEAP32[i15 >> 2] = 0;
  HEAP32[i15 + 4 >> 2] = 0;
  HEAP32[i15 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i15);
   i1 = HEAP32[i5 >> 2] | 0;
   i16 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i11 >> 0] = i4;
   if (!i4) i1 = i15; else {
    i1 = i15;
    i16 = 8;
   }
  } else i16 = 6;
  if ((i16 | 0) == 6) {
   i18 = i4 + 16 & -16;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i8 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i18, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i9 >> 2] = i18 | -2147483648;
   HEAP32[i10 >> 2] = i4;
   i16 = 8;
  }
  if ((i16 | 0) == 8) {
   i16 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  if (__ZN8JSONRead18GetValueNodeForKeyEPKc(i14, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15) | 0) {
   i3 = i2 + 800 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = 0;
    do {
     i4 = i2 + 32 + (i1 * 12 | 0) | 0;
     if (!(HEAP8[i2 + 32 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i4 >> 2] | 0, i15 | 0, i14 | 0); else mftCall_viii(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 32 + (i1 * 12 | 0) + 4 >> 2] | 0, i15 | 0, i14 | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
  }
  if ((HEAP8[i11 >> 0] | 0) < 0) {
   i18 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i13 >> 2] = 66;
   HEAP32[i12 >> 2] = i4;
   __Z19free_alloc_internalPvRK10MemLabelId(i18, i13);
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
 }
 __ZN8JSONReadD2Ev(i14);
 STACKTOP = i17;
 return;
}

function __ZN11TypeManager19ClassNameToTypeInfoEPKcb(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16 + 4 | 0;
 i14 = i16;
 HEAP32[i14 >> 2] = i1;
 if (!i2) {
  if ((HEAP32[i4 + 100 >> 2] | 0) == (HEAP32[i4 + 68 >> 2] | 0)) {
   i2 = HEAP32[i4 + 92 >> 2] | 0;
   i3 = HEAP32[i4 + 96 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_(i3, i4 + 64 | 0, i14);
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i4 + 92 >> 2] | 0;
   i3 = HEAP32[i4 + 96 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  i15 = HEAP32[i1 + 4 >> 2] | 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 __ZN14dense_hash_mapIPKcPK4RTTIN11TypeManager23ConstCharPtrHashFunctorENS5_19ConstCharPtrEqualToE13stl_allocatorINSt3__24pairIKS1_S4_EEL18MemLabelIdentifier6ELi16EEE5beginEv(i3, i4 + 64 | 0);
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i12 = HEAP32[i3 + 8 >> 2] | 0;
 i13 = i4 + 92 | 0;
 i8 = i4 + 96 | 0;
 if ((i1 | 0) == ((HEAP32[i13 >> 2] | 0) + (HEAP32[i8 >> 2] << 3) | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i2 + 4 | 0;
 i10 = i2 + 20 | 0;
 i11 = i2 + 8 | 0;
 i7 = i2 + 12 | 0;
 while (1) {
  if (!(__Z7StrICmpPKcS0_(HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) break;
  i2 = i1 + 8 | 0;
  i1 = i2;
  L18 : do if ((i2 | 0) != (i12 | 0)) {
   i6 = HEAP32[i10 >> 2] | 0;
   if (!i6) {
    i4 = i2;
    while (1) {
     i2 = HEAP32[i4 >> 2] | 0;
     if (i2 | 0) {
      if (!(HEAP8[i11 >> 0] | 0)) break L18;
      if (!(HEAP32[i9 >> 2] | 0)) break L18;
      i3 = HEAP32[i7 >> 2] | 0;
      if ((i3 | 0) != (i2 | 0)) {
       if (!i3) break L18;
       if (_strcmp(i3, i2) | 0) break L18;
      }
     }
     i4 = i4 + 8 | 0;
     i1 = i4;
     if ((i4 | 0) == (i12 | 0)) break L18;
    }
   }
   do {
    i3 = HEAP32[i2 >> 2] | 0;
    do if ((i6 | 0) != (i3 | 0)) {
     i4 = (i3 | 0) != 0;
     if (i4) if (!(_strcmp(i6, i3) | 0)) break;
     if (!(HEAP8[i11 >> 0] | 0)) break L18;
     if (!(HEAP32[i9 >> 2] | 0)) break L18;
     i5 = HEAP32[i7 >> 2] | 0;
     if ((i5 | 0) != (i3 | 0)) {
      if (!(i4 & (i5 | 0) != 0)) break L18;
      if (_strcmp(i5, i3) | 0) break L18;
     }
    } while (0);
    i2 = i2 + 8 | 0;
    i1 = i2;
   } while ((i2 | 0) != (i12 | 0));
  } while (0);
  if ((i1 | 0) == ((HEAP32[i13 >> 2] | 0) + (HEAP32[i8 >> 2] << 3) | 0)) {
   i1 = 0;
   i15 = 7;
   break;
  }
 }
 if ((i15 | 0) == 7) {
  STACKTOP = i16;
  return i1 | 0;
 }
 i15 = HEAP32[i1 + 4 >> 2] | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN5physx22PxVehicleWheelsSimData8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 i4 = (i1 + 3 | 0) >>> 2;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8 + 32 | 0, (i4 * 944 | 0) + 64 | 0, gb + 834202 | 0, 49) | 0;
 i2 = i6 + 64 | 0;
 i7 = i6 + 32 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i6 + 36 >> 2] = i4;
 HEAP32[i6 + 40 >> 2] = i1;
 if (i4 | 0) {
  __ZN5physx23PxVehicleWheels4SimDataC2Ev(i2);
  if ((i4 | 0) != 1) {
   i2 = 1;
   do {
    __ZN5physx23PxVehicleWheels4SimDataC2Ev((HEAP32[i7 >> 2] | 0) + (i2 * 944 | 0) | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
  }
 }
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(.230800003);
 HEAPF32[i6 + 8 >> 2] = Math_fround(3.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(3.0);
 HEAPF32[i6 + 16 >> 2] = Math_fround(.333333343);
 i2 = i6 + 44 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 if (i1 | 0) {
  i2 = 0;
  do {
   i10 = i6 + 44 + (i2 >>> 5 << 2) | 0;
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << (i2 & 31);
   i10 = i2 >>> 2;
   i9 = i2 & 3;
   __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i7 >> 2] | 0) + (i10 * 944 | 0) | 0, i9, i2);
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i7 >> 2] | 0) + (i10 * 944 | 0) | 0, i9, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 if (i4 << 2 >>> 0 <= i1 >>> 0) {
  i10 = HEAP32[gb + 158872 >> 2] | 0;
  i9 = i6 + 48 | 0;
  HEAP32[i9 >> 2] = i10;
  i9 = HEAP32[gb + 158876 >> 2] | 0;
  i10 = i6 + 52 | 0;
  HEAP32[i10 >> 2] = i9;
  i10 = HEAP32[gb + 158880 >> 2] | 0;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = i10;
  i9 = HEAP32[gb + 158884 >> 2] | 0;
  i10 = i6 + 60 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i8;
  return i6 | 0;
 }
 i2 = i4 << 2;
 do {
  i9 = i6 + 44 + (i1 >>> 5 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << (i1 & 31));
  i9 = i1 >>> 2;
  i10 = i1 & 3;
  __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i7 >> 2] | 0) + (i9 * 944 | 0) | 0, i10, -1);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i7 >> 2] | 0) + (i9 * 944 | 0) | 0, i10, i5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i10 = HEAP32[gb + 158872 >> 2] | 0;
 i9 = i6 + 48 | 0;
 HEAP32[i9 >> 2] = i10;
 i9 = HEAP32[gb + 158876 >> 2] | 0;
 i10 = i6 + 52 | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = HEAP32[gb + 158880 >> 2] | 0;
 i9 = i6 + 56 | 0;
 HEAP32[i9 >> 2] = i10;
 i9 = HEAP32[gb + 158884 >> 2] | 0;
 i10 = i6 + 60 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i8;
 return i6 | 0;
}

function __ZN15ParticleEmitter9TimedEmitEf(i5, f6) {
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = i5 + 206 | 0;
 i1 = i5 + 136 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(HEAP8[i4 >> 0] | 0)) {
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i5 + 128 >> 2]));
  i2 = f3 > Math_fround(16250.0);
  f3 = Math_fround((i2 ? Math_fround(16250.0) : f3) + Math_fround(.99999994));
 } else {
  i2 = f3 > Math_fround(16250.0);
  f3 = Math_fround((i2 ? Math_fround(16250.0) : f3) + Math_fround(.5));
 }
 i10 = ~~f3 >>> 0;
 i2 = i5 + 56 | 0;
 __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE7reserveEj(i2, i10);
 f11 = Math_fround(HEAPF32[i5 + 132 >> 2]);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 i12 = HEAP32[gb + 1477076 >> 2] | 0;
 i12 = i12 << 11 ^ i12;
 HEAP32[gb + 1477076 >> 2] = HEAP32[gb + 1477080 >> 2];
 HEAP32[gb + 1477080 >> 2] = HEAP32[gb + 1477084 >> 2];
 i1 = HEAP32[gb + 1477088 >> 2] | 0;
 HEAP32[gb + 1477084 >> 2] = i1;
 i1 = i12 >>> 8 ^ i12 ^ i1 ^ i1 >>> 19;
 HEAP32[gb + 1477088 >> 2] = i1;
 f3 = Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround(f11 * f3) + Math_fround(f9 * Math_fround(Math_fround(1.0) - f3)));
 f9 = Math_fround(i10 | 0);
 f3 = f9 < f3 ? f9 : f3;
 if (!(HEAP8[i4 >> 0] | 0)) {
  f11 = Math_fround(f3 * f6);
  i1 = i5 + 112 | 0;
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i1 >> 2]));
  i4 = ~~f11 >>> 0;
  HEAPF32[i1 >> 2] = Math_fround(f11 - Math_fround(i4 | 0));
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i5 + 60 >> 2] | 0;
 } else {
  i1 = HEAP32[i5 + 60 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i4 = ~~Math_fround(f3 + Math_fround(.5)) >>> 0;
   i2 = i1;
  } else i4 = 0;
 }
 i1 = (((HEAP32[i5 + 64 >> 2] | 0) - i2 | 0) / 48 | 0) - ((i1 - i2 | 0) / 48 | 0) | 0;
 i1 = (i4 | 0) < (i1 | 0) ? i4 : i1;
 i2 = i5 + 44 | 0;
 if (!(HEAP8[i5 + 192 >> 0] | 0)) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  i12 = i5 + 32 | 0;
  HEAP32[i12 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 } else {
  i12 = i5 + 32 | 0;
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i8;
  return;
 }
 __ZN15ParticleEmitter4EmitEjf(i5, i1, Math_fround(__Z16CalcInvDeltaTimef(f6)));
 STACKTOP = i8;
 return;
}

function __ZNK5physx11PxSceneDesc7isValidEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 if (!(HEAP32[i8 + 32 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = (HEAP32[i8 + 24 >> 2] | 0) == 0;
 if (!(HEAP32[i8 + 28 >> 2] | 0)) {
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  }
 } else if (i1) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i8 + 72 >> 2] | 0) >>> 0 >= 257) {
  i8 = 0;
  return i8 | 0;
 }
 if (((HEAP32[i8 + 116 >> 2] | 0) + -1 | 0) >>> 0 >= 2) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i8 + 124 >> 2] | 0) >>> 0 < 4) {
  i8 = 0;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i8 + 80 >> 2]) < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i8 + 88 >> 2]) < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i8 + 92 >> 2]) < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i8 + 96 >> 2]) < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i8 + 104 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i8 + 144 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i8 + 140 >> 2] | 0) >>> 0 < (HEAP32[i8 + 136 >> 2] | 0) >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 if (Math_fround(HEAPF32[i8 + 156 >> 2]) <= Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i8 + 152 >> 2] | 0) == 1) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP16[i8 + 100 >> 1] & 16400) == 16400) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i8 + 160 >> 2] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i8 + 164 >> 2] | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i8 + 168 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i8 + 172 >> 2] | 0;
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i8 + 176 >> 2] | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i1 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = HEAP32[i8 + 180 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i8 & 2139095040) >>> 0 >= 2139095040) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(!(f3 <= f6) | !(f4 <= f7) | !(f5 <= f2))) {
  i8 = 1;
  return i8 | 0;
 }
 i8 = f3 == Math_fround(8507058669999999534545717.0e13) & f4 == Math_fround(8507058669999999534545717.0e13) & f5 == Math_fround(8507058669999999534545717.0e13) & f6 == Math_fround(-8507058669999999534545717.0e13) & f7 == Math_fround(-8507058669999999534545717.0e13) & f2 == Math_fround(-8507058669999999534545717.0e13);
 return i8 | 0;
}

function __ZN21DownloadHandlerScript21OnBindScriptingObjectEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 48 | 0;
 i3 = i9 + 40 | 0;
 i4 = i9 + 32 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 if (!i2) {
  __Z6FormatPKcz(i8, gb + 1026427 | 0, i9 + 24 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 1026505 | 0, 45, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  STACKTOP = i9;
  return;
 }
 if (HEAP32[(__Z34GetUnityWebRequestScriptingClassesv() | 0) >> 2] | 0) {
  i10 = i1 + 20 | 0;
  i13 = __Z34GetUnityWebRequestScriptingClassesv() | 0;
  i12 = HEAP32[i13 + 4 >> 2] | 0;
  i11 = i4;
  HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + 4 >> 2] = i12;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i2, i8);
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP8[i10 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 }
 if (HEAP32[(__Z34GetUnityWebRequestScriptingClassesv() | 0) + 24 >> 2] | 0) {
  i13 = i1 + 36 | 0;
  i10 = (__Z34GetUnityWebRequestScriptingClassesv() | 0) + 24 | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i5;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i2, i8);
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP8[i13 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 }
 if (HEAP32[(__Z34GetUnityWebRequestScriptingClassesv() | 0) + 16 >> 2] | 0) {
  i13 = i1 + 44 | 0;
  i10 = (__Z34GetUnityWebRequestScriptingClassesv() | 0) + 16 | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i6;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i2, i8);
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP8[i13 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 }
 if (!(HEAP32[(__Z34GetUnityWebRequestScriptingClassesv() | 0) + 8 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i13 = i1 + 28 | 0;
 i10 = (__Z34GetUnityWebRequestScriptingClassesv() | 0) + 8 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i7;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i2, i8);
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i13 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 STACKTOP = i9;
 return;
}

function __ZN13MonoBehaviour20WillDestroyComponentEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 256 | 0;
 i7 = i11 + 248 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 i1 = i6 + 143 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 587406 | 0, 0, gb + 587199 | 0, 255, 1, 0, 0, 0);
  STACKTOP = i11;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 i5 = i6 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i6 + 140 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 + 56 >> 2] | 0;
 if (!i1) i3 = 0; else if (((HEAP32[i1 + 28 >> 2] | 0) + -1 | 0) >>> 0 < 2) {
  i3 = i6 + 60 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i2 + 72 >> 2] | 0;
  i2 = HEAP8[i2 + 76 >> 0] | 0;
  if (i1 | 0) {
   HEAP32[i7 >> 2] = 0;
   i12 = i9;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i12 + 4 >> 2] = i2 & 255;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i8, i4, i10);
   HEAP8[i8 + 233 >> 0] = 1;
   HEAP32[i8 + 216 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i8);
   __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i8, i7) | 0;
  }
  if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) i3 = i2 & 255; else {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i2 + 80 >> 2] | 0;
   i2 = HEAP8[i2 + 84 >> 0] | 0;
   i3 = i2 & 255;
   if (i1) {
    HEAP32[i7 >> 2] = 0;
    i12 = HEAP32[i5 >> 2] | 0;
    i13 = i9;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i13 + 4 >> 2] = i2 & 255;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i8, i12, i10);
    HEAP8[i8 + 233 >> 0] = 1;
    HEAP32[i8 + 216 >> 2] = HEAP32[i6 + 4 >> 2];
    __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i8);
    __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i8, i7) | 0;
   }
  }
 } else i3 = 0;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i6 + 60 >> 2] | 0;
 i1 = HEAP32[i2 + 136 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAPU8[i2 + 140 >> 0] | i3 & -256;
 HEAP32[i7 >> 2] = 0;
 i13 = HEAP32[i5 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i8, i13, i10);
 HEAP8[i8 + 233 >> 0] = 1;
 HEAP32[i8 + 216 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i8);
 __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i8, i7) | 0;
 STACKTOP = i11;
 return;
}

function __ZNK9dtNavMesh15getPolyGeometryEyPfPyi(i9, i1, i2, i7, i13, i14) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0 | (i1 & 983040 | 0) == 65536 & 0 == 0) {
  i14 = 0;
  return i14 | 0;
 }
 i8 = _bitshift64Lshr(i1 | 0, i2 | 0, 20) | 0;
 getTempRet0() | 0;
 i8 = i8 & 268435455;
 i6 = i1 & 65535;
 if (i8 >>> 0 >= (HEAP32[i9 + 16 >> 2] | 0) >>> 0) {
  i14 = 0;
  return i14 | 0;
 }
 i11 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 if ((HEAP32[i5 + (i8 * 56 | 0) + 4 >> 2] | 0) != (i11 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i1 = HEAP32[i5 + (i8 * 56 | 0) + 8 >> 2] | 0;
 if (!i1) {
  i14 = 0;
  return i14 | 0;
 }
 if (i6 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
  i14 = 0;
  return i14 | 0;
 }
 i2 = HEAP32[i5 + (i8 * 56 | 0) + 16 >> 2] | 0;
 i4 = i2 + (i6 << 5) | 0;
 i10 = HEAP8[i2 + (i6 << 5) + 28 >> 0] | 0;
 i11 = i10 & 255;
 if ((i7 | 0) != 0 & i10 << 24 >> 24 != 0) {
  i3 = HEAP32[i5 + (i8 * 56 | 0) + 20 >> 2] | 0;
  i1 = 0;
  do {
   i15 = i7 + (i1 * 3 << 2) | 0;
   i16 = i3 + ((HEAPU16[i2 + (i6 << 5) + (i1 << 1) >> 1] | 0) * 3 << 2) | 0;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 }
 if (!i13) {
  i16 = i11;
  return i16 | 0;
 }
 i1 = Math_imul(i11, i14) | 0;
 if ((i1 | 0) > 0) _memset(i13 | 0, 0, i1 << 3 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 + (i8 * 56 | 0) + 12 >> 2] | 0) + (i4 - (HEAP32[i5 + (i8 * 56 | 0) + 16 >> 2] | 0) >> 5 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i16 = i11;
  return i16 | 0;
 }
 i1 = (HEAP32[i9 + 36 >> 2] | 0) + (i1 << 4) | 0;
 if (!i1) {
  i16 = i11;
  return i16 | 0;
 }
 i6 = i9 + 36 | 0;
 if ((i14 | 0) > 0) i12 = i1; else {
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i1 = i11;
    i2 = 25;
    break;
   }
   i1 = (HEAP32[i6 >> 2] | 0) + (i1 << 4) | 0;
   if (!i1) {
    i1 = i11;
    i2 = 25;
    break;
   }
  }
  if ((i2 | 0) == 25) return i1 | 0;
 }
 while (1) {
  i5 = i12;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  L42 : do if (!((i4 & 983040 | 0) == 65536 & 0 == 0)) {
   i1 = HEAP8[i12 + 12 >> 0] | 0;
   if ((i1 & 255) < (i10 & 255)) {
    i2 = Math_imul(i1 & 255, i14) | 0;
    i1 = 0;
    while (1) {
     i3 = i13 + (i1 + i2 << 3) | 0;
     i16 = i3;
     i1 = i1 + 1 | 0;
     if ((HEAP32[i16 >> 2] | 0) == 0 & (HEAP32[i16 + 4 >> 2] | 0) == 0) break;
     if ((i1 | 0) >= (i14 | 0)) break L42;
    }
    i16 = i3;
    HEAP32[i16 >> 2] = i4;
    HEAP32[i16 + 4 >> 2] = i5;
   }
  } while (0);
  i1 = HEAP32[i12 + 8 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = i11;
   i2 = 25;
   break;
  }
  i12 = (HEAP32[i6 >> 2] | 0) + (i1 << 4) | 0;
  if (!i12) {
   i1 = i11;
   i2 = 25;
   break;
  }
 }
 if ((i2 | 0) == 25) return i1 | 0;
 return 0;
}

function __ZN5Unity10HingeJoint16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 __ZN5Unity5Joint16CheckConsistencyEv(i1);
 i12 = i1 + 128 | 0;
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 i8 = f10 < Math_fround(-340282326000000008404918.0e15);
 i11 = f10 > Math_fround(340282326000000008404918.0e15);
 f10 = i11 ? Math_fround(340282326000000008404918.0e15) : f10;
 f10 = i8 ? Math_fround(-340282326000000008404918.0e15) : f10;
 i8 = i1 + 132 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i11 = f9 < Math_fround(0.0);
 i7 = f9 > Math_fround(340282326000000008404918.0e15);
 f9 = i7 ? Math_fround(340282326000000008404918.0e15) : f9;
 f9 = i11 ? Math_fround(0.0) : f9;
 HEAPF32[i12 >> 2] = f10;
 HEAPF32[i8 >> 2] = f9;
 i8 = i1 + 100 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i12 = f9 < Math_fround(-340282326000000008404918.0e15);
 i11 = f9 > Math_fround(340282326000000008404918.0e15);
 f9 = i11 ? Math_fround(340282326000000008404918.0e15) : f9;
 f9 = i12 ? Math_fround(-340282326000000008404918.0e15) : f9;
 i12 = i1 + 96 | 0;
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 i11 = f10 < Math_fround(-340282326000000008404918.0e15);
 i7 = f10 > Math_fround(340282326000000008404918.0e15);
 f10 = i7 ? Math_fround(340282326000000008404918.0e15) : f10;
 f10 = i11 ? Math_fround(-340282326000000008404918.0e15) : f10;
 i11 = f9 < f10;
 i7 = i1 + 104 | 0;
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 f2 = i3 ? Math_fround(0.0) : f2;
 i3 = i1 + 108 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = f4 < Math_fround(0.0);
 i13 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i13 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i5 ? Math_fround(0.0) : f4;
 i5 = i1 + 112 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i13 = f6 < Math_fround(0.0);
 i14 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i14 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i13 ? Math_fround(0.0) : f6;
 HEAPF32[i12 >> 2] = i11 ? f9 : f10;
 HEAPF32[i8 >> 2] = i11 ? f10 : f9;
 HEAPF32[i7 >> 2] = f2;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i5 >> 2] = f6;
 i5 = i1 + 116 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = f6 < Math_fround(0.0);
 i7 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i7 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = i1 + 120 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i7 = f4 < Math_fround(0.0);
 i8 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i8 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i7 ? Math_fround(0.0) : f4;
 i1 = i1 + 124 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = f2 < Math_fround(-180.0);
 i8 = f2 > Math_fround(180.0);
 f2 = i8 ? Math_fround(180.0) : f2;
 f2 = i7 ? Math_fround(-180.0) : f2;
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_mesh_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161260 | 0, gb + 426642 | 0, 0, 0);
 HEAP32[gb + 1161272 >> 2] = 0;
 HEAP32[gb + 1161272 + 12 >> 2] = 0;
 HEAP32[gb + 1161272 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i3 = i1;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = gb + 1161272 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[gb + 1161272 + 20 >> 2] = 0;
 HEAP32[gb + 1161272 + 32 >> 2] = 0;
 HEAP32[gb + 1161272 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i5 = i1;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = gb + 1161272 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[gb + 1161312 >> 2] = 0;
 HEAP32[gb + 1161312 + 12 >> 2] = 0;
 HEAP32[gb + 1161312 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = gb + 1161312 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161436 | 0, gb + 426662 | 0, 0, 0);
 HEAP32[gb + 1161344 >> 2] = 0;
 i4 = gb + 63528 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = gb + 1161344 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[gb + 1161344 + 12 >> 2] = 16;
 i1 = gb + 1161344 + 16 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3387 | 0, fb + 3388 | 0, 0, gb + 1161344 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161448 | 0, gb + 426683 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161424 | 0, gb + 426707 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161332 | 0, gb + 426722 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161460 | 0, gb + 426741 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161472 | 0, gb + 426761 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161484 | 0, gb + 426775 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161496 | 0, gb + 426791 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161508 | 0, gb + 426806 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161520 | 0, gb + 426826 | 0, 0, 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1161532 | 0, 2);
 STACKTOP = i2;
 return;
}

function __ZZL20PickDetailPolyHeightRK10DetailMeshiRK8Vector3fEN18PickHeightCallback7processES1_RK14DetailMeshPolyPKii(i1, i12, i14, i15, i16) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, f23 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 4 | 0;
 i18 = i21;
 if ((i16 | 0) <= 0) {
  STACKTOP = i21;
  return;
 }
 i19 = i12 + 20 | 0;
 i20 = i1 + 16 | 0;
 i13 = i1 + 20 | 0;
 i11 = i1 + 4 | 0;
 i10 = 0;
 do {
  i5 = (HEAP32[i19 >> 2] | 0) + (HEAP32[i15 + (i10 << 2) >> 2] << 2 << 1) | 0;
  i9 = HEAP32[i14 >> 2] | 0;
  i7 = (HEAPU16[i5 >> 1] | 0) + i9 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i4 = (HEAPU16[i5 + 2 >> 1] | 0) + i9 | 0;
  i9 = (HEAPU16[i5 + 4 >> 1] | 0) + i9 | 0;
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  i5 = i8 + (i7 * 12 | 0) | 0;
  i3 = i8 + (i4 * 12 | 0) | 0;
  i6 = i8 + (i9 * 12 | 0) | 0;
  if (__Z28dtClosestHeightPointTrianglePKfS0_S0_S0_Rf(i11, i5, i3, i6, i18) | 0) {
   HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
   HEAPF32[i13 >> 2] = Math_fround(0.0);
  } else if (Math_fround(HEAPF32[i13 >> 2]) > Math_fround(0.0)) {
   f2 = Math_fround(__Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i11, i5, i3, i17));
   if (f2 < Math_fround(3402823469999999843913219.0e14)) {
    f23 = Math_fround(HEAPF32[i8 + (i7 * 12 | 0) + 4 >> 2]);
    f22 = Math_fround(Math_fround(HEAPF32[i8 + (i4 * 12 | 0) + 4 >> 2]) - f23);
    HEAPF32[i18 >> 2] = Math_fround(f23 + Math_fround(f22 * Math_fround(HEAPF32[i17 >> 2])));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   } else i1 = 2139095039;
   f2 = Math_fround(__Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i11, i3, i6, i17));
   if (f2 < (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    f22 = Math_fround(HEAPF32[i8 + (i4 * 12 | 0) + 4 >> 2]);
    f23 = Math_fround(Math_fround(HEAPF32[i8 + (i9 * 12 | 0) + 4 >> 2]) - f22);
    HEAPF32[i18 >> 2] = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i17 >> 2])));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f2 = Math_fround(__Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i11, i6, i5, i17));
   if (f2 < (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
    f22 = Math_fround(HEAPF32[i8 + (i9 * 12 | 0) + 4 >> 2]);
    f23 = Math_fround(Math_fround(HEAPF32[i8 + (i7 * 12 | 0) + 4 >> 2]) - f22);
    HEAPF32[i18 >> 2] = Math_fround(f22 + Math_fround(f23 * Math_fround(HEAPF32[i17 >> 2])));
    i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   }
   f23 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f23 < Math_fround(HEAPF32[i13 >> 2])) {
    HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i13 >> 2] = i1;
   }
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i16 | 0));
 STACKTOP = i21;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f7 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f13);
 f14 = Math_fround(-f7);
 f11 = Math_fround(-f9);
 f8 = HEAP32[gb + 48 + (i1 << 4) >> 2] | 0 ? f13 : f8;
 f14 = HEAP32[gb + 48 + (i1 << 4) + 4 >> 2] | 0 ? f7 : f14;
 f11 = HEAP32[gb + 48 + (i1 << 4) + 8 >> 2] | 0 ? f9 : f11;
 f9 = Math_fround(HEAPF32[i15 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 f14 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f13 + Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __Z19NormalizeWheelInputf(f8) {
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 if (f8 == Math_fround(0.0)) {
  STACKTOP = i9;
  return Math_fround(f8);
 }
 if (!(HEAP8[gb + 1544206 >> 0] | 0)) {
  HEAP32[gb + 1103792 >> 2] = 0;
  HEAP32[gb + 1103792 + 12 >> 2] = 0;
  HEAP32[gb + 1103792 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
  i4 = i1;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = gb + 1103792 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP8[gb + 1544206 >> 0] = 1;
 }
 i1 = HEAP32[gb + 1103792 + 16 >> 2] | 0;
 do if ((i1 & 2147483644) >>> 0 < 500) if ((i1 | 0) > -1) {
  HEAP32[gb + 1103792 + 16 >> 2] = 500;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1103792 >> 2] | 0, 2e3, 4, gb + 1103792 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[gb + 1103792 >> 2] = i6;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2e3, 4, gb + 1103792 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[gb + 1103792 >> 2] | 0, HEAP32[gb + 1103792 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[gb + 1103792 + 16 >> 2] = 500;
  HEAP32[gb + 1103792 >> 2] = i6;
  break;
 } while (0);
 i1 = HEAP32[gb + 1103792 + 12 >> 2] | 0;
 if (i1 >>> 0 < 500) {
  f7 = Math_fround(Math_abs(Math_fround(f8)));
  i6 = HEAP32[gb + 1103792 >> 2] | 0;
  i4 = i6;
  L15 : do if (!i1) i2 = i6; else {
   i3 = i6 + (i1 << 2) | 0;
   i2 = i6;
   while (1) {
    if (!(Math_fround(HEAPF32[i2 >> 2]) < f7)) break L15;
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i2 = i3;
     break;
    }
   }
  } while (0);
  i4 = i2 - i4 >> 2;
  i5 = i1 - i4 | 0;
  i1 = i1 + 1 | 0;
  HEAP32[gb + 1103792 + 12 >> 2] = i1;
  i2 = HEAP32[gb + 1103792 + 16 >> 2] | 0;
  i3 = i2 & 2147483647;
  do if (i3 >>> 0 < i1 >>> 0) {
   i10 = i2 << 1;
   i1 = i10 >>> 0 > i1 >>> 0 ? i10 : i1;
   if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[gb + 1103792 + 16 >> 2] = i1;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, gb + 1103792 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[gb + 1103792 >> 2] = i1;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, gb + 1103792 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[gb + 1103792 >> 2] | 0, HEAP32[gb + 1103792 + 12 >> 2] << 2 | 0) | 0;
    HEAP32[gb + 1103792 + 16 >> 2] = i1;
    HEAP32[gb + 1103792 >> 2] = i10;
    i1 = i10;
    break;
   } else i1 = i6;
  } else i1 = i6; while (0);
  i1 = i1 + (i4 << 2) | 0;
  _memmove(i1 + 4 | 0, i1 | 0, i5 << 2 | 0) | 0;
  HEAPF32[i1 >> 2] = f7;
  i1 = HEAP32[gb + 1103792 + 12 >> 2] | 0;
 }
 f8 = Math_fround(f8 / Math_fround(HEAPF32[(HEAP32[gb + 1103792 >> 2] | 0) + (((i1 >>> 0) / 3 | 0) << 2) >> 2]));
 STACKTOP = i9;
 return Math_fround(f8);
}

function __ZN2UI13RectTransform13SetWorldSpaceERK8Vector3fRK8Vector2fb(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 64 | 0;
 i11 = i13;
 i12 = i6 + 100 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) {
  if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
  f5 = Math_fround(HEAPF32[i1 + 120 >> 2]);
  f3 = Math_fround(HEAPF32[i1 + 124 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 128 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 } else {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f18 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 f17 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i6 + 140 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i6 + 144 >> 2])));
 f2 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i6 + 148 >> 2])));
 i14 = i6 + 152 | 0;
 i16 = i6 + 160 | 0;
 f4 = Math_fround(HEAPF32[i16 >> 2]);
 i1 = i6 + 156 | 0;
 i15 = i6 + 164 | 0;
 f3 = Math_fround(HEAPF32[i15 >> 2]);
 f5 = Math_fround(f4 + Math_fround(f5 - f18));
 f2 = Math_fround(f3 + Math_fround(f2 - f17));
 HEAPF32[i16 >> 2] = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f5));
 HEAPF32[i15 >> 2] = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f2));
 __ZN2UI13RectTransform16UpdatePosAndRectEb(i6, 0) | 0;
 __ZNK9Transform11GetPositionEv(i10, i6);
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i10 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i10 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i10 + 8 >> 2]));
 i12 = HEAP32[i12 >> 2] | 0;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i11, (i12 | 0) == 0 ? i6 : i12);
 f4 = Math_fround(f2 * Math_fround(HEAPF32[i11 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i11 + 16 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i11 + 32 >> 2])));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i11 + 4 >> 2]));
 f3 = Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i11 + 20 >> 2])));
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i11 + 36 >> 2])));
 HEAPF32[i14 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i14 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i6, i9, 0);
 STACKTOP = i13;
 return;
}

function __ZN17AudioReverbFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 52 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 56 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 60 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.100000001);
 i5 = f2 > Math_fround(20.0);
 f2 = i5 ? Math_fround(20.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.100000001) : f2;
 i3 = i1 + 64 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.100000001);
 i5 = f2 > Math_fround(2.0);
 f2 = i5 ? Math_fround(2.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.100000001) : f2;
 i3 = i1 + 68 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(1.0e3);
 f2 = i5 ? Math_fround(1.0e3) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 76 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(2.0e3);
 f2 = i5 ? Math_fround(2.0e3) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i3 = i1 + 80 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(.100000001);
 f2 = i5 ? Math_fround(.100000001) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 84 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(100.0);
 f2 = i5 ? Math_fround(100.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(100.0);
 f2 = i5 ? Math_fround(100.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 92 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(20.0);
 i5 = f2 > Math_fround(2.0e4);
 f2 = i5 ? Math_fround(2.0e4) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(20.0) : f2;
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e4);
 i5 = f2 > Math_fround(0.0);
 f2 = i5 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e4) : f2;
 i1 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(20.0);
 i4 = f2 > Math_fround(1.0e4);
 f2 = i4 ? Math_fround(1.0e4) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(20.0) : f2;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 340 | 0;
 i6 = i9 + 288 | 0;
 i8 = i9 + 144 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 0, i10, gb + 166432 | 0, i5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 48 | 0, 3);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 144) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 340 | 0;
 i6 = i9 + 288 | 0;
 i8 = i9 + 144 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 0, i10, gb + 166432 | 0, i5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 48 | 0, 3);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 144) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN3MBP12removeObjectEj(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 1 | 0;
 i13 = i14;
 i11 = i8 >>> 2;
 i7 = HEAP32[i10 + 44 >> 2] | 0;
 i3 = HEAP32[i10 + 28 >> 2] | 0;
 i4 = i7 + (i11 * 12 | 0) + 4 | 0;
 i5 = HEAP16[i4 >> 1] | 0;
 i6 = i5 & 65535;
 if (i5 << 16 >> 16) {
  i1 = i7 + (i11 * 12 | 0) + 8 | 0;
  if (i5 << 16 >> 16 != 1) i1 = (HEAP32[i10 + 96 + (i6 << 4) + 8 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
  i2 = 0;
  do {
   __ZN9BoxPruner12removeObjectEt(HEAP32[i3 + ((HEAPU16[i1 + (i2 << 2) + 2 >> 1] | 0) * 40 | 0) + 28 >> 2] | 0, HEAP16[i1 + (i2 << 2) >> 1] | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  if ((i5 & 65535) > 1) {
   i5 = HEAP32[i7 + (i11 * 12 | 0) + 8 >> 2] | 0;
   i9 = i10 + 4208 + (i6 << 2) | 0;
   HEAP32[(HEAP32[i10 + 96 + (i6 << 4) + 8 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i5;
  }
 }
 HEAP16[i4 >> 1] = 0;
 i9 = i7 + (i11 * 12 | 0) + 6 | 0;
 HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 4;
 i9 = i10 + 12 | 0;
 HEAP32[i7 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i9 >> 2];
 i5 = i10 + 80 | 0;
 i7 = i8 >>> 7;
 i3 = i10 + 84 | 0;
 if (i7 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) i1 = HEAP32[i5 >> 2] | 0; else {
  i4 = i11 + 128 | 0;
  i4 = ((i4 & 31 | 0) != 0 & 1) + (i4 >>> 5) | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i4 << 2, gb + 717183 | 0, 412) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) i2 = 0; else {
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 << 2 | 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  if ((i4 | 0) != (i2 | 0)) _memset(i1 + (i2 << 2) | 0, 0, i4 - i2 << 2 | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i2);
   HEAP32[i5 >> 2] = 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i4;
 }
 i6 = 1 << (i11 & 31);
 i5 = i1 + (i7 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i6;
 HEAP32[i9 >> 2] = i11;
 i5 = i10 + 88 | 0;
 i4 = i10 + 92 | 0;
 if (i7 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  i13 = HEAP32[i5 >> 2] | 0;
  i13 = i13 + (i7 << 2) | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = i12 | i6;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return 1;
 }
 i3 = i11 + 128 | 0;
 i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i3 << 2, gb + 717183 | 0, 412) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  _memcpy(i2 | 0, HEAP32[i5 >> 2] | 0, i1 << 2 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if ((i3 | 0) != (i1 | 0)) _memset(i2 + (i1 << 2) | 0, 0, i3 - i1 << 2 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i1);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = i2;
 HEAP32[i4 >> 2] = i3;
 i13 = i2;
 i13 = i13 + (i7 << 2) | 0;
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = i12 | i6;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return 1;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 32 | 0;
 i5 = i11 + 16 | 0;
 i10 = i11;
 i6 = i7 + 264 | 0;
 i2 = i8 + 16 | 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i1 ? HEAP32[i8 + 20 >> 2] | 0 : i3 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i12 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i3 = __ZNKSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i6, i9, i10) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE25__construct_node_with_keyERS6_(i5, i6, i10);
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i6 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 268 >> 2] | 0, i2);
  i12 = i7 + 276 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 }
 HEAP32[i1 + 32 >> 2] = 1;
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 i12 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i7 + 64 >> 2] = __ZN11UnityEngine15CloudWebService16SessionContainer27GetDeleteErrorJsonDataBlockERK8UnityStrS4_RS2_(i8, i12 + 20 | 0, i12 + 52 | 0, i7 + 112 | 0) | 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i8);
 HEAP32[i7 + 128 >> 2] = 0;
 HEAP8[i7 + 52 >> 0] = 1;
 __ZN11UnityEngine15CloudWebService14DataDispatcher15SetupWebRequestEv(i7);
 __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv(i7);
 STACKTOP = i11;
 return;
}

function __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i6 = i1 + 4 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i4 = i2 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = HEAP32[i4 + 24 >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = i1;
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i5;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i5 >>> 0 <= 1) return;
 i2 = i3 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 1;
 do {
  i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  f11 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 12 >> 2]);
  f9 = Math_fround(f11 * f17);
  f15 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 24 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 24 >> 2]);
  f7 = Math_fround(f15 * f10);
  f16 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 20 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 16 >> 2]);
  f12 = Math_fround(f16 * f8);
  f19 = Math_fround(HEAPF32[i6 + (i3 * 40 | 0) + 12 >> 2]);
  f18 = Math_fround(HEAPF32[i4 + (i1 * 40 | 0) + 20 >> 2]);
  f9 = Math_fround(Math_fround(Math_fround(f9 - Math_fround(f15 * f18)) - Math_fround(f10 * f16)) - Math_fround(f8 * f19));
  f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f17 * f19)) - Math_fround(f16 * f18)) - Math_fround(f11 * f8));
  f12 = Math_fround(Math_fround(Math_fround(f12 - Math_fround(f11 * f18)) - Math_fround(f17 * f15)) - Math_fround(f10 * f19));
  f10 = Math_fround(Math_fround(Math_fround(Math_fround(f19 * f18) - Math_fround(f17 * f16)) - Math_fround(f15 * f8)) - Math_fround(f11 * f10));
  i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i14 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  i13 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
  f10 = (HEAP32[tempDoublePtr >> 2] = i14 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = Math_fround(f10 * f10);
  f9 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(f9 * f9);
  f8 = (HEAP32[tempDoublePtr >> 2] = i3 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f11) + Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8))))));
  f9 = Math_fround(f11 * f9);
  f8 = Math_fround(f11 * f8);
  f7 = Math_fround(f11 * f7);
  HEAPF32[i6 + (i1 * 40 | 0) + 12 >> 2] = Math_fround(f11 * f10);
  HEAPF32[i6 + (i1 * 40 | 0) + 16 >> 2] = f9;
  HEAPF32[i6 + (i1 * 40 | 0) + 20 >> 2] = f8;
  HEAPF32[i6 + (i1 * 40 | 0) + 24 >> 2] = f7;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i16, i1, i15, i3, i14) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 16 | 0;
 i13 = i17;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i16, HEAP32[i15 >> 2] | 0);
 HEAP32[i12 >> 2] = 155;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = i16;
  i2 = HEAP32[i16 >> 2] | 0;
 } else {
  i10 = i13 + 4 | 0;
  i11 = i13 + 8 | 0;
  i7 = i13 + 12 | 0;
  i8 = i16 + 36 | 0;
  i9 = i16 + 20 | 0;
  i6 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i16, i1);
   HEAP32[i11 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 >> 2] = i15;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i10 >> 2] = i6 + 168;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj155ES2_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigEEEKNS_33PxClothStretchConfigGeneratedInfoEEEvPjRKT_RT0_(i16, i12, i13, i14);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i8 >> 0] = 1; else {
    i4 = i1 + -1 | 0;
    i5 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i5 + (i4 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i2 = HEAP32[i16 >> 2] | 0;
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP8[i8 >> 0] = 1;
    if (i1) if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i8 >> 0] = 0;
   }
   i3 = i3 + 8 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i6 = i6 + 16 | 0;
  }
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i17;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i17;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i17;
 return;
}

function __ZN12AudioManager21SetActiveOutputDriverEP9FMOD_GUID(i2, i14) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16 + 20 | 0;
 i5 = i16 + 16 | 0;
 i6 = i16 + 24 | 0;
 i7 = i16;
 do if (i14 | 0) {
  if (!(HEAP32[i14 >> 2] | 0)) {
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   if (i13 >>> 0 < 65536 & (i13 & 65535) << 16 >> 16 == 0) {
    i13 = i14 + 8 | 0;
    if ((HEAP32[i13 >> 2] | 0) == 0 & (HEAP32[i13 + 4 >> 2] | 0) == 0) break;
   }
  }
  i4 = i2 + 88 | 0;
  if (!(__ZN4FMOD6System13getNumDriversEPi(HEAP32[i4 >> 2] | 0, i3) | 0)) {
   HEAP32[i5 >> 2] = -1;
   if (!(__ZN4FMOD6System9getDriverEPi(HEAP32[i4 >> 2] | 0, i5) | 0)) {
    if (!(__ZN4FMOD6System13getDriverInfoEiPciP9FMOD_GUID(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0, i6, 64, i7) | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i14 >> 2] | 0)) if ((HEAP32[i7 + 4 >> 2] | 0) == (HEAP32[i14 + 4 >> 2] | 0)) if ((HEAP32[i7 + 8 >> 2] | 0) == (HEAP32[i14 + 8 >> 2] | 0)) if ((HEAP32[i7 + 12 >> 2] | 0) == (HEAP32[i14 + 12 >> 2] | 0)) i1 = 1; else i15 = 13; else i15 = 13; else i15 = 13; else i15 = 13; else i15 = 13;
    L16 : do if ((i15 | 0) == 13) if ((HEAP32[i3 >> 2] | 0) > 0) {
     i8 = i7 + 4 | 0;
     i9 = i14 + 4 | 0;
     i10 = i7 + 8 | 0;
     i11 = i14 + 8 | 0;
     i12 = i7 + 12 | 0;
     i13 = i14 + 12 | 0;
     i1 = 0;
     L19 : while (1) {
      if (!(__ZN4FMOD6System13getDriverInfoEiPciP9FMOD_GUID(HEAP32[i4 >> 2] | 0, i1, i6, 64, i7) | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i14 >> 2] | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i11 >> 2] | 0)) if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i13 >> 2] | 0)) switch (__ZN4FMOD6System9setDriverEi(HEAP32[i4 >> 2] | 0, i1) | 0) {
      case 60:
       {
        i15 = 21;
        break L19;
       }
      case 0:
       break L19;
      default:
       {}
      }
      i1 = i1 + 1 | 0;
      if ((i1 | 0) >= (HEAP32[i3 >> 2] | 0)) {
       i1 = 0;
       break L16;
      }
     }
     if ((i15 | 0) == 21) {
      __ZN4FMOD6System9setDriverEi(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
      i1 = 0;
      break;
     }
     HEAP8[i2 + 227 >> 0] = 1;
     HEAP8[i2 + 226 >> 0] = 1;
     i1 = i2 + 276 | 0;
     if ((i1 | 0) == (i14 | 0)) i1 = 1; else {
      HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i1 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i1 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      HEAP32[i1 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
      i1 = 1;
     }
    } else i1 = 0; while (0);
   } else i1 = 0;
  } else i1 = 0;
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 } while (0);
 i15 = i2 + 276 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i15 = (__ZN4FMOD6System9setDriverEi(HEAP32[i2 + 88 >> 2] | 0, 0) | 0) == 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471425 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471461 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471471 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471485 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471500 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471508 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471521 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 196 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 197 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 200 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 216 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 36 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 64 >> 0] = i1;
 i1 = i4 + 65 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 68 | 0;
  __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  i8 = i4 + 112 | 0;
  __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 }
}

function __Z21GetAnimatableBindTypeRK16TypeTreeIterator(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37012 >> 2] | 0;
 do if (!i2) i4 = 3; else if (!i1) {
  i1 = 0;
  i4 = 3;
 } else {
  i6 = HEAP32[gb + 36932 >> 2] | 0;
  i5 = HEAP32[gb + 36936 >> 2] | 0;
  if (i5 >>> 0 > i2 >>> 0 & ((i6 >>> 0 > i2 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i5 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) i1 = 5; else break;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) i1 = 5; else break;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 3) if ((i1 | 0) == (i2 | 0)) {
  i6 = 5;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 36972 >> 2] | 0;
 do if (!i2) i4 = 9; else if (!i1) {
  i1 = 0;
  i4 = 9;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) i1 = 6; else break;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) i1 = 6; else break;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 9) if ((i1 | 0) == (i2 | 0)) {
  i6 = 6;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37300 >> 2] | 0;
 do if (!i2) i4 = 15; else if (!i1) {
  i1 = 0;
  i4 = 15;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) if ((i1 | 0) == (i2 | 0)) {
   i4 = 19;
   break;
  } else break; else if (!(_strcmp(i2, i1) | 0)) {
   i4 = 19;
   break;
  } else break;
 } while (0);
 if ((i4 | 0) == 15) if ((i1 | 0) == (i2 | 0)) i4 = 19;
 if ((i4 | 0) == 19) if (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i3) | 0) + 20 >> 2] & 256 | 0) {
  i6 = 6;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37164 >> 2] | 0;
 do if (!i2) i4 = 22; else if (!i1) {
  i1 = 0;
  i4 = 22;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) i1 = 8; else break;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) i1 = 8; else break;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 22) if ((i1 | 0) == (i2 | 0)) {
  i6 = 8;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37184 >> 2] | 0;
 do if (!i2) i4 = 28; else if (!i1) {
  i1 = 0;
  i4 = 28;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) {
   i1 = (i1 | 0) == (i2 | 0);
   break;
  } else {
   i1 = (_strcmp(i2, i1) | 0) == 0;
   break;
  }
 } while (0);
 if ((i4 | 0) == 28) i1 = (i1 | 0) == (i2 | 0);
 i6 = i1 ? 9 : 0;
 return i6 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = i5 << 3;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 3) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 3) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 904255 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN7mecanim8skeleton19SkeletonMaskElement8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 904255 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim8skeleton19SkeletonMaskElement8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN12HingeJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, f16 = f0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 if (!(i1 & 16)) return;
 i6 = i4 + 112 | 0;
 i9 = HEAP16[i6 >> 1] | 0;
 i7 = i9 & 255;
 i8 = i7 << 24 >> 24 != 0;
 i11 = i4 + 113 | 0;
 i9 = (i9 & 65535) >>> 8 & 255;
 i10 = i9 << 24 >> 24 != 0;
 i3 = i4 + 96 | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i4 + 96 | 0;
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f13 < Math_fround(-1.0e6);
 i1 = f13 > Math_fround(1.0e6);
 f13 = i1 ? Math_fround(1.0e6) : f13;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(-1.0e6) : f13;
 i3 = i4 + 100 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i5 = f13 < Math_fround(0.0);
 i1 = f13 > Math_fround(1.0e6);
 f13 = i1 ? Math_fround(1.0e6) : f13;
 HEAPF32[i3 >> 2] = i5 ? Math_fround(0.0) : f13;
 HEAP8[i6 >> 0] = 1;
 i5 = i4 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  __ZN15b2RevoluteJoint11EnableMotorEb(i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __ZN15b2RevoluteJoint13SetMotorSpeedEf(i1, Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.0174532924)));
   __ZN15b2RevoluteJoint17SetMaxMotorTorqueEf(i1, Math_fround(HEAPF32[i3 >> 2]));
   i1 = HEAP32[i5 >> 2] | 0;
  }
 }
 i2 = i4 + 104 | 0;
 i14 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i4 + 104 | 0;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 i2 = f13 < Math_fround(-1.0e6);
 i15 = f13 > Math_fround(1.0e6);
 f13 = i15 ? Math_fround(1.0e6) : f13;
 HEAPF32[i3 >> 2] = i2 ? Math_fround(-1.0e6) : f13;
 i2 = i4 + 108 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = f13 < Math_fround(-1.0e6);
 i14 = f13 > Math_fround(1.0e6);
 f13 = i14 ? Math_fround(1.0e6) : f13;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(-1.0e6) : f13;
 HEAP8[i11 >> 0] = 1;
 if (!i1) i12 = 7; else {
  __ZN15b2RevoluteJoint11EnableLimitEb(i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i12 = 7; else {
   f16 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.0174532924));
   i14 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   f13 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.0174532924));
   i15 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = f16 > f13;
   f13 = (HEAP32[tempDoublePtr >> 2] = i4 ? i15 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   __ZN15b2RevoluteJoint9SetLimitsEff(i1, f13, (HEAP32[tempDoublePtr >> 2] = i4 ? i14 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i1 = HEAP32[i5 >> 2] | 0;
   HEAP8[i6 >> 0] = i7;
   if (i1 | 0) {
    __ZN15b2RevoluteJoint11EnableMotorEb(i1, i8);
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP8[i11 >> 0] = i9;
    if (!i1) return;
    __ZN15b2RevoluteJoint11EnableLimitEb(i1, i10);
    return;
   }
  }
 }
 if ((i12 | 0) == 7) HEAP8[i6 >> 0] = i7;
 HEAP8[i11 >> 0] = i9;
 return;
}

function __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i11, i12, i14, i15, f16, i4) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 f16 = Math_fround(f16);
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i1 = HEAP32[i14 + 324 >> 2] | 0;
 i13 = i1 + (i15 << 3) | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + (i15 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) < 0) i1 = HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 52 >> 2] | 0;
 if ((i1 | 0) > 2500) {
  STACKTOP = i18;
  return;
 }
 i10 = __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(i3, i4, i2) | 0;
 if ((i10 | 0) < 0) {
  STACKTOP = i18;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? i3 : i1;
 if (__ZNK6Shader24GetShadowCasterPassToUseEiRi(i1, i10, i18 + 24 | 0) | 0) {
  i3 = i11 + 12 | 0;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  HEAP32[i17 + 8 >> 2] = 0;
  HEAP32[i17 + 12 >> 2] = 0;
  HEAP32[i17 + 16 >> 2] = 0;
  HEAP32[i17 + 20 >> 2] = 0;
  i4 = i11 + 24 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i11 + 28 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i6 >>> 0 > i9 >>> 0) {
   i2 = i8 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i2;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 * 24 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
    HEAP32[i7 >> 2] = i2;
    HEAP32[i3 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  i11 = (HEAP32[i3 >> 2] | 0) + (i5 * 24 | 0) | 0;
  HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i17 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i17 + 20 >> 2];
  i17 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i14 + 248 >> 2] | 0;
  i8 = i10 << 24 | (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0) >>> 22 | (HEAP16[i14 + 182 >> 1] | 0 ? i7 << 10 & 16776192 : 16776192);
  i9 = i11 + (i17 * 24 | 0) | 0;
  HEAP32[i9 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 168 >> 2] << 23 & -16777216 | i7 & 65535 | HEAPU16[i14 + 180 >> 1] << 16 & 16711680;
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i11 + (i17 * 24 | 0) + 8 >> 2] = i12;
  HEAP32[i11 + (i17 * 24 | 0) + 20 >> 2] = i15;
  HEAP32[i11 + (i17 * 24 | 0) + 16 >> 2] = i1;
  HEAP32[i11 + (i17 * 24 | 0) + 12 >> 2] = i10;
 }
 STACKTOP = i18;
 return;
}

function __ZN13TextRendering4Font8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 i6 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 5);
 i11 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946508 | 0, i11, i1 + 32 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944562 | 0, gb + 946436 | 0, i7, 0);
 i8 = i10 + 8 | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 36 | 0;
 HEAPF32[i6 >> 2] = Math_fround(HEAP32[i8 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034730 | 0, i11, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i8 >> 2] = ~~Math_fround(HEAPF32[i6 >> 2]);
 i8 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944580 | 0, gb + 944590 | 0, i8, 1);
 i6 = i10 + 8 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i9, i8, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN20TextRenderingPrivate8FontImpl8TransferI24GenerateTypeTreeTransferEEvRT_(HEAP32[i1 + 48 >> 2] | 0, i2);
 STACKTOP = i3;
 return;
}

function _h2v2_smooth_downsample(i3, i7, i25, i26) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i8 = HEAP32[i7 + 28 >> 2] | 0;
 i9 = i8 << 3;
 i6 = i25 + -4 | 0;
 i1 = HEAP32[i3 + 220 >> 2] | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = i8 << 4;
 if ((i1 | 0) > -2 & (i8 - i4 | 0) > 0) {
  i5 = i4 + ~i8 | 0;
  i5 = (i8 | 2) - i4 + ((i5 | 0) > -2 ? i5 : -2) | 0;
  i2 = i1 + 1 | 0;
  i1 = 0;
  while (1) {
   i24 = (HEAP32[i6 + (i1 << 2) >> 2] | 0) + i4 | 0;
   _memset(i24 | 0, HEAP8[i24 + -1 >> 0] | 0, i5 | 0) | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 i24 = HEAP32[i3 + 180 >> 2] | 0;
 i23 = (Math_imul(i24, -80) | 0) + 16384 | 0;
 i24 = i24 << 4;
 i21 = i7 + 12 | 0;
 if ((HEAP32[i21 >> 2] | 0) <= 0) return;
 i22 = i9 + -2 | 0;
 i20 = i8 + -2 | 0;
 i15 = i9 + -1 | 0;
 i8 = 0;
 i14 = 0;
 do {
  i16 = HEAP32[i26 + (i8 << 2) >> 2] | 0;
  i5 = HEAP32[i25 + (i14 << 2) >> 2] | 0;
  i18 = HEAP32[i25 + ((i14 | 1) << 2) >> 2] | 0;
  i17 = HEAP32[i25 + (i14 + -1 << 2) >> 2] | 0;
  i14 = i14 + 2 | 0;
  i19 = HEAP32[i25 + (i14 << 2) >> 2] | 0;
  i7 = HEAPU8[i5 >> 0] | 0;
  i6 = HEAPU8[i18 >> 0] | 0;
  i1 = HEAPU8[i17 >> 0] | 0;
  i13 = HEAPU8[i19 >> 0] | 0;
  i12 = i5 + 2 | 0;
  i11 = i18 + 2 | 0;
  i10 = i17 + 2 | 0;
  i9 = i19 + 2 | 0;
  HEAP8[i16 >> 0] = ((Math_imul((HEAPU8[i5 + 1 >> 0] | 0) + i7 + i6 + (HEAPU8[i18 + 1 >> 0] | 0) | 0, i23) | 0) + 32768 + (Math_imul(i13 + i1 + (HEAPU8[i10 >> 0] | 0) + (HEAPU8[i9 >> 0] | 0) + (i6 + i7 + i1 + (HEAPU8[i17 + 1 >> 0] | 0) + i13 + (HEAPU8[i19 + 1 >> 0] | 0) + (HEAPU8[i12 >> 0] | 0) + (HEAPU8[i11 >> 0] | 0) << 1) | 0, i24) | 0) | 0) >>> 16;
  i18 = i18 + i20 | 0;
  i19 = i19 + i20 | 0;
  i13 = i22;
  i1 = i16;
  while (1) {
   i1 = i1 + 1 | 0;
   i2 = HEAPU8[i12 + 1 >> 0] | 0;
   i3 = HEAPU8[i11 + 1 >> 0] | 0;
   i4 = i2 + (HEAPU8[i12 >> 0] | 0) + (HEAPU8[i11 >> 0] | 0) + i3 | 0;
   i5 = HEAPU8[i10 + 1 >> 0] | 0;
   i6 = HEAPU8[i9 + 1 >> 0] | 0;
   i7 = i5 + (HEAPU8[i10 >> 0] | 0) + (HEAPU8[i9 >> 0] | 0) + i6 + (HEAPU8[i12 + -1 >> 0] | 0) | 0;
   if (!i13) break;
   i6 = i12 + 2 | 0;
   i5 = i11 + 2 | 0;
   i3 = i10 + 2 | 0;
   i2 = i9 + 2 | 0;
   HEAP8[i1 >> 0] = ((Math_imul(i4, i23) | 0) + 32768 + (Math_imul((HEAPU8[i3 >> 0] | 0) + (HEAPU8[i10 + -1 >> 0] | 0) + ((HEAPU8[i6 >> 0] | 0) + i7 + (HEAPU8[i11 + -1 >> 0] | 0) + (HEAPU8[i5 >> 0] | 0) << 1) + (HEAPU8[i9 + -1 >> 0] | 0) + (HEAPU8[i2 >> 0] | 0) | 0, i24) | 0) | 0) >>> 16;
   i9 = i2;
   i10 = i3;
   i11 = i5;
   i12 = i6;
   i13 = i13 + -1 | 0;
  }
  HEAP8[i16 + i15 >> 0] = ((Math_imul(i4, i23) | 0) + 32768 + (Math_imul(i6 + i5 + (HEAPU8[i17 + i20 + -1 >> 0] | 0) + (HEAPU8[i19 + -1 >> 0] | 0) + (i3 + i2 + i7 + (HEAPU8[i18 + -1 >> 0] | 0) << 1) | 0, i24) | 0) | 0) >>> 16;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (HEAP32[i21 >> 2] | 0));
 return;
}

function __ZN19OverlapPointQuery2D13ReportFixtureEP9b2Fixture(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 12 | 0;
 i10 = i12;
 if (HEAP8[i6 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 i7 = HEAP32[i6 + 60 >> 2] | 0;
 i11 = i7;
 if ((i7 | 0) == (HEAP32[i5 + 24 >> 2] | 0)) {
  STACKTOP = i12;
  return 1;
 }
 if (!i7) {
  STACKTOP = i12;
  return 1;
 }
 i9 = i7 + 28 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 if (!(1 << HEAP32[i1 + 48 >> 2] & HEAP32[i5 + 12 >> 2])) {
  STACKTOP = i12;
  return 1;
 }
 f13 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 if (!(!(f14 > f15) & !(f14 < f13))) {
  STACKTOP = i12;
  return 1;
 }
 i3 = i5 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 L20 : do if (i4 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i7 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) break L20;
  }
  __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f15 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f15 > Math_fround(HEAPF32[i10 + 8 >> 2]))) {
   STACKTOP = i12;
   return 1;
  }
  HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + (i1 << 2) >> 2] = i11;
  STACKTOP = i12;
  return 1;
 } while (0);
 i10 = HEAP32[i6 + 32 >> 2] | 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0, (HEAP32[i6 + 28 >> 2] | 0) + 12 | 0, i5 + 4 | 0) | 0)) {
  STACKTOP = i12;
  return 1;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i11;
 STACKTOP = i12;
 return 1;
}

function __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 296 | 0;
 i9 = i10;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(1.0);
 i1 = i9 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 52 >> 2] = Math_fround(1.0);
 i1 = i9 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 72 >> 2] = Math_fround(1.0);
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 112 >> 2] = Math_fround(1.0);
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 132 >> 2] = Math_fround(1.0);
 i1 = i9 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 152 >> 2] = Math_fround(1.0);
 i1 = i9 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 172 >> 2] = Math_fround(1.0);
 i1 = i9 + 176 | 0;
 i2 = i9 + 249 | 0;
 i3 = i1;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i9 + 292 | 0;
 i3 = i9 + 252 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i9 + 293 >> 0] = 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i6 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(i9, HEAP32[i1 + 8 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8GUIStyleEEvRT_PKc17TransferMetaFlags(i2, i9, HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 + 24 >> 2] | 0);
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 STACKTOP = i10;
 return;
}

function __Z15AddLoopingFrameIfEvR17AnimationCurveTplIT_Ef(i6, f2) {
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i3 = i6 + 68 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 i7 = i6 + 56 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i5 >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP32[i5 + (i4 + -1 << 4) >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i8;
  return;
 }
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i5;
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i6, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) >= 2) {
  i3 = i1 + -2 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + (i3 << 4) >> 2]);
  f10 = Math_fround(f2 - f9);
  f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i5 + (i3 << 4) + 4 >> 2]);
  f13 = Math_fround(f12 - f11);
  f2 = Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) - f2);
  f12 = Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) - f12);
  i3 = f10 < Math_fround(0.0);
  f14 = Math_fround(-f10);
  i3 = (i3 ? f14 : f10) > Math_fround(9.99999974e-06);
  f10 = Math_fround(f13 / f10);
  i7 = f2 < Math_fround(0.0);
  f13 = Math_fround(-f2);
  i7 = (i7 ? f13 : f2) > Math_fround(9.99999974e-06);
  f2 = Math_fround(f12 / f2);
  f10 = Math_fround(f10 * Math_fround(.5));
  f10 = i3 ? f10 : Math_fround(0.0);
  f2 = Math_fround(f2 * Math_fround(.5));
  f2 = Math_fround(f10 + (i7 ? f2 : Math_fround(0.0)));
  HEAPF32[i5 + 8 >> 2] = f2;
  HEAPF32[i5 + 12 >> 2] = f2;
  i7 = i1 + -1 | 0;
  i3 = (i7 | 0) == 0 ? i1 : 1;
  f2 = Math_fround(HEAPF32[i5 + (i7 << 4) >> 2]);
  f9 = Math_fround(f2 - f9);
  f10 = Math_fround(HEAPF32[i5 + (i7 << 4) + 4 >> 2]);
  f11 = Math_fround(f10 - f11);
  f2 = Math_fround(Math_fround(HEAPF32[i5 + (i3 << 4) >> 2]) - f2);
  f10 = Math_fround(Math_fround(HEAPF32[i5 + (i3 << 4) + 4 >> 2]) - f10);
  i3 = f9 < Math_fround(0.0);
  f12 = Math_fround(-f9);
  i3 = (i3 ? f12 : f9) > Math_fround(9.99999974e-06);
  f9 = Math_fround(f11 / f9);
  i4 = f2 < Math_fround(0.0);
  f11 = Math_fround(-f2);
  i4 = (i4 ? f11 : f2) > Math_fround(9.99999974e-06);
  f2 = Math_fround(f10 / f2);
  f9 = Math_fround(f9 * Math_fround(.5));
  f9 = i3 ? f9 : Math_fround(0.0);
  f2 = Math_fround(f2 * Math_fround(.5));
  f2 = Math_fround(f9 + (i4 ? f2 : Math_fround(0.0)));
  HEAPF32[i5 + (i7 << 4) + 8 >> 2] = f2;
  HEAPF32[i5 + (i7 << 4) + 12 >> 2] = f2;
  HEAPF32[i6 + 4 >> 2] = Math_fround(inf);
  HEAP32[i6 >> 2] = 0;
  HEAPF32[i6 + 32 >> 2] = Math_fround(inf);
  HEAP32[i6 + 28 >> 2] = 0;
 }
 STACKTOP = i8;
 return;
}

function __ZNK13WheelCollider12GetWorldPoseEP8Vector3fP11Quaternionf(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 96 | 0;
 i6 = i9 + 80 | 0;
 i7 = i9;
 i8 = i9 + 64 | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 __ZNK13WheelCollider12GetLocalPoseER8Vector3fR11Quaternionf(i1, i5, i6);
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i7, i3);
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f15 * f19);
 f18 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f18 = Math_fround(f15 + Math_fround(f18 * f17));
 f15 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f20 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f18 + Math_fround(f15 * f20));
 f15 = Math_fround(Math_fround(HEAPF32[i7 + 48 >> 2]) + f15);
 f18 = Math_fround(f19 * Math_fround(HEAPF32[i7 + 4 >> 2]));
 f18 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i7 + 20 >> 2])));
 f18 = Math_fround(f18 + Math_fround(f20 * Math_fround(HEAPF32[i7 + 36 >> 2])));
 f18 = Math_fround(Math_fround(HEAPF32[i7 + 52 >> 2]) + f18);
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i7 + 8 >> 2]));
 f17 = Math_fround(f19 + Math_fround(f17 * Math_fround(HEAPF32[i7 + 24 >> 2])));
 f20 = Math_fround(f17 + Math_fround(f20 * Math_fround(HEAPF32[i7 + 40 >> 2])));
 f20 = Math_fround(Math_fround(HEAPF32[i7 + 56 >> 2]) + f20);
 HEAPF32[i2 >> 2] = f15;
 HEAPF32[i2 + 4 >> 2] = f18;
 HEAPF32[i2 + 8 >> 2] = f20;
 __ZNK9Transform11GetRotationEv(i8, i3);
 f20 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(f20 * f18);
 f17 = Math_fround(HEAPF32[i8 >> 2]);
 f19 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f17 * f19));
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f16 * f10));
 f14 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f18 * f14) + Math_fround(Math_fround(f19 * f16) + Math_fround(f20 * f13))) - Math_fround(f17 * f10));
 f11 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f10) + Math_fround(f19 * f14)) + Math_fround(f17 * f13)) - Math_fround(f18 * f16));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f20 * f19) - Math_fround(f18 * f17)) - Math_fround(f16 * f13)) - Math_fround(f10 * f14));
 HEAPF32[i4 >> 2] = Math_fround(f15 - Math_fround(f14 * f13));
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = f10;
 STACKTOP = i9;
 return;
}

function __ZN13UnityProfiler20InitializeMainThreadEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, gb + 63576 | 0, 16, gb + 585142 | 0, gb + 585142 | 0, gb + 585151 | 0, 67) | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i3 = i2 + 56 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i2 + 60 >> 2] = i3;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 1;
 i3 = i2 + 88 | 0;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(116, gb + 63576 | 0, 16, gb + 585151 | 0, 117) | 0;
 __ZN9profiling14SamplerManagerC2Ev(i3);
 HEAP32[i2 + 76 >> 2] = i3;
 HEAP32[i2 + 28 >> 2] = 2;
 HEAP32[i2 + 24 >> 2] = 2;
 i3 = i2 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1451e3 >> 2] = i2;
 __ZN25StaticProfilerInformation8RegisterEv();
 __ZN22UnityProfilerPerThread10InitializeEPKcS1_(gb + 1576256 | 0, gb + 585225 | 0);
 HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 72 >> 2] = HEAP32[gb + 1163228 >> 2];
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 13892 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 13124 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 13124 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 13124 + (i1 * 12 | 0) >> 2] = fb + 177;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 16980 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 16212 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 16212 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 16212 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 178;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 16212 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 16212 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 16212 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 178;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, f16 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13;
 i1 = i14 + 36 | 0;
 if (HEAP16[i14 + 6 >> 1] & 1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13 + 5 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i14 + 52 >> 2] = HEAP32[i6 + 8 >> 2];
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i9 >> 2] = i8;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i14 + 20 | 0;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i14 + 40 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i14 + 44 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP16[i14 + 48 >> 1] = HEAP16[i6 + 28 >> 1] | 0;
 i7 = i6 + 12 | 0;
 HEAP32[i14 + 96 >> 2] = HEAP32[i7 >> 2];
 HEAPF32[i14 + 24 >> 2] = Math_fround((i8 + -2 | 0) >>> 0);
 HEAPF32[i14 + 28 >> 2] = Math_fround((i11 + -2 | 0) >>> 0);
 HEAPF32[i14 + 32 >> 2] = Math_fround(i11 >>> 0);
 i5 = i11 + 3 | 0;
 HEAP32[i14 + 84 >> 2] = i5 & -4;
 i12 = i8 + 3 | 0;
 HEAP32[i14 + 80 >> 2] = i12 & -4;
 HEAP32[i14 + 88 >> 2] = i5 >>> 2;
 HEAP32[i14 + 92 >> 2] = i12 >>> 2;
 HEAP32[i1 >> 2] = 0;
 i8 = Math_imul(i11, i8) | 0;
 i11 = i14 + 104 | 0;
 HEAPF32[i11 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i12 = i14 + 108 | 0;
 HEAPF32[i12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 if (i8 | 0) {
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13 + 4 | 0, i8 << 2, gb + 724537 | 0, 371) | 0;
  HEAP32[i1 >> 2] = i2;
  if (!i2) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 724537 | 0, 374, gb + 724619 | 0, i3);
   i14 = 0;
   STACKTOP = i13;
   return i14 | 0;
  }
  i4 = i2;
  i5 = 0;
  i1 = -32768;
  i2 = 32767;
  i3 = HEAP32[i6 + 16 >> 2] | 0;
  while (1) {
   i6 = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
   HEAP16[i4 >> 1] = i6;
   HEAP16[i4 + 2 >> 1] = i6 >>> 16;
   i6 = HEAP16[i3 >> 1] | 0;
   i2 = i6 << 16 >> 16 < i2 << 16 >> 16 ? i6 : i2;
   i1 = i6 << 16 >> 16 > i1 << 16 >> 16 ? i6 : i1;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else {
    i4 = i4 + 4 | 0;
    i3 = i3 + (HEAP32[i7 >> 2] | 0) | 0;
   }
  }
  f15 = Math_fround(i1 << 16 >> 16);
  HEAPF32[i11 >> 2] = Math_fround(i2 << 16 >> 16);
  HEAPF32[i12 >> 2] = f15;
 }
 __ZN5physx2Gu11HeightField34parseTrianglesForCollisionVerticesEt(i14, 127);
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i14 + 100 >> 2] = Math_imul(i10, i9) | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 f16 = Math_fround((i9 + -1 | 0) >>> 0);
 f15 = Math_fround((i10 + -1 | 0) >>> 0);
 HEAP32[i14 + 56 >> 2] = 0;
 HEAP32[i14 + 60 >> 2] = i11;
 HEAP32[i14 + 64 >> 2] = 0;
 HEAPF32[i14 + 68 >> 2] = f16;
 HEAP32[i14 + 72 >> 2] = i12;
 HEAPF32[i14 + 76 >> 2] = f15;
 i14 = 1;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN5physx2Cm9transformERKNS0_8Matrix34ERKNS_9PxBounds3E(i3, i5, i4) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 f1 = Math_fround(HEAPF32[i4 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 if (f1 > f2) {
  HEAPF32[i3 >> 2] = f1;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAPF32[i3 + 12 >> 2] = f2;
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  return;
 } else {
  f19 = Math_fround(HEAPF32[i5 >> 2]);
  f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f18 = Math_fround(HEAPF32[i5 + 12 >> 2]);
  f16 = Math_fround(HEAPF32[i5 + 16 >> 2]);
  f6 = Math_fround(HEAPF32[i5 + 20 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f15 = Math_fround(HEAPF32[i5 + 28 >> 2]);
  f8 = Math_fround(HEAPF32[i5 + 32 >> 2]);
  f23 = Math_fround(f1 + f2);
  f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f14 = Math_fround(f7 + f22);
  f20 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f21 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f23 = Math_fround(f23 * Math_fround(.5));
  f14 = Math_fround(f14 * Math_fround(.5));
  f11 = Math_fround(Math_fround(f20 + f21) * Math_fround(.5));
  f10 = Math_fround(Math_fround(Math_fround(f23 * f19) + Math_fround(f14 * f18)) + Math_fround(f11 * f9));
  f12 = Math_fround(Math_fround(Math_fround(f23 * f17) + Math_fround(f14 * f16)) + Math_fround(f11 * f15));
  f11 = Math_fround(Math_fround(Math_fround(f23 * f13) + Math_fround(f14 * f6)) + Math_fround(f11 * f8));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i5 + 36 >> 2]));
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i5 + 40 >> 2]));
  f11 = Math_fround(f11 + Math_fround(HEAPF32[i5 + 44 >> 2]));
  f14 = Math_fround(Math_fround(f2 - f1) * Math_fround(.5));
  f7 = Math_fround(Math_fround(f22 - f7) * Math_fround(.5));
  f2 = Math_fround(Math_fround(f21 - f20) * Math_fround(.5));
  f9 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f14 * f19))) + Math_fround(Math_abs(Math_fround(f18 * f7)))) + Math_fround(Math_abs(Math_fround(f9 * f2))));
  f1 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f14 * f17))) + Math_fround(Math_abs(Math_fround(f16 * f7)))) + Math_fround(Math_abs(Math_fround(f15 * f2))));
  f2 = Math_fround(Math_fround(Math_fround(Math_abs(Math_fround(f14 * f13))) + Math_fround(Math_abs(Math_fround(f6 * f7)))) + Math_fround(Math_abs(Math_fround(f8 * f2))));
  f8 = Math_fround(f12 - f1);
  f7 = Math_fround(f11 - f2);
  f6 = Math_fround(f10 + f9);
  f1 = Math_fround(f12 + f1);
  f2 = Math_fround(f11 + f2);
  HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
  HEAPF32[i3 + 4 >> 2] = f8;
  HEAPF32[i3 + 8 >> 2] = f7;
  HEAPF32[i3 + 12 >> 2] = f6;
  HEAPF32[i3 + 16 >> 2] = f1;
  HEAPF32[i3 + 20 >> 2] = f2;
  return;
 }
}

function __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_(i3, i4, i1, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_(i3, i4, i1, i5) | 0;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i2, i1) | 0)) {
  i8 = i7;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i8 = i1 + 16 | 0;
 i2 = i2 + 16 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i10;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i1, i4) | 0)) {
  i10 = i7 + 1 | 0;
  STACKTOP = i9;
  return i10 | 0;
 };
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i1 = i4 + 16 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i10;
 if (!(__ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i5, i4, i3) | 0)) {
  i10 = i7 + 2 | 0;
  STACKTOP = i9;
  return i10 | 0;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i8 = i3 + 16 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i10;
 i10 = i7 + 3 | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 24 | 0;
 i13 = i14;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 20 | 0) + 1 | 0;
 if (i4 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i5 = ((HEAP32[i8 + 8 >> 2] | 0) - i2 | 0) / 20 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 107374182 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 214748364;
 i5 = (i1 - i2 | 0) / 20 | 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = i8 + 8;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 20 | 0) | 0;
 HEAP32[i13 >> 2] = i6;
 i1 = i6 + (i5 * 20 | 0) | 0;
 i10 = i13 + 8 | 0;
 HEAP32[i10 >> 2] = i1;
 i7 = i13 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i13 + 12 >> 2] = i6 + (i3 * 20 | 0);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + (i5 * 20 | 0) + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + (i5 * 20 | 0) + 12 >> 2] | 0;
  i11 = 8;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i11 = 10;
 } else i11 = 8;
 if ((i11 | 0) == 8) {
  i15 = i4 + 16 & -16;
  HEAP32[i12 >> 2] = 66;
  HEAP32[i12 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + (i5 * 20 | 0) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i6 + (i5 * 20 | 0) + 4 >> 2] = i4;
  i1 = i2;
  i11 = 10;
 }
 if ((i11 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i6 + (i5 * 20 | 0) + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 20;
 __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i13);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i10 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i12);
    i1 = HEAP32[i10 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Gu17intersectPlaneBoxERKNS_7PxPlaneERKNS0_3BoxE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_(i7, i1 + 36 | 0, i1 + 48 | 0, i1, i1 + 12 | 0, i1 + 24 | 0);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f9 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 12 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 28 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 32 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 36 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 40 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 44 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 48 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 52 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 56 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 60 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 64 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 68 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 72 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 76 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 80 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 84 >> 2]) * f3);
 f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 88 >> 2]) * f4));
 if (Math_fround(f2 + Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i7 + 92 >> 2]) * f5))) <= Math_fround(0.0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN29AssetBundleLoadAssetOperationC2ER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb(i3, i1, i4, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 __ZN13LoadOperationC2Ev(i3);
 HEAP32[i3 >> 2] = gb + 27408 + 8;
 HEAP32[i3 + 160 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = i3 + 164 | 0;
 HEAP32[i9 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i9, i1 + 168 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 168 | 0, i4);
 HEAP32[i3 + 180 >> 2] = i2;
 HEAP32[i3 + 188 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = 0;
 HEAP32[i3 + 184 >> 2] = i3 + 188;
 i2 = gb + 63200 | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i3 + 196 >> 2] = 0;
 i1 = i3 + 208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 212 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i9 = i6;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i10 = i3 + 200 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = i2;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 228 >> 2] = 0;
 HEAP32[i3 + 232 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i10 = i6;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i3 + 220 | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i9 = i4 + 11 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 367739 | 0, 27, i2 + 27 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3 + 148 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (i3 | 0) {
  i10 = HEAP32[gb + 1104056 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i6 + 4 >> 0] = 1;
  i10 = i10 + 16 | 0;
  __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12resize_deltaEjj(i10, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E15insert_noresizeERKS5_(i7, i10, i6);
 }
 __ZN29AssetBundleLoadAssetOperation20PreparePreloadAssetsEb(i3, i5);
 if (!(HEAP32[i1 >> 2] | 0)) {
  __ZN13LoadOperation13SetNoWorkToDoEv(i3);
  STACKTOP = i8;
  return;
 } else {
  __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i3);
  STACKTOP = i8;
  return;
 }
}

function __ZN13UnityProfiler18SerializeFrameDataER17ProfilerFrameDataR13dynamic_arrayIiLj4EE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 12 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i2 = i5 + 1 | 0;
 i10 = i8 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 + (i5 << 2) >> 2] = 1;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i6 >>> 0 > i4 >>> 0) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i10 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i6;
 HEAP32[i1 + (i5 << 2) >> 2] = 538314274;
 __ZN17ProfilerFrameData9SerializeER13dynamic_arrayIiLj4EE(i7, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 & 2147483647;
 if (i3 >>> 0 <= i5 >>> 0) {
  HEAP32[i9 >> 2] = i3;
  i10 = HEAP32[i8 >> 2] | 0;
  i10 = i10 + (i2 << 2) | 0;
  HEAP32[i10 >> 2] = -1347440721;
  return;
 }
 i1 = i4 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i5 >>> 0 >= i1 >>> 0) {
  HEAP32[i9 >> 2] = i3;
  i10 = HEAP32[i8 >> 2] | 0;
  i10 = i10 + (i2 << 2) | 0;
  HEAP32[i10 >> 2] = -1347440721;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i3;
  i10 = HEAP32[i8 >> 2] | 0;
  i10 = i10 + (i2 << 2) | 0;
  HEAP32[i10 >> 2] = -1347440721;
  return;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i3;
  i10 = HEAP32[i8 >> 2] | 0;
  i10 = i10 + (i2 << 2) | 0;
  HEAP32[i10 >> 2] = -1347440721;
  return;
 }
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -36 | 0;
  i5 = i1;
  i1 = i1 + -36 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -32 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -24 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -24 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -28 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -32 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -20 | 0;
  i7 = i5 + -20 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP8[i17 + 16 >> 0] = HEAP8[i7 + 16 >> 0] | 0;
  i6 = (HEAP32[i13 >> 2] | 0) + -36 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -36 | 0;
  i5 = i1;
  i1 = i1 + -36 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -32 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -24 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -24 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -28 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -32 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -20 | 0;
  i7 = i5 + -20 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP8[i17 + 16 >> 0] = HEAP8[i7 + 16 >> 0] | 0;
  i6 = (HEAP32[i13 >> 2] | 0) + -36 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i12 = i15 + 8 | 0;
 HEAPF32[i12 + 4 >> 2] = Math_fround(inf);
 HEAP32[i12 >> 2] = 0;
 i8 = i12 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i12 + 32 >> 2] = Math_fround(inf);
 HEAP32[i12 + 28 >> 2] = 0;
 i8 = i12 + 36 | 0;
 HEAP32[i12 + 68 >> 2] = 0;
 i13 = i12 + 72 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i12 + 60 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i8 = i7;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i14;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i12 + 80 >> 2] = 2;
 HEAP32[i12 + 76 >> 2] = 2;
 HEAP32[i12 + 84 >> 2] = 4;
 i6 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i3 + 24 >> 2] | 0;
 i9 = i6 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 do if ((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0) {
  i10 = i6 + 40 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   if (!i11) break;
   if ((HEAP32[i11 + 16 >> 2] | 0) != 3) break;
  }
  i16 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i11, i1) | 0;
  HEAP32[i10 >> 2] = i16;
  i1 = i6 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = gb + 1034188;
  if (!i16) {
   i16 = HEAP8[i9 >> 0] | 0;
   HEAP32[i10 >> 2] = i11;
   HEAP32[i1 >> 2] = i2;
   if (!(i16 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
   __ZN17AnimationCurveTplIfE8TransferI8JSONReadEEvRT_(i12, i6);
   HEAP8[i9 >> 0] = 1;
   i16 = i6 + 56 | 0;
   HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
   HEAP32[i10 >> 2] = i11;
   HEAP32[i1 >> 2] = i2;
  }
  i16 = i3 + 20 | 0;
  i9 = HEAP32[i16 >> 2] | 0;
  i10 = i4 + 4 | 0;
  i11 = i4 + 12 | 0;
  HEAP32[i7 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i11 >> 2] | 0) | 0 : i9) >> 2];
  __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i5, i12, i7);
  i16 = HEAP32[i16 >> 2] | 0;
  HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i16 + -8 + (HEAP32[i11 >> 2] | 0) | 0 : i16) >> 2] = HEAP32[i7 >> 2];
 } while (0);
 i1 = i12 + 56 | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i14);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 564 | 0;
 i6 = i9 + 512 | 0;
 i8 = i9 + 256 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10, 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 1, i10 + 16 | 0, gb + 166432 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 2, i10 + 32 | 0, gb + 166432 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 256) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 564 | 0;
 i6 = i9 + 512 | 0;
 i8 = i9 + 256 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10, 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 1, i10 + 16 | 0, gb + 166432 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 2, i10 + 32 | 0, gb + 166432 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 256) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __Z34AlignedCylinderOverlapsOrientedBoxPfPKfS1_fff(i1, i2, i4, f6, f8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i3 = 0, i5 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i20;
 i17 = i20 + 144 | 0;
 i18 = i20 + 124 | 0;
 i19 = i20 + 104 | 0;
 i3 = i20 + 96 | 0;
 HEAP32[i17 >> 2] = 0;
 i22 = i17 + 12 | 0;
 HEAP32[i22 >> 2] = 0;
 i11 = i17 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i14 = i10;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i5 + 4 >> 2] = i13;
 HEAP32[i18 >> 2] = 0;
 i5 = i18 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i13 = i18 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i16 = i10;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i7 = i14;
 HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i7 + 4 >> 2] = i15;
 HEAP32[i19 >> 2] = 0;
 i7 = i19 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i15 = i19 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i19 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i24 = i10;
 i23 = HEAP32[i24 + 4 >> 2] | 0;
 i21 = i16;
 HEAP32[i21 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i21 + 4 >> 2] = i23;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i12);
 i21 = (HEAP32[i13 >> 2] | 0) > -1;
 HEAP32[i22 >> 2] = 8;
 HEAP32[i11 >> 2] = -2147483640;
 HEAP32[i17 >> 2] = i2;
 if (i21) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i14);
  HEAP32[i18 >> 2] = 0;
 }
 HEAP32[i13 >> 2] = -2147483636;
 HEAP32[i18 >> 2] = i10;
 HEAP32[i5 >> 2] = 0;
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i16);
  HEAP32[i19 >> 2] = 0;
 }
 HEAP32[i15 >> 2] = -2147483635;
 HEAP32[i19 >> 2] = i20 + 168;
 HEAP32[i7 >> 2] = 0;
 i24 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i24;
 __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff(i18, i17, f8, f9);
 __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i19, i18);
 if ((HEAP32[i7 >> 2] | 0) >>> 0 < 3) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  i1 = 0;
 } else i1 = __Z17CircleHullOverlapPfRK13dynamic_arrayI8Vector2fLj4EERKS1_f(i1, i19, i3, f6) | 0;
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i16);
  HEAP32[i19 >> 2] = 0;
 }
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i14);
  HEAP32[i18 >> 2] = 0;
 }
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i20;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i12);
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i20;
 return i1 | 0;
}

function __Z22GetTextureFormatString13TextureFormat(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 421058 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 421046 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 421034 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 421023 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 421011 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 420999 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 420988 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 420977 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 420966 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 420953 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 420933 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 420912 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 420891 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 420874 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 420856 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 420832 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 420810 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 420798 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 420791 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 420783 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 420773 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 420765 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 420756 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 420745 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 420717 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 420688 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 420660 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 420631 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 420605 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 420579 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 420552 | 0;
   break;
  }
 case 45:
  {
   i1 = gb + 420525 | 0;
   break;
  }
 case 46:
  {
   i1 = gb + 420484 | 0;
   break;
  }
 case 47:
  {
   i1 = gb + 420456 | 0;
   break;
  }
 case 41:
  {
   i1 = gb + 420426 | 0;
   break;
  }
 case 42:
  {
   i1 = gb + 420389 | 0;
   break;
  }
 case 43:
  {
   i1 = gb + 420358 | 0;
   break;
  }
 case 44:
  {
   i1 = gb + 420320 | 0;
   break;
  }
 case 60:
  {
   i1 = gb + 420288 | 0;
   break;
  }
 case 61:
  {
   i1 = gb + 420255 | 0;
   break;
  }
 case 48:
  {
   i1 = gb + 420225 | 0;
   break;
  }
 case 54:
  {
   i1 = gb + 420194 | 0;
   break;
  }
 case 49:
  {
   i1 = gb + 420164 | 0;
   break;
  }
 case 55:
  {
   i1 = gb + 420133 | 0;
   break;
  }
 case 50:
  {
   i1 = gb + 420103 | 0;
   break;
  }
 case 56:
  {
   i1 = gb + 420072 | 0;
   break;
  }
 case 51:
  {
   i1 = gb + 420042 | 0;
   break;
  }
 case 57:
  {
   i1 = gb + 420011 | 0;
   break;
  }
 case 52:
  {
   i1 = gb + 419979 | 0;
   break;
  }
 case 58:
  {
   i1 = gb + 419946 | 0;
   break;
  }
 case 53:
  {
   i1 = gb + 419914 | 0;
   break;
  }
 case 59:
  {
   i1 = gb + 419881 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 419863 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 419844 | 0;
   break;
  }
 default:
  i1 = gb + 419832 | 0;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = (i1 | 0) == (i5 | 0);
 HEAP8[i1 + 12 >> 0] = i7 & 1;
 if (i7) return;
 while (1) {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 12 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   i2 = 37;
   break;
  }
  i6 = i7 + 8 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) == (i7 | 0)) {
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!i2) {
    i2 = 8;
    break;
   }
   i2 = i2 + 12 | 0;
   if (HEAP8[i2 >> 0] | 0) {
    i2 = 8;
    break;
   }
   HEAP8[i3 >> 0] = 1;
   HEAP8[i4 + 12 >> 0] = (i4 | 0) == (i5 | 0) & 1;
   HEAP8[i2 >> 0] = 1;
  } else {
   if (!i2) {
    i2 = 24;
    break;
   }
   i2 = i2 + 12 | 0;
   if (HEAP8[i2 >> 0] | 0) {
    i2 = 24;
    break;
   }
   HEAP8[i3 >> 0] = 1;
   HEAP8[i4 + 12 >> 0] = (i4 | 0) == (i5 | 0) & 1;
   HEAP8[i2 >> 0] = 1;
  }
  if ((i4 | 0) == (i5 | 0)) {
   i2 = 37;
   break;
  } else i1 = i4;
 }
 if ((i2 | 0) == 8) {
  if ((HEAP32[i7 >> 2] | 0) == (i1 | 0)) {
   i1 = i7;
   i5 = i4;
  } else {
   i5 = i7 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   if (!i2) i2 = i4; else {
    HEAP32[i2 + 8 >> 2] = i7;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i1 + 8 | 0;
   HEAP32[i3 >> 2] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) HEAP32[i2 >> 2] = i1; else HEAP32[i2 + 4 >> 2] = i1;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i6 >> 2] = i1;
   i5 = HEAP32[i3 >> 2] | 0;
  }
  HEAP8[i1 + 12 >> 0] = 1;
  HEAP8[i5 + 12 >> 0] = 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i5;
  i1 = i5 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  return;
 } else if ((i2 | 0) == 24) {
  if ((HEAP32[i7 >> 2] | 0) == (i1 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   i5 = i1 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   if (!i2) i2 = i4; else {
    HEAP32[i2 + 8 >> 2] = i7;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i1 + 8 | 0;
   HEAP32[i3 >> 2] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) HEAP32[i2 >> 2] = i1; else HEAP32[i2 + 4 >> 2] = i1;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i6 >> 2] = i1;
   i4 = HEAP32[i3 >> 2] | 0;
  } else i1 = i7;
  HEAP8[i1 + 12 >> 0] = 1;
  HEAP8[i4 + 12 >> 0] = 0;
  i7 = i4 + 4 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) HEAP32[i1 + 8 >> 2] = i4;
  i1 = i4 + 8 | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) HEAP32[i2 >> 2] = i3; else HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  return;
 } else if ((i2 | 0) == 37) return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx(i1, i8, i6, i7, i4, i5) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i10 = i14 + 28 | 0;
 i2 = i14 + 24 | 0;
 i13 = i1 + -124 | 0;
 HEAP16[i2 >> 1] = i8;
 i3 = i13 + 280 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i13 + 212 | 0, i2, i9) | 0;
  if (!(HEAP8[i9 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i8;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i12 = HEAP32[i3 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i1 | 0, i4 | 0, i5 | 0);
 }
 if (!(HEAP8[i13 + 276 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i3 = i13 + 72 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i12 = (i11 | 0) == 0;
 if (!i12) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 + 4 >> 2] | 0);
 i2 = i9;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i9 + 8 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i9 + 16 >> 2] = i1;
 HEAP8[i10 >> 0] = 5;
 i2 = i10 + 1 | 0;
 HEAP16[i10 + 2 >> 1] = i8;
 HEAP8[i2 >> 0] = 3;
 if (i7 >>> 0 < 0 | (i7 | 0) == 0 & i6 >>> 0 < 256) i1 = 3; else if (i7 >>> 0 < 0 | (i7 | 0) == 0 & i6 >>> 0 < 65536) i1 = 7; else i1 = i7 >>> 0 < 1 | (i7 | 0) == 1 & i6 >>> 0 < 0 ? 11 : 15;
 HEAP8[i2 >> 0] = i1;
 i1 = i13 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i10, i1);
 __ZN5physx7profile10EventValue9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE(i9, i1, i10);
 i9 = i13 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = i13 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 >= (HEAP32[i13 + 44 >> 2] | 0) >>> 0) {
  i7 = HEAP32[i3 >> 2] | 0;
  i8 = (i7 | 0) == 0;
  if (i8) i3 = i1; else {
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i1 = i2;
  i4 = i3 - i1 | 0;
  i5 = HEAP32[i13 + 36 >> 2] | 0;
  if (i5) {
   i1 = i13 + 32 | 0;
   i3 = 0;
   do {
    i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i2 | 0, i4 | 0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i5 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0);
  if (!i8) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 }
 if (!i12) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i11 + 4 >> 2] | 0);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6 - i3 | 0;
 i5 = i1 >> 6;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4;
 i9 = i6;
 if (i5 >>> 0 > (HEAP32[i7 >> 2] | 0) - i4 >> 6 >>> 0) {
  __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i8);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i6 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
  i1 = i6 >> 5;
  i1 = i6 >> 6 >>> 0 < 1073741823 ? (i1 >>> 0 < i5 >>> 0 ? i5 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i8 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 << 6);
  if ((i3 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i1 = i3;
  do {
   __ZN14AnimationEventC2ERKS_(i2, i1);
   i1 = i1 + 64 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 64 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) - i4 >> 6;
 i4 = i5 >>> 0 > i1 >>> 0;
 i1 = i4 ? i3 + (i1 << 6) | 0 : i6;
 if ((i3 | 0) != (i1 | 0)) do {
  __ZN14AnimationEventaSERKS_(i2, i3) | 0;
  i3 = i3 + 64 | 0;
  i2 = i2 + 64 | 0;
 } while ((i3 | 0) != (i1 | 0));
 if (i4) {
  if ((i1 | 0) == (i9 | 0)) {
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN14AnimationEventC2ERKS_(i2, i1);
   i1 = i1 + 64 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 64 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = i10 + 4 | 0;
 i5 = i10 + 4 | 0;
 do {
  HEAP32[i7 >> 2] = i1 + -64;
  i3 = i1 + -44 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i3 >> 2] | 0;
   i8 = HEAP32[i1 + -32 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i3 = i1 + -60 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i9 = HEAP32[i3 >> 2] | 0;
   i8 = HEAP32[i1 + -48 >> 2] | 0;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i5 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN19AssetBundleManifest33CollectAllDependenciesRecursivelyEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(i13, i6, i14) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 4 | 0;
 i8 = i16;
 HEAP32[i8 >> 2] = i6;
 i2 = HEAP32[i13 + 36 >> 2] | 0;
 i7 = HEAP32[i13 + 40 >> 2] | 0;
 i1 = i7 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 40 | 0;
  i1 = i2;
  while (1) {
   i12 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i12 * 40 | 0) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 40 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i12 | 0 : i12;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i16;
  return;
 }
 if ((i1 | 0) == (i7 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) > (i6 | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_(i13 + 32 | 0, i15, i8);
 i8 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 i8 = i8 + 20 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i16;
  return;
 }
 i9 = i14 + 4 | 0;
 i10 = i9;
 i11 = i14 + 4 | 0;
 i12 = i14 + 8 | 0;
 do {
  i3 = HEAP32[i9 >> 2] | 0;
  do if (!i3) {
   HEAP32[i15 >> 2] = i9;
   i6 = i10;
   i4 = i9;
  } else {
   i5 = HEAP32[i1 >> 2] | 0;
   while (1) {
    i4 = HEAP32[i3 + 16 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) {
      i5 = 12;
      break;
     } else i3 = i4;
    } else {
     if ((i4 | 0) >= (i5 | 0)) {
      i5 = 17;
      break;
     }
     i7 = i3 + 4 | 0;
     i4 = HEAP32[i7 >> 2] | 0;
     if (!i4) {
      i5 = 16;
      break;
     } else i3 = i4;
    }
   }
   if ((i5 | 0) == 12) {
    HEAP32[i15 >> 2] = i3;
    i6 = i3;
    i4 = i3;
    break;
   } else if ((i5 | 0) == 16) {
    HEAP32[i15 >> 2] = i3;
    i6 = i3;
    i4 = i7;
    break;
   } else if ((i5 | 0) == 17) {
    HEAP32[i15 >> 2] = i3;
    i6 = i3;
    i4 = i15;
    break;
   }
  } while (0);
  if (!(HEAP32[i4 >> 2] | 0)) {
   i2 = __Znwj(20) | 0;
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i6;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i14 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i2);
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   __ZN19AssetBundleManifest33CollectAllDependenciesRecursivelyEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(i13, HEAP32[i1 >> 2] | 0, i14);
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i16;
 return;
}

function __ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_(i1, i2, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i19 = i19 | 0;
 var f3 = f0, d4 = 0.0, d5 = 0.0, f6 = f0, d7 = 0.0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i18 = HEAP32[i1 >> 2] | 0;
 i15 = (HEAP32[i1 + 4 >> 2] | 0) - i18 | 0;
 i17 = i15 >> 5;
 if ((i15 | 0) <= 0) {
  i20 = 2;
  i20 = (i20 | 0) != 2;
  i20 = i20 & 1;
  return i20 | 0;
 }
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 i12 = i2 + 4 | 0;
 i13 = i19 + 4 | 0;
 f14 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 i11 = 0;
 L4 : while (1) {
  f9 = Math_fround(HEAPF32[i18 + (i11 << 5) >> 2]);
  i2 = HEAP32[i18 + (i11 << 5) + 4 >> 2] | 0;
  i11 = i11 + 1 | 0;
  i15 = (i11 | 0) < (i17 | 0);
  if (i15) i1 = i11; else i1 = (i11 | 0) % (i17 | 0) | 0;
  f10 = Math_fround(HEAPF32[i18 + (i1 << 5) >> 2]);
  i1 = HEAP32[i18 + (i1 << 5) + 4 >> 2] | 0;
  if (f9 == f16) {
   f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f8 == Math_fround(HEAPF32[i12 >> 2])) i1 = 4; else i20 = 7;
  } else i20 = 7;
  do if ((i20 | 0) == 7) {
   i20 = 0;
   f6 = Math_fround(HEAPF32[i19 >> 2]);
   if (f10 == f6) {
    f8 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (f8 == Math_fround(HEAPF32[i13 >> 2])) {
     i1 = 4;
     break;
    }
   }
   if (f6 == f9) {
    f8 = Math_fround(HEAPF32[i13 >> 2]);
    if (f8 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
     i1 = 4;
     break;
    }
   }
   f8 = Math_fround(HEAPF32[i12 >> 2]);
   f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f16 == f10 & f8 == f3) i1 = 4; else {
    f24 = Math_fround(HEAPF32[i13 >> 2]);
    f23 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f22 = Math_fround(f10 - f9);
    f10 = Math_fround(f3 - f23);
    f21 = Math_fround(f6 - f16);
    f6 = Math_fround(f24 - f8);
    f9 = Math_fround(f16 - f9);
    f8 = Math_fround(f8 - f23);
    f3 = Math_fround(Math_fround(f10 * f21) - Math_fround(f22 * f6));
    d4 = +f3;
    f10 = Math_fround(Math_fround(f22 * f8) - Math_fround(f10 * f9));
    d5 = +f10;
    f6 = Math_fround(Math_fround(f8 * f21) - Math_fround(f9 * f6));
    d7 = +f6;
    if (Math_fround(Math_abs(Math_fround(f10))) < f14) if (Math_fround(Math_abs(Math_fround(f6))) < f14) if (Math_fround(Math_abs(Math_fround(f3))) < f14) {
     i1 = 0;
     break;
    }
    if (Math_fround(Math_abs(Math_fround(f3))) < f14) i1 = 0; else {
     d5 = d5 / d4;
     d7 = d7 / d4;
     i1 = (d7 > 1.0 | (d7 < 0.0 | (d5 < 0.0 | d5 > 1.0))) & 1 ^ 1;
    }
   }
  } while (0);
  switch (i1 & 7) {
  case 4:
  case 0:
   break;
  default:
   {
    i20 = 19;
    break L4;
   }
  }
  if (!i15) {
   i1 = 2;
   i20 = 19;
   break;
  }
 }
 if ((i20 | 0) == 19) {
  i20 = (i1 | 0) != 2;
  i20 = i20 & 1;
  return i20 | 0;
 }
 return 0;
}

function __ZN13MemoryManagerC2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i5 = i9;
 i7 = i9 + 12 | 0;
 i1 = 0;
 do {
  HEAP32[i6 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 i4 = i6 + 768 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i6 + 772 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i6 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i6 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 i3 = i6 + 1540 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 1544 >> 2] = 0;
 HEAP32[i6 + 1564 >> 2] = 0;
 i1 = i6 + 1549 | 0;
 i2 = i1 + 11 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 _memset(i6 + 3824 | 0, 0, 3072) | 0;
 _memset(i6 + 1568 | 0, 0, 192) | 0;
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i2 = i1 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i2;
 if (i2 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN20DynamicHeapAllocatorI17LowLevelAllocatorEC2EjjbP15BucketAllocatorPKc(i1, 1048576, 0, 1, 0, gb + 582385 | 0);
 i2 = i6 + 1560 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 + 3812 >> 2] = 0;
 i1 = 0;
 do {
  i10 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 1764 + (i10 << 2) >> 2] = i1;
 } while ((i1 | 0) != 512);
 i1 = 0;
 do {
  HEAP32[i6 + 3824 + (i1 * 24 | 0) >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 128);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i7, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i6 + (i1 * 12 | 0) >> 2] = fb + 141;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 <= 63) {
  i10 = i1;
  i8 = i10 + 1 | 0;
  HEAP32[i3 >> 2] = i8;
  i8 = i6 + 772 + (i10 * 12 | 0) + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  i8 = i6 + 772 + (i10 * 12 | 0) + 8 | 0;
  HEAP8[i8 >> 0] = 0;
  i10 = i6 + 772 + (i10 * 12 | 0) | 0;
  HEAP32[i10 >> 2] = fb + 691;
  STACKTOP = i9;
  return;
 }
 __Z6FormatPKcz(i7, gb + 1048800 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i10 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 1 | 0;
 HEAP32[i3 >> 2] = i8;
 i8 = i6 + 772 + (i10 * 12 | 0) + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i8 = i6 + 772 + (i10 * 12 | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i10 = i6 + 772 + (i10 * 12 | 0) | 0;
 HEAP32[i10 >> 2] = fb + 691;
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine7Connect18ConnectSessionInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 32 | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 i3 = i1 + 60 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 76 | 0;
 i2 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 112 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 128 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 160 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 176 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZL14SweepBoxSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i10, i3, i2, i1, i7, i8) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, i24 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i11 + 72 | 0;
 i15 = i11 + 40 | 0;
 i14 = i11 + 32 | 0;
 i13 = i11;
 i9 = i11 + 88 | 0;
 i12 = i11 + 136 | 0;
 HEAP32[i16 >> 2] = 3;
 i24 = i3 + 40 | 0;
 d23 = +HEAPF64[i1 >> 3];
 d21 = +HEAPF64[i1 + 8 >> 3];
 d19 = +HEAPF64[i1 + 16 >> 3];
 i4 = i2 + 16 | 0;
 d22 = +HEAPF64[i4 >> 3];
 i5 = i2 + 24 | 0;
 d20 = +HEAPF64[i5 >> 3];
 i6 = i2 + 32 | 0;
 d18 = +HEAPF64[i6 >> 3];
 HEAP32[i16 + 4 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i24 + 4 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAPF32[i15 + 16 >> 2] = Math_fround(d23 - d22);
 HEAPF32[i15 + 20 >> 2] = Math_fround(d21 - d20);
 HEAPF32[i15 + 24 >> 2] = Math_fround(d19 - d18);
 HEAP32[i15 >> 2] = HEAP32[i10 + 228 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i10 + 232 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i10 + 236 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i10 + 240 >> 2];
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 1065353216;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = -1;
 HEAP16[i9 + 12 >> 1] = 0;
 i1 = i9 + 16 | 0;
 i2 = i9 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i3 = i8 + 36 | 0;
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 HEAP16[i12 >> 1] = (HEAP8[i10 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i7, f17, i16, i15, i14, i13, i9, i12, Math_fround(0.0)) | 0)) {
  i24 = 0;
  STACKTOP = i11;
  return i24 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i9 + 32 >> 2];
 HEAP32[i8 + 32 >> 2] = HEAP32[i9 + 36 >> 2];
 HEAP32[i8 + 40 >> 2] = -1;
 HEAP32[i8 + 44 >> 2] = -1;
 d23 = +Math_fround(HEAPF32[i1 >> 2]);
 HEAPF64[i8 >> 3] = d23 + +HEAPF64[i4 >> 3];
 d23 = +Math_fround(HEAPF32[i9 + 20 >> 2]);
 HEAPF64[i8 + 8 >> 3] = d23 + +HEAPF64[i5 >> 3];
 d23 = +Math_fround(HEAPF32[i9 + 24 >> 2]);
 HEAPF64[i8 + 16 >> 3] = d23 + +HEAPF64[i6 >> 3];
 i24 = 1;
 STACKTOP = i11;
 return i24 | 0;
}

function __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = i5 - i3 >> 4;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= i1 - i6 >> 4 >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i6 >> 4;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 << 4) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN14ConstantStringaSERKS_(i2, i3);
   i9 = i2 + 4 | 0;
   i8 = i3 + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i3 = i3 + 16 | 0;
   i2 = i2 + 16 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -16 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN14ConstantStringD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i2, i1);
   i9 = i2 + 4 | 0;
   i8 = i1 + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i1 = i1 + 16 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -16 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN14ConstantStringD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = i1 - i2 | 0;
 i1 = i6 >> 3;
 i1 = i6 >> 4 >>> 0 < 134217727 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 268435455;
 if (i1 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 << 4) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 4);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  HEAP32[i2 >> 2] = 0;
  __ZN14ConstantString6assignERKS_(i2, i1);
  i9 = i2 + 4 | 0;
  i8 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i1 = i1 + 16 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN8Animator14GetMuscleValueEiPf(i9, i4, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i6 = i11;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 i7 = i9 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i4 = __ZN7mecanim9animation15FindMuscleIndexEj(i4) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 15; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i12 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 15; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 17;
  }
 }
 if ((i8 | 0) == 15) i8 = 17;
 if ((i8 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 if ((i4 | 0) > 13 & ((__ZNK6Avatar7IsHumanEv(i1) | 0) ^ 1)) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i1 = (i4 | 0) != -1;
 if ((HEAP32[i9 + 240 >> 2] | 0) == 0 | i1 ^ 1) {
  i12 = i1;
  STACKTOP = i11;
  return i12 | 0;
 }
 i12 = HEAP32[i9 + 204 >> 2] | 0;
 HEAPF32[i10 >> 2] = Math_fround(__ZN7mecanim9animation19GetMuscleCurveValueERKNS_5human9HumanPoseERKN4math4trsXEi(HEAP32[i12 + 24 >> 2] | 0, (HEAP32[i12 + 16 >> 2] | 0) + 68 | 0, i4));
 i12 = i1;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN5physx2Sc8ShapeSim16onGeometryChangeEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i7 = HEAP32[i11 + 12 + 4 >> 2] | 0;
 i8 = i7 & 1073741823;
 i9 = i11 + 8 | 0;
 if ((i8 | 0) != 1073741823) {
  i1 = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0;
  i4 = i1 + 5912 | 0;
  i5 = (i8 + 32 | 0) >>> 5;
  i6 = i1 + 5916 | 0;
  if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
   i2 = i1 + 5920 | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 2, gb + 769739 | 0, 329) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    _memcpy(i1 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
   }
   i3 = HEAP32[i6 >> 2] | 0;
   _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
  } else i1 = HEAP32[i4 >> 2] | 0;
  i6 = i1 + (i8 >>> 5 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i7 & 31);
  __ZN5physx14PxsAABBManager13setActorDirtyEj(HEAP32[(HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i8);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i8 + (HEAP32[i1 + 28 >> 2] << 2) | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i10 + 8 >> 2] = i11;
 i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i10) | 0;
 L12 : do if (i1 | 0) while (1) {
  switch (HEAPU8[i1 + 20 >> 0] | 0 | 0) {
  case 4:
   {
    i8 = i1 + -8 | 0;
    i7 = i8 + 32 | 0;
    __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i7 >> 2] | 0) | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 + 36 >> 2] | 0);
    break;
   }
  case 0:
   {
    i1 = HEAP32[i1 + -8 + 56 >> 2] | 0;
    if (i1 | 0) __ZN5physx17PxsContactManager16resetCachedStateEv(i1);
    break;
   }
  default:
   {}
  }
  i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i10) | 0;
  if (!i1) break L12;
 } while (0);
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i3 + 36 >> 2] | 0) + 1e3 >> 2] | 0;
 i1 = (HEAP32[i11 + 28 >> 2] | 0) + 32 | 0;
 i2 = HEAP8[i3 + 50 >> 0] | 0;
 switch (i2 << 24 >> 24) {
 case 1:
 case 4:
  {
   i10 = (HEAP32[i3 + 52 >> 2] | 0) + 16 | 0;
   i9 = i2 << 24 >> 24 == 1;
   i11 = i2 << 24 >> 24 == 4;
   i11 = i9 | i11;
   __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb(i4, i1, i10, i11);
   STACKTOP = i12;
   return;
  }
 default:
  {
   i10 = (HEAP32[i3 + 52 >> 2] | 0) + 16 | 0;
   i9 = i2 << 24 >> 24 == 1;
   i11 = i2 << 24 >> 24 == 4;
   i11 = i9 | i11;
   __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb(i4, i1, i10, i11);
   STACKTOP = i12;
   return;
  }
 }
}

function __Z31CreateScriptableObjectUncheckediP10MonoScriptPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i3 = i10 + 8 | 0;
 i5 = i10;
 i11 = gb + 63520 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i11;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i9 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i9, 0, i7, 0) | 0;
 if (!i9) {
  if (!i2) {
   i12 = 0;
   STACKTOP = i10;
   return i12 | 0;
  }
  HEAP32[i3 >> 2] = __ZN6Object15ClassIDToStringEi(i1) | 0;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z6FormatPKcz(i7, gb + 445235 | 0, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i12 = 0;
  STACKTOP = i10;
  return i12 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0);
 do if ((((HEAP32[i9 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  if (!i4) __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i9, 0, 0); else {
   HEAP32[i7 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i9, i7, 0);
  }
  if (!i6) {
   i12 = 0;
   STACKTOP = i10;
   return i12 | 0;
  }
  HEAP32[i5 >> 2] = i6;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 14; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i5);
    i2 = HEAP32[i7 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 14; else if (HEAP32[i1 + 4 >> 2] | 0) {
    i1 = i9;
    break;
   }
  }
  if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
   i12 = 0;
   STACKTOP = i10;
   return i12 | 0;
  } else i1 = i9;
 } else i1 = 0; while (0);
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0);
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, 4);
 i12 = i1;
 STACKTOP = i10;
 return i12 | 0;
}

function __Z24DecodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = i7 + 11 | 0;
 i9 = HEAP8[i3 >> 0] | 0;
 i9 = i9 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i9 & 255;
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, 92, 0) | 0;
 if ((i1 | 0) == -1) i2 = 0; else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i8, i9);
  i2 = 0;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i8, i7, i2, i1 - i2 | 0) | 0;
   i2 = i1 + 1 | 0;
   L5 : do if (i2 >>> 0 < i9 >>> 0) switch (HEAP8[((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) + i2 >> 0] | 0) {
   case 92:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, gb + 585717 | 0) | 0;
     i2 = i1 + 2 | 0;
     break L5;
    }
   case 110:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, gb + 1074320 | 0) | 0;
     i2 = i1 + 2 | 0;
     break L5;
    }
   case 114:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, gb + 1074322 | 0) | 0;
     i2 = i1 + 2 | 0;
     break L5;
    }
   case 0:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, gb + 585717 | 0) | 0;
     break L5;
    }
   default:
    break L5;
   } else if ((i2 | 0) == (i9 | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i8, gb + 585717 | 0) | 0;
    i2 = i9;
   } while (0);
   i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, 92, i2) | 0;
  } while ((i1 | 0) != -1);
 }
 i3 = i8 + 11 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i9 >>> 0 > i2 >>> 0 ? ((i4 << 24 >> 24 < 0 ? i1 : i4 & 255) | 0) != 0 : 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i8, i7, i2, i9 - i2 | 0) | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i2 = i4;
 i5 = i2 << 24 >> 24 < 0 ? i1 : i2 & 255;
 if ((i5 | 0) == 0 | (i5 | 0) == (i9 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return;
 };
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERs(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i2 = i12 + 20 | 0;
 i4 = i12 + 16 | 0;
 i5 = i12 + 12 | 0;
 i1 = i12 + 28 | 0;
 i9 = i12 + 8 | 0;
 i6 = i12 + 4 | 0;
 i7 = i12;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i11 | 0, 0);
 i13 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i13 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 17;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i7 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474604 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  do if (i13 & 1) i10 = 8; else {
   i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i13 + 24 >> 2];
   HEAP32[i5 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   invoke_iiiiiii(i14 | 0, i1 | 0, i2 | 0, i3 | 0, i13 | 0, i9 | 0, i6 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) i10 = 8; else {
    __ZNSt3__26localeD2Ev(i7);
    i1 = HEAP32[i6 >> 2] | 0;
    do if ((i1 | 0) < -32768) {
     i1 = HEAP32[i9 >> 2] | 4;
     HEAP32[i9 >> 2] = i1;
     HEAP16[i8 >> 1] = -32768;
    } else if ((i1 | 0) > 32767) {
     i1 = HEAP32[i9 >> 2] | 4;
     HEAP32[i9 >> 2] = i1;
     HEAP16[i8 >> 1] = 32767;
     break;
    } else {
     HEAP16[i8 >> 1] = i1;
     i1 = HEAP32[i9 >> 2] | 0;
     break;
    } while (0);
    i14 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | i1 | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i10 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i7);
  }
  i2 = i11;
  i3 = i11;
  i10 = 17;
  break L1;
 } while (0); while (0);
 do if ((i10 | 0) == 17) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERs(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i2 = i12 + 20 | 0;
 i4 = i12 + 16 | 0;
 i5 = i12 + 12 | 0;
 i1 = i12 + 28 | 0;
 i9 = i12 + 8 | 0;
 i6 = i12 + 4 | 0;
 i7 = i12;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i11 | 0, 0);
 i13 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i13 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 17;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i7 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i7 | 0, gb + 1474580 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  do if (i13 & 1) i10 = 8; else {
   i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i13 + 24 >> 2];
   HEAP32[i5 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   invoke_iiiiiii(i14 | 0, i1 | 0, i2 | 0, i3 | 0, i13 | 0, i9 | 0, i6 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) i10 = 8; else {
    __ZNSt3__26localeD2Ev(i7);
    i1 = HEAP32[i6 >> 2] | 0;
    do if ((i1 | 0) < -32768) {
     i1 = HEAP32[i9 >> 2] | 4;
     HEAP32[i9 >> 2] = i1;
     HEAP16[i8 >> 1] = -32768;
    } else if ((i1 | 0) > 32767) {
     i1 = HEAP32[i9 >> 2] | 4;
     HEAP32[i9 >> 2] = i1;
     HEAP16[i8 >> 1] = 32767;
     break;
    } else {
     HEAP16[i8 >> 1] = i1;
     i1 = HEAP32[i9 >> 2] | 0;
     break;
    } while (0);
    i14 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | i1 | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i10 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i7);
  }
  i2 = i11;
  i3 = i11;
  i10 = 17;
  break L1;
 } while (0); while (0);
 do if ((i10 | 0) == 17) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_Scale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i3, i2, i4, i5, i6, i1, i7) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, i26 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 24 | 0;
 i9 = i1 + 12 | 0;
 i8 = i1;
 i26 = HEAP32[i3 + 3372 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i4 >> 2]);
 f20 = Math_fround(HEAPF32[i26 >> 2]);
 f21 = Math_fround(f22 * f20);
 f19 = Math_fround(HEAPF32[i26 + 4 >> 2]);
 f13 = Math_fround(f22 * f19);
 f18 = Math_fround(HEAPF32[i26 + 8 >> 2]);
 f22 = Math_fround(f22 * f18);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i26 + 12 >> 2]);
 f14 = Math_fround(f24 * f15);
 f17 = Math_fround(HEAPF32[i26 + 16 >> 2]);
 f25 = Math_fround(f24 * f17);
 f16 = Math_fround(HEAPF32[i26 + 20 >> 2]);
 f14 = Math_fround(f21 + f14);
 f25 = Math_fround(f13 + f25);
 f24 = Math_fround(f22 + Math_fround(f24 * f16));
 f22 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i26 + 24 >> 2]);
 f21 = Math_fround(f22 * f13);
 f12 = Math_fround(HEAPF32[i26 + 28 >> 2]);
 f23 = Math_fround(f22 * f12);
 f11 = Math_fround(HEAPF32[i26 + 32 >> 2]);
 f23 = Math_fround(f25 + f23);
 f22 = Math_fround(f24 + Math_fround(f22 * f11));
 HEAPF32[i10 >> 2] = Math_fround(f14 + f21);
 HEAPF32[i10 + 4 >> 2] = f23;
 HEAPF32[i10 + 8 >> 2] = f22;
 f22 = Math_fround(HEAPF32[i5 >> 2]);
 f23 = Math_fround(f22 * f20);
 f21 = Math_fround(f22 * f19);
 f22 = Math_fround(f22 * f18);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f14 * f15));
 f21 = Math_fround(f21 + Math_fround(f14 * f17));
 f14 = Math_fround(f22 + Math_fround(f14 * f16));
 f22 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f22 * f12));
 f14 = Math_fround(f14 + Math_fround(f22 * f11));
 HEAPF32[i9 >> 2] = Math_fround(f23 + Math_fround(f22 * f13));
 HEAPF32[i9 + 4 >> 2] = f21;
 HEAPF32[i9 + 8 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f20 = Math_fround(f14 * f20);
 f19 = Math_fround(f14 * f19);
 f18 = Math_fround(f14 * f18);
 f14 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f15 = Math_fround(f20 + Math_fround(f14 * f15));
 f17 = Math_fround(f19 + Math_fround(f14 * f17));
 f16 = Math_fround(f18 + Math_fround(f14 * f16));
 f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f12 = Math_fround(f17 + Math_fround(f14 * f12));
 f11 = Math_fround(f16 + Math_fround(f14 * f11));
 HEAPF32[i8 >> 2] = Math_fround(f15 + Math_fround(f14 * f13));
 HEAPF32[i8 + 4 >> 2] = f12;
 HEAPF32[i8 + 8 >> 2] = f11;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj(i3 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, i10, i9, i8, i7);
 STACKTOP = i1;
 return 1;
}

function __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjijPjP8Vector2fRNS_6memory9AllocatorE(i1, i2, i9, i7, i4, i6, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i3 = 0, i5 = 0, i8 = 0, i11 = 0;
 i11 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, 48, 4) | 0;
 HEAP32[i11 >> 2] = 0;
 i5 = i11 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i11 + 32 >> 2] = -1;
 HEAPF32[i11 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 40 >> 2] = Math_fround(0.0);
 HEAP8[i11 + 44 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = i2;
 HEAP32[i11 + 12 >> 2] = i7;
 i5 = (i7 | 0) != 0;
 if (i5) {
  i1 = i11 + 16 | 0;
  i2 = i7 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i7 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i8 = i1;
  i3 = i3 | 0 ? i3 - i8 | 0 : 0;
  HEAP32[i1 >> 2] = i3;
  _memcpy(i3 + i8 | 0, i4 | 0, i2 | 0) | 0;
 }
 HEAP32[i11 >> 2] = i9;
 i1 = i11 + 24 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, 40, 4) | 0;
 i3 = i2;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i8 = i1;
 i4 = i2 | 0 ? i2 - i8 | 0 : 0;
 HEAP32[i1 >> 2] = i4;
 i8 = i4 + i8 | 0;
 HEAP32[i8 >> 2] = i7;
 if (i5) {
  i2 = i8 + 4 | 0;
  i5 = i7 << 3;
  i3 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i5 | 0, 4) | 0;
  i4 = i2;
  i3 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i2 >> 2] = i3;
  _memcpy(i3 + i4 | 0, i6 | 0, i5 | 0) | 0;
 }
 if ((i9 | 1 | 0) != 3) return i11 | 0;
 if ((i9 | 0) == 2) {
  HEAP32[i8 + 8 >> 2] = i7;
  i3 = i8 + 12 | 0;
  if (!i7) i1 = 0; else {
   i2 = i7 << 2;
   i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i2 | 0, 4) | 0;
   if ((i1 | 0) != (i1 + (i7 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
  }
  HEAP32[i3 >> 2] = i1 | 0 ? i1 - i3 | 0 : 0;
 }
 i3 = Math_imul(i7, i7) | 0;
 HEAP32[i8 + 24 >> 2] = i3;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i8 + 32 | 0;
 HEAP32[i6 >> 2] = i7;
 i4 = i8 + 28 | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i2 = i8 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i1 << 3 | 0, 4) | 0;
 HEAP32[i2 >> 2] = i1 | 0 ? i1 - i2 | 0 : 0;
 i4 = i8 + 36 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 3;
  i1 = mftCall_iiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 3) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 __ZN7mecanim9animation18PrecomputeFreeformEiRNS0_19Blend2dDataConstantERNS_6memory9AllocatorE(i9, i8, i10);
 return i11 | 0;
}

function __ZN24CompressedAnimationCurve18DecompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E(i7, i14) {
 i7 = i7 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i19;
 i15 = i19 + 8 | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 HEAP32[i15 + 12 >> 2] = i16;
 i17 = i15 + 16 | 0;
 HEAP32[i17 >> 2] = i16;
 i18 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 64016 | 0);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i18;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16 << 2, 4, i18, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i15 >> 2] = i8;
 i9 = HEAP8[i7 + 4 >> 0] | 0;
 i10 = _bitshift64Shl(1, 0, i9 & 255 | 0) | 0;
 i10 = _i64Add(i10 | 0, getTempRet0() | 0, -1, 0) | 0;
 getTempRet0() | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i11 = i7 + 8 | 0;
  i12 = i9 & 255;
  i6 = 0;
  i3 = 0;
  i2 = 0;
  i1 = i9;
  while (1) {
   i13 = i8 + (i6 << 2) | 0;
   HEAP32[i13 >> 2] = 0;
   if (!(i1 << 24 >> 24)) {
    i4 = i2;
    i2 = 0;
    i1 = 0;
   } else {
    i5 = HEAP32[i11 >> 2] | 0;
    i4 = 0;
    i1 = i2;
    i2 = 0;
    do {
     i2 = (HEAPU8[i5 + i1 >> 0] | 0) >>> i3 << i4 | i2;
     HEAP32[i13 >> 2] = i2;
     i20 = i12 - i4 | 0;
     i21 = 8 - i3 | 0;
     i20 = (i21 | 0) < (i20 | 0) ? i21 : i20;
     i3 = i20 + i3 | 0;
     i4 = i20 + i4 | 0;
     i20 = (i3 | 0) == 8;
     i3 = i20 ? 0 : i3;
     i1 = (i20 & 1) + i1 | 0;
    } while ((i4 | 0) < (i12 | 0));
    i4 = i1;
    i1 = i9;
   }
   HEAP32[i13 >> 2] = i2 & i10;
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break; else i2 = i4;
  }
 }
 i1 = i14 + 152 | 0;
 i2 = i14 + 164 | 0;
 HEAP32[i2 >> 2] = i16;
 i3 = i14 + 168 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i16 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i16;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i16 * 52 | 0, 4, i14 + 156 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i21 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16 * 52 | 0, 4, i14 + 156 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i21 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 52 | 0) | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i1 >> 2] = i21;
  break;
 } while (0);
 if ((i16 | 0) > 0) {
  i4 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i14 + 152 >> 2] | 0;
  i1 = 0;
  i2 = 0;
  do {
   i1 = (HEAP32[i4 + (i2 << 2) >> 2] | 0) + i1 | 0;
   HEAPF32[i3 + (i2 * 52 | 0) >> 2] = Math_fround(+(i1 >>> 0) * .01);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i16 | 0));
 }
 if ((HEAP32[i17 >> 2] | 0) <= -1) {
  STACKTOP = i19;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i18);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i19;
 return;
}

function __ZN14CachingManager10MarkAsUsedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = i8 + 52 | 0;
 i2 = i8 + 40 | 0;
 i6 = i8 + 28 | 0;
 i7 = i8 + 16 | 0;
 i9 = HEAP32[(__Z17GetCachingManagerv() | 0) + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i6, i9, i3, i5);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, (HEAP32[(__Z17GetCachingManagerv() | 0) + 4 >> 2] | 0) + 4 | 0, i6);
 __Z20GetPlatformCachePathv(i5);
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i5); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i5, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i9 = HEAP8[i7 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i9 & 255) | 0)) {
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 if (__ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE(i7, 0, i5) | 0) {
  i4 = _time(0) | 0;
  __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl(i7, i5, i4) | 0;
  __ZN5Cache15UpdateTimestampERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEl(HEAP32[(__Z17GetCachingManagerv() | 0) + 4 >> 2] | 0, i7, i4);
  i4 = 1;
 } else i4 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i9 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i9;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i9 = i4;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN13AnimationClip12Vector3CurveC2ERKS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i6 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i6 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i4 + 11 >> 0] = i6;
  if (!i6) i1 = i4; else {
   i1 = i4;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i6 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i4 + 4 >> 2] = i6;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 i9 = i4 + 16 | 0;
 i7 = i5 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i4 + 32 >> 2] = HEAP32[i5 + 32 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i5 + 40 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i4 + 48 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i4 + 52 >> 2] = HEAP32[i5 + 52 >> 2];
 HEAP32[i4 + 56 >> 2] = HEAP32[i5 + 56 >> 2];
 HEAP32[i4 + 60 >> 2] = HEAP32[i5 + 60 >> 2];
 HEAP32[i4 + 64 >> 2] = HEAP32[i5 + 64 >> 2];
 HEAP32[i4 + 68 >> 2] = HEAP32[i5 + 68 >> 2];
 HEAP32[i4 + 72 >> 2] = HEAP32[i5 + 72 >> 2];
 i9 = i4 + 76 | 0;
 i7 = i5 + 76 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 88 >> 2] = HEAP32[i5 + 88 >> 2];
 HEAP32[i4 + 92 >> 2] = HEAP32[i5 + 92 >> 2];
 HEAP32[i4 + 96 >> 2] = HEAP32[i5 + 96 >> 2];
 HEAP32[i4 + 100 >> 2] = HEAP32[i5 + 100 >> 2];
 HEAP32[i4 + 104 >> 2] = HEAP32[i5 + 104 >> 2];
 HEAP32[i4 + 108 >> 2] = HEAP32[i5 + 108 >> 2];
 HEAP32[i4 + 112 >> 2] = HEAP32[i5 + 112 >> 2];
 HEAP32[i4 + 116 >> 2] = HEAP32[i5 + 116 >> 2];
 HEAP32[i4 + 120 >> 2] = HEAP32[i5 + 120 >> 2];
 HEAP32[i4 + 124 >> 2] = HEAP32[i5 + 124 >> 2];
 HEAP32[i4 + 128 >> 2] = HEAP32[i5 + 128 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[i5 + 132 >> 2];
 __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEC2ERKS3_(i4 + 136 | 0, i5 + 136 | 0);
 i9 = i4 + 156 | 0;
 i7 = i5 + 156 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 168 >> 2] = HEAP32[i5 + 168 >> 2];
 STACKTOP = i8;
 return;
}

function __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 HEAP32[i3 + 44 >> 2] = i4;
 HEAP32[i3 + 40 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 80 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 88 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i2 + 124 >> 2];
 HEAP32[i3 + 52 >> 2] = HEAP32[i2 + 76 >> 2];
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f19 = Math_fround(f8 + f8);
 f20 = Math_fround(f18 + f18);
 f22 = Math_fround(f13 + f13);
 f6 = Math_fround(f18 * f20);
 f15 = Math_fround(f13 * f22);
 f18 = Math_fround(f19 * f18);
 f9 = Math_fround(f19 * f13);
 f14 = Math_fround(f19 * f21);
 f13 = Math_fround(f20 * f13);
 f20 = Math_fround(f20 * f21);
 f21 = Math_fround(f22 * f21);
 f22 = Math_fround(Math_fround(Math_fround(1.0) - f6) - f15);
 f16 = Math_fround(f18 + f21);
 f10 = Math_fround(f9 - f20);
 f21 = Math_fround(f18 - f21);
 f19 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f19));
 f15 = Math_fround(f19 - f15);
 f8 = Math_fround(f13 + f14);
 f20 = Math_fround(f9 + f20);
 f14 = Math_fround(f13 - f14);
 f6 = Math_fround(f19 - f6);
 f19 = Math_fround(HEAPF32[i2 + 112 >> 2]);
 f13 = Math_fround(f19 * f22);
 f9 = Math_fround(f19 * f16);
 f19 = Math_fround(f19 * f10);
 f18 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f12 = Math_fround(f18 * f21);
 f7 = Math_fround(f18 * f15);
 f18 = Math_fround(f18 * f8);
 f17 = Math_fround(HEAPF32[i2 + 120 >> 2]);
 f11 = Math_fround(f20 * f17);
 f5 = Math_fround(f14 * f17);
 f17 = Math_fround(f6 * f17);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(f22 * f13) + Math_fround(f21 * f12)) + Math_fround(f20 * f11));
 i1 = i3 + 12 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(Math_fround(f16 * f9) + Math_fround(f15 * f7)) + Math_fround(f14 * f5));
 i4 = i3 + 24 | 0;
 HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f8 * f18)) + Math_fround(f6 * f17));
 f14 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(f15 * f12)) + Math_fround(f14 * f11));
 HEAPF32[i3 + 4 >> 2] = f14;
 HEAPF32[i1 >> 2] = f14;
 f11 = Math_fround(Math_fround(Math_fround(f10 * f13) + Math_fround(f8 * f12)) + Math_fround(f6 * f11));
 HEAPF32[i3 + 8 >> 2] = f11;
 HEAPF32[i4 >> 2] = f11;
 f5 = Math_fround(Math_fround(Math_fround(f10 * f9) + Math_fround(f8 * f7)) + Math_fround(f6 * f5));
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i4 + 4 >> 2] = f5;
 HEAP32[i3 + 36 >> 2] = HEAP32[i2 + 92 >> 2];
 return;
}

function __ZN7mecanim12statemachine19CreateStateConstantEPPNS0_18TransitionConstantEjfjbbbjfjPPNS_9animation17BlendTreeConstantEjjjjjbRNS_6memory9AllocatorE(i17, i18, f7, i6, i8, i9, i10, i11, f12, i13, i20, i21, i1, i2, i3, i4, i16, i19) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 f7 = Math_fround(f7);
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i19 = i19 | 0;
 var i5 = 0, i14 = 0, i15 = 0, i22 = 0;
 i22 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, 64, 4) | 0;
 i5 = i22 + 52 | 0;
 i14 = i22 + 4 | 0;
 i15 = i14 + 44 | 0;
 do {
  HEAP32[i14 >> 2] = 0;
  i14 = i14 + 4 | 0;
 } while ((i14 | 0) < (i15 | 0));
 HEAP32[i22 >> 2] = i18;
 HEAPF32[i5 >> 2] = f7;
 HEAP8[i22 + 60 >> 0] = i8 & 1;
 HEAP8[i22 + 61 >> 0] = i9 & 1;
 HEAP8[i22 + 63 >> 0] = i10 & 1;
 HEAPF32[i22 + 56 >> 2] = f12;
 HEAP32[i22 + 28 >> 2] = i2;
 HEAP32[i22 + 32 >> 2] = i3;
 HEAP32[i22 + 24 >> 2] = i1;
 HEAP32[i22 + 36 >> 2] = i4;
 HEAP32[i22 + 40 >> 2] = i6;
 HEAP32[i22 + 44 >> 2] = i11;
 HEAP32[i22 + 48 >> 2] = i13;
 HEAP32[i22 + 8 >> 2] = i21;
 i6 = i22 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP8[i22 + 62 >> 0] = i16 & 1;
 i5 = i22 + 12 | 0;
 i8 = (i21 | 0) == 0;
 if (i8) i1 = 0; else {
  i2 = i21 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i21 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i4 = i5;
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 i1 = i22 + 4 | 0;
 if (!i18) HEAP32[i1 >> 2] = 0; else {
  i2 = i18 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i18 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i2 = i1;
  i16 = i3 | 0 ? i3 - i2 | 0 : 0;
  HEAP32[i1 >> 2] = i16;
  i2 = i16 + i2 | 0;
  i1 = 0;
  do {
   i16 = i2 + (i1 << 2) | 0;
   i15 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
   HEAP32[i16 >> 2] = i15 | 0 ? i15 - i16 | 0 : 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i18 | 0));
 }
 if (!i8) {
  i1 = 0;
  do {
   if (!(HEAP32[i20 + (i1 << 2) >> 2] | 0)) HEAP32[(HEAP32[i5 >> 2] | 0) + i4 + (i1 << 2) >> 2] = -1; else {
    HEAP32[(HEAP32[i5 >> 2] | 0) + i4 + (i1 << 2) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i21 | 0));
 }
 i4 = i22 + 20 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i19 >> 2] >> 2] | 0, i19 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i2 = i4;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i4 >> 2] = i1;
 if (i8) return i22 | 0;
 i4 = i1 + i2 | 0;
 i1 = 0;
 i3 = 0;
 do {
  i2 = HEAP32[i20 + (i3 << 2) >> 2] | 0;
  if (i2) {
   i19 = i4 + (i1 << 2) | 0;
   HEAP32[i19 >> 2] = i2 - i19;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i21 | 0));
 return i22 | 0;
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_18PxClothFabricPhaseEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i15, i3, i14, i16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 16 | 0;
 i4 = i17 + 12 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 HEAP32[i3 >> 2] = 8;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i16; else {
  HEAP32[gb + 1457184 >> 2] = (HEAP32[gb + 1457184 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i12 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i10 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i12 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i10 = 9;
   } else i10 = 8;
  }
  if ((i10 | 0) == 8) {
   i9 = _strlen(i1) | 0;
   i7 = i1 + i9 | 0;
   if ((i9 | 0) > 0) {
    i8 = i13 + 4 | 0;
    i5 = i1;
    i9 = 0;
    i4 = 0;
    i2 = 0;
    while (1) {
     HEAP32[i13 >> 2] = 0;
     HEAP32[i8 >> 2] = 0;
     if (i5 | 0) if (HEAP8[i5 >> 0] | 0) __ZN5physx2Sn9StrToImplINS_18PxClothFabricPhaseEE5strtoERS2_RPKc(i11, i13, i12);
     i3 = i9 + 8 | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i4 | 0) | 0;
      if (i9 | 0) _memcpy(i5 | 0, i2 | 0, i9 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else i6 = i2;
     i18 = i13;
     i19 = HEAP32[i18 >> 2] | 0;
     i18 = HEAP32[i18 + 4 >> 2] | 0;
     i5 = i6 + i9 | 0;
     i9 = i5;
     HEAP8[i9 >> 0] = i19;
     HEAP8[i9 + 1 >> 0] = i19 >> 8;
     HEAP8[i9 + 2 >> 0] = i19 >> 16;
     HEAP8[i9 + 3 >> 0] = i19 >> 24;
     i5 = i5 + 4 | 0;
     HEAP8[i5 >> 0] = i18;
     HEAP8[i5 + 1 >> 0] = i18 >> 8;
     HEAP8[i5 + 2 >> 0] = i18 >> 16;
     HEAP8[i5 + 3 >> 0] = i18 >> 24;
     i5 = HEAP32[i12 >> 2] | 0;
     if (i5 >>> 0 >= i7 >>> 0) break; else i9 = i3;
    }
    i4 = i1;
    i3 = i3 >>> 3;
    i1 = i16;
   } else i10 = 9;
  }
  if ((i10 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i16;
  }
  HEAP32[i15 >> 2] = i2;
  HEAP32[i14 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ES2_RKNS_18PxVehicleGearsDataES6_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 340 | 0;
 i6 = i9 + 288 | 0;
 i8 = i9 + 144 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 0, i10, gb + 166432 | 0, i5);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 32 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10 + 48 | 0, 3);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 144) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN13RendererSceneD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN21IntermediateRenderers5ClearEj(i8, 0);
 HEAP32[i8 + 144 >> 2] = 0;
 i5 = i8 + 140 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, gb + 63600 | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i8 + 60 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i6 = i8 + 72 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = i3 + (i4 * 24 | 0) | 0;
 L1 : do if (i4 | 0) {
  i1 = i3;
  do {
   HEAP32[i1 + 8 >> 2] = -1;
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = 0;
  i2 = i4;
  while (1) {
   if (!(HEAP32[i3 + (i1 * 24 | 0) >> 2] | 0)) {
    __ZN13RendererScene14RemoveRendererEi(i8, i1) | 0;
    i1 = i1 + -1 | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
   i3 = HEAP32[i5 >> 2] | 0;
  }
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 27788 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L11 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 27020 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 2379 | 0)) {
    i4 = i6 + 27020 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 27020 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L11;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 27020 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 27020 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 27020 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 27020 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 27020 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 27020 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = i8 + 120 | 0;
 if ((HEAP32[i8 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 + 116 >> 2] | 0) > -1) {
  i7 = i8 + 100 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 104 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 i1 = i8 + 80 | 0;
 if ((HEAP32[i8 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 60 | 0;
 if ((HEAP32[i8 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 40 | 0;
 if ((HEAP32[i8 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 20 | 0;
 if ((HEAP32[i8 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i8 + 4 | 0);
 HEAP32[i8 >> 2] = 0;
 return;
}

function __Z18PrepareClipBuilderR18MecanimClipBuilder(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = 0;
 i9 = 0;
 while (1) {
  i4 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 12 >> 2] | 0;
  if (!i4) {
   i2 = 0;
   i3 = 0;
   i1 = 0;
  } else {
   i5 = HEAP32[i10 + 620 + (i8 * 148 | 0) >> 2] | 0;
   i3 = 0;
   i2 = 0;
   i1 = 0;
   do {
    i1 = ((HEAP32[(HEAP32[i5 + (i3 << 2) >> 2] | 0) + 132 >> 2] | 0) * 3 | 0) + i1 | 0;
    i2 = i2 + 3 | 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i4 >>> 0);
  }
  i5 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 52 >> 2] | 0;
  if (i5) {
   i6 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 40 >> 2] | 0;
   i4 = 0;
   do {
    i1 = (HEAP32[(HEAP32[i6 + (i4 << 2) >> 2] | 0) + 164 >> 2] << 2) + i1 | 0;
    i2 = i2 + 4 | 0;
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i5 >>> 0);
  }
  i5 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 32 >> 2] | 0;
  if (i5) {
   i6 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 20 >> 2] | 0;
   i4 = 0;
   do {
    i1 = ((HEAP32[(HEAP32[i6 + (i4 << 2) >> 2] | 0) + 132 >> 2] | 0) * 3 | 0) + i1 | 0;
    i2 = i2 + 3 | 0;
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i5 >>> 0);
  }
  i5 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 72 >> 2] | 0;
  if (i5) {
   i6 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 60 >> 2] | 0;
   i4 = 0;
   do {
    i1 = ((HEAP32[(HEAP32[i6 + (i4 << 2) >> 2] | 0) + 132 >> 2] | 0) * 3 | 0) + i1 | 0;
    i2 = i2 + 3 | 0;
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i5 >>> 0);
  }
  i5 = i10 + 620 + (i8 * 148 | 0) + 92 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   i6 = i10 + 620 + (i8 * 148 | 0) + 128 | 0;
   i7 = i10 + 620 + (i8 * 148 | 0) + 80 | 0;
   i4 = 0;
   while (1) {
    if (__ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE((HEAP32[i6 >> 2] | 0) + (i3 << 4) | 0) | 0) HEAP32[i10 + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 4) + 4 >> 2] << 2) >> 2] = i2 + i9;
    i1 = (HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 68 >> 2] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) break; else i3 = i3 + 1 | 0;
   }
  }
  i4 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 112 >> 2] | 0;
  if (i4) {
   i5 = HEAP32[i10 + 620 + (i8 * 148 | 0) + 100 >> 2] | 0;
   i3 = 0;
   do {
    i1 = (HEAP32[(HEAP32[i5 + (i3 << 2) >> 2] | 0) + 12 >> 2] | 0) + i1 | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i4 >>> 0);
  }
  HEAP32[i10 + 620 + (i8 * 148 | 0) + 124 >> 2] = i1;
  HEAP32[i10 + 620 + (i8 * 148 | 0) + 120 >> 2] = i2;
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == 3) break; else i9 = i2 + i9 | 0;
 }
 i9 = (HEAP32[i10 + 740 >> 2] | 0) + (HEAP32[i10 + 888 >> 2] | 0) | 0;
 HEAP32[i10 + 1064 >> 2] = (HEAP32[i10 + 760 >> 2] | 0) + (HEAP32[i10 + 908 >> 2] | 0) + (HEAP32[i10 + 1056 >> 2] | 0);
 i9 = i9 + (HEAP32[i10 + 1036 >> 2] | 0) | 0;
 HEAP32[i10 + 1068 >> 2] = i9;
 return (i9 | 0) != 0 | (HEAP8[i10 + 1072 >> 0] | 0) != 0 | 0;
}

function __ZN9Transform8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896768 | 0, HEAP32[gb + 37208 >> 2] | 0, i6, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 56 | 0;
 i8 = HEAP32[gb + 37324 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896797 | 0, i8, i6, 0);
 i7 = i2 + 20 | 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 68 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896813 | 0, i8, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN9Transform25CompleteTransformTransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 16 | 0;
 i4 = i8 + 8 | 0;
 i6 = i8;
 i5 = i7 + 16 | 0;
 i13 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i7 + 32 >> 2] | 0;
 i12 = HEAP32[i7 + 60 >> 2] | 0;
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i14 = i7 + 24 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0) | 0;
 i15 = i7 + 64 | 0;
 i2 = i15;
 i2 = _i64Add(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 1, 0) | 0;
 i11 = getTempRet0() | 0;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i15 + 4 >> 2] = i11;
 i14 = HEAP32[i14 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0);
 i11 = __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i13, i10, i12, i3, i2, i11) | 0;
 __ZN12_GLOBAL__N_110Connection22initializeProfileTypesERN5physx8debugger4comm31PvdCommStreamInternalDataStreamE(i7, i11);
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 12, gb + 776481 | 0, gb + 773844 | 0, 731) | 0;
 HEAP32[i5 >> 2] = gb + 150280 + 8;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = i11;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i11 | 0);
 i11 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 112 >> 2] | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(i12 | 0, i11 | 0, i10 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0);
 i10 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = gb + 775887;
 HEAP32[i9 + 4 >> 2] = gb + 776499;
 mftCall_iiii(i11 | 0, i10 | 0, i9 | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 | 0);
 i2 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i4 | 0, i2 | 0);
 if (HEAP32[i4 >> 2] | 0) {
  i1 = i4 + 4 | 0;
  i2 = 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, (HEAP32[i1 >> 2] | 0) + (i2 << 3) | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0);
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i7 + 56 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + (i2 << 2) >> 2] = i5;
  HEAP32[i1 >> 2] = i2 + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i7 + 36 | 0, i6) | 0;
  STACKTOP = i8;
  return;
 }
}

function __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 16 | 0;
 i13 = i5;
 __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i14, i2 + 208 | 0, i3);
 __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i13, i2, i3);
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
 i12 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
 i9 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = HEAP32[i13 + 8 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i11 = i9 & 255;
 i7 = ~~f22 & 255;
 i10 = i9 >>> 8 & 255;
 i6 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i20 = i17 & 255;
 i18 = ~~f21 & 255;
 i3 = i17 >>> 8 & 255;
 i2 = i17 >>> 16 & 255;
 i17 = i17 >>> 24;
 i2 = ((Math_imul((i16 & 255) - i20 | 0, i18) | 0) + 128 >> 8) + i20 | (Math_imul((i16 >>> 8 & 255) - i3 | 0, i18) | 0) + (i3 << 8 | 128) & -256 | (((Math_imul((i16 >>> 24) - i17 | 0, i18) | 0) + 128 | 0) >>> 8) + i17 << 24 | (((Math_imul((i16 >>> 16 & 255) - i2 | 0, i18) | 0) + 128 | 0) >>> 8) + i2 << 16;
 i18 = i4 & 255;
 i16 = ~~f19 & 255;
 i17 = i4 >>> 8 & 255;
 i3 = i4 >>> 16 & 255;
 i4 = i4 >>> 24;
 i3 = ((Math_imul((i15 & 255) - i18 | 0, i16) | 0) + 128 >> 8) + i18 | (Math_imul((i15 >>> 8 & 255) - i17 | 0, i16) | 0) + (i17 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i4 | 0, i16) | 0) + 128 | 0) >>> 8) + i4 << 24 | (((Math_imul((i15 >>> 16 & 255) - i3 | 0, i16) | 0) + 128 | 0) >>> 8) + i3 << 16;
 i16 = i14 & 255;
 i12 = i12 & 255;
 i15 = i14 >>> 8 & 255;
 i4 = i14 >>> 16 & 255;
 i14 = i14 >>> 24;
 i4 = ((Math_imul((i13 & 255) - i16 | 0, i12) | 0) + 128 >> 8) + i16 | (Math_imul((i13 >>> 8 & 255) - i15 | 0, i12) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul((i13 >>> 24) - i14 | 0, i12) | 0) + 128 | 0) >>> 8) + i14 << 24 | (((Math_imul((i13 >>> 16 & 255) - i4 | 0, i12) | 0) + 128 | 0) >>> 8) + i4 << 16;
 HEAP32[i1 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i7) | 0) + 128 >> 8) + i11 | (Math_imul((i8 >>> 8 & 255) - i10 | 0, i7) | 0) + (i10 << 8 | 128) & -256 | (((Math_imul((i8 >>> 24) - i9 | 0, i7) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i8 >>> 16 & 255) - i6 | 0, i7) | 0) + 128 | 0) >>> 8) + i6 << 16;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb(i10, i7, i13) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = i10 + 88 | 0;
 i5 = HEAP32[i14 >> 2] | 0;
 if (HEAP32[i5 + 102868 >> 2] & 2 | 0) {
  i15 = 0;
  return i15 | 0;
 }
 i15 = __ZN16b2BlockAllocator8AllocateEi(i5, 64) | 0;
 i4 = i15 + 52 | 0;
 HEAP16[i4 >> 1] = 1;
 HEAP16[i15 + 54 >> 1] = -1;
 HEAP16[i15 + 56 >> 1] = 0;
 i1 = i15 + 60 | 0;
 i11 = i15 + 44 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i15 + 48 | 0;
 HEAP32[i12 >> 2] = 0;
 i2 = i15;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i15 + 36 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i15 + 40 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = i15 + 28 | 0;
 HEAP32[i8 >> 2] = i10;
 i9 = i15 + 24 | 0;
 HEAP32[i9 >> 2] = 0;
 i3 = i7 + 22 | 0;
 HEAP16[i4 >> 1] = HEAP16[i3 >> 1] | 0;
 HEAP16[i4 + 2 >> 1] = HEAP16[i3 + 2 >> 1] | 0;
 HEAP16[i4 + 4 >> 1] = HEAP16[i3 + 4 >> 1] | 0;
 HEAP8[i15 + 58 >> 0] = HEAP8[i7 + 20 >> 0] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i5 | 0) | 0;
 i6 = i15 + 32 | 0;
 HEAP32[i6 >> 2] = i3;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i5, i3 * 28 | 0) | 0;
 HEAP32[i11 >> 2] = i2;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] = 0;
   HEAP32[i2 + (i1 * 28 | 0) + 24 >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i12 >> 2] = 0;
 i4 = i15 + 20 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 if (HEAP16[i10 + 4 >> 1] & 32) {
  i2 = (HEAP32[i14 >> 2] | 0) + 102872 | 0;
  i3 = i10 + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0) | 0;
  HEAP32[i12 >> 2] = i7;
  if ((i7 | 0) > 0) {
   i1 = 0;
   do {
    i7 = HEAP32[i11 >> 2] | 0;
    i5 = i7 + (i1 * 28 | 0) | 0;
    i16 = HEAP32[i6 >> 2] | 0;
    mftCall_viiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 24 >> 2] | 0, i16 | 0, i5 | 0, i3 | 0, i1 | 0, 1);
    HEAP32[i7 + (i1 * 28 | 0) + 24 >> 2] = __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv(i2, i5, i5) | 0;
    HEAP32[i7 + (i1 * 28 | 0) + 16 >> 2] = i15;
    HEAP32[i7 + (i1 * 28 | 0) + 20 >> 2] = i1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
  }
 }
 i16 = i10 + 100 | 0;
 HEAP32[i9 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i16 >> 2] = i15;
 i16 = i10 + 104 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 HEAP32[i8 >> 2] = i10;
 if (i13) if (Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0)) __ZN6b2Body13ResetMassDataEv(i10);
 i16 = (HEAP32[i14 >> 2] | 0) + 102868 | 0;
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | 1;
 i16 = i15;
 return i16 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = i5 << 3;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 3) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 3) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 898886 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN7mecanim9animation10ValueDelta8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 898886 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim9animation10ValueDelta8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function _pre_process_data(i18, i7, i15, i16, i20, i21, i22) {
 i18 = i18 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i19 = 0;
 i17 = HEAP32[i18 + 324 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 >>> 0 >= i16 >>> 0) return;
 i8 = i18 + 220 | 0;
 i9 = i17 + 52 | 0;
 i10 = i18 + 336 | 0;
 i11 = i17 + 8 | 0;
 i12 = i17 + 48 | 0;
 i19 = i18 + 60 | 0;
 i13 = i18 + 28 | 0;
 i14 = i18 + 340 | 0;
 while (1) {
  if ((HEAP32[i21 >> 2] | 0) >>> 0 >= i22 >>> 0) {
   i4 = 28;
   break;
  }
  i6 = i16 - i1 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = (HEAP32[i8 >> 2] | 0) - i2 | 0;
  i6 = i5 >>> 0 < i6 >>> 0 ? i5 : i6;
  mftCall_viiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0, i18 | 0, i7 + (i1 << 2) | 0, i11 | 0, i2 | 0, i6 | 0);
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + i6;
  i2 = (HEAP32[i9 >> 2] | 0) + i6 | 0;
  HEAP32[i9 >> 2] = i2;
  i6 = (HEAP32[i12 >> 2] | 0) - i6 | 0;
  HEAP32[i12 >> 2] = i6;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i6 | 0) == 0 & (i2 | 0) < (i1 | 0)) {
   i3 = HEAP32[i19 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i6 = 0;
    while (1) {
     i4 = HEAP32[i17 + 8 + (i6 << 2) >> 2] | 0;
     i5 = HEAP32[i13 >> 2] | 0;
     if ((i2 | 0) < (i1 | 0)) {
      i3 = i2 + -1 | 0;
      do {
       _jcopy_sample_rows(i4, i3, i4, i2, 1, i5);
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i1 | 0));
      i3 = HEAP32[i19 >> 2] | 0;
     }
     i1 = i6 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) break;
     i6 = i1;
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i9 >> 2] = i1;
   i4 = 15;
  } else if ((i2 | 0) == (i1 | 0)) i4 = 15;
  if ((i4 | 0) == 15) {
   i4 = 0;
   mftCall_viiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0, i18 | 0, i11 | 0, 0, i20 | 0, HEAP32[i21 >> 2] | 0);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i21 >> 2] = (HEAP32[i21 >> 2] | 0) + 1;
  }
  if (!(HEAP32[i12 >> 2] | 0)) {
   i3 = HEAP32[i21 >> 2] | 0;
   if (i3 >>> 0 < i22 >>> 0) {
    i4 = 19;
    break;
   }
  }
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 >>> 0 >= i16 >>> 0) {
   i4 = 28;
   break;
  }
 }
 if ((i4 | 0) == 19) {
  i2 = HEAP32[i19 >> 2] | 0;
  L32 : do if ((i2 | 0) > 0) {
   i8 = HEAP32[i18 + 68 >> 2] | 0;
   i1 = 0;
   while (1) {
    i6 = HEAP32[i20 + (i1 << 2) >> 2] | 0;
    i7 = HEAP32[i8 + 28 >> 2] << 3;
    i5 = HEAP32[i8 + 12 >> 2] | 0;
    i3 = Math_imul(i5, i3) | 0;
    i5 = Math_imul(i5, i22) | 0;
    if ((i3 | 0) < (i5 | 0)) {
     i4 = i3 + -1 | 0;
     i2 = i3;
     do {
      _jcopy_sample_rows(i6, i4, i6, i2, 1, i7);
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i5 | 0));
     i2 = HEAP32[i19 >> 2] | 0;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) break L32;
    i8 = i8 + 84 | 0;
    i3 = HEAP32[i21 >> 2] | 0;
   }
  } while (0);
  HEAP32[i21 >> 2] = i22;
  return;
 } else if ((i4 | 0) == 28) return;
}

function __ZN20SpeedTreeWindManager18RegisterGlobalWindER13SpeedTreeWind(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  return;
 } while (0);
 i7 = i6;
 HEAPF64[i6 + 1392 >> 3] = +Math_fround(HEAPF32[i8 + 52 >> 2]);
 HEAPF32[i6 + 1628 >> 2] = Math_fround(1.0);
 i1 = i6 + 1632 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i6 + 1652 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 1656 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 1724 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1708 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1712 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1716 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1740 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1744 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1728 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1732 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1756 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1760 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1804 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1808 >> 2] = Math_fround(0.0);
 i1 = i6 + 1772 | 0;
 i2 = i6 + 1820 | 0;
 i3 = i6 + 1764 | 0;
 i4 = i6 + 1660 | 0;
 i5 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 1812 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 1852 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1856 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1860 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 1864 >> 2] = Math_fround(1.0);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i3;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 + (i2 << 3) >> 2] = i7;
 HEAP8[i9 + (i2 << 3) + 4 >> 0] = 0;
 return;
}

function __ZN16CompareSceneNameC2ERK8UnityStr(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 24 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12;
 i7 = i6 + 11 | 0;
 i3 = HEAP8[i7 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i8 = i6 + 4 | 0;
 i1 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i3 = i2 ? HEAP32[i8 >> 2] | 0 : i3 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, i3);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5);
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i11 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i9 + 11 >> 0] = i3;
  if (!i3) i1 = i9; else {
   i1 = i9;
   i11 = 6;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i13 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i13 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i3;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = i9 + 16 | 0;
 i3 = HEAP8[i7 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i3 = i2 ? HEAP32[i8 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 28 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i9 + 28 >> 2] | 0;
  i11 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i13 = i1;
   i13 = i13 + i3 | 0;
   HEAP8[i13 >> 0] = 0;
   STACKTOP = i12;
   return;
  }
 } else i11 = 10;
 if ((i11 | 0) == 10) {
  i11 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i2;
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i13;
  HEAP32[i9 + 24 >> 2] = i11 | -2147483648;
  HEAP32[i9 + 20 >> 2] = i3;
  i1 = i13;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 i13 = i1;
 i13 = i13 + i3 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_(i14, i15, i12, i11, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i14, i15, i12, i1) | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i8 + 32 >> 2] | 0;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i9 = i3;
 i10 = i8;
 do if ((i2 | 0) == (i1 | 0)) {
  i4 = i8 + 112 | 0;
  i5 = i3 + 112 | 0;
  i7 = HEAP8[i5 + 11 >> 0] | 0;
  i6 = i7 << 24 >> 24 < 0;
  i7 = i6 ? HEAP32[i3 + 116 >> 2] | 0 : i7 & 255;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i3 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i8 + 116 >> 2] | 0 : i3 & 255;
  i1 = i3 >>> 0 < i7 >>> 0 ? i3 : i7;
  if (i1 | 0) {
   i1 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i2 ? HEAP32[i4 >> 2] | 0 : i4, i1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) < 0) break; else i1 = i13;
    return i1 | 0;
   }
  }
  if (i7 >>> 0 >= i3 >>> 0) {
   i15 = i13;
   return i15 | 0;
  }
 } else if ((i2 | 0) <= (i1 | 0)) {
  i15 = i13;
  return i15 | 0;
 } while (0);
 HEAP32[i12 >> 2] = i10;
 HEAP32[i11 >> 2] = i9;
 i1 = i13 + 1 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i15 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = i4;
 i11 = i5;
 do if ((i2 | 0) == (i3 | 0)) {
  i6 = i5 + 112 | 0;
  i7 = i4 + 112 | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i4 + 116 >> 2] | 0 : i9 & 255;
  i4 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i5 + 116 >> 2] | 0 : i4 & 255;
  i2 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  if (i2 | 0) {
   i2 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
   if (i2 | 0) {
    if ((i2 | 0) < 0) break;
    return i1 | 0;
   }
  }
  if (i9 >>> 0 >= i4 >>> 0) {
   i15 = i1;
   return i15 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i15 = i1;
  return i15 | 0;
 } while (0);
 HEAP32[i15 >> 2] = i11;
 HEAP32[i12 >> 2] = i10;
 i1 = i13 + 2 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = i4;
 i11 = i5;
 do if ((i2 | 0) == (i3 | 0)) {
  i6 = i5 + 112 | 0;
  i7 = i4 + 112 | 0;
  i9 = HEAP8[i7 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i4 + 116 >> 2] | 0 : i9 & 255;
  i4 = HEAP8[i6 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i5 + 116 >> 2] | 0 : i4 & 255;
  i2 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  if (i2 | 0) {
   i2 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i3 ? HEAP32[i6 >> 2] | 0 : i6, i2) | 0;
   if (i2 | 0) {
    if ((i2 | 0) < 0) break;
    return i1 | 0;
   }
  }
  if (i9 >>> 0 >= i4 >>> 0) {
   i15 = i1;
   return i15 | 0;
  }
 } else if ((i2 | 0) <= (i3 | 0)) {
  i15 = i1;
  return i15 | 0;
 } while (0);
 HEAP32[i14 >> 2] = i11;
 HEAP32[i15 >> 2] = i10;
 i15 = i13 + 3 | 0;
 return i15 | 0;
}

function __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i2 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc(i6, HEAP32[i8 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i4 = i1 + -1 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i8 + 16 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj560ENS_22PxRepXPropertyAccessorILj560ES4_NS_27PxVehicleClutchAccuracyMode4EnumESA_EEEEvRKT0_(i6, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i6 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i6 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i8 + 32 | 0, i7 + 2 | 0);
 STACKTOP = i9;
 return i7 + 3 | 0;
}

function __ZN16StreamedResource8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 391085 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i6, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[gb + 37296 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800947 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 8 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     i12 = i2;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     i2 = i4;
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
   if (HEAP32[i9 >> 2] & 512 | 0) {
    i11 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    i12 = i4 + 4 | 0;
    HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i11;
   }
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842535 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i12 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i12 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i12 >>> 0) i8 = 23; else {
   i3 = i2 + 8 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
    i7 = i2;
    i11 = HEAP32[i7 + 4 >> 2] | 0;
    i12 = i4;
    HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
  if (HEAP32[i9 >> 2] & 512 | 0) {
   i11 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   i12 = i4 + 4 | 0;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i12 >> 2] | 0) | 0;
   HEAP32[i12 >> 2] = i11;
  }
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i12, i5, i1) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i14 = i12 + 120 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 65;
 HEAP32[i13 + 4 >> 2] = i15;
 i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 40 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 i16 = i12 + 96 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i3 = i12 + 100 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i11 = i2 >>> 0 > i5 >>> 0 ? i5 : i2;
 i4 = i1 + (i11 * 40 | 0) | 0;
 if (i11) {
  i2 = i15;
  while (1) {
   i11 = i1;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i9 = i2;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = i10;
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i9 = i1 + 32 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i2 + 32 | 0;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = i1 + 40 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 40 | 0;
  }
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i11 = i15 + (i5 * 40 | 0) | 0;
 if ((i2 | 0) == (i5 | 0)) {
  i12 = HEAP32[i16 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = 65;
  i14 = i13 + 4 | 0;
  HEAP32[i14 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
  HEAP32[i16 >> 2] = i15;
  STACKTOP = i17;
  return;
 }
 i4 = i12 + 56 | 0;
 i5 = i12 + 64 | 0;
 i6 = i12 + 68 | 0;
 i7 = i12 + 72 | 0;
 i8 = i12 + 76 | 0;
 i9 = i12 + 80 | 0;
 i10 = i12 + 84 | 0;
 i3 = i12 + 88 | 0;
 i1 = i15 + (i2 * 40 | 0) | 0;
 do {
  i12 = i4;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i18 = i1;
  HEAP32[i18 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i18 + 4 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i10 >> 2];
  i18 = i3;
  i2 = HEAP32[i18 + 4 >> 2] | 0;
  i12 = i1 + 32 | 0;
  HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i12 + 4 >> 2] = i2;
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i11 | 0));
 i18 = HEAP32[i16 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 65;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i18, i13);
 HEAP32[i16 >> 2] = i15;
 STACKTOP = i17;
 return;
}

function __ZN14Raycast2DQuery13ReportFixtureEP9b2FixtureRK6b2Vec2S4_f(i7, i2, i5, i6, f9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f9 = Math_fround(f9);
 var i1 = 0, i3 = 0, f4 = f0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 if (HEAP8[i2 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  f9 = Math_fround(-1.0);
  STACKTOP = i11;
  return Math_fround(f9);
 }
 i8 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i8 | 0) == (HEAP32[i7 + 16 >> 2] | 0)) {
  f9 = Math_fround(1.0);
  STACKTOP = i11;
  return Math_fround(f9);
 }
 if (!i8) {
  f9 = Math_fround(-1.0);
  STACKTOP = i11;
  return Math_fround(f9);
 }
 i2 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i2) {
  f9 = Math_fround(-1.0);
  STACKTOP = i11;
  return Math_fround(f9);
 }
 if (!(1 << HEAP32[i2 + 48 >> 2] & HEAP32[i7 + 4 >> 2])) {
  f9 = Math_fround(-1.0);
  STACKTOP = i11;
  return Math_fround(f9);
 }
 f4 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(!(f12 > f13) & !(f12 < f4))) {
  f13 = Math_fround(-1.0);
  STACKTOP = i11;
  return Math_fround(f13);
 }
 i15 = i1 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i14;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 20 >> 2] = i5;
 HEAPF32[i1 + 28 >> 2] = f9;
 if (f9 > Math_fround(0.0)) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(HEAPF32[i7 + 20 >> 2]);
  f13 = Math_fround(f12 - f13);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i7 + 24 >> 2]));
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(f4 * f4))));
 } else f4 = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = f4;
 HEAP32[i1 + 32 >> 2] = i8;
 i5 = HEAP32[i7 + 36 >> 2] | 0;
 i6 = HEAP32[i5 + 12 >> 2] | 0;
 L23 : do if (!i6) i10 = 16; else {
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = 0;
  while (1) {
   if ((HEAP32[i3 + (i2 * 36 | 0) + 32 >> 2] | 0) == (i8 | 0)) break;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i6 | 0)) {
    i10 = 16;
    break L23;
   }
  }
  if (Math_fround(HEAPF32[i3 + (i2 * 36 | 0) + 28 >> 2]) > f9) {
   i3 = i3 + (i2 * 36 | 0) | 0;
   i2 = i3 + 36 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
 } while (0);
 if ((i10 | 0) == 16) __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i5, i1);
 f13 = Math_fround(1.0);
 STACKTOP = i11;
 return Math_fround(f13);
}

function __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE15set_deleted_keyERSG_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 20 | 0;
 i7 = i10;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i7 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i8 >> 2] | 0;
   i9 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i7 + 11 >> 0] = i4;
   if (!i4) i1 = i7; else {
    i1 = i7;
    i9 = 8;
   }
  } else {
   i1 = i2;
   i9 = 6;
  }
  if ((i9 | 0) == 6) {
   i2 = i4 + 16 & -16;
   HEAP32[i6 >> 2] = 54;
   HEAP32[i6 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i7 + 4 >> 2] = i4;
   i9 = 8;
  }
  if ((i9 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 HEAP32[i7 + 16 >> 2] = 0;
 if (HEAP32[i5 + 4 >> 2] | 0) {
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j(i6, i5, 0);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_(i5, i6);
  __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i6);
 }
 HEAP8[i5 + 8 >> 0] = 1;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i5, i5 + 12 | 0, i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 54;
 HEAP32[i6 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
 STACKTOP = i10;
 return;
}

function __ZN19ShaderPropertySheet8CopyFromERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i8 + 8 | 0;
 i6 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 i5 = i8 + 32 | 0;
 i6 = HEAP32[i9 + 32 >> 2] | 0;
 i7 = i8 + 44 | 0;
 i1 = HEAP32[i9 + 44 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 48 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i8 + 36 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 36 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 i2 = i8 + 52 | 0;
 i6 = HEAP32[i9 + 52 >> 2] | 0;
 i7 = i8 + 64 | 0;
 i1 = HEAP32[i9 + 64 >> 2] << 2;
 i3 = i1 >> 2;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 68 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 i5 = HEAP32[i9 + 72 >> 2] | 0;
 i1 = HEAP32[i9 + 84 >> 2] | 0;
 i2 = i8 + 72 | 0;
 i6 = i8 + 84 | 0;
 HEAP32[i6 >> 2] = i1;
 i3 = i8 + 88 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i7;
  i1 = i7;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0;
 HEAP32[i8 + 92 >> 2] = HEAP32[i9 + 92 >> 2];
 HEAP32[i8 + 96 >> 2] = HEAP32[i9 + 96 >> 2];
 HEAP8[i8 + 108 >> 0] = HEAP8[i9 + 108 >> 0] | 0;
 return;
}

function __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i7 = i11;
 i10 = i7 + 8 | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (!(i6 & 1)) {
  i6 = i3 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i4 = i3 + 24 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i9, 4);
   i1 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = i2;
   i5 = i2;
  }
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i5 + 8 | 0;
  if (i2 >>> 0 > i3 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i9, 8);
   i5 = i9 + 4 | 0;
   i2 = i9;
   i3 = i5;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } else {
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i9;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i5;
   HEAP32[i6 >> 2] = i2;
   i2 = i9;
   i3 = i9 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = _llvm_bswap_i32(i5 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  i7 = i9;
  i9 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i8 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(i1, 0) | 0;
  STACKTOP = i11;
  return;
 } else {
  i5 = i3 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i4 = i1 + 4 | 0;
  i3 = i3 + 24 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 4);
   i1 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i4 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 8);
   i4 = i9 + 4 | 0;
   i1 = i9;
   i2 = i4;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i9;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i9;
   i2 = i9 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i4 = i9;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = i5;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i7, i9);
  HEAP32[i8 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(HEAP32[i9 >> 2] | 0, (i6 & 8388608 | 0) != 0) | 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN12CubemapArray8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i8, i1 + 80 | 0, 16);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 397038 | 0, i8, i1 + 84 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 88 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410455 | 0, i8, i4, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410444 | 0, i8, i1 + 76 | 0, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 430648 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 16);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i9, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932818 | 0, i8, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425828 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 105 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i2, i4, gb + 411165 | 0, 1);
 __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i2, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 92 >> 2] | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN12AudioManager23ProcessScheduledSourcesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 8 | 0;
 i10 = i15 + 4 | 0;
 i11 = i15;
 i12 = i1 + 88 | 0;
 __ZN4FMOD6System11getDSPClockEPjS1_(HEAP32[i12 >> 2] | 0, i8, i10) | 0;
 i13 = i1 + 60 | 0;
 i14 = i1 + 64 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i4 = i2;
 if ((i4 | 0) == (i13 | 0)) {
  HEAP32[i14 >> 2] = i13;
  HEAP32[i13 >> 2] = i13;
  STACKTOP = i15;
  return;
 }
 i9 = i1 + 200 | 0;
 i7 = i1 + 44 | 0;
 do {
  i1 = i2;
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = i1 + 16 | 0;
  if (+HEAPF64[i1 >> 3] != 0.0) {
   __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i12 >> 2] | 0, i11, 0, 0, 0, 0, 0) | 0;
   d3 = +HEAPF64[i1 >> 3];
   if (d3 > 0.0) {
    d3 = d3 * +(HEAP32[i11 >> 2] | 0);
    i5 = +Math_abs(d3) >= 1.0 ? (d3 > 0.0 ? ~~+Math_min(+Math_floor(d3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d3 - +(~~d3 >>> 0)) / 4294967296.0) >>> 0) : 0;
    i2 = i9;
    i2 = _i64Add(~~d3 >>> 0 | 0, i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
    i5 = getTempRet0() | 0;
    i1 = HEAP32[i6 + 456 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
    __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 1, i5, i2) | 0;
   } else {
    d3 = -(d3 * +(HEAP32[i11 >> 2] | 0));
    i2 = _i64Add(~~d3 >>> 0 | 0, (+Math_abs(d3) >= 1.0 ? (d3 > 0.0 ? ~~+Math_min(+Math_floor(d3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d3 - +(~~d3 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
    i5 = getTempRet0() | 0;
    i1 = HEAP32[i6 + 456 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
    __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 1, i5, i2) | 0;
   }
   HEAP8[i6 + 498 >> 0] = 1;
  }
  i2 = i6 + 444 | 0;
  if ((i2 | 0) != (i7 | 0)) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = i6 + 448 | 0; else {
    i5 = i6 + 448 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    i1 = i5;
   }
   i5 = HEAP32[i7 >> 2] | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i5 + 4 >> 2] = i2;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  }
  __ZN11AudioSource16UpdateParametersEv(i6);
  __ZN11AudioSource16UpdatePauseStateEv(i6);
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i4 = i2;
 } while ((i4 | 0) != (i13 | 0));
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == (i13 | 0)) {
  HEAP32[i14 >> 2] = i13;
  HEAP32[i13 >> 2] = i13;
  STACKTOP = i15;
  return;
 }
 do {
  i12 = i1 + 4 | 0;
  i11 = i1;
  i1 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
 } while ((i1 | 0) != (i13 | 0));
 HEAP32[i14 >> 2] = i13;
 HEAP32[i13 >> 2] = i13;
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu11HeightField13modifySamplesEiiRKNS_17PxHeightFieldDescEb(i20, i13, i14, i3, i17) {
 i20 = i20 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 36 >> 2] | 0, i20 | 0) | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 32 >> 2] | 0, i20 | 0) | 0;
 i19 = i20 + 104 | 0;
 f1 = Math_fround(HEAPF32[i19 >> 2]);
 i18 = i20 + 108 | 0;
 f2 = Math_fround(HEAPF32[i18 >> 2]);
 i5 = (HEAP32[i3 >> 2] | 0) + i14 | 0;
 i5 = (i5 | 0) > 0 ? i5 : 0;
 i10 = i3 + 4 | 0;
 i4 = (HEAP32[i10 >> 2] | 0) + i13 | 0;
 i4 = (i4 | 0) > 0 ? i4 : 0;
 i6 = (i14 | 0) < 0 ? 0 : i14;
 if (i6 >>> 0 < (i5 >>> 0 < i16 >>> 0 ? i5 : i16) >>> 0) {
  i11 = (i13 | 0) < 0 ? 0 : i13;
  i12 = i20 + 36 | 0;
  i9 = i3 + 16 | 0;
  if (i11 >>> 0 < (i4 >>> 0 < i15 >>> 0 ? i4 : i15) >>> 0) {
   i8 = i4 >>> 0 > i15 >>> 0 ? i15 : i4;
   i7 = i5 >>> 0 > i16 >>> 0 ? i16 : i5;
   do {
    i3 = Math_imul(i6, i15) | 0;
    i4 = i6 - i14 | 0;
    i5 = i11;
    do {
     i22 = i5 + i3 | 0;
     i23 = HEAP32[i12 >> 2] | 0;
     i25 = i23 + (i22 << 2) | 0;
     i24 = i5 - i13 + (Math_imul(HEAP32[i10 >> 2] | 0, i4) | 0) | 0;
     i24 = (HEAP32[i9 >> 2] | 0) + (i24 << 2) | 0;
     i24 = HEAPU16[i24 >> 1] | HEAPU16[i24 + 2 >> 1] << 16;
     HEAP16[i25 >> 1] = i24;
     HEAP16[i25 + 2 >> 1] = i24 >>> 16;
     i25 = __ZNK5physx2Gu11HeightField22isCollisionVertexPrecaEjjjt(i20, i22, i6, i5, 127) | 0;
     i23 = i23 + (i22 << 2) + 3 | 0;
     i24 = HEAPU8[i23 >> 0] | 0;
     HEAP8[i23 >> 0] = i25 ? i24 | 128 : i24 & 127;
     f21 = Math_fround(HEAP16[(HEAP32[i12 >> 2] | 0) + (i22 << 2) >> 1] | 0);
     f1 = f21 < f1 ? f21 : f1;
     f2 = f21 > f2 ? f21 : f2;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i8 | 0));
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i7 | 0));
  }
 }
 if (!i17) {
  f21 = f2;
  f2 = f1;
  HEAPF32[i19 >> 2] = f2;
  HEAPF32[i18 >> 2] = f21;
  i25 = i20 + 60 | 0;
  HEAPF32[i25 >> 2] = f2;
  i25 = i20 + 72 | 0;
  HEAPF32[i25 >> 2] = f21;
  return 1;
 }
 i3 = Math_imul(i16, i15) | 0;
 if (!i3) {
  f21 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i19 >> 2] = f2;
  HEAPF32[i18 >> 2] = f21;
  i25 = i20 + 60 | 0;
  HEAPF32[i25 >> 2] = f2;
  i25 = i20 + 72 | 0;
  HEAPF32[i25 >> 2] = f21;
  return 1;
 }
 i4 = HEAP32[i20 + 36 >> 2] | 0;
 f2 = Math_fround(-3402823469999999843913219.0e14);
 f1 = Math_fround(3402823469999999843913219.0e14);
 i5 = 0;
 do {
  f21 = Math_fround(HEAP16[i4 + (i5 << 2) >> 1] | 0);
  f1 = f21 < f1 ? f21 : f1;
  f2 = f21 > f2 ? f21 : f2;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i3 | 0));
 HEAPF32[i19 >> 2] = f1;
 HEAPF32[i18 >> 2] = f2;
 i25 = i20 + 60 | 0;
 HEAPF32[i25 >> 2] = f1;
 i25 = i20 + 72 | 0;
 HEAPF32[i25 >> 2] = f2;
 return 1;
}

function __ZN12_GLOBAL__N_113generateConesEPN5physx5cloth8ConeDataEPKNS1_10SphereDataEPKNS1_9IndexPairEj(i2, i21, i9, i1) {
 i2 = i2 | 0;
 i21 = i21 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i22 + 120 | 0;
 i20 = i22 + 104 | 0;
 i18 = i22 + 88 | 0;
 i10 = i22 + 72 | 0;
 i17 = i22 + 56 | 0;
 i11 = i22 + 40 | 0;
 i12 = i22 + 28 | 0;
 i13 = i22 + 16 | 0;
 i14 = i22 + 4 | 0;
 i15 = i22;
 i16 = i9 + (i1 << 3) | 0;
 if (!i1) {
  STACKTOP = i22;
  return;
 }
 i7 = i17 + 4 | 0;
 i8 = i17 + 8 | 0;
 i3 = i17 + 12 | 0;
 i4 = i18 + 4 | 0;
 i5 = i18 + 8 | 0;
 i6 = i19 + 12 | 0;
 i1 = i9;
 while (1) {
  __ZN5physx6PxVec4C2ERKS0_(i19, i21 + (HEAP32[i1 >> 2] << 4) | 0);
  i23 = i1 + 4 | 0;
  __ZN5physx6PxVec4C2ERKS0_(i20, i21 + (HEAP32[i23 >> 2] << 4) | 0);
  __ZNK5physx6PxVec4plERKS0_(i10, i20, i19);
  __ZNK5physx6PxVec4mlEf(i18, i10, Math_fround(.5));
  __ZNK5physx6PxVec4miERKS0_(i11, i20, i19);
  __ZNK5physx6PxVec4mlEf(i17, i11, Math_fround(.5));
  f24 = Math_fround(HEAPF32[i17 >> 2]);
  f24 = Math_fround(f24 * f24);
  f26 = Math_fround(HEAPF32[i7 >> 2]);
  f26 = Math_fround(f24 + Math_fround(f26 * f26));
  f24 = Math_fround(HEAPF32[i8 >> 2]);
  f24 = Math_fround(f26 + Math_fround(f24 * f24));
  f26 = Math_fround(f24 - Math_fround(__Z3sqrIfET_RKS0_(i3)));
  f25 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f24))));
  f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f26))));
  i9 = !(f26 <= Math_fround(0.0));
  f27 = i9 ? f27 : Math_fround(0.0);
  f25 = i9 ? f25 : Math_fround(0.0);
  f24 = Math_fround(f24 * f25);
  f26 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f27);
  f29 = Math_fround(HEAPF32[i18 >> 2]);
  f28 = Math_fround(HEAPF32[i4 >> 2]);
  __ZN5physx6PxVec3C2Efff(i12, f29, f28, Math_fround(HEAPF32[i5 >> 2]));
  __ZN5physx6PxVec3aSERKS0_(i2, i12) | 0;
  f28 = Math_fround(HEAPF32[i3 >> 2]);
  HEAPF32[i2 + 12 >> 2] = Math_fround(f24 * Math_fround(f27 * Math_fround(f28 + Math_fround(HEAPF32[i6 >> 2]))));
  f28 = Math_fround(HEAPF32[i17 >> 2]);
  f27 = Math_fround(HEAPF32[i7 >> 2]);
  __ZN5physx6PxVec3C2Efff(i14, f28, f27, Math_fround(HEAPF32[i8 >> 2]));
  __ZNK5physx6PxVec3mlEf(i13, i14, f25);
  __ZN5physx6PxVec3aSERKS0_(i2 + 16 | 0, i13) | 0;
  HEAPF32[i2 + 28 >> 2] = f26;
  HEAPF32[i15 >> 2] = Math_fround(f25 * Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i2 + 32 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(__Z3sqrIfET_RKS0_(i15)));
  HEAPF32[i2 + 36 >> 2] = f24;
  i9 = 1 << HEAP32[i1 >> 2];
  HEAP32[i2 + 40 >> 2] = i9;
  HEAP32[i2 + 44 >> 2] = 1 << HEAP32[i23 >> 2] | i9;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i16 | 0)) break; else i2 = i2 + 48 | 0;
 }
 STACKTOP = i22;
 return;
}

function __Z23TransferScriptingObjectI19StreamedBinaryWriteILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 3) if (!(HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 3;
  __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZNK14b2PolygonShape11ComputeMassEP10b2MassDataf(i10, i13, f14) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i11 = 0, f12 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i11 = HEAP32[i10 + 148 >> 2] | 0;
 i5 = (i11 | 0) > 0;
 if (i5) {
  i1 = 0;
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  do {
   f2 = Math_fround(f2 + Math_fround(HEAPF32[i10 + 20 + (i1 << 3) >> 2]));
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 + 20 + (i1 << 3) + 4 >> 2]));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i11 | 0));
  f8 = Math_fround(Math_fround(1.0) / Math_fround(i11 | 0));
  f12 = Math_fround(f2 * f8);
  f2 = Math_fround(f3 * f8);
  if (i5) {
   i5 = i10 + 20 | 0;
   i9 = i10 + 24 | 0;
   f8 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   i1 = 0;
   f6 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   do {
    f18 = Math_fround(Math_fround(HEAPF32[i10 + 20 + (i1 << 3) >> 2]) - f12);
    f16 = Math_fround(Math_fround(HEAPF32[i10 + 20 + (i1 << 3) + 4 >> 2]) - f2);
    i1 = i1 + 1 | 0;
    i15 = (i1 | 0) < (i11 | 0);
    f17 = Math_fround(Math_fround(HEAPF32[(i15 ? i10 + 20 + (i1 << 3) | 0 : i5) >> 2]) - f12);
    f3 = Math_fround(Math_fround(HEAPF32[(i15 ? i10 + 20 + (i1 << 3) + 4 | 0 : i9) >> 2]) - f2);
    f19 = Math_fround(Math_fround(f18 * f3) - Math_fround(f16 * f17));
    f20 = Math_fround(f19 * Math_fround(.5));
    f8 = Math_fround(f8 + f20);
    f20 = Math_fround(f20 * Math_fround(.333333343));
    f6 = Math_fround(f6 + Math_fround(Math_fround(f18 + f17) * f20));
    f4 = Math_fround(f4 + Math_fround(Math_fround(f16 + f3) * f20));
    f7 = Math_fround(f7 + Math_fround(Math_fround(f19 * Math_fround(.0833333358)) * Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f18 * f18) + Math_fround(f18 * f17))) + Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f16 * f16) + Math_fround(f16 * f3))))));
   } while (i15);
   f3 = f12;
  } else {
   f8 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f6 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f3 = f12;
  }
 } else {
  f2 = Math_fround(Math_fround(1.0) / Math_fround(i11 | 0));
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(f2 * Math_fround(0.0));
  f2 = Math_fround(f2 * Math_fround(0.0));
 }
 f20 = Math_fround(Math_abs(Math_fround(f8)));
 f12 = Math_fround(f20 * f14);
 HEAPF32[i13 >> 2] = f12;
 f19 = Math_fround(Math_fround(1.0) / f20);
 f18 = Math_fround(f6 * f19);
 f19 = Math_fround(f4 * f19);
 f16 = Math_fround(f3 + f18);
 f17 = Math_fround(f2 + f19);
 HEAPF32[i13 + 4 >> 2] = f16;
 HEAPF32[i13 + 8 >> 2] = f17;
 HEAPF32[i13 + 12 >> 2] = Math_fround(Math_fround(f7 * f14) + Math_fround(f12 * Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f17 * f17)) - Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)))));
 HEAPF32[i13 + 16 >> 2] = f20;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS4_EE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags(i12, i9, i1) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 8 | 0;
 i6 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i6 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i5 - i2 >> 2;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj(i9, i4 - i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 } else if (i4 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i4 << 2) | 0;
  if ((i5 | 0) == (i1 | 0)) i1 = i4; else {
   i5 = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2) | 0;
   HEAP32[i6 >> 2] = i5;
   i1 = i4;
  }
 } else i1 = i4;
 do if (i1 | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899338 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   L14 : do if ((i1 | 0) != (i5 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i9 = i2 + 24 | 0;
     HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i9 + 4 >> 2] = i3;
     i9 = HEAP32[i7 >> 2] | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i5 | 0)) break L14;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 899338 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i5 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN11DynamicMesh24RemoveDegeneratePolygonsEv(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0, f28 = f0, f29 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i22 + 4 | 0;
 i18 = i22;
 i1 = HEAP32[i17 + 12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i22;
  return;
 }
 i19 = i17 + 20 | 0;
 i20 = i17 + 8280 | 0;
 i2 = 0;
 do {
  i15 = HEAP32[i17 >> 2] | 0;
  i4 = HEAP8[i15 + (i2 * 26 | 0) + 24 >> 0] | 0;
  i6 = i4 & 255;
  i7 = HEAP32[i19 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i20 >> 2]);
  do if ((i4 & 255) < 3) i21 = 10; else {
   HEAP32[i16 >> 2] = 0;
   i23 = i7 + ((HEAPU16[i15 + (i2 * 26 | 0) + 12 >> 1] | 0) * 12 | 0) | 0;
   f9 = Math_fround(HEAPF32[i23 >> 2]);
   f10 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   f11 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   i23 = i7 + ((HEAPU16[i15 + (i2 * 26 | 0) + 14 >> 1] | 0) * 12 | 0) | 0;
   f12 = Math_fround(HEAPF32[i23 >> 2]);
   f13 = Math_fround(HEAPF32[i23 + 8 >> 2]);
   f3 = Math_fround(0.0);
   i4 = 2;
   f5 = Math_fround(0.0);
   f14 = Math_fround(HEAPF32[i23 + 4 >> 2]);
   do {
    i27 = i7 + ((HEAPU16[i15 + (i2 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0) * 12 | 0) | 0;
    f24 = Math_fround(f12 - f9);
    f29 = Math_fround(f13 - f10);
    f12 = Math_fround(HEAPF32[i27 >> 2]);
    f25 = Math_fround(f12 - f9);
    f13 = Math_fround(HEAPF32[i27 + 8 >> 2]);
    f26 = Math_fround(f13 - f10);
    f3 = Math_fround(f3 + Math_fround(Math_fround(f29 * f25) - Math_fround(f24 * f26)));
    f28 = Math_fround(f14 - f11);
    f24 = Math_fround(Math_fround(f29 * f29) + Math_fround(Math_fround(f28 * f28) + Math_fround(f24 * f24)));
    HEAPF32[i18 >> 2] = f24;
    i23 = HEAP32[(f24 < f5 ? i16 : i18) >> 2] | 0;
    HEAP32[i16 >> 2] = i23;
    f14 = Math_fround(HEAPF32[i27 + 4 >> 2]);
    f24 = Math_fround(f14 - f11);
    f24 = Math_fround(Math_fround(f26 * f26) + Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)));
    HEAPF32[i18 >> 2] = f24;
    i23 = f24 < (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i23 = HEAP32[(i23 ? i16 : i18) >> 2] | 0;
    HEAP32[i16 >> 2] = i23;
    i4 = i4 + 1 | 0;
    f5 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   } while ((i4 | 0) != (i6 | 0));
   if (!(f3 <= Math_fround(0.0))) {
    f29 = Math_fround(f8 * Math_fround(.00999999977));
    if (!(Math_fround(f3 * f3) <= Math_fround(Math_fround(f29 * f29) * f5))) break; else {
     i21 = 10;
     break;
    }
   } else {
    i21 = 10;
    break;
   }
  } while (0);
  if ((i21 | 0) == 10) {
   i21 = 0;
   __ZN11DynamicMesh24CollapsePolygonUnorderedEj(i17, i2);
   i2 = i2 + -1 | 0;
   i1 = i1 + -1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 STACKTOP = i22;
 return;
}

function __ZL11RecurseCopyR8TypeTreeRK16TypeTreeIteratorS3_(i14, i1, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18;
 i16 = i18 + 8 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i13 = i1 + 4 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 i1 = i2 + 4 | 0;
 i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 i9 = HEAP32[gb + 36932 >> 2] | 0;
 i8 = i14 + 20 | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc(i11 + (i3 * 24 | 0) + 4 | 0, i8, ((i10 | 0) < 0 ? i9 : HEAP32[i12 + 20 >> 2] | 0) + (i10 & 2147483647) | 0);
 i10 = HEAP32[i2 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 8 >> 2] | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i14 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 24 | 0) + 8 | 0, i8, ((i12 | 0) < 0 ? i9 : HEAP32[i10 + 20 >> 2] | 0) + (i12 & 2147483647) | 0);
 i12 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 + (i3 * 24 | 0) + 12 >> 2] = HEAP32[i2 + (i1 * 24 | 0) + 12 >> 2];
 HEAP32[i11 + (i3 * 24 | 0) + 16 >> 2] = HEAP32[i2 + (i1 * 24 | 0) + 16 >> 2];
 HEAP8[i11 + (i3 * 24 | 0) + 3 >> 0] = HEAP8[i2 + (i1 * 24 | 0) + 3 >> 0] | 0;
 HEAP16[i11 + (i3 * 24 | 0) >> 1] = HEAP16[i2 + (i1 * 24 | 0) >> 1] | 0;
 HEAP32[i11 + (i3 * 24 | 0) + 20 >> 2] = HEAP32[i2 + (i1 * 24 | 0) + 20 >> 2];
 i3 = i2 + (i1 * 24 | 0) | 0;
 if ((i3 + 24 | 0) >>> 0 < (i2 + ((HEAP32[i12 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i3 + 26 >> 0] | 0 | 0) == ((HEAPU8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i1 = i1 + 1 | 0;
  HEAP32[i15 >> 2] = i12;
  HEAP32[i15 + 4 >> 2] = i1;
  if (!i12) {
   STACKTOP = i18;
   return;
  }
  i7 = i14 + 12 | 0;
  i8 = i16 + 4 | 0;
  i6 = i15 + 4 | 0;
  i9 = i12 + 12 | 0;
  i10 = i12;
  i11 = (i12 | 0) == 0;
  L7 : while (1) {
   __ZN8TypeTree8AddChildEj(i14, HEAP32[i13 >> 2] | 0);
   i2 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i16 >> 2] = i14;
   HEAP32[i8 >> 2] = i2;
   __ZL11RecurseCopyR8TypeTreeRK16TypeTreeIteratorS3_(i14, i16, i15);
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
   i4 = i2 + ((HEAP32[i9 >> 2] | 0) * 24 | 0) | 0;
   i5 = i2;
   i2 = i2 + (i1 * 24 | 0) | 0;
   do {
    i1 = i2;
    i2 = i2 + 24 | 0;
    if (i2 >>> 0 >= i4 >>> 0) break L7;
    i1 = HEAP8[i1 + 26 >> 0] | 0;
   } while ((i1 & 255) > (i3 & 255));
   if (i1 << 24 >> 24 != i3 << 24 >> 24) break;
   i1 = (i2 - i5 | 0) / 24 | 0;
   HEAP32[i15 >> 2] = i10;
   HEAP32[i6 >> 2] = i1;
   if (i11) {
    i17 = 6;
    break;
   }
  }
  if ((i17 | 0) == 6) {
   STACKTOP = i18;
   return;
  }
  HEAP32[i15 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i18;
  return;
 }
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -36 | 0;
  i5 = i1;
  i1 = i1 + -36 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -32 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -24 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -24 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -28 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -32 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -20 | 0;
  i7 = i5 + -20 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i17 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  i6 = (HEAP32[i13 >> 2] | 0) + -36 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i5 = i9;
 if (!i7) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i7;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9; else i6 = 10;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
  if (i1 | 0) i6 = 10;
 }
 if ((i6 | 0) == 10) if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
  i8 = __ZNK13MonoBehaviour17GetExecutionOrderEv(i1) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i7;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 17; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 17; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 19;
  }
 }
 if ((i6 | 0) == 17) i6 = 19;
 if ((i6 | 0) == 19) {
  i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
  if (!i1) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 i1 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
 if ((i1 - (HEAP32[gb + 28304 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28304 + 28 >> 2] | 0) >>> 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[(HEAP32[gb + 1106156 + 4 + (i1 << 2) >> 2] | 0) + 24 >> 2] << 3) + 4 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z23TransferScriptingObjectI24GenerateTypeTreeTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 6) if (!(HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 6;
  __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __Z23TransferScriptingObjectI18StreamedBinaryReadILb1EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 2) if (!(HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 2;
  __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __Z23TransferScriptingObjectI18StreamedBinaryReadILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 1) if (!(HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 1;
  __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb(i2, i3, i6, i5, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 44 | 0;
 i1 = i9 + 16 | 0;
 i7 = i9 + 4 | 0;
 if ((i5 & -2 | 0) == 2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 659217 | 0, 365, gb + 735603 | 0, i9);
  STACKTOP = i9;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i2 | 0);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i2 | 0);
  f14 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) * Math_fround(2.0));
  f17 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) * Math_fround(2.0));
  f20 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(2.0));
  f18 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  f16 = Math_fround(f14 * f10);
  f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f17 * f12));
  f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f20 * f11));
  f15 = Math_fround(Math_fround(f10 * f16) + Math_fround(Math_fround(f14 * f19) + Math_fround(f18 * Math_fround(Math_fround(f20 * f12) - Math_fround(f17 * f11)))));
  f13 = Math_fround(Math_fround(f12 * f16) + Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * Math_fround(Math_fround(f14 * f11) - Math_fround(f20 * f10)))));
  f16 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * Math_fround(Math_fround(f17 * f10) - Math_fround(f14 * f12)))) + Math_fround(f11 * f16));
  f15 = Math_fround(Math_fround(HEAPF32[i4 + 16 >> 2]) + f15);
  f13 = Math_fround(Math_fround(HEAPF32[i4 + 20 >> 2]) + f13);
  f16 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) + f16);
  f15 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f15);
  f13 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f13);
  f16 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f16);
  f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f12 = Math_fround(f13 * f11);
  f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f12 = Math_fround(f12 - Math_fround(f16 * f14));
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(Math_fround(f16 * f10) - Math_fround(f11 * f15));
  f10 = Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f10));
  HEAPF32[i7 >> 2] = f12;
  HEAPF32[i7 + 4 >> 2] = f11;
  HEAPF32[i7 + 8 >> 2] = f10;
  mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i2 | 0, i3 | 0, i5 | 0, i8 | 0);
  mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, i7 | 0, i5 | 0, i8 | 0);
  STACKTOP = i9;
  return;
 }
}
function __ZN5physx3Cct9SweepTest17onObstacleUpdatedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f(i9, i2, i1, i4, i5, f3) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i6 = i10;
 i7 = i9 + 152 | 0;
 if ((HEAP32[i7 >> 2] | 0) != (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = -1;
 HEAP16[i8 + 12 >> 1] = 0;
 i2 = i8 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i8 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = -1;
 i2 = __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKNS_6PxVec3ES6_fRj(i1, i8, i4, i5, f3, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == 0 ? 1 : (HEAP32[i7 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i6 = HEAP32[i8 + 16 >> 2] | 0;
 HEAP32[i9 + 212 >> 2] = i6;
 i7 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i9 + 216 >> 2] = i7;
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i9 + 220 >> 2] = i8;
 f11 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f19 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f17 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f18 = Math_fround(+HEAPF64[i2 + 8 >> 3]);
 f13 = Math_fround(+HEAPF64[i2 + 16 >> 3]);
 f14 = Math_fround(+HEAPF64[i2 + 24 >> 3]);
 f20 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f18 = Math_fround(Math_fround(f11 - f18) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(f19 - f13) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f17 - f14) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f19 = Math_fround(Math_fround(Math_fround(f18 * f20) + Math_fround(f13 * f15)) + Math_fround(f14 * f12));
 f11 = Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f13 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f12) - Math_fround(f20 * f14)))));
 f3 = Math_fround(Math_fround(f12 * f19) + Math_fround(Math_fround(f14 * f17) - Math_fround(f16 * Math_fround(Math_fround(f20 * f13) - Math_fround(f18 * f15)))));
 HEAPF32[i9 + 200 >> 2] = Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)))));
 HEAPF32[i9 + 204 >> 2] = f11;
 HEAPF32[i9 + 208 >> 2] = f3;
 STACKTOP = i10;
 return;
}

function __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 f3 = Math_fround(HEAPF32[i11 >> 2]);
 f25 = Math_fround(f3 * Math_fround(10.0));
 f19 = Math_fround(HEAPF32[i12 >> 2]);
 f14 = Math_fround(Math_fround(f19 - f3) / f25);
 i23 = f14 >= Math_fround(0.0);
 f17 = Math_fround(f14 + Math_fround(-.99999994));
 i23 = ~~(i23 ? f14 : f17);
 f17 = Math_fround(Math_fround(f3 + f19) / f25);
 i13 = f17 >= Math_fround(0.0);
 f14 = Math_fround(f17 + Math_fround(-.99999994));
 i13 = ~~(i13 ? f17 : f14);
 f14 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f17 = Math_fround(Math_fround(f14 - f3) / f25);
 i15 = f17 >= Math_fround(0.0);
 f26 = Math_fround(f17 + Math_fround(-.99999994));
 i15 = ~~(i15 ? f17 : f26);
 f26 = Math_fround(Math_fround(f3 + f14) / f25);
 i16 = f26 >= Math_fround(0.0);
 f17 = Math_fround(f26 + Math_fround(-.99999994));
 i16 = ~~(i16 ? f26 : f17);
 f17 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f26 = Math_fround(Math_fround(f17 - f3) / f25);
 i1 = f26 >= Math_fround(0.0);
 f24 = Math_fround(f26 + Math_fround(-.99999994));
 i1 = ~~(i1 ? f26 : f24);
 f25 = Math_fround(Math_fround(f3 + f17) / f25);
 i18 = f25 >= Math_fround(0.0);
 f24 = Math_fround(f25 + Math_fround(-.99999994));
 i18 = ~~(i18 ? f25 : f24);
 if ((i1 | 0) <= (i18 | 0)) {
  i20 = HEAP32[i11 + 4 >> 2] | 0;
  i21 = (i23 | 0) > (i13 | 0);
  i22 = i11 + 8 | 0;
  if ((i15 | 0) <= (i16 | 0)) {
   i2 = -1;
   f3 = Math_fround(f3 * f3);
   while (1) {
    i10 = Math_imul(i1, -887442657) | 0;
    if (!i21) {
     i9 = i15;
     while (1) {
      i8 = (Math_imul(i9, -669632447) | 0) + i10 | 0;
      i7 = i23;
      while (1) {
       i4 = HEAP32[i11 + 28 + ((i8 + (Math_imul(i7, -1918454973) | 0) & 2047) << 2) >> 2] | 0;
       if ((i4 | 0) != -1) {
        i5 = HEAP32[i20 >> 2] | 0;
        i6 = HEAP32[i22 >> 2] | 0;
        do {
         f24 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) >> 2]) - f19);
         f25 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 4 >> 2]) - f14);
         f26 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 8 >> 2]) - f17);
         f26 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
         i27 = f26 < f3;
         f3 = i27 ? f26 : f3;
         i2 = i27 ? i4 : i2;
         i4 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
        } while ((i4 | 0) != -1);
       }
       if ((i7 | 0) < (i13 | 0)) i7 = i7 + 1 | 0; else break;
      }
      if ((i9 | 0) < (i16 | 0)) i9 = i9 + 1 | 0; else break;
     }
    }
    if ((i1 | 0) < (i18 | 0)) i1 = i1 + 1 | 0; else break;
   }
   if ((i2 | 0) != -1) {
    i27 = i2;
    return i27 | 0;
   }
  }
 }
 i27 = __ZN12VertexWelderILi2048EE4PushERK8Vector3f(i11, i12) | 0;
 return i27 | 0;
}

function __ZN9Texture3D13UploadTextureEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i1 = i14 + 4 | 0;
 i13 = i14;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i16 = __Z12GetGfxDevicev() | 0;
 i17 = HEAP32[(HEAP32[i16 >> 2] | 0) + 448 >> 2] | 0;
 i9 = i10 + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 i11 = i10 + 96 | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 100 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i10 + 80 >> 2] | 0;
 i2 = HEAP32[i10 + 84 >> 2] | 0;
 i7 = HEAP32[i10 + 88 >> 2] | 0;
 i6 = HEAP32[i10 + 92 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 116 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 mftCall_viiiiiiiiii(i17 | 0, i16 | 0, i8 | 0, i15 | 0, i3 | 0, i4 | 0, i2 | 0, i7 | 0, i6 | 0, i5 | 0, 0);
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i10;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i8;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i17 = i7 + 8 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 }
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 92 >> 2] | 0, i10 | 0);
 i16 = __Z12GetGfxDevicev() | 0;
 i15 = HEAP32[(HEAP32[i16 >> 2] | 0) + 680 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 i17 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 mftCall_viii(i15 | 0, i16 | 0, i8 | 0, i17 | 0);
 HEAP8[i10 + 104 >> 0] = 1;
 if (HEAP8[i10 + 105 >> 0] | 0) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function _UNITY_FT_Raccess_Get_DataOffsets(i1, i9, i8, i12, i7, i10, i13, i14) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = _UNITY_FT_Stream_Seek(i9, i8) | 0;
 HEAP32[i15 >> 2] = i1;
 if (i1 | 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadUShort(i9, i15) | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if (i2 | 0) {
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 }
 i4 = i1 & 65535;
 i3 = 0;
 while (1) {
  i5 = _UNITY_FT_Stream_ReadULong(i9, i15) | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) {
   i4 = 24;
   break;
  }
  i6 = _UNITY_FT_Stream_ReadUShort(i9, i15) | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) {
   i4 = 24;
   break;
  }
  i2 = _UNITY_FT_Stream_ReadUShort(i9, i15) | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) {
   i4 = 24;
   break;
  }
  if ((i5 | 0) == (i7 | 0)) {
   i4 = 9;
   break;
  }
  if ((i3 | 0) < (i4 | 0)) i3 = i3 + 1 | 0; else {
   i1 = 1;
   i4 = 24;
   break;
  }
 }
 if ((i4 | 0) == 9) {
  HEAP32[i14 >> 2] = (i6 & 65535) + 1;
  i1 = _UNITY_FT_Stream_Seek(i9, (i2 & 65535) + i8 | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  if (i1 | 0) {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  }
  i3 = _UNITY_ft_mem_realloc(i11, 8, 0, HEAP32[i14 >> 2] | 0, 0, i15) | 0;
  i1 = HEAP32[i15 >> 2] | 0;
  if (i1 | 0) {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  }
  i1 = HEAP32[i14 >> 2] | 0;
  L23 : do if ((i1 | 0) > 0) {
   i2 = 0;
   while (1) {
    HEAP16[i3 + (i2 << 3) >> 1] = _UNITY_FT_Stream_ReadUShort(i9, i15) | 0;
    if (HEAP32[i15 >> 2] | 0) break L23;
    i8 = _UNITY_FT_Stream_Skip(i9, 2) | 0;
    HEAP32[i15 >> 2] = i8;
    if (i8 | 0) break L23;
    i1 = _UNITY_FT_Stream_ReadULong(i9, i15) | 0;
    if (HEAP32[i15 >> 2] | 0) break L23;
    i8 = _UNITY_FT_Stream_Skip(i9, 4) | 0;
    HEAP32[i15 >> 2] = i8;
    if (i8 | 0) break L23;
    HEAP32[i3 + (i2 << 3) + 4 >> 2] = i1 & 16777215;
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i14 >> 2] | 0;
    if ((i2 | 0) >= (i1 | 0)) {
     i4 = 17;
     break;
    }
   }
  } else i4 = 17; while (0);
  if ((i4 | 0) == 17) {
   if (i10 << 24 >> 24) {
    _qsort(i3, i1, 8, fb + 1e3 | 0);
    i1 = HEAP32[i14 >> 2] | 0;
   }
   i2 = _UNITY_ft_mem_realloc(i11, 4, 0, i1, 0, i15) | 0;
   if (!(HEAP32[i15 >> 2] | 0)) {
    if ((HEAP32[i14 >> 2] | 0) > 0) {
     i1 = 0;
     do {
      HEAP32[i2 + (i1 << 2) >> 2] = (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) + i12;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i14 >> 2] | 0));
    }
    HEAP32[i13 >> 2] = i2;
    HEAP32[i15 >> 2] = 0;
   }
  }
  _UNITY_ft_mem_free(i11, i3);
  i15 = HEAP32[i15 >> 2] | 0;
  STACKTOP = i16;
  return i15 | 0;
 } else if ((i4 | 0) == 24) {
  STACKTOP = i16;
  return i1 | 0;
 }
 return 0;
}

function _cf2_hintmap_insertHint(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i7 = 0;
  i1 = i9;
 } else i7 = (HEAP32[i9 >> 2] | 0) != 0 & 1;
 i6 = i8 + 20 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 L4 : do if (!i4) i5 = 0; else {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = 0;
  while (1) {
   if ((HEAP32[i8 + 28 + (i2 * 20 | 0) + 8 >> 2] | 0) >= (i3 | 0)) {
    i5 = i2;
    break L4;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i5 = i2;
    break;
   }
  }
 } while (0);
 if (i5 >>> 0 < i4 >>> 0) {
  i2 = HEAP32[i8 + 28 + (i5 * 20 | 0) + 8 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) return;
  if (i7 << 24 >> 24) if ((i2 | 0) <= (HEAP32[i9 + 8 >> 2] | 0)) return;
  if (HEAP32[i8 + 28 + (i5 * 20 | 0) >> 2] & 8 | 0) return;
 }
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 do if (HEAP8[i2 + 12 >> 0] | 0) if (!(HEAP32[i1 >> 2] & 16)) if (!(i7 << 24 >> 24)) {
  HEAP32[i1 + 12 >> 2] = _cf2_hintmap_map(i2, HEAP32[i1 + 8 >> 2] | 0) | 0;
  break;
 } else {
  i10 = i9 + 8 | 0;
  i3 = i1 + 8 | 0;
  i4 = _cf2_hintmap_map(i2, ((HEAP32[i3 >> 2] | 0) + (HEAP32[i10 >> 2] | 0) | 0) / 2 | 0) | 0;
  i3 = _UNITY_FT_MulFix(((HEAP32[i10 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 2 | 0, HEAP32[i8 + 16 >> 2] | 0) | 0;
  HEAP32[i1 + 12 >> 2] = i4 - i3;
  HEAP32[i9 + 12 >> 2] = i3 + i4;
  break;
 } while (0);
 if (i5 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) < (HEAP32[i8 + 28 + ((i5 + -1 | 0) * 20 | 0) + 12 >> 2] | 0)) return;
 i4 = HEAP32[i6 >> 2] | 0;
 do if (i4 >>> 0 > i5 >>> 0) if (!(i7 << 24 >> 24)) {
  if ((HEAP32[i1 + 12 >> 2] | 0) <= (HEAP32[i8 + 28 + (i5 * 20 | 0) + 12 >> 2] | 0)) break;
  return;
 } else {
  if ((HEAP32[i9 + 12 >> 2] | 0) <= (HEAP32[i8 + 28 + (i5 * 20 | 0) + 12 >> 2] | 0)) break;
  return;
 } while (0);
 i3 = i4 + (i7 & 255) | 0;
 i2 = i4 - i5 | 0;
 if (i3 >>> 0 > 191) return;
 if (i2 | 0) while (1) {
  i4 = i4 + -1 | 0;
  i2 = i2 + -1 | 0;
  i10 = i8 + 28 + (i3 * 20 | 0) | 0;
  i11 = i8 + 28 + (i4 * 20 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  if (!i2) break; else i3 = i3 + -1 | 0;
 }
 i11 = i8 + 28 + (i5 * 20 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 if (!(i7 << 24 >> 24)) return;
 i11 = i8 + 28 + ((i5 + 1 | 0) * 20 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZNK5physx17ConvexHullBuilder17ComputeGeomCenterERNS_6PxVec3E(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0, i29 = 0, i30 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 if (!(i7 | 0 ? (HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 38 >> 0] | 0) != 0 : 0)) {
  i11 = 0;
  return i11 | 0;
 }
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i9 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i8) {
  i1 = i9;
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  f5 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  i6 = 0;
  do {
   i30 = HEAP32[i1 + (i6 * 12 | 0) >> 2] | 0;
   i29 = HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2] | 0;
   i28 = HEAP32[i1 + (i6 * 12 | 0) + 8 >> 2] | 0;
   f17 = Math_fround(HEAPF32[i7 + (i30 * 12 | 0) >> 2]);
   f16 = Math_fround(HEAPF32[i7 + (i29 * 12 | 0) >> 2]);
   f26 = Math_fround(f17 - f16);
   f21 = Math_fround(HEAPF32[i7 + (i30 * 12 | 0) + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i7 + (i29 * 12 | 0) + 4 >> 2]);
   f24 = Math_fround(f21 - f20);
   f19 = Math_fround(HEAPF32[i7 + (i30 * 12 | 0) + 8 >> 2]);
   f18 = Math_fround(HEAPF32[i7 + (i29 * 12 | 0) + 8 >> 2]);
   f27 = Math_fround(f19 - f18);
   f15 = Math_fround(HEAPF32[i7 + (i28 * 12 | 0) >> 2]);
   f23 = Math_fround(f17 - f15);
   f14 = Math_fround(HEAPF32[i7 + (i28 * 12 | 0) + 4 >> 2]);
   f25 = Math_fround(f21 - f14);
   f13 = Math_fround(HEAPF32[i7 + (i28 * 12 | 0) + 8 >> 2]);
   f12 = Math_fround(f19 - f13);
   f22 = Math_fround(Math_fround(f24 * f12) - Math_fround(f27 * f25));
   f12 = Math_fround(Math_fround(f27 * f23) - Math_fround(f26 * f12));
   f23 = Math_fround(Math_fround(f26 * f25) - Math_fround(f24 * f23));
   f12 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f22 * f22) + Math_fround(f12 * f12))))) * Math_fround(.5));
   f14 = Math_fround(Math_fround(Math_fround(Math_fround(f21 + f20) + f14) * Math_fround(.333333343)) * f12);
   f13 = Math_fround(f12 * Math_fround(Math_fround(Math_fround(f19 + f18) + f13) * Math_fround(.333333343)));
   f5 = Math_fround(f5 + Math_fround(Math_fround(Math_fround(Math_fround(f17 + f16) + f15) * Math_fround(.333333343)) * f12));
   HEAPF32[i9 >> 2] = f5;
   f4 = Math_fround(f14 + f4);
   HEAPF32[i10 >> 2] = f4;
   f3 = Math_fround(f13 + f3);
   HEAPF32[i11 >> 2] = f3;
   f2 = Math_fround(f2 + f12);
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i8 >>> 0);
  i1 = i9;
 }
 f27 = Math_fround(Math_fround(1.0) / f2);
 HEAPF32[i1 >> 2] = Math_fround(f27 * f5);
 HEAPF32[i10 >> 2] = Math_fround(f27 * f4);
 HEAPF32[i11 >> 2] = Math_fround(f27 * f3);
 i30 = 1;
 return i30 | 0;
}

function __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_(i16, i4, i1) {
 i16 = i16 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = (HEAP32[i4 + 32 >> 2] | 0) + -1 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i1 = -2128831035; else {
  i3 = i7;
  i1 = -2128831035;
  do {
   i3 = i3 + 1 | 0;
   i1 = Math_imul(i2 & 255 ^ i1, 16777619) | 0;
   i2 = HEAP8[i3 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
 }
 i1 = i1 & i14;
 i10 = HEAP32[i4 + 20 >> 2] | 0;
 i11 = HEAP32[i4 + 28 >> 2] | 0;
 i2 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
 if ((i10 | 0) == (i2 | 0)) {
  HEAP32[i16 >> 2] = -1;
  i2 = i1;
  i1 = i16 + 4 | 0;
 } else {
  i12 = i4 + 8 | 0;
  i13 = i4 + 4 | 0;
  i8 = i4 + 12 | 0;
  i9 = (i10 | 0) != 0;
  L8 : do if (!i7) {
   i3 = -1;
   i6 = 0;
   i5 = i2;
   while (1) {
    i2 = (i5 | 0) != 0;
    if (i9 & i2) if (!(_strcmp(i10, i5) | 0)) {
     i2 = i1;
     break L8;
    }
    do if (!(HEAP8[i12 >> 0] | 0)) i15 = 29; else if (!(HEAP32[i13 >> 2] | 0)) i15 = 29; else {
     i4 = HEAP32[i8 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      if (!((i4 | 0) != 0 & i2)) {
       i15 = 29;
       break;
      }
      if (_strcmp(i4, i5) | 0) {
       i15 = 29;
       break;
      }
     }
     i3 = (i3 | 0) == -1 ? i1 : i3;
    } while (0);
    if ((i15 | 0) == 29) {
     i15 = 0;
     if (!i5) {
      i15 = 30;
      break L8;
     }
    }
    i6 = i6 + 1 | 0;
    i1 = i6 + i1 & i14;
    i5 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
    if ((i10 | 0) == (i5 | 0)) {
     i2 = i1;
     break;
    }
   }
  } else {
   i3 = -1;
   i6 = 0;
   i5 = i2;
   while (1) {
    i2 = (i5 | 0) != 0;
    if (i9 & i2) if (!(_strcmp(i10, i5) | 0)) {
     i2 = i1;
     break L8;
    }
    do if (!(HEAP8[i12 >> 0] | 0)) i15 = 14; else if (!(HEAP32[i13 >> 2] | 0)) i15 = 14; else {
     i4 = HEAP32[i8 >> 2] | 0;
     if ((i4 | 0) != (i5 | 0)) {
      if (!((i4 | 0) != 0 & i2)) {
       i15 = 14;
       break;
      }
      if (_strcmp(i4, i5) | 0) {
       i15 = 14;
       break;
      }
     }
     i3 = (i3 | 0) == -1 ? i1 : i3;
    } while (0);
    if ((i15 | 0) == 14) {
     i15 = 0;
     if ((i7 | 0) == (i5 | 0)) {
      i15 = 30;
      break L8;
     }
     if (i5) if (!(_strcmp(i7, i5) | 0)) {
      i15 = 30;
      break L8;
     }
    }
    i6 = i6 + 1 | 0;
    i1 = i6 + i1 & i14;
    i5 = HEAP32[i11 + (i1 << 3) >> 2] | 0;
    if ((i10 | 0) == (i5 | 0)) {
     i2 = i1;
     break;
    }
   }
  } while (0);
  if ((i15 | 0) == 30) {
   HEAP32[i16 >> 2] = i1;
   HEAP32[i16 + 4 >> 2] = -1;
   return;
  }
  HEAP32[i16 >> 2] = -1;
  i1 = i16 + 4 | 0;
  if ((i3 | 0) != -1) {
   HEAP32[i1 >> 2] = i3;
   return;
  }
 }
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ES2_RKNS_20PxVehicleAutoBoxDataES6_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i12, i1, i11, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 564 | 0;
 i6 = i9 + 512 | 0;
 i8 = i9 + 256 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i12 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i12 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i12 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i12 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i12 + 24 | 0;
 mftCall_vii(HEAP32[i11 + 16 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0);
 i14 = i12 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i3 = HEAP32[i12 + 28 >> 2] | 0;
 i4 = HEAP32[i12 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i6 >> 2] = i15;
 HEAP32[i6 + 4 >> 2] = i13;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i8;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i7;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i10, 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 1, i10 + 16 | 0, gb + 166432 | 0, i5);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i6, 2, i10 + 32 | 0, gb + 166432 | 0, i5);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i12 + 40 >> 2] >> 0] = 1;
 i15 = HEAP32[i1 >> 2] | 0;
 _memcpy(i5 | 0, i8 | 0, 256) | 0;
 mftCall_vii(HEAP32[i11 + 20 >> 2] | 0, i15 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN14BlendShapeDataaSERKS_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = (i9 | 0) == (i10 | 0);
 if (i8) return i10 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i10 + 12 | 0;
 i1 = (HEAP32[i9 + 12 >> 2] | 0) * 40 | 0;
 i2 = (i1 | 0) / 40 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  break;
 } else i1 = HEAP32[i10 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
 i2 = i10 + 20 | 0;
 i6 = HEAP32[i9 + 20 >> 2] | 0;
 i7 = i10 + 32 | 0;
 i1 = (HEAP32[i9 + 32 >> 2] | 0) * 12 | 0;
 i3 = (i1 | 0) / 12 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i10 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i10 + 40 | 0, HEAP32[i9 + 40 >> 2] | 0, HEAP32[i9 + 44 >> 2] | 0);
 i5 = i10 + 52 | 0;
 if (i8) return i10 | 0;
 i6 = HEAP32[i9 + 52 >> 2] | 0;
 i7 = i10 + 64 | 0;
 i1 = HEAP32[i9 + 64 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 i3 = i10 + 68 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i10 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 return i10 | 0;
}

function _ps_dimension_add_t1stem(i12, i2, i1, i14, i17) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18;
 if ((i1 | 0) < 0) {
  i16 = (i1 | 0) == -21;
  i1 = 0;
  i11 = i16 ? 3 : 1;
  i2 = (i16 ? -21 : 0) + i2 | 0;
 } else i11 = 0;
 i16 = (i17 | 0) != 0;
 if (i16) HEAP32[i17 >> 2] = -1;
 i6 = HEAP32[i12 >> 2] | 0;
 i10 = i12 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i9 = i4;
 i3 = i4;
 L7 : do if (!i6) {
  i5 = 0;
  i13 = 9;
 } else {
  i5 = 0;
  while (1) {
   if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i4 + 4 >> 2] | 0) == (i1 | 0)) {
    i7 = i5;
    break L7;
   }
   i5 = i5 + 1 | 0;
   if (i5 >>> 0 < i6 >>> 0) i4 = i4 + 12 | 0; else {
    i13 = 9;
    break;
   }
  }
 } while (0);
 if ((i13 | 0) == 9) {
  i8 = i6 + 1 | 0;
  i7 = i12 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i8 >>> 0 >= i4 >>> 0) {
   HEAP32[i15 >> 2] = 0;
   do if (i4 >>> 0 < i8 >>> 0) {
    i6 = i6 + 8 & -8;
    i3 = _UNITY_ft_mem_realloc(i14, 12, i4, i6, i9, i15) | 0;
    HEAP32[i10 >> 2] = i3;
    i4 = HEAP32[i15 >> 2] | 0;
    if (!i4) {
     HEAP32[i7 >> 2] = i6;
     break;
    }
    i17 = i4;
    STACKTOP = i18;
    return i17 | 0;
   } while (0);
  }
  i7 = i3 + (i8 * 12 | 0) + -12 | 0;
  HEAP32[i12 >> 2] = i8;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i11;
  i7 = i5;
 }
 i4 = i12 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i3 = i12 + 16 | 0;
  do if (!(HEAP32[i3 >> 2] | 0)) {
   HEAP32[i15 >> 2] = 0;
   i2 = i12 + 20 | 0;
   i1 = _UNITY_ft_mem_realloc(i14, 16, 0, 8, HEAP32[i2 >> 2] | 0, i15) | 0;
   HEAP32[i2 >> 2] = i1;
   i2 = HEAP32[i15 >> 2] | 0;
   if (!i2) {
    HEAP32[i3 >> 2] = 8;
    break;
   }
   i17 = i2;
   STACKTOP = i18;
   return i17 | 0;
  } else i1 = HEAP32[i12 + 20 >> 2] | 0; while (0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = 1;
  i13 = 24;
 } else {
  i1 = (HEAP32[i12 + 20 >> 2] | 0) + (i1 << 4) + -16 | 0;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 <= i7 >>> 0) i13 = 24;
 }
 if ((i13 | 0) == 24) {
  i5 = i7 + 1 | 0;
  i6 = i1 + 4 | 0;
  i3 = ((HEAP32[i6 >> 2] | 0) + 7 | 0) >>> 3;
  i2 = (i7 + 8 | 0) >>> 3;
  HEAP32[i15 >> 2] = 0;
  do if (i2 >>> 0 > i3 >>> 0) {
   i4 = i2 + 7 & 1073741816;
   i2 = i1 + 8 | 0;
   HEAP32[i2 >> 2] = _UNITY_ft_mem_realloc(i14, 1, i3, i4, HEAP32[i2 >> 2] | 0, i15) | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   if (!i2) {
    HEAP32[i6 >> 2] = i4 << 3;
    break;
   }
   i17 = i2;
   STACKTOP = i18;
   return i17 | 0;
  } while (0);
  HEAP32[i1 >> 2] = i5;
 }
 i15 = (HEAP32[i1 + 8 >> 2] | 0) + (i7 >>> 3) | 0;
 HEAP8[i15 >> 0] = HEAPU8[i15 >> 0] | 0 | 128 >>> (i7 & 7);
 if (!i16) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 HEAP32[i17 >> 2] = i7;
 i17 = 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN19MeshParticleEmitterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i4 + 8 | 0;
 i9 = i4;
 i11 = i2;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i10, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i10 = i1 + 144 | 0;
 i9 = i1 + 156 | 0;
 i8 = i1 + 168 | 0;
 i2 = i1 + 180 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = i1;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 205 >> 0] = 1;
 HEAP8[i1 + 204 >> 0] = 1;
 HEAP8[i1 + 206 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 HEAP8[i1 + 110 >> 0] = 0;
 HEAPF32[i1 + 116 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 120 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 124 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(50.0);
 HEAP8[i1 + 192 >> 0] = 1;
 HEAPF32[i1 + 140 >> 2] = Math_fround(.0500000007);
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 193 >> 0] = 0;
 HEAP8[i1 + 207 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i1 + 84 >> 2] = f7;
 HEAPF32[i1 + 88 >> 2] = f6;
 HEAPF32[i1 + 92 >> 2] = f5;
 HEAP32[i1 >> 2] = gb + 190616 + 8;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN18SharedMaterialDataC2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i1 = i6;
 HEAP32[i4 + 4 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 67612 + 8;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 1;
 HEAP32[i4 + 12 >> 2] = gb + 33952 + 8;
 i7 = gb + 63288 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i1);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i4 + 48 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63288 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i1);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i4 + 68 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63288 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i1);
 i1 = i5;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i4 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 i3 = gb + 63288 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 112 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP8[i4 + 120 >> 0] = 1;
 i1 = i4 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = i4 + 164 | 0;
 i2 = i4 + 124 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 >> 0] = HEAP8[i1 >> 0] & -4;
 HEAP32[i4 + 168 >> 2] = 0;
 i1 = i4 + 176 | 0;
 i3 = i4 + 180 | 0;
 HEAP32[i4 + 200 >> 2] = 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i8 = i5;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4 + 192 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i4 + 208 >> 2] = 0;
 HEAP32[i4 + 220 >> 2] = 0;
 HEAP32[i4 + 224 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 212 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i3 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 STACKTOP = i6;
 return;
}

function __ZN18CrashReportHandler17HandleLogCallbackEPS_RKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_ib(i9, i2, i4, i10, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 32 | 0;
 i6 = i8 + 16 | 0;
 i7 = i8;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i12 = i1 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i1 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i11 = 4;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i2;
  if (!i2) i1 = i6; else {
   i1 = i6;
   i11 = 6;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i12 = i2 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i2;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i12 = i1 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i4 >> 2] | 0 : i4;
 i4 = i12 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i11 = 10;
 } else if (i4 >>> 0 < 11) {
  i1 = i7 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i7; else {
   i2 = i7;
   i11 = 12;
  }
 } else i11 = 10;
 if ((i11 | 0) == 10) {
  i12 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i1 = i7 + 11 | 0;
  i11 = 12;
 }
 if ((i11 | 0) == 12) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN18CrashReportHandler9HandleLogERK8UnityStrS2_7LogType(i9, i6, i7, i10);
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i5);
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i12 = HEAP32[i6 >> 2] | 0;
 i11 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i5);
 STACKTOP = i8;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIjNS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i17, i3, i1) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 8 | 0;
 i13 = i16;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i17, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i16;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i14 = HEAP32[i1 >> 2] | 0;
 L4 : do if (HEAP32[i2 >> 2] | 0) {
  i12 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i17, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, 0, 0) | 0;
  i9 = i17 + 80 | 0;
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i9 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i11 = i17 + 84 | 0;
  HEAP32[HEAP32[i11 >> 2] >> 2] = 0;
  if ((i12 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i17);
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) == (i14 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferIjEEvRT_PKc17TransferMetaFlags(i17, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i14 | 0)) break L4;
   }
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i12 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  L11 : do if ((i1 | 0) != (i14 | 0)) {
   i4 = i17 + 16 | 0;
   i5 = i17 + 20 | 0;
   i6 = i17 + 32 | 0;
   i7 = i17 + 36 | 0;
   i8 = i17 + 24 | 0;
   i3 = 0;
   while (1) {
    i19 = (Math_imul(i3, i10) | 0) + i12 | 0;
    HEAP32[i2 + 20 >> 2] = i19;
    HEAP32[i2 + 12 >> 2] = i19;
    __ZNK16TypeTreeIterator8ChildrenEv(i13, i2);
    i19 = i13;
    i18 = HEAP32[i19 + 4 >> 2] | 0;
    i3 = i2 + 24 | 0;
    HEAP32[i3 >> 2] = HEAP32[i19 >> 2];
    HEAP32[i3 + 4 >> 2] = i18;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 >> 2] | 0, 0 - (HEAP32[i6 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i15 = 9; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) i15 = 9; else {
      HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i4 >> 2] = i3;
     }
    }
    if ((i15 | 0) == 9) {
     i15 = 0;
     __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 4);
    }
    if (HEAP32[i17 >> 2] & 512 | 0) HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i14 | 0)) break L11;
    i3 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i17);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i17);
 STACKTOP = i16;
 return;
}

function __Z52UnityWebRequest_CUSTOM_InternalGetResponseHeaderKeysP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i8 = i9 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 if (((HEAP32[i1 + 108 >> 2] | 0) + -3 | 0) >>> 0 >= 2) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i1 + 56 | 0;
 i2 = i1 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i1 + -16 >> 2] | 0;
 if ((i1 | 0) < 1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i7 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 i4 = __Znwj(i1 * 12 | 0) | 0;
 i10 = i4;
 i3 = i4 + (i1 * 12 | 0) | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i7 >> 2] = i10;
 HEAP32[i6 >> 2] = i3;
 i1 = HEAP32[i2 >> 2] | 0;
 L16 : do if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
  i2 = HEAP32[i1 + -24 >> 2] | 0;
  i5 = i1 + -20 | 0;
  if ((i2 | 0) != (i5 | 0)) while (1) {
   i1 = i2 + 16 | 0;
   if ((i4 | 0) == (i3 | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i8, i1); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 12;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break L16;
   i2 = i1;
   i4 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 i4 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 12 | 0) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i6 = i1 + (i3 * 12 | 0) | 0;
   i2 = HEAP8[i6 + 11 >> 0] | 0;
   i10 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i4, i3, __Z20scripting_string_newPKcj(i10 ? HEAP32[i6 >> 2] | 0 : i6, i10 ? HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 12 | 0) >>> 0);
 }
 i3 = i1;
 if (i1 | 0) {
  if ((i2 | 0) != (i3 | 0)) {
   do {
    i10 = i2 + -12 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
    i2 = HEAP32[i7 >> 2] | 0;
   } while ((i2 | 0) != (i3 | 0));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i10 = i4;
 STACKTOP = i9;
 return i10 | 0;
}

function __GLOBAL__sub_I_runtime_shaders_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 8 | 0;
 i3 = i1;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166268 | 0, gb + 476588 | 0, 0, 0);
 HEAP32[gb + 1166280 >> 2] = gb + 1166280;
 HEAP32[gb + 1166280 + 4 >> 2] = gb + 1166280;
 HEAP32[gb + 1166216 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166216 | 0, gb + 476605 | 0);
 HEAP32[gb + 1166220 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166220 | 0, gb + 476624 | 0);
 HEAP32[gb + 1166224 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166224 | 0, gb + 476653 | 0);
 HEAP32[gb + 1166228 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166228 | 0, gb + 476673 | 0);
 HEAP32[gb + 1166228 + 4 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166228 + 4 | 0, gb + 476692 | 0);
 HEAP32[gb + 1166236 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166236 | 0, gb + 476712 | 0);
 HEAP32[gb + 1166136 >> 2] = 0;
 i2 = gb + 63304 | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = gb + 1166136 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[gb + 1166136 + 12 >> 2] = 16;
 _strncpy(gb + 1166136 + 16 | 0, gb + 476730 | 0, 32) | 0;
 _strncpy(gb + 1166136 + 48 | 0, gb + 476743 | 0, 32) | 0;
 HEAP8[gb + 1166136 + 47 >> 0] = 0;
 HEAP8[gb + 1166136 + 79 >> 0] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3436 | 0, fb + 3437 | 0, 0, gb + 1166136 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166288 | 0, gb + 476757 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166300 | 0, gb + 476778 | 0, 0, 0);
 i6 = gb + 63280 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[gb + 1166312 >> 2] = 0;
 HEAP32[gb + 1166312 + 12 >> 2] = 0;
 HEAP32[gb + 1166312 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i2 = i4;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = gb + 1166312 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = gb + 63280 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[gb + 1166332 >> 2] = 0;
 HEAP32[gb + 1166332 + 12 >> 2] = 0;
 HEAP32[gb + 1166332 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = gb + 1166332 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546609 | 0, fb + 3438 | 0, fb + 3439 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166256 | 0, gb + 476803 | 0, 0, 0);
 STACKTOP = i1;
 return;
}

function __ZN5physx27InternalTriangleMeshBuilder13remapTopologyEPKj(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 2 | 0;
 i6 = i11 + 1 | 0;
 i9 = i11;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 3 | 0, i1 * 12 | 0, gb + 730919 | 0, 45) | 0;
 i1 = i2 + 12 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i2 = 0;
  do {
   i5 = i3 + (i2 * 12 | 0) | 0;
   i12 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i8 + (i2 << 2) >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = i3;
 i1 = HEAP32[i10 >> 2] | 0;
 if (HEAP32[i1 + 160 >> 2] | 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1 >>> 0 > 2147483647 ? -1 : i1 << 1;
  if (!i2) i4 = 0; else {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i12 | 0, i1 | 0, i2 | 0, (i4 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 53) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[i2 + 160 >> 2] | 0;
   i5 = 0;
   do {
    HEAP16[i4 + (i5 << 1) >> 1] = HEAP16[i3 + (HEAP32[i8 + (i5 << 2) >> 2] << 1) >> 1] | 0;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i1 >>> 0);
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i2 + 160 >> 2] | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 + 160 >> 2] = i4;
 }
 if (HEAP8[(HEAP32[i10 + 8 >> 2] | 0) + 12 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
 if (!i3) i5 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i5 = mftCall_iiiiii(i1 | 0, i2 | 0, i3 | 0, (i5 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 62) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i1 + 164 | 0;
 if (!i2) i1 = HEAP32[i1 >> 2] | 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = (i1 | 0) == 0;
  i4 = 0;
  do {
   i2 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
   if (!i3) i2 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
   HEAP32[i5 + (i4 << 2) >> 2] = i2;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i1);
 HEAP32[(HEAP32[i10 >> 2] | 0) + 164 >> 2] = i5;
 STACKTOP = i11;
 return;
}

function __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 f3 = Math_fround(HEAPF32[i11 >> 2]);
 f25 = Math_fround(f3 * Math_fround(10.0));
 f19 = Math_fround(HEAPF32[i12 >> 2]);
 f14 = Math_fround(Math_fround(f19 - f3) / f25);
 i23 = f14 >= Math_fround(0.0);
 f17 = Math_fround(f14 + Math_fround(-.99999994));
 i23 = ~~(i23 ? f14 : f17);
 f17 = Math_fround(Math_fround(f3 + f19) / f25);
 i13 = f17 >= Math_fround(0.0);
 f14 = Math_fround(f17 + Math_fround(-.99999994));
 i13 = ~~(i13 ? f17 : f14);
 f14 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f17 = Math_fround(Math_fround(f14 - f3) / f25);
 i15 = f17 >= Math_fround(0.0);
 f26 = Math_fround(f17 + Math_fround(-.99999994));
 i15 = ~~(i15 ? f17 : f26);
 f26 = Math_fround(Math_fround(f3 + f14) / f25);
 i16 = f26 >= Math_fround(0.0);
 f17 = Math_fround(f26 + Math_fround(-.99999994));
 i16 = ~~(i16 ? f26 : f17);
 f17 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f26 = Math_fround(Math_fround(f17 - f3) / f25);
 i1 = f26 >= Math_fround(0.0);
 f24 = Math_fround(f26 + Math_fround(-.99999994));
 i1 = ~~(i1 ? f26 : f24);
 f25 = Math_fround(Math_fround(f3 + f17) / f25);
 i18 = f25 >= Math_fround(0.0);
 f24 = Math_fround(f25 + Math_fround(-.99999994));
 i18 = ~~(i18 ? f25 : f24);
 if ((i1 | 0) <= (i18 | 0)) {
  i20 = HEAP32[i11 + 4 >> 2] | 0;
  i21 = (i23 | 0) > (i13 | 0);
  i22 = i11 + 8 | 0;
  if ((i15 | 0) <= (i16 | 0)) {
   i2 = -1;
   f3 = Math_fround(f3 * f3);
   while (1) {
    i10 = Math_imul(i1, -887442657) | 0;
    if (!i21) {
     i9 = i15;
     while (1) {
      i8 = (Math_imul(i9, -669632447) | 0) + i10 | 0;
      i7 = i23;
      while (1) {
       i4 = HEAP32[i11 + 28 + ((i8 + (Math_imul(i7, -1918454973) | 0) & 63) << 2) >> 2] | 0;
       if ((i4 | 0) != -1) {
        i5 = HEAP32[i20 >> 2] | 0;
        i6 = HEAP32[i22 >> 2] | 0;
        do {
         f24 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) >> 2]) - f19);
         f25 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 4 >> 2]) - f14);
         f26 = Math_fround(Math_fround(HEAPF32[i5 + (i4 * 12 | 0) + 8 >> 2]) - f17);
         f26 = Math_fround(Math_fround(Math_fround(f24 * f24) + Math_fround(f25 * f25)) + Math_fround(f26 * f26));
         i27 = f26 < f3;
         f3 = i27 ? f26 : f3;
         i2 = i27 ? i4 : i2;
         i4 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
        } while ((i4 | 0) != -1);
       }
       if ((i7 | 0) < (i13 | 0)) i7 = i7 + 1 | 0; else break;
      }
      if ((i9 | 0) < (i16 | 0)) i9 = i9 + 1 | 0; else break;
     }
    }
    if ((i1 | 0) < (i18 | 0)) i1 = i1 + 1 | 0; else break;
   }
   if ((i2 | 0) != -1) {
    i27 = i2;
    return i27 | 0;
   }
  }
 }
 i27 = __ZN12VertexWelderILi64EE4PushERK8Vector3f(i11, i12) | 0;
 return i27 | 0;
}

function __ZN5physx27PxParticleBaseGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 HEAP32[i1 + 120 >> 2] = gb + 741403;
 HEAP32[i1 + 124 >> 2] = 170;
 HEAP32[i1 + 128 >> 2] = fb + 463;
 HEAP32[i1 + 132 >> 2] = fb + 398;
 HEAP32[i1 + 136 >> 2] = gb + 675083;
 HEAP32[i1 + 140 >> 2] = 171;
 HEAP32[i1 + 144 >> 2] = fb + 3575;
 HEAP32[i1 + 148 >> 2] = fb + 3576;
 HEAP32[i1 + 152 >> 2] = gb + 743183;
 HEAP32[i1 + 156 >> 2] = 172;
 HEAP32[i1 + 160 >> 2] = fb + 464;
 HEAP32[i1 + 164 >> 2] = fb + 399;
 HEAP32[i1 + 168 >> 2] = gb + 741375;
 HEAP32[i1 + 172 >> 2] = 173;
 HEAP32[i1 + 176 >> 2] = fb + 465;
 HEAP32[i1 + 180 >> 2] = fb + 400;
 HEAP32[i1 + 184 >> 2] = gb + 672693;
 HEAP32[i1 + 188 >> 2] = 174;
 HEAP32[i1 + 192 >> 2] = fb + 466;
 HEAP32[i1 + 196 >> 2] = fb + 401;
 HEAP32[i1 + 200 >> 2] = gb + 672709;
 HEAP32[i1 + 204 >> 2] = 175;
 HEAP32[i1 + 208 >> 2] = fb + 467;
 HEAP32[i1 + 212 >> 2] = fb + 402;
 HEAP32[i1 + 216 >> 2] = gb + 672848;
 HEAP32[i1 + 220 >> 2] = 176;
 HEAP32[i1 + 224 >> 2] = fb + 3577;
 HEAP32[i1 + 228 >> 2] = fb + 3578;
 HEAP32[i1 + 232 >> 2] = gb + 743242;
 HEAP32[i1 + 236 >> 2] = 177;
 HEAP32[i1 + 240 >> 2] = fb + 2176;
 HEAP32[i1 + 244 >> 2] = gb + 743229;
 HEAP32[i1 + 248 >> 2] = 178;
 HEAP32[i1 + 252 >> 2] = fb + 2177;
 HEAP32[i1 + 256 >> 2] = gb + 743196;
 HEAP32[i1 + 260 >> 2] = 179;
 HEAP32[i1 + 264 >> 2] = fb + 468;
 HEAP32[i1 + 268 >> 2] = fb + 403;
 HEAP32[i1 + 272 >> 2] = gb + 672909;
 HEAP32[i1 + 276 >> 2] = 180;
 HEAP32[i1 + 280 >> 2] = fb + 469;
 HEAP32[i1 + 284 >> 2] = fb + 404;
 HEAP32[i1 + 288 >> 2] = gb + 672895;
 HEAP32[i1 + 292 >> 2] = 181;
 HEAP32[i1 + 296 >> 2] = fb + 470;
 HEAP32[i1 + 300 >> 2] = fb + 405;
 HEAP32[i1 + 304 >> 2] = gb + 743214;
 HEAP32[i1 + 308 >> 2] = 182;
 HEAP32[i1 + 312 >> 2] = fb + 471;
 HEAP32[i1 + 316 >> 2] = fb + 406;
 HEAP32[i1 + 320 >> 2] = gb + 743260;
 HEAP32[i1 + 324 >> 2] = 183;
 HEAP32[i1 + 328 >> 2] = fb + 2178;
 __ZN5physx23ProjectionPlanePropertyC2Ev(i1 + 332 | 0);
 return;
}

function __ZN17CollisionMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_R4Mesh(i1, i15, i2) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 8 | 0;
 i2 = i14;
 i8 = i14 + 36 | 0;
 i11 = i14 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i2);
 i5 = i4;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i10 = i7;
 HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i2);
 i2 = i4;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i10;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 i12 = i15 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i13 = i15 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i12 >> 2] = i2;
  i1 = 0;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i1 + i2 | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i15);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i4, 4);
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + i5 | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i15);
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
  HEAP32[i11 >> 2] = 0;
 }
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __Z23TransferScriptingObjectI17RemapPPtrTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 7) if ((HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0) == 1) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 263;
  __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i16, i1, i15, i3, i14) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17 + 16 | 0;
 i13 = i17;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i16, HEAP32[i15 >> 2] | 0);
 HEAP32[i12 >> 2] = 433;
 i1 = HEAP32[i16 + 48 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = i16;
  i2 = HEAP32[i16 >> 2] | 0;
 } else {
  i10 = i13 + 4 | 0;
  i11 = i13 + 8 | 0;
  i7 = i13 + 12 | 0;
  i8 = i16 + 36 | 0;
  i9 = i16 + 20 | 0;
  i6 = i2;
  while (1) {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i16, i1);
   HEAP32[i11 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 >> 2] = i15;
   HEAP8[i13 >> 0] = 1;
   HEAP32[i10 >> 2] = i6 + 276;
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj433ES2_NS_9PxD6Drive4EnumENS_14PxD6JointDriveEEEKNS_27PxD6JointDriveGeneratedInfoEEEvPjRKT_RT0_(i16, i12, i13, i14);
   i2 = HEAP32[i16 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i8 >> 0] = 1; else {
    i4 = i1 + -1 | 0;
    i5 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i5 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i5 + (i4 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i9 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i16 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i2 = HEAP32[i16 >> 2] | 0;
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP8[i8 >> 0] = 1;
    if (i1) if (!(HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i8 >> 0] = 0;
   }
   i3 = i3 + 8 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i5 = i16;
    break;
   } else i6 = i6 + 16 | 0;
  }
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i16 + 36 >> 0] = 1;
  STACKTOP = i17;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i16 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i16 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i17;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i17;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i17;
 return;
}

function __ZN14Texture2DArray13UploadTextureEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i9 = i16 + 4 | 0;
 i15 = i16;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 482 >> 0] | 0)) {
  STACKTOP = i16;
  return;
 }
 i1 = i14 + 96 | 0;
 i2 = i14 + 104 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i10 = __Z12GetGfxDevicev() | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 456 >> 2] | 0;
 i13 = i14 + 48 | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 i8 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i14 + 80 >> 2] | 0;
 i3 = HEAP32[i14 + 84 >> 2] | 0;
 i4 = HEAP32[i14 + 88 >> 2] | 0;
 i5 = HEAP32[i14 + 92 >> 2] | 0;
 i6 = HEAP32[i14 + 76 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i7 = HEAP32[i14 + 60 >> 2] | 0; else i7 = 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 mftCall_viiiiiiiiiii(i11 | 0, i10 | 0, i12 | 0, i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, 0, i7 | 0);
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = i14;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i12 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 14;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 13;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 9) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 13) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 14) {
   HEAP32[i12 >> 2] = i1;
   i4 = i1;
   i3 = i12;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i11 = i7 + 8 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 92 >> 2] | 0, i14 | 0);
 i11 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 680 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 i13 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 36 >> 2] | 0, i14 | 0) | 0;
 HEAP32[i12 >> 2] = HEAP32[i15 >> 2];
 mftCall_viii(i10 | 0, i11 | 0, i12 | 0, i13 | 0);
 HEAP8[i14 + 108 >> 0] = 1;
 STACKTOP = i16;
 return;
}

function __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 296 | 0;
 i9 = i10;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 32 >> 2] = Math_fround(1.0);
 i1 = i9 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 52 >> 2] = Math_fround(1.0);
 i1 = i9 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 72 >> 2] = Math_fround(1.0);
 i1 = i9 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 i1 = i9 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 112 >> 2] = Math_fround(1.0);
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 132 >> 2] = Math_fround(1.0);
 i1 = i9 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 152 >> 2] = Math_fround(1.0);
 i1 = i9 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i9 + 172 >> 2] = Math_fround(1.0);
 i1 = i9 + 176 | 0;
 i2 = i9 + 249 | 0;
 i3 = i1;
 i4 = i3 + 72 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i9 + 292 | 0;
 i3 = i9 + 252 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i9 + 293 >> 0] = 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i6 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i7 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 __ZN8GUIStyleaSERKS_(i9, HEAP32[i1 + 8 >> 2] | 0) | 0;
 __ZN8GUIStyle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i2);
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 STACKTOP = i10;
 return;
}

function __ZN9dtNavMesh33unconnectOffMeshConnectionsToTileEPK10dtMeshTile(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i1 = HEAP32[i8 + 52 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i10 = i8 + 48 | 0;
 i11 = i8 + 16 | 0;
 i12 = i8 + 20 | 0;
 i13 = i8 + 36 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 do {
  i6 = i5 + (i1 * 104 | 0) + 88 | 0;
  i7 = i5 + (i1 * 104 | 0) + 92 | 0;
  i3 = i5 + (i1 * 104 | 0) + 24 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
   i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
   getTempRet0() | 0;
   i4 = i4 & 268435455;
   if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    i3 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
    getTempRet0() | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    i2 = (HEAP32[i2 + (i4 * 56 | 0) + 4 >> 2] | 0) == (i3 | 0) ? i2 + (i4 * 56 | 0) | 0 : 0;
   } else i2 = 0;
   if ((i2 | 0) == (i9 | 0)) {
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) != -1) do {
     i4 = HEAP32[i13 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i4 + (i2 << 4) + 8 >> 2] | 0;
     if (!(HEAP8[i4 + (i3 << 4) + 12 >> 0] | 0)) {
      i15 = _bitshift64Shl(HEAP32[i7 >> 2] | 0, 0, 48) | 0;
      i14 = getTempRet0() | 0;
      i15 = i1 | i15 | 65536;
      i4 = i4 + (i3 << 4) | 0;
      __ZN9dtNavMesh17removeLinkBetweenEyy(i8, i15, i14, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
      i4 = (HEAP32[i13 >> 2] | 0) + (i3 << 4) | 0;
      __ZN9dtNavMesh17removeLinkBetweenEyy(i8, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i15, i14);
     }
    } while ((i2 | 0) != -1);
   }
  }
  i3 = i5 + (i1 * 104 | 0) + 56 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
   i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
   getTempRet0() | 0;
   i4 = i4 & 268435455;
   if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    i15 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
    getTempRet0() | 0;
    i2 = HEAP32[i12 >> 2] | 0;
    i2 = (HEAP32[i2 + (i4 * 56 | 0) + 4 >> 2] | 0) == (i15 | 0) ? i2 + (i4 * 56 | 0) | 0 : 0;
   } else i2 = 0;
   if ((i2 | 0) == (i9 | 0)) {
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) != -1) do {
     i4 = HEAP32[i13 >> 2] | 0;
     i3 = i2;
     i2 = HEAP32[i4 + (i2 << 4) + 8 >> 2] | 0;
     if ((HEAP8[i4 + (i3 << 4) + 12 >> 0] | 0) == 1) {
      i14 = _bitshift64Shl(HEAP32[i7 >> 2] | 0, 0, 48) | 0;
      i15 = getTempRet0() | 0;
      i14 = i1 | i14 | 65536;
      i6 = i4 + (i3 << 4) | 0;
      __ZN9dtNavMesh17removeLinkBetweenEyy(i8, i14, i15, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0);
      i6 = (HEAP32[i13 >> 2] | 0) + (i3 << 4) | 0;
      __ZN9dtNavMesh17removeLinkBetweenEyy(i8, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i14, i15);
     }
    } while ((i2 | 0) != -1);
   }
  }
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i5 + (i1 * 104 | 0) + 96 >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN5physx29PxPrismaticJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 742325;
 HEAP32[i1 + 240 >> 2] = 456;
 HEAP32[i1 + 244 >> 2] = fb + 439;
 HEAP32[i1 + 248 >> 2] = gb + 742194;
 HEAP32[i1 + 252 >> 2] = 457;
 HEAP32[i1 + 256 >> 2] = fb + 440;
 HEAP32[i1 + 260 >> 2] = gb + 906575;
 HEAP32[i1 + 264 >> 2] = 458;
 HEAP32[i1 + 268 >> 2] = fb + 3562;
 HEAP32[i1 + 272 >> 2] = fb + 3563;
 HEAP32[i1 + 276 >> 2] = gb + 742334;
 HEAP32[i1 + 280 >> 2] = 459;
 HEAP32[i1 + 284 >> 2] = fb + 2168;
 HEAP32[i1 + 288 >> 2] = fb + 3564;
 HEAP32[i1 + 292 >> 2] = gb + 741652;
 HEAP32[i1 + 296 >> 2] = 460;
 HEAP32[i1 + 300 >> 2] = fb + 441;
 HEAP32[i1 + 304 >> 2] = fb + 380;
 HEAP32[i1 + 308 >> 2] = gb + 742267;
 HEAP32[i1 + 312 >> 2] = 461;
 HEAP32[i1 + 316 >> 2] = fb + 442;
 HEAP32[i1 + 320 >> 2] = fb + 381;
 HEAP32[i1 + 324 >> 2] = gb + 831985;
 HEAP32[i1 + 328 >> 2] = 462;
 HEAP32[i1 + 332 >> 2] = fb + 2169;
 return;
}

function __Z14GetBuiltinSkini(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[gb + 1468304 >> 2] | 0;
 do if (!i1) i7 = 10; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468304 >> 2] | 0) | 0)) i7 = 10;
 } while (0);
 if ((i7 | 0) == 10) {
  i1 = __Z25GetBuiltinResourceManagerv() | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1018575 | 0, 25);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, gb + 27592 | 0, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[gb + 1468304 >> 2] = i1;
 }
 i4 = gb + 1468304 + (i4 << 2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 19; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 19; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 21;
  }
 }
 if ((i7 | 0) == 19) i7 = 21;
 if ((i7 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i9 = i1;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 8 | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i5) HEAP32[i1 >> 2] = 0; else {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = i5 << 3;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i5 << 3) | 0)) _memset(i3 | 0, -1, i2 | 0) | 0;
  HEAP32[i1 >> 2] = i3 | 0 ? i3 - i1 | 0 : 0;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i4 >> 2] >> 2] << 3) | 0;
 do if (HEAP32[i6 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906602 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L15 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN7mecanim8skeleton4Node8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L15;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 906602 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim8skeleton4Node8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN6ShaderC2E10MemLabelId18ObjectCreationMode(i8, i1, i5) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 i3 = i1;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i8, i6, i5);
 HEAP32[i8 >> 2] = gb + 67676 + 8;
 i7 = i8 + 44 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i8 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 72 >> 2] = 0;
 HEAP32[i8 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i8 + 64 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i8 + 80 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP8[i9 + 12 >> 0] = 0;
 if (!(HEAP32[gb + 1166244 >> 2] | 0)) {
  i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1166404 >> 2] | 0, 0, 0) | 0;
  __ZN9ShaderLab13InitShaderLabEv();
  if (i9) __Z19pop_allocation_rootv();
 }
 i6 = i8 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 1166244 >> 2];
 i9 = i8 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i8 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP8[i8 + 93 >> 0] = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(88, gb + 63280 | 0, 16, gb + 470432 | 0, 115) | 0;
 i2 = i1 + 24 | 0;
 i3 = i1;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i4 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i1 + 56 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i1 + 72 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i8 + 96 >> 2] = i1;
 if ((i5 | 0) == 1) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 } else {
  __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i1, i8);
  i1 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i6 >> 2] | 0, i7) | 0;
 }
 HEAP32[i9 >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd12ellipseClampERKNS_6PxVec3ES3_(i18, i19, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f16 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f2 = Math_fround(Math_abs(Math_fround(f16)));
 f17 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f17)));
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f11 >= f12)) {
  if (f2 < Math_fround(9.99999997e-07)) {
   i19 = f17 > Math_fround(0.0);
   f17 = Math_fround(-f12);
   HEAPF32[i18 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i18 + 8 >> 2] = i19 ? f12 : f17;
   return;
  }
 } else if (f3 < Math_fround(9.99999997e-07)) {
  i19 = f16 > Math_fround(0.0);
  f17 = Math_fround(-f11);
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  HEAPF32[i18 + 4 >> 2] = i19 ? f11 : f17;
  HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
  return;
 }
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f5 * f5);
 f14 = Math_fround(f11 * f11);
 f15 = Math_fround(f12 * f12);
 f5 = Math_fround(f5 * Math_fround(0.0));
 f10 = Math_fround(f2 * f11);
 f4 = Math_fround(f3 * f12);
 f8 = Math_fround(f10 - f14);
 f9 = Math_fround(f4 - f15);
 f5 = Math_fround(f5 * Math_fround(0.0));
 f5 = Math_fround(Math_fround(f5 * f5) * Math_fround(0.0));
 i1 = 0;
 f9 = f8 > f9 ? f8 : f9;
 while (1) {
  f3 = Math_fround(Math_fround(1.0) / Math_fround(f14 + f9));
  f2 = Math_fround(Math_fround(1.0) / Math_fround(f15 + f9));
  f6 = Math_fround(f10 * f3);
  f7 = Math_fround(f4 * f2);
  f6 = Math_fround(f6 * f6);
  f7 = Math_fround(f7 * f7);
  f8 = Math_fround(Math_fround(f6 + f7) + Math_fround(-1.0));
  if (f8 < Math_fround(.0000999999974)) {
   i1 = 8;
   break;
  }
  f9 = Math_fround(f9 - Math_fround(f8 / Math_fround(Math_fround(Math_fround(f5 + Math_fround(f3 * f6)) + Math_fround(f2 * f7)) * Math_fround(-2.0))));
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= 20) {
   i1 = 10;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  f16 = Math_fround(f3 * Math_fround(f14 * f16));
  f17 = Math_fround(f2 * Math_fround(f15 * f17));
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2])) * Math_fround(0.0));
  HEAPF32[i18 + 4 >> 2] = f16;
  HEAPF32[i18 + 8 >> 2] = f17;
  return;
 } else if ((i1 | 0) == 10) {
  f16 = Math_fround(f3 * Math_fround(f14 * f16));
  f17 = Math_fround(f2 * Math_fround(f15 * f17));
  f14 = Math_fround(f16 / f11);
  f15 = Math_fround(f17 / f12);
  f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(f15 * f15)))));
  f16 = Math_fround(f16 * f15);
  f17 = Math_fround(f17 * f15);
  HEAPF32[i18 >> 2] = Math_fround(Math_fround(Math_fround(f13 * Math_fround(HEAPF32[i19 >> 2])) * Math_fround(0.0)) * f15);
  HEAPF32[i18 + 4 >> 2] = f16;
  HEAPF32[i18 + 8 >> 2] = f17;
  return;
 }
}

function __ZN16Physics2DManager31DestroyColliderIgnoreCollisionsEP10Collider2D(i9, i18) {
 i9 = i9 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i19 = i9 + 40 | 0;
 i10 = HEAP32[i19 >> 2] | 0;
 i20 = i9 + 44 | 0;
 i17 = HEAP32[i20 >> 2] | 0;
 i21 = i10 + (i17 * 12 | 0) | 0;
 L1 : do if (!i17) i1 = i10; else {
  i8 = HEAP32[i9 + 28 >> 2] | 0;
  i2 = i9 + 32 | 0;
  i3 = i9 + 8 | 0;
  i4 = i9 + 16 | 0;
  i5 = i9 + 20 | 0;
  i6 = i9 + 12 | 0;
  i1 = i10;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   if ((i8 | 0) == (i7 | 0)) {
    if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i22 = 5;
   } else i22 = 5;
   if ((i22 | 0) == 5) {
    i22 = 0;
    if (!(HEAP8[i6 >> 0] | 0)) break L1;
    if (!(HEAP32[i3 >> 2] | 0)) break L1;
    if ((HEAP32[i4 >> 2] | 0) != (i7 | 0)) break L1;
    if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L1;
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i21 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i21 | 0)) return;
 i11 = i9 + 12 | 0;
 i8 = i9 + 8 | 0;
 i12 = i9 + 16 | 0;
 i13 = i9 + 60 | 0;
 i14 = i9 + 16 | 0;
 i15 = i9 + 20 | 0;
 i16 = i9 + 28 | 0;
 i7 = i9 + 32 | 0;
 i6 = i10;
 i5 = i17;
 while (1) {
  i2 = i1 + 12 | 0;
  L20 : do if ((i2 | 0) == (i21 | 0)) i2 = i21; else {
   i4 = HEAP32[i16 >> 2] | 0;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i4 | 0) == (i3 | 0)) {
     if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) i22 = 17;
    } else i22 = 17;
    if ((i22 | 0) == 17) {
     i22 = 0;
     if (!(HEAP8[i11 >> 0] | 0)) break L20;
     if (!(HEAP32[i8 >> 2] | 0)) break L20;
     if ((HEAP32[i14 >> 2] | 0) != (i3 | 0)) break L20;
     if ((HEAP32[i15 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) break L20;
    }
    i2 = i2 + 12 | 0;
    if ((i2 | 0) == (i21 | 0)) {
     i2 = i21;
     break;
    }
   }
  } while (0);
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) == (i18 | 0)) i22 = 24; else if ((HEAP32[i1 + 4 >> 2] | 0) == (i18 | 0)) i22 = 24;
  do if ((i22 | 0) == 24) {
   i22 = 0;
   if ((i1 | 0) != (i6 + (i5 * 12 | 0) | 0)) {
    if (!(HEAP8[i11 >> 0] | 0)) i22 = 28; else if (!(HEAP32[i8 >> 2] | 0)) i22 = 28; else if ((HEAP32[i14 >> 2] | 0) == (i3 | 0)) {
     i17 = (HEAP32[i15 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
     HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
     if (i17) break;
    } else i22 = 28;
    if ((i22 | 0) == 28) {
     i22 = 0;
     HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    }
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    HEAP8[i13 >> 0] = 1;
   }
  } while (0);
  i6 = HEAP32[i19 >> 2] | 0;
  i5 = HEAP32[i20 >> 2] | 0;
  if ((i2 | 0) == (i6 + (i5 * 12 | 0) | 0)) break; else i1 = i2;
 }
 return;
}

function __Z34NavMesh_CUSTOM_TriangulateInternalv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10;
 i1 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 i9 = i1 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i3 = i14;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i6;
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i15 + 4 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = 0;
 i15 = i1 + 32 | 0;
 HEAP32[i15 >> 2] = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i5 = i14;
 i11 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i11;
 HEAP32[i1 + 40 >> 2] = 0;
 i8 = i1 + 52 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = i1 + 56 | 0;
 HEAP32[i11 >> 2] = 0;
 i5 = i1 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i12 = HEAP32[i14 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i7 + 4 >> 2] = i12;
 __ZNK14NavMeshManager11TriangulateERNS_13TriangulationE(__Z17GetNavMeshManagerv() | 0, i1);
 i7 = i1 + 40 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i14 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
 i8 = (i12 | 0) == 0 ? 0 : i8;
 i14 = __Z19scripting_array_newP11Il2CppClassjj(i14, 12, i8) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i14, 0, 12) | 0, i12 | 0, i8 * 12 | 0) | 0;
 i8 = i1 + 20 | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i13 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i15 = (i12 | 0) == 0 ? 0 : i15;
 i13 = __Z19scripting_array_newP11Il2CppClassjj(i13, 4, i15) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i13, 0, 4) | 0, i12 | 0, i15 << 2 | 0) | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i12 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i9 = (i15 | 0) == 0 ? 0 : i9;
 i12 = __Z19scripting_array_newP11Il2CppClassjj(i12, 4, i9) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i12, 0, 4) | 0, i15 | 0, i9 << 2 | 0) | 0;
 i9 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z21GetAIScriptingClassesv() | 0) >> 2] | 0) | 0;
 HEAP32[i9 + 8 >> 2] = i14;
 HEAP32[i9 + 12 >> 2] = i13;
 HEAP32[i9 + 16 >> 2] = i12;
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i5);
  HEAP32[i7 >> 2] = 0;
 }
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i3);
  HEAP32[i8 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i9 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z21ApplyDirectionalForceR23ParticleSystemParticlesjjRK8Vector3fS3_RKN4math7_float4E(i5, i12, i13, i1, i2, i14) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, i25 = 0, f26 = f0, i27 = 0, f28 = f0, i29 = 0, f30 = f0, i31 = 0, f32 = f0, i33 = 0, f34 = f0, i35 = 0, f36 = f0, f37 = f0, f38 = f0, f39 = f0, f40 = f0, f41 = f0, f42 = f0, f43 = f0, f44 = f0, f45 = f0, f46 = f0, f47 = f0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 if (i12 >>> 0 >= i13 >>> 0) return;
 i9 = i14 + 4 | 0;
 i6 = i14 + 8 | 0;
 i7 = i14 + 12 | 0;
 i8 = HEAP32[i5 + 60 >> 2] | 0;
 i3 = HEAP32[i5 + 80 >> 2] | 0;
 i2 = HEAP32[i5 + 100 >> 2] | 0;
 i1 = i12;
 do {
  f40 = Math_fround(HEAPF32[i14 >> 2]);
  f37 = Math_fround(f11 * f40);
  f39 = Math_fround(HEAPF32[i9 >> 2]);
  f47 = Math_fround(f11 * f39);
  f38 = Math_fround(HEAPF32[i6 >> 2]);
  f46 = Math_fround(f11 * f38);
  f15 = Math_fround(HEAPF32[i7 >> 2]);
  f45 = Math_fround(f11 * f15);
  f44 = Math_fround(f10 * f40);
  f43 = Math_fround(f10 * f39);
  f42 = Math_fround(f10 * f38);
  f41 = Math_fround(f10 * f15);
  f40 = Math_fround(f4 * f40);
  f39 = Math_fround(f4 * f39);
  f38 = Math_fround(f4 * f38);
  f15 = Math_fround(f4 * f15);
  i35 = i8 + (i1 << 2) | 0;
  f36 = Math_fround(HEAPF32[i35 >> 2]);
  i33 = i35 + 4 | 0;
  f34 = Math_fround(HEAPF32[i33 >> 2]);
  i31 = i35 + 8 | 0;
  f32 = Math_fround(HEAPF32[i31 >> 2]);
  i29 = i35 + 12 | 0;
  f30 = Math_fround(HEAPF32[i29 >> 2]);
  i27 = i3 + (i1 << 2) | 0;
  f28 = Math_fround(HEAPF32[i27 >> 2]);
  i25 = i27 + 4 | 0;
  f26 = Math_fround(HEAPF32[i25 >> 2]);
  i23 = i27 + 8 | 0;
  f24 = Math_fround(HEAPF32[i23 >> 2]);
  i21 = i27 + 12 | 0;
  f22 = Math_fround(HEAPF32[i21 >> 2]);
  i19 = i2 + (i1 << 2) | 0;
  f20 = Math_fround(HEAPF32[i19 >> 2]);
  i17 = i19 + 4 | 0;
  f18 = Math_fround(HEAPF32[i17 >> 2]);
  i5 = i19 + 8 | 0;
  f16 = Math_fround(HEAPF32[i5 >> 2]);
  i12 = i19 + 12 | 0;
  f34 = Math_fround(f47 + f34);
  f32 = Math_fround(f46 + f32);
  f30 = Math_fround(f45 + f30);
  f28 = Math_fround(f44 + f28);
  f26 = Math_fround(f43 + f26);
  f24 = Math_fround(f42 + f24);
  f22 = Math_fround(f41 + f22);
  f20 = Math_fround(f40 + f20);
  f18 = Math_fround(f39 + f18);
  f16 = Math_fround(f38 + f16);
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i12 >> 2]));
  HEAPF32[i35 >> 2] = Math_fround(f37 + f36);
  HEAPF32[i33 >> 2] = f34;
  HEAPF32[i31 >> 2] = f32;
  HEAPF32[i29 >> 2] = f30;
  HEAPF32[i27 >> 2] = f28;
  HEAPF32[i25 >> 2] = f26;
  HEAPF32[i23 >> 2] = f24;
  HEAPF32[i21 >> 2] = f22;
  HEAPF32[i19 >> 2] = f20;
  HEAPF32[i17 >> 2] = f18;
  HEAPF32[i5 >> 2] = f16;
  HEAPF32[i12 >> 2] = f15;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i13 >>> 0);
 return;
}

function _UNITY_FT_Glyph_Stroke(i14, i13, i15) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16;
 if (!i14) {
  i15 = 6;
  STACKTOP = i16;
  return i15 | 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if (!i2) {
  i15 = 6;
  STACKTOP = i16;
  return i15 | 0;
 }
 if ((HEAP32[i2 + 4 >> 2] | 0) != ((HEAP32[(HEAP32[i13 + 128 >> 2] | 0) + 188 >> 2] | 0) + 4 | 0)) {
  i15 = 6;
  STACKTOP = i16;
  return i15 | 0;
 }
 i3 = _UNITY_FT_Glyph_Copy(i2, i1) | 0;
 i10 = (i3 | 0) == 0;
 i11 = i10 ? HEAP32[i1 >> 2] | 0 : i2;
 if (!i10) {
  i15 = i3;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i11 + 20 | 0;
 i1 = _UNITY_FT_Stroker_ParseOutline(i13, i10, 0) | 0;
 if (!i1) {
  i1 = HEAP32[i13 + 64 >> 2] | 0;
  L15 : do if (!i1) {
   i2 = 0;
   i1 = 0;
   i12 = 13;
  } else {
   i7 = HEAP32[i13 + 76 >> 2] | 0;
   i5 = i1;
   i2 = 0;
   i1 = 0;
   i3 = 0;
   while (1) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = (i3 | 0) == 0;
    if (!(i6 & 4)) {
     if (i4) {
      i1 = 0;
      i2 = 0;
      break L15;
     }
    } else if (i4) i3 = 1; else {
     i1 = 0;
     i2 = 0;
     break L15;
    }
    i9 = i6 & 8;
    i2 = ((i9 & 255) >>> 3 & 255) + i2 | 0;
    i3 = i9 << 24 >> 24 == 0 ? i3 : 0;
    i5 = i5 + -1 | 0;
    i1 = i1 + 1 | 0;
    if (!i5) break; else i7 = i7 + 1 | 0;
   }
   if (!i3) i12 = 13; else {
    i1 = 0;
    i2 = 0;
   }
  } while (0);
  if ((i12 | 0) == 13) HEAP8[i13 + 92 >> 0] = 1;
  i3 = HEAP32[i13 + 96 >> 2] | 0;
  L27 : do if (!i3) {
   i4 = 0;
   i3 = 0;
   i12 = 21;
  } else {
   i9 = HEAP32[i13 + 108 >> 2] | 0;
   i7 = i3;
   i4 = 0;
   i3 = 0;
   i5 = 0;
   while (1) {
    i8 = HEAP8[i9 >> 0] | 0;
    i6 = (i5 | 0) == 0;
    if (!(i8 & 4)) {
     if (i6) {
      i3 = 0;
      i4 = 0;
      break L27;
     }
    } else if (i6) i5 = 1; else {
     i3 = 0;
     i4 = 0;
     break L27;
    }
    i8 = i8 & 8;
    i4 = ((i8 & 255) >>> 3 & 255) + i4 | 0;
    i5 = i8 << 24 >> 24 == 0 ? i5 : 0;
    i7 = i7 + -1 | 0;
    i3 = i3 + 1 | 0;
    if (!i7) break; else i9 = i9 + 1 | 0;
   }
   if (!i5) i12 = 21; else {
    i3 = 0;
    i4 = 0;
   }
  } while (0);
  if ((i12 | 0) == 21) HEAP8[i13 + 124 >> 0] = 1;
  _UNITY_FT_Outline_Done(HEAP32[i11 >> 2] | 0, i10) | 0;
  i1 = _UNITY_FT_Outline_New(HEAP32[i11 >> 2] | 0, i3 + i1 | 0, i4 + i2 | 0, i10) | 0;
  if (!i1) {
   HEAP16[i10 + 2 >> 1] = 0;
   HEAP16[i10 >> 1] = 0;
   _UNITY_FT_Stroker_ExportBorder(i13, 0, i10);
   _UNITY_FT_Stroker_ExportBorder(i13, 1, i10);
   if (i15 << 24 >> 24) _UNITY_FT_Done_Glyph(HEAP32[i14 >> 2] | 0);
   HEAP32[i14 >> 2] = i11;
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 _UNITY_FT_Done_Glyph(i11);
 if (i15 << 24 >> 24) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i14 >> 2] = 0;
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 52;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 52;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNK7dtCrowd27UpdateProximityGridCellSizeEP15dtProximityGridii(i8, i10, i6, i9) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0;
 i11 = i9 + i6 | 0;
 if (!i11) {
  _memset(HEAP32[i10 + 20 >> 2] | 0, -1, HEAP32[i10 + 24 >> 2] << 1 | 0) | 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 28 >> 2] = 65535;
  HEAP32[i10 + 32 >> 2] = 65535;
  HEAP32[i10 + 36 >> 2] = -65535;
  HEAP32[i10 + 40 >> 2] = -65535;
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAPF32[i10 + 4 >> 2] = Math_fround(1.0);
  return;
 }
 if ((i6 | 0) > 0) {
  i7 = HEAP32[i8 + 16 >> 2] | 0;
  i4 = HEAP32[i8 + 392 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i8 + 444 >> 2]);
  f1 = Math_fround(0.0);
  i3 = 0;
  f2 = Math_fround(0.0);
  do {
   i14 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
   f15 = Math_fround(Math_fround(HEAPF32[i7 + (i14 * 608 | 0) + 292 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(HEAPF32[i7 + (i14 * 608 | 0) + 516 >> 2]);
   i16 = f12 < Math_fround(0.0);
   f13 = Math_fround(-f12);
   f2 = Math_fround(f2 + Math_fround(f15 + Math_fround(f5 * (i16 ? f13 : f12))));
   f12 = Math_fround(HEAPF32[i7 + (i14 * 608 | 0) + 524 >> 2]);
   i14 = f12 < Math_fround(0.0);
   f13 = Math_fround(-f12);
   f1 = Math_fround(f1 + Math_fround(f15 + Math_fround(f5 * (i14 ? f13 : f12))));
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i6 | 0));
 } else {
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 if ((i9 | 0) > 0) {
  i4 = HEAP32[i8 + 416 >> 2] | 0;
  i6 = HEAP32[i8 + 396 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i8 + 444 >> 2]);
  i3 = 0;
  do {
   i16 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
   f13 = Math_fround(Math_fround(HEAPF32[i4 + (i16 * 92 | 0) + 36 >> 2]) * Math_fround(2.0));
   f12 = Math_fround(HEAPF32[i4 + (i16 * 92 | 0) + 12 >> 2]);
   i14 = f12 < Math_fround(0.0);
   f15 = Math_fround(-f12);
   f2 = Math_fround(f2 + Math_fround(f13 + Math_fround(f5 * (i14 ? f15 : f12))));
   f12 = Math_fround(Math_fround(HEAPF32[i4 + (i16 * 92 | 0) + 44 >> 2]) * Math_fround(2.0));
   f15 = Math_fround(HEAPF32[i4 + (i16 * 92 | 0) + 20 >> 2]);
   i16 = f15 < Math_fround(0.0);
   f13 = Math_fround(-f15);
   f1 = Math_fround(f1 + Math_fround(f12 + Math_fround(f5 * (i16 ? f13 : f15))));
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i9 | 0));
 }
 f15 = Math_fround(Math_fround(1.0) / Math_fround(i11 | 0));
 f13 = Math_fround(f15 * f2);
 i16 = f13 < Math_fround(1.0);
 f13 = i16 ? Math_fround(1.0) : f13;
 f15 = Math_fround(f15 * f1);
 i16 = f15 < Math_fround(1.0);
 f15 = i16 ? Math_fround(1.0) : f15;
 _memset(HEAP32[i10 + 20 >> 2] | 0, -1, HEAP32[i10 + 24 >> 2] << 1 | 0) | 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = 65535;
 HEAP32[i10 + 32 >> 2] = 65535;
 HEAP32[i10 + 36 >> 2] = -65535;
 HEAP32[i10 + 40 >> 2] = -65535;
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(1.0) / f13);
 HEAPF32[i10 + 4 >> 2] = Math_fround(Math_fround(1.0) / f15);
 return;
}

function __ZN5physx33postProcessConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj(i2, i15, i4, i5, i10, i16, i13, i12) {
 i2 = i2 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17;
 i3 = i17 + 8 | 0;
 i14 = i2;
 if (i15 | 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 5) + 28 >> 2] = 0;
   HEAP16[i2 + (i1 << 5) + 12 >> 1] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
 }
 if (!i5) {
  if (!i16) i1 = 0; else {
   i2 = 0;
   i1 = 0;
   while (1) {
    i6 = HEAP32[i10 >> 2] | 0;
    i7 = HEAP32[i10 + 4 >> 2] | 0;
    i8 = (i6 - i14 | 0) >>> 5 >>> 0 < i15 >>> 0;
    if (i8) i3 = HEAPU16[i6 + 12 >> 1] | 0; else i3 = 65535;
    i9 = (i7 - i14 | 0) >>> 5 >>> 0 < i15 >>> 0;
    if (i9) i4 = HEAPU16[i7 + 12 >> 1] | 0; else i4 = 65535;
    HEAP16[i10 + 28 >> 1] = i3;
    HEAP16[i10 + 30 >> 1] = i4;
    i5 = i3 + 1 & 65535;
    i3 = i4 + 1 & 65535;
    i13 = (i5 & 65535) < (i3 & 65535) ? i3 : i5;
    i1 = (i1 & 65535) < (i13 & 65535) ? i13 : i1;
    if (i8) HEAP16[i6 + 12 >> 1] = i5;
    if (i9) HEAP16[i7 + 12 >> 1] = i3;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i16 | 0)) break; else i10 = i10 + 32 | 0;
   }
  }
  i16 = i1 & 65535;
  STACKTOP = i17;
  return i16 | 0;
 }
 i2 = i5 << 2;
 i8 = i2 >>> 0 > 1024;
 i9 = i11 + 4 | 0;
 HEAP8[i9 >> 0] = i8 & 1;
 if (i8) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i3, i2, gb + 720042 | 0, 1211) | 0;
  HEAP32[i11 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i11 >> 2] = i1;
 }
 i2 = 0;
 do {
  i8 = HEAP32[i4 + (i2 * 40 | 0) >> 2] | 0;
  HEAP32[i1 + (i2 << 2) >> 2] = i8;
  HEAP32[i8 + 28 >> 2] = 0;
  HEAP16[i8 + 14 >> 1] = 0;
  HEAP16[i8 + 12 >> 1] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 i2 = __ZN5physx37updateAtomProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj(i10, i16, i14, i15, i1, i5) | 0;
 if (i12 | 0) {
  i7 = 0;
  do {
   i3 = HEAP32[i13 + (i7 << 4) + 4 >> 2] | 0;
   if (i3 | 0) {
    i4 = (HEAP32[i13 + (i7 << 4) + 12 >> 2] | 0) + 12 | 0;
    i5 = HEAP16[i4 >> 1] | 0;
    i6 = HEAP32[i13 + (i7 << 4) >> 2] | 0;
    i8 = 0;
    do {
     i16 = i6 + i8 | 0;
     HEAP16[i10 + (i16 << 5) + 28 >> 1] = i5;
     HEAP16[i10 + (i16 << 5) + 30 >> 1] = i5;
     i8 = i8 + 1 | 0;
    } while (i8 >>> 0 < i3 >>> 0);
    HEAP16[i4 >> 1] = i5 + 1 << 16 >> 16;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i12 | 0));
 }
 if (!(HEAP8[i9 >> 0] | 0)) {
  i16 = i2;
  STACKTOP = i17;
  return i16 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i11, i1);
 i16 = i2;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5Umbra11ShadowUtils18getFrustumVerticesEPNS_7Vector3EPKNS_7Vector4E(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, i21 = 0, i22 = 0;
 i1 = 0;
 do {
  i20 = i1 >> 2;
  f4 = Math_fround(HEAPF32[i3 + (i20 << 4) >> 2]);
  f8 = Math_fround(HEAPF32[i3 + (i20 << 4) + 4 >> 2]);
  f10 = Math_fround(HEAPF32[i3 + (i20 << 4) + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + (i20 << 4) + 12 >> 2]);
  i20 = i1 >>> 1 & 1 | 2;
  f19 = Math_fround(HEAPF32[i3 + (i20 << 4) >> 2]);
  f15 = Math_fround(HEAPF32[i3 + (i20 << 4) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + (i20 << 4) + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i3 + (i20 << 4) + 12 >> 2]);
  i20 = i1 & 1 | 4;
  f17 = Math_fround(HEAPF32[i3 + (i20 << 4) >> 2]);
  f9 = Math_fround(HEAPF32[i3 + (i20 << 4) + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + (i20 << 4) + 8 >> 2]);
  f14 = Math_fround(HEAPF32[i3 + (i20 << 4) + 12 >> 2]);
  f12 = Math_fround(Math_fround(f15 * f7) - Math_fround(f16 * f9));
  f5 = Math_fround(Math_fround(f16 * f17) - Math_fround(f19 * f7));
  f18 = Math_fround(Math_fround(f19 * f9) - Math_fround(f15 * f17));
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f4 * f12) + Math_fround(f8 * f5))));
  f5 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f10 * f19) - Math_fround(f4 * f16)) * f14) + Math_fround(Math_fround(f13 * f5) + Math_fround(f11 * Math_fround(Math_fround(f4 * f7) - Math_fround(f10 * f17))))) * f6));
  f4 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f4 * f15) - Math_fround(f8 * f19)) * f14) + Math_fround(Math_fround(f13 * f18) + Math_fround(f11 * Math_fround(Math_fround(f8 * f17) - Math_fround(f4 * f9))))) * f6));
  HEAPF32[i2 + (i1 * 12 | 0) >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f16) - Math_fround(f10 * f15)) * f14) + Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * Math_fround(Math_fround(f10 * f9) - Math_fround(f8 * f7))))) * f6));
  HEAPF32[i2 + (i1 * 12 | 0) + 4 >> 2] = f5;
  HEAPF32[i2 + (i1 * 12 | 0) + 8 >> 2] = f4;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i21 = i2 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i22 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i21 + 8 >> 2];
 HEAP32[i21 >> 2] = i3;
 HEAP32[i2 + 16 >> 2] = i1;
 HEAP32[i2 + 20 >> 2] = i22;
 i22 = i2 + 48 | 0;
 i1 = i2 + 60 | 0;
 i21 = HEAP32[i22 >> 2] | 0;
 i3 = HEAP32[i2 + 52 >> 2] | 0;
 i20 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i22 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i22 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i22 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = i21;
 HEAP32[i2 + 64 >> 2] = i3;
 HEAP32[i2 + 68 >> 2] = i20;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i7 = i12 + 8 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 HEAPF32[i10 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i10 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy(i4, i2, i10, 1);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 3) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 839392 | 0, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN5Unity5Cloth26ClothConstrainCoefficients8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 839392 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN5Unity5Cloth26ClothConstrainCoefficients8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN7mecanim9animation19Blend2dDataConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i7 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i6 + 4;
 HEAP32[i10 + 4 >> 2] = i6;
 HEAP32[i10 + 8 >> 2] = i4;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i7, i10, 0);
 i4 = i6 + 12 | 0;
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i10, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i6 + 20;
 HEAP32[i10 + 4 >> 2] = i6 + 16;
 HEAP32[i10 + 8 >> 2] = i1;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i7, i10, 0);
 i1 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i10, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (!i5) {
  i5 = i6 + 36 | 0;
  i8 = i6 + 32 | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = i5;
  i11 = i10 + 4 | 0;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 8 | 0;
  HEAP32[i11 >> 2] = i9;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i7, i10, 0);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i5 = i6 + 36 | 0;
 i8 = i6 + 32 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i5;
 i11 = i10 + 4 | 0;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 8 | 0;
 HEAP32[i11 >> 2] = i9;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i7, i10, 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_24PxClothCollisionTriangleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i18, i3, i17, i19) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i20 + 46 | 0;
 i13 = i20 + 45 | 0;
 i14 = i20 + 44 | 0;
 i4 = i20 + 4 | 0;
 i15 = i20;
 i16 = i20 + 8 | 0;
 HEAP32[i3 >> 2] = 36;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i17 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i20;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i19; else {
  HEAP32[gb + 1457188 >> 2] = (HEAP32[gb + 1457188 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i15 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i11 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i15 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i11 = 9;
   } else i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i10 = _strlen(i1) | 0;
   i8 = i1 + i10 | 0;
   if ((i10 | 0) > 0) {
    i9 = i16 + 12 | 0;
    i10 = i16 + 24 | 0;
    i5 = i1;
    i7 = 0;
    i4 = 0;
    i2 = 0;
    while (1) {
     if (i5 | 0) if (HEAP8[i5 >> 0] | 0) {
      __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i12, i16, i15);
      __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i13, i9, i15);
      __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i14, i10, i15);
     }
     i3 = i7 + 36 | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i19 | 0, i4 | 0) | 0;
      if (i7 | 0) _memcpy(i5 | 0, i2 | 0, i7 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else i6 = i2;
     i5 = i6 + i7 | 0;
     i6 = i16;
     i7 = i5 + 36 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i5 | 0) < (i7 | 0));
     i5 = HEAP32[i15 >> 2] | 0;
     if (i5 >>> 0 >= i8 >>> 0) break; else i7 = i3;
    }
    i4 = i1;
    i3 = (i3 >>> 0) / 36 | 0;
    i1 = i19;
   } else i11 = 9;
  }
  if ((i11 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i19;
  }
  HEAP32[i18 >> 2] = i2;
  HEAP32[i17 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i19 | 0, 0);
 STACKTOP = i20;
 return;
}

function __ZN16PackedQuatVector9PackQuatsEP11Quaternionfi(i1, i14, i15) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i17;
 HEAP32[i1 >> 2] = i15;
 i16 = i1 + 4 | 0;
 i6 = i15 << 2;
 HEAP8[i4 >> 0] = 0;
 i7 = i1 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = i3 - i1 | 0;
 if (i6 >>> 0 > i2 >>> 0) __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh(i16, i6 - i2 | 0, i4); else if (i6 >>> 0 < i2 >>> 0) {
  i1 = i1 + i6 | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i1;
 }
 if ((i15 | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i4 = 0;
 i6 = 0;
 i12 = 0;
 while (1) {
  i13 = i14 + (i12 << 4) | 0;
  f8 = Math_fround(HEAPF32[i13 >> 2]);
  i1 = f8 < Math_fround(0.0);
  i1 = i1 ? 4 : 0;
  f8 = Math_fround(Math_abs(Math_fround(f8)));
  f5 = Math_fround(HEAPF32[i14 + (i12 << 4) + 4 >> 2]);
  f9 = Math_fround(Math_abs(Math_fround(f5)));
  if (f9 > f8) if (f5 < Math_fround(0.0)) {
   f8 = f9;
   i1 = 5;
  } else {
   f8 = f9;
   i1 = 1;
  }
  f5 = Math_fround(HEAPF32[i14 + (i12 << 4) + 8 >> 2]);
  f9 = Math_fround(Math_abs(Math_fround(f5)));
  if (f9 > f8) if (f5 < Math_fround(0.0)) {
   f8 = f9;
   i1 = 6;
  } else {
   f8 = f9;
   i1 = 2;
  }
  f5 = Math_fround(HEAPF32[i14 + (i12 << 4) + 12 >> 2]);
  if (Math_fround(Math_abs(Math_fround(f5))) > f8) if (f5 < Math_fround(0.0)) i1 = 7; else i1 = 3;
  i3 = i1 & 255;
  i2 = 0;
  do {
   i11 = (HEAP32[i16 >> 2] | 0) + i4 | 0;
   HEAP8[i11 >> 0] = HEAPU8[i11 >> 0] | 0 | i3 >>> i2 << i6;
   i11 = 3 - i2 | 0;
   i10 = 8 - i6 | 0;
   i11 = (i10 | 0) < (i11 | 0) ? i10 : i11;
   i10 = i11 + i6 | 0;
   i2 = i11 + i2 | 0;
   i11 = (i10 | 0) == 8;
   i6 = i11 ? 0 : i10;
   i4 = (i11 & 1) + i4 | 0;
  } while ((i2 | 0) < 3);
  i11 = i1 & 3;
  i10 = i1 + 1 & 3;
  i7 = 0;
  i1 = i4;
  i2 = i6;
  do {
   if ((i11 | 0) != (i7 | 0)) {
    i4 = (i10 | 0) == (i7 | 0) ? 9 : 10;
    f9 = Math_fround(Math_fround(Math_fround(HEAPF32[i13 + (i7 << 2) >> 2]) + Math_fround(1.0)) * Math_fround(.5));
    i6 = f9 < Math_fround(0.0);
    f9 = i6 ? Math_fround(0.0) : f9;
    i6 = f9 > Math_fround(1.0);
    i6 = ~~Math_fround(Math_fround((1 << i4) + -1 | 0) * (i6 ? Math_fround(1.0) : f9)) >>> 0;
    i3 = 0;
    do {
     i18 = (HEAP32[i16 >> 2] | 0) + i1 | 0;
     HEAP8[i18 >> 0] = HEAPU8[i18 >> 0] | 0 | i6 >>> i3 << i2;
     i18 = i4 - i3 | 0;
     i19 = 8 - i2 | 0;
     i18 = (i19 | 0) < (i18 | 0) ? i19 : i18;
     i2 = i18 + i2 | 0;
     i3 = i18 + i3 | 0;
     i18 = (i2 | 0) == 8;
     i2 = i18 ? 0 : i2;
     i1 = (i18 & 1) + i1 | 0;
    } while ((i4 | 0) > (i3 | 0));
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 4);
  i12 = i12 + 1 | 0;
  if ((i12 | 0) == (i15 | 0)) break; else {
   i4 = i1;
   i6 = i2;
  }
 }
 STACKTOP = i17;
 return;
}

function __ZN15Cast2DQueryBase15InitializeQueryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i6 = i11 + 32 | 0;
 i7 = i11 + 16 | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 i9 = i1 + 36 | 0;
 HEAP32[i9 >> 2] = i8;
 i10 = i1 + 28 | 0;
 i3 = i1 + 32 | 0;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 i12 = f4 == Math_fround(-inf);
 f4 = i12 ? Math_fround(-3402823469999999843913219.0e14) : f4;
 HEAPF32[i10 >> 2] = f4;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i12 = f5 == Math_fround(inf);
 f5 = i12 ? Math_fround(3402823469999999843913219.0e14) : f5;
 HEAPF32[i3 >> 2] = f5;
 if (!(f4 < f5)) {
  HEAPF32[i10 >> 2] = f5;
  HEAPF32[i3 >> 2] = f4;
 }
 HEAP32[i1 + 72 >> 2] = i8;
 HEAP8[i1 + 98 >> 0] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 i12 = i1 + 76 | 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i12 = i1 + 20 | 0;
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(+Math_sin(+f5));
 f5 = Math_fround(+Math_cos(+f5));
 i10 = i1 + 104 | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i1 + 108 >> 2] = i3;
 HEAPF32[i1 + 112 >> 2] = f4;
 HEAPF32[i1 + 116 >> 2] = f5;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = f5;
 mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0, i6 | 0, i10 | 0, 0, 1);
 i8 = HEAP32[i9 >> 2] | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0, i7 | 0, i2 | 0, 0, 1);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 HEAPF32[i1 + 120 >> 2] = f5 < f4 ? f5 : f4;
 HEAPF32[i1 + 124 >> 2] = f13 < f14 ? f13 : f14;
 f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 HEAPF32[i1 + 128 >> 2] = f14 > f13 ? f14 : f13;
 HEAPF32[i1 + 132 >> 2] = f4 > f5 ? f4 : f5;
 __ZN15b2DistanceProxy3SetEPK7b2Shapei(i1 + 136 | 0, HEAP32[i9 >> 2] | 0, 0);
 HEAPF32[i1 + 192 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i1 + 200 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i2;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i1 + 208 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i1 + 220 >> 2] = i12;
 HEAP32[i1 + 216 >> 2] = i12;
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 369 >> 0] = 1;
 STACKTOP = i11;
 return;
}

function __Z51StaticBatchingUtility_CUSTOM_InternalCombineIndicesP11Il2CppArrayP12Il2CppObject(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 16 | 0;
 i9 = i14 + 12 | 0;
 i12 = i14;
 i10 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 80) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i12 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 if (i6 | 0) {
  __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj(i12, i6);
  i5 = 0;
  do {
   i4 = HEAP32[i10 + (i5 * 80 | 0) >> 2] | 0;
   if (!i4) i1 = 0; else {
    HEAP32[i9 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 16; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i2 = HEAP32[i8 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 18;
     }
    }
    if ((i11 | 0) == 16) i11 = 18;
    if ((i11 | 0) == 18) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
   }
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i2 + (i5 * 112 | 0) >> 2] = i1;
   HEAP32[i2 + (i5 * 112 | 0) + 108 >> 2] = HEAP32[i10 + (i5 * 80 | 0) + 4 >> 2];
   HEAP32[i2 + (i5 * 112 | 0) + 8 >> 2] = HEAP32[i10 + (i5 * 80 | 0) + 12 >> 2];
   i1 = i2 + (i5 * 112 | 0) + 12 | 0;
   i2 = i10 + (i5 * 80 | 0) + 16 | 0;
   i3 = i1 + 64 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 if (!i7) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 __Z35CombineMeshIndicesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb(i12, i1, 0, 1);
 HEAP8[i1 + 41 >> 0] = 0;
 HEAP8[i1 + 43 >> 0] = 1;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i13 >> 2] = i2 + (~(((i2 + -112 - i1 | 0) >>> 0) / 112 | 0) * 112 | 0);
 __ZdlPv(i1);
 STACKTOP = i14;
 return;
}

function __Z23TransferScriptingObjectI14SafeBinaryReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i11 = i14 + 60 | 0;
 i4 = i14 + 80 | 0;
 i5 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i4 >> 0] = 0;
 L1 : do if (!i1) i2 = 0; else {
  i3 = i1 + 44 | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i2) {
   while (1) {
    i2 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i1 >> 2] | 0, i4) | 0;
    if (!(HEAP32[i3 >> 2] | 0)) break;
    if (i2 | 0) __ZN23CachedSerializationDataD2Ev(i2);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63496 | 0);
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) break L3;
   }
   HEAP32[i3 >> 2] = i2;
  } while (0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) i2 = 0; else {
   i1 = 0;
   while (1) {
    if ((HEAP8[i2 + 8 + (i1 * 24 | 0) >> 0] | 0) == 5) if (!(HEAP8[i2 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i2 = 0;
     break L1;
    }
   }
   i2 = i2 + 8 + (i1 * 24 | 0) + 4 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i6 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i1 = i12;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i10;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = 5;
  __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i5, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i4 = i11 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i5 = i11 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i8;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i11;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i7);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS4_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 34;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNK26AnimatorOverrideController7GetClipE4PPtrI13AnimationClipEb(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 16 | 0;
 i6 = i12 + 12 | 0;
 i10 = i12;
 i7 = HEAP32[i1 >> 2] | 0;
 if (!i7) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i6 >> 2] = i7;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i11 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i13 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i13 + 28 >> 2] | 0;
   i4 = HEAP32[i13 + 32 >> 2] | 0;
   i1 = i13;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i11 = 9;
 }
 if ((i11 | 0) == 7) i11 = 9;
 do if ((i11 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i7) | 0)) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = i7;
 if (!i1) i11 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i11 = 18;
  }
 }
 if ((i11 | 0) == 16) i11 = 18;
 if ((i11 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(i7) | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i13, _strlen(i13) | 0);
 i13 = __ZNK26AnimatorOverrideController7GetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i8, i10, i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_(i12, i11, i4, i6, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 1 | 0;
 i10 = i13;
 i2 = i12 + 280 | 0;
 i3 = i12 + 296 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  i1 = HEAP32[i12 + 292 >> 2] | 0;
  if (!i1) {
   i5 = -1;
   i1 = i12 + 284 | 0;
   break;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 << 1 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   i8 = 5;
   break;
  }
 } else i8 = 5; while (0);
 if ((i8 | 0) == 5) {
  i8 = (HEAP32[i12 + 288 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = -1;
  i8 = i12 + 284 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i5 + (i1 * 12 | 0) >> 2] = -1;
  HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = -1;
  HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = 0;
  i5 = i12 + 300 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i5 = i1;
  i1 = i8;
 }
 HEAP32[i7 >> 2] = i5;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] = 0;
 HEAP32[i1 + (i5 * 12 | 0) >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] = 4;
 i1 = i12 + 332 | 0;
 i2 = i12 + 336 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i12 + 364 | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) {
  i8 = i3 << 1;
  i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i3 << 5, gb + 681489 | 0, 1659) | 0;
  i16 = i9 + (i8 << 2) | 0;
  i14 = i9 + (i3 << 2 << 2) | 0;
  i6 = i9 + (i3 * 6 << 2) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  i15 = i12 + 340 | 0;
  _memcpy(i16 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i12 + 344 >> 2] << 2 | 0) | 0;
  i3 = i12 + 356 | 0;
  _memcpy(i14 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i12 + 360 >> 2] << 2 | 0) | 0;
  i7 = i12 + 348 | 0;
  _memcpy(i6 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i12 + 352 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = i9;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i3 >> 2] = i14;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i4 >> 2] = i8;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i9 + (i10 << 2) | 0;
  HEAP32[i10 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + 1 | 0;
  HEAP32[i2 >> 2] = i10;
  i12 = i12 + 456 + (i11 << 2) | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i11 = i11 + 1 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 } else {
  i15 = HEAP32[i1 >> 2] | 0;
  i16 = i3;
  i16 = i15 + (i16 << 2) | 0;
  HEAP32[i16 >> 2] = i5;
  i16 = HEAP32[i2 >> 2] | 0;
  i16 = i16 + 1 | 0;
  HEAP32[i2 >> 2] = i16;
  i16 = i12 + 456 + (i11 << 2) | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i15 = i15 + 1 | 0;
  HEAP32[i16 >> 2] = i15;
  STACKTOP = i13;
  return;
 }
}

function __Z34AnimationState_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i10 = i13 + 40 | 0;
 i3 = i13 + 32 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i9) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 __ZNK11ICallString6ToUTF8Ev(i12, i3);
 i3 = HEAP8[i12 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
 i3 = i1 ? HEAP32[i12 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i5 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i5 = 9;
  }
 } else i5 = 7;
 if ((i5 | 0) == 7) {
  i8 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i5 = 9;
 }
 if ((i5 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i9 + 112 | 0;
 i6 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i8 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 120 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 116 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 116 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i13;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i13;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 16 | 0;
 i13 = i5;
 __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i14, i2 + 72 | 0, i3);
 __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i13, i2, i3);
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
 i12 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
 i9 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = HEAP32[i13 + 8 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i11 = i9 & 255;
 i7 = ~~f22 & 255;
 i10 = i9 >>> 8 & 255;
 i6 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i20 = i17 & 255;
 i18 = ~~f21 & 255;
 i3 = i17 >>> 8 & 255;
 i2 = i17 >>> 16 & 255;
 i17 = i17 >>> 24;
 i2 = ((Math_imul((i16 & 255) - i20 | 0, i18) | 0) + 128 >> 8) + i20 | (Math_imul((i16 >>> 8 & 255) - i3 | 0, i18) | 0) + (i3 << 8 | 128) & -256 | (((Math_imul((i16 >>> 24) - i17 | 0, i18) | 0) + 128 | 0) >>> 8) + i17 << 24 | (((Math_imul((i16 >>> 16 & 255) - i2 | 0, i18) | 0) + 128 | 0) >>> 8) + i2 << 16;
 i18 = i4 & 255;
 i16 = ~~f19 & 255;
 i17 = i4 >>> 8 & 255;
 i3 = i4 >>> 16 & 255;
 i4 = i4 >>> 24;
 i3 = ((Math_imul((i15 & 255) - i18 | 0, i16) | 0) + 128 >> 8) + i18 | (Math_imul((i15 >>> 8 & 255) - i17 | 0, i16) | 0) + (i17 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i4 | 0, i16) | 0) + 128 | 0) >>> 8) + i4 << 24 | (((Math_imul((i15 >>> 16 & 255) - i3 | 0, i16) | 0) + 128 | 0) >>> 8) + i3 << 16;
 i16 = i14 & 255;
 i12 = i12 & 255;
 i15 = i14 >>> 8 & 255;
 i4 = i14 >>> 16 & 255;
 i14 = i14 >>> 24;
 i4 = ((Math_imul((i13 & 255) - i16 | 0, i12) | 0) + 128 >> 8) + i16 | (Math_imul((i13 >>> 8 & 255) - i15 | 0, i12) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul((i13 >>> 24) - i14 | 0, i12) | 0) + 128 | 0) >>> 8) + i14 << 24 | (((Math_imul((i13 >>> 16 & 255) - i4 | 0, i12) | 0) + 128 | 0) >>> 8) + i4 << 16;
 HEAP32[i1 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i7) | 0) + 128 >> 8) + i11 | (Math_imul((i8 >>> 8 & 255) - i10 | 0, i7) | 0) + (i10 << 8 | 128) & -256 | (((Math_imul((i8 >>> 24) - i9 | 0, i7) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i8 >>> 16 & 255) - i6 | 0, i7) | 0) + 128 | 0) >>> 8) + i6 << 16;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 16 | 0;
 i13 = i5;
 __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i14, i2 + 72 | 0, i3);
 __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i13, i2, i3);
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
 i12 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
 i9 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = HEAP32[i13 + 8 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i11 = i9 & 255;
 i7 = ~~f22 & 255;
 i10 = i9 >>> 8 & 255;
 i6 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i20 = i17 & 255;
 i18 = ~~f21 & 255;
 i3 = i17 >>> 8 & 255;
 i2 = i17 >>> 16 & 255;
 i17 = i17 >>> 24;
 i2 = ((Math_imul((i16 & 255) - i20 | 0, i18) | 0) + 128 >> 8) + i20 | (Math_imul((i16 >>> 8 & 255) - i3 | 0, i18) | 0) + (i3 << 8 | 128) & -256 | (((Math_imul((i16 >>> 24) - i17 | 0, i18) | 0) + 128 | 0) >>> 8) + i17 << 24 | (((Math_imul((i16 >>> 16 & 255) - i2 | 0, i18) | 0) + 128 | 0) >>> 8) + i2 << 16;
 i18 = i4 & 255;
 i16 = ~~f19 & 255;
 i17 = i4 >>> 8 & 255;
 i3 = i4 >>> 16 & 255;
 i4 = i4 >>> 24;
 i3 = ((Math_imul((i15 & 255) - i18 | 0, i16) | 0) + 128 >> 8) + i18 | (Math_imul((i15 >>> 8 & 255) - i17 | 0, i16) | 0) + (i17 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i4 | 0, i16) | 0) + 128 | 0) >>> 8) + i4 << 24 | (((Math_imul((i15 >>> 16 & 255) - i3 | 0, i16) | 0) + 128 | 0) >>> 8) + i3 << 16;
 i16 = i14 & 255;
 i12 = i12 & 255;
 i15 = i14 >>> 8 & 255;
 i4 = i14 >>> 16 & 255;
 i14 = i14 >>> 24;
 i4 = ((Math_imul((i13 & 255) - i16 | 0, i12) | 0) + 128 >> 8) + i16 | (Math_imul((i13 >>> 8 & 255) - i15 | 0, i12) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul((i13 >>> 24) - i14 | 0, i12) | 0) + 128 | 0) >>> 8) + i14 << 24 | (((Math_imul((i13 >>> 16 & 255) - i4 | 0, i12) | 0) + 128 | 0) >>> 8) + i4 << 16;
 HEAP32[i1 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i7) | 0) + 128 >> 8) + i11 | (Math_imul((i8 >>> 8 & 255) - i10 | 0, i7) | 0) + (i10 << 8 | 128) & -256 | (((Math_imul((i8 >>> 24) - i9 | 0, i7) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i8 >>> 16 & 255) - i6 | 0, i7) | 0) + 128 | 0) >>> 8) + i6 << 16;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 16 | 0;
 i13 = i5;
 __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i14, i2 + 72 | 0, i3);
 __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i13, i2, i3);
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
 i12 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
 i9 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = HEAP32[i13 + 8 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i11 = i9 & 255;
 i7 = ~~f22 & 255;
 i10 = i9 >>> 8 & 255;
 i6 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i20 = i17 & 255;
 i18 = ~~f21 & 255;
 i3 = i17 >>> 8 & 255;
 i2 = i17 >>> 16 & 255;
 i17 = i17 >>> 24;
 i2 = ((Math_imul((i16 & 255) - i20 | 0, i18) | 0) + 128 >> 8) + i20 | (Math_imul((i16 >>> 8 & 255) - i3 | 0, i18) | 0) + (i3 << 8 | 128) & -256 | (((Math_imul((i16 >>> 24) - i17 | 0, i18) | 0) + 128 | 0) >>> 8) + i17 << 24 | (((Math_imul((i16 >>> 16 & 255) - i2 | 0, i18) | 0) + 128 | 0) >>> 8) + i2 << 16;
 i18 = i4 & 255;
 i16 = ~~f19 & 255;
 i17 = i4 >>> 8 & 255;
 i3 = i4 >>> 16 & 255;
 i4 = i4 >>> 24;
 i3 = ((Math_imul((i15 & 255) - i18 | 0, i16) | 0) + 128 >> 8) + i18 | (Math_imul((i15 >>> 8 & 255) - i17 | 0, i16) | 0) + (i17 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i4 | 0, i16) | 0) + 128 | 0) >>> 8) + i4 << 24 | (((Math_imul((i15 >>> 16 & 255) - i3 | 0, i16) | 0) + 128 | 0) >>> 8) + i3 << 16;
 i16 = i14 & 255;
 i12 = i12 & 255;
 i15 = i14 >>> 8 & 255;
 i4 = i14 >>> 16 & 255;
 i14 = i14 >>> 24;
 i4 = ((Math_imul((i13 & 255) - i16 | 0, i12) | 0) + 128 >> 8) + i16 | (Math_imul((i13 >>> 8 & 255) - i15 | 0, i12) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul((i13 >>> 24) - i14 | 0, i12) | 0) + 128 | 0) >>> 8) + i14 << 24 | (((Math_imul((i13 >>> 16 & 255) - i4 | 0, i12) | 0) + 128 | 0) >>> 8) + i4 << 16;
 HEAP32[i1 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i7) | 0) + 128 >> 8) + i11 | (Math_imul((i8 >>> 8 & 255) - i10 | 0, i7) | 0) + (i10 << 8 | 128) & -256 | (((Math_imul((i8 >>> 24) - i9 | 0, i7) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i8 >>> 16 & 255) - i6 | 0, i7) | 0) + 128 | 0) >>> 8) + i6 << 16;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 16 | 0;
 i13 = i5;
 __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i14, i2 + 72 | 0, i3);
 __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i13, i2, i3);
 f22 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
 f21 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
 i12 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
 i9 = HEAP32[i14 >> 2] | 0;
 i17 = HEAP32[i14 + 4 >> 2] | 0;
 i4 = HEAP32[i14 + 8 >> 2] | 0;
 i14 = HEAP32[i14 + 12 >> 2] | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = HEAP32[i13 + 8 >> 2] | 0;
 i13 = HEAP32[i13 + 12 >> 2] | 0;
 i11 = i9 & 255;
 i7 = ~~f22 & 255;
 i10 = i9 >>> 8 & 255;
 i6 = i9 >>> 16 & 255;
 i9 = i9 >>> 24;
 i20 = i17 & 255;
 i18 = ~~f21 & 255;
 i3 = i17 >>> 8 & 255;
 i2 = i17 >>> 16 & 255;
 i17 = i17 >>> 24;
 i2 = ((Math_imul((i16 & 255) - i20 | 0, i18) | 0) + 128 >> 8) + i20 | (Math_imul((i16 >>> 8 & 255) - i3 | 0, i18) | 0) + (i3 << 8 | 128) & -256 | (((Math_imul((i16 >>> 24) - i17 | 0, i18) | 0) + 128 | 0) >>> 8) + i17 << 24 | (((Math_imul((i16 >>> 16 & 255) - i2 | 0, i18) | 0) + 128 | 0) >>> 8) + i2 << 16;
 i18 = i4 & 255;
 i16 = ~~f19 & 255;
 i17 = i4 >>> 8 & 255;
 i3 = i4 >>> 16 & 255;
 i4 = i4 >>> 24;
 i3 = ((Math_imul((i15 & 255) - i18 | 0, i16) | 0) + 128 >> 8) + i18 | (Math_imul((i15 >>> 8 & 255) - i17 | 0, i16) | 0) + (i17 << 8 | 128) & -256 | (((Math_imul((i15 >>> 24) - i4 | 0, i16) | 0) + 128 | 0) >>> 8) + i4 << 24 | (((Math_imul((i15 >>> 16 & 255) - i3 | 0, i16) | 0) + 128 | 0) >>> 8) + i3 << 16;
 i16 = i14 & 255;
 i12 = i12 & 255;
 i15 = i14 >>> 8 & 255;
 i4 = i14 >>> 16 & 255;
 i14 = i14 >>> 24;
 i4 = ((Math_imul((i13 & 255) - i16 | 0, i12) | 0) + 128 >> 8) + i16 | (Math_imul((i13 >>> 8 & 255) - i15 | 0, i12) | 0) + (i15 << 8 | 128) & -256 | (((Math_imul((i13 >>> 24) - i14 | 0, i12) | 0) + 128 | 0) >>> 8) + i14 << 24 | (((Math_imul((i13 >>> 16 & 255) - i4 | 0, i12) | 0) + 128 | 0) >>> 8) + i4 << 16;
 HEAP32[i1 >> 2] = ((Math_imul((i8 & 255) - i11 | 0, i7) | 0) + 128 >> 8) + i11 | (Math_imul((i8 >>> 8 & 255) - i10 | 0, i7) | 0) + (i10 << 8 | 128) & -256 | (((Math_imul((i8 >>> 24) - i9 | 0, i7) | 0) + 128 | 0) >>> 8) + i9 << 24 | (((Math_imul((i8 >>> 16 & 255) - i6 | 0, i7) | 0) + 128 | 0) >>> 8) + i6 << 16;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeE(i8, i5, i9, i1, i3, i4, i2) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((i3 | 0) <= (i4 | 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i3 | 0)) return;
  i7 = ((i3 + -8 + (0 - i1) | 0) >>> 3) + 1 | 0;
  i5 = i2;
  i6 = i1;
  while (1) {
   i8 = i6;
   i10 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i5;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i4 = i4 + 8 | 0;
   if ((i4 | 0) == (i3 | 0)) break; else {
    i5 = i5 + 8 | 0;
    i6 = i4;
   }
  }
  i8 = i2 + (i7 << 3) | 0;
  if ((i8 | 0) == (i2 | 0)) return;
  i7 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((i3 | 0) == (i7 | 0)) break;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i6 = i1;
   if (i4 >>> 0 < i5 >>> 0) {
    HEAP32[i1 >> 2] = i4;
    HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    i4 = i2;
    i3 = i3 + 8 | 0;
   } else {
    HEAP32[i1 >> 2] = i5;
    HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    i4 = i2 + 8 | 0;
   }
   if ((i4 | 0) == (i8 | 0)) {
    i12 = 26;
    break;
   } else {
    i2 = i4;
    i1 = i6 + 8 | 0;
   }
  }
  if ((i12 | 0) == 26) return;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i2 = i2 + 8 | 0;
   if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 8 | 0;
  }
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i1;
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) return;
 i6 = ((i3 + -8 + (0 - i1) | 0) >>> 3) + 1 | 0;
 i5 = i2;
 i4 = i1;
 i1 = i7;
 while (1) {
  i9 = i4;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i5;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i3 | 0)) break; else {
   i5 = i5 + 8 | 0;
   i4 = i1;
  }
 }
 i4 = i2 + (i6 << 3) | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i11 = HEAP32[i8 >> 2] | 0;
 i1 = i4;
 i5 = i7;
 while (1) {
  if ((i5 | 0) == (i11 | 0)) break;
  i6 = i5 + -8 | 0;
  i9 = i4 + -8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i10 = i3 + -8 | 0;
  if (i7 >>> 0 < i8 >>> 0) {
   HEAP32[i10 >> 2] = i8;
   HEAP32[i3 + -4 >> 2] = HEAP32[i4 + -4 >> 2];
   i6 = i9;
   i4 = i9;
  } else {
   HEAP32[i10 >> 2] = i7;
   HEAP32[i3 + -4 >> 2] = HEAP32[i5 + -4 >> 2];
   i5 = i6;
   i6 = i1;
  }
  if ((i4 | 0) == (i2 | 0)) {
   i12 = 26;
   break;
  } else {
   i1 = i6;
   i3 = i10;
  }
 }
 if ((i12 | 0) == 26) return;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  i12 = i3;
  i3 = i3 + -8 | 0;
  i11 = i1;
  i1 = i1 + -8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 + -4 >> 2] = HEAP32[i11 + -4 >> 2];
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i15, i1, i17, i2) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, i23 = 0, i24 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 136 | 0;
 i13 = i20;
 i3 = i20 + 132 | 0;
 i19 = i20 + 128 | 0;
 f22 = Math_fround(HEAPF32[i15 >> 2]);
 f22 = Math_fround(f22 - Math_fround(HEAPF32[i1 >> 2]));
 i16 = i15 + 8 | 0;
 f21 = Math_fround(HEAPF32[i16 >> 2]);
 f21 = Math_fround(f21 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (Math_fround(Math_fround(f22 * f22) + Math_fround(f21 * f21)) == Math_fround(0.0)) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 i14 = i15 + 28 | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 if ((__ZNK14dtNavMeshQuery16moveAlongSurfaceEyPKfS1_PK13dtQueryFilterPfPyPii(i17, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i15, i1, i2, i18, i13, i3, 16) | 0) < 0) {
  i19 = i15 + 44 | 0;
  HEAP8[i19 >> 0] = (HEAPU8[i19 >> 0] | 0) & 254;
 } else {
  i1 = HEAP32[i14 >> 2] | 0;
  i12 = i15 + 32 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = HEAP32[i15 + 36 >> 2] | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  if ((i11 | 0) > 0) {
   i4 = -1;
   i7 = i2;
   i3 = -1;
   do {
    if ((i7 | 0) <= 0) break;
    i7 = i7 + -1 | 0;
    i9 = i1 + (i7 << 3) | 0;
    i8 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    i5 = i11;
    i6 = 0;
    do {
     i23 = i5;
     i5 = i5 + -1 | 0;
     i24 = i13 + (i5 << 3) | 0;
     i24 = (i8 | 0) == (HEAP32[i24 >> 2] | 0) ? (i9 | 0) == (HEAP32[i24 + 4 >> 2] | 0) : 0;
     i3 = i24 ? i5 : i3;
     i6 = i6 | i24;
     i4 = i24 ? i7 : i4;
    } while ((i23 | 0) > 1);
   } while (!i6);
   if (!((i3 | 0) == -1 | (i4 | 0) == -1)) {
    i5 = i11 - i3 | 0;
    i3 = i4 + 1 | 0;
    i3 = (i3 | 0) < (i2 | 0) ? i3 : i2;
    i4 = i2 - i3 | 0;
    i4 = (i4 | 0) < 0 ? 0 : i4;
    i4 = (i4 + i5 | 0) > (i10 | 0) ? i10 - i5 | 0 : i4;
    if (i4 | 0) _memmove(i1 + (i5 << 3) | 0, i1 + (i3 << 3) | 0, i4 << 3 | 0) | 0;
    if ((i5 | 0) > 0) {
     i3 = i11 + -1 | 0;
     i2 = 0;
     do {
      i11 = i13 + (i3 - i2 << 3) | 0;
      i23 = HEAP32[i11 + 4 >> 2] | 0;
      i24 = i1 + (i2 << 3) | 0;
      HEAP32[i24 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i24 + 4 >> 2] = i23;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i5 | 0));
    }
    i2 = i4 + i5 | 0;
    i1 = HEAP32[i14 >> 2] | 0;
   }
  }
  HEAP32[i12 >> 2] = i2;
  i24 = i15 + 4 | 0;
  HEAP32[i19 >> 2] = HEAP32[i24 >> 2];
  i23 = i1;
  __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i17, HEAP32[i23 >> 2] | 0, HEAP32[i23 + 4 >> 2] | 0, i18, i19) | 0;
  i23 = HEAP32[i19 >> 2] | 0;
  HEAP32[i18 + 4 >> 2] = i23;
  HEAP32[i15 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i24 >> 2] = i23;
  HEAP32[i16 >> 2] = HEAP32[i18 + 8 >> 2];
 }
 STACKTOP = i20;
 return;
}

function __ZN11TimeManager6UpdateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, d3 = 0.0, i4 = 0, d5 = 0.0, i6 = 0, d7 = 0.0, d9 = 0.0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i10 = i8 + 132 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i8 + 136 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if (HEAP8[i8 + 192 >> 0] | 0) return;
 d9 = +__Z19GetTimeSinceStartupv();
 d7 = d9 - +HEAPF64[i8 + 160 >> 3];
 i10 = i8 + 176 | 0;
 HEAPF64[i8 + 184 >> 3] = d7 - +HEAPF64[i10 >> 3];
 HEAPF64[i10 >> 3] = d7;
 i10 = i8 + 152 | 0;
 d7 = d9 - +HEAPF64[i10 >> 3];
 i1 = HEAP32[i8 + 144 >> 2] | 0;
 do if ((i1 | 0) > 0) {
  d3 = +HEAPF64[i8 + 64 >> 3];
  f2 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
  d5 = d3 + +Math_fround(f2 * Math_fround(HEAPF32[i8 + 196 >> 2]));
  i4 = i8 + 129 | 0;
  i6 = i4;
  i4 = HEAP8[i4 >> 0] | 0;
 } else {
  i1 = i8 + 128 | 0;
  i6 = HEAP16[i1 >> 1] | 0;
  i4 = (i6 & 65535) >>> 8 & 255;
  if ((i6 & 255) << 24 >> 24) {
   HEAP8[i1 >> 0] = 0;
   return;
  }
  i6 = i8 + 129 | 0;
  d3 = +HEAPF64[i8 + 64 >> 3];
  if (i4 << 24 >> 24) {
   d5 = d3 + +Math_fround(Math_fround(HEAPF32[i8 + 196 >> 2]) * Math_fround(.0199999996));
   break;
  }
  d5 = d7 - d3;
  f2 = Math_fround(HEAPF32[i8 + 200 >> 2]);
  if (d5 > +f2) {
   d5 = d3 + +Math_fround(f2 * Math_fround(HEAPF32[i8 + 196 >> 2]));
   i4 = 0;
   break;
  }
  f2 = Math_fround(HEAPF32[i8 + 196 >> 2]);
  if (d5 < 9.999999747378752e-06) {
   d5 = d3 + +Math_fround(f2 * Math_fround(9.99999974e-06));
   i4 = 0;
   break;
  }
  f11 = Math_fround(f2 + Math_fround(-1.0));
  i4 = f11 < Math_fround(0.0);
  f12 = Math_fround(-f11);
  if (!((i4 ? f12 : f11) <= Math_fround(9.99999997e-07))) {
   d5 = d3 + +Math_fround(Math_fround(d5) * f2);
   i4 = 0;
  } else {
   d5 = d7;
   i4 = 0;
  }
 } while (0);
 i13 = i8 + 64 | 0;
 HEAPF64[i8 + 72 >> 3] = d3;
 HEAPF64[i13 >> 3] = d5;
 f11 = Math_fround(d5 - d3);
 HEAPF32[i8 + 80 >> 2] = f11;
 i1 = f11 > Math_fround(9.99999974e-06);
 f12 = Math_fround(Math_fround(1.0) / f11);
 HEAPF32[i8 + 92 >> 2] = i1 ? f12 : Math_fround(1.0);
 i1 = i8 + 88 | 0;
 f12 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.800000011)) + Math_fround(.200000003));
 HEAPF32[i1 >> 2] = f12;
 f12 = Math_fround(Math_fround(.200000003) / f12);
 i14 = i8 + 84 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(f11 * f12) + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(Math_fround(1.0) - f12)));
 i8 = i8 + 96 | 0;
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
 HEAPF64[i10 >> 3] = d9 - d5;
 if (!(i4 << 24 >> 24)) return;
 HEAP8[i6 >> 0] = 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __Z33CalculateTriangleAreaRotationlessP8Vector3ffffRS_(i1, f2, f3, f4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f24 = Math_fround(f18 - f17);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(f16 - f15);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f20 = Math_fround(f14 - f6);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f23 = Math_fround(f17 - f10);
 f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f21 = Math_fround(f15 - f7);
 f12 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f8 = Math_fround(f6 - f12);
 f11 = Math_fround(Math_fround(f13 * f8) - Math_fround(f20 * f21));
 f8 = Math_fround(Math_fround(f20 * f23) - Math_fround(f24 * f8));
 f23 = Math_fround(Math_fround(f24 * f21) - Math_fround(f13 * f23));
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(f23 * f23) + Math_fround(Math_fround(f11 * f11) + Math_fround(f8 * f8)))));
 f11 = Math_fround(f11 / f13);
 f8 = Math_fround(f8 / f13);
 f13 = Math_fround(f23 / f13);
 f23 = Math_fround(f17 - f18);
 f21 = Math_fround(f15 - f16);
 f24 = Math_fround(f6 - f14);
 f20 = Math_fround(f10 - f18);
 f22 = Math_fround(f7 - f16);
 f9 = Math_fround(f12 - f14);
 f19 = Math_fround(Math_fround(f21 * f9) - Math_fround(f24 * f22));
 f9 = Math_fround(Math_fround(f24 * f20) - Math_fround(f23 * f9));
 f20 = Math_fround(Math_fround(f23 * f22) - Math_fround(f21 * f20));
 f9 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f20 * f20) + Math_fround(Math_fround(f19 * f19) + Math_fround(f9 * f9))))) * Math_fround(.5));
 f10 = Math_fround(Math_fround(Math_fround(f18 + f17) + f10) / Math_fround(3.0));
 f7 = Math_fround(Math_fround(Math_fround(f16 + f15) + f7) / Math_fround(3.0));
 f12 = Math_fround(Math_fround(Math_fround(f14 + f6) + f12) / Math_fround(3.0));
 f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f10);
 f7 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f7);
 f12 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f12);
 f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f7 * f7)) + Math_fround(f12 * f12))));
 f7 = Math_fround(Math_fround(f13 * Math_fround(f12 / f6)) + Math_fround(Math_fround(f11 * Math_fround(f10 / f6)) + Math_fround(f8 * Math_fround(f7 / f6))));
 i5 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f2 = Math_fround(+Math_sin(+Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274))));
 return Math_fround(Math_fround(Math_fround(f2 * Math_fround(Math_fround(Math_fround(f9 * f2) * f3) * f4)) * (i5 ? f8 : f7)) / f6);
}

function __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 1088 | 0;
 i6 = i12 + 8 | 0;
 i11 = i12 + 20 | 0;
 i9 = i12;
 i7 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i6, i7, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = __ZNK15FileSystemEntry4SizeEv(i10) | 0;
 getTempRet0() | 0;
 __ZN12FileAccessorC2Ev(i11);
 if (i6 >>> 0 > 2147483631 | (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i11, i10, 0, 0) | 0) ^ 1) {
  i9 = 0;
  __ZN12FileAccessorD2Ev(i11);
  __ZN13FileEntryDataD2Ev(i10);
  STACKTOP = i12;
  return i9 | 0;
 }
 i7 = i8 + 11 | 0;
 i3 = HEAP8[i7 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 if (i2) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i3 & 255;
 do if (i6 >>> 0 > i1 >>> 0) {
  i5 = i6 - i1 | 0;
  if (i5 | 0) {
   if (i2) {
    i1 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0;
    i4 = HEAP32[i8 + 4 >> 2] | 0;
   } else {
    i1 = 10;
    i4 = i3 & 255;
   }
   if ((i1 - i4 | 0) >>> 0 < i5 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i8, i1, i5 - i1 + i4 | 0, i4, i4, 0, 0);
    i1 = HEAP8[i7 >> 0] | 0;
   } else i1 = i3;
   if (i1 << 24 >> 24 < 0) i2 = HEAP32[i8 >> 2] | 0; else i2 = i8;
   _memset(i2 + i4 | 0, 0, i5 | 0) | 0;
   i1 = i4 + i5 | 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } else if (i2) {
  HEAP8[(HEAP32[i8 >> 2] | 0) + i6 >> 0] = 0;
  HEAP32[i8 + 4 >> 2] = i6;
  break;
 } else {
  HEAP8[i8 + i6 >> 0] = 0;
  HEAP8[i7 >> 0] = i6;
  break;
 } while (0);
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 if (!i6) {
  __ZN12FileAccessor5CloseEv(i11) | 0;
  i1 = i6;
  i2 = 0;
  i3 = 28;
 } else {
  if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  i5 = __ZN12FileAccessor4ReadEyPvPy(i11, i6, 0, i1, i9) | 0;
  __ZN12FileAccessor5CloseEv(i11) | 0;
  if (i5) {
   i1 = i6;
   i2 = 0;
   i3 = 28;
  } else i3 = 29;
 }
 if ((i3 | 0) == 28) if ((HEAP32[i9 >> 2] | 0) == (i1 | 0) ? (HEAP32[i9 + 4 >> 2] | 0) == (i2 | 0) : 0) i1 = 1; else i3 = 29;
 do if ((i3 | 0) == 29) if ((HEAP8[i7 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i8 >> 2] >> 0] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i1 = 0;
  break;
 } else {
  HEAP8[i8 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
  i1 = 0;
  break;
 } while (0);
 i9 = i1;
 __ZN12FileAccessorD2Ev(i11);
 __ZN13FileEntryDataD2Ev(i10);
 STACKTOP = i12;
 return i9 | 0;
}

function __ZN7mecanim9animation22EvaluateAvatarRetargetEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb(i5, i6, i8, i9, i10, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 928 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 888 | 0;
 i1 = i13;
 i12 = i5 + 20 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 i7 = i12;
 i4 = i2 + i7 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i14 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i4;
 HEAP32[i11 + 8 >> 2] = i14;
 i14 = HEAP32[i9 + 16 >> 2] | 0;
 i4 = HEAP32[i9 + 20 >> 2] | 0;
 i2 = HEAP32[i9 + 24 >> 2] | 0;
 HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = i14;
 HEAP32[i11 + 20 >> 2] = i4;
 HEAP32[i11 + 24 >> 2] = i2;
 i2 = HEAP32[i9 + 32 >> 2] | 0;
 i4 = HEAP32[i9 + 36 >> 2] | 0;
 HEAP32[i11 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP32[i11 + 32 >> 2] = i2;
 HEAP32[i11 + 36 >> 2] = i4;
 __ZN7mecanim5human9HumanPoseC2Ev(i1);
 i4 = i8 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3) {
  i14 = i8 + 20 | 0;
  __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(HEAP32[i14 >> 2] | 0, i2, 0);
  i1 = 0;
  i2 = i14;
 } else {
  __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b(i1, i2, 0);
  i2 = i8 + 20 | 0;
 }
 i14 = HEAP32[i12 >> 2] | 0;
 __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_((i14 | 0) == 0 ? 0 : i14 + i7 | 0, HEAP32[i2 >> 2] | 0, i1, i11, HEAP32[i4 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0);
 i14 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i14 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 192 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 236 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 256 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 300 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 304 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 320 >> 2] = Math_fround(0.0);
 i14 = i14 + 52 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 if (HEAP8[i6 + 19 >> 0] | 0) {
  __ZN7mecanim9animation11SetIKOnFeetEbRKNS0_14AvatarConstantERKNS0_11AvatarInputERNS0_12AvatarMemoryERNS0_15AvatarWorkspaceERNS0_12AvatarOutputE(1, i5, i6, i9, i10, i8);
  __ZN7mecanim9animation11SetIKOnFeetEbRKNS0_14AvatarConstantERKNS0_11AvatarInputERNS0_12AvatarMemoryERNS0_15AvatarWorkspaceERNS0_12AvatarOutputE(0, i5, i6, i9, i10, i8);
 }
 STACKTOP = i13;
 return;
}

function __ZN5Cache22ReadCacheIndexThreadedEPv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 48 | 0;
 i3 = i8 + 36 | 0;
 i1 = i8 + 24 | 0;
 i7 = i8 + 12 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i5 + 4 | 0, i2);
 __Z20GetPlatformCachePathv(i6);
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i6); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i6, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i2 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i7, i6, 0, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 L5 : do if (i2) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i5 + 52 | 0;
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i2;
   while (1) {
    if (HEAP8[i1 >> 0] | 0) break L5;
    i2 = i3 + 16 | 0;
    if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
     i9 = __Z22GetFolderSizeRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
     getTempRet0() | 0;
     __ZN5Cache10AddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i5, i2, i9);
    }
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
   }
  }
 } else i1 = i5 + 52 | 0; while (0);
 __ZN5Cache18WriteCacheInfoFileEb(i5, 0);
 HEAP8[i1 >> 0] = 1;
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, HEAP32[i4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return 0;
}

function __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 77;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 77;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i6, i7, i8, i4, i1, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i10 = __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_(i6, i7, i8, i4, i9) | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i11;
  return i10 | 0;
 }
 i12 = HEAP32[i4 >> 2] | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP16[i2 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i3 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i8 | 0) | 0)) {
  i12 = i10 + 1 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i12 = HEAP32[i8 >> 2] | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP16[i3 + 8 >> 1] = HEAP16[i2 + 8 >> 1] | 0;
 HEAP32[i4 >> 2] = i12;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i2 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0)) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 i1 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP16[i1 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 HEAP32[i8 >> 2] = i12;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i3 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i12 = i10 + 3 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i12 = HEAP32[i6 >> 2] | 0;
 i9 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP16[i5 + 8 >> 1] = HEAP16[i9 + 8 >> 1] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i9 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i1 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 i12 = i10 + 4 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i9, i1, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 i12 = i1;
 i6 = i13 - i12 | 0;
 i8 = i6 >> 1;
 i10 = i9 + 8 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i11 = i5;
 if (i8 >>> 0 > i2 - i5 >> 2 >>> 0) {
  i4 = i5;
  if (i5) {
   i2 = i9 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i11 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
   i11 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i2 = 0;
  }
  if ((i6 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
  } else i3 = 0;
  i11 = i2 - i3 | 0;
  i2 = i11 >> 1;
  i2 = i11 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i8 >>> 0 ? i8 : i2) : 2147483647;
  if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i4 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i5 = i9 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i4 + (i2 << 2);
  if ((i1 | 0) == (i13 | 0)) {
   STACKTOP = i14;
   return;
  }
  i3 = i13 + -2 - i12 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAPU16[i1 >> 1];
   i1 = i1 + 2 | 0;
   if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i5 >> 2] = i4 + ((i3 >>> 1) + 1 << 2);
  STACKTOP = i14;
  return;
 }
 i9 = i9 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = i10 - i5 >> 2;
 i4 = i8 >>> 0 > i7 >>> 0;
 i7 = i1 + (i7 << 1) | 0;
 i6 = i4 ? i7 : i13;
 i5 = i10;
 if ((i6 | 0) == (i1 | 0)) i1 = i11; else {
  i3 = i6 + -2 - i12 | 0;
  i2 = i11;
  while (1) {
   HEAP32[i2 >> 2] = HEAPU16[i1 >> 1];
   i1 = i1 + 2 | 0;
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i2 + 4 | 0;
  }
  i1 = i11 + ((i3 >>> 1) + 1 << 2) | 0;
 }
 if (!i4) {
  if ((i5 | 0) == (i1 | 0)) {
   STACKTOP = i14;
   return;
  }
  HEAP32[i9 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
  STACKTOP = i14;
  return;
 }
 if ((i6 | 0) == (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i13 + -2 - i6 | 0;
 i1 = i7;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAPU16[i1 >> 1];
  i1 = i1 + 2 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i9 >> 2] = i4 + ((i3 >>> 1) + 1 << 2);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -32 | 0;
  i5 = i1;
  i1 = i1 + -32 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -28 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -20 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -20 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -24 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -28 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -16 | 0;
  i7 = i5 + -16 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i17 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  i6 = (HEAP32[i13 >> 2] | 0) + -32 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZN8VRDevice21UpdateCameraTransformERK6Camera(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 48 | 0;
 i3 = i14 + 40 | 0;
 i11 = i14 + 16 | 0;
 i12 = i14;
 i9 = i14 + 36 | 0;
 i13 = i14 + 32 | 0;
 if (!(HEAP8[i2 + 1083 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i7 = i1 + 280 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i6 = (i8 | 0) == 0;
 if (i6) i1 = 0; else i1 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 __ZN7VRInput35InsertReferenceTransformIfNecessaryE4PPtrI9TransformE(i2, i10);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = -2147483632;
 HEAP32[i12 + 4 >> 2] = 14;
 i3 = i1;
 i4 = gb + 1044508 | 0;
 i5 = i3 + 14 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i1 + 14 >> 0] = 0;
 if (i6) i1 = 0; else i1 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 __ZNK7VRInput16GetLocalPositionERK8UnityStr4PPtrI9TransformE(i11, i2, i12, i10);
 __ZN9Transform16SetLocalPositionERK8Vector3f(i8, i11);
 if ((HEAP8[i12 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i12 >> 2] | 0;
  i6 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i2;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = -2147483632;
 HEAP32[i12 + 4 >> 2] = 14;
 i3 = i2;
 i4 = gb + 1044508 | 0;
 i5 = i3 + 14 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i2 + 14 >> 0] = 0;
 HEAP32[i13 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 __ZNK7VRInput16GetLocalRotationERK8UnityStr4PPtrI9TransformE(i11, i1, i12, i10);
 __ZN9Transform16SetLocalRotationERK11Quaternionf(i8, i11);
 if ((HEAP8[i12 + 11 >> 0] | 0) < 0) {
  i13 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 48 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 656402 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 48 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   i1 = i1 + 48 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 48 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 * 48 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 40 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i4 + (i1 * 48 | 0) + 44 >> 2] = HEAP32[i6 + 44 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 48 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 48 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 48 | 0) | 0;
 return i9 | 0;
}

function __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 48 | 0) + 1 | 0;
 if ((i8 | 0) < -48) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 48 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 2147483647;
 i1 = (i2 - i1 | 0) / 48 | 0;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 18;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 48 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i3 + (i1 * 48 | 0) | 0;
 i2 = i4;
 i7 = i3 + (i5 * 48 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + (i1 * 48 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + (i1 * 48 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + (i1 * 48 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + (i1 * 48 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 i5 = i3 + (i1 * 48 | 0) + 24 | 0;
 i1 = i6 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i5 = i4 + 48 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  do {
   i14 = i3;
   i3 = i3 + -48 | 0;
   HEAP32[i4 + -48 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 + -44 >> 2] = HEAP32[i14 + -44 >> 2];
   HEAP32[i4 + -40 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i4 + -36 >> 2] = HEAP32[i14 + -36 >> 2];
   HEAP32[i4 + -32 >> 2] = HEAP32[i14 + -32 >> 2];
   HEAP32[i4 + -28 >> 2] = HEAP32[i14 + -28 >> 2];
   i6 = i4 + -24 | 0;
   i14 = i14 + -24 | 0;
   HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   i4 = i2 + -48 | 0;
   i2 = i4;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 18;
 HEAP32[i10 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5UmbraL12processBlockEPKjPj(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22;
 i14 = HEAP32[i10 >> 2] | 0;
 i15 = i10 + 4 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i17 = i10 + 8 | 0;
 i18 = HEAP32[i17 >> 2] | 0;
 i19 = i10 + 12 | 0;
 i20 = HEAP32[i19 >> 2] | 0;
 i11 = i10 + 16 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i13 + 4 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i13 + 8 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 8 >> 2] | 0) | 0;
 HEAP32[i13 + 12 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 12 >> 2] | 0) | 0;
 HEAP32[i13 + 16 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 16 >> 2] | 0) | 0;
 HEAP32[i13 + 20 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 20 >> 2] | 0) | 0;
 HEAP32[i13 + 24 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 24 >> 2] | 0) | 0;
 HEAP32[i13 + 28 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 28 >> 2] | 0) | 0;
 HEAP32[i13 + 32 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 32 >> 2] | 0) | 0;
 HEAP32[i13 + 36 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 36 >> 2] | 0) | 0;
 HEAP32[i13 + 40 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 40 >> 2] | 0) | 0;
 HEAP32[i13 + 44 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 44 >> 2] | 0) | 0;
 HEAP32[i13 + 48 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 48 >> 2] | 0) | 0;
 HEAP32[i13 + 52 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 52 >> 2] | 0) | 0;
 HEAP32[i13 + 56 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 56 >> 2] | 0) | 0;
 HEAP32[i13 + 60 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 60 >> 2] | 0) | 0;
 i6 = i14;
 i4 = i12;
 i7 = i20;
 i8 = i18;
 i5 = i16;
 i9 = 0;
 while (1) {
  i1 = i9 & 15;
  do if ((i9 | 0) > 15) {
   i2 = i13 + (i1 << 2) | 0;
   i1 = HEAP32[i13 + ((i9 + 8 & 15) << 2) >> 2] ^ HEAP32[i13 + ((i9 + 13 & 15) << 2) >> 2] ^ HEAP32[i13 + ((i9 + 2 & 15) << 2) >> 2] ^ HEAP32[i2 >> 2];
   i1 = i1 >>> 31 | i1 << 1;
   HEAP32[i2 >> 2] = i1;
   i2 = i6 >>> 27 | i6 << 5;
   if ((i9 | 0) < 20) i21 = 5; else {
    if ((i9 | 0) < 40) {
     i3 = i8 ^ i5 ^ i7;
     break;
    }
    if ((i9 | 0) < 60) {
     i3 = (i7 | i8) & i5 | i7 & i8;
     break;
    } else {
     i3 = i8 ^ i5 ^ i7;
     break;
    }
   }
  } else {
   i1 = HEAP32[i13 + (i1 << 2) >> 2] | 0;
   i2 = i6 >>> 27 | i6 << 5;
   i21 = 5;
  } while (0);
  if ((i21 | 0) == 5) {
   i21 = 0;
   i3 = i7 & ~i5 | i8 & i5;
  }
  i2 = i2 + i4 + i3 + i1 + (HEAP32[gb + 80128 + (((i9 | 0) / 20 | 0) << 2) >> 2] | 0) | 0;
  i1 = i5 >>> 2 | i5 << 30;
  i9 = i9 + 1 | 0;
  if ((i9 | 0) == 80) break; else {
   i5 = i6;
   i3 = i8;
   i4 = i7;
   i6 = i2;
   i8 = i1;
   i7 = i3;
  }
 }
 HEAP32[i10 >> 2] = i14 + i2;
 HEAP32[i15 >> 2] = i16 + i6;
 HEAP32[i17 >> 2] = i18 + i1;
 HEAP32[i19 >> 2] = i20 + i8;
 HEAP32[i11 >> 2] = i12 + i7;
 STACKTOP = i22;
 return;
}

function __ZN17PolygonCollider2D15TransformPointsERK13dynamic_arrayI8Vector2fLj4EERK10Matrix4x4fRKS1_P6b2Vec2(i8, i9, i19, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0;
 i20 = i8 + 12 | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 if (!i3) {
  i24 = 0;
  return i24 | 0;
 }
 i21 = i19 + 4 | 0;
 i22 = i9 + 16 | 0;
 i23 = i9 + 32 | 0;
 i10 = i9 + 48 | 0;
 i11 = i9 + 4 | 0;
 i12 = i9 + 20 | 0;
 i13 = i9 + 36 | 0;
 i14 = i9 + 52 | 0;
 i15 = i9 + 8 | 0;
 i16 = i9 + 24 | 0;
 i17 = i9 + 40 | 0;
 i18 = i9 + 56 | 0;
 i7 = 0;
 i1 = 0;
 while (1) {
  i26 = HEAP32[i8 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i26 + (i7 << 3) >> 2]);
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i19 >> 2]));
  f6 = Math_fround(HEAPF32[i26 + (i7 << 3) + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i21 >> 2]));
  f4 = Math_fround(f27 * Math_fround(HEAPF32[i9 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i22 >> 2])));
  f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i23 >> 2]) * Math_fround(0.0)));
  f4 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f4);
  i26 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  f5 = Math_fround(f27 * Math_fround(HEAPF32[i11 >> 2]));
  f5 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2])));
  f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(0.0)));
  f5 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f5);
  i25 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  f27 = Math_fround(f27 * Math_fround(HEAPF32[i15 >> 2]));
  f6 = Math_fround(f27 + Math_fround(f6 * Math_fround(HEAPF32[i16 >> 2])));
  f6 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i17 >> 2]) * Math_fround(0.0)));
  f6 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f6);
  if (!((i26 & 2139095040 | 0) != 2139095040 & (i25 & 2139095040 | 0) != 2139095040 & ((HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) != 2139095040)) {
   i1 = 0;
   i24 = 9;
   break;
  }
  if (Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(f6 * f6)) > Math_fround(999999995.0e3)) {
   i1 = 0;
   i24 = 9;
   break;
  }
  if ((i1 | 0) > 0) {
   f6 = Math_fround(Math_fround(HEAPF32[i2 + -8 >> 2]) - f4);
   f27 = Math_fround(Math_fround(HEAPF32[i2 + -4 >> 2]) - f5);
   if (!(Math_fround(Math_fround(f6 * f6) + Math_fround(f27 * f27)) <= Math_fround(6.24999984e-06))) i24 = 7;
  } else i24 = 7;
  if ((i24 | 0) == 7) {
   i24 = 0;
   HEAPF32[i2 >> 2] = f4;
   HEAPF32[i2 + 4 >> 2] = f5;
   i1 = i1 + 1 | 0;
   i2 = i2 + 8 | 0;
   i3 = HEAP32[i20 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= i3 >>> 0) {
   i24 = 9;
   break;
  }
 }
 if ((i24 | 0) == 9) return i1 | 0;
 return 0;
}

function __Z14OutputContoursP14TESStesselatorP8TESSmeshi(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i7 = i8 + 92 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i8 + 100 | 0;
 HEAP32[i6 >> 2] = 0;
 i10 = i1 + 44 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) i1 = 0; else {
  i2 = 0;
  i3 = 0;
  do {
   if (HEAP8[i1 + 21 >> 0] | 0) {
    i5 = HEAP32[i1 + 8 >> 2] | 0;
    i4 = i5;
    do {
     i2 = i2 + 1 | 0;
     i4 = HEAP32[i4 + 12 >> 2] | 0;
    } while ((i4 | 0) != (i5 | 0));
    HEAP32[i7 >> 2] = i2;
    i3 = i3 + 1 | 0;
    HEAP32[i6 >> 2] = i3;
   }
   i1 = HEAP32[i1 >> 2] | 0;
  } while ((i1 | 0) != (i10 | 0));
  i1 = i3;
 }
 i2 = i8 + 104 | 0;
 i3 = i8 + 116 | 0;
 i6 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i1 << 3 | 0) | 0;
 i5 = i8 + 96 | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) {
  HEAP32[i8 + 4 >> 2] = 1;
  return;
 }
 i6 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, Math_imul(i9 << 2, HEAP32[i7 >> 2] | 0) | 0) | 0;
 i4 = i8 + 84 | 0;
 HEAP32[i4 >> 2] = i6;
 if (!i6) {
  HEAP32[i8 + 4 >> 2] = 1;
  return;
 }
 i1 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 HEAP32[i8 + 88 >> 2] = i1;
 if (!i1) {
  HEAP32[i8 + 4 >> 2] = 1;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if ((i4 | 0) == (i10 | 0)) return;
 if ((i9 | 0) > 2) {
  i8 = 0;
  i7 = i4;
  while (1) {
   if (!(HEAP8[i7 + 21 >> 0] | 0)) i4 = i8; else {
    i5 = HEAP32[i7 + 8 >> 2] | 0;
    i4 = 0;
    i6 = i1;
    i1 = i5;
    do {
     i11 = HEAP32[i1 + 16 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i11 + 12 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i11 + 16 >> 2];
     i9 = i2;
     i2 = i2 + 12 | 0;
     HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 20 >> 2];
     i9 = i6;
     i6 = i6 + 4 | 0;
     HEAP32[i9 >> 2] = HEAP32[i11 + 40 >> 2];
     i4 = i4 + 1 | 0;
     i1 = HEAP32[i1 + 12 >> 2] | 0;
    } while ((i1 | 0) != (i5 | 0));
    HEAP32[i3 >> 2] = i8;
    HEAP32[i3 + 4 >> 2] = i4;
    i4 = i4 + i8 | 0;
    i3 = i3 + 8 | 0;
    i1 = i6;
   }
   i7 = HEAP32[i7 >> 2] | 0;
   if ((i7 | 0) == (i10 | 0)) break; else i8 = i4;
  }
  return;
 } else {
  i8 = 0;
  i7 = i4;
  while (1) {
   if (!(HEAP8[i7 + 21 >> 0] | 0)) i4 = i8; else {
    i5 = HEAP32[i7 + 8 >> 2] | 0;
    i4 = 0;
    i6 = i1;
    i1 = i5;
    do {
     i9 = HEAP32[i1 + 16 >> 2] | 0;
     HEAP32[i2 >> 2] = HEAP32[i9 + 12 >> 2];
     i11 = i2;
     i2 = i2 + 8 | 0;
     HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 16 >> 2];
     i11 = i6;
     i6 = i6 + 4 | 0;
     HEAP32[i11 >> 2] = HEAP32[i9 + 40 >> 2];
     i4 = i4 + 1 | 0;
     i1 = HEAP32[i1 + 12 >> 2] | 0;
    } while ((i1 | 0) != (i5 | 0));
    HEAP32[i3 >> 2] = i8;
    HEAP32[i3 + 4 >> 2] = i4;
    i4 = i4 + i8 | 0;
    i3 = i3 + 8 | 0;
    i1 = i6;
   }
   i7 = HEAP32[i7 >> 2] | 0;
   if ((i7 | 0) == (i10 | 0)) break; else i8 = i4;
  }
  return;
 }
}

function __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 25;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 25;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZN7dtCrowd20UpdateActiveAgentIDsEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i5 = i6 + 392 | 0;
  i4 = HEAP32[i6 + 16 >> 2] | 0;
  i3 = 0;
  i2 = 0;
  do {
   if (HEAP8[i4 + (i3 * 608 | 0) + 602 >> 0] & 1) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i3;
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 } else i2 = 0;
 HEAP32[i6 + 400 >> 2] = i2;
 i14 = i6 + 380 | 0;
 i15 = i6 + 384 | 0;
 __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE(i14, HEAP32[i15 >> 2] | 0);
 i10 = i6 + 388 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i14 >> 2] = i15;
 HEAP32[i15 >> 2] = 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i11 = i6 + 392 | 0;
 i12 = i6 + 20 | 0;
 i13 = i15;
 i9 = i6 + 384 | 0;
 i8 = 0;
 do {
  i7 = (HEAP32[i12 >> 2] | 0) + ((HEAP32[(HEAP32[i11 >> 2] | 0) + (i8 << 2) >> 2] | 0) * 56 | 0) + 40 | 0;
  i6 = i7;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  if (!((i5 | 0) == 0 & (i6 | 0) == 0)) {
   i1 = HEAP32[i15 >> 2] | 0;
   do if (!i1) {
    HEAP32[i16 >> 2] = i15;
    i5 = i13;
    i4 = i15;
   } else {
    while (1) {
     i4 = i1 + 16 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (i6 >>> 0 < i4 >>> 0 | (i6 | 0) == (i4 | 0) & i5 >>> 0 < i3 >>> 0) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) {
       i3 = 13;
       break;
      } else i1 = i3;
     } else {
      if (!(i4 >>> 0 < i6 >>> 0 | (i4 | 0) == (i6 | 0) & i3 >>> 0 < i5 >>> 0)) {
       i3 = 18;
       break;
      }
      i4 = i1 + 4 | 0;
      i3 = HEAP32[i4 >> 2] | 0;
      if (!i3) {
       i3 = 17;
       break;
      } else i1 = i3;
     }
    }
    if ((i3 | 0) == 13) {
     HEAP32[i16 >> 2] = i1;
     i5 = i1;
     i4 = i1;
     break;
    } else if ((i3 | 0) == 17) {
     HEAP32[i16 >> 2] = i1;
     i5 = i1;
     break;
    } else if ((i3 | 0) == 18) {
     HEAP32[i16 >> 2] = i1;
     i5 = i1;
     i4 = i16;
     break;
    }
   } while (0);
   if (!(HEAP32[i4 >> 2] | 0)) {
    i1 = __Znwj(24) | 0;
    i6 = i7;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i3 = i1 + 16 | 0;
    HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i3 + 4 >> 2] = i7;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = i5;
    HEAP32[i4 >> 2] = i1;
    i3 = HEAP32[HEAP32[i14 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i14 >> 2] = i3;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   }
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i2 | 0));
 STACKTOP = i17;
 return;
}

function __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 i3 = mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0;
 do if (i2) {
  i2 = i4;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i3) {
   i10 = i6;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i4;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   i3 = i6;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i3 + 4 >> 2] = i2;
   i1 = 1;
   break;
  }
  i3 = i5;
  i9 = HEAP32[i3 + 4 >> 2] | 0;
  i10 = i4;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  i10 = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 4 >> 2] = i2;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0) {
   i10 = i5;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i2 = i6;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = i5;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i6;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 4 >> 2] = i10;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  i9 = i5;
  i3 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = i6;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i10 = i5;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 + 4 >> 2] = i2;
  i10 = i6;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i10 + 4 >> 2] = i9;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, i4 | 0) | 0) {
   i10 = i4;
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 4 >> 2] | 0;
   i2 = i5;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i5;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i1 + 4 >> 2] = i10;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i10 = i1;
  return i10 | 0;
 }
 i9 = i6;
 i3 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i7;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i2;
 i10 = i7;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 4 >> 2] = i9;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0)) {
  i11 = i1 + 1 | 0;
  return i11 | 0;
 }
 i10 = i5;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i6;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i5;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 i11 = i6;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
  i11 = i1 + 2 | 0;
  return i11 | 0;
 }
 i10 = i4;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i5;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 i11 = i5;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = i1 + 3 | 0;
 return i11 | 0;
}

function __ZN5physx10PxsContext28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskE(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = i16 + 224 | 0;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i15 >> 2] | 0, HEAP32[i16 + 6976 >> 2] | 0);
 i14 = i16 + 1356 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP32[i16 + 6968 >> 2] | 0);
 i8 = i16 + 1360 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (HEAP32[i16 + 6972 >> 2] | 0);
 i1 = __ZN5physx6shdfnd9SListImpl5flushEv(HEAP32[i15 >> 2] | 0) | 0;
 i9 = i16 + 7568 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = (i1 | 0) == 0;
 if (i10) {
  i2 = i1;
  i3 = 0;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i1;
 }
 i11 = i16 + 7588 | 0;
 i12 = i16 + 7592 | 0;
 i13 = i16 + 1344 | 0;
 L4 : while (1) {
  i7 = (i2 | 0) == 0;
  while (1) {
   if (!i3) break L4;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP32[i3 + 9152 >> 2] | 0);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (HEAP32[i3 + 9148 >> 2] | 0);
   i5 = 0;
   do {
    i4 = i16 + 6980 + (i5 * 28 | 0) | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 4 >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 8 >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 12 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 12 >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 16 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 16 >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 20 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 20 >> 2] | 0);
    i4 = i16 + 6980 + (i5 * 28 | 0) + 24 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + (HEAP32[i3 + 120 + (i5 * 28 | 0) + 24 >> 2] | 0);
    i4 = HEAP32[i9 >> 2] | 0;
    i6 = i5;
    do {
     i4 = i4 + (HEAP32[i3 + 120 + (i5 * 28 | 0) + (i6 << 2) >> 2] | 0) | 0;
     HEAP32[i9 >> 2] = i4;
     i6 = i6 + 1 | 0;
    } while ((i6 | 0) != 7);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != 7);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i3 + 8776 >> 2] | 0);
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + (HEAP32[i3 + 8780 >> 2] | 0);
   __ZN5physx18PxcNpThreadContext10clearStatsEv(i3 + 16 | 0);
   __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj(i13, HEAP32[i3 + 9136 >> 2] | 0, HEAP32[i3 + 9140 >> 2] & 2147483647);
   if (i7) i3 = 0; else break;
  }
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 if (i10) return;
 do {
  i16 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i15 >> 2] | 0, i16);
 } while ((i1 | 0) != 0);
 return;
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6insertENS_11__wrap_iterIPKhEEjRS6_(i11, i2, i12, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i11 >> 2] | 0;
 i5 = i14;
 i14 = i14 + ((HEAP32[i2 >> 2] | 0) - i5) | 0;
 if (!i12) {
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i11 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i15 = i11 + 4 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i2 = i7;
 if ((i3 - i2 | 0) >>> 0 >= i12 >>> 0) {
  i3 = i2 - i14 | 0;
  if (i3 >>> 0 < i12 >>> 0) {
   i2 = i12 - i3 | 0;
   i4 = i7;
   do {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    i4 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
    HEAP32[i15 >> 2] = i4;
    i2 = i2 + -1 | 0;
   } while ((i2 | 0) != 0);
   if (!i3) {
    i15 = i14;
    STACKTOP = i16;
    return i15 | 0;
   }
  } else {
   i3 = i12;
   i4 = i7;
  }
  i6 = i4 - (i14 + i12) | 0;
  i2 = i14 + i6 | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i5 = i4;
   do {
    HEAP8[i5 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i5 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
    HEAP32[i15 >> 2] = i5;
   } while ((i2 | 0) != (i7 | 0));
  }
  if (i6 | 0) _memmove(i4 + (0 - i6) | 0, i14 | 0, i6 | 0) | 0;
  if (i14 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i15 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + i12 | 0 : i1;
  _memset(i14 | 0, HEAP8[i1 >> 0] | 0, i3 | 0) | 0;
  i15 = i14;
  STACKTOP = i16;
  return i15 | 0;
 }
 i9 = i11 + 12 | 0;
 i4 = i2 - i5 + i12 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
 } else i2 = i3;
 i6 = i2 - i5 | 0;
 i2 = i6 << 1;
 i2 = i6 >>> 0 < 1073741823 ? (i2 >>> 0 < i4 >>> 0 ? i4 : i2) : 2147483647;
 i6 = i14;
 if (!i2) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i13 >> 2] = 14;
  HEAP32[i13 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 }
 i8 = i3 + (i6 - i5) | 0;
 i7 = i3 + i2 | 0;
 i2 = i12;
 i3 = i8;
 i4 = i8;
 do {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i4 = i3 + 1 | 0;
  i3 = i4;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i6 - i1 | 0;
 i5 = i8 + (0 - i2) | 0;
 if ((i2 | 0) > 0) _memcpy(i5 | 0, i1 | 0, i2 | 0) | 0;
 i1 = (HEAP32[i15 >> 2] | 0) - i6 | 0;
 if ((i1 | 0) > 0) {
  _memcpy(i4 | 0, i14 | 0, i1 | 0) | 0;
  i1 = i4 + i1 | 0;
 } else i1 = i3;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i15 >> 2] = i1;
 HEAP32[i10 >> 2] = i7;
 if (!i2) {
  i15 = i8;
  STACKTOP = i16;
  return i15 | 0;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i13 >> 2] = 14;
 HEAP32[i13 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i13);
 i15 = i8;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK10Matrix4x4f10IsIdentityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-1.0));
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if ((i5 ? f4 : f3) <= f2) {
  f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f3 = Math_fround(-f4);
  if ((i5 ? f3 : f4) <= f2) {
   f4 = Math_fround(HEAPF32[i1 + 32 >> 2]);
   i5 = f4 < Math_fround(0.0);
   f3 = Math_fround(-f4);
   if ((i5 ? f3 : f4) <= f2) {
    f4 = Math_fround(HEAPF32[i1 + 48 >> 2]);
    i5 = f4 < Math_fround(0.0);
    f3 = Math_fround(-f4);
    if ((i5 ? f3 : f4) <= f2) {
     f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     i5 = f4 < Math_fround(0.0);
     f3 = Math_fround(-f4);
     if ((i5 ? f3 : f4) <= f2) {
      f4 = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) + Math_fround(-1.0));
      i5 = f4 < Math_fround(0.0);
      f3 = Math_fround(-f4);
      if ((i5 ? f3 : f4) <= f2) {
       f4 = Math_fround(HEAPF32[i1 + 36 >> 2]);
       i5 = f4 < Math_fround(0.0);
       f3 = Math_fround(-f4);
       if ((i5 ? f3 : f4) <= f2) {
        f4 = Math_fround(HEAPF32[i1 + 52 >> 2]);
        i5 = f4 < Math_fround(0.0);
        f3 = Math_fround(-f4);
        if ((i5 ? f3 : f4) <= f2) {
         f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
         i5 = f4 < Math_fround(0.0);
         f3 = Math_fround(-f4);
         if ((i5 ? f3 : f4) <= f2) {
          f4 = Math_fround(HEAPF32[i1 + 24 >> 2]);
          i5 = f4 < Math_fround(0.0);
          f3 = Math_fround(-f4);
          if ((i5 ? f3 : f4) <= f2) {
           f4 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) + Math_fround(-1.0));
           i5 = f4 < Math_fround(0.0);
           f3 = Math_fround(-f4);
           if ((i5 ? f3 : f4) <= f2) {
            f4 = Math_fround(HEAPF32[i1 + 56 >> 2]);
            i5 = f4 < Math_fround(0.0);
            f3 = Math_fround(-f4);
            if ((i5 ? f3 : f4) <= f2) {
             f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
             i5 = f4 < Math_fround(0.0);
             f3 = Math_fround(-f4);
             if ((i5 ? f3 : f4) <= f2) {
              f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
              i5 = f4 < Math_fround(0.0);
              f3 = Math_fround(-f4);
              if ((i5 ? f3 : f4) <= f2) {
               f4 = Math_fround(HEAPF32[i1 + 44 >> 2]);
               i5 = f4 < Math_fround(0.0);
               f3 = Math_fround(-f4);
               if ((i5 ? f3 : f4) <= f2) {
                f4 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) + Math_fround(-1.0));
                i5 = f4 < Math_fround(0.0);
                f3 = Math_fround(-f4);
                if ((i5 ? f3 : f4) <= f2) {
                 i5 = 1;
                 return i5 | 0;
                }
               }
              }
             }
            }
           }
          }
         }
        }
       }
      }
     }
    }
   }
  }
 }
 i5 = 0;
 return i5 | 0;
}

function __ZN8Animator19SetVisibleRenderersEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i10 = i11;
 i8 = i11 + 16 | 0;
 i9 = i6 + 88 | 0;
 if (i1) i2 = (HEAP8[i9 >> 0] | 0) == 0; else i2 = 0;
 HEAP8[i9 >> 0] = i1 & 1;
 if (!(__Z14IsWorldPlayingv() | 0)) {
  STACKTOP = i11;
  return;
 }
 if (i2) {
  f5 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
  i4 = i6 + 36 | 0;
  if (f5 == Math_fround(0.0) | (HEAP32[i4 >> 2] | 0) == 0) {
   STACKTOP = i11;
   return;
  }
  i2 = i6 + 153 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i3 = 8; else if (!(HEAP32[i6 + 168 >> 2] | 0)) i3 = 8;
  if ((i3 | 0) == 8) __ZN8Animator12CreateObjectEv(i6);
  if (HEAP32[i6 + 108 >> 2] | 0) {
   i1 = HEAP32[i6 + 624 >> 2] | 0;
   if (i1 | 0) {
    i1 = HEAP32[i1 + 96 >> 2] | 0;
    if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i6 + 420 >> 2];
   }
  }
  if (HEAP8[i2 >> 0] | 0) if (HEAP32[i6 + 168 >> 2] | 0) {
   i1 = HEAP32[i6 + 136 >> 2] | 0;
   if ((HEAP32[i6 + 92 >> 2] | 0) == 2) i3 = 1; else i3 = (HEAP8[i1 + 136 >> 0] | 0) != 0;
   HEAP8[i1 + 136 >> 0] = 1;
   HEAP8[i1 + 137 >> 0] = 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i1 = i6 + 624 | 0;
    if (HEAP32[i1 >> 2] | 0) {
     __ZN18PlayableController4TickEf(i2, f5);
     i12 = HEAP32[i1 >> 2] | 0;
     i1 = gb + 64016 | 0;
     i4 = HEAP32[i1 + 4 >> 2] | 0;
     i13 = i10;
     HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i13 + 4 >> 2] = i4;
     HEAP32[i8 >> 2] = 0;
     i13 = i8 + 12 | 0;
     HEAP32[i13 >> 2] = 0;
     i4 = i8 + 16 | 0;
     i1 = i8 + 4 | 0;
     __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i10);
     i14 = i7;
     i7 = HEAP32[i14 + 4 >> 2] | 0;
     i10 = i1;
     HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i10 + 4 >> 2] = i7;
     HEAP32[i4 >> 2] = 1;
     i10 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 24, 8, i1, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i8 >> 2] = i10;
     HEAP32[i13 >> 2] = 1;
     HEAP32[i10 >> 2] = i2;
     HEAP32[i10 + 4 >> 2] = i6;
     HEAP32[i10 + 12 >> 2] = i12;
     __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb(i8, i3, 1, 1);
     if ((HEAP32[i4 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i1);
      HEAP32[i8 >> 2] = 0;
     }
    }
   }
  }
 }
 if (!(__ZNK9HPlayable7IsValidEv(i6 + 628 | 0) | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i9 >> 0] | 0)) if ((HEAP32[i6 + 92 >> 2] | 0) == 2) {
  i14 = HEAP32[(HEAP32[i6 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, 0);
  STACKTOP = i11;
  return;
 }
 i14 = HEAP32[(HEAP32[i6 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, 1);
 STACKTOP = i11;
 return;
}

function __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 92 | 0, i5);
 i1 = i7 + 40 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i9 = i11;
 i1 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 12 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i8, HEAP32[i2 >> 2] | 0);
 i10 = HEAP32[i1 >> 2] | 0;
 L4 : do if (HEAP32[i2 >> 2] | 0) {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) i1 = gb + 1034517 | 0; else {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   HEAP8[i1 >> 0] = 80;
   HEAP8[i1 + 1 >> 0] = 80;
   HEAP8[i1 + 2 >> 0] = 116;
   HEAP8[i1 + 3 >> 0] = 114;
   HEAP8[i1 + 4 >> 0] = 60;
   i2 = i1 + 6 | 0;
   HEAP8[i1 + 5 >> 0] = 36;
   i3 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   if (i4 << 24 >> 24) do {
    HEAP8[i2 >> 0] = i4;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
   } while (i4 << 24 >> 24 != 0);
   HEAP8[i2 >> 0] = 62;
   HEAP8[i2 + 1 >> 0] = 0;
  }
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i1, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) != 2) {
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   i1 = HEAP32[i8 >> 2] | 0;
   if ((i1 | 0) == (i10 | 0)) break;
   while (1) {
    __ZN14SafeBinaryRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1041891 | 0, 0);
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i10 | 0)) break L4;
   }
  }
  i2 = HEAP32[i4 >> 2] | 0;
  i7 = HEAP32[i2 + 12 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  L18 : do if ((i1 | 0) != (i10 | 0)) {
   i3 = 0;
   while (1) {
    i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
    HEAP32[i2 + 20 >> 2] = i13;
    HEAP32[i2 + 12 >> 2] = i13;
    __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
    i13 = i9;
    i3 = HEAP32[i13 + 4 >> 2] | 0;
    i8 = i2 + 24 | 0;
    HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i8 + 4 >> 2] = i3;
    i8 = HEAP32[i6 >> 2] | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
    i1 = i1 + 12 | 0;
    if ((i1 | 0) == (i10 | 0)) break L18;
    i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i12);
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function _UNITY_png_do_strip_channel(i6, i8, i1) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i6 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i5 = i8 + i3 | 0;
 i7 = i6 + 10 | 0;
 switch (HEAP8[i7 >> 0] | 0) {
 case 2:
  {
   switch (HEAP8[i6 + 9 >> 0] | 0) {
   case 8:
    {
     i4 = (i1 | 0) == 0;
     i2 = i8 + 1 | 0;
     i1 = i4 ? i2 : i8;
     i2 = i4 ? i8 + 2 | 0 : i2;
     if (i2 >>> 0 < i5 >>> 0) {
      i4 = ((i8 + (i3 + -1 - i2) | 0) >>> 1) + 1 | 0;
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       i2 = i2 + 2 | 0;
       if (i2 >>> 0 >= i5 >>> 0) break; else i3 = i3 + 1 | 0;
      }
      i1 = i1 + i4 | 0;
     }
     HEAP8[i6 + 11 >> 0] = 8;
     break;
    }
   case 16:
    {
     i4 = (i1 | 0) == 0;
     i2 = i8 + 2 | 0;
     i1 = i4 ? i2 : i8;
     i2 = i4 ? i8 + 4 | 0 : i2;
     if (i2 >>> 0 < i5 >>> 0) {
      i4 = ((i8 + (i3 + -1 - i2) | 0) >>> 2 << 1) + 2 | 0;
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP8[i3 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
       i2 = i2 + 4 | 0;
       if (i2 >>> 0 >= i5 >>> 0) break; else i3 = i3 + 2 | 0;
      }
      i1 = i1 + i4 | 0;
     }
     HEAP8[i6 + 11 >> 0] = 16;
     break;
    }
   default:
    return;
   }
   HEAP8[i7 >> 0] = 1;
   i2 = i6 + 8 | 0;
   if ((HEAP8[i2 >> 0] | 0) == 4) HEAP8[i2 >> 0] = 0;
   break;
  }
 case 4:
  {
   switch (HEAP8[i6 + 9 >> 0] | 0) {
   case 8:
    {
     i2 = (i1 | 0) == 0;
     i1 = i2 ? i8 + 3 | 0 : i8;
     i2 = i2 ? i8 + 4 | 0 : i8 + 1 | 0;
     if (i2 >>> 0 < i5 >>> 0) {
      i4 = (((i8 + (i3 + -1 - i2) | 0) >>> 2) * 3 | 0) + 3 | 0;
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP8[i3 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
       HEAP8[i3 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
       i2 = i2 + 4 | 0;
       if (i2 >>> 0 >= i5 >>> 0) break; else i3 = i3 + 3 | 0;
      }
      i1 = i1 + i4 | 0;
     }
     HEAP8[i6 + 11 >> 0] = 24;
     break;
    }
   case 16:
    {
     i2 = (i1 | 0) == 0;
     i1 = i2 ? i8 + 6 | 0 : i8;
     i2 = i2 ? i8 + 8 | 0 : i8 + 2 | 0;
     if (i2 >>> 0 < i5 >>> 0) {
      i4 = (((i8 + (i3 + -1 - i2) | 0) >>> 3) * 6 | 0) + 6 | 0;
      i3 = i1;
      while (1) {
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       HEAP8[i3 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
       HEAP8[i3 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
       HEAP8[i3 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
       HEAP8[i3 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
       HEAP8[i3 + 5 >> 0] = HEAP8[i2 + 5 >> 0] | 0;
       i2 = i2 + 8 | 0;
       if (i2 >>> 0 >= i5 >>> 0) break; else i3 = i3 + 6 | 0;
      }
      i1 = i1 + i4 | 0;
     }
     HEAP8[i6 + 11 >> 0] = 48;
     break;
    }
   default:
    return;
   }
   HEAP8[i7 >> 0] = 3;
   i2 = i6 + 8 | 0;
   if ((HEAP8[i2 >> 0] | 0) == 6) HEAP8[i2 >> 0] = 2;
   break;
  }
 default:
  return;
 }
 HEAP32[i9 >> 2] = i1 - i8;
 return;
}

function __ZN9Projector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i7 + 24 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i5 = i3;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i5 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i2 = i5;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i6 + 52 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 64 | 0, i7);
 i1 = i6 + 60 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i10 = HEAP32[i8 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i10 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i10;
  HEAP32[i9 >> 2] = i3;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN13SliderJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802905 | 0, i6, i1 + 118 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803298 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803251 | 0, i6, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 100 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803262 | 0, gb + 803270 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803306 | 0, i5, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803319 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802926 | 0, i6, i1 + 117 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802938 | 0, gb + 802958 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802983 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803002 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function _psh_hint_table_find_strong_points(i9, i10, i2, i1, i12, i13) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 if (!i1) return;
 i14 = 0 - i13 | 0;
 i15 = (i9 | 0) == 0;
 i11 = (i13 | 0) == 2;
 i8 = i11 ? 128 : 256;
 i11 = i11 ? 256 : 128;
 while (1) {
  i7 = HEAP32[i2 + 28 >> 2] | 0;
  i5 = i2 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  L6 : do if (!(i6 & 16)) {
   i4 = HEAP16[i2 + 20 >> 1] | 0;
   i3 = (i4 & 65535) << 24 >> 24;
   if ((i3 | 0) == (i13 | 0) | (i3 | 0) == (i14 | 0)) i16 = 6; else {
    i3 = ((i4 & 65535) >>> 8 & 65535) << 24 >> 24;
    if ((i3 | 0) == (i13 | 0) | (i3 | 0) == (i14 | 0)) i16 = 6;
   }
   if ((i16 | 0) == 6) {
    i16 = 0;
    if (i3 | 0) if ((i3 | 0) == (i13 | 0)) {
     if (i15) break; else i3 = 0;
     while (1) {
      i4 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
      i17 = i7 - (HEAP32[i4 >> 2] | 0) | 0;
      i3 = i3 + 1 | 0;
      if ((i17 | 0) < (i12 | 0) & (0 - i17 | 0) < (i12 | 0)) break;
      if (i3 >>> 0 >= i9 >>> 0) break L6;
     }
     HEAP32[i5 >> 2] = i6 | 528;
     HEAP32[i2 + 24 >> 2] = i4;
     break;
    } else {
     if ((i3 | 0) != (i14 | 0) | i15) break; else i3 = 0;
     while (1) {
      i4 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
      i17 = i7 - (HEAP32[i4 >> 2] | 0) - (HEAP32[i4 + 4 >> 2] | 0) | 0;
      i3 = i3 + 1 | 0;
      if ((i17 | 0) < (i12 | 0) & (0 - i17 | 0) < (i12 | 0)) break;
      if (i3 >>> 0 >= i9 >>> 0) break L6;
     }
     HEAP32[i5 >> 2] = i6 | 1040;
     HEAP32[i2 + 24 >> 2] = i4;
     break;
    }
   }
   if (i6 & 64 | 0) {
    L26 : do if (!(i6 & i8)) {
     if (!((i6 & i11 | 0) == 0 | i15)) {
      i3 = 0;
      while (1) {
       i4 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
       i17 = i7 - (HEAP32[i4 >> 2] | 0) - (HEAP32[i4 + 4 >> 2] | 0) | 0;
       i3 = i3 + 1 | 0;
       if ((i17 | 0) < (i12 | 0) & (0 - i17 | 0) < (i12 | 0)) break;
       if (i3 >>> 0 >= i9 >>> 0) break L26;
      }
      HEAP32[i2 + 24 >> 2] = i4;
      HEAP32[i5 >> 2] = i6 | 1040;
     }
    } else {
     if (i15) break L6; else i3 = 0;
     while (1) {
      i4 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
      i17 = i7 - (HEAP32[i4 >> 2] | 0) | 0;
      i3 = i3 + 1 | 0;
      if ((i17 | 0) < (i12 | 0) & (0 - i17 | 0) < (i12 | 0)) break;
      if (i3 >>> 0 >= i9 >>> 0) break L26;
     }
     HEAP32[i2 + 24 >> 2] = i4;
     HEAP32[i5 >> 2] = i6 | 528;
    } while (0);
    i4 = i2 + 24 | 0;
    if (!((HEAP32[i4 >> 2] | 0) != 0 | i15)) {
     i3 = 0;
     while (1) {
      i5 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
      i6 = HEAP32[i5 >> 2] | 0;
      if ((i7 | 0) >= (i6 | 0)) if ((i7 | 0) <= ((HEAP32[i5 + 4 >> 2] | 0) + i6 | 0)) break;
      i3 = i3 + 1 | 0;
      if (i3 >>> 0 >= i9 >>> 0) break L6;
     }
     HEAP32[i4 >> 2] = i5;
    }
   }
  } while (0);
  i1 = i1 + -1 | 0;
  if (!i1) break; else i2 = i2 + 40 | 0;
 }
 return;
}

function __ZN29RenderNodeQueuePrepareContextD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[gb + 1112412 + (i1 << 4) + 4 >> 2] | 0;
  if (i2 | 0) mftCall_vi(i2 | 0, HEAP32[i3 + 1508 + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 i1 = i3 + 1280 | 0;
 if ((HEAP32[i3 + 1296 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1284 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1200 | 0;
 if ((HEAP32[i3 + 1216 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1204 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1120 | 0;
 if ((HEAP32[i3 + 1136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1040 | 0;
 if ((HEAP32[i3 + 1056 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1044 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 960 | 0;
 if ((HEAP32[i3 + 976 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 964 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 880 | 0;
 if ((HEAP32[i3 + 896 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 884 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 800 | 0;
 if ((HEAP32[i3 + 816 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 804 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 720 | 0;
 if ((HEAP32[i3 + 736 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 724 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 640 | 0;
 if ((HEAP32[i3 + 656 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 644 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 560 | 0;
 if ((HEAP32[i3 + 576 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 564 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 480 | 0;
 if ((HEAP32[i3 + 496 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 484 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 400 | 0;
 if ((HEAP32[i3 + 416 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 404 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 320 | 0;
 if ((HEAP32[i3 + 336 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 324 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 240 | 0;
 if ((HEAP32[i3 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 160 | 0;
 if ((HEAP32[i3 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 80 | 0;
 if ((HEAP32[i3 + 96 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13AnimationClip9PPtrCurveaSERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i9 | 0) == (i8 | 0)) {
  i6 = i8 + 32 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i9 + 32 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  return i9 | 0;
 }
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i3 = i9 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 i1 = i9 + 16 | 0;
 i6 = i8 + 16 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i8 + 20 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i9 + 20 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 20 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i7 = i8 + 32 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i9 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i9 + 40 | 0;
 i6 = HEAP32[i8 + 40 >> 2] | 0;
 i7 = i9 + 52 | 0;
 i1 = HEAP32[i8 + 52 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 return i9 | 0;
}

function __ZN5Light9SetCookieEP7Texture(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 8 | 0;
 i8 = i13;
 i12 = i11 + 44 | 0;
 i4 = HEAP32[(HEAP32[i12 >> 2] | 0) + 92 >> 2] | 0;
 if (!i4) i5 = 0; else {
  HEAP32[i8 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 9;
   }
  }
  if ((i9 | 0) == 7) i9 = 9;
  if ((i9 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  i5 = i1;
 }
 i6 = (i10 | 0) == 0;
 if (i6) i1 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  if (!i4) i1 = 0; else {
   HEAP32[i8 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 18; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i8 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 18; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 20;
    }
   }
   if ((i9 | 0) == 18) i9 = 20;
   if ((i9 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  }
 }
 if ((i5 | 0) == (i1 | 0)) {
  STACKTOP = i13;
  return;
 }
 __ZNK5Light16UnshareLightDataEv(i11);
 if (i6) i1 = 0; else i1 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[(HEAP32[i12 >> 2] | 0) + 92 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0);
 __ZNK5Light16UnshareLightDataEv(i11);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i12 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i11);
 __ZN5Light10SetupFlareEv(i11);
 STACKTOP = i13;
 return;
}

function __Z29CalculateClippedBoxConvexHullPfPKfff(i6, i1, f7, f4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i17;
 i14 = i17 + 136 | 0;
 i15 = i17 + 116 | 0;
 i16 = i17 + 96 | 0;
 HEAP32[i14 >> 2] = 0;
 i19 = i14 + 12 | 0;
 HEAP32[i19 >> 2] = 0;
 i8 = i14 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i11 = i5;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i15 >> 2] = 0;
 i2 = i15 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i10 = i15 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i13 = i5;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 HEAP32[i16 >> 2] = 0;
 i3 = i16 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i12 = i16 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i16 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i21 = i5;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i18 = i13;
 HEAP32[i18 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i18 + 4 >> 2] = i20;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i18 = (HEAP32[i10 >> 2] | 0) > -1;
 HEAP32[i19 >> 2] = 8;
 HEAP32[i8 >> 2] = -2147483640;
 HEAP32[i14 >> 2] = i1;
 if (i18) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11);
  HEAP32[i15 >> 2] = 0;
 }
 HEAP32[i10 >> 2] = -2147483636;
 HEAP32[i15 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i13);
  HEAP32[i16 >> 2] = 0;
 }
 HEAP32[i12 >> 2] = -2147483635;
 HEAP32[i16 >> 2] = i17 + 160;
 HEAP32[i3 >> 2] = 0;
 __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff(i15, i14, f7, f4);
 __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_(i16, i15);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = HEAP32[i16 >> 2] | 0;
  i2 = 0;
  do {
   i21 = i6 + (i2 * 3 << 2) | 0;
   HEAP32[i21 >> 2] = HEAP32[i3 + (i2 << 3) >> 2];
   HEAPF32[i21 + 4 >> 2] = f7;
   HEAP32[i21 + 8 >> 2] = HEAP32[i3 + (i2 << 3) + 4 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i12 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i16 >> 2] | 0, i13);
  HEAP32[i16 >> 2] = 0;
 }
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i11);
  HEAP32[i15 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i9);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN5physx13NpRigidStatic13setGlobalPoseERKNS_11PxTransformEb(i16, i2, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f17 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15;
 i7 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i16) | 0;
 i13 = i16 + 48 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f8 * f8);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f9 * f9));
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f10 * f10));
 f17 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f17 * f17)))));
 f8 = Math_fround(f8 * f11);
 f9 = Math_fround(f9 * f11);
 f10 = Math_fround(f10 * f11);
 f11 = Math_fround(f17 * f11);
 HEAPF32[i3 >> 2] = f8;
 HEAPF32[i3 + 4 >> 2] = f9;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = f11;
 i12 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 + 16 >> 2] = i12;
 i14 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i3 + 20 >> 2] = i14;
 i5 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = i5;
 i1 = i16 + 64 | 0;
 i6 = i16 + 52 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i13;
   i2 = 5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i13 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else {
    i3 = i13;
    i2 = 5;
   }
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) __ZN5physx2Sc10StaticCore14setActor2WorldERKNS_11PxTransformE(i1, i3); else if ((i2 | 0) == 5) {
  i2 = i16 + 56 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAPF32[i1 + 96 >> 2] = f8;
  HEAPF32[i1 + 100 >> 2] = f9;
  HEAPF32[i1 + 104 >> 2] = f10;
  HEAPF32[i1 + 108 >> 2] = f11;
  HEAP32[i1 + 112 >> 2] = i12;
  HEAP32[i1 + 116 >> 2] = i14;
  HEAP32[i1 + 120 >> 2] = i5;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i13);
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 64;
 }
 if (i7 | 0) {
  __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i16 + 20 | 0, i7 + 3392 | 0);
  i14 = i7 + 3412 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i16 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i4) {
  STACKTOP = i15;
  return;
 }
 i1 = 0;
 while (1) {
  if (!(HEAP8[i3 + (i1 << 3) >> 0] | 0)) {
   i2 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   if (!i2) {
    i2 = 17;
    break;
   }
   __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE(i2, i16);
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i2 = 17;
   break;
  }
 }
 if ((i2 | 0) == 17) {
  STACKTOP = i15;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13BoneInfluenceLj16EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 32 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i7 = i12 + 8 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = 0;
 __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i4, i2, i10, 1);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 5) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 426264 | 0, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN13BoneInfluence8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 426264 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13BoneInfluence8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i4, i6, i8, i9, i10, i11, i5) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((i11 | 0) == (i10 | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 i7 = HEAP32[i1 + 2540 >> 2] | 0;
 i2 = i4 + 856 | 0;
 if (!(HEAP8[(HEAP32[i2 >> 2] | 0) + 4 >> 0] | 0)) i3 = (HEAP8[(HEAP32[i4 + 896 >> 2] | 0) + 4 >> 0] | 0) != 0; else i3 = 1;
 __ZNK13InitialModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4Eb(i1, i6, i8, i9, i10, i11, i5, i3);
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) {
  HEAP32[i12 + 12 >> 2] = i7;
  HEAP32[i12 + 8 >> 2] = i7;
  HEAP32[i12 + 4 >> 2] = i7;
  HEAP32[i12 >> 2] = i7;
  __ZN14RotationModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj(i1, i6, i8, i9, i12, i10, i11);
 }
 i1 = HEAP32[i4 + 868 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN14VelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj(i1, i6, i8, i9, i10, i11);
 i1 = HEAP32[i4 + 888 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN11NoiseModule6UpdateERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjjfRKN4math7_float4E(i1, i6, i9, i10, i11, Math_fround(HEAPF32[i8 + 396 >> 2]), i5);
 i1 = HEAP32[i4 + 872 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN21InheritVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj(i1, i6, i8, i9, i10, i11);
 i1 = HEAP32[i4 + 876 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN11ForceModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i6, i8, i9, i10, i11, i5);
 i1 = HEAP32[i4 + 880 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN20ExternalForcesModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i6, i8, i9, i10, i11, i5);
 i1 = HEAP32[i4 + 884 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN19ClampVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i6, i8, i9, i10, i11, i5);
 i1 = HEAP32[i4 + 896 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i12 + 12 >> 2] = i7;
 HEAP32[i12 + 8 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = i7;
 HEAP32[i12 >> 2] = i7;
 __ZN21RotationBySpeedModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj(i1, i6, i8, i9, i12, i10, i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 52;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 52;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 51;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 51;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNK12HeaderHelper13GetAllHeadersEv(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 24 | 0;
 i12 = i14 + 12 | 0;
 i13 = i14;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i14;
  return;
 }
 i8 = i13 + 11 | 0;
 i9 = i13 + 4 | 0;
 i3 = i12 + 11 | 0;
 i4 = i12 + 4 | 0;
 i5 = i11 + 11 | 0;
 i6 = i11 + 4 | 0;
 while (1) {
  i17 = i2 + 16 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  i15 = HEAP8[i17 + 11 >> 0] | 0;
  i18 = i15 << 24 >> 24 < 0;
  i15 = i18 ? HEAP32[i2 + 20 >> 2] | 0 : i15 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i13, i18 ? HEAP32[i17 >> 2] | 0 : i17, i15, i15 + 2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i13, gb + 1084762 | 0, 2) | 0;
  i15 = i2 + 28 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  i17 = HEAP8[i8 >> 0] | 0;
  i18 = i17 << 24 >> 24 < 0;
  i17 = i18 ? HEAP32[i9 >> 2] | 0 : i17 & 255;
  i16 = i15 + 11 | 0;
  i1 = HEAP8[i16 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i2 + 32 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i12, i18 ? HEAP32[i13 >> 2] | 0 : i13, i17, i1 + i17 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i12, (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i15 >> 2] | 0 : i15, i1) | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i15 = i1 << 24 >> 24 < 0;
  i1 = i15 ? HEAP32[i4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i11, i15 ? HEAP32[i12 >> 2] | 0 : i12, i1, i1 + 2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, gb + 1027297 | 0, 2) | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i15 = i1 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i15 ? HEAP32[i11 >> 2] | 0 : i11, i15 ? HEAP32[i6 >> 2] | 0 : i1 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
 }
 STACKTOP = i14;
 return;
}

function __ZN8Gradient8TransferI9JSONWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1033999 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 1034004 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 1034009 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 12 | 0, gb + 1034014 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 1034019 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 1034024 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 1034029 | 0, 1);
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1034034 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 1034039 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 34 | 0, gb + 1034046 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 1034053 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 38 | 0, gb + 1034060 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 1034067 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 42 | 0, gb + 1034074 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 1034081 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 46 | 0, gb + 1034088 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 1034095 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 50 | 0, gb + 1034102 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 1034109 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 54 | 0, gb + 1034116 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1034123 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 58 | 0, gb + 1034130 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 1034137 | 0, 1);
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i2, i1 + 62 | 0, gb + 1034144 | 0, 1);
 i4 = i1 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i5, gb + 1034151 | 0, 1);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 1034158 | 0, 1);
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i2, i1 + 65 | 0, gb + 1034173 | 0, 1);
 STACKTOP = i3;
 return;
}

function __ZN5physx24PxRigidBodyGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 HEAP32[i1 + 120 >> 2] = gb + 673509;
 HEAP32[i1 + 124 >> 2] = 23;
 HEAP32[i1 + 128 >> 2] = fb + 3496;
 HEAP32[i1 + 132 >> 2] = fb + 3497;
 HEAP32[i1 + 136 >> 2] = gb + 673520;
 HEAP32[i1 + 140 >> 2] = 24;
 HEAP32[i1 + 144 >> 2] = fb + 398;
 HEAP32[i1 + 148 >> 2] = fb + 2119;
 HEAP32[i1 + 152 >> 2] = gb + 673527;
 HEAP32[i1 + 156 >> 2] = 25;
 HEAP32[i1 + 160 >> 2] = fb + 399;
 HEAP32[i1 + 164 >> 2] = fb + 2120;
 HEAP32[i1 + 168 >> 2] = gb + 673812;
 HEAP32[i1 + 172 >> 2] = 28;
 HEAP32[i1 + 176 >> 2] = fb + 3499;
 HEAP32[i1 + 180 >> 2] = fb + 3500;
 HEAP32[i1 + 184 >> 2] = gb + 673827;
 HEAP32[i1 + 188 >> 2] = 29;
 HEAP32[i1 + 192 >> 2] = fb + 380;
 HEAP32[i1 + 196 >> 2] = fb + 323;
 HEAP32[i1 + 200 >> 2] = gb + 673832;
 HEAP32[i1 + 204 >> 2] = 30;
 HEAP32[i1 + 208 >> 2] = fb + 381;
 HEAP32[i1 + 212 >> 2] = gb + 756464;
 HEAP32[i1 + 216 >> 2] = 31;
 HEAP32[i1 + 220 >> 2] = fb + 3501;
 HEAP32[i1 + 224 >> 2] = fb + 3502;
 HEAP32[i1 + 228 >> 2] = gb + 673840;
 HEAP32[i1 + 232 >> 2] = 32;
 HEAP32[i1 + 236 >> 2] = fb + 3503;
 HEAP32[i1 + 240 >> 2] = gb + 673866;
 HEAP32[i1 + 244 >> 2] = 33;
 HEAP32[i1 + 248 >> 2] = fb + 3504;
 HEAP32[i1 + 252 >> 2] = fb + 3505;
 HEAP32[i1 + 256 >> 2] = gb + 673881;
 HEAP32[i1 + 260 >> 2] = 34;
 HEAP32[i1 + 264 >> 2] = fb + 3506;
 HEAP32[i1 + 268 >> 2] = fb + 3507;
 HEAP32[i1 + 272 >> 2] = gb + 673897;
 HEAP32[i1 + 276 >> 2] = 35;
 HEAP32[i1 + 280 >> 2] = fb + 2124;
 HEAP32[i1 + 284 >> 2] = fb + 3508;
 HEAP32[i1 + 288 >> 2] = gb + 673915;
 HEAP32[i1 + 292 >> 2] = 36;
 HEAP32[i1 + 296 >> 2] = fb + 2125;
 HEAP32[i1 + 300 >> 2] = fb + 3509;
 HEAP32[i1 + 304 >> 2] = gb + 673930;
 HEAP32[i1 + 308 >> 2] = 37;
 HEAP32[i1 + 312 >> 2] = fb + 382;
 HEAP32[i1 + 316 >> 2] = fb + 324;
 HEAP32[i1 + 320 >> 2] = gb + 673955;
 HEAP32[i1 + 324 >> 2] = 38;
 HEAP32[i1 + 328 >> 2] = fb + 383;
 HEAP32[i1 + 332 >> 2] = fb + 325;
 return;
}

function __ZL19GetCameraTargetRectRK6Camerab(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i6 + 744 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  f11 = Math_fround(HEAP32[i1 + 80 >> 2] | 0);
  f10 = Math_fround(HEAP32[i1 + 84 >> 2] | 0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = f11;
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = f10;
  STACKTOP = i7;
  return;
 } while (0);
 i1 = HEAP32[i6 + 748 >> 2] | 0;
 if (i1 | 0) if (!(HEAP8[i1 + 31 >> 0] | 0)) {
  f10 = Math_fround((HEAP32[i1 + 4 >> 2] | 0) >>> 0);
  f11 = Math_fround((HEAP32[i1 + 8 >> 2] | 0) >>> 0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = f10;
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = f11;
  STACKTOP = i7;
  return;
 }
 if (__ZNK6Camera16GetStereoEnabledEv(i6) | 0) {
  i1 = __Z12GetIVRDevicev() | 0;
  if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0) {
   i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
   f10 = Math_fround(i9 | 0);
   f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0) | 0);
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 8 >> 2] = f10;
   HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i8 + 12 >> 2] = f11;
   STACKTOP = i7;
   return;
  }
 }
 i9 = __Z16GetScreenManagerv() | 0;
 f10 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 80 >> 2] | 0, i9 | 0) | 0);
 f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i9 | 0) | 0);
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = f10;
 HEAPF32[i8 + 12 >> 2] = f11;
 STACKTOP = i7;
 return;
}

function _csinh(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, d16 = 0.0, d17 = 0.0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 32 | 0;
 i3 = i15 + 16 | 0;
 i4 = i15;
 d10 = +HEAPF64[i2 >> 3];
 i5 = i2 + 8 | 0;
 d11 = +HEAPF64[i5 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d10;
 i12 = HEAP32[tempDoublePtr >> 2] | 0;
 i13 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d11;
 i14 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = i13 & 2147483647;
 i8 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 i9 = i6 >>> 0 < 2146435072;
 do if (i9 & i8 >>> 0 < 2146435072) {
  if (!(i8 | i14)) {
   HEAPF64[i7 >> 3] = +_sinh(d10);
   HEAPF64[i7 + 8 >> 3] = d11;
   break;
  }
  if (i6 >>> 0 < 1077280768) {
   d16 = +_sinh(d10) * +Math_cos(+d11);
   d11 = +_cosh(d10) * +Math_sin(+d11);
   HEAPF64[i7 >> 3] = d16;
   HEAPF64[i7 + 8 >> 3] = d11;
   break;
  }
  if (i6 >>> 0 < 1082535490) {
   d17 = +Math_exp(+(+Math_abs(+d10))) * .5;
   d16 = d17 * +Math_sin(+d11);
   HEAPF64[i7 >> 3] = +_copysign(d17, d10) * +Math_cos(+d11);
   HEAPF64[i7 + 8 >> 3] = d16;
   break;
  }
  if (i6 >>> 0 < 1083620266) {
   HEAPF64[i4 >> 3] = +Math_abs(+d10);
   HEAPF64[i4 + 8 >> 3] = d11;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   ___ldexp_cexp(i3, i1, -1);
   d16 = +HEAPF64[i3 >> 3];
   d17 = +HEAPF64[i3 + 8 >> 3];
   HEAPF64[i2 >> 3] = d16;
   HEAPF64[i5 >> 3] = d17;
   HEAPF64[i7 >> 3] = d16 * +_copysign(1.0, d10);
   HEAPF64[i7 + 8 >> 3] = d17;
   break;
  } else {
   d16 = d10 * 8988465674311579538646525.0e283;
   d17 = d16 * d16 * +Math_sin(+d11);
   HEAPF64[i7 >> 3] = d16 * +Math_cos(+d11);
   HEAPF64[i7 + 8 >> 3] = d17;
   break;
  }
 } else {
  i2 = i8 >>> 0 > 2146435071;
  if ((i6 | i12 | 0) == 0 & i2) {
   d17 = d11 - d11;
   HEAPF64[i7 >> 3] = +_copysign(0.0, d10 * d17);
   HEAPF64[i7 + 8 >> 3] = d17;
   break;
  }
  i1 = i6 >>> 0 > 2146435071;
  if (i1 & (i8 | i14 | 0) == 0) if (!(i13 & 1048575 | i12)) {
   HEAPF64[i7 >> 3] = d10;
   HEAPF64[i7 + 8 >> 3] = d11;
   break;
  } else {
   d17 = +_copysign(0.0, d11);
   HEAPF64[i7 >> 3] = d10;
   HEAPF64[i7 + 8 >> 3] = d17;
   break;
  }
  if (i9 & i2) {
   d17 = d11 - d11;
   HEAPF64[i7 >> 3] = d17;
   HEAPF64[i7 + 8 >> 3] = d10 * d17;
   break;
  }
  if (i1) if (!(i13 & 1048575 | i12)) if (i2) {
   HEAPF64[i7 >> 3] = d10 * d10;
   HEAPF64[i7 + 8 >> 3] = d10 * (d11 - d11);
   break;
  } else {
   d16 = d10 * +Math_cos(+d11);
   d17 = +Math_sin(+d11) * inf;
   HEAPF64[i7 >> 3] = d16;
   HEAPF64[i7 + 8 >> 3] = d17;
   break;
  }
  d17 = d11 - d11;
  HEAPF64[i7 >> 3] = d10 * d10 * d17;
  HEAPF64[i7 + 8 >> 3] = (d10 + d10) * d17;
 } while (0);
 STACKTOP = i15;
 return;
}

function __ZN13AnimationClip9PPtrCurveC2ERKS0_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   i8 = i6 + 32 | 0;
   i5 = i7 + 32 | 0;
   i3 = i5;
   i3 = HEAP32[i3 >> 2] | 0;
   i5 = i5 + 4 | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   i4 = i8;
   HEAP32[i4 >> 2] = i3;
   i8 = i8 + 4 | 0;
   HEAP32[i8 >> 2] = i5;
   i6 = i6 + 40 | 0;
   i8 = i7 + 40 | 0;
   __ZN13dynamic_arrayI12PPtrKeyframeLj4EEC2ERKS1_(i6, i8);
   STACKTOP = i9;
   return;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 i8 = i6 + 32 | 0;
 i10 = i7 + 32 | 0;
 i4 = i10;
 i4 = HEAP32[i4 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = i4;
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i10;
 i8 = i6 + 40 | 0;
 i10 = i7 + 40 | 0;
 __ZN13dynamic_arrayI12PPtrKeyframeLj4EEC2ERKS1_(i8, i10);
 STACKTOP = i9;
 return;
}

function __ZN12LineRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 24 | 0;
 i6 = i4 + 8 | 0;
 i5 = i4;
 i8 = i4 + 16 | 0;
 i9 = i2;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i7, i3);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 i3 = i1 + 32 | 0;
 __ZN12BaseRendererC2E12RendererType(i3, 6);
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i3 >> 2] = gb + 43728 + 180;
 HEAP32[i1 + 284 >> 2] = -1;
 __ZNK6Object14GetMemoryLabelEv(i5, i1);
 i3 = i5;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i11 = i7;
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i1 + 292 | 0;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = i1 + 308 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = i1;
 HEAP8[i1 + 328 >> 0] = 1;
 HEAP8[i1 + 329 >> 0] = 1;
 i3 = i1 + 268 | 0;
 i5 = i1 + 332 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16528383 | 82944;
 HEAP16[i3 >> 1] = i5;
 HEAP8[i3 + 2 >> 0] = i5 >>> 16;
 HEAP32[i1 >> 2] = gb + 43492 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43492 + 184;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = -1;
 HEAP32[i1 + 364 >> 2] = 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(196, i2, 16, gb + 406663 | 0, 28) | 0;
 i11 = i2;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN14LineParametersC2E10MemLabelId(i5, i7);
 HEAP32[i1 + 344 >> 2] = i5;
 i5 = __ZnwjRK10MemLabelIdiPKci(28, i2, 16, gb + 406663 | 0, 29) | 0;
 i8 = i2;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = gb + 44764 + 8;
 i2 = i6;
 HEAP32[i2 >> 2] = i9;
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i5 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 348 >> 2] = i5;
 __ZN8Renderer10SetVisibleEb(i1, 0);
 i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16528383;
 HEAP16[i3 >> 1] = i2;
 HEAP8[i3 + 2 >> 0] = i2 >>> 16;
 STACKTOP = i4;
 return;
}

function __ZN5physxL22concludeContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEjj(i1, i2, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i13 = i1 + ((i2 & 65535) << 4) | 0;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = 0;
 if (!(i2 << 16 >> 16)) {
  STACKTOP = i17;
  return;
 } else i10 = i1;
 while (1) {
  i4 = HEAP8[i10 + 1 >> 0] | 0;
  i9 = i4 & 255;
  i11 = HEAP8[i10 + 2 >> 0] | 0;
  i12 = i11 & 255;
  i7 = i9 << 4;
  i3 = i7 + 144 | 0;
  i8 = i3 + (Math_imul(i9, i14) | 0) | 0;
  i2 = HEAPU8[i10 + 3 >> 0] | 0;
  i5 = (i2 & 2 | 0) == 0;
  i6 = i12 << 4;
  i11 = i11 << 24 >> 24 == 0;
  i7 = i8 + ((i2 & 1 | 0) == 0 ? 0 : i7) + (i11 ? i6 : i6 + 128 | 0) | 0;
  i2 = i10 + i7 | 0;
  i8 = Math_imul(i12, i15) | 0;
  i1 = i10 + (i7 + i8) | 0;
  if (i4 << 24 >> 24) {
   i3 = i10 + i3 | 0;
   i4 = 0;
   while (1) {
    i24 = i3 + 128 | 0;
    f26 = Math_fround(HEAPF32[i24 >> 2]);
    i22 = i3 + 132 | 0;
    f28 = Math_fround(HEAPF32[i22 >> 2]);
    i20 = i3 + 136 | 0;
    f27 = Math_fround(HEAPF32[i20 >> 2]);
    i18 = i3 + 140 | 0;
    f19 = Math_fround(HEAPF32[i18 >> 2]);
    f25 = Math_fround(HEAPF32[i3 + 112 >> 2]);
    f23 = Math_fround(HEAPF32[i3 + 116 >> 2]);
    f21 = Math_fround(HEAPF32[i3 + 120 >> 2]);
    f23 = Math_fround(f28 - f23);
    f21 = Math_fround(f27 - f21);
    f19 = Math_fround(f19 - Math_fround(HEAPF32[i3 + 124 >> 2]));
    HEAPF32[i24 >> 2] = Math_fround(f26 - f25);
    HEAPF32[i22 >> 2] = f23;
    HEAPF32[i20 >> 2] = f21;
    HEAPF32[i18 >> 2] = f19;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i9 | 0)) break; else i3 = i3 + i14 | 0;
   }
  }
  if (i5) {
   if (!i11) {
    i3 = 0;
    while (1) {
     i24 = i2 + 96 | 0;
     HEAP32[i24 >> 2] = HEAP32[i16 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
     HEAP32[i24 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i12 | 0)) break; else i2 = i2 + i15 | 0;
    }
   }
  } else {
   i4 = i10 + (i8 + i6 + i7) | 0;
   if (i11) i1 = i4; else {
    i3 = 0;
    while (1) {
     i24 = i2 + 96 | 0;
     HEAP32[i24 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i24 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i24 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i24 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i12 | 0)) {
      i1 = i4;
      break;
     } else {
      i2 = i2 + i15 | 0;
      i1 = i1 + 16 | 0;
     }
    }
   }
  }
  if (i1 >>> 0 < i13 >>> 0) i10 = i1; else break;
 }
 STACKTOP = i17;
 return;
}

function __ZN5physx7ConvexHC2Eiii(i5, i11, i9, i10) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 1 | 0;
 i7 = i12;
 i8 = i5 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 if (i11 | 0) {
  HEAP32[i1 >> 2] = i11;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i11 * 12 | 0, gb + 730303 | 0, 136) | 0;
  HEAP32[i5 >> 2] = i1;
  if ((HEAP32[i8 >> 2] | 0) > 0) {
   HEAP32[i1 >> 2] = HEAP32[0];
   HEAP32[i1 + 4 >> 2] = HEAP32[1];
   HEAP32[i1 + 8 >> 2] = HEAP32[2];
   if ((HEAP32[i8 >> 2] | 0) > 1) {
    i1 = 1;
    do {
     i4 = (HEAP32[i5 >> 2] | 0) + (i1 * 12 | 0) | 0;
     i3 = 0 + (i1 * 12 | 0) | 0;
     HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i8 >> 2] | 0));
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, 0);
  }
 }
 i2 = i5 + 12 | 0;
 i4 = i5 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = i5 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if (i9 | 0) {
  HEAP32[i1 >> 2] = i9;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i9 << 2, gb + 730303 | 0, 136) | 0;
  HEAP32[i2 >> 2] = i1;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   HEAP16[i1 >> 1] = 0;
   HEAP16[i1 + 2 >> 1] = 0 >>> 16;
   if ((HEAP32[i4 >> 2] | 0) > 1) {
    i1 = 1;
    do {
     i3 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
     i13 = HEAP32[0 + (i1 << 2) >> 2] | 0;
     HEAP16[i3 >> 1] = i13;
     HEAP16[i3 + 2 >> 1] = i13 >>> 16;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, 0);
  }
 }
 i2 = i5 + 24 | 0;
 i3 = i5 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if (!i10) {
  HEAP32[i8 >> 2] = i11;
  HEAP32[i4 >> 2] = i9;
  HEAP32[i3 >> 2] = i10;
  STACKTOP = i12;
  return;
 }
 HEAP32[i1 >> 2] = i10;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i10 << 4, gb + 730303 | 0, 136) | 0;
 HEAP32[i2 >> 2] = i1;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  HEAP32[i1 >> 2] = HEAP32[0];
  HEAP32[i1 + 4 >> 2] = HEAP32[1];
  HEAP32[i1 + 8 >> 2] = HEAP32[2];
  HEAP32[i1 + 12 >> 2] = HEAP32[3];
  if ((HEAP32[i3 >> 2] | 0) > 1) {
   i1 = 1;
   do {
    i13 = (HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0;
    i6 = 0 + (i1 << 4) | 0;
    HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, 0);
 }
 HEAP32[i8 >> 2] = i11;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i3 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_(i1, i7, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i5 = i1 + 11 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 i9 = i1 + 4 | 0;
 i4 = i7 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i8 = i7 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i10, (i6 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i6 & 255) + 1 + (i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255) | 0);
 i5 = HEAP8[i5 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 i5 = i2 ? HEAP32[i9 >> 2] | 0 : i5 & 255;
 if (!i5) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i7) | 0;
  return;
 }
 i9 = HEAP8[i4 >> 0] | 0;
 i3 = i9 << 24 >> 24 < 0;
 if (!((i3 ? HEAP32[i8 >> 2] | 0 : i9 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i1) | 0;
  return;
 }
 i2 = i2 ? HEAP32[i1 >> 2] | 0 : i1;
 i9 = (HEAP8[i2 + (i5 + -1) >> 0] | 0) == 47;
 i6 = (HEAP8[(i3 ? HEAP32[i7 >> 2] | 0 : i7) >> 0] | 0) == 47;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i2, i5) | 0;
 if (!i9) if (i6) {
  i9 = HEAP8[i4 >> 0] | 0;
  i6 = i9 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i6 ? HEAP32[i7 >> 2] | 0 : i7, i6 ? HEAP32[i8 >> 2] | 0 : i9 & 255) | 0;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i10, 47);
  i9 = HEAP8[i4 >> 0] | 0;
  i6 = i9 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i6 ? HEAP32[i7 >> 2] | 0 : i7, i6 ? HEAP32[i8 >> 2] | 0 : i9 & 255) | 0;
  return;
 }
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 if (!i6) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i10, i3, i2 ? HEAP32[i8 >> 2] | 0 : i1 & 255) | 0;
  return;
 }
 i6 = i3 + 1 | 0;
 i4 = i2 ? HEAP32[i8 >> 2] | 0 : i1 & 255;
 i5 = i3 + i4 | 0;
 i3 = i6;
 i9 = i10 + 11 | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
  i8 = HEAP32[i10 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i8 = i1 & 255;
 }
 i7 = i5 - i3 | 0;
 if (!i7) return;
 if ((i2 - i8 | 0) >>> 0 < i7 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i10, i2, i8 + i7 - i2 | 0, i8, i8, 0, 0);
  i1 = HEAP8[i9 >> 0] | 0;
 }
 i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10) + i8 | 0;
 if ((i4 | 0) != 1) {
  i2 = i6;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i3 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
 }
 HEAP8[i1 >> 0] = 0;
 i1 = i8 + i7 | 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  HEAP32[i10 + 4 >> 2] = i1;
  return;
 } else {
  HEAP8[i9 >> 0] = i1;
  return;
 }
}

function __ZN5physx2Gu33MultiplePersistentContactManifold10fromBufferEPh(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!i2) {
  HEAP32[i8 + 16 >> 2] = 2139095039;
  HEAP32[i8 + 20 >> 2] = 2139095039;
  HEAP32[i8 + 24 >> 2] = 2139095039;
  HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 1065353216;
  i9 = 8;
 } else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  if (!i1) i9 = 8; else {
   i7 = 0;
   i6 = i2 + 48 | 0;
   while (1) {
    HEAP8[i8 + 48 + i7 >> 0] = i7;
    i2 = i6 + 16 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i4 = i8 + 64 + (i7 * 400 | 0) + 384 | 0;
    HEAP32[i4 >> 2] = i3;
    if (i3 | 0) {
     i5 = 0;
     do {
      i13 = i2 + (i5 * 48 | 0) | 0;
      i12 = HEAP32[i13 + 4 >> 2] | 0;
      i11 = HEAP32[i13 + 8 >> 2] | 0;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 4 >> 2] = i12;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 8 >> 2] = i11;
      HEAPF32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 12 >> 2] = Math_fround(0.0);
      i11 = i2 + (i5 * 48 | 0) + 16 | 0;
      i12 = HEAP32[i11 + 4 >> 2] | 0;
      i13 = HEAP32[i11 + 8 >> 2] | 0;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 16 >> 2] = HEAP32[i11 >> 2];
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 20 >> 2] = i12;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 24 >> 2] = i13;
      HEAPF32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 28 >> 2] = Math_fround(0.0);
      i13 = i2 + (i5 * 48 | 0) + 32 | 0;
      i12 = HEAP32[i13 + 4 >> 2] | 0;
      i11 = HEAP32[i13 + 8 >> 2] | 0;
      i10 = HEAP32[i13 + 12 >> 2] | 0;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 32 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 36 >> 2] = i12;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 40 >> 2] = i11;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 44 >> 2] = i10;
      HEAP32[i8 + 64 + (i7 * 400 | 0) + (i5 << 6) + 48 >> 2] = HEAP32[i2 + (i5 * 48 | 0) + 12 >> 2];
      i5 = i5 + 1 | 0;
     } while (i5 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
    }
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i1 | 0)) break; else i6 = i6 + ((i3 * 48 | 0) + 16) | 0;
   }
   HEAP8[i8 + 52 >> 0] = i1;
   if (i1 >>> 0 >= 4) return;
  }
 }
 if ((i9 | 0) == 8) {
  HEAP8[i8 + 52 >> 0] = 0;
  i1 = 0;
 }
 do {
  HEAP8[i8 + 48 + i1 >> 0] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 return;
}

function __ZN5physx14SingleAABBTaskC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 104544 + 8;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i1 + 24 >> 2] = 0;
 i2 = i1 + 48 | 0;
 HEAP16[i1 + 52 >> 1] = -1;
 HEAP16[i1 + 54 >> 1] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 4;
 i2 = i1 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 116 | 0;
 HEAP16[i1 + 120 >> 1] = -1;
 HEAP16[i1 + 122 >> 1] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 4;
 i2 = i1 + 164 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 184 | 0;
 HEAP16[i1 + 188 >> 1] = -1;
 HEAP16[i1 + 190 >> 1] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 196 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = 4;
 i2 = i1 + 232 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 252 | 0;
 HEAP16[i1 + 256 >> 1] = -1;
 HEAP16[i1 + 258 >> 1] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = 4;
 i2 = i1 + 300 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 320 | 0;
 HEAP16[i1 + 324 >> 1] = -1;
 HEAP16[i1 + 326 >> 1] = 0;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 364 >> 2] = 4;
 i2 = i1 + 368 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 388 | 0;
 HEAP16[i1 + 392 >> 1] = -1;
 HEAP16[i1 + 394 >> 1] = 0;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 400 >> 2] = 0;
 HEAP32[i1 + 404 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104588 + 8;
 HEAP32[i1 + 408 >> 2] = 0;
 HEAP32[i1 + 432 >> 2] = 4;
 i1 = i1 + 436 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i9, i10, i14, i1, i15, i16, i17) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i21;
 i18 = i21 + 32 | 0;
 i19 = i21 + 28 | 0;
 i20 = i21 + 16 | 0;
 i11 = i20 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i20 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i20 + 4 | 0;
 HEAP32[i20 >> 2] = i13;
 i2 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 if ((i2 | 0) != (i6 | 0)) {
  i7 = i13;
  i5 = i2;
  i1 = i2;
  while (1) {
   i3 = i5 + 16 | 0;
   HEAP32[i19 >> 2] = i7;
   HEAP32[i8 >> 2] = HEAP32[i19 >> 2];
   i4 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_(i20, i8, i18, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = __Znwj(40) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + 16 | 0, i3);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + 28 | 0, i5 + 28 | 0);
    i3 = HEAP32[i18 >> 2] | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i2;
    i3 = HEAP32[HEAP32[i20 >> 2] >> 2] | 0;
    if (i3) {
     HEAP32[i20 >> 2] = i3;
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i2);
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i6 | 0)) break; else i5 = i1;
  }
 }
 i19 = __Znwj(112) | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 __ZN13EmscriptenWWWC2EPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i19, i9, i10, i14, i20, i15, i8, i17);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i20, HEAP32[i13 >> 2] | 0);
 STACKTOP = i21;
 return i19 | 0;
}

function __ZNK26AnimatorOverrideController7GetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i9, i2, i10) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i9) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i5 + 12 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + (i12 << 2) | 0;
 HEAP32[i6 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 if (!i12) i2 = 0; else {
  while (1) {
   if (__ZN8FindClipclERK4PPtrI13AnimationClipE(i6, i1) | 0) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i1 = i3;
    break;
   }
  }
  i2 = HEAP32[i4 >> 2] | 0;
 }
 if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + (i2 << 2) | 0)) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i8 = 12; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[i2 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
   i3 = HEAP32[i6 >> 2] | 0;
   i12 = HEAP32[i2 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i3 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
   i3 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 12; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 14;
 }
 if ((i8 | 0) == 12) i8 = 14;
 if ((i8 | 0) == 14) if (!(__Z31ReadObjectFromPersistentManageri(i1) | 0)) {
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 i2 = HEAP32[i9 + 84 >> 2] | 0;
 i3 = HEAP32[i9 + 96 >> 2] | 0;
 i4 = i2 + (i3 << 3) | 0;
 i3 = (i3 | 0) == 0;
 if (i10) {
  L28 : do if (!i3) {
   do {
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break L28;
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i4 | 0));
   STACKTOP = i11;
   return i1 | 0;
  } while (0);
  if ((i2 | 0) == (i4 | 0)) {
   i12 = i1;
   STACKTOP = i11;
   return i12 | 0;
  }
  i12 = __Z16return_effectiveRK21AnimationClipOverride(i2) | 0;
  STACKTOP = i11;
  return i12 | 0;
 } else {
  L39 : do if (!i3) {
   do {
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break L39;
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i4 | 0));
   STACKTOP = i11;
   return i1 | 0;
  } while (0);
  if ((i2 | 0) == (i4 | 0)) {
   i12 = i1;
   STACKTOP = i11;
   return i12 | 0;
  }
  i12 = __Z15return_overrideRK21AnimationClipOverride(i2) | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 return 0;
}

function __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i9, i14, i15, i13, i1) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, f16 = f0, f17 = f0, f18 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f2);
 i8 = i9 + 32 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i10 = i9 + 44 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 if (!(i1 << 24 >> 24)) i1 = 0; else {
  f4 = Math_fround(HEAPF32[i15 >> 2]);
  f5 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  i3 = i1 & 255;
  i7 = 0;
  do {
   f18 = Math_fround(HEAPF32[i11 + (i7 * 48 | 0) + 16 >> 2]);
   f17 = Math_fround(HEAPF32[i11 + (i7 * 48 | 0) + 20 >> 2]);
   f18 = Math_fround(f18 - f4);
   f17 = Math_fround(f17 - f5);
   f16 = Math_fround(Math_fround(HEAPF32[i11 + (i7 * 48 | 0) + 24 >> 2]) - f6);
   if (f2 > Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f16 * f16))) {
    i1 = i7;
    i12 = 5;
    break;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i3 >>> 0);
  if ((i12 | 0) == 5) {
   i12 = i11 + (i1 * 48 | 0) | 0;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   i14 = (HEAP32[i10 >> 2] | 0) + (i1 * 48 | 0) + 16 | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
   i15 = (HEAP32[i10 >> 2] | 0) + (i1 * 48 | 0) + 32 | 0;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i15 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i15 = 0;
   return i15 | 0;
  }
  if ((i1 & 255) >= 4) {
   __ZN5physx2Gu25PersistentContactManifold20reduceContactsForPCMERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE(i9, i14, i15, i13) | 0;
   i15 = 0;
   return i15 | 0;
  }
 }
 i12 = i11 + ((i1 & 255) * 48 | 0) | 0;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i14 = (HEAP32[i10 >> 2] | 0) + ((HEAPU8[i8 >> 0] | 0) * 48 | 0) + 16 | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 i15 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i15 + 1 << 24 >> 24;
 i15 = (HEAP32[i10 >> 2] | 0) + ((i15 & 255) * 48 | 0) + 32 | 0;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 i15 = 1;
 return i15 | 0;
}

function __ZN5audio5mixerL32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRKNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEiRNS6_6vectorI9UnityGUIDNSA_ISG_EEEE(i10, i11, i12, i13, i14) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i18 + 12 | 0;
 i16 = i18;
 i17 = i12 + 11 | 0;
 do if ((i13 | 0) > -1 & (_strstr((HEAP8[i17 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, i11) | 0) != 0) {
  i1 = i10 + 8 | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 + (i13 << 4) | 0;
  i2 = i14 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i14 + 8 >> 2] | 0)) {
   __ZNSt3__26vectorI9UnityGUIDNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i14, i1);
   break;
  } else {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
   break;
  }
 } while (0);
 i1 = i10 + 48 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  STACKTOP = i18;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i5;
 i7 = i12 + 4 | 0;
 i8 = i16 + 11 | 0;
 i9 = i16 + 4 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i4 = 0;
 i1 = i2;
 do {
  if ((HEAP32[(HEAP32[i5 >> 2] | 0) + i6 + (i4 << 4) >> 2] | 0) == (i13 | 0)) {
   HEAP32[i16 >> 2] = 0;
   HEAP32[i16 + 4 >> 2] = 0;
   HEAP32[i16 + 8 >> 2] = 0;
   i2 = HEAP8[i17 >> 0] | 0;
   i19 = i2 << 24 >> 24 < 0;
   i2 = i19 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i16, i19 ? HEAP32[i12 >> 2] | 0 : i12, i2, i2 + 1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, gb + 1087627 | 0, 1) | 0;
   HEAP32[i15 >> 2] = 0;
   HEAP32[i15 + 4 >> 2] = 0;
   HEAP32[i15 + 8 >> 2] = 0;
   i2 = HEAP8[i8 >> 0] | 0;
   i19 = i2 << 24 >> 24 < 0;
   i2 = i19 ? HEAP32[i9 >> 2] | 0 : i2 & 255;
   i1 = _strlen(i3) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i15, i19 ? HEAP32[i16 >> 2] | 0 : i16, i2, i2 + i1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i15, i3, i1) | 0;
   __ZN5audio5mixerL32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRKNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEiRNS6_6vectorI9UnityGUIDNSA_ISG_EEEE(i10, i11, i15, i4, i14);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i3 = i3 + ((_strlen(i3) | 0) + 1) | 0;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 STACKTOP = i18;
 return;
}

function __ZN13SplatDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i6 = i9 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 44 | 0;
 HEAP32[i8 >> 2] = i4;
 i12 = i10 + 16 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i3 = i5 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SplatPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i9 + 12 | 0;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 HEAP32[i8 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i9 + 36 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i4 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + 48 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 49 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
}

function __ZNK13RenderManager28IsDisplayReferencedByCamerasEi(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i9 = i1 + 4 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i9 | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 while (1) {
  i5 = i1 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i3 = HEAP32[i7 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 10;
   }
  }
  if ((i10 | 0) == 8) i10 = 10;
  if ((i10 | 0) == 10) {
   i10 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  }
  if ((HEAP32[i1 + 820 >> 2] | 0) == (i6 | 0)) {
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 17; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i3 = HEAP32[i7 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 17; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 19;
    }
   }
   if ((i10 | 0) == 17) i10 = 19;
   if ((i10 | 0) == 19) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) {
    i1 = 1;
    i10 = 22;
    break;
   }
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i9 | 0)) {
   i1 = 0;
   i10 = 22;
   break;
  }
 }
 if ((i10 | 0) == 22) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx11NodeManager6resizeEj(i16, i15) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = (i15 * 12 | 0) + 15 & -16;
 i5 = (i15 << 2) + 15 & -16;
 i14 = (i15 + 31 | 0) >>> 5;
 i1 = (i14 << 2) + 15 & 1073741808;
 i8 = i9 + i5 | 0;
 i5 = i8 + i5 | 0;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17 + 1 | 0, (i1 << 2) + i5 | 0, gb + 681489 | 0, 970) | 0;
 i8 = i7 + i8 | 0;
 i2 = i7 + i5 | 0;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 i5 = i5 + i1 | 0;
 i3 = i7 + i5 | 0;
 _memset(i3 | 0, 0, i1 | 0) | 0;
 i5 = i5 + i1 | 0;
 i4 = i7 + i5 | 0;
 _memset(i4 | 0, 0, i1 | 0) | 0;
 i5 = i7 + (i5 + i1) | 0;
 _memset(i5 | 0, 0, i1 | 0) | 0;
 i9 = i7 + i9 | 0;
 i1 = i16 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i10 = i2;
 i11 = i3;
 i12 = i4;
 i13 = i5;
 if (!i6) {
  i5 = i16 + 12 | 0;
  i2 = i16 + 8 | 0;
 } else {
  i18 = i16 + 12 | 0;
  _memcpy(i7 | 0, i6 | 0, (HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
  i6 = i16 + 8 | 0;
  _memcpy(i9 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
  _memcpy(i8 | 0, HEAP32[i16 + 24 >> 2] | 0, HEAP32[i18 >> 2] << 2 | 0) | 0;
  _memcpy(i2 | 0, HEAP32[i16 + 28 >> 2] | 0, HEAP32[i16 + 44 >> 2] << 2 | 0) | 0;
  _memcpy(i3 | 0, HEAP32[i16 + 32 >> 2] | 0, HEAP32[i16 + 48 >> 2] << 2 | 0) | 0;
  _memcpy(i4 | 0, HEAP32[i16 + 36 >> 2] | 0, HEAP32[i16 + 52 >> 2] << 2 | 0) | 0;
  _memcpy(i5 | 0, HEAP32[i16 + 40 >> 2] | 0, HEAP32[i16 + 56 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i1 >> 2] | 0);
  i5 = i18;
  i2 = i6;
 }
 HEAP32[i1 >> 2] = i7;
 HEAP32[i2 >> 2] = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i16 + 16 | 0;
 i3 = i15 + -1 | 0;
 HEAP32[i9 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 if (i3 >>> 0 > i1 >>> 0) {
  i4 = i1;
  do {
   i18 = i4;
   i4 = i4 + 1 | 0;
   HEAP32[i9 + (i18 << 2) >> 2] = i4;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAP32[i2 >> 2] = i1;
 i9 = i16 + 20 | 0;
 HEAP32[i9 >> 2] = (((i15 | 0) == 0) << 31 >> 31) + i15 - i1 + (HEAP32[i9 >> 2] | 0);
 i9 = HEAP32[i5 >> 2] | 0;
 _memset(i8 + (i9 << 2) | 0, -1, i15 - i9 << 2 | 0) | 0;
 HEAP32[i16 + 24 >> 2] = i8;
 i9 = i14 | -2147483648;
 HEAP32[i16 + 28 >> 2] = i10;
 HEAP32[i16 + 44 >> 2] = i14;
 i18 = HEAP32[i16 + 252 >> 2] | 0;
 HEAP32[i18 >> 2] = i10;
 HEAP32[i18 + 4 >> 2] = i9;
 HEAP32[i16 + 32 >> 2] = i11;
 HEAP32[i16 + 48 >> 2] = i14;
 i18 = HEAP32[i16 + 256 >> 2] | 0;
 HEAP32[i18 >> 2] = i11;
 HEAP32[i18 + 4 >> 2] = i9;
 HEAP32[i16 + 36 >> 2] = i12;
 HEAP32[i16 + 52 >> 2] = i14;
 i18 = HEAP32[i16 + 260 >> 2] | 0;
 HEAP32[i18 >> 2] = i12;
 HEAP32[i18 + 4 >> 2] = i9;
 HEAP32[i16 + 40 >> 2] = i13;
 HEAP32[i16 + 56 >> 2] = i14;
 i18 = HEAP32[i16 + 264 >> 2] | 0;
 HEAP32[i18 >> 2] = i13;
 HEAP32[i18 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = i15;
 STACKTOP = i17;
 return;
}

function __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i9 = i10;
 i1 = i10 + 4 | 0;
 i2 = i8 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63304 | 0);
  HEAP32[i2 >> 2] = 0;
  if (HEAP32[i8 + 20 >> 2] & 1024 | 0) {
   i9 = __Z12GetIVRDevicev() | 0;
   mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0, 0, i8 | 0) | 0;
  }
  if (HEAP32[i8 >> 2] | 0) {
   i9 = __Z16GetRealGfxDevicev() | 0;
   i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + 452 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   mftCall_vii(i6 | 0, i9 | 0, i7 | 0);
  }
  i1 = i8 + 36 | 0;
  if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES18DeleteRenderbufferERj(i4, i1);
  i1 = i8 + 44 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i10;
   return;
  }
  __ZN7ApiGLES18DeleteRenderbufferERj(i4, i1);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i9 >> 2] = i1;
 i2 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i5 = i3 + (i1 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i2, i9);
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i6 = HEAP32[gb + 1157724 >> 2] | 0;
  i5 = (i5 | 0) == -1 ? i3 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i3 + (i5 << 3) | 0;
  i3 = HEAP32[i6 + 28 >> 2] | 0;
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  i2 = i6;
 }
 i4 = i3 + (i1 << 3) | 0;
 if ((i5 | 0) == (i4 | 0)) i6 = 0; else i6 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 i5 = i2 + 4 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i2, i9);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i3 + (i1 << 3) | 0 : i3 + (i4 << 3) | 0;
 }
 if ((i4 | 0) != (i3 + (i1 << 3) | 0)) {
  i7 = i2 + 12 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  HEAP8[i2 + 48 >> 0] = 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63304 | 0);
 STACKTOP = i10;
 return;
}

function __ZN17Physics2DSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) > 1 ? i4 : 1;
 i3 = i1 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) > 1 ? i4 : 1;
 i3 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 52 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 56 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 60 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 64 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 68 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 72 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 76 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 80 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 84 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 i1 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(.100000001);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(.100000001) : f2;
 return;
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE19StreamedBinaryWriteILb0EEEvRPT_PKcRjS9_RT0_(i4, i1, i5, i2, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i1, i5, 4);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  __ZN7mecanim9animation18ClipMuscleConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
  return;
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, HEAP32[i5 >> 2] | 0);
 i5 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 1736, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i5);
 i2 = i5 + 888 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 912 >> 2] = 1065353216;
 HEAP32[i5 + 916 >> 2] = 1065353216;
 HEAP32[i5 + 920 >> 2] = 1065353216;
 HEAP32[i5 + 924 >> 2] = 1065353216;
 i2 = i5 + 928 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 952 >> 2] = 1065353216;
 HEAP32[i5 + 956 >> 2] = 1065353216;
 HEAP32[i5 + 960 >> 2] = 1065353216;
 HEAP32[i5 + 964 >> 2] = 1065353216;
 i2 = i5 + 968 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 992 >> 2] = 1065353216;
 HEAP32[i5 + 996 >> 2] = 1065353216;
 HEAP32[i5 + 1e3 >> 2] = 1065353216;
 HEAP32[i5 + 1004 >> 2] = 1065353216;
 i2 = i5 + 1008 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 1032 >> 2] = 1065353216;
 HEAP32[i5 + 1036 >> 2] = 1065353216;
 HEAP32[i5 + 1040 >> 2] = 1065353216;
 HEAP32[i5 + 1044 >> 2] = 1065353216;
 i2 = i5 + 1048 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i5 + 1068 >> 2] = Math_fround(1.0);
 i2 = i5 + 1072 | 0;
 i3 = i5 + 1708 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP16[i3 + 20 >> 1] = 0;
 HEAP8[i5 + 1730 >> 0] = 1;
 HEAP8[i5 + 1731 >> 0] = 0;
 HEAP8[i5 + 1732 >> 0] = 1;
 HEAP8[i5 + 1733 >> 0] = 0;
 HEAP8[i5 + 1734 >> 0] = 0;
 _memset(i5 + 1088 | 0, -1, 620) | 0;
 HEAP32[i4 >> 2] = i5;
 __ZN7mecanim9animation18ClipMuscleConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i4 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 16 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = (i1 - i5 >> 4) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i8 = i4 - i7 | 0;
 i5 = i8 >> 3;
 i5 = i8 >> 4 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 34;
  HEAP32[i12 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (i1 - i7 >> 4 << 4) | 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i3 + (i5 << 4);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i10, i11);
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i12 >> 2] = 34;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13;
 i3 = i10 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i4 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 16 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 12 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = (i1 - i5 >> 4) + i2 | 0;
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i4 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } else i7 = i5;
 i8 = i4 - i7 | 0;
 i5 = i8 >> 3;
 i5 = i8 >> 4 >>> 0 < 1073741823 ? (i5 >>> 0 < i6 >>> 0 ? i6 : i5) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 if (!i5) i3 = 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i1 = i3 + (i1 - i7 >> 4 << 4) | 0;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 + 12 >> 2] = i3 + (i5 << 4);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i10, i11);
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  HEAP32[i12 >> 2] = 12;
  HEAP32[i12 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 28 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i8 = i9;
   i10 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i1 + 12 | 0;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = (HEAP32[i12 >> 2] | 0) + 28 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 28 | 0) + i2 | 0;
 if (i5 >>> 0 > 153391689) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 28 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 76695844 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 153391689;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 28 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 28 | 0) * 28 | 0) | 0;
 i8 = i3;
 i4 = i6 + (i5 * 28 | 0) | 0;
 i7 = i8;
 i1 = i3;
 do {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i14 = i9;
  i5 = HEAP32[i14 + 4 >> 2] | 0;
  i6 = i1 + 12 | 0;
  HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i7 + 28 | 0;
  i7 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i6 = i5;
  i1 = i5;
  i2 = i8;
 } else {
  i2 = i8;
  do {
   i14 = i1;
   i1 = i1 + -28 | 0;
   i6 = i1;
   i8 = HEAP32[i6 + 4 >> 2] | 0;
   i9 = i3 + -28 | 0;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i3 + -20 | 0, i14 + -20 | 0);
   i3 = i2 + -28 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i5 | 0));
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i11 >> 2] = i4;
 i3 = i6;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -28 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i6);
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5clearEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16;
 i7 = i15 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i15 + 88 | 0;
 L1 : do if (i2 | 0) {
  i4 = HEAP32[i5 >> 2] | 0;
  if (i4 | 0) {
   i1 = 0;
   while (1) {
    i3 = HEAP32[i2 + (i1 * 36 | 0) >> 2] | 0;
    if (i3 | 0) if (HEAP32[i2 + (i1 * 36 | 0) + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + (i1 * 36 | 0) + 24 | 0);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) break L1;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  }
 } while (0);
 HEAP32[i5 >> 2] = 32;
 HEAP32[i15 + 100 >> 2] = 16;
 HEAP32[i15 + 96 >> 2] = 6;
 HEAP8[i15 + 104 >> 0] = 0;
 i1 = i15 + 108 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = 57;
 HEAP32[i6 + 4 >> 2] = i3;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1152, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  i14 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = 57;
  HEAP32[i6 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 }
 HEAP32[i7 >> 2] = i3;
 i8 = i3 + ((HEAP32[i5 >> 2] | 0) * 36 | 0) | 0;
 i9 = i15 + 48 | 0;
 if ((i3 | 0) == (i8 | 0)) {
  i14 = i15 + 92 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = 0;
  STACKTOP = i16;
  return;
 }
 i10 = i15 + 72 | 0;
 i11 = i15 + 80 | 0;
 i12 = i15 + 52 | 0;
 i13 = i15 + 52 | 0;
 i14 = i15 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i5 = i3 + 20 | 0;
  HEAP32[i5 >> 2] = 0;
  i2 = i3 + 24 | 0;
  i6 = i10;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i2;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = i3 + 4 | 0;
  HEAP8[i1 >> 0] = 0;
  do if ((i3 | 0) != (i9 | 0)) {
   i6 = HEAP32[i9 >> 2] | 0;
   i17 = (i6 | 0) == 0;
   i6 = i17 ? i13 : i6;
   i7 = HEAP32[i14 >> 2] | 0;
   i4 = i3 + 4 | 0;
   if (!((HEAP32[i12 >> 2] | 0) != 0 | i17)) {
    HEAP32[i3 >> 2] = i6;
    HEAP32[i5 >> 2] = i7;
    HEAP32[i4 >> 2] = 0;
    break;
   }
   if (i7 >>> 0 > 15) {
    i17 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i2, 0, gb + 1047486 | 0, 251) | 0;
    HEAP32[i3 >> 2] = i17;
    HEAP32[i4 >> 2] = i7;
    i1 = (i17 | 0) == 0 ? i1 : i17;
   }
   _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   HEAP32[i5 >> 2] = i7;
  } while (0);
  HEAP32[i3 + 32 >> 2] = HEAP32[i11 >> 2];
  i3 = i3 + 36 | 0;
 } while ((i3 | 0) != (i8 | 0));
 i17 = i15 + 92 | 0;
 HEAP32[i17 >> 2] = 0;
 i17 = i15 + 4 | 0;
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z18MurmurHash1AlignedPKvij(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i1 = (Math_imul(i7, -962287725) | 0) ^ i1;
 i2 = i11;
 i10 = i2 & 3;
 i3 = (i7 | 0) > 3;
 if (i3 & (i10 | 0) != 0) {
  switch (i2 & 3) {
  case 1:
   {
    i2 = (HEAPU8[i11 + 2 >> 0] | 0) << 16;
    i12 = 6;
    break;
   }
  case 2:
   {
    i2 = 0;
    i12 = 6;
    break;
   }
  case 3:
   {
    i2 = 0;
    i12 = 7;
    break;
   }
  default:
   i2 = 0;
  }
  if ((i12 | 0) == 6) {
   i2 = (HEAPU8[i11 + 1 >> 0] | 0) << 8 | i2;
   i12 = 7;
  }
  if ((i12 | 0) == 7) i2 = HEAPU8[i11 >> 0] | 0 | i2;
  i9 = i10 << 3;
  i3 = i2 << i9;
  i8 = 4 - i10 | 0;
  i4 = i11 + i8 | 0;
  i2 = i7 - i8 | 0;
  i8 = i8 << 3;
  if ((i2 | 0) > 3) {
   i5 = i10 + i7 + -8 | 0;
   i6 = i5 & -4;
   i7 = i6 + 8 - i10 | 0;
   while (1) {
    i13 = i3;
    i3 = HEAP32[i4 >> 2] | 0;
    i13 = Math_imul((i3 << i8 | i13 >>> i9) + i1 | 0, -962287725) | 0;
    i1 = i13 >>> 16 ^ i13;
    i2 = i2 + -4 | 0;
    if ((i2 | 0) <= 3) break; else i4 = i4 + 4 | 0;
   }
   i6 = i5 - i6 | 0;
   i5 = i11 + i7 | 0;
  } else {
   i6 = i2;
   i5 = i4;
  }
  i4 = (i6 | 0) < (i10 | 0) ? i6 : i10;
  switch (i4 | 0) {
  case 3:
   {
    i2 = (HEAPU8[i5 + 2 >> 0] | 0) << 16;
    i12 = 14;
    break;
   }
  case 2:
   {
    i2 = 0;
    i12 = 14;
    break;
   }
  case 1:
   {
    i2 = 0;
    i12 = 15;
    break;
   }
  case 0:
   {
    i2 = 0;
    i12 = 16;
    break;
   }
  default:
   {}
  }
  if ((i12 | 0) == 14) {
   i2 = (HEAPU8[i5 + 1 >> 0] | 0) << 8 | i2;
   i12 = 15;
  }
  if ((i12 | 0) == 15) {
   i2 = HEAPU8[i5 >> 0] | 0 | i2;
   i12 = 16;
  }
  if ((i12 | 0) == 16) {
   i1 = Math_imul((i2 << i8 | i3 >>> i9) + i1 | 0, -962287725) | 0;
   i1 = i1 >>> 16 ^ i1;
  }
  i3 = i6 - i4 | 0;
  i2 = i5 + i4 | 0;
 } else if (i3) {
  i5 = i7 + -4 | 0;
  i4 = i5 & -4;
  i6 = i11 + (i4 + 4) | 0;
  i3 = i11;
  i2 = i7;
  while (1) {
   i13 = Math_imul((HEAP32[i3 >> 2] | 0) + i1 | 0, -962287725) | 0;
   i1 = i13 >>> 16 ^ i13;
   i2 = i2 + -4 | 0;
   if ((i2 | 0) <= 3) break; else i3 = i3 + 4 | 0;
  }
  i3 = i5 - i4 | 0;
  i2 = i6;
 } else {
  i3 = i7;
  i2 = i11;
 }
 switch (i3 | 0) {
 case 3:
  {
   i1 = ((HEAPU8[i2 + 2 >> 0] | 0) << 16) + i1 | 0;
   i12 = 22;
   break;
  }
 case 2:
  {
   i12 = 22;
   break;
  }
 case 1:
  break;
 default:
  {
   i13 = i1;
   i13 = Math_imul(i13, -962287725) | 0;
   i12 = i13 >>> 10;
   i13 = i12 ^ i13;
   i13 = Math_imul(i13, -962287725) | 0;
   i12 = i13 >>> 17;
   i13 = i12 ^ i13;
   return i13 | 0;
  }
 }
 if ((i12 | 0) == 22) i1 = ((HEAPU8[i2 + 1 >> 0] | 0) << 8) + i1 | 0;
 i13 = Math_imul((HEAPU8[i2 >> 0] | 0) + i1 | 0, -962287725) | 0;
 i13 = i13 >>> 16 ^ i13;
 i13 = Math_imul(i13, -962287725) | 0;
 i12 = i13 >>> 10;
 i13 = i12 ^ i13;
 i13 = Math_imul(i13, -962287725) | 0;
 i12 = i13 >>> 17;
 i13 = i12 ^ i13;
 return i13 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 2) | 0, 0, i7 - i6 << 2 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37012 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 512)) {
    if (!(i1 & 1048576)) {
     HEAPF32[i6 >> 2] = Math_fround(0.0);
     break;
    }
    if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
    HEAPF32[i6 >> 2] = Math_fround(__Z19SimpleStringToFloatPKcPi(i1, 0));
   } else {
    do if (!(i1 & 16384)) {
     if (i1 & 1024 | 0) {
      d2 = +(HEAP32[i5 >> 2] | 0);
      break;
     }
     if (i1 & 2048 | 0) {
      d2 = +((HEAP32[i5 >> 2] | 0) >>> 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    HEAPF32[i6 >> 2] = Math_fround(d2);
   } while (0);
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 4 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN8GUIStyle14GetDefaultFontEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i5 = i7;
 i1 = HEAP32[gb + 1468160 >> 2] | 0;
 do if (!i1) i6 = 10; else {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468160 >> 2] | 0) | 0)) i6 = 10;
 } while (0);
 if ((i6 | 0) == 10) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1017543 | 0, 9);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i4) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[gb + 1468160 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 i1 = HEAP32[gb + 1468160 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 19; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 19; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 21;
  }
 }
 if ((i6 | 0) == 19) i6 = 21;
 if ((i6 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1468160 >> 2] | 0) | 0;
 i8 = i1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN16b2ContactManager7CollideEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i1 = HEAP32[i12 + 60 >> 2] | 0;
 if (!i1) return;
 i13 = i12 + 4 | 0;
 i14 = i12 + 72 | 0;
 i15 = i12 + 68 | 0;
 do {
  i10 = HEAP32[i1 + 48 >> 2] | 0;
  i7 = HEAP32[i1 + 52 >> 2] | 0;
  i8 = HEAP32[i1 + 56 >> 2] | 0;
  i9 = HEAP32[i1 + 60 >> 2] | 0;
  i4 = HEAP32[i10 + 28 >> 2] | 0;
  i6 = HEAP32[i7 + 28 >> 2] | 0;
  i5 = i1 + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  L6 : do if (!(i2 & 8)) i11 = 16; else {
   if (!(HEAP32[i6 >> 2] | 0)) {
    if (HEAP32[i4 >> 2] | 0) i11 = 6;
   } else i11 = 6;
   L10 : do if ((i11 | 0) == 6) {
    i11 = 0;
    i3 = HEAP32[i6 + 108 >> 2] | 0;
    if (i3 | 0) do {
     if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) if (!(HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + 61 >> 0] | 0)) break L10;
     i3 = HEAP32[i3 + 12 >> 2] | 0;
    } while ((i3 | 0) != 0);
    i3 = HEAP32[i15 >> 2] | 0;
    do if (i3) if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i10 | 0, i7 | 0) | 0) {
     i2 = HEAP32[i5 >> 2] | 0;
     break;
    } else {
     i10 = HEAP32[i1 + 12 >> 2] | 0;
     __ZN16b2ContactManager7DestroyEP9b2Contact(i12, i1);
     i1 = i10;
     break L6;
    } while (0);
    HEAP32[i5 >> 2] = i2 & -9;
    i11 = 16;
    break L6;
   } while (0);
   i10 = HEAP32[i1 + 12 >> 2] | 0;
   __ZN16b2ContactManager7DestroyEP9b2Contact(i12, i1);
   i1 = i10;
  } while (0);
  do if ((i11 | 0) == 16) {
   i11 = 0;
   if (!(HEAP16[i4 + 4 >> 1] & 2)) i3 = 0; else i3 = (HEAP32[i4 >> 2] | 0) != 0;
   if (!(HEAP16[i6 + 4 >> 1] & 2)) i2 = 0; else i2 = (HEAP32[i6 >> 2] | 0) != 0;
   if (!(i3 | i2)) {
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    break;
   }
   i8 = HEAP32[(HEAP32[i10 + 44 >> 2] | 0) + (i8 * 28 | 0) + 24 >> 2] | 0;
   i10 = HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + (i9 * 28 | 0) + 24 >> 2] | 0;
   i9 = HEAP32[i13 >> 2] | 0;
   f19 = Math_fround(HEAPF32[i9 + (i10 * 36 | 0) >> 2]);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i9 + (i8 * 36 | 0) + 8 >> 2]));
   f18 = Math_fround(HEAPF32[i9 + (i10 * 36 | 0) + 4 >> 2]);
   f18 = Math_fround(f18 - Math_fround(HEAPF32[i9 + (i8 * 36 | 0) + 12 >> 2]));
   f17 = Math_fround(HEAPF32[i9 + (i8 * 36 | 0) >> 2]);
   f17 = Math_fround(f17 - Math_fround(HEAPF32[i9 + (i10 * 36 | 0) + 8 >> 2]));
   f16 = Math_fround(HEAPF32[i9 + (i8 * 36 | 0) + 4 >> 2]);
   if (f19 > Math_fround(0.0) | f18 > Math_fround(0.0) | f17 > Math_fround(0.0) | Math_fround(f16 - Math_fround(HEAPF32[i9 + (i10 * 36 | 0) + 12 >> 2])) > Math_fround(0.0)) {
    i10 = HEAP32[i1 + 12 >> 2] | 0;
    __ZN16b2ContactManager7DestroyEP9b2Contact(i12, i1);
    i1 = i10;
    break;
   } else {
    __ZN9b2Contact6UpdateEP17b2ContactListener(i1, HEAP32[i14 >> 2] | 0);
    i1 = HEAP32[i1 + 12 >> 2] | 0;
    break;
   }
  } while (0);
 } while ((i1 | 0) != 0);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E5clearEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i7 = i13 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i13 + 56 | 0;
 if (!i1) i1 = 0; else {
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4) {
   i5 = i14 + 4 | 0;
   i3 = 0;
   do {
    i2 = i1 + (i3 * 20 | 0) | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + (i3 * 20 | 0) + 12 >> 2] | 0;
     HEAP32[i14 >> 2] = 54;
     HEAP32[i5 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i14);
    }
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
 }
 HEAP32[i6 >> 2] = 32;
 HEAP32[i13 + 68 >> 2] = 16;
 HEAP32[i13 + 64 >> 2] = 6;
 HEAP8[i13 + 72 >> 0] = 0;
 i2 = __Znwj(640) | 0;
 if (!i1) i1 = 32; else {
  __ZdlPv(i1);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i2;
 i6 = i2 + (i1 * 20 | 0) | 0;
 i7 = i13 + 32 | 0;
 if ((i2 | 0) == (i6 | 0)) {
  i15 = i13 + 60 | 0;
  HEAP32[i15 >> 2] = 0;
  i15 = i13 + 4 | 0;
  HEAP32[i15 >> 2] = 0;
  STACKTOP = i16;
  return;
 }
 i8 = i13 + 44 | 0;
 i9 = i7 + 11 | 0;
 i10 = i13 + 36 | 0;
 i11 = i14 + 4 | 0;
 i12 = i13 + 48 | 0;
 do {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = i1;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i1 = HEAP32[i3 >> 2] | 0;
    i15 = 16;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i5;
    if (!i5) i1 = i2; else {
     i1 = i2;
     i15 = 18;
    }
   } else i15 = 16;
   if ((i15 | 0) == 16) {
    i3 = i5 + 16 & -16;
    HEAP32[i14 >> 2] = 54;
    HEAP32[i11 >> 2] = i1;
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i2 + 8 >> 2] = i3 | -2147483648;
    HEAP32[i2 + 4 >> 2] = i5;
    i15 = 18;
   }
   if ((i15 | 0) == 18) {
    i15 = 0;
    _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i1 + i5 >> 0] = 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  }
  HEAP32[i2 + 16 >> 2] = HEAP32[i12 >> 2];
  i2 = i2 + 20 | 0;
 } while ((i2 | 0) != (i6 | 0));
 i15 = i13 + 60 | 0;
 HEAP32[i15 >> 2] = 0;
 i15 = i13 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function _UNITY_FT_Done_Library(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 if (!i10) {
  i12 = 33;
  return i12 | 0;
 }
 i11 = i10 + 224 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i12 + -1;
 if ((i12 | 0) > 1) {
  i12 = 0;
  return i12 | 0;
 }
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i10 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i9 = 0;
 i1 = i2;
 do {
  L9 : do if (!i2) i2 = 0; else {
   if (i9 | 0) {
    i7 = 0;
    while (1) {
     i1 = HEAP32[i10 + 20 + (i7 << 2) >> 2] | 0;
     if (HEAP32[HEAP32[i1 >> 2] >> 2] & 1 | 0) {
      i6 = i1 + 16 | 0;
      i1 = HEAP32[i6 >> 2] | 0;
      if (i1 | 0) do {
       i1 = HEAP32[i1 + 8 >> 2] | 0;
       if (i1 | 0) {
        i2 = HEAP32[i1 + 96 >> 2] | 0;
        if (i2 | 0) {
         i5 = (HEAP32[i1 + 128 >> 2] | 0) + 52 | 0;
         i8 = HEAP32[i5 >> 2] | 0;
         HEAP32[i5 >> 2] = i8 + -1;
         if ((i8 | 0) <= 1) {
          i3 = HEAP32[i2 + 8 >> 2] | 0;
          i4 = i2 + 16 | 0;
          i5 = _UNITY_FT_List_Find(i4, i1) | 0;
          if (i5 | 0) {
           _UNITY_FT_List_Remove(i4, i5);
           _UNITY_ft_mem_free(i3, i5);
           _destroy_face(i3, i1, i2);
          }
         }
        }
       }
       i1 = HEAP32[i6 >> 2] | 0;
      } while ((i1 | 0) != 0);
     }
     i7 = i7 + 1 | 0;
     i2 = HEAP32[i12 >> 2] | 0;
     if (i7 >>> 0 >= i2 >>> 0) {
      i1 = i2;
      break L9;
     }
    }
   }
   i8 = HEAP32[gb + 185856 + (i9 << 2) >> 2] | 0;
   i7 = 0;
   while (1) {
    i2 = HEAP32[i10 + 20 + (i7 << 2) >> 2] | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!(_strcmp(HEAP32[i3 + 8 >> 2] | 0, i8) | 0)) if (!(HEAP32[i3 >> 2] & 1)) i2 = i1; else {
     i6 = i2 + 16 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     if (!i2) i2 = i1; else {
      i1 = i2;
      do {
       i1 = HEAP32[i1 + 8 >> 2] | 0;
       if (i1 | 0) {
        i2 = HEAP32[i1 + 96 >> 2] | 0;
        if (i2 | 0) {
         i4 = (HEAP32[i1 + 128 >> 2] | 0) + 52 | 0;
         i5 = HEAP32[i4 >> 2] | 0;
         HEAP32[i4 >> 2] = i5 + -1;
         if ((i5 | 0) <= 1) {
          i3 = HEAP32[i2 + 8 >> 2] | 0;
          i4 = i2 + 16 | 0;
          i5 = _UNITY_FT_List_Find(i4, i1) | 0;
          if (i5 | 0) {
           _UNITY_FT_List_Remove(i4, i5);
           _UNITY_ft_mem_free(i3, i5);
           _destroy_face(i3, i1, i2);
          }
         }
        }
       }
       i1 = HEAP32[i6 >> 2] | 0;
      } while ((i1 | 0) != 0);
      i2 = HEAP32[i12 >> 2] | 0;
     }
    } else i2 = i1;
    i7 = i7 + 1 | 0;
    if (i7 >>> 0 >= i2 >>> 0) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  } while (0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != 2);
 if (i1 | 0) do {
  _UNITY_FT_Remove_Module(i10, HEAP32[i10 + 20 + (i1 + -1 << 2) >> 2] | 0) | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 _UNITY_ft_pic_container_destroy(i10);
 _UNITY_ft_mem_free(i11, i10);
 i12 = 0;
 return i12 | 0;
}

function __ZN17CollisionMeshData8TransferI24GenerateTypeTreeTransferEEvRT_R4Mesh(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i6 + 8 | 0;
 i11 = i6;
 i4 = i6 + 36 | 0;
 i5 = i6 + 16 | 0;
 i8 = gb + 64016 | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i11);
 i8 = i13;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i3;
 i10 = gb + 64016 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i8 = i5 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i11);
 i10 = i13;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i14 = i3;
 HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 i14 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 425997 | 0, i14, i4, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i7, gb + 1041885 | 0, gb + 1041885 | 0, i13, 0);
 i12 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, i12, i11, 0);
 i10 = i7 + 16 | 0;
 i9 = i7 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 426024 | 0, i14, i5, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i7, gb + 1041885 | 0, gb + 1041885 | 0, i13, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i7, gb + 1041891 | 0, i12, i11, 0);
 HEAP32[(HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i7);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i7);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i7);
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
  HEAP32[i5 >> 2] = 0;
 }
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN9Rigidbody11SetRotationERK11Quaternionf(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 56 | 0;
 i13 = i16 + 28 | 0;
 i14 = i16;
 i15 = i11 + 52 | 0;
 i17 = HEAP32[i15 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i14 | 0, i17 | 0);
 i17 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = i17;
 i6 = i14 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 i7 = i14 + 8 | 0;
 HEAP32[i7 >> 2] = i5;
 i8 = i14 + 12 | 0;
 HEAP32[i8 >> 2] = i1;
 f9 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i17 & 2139095040) >>> 0 < 2139095040) {
  f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if ((i3 & 2139095040) >>> 0 < 2139095040) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i5 & 2139095040) >>> 0 < 2139095040) {
    f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if ((i1 & 2139095040) >>> 0 < 2139095040) if (Math_fround(Math_abs(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f4 * f4))))) + Math_fround(-1.0)))) < Math_fround(.00999999977)) {
     if (!(HEAP8[i11 + 84 >> 0] | 0)) {
      i1 = HEAP32[i11 + 108 >> 2] | 0;
      if (i1 | 0) HEAP32[i1 + 40 >> 2] = 1;
     } else {
      if (HEAP8[i11 + 80 >> 0] | 0) {
       i17 = HEAP32[i15 >> 2] | 0;
       if (!(mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 228 >> 2] | 0, i17 | 0, i13 | 0) | 0)) {
        i5 = HEAP32[i15 >> 2] | 0;
        mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i12 | 0, i5 | 0);
        i5 = HEAP32[i12 + 20 >> 2] | 0;
        i17 = HEAP32[i12 + 24 >> 2] | 0;
        HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
        HEAP32[i13 + 20 >> 2] = i5;
        HEAP32[i13 + 24 >> 2] = i17;
       }
       HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i13 + 4 >> 2] = HEAP32[i6 >> 2];
       HEAP32[i13 + 8 >> 2] = HEAP32[i7 >> 2];
       HEAP32[i13 + 12 >> 2] = HEAP32[i8 >> 2];
       i17 = HEAP32[i15 >> 2] | 0;
       mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 224 >> 2] | 0, i17 | 0, i13 | 0);
      }
      i17 = i11 + 104 | 0;
      HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -2;
     }
     i17 = HEAP32[i15 >> 2] | 0;
     mftCall_viii(HEAP32[(HEAP32[i17 >> 2] | 0) + 88 >> 2] | 0, i17 | 0, i14 | 0, 1);
     STACKTOP = i16;
     return;
    }
   }
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 781850 | 0, 0, gb + 732812 | 0, 1307, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i16;
 return;
}

function __ZN7mecanim8skeleton25Skeleton2BoneAdjustLengthEPKNS0_8SkeletonEiiiRKN4math7_float3ERKfPNS0_13SkeletonPoseTINS4_4trsXEEESD_(i4, i5, i9, i10, i6, i8, i11, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i7 = i7 + 4 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 f2 = Math_fround(HEAPF32[i7 + (i9 * 40 | 0) >> 2]);
 f1 = Math_fround(HEAPF32[i7 + (i9 * 40 | 0) + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i7 + (i9 * 40 | 0) + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) >> 2]);
 f16 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i7 + (i5 * 40 | 0) + 8 >> 2]);
 f14 = Math_fround(f2 - f17);
 f13 = Math_fround(f1 - f16);
 f12 = Math_fround(f3 - f15);
 f18 = Math_fround(HEAPF32[i7 + (i10 * 40 | 0) >> 2]);
 f19 = Math_fround(HEAPF32[i7 + (i10 * 40 | 0) + 4 >> 2]);
 f2 = Math_fround(f18 - f2);
 f1 = Math_fround(f19 - f1);
 f3 = Math_fround(Math_fround(HEAPF32[i7 + (i10 * 40 | 0) + 8 >> 2]) - f3);
 f19 = Math_fround(HEAPF32[i6 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f17 = Math_fround(f19 - f17);
 f16 = Math_fround(f18 - f16);
 f15 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f15);
 f3 = Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(Math_fround(f15 * f15) + Math_fround(0.0))))) / Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))))) + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)) + Math_fround(Math_fround(f3 * f3) + Math_fround(0.0)))))));
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(Math_fround(1.0) - f1);
 if (!(f3 > f2)) return;
 f19 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(f3 - f2) / Math_fround(f1 * Math_fround(2.0)))))));
 f19 = Math_fround(Math_fround(f19 * Math_fround(f1 * f19)) + Math_fround(1.0));
 i11 = i11 + 4 | 0;
 i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
 i6 = i11 + (i9 * 40 | 0) | 0;
 f16 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f19);
 i7 = i11 + (i9 * 40 | 0) + 4 | 0;
 f18 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * f19);
 i8 = i11 + (i9 * 40 | 0) + 8 | 0;
 f17 = Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i6 >> 2] = f16;
 HEAPF32[i7 >> 2] = f18;
 HEAPF32[i8 >> 2] = f17;
 i8 = i11 + (i10 * 40 | 0) | 0;
 f17 = Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2]));
 i9 = i11 + (i10 * 40 | 0) + 4 | 0;
 f18 = Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2]));
 i11 = i11 + (i10 * 40 | 0) + 8 | 0;
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2]));
 HEAPF32[i8 >> 2] = f17;
 HEAPF32[i9 >> 2] = f18;
 HEAPF32[i11 >> 2] = f19;
 return;
}

function __ZN5physx14PxRigidBodyExt23addLocalForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i1, i2, i4, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i6 + 24 | 0;
 i7 = i6 + 12 | 0;
 i8 = i6;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i20 | 0, i1 | 0);
 f18 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f16 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f19 = Math_fround(HEAPF32[i20 >> 2]);
 f17 = Math_fround(f18 * f19);
 f13 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f10 * f13));
 f11 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f9 * f11));
 f14 = Math_fround(Math_fround(f19 * f17) + Math_fround(Math_fround(f18 * f16) + Math_fround(f15 * Math_fround(Math_fround(f9 * f13) - Math_fround(f10 * f11)))));
 f12 = Math_fround(Math_fround(f13 * f17) + Math_fround(Math_fround(f10 * f16) + Math_fround(f15 * Math_fround(Math_fround(f18 * f11) - Math_fround(f9 * f19)))));
 f17 = Math_fround(Math_fround(Math_fround(f9 * f16) + Math_fround(f15 * Math_fround(Math_fround(f10 * f19) - Math_fround(f18 * f13)))) + Math_fround(f11 * f17));
 f14 = Math_fround(Math_fround(HEAPF32[i20 + 16 >> 2]) + f14);
 f12 = Math_fround(Math_fround(HEAPF32[i20 + 20 >> 2]) + f12);
 f17 = Math_fround(Math_fround(HEAPF32[i20 + 24 >> 2]) + f17);
 HEAPF32[i7 >> 2] = f14;
 HEAPF32[i7 + 4 >> 2] = f12;
 HEAPF32[i7 + 8 >> 2] = f17;
 f17 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(f12 * f13)) + Math_fround(f14 * f11));
 f10 = Math_fround(Math_fround(f13 * f18) + Math_fround(Math_fround(f12 * f16) + Math_fround(f15 * Math_fround(Math_fround(f17 * f11) - Math_fround(f14 * f19)))));
 f9 = Math_fround(Math_fround(Math_fround(f14 * f16) + Math_fround(f15 * Math_fround(Math_fround(f12 * f19) - Math_fround(f17 * f13)))) + Math_fround(f11 * f18));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(f19 * f18) + Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f11)))));
 HEAPF32[i8 + 4 >> 2] = f10;
 HEAPF32[i8 + 8 >> 2] = f9;
 __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb(i1, i8, i7, i3, i5);
 STACKTOP = i6;
 return;
}

function __ZN17BufferManagerGLESD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 __ZN17BufferManagerGLES5ClearEv(i4);
 i3 = i4 + 148 | 0;
 i2 = i4 + 156 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 152 >> 2] | 0;
  i5 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i6;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZdlPv(i6);
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 136 | 0, HEAP32[i4 + 140 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 124 | 0, HEAP32[i4 + 128 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 112 | 0, HEAP32[i4 + 116 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 100 | 0, HEAP32[i4 + 104 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 88 | 0, HEAP32[i4 + 92 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 76 | 0, HEAP32[i4 + 80 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 64 | 0, HEAP32[i4 + 68 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 52 | 0, HEAP32[i4 + 56 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 40 | 0, HEAP32[i4 + 44 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 28 | 0, HEAP32[i4 + 32 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 16 | 0, HEAP32[i4 + 20 >> 2] | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i3) return;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i12, i5, i1) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17;
 i14 = i12 + 196 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 65;
 HEAP32[i13 + 4 >> 2] = i15;
 i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 80 | 0, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 i16 = i12 + 172 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i3 = i12 + 176 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i11 = i2 >>> 0 > i5 >>> 0 ? i5 : i2;
 i4 = i1 + (i11 * 80 | 0) | 0;
 if (i11) {
  i2 = i15;
  while (1) {
   i11 = i1;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i9 = i2;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = i10;
   i9 = i2 + 8 | 0;
   i10 = i1 + 8 | 0;
   i11 = i9 + 56 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
   HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
   i9 = i1 + 72 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i2 + 72 | 0;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = i1 + 80 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 80 | 0;
  }
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i8 = i15 + (i5 * 80 | 0) | 0;
 if ((i2 | 0) == (i5 | 0)) {
  i12 = HEAP32[i16 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 >> 2] = 65;
  i14 = i13 + 4 | 0;
  HEAP32[i14 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
  HEAP32[i16 >> 2] = i15;
  STACKTOP = i17;
  return;
 }
 i4 = i12 + 92 | 0;
 i5 = i12 + 100 | 0;
 i6 = i12 + 156 | 0;
 i7 = i12 + 160 | 0;
 i3 = i12 + 164 | 0;
 i1 = i15 + (i2 * 80 | 0) | 0;
 do {
  i11 = i4;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  i9 = i1 + 8 | 0;
  i10 = i5;
  i11 = i9 + 56 | 0;
  do {
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   i9 = i9 + 4 | 0;
   i10 = i10 + 4 | 0;
  } while ((i9 | 0) < (i11 | 0));
  HEAP32[i1 + 64 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 68 >> 2] = HEAP32[i7 >> 2];
  i10 = i3;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i1 + 72 | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i8 | 0));
 i12 = HEAP32[i16 >> 2] | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 65;
 i14 = i13 + 4 | 0;
 HEAP32[i14 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i13);
 HEAP32[i16 >> 2] = i15;
 STACKTOP = i17;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 0) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i12, i1, 1);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i12, i1, 1); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf(i1, i8, i10, i11) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i7 = i9;
 i2 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i2 | 0));
 __ZN10Matrix4x4f9TransposeEv(i9) | 0;
 f14 = Math_fround(HEAPF32[i9 + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i9 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + 40 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62536 + 8 >> 2]);
 f3 = Math_fround(f6 * f4);
 f13 = Math_fround(HEAPF32[gb + 62536 + 4 >> 2]);
 f3 = Math_fround(f3 - Math_fround(f15 * f13));
 f5 = Math_fround(HEAPF32[gb + 62536 >> 2]);
 f4 = Math_fround(Math_fround(f15 * f5) - Math_fround(f14 * f4));
 f5 = Math_fround(Math_fround(f14 * f13) - Math_fround(f6 * f5));
 f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)));
 if (!(f6 <= Math_fround(9.99999997e-07))) {
  f14 = Math_fround(Math_sqrt(Math_fround(f6)));
  f15 = Math_fround(f3 / f14);
  f4 = Math_fround(f4 / f14);
  f3 = Math_fround(f5 / f14);
  HEAPF32[i8 >> 2] = f15;
  HEAPF32[i8 + 4 >> 2] = f4;
  i2 = i8 + 8 | 0;
  HEAPF32[i2 >> 2] = f3;
  i1 = i8;
  f5 = f15;
 } else {
  i7 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i9 = HEAP32[i9 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i8 + 4 >> 2] = i1;
  i2 = i8 + 8 | 0;
  HEAP32[i2 >> 2] = i9;
  f3 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i8;
  f5 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f14 = Math_fround(HEAPF32[gb + 62536 + 4 >> 2]);
 f6 = Math_fround(f14 * f3);
 f13 = Math_fround(HEAPF32[gb + 62536 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f13 * f4));
 f13 = Math_fround(f13 * f5);
 f15 = Math_fround(HEAPF32[gb + 62536 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f3 * f15));
 f14 = Math_fround(Math_fround(f4 * f15) - Math_fround(f14 * f5));
 f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f6 * f6) + Math_fround(f13 * f13)))));
 f13 = Math_fround(f13 / f15);
 f14 = Math_fround(f14 / f15);
 HEAPF32[i10 >> 2] = Math_fround(f6 / f15);
 HEAPF32[i10 + 4 >> 2] = f13;
 HEAPF32[i10 + 8 >> 2] = f14;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(f14 * Math_fround(0.0));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(+Math_atan2(+Math_fround(f13 - f15), +Math_fround(f14 + Math_fround(f15 * Math_fround(0.0)))));
 i10 = f15 < Math_fround(0.0);
 f14 = Math_fround(f15 + Math_fround(6.28318548));
 HEAPF32[i11 >> 2] = i10 ? f14 : f15;
 STACKTOP = i12;
 return;
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb0EEEvRPT_PKcRjS9_RT0_(i4, i1, i5, i2, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4); else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
  return;
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, HEAP32[i5 >> 2] | 0);
 i5 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 1736, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i5);
 i2 = i5 + 888 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 912 >> 2] = 1065353216;
 HEAP32[i5 + 916 >> 2] = 1065353216;
 HEAP32[i5 + 920 >> 2] = 1065353216;
 HEAP32[i5 + 924 >> 2] = 1065353216;
 i2 = i5 + 928 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 952 >> 2] = 1065353216;
 HEAP32[i5 + 956 >> 2] = 1065353216;
 HEAP32[i5 + 960 >> 2] = 1065353216;
 HEAP32[i5 + 964 >> 2] = 1065353216;
 i2 = i5 + 968 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 992 >> 2] = 1065353216;
 HEAP32[i5 + 996 >> 2] = 1065353216;
 HEAP32[i5 + 1e3 >> 2] = 1065353216;
 HEAP32[i5 + 1004 >> 2] = 1065353216;
 i2 = i5 + 1008 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i5 + 1032 >> 2] = 1065353216;
 HEAP32[i5 + 1036 >> 2] = 1065353216;
 HEAP32[i5 + 1040 >> 2] = 1065353216;
 HEAP32[i5 + 1044 >> 2] = 1065353216;
 i2 = i5 + 1048 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i5 + 1068 >> 2] = Math_fround(1.0);
 i2 = i5 + 1072 | 0;
 i3 = i5 + 1708 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP16[i3 + 20 >> 1] = 0;
 HEAP8[i5 + 1730 >> 0] = 1;
 HEAP8[i5 + 1731 >> 0] = 0;
 HEAP8[i5 + 1732 >> 0] = 1;
 HEAP8[i5 + 1733 >> 0] = 0;
 HEAP8[i5 + 1734 >> 0] = 0;
 _memset(i5 + 1088 | 0, -1, 620) | 0;
 HEAP32[i4 >> 2] = i5;
 __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 return;
}

function __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i6 = i10;
 i7 = i10 + 32 | 0;
 i8 = i10 + 28 | 0;
 i3 = HEAP16[i1 >> 1] | 0;
 i4 = (i3 & 65535) < 65534;
 L1 : do if ((HEAP16[i1 + 2 >> 1] | 0) == -1 & (i4 ^ 1)) {
  i11 = i5 + 4 | 0;
  i1 = HEAP32[i11 >> 2] & -12289;
  HEAP32[i11 >> 2] = i1;
 } else {
  L4 : do if ((HEAP32[i2 + 8 >> 2] | 0) != 2) switch (HEAP32[i2 + 12 >> 2] | 0) {
  case 1:
   {
    i11 = i5 + 4 | 0;
    i1 = HEAP32[i11 >> 2] & -12289 | 4096;
    HEAP32[i11 >> 2] = i1;
    break L1;
   }
  case 2:
   {
    i11 = i5 + 4 | 0;
    i1 = HEAP32[i11 >> 2] & -12289 | 8192;
    HEAP32[i11 >> 2] = i1;
    break L1;
   }
  default:
   break L4;
  } while (0);
  i11 = i5 + 4 | 0;
  i1 = HEAP32[i11 >> 2] & -12289;
  HEAP32[i11 >> 2] = i1;
 } while (0);
 if (!i4) {
  i11 = i5 + 4 | 0;
  i9 = i1 & -2049;
  HEAP32[i11 >> 2] = i9;
  i9 = i9 & -16385;
  HEAP32[i11 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
 i3 = i3 & 65535;
 i3 = (HEAP32[i2 + 20 >> 2] | 0) > (i3 | 0) ? (HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) | 0 : gb + 1098016 | 0;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = i1 | 2048;
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = -1073741814;
 HEAP32[i2 + 3180 >> 2] = i1;
 HEAP32[i2 + 3184 >> 2] = 2;
 i1 = HEAP32[i2 + 3188 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 >= 2) {
  i5 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i11 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i8) | 0;
  HEAP32[i6 >> 2] = gb + 478914;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i11;
  __Z6FormatPKcz(i7, gb + 478736 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 HEAP32[i2 + 3192 >> 2] = 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = -1073741813;
 HEAP32[i2 + 3200 >> 2] = i1;
 HEAP32[i2 + 3204 >> 2] = 2;
 i1 = HEAP32[i2 + 3208 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 >= 2) {
  i6 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
  i11 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i8) | 0;
  HEAP32[i9 >> 2] = gb + 478914;
  HEAP32[i9 + 4 >> 2] = i6;
  HEAP32[i9 + 8 >> 2] = i11;
  __Z6FormatPKcz(i7, gb + 478736 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 HEAP32[i2 + 3212 >> 2] = 0;
 i11 = i4;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = i9 & -16385;
 HEAP32[i11 >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorINS0_IfNS_9allocatorIfEEEENS1_IS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i14, i6) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = i14 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i14);
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 }
 i13 = i14 + 8 | 0;
 i12 = ((HEAP32[i13 >> 2] | 0) - i1 | 0) / 12 | 0;
 i8 = i12 << 1;
 i3 = i12 >>> 0 < 178956970 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 357913941;
 i8 = (i2 - i1 | 0) / 12 | 0;
 if (!i3) i10 = 0; else i10 = __Znwj(i3 * 12 | 0) | 0;
 i4 = i10 + (i8 * 12 | 0) | 0;
 i9 = i4;
 i12 = i10 + (i3 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 i11 = i10 + (i8 * 12 | 0) + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 + (i8 * 12 | 0) + 8 >> 2] = 0;
 i3 = i6 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 - i2 | 0;
 i7 = i5 >> 2;
 if (i7 | 0) {
  if (i7 >>> 0 > 1073741823) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i6 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  } else i6 = i2;
  i2 = __Znwj(i5) | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i10 + (i8 * 12 | 0) + 8 >> 2] = i2 + (i7 << 2);
  i1 = i1 - i6 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
   HEAP32[i11 >> 2] = i2 + (i1 >> 2 << 2);
  }
 }
 i11 = i4 + 12 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  i1 = i9;
  i7 = i10;
  i3 = i10;
 } else {
  do {
   i3 = i4 + -12 | 0;
   HEAP32[i3 >> 2] = 0;
   i8 = i4 + -8 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i4 + -4 >> 2] = 0;
   i6 = i1 + -8 | 0;
   i1 = i1 + -12 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
   i5 = i2 >> 2;
   if (i5 | 0) {
    if (i5 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
    i7 = __Znwj(i2) | 0;
    HEAP32[i8 >> 2] = i7;
    HEAP32[i3 >> 2] = i7;
    HEAP32[i4 + -4 >> 2] = i7 + (i5 << 2);
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = (HEAP32[i6 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i7 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i8 >> 2] = i7 + (i2 >> 2 << 2);
    }
   }
   i4 = i9 + -12 | 0;
   i9 = i4;
  } while ((i1 | 0) != (i10 | 0));
  i1 = i9;
  i7 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i15 >> 2] = i11;
 HEAP32[i13 >> 2] = i12;
 i6 = i7;
 if ((i3 | 0) != (i6 | 0)) do {
  i1 = i3;
  i3 = i3 + -12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i1 = i1 + -8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i4 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i5 | 0) >>> 2) << 2);
   __ZdlPv(i4);
  }
 } while ((i3 | 0) != (i6 | 0));
 if (!i7) return;
 __ZdlPv(i7);
 return;
}

function __ZN5physx2Sc15ArticulationSim12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_(i10, i1, i6, i7, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 4096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 2048 | 0;
 i9 = i12;
 i5 = i10 + 16 | 0;
 i2 = HEAP32[i5 >> 2] << 5;
 _memset(i9 | 0, 0, i2 | 0) | 0;
 _memset(i11 | 0, 0, i2 | 0) | 0;
 i2 = __ZNK5physx2Sc8BodyCore6getSimEv(i1) | 0;
 i3 = HEAP32[i10 + 28 >> 2] | 0;
 L1 : do if (!i3) i1 = -2147483648; else {
  i4 = HEAP32[i10 + 24 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break L1;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = -2147483648;
    break;
   }
  }
 } while (0);
 f13 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i7 + 4 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[i7 + 8 >> 2]));
 HEAPF32[i9 + (i1 << 5) >> 2] = f13;
 HEAPF32[i9 + (i1 << 5) + 4 >> 2] = f14;
 HEAPF32[i9 + (i1 << 5) + 8 >> 2] = f15;
 HEAPF32[i9 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
 f15 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i8 + 4 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i8 + 8 >> 2]));
 HEAPF32[i9 + (i1 << 5) + 16 >> 2] = f15;
 HEAPF32[i9 + (i1 << 5) + 20 >> 2] = f14;
 HEAPF32[i9 + (i1 << 5) + 24 >> 2] = f13;
 HEAPF32[i9 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
 __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_(i6, i9, i11);
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i10 + 24 >> 2] | 0;
 i2 = 0;
 do {
  i10 = HEAP32[(HEAP32[i1 + (i2 << 2) >> 2] | 0) + 52 >> 2] | 0;
  f18 = Math_fround(HEAPF32[i11 + (i2 << 5) >> 2]);
  f17 = Math_fround(HEAPF32[i11 + (i2 << 5) + 4 >> 2]);
  f16 = Math_fround(HEAPF32[i11 + (i2 << 5) + 8 >> 2]);
  f13 = Math_fround(HEAPF32[i11 + (i2 << 5) + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i11 + (i2 << 5) + 20 >> 2]);
  f15 = Math_fround(HEAPF32[i11 + (i2 << 5) + 24 >> 2]);
  i7 = i10 + 80 | 0;
  f18 = Math_fround(f18 + Math_fround(HEAPF32[i7 >> 2]));
  i9 = i10 + 84 | 0;
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i9 >> 2]));
  i8 = i10 + 88 | 0;
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i8 >> 2]));
  HEAPF32[i7 >> 2] = f18;
  HEAPF32[i9 >> 2] = f17;
  HEAPF32[i8 >> 2] = f16;
  i8 = i10 + 96 | 0;
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
  i9 = i10 + 100 | 0;
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i9 >> 2]));
  i10 = i10 + 104 | 0;
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i9 >> 2] = f14;
  HEAPF32[i10 >> 2] = f15;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx9NpPhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableEbPNS_20PxProfileZoneManagerE(i6, i3, i2, i1, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i4 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i6 >> 2] = gb + 93400 + 8;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 __ZN5physx2Sc7PhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableE(i6 + 20 | 0, i3, i2);
 i1 = i6 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 512, gb + 688901 | 0, 80) | 0;
 HEAP32[i6 + 52 >> 2] = i1;
 HEAP32[i6 + 56 >> 2] = 128;
 _memset(i1 | 0, 0, 512) | 0;
 HEAP32[i6 + 60 >> 2] = gb + 146804 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i2 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i6 + 64 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = i6 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i6 + 92 >> 2] = Math_fround(.75);
 HEAP32[i6 + 96 >> 2] = -1;
 HEAP32[i6 + 100 >> 2] = 0;
 HEAP32[i6 + 104 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i6 + 108 >> 2] = gb + 146824 + 8;
 HEAP8[i6 + 112 >> 0] = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i7 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i6 + 116 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcRNS_21PxProfileNameProviderEj(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0, gb + 768255 | 0, gb + 146844 | 0, 16384) | 0;
 HEAP32[i6 + 120 >> 2] = i1;
 if (!i5) {
  i7 = i6 + 124 | 0;
  HEAP32[i7 >> 2] = i5;
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 i7 = i6 + 124 | 0;
 HEAP32[i7 >> 2] = i5;
 STACKTOP = i4;
 return;
}

function __ZN20TextRenderingPrivate8FontImplD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i8 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN20TextRenderingPrivate15DynamicFontDataD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63392 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i8 + 148 | 0, HEAP32[i8 + 152 >> 2] | 0);
 i4 = HEAP32[i8 + 132 >> 2] | 0;
 i1 = i4;
 if (i4 | 0) {
  i2 = i8 + 136 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i1 | 0) >>> 4) << 4);
  i6 = HEAP32[i8 + 144 >> 2] | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP32[i7 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
 }
 i1 = HEAP32[i8 + 116 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 120 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i6 = HEAP32[i8 + 128 >> 2] | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP32[i7 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 i4 = i8 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 104 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i7 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i6 = HEAP32[i8 + 112 >> 2] | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP32[i7 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 if ((HEAP32[i8 + 96 >> 2] | 0) > -1) {
  i6 = i8 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i8 + 84 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 i1 = HEAP32[i8 + 60 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 64 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -60 - i2 | 0) >>> 0) / 60 | 0) * 60 | 0);
  i6 = HEAP32[i8 + 72 >> 2] | 0;
  HEAP32[i7 >> 2] = 34;
  HEAP32[i7 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 i1 = i8 + 40 | 0;
 if ((HEAP32[i8 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i1 = i8 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
 __ZdlPv(i3);
 STACKTOP = i9;
 return;
}

function __ZN18ReflectionProbeJob3RunEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 switch (HEAP32[i6 + 8 >> 2] | 0) {
 case 3:
  {
   i1 = HEAP32[(__Z21GetManagerFromContexti(25) | 0) + 376 >> 2] | 0;
   if (!i1) return 1;
   do {
    i1 = i1 + -1 | 0;
    __ZN16ReflectionProbes16RenderProbeFacesEP15ReflectionProbei(HEAP32[gb + 1112272 >> 2] | 0, HEAP32[i6 >> 2] | 0, 63);
    i3 = HEAP32[i6 >> 2] | 0;
    i4 = i3 + 168 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
     HEAP32[i4 >> 2] = i2;
    }
    __ZN13ProbeRenderer8ConvolveEbijjb(i2, 1, 63, 1, 1, 0);
    i3 = HEAP32[i6 >> 2] | 0;
    i4 = i3 + 168 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
     HEAP32[i4 >> 2] = i2;
    }
    __ZN13ProbeRenderer8ConvolveEbijjb(i2, 1, 63, 2, -1, 1);
    i3 = HEAP32[gb + 1112272 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    i5 = i4 + 168 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(i3, i4) | 0;
     HEAP32[i5 >> 2] = i2;
    }
    __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer(i4, i2);
    __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(i3, i4, HEAP32[i4 + 156 >> 2] | 0);
    HEAP8[i4 + 160 >> 0] = 0;
    HEAP8[(HEAP32[i5 >> 2] | 0) + 16 >> 0] = 1;
    HEAP32[i5 >> 2] = 0;
   } while ((i1 | 0) != 0);
   return 1;
  }
 case 0:
  {
   __ZN16ReflectionProbes16RenderProbeFacesEP15ReflectionProbei(HEAP32[gb + 1112272 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0);
   return 1;
  }
 case 1:
  {
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + 168 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i2) | 0;
    HEAP32[i3 >> 2] = i1;
   }
   __ZN13ProbeRenderer8ConvolveEbijjb(i1, 1, 63, 1, 1, 0);
   return 1;
  }
 case 2:
  {
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + 168 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i2) | 0;
    HEAP32[i3 >> 2] = i1;
   }
   __ZN13ProbeRenderer8ConvolveEbijjb(i1, 1, 63, 2, -1, 1);
   i4 = HEAP32[gb + 1112272 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + 168 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(i4, i2) | 0;
    HEAP32[i3 >> 2] = i1;
   }
   __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer(i2, i1);
   __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(i4, i2, HEAP32[i2 + 156 >> 2] | 0);
   HEAP8[i2 + 160 >> 0] = 0;
   HEAP8[(HEAP32[i3 >> 2] | 0) + 16 >> 0] = 1;
   HEAP32[i3 >> 2] = 0;
   return 1;
  }
 default:
  return 1;
 }
 return 0;
}

function __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i19 + 52 | 0;
 i11 = i19 + 48 | 0;
 i18 = i19 + 16 | 0;
 i7 = i19;
 i15 = i1 + 196 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i8 + 16 >> 2] | 0;
 i17 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = 0;
 i9 = i2 + 4 | 0;
 i21 = HEAP32[i9 >> 2] | 0;
 i10 = i2 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i21;
 HEAP32[i7 + 8 >> 2] = i5;
 i8 = HEAPU16[i8 >> 1] | 0;
 i7 = __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_(i7, i6, i11) | 0;
 f20 = Math_fround(Math_fround((i8 + -1 | 0) >>> 0) * Math_fround(.5));
 f4 = Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(1.0)));
 i11 = (Math_imul((~~Math_fround(f4 + Math_fround(.5)) >>> 0) + (Math_imul(i7, i8) | 0) | 0, i8) | 0) + (~~Math_fround(Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(1.0))) + Math_fround(.5)) >>> 0) | 0;
 i11 = HEAPU8[(HEAP32[(HEAP32[i15 >> 2] | 0) + 4 >> 2] | 0) + i11 >> 0] | 0;
 i15 = HEAP32[i1 + 200 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i15 + (i11 * 12 | 0) >> 2]);
 f4 = Math_fround(HEAPF32[i15 + (i11 * 12 | 0) + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i15 + (i11 * 12 | 0) + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i9 >> 2]);
 f14 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f20 * f12) + Math_fround(f4 * f13)) + Math_fround(f3 * f14));
 i1 = i11;
 while (1) {
  i2 = HEAP16[i16 + (i1 << 2) >> 1] | 0;
  i11 = HEAPU16[i16 + (i1 << 2) + 2 >> 1] | 0;
  if (!(i2 << 16 >> 16)) {
   i2 = 9;
   break;
  }
  i10 = i2 & 65535;
  i9 = 0;
  i8 = i1;
  while (1) {
   i2 = HEAPU8[i17 + (i9 + i11) >> 0] | 0;
   f20 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) >> 2]);
   f4 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 4 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f20 * f12) + Math_fround(f4 * f13)) + Math_fround(Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 8 >> 2]) * f14));
   if (f4 > f3) {
    i5 = 1 << (i2 & 31);
    i6 = i18 + (i2 >>> 5 << 2) | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    if (!(i7 & i5)) {
     HEAP32[i6 >> 2] = i7 | i5;
     f3 = f4;
    } else i2 = i8;
   } else i2 = i8;
   i9 = i9 + 1 | 0;
   if ((i9 | 0) == (i10 | 0)) break; else i8 = i2;
  }
  if ((i2 | 0) == (i1 | 0)) {
   i2 = 9;
   break;
  } else i1 = i2;
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i19;
  return i1 | 0;
 }
 return 0;
}

function __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 92 | 0, i5);
 i1 = i7 + 40 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 68 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 36 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function _UNITY_tt_face_load_sbit(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i7 = i1 + 724 | 0;
 i8 = i1 + 728 | 0;
 i9 = i1 + 732 | 0;
 i5 = i1 + 736 | 0;
 i2 = i1 + 508 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 do if (!(mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1128418371, i6 | 0, i4 | 0) | 0)) {
  HEAP32[i9 >> 2] = 2;
  i2 = 2;
  i3 = 8;
 } else {
  if (mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1161972803, i6 | 0, i4 | 0) | 0) if (mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1651273571, i6 | 0, i4 | 0) | 0) {
   i1 = mftCall_iiiii(HEAP32[i2 >> 2] | 0, i1 | 0, 1935829368, i6 | 0, i4 | 0) | 0;
   if (i1 | 0) break;
   HEAP32[i9 >> 2] = 3;
   i2 = 3;
   i3 = 8;
   break;
  }
  HEAP32[i9 >> 2] = 1;
  i2 = 1;
  i3 = 8;
 } while (0);
 L9 : do if ((i3 | 0) == 8) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 >>> 0 < 8) i1 = 3; else switch (i2 & 3) {
  case 2:
  case 1:
   {
    i1 = _UNITY_FT_Stream_ExtractFrame(i6, i1, i7) | 0;
    if (i1 | 0) break L9;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    i4 = HEAP32[i7 >> 2] | 0;
    i2 = (HEAPU8[i4 + 5 >> 0] | 0) << 16 | (HEAPU8[i4 + 4 >> 0] | 0) << 24 | (HEAPU8[i4 + 6 >> 0] | 0) << 8 | (HEAPU8[i4 + 7 >> 0] | 0);
    if (((HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | 0) != 131072) {
     i1 = 2;
     break L9;
    }
    if (i2 >>> 0 > 65535) {
     i1 = 3;
     break L9;
    }
    HEAP32[i5 >> 2] = (i2 * 48 | 8) >>> 0 > i1 >>> 0 ? ((i1 + -8 | 0) >>> 0) / 48 | 0 : i2;
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  case 3:
   {
    i1 = _UNITY_FT_Stream_EnterFrame(i6, 8) | 0;
    if (i1 | 0) break L9;
    i3 = _UNITY_FT_Stream_GetUShort(i6) | 0;
    i1 = _UNITY_FT_Stream_GetUShort(i6) | 0;
    i2 = _UNITY_FT_Stream_GetULong(i6) | 0;
    _UNITY_FT_Stream_ExitFrame(i6);
    if (!(i3 << 16 >> 16)) {
     i1 = 2;
     break L9;
    }
    if (i1 << 16 >> 16 == 1) {
     if (i2 >>> 0 > 65535) {
      i1 = 3;
      break L9;
     }
    } else if (i1 << 16 >> 16 != 3 | i2 >>> 0 > 65535) {
     i1 = 3;
     break L9;
    }
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = ((i2 << 2) + 8 | 0) >>> 0 > i1 >>> 0 ? (i1 + -8 | 0) >>> 2 : i2;
    i1 = _UNITY_FT_Stream_Seek(i6, (_UNITY_FT_Stream_Pos(i6) | 0) + -8 | 0) | 0;
    if (i1 | 0) break L9;
    i1 = (i2 << 2) + 8 | 0;
    HEAP32[i8 >> 2] = i1;
    i1 = _UNITY_FT_Stream_ExtractFrame(i6, i1, i7) | 0;
    if (i1 | 0) break L9;
    HEAP32[i5 >> 2] = i2;
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  default:
   {
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  }
 } while (0);
 if (HEAP32[i7 >> 2] | 0) _UNITY_FT_Stream_ReleaseFrame(i6, i7);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 12;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 12;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn18RepXCollectionImplC2ERNS_23PxSerializationRegistryERNS_19PxAllocatorCallbackERNS_12PxCollectionE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i4 >> 2] = gb + 146368 + 8;
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0) | 0;
 i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 84, gb + 830799 | 0, gb + 766736 | 0, 435) | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = gb + 142044 + 8;
 i7 = i5 + 8 | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i5 + 12 >> 2] = i7;
 HEAP32[i5 + 16 >> 2] = i7;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 i6 = i5 + 32 | 0;
 HEAP32[i6 >> 2] = i7;
 i7 = i5 + 36 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAPF32[i5 + 60 >> 2] = Math_fround(.75);
 HEAP32[i5 + 64 >> 2] = -1;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i6, 64);
 HEAP32[i5 + 76 >> 2] = 32;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i5 + 80 >> 2] = 1;
 HEAP32[i4 + 8 >> 2] = i5 + 4;
 HEAP32[i4 + 12 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = i5;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 i3 = i4 + 32 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i4 + 36 >> 2] = i3;
 i5 = i3;
 HEAP32[i4 + 40 >> 2] = i5;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 i1 = i4 + 56 | 0;
 HEAP32[i1 >> 2] = i5;
 i5 = i4 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i4 + 84 >> 2] = Math_fround(.75);
 HEAP32[i4 + 88 >> 2] = -1;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i4 + 100 >> 2] = 32;
 HEAP32[i4 + 112 >> 2] = i3;
 i3 = i4 + 116 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = gb + 89528 + 8;
 HEAP32[i4 + 108 >> 2] = gb + 89528 + 32;
 i3 = i4 + 132 | 0;
 HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 156 >> 2] = gb + 766707;
 HEAP32[i4 + 160 >> 2] = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 return;
}

function __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE(i13, i4, i5, i6) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 16 | 0;
 i10 = i14 + 8 | 0;
 i7 = i14;
 i12 = i13 + 204 | 0;
 i9 = i13 + 208 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  i1 = i9;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((_strcmp(HEAP32[i2 + 16 >> 2] | 0, i4) | 0) >= 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i9 | 0)) if (!((_strcmp(i4, HEAP32[i1 + 16 >> 2] | 0) | 0) < 0 | (i1 | 0) == (i9 | 0))) {
   i13 = i1;
   i13 = i13 + 20 | 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 i1 = (_strlen(i4) | 0) + 1 | 0;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63576 | 0, 0, gb + 461711 | 0, 48) | 0;
 _strncpy(i8, i4, i1) | 0;
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(i7, 0, i5, i6 | 1);
 i6 = i7;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i8;
 i1 = HEAP32[i9 >> 2] | 0;
 do if (!i1) {
  HEAP32[i10 >> 2] = i9;
  i4 = i9;
  i3 = i9;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((_strcmp(i8, i2) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 11;
     break;
    } else i1 = i2;
   } else {
    if ((_strcmp(i2, i8) | 0) >= 0) {
     i2 = 16;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 15;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 11) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 15) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 16) {
   HEAP32[i10 >> 2] = i1;
   i4 = i1;
   i3 = i10;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i13 + 212 >> 2] | 0;
  HEAP32[i11 >> 2] = 57;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = i7;
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i12 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 + 208 >> 2] | 0, i2);
  i13 = i13 + 216 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 }
 HEAP32[i1 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
 i13 = i1;
 i13 = i13 + 20 | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN9ShaderLab11ShaderStateC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i8 = i7;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i8 = i7;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1 + 60 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 76 >> 0] = 0;
 __ZN9ShaderLab20ShaderBlendStateDescC2Ev(i1 + 80 | 0);
 HEAPF32[i1 + 540 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 544 >> 2] = -1;
 HEAPF32[i1 + 548 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 552 >> 2] = -1;
 HEAPF32[i1 + 556 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 560 >> 2] = -1;
 HEAPF32[i1 + 564 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 568 >> 2] = -1;
 HEAPF32[i1 + 572 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 576 >> 2] = -1;
 HEAP32[i1 + 600 >> 2] = -1;
 HEAPF32[i1 + 596 >> 2] = Math_fround(8.0);
 HEAP32[i1 + 608 >> 2] = -1;
 HEAPF32[i1 + 604 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 616 >> 2] = -1;
 HEAPF32[i1 + 612 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 624 >> 2] = -1;
 HEAPF32[i1 + 620 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 632 >> 2] = -1;
 HEAPF32[i1 + 628 >> 2] = Math_fround(8.0);
 HEAP32[i1 + 640 >> 2] = -1;
 HEAPF32[i1 + 636 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 648 >> 2] = -1;
 HEAPF32[i1 + 644 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 656 >> 2] = -1;
 HEAPF32[i1 + 652 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 664 >> 2] = -1;
 HEAPF32[i1 + 660 >> 2] = Math_fround(8.0);
 HEAP32[i1 + 672 >> 2] = -1;
 HEAPF32[i1 + 668 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 680 >> 2] = -1;
 HEAPF32[i1 + 676 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 688 >> 2] = -1;
 HEAPF32[i1 + 684 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 584 >> 2] = -1;
 HEAPF32[i1 + 580 >> 2] = Math_fround(255.0);
 HEAP32[i1 + 592 >> 2] = -1;
 HEAPF32[i1 + 588 >> 2] = Math_fround(255.0);
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 696 >> 2] = -1;
 HEAP32[i1 + 700 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 HEAP32[i1 + 716 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 704 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i1 = i1 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = -1;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 STACKTOP = i2;
 return;
}

function __ZN8TypeTree8BlobReadERPKhS1_ib(i7, i8, i2, i1, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i10 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 i5 = i4 + 4 | 0;
 HEAP32[i8 >> 2] = i5;
 i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
 i4 = i4 + 8 | 0;
 HEAP32[i8 >> 2] = i4;
 i3 = _llvm_bswap_i32(i10 | 0) | 0;
 i6 = _llvm_bswap_i32(i5 | 0) | 0;
 i10 = i9 ? i3 : i10;
 i5 = i9 ? i6 : i5;
 i6 = i10 * 24 | 0;
 if ((i4 + i6 + i5 | 0) >>> 0 > i2 >>> 0) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = i7 + 12 | 0;
 HEAP32[i1 >> 2] = i10;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i10 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i10;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i6, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i7 >> 2] = i4;
  break;
 } while (0);
 i1 = i7 + 20 | 0;
 i2 = i7 + 32 | 0;
 HEAP32[i2 >> 2] = i5;
 i3 = i7 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5, 1, i7 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i7 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i4;
  break;
 } while (0);
 _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, i6 | 0) | 0;
 i6 = (HEAP32[i8 >> 2] | 0) + i6 | 0;
 HEAP32[i8 >> 2] = i6;
 _memcpy(HEAP32[i1 >> 2] | 0, i6 | 0, i5 | 0) | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i5;
 if (!((i10 | 0) != 0 & i9)) {
  i10 = 1;
  return i10 | 0;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = 0;
 do {
  i9 = i2 + (i1 * 24 | 0) | 0;
  HEAP16[i9 >> 1] = _llvm_bswap_i16(HEAP16[i9 >> 1] | 0) | 0;
  i9 = i2 + (i1 * 24 | 0) + 4 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i2 + (i1 * 24 | 0) + 8 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i2 + (i1 * 24 | 0) + 12 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i2 + (i1 * 24 | 0) + 16 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i2 + (i1 * 24 | 0) + 20 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i1 = 1;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 296 | 0;
 i4 = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 32 >> 2] = Math_fround(1.0);
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 52 >> 2] = Math_fround(1.0);
 i1 = i4 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 i1 = i4 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 92 >> 2] = Math_fround(1.0);
 i1 = i4 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 112 >> 2] = Math_fround(1.0);
 i1 = i4 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 132 >> 2] = Math_fround(1.0);
 i1 = i4 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 152 >> 2] = Math_fround(1.0);
 i1 = i4 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 172 >> 2] = Math_fround(1.0);
 i1 = i4 + 176 | 0;
 i2 = i4 + 249 | 0;
 i5 = i1;
 i7 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i4 + 292 | 0;
 i5 = i4 + 252 | 0;
 i7 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i4 + 293 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i8, gb + 1041885 | 0, gb + 1041885 | 0, i3, i9);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, gb + 1041891 | 0, gb + 1034552 | 0, i4, 0);
 __ZN8GUIStyle8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i8);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i8);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i8);
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i9 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i3);
 STACKTOP = i6;
 return;
}

function __ZN16BaseVideoTexture15InitVideoMemoryEii(i8, i2, i3) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 if (!(i2 + -1 & i2)) {
  if (i3 + -1 & i3 | 0) i1 = 3;
 } else i1 = 3;
 if ((i1 | 0) == 3) if (!(__Z20IsNPOTTextureAllowedb(0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 867964 | 0, 0, gb + 868043 | 0, 76, 262656, 0, 0, 0);
 i7 = i8 + 84 | 0;
 HEAP32[i7 >> 2] = i2;
 i6 = i8 + 88 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 136 >> 2] | 0, i8 | 0) | 0)) f4 = Math_fround(1.0); else f4 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 136 >> 2] | 0, i8 | 0) | 0));
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0) | 0)) f5 = Math_fround(1.0); else f5 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0) | 0));
 HEAPF32[i8 + 68 >> 2] = f4;
 HEAPF32[i8 + 72 >> 2] = f5;
 i3 = i8 + 94 | 0;
 do if (HEAP8[i3 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == 2147483647) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 868118 | 0, 0, gb + 868043 | 0, 92, 1, 0, 0, 0);
   STACKTOP = i11;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  i12 = i1 + 1 | 0;
  i1 = Math_imul(i2, i12) | 0;
  if ((i12 | 0) != ((i1 >>> 0) / (i2 >>> 0) | 0 | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 868147 | 0, 0, gb + 868043 | 0, 99, 1, 0, 0, 0);
   STACKTOP = i11;
   return;
  }
  if ((i1 | 0) == (i1 & 1073741823 | 0)) {
   __ZNK6Object14GetMemoryLabelEv(i9, i8);
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 16, i9, 0, gb + 868043 | 0, 111) | 0;
   i12 = HEAP32[i7 >> 2] | 0;
   i2 = i2 + (i12 << 2) | 0;
   HEAP32[i8 + 80 >> 2] = i2;
   if ((Math_imul(HEAP32[i6 >> 2] | 0, i12) | 0) > 0) i1 = 0; else break;
   do {
    HEAP32[i2 + (i1 << 2) >> 2] = 255;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0));
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 868147 | 0, 0, gb + 868043 | 0, 107, 1, 0, 0, 0);
   STACKTOP = i11;
   return;
  }
 } while (0);
 if (HEAP8[i3 >> 0] | 0) {
  __ZN16BaseVideoTexture22UploadGfxTextureBufferEPj(i8, HEAP32[i8 + 80 >> 2] | 0);
  HEAP8[i8 + 93 >> 0] = 1;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 + 48 >> 2];
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i8 + 60 >> 2] | 0; else i1 = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 mftCall_viiiiiifiii(i3 | 0, i2 | 0, i9 | 0, 2, 1, 1, 1, 0.0, 0, i1 | 0, 2);
 STACKTOP = i11;
 return;
}

function __ZNSt3__23mapINS_4pairIKiS2_EEN2UI14DepthSortLayerENS_4lessIS3_EE13stl_allocatorINS1_IKS3_S5_EEL18MemLabelIdentifier1ELi16EEEixERS9_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i2 = i11 + 8 | 0;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  HEAP32[i2 >> 2] = i3;
  i4 = i3;
  i2 = i3;
  i7 = 14;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i8 + 4 >> 2] | 0;
  L4 : while (1) {
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   do if ((i4 | 0) < (i3 | 0)) i7 = 6; else {
    if ((i3 | 0) >= (i4 | 0)) {
     i3 = HEAP32[i1 + 20 >> 2] | 0;
     if ((i6 | 0) < (i3 | 0)) {
      i7 = 6;
      break;
     }
     if ((i3 | 0) >= (i6 | 0)) {
      i7 = 12;
      break L4;
     }
    }
    i5 = i1 + 4 | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if (!i3) {
     i7 = 11;
     break L4;
    } else i1 = i3;
   } while (0);
   if ((i7 | 0) == 6) {
    i7 = 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i7 = 7;
     break;
    } else i1 = i3;
   }
  }
  if ((i7 | 0) == 7) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i7 | 0) == 11) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i2 = i5;
   break;
  } else if ((i7 | 0) == 12) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i7 = 14;
   break;
  }
 } while (0);
 if ((i7 | 0) == 14) if (i1) {
  i10 = i1;
  i10 = i10 + 24 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i3;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(64, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 i7 = i8;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = 0;
 i1 = i3 + 28 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i6 = i9;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = i3 + 48 | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 + 4 >> 2] | 0, i1);
 i10 = i10 + 12 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i3;
 i10 = i10 + 24 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7mecanim9animation19Blend2dDataConstant8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i7 = i8;
 i3 = i6 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 903889 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 12;
 HEAP32[i7 + 4 >> 2] = i2 + 8;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 903910 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 20;
 HEAP32[i7 + 4 >> 2] = i2 + 16;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 903932 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 28;
 HEAP32[i7 + 4 >> 2] = i2 + 24;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 903955 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 36;
 HEAP32[i7 + 4 >> 2] = i2 + 32;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 903981 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_(i12, i2, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) == (i11 | 0)) {
  i14 = i1;
  return i14 | 0;
 }
 i13 = i12 + 64 | 0;
 i14 = i12 + 76 | 0;
 while (1) {
  HEAP32[i2 + 24 >> 2] = 0;
  i9 = i2 + 4 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i7 = i6 + 8 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i3 = i1 + 8 | 0; else {
   i8 = i10 + 24 | 0;
   if (!(HEAP32[i8 >> 2] | 0)) {
    i3 = 6;
    break;
   }
   i3 = i1 + 8 | 0;
   i4 = __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i12 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   if (!i4) {
    i3 = 8;
    break;
   }
   if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(HEAP32[i12 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0)) {
    i3 = 11;
    break;
   }
   HEAP32[i8 >> 2] = 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i4 + 24 >> 2] = i10;
  }
  if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) {
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i12 >> 2] | 0, HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] | 0, i4) | 0)) {
    i3 = 14;
    break;
   }
   if (!(__Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_(HEAP32[i12 >> 2] | 0, i1, i4) | 0)) {
    i3 = 16;
    break;
   }
  }
  i1 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP8[i8 + 21 >> 0] = HEAP32[i2 + 12 >> 2];
  HEAP32[i8 + 8 >> 2] = i1;
  HEAP32[i1 + 24 >> 2] = 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i8 = i9 + 8 | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 >> 2];
  HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] = i7;
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i9;
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i10 | 0) == (i11 | 0)) {
   i3 = 18;
   break;
  } else i2 = i10;
 }
 if ((i3 | 0) == 6) {
  i12 = HEAP32[i1 + 20 >> 2] | 0;
  HEAP8[i12 + 21 >> 0] = HEAP32[i2 + 12 >> 2];
  HEAP32[i12 + 8 >> 2] = i1;
  HEAP32[i1 + 24 >> 2] = 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i12 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i12 + 8 >> 2] = i5;
  HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] = i12;
  i13 = HEAP32[i13 + 16 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i6;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i14 >> 2] = i2;
  i14 = i1;
  return i14 | 0;
 } else if ((i3 | 0) == 8) _longjmp(i12 + 144 | 0, 1); else if ((i3 | 0) == 11) _longjmp(i12 + 144 | 0, 1); else if ((i3 | 0) == 14) _longjmp(i12 + 144 | 0, 1); else if ((i3 | 0) == 16) _longjmp(i12 + 144 | 0, 1); else if ((i3 | 0) == 18) return i1 | 0;
 return 0;
}

function __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i12, i1, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15;
 i14 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 - i14 | 0;
 i6 = i5 >> 2;
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = i14;
 i10 = i9;
 i13 = i4;
 if (i6 >>> 0 <= i2 - i9 >> 2 >>> 0) {
  i7 = i12 + 4 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - i9 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i14 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i14 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i15;
    return;
   }
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i15;
   return;
  }
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) {
   STACKTOP = i15;
   return;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  STACKTOP = i15;
  return;
 }
 i4 = i9;
 if (i9) {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i10 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i12 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
  i2 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 1;
 i2 = i10 >> 2 >>> 0 < 1073741823 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 2147483647;
 if ((i2 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
 i4 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i11 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i15;
  return;
 }
 i3 = i13 + -4 - i14 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE8__appendEj(i11, i3) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i12 = i11 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i2 - i1 | 0) / 96 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 76 >> 2] = 0;
   HEAP32[i1 + 80 >> 2] = 0;
   i2 = i1 + 68 | 0;
   i6 = i1 + 4 | 0;
   i7 = i6 + 64 | 0;
   do {
    HEAP32[i6 >> 2] = 0;
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) < (i7 | 0));
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
   i9 = i10;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   HEAP32[i1 + 92 >> 2] = 0;
   HEAP32[i1 + 88 >> 2] = 0;
   HEAP32[i1 + 84 >> 2] = 0;
   i1 = (HEAP32[i13 >> 2] | 0) + 96 | 0;
   HEAP32[i13 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 96 | 0) + i3 | 0;
 if (i5 >>> 0 > 44739242) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 96 | 0;
 i9 = i8 << 1;
 i5 = i8 >>> 0 < 22369621 ? (i9 >>> 0 < i5 >>> 0 ? i5 : i9) : 44739242;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 96 | 0) | 0;
 i2 = i6 + (((i1 - i4 | 0) / 96 | 0) * 96 | 0) | 0;
 i8 = i2;
 i5 = i6 + (i5 * 96 | 0) | 0;
 i9 = i8;
 i1 = i2;
 do {
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 76 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = 0;
  i4 = i1 + 68 | 0;
  i6 = i1 + 4 | 0;
  i7 = i6 + 64 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i7 | 0));
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i15 = i10;
  i6 = HEAP32[i15 + 4 >> 2] | 0;
  i7 = i4;
  HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 + 92 >> 2] = 0;
  HEAP32[i1 + 88 >> 2] = 0;
  HEAP32[i1 + 84 >> 2] = 0;
  i1 = i9 + 96 | 0;
  i9 = i1;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i4 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i8;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i8;
  do {
   i1 = i1 + -96 | 0;
   __ZN19ComputeShaderKernelC2ERKS_(i2 + -96 | 0, i1);
   i2 = i3 + -96 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i12 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -96 | 0;
  __ZN19ComputeShaderKernelD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 __ZdlPv(i3);
 STACKTOP = i14;
 return;
}

function __ZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEE(i18, i17, i20, i21, i19) {
 i18 = i18 | 0;
 i17 = i17 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i22;
 i15 = i22 + 44 | 0;
 if (!(HEAP32[i18 + 4 >> 2] | 0)) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i1 = HEAP32[i18 >> 2] | 0;
 if (!i1) {
  i21 = 0;
  STACKTOP = i22;
  return i21 | 0;
 }
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i22 + 45 | 0, i1, gb + 727718 | 0, 522) | 0;
 _memset(i12 | 0, 0, HEAP32[i18 >> 2] | 0) | 0;
 i13 = i16 + 12 | 0;
 i3 = i16 + 4 | 0;
 i4 = i16 + 16 | 0;
 i5 = i16 + 8 | 0;
 i6 = i16 + 32 | 0;
 i7 = i16 + 36 | 0;
 i8 = i16 + 40 | 0;
 i9 = i16 + 20 | 0;
 i10 = i16 + 24 | 0;
 i11 = i16 + 28 | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i14 = 0;
 while (1) {
  L9 : do if (!i2) i1 = 0; else {
   i1 = 0;
   do {
    if (!(HEAP8[i12 + i1 >> 0] | 0)) break L9;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  } while (0);
  if ((i1 | 0) != (i2 | 0)) {
   HEAP32[i16 >> 2] = i18;
   HEAP32[i13 >> 2] = i12;
   HEAP32[i3 >> 2] = i14;
   HEAP32[i4 >> 2] = i17;
   HEAP32[i5 >> 2] = i20;
   HEAP32[i6 >> 2] = i21;
   HEAP32[i7 >> 2] = i19;
   HEAP32[i8 >> 2] = 0;
   i27 = HEAP32[i19 + (i1 * 12 | 0) >> 2] | 0;
   i26 = HEAP32[i19 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i2 = HEAP32[i19 + (i1 * 12 | 0) + 8 >> 2] | 0;
   f25 = Math_fround(HEAPF32[i21 + (i27 * 12 | 0) >> 2]);
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i21 + (i26 * 12 | 0) >> 2]));
   f24 = Math_fround(HEAPF32[i21 + (i27 * 12 | 0) + 4 >> 2]);
   f24 = Math_fround(f24 + Math_fround(HEAPF32[i21 + (i26 * 12 | 0) + 4 >> 2]));
   f23 = Math_fround(HEAPF32[i21 + (i27 * 12 | 0) + 8 >> 2]);
   f23 = Math_fround(f23 + Math_fround(HEAPF32[i21 + (i26 * 12 | 0) + 8 >> 2]));
   f25 = Math_fround(f25 + Math_fround(HEAPF32[i21 + (i2 * 12 | 0) >> 2]));
   f24 = Math_fround(f24 + Math_fround(HEAPF32[i21 + (i2 * 12 | 0) + 4 >> 2]));
   f24 = Math_fround(f24 * Math_fround(.333333343));
   f23 = Math_fround(Math_fround(f23 + Math_fround(HEAPF32[i21 + (i2 * 12 | 0) + 8 >> 2])) * Math_fround(.333333343));
   HEAPF32[i9 >> 2] = Math_fround(f25 * Math_fround(.333333343));
   HEAPF32[i10 >> 2] = f24;
   HEAPF32[i11 >> 2] = f23;
   __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj(i16, i1, -1, -1, -1);
   i2 = HEAP32[i18 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 | 0)) break; else i14 = i14 + 1 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i15, i12);
 i27 = 1;
 STACKTOP = i22;
 return i27 | 0;
}

function __ZN5Flare8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i6, i8);
 i2 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 373571 | 0, gb + 944590 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 373586 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 373602 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN5Flare12FlareElementENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 373613 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN16ReflectionProbesC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i9 = i7;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 + 32 >> 2] = -1;
 HEAP8[i1 + 36 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i4 = i7;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i1 + 44 | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i9 = i7;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = i1 + 80 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i4 = gb + 63536 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i9 = i7;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1 + 108 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i6;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i2 = i7;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i1 + 128 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i6;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i9 = i7;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1 + 148 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i6;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + 168 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = i1 + 184 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 192 | 0;
 i4 = i2 + 124 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 STACKTOP = i3;
 return;
}

function __Z48DownloadHandlerTexture_CUSTOM_InternalGetTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i5 = i9 + 16 | 0;
 i7 = i9 + 12 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027830 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027830 | 0, i2);
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0)) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1027880 | 0, i9 + 8 | 0);
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i6) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 13; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 13; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 15;
 }
 if ((i8 | 0) == 13) i8 = 15;
 do if ((i8 | 0) == 15) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i7 >> 2] = i6;
 if (!i1) i8 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 24;
  }
 }
 if ((i8 | 0) == 22) i8 = 24;
 if ((i8 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __Z30GetSplashScreenBackgroundColorv(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __Z17GetPlayerSettingsv() | 0;
 i10 = i1 + 244 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i10 = __Z16GetScreenManagerv() | 0;
 f6 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 80 >> 2] | 0, i10 | 0) | 0);
 f8 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 84 >> 2] | 0, i10 | 0) | 0);
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = f6;
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = f8;
 if (__Z25GetSplashScreenBackgroundRK5RectTIfE(i7) | 0) {
  HEAP32[i4 >> 2] = 1065353216;
  HEAP32[i4 + 4 >> 2] = 1065353216;
  HEAP32[i4 + 8 >> 2] = 1065353216;
  HEAP32[i4 + 12 >> 2] = 1065353216;
  STACKTOP = i9;
  return;
 }
 f5 = Math_fround(__ZNK26PlayerSettingsSplashScreen29GetSplashScreenOverlayOpacityEv(i1 + 144 | 0));
 if (!(f5 > Math_fround(0.0))) {
  STACKTOP = i9;
  return;
 }
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = i4 + 4 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 if ((HEAP32[i1 + 152 >> 2] | 0) == 1) {
  f3 = Math_fround(_fmaxf(f6, f8));
  i1 = i4 + 8 | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(_fmaxf(f3, f2));
  if (!(f3 > Math_fround(.5))) {
   STACKTOP = i9;
   return;
  }
  f12 = Math_fround(f5 * Math_fround(Math_fround(1.0) - Math_fround(Math_fround(.5) / f3)));
  f11 = Math_fround(Math_fround(1.0) - f12);
  f3 = Math_fround(f6 * f11);
  f5 = Math_fround(f8 * f11);
  f6 = Math_fround(f2 * f11);
  i10 = i4 + 12 | 0;
  f2 = Math_fround(f12 * Math_fround(0.0));
  f5 = Math_fround(f2 + f5);
  f6 = Math_fround(f2 + f6);
  f8 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i10 >> 2])));
  HEAPF32[i4 >> 2] = Math_fround(f2 + f3);
  HEAPF32[i7 >> 2] = f5;
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i10 >> 2] = f8;
  STACKTOP = i9;
  return;
 } else {
  f3 = Math_fround(_fminf(f6, f8));
  i1 = i4 + 8 | 0;
  f2 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(_fminf(f3, f2));
  if (!(f3 < Math_fround(.5))) {
   STACKTOP = i9;
   return;
  }
  f5 = Math_fround(f5 * Math_fround(Math_fround(1.0) - Math_fround(Math_fround(.5) / Math_fround(Math_fround(1.0) - f3))));
  f12 = Math_fround(Math_fround(1.0) - f5);
  f6 = Math_fround(f6 * f12);
  f8 = Math_fround(f8 * f12);
  f11 = Math_fround(f2 * f12);
  i10 = i4 + 12 | 0;
  f8 = Math_fround(f5 + f8);
  f11 = Math_fround(f5 + f11);
  f12 = Math_fround(f5 + Math_fround(f12 * Math_fround(HEAPF32[i10 >> 2])));
  HEAPF32[i4 >> 2] = Math_fround(f5 + f6);
  HEAPF32[i7 >> 2] = f8;
  HEAPF32[i1 >> 2] = f11;
  HEAPF32[i10 >> 2] = f12;
  STACKTOP = i9;
  return;
 }
}

function __ZN21GLESGpuProgramApplier11ApplyMatrixERKN20GpuProgramParameters14ValueParameterEPK10Matrix4x4ft(i9, i11, i5, i6) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i1 = i11 + 16 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 switch ((i3 & 255) << 24 >> 24) {
 case 4:
  {
   if ((i3 & 65280 | 0) != 1024) {
    STACKTOP = i12;
    return;
   }
   i1 = HEAP32[i9 + 12 >> 2] | 0;
   if ((i1 | 0) != -1) {
    __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi((HEAP32[i9 + 16 >> 2] | 0) + 6624 | 0, i1, HEAP32[i11 + 4 >> 2] | 0, i5, (i6 & 65535) << 6);
    STACKTOP = i12;
    return;
   }
   i2 = HEAP32[gb + 1451080 >> 2] | 0;
   i1 = HEAP32[i11 + 4 >> 2] | 0;
   if (!(i3 & 131072)) {
    mftCall_viiii(HEAP32[i2 + 164 >> 2] | 0, i1 | 0, i6 & 65535 | 0, 0, i5 | 0);
    STACKTOP = i12;
    return;
   } else {
    mftCall_viii(HEAP32[i2 + 152 >> 2] | 0, i1 | 0, (i6 & 65535) << 2 | 0, i5 | 0);
    STACKTOP = i12;
    return;
   }
  }
 case 3:
  {
   if ((HEAP16[i1 >> 1] & -256) << 16 >> 16 != 768) {
    STACKTOP = i12;
    return;
   }
   HEAP32[i10 >> 2] = 0;
   i7 = i10 + 4 | 0;
   i3 = gb + 63160 | 0;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i8 = i7;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = i4;
   i8 = i6 & 65535;
   i4 = i8 * 36 | 0;
   if (!(i6 << 16 >> 16)) {
    i2 = 0;
    i3 = 0;
   } else {
    i2 = i4 | 3;
    if (i2 >>> 0 < 2e3) {
     i1 = STACKTOP;
     STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
     if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, gb + 64016 | 0, 0, gb + 604722 | 0, 708) | 0;
     i2 = gb + 64016 | 0;
     i13 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     HEAP32[i10 >> 2] = i1;
     i3 = i7;
     HEAP32[i3 >> 2] = i13;
     HEAP32[i3 + 4 >> 2] = i2;
    }
    i2 = i1 + 3 & -4;
    i3 = i2;
    i1 = 0;
    do {
     __ZN10Matrix3x3faSERK10Matrix4x4f(i3 + (i1 * 36 | 0) | 0, i5 + (i1 << 6) | 0) | 0;
     i1 = i1 + 1 | 0;
    } while ((i1 & 65535) << 16 >> 16 != i6 << 16 >> 16);
   }
   i1 = HEAP32[i9 + 12 >> 2] | 0;
   do if ((i1 | 0) == -1) {
    i1 = HEAP32[gb + 1451080 >> 2] | 0;
    i2 = HEAP32[i11 + 4 >> 2] | 0;
    if (!(HEAP8[i11 + 18 >> 0] & 2)) {
     mftCall_viiii(HEAP32[i1 + 160 >> 2] | 0, i2 | 0, i8 | 0, 0, i3 | 0);
     break;
    } else {
     mftCall_viii(HEAP32[i1 + 144 >> 2] | 0, i2 | 0, i8 * 3 | 0, i3 | 0);
     break;
    }
   } else __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi((HEAP32[i9 + 16 >> 2] | 0) + 6624 | 0, i1, HEAP32[i11 + 4 >> 2] | 0, i2, i4); while (0);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i7);
   STACKTOP = i12;
   return;
  }
 default:
  {
   STACKTOP = i12;
   return;
  }
 }
}

function __ZN18GlslGpuProgramGLES24StoreInBinaryShaderCacheEPKc(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 8 | 0;
 i6 = i11;
 i10 = i11 + 16 | 0;
 i8 = HEAP32[gb + 64016 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[gb + 64016 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = i10 + 20 | 0;
 i6 = HEAP32[gb + 1451080 >> 2] | 0;
 i3 = HEAP32[i1 + 88 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 do if (!i3) {
  i1 = 0;
  i2 = 0;
 } else {
  i4 = i10 + 24 | 0;
  mftCall_viii(HEAP32[i6 + 92 >> 2] | 0, i3 | 0, 34625, i4 | 0);
  i1 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 1, i9, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
   i1 = i2;
   break;
  } else i1 = HEAP32[i10 >> 2] | 0; while (0);
  i13 = i1 + 4 | 0;
  i12 = i10 + 28 | 0;
  HEAP32[i12 >> 2] = i13;
  i2 = i10 + 32 | 0;
  HEAP32[i2 >> 2] = i1;
  mftCall_viiiii(HEAP32[i6 + 224 >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, 0, i1 | 0, i13 | 0);
  if ((HEAP32[i12 >> 2] | 0) == 0 | (HEAP32[i2 >> 2] | 0) == 0) i1 = 0; else {
   i5 = _fopen(i5, gb + 777169 | 0) | 0;
   if (!i5) i1 = 0; else {
    i4 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if (!(_ferror(i5) | 0)) {
     i1 = _fwrite(i4, i2, 1, i5) | 0;
     L15 : do if (_ferror(i5) | 0) {
      i3 = ___errno_location() | 0;
      do {
       if ((HEAP32[i3 >> 2] | 0) != 4) break L15;
       _clearerr(i5);
       i1 = _fwrite(i4, i2, 1, i5) | 0;
      } while ((_ferror(i5) | 0) != 0);
     } while (0);
     i1 = (i1 | 0) == 1;
    } else i1 = 0;
    _fclose(i5) | 0;
   }
  }
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   i2 = HEAP32[i10 >> 2] | 0;
   break;
  } else {
   i13 = i1;
   STACKTOP = i11;
   return i13 | 0;
  }
 } while (0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
 HEAP32[i10 >> 2] = 0;
 i13 = i1;
 STACKTOP = i11;
 return i13 | 0;
}

function __ZL24PrepareSpriteRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i6 = HEAP32[i8 + 32 >> 2] | 0;
 i7 = HEAP32[i8 + 36 >> 2] | 0;
 i10 = HEAP32[i8 + 48 >> 2] | 0;
 i11 = i8 + 16 | 0;
 i14 = i8 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i12 = i8 + 12 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i2 >>> 0 >= i7 >>> 0) {
  i13 = i1;
  HEAP32[i14 >> 2] = i13;
  return;
 }
 i13 = i8 + 20 | 0;
 i9 = i8 + 24 | 0;
 while (1) {
  i5 = HEAP32[i10 + ((HEAP32[i6 + (i2 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0;
  i5 = (i5 | 0) == 0 ? 0 : i5 + -32 | 0;
  i3 = i5 + 32 | 0;
  i4 = i5 + 268 | 0;
  if (((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 63 | 0) != 3) {
   i2 = 15;
   break;
  }
  i2 = HEAP32[i5 + 364 >> 2] | 0;
  do if (i2) {
   if (__ZNK16SpriteRenderData22IsUVCalculationPendingEv(__ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0) | 0) {
    __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i8);
    break;
   }
   i4 = HEAP16[i5 + 272 >> 1] | 0;
   if ((i4 & 65535) > 255 | (i4 & 255) << 24 >> 24 != 0) {
    __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i8);
    break;
   }
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = i4 + (i1 * 360 | 0) | 0;
   __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode(i3, i5 + 36 | 0, Math_fround(0.0), i2);
   __ZN12BaseRenderer11ClearProbesER10RenderNode(i2);
   if (!(__ZN12BaseRenderer25FlattenSharedMaterialDataILb1EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i3, i11, i2) | 0)) {
    __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i8);
    break;
   }
   i2 = HEAP32[i13 >> 2] | 0;
   if ((i2 + 24 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
    __ZN22PerThreadPageAllocator14AcquireNewPageEj(i11, 32768);
    i2 = HEAP32[i13 >> 2] | 0;
   }
   i3 = (HEAP32[i11 >> 2] | 0) + i2 | 0;
   HEAP32[i13 >> 2] = i2 + 24;
   HEAP32[i4 + (i1 * 360 | 0) + 328 >> 2] = i3;
   HEAP32[i3 >> 2] = __ZN14SpriteRenderer11GetGeometryEv(i5) | 0;
   i16 = HEAP16[i5 + 360 >> 1] | 0;
   HEAP8[i3 + 4 >> 0] = i16;
   HEAP8[i3 + 5 >> 0] = (i16 & 65535) >>> 8;
   i3 = i3 + 8 | 0;
   i16 = HEAP32[i5 + 348 >> 2] | 0;
   i15 = HEAP32[i5 + 352 >> 2] | 0;
   i2 = HEAP32[i5 + 356 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 + 344 >> 2];
   HEAP32[i3 + 4 >> 2] = i16;
   HEAP32[i3 + 8 >> 2] = i15;
   HEAP32[i3 + 12 >> 2] = i2;
   HEAP32[i4 + (i1 * 360 | 0) + 332 >> 2] = fb + 222;
   HEAP32[i4 + (i1 * 360 | 0) + 344 >> 2] = fb + 2416;
   HEAP32[i4 + (i1 * 360 | 0) + 348 >> 2] = 1;
   HEAP32[i4 + (i1 * 360 | 0) + 340 >> 2] = fb + 528;
   i1 = i1 + 1 | 0;
  } while (0);
  i2 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) {
   i2 = 15;
   break;
  }
 }
 if ((i2 | 0) == 15) {
  HEAP32[i14 >> 2] = i1;
  return;
 }
}

function __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i6 + 12 | 0, i1);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6 + 28 | 0, gb + 1085935 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i3 >>> 0 > 20 ? 20 : i3;
 i4 = i6 + 40 + (i3 << 2) | 0;
 if (i3 | 0) {
  i3 = i6 + 40 | 0;
  do {
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
    i1 = HEAP32[i7 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i8 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 120 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 124 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 128 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 132 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 464 | 0;
 i4 = i9 + 456 | 0;
 i5 = i9;
 if (HEAP8[i2 + 86 >> 0] | 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i7 = i5 + 16 | 0;
  i11 = i2 + 16 | 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i7 = i2 + 32 | 0;
  i11 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = i5 + 32 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = i11;
  i8 = i5 + 40 | 0;
  i11 = i2 + 40 | 0;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i11 = i5 + 56 | 0;
  i7 = i2 + 56 | 0;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  i11 = i2 + 72 | 0;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = i5 + 72 | 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 + 4 >> 2] = i2;
  __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv(i5);
  __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv(i8);
  __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv(i3, i8);
  __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv(i4, i5);
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(_fminf(f10, Math_fround(HEAPF32[i4 >> 2])));
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f6 = Math_fround(_fmaxf(f6, Math_fround(HEAPF32[i4 + 4 >> 2])));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f6;
  STACKTOP = i9;
  return;
 }
 f6 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 i11 = HEAP16[i2 + 84 >> 1] | 0;
 i7 = i2 + 88 | 0;
 __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i5, i7, f6) | 0;
 i8 = i5 + 228 | 0;
 if ((i11 & -2) << 16 >> 16 == 2) __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i8, i2 + 176 | 0, f6) | 0; else __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i8, i7, f6) | 0;
 __ZN15PolynomialCurve15DoubleIntegrateEv(i5);
 __ZN15PolynomialCurve15DoubleIntegrateEv(i8);
 __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv(i3, i8);
 __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv(i4, i5);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(_fminf(f6, Math_fround(HEAPF32[i4 >> 2])));
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(_fmaxf(f10, Math_fround(HEAPF32[i4 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f10;
 STACKTOP = i9;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator20outputClusterPortalsEi(i3, i10) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i1 = HEAP32[i3 + 280 >> 2] | 0;
 if (!i1) {
  i11 = 1;
  return i11 | 0;
 }
 i11 = i3 + 56 | 0;
 i2 = HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + (i10 << 2) >> 2] | 0) + 124 >> 2] << 3;
 i1 = i1 << 4;
 if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i3 + 300 | 0, i1 + 32 + i2 | 0, 65536) | 0)) {
  HEAP32[i3 + 464 >> 2] = 1;
  i11 = 0;
  return i11 | 0;
 }
 i6 = i3 + 456 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = i2 + 15 & -16;
 i5 = i3 + 452 | 0;
 i9 = i3 + 444 | 0;
 i7 = (HEAP32[i9 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 _memset(i8 | 0, 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i2;
 i7 = i3 + 432 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 + (i10 << 5) + 20 >> 2] = (HEAP32[i3 + 304 + (i12 << 3) + 4 >> 2] | 0) - (HEAP32[i3 + 304 + (i12 << 3) >> 2] | 0);
 i4 = i3 + 304 + (HEAP32[i7 >> 2] << 3) + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i2;
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = (HEAP32[i9 >> 2] | 0) + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 _memset(i9 | 0, 0, i1 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + (i10 << 5) + 24 >> 2] = (HEAP32[i3 + 304 + (i5 << 3) + 4 >> 2] | 0) - (HEAP32[i3 + 304 + (i5 << 3) >> 2] | 0);
 i7 = i3 + 304 + (HEAP32[i7 >> 2] << 3) + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
 HEAP8[i3 + 436 >> 0] = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[(HEAP32[i1 + (i10 << 2) >> 2] | 0) + 124 >> 2] | 0) <= 0) {
  i12 = 1;
  return i12 | 0;
 }
 i7 = i3 + 288 | 0;
 i6 = i3 + 272 | 0;
 i4 = 0;
 i5 = 0;
 i3 = i1;
 while (1) {
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  if (!i1) {
   i2 = i5;
   i1 = i3;
  } else {
   i2 = i5;
   i3 = HEAP32[i6 >> 2] | 0;
   do {
    i12 = i1 + -1 | 0;
    i16 = HEAP32[i3 + (i12 * 28 | 0) + 4 >> 2] | 0;
    i15 = HEAP32[i3 + (i12 * 28 | 0) + 16 >> 2] | HEAP32[i3 + (i12 * 28 | 0) + 8 >> 2] << 16;
    i14 = HEAP32[i3 + (i12 * 28 | 0) + 20 >> 2] | HEAP32[i3 + (i12 * 28 | 0) + 12 >> 2] << 16;
    i13 = i2;
    i2 = i2 + 1 | 0;
    HEAP32[i9 + (i13 << 4) >> 2] = HEAP32[i3 + (i12 * 28 | 0) >> 2];
    HEAP32[i9 + (i13 << 4) + 4 >> 2] = i16;
    HEAP32[i9 + (i13 << 4) + 8 >> 2] = i15;
    HEAP32[i9 + (i13 << 4) + 12 >> 2] = i14;
    i3 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i3 + (i12 * 28 | 0) + 24 >> 2] | 0;
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i8 + (i4 << 3) >> 2] = i5;
  HEAP32[i8 + (i4 << 3) + 4 >> 2] = i2 - i5;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (HEAP32[(HEAP32[i1 + (i10 << 2) >> 2] | 0) + 124 >> 2] | 0)) {
   i1 = 1;
   break;
  } else {
   i5 = i2;
   i3 = i1;
  }
 }
 return i1 | 0;
}

function __ZN13SliderJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 if (!(i1 & 16)) return;
 i6 = i4 + 116 | 0;
 i9 = HEAP16[i6 >> 1] | 0;
 i7 = i9 & 255;
 i8 = i7 << 24 >> 24 != 0;
 i11 = i4 + 117 | 0;
 i9 = (i9 & 65535) >>> 8 & 255;
 i10 = i9 << 24 >> 24 != 0;
 i3 = i4 + 100 | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i4 + 100 | 0;
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f13 < Math_fround(-1.0e6);
 i1 = f13 > Math_fround(1.0e6);
 f13 = i1 ? Math_fround(1.0e6) : f13;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(-1.0e6) : f13;
 i3 = i4 + 104 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i5 = f13 < Math_fround(0.0);
 i1 = f13 > Math_fround(1.0e6);
 f13 = i1 ? Math_fround(1.0e6) : f13;
 HEAPF32[i3 >> 2] = i5 ? Math_fround(0.0) : f13;
 HEAP8[i6 >> 0] = 1;
 i5 = i4 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  __ZN16b2PrismaticJoint11EnableMotorEb(i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __ZN16b2PrismaticJoint13SetMotorSpeedEf(i1, Math_fround(HEAPF32[i2 >> 2]));
   __ZN16b2PrismaticJoint16SetMaxMotorForceEf(i1, Math_fround(HEAPF32[i3 >> 2]));
   i1 = HEAP32[i5 >> 2] | 0;
  }
 }
 i3 = i4 + 108 | 0;
 i2 = i3;
 i15 = HEAP32[i2 + 4 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 i2 = f14 < Math_fround(-1.0e6);
 i16 = f14 > Math_fround(1.0e6);
 f14 = i16 ? Math_fround(1.0e6) : f14;
 f14 = i2 ? Math_fround(-1.0e6) : f14;
 HEAPF32[i3 >> 2] = f14;
 i2 = i4 + 112 | 0;
 f13 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i4 = f13 < Math_fround(-1.0e6);
 i15 = f13 > Math_fround(1.0e6);
 f13 = i15 ? Math_fround(1.0e6) : f13;
 f13 = i4 ? Math_fround(-1.0e6) : f13;
 HEAPF32[i2 >> 2] = f13 < f14 ? f14 : f13;
 HEAP8[i11 >> 0] = 1;
 if (!i1) i12 = 7; else {
  __ZN16b2PrismaticJoint11EnableLimitEb(i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i12 = 7; else {
   i15 = HEAP32[i3 >> 2] | 0;
   f14 = Math_fround(HEAPF32[i2 >> 2]);
   i16 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f14;
   f14 = (HEAP32[tempDoublePtr >> 2] = i4 ? i16 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   __ZN16b2PrismaticJoint9SetLimitsEff(i1, f14, (HEAP32[tempDoublePtr >> 2] = i4 ? i15 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2])));
   i1 = HEAP32[i5 >> 2] | 0;
   HEAP8[i6 >> 0] = i7;
   if (i1 | 0) {
    __ZN16b2PrismaticJoint11EnableMotorEb(i1, i8);
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP8[i11 >> 0] = i9;
    if (!i1) return;
    __ZN16b2PrismaticJoint11EnableLimitEb(i1, i10);
    return;
   }
  }
 }
 if ((i12 | 0) == 7) HEAP8[i6 >> 0] = i7;
 HEAP8[i11 >> 0] = i9;
 return;
}

function __ZN8IRaycast12IntersectAnyERKN4math8floatNx3ES3_P4AABBj(i2, i1, i21, i25) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 i25 = i25 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f22 = f0, f23 = f0, f24 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0, f33 = f0, f34 = f0;
 if (!i25) {
  i25 = 0;
  return i25 | 0;
 }
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f27 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f28 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f20 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f23 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f24 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 i1 = 0;
 while (1) {
  i2 = i21 + (i1 * 24 | 0) | 0;
  f34 = Math_fround(HEAPF32[i2 >> 2]);
  f32 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f30 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i2 = i21 + (i1 * 24 | 0) + 12 | 0;
  f33 = Math_fround(HEAPF32[i2 >> 2]);
  f31 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f29 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i1 = i1 + 1 | 0;
  if ((Math_fround(Math_abs(Math_fround(f5 - f34))) <= Math_fround(f33 + f26) ? Math_fround(Math_abs(Math_fround(f9 - f32))) <= Math_fround(f31 + f17) : 0) & Math_fround(Math_abs(Math_fround(f13 - f30))) <= Math_fround(f29 + f22) | (Math_fround(Math_abs(Math_fround(f6 - f34))) <= Math_fround(f33 + f27) ? Math_fround(Math_abs(Math_fround(f10 - f32))) <= Math_fround(f31 + f18) : 0) & Math_fround(Math_abs(Math_fround(f14 - f30))) <= Math_fround(f29 + f23) | (Math_fround(Math_abs(Math_fround(f7 - f34))) <= Math_fround(f33 + f28) ? Math_fround(Math_abs(Math_fround(f11 - f32))) <= Math_fround(f31 + f19) : 0) & Math_fround(Math_abs(Math_fround(f15 - f30))) <= Math_fround(f29 + f24) | (Math_fround(Math_abs(Math_fround(f8 - f34))) <= Math_fround(f33 + f16) ? Math_fround(Math_abs(Math_fround(f12 - f32))) <= Math_fround(f31 + f20) : 0) & Math_fround(Math_abs(Math_fround(f3 - f30))) <= Math_fround(f29 + f4)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  if (i1 >>> 0 >= i25 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN5Umbra12StreamReader14readLineAppendERNS_5ArrayIcEE(i5, i14) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16;
 i15 = i14 + 12 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i10 = i5 + 4 | 0;
 i12 = i14 + 8 | 0;
 i13 = i14 + 4 | 0;
 do {
  if (!(HEAP8[i10 >> 0] | 0)) break;
  i8 = HEAP32[i5 >> 2] | 0;
  i8 = (mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i9 | 0, 1) | 0) == 1;
  HEAP8[i10 >> 0] = i8 & 1;
  i6 = HEAP8[i9 >> 0] | 0;
  if (!i8) break;
  i7 = HEAP32[i15 >> 2] | 0;
  i8 = i7 + 1 | 0;
  if ((HEAP32[i12 >> 2] | 0) > (i7 | 0)) {
   i1 = HEAP32[i13 >> 2] | 0;
   i3 = 14;
  } else {
   i2 = i8 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
   i1 = HEAP32[i14 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 16 | 0, 0) | 0;
   if (i1 | 0) {
    HEAP32[i1 >> 2] = i2;
    i4 = i1 + 16 | 0;
    HEAP32[i12 >> 2] = i2;
    i1 = HEAP32[i13 >> 2] | 0;
    do if (i1 | 0) {
     i2 = HEAP32[i15 >> 2] | 0;
     if (i2) {
      i3 = (i2 | 0) <= (i8 | 0) ? i2 : i8;
      if ((i3 | 0) > 0) {
       i2 = 0;
       do {
        HEAP8[i4 + i2 >> 0] = HEAP8[i1 + i2 >> 0] | 0;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != (i3 | 0));
       i1 = HEAP32[i13 >> 2] | 0;
       if (!i1) break;
      }
     }
     i3 = HEAP32[i14 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 + -16 | 0);
    } while (0);
    HEAP32[i13 >> 2] = i4;
    i1 = i4;
    i3 = 14;
   }
  }
  if ((i3 | 0) == 14) {
   i3 = 0;
   HEAP32[i15 >> 2] = i8;
   HEAP8[i1 + i7 >> 0] = i6;
  }
 } while (i6 << 24 >> 24 != 10);
 i7 = HEAP32[i15 >> 2] | 0;
 i5 = i7 - i11 | 0;
 if (!i5) {
  i15 = -1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i6 = i7 + 1 | 0;
 if ((HEAP32[i12 >> 2] | 0) > (i7 | 0)) i1 = HEAP32[i13 >> 2] | 0; else {
  i2 = i6 << 1;
  i2 = (i2 | 0) > 16 ? i2 : 16;
  i1 = HEAP32[i14 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 16 | 0, 0) | 0;
  if (!i1) {
   i15 = i5;
   STACKTOP = i16;
   return i15 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 16 | 0;
  HEAP32[i12 >> 2] = i2;
  i2 = HEAP32[i13 >> 2] | 0;
  do if (i2 | 0) {
   i3 = HEAP32[i15 >> 2] | 0;
   if (i3) {
    i4 = (i3 | 0) <= (i6 | 0) ? i3 : i6;
    if ((i4 | 0) > 0) {
     i3 = 0;
     do {
      HEAP8[i1 + i3 >> 0] = HEAP8[i2 + i3 >> 0] | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i4 | 0));
     i2 = HEAP32[i13 >> 2] | 0;
     if (!i2) break;
    }
   }
   i14 = HEAP32[i14 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 + -16 | 0);
  } while (0);
  HEAP32[i13 >> 2] = i1;
 }
 HEAP32[i15 >> 2] = i6;
 HEAP8[i1 + i7 >> 0] = 0;
 i15 = i5;
 STACKTOP = i16;
 return i15 | 0;
}

function __Z41Physics2D_CUSTOM_INTERNAL_CALL_BoxCastAllRK13Vector2fIcallS1_fS1_fiff(i1, i2, f6, i3, f7, i4, f8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 i3 = i3 | 0;
 f7 = Math_fround(f7);
 i4 = i4 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i13 + 8 | 0;
 i15 = i13;
 i12 = i13 + 24 | 0;
 i14 = i13 + 16 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i15;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i15);
 i19 = i16;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i17 = i11;
 HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 i17 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 do if (!(__ZN16Physics2DManager10BoxCastAllERK8Vector2fS2_fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i17, i16, i15, f6, i14, f7, i4, f8, f9, 0, 0, i12) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i2 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i5) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i5) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i3 = 0;
  while (1) {
   i17 = i2;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i4;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   i19 = i2 + 8 | 0;
   i18 = HEAP32[i19 + 4 >> 2] | 0;
   i17 = i4 + 8 | 0;
   HEAP32[i17 >> 2] = HEAP32[i19 >> 2];
   HEAP32[i17 + 4 >> 2] = i18;
   i17 = i2 + 16 | 0;
   i18 = HEAP32[i17 + 4 >> 2] | 0;
   i19 = i4 + 16 | 0;
   HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i19 + 4 >> 2] = i18;
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i5 | 0)) break; else {
    i4 = i4 + 36 | 0;
    i2 = i2 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 HEAP32[i6 >> 2] = gb + 59740 + 8;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i6 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = i6 + 56 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i6 + 96 >> 2] = Math_fround(.00100000005);
 HEAPF32[i6 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 100 >> 2] = Math_fround(.100000001);
 HEAP8[i6 + 105 >> 0] = 0;
 HEAP8[i6 + 104 >> 0] = 0;
 HEAPF32[i6 + 80 >> 2] = Math_fround(0.0);
 HEAP32[i6 + 88 >> 2] = 0;
 __ZN9InputAxis7SetNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i1);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i8 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i8 >> 0] = 0;
 i3 = i4 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i6 + 28 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i8 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i8 >> 0] = 0;
 i3 = i5 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i6 + 44 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 STACKTOP = i9;
 return;
}

function __ZN6prcoreL18BlitFloatToIntegerERK14ImageReferenceRS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((i3 | 0) == 5) {
  if ((i2 | 0) == 18) i1 = 0; else if ((i2 | 0) == 19) i1 = 1; else if ((i2 | 0) == 23) i1 = 2; else if ((i2 | 0) == 20) i1 = 3; else if ((i2 | 0) == 6) i1 = 4; else if ((i2 | 0) == 15) i1 = 5; else if ((i2 | 0) == 16) i1 = 6; else switch (i2 | 0) {
  case 23:
   {
    i1 = 2;
    i7 = 14;
    break L1;
   }
  case 17:
   {
    i1 = 7;
    break;
   }
  default:
   {
    i7 = 17;
    break L1;
   }
  }
  i1 = HEAP32[gb + 56864 + (i1 << 2) >> 2] | 0;
  if (!i1) i7 = 12; else {
   HEAP8[i6 >> 0] = 0;
   HEAP32[i6 + 4 >> 2] = i1;
   i1 = i6 + 8 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = i6 + 12 | 0;
  }
 } else i7 = 12; while (0);
 if ((i7 | 0) == 12) if ((i2 | 0) == 18) {
  i1 = 0;
  i7 = 14;
 } else if ((i2 | 0) == 19) {
  i1 = 1;
  i7 = 14;
 } else if ((i2 | 0) == 23) {
  i1 = 2;
  i7 = 14;
 } else if ((i2 | 0) == 20) {
  i1 = 3;
  i7 = 14;
 } else i7 = 17;
 if ((i7 | 0) == 17) if ((i2 | 0) == 6) {
  i1 = 4;
  i7 = 14;
 } else if ((i2 | 0) == 15) {
  i1 = 5;
  i7 = 14;
 } else if ((i2 | 0) == 16) {
  i1 = 6;
  i7 = 14;
 } else if ((i2 | 0) == 17) {
  i1 = 7;
  i7 = 14;
 } else {
  i2 = 0;
  i7 = 21;
 }
 if ((i7 | 0) == 14) {
  i2 = HEAP32[gb + 56864 + (i1 << 2) >> 2] | 0;
  i7 = 21;
 }
 if ((i7 | 0) == 21) {
  L27 : do if ((i3 | 0) == -1) {
   i1 = 0;
   i7 = 23;
  } else if ((i3 | 0) == 1001) {
   i1 = 1;
   i7 = 23;
  } else if ((i3 | 0) == 1) {
   i1 = 2;
   i7 = 23;
  } else if ((i3 | 0) == 7) {
   i1 = 3;
   i7 = 23;
  } else if ((i3 | 0) == 3) {
   i1 = 4;
   i7 = 23;
  } else {
   switch (i3 | 0) {
   case 2:
   case 5:
    {
     i1 = (i3 | 0) == 2 ? 6 : 7;
     i7 = 23;
     break L27;
    }
   default:
    {}
   }
   if ((i3 | 0) == 8) {
    i1 = 8;
    i7 = 23;
   } else if ((i3 | 0) == 1e3) {
    i1 = 9;
    i7 = 23;
   } else if ((i3 | 0) == 13) {
    i1 = 10;
    i7 = 23;
   } else if ((i3 | 0) == 14) {
    i1 = 11;
    i7 = 23;
   } else if ((i3 | 0) == 4) {
    i1 = 12;
    i7 = 23;
   } else i1 = 0;
  } while (0);
  if ((i7 | 0) == 23) i1 = HEAP32[gb + 56896 + (i1 + 91 << 2) >> 2] | 0;
  i7 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(5) | 0) + 4 >> 2] | 0;
  HEAP8[i6 >> 0] = 1;
  HEAP32[i6 + 4 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = i6 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = i7;
 }
 __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE(i5, i4, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZdaPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i6 = i12 + 20 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i7 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 28 >> 2])) >>> 0;
 i2 = i1 << 2;
 i10 = (i7 << 2) + i2 | 0;
 i10 = (0 - i10 & 12) + i10 | 0;
 i8 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i8 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i10 + (i7 << 4) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i9 = i8 + i2 | 0;
 i10 = i8 + i10 | 0;
 _memset(i8 | 0, -1, i2 | 0) | 0;
 i2 = i12 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  i4 = i1 + -1 | 0;
  i5 = 0;
  do {
   i15 = i3 + (i5 << 4) | 0;
   i16 = HEAP32[i15 >> 2] | 0;
   i15 = HEAP32[i15 + 4 >> 2] | 0;
   i14 = _i64Add(i16 | 0, i15 | 0, -1, ~i16 | 0) | 0;
   i17 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i14 | 0, i17 | 0, 22) | 0;
   i14 = i18 ^ i14;
   i17 = (getTempRet0() | 0) ^ i17;
   i18 = _bitshift64Shl(i14 | 0, i17 | 0, 13) | 0;
   i18 = _i64Add(i14 | 0, i17 | 0, ~i18 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i17 = getTempRet0() | 0;
   i14 = _bitshift64Lshr(i18 | 0, i17 | 0, 8) | 0;
   i17 = ___muldi3(i14 ^ i18 | 0, (getTempRet0() | 0) ^ i17 | 0, 9, 0) | 0;
   i18 = getTempRet0() | 0;
   i14 = _bitshift64Lshr(i17 | 0, i18 | 0, 15) | 0;
   i17 = i14 ^ i17;
   i18 = (getTempRet0() | 0) ^ i18;
   i14 = _bitshift64Shl(i17 | 0, i18 | 0, 27) | 0;
   i14 = _i64Add(i17 | 0, i18 | 0, ~i14 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i18 = getTempRet0() | 0;
   i17 = _bitshift64Lshr(i14 | 0, i18 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i18;
   i14 = i8 + (((i17 ^ i14) & i4) << 2) | 0;
   HEAP32[i9 + (i5 << 2) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i5;
   i14 = i10 + (i5 << 4) | 0;
   HEAP32[i14 >> 2] = i16;
   HEAP32[i14 + 4 >> 2] = i15;
   HEAP32[i10 + (i5 << 4) + 8 >> 2] = HEAP32[i3 + (i5 << 4) + 8 >> 2];
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i18 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i8;
 HEAP32[i12 + 16 >> 2] = i8;
 HEAP32[i12 + 24 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i7;
 i1 = i12 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN6Camera16DoRenderGUILayerER17ShaderPassContextNS_10RenderFlagE(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 24 | 0;
 i1 = i16;
 i14 = i16 + 8 | 0;
 i15 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 30272 | 0) | 0;
 if (!i15) {
  STACKTOP = i16;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 112 >> 2] | 0, i15 | 0) | 0)) {
  STACKTOP = i16;
  return;
 }
 if ((HEAP16[gb + 1110448 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i17;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110448 | 0, i13);
  i6 = gb + 1110448 | 0;
 } else i6 = 0;
 i7 = HEAP32[gb + 1110448 >> 2] | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 648 >> 2] | 0, i1 | 0, i7 | 0);
 __ZL19GetCameraTargetRectRK6Camerab(i13, i17, 1);
 i7 = i17 + 864 | 0;
 HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 f11 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f4 = Math_fround(f11 * Math_fround(HEAPF32[i14 >> 2]));
 i7 = i14 + 8 | 0;
 f9 = Math_fround(f11 * Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i7 >> 2] = f9;
 i1 = i14 + 4 | 0;
 f5 = Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2]));
 i8 = i14 + 12 | 0;
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i8 >> 2] = f10;
 f3 = Math_fround(HEAPF32[i13 >> 2]);
 f2 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f4 = Math_fround(f4 + f3);
 HEAPF32[i14 >> 2] = f4;
 f5 = Math_fround(f5 + f2);
 HEAPF32[i1 >> 2] = f5;
 f9 = Math_fround(f9 + f4);
 f10 = Math_fround(f10 + f5);
 f11 = Math_fround(f11 + f3);
 f12 = Math_fround(f12 + f2);
 if (f4 < f3) HEAPF32[i14 >> 2] = f3; else f3 = f4;
 if (f5 < f2) HEAPF32[i1 >> 2] = f2; else f2 = f5;
 f11 = Math_fround((f9 > f11 ? f11 : f9) - f3);
 i1 = f11 < Math_fround(0.0);
 HEAPF32[i7 >> 2] = i1 ? Math_fround(0.0) : f11;
 f12 = Math_fround((f10 > f12 ? f12 : f10) - f2);
 i7 = f12 < Math_fround(0.0);
 HEAPF32[i8 >> 2] = i7 ? Math_fround(0.0) : f12;
 i17 = HEAP32[i17 + 880 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 __ZN8GUILayer14RenderGUILayerE5RectTIfEjR17ShaderPassContext(i15, i13, i17, i18);
 i18 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 652 >> 2] | 0, i18 | 0);
 if (!i6) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i16;
 return;
}

function __ZN20ArchiveStorageHeader10ReadHeaderER12FileAccessorRNS_6HeaderE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[gb + 70780 >> 2] | 0;
 i2 = _strlen(i1) | 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 if ((i2 | 0) != ((i3 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255) | 0)) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 switch (i2 | 0) {
 case -1:
  {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i5);
   break;
  }
 case 0:
  break;
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) if (_memcmp(i3 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5, i1, i2) | 0) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i5 + 16 | 0;
 i3 = __ZN12FileAccessor4ReadEyPvPy(i6, 4, 0, i1, i7) | 0;
 i4 = i7;
 if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 4 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 if (i4 >>> 0 > 6) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i6, i5 + 20 | 0) | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(__ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i6, i5 + 36 | 0) | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i5 + 56 | 0;
 i3 = __ZN12FileAccessor4ReadEyPvPy(i6, 8, 0, i1, i7) | 0;
 i4 = i7;
 if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 8 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i4;
 i1 = i5 + 64 | 0;
 i3 = __ZN12FileAccessor4ReadEyPvPy(i6, 4, 0, i1, i7) | 0;
 i4 = i7;
 if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 4 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 i2 = i5 + 68 | 0;
 i3 = __ZN12FileAccessor4ReadEyPvPy(i6, 4, 0, i2, i7) | 0;
 i4 = i7;
 if (!(i3 & ((HEAP32[i4 >> 2] | 0) == 4 & (HEAP32[i4 + 4 >> 2] | 0) == 0))) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > i4 >>> 0) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i5 + 72 | 0;
 i6 = __ZN12FileAccessor4ReadEyPvPy(i6, 4, 0, i1, i7) | 0;
 if (!(i6 & ((HEAP32[i7 >> 2] | 0) == 4 & (HEAP32[i7 + 4 >> 2] | 0) == 0))) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN12CubemapArray13UploadTextureEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 8 | 0;
 i8 = i15 + 4 | 0;
 i14 = i15;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 483 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i1 = i13 + 92 | 0;
 i2 = i13 + 100 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i9 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 460 >> 2] | 0;
 i12 = i13 + 48 | 0;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i13 + 80 >> 2] | 0;
 i3 = HEAP32[i13 + 84 >> 2] | 0;
 i4 = HEAP32[i13 + 88 >> 2] | 0;
 i5 = HEAP32[i13 + 76 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i6 = HEAP32[i13 + 60 >> 2] | 0; else i6 = 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 mftCall_viiiiiiiiii(i10 | 0, i9 | 0, i11 | 0, i7 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, 0, i6 | 0);
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i13;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i11 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 14;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 13;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 9) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 13) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 14) {
   HEAP32[i11 >> 2] = i1;
   i4 = i1;
   i3 = i11;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i10 = i7 + 8 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 92 >> 2] | 0, i13 | 0);
 i10 = __Z12GetGfxDevicev() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 680 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 i12 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 mftCall_viii(i9 | 0, i10 | 0, i11 | 0, i12 | 0);
 HEAP8[i13 + 104 >> 0] = 1;
 STACKTOP = i15;
 return;
}

function __ZN12CachedReader15UpdateReadCacheEPvj(i7, i12, i14) {
 i7 = i7 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i15 = 0, i16 = 0;
 i11 = i7 + 4 | 0;
 i9 = i7 + 16 | 0;
 i10 = i7 + 20 | 0;
 i13 = (Math_imul(HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) + ((HEAP32[i7 >> 2] | 0) - (HEAP32[i11 >> 2] | 0)) | 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i7, i13, i14);
 i6 = i7 + 32 | 0;
 if (HEAP8[i6 >> 0] | 0) {
  _memset(i12 | 0, 0, i14 | 0) | 0;
  return;
 }
 __ZN12CachedReader16OutOfBoundsErrorEjj(i7, i13, 0);
 if (!(HEAP8[i6 >> 0] | 0)) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = (i13 >>> 0) / (i1 >>> 0) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i7 + 12 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = (i13 >>> 0) / ((HEAP32[i10 >> 2] | 0) >>> 0) | 0;
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i1 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i11 | 0, i7 + 8 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i1 = i13 - (Math_imul(i2, i1) | 0) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = i2 + i1 | 0;
  HEAP32[i7 >> 2] = i1;
  i5 = i7;
 } else {
  i5 = i7;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i7 + 8 | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 i16 = i1 >>> 0 < i2 >>> 0 ? i2 : i1 >>> 0 > i15 >>> 0 ? i15 : i1;
 i3 = i1 + i14 | 0;
 i4 = i16;
 _memcpy(i12 + (i4 - i1) | 0, i16 | 0, (i3 >>> 0 < i2 >>> 0 ? i2 : i3 >>> 0 > i15 >>> 0 ? i15 : i3) - i4 | 0) | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + i14 | 0;
 if (i1 >>> 0 <= (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i1;
  return;
 }
 i4 = i13 + i14 | 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i7, i4, 0);
 if (!(HEAP8[i6 >> 0] | 0)) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = (i4 >>> 0) / (i1 >>> 0) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i7 + 12 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = (i4 >>> 0) / ((HEAP32[i10 >> 2] | 0) >>> 0) | 0;
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i1 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i11 | 0, i8 | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i3 = i4 - (Math_imul(i2, i1) | 0) | 0;
  i16 = HEAP32[i11 >> 2] | 0;
  HEAP32[i5 >> 2] = i16 + i3;
  i3 = i1;
  i1 = i16;
 } else {
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i11 = i13 - (Math_imul(i3, i2) | 0) | 0;
 i10 = i1 + i11 | 0;
 i13 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 | 0) < 0 ? i1 : i10 >>> 0 > i13 >>> 0 ? i13 : i10;
 i15 = i10 + i14 | 0;
 i16 = i11;
 _memcpy(i12 + (i16 - i10) | 0, i11 | 0, (i15 >>> 0 < i1 >>> 0 ? i1 : i15 >>> 0 > i13 >>> 0 ? i13 : i15) - i16 | 0) | 0;
 return;
}

function __Z35Texture2D_CUSTOM_SetBlockOfPixels32P12Il2CppObjectiiiiP11Il2CppArrayi(i13, i6, i7, i8, i9, i10, i11) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 16 | 0;
 i4 = i14 + 8 | 0;
 i3 = i14;
 i2 = i14 + 40 | 0;
 i12 = i14 + 28 | 0;
 HEAP32[i2 >> 2] = i13;
 if (!i13) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
 if (!i1) {
  i15 = i13;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i15);
 }
 if (!(HEAP8[i1 + 111 >> 0] | 0)) {
  i15 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i2) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 36 >> 2] | 0, i15 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 if ((i11 | 0) >= 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
  if ((__ZNK9Texture2D16CountDataMipmapsEv(i1) | 0) > (i11 | 0)) {
   i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i10) | 0;
   i15 = ___muldi3(i9 | 0, ((i9 | 0) < 0) << 31 >> 31 | 0, i8 | 0, ((i8 | 0) < 0) << 31 >> 31 | 0) | 0;
   i4 = getTempRet0() | 0;
   i3 = ((i1 | 0) < 0) << 31 >> 31;
   if (i4 >>> 0 > 0 | (i4 | 0) == 0 & i15 >>> 0 > 2147483647 | (i3 >>> 0 < i4 >>> 0 | (i3 | 0) == (i4 | 0) & i1 >>> 0 < i15 >>> 0)) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i5 + 4 >> 2] = i8;
    HEAP32[i5 + 8 >> 2] = i9;
    __Z6FormatPKcz(i12, gb + 570503 | 0, i5);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 570137 | 0, 427, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    STACKTOP = i14;
    return;
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
   __ZN9Texture2D11SetPixels32EiiiiiPK11ColorRGBA32(i1, i6, i7, i8, i9, i11, __Z27scripting_array_element_ptrP11Il2CppArrayij(i10, 0, 4) | 0);
   STACKTOP = i14;
   return;
  }
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i13) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 HEAP32[i4 >> 2] = __ZNK9Texture2D16CountDataMipmapsEv(i1) | 0;
 __Z6FormatPKcz(i12, gb + 570440 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 570137 | 0, 420, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN16ScriptingManager15GetAssemblyNameENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1 + 36 | 0;
 i6 = i1 + 24 | 0;
 i5 = i1 + 12 | 0;
 i7 = i1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i10 = i3 + 11 | 0;
 i11 = HEAP8[i10 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i11 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, gb + 465894 | 0, 9, i11 + 9 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i11) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i11 = i3 << 24 >> 24 < 0;
 i3 = i11 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 i10 = i4 + 11 | 0;
 i9 = HEAP8[i10 >> 0] | 0;
 i9 = i9 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i9 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i11 ? HEAP32[i5 >> 2] | 0 : i5, i3, i9 + i3 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i9) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1576256 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = HEAP8[i6 + 11 >> 0] | 0;
 i10 = i9 << 24 >> 24 < 0;
 i9 = i10 ? HEAP32[i6 + 4 >> 2] | 0 : i9 & 255;
 i3 = i7 + 11 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 i4 = i4 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i10 ? HEAP32[i6 >> 2] | 0 : i6, i9, i4 + i9 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i2, i3 ? HEAP32[i8 >> 2] | 0 : i8, i4, i4 + 4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i2, gb + 465904 | 0, 4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i1;
 return;
}

function _get_interesting_appn(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i10 = i8 + 24 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if (!i1) if (!((mftCall_ii(HEAP32[i11 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i1 = HEAP32[i12 >> 2] | 0;
  break;
 } while (0);
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = i1 + -1 | 0;
 i2 = i3 + 1 | 0;
 i3 = HEAPU8[i3 >> 0] << 8;
 do if (!i1) if (!((mftCall_ii(HEAP32[i11 + 12 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  break;
 } while (0);
 i6 = HEAPU8[i2 >> 0] | i3;
 i7 = i6 + -2 | 0;
 i6 = (i7 | 0) > 13 ? 14 : i6 >>> 0 > 2 ? i7 : 0;
 i3 = i1 + -1 | 0;
 i1 = i2 + 1 | 0;
 L13 : do if (!i6) i2 = i3; else {
  i5 = i11 + 12 | 0;
  i4 = 0;
  i2 = i3;
  while (1) {
   if (!i2) {
    if (!((mftCall_ii(HEAP32[i5 >> 2] | 0, i8 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     break;
    }
    i2 = HEAP32[i12 >> 2] | 0;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   HEAP8[i9 + i4 >> 0] = HEAP8[i1 >> 0] | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 + -1 | 0;
   i1 = i1 + 1 | 0;
   if (i4 >>> 0 >= i6 >>> 0) break L13;
  }
  STACKTOP = i13;
  return i1 | 0;
 } while (0);
 i3 = i7 - i6 | 0;
 i4 = HEAP32[i8 + 380 >> 2] | 0;
 L23 : do switch (i4 | 0) {
 case 224:
  {
   _examine_app0(i8, i9, i6, i3);
   break;
  }
 case 238:
  {
   if (i6 >>> 0 > 11 & (HEAP8[i9 >> 0] | 0) == 65) if ((HEAP8[i9 + 1 >> 0] | 0) == 100) if ((HEAP8[i9 + 2 >> 0] | 0) == 111) if ((HEAP8[i9 + 3 >> 0] | 0) == 98) if ((HEAP8[i9 + 4 >> 0] | 0) == 101) {
    i4 = HEAPU8[i9 + 7 >> 0] << 8 | HEAPU8[i9 + 8 >> 0];
    i5 = HEAPU8[i9 + 9 >> 0] << 8 | HEAPU8[i9 + 10 >> 0];
    i7 = HEAP8[i9 + 11 >> 0] | 0;
    i6 = HEAP32[i8 >> 2] | 0;
    HEAP32[i6 + 24 >> 2] = HEAPU8[i9 + 5 >> 0] << 8 | HEAPU8[i9 + 6 >> 0];
    HEAP32[i6 + 28 >> 2] = i4;
    HEAP32[i6 + 32 >> 2] = i5;
    HEAP32[i6 + 36 >> 2] = i7 & 255;
    HEAP32[i6 + 20 >> 2] = 76;
    mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i8 | 0, 1);
    HEAP8[i8 + 264 >> 0] = 1;
    HEAP8[i8 + 265 >> 0] = i7;
    break L23;
   }
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i9 + 20 >> 2] = 78;
   HEAP32[i9 + 24 >> 2] = i7;
   mftCall_vii(HEAP32[i9 + 4 >> 2] | 0, i8 | 0, 1);
   break;
  }
 default:
  {
   i9 = HEAP32[i8 >> 2] | 0;
   HEAP32[i9 + 20 >> 2] = 68;
   HEAP32[i9 + 24 >> 2] = i4;
   mftCall_vi(HEAP32[i9 >> 2] | 0, i8 | 0);
  }
 } while (0);
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 if ((i3 | 0) <= 0) {
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i3 | 0);
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEEEEEjT_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i2 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_11PxMeshScaleEE8pushNameEPKc(i7, HEAP32[i6 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i7 + 36 >> 0] = 1; else {
  i4 = i1 + -1 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i7 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i7 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 i2 = i6 + 16 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_11PxMeshScaleEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_(i7, i5);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  i8 = i8 + 2 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i8 = i8 + 2 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i8 = i8 + 2 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i8 = i8 + 2 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7mecanim9animation10SampleClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEfPf(i1, i2, f6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf(i1, i2, f6);
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) < 4) i2 = 0; else {
  i3 = 0;
  i2 = 4;
  while (1) {
   i4 = i7 + (i3 << 2) | 0;
   f15 = Math_fround(HEAPF32[i1 >> 2]);
   f26 = Math_fround(HEAPF32[i1 + 20 >> 2]);
   f22 = Math_fround(HEAPF32[i1 + 40 >> 2]);
   f15 = Math_fround(f6 - f15);
   f26 = Math_fround(f6 - f26);
   f22 = Math_fround(f6 - f22);
   f18 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 60 >> 2]));
   f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f25 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   f21 = Math_fround(HEAPF32[i1 + 44 >> 2]);
   f17 = Math_fround(HEAPF32[i1 + 64 >> 2]);
   f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   f20 = Math_fround(HEAPF32[i1 + 48 >> 2]);
   f16 = Math_fround(HEAPF32[i1 + 68 >> 2]);
   f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
   f23 = Math_fround(HEAPF32[i1 + 32 >> 2]);
   f19 = Math_fround(HEAPF32[i1 + 52 >> 2]);
   f8 = Math_fround(HEAPF32[i1 + 72 >> 2]);
   f11 = Math_fround(HEAPF32[i1 + 16 >> 2]);
   f10 = Math_fround(HEAPF32[i1 + 36 >> 2]);
   f9 = Math_fround(HEAPF32[i1 + 56 >> 2]);
   f10 = Math_fround(Math_fround(f26 * Math_fround(Math_fround(f26 * Math_fround(Math_fround(f26 * f25) + f24)) + f23)) + f10);
   f9 = Math_fround(Math_fround(f22 * Math_fround(Math_fround(f22 * Math_fround(Math_fround(f22 * f21) + f20)) + f19)) + f9);
   f8 = Math_fround(Math_fround(f18 * Math_fround(Math_fround(f18 * Math_fround(Math_fround(f18 * f17) + f16)) + f8)) + Math_fround(HEAPF32[i1 + 76 >> 2]));
   HEAPF32[i4 >> 2] = Math_fround(Math_fround(f15 * Math_fround(Math_fround(f15 * Math_fround(Math_fround(f15 * f14) + f13)) + f12)) + f11);
   HEAPF32[i4 + 4 >> 2] = f10;
   HEAPF32[i4 + 8 >> 2] = f9;
   HEAPF32[i4 + 12 >> 2] = f8;
   i1 = i1 + 80 | 0;
   i4 = i2 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i4 | 0) > (i3 | 0)) break; else {
    i3 = i2;
    i2 = i4;
   }
  }
 }
 if ((i2 | 0) >= (i3 | 0)) return;
 while (1) {
  f25 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
  f26 = Math_fround(f25 * Math_fround(HEAPF32[i1 + 4 >> 2]));
  f26 = Math_fround(f25 * Math_fround(f26 + Math_fround(HEAPF32[i1 + 8 >> 2])));
  f26 = Math_fround(f25 * Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f26));
  HEAPF32[i7 + (i2 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + f26);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 20 | 0;
 }
 return;
}

function __Z36CalculateLODGroupBoundsCenterAndSizeR8Vector3fRfRK8LODGroup(i13, i14, i2) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 16 | 0;
 i10 = i16 + 8 | 0;
 i11 = i16 + 4 | 0;
 i12 = i16;
 HEAP32[i15 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f1 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i4 = i15 + 12 | 0;
 HEAPF32[i4 >> 2] = f7;
 i6 = i15 + 16 | 0;
 HEAPF32[i6 >> 2] = f1;
 i8 = i15 + 20 | 0;
 HEAPF32[i8 >> 2] = f9;
 __Z15GetLODGroupAABBR10MinMaxAABBRK8LODGroup(i15, i2);
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f1 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (f9 == f1) {
  f7 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  if (f7 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
   f7 = Math_fround(HEAPF32[i15 + 8 >> 2]);
   if (!(f7 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2]))) i5 = 4;
  } else i5 = 4;
 } else i5 = 4;
 do if ((i5 | 0) == 4) {
  f3 = Math_fround(-f1);
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  if (f7 == f3) {
   f17 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
   f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   f1 = Math_fround(HEAPF32[i8 >> 2]);
   if (!(f3 != f18 | f1 != f17)) break;
  } else {
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   f1 = Math_fround(HEAPF32[i8 >> 2]);
  }
  f21 = Math_fround(f7 + f9);
  f17 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f20 = Math_fround(f3 + f17);
  f18 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f20 = Math_fround(f20 * Math_fround(.5));
  f19 = Math_fround(Math_fround(f1 + f18) * Math_fround(.5));
  HEAPF32[i13 >> 2] = Math_fround(f21 * Math_fround(.5));
  HEAPF32[i13 + 4 >> 2] = f20;
  HEAPF32[i13 + 8 >> 2] = f19;
  f9 = Math_fround(Math_fround(Math_fround(f7 - f9) * Math_fround(.5)) * Math_fround(2.0));
  f17 = Math_fround(Math_fround(Math_fround(f3 - f17) * Math_fround(.5)) * Math_fround(2.0));
  f18 = Math_fround(Math_fround(Math_fround(f1 - f18) * Math_fround(.5)) * Math_fround(2.0));
  HEAPF32[i10 >> 2] = f9;
  HEAPF32[i11 >> 2] = f17;
  HEAPF32[i12 >> 2] = f18;
  i15 = f9 < f17 ? i11 : i10;
  i13 = Math_fround(HEAPF32[i15 >> 2]) < f18;
  HEAP32[i14 >> 2] = HEAP32[(i13 ? i12 : i15) >> 2];
  STACKTOP = i16;
  return;
 } while (0);
 HEAP32[i13 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 STACKTOP = i16;
 return;
}

function __ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_(i4, i6, i9, i7, i10, i1, i2, i8, i12, i13, i11, i5) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 L1 : do if (i4 << 24 >> 24 == i1 << 24 >> 24) if (!(HEAP8[i6 >> 0] | 0)) i1 = -1; else {
  HEAP8[i6 >> 0] = 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = 46;
  i10 = HEAP8[i8 + 11 >> 0] | 0;
  if (!((i10 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i10 & 255) | 0)) i1 = 0; else {
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 - i12 | 0) < 160) {
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i1 + 4;
    HEAP32[i1 >> 2] = i12;
    i1 = 0;
   } else i1 = 0;
  }
 } else {
  if (i4 << 24 >> 24 == i2 << 24 >> 24) {
   i3 = HEAP8[i8 + 11 >> 0] | 0;
   if ((i3 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255) | 0) {
    if (!(HEAP8[i6 >> 0] | 0)) {
     i1 = -1;
     break;
    }
    i1 = HEAP32[i13 >> 2] | 0;
    if ((i1 - i12 | 0) >= 160) {
     i1 = 0;
     break;
    }
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i1 + 4;
    HEAP32[i1 >> 2] = i12;
    HEAP32[i11 >> 2] = 0;
    i1 = 0;
    break;
   }
  }
  i3 = i5 + 32 | 0;
  i2 = 0;
  while (1) {
   i1 = i5 + i2 | 0;
   if ((i2 | 0) == 32) {
    i1 = i3;
    break;
   }
   if ((HEAP8[i1 >> 0] | 0) == i4 << 24 >> 24) break; else i2 = i2 + 1 | 0;
  }
  i2 = i1 - i5 | 0;
  if ((i2 | 0) > 31) i1 = -1; else {
   i3 = HEAP8[gb + 1077991 + i2 >> 0] | 0;
   switch (i2 | 0) {
   case 24:
   case 25:
    {
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) != (i7 | 0)) if ((HEAPU8[i1 + -1 >> 0] & 95 | 0) != (HEAPU8[i9 >> 0] & 127 | 0)) {
      i1 = -1;
      break L1;
     }
     HEAP32[i10 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3;
     i1 = 0;
     break L1;
    }
   case 23:
   case 22:
    {
     HEAP8[i9 >> 0] = 80;
     i1 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3;
     i1 = 0;
     break L1;
    }
   default:
    {
     i1 = i3 & 95;
     if ((i1 | 0) == (HEAP8[i9 >> 0] | 0)) {
      HEAP8[i9 >> 0] = i1 | 128;
      if (HEAP8[i6 >> 0] | 0) {
       HEAP8[i6 >> 0] = 0;
       i9 = HEAP8[i8 + 11 >> 0] | 0;
       if ((i9 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i9 & 255) | 0) {
        i1 = HEAP32[i13 >> 2] | 0;
        if ((i1 - i12 | 0) < 160) {
         i12 = HEAP32[i11 >> 2] | 0;
         HEAP32[i13 >> 2] = i1 + 4;
         HEAP32[i1 >> 2] = i12;
        }
       }
      }
     }
     i13 = HEAP32[i10 >> 2] | 0;
     HEAP32[i10 >> 2] = i13 + 1;
     HEAP8[i13 >> 0] = i3;
     if ((i2 | 0) > 21) {
      i1 = 0;
      break L1;
     }
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i1 = 0;
     break L1;
    }
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i4, i1, i6, i8, i9, i10) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 24 | 0;
 i2 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i11 = i14;
 i13 = i14 + 28 | 0;
 f17 = Math_fround((HEAP32[i4 + 56 >> 2] | 0) >>> 0);
 f16 = Math_fround(HEAPF32[i4 + 96 >> 2]);
 f17 = Math_fround(Math_fround(f17 * f16) + Math_fround(.5));
 i5 = f17 >= Math_fround(0.0);
 f15 = Math_fround(f17 + Math_fround(-.99999994));
 i5 = ~~(i5 ? f17 : f15);
 f16 = Math_fround(Math_fround(f16 * Math_fround((HEAP32[i4 + 60 >> 2] | 0) >>> 0)) + Math_fround(.5));
 i7 = f16 >= Math_fround(0.0);
 f15 = Math_fround(f16 + Math_fround(-.99999994));
 i7 = ~~(i7 ? f16 : f15);
 if (i1 & 1 | 0) {
  HEAP32[i10 + 16 >> 2] = 1;
  i1 = i13 + 11 | 0;
  HEAP32[i11 >> 2] = gb + 1044540;
  HEAP32[i11 + 4 >> 2] = i9;
  __Z6FormatPKcz(i13, gb + 1044523 | 0, i11);
  i11 = __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc(i4, i10, i6, 1, i5, i7, i8, 0, 0, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  HEAP32[i12 >> 2] = gb + 1044545;
  HEAP32[i12 + 4 >> 2] = i9;
  __Z6FormatPKcz(i13, gb + 1044523 | 0, i12);
  if (i11) i1 = __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc(i4, i10 + 4 | 0, i6, 1, i5, i7, i8, 0, 1, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) | 0; else i1 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (i1 & 2 | 0) {
  HEAP32[i2 >> 2] = i9;
  __Z6FormatPKcz(i13, gb + 1044551 | 0, i2);
  HEAP32[i10 + 16 >> 2] = 2;
  i12 = __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc(i4, i10, i6, 2, (i5 << 1) + 254 & -256, i7, i8, 0, 0, (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i13 = i12;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(i1 & 4)) {
  HEAP32[i10 + 16 >> 2] = 0;
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 } else {
  HEAP32[i3 >> 2] = i9;
  __Z6FormatPKcz(i13, gb + 1044576 | 0, i3);
  HEAP32[i10 + 16 >> 2] = 4;
  i12 = __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc(i4, i10, i6, 2, i5, i7, i8, 1, 0, (HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i13 = i12;
  STACKTOP = i14;
  return i13 | 0;
 }
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 12 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i7 = i12 + 8 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i4, i2, i10, 1);
 i9 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 619732 | 0, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN9SubModule14SubEmitterDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 619732 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN9SubModule14SubEmitterDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL34GeomOverlapCallback_CapsuleCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 24 | 0;
 i8 = i1;
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f14 * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f11 = Math_fround(f10 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f14 * f7) + Math_fround(Math_fround(f10 * f11) + Math_fround(-1.0)));
 f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(f14 * f11);
 f16 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f7 * f16));
 f16 = Math_fround(Math_fround(f7 * f14) - Math_fround(f11 * f16));
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f11 * f10);
 f13 = Math_fround(f11 * f13);
 f16 = Math_fround(f11 * f16);
 f11 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f14 = Math_fround(f11 + f10);
 f7 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f12 = Math_fround(f7 + f13);
 f6 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f15 = Math_fround(f16 + f6);
 HEAPF32[i9 >> 2] = f14;
 HEAPF32[i9 + 4 >> 2] = f12;
 HEAPF32[i9 + 8 >> 2] = f15;
 f13 = Math_fround(f7 - f13);
 f16 = Math_fround(f6 - f16);
 HEAPF32[i9 + 12 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i9 + 16 >> 2] = f13;
 HEAPF32[i9 + 20 >> 2] = f16;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(f16 * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f11 = Math_fround(f10 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(f10 * f11) + Math_fround(-1.0)));
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f6 = Math_fround(f16 * f11);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f13 * f7));
 f7 = Math_fround(Math_fround(f13 * f16) - Math_fround(f11 * f7));
 f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f11 * f10);
 f6 = Math_fround(f11 * f6);
 f7 = Math_fround(f11 * f7);
 f11 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f16 = Math_fround(f11 + f10);
 f13 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f15 = Math_fround(f13 + f6);
 f12 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f14 = Math_fround(f7 + f12);
 HEAPF32[i8 >> 2] = f16;
 HEAPF32[i8 + 4 >> 2] = f15;
 HEAPF32[i8 + 8 >> 2] = f14;
 f6 = Math_fround(f13 - f6);
 f7 = Math_fround(f12 - f7);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i8 + 16 >> 2] = f6;
 HEAPF32[i8 + 20 >> 2] = f7;
 f7 = Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i9, i8, 0, 0));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 i5 = f7 <= Math_fround(f6 * f6);
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 3, 8, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 8, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 3) | 0, 0, i7 - i6 << 3 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 36996 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 512)) {
    if (!(i1 & 1048576)) {
     HEAPF64[i6 >> 3] = 0.0;
     break;
    }
    if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
    HEAPF64[i6 >> 3] = +Math_fround(__Z19SimpleStringToFloatPKcPi(i1, 0));
   } else {
    do if (!(i1 & 16384)) {
     if (i1 & 1024 | 0) {
      d2 = +(HEAP32[i5 >> 2] | 0);
      break;
     }
     if (i1 & 2048 | 0) {
      d2 = +((HEAP32[i5 >> 2] | 0) >>> 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    HEAPF64[i6 >> 3] = d2;
   } while (0);
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 8 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __Z36UnityWebRequest_Get_Custom_PropErrorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i1 + 108 >> 2] | 0) != 4) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   do switch (HEAP32[i1 + 104 >> 2] | 0) {
   case 2:
    {
     i1 = gb + 1030869 | 0;
     break;
    }
   case 3:
    {
     i1 = gb + 1030840 | 0;
     break;
    }
   case 4:
    {
     i1 = gb + 1030819 | 0;
     break;
    }
   case 5:
    {
     i1 = gb + 1030805 | 0;
     break;
    }
   case 6:
    {
     i1 = gb + 1030784 | 0;
     break;
    }
   case 7:
    {
     i1 = gb + 1030752 | 0;
     break;
    }
   case 8:
    {
     i1 = gb + 1030717 | 0;
     break;
    }
   case 9:
    {
     i1 = gb + 1030703 | 0;
     break;
    }
   case 10:
    {
     i1 = gb + 1030676 | 0;
     break;
    }
   case 11:
    {
     i1 = gb + 1030655 | 0;
     break;
    }
   case 12:
    {
     i1 = gb + 1030635 | 0;
     break;
    }
   case 13:
    {
     i1 = gb + 1030621 | 0;
     break;
    }
   case 14:
    {
     i1 = gb + 1030605 | 0;
     break;
    }
   case 15:
    {
     i1 = gb + 1030569 | 0;
     break;
    }
   case 16:
    {
     i1 = gb + 1030535 | 0;
     break;
    }
   case 17:
    {
     i1 = gb + 1030519 | 0;
     break;
    }
   case 18:
    {
     i1 = gb + 1030495 | 0;
     break;
    }
   case 19:
    {
     i1 = gb + 1030466 | 0;
     break;
    }
   case 20:
    {
     i1 = gb + 1030428 | 0;
     break;
    }
   case 21:
    {
     i1 = gb + 1030404 | 0;
     break;
    }
   case 22:
    {
     i1 = gb + 1030381 | 0;
     break;
    }
   case 23:
    {
     i1 = gb + 1030331 | 0;
     break;
    }
   case 24:
    {
     i1 = gb + 1030288 | 0;
     break;
    }
   case 25:
    {
     i1 = gb + 1030263 | 0;
     break;
    }
   case 26:
    {
     i1 = gb + 1030233 | 0;
     break;
    }
   case 27:
    {
     i1 = gb + 1030220 | 0;
     break;
    }
   case 28:
    {
     i1 = gb + 1030200 | 0;
     break;
    }
   case 29:
    {
     i1 = gb + 1030174 | 0;
     break;
    }
   case 30:
    {
     i1 = gb + 1030118 | 0;
     break;
    }
   case 31:
    {
     i1 = gb + 1030083 | 0;
     break;
    }
   case 32:
    {
     i1 = gb + 1030043 | 0;
     break;
    }
   case 33:
    {
     i1 = gb + 1030002 | 0;
     break;
    }
   case 34:
    {
     i1 = gb + 1029961 | 0;
     break;
    }
   case 35:
    {
     i1 = gb + 1029933 | 0;
     break;
    }
   case 36:
    {
     i1 = gb + 1029913 | 0;
     break;
    }
   case 37:
    {
     i1 = gb + 1029897 | 0;
     break;
    }
   default:
    i1 = 0;
   } while (0);
   i2 = __Z20scripting_string_newPKc(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function _UNITY_png_do_gray_to_rgb(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP8[i6 + 9 >> 0] | 0;
 if ((i1 & 255) <= 7) return;
 i4 = i6 + 8 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if (i2 & 2) return;
 L7 : do switch (i2 << 24 >> 24) {
 case 0:
  {
   if (i1 << 24 >> 24 == 8) {
    i1 = i3 + i5 + -1 | 0;
    if (!i5) break L7;
    i3 = i1 + (i5 << 1) | 0;
    i2 = 0;
    while (1) {
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + -1 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + -2 >> 0] = HEAP8[i1 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else {
      i3 = i3 + -3 | 0;
      i1 = i1 + -1 | 0;
     }
    }
   } else {
    i1 = i3 + (i5 << 1) + -1 | 0;
    if (!i5) break L7;
    i3 = i1 + (i5 << 2) | 0;
    i2 = 0;
    while (1) {
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     i7 = i1 + -1 | 0;
     HEAP8[i3 + -1 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i3 + -2 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + -3 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i3 + -4 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + -5 >> 0] = HEAP8[i7 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else {
      i3 = i3 + -6 | 0;
      i1 = i1 + -2 | 0;
     }
    }
   }
   break;
  }
 case 4:
  {
   if (i1 << 24 >> 24 == 8) {
    i2 = i5 << 1;
    i1 = i3 + i2 + -1 | 0;
    if (!i5) break L7;
    i3 = i1 + i2 | 0;
    i2 = 0;
    while (1) {
     i7 = i1 + -1 | 0;
     HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
     HEAP8[i3 + -1 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i3 + -2 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i3 + -3 >> 0] = HEAP8[i7 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else {
      i3 = i3 + -4 | 0;
      i1 = i1 + -2 | 0;
     }
    }
   } else {
    i2 = i5 << 2;
    i1 = i3 + i2 + -1 | 0;
    if (!i5) break L7;
    i3 = i1;
    i1 = i1 + i2 | 0;
    i2 = 0;
    while (1) {
     HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
     i8 = i3 + -2 | 0;
     HEAP8[i1 + -1 >> 0] = HEAP8[i3 + -1 >> 0] | 0;
     HEAP8[i1 + -2 >> 0] = HEAP8[i8 >> 0] | 0;
     i7 = i3 + -3 | 0;
     HEAP8[i1 + -3 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i1 + -4 >> 0] = HEAP8[i8 >> 0] | 0;
     HEAP8[i1 + -5 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i1 + -6 >> 0] = HEAP8[i8 >> 0] | 0;
     HEAP8[i1 + -7 >> 0] = HEAP8[i7 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else {
      i3 = i3 + -4 | 0;
      i1 = i1 + -8 | 0;
     }
    }
   }
   break;
  }
 default:
  {}
 } while (0);
 i8 = i6 + 10 | 0;
 i1 = (HEAPU8[i8 >> 0] | 0) + 2 | 0;
 HEAP8[i8 >> 0] = i1;
 i8 = HEAP16[i4 >> 1] | 0;
 HEAP8[i4 >> 0] = i8 & 65535 | 2;
 i1 = Math_imul((i8 & 65535) >>> 8 & 65535, i1 & 255) | 0;
 HEAP8[i6 + 11 >> 0] = i1;
 i1 = i1 & 255;
 if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i5) | 0; else i1 = ((Math_imul(i1, i5) | 0) + 7 | 0) >>> 3;
 HEAP32[i6 + 4 >> 2] = i1;
 return;
}

function _fcntl(i15, i2, i1) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i17 + 152 | 0;
 i6 = i17 + 136 | 0;
 i16 = i17 + 120 | 0;
 i14 = i17 + 104 | 0;
 i13 = i17 + 96 | 0;
 i10 = i17 + 80 | 0;
 i9 = i17 + 64 | 0;
 i4 = i17 + 48 | 0;
 i11 = i17 + 32 | 0;
 i5 = i17 + 16 | 0;
 i3 = i17;
 i18 = i17 + 176 | 0;
 i8 = i17 + 168 | 0;
 HEAP32[i18 >> 2] = i1;
 i1 = (HEAP32[i18 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i18 >> 2] = i1 + 4;
 i12 = (i2 | 0) == 4 ? i12 | 32768 : i12;
 L1 : do switch (i2 | 0) {
 case 14:
  {
   HEAP32[i3 >> 2] = i15;
   HEAP32[i3 + 4 >> 2] = 14;
   HEAP32[i3 + 8 >> 2] = i12;
   i1 = ___syscall_ret(___syscall221(221, i3 | 0) | 0) | 0;
   break;
  }
 case 9:
  {
   HEAP32[i5 >> 2] = i15;
   HEAP32[i5 + 4 >> 2] = 16;
   HEAP32[i5 + 8 >> 2] = i8;
   i1 = ___syscall221(221, i5 | 0) | 0;
   switch (i1 | 0) {
   case -22:
    {
     HEAP32[i11 >> 2] = i15;
     HEAP32[i11 + 4 >> 2] = 9;
     HEAP32[i11 + 8 >> 2] = i12;
     i1 = ___syscall221(221, i11 | 0) | 0;
     break;
    }
   case 0:
    {
     i1 = HEAP32[i8 + 4 >> 2] | 0;
     i1 = (HEAP32[i8 >> 2] | 0) == 2 ? 0 - i1 | 0 : i1;
     break;
    }
   default:
    i1 = ___syscall_ret(i1) | 0;
   }
   break;
  }
 case 1030:
  {
   HEAP32[i4 >> 2] = i15;
   HEAP32[i4 + 4 >> 2] = 1030;
   HEAP32[i4 + 8 >> 2] = i12;
   i1 = ___syscall221(221, i4 | 0) | 0;
   if ((i1 | 0) != -22) {
    if ((i1 | 0) > -1) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i9 + 4 >> 2] = 2;
     HEAP32[i9 + 8 >> 2] = 1;
     ___syscall221(221, i9 | 0) | 0;
    }
    i1 = ___syscall_ret(i1) | 0;
    break L1;
   }
   HEAP32[i10 >> 2] = i15;
   HEAP32[i10 + 4 >> 2] = 1030;
   HEAP32[i10 + 8 >> 2] = 0;
   i1 = ___syscall221(221, i10 | 0) | 0;
   if ((i1 | 0) == -22) {
    HEAP32[i14 >> 2] = i15;
    HEAP32[i14 + 4 >> 2] = 0;
    HEAP32[i14 + 8 >> 2] = i12;
    i1 = ___syscall221(221, i14 | 0) | 0;
    if ((i1 | 0) > -1) {
     HEAP32[i16 >> 2] = i1;
     HEAP32[i16 + 4 >> 2] = 2;
     HEAP32[i16 + 8 >> 2] = 1;
     ___syscall221(221, i16 | 0) | 0;
    }
    i1 = ___syscall_ret(i1) | 0;
    break L1;
   } else {
    if ((i1 | 0) > -1) {
     HEAP32[i13 >> 2] = i1;
     ___syscall6(6, i13 | 0) | 0;
    }
    i1 = ___syscall_ret(-22) | 0;
    break L1;
   }
  }
 default:
  if ((i2 + -12 | 0) >>> 0 < 5) {
   HEAP32[i6 >> 2] = i15;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i12;
   i1 = ___syscall_ret(___syscall221(221, i6 | 0) | 0) | 0;
   break L1;
  } else {
   HEAP32[i7 >> 2] = i15;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i7 + 8 >> 2] = i12;
   i1 = ___syscall_ret(___syscall221(221, i7 | 0) | 0) | 0;
   break L1;
  }
 } while (0);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN17PxcPoolMallocDataD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (HEAP32[i5 + 876 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5 + 596 | 0);
 i3 = i5 + 860 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 864 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 868 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 600 | 0) == (i1 | 0)) {
   HEAP8[i5 + 856 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i5 + 580 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5 + 300 | 0);
 i3 = i5 + 564 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 568 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 572 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 304 | 0) == (i1 | 0)) {
   HEAP8[i5 + 560 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 if (HEAP32[i5 + 284 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5 + 4 | 0);
 i3 = i5 + 268 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i5 + 272 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 276 >> 2] | 0;
 do if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i5 + 8 | 0) == (i1 | 0)) {
   HEAP8[i5 + 264 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN14PhysicsManager20SetupDefaultMaterialEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i2 = i8;
 i4 = i5 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) HEAP32[i5 + 64 >> 2] = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 11; else {
     HEAP32[i5 + 64 >> 2] = i1;
     i2 = i1;
    }
   }
  }
  if ((i7 | 0) == 8) i7 = 11;
  if ((i7 | 0) == 11) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i5 + 64 >> 2] = i1;
   if (!i1) break; else i2 = i1;
  }
  i1 = HEAP32[gb + 1457408 >> 2] | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i6 | 0, 1, 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i2 + 52 >> 2] | 0;
   if (i1 | 0) i7 = 14;
  } else i7 = 14;
  if ((i7 | 0) == 14) {
   mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 40 >> 2]));
   mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 44 >> 2]));
   f10 = Math_fround(HEAPF32[i2 + 48 >> 2]);
   i9 = f10 < Math_fround(0.0);
   i7 = f10 > Math_fround(1.0);
   f10 = i7 ? Math_fround(1.0) : f10;
   mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i9 ? Math_fround(0.0) : f10));
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i2 + 32 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0);
  }
  STACKTOP = i8;
  return;
 } while (0);
 i9 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i6 | 0, 1, 0) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, .600000024);
 i9 = HEAP32[i6 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0, .600000024);
 i9 = HEAP32[i6 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i9 >> 2] | 0) + 44 >> 2] | 0, i9 | 0, 0.0);
 STACKTOP = i8;
 return;
}

function __ZN13GfxDeviceGLES19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i6 + 30 >> 0] | 0) if (HEAP8[i5 + 30 >> 0] | 0) {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1157724 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i2 = 0; else i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
  if ((i2 | 0) != 0 & (HEAP32[i6 + 36 >> 2] | 0) != 0) if (HEAP32[i1 >> 2] | 0) {
   i4 = i1 + 8 | 0;
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i7 + 7336 | 0;
   i3 = i1;
   i9 = HEAP32[i3 + 4 >> 2] | 0;
   if (i9 >>> 0 < i2 >>> 0 | ((i9 | 0) == (i2 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0 : 0)) {
    i9 = HEAP32[i7 + 4860 >> 2] | 0;
    i4 = i7 + 5480 | 0;
    mftCall_vi(i9 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i4 >> 2] | 0, 9) | 0);
    i9 = i7 + 7368 | 0;
    i3 = i9;
    i2 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    i11 = _i64Add(i2 | 0, i3 | 0, 1, 0) | 0;
    i10 = getTempRet0() | 0;
    HEAP32[i9 >> 2] = i11;
    HEAP32[i9 + 4 >> 2] = i10;
    i9 = i1;
    HEAP32[i9 >> 2] = i2;
    HEAP32[i9 + 4 >> 2] = i3;
    i4 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i4 >> 2] | 0, 9) | 0);
    i9 = i7 + 7376 | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & i4;
   }
   i11 = i7 + 4616 | 0;
   __ZN18GfxFramebufferGLES7PrepareEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i11 >> 2] | 0) | 0);
   __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i11 >> 2] | 0) | 0, i5, i6);
   STACKTOP = i8;
   return;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 604202 | 0, 0, gb + 603515 | 0, 878, 512, 0, 0, 0);
  STACKTOP = i8;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 604157 | 0, 0, gb + 603515 | 0, 870, 512, 0, 0, 0);
 STACKTOP = i8;
 return;
}

function __ZN11MemoryStats11DeserializeEPPib(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2] << 10;
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2] << 10;
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2] << 10;
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2] << 10;
 HEAP32[i6 + 16 >> 2] = HEAP32[i1 + 16 >> 2] << 10;
 HEAP32[i6 + 20 >> 2] = HEAP32[i1 + 20 >> 2] << 10;
 HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2] << 10;
 HEAP32[i6 + 28 >> 2] = HEAP32[i1 + 28 >> 2] << 10;
 HEAP32[i6 + 32 >> 2] = HEAP32[i1 + 32 >> 2] << 10;
 HEAP32[i6 + 36 >> 2] = HEAP32[i1 + 36 >> 2] << 10;
 HEAP32[i6 + 40 >> 2] = HEAP32[i1 + 40 >> 2] << 10;
 HEAP32[i6 + 44 >> 2] = HEAP32[i1 + 44 >> 2] << 10;
 HEAP32[i6 + 48 >> 2] = HEAP32[i1 + 48 >> 2] << 10;
 HEAP32[i6 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i6 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i6 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i6 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i6 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i6 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i6 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i6 + 84 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i6 + 88 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i6 + 92 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i6 + 96 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i6 + 100 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i6 + 104 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i7 >> 2] = i1 + 112;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = i6 + 188 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i4, i1, i3, 1);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != -1) do {
  i8 = i3;
  i3 = i3 + 8 | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i1 >> 2];
  i1 = i8 + 12 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = HEAP32[i3 >> 2] | 0;
 } while ((i2 | 0) != -1);
 HEAP32[i6 + 124 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 128 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 132 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 136 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i6 + 140 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i6 + 144 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i6 + 148 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i6 + 152 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i6 + 156 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i6 + 160 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i6 + 164 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i6 + 168 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i6 + 172 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i6 + 176 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i6 + 180 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i6 + 184 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i7 >> 2] = i1 + 64;
 STACKTOP = i5;
 return;
}

function __ZL30GeomMTDCallback_CapsuleCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 28 | 0;
 i8 = i7;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 f10 = Math_fround(f16 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f13 = Math_fround(f12 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f16 * f10) + Math_fround(Math_fround(f12 * f13) + Math_fround(-1.0)));
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f15 = Math_fround(f16 * f13);
 f18 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f10 * f18));
 f18 = Math_fround(Math_fround(f10 * f16) - Math_fround(f13 * f18));
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(f13 * f12);
 f15 = Math_fround(f13 * f15);
 f18 = Math_fround(f13 * f18);
 f13 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f16 = Math_fround(f13 + f12);
 f10 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f14 = Math_fround(f10 + f15);
 f11 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f17 = Math_fround(f18 + f11);
 HEAPF32[i9 >> 2] = f16;
 HEAPF32[i9 + 4 >> 2] = f14;
 HEAPF32[i9 + 8 >> 2] = f17;
 f15 = Math_fround(f10 - f15);
 f18 = Math_fround(f11 - f18);
 HEAPF32[i9 + 12 >> 2] = Math_fround(f13 - f12);
 HEAPF32[i9 + 16 >> 2] = f15;
 HEAPF32[i9 + 20 >> 2] = f18;
 HEAP32[i9 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(f18 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f13 = Math_fround(f12 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f12 * f13) + Math_fround(-1.0)));
 f18 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f11 = Math_fround(f18 * f13);
 f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f15 * f10));
 f10 = Math_fround(Math_fround(f15 * f18) - Math_fround(f13 * f10));
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f13 * f12);
 f11 = Math_fround(f13 * f11);
 f10 = Math_fround(f13 * f10);
 f13 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f18 = Math_fround(f13 + f12);
 f15 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f17 = Math_fround(f15 + f11);
 f14 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f16 = Math_fround(f10 + f14);
 HEAPF32[i8 >> 2] = f18;
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 f11 = Math_fround(f15 - f11);
 f10 = Math_fround(f14 - f10);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f13 - f12);
 HEAPF32[i8 + 16 >> 2] = f11;
 HEAPF32[i8 + 20 >> 2] = f10;
 HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 4 >> 2];
 i6 = __ZN5physx2Gu25computeMTD_CapsuleCapsuleERNS_6PxVec3ERfRKNS0_7CapsuleES6_(i4, i1, i9, i8) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZL24AssignProjectorQueuesJobP30AssignProjectorQueuesJobHeader(i20) {
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 4 | 0;
 i1 = i21;
 if ((HEAP16[gb + 1114908 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114908 | 0, i19);
  i14 = gb + 1114908 | 0;
 } else i14 = 0;
 i3 = HEAP32[i20 + 4 >> 2] | 0;
 i17 = i3 + 8 | 0;
 i18 = HEAP32[(HEAP32[i17 >> 2] | 0) + 1832 >> 2] | 0;
 i4 = HEAP32[i20 + 12 >> 2] | 0;
 i15 = HEAP32[i20 + 16 >> 2] | 0;
 i2 = HEAP32[i20 + 8 >> 2] | 0;
 HEAP32[i19 >> 2] = 0;
 i16 = i19 + 4 | 0;
 i11 = gb + 63160 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i16;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 do if (!i2) i1 = 0; else if (i2 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 387960 | 0, 900) | 0;
  i12 = gb + 64016 | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i19 >> 2] = i1;
  i13 = i16;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i13 + 4 >> 2] = i12;
  break;
 } while (0);
 _memset(i1 | 0, 0, i2 | 0) | 0;
 i11 = HEAP32[i3 + 180 >> 2] | 0;
 if (i11 | 0) {
  i12 = HEAP32[i18 + 32804 >> 2] | 0;
  i13 = HEAP32[i3 + 168 >> 2] | 0;
  i8 = HEAP32[i3 + 108 >> 2] | 0;
  i9 = HEAP32[i20 >> 2] | 0;
  i10 = i18 + 32808 | 0;
  i2 = i12;
  i7 = 0;
  do {
   i3 = HEAP32[i13 + (i7 * 12 | 0) + 4 >> 2] | 0;
   i6 = (i7 >>> 0) / (i15 >>> 0) | 0;
   i5 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
   i6 = i1 + i6 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) {
    HEAP32[i5 + 176 >> 2] = i2;
    HEAP32[i5 + 180 >> 2] = i4;
    HEAP8[i6 >> 0] = 1;
   }
   i5 = HEAP16[i8 + (i3 << 5) + 12 >> 1] | 0;
   L17 : do if ((i5 | 0) > (i4 | 0)) if (!(HEAP8[(HEAP32[i17 >> 2] | 0) + 1825 >> 0] | 0)) {
    i3 = (HEAP32[i10 >> 2] | 0) + i12 | 0;
    if (i2 >>> 0 < i3 >>> 0) {
     i4 = HEAP32[i18 >> 2] | 0;
     while (1) {
      if ((HEAP32[i4 + (i2 * 360 | 0) + 240 >> 2] | 0) > (i5 | 0)) {
       i4 = i5;
       break L17;
      }
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 >= i3 >>> 0) {
       i4 = i5;
       break;
      }
     }
    } else i4 = i5;
   } else i4 = i5; while (0);
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i11 >>> 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i20, gb + 64024 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i19 >> 2] | 0, i16);
 if (!i14) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i21;
 return;
}

function __ZNK13b2DynamicTree5QueryI19b2WorldQueryWrapperEEvPT_RK6b2AABB(i1, i12, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i17 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i17;
 i14 = i16 + 1028 | 0;
 i15 = i16 + 1032 | 0;
 HEAP32[i15 >> 2] = 256;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 >> 2] = 1;
 i10 = i1 + 4 | 0;
 i11 = i13 + 4 | 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 12 | 0;
 i9 = i12 + 4 | 0;
 i1 = 1;
 i2 = i17;
 L1 : while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i14 >> 2] = i1;
  i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  do if ((i5 | 0) != -1) {
   i6 = HEAP32[i10 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i13 >> 2]);
   f22 = Math_fround(f22 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 8 >> 2]));
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 12 >> 2]));
   f20 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) >> 2]);
   f20 = Math_fround(f20 - Math_fround(HEAPF32[i7 >> 2]));
   f19 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 4 >> 2]);
   if (!(f22 > Math_fround(0.0) | f21 > Math_fround(0.0) | f20 > Math_fround(0.0) | Math_fround(f19 - Math_fround(HEAPF32[i8 >> 2])) > Math_fround(0.0))) {
    i3 = i6 + (i5 * 36 | 0) + 24 | 0;
    if ((HEAP32[i3 >> 2] | 0) == -1) {
     i6 = HEAP32[i9 >> 2] | 0;
     if (!(mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0) + (i5 * 36 | 0) + 16 >> 2] | 0) + 16 >> 2] | 0) | 0)) break L1;
     i1 = HEAP32[i14 >> 2] | 0;
     break;
    }
    if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
     HEAP32[i15 >> 2] = i1 << 1;
     i4 = __Z7b2Alloci(i1 << 3) | 0;
     HEAP32[i16 >> 2] = i4;
     _memcpy(i4 | 0, i2 | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
     if ((i2 | 0) != (i17 | 0)) __Z6b2FreePv(i2);
    }
    i4 = HEAP32[i16 >> 2] | 0;
    HEAP32[i4 + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    HEAP32[i14 >> 2] = i2;
    i1 = i6 + (i5 * 36 | 0) + 28 | 0;
    if ((i2 | 0) == (HEAP32[i15 >> 2] | 0)) {
     HEAP32[i15 >> 2] = i2 << 1;
     i6 = __Z7b2Alloci(i2 << 3) | 0;
     HEAP32[i16 >> 2] = i6;
     _memcpy(i6 | 0, i4 | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
     if ((i4 | 0) != (i17 | 0)) __Z6b2FreePv(i4);
    }
    HEAP32[(HEAP32[i16 >> 2] | 0) + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i1 >> 2];
    i1 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    HEAP32[i14 >> 2] = i1;
   }
  } while (0);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i18;
  return;
 }
 __Z6b2FreePv(i1);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i5);
 i1 = i8 + 56 | 0;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i8 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i8 + 92 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i5 = i8 + 112 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i1 = i8 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZNK15LODGroupManager17CalculateLODMasksERK13LODParametersfPhPf(i4, i8, f7, i14, i15) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 f7 = Math_fround(f7);
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 4 | 0;
 i2 = i16;
 if ((HEAP16[gb + 1161208 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161208 | 0, i1);
  i13 = gb + 1161208 | 0;
 } else i13 = 0;
 f3 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 i1 = (HEAP8[i8 >> 0] | 0) == 0;
 if (i1) f3 = Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i8 + 16 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)) * Math_fround(.5))));
 f3 = Math_fround(f3 * Math_fround(2.0));
 f3 = Math_fround(f3 / Math_fround(HEAPF32[i4 + 24 >> 2]));
 i9 = i4 + 4 | 0;
 i10 = HEAP32[i4 + 16 >> 2] | 0;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 i11 = i4 + 28 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i12 = 1 << (i2 >>> 0 > 7 ? 7 : i2) & 255;
 f7 = Math_fround(f7 / Math_fround(HEAPF32[i4 + 32 >> 2]));
 L7 : do if (i1) {
  f3 = Math_fround(f3 * f3);
  if (i10 >>> 0 > 1) {
   i5 = i8 + 4 | 0;
   i6 = i8 + 8 | 0;
   i4 = i8 + 12 | 0;
   i1 = 1;
   while (1) {
    i22 = HEAP32[i9 >> 2] | 0;
    i8 = i22 + (i1 * 96 | 0) | 0;
    f21 = Math_fround(HEAPF32[i8 >> 2]);
    f20 = Math_fround(HEAPF32[i22 + (i1 * 96 | 0) + 4 >> 2]);
    f17 = Math_fround(HEAPF32[i22 + (i1 * 96 | 0) + 8 >> 2]);
    f19 = Math_fround(HEAPF32[i5 >> 2]);
    f18 = Math_fround(HEAPF32[i6 >> 2]);
    f19 = Math_fround(f21 - f19);
    f18 = Math_fround(f20 - f18);
    f17 = Math_fround(f17 - Math_fround(HEAPF32[i4 >> 2]));
    __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb(i8, Math_fround(Math_sqrt(Math_fround(f3 * Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f18 * f18)) + Math_fround(f17 * f17))))), i2, i12, f7, i14 + i1 | 0, i15 + (i1 << 2) | 0, 0);
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i10 | 0)) break L7;
    i2 = HEAP32[i11 >> 2] | 0;
   }
  }
 } else if (i10 >>> 0 > 1) {
  __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb((HEAP32[i9 >> 2] | 0) + 96 | 0, f3, i2, i12, f7, i14 + 1 | 0, i15 + 4 | 0, 0);
  if ((i10 | 0) != 2) {
   i1 = 2;
   do {
    __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb((HEAP32[i9 >> 2] | 0) + (i1 * 96 | 0) | 0, f3, HEAP32[i11 >> 2] | 0, i12, f7, i14 + i1 | 0, i15 + (i1 << 2) | 0, 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i10 | 0));
  }
 } while (0);
 if (!i13) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sn29setMissingPropertiesToDefaultEPNS0_7XmlNodeERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEjRNS_7profile14ProfileHashMapIPKcjNS_6shdfnd4HashISB_EEEE(i11, i9, i8, i2, i6) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i1 = HEAP32[i11 + 16 >> 2] | 0;
 if (i1 | 0) do {
  __ZN5physx2Sn29setMissingPropertiesToDefaultEPNS0_7XmlNodeERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEjRNS_7profile14ProfileHashMapIPKcjNS_6shdfnd4HashISB_EEEE(i1, i9, i8, i2, i6);
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i4 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i5 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = 5381; else {
  i2 = 5381;
  i3 = i5;
  do {
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i1 = i2;
 }
 i2 = HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  STACKTOP = i12;
  return;
 }
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 while (1) {
  i1 = i4 + (i2 << 3) | 0;
  if (!(_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0)) break;
  i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   i7 = 23;
   break;
  }
 }
 if ((i7 | 0) == 23) {
  STACKTOP = i12;
  return;
 }
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 52 >> 2] | 0, i9 | 0, i11 | 0);
 _memset(i10 | 0, 0, 512) | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i7 = _strlen(i6) | 0;
 i2 = i8 + (HEAP32[i4 + (i2 << 3) + 4 >> 2] << 3) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(_strncmp(i1, i6, i7) | 0)) {
  i6 = i7 + 1 | 0;
  do {
   i1 = i1 + i6 | 0;
   mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 44 >> 2] | 0, i9 | 0);
   if (HEAP8[i1 >> 0] | 0) {
    i4 = 0;
    do {
     i5 = i1;
     L31 : while (1) {
      i3 = i5 + 1 | 0;
      switch (HEAP8[i3 >> 0] | 0) {
      case 46:
      case 0:
       break L31;
      default:
       i5 = i3;
      }
     }
     i8 = i3 - i1 | 0;
     i8 = (i8 | 0) < 1023 ? i8 : 1023;
     _memcpy(i10 | 0, i1 | 0, i8 | 0) | 0;
     HEAP8[i10 + i8 >> 0] = 0;
     if (!(mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, i10 | 0) | 0)) {
      mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 56 >> 2] | 0, i9 | 0, i10 | 0);
      i4 = 1;
     }
     i1 = (HEAP8[i3 >> 0] | 0) == 0 ? i3 : i5 + 2 | 0;
    } while ((HEAP8[i1 >> 0] | 0) != 0);
    if (i4) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2] | 0, i9 | 0, HEAP32[i2 + 4 >> 2] | 0);
   }
   mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0, i9 | 0);
   i2 = i2 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } while (!(_strncmp(i1, HEAP32[i11 >> 2] | 0, i7) | 0));
 }
 STACKTOP = i12;
 return;
}

function __ZN11b2RopeJoint24SolveVelocityConstraintsERK12b2SolverData(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0;
 i12 = i5 + 96 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i16 = i2 + 28 | 0;
 i24 = HEAP32[i16 >> 2] | 0;
 i19 = i24 + (i7 * 12 | 0) | 0;
 f20 = Math_fround(HEAPF32[i19 >> 2]);
 i4 = i24 + (i7 * 12 | 0) + 4 | 0;
 f21 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(HEAPF32[i24 + (i7 * 12 | 0) + 8 >> 2]);
 i7 = i5 + 100 | 0;
 i23 = HEAP32[i7 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) >> 2]);
 f9 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i24 + (i23 * 12 | 0) + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 116 >> 2]);
 f22 = Math_fround(f6 * f11);
 f13 = Math_fround(HEAPF32[i5 + 112 >> 2]);
 f22 = Math_fround(f20 - f22);
 f1 = Math_fround(f21 + Math_fround(f6 * f13));
 f14 = Math_fround(HEAPF32[i5 + 124 >> 2]);
 f18 = Math_fround(f10 * f14);
 f15 = Math_fround(HEAPF32[i5 + 120 >> 2]);
 f18 = Math_fround(f8 - f18);
 f17 = Math_fround(f9 + Math_fround(f10 * f15));
 f3 = Math_fround(HEAPF32[i5 + 88 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i5 + 84 >> 2]));
 f22 = Math_fround(f18 - f22);
 f1 = Math_fround(f17 - f1);
 f17 = Math_fround(HEAPF32[i5 + 104 >> 2]);
 f22 = Math_fround(f22 * f17);
 f18 = Math_fround(HEAPF32[i5 + 108 >> 2]);
 f1 = Math_fround(f22 + Math_fround(f1 * f18));
 if (f3 < Math_fround(0.0)) f1 = Math_fround(f1 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f22 = Math_fround(f1 * Math_fround(HEAPF32[i5 + 160 >> 2]));
 i23 = i5 + 92 | 0;
 f1 = Math_fround(HEAPF32[i23 >> 2]);
 f22 = Math_fround(f1 - f22);
 i24 = f22 > Math_fround(0.0);
 f22 = i24 ? Math_fround(0.0) : f22;
 HEAPF32[i23 >> 2] = f22;
 f1 = Math_fround(f22 - f1);
 f22 = Math_fround(f17 * f1);
 f1 = Math_fround(f18 * f1);
 f17 = Math_fround(HEAPF32[i5 + 144 >> 2]);
 f3 = Math_fround(f20 - Math_fround(f17 * f22));
 f17 = Math_fround(f21 - Math_fround(f17 * f1));
 f18 = Math_fround(f6 - Math_fround(Math_fround(HEAPF32[i5 + 152 >> 2]) * Math_fround(Math_fround(f1 * f13) - Math_fround(f22 * f11))));
 f21 = Math_fround(HEAPF32[i5 + 148 >> 2]);
 f20 = Math_fround(f8 + Math_fround(f22 * f21));
 f21 = Math_fround(f9 + Math_fround(f1 * f21));
 f22 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i5 + 156 >> 2]) * Math_fround(Math_fround(f1 * f15) - Math_fround(f22 * f14))));
 HEAPF32[i19 >> 2] = f3;
 HEAPF32[i4 >> 2] = f17;
 i23 = HEAP32[i16 >> 2] | 0;
 HEAPF32[i23 + ((HEAP32[i12 >> 2] | 0) * 12 | 0) + 8 >> 2] = f18;
 i24 = HEAP32[i7 >> 2] | 0;
 HEAPF32[i23 + (i24 * 12 | 0) >> 2] = f20;
 HEAPF32[i23 + (i24 * 12 | 0) + 4 >> 2] = f21;
 HEAPF32[(HEAP32[i16 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 12 | 0) + 8 >> 2] = f22;
 return;
}

function __ZL22ScheduleSceneNodesJobsP25ScheduleSceneNodesJobDataj(i19, i20) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i21 + 4 | 0;
 i2 = i21;
 if ((HEAP16[gb + 1110692 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110692 | 0, i1);
  i15 = gb + 1110692 | 0;
 } else i15 = 0;
 i16 = i19 + 2736 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i17 = i1 + 16 + (i20 * 12 | 0) | 0;
 i18 = i19 + (i20 * 532 | 0) | 0;
 i2 = HEAP32[i1 + 16 + (i20 * 12 | 0) + 4 >> 2] | 0;
 if (!i2) {
  HEAP32[i19 + (i20 * 532 | 0) + 348 >> 2] = 0;
  __Z21ClearFenceWithoutSyncR8JobFence(i19 + 2660 + (i20 << 3) | 0);
 } else {
  i14 = HEAP32[i1 + 1136 + (i20 * 12 | 0) + 4 >> 2] | 0;
  i2 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i19 + (i20 * 532 | 0) + 340 | 0, i2, 500) | 0;
  if ((i2 | 0) > 0) {
   i3 = i19 + (i20 * 532 | 0) + 4 | 0;
   i4 = i19 + (i20 * 532 | 0) + 8 | 0;
   i5 = i19 + 2720 | 0;
   i6 = i19 + (i20 * 532 | 0) + 16 | 0;
   i7 = i19 + 2700 + (i20 << 2) | 0;
   i8 = i19 + (i20 * 532 | 0) + 12 | 0;
   i1 = 0;
   do {
    i9 = HEAP32[i19 + (i20 * 532 | 0) + 340 + (i1 * 12 | 0) + 4 >> 2] | 0;
    HEAP32[i18 >> 2] = i17;
    HEAP32[i3 >> 2] = i14;
    HEAP32[i4 >> 2] = HEAP32[i16 >> 2];
    i10 = i19 + (i20 * 532 | 0) + 20 + (i1 * 20 | 0) | 0;
    i11 = i19 + (i20 * 532 | 0) + 20 + (i1 * 20 | 0) + 4 | 0;
    i22 = gb + 64024 | 0;
    i13 = HEAP32[i22 + 4 >> 2] | 0;
    i12 = i11;
    HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
    HEAP32[i12 + 4 >> 2] = i13;
    i12 = i19 + (i20 * 532 | 0) + 20 + (i1 * 20 | 0) + 16 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    do if ((i13 & 2147483647) >>> 0 < i9 >>> 0) if ((i13 | 0) > -1) {
     HEAP32[i12 >> 2] = i9;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i9 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i22 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i22 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i19 + (i20 * 532 | 0) + 20 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i9;
     HEAP32[i10 >> 2] = i22;
     break;
    } while (0);
    HEAP32[i6 >> 2] = i5;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i19 + 2660 + (i20 << 3) | 0, fb + 2374 | 0, i18, i2, 0, 0);
 }
 if (!i15) {
  STACKTOP = i21;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i21;
 return;
}

function __ZN22ForwardLinearAllocator8allocateEjj(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i3 + 8 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i7 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 72;
  HEAP32[i8 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  i10 = i7 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = i3;
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i6 = HEAP32[i3 + 16 >> 2] | 0;
  i6 = i6 >>> 0 < i4 >>> 0 ? i4 : i6;
  i11 = i3 + 20 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i8;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i2 + 4 >> 2] = i11;
  i2 = i7 + 20 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i2 + 4 >> 2] = i11;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i8, 0, gb + 462401 | 0, 31) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i7 + 12 >> 2] = i2;
  HEAP32[i7 + 16 >> 2] = i6;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = (i7 + -1 | i1 + -1) + (1 - i7) | 0;
 i2 = i1 + i4 | 0;
 if (i2 >>> 0 <= ((HEAP32[i6 + 16 >> 2] | 0) - i7 + (HEAP32[i6 + 8 >> 2] | 0) | 0) >>> 0) {
  i11 = i6;
  i12 = i7;
  i11 = i11 + 12 | 0;
  i10 = i12 + i2 | 0;
  HEAP32[i11 >> 2] = i10;
  i12 = i12 + i1 | 0;
  STACKTOP = i9;
  return i12 | 0;
 }
 i12 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 72;
 HEAP32[i8 + 4 >> 2] = i12;
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i7 = i12 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = i3;
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i3 >> 2] = i12;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i11 = HEAP32[i3 + 16 >> 2] | 0;
 i11 = i11 >>> 0 < i4 >>> 0 ? i4 : i11;
 i6 = i3 + 20 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = i12 + 20 | 0;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i8, 0, gb + 462401 | 0, 31) | 0;
 HEAP32[i7 >> 2] = i10;
 HEAP32[i12 + 12 >> 2] = i10;
 HEAP32[i12 + 16 >> 2] = i11;
 i12 = HEAP32[i3 >> 2] | 0;
 i11 = i12;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 i11 = i11 + 12 | 0;
 i10 = i12 + i2 | 0;
 HEAP32[i11 >> 2] = i10;
 i12 = i12 + i1 | 0;
 STACKTOP = i9;
 return i12 | 0;
}

function __ZN13WebCamTexture16EnsureUniqueNameER16MonoWebCamDeviceRKNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier56ELi16EEEE(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i24;
 i15 = i24 + 16 | 0;
 i16 = i24 + 4 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i16, HEAP32[i11 >> 2] | 0);
 i17 = i15 + 11 | 0;
 i18 = i15 + 4 | 0;
 i19 = i12 + 4 | 0;
 i20 = i15 + 11 | 0;
 i21 = i15 + 4 | 0;
 i13 = i16 + 11 | 0;
 i14 = i16 + 4 | 0;
 i10 = 0;
 while (1) {
  if ((i10 | 0) > 0) {
   HEAP32[i22 >> 2] = i10;
   __Z6FormatPKcz(i15, gb + 364129 | 0, i22);
   i9 = HEAP8[i17 >> 0] | 0;
   i8 = i9 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i16, i8 ? HEAP32[i15 >> 2] | 0 : i15, i8 ? HEAP32[i18 >> 2] | 0 : i9 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i19 >> 2] | 0;
  L6 : do if ((i1 | 0) != (i9 | 0)) {
   L7 : while (1) {
    __Z24scripting_cpp_string_forP12Il2CppString(i15, HEAP32[i1 >> 2] | 0);
    i3 = HEAP8[i20 >> 0] | 0;
    i5 = i3 << 24 >> 24 < 0;
    i3 = i3 & 255;
    i6 = i5 ? HEAP32[i21 >> 2] | 0 : i3;
    i8 = HEAP8[i13 >> 0] | 0;
    i2 = i8 << 24 >> 24 < 0;
    do if ((i6 | 0) == ((i2 ? HEAP32[i14 >> 2] | 0 : i8 & 255) | 0)) {
     i7 = HEAP32[i15 >> 2] | 0;
     i8 = i5 ? i7 : i15;
     i2 = i2 ? HEAP32[i16 >> 2] | 0 : i16;
     i4 = (i6 | 0) == 0;
     if (i5) {
      if (i4) break L7;
      i8 = (_memcmp(i8, i2, i6) | 0) == 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
      if (i8) break L6; else break;
     }
     if (i4) break L7;
     if ((i7 & 255) << 24 >> 24 == (HEAP8[i2 >> 0] | 0)) {
      i4 = i15;
      while (1) {
       i3 = i3 + -1 | 0;
       i4 = i4 + 1 | 0;
       if (!i3) break L7;
       i2 = i2 + 1 | 0;
       if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
        i23 = 13;
        break;
       }
      }
     } else i23 = 13;
    } else i23 = 13; while (0);
    if ((i23 | 0) == 13) {
     i23 = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
    }
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break L6;
    }
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i15);
  } while (0);
  if ((i1 | 0) == (HEAP32[i19 >> 2] | 0)) break; else i10 = i10 + 1 | 0;
 }
 HEAP32[i11 >> 2] = __Z20scripting_string_newPKc((HEAP8[i13 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 STACKTOP = i24;
 return;
}

function _vstrfmon_l(i11, i2, i3, i9) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, d14 = 0.0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 L1 : do if (!i2) {
  i1 = i11;
  i12 = 21;
 } else {
  i1 = i11;
  L2 : while (1) {
   i4 = HEAP8[i3 >> 0] | 0;
   switch (i4 << 24 >> 24) {
   case 0:
    {
     i12 = 21;
     break L1;
    }
   case 37:
    {
     i3 = i3 + 1 | 0;
     i5 = HEAP8[i3 >> 0] | 0;
     if (i5 << 24 >> 24 == 37) {
      i4 = 37;
      i12 = 3;
     } else {
      i4 = 0;
      L6 : while (1) {
       i6 = i5 << 24 >> 24;
       switch (i6 | 0) {
       case 61:
        {
         i3 = i3 + 1 | 0;
         break;
        }
       case 33:
       case 43:
       case 40:
       case 94:
        break;
       case 45:
        {
         i4 = 1;
         break;
        }
       default:
        break L6;
       }
       i5 = i3 + 1 | 0;
       i3 = i5;
       i5 = HEAP8[i5 >> 0] | 0;
      }
      i7 = i6 + -48 | 0;
      if (i7 >>> 0 < 10) {
       i6 = 0;
       do {
        i6 = i7 + (i6 * 10 | 0) | 0;
        i3 = i3 + 1 | 0;
        i5 = HEAP8[i3 >> 0] | 0;
        i7 = (i5 << 24 >> 24) + -48 | 0;
       } while (i7 >>> 0 < 10);
      } else i6 = 0;
      if (i5 << 24 >> 24 == 35) {
       i3 = i3 + 1 | 0;
       i5 = HEAP8[i3 >> 0] | 0;
       i8 = (i5 << 24 >> 24) + -48 | 0;
       if (i8 >>> 0 < 10) {
        i7 = 0;
        do {
         i7 = i8 + (i7 * 10 | 0) | 0;
         i3 = i3 + 1 | 0;
         i5 = HEAP8[i3 >> 0] | 0;
         i8 = (i5 << 24 >> 24) + -48 | 0;
        } while (i8 >>> 0 < 10);
       } else i7 = 0;
      } else i7 = 0;
      if (i5 << 24 >> 24 == 46) {
       i3 = i3 + 1 | 0;
       i8 = (HEAP8[i3 >> 0] | 0) + -48 | 0;
       if (i8 >>> 0 < 10) {
        i5 = 0;
        do {
         i5 = i8 + (i5 * 10 | 0) | 0;
         i3 = i3 + 1 | 0;
         i8 = (HEAP8[i3 >> 0] | 0) + -48 | 0;
        } while (i8 >>> 0 < 10);
       } else i5 = 0;
      } else i5 = 2;
      i8 = i7 + 1 + i5 | 0;
      i7 = (HEAP32[i9 >> 2] | 0) + (8 - 1) & ~(8 - 1);
      d14 = +HEAPF64[i7 >> 3];
      HEAP32[i9 >> 2] = i7 + 8;
      HEAP32[i10 >> 2] = (i4 | 0) == 0 & (i6 | 0) > (i8 | 0) ? i6 : i8;
      HEAP32[i10 + 4 >> 2] = i5;
      HEAPF64[i10 + 8 >> 3] = d14;
      i4 = _snprintf(i1, i2, gb + 1073773 | 0, i10) | 0;
      if (i2 >>> 0 <= i4 >>> 0) break L2;
      i1 = i1 + i4 | 0;
      i2 = i2 - i4 | 0;
     }
     break;
    }
   default:
    i12 = 3;
   }
   if ((i12 | 0) == 3) {
    i12 = 0;
    HEAP8[i1 >> 0] = i4;
    i1 = i1 + 1 | 0;
    i2 = i2 + -1 | 0;
   }
   if (!i2) {
    i12 = 21;
    break L1;
   } else i3 = i3 + 1 | 0;
  }
  HEAP32[(___errno_location() | 0) >> 2] = 7;
  i1 = -1;
 } while (0);
 if ((i12 | 0) == 21) i1 = i1 - i11 | 0;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
 i4 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i7 + 11 >> 0] = i4;
  if (!i4) i1 = i7; else {
   i1 = i7;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i6 = i4 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 i1 = i7 + 20 | 0;
 i2 = i8 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i7 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i4 = i8 + 24 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 36 | 0;
 if (i5 | 0) {
  if (i6 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i5 = __Znwj(i5) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 + 28 >> 2] = i5 + (i6 * 36 | 0);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 }
 i1 = i7 + 32 | 0;
 i2 = i8 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i7 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = 0;
 i4 = i8 + 36 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = (i5 | 0) / 36 | 0;
 if (!i5) {
  i7 = i7 + 44 | 0;
  i8 = i8 + 44 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
 if (i6 >>> 0 > 119304647) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i5 = __Znwj(i5) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i7 + 40 >> 2] = i5 + (i6 * 36 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 i7 = i7 + 44 | 0;
 i8 = i8 + 44 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i4 = i11 + 8 | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[HEAP32[i3 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i4) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i9 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i1 * 40 | 0, 4) | 0;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 }
 HEAP32[i2 >> 2] = i1;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + ((HEAP32[HEAP32[i3 >> 2] >> 2] | 0) * 40 | 0) | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905989 | 0, 0, 1) | 0;
  i4 = i12 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i12 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i6 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 905989 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function _getopt(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 4 | 0;
 i5 = i10;
 i1 = HEAP32[gb + 191400 >> 2] | 0;
 if ((i1 | 0) == 0 | (HEAP32[gb + 1469520 >> 2] | 0) != 0) {
  HEAP32[gb + 1469520 >> 2] = 0;
  HEAP32[gb + 1469524 >> 2] = 0;
  HEAP32[gb + 191400 >> 2] = 1;
  i1 = 1;
 }
 L4 : do if ((i1 | 0) < (i7 | 0)) {
  i2 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
  if (!i2) i1 = -1; else if ((HEAP8[i2 >> 0] | 0) == 45) {
   switch (HEAP8[i2 + 1 >> 0] | 0) {
   case 0:
    {
     i1 = -1;
     break L4;
    }
   case 45:
    {
     if (!(HEAP8[i2 + 2 >> 0] | 0)) {
      HEAP32[gb + 191400 >> 2] = i1 + 1;
      i1 = -1;
      break L4;
     }
     break;
    }
   default:
    {}
   }
   i1 = HEAP32[gb + 1469524 >> 2] | 0;
   if (!i1) {
    HEAP32[gb + 1469524 >> 2] = 1;
    i1 = 1;
   }
   i1 = _mbtowc(i6, i2 + i1 | 0, 4) | 0;
   if ((i1 | 0) < 0) {
    HEAP32[i6 >> 2] = 65533;
    i3 = 1;
    i2 = 65533;
   } else {
    i3 = i1;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i1 = HEAP32[gb + 191400 >> 2] | 0;
   i11 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   i12 = HEAP32[gb + 1469524 >> 2] | 0;
   i4 = i11 + i12 | 0;
   HEAP32[gb + 1469528 >> 2] = i2;
   i2 = i12 + i3 | 0;
   HEAP32[gb + 1469524 >> 2] = i2;
   if (!(HEAP8[i11 + i2 >> 0] | 0)) {
    HEAP32[gb + 191400 >> 2] = i1 + 1;
    HEAP32[gb + 1469524 >> 2] = 0;
   }
   i1 = _mbtowc(i5, i9, 4) | 0;
   L22 : do if (!i1) i2 = 0; else {
    i2 = 0;
    do {
     if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) break L22;
     i2 = ((i1 | 0) < 1 ? 1 : i1) + i2 | 0;
     i1 = _mbtowc(i5, i9 + i2 | 0, 4) | 0;
    } while ((i1 | 0) != 0);
   } while (0);
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) != (HEAP32[i6 >> 2] | 0)) {
    if (!((HEAP8[i9 >> 0] | 0) != 58 & (HEAP32[gb + 191404 >> 2] | 0) != 0)) {
     i1 = 63;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    _write(2, i1, _strlen(i1) | 0) | 0;
    _write(2, gb + 1073783 | 0, 18) | 0;
    _write(2, i4, i3) | 0;
    _write(2, gb + 1074320 | 0, 1) | 0;
    i1 = 63;
    break;
   }
   if ((HEAP8[i9 + (i2 + 1) >> 0] | 0) == 58) {
    i2 = HEAP32[gb + 191400 >> 2] | 0;
    if ((i2 | 0) < (i7 | 0)) {
     HEAP32[gb + 191400 >> 2] = i2 + 1;
     HEAP32[gb + 1469532 >> 2] = (HEAP32[i8 + (i2 << 2) >> 2] | 0) + (HEAP32[gb + 1469524 >> 2] | 0);
     HEAP32[gb + 1469524 >> 2] = 0;
     break;
    }
    if ((HEAP8[i9 >> 0] | 0) == 58) i1 = 58; else if (!(HEAP32[gb + 191404 >> 2] | 0)) i1 = 63; else {
     i1 = HEAP32[i8 >> 2] | 0;
     _write(2, i1, _strlen(i1) | 0) | 0;
     _write(2, gb + 1073802 | 0, 31) | 0;
     _write(2, i4, i3) | 0;
     _write(2, gb + 1074320 | 0, 1) | 0;
     i1 = 63;
    }
   }
  } else i1 = -1;
 } else i1 = -1; while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -28 | 0;
  i5 = i1;
  i1 = i1 + -28 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -24 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -16 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -16 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -20 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -24 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i17 = i6 + -12 | 0;
  i7 = i5 + -12 | 0;
  HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i17 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i17 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i6 = (HEAP32[i13 >> 2] | 0) + -28 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __Z33CommandBuffer_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i10 = i13 + 40 | 0;
 i3 = i13 + 36 | 0;
 i11 = i13 + 8 | 0;
 i12 = i13 + 24 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i9) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 __ZNK11ICallString6ToUTF8Ev(i12, i3);
 i2 = (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i5 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i5 = 9;
  }
 } else i5 = 7;
 if ((i5 | 0) == 7) {
  i8 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i5 = 9;
 }
 if ((i5 | 0) == 9) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i9 + 164 | 0;
 i6 = i11 + 11 | 0;
 do if ((i1 | 0) != (i11 | 0)) {
  i8 = HEAP8[i6 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i11 >> 2] | 0 : i11;
  i8 = i4 ? HEAP32[i11 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i9 + 172 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i9 + 168 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i9 + 168 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i13;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i13;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_commandbuffer_lump_cpp() {
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 | 0, gb + 422878 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 8 | 0, gb + 422911 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 16 | 0, gb + 422943 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 24 | 0, gb + 422983 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 32 | 0, gb + 423022 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 40 | 0, gb + 423050 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 48 | 0, gb + 423077 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 56 | 0, gb + 423106 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 64 | 0, gb + 423134 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 72 | 0, gb + 423164 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 80 | 0, gb + 423193 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 88 | 0, gb + 423227 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 96 | 0, gb + 423260 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 104 | 0, gb + 423299 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 112 | 0, gb + 423337 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 120 | 0, gb + 423364 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 128 | 0, gb + 423390 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 136 | 0, gb + 423423 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 144 | 0, gb + 423455 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 152 | 0, gb + 423488 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 160 | 0, gb + 423520 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 168 | 0, gb + 423550 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1159956 + 176 | 0, gb + 423582 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1160140 | 0, gb + 423613 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1160140 + 8 | 0, gb + 423643 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1160140 + 16 | 0, gb + 423672 | 0, 0, 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1160140 + 24 | 0, gb + 423708 | 0, 0, 0);
 return;
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 902959 | 0, 0);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 4;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i5;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 901608 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 901635 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 12 | 0, gb + 901655 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 901672 | 0, 0);
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 901689 | 0, 0);
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 901707 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 901736 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 901753 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 901780 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 901804 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 901827 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 901847 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 901867 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 901895 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 901920 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 901945 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 68 | 0, gb + 901967 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 903232 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 76 | 0, gb + 903253 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 80 | 0, gb + 901984 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 81 | 0, gb + 902010 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 82 | 0, gb + 902025 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 83 | 0, gb + 902047 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 84 | 0, gb + 902065 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 85 | 0, gb + 902083 | 0, 0);
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 86 | 0, gb + 902106 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm8Matrix34ENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 * 48 | 0;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 719341 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 * 48 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   i1 = i1 + 48 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 48 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 40 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP32[i4 + (i6 * 48 | 0) + 44 >> 2] = HEAP32[i7 + 44 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 48 | 0) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 48 | 0) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 * 48 | 0) | 0;
 return i10 | 0;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i9 = i8 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
 HEAP32[i9 >> 2] = i1;
 i16 = HEAP32[i8 + 8 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) return i8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i14 + 68 >> 2] | 0;
 i17 = i14 + 48 | 0;
 i18 = i14 + 52 | 0;
 i10 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i12 = i14 + 32 | 0;
 i13 = i14 + 12 | 0;
 i14 = i14 + 16 | 0;
 if (!i7) {
  i4 = i1;
  L5 : while (1) {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if (i1 | 0) {
    if (!(HEAP8[i10 >> 0] | 0)) {
     i6 = 23;
     break;
    }
    if (!(HEAP32[i11 >> 2] | 0)) {
     i6 = 23;
     break;
    }
    if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
     i6 = 23;
     break;
    }
    i2 = HEAP32[i4 >> 2] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? i4 + 4 | 0 : i2;
    i3 = (i3 | 0) == 0 ? i14 : i3;
    while (1) {
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L5;
     }
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
   }
   i4 = i4 + 36 | 0;
   HEAP32[i9 >> 2] = i4;
   if ((i4 | 0) == (i16 | 0)) {
    i6 = 23;
    break;
   }
  }
  if ((i6 | 0) == 23) return i8 | 0;
 } else i15 = i1;
 L22 : while (1) {
  i5 = HEAP32[i15 + 20 >> 2] | 0;
  L24 : do if ((i7 | 0) == (i5 | 0)) {
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   i1 = i7;
   i2 = (i2 | 0) == 0 ? i15 + 4 | 0 : i2;
   i3 = (i3 | 0) == 0 ? i18 : i3;
   while (1) {
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
     i6 = 15;
     break L24;
    }
    i1 = i1 + -1 | 0;
    if (!i1) break; else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } else i6 = 15; while (0);
  if ((i6 | 0) == 15) {
   i6 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i6 = 23;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i6 = 23;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i5 | 0)) {
    i6 = 23;
    break;
   }
   i1 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i5 | 0) {
    i3 = i5;
    i2 = (i1 | 0) == 0 ? i15 + 4 | 0 : i1;
    i1 = (i4 | 0) == 0 ? i14 : i4;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L22;
     }
     i3 = i3 + -1 | 0;
     if (!i3) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  i15 = i15 + 36 | 0;
  HEAP32[i9 >> 2] = i15;
  if ((i15 | 0) == (i16 | 0)) {
   i6 = 23;
   break;
  }
 }
 if ((i6 | 0) == 23) return i8 | 0;
 return 0;
}

function __ZN9AnimationD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 176044 + 8;
 __ZN9Animation15ThreadedCleanupEv(i5);
 i1 = HEAP32[i5 + 316 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 320 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i2 | 0) >>> 4) << 4);
  i4 = HEAP32[i5 + 328 >> 2] | 0;
  HEAP32[i6 >> 2] = 25;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 300 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 304 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 312 >> 2] | 0;
  HEAP32[i6 >> 2] = 25;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 284 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 288 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 296 >> 2] | 0;
  HEAP32[i6 >> 2] = 25;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 268 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 272 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 104 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 108 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 116 >> 2] | 0;
  HEAP32[i6 >> 2] = 25;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = i5 + 84 | 0;
 if ((HEAP32[i5 + 100 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 88 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 68 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 72 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 80 >> 2] | 0;
  HEAP32[i6 >> 2] = 25;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = gb + 37748 + 8;
  HEAP32[i5 >> 2] = gb + 29060 + 8;
  HEAP32[i5 >> 2] = gb + 26392 + 8;
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i4 = HEAP32[i5 + 60 >> 2] | 0;
 HEAP32[i6 >> 2] = 25;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 HEAP32[i5 >> 2] = gb + 37748 + 8;
 HEAP32[i5 >> 2] = gb + 29060 + 8;
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 STACKTOP = i7;
 return;
}

function __ZN8Material15ResetWithShaderEP6Shader(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i9 + 100 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 231) | 0;
  __ZN18SharedMaterialDataC2Ev(i1);
  HEAP32[i8 >> 2] = i1;
 }
 __ZN19ShaderPropertySheet5ClearEb(i1 + 12 | 0, 0);
 i5 = i1 + 220 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 208 | 0;
  i2 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i4 >> 2] | 0) + (i2 * 244 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i1 + 164 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2;
 i5 = i7 + 4 | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 i4 = i7 + 16 | 0;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 i3 = i7 + 28 | 0;
 HEAP32[i7 + 24 >> 2] = i3;
 __ZN18UnityPropertySheetaSERKS_(i9 + 44 | 0, i7) | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i7 + 24 | 0, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i7 + 12 | 0, HEAP32[i4 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i7, HEAP32[i5 >> 2] | 0);
 HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] = i6;
 do if ((i6 | 0) == 0 & (HEAP32[gb + 1166240 >> 2] | 0) == 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 469921 | 0, 27);
  i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i7) | 0;
  HEAP32[gb + 1166240 >> 2] = i1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  } else {
   HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
   break;
  }
 } while (0);
 __ZN8Material17UpdateToNewShaderEb(i9, 0);
 STACKTOP = i10;
 return;
}

function __ZN2UIL41GenerateRenderableUIInstructionCombineJobEPNS_28PreprocessUIInstructionsDataE(i17) {
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18 + 4 | 0;
 i2 = i18;
 if ((HEAP16[gb + 1468096 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468096 | 0, i1);
  i16 = gb + 1468096 | 0;
 } else i16 = 0;
 i14 = HEAP32[i17 + 776 >> 2] | 0;
 i15 = i14 + 12 | 0;
 f6 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f10 = Math_fround(-f6);
 f7 = Math_fround(-f4);
 f5 = Math_fround(-f3);
 i13 = i17 + 768 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  i9 = 0;
  i2 = 0;
  i8 = 0;
 } else {
  i9 = HEAP32[i15 >> 2] | 0;
  i11 = 0;
  i2 = 0;
  i12 = 0;
  i8 = 0;
  while (1) {
   i1 = HEAP32[i17 + 192 + (i12 << 2) >> 2] | 0;
   if (!i1) i1 = i11; else {
    _memcpy(i9 | 0, (HEAP32[i15 >> 2] | 0) + ((HEAP32[i17 + (i12 * 12 | 0) >> 2] << 3) * 252 | 0) | 0, i1 * 252 | 0) | 0;
    i9 = i9 + (i1 * 252 | 0) | 0;
    i1 = i1 + i11 | 0;
    i11 = HEAP32[i17 + 256 + (i12 << 2) >> 2] | 0;
    i2 = i11 + i2 | 0;
    i8 = (HEAP32[i17 + 320 + (i12 << 2) >> 2] | 0) + i8 | 0;
    if (i11) {
     f24 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) >> 2]);
     f20 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) + 4 >> 2]);
     f19 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) + 8 >> 2]);
     f23 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) + 12 >> 2]);
     f22 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) + 16 >> 2]);
     f21 = Math_fround(HEAPF32[i17 + 384 + (i12 * 24 | 0) + 20 >> 2]);
     f6 = f24 < f6 ? f24 : f6;
     f10 = f10 < f23 ? f23 : f10;
     f7 = f7 < f22 ? f22 : f7;
     f5 = f5 < f21 ? f21 : f5;
     f4 = f20 < f4 ? f20 : f4;
     f3 = f19 < f3 ? f19 : f3;
    }
   }
   i12 = i12 + 1 | 0;
   if (i12 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) {
    i9 = i1;
    break;
   } else i11 = i1;
  }
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i8;
 HEAP32[i14 + 8 >> 2] = i9;
 HEAPF32[i14 + 24 >> 2] = f6;
 HEAPF32[i14 + 28 >> 2] = f4;
 HEAPF32[i14 + 32 >> 2] = f3;
 HEAPF32[i14 + 36 >> 2] = f10;
 HEAPF32[i14 + 40 >> 2] = f7;
 HEAPF32[i14 + 44 >> 2] = f5;
 if (i9 | 0) {
  i2 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 * 252 | 0) + 84 >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i17, gb + 64024 | 0);
 if (!i16) {
  STACKTOP = i18;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i18;
 return;
}

function __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 HEAP8[i8 + 869 >> 0] = 1;
 i9 = HEAP32[i8 + 16 >> 2] | 0;
 i10 = i9 & 2147483647;
 i7 = HEAP32[i8 + 12 >> 2] | 0;
 i1 = HEAP8[i8 + 870 >> 0] | 0 ? 0 : 2;
 i9 = i9 << 2;
 i6 = i7 << 2;
 if (!i7) {
  do {
   i2 = i8 + 360 + (i1 * 20 | 0) | 0;
   i3 = i8 + 360 + (i1 * 20 | 0) + 16 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i10 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i10;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i9, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 + 360 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i10;
    HEAP32[i2 >> 2] = i7;
    break;
   } while (0);
   HEAP32[i8 + 360 + (i1 * 20 | 0) + 12 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 3);
  return;
 }
 do {
  i4 = i8 + 360 + (i1 * 20 | 0) | 0;
  i5 = i8 + 360 + (i1 * 20 | 0) + 16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i10 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i10;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i9, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 + 360 + (i1 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i10;
   HEAP32[i4 >> 2] = i2;
   i2 = i10;
   break;
  } while (0);
  i3 = i8 + 360 + (i1 * 20 | 0) + 12 | 0;
  HEAP32[i3 >> 2] = i7;
  do if ((i2 & 2147483647) >>> 0 < i7 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i7;
   i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i6, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i4 >> 2] = i3;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i8 + 360 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i4 >> 2] = i2;
   i3 = i2;
   break;
  } else i3 = HEAP32[i4 >> 2] | 0; while (0);
  i2 = 0;
  do {
   i5 = i3 + (i2 << 2) | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 return;
}

function __ZN16Physics2DManager10RaycastAllERK8Vector2fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i3, i2, f8, i10, f11, f15, i12, i16, i18) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f15 = Math_fround(f15);
 i12 = i12 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, i13 = 0, i14 = 0, i17 = 0, i19 = 0, f20 = f0, f21 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19 + 8 | 0;
 i1 = i19;
 if ((HEAP16[gb + 1457644 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457644 | 0, i13);
  i17 = gb + 1457644 | 0;
 } else i17 = 0;
 i14 = f8 == Math_fround(inf);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f6 * f6));
 if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
 f7 = Math_fround(f5 * f4);
 f6 = Math_fround(f6 * f4);
 f4 = i14 ? Math_fround(1.0e5) : f8;
 f5 = Math_fround(f4 * f7);
 f4 = Math_fround(f4 * f6);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f9 + f5);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(f8 + f4);
 f21 = Math_fround(f5 - f9);
 f20 = Math_fround(f4 - f8);
 f20 = Math_fround(Math_sqrt(Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20))));
 if (((HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) == 2139095040) {
  f5 = Math_fround(f9 + Math_fround(f7 * Math_fround(1.0e5)));
  f4 = Math_fround(f8 + Math_fround(f6 * Math_fround(1.0e5)));
 }
 HEAP32[i13 >> 2] = gb + 156148 + 8;
 HEAP32[i13 + 4 >> 2] = i10;
 i1 = i13 + 8 | 0;
 i2 = i13 + 12 | 0;
 HEAP32[i13 + 16 >> 2] = i12;
 HEAPF32[i13 + 20 >> 2] = f9;
 HEAPF32[i13 + 24 >> 2] = f8;
 HEAPF32[i13 + 28 >> 2] = f5;
 HEAPF32[i13 + 32 >> 2] = f4;
 HEAP32[i13 + 36 >> 2] = i18;
 i12 = f11 == Math_fround(-inf);
 f5 = i12 ? Math_fround(-3402823469999999843913219.0e14) : f11;
 HEAPF32[i1 >> 2] = f5;
 i12 = f15 == Math_fround(inf);
 f4 = i12 ? Math_fround(3402823469999999843913219.0e14) : f15;
 HEAPF32[i2 >> 2] = f4;
 if (!(f5 < f4)) {
  HEAPF32[i1 >> 2] = f4;
  HEAPF32[i2 >> 2] = f5;
 }
 i3 = __ZN14Raycast2DQuery8RunQueryEb(i13, i16) | 0;
 if (!((i3 | 0) == 0 | i14 ^ 1)) {
  i1 = HEAP32[i18 + 12 >> 2] | 0;
  if (i1 | 0) {
   i18 = HEAP32[i18 >> 2] | 0;
   i2 = i18 + (i1 * 36 | 0) | 0;
   i1 = i18;
   do {
    i18 = i1 + 28 | 0;
    HEAPF32[i18 >> 2] = Math_fround(Math_fround(HEAPF32[i18 >> 2]) * Math_fround(1.0e5));
    i1 = i1 + 36 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 if (!i17) {
  STACKTOP = i19;
  return i3 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i19;
 return i3 | 0;
}

function __ZN14AreaEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i5);
 i1 = i8 + 56 | 0;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i8 + 60 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i8 + 92 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i8 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i8 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = i9 - i2 >> 4;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= i1 - i5 >> 4 >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i5 >> 4;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 << 4) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN14ConstantStringaSERKS_(i3, i2);
   i8 = i3 + 4 | 0;
   i6 = i2 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i2 = i2 + 16 | 0;
   i3 = i3 + 16 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -16 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN14ConstantStringD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i2, i1);
   i8 = i2 + 4 | 0;
   i6 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i1 = i1 + 16 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -16 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN14ConstantStringD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = i1 - i3 | 0;
 i3 = i5 >> 3;
 i3 = i5 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 268435455;
 if (i3 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 << 4) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 << 4);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  HEAP32[i1 >> 2] = 0;
  __ZN14ConstantString6assignERKS_(i1, i2);
  i8 = i1 + 4 | 0;
  i7 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i2 = i2 + 16 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN5physx3Cct13HandleManager3AddEPv(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i6 + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP16[(HEAP32[i6 + 16 >> 2] | 0) + (i7 << 1) >> 1] | 0;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i7 << 2) >> 2] = i9;
  HEAP32[i8 >> 2] = i7 + 1;
  i9 = i5 & 65535;
  HEAP16[(HEAP32[i6 + 12 >> 2] | 0) + (i9 << 1) >> 1] = i7;
  HEAP32[i1 >> 2] = i2 + -1;
  i9 = (HEAPU16[(HEAP32[i6 + 20 >> 2] | 0) + (i9 << 1) >> 1] | 0) << 16 | i9;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = i6 + 8 | 0;
 if ((i7 | 0) == (HEAP32[i1 >> 2] | 0)) {
  i2 = i7 << 1;
  i2 = i2 >>> 0 > 65535 ? 65535 : i2;
  HEAP32[i1 >> 2] = i2;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 3 | 0, i2 << 2, gb + 657886 | 0, 75) | 0;
  i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 2 | 0, HEAP32[i1 >> 2] << 1, gb + 657886 | 0, 76) | 0;
  i11 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 1 | 0, HEAP32[i1 >> 2] << 1, gb + 657886 | 0, 77) | 0;
  i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, HEAP32[i1 >> 2] << 1, gb + 657886 | 0, 78) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  i3 = i6 + 12 | 0;
  _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] << 1 | 0) | 0;
  i4 = i6 + 16 | 0;
  _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] << 1 | 0) | 0;
  i5 = i6 + 20 | 0;
  _memcpy(i7 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] << 1 | 0) | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  _memset(i12 + (i13 << 1) | 0, -1, (HEAP32[i1 >> 2] | 0) - i13 << 1 | 0) | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  _memset(i11 + (i13 << 1) | 0, -1, (HEAP32[i1 >> 2] | 0) - i13 << 1 | 0) | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  _memset(i7 + (i13 << 1) | 0, 0, (HEAP32[i1 >> 2] | 0) - i13 << 1 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 7 | 0, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 6 | 0, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 5 | 0, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 4 | 0, HEAP32[i6 >> 2] | 0);
  HEAP32[i6 >> 2] = i2;
  HEAP32[i3 >> 2] = i12;
  HEAP32[i4 >> 2] = i11;
  HEAP32[i5 >> 2] = i7;
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = i6 + 12 | 0;
  i4 = i6 + 16 | 0;
  i5 = i6 + 20 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i7;
 }
 HEAP32[i2 + (i1 << 2) >> 2] = i9;
 i13 = i1 & 65535;
 HEAP16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] = i13;
 HEAP16[(HEAP32[i4 >> 2] | 0) + (i1 << 1) >> 1] = i13;
 HEAP32[i8 >> 2] = i1 + 1;
 i13 = (HEAPU16[(HEAP32[i5 >> 2] | 0) + (i1 << 1) >> 1] | 0) << 16 | i1;
 STACKTOP = i10;
 return i13 | 0;
}

function __Z22CalculateShadowMapSizeRK13ShadowJobData9LightTypeRK8Vector2fii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, f7 = f0, f8 = f0;
 i6 = Math_fround(HEAPF32[(__Z15GetGraphicsCapsv() | 0) + 100 >> 2]) >= Math_fround(480.0);
 switch (i2 | 0) {
 case 2:
  {
   if ((i5 | 0) > 0) {
    i2 = i5 + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 | 0;
   } else {
    f7 = Math_fround(HEAPF32[i3 >> 2]);
    f7 = Math_fround(f7 * Math_fround(HEAPF32[i1 + 540 >> 2]));
    f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    f8 = Math_fround(f8 * Math_fround(HEAPF32[i1 + 544 >> 2]));
    i2 = ~~(f7 < f8 ? f8 : f7) + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 >> i4;
   }
   i1 = (__Z15GetGraphicsCapsv() | 0) + 128 | 0;
   i6 = i6 ? 1024 : 512;
   i1 = HEAP32[i1 >> 2] | 0;
   i1 = (i6 | 0) < (i1 | 0) ? i6 : i1;
   if ((i2 | 0) < 16) {
    i6 = 16;
    return i6 | 0;
   }
   i6 = (i2 | 0) > (i1 | 0) ? i1 : i2;
   return i6 | 0;
  }
 case 0:
  {
   if ((i5 | 0) > 0) {
    i2 = i5 + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 | 0;
   } else {
    f8 = Math_fround(HEAPF32[i3 >> 2]);
    f8 = Math_fround(f8 * Math_fround(HEAPF32[i1 + 540 >> 2]));
    f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
    f7 = Math_fround(f7 * Math_fround(HEAPF32[i1 + 544 >> 2]));
    i2 = ~~Math_fround((f8 < f7 ? f7 : f8) * Math_fround(2.0)) + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 >> i4;
   }
   i1 = (__Z15GetGraphicsCapsv() | 0) + 132 | 0;
   i6 = i6 ? 2048 : 1024;
   i1 = HEAP32[i1 >> 2] | 0;
   i1 = (i6 | 0) < (i1 | 0) ? i6 : i1;
   if ((i2 | 0) < 16) {
    i6 = 16;
    return i6 | 0;
   }
   i6 = (i2 | 0) > (i1 | 0) ? i1 : i2;
   return i6 | 0;
  }
 case 1:
  {
   if ((i5 | 0) > 0) {
    i2 = i5 + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 | 0;
   } else {
    f8 = Math_fround(HEAPF32[i1 + 540 >> 2]);
    f7 = Math_fround(HEAPF32[i1 + 544 >> 2]);
    i2 = ~~Math_fround(Math_fround(~~(f8 < f7 ? f7 : f8) | 0) * Math_fround(3.79999995)) + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 >> i4;
   }
   i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2] | 0;
   i1 = i6 ? ((i1 | 0) > 4096 ? 4096 : i1) : (i1 | 0) > 2048 ? 2048 : i1;
   if ((i2 | 0) < 32) {
    i6 = 32;
    return i6 | 0;
   }
   i6 = (i2 | 0) > (i1 | 0) ? i1 : i2;
   return i6 | 0;
  }
 default:
  {
   i6 = 128;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN5Cache15FreeUsableSpaceEj(i2, i15) {
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i1 = __ZN5Cache32GetCachingDiskSpaceFreeAndUsableEv(i2) | 0;
 i3 = getTempRet0() | 0;
 i13 = i2 + 56 | 0;
 i14 = i2 + 60 | 0;
 if (!(i3 >>> 0 < 0 | (i3 | 0) == 0 & i1 >>> 0 < i15 >>> 0)) {
  i13 = i3;
  i12 = i1;
  i14 = i13 >>> 0 > 0;
  i15 = i12 >>> 0 >= i15 >>> 0;
  i13 = (i13 | 0) == 0;
  i15 = i13 & i15;
  i15 = i14 | i15;
  return i15 | 0;
 }
 i10 = i2 + 68 | 0;
 i11 = i2 + 24 | 0;
 i12 = i2 + 64 | 0;
 i9 = i2 + 60 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 L4 : while (1) {
  i2 = i4;
  if ((i2 | 0) == (i14 | 0)) {
   i2 = 19;
   break;
  } else i8 = i4;
  while (1) {
   i6 = i2 + 4 | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   if (!i4) {
    i5 = i8;
    while (1) {
     i4 = HEAP32[i5 + 8 >> 2] | 0;
     if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) break; else i5 = i4;
    }
   } else while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) break; else i4 = i5;
   }
   i7 = i4;
   i5 = i2 + 16 | 0;
   if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) if (!(__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE14__count_uniqueIS7_EEjRKT_(i10, i5) | 0)) if (!(__Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0)) if (__Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) break;
   if ((i4 | 0) == (i14 | 0)) {
    i2 = 19;
    break L4;
   } else {
    i8 = i7;
    i2 = i4;
   }
  }
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  i17 = i11;
  i4 = HEAP32[i6 >> 2] | 0;
  i17 = _i64Subtract(HEAP32[i17 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, i5 | 0, 0) | 0;
  i16 = getTempRet0() | 0;
  i6 = i11;
  HEAP32[i6 >> 2] = i17;
  HEAP32[i6 + 4 >> 2] = i16;
  i1 = _i64Add(i5 | 0, 0, i1 | 0, i3 | 0) | 0;
  i3 = getTempRet0() | 0;
  i6 = i8;
  if (!i4) {
   i5 = i6;
   while (1) {
    i4 = HEAP32[i5 + 8 >> 2] | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) break; else i5 = i4;
   }
  } else while (1) {
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) break; else i4 = i5;
  }
  if ((HEAP32[i13 >> 2] | 0) == (i2 | 0)) HEAP32[i13 >> 2] = i4;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i8);
  if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i1 >>> 0 < i15 >>> 0) i4 = i7; else {
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) {
  i16 = i3 >>> 0 > 0;
  i17 = i1 >>> 0 >= i15 >>> 0;
  i15 = (i3 | 0) == 0;
  i17 = i15 & i17;
  i17 = i16 | i17;
  return i17 | 0;
 }
 return 0;
}

function __ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj(i6, i2, i1, i4, f12, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 f12 = Math_fround(f12);
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = HEAP32[i6 + 32 >> 2] | 0;
 switch (i3 | 0) {
 case 1:
  {
   i11 = i2 << 24 >> 24;
   i11 = ((((i2 & 255) + -97 & 255) < 26 ? i11 + 224 | 0 : i11) << 24 >> 24) - (HEAP32[i6 + 28 >> 2] | 0) | 0;
   break;
  }
 case 2:
  {
   i11 = i2 << 24 >> 24;
   i11 = ((((i2 & 255) + -65 & 255) < 26 ? i11 + 32 | 0 : i11) << 24 >> 24) - (HEAP32[i6 + 28 >> 2] | 0) | 0;
   break;
  }
 default:
  i11 = i2 - (HEAP32[i6 + 28 >> 2] | 0) | 0;
 }
 if (!i1) i1 = HEAP32[(HEAP32[i6 + 76 >> 2] | 0) + 36 >> 2] | 0;
 i1 = (i1 | 0) > 500 ? 500 : i1;
 do if ((i3 | 0) == -2) i8 = i1; else {
  if ((i1 | 0) != (HEAP32[(HEAP32[i6 + 76 >> 2] | 0) + 36 >> 2] | 0)) {
   if (!i5) {
    i4 = 0;
    i8 = 0;
    break;
   }
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1;
   i1 = 0;
  }
  if ((i4 | 0) == 0 | (i5 | 0) == 0) {
   i4 = 0;
   i8 = i1;
  } else {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i4 = 0;
   i8 = i1;
  }
 } while (0);
 i3 = HEAP32[i6 + 60 >> 2] | 0;
 i9 = HEAP32[i6 + 64 >> 2] | 0;
 i1 = i9 - i3 | 0;
 if (!i1) i2 = i3; else {
  i1 = (i1 | 0) / 60 | 0;
  i2 = i3;
  do {
   i6 = (i1 | 0) / 2 | 0;
   i7 = i3 + (i6 * 60 | 0) | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   do if ((i5 | 0) == (i11 | 0)) {
    i5 = HEAP32[i3 + (i6 * 60 | 0) + 40 >> 2] | 0;
    if ((i5 | 0) != (i8 | 0)) if ((i5 | 0) < (i8 | 0)) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    }
    i5 = HEAP32[i3 + (i6 * 60 | 0) + 44 >> 2] | 0;
    if ((i5 | 0) == (i4 | 0)) if (Math_fround(HEAPF32[i3 + (i6 * 60 | 0) + 48 >> 2]) < f12) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    } else if (i4 >>> 0 < i5 >>> 0) {
     i10 = 23;
     break;
    } else {
     i1 = i6;
     break;
    }
   } else if (i5 >>> 0 < i11 >>> 0) i10 = 23; else i1 = i6; while (0);
   if ((i10 | 0) == 23) {
    i10 = 0;
    i3 = i7 + 60 | 0;
    i1 = i1 + -1 - i6 | 0;
    i2 = i3;
   }
  } while ((i1 | 0) != 0);
 }
 if ((i2 | 0) == (i9 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i11 | 0) == (i1 | 0)) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  if ((i8 | 0) != (i1 | 0)) {
   if ((i8 | 0) < (i1 | 0) | (i2 | 0) == (i9 | 0)) i1 = 0; else break;
   return i1 | 0;
  }
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  if ((i4 | 0) == (i1 | 0)) {
   if ((i2 | 0) == (i9 | 0) ? 1 : Math_fround(HEAPF32[i2 + 48 >> 2]) > f12) i1 = 0; else break;
   return i1 | 0;
  } else {
   if (i1 >>> 0 < i4 >>> 0 | (i2 | 0) == (i9 | 0)) i1 = 0; else break;
   return i1 | 0;
  }
 } else if (i11 >>> 0 < i1 >>> 0 | (i2 | 0) == (i9 | 0)) {
  i11 = 0;
  return i11 | 0;
 } while (0);
 HEAP32[i2 + 52 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2];
 i11 = 1;
 return i11 | 0;
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i6, i2, i8) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i8 - i2 | 0;
 i5 = i1 >> 6;
 i7 = i6 + 8 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i4;
 if (i5 >>> 0 > (HEAP32[i7 >> 2] | 0) - i4 >> 6 >>> 0) {
  __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i6);
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i4 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
  i3 = i4 >> 5;
  i3 = i4 >> 6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 25;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 6, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i6 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i1 + (i3 << 6);
  if ((i2 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  do {
   __ZN14AnimationEventC2ERKS_(i1, i2);
   i2 = i2 + 64 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 64 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i6 = i6 + 4 | 0;
 i1 = (HEAP32[i6 >> 2] | 0) - i4 >> 6;
 i5 = i5 >>> 0 > i1 >>> 0;
 i1 = i2 + (i1 << 6) | 0;
 i4 = i5 ? i1 : i8;
 if ((i4 | 0) != (i2 | 0)) do {
  __ZN14AnimationEventaSERKS_(i3, i2) | 0;
  i2 = i2 + 64 | 0;
  i3 = i3 + 64 | 0;
 } while ((i2 | 0) != (i4 | 0));
 if (i5) {
  if ((i4 | 0) == (i8 | 0)) {
   STACKTOP = i10;
   return;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   __ZN14AnimationEventC2ERKS_(i2, i1);
   i1 = i1 + 64 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 64 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i9 + 4 | 0;
 i5 = i9 + 4 | 0;
 do {
  HEAP32[i6 >> 2] = i1 + -64;
  i2 = i1 + -44 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + -32 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i2 = i1 + -60 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + -48 >> 2] | 0;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i5 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
  }
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx21PxsBodyTransformVault7addBodyERKNS_11PxsBodyCoreE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i7;
 i5 = i5 + ~(i5 << 15) | 0;
 i5 = (i5 >>> 10 ^ i5) * 9 | 0;
 i5 = i5 >>> 6 ^ i5;
 i5 = i5 + ~(i5 << 11) | 0;
 i5 = i8 + (((i5 >>> 16 ^ i5) & 1023) << 2) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i6 = 12; else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  L3 : do if (i1) while (1) {
   if ((HEAP32[i2 + 28 >> 2] | 0) == (i7 | 0)) break L3;
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else {
    i4 = i1;
    i1 = i2;
    i2 = i4;
   }
  } while (0);
  if ((HEAP32[i2 + 28 >> 2] | 0) == (i7 | 0)) {
   i8 = i2 + 36 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   return;
  }
  if (!i2) i6 = 12; else {
   i3 = i8 + 4388 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i8 + 4096 | 0);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i5 = i8 + 4376 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   i5 = i8 + 4380 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   if (!i1) i1 = 0; else {
    i3 = i1;
    i4 = i3 + 40 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
    HEAP32[i1 + 32 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = i7;
   }
   HEAP32[i2 + 32 >> 2] = i1;
  }
 }
 if ((i6 | 0) == 12) {
  i2 = i8 + 4388 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i8 + 4096 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i6 = i8 + 4376 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  i6 = i8 + 4380 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else {
   i3 = i1;
   i4 = i3 + 40 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   HEAP32[i1 + 32 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = i7;
  }
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i1 + 36 >> 2] = 1;
 i8 = i8 + 4392 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 8 | 0;
 i15 = i16;
 i1 = i17 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i17 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i14, 4);
  i1 = HEAP32[i14 >> 2] | 0;
 } else {
  i13 = HEAP32[i2 >> 2] | 0;
  HEAP32[i14 >> 2] = i13;
  HEAP32[i1 >> 2] = i3;
  i1 = i13;
 }
 i8 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i15 >> 2] = -1;
 i9 = i15 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i10 = i18 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i18, HEAP32[i10 >> 2] | 0);
 i11 = i18 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i18 >> 2] = i10;
 HEAP32[i10 >> 2] = 0;
 if ((i8 | 0) <= 0) {
  STACKTOP = i16;
  return;
 }
 i12 = i10;
 i13 = i18 + 4 | 0;
 i7 = 0;
 do {
  __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i15, i17);
  i5 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  do if (!i1) {
   HEAP32[i14 >> 2] = i10;
   i4 = i12;
   i3 = i10;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i14 >> 2] = i1;
    i4 = i1;
    i3 = i14;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(24) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i6;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i18 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 >> 2] | 0, i1);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i8 | 0));
 STACKTOP = i16;
 return;
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i9 = i8 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
 HEAP32[i9 >> 2] = i1;
 i16 = HEAP32[i8 + 8 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) return i8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i14 + 68 >> 2] | 0;
 i17 = i14 + 48 | 0;
 i18 = i14 + 52 | 0;
 i10 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i12 = i14 + 32 | 0;
 i13 = i14 + 12 | 0;
 i14 = i14 + 16 | 0;
 if (!i7) {
  i4 = i1;
  L5 : while (1) {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if (i1 | 0) {
    if (!(HEAP8[i10 >> 0] | 0)) {
     i6 = 23;
     break;
    }
    if (!(HEAP32[i11 >> 2] | 0)) {
     i6 = 23;
     break;
    }
    if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
     i6 = 23;
     break;
    }
    i2 = HEAP32[i4 >> 2] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? i4 + 4 | 0 : i2;
    i3 = (i3 | 0) == 0 ? i14 : i3;
    while (1) {
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L5;
     }
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
   }
   i4 = i4 + 36 | 0;
   HEAP32[i9 >> 2] = i4;
   if ((i4 | 0) == (i16 | 0)) {
    i6 = 23;
    break;
   }
  }
  if ((i6 | 0) == 23) return i8 | 0;
 } else i15 = i1;
 L22 : while (1) {
  i5 = HEAP32[i15 + 20 >> 2] | 0;
  L24 : do if ((i7 | 0) == (i5 | 0)) {
   i2 = HEAP32[i15 >> 2] | 0;
   i3 = HEAP32[i17 >> 2] | 0;
   i1 = i7;
   i2 = (i2 | 0) == 0 ? i15 + 4 | 0 : i2;
   i3 = (i3 | 0) == 0 ? i18 : i3;
   while (1) {
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
     i6 = 15;
     break L24;
    }
    i1 = i1 + -1 | 0;
    if (!i1) break; else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } else i6 = 15; while (0);
  if ((i6 | 0) == 15) {
   i6 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i6 = 23;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i6 = 23;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i5 | 0)) {
    i6 = 23;
    break;
   }
   i1 = HEAP32[i15 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i5 | 0) {
    i3 = i5;
    i2 = (i1 | 0) == 0 ? i15 + 4 | 0 : i1;
    i1 = (i4 | 0) == 0 ? i14 : i4;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L22;
     }
     i3 = i3 + -1 | 0;
     if (!i3) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  i15 = i15 + 36 | 0;
  HEAP32[i9 >> 2] = i15;
  if ((i15 | 0) == (i16 | 0)) {
   i6 = 23;
   break;
  }
 }
 if ((i6 | 0) == 23) return i8 | 0;
 return 0;
}

function __ZN14DirectorPlayer4PlayE9HPlayableP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0);
 i4 = __ZnwjRK10MemLabelIdiPKci(176, gb + 63784 | 0, 16, gb + 389990 | 0, 85) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i9 = i8;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i6 = i8;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i4 + 28 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i9 = i8;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i4 + 48 | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i4 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i4 + 88 >> 2] = 0;
 i5 = i4 + 96 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i5 = i4 + 120 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP8[i4 + 148 >> 0] = 1;
 HEAP32[i4 + 156 >> 2] = 0;
 HEAP32[i4 + 160 >> 2] = 2;
 HEAP8[i4 + 164 >> 0] = 0;
 HEAP8[i4 + 165 >> 0] = 0;
 HEAP32[i4 + 168 >> 2] = 0;
 i5 = i1 + 36 | 0;
 HEAP32[i5 >> 2] = i4;
 i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 if ((i6 | 0) == 3) __ZN15DirectorManager17RemoveFromManagerEP18PlayableController(__Z18GetDirectorManagerv() | 0, i4);
 HEAP32[i4 >> 2] = i6;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 __ZN18PlayableController4BindEP8PlayableP14DirectorPlayeriP12Il2CppObject(HEAP32[i5 >> 2] | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1, -1, i3);
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 164 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 i3 = i1 + 156 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i1 + 168 >> 2] | 0;
 if (i4 | 0) HEAP32[i3 >> 2] = __Z29scripting_gchandle_get_targetj(i4) | 0;
 if ((HEAP32[i1 >> 2] | 0) != 3) __ZN15DirectorManager14ScheduleForAddEP18PlayableController(__Z18GetDirectorManagerv() | 0, i1);
 HEAP8[i2 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i5, i1);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 44 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 36 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 48 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 49 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 i5 = (i1 | 0) == 1;
 i6 = i11 + 92 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i3 = i4 + -1 | 0;
  i1 = HEAP32[i11 + 80 >> 2] | 0;
  if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) == (i2 | 0)) {
   HEAP32[i6 >> 2] = i3;
   break;
  }
  i3 = i1 + (i4 << 2) | 0;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) break L4;
  }
  if ((i1 | 0) != (i3 | 0)) {
   i9 = i1 + 4 | 0;
   _memmove(i1 | 0, i9 | 0, i3 - i9 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  }
 } while (0);
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i2 + 32 >> 2] | 0;
 i8 = HEAP32[i2 + 36 >> 2] | 0;
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (!i1) i5 = i8; else {
  do {
   i2 = HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
   i1 = HEAP32[i2 + 92 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i5 = HEAP32[i2 + 36 >> 2] | 0;
 }
 i6 = HEAP32[i9 + 16 >> 2] | 0;
 i7 = HEAP32[i6 + (i8 << 2) >> 2] | 0;
 i3 = HEAP32[i9 + 72 >> 2] | 0;
 i14 = i3 + (i8 << 2) | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i13 = HEAP32[i9 + 68 >> 2] | 0;
 i4 = i13 + (i5 << 2) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i14 >> 2] = -1;
 HEAP32[i13 + (i1 << 2) >> 2] = i2;
 HEAP32[i4 >> 2] = -1;
 if ((i2 | 0) != -1) HEAP32[i3 + (i2 << 2) >> 2] = i1;
 i14 = i9 + 4 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = i8;
 HEAP32[i4 >> 2] = i1;
 if ((i1 | 0) != -1) HEAP32[i3 + (i1 << 2) >> 2] = i5;
 i1 = HEAP32[i11 + 36 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  do {
   i14 = i6 + (i1 << 2) | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) - i7;
   i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
 }
 i2 = i11 + 32 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1158396 >> 2] | 0;
 i4 = HEAP32[i3 + 36 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  i6 = HEAP32[i2 + 56 >> 2] | 0;
  i7 = i2 + 36 | 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  do {
   i14 = HEAP32[i5 + (i1 << 2) >> 2] & i4;
   i13 = i6 + (i1 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | i14;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i14;
   i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
 }
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i3, i9);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i11, gb + 1105076 | 0, i10);
 STACKTOP = i12;
 return;
}

function __ZN2UI14CanvasRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(236, i1, 16, gb + 1048932 | 0, 0, gb + 1012890 | 0, 20) | 0;
 i11 = i1;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 186892 + 8;
 HEAPF32[i4 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 48 >> 2] = 0;
 i2 = i4 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i4 + 64 >> 2] = f9;
 HEAPF32[i4 + 68 >> 2] = f8;
 HEAPF32[i4 + 72 >> 2] = f7;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i4 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + 100 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[i4 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4 + 120 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i4 + 136 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = 0;
 HEAP8[i4 + 160 >> 0] = 0;
 i5 = i4 + 162 | 0;
 i1 = i4 + 168 | 0;
 i2 = i4 + 188 | 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP16[i5 >> 1] = 0;
 HEAP16[i5 + 2 >> 1] = 0 >>> 16;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP32[i4 + 208 >> 2] = -1;
 HEAP32[i4 + 212 >> 2] = -1;
 HEAP32[i4 + 216 >> 2] = -1;
 HEAP32[i4 + 220 >> 2] = 0;
 HEAP32[i4 + 224 >> 2] = -1;
 HEAP32[i4 + 228 >> 2] = -1;
 HEAP32[i4 + 232 >> 2] = -1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14ParticleSystem21RendererBecameVisibleEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, d2 = 0.0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, i10 = 0, f12 = f0;
 i10 = i11 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 30 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 HEAP8[i3 >> 0] = 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) != 1) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 d2 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 i3 = HEAP32[i10 >> 2] | 0;
 d9 = +HEAPF64[i3 + 40 >> 3];
 i8 = i11 + 36 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = (HEAP8[i6 + 277 >> 0] | 0) == 0;
 if (i7) {
  d4 = d2 - +HEAPF64[i3 + 32 >> 3] + +Math_fround(HEAPF32[i3 + 396 >> 2]);
  f12 = Math_fround(HEAPF32[i6 + 264 >> 2]);
  if (d4 > +Math_fround(f12 + Math_fround(HEAPF32[(HEAP32[i11 + 44 >> 2] | 0) + 88 >> 2]))) i1 = i3 + 13 | 0; else i5 = 7;
 } else i5 = 7;
 do if ((i5 | 0) == 7) {
  i1 = i3 + 13 | 0;
  i5 = HEAP8[i1 >> 0] | 0;
  if (i5 << 24 >> 24) if (d2 - d9 > +Math_fround(HEAPF32[(HEAP32[i11 + 44 >> 2] | 0) + 88 >> 2])) break;
  d4 = +HEAPF64[i3 + 32 >> 3];
  d2 = d2 - d4;
  if (d9 > d4) {
   HEAP8[i1 >> 0] = 0;
   d4 = d9 - d4;
   if (!i7) {
    f12 = Math_fround(d4);
    d4 = +Math_fround(_fmodf(f12, Math_fround(HEAPF32[i6 + 264 >> 2])));
   }
   __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i11, Math_fround(d4), 1);
   HEAP8[(HEAP32[i10 >> 2] | 0) + 13 >> 0] = 1;
   d2 = d2 - d4;
   i1 = HEAP32[i8 >> 2] | 0;
   if (HEAP8[i1 + 277 >> 0] | 0) {
    f12 = Math_fround(d2);
    d2 = +Math_fround(_fmodf(f12, Math_fround(HEAPF32[i1 + 264 >> 2])));
   }
   __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i11, Math_fround(d2), 1);
  } else {
   if (!i7) {
    f12 = Math_fround(d2);
    d2 = +Math_fround(_fmodf(f12, Math_fround(HEAPF32[i6 + 264 >> 2])));
   }
   __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i11, Math_fround(d2), 1);
  }
  __ZN14ParticleSystem4PlayEb(i11, 1);
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP8[i11 + 13 >> 0] = i5;
  HEAPF64[i11 + 40 >> 3] = d9;
  return;
 } while (0);
 HEAP8[i3 + 12 >> 0] = 1;
 HEAP8[i1 >> 0] = 1;
 d9 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i10 >> 2] | 0) + 40 >> 3] = d9;
 i3 = i11 + 32 | 0;
 __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i3 >> 2] | 0, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i1 + 480 >> 2] = 0;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (HEAP8[i1 + 13 >> 0] | 0) HEAP32[i1 + 8 >> 2] = 0;
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i11, HEAP32[i3 >> 2] | 0, i1);
 return;
}

function __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i9, i1, i2, i8, i10, i11, i12) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 8 | 0;
 i4 = i13;
 i3 = i13 + 12 | 0;
 i7 = (i1 | 0) == 0 ? 1 : i1;
 i2 = i2 + -1 | 15;
 i6 = i2 + 1 | 0;
 if ((i2 + 65537 | 0) >>> 0 > ~i7 >>> 0) if (!(i10 & 1)) {
  __Z6FormatPKcz(i3, gb + 581944 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 581974 | 0, 1081, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  __Z6FormatPKcz(i3, gb + 581944 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 581974 | 0, 1085, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!(HEAP8[i9 + 1550 >> 0] | 0)) {
  if ((i1 | 0) < 4) {
   i12 = i9 + 1564 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  }
  i12 = HEAP32[i9 + 1560 >> 2] | 0;
  i12 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i7 | 0, i6 | 0) | 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 switch (i1 | 0) {
 case 1:
  {
   i1 = __ZN12TLSAllocatorI14StackAllocatorE8AllocateEji(HEAP32[i9 + 1552 >> 2] | 0, i7, i6) | 0;
   if (i1 | 0) {
    i12 = i1;
    STACKTOP = i13;
    return i12 | 0;
   }
   i12 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i9, i7, i6, gb + 64032 | 0, i10, i11, i12) | 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 case 2:
 case 57:
 case 58:
  {
   i3 = 0;
   break;
  }
 default:
  if (!(__Z31profiler_get_memory_record_modev() | 0)) i3 = 0; else {
   __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1188360 | 0, 0);
   i3 = gb + 1188360 | 0;
  }
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = (i1 | 0) < 4;
 if ((i1 | 0) < 128) i1 = HEAP32[i9 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
  i1 = HEAP32[i9 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i7 | 0, i6 | 0) | 0;
 if ((i10 & 1 | 0) == 0 | (i1 | 0) != 0) {
  if (!i1) __ZL16OutOfMemoryErrorjiRK10MemLabelIdiPKc(i7, i6, i8, i12, i11);
  if (!i2) __ZN13MemoryManager18RegisterAllocationEPvjRK10MemLabelIdPKcS5_i(i9, i1, i7, i8, gb + 582050 | 0, i11, i12);
 } else i1 = 0;
 if (!i3) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i3, i16) {
 i3 = i3 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 32 | 0;
 i18 = i20;
 i19 = i3 + 16 | 0;
 i1 = HEAP32[i19 >> 2] | 0;
 i2 = i1 + 1648 | 0;
 if (i2 >>> 0 > (HEAP32[i3 + 12 >> 2] | 0) >>> 0) i1 = 0; else HEAP32[i19 >> 2] = i2;
 i13 = i1 + 24 | 0;
 i14 = i1 + 44 | 0;
 i15 = i1 + 1644 | 0;
 _memset(i1 | 0, 0, 1648) | 0;
 i2 = i14;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 12 >> 2] = -1;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i15 | 0));
 if (!i1) {
  i19 = -1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i9 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
 i12 = HEAP32[i9 + 48 >> 2] | 0;
 i10 = (HEAP32[i9 + 44 >> 2] | 0) >>> 5;
 i11 = i9 + i12 | 0;
 if ((i12 | 0) == 0 | (i11 | 0) == 0) {
  HEAP32[i19 >> 2] = i1;
  i19 = -1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i21 = HEAP32[i9 + 60 >> 2] | 0;
 HEAPF32[i18 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
 i12 = i18 + 12 | 0;
 HEAP32[i12 >> 2] = -1;
 HEAPF32[i18 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 24 >> 2] = Math_fround(0.0);
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = HEAP32[i9 + 24 >> 2] | 0;
 i5 = HEAP32[i9 + 28 >> 2] | 0;
 i6 = HEAP32[i9 + 32 >> 2] | 0;
 i7 = HEAP32[i9 + 36 >> 2] | 0;
 i8 = HEAP32[i9 + 40 >> 2] | 0;
 i22 = HEAP32[i16 + 4 >> 2] | 0;
 i2 = HEAP32[i16 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i22;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i1 + 12 >> 2] = i10;
 HEAP32[i1 + 16 >> 2] = i11;
 HEAP32[i1 + 20 >> 2] = i11 + (((i10 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i13 >> 2] = i9;
 HEAP32[i1 + 28 >> 2] = i21;
 HEAP32[i1 + 32 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = i10;
 if (i10 | 0) {
  i22 = HEAP32[i11 >> 2] & 3;
  HEAP32[i14 >> 2] = i3;
  HEAP32[i1 + 48 >> 2] = i4;
  HEAP32[i1 + 52 >> 2] = i5;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 60 >> 2] = i6;
  HEAP32[i1 + 64 >> 2] = i7;
  HEAP32[i1 + 68 >> 2] = i8;
  HEAP8[i1 + 72 >> 0] = 0;
  HEAP8[i1 + 73 >> 0] = i22;
  HEAP8[i1 + 74 >> 0] = 63;
  HEAP8[i1 + 75 >> 0] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 HEAP8[i15 >> 0] = 1;
 i22 = __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE(i1, i18, i17) | 0;
 i22 = i22 ? HEAP32[i12 >> 2] | 0 : -1;
 HEAP32[i19 >> 2] = i1;
 STACKTOP = i20;
 return i22 | 0;
}

function __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i1 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i7 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 }
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i7 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6 + 4 | 0, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 }
 i7 = i2 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i5 = i2 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function _UNITY_png_read_transform_info(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i7 + 212 >> 2] | 0;
 do if (i6 & 4096 | 0) {
  i2 = i8 + 25 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i1 = (HEAP16[i7 + 424 >> 1] | 0) == 0;
  if (i3 << 24 >> 24 == 3) {
   HEAP8[i2 >> 0] = i1 ? 2 : 6;
   HEAP8[i8 + 24 >> 0] = 8;
   HEAP16[i8 + 22 >> 1] = 0;
   if (HEAP32[i7 + 412 >> 2] | 0) break;
   _UNITY_png_error(i7, gb + 353218 | 0);
  }
  if (!((i6 & 33554432 | 0) == 0 | i1)) HEAP8[i2 >> 0] = i3 & 255 | 4;
  i1 = i8 + 24 | 0;
  if ((HEAPU8[i1 >> 0] | 0) < 8) HEAP8[i1 >> 0] = 8;
  HEAP16[i8 + 22 >> 1] = 0;
 } while (0);
 if (i6 & 128 | 0) {
  i5 = i8 + 162 | 0;
  i4 = i7 + 448 | 0;
  HEAP16[i5 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP16[i5 + 2 >> 1] = HEAP16[i4 + 2 >> 1] | 0;
  HEAP16[i5 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
  HEAP16[i5 + 6 >> 1] = HEAP16[i4 + 6 >> 1] | 0;
  HEAP16[i5 + 8 >> 1] = HEAP16[i4 + 8 >> 1] | 0;
 }
 HEAP32[i8 + 40 >> 2] = HEAP32[i7 + 680 >> 2];
 i5 = i8 + 24 | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 i1 = i2 & 255;
 i2 = (i2 & 65535) >>> 8;
 i3 = i2 & 255;
 if (i1 << 24 >> 24 == 16) {
  if (!(i6 & 67108864)) i1 = 16; else {
   HEAP8[i5 >> 0] = 8;
   i1 = 8;
  }
  if (i6 & 1024) {
   HEAP8[i5 >> 0] = 8;
   i1 = 8;
  }
 }
 if (i6 & 16384) {
  i3 = (i2 & 65535 | 2) & 255;
  HEAP8[i8 + 25 >> 0] = i3;
 }
 if ((i6 & 4 | 0) != 0 & (i1 & 255) < 8) {
  HEAP8[i5 >> 0] = 8;
  i4 = 8;
 } else i4 = i1;
 i2 = i8 + 25 | 0;
 do if (i3 << 24 >> 24 == 3) {
  HEAP8[i8 + 29 >> 0] = 1;
  i1 = 1;
 } else {
  i1 = i8 + 29 | 0;
  if (!(i3 & 2)) {
   HEAP8[i1 >> 0] = 1;
   i1 = 1;
   break;
  } else {
   HEAP8[i1 >> 0] = 3;
   i1 = 3;
   break;
  }
 } while (0);
 if (i6 & 262144) {
  i3 = i3 & 251;
  HEAP8[i2 >> 0] = i3;
  HEAP16[i8 + 22 >> 1] = 0;
 }
 if (i3 & 4) {
  i1 = i1 + 1 << 24 >> 24;
  HEAP8[i8 + 29 >> 0] = i1;
 }
 L43 : do if (!(i6 & 32768)) i3 = i1; else {
  switch (i3 << 24 >> 24) {
  case 0:
  case 2:
   break;
  default:
   {
    i3 = i1;
    break L43;
   }
  }
  i1 = i1 + 1 << 24 >> 24;
  HEAP8[i8 + 29 >> 0] = i1;
  if (!(i6 & 16777216)) i3 = i1; else {
   HEAP8[i2 >> 0] = i3 & 255 | 4;
   i3 = i1;
  }
 } while (0);
 if (!(i6 & 1048576)) {
  i2 = i3;
  i1 = i4;
 } else {
  i2 = HEAP16[i7 + 200 >> 1] | 0;
  i1 = i2 & 255;
  i2 = (i2 & 65535) >>> 8 & 255;
  if ((i4 & 255) < (i1 & 255)) HEAP8[i5 >> 0] = i1; else i1 = i4;
  if ((i3 & 255) < (i2 & 255)) HEAP8[i8 + 29 >> 0] = i2; else i2 = i3;
 }
 i1 = Math_imul(i1 & 255, i2 & 255) | 0;
 HEAP8[i8 + 30 >> 0] = i1;
 i1 = i1 & 255;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i1 >>> 0 > 7) {
  i6 = Math_imul(i1 >>> 3, i2) | 0;
  i8 = i8 + 12 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i7 + 400 | 0;
  HEAP32[i8 >> 2] = i6;
  return;
 } else {
  i6 = ((Math_imul(i1, i2) | 0) + 7 | 0) >>> 3;
  i8 = i8 + 12 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i7 + 400 | 0;
  HEAP32[i8 >> 2] = i6;
  return;
 }
}

function __ZN5physx3Scb5SceneD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = HEAP32[i3 + 3368 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 3360 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = i3 + 2820 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2780 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2740 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2700 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2660 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2620 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2580 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 2540 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i2 = HEAP32[i3 + 2536 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 2528 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 2524 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 2516 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 2512 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 2504 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = i3 + 2464 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 __ZN5physx2Cm9FlushPoolD2Ev(i3 + 2436 | 0);
 i1 = i3 + 2428 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 }
 i2 = HEAP32[i3 + 2424 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  i3 = i3 + 16 | 0;
  __ZN5physx2Sc5SceneD2Ev(i3);
  return;
 }
 i1 = HEAP32[i3 + 2416 >> 2] | 0;
 if (!i1) {
  i3 = i3 + 16 | 0;
  __ZN5physx2Sc5SceneD2Ev(i3);
  return;
 }
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 i3 = i3 + 16 | 0;
 __ZN5physx2Sc5SceneD2Ev(i3);
 return;
}

function __ZN5physx2Sn18writeAllPropertiesINS_23PxVehicleDriveSimDataNWEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i17, i15, i18, i1, i2) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i19;
 i10 = i19 + 144 | 0;
 i16 = i19 + 128 | 0;
 i12 = i19 + 112 | 0;
 i8 = i19 + 32 | 0;
 i13 = i17;
 i14 = i18;
 __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i15;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimDataNWEEEEEEEjT_j(i8, i9, 0) | 0;
 i7 = HEAP32[i8 + 72 >> 2] | 0;
 i8 = HEAP32[i8 + 64 >> 2] | 0;
 i11 = i17 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (!i3) i3 = 0; else {
  i4 = i3 + -1 | 0;
  i5 = i17 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (!(HEAP8[i6 + (i4 << 3) + 4 >> 0] | 0)) {
   mftCall_vii(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0, HEAP32[i6 + (i4 << 3) >> 2] | 0);
   i3 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i5 >> 2] | 0) + (i3 + -1 << 3) + 4 >> 0] = 1;
  }
 }
 HEAP32[i9 >> 2] = i8;
 HEAP8[i9 + 4 >> 0] = 0;
 if ((HEAP32[i17 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = i9;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = (HEAP32[i17 + 4 >> 2] | 0) + (i3 << 3) | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i17, i9) | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev(i12);
 mftCall_vii(i7 | 0, i16 | 0, i15 | 0);
 __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev(i9);
 HEAP32[i10 >> 2] = i13;
 HEAP32[i10 + 4 >> 2] = i14;
 HEAP32[i10 + 8 >> 2] = i16;
 HEAP32[i10 + 12 >> 2] = i1;
 HEAP32[i10 + 16 >> 2] = i2;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i9, 0);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 if (HEAP8[(HEAP32[i17 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 20 >> 2] | 0, i18 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i1 + -1;
 STACKTOP = i19;
 return;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i1, i3, i4, i15, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 HEAP32[i1 >> 2] = i3;
 i17 = i1 + 4 | 0;
 HEAP32[i17 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i15;
 if ((i4 | 0) == (i15 | 0) | i2 ^ 1) return;
 i8 = HEAP32[i3 + 68 >> 2] | 0;
 i14 = i3 + 48 | 0;
 i9 = i3 + 52 | 0;
 i10 = i3 + 8 | 0;
 i11 = i3 + 4 | 0;
 i12 = i3 + 32 | 0;
 i13 = i3 + 12 | 0;
 i7 = i3 + 16 | 0;
 if (!i8) {
  L5 : while (1) {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if (i1 | 0) {
    if (!(HEAP8[i10 >> 0] | 0)) {
     i6 = 23;
     break;
    }
    if (!(HEAP32[i11 >> 2] | 0)) {
     i6 = 23;
     break;
    }
    if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
     i6 = 23;
     break;
    }
    i2 = HEAP32[i4 >> 2] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? i4 + 4 | 0 : i2;
    i3 = (i3 | 0) == 0 ? i7 : i3;
    while (1) {
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L5;
     }
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
   }
   i4 = i4 + 36 | 0;
   HEAP32[i17 >> 2] = i4;
   if ((i4 | 0) == (i15 | 0)) {
    i6 = 23;
    break;
   }
  }
  if ((i6 | 0) == 23) return;
 } else i16 = i4;
 L22 : while (1) {
  i5 = HEAP32[i16 + 20 >> 2] | 0;
  L24 : do if ((i8 | 0) == (i5 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i1 = i8;
   i2 = (i2 | 0) == 0 ? i16 + 4 | 0 : i2;
   i3 = (i3 | 0) == 0 ? i9 : i3;
   while (1) {
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
     i6 = 15;
     break L24;
    }
    i1 = i1 + -1 | 0;
    if (!i1) break; else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } else i6 = 15; while (0);
  if ((i6 | 0) == 15) {
   i6 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i6 = 23;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i6 = 23;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i5 | 0)) {
    i6 = 23;
    break;
   }
   i1 = HEAP32[i16 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i5 | 0) {
    i3 = i5;
    i2 = (i1 | 0) == 0 ? i16 + 4 | 0 : i1;
    i1 = (i4 | 0) == 0 ? i7 : i4;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L22;
     }
     i3 = i3 + -1 | 0;
     if (!i3) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  i16 = i16 + 36 | 0;
  HEAP32[i17 >> 2] = i16;
  if ((i16 | 0) == (i15 | 0)) {
   i6 = 23;
   break;
  }
 }
 if ((i6 | 0) == 23) return;
}

function __ZN16UnityAdsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i9, i1 + 8 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041805 | 0, i9, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041676 | 0, i9, i1 + 17 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041827 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041846 | 0, i9, i1 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041858 | 0, i9, i1 + 36 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13b2PulleyJoint24SolveVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, i26 = 0;
 i8 = i1 + 120 | 0;
 i23 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 28 | 0;
 i26 = HEAP32[i3 >> 2] | 0;
 i11 = i26 + (i23 * 12 | 0) | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 i5 = i26 + (i23 * 12 | 0) + 4 | 0;
 f21 = Math_fround(HEAPF32[i5 >> 2]);
 f20 = Math_fround(HEAPF32[i26 + (i23 * 12 | 0) + 8 >> 2]);
 i2 = i1 + 124 | 0;
 i23 = HEAP32[i2 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i26 + (i23 * 12 | 0) >> 2]);
 f17 = Math_fround(HEAPF32[i26 + (i23 * 12 | 0) + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i26 + (i23 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 148 >> 2]);
 f10 = Math_fround(f20 * f9);
 f18 = Math_fround(HEAPF32[i1 + 144 >> 2]);
 f10 = Math_fround(f12 - f10);
 f25 = Math_fround(f21 + Math_fround(f20 * f18));
 f4 = Math_fround(HEAPF32[i1 + 156 >> 2]);
 f24 = Math_fround(f16 * f4);
 f14 = Math_fround(HEAPF32[i1 + 152 >> 2]);
 f24 = Math_fround(f7 - f24);
 f22 = Math_fround(f17 + Math_fround(f16 * f14));
 f6 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f10 = Math_fround(f10 * f6);
 f19 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f25 = Math_fround(-Math_fround(f10 + Math_fround(f25 * f19)));
 f10 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f24 = Math_fround(f24 * f13);
 f15 = Math_fround(HEAPF32[i1 + 140 >> 2]);
 f22 = Math_fround(f25 - Math_fround(f10 * Math_fround(f24 + Math_fround(f22 * f15))));
 f22 = Math_fround(Math_fround(HEAPF32[i1 + 192 >> 2]) * f22);
 i23 = i1 + 116 | 0;
 HEAPF32[i23 >> 2] = Math_fround(Math_fround(HEAPF32[i23 >> 2]) - f22);
 f6 = Math_fround(f6 * f22);
 f19 = Math_fround(f19 * f22);
 f10 = Math_fround(f22 * f10);
 f13 = Math_fround(f13 * f10);
 f15 = Math_fround(f10 * f15);
 f10 = Math_fround(HEAPF32[i1 + 176 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f6 * f10));
 f10 = Math_fround(f21 + Math_fround(f19 * f10));
 f9 = Math_fround(f20 + Math_fround(Math_fround(HEAPF32[i1 + 184 >> 2]) * Math_fround(Math_fround(f19 * f18) - Math_fround(f6 * f9))));
 f6 = Math_fround(HEAPF32[i1 + 180 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f13 * f6));
 f6 = Math_fround(f17 + Math_fround(f15 * f6));
 f4 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i1 + 188 >> 2]) * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f4))));
 HEAPF32[i11 >> 2] = f12;
 HEAPF32[i5 >> 2] = f10;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i5 + ((HEAP32[i8 >> 2] | 0) * 12 | 0) + 8 >> 2] = f9;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i5 + (i1 * 12 | 0) >> 2] = f7;
 HEAPF32[i5 + (i1 * 12 | 0) + 4 >> 2] = f6;
 HEAPF32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 >> 2] = f4;
 return;
}

function __ZL11DecodeValuePPKcS0_(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 1 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP8[i3 >> 0] | 0;
 if (i1 >>> 0 > i6 >>> 0) {
  HEAP32[i4 >> 2] = 255;
  i7 = i4 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 if ((i2 + 127 & 255) < 124) {
  HEAP32[i4 >> 2] = 255;
  i7 = i4 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 switch (i2 << 24 >> 24) {
 case -2:
  {
   i7 = i3 + 5 | 0;
   HEAP32[i5 >> 2] = i7;
   if (i7 >>> 0 > i6 >>> 0) {
    HEAP32[i4 >> 2] = 255;
    i7 = i4 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    STACKTOP = i8;
    return;
   } else {
    i7 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
    HEAP32[i4 >> 2] = 254;
    HEAP32[i4 + 4 >> 2] = i7;
    i7 = i4 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    STACKTOP = i8;
    return;
   }
  }
 case -3:
  {
   i7 = i3 + 5 | 0;
   HEAP32[i5 >> 2] = i7;
   if (i7 >>> 0 > i6 >>> 0) {
    HEAP32[i4 >> 2] = 255;
    i7 = i4 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    STACKTOP = i8;
    return;
   } else {
    i7 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
    HEAP32[i4 >> 2] = 253;
    HEAP32[i4 + 4 >> 2] = i7;
    i7 = i4 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    STACKTOP = i8;
    return;
   }
  }
 case -128:
  {
   i2 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
   i1 = i3 + 5 | 0;
   HEAP32[i5 >> 2] = i1;
   if (i1 >>> 0 > i6 >>> 0) {
    HEAP32[i4 >> 2] = 255;
    i7 = i4 + 8 | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    STACKTOP = i8;
    return;
   }
   break;
  }
 default:
  i2 = i2 & 255;
 }
 i3 = i1 + i2 | 0;
 HEAP32[i5 >> 2] = i3;
 if (i3 >>> 0 > i6 >>> 0) {
  HEAP32[i4 >> 2] = 255;
  i7 = i4 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i1, i2);
  HEAP32[i4 >> 2] = 128;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4 + 8 | 0, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN7mecanim5human7GetAxesEPKNS0_5HumanEi(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i12 = i3 + 4 | 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 i13 = i3 + 8 | 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 i14 = i3 + 12 | 0;
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
 i15 = i3 + 20 | 0;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 i16 = i3 + 24 | 0;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 i17 = i3 + 28 | 0;
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i4 = i3 + 40 | 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i5 = i3 + 36 | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 32 >> 2] = Math_fround(1.0);
 i6 = i3 + 52 | 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 i7 = i3 + 48 | 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 44 >> 2] = Math_fround(1.0);
 i8 = i3 + 64 | 0;
 HEAPF32[i8 >> 2] = Math_fround(-1.0);
 i9 = i3 + 60 | 0;
 HEAPF32[i9 >> 2] = Math_fround(-1.0);
 HEAPF32[i3 + 56 >> 2] = Math_fround(-1.0);
 i10 = i3 + 68 | 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0);
 i11 = i3 + 72 | 0;
 HEAP32[i11 >> 2] = 3;
 i1 = HEAP32[i2 + 72 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i2 = i2 + 40 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i18 = i2 + 4 | 0;
 i1 = HEAP32[i18 + (HEAP32[i18 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i18 = i2 + 16 | 0;
 i18 = (HEAP32[i18 >> 2] | 0) + i18 | 0;
 i20 = HEAP32[i18 + (i1 * 76 | 0) + 4 >> 2] | 0;
 i19 = HEAP32[i18 + (i1 * 76 | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i18 + (i1 * 76 | 0) + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i18 + (i1 * 76 | 0) >> 2];
 HEAP32[i12 >> 2] = i20;
 HEAP32[i13 >> 2] = i19;
 HEAP32[i14 >> 2] = i2;
 i12 = HEAP32[i18 + (i1 * 76 | 0) + 20 >> 2] | 0;
 i13 = HEAP32[i18 + (i1 * 76 | 0) + 24 >> 2] | 0;
 i14 = HEAP32[i18 + (i1 * 76 | 0) + 28 >> 2] | 0;
 HEAP32[i3 + 16 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 16 >> 2];
 HEAP32[i15 >> 2] = i12;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i17 >> 2] = i14;
 i16 = HEAP32[i18 + (i1 * 76 | 0) + 36 >> 2] | 0;
 i17 = HEAP32[i18 + (i1 * 76 | 0) + 40 >> 2] | 0;
 HEAP32[i3 + 32 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 32 >> 2];
 HEAP32[i5 >> 2] = i16;
 HEAP32[i4 >> 2] = i17;
 i17 = HEAP32[i18 + (i1 * 76 | 0) + 48 >> 2] | 0;
 i16 = HEAP32[i18 + (i1 * 76 | 0) + 52 >> 2] | 0;
 HEAP32[i3 + 44 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 44 >> 2];
 HEAP32[i7 >> 2] = i17;
 HEAP32[i6 >> 2] = i16;
 i16 = HEAP32[i18 + (i1 * 76 | 0) + 60 >> 2] | 0;
 i17 = HEAP32[i18 + (i1 * 76 | 0) + 64 >> 2] | 0;
 HEAP32[i3 + 56 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 56 >> 2];
 HEAP32[i9 >> 2] = i16;
 HEAP32[i8 >> 2] = i17;
 HEAP32[i10 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 68 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i18 + (i1 * 76 | 0) + 72 >> 2];
 return;
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE24GenerateTypeTreeTransferEvRPT_PKcRjS8_RT0_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 1744 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, i4, HEAP32[gb + 37304 >> 2] | 0, i3, 0);
 HEAP32[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i5 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN7mecanim5human9HumanPoseC2Ev(i6);
 i3 = i6 + 888 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 912 >> 2] = 1065353216;
 HEAP32[i6 + 916 >> 2] = 1065353216;
 HEAP32[i6 + 920 >> 2] = 1065353216;
 HEAP32[i6 + 924 >> 2] = 1065353216;
 i3 = i6 + 928 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 952 >> 2] = 1065353216;
 HEAP32[i6 + 956 >> 2] = 1065353216;
 HEAP32[i6 + 960 >> 2] = 1065353216;
 HEAP32[i6 + 964 >> 2] = 1065353216;
 i3 = i6 + 968 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 992 >> 2] = 1065353216;
 HEAP32[i6 + 996 >> 2] = 1065353216;
 HEAP32[i6 + 1e3 >> 2] = 1065353216;
 HEAP32[i6 + 1004 >> 2] = 1065353216;
 i3 = i6 + 1008 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i6 + 1032 >> 2] = 1065353216;
 HEAP32[i6 + 1036 >> 2] = 1065353216;
 HEAP32[i6 + 1040 >> 2] = 1065353216;
 HEAP32[i6 + 1044 >> 2] = 1065353216;
 i3 = i6 + 1048 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAPF32[i6 + 1068 >> 2] = Math_fround(1.0);
 i3 = i6 + 1072 | 0;
 i4 = i6 + 1708 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP16[i4 + 20 >> 1] = 0;
 HEAP8[i6 + 1730 >> 0] = 1;
 HEAP8[i6 + 1731 >> 0] = 0;
 HEAP8[i6 + 1732 >> 0] = 1;
 HEAP8[i6 + 1733 >> 0] = 0;
 HEAP8[i6 + 1734 >> 0] = 0;
 _memset(i6 + 1088 | 0, -1, 620) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, i2, gb + 898415 | 0, i6, 0);
 __ZN7mecanim9animation18ClipMuscleConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 STACKTOP = i1;
 return;
}

function __ZNK13b2DynamicTree5QueryI24b2WorldQueryProxyWrapperEEvPT_RK6b2AABB(i1, i12, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i17 = i16 + 4 | 0;
 HEAP32[i16 >> 2] = i17;
 i14 = i16 + 1028 | 0;
 i15 = i16 + 1032 | 0;
 HEAP32[i15 >> 2] = 256;
 HEAP32[i17 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 >> 2] = 1;
 i10 = i1 + 4 | 0;
 i11 = i13 + 4 | 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 12 | 0;
 i9 = i12 + 4 | 0;
 i1 = 1;
 i2 = i17;
 L1 : while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i14 >> 2] = i1;
  i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  do if ((i5 | 0) != -1) {
   i6 = HEAP32[i10 >> 2] | 0;
   f22 = Math_fround(HEAPF32[i13 >> 2]);
   f22 = Math_fround(f22 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 8 >> 2]));
   f21 = Math_fround(HEAPF32[i11 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 12 >> 2]));
   f20 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) >> 2]);
   f20 = Math_fround(f20 - Math_fround(HEAPF32[i7 >> 2]));
   f19 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 4 >> 2]);
   if (!(f22 > Math_fround(0.0) | f21 > Math_fround(0.0) | f20 > Math_fround(0.0) | Math_fround(f19 - Math_fround(HEAPF32[i8 >> 2])) > Math_fround(0.0))) {
    i3 = i6 + (i5 * 36 | 0) + 24 | 0;
    if ((HEAP32[i3 >> 2] | 0) == -1) {
     i6 = HEAP32[i9 >> 2] | 0;
     if (!(mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] | 0) + (i5 * 36 | 0) + 16 >> 2] | 0) | 0)) break L1;
     i1 = HEAP32[i14 >> 2] | 0;
     break;
    }
    if ((i1 | 0) == (HEAP32[i15 >> 2] | 0)) {
     HEAP32[i15 >> 2] = i1 << 1;
     i4 = __Z7b2Alloci(i1 << 3) | 0;
     HEAP32[i16 >> 2] = i4;
     _memcpy(i4 | 0, i2 | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
     if ((i2 | 0) != (i17 | 0)) __Z6b2FreePv(i2);
    }
    i4 = HEAP32[i16 >> 2] | 0;
    HEAP32[i4 + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    HEAP32[i14 >> 2] = i2;
    i1 = i6 + (i5 * 36 | 0) + 28 | 0;
    if ((i2 | 0) == (HEAP32[i15 >> 2] | 0)) {
     HEAP32[i15 >> 2] = i2 << 1;
     i6 = __Z7b2Alloci(i2 << 3) | 0;
     HEAP32[i16 >> 2] = i6;
     _memcpy(i6 | 0, i4 | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
     if ((i4 | 0) != (i17 | 0)) __Z6b2FreePv(i4);
    }
    HEAP32[(HEAP32[i16 >> 2] | 0) + (HEAP32[i14 >> 2] << 2) >> 2] = HEAP32[i1 >> 2];
    i1 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    HEAP32[i14 >> 2] = i1;
   }
  } while (0);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i16 >> 2] | 0;
 }
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) == (i17 | 0)) {
  STACKTOP = i18;
  return;
 }
 __Z6b2FreePv(i1);
 HEAP32[i16 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i9 = i14 + 8 | 0;
 i10 = i14;
 i11 = i15 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i12 = i15 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = i1 - i5 >> 3;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj(i3, i2 - i4 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 } else if (i2 >>> 0 < i4 >>> 0) {
  i2 = i5 + (i2 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    HEAP32[i6 >> 2] = i1 + -8;
    __ZN14ConstantStringD2Ev(i1 + -4 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = i2;
  }
 }
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 12 | 0;
 i6 = i9 + 11 | 0;
 i7 = i9 + 12 | 0;
 i8 = i13 + 4 | 0;
 do {
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i11, i13, 4);
   i3 = HEAP32[i13 >> 2] | 0;
  } else {
   i3 = HEAP32[i3 >> 2] | 0;
   HEAP32[i13 >> 2] = i3;
   HEAP32[i11 >> 2] = i4;
  }
  HEAP32[i2 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i5 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i15, i9, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i15);
  i4 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i17 = gb + 63648 | 0;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i3 = i10;
  HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i3 + 4 >> 2] = i16;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i2 + 4 | 0, i4, i13);
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   i17 = HEAP32[i9 >> 2] | 0;
   i16 = HEAP32[i7 >> 2] | 0;
   HEAP32[i13 >> 2] = 1;
   HEAP32[i8 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i17, i13);
  }
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i14;
 return;
}

function _fill_window(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i9 = i8 + 44 | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i17 = i8 + 60 | 0;
 i18 = i8 + 116 | 0;
 i19 = i8 + 108 | 0;
 i20 = i16 + -262 | 0;
 i21 = i8 + 56 | 0;
 i22 = i8 + 72 | 0;
 i23 = i8 + 88 | 0;
 i10 = i8 + 84 | 0;
 i11 = i8 + 112 | 0;
 i12 = i8 + 92 | 0;
 i13 = i8 + 76 | 0;
 i14 = i8 + 68 | 0;
 i15 = i8 + 64 | 0;
 i1 = HEAP32[i18 >> 2] | 0;
 i2 = i16;
 while (1) {
  i3 = HEAP32[i19 >> 2] | 0;
  i4 = (HEAP32[i17 >> 2] | 0) - i1 - i3 | 0;
  if (i3 >>> 0 >= (i20 + i2 | 0) >>> 0) {
   i3 = HEAP32[i21 >> 2] | 0;
   _memcpy(i3 | 0, i3 + i16 | 0, i16 | 0) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) - i16;
   i3 = (HEAP32[i19 >> 2] | 0) - i16 | 0;
   HEAP32[i19 >> 2] = i3;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) - i16;
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = i2;
   i2 = (HEAP32[i14 >> 2] | 0) + (i2 << 1) | 0;
   do {
    i2 = i2 + -2 | 0;
    i7 = HEAPU16[i2 >> 1] | 0;
    HEAP16[i2 >> 1] = i7 >>> 0 < i16 >>> 0 ? 0 : i7 - i16 & 65535;
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) != 0);
   i1 = i16;
   i2 = (HEAP32[i15 >> 2] | 0) + (i16 << 1) | 0;
   do {
    i2 = i2 + -2 | 0;
    i7 = HEAPU16[i2 >> 1] | 0;
    HEAP16[i2 >> 1] = i7 >>> 0 < i16 >>> 0 ? 0 : i7 - i16 & 65535;
    i1 = i1 + -1 | 0;
   } while ((i1 | 0) != 0);
   i4 = i4 + i16 | 0;
  }
  i7 = HEAP32[i8 >> 2] | 0;
  i5 = i7 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (!i6) {
   i1 = 19;
   break;
  }
  i1 = HEAP32[i18 >> 2] | 0;
  i3 = (HEAP32[i21 >> 2] | 0) + i3 + i1 | 0;
  i2 = i6 >>> 0 > i4 >>> 0 ? i4 : i6;
  if (!i2) i2 = 0; else {
   HEAP32[i5 >> 2] = i6 - i2;
   switch (HEAP32[(HEAP32[i7 + 28 >> 2] | 0) + 24 >> 2] | 0) {
   case 1:
    {
     i1 = i7 + 48 | 0;
     HEAP32[i1 >> 2] = _unity_z_adler32(HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0, i2) | 0;
     i1 = i7;
     break;
    }
   case 2:
    {
     i1 = i7 + 48 | 0;
     HEAP32[i1 >> 2] = _unity_z_crc32(HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0, i2) | 0;
     i1 = i7;
     break;
    }
   default:
    i1 = i7;
   }
   _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, i2 | 0) | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
   i1 = i7 + 8 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
   i1 = HEAP32[i18 >> 2] | 0;
  }
  i1 = i1 + i2 | 0;
  HEAP32[i18 >> 2] = i1;
  if (i1 >>> 0 > 2) {
   i6 = HEAP32[i19 >> 2] | 0;
   i5 = HEAP32[i21 >> 2] | 0;
   i7 = HEAPU8[i5 + i6 >> 0] | 0;
   HEAP32[i22 >> 2] = i7;
   HEAP32[i22 >> 2] = ((HEAPU8[i5 + (i6 + 1) >> 0] | 0) ^ i7 << HEAP32[i23 >> 2]) & HEAP32[i10 >> 2];
   if (i1 >>> 0 >= 262) {
    i1 = 19;
    break;
   }
  }
  if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0)) {
   i1 = 19;
   break;
  }
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) == 19) return;
}

function __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_S3_RfS4_(i8, i5, i10, i3, i9, i12, i11) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0, f7 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 if (Math_fround(Math_abs(Math_fround(HEAPF32[i3 >> 2]))) < Math_fround(1.1920929e-07)) {
  f1 = Math_fround(HEAPF32[i10 >> 2]);
  if (f1 < Math_fround(HEAPF32[i8 >> 2])) return -1;
  if (f1 > Math_fround(HEAPF32[i5 >> 2])) return -1;
 }
 if (Math_fround(Math_abs(Math_fround(HEAPF32[i3 + 4 >> 2]))) < Math_fround(1.1920929e-07)) {
  f1 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  if (f1 < Math_fround(HEAPF32[i8 + 4 >> 2])) return -1;
  if (f1 > Math_fround(HEAPF32[i5 + 4 >> 2])) return -1;
 }
 if (Math_fround(Math_abs(Math_fround(HEAPF32[i3 + 8 >> 2]))) < Math_fround(1.1920929e-07)) {
  f4 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f1 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  if (f4 < f1) return -1;
  f2 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  if (f4 > f2) return -1;
 } else {
  f1 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f2 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 }
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 f14 = Math_fround(HEAPF32[i10 >> 2]);
 f13 = Math_fround(f13 - f14);
 f16 = Math_fround(HEAPF32[i9 >> 2]);
 f13 = Math_fround(f13 * f16);
 f14 = Math_fround(f16 * Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f14));
 f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f16 = Math_fround(f16 - f6);
 f15 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f16 = Math_fround(f16 * f15);
 f6 = Math_fround(f15 * Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f6));
 f15 = Math_fround(f1 - f4);
 f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f15 = Math_fround(f15 * f7);
 f7 = Math_fround(f7 * Math_fround(f2 - f4));
 i3 = f13 > f14;
 f1 = i3 ? f13 : f14;
 i5 = f16 > f6;
 f2 = i5 ? f6 : f16;
 f4 = i5 ? f16 : f6;
 i8 = f15 > f7;
 f6 = i8 ? f7 : f15;
 f7 = i8 ? f15 : f7;
 HEAPF32[i12 >> 2] = i3 ? f14 : f13;
 HEAPF32[i11 >> 2] = f1;
 if (f2 > Math_fround(HEAPF32[i12 >> 2])) {
  HEAPF32[i12 >> 2] = f2;
  f1 = Math_fround(HEAPF32[i11 >> 2]);
  i3 = i5 ? 4 : 1;
 } else i3 = i3 ? 3 : 0;
 f1 = f1 < f4 ? f1 : f4;
 HEAPF32[i11 >> 2] = f1;
 if (!(f6 > Math_fround(HEAPF32[i12 >> 2]))) {
  f16 = f1;
  i10 = i3;
  i9 = f16 < f7;
  f16 = i9 ? f16 : f7;
  HEAPF32[i11 >> 2] = f16;
  f15 = Math_fround(HEAPF32[i12 >> 2]);
  i11 = f15 > f16;
  i12 = f16 < Math_fround(1.1920929e-07);
  i12 = i11 | i12;
  i12 = i12 ? -1 : i10;
  return i12 | 0;
 }
 HEAPF32[i12 >> 2] = f6;
 f16 = Math_fround(HEAPF32[i11 >> 2]);
 i10 = i8 ? 5 : 2;
 i9 = f16 < f7;
 f16 = i9 ? f16 : f7;
 HEAPF32[i11 >> 2] = f16;
 f15 = Math_fround(HEAPF32[i12 >> 2]);
 i11 = f15 > f16;
 i12 = f16 < Math_fround(1.1920929e-07);
 i12 = i11 | i12;
 i12 = i12 ? -1 : i10;
 return i12 | 0;
}

function __ZN2UI13RectTransform8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 if (HEAP32[i7 + 32 >> 2] | 0) __ZN9Transform28ApplyRuntimeToSerializedDataEv(i7);
 __ZN9Transform8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 136 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 144 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 148 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 152 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 156 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 160 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 164 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 168 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 172 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i1, i3, i4, i15, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 HEAP32[i1 >> 2] = i3;
 i17 = i1 + 4 | 0;
 HEAP32[i17 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i15;
 if ((i4 | 0) == (i15 | 0) | i2 ^ 1) return;
 i8 = HEAP32[i3 + 68 >> 2] | 0;
 i14 = i3 + 48 | 0;
 i9 = i3 + 52 | 0;
 i10 = i3 + 8 | 0;
 i11 = i3 + 4 | 0;
 i12 = i3 + 32 | 0;
 i13 = i3 + 12 | 0;
 i7 = i3 + 16 | 0;
 if (!i8) {
  L5 : while (1) {
   i1 = HEAP32[i4 + 20 >> 2] | 0;
   if (i1 | 0) {
    if (!(HEAP8[i10 >> 0] | 0)) {
     i6 = 23;
     break;
    }
    if (!(HEAP32[i11 >> 2] | 0)) {
     i6 = 23;
     break;
    }
    if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
     i6 = 23;
     break;
    }
    i2 = HEAP32[i4 >> 2] | 0;
    i3 = HEAP32[i13 >> 2] | 0;
    i2 = (i2 | 0) == 0 ? i4 + 4 | 0 : i2;
    i3 = (i3 | 0) == 0 ? i7 : i3;
    while (1) {
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L5;
     }
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i2 = i2 + 1 | 0;
      i3 = i3 + 1 | 0;
     }
    }
   }
   i4 = i4 + 36 | 0;
   HEAP32[i17 >> 2] = i4;
   if ((i4 | 0) == (i15 | 0)) {
    i6 = 23;
    break;
   }
  }
  if ((i6 | 0) == 23) return;
 } else i16 = i4;
 L22 : while (1) {
  i5 = HEAP32[i16 + 20 >> 2] | 0;
  L24 : do if ((i8 | 0) == (i5 | 0)) {
   i2 = HEAP32[i16 >> 2] | 0;
   i3 = HEAP32[i14 >> 2] | 0;
   i1 = i8;
   i2 = (i2 | 0) == 0 ? i16 + 4 | 0 : i2;
   i3 = (i3 | 0) == 0 ? i9 : i3;
   while (1) {
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
     i6 = 15;
     break L24;
    }
    i1 = i1 + -1 | 0;
    if (!i1) break; else {
     i2 = i2 + 1 | 0;
     i3 = i3 + 1 | 0;
    }
   }
  } else i6 = 15; while (0);
  if ((i6 | 0) == 15) {
   i6 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i6 = 23;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i6 = 23;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i5 | 0)) {
    i6 = 23;
    break;
   }
   i1 = HEAP32[i16 >> 2] | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   if (i5 | 0) {
    i3 = i5;
    i2 = (i1 | 0) == 0 ? i16 + 4 | 0 : i1;
    i1 = (i4 | 0) == 0 ? i7 : i4;
    while (1) {
     if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
      i6 = 23;
      break L22;
     }
     i3 = i3 + -1 | 0;
     if (!i3) break; else {
      i2 = i2 + 1 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  i16 = i16 + 36 | 0;
  HEAP32[i17 >> 2] = i16;
  if ((i16 | 0) == (i15 | 0)) {
   i6 = 23;
   break;
  }
 }
 if ((i6 | 0) == 23) return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 2) | 0, 0, i7 - i6 << 2 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37040 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 1024)) {
    if (!(i1 & 512)) {
     if (!(i1 & 1048576)) {
      HEAP32[i6 >> 2] = 0;
      break;
     }
     if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
     HEAP32[i6 >> 2] = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i1 & 16384)) {
     if (i1 & 2048 | 0) {
      d2 = +((HEAP32[i5 >> 2] | 0) >>> 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    HEAP32[i6 >> 2] = ~~d2 >>> 0;
   } else HEAP32[i6 >> 2] = HEAP32[i5 >> 2]; while (0);
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 4 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN18AssetBundleManager30CollectPreloadDataDependenciesER4PPtrI11AssetBundleEbR13dynamic_arrayIiLj4EE(i8, i4, i9, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i6 = i12 + 8 | 0;
 i7 = i12 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) break;
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i13 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) break;
  if (HEAP32[i1 + 4 >> 2] | 0) {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i1 = 0; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   if (!i1) i11 = 19; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27368 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27368 + 28 >> 2] | 0) >>> 0) i11 = 19;
   if ((i11 | 0) == 19) i1 = 0;
   __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE(i8, i1, i1 + 172 | 0, i9, i10);
   STACKTOP = i12;
   return;
  }
 } while (0);
 __Z6FormatPKcz(i6, gb + 365635 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 365670 | 0, 187, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i12;
 return;
}

function __Z13TransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, i22 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i5;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i3, i20);
 f15 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i20 >> 2]);
 f8 = Math_fround(f15 * f9);
 i22 = f8 < Math_fround(0.0);
 f18 = Math_fround(-f8);
 f19 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f7 = Math_fround(f13 * f19);
 i3 = f7 < Math_fround(0.0);
 f11 = Math_fround(-f7);
 f7 = Math_fround((i22 ? f18 : f8) + (i3 ? f11 : f7));
 f11 = Math_fround(HEAPF32[i20 + 24 >> 2]);
 f8 = Math_fround(f6 * f11);
 i3 = f8 < Math_fround(0.0);
 f18 = Math_fround(-f8);
 f8 = Math_fround(f7 + (i3 ? f18 : f8));
 f18 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f7 = Math_fround(f15 * f18);
 i3 = f7 < Math_fround(0.0);
 f16 = Math_fround(-f7);
 f17 = Math_fround(HEAPF32[i20 + 16 >> 2]);
 f21 = Math_fround(f13 * f17);
 i22 = f21 < Math_fround(0.0);
 f10 = Math_fround(-f21);
 f21 = Math_fround((i3 ? f16 : f7) + (i22 ? f10 : f21));
 f10 = Math_fround(HEAPF32[i20 + 28 >> 2]);
 f7 = Math_fround(f6 * f10);
 i22 = f7 < Math_fround(0.0);
 f16 = Math_fround(-f7);
 f7 = Math_fround(f21 + (i22 ? f16 : f7));
 f16 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 f15 = Math_fround(f15 * f16);
 i22 = f15 < Math_fround(0.0);
 f21 = Math_fround(-f15);
 f14 = Math_fround(HEAPF32[i20 + 20 >> 2]);
 f13 = Math_fround(f13 * f14);
 i3 = f13 < Math_fround(0.0);
 f12 = Math_fround(-f13);
 f13 = Math_fround((i22 ? f21 : f15) + (i3 ? f12 : f13));
 f12 = Math_fround(HEAPF32[i20 + 32 >> 2]);
 f6 = Math_fround(f6 * f12);
 i3 = f6 < Math_fround(0.0);
 f15 = Math_fround(-f6);
 f6 = Math_fround(f13 + (i3 ? f15 : f6));
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f9 * f15);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f19 = Math_fround(f9 + Math_fround(f19 * f13));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(f19 + Math_fround(f11 * f9));
 f10 = Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(f17 * f13)) + Math_fround(f10 * f9));
 f9 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f12 * f9));
 f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f11);
 f10 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) + f10);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i4 >> 2] = f11;
 HEAPF32[i4 + 4 >> 2] = f10;
 HEAPF32[i4 + 8 >> 2] = f9;
 HEAPF32[i4 + 12 >> 2] = f8;
 HEAPF32[i4 + 16 >> 2] = f7;
 HEAPF32[i4 + 20 >> 2] = f6;
 STACKTOP = i5;
 return;
}

function __ZN11NoiseModule5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAPF32[i1 + 800 >> 2] = Math_fround(.5);
 HEAP8[i1 + 804 >> 0] = 0;
 HEAP8[i1 + 805 >> 0] = 1;
 HEAP32[i1 + 808 >> 2] = 1;
 HEAPF32[i1 + 812 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 816 >> 2] = Math_fround(2.0);
 HEAP32[i1 + 820 >> 2] = 2;
 HEAPF32[i1 + 1088 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 904 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 910 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 824 | 0, i1 + 912 | 0, Math_fround(0.0), HEAP16[i1 + 908 >> 1] | 0) | 0) & 1;
 HEAP8[i1 + 1884 >> 0] = 0;
 HEAP16[i1 + 92 >> 1] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, Math_fround(1.0), 0) | 0) & 1;
 HEAP16[i1 + 1176 >> 1] = 1;
 i3 = i1 + 1180 | 0;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAPF32[i5 >> 2] = Math_fround(-1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(1.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E(i3);
 HEAP16[i1 + 356 >> 1] = 0;
 HEAPF32[i1 + 352 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, Math_fround(1.0), 0) | 0) & 1;
 HEAP16[i1 + 1440 >> 1] = 1;
 i3 = i1 + 1444 | 0;
 HEAP32[i1 + 1512 >> 2] = 0;
 HEAPF32[i5 >> 2] = Math_fround(-1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(1.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E(i3);
 HEAP16[i1 + 620 >> 1] = 0;
 HEAPF32[i1 + 616 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, Math_fround(1.0), 0) | 0) & 1;
 HEAP16[i1 + 1704 >> 1] = 1;
 i3 = i1 + 1708 | 0;
 HEAP32[i1 + 1776 >> 2] = 0;
 HEAPF32[i5 >> 2] = Math_fround(-1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(1.0), i5);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3, i4) | 0;
 __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E(i3);
 STACKTOP = i2;
 return;
}

function __ZN9LensFlare8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373697 | 0, gb + 373705 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373717 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373730 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 64 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380814 | 0, gb + 1048681 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 4194305);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373742 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i1, i2, i5, i8, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i13 = i1 + 84 | 0;
 i14 = i13;
 i16 = HEAP32[i13 >> 2] | 0;
 i15 = i16 + i14 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 i4 = i3 + -1 | 0;
 i10 = i1 + 4 | 0;
 i17 = HEAP32[i10 >> 2] | 0;
 i6 = i1 + 96 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i7 = i6;
 __ZN7mecanim9animation30SkeletonPoseFromValueRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapEPKiRS8_ii((i16 | 0) == 0 ? 0 : i15, (i17 | 0) == 0 ? 0 : i17 + i10 | 0, i8, i2, (i9 | 0) == 0 ? 0 : i9 + i7 | 0, i11, i4, 0);
 i9 = HEAP32[i13 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_((i9 | 0) == 0 ? 0 : i9 + i14 | 0, i11, i12);
 i9 = i11 + 4 | 0;
 i10 = i9;
 i17 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
 i15 = i17;
 i16 = HEAP32[i5 + 4 >> 2] | 0;
 i18 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i15 + 8 >> 2] = i18;
 i18 = HEAP32[i5 + 16 >> 2] | 0;
 i16 = HEAP32[i5 + 20 >> 2] | 0;
 i17 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i15 + 16 >> 2] = i18;
 HEAP32[i15 + 20 >> 2] = i16;
 HEAP32[i15 + 24 >> 2] = i17;
 i17 = HEAP32[i5 + 32 >> 2] | 0;
 i16 = HEAP32[i5 + 36 >> 2] | 0;
 HEAP32[i15 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i15 + 32 >> 2] = i17;
 HEAP32[i15 + 36 >> 2] = i16;
 if ((HEAP32[i1 + 40 >> 2] | 0) > 0) {
  i18 = HEAP32[i13 >> 2] | 0;
  __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i18 | 0) == 0 ? 0 : i18 + i14 | 0, i11, i12, i3 + -2 | 0, 0);
 }
 i18 = HEAP32[i13 >> 2] | 0;
 __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii((i18 | 0) == 0 ? 0 : i18 + i14 | 0, i12, i11, i4, i4);
 i18 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
 i17 = i18;
 HEAP32[i18 >> 2] = 0;
 i18 = i17 + 4 | 0;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i17 + 24 >> 2] = 1065353216;
 HEAP32[i17 + 28 >> 2] = 1065353216;
 HEAP32[i17 + 32 >> 2] = 1065353216;
 HEAP32[i17 + 36 >> 2] = 1065353216;
 i17 = HEAP32[i13 >> 2] | 0;
 i18 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim9animation30ValueFromSkeletonPoseRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapEPKiRNS_10ValueArrayEii((i17 | 0) == 0 ? 0 : i17 + i14 | 0, i11, i2, (i18 | 0) == 0 ? 0 : i18 + i7 | 0, i8, i4, 0);
 return;
}

function __ZN15ParticleEmitterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i4 + 8 | 0;
 i9 = i4;
 i11 = i2;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i10, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i10 = i1 + 144 | 0;
 i9 = i1 + 156 | 0;
 i8 = i1 + 168 | 0;
 i2 = i1 + 180 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = i1;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 205 >> 0] = 1;
 HEAP8[i1 + 204 >> 0] = 1;
 HEAP8[i1 + 206 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 HEAP8[i1 + 110 >> 0] = 0;
 HEAPF32[i1 + 116 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 120 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 124 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(50.0);
 HEAP8[i1 + 192 >> 0] = 1;
 HEAPF32[i1 + 140 >> 2] = Math_fround(.0500000007);
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 193 >> 0] = 0;
 HEAP8[i1 + 207 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i1 + 84 >> 2] = f7;
 HEAPF32[i1 + 88 >> 2] = f6;
 HEAPF32[i1 + 92 >> 2] = f5;
 STACKTOP = i4;
 return;
}

function __ZN9JSONWrite21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i8, i1, i13) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20;
 i17 = HEAP32[i8 + 56 >> 2] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i17);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 HEAP32[i17 + 16 >> 2] = 4;
 i17 = i16 + 24 | 0;
 HEAP8[i17 >> 0] = 1;
 i18 = i16 + 28 | 0;
 HEAP32[i18 >> 2] = 0;
 i19 = i16 + 32 | 0;
 HEAP32[i19 >> 2] = 0;
 i9 = i16 + 36 | 0;
 HEAP32[i9 >> 2] = -1;
 i10 = i16 + 44 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 i11 = i16 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i4 = i1 + 4 | 0;
 i12 = i16 + 4 | 0;
 i3 = (__Z28scripting_class_is_valuetypeP11Il2CppClass(HEAP32[i4 >> 2] | 0) | 0) & 1;
 HEAP8[i12 >> 0] = i3;
 i14 = i16 + 8 | 0;
 HEAP32[i14 >> 2] = __Z28scripting_array_element_sizeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0) | 0;
 i15 = i16 + 16 | 0;
 HEAP32[i15 >> 2] = HEAP32[i4 >> 2];
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i16 + 40 >> 2] = i2;
 HEAP32[i16 + 48 >> 2] = i4;
 i4 = i4 - i2 >> 6;
 HEAP32[i16 + 56 >> 2] = i4;
 HEAP32[i16 + 52 >> 2] = i4;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
 if (!i4) {
  STACKTOP = i20;
  return;
 }
 i5 = i16 + 40 | 0;
 i6 = i16 + 20 | 0;
 i7 = i16 + 20 | 0;
 i1 = 0;
 while (1) {
  HEAP32[i10 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, i1) | 0) >> 2] | 0;
   if (!i1) {
    i1 = _il2cpp_object_new(HEAP32[i15 >> 2] | 0) | 0;
    __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(HEAP32[HEAP32[i16 >> 2] >> 2] | 0, HEAP32[i11 >> 2] | 0, i1);
   }
   i2 = HEAP32[i15 >> 2] | 0;
   HEAP8[i17 >> 0] = 1;
   HEAP32[i18 >> 2] = i1;
   i1 = -1;
  } else {
   i3 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = (Math_imul(HEAP32[i14 >> 2] | 0, i1) | 0) + 16 | 0;
   HEAP8[i17 >> 0] = 0;
   HEAP32[i18 >> 2] = i3;
  }
  HEAP32[i19 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  __ZN9JSONWrite8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags(i8, i7, gb + 1041891 | 0, i13);
  i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i1;
  if ((i1 | 0) == (i4 | 0)) break;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP8[i12 >> 0] | 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN9ShaderLab11shaderprops9GetTexEnvEPK19ShaderPropertySheetS3_NS_16FastPropertyNameE16TextureDimensionRNS0_16PropertyLocationE(i4, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) != -1 & i5 >>> 0 > 1073741823) {
  i2 = __Z12GetGfxDevicev() | 0;
  i3 = i5 & 1073741823;
  i1 = i2 + 2980 + (i3 * 20 | 0) | 0;
  if (HEAP32[i1 >> 2] | 0) if ((i7 | 0) == 1 ? 1 : (HEAP32[i2 + 2980 + (i3 * 20 | 0) + 4 >> 2] | 0) == (i7 | 0)) {
   HEAP32[i8 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = 2;
   i8 = i1;
   return i8 | 0;
  }
 }
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 L7 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L7;
  }
  if ((i1 | 0) > -1) {
   i2 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   i1 = (HEAP32[i4 + 72 >> 2] | 0) + i2 | 0;
   if (HEAP32[i1 >> 2] | 0) if ((i7 | 0) == 1 ? 1 : (HEAP32[i1 + 4 >> 2] | 0) == (i7 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i8 + 4 >> 2] = 0;
    i8 = i1;
    return i8 | 0;
   }
   i3 = i1 + 16 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != -1 & i1 >>> 0 > 1073741823) {
    i4 = __Z12GetGfxDevicev() | 0;
    i1 = i1 & 1073741823;
    i2 = i4 + 2980 + (i1 * 20 | 0) | 0;
    if (HEAP32[i2 >> 2] | 0) if ((i7 | 0) == 1 ? 1 : (HEAP32[i4 + 2980 + (i1 * 20 | 0) + 4 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i8 >> 2] = HEAP32[i3 >> 2] & 1073741823;
     HEAP32[i8 + 4 >> 2] = 2;
     i8 = i2;
     return i8 | 0;
    }
   }
  }
 } while (0);
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 L24 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i6 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L24;
  }
  if ((i1 | 0) > -1) {
   i2 = HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   i1 = (HEAP32[i6 + 72 >> 2] | 0) + i2 | 0;
   if (HEAP32[i1 >> 2] | 0) if ((i7 | 0) == 1 ? 1 : (HEAP32[i1 + 4 >> 2] | 0) == (i7 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i8 + 4 >> 2] = 1;
    i8 = i1;
    return i8 | 0;
   }
   i3 = i1 + 16 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != -1 & i1 >>> 0 > 1073741823) {
    i4 = __Z12GetGfxDevicev() | 0;
    i1 = i1 & 1073741823;
    i2 = i4 + 2980 + (i1 * 20 | 0) | 0;
    if (HEAP32[i2 >> 2] | 0) if ((i7 | 0) == 1 ? 1 : (HEAP32[i4 + 2980 + (i1 * 20 | 0) + 4 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i8 >> 2] = HEAP32[i3 >> 2] & 1073741823;
     HEAP32[i8 + 4 >> 2] = 2;
     i8 = i2;
     return i8 | 0;
    }
   }
  }
 } while (0);
 HEAP32[i8 >> 2] = -1;
 HEAP32[i8 + 4 >> 2] = 4;
 i8 = __ZN10builtintex16GetDefaultTexEnvE16TextureDimension(i7) | 0;
 return i8 | 0;
}

function __ZN2UI14CanvasRenderer5ClearEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 __ZN2UI14CanvasRenderer7SetMeshEP4Mesh(i5, 0);
 i2 = i5 + 32 | 0;
 i3 = i5 + 36 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i5 + 40 >> 2]) == Math_fround(1.0)) {
  if (!(Math_fround(HEAPF32[i5 + 44 >> 2]) == Math_fround(1.0))) i4 = 5;
 } else i4 = 5; else i4 = 5; else i4 = 5;
 if ((i4 | 0) == 5) {
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAP32[i3 >> 2] = 1065353216;
  HEAP32[i5 + 40 >> 2] = 1065353216;
  HEAP32[i5 + 44 >> 2] = 1065353216;
 }
 if (HEAP32[i5 + 108 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i5 + 96 | 0, 0, i1, 1);
  i3 = i5 + 162 | 0;
  HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2056;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i5 + 188 >> 2] | 0, i5);
 }
 i1 = i5 + 136 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i3 = HEAP32[i5 + 160 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i5 + 144 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP8[i2 + 16 >> 0] = 0;
  if ((i3 & 255) << 24 >> 24) {
   i2 = i5 + 162 | 0;
   i1 = i3 >>> 16 & 65535;
   i4 = 12;
  }
 } else {
  HEAP32[i1 >> 2] = 0;
  i2 = i5 + 144 | 0;
  i1 = i5 + 162 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP8[i2 + 16 >> 0] = 0;
  i2 = i1;
  i1 = HEAP16[i1 >> 1] | 0;
  i4 = 12;
 }
 if ((i4 | 0) == 12) {
  HEAP16[i2 >> 1] = i1 & 65535 | 2056;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i5 + 188 >> 2] | 0, i5);
 }
 i1 = i5 + 140 | 0;
 i4 = (HEAP32[i1 >> 2] | 0) == 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i5 + 162 | 0;
 if (i4) {
  i4 = i5 + 188 | 0;
  i3 = HEAP16[i1 >> 1] | 0;
  i3 = i3 & 65535;
  i3 = i3 | 3181;
  i3 = i3 & 65535;
  HEAP16[i1 >> 1] = i3;
  i3 = HEAP32[gb + 1467948 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i3, i4, i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 2056;
  i4 = i5 + 188 | 0;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i4 >> 2] | 0, i5);
  i3 = HEAP16[i1 >> 1] | 0;
  i3 = i3 & 65535;
  i3 = i3 | 3181;
  i3 = i3 & 65535;
  HEAP16[i1 >> 1] = i3;
  i3 = HEAP32[gb + 1467948 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i3, i4, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 2) | 0, 0, i7 - i6 << 2 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37304 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 2048)) {
    if (!(i1 & 512)) {
     if (!(i1 & 1048576)) {
      HEAP32[i6 >> 2] = 0;
      break;
     }
     if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
     HEAP32[i6 >> 2] = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i1 & 16384)) {
     if (i1 & 1024 | 0) {
      d2 = +(HEAP32[i5 >> 2] | 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    HEAP32[i6 >> 2] = ~~d2 >>> 0;
   } else HEAP32[i6 >> 2] = HEAP32[i5 >> 2]; while (0);
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 4 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN5physx2Sn12RepXUpgrader35upgrade3_1CollectionTo3_2CollectionERNS0_14RepXCollectionE(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 24 | 0;
 i12 = i14 + 60 | 0;
 i5 = i14 + 48 | 0;
 i6 = i14;
 i10 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 56 >> 2] | 0, i13 | 0) | 0;
 __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj(i13, i10, gb + 142072 | 0, 245);
 i11 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 52 >> 2] | 0, i13 | 0, gb + 763455 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0) | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 36 >> 2] | 0, i13 | 0) | 0;
 if ((i1 | 0) == (i7 | 0)) {
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + 68 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(i12 | 0, i10 | 0);
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = i12 + 8 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(i12 | 0, i13 | 0);
  STACKTOP = i14;
  return i11 | 0;
 }
 i8 = i6 + 4 | 0;
 i9 = i6 + 16 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 40 >> 2] | 0, i13 | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0, i3 | 0);
  if (_strstr(i2, gb + 763461 | 0) | 0) {
   mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 64 >> 2] | 0, i10 | 0, gb + 763472 | 0) | 0;
   mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 64 >> 2] | 0, i10 | 0, gb + 763489 | 0) | 0;
   mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 64 >> 2] | 0, i10 | 0, gb + 763505 | 0) | 0;
  }
  i15 = HEAP32[(HEAP32[i11 >> 2] | 0) + 44 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i9 >> 2] = i3;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  mftCall_vii(i15 | 0, i11 | 0, i4 | 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i7 | 0));
 i15 = HEAP32[i10 >> 2] | 0;
 i15 = i15 + 68 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 mftCall_vi(i15 | 0, i10 | 0);
 i15 = HEAP32[i13 >> 2] | 0;
 i15 = i15 + 8 | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 mftCall_vi(i15 | 0, i13 | 0);
 STACKTOP = i14;
 return i11 | 0;
}

function __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 if (!(Math_fround(Math_abs(Math_fround(f1))) <= Math_fround(.999899983))) {
  f8 = Math_fround(Math_fround(0.0) - Math_fround(HEAPF32[i3 >> 2]));
  f7 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i3 + 4 >> 2]));
  f4 = Math_fround(Math_fround(0.0) - f1);
  f5 = Math_fround(Math_fround(2.0) / Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7))));
  f1 = Math_fround(f5 * Math_fround(Math_fround(Math_fround(f8 * Math_fround(0.0)) + f7) - f4));
  f9 = Math_fround(f5 * f8);
  f10 = Math_fround(f1 * f8);
  f11 = Math_fround(Math_fround(f10 * Math_fround(0.0)) - Math_fround(f9 * f8));
  i6 = i2 + 12 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f10 - Math_fround(f9 * f7));
  i3 = i2 + 24 | 0;
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(Math_fround(0.0) - Math_fround(f9 * f4)) - f10);
  HEAPF32[i2 >> 2] = Math_fround(f11 + Math_fround(1.0));
  f11 = Math_fround(f5 * f7);
  f10 = Math_fround(f1 * f7);
  HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(f10 * Math_fround(0.0)) - Math_fround(f11 * f8));
  f9 = Math_fround(f10 + Math_fround(Math_fround(-1.0) - Math_fround(f11 * f7)));
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f11 * f4)) - f10);
  HEAPF32[i6 + 4 >> 2] = Math_fround(f9 + Math_fround(1.0));
  f5 = Math_fround(f5 * f4);
  f1 = Math_fround(f1 * f4);
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(f1 * Math_fround(0.0)) + Math_fround(Math_fround(0.0) - Math_fround(f5 * f8)));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f1 + Math_fround(Math_fround(1.0) - Math_fround(f5 * f7)));
  HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(-1.0) - Math_fround(f5 * f4)) - f1) + Math_fround(1.0));
  return;
 } else {
  f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f12 = Math_fround(-f10);
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(f1 + Math_fround(1.0)));
  f13 = Math_fround(f5 * f12);
  f11 = Math_fround(f5 * Math_fround(0.0));
  f4 = Math_fround(f8 * f13);
  f7 = Math_fround(f13 * Math_fround(0.0));
  f9 = Math_fround(f8 * f11);
  HEAPF32[i2 >> 2] = Math_fround(f1 + Math_fround(f13 * f12));
  i3 = i2 + 12 | 0;
  HEAPF32[i3 >> 2] = f4;
  i6 = i2 + 24 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f8 + f7);
  HEAPF32[i2 + 4 >> 2] = Math_fround(f4 + Math_fround(0.0));
  HEAPF32[i3 + 4 >> 2] = Math_fround(f1 + Math_fround(f8 * Math_fround(f8 * f5)));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f10 + f9);
  HEAPF32[i2 + 8 >> 2] = Math_fround(f7 - f8);
  HEAPF32[i3 + 8 >> 2] = Math_fround(f9 - f10);
  HEAPF32[i6 + 8 >> 2] = Math_fround(f1 + Math_fround(f11 * Math_fround(0.0)));
  return;
 }
}

function __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE6extendEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i10 + 4 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = (HEAP32[i10 >> 2] | 0) * 1312 | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i7 = _PxGetFoundation() | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
 i7 = mftCall_iiiiii(i6 | 0, i8 | 0, i1 | 0, (i7 ? gb + 713623 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 140) | 0;
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 + 1 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[(HEAP32[i10 + 24 >> 2] | 0) + (i8 << 2) >> 2] = i7;
 i8 = i10 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = Math_imul(i1 << 2, i3) | 0;
 if (!i2) i2 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i2 = mftCall_iiiiii(i6 | 0, i1 | 0, i2 | 0, (i3 ? gb + 713623 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 147) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i6 = i10 + 32 | 0;
 i4 = ((Math_imul(i3, i1) | 0) + 31 | 0) >>> 5;
 i5 = i10 + 36 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i1 = i10 + 40 | 0;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i6 >> 2] | 0);
  }
  i3 = HEAP32[i5 >> 2] | 0;
  _memset(i2 + ((i3 & 2147483647) << 2) | 0, 0, i4 - i3 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i5 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i3 + -1 | 0;
 if ((i1 | 0) <= -1) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = i10 + 28 | 0;
 i4 = i10 + 20 | 0;
 while (1) {
  i5 = i7 + (i1 * 1312 | 0) | 0;
  __ZN5physx20PxsParticleSystemSimC2EPNS_10PxsContextEj(i5, HEAP32[i2 >> 2] | 0, (Math_imul((HEAP32[i9 >> 2] | 0) + -1 | 0, i3) | 0) + i1 | 0);
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i6 + 1;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] = i5;
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= -1) {
   i1 = 1;
   break;
  }
  i3 = HEAP32[i10 >> 2] | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_116CollectionSorter7ElementENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i5 = 0; else {
  i1 = i7 << 5;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 755013 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i12 = i2 + 8 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 8 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE(i1 + 16 | 0, i2 + 16 | 0);
   HEAP8[i1 + 28 >> 0] = HEAP8[i2 + 28 >> 0] | 0;
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i5 + (i1 << 5) >> 2] = HEAP32[i4 >> 2];
 i11 = i4 + 8 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = i5 + (i1 << 5) + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = i3;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE(i5 + (i1 << 5) + 16 | 0, i4 + 16 | 0);
 HEAP8[i5 + (i1 << 5) + 28 >> 0] = HEAP8[i4 + 28 >> 0] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + (i12 << 5) | 0;
 if ((i12 | 0) > 0) do {
  i12 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i12 | 0) > -1 & (i12 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 | 0) {
    i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i2 | 0);
   }
  }
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i6 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i6 >> 2] = i11;
  i12 = i5 + (i12 << 5) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i6 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i6 >> 2] = i11;
  i12 = i5 + (i12 << 5) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i8 >> 2] = i5;
 HEAP32[i9 >> 2] = i7;
 i12 = HEAP32[i6 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i6 >> 2] = i11;
 i12 = i5 + (i12 << 5) | 0;
 return i12 | 0;
}

function __ZN12MeshCollider7CleanupEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = i5 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i5 + 76 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i5 + 88 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i5 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i5 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i5 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = i5 + 120 | 0;
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 do if (!(HEAP8[i5 + 61 >> 0] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) == 4) {
  HEAP32[i4 >> 2] = 4;
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 28 >> 2] = Math_fround(1.0);
  i1 = i4 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i4 | 0) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  break;
 } else {
  HEAP32[i4 >> 2] = 5;
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 28 >> 2] = Math_fround(1.0);
  i1 = i4 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 + 36 >> 2] | 0;
  break;
 } else i1 = 0; while (0);
 if (HEAP32[i3 >> 2] | 0) {
  if (__Z12GetIVehiclesv() | 0) {
   i4 = __Z12GetIVehiclesv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i5 | 0);
  }
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0) | 0;
  if (!(HEAP32[i2 + 8 >> 2] | 0)) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0); else mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, 1);
  HEAP32[i3 >> 2] = 0;
 }
 if (!i1) {
  i5 = i5 + 120 | 0;
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 i5 = i5 + 120 | 0;
 HEAP8[i5 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i5 = i1;
  i1 = i1 + -24 | 0;
  HEAP32[i6 + -24 >> 2] = HEAP32[i1 >> 2];
  i2 = i6 + -20 | 0;
  i4 = i5 + -20 | 0;
  i7 = HEAP8[i4 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i4 >> 2] | 0 : i4;
  i7 = i3 ? HEAP32[i5 + -16 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -8 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -8 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -12 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -16 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  HEAP32[i6 + -4 >> 2] = HEAP32[i5 + -4 >> 2];
  i6 = (HEAP32[i13 >> 2] | 0) + -24 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -24 | 0;
  i5 = i1;
  i1 = i1 + -24 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -20 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -12 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -12 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -16 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -20 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  i5 = i5 + -8 | 0;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i17 = i6 + -8 | 0;
  HEAP32[i17 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i17 + 4 >> 2] = i7;
  i6 = (HEAP32[i13 >> 2] | 0) + -24 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf(i4, i8, i9, i10, i11) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f5 = f0, i6 = 0, i7 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i8 & 983040 | 0) == 65536 & 0 == 0) {
  i7 = i8 & 65535;
  if (i7 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i11 = -2147483648;
   return i11 | 0;
  }
  i9 = _bitshift64Lshr(i8 | 0, i9 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i1 + (i7 * 104 | 0) | 0) == 0 ? 1 : (i9 | 0) != (HEAP32[i1 + (i7 * 104 | 0) + 92 >> 2] | 0)) {
   i11 = -2147483648;
   return i11 | 0;
  }
  f14 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + (i7 * 104 | 0) + 12 >> 2]);
  f16 = Math_fround(f14 - f5);
  f13 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  i6 = i1 + (i7 * 104 | 0) + 16 | 0;
  f3 = Math_fround(f13 - Math_fround(HEAPF32[i6 >> 2]));
  f12 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  i2 = i1 + (i7 * 104 | 0) + 20 | 0;
  f15 = Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2]));
  f15 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f3 * f3)) + Math_fround(f15 * f15));
  f3 = Math_fround(HEAPF32[i1 + (i7 * 104 | 0) + 44 >> 2]);
  f14 = Math_fround(f14 - f3);
  i4 = i1 + (i7 * 104 | 0) + 48 | 0;
  f13 = Math_fround(f13 - Math_fround(HEAPF32[i4 >> 2]));
  i1 = i1 + (i7 * 104 | 0) + 52 | 0;
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i1 >> 2]));
  if (f15 < Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(f12 * f12))) {
   HEAPF32[i11 >> 2] = f5;
   HEAP32[i11 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i2 >> 2];
   i11 = 1073741824;
   return i11 | 0;
  } else {
   HEAPF32[i11 >> 2] = f3;
   HEAP32[i11 + 4 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 >> 2];
   i11 = 1073741824;
   return i11 | 0;
  }
 }
 if ((i8 | 0) == 0 & (i9 | 0) == 0) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i6 = _bitshift64Lshr(i8 | 0, i9 | 0, 20) | 0;
 getTempRet0() | 0;
 i6 = i6 & 268435455;
 i7 = i8 & 65535;
 if (i6 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i2 = _bitshift64Lshr(i8 | 0, i9 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i6 * 56 | 0) + 4 >> 2] | 0) != (i2 | 0)) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i2 = HEAP32[i1 + (i6 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i11 = -2147483640;
  return i11 | 0;
 }
 if (i7 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i11 = -2147483640;
  return i11 | 0;
 }
 __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf(i10, (HEAP32[i1 + (i6 * 56 | 0) + 16 >> 2] | 0) + (i7 << 5) | 0, i1 + (i6 * 56 | 0) | 0, i11);
 __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i4, i8, i9, i11, i11 + 4 | 0) | 0;
 i11 = 1073741824;
 return i11 | 0;
}

function __ZN16HeightMeshBVNode8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i2 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843849 | 0, i2, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i3 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 843853 | 0, i2, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 24 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1085953 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 1086007 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 29; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 29; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 29) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _UNITY_png_handle_pCAL(i12, i13, i6) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = HEAP32[i12 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i12, gb + 352205 | 0);
 if (i1 & 4 | 0) {
  _UNITY_png_crc_finish(i12, i6) | 0;
  _UNITY_png_chunk_benign_error(i12, gb + 352423 | 0);
  return;
 }
 if (i13 | 0) if (HEAP32[i13 + 8 >> 2] & 1024 | 0) {
  _UNITY_png_crc_finish(i12, i6) | 0;
  _UNITY_png_chunk_benign_error(i12, gb + 352436 | 0);
  return;
 }
 i3 = i6 + 1 | 0;
 i4 = i12 + 644 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = 11; else {
  i2 = i12 + 648 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < i3 >>> 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   _UNITY_png_free(i12, i1);
   i5 = 11;
  }
 }
 do if ((i5 | 0) == 11) {
  i1 = _UNITY_png_malloc_base(i12, i3) | 0;
  if (i1 | 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i12 + 648 >> 2] = i3;
   break;
  }
  _UNITY_png_crc_finish(i12, i6) | 0;
  _UNITY_png_chunk_benign_error(i12, gb + 661520 | 0);
  return;
 } while (0);
 _UNITY_png_read_data(i12, i1, i6);
 _UNITY_png_calculate_crc(i12, i1, i6);
 if (_UNITY_png_crc_finish(i12, 0) | 0) return;
 i11 = i1 + i6 | 0;
 HEAP8[i11 >> 0] = 0;
 i3 = i1;
 while (1) {
  i2 = i3 + 1 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) break; else i3 = i2;
 }
 if (i11 >>> 0 <= (i3 + 12 | 0) >>> 0) {
  _UNITY_png_chunk_benign_error(i12, gb + 352446 | 0);
  return;
 }
 i9 = HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i3 + 3 >> 0] << 8 | HEAPU8[i3 + 4 >> 0];
 i10 = HEAPU8[i3 + 6 >> 0] << 16 | HEAPU8[i3 + 5 >> 0] << 24 | HEAPU8[i3 + 7 >> 0] << 8 | HEAPU8[i3 + 8 >> 0];
 i2 = HEAP8[i3 + 9 >> 0] | 0;
 i4 = HEAP8[i3 + 10 >> 0] | 0;
 i7 = i3 + 11 | 0;
 i8 = i2 & 255;
 if (i2 << 24 >> 24 != 0 | i4 << 24 >> 24 == 2) if ((i2 + -1 & 255) > 1 | i4 << 24 >> 24 == 3) if (i2 << 24 >> 24 != 3 | i4 << 24 >> 24 == 4) {
  if ((i2 & 255) > 3) {
   _UNITY_png_chunk_benign_error(i12, gb + 352767 | 0);
   i2 = i7;
  } else i2 = i7;
  while (1) if (!(HEAP8[i2 >> 0] | 0)) break; else i2 = i2 + 1 | 0;
  i5 = i4 & 255;
  i6 = _UNITY_png_malloc_warn(i12, i5 << 2) | 0;
  if (!i6) {
   _UNITY_png_chunk_benign_error(i12, gb + 661520 | 0);
   return;
  }
  L46 : do if (i4 << 24 >> 24) {
   i3 = 0;
   L47 : while (1) {
    i2 = i2 + 1 | 0;
    HEAP32[i6 + (i3 << 2) >> 2] = i2;
    if (i2 >>> 0 > i11 >>> 0) break;
    while (1) {
     if (!(HEAP8[i2 >> 0] | 0)) break;
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 > i11 >>> 0) break L47;
    }
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i5 | 0)) break L46;
   }
   _UNITY_png_free(i12, i6);
   _UNITY_png_chunk_benign_error(i12, gb + 352794 | 0);
   return;
  } while (0);
  _UNITY_png_set_pCAL(i12, i13, i1, i9, i10, i8, i5, i7, i6);
  _UNITY_png_free(i12, i6);
  return;
 }
 _UNITY_png_chunk_benign_error(i12, gb + 352743 | 0);
 return;
}

function __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (HEAP32[i1 + 1188 >> 2] & 6 | 0) {
  i9 = HEAP32[i1 + 1204 >> 2] | 0;
  i1 = 0;
  i2 = 0;
  i3 = gb + 90604 | 0;
  do {
   if (i3 >>> 0 >= (gb + 90604 + 12 | 0) >>> 0) break;
   i8 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 + 16 + (i8 * 12 | 0) >> 2] | 0;
   i8 = HEAP32[i9 + 16 + (i8 * 12 | 0) + 4 >> 2] | 0;
   i2 = i1;
   i1 = i1 + (i8 << 2) | 0;
   i3 = i3 + 4 | 0;
  } while ((i8 | 0) <= 0);
  i4 = i2;
  if (i4 >>> 0 < i1 >>> 0) do {
   i8 = i1 + -4 | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   i6 = (i6 | 0) == 0 ? 0 : i6 + -8 | 0;
   i7 = i6 + 4 | 0;
   HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 0 | 65534;
   i5 = i6 + 6 | 0;
   i1 = HEAP16[i5 >> 1] | 0;
   if (!(i1 & 2)) {
    __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i6);
    i1 = (HEAPU16[i5 >> 1] | 0 | 2) & 65535;
    HEAP16[i5 >> 1] = i1;
   }
   if (!(i1 & 1)) i10 = 11; else if (!(HEAP16[i7 >> 1] & 1)) i10 = 11; else if ((__ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i11, i6, 0, 0) | 0) == (i6 | 0)) i10 = 11;
   if ((i10 | 0) == 11) {
    i10 = 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, 0);
   }
   i1 = i8;
   L18 : do if (i4 >>> 0 >= i8 >>> 0) do {
    if (i3 >>> 0 >= (gb + 90604 + 12 | 0) >>> 0) break L18;
    i8 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i9 + 16 + (i8 * 12 | 0) >> 2] | 0;
    i8 = HEAP32[i9 + 16 + (i8 * 12 | 0) + 4 >> 2] | 0;
    i2 = i1;
    i1 = i1 + (i8 << 2) | 0;
    i3 = i3 + 4 | 0;
   } while ((i8 | 0) <= 0); while (0);
   i4 = i2;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i7 = i11 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i11 + 72 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
   if (!(HEAP16[i3 + 6 >> 1] & 1)) i10 = 20; else if (!(HEAP16[i3 + 4 >> 1] & 1)) i10 = 20; else if ((__ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i11, i3, 0, 0) | 0) == (i3 | 0)) i10 = 20;
   if ((i10 | 0) == 20) {
    i10 = 0;
    mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 0);
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i11 + 88 >> 2] | 0;
 if (!i1) return;
 if (!(HEAP32[i7 >> 2] | 0)) return;
 _memset(HEAP32[i11 + 80 >> 2] | 0, -1, i1 << 2 | 0) | 0;
 i6 = i11 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2 + -1 | 0;
 i4 = i11 + 76 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i5) {
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + (i3 << 2) >> 2] = i2;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
 HEAP32[i11 + 96 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeE(i8, i5, i9, i1, i3, i4, i2) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 if ((i3 | 0) <= (i4 | 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i3 | 0)) return;
  i7 = ((i3 + -8 + (0 - i1) | 0) >>> 3) + 1 | 0;
  i5 = i2;
  i6 = i1;
  while (1) {
   i11 = i6;
   i6 = HEAP32[i11 + 4 >> 2] | 0;
   i8 = i5;
   HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i8 + 4 >> 2] = i6;
   i4 = i4 + 8 | 0;
   if ((i4 | 0) == (i3 | 0)) break; else {
    i5 = i5 + 8 | 0;
    i6 = i4;
   }
  }
  i8 = i2 + (i7 << 3) | 0;
  if ((i8 | 0) == (i2 | 0)) return;
  i7 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((i3 | 0) == (i7 | 0)) break;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i6 = i1;
   if ((i4 | 0) < (i5 | 0)) {
    HEAP32[i6 >> 2] = i4;
    i4 = i2;
    i5 = i3;
    i3 = i3 + 8 | 0;
   } else {
    HEAP32[i6 >> 2] = i5;
    i4 = i2 + 8 | 0;
    i5 = i2;
   }
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   if ((i4 | 0) == (i8 | 0)) {
    i10 = 26;
    break;
   } else {
    i2 = i4;
    i1 = i6 + 8 | 0;
   }
  }
  if ((i10 | 0) == 26) return;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i2 = i2 + 8 | 0;
   if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 8 | 0;
  }
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i3;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) return;
 i7 = ((i1 + -8 + (0 - i3) | 0) >>> 3) + 1 | 0;
 i6 = i2;
 i5 = i3;
 i3 = i4;
 while (1) {
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i11 = i6;
  HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 4 >> 2] = i9;
  i3 = i3 + 8 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else {
   i6 = i6 + 8 | 0;
   i5 = i3;
  }
 }
 i5 = i2 + (i7 << 3) | 0;
 if ((i5 | 0) == (i2 | 0)) return;
 i9 = HEAP32[i8 >> 2] | 0;
 i3 = i5;
 i8 = i5;
 while (1) {
  if ((i4 | 0) == (i9 | 0)) break;
  i5 = HEAP32[i4 + -8 >> 2] | 0;
  i6 = HEAP32[i8 + -8 >> 2] | 0;
  i7 = i1 + -8 | 0;
  if ((i5 | 0) < (i6 | 0)) {
   HEAP32[i7 >> 2] = i6;
   i6 = i8 + -8 | 0;
   i7 = i8;
   i5 = i6;
  } else {
   HEAP32[i7 >> 2] = i5;
   i7 = i4;
   i4 = i4 + -8 | 0;
   i5 = i3;
   i6 = i8;
  }
  HEAP32[i1 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
  if ((i6 | 0) == (i2 | 0)) {
   i10 = 26;
   break;
  } else {
   i3 = i5;
   i1 = i1 + -8 | 0;
   i8 = i6;
  }
 }
 if ((i10 | 0) == 26) return;
 if ((i3 | 0) == (i2 | 0)) return;
 while (1) {
  HEAP32[i1 + -8 >> 2] = HEAP32[i3 + -8 >> 2];
  HEAP32[i1 + -4 >> 2] = HEAP32[i3 + -4 >> 2];
  i3 = i3 + -8 | 0;
  if ((i3 | 0) == (i2 | 0)) break; else i1 = i1 + -8 | 0;
 }
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv(i14, i6) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i13 >> 2] | 0);
 i11 = i14 + 76 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i14);
  return;
 }
 i3 = i6;
 i3 = i3 + ~(i3 << 15) | 0;
 i3 = (i3 >>> 10 ^ i3) * 9 | 0;
 i3 = i3 >>> 6 ^ i3;
 i3 = i3 + ~(i3 << 11) | 0;
 i12 = i14 + 68 | 0;
 i3 = (HEAP32[i12 >> 2] | 0) + ((i1 + -1 & (i3 >>> 16 ^ i3)) << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i14);
  return;
 }
 i10 = i14 + 60 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 64 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i2 = i1;
 while (1) {
  i1 = i3;
  i3 = i5 + (i2 << 2) | 0;
  i4 = i2;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i8 + (i4 << 4) >> 2] | 0) == (i6 | 0)) {
   i5 = i4;
   break;
  }
  if ((i2 | 0) == -1) {
   i7 = 11;
   break;
  }
 }
 if ((i7 | 0) == 11) {
  i14 = HEAP32[i13 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i14);
  return;
 }
 HEAP32[i1 >> 2] = i2;
 i3 = i14 + 92 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i7 = i14 + 88 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i8 + (i5 << 4) >> 2] = HEAP32[i8 + (i1 << 4) >> 2];
  HEAP8[i8 + (i5 << 4) + 4 >> 0] = HEAP8[i8 + (i1 << 4) + 4 >> 0] | 0;
  HEAP8[i8 + (i5 << 4) + 5 >> 0] = HEAP8[i8 + (i1 << 4) + 5 >> 0] | 0;
  i4 = i8 + (i5 << 4) + 6 | 0;
  i2 = i8 + (i1 << 4) + 6 | 0;
  i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
  HEAP8[i4 >> 0] = i2;
  HEAP8[i4 + 1 >> 0] = i2 >> 8;
  HEAP8[i4 + 2 >> 0] = i2 >> 16;
  HEAP8[i4 + 3 >> 0] = i2 >> 24;
  HEAP8[i8 + (i5 << 4) + 10 >> 0] = HEAP8[i8 + (i1 << 4) + 10 >> 0] | 0;
  HEAP8[i8 + (i5 << 4) + 11 >> 0] = HEAP8[i8 + (i1 << 4) + 11 >> 0] | 0;
  HEAP8[i8 + (i5 << 4) + 12 >> 0] = HEAP8[i8 + (i1 << 4) + 12 >> 0] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 >> 2] << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 4) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i11 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 84 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = HEAP32[i13 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i14);
 return;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj(i8, i9, i5, i6, i4, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i11 = 0, i12 = 0;
 i1 = i9 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i9 + 24 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i3 = i12;
 if (i2 >>> 0 < i12 >>> 0) {
  HEAP32[i1 >> 2] = i12;
  i7 = i3;
 } else i7 = i2;
 i1 = i10 & 24;
 if (!i1) {
  i12 = i8;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i12 = i8 + 8 | 0;
  HEAP32[i12 >> 2] = -1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 }
 if ((i4 | 0) == 1 & (i1 | 0) == 24) {
  i12 = i8;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  i12 = i8 + 8 | 0;
  HEAP32[i12 >> 2] = -1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 }
 L12 : do switch (i4 | 0) {
 case 0:
  {
   i1 = 0;
   i2 = 0;
   break;
  }
 case 1:
  if (!(i10 & 8)) {
   i2 = i3 - (HEAP32[i9 + 20 >> 2] | 0) | 0;
   i1 = i2;
   i2 = ((i2 | 0) < 0) << 31 >> 31;
   break L12;
  } else {
   i2 = (HEAP32[i9 + 12 >> 2] | 0) - (HEAP32[i9 + 8 >> 2] | 0) | 0;
   i1 = i2;
   i2 = ((i2 | 0) < 0) << 31 >> 31;
   break L12;
  }
 case 2:
  {
   i1 = i9 + 32 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i2 = i7 - i1 | 0;
   i1 = i2;
   i2 = ((i2 | 0) < 0) << 31 >> 31;
   break;
  }
 default:
  {
   i12 = i8;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i12 = i8 + 8 | 0;
   HEAP32[i12 >> 2] = -1;
   HEAP32[i12 + 4 >> 2] = -1;
   return;
  }
 } while (0);
 i2 = _i64Add(i1 | 0, i2 | 0, i5 | 0, i6 | 0) | 0;
 i3 = getTempRet0() | 0;
 if ((i3 | 0) >= 0) {
  i1 = i9 + 32 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i6 = i7 - i1 | 0;
  i5 = ((i6 | 0) < 0) << 31 >> 31;
  if (!((i5 | 0) < (i3 | 0) | (i5 | 0) == (i3 | 0) & i6 >>> 0 < i2 >>> 0)) {
   i1 = i10 & 8;
   if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
    if (i1 | 0) if (!(HEAP32[i9 + 12 >> 2] | 0)) {
     i12 = i8;
     HEAP32[i12 >> 2] = 0;
     HEAP32[i12 + 4 >> 2] = 0;
     i12 = i8 + 8 | 0;
     HEAP32[i12 >> 2] = -1;
     HEAP32[i12 + 4 >> 2] = -1;
     return;
    }
    if ((i10 & 16 | 0) != 0 & (i12 | 0) == 0) {
     i12 = i8;
     HEAP32[i12 >> 2] = 0;
     HEAP32[i12 + 4 >> 2] = 0;
     i12 = i8 + 8 | 0;
     HEAP32[i12 >> 2] = -1;
     HEAP32[i12 + 4 >> 2] = -1;
     return;
    }
   }
   if (i1 | 0) {
    HEAP32[i9 + 12 >> 2] = (HEAP32[i9 + 8 >> 2] | 0) + i2;
    HEAP32[i9 + 16 >> 2] = i7;
   }
   if (i10 & 16 | 0) HEAP32[i11 >> 2] = (HEAP32[i9 + 20 >> 2] | 0) + i2;
   i12 = i8;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   i12 = i8 + 8 | 0;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i12 + 4 >> 2] = i3;
   return;
  }
 }
 i12 = i8;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i12 = i8 + 8 | 0;
 HEAP32[i12 >> 2] = -1;
 HEAP32[i12 + 4 >> 2] = -1;
 return;
}

function __ZN9Transform16SetLocalRotationERK11Quaternionf(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i10 = i12 + 32 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i10 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 f13 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f15 * f15)) + Math_fround(Math_fround(f14 * f14) + Math_fround(f17 * f17)));
 f2 = Math_fround(Math_sqrt(Math_fround(f13)));
 f16 = Math_fround(f16 / f2);
 f15 = Math_fround(f15 / f2);
 f14 = Math_fround(f14 / f2);
 f2 = Math_fround(f17 / f2);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f13 > Math_fround(1.0e-30);
 i3 = i9 ? i3 : 0;
 i4 = i9 ? i4 : 0;
 i5 = i9 ? i5 : 0;
 i7 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i19 = i1 + (i11 * 40 | 0) + 12 | 0;
 f17 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f17 != Math_fround(HEAPF32[i19 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = i1 + (i11 * 40 | 0) + 16 | 0;
 i20 = f17 != Math_fround(HEAPF32[i18 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i1 + (i11 * 40 | 0) + 20 | 0;
 i21 = f17 != Math_fround(HEAPF32[i6 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i1 + (i11 * 40 | 0) + 24 | 0;
 i9 = f17 != Math_fround(HEAPF32[i8 >> 2]) | (i21 | (i20 | i9));
 HEAP32[i19 >> 2] = i3;
 HEAP32[i18 >> 2] = i4;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 if (!i9) return;
 i4 = HEAP32[i10 + 44 >> 2] | HEAP32[i10 + 40 >> 2];
 i5 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 if (i5 | 0) {
  i6 = HEAP32[i10 + 60 >> 2] | 0;
  i7 = HEAP32[i10 + 56 >> 2] | 0;
  i8 = i10 + 36 | 0;
  i9 = HEAP32[i10 + 68 >> 2] | 0;
  i3 = 0;
  i1 = i11;
  while (1) {
   i21 = HEAP32[i6 + (i1 << 2) >> 2] & i4;
   i20 = i7 + (i1 << 2) | 0;
   HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i21;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i21;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i5 | 0)) break; else i1 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  }
 }
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(i10, HEAP32[i12 + 36 >> 2] | 0, 2);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i12 + 32 >> 2] | 0);
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i4;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (!i3) {
  i7 = i4;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i1 = i11 + 12 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i6 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i6;
  i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i6, 1, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i3;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 1, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i11 >> 2] = i3;
  break;
 } while (0);
 if (i6 >>> 0 > i7 >>> 0) {
  i1 = i6 - i7 | 0;
  if (i1 | 0) _memset(i3 + i7 | 0, 0, i1 | 0) | 0;
 }
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37252 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 1024)) {
    if (!(i1 & 512)) {
     if (!(i1 & 1048576)) {
      i1 = 0;
      break;
     }
     if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
     i1 = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i1 & 16384)) {
     if (i1 & 2048 | 0) {
      d2 = +((HEAP32[i5 >> 2] | 0) >>> 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    i1 = ~~d2 >>> 0;
   } else i1 = HEAP32[i5 >> 2] | 0; while (0);
   HEAP8[i6 >> 0] = i1;
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 1 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN18AnimatorController19TransferRuntimeDataI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i3 = i8 + 4 | 0;
 HEAP32[i3 >> 2] = i7 + 104;
 i4 = i7 + 128 | 0;
 i5 = i7 + 132 | 0;
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i8 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i1, HEAP32[i5 >> 2] | 0);
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 24, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
 }
 __ZN7mecanim9animation18ControllerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
 __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i8, i7 + 140 | 0, 0);
 i4 = i7 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
 i1 = HEAP32[i7 + 80 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN38StateMachineBehaviourVectorDescription8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 156 | 0, i8);
 i4 = i7 + 204 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
 i1 = HEAP32[i7 + 192 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN4PPtrI13MonoBehaviourE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i7 + 152 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __Z15CreatePrimitivei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 switch (i1 | 0) {
 case 0:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444939 | 0, 6);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 case 1:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444946 | 0, 7);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 1) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444954 | 0, 8);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 2) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 case 3:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444963 | 0, 4);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 3) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 case 4:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444968 | 0, 5);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 4) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 case 5:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1046280 | 0, 4);
   i1 = __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i2, 5) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i2 = i1;
   STACKTOP = i3;
   return i2 | 0;
  }
 default:
  {
   i2 = 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Transform8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 136 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 140 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 144 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 148 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 152 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 156 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 160 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 164 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 168 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 172 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i7 + 177 | 0;
  HEAP8[i8 >> 0] = 1;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i7 + 177 | 0;
  HEAP8[i8 >> 0] = 1;
  return;
 }
}

function __Z25GetSplashScreenBackgroundRK5RectTIfE(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i5 = (__Z17GetPlayerSettingsv() | 0) + 144 | 0;
 i4 = __ZNK26PlayerSettingsSplashScreen34GetSplashScreenBackgroundLandscapeEv(i5) | 0;
 if (!i4) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 9; else i6 = i1;
  }
 }
 if ((i9 | 0) == 7) i9 = 9;
 if ((i9 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  } else i6 = i1;
 }
 i4 = __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv(i5) | 0;
 if (!i4) {
  i10 = i6;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   i10 = i6;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 f12 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 i10 = f12 < Math_fround(HEAPF32[i10 + 12 >> 2]);
 i10 = i10 ? i1 : i6;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i3 = i1 >>> 0 > 8 ? 8 : i1;
 if (!i3) {
  i1 = i8 + 64 | 0;
  HEAP8[i1 >> 0] = i3;
 } else {
  i1 = 0;
  do {
   f9 = Math_fround(HEAPF32[i2 + (i1 * 20 | 0) >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i8 + (i1 << 2) >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i2 + (i1 * 20 | 0) + 4 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i8 + (i1 << 2) + 1 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i2 + (i1 * 20 | 0) + 8 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i8 + (i1 << 2) + 2 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i2 + (i1 * 20 | 0) + 16 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP16[i8 + 32 + (i1 << 1) >> 1] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(65535.0)) + Math_fround(.5)) >>> 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
  i2 = i3 & 255;
  i1 = i8 + 64 | 0;
  HEAP8[i1 >> 0] = i2;
  i7 = i3 & 255;
  if (i7 >>> 0 > 1) {
   i2 = 0;
   i6 = 1;
   while (1) {
    i3 = i8 + 32 + (i2 << 1) | 0;
    i4 = HEAP16[i3 >> 1] | 0;
    i5 = i8 + 32 + (i6 << 1) | 0;
    if ((i4 & 65535) > (HEAPU16[i5 >> 1] | 0)) {
     i11 = i8 + (i2 << 2) | 0;
     i14 = HEAP8[i11 >> 0] | 0;
     i16 = i8 + (i2 << 2) + 1 | 0;
     i12 = HEAP8[i16 >> 0] | 0;
     i15 = i8 + (i2 << 2) + 2 | 0;
     i10 = HEAP8[i15 >> 0] | 0;
     i13 = i8 + (i6 << 2) | 0;
     HEAP8[i11 >> 0] = HEAP8[i13 >> 0] | 0;
     i11 = i8 + (i6 << 2) + 1 | 0;
     HEAP8[i16 >> 0] = HEAP8[i11 >> 0] | 0;
     i6 = i8 + (i6 << 2) + 2 | 0;
     HEAP8[i15 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP16[i3 >> 1] = HEAP16[i5 >> 1] | 0;
     HEAP8[i13 >> 0] = i14;
     HEAP8[i11 >> 0] = i12;
     HEAP8[i6 >> 0] = i10;
     HEAP16[i5 >> 1] = i4;
     i2 = (i2 | 0) > 0 ? i2 + -2 | 0 : i2;
    }
    i6 = i2 + 2 | 0;
    if ((i6 | 0) >= (i7 | 0)) break; else i2 = i2 + 1 | 0;
   }
   i2 = HEAP8[i1 >> 0] | 0;
  }
  if ((i2 & 255) >= 2) return;
 }
 HEAP8[i1 >> 0] = 2;
 i16 = i8 + 4 | 0;
 HEAP8[i16 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP8[i16 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
 HEAP8[i16 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
 HEAP16[i8 + 32 >> 1] = 0;
 HEAP16[i8 + 34 >> 1] = -1;
 return;
}

function __ZL38GetApplicationSpecificDataPathAppendixNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN9dtNavMesh20addOffMeshConnectionEPK25dtOffMeshConnectionParams(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 if (!(HEAP32[i10 + 24 >> 2] | 0)) {
  i10 = 0;
  i11 = 0;
  setTempRet0(i10 | 0);
  return i11 | 0;
 }
 i8 = i10 + 40 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i7 = i10 + 44 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = (i6 | 0) == 0 ? 4 : i6 << 1;
  i1 = i10 + 48 | 0;
  if (i6 >>> 0 < i3 >>> 0) {
   i5 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 * 104 | 0) | 0;
   if (!i5) i2 = HEAP32[i8 >> 2] | 0; else {
    HEAP32[i1 >> 2] = i5;
    i2 = HEAP32[i7 >> 2] | 0;
    i6 = i3 + -1 | 0;
    if (i2 >>> 0 < i6 >>> 0) {
     i4 = i2;
     do {
      HEAP32[i5 + (i4 * 104 | 0) + 92 >> 2] = 1;
      i12 = i4;
      i4 = i4 + 1 | 0;
      HEAP32[i5 + (i12 * 104 | 0) + 96 >> 2] = i4;
     } while ((i4 | 0) != (i6 | 0));
    }
    HEAP32[i5 + (i6 * 104 | 0) + 92 >> 2] = 1;
    HEAP32[i5 + (i6 * 104 | 0) + 96 >> 2] = -1;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
   }
   if ((i2 | 0) == -1) i2 = -1; else i9 = 11;
  } else i2 = -1;
 } else {
  i1 = i10 + 48 | 0;
  i9 = 11;
 }
 if ((i9 | 0) == 11) {
  i12 = (HEAP32[i1 >> 2] | 0) + (i2 * 104 | 0) + 96 | 0;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + (i2 * 104 | 0) | 0;
 i4 = i1 + (i2 * 104 | 0) + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i3;
 i7 = i6 + 104 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i4 >> 2] = i5;
 i12 = i10 + 52 | 0;
 HEAP32[i1 + (i2 * 104 | 0) + 96 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 32 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 36 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 40 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 64 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 68 >> 2] = HEAP32[i11 + 28 >> 2];
 HEAP8[i1 + (i2 * 104 | 0) + 72 >> 0] = HEAP8[i11 + 32 >> 0] | 0;
 HEAP32[i1 + (i2 * 104 | 0) + 76 >> 2] = HEAP32[i11 + 36 >> 2];
 i12 = HEAP32[i11 + 40 >> 2] | 0;
 HEAP8[i1 + (i2 * 104 | 0) + 80 >> 0] = i12;
 HEAP16[i1 + (i2 * 104 | 0) + 82 >> 1] = i12 >>> 16;
 HEAP32[i1 + (i2 * 104 | 0) + 84 >> 2] = HEAP32[i11 + 44 >> 2];
 HEAP32[i1 + (i2 * 104 | 0) + 88 >> 2] = -1;
 i12 = _bitshift64Shl(i5 | 0, 0, 48) | 0;
 i11 = getTempRet0() | 0;
 __ZN9dtNavMesh24connectOffMeshConnectionEj(i10, i2);
 i10 = i10 + 56 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
 HEAP32[i10 >> 2] = (i9 | 0) == 0 ? 1 : i9;
 i12 = i2 | i12 | 65536;
 setTempRet0(i11 | 0);
 return i12 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14AddVectorParamEPKcii15ShaderParamTypei(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 48 | 0;
 i9 = i11 + 12 | 0;
 i10 = i11;
 i12 = HEAP32[i1 + 172 >> 2] | 0;
 i1 = (HEAP32[i1 + 168 >> 2] | 0) == (i12 | 0) ? i1 + 108 | 0 : i12 + -16 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i2, _strlen(i2) | 0);
 __ZN9ShaderLab20SerializedSubProgram15VectorParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei(i9, i10, i3, i4, i5, i6);
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1, i9);
  i1 = i9 + 11 | 0;
 } else {
  i1 = i9 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i7 = 5;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i7 = 7;
   }
  } else i7 = 5;
  if ((i7 | 0) == 5) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i8 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i7 = 7;
  }
  if ((i7 | 0) == 7) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i12 = i6 + 16 | 0;
  i7 = i9 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP8[i12 + 16 >> 0] = HEAP8[i7 + 16 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 36;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14AddMatrixParamEPKcii15ShaderParamTypei(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 48 | 0;
 i9 = i11 + 12 | 0;
 i10 = i11;
 i12 = HEAP32[i1 + 172 >> 2] | 0;
 i1 = (HEAP32[i1 + 168 >> 2] | 0) == (i12 | 0) ? i1 + 120 | 0 : i12 + -28 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i2, _strlen(i2) | 0);
 __ZN9ShaderLab20SerializedSubProgram15MatrixParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei(i9, i10, i3, i4, i5, i6);
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i1, i9);
  i1 = i9 + 11 | 0;
 } else {
  i1 = i9 + 11 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i3 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  i4 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i6 + 12 >> 2] | 0;
   i7 = 5;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i6 + 11 >> 0] = i4;
   if (!i4) i2 = i6; else {
    i2 = i6;
    i7 = 7;
   }
  } else i7 = 5;
  if ((i7 | 0) == 5) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i8 + 4 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i6 + 4 >> 2] = i4;
   i7 = 7;
  }
  if ((i7 | 0) == 7) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i2 + i4 >> 0] = 0;
  i12 = i6 + 16 | 0;
  i7 = i9 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP8[i12 + 16 >> 0] = HEAP8[i7 + 16 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 36;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx15PxSerialization24serializeCollectionToXmlERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPNS_9PxCookingEPKS3_PNS0_18PxXmlMiscParameterE(i11, i10, i4, i1, i2, i3) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 32 | 0;
 i12 = i14 + 16 | 0;
 i8 = i14;
 if (!(__ZN5physx15PxSerialization14isSerializableERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_(i10, i4, i2) | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i9 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = 0;
 i7 = __Z18PxCreateCollectionv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, i10 | 0);
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, i2 | 0);
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0) | 0;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 164, gb + 766713 | 0, gb + 766736 | 0, 698) | 0;
 __ZN5physx2Sn18RepXCollectionImplC2ERNS_23PxSerializationRegistryERNS_19PxAllocatorCallbackERNS_12PxCollectionE(i6, i4, i5, i7);
 if (i3 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i3 + 12 | 0);
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, i3 | 0);
 }
 i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0, i10 | 0) | 0;
 if (i5 | 0) {
  __ZN5physx2Sn14sortCollectionERNS_2Cm10CollectionERNS0_21SerializationRegistryEb(i10, i4, 1);
  i1 = i12 + 4 | 0;
  i2 = i12 + 8 | 0;
  i4 = 0;
  do {
   i3 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0, i10 | 0, i4 | 0) | 0;
   if ((HEAP16[i3 + 4 >> 1] | 0) == 7) {
    if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0)) i13 = 10;
   } else i13 = 10;
   if ((i13 | 0) == 10) {
    i13 = 0;
    i18 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0, i3 | 0) | 0;
    i16 = getTempRet0() | 0;
    i17 = (i18 | 0) == 0 & (i16 | 0) == 0;
    HEAP32[i12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0) | 0;
    HEAP32[i1 >> 2] = i3;
    i15 = i2;
    HEAP32[i15 >> 2] = i17 ? i3 : i18;
    HEAP32[i15 + 4 >> 2] = i17 ? 0 : i16;
    mftCall_viiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 68 >> 2] | 0, i8 | 0, i6 | 0, i12 | 0, i7 | 0, i9 | 0);
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i5 >>> 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 56 >> 2] | 0, i7 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 72 >> 2] | 0, i6 | 0, i11 | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0);
 i18 = 1;
 STACKTOP = i14;
 return i18 | 0;
}

function __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE6extendEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i10 + 4 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = (HEAP32[i10 >> 2] | 0) * 52 | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i7 = _PxGetFoundation() | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
 i7 = mftCall_iiiiii(i6 | 0, i8 | 0, i1 | 0, (i7 ? gb + 713751 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 140) | 0;
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 + 1 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[(HEAP32[i10 + 24 >> 2] | 0) + (i8 << 2) >> 2] = i7;
 i8 = i10 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = Math_imul(i1 << 2, i3) | 0;
 if (!i2) i2 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i2 = mftCall_iiiiii(i6 | 0, i1 | 0, i2 | 0, (i3 ? gb + 713751 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 147) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i6 = i10 + 32 | 0;
 i4 = ((Math_imul(i3, i1) | 0) + 31 | 0) >>> 5;
 i5 = i10 + 36 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i1 = i10 + 40 | 0;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i6 >> 2] | 0);
  }
  i3 = HEAP32[i5 >> 2] | 0;
  _memset(i2 + ((i3 & 2147483647) << 2) | 0, 0, i4 - i3 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i5 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i3 + -1 | 0;
 if ((i1 | 0) <= -1) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = i10 + 28 | 0;
 i4 = i10 + 20 | 0;
 while (1) {
  i5 = i7 + (i1 * 52 | 0) | 0;
  __ZN5physx16PxsParticleShapeC2EPNS_10PxsContextEj(i5, HEAP32[i2 >> 2] | 0, (Math_imul((HEAP32[i9 >> 2] | 0) + -1 | 0, i3) | 0) + i1 | 0);
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i6 + 1;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] = i5;
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= -1) {
   i1 = 1;
   break;
  }
  i3 = HEAP32[i10 >> 2] | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK8Collider(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 if (!i15) return;
 i16 = i1 + 136 | 0;
 i13 = i1 + 104 | 0;
 i12 = 0;
 do {
  i4 = (i12 | 0) == 0 ? i16 : i13;
  i1 = HEAP32[i4 >> 2] | 0;
  i14 = i4 + 4 | 0;
  i3 = i1;
  i2 = i1;
  if ((i3 | 0) != (i14 | 0)) if (HEAP8[i3 + 24 >> 0] | 0) while (1) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i14 | 0)) {
    i1 = i14;
    break;
   }
   if (!(HEAP8[i1 + 24 >> 0] | 0)) break; else i2 = i1;
  }
  i2 = i1;
  L20 : do if ((i2 | 0) != (i14 | 0)) {
   i9 = i4 + 12 | 0;
   i10 = i4 + 24 | 0;
   i11 = i4 + 28 | 0;
   i8 = i4 + 16 | 0;
   while (1) {
    if ((HEAP32[i2 + 28 >> 2] | 0) == (i15 | 0)) i17 = 17; else if ((HEAP32[i2 + 32 >> 2] | 0) == (i15 | 0)) i17 = 17;
    if ((i17 | 0) == 17) {
     i17 = 0;
     i3 = i2 + 24 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) {
      HEAP8[i3 >> 0] = 1;
      i3 = i2 + 16 | 0;
      i4 = HEAP32[i10 >> 2] | 0;
      i5 = i4 + 1 | 0;
      i6 = HEAP32[i11 >> 2] | 0;
      i7 = i6 & 2147483647;
      do if (i5 >>> 0 > i7 >>> 0) {
       i2 = i6 << 1;
       i2 = (i2 | 0) == 0 ? 1 : i2;
       if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
        HEAP32[i11 >> 2] = i2;
        HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 3, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
        break;
       } else {
        i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
        _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
        HEAP32[i11 >> 2] = i2;
        HEAP32[i9 >> 2] = i7;
        break;
       }
      } while (0);
      HEAP32[i10 >> 2] = i5;
      i5 = i3;
      i6 = HEAP32[i5 + 4 >> 2] | 0;
      i7 = (HEAP32[i9 >> 2] | 0) + (i4 << 3) | 0;
      HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
      HEAP32[i7 + 4 >> 2] = i6;
     }
    }
    while (1) {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (i14 | 0)) break L20;
     if (!(HEAP8[i2 + 24 >> 0] | 0)) break; else i1 = i2;
    }
    if ((i2 | 0) == (i14 | 0)) break; else i1 = i2;
   }
  } while (0);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 2);
 return;
}

function __ZN11dtPathQueue6updateEiPi(i1, i20, i21) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i23;
 i19 = i1 + 224 | 0;
 i15 = i1 + 60 | 0;
 i5 = i1 + 64 | 0;
 i16 = i1 + 228 | 0;
 i17 = i1 + 32 | 0;
 i18 = i1 + 40 | 0;
 i11 = i1 + 4 | 0;
 i12 = i1 + 16 | 0;
 i3 = i1 + 72 | 0;
 i4 = i1 + 68 | 0;
 i13 = i1 + 204 | 0;
 i14 = i1 + 208 | 0;
 i8 = i1 + 56 | 0;
 i7 = i1 + 220 | 0;
 i9 = i1 + 48 | 0;
 i10 = i1 + 52 | 0;
 do if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = i20;
  i22 = 20;
 } else {
  i2 = HEAP32[i15 >> 2] | 0;
  if (i2 >>> 0 > 1073741823) {
   i22 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i22 + 1;
   if ((i22 | 0) <= 1) {
    i1 = i20;
    i22 = 20;
    break;
   }
   HEAP32[i1 >> 2] = 0;
   HEAP32[i15 >> 2] = 0;
   i1 = i20;
   i22 = 20;
   break;
  }
  if (!i2) {
   i5 = i17;
   i2 = i18;
   i2 = __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter(HEAP32[i16 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i11, i12, i3) | 0;
   HEAP32[i15 >> 2] = i2;
   HEAP32[i4 >> 2] = HEAP32[(HEAP32[HEAP32[i16 >> 2] >> 2] | 0) + 56 >> 2];
  }
  if (!(i2 & 536870912)) i1 = i20; else {
   HEAP32[i6 >> 2] = 0;
   i2 = __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi(HEAP32[i16 >> 2] | 0, i20, i6) | 0;
   HEAP32[i15 >> 2] = i2;
   i1 = i20 - (HEAP32[i6 >> 2] | 0) | 0;
  }
  if (i2 & 1073741824 | 0) {
   i4 = i2 & 16777215;
   HEAP32[i6 >> 2] = 0;
   i2 = __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi(HEAP32[i16 >> 2] | 0, i6) | 0;
   HEAP32[i15 >> 2] = i2;
   if (i2 & 1073741824) {
    i3 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
    do if ((i3 | 0) > (i2 | 0)) {
     i2 = HEAP32[i7 >> 2] | 0;
     i3 = i3 + -1 + i2 | 0;
     i2 = i3 - ((i3 | 0) % (i2 | 0) | 0) | 0;
     i3 = __Z9dtReallocPvi(HEAP32[i9 >> 2] | 0, i2 << 3) | 0;
     if (!i3) {
      i2 = HEAP32[i8 >> 2] | 0;
      break;
     } else {
      HEAP32[i9 >> 2] = i3;
      HEAP32[i8 >> 2] = i2;
      break;
     }
    } while (0);
    i2 = __ZN14dtNavMeshQuery7getPathEPyPii(HEAP32[i16 >> 2] | 0, HEAP32[i9 >> 2] | 0, i10, i2) | 0;
    HEAP32[i15 >> 2] = i2;
   }
   HEAP32[i15 >> 2] = i2 | i4;
   if (HEAP8[i13 >> 0] | 0) __ZN15dtPathQueryInfo3setEyyPKfS1_PK14dtNavMeshQuery(i14, HEAP32[i17 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, i11, i12, HEAP32[i16 >> 2] | 0);
  }
  if ((i1 | 0) >= 1) i22 = 20;
 } while (0);
 if ((i22 | 0) == 20) HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + 1;
 if (!i21) {
  STACKTOP = i23;
  return;
 }
 HEAP32[i21 >> 2] = i20 - i1;
 STACKTOP = i23;
 return;
}

function __Z18ExtractMeshIndicesRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEERK15CombineInstancebRjPt(i7, i11, i4, i8, i13) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i9 = HEAP32[i7 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) i6 = i9; else {
  i6 = i1 + (~((i1 + -4 - i9 | 0) >>> 2) << 2) | 0;
  HEAP32[i10 >> 2] = i6;
 }
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i13 = 0;
  return i13 | 0;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 i5 = i3 + 128 | 0;
 if ((i1 | 0) >= (((HEAP32[i3 + 132 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 52 | 0 | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = i4 ? HEAP32[i11 + 108 >> 2] | 0 : i14;
 HEAP32[i8 >> 2] = (HEAP32[i3 + 100 >> 2] | 0) + i14;
 if ((i6 | 0) != (i9 | 0)) HEAP32[i10 >> 2] = i6 + (~((i6 + -4 - i9 | 0) >>> 2) << 2);
 switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i7, i1, i5, i3) | 0) {
 case 1:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
   break;
  }
 case 4:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
   break;
  }
 default:
  {}
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i10 >> 2] | 0) - i4 >> 2;
 f20 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f19 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f21 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 28 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + 32 >> 2]);
 f17 = Math_fround(HEAPF32[i11 + 36 >> 2]);
 f18 = Math_fround(Math_fround(f19 * f17) - Math_fround(f21 * f16));
 f17 = Math_fround(Math_fround(f21 * f15) - Math_fround(f20 * f17));
 f15 = Math_fround(Math_fround(f20 * f16) - Math_fround(f19 * f15));
 f19 = Math_fround(HEAPF32[i11 + 44 >> 2]);
 f16 = Math_fround(HEAPF32[i11 + 48 >> 2]);
 i2 = (i1 | 0) == 0;
 if (Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * f16)) + Math_fround(f15 * Math_fround(HEAPF32[i11 + 52 >> 2]))) >= Math_fround(0.0)) {
  if (i2) {
   i14 = 0;
   return i14 | 0;
  } else i2 = 0;
  do {
   HEAP16[i13 + (i2 << 1) >> 1] = (HEAP32[i4 + (i2 << 2) >> 2] | 0) + i12;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  return i1 | 0;
 }
 if (i2) {
  i14 = 0;
  return i14 | 0;
 }
 i3 = i1 + -1 | 0;
 i2 = 0;
 do {
  HEAP16[i13 + (i2 << 1) >> 1] = (HEAP32[i4 + (i3 - i2 << 2) >> 2] | 0) + i12;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return i1 | 0;
}

function __ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f10 - f3);
 f4 = Math_fround(f11 - f4);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f11 = Math_fround(HEAPF32[i8 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 132 >> 2]);
 f11 = Math_fround(f5 + f11);
 f10 = Math_fround(f6 + f10);
 f9 = Math_fround(f7 + Math_fround(HEAPF32[i8 + 136 >> 2]));
 if (f2 < Math_fround(-f9) | (f4 < Math_fround(-f10) | (f3 < Math_fround(-f11) | (f3 > f11 | f4 > f10 | f2 > f9)))) {
  i8 = 0;
  return i8 | 0;
 }
 f26 = Math_fround(HEAPF32[i8 + 32 >> 2]);
 f24 = Math_fround(HEAPF32[i8 + 36 >> 2]);
 f22 = Math_fround(HEAPF32[i8 + 40 >> 2]);
 f25 = Math_fround(HEAPF32[i8 + 48 >> 2]);
 f23 = Math_fround(HEAPF32[i8 + 52 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f12 = Math_fround(HEAPF32[i8 + 64 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 68 >> 2]);
 f9 = Math_fround(HEAPF32[i8 + 72 >> 2]);
 f19 = Math_fround(HEAPF32[i8 + 80 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 84 >> 2]);
 f13 = Math_fround(HEAPF32[i8 + 88 >> 2]);
 f20 = Math_fround(HEAPF32[i8 + 96 >> 2]);
 f17 = Math_fround(HEAPF32[i8 + 100 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 104 >> 2]);
 f21 = Math_fround(HEAPF32[i8 + 112 >> 2]);
 f18 = Math_fround(HEAPF32[i8 + 116 >> 2]);
 f15 = Math_fround(HEAPF32[i8 + 120 >> 2]);
 f12 = Math_fround(Math_fround(Math_fround(f3 * f26) + Math_fround(f4 * f25)) + Math_fround(f2 * f12));
 f10 = Math_fround(Math_fround(Math_fround(f3 * f24) + Math_fround(f4 * f23)) + Math_fround(f2 * f10));
 f3 = Math_fround(Math_fround(Math_fround(f3 * f22) + Math_fround(f4 * f11)) + Math_fround(f2 * f9));
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f9 = Math_fround(Math_fround(f7 * f21) + Math_fround(Math_fround(f6 * f20) + Math_fround(Math_fround(f5 * f19) + f9)));
 f11 = Math_fround(Math_fround(f7 * f18) + Math_fround(Math_fround(f6 * f17) + Math_fround(Math_fround(f5 * f16) + f11)));
 f2 = Math_fround(Math_fround(f7 * f15) + Math_fround(Math_fround(f6 * f14) + Math_fround(Math_fround(f5 * f13) + Math_fround(HEAPF32[i8 + 8 >> 2]))));
 if (f10 < Math_fround(-f11) | (f12 < Math_fround(-f9) | (f12 > f9 | f10 > f11 | f3 > f2))) i1 = 0; else i1 = !(f3 < Math_fround(-f2));
 i8 = i1 & 1;
 return i8 | 0;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_(i12, i3, i10) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 8 | 0;
 i1 = i13;
 i2 = i12 + 88 | 0;
 if ((HEAP32[i12 + 96 >> 2] | 0) == (HEAP32[i10 + 8 >> 2] | 0)) {
  i8 = i2;
  i9 = i10;
  if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i9 >> 2] | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (HEAP32[i9 + 4 >> 2] | 0) : 0) if ((HEAP8[i12 + 100 >> 0] | 0) == (HEAP8[i10 + 12 >> 0] | 0)) if ((HEAP8[i12 + 101 >> 0] | 0) == (HEAP8[i10 + 13 >> 0] | 0)) {
   i9 = i10 + 16 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_18RelativeStartEventEEEvhtRKT_(i12, 3, i3, i1);
   STACKTOP = i13;
   return;
  }
 };
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP8[i11 >> 0] = 1;
 i9 = i11 + 1 | 0;
 HEAP16[i11 + 2 >> 1] = i3;
 i5 = i10 + 16 | 0;
 i7 = i5;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i12 + 104 | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP8[i9 >> 0] = 3;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i4 = 3;
  i2 = i6;
  i1 = i7;
 } else {
  i2 = _i64Subtract(i6 | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 256) i1 = 0; else if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 65536) i1 = 1; else i1 = i3 >>> 0 < 1 | (i3 | 0) == 1 & i2 >>> 0 < 0 ? 2 : 3;
  HEAP8[i9 >> 0] = i1;
  i14 = (i1 | 0) == 3;
  i4 = i1;
  i2 = i14 ? i6 : i2;
  i1 = i14 ? i7 : i3;
 }
 i14 = i5;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i1;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 256) i1 = 0; else if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 65536) i1 = 4; else i1 = i2 >>> 0 < 1 | (i2 | 0) == 1 & i1 >>> 0 < 0 ? 8 : 12;
 HEAP8[i9 >> 0] = i1 | i4;
 i14 = i8;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i7;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10StartEventEEEvRNS0_11EventHeaderERT_(i12, i11, i10);
 STACKTOP = i13;
 return;
}

function __ZN10systeminfo14GetDeviceModelEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i9 = i11 + 32 | 0;
 i10 = i11 + 20 | 0;
 i8 = i11 + 8 | 0;
 i2 = HEAP32[gb + 1103748 >> 2] | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) if (i3) {
  i10 = HEAP32[i2 >> 2] | 0;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i10 = i2;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = _JS_SystemInfo_GetBrowserName(0, 0) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i9, i3, 0);
 i3 = i9 + 11 | 0;
 i6 = HEAP8[i3 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 _JS_SystemInfo_GetBrowserName((i7 ? HEAP32[i9 >> 2] | 0 : i9) | 0, (i7 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0) | 0;
 i6 = _JS_SystemInfo_GetBrowserVersionString(0, 0) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i10, i6, 0);
 i6 = i10 + 11 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 _JS_SystemInfo_GetBrowserVersionString((i5 ? HEAP32[i10 >> 2] | 0 : i10) | 0, (i5 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255) | 0) | 0;
 i7 = HEAP32[gb + 1103748 >> 2] | 0;
 i6 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 HEAP32[i4 >> 2] = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 HEAP32[i4 + 4 >> 2] = i6;
 __Z6FormatPKcz(i8, gb + 363899 | 0, i4);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i7 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
 } else {
  if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = HEAP32[gb + 1103748 >> 2] | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterSystemP12Il2CppObjecti(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i9 + 16 | 0;
 i7 = i9 + 12 | 0;
 i1 = i9 + 8 | 0;
 HEAP32[i1 >> 2] = i4;
 if ((i5 | 0) < 0) {
  i10 = __ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i1) | 0;
  i10 = i10 + 916 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = __ZNK9SubModule19GetSubEmittersCountEv(i10) | 0;
  i10 = i10 + -1 | 0;
  HEAP32[i3 >> 2] = i5;
  i2 = i3 + 4 | 0;
  HEAP32[i2 >> 2] = i10;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i3);
 }
 if (!i4) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i10 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i2 + 916 >> 2] | 0) | 0) >>> 0 <= i5 >>> 0) {
  i2 = __ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i1) | 0;
  i2 = i2 + 916 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i2 = __ZNK9SubModule19GetSubEmittersCountEv(i2) | 0;
  i2 = i2 + -1 | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = i3 + 4 | 0;
  HEAP32[i10 >> 2] = i2;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i4 = HEAP32[(HEAP32[(HEAP32[i1 + 916 >> 2] | 0) + 8 >> 2] | 0) + (i5 * 12 | 0) >> 2] | 0;
 if (!i4) {
  i10 = 0;
  i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i10) | 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 15; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 15; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 17;
  }
 }
 if ((i8 | 0) == 15) i8 = 17;
 if ((i8 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i10 = i1;
 i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i10) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __Z23CalculateGlobalPosition23TransformAccessReadOnly(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i7 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i9 + (i1 * 40 | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i5 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 do {
  f22 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 28 >> 2]);
  f15 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 32 >> 2]);
  f22 = Math_fround(f2 * f22);
  f15 = Math_fround(f3 * f15);
  f19 = Math_fround(f4 * Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 36 >> 2]));
  f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 16 >> 2]);
  f18 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 12 >> 2]);
  f10 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 20 >> 2]);
  f24 = Math_fround(f12 * Math_fround(-2.0));
  f16 = Math_fround(f12 * Math_fround(2.0));
  f21 = Math_fround(f24 * f10);
  f14 = Math_fround(f23 * Math_fround(2.0));
  f20 = Math_fround(f23 * Math_fround(-2.0));
  f25 = Math_fround(f10 * f20);
  f17 = Math_fround(f18 * Math_fround(-2.0));
  f11 = Math_fround(f18 * Math_fround(2.0));
  f10 = Math_fround(f10 * f17);
  f13 = Math_fround(Math_fround(f22 + Math_fround(f22 * Math_fround(Math_fround(f12 * f24) - Math_fround(f23 * f14)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f11 * f23) - f21)) + Math_fround(f15 * Math_fround(f25 - Math_fround(f12 * f17)))));
  f11 = Math_fround(Math_fround(f15 + Math_fround(f22 * Math_fround(Math_fround(f18 * f16) - f25))) + Math_fround(Math_fround(f19 * Math_fround(f10 - Math_fround(f24 * f23))) + Math_fround(f15 * Math_fround(Math_fround(f23 * f20) - Math_fround(f18 * f11)))));
  f10 = Math_fround(Math_fround(f19 + Math_fround(f22 * Math_fround(f21 - Math_fround(f18 * f20)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f18 * f17) - Math_fround(f12 * f16))) + Math_fround(f15 * Math_fround(Math_fround(f12 * f14) - f10))));
  f14 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) >> 2]);
  f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 4 >> 2]);
  f2 = Math_fround(f14 + f13);
  f3 = Math_fround(f12 + f11);
  f4 = Math_fround(Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 8 >> 2]) + f10);
  i1 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i8 >> 2] = f2;
 HEAPF32[i5 >> 2] = f3;
 HEAPF32[i6 >> 2] = f4;
 return;
}

function __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i8, i9, i14) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i21;
 i16 = i14 + 132 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  STACKTOP = i21;
  return;
 }
 i17 = i15 + 4 | 0;
 i18 = i15 + 8 | 0;
 i19 = i14 + 120 | 0;
 i10 = i15 + 12 | 0;
 i11 = i15 + 24 | 0;
 i12 = i15 + 36 | 0;
 i5 = i15 + 36 | 0;
 i6 = i15 + 40 | 0;
 i7 = i15 + 44 | 0;
 i13 = i15 + 48 | 0;
 i4 = -1;
 do {
  HEAPF32[i17 >> 2] = Math_fround(inf);
  HEAP32[i15 >> 2] = 0;
  i2 = i18;
  i3 = i2 + 52 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  do if ((i4 | 0) == (i1 + -1 | 0)) {
   i20 = HEAP32[i19 >> 2] | 0;
   HEAP32[i17 >> 2] = HEAP32[i20 + (i4 * 40 | 0) >> 2];
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   i20 = i20 + (i4 * 40 | 0) + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
   i20 = 10;
  } else {
   if ((i4 | 0) != -1) {
    __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif(i14, i15, i4, i4 + 1 | 0, Math_fround(0.0));
    i20 = 10;
    break;
   }
   i2 = HEAP32[i19 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i2 >> 2]) == Math_fround(-3402823469999999843913219.0e14))) {
    HEAPF32[i17 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i5 >> 2] = Math_fround(0.0);
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i7 >> 2] = Math_fround(0.0);
    HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    i20 = i2 + 4 | 0;
    HEAP32[i13 >> 2] = HEAP32[i20 >> 2];
    HEAP32[i13 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
    HEAP32[i13 + 8 >> 2] = HEAP32[i20 + 8 >> 2];
    i20 = 10;
   }
  } while (0);
  if ((i20 | 0) == 10) {
   i20 = 0;
   __Z23ConvertCacheToBuildKeysI8Vector3fEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i15, i9, i8);
   i1 = HEAP32[i16 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 STACKTOP = i21;
 return;
}

function __ZNK9profiling14SamplerManager16GetSamplersNamesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 12 | 0;
 i6 = i12;
 if ((HEAP16[gb + 1451016 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451016 | 0, i3);
  i4 = gb + 1451016 | 0;
 } else i4 = 0;
 i7 = (HEAP32[i5 + 92 >> 2] | 0) - (HEAP32[i5 + 4 >> 2] | 0) | 0;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0, 4, i7) | 0;
 i8 = i5 + 84 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 i9 = i5 + 88 | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i3, i5, i10, i10 + ((HEAP32[i9 >> 2] | 0) * 36 | 0) | 0, 1);
 i10 = (HEAP32[i8 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 36 | 0) | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i6, i5, i10, i10, 1);
 i10 = i3 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i6 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i11 >> 2] | 0)) {
  i2 = 0;
  while (1) {
   i13 = HEAP32[i1 >> 2] | 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i7, i2, __Z20scripting_string_newPKcj((i13 | 0) == 0 ? i1 + 4 | 0 : i13, HEAP32[i1 + 20 >> 2] | 0) | 0);
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i3) | 0;
   i13 = (HEAP32[i8 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 36 | 0) | 0;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i6, i5, i13, i13, 1);
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i11 >> 2] | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 if (!i4) {
  STACKTOP = i12;
  return i7 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i12;
 return i7 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 1, 2, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 1) | 0, 0, i7 - i6 << 1 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37240 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 1024)) {
    if (!(i1 & 512)) {
     if (!(i1 & 1048576)) {
      i1 = 0;
      break;
     }
     if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
     i1 = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i1 & 16384)) {
     if (i1 & 2048 | 0) {
      d2 = +((HEAP32[i5 >> 2] | 0) >>> 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    i1 = ~~d2 >>> 0;
   } else i1 = HEAP32[i5 >> 2] | 0; while (0);
   HEAP16[i6 >> 1] = i1;
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 2 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN5physx2Cm19visualizeDoubleConeERNS0_12RenderOutputEfRKNS_11PxTransformEfb(i16, f17, i3, f2, i1) {
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0, f20 = f0, i21 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i18 + 60 | 0;
 i6 = i18 + 48 | 0;
 i12 = i18 + 36 | 0;
 i13 = i18 + 24 | 0;
 i14 = i18 + 12 | 0;
 i15 = i18;
 i3 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i16, i3) | 0;
 __ZN5physx2Cm12RenderOutputlsEj(i3, i1 ? -65536 : -8355712) | 0;
 f11 = Math_fround(+Math_sin(+(+f2)));
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i16, 2) | 0;
 f11 = Math_fround(f11 * f17);
 i1 = i5 + 4 | 0;
 i3 = i5 + 8 | 0;
 i4 = 0;
 do {
  f2 = Math_fround(Math_fround(i4 >>> 0) * Math_fround(.196349546));
  f19 = Math_fround(Math_fround(+Math_cos(+f2)) * f17);
  f2 = Math_fround(Math_fround(+Math_sin(+f2)) * f17);
  HEAPF32[i5 >> 2] = f11;
  HEAPF32[i1 >> 2] = f19;
  HEAPF32[i3 >> 2] = f2;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i16, i5) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 33);
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i16, 2) | 0;
 f2 = Math_fround(-f11);
 i1 = i6 + 4 | 0;
 i3 = i6 + 8 | 0;
 i4 = 0;
 do {
  f19 = Math_fround(Math_fround(i4 >>> 0) * Math_fround(.196349546));
  f20 = Math_fround(Math_fround(+Math_cos(+f19)) * f17);
  f19 = Math_fround(Math_fround(+Math_sin(+f19)) * f17);
  HEAPF32[i6 >> 2] = f2;
  HEAPF32[i1 >> 2] = f20;
  HEAPF32[i3 >> 2] = f19;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i16, i6) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 33);
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i16, 1) | 0;
 i1 = i12 + 4 | 0;
 i3 = i12 + 8 | 0;
 i4 = i13 + 4 | 0;
 i5 = i13 + 8 | 0;
 i6 = i14 + 4 | 0;
 i7 = i14 + 8 | 0;
 i8 = i15 + 4 | 0;
 i9 = i15 + 8 | 0;
 i10 = 0;
 do {
  HEAPF32[i12 >> 2] = Math_fround(0.0);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i21 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i16, i12) | 0;
  f20 = Math_fround(Math_fround(i10 >>> 0) * Math_fround(.196349546));
  f19 = Math_fround(Math_fround(+Math_cos(+f20)) * f17);
  f20 = Math_fround(Math_fround(+Math_sin(+f20)) * f17);
  HEAPF32[i13 >> 2] = f2;
  HEAPF32[i4 >> 2] = f19;
  HEAPF32[i5 >> 2] = f20;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i21, i13) | 0;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  i21 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i16, i14) | 0;
  HEAPF32[i15 >> 2] = f11;
  HEAPF32[i8 >> 2] = f19;
  HEAPF32[i9 >> 2] = f20;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i21, i15) | 0;
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 32);
 STACKTOP = i18;
 return;
}

function __ZNK11MinMaxCurve20FindMinMaxIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 480 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 464 | 0;
 i4 = i9 + 456 | 0;
 i5 = i9;
 if (HEAP8[i2 + 86 >> 0] | 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i7 = i5 + 16 | 0;
  i11 = i2 + 16 | 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i7 = i2 + 32 | 0;
  i11 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = i5 + 32 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = i11;
  i8 = i5 + 40 | 0;
  i11 = i2 + 40 | 0;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  i11 = i5 + 56 | 0;
  i7 = i2 + 56 | 0;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  i11 = i2 + 72 | 0;
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = i5 + 72 | 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i7 + 4 >> 2] = i2;
  __ZN24OptimizedPolynomialCurve9IntegrateEv(i5);
  __ZN24OptimizedPolynomialCurve9IntegrateEv(i8);
  __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv(i3, i8);
  __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv(i4, i5);
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  f10 = Math_fround(_fminf(f10, Math_fround(HEAPF32[i4 >> 2])));
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f6 = Math_fround(_fmaxf(f6, Math_fround(HEAPF32[i4 + 4 >> 2])));
  HEAPF32[i1 >> 2] = f10;
  HEAPF32[i1 + 4 >> 2] = f6;
  STACKTOP = i9;
  return;
 }
 f6 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 i11 = HEAP16[i2 + 84 >> 1] | 0;
 i7 = i2 + 88 | 0;
 __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i5, i7, f6) | 0;
 i8 = i5 + 228 | 0;
 if ((i11 & -2) << 16 >> 16 == 2) __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i8, i2 + 176 | 0, f6) | 0; else __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i8, i7, f6) | 0;
 __ZN15PolynomialCurve9IntegrateEv(i5);
 __ZN15PolynomialCurve9IntegrateEv(i8);
 __ZNK15PolynomialCurve20FindMinMaxIntegratedEv(i3, i8);
 __ZNK15PolynomialCurve20FindMinMaxIntegratedEv(i4, i5);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(_fminf(f6, Math_fround(HEAPF32[i4 >> 2])));
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(_fmaxf(f10, Math_fround(HEAPF32[i4 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f10;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i1, i15, i13, i14) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0;
 i12 = i1 + 32 | 0;
 if (!(HEAP8[i12 >> 0] | 0)) {
  i14 = 0;
  i15 = i15 + 4096 | 0;
  HEAP32[i15 >> 2] = i14;
  return;
 }
 i4 = i1 + 44 | 0;
 i5 = i14 + 4 | 0;
 i6 = i14 + 8 | 0;
 i7 = i14 + 12 | 0;
 i8 = i14 + 16 | 0;
 i9 = i14 + 20 | 0;
 i10 = i14 + 24 | 0;
 i2 = i13 + 4 | 0;
 i3 = i13 + 8 | 0;
 i11 = 0;
 while (1) {
  i16 = HEAP32[i4 >> 2] | 0;
  f27 = Math_fround(HEAPF32[i14 >> 2]);
  f25 = Math_fround(HEAPF32[i5 >> 2]);
  f23 = Math_fround(HEAPF32[i6 >> 2]);
  f28 = Math_fround(HEAPF32[i7 >> 2]);
  f20 = Math_fround(HEAPF32[i8 >> 2]);
  f19 = Math_fround(HEAPF32[i9 >> 2]);
  f31 = Math_fround(HEAPF32[i10 >> 2]);
  f24 = Math_fround(HEAPF32[i16 + (i11 * 48 | 0) + 16 >> 2]);
  f26 = Math_fround(HEAPF32[i16 + (i11 * 48 | 0) + 20 >> 2]);
  f29 = Math_fround(HEAPF32[i16 + (i11 * 48 | 0) + 24 >> 2]);
  f30 = Math_fround(Math_fround(f28 * f28) + Math_fround(-.5));
  f18 = Math_fround(Math_fround(Math_fround(f27 * f24) + Math_fround(f25 * f26)) + Math_fround(f23 * f29));
  f20 = Math_fround(f20 + Math_fround(Math_fround(Math_fround(f27 * f18) + Math_fround(Math_fround(f30 * f24) + Math_fround(f28 * Math_fround(Math_fround(f25 * f29) - Math_fround(f23 * f26))))) * Math_fround(2.0)));
  f19 = Math_fround(f19 + Math_fround(Math_fround(Math_fround(f25 * f18) + Math_fround(Math_fround(f30 * f26) + Math_fround(f28 * Math_fround(Math_fround(f23 * f24) - Math_fround(f27 * f29))))) * Math_fround(2.0)));
  f18 = Math_fround(f31 + Math_fround(Math_fround(Math_fround(Math_fround(f30 * f29) + Math_fround(f28 * Math_fround(Math_fround(f27 * f26) - Math_fround(f25 * f24)))) + Math_fround(f23 * f18)) * Math_fround(2.0)));
  i16 = HEAP32[i16 + (i11 * 48 | 0) + 44 >> 2] | 0;
  i1 = i11 + 1 | 0;
  i22 = HEAP32[i2 >> 2] | 0;
  i21 = HEAP32[i3 >> 2] | 0;
  i17 = i15 + (i11 << 6) | 0;
  HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i17 + 4 >> 2] = i22;
  HEAP32[i17 + 8 >> 2] = i21;
  HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
  i17 = i15 + (i11 << 6) + 16 | 0;
  HEAPF32[i17 >> 2] = f20;
  HEAPF32[i17 + 4 >> 2] = f19;
  HEAPF32[i17 + 8 >> 2] = f18;
  HEAPF32[i17 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i15 + (i11 << 6) + 12 >> 2] = i16;
  HEAP32[i15 + (i11 << 6) + 48 >> 2] = -1;
  HEAP32[i15 + (i11 << 6) + 52 >> 2] = -1;
  if (i1 >>> 0 < 64 & i1 >>> 0 < (HEAPU8[i12 >> 0] | 0) >>> 0) i11 = i1; else break;
 }
 i22 = i15 + 4096 | 0;
 HEAP32[i22 >> 2] = i1;
 return;
}

function __ZN15ScriptsIterator4NextEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 L1 : do if (i1 >>> 0 < i2 >>> 0) {
  while (1) {
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3) {
    HEAP32[i8 >> 2] = i3;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i9 = 9; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i11 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 9; else if (HEAP32[i2 + 4 >> 2] | 0) break;
    }
    if ((i9 | 0) == 9) i9 = 0;
    i11 = (__Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0) == 0;
    i1 = HEAP32[i5 >> 2] | 0;
    if (!i11) break L1;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i1 = i1 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } while (0);
 if (i1 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 HEAP32[i5 >> 2] = i1 + 4;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 22; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
   i2 = HEAP32[i7 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 22; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 24;
  }
 }
 if ((i9 | 0) == 22) i9 = 24;
 if ((i9 | 0) == 24) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i11 = i1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN12_GLOBAL__N_110ConnectionD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = gb + 147904 + 8;
 HEAP32[i8 + 4 >> 2] = gb + 147904 + 120;
 HEAP32[i8 + 8 >> 2] = gb + 147904 + 144;
 HEAP32[i8 + 12 >> 2] = gb + 147904 + 168;
 i1 = i8 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i8 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i8 + 128 >> 2] | 0;
 if (!i1) i7 = i8 + 16 | 0; else {
  HEAP8[i1 + 20 >> 0] = 0;
  i7 = i8 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 i5 = HEAP32[i8 + 28 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
 i5 = i8 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i8 + 48 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if (i3) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 i1 = i8 + 120 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
  }
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i8 + 88 >> 2] = gb + 148172 + 8;
 i7 = i8 + 100 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i7 >> 2] | 0);
 i6 = HEAP32[i8 + 92 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i8 + 72 >> 2] = gb + 148172 + 8;
 i7 = i8 + 84 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i7 >> 2] | 0);
 i6 = HEAP32[i8 + 76 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i8 + 36 >> 2] = gb + 148240 + 8;
 i7 = HEAP32[i8 + 56 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) return;
 i7 = HEAP32[i8 + 40 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i8 + 48 >> 2] | 0);
 return;
}

function __ZN12MeshCollider16TransformChangedEi(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 96 | 0;
 i5 = i9 + 64 | 0;
 i6 = i9;
 i7 = i8 + 36 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!((i2 & 64 | 0) == 0 | (i1 | 0) == 0)) {
  i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if ((__ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i8, 0) | 0) != (i3 | 0)) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 156 >> 2] | 0, i8 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (!i1) {
  i1 = HEAP32[i8 + 28 >> 2] | 0;
  if (!i1) {
   STACKTOP = i9;
   return;
  }
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   STACKTOP = i9;
   return;
  }
  if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0) | 0)) {
   STACKTOP = i9;
   return;
  }
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, 0);
  STACKTOP = i9;
  return;
 }
 i3 = (i2 & 8 | 0) != 0;
 if (i3) {
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 148 >> 2] | 0, i8 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 172 >> 2] | 0, i8 | 0);
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 28 | 0;
 if (__ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0, i6) | 0) {
  i10 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0;
  __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i6, i4);
  i13 = HEAP32[i6 + 48 >> 2] | 0;
  i12 = HEAP32[i6 + 52 >> 2] | 0;
  i6 = HEAP32[i6 + 56 >> 2] | 0;
  i16 = HEAP32[i4 + 4 >> 2] | 0;
  i15 = HEAP32[i4 + 8 >> 2] | 0;
  i14 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i16;
  HEAP32[i5 + 8 >> 2] = i15;
  HEAP32[i5 + 12 >> 2] = i14;
  HEAP32[i5 + 16 >> 2] = i13;
  HEAP32[i5 + 20 >> 2] = i12;
  HEAP32[i5 + 24 >> 2] = i6;
  mftCall_vii(i11 | 0, i10 | 0, i5 | 0);
  if (!((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 5)) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0) | 0) & 1)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
 }
 if (i3 | (HEAP32[i1 >> 2] | 0) != (HEAP32[i8 + 28 >> 2] | 0)) {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
   if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
  }
 }
 STACKTOP = i9;
 return;
}

function __ZN11AudioSource16CreateFMODGroupsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i2 = i6;
 i3 = i6 + 32 | 0;
 i1 = i5 + 488 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, gb + 866962 | 0, i1) | 0;
  if (i1 | 0) {
   i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i2 >> 2] = gb + 855390;
   HEAP32[i2 + 4 >> 2] = 320;
   HEAP32[i2 + 8 >> 2] = gb + 866975;
   HEAP32[i2 + 12 >> 2] = i1;
   __Z6FormatPKcz(i3, gb + 883334 | 0, i2);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  }
 }
 i1 = i5 + 492 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, gb + 867058 | 0, i1) | 0;
  if (i1 | 0) {
   i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i4 >> 2] = gb + 855390;
   HEAP32[i4 + 4 >> 2] = 327;
   HEAP32[i4 + 8 >> 2] = gb + 867071;
   HEAP32[i4 + 12 >> 2] = i2;
   __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  }
 }
 do if (!(HEAP8[i5 + 422 >> 0] | 0)) {
  HEAP32[i5 + 544 >> 2] = 0;
  i1 = i5 + 540 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN4FMOD3DSP7releaseEv(i2) | 0;
   HEAP32[i1 >> 2] = 0;
  }
 } else {
  i1 = i5 + 540 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) if (__ZNK12AudioManager25RequiresCustomSpatializerEv(__Z15GetAudioManagerv() | 0) | 0) {
   i2 = __ZN12AudioManager31GetCurrentSpatializerDefinitionEv(__Z15GetAudioManagerv() | 0) | 0;
   if (!i2) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 867327 | 0, 0, gb + 855390 | 0, 348, 512, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
    break;
   }
   i4 = __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i2, HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, 0, 0, i5 + 544 | 0) | 0;
   HEAP32[i1 >> 2] = i4;
   if (!i4) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 867154 | 0, 0, gb + 855390 | 0, 344, 512, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
    break;
   } else {
    __ZN11AudioSource12ApplyFiltersEv(i5);
    break;
   }
  }
 } while (0);
 __ZN11AudioSource19ConfigureFMODGroupsEv(i5);
 __ZN11AudioSource16UpdateParametersEv(i5);
 STACKTOP = i6;
 return;
}

function __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 44 | 0;
 i7 = i13 + 40 | 0;
 i10 = i13 + 20 | 0;
 i8 = i13;
 i12 = HEAP32[i4 + 20 >> 2] | 0;
 i9 = i10 + 4 | 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = -1;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = (HEAP32[i6 + 32 >> 2] | 0) == 17;
 i2 = i5;
 do if (!i5) {
  i2 = i6 + 12 | 0;
  if (i1) i1 = 0; else i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP8[i11 >> 0] = 1;
  HEAP32[i11 + 4 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i5;
  HEAP32[i11 + 12 >> 2] = -1;
 } else {
  if (!i1) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i11, HEAP32[i6 >> 2] | 0, i4, 1);
   break;
  }
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  i3 = HEAP32[i6 + 12 >> 2] | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i4 + 12 >> 2] | 0) | 0;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i11 + 4 >> 2] = i2;
  } else {
   HEAP8[i11 >> 0] = 0;
   HEAP32[i11 + 4 >> 2] = i2;
  }
  HEAP32[i11 + 8 >> 2] = i3;
  HEAP32[i11 + 12 >> 2] = i1;
 } while (0);
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 i3 = (HEAP32[i4 + 16 >> 2] | 0) + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + (i1 << 6) | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = i8 + 4 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i8 >> 2] = i4;
 i4 = i8 + 8 | 0;
 HEAP32[i4 >> 2] = i5;
 i1 = i1 << 6 >> 6;
 HEAP32[i8 + 16 >> 2] = i1;
 i5 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 >> 2] = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if ((i1 | 0) > 0) {
  HEAP32[i11 + 20 >> 2] = i12;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = i8;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) do {
   i10 = i2 + 64 | 0;
   HEAP32[i3 >> 2] = i10;
   HEAP32[i5 >> 2] = i1 - i10 >> 6;
   mftCall_vii(HEAP32[i2 >> 2] | 0, i2 + 4 | 0, i11 | 0);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i10 | 0, i12 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i12);
 STACKTOP = i13;
 return;
}

function __Z11SkinGenericILi4ELb1ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, i28 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = HEAP32[i1 + 24 >> 2] | 0;
 i9 = HEAP32[i1 + 68 >> 2] | 0;
 i10 = HEAP32[i1 + 40 >> 2] | 0;
 i11 = HEAP32[i1 + 44 >> 2] | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 i7 = HEAP32[i1 + 48 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 i3 = i8;
 while (1) {
  i28 = __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence(i5, 4, i9, i8, i8, i3) | 0;
  i13 = i4 + i7 | 0;
  f14 = Math_fround(HEAPF32[i28 >> 2]);
  f20 = Math_fround(HEAPF32[i4 >> 2]);
  f19 = Math_fround(f14 * f20);
  f27 = Math_fround(HEAPF32[i28 + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f19 = Math_fround(f19 + Math_fround(f27 * f23));
  f16 = Math_fround(HEAPF32[i28 + 32 >> 2]);
  f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f19 = Math_fround(f19 + Math_fround(f16 * f17));
  f19 = Math_fround(Math_fround(HEAPF32[i28 + 48 >> 2]) + f19);
  f26 = Math_fround(HEAPF32[i28 + 4 >> 2]);
  f18 = Math_fround(f20 * f26);
  f25 = Math_fround(HEAPF32[i28 + 20 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f23 * f25));
  f15 = Math_fround(HEAPF32[i28 + 36 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f17 * f15));
  f18 = Math_fround(Math_fround(HEAPF32[i28 + 52 >> 2]) + f18);
  f24 = Math_fround(HEAPF32[i28 + 8 >> 2]);
  f20 = Math_fround(f20 * f24);
  f22 = Math_fround(HEAPF32[i28 + 24 >> 2]);
  f23 = Math_fround(f20 + Math_fround(f23 * f22));
  f20 = Math_fround(HEAPF32[i28 + 40 >> 2]);
  f17 = Math_fround(f23 + Math_fround(f17 * f20));
  f17 = Math_fround(Math_fround(HEAPF32[i28 + 56 >> 2]) + f17);
  f23 = Math_fround(HEAPF32[i13 >> 2]);
  f14 = Math_fround(f14 * f23);
  f21 = Math_fround(HEAPF32[i13 + 4 >> 2]);
  f27 = Math_fround(f14 + Math_fround(f27 * f21));
  f14 = Math_fround(HEAPF32[i13 + 8 >> 2]);
  f16 = Math_fround(f27 + Math_fround(f16 * f14));
  f15 = Math_fround(Math_fround(Math_fround(f26 * f23) + Math_fround(f25 * f21)) + Math_fround(f15 * f14));
  f14 = Math_fround(Math_fround(Math_fround(f24 * f23) + Math_fround(f22 * f21)) + Math_fround(f20 * f14));
  HEAPF32[i1 >> 2] = f19;
  HEAPF32[i1 + 4 >> 2] = f18;
  HEAPF32[i1 + 8 >> 2] = f17;
  i13 = i1 + i7 | 0;
  HEAPF32[i13 >> 2] = f16;
  HEAPF32[i13 + 4 >> 2] = f15;
  HEAPF32[i13 + 8 >> 2] = f14;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) break; else {
   i4 = i4 + i10 | 0;
   i1 = i1 + i11 | 0;
   i3 = i3 + 32 | 0;
  }
 }
 STACKTOP = i12;
 return;
}

function __ZN9JSONWrite8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 24 | 0;
 i15 = i17;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i17;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i6 = i11 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 3;
 HEAP32[i6 >> 2] = i15;
 i3 = HEAP32[i10 >> 2] | 0;
 HEAP32[i14 + 20 >> 2] = i11;
 i4 = i10 + 4 | 0;
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = i3;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) i16 = 12; else {
  i3 = i3 + 12 | 0;
  do {
   i10 = i1 + 64 | 0;
   HEAP32[i4 >> 2] = i10;
   HEAP32[i3 >> 2] = i2 - i10 >> 6;
   mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i14 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
  if (HEAP32[i6 >> 2] | 0) i16 = 12;
 }
 if ((i16 | 0) == 12) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i7, i13, i15);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i6 >> 2] = i7;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 STACKTOP = i17;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_(i12, i3, i10) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 8 | 0;
 i1 = i13;
 i2 = i12 + 88 | 0;
 if ((HEAP32[i12 + 96 >> 2] | 0) == (HEAP32[i10 + 8 >> 2] | 0)) {
  i8 = i2;
  i9 = i10;
  if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i9 >> 2] | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (HEAP32[i9 + 4 >> 2] | 0) : 0) if ((HEAP8[i12 + 100 >> 0] | 0) == (HEAP8[i10 + 12 >> 0] | 0)) if ((HEAP8[i12 + 101 >> 0] | 0) == (HEAP8[i10 + 13 >> 0] | 0)) {
   i9 = i10 + 16 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_17RelativeStopEventEEEvhtRKT_(i12, 4, i3, i1);
   STACKTOP = i13;
   return;
  }
 };
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP8[i11 >> 0] = 2;
 i9 = i11 + 1 | 0;
 HEAP16[i11 + 2 >> 1] = i3;
 i5 = i10 + 16 | 0;
 i7 = i5;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i12 + 104 | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP8[i9 >> 0] = 3;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i4 = 3;
  i2 = i6;
  i1 = i7;
 } else {
  i2 = _i64Subtract(i6 | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 256) i1 = 0; else if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 65536) i1 = 1; else i1 = i3 >>> 0 < 1 | (i3 | 0) == 1 & i2 >>> 0 < 0 ? 2 : 3;
  HEAP8[i9 >> 0] = i1;
  i14 = (i1 | 0) == 3;
  i4 = i1;
  i2 = i14 ? i6 : i2;
  i1 = i14 ? i7 : i3;
 }
 i14 = i5;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i1;
 i2 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 256) i1 = 0; else if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 65536) i1 = 4; else i1 = i2 >>> 0 < 1 | (i2 | 0) == 1 & i1 >>> 0 < 0 ? 8 : 12;
 HEAP8[i9 >> 0] = i1 | i4;
 i14 = i8;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = i7;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_9StopEventEEEvRNS0_11EventHeaderERT_(i12, i11, i10);
 STACKTOP = i13;
 return;
}

function __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i7, i1, i4, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 24 | 0;
 i8 = i9;
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i7, i1) | 0;
 if ((i2 | 0) != (i7 + 4 | 0)) {
  i1 = i2 + 28 | 0;
  if (i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i4) | 0;
   STACKTOP = i9;
   return 0;
  } else {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i7 = i4 + 11 | 0;
   i8 = HEAP8[i7 >> 0] | 0;
   i8 = i8 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, gb + 1087585 | 0, 1, i8 + 1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i8) | 0;
   i8 = HEAP8[i6 + 11 >> 0] | 0;
   i7 = i8 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i7 ? HEAP32[i6 >> 2] | 0 : i6, i7 ? HEAP32[i6 + 4 >> 2] | 0 : i8 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   STACKTOP = i9;
   return 0;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i1);
 i5 = i8 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i4);
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i7, i6, i8) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(40) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 28 | 0, i5);
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i7 = i7 + 8 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return 0;
}

function __ZN23TextDOMTransferReadBaseI8JSONReadE10InitArraysEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i5 + 44 | 0;
 i9 = i5 + 48 | 0;
 i4 = gb + 64016 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i5 + 64 | 0;
 i2 = i5 + 68 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i5 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483584) >>> 0 < 64) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 64;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 256, 4, i2, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i2, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 76 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = 64;
  HEAP32[i1 >> 2] = i7;
  break;
 } while (0);
 i7 = i5 + 60 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if ((i1 & 2147483584) >>> 0 < 64) if ((i1 | 0) > -1) {
  HEAP32[i7 >> 2] = 64;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, 512, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(512, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 + 56 >> 2] << 3 | 0) | 0;
  HEAP32[i7 >> 2] = 64;
  HEAP32[i8 >> 2] = i1;
  i1 = 64;
  break;
 } while (0);
 i3 = i5 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i1 & 2147483647;
 if (i5 >>> 0 <= i6 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = -1;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 i2 = i1 << 1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 if (i6 >>> 0 >= i2 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = -1;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i2 << 3, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = -1;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = i9 + (i4 << 3) | 0;
  HEAP32[i8 >> 2] = -1;
  i9 = i9 + (i4 << 3) + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
}

function __ZNK12CullingGroup34GetEffectiveDistanceReferencePointEv(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 16 | 0;
 i7 = i12 + 12 | 0;
 i10 = i12;
 i8 = i5 + 80 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i11 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i13 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i13 + 28 >> 2] | 0;
    i4 = HEAP32[i13 + 32 >> 2] | 0;
    i1 = i13;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i11 = 9;
  }
  if ((i11 | 0) == 7) i11 = 9;
  if ((i11 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  if (!i1) i11 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i11 = 18;
   }
  }
  if ((i11 | 0) == 16) i11 = 18;
  if ((i11 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
  __ZNK9Transform11GetPositionEv(i10, i1);
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i13 = HEAP32[i10 + 8 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = i11;
  HEAP32[i9 + 8 >> 2] = i13;
  STACKTOP = i12;
  return;
 } while (0);
 i13 = i5 + 68 | 0;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 STACKTOP = i12;
 return;
}

function __ZN5physx2Gu27intersectRayTriangleCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i10, i21, i2, i3, i5, i22, i23, i24, f14) {
 i10 = i10 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 f14 = Math_fround(f14);
 var f1 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(f19 - f1);
 f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 - f9);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f13 - f4);
 f17 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f1);
 f18 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f9);
 f15 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f4);
 i2 = i21 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f8 * f15);
 i3 = i21 + 8 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f18 * f7));
 f7 = Math_fround(f17 * f7);
 f16 = Math_fround(HEAPF32[i21 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f15 * f16));
 f8 = Math_fround(Math_fround(f18 * f16) - Math_fround(f17 * f8));
 f16 = Math_fround(Math_fround(f13 * f8) + Math_fround(Math_fround(f19 * f6) + Math_fround(f20 * f7)));
 if (f16 < Math_fround(9.99999997e-07)) {
  i24 = 0;
  return i24 | 0;
 }
 f12 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f1);
 f11 = Math_fround(Math_fround(HEAPF32[i10 + 4 >> 2]) - f9);
 f4 = Math_fround(Math_fround(HEAPF32[i10 + 8 >> 2]) - f4);
 f1 = Math_fround(Math_fround(Math_fround(f6 * f12) + Math_fround(f7 * f11)) + Math_fround(f8 * f4));
 HEAPF32[i23 >> 2] = f1;
 f9 = Math_fround(-f14);
 if (f1 < f9) {
  i24 = 0;
  return i24 | 0;
 }
 f8 = Math_fround(f16 + f14);
 if (f1 > f8) {
  i24 = 0;
  return i24 | 0;
 }
 f7 = Math_fround(Math_fround(f13 * f11) - Math_fround(f20 * f4));
 f6 = Math_fround(Math_fround(f19 * f4) - Math_fround(f13 * f12));
 f4 = Math_fround(Math_fround(f20 * f12) - Math_fround(f19 * f11));
 f1 = Math_fround(f7 * Math_fround(HEAPF32[i21 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2])));
 f1 = Math_fround(f1 + Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i24 >> 2] = f1;
 if (f1 < f9) {
  i24 = 0;
  return i24 | 0;
 }
 if (Math_fround(f1 + Math_fround(HEAPF32[i23 >> 2])) > f8) {
  i24 = 0;
  return i24 | 0;
 }
 f20 = Math_fround(Math_fround(1.0) / f16);
 HEAPF32[i22 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f4) + Math_fround(Math_fround(f17 * f7) + Math_fround(f18 * f6))) * f20);
 HEAPF32[i23 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i23 >> 2]));
 HEAPF32[i24 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i24 >> 2]));
 i24 = 1;
 return i24 | 0;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i9, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i1, 1);
   __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i2 = i2 - i1 >> 4;
 i1 = i4 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  HEAP32[i4 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i3, __Z34scripting_class_array_element_sizeP11Il2CppClass(i3) | 0, i2) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 if (i2 | 0) {
  i1 = 0;
  do {
   i6 = __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(HEAP32[i4 >> 2] | 0, i1) | 0;
   i5 = (HEAP32[i9 >> 2] | 0) + (i1 << 4) | 0;
   HEAP32[i6 >> 2] = __Z20scripting_string_newPKc((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i11, i3, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 40 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i13 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i11 >> 2] | 0)) {
   i10 = i3;
   i12 = HEAP32[i10 + 4 >> 2] | 0;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
  }
  HEAP32[i11 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i11 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 i3 = i11 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i7 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 1, 2, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i11 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 > i6 >>> 0) _memset(i1 + (i6 << 1) | 0, 0, i7 - i6 << 1 | 0) | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + (i9 * 24 | 0) | 0;
 if (i9 | 0) {
  i9 = HEAP32[gb + 37288 >> 2] | 0;
  i7 = i10 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i5 = i1;
  while (1) {
   HEAP32[i12 >> 2] = i5;
   HEAP32[i7 >> 2] = i9;
   i1 = HEAP32[i5 + 16 >> 2] | 0;
   do if (!(i1 & 2048)) {
    if (!(i1 & 512)) {
     if (!(i1 & 1048576)) {
      i1 = 0;
      break;
     }
     if (!(i1 & 4194304)) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
     i1 = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i1 & 16384)) {
     if (i1 & 1024 | 0) {
      d2 = +(HEAP32[i5 >> 2] | 0);
      break;
     }
     i4 = i5;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if (!(i1 & 4096)) {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0);
      break;
     } else {
      d2 = +(i3 >>> 0) + 4294967296.0 * +(i4 | 0);
      break;
     }
    } else d2 = +HEAPF64[i5 >> 3]; while (0);
    i1 = ~~d2 >>> 0;
   } else i1 = HEAP32[i5 >> 2] | 0; while (0);
   HEAP16[i6 >> 1] = i1;
   i5 = i5 + 24 | 0;
   if ((i5 | 0) == (i8 | 0)) break; else i6 = i6 + 2 | 0;
  }
 }
 HEAP32[i12 >> 2] = i13;
 return;
}

function __ZN7mecanim5human13HumanCopyAxesEPKNS0_5HumanEPS1_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = i7 + 40 | 0;
 i10 = i9;
 i11 = i8 + 40 | 0;
 i12 = i11;
 i6 = 0;
 do {
  i1 = HEAP32[i7 + 72 + (i6 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   i5 = (HEAP32[i9 >> 2] | 0) + i10 + 4 | 0;
   i1 = i5 + (HEAP32[i5 >> 2] | 0) + (i1 << 3) | 0;
  } else i1 = 0;
  i2 = HEAP32[i8 + 72 + (i6 << 2) >> 2] | 0;
  if ((i2 | 0) > -1) {
   i5 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
   i3 = i5 + 4 | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
   if ((i1 | 0) != 0 & (i3 + (i2 << 3) | 0) != 0) {
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if ((i4 | 0) != -1) {
     i1 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i5 = i5 + 16 | 0;
      i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
      i3 = (HEAP32[i9 >> 2] | 0) + i10 + 16 | 0;
      i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
      i13 = HEAP32[i3 + (i4 * 76 | 0) + 4 >> 2] | 0;
      i2 = HEAP32[i3 + (i4 * 76 | 0) + 8 >> 2] | 0;
      i14 = HEAP32[i3 + (i4 * 76 | 0) + 12 >> 2] | 0;
      HEAP32[i5 + (i1 * 76 | 0) >> 2] = HEAP32[i3 + (i4 * 76 | 0) >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 4 >> 2] = i13;
      HEAP32[i5 + (i1 * 76 | 0) + 8 >> 2] = i2;
      HEAP32[i5 + (i1 * 76 | 0) + 12 >> 2] = i14;
      i14 = HEAP32[i3 + (i4 * 76 | 0) + 20 >> 2] | 0;
      i2 = HEAP32[i3 + (i4 * 76 | 0) + 24 >> 2] | 0;
      i13 = HEAP32[i3 + (i4 * 76 | 0) + 28 >> 2] | 0;
      HEAP32[i5 + (i1 * 76 | 0) + 16 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 16 >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 20 >> 2] = i14;
      HEAP32[i5 + (i1 * 76 | 0) + 24 >> 2] = i2;
      HEAP32[i5 + (i1 * 76 | 0) + 28 >> 2] = i13;
      i13 = HEAP32[i3 + (i4 * 76 | 0) + 36 >> 2] | 0;
      i2 = HEAP32[i3 + (i4 * 76 | 0) + 40 >> 2] | 0;
      HEAP32[i5 + (i1 * 76 | 0) + 32 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 32 >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 36 >> 2] = i13;
      HEAP32[i5 + (i1 * 76 | 0) + 40 >> 2] = i2;
      i2 = HEAP32[i3 + (i4 * 76 | 0) + 48 >> 2] | 0;
      i13 = HEAP32[i3 + (i4 * 76 | 0) + 52 >> 2] | 0;
      HEAP32[i5 + (i1 * 76 | 0) + 44 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 44 >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 48 >> 2] = i2;
      HEAP32[i5 + (i1 * 76 | 0) + 52 >> 2] = i13;
      i13 = HEAP32[i3 + (i4 * 76 | 0) + 60 >> 2] | 0;
      i2 = HEAP32[i3 + (i4 * 76 | 0) + 64 >> 2] | 0;
      HEAP32[i5 + (i1 * 76 | 0) + 56 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 56 >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 60 >> 2] = i13;
      HEAP32[i5 + (i1 * 76 | 0) + 64 >> 2] = i2;
      HEAP32[i5 + (i1 * 76 | 0) + 68 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 68 >> 2];
      HEAP32[i5 + (i1 * 76 | 0) + 72 >> 2] = HEAP32[i3 + (i4 * 76 | 0) + 72 >> 2];
     }
    }
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 24);
 return;
}

function __ZN5physx21MaterialIndicesStruct17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 138820 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 138820 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 138820 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 138820 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 138820 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 138820 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 138820 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 138820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 138852 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 138852 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 138852 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 138852 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 138852 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 138852 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 138852 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 138852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 138884 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 138884 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 138884 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 138884 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 138884 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 138884 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 138884 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 138884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 138916 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 138916 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 138916 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 138916 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 138916 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 138916 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 138916 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 138916 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 138948 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 138948 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 138948 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 138948 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 138948 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 138948 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 138948 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 138948 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN10Matrix3x3fmLERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = i2 + 4 | 0;
 i16 = i2 + 8 | 0;
 i14 = i2 + 16 | 0;
 i13 = i2 + 20 | 0;
 i11 = i2 + 24 | 0;
 i9 = i2 + 32 | 0;
 i7 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i10 = i1 + 12 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 24 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 i3 = i1 + 4 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i15 = i1 + 28 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i4 >> 2])));
 i15 = i1 + 8 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 32 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj541ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1, i6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj542ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 16 | 0, i6 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj543ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 32 | 0, i6 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj544ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 48 | 0, i6 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj545ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 64 | 0, i6 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj546ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 80 | 0, i6 + 5 | 0);
 i1 = i1 + 96 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj547ENS_22PxRepXPropertyAccessorILj547ES4_NS4_4EnumES9_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 7 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 7 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 7 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 7 | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sn18writeAllPropertiesINS_18PxJointLinearLimitEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i11, i3, i7, i1, i2) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i12 = i13 + 160 | 0;
 i5 = i13 + 32 | 0;
 i9 = i13 + 128 | 0;
 i10 = i11;
 i14 = i7;
 i4 = i3;
 i6 = i2;
 __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev(i5);
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i14;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i1;
 HEAP32[i8 + 16 >> 2] = i6;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEEEEEjT_j(i5, i8, 0) | 0;
 HEAP32[i9 >> 2] = i10;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i4;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i6;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 i5 = i5 + 80 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i6 = i12 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = i1 + -1 | 0;
  i3 = i11 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i4 + (i2 << 3) + 4 >> 0] | 0)) {
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, HEAP32[i4 + (i2 << 3) >> 2] | 0);
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] = 1;
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 if ((HEAP32[i11 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i14 = (HEAP32[i11 + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i14 + 4 >> 2] = i8;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i11, i8) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj490ENS_22PxRepXPropertyAccessorILj490ES4_ffEEEEvRKT0_(i9, i12);
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE6extendEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i10 + 4 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] << 7;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i7 = _PxGetFoundation() | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
 i7 = mftCall_iiiiii(i6 | 0, i8 | 0, i1 | 0, (i7 ? gb + 702609 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 140) | 0;
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 + 1 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[(HEAP32[i10 + 24 >> 2] | 0) + (i8 << 2) >> 2] = i7;
 i8 = i10 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = Math_imul(i1 << 2, i3) | 0;
 if (!i2) i2 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i2 = mftCall_iiiiii(i6 | 0, i1 | 0, i2 | 0, (i3 ? gb + 702609 | 0 : gb + 837976 | 0) | 0, gb + 702731 | 0, 147) | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i6 = i10 + 32 | 0;
 i4 = ((Math_imul(i3, i1) | 0) + 31 | 0) >>> 5;
 i5 = i10 + 36 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i1 = i10 + 40 | 0;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i6 >> 2] | 0);
  }
  i3 = HEAP32[i5 >> 2] | 0;
  _memset(i2 + ((i3 & 2147483647) << 2) | 0, 0, i4 - i3 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i5 >> 2] = i4;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i3 + -1 | 0;
 if ((i1 | 0) <= -1) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = i10 + 28 | 0;
 i4 = i10 + 20 | 0;
 while (1) {
  i5 = i7 + (i1 << 7) | 0;
  __ZN5physx17PxsContactManagerC2EPNS_10PxsContextEj(i5, HEAP32[i2 >> 2] | 0, (Math_imul((HEAP32[i9 >> 2] | 0) + -1 | 0, i3) | 0) + i1 | 0);
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i6 + 1;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] = i5;
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= -1) {
   i1 = 1;
   break;
  }
  i3 = HEAP32[i10 >> 2] | 0;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN14NavMeshManager14SamplePositionEP10NavMeshHitRK8Vector3fRK13dtQueryFilterf(i6, i7, i3, i4, f8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f8 = Math_fround(f8);
 var f1 = f0, i2 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i11 + 20 | 0;
 i5 = i11 + 8 | 0;
 HEAPF32[i5 >> 2] = f8;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f8;
 i2 = HEAP32[i6 + 112 >> 2] | 0;
 if (i2 | 0) {
  __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i2, i3, i5, i4, i9, i10) | 0;
  i5 = i9;
  if (!((HEAP32[i5 >> 2] | 0) == 0 & (HEAP32[i5 + 4 >> 2] | 0) == 0)) {
   f13 = Math_fround(HEAPF32[i10 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i3 >> 2]));
   f12 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 + 4 >> 2]));
   f1 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f1 = Math_fround(f1 - Math_fround(HEAPF32[i3 + 8 >> 2]));
   f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)) + Math_fround(f1 * f1))));
   if (f1 > f8) {
    HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
    i10 = i7 + 12 | 0;
    HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    HEAPF32[i7 + 24 >> 2] = Math_fround(inf);
    HEAP32[i7 + 28 >> 2] = 0;
    HEAP32[i7 + 32 >> 2] = 0;
    i10 = 0;
    STACKTOP = i11;
    return i10 | 0;
   } else {
    __ZNK15HeightMeshQuery17SetPositionHeightEPf(HEAP32[i6 + 116 >> 2] | 0, i10) | 0;
    HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    i10 = i7 + 12 | 0;
    HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    HEAPF32[i7 + 24 >> 2] = f1;
    i10 = i9;
    HEAP32[i7 + 28 >> 2] = __ZNK9dtNavMesh12getPolyFlagsEy(HEAP32[i6 + 108 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0) | 0;
    HEAP32[i7 + 32 >> 2] = 1;
    i10 = 1;
    STACKTOP = i11;
    return i10 | 0;
   }
  }
 };
 HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 i10 = i7 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i7 + 24 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN27NoiseModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 do switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 800 >> 2] = f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 888 >> 2] | 0) + 805 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 812 >> 2] = f4;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 816 >> 2] = f4;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 904 >> 2] = f4;
   HEAP8[i3 + 910 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 824 | 0, i3 + 912 | 0, f4, HEAP16[i3 + 908 >> 1] | 0) | 0) & 1;
   return;
  }
 case 8:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 1172 >> 2] = f4;
   HEAP8[i3 + 1178 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1092 | 0, i3 + 1180 | 0, f4, HEAP16[i3 + 1176 >> 1] | 0) | 0) & 1;
   return;
  }
 case 9:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 1436 >> 2] = f4;
   HEAP8[i3 + 1442 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1356 | 0, i3 + 1444 | 0, f4, HEAP16[i3 + 1440 >> 1] | 0) | 0) & 1;
   return;
  }
 case 10:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 888 >> 2] | 0;
   HEAPF32[i3 + 1700 >> 2] = f4;
   HEAP8[i3 + 1706 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 1620 | 0, i3 + 1708 | 0, f4, HEAP16[i3 + 1704 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 } while (0);
}

function __ZN13WheelCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 60 | 0, gb + 1034411 | 0, 0);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN11JointSpring8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 76 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 104 | 0, i5);
 __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 124 | 0, i5);
 i1 = i4 + 41 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 200 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) >> 2]);
 f14 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 f14 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f13 + Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = i8 + 44 | 0;
 if (!(HEAP32[i6 >> 2] & 32768)) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = i8 + 32 | 0;
 __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i9 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, i8 + 60 | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 & 476) {
  i1 = (i1 >>> 11 & 256 | 16) & i1;
  i5 = i8 + 48 | 0;
  if (i1 | 0) __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i8, i1, (HEAP16[(HEAP32[i5 >> 2] | 0) + 14 >> 1] | 0) == 1 ? 8 : 0, 1, i2);
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i2 + 20 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i9 >> 2] | 0) | 0) + 76 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 | 0)) {
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = i2 + 20 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2);
     i1 = HEAP32[i3 >> 2] | 0;
    }
    i5 = i1 + 10 | 0;
    HEAP16[i5 >> 1] = HEAP16[i5 >> 1] | 16;
   }
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 & 10485760) {
   i2 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i9 >> 2] | 0) | 0) + 1104 >> 2] | 0;
   if (!(i1 & 8388608)) __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i2, i8); else __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i2, i8);
   i1 = HEAP32[i6 >> 2] & -1572865;
   HEAP32[i6 >> 2] = i1;
  }
 }
 HEAP32[i6 >> 2] = i1 & -98305 | 65536;
 if (i7) {
  i3 = (HEAP32[i8 + 48 >> 2] | 0) + 14 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
  i3 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i9 >> 2] | 0) | 0;
  i1 = i8 + 36 | 0;
  i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 >> 2] | 0) | 0;
  if (i3 | 0) {
   i8 = i3 + 148 | 0;
   HEAP16[i8 >> 1] = (HEAP16[i8 >> 1] | 0) + -1 << 16 >> 16;
  }
  if (i2) {
   i8 = i2 + 148 | 0;
   HEAP16[i8 >> 1] = (HEAP16[i8 >> 1] | 0) + -1 << 16 >> 16;
  }
 } else i1 = i8 + 36 | 0;
 i4 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i9 >> 2] | 0) | 0;
 i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i1 >> 2] | 0) | 0;
 i2 = (i4 | 0) != 0;
 i3 = (i1 | 0) != 0;
 if (i2 & i3) {
  i9 = 1;
  return i9 | 0;
 }
 if (i2) __ZN5physx2Sc7BodySim14internalWakeUpEf(i4, Math_fround(.399999976));
 if (!i3) {
  i9 = 0;
  return i9 | 0;
 }
 __ZN5physx2Sc7BodySim14internalWakeUpEf(i1, Math_fround(.399999976));
 i9 = 0;
 return i9 | 0;
}

function __ZNSt3__218__insertion_sort_3IRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i6, i7, i18) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i28 = i31;
 i1 = i6 + 176 | 0;
 __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_(i6, i6 + 88 | 0, i1, i18) | 0;
 i2 = i6 + 264 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i31;
  return;
 }
 i29 = i28 + 4 | 0;
 i30 = i28 + 8 | 0;
 i8 = i28 + 12 | 0;
 i9 = i28 + 16 | 0;
 i10 = i28 + 20 | 0;
 i11 = i28 + 24 | 0;
 i12 = i28 + 28 | 0;
 i13 = i28 + 32 | 0;
 i14 = i28 + 36 | 0;
 i15 = i28 + 40 | 0;
 i16 = i28 + 44 | 0;
 i17 = i28 + 48 | 0;
 i19 = i28 + 52 | 0;
 i20 = i28 + 56 | 0;
 i21 = i28 + 60 | 0;
 i22 = i28 + 64 | 0;
 i23 = i28 + 68 | 0;
 i24 = i28 + 72 | 0;
 i25 = i28 + 76 | 0;
 i26 = i28 + 80 | 0;
 i27 = i28 + 84 | 0;
 while (1) {
  if (mftCall_iii(HEAP32[i18 >> 2] | 0, i2 | 0, i1 | 0) | 0) {
   HEAP32[i28 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i29 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i30 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i8 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i9 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i12 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i13 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i14 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i15 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i16 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i17 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i2 + 52 >> 2];
   HEAP32[i20 >> 2] = HEAP32[i2 + 56 >> 2];
   HEAP32[i21 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i22 >> 2] = HEAP32[i2 + 64 >> 2];
   HEAP32[i23 >> 2] = HEAP32[i2 + 68 >> 2];
   HEAP32[i24 >> 2] = HEAP32[i2 + 72 >> 2];
   HEAP32[i25 >> 2] = HEAP32[i2 + 76 >> 2];
   HEAP32[i26 >> 2] = HEAP32[i2 + 80 >> 2];
   HEAP32[i27 >> 2] = HEAP32[i2 + 84 >> 2];
   i3 = i2;
   while (1) {
    i4 = i1;
    i5 = i3 + 88 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    if ((i1 | 0) == (i6 | 0)) break;
    i3 = i1 + -88 | 0;
    if (mftCall_iii(HEAP32[i18 >> 2] | 0, i28 | 0, i3 | 0) | 0) {
     i5 = i1;
     i1 = i3;
     i3 = i5;
    } else break;
   }
   i3 = i1;
   i4 = i28;
   i5 = i3 + 88 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
  }
  i1 = i2 + 88 | 0;
  if ((i1 | 0) == (i7 | 0)) break; else {
   i5 = i2;
   i2 = i1;
   i1 = i5;
  }
 }
 STACKTOP = i31;
 return;
}

function __ZN17PersistentManager23DestroyFromFileInternalEi(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i2 = HEAP32[i6 + 56 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i4 = 5; else {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if ((i3 | 0) > (i5 | 0)) i4 = 5; else if ((HEAP32[i2 + 32 >> 2] | 0) < (i5 | 0)) i4 = 5; else {
   i9 = (i5 - i3 | 0) / 2 | 0;
   i10 = i9;
   i9 = ((i9 | 0) < 0) << 31 >> 31;
  }
 }
 if ((i4 | 0) == 5) {
  i4 = i2 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   STACKTOP = i11;
   return;
  } else i2 = i4;
  L9 : while (1) {
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i1) break L9; else i3 = i1;
   }
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) == (i4 | 0)) {
   STACKTOP = i11;
   return;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > (i5 | 0)) {
   STACKTOP = i11;
   return;
  }
  i1 = HEAP32[i2 + 24 >> 2] | 0;
  i2 = i2 + 32 | 0;
  if ((i1 | 0) == -1) {
   STACKTOP = i11;
   return;
  } else {
   i10 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i2 + 4 >> 2] | 0;
  }
 }
 i1 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i6, i1) | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = i1 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(20, gb + 63416 | 0, 16, gb + 466989 | 0, gb + 1576256 | 0, gb + 466878 | 0, 74) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
  i6 = i7;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i2;
 }
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 8, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = (HEAP32[i2 >> 2] | 0) + (i4 << 3) | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN13AnimationClip10FloatCurveC2ERKS0_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i8 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i7 + 11 >> 0] = i3;
  if (!i3) i1 = i7; else {
   i1 = i7;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i3;
  i6 = 6;
 }
 if ((i6 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i7 + 16 | 0;
 i3 = i8 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i8 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i7 + 28 >> 2] | 0;
  i6 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i6 = 12;
 } else i6 = 10;
 if ((i6 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i4;
  i1 = i5;
  i6 = 12;
 }
 if ((i6 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i3 = i8 + 32 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7 + 32 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i7 + 40 | 0;
 i2 = i8 + 40 | 0;
 i3 = i1 + 56 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i7 + 96 | 0, i8 + 96 | 0);
 i10 = i7 + 116 | 0;
 i6 = i8 + 116 | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 128 >> 2] = HEAP32[i8 + 128 >> 2];
 STACKTOP = i9;
 return;
}

function __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState(i7, i1, i10, i9, i11) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 12 | 0;
 i6 = i12;
 if ((HEAP32[i7 + 68 >> 2] | 0) == (HEAP32[i7 + 4 >> 2] | 0)) {
  i2 = i7 + 60 | 0;
  i3 = i7 + 64 | 0;
  i5 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i6 >> 2] = i7;
  i1 = i6 + 4 | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i5;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i6);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E13find_positionERS3_(i8, i7, i1);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i7 + 60 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = i7 + 64 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i5 = i4 + (i5 * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i7;
   i1 = i6 + 4 | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i6 + 8 >> 2] = i5;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i6);
  } else {
   HEAP32[i6 >> 2] = i7;
   i13 = i6 + 4 | 0;
   HEAP32[i13 >> 2] = i4 + (i1 * 24 | 0);
   HEAP32[i6 + 8 >> 2] = i4 + (i5 * 24 | 0);
   i1 = i13;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i6 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i8 >> 2] = i7;
 i13 = i8 + 4 | 0;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i6;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i8);
 if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i3 = i1 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 do if (((HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] | 0) + -1 | 0) >>> 0 < 4) if (__ZN14AnimationState18ShouldMixTransformER9Transform(i11, HEAP32[i2 + (i1 * 24 | 0) + 12 >> 2] | 0) | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  break;
 } else {
  STACKTOP = i12;
  return;
 } while (0);
 HEAP32[(HEAP32[i11 + 4 >> 2] | 0) + (i1 << 2) >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __Z27StateChangeValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object(i1, i2, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 40 | 0;
 i6 = i11 + 32 | 0;
 i4 = i11 + 24 | 0;
 i7 = i11 + 16 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 i14 = i2;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i4 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i10) | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i6, i4, i3, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 444 >> 2] | 0);
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i6 + 4 >> 0] | 0;
 L1 : do if (HEAP32[i2 >> 2] | 0) {
  i6 = i2;
  i4 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i14 = i7;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i14 + 4 >> 2] = i6;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  switch (__Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i10) | 0) {
  case 3:
   {
    i9 = i8;
    HEAP32[i9 >> 2] = i4;
    HEAP32[i9 + 4 >> 2] = i6;
    i9 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 8 >> 2] | 0;
    i12 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 20 >> 2] | 0;
    i13 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
    i14 = __Z14GetMonoManagerv() | 0;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    if (__Z22Check3MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_P6ObjectR11MonoManager(i10, i3, i9, i12, i13, i5, i14) | 0) break L1;
    break;
   }
  case 4:
   {
    i7 = i9;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i7 + 4 >> 2] = i6;
    i7 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 8 >> 2] | 0;
    i8 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 20 >> 2] | 0;
    i12 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
    i13 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 48 >> 2] | 0;
    i14 = __Z14GetMonoManagerv() | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    if (__Z22Check4MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_S1_P6ObjectR11MonoManager(i10, i3, i7, i8, i12, i13, i5, i14) | 0) break L1;
    break;
   }
  default:
   break L1;
  }
  HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
  HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 } while (0);
 i12 = i2;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 STACKTOP = i11;
 return;
}

function __Z19mono_profiler_begin21ScriptingMethodIl2CppP11Il2CppClassS_P12Il2CppObject(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 32 | 0;
 i13 = i18 + 24 | 0;
 i10 = i18 + 16 | 0;
 i11 = i18 + 8 | 0;
 i12 = i18;
 i17 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i17) {
  i17 = -1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!(HEAP8[i17 >> 0] | 0)) {
  i17 = -1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 24 >> 2] & 4 | 0) {
  i17 = HEAP32[(HEAP32[i17 + 36 >> 2] | 0) + ((HEAP32[i17 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!i7) i15 = 0; else {
  i15 = __Z26scripting_object_get_classP12Il2CppObject(i7) | 0;
  if (__Z26scripting_class_has_parentP11Il2CppClassS0_(i15, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0) i15 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0; else i15 = 0;
 }
 i8 = i17 + 192 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) i16 = 17; else {
  i9 = HEAP32[i4 >> 2] | 0;
  i1 = i8;
  L17 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L17; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i8 | 0)) i16 = 17; else if (i9 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) i16 = 17; else i2 = HEAP32[i1 + 24 >> 2] | 0;
 }
 if ((i16 | 0) == 17) {
  i9 = i4;
  i16 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = i10;
  HEAP32[i2 >> 2] = i16;
  HEAP32[i2 + 4 >> 2] = i9;
  i2 = i11;
  HEAP32[i2 >> 2] = i16;
  HEAP32[i2 + 4 >> 2] = i9;
  HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  i2 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i14) | 0;
  i9 = i6;
  i11 = HEAP32[i9 + 4 >> 2] | 0;
  i16 = i12;
  HEAP32[i16 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i16 + 4 >> 2] = i11;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  i2 = __ZN22UnityProfilerPerThread34CreateProfilerInformationForMethodEP12Il2CppObject21ScriptingMethodIl2CppPKcP11Il2CppClassS2_N19ProfilerInformation5FlagsE(i17, i7, i13, i2, i5, i14, 8) | 0;
 }
 if ((HEAP16[i2 + 6 >> 1] | 0) <= -1) {
  i17 = -1;
  STACKTOP = i18;
  return i17 | 0;
 }
 if (!i15) i1 = 0; else i1 = HEAP32[i15 + 4 >> 2] | 0;
 i17 = __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i17, i2, i1) | 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj(i2, i3, f4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 72 | 0;
 i18 = i5 + 60 | 0;
 i17 = i5 + 48 | 0;
 i16 = i5 + 36 | 0;
 i15 = i5 + 24 | 0;
 i10 = i5 + 12 | 0;
 i6 = i5;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i3 = i14 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = Math_fround(1.0);
 i3 = i14 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(1.0);
 i3 = i14 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 60 >> 2] = Math_fround(1.0);
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f13 = Math_fround(f8 + Math_fround(0.0));
 f12 = Math_fround(f7 + f4);
 f11 = Math_fround(f9 + Math_fround(0.0));
 HEAPF32[i18 >> 2] = f13;
 HEAPF32[i18 + 4 >> 2] = f12;
 HEAPF32[i18 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i18) | 0;
 f12 = Math_fround(f7 - f4);
 HEAPF32[i17 >> 2] = f8;
 HEAPF32[i17 + 4 >> 2] = f12;
 HEAPF32[i17 + 8 >> 2] = f9;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i17) | 0;
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f12 = Math_fround(f7 + Math_fround(0.0));
 HEAPF32[i16 >> 2] = Math_fround(f8 + f4);
 HEAPF32[i16 + 4 >> 2] = f12;
 HEAPF32[i16 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i16) | 0;
 HEAPF32[i15 >> 2] = Math_fround(f8 - f4);
 HEAPF32[i15 + 4 >> 2] = f7;
 HEAPF32[i15 + 8 >> 2] = f9;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i15) | 0;
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f11 = Math_fround(f9 + f4);
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i10 + 4 >> 2] = f12;
 HEAPF32[i10 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i10) | 0;
 f4 = Math_fround(f9 - f4);
 HEAPF32[i6 >> 2] = f8;
 HEAPF32[i6 + 4 >> 2] = f7;
 HEAPF32[i6 + 8 >> 2] = f4;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN27ParticleSystemReadOnlyState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i1 = i7 + 264 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 268 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 277 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 278 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 279 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 276 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 280 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 288 | 0, i5);
 i1 = i7 + 284 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 272 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i4 = i11 + 8 | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[HEAP32[i3 >> 2] >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i4) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i9 = HEAP32[i8 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i1 << 3 | 0, 4) | 0;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 }
 HEAP32[i2 >> 2] = i1;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 + (HEAP32[HEAP32[i3 >> 2] >> 2] << 3) | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i3 = HEAP32[gb + 37320 >> 2] | 0;
  i4 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i4 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i4 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i8 = i2 + 24 | 0;
     HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i8 + 4 >> 2] = i3;
     i8 = HEAP32[i7 >> 2] | 0;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL23FindShadowCastingLightsR12ActiveLightsR13dynamic_arrayI13ShadowedLightLj16EEjj(i11, i12, i3, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15 + 4 | 0;
 i2 = i15;
 if ((HEAP16[gb + 1110764 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110764 | 0, i1);
  i7 = gb + 1110764 | 0;
 } else i7 = 0;
 if (i3 >>> 0 < i13 >>> 0) {
  i9 = i12 + 12 | 0;
  i10 = i12 + 16 | 0;
  i8 = i12 + 4 | 0;
  do {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!(HEAP8[i1 + (i3 * 180 | 0) + 9 >> 0] | 0)) i14 = 17; else if (!(HEAP8[i1 + (i3 * 180 | 0) + 8 >> 0] | 0)) i14 = 17; else if (!(HEAP32[(HEAP32[i1 + (i3 * 180 | 0) >> 2] | 0) + 96 >> 2] | 0)) i14 = 17; else {
    i6 = HEAP32[i9 >> 2] | 0;
    HEAP32[i1 + (i3 * 180 | 0) + 4 >> 2] = i6;
    i2 = i6 + 1 | 0;
    i4 = HEAP32[i10 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i2 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 * 960 | 0, 16, i8, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 960 | 0, 16, i8, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 960 | 0) | 0;
      HEAP32[i10 >> 2] = i1;
      HEAP32[i12 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i9 >> 2] = i2;
    i1 = HEAP32[i12 >> 2] | 0;
    i2 = i1 + (i6 * 960 | 0) + 4 | 0;
    HEAP32[i1 + (i6 * 960 | 0) + 68 >> 2] = 0;
    i4 = i2;
    i5 = i4 + 60 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i5 | 0));
    HEAP8[i2 + 60 >> 0] = 0;
    HEAP32[i1 + (i6 * 960 | 0) + 72 >> 2] = 0;
    HEAP32[i1 + (i6 * 960 | 0) + 76 >> 2] = 0;
    HEAPF32[i1 + (i6 * 960 | 0) + 700 >> 2] = Math_fround(0.0);
    i4 = i1 + (i6 * 960 | 0) + 832 | 0;
    i5 = i4 + 60 | 0;
    do {
     HEAP32[i4 >> 2] = 0;
     i4 = i4 + 4 | 0;
    } while ((i4 | 0) < (i5 | 0));
    HEAP32[i1 + (i6 * 960 | 0) + 932 >> 2] = 0;
    HEAP32[i1 + (i6 * 960 | 0) + 936 >> 2] = 0;
    HEAP32[i1 + (i6 * 960 | 0) + 944 >> 2] = 0;
    HEAP32[i1 + (i6 * 960 | 0) >> 2] = i3;
   }
   if ((i14 | 0) == 17) {
    i14 = 0;
    HEAP32[i1 + (i3 * 180 | 0) + 4 >> 2] = -1;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i13 | 0));
 }
 if (!i7) {
  STACKTOP = i15;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i15;
 return;
}

function __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 f11 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = f9 < f11 ? f9 : f11;
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = f15 < f11 ? f15 : f11;
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = f13 < f11 ? f13 : f11;
 f12 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f7 = f12 < f11 ? f12 : f11;
 f9 = Math_fround(f9 - f11);
 f15 = Math_fround(f15 - f11);
 f13 = Math_fround(f13 - f11);
 f11 = Math_fround(f12 - f11);
 i3 = f9 < Math_fround(0.0);
 f9 = i3 ? Math_fround(0.0) : f9;
 i3 = f15 < Math_fround(0.0);
 f15 = i3 ? Math_fround(0.0) : f15;
 i3 = f13 < Math_fround(0.0);
 f13 = i3 ? Math_fround(0.0) : f13;
 i3 = f11 < Math_fround(0.0);
 f11 = i3 ? Math_fround(0.0) : f11;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(f4 * f12);
 f16 = Math_fround(f5 * f12);
 f14 = Math_fround(f12 * f6);
 f12 = Math_fround(f12 * f7);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(f4 * Math_fround(f10 + f8));
 f16 = Math_fround(f5 * Math_fround(f16 + f8));
 f14 = Math_fround(f6 * Math_fround(f14 + f8));
 f12 = Math_fround(f7 * Math_fround(f8 + f12));
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f4 * Math_fround(f8 + f10));
 f16 = Math_fround(f5 * Math_fround(f8 + f16));
 f14 = Math_fround(f6 * Math_fround(f8 + f14));
 f12 = Math_fround(f7 * Math_fround(f8 + f12));
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(f4 * Math_fround(f8 + f10));
 f16 = Math_fround(f5 * Math_fround(f8 + f16));
 f14 = Math_fround(f6 * Math_fround(f8 + f14));
 f12 = Math_fround(f7 * Math_fround(f8 + f12));
 f8 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f7 = Math_fround(f9 * f8);
 f6 = Math_fround(f15 * f8);
 f5 = Math_fround(f13 * f8);
 f8 = Math_fround(f11 * f8);
 f4 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(f9 * Math_fround(f7 + f4));
 f6 = Math_fround(f15 * Math_fround(f6 + f4));
 f5 = Math_fround(f13 * Math_fround(f5 + f4));
 f4 = Math_fround(f11 * Math_fround(f8 + f4));
 f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f7 = Math_fround(f9 * Math_fround(f8 + f7));
 f6 = Math_fround(f15 * Math_fround(f8 + f6));
 f5 = Math_fround(f13 * Math_fround(f8 + f5));
 f4 = Math_fround(f11 * Math_fround(f8 + f4));
 f8 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f6 = Math_fround(f16 + Math_fround(f15 * Math_fround(f8 + f6)));
 f5 = Math_fround(f14 + Math_fround(f13 * Math_fround(f8 + f5)));
 f4 = Math_fround(f12 + Math_fround(f11 * Math_fround(f8 + f4)));
 HEAPF32[i1 >> 2] = Math_fround(f10 + Math_fround(f9 * Math_fround(f8 + f7)));
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = f4;
 return;
}

function __ZN6prcoreL18BlitIntegerToFloatERK14ImageReferenceRS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 L1 : do switch (i1 | 0) {
 case 5:
  {
   if ((i3 | 0) == 18) i1 = 0; else if ((i3 | 0) == 19) i1 = 1; else if ((i3 | 0) == 23) i1 = 2; else if ((i3 | 0) == 20) i1 = 3; else if ((i3 | 0) == 6) i1 = 4; else if ((i3 | 0) == 15) i1 = 5; else if ((i3 | 0) == 16) i1 = 6; else if ((i3 | 0) == 17) i1 = 7; else {
    i1 = 91;
    i7 = 13;
    break L1;
   }
   i1 = HEAP32[gb + 57604 + (i1 << 2) >> 2] | 0;
   if (!i1) {
    i1 = 91;
    i7 = 13;
   } else {
    HEAP8[i6 >> 0] = 0;
    HEAP32[i6 + 4 >> 2] = i1;
    i1 = i6 + 8 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    i1 = i6 + 12 | 0;
   }
   break;
  }
 case -1:
  {
   i1 = 0;
   i7 = 13;
   break;
  }
 default:
  if ((i1 | 0) == 1001) {
   i1 = 13;
   i7 = 13;
  } else if ((i1 | 0) == 1) {
   i1 = 26;
   i7 = 13;
  } else if ((i1 | 0) == 7) {
   i1 = 39;
   i7 = 13;
  } else if ((i1 | 0) == 3) {
   i1 = 52;
   i7 = 13;
  } else {
   switch (i1 | 0) {
   case 2:
   case 5:
    {
     i1 = (i1 | 0) == 2 ? 78 : 91;
     i7 = 13;
     break L1;
    }
   default:
    {}
   }
   if ((i1 | 0) == 8) {
    i1 = 104;
    i7 = 13;
   } else if ((i1 | 0) == 1e3) {
    i1 = 117;
    i7 = 13;
   } else if ((i1 | 0) == 13) {
    i1 = 130;
    i7 = 13;
   } else if ((i1 | 0) == 14) {
    i1 = 143;
    i7 = 13;
   } else if ((i1 | 0) == 4) {
    i1 = 156;
    i7 = 13;
   } else {
    i2 = 0;
    i7 = 23;
   }
  }
 } while (0);
 if ((i7 | 0) == 13) {
  i2 = HEAP32[gb + 56896 + (i1 + 7 << 2) >> 2] | 0;
  i7 = 23;
 }
 if ((i7 | 0) == 23) {
  if ((i3 | 0) == 18) {
   i1 = 0;
   i7 = 25;
  } else if ((i3 | 0) == 19) {
   i1 = 1;
   i7 = 25;
  } else if ((i3 | 0) == 23) {
   i1 = 2;
   i7 = 25;
  } else if ((i3 | 0) == 20) {
   i1 = 3;
   i7 = 25;
  } else if ((i3 | 0) == 6) {
   i1 = 4;
   i7 = 25;
  } else if ((i3 | 0) == 15) {
   i1 = 5;
   i7 = 25;
  } else if ((i3 | 0) == 16) {
   i1 = 6;
   i7 = 25;
  } else if ((i3 | 0) == 17) {
   i1 = 7;
   i7 = 25;
  } else i1 = 0;
  if ((i7 | 0) == 25) i1 = HEAP32[gb + 57604 + (i1 << 2) >> 2] | 0;
  i7 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(5) | 0) + 4 >> 2] | 0;
  HEAP8[i6 >> 0] = 1;
  HEAP32[i6 + 4 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = i6 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = i7;
 }
 __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE(i5, i4, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZdaPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN5physx28PxTransformFromPlaneEquationERKNS_7PxPlaneE(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f13 * f13)))));
 f11 = Math_fround(f11 * f10);
 f12 = Math_fround(f12 * f10);
 f13 = Math_fround(f13 * f10);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * f10);
 if (((f11 == Math_fround(0.0) & 1) + (f12 == Math_fround(0.0) & 1) + (f13 == Math_fround(0.0) & 1) | 0) == 2) if (f11 > Math_fround(0.0)) {
  i1 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 1065353216;
 } else if (f11 < Math_fround(0.0)) {
  i1 = 0;
  i4 = 0;
  i5 = 1065353216;
  i6 = 0;
 } else {
  f8 = Math_fround(f13 * Math_fround(-.707106769));
  f9 = Math_fround(f12 * Math_fround(.707106769));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = 0;
  i5 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = 1060439283;
 } else {
  f2 = Math_fround(f12 * Math_fround(0.0));
  f3 = Math_fround(f13 * Math_fround(0.0));
  f9 = Math_fround(f3 + Math_fround(f11 + f2));
  if (f9 > Math_fround(-1.0)) {
   f8 = Math_fround(f11 * Math_fround(0.0));
   f3 = Math_fround(f3 - f2);
   f7 = Math_fround(f8 - f13);
   f8 = Math_fround(f12 - f8);
   f2 = Math_fround(f9 + Math_fround(1.0));
  } else if (Math_fround(Math_abs(Math_fround(1.0))) < Math_fround(.100000001)) {
   f3 = Math_fround(0.0);
   f7 = Math_fround(0.0);
   f8 = Math_fround(-0.0);
   f2 = Math_fround(0.0);
  } else {
   f3 = Math_fround(0.0);
   f7 = Math_fround(-1.0);
   f8 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
  f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f8 * f8) + Math_fround(Math_fround(f7 * f7) + Math_fround(f3 * f3)))))));
  f3 = Math_fround(f3 * f9);
  f7 = Math_fround(f7 * f9);
  f8 = Math_fround(f8 * f9);
  f9 = Math_fround(f2 * f9);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f11 = Math_fround(-Math_fround(f11 * f10));
 f12 = Math_fround(-Math_fround(f12 * f10));
 f13 = Math_fround(-Math_fround(f13 * f10));
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i4;
 HEAP32[i14 + 8 >> 2] = i5;
 HEAP32[i14 + 12 >> 2] = i6;
 HEAPF32[i14 + 16 >> 2] = f11;
 HEAPF32[i14 + 20 >> 2] = f12;
 HEAPF32[i14 + 24 >> 2] = f13;
 return;
}

function __ZN5Umbra9Matrix3x3mLERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i9 = i1 + 12 | 0;
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 i3 = i1 + 24 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 i17 = i2 + 4 | 0;
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 i16 = i2 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 i14 = i2 + 12 | 0;
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 i13 = i2 + 16 | 0;
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 i11 = i2 + 20 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 i9 = i2 + 24 | 0;
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 i7 = i2 + 28 | 0;
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 i4 = i2 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 i3 = i1 + 4 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i15 = i1 + 28 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i4 >> 2])));
 i15 = i1 + 8 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 32 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZN18GfxFramebufferGLES23SetupDefaultFramebufferEPP17RenderSurfaceBaseS2_N2gl6HandleILNS3_10ObjectTypeE9EEE(i1, i2, i4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i1 + 384 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i1 + 400 >> 2] = 1;
 HEAP32[i1 + 408 >> 2] = 2;
 HEAP8[i1 + 414 >> 0] = 1;
 HEAP8[i1 + 415 >> 0] = 1;
 i3 = i1 + 432 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 + 448 >> 2] = 1;
 HEAP32[i1 + 456 >> 2] = 2;
 HEAP8[i1 + 462 >> 0] = 0;
 HEAP8[i1 + 463 >> 0] = 1;
 i9 = i1 + 20 | 0;
 i11 = i9 + 72 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i1 + 16 >> 2] = i8;
 HEAP32[i1 + 48 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = 1;
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i1 + 80 >> 0] = 0;
 HEAP8[i1 + 88 >> 0] = 0;
 HEAP8[i1 + 89 >> 0] = 0;
 HEAP32[i1 + 60 >> 2] = -1;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 i5 = i7 + 68 | 0;
 i9 = i7 + 4 | 0;
 i11 = i9 + 92 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i7 >> 2] = 1;
 i11 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 36 >> 2] = HEAP32[i11 + 36 >> 2];
 HEAP8[i7 + 92 >> 0] = 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 72 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i7 + 76 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i7 + 80 >> 2] = 0;
 HEAP32[i7 + 84 >> 2] = 0;
 HEAP32[i7 + 88 >> 2] = -1;
 i11 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i1, i7) | 0;
 i9 = i6;
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i9;
 i11 = i1 + 376 | 0;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i9;
 if (__Z19GetScreenManagerPtrv() | 0) {
  i11 = __Z16GetScreenManagerv() | 0;
  f13 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 80 >> 2] | 0, i11 | 0) | 0);
  f12 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i11 | 0) | 0);
  i11 = ~~f13 >>> 0;
  HEAP32[i1 + 436 >> 2] = i11;
  HEAP32[i1 + 388 >> 2] = i11;
  i11 = ~~f12 >>> 0;
  HEAP32[i1 + 440 >> 2] = i11;
  HEAP32[i1 + 392 >> 2] = i11;
 }
 if (i2 | 0) HEAP32[i2 >> 2] = i8;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i4 >> 2] = i3;
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = i16 + 28 | 0;
 i13 = i16 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i5 = i10;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i15;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i7 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i13 + 12 >> 2] = i1;
 if (i1 | 0) {
  HEAP32[i14 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i5 = 0;
   i2 = i1;
   do {
    i4 = (HEAP32[i7 >> 2] | 0) + (i5 << 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else {
     HEAP32[i11 >> 2] = i1;
     i1 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i1) i12 = 13; else {
      if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
       i2 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[i1 + 32 >> 2] | 0;
       i1 = i2 + (i3 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
       i2 = HEAP32[i10 >> 2] | 0;
       i17 = HEAP32[i1 + 28 >> 2] | 0;
       i3 = HEAP32[gb + 1104264 >> 2] | 0;
       i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
       i2 = HEAP32[i3 + 28 >> 2] | 0;
       i3 = HEAP32[i3 + 32 >> 2] | 0;
      }
      if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 13; else {
       i1 = HEAP32[i1 + 4 >> 2] | 0;
       if (!i1) i12 = 15;
      }
     }
     if ((i12 | 0) == 13) i12 = 15;
     if ((i12 | 0) == 15) {
      i12 = 0;
      i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     }
     i2 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[(HEAP32[i13 >> 2] | 0) + (i5 << 2) >> 2] = i1;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i2 >>> 0);
  }
 }
 i1 = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayIP13AnimationClipLj4EERNS1_6memory9AllocatorE(i6, i13, i9) | 0;
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i15);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i16;
 return i1 | 0;
}

function __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 32 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i7 = i6 >> 4;
 i5 = i6 >> 5 >>> 0 < 1073741823 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 73;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 5, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i1 - i4 >> 5 << 5) | 0;
 i7 = i3;
 i4 = i6 + (i5 << 5) | 0;
 i1 = i3;
 i6 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  i1 = i6 + 32 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i15 = i5;
   i5 = i5 + -32 | 0;
   HEAP32[i3 + -32 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i15 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i15 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i15 + -20 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i15 + -16 >> 2];
   HEAP32[i3 + -12 >> 2] = HEAP32[i15 + -12 >> 2];
   i15 = i15 + -8 | 0;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i7 = i3 + -8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i7 + 4 >> 2] = i14;
   i3 = i2 + -32 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i11 >> 2] = i4;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 73;
 HEAP32[i10 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5physx9NpPhysics24registerDeletionListenerERNS_18PxDeletionListenerERKNS_7PxFlagsINS_19PxDeletionEventFlag4EnumEhEEb(i9, i8, i5, i6) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i7 = i12 + 4 | 0;
 i11 = i9 + 64 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 i1 = HEAP32[i9 + 88 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = i8;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i3 = HEAP32[i9 + 72 >> 2] | 0;
   i4 = i9 + 76 | 0;
   i2 = i1;
   while (1) {
    i1 = i3 + (i2 << 3) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) break;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   if (i1 | 0) {
    i11 = HEAP32[i11 >> 2] | 0;
    __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
    STACKTOP = i12;
    return;
   }
  }
 } while (0);
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i3 | 0, i4 | 0, 44, (i2 ? gb + 689117 | 0 : gb + 837976 | 0) | 0, gb + 689263 | 0, 689) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i2 + 24 >> 2] = Math_fround(.75);
 HEAP32[i2 + 28 >> 2] = -1;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj(i2, 64);
 HEAP8[i2 + 40 >> 0] = HEAP8[i5 >> 0] | 0;
 HEAP8[i2 + 41 >> 0] = i6 & 1;
 if (!i2) {
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = i8;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb(i9 + 68 | 0, i10, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP8[i9 + 112 >> 0] = 1;
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
 i11 = HEAP32[i11 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 STACKTOP = i12;
 return;
}

function __ZL21RegisterInterfaceImpl18UnityInterfaceGUIDP15IUnityInterface(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i6 = i14;
 i13 = HEAP32[gb + 1163148 >> 2] | 0;
 i11 = i1;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i13 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i3;
  i4 = i3;
 } else {
  L3 : while (1) {
   i4 = i1 + 16 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   do if (i11 >>> 0 < i4 >>> 0 | (i11 | 0) == (i4 | 0) & i12 >>> 0 < i3 >>> 0) i10 = 5; else {
    i5 = (i12 | 0) == (i3 | 0) & (i11 | 0) == (i4 | 0);
    if (i5) {
     i15 = i1 + 24 | 0;
     i16 = HEAP32[i15 + 4 >> 2] | 0;
     if (i8 >>> 0 < i16 >>> 0 | ((i8 | 0) == (i16 | 0) ? i7 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0 : 0)) {
      i10 = 5;
      break;
     }
    }
    if (!(i4 >>> 0 < i11 >>> 0 | (i4 | 0) == (i11 | 0) & i3 >>> 0 < i12 >>> 0)) {
     if (!i5) {
      i10 = 13;
      break L3;
     }
     i16 = i1 + 24 | 0;
     i15 = HEAP32[i16 + 4 >> 2] | 0;
     if (!(i15 >>> 0 < i8 >>> 0 | ((i15 | 0) == (i8 | 0) ? (HEAP32[i16 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) {
      i10 = 13;
      break L3;
     }
    }
    i3 = i1 + 4 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) {
     i10 = 12;
     break L3;
    } else i1 = i4;
   } while (0);
   if ((i10 | 0) == 5) {
    i10 = 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i10 = 6;
     break;
    } else i1 = i3;
   }
  }
  if ((i10 | 0) == 6) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i10 | 0) == 12) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i10 | 0) == 13) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i3 = i6;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i13 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = 6;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 i16 = i1 + 16 | 0;
 HEAP32[i16 >> 2] = i12;
 HEAP32[i16 + 4 >> 2] = i11;
 i16 = i1 + 24 | 0;
 HEAP32[i16 >> 2] = i7;
 HEAP32[i16 + 4 >> 2] = i8;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i13 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 + 4 >> 2] | 0, i1);
 i16 = i13 + 12 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 STACKTOP = i14;
 return;
}

function __ZN10Matrix3x3fmLERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = i2 + 4 | 0;
 i16 = i2 + 8 | 0;
 i14 = i2 + 12 | 0;
 i13 = i2 + 16 | 0;
 i11 = i2 + 20 | 0;
 i9 = i2 + 24 | 0;
 i7 = i2 + 28 | 0;
 i4 = i2 + 32 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i10 = i1 + 12 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 24 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 i3 = i1 + 4 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i15 = i1 + 28 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i11 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i4 >> 2])));
 i15 = i1 + 8 | 0;
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i1 + 32 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i17 >> 2])));
 HEAPF32[i15 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i16 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i13 >> 2])));
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(f5 * Math_fround(HEAPF32[i11 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2])));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 3:
  {
   HEAP32[i2 >> 2] = 3;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   return;
  }
 case 0:
  {
   i4 = i1;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i2;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
   return;
  }
 case 1:
  {
   HEAP32[i2 >> 2] = 1;
   return;
  }
 case 4:
  {
   HEAP32[i2 >> 2] = 4;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i2 + 32 >> 2] = i4;
   HEAP32[i2 + 36 >> 2] = i4 + 16;
   return;
  }
 case 5:
  {
   HEAP32[i2 >> 2] = 5;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP8[i2 + 32 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
   i4 = i2 + 33 | 0;
   i3 = i1 + 33 | 0;
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i4 + 1 >> 0] = HEAP8[i3 + 1 >> 0] | 0;
   HEAP8[i4 + 2 >> 0] = HEAP8[i3 + 2 >> 0] | 0;
   HEAP8[i4 + 3 >> 0] = HEAP8[i3 + 3 >> 0] | 0;
   HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
   HEAP8[i4 + 5 >> 0] = HEAP8[i3 + 5 >> 0] | 0;
   HEAP8[i4 + 6 >> 0] = HEAP8[i3 + 6 >> 0] | 0;
   i4 = HEAP32[i2 + 36 >> 2] | 0;
   HEAP32[i2 + 40 >> 2] = i4 + 16;
   HEAP32[i2 + 44 >> 2] = HEAP32[i4 + 176 >> 2];
   HEAP32[i2 + 48 >> 2] = 0;
   HEAP16[i2 + 52 >> 1] = 0;
   return;
  }
 case 6:
  {
   HEAP32[i2 >> 2] = 6;
   i3 = i1 + 4 | 0;
   i4 = i2 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP8[i2 + 20 >> 0] = HEAP8[i1 + 20 >> 0] | 0;
   i4 = i2 + 21 | 0;
   i3 = i1 + 21 | 0;
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i4 + 1 >> 0] = HEAP8[i3 + 1 >> 0] | 0;
   HEAP8[i4 + 2 >> 0] = HEAP8[i3 + 2 >> 0] | 0;
   HEAP32[i2 + 24 >> 2] = (HEAP32[i2 + 4 >> 2] | 0) + 16;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP16[i2 + 32 >> 1] = 0;
   return;
  }
 default:
  return;
 }
}

function __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i6 + 100 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN14PhysicMaterial13AwakeFromLoadE17AwakeFromLoadMode(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i8 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i13 = HEAP32[gb + 1457408 >> 2] | 0;
  i2 = i8 + 44 | 0;
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i8 + 40 | 0;
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i8 + 48 | 0;
  f10 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = f10 < Math_fround(0.0);
  i14 = f10 > Math_fround(1.0);
  f10 = i14 ? Math_fround(1.0) : f10;
  i1 = mftCall_iifff(HEAP32[(HEAP32[i13 >> 2] | 0) + 144 >> 2] | 0, i13 | 0, +f12, +f11, +(i1 ? Math_fround(0.0) : f10)) | 0;
  HEAP32[i6 >> 2] = i1;
  if (!i1) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737152 | 0, 0, gb + 737252 | 0, 127, 1, HEAP32[i8 + 4 >> 2] | 0, 0, 0);
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) i9 = 5;
  } else i9 = 5;
 } else {
  i2 = i8 + 44 | 0;
  i3 = i8 + 48 | 0;
  i4 = i8 + 40 | 0;
  i9 = 5;
 }
 if ((i9 | 0) == 5) {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i4 >> 2]));
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 >> 2]));
  f12 = Math_fround(HEAPF32[i3 >> 2]);
  i14 = f12 < Math_fround(0.0);
  i13 = f12 > Math_fround(1.0);
  f12 = i13 ? Math_fround(1.0) : f12;
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i14 ? Math_fround(0.0) : f12));
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i8 + 32 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i8 + 36 >> 2] | 0);
 }
 if ((HEAP32[(__Z21GetManagerFromContexti(9) | 0) + 64 >> 2] | 0) != (i8 | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i5 | 0, 1, 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) i9 = 9;
 } else i9 = 9;
 if ((i9 | 0) == 9) {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i8 + 40 >> 2]));
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i8 + 44 >> 2]));
  f12 = Math_fround(HEAPF32[i8 + 48 >> 2]);
  i14 = f12 < Math_fround(0.0);
  i13 = f12 > Math_fround(1.0);
  f12 = i13 ? Math_fround(1.0) : f12;
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i14 ? Math_fround(0.0) : f12));
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i8 + 32 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i8 + 36 >> 2] | 0);
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx3Scb4Base17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 126116 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 126116 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 126116 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 126116 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 126116 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 126116 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 126116 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 126116 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 126148 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 126148 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 126148 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 126148 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 126148 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 126148 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 126148 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 126148 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 126180 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 126180 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 126180 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 126180 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 126180 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 126180 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 126180 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 126180 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 126212 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 126212 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 126212 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 126212 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 126212 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 126212 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 126212 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 126212 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 126244 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 126244 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 126244 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 126244 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 126244 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 126244 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 126244 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 126244 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj(i2, i3, f4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5 + 72 | 0;
 i18 = i5 + 60 | 0;
 i17 = i5 + 48 | 0;
 i16 = i5 + 36 | 0;
 i15 = i5 + 24 | 0;
 i10 = i5 + 12 | 0;
 i6 = i5;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i14 >> 2] = Math_fround(1.0);
 i3 = i14 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 20 >> 2] = Math_fround(1.0);
 i3 = i14 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 40 >> 2] = Math_fround(1.0);
 i3 = i14 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i14 + 60 >> 2] = Math_fround(1.0);
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f13 = Math_fround(f8 + Math_fround(0.0));
 f12 = Math_fround(f7 + f4);
 f11 = Math_fround(f9 + Math_fround(0.0));
 HEAPF32[i18 >> 2] = f13;
 HEAPF32[i18 + 4 >> 2] = f12;
 HEAPF32[i18 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i18) | 0;
 f12 = Math_fround(f7 - f4);
 HEAPF32[i17 >> 2] = f8;
 HEAPF32[i17 + 4 >> 2] = f12;
 HEAPF32[i17 + 8 >> 2] = f9;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i17) | 0;
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f12 = Math_fround(f7 + Math_fround(0.0));
 HEAPF32[i16 >> 2] = Math_fround(f8 + f4);
 HEAPF32[i16 + 4 >> 2] = f12;
 HEAPF32[i16 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i16) | 0;
 HEAPF32[i15 >> 2] = Math_fround(f8 - f4);
 HEAPF32[i15 + 4 >> 2] = f7;
 HEAPF32[i15 + 8 >> 2] = f9;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i15) | 0;
 i3 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i14) | 0, 1) | 0;
 f11 = Math_fround(f9 + f4);
 HEAPF32[i10 >> 2] = f13;
 HEAPF32[i10 + 4 >> 2] = f12;
 HEAPF32[i10 + 8 >> 2] = f11;
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i10) | 0;
 f4 = Math_fround(f9 - f4);
 HEAPF32[i6 >> 2] = f8;
 HEAPF32[i6 + 4 >> 2] = f7;
 HEAPF32[i6 + 8 >> 2] = f4;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN2UI6Canvas11DrawRawMeshERNS_5BatchEP9GfxBufferS4_(i7, i6, i16, i17) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 8 | 0;
 i2 = i20;
 i19 = __Z12GetGfxDevicev() | 0;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i18, i1, i2);
   i2 = HEAP32[i18 >> 2] | 0;
   i15 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i20;
   return;
  }
 }
 if ((__ZNK8Material12GetPassCountEv(i1) | 0) <= 0) {
  STACKTOP = i20;
  return;
 }
 i15 = i6 + 8 | 0;
 i9 = i6 + 12 | 0;
 i10 = i7 + 248 | 0;
 i11 = i7 + 316 | 0;
 i12 = i7 + 320 | 0;
 i13 = i7 + 324 | 0;
 i14 = i18 + 4 | 0;
 i7 = i7 + 328 | 0;
 i6 = 0;
 do {
  i8 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i1, i6, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
  if (i8 | 0) {
   i3 = HEAP32[i15 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i5 = i3;
    i4 = i3;
    while (1) {
     i3 = HEAP32[i10 >> 2] | 0;
     if (!(HEAP32[i11 >> 2] | 0)) i3 = i4; else if (!(HEAP32[i12 >> 2] | 0)) i3 = i4; else {
      mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 184 >> 2] | 0, i19 | 0, HEAP32[i3 + (i5 * 36 | 0) >> 2] | 0);
      HEAP32[i18 >> 2] = i16;
      HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
      mftCall_viiiiiiii(HEAP32[(HEAP32[i19 >> 2] | 0) + 244 >> 2] | 0, i19 | 0, i17 | 0, i18 | 0, 1, i3 + (i5 * 36 | 0) + 4 | 0, 1, HEAP32[i7 >> 2] | 0, i8 | 0);
      __Z15gpu_time_samplev();
      i2 = HEAP32[i9 >> 2] | 0;
      i3 = HEAP32[i15 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
     if ((i5 | 0) >= (i2 + i3 | 0)) break; else i4 = i3;
    }
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (__ZNK8Material12GetPassCountEv(i1) | 0));
 STACKTOP = i20;
 return;
}

function __Z34CalculateTriangleAreaRadialFrustumP8Vector3fffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, f7 = f0, f8 = f0, d9 = 0.0, f10 = f0, f11 = f0, d12 = 0.0, d13 = 0.0, d14 = 0.0, i15 = 0, i16 = 0, d17 = 0.0, i18 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i6;
 d13 = +Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 d13 = +Math_cos(+d13) / +Math_sin(+d13);
 f8 = Math_fround(f4 - f3);
 d9 = +Math_fround(Math_fround(f3 + f4) / f8);
 d12 = +Math_fround(Math_fround(Math_fround(f3 * Math_fround(2.0)) * f4) / f8);
 d14 = +f5;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f8 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(f8 * f8);
 i18 = i15 + 4 | 0;
 f7 = Math_fround(HEAPF32[i18 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f7 * f7));
 f3 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 d17 = d14 * (d13 * (1.0 / (d12 + d9 * +Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f3 * f3))))))) * .5;
 f8 = Math_fround(+f8 * d17);
 HEAPF32[i15 >> 2] = f8;
 f7 = Math_fround(+f7 * d17);
 HEAPF32[i18 >> 2] = f7;
 i18 = i15 + 12 | 0;
 i16 = i1 + 12 | 0;
 HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 f3 = Math_fround(HEAPF32[i18 >> 2]);
 f11 = Math_fround(f3 * f3);
 i16 = i15 + 16 | 0;
 f4 = Math_fround(HEAPF32[i16 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * f4));
 f2 = Math_fround(HEAPF32[i15 + 20 >> 2]);
 d17 = d14 * (d13 * (1.0 / (d12 + d9 * +Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f2 * f2))))))) * .5;
 f3 = Math_fround(+f3 * d17);
 HEAPF32[i18 >> 2] = f3;
 f4 = Math_fround(+f4 * d17);
 HEAPF32[i16 >> 2] = f4;
 i16 = i15 + 24 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f11 = Math_fround(f2 * f2);
 f5 = Math_fround(HEAPF32[i15 + 28 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f5 * f5));
 f10 = Math_fround(HEAPF32[i15 + 32 >> 2]);
 d9 = d14 * (d13 * (1.0 / (d12 + d9 * +Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f10 * f10))))))) * .5;
 f2 = Math_fround(+f2 * d9);
 f5 = Math_fround(+f5 * d9);
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f8 - f2) * Math_fround(f7 + f5)) + Math_fround(Math_fround(Math_fround(f3 - f8) * Math_fround(f4 + f7)) + Math_fround(Math_fround(f2 - f3) * Math_fround(f4 + f5)))) * Math_fround(.5));
 i1 = f5 < Math_fround(0.0);
 f4 = Math_fround(-f5);
 STACKTOP = i6;
 return Math_fround(i1 ? f4 : f5);
}

function __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i7, i8, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i11 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = ((i1 - i4 | 0) >>> 0) / (i6 >>> 0) | 0;
 i9 = i7 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = i5;
 if (i10 >>> 0 > ((i3 - i5 | 0) / 12 | 0) >>> 0) {
  i4 = i5;
  if (!i5) i1 = i3; else {
   i1 = i7 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -12 - i5 | 0) >>> 0) / 12 | 0) * 12 | 0);
   __ZdlPv(i4);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = 0;
  }
  if (i10 >>> 0 > 357913941) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  i6 = (i1 - i2 | 0) / 12 | 0;
  i2 = i6 << 1;
  i2 = i6 >>> 0 < 178956970 ? (i2 >>> 0 < i10 >>> 0 ? i10 : i2) : 357913941;
  if (i2 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = __Znwj(i2 * 12 | 0) | 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i9 >> 2] = i1 + (i2 * 12 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) return;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i2 = i2 + i4 | 0;
   i1 = i1 + 12 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i5 >> 2] = i1;
  return;
 }
 i9 = i7 + 4 | 0;
 i5 = ((HEAP32[i9 >> 2] | 0) - i5 | 0) / 12 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 if (i10 >>> 0 > i5 >>> 0) {
  i1 = i4;
  i7 = 1;
  i3 = i1;
  i1 = i1 + (Math_imul(i8, i5) | 0) | 0;
  i6 = i8;
 } else {
  i7 = 0;
  i3 = i4;
 }
 if ((i3 | 0) != (i1 | 0)) while (1) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = i4 + i8 | 0;
  i2 = i2 + 12 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i4 = i3;
 }
 if (!i7) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
  HEAP32[i9 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  return;
 }
 i3 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 i2 = HEAP32[i9 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i1 = i1 + i6 | 0;
  i2 = i2 + 12 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 return;
}

function __ZNSt3__218__insertion_sort_3IRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i6 + 16 | 0;
 i2 = i6 + 8 | 0;
 i4 = mftCall_iii(HEAP32[i8 >> 2] | 0, i2 | 0, i6 | 0) | 0;
 i5 = mftCall_iii(HEAP32[i8 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 do if (i4) {
  i4 = i6;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (i5) {
   i11 = i1;
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   i5 = i6;
   HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i5 + 4 >> 2] = i2;
   i5 = i1;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i5 + 4 >> 2] = i4;
   break;
  }
  i12 = i2;
  i5 = HEAP32[i12 + 4 >> 2] | 0;
  i11 = i6;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i11 + 4 >> 2] = i5;
  i11 = i2;
  HEAP32[i11 >> 2] = i3;
  HEAP32[i11 + 4 >> 2] = i4;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i1 | 0, i2 | 0) | 0) {
   i11 = i2;
   i5 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i1;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i12 + 4 >> 2] = i4;
   i12 = i1;
   HEAP32[i12 >> 2] = i5;
   HEAP32[i12 + 4 >> 2] = i11;
  }
 } else if (i5) {
  i11 = i2;
  i5 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i3 = i1;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i12 = i2;
  HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i12 + 4 >> 2] = i4;
  i12 = i1;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i12 + 4 >> 2] = i11;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i2 | 0, i6 | 0) | 0) {
   i11 = i6;
   i5 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i2;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i12 = i6;
   HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i12 + 4 >> 2] = i4;
   i12 = i2;
   HEAP32[i12 >> 2] = i5;
   HEAP32[i12 + 4 >> 2] = i11;
  }
 } while (0);
 i2 = i6 + 24 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i10;
  return;
 }
 while (1) {
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i2 | 0, i1 | 0) | 0) {
   i11 = i2;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i9;
   HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i3 + 4 >> 2] = i12;
   i3 = i2;
   while (1) {
    i5 = i1;
    i11 = HEAP32[i5 + 4 >> 2] | 0;
    i12 = i3;
    HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i12 + 4 >> 2] = i11;
    if ((i1 | 0) == (i6 | 0)) break;
    i3 = i1 + -8 | 0;
    if (mftCall_iii(HEAP32[i8 >> 2] | 0, i9 | 0, i3 | 0) | 0) {
     i12 = i1;
     i1 = i3;
     i3 = i12;
    } else break;
   }
   i5 = i9;
   i11 = HEAP32[i5 + 4 >> 2] | 0;
   i12 = i1;
   HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
  }
  i1 = i2 + 8 | 0;
  if ((i1 | 0) == (i7 | 0)) break; else {
   i12 = i2;
   i2 = i1;
   i1 = i12;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i6 = i11 + 8 | 0;
 HEAP8[i6 >> 0] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i7;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE14handleAccessorILj536ENS_22PxRepXPropertyAccessorILj536ES4_KffEEEEvRKT0_(i8, i6);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
  HEAP32[i1 + 8 >> 2] = i2 + -1;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i8, i9 + 1 | 0, i10 + 16 | 0, gb + 166696 | 0, i7);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i8, i9 + 2 | 0, i10 + 32 | 0, gb + 166696 | 0, i7);
 STACKTOP = i11;
 return i9 + 3 | 0;
}

function __ZN19SkinnedMeshRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i7 = i4;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 2, i5, i3);
 HEAP32[i1 >> 2] = gb + 58672 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 58672 + 196;
 i3 = i1 + 340 | 0;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 364 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP32[i1 + 384 >> 2] = 0;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP32[i1 + 400 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 388 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i1 + 408 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP32[i1 + 432 >> 2] = 0;
 i3 = i1 + 420 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i2);
 i7 = i5;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 416 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(0, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
 i3 = i1 + 436 | 0;
 i2 = i1 + 448 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 476 >> 2] = 0;
 HEAP32[i1 + 488 >> 2] = 0;
 HEAP32[i1 + 492 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 480 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 508 >> 2] = 0;
 HEAP32[i1 + 512 >> 2] = 0;
 HEAP32[i1 + 516 >> 2] = 0;
 HEAP32[i1 + 520 >> 2] = i1;
 HEAP32[i1 + 524 >> 2] = 0;
 HEAP32[i1 + 528 >> 2] = 0;
 HEAP32[i1 + 532 >> 2] = i1;
 HEAP8[i1 + 467 >> 0] = 0;
 HEAP8[i1 + 500 >> 0] = 0;
 HEAP8[i1 + 465 >> 0] = 1;
 HEAP8[i1 + 466 >> 0] = 1;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 496 >> 2] = 0;
 HEAP32[i1 + 504 >> 2] = 0;
 HEAP32[i1 + 468 >> 2] = 0;
 HEAP32[i1 + 472 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN11AudioSource13UpdateDopplerE12SoundChannelfR8Vector3fS2_(i3, i17, f1, i15, i4) {
 i3 = i3 | 0;
 i17 = i17 | 0;
 f1 = Math_fround(f1);
 i15 = i15 | 0;
 i4 = i4 | 0;
 var f2 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f16 = f0, i18 = 0;
 f2 = Math_fround(HEAPF32[i3 + 400 >> 2]);
 if (f2 > Math_fround(0.0) ? (HEAP32[i3 + 104 >> 2] | 0) != 1 : 0) f1 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i3 + 36 | 0, Math_fround(f1 / f2), 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i3 + 92 >> 2] | 0) + 4 >> 2]);
 i6 = f1 < Math_fround(0.0);
 i18 = f1 > Math_fround(1.0);
 f16 = i18 ? Math_fround(1.0) : f1;
 f16 = i6 ? Math_fround(0.0) : f16;
 i6 = __ZNK12AudioManager16GetAudioListenerEv(__Z15GetAudioManagerv() | 0) | 0;
 if (!i6) {
  f16 = Math_fround(1.0);
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + 16 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i17 = i18 + 228 | 0;
  HEAPF32[i17 >> 2] = f16;
  __ZN20SoundChannelInstance11UpdatePitchEv(i18);
  return;
 }
 i3 = i3 + 392 | 0;
 if (!(f16 > Math_fround(0.0) ? Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0) : 0)) {
  f16 = Math_fround(1.0);
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = i18 + 16 | 0;
  i18 = HEAP32[i18 >> 2] | 0;
  i17 = i18 + 228 | 0;
  HEAPF32[i17 >> 2] = f16;
  __ZN20SoundChannelInstance11UpdatePitchEv(i18);
  return;
 }
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 56 >> 2]);
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i6 + 36 >> 2]));
 f10 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i6 + 40 >> 2]));
 f2 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i6 + 44 >> 2]));
 f5 = Math_fround(HEAPF32[(__Z15GetAudioManagerv() | 0) + 76 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f2 * f2))));
 if (f1 > Math_fround(0.0)) f1 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f11 - f12) * f9) + Math_fround(Math_fround(f13 - f14) * f10)) + Math_fround(Math_fround(f7 - f8) * f2)) / f1); else f1 = Math_fround(0.0);
 f14 = Math_fround(Math_fround(Math_fround(340.0) - Math_fround(f5 * f1)) / Math_fround(340.0));
 i18 = f14 < Math_fround(9.99999997e-07);
 f16 = Math_fround(Math_fround(Math_fround(1.0) - f16) + Math_fround(f16 * (i18 ? Math_fround(9.99999997e-07) : f14)));
 i18 = HEAP32[i17 >> 2] | 0;
 i18 = i18 + 16 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i17 = i18 + 228 | 0;
 HEAPF32[i17 >> 2] = f16;
 __ZN20SoundChannelInstance11UpdatePitchEv(i18);
 return;
}

function __ZN5physx3Ext20ProfileZoneInterface19getProfileEventNameEy(i7, i9, i10) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16 | 0;
 i6 = i12;
 i5 = i12 + 8 | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = _i64Add(-1, ~i9 | 0, i9 | 0, i10 | 0) | 0;
  i3 = getTempRet0() | 0;
  i2 = _bitshift64Lshr(i4 | 0, i3 | 0, 22) | 0;
  i4 = i2 ^ i4;
  i3 = (getTempRet0() | 0) ^ i3;
  i2 = _bitshift64Shl(i4 | 0, i3 | 0, 13) | 0;
  i2 = _i64Add(i4 | 0, i3 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i3 = getTempRet0() | 0;
  i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 8) | 0;
  i3 = ___muldi3(i4 ^ i2 | 0, (getTempRet0() | 0) ^ i3 | 0, 9, 0) | 0;
  i2 = getTempRet0() | 0;
  i4 = _bitshift64Lshr(i3 | 0, i2 | 0, 15) | 0;
  i3 = i4 ^ i3;
  i2 = (getTempRet0() | 0) ^ i2;
  i4 = _bitshift64Shl(i3 | 0, i2 | 0, 27) | 0;
  i4 = _i64Add(i3 | 0, i2 | 0, ~i4 | 0, ~(getTempRet0() | 0) | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = _bitshift64Lshr(i4 | 0, i2 | 0, 31) | 0;
  (getTempRet0() | 0) ^ i2;
  i1 = HEAP32[(HEAP32[i7 + 20 >> 2] | 0) + ((i1 + -1 & (i3 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i7 + 12 >> 2] | 0;
   i3 = i7 + 16 | 0;
   while (1) {
    i2 = i4 + (i1 << 4) | 0;
    i13 = i2;
    if ((HEAP32[i13 >> 2] | 0) == (i9 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i10 | 0) : 0) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i13 = HEAP32[i4 + (i1 << 4) + 8 >> 2] | 0;
    STACKTOP = i12;
    return i13 | 0;
   }
  }
 } while (0);
 i2 = (HEAP32[i7 + 4 >> 2] | 0) + 4 | 0;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i5 | 0, i2 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  i13 = gb + 660663 | 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 i5 = i5 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (0 == (i10 | 0) ? (HEAPU16[i3 + (i1 << 3) + 4 >> 1] | 0) == (i9 | 0) : 0) {
   i4 = i1;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = gb + 660663 | 0;
   i8 = 16;
   break;
  }
 }
 if ((i8 | 0) == 16) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i2 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i7 + 8 | 0, i6, i11) | 0;
 if (!(HEAP8[i11 >> 0] | 0)) {
  i13 = i1;
  HEAP32[i13 >> 2] = i9;
  HEAP32[i13 + 4 >> 2] = i10;
  i1 = i1 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
 } else i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = i2;
 i13 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) >> 2] | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN5physx24getBinaryMetaData_PxBaseERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 121380 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 121380 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 121380 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 121380 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 121380 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 121380 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 121380 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 121380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 121412 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 121412 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 121412 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 121412 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 121412 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 121412 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 121412 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 121412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 121444 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 121444 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 121444 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 121444 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 121444 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 121444 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 121444 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 121444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 121476 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 121476 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 121476 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 121476 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 121476 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 121476 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 121476 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 121476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121508 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121508 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121508 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121508 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121508 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121508 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121508 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121508 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx18PxsDynamicsContext23atomIntegrationParallelEfPKPNS_11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPSA_RjSI_RNS_10PxBaseTaskE(i19, f9, i7, i15, i8, i6, i17, i16, i14, i12, i13, i18) {
 i19 = i19 | 0;
 f9 = Math_fround(f9);
 i7 = i7 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i11 = i8 + 255 | 0;
 i1 = i11 >>> 8;
 if (i11 >>> 0 <= 511) {
  __Z15atomIntegrationfPKPN5physx11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPS9_RjSH_(Math_fround(HEAPF32[i19 + 124 >> 2]), i7, i15, i8, i6, i17, i16, 0, i12, i13);
  return;
 }
 if (!i1) return;
 i3 = i19 + 96 | 0;
 i10 = 0;
 i11 = ~i1;
 while (1) {
  i4 = i11 >>> 0 > 4294967231 ? ~i11 : 64;
  i5 = i1 - i10 | 0;
  i5 = i5 >>> 0 < 64 ? i5 : 64;
  i20 = HEAP32[(HEAP32[i3 >> 2] | 0) + 6960 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i20 >> 2] | 0);
  i2 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i20, i5 * 72 | 0, 16) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i20 >> 2] | 0);
  if (i5 | 0) {
   i5 = 0;
   do {
    i25 = i5 + i10 << 8;
    i20 = i2 + (i5 * 72 | 0) | 0;
    i24 = i8 - i25 | 0;
    HEAP16[i2 + (i5 * 72 | 0) + 4 >> 1] = -1;
    HEAP16[i2 + (i5 * 72 | 0) + 6 >> 1] = 0;
    i21 = i2 + (i5 * 72 | 0) + 8 | 0;
    HEAP32[i21 >> 2] = 0;
    HEAP32[i20 >> 2] = gb + 87404 + 8;
    i22 = i2 + (i5 * 72 | 0) + 12 | 0;
    HEAP32[i22 >> 2] = 0;
    i23 = i2 + (i5 * 72 | 0) + 16 | 0;
    HEAP32[i23 >> 2] = 0;
    HEAP32[i20 >> 2] = gb + 106400 + 8;
    HEAP32[i2 + (i5 * 72 | 0) + 20 >> 2] = i19;
    HEAP32[i2 + (i5 * 72 | 0) + 24 >> 2] = i7;
    HEAP32[i2 + (i5 * 72 | 0) + 28 >> 2] = i15;
    HEAP32[i2 + (i5 * 72 | 0) + 32 >> 2] = i17;
    HEAP32[i2 + (i5 * 72 | 0) + 36 >> 2] = i16;
    HEAP32[i2 + (i5 * 72 | 0) + 40 >> 2] = i14;
    HEAP32[i2 + (i5 * 72 | 0) + 44 >> 2] = i6;
    HEAPF32[i2 + (i5 * 72 | 0) + 48 >> 2] = f9;
    HEAP32[i2 + (i5 * 72 | 0) + 52 >> 2] = i8;
    HEAP32[i2 + (i5 * 72 | 0) + 56 >> 2] = i12;
    HEAP32[i2 + (i5 * 72 | 0) + 60 >> 2] = i13;
    HEAP32[i2 + (i5 * 72 | 0) + 64 >> 2] = i25;
    HEAP32[i2 + (i5 * 72 | 0) + 68 >> 2] = i24 >>> 0 < 256 ? i24 : 256;
    HEAP32[i23 >> 2] = 1;
    HEAP32[i22 >> 2] = i18;
    mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
    HEAP32[i21 >> 2] = HEAP32[(HEAP32[i22 >> 2] | 0) + 8 >> 2];
    mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 20 >> 2] | 0, i20 | 0);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i4 | 0));
  }
  i10 = i10 + 64 | 0;
  if (i1 >>> 0 <= i10 >>> 0) break; else i11 = i11 + 64 | 0;
 }
 return;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags(i17, i18, i1) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 12 | 0;
 i14 = i16 + 8 | 0;
 i15 = i16;
 i1 = i17 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i17 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i14, 4); else {
  HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i15 >> 2] = -1;
 i8 = i15 + 4 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 i9 = i18 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i18, HEAP32[i9 >> 2] | 0);
 i10 = i18 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i18 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 if ((HEAP32[i14 >> 2] | 0) <= 0) {
  STACKTOP = i16;
  return;
 }
 i11 = i9;
 i12 = i18 + 4 | 0;
 i7 = 0;
 do {
  __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i15, i17);
  i5 = HEAP32[i15 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  do if (!i1) {
   HEAP32[i13 >> 2] = i9;
   i4 = i11;
   i3 = i9;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i5 | 0) < (i2 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = 15;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 10) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 15) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i13;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(24) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i6;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i18 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i18 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i1);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (HEAP32[i14 >> 2] | 0));
 STACKTOP = i16;
 return;
}

function __ZN16PlayerConnection14PollListenModeEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = i7 + 24 | 0;
 i1 = i7 + 20 | 0;
 i3 = i7 + 8 | 0;
 if (!(HEAP8[i6 + 141 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i6 + 96 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i8 = i6 + 400 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  d10 = +_emscripten_get_now() * 1.0e6;
  i8 = _i64Subtract(~~d10 >>> 0 | 0, (+Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i9 | 0, i8 | 0) | 0;
  i8 = __Z17TimeToNanosecondsy(i8, getTempRet0() | 0) | 0;
  i9 = getTempRet0() | 0;
  if (!(i9 >>> 0 > 0 | (i9 | 0) == 0 & i8 >>> 0 > 1e9)) {
   STACKTOP = i7;
   return;
  }
 }
 HEAP32[i1 >> 2] = 16;
 if (HEAP8[i6 + 209 >> 0] | 0) {
  i1 = __ZN12ServerSocket6AcceptEP8sockaddrPj(i6 + 192 | 0, i2, i1) | 0;
  if ((i1 | 0) != -1) {
   __Z10InAddrToIPP11sockaddr_in(i3, i2);
   HEAP32[i5 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
   HEAP32[i5 + 4 >> 2] = i1;
   _printf_console(gb + 460332 | 0, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   HEAP32[gb + 1163124 >> 2] = (HEAP32[gb + 1163124 >> 2] | 0) + 1;
   __ZN17GeneralConnection18RegisterConnectionEji(i6, HEAP32[gb + 1163124 >> 2] | 0, i1);
  }
 }
 do if (!(HEAP32[i4 >> 2] | 0)) {
  if (!(HEAP8[gb + 1546600 >> 0] | 0)) if (!(HEAP8[i6 + 148 >> 0] | 0)) {
   i2 = 0;
   i3 = 1e9;
   break;
  }
  i2 = 0;
  i3 = 1e7;
 } else {
  i2 = 0;
  i3 = 1e9;
 } while (0);
 i1 = i6 + 400 | 0;
 i9 = i1;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 d10 = +_emscripten_get_now() * 1.0e6;
 i9 = _i64Subtract(~~d10 >>> 0 | 0, (+Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i8 | 0, i9 | 0) | 0;
 i9 = __Z17TimeToNanosecondsy(i9, getTempRet0() | 0) | 0;
 i8 = getTempRet0() | 0;
 if (i8 >>> 0 > i2 >>> 0 | (i8 | 0) == (i2 | 0) & i9 >>> 0 > i3 >>> 0) {
  d10 = +_emscripten_get_now() * 1.0e6;
  i9 = +Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i2 = i1;
  HEAP32[i2 >> 2] = ~~d10 >>> 0;
  HEAP32[i2 + 4 >> 2] = i9;
  i2 = i6 + 180 | 0;
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i6 + 184 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } else {
   i3 = i1 & 255;
   i1 = i2;
  }
  __ZN15MulticastSocket4SendEPKvj(i6 + 16 | 0, i1, i3 + 1 | 0) | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZN13AnimationClip9PPtrCurve8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i2 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 899332 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 16 | 0;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898367 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i2, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898362 | 0, i3, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i6, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898384 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898377 | 0, gb + 899338 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i8, i9);
 i5 = i8 + 40 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i5 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i9, i8 + 52 | 0, gb + 899134 | 0, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i5 = i1 >>> 0 > 4 ? 4 : i1;
 i2 = i8 + 68 + (i5 << 6) | 0;
 if (i5 | 0) {
  i1 = i8 + 68 | 0;
  do {
   __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 324 | 0, i9);
 __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 460 | 0, i9);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i10, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 if (!i1) {
  i7 = i8 + 804 | 0;
  HEAP32[i10 >> 2] = 7;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = i7;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags(i9, i10, 0);
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i8 + 596 | 0, i1 << 2);
 i7 = i8 + 804 | 0;
 HEAP32[i10 >> 2] = 7;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags(i9, i10, 0);
 STACKTOP = i11;
 return;
}

function __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i8, i4, i9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = i4;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 i7 = i8 + 12 | 0;
 i2 = i8 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = 12;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = 5;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i3 = 11;
     break;
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = 9;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 5) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   i3 = 12;
   break;
  } else if ((i3 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = 12;
   break;
  } else if ((i3 | 0) == 11) {
   HEAP32[i5 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i2 = i5;
    i3 = 12;
    break;
   } else {
    i7 = i1;
    break;
   }
  }
 } while (0);
 if ((i3 | 0) == 12) {
  i3 = __Znwj(32) | 0;
  HEAP32[i3 + 16 >> 2] = i6;
  i1 = i3 + 24 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = i4;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (!i1) i1 = i3; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 16 >> 2] | 0, i1);
  i7 = i8 + 20 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  i7 = i3;
 }
 i5 = i7 + 20 | 0;
 i4 = i7 + 24 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 } else {
  i3 = i4;
  i2 = i6;
 }
 L25 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L25;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 > i9 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) HEAP32[i5 >> 2] = i1;
 i9 = i7 + 28 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i3);
 __ZdlPv(i3);
 STACKTOP = i10;
 return;
}

function __Z17HumanBoneFromMonoRK13MonoHumanBoneR9HumanBone(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __Z24scripting_cpp_string_forP12Il2CppString(i10, HEAP32[i8 >> 2] | 0);
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i5 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 i5 = i9 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i4 >>> 0 > i3 >>> 0) {
  i7 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i4 - i3 | 0, i7, 0, i7, i4, i6);
 } else {
  i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i4;
   break;
  } else {
   HEAP8[i5 >> 0] = i4;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = i9 + 16 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i10, HEAP32[i8 + 4 >> 2] | 0);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 i7 = i1 + 11 | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  i7 = i3 ? HEAP32[i9 + 20 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i9 + 20 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i7 = i8 + 8 | 0;
 i10 = i9 + 32 | 0;
 HEAP8[i9 + 72 >> 0] = (HEAP32[i8 + 48 >> 2] | 0) != 1 & 1;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i10 = i9 + 44 | 0;
 i7 = i8 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i10 = i9 + 56 | 0;
 i7 = i8 + 32 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 68 >> 2] = HEAP32[i8 + 44 >> 2];
 STACKTOP = i11;
 return;
}

function _unity_z_inflateSync(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 if (!i10) {
  i11 = -2;
  STACKTOP = i12;
  return i11 | 0;
 }
 i11 = HEAP32[i10 + 28 >> 2] | 0;
 if (!i11) {
  i11 = -2;
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = i10 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) if ((HEAP32[i11 + 60 >> 2] | 0) >>> 0 < 8) {
  i11 = -5;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((HEAP32[i11 >> 2] | 0) == 29) {
  i3 = i11 + 104 | 0;
  i1 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 } else {
  HEAP32[i11 >> 2] = 29;
  i3 = i11 + 60 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i4 = i11 + 56 | 0;
  i1 = HEAP32[i4 >> 2] << (i5 & 7);
  HEAP32[i4 >> 2] = i1;
  i5 = i5 & -8;
  HEAP32[i3 >> 2] = i5;
  if (i5 >>> 0 > 7) {
   i6 = 7 - i5 | 0;
   i6 = (i5 + (i6 >>> 0 > 4294967288 ? i6 : -8) | 0) >>> 3;
   i7 = i6 + 1 | 0;
   i6 = i6 << 3;
   i2 = 0;
   do {
    HEAP8[i8 + i2 >> 0] = i1;
    i2 = i2 + 1 | 0;
    i1 = i1 >>> 8;
   } while ((i2 | 0) != (i7 | 0));
   HEAP32[i4 >> 2] = i1;
   HEAP32[i3 >> 2] = i5 + -8 - i6;
   i1 = i11 + 104 | 0;
   HEAP32[i1 >> 2] = 0;
   i3 = 0;
   i4 = 0;
   do {
    i2 = HEAP8[i8 + i4 >> 0] | 0;
    if ((i2 & 255 | 0) == ((i3 >>> 0 < 2 ? 0 : 255) | 0)) i3 = i3 + 1 | 0; else i3 = i2 << 24 >> 24 == 0 ? 4 - i3 | 0 : 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i7 >>> 0 & i3 >>> 0 < 4);
  } else {
   i1 = i11 + 104 | 0;
   HEAP32[i1 >> 2] = 0;
   i3 = 0;
  }
  HEAP32[i1 >> 2] = i3;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i6 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != 0 & i3 >>> 0 < 4) {
  i5 = 0;
  while (1) {
   i4 = HEAP8[i6 + i5 >> 0] | 0;
   if ((i4 & 255 | 0) == ((i3 >>> 0 < 2 ? 0 : 255) | 0)) i3 = i3 + 1 | 0; else i3 = i4 << 24 >> 24 == 0 ? 4 - i3 | 0 : 0;
   i4 = i5 + 1 | 0;
   if (i4 >>> 0 < i2 >>> 0 & i3 >>> 0 < 4) i5 = i4; else break;
  }
 } else i4 = 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i4;
 HEAP32[i10 >> 2] = i6 + i4;
 i2 = i10 + 8 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + i4 | 0;
 HEAP32[i2 >> 2] = i1;
 if ((i3 | 0) != 4) {
  i11 = -3;
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = i10 + 20 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 + 28 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 48 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 32768;
 HEAP32[i11 + 32 >> 2] = 0;
 HEAP32[i11 + 40 >> 2] = 0;
 HEAP32[i11 + 44 >> 2] = 0;
 HEAP32[i11 + 48 >> 2] = 0;
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 60 >> 2] = 0;
 i10 = i11 + 1328 | 0;
 HEAP32[i11 + 108 >> 2] = i10;
 HEAP32[i11 + 80 >> 2] = i10;
 HEAP32[i11 + 76 >> 2] = i10;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i11 >> 2] = 11;
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb(i8, i12, i13, i1, i14, i15, i9) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i16 = 0, f17 = f0, f18 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16;
 HEAP8[i9 >> 0] = 1;
 f18 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f18 = Math_fround(Math_fround(f18 + Math_fround(HEAPF32[i1 >> 2])) * Math_fround(.5));
 f17 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f17 = Math_fround(Math_fround(f17 + Math_fround(HEAPF32[i1 + 4 >> 2])) * Math_fround(.5));
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i1 + 8 >> 2])) * Math_fround(.5));
 HEAPF32[i7 >> 2] = f18;
 HEAPF32[i7 + 4 >> 2] = f17;
 HEAPF32[i7 + 8 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i7 + (i14 << 2) >> 2]);
 HEAPF32[i15 >> 2] = f5;
 i7 = (i13 | 0) > 0;
 if (!i7) {
  HEAP8[i9 >> 0] = 0;
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i6 = HEAP32[i8 + 56 >> 2] | 0;
 i4 = 0;
 i2 = 0;
 i3 = 0;
 while (1) {
  i1 = HEAP32[i6 + (HEAP32[i12 + (i4 << 2) >> 2] << 2) >> 2] | 0;
  if (!(Math_fround(HEAPF32[i1 + 32 + (i14 << 2) >> 2]) <= f5)) {
   if (!(Math_fround(HEAPF32[i1 + 20 + (i14 << 2) >> 2]) >= f5)) {
    i11 = 10;
    break;
   }
   i2 = i2 + 1 | 0;
  } else i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (i13 | 0)) {
   i11 = 9;
   break;
  }
 }
 if ((i11 | 0) == 9) if (!((i3 | 0) != 0 & (i2 | 0) != 0)) i11 = 10;
 if ((i11 | 0) == 10) {
  HEAP8[i9 >> 0] = 0;
  if (!i7) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
  i10 = HEAP32[i8 + 56 >> 2] | 0;
  i2 = 0;
  i9 = 0;
  i1 = 2147483647;
  do {
   f5 = Math_fround(HEAPF32[(HEAP32[i10 + (HEAP32[i12 + (i9 << 2) >> 2] << 2) >> 2] | 0) + 32 + (i14 << 2) >> 2]);
   i6 = 0;
   i8 = 0;
   i4 = 0;
   i7 = 0;
   while (1) {
    i3 = HEAP32[i10 + (HEAP32[i12 + (i8 << 2) >> 2] << 2) >> 2] | 0;
    if (!(Math_fround(HEAPF32[i3 + 32 + (i14 << 2) >> 2]) <= f5)) {
     if (!(Math_fround(HEAPF32[i3 + 20 + (i14 << 2) >> 2]) >= f5)) break;
     i4 = i4 + 1 | 0;
     i3 = i7;
    } else {
     i3 = i7 + 1 | 0;
     i6 = i3;
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) >= (i13 | 0)) {
     i11 = 18;
     break;
    } else i7 = i3;
   }
   if ((i11 | 0) == 18) {
    i11 = 0;
    if ((i3 | 0) != 0 & (i4 | 0) != 0) {
     i3 = i6 - i13 + i6 | 0;
     i3 = (i3 | 0) < 0 ? 0 - i3 | 0 : i3;
     if ((i6 | 0) > 0 & (i6 | 0) < (i13 | 0) & (i3 | 0) < (i1 | 0)) {
      HEAPF32[i15 >> 2] = f5;
      i2 = 1;
      i1 = i3;
     }
    }
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i13 | 0));
  if (!i2) {
   i15 = 0;
   STACKTOP = i16;
   return i15 | 0;
  }
 }
 i15 = 1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN10GUITexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944580 | 0, gb + 944590 | 0, i5, 0);
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 385675 | 0, HEAP32[gb + 37212 >> 2] | 0, i7, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 385688 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 385701 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 385715 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 385727 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL26GeomOverlapCallback_BoxBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 36 | 0;
 i6 = i1;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f17 = Math_fround(f9 + f9);
 f13 = Math_fround(f11 + f11);
 f14 = Math_fround(f10 + f10);
 f9 = Math_fround(f9 * f17);
 f12 = Math_fround(f11 * f13);
 f8 = Math_fround(f10 * f14);
 f11 = Math_fround(f17 * f11);
 f16 = Math_fround(f17 * f10);
 f17 = Math_fround(f17 * f15);
 f10 = Math_fround(f13 * f10);
 f13 = Math_fround(f13 * f15);
 f15 = Math_fround(f14 * f15);
 f14 = Math_fround(f11 + f15);
 f18 = Math_fround(f16 - f13);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f12) - f8);
 HEAPF32[i7 + 4 >> 2] = f14;
 HEAPF32[i7 + 8 >> 2] = f18;
 f9 = Math_fround(Math_fround(1.0) - f9);
 f8 = Math_fround(f9 - f8);
 f18 = Math_fround(f10 + f17);
 HEAPF32[i7 + 12 >> 2] = Math_fround(f11 - f15);
 HEAPF32[i7 + 16 >> 2] = f8;
 HEAPF32[i7 + 20 >> 2] = f18;
 f17 = Math_fround(f10 - f17);
 f12 = Math_fround(f9 - f12);
 HEAPF32[i7 + 24 >> 2] = Math_fround(f16 + f13);
 HEAPF32[i7 + 28 >> 2] = f17;
 HEAPF32[i7 + 32 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(f12 + f12);
 f10 = Math_fround(f17 + f17);
 f18 = Math_fround(f13 + f13);
 f12 = Math_fround(f12 * f9);
 f8 = Math_fround(f17 * f10);
 f15 = Math_fround(f13 * f18);
 f17 = Math_fround(f9 * f17);
 f11 = Math_fround(f9 * f13);
 f9 = Math_fround(f9 * f16);
 f13 = Math_fround(f10 * f13);
 f10 = Math_fround(f10 * f16);
 f16 = Math_fround(f18 * f16);
 f18 = Math_fround(f17 + f16);
 f14 = Math_fround(f11 - f10);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f8) - f15);
 HEAPF32[i6 + 4 >> 2] = f18;
 HEAPF32[i6 + 8 >> 2] = f14;
 f12 = Math_fround(Math_fround(1.0) - f12);
 f15 = Math_fround(f12 - f15);
 f14 = Math_fround(f13 + f9);
 HEAPF32[i6 + 12 >> 2] = Math_fround(f17 - f16);
 HEAPF32[i6 + 16 >> 2] = f15;
 HEAPF32[i6 + 20 >> 2] = f14;
 f9 = Math_fround(f13 - f9);
 f8 = Math_fround(f12 - f8);
 HEAPF32[i6 + 24 >> 2] = Math_fround(f11 + f10);
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f8;
 i5 = __ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b(i2 + 4 | 0, i4 + 16 | 0, i7, i3 + 4 | 0, i5 + 16 | 0, i6, 1) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function _TT_Hint_Glyph(i12, i6) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i12 + 124 | 0;
 i8 = HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + 140 >> 2] | 0;
 i3 = (i8 | 0) > 0;
 if (i3) _memcpy(HEAP32[i12 + 136 >> 2] | 0, HEAP32[i12 + 140 >> 2] | 0, HEAPU16[i12 + 132 >> 1] << 3 | 0) | 0;
 i10 = i12 + 160 | 0;
 i1 = i12 + 4 | 0;
 i2 = (HEAP32[i10 >> 2] | 0) + 284 | 0;
 i4 = (HEAP32[i1 >> 2] | 0) + 172 | 0;
 i5 = i2 + 68 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i2 = i2 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i2 | 0) < (i5 | 0));
 if (!(i6 << 24 >> 24)) {
  i9 = HEAP32[i1 >> 2] | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 + 220 >> 2] = HEAP32[i9 + 48 >> 2];
  HEAP32[i11 + 224 >> 2] = HEAP32[i9 + 52 >> 2];
  i11 = i12 + 140 | 0;
  i9 = i12 + 132 | 0;
 } else {
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 + 220 >> 2] = 65536;
  HEAP32[i11 + 224 >> 2] = 65536;
  i11 = i12 + 140 | 0;
  i9 = i12 + 132 | 0;
  _memcpy(HEAP32[i12 + 144 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAPU16[i9 >> 1] << 3 | 0) | 0;
 }
 i2 = HEAP16[i9 >> 1] | 0;
 i5 = i2 & 65535;
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = i1 + (i5 + -4 << 3) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 32 & -64;
 i4 = i1 + (i5 + -3 << 3) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 32 & -64;
 i4 = i1 + (i5 + -2 << 3) + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 32 & -64;
 i5 = i1 + (i5 + -1 << 3) + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 32 & -64;
 if (i3) {
  i3 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + 64 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  _UNITY_TT_Set_CodeRange(i2, 3, HEAP32[i2 + 392 >> 2] | 0, i8);
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP8[i2 + 560 >> 0] = i6;
  i2 = i2 + 144 | 0;
  i4 = i7;
  i5 = i2 + 36 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = _UNITY_TT_Run_Context(HEAP32[i10 >> 2] | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if (i2 | 0) if (HEAP8[i1 + 561 >> 0] | 0) {
   i12 = i2;
   return i12 | 0;
  }
  HEAP8[i3 >> 0] = HEAP32[i1 + 340 >> 2] << 5 | HEAPU8[i3 >> 0] | 4;
  i2 = HEAP16[i9 >> 1] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i10 = i2 & 65535;
 i8 = i1 + (i10 + -4 << 3) | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i12 + 68 | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 i11 = i1 + (i10 + -3 << 3) | 0;
 i9 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i12 + 76 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i1 + (i10 + -2 << 3) | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i12 + 184 | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 i10 = i1 + (i10 + -1 << 3) | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i12 + 192 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = 0;
 return i12 | 0;
}

function __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = (i4 - i5 | 0) / 24 | 0;
 i6 = i11 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i1 = i5;
 i8 = i10;
 i12 = i4;
 if (i9 >>> 0 > ((i2 - i10 | 0) / 24 | 0) >>> 0) {
  i4 = i10;
  if (i10) {
   i2 = i11 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i8 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i10 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i4);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
  }
  if (i9 >>> 0 > 178956970) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  } else i3 = 0;
  i10 = (i2 - i3 | 0) / 24 | 0;
  i3 = i10 << 1;
  i3 = i10 >>> 0 < 89478485 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 178956970;
  if (i3 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = __Znwj(i3 * 24 | 0) | 0;
  i4 = i11 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i6 >> 2] = i2 + (i3 * 24 | 0);
  if ((i1 | 0) == (i12 | 0)) return;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   i1 = i1 + 24 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 24 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i12 | 0));
  return;
 } else {
  i6 = i11 + 4 | 0;
  i2 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 24 | 0;
  i3 = i9 >>> 0 > i2 >>> 0;
  i1 = i3 ? i1 + (i2 * 24 | 0) | 0 : i4;
  i2 = i1 - i5 | 0;
  if (i2 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i8 + (((i2 | 0) / 24 | 0) * 24 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   i1 = i1 + 24 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
}

function __ZN7b2World4StepEfii(i10, f9, i2, i4) {
 i10 = i10 | 0;
 f9 = Math_fround(f9);
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 25 | 0;
 i6 = i13;
 i7 = i13 + 24 | 0;
 i12 = i10 + 102868 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i5 = i10 + 102872 | 0;
 if (i1 & 1) {
  __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i5, i5);
  i1 = HEAP32[i12 >> 2] & -2;
  HEAP32[i12 >> 2] = i1;
 }
 HEAP32[i12 >> 2] = i1 | 2;
 HEAPF32[i6 >> 2] = f9;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i6 + 16 >> 2] = i4;
 i1 = f9 > Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f9);
 f3 = i1 ? f3 : Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = f3;
 i2 = i10 + 102992 | 0;
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f9);
 HEAP8[i6 + 20 >> 0] = HEAP8[i10 + 102996 >> 0] | 0;
 __ZN16b2ContactManager7CollideEv(i5);
 HEAPF32[i10 + 103004 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i7));
 if ((HEAP8[i10 + 102999 >> 0] | 0) != 0 & i1) {
  __ZN7b2World5SolveERK10b2TimeStep(i10, i6);
  HEAPF32[i10 + 103008 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i7));
 }
 if ((HEAP8[i10 + 102997 >> 0] | 0) != 0 & i1) {
  __ZN7b2World8SolveTOIERK10b2TimeStep(i10, i6);
  HEAPF32[i10 + 103028 >> 2] = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i7));
 }
 if (i1) HEAPF32[i2 >> 2] = f3;
 if (HEAP32[i12 >> 2] & 4 | 0) {
  i1 = HEAP32[i10 + 102956 >> 2] | 0;
  if (i1 | 0) do {
   HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
   i1 = HEAP32[i1 + 96 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = HEAP32[i10 + 102932 >> 2] | 0;
 if (!i1) {
  f9 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i11));
  i11 = i10 + 103e3 | 0;
  HEAPF32[i11 >> 2] = f9;
  i11 = HEAP32[i12 >> 2] | 0;
  i11 = i11 & -3;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i8 = i10 + 102944 | 0;
 do {
  do if (HEAP32[i1 + 4 >> 2] & 4 | 0) {
   i6 = HEAP32[i1 + 48 >> 2] | 0;
   i7 = HEAP32[i1 + 52 >> 2] | 0;
   i2 = HEAP32[i6 + 28 >> 2] | 0;
   i4 = HEAP32[i7 + 28 >> 2] | 0;
   if (!(HEAP16[i2 + 4 >> 1] & 2)) i5 = 0; else i5 = (HEAP32[i2 >> 2] | 0) != 0;
   if (!(HEAP16[i4 + 4 >> 1] & 2)) i2 = 0; else i2 = (HEAP32[i4 >> 2] | 0) != 0;
   if (i5 | i2) {
    if (!(HEAP8[i6 + 58 >> 0] | 0)) if (!(HEAP8[i7 + 58 >> 0] | 0)) break;
    __ZN9b2Contact6UpdateEP17b2ContactListener(i1, HEAP32[i8 >> 2] | 0);
   }
  } while (0);
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 f9 = Math_fround(__ZNK7b2Timer15GetMillisecondsEv(i11));
 i11 = i10 + 103e3 | 0;
 HEAPF32[i11 >> 2] = f9;
 i11 = HEAP32[i12 >> 2] | 0;
 i11 = i11 & -3;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN12_GLOBAL__N_112UserRenderer20visualizeJointFramesERKN5physx11PxTransformES4_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 56 | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 i16 = i8 + 4 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 + 4 >> 2];
 i15 = i8 + 8 | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 + 8 >> 2];
 i14 = i8 + 12 | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 i13 = i8 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 + 20 >> 2];
 i12 = i8 + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i1 >> 2];
 i11 = i8 + 32 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 + 4 >> 2];
 i10 = i8 + 36 | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 + 8 >> 2];
 i9 = i8 + 40 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i1 + 16 >> 2];
 i7 = i8 + 48 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
 i5 = i8 + 52 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 24 >> 2];
 i18 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 150564 + 8;
 HEAP32[i6 + 4 >> 2] = i18;
 i1 = i3 + 24 | 0;
 i2 = i3 + 20 | 0;
 i17 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i18, i17 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i17 >> 0] = 5;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i15 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i8 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i8 + 28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i11 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i10 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i9 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i8 + 44 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i7 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i5 | 0);
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN11DynamicMesh10AddPolygonEPKtRKij(i9, i2, i10, i3) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i4 = i3 & 255;
 i5 = i1 + 24 | 0;
 i6 = i1;
 i7 = i6 + 26 | 0;
 do {
  HEAP16[i6 >> 1] = 0;
  i6 = i6 + 2 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP8[i5 >> 0] = i4;
 if (i3 | 0) _memcpy(i1 + 12 | 0, i2 | 0, i3 << 1 | 0) | 0;
 i8 = i9 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i9 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i2 = i6 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 26 | 0, 2, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 26 | 0, 2, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 26 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i9 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i4;
 i6 = (HEAP32[i9 >> 2] | 0) + (i3 * 26 | 0) | 0;
 i7 = i6 + 26 | 0;
 do {
  HEAP16[i6 >> 1] = HEAP16[i1 >> 1] | 0;
  i6 = i6 + 2 | 0;
  i1 = i1 + 2 | 0;
 } while ((i6 | 0) < (i7 | 0));
 i2 = i9 + 40 | 0;
 i3 = i9 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + (i4 << 2) | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = 1 - i1 | 0;
 i16 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f8 = Math_fround(HEAPF32[i16 + (i1 << 4) >> 2]);
 f14 = Math_fround(HEAPF32[i16 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i1 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 f14 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f13 + Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i13 + 688 | 0;
 i10 = i13 + 592 | 0;
 i6 = i13 + 296 | 0;
 i7 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = HEAP32[i1 + 80 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i8;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 2 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 2 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i8 + 4 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + 4;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i8, i9, 0);
 i5 = i7 + 12 | 0;
 i6 = i7 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i1) {
  HEAP32[i5 >> 2] = 0;
  i1 = i5;
  i2 = 0;
 } else {
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 << 4 | 0, 4) | 0;
  i2 = i4 + (i3 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i1 = i5;
  i2 = i4 | 0 ? i4 - i1 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2 + i1 | 0;
 i2 = i1 + (i3 << 4) | 0;
 if (i3 | 0) do {
  __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i1, i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + 20;
 HEAP32[i9 + 4 >> 2] = i7 + 16;
 HEAP32[i9 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i8, i9, 0);
 i6 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + 28;
 HEAP32[i9 + 4 >> 2] = i7 + 24;
 HEAP32[i9 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i8, i9, 0);
 i6 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + 36;
 HEAP32[i9 + 4 >> 2] = i7 + 32;
 HEAP32[i9 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i8, i9, 0);
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + 44;
 HEAP32[i9 + 4 >> 2] = i7 + 40;
 HEAP32[i9 + 8 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags(i8, i9, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 STACKTOP = i11;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i13, i1, i3, i4, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i1 = i12;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i13, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = 538;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? i1 : i10;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = i13; else {
  i9 = i13 + 24 | 0;
  i8 = i3 + 8 | 0;
  i6 = i13 + 36 | 0;
  i7 = i13 + 20 | 0;
  i5 = i4;
  do {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i13, i1);
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_(i13, i11) | 0) {
    f14 = Math_fround(HEAPF32[i11 >> 2]);
    mftCall_viif(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, i1 | 0, +f14);
   }
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i6 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i7 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i6 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i6 >> 0] = 0;
   }
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i5 = i5 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i5 = i13;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i13 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i13 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i13 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i13, i1, i3, i4, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i1 = i12;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i13, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = 537;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? i1 : i10;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = i13; else {
  i9 = i13 + 24 | 0;
  i8 = i3 + 8 | 0;
  i6 = i13 + 36 | 0;
  i7 = i13 + 20 | 0;
  i5 = i4;
  do {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i13, i1);
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_(i13, i11) | 0) {
    f14 = Math_fround(HEAPF32[i11 >> 2]);
    mftCall_viif(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, i1 | 0, +f14);
   }
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i6 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i7 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i6 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i6 >> 0] = 0;
   }
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i5 = i5 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i5 = i13;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i13 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i13 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i13 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN4crnd12crn_unpacker22decode_alpha_endpointsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i9 = i12 + 40 | 0;
 i10 = i12 + 16 | 0;
 i2 = HEAP32[i3 + 88 >> 2] | 0;
 i7 = (HEAPU8[i2 + 55 >> 0] | 0) << 8 | (HEAPU8[i2 + 56 >> 0] | 0);
 i8 = i3 + 92 | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) + ((HEAPU8[i2 + 50 >> 0] | 0) << 8 | (HEAPU8[i2 + 49 >> 0] | 0) << 16 | (HEAPU8[i2 + 51 >> 0] | 0)) | 0;
 i2 = (HEAPU8[i2 + 53 >> 0] | 0) << 8 | (HEAPU8[i2 + 52 >> 0] | 0) << 16 | (HEAPU8[i2 + 54 >> 0] | 0);
 if (!i2) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i3 + 96 >> 2] = i1;
 HEAP32[i3 + 104 >> 2] = i2;
 HEAP32[i3 + 100 >> 2] = i1 + i2;
 HEAP32[i3 + 108 >> 2] = 0;
 HEAP32[i3 + 112 >> 2] = 0;
 i6 = i10 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP8[i10 + 16 >> 0] = 0;
 L4 : do if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i8, i10) | 0) {
  i5 = i3 + 268 | 0;
  i2 = i3 + 272 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != (i7 | 0)) {
   if (i1 >>> 0 <= i7 >>> 0) {
    do if ((HEAP32[i3 + 276 >> 2] | 0) >>> 0 < i7 >>> 0) if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i5, i7, (i1 + 1 | 0) == (i7 | 0), 2, 0) | 0) {
     i1 = HEAP32[i2 >> 2] | 0;
     break;
    } else {
     HEAP8[i3 + 280 >> 0] = 1;
     i3 = 0;
     break L4;
    } while (0);
    _memset((HEAP32[i5 >> 2] | 0) + (i1 << 1) | 0, 0, i7 - i1 << 1 | 0) | 0;
   }
   HEAP32[i2 >> 2] = i7;
  }
  if (!i7) i3 = 1; else {
   i2 = 0;
   i3 = 0;
   i4 = 0;
   i1 = HEAP32[i5 >> 2] | 0;
   while (1) {
    i5 = __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i8, i10) | 0;
    i4 = i5 + i4 & 255;
    i3 = (__ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i8, i10) | 0) + i3 & 255;
    HEAP16[i1 >> 1] = i3 << 8 | i4;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i7 | 0)) {
     i3 = 1;
     break;
    } else i1 = i1 + 2 | 0;
   }
  }
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i11 >> 2] = gb + 401209;
   HEAP32[i11 + 4 >> 2] = 2513;
   HEAP32[i11 + 8 >> 2] = gb + 401349;
   _sprintf(i9, gb + 401176 | 0, i11) | 0;
   _puts(i9) | 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
 }
 i11 = i3;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx6shdfnd10FoundationC2ERNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i4 >> 2] = gb + 110452 + 8;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = gb + 110500 + 8;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP32[i4 + 44 >> 2] = -1;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = HEAP32[gb + 1452348 >> 2] | 0;
  i5 = i2 + 8 | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i1 = mftCall_iiiiii(i6 | 0, i5 | 0, i1 | 0, (i2 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i4 + 48 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = i4 + 52 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i4 + 76 >> 2] = Math_fround(.75);
 HEAP32[i4 + 80 >> 2] = -1;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS0_14NamedAllocatorEPKcEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_S9_SC_NS0_20NonTrackingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i1, 64);
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = HEAP32[gb + 1452348 >> 2] | 0;
  i5 = i6 + 8 | 0;
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i5 | 0, i1 | 0, (i6 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i4 + 92 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 i1 = i4 + 108 | 0;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i2) {
  i5 = 0;
  HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImplC2Ev(i5);
  i5 = i4 + 116 | 0;
  __ZN5physx6shdfnd12ErrorHandlerC2Ev(i5);
  i6 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE(i5, i6) | 0;
  return;
 }
 i5 = HEAP32[gb + 1452348 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i5 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i1 >> 2] = i5;
 __ZN5physx6shdfnd9MutexImplC2Ev(i5);
 i5 = i4 + 116 | 0;
 __ZN5physx6shdfnd12ErrorHandlerC2Ev(i5);
 i6 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE(i5, i6) | 0;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E15insert_noresizeERKS7_(i13, i14, i15) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i18 = i14 + 40 | 0;
 i9 = HEAP32[i18 >> 2] | 0;
 i10 = i9 + -1 | 0;
 i11 = HEAP32[i15 >> 2] | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i1 + 2127912214 + (i1 << 12) | 0;
 i1 = i1 ^ -949894596 ^ HEAP32[i6 + 4 >> 2] ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i16 = i14 + 36 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i14 + 24 >> 2] | 0;
 i8 = i14 + 28 | 0;
 i12 = i14 + 8 | 0;
 i19 = i14 + 4 | 0;
 i20 = i14 + 12 | 0;
 i21 = i14 + 16 | 0;
 i5 = 0;
 i3 = -1;
 i1 = i1 + -744332180 ^ i1 << 9;
 while (1) {
  i4 = i1 & i10;
  i2 = HEAP32[i17 + (i4 * 12 | 0) >> 2] | 0;
  if ((i7 | 0) == (i2 | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i17 + (i4 * 12 | 0) + 4 >> 2] | 0)) {
   i22 = 4;
   break;
  }
  i1 = HEAP8[i12 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i22 = 10; else if (!(HEAP32[i19 >> 2] | 0)) i22 = 10; else if ((HEAP32[i20 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i21 >> 2] | 0) == (HEAP32[i17 + (i4 * 12 | 0) + 4 >> 2] | 0)) i1 = (i3 | 0) == -1 ? i4 : i3; else i22 = 10; else i22 = 10;
  if ((i22 | 0) == 10) {
   i22 = 0;
   if ((i11 | 0) == (i2 | 0)) if ((i6 | 0) == (HEAP32[i17 + (i4 * 12 | 0) + 4 >> 2] | 0)) {
    i22 = 13;
    break;
   } else i1 = i3; else i1 = i3;
  }
  i2 = i5 + 1 | 0;
  i5 = i2;
  i3 = i1;
  i1 = i2 + i4 | 0;
 }
 if ((i22 | 0) == 4) {
  i2 = (i3 | 0) == -1 ? i4 : i3;
  i1 = HEAP8[i12 >> 0] | 0;
 } else if ((i22 | 0) == 13) if ((i4 | 0) == -1) i2 = -1; else {
  HEAP32[i13 >> 2] = i14;
  HEAP32[i13 + 4 >> 2] = i17 + (i4 * 12 | 0);
  HEAP32[i13 + 8 >> 2] = i17 + (i9 * 12 | 0);
  HEAP8[i13 + 12 >> 0] = 0;
  return;
 }
 if (!(i1 << 24 >> 24)) i22 = 20; else {
  i1 = HEAP32[i19 >> 2] | 0;
  if (!i1) i22 = 20; else if ((HEAP32[i20 >> 2] | 0) == (HEAP32[i17 + (i2 * 12 | 0) >> 2] | 0)) if ((HEAP32[i21 >> 2] | 0) == (HEAP32[i17 + (i2 * 12 | 0) + 4 >> 2] | 0)) HEAP32[i19 >> 2] = i1 + -1; else i22 = 20; else i22 = 20;
 }
 if ((i22 | 0) == 20) {
  i22 = i14 + 44 | 0;
  HEAP32[i22 >> 2] = (HEAP32[i22 >> 2] | 0) + 1;
 }
 i21 = i17 + (i2 * 12 | 0) | 0;
 HEAP32[i21 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i21 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i21 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i21 = HEAP32[i16 >> 2] | 0;
 i22 = i21 + ((HEAP32[i18 >> 2] | 0) * 12 | 0) | 0;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i13 + 4 >> 2] = i21 + (i2 * 12 | 0);
 HEAP32[i13 + 8 >> 2] = i22;
 HEAP8[i13 + 12 >> 0] = 1;
 return;
}

function __Z36UnityWebRequest_CUSTOM_InternalBeginP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i2 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = i3 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1029819 | 0, i5 + 8 | 0);
 i2 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63808 | 0, 16, gb + 1029659 | 0, 175) | 0;
 __ZN29UnityWebRequestAsyncOperationC2EP15UnityWebRequest(i2, i3);
 HEAP32[i3 + 112 >> 2] = i2;
 if (i2 | 0) {
  i6 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 if ((HEAP32[i1 >> 2] | 0) != 1) {
  i6 = 35;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = i1 + 32 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(i1 | 0, i2 | 0);
  i6 = __Z17GetWebErrorString8WebError(i6) | 0;
  HEAP32[i4 >> 2] = i6;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i4);
 }
 i6 = __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE7PrepareEv(i3) | 0;
 i1 = i3 + 104 | 0;
 HEAP32[i1 >> 2] = i6;
 do if ((i6 | 0) == 1 | (i6 | 1 | 0) != 1) __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv(i3); else {
  i6 = __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE9DoRequestEv(i3) | 0;
  HEAP32[i1 >> 2] = i6;
  if (!i6) {
   i6 = __Z23GetCoreScriptingClassesv() | 0;
   i6 = i6 + 36 | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   i6 = __Z20scripting_object_newP11Il2CppClass(i6) | 0;
   i4 = i6 + 8 | 0;
   HEAP32[i4 >> 2] = i2;
   STACKTOP = i5;
   return i6 | 0;
  } else {
   __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv(i3);
   break;
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i6 = i1;
  i5 = HEAP32[i2 >> 2] | 0;
  i5 = i5 + 32 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(i5 | 0, i2 | 0);
  i6 = __Z17GetWebErrorString8WebError(i6) | 0;
  HEAP32[i4 >> 2] = i6;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i4);
 } else {
  i6 = __Z23GetCoreScriptingClassesv() | 0;
  i6 = i6 + 36 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = __Z20scripting_object_newP11Il2CppClass(i6) | 0;
  i4 = i6 + 8 | 0;
  HEAP32[i4 >> 2] = i2;
  STACKTOP = i5;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIcNS_9allocatorIcEEE6insertINS_11__wrap_iterIPKcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsISA_E9referenceEEE5valueENS5_IPcEEE4typeES8_SA_SA_(i13, i1, i10, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i5 = i7;
 i1 = i7 + ((HEAP32[i1 >> 2] | 0) - i5) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i8 = i4 - i3 | 0;
 i11 = i4;
 if ((i8 | 0) <= 0) {
  i14 = i1;
  return i14 | 0;
 }
 i12 = i13 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i14 = i13 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 i6 = i9;
 if ((i8 | 0) <= (i2 - i6 | 0)) {
  i5 = i6 - i1 | 0;
  if ((i8 | 0) > (i5 | 0)) {
   i2 = i3 + i5 | 0;
   i4 = i2;
   if ((i2 | 0) == (i11 | 0)) i2 = i9; else {
    i3 = i2;
    i2 = i9;
    do {
     HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
     i3 = i3 + 1 | 0;
     i2 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
     HEAP32[i14 >> 2] = i2;
    } while ((i3 | 0) != (i11 | 0));
   }
   if ((i5 | 0) > 0) i6 = i2; else {
    i14 = i1;
    return i14 | 0;
   }
  } else i6 = i9;
  i5 = i6 - (i1 + i8) | 0;
  i2 = i1 + i5 | 0;
  if (i2 >>> 0 < i9 >>> 0) {
   i3 = i6;
   do {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 1 | 0;
    HEAP32[i14 >> 2] = i3;
   } while ((i2 | 0) != (i9 | 0));
  }
  if (i5 | 0) _memmove(i6 + (0 - i5) | 0, i1 | 0, i5 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0)) {
   i14 = i1;
   return i14 | 0;
  } else i3 = i1;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
  return i1 | 0;
 }
 i4 = i6 - i5 + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i5 = HEAP32[i13 >> 2] | 0;
  i7 = i5;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2 - i5 | 0;
 i8 = i10 << 1;
 i4 = i10 >>> 0 < 1073741823 ? (i8 >>> 0 < i4 >>> 0 ? i4 : i8) : 2147483647;
 i8 = i1;
 if (!i4) i6 = 0; else i6 = __Znwj(i4) | 0;
 i9 = i6 + (i8 - i5) | 0;
 i2 = i9;
 i6 = i6 + i4 | 0;
 if ((i3 | 0) == (i11 | 0)) i4 = i7; else {
  i4 = i9;
  do {
   HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
   i4 = i2 + 1 | 0;
   i2 = i4;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i11 | 0));
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i3 = i8 - i4 | 0;
 i5 = i9 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
 i3 = (HEAP32[i14 >> 2] | 0) - i8 | 0;
 if ((i3 | 0) > 0) {
  _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
  i2 = i2 + i3 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } else i1 = i4;
 HEAP32[i13 >> 2] = i5;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i12 >> 2] = i6;
 if (!i1) {
  i14 = i9;
  return i14 | 0;
 }
 __ZdlPv(i1);
 i14 = i9;
 return i14 | 0;
}

function __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i13 + 688 | 0;
 i10 = i13 + 592 | 0;
 i6 = i13 + 296 | 0;
 i7 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = HEAP32[i1 + 80 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i8;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 2 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 2 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 720 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i13 + 688 | 0;
 i10 = i13 + 592 | 0;
 i6 = i13 + 296 | 0;
 i7 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = HEAP32[i1 + 80 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i11 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i14 = i8;
  i4 = HEAP32[i14 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i11 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i6 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i10 | 0, HEAP32[i11 + 8 >> 2] | 0);
 i3 = i11 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i8);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i14;
 HEAP32[i9 + 8 >> 2] = i10;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i8, i9, 0) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i14 = i12 + 2 | 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i14 = i12 + 2 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN9Rigidbody16AddRelativeForceERK8Vector3fi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, f18 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 28 | 0;
 i10 = i12;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 }
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 i16 = f17 < Math_fround(0.0);
 f18 = Math_fround(-f17);
 i6 = i3 + 4 | 0;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f14 < Math_fround(0.0);
 f15 = Math_fround(-f14);
 i7 = i3 + 8 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = f4 < Math_fround(0.0);
 f13 = Math_fround(-f4);
 i16 = (i16 ? f18 : f17) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
 i5 = i16 & (i5 ? f15 : f14) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 if (i5 & (i8 ? f13 : f4) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
  STACKTOP = i12;
  return;
 }
 i8 = i1 + 52 | 0;
 i16 = HEAP32[i8 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 200 >> 2] | 0, i16 | 0) | 0) & 1) {
  STACKTOP = i12;
  return;
 }
 f4 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 switch (i2 | 0) {
 case 5:
  {
   f15 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f17 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f18 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 0;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   i1 = 1;
   i11 = 6;
   break;
  }
 case 2:
  {
   f15 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f17 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f18 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 1;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  {
   i1 = 0;
   i11 = 6;
  }
 }
 if ((i11 | 0) == 6) {
  i5 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i16 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 124 >> 2] | 0, i10 | 0, i16 | 0);
 HEAP32[i9 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 24 >> 2];
 i16 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i10 + 8 >> 2] = i2;
 __ZN5physx14PxRigidBodyExt23addLocalForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i16, i10, i9, i1, 1);
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i9 = i12;
 i11 = i8 + 12 | 0;
 if (HEAP8[i11 >> 0] | 0) __ZN12FileAccessor5CloseEv(i8 + 1092 | 0) | 0;
 HEAP32[i8 + 2164 >> 2] = 0;
 i1 = i8 + 16 | 0;
 do if ((i1 | 0) == (i2 | 0)) i3 = i1 + 11 | 0; else {
  i6 = HEAP8[i2 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
  i6 = i3 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
  i3 = i1 + 11 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i4 = i2 << 24 >> 24 < 0;
  if (i4) i5 = (HEAP32[i8 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i4) i2 = HEAP32[i8 + 20 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i4) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  if (i6 | 0) _memmove(i2 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 20 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 i2 = HEAP8[i3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i8 + 20 >> 2] | 0;
 } else {
  i4 = i1;
  i2 = i2 & 255;
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i4, i2);
 __Z39DeleteLastPathNameComponentWithAnySlashRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i10, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i8 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i8, _strlen(i8) | 0);
 i8 = __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if (!i8) {
  i11 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 if (!(__Z23CreateAsFileIfNotExistsPKc(i1) | 0)) {
  i11 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP8[i11 >> 0] = 1;
 i11 = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i12;
 return i11 | 0;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i9, i1);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i1, 1);
   __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i2 = i2 - i1 >> 4;
 i1 = i4 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  HEAP32[i4 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i3, __Z34scripting_class_array_element_sizeP11Il2CppClass(i3) | 0, i2) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 if (i2 | 0) {
  i1 = 0;
  do {
   i6 = __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(HEAP32[i4 >> 2] | 0, i1) | 0;
   i5 = (HEAP32[i9 >> 2] | 0) + (i1 << 4) | 0;
   HEAP32[i6 >> 2] = __Z20scripting_string_newPKc((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN15PointEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802350 | 0, i6, i1 + 92 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802367 | 0, i6, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802384 | 0, i6, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 112 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i9 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802400 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 116 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802414 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i1 + 120 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802428 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802440 | 0, i6, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802447 | 0, i6, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx35integrateUndriveWheelRotationSpeedsEfffPKfS1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE(f4, f1, f3, i5, i2, i7, i6) {
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(Math_fround(HEAPF32[i7 + 232 >> 2]) * f4);
 f10 = Math_fround(HEAPF32[i7 + 208 >> 2]);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(Math_fround(f9 + Math_fround(f8 * Math_fround(f13 + Math_fround(HEAPF32[i2 >> 2])))) / Math_fround(Math_fround(f10 * f8) + Math_fround(1.0)));
 f10 = Math_fround(HEAPF32[i7 + 212 >> 2]);
 i11 = Math_fround(f9 * f8) <= Math_fround(0.0) ? Math_fround(Math_fround(f10 * f1) + Math_fround(Math_fround(HEAPF32[i7 + 216 >> 2]) * f3)) != Math_fround(0.0) : 0;
 HEAPF32[i6 >> 2] = i11 ? Math_fround(0.0) : f8;
 i11 = i6 + 4 | 0;
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f10 = Math_fround(Math_fround(HEAPF32[i7 + 280 >> 2]) * f4);
 f9 = Math_fround(HEAPF32[i7 + 256 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f10 = Math_fround(Math_fround(f8 + Math_fround(f10 * Math_fround(f13 + Math_fround(HEAPF32[i2 + 4 >> 2])))) / Math_fround(Math_fround(f9 * f10) + Math_fround(1.0)));
 f9 = Math_fround(HEAPF32[i7 + 260 >> 2]);
 i12 = Math_fround(f8 * f10) <= Math_fround(0.0) ? Math_fround(Math_fround(f9 * f1) + Math_fround(Math_fround(HEAPF32[i7 + 264 >> 2]) * f3)) != Math_fround(0.0) : 0;
 HEAPF32[i11 >> 2] = i12 ? Math_fround(0.0) : f10;
 i11 = i6 + 8 | 0;
 f10 = Math_fround(HEAPF32[i11 >> 2]);
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 328 >> 2]) * f4);
 f8 = Math_fround(HEAPF32[i7 + 304 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(Math_fround(f10 + Math_fround(f9 * Math_fround(f13 + Math_fround(HEAPF32[i2 + 8 >> 2])))) / Math_fround(Math_fround(f8 * f9) + Math_fround(1.0)));
 f8 = Math_fround(HEAPF32[i7 + 308 >> 2]);
 i12 = Math_fround(f10 * f9) <= Math_fround(0.0) ? Math_fround(Math_fround(f8 * f1) + Math_fround(Math_fround(HEAPF32[i7 + 312 >> 2]) * f3)) != Math_fround(0.0) : 0;
 HEAPF32[i11 >> 2] = i12 ? Math_fround(0.0) : f9;
 i6 = i6 + 12 | 0;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(Math_fround(HEAPF32[i7 + 376 >> 2]) * f4);
 f8 = Math_fround(HEAPF32[i7 + 352 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f4 = Math_fround(Math_fround(f9 + Math_fround(f4 * Math_fround(f10 + Math_fround(HEAPF32[i2 + 12 >> 2])))) / Math_fround(Math_fround(f8 * f4) + Math_fround(1.0)));
 f8 = Math_fround(HEAPF32[i7 + 356 >> 2]);
 i7 = Math_fround(f9 * f4) <= Math_fround(0.0) ? Math_fround(Math_fround(f8 * f1) + Math_fround(Math_fround(HEAPF32[i7 + 360 >> 2]) * f3)) != Math_fround(0.0) : 0;
 HEAPF32[i6 >> 2] = i7 ? Math_fround(0.0) : f4;
 return;
}

function __ZN21SweepCallbackNonAlloc14processTouchesEPKN5physx10PxSweepHitEj(i1, i16, i17) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i21;
 i19 = i1 + 76 | 0;
 if (!i17) {
  i20 = 1;
  STACKTOP = i21;
  return i20 | 0;
 }
 i20 = i1 + 72 | 0;
 i13 = i1 + 68 | 0;
 i14 = i18 + 4 | 0;
 i15 = i18 + 8 | 0;
 i3 = i18 + 12 | 0;
 i4 = i18 + 16 | 0;
 i5 = i18 + 20 | 0;
 i6 = i18 + 24 | 0;
 i7 = i18 + 28 | 0;
 i8 = i18 + 32 | 0;
 i9 = i18 + 36 | 0;
 i1 = 0;
 while (1) {
  i10 = HEAP32[i19 >> 2] | 0;
  if ((i10 | 0) >= (HEAP32[i20 >> 2] | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  }
  HEAP32[i19 >> 2] = i10 + 1;
  i11 = HEAP32[i13 >> 2] | 0;
  i12 = i11 + (i10 * 44 | 0) | 0;
  i2 = i16 + (i1 * 48 | 0) + 4 | 0;
  HEAP32[i11 + (i10 * 44 | 0) + 40 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
  i22 = i16 + (i1 * 48 | 0) + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i22 = i11 + (i10 * 44 | 0) + 12 | 0;
  i23 = i16 + (i1 * 48 | 0) + 28 | 0;
  HEAP32[i22 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i22 + 4 >> 2] = HEAP32[i23 + 4 >> 2];
  HEAP32[i22 + 8 >> 2] = HEAP32[i23 + 8 >> 2];
  HEAP32[i18 >> 2] = 5;
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  HEAPF32[i15 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  i22 = i8;
  HEAP32[i22 >> 2] = 0;
  HEAP32[i22 + 4 >> 2] = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i18 | 0) | 0) {
   i2 = HEAP32[i9 >> 2] | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
   i2 = HEAP32[i2 + (HEAP32[i16 + (i1 * 48 | 0) + 8 >> 2] << 2) >> 2] | 0;
  } else i2 = -1;
  HEAP32[i11 + (i10 * 44 | 0) + 24 >> 2] = i2;
  i23 = HEAP32[i16 + (i1 * 48 | 0) + 40 >> 2] | 0;
  HEAP32[i11 + (i10 * 44 | 0) + 28 >> 2] = i23;
  HEAPF32[i11 + (i10 * 44 | 0) + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i11 + (i10 * 44 | 0) + 36 >> 2] = Math_fround(0.0);
  if ((HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0)) {
   HEAP32[i12 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i17 >>> 0) {
   i1 = 1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i21;
  return i1 | 0;
 }
 return 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 40 | 0;
 i6 = i9 + 12 | 0;
 i7 = i9 + 24 | 0;
 i8 = i9;
 L1 : do if ((i2 - i1 | 0) > 3) if ((HEAP8[i1 >> 0] | 0) == 68) {
  switch (HEAP8[i1 + 1 >> 0] | 0) {
  case 84:
  case 116:
   break;
  default:
   break L1;
  }
  i10 = i1 + 2 | 0;
  i4 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i10, i2, i3) | 0;
  if (!((i4 | 0) == (i10 | 0) | (i4 | 0) == (i2 | 0))) if ((HEAP8[i4 >> 0] | 0) == 69) {
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) {
    i3 = i2 + -24 | 0;
    __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i8, i3);
    __THREW__ = 0;
    i2 = invoke_iiii(fb + 520 | 0, i8 | 0, 0, gb + 1086472 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    do if (i10 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
    } else {
     HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __THREW__ = 0;
     i2 = invoke_iii(fb + 1152 | 0, i7 | 0, gb + 1086288 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (i10 & 1) {
      i1 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      break;
     };
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
     HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
     i1 = 0;
     while (1) {
      if ((i1 | 0) == 3) break;
      HEAP32[i2 + (i1 << 2) >> 2] = 0;
      i1 = i1 + 1 | 0;
     }
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i5, i6);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_(i3, i5);
     __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i5);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i6);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
     i1 = i4 + 1 | 0;
     break L1;
    } while (0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i8);
    ___resumeException(i1 | 0);
   }
  }
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function _tlsf_create(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i3 = i1 + -3196 | 0;
 i4 = i3 & -4;
 if ((i4 + -12 | 0) >>> 0 > 1073741812) {
  HEAP32[i2 >> 2] = 3208;
  HEAP32[i2 + 4 >> 2] = 1073745020;
  _printf(gb + 597762 | 0, i2) | 0;
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i8 + 8 >> 2] = i8;
 HEAP32[i8 + 12 >> 2] = i8;
 i7 = i8 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i8 + 20 + (i1 << 2) >> 2] = 0;
  HEAP32[i8 + 116 + (i1 << 7) >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 4 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 8 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 12 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 16 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 20 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 24 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 28 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 32 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 36 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 40 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 44 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 48 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 52 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 56 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 60 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 64 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 68 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 72 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 76 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 80 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 84 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 88 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 92 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 96 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 100 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 104 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 108 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 112 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 116 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 120 >> 2] = i8;
  HEAP32[i8 + 116 + (i1 << 7) + 124 >> 2] = i8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i5 = i8 + 3184 | 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = i4 | 1;
 if (i4 >>> 0 < 128) {
  i1 = i3 >>> 2;
  i2 = 0;
 } else {
  i2 = 31 - (Math_clz32(i4 | 0) | 0) | 0;
  i1 = i4 >>> (i2 + -5 | 0) ^ 32;
  i2 = i2 + -6 | 0;
 }
 i3 = i8 + 116 + (i2 << 7) + (i1 << 2) | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i5 + 12 >> 2] = i8;
 HEAP32[i10 + 12 >> 2] = i5;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << i2;
 i7 = i8 + 20 + (i2 << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << i1;
 i7 = ((HEAP32[i6 >> 2] | 0) + -4 & -4) + i4 | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = 2;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Sc10NPhaseCore35createParticlePacketBodyInteractionERNS0_19ParticlePacketShapeERNS0_8ShapeSimEj(i10, i8, i9, i7) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i3 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = HEAP32[i8 + 36 >> 2] | 0;
 i2 = HEAP16[i8 + 42 >> 1] | 0;
 i4 = i1 + ((i2 & 65535) << 2) | 0;
 L1 : do if (!(i2 << 16 >> 16)) i5 = 6; else {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i1 + 16 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i1 + 32 >> 2] | 0) == (i8 | 0)) break;
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i5 = 6;
    break L1;
   }
  }
  i2 = HEAP32[i1 + 40 >> 2] | 0;
 } while (0);
 if ((i5 | 0) == 6) {
  __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE(i6, i10, i8, i9, 0);
  i4 = HEAPU16[i6 >> 1] | 0;
  if (i4 & 1 | 0) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i3 = i10 + 732 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i10 + 440 | 0);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i5 = i10 + 720 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = i10 + 724 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!i2) i2 = 0; else {
   i5 = HEAP16[i6 + 2 >> 1] | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i9;
   HEAP16[i2 + 8 >> 1] = i5;
   i5 = i2 + 12 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP8[i5 + 8 >> 0] = 0;
  }
  HEAP8[i2 + 19 >> 0] = i4 >>> 1 & 1;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP8[i2 + 18 >> 0] = (i1 | 0) != 0 & 1;
  if (i1) {
   HEAP8[i1 + 8 >> 0] = 1;
   HEAP32[i1 + 4 >> 2] = i2;
  }
 }
 i3 = i10 + 2212 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i10 + 1920 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i6 = i10 + 2200 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i10 = i10 + 2204 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 if (!i1) i1 = 0; else {
  __ZN5physx2Sc35ParticleElementRbElementInteractionC2ERNS0_19ParticlePacketShapeERNS0_8ShapeSimERNS0_16ActorElementPairE(i1, i8, i9, i2);
  i10 = i2 + 16 | 0;
  HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + 1 << 16 >> 16;
  __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEj(i1, i7);
 }
 if (!(HEAP8[i2 + 18 >> 0] | 0)) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = i1 + 6 | 0;
 HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 4;
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i1 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i7 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 }
 i7 = i2 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i5 = i2 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function ___dns_get_rr(i6, i11, i12, i7, i13, i14, i5) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 L1 : do if (!(HEAP8[i13 + 3 >> 0] & 15)) {
  i2 = HEAPU8[i13 + 4 >> 0] << 8 | HEAPU8[i13 + 5 >> 0];
  i8 = HEAPU8[i13 + 6 >> 0] << 8 | HEAPU8[i13 + 7 >> 0];
  if ((i8 + i2 | 0) >>> 0 > 64) i1 = -1; else {
   if (!i2) i2 = 12; else {
    i1 = 12;
    while (1) {
     i2 = i2 + -1 | 0;
     i4 = i13 + i1 | 0;
     i3 = HEAP8[i4 >> 0] | 0;
     L7 : do if ((i1 | 0) < 512) do {
      if (((i3 & 255) + -1 | 0) >>> 0 >= 127) break L7;
      i1 = i1 + 1 | 0;
      i4 = i13 + i1 | 0;
      i3 = HEAP8[i4 >> 0] | 0;
     } while ((i1 | 0) < 512); while (0);
     if ((i3 & 255) > 193) {
      i1 = -1;
      break L1;
     }
     if (i3 << 24 >> 24 == -63) {
      if ((i1 | 0) > 506 | (HEAP8[i4 + 1 >> 0] | 0) == -1) {
       i1 = -1;
       break L1;
      }
     } else if ((i1 | 0) > 506) {
      i1 = -1;
      break L1;
     }
     i1 = (i3 << 24 >> 24 ? 6 : 5) + i1 | 0;
     if (!i2) {
      i2 = i1;
      break;
     }
    }
   }
   if (!i8) i1 = 0; else {
    i10 = i13 + 512 | 0;
    i9 = (i5 | 0) != 0;
    i1 = 0;
    while (1) {
     i8 = i8 + -1 | 0;
     i4 = i13 + i2 | 0;
     i3 = HEAP8[i4 >> 0] | 0;
     L21 : do if ((i2 | 0) < 512) do {
      if (((i3 & 255) + -1 | 0) >>> 0 >= 127) break L21;
      i2 = i2 + 1 | 0;
      i4 = i13 + i2 | 0;
      i3 = HEAP8[i4 >> 0] | 0;
     } while ((i2 | 0) < 512); while (0);
     if ((i3 & 255) > 193) {
      i1 = -1;
      break L1;
     }
     if (i3 << 24 >> 24 == -63) {
      if ((i2 | 0) > 506 | (HEAP8[i4 + 1 >> 0] | 0) == -1) {
       i1 = -1;
       break L1;
      }
     } else if ((i2 | 0) > 506) {
      i1 = -1;
      break L1;
     }
     i4 = (i3 << 24 >> 24 ? 2 : 1) + i2 | 0;
     i2 = i13 + i4 | 0;
     i5 = HEAPU8[i2 + 8 >> 0] << 8 | HEAPU8[i2 + 9 >> 0];
     if ((i5 + i4 | 0) > 512) {
      i1 = -1;
      break L1;
     }
     if (i5 >>> 0 > i12 >>> 0 ? 1 : (HEAPU8[i2 + 1 >> 0] | 0) != (i14 | 0)) {
      i2 = i6;
      i3 = i7;
     } else {
      if (i9) if ((___dn_expand(i13, i10, i2 + 10 | 0, i15, 256) | 0) < 0) {
       i1 = -1;
       break L1;
      }
      if ((i7 | 0) != 0 & (i6 | 0) != 0) {
       if (i9) _strcpy(i6, i15) | 0; else _memcpy(i6 | 0, i2 + 10 | 0, i5 | 0) | 0;
       i2 = i6 + i11 | 0;
       i3 = i7 + -1 | 0;
      } else {
       i2 = i6;
       i3 = i7;
      }
      i1 = i1 + 1 | 0;
     }
     if (!i8) break; else {
      i6 = i2;
      i7 = i3;
      i2 = i4 + 10 + i5 | 0;
     }
    }
   }
  }
 } else i1 = 0; while (0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 48 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i4 = i1 + 48 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i4 | 0));
   i1 = (HEAP32[i12 >> 2] | 0) + 48 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 48 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 48 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 1073741823 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 18;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 48 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (((i1 - i4 | 0) / 48 | 0) * 48 | 0) | 0;
 i7 = i3;
 i5 = i6 + (i5 * 48 | 0) | 0;
 i1 = i3;
 i6 = i7;
 do {
  i4 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  i1 = i6 + 48 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i4 = i2;
  i2 = i7;
  do {
   i14 = i4;
   i4 = i4 + -48 | 0;
   HEAP32[i3 + -48 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + -44 >> 2] = HEAP32[i14 + -44 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i14 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i14 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i14 + -28 >> 2];
   i7 = i3 + -24 | 0;
   i14 = i14 + -24 | 0;
   HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   i3 = i2 + -48 | 0;
   i2 = i3;
  } while ((i4 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i11 >> 2] = i5;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 18;
 HEAP32[i10 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN8UVModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 272 | 0, i7);
 i1 = i6 + 536 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 540 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 544 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 548 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 552 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 560 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 564 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 568 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 556 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i9, i8, 0);
 i3 = i8 + 20 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i4 = i9 + 8 | 0;
 __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = i1 + (i3 * 56 | 0) | 0;
 if (i3 | 0) do {
  __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 56 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i8 + 52 >> 2] | 0;
 i2 = i1 + (i3 << 4) | 0;
 if (i3 | 0) do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i9, i8 + 80 | 0, 0);
 i3 = i8 + 100 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i8 + 112 >> 2] | 0;
 i2 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i8);
  STACKTOP = i10;
  return;
 }
 do {
  __ZN33EnlightenTerrainChunksInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i8);
 STACKTOP = i10;
 return;
}

function __ZNK12GraphicsCaps17CheckGPUSupportedEv(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 64 | 0;
 i5 = i10 + 48 | 0;
 i8 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i4 = i10 + 8 | 0;
 i2 = i10;
 i3 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
 if (!(HEAP8[i1 + 493 >> 0] | 0)) if ((i3 | 0) != 4 & (__Z19GetActiveColorSpacev() | 0) == 1) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  __Z6FormatPKcz(i9, gb + 477089 | 0, i2);
  STACKTOP = i10;
  return;
 }
 i2 = i3 + -8 | 0;
 L10 : do if (i2 >>> 0 < 10) if (521 >>> (i2 & 1023) & 1) {
  switch (i3 | 0) {
  case 17:
   {
    i2 = HEAP32[i1 + 728 >> 2] | 0;
    i3 = HEAP32[i1 + 732 >> 2] | 0;
    if (((i2 * 10 | 0) + i3 | 0) >= 31) break L10;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i4 + 4 >> 2] = i2;
    HEAP32[i4 + 8 >> 2] = i3;
    __Z6FormatPKcz(i9, gb + 477146 | 0, i4);
    STACKTOP = i10;
    return;
   }
  case 8:
  case 11:
   break;
  default:
   break L10;
  }
  switch (HEAP32[i1 + 540 >> 2] | 0) {
  case 2:
   {
    i3 = HEAP32[i1 + 728 >> 2] | 0;
    i4 = HEAP32[i1 + 732 >> 2] | 0;
    i2 = (i3 * 10 | 0) + i4 | 0;
    if (!i2) {
     if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i7 >> 2] = i1;
     __Z6FormatPKcz(i9, gb + 477229 | 0, i7);
     STACKTOP = i10;
     return;
    }
    if ((i2 | 0) >= 30) break L10;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i8 + 4 >> 2] = i3;
    HEAP32[i8 + 8 >> 2] = i4;
    __Z6FormatPKcz(i9, gb + 477281 | 0, i8);
    STACKTOP = i10;
    return;
   }
  case 1:
   {
    i2 = HEAP32[i1 + 728 >> 2] | 0;
    i3 = HEAP32[i1 + 732 >> 2] | 0;
    if (((i2 * 10 | 0) + i3 | 0) >= 20) break L10;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i5 + 4 >> 2] = i2;
    HEAP32[i5 + 8 >> 2] = i3;
    __Z6FormatPKcz(i9, gb + 477370 | 0, i5);
    STACKTOP = i10;
    return;
   }
  case 3:
  case 4:
   {
    i2 = HEAP32[i1 + 728 >> 2] | 0;
    i3 = HEAP32[i1 + 732 >> 2] | 0;
    if (((i2 * 10 | 0) + i3 | 0) >= 31) break L10;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i6 + 4 >> 2] = i2;
    HEAP32[i6 + 8 >> 2] = i3;
    __Z6FormatPKcz(i9, gb + 477459 | 0, i6);
    STACKTOP = i10;
    return;
   }
  default:
   break L10;
  }
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1576256 | 0, 0);
 STACKTOP = i10;
 return;
}

function __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i1 = i7 + 264 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 268 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 277 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 278 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 279 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 276 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 280 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 288 | 0, i5);
 i1 = i7 + 284 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 272 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN5physx15saveHeightFieldERKNS_2Gu11HeightFieldERNS_14PxOutputStreamEb(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(__ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE(72, 70, 72, 70, 0, i4, i5) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 16 >> 2] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 20 >> 2] | 0, i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 24 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 28 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 32 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 40 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 44 >> 2]), i4, i5);
 __ZN5physx9writeWordEtbRNS_14PxOutputStreamE(HEAP16[i1 + 48 >> 1] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 52 >> 2] | 0, i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 56 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 60 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 64 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 68 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 72 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 76 >> 2]), i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 80 >> 2] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 84 >> 2] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 88 >> 2] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 92 >> 2] | 0, i4, i5);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 96 >> 2] | 0, i4, i5);
 i3 = i1 + 100 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i3 >> 2] | 0, i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 104 >> 2]), i4, i5);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i1 + 108 >> 2]), i4, i5);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i5 = 1;
  return i5 | 0;
 }
 i1 = i1 + 36 | 0;
 i2 = 0;
 do {
  i6 = HEAP32[i1 >> 2] | 0;
  __ZN5physx9writeWordEtbRNS_14PxOutputStreamE(HEAP16[i6 + (i2 << 2) >> 1] | 0, i4, i5);
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i6 + (i2 << 2) + 2 | 0, 1) | 0;
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i6 + (i2 << 2) + 3 | 0, 1) | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN5physx14PxRigidBodyExt27computeLinearAngularImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_(i2, i3, i8, i4, f6, f5, i7, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i9;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i21 | 0, i2 | 0);
 f10 = Math_fround(Math_fround(HEAPF32[i21 + 16 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(HEAPF32[i21 + 20 >> 2]) * Math_fround(2.0));
 f20 = Math_fround(Math_fround(HEAPF32[i21 + 24 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(f10 * f16);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f17 * f11));
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f20 * f13));
 f14 = Math_fround(Math_fround(f16 * f15) + Math_fround(Math_fround(f10 * f19) + Math_fround(f18 * Math_fround(Math_fround(f20 * f11) - Math_fround(f17 * f13)))));
 f12 = Math_fround(Math_fround(f11 * f15) + Math_fround(Math_fround(f17 * f19) + Math_fround(f18 * Math_fround(Math_fround(f10 * f13) - Math_fround(f20 * f16)))));
 f15 = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * Math_fround(Math_fround(f17 * f16) - Math_fround(f10 * f11)))) + Math_fround(f13 * f15));
 f14 = Math_fround(Math_fround(HEAPF32[i3 + 16 >> 2]) + f14);
 f12 = Math_fround(Math_fround(HEAPF32[i3 + 20 >> 2]) + f12);
 f15 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f15);
 f13 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f6);
 i3 = i4 + 4 | 0;
 f11 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f6);
 i2 = i4 + 8 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f6);
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i7 + 4 >> 2] = f11;
 HEAPF32[i7 + 8 >> 2] = f10;
 f14 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f14);
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f12);
 f15 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) - f15);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f12 * f10);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f11 - Math_fround(f15 * f13));
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(Math_fround(Math_fround(f15 * f6) - Math_fround(f14 * f10)) * f5);
 f6 = Math_fround(Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f6)) * f5);
 HEAPF32[i1 >> 2] = Math_fround(f11 * f5);
 HEAPF32[i1 + 4 >> 2] = f10;
 HEAPF32[i1 + 8 >> 2] = f6;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 24 | 0;
 i12 = i13;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = (i1 - i2 >> 4) + 1 | 0;
 if (i4 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = (HEAP32[i8 + 8 >> 2] | 0) - i2 | 0;
 i3 = i9 >> 3;
 i3 = i9 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 268435455;
 i4 = i1 - i2 >> 4;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i8 + 8;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 4) | 0;
 HEAP32[i12 >> 2] = i5;
 i1 = i5 + (i4 << 4) | 0;
 i9 = i12 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 i7 = i12 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i5 + (i3 << 4);
 i2 = HEAP8[i6 + 11 >> 0] | 0;
 i14 = i2 << 24 >> 24 < 0;
 i3 = i14 ? HEAP32[i6 >> 2] | 0 : i6;
 i6 = i14 ? HEAP32[i6 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + (i4 << 4) + 12 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i5 + (i4 << 4) + 12 >> 2] | 0;
  i10 = 8;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i6;
  if (i6) i10 = 10;
 } else i10 = 8;
 if ((i10 | 0) == 8) {
  i15 = i6 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i2;
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i14;
  HEAP32[i5 + (i4 << 4) + 8 >> 2] = i15 | -2147483648;
  HEAP32[i5 + (i4 << 4) + 4 >> 2] = i6;
  i1 = i14;
  i10 = 10;
 }
 if ((i10 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 16;
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i8, i12);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i11 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i9 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i15 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i15, i11);
    i1 = HEAP32[i9 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN7mecanim22CreateValueArrayWeightEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i3, i13) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = mftCall_iiii(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, i13 | 0, 40, 4) | 0;
 i1 = i14;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i10 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i10) {
  i8 = i14 + 8 | 0;
  i9 = i14 + 16 | 0;
  i11 = i14 + 32 | 0;
  i6 = i14 + 24 | 0;
  i7 = i14;
  i5 = 0;
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i7 = i3 + 4 | 0;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i8 = i14 + 8 | 0;
  i9 = i14 + 16 | 0;
  i11 = i14 + 32 | 0;
  i12 = i14 + 24 | 0;
  i6 = 0;
  i4 = 0;
  i5 = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
  while (1) {
   switch (HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] | 0) {
   case 6:
    {
     i4 = i4 + 1 | 0;
     HEAP32[i14 >> 2] = i4;
     break;
    }
   case 7:
    {
     i5 = i5 + 1 | 0;
     HEAP32[i8 >> 2] = i5;
     break;
    }
   case 8:
    {
     i3 = i3 + 1 | 0;
     HEAP32[i9 >> 2] = i3;
     break;
    }
   case 1:
    {
     i2 = i2 + 1 | 0;
     HEAP32[i11 >> 2] = i2;
     break;
    }
   case 3:
    {
     i1 = i1 + 1 | 0;
     HEAP32[i12 >> 2] = i1;
     break;
    }
   default:
    {}
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i10 >>> 0) {
    i6 = i12;
    i7 = i14;
    break L1;
   }
  }
 } while (0);
 i2 = i5 + i4 + i3 + i2 + i1 | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, i13 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i15 = i14 + 4 | 0;
 i16 = i15;
 i17 = i1 | 0 ? i1 - i16 | 0 : 0;
 HEAP32[i15 >> 2] = i17;
 i15 = HEAP32[i7 >> 2] | 0;
 i1 = i1 + (i15 << 2) | 0;
 i2 = i14 + 12 | 0;
 i3 = i2;
 HEAP32[i2 >> 2] = i1 | 0 ? i1 - i3 | 0 : 0;
 i1 = i1 + (HEAP32[i8 >> 2] << 2) | 0;
 i4 = i14 + 20 | 0;
 i5 = i4;
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 i1 = i1 + (HEAP32[i9 >> 2] << 2) | 0;
 i7 = i14 + 36 | 0;
 i10 = i7;
 HEAP32[i7 >> 2] = i1 | 0 ? i1 - i10 | 0 : 0;
 i1 = i1 + (HEAP32[i11 >> 2] << 2) | 0;
 i12 = i14 + 28 | 0;
 i13 = i12;
 HEAP32[i12 >> 2] = i1 | 0 ? i1 - i13 | 0 : 0;
 _memset(((i17 | 0) == 0 ? 0 : i17 + i16 | 0) | 0, 0, i15 << 2 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 _memset(((i2 | 0) == 0 ? 0 : i2 + i3 | 0) | 0, 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 _memset(((i8 | 0) == 0 ? 0 : i8 + i5 | 0) | 0, 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 _memset(((i9 | 0) == 0 ? 0 : i9 + i10 | 0) | 0, 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 _memset(((i12 | 0) == 0 ? 0 : i12 + i13 | 0) | 0, 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 return i14 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj154ES2_RKNS_29PxClothMotionConstraintConfigES6_EEKNS_42PxClothMotionConstraintConfigGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 12 | 0;
 i7 = i8 + 64 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj399ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj400ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 16 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj401ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9 + 32 | 0, 2);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f21 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f20 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f19 = Math_fround(Math_fround(Math_fround(f20 * f18) + Math_fround(f15 * f12)) + Math_fround(f13 * f14));
 f11 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f17 * f12) + Math_fround(f16 * Math_fround(Math_fround(f13 * f18) - Math_fround(f20 * f14))))) * Math_fround(2.0)));
 f10 = Math_fround(f10 + Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * Math_fround(Math_fround(f20 * f12) - Math_fround(f15 * f18)))) + Math_fround(f13 * f19)) * Math_fround(2.0)));
 f6 = Math_fround(Math_fround(f16 * f7) - Math_fround(Math_fround(Math_fround(f20 * f23) + Math_fround(f15 * f24)) + Math_fround(f13 * f22)));
 f9 = Math_fround(Math_fround(Math_fround(f15 * f22) - Math_fround(f13 * f24)) + Math_fround(Math_fround(f16 * f23) + Math_fround(f20 * f7)));
 f8 = Math_fround(Math_fround(Math_fround(f13 * f23) - Math_fround(f20 * f22)) + Math_fround(Math_fround(f16 * f24) + Math_fround(f15 * f7)));
 f7 = Math_fround(Math_fround(Math_fround(f20 * f24) - Math_fround(f15 * f23)) + Math_fround(Math_fround(f16 * f22) + Math_fround(f13 * f7)));
 HEAPF32[i5 + 16 >> 2] = Math_fround(f21 + Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12))))) * Math_fround(2.0)));
 HEAPF32[i5 + 20 >> 2] = f11;
 HEAPF32[i5 + 24 >> 2] = f10;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = f6;
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i4 + 36 | 0, i2, i5, Math_fround(HEAPF32[i4 + 28 >> 2]), 0);
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i6, i2, i10) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i2;
 i5 = i10 - i3 >> 5;
 i7 = i6 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i8 = i9;
 if (i5 >>> 0 <= i1 - i9 >> 5 >>> 0) {
  i7 = i6 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i9 >> 5;
  i6 = i5 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 << 5) | 0;
  i5 = i6 ? i1 : i10;
  i3 = i5 - i3 | 0;
  i4 = i3 >> 5;
  if (i4 | 0) _memmove(i9 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i8 + (i4 << 5) | 0;
  if (!i6) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -32 - i2 | 0) >>> 5) << 5);
   return;
  }
  if ((i5 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i9 = i2 + 16 | 0;
   i8 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i1 = i1 + 32 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 32 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 i4 = i9;
 if (i9) {
  i1 = i6 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i8 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -32 - i9 | 0) >>> 5) << 5);
  __ZdlPv(i4);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
 }
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i3 = 0;
 i9 = i1 - i3 | 0;
 i3 = i9 >> 4;
 i3 = i9 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 134217727;
 if (i3 >>> 0 > 134217727) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i1 = __Znwj(i3 << 5) | 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = i1 + (i3 << 5);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i9 = i1 + 16 | 0;
  i8 = i2 + 16 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i2 = i2 + 32 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 32 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __ZN6Camera8DoRenderER11CullResultsRK19SharedRendererSceneNS_10RenderFlagEPFvRS_R10RenderLoopRK15RenderNodeQueueEPSA_(i7, i8, i1, i9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f12 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i3 = i6;
 f5 = Math_fround(HEAPF32[i7 + 872 >> 2]);
 if (f5 <= Math_fround(9.99999974e-06)) {
  STACKTOP = i6;
  return;
 }
 f2 = Math_fround(HEAPF32[i7 + 876 >> 2]);
 if (f2 <= Math_fround(9.99999974e-06)) {
  STACKTOP = i6;
  return;
 }
 f12 = Math_fround(HEAPF32[i7 + 864 >> 2]);
 if (!(!(f12 >= Math_fround(1.0)) & !(Math_fround(f5 + f12) <= Math_fround(0.0)))) {
  STACKTOP = i6;
  return;
 }
 f12 = Math_fround(HEAPF32[i7 + 868 >> 2]);
 if (!(!(f12 >= Math_fround(1.0)) & !(Math_fround(f2 + f12) <= Math_fround(0.0)))) {
  STACKTOP = i6;
  return;
 }
 f12 = Math_fround(HEAPF32[i7 + 924 >> 2]);
 f2 = Math_fround(HEAPF32[i7 + 920 >> 2]);
 if (f12 <= f2) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP8[i7 + 1088 >> 0] | 0)) {
  if (f2 <= Math_fround(0.0)) {
   STACKTOP = i6;
   return;
  }
  f12 = Math_fround(HEAPF32[i7 + 292 >> 2]);
  i4 = f12 < Math_fround(0.0);
  f5 = Math_fround(-f12);
  if ((i4 ? f5 : f12) < Math_fround(9.99999997e-07)) {
   STACKTOP = i6;
   return;
  }
 } else {
  f12 = Math_fround(HEAPF32[i7 + 916 >> 2]);
  i4 = f12 < Math_fround(0.0);
  f5 = Math_fround(-f12);
  if ((i4 ? f5 : f12) < Math_fround(9.99999997e-07)) {
   STACKTOP = i6;
   return;
  }
 }
 if ((HEAP16[gb + 1110472 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110472 | 0, i1);
  i1 = gb + 1110472 | 0;
 } else i1 = 0;
 i3 = HEAP32[gb + 1110472 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i3 | 0);
 i3 = i8 + 1372 | 0;
 i4 = i7 + 1124 | 0;
 __Z27InitializeRenderLoopContextP6CameraRK19SharedRendererSceneP10RenderLoop(i7, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 __Z12GetGfxDevicev() | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 do if (!i10) __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb(i4, HEAP32[i8 + 1204 >> 2] | 0, i8, HEAP32[i7 + 1128 >> 2] | 0, 0); else if (!i11) {
  mftCall_viii(i10 | 0, i7 | 0, i4 | 0, (HEAP32[i3 >> 2] | 0) + 8 | 0);
  break;
 } else {
  mftCall_viii(i10 | 0, i7 | 0, i4 | 0, i11 | 0);
  break;
 } while (0);
 __ZN6Camera21PostMultiCustomRenderENS_10RenderFlagEb(i7, i9, 1);
 i11 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 652 >> 2] | 0, i11 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i15 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i15 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i15 + 8 >> 2]));
 f14 = Math_fround(f8 + Math_fround(f14 * Math_fround(HEAPF32[i15 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f13 + Math_fround(f14 + Math_fround(f11 * Math_fround(HEAPF32[i15 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN7mecanim12statemachine13EndTransitionERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS_6memory16MecanimAllocatorE(i1, i2, i8, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  i7 = i8 + 80 | 0;
  i8 = i8 + 85 | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
  return;
 }
 i7 = i2 + 12 | 0;
 i1 = i8 + 80 | 0;
 i6 = 0;
 do {
  i3 = HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i4 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 16 >> 2] | 0;
  i2 = i4 + 4 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i4 + 12 >> 2] | 0;
   __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(i3, 0);
   __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 1);
   __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i2, HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, 0) | 0;
   __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i5, HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, 1) | 0;
   i2 = HEAP32[i5 + 8 >> 2] | 0;
   i4 = i2 + 28 | 0;
   if ((HEAP32[i4 >> 2] | 0) != 1) {
    i3 = i2 + 16 | 0;
    i2 = 0;
    do {
     __ZN8Playable14SetInputWeightEif(i5, i2, Math_fround(0.0));
     __ZN21AnimationClipPlayable7SetClipEP13AnimationClip(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0, 0);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < ((HEAP32[i4 >> 2] | 0) + -1 | 0) >>> 0);
   }
  } else {
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i4 + 12 >> 2] | 0;
   i4 = HEAP32[i4 + 20 >> 2] | 0;
   __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(i3, 0);
   __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 1);
   __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 2);
   __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i2, HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, 0) | 0;
   __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i4, HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, 1) | 0;
   __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i5, HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 0, 2) | 0;
  }
  __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 1, Math_fround(0.0));
  __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + (i6 << 2) >> 2] | 0, 2, Math_fround(0.0));
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 i8 = i8 + 85 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 return;
}

function __Z27CalculateProjectedBoxArea2DPK8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f19 - f13);
 f18 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(f12 * Math_fround(f18 + f15));
 f11 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f7 = Math_fround(f11 - f19);
 f20 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f7 = Math_fround(f7 * Math_fround(f18 + f20));
 f16 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f6 = Math_fround(f13 - f16);
 f14 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f6 = Math_fround(f6 * Math_fround(f15 + f14));
 f22 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f8 = Math_fround(f22 - f11);
 f2 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f8 = Math_fround(f8 * Math_fround(f20 + f2));
 f21 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f5 = Math_fround(f16 - f21);
 f3 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f14 + f3));
 f14 = Math_fround(Math_fround(f11 - f16) * Math_fround(f20 + f14));
 f20 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f11 = Math_fround(f20 - f16);
 f10 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f11 = Math_fround(f11 * Math_fround(f10 + f4));
 f9 = Math_fround(Math_fround(f22 - f20) * Math_fround(f2 + f10));
 f2 = Math_fround(Math_fround(f21 - f22) * Math_fround(f2 + f3));
 f3 = Math_fround(Math_fround(f16 - f21) * Math_fround(f3 + f4));
 f10 = Math_fround(Math_fround(f20 - f19) * Math_fround(f18 + f10));
 f4 = Math_fround(Math_fround(f13 - f16) * Math_fround(f15 + f4));
 f15 = Math_fround(f6 + Math_fround(Math_fround(f12 + f7) - f14));
 i17 = f15 < Math_fround(0.0);
 f16 = Math_fround(-f15);
 f14 = Math_fround(f5 + Math_fround(Math_fround(f14 + f8) + f2));
 i1 = f14 < Math_fround(0.0);
 f13 = Math_fround(-f14);
 f14 = Math_fround((i17 ? f16 : f15) + (i1 ? f13 : f14));
 f2 = Math_fround(f3 + Math_fround(f2 + Math_fround(f9 + f11)));
 i1 = f2 < Math_fround(0.0);
 f13 = Math_fround(-f2);
 f2 = Math_fround(f14 + (i1 ? f13 : f2));
 f11 = Math_fround(f4 + Math_fround(Math_fround(f12 + f10) - f11));
 i1 = f11 < Math_fround(0.0);
 f12 = Math_fround(-f11);
 f2 = Math_fround((i1 ? f12 : f11) + f2);
 f7 = Math_fround(Math_fround(Math_fround(f10 + f9) - f8) - f7);
 i1 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f2 = Math_fround((i1 ? f8 : f7) + f2);
 f3 = Math_fround(f6 + Math_fround(f5 + Math_fround(Math_fround(-f4) - f3)));
 i1 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 return Math_fround(Math_fround((i1 ? f4 : f3) + f2) * Math_fround(.5));
}

function __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17 + 20 | 0;
 i13 = i17 + 48 | 0;
 i14 = i17;
 i16 = HEAP32[i4 + 20 >> 2] | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = (HEAP32[i7 + 32 >> 2] | 0) == 17;
 i3 = i12;
 do if (!i12) {
  i1 = i7 + 12 | 0;
  if (i2) i2 = 0; else i2 = _il2cpp_object_new(HEAP32[i1 >> 2] | 0) | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP8[i15 >> 0] = 1;
  HEAP32[i15 + 4 >> 2] = i2;
  HEAP32[i15 + 8 >> 2] = i8;
  HEAP32[i15 + 12 >> 2] = -1;
  i12 = 1;
  i3 = i2;
  i5 = -1;
 } else {
  if (!i2) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i15, HEAP32[i7 >> 2] | 0, i4, 1);
   i12 = HEAP8[i15 >> 0] | 0;
   i3 = HEAP32[i15 + 4 >> 2] | 0;
   i8 = HEAP32[i15 + 8 >> 2] | 0;
   i5 = HEAP32[i15 + 12 >> 2] | 0;
   break;
  }
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = HEAP32[i7 + 12 >> 2] | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i4 + 12 >> 2] | 0) | 0;
   HEAP8[i15 >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = i3;
  } else {
   HEAP8[i15 >> 0] = 0;
   HEAP32[i15 + 4 >> 2] = i3;
  }
  HEAP32[i15 + 8 >> 2] = i2;
  HEAP32[i15 + 12 >> 2] = i1;
  i12 = 0;
  i8 = i2;
  i5 = i1;
 } while (0);
 i6 = i15 + 1 | 0;
 HEAP8[i13 >> 0] = HEAP8[i6 >> 0] | 0;
 HEAP8[i13 + 1 >> 0] = HEAP8[i6 + 1 >> 0] | 0;
 HEAP8[i13 + 2 >> 0] = HEAP8[i6 + 2 >> 0] | 0;
 i6 = HEAP32[i7 + 44 >> 2] | 0;
 i9 = (HEAP32[i4 + 16 >> 2] | 0) + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + (i6 << 6) | 0;
 HEAP32[i9 >> 2] = i2;
 i9 = i14 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i14 >> 2] = i1;
 i10 = i14 + 8 | 0;
 HEAP32[i10 >> 2] = i2;
 i4 = i6 << 6 >> 6;
 HEAP32[i14 + 16 >> 2] = i4;
 i11 = i14 + 12 | 0;
 HEAP32[i11 >> 2] = i4;
 i4 = HEAP32[i7 + 24 >> 2] | 0;
 i7 = (i4 | 0) != 0;
 if (i7) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i16, i4);
 HEAP32[i15 + 20 >> 2] = i16;
 HEAP8[i15 >> 0] = i12;
 i12 = i15 + 1 | 0;
 HEAP8[i12 >> 0] = HEAP8[i13 >> 0] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[i13 + 1 >> 0] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[i13 + 2 >> 0] | 0;
 HEAP32[i15 + 4 >> 2] = i3;
 HEAP32[i15 + 8 >> 2] = i8;
 HEAP32[i15 + 12 >> 2] = i5;
 HEAP32[i15 + 16 >> 2] = i14;
 if (i6 | 0) do {
  i14 = i1 + 64 | 0;
  HEAP32[i9 >> 2] = i14;
  HEAP32[i11 >> 2] = i2 - i14 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i15 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i7) {
  STACKTOP = i17;
  return;
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i16);
 STACKTOP = i17;
 return;
}

function __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = HEAP16[i4 + 152 >> 1] | 0;
 HEAP32[i3 >> 2] = i7 << 16 >> 16;
 switch (i7 << 16 >> 16) {
 case 0:
  {
   i7 = HEAP32[i4 + 148 >> 2] | 0;
   f10 = Math_fround(Math_fround((i7 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f9 = Math_fround(Math_fround(i7 >>> 16 & 255) / Math_fround(255.0));
   f8 = Math_fround(Math_fround(i7 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 28 >> 2] = Math_fround(Math_fround(i7 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 32 >> 2] = f10;
   HEAPF32[i3 + 36 >> 2] = f9;
   HEAPF32[i3 + 40 >> 2] = f8;
   return;
  }
 case 4:
 case 1:
  {
   i2 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 200 >> 2] | 0) | 0;
   HEAP32[i3 + 8 >> 2] = i2;
   i1 = __Znwj(72) | 0;
   i5 = i1;
   i6 = i4;
   i7 = i5 + 72 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   HEAP32[i2 + 8 >> 2] = i1;
   return;
  }
 case 2:
  {
   i7 = HEAP32[i4 + 144 >> 2] | 0;
   f10 = Math_fround(Math_fround((i7 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f9 = Math_fround(Math_fround(i7 >>> 16 & 255) / Math_fround(255.0));
   f8 = Math_fround(Math_fround(i7 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 12 >> 2] = Math_fround(Math_fround(i7 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 16 >> 2] = f10;
   HEAPF32[i3 + 20 >> 2] = f9;
   HEAPF32[i3 + 24 >> 2] = f8;
   i7 = HEAP32[i4 + 148 >> 2] | 0;
   f8 = Math_fround(Math_fround((i7 & 65535) >>> 8 & 255) / Math_fround(255.0));
   f9 = Math_fround(Math_fround(i7 >>> 16 & 255) / Math_fround(255.0));
   f10 = Math_fround(Math_fround(i7 >>> 24 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 28 >> 2] = Math_fround(Math_fround(i7 & 255) / Math_fround(255.0));
   HEAPF32[i3 + 32 >> 2] = f8;
   HEAPF32[i3 + 36 >> 2] = f9;
   HEAPF32[i3 + 40 >> 2] = f10;
   return;
  }
 default:
  {
   i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 200 >> 2] | 0) | 0;
   HEAP32[i3 + 4 >> 2] = i1;
   i2 = __Znwj(72) | 0;
   i5 = i2;
   i6 = i4 + 72 | 0;
   i7 = i5 + 72 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   HEAP32[i1 + 8 >> 2] = i2;
   i2 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 200 >> 2] | 0) | 0;
   HEAP32[i3 + 8 >> 2] = i2;
   i1 = __Znwj(72) | 0;
   i5 = i1;
   i6 = i4;
   i7 = i5 + 72 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   HEAP32[i2 + 8 >> 2] = i1;
   return;
  }
 }
}

function __ZN14PhysicsManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 HEAP32[i8 >> 2] = gb + 113148 + 8;
 HEAP32[i8 + 28 >> 2] = gb + 113148 + 140;
 __ZN5Unity12PhysicsQueryD2Ev(i8 + 736 | 0);
 i1 = HEAP32[i8 + 724 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 728 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = i8 + 176 | 0;
 _memset(i8 + 196 | 0, 0, 528) | 0;
 if ((HEAP32[i8 + 192 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 180 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 148 | 0;
 if ((HEAP32[i8 + 164 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 152 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i8 + 136 | 0, HEAP32[i8 + 140 >> 2] | 0);
 i1 = i8 + 116 | 0;
 if ((HEAP32[i8 + 132 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 120 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i8 + 104 | 0, HEAP32[i8 + 108 >> 2] | 0);
 i1 = HEAP32[i8 + 92 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 96 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i6 = i8 + 80 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 84 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -72 | 0;
    HEAP32[i7 >> 2] = i3;
    i5 = i2 + -12 | 0;
    i4 = i2 + -4 | 0;
    if (!(HEAP32[i4 >> 2] | 0)) i2 = i3; else {
     i2 = HEAP32[i2 + -8 >> 2] | 0;
     i9 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
     i10 = HEAP32[i2 >> 2] | 0;
     HEAP32[i10 + 4 >> 2] = HEAP32[i9 >> 2];
     HEAP32[HEAP32[i9 >> 2] >> 2] = i10;
     HEAP32[i4 >> 2] = 0;
     if ((i2 | 0) == (i5 | 0)) i2 = i3; else {
      do {
       i10 = i2;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       __ZdlPv(i10);
      } while ((i2 | 0) != (i5 | 0));
      i2 = HEAP32[i7 >> 2] | 0;
     }
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i8 + 68 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = gb + 28648 + 8;
  HEAP32[i8 >> 2] = gb + 28496 + 8;
  return;
 }
 i2 = i8 + 72 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i1);
 HEAP32[i8 >> 2] = gb + 28648 + 8;
 HEAP32[i8 >> 2] = gb + 28496 + 8;
 return;
}

function __Z26ExtractAllRenderersInSceneR13dynamic_arrayIP8RendererLj4EE(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 8 | 0;
 i15 = i16;
 i14 = i16 + 16 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i11 = i14 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i15);
 i15 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31312 | 0, i14, 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i15 = i10 + 16 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i15 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i10 >> 2] = i9;
  }
  i1 = HEAP32[i11 >> 2] | 0;
 }
 if (i1 | 0) {
  i8 = i10 + 12 | 0;
  i9 = i10 + 4 | 0;
  i7 = 0;
  do {
   i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   i6 = i5;
   if (!(HEAP32[i5 + 8 >> 2] & 1048576)) {
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i3;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i6;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentryC2ERS3_b(i13, i14, i3) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15;
 HEAP8[i13 >> 0] = 0;
 i1 = i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i2) {
  i1 = HEAP32[i1 + 72 >> 2] | 0;
  if (i1 | 0) __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i1) | 0;
  do if (!i3) {
   i1 = i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0;
   if (HEAP32[i1 + 4 >> 2] & 4096 | 0) {
    HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
    __THREW__ = 0;
    i12 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
    i11 = __THREW__;
    __THREW__ = 0;
    if (i11 & 1) {
     i15 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
     ___resumeException(i15 | 0);
    }
    __ZNSt3__26localeD2Ev(i4);
    i1 = HEAP32[i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i7 = i1;
    i8 = (i1 | 0) == 0;
    i9 = i7 + 12 | 0;
    i10 = i7 + 16 | 0;
    i11 = i1;
    while (1) {
     if (i8) {
      i3 = 0;
      i1 = 0;
      break;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
     i6 = (i2 | 0) == -1;
     i4 = i6 ? 0 : i1;
     if (i6) {
      i3 = 0;
      i1 = 0;
      break;
     }
     i3 = i4;
     i5 = i3 + 12 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     i6 = i3 + 16 | 0;
     if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0; else i2 = HEAP32[i2 >> 2] | 0;
     if (!(mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, 8192, i2 | 0) | 0)) break;
     i2 = HEAP32[i5 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
      mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0;
      continue;
     } else {
      HEAP32[i5 >> 2] = i2 + 4;
      continue;
     }
    }
    if (i1 | 0) {
     i2 = HEAP32[i3 + 12 >> 2] | 0;
     if ((i2 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
     if ((i1 | 0) != -1) break;
    }
    i12 = i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __ZNSt3__28ios_base5clearEj(i12, HEAP32[i12 + 16 >> 2] | 6);
   }
  } while (0);
  HEAP8[i13 >> 0] = (HEAP32[i14 + (HEAP32[(HEAP32[i14 >> 2] | 0) + -12 >> 2] | 0) + 16 >> 2] | 0) == 0 & 1;
 } else __ZNSt3__28ios_base5clearEj(i1, i2 | 4);
 STACKTOP = i15;
 return;
}

function __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i6 = i13;
 i10 = i13 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
  i7 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = i7 + (i1 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i9, i2, i6);
  i4 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i2 + 28 >> 2] | 0;
  i8 = HEAP32[gb + 1157724 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i4 << 3) | 0;
  i7 = HEAP32[i8 + 28 >> 2] | 0;
  i1 = HEAP32[i8 + 32 >> 2] | 0;
  i2 = i8;
 }
 i3 = i7 + (i1 << 3) | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else i4 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 if (!i8) {
  i12 = i4;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (HEAP32[i5 + 36 >> 2] | 0) {
  i12 = i4;
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i6 >> 2] = i8;
 if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) i2 = i7; else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i9, i2, i6);
  i3 = HEAP32[i9 >> 2] | 0;
  i7 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i7 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) i12 = 13; else {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i1) i12 = 13;
 }
 if ((i12 | 0) == 13) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 17) | 0;
  HEAP32[i1 >> 2] = 0;
  i12 = i1 + 8 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 2;
  HEAP32[i1 + 20 >> 2] = 3;
  HEAP32[i1 + 24 >> 2] = 1;
  HEAP32[i1 + 28 >> 2] = 1;
  HEAP32[i1 + 32 >> 2] = 1;
  HEAP32[i1 + 36 >> 2] = 1;
  HEAP32[i10 >> 2] = i8;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i9, i1);
 }
 if (HEAP32[i1 >> 2] | 0) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP32[i1 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(i11, i4) | 0;
 HEAP32[i1 + 16 >> 2] = i4;
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function _UNITY_png_format_number(i21, i2, i15, i16) {
 i21 = i21 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i8 = i2 + -1 | 0;
 HEAP8[i8 >> 0] = 0;
 if (i8 >>> 0 <= i21 >>> 0) {
  i21 = i8;
  return i21 | 0;
 }
 i9 = (i15 | 0) == 5;
 i7 = 0;
 i3 = 1;
 i6 = 0;
 i2 = i16;
 i4 = i8;
 L4 : while (1) {
  L6 : do switch (i15 | 0) {
  case 2:
   {
    i18 = 1;
    i19 = 0;
    i20 = i16;
    i10 = i8;
    i17 = 5;
    break L4;
   }
  case 5:
   {
    if (!((i2 | 0) != 0 | (i6 | 0) < (i3 | 0))) {
     i1 = i4;
     i17 = 22;
     break L4;
    }
    i3 = (i2 >>> 0) % 10 | 0;
    i5 = i4 + -1 | 0;
    if (!(i7 | i3)) i3 = i7; else {
     HEAP8[i5 >> 0] = HEAP8[gb + 350460 + i3 >> 0] | 0;
     i3 = 1;
     i4 = i5;
    }
    i2 = (i2 >>> 0) / 10 | 0;
    i5 = 5;
    break;
   }
  default:
   {
    i5 = i3;
    i3 = i6;
    while (1) {
     if (!((i2 | 0) != 0 | (i3 | 0) < (i5 | 0))) {
      i1 = i4;
      i17 = 22;
      break L4;
     }
     switch (i15 | 0) {
     case 3:
      {
       i12 = i5;
       i17 = 14;
       break;
      }
     case 4:
      {
       i12 = 2;
       i17 = 14;
       break;
      }
     case 1:
      {
       i13 = i4 + -1 | 0;
       HEAP8[i13 >> 0] = HEAP8[((i2 >>> 0) % 10 | 0) + (gb + 350460) >> 0] | 0;
       i11 = (i2 >>> 0) / 10 | 0;
       i14 = i5;
       break;
      }
     default:
      {
       i6 = i3;
       i2 = 0;
       i3 = i7;
       break L6;
      }
     }
     if ((i17 | 0) == 14) {
      i17 = 0;
      i13 = i4 + -1 | 0;
      HEAP8[i13 >> 0] = HEAP8[(i2 & 15) + (gb + 350460) >> 0] | 0;
      i11 = i2 >>> 4;
      i14 = i12;
     }
     if (i13 >>> 0 > i21 >>> 0) {
      i5 = i14;
      i3 = i3 + 1 | 0;
      i2 = i11;
      i4 = i13;
     } else {
      i1 = i13;
      i17 = 22;
      break L4;
     }
    }
   }
  } while (0);
  i6 = i6 + 1 | 0;
  do if (i9 & (i6 | 0) == 5 & i4 >>> 0 > i21 >>> 0) {
   if (i3 | 0) {
    i4 = i4 + -1 | 0;
    HEAP8[i4 >> 0] = 46;
    break;
   }
   if (!i2) {
    i4 = i4 + -1 | 0;
    HEAP8[i4 >> 0] = 48;
    i3 = 0;
    i2 = 0;
   } else i3 = 0;
  } while (0);
  if (i4 >>> 0 <= i21 >>> 0) {
   i1 = i4;
   i17 = 22;
   break;
  } else {
   i7 = i3;
   i3 = i5;
  }
 }
 if ((i17 | 0) == 5) {
  while (1) {
   if (!((i20 | 0) != 0 | (i19 | 0) < (i18 | 0))) {
    i1 = i10;
    i17 = 22;
    break;
   }
   i1 = i10 + -1 | 0;
   HEAP8[i1 >> 0] = HEAP8[((i20 >>> 0) % 10 | 0) + (gb + 350460) >> 0] | 0;
   if (i1 >>> 0 > i21 >>> 0) {
    i18 = 2;
    i19 = i19 + 1 | 0;
    i20 = (i20 >>> 0) / 10 | 0;
    i10 = i1;
   } else {
    i17 = 22;
    break;
   }
  }
  if ((i17 | 0) == 22) return i1 | 0;
 } else if ((i17 | 0) == 22) return i1 | 0;
 return 0;
}

function __Z25ExtractAllTerrainsInSceneR13dynamic_arrayIP7TerrainLj4EE(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 8 | 0;
 i15 = i16;
 i14 = i16 + 16 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i11 = i14 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i15);
 i15 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 35740 | 0, i14, 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i15 = i10 + 16 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i15 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i15 >> 2] = i1;
   HEAP32[i10 >> 2] = i9;
  }
  i1 = HEAP32[i11 >> 2] | 0;
 }
 if (i1 | 0) {
  i8 = i10 + 12 | 0;
  i9 = i10 + 4 | 0;
  i7 = 0;
  do {
   i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   i6 = i5;
   if (!(HEAP32[i5 + 8 >> 2] & 1048576)) {
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i15 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i15 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i3;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i6;
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE12__move_rangeEPS1_S6_S6_(i1, i14, i11, i2) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i10 = i1 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i5 = i7 - i2 >> 4;
 i9 = i14 + (i5 << 4) | 0;
 if (i9 >>> 0 < i11 >>> 0) {
  i6 = i12 + 4 | 0;
  i4 = i9;
  i1 = i7;
  do {
   i8 = HEAP8[i4 + 11 >> 0] | 0;
   i2 = i8 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
   i8 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i8 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i13 = 25;
   } else if (i8 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i8;
    if (i8) i13 = 27;
   } else i13 = 25;
   if ((i13 | 0) == 25) {
    i16 = i8 + 16 & -16;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = i16 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = i2;
    i13 = 27;
   }
   if ((i13 | 0) == 27) {
    i13 = 0;
    _memcpy(i1 | 0, i3 | 0, i8 | 0) | 0;
   }
   HEAP8[i1 + i8 >> 0] = 0;
   i4 = i4 + 16 | 0;
   i1 = (HEAP32[i10 >> 2] | 0) + 16 | 0;
   HEAP32[i10 >> 2] = i1;
  } while (i4 >>> 0 < i11 >>> 0);
 }
 if (!i5) {
  STACKTOP = i15;
  return;
 }
 do {
  i5 = i7;
  i7 = i7 + -16 | 0;
  i1 = i9;
  i9 = i9 + -16 | 0;
  do if ((i5 | 0) != (i1 | 0)) {
   i6 = HEAP8[i9 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   i8 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
   i6 = i3 ? HEAP32[i1 + -12 >> 2] | 0 : i6 & 255;
   i3 = i7 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i5 + -8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i6 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i5 + -12 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i5 + -12 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
 } while ((i9 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZN26AnimatorControllerPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 8 | 0;
 i15 = i17;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i17;
  return;
 }
 i8 = HEAP32[i1 + 84 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 100 >> 2] | 0, i8 | 0) | 0;
 i9 = i8 + 12 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i10 = i13 + 12 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13 + 4 | 0;
 i7 = 0;
 do {
  i4 = (HEAP32[i8 >> 2] | 0) + (i7 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i15 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i16 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i1, i15);
     i2 = HEAP32[i14 >> 2] | 0;
     i6 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i16 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i16 = 12;
    }
   }
   if ((i16 | 0) == 10) i16 = 12;
   if ((i16 | 0) == 12) {
    i16 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i2;
    HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i13 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 STACKTOP = i17;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__218__insertion_sort_3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i19, i20, i1) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 20 | 0;
 i22 = i23 + 8 | 0;
 i18 = i23;
 i2 = i19 + 72 | 0;
 __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i19, i19 + 36 | 0, i2, i1) | 0;
 i1 = i19 + 108 | 0;
 if ((i1 | 0) == (i20 | 0)) {
  STACKTOP = i23;
  return;
 }
 i17 = i21 + 8 | 0;
 i14 = i22 + 8 | 0;
 i15 = i21 + 8 | 0;
 i16 = i22 + 8 | 0;
 while (1) {
  __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f24 = Math_fround(HEAPF32[i17 >> 2]);
  __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (f24 > Math_fround(HEAPF32[i14 >> 2])) {
   i8 = HEAP32[i1 >> 2] | 0;
   i9 = HEAP32[i1 + 4 >> 2] | 0;
   i10 = HEAP32[i1 + 8 >> 2] | 0;
   i11 = HEAP32[i1 + 12 >> 2] | 0;
   i12 = HEAP32[i1 + 16 >> 2] | 0;
   i13 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = i1 + 24 | 0;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i18;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = HEAP32[i1 + 32 >> 2] | 0;
   i6 = i7 + 28 | 0;
   i3 = i1;
   while (1) {
    i4 = i2;
    i5 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    if ((i2 | 0) == (i19 | 0)) {
     i2 = i19;
     break;
    }
    __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
    f24 = Math_fround(HEAPF32[i15 >> 2]);
    __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f24 > Math_fround(HEAPF32[i16 >> 2])) {
     i3 = i2;
     i2 = i2 + -36 | 0;
    } else break;
   }
   HEAP32[i2 >> 2] = i8;
   HEAP32[i2 + 4 >> 2] = i9;
   HEAP32[i2 + 8 >> 2] = i10;
   HEAP32[i2 + 12 >> 2] = i11;
   HEAP32[i2 + 16 >> 2] = i12;
   HEAP32[i2 + 20 >> 2] = i13;
   i11 = i18;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i2 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i2 + 32 >> 2] = i7;
  }
  i2 = i1 + 36 | 0;
  if ((i2 | 0) == (i20 | 0)) break; else {
   i13 = i1;
   i1 = i2;
   i2 = i13;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZN7mecanim4hand12HandCopyAxesEPKNS0_4HandEPKNS_8skeleton8SkeletonES3_PS5_(i10, i2, i11, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i12 = i2 + 4 | 0;
 i13 = i12;
 i14 = i1 + 4 | 0;
 i15 = i14;
 i8 = i1 + 16 | 0;
 i9 = i8;
 i6 = i2 + 16 | 0;
 i7 = i6;
 i5 = 0;
 do {
  i1 = HEAP32[i10 + (i5 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) i1 = (HEAP32[i12 >> 2] | 0) + i13 + (i1 << 3) | 0; else i1 = 0;
  i2 = HEAP32[i11 + (i5 << 2) >> 2] | 0;
  if ((i2 | 0) > -1) {
   i3 = (HEAP32[i14 >> 2] | 0) + i15 | 0;
   if ((i1 | 0) != 0 & (i3 + (i2 << 3) | 0) != 0) {
    i4 = HEAP32[i1 + 4 >> 2] | 0;
    if ((i4 | 0) != -1) {
     i1 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
     if ((i1 | 0) != -1) {
      i3 = (HEAP32[i8 >> 2] | 0) + i9 | 0;
      i2 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
      i17 = HEAP32[i2 + (i4 * 76 | 0) + 4 >> 2] | 0;
      i16 = HEAP32[i2 + (i4 * 76 | 0) + 8 >> 2] | 0;
      i18 = HEAP32[i2 + (i4 * 76 | 0) + 12 >> 2] | 0;
      HEAP32[i3 + (i1 * 76 | 0) >> 2] = HEAP32[i2 + (i4 * 76 | 0) >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 4 >> 2] = i17;
      HEAP32[i3 + (i1 * 76 | 0) + 8 >> 2] = i16;
      HEAP32[i3 + (i1 * 76 | 0) + 12 >> 2] = i18;
      i18 = HEAP32[i2 + (i4 * 76 | 0) + 20 >> 2] | 0;
      i16 = HEAP32[i2 + (i4 * 76 | 0) + 24 >> 2] | 0;
      i17 = HEAP32[i2 + (i4 * 76 | 0) + 28 >> 2] | 0;
      HEAP32[i3 + (i1 * 76 | 0) + 16 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 16 >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 20 >> 2] = i18;
      HEAP32[i3 + (i1 * 76 | 0) + 24 >> 2] = i16;
      HEAP32[i3 + (i1 * 76 | 0) + 28 >> 2] = i17;
      i17 = HEAP32[i2 + (i4 * 76 | 0) + 36 >> 2] | 0;
      i16 = HEAP32[i2 + (i4 * 76 | 0) + 40 >> 2] | 0;
      HEAP32[i3 + (i1 * 76 | 0) + 32 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 32 >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 36 >> 2] = i17;
      HEAP32[i3 + (i1 * 76 | 0) + 40 >> 2] = i16;
      i16 = HEAP32[i2 + (i4 * 76 | 0) + 48 >> 2] | 0;
      i17 = HEAP32[i2 + (i4 * 76 | 0) + 52 >> 2] | 0;
      HEAP32[i3 + (i1 * 76 | 0) + 44 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 44 >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 48 >> 2] = i16;
      HEAP32[i3 + (i1 * 76 | 0) + 52 >> 2] = i17;
      i17 = HEAP32[i2 + (i4 * 76 | 0) + 60 >> 2] | 0;
      i16 = HEAP32[i2 + (i4 * 76 | 0) + 64 >> 2] | 0;
      HEAP32[i3 + (i1 * 76 | 0) + 56 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 56 >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 60 >> 2] = i17;
      HEAP32[i3 + (i1 * 76 | 0) + 64 >> 2] = i16;
      HEAP32[i3 + (i1 * 76 | 0) + 68 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 68 >> 2];
      HEAP32[i3 + (i1 * 76 | 0) + 72 >> 2] = HEAP32[i2 + (i4 * 76 | 0) + 72 >> 2];
     }
    }
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 15);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j(i10, i4, i1, i3) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i7 = i11;
 i5 = i1;
 i6 = i4;
 i2 = (HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0) >>> 0 < (HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0) >>> 0;
 i12 = i2 ? i1 : i4;
 i2 = i2 ? i4 : i1;
 i1 = HEAP32[i12 + 8 >> 2] | 0;
 i13 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i13 + (HEAP32[i1 + 28 >> 2] << 2) | 0;
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i12;
 i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i8) | 0;
 L1 : do if (!i1) i9 = 5; else {
  while (1) {
   if ((HEAP32[i1 + 24 >> 2] | 0) == (i2 | 0)) break;
   if ((HEAP32[i1 + 28 >> 2] | 0) == (i2 | 0)) break;
   i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i8) | 0;
   if (!i1) {
    i9 = 5;
    break L1;
   }
  }
  __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i10, i1 + -8 | 0, 4, i3, 1);
 } while (0);
 i2 = 0 == 0 ? (HEAP32[i4 + 12 >> 2] & -1073741824 | 0) == -2147483648 : 0;
 i1 = i2 ? i6 : i5;
 i2 = i2 ? i5 : i6;
 if (!(0 == 0 ? (HEAP32[i1 + 12 >> 2] & -1073741824 | 0) == -2147483648 : 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(0 == 0 ? (HEAP32[i2 + 12 >> 2] & -1073741824 | 0) == 0 : 0)) {
  STACKTOP = i11;
  return;
 }
 i13 = i2;
 i3 = __ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN5physx2Sc8ClothSim20removeCollisionShapeEPKNS0_8ShapeSimE(i3, i13);
 HEAP32[i7 >> 2] = i13;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb(i10 + 2512 | 0, i7, i8) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  i13 = i1 + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i13;
 } else i1 = i1 + 4 | 0;
 while (1) {
  i2 = i1 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) break;
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i9 = 15;
   break;
  }
 }
 if ((i9 | 0) == 15) {
  HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
  i13 = i10 + 2496 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  i13 = i10 + 2508 | 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i1;
  i1 = i10 + 2500 | 0;
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i13 + 1;
  if ((i13 | 0) >= ((HEAP32[i10 + 2492 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i10 + 2216 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN16MeshSkinningData16GetSkinInfluenceEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i6 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i6) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = HEAP32[i5 + 20 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   i3 = i5 + 60 | 0;
   i4 = i5 + 72 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    return i7 | 0;
   }
   HEAP32[i4 >> 2] = i6;
   i1 = i5 + 76 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i1 >> 2] = i6;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i6 << 2, 4, i5 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i3 >> 2] = i2;
    break;
   } else {
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i5 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i1 >> 2] = i6;
    HEAP32[i3 >> 2] = i2;
    break;
   } else i2 = HEAP32[i3 >> 2] | 0; while (0);
   if ((i6 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i7 + (i1 << 5) + 16 >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   i7 = i2;
   return i7 | 0;
  }
 case 2:
  {
   i1 = i5 + 40 | 0;
   i2 = i5 + 52 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i7 = HEAP32[i1 >> 2] | 0;
    return i7 | 0;
   }
   HEAP32[i2 >> 2] = i6;
   i3 = i5 + 56 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i6;
    i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 << 4, 16, i5 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i1 >> 2] = i2;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i5 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
    HEAP32[i3 >> 2] = i6;
    HEAP32[i1 >> 2] = i5;
    i2 = i5;
    break;
   } else i2 = HEAP32[i1 >> 2] | 0; while (0);
   if ((i6 | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i2 + (i1 << 4) + 8 >> 2] = HEAP32[i7 + (i1 << 5) + 16 >> 2];
     HEAP32[i2 + (i1 << 4) + 12 >> 2] = HEAP32[i7 + (i1 << 5) + 20 >> 2];
     f9 = Math_fround(HEAPF32[i7 + (i1 << 5) >> 2]);
     i5 = i7 + (i1 << 5) + 4 | 0;
     f8 = Math_fround(Math_fround(1.0) / Math_fround(f9 + Math_fround(HEAPF32[i5 >> 2])));
     HEAPF32[i2 + (i1 << 4) >> 2] = Math_fround(f9 * f8);
     HEAPF32[i2 + (i1 << 4) + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f8);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
   }
   i7 = i2;
   return i7 | 0;
  }
 case 4:
  return i7 | 0;
 default:
  {
   i7 = 0;
   return i7 | 0;
  }
 }
 return 0;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 24) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 24 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i8 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i2 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 do {
  f22 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 28 >> 2]);
  f15 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 32 >> 2]);
  f22 = Math_fround(f3 * f22);
  f15 = Math_fround(f4 * f15);
  f19 = Math_fround(f5 * Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 36 >> 2]));
  f12 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 16 >> 2]);
  f18 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 12 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 24 >> 2]);
  f23 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 20 >> 2]);
  f24 = Math_fround(f12 * Math_fround(-2.0));
  f16 = Math_fround(f12 * Math_fround(2.0));
  f21 = Math_fround(f24 * f10);
  f14 = Math_fround(f23 * Math_fround(2.0));
  f20 = Math_fround(f23 * Math_fround(-2.0));
  f25 = Math_fround(f10 * f20);
  f17 = Math_fround(f18 * Math_fround(-2.0));
  f11 = Math_fround(f18 * Math_fround(2.0));
  f10 = Math_fround(f10 * f17);
  f13 = Math_fround(Math_fround(f22 + Math_fround(f22 * Math_fround(Math_fround(f12 * f24) - Math_fround(f23 * f14)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f11 * f23) - f21)) + Math_fround(f15 * Math_fround(f25 - Math_fround(f12 * f17)))));
  f11 = Math_fround(Math_fround(f15 + Math_fround(f22 * Math_fround(Math_fround(f18 * f16) - f25))) + Math_fround(Math_fround(f19 * Math_fround(f10 - Math_fround(f24 * f23))) + Math_fround(f15 * Math_fround(Math_fround(f23 * f20) - Math_fround(f18 * f11)))));
  f10 = Math_fround(Math_fround(f19 + Math_fround(f22 * Math_fround(f21 - Math_fround(f18 * f20)))) + Math_fround(Math_fround(f19 * Math_fround(Math_fround(f18 * f17) - Math_fround(f12 * f16))) + Math_fround(f15 * Math_fround(Math_fround(f12 * f14) - f10))));
  f14 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) >> 2]);
  f12 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 4 >> 2]);
  f3 = Math_fround(f14 + f13);
  f4 = Math_fround(f12 + f11);
  f5 = Math_fround(Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 8 >> 2]) + f10);
  i1 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i9 >> 2] = f3;
 HEAPF32[i2 >> 2] = f4;
 HEAPF32[i6 >> 2] = f5;
 return;
}

function __ZN22RenderingCommandBuffer11AddDrawMeshERK10Matrix4x4fP4MeshP8MaterialiiP19ShaderPropertySheet(i17, i2, i11, i12, i13, i14, i1) {
 i17 = i17 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 if (!i1) i6 = -1; else {
  i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 423766 | 0, 97) | 0;
  __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i3, i17 + 8 | 0, i1);
  i4 = i17 + 40 | 0;
  i5 = i17 + 52 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i8 = i17 + 56 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 2, 4, i17 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i17 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i15 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = i15;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i7;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
 }
 i4 = i16;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 if (!i11) i15 = 0; else i15 = HEAP32[i11 + 4 >> 2] | 0;
 if (!i12) i11 = 0; else i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i13 & 65535;
 i9 = i14 & 65535;
 i7 = i17 + 8 | 0;
 i8 = i17 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i17 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i17 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 1;
 i4 = i4 + 7 & -4;
 i5 = i4 + 92 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i1 = i1 + i4 | 0;
 i4 = i1;
 i2 = i16;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 HEAP32[i1 + 64 >> 2] = i15;
 HEAP32[i1 + 68 >> 2] = i11;
 HEAP16[i1 + 72 >> 1] = i10;
 HEAP16[i1 + 74 >> 1] = i9;
 HEAP32[i1 + 76 >> 2] = i6;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 i17 = i17 + 32 | 0;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 STACKTOP = i18;
 return;
}

function __ZN14HeightMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i11) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i11 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i11 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 * 12 | 0) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 60 | 0, i11);
 i4 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i7 + 40 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i10 << 5) | 0;
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN16HeightMeshBVNode8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i12;
 return;
}

function __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 296 | 0;
 i4 = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 32 >> 2] = Math_fround(1.0);
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 52 >> 2] = Math_fround(1.0);
 i1 = i4 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 i1 = i4 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 92 >> 2] = Math_fround(1.0);
 i1 = i4 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 112 >> 2] = Math_fround(1.0);
 i1 = i4 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 132 >> 2] = Math_fround(1.0);
 i1 = i4 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 152 >> 2] = Math_fround(1.0);
 i1 = i4 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 172 >> 2] = Math_fround(1.0);
 i1 = i4 + 176 | 0;
 i2 = i4 + 249 | 0;
 i5 = i1;
 i7 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i4 + 292 | 0;
 i5 = i4 + 252 | 0;
 i7 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i4 + 293 >> 0] = 0;
 i9 = HEAP32[i9 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i9, HEAP32[i8 + 4 >> 2] | 0, gb + 1034552 | 0, i4, HEAP32[i8 + 24 >> 2] | 0);
 __ZN8GUIStyle8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i9);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i9);
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i9 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i3);
 STACKTOP = i6;
 return;
}

function __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb(i11, i3, i18, i19, i20, i15, i4) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i12 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 i16 = i18 + 4 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i11, i3, i18, i17);
 i13 = i18 + 56 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i14 = i18 + 60 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if (i4) {
  HEAP32[i1 + (i17 << 2) >> 2] = i15;
  HEAP32[i2 + (i17 << 2) >> 2] = i15;
 } else {
  i10 = HEAP32[(HEAP32[i11 + 60 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i9 = HEAP32[(HEAP32[i11 + 56 >> 2] | 0) + (i3 << 2) >> 2] | i10 & i15;
  HEAP32[i1 + (i17 << 2) >> 2] = i9;
  HEAP32[i2 + (i17 << 2) >> 2] = i10;
  i10 = i18 + 36 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i9;
 }
 i10 = i11 + 68 | 0;
 i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 i9 = i18 + 68 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) + (i17 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i12 >>> 0 > 1) {
  i6 = i11 + 60 | 0;
  i7 = i11 + 56 | 0;
  i8 = i18 + 36 | 0;
  if (i4) {
   i4 = 1;
   while (1) {
    __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i11, i3, i18, i2);
    HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = i15;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i15;
    i4 = i4 + 1 | 0;
    i1 = (HEAP32[i9 >> 2] | 0) + (i2 << 2) | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    if ((i4 | 0) == (i12 | 0)) {
     i3 = i2;
     i2 = i5;
     break;
    } else {
     i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     i2 = i5;
    }
   }
  } else {
   i4 = 1;
   while (1) {
    __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i11, i3, i18, i2);
    i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | i5 & i15;
    HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] = i5;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i1;
    i4 = i4 + 1 | 0;
    i1 = (HEAP32[i9 >> 2] | 0) + (i2 << 2) | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    if ((i4 | 0) == (i12 | 0)) {
     i3 = i2;
     i2 = i5;
     break;
    } else {
     i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     i2 = i5;
    }
   }
  }
 } else i3 = i17;
 HEAP32[i16 >> 2] = i2;
 if ((i2 | 0) == -1) {
  HEAP32[i1 >> 2] = -1;
  HEAP32[i19 >> 2] = i17;
  HEAP32[i20 >> 2] = i3;
  return;
 }
 HEAP32[(HEAP32[i18 + 72 >> 2] | 0) + (i2 << 2) >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i19 >> 2] = i17;
 HEAP32[i20 >> 2] = i3;
 return;
}

function __ZN7mecanim4hand8HandPose8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899224 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i5, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = 20;
 HEAP32[i6 + 4 >> 2] = i1 + 40;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899201 | 0, HEAP32[gb + 37256 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 12 | 0, 0);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i3 + 8 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899232 | 0, i6, i1 + 120 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899243 | 0, i6, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899255 | 0, i6, i1 + 128 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899263 | 0, i6, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx16PxsFluidDynamics12updatePacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i16, i17, i18, i19, i4, i13, i12, i14) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, f20 = f0;
 i11 = i4 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i15 = i4 + 8 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 if (!((i17 | 0) != 0 | (i10 | 0) == 0)) {
  i2 = HEAP32[i16 >> 2] | 0;
  i3 = 0;
  do {
   i9 = i3 + i5 | 0;
   HEAP32[i19 + (i9 << 5) + 12 >> 2] = i2;
   HEAP32[i18 + (i9 * 12 | 0) >> 2] = 0;
   HEAP32[i18 + (i9 * 12 | 0) + 4 >> 2] = 0;
   HEAP32[i18 + (i9 * 12 | 0) + 8 >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i10 | 0));
 }
 if (i10 >>> 0 < 101 ? (HEAP32[i12 + 784 >> 2] | 0) >>> 0 < 101 : 0) {
  i9 = i19 + (i5 << 5) | 0;
  i4 = i18 + (i5 * 12 | 0) | 0;
  if (i10 >>> 0 > 1) {
   i5 = i14 + 36 | 0;
   i6 = (i17 | 0) == 0;
   i7 = i14 + 28 | 0;
   i8 = i14 + 32 | 0;
   i2 = i10;
   i3 = 1;
   do {
    i10 = HEAP32[i5 >> 2] | 0;
    __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i4, i4, i9, i9, i10 + (i3 + -1 << 2) | 0, 1, i10 + (i3 << 2) | 0, i2 - i3 | 0, 1, i6, i16, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0);
    i3 = i3 + 1 | 0;
    i2 = HEAP32[i15 >> 2] | 0;
   } while (i2 >>> 0 > i3 >>> 0);
  }
  __ZN5physx16PxsFluidDynamics29updateParticlesBruteForceHaloENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i16, i17, i18, i19, i13, i12, i14);
 } else __ZN5physx16PxsFluidDynamics21updatePacketLocalHashENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i16, i17, i18, i19, i4, i13, i12, i14);
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if ((i17 | 0) != 1 | (i3 | 0) == 0) return;
 f1 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 i2 = 0;
 do {
  i17 = i2 + i4 | 0;
  f20 = Math_fround(f1 * Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i19 + (i17 << 5) + 12 >> 2])));
  i16 = i18 + (i17 * 12 | 0) | 0;
  HEAPF32[i16 >> 2] = Math_fround(Math_fround(HEAPF32[i16 >> 2]) * f20);
  i16 = i18 + (i17 * 12 | 0) + 4 | 0;
  HEAPF32[i16 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i16 >> 2]));
  i17 = i18 + (i17 * 12 | 0) + 8 | 0;
  HEAPF32[i17 >> 2] = Math_fround(f20 * Math_fround(HEAPF32[i17 >> 2]));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN9JSONWrite8TransferINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i5 = i11 + 56 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i5 >> 2] = i14;
 i4 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 i1 = i4;
 while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
 i2 = i1 - i4 | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 if (i2 >>> 0 < 12) {
  HEAP32[i3 >> 2] = 7340037;
  HEAP8[i14 + 11 >> 0] = 11 - i2;
  i1 = i14;
 } else {
  HEAP32[i3 >> 2] = 3145733;
  HEAP32[i14 + 4 >> 2] = i2;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i14 >> 2] = i1;
 }
 _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 if (HEAP32[i5 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i6, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i5 >> 2] = i6;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i13, i1, i3, i4, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i1 = i12;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i13, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = 530;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? i1 : i10;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = i13; else {
  i9 = i13 + 24 | 0;
  i8 = i3 + 8 | 0;
  i6 = i13 + 36 | 0;
  i7 = i13 + 20 | 0;
  i5 = i4;
  do {
   __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i13, i1);
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_(i13, i11) | 0) {
    f14 = Math_fround(HEAPF32[i11 >> 2]);
    mftCall_viif(HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, i1 | 0, +f14);
   }
   i2 = HEAP32[i13 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) HEAP8[i6 >> 0] = 1; else {
    i3 = i1 + -1 | 0;
    i4 = HEAP32[i2 + 4 >> 2] | 0;
    if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
     i1 = HEAP32[i7 >> 2] | 0;
     mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
     i1 = HEAP32[i13 >> 2] | 0;
     i2 = i1;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    }
    HEAP32[i2 + 8 >> 2] = i1 + -1;
    i1 = HEAP32[i13 >> 2] | 0;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    HEAP8[i6 >> 0] = 1;
    if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i6 >> 0] = 0;
   }
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i5 = i5 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i5 = i13;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i13 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i13 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i13 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i12 = i10 + 24 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i9 + 8 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i7 = i9 + 12 | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 24 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i9 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 32 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
}

function __ZN14dtNavMeshQuery29finalizeSlicedFindPathPartialEPiPKyi(i15, i16, i12, i2) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i17 = 0;
 HEAP32[i16 >> 2] = 0;
 if (!i2) {
  i16 = -2147483648;
  return i16 | 0;
 }
 i1 = i15 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) < 0) {
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i16 = -2147483648;
  return i16 | 0;
 }
 i11 = i15 + 24 | 0;
 i14 = i15 + 32 | 0;
 if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i14 >> 2] | 0) ? (HEAP32[i11 + 4 >> 2] | 0) == (HEAP32[i14 + 4 >> 2] | 0) : 0) {
  i2 = 1;
  i1 = i3;
 } else {
  if ((i2 | 0) <= 0) {
   i16 = -2147483648;
   return i16 | 0;
  }
  i14 = i15 + 76 | 0;
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = (HEAP32[i8 + 16 >> 2] | 0) + -1 | 0;
  i10 = HEAP32[i8 + 4 >> 2] | 0;
  i11 = i8 + 8 | 0;
  L13 : while (1) {
   i7 = i2;
   i2 = i2 + -1 | 0;
   i5 = i12 + (i2 << 3) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = _bitshift64Shl(i4 | 0, i5 | 0, 18) | 0;
   i3 = _i64Add(i3 | 0, getTempRet0() | 0, ~i4 | 0, ~i5 | 0) | 0;
   i17 = getTempRet0() | 0;
   i6 = _bitshift64Lshr(i3 | 0, i17 | 0, 31) | 0;
   i17 = ___muldi3(i6 ^ i3 | 0, (getTempRet0() | 0) ^ i17 | 0, 21, 0) | 0;
   i3 = getTempRet0() | 0;
   i6 = _bitshift64Lshr(i17 | 0, i3 | 0, 11) | 0;
   i3 = ___muldi3(i6 ^ i17 | 0, (getTempRet0() | 0) ^ i3 | 0, 65, 0) | 0;
   i17 = getTempRet0() | 0;
   i6 = _bitshift64Lshr(i3 | 0, i17 | 0, 22) | 0;
   (getTempRet0() | 0) ^ i17;
   i3 = HEAP16[i10 + (((i6 ^ i3) & i9) << 1) >> 1] | 0;
   L15 : do if (i3 << 16 >> 16 != -1) {
    i6 = HEAP32[i8 >> 2] | 0;
    i3 = i3 & 65535;
    while (1) {
     i17 = i6 + (i3 << 5) + 24 | 0;
     if ((HEAP32[i17 >> 2] | 0) == (i4 | 0) ? (HEAP32[i17 + 4 >> 2] | 0) == (i5 | 0) : 0) break;
     i3 = HEAP16[(HEAP32[i11 >> 2] | 0) + (i3 << 1) >> 1] | 0;
     if (i3 << 16 >> 16 == -1) break L15; else i3 = i3 & 65535;
    }
    i6 = i6 + (i3 << 5) | 0;
    if (i6 | 0) break L13;
   } while (0);
   if ((i7 | 0) <= 1) {
    i1 = -2147483648;
    i13 = 21;
    break;
   }
  }
  if ((i13 | 0) == 21) return i1 | 0;
  i2 = 0;
  i5 = 0;
  while (1) {
   i7 = i6 + 20 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i3 = i8 & 1073741823;
   if (!i3) i4 = 0; else i4 = (HEAP32[HEAP32[i14 >> 2] >> 2] | 0) + (i3 + -1 << 5) | 0;
   if (!i5) i3 = 0; else i3 = (i5 - (HEAP32[HEAP32[i14 >> 2] >> 2] | 0) >> 5) + 1 | 0;
   HEAP32[i7 >> 2] = i8 & -1073741824 | i3 & 1073741823;
   i2 = i2 + 1 | 0;
   if (!i4) break; else {
    i5 = i6;
    i6 = i4;
   }
  }
  HEAP32[i15 + 16 >> 2] = i6;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i16 >> 2] = i2;
 i17 = i1 & 16777215 | 1073741824;
 return i17 | 0;
}

function __ZN20UnityConnectSettingsD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 189132 + 8;
 i2 = i5 + 164 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i5 + 168 | 0;
 if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) do {
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
 i1 = i5 + 216 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i5 + 228 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
 }
 i1 = i5 + 200 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i5 + 212 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
 }
 i1 = i5 + 180 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i5 + 192 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 176 >> 2] | 0;
  HEAP32[i6 >> 2] = 5;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 HEAP32[i5 + 112 >> 2] = gb + 189284 + 8;
 i1 = i5 + 148 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 160 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 132 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 144 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 HEAP32[i5 + 68 >> 2] = gb + 189312 + 8;
 i1 = i5 + 96 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 108 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  i6 = i5 + 28 | 0;
  __ZN22CrashReportingSettingsD2Ev(i6);
  HEAP32[i5 >> 2] = gb + 28648 + 8;
  HEAP32[i5 >> 2] = gb + 28496 + 8;
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 + 92 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 i6 = i5 + 28 | 0;
 __ZN22CrashReportingSettingsD2Ev(i6);
 HEAP32[i5 >> 2] = gb + 28648 + 8;
 HEAP32[i5 >> 2] = gb + 28496 + 8;
 STACKTOP = i7;
 return;
}

function __Z25GetClassFromScriptClassIdRK8UnityStr(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 80 | 0;
 i5 = i10 + 64 | 0;
 i6 = i10 + 32 | 0;
 i7 = i10 + 16 | 0;
 i8 = i10 + 48 | 0;
 i9 = i10;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i3 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __Z26GetScriptClassIdComponentsRK8UnityStrRS_S2_S2_(i1, i5, i6, i7);
 i1 = i5 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i11 = i3 ? HEAP32[i5 >> 2] | 0 : i5;
 i2 = i3 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i11, i2);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 457511 | 0, 3);
 __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i4, i9);
 i2 = i6 + 11 | 0;
 i11 = i7 + 11 | 0;
 i3 = __Z29scripting_class_from_fullnamePKcS0_S0_((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if ((HEAP8[i11 >> 0] | 0) < 0) {
  i11 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
 }
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i11 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
 }
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i11 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
 }
 i11 = i3;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN18AsyncUploadManager17ScheduleAsyncReadEP10AtomicNodeP16AsyncReadCommand(i12, i13, i14) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0;
 if (i14 | 0) {
  i15 = HEAP32[i13 + 4 >> 2] | 0;
  i9 = Math_imul(HEAP32[i15 + 32 >> 2] | 0, HEAP32[i15 + 24 >> 2] | 0) | 0;
  i10 = i15 + 60 | 0;
  i1 = (__Z19GetBytesForOnePixel13TextureFormat(HEAP32[i10 >> 2] | 0) | 0) + i9 | 0;
  i11 = i15 + 64 | 0;
  if (!(HEAP32[i11 >> 2] & 536870912)) i8 = 0; else {
   i8 = (Math_imul(HEAP32[i15 + 120 >> 2] | 0, HEAP32[i15 + 108 >> 2] | 0) | 0) + i1 | 0;
   i8 = i8 + (__Z19GetBytesForOnePixel13TextureFormat(HEAP32[i15 + 124 >> 2] | 0) | 0) | 0;
   i1 = (Math_imul(HEAP32[i15 + 92 >> 2] | 0, HEAP32[i15 + 80 >> 2] | 0) | 0) + i8 | 0;
   i1 = i1 + (__Z19GetBytesForOnePixel13TextureFormat(HEAP32[i15 + 96 >> 2] | 0) | 0) | 0;
  }
  i4 = i1 + 3 & -4;
  if (i4 >>> 0 >= (HEAP32[i12 + 12 >> 2] | 0) >>> 0) HEAP32[i12 + 16 >> 2] = i4;
  i5 = HEAP32[i12 + 1324 >> 2] | 0;
  i6 = i5 + 24 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  i7 = i5 + 28 | 0;
  i2 = i1 >>> 0 > i3 >>> 0;
  if ((HEAP32[i7 >> 2] | 0) == 1) {
   i1 = i2 ? i1 + ~i3 | 0 : 0;
   i2 = i3;
  } else if (i2) {
   i1 = 0;
   i2 = i3;
  } else {
   i2 = HEAP32[i5 + 16 >> 2] | 0;
   i16 = i2 - i3 | 0;
   i1 = i1 >>> 0 < i3 >>> 0 ? i1 : i2;
   i2 = i16 >>> 0 >= i4 >>> 0 | i1 >>> 0 < i4 >>> 0;
   i1 = i2 ? i16 : i1;
   i2 = i2 ? i3 : 0;
  }
  i1 = i1 >>> 0 > i4 >>> 0 ? i4 : i1;
  i3 = (HEAP32[i5 >> 2] | 0) + i2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   if (!i2) if (HEAP32[i6 >> 2] | 0) {
    HEAP32[i5 + 32 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   }
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
   if (i3 | 0) {
    HEAP32[i15 + 144 >> 2] = i4;
    i1 = i15 + 68 | 0;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i14 + 12 >> 2] = i3;
    if (HEAP32[i11 >> 2] & 536870912 | 0) {
     HEAP32[i15 + 104 >> 2] = i3 + i9 + (__Z19GetBytesForOnePixel13TextureFormat(HEAP32[i10 >> 2] | 0) | 0);
     HEAP32[i15 + 76 >> 2] = (HEAP32[i1 >> 2] | 0) + i8;
    }
    HEAP32[i14 + 16 >> 2] = i9;
    HEAP32[i14 + 20 >> 2] = HEAP32[i15 + 136 >> 2];
    i1 = i15 + 156 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i14, i1) | 0;
    HEAP32[i14 + 32 >> 2] = i15;
    __Z16AsyncReadRequestP16AsyncReadCommand(i14);
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
    i16 = HEAP32[i12 + 1328 >> 2] | 0;
    HEAP32[i13 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i16 >> 2] = i13;
    i16 = 1;
    return i16 | 0;
   }
  }
 }
 HEAP32[i12 + 40 >> 2] = i13;
 i16 = 0;
 return i16 | 0;
}

function __ZN15QualitySettings10SetCurrentENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i14, i9, i15) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 4 | 0;
 i1 = i16;
 if ((HEAP16[gb + 1158292 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158292 | 0, i12);
  i13 = gb + 1158292 | 0;
 } else i13 = 0;
 i10 = HEAP32[i14 + 32 >> 2] | 0;
 i11 = HEAP32[i14 + 28 >> 2] | 0;
 i7 = i11;
 L4 : do if ((i10 | 0) == (i11 | 0)) i1 = 0; else {
  i8 = HEAP8[i9 + 11 >> 0] | 0;
  i6 = i8 << 24 >> 24 < 0;
  i8 = i6 ? HEAP32[i9 + 4 >> 2] | 0 : i8 & 255;
  L6 : do if (i6) {
   i6 = (i10 - i11 | 0) / 108 | 0;
   i1 = 0;
   while (1) {
    i3 = i7 + (i1 * 108 | 0) | 0;
    i5 = HEAP8[i3 + 11 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    if (i2) i4 = HEAP32[i7 + (i1 * 108 | 0) + 4 >> 2] | 0; else i4 = i5 & 255;
    if ((i4 | 0) == (i8 | 0)) {
     if (i2) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i7 + (i1 * 108 | 0) + 4 >> 2] | 0;
     } else i2 = i5 & 255;
     if (!(_strncmp(i3, HEAP32[i9 >> 2] | 0, i2) | 0)) break L6;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = 0;
     break L4;
    }
   }
  } else {
   i6 = (i10 - i11 | 0) / 108 | 0;
   i1 = 0;
   while (1) {
    i3 = i7 + (i1 * 108 | 0) | 0;
    i5 = HEAP8[i3 + 11 >> 0] | 0;
    i2 = i5 << 24 >> 24 < 0;
    if (i2) i4 = HEAP32[i7 + (i1 * 108 | 0) + 4 >> 2] | 0; else i4 = i5 & 255;
    if ((i4 | 0) == (i8 | 0)) {
     if (i2) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i7 + (i1 * 108 | 0) + 4 >> 2] | 0;
     } else i2 = i5 & 255;
     if (!(_strncmp(i3, i9, i2) | 0)) break L6;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = 0;
     break L4;
    }
   }
  } while (0);
  i9 = ((i10 - i11 | 0) / 108 | 0) + -1 | 0;
  i10 = i14 + 44 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = (i1 | 0) < 0 ? 0 : (i9 | 0) < (i1 | 0) ? i9 : i1;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, gb + 405977 | 0, 20);
  __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i12, HEAP32[i10 >> 2] | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  __ZN15QualitySettings13ApplySettingsEib(i14, i11, i15);
  i1 = 1;
 } while (0);
 if (!i13) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReport7onEventEjPj(i1, i29, i28) {
 i1 = i1 | 0;
 i29 = i29 | 0;
 i28 = i28 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i30 = 0, i31 = 0, f32 = f0;
 i31 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i27 = i31 + 48 | 0;
 i30 = i31;
 i6 = i31 + 84 | 0;
 if (!i29) {
  STACKTOP = i31;
  return 1;
 }
 i17 = i1 + 4 | 0;
 i20 = i1 + 8 | 0;
 i21 = i30 + 4 | 0;
 i22 = i30 + 8 | 0;
 i23 = i30 + 12 | 0;
 i24 = i30 + 16 | 0;
 i25 = i30 + 40 | 0;
 i26 = i1 + 20 | 0;
 i7 = i1 + 80 | 0;
 i8 = i1 + 92 | 0;
 i9 = i1 + 96 | 0;
 i10 = i1 + 98 | 0;
 i11 = i1 + 12 | 0;
 i12 = i30 + 16 | 0;
 i13 = i30 + 20 | 0;
 i14 = i30 + 24 | 0;
 i15 = i30 + 28 | 0;
 i16 = i30 + 32 | 0;
 i18 = i30 + 36 | 0;
 i19 = i30 + 44 | 0;
 i1 = i1 + 16 | 0;
 i5 = 0;
 do {
  i2 = HEAP32[i28 + (i5 << 2) >> 2] | 0;
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i17 >> 2] | 0, HEAP32[i20 >> 2] | 0, i27, 0, 0, i2, 1, 1) | 0;
  HEAP32[i30 >> 2] = 0;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i22 >> 2] = -1;
  HEAP16[i23 >> 1] = 0;
  HEAP32[i24 >> 2] = 0;
  HEAP32[i24 + 4 >> 2] = 0;
  HEAP32[i24 + 8 >> 2] = 0;
  HEAP32[i24 + 12 >> 2] = 0;
  HEAP32[i24 + 16 >> 2] = 0;
  HEAP32[i24 + 20 >> 2] = 0;
  HEAPF32[i25 >> 2] = Math_fround(3402823469999999843913219.0e14);
  f32 = Math_fround(HEAPF32[i8 >> 2]);
  HEAP16[i6 >> 1] = HEAP16[i9 >> 1] | 0;
  if (__ZL19sweepBoxVsTrianglesjPKN5physx10PxTriangleERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEbPKj(1, i27, i26, i7, f32, i30, i6, (HEAP8[i10 >> 0] | 0) != 0, 0) | 0) {
   f32 = Math_fround(HEAPF32[i25 >> 2]);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = i3 + 40 | 0;
   if (f32 < Math_fround(HEAPF32[i4 >> 2])) {
    HEAP32[i3 >> 2] = HEAP32[i30 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i30 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i30 + 8 >> 2];
    HEAP16[i3 + 12 >> 1] = HEAP16[i23 >> 1] | 0;
    HEAP32[i3 + 16 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i3 + 32 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i3 + 36 >> 2] = HEAP32[i18 >> 2];
    HEAP32[i4 >> 2] = HEAP32[i25 >> 2];
    HEAP32[i3 + 44 >> 2] = HEAP32[i19 >> 2];
    HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] = i2;
    HEAP8[i1 >> 0] = 1;
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i29 | 0));
 STACKTOP = i31;
 return 1;
}

function __ZN8UVModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 272 | 0, i7);
 i1 = i6 + 536 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 540 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 544 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 548 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 552 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 560 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 564 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 568 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 556 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN5audio5mixer16SnapshotConstant8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 863350 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i7 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 8;
 HEAP32[i8 + 4 >> 2] = i5 + 4;
 HEAP32[i8 + 8 >> 2] = i4;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041262 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i7, i8, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 20;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 863359 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 24;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 863375 | 0, i4, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i8, 0); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i9;
 return;
}

function __ZN16LightmapSettings20DidChangeActiveSceneEP10UnitySceneS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 i1 = __ZNK10UnityScene19GetLevelGameManagerEi(i1, 26) | 0;
 if (!i1) i3 = 4; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30672 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30672 + 28 >> 2] | 0) >>> 0) i3 = 4;
 if ((i3 | 0) == 4) i1 = 0;
 i9 = __ZNK10UnityScene19GetLevelGameManagerEi(i2, 26) | 0;
 if (!i9) return;
 if ((i1 | 0) == 0 ? 1 : (((HEAP32[i9 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30672 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30672 + 28 >> 2] | 0) >>> 0) return;
 HEAP32[i9 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 i6 = i9 + 36 | 0;
 i2 = i1 + 36 | 0;
 if ((i2 | 0) != (i6 | 0)) {
  i7 = HEAP32[i2 >> 2] | 0;
  i8 = i6 + 12 | 0;
  i2 = HEAP32[i1 + 48 >> 2] << 3;
  i3 = i2 >> 3;
  HEAP32[i8 >> 2] = i3;
  i4 = i6 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i3;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i6 >> 2] = i2;
   break;
  } else i2 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i2 | 0, i7 | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
 }
 i6 = i9 + 56 | 0;
 i2 = i1 + 56 | 0;
 if ((i2 | 0) != (i6 | 0)) {
  i7 = HEAP32[i2 >> 2] | 0;
  i8 = i9 + 68 | 0;
  i2 = (HEAP32[i1 + 68 >> 2] | 0) * 28 | 0;
  i3 = (i2 | 0) / 28 | 0;
  HEAP32[i8 >> 2] = i3;
  i4 = i9 + 72 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i3;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 28 | 0) | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i6 >> 2] = i2;
   break;
  } else i2 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i2 | 0, i7 | 0, (HEAP32[i8 >> 2] | 0) * 28 | 0) | 0;
 }
 __ZN21EnlightenSceneMappingaSERKS_(i9 + 100 | 0, i1 + 100 | 0) | 0;
 __ZN16LightmapSettings7RebuildEv(i9);
 i8 = HEAP32[i1 + 28 >> 2] | 0;
 __ZN16LightmapSettings28SetDynamicGILightmapTexturesEPK22RealtimeLightmapIDDataj(i9, HEAP32[i8 + 24 >> 2] | 0, HEAP32[i8 + 28 >> 2] | 0);
 return;
}

function __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_(i6, i7, i1, i2, i13) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i14 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_(i6, i7, i1, i13) | 0;
 if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return i14 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i8;
 i8 = i1 + 4 | 0;
 i16 = i2 + 4 | 0;
 i17 = HEAP32[i8 >> 2] | 0;
 i9 = i1 + 8 | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 i10 = i1 + 12 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i1 + 16 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i12 = i1 + 20 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i16 + 16 >> 2];
 HEAP32[i16 >> 2] = i17;
 HEAP32[i2 + 8 >> 2] = i15;
 HEAP32[i2 + 12 >> 2] = i3;
 HEAP32[i2 + 16 >> 2] = i4;
 HEAP32[i2 + 20 >> 2] = i5;
 if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i1 | 0, i7 | 0) | 0)) {
  i17 = i14 + 1 | 0;
  return i17 | 0;
 }
 i19 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i19;
 i1 = i7 + 4 | 0;
 i19 = HEAP32[i1 >> 2] | 0;
 i2 = i7 + 8 | 0;
 i18 = HEAP32[i2 >> 2] | 0;
 i3 = i7 + 12 | 0;
 i15 = HEAP32[i3 >> 2] | 0;
 i4 = i7 + 16 | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 i5 = i7 + 20 | 0;
 i17 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i8 >> 2] = i19;
 HEAP32[i9 >> 2] = i18;
 HEAP32[i10 >> 2] = i15;
 HEAP32[i11 >> 2] = i16;
 HEAP32[i12 >> 2] = i17;
 if (!(mftCall_iii(HEAP32[i13 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i19 = i14 + 2 | 0;
  return i19 | 0;
 }
 i13 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i13;
 i13 = i6 + 4 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = HEAP32[i6 + 8 >> 2] | 0;
 i17 = HEAP32[i6 + 12 >> 2] | 0;
 i18 = HEAP32[i6 + 16 >> 2] | 0;
 i19 = HEAP32[i6 + 20 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 >> 2] = i15;
 HEAP32[i2 >> 2] = i16;
 HEAP32[i3 >> 2] = i17;
 HEAP32[i4 >> 2] = i18;
 HEAP32[i5 >> 2] = i19;
 i19 = i14 + 3 | 0;
 return i19 | 0;
}

function __ZN9Heightmap10SetHeightsEiiiiPKfb(i10, i11, i13, i14, i15, i8, i16) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17;
 i7 = (HEAP32[i10 + 16 >> 2] | 0) + -1 | 0;
 i1 = Math_imul(i15, i14) | 0;
 i12 = __Znaj(i1 >>> 0 > 1073741823 ? -1 : i1 << 2) | 0;
 if (i1 | 0) {
  i1 = i12 + (i1 << 2) | 0;
  i2 = i12;
  do {
   HEAP8[i2 + 2 >> 0] = 0;
   HEAP8[i2 + 3 >> 0] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 if ((i14 | 0) > 0 & (i15 | 0) > 0) {
  i3 = HEAP32[i10 + 76 >> 2] | 0;
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i5 = Math_imul(i3, i2 + i11 | 0) | 0;
   i6 = Math_imul(i2, i15) | 0;
   i1 = 0;
   do {
    f21 = Math_fround(Math_fround(Math_fround(HEAPF32[i8 + ((Math_imul(i1, i14) | 0) + i2 << 2) >> 2]) * Math_fround(32766.0)) + Math_fround(.5));
    i19 = f21 >= Math_fround(0.0);
    f20 = Math_fround(f21 + Math_fround(-.99999994));
    i19 = ~~(i19 ? f21 : f20);
    i18 = i1 + i13 + i5 | 0;
    i19 = (i19 | 0) < 0 ? 0 : ((i19 | 0) > 32766 ? 32766 : i19) & 65535;
    HEAP16[i4 + ((i18 >>> 0 > i7 >>> 0 ? i7 : i18) << 1) >> 1] = i19;
    i18 = i12 + (i1 + i6 << 2) | 0;
    i19 = i19 & 65535 | 8388608;
    HEAP16[i18 >> 1] = i19;
    HEAP16[i18 + 2 >> 1] = i19 >>> 16;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i15 | 0));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i14 | 0));
 }
 i1 = HEAP32[i10 + 100 >> 2] | 0;
 if (!i1) {
  __ZdaPv(i12);
  __ZN9Heightmap15PrecomputeErrorEiiiib(i10, i11, i13, i14, i15, i16);
  i18 = HEAP32[i10 >> 2] | 0;
  i19 = i16 ? 4 : 1;
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i18, i19);
  STACKTOP = i17;
  return;
 }
 HEAP32[i9 + 8 >> 2] = 1;
 HEAP16[i9 + 28 >> 1] = 0;
 HEAP32[i9 >> 2] = i14;
 HEAP32[i9 + 4 >> 2] = i15;
 HEAP32[i9 + 12 >> 2] = 4;
 HEAP32[i9 + 16 >> 2] = i12;
 HEAPF32[i9 + 20 >> 2] = Math_fround(-Math_fround(HEAPF32[i10 + 84 >> 2]));
 HEAPF32[i9 + 24 >> 2] = Math_fround(4.0);
 mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i13 | 0, i11 | 0, i9 | 0, 0) | 0;
 i1 = HEAP32[i10 + 68 >> 2] | 0;
 i3 = i10 + 64 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i19 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i19 = HEAP32[i19 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 144 >> 2] | 0, i19 | 0, 0);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 __ZdaPv(i12);
 __ZN9Heightmap15PrecomputeErrorEiiiib(i10, i11, i13, i14, i15, i16);
 i18 = HEAP32[i10 >> 2] | 0;
 i19 = i16 ? 4 : 1;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i18, i19);
 STACKTOP = i17;
 return;
}

function __ZL18FindAllLiveObjectsR21GarbageCollectorState(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 4 | 0;
 i2 = i12;
 if ((HEAP16[gb + 1162828 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162828 | 0, i1);
  i11 = gb + 1162828 | 0;
 } else i11 = 0;
 i5 = HEAP32[gb + 1104264 >> 2] | 0;
 HEAP32[i10 + 100 >> 2] = (HEAP32[i5 + 36 >> 2] | 0) - (HEAP32[i5 + 4 >> 2] | 0);
 i8 = i5 + 4 | 0;
 i1 = (HEAP32[i5 + 36 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
 i2 = i10 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i9;
  break;
 } while (0);
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i7 = HEAP32[i5 + 32 >> 2] | 0;
 i9 = i2 + (i7 << 3) | 0;
 i1 = i2;
 L10 : do if (i7) {
  i6 = HEAP32[i5 + 20 >> 2] | 0;
  i7 = i5 + 8 | 0;
  i4 = i5 + 12 | 0;
  i3 = i2;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i6 | 0) != (i2 | 0)) {
    if (!(HEAP8[i7 >> 0] | 0)) break L10;
    if (!(HEAP32[i8 >> 2] | 0)) break L10;
    if ((HEAP32[i4 >> 2] | 0) != (i2 | 0)) break L10;
   }
   i3 = i3 + 8 | 0;
   i1 = i3;
  } while ((i3 | 0) != (i9 | 0));
 } while (0);
 i3 = HEAP32[i10 >> 2] | 0;
 L20 : do if ((i1 | 0) != (i9 | 0)) {
  i2 = 0;
  while (1) {
   while (1) {
    if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 4294967293) break;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i9 | 0)) break L20;
   }
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i3 + (i2 << 3) >> 2] = i8;
   i8 = i8 + 8 | 0;
   i10 = i3 + (i2 << 3) + 4 | 0;
   i7 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] & 536870911;
   i5 = HEAP32[i10 >> 2] & -1073741824 | i7;
   HEAP32[i10 >> 2] = i5;
   i6 = HEAP32[i8 >> 2] << 10 & 1073741824;
   HEAP32[i10 >> 2] = i6 | i5 & -1610612737;
   HEAP32[i10 >> 2] = i6 | i7 | HEAP32[i8 >> 2] << 13 & -2147483648;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i9 | 0)) break; else i2 = i2 + 1 | 0;
  }
 } while (0);
 if (!i11) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i12;
 return;
}

function __Z32AudioMixerDuckingProcessCallbackP21UnityAudioEffectStatePfS1_jii(i2, i18, i19, i6, i7, i1) {
 i2 = i2 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f20 = f0;
 i16 = HEAP32[i2 + 28 >> 2] | 0;
 i17 = HEAP32[i2 + 24 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i16 + 16 >> 2]);
 f4 = Math_fround((HEAP32[i2 + 4 >> 2] | 0) >>> 0);
 f5 = Math_fround(i7 | 0);
 f3 = Math_fround(f5 * Math_fround(f3 * f4));
 if (!(f3 <= Math_fround(0.0))) f15 = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(.00999999046, +Math_fround(Math_fround(1.0) / f3)))); else f15 = Math_fround(1.0);
 f3 = Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i16 + 20 >> 2]) * f4));
 if (!(f3 <= Math_fround(0.0))) f5 = Math_fround(Math_fround(1.0) - Math_fround(+Math_pow(.00999999046, +Math_fround(Math_fround(1.0) / f3)))); else f5 = Math_fround(1.0);
 f8 = Math_fround(+Math_pow(10.0, +Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) * Math_fround(.0500000007))));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i16 + 12 >> 2])) + Math_fround(-1.0)) * Math_fround(.5));
 f11 = Math_fround(f9 * Math_fround(.0250000004));
 i10 = i16 + 28 | 0;
 f13 = Math_fround(HEAPF32[i10 >> 2]);
 i2 = f13 > Math_fround(0.0);
 f11 = Math_fround(f11 / (i2 ? f13 : Math_fround(1.0)));
 f12 = Math_fround(+Math_pow(10.0, +Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) * Math_fround(-.100000001))));
 f13 = Math_fround(+Math_pow(10.0, +Math_fround(f13 * Math_fround(-.100000001))));
 f14 = Math_fround(Math_fround(1.0) / f13);
 i2 = Math_imul(i7, i6) | 0;
 if (!i2) return 0;
 i6 = i16 + 32 | 0;
 i7 = i16 + 4 | 0;
 i1 = 0;
 do {
  f4 = Math_fround(HEAPF32[i18 + (i1 << 2) >> 2]);
  f20 = Math_fround(Math_fround(HEAPF32[i17 + (i1 << 2) >> 2]) - f4);
  f20 = Math_fround(f4 + Math_fround(f20 * Math_fround(HEAPF32[i6 >> 2])));
  f20 = Math_fround(Math_fround(f20 * f20) + Math_fround(9.99999996e-12));
  f3 = Math_fround(HEAPF32[i16 >> 2]);
  f3 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f20 - f3) * (f20 > f3 ? f15 : f5)) + Math_fround(1.00000002e-16)));
  HEAPF32[i16 >> 2] = f3;
  f3 = Math_fround(f12 * f3);
  do if (!(f3 >= f13)) f3 = f8; else if (f3 < f14) {
   f3 = Math_fround(Math_fround(_log10f(f3)) * Math_fround(10.0));
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 >> 2]));
   f3 = Math_fround(f8 * Math_fround(+Math_pow(10.0, +Math_fround(f3 * Math_fround(f11 * f3)))));
   break;
  } else {
   f3 = Math_fround(f8 * Math_fround(+Math_pow(+f3, +f9)));
   break;
  } while (0);
  HEAPF32[i7 >> 2] = f3;
  HEAPF32[i19 + (i1 << 2) >> 2] = Math_fround(f4 * f3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return 0;
}

function __Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i1, i6, i12) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(f5 * f5))));
 f7 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 if (f3 < f7) {
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 16 >> 2] = Math_fround(1.0);
  HEAPF32[i12 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 32 >> 2] = Math_fround(1.0);
  i12 = 0;
  return i12 | 0;
 }
 f11 = Math_fround(f2 / f3);
 f10 = Math_fround(f4 / f3);
 f9 = Math_fround(f5 / f3);
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(f9 * f4);
 f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(f2 - Math_fround(f10 * f3));
 f3 = Math_fround(f11 * f3);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(f3 - Math_fround(f9 * f5));
 f4 = Math_fround(Math_fround(f10 * f5) - Math_fround(f11 * f4));
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)))));
 if (f5 < f7) {
  HEAPF32[i12 >> 2] = Math_fround(1.0);
  HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 16 >> 2] = Math_fround(1.0);
  HEAPF32[i12 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i12 + 32 >> 2] = Math_fround(1.0);
  i12 = 0;
  return i12 | 0;
 }
 f8 = Math_fround(f2 / f5);
 f7 = Math_fround(f3 / f5);
 f2 = Math_fround(f4 / f5);
 f3 = Math_fround(Math_fround(f10 * f2) - Math_fround(f9 * f7));
 f4 = Math_fround(Math_fround(f9 * f8) - Math_fround(f11 * f2));
 f5 = Math_fround(Math_fround(f11 * f7) - Math_fround(f10 * f8));
 f13 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))) + Math_fround(-1.0));
 i6 = f13 < Math_fround(0.0);
 f14 = Math_fround(-f13);
 if (!((i6 ? f14 : f13) <= Math_fround(9.99999997e-07))) {
  i12 = 0;
  return i12 | 0;
 }
 HEAPF32[i12 >> 2] = f8;
 HEAPF32[i12 + 12 >> 2] = f3;
 HEAPF32[i12 + 24 >> 2] = f11;
 HEAPF32[i12 + 4 >> 2] = f7;
 HEAPF32[i12 + 16 >> 2] = f4;
 HEAPF32[i12 + 28 >> 2] = f10;
 HEAPF32[i12 + 8 >> 2] = f2;
 HEAPF32[i12 + 20 >> 2] = f5;
 HEAPF32[i12 + 32 >> 2] = f9;
 i12 = 1;
 return i12 | 0;
}

function __ZNSt3__218__insertion_sort_3IR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_(i19, i20, i1) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i23 + 20 | 0;
 i22 = i23 + 8 | 0;
 i18 = i23;
 i2 = i19 + 72 | 0;
 __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_(i19, i19 + 36 | 0, i2, i1) | 0;
 i1 = i19 + 108 | 0;
 if ((i1 | 0) == (i20 | 0)) {
  STACKTOP = i23;
  return;
 }
 i17 = i21 + 8 | 0;
 i14 = i22 + 8 | 0;
 i15 = i21 + 8 | 0;
 i16 = i22 + 8 | 0;
 while (1) {
  __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f24 = Math_fround(HEAPF32[i17 >> 2]);
  __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (f24 < Math_fround(HEAPF32[i14 >> 2])) {
   i8 = HEAP32[i1 >> 2] | 0;
   i9 = HEAP32[i1 + 4 >> 2] | 0;
   i10 = HEAP32[i1 + 8 >> 2] | 0;
   i11 = HEAP32[i1 + 12 >> 2] | 0;
   i12 = HEAP32[i1 + 16 >> 2] | 0;
   i13 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = i1 + 24 | 0;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i18;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = HEAP32[i1 + 32 >> 2] | 0;
   i6 = i7 + 28 | 0;
   i3 = i1;
   while (1) {
    i4 = i2;
    i5 = i3 + 36 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    if ((i2 | 0) == (i19 | 0)) {
     i2 = i19;
     break;
    }
    __ZNK9Transform11GetPositionEv(i21, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
    f24 = Math_fround(HEAPF32[i15 >> 2]);
    __ZNK9Transform11GetPositionEv(i22, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i2 + -4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f24 < Math_fround(HEAPF32[i16 >> 2])) {
     i3 = i2;
     i2 = i2 + -36 | 0;
    } else break;
   }
   HEAP32[i2 >> 2] = i8;
   HEAP32[i2 + 4 >> 2] = i9;
   HEAP32[i2 + 8 >> 2] = i10;
   HEAP32[i2 + 12 >> 2] = i11;
   HEAP32[i2 + 16 >> 2] = i12;
   HEAP32[i2 + 20 >> 2] = i13;
   i11 = i18;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i2 + 24 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   HEAP32[i2 + 32 >> 2] = i7;
  }
  i2 = i1 + 36 | 0;
  if ((i2 | 0) == (i20 | 0)) break; else {
   i13 = i1;
   i1 = i2;
   i2 = i13;
  }
 }
 STACKTOP = i23;
 return;
}

function __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib(i5, i6, i8, i9, i10, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 8 | 0;
 i1 = i14;
 if ((HEAP16[gb + 1166288 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166288 | 0, i13);
  i4 = gb + 1166288 | 0;
 } else i4 = 0;
 i2 = i5 + 100 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i3 + 124 >> 2] | 0;
 i21 = HEAP32[i3 + 128 >> 2] | 0;
 i20 = HEAP32[i3 + 132 >> 2] | 0;
 i19 = HEAP32[i3 + 136 >> 2] | 0;
 i18 = HEAP32[i3 + 140 >> 2] | 0;
 i17 = HEAP32[i3 + 144 >> 2] | 0;
 i16 = HEAP32[i3 + 148 >> 2] | 0;
 i15 = HEAP32[i3 + 152 >> 2] | 0;
 i7 = i8 + 4 | 0;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i13 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i13 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i1;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i21;
 i1 = i8 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i20;
 i1 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i19;
 i1 = i8 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i18;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i17;
 i1 = i8 + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i16;
 i1 = i8 + 32 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i15;
 i1 = HEAP8[i3 + 164 >> 0] | 0;
 if (!(i1 & 1)) i12 = 5; else if (!(HEAP32[i3 + 8 >> 2] | 0)) i12 = 5;
 if ((i12 | 0) == 5) {
  __ZN8Material15BuildPropertiesEv(i5);
  i1 = HEAP8[(HEAP32[i2 >> 2] | 0) + 164 >> 0] | 0;
 }
 if (i1 & 2) __ZN8Material12UpdateHashesEv(i5);
 i1 = __Z26ApplyMaterialPassWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i3, i8, i9, i6, i10, i11, 0, 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
 if (!i4) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb(i4, i6, i3, i1) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 switch (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0) {
 case 0:
  {
   __ZN5physx7NpScene17removeRigidStaticERNS_13NpRigidStaticEbb(i4, i6, i3, i1);
   STACKTOP = i7;
   return;
  }
 case 1:
  {
   __ZN5physx7NpScene18removeRigidDynamicERNS_14NpRigidDynamicEbb(i4, i6, i3, i1);
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i4 + 16 | 0, i6 + 20 | 0, 0);
   i5 = i4 + 3640 | 0;
   i3 = i4 + 3644 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   L7 : do if (!i4) i1 = 0; else {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L7;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   } while (0);
   if ((i1 | 0) == (i4 | 0)) {
    STACKTOP = i7;
    return;
   }
   i4 = i4 + -1 | 0;
   HEAP32[i3 >> 2] = i4;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
   STACKTOP = i7;
   return;
  }
 case 3:
  {
   __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i4 + 16 | 0, i6 + 20 | 0, 0);
   i5 = i4 + 3640 | 0;
   i3 = i4 + 3644 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   L18 : do if (!i4) i1 = 0; else {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L18;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   } while (0);
   if ((i1 | 0) == (i4 | 0)) {
    STACKTOP = i7;
    return;
   }
   i4 = i4 + -1 | 0;
   HEAP32[i3 >> 2] = i4;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
   STACKTOP = i7;
   return;
  }
 case 5:
  {
   __ZN5physx3Scb5Scene11removeClothERNS0_5ClothE(i4 + 16 | 0, i6 + 20 | 0);
   i5 = i4 + 3652 | 0;
   i3 = i4 + 3656 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   L29 : do if (!i4) i1 = 0; else {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L29;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   } while (0);
   if ((i1 | 0) == (i4 | 0)) {
    STACKTOP = i7;
    return;
   }
   i4 = i4 + -1 | 0;
   HEAP32[i3 >> 2] = i4;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
   STACKTOP = i7;
   return;
  }
 case 4:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 707, gb + 709025 | 0, i2);
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f(i11, i21, i2, i3, i5, i22, i23, i24, f14) {
 i11 = i11 | 0;
 i21 = i21 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 f14 = Math_fround(f14);
 var f1 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f19 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(f19 - f4);
 f20 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f20 = Math_fround(f20 - f10);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f13 - f6);
 f17 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f4);
 f18 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f10);
 f16 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f6);
 i2 = i21 + 4 | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f9 * f16);
 i3 = i21 + 8 | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f18 * f8));
 f8 = Math_fround(f17 * f8);
 f1 = Math_fround(HEAPF32[i21 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f16 * f1));
 f9 = Math_fround(Math_fround(f18 * f1) - Math_fround(f17 * f9));
 f1 = Math_fround(Math_fround(f13 * f9) + Math_fround(Math_fround(f19 * f7) + Math_fround(f20 * f8)));
 if (f1 > Math_fround(-9.99999997e-07) & f1 < Math_fround(9.99999997e-07)) {
  i24 = 0;
  return i24 | 0;
 }
 f15 = Math_fround(Math_fround(1.0) / f1);
 f12 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) - f4);
 f10 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) - f10);
 f4 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f6);
 f1 = Math_fround(f15 * Math_fround(Math_fround(Math_fround(f7 * f12) + Math_fround(f8 * f10)) + Math_fround(f9 * f4)));
 HEAPF32[i23 >> 2] = f1;
 f9 = Math_fround(-f14);
 if (f1 < f9) {
  i24 = 0;
  return i24 | 0;
 }
 f8 = Math_fround(f14 + Math_fround(1.0));
 if (f1 > f8) {
  i24 = 0;
  return i24 | 0;
 }
 f7 = Math_fround(Math_fround(f13 * f10) - Math_fround(f20 * f4));
 f6 = Math_fround(Math_fround(f19 * f4) - Math_fround(f13 * f12));
 f4 = Math_fround(Math_fround(f20 * f12) - Math_fround(f19 * f10));
 f1 = Math_fround(f7 * Math_fround(HEAPF32[i21 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2])));
 f1 = Math_fround(f15 * Math_fround(f1 + Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]))));
 HEAPF32[i24 >> 2] = f1;
 if (f1 < f9) {
  i24 = 0;
  return i24 | 0;
 }
 if (Math_fround(f1 + Math_fround(HEAPF32[i23 >> 2])) > f8) {
  i24 = 0;
  return i24 | 0;
 }
 HEAPF32[i22 >> 2] = Math_fround(f15 * Math_fround(Math_fround(f16 * f4) + Math_fround(Math_fround(f17 * f7) + Math_fround(f18 * f6))));
 i24 = 1;
 return i24 | 0;
}

function __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb(i12, i5, i6) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i7 = i13;
 if (!i5) {
  i12 = -1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = i12 + 20 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = i12 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 L4 : do if ((i2 | 0) == (i1 | 0)) i8 = 8; else {
  while (1) {
   i4 = _strlen(i5) | 0;
   i14 = HEAP8[i2 + 11 >> 0] | 0;
   if ((i4 | 0) == ((i14 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i14 & 255) | 0)) {
    i14 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, i5, i4) | 0) == 0;
    i1 = HEAP32[i9 >> 2] | 0;
    if (i14) break;
   }
   i2 = i2 + 16 | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i8 = 8;
    break L4;
   }
  }
  if ((i2 | 0) == (i1 | 0)) i8 = 8; else i6 = i2 - (HEAP32[i11 >> 2] | 0) >> 4;
 } while (0);
 if ((i8 | 0) == 8) {
  if (!i6) {
   i14 = -1;
   STACKTOP = i13;
   return i14 | 0;
  };
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i5, _strlen(i5) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i7);
  i2 = i10 + 12 | 0;
  HEAP8[i2 >> 0] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i12 + 28 >> 2] | 0)) {
   __ZNSt3__26vectorI25VirtualJoystickPropertiesNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i11, i10);
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i10);
   HEAP8[i1 + 12 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 16 | 0;
   HEAP32[i9 >> 2] = i1;
  }
  i6 = (i1 - (HEAP32[i11 >> 2] | 0) >> 4) + -1 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 }
 d3 = +__Z19GetTimeSinceStartupv();
 i5 = i12 + 8 | 0;
 if (d3 - +HEAPF64[i12 >> 3] > 1.0) {
  i4 = HEAP32[i5 >> 2] | 0;
  i1 = i12 + 12 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i4 | 0)) do {
   i14 = i2 + -12 | 0;
   HEAP32[i1 >> 2] = i14;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i4 | 0));
  __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i5);
  HEAPF64[i12 >> 3] = d3;
 } else i1 = i12 + 12 | 0;
 i14 = (((HEAP32[i1 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 12 | 0) + i6 | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN12AudioManager6UpdateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i1 = i11;
 if ((HEAP16[gb + 1459992 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459992 | 0, i7);
  i8 = gb + 1459992 | 0;
 } else i8 = 0;
 i6 = i10 + 88 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i10, 0, 0) | 0;
  f4 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
  f5 = Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 184 >> 3]);
  i3 = i10 + 68 | 0;
  i1 = HEAP32[i10 + 72 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!(HEAP32[i1 + 104 >> 2] | 0)) __ZN10AudioMixer6UpdateEf(i1, f4); else __ZN10AudioMixer6UpdateEf(i1, f5);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  __ZN12AudioManager23ProcessScheduledSourcesEv(i10);
  i1 = HEAP32[i10 + 56 >> 2] | 0;
  i3 = i10 + 52 | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i12 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i12 = HEAP32[i12 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 120 >> 2] | 0, i12 | 0);
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i10 + 48 >> 2] | 0;
  i3 = i10 + 44 | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i12 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i12 = HEAP32[i12 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 120 >> 2] | 0, i12 | 0);
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i10 + 84 >> 2] | 0;
  i3 = i10 + 80 | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) do {
   i12 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 120 >> 2] | 0, i12 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i7 >> 2] = 0;
  __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i6 >> 2] | 0, i7, 0, 0, 0, 0, 0) | 0;
  HEAP32[gb + 1097872 + 12 >> 2] = HEAP32[i7 >> 2];
  i12 = HEAP32[gb + 1097872 + 8 >> 2] & -4;
  i1 = (__Z14GetPlayerPausev() | 0) != 0;
  HEAP32[gb + 1097872 + 8 >> 2] = i12 | (i1 ? 2 : 0) | 1;
  __ZN4FMOD6System6updateEv(HEAP32[i6 >> 2] | 0) | 0;
  i1 = i10 + 228 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   HEAP8[i1 >> 0] = 0;
   __ZN12AudioManager29ShutdownReinitializeAndReloadEv(i10);
  }
  __ZN12AudioManager39HandlePendingAudioConfigurationCallbackEv(i10);
  if (i9) __Z19pop_allocation_rootv();
 }
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i11;
 return;
}

function __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i2, i3, i4, i5, i6, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 i1 = __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_(i2, i3, i4, i5, i1) | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f10 < Math_fround(HEAPF32[i8 + 8 >> 2]))) {
  i11 = i1;
  STACKTOP = i9;
  return i11 | 0;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i11;
 i11 = HEAP32[i4 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f10 < Math_fround(HEAPF32[i8 + 8 >> 2]))) {
  i11 = i1 + 1 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i11;
 i11 = HEAP32[i3 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f10 < Math_fround(HEAPF32[i8 + 8 >> 2]))) {
  i11 = i1 + 2 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i11;
 i11 = HEAP32[i2 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f10 < Math_fround(HEAPF32[i8 + 8 >> 2]))) {
  i11 = i1 + 3 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i11;
 i11 = i1 + 4 | 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 40 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i8 = gb + 63648 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i1 + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP8[i1 + 4 >> 0] = 0;
   HEAP32[i1 + 32 >> 2] = 1;
   HEAP8[i1 + 36 >> 0] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 40 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 40 | 0) + i2 | 0;
 if (i5 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 40 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 53687091 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 107374182;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 40 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 40 | 0) * 40 | 0) | 0;
 i7 = i3;
 i4 = i6 + (i5 * 40 | 0) | 0;
 i6 = gb + 63648 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i7;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i12 = i1 + 24 | 0;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP8[i1 + 4 >> 0] = 0;
  HEAP32[i1 + 32 >> 2] = 1;
  HEAP8[i1 + 36 >> 0] = 0;
  i1 = i8 + 40 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i7;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i12 = i3 + -40 | 0;
   i7 = i1;
   i1 = i1 + -40 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i3 + -20 >> 2] = 0;
   i14 = i7 + -16 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i5 = i3 + -16 | 0;
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = i13;
   HEAP8[i3 + -36 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i12, i1);
   i12 = i3 + -8 | 0;
   i7 = i7 + -8 | 0;
   HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
   HEAP8[i12 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
   i3 = i2 + -40 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i6 | 0));
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i4;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -36 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN5audio5mixer14EffectConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047471 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863408 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863427 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863449 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863466 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863482 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1 + 28;
 HEAP32[i7 + 4 >> 2] = i1 + 24;
 HEAP32[i7 + 8 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863489 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i3 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z29Input_CUSTOM_GetJoystickNamesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 44 | 0;
 i1 = i8 + 40 | 0;
 i2 = i8 + 36 | 0;
 i5 = i8 + 24 | 0;
 i3 = i8 + 12 | 0;
 i11 = i8 + 8 | 0;
 i10 = i8 + 4 | 0;
 i9 = i8;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i5);
 __Z23GetVirtualJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i3);
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertINS_11__wrap_iterIPS6_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESC_E4typeENSA_IPKS6_EESE_SE_(i5, i2, i1, i7) | 0;
 i7 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(i7, 4, ((HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 12 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) {
  i2 = 0;
  do {
   i11 = i1;
   i9 = i11 + (i2 * 12 | 0) | 0;
   i1 = HEAP8[i9 + 11 >> 0] | 0;
   i10 = i1 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i7, i2, __Z20scripting_string_newPKcj(i10 ? HEAP32[i9 >> 2] | 0 : i9, i10 ? HEAP32[i11 + (i2 * 12 | 0) + 4 >> 2] | 0 : i1 & 255) | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i2 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0);
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i2; else {
   do {
    i11 = i1 + -12 | 0;
    HEAP32[i4 >> 2] = i11;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i11 = i2 + -12 | 0;
   HEAP32[i6 >> 2] = i11;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 28 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = i1 + 16;
   HEAP32[i1 + 24 >> 2] = 0;
   i1 = (HEAP32[i7 >> 2] | 0) + 28 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 28 | 0) + i2 | 0;
 if (i6 >>> 0 > 153391689) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 28 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 76695844 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 153391689;
 i1 = (i1 - i5 | 0) / 28 | 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 28 | 0) | 0;
 HEAP32[i9 >> 2] = i4;
 i7 = i4 + (i1 * 28 | 0) | 0;
 i6 = i9 + 8 | 0;
 HEAP32[i6 >> 2] = i7;
 i5 = i9 + 4 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i9 + 12 >> 2] = i4 + (i3 * 28 | 0);
 i3 = i1 + i2 | 0;
 i1 = i7;
 while (1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = i1 + 16;
  HEAP32[i1 + 24 >> 2] = 0;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i1 = i1 + 28 | 0;
 }
 HEAP32[i6 >> 2] = i4 + (i3 * 28 | 0);
 __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i9);
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i3 = i1 + -28 | 0;
  HEAP32[i6 >> 2] = i3;
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + -16 | 0, HEAP32[i1 + -12 >> 2] | 0);
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i2 = i1 + -24 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
    do {
     i8 = i1 + -872 | 0;
     HEAP32[i2 >> 2] = i8;
     __ZN9ShaderLab14SerializedPassD2Ev(i8);
     i1 = HEAP32[i2 >> 2] | 0;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function __ZN5Umbra8QueryExt17queryShortestPathEjRNS_4PathERKNS_7Vector3ES5_(i1, i5, i8, i9, i10) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i7 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i13 >> 2] = i7;
 i2 = HEAP32[i7 + 76 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = i2;
 i12 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i12 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i12 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i1;
 i6 = i1 + i4 | 0;
 HEAP32[i13 + 12 >> 2] = i6;
 i11 = i13 + 16 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i13 + 20 >> 2] = i4;
 HEAP32[i13 + 24 >> 2] = 0;
 i12 = i13 + 28 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i13 + 32 >> 2] = i5;
 HEAP32[i13 + 36 >> 2] = 0;
 HEAP32[i13 + 40 >> 2] = -1;
 i5 = HEAP32[i7 + 84 >> 2] | 0;
 HEAP32[i13 + 44 >> 2] = i5;
 HEAP32[i13 + 48 >> 2] = i5;
 HEAP32[i13 + 52 >> 2] = 0;
 HEAP32[i13 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) {
  i3 = 0;
  i4 = i1;
 } else {
  i2 = i1 + 80 | 0;
  HEAP32[i11 >> 2] = i2;
  if (!i1) {
   i3 = 0;
   i4 = i2;
  } else {
   HEAP32[i1 >> 2] = 13;
   i3 = i1 + 16 | 0;
   i4 = i2;
  }
 }
 HEAP32[i13 + 60 >> 2] = i3;
 i1 = i3;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP32[i7 >> 2] | 0)) {
  i12 = 6;
  __ZN5Umbra12QueryContextD2Ev(i13);
  STACKTOP = i14;
  return i12 | 0;
 }
 i1 = i8 + 3 & -4;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i4 + 24176 | 0;
 if (i2 >>> 0 > i6 >>> 0) {
  __ZN5Umbra10PathFinderC2ERNS_12QueryContextE(0, i13);
  i12 = 2;
  __ZN5Umbra12QueryContextD2Ev(i13);
  STACKTOP = i14;
  return i12 | 0;
 }
 HEAP32[i11 >> 2] = i2;
 __ZN5Umbra10PathFinderC2ERNS_12QueryContextE(i4, i13);
 if (!i4) {
  i12 = 2;
  __ZN5Umbra12QueryContextD2Ev(i13);
  STACKTOP = i14;
  return i12 | 0;
 }
 if (!(HEAP32[i12 >> 2] | 0)) __ZN5Umbra10PathFinder4findERNS_7ImpPathERKNS_7Vector3ES5_(i4, i1, i9, i10);
 i1 = HEAP32[i4 + 24168 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i4 + 152 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i4 + 148 >> 2] | 0) + 12 >> 2] = i1 + -16;
 i1 = HEAP32[i4 + 124 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 128 >> 2];
 i1 = HEAP32[i4 + 88 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 92 >> 2];
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 56 >> 2];
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i11 >> 2] = i4;
 i12 = HEAP32[i12 >> 2] | 0;
 __ZN5Umbra12QueryContextD2Ev(i13);
 STACKTOP = i14;
 return i12 | 0;
}

function __ZNK8VRDevice20GetCullingParametersEPK6CameraR10Matrix4x4fS4_Rf(i8, i9, i10, i11, i5) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1469216 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i9;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469216 | 0, i7);
  i6 = gb + 1469216 | 0;
 } else i6 = 0;
 mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 92 >> 2] | 0, i7 | 0, i8 | 0, i9 | 0, 2);
 i1 = i10;
 i3 = i7;
 i4 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i1 | 0) < (i4 | 0));
 i1 = HEAP32[i8 + 280 >> 2] | 0;
 if (!i1) f2 = Math_fround(__ZNK6Camera19GetStereoSeparationEv(i9)); else f2 = Math_fround(__ZNK7VRInput16GetEyeSeparationEv(i1));
 HEAPF32[i5 >> 2] = f2;
 f2 = Math_fround(f2 * Math_fround(.5));
 f2 = Math_fround(f2 / Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(__ZNK6Camera6GetFovEv(i9)) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)))));
 i4 = HEAP32[gb + 62512 >> 2] | 0;
 i3 = HEAP32[gb + 62512 + 4 >> 2] | 0;
 i1 = HEAP32[gb + 62512 + 8 >> 2] | 0;
 i5 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (i5) {
  __ZNK9Transform18GetWorldScaleLossyEv(i7, i5);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = HEAP32[i7 + 8 >> 2] | 0;
 }
 f14 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f13 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f2 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f16 = Math_fround(-Math_fround(f13 * f16));
 f15 = Math_fround(-Math_fround(f2 * Math_fround(HEAPF32[i10 + 40 >> 2])));
 HEAPF32[i7 >> 2] = Math_fround(-Math_fround(f14 * f17));
 HEAPF32[i7 + 4 >> 2] = f16;
 HEAPF32[i7 + 8 >> 2] = f15;
 __ZN10Matrix4x4f9TranslateERK8Vector3f(i10, i7) | 0;
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(f2 * f2))));
 __ZNK8VRDevice38GetProjectionMatrixWithClippingOffsetsEPK6Camera21MonoOrStereoscopicEyeffR10Matrix4x4f(i8, i9, 2, f2, f2, i11);
 if (!i6) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i12;
 return;
}

function __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 40 | 0;
 i6 = i11 + 20 | 0;
 i7 = i11;
 i10 = HEAP32[i5 + 20 >> 2] | 0;
 i8 = i6 + 4 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = -1;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = (HEAP32[i4 + 32 >> 2] | 0) == 17;
 i2 = i3;
 do if (!i3) {
  i2 = i4 + 12 | 0;
  if (i1) i1 = 0; else i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP8[i9 >> 0] = 1;
  HEAP32[i9 + 4 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[i9 + 12 >> 2] = -1;
 } else {
  if (!i1) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i9, HEAP32[i4 >> 2] | 0, i5, 1);
   break;
  }
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i3 = HEAP32[i4 + 12 >> 2] | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0;
   HEAP8[i9 >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = i2;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = i2;
  }
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[i9 + 12 >> 2] = i1;
 } while (0);
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i3 = HEAP32[i4 + 44 >> 2] | 0;
 i2 = (HEAP32[i5 + 16 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i1 = i5 + (i3 << 6) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = i1;
 i3 = i3 << 6 >> 6;
 HEAP32[i7 + 16 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i3;
 HEAP32[i6 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, i6, HEAP32[i4 + 24 >> 2] | 0);
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 + 20 >> 2] = i10;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = i3;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
  STACKTOP = i11;
  return;
 }
 i3 = i3 + 12 | 0;
 do {
  i8 = i1 + 64 | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i3 >> 2] = i2 - i8 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i9 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 STACKTOP = i11;
 return;
}

function __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i7, i8, i5, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i2 = i11;
 i1 = HEAP16[i8 + 12 >> 1] | 0;
 if (i1 << 16 >> 16 == 114) {
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  do if (!i4) i6 = 12; else {
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i2);
     i2 = HEAP32[i10 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i6 = 10;
    }
   }
   if ((i6 | 0) == 8) i6 = 10;
   if ((i6 | 0) == 10) {
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i6 = 12;
     break;
    }
   }
   if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) i6 = 12;
  } while (0);
  if ((i6 | 0) == 12) i1 = 0;
  i2 = __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(HEAP32[i5 + 28 >> 2] | 0, 114, i1) | 0;
 } else {
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1 & 65535) | 0;
  if (!i1) i2 = 0; else i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, i1) | 0;
 }
 i3 = HEAPU8[i8 + 14 >> 0] | 0;
 i1 = HEAP32[(HEAP32[i7 + 20 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 if (!((i2 | 0) != 0 & (i1 | 0) != 0)) {
  i12 = -1;
  STACKTOP = i11;
  return i12 | 0;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i10 + 8 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i2;
 i1 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i8 | 0, i10 | 0) | 0;
 if ((i1 | 0) != -1) {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 }
 i12 = i1;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN13MemoryManager10DeallocateEPv(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 if (!(__Z31profiler_get_memory_record_modev() | 0)) i8 = 0; else {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1188396 | 0, 0);
  i8 = gb + 1188396 | 0;
 }
 i11 = __ZN13MemoryManager25GetAllocatorContainingPtrEPKv(i9, i10) | 0;
 if (!i11) {
  if (HEAP8[i9 + 1550 >> 0] | 0) _free(i10);
 } else {
  if (HEAP32[gb + 1163236 >> 2] | 0) if ((i11 | 0) != (HEAP32[i9 + 1560 >> 2] | 0)) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i11 | 0, i10 | 0) | 0;
   __ZN14MemoryProfiler20UnregisterAllocationEPvjRK10MemLabelId(HEAP32[gb + 1163236 >> 2] | 0, i10, i1, gb + 63160 | 0);
   if (HEAP8[i9 + 1548 >> 0] | 0) {
    i7 = 0 - i1 | 0;
    i4 = i9 + 1556 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i6 = i9 + 1544 | 0;
    if ((HEAP32[i6 >> 2] | 0) > 0) {
     i2 = 0;
     do {
      i3 = HEAP32[i9 + 1568 + (i2 << 2) >> 2] | 0;
      i1 = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0) + i1 | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
    }
    i3 = 0;
    do {
     i2 = HEAP32[i9 + 1764 + (i3 << 2) >> 2] | 0;
     if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 512);
    d5 = +Math_fround(Math_fround(i1 >>> 0) * Math_fround(9.53674316e-07));
    i1 = HEAP32[i4 >> 2] | 0;
    if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    if ((HEAP32[i6 >> 2] | 0) > 0) {
     i2 = 0;
     do {
      i4 = HEAP32[i9 + 1568 + (i2 << 2) >> 2] | 0;
      i1 = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0) | 0) + i1 | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
    }
    i3 = 0;
    do {
     i2 = HEAP32[i9 + 1764 + (i3 << 2) >> 2] | 0;
     if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != 512);
    HEAP32[i12 >> 2] = i10;
    HEAP32[i12 + 4 >> 2] = i7;
    HEAPF64[i12 + 8 >> 3] = d5;
    HEAP32[i12 + 16 >> 2] = i1;
    _printf_console(gb + 582342 | 0, i12);
   }
  }
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i10 | 0);
 }
 if (!i8) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i13;
 return;
}

function __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) i1 = 0; else {
  i4 = (i1 - i2 | 0) / 12 | 0;
  i3 = 0;
  i1 = 0;
  do {
   i2 = HEAP8[i5 + (i3 * 12 | 0) + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i2 = HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] | 0; else i2 = i2 & 255;
   i1 = i2 + ((i1 | 0) == 0 ? 0 : i1 + 1 | 0) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i10 = i12 + 11 | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i12 >> 2] >> 0] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
 } else {
  HEAP8[i12 >> 0] = 0;
  HEAP8[i10 >> 0] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE7reserveEj(i12, i1);
 i1 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) == (i1 | 0)) return;
 i8 = i12 + 4 | 0;
 i9 = i12 + 8 | 0;
 i7 = 0;
 do {
  i3 = HEAP8[i10 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i3 & 255;
  if ((i4 ? i2 : i3) | 0) {
   if (i4) {
    i3 = i2;
    i1 = (HEAP32[i9 >> 2] & 2147483647) + -1 | 0;
   } else i1 = 10;
   if ((i3 | 0) == (i1 | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i12, i1, 1, i1, i1, 0, 0);
    if ((HEAP8[i10 >> 0] | 0) > -1) i2 = 19; else i2 = 20;
   } else if (i4) i2 = 20; else i2 = 19;
   if ((i2 | 0) == 19) {
    HEAP8[i10 >> 0] = i3 + 1;
    i1 = i12;
   } else if ((i2 | 0) == 20) {
    i1 = HEAP32[i12 >> 2] | 0;
    HEAP32[i8 >> 2] = i3 + 1;
   }
   i1 = i1 + i3 | 0;
   HEAP8[i1 >> 0] = 32;
   HEAP8[i1 + 1 >> 0] = 0;
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i1 = i1 + (i7 * 12 | 0) | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i6 = _strlen(i1) | 0;
  i2 = HEAP8[i10 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) {
   i4 = (HEAP32[i9 >> 2] & 2147483647) + -1 | 0;
   i5 = HEAP32[i8 >> 2] | 0;
  } else {
   i4 = 10;
   i5 = i2 & 255;
  }
  if ((i4 - i5 | 0) >>> 0 < i6 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i4, i6 - i4 + i5 | 0, i5, i5, 0, i6, i1); else if (i6 | 0) {
   i2 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
   _memcpy(i2 + i5 | 0, i1 | 0, i6 | 0) | 0;
   i1 = i5 + i6 | 0;
   if ((HEAP8[i10 >> 0] | 0) < 0) HEAP32[i8 >> 2] = i1; else HEAP8[i10 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
  i7 = i7 + 1 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 } while ((i7 | 0) != (((HEAP32[i13 >> 2] | 0) - i1 | 0) / 12 | 0 | 0));
 return;
}

function __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 i13 = i16 + 52 | 0;
 HEAP32[i13 >> 2] = 0;
 i4 = i13 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i14 = i13 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i9 = i12;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform(i12, i13, 0, -2);
 HEAP8[i12 + 25 >> 0] = 0;
 __ZN9BlobWrite8TransferIN7mecanim9animation12AvatarMemoryEEEvRT_PKc17TransferMetaFlags(i12, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 i11 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i4 >> 2] | 0, 16) | 0;
 if (i11 | 0) _memcpy(i11 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i9 = i12 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i12 + 44 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + (i1 >>> 8 << 2) | 0;
 i10 = i12 + 36 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i4 = i7;
 i5 = i2;
 if ((i7 | 0) == (i2 | 0)) {
  i6 = 0;
  i7 = i12 + 48 | 0;
  i1 = 0;
 } else {
  i7 = i12 + 48 | 0;
  i6 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i6 = (HEAP32[i2 + (i6 >>> 8 << 2) >> 2] | 0) + ((i6 & 255) << 4) | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + ((i1 & 255) << 4) | 0;
 }
 L8 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L8;
   i1 = i1 + 16 | 0;
  } while ((i1 - (HEAP32[i3 >> 2] | 0) | 0) != 4096);
  i1 = i3 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i4 - i5 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = (HEAP32[i10 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i8 >> 2] = 128;
   break;
  }
 case 2:
  {
   HEAP32[i8 >> 2] = 256;
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 if ((HEAP32[i14 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return i11 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i15);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i16;
 return i11 | 0;
}

function __ZNSt3__26vectorIN5physx10PxSweepHitENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (((i3 - i1 | 0) / 48 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = -1;
   HEAP16[i1 + 12 >> 1] = 0;
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAPF32[i1 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i1 = (HEAP32[i10 >> 2] | 0) + 48 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 48 | 0) + i2 | 0;
 if (i5 >>> 0 > 89478485) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 48 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 44739242 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 89478485;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 48 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 48 | 0) * 48 | 0) | 0;
 i7 = i3;
 i4 = i6 + (i5 * 48 | 0) | 0;
 i6 = i7;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = -1;
  HEAP16[i1 + 12 >> 1] = 0;
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAPF32[i1 + 40 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i1 = i6 + 48 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i11 = i3 + -48 | 0;
   i7 = i5;
   i5 = i5 + -48 | 0;
   HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP16[i3 + -36 >> 1] = HEAP16[i7 + -36 >> 1] | 0;
   HEAP32[i3 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i7 + -16 >> 2];
   HEAP32[i3 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i3 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i3 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   i3 = i2 + -48 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN15DetailPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 4 | 0, i5);
 i1 = i7 + 8 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i5 + 24 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 32 | 0, i5);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 48 | 0, i5);
 i1 = i7 + 64 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i10, i12) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 8 | 0;
 i4 = i16;
 i15 = i16 + 16 | 0;
 i14 = gb + 64016 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i15 >> 2] = 0;
 i11 = i15 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i4);
 i6 = i9;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 24 >> 2] | 0;
 i6 = i3 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 do if ((i5 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i7 = i3 + 40 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   if (!i8) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i8 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i17 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i8, i1) | 0;
  HEAP32[i7 >> 2] = i17;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i17 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i5);
   i18 = i3 + 8 | 0;
   i5 = HEAP32[i18 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
   HEAP32[i17 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_10MemLabelId17TransferMetaFlags(i3, i15, i9, 0);
   HEAP8[i6 >> 0] = 1;
   i17 = i3 + 56 | 0;
   HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i10 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i10 >> 2] | 0; else {
  i18 = i12 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i18 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i18 >> 2] | 0, i1, HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 }
 i18 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i18 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if ((HEAP32[i13 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN5physx28PxArticulationRepXSerializer16objectToFileImplEPKNS_14PxArticulationEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i6, i5, i8, i7, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 592 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i10 + 352 | 0;
 i12 = i10 + 120 | 0;
 i11 = i10 + 88 | 0;
 i9 = i10 + 24 | 0;
 i4 = i10 + 40 | 0;
 i16 = i10;
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = i9 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i3 = i9 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = i1;
 i1 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i4 + 28 >> 2] = Math_fround(.75);
 HEAP32[i4 + 32 >> 2] = -1;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj(i4, 64);
 __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEEC2ERNS_7profile12ProfileArrayINS0_14NameStackEntryEEERNS_9XmlWriterEPKS2_RNS_12MemoryBufferERNS_12PxCollectionEPNS4_14ProfileHashMapIKyPKNS_18PxArticulationLinkENS_6shdfnd4HashISI_EEEE(i16, i9, i8, i6, i7, i5, i4);
 i14 = HEAP32[i16 >> 2] | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i5 = HEAP32[i16 + 8 >> 2] | 0;
 i6 = HEAP32[i16 + 12 >> 2] | 0;
 i7 = HEAP32[i16 + 16 >> 2] | 0;
 i8 = HEAP32[i16 + 20 >> 2] | 0;
 _memset(i15 | 0, 0, 232) | 0;
 __ZN5physx27PxArticulationGeneratedInfoC2Ev(i15);
 _memset(i12 | 0, 0, 232) | 0;
 __ZN5physx27PxArticulationGeneratedInfoC2Ev(i12);
 HEAP32[i11 >> 2] = i14;
 HEAP32[i11 + 4 >> 2] = i13;
 HEAP32[i11 + 8 >> 2] = i5;
 HEAP32[i11 + 12 >> 2] = i6;
 HEAP32[i11 + 16 >> 2] = i7;
 HEAP32[i11 + 20 >> 2] = i8;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEEEEjT_j(i12, i11, 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i16 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 }
 i16 = HEAP32[i3 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i10;
 return;
}

function __Z21EvalTriUVUsingEdgeLenRK8Vector3fS1_S1_RK8Vector2fS4_S4_ff(i3, i4, i15, i6, i7, i20, f1, f2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i20 = i20 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f5 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f23 = Math_fround(HEAPF32[i4 >> 2]);
 f24 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f2 = Math_fround(f17 - f23);
 f16 = Math_fround(f18 - f24);
 f1 = Math_fround(f13 - f21);
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f16 * f16)) + Math_fround(f1 * f1))));
 f16 = Math_fround(f14 - f22);
 f2 = Math_fround(f5 - f19);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f16 * f16) + Math_fround(f2 * f2))));
 if (f1 < Math_fround(.00100000005) | f2 < Math_fround(.00100000005)) f16 = Math_fround(0.0); else {
  f16 = Math_fround(f1 / f2);
  f16 = Math_fround(f16 * f16);
 }
 f10 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f9 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f1 = Math_fround(f17 - f10);
 f18 = Math_fround(f18 - f11);
 f2 = Math_fround(f13 - f8);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f18 * f18)) + Math_fround(f2 * f2))));
 f18 = Math_fround(f14 - f12);
 f1 = Math_fround(f5 - f9);
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f18 * f18) + Math_fround(f1 * f1))));
 if (f2 < Math_fround(.00100000005) | f1 < Math_fround(.00100000005)) f5 = Math_fround(0.0); else {
  f5 = Math_fround(f2 / f1);
  f5 = Math_fround(f5 * f5);
 }
 i3 = f16 < f5;
 f1 = Math_fround(f23 - f10);
 f24 = Math_fround(f24 - f11);
 f2 = Math_fround(f21 - f8);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f24 * f24)) + Math_fround(f2 * f2))));
 f24 = Math_fround(f22 - f12);
 f1 = Math_fround(f19 - f9);
 f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(f24 * f24) + Math_fround(f1 * f1))));
 if (f2 < Math_fround(.00100000005) | f1 < Math_fround(.00100000005)) {
  f23 = Math_fround(0.0);
  f24 = i3 ? f5 : f16;
  i20 = f24 < f23;
  f24 = i20 ? f23 : f24;
  return Math_fround(f24);
 }
 f23 = Math_fround(f2 / f1);
 f23 = Math_fround(f23 * f23);
 f24 = i3 ? f5 : f16;
 i20 = f24 < f23;
 f24 = i20 ? f23 : f24;
 return Math_fround(f24);
}

function __ZNK18PlayableController14GetBindingInfoER13dynamic_arrayIP14DirectorPlayerLj4EERS0_IP8PlayableLj4EERS0_IiLj4EE(i9, i5, i8, i10) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = i9 + 4 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = i5 + 12 | 0;
  i1 = HEAP32[i9 + 16 >> 2] << 2;
  i2 = i1 >> 2;
  HEAP32[i7 >> 2] = i2;
  i3 = i5 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 }
 i1 = i9 + 24 | 0;
 if ((i1 | 0) != (i8 | 0)) {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = i8 + 12 | 0;
  i1 = HEAP32[i9 + 36 >> 2] << 2;
  i2 = i1 >> 2;
  HEAP32[i6 >> 2] = i2;
  i3 = i8 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  } else i1 = HEAP32[i8 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 }
 i1 = i9 + 64 | 0;
 if ((i1 | 0) == (i10 | 0)) return;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i10 + 12 | 0;
 i1 = HEAP32[i9 + 76 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  break;
 } else i1 = HEAP32[i10 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 return;
}

function __ZN4Mesh12SetIndexDataEiiPKv16GfxPrimitiveTypei(i1, i11, i13, i14, i10, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 4 | 0;
 i6 = i15;
 i7 = i15 + 8 | 0;
 i9 = i1 + 32 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i4 + 128 >> 2] | 0;
 i1 = HEAP32[i8 + (i11 * 52 | 0) + 36 >> 2] << 1;
 i5 = (i13 << 1) - i1 | 0;
 i2 = i4 + 112 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + (HEAP32[i8 + (i11 * 52 | 0) + 32 >> 2] | 0) | 0;
 if ((i5 | 0) > 0) {
  HEAP32[i6 >> 2] = i8 + i1;
  HEAP8[i7 >> 0] = 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6insertENS_11__wrap_iterIPKhEEjRS6_(i2, i3, i5, i7) | 0;
 } else {
  i2 = i8 + (0 - i5) | 0;
  if (i5 | 0) {
   i4 = i4 + 116 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = i1 - i2 | 0;
   if (!i3) i2 = i1; else {
    _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   i1 = i8 + i3 | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i1;
  }
 }
 i6 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i6 + 128 >> 2] | 0;
 HEAP32[i7 + (i11 * 52 | 0) + 36 >> 2] = i13;
 HEAP32[i7 + (i11 * 52 | 0) + 40 >> 2] = i10;
 i2 = i11 + 1 | 0;
 i5 = ((HEAP32[i6 + 132 >> 2] | 0) - i7 | 0) / 52 | 0;
 if (i2 >>> 0 < i5 >>> 0) {
  i3 = (i13 << 1) + (HEAP32[i7 + (i11 * 52 | 0) + 32 >> 2] | 0) | 0;
  HEAP32[i7 + (i2 * 52 | 0) + 32 >> 2] = i3;
  i1 = i11 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) {
   i4 = i1;
   while (1) {
    i3 = (HEAP32[i7 + (i2 * 52 | 0) + 36 >> 2] << 1) + i3 | 0;
    HEAP32[i7 + (i4 * 52 | 0) + 32 >> 2] = i3;
    i1 = i4 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break; else {
     i2 = i4;
     i4 = i1;
    }
   }
  }
 }
 if (i12 & 8 | 0) {
  STACKTOP = i15;
  return;
 }
 if (!(i12 & 1)) {
  i2 = HEAP32[i7 + (i11 * 52 | 0) + 32 >> 2] | 0;
  i12 = HEAP32[i6 + 112 >> 2] | 0;
  i11 = (HEAP32[i6 + 116 >> 2] | 0) - i12 | 0;
  i2 = (i11 | 0) != 0 & i11 >>> 0 > i2 >>> 0 ? i12 + i2 | 0 : 0;
  if ((i13 | 0) > 0) i1 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   HEAP16[i2 + (i1 << 1) >> 1] = HEAP32[i14 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
  STACKTOP = i15;
  return;
 } else {
  i2 = HEAP32[i7 + (i11 * 52 | 0) + 32 >> 2] | 0;
  i12 = HEAP32[i6 + 112 >> 2] | 0;
  i11 = (HEAP32[i6 + 116 >> 2] | 0) - i12 | 0;
  i2 = (i11 | 0) != 0 & i11 >>> 0 > i2 >>> 0 ? i12 + i2 | 0 : 0;
  if ((i13 | 0) > 0) i1 = 0; else {
   STACKTOP = i15;
   return;
  }
  do {
   HEAP16[i2 + (i1 << 1) >> 1] = HEAP16[i14 + (i1 << 1) >> 1] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
  STACKTOP = i15;
  return;
 }
}

function __Z29GameObject_Set_Custom_PropTagP12Il2CppObjectP12Il2CppString(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i7 = i12 + 48 | 0;
 i11 = i12 + 16 | 0;
 i8 = i12 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 if (__ZNK11ICallString6IsNullEv(i7) | 0) {
  if (!i10) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i10) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 514703 | 0, 0, gb + 514726 | 0, 340, 1, i1, 0, 0);
  STACKTOP = i12;
  return;
 }
 i2 = __Z13GetTagManagerv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i7);
 HEAP32[i11 >> 2] = 0;
 i3 = i11 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i11 + 24 | 0;
 i13 = gb + 63648 | 0;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i11 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i5 = HEAP8[i8 + 11 >> 0] | 0;
 i13 = i5 << 24 >> 24 < 0;
 i4 = i13 ? HEAP32[i8 >> 2] | 0 : i8;
 i5 = i13 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
 if (i5 >>> 0 > 15) {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i11 + 4 >> 2] = i5;
  i1 = (i13 | 0) == 0 ? i1 : i13;
 }
 _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i3 >> 2] = i5;
 i2 = __ZN10TagManager11StringToTagERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i2, i11) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i11 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if ((i2 | 0) == -1) {
  HEAP32[i9 >> 2] = __ZNK11ICallString16GetRawCharBufferEv(i7) | 0;
  __Z6FormatPKcz(i11, gb + 514827 | 0, i9);
  if (!i10) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i10) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11, 0, gb + 514726 | 0, 346, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i12;
  return;
 }
 if (!i10) {
  i13 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i10) | 0;
 if (!i1) {
  i13 = i10;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 }
 __ZN10GameObject6SetTagEj(i1, i2);
 STACKTOP = i12;
 return;
}

function __ZNK5physx19NpArticulationJoint12getChildPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i3;
 i20 = HEAP32[i2 + 200 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 124 >> 2] | 0, i18 | 0, i20 | 0);
 i2 = (HEAP32[i2 + 12 >> 2] & 2 | 0) == 0 ? i2 + 52 | 0 : (HEAP32[i2 + 16 >> 2] | 0) + 28 | 0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(f9 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f7 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i18 >> 2]);
 f4 = Math_fround(f9 * f14);
 f12 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f8 * f12));
 f10 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f19 * f10));
 f6 = Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f9 * f7) + Math_fround(f16 * Math_fround(Math_fround(f19 * f12) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f12 * f4) + Math_fround(Math_fround(f8 * f7) + Math_fround(f16 * Math_fround(Math_fround(f9 * f10) - Math_fround(f19 * f14)))));
 f4 = Math_fround(Math_fround(Math_fround(f19 * f7) + Math_fround(f16 * Math_fround(Math_fround(f8 * f14) - Math_fround(f9 * f12)))) + Math_fround(f10 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i18 + 20 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) + f4);
 f9 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(Math_fround(f11 * f16) + Math_fround(f15 * f12))) - Math_fround(f13 * f14));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f10))) - Math_fround(f17 * f12));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f14)) - Math_fround(f11 * f12)) - Math_fround(f13 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14)) + Math_fround(f13 * f12)) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN8Animator23SetPlaybackTimeInternalEf(i9, f10) {
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 36 | 0;
 i11 = i14 + 32 | 0;
 i6 = i14 + 16 | 0;
 i8 = i14;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 f12 = Math_fround(__ZN14AvatarPlayback9PlayFrameEfRPN7mecanim9animation12AvatarMemoryERPNS1_16ControllerMemoryE(i9 + 504 | 0, f10, i7, i11));
 if (!(HEAP32[i7 >> 2] | 0)) {
  HEAPF32[i9 + 552 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 556 >> 2] = Math_fround(0.0);
  STACKTOP = i14;
  return;
 }
 if (HEAP32[i9 + 108 >> 2] | 0) {
  i2 = i9 + 624 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i3 = i9 + 136 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4) {
    i5 = i9 + 148 | 0;
    if (!(HEAP32[i5 >> 2] | 0)) {
     i1 = i9 + 112 | 0;
     HEAP32[i3 >> 2] = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i4, i1, i5) | 0;
     __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(i4, i1);
     i1 = HEAP32[i2 >> 2] | 0;
    }
   }
   __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE(i1, i9 + 112 | 0);
  }
 }
 i2 = i9 + 556 | 0;
 HEAPF32[i2 >> 2] = f10;
 i3 = i9 + 136 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = i9 + 148 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 177508 + 8;
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i6 + 8 >> 2] = i5;
 HEAP32[i6 + 12 >> 2] = i1;
 i1 = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(HEAP32[i7 >> 2] | 0, i6, i4) | 0;
 do if (!i1) {
  i1 = i9 + 112 | 0;
  __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i1);
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, 4, i9 + 116 | 0, 0, gb + 913345 | 0, 415) | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = gb + 177508 + 8;
  HEAP32[i8 + 4 >> 2] = i5;
  HEAP32[i8 + 8 >> 2] = i5;
  HEAP32[i8 + 12 >> 2] = i6;
  i8 = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(HEAP32[i7 >> 2] | 0, i8, i4) | 0;
  HEAP32[i3 >> 2] = i8;
  if (!i8) {
   HEAPF32[i9 + 552 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   break;
  } else {
   i13 = 15;
   break;
  }
 } else {
  HEAP32[i3 >> 2] = i1;
  i1 = i9 + 112 | 0;
  i13 = 15;
 } while (0);
 if ((i13 | 0) == 15) {
  HEAPF32[i9 + 552 >> 2] = Math_fround(f10 - f12);
  __ZN26AnimatorControllerPlayable15SetRecorderDataEPN7mecanim9animation16ControllerMemoryERNS0_6memory9AllocatorE(HEAP32[i9 + 624 >> 2] | 0, HEAP32[i11 >> 2] | 0, i1);
 }
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 0) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i12, i1, 1);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i12, i1, 1); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc13ClothBulkData15exportExtraDataERNS_22PxSerializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 4 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 16 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 32 >> 2] & 2147483647;
  if (i2 | HEAP32[i4 + 28 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 * 12 | 0);
 }
 i1 = HEAP32[i4 + 36 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 40 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 56 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 52 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 68 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 64 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 72 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 80 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 76 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i2 = HEAP32[i4 + 84 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i4 + 92 >> 2] & 2147483647;
  if (i1 | HEAP32[i4 + 88 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, i1 * 36 | 0);
 }
 i1 = HEAP32[i4 + 96 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 104 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 100 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 108 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 116 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 112 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 120 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 128 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 124 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 }
 i1 = HEAP32[i4 + 144 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i4 + 152 >> 2] | 0;
 if (!(i2 & 2147483647 | HEAP32[i4 + 148 >> 2])) return;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 4 | 0);
 return;
}

function __ZN12LightsModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i3 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 16 | 0, i4);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 12 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 20 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 21 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 22 >> 0] = i1;
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 24 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 288 | 0, i4);
 i1 = i3 + 552 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN12GUIClipState10BeginOnGUIER10InputEvent(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i6 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5 + 140 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i8;
 f11 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i6 + 12 >> 2]));
 f10 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i6 + 16 >> 2]));
 HEAPF32[i5 + 148 >> 2] = f11;
 HEAPF32[i5 + 152 >> 2] = f10;
 __ZN10Matrix4x4f11SetIdentityEv(i5 + 12 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i5 + 76 | 0) | 0;
 i8 = i5 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i4;
 if (!((i4 | 0) == (i1 | 0) | (i2 | 0) == (i1 | 0))) {
  i2 = i2 + (~(((i2 + -56 - i1 | 0) >>> 0) / 56 | 0) * 56 | 0) | 0;
  HEAP32[i8 >> 2] = i2;
 }
 HEAPF32[i7 + 16 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i7 + 20 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i7 + 24 >> 2] = Math_fround(4.0e4);
 HEAPF32[i7 + 28 >> 2] = Math_fround(4.0e4);
 HEAPF32[i7 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i7 + 4 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i7 + 8 >> 2] = Math_fround(4.0e4);
 HEAPF32[i7 + 12 >> 2] = Math_fround(4.0e4);
 i1 = i7 + 32 | 0;
 HEAP32[i1 >> 2] = 1176256512;
 i3 = i7 + 36 | 0;
 HEAP32[i3 >> 2] = 1176256512;
 i4 = i7 + 40 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((i2 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i5, i7);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + -56 | 0;
  __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i5, i6, i8);
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 40 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 44 >> 2] = HEAP32[i7 + 44 >> 2];
  HEAP32[i2 + 48 >> 2] = HEAP32[i7 + 48 >> 2];
  HEAP32[i2 + 52 >> 2] = HEAP32[i7 + 52 >> 2];
  i7 = (HEAP32[i8 >> 2] | 0) + 56 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = i7;
  i8 = i8 + -56 | 0;
  __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i5, i6, i8);
  STACKTOP = i9;
  return;
 }
}

function __Z20SkeletonBoneFromMonoRK16MonoSkeletonBoneR12SkeletonBone(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __Z24scripting_cpp_string_forP12Il2CppString(i10, HEAP32[i8 >> 2] | 0);
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i5 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 i5 = i9 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i4 >>> 0 > i3 >>> 0) {
  i7 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i4 - i3 | 0, i7, 0, i7, i4, i6);
 } else {
  i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i4;
   break;
  } else {
   HEAP8[i5 >> 0] = i4;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i1 = i9 + 16 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i10, HEAP32[i8 + 4 >> 2] | 0);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i7 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 i7 = i1 + 11 | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i4 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i6 >>> 0 > i4 >>> 0) {
  i7 = i3 ? HEAP32[i9 + 20 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i9 + 20 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 i10 = i9 + 32 | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i10 = i9 + 44 | 0;
 i7 = i8 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i10 = i9 + 60 | 0;
 i9 = i8 + 36 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i10, i7, i3, i4, i8, i5, i9) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, f6 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = i7 + -1 | 0;
 i13 = i3 + -1 | 0;
 f2 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i15 = i4 + -1 | 0;
 i18 = i8 + -1 | 0;
 i13 = (i3 | 0) < 1 ? 0 : (i18 | 0) < (i13 | 0) ? i18 : i13;
 i17 = Math_imul((i7 | 0) < 1 ? 0 : (i15 | 0) < (i17 | 0) ? i15 : i17, i8) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 f12 = Math_fround(f2 * Math_fround(HEAP16[i4 + (i13 + i17 << 1) >> 1] | 0));
 i16 = (i3 | 0) < 0 ? 0 : (i18 | 0) < (i3 | 0) ? i18 : i3;
 f6 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAP16[i4 + (i16 + i17 << 1) >> 1] | 0)) * Math_fround(-2.0)) - f12);
 i5 = i3 + 1 | 0;
 i5 = (i3 | 0) < -1 ? 0 : (i18 | 0) < (i5 | 0) ? i18 : i5;
 f14 = Math_fround(f2 * Math_fround(HEAP16[i4 + (i5 + i17 << 1) >> 1] | 0));
 f6 = Math_fround(f6 - f14);
 i3 = i7 + 1 | 0;
 i3 = Math_imul((i7 | 0) < -1 ? 0 : (i15 | 0) < (i3 | 0) ? i15 : i3, i8) | 0;
 f1 = Math_fround(f2 * Math_fround(HEAP16[i4 + (i13 + i3 << 1) >> 1] | 0));
 f6 = Math_fround(f1 + f6);
 f6 = Math_fround(f6 + Math_fround(Math_fround(f2 * Math_fround(HEAP16[i4 + (i16 + i3 << 1) >> 1] | 0)) * Math_fround(2.0)));
 f11 = Math_fround(f2 * Math_fround(HEAP16[i4 + (i5 + i3 << 1) >> 1] | 0));
 f6 = Math_fround(f11 + f6);
 f6 = Math_fround(f6 / Math_fround(HEAPF32[i9 >> 2]));
 i8 = Math_imul((i7 | 0) < 0 ? 0 : (i15 | 0) < (i7 | 0) ? i15 : i7, i8) | 0;
 f1 = Math_fround(f14 + Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAP16[i4 + (i13 + i8 << 1) >> 1] | 0)) * Math_fround(-2.0)) - f12) - f1));
 f1 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAP16[i4 + (i5 + i8 << 1) >> 1] | 0)) * Math_fround(2.0)) + f1));
 f1 = Math_fround(f1 / Math_fround(HEAPF32[i9 + 8 >> 2]));
 f2 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(64.0)) + Math_fround(f1 * f1));
 if (f2 == Math_fround(0.0)) {
  f14 = f2;
  f11 = Math_fround(f6 * f14);
  f11 = Math_fround(-f11);
  f12 = Math_fround(f14 * Math_fround(8.0));
  f14 = Math_fround(f1 * f14);
  f14 = Math_fround(-f14);
  HEAPF32[i10 >> 2] = f11;
  i18 = i10 + 4 | 0;
  HEAPF32[i18 >> 2] = f12;
  i18 = i10 + 8 | 0;
  HEAPF32[i18 >> 2] = f14;
  return;
 }
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2))));
 f11 = Math_fround(f6 * f14);
 f11 = Math_fround(-f11);
 f12 = Math_fround(f14 * Math_fround(8.0));
 f14 = Math_fround(f1 * f14);
 f14 = Math_fround(-f14);
 HEAPF32[i10 >> 2] = f11;
 i18 = i10 + 4 | 0;
 HEAPF32[i18 >> 2] = f12;
 i18 = i10 + 8 | 0;
 HEAPF32[i18 >> 2] = f14;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_(i11, i12, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = i12 + 32 | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i7 = i9 + -1 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i1 = (Math_imul((Math_imul((Math_imul((Math_imul(i8 >>> 24 ^ -2128831035, 16777619) | 0) ^ i8 >>> 16 & 255, 16777619) | 0) ^ i8 >>> 8 & 255, 16777619) | 0) ^ i8 & 255, 16777619) | 0) & i7;
 i14 = i12 + 28 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i6 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
 i10 = HEAP8[i12 + 8 >> 0] | 0;
 L1 : do if ((i6 | 0) == (i4 | 0)) i4 = 16; else {
  i2 = i12 + 12 | 0;
  L3 : do if (!(i10 << 24 >> 24)) {
   i3 = 0;
   i2 = i4;
   while (1) {
    if ((i8 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i7;
    i2 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     i4 = 20;
     break L1;
    }
   }
  } else {
   if (!(HEAP32[i12 + 4 >> 2] | 0)) {
    i3 = 0;
    i2 = i4;
    while (1) {
     if ((i8 | 0) == (i2 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i7;
     i2 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
     if ((i6 | 0) == (i2 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else {
    i5 = HEAP32[i2 >> 2] | 0;
    i2 = -1;
    i3 = 0;
    do {
     if ((i5 | 0) == (i4 | 0)) i2 = (i2 | 0) == -1 ? i1 : i2; else if ((i8 | 0) == (i4 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i7;
     i4 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
    } while ((i6 | 0) != (i4 | 0));
   }
   i1 = (i2 | 0) == -1 ? i1 : i2;
   i4 = 16;
   break L1;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = -1;
   i4 = 16;
  } else {
   HEAP32[i11 >> 2] = i12;
   HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
   HEAP32[i11 + 8 >> 2] = i15 + (i9 << 3);
   HEAP8[i11 + 12 >> 0] = 0;
   return;
  }
 } while (0);
 if ((i4 | 0) == 16) if (!(i10 << 24 >> 24)) i4 = 20; else {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i4 = 20; else if ((HEAP32[i12 + 12 >> 2] | 0) == (HEAP32[i15 + (i1 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i4 = 20;
 }
 if ((i4 | 0) == 20) {
  i10 = i12 + 36 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i10 = i13;
 i13 = HEAP32[i10 + 4 >> 2] | 0;
 i15 = i15 + (i1 << 3) | 0;
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = i13;
 i15 = HEAP32[i14 >> 2] | 0;
 i16 = i15 + (HEAP32[i16 >> 2] << 3) | 0;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
 HEAP32[i11 + 8 >> 2] = i16;
 HEAP8[i11 + 12 >> 0] = 1;
 return;
}

function __ZN12_GLOBAL__N_110Connection9setCameraEPKcRKN5physx6PxVec3ES6_S6_(i20, i4, i1, i2, i3) {
 i20 = i20 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21 + 56 | 0;
 i19 = i21 + 48 | 0;
 i18 = i21;
 i13 = i21 + 4 | 0;
 HEAP32[i13 >> 2] = gb + 150368 + 8;
 HEAP32[i13 + 4 >> 2] = i4;
 i14 = i13 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 i15 = i13 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 + 4 >> 2];
 i16 = i13 + 16 | 0;
 HEAP32[i16 >> 2] = HEAP32[i1 + 8 >> 2];
 i10 = i13 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 i11 = i13 + 24 | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 + 4 >> 2];
 i12 = i13 + 28 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 + 8 >> 2];
 i7 = i13 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 i8 = i13 + 36 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 + 4 >> 2];
 i9 = i13 + 40 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i17 >> 2] = gb + 149652 + 8;
 i6 = i17 + 4 | 0;
 HEAP32[i6 >> 2] = i18;
 HEAP32[i18 >> 2] = 1;
 i1 = i4 | 0 ? i4 : gb + 1576256 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = i17;
  i2 = 5;
  i3 = i18;
  i4 = 0;
  i5 = gb + 149652 + 8 | 0;
 } else {
  i4 = (_strlen(i1) | 0) + 1 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = i17;
  i2 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i5 = HEAP32[i17 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, i17 | 0, i14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i15 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i10 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i11 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i7 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i17 | 0, i9 | 0);
 i20 = i20 + 28 | 0;
 i16 = HEAP32[i20 >> 2] | 0;
 i18 = mftCall_iiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 20 >> 2] | 0, i16 | 0, HEAP32[i18 >> 2] | 0, 1, 0, 0) | 0;
 HEAP32[i19 >> 2] = gb + 149708 + 8;
 HEAP32[i19 + 4 >> 2] = i18;
 HEAP8[i17 >> 0] = 23;
 mftCall_iiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, i17 | 0, 1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i19 | 0);
 i20 = HEAP32[i20 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i20 >> 2] | 0) + 28 >> 2] | 0, i20 | 0);
 STACKTOP = i21;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager16createControllerERKNS_16PxControllerDescE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i6 = i10 + 4 | 0;
 i9 = i10;
 if (!(mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 switch (HEAP32[i1 + 104 >> 2] | 0) {
 case 0:
  {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, 512, (i4 ? gb + 658802 | 0 : gb + 837976 | 0) | 0, gb + 657349 | 0, 126) | 0;
   i5 = i7 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   __ZN5physx3Cct13BoxControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE(i4, i1, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0, HEAP32[i5 >> 2] | 0);
   i5 = i4;
   i4 = (i4 | 0) == 0 ? 0 : i4 + 8 | 0;
   break;
  }
 case 1:
  {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, 512, (i4 ? gb + 658926 | 0 : gb + 837976 | 0) | 0, gb + 657349 | 0, 132) | 0;
   i5 = i7 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   __ZN5physx3Cct17CapsuleControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE(i4, i1, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0, HEAP32[i5 >> 2] | 0);
   i5 = i4;
   i4 = (i4 | 0) == 0 ? 0 : i4 + 8 | 0;
   break;
  }
 default:
  {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 HEAP32[i6 >> 2] = i4;
 if (!i4) {
  i9 = i5;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i7 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 72 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_3Cct10ControllerENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i6) | 0;
 HEAP32[i4 + 464 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0) | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i9 | 0, 1, 0) | 0;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i7 + 76 | 0, i9, i8) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 i9 = i5;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 4 | 0;
 i6 = i11;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 i1 = i7 + 460 | 0;
 i9 = i8 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i10 = i8 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 464 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 465 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 352 | 0, i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i8, i7 + 360 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i7 + 416 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i12 = i8 + 8 | 0;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i4 = i7 + 420 | 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
 }
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i3, i1, i5, 1);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1 << 2);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 380 | 0, i8);
 __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 436 | 0, i8);
 i1 = i7 + 466 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 16 | 0;
 i11 = i13;
 i8 = i7 + 44 | 0;
 i9 = i7 + 4 | 0;
 if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) {
  i10 = i7 + 36 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 + 40 >> 2] | 0;
  i1 = i3 + (i4 * 12 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i5, i7, i2);
  i1 = HEAP32[i5 >> 2] | 0;
  i10 = i7 + 36 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 + 40 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i3 + (i4 * 12 | 0) | 0 : i3 + (i1 * 12 | 0) | 0;
 }
 if ((i1 | 0) != (i3 + (i4 * 12 | 0) | 0)) {
  i12 = i1;
  i12 = i12 + 8 | 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = i2;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj(i7, 1, 0);
 __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i5, i7, i11);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  do if (!(HEAP8[i7 + 8 >> 0] | 0)) i12 = 14; else {
   i3 = HEAP32[i9 >> 2] | 0;
   if (!i3) i12 = 14; else {
    i1 = HEAP32[i10 >> 2] | 0;
    i4 = HEAP32[i7 + 12 >> 2] | 0;
    i5 = HEAP32[i1 + (i6 * 12 | 0) >> 2] | 0;
    i2 = HEAP32[i7 + 16 >> 2] | 0;
    if ((i4 | 0) == (i5 | 0)) {
     if ((i2 | 0) != (HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2] | 0)) i12 = 11;
    } else i12 = 11;
    if ((i12 | 0) == 11) {
     if ((i2 | 0) != (i5 | 0)) {
      i12 = 14;
      break;
     }
     if ((i4 | 0) != (HEAP32[i1 + (i6 * 12 | 0) + 4 >> 2] | 0)) {
      i12 = 14;
      break;
     }
    }
    HEAP32[i9 >> 2] = i3 + -1;
   }
  } while (0);
  if ((i12 | 0) == 14) {
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i1 = i1 + (i6 * 12 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i1 = (HEAP32[i10 >> 2] | 0) + (i6 * 12 | 0) | 0;
 } else i1 = (HEAP32[i10 >> 2] | 0) + (i1 * 12 | 0) | 0;
 i12 = i1;
 i12 = i12 + 8 | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_(i3, i4, i5, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i3, i4, i5, i8) | 0;
 if (mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 4 >> 2] | 0;
  i12 = i6;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i11;
  i1 = i6;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i9;
  i1 = i2 + 1 | 0;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, i4 | 0) | 0) {
   i10 = HEAP32[i4 >> 2] | 0;
   i11 = HEAP32[i4 + 4 >> 2] | 0;
   i1 = i5;
   i9 = HEAP32[i1 + 4 >> 2] | 0;
   i12 = i4;
   HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 + 4 >> 2] = i9;
   i12 = i5;
   HEAP32[i12 >> 2] = i10;
   HEAP32[i12 + 4 >> 2] = i11;
   if (mftCall_iii(HEAP32[i8 >> 2] | 0, i4 | 0, i3 | 0) | 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i12 = HEAP32[i3 + 4 >> 2] | 0;
    i9 = i4;
    i10 = HEAP32[i9 + 4 >> 2] | 0;
    i1 = i3;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i1 + 4 >> 2] = i10;
    i1 = i4;
    HEAP32[i1 >> 2] = i11;
    HEAP32[i1 + 4 >> 2] = i12;
    i1 = i2 + 3 | 0;
   } else i1 = i2 + 2 | 0;
  }
 } else i1 = i2;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i7 | 0, i6 | 0) | 0)) {
  i12 = i1;
  return i12 | 0;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i7;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i6;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i7;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i6 | 0, i5 | 0) | 0)) {
  i12 = i1 + 1 | 0;
  return i12 | 0;
 }
 i10 = HEAP32[i5 >> 2] | 0;
 i11 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i6;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i6;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
  i12 = i1 + 2 | 0;
  return i12 | 0;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i5;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i5;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 if (!(mftCall_iii(HEAP32[i8 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
  i12 = i1 + 3 | 0;
  return i12 | 0;
 }
 i10 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i4;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = i3;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = i4;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i1 + 4 | 0;
 return i12 | 0;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE12__move_rangeEPS1_S5_S5_(i1, i14, i11, i2) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i10 = i1 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i5 = i7 - i2 >> 4;
 i9 = i14 + (i5 << 4) | 0;
 if (i9 >>> 0 < i11 >>> 0) {
  i6 = i12 + 4 | 0;
  i4 = i9;
  i1 = i7;
  do {
   i8 = HEAP8[i4 + 11 >> 0] | 0;
   i2 = i8 << 24 >> 24 < 0;
   i3 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
   i8 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 + 12 >> 2] = i2;
   if (i8 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    i13 = 25;
   } else if (i8 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i8;
    if (i8) i13 = 27;
   } else i13 = 25;
   if ((i13 | 0) == 25) {
    i16 = i8 + 16 & -16;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i16, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = i16 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i8;
    i1 = i2;
    i13 = 27;
   }
   if ((i13 | 0) == 27) {
    i13 = 0;
    _memcpy(i1 | 0, i3 | 0, i8 | 0) | 0;
   }
   HEAP8[i1 + i8 >> 0] = 0;
   i4 = i4 + 16 | 0;
   i1 = (HEAP32[i10 >> 2] | 0) + 16 | 0;
   HEAP32[i10 >> 2] = i1;
  } while (i4 >>> 0 < i11 >>> 0);
 }
 if (!i5) {
  STACKTOP = i15;
  return;
 }
 do {
  i5 = i7;
  i7 = i7 + -16 | 0;
  i1 = i9;
  i9 = i9 + -16 | 0;
  do if ((i5 | 0) != (i1 | 0)) {
   i6 = HEAP8[i9 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   i8 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
   i6 = i3 ? HEAP32[i1 + -12 >> 2] | 0 : i6 & 255;
   i3 = i7 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i5 + -8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i6 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i5 + -12 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i5 + -12 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
 } while ((i9 | 0) != (i14 | 0));
 STACKTOP = i15;
 return;
}

function __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i3, i13) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i14 = mftCall_iiii(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, i13 | 0, 40, 4) | 0;
 i1 = i14;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i10 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i10) {
  i8 = i14 + 8 | 0;
  i9 = i14 + 16 | 0;
  i11 = i14 + 24 | 0;
  i12 = i14 + 32 | 0;
  i6 = i14;
  i7 = 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
  i3 = 0;
 } else {
  i7 = i3 + 4 | 0;
  i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
  i8 = i14 + 8 | 0;
  i9 = i14 + 16 | 0;
  i11 = i14 + 24 | 0;
  i12 = i14 + 32 | 0;
  i6 = 0;
  i4 = 0;
  i5 = 0;
  i2 = 0;
  i1 = 0;
  i3 = 0;
  while (1) {
   switch (HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] | 0) {
   case 6:
    {
     i4 = i4 + 1 | 0;
     HEAP32[i14 >> 2] = i4;
     break;
    }
   case 7:
    {
     i5 = i5 + 1 | 0;
     HEAP32[i8 >> 2] = i5;
     break;
    }
   case 8:
    {
     i2 = i2 + 1 | 0;
     HEAP32[i9 >> 2] = i2;
     break;
    }
   case 1:
    {
     i1 = i1 + 1 | 0;
     HEAP32[i11 >> 2] = i1;
     break;
    }
   case 3:
    {
     i3 = i3 + 1 | 0;
     HEAP32[i12 >> 2] = i3;
     break;
    }
   default:
    {}
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i10 >>> 0) {
    i6 = i14;
    i7 = i5;
    break L1;
   }
  }
 } while (0);
 i3 = i7 + i4 + i2 + i1 + i3 | 0;
 if (!i3) {
  i5 = 0;
  i3 = i7;
 } else {
  i5 = mftCall_iiii(HEAP32[HEAP32[i13 >> 2] >> 2] | 0, i13 | 0, i3 | 0, 1) | 0;
  _memset(i5 | 0, 0, i3 | 0) | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = i14 + 4 | 0;
 i17 = i6;
 i18 = i5 | 0 ? i5 - i17 | 0 : 0;
 HEAP32[i6 >> 2] = i18;
 i6 = i5 + i4 | 0;
 i16 = i14 + 12 | 0;
 i15 = i16;
 HEAP32[i16 >> 2] = i6 | 0 ? i6 - i15 | 0 : 0;
 i6 = i6 + i3 | 0;
 i3 = i14 + 20 | 0;
 i5 = i3;
 HEAP32[i3 >> 2] = i6 | 0 ? i6 - i5 | 0 : 0;
 i2 = i6 + i2 | 0;
 i6 = i14 + 28 | 0;
 i7 = i6;
 HEAP32[i6 >> 2] = i2 | 0 ? i2 - i7 | 0 : 0;
 i2 = i2 + i1 | 0;
 i10 = i14 + 36 | 0;
 i13 = i10;
 HEAP32[i10 >> 2] = i2 | 0 ? i2 - i13 | 0 : 0;
 _memset(((i18 | 0) == 0 ? 0 : i18 + i17 | 0) | 0, 0, i4 | 0) | 0;
 i4 = HEAP32[i16 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i15 | 0) | 0, 0, HEAP32[i8 >> 2] | 0) | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 _memset(((i8 | 0) == 0 ? 0 : i8 + i5 | 0) | 0, 0, HEAP32[i9 >> 2] | 0) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 _memset(((i9 | 0) == 0 ? 0 : i9 + i7 | 0) | 0, 0, HEAP32[i11 >> 2] | 0) | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 _memset(((i11 | 0) == 0 ? 0 : i11 + i13 | 0) | 0, 0, HEAP32[i12 >> 2] | 0) | 0;
 return i14 | 0;
}

function __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 i4 = i5 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i2 = HEAP32[i1 + (i3 * 20 | 0) >> 2] | 0;
   do if (i2 | 0) {
    if (!(HEAP32[i2 + 128 >> 2] | 0)) if (!(HEAP32[i2 + 136 >> 2] | 0)) break;
    __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i2, 0, -1, 0, 0);
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i6, i7, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
   } while (0);
   i1 = HEAP32[i1 + (i3 * 20 | 0) + 4 >> 2] | 0;
   do if (i1 | 0) {
    if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) break;
    __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i6, i7, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
   } while (0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0);
 }
 if (!(HEAP8[i5 + 104 >> 0] | 0)) {
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i8, 0, -1, 0, 0);
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 do if (i1 | 0) {
  if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) break;
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i6, i7, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
 } while (0);
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (!i1) {
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i8, 0, -1, 0, 0);
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i8, 0, -1, 0, 0);
  STACKTOP = i9;
  return;
 }
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i6, i7, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i8, 0, -1, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_(i11, i12, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = i12 + 32 | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i7 = i9 + -1 | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i1 = (Math_imul((Math_imul((Math_imul((Math_imul(i8 >>> 24 ^ -2128831035, 16777619) | 0) ^ i8 >>> 16 & 255, 16777619) | 0) ^ i8 >>> 8 & 255, 16777619) | 0) ^ i8 & 255, 16777619) | 0) & i7;
 i14 = i12 + 28 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i6 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
 i10 = HEAP8[i12 + 8 >> 0] | 0;
 L1 : do if ((i6 | 0) == (i4 | 0)) i4 = 16; else {
  i2 = i12 + 12 | 0;
  L3 : do if (!(i10 << 24 >> 24)) {
   i3 = 0;
   i2 = i4;
   while (1) {
    if ((i8 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i7;
    i2 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     i4 = 20;
     break L1;
    }
   }
  } else {
   if (!(HEAP32[i12 + 4 >> 2] | 0)) {
    i3 = 0;
    i2 = i4;
    while (1) {
     if ((i8 | 0) == (i2 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i7;
     i2 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
     if ((i6 | 0) == (i2 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else {
    i5 = HEAP32[i2 >> 2] | 0;
    i2 = -1;
    i3 = 0;
    do {
     if ((i5 | 0) == (i4 | 0)) i2 = (i2 | 0) == -1 ? i1 : i2; else if ((i8 | 0) == (i4 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i7;
     i4 = HEAP32[i15 + (i1 << 3) >> 2] | 0;
    } while ((i6 | 0) != (i4 | 0));
   }
   i1 = (i2 | 0) == -1 ? i1 : i2;
   i4 = 16;
   break L1;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = -1;
   i4 = 16;
  } else {
   HEAP32[i11 >> 2] = i12;
   HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
   HEAP32[i11 + 8 >> 2] = i15 + (i9 << 3);
   HEAP8[i11 + 12 >> 0] = 0;
   return;
  }
 } while (0);
 if ((i4 | 0) == 16) if (!(i10 << 24 >> 24)) i4 = 20; else {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i4 = 20; else if ((HEAP32[i12 + 12 >> 2] | 0) == (HEAP32[i15 + (i1 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i4 = 20;
 }
 if ((i4 | 0) == 20) {
  i10 = i12 + 36 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i10 = i13;
 i13 = HEAP32[i10 + 4 >> 2] | 0;
 i15 = i15 + (i1 << 3) | 0;
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = i13;
 i15 = HEAP32[i14 >> 2] | 0;
 i16 = i15 + (HEAP32[i16 >> 2] << 3) | 0;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
 HEAP32[i11 + 8 >> 2] = i16;
 HEAP8[i11 + 12 >> 0] = 1;
 return;
}

function __Z32TransferFileOverPlayerConnectionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvjS8_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 48 | 0;
 i11 = i13 + 36 | 0;
 i6 = i13 + 16 | 0;
 i17 = i13 + 12 | 0;
 i14 = i13 + 8 | 0;
 i16 = i1 + 11 | 0;
 HEAP32[i12 >> 2] = (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 HEAP32[i12 + 4 >> 2] = i3;
 _printf_console(gb + 460861 | 0, i12);
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i19 = i12;
 i18 = HEAP32[i19 + 4 >> 2] | 0;
 i15 = i9;
 HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i15 + 4 >> 2] = i18;
 HEAP32[i11 >> 2] = gb + 65660 + 8;
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP32[i6 + 16 >> 2] = 0;
 i15 = HEAP8[i16 >> 0] | 0;
 i15 = i15 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i15 & 255;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i14 >> 2] = i5 + i3;
 __ZN12CachedWriter9InitWriteER15CacheWriterBase(i6, i11);
 __ZN12CachedWriter5WriteEPKvj(i6, i17, 4);
 __ZN12CachedWriter5WriteEPKvj(i6, (HEAP8[i16 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, i15);
 __ZN12CachedWriter5WriteEPKvj(i6, i14, 4);
 if (i5 | 0) __ZN12CachedWriter5WriteEPKvj(i6, i4, i5);
 __ZN12CachedWriter5WriteEPKvj(i6, i2, i3);
 __ZN12CachedWriter15CompleteWritingEv(i6) | 0;
 i5 = HEAP32[gb + 1163120 >> 2] | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP16[i12 >> 1] = 20111;
 HEAP16[i12 + 2 >> 1] = 200;
 HEAP32[i12 + 4 >> 2] = i3;
 i3 = i5 + 140 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 HEAP8[i3 >> 0] = 0;
 i1 = HEAP32[i5 + 88 >> 2] | 0;
 i5 = i5 + 92 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv(HEAP32[i2 + 20 >> 2] | 0, i12, i6);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 HEAP8[i3 >> 0] = i4;
 HEAP32[i11 >> 2] = gb + 65660 + 8;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZNK9Heightmap39CalculateNormalSobelRespectingNeighborsEiiPK15TerrainRenderer(i8, i1, i2, i3, i4) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = i2 + -1 | 0;
 i13 = i3 + -1 | 0;
 f9 = Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i12, i13, i4));
 f9 = Math_fround(Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i12, i3, i4)) * Math_fround(-2.0)) - f9);
 i10 = i3 + 1 | 0;
 f9 = Math_fround(f9 - Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i12, i10, i4)));
 i11 = i2 + 1 | 0;
 f9 = Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i11, i13, i4)) + f9);
 f9 = Math_fround(f9 + Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i11, i3, i4)) * Math_fround(2.0)));
 f9 = Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i11, i10, i4)) + f9);
 f9 = Math_fround(f9 / Math_fround(HEAPF32[i1 + 88 >> 2]));
 f7 = Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i12, i13, i4));
 f7 = Math_fround(Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i2, i13, i4)) * Math_fround(-2.0)) - f7);
 f7 = Math_fround(f7 - Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i11, i13, i4)));
 f7 = Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i12, i10, i4)) + f7);
 f7 = Math_fround(f7 + Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i2, i10, i4)) * Math_fround(2.0)));
 f7 = Math_fround(Math_fround(__ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer(i1, i11, i10, i4)) + f7);
 f7 = Math_fround(f7 / Math_fround(HEAPF32[i1 + 96 >> 2]));
 f5 = Math_fround(-f9);
 HEAPF32[i8 >> 2] = f5;
 i1 = i8 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(8.0);
 f6 = Math_fround(-f7);
 i2 = i8 + 8 | 0;
 HEAPF32[i2 >> 2] = f6;
 f7 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(64.0)) + Math_fround(f7 * f7));
 if (f7 == Math_fround(0.0)) {
  f9 = f7;
  f5 = Math_fround(f9 * f5);
  f7 = Math_fround(f9 * Math_fround(8.0));
  f9 = Math_fround(f9 * f6);
  HEAPF32[i8 >> 2] = f5;
  HEAPF32[i1 >> 2] = f7;
  HEAPF32[i2 >> 2] = f9;
  return;
 }
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f7))));
 f5 = Math_fround(f9 * f5);
 f7 = Math_fround(f9 * Math_fround(8.0));
 f9 = Math_fround(f9 * f6);
 HEAPF32[i8 >> 2] = f5;
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i2 >> 2] = f9;
 return;
}

function __ZNK11b2EdgeShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i5, i21, i20, i3, i2) {
 i5 = i5 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(f12 - f14);
 f13 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(f13 - f15);
 f19 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f11 = Math_fround(f12 * f19);
 f18 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f13 * f18));
 f12 = Math_fround(Math_fround(f19 * f13) - Math_fround(f12 * f18));
 f14 = Math_fround(Math_fround(HEAPF32[i20 + 8 >> 2]) - f14);
 f15 = Math_fround(Math_fround(HEAPF32[i20 + 12 >> 2]) - f15);
 f13 = Math_fround(Math_fround(Math_fround(f19 * f14) + Math_fround(f18 * f15)) - f11);
 f14 = Math_fround(Math_fround(Math_fround(f19 * f15) - Math_fround(f18 * f14)) - f12);
 f15 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f17 = Math_fround(f17 - f15);
 f8 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) - f16);
 f4 = Math_fround(-f17);
 f9 = Math_fround(Math_fround(f17 * f17) + Math_fround(f8 * f8));
 f1 = Math_fround(Math_sqrt(Math_fround(f9)));
 if (f1 < Math_fround(1.1920929e-07)) {
  f7 = f8;
  f6 = f4;
 } else {
  f6 = Math_fround(Math_fround(1.0) / f1);
  f7 = Math_fround(f8 * f6);
  f6 = Math_fround(f6 * f4);
 }
 f10 = Math_fround(Math_fround(Math_fround(f15 - f11) * f7) + Math_fround(Math_fround(f16 - f12) * f6));
 f1 = Math_fround(Math_fround(f13 * f7) + Math_fround(f14 * f6));
 if (f1 == Math_fround(0.0)) {
  i21 = 0;
  return i21 | 0;
 }
 f1 = Math_fround(f10 / f1);
 if (f1 < Math_fround(0.0)) {
  i21 = 0;
  return i21 | 0;
 }
 if (f9 == Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i20 + 16 >> 2]) < f1) {
  i21 = 0;
  return i21 | 0;
 }
 f17 = Math_fround(Math_fround(Math_fround(f17 * Math_fround(Math_fround(f11 + Math_fround(f13 * f1)) - f15)) + Math_fround(f8 * Math_fround(Math_fround(f12 + Math_fround(f14 * f1)) - f16))) / f9);
 if (f17 < Math_fround(0.0) | f17 > Math_fround(1.0)) {
  i21 = 0;
  return i21 | 0;
 }
 HEAPF32[i21 + 8 >> 2] = f1;
 f4 = Math_fround(Math_fround(f7 * f19) - Math_fround(f6 * f18));
 f1 = Math_fround(Math_fround(f6 * f19) + Math_fround(f7 * f18));
 if (f10 > Math_fround(0.0)) {
  f19 = Math_fround(-f1);
  HEAPF32[i21 >> 2] = Math_fround(-f4);
  HEAPF32[i21 + 4 >> 2] = f19;
  i21 = 1;
  return i21 | 0;
 } else {
  HEAPF32[i21 >> 2] = f4;
  HEAPF32[i21 + 4 >> 2] = f1;
  i21 = 1;
  return i21 | 0;
 }
 return 0;
}

function __ZN4FMOD7SystemI9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE(i7, i1, i3, i2, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, d9 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   i1 = __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7GetFreeEi(i7 + 76 | 0, -1) | 0;
   if (!i1) {
    HEAP32[i5 >> 2] = 10;
    HEAP32[i5 + 4 >> 2] = gb + 859320;
    _printf(gb + 859330 | 0, i5) | 0;
    i8 = 10;
    STACKTOP = i6;
    return i8 | 0;
   } else {
    HEAP32[i8 >> 2] = HEAP32[i1 + 20 >> 2];
    i3 = i1 + 40 | 0;
    i5 = i1 + 48 | 0;
    i8 = i1 + 44 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    HEAP32[i4 + 8 >> 2] = HEAP32[i5 >> 2];
    HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i4;
    HEAP32[i8 >> 2] = i3;
    i4 = i2 + 56 | 0;
    HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i5 >> 2] = i2 + 52;
    HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] = i3;
    HEAP32[i4 >> 2] = i3;
    i4 = i2 + 320 | 0;
    i3 = i1 + 164 | 0;
    _JS_Sound_Play(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0.0, 0.0);
    _JS_Sound_SetLoopPoints(HEAP32[i3 >> 2] | 0, +(+HEAPF64[i2 + 328 >> 3]), +(+HEAPF64[i2 + 336 >> 3]));
    HEAP32[i1 + 64 >> 2] = i2;
    HEAP32[i1 + 68 >> 2] = 0;
    i3 = i1 + 128 | 0;
    HEAP32[i3 >> 2] = _JS_Sound_GetLength(HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i3 + 4 >> 2] = 0;
    d9 = +__Z19GetTimeSinceStartupv() * 44100.0;
    i3 = ~~d9 >>> 0;
    i4 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
    i5 = i1 + 104 | 0;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i4;
    i5 = i1 + 120 | 0;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i4;
    HEAPF32[i1 + 140 >> 2] = Math_fround(44100.0);
    i5 = i1 + 52 | 0;
    i4 = i1 + 60 | 0;
    i3 = i1 + 56 | 0;
    i8 = HEAP32[i3 >> 2] | 0;
    HEAP32[i8 + 8 >> 2] = HEAP32[i4 >> 2];
    HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i8;
    HEAP32[i3 >> 2] = i5;
    i8 = i7 + 68 | 0;
    HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i4 >> 2] = i7 + 64;
    HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] = i5;
    HEAP32[i8 >> 2] = i5;
    i8 = i7 + 36 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
    i8 = 0;
    STACKTOP = i6;
    return i8 | 0;
   }
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859320;
 _printf(gb + 853184 | 0, i4) | 0;
 i8 = 36;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN13LoadOperationC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 8 | 0;
 i7 = i2;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i5 = i1 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 65708 + 8;
 i5 = gb + 63200 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i7 = i6;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i1 + 68 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = gb + 63416 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 + 84 >> 2] = -1;
 HEAP32[i1 + 88 >> 2] = 4096;
 i7 = i1 + 92 | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = __Znwj(32) | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 4096;
 HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 16, i6, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i7 + 4 >> 0] = 1;
 i5 = i6;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i7 + 28 >> 2] = 0;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i1 + 112 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 100 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 104 >> 2] = 0;
 i3 = gb + 63416 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i1 + 116 >> 2] = -1;
 HEAP32[i1 + 120 >> 2] = 12288;
 i4 = i1 + 124 | 0;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = __Znwj(32) | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 16384;
 HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16384, 16, i6, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i4 + 4 >> 0] = 1;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i4 + 28 >> 2] = 0;
 i3 = i1 + 140 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 + 144 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 136 >> 2] = 0;
 i1 = i1 + 148 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN6b2Rope4StepEfi(i15, f14, i13) {
 i15 = i15 | 0;
 f14 = Math_fround(f14);
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i16 = 0;
 if (f14 == Math_fround(0.0)) return;
 f12 = Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_fround(HEAPF32[i15 + 36 >> 2]) * f14))));
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i4 = i15 + 8 | 0;
  i7 = i15 + 4 | 0;
  i8 = i15 + 16 | 0;
  i9 = i15 + 12 | 0;
  i10 = i15 + 28 | 0;
  i11 = i15 + 32 | 0;
  i3 = 0;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   i16 = i2 + (i3 << 3) | 0;
   i1 = HEAP32[i16 + 4 >> 2] | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 3) | 0;
   HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   i2 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2]) > Math_fround(0.0);
   i1 = HEAP32[i9 >> 2] | 0;
   if (i2) {
    f5 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) * f14);
    f6 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f14);
    i16 = i1 + (i3 << 3) | 0;
    f5 = Math_fround(f5 + Math_fround(HEAPF32[i16 >> 2]));
    HEAPF32[i16 >> 2] = f5;
    i16 = i1 + (i3 << 3) + 4 | 0;
    f6 = Math_fround(f6 + Math_fround(HEAPF32[i16 >> 2]));
    HEAPF32[i16 >> 2] = f6;
   } else {
    f5 = Math_fround(HEAPF32[i1 + (i3 << 3) >> 2]);
    f6 = Math_fround(HEAPF32[i1 + (i3 << 3) + 4 >> 2]);
   }
   f5 = Math_fround(f12 * f5);
   HEAPF32[i1 + (i3 << 3) >> 2] = f5;
   f6 = Math_fround(f12 * f6);
   HEAPF32[i1 + (i3 << 3) + 4 >> 2] = f6;
   i2 = HEAP32[i7 >> 2] | 0;
   f5 = Math_fround(f5 * f14);
   f6 = Math_fround(f6 * f14);
   i1 = i2 + (i3 << 3) | 0;
   HEAPF32[i1 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
   i1 = i2 + (i3 << 3) + 4 | 0;
   HEAPF32[i1 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i1 >> 2]));
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i15 >> 2] | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 if ((i13 | 0) > 0) {
  i1 = 0;
  do {
   __ZN6b2Rope7SolveC2Ev(i15);
   __ZN6b2Rope7SolveC3Ev(i15);
   __ZN6b2Rope7SolveC2Ev(i15);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
  i1 = HEAP32[i15 >> 2] | 0;
 }
 f5 = Math_fround(Math_fround(1.0) / f14);
 if ((i1 | 0) <= 0) return;
 i2 = i15 + 12 | 0;
 i3 = i15 + 4 | 0;
 i4 = i15 + 8 | 0;
 i1 = 0;
 do {
  i16 = HEAP32[i2 >> 2] | 0;
  i11 = HEAP32[i3 >> 2] | 0;
  i13 = HEAP32[i4 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i11 + (i1 << 3) >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i13 + (i1 << 3) >> 2]));
  f14 = Math_fround(HEAPF32[i11 + (i1 << 3) + 4 >> 2]);
  f14 = Math_fround(f5 * Math_fround(f14 - Math_fround(HEAPF32[i13 + (i1 << 3) + 4 >> 2])));
  HEAPF32[i16 + (i1 << 3) >> 2] = Math_fround(f5 * f12);
  HEAPF32[i16 + (i1 << 3) + 4 >> 2] = f14;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i15 >> 2] | 0));
 return;
}

function __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i12, i6, i4, i5) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i8 = i13 + 272 | 0;
 i2 = __ZNK5physx2Sc10StaticCore6getSimEv(i6) | 0;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i12 + 1236 >> 2] | 0;
 if (!i1) {
  i3 = i7 + 256 | 0;
  i1 = i7 + 260 | 0;
  HEAP32[i7 + 264 >> 2] = 0;
  i11 = i7 + 268 | 0;
  HEAP8[i3 >> 0] = 1;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i11 >> 2] = 64;
  __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb(i12, i2, i7, i4, i5);
  i11 = HEAP32[i11 >> 2] | 0;
  do if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i7 | 0) == (i1 | 0)) {
    HEAP8[i3 >> 0] = 0;
    break;
   }
   if (i1 | 0) {
    i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
   }
  } while (0);
 } else __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb(i12, i2, i1, i4, i5);
 i11 = HEAP32[i12 + 1216 >> 2] | 0;
 i9 = __ZNK5physx2Sc10StaticCore6getSimEv(i6) | 0;
 L15 : do if (i9 | 0) {
  mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
  i10 = i11 + 24 | 0;
  if (!(HEAP8[i10 >> 0] | 0)) i1 = i11 + 16 | 0; else {
   i1 = i11 + 16 | 0;
   __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i11 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i7, i8, 32);
  }
  i5 = Math_imul(HEAP32[i11 + 4 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  if ((i1 | 0) >= 0) {
   i6 = HEAP32[i11 + 12 >> 2] | 0;
   i2 = 0;
   i4 = i1;
   L22 : while (1) {
    while (1) {
     i1 = i2 + i4 >> 1;
     i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
     if (i3 >>> 0 <= i9 >>> 0 & (i3 + i5 | 0) >>> 0 > i9 >>> 0) break L22;
     if (i3 >>> 0 >= i9 >>> 0) break;
     if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else break L15;
    }
    i1 = i1 + -1 | 0;
    if ((i2 | 0) > (i1 | 0)) break L15; else i4 = i1;
   }
   i8 = i6 + (i1 * 12 | 0) + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i8 >> 2] = i9;
   if (HEAP8[i10 >> 0] | 0) HEAP32[i11 + 8 >> 2] = i1;
   HEAP8[i10 >> 0] = 0;
  }
 } while (0);
 i12 = i12 + 1416 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu15OBBTriangleTestC2ERKNS0_3BoxE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 100 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 104 >> 2] = HEAP32[i1 + 56 >> 2];
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i11 = HEAP32[i1 + 8 >> 2] | 0;
 i10 = HEAP32[i1 + 12 >> 2] | 0;
 i9 = HEAP32[i1 + 16 >> 2] | 0;
 i8 = HEAP32[i1 + 20 >> 2] | 0;
 i7 = HEAP32[i1 + 24 >> 2] | 0;
 i6 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 f18 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f17 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f14 = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f16 = Math_fround((HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f18);
 f16 = Math_fround(f16 + Math_fround((HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17));
 f16 = Math_fround(f16 + Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14));
 f15 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f18);
 f15 = Math_fround(f15 + Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17));
 f15 = Math_fround(f15 + Math_fround((HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14));
 f18 = Math_fround((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f18);
 f17 = Math_fround(f18 + Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f17));
 f14 = Math_fround(f17 + Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f14));
 HEAP32[i2 >> 2] = i13;
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i2 + 8 >> 2] = i7;
 HEAP32[i2 + 12 >> 2] = i12;
 HEAP32[i2 + 16 >> 2] = i9;
 HEAP32[i2 + 20 >> 2] = i6;
 HEAP32[i2 + 24 >> 2] = i11;
 HEAP32[i2 + 28 >> 2] = i8;
 HEAP32[i2 + 32 >> 2] = i5;
 HEAPF32[i2 + 72 >> 2] = f16;
 HEAPF32[i2 + 76 >> 2] = f15;
 HEAPF32[i2 + 80 >> 2] = f14;
 HEAP32[i2 + 36 >> 2] = i13;
 HEAP32[i2 + 40 >> 2] = i12;
 HEAP32[i2 + 44 >> 2] = i11;
 HEAP32[i2 + 48 >> 2] = i10;
 HEAP32[i2 + 52 >> 2] = i9;
 HEAP32[i2 + 56 >> 2] = i8;
 HEAP32[i2 + 60 >> 2] = i7;
 HEAP32[i2 + 64 >> 2] = i6;
 HEAP32[i2 + 68 >> 2] = i5;
 HEAP32[i2 + 84 >> 2] = i4;
 HEAP32[i2 + 88 >> 2] = i3;
 HEAP32[i2 + 92 >> 2] = i1;
 return;
}

function __ZN3MBP12updateObjectEjP9BoxPruner(i13, i8, i5) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i9 = i8 >>> 2;
 i4 = HEAP32[i13 + 28 >> 2] | 0;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 i11 = i10 + (i9 * 12 | 0) + 4 | 0;
 i6 = HEAP16[i11 >> 1] | 0;
 i7 = i6 & 65535;
 i1 = i10 + (i9 * 12 | 0) + 8 | 0;
 if (i6 << 16 >> 16 == 1) i2 = 4; else if (i6 << 16 >> 16) {
  i1 = (HEAP32[i13 + 96 + (i7 << 4) + 8 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
  i2 = 4;
 }
 L4 : do if ((i2 | 0) == 4) {
  i3 = 0;
  i2 = 0;
  do {
   if ((HEAP32[i4 + ((HEAPU16[i1 + (i3 << 2) + 2 >> 1] | 0) * 40 | 0) + 28 >> 2] | 0) != (i5 | 0)) {
    i15 = i1 + (i3 << 2) | 0;
    HEAP32[i12 + (i2 << 2) >> 2] = HEAPU16[i15 >> 1] | HEAPU16[i15 + 2 >> 1] << 16;
    i2 = i2 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i7 | 0));
  i5 = i2;
  if ((i6 & 65535) > 1) {
   i6 = HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] | 0;
   i15 = i13 + 4208 + (i7 << 2) | 0;
   HEAP32[(HEAP32[i13 + 96 + (i7 << 4) + 8 >> 2] | 0) + (i6 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i6;
  }
  switch (i5 | 0) {
  case 0:
   break L4;
  case 1:
   {
    i15 = i10 + (i9 * 12 | 0) + 8 | 0;
    i13 = HEAP32[i12 >> 2] | 0;
    HEAP16[i15 >> 1] = i13;
    HEAP16[i15 + 2 >> 1] = i13 >>> 16;
    break;
   }
  default:
   {
    i4 = i13 + 96 + (i5 << 4) | 0;
    i1 = i13 + 4208 + (i5 << 2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) == -1) {
     i3 = i13 + 96 + (i5 << 4) + 4 | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] = i1;
     i2 = i5 & 1073741823;
     if ((i1 + i2 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
      __ZN5physx2Gu9Container6ResizeEj(i4, i2) | 0;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     i15 = (HEAP32[i13 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i1 << 2) | 0;
     HEAP32[i3 >> 2] = i1 + i2;
     i1 = i15;
    } else {
     HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] = i2;
     i15 = (HEAP32[i13 + 96 + (i5 << 4) + 8 >> 2] | 0) + (i2 << 2) | 0;
     HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
     i1 = i15;
    }
    _memcpy(i1 | 0, i12 | 0, i5 << 2 | 0) | 0;
   }
  }
  HEAP16[i11 >> 1] = i5;
  STACKTOP = i14;
  return 1;
 } while (0);
 HEAP16[i11 >> 1] = 0;
 HEAP32[i10 + (i9 * 12 | 0) + 8 >> 2] = i8;
 i3 = HEAP32[i10 + (i9 * 12 | 0) >> 2] | 0;
 i2 = i13 + 5236 | 0;
 i4 = i13 + 5240 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  __ZN5physx2Gu9Container6ResizeEj(i2, 1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[(HEAP32[i13 + 5244 >> 2] | 0) + (i1 << 2) >> 2] = i3;
 STACKTOP = i14;
 return 1;
}

function __ZN12MeshRenderer18CalculateLocalAABBER4AABBRKS_RK4Mesh(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i3 = HEAP16[i1 + 218 >> 1] | 0;
 if (!(i3 << 16 >> 16)) {
  i11 = i2 + 48 | 0;
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  return;
 }
 i1 = i1 + 216 | 0;
 if (i3 << 16 >> 16 == 1) {
  i11 = (HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 128 >> 2] | 0) + ((HEAPU16[i1 >> 1] | 0) * 52 | 0) + 8 | 0;
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  return;
 }
 f4 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f8 = Math_fround(-f5);
 f7 = Math_fround(-f9);
 f6 = Math_fround(-f4);
 i11 = HEAPU16[i1 >> 1] | 0;
 i10 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 128 >> 2] | 0;
 i2 = i3 & 65535;
 i1 = 0;
 do {
  i3 = i11 + i1 | 0;
  f18 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 20 >> 2]);
  f21 = Math_fround(f18 - f15);
  f17 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 12 >> 2]);
  f14 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 24 >> 2]);
  f20 = Math_fround(f17 - f14);
  f16 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i10 + (i3 * 52 | 0) + 28 >> 2]);
  f19 = Math_fround(f16 - f13);
  f4 = f21 < f4 ? f21 : f4;
  f9 = f20 < f9 ? f20 : f9;
  f5 = f19 < f5 ? f19 : f5;
  f15 = Math_fround(f18 + f15);
  f14 = Math_fround(f17 + f14);
  f13 = Math_fround(f16 + f13);
  f6 = f6 < f15 ? f15 : f6;
  f7 = f7 < f14 ? f14 : f7;
  f8 = f8 < f13 ? f13 : f8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 f17 = Math_fround(Math_fround(f9 + f7) * Math_fround(.5));
 f18 = Math_fround(Math_fround(f5 + f8) * Math_fround(.5));
 f19 = Math_fround(Math_fround(f6 - f4) * Math_fround(.5));
 f20 = Math_fround(Math_fround(f7 - f9) * Math_fround(.5));
 f21 = Math_fround(Math_fround(f8 - f5) * Math_fround(.5));
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(f4 + f6) * Math_fround(.5));
 HEAPF32[i12 + 4 >> 2] = f17;
 HEAPF32[i12 + 8 >> 2] = f18;
 HEAPF32[i12 + 12 >> 2] = f19;
 HEAPF32[i12 + 16 >> 2] = f20;
 HEAPF32[i12 + 20 >> 2] = f21;
 return;
}

function __ZNK5physx19NpArticulationJoint13getParentPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i3;
 i20 = HEAP32[i2 + 196 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i20 >> 2] | 0) + 124 >> 2] | 0, i18 | 0, i20 | 0);
 i2 = (HEAP32[i2 + 12 >> 2] & 1 | 0) == 0 ? i2 + 24 | 0 : HEAP32[i2 + 16 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(f9 * Math_fround(2.0));
 f8 = Math_fround(f8 * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i18 + 12 >> 2]);
 f7 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i18 >> 2]);
 f4 = Math_fround(f9 * f14);
 f12 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f8 * f12));
 f10 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f19 * f10));
 f6 = Math_fround(Math_fround(f14 * f4) + Math_fround(Math_fround(f9 * f7) + Math_fround(f16 * Math_fround(Math_fround(f19 * f12) - Math_fround(f8 * f10)))));
 f5 = Math_fround(Math_fround(f12 * f4) + Math_fround(Math_fround(f8 * f7) + Math_fround(f16 * Math_fround(Math_fround(f9 * f10) - Math_fround(f19 * f14)))));
 f4 = Math_fround(Math_fround(Math_fround(f19 * f7) + Math_fround(f16 * Math_fround(Math_fround(f8 * f14) - Math_fround(f9 * f12)))) + Math_fround(f10 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i18 + 20 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) + f4);
 f9 = Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(Math_fround(f11 * f16) + Math_fround(f15 * f12))) - Math_fround(f13 * f14));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f13 * f16) + Math_fround(f15 * f10))) - Math_fround(f17 * f12));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f16) - Math_fround(f17 * f14)) - Math_fround(f11 * f12)) - Math_fround(f13 * f10));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * f14)) + Math_fround(f13 * f12)) - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7FrustumENS_12MatrixFormatE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i5 = i1 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 _memset(i1 + 64 | 0, 0, 276) | 0;
 HEAPF32[i1 + 340 >> 2] = Math_fround(1.0);
 i5 = i1 + 344 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i1 + 360 >> 2] = Math_fround(1.0);
 i6 = i1 + 364 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i1 + 380 >> 2] = Math_fround(1.0);
 i6 = i1 + 384 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAPF32[i1 + 400 >> 2] = Math_fround(1.0);
 i6 = i1 + 404 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP8[i6 + 32 >> 0] = 0;
 HEAP32[i1 + 432 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 i4 = i1 + 436 | 0;
 HEAP8[i4 >> 0] = 1;
 i3 = i1 + 340 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 348 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 352 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 356 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 360 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 364 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 368 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 372 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 376 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 380 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 384 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 388 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 392 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 396 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 400 >> 2] = HEAP32[i2 + 60 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i3, i3) | 0;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN13AnimationClip10FloatCurve8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i2 = i6 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 899332 | 0, gb + 1034188 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 16 | 0;
 i2 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898367 | 0, i2, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i3, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898362 | 0, i2, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i6, 1); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898384 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 24; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 24; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898377 | 0, gb + 899338 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNK5physx15PxVehicleWheels20computeSidewaysSpeedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i2 + 40 | 0;
 i15 = i2 + 12 | 0;
 i5 = i2;
 i1 = i1 + 104 | 0;
 i17 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i17 | 0);
 i17 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 124 >> 2] | 0, i15 | 0, i17 | 0);
 f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(f3 * f14);
 f6 = Math_fround(HEAPF32[i15 + 12 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * f6));
 f12 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f13 * f12));
 f10 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f11 = Math_fround(f11 - Math_fround(f8 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f8 * f14) + Math_fround(Math_fround(f13 * f6) + Math_fround(f3 * f10))) - Math_fround(f4 * f12));
 f7 = Math_fround(Math_fround(Math_fround(f4 * f10) + Math_fround(Math_fround(f8 * f6) + Math_fround(f3 * f12))) - Math_fround(f13 * f14));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f6) - Math_fround(f4 * f14)) - Math_fround(f13 * f10)) - Math_fround(f8 * f12));
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i1 | 0);
 f8 = Math_fround(Math_fround(HEAPF32[gb + 158836 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 4 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[gb + 158836 + 8 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f11 * f8) + Math_fround(f9 * f10)) + Math_fround(f7 * f13));
 f6 = Math_fround(Math_fround(f11 * f4) + Math_fround(Math_fround(f14 * f8) + Math_fround(f12 * Math_fround(Math_fround(f9 * f13) - Math_fround(f7 * f10)))));
 f3 = Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f14 * f10) + Math_fround(f12 * Math_fround(Math_fround(f7 * f8) - Math_fround(f11 * f13)))));
 f4 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f8)))) + Math_fround(f7 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f6);
 f3 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f3));
 f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f4) + f3);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN5physx2Sc7BodySim15setArticulationEPNS0_15ArticulationSimEfb(i8, i1, f3, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 HEAP32[i8 + 152 >> 2] = i1;
 if (!i1) return;
 HEAPF32[(HEAP32[i8 + 52 >> 2] | 0) + 152 >> 2] = f3;
 if (!i2) {
  __ZN5physx2Sc5Actor9setActiveEbj(i8, 1, 0);
  i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i8 + 36 >> 2] | 0) | 0;
  i1 = i8 + 188 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i5 + 16 >> 2] | 0;
  i7 = i4 + (i2 * 12 | 0) + 8 | 0;
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i7 >> 0] = i8 & 231 | 8;
  do if (!(i8 & 8)) {
   i8 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i2 & 31);
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
    i2 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    i1 = 1 << (i1 & 31);
    if (!(i4 & i1)) {
     HEAP32[i2 >> 2] = i4 | i1;
     break;
    } else {
     HEAP32[i2 >> 2] = i4 & ~i1;
     break;
    }
   }
  } while (0);
  HEAP8[i5 + 477 >> 0] = 1;
  return;
 }
 i5 = i8 + 36 | 0;
 i6 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i5 >> 2] | 0) | 0;
 i7 = i8 + 188 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 i9 = i2 + (i1 * 12 | 0) + 8 | 0;
 i4 = HEAP8[i9 >> 0] | 0;
 HEAP8[i9 >> 0] = i4 & 247;
 do if (i4 & 8) {
  i9 = (HEAP32[HEAP32[i6 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << (i1 & 31));
  i1 = HEAP32[i7 >> 2] | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i6 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i4 & i1)) {
    HEAP32[i2 >> 2] = i4 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i4 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i6 + 477 >> 0] = 1;
 i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i5 >> 2] | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i6 = i2 + (i1 * 12 | 0) + 8 | 0;
 i9 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i9 & 231 | 16;
 do if (i9 & 8) {
  i9 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << (i1 & 31));
  i1 = HEAP32[i7 >> 2] | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i4 & i1)) {
    HEAP32[i2 >> 2] = i4 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i4 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i5 + 477 >> 0] = 1;
 __ZN5physx2Sc5Actor9setActiveEbj(i8, 0, 0);
 return;
}

function __ZNK5physx15PxVehicleWheels19computeForwardSpeedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i2 + 40 | 0;
 i15 = i2 + 12 | 0;
 i5 = i2;
 i1 = i1 + 104 | 0;
 i17 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i17 | 0);
 i17 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 124 >> 2] | 0, i15 | 0, i17 | 0);
 f3 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(f3 * f14);
 f6 = Math_fround(HEAPF32[i15 + 12 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * f6));
 f12 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f13 * f12));
 f10 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f11 = Math_fround(f11 - Math_fround(f8 * f10));
 f9 = Math_fround(Math_fround(Math_fround(f8 * f14) + Math_fround(Math_fround(f13 * f6) + Math_fround(f3 * f10))) - Math_fround(f4 * f12));
 f7 = Math_fround(Math_fround(Math_fround(f4 * f10) + Math_fround(Math_fround(f8 * f6) + Math_fround(f3 * f12))) - Math_fround(f13 * f14));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f6) - Math_fround(f4 * f14)) - Math_fround(f13 * f10)) - Math_fround(f8 * f12));
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i1 | 0);
 f8 = Math_fround(Math_fround(HEAPF32[gb + 158860 >> 2]) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 4 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[gb + 158860 + 8 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f12 * f12) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f11 * f8) + Math_fround(f9 * f10)) + Math_fround(f7 * f13));
 f6 = Math_fround(Math_fround(f11 * f4) + Math_fround(Math_fround(f14 * f8) + Math_fround(f12 * Math_fround(Math_fround(f9 * f13) - Math_fround(f7 * f10)))));
 f3 = Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f14 * f10) + Math_fround(f12 * Math_fround(Math_fround(f7 * f8) - Math_fround(f11 * f13)))));
 f4 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f8)))) + Math_fround(f7 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f6);
 f3 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f3));
 f3 = Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f4) + f3);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + (i4 * 12 | 0) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[i2 >> 2] | 0;
   i17 = HEAP32[i14 + (i10 * 12 | 0) >> 2] | 0;
   i17 = _i64Add(i17 | 0, HEAP32[i14 + (i10 * 12 | 0) + 4 >> 2] | 0, -1, ~i17 | 0) | 0;
   i16 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i17 | 0, i16 | 0, 22) | 0;
   i17 = i15 ^ i17;
   i16 = (getTempRet0() | 0) ^ i16;
   i15 = _bitshift64Shl(i17 | 0, i16 | 0, 13) | 0;
   i15 = _i64Add(i17 | 0, i16 | 0, ~i15 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i16 = getTempRet0() | 0;
   i17 = _bitshift64Lshr(i15 | 0, i16 | 0, 8) | 0;
   i16 = ___muldi3(i17 ^ i15 | 0, (getTempRet0() | 0) ^ i16 | 0, 9, 0) | 0;
   i15 = getTempRet0() | 0;
   i17 = _bitshift64Lshr(i16 | 0, i15 | 0, 15) | 0;
   i16 = i17 ^ i16;
   i15 = (getTempRet0() | 0) ^ i15;
   i17 = _bitshift64Shl(i16 | 0, i15 | 0, 27) | 0;
   i17 = _i64Add(i16 | 0, i15 | 0, ~i17 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i15 = getTempRet0() | 0;
   i16 = _bitshift64Lshr(i17 | 0, i15 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i15;
   i17 = i5 + (((i16 ^ i17) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i10;
   i17 = i14 + (i10 * 12 | 0) | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i15 = i7 + (i10 * 12 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP32[i7 + (i10 * 12 | 0) + 8 >> 2] = HEAP32[i14 + (i10 * 12 | 0) + 8 >> 2];
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __Z21CheckForAbstractClassR10GameObject11ClassIDTypePNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i8, i3, i10) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 8 | 0;
 i14 = i15;
 i11 = i15 + 44 | 0;
 i12 = i15 + 24 | 0;
 i13 = i15 + 12 | 0;
 if (!(HEAP8[(__ZN6Object13ClassIDToRTTIEi(i3) | 0) + 32 >> 0] | 0)) {
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (!i10) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = gb + 64016 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i12 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i4 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i1;
 __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(i3, i12, 1);
 if (!(HEAP32[i6 >> 2] | 0)) i1 = i11; else {
  i4 = i13 + 11 | 0;
  i5 = i13 + 4 | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  do {
   HEAP32[i7 >> 2] = __ZN6Object15ClassIDToStringEi(HEAP32[i3 >> 2] | 0) | 0;
   __Z6FormatPKcz(i13, gb + 446783 | 0, i7);
   i1 = HEAP8[i4 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i11, i2 ? HEAP32[i13 >> 2] | 0 : i13, i2 ? HEAP32[i5 >> 2] | 0 : i1 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i1 + (i2 << 2) + -4 | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i11, gb + 446788 | 0) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i1 + (i2 << 2) | 0));
  i1 = (HEAP8[i11 + 11 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11;
 }
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i14 + 4 >> 2] = i8;
 __Z6FormatPKcz(i13, gb + 446693 | 0, i14);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i10, i13) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i12 + 4 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i14 = 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN15DirectorManager15InitializeClassEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 HEAP32[gb + 1115296 + 120 >> 2] = fb + 120;
 HEAP32[gb + 1115296 + 132 >> 2] = fb + 121;
 HEAP32[gb + 1115296 + 144 >> 2] = fb + 122;
 HEAP32[gb + 1115296 + 164 >> 2] = fb + 123;
 HEAP32[gb + 1115296 + 204 >> 2] = fb + 124;
 HEAP32[gb + 1115296 + 268 >> 2] = fb + 125;
 HEAP32[gb + 1115296 + 312 >> 2] = fb + 126;
 HEAP32[gb + 1115296 + 216 >> 2] = fb + 127;
 HEAP32[gb + 1115296 + 224 >> 2] = fb + 128;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 24700 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) >> 2] = fb + 129;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188456 + 48 >> 2] = i1;
 HEAP32[gb + 1188456 + 8 >> 2] = 0;
 HEAP32[gb + 1188456 + 28 >> 2] = 0;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188456 + 52 >> 2] = i1;
 HEAP32[gb + 1188456 + 12 >> 2] = 0;
 HEAP32[gb + 1188456 + 32 >> 2] = 0;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188456 + 56 >> 2] = i1;
 HEAP32[gb + 1188456 + 16 >> 2] = 0;
 HEAP32[gb + 1188456 + 36 >> 2] = 0;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188456 + 60 >> 2] = i1;
 HEAP32[gb + 1188456 + 20 >> 2] = 0;
 HEAP32[gb + 1188456 + 40 >> 2] = 0;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188456 + 64 >> 2] = i1;
 HEAP32[gb + 1188456 + 24 >> 2] = 0;
 HEAP32[gb + 1188456 + 44 >> 2] = 0;
 HEAPF32[gb + 1188456 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1188456 + 4 >> 2] = 0;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188416 >> 2] = i1;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188420 >> 2] = i1;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188424 >> 2] = i1;
 i1 = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[gb + 1188432 >> 2] = i1;
 i1 = 0;
 do {
  i3 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63784 | 0, 16, gb + 582681 | 0, 935) | 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 11;
  i4 = HEAP32[gb + 1188432 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 128);
 HEAP32[gb + 1188436 >> 2] = 0;
 HEAP8[i5 + 440 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN7mecanim8skeleton12SkeletonCopyEPKNS0_8SkeletonEPS1_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 if (i9 | 0) {
  i4 = i10 + 4 | 0;
  i5 = i4;
  i6 = i11 + 4 | 0;
  i7 = i6;
  i8 = i11 + 8 | 0;
  i9 = i8;
  i2 = i10 + 8 | 0;
  i3 = i2;
  i1 = 0;
  do {
   i14 = (HEAP32[i6 >> 2] | 0) + i7 + (i1 << 3) | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i12 = (HEAP32[i4 >> 2] | 0) + i5 + (i1 << 3) | 0;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i4 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 + 12 >> 2] = i4;
 if (!i4) return;
 i3 = i10 + 16 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i2 = i11 + 16 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 0;
 do {
  i13 = HEAP32[i2 + (i1 * 76 | 0) + 4 >> 2] | 0;
  i14 = HEAP32[i2 + (i1 * 76 | 0) + 8 >> 2] | 0;
  i12 = HEAP32[i2 + (i1 * 76 | 0) + 12 >> 2] | 0;
  HEAP32[i3 + (i1 * 76 | 0) >> 2] = HEAP32[i2 + (i1 * 76 | 0) >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 4 >> 2] = i13;
  HEAP32[i3 + (i1 * 76 | 0) + 8 >> 2] = i14;
  HEAP32[i3 + (i1 * 76 | 0) + 12 >> 2] = i12;
  i12 = HEAP32[i2 + (i1 * 76 | 0) + 20 >> 2] | 0;
  i14 = HEAP32[i2 + (i1 * 76 | 0) + 24 >> 2] | 0;
  i13 = HEAP32[i2 + (i1 * 76 | 0) + 28 >> 2] | 0;
  HEAP32[i3 + (i1 * 76 | 0) + 16 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 16 >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 20 >> 2] = i12;
  HEAP32[i3 + (i1 * 76 | 0) + 24 >> 2] = i14;
  HEAP32[i3 + (i1 * 76 | 0) + 28 >> 2] = i13;
  i13 = HEAP32[i2 + (i1 * 76 | 0) + 36 >> 2] | 0;
  i14 = HEAP32[i2 + (i1 * 76 | 0) + 40 >> 2] | 0;
  HEAP32[i3 + (i1 * 76 | 0) + 32 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 32 >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 36 >> 2] = i13;
  HEAP32[i3 + (i1 * 76 | 0) + 40 >> 2] = i14;
  i14 = HEAP32[i2 + (i1 * 76 | 0) + 48 >> 2] | 0;
  i13 = HEAP32[i2 + (i1 * 76 | 0) + 52 >> 2] | 0;
  HEAP32[i3 + (i1 * 76 | 0) + 44 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 44 >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 48 >> 2] = i14;
  HEAP32[i3 + (i1 * 76 | 0) + 52 >> 2] = i13;
  i13 = HEAP32[i2 + (i1 * 76 | 0) + 60 >> 2] | 0;
  i14 = HEAP32[i2 + (i1 * 76 | 0) + 64 >> 2] | 0;
  HEAP32[i3 + (i1 * 76 | 0) + 56 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 56 >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 60 >> 2] = i13;
  HEAP32[i3 + (i1 * 76 | 0) + 64 >> 2] = i14;
  HEAP32[i3 + (i1 * 76 | 0) + 68 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 68 >> 2];
  HEAP32[i3 + (i1 * 76 | 0) + 72 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 72 >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __Z44Physics2D_CUSTOM_INTERNAL_CALL_CircleCastAllRK13Vector2fIcallfS1_fiff(i1, f6, i2, f7, i3, f8, f9) {
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 i3 = i3 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i13 + 8 | 0;
 i5 = i13;
 i12 = i13 + 16 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i5);
 i17 = i14;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i11;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 i15 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 do if (!(__ZN16Physics2DManager13CircleCastAllERK8Vector2ffS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i15, i14, f6, i5, f7, i3, f8, f9, 0, 0, i12) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i2 = HEAP32[i12 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i5) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i5) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i3 = 0;
  while (1) {
   i15 = i2;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i4;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   i17 = i2 + 8 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i15 = i4 + 8 | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   i15 = i2 + 16 | 0;
   i16 = HEAP32[i15 + 4 >> 2] | 0;
   i17 = i4 + 16 | 0;
   HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i17 + 4 >> 2] = i16;
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i5 | 0)) break; else {
    i4 = i4 + 36 | 0;
    i2 = i2 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return i1 | 0;
}

function __GLOBAL__sub_I_runtime_mecanim_animation_lump_cpp() {
 var i1 = 0;
 HEAPF32[gb + 1466580 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 16 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 24 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 60 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 68 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 80 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 112 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 124 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 132 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 152 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 164 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1466580 + 168 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1466580 + 188 >> 2] = Math_fround(-1.0);
 i1 = gb + 1553740 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 128 | 0;
 } while ((i1 | 0) != (gb + 1553740 + 19840 | 0));
 return;
}

function __ZN9Polygon2D9SetPointsEPK8Vector2fj(i9, i11, i10) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 8 | 0;
 i3 = i12;
 i8 = i12 + 16 | 0;
 i7 = gb + 63400 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i9 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i3 - i2 | 0;
 i1 = (i4 | 0) / 20 | 0;
 if (!i4) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEjRKS3_(i9, 1 - i1 | 0, i8); else if (i1 >>> 0 > 1) {
  i4 = i2 + 20 | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i2 = i3;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
  HEAP32[i8 >> 2] = 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
  i6 = HEAP32[i9 >> 2] | 0;
 } else i6 = i1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i6 + 12 | 0;
 i1 = i10 << 3;
 i2 = i1 >> 3;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  i10 = i10 << 3;
  _memcpy(i9 | 0, i11 | 0, i10 | 0) | 0;
  STACKTOP = i12;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i9;
  i10 = HEAP32[i5 >> 2] | 0;
  i10 = i10 << 3;
  _memcpy(i9 | 0, i11 | 0, i10 | 0) | 0;
  STACKTOP = i12;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i9;
  i10 = HEAP32[i5 >> 2] | 0;
  i10 = i10 << 3;
  _memcpy(i9 | 0, i11 | 0, i10 | 0) | 0;
  STACKTOP = i12;
  return;
 }
}

function __ZN9HumanBoneC2ERKS_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 12;
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i5;
  i8 = 12;
 }
 if ((i8 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i6 + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i6 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i7 + 44 >> 2];
 HEAP32[i6 + 48 >> 2] = HEAP32[i7 + 48 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i7 + 52 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i7 + 56 >> 2];
 HEAP32[i6 + 60 >> 2] = HEAP32[i7 + 60 >> 2];
 HEAP32[i6 + 64 >> 2] = HEAP32[i7 + 64 >> 2];
 i10 = i6 + 68 | 0;
 i8 = i7 + 68 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP8[i10 + 4 >> 0] = HEAP8[i8 + 4 >> 0] | 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu14contactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i2, i10, i11, i12, i9, i1, i8) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 392 | 0;
 i19 = i7 + 168 | 0;
 i3 = i7 + 72 | 0;
 i5 = i7 + 96 | 0;
 i4 = i7;
 i1 = i2 + 4 | 0;
 __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E(i19, i1);
 __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i19, i6);
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(-f15);
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(-f14);
 f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(-f13);
 HEAPF32[i3 >> 2] = f18;
 HEAPF32[i3 + 4 >> 2] = f17;
 HEAPF32[i3 + 8 >> 2] = f16;
 HEAPF32[i3 + 12 >> 2] = f15;
 HEAPF32[i3 + 16 >> 2] = f14;
 HEAPF32[i3 + 20 >> 2] = f13;
 i1 = i10 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i10 + 8 >> 2]) == Math_fround(1.0)) i2 = Math_fround(HEAPF32[i10 + 12 >> 2]) == Math_fround(1.0); else i2 = 0; else i2 = 0;
 HEAP32[i5 >> 2] = 1065353216;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 1065353216;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 1065353216;
 HEAP32[i5 + 36 >> 2] = 1065353216;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 1065353216;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 1065353216;
 if (!i2) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i5, i1, i10 + 16 | 0);
 HEAP32[i4 >> 2] = 1065353216;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 1065353216;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 1065353216;
 HEAP32[i4 + 36 >> 2] = 1065353216;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 1065353216;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 1065353216;
 i19 = __ZL16contactHullMesh2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESI_bb(i6, i3, i10, i11, i12, Math_fround(HEAPF32[i9 >> 2]), i8, i4, i5, 1, i2) | 0;
 STACKTOP = i7;
 return i19 | 0;
}

function __ZN14ParticleSystem27DetermineSupportsProceduralERKS_(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP32[(HEAP32[i5 + 36 >> 2] | 0) + 280 >> 2] | 0)) if (Math_fround(HEAPF32[i5 + 616 >> 2]) == Math_fround(0.0)) if (!(HEAP8[(HEAP32[i5 + 880 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 884 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 896 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 904 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 912 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 916 >> 2] | 0) + 4 >> 0] | 0)) if (!(HEAP8[(HEAP32[i5 + 888 >> 2] | 0) + 4 >> 0] | 0)) i3 = (HEAP8[(HEAP32[i5 + 908 >> 2] | 0) + 4 >> 0] | 0) == 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0; else i3 = 0;
 i2 = HEAP32[i5 + 44 >> 2] | 0;
 i1 = (HEAP8[i2 + 4 >> 0] | 0) == 0;
 if (i1 | i3 ^ 1) i1 = i3 & i1; else i1 = (HEAP16[i2 + 2360 >> 1] | 0) == 0;
 i4 = i5 + 856 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = (HEAP8[i2 + 4 >> 0] | 0) == 0;
 if (i3 | i1 ^ 1) i1 = i3 & i1; else {
  i3 = __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i2 + 624 | 0, HEAP16[i2 + 620 >> 1] | 0) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = (HEAP8[i2 + 800 >> 0] | 0) == 0;
  if (i1 | i3 ^ 1) i1 = i3 & i1; else if (__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i2 + 96 | 0, HEAP16[i2 + 92 >> 1] | 0) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i1 + 360 | 0, HEAP16[i1 + 356 >> 1] | 0) | 0;
  } else i1 = 0;
 }
 i3 = i5 + 868 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = (HEAP8[i4 + 4 >> 0] | 0) == 0;
 if (i2 | i1 ^ 1) i4 = i1 & i2; else if (__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i4 + 96 | 0, HEAP16[i4 + 92 >> 1] | 0) | 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  if (__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i4 + 360 | 0, HEAP16[i4 + 356 >> 1] | 0) | 0) {
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i4 + 624 | 0, HEAP16[i4 + 620 >> 1] | 0) | 0;
  } else i4 = 0;
 } else i4 = 0;
 i2 = i5 + 876 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP8[i3 + 4 >> 0] | 0) == 0;
 if (i1 | i4 ^ 1) {
  i5 = i4 & i1;
  return i5 | 0;
 }
 if (!(__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i3 + 96 | 0, HEAP16[i3 + 92 >> 1] | 0) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 if (!(__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i5 + 360 | 0, HEAP16[i5 + 356 >> 1] | 0) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 if (!(__Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i5 + 624 | 0, HEAP16[i5 + 620 >> 1] | 0) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (HEAP8[(HEAP32[i2 >> 2] | 0) + 801 >> 0] | 0) == 0;
 return i5 | 0;
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i11 = HEAP32[i8 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i15 = i13;
  i10 = i8;
  i13 = HEAP32[i13 >> 2] | 0;
  i14 = i11;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i15 >> 2] = i14;
  i14 = i9 + 8 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i12 = i8 + 8 | 0;
  i14 = i9 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i14 >> 2] = i13;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i9 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i14 = i10 + 4 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 do {
  i2 = i6 + -20 | 0;
  i5 = i1;
  i1 = i1 + -20 | 0;
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i5 + -16 >> 2] | 0 : i7 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 + -8 >> 2] = i3;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i6 + -8 >> 2] | 0;
   i15 = 7;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i7;
   if (i7) i15 = 9;
  } else i15 = 7;
  if ((i15 | 0) == 7) {
   i17 = i7 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i14 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i6 + -12 >> 2] = i17 | -2147483648;
   HEAP32[i6 + -16 >> 2] = i7;
   i2 = i3;
   i15 = 9;
  }
  if ((i15 | 0) == 9) {
   i15 = 0;
   _memcpy(i2 | 0, i4 | 0, i7 | 0) | 0;
  }
  HEAP8[i2 + i7 >> 0] = 0;
  HEAP32[i6 + -4 >> 2] = HEAP32[i5 + -4 >> 2];
  i6 = (HEAP32[i13 >> 2] | 0) + -20 | 0;
  HEAP32[i13 >> 2] = i6;
 } while ((i1 | 0) != (i11 | 0));
 i17 = i13;
 i15 = i8;
 i14 = i6;
 i13 = HEAP32[i8 >> 2] | 0;
 HEAP32[i15 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i9 + 8 | 0;
 i15 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 i13 = i8 + 8 | 0;
 i15 = i9 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i15 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i9 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 i5 = i10 + 32 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj509ENS_22PxRepXPropertyAccessorILj509ES4_ffEEEEvRKT0_(i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i7 = i10 + 48 | 0;
  i10 = i9 + 1 | 0;
  __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEclILj510ES3_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i10);
  i10 = i9 + 2 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 4 >> 0] | 0) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2 + -1;
 i7 = i10 + 48 | 0;
 i10 = i9 + 1 | 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEclILj510ES3_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i7, i10);
 i10 = i9 + 2 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx2Sc15ClothFabricCore15importExtraDataERNS_24PxDeserializationContextE(i16, i15) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i14 = i16 + 8 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i9 = HEAP32[i16 + 16 >> 2] | 0;
  if (i9 & 2147483647 | HEAP32[i16 + 12 >> 2] | 0) {
   i19 = i15 + 4 | 0;
   i18 = HEAP32[i19 >> 2] | 0;
   HEAP32[i19 >> 2] = i18 + (i9 << 2);
   HEAP32[i14 >> 2] = i18;
  }
 }
 if (!(HEAP32[i16 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i18 = i15 + 4 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 HEAP32[i18 >> 2] = i14 + 76;
 __ZN5physx2Sc19ClothFabricBulkData15importExtraDataERNS_24PxDeserializationContextE(i14, i15);
 i18 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i15 = HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 i20 = HEAP32[i14 + 4 >> 2] | 0;
 i9 = i20 + (HEAP32[i14 + 8 >> 2] << 2) | 0;
 HEAP32[i7 >> 2] = i20;
 HEAP32[i7 + 4 >> 2] = i9;
 i9 = HEAP32[i14 + 16 >> 2] | 0;
 i20 = i9 + (HEAP32[i14 + 20 >> 2] << 2) | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i20;
 i20 = HEAP32[i14 + 28 >> 2] | 0;
 i9 = i20 + (HEAP32[i14 + 32 >> 2] << 2) | 0;
 HEAP32[i10 >> 2] = i20;
 HEAP32[i10 + 4 >> 2] = i9;
 i9 = HEAP32[i14 + 40 >> 2] | 0;
 i20 = i9 + (HEAP32[i14 + 44 >> 2] << 2) | 0;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i20;
 i20 = HEAP32[i14 + 52 >> 2] | 0;
 i9 = i20 + (HEAP32[i14 + 56 >> 2] << 2) | 0;
 HEAP32[i12 >> 2] = i20;
 HEAP32[i12 + 4 >> 2] = i9;
 i9 = HEAP32[i14 + 64 >> 2] | 0;
 i14 = i9 + (HEAP32[i14 + 68 >> 2] << 2) | 0;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 i19 = mftCall_iiiiiiiii(i15 | 0, i18 | 0, i19 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 HEAP32[i16 >> 2] = i19;
 i19 = i19 + 4 | 0;
 HEAP16[i19 >> 1] = (HEAP16[i19 >> 1] | 0) + 1 << 16 >> 16;
 STACKTOP = i17;
 return;
}

function __ZN5Umbra4HashIjiE6rehashEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 if (!i1) {
  i1 = HEAP32[i12 + 16 >> 2] << 1;
  i1 = i1 >>> 0 < 4 ? 4 : i1;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i1 * 12 | 0;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 + 16 | 0, 0) | 0;
 if (!i2) i10 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i10 = i2 + 16 | 0;
 }
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = i1 << 2;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 + 16 | 0, 0) | 0;
 if (!i3) {
  if (!i10) {
   i12 = 0;
   return i12 | 0;
  }
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i10 + -16 | 0);
  i12 = 0;
  return i12 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i11 = i3 + 16 | 0;
 if (!i10) {
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i3 | 0);
  i12 = 0;
  return i12 | 0;
 }
 _memset(i10 | 0, 0, i4 | 0) | 0;
 _memset(i11 | 0, 0, i2 | 0) | 0;
 if ((i1 | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i10 + (i2 * 12 | 0) >> 2] = -1;
   HEAP32[i11 + (i2 << 2) >> 2] = -1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i9 = i12 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) i2 = 0; else {
  i8 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i6 = i12 + 8 | 0;
   i7 = i1 + -1 | 0;
   i2 = 0;
   i5 = 0;
   do {
    i4 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
    if ((i4 | 0) != -1) {
     i3 = HEAP32[i6 >> 2] | 0;
     do {
      i13 = HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] | 0;
      HEAP32[i10 + (i2 * 12 | 0) + 4 >> 2] = i13;
      HEAP32[i10 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2];
      i13 = i11 + (((i13 >>> 5) + i13 + (i13 >>> 10) + (i13 >>> 20) & i7) << 2) | 0;
      HEAP32[i10 + (i2 * 12 | 0) >> 2] = HEAP32[i13 >> 2];
      HEAP32[i13 >> 2] = i2;
      i2 = i2 + 1 | 0;
      i4 = HEAP32[i3 + (i4 * 12 | 0) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i3 = HEAP32[i9 >> 2] | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (i3 | 0));
  } else i2 = 0;
  if (i8 | 0) {
   i13 = HEAP32[i12 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i8 + -16 | 0);
  }
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  if (i3) {
   i13 = HEAP32[i12 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i3 + -16 | 0);
  }
 }
 if ((i2 | 0) < (i1 | 0)) {
  i3 = i2;
  do {
   i13 = i3;
   i3 = i3 + 1 | 0;
   HEAP32[i10 + (i13 * 12 | 0) >> 2] = i3;
  } while ((i3 | 0) != (i1 | 0));
 }
 HEAP32[i10 + ((i1 + -1 | 0) * 12 | 0) >> 2] = -1;
 HEAP32[i12 + 12 >> 2] = i2;
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i9 >> 2] = i1;
 i13 = 1;
 return i13 | 0;
}

function __ZN5Umbra4HashIiiE6rehashEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 if (!i1) {
  i1 = HEAP32[i12 + 16 >> 2] << 1;
  i1 = i1 >>> 0 < 4 ? 4 : i1;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = i1 * 12 | 0;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 + 16 | 0, 0) | 0;
 if (!i2) i10 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i10 = i2 + 16 | 0;
 }
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = i1 << 2;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 + 16 | 0, 0) | 0;
 if (!i3) {
  if (!i10) {
   i12 = 0;
   return i12 | 0;
  }
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i10 + -16 | 0);
  i12 = 0;
  return i12 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i11 = i3 + 16 | 0;
 if (!i10) {
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i3 | 0);
  i12 = 0;
  return i12 | 0;
 }
 _memset(i10 | 0, 0, i4 | 0) | 0;
 _memset(i11 | 0, 0, i2 | 0) | 0;
 if ((i1 | 0) > 0) {
  i2 = 0;
  do {
   HEAP32[i10 + (i2 * 12 | 0) >> 2] = -1;
   HEAP32[i11 + (i2 << 2) >> 2] = -1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i9 = i12 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) i2 = 0; else {
  i8 = HEAP32[i12 + 4 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i6 = i12 + 8 | 0;
   i7 = i1 + -1 | 0;
   i2 = 0;
   i5 = 0;
   do {
    i4 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
    if ((i4 | 0) != -1) {
     i3 = HEAP32[i6 >> 2] | 0;
     do {
      i13 = HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] | 0;
      HEAP32[i10 + (i2 * 12 | 0) + 4 >> 2] = i13;
      HEAP32[i10 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2];
      i13 = i11 + (((i13 >>> 5) + i13 + (i13 >>> 10) + (i13 >>> 20) & i7) << 2) | 0;
      HEAP32[i10 + (i2 * 12 | 0) >> 2] = HEAP32[i13 >> 2];
      HEAP32[i13 >> 2] = i2;
      i2 = i2 + 1 | 0;
      i4 = HEAP32[i3 + (i4 * 12 | 0) >> 2] | 0;
     } while ((i4 | 0) != -1);
     i3 = HEAP32[i9 >> 2] | 0;
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (i3 | 0));
  } else i2 = 0;
  if (i8 | 0) {
   i13 = HEAP32[i12 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i8 + -16 | 0);
  }
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  if (i3) {
   i13 = HEAP32[i12 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i3 + -16 | 0);
  }
 }
 if ((i2 | 0) < (i1 | 0)) {
  i3 = i2;
  do {
   i13 = i3;
   i3 = i3 + 1 | 0;
   HEAP32[i10 + (i13 * 12 | 0) >> 2] = i3;
  } while ((i3 | 0) != (i1 | 0));
 }
 HEAP32[i10 + ((i1 + -1 | 0) * 12 | 0) >> 2] = -1;
 HEAP32[i12 + 12 >> 2] = i2;
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i9 >> 2] = i1;
 i13 = 1;
 return i13 | 0;
}

function __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EEjNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_jEEL18MemLabelIdentifier65ELi16EEEixERSA_(i16, i17) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20;
 i19 = i20 + 16 | 0;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 if ((HEAP32[i16 + 44 >> 2] | 0) == (i1 | 0)) {
  i2 = HEAP32[i16 + 36 >> 2] | 0;
  i1 = HEAP32[i16 + 40 >> 2] | 0;
  i3 = i2 + (i1 * 12 | 0) | 0;
 } else {
  i15 = HEAP32[i16 + 40 >> 2] | 0;
  i6 = i15 + -1 | 0;
  i7 = HEAP32[i17 >> 2] | 0;
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = HEAP32[i17 + 4 >> 2] | 0;
  i4 = i4 + 2127912214 + (i4 << 12) | 0;
  i4 = i4 ^ -949894596 ^ HEAP32[i8 + 4 >> 2] ^ i4 >>> 19;
  i4 = i4 + 374761393 + (i4 << 5) | 0;
  i2 = HEAP32[i16 + 36 >> 2] | 0;
  i9 = HEAP32[i16 + 24 >> 2] | 0;
  i10 = i16 + 28 | 0;
  i11 = i16 + 8 | 0;
  i12 = i16 + 12 | 0;
  i13 = i16 + 16 | 0;
  i5 = 0;
  i4 = i4 + -744332180 ^ i4 << 9;
  i3 = i1;
  while (1) {
   i1 = i4 & i6;
   i4 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
   if ((i9 | 0) == (i4 | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) {
    i1 = -1;
    break;
   }
   if (!(HEAP8[i11 >> 0] | 0)) i14 = 10; else if (!i3) {
    i3 = 0;
    i14 = 10;
   } else if ((HEAP32[i12 >> 2] | 0) == (i4 | 0)) {
    if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) i14 = 10;
   } else i14 = 10;
   if ((i14 | 0) == 10) {
    i14 = 0;
    if ((i7 | 0) == (i4 | 0)) if ((i8 | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) break;
   }
   i4 = i5 + 1 | 0;
   i5 = i4;
   i4 = i4 + i1 | 0;
  }
  i3 = (i1 | 0) == -1 ? i2 + (i15 * 12 | 0) | 0 : i2 + (i1 * 12 | 0) | 0;
  i1 = i15;
 }
 if ((i3 | 0) != (i2 + (i1 * 12 | 0) | 0)) {
  i19 = i3;
  i19 = i19 + 8 | 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 i14 = i17;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i17 = i18;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i17 + 4 >> 2] = i15;
 HEAP32[i18 + 8 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj(i16, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E15insert_noresizeERKS7_(i19, i16, i18);
 i19 = HEAP32[i19 + 4 >> 2] | 0;
 i19 = i19 + 8 | 0;
 STACKTOP = i20;
 return i19 | 0;
}

function __ZN13GfxDeviceGLES12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj(i1, i6, i4, i2, i7, i8, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i3 = (HEAP32[i6 + 12 >> 2] | 0) == 1;
 HEAP32[i6 + 20 >> 2] = i2;
 i1 = i6 + 16 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) == (i4 | 0);
 if (!i3) {
  do if (i2) {
   i1 = i6 + 28 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 + 24 >> 2] = i7;
   if (!i2) i5 = 30; else {
    if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 >= i7 >>> 0) {
     i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i2) | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i4) {
      if (!i2) {
       i5 = 30;
       break;
      }
      i3 = i6 + 32 | 0;
      break;
     }
    }
    __ZN14DataBufferGLES7ReleaseEv(i2);
    HEAP32[i1 >> 2] = 0;
    i5 = 30;
   }
  } else {
   HEAP32[i1 >> 2] = i4;
   HEAP32[i6 + 32 >> 2] = i4 >>> 0 < 4 ? i4 : 1;
   i1 = i6 + 28 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = i7;
   i5 = 30;
  } while (0);
  if ((i5 | 0) == 30) {
   i2 = __Z20GetBufferManagerGLESv() | 0;
   i3 = i6 + 32 | 0;
   i2 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i2, i7, HEAP32[i3 >> 2] | 0, 0) | 0;
   HEAP32[i1 >> 2] = i2;
  }
  if ((HEAP32[i3 >> 2] | 0) == 3) __ZN14DataBufferGLES13EnsureStorageEi(i2, i7);
  __ZN14DataBufferGLES6UploadEiiPKv(HEAP32[i1 >> 2] | 0, 0, i7, i8);
  return;
 }
 do if (i2) {
  i1 = i6 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 + 24 >> 2] = i7;
  if (!i2) i5 = 16; else {
   if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 >= i7 >>> 0) {
    i4 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i2) | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i4) {
     if (!i2) {
      i5 = 16;
      break;
     }
     i3 = i6 + 32 | 0;
     break;
    }
   }
   __ZN14DataBufferGLES7ReleaseEv(i2);
   HEAP32[i1 >> 2] = 0;
   i5 = 16;
  }
 } else {
  HEAP32[i1 >> 2] = i4;
  switch (i4 | 0) {
  case 0:
   {
    i1 = 4;
    break;
   }
  case 1:
   {
    i1 = 5;
    break;
   }
  case 2:
   {
    i1 = 6;
    break;
   }
  default:
   i1 = 5;
  }
  HEAP32[i6 + 32 >> 2] = i1;
  i1 = i6 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = i7;
  i5 = 16;
 } while (0);
 if ((i5 | 0) == 16) {
  i2 = __Z20GetBufferManagerGLESv() | 0;
  i3 = i6 + 32 | 0;
  i2 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i2, i7, HEAP32[i3 >> 2] | 0, 0) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 if ((HEAP32[i3 >> 2] | 0) == 3) __ZN14DataBufferGLES13EnsureStorageEi(i2, i7);
 __ZN14DataBufferGLES6UploadEiiPKv(HEAP32[i1 >> 2] | 0, 0, i7, i8);
 return;
}

function __ZN2UI6Canvas14RenderOverlaysEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1468012 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468012 | 0, i1);
  i12 = gb + 1468012 | 0;
 } else i12 = 0;
 i3 = HEAP32[gb + 1468012 >> 2] | 0;
 i9 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 648 >> 2] | 0, i9 | 0, i3 | 0);
 i3 = i10 + 332 | 0;
 if (HEAP32[i3 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i3);
 i5 = __Z12GetGfxDevicev() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 256 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 + 340 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 mftCall_vii(i6 | 0, i5 | 0, i1 | 0);
 i1 = HEAP32[i10 + 424 >> 2] | 0;
 i5 = i10 + 228 | 0;
 i6 = i10 + 240 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) i11 = 17; else {
  i7 = i10 + 316 | 0;
  i8 = i10 + 320 | 0;
  i9 = i10 + 428 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  L9 : do {
   while (1) {
    if (HEAP8[i4 >> 0] | 0) if ((i1 | 0) != (HEAP32[i9 >> 2] | 0)) {
     i11 = 10;
     break;
    }
    i3 = __ZN2UI6Canvas19GetProjectionMatrixEv(i10) | 0;
    i2 = __Z12GetGfxDevicev() | 0;
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i3 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, gb + 1162292 | 0);
    mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, gb + 1162292 | 0);
    i2 = HEAP32[i7 >> 2] | 0;
    if (i2 | 0) {
     i3 = HEAP32[i8 >> 2] | 0;
     if (i3 | 0) {
      i11 = 14;
      break;
     }
    }
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i4 | 0) == ((HEAP32[i5 >> 2] | 0) + (i2 << 4) | 0)) break L9;
   }
   if ((i11 | 0) == 10) {
    i11 = 0;
    __ZN2UI6Canvas14RenderOverlaysEv(HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } else if ((i11 | 0) == 14) {
    i11 = 0;
    __ZN2UI6Canvas11DrawRawMeshERNS_5BatchEP9GfxBufferS4_(i10, i4, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0);
   }
   i4 = i4 + 16 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i4 | 0) != ((HEAP32[i5 >> 2] | 0) + (i2 << 4) | 0));
  if (!i2) i11 = 17;
 }
 if ((i11 | 0) == 17) {
  i2 = i10 + 428 | 0;
  if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
   __ZN2UI6Canvas14RenderOverlaysEv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 }
 i11 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 652 >> 2] | 0, i11 | 0);
 if (!i12) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i13;
 return;
}

function __ZN28LightProbeProxyVolumeManager6UpdateEv(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 4 | 0;
 i2 = i17;
 if ((HEAP16[gb + 1111196 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111196 | 0, i1);
  i8 = gb + 1111196 | 0;
 } else i8 = 0;
 i14 = i16 + 12 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i15 = i16 + 20 | 0;
  __ZN28LightProbeProxyVolumeContext5ResetEv(i15);
  if (HEAP32[i14 >> 2] | 0) {
   i9 = i16 + 40 | 0;
   i10 = i16 + 32 | 0;
   i11 = i16 + 36 | 0;
   i12 = i16 + 24 | 0;
   i6 = HEAP32[i16 >> 2] | 0;
   i7 = 0;
   while (1) {
    i13 = HEAP32[i6 >> 2] | 0;
    HEAP16[i13 + 152 >> 1] = i7;
    __ZN28LightProbeProxyVolumeManager17UpdateBoundingBoxER21LightProbeProxyVolume(0, i13);
    __ZN28LightProbeProxyVolumeManager16UpdateResolutionER21LightProbeProxyVolume(0, i13);
    if (HEAP8[i9 >> 0] | 0) {
     i1 = i13 + 154 | 0;
     if (!((HEAP8[i1 >> 0] | 0) == 0 ? (HEAP32[i13 + 44 >> 2] | 0) != 1 : 0)) {
      __ZN28LightProbeProxyVolumeManager22AllocateVolumeTexturesER21LightProbeProxyVolume(0, i13);
      __ZN28LightProbeProxyVolumeManager16BlendLightProbesER21LightProbeProxyVolume(i16, i13);
      __ZN28LightProbeProxyVolumeManager25UpdateSHCoeffsTextureDataER21LightProbeProxyVolume(0, i13);
      HEAP8[i1 >> 0] = 0;
     }
    }
    i2 = HEAP32[i10 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i11 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 * 100 | 0, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 100 | 0, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i15 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 100 | 0) | 0;
      HEAP32[i11 >> 2] = i1;
      HEAP32[i15 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i10 >> 2] = i3;
    __ZN21LightProbeProxyVolume13GetRenderDataER27LightProbeProxyVolumeSample(i13, (HEAP32[i15 >> 2] | 0) + (i2 * 100 | 0) | 0);
    i6 = i6 + 4 | 0;
    if ((i6 | 0) == ((HEAP32[i16 >> 2] | 0) + (HEAP32[i14 >> 2] << 2) | 0)) break; else i7 = i7 + 1 << 16 >> 16;
   }
  }
 }
 if (!i8) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i17;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = gb + 114164 + 8;
 i1 = i9 + 116 | 0;
 HEAP32[i1 >> 2] = gb + 114164 + 112;
 HEAP32[i9 + 120 >> 2] = gb + 114164 + 168;
 HEAP32[i9 + 124 >> 2] = gb + 114164 + 188;
 HEAP32[i9 + 128 >> 2] = gb + 114164 + 228;
 i8 = i9 + 132 | 0;
 HEAP32[i8 >> 2] = gb + 114164 + 248;
 i2 = i9 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i1 | 0);
 HEAP32[i2 >> 2] = 0;
 i6 = HEAP32[i9 + 72 >> 2] | 0;
 i7 = (i6 | 0) == 0;
 if (!i7) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 + 4 >> 2] | 0);
 i4 = i9 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L7 : do if (!i1) i1 = 0; else {
  i5 = i9 + 32 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i8 | 0)) {
    i1 = i3;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break L7;
  }
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0);
  i8 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i8;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i8 << 2) >> 2];
  i1 = i8;
 } while (0);
 HEAP8[i9 + 76 >> 0] = (i1 | 0) != 0 & 1;
 if (!i7) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 + 4 >> 2] | 0);
 i8 = HEAP32[i9 + 272 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 + 264 >> 2] | 0;
  if (i1 | 0) {
   i8 = HEAP32[HEAP32[i9 + 260 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i9 + 216 >> 2] | 0;
 if (i1 | 0) {
  i8 = HEAP32[HEAP32[i9 + 212 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 }
 i1 = HEAP32[i9 + 172 >> 2] | 0;
 if (i1 | 0) {
  i8 = HEAP32[HEAP32[i9 + 168 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 }
 i8 = HEAP32[i9 + 164 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i9 + 156 >> 2] | 0;
  if (i1 | 0) {
   i8 = HEAP32[HEAP32[i9 + 152 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 }
 i1 = i9 + 148 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev(i9);
  return;
 }
 i8 = HEAP32[HEAP32[i9 + 144 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev(i9);
 return;
}

function __ZN5physx3Scb11RigidObject13onShapeAttachERNS0_5ShapeE(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i8 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = i3 >>> 30;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 if (!(HEAP8[i9 + 2433 >> 0] | 0)) {
  i1 = i8;
  if (!(HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 | 0 : HEAP32[i8 + 8 >> 2] | 0) >> 1] & 8)) {
   __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i10);
   __ZN5physx2Sc9RigidCore15addShapeToSceneERNS0_9ShapeCoreE((HEAP32[gb + 90260 + 24 + (((HEAP32[i7 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0, i10 + 16 | 0);
  }
  i1 = i10 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) != 16777216) {
   STACKTOP = i11;
   return;
  }
  HEAP32[i1 >> 2] = i2 & 1073741823 | -2147483648;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) == 1) {
  i1 = i10 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 & 251658240 | 0) != 16777216) {
   STACKTOP = i11;
   return;
  }
  HEAP32[i1 >> 2] = i2 & 1073741823 | 1073741824;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 i1 = i8 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(i9, i3 >>> 24 & 15) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i4 = i2 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L24 : do if (!i5) i1 = 0; else {
  i3 = HEAP32[i2 + 72 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i10 | 0)) break L24;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 do if ((i1 | 0) == (i5 | 0)) {
  HEAP32[i6 >> 2] = i10;
  i1 = i2 + 28 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 + 32 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i2 + 24 >> 2] | 0) + (i3 << 2) >> 2] = i10;
   HEAP32[i1 >> 2] = i3 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i2 + 4 | 0, i6) | 0;
   break;
  }
 } else {
  i3 = HEAP32[i2 + 72 >> 2] | 0;
  i6 = i3 + (i1 << 3) | 0;
  i5 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  i5 = i3 + (i5 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP8[i6 + 4 >> 0] = HEAP8[i5 + 4 >> 0] | 0;
 } while (0);
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i8 >> 2] | 0, i8);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 251658240 | 0) != 16777216) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i1 >> 2] = i2 & 1073741823 | 1073741824;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN15ResourceManager12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 32 | 0;
 i10 = i13 + 16 | 0;
 i11 = i13;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i1);
 i6 = i11 + 11 | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i5 = i11 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i4 ? i1 : i3 & 255) | 0) {
  i4 = i4 ? i2 : i11;
  do {
   i14 = HEAP8[i4 >> 0] | 0;
   i3 = i14 << 24 >> 24;
   HEAP8[i4 >> 0] = (i14 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
   i4 = i4 + 1 | 0;
   i3 = HEAP8[i6 >> 0] | 0;
   i14 = i3 << 24 >> 24 < 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i4 | 0) != ((i14 ? i2 : i11) + (i14 ? i1 : i3 & 255) | 0));
 }
 i14 = i3 << 24 >> 24 < 0;
 i4 = i14 ? i2 : i11;
 i3 = i14 ? i1 : i3 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i12 = 7;
 } else if (i3 >>> 0 < 11) {
  i1 = i10 + 11 | 0;
  HEAP8[i1 >> 0] = i3;
  if (!i3) i2 = i10; else {
   i2 = i10;
   i12 = 9;
  }
 } else i12 = 7;
 if ((i12 | 0) == 7) {
  i14 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i10 + 8 >> 2] = i14 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i1 = i10 + 11 | 0;
  i12 = 9;
 }
 if ((i12 | 0) == 9) _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i2 + i3 >> 0] = 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESM_EERKT_(i9, i8 + 44 | 0, i10);
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i14, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1);
 i2 = i8 + 92 | 0;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i5 = i8 + 112 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i4 = i8 + 116 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i1;
 i5 = i8 + 120 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i1 = i8 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 4 | 0, i5);
 i1 = i7 + 8 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i5 + 24 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 32 | 0, i5);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 48 | 0, i5);
 i1 = i7 + 64 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN13AnimationClip15QuaternionCurveaSERKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = (i8 | 0) == (i9 | 0);
 do if (!i7) {
  i5 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
  i5 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i8 + 16 | 0;
 i2 = i9 + 16 | 0;
 i3 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 92 | 0;
 i2 = i9 + 92 | 0;
 i3 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i5 = i8 + 168 | 0;
 if (i7) {
  i7 = i8 + 188 | 0;
  i6 = i9 + 188 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  i7 = i9 + 200 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 200 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 }
 i6 = HEAP32[i9 + 168 >> 2] | 0;
 i7 = i8 + 180 | 0;
 i1 = (HEAP32[i9 + 180 >> 2] | 0) * 52 | 0;
 i2 = (i1 | 0) / 52 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 184 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i8 + 172 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 172 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
 i7 = i8 + 188 | 0;
 i6 = i9 + 188 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i7 = i9 + 200 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 200 | 0;
 HEAP32[i9 >> 2] = i7;
 return i8 | 0;
}

function __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (((i3 - i1 | 0) / 44 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAPF32[i1 + 8 >> 2] = Math_fround(15.0);
   HEAPF32[i1 + 12 >> 2] = Math_fround(15.0);
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i9 + 24 >> 2] = 0;
   i1 = (HEAP32[i10 >> 2] | 0) + 44 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 44 | 0) + i2 | 0;
 if (i5 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 44 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 48806446 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 97612893;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 44 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 44 | 0) * 44 | 0) | 0;
 i7 = i3;
 i4 = i6 + (i5 * 44 | 0) | 0;
 i6 = i7;
 i1 = i3;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAPF32[i1 + 8 >> 2] = Math_fround(15.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(15.0);
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  i1 = i6 + 44 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i7 = i5;
   i5 = i5 + -44 | 0;
   i13 = i5;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i3 + -44 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i3 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i7 + -16 >> 2];
   HEAP32[i3 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i3 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i3 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   i3 = i2 + -44 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN19CharacterController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 92 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 96 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 96 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN17PolygonCollider2D14CreateInternalEP11Rigidbody2D(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i8 = i11 + 96 | 0;
 i9 = i11 + 32 | 0;
 i10 = i11 + 28 | 0;
 if ((HEAP16[gb + 1457848 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457848 | 0, i5);
  i6 = gb + 1457848 | 0;
 } else i6 = 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 do if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = HEAP32[i7 + 160 >> 2] | 0;
  if ((HEAP32[i7 + 164 >> 2] | 0) != (i1 | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 >= 3) {
   __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D(i7, i10, i9, i2);
   if ((HEAP16[gb + 1457860 + 6 >> 1] | 0) > -1) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457860 | 0, i5);
    i1 = gb + 1457860 | 0;
   } else i1 = 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   i2 = i8 + 16 | 0;
   HEAP32[i2 >> 2] = 0;
   i3 = i8 + 4 | 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
   i13 = i5;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i4 = i3;
   HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i4 + 4 >> 2] = i12;
   i4 = __ZN17PolygonCollider2D19ExtractConvexShapesER13dynamic_arrayIP7b2ShapeLj4EERK10Matrix4x4f(i7, i8, i9) | 0;
   if (!i4) {
    HEAP32[i7 + 56 >> 2] = 1;
    if ((HEAP32[i2 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i3);
     HEAP32[i8 >> 2] = 0;
    }
    if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   } else {
    HEAP16[i5 + 22 >> 1] = 1;
    HEAP16[i5 + 24 >> 1] = -1;
    HEAP16[i5 + 26 >> 1] = 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAPF32[i5 + 8 >> 2] = Math_fround(.200000003);
    HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
    HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
    HEAP8[i5 + 20 >> 0] = 0;
    __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE(i7, i9, i5, HEAP32[i10 >> 2] | 0, i8);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64016 | 0);
    if ((HEAP32[i2 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i3);
     HEAP32[i8 >> 2] = 0;
    }
    if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   }
   break;
  }
  HEAP32[i7 + 56 >> 2] = 1;
 } while (0);
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return;
}

function __ZN16GraphicsSettings8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 28 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 52 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 68 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 60 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i4 + 92 >> 2] | 0;
 i3 = HEAP32[i4 + 96 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = HEAP32[i4 + 108 >> 2] | 0;
 i3 = HEAP32[i4 + 112 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i2 = i4 + 124 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE24ExtractResponseEtagValueEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i14 = i4 + 2252 | 0;
 HEAP8[i14 >> 0] = 1;
 i9 = i4 + 2168 | 0;
 i13 = HEAP32[(HEAP32[i9 >> 2] | 0) + 52 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1047183 | 0, 4);
 i13 = mftCall_iii(i13 | 0, i9 | 0, i10 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!i13) {
  STACKTOP = i16;
  return;
 }
 i1 = i4 + 2236 | 0;
 i11 = i13 + 11 | 0;
 i8 = HEAP8[i11 >> 0] | 0;
 i5 = i8 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i13 >> 2] | 0 : i13;
 i12 = i13 + 4 | 0;
 i8 = i5 ? HEAP32[i12 >> 2] | 0 : i8 & 255;
 i5 = i1 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i6 = (HEAP32[i4 + 2244 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
 do if (i8 >>> 0 > i6 >>> 0) {
  if (i3) i2 = HEAP32[i4 + 2240 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i6, i8 - i6 | 0, i2, 0, i2, i8, i7);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i4 + 2240 >> 2] = i8;
   break;
  } else {
   HEAP8[i5 >> 0] = i8;
   break;
  }
 } while (0);
 i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1047188 | 0, 13);
 i2 = mftCall_iii(i2 | 0, i9 | 0, i10 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!i2) {
  STACKTOP = i16;
  return;
 }
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i6 = HEAP8[i11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i12 >> 2] | 0 : i6 & 255;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i6 = HEAP8[i11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i12 >> 2] | 0 : i6 & 255;
  i5 = i1 & 255;
 }
 i3 = i6 >>> 0 < i5 >>> 0;
 i1 = i3 ? i6 : i5;
 if (!i1) i15 = 23; else {
  i1 = _memcmp(i2, i4 ? HEAP32[i13 >> 2] | 0 : i13, i1) | 0;
  if (!i1) i15 = 23;
 }
 if ((i15 | 0) == 23) i1 = i5 >>> 0 < i6 >>> 0 ? -1 : i3 & 1;
 HEAP8[i14 >> 0] = (i1 | 0) != 0 & 1;
 STACKTOP = i16;
 return;
}

function __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(i1, i4, i2, f3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0;
 i13 = i1 + 64 | 0;
 f25 = Math_fround(HEAPF32[i13 >> 2]);
 i15 = i1 + 68 | 0;
 f24 = Math_fround(HEAPF32[i15 >> 2]);
 i16 = i1 + 72 | 0;
 f23 = Math_fround(HEAPF32[i16 >> 2]);
 i17 = i1 + 80 | 0;
 f22 = Math_fround(HEAPF32[i17 >> 2]);
 i18 = i1 + 84 | 0;
 f21 = Math_fround(HEAPF32[i18 >> 2]);
 i14 = i1 + 88 | 0;
 f11 = Math_fround(HEAPF32[i14 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 108 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f20 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f3);
 f6 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f3);
 f5 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * f3);
 f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f3);
 f10 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f3);
 f19 = Math_fround(Math_fround(1.0) - Math_fround(f19 * f3));
 f7 = Math_fround(Math_fround(1.0) - Math_fround(f7 * f3));
 f20 = Math_fround(f25 + f20);
 f6 = Math_fround(f24 + f6);
 f5 = Math_fround(f23 + f5);
 f9 = Math_fround(f22 + f9);
 f10 = Math_fround(f21 + f10);
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f3));
 i4 = f19 >= Math_fround(0.0);
 f19 = i4 ? f19 : Math_fround(0.0);
 i4 = f7 >= Math_fround(0.0);
 f7 = i4 ? f7 : Math_fround(0.0);
 f3 = Math_fround(f19 * f20);
 f6 = Math_fround(f19 * f6);
 f5 = Math_fround(f19 * f5);
 f9 = Math_fround(f7 * f9);
 f10 = Math_fround(f7 * f10);
 f11 = Math_fround(f7 * f11);
 f7 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f6 * f6)) + Math_fround(f5 * f5));
 if (f7 > f8) {
  f25 = Math_fround(Math_sqrt(Math_fround(f8 / f7)));
  f7 = Math_fround(f5 * f25);
  f6 = Math_fround(f6 * f25);
  f3 = Math_fround(f3 * f25);
 } else f7 = f5;
 f5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11));
 if (!(f5 > f12)) {
  f25 = f11;
  f24 = f10;
  f23 = f9;
  HEAPF32[i13 >> 2] = f3;
  HEAPF32[i15 >> 2] = f6;
  HEAPF32[i16 >> 2] = f7;
  HEAPF32[i17 >> 2] = f23;
  HEAPF32[i18 >> 2] = f24;
  HEAPF32[i14 >> 2] = f25;
  return;
 }
 f23 = Math_fround(Math_sqrt(Math_fround(f12 / f5)));
 f25 = Math_fround(f11 * f23);
 f24 = Math_fround(f10 * f23);
 f23 = Math_fround(f9 * f23);
 HEAPF32[i13 >> 2] = f3;
 HEAPF32[i15 >> 2] = f6;
 HEAPF32[i16 >> 2] = f7;
 HEAPF32[i17 >> 2] = f23;
 HEAPF32[i18 >> 2] = f24;
 HEAPF32[i14 >> 2] = f25;
 return;
}

function __ZN15AudioReverbZone12VerifyValuesEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0;
 i1 = i3 + 48 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 < Math_fround(0.0)) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 i1 = i3 + 52 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) < f2) HEAPF32[i1 >> 2] = f2;
 i1 = i3 + 60 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i4 | 0) < -1e4 ? -1e4 : (i4 | 0) > 0 ? 0 : i4;
 i1 = i3 + 64 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i4 | 0) < -1e4 ? -1e4 : (i4 | 0) > 0 ? 0 : i4;
 i1 = i3 + 68 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i4 | 0) < -1e4 ? -1e4 : (i4 | 0) > 0 ? 0 : i4;
 i1 = i3 + 72 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(.100000001);
 i5 = f2 > Math_fround(20.0);
 f2 = i5 ? Math_fround(20.0) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(.100000001) : f2;
 i1 = i3 + 76 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(.100000001);
 i5 = f2 > Math_fround(2.0);
 f2 = i5 ? Math_fround(2.0) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(.100000001) : f2;
 i1 = i3 + 80 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i4 | 0) < -1e4 ? -1e4 : (i4 | 0) > 1e3 ? 1e3 : i4;
 i1 = i3 + 84 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(.300000012);
 f2 = i5 ? Math_fround(.300000012) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i3 + 88 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i4 | 0) < -1e4 ? -1e4 : (i4 | 0) > 2e3 ? 2e3 : i4;
 i1 = i3 + 92 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(.100000001);
 f2 = i5 ? Math_fround(.100000001) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i3 + 96 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(1.0e3);
 i5 = f2 > Math_fround(2.0e4);
 f2 = i5 ? Math_fround(2.0e4) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(1.0e3) : f2;
 i1 = i3 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(20.0);
 i5 = f2 > Math_fround(1.0e3);
 f2 = i5 ? Math_fround(1.0e3) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(20.0) : f2;
 i1 = i3 + 104 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(10.0);
 f2 = i5 ? Math_fround(10.0) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i3 + 108 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(100.0);
 f2 = i5 ? Math_fround(100.0) : f2;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i3 + 112 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(100.0);
 f2 = i4 ? Math_fround(100.0) : f2;
 HEAPF32[i3 >> 2] = i1 ? Math_fround(0.0) : f2;
 return;
}

function __ZN13AnimationClip12Vector3CurveaSERKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = (i8 | 0) == (i9 | 0);
 do if (!i7) {
  i5 = HEAP8[i9 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
  i5 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i8 + 16 | 0;
 i2 = i9 + 16 | 0;
 i3 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i8 + 76 | 0;
 i2 = i9 + 76 | 0;
 i3 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i5 = i8 + 136 | 0;
 if (i7) {
  i7 = i8 + 156 | 0;
  i6 = i9 + 156 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  i7 = i9 + 168 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 168 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 }
 i6 = HEAP32[i9 + 136 >> 2] | 0;
 i7 = i8 + 148 | 0;
 i1 = (HEAP32[i9 + 148 >> 2] | 0) * 40 | 0;
 i2 = (i1 | 0) / 40 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 152 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i8 + 140 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 140 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 i7 = i8 + 156 | 0;
 i6 = i9 + 156 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i7 = i9 + 168 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 168 | 0;
 HEAP32[i9 >> 2] = i7;
 return i8 | 0;
}

function __Z20CreateObjectFromCodeI18ProceduralMaterialEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(296, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8MaterialC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 HEAP32[i4 >> 2] = gb + 59244 + 8;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 9;
 HEAP32[i4 + 116 >> 2] = 9;
 HEAP8[i4 + 120 >> 0] = 1;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i4 + 144 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 + 168 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 167 >> 0] = 0;
 HEAP8[i4 + 156 >> 0] = 0;
 i1 = i4 + 172 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i4 + 208 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = 0;
 HEAP32[i4 + 216 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i4 + 224 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 232 >> 2] = 0;
 HEAP32[i4 + 220 >> 2] = i1;
 i1 = i4 + 240 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i4 + 256 >> 2] = 1;
 HEAP32[i4 + 264 >> 2] = 42;
 HEAPF32[i4 + 268 >> 2] = Math_fround(0.0);
 i1 = i4 + 276 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 280 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 284 >> 2] = 0;
 HEAP32[i4 + 272 >> 2] = i1;
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN8Material15BuildPropertiesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i2 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i6 = 11; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i2);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) i6 = 11;
 } while (0);
 if ((i6 | 0) == 11) {
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 469921 | 0, 27);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i5) | 0;
   HEAP32[gb + 1166240 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i1 = HEAP32[gb + 1166240 >> 2] | 0;
   if (!i1) i1 = 0; else HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
  }
 }
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i10 = HEAP32[i7 + 100 >> 2] | 0;
  i6 = i10 + 12 | 0;
  __ZN19ShaderPropertySheet8CopyFromERKS_(i6, HEAP32[i3 + 92 >> 2] | 0);
  i5 = i7 + 44 | 0;
  __ZN18UnityPropertySheet20AddNewShaderlabPropsERK19ShaderPropertySheet(i5, HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0) | 0;
  __ZN18UnityPropertySheet25AssignDefinedPropertiesToER19ShaderPropertySheet(i5, i6);
  HEAP32[i10 + 8 >> 2] = i1;
  i6 = i10 + 164 | 0;
  HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 1;
  HEAP32[i10 + 168 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN8Material12UpdateHashesEv(i7);
 }
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN7mecanim5human9HumanPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7, i8);
 i5 = i7 + 40 | 0;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i8 + 24 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i5 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i8, i7 + 52 | 0, gb + 899134 | 0, 0);
 HEAP32[i6 >> 2] = 4;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 68 | 0, i8);
 __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 132 | 0, i8);
 __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 196 | 0, i8);
 __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 260 | 0, i8);
 __ZN7mecanim4hand8HandPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 324 | 0, i8);
 __ZN7mecanim4hand8HandPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 460 | 0, i8);
 HEAP32[i6 >> 2] = 52;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 52;
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
 i2 = i7 + 804 | 0;
 i1 = i7 + 596 | 0;
 do {
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __Z13TransferArrayILi7EKN4math7_float3E19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_(i7 + 804 | 0, gb + 899212 | 0, i8);
 STACKTOP = i11;
 return;
}

function __ZN5Unity14CharacterJoint14SetSwing2LimitERK14SoftJointLimit(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i9 = f3 < Math_fround(0.0);
 i8 = f3 > Math_fround(1.0);
 f3 = i8 ? Math_fround(1.0) : f3;
 f3 = i9 ? Math_fround(0.0) : f3;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i9 = f4 < Math_fround(0.0);
 i8 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i8 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i9 ? Math_fround(0.0) : f4;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
  i9 = f2 < Math_fround(3.0);
  i8 = f2 > Math_fround(177.0);
  f2 = i8 ? Math_fround(177.0) : f2;
  f2 = i9 ? Math_fround(3.0) : f2;
 }
 i9 = i6 + 160 | 0;
 HEAPF32[i9 >> 2] = f2;
 i5 = i6 + 164 | 0;
 HEAPF32[i5 >> 2] = f3;
 i8 = i6 + 168 | 0;
 HEAPF32[i8 >> 2] = f4;
 i6 = i6 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i5 = f2 == Math_fround(0.0);
 f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i5) f3 = Math_fround(1.57079637); else f3 = Math_fround(Math_fround(Math_fround(f2 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i10 + 24 >> 2] = f3;
 f4 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f12 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i8 = f12 > Math_fround(0.0);
 f2 = i8 ? f2 : Math_fround(-1.0);
 if (f2 == Math_fround(-1.0)) {
  f2 = Math_fround((f4 < f3 ? f4 : f3) * Math_fround(.49000001));
  i8 = f2 > Math_fround(.100000001);
  f2 = i8 ? Math_fround(.100000001) : f2;
 }
 i8 = f7 > Math_fround(0.0);
 i5 = f2 < Math_fround(.200000003);
 f12 = i5 ? Math_fround(.200000003) : f2;
 HEAPF32[i10 + 16 >> 2] = i8 ? Math_fround(9.99999974e-06) : f12;
 i8 = HEAP32[i6 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, i8 | 0, 5, 1);
 i8 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 156 >> 2] | 0, i8 | 0, i10 | 0);
 if (Math_fround(HEAPF32[i9 >> 2]) == Math_fround(0.0)) {
  i10 = HEAP32[i6 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 120 >> 2] | 0, i10 | 0, 5, 0);
 }
 STACKTOP = i11;
 return;
}

function __ZN5Unity14CharacterJoint14SetSwing1LimitERK14SoftJointLimit(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i9 = f3 < Math_fround(0.0);
 i8 = f3 > Math_fround(1.0);
 f3 = i8 ? Math_fround(1.0) : f3;
 f3 = i9 ? Math_fround(0.0) : f3;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i9 = f4 < Math_fround(0.0);
 i8 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i8 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i9 ? Math_fround(0.0) : f4;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
  i9 = f2 < Math_fround(3.0);
  i8 = f2 > Math_fround(177.0);
  f2 = i8 ? Math_fround(177.0) : f2;
  f2 = i9 ? Math_fround(3.0) : f2;
 }
 i9 = i6 + 148 | 0;
 HEAPF32[i9 >> 2] = f2;
 i5 = i6 + 152 | 0;
 HEAPF32[i5 >> 2] = f3;
 i8 = i6 + 156 | 0;
 HEAPF32[i8 >> 2] = f4;
 i6 = i6 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i10 | 0, i1 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i5 = f2 == Math_fround(0.0);
 f7 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i5) f3 = Math_fround(1.57079637); else f3 = Math_fround(Math_fround(Math_fround(f2 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i10 + 20 >> 2] = f3;
 f4 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f12 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i8 = f12 > Math_fround(0.0);
 f2 = i8 ? f2 : Math_fround(-1.0);
 if (f2 == Math_fround(-1.0)) {
  f2 = Math_fround((f3 < f4 ? f3 : f4) * Math_fround(.49000001));
  i8 = f2 > Math_fround(.100000001);
  f2 = i8 ? Math_fround(.100000001) : f2;
 }
 i8 = f7 > Math_fround(0.0);
 i5 = f2 < Math_fround(.200000003);
 f12 = i5 ? Math_fround(.200000003) : f2;
 HEAPF32[i10 + 16 >> 2] = i8 ? Math_fround(9.99999974e-06) : f12;
 i8 = HEAP32[i6 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, i8 | 0, 4, 1);
 i8 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 156 >> 2] | 0, i8 | 0, i10 | 0);
 if (Math_fround(HEAPF32[i9 >> 2]) == Math_fround(0.0)) {
  i10 = HEAP32[i6 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 120 >> 2] | 0, i10 | 0, 4, 0);
 }
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i15, i7, i1) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i9 = i14 + 16 | 0;
 i10 = i14;
 i1 = i14 + 8 | 0;
 i11 = i15 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i15 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i4 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i11 >> 2] = i3;
 }
 i2 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = i1 - i5 >> 3;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj(i2, i4 - i3 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 } else if (i4 >>> 0 < i3 >>> 0) {
  i2 = i5 + (i4 << 3) | 0;
  if ((i1 | 0) != (i2 | 0)) {
   do {
    HEAP32[i6 >> 2] = i1 + -8;
    __ZN14ConstantStringD2Ev(i1 + -4 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = i2;
  }
 }
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 12 | 0;
 i6 = i9 + 11 | 0;
 i7 = i9 + 12 | 0;
 i8 = i13 + 4 | 0;
 do {
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i11 >> 2] = i4;
  }
  HEAP32[i5 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i15, i9, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i15);
  i4 = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i17 = gb + 63648 | 0;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i3 = i10;
  HEAP32[i3 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i3 + 4 >> 2] = i16;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i2 + 4 | 0, i4, i13);
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   i17 = HEAP32[i9 >> 2] | 0;
   i16 = HEAP32[i7 >> 2] | 0;
   HEAP32[i13 >> 2] = 1;
   HEAP32[i8 >> 2] = i16;
   __Z19free_alloc_internalPvRK10MemLabelId(i17, i13);
  }
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i14;
 return;
}

function __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 76 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 77 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 78 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 79 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN17BufferManagerGLES16PruneFreeBuffersEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i10 = 0;
 do {
  i12 = i11 + 16 + (i10 * 12 | 0) | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  i13 = i11 + 16 + (i10 * 12 | 0) + 4 | 0;
  i2 = i1;
  L3 : do if ((i2 | 0) != (i13 | 0)) {
   i14 = i11 + 16 + (i10 * 12 | 0) + 8 | 0;
   i15 = i11 + 16 + (i10 * 12 | 0) + 4 | 0;
   i7 = i1;
   do {
    i1 = i7;
    i8 = i2;
    while (1) {
     i9 = HEAP32[i8 + 20 >> 2] | 0;
     i2 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i9 + 32 >> 2] | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     f17 = Math_fround((i3 - i4 | 0) >>> 0);
     f16 = Math_fround(Math_fround(HEAP32[i9 + 8 >> 2] | 0) * Math_fround(.000166666665));
     i7 = f16 < Math_fround(50.0);
     if (Math_fround(f17 + (i7 ? f16 : Math_fround(50.0))) >= Math_fround(59.0)) {
      if (i3 >>> 0 < i4 >>> 0) break;
      if ((HEAP32[i2 + 160 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
     }
     i2 = HEAP32[i8 + 4 >> 2] | 0;
     if (!i2) while (1) {
      i2 = HEAP32[i1 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
     } else {
      i1 = i2;
      while (1) {
       i2 = HEAP32[i1 >> 2] | 0;
       if (!i2) {
        i2 = i1;
        break;
       } else i1 = i2;
      }
     }
     if ((i2 | 0) == (i13 | 0)) break L3; else {
      i1 = i2;
      i8 = i2;
     }
    }
    i3 = HEAP32[i8 + 4 >> 2] | 0;
    i6 = (i3 | 0) == 0;
    if (i6) {
     i5 = i1;
     i4 = i5;
     while (1) {
      i2 = HEAP32[i4 + 8 >> 2] | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break; else i4 = i2;
     }
    } else {
     i2 = i3;
     while (1) {
      i4 = HEAP32[i2 >> 2] | 0;
      if (!i4) break; else i2 = i4;
     }
     i5 = i1;
    }
    i7 = i2;
    if (i6) {
     i4 = i5;
     while (1) {
      i3 = HEAP32[i4 + 8 >> 2] | 0;
      if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
     }
    } else while (1) {
     i4 = HEAP32[i3 >> 2] | 0;
     if (!i4) break; else i3 = i4;
    }
    if ((HEAP32[i12 >> 2] | 0) == (i8 | 0)) HEAP32[i12 >> 2] = i3;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
    __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i15 >> 2] | 0, i5);
    __ZdlPv(i1);
    if (i9 | 0) {
     i1 = i9 + 4 | 0;
     if (HEAP8[i9 + 20 >> 0] | 0) __Z34register_external_gfx_deallocationPvPKci(HEAP32[i1 >> 2] | -1073741824, gb + 602218 | 0, 116);
     if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 63304 | 0);
   } while ((i2 | 0) != (i13 | 0));
  } while (0);
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 11);
 return;
}

function __ZN17AudioReverbFilter6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i3 + 104 >> 2] | 0;
 if ((i1 | 0) < 27) {
  i13 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 16 >> 2] | 0;
  i4 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 20 >> 2] | 0;
  i12 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 24 >> 2] | 0;
  i11 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 28 >> 2] | 0;
  i10 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 36 >> 2] | 0;
  i9 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 44 >> 2] | 0;
  i8 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 48 >> 2] | 0;
  i5 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 60 >> 2] | 0;
  i2 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 64 >> 2] | 0;
  i7 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 68 >> 2] | 0;
  i6 = HEAP32[gb + 171848 + (i1 * 80 | 0) + 72 >> 2] | 0;
  HEAPF32[i3 + 48 >> 2] = Math_fround(HEAP32[gb + 171848 + (i1 * 80 | 0) + 12 >> 2] | 0);
  HEAPF32[i3 + 52 >> 2] = Math_fround(i13 | 0);
  HEAP32[i3 + 60 >> 2] = i12;
  HEAP32[i3 + 64 >> 2] = i11;
  HEAPF32[i3 + 68 >> 2] = Math_fround(i10 | 0);
  HEAPF32[i3 + 76 >> 2] = Math_fround(i9 | 0);
  HEAP32[i3 + 80 >> 2] = i8;
  HEAP32[i3 + 84 >> 2] = i7;
  HEAP32[i3 + 88 >> 2] = i6;
  HEAP32[i3 + 92 >> 2] = i5;
  HEAPF32[i3 + 96 >> 2] = Math_fround(i4 | 0);
  HEAP32[i3 + 100 >> 2] = i2;
 }
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD3DSP12setParameterEif(i2, 0, Math_fround(HEAPF32[i3 + 44 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 1, Math_fround(HEAPF32[i3 + 48 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 2, Math_fround(HEAPF32[i3 + 52 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 3, Math_fround(HEAPF32[i3 + 60 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 4, Math_fround(HEAPF32[i3 + 64 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 5, Math_fround(HEAPF32[i3 + 68 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 6, Math_fround(HEAPF32[i3 + 72 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 7, Math_fround(HEAPF32[i3 + 76 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 8, Math_fround(HEAPF32[i3 + 80 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 9, Math_fround(HEAPF32[i3 + 84 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 10, Math_fround(HEAPF32[i3 + 88 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 11, Math_fround(HEAPF32[i3 + 92 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 12, Math_fround(HEAPF32[i3 + 96 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i1 >> 2] | 0, 13, Math_fround(HEAPF32[i3 + 100 >> 2])) | 0;
 return;
}

function __ZN13TriggerModule8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 i5 = i4 + 8 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i7 = i3 + 16 | 0;
 i8 = i3 + 24 | 0;
 i9 = HEAP32[gb + 37248 >> 2] | 0;
 i1 = 0;
 do {
  i11 = i2 + 28 + (i1 << 2) | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[gb + 82920 + (i1 << 2) >> 2] | 0, gb + 619781 | 0, i11, 0);
  i12 = i5;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048093 | 0, i6, i11, 1);
  HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048102 | 0, i9, i5, 1);
  HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 6);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619755 | 0, i6, i2 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619762 | 0, i6, i2 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619770 | 0, i6, i2 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619776 | 0, i6, i2 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 619975 | 0, HEAP32[gb + 37012 >> 2] | 0, i2 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 STACKTOP = i10;
 return;
}

function __ZN2UI14CanvasRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i11 = i2;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 186892 + 8;
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 48 >> 2] = 0;
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 64 >> 2] = f9;
 HEAPF32[i1 + 68 >> 2] = f8;
 HEAPF32[i1 + 72 >> 2] = f7;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 100 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 120 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP8[i1 + 160 >> 0] = 0;
 i5 = i1 + 162 | 0;
 i2 = i1 + 168 | 0;
 i3 = i1 + 188 | 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP16[i5 >> 1] = 0;
 HEAP16[i5 + 2 >> 1] = 0 >>> 16;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 208 >> 2] = -1;
 HEAP32[i1 + 212 >> 2] = -1;
 HEAP32[i1 + 216 >> 2] = -1;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = -1;
 HEAP32[i1 + 228 >> 2] = -1;
 HEAP32[i1 + 232 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i8 + 4 | 0;
 if ((i1 | 0) == (i10 | 0)) {
  i14 = i12;
  i9 = i7;
  i12 = HEAP32[i12 >> 2] | 0;
  i13 = i10;
  HEAP32[i9 >> 2] = i12;
  HEAP32[i14 >> 2] = i13;
  i13 = i8 + 8 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i13 >> 2] = i12;
  i11 = i7 + 8 | 0;
  i13 = i8 + 12 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i10 = HEAP32[i13 >> 2] | 0;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i13 >> 2] = i12;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i14;
  STACKTOP = i15;
  return;
 }
 i13 = i9 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 do {
  i3 = i1;
  i1 = i1 + -20 | 0;
  HEAP32[i4 + -20 >> 2] = HEAP32[i1 >> 2];
  i2 = i4 + -16 | 0;
  i5 = i3 + -16 | 0;
  i6 = HEAP8[i5 + 11 >> 0] | 0;
  i16 = i6 << 24 >> 24 < 0;
  i5 = i16 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i16 ? HEAP32[i3 + -12 >> 2] | 0 : i6 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + -4 >> 2] = i3;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i4 + -4 >> 2] | 0;
   i14 = 7;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i6;
   if (i6) i14 = 9;
  } else i14 = 7;
  if ((i14 | 0) == 7) {
   i17 = i6 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i13 >> 2] = i3;
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i16;
   HEAP32[i4 + -8 >> 2] = i17 | -2147483648;
   HEAP32[i4 + -12 >> 2] = i6;
   i2 = i16;
   i14 = 9;
  }
  if ((i14 | 0) == 9) {
   i14 = 0;
   _memcpy(i2 | 0, i5 | 0, i6 | 0) | 0;
  }
  HEAP8[i2 + i6 >> 0] = 0;
  i4 = (HEAP32[i12 >> 2] | 0) + -20 | 0;
  HEAP32[i12 >> 2] = i4;
 } while ((i1 | 0) != (i10 | 0));
 i17 = i12;
 i16 = i7;
 i14 = i4;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i17 >> 2] = i13;
 i13 = i8 + 8 | 0;
 i16 = HEAP32[i11 >> 2] | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i11 >> 2] = i14;
 HEAP32[i13 >> 2] = i16;
 i13 = i7 + 8 | 0;
 i16 = i8 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i16 >> 2] | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i16 >> 2] = i14;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i8 >> 2] = i17;
 STACKTOP = i15;
 return;
}

function __ZN9Rigidbody18AddForceAtPositionERK8Vector3fS2_i(i1, i3, i8, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, f18 = f0, f19 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 12 | 0;
 i11 = i13;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 i17 = f18 < Math_fround(0.0);
 f19 = Math_fround(-f18);
 i6 = i3 + 4 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f15 < Math_fround(0.0);
 f16 = Math_fround(-f15);
 i7 = i3 + 8 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = f4 < Math_fround(0.0);
 f14 = Math_fround(-f4);
 i17 = (i17 ? f19 : f18) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
 i5 = i17 & (i5 ? f16 : f15) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 if (i5 & (i9 ? f14 : f4) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
  STACKTOP = i13;
  return;
 }
 i9 = i1 + 52 | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i17 >> 2] | 0) + 200 >> 2] | 0, i17 | 0) | 0) & 1) {
  STACKTOP = i13;
  return;
 }
 f4 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 switch (i2 | 0) {
 case 5:
  {
   f16 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f18 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f19 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 0;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   i1 = 1;
   i12 = 6;
   break;
  }
 case 2:
  {
   f16 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f18 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f19 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 1;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  {
   i1 = 0;
   i12 = 6;
  }
 }
 if ((i12 | 0) == 6) {
  i5 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i17 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i10 + 8 >> 2] = i2;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i11 + 8 >> 2] = i12;
 __ZN5physx14PxRigidBodyExt13addForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i17, i10, i11, i1, 1);
 STACKTOP = i13;
 return;
}

function __ZN15AudioMixerGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i7 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 52 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863864 | 0, gb + 863877 | 0, i5, 0);
 i10 = i9 + 8 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i10, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i10 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863894 | 0, gb + 863904 | 0, i10, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i10, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863909 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 863920 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 56 | 0;
 i13 = i4 + 28 | 0;
 i18 = i4;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i13 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i18 | 0, i2 | 0);
 f11 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(HEAPF32[i18 + 20 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f16 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f6 = Math_fround(f11 * f9);
 f7 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f14 * f7));
 f5 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f17 * f5));
 f8 = Math_fround(Math_fround(f9 * f6) + Math_fround(Math_fround(f11 * f16) + Math_fround(f15 * Math_fround(Math_fround(f17 * f7) - Math_fround(f14 * f5)))));
 f10 = Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f14 * f16) + Math_fround(f15 * Math_fround(Math_fround(f11 * f5) - Math_fround(f17 * f9)))));
 f6 = Math_fround(Math_fround(Math_fround(f17 * f16) + Math_fround(f15 * Math_fround(Math_fround(f14 * f9) - Math_fround(f11 * f7)))) + Math_fround(f5 * f6));
 f8 = Math_fround(Math_fround(HEAPF32[i13 + 16 >> 2]) + f8);
 f10 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) + f10);
 f6 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) + f6);
 f8 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f8);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f10);
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f6);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i12 | 0, i2 | 0);
 f5 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f7 = Math_fround(f6 * f5);
 f11 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f10 * f11));
 f11 = Math_fround(f8 * f11);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(f11 - Math_fround(f6 * f9));
 f5 = Math_fround(Math_fround(f10 * f9) - Math_fround(f8 * f5));
 HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
 STACKTOP = i4;
 return;
}

function __ZN14dense_hash_mapIiPKcN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEEixERS9_(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 16 | 0;
 i14 = i15;
 i4 = HEAP32[i11 + 4 >> 2] | 0;
 if ((HEAP32[i11 + 36 >> 2] | 0) == (i4 | 0)) {
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i11 + 32 >> 2] | 0;
  i7 = i10 + -1 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i1 = (Math_imul((Math_imul((Math_imul((Math_imul(i8 >>> 24 ^ -2128831035, 16777619) | 0) ^ i8 >>> 16 & 255, 16777619) | 0) ^ i8 >>> 8 & 255, 16777619) | 0) ^ i8 & 255, 16777619) | 0) & i7;
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i9 = HEAP32[i11 + 20 >> 2] | 0;
  i6 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L4 : do if ((i9 | 0) == (i6 | 0)) i1 = -1; else {
   i3 = i11 + 12 | 0;
   if (!(HEAP8[i11 + 8 >> 0] | 0)) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   if (!i4) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i7;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   i5 = HEAP32[i3 >> 2] | 0;
   i4 = 0;
   i3 = i6;
   while (1) {
    if ((i5 | 0) != (i3 | 0) & (i8 | 0) == (i3 | 0)) break L4;
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i7;
    i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
    if ((i9 | 0) == (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i3 = (i1 | 0) == -1 ? i2 + (i10 << 3) | 0 : i2 + (i1 << 3) | 0;
  i1 = i10;
 }
 if ((i3 | 0) != (i2 + (i1 << 3) | 0)) {
  i14 = i3;
  i14 = i14 + 4 | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj(i11, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_(i14, i11, i13);
 i14 = HEAP32[i14 + 4 >> 2] | 0;
 i14 = i14 + 4 | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function _gzseek(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if ((i8 | 0) == 0 | (i2 | 0) == 2) {
  i9 = -1;
  return i9 | 0;
 }
 i5 = i8 + 56 | 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case -3:
 case -1:
  {
   i9 = -1;
   return i9 | 0;
  }
 default:
  {}
 }
 i4 = HEAP8[i8 + 92 >> 0] | 0;
 if (i4 << 24 >> 24 == 119) {
  if (!i2) i1 = i1 - (HEAP32[i8 + 100 >> 2] | 0) | 0;
  if ((i1 | 0) < 0) {
   i9 = -1;
   return i9 | 0;
  }
  i3 = i8 + 68 | 0;
  do if (!(HEAP32[i3 >> 2] | 0)) {
   i2 = _malloc(16384) | 0;
   HEAP32[i3 >> 2] = i2;
   if (!i2) {
    i9 = -1;
    return i9 | 0;
   } else {
    _memset(i2 | 0, 0, 16384) | 0;
    break;
   }
  } while (0);
  while (1) {
   if ((i1 | 0) <= 0) break;
   i2 = _gzwrite(i8, HEAP32[i3 >> 2] | 0, (i1 | 0) < 16384 ? i1 : 16384) | 0;
   if (!i2) {
    i7 = -1;
    i9 = 34;
    break;
   } else i1 = i1 - i2 | 0;
  }
  if ((i9 | 0) == 34) return i7 | 0;
  i9 = HEAP32[i8 + 100 >> 2] | 0;
  return i9 | 0;
 }
 if ((i2 | 0) == 1) i1 = (HEAP32[i8 + 104 >> 2] | 0) + i1 | 0;
 if ((i1 | 0) < 0) {
  i9 = -1;
  return i9 | 0;
 }
 i2 = i8 + 88 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  HEAP32[i8 + 108 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i8 + 68 >> 2];
  if ((_fseek(HEAP32[i8 + 64 >> 2] | 0, i1, 0) | 0) < 0) {
   i9 = -1;
   return i9 | 0;
  }
  HEAP32[i8 + 104 >> 2] = i1;
  HEAP32[i8 + 100 >> 2] = i1;
  i9 = i1;
  return i9 | 0;
 }
 i6 = i8 + 104 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) < (i3 | 0)) {
  if (i4 << 24 >> 24 != 114) {
   i9 = -1;
   return i9 | 0;
  }
  HEAP32[i5 >> 2] = 0;
  HEAP32[i8 + 60 >> 2] = 0;
  HEAP32[i8 + 108 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i8 + 68 >> 2];
  HEAP32[i8 + 76 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
  if (!(HEAP32[i2 >> 2] | 0)) _unity_z_inflateReset(i8) | 0;
  HEAP32[i8 + 100 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  if ((_fseek(HEAP32[i8 + 64 >> 2] | 0, HEAP32[i8 + 96 >> 2] | 0, 0) | 0) < 0) {
   i9 = -1;
   return i9 | 0;
  }
 } else i1 = i1 - i3 | 0;
 i4 = i8 + 72 | 0;
 if (!i1) i1 = 0; else {
  if (!(HEAP32[i4 >> 2] | 0)) {
   i3 = _malloc(16384) | 0;
   HEAP32[i4 >> 2] = i3;
   if (!i3) {
    i9 = -1;
    return i9 | 0;
   }
  }
  i2 = i8 + 108 | 0;
  if ((HEAP32[i2 >> 2] | 0) != -1) {
   HEAP32[i2 >> 2] = -1;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i1 = i1 + -1 | 0;
   if (HEAP32[i8 + 112 >> 2] | 0) HEAP32[i5 >> 2] = 1;
  }
 }
 while (1) {
  if ((i1 | 0) <= 0) break;
  i2 = _gzread(i8, HEAP32[i4 >> 2] | 0, (i1 | 0) < 16384 ? i1 : 16384) | 0;
  i3 = (i2 | 0) < 1;
  if (i3) {
   i7 = -1;
   i9 = 34;
   break;
  } else i1 = i1 - (i3 ? 0 : i2) | 0;
 }
 if ((i9 | 0) == 34) return i7 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 return i9 | 0;
}

function __ZN11LightProbesC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i7 = i4 + 8 | 0;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 34648 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 56 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63752 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 76 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = gb + 63752 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 96 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = i6;
 i6 = i1 + 136 | 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 172 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 188 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z32GetSceneHierarchyPathDescriptivePK6Object(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 64 | 0;
 i8 = i12 + 48 | 0;
 i9 = i12 + 32 | 0;
 i10 = i12 + 16 | 0;
 i11 = i12;
 __Z21GetSceneHierarchyPathPK6Object(i8, i1);
 i2 = i8 + 11 | 0;
 i5 = HEAP8[i2 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
 } else {
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i10 + 12 >> 2] = i1;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = -2147483616;
  HEAP32[i10 + 4 >> 2] = 22;
  i3 = i1;
  i4 = gb + 448062 | 0;
  i5 = i3 + 22 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  HEAP8[i1 + 22 >> 0] = 0;
  __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i9, i10, i8);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i5 = i11 + 11 | 0;
  HEAP8[i5 >> 0] = 1;
  HEAP8[i11 >> 0] = 34;
  HEAP8[i11 + 1 >> 0] = 0;
  __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i6, i9, i11);
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   i6 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  }
  if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
   i11 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
  }
  if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
   i11 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 1;
   HEAP32[i7 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
  }
 }
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
 STACKTOP = i12;
 return;
}

function __Z13MurmurHash64APKviy(i4, i7, i1, i3) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = ___muldi3(i7 | 0, ((i7 | 0) < 0) << 31 >> 31 | 0, 1540483477, -962287725) | 0;
 i2 = i2 ^ i1;
 i1 = (getTempRet0() | 0) ^ i3;
 i3 = (i7 | 0) / 8 | 0;
 i6 = i4 + (i3 << 3) | 0;
 if ((i4 | 0) != (i6 | 0)) {
  i5 = i4 + (i3 << 3) | 0;
  i3 = i4;
  do {
   i9 = i3;
   i3 = i3 + 8 | 0;
   i9 = ___muldi3(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, 1540483477, -962287725) | 0;
   i4 = getTempRet0() | 0;
   i10 = _bitshift64Lshr(i9 | 0, i4 | 0, 47) | 0;
   i4 = ___muldi3(i10 ^ i9 | 0, (getTempRet0() | 0) ^ i4 | 0, 1540483477, -962287725) | 0;
   i2 = ___muldi3(i4 ^ i2 | 0, (getTempRet0() | 0) ^ i1 | 0, 1540483477, -962287725) | 0;
   i1 = getTempRet0() | 0;
  } while ((i3 | 0) != (i6 | 0));
  i4 = i5;
 }
 switch (i7 & 7) {
 case 7:
  {
   i2 = (_bitshift64Shl(HEAPU8[i4 + 6 >> 0] | 0 | 0, 0, 48) | 0) ^ i2;
   i1 = (getTempRet0() | 0) ^ i1;
   i8 = 7;
   break;
  }
 case 6:
  {
   i8 = 7;
   break;
  }
 case 5:
  {
   i8 = 8;
   break;
  }
 case 4:
  {
   i8 = 9;
   break;
  }
 case 3:
  {
   i8 = 10;
   break;
  }
 case 2:
  {
   i8 = 11;
   break;
  }
 case 1:
  break;
 default:
  {
   i9 = i2;
   i10 = i1;
   i8 = _bitshift64Lshr(i9 | 0, i10 | 0, 47) | 0;
   i7 = getTempRet0() | 0;
   i9 = i8 ^ i9;
   i10 = i7 ^ i10;
   i10 = ___muldi3(i9 | 0, i10 | 0, 1540483477, -962287725) | 0;
   i9 = getTempRet0() | 0;
   i7 = _bitshift64Lshr(i10 | 0, i9 | 0, 47) | 0;
   i8 = getTempRet0() | 0;
   i10 = i7 ^ i10;
   i9 = i8 ^ i9;
   setTempRet0(i9 | 0);
   return i10 | 0;
  }
 }
 if ((i8 | 0) == 7) {
  i10 = _bitshift64Shl(HEAPU8[i4 + 5 >> 0] | 0 | 0, 0, 40) | 0;
  i2 = i10 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i8 = 8;
 }
 if ((i8 | 0) == 8) {
  i1 = (HEAPU8[i4 + 4 >> 0] | 0) ^ i1;
  i8 = 9;
 }
 if ((i8 | 0) == 9) {
  i10 = _bitshift64Shl(HEAPU8[i4 + 3 >> 0] | 0 | 0, 0, 24) | 0;
  i2 = i10 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i8 = 10;
 }
 if ((i8 | 0) == 10) {
  i10 = _bitshift64Shl(HEAPU8[i4 + 2 >> 0] | 0 | 0, 0, 16) | 0;
  i2 = i10 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
  i8 = 11;
 }
 if ((i8 | 0) == 11) {
  i10 = _bitshift64Shl(HEAPU8[i4 + 1 >> 0] | 0 | 0, 0, 8) | 0;
  i2 = i10 ^ i2;
  i1 = (getTempRet0() | 0) ^ i1;
 }
 i9 = ___muldi3((HEAPU8[i4 >> 0] | 0) ^ i2 | 0, i1 | 0, 1540483477, -962287725) | 0;
 i10 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i9 | 0, i10 | 0, 47) | 0;
 i7 = getTempRet0() | 0;
 i9 = i8 ^ i9;
 i10 = i7 ^ i10;
 i10 = ___muldi3(i9 | 0, i10 | 0, 1540483477, -962287725) | 0;
 i9 = getTempRet0() | 0;
 i7 = _bitshift64Lshr(i10 | 0, i9 | 0, 47) | 0;
 i8 = getTempRet0() | 0;
 i10 = i7 ^ i10;
 i9 = i8 ^ i9;
 setTempRet0(i9 | 0);
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_17PxActiveTransformENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 36 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 706509 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 36 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i1 = i1 + 36 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 36 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 * 36 | 0) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i4 + (i1 * 36 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i4 + (i1 * 36 | 0) + 32 >> 2] = HEAP32[i6 + 32 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 * 36 | 0) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 * 36 | 0) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 * 36 | 0) | 0;
 return i12 | 0;
}

function __ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw(i4, i6, i9, i7, i10, i1, i2, i8, i12, i13, i11, i5) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 L1 : do if ((i4 | 0) == (i1 | 0)) if (!(HEAP8[i6 >> 0] | 0)) i1 = -1; else {
  HEAP8[i6 >> 0] = 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i9 + 1;
  HEAP8[i9 >> 0] = 46;
  i10 = HEAP8[i8 + 11 >> 0] | 0;
  if (!((i10 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i10 & 255) | 0)) i1 = 0; else {
   i1 = HEAP32[i13 >> 2] | 0;
   if ((i1 - i12 | 0) < 160) {
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i1 + 4;
    HEAP32[i1 >> 2] = i12;
    i1 = 0;
   } else i1 = 0;
  }
 } else {
  if ((i4 | 0) == (i2 | 0)) {
   i3 = HEAP8[i8 + 11 >> 0] | 0;
   if ((i3 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255) | 0) {
    if (!(HEAP8[i6 >> 0] | 0)) {
     i1 = -1;
     break;
    }
    i1 = HEAP32[i13 >> 2] | 0;
    if ((i1 - i12 | 0) >= 160) {
     i1 = 0;
     break;
    }
    i12 = HEAP32[i11 >> 2] | 0;
    HEAP32[i13 >> 2] = i1 + 4;
    HEAP32[i1 >> 2] = i12;
    HEAP32[i11 >> 2] = 0;
    i1 = 0;
    break;
   }
  }
  i3 = i5 + 128 | 0;
  i2 = 0;
  while (1) {
   i1 = i5 + (i2 << 2) | 0;
   if ((i2 | 0) == 32) {
    i1 = i3;
    break;
   }
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i2 = i1 - i5 | 0;
  i1 = i2 >> 2;
  if ((i2 | 0) > 124) i1 = -1; else {
   i3 = HEAP8[gb + 1077991 + i1 >> 0] | 0;
   switch (i1 | 0) {
   case 24:
   case 25:
    {
     i1 = HEAP32[i10 >> 2] | 0;
     if ((i1 | 0) != (i7 | 0)) if ((HEAPU8[i1 + -1 >> 0] & 95 | 0) != (HEAPU8[i9 >> 0] & 127 | 0)) {
      i1 = -1;
      break L1;
     }
     HEAP32[i10 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3;
     i1 = 0;
     break L1;
    }
   case 23:
   case 22:
    {
     HEAP8[i9 >> 0] = 80;
     break;
    }
   default:
    {
     i1 = i3 & 95;
     if ((i1 | 0) == (HEAP8[i9 >> 0] | 0)) {
      HEAP8[i9 >> 0] = i1 | 128;
      if (HEAP8[i6 >> 0] | 0) {
       HEAP8[i6 >> 0] = 0;
       i9 = HEAP8[i8 + 11 >> 0] | 0;
       if ((i9 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i9 & 255) | 0) {
        i1 = HEAP32[i13 >> 2] | 0;
        if ((i1 - i12 | 0) < 160) {
         i12 = HEAP32[i11 >> 2] | 0;
         HEAP32[i13 >> 2] = i1 + 4;
         HEAP32[i1 >> 2] = i12;
        }
       }
      }
     }
    }
   }
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = i13 + 1;
   HEAP8[i13 >> 0] = i3;
   if ((i2 | 0) > 84) i1 = 0; else {
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
    i1 = 0;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZN5Unity12PhysicsQueryC2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i8 + 12 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8 + 24 | 0;
 i7 = i8 + 28 | 0;
 i9 = i8 + 36 | 0;
 i10 = i8 + 40 | 0;
 i11 = i8 + 48 | 0;
 i12 = i8 + 52 | 0;
 i1 = i8;
 i2 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZNSt3__26vectorIN5physx10PxSweepHitENS_9allocatorIS2_EEE8__appendEj(i8, 128);
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i3 - i2 >> 6;
 if (i1 >>> 0 < 128) __ZNSt3__26vectorIN5physx12PxRaycastHitENS_9allocatorIS2_EEE8__appendEj(i4, 128 - i1 | 0); else if ((i1 | 0) != 128) {
  i1 = i2 + 8192 | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -64 - i1 | 0) >>> 6) << 6);
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i3 - i2 >> 4;
 if (i1 >>> 0 < 128) __ZNSt3__26vectorIN5physx12PxOverlapHitENS_9allocatorIS2_EEE8__appendEj(i6, 128 - i1 | 0); else if ((i1 | 0) != 128) {
  i1 = i2 + 2048 | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -16 - i1 | 0) >>> 4) << 4);
 }
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) - i2 >> 2 >>> 0 < 128) {
  i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
  i6 = i3 >> 2;
  i4 = __Znwj(512) | 0;
  i5 = i4 + (i6 << 2) | 0;
  i6 = i5 + (0 - i6 << 2) | 0;
  if ((i3 | 0) > 0) _memcpy(i6 | 0, i2 | 0, i3 | 0) | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i1 >> 2] = i4 + 512;
  if (i2 | 0) __ZdlPv(i2);
 }
 i6 = i8 + 56 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = i1;
 if ((((HEAP32[i6 >> 2] | 0) - i1 | 0) / 44 | 0) >>> 0 >= 128) return;
 i4 = HEAP32[i12 >> 2] | 0;
 i2 = i4;
 i8 = __Znwj(5632) | 0;
 i4 = i8 + (((i4 - i1 | 0) / 44 | 0) * 44 | 0) | 0;
 i7 = i4;
 i8 = i8 + 5632 | 0;
 if ((i2 | 0) == (i5 | 0)) i2 = i7; else {
  i3 = i2;
  i2 = i7;
  i1 = i4;
  do {
   i10 = i3;
   i3 = i3 + -44 | 0;
   HEAP32[i1 + -44 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i10 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i10 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i10 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i10 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i10 + -24 >> 2];
   i13 = i10 + -20 | 0;
   i4 = HEAP32[i13 + 4 >> 2] | 0;
   i9 = i1 + -20 | 0;
   HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i9 + 4 >> 2] = i4;
   HEAP32[i1 + -12 >> 2] = HEAP32[i10 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i10 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i10 + -4 >> 2];
   i1 = i2 + -44 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i6 >> 2] = i8;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 24 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 450991 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 450991 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN5physx18NpArticulationLinkC2ERKNS_11PxTransformERNS_14NpArticulationEPS0_(i6, i1, i3, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP16[i6 + 4 >> 1] = 15;
 HEAP16[i6 + 6 >> 1] = 1;
 i2 = i6 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 91596 + 8;
 __ZN5physx7NpActorC2EPKc(i6 + 12 | 0, 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerC2Ev(i6 + 20 | 0);
 HEAP32[i6 >> 2] = gb + 92112 + 8;
 HEAP32[i6 + 48 >> 2] = 0;
 HEAP32[i6 + 56 >> 2] = 0;
 i2 = i6 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i6 + 64 | 0;
 __ZN5physx2Sc8BodyCoreC2ENS_11PxActorType4EnumERKNS_11PxTransformE(i8, 4, i1);
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -251658241 | 50331648;
 HEAP32[i6 + 224 >> 2] = HEAP32[i6 + 80 >> 2];
 HEAP32[i6 + 228 >> 2] = HEAP32[i6 + 84 >> 2];
 HEAP32[i6 + 232 >> 2] = HEAP32[i6 + 88 >> 2];
 HEAP32[i6 + 236 >> 2] = HEAP32[i6 + 92 >> 2];
 HEAP32[i6 + 240 >> 2] = HEAP32[i6 + 96 >> 2];
 HEAP32[i6 + 244 >> 2] = HEAP32[i6 + 100 >> 2];
 HEAP32[i6 + 248 >> 2] = HEAP32[i6 + 104 >> 2];
 HEAP32[i6 + 252 >> 2] = HEAP32[i6 + 144 >> 2];
 HEAP32[i6 + 256 >> 2] = HEAP32[i6 + 148 >> 2];
 HEAP32[i6 + 260 >> 2] = HEAP32[i6 + 152 >> 2];
 HEAP32[i6 + 264 >> 2] = HEAP32[i6 + 160 >> 2];
 HEAP32[i6 + 268 >> 2] = HEAP32[i6 + 164 >> 2];
 HEAP32[i6 + 272 >> 2] = HEAP32[i6 + 168 >> 2];
 HEAPF32[i6 + 276 >> 2] = Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i8));
 HEAP32[i6 + 280 >> 2] = 1;
 HEAP32[i6 + 284 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 92380 + 8;
 HEAP32[i6 + 288 >> 2] = i3;
 HEAP32[i6 + 292 >> 2] = 0;
 HEAP32[i6 + 296 >> 2] = i5;
 HEAP32[i6 + 324 >> 2] = 0;
 HEAP8[i6 + 316 >> 0] = 1;
 HEAP32[i6 + 320 >> 2] = i6 + 300;
 HEAP32[i6 + 328 >> 2] = 4;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -251658241 | 67108864;
 HEAP32[i4 >> 2] = i6;
 i1 = i3 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 + 96 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 + 88 >> 2] | 0) + (i2 << 2) >> 2] = i6;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_18NpArticulationLinkENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i3 + 68 | 0, i4) | 0;
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = i6;
 i1 = i5 + 324 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i5 + 328 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i5 + 320 >> 2] | 0) + (i2 << 2) >> 2] = i6;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_18NpArticulationLinkENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i5 + 300 | 0, i4) | 0;
 STACKTOP = i7;
 return;
}

function __ZN11PerlinNoise5NoiseEff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0;
 i14 = f1 < Math_fround(0.0);
 f7 = Math_fround(-f1);
 f7 = i14 ? f7 : f1;
 i14 = f2 < Math_fround(0.0);
 f6 = Math_fround(-f2);
 f6 = i14 ? f6 : f2;
 i14 = ~~f7;
 i10 = ~~f6;
 i12 = i14 & 255;
 i5 = i10 & 255;
 f7 = Math_fround(f7 - Math_fround(i14 | 0));
 f6 = Math_fround(f6 - Math_fround(i10 | 0));
 i10 = f7 > Math_fround(1.0);
 f8 = i10 ? Math_fround(1.0) : f7;
 f8 = Math_fround(Math_fround(f8 * Math_fround(f8 * f8)) * Math_fround(Math_fround(f8 * Math_fround(Math_fround(f8 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 i10 = f6 > Math_fround(1.0);
 f9 = i10 ? Math_fround(1.0) : f6;
 f9 = Math_fround(Math_fround(f9 * Math_fround(f9 * f9)) * Math_fround(Math_fround(f9 * Math_fround(Math_fround(f9 * Math_fround(6.0)) + Math_fround(-15.0))) + Math_fround(10.0)));
 i10 = (HEAP32[gb + 80356 + (i12 << 2) >> 2] | 0) + i5 | 0;
 i5 = (HEAP32[gb + 80356 + (i12 + 1 << 2) >> 2] | 0) + i5 | 0;
 i12 = HEAP32[gb + 80356 + (HEAP32[gb + 80356 + (i10 << 2) >> 2] << 2) >> 2] | 0;
 i14 = i12 & 15;
 f3 = i14 >>> 0 < 8 ? f7 : f6;
 f4 = (i14 | 2 | 0) == 14 ? f7 : Math_fround(0.0);
 f4 = i14 >>> 0 < 4 ? f6 : f4;
 f13 = Math_fround(-f3);
 f2 = Math_fround(-f4);
 f2 = Math_fround(((i12 & 1 | 0) == 0 ? f3 : f13) + ((i12 & 2 | 0) == 0 ? f4 : f2));
 i12 = HEAP32[gb + 80356 + (HEAP32[gb + 80356 + (i5 << 2) >> 2] << 2) >> 2] | 0;
 f4 = Math_fround(f7 + Math_fround(-1.0));
 i14 = i12 & 15;
 f13 = i14 >>> 0 < 8 ? f4 : f6;
 f3 = (i14 | 2 | 0) == 14 ? f4 : Math_fround(0.0);
 f3 = i14 >>> 0 < 4 ? f6 : f3;
 f1 = Math_fround(-f13);
 f11 = Math_fround(-f3);
 f2 = Math_fround(f2 + Math_fround(f8 * Math_fround(Math_fround(((i12 & 1 | 0) == 0 ? f13 : f1) + ((i12 & 2 | 0) == 0 ? f3 : f11)) - f2)));
 i10 = HEAP32[gb + 80356 + (HEAP32[gb + 80356 + (i10 + 1 << 2) >> 2] << 2) >> 2] | 0;
 f6 = Math_fround(f6 + Math_fround(-1.0));
 i12 = i10 & 15;
 f11 = i12 >>> 0 < 8 ? f7 : f6;
 f7 = (i12 | 2 | 0) == 14 ? f7 : Math_fround(0.0);
 f7 = i12 >>> 0 < 4 ? f6 : f7;
 f3 = Math_fround(-f11);
 f1 = Math_fround(-f7);
 f1 = Math_fround(((i10 & 1 | 0) == 0 ? f11 : f3) + ((i10 & 2 | 0) == 0 ? f7 : f1));
 i5 = HEAP32[gb + 80356 + (HEAP32[gb + 80356 + (i5 + 1 << 2) >> 2] << 2) >> 2] | 0;
 i10 = i5 & 15;
 f7 = i10 >>> 0 < 8 ? f4 : f6;
 f4 = (i10 | 2 | 0) == 14 ? f4 : Math_fround(0.0);
 f4 = i10 >>> 0 < 4 ? f6 : f4;
 f6 = Math_fround(-f7);
 f3 = Math_fround(-f4);
 return Math_fround(f2 + Math_fround(f9 * Math_fround(Math_fround(f1 + Math_fround(f8 * Math_fround(Math_fround(((i5 & 1 | 0) == 0 ? f7 : f6) + ((i5 & 2 | 0) == 0 ? f4 : f3)) - f1))) - f2)));
}

function __ZL24PrepareSpriteRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i7 = HEAP32[i9 + 32 >> 2] | 0;
 i8 = HEAP32[i9 + 36 >> 2] | 0;
 i11 = HEAP32[i9 + 48 >> 2] | 0;
 i12 = i9 + 16 | 0;
 i15 = i9 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i13 = i9 + 12 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 >= i8 >>> 0) {
  i14 = i1;
  HEAP32[i15 >> 2] = i14;
  return;
 }
 i14 = i9 + 20 | 0;
 i10 = i9 + 24 | 0;
 while (1) {
  i5 = HEAP32[i11 + ((HEAP32[i7 + (i2 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0;
  i5 = (i5 | 0) == 0 ? 0 : i5 + -32 | 0;
  i2 = i5 + 32 | 0;
  i6 = i5 + 268 | 0;
  if (((HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16) & 63 | 0) != 3) {
   i2 = 13;
   break;
  }
  do if (HEAP32[i5 + 364 >> 2] | 0) {
   i6 = HEAP32[i9 >> 2] | 0;
   i3 = i6 + (i1 * 360 | 0) | 0;
   i4 = i5 + 272 | 0;
   i16 = HEAP16[i4 >> 1] | 0;
   if ((i16 & 65535) > 255 | (i16 & 255) << 24 >> 24 != 0) {
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0);
    HEAP8[i4 >> 0] = 0;
    HEAP8[i5 + 273 >> 0] = 0;
   }
   __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode(i2, i5 + 36 | 0, Math_fround(0.0), i3);
   __ZN12BaseRenderer11ClearProbesER10RenderNode(i3);
   if (!(__ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i2, i12, i3) | 0)) {
    __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i9);
    break;
   }
   i2 = HEAP32[i14 >> 2] | 0;
   if ((i2 + 24 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
    __ZN22PerThreadPageAllocator14AcquireNewPageEj(i12, 32768);
    i2 = HEAP32[i14 >> 2] | 0;
   }
   i16 = (HEAP32[i12 >> 2] | 0) + i2 | 0;
   HEAP32[i14 >> 2] = i2 + 24;
   HEAP32[i6 + (i1 * 360 | 0) + 328 >> 2] = i16;
   HEAP32[i16 >> 2] = __ZN14SpriteRenderer11GetGeometryEv(i5) | 0;
   i2 = HEAP16[i5 + 360 >> 1] | 0;
   HEAP8[i16 + 4 >> 0] = i2;
   HEAP8[i16 + 5 >> 0] = (i2 & 65535) >>> 8;
   i16 = i16 + 8 | 0;
   i2 = HEAP32[i5 + 348 >> 2] | 0;
   i3 = HEAP32[i5 + 352 >> 2] | 0;
   i4 = HEAP32[i5 + 356 >> 2] | 0;
   HEAP32[i16 >> 2] = HEAP32[i5 + 344 >> 2];
   HEAP32[i16 + 4 >> 2] = i2;
   HEAP32[i16 + 8 >> 2] = i3;
   HEAP32[i16 + 12 >> 2] = i4;
   HEAP32[i6 + (i1 * 360 | 0) + 332 >> 2] = fb + 222;
   HEAP32[i6 + (i1 * 360 | 0) + 344 >> 2] = fb + 2416;
   HEAP32[i6 + (i1 * 360 | 0) + 348 >> 2] = 1;
   HEAP32[i6 + (i1 * 360 | 0) + 340 >> 2] = fb + 528;
   i1 = i1 + 1 | 0;
  } while (0);
  i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
  HEAP32[i13 >> 2] = i2;
  if (i2 >>> 0 >= i8 >>> 0) {
   i2 = 13;
   break;
  }
 }
 if ((i2 | 0) == 13) {
  HEAP32[i15 >> 2] = i1;
  return;
 }
}

function __Z19TransferField_ArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 48 | 0;
 i3 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, HEAP32[i4 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i7, HEAP32[i4 + 24 >> 2] | 0);
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i6, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i8 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __Z14PadImageBorderR14ImageReferenceii(i3, i11, i1) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = HEAP32[i3 + 8 >> 2] | 0;
 i10 = i3 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i12 = __Z25GetBytesFromTextureFormat13TextureFormat(HEAP32[i3 >> 2] | 0) | 0;
 L1 : do if ((i1 | 0) > 0) {
  i7 = Math_imul(i12, i11 + -1 | 0) | 0;
  i8 = (i14 | 0) > (i11 | 0);
  i9 = i3 + 12 | 0;
  if ((i12 | 0) > 0) i6 = 0; else {
   i3 = HEAP32[i9 >> 2] | 0;
   if (i8) {
    i4 = 0;
    while (1) {
     i2 = i2 + i3 | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i1 | 0)) break L1;
    }
   } else {
    i4 = 0;
    while (1) {
     i2 = i2 + i3 | 0;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i1 | 0)) break L1;
    }
   }
  }
  do {
   i4 = i2 + i7 | 0;
   i3 = 0;
   do {
    HEAP8[i13 + i3 >> 0] = HEAP8[i4 + i3 >> 0] | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i12 | 0));
   if (i8) {
    i5 = i11;
    do {
     i4 = i4 + i12 | 0;
     i3 = 0;
     do {
      HEAP8[i4 + i3 >> 0] = HEAP8[i13 + i3 >> 0] | 0;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i12 | 0));
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i14 | 0));
   }
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = i2 + i3 | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i1 | 0));
 } else {
  i3 = i3 + 12 | 0;
  i9 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 } while (0);
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = Math_imul(i3, i1 + -1 | 0) | 0;
 i8 = i4 + i3 | 0;
 i6 = (i12 | 0) > 0;
 if (i6) _memcpy(i13 | 0, i4 + (i3 + (Math_imul(i12, i11 + -1 | 0) | 0)) | 0, i12 | 0) | 0;
 if ((i15 | 0) <= (i1 | 0)) {
  STACKTOP = i16;
  return;
 }
 i7 = Math_imul(i12, i11) | 0;
 if ((i14 | 0) <= (i11 | 0)) if (i6) {
  while (1) {
   _memcpy(i2 | 0, i8 | 0, i7 | 0) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i15 | 0)) break; else i2 = i2 + (HEAP32[i9 >> 2] | 0) | 0;
  }
  STACKTOP = i16;
  return;
 } else {
  while (1) {
   _memcpy(i2 | 0, i8 | 0, i7 | 0) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i15 | 0)) break; else i2 = i2 + (HEAP32[i9 >> 2] | 0) | 0;
  }
  STACKTOP = i16;
  return;
 }
 while (1) {
  _memcpy(i2 | 0, i8 | 0, i7 | 0) | 0;
  if (i6) {
   i4 = i11;
   i5 = i2 + i7 | 0;
   while (1) {
    i3 = 0;
    do {
     HEAP8[i5 + i3 >> 0] = HEAP8[i13 + i3 >> 0] | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i12 | 0));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i14 | 0)) break; else i5 = i5 + i12 | 0;
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i15 | 0)) break; else i2 = i2 + (HEAP32[i9 >> 2] | 0) | 0;
 }
 STACKTOP = i16;
 return;
}

function ___getopt_long(i8, i10, i9, i13, i12, i3) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i1 = HEAP32[gb + 191400 >> 2] | 0;
 if ((i1 | 0) == 0 | (HEAP32[gb + 1469520 >> 2] | 0) != 0) {
  HEAP32[gb + 1469520 >> 2] = 0;
  HEAP32[gb + 1469524 >> 2] = 0;
  HEAP32[gb + 191400 >> 2] = 1;
  i1 = 1;
 }
 L4 : do if ((i1 | 0) < (i8 | 0)) {
  i5 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  if (!i5) i1 = -1; else if ((HEAP8[i5 >> 0] | 0) == 45) {
   i4 = i5 + 1 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!i3) {
    if (i2 << 24 >> 24 == 45) if (HEAP8[i5 + 2 >> 0] | 0) {
     i2 = 45;
     i11 = 10;
    }
   } else if (i2 << 24 >> 24) i11 = 10;
   if ((i11 | 0) == 10) {
    i3 = HEAP32[i13 >> 2] | 0;
    i7 = i2 << 24 >> 24 == 45;
    L14 : do if (i3 | 0) {
     i5 = i7 ? i5 + 2 | 0 : i4;
     i6 = 0;
     i4 = i3;
     L16 : while (1) {
      i3 = HEAP8[i4 >> 0] | 0;
      L18 : do if (!(i3 << 24 >> 24)) {
       i2 = i5;
       i11 = 15;
      } else {
       i2 = i5;
       while (1) {
        if (i3 << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) break L18;
        i4 = i4 + 1 | 0;
        i2 = i2 + 1 | 0;
        i3 = HEAP8[i4 >> 0] | 0;
        if (!(i3 << 24 >> 24)) {
         i11 = 15;
         break;
        }
       }
      } while (0);
      L22 : do if ((i11 | 0) == 15) {
       i11 = 0;
       i3 = HEAP8[i2 >> 0] | 0;
       switch (i3 << 24 >> 24) {
       case 61:
       case 0:
        break;
       default:
        break L22;
       }
       i4 = HEAP32[i13 + (i6 << 4) + 4 >> 2] | 0;
       if (i3 << 24 >> 24 != 61) {
        i11 = 19;
        break L16;
       }
       if (i4 | 0) {
        i11 = 18;
        break L16;
       }
      } while (0);
      i2 = i6 + 1 | 0;
      i4 = HEAP32[i13 + (i2 << 4) >> 2] | 0;
      if (!i4) break L14; else i6 = i2;
     }
     do if ((i11 | 0) == 18) HEAP32[gb + 1469532 >> 2] = i2 + 1; else if ((i11 | 0) == 19) if ((i4 | 0) == 1) {
      i1 = i1 + 1 | 0;
      HEAP32[gb + 191400 >> 2] = i1;
      i11 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
      HEAP32[gb + 1469532 >> 2] = i11;
      if (!i11) {
       i1 = 58;
       break L4;
      } else break;
     } else {
      HEAP32[gb + 1469532 >> 2] = 0;
      break;
     } while (0);
     HEAP32[gb + 191400 >> 2] = i1 + 1;
     if (i12 | 0) HEAP32[i12 >> 2] = i6;
     i2 = HEAP32[i13 + (i6 << 4) + 8 >> 2] | 0;
     i1 = HEAP32[i13 + (i6 << 4) + 12 >> 2] | 0;
     if (!i2) break L4;
     HEAP32[i2 >> 2] = i1;
     i1 = 0;
     break L4;
    } while (0);
    if (i7) {
     HEAP32[gb + 191400 >> 2] = i1 + 1;
     i1 = 63;
     break;
    }
   }
   i1 = _getopt(i8, i10, i9) | 0;
  } else i1 = -1;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZN5physx2Gu17intersectRayAABB2ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RKNS2_6FloatVERS6_S9_(i3, i2, i5, i4, i1, i7, i6) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f20 = Math_fround(-f12);
 f11 = Math_fround(-f9);
 f14 = Math_fround(-f13);
 f20 = f12 > f20 ? f12 : f20;
 f11 = f9 > f11 ? f9 : f11;
 f14 = f13 > f14 ? f13 : f14;
 i4 = f20 > Math_fround(9.99999971e-10);
 f20 = i4 ? f20 : Math_fround(9.99999971e-10);
 i4 = f11 > Math_fround(9.99999971e-10);
 f11 = i4 ? f11 : Math_fround(9.99999971e-10);
 i4 = f14 > Math_fround(9.99999971e-10);
 f14 = i4 ? f14 : Math_fround(9.99999971e-10);
 i4 = f12 >= Math_fround(0.0);
 f12 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
 i4 = f9 >= Math_fround(0.0);
 f9 = i4 ? Math_fround(1.0) : Math_fround(-1.0);
 i4 = f13 >= Math_fround(0.0);
 f20 = Math_fround(Math_fround(1.0) / Math_fround(f12 * f20));
 f11 = Math_fround(Math_fround(1.0) / Math_fround(f9 * f11));
 f14 = Math_fround(Math_fround(1.0) / Math_fround((i4 ? Math_fround(1.0) : Math_fround(-1.0)) * f14));
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f18 = Math_fround(HEAPF32[i5 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f9 = Math_fround(f20 * Math_fround(f9 - f18));
 f12 = Math_fround(f11 * Math_fround(f12 - f17));
 f13 = Math_fround(f14 * Math_fround(f13 - f16));
 f19 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(f20 * Math_fround(f19 - f18));
 f17 = Math_fround(f11 * Math_fround(f15 - f17));
 f16 = Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f16));
 f14 = f18 < f9 ? f18 : f9;
 f15 = f17 < f12 ? f17 : f12;
 f11 = f16 < f13 ? f16 : f13;
 f9 = f18 > f9 ? f18 : f9;
 f12 = f17 > f12 ? f17 : f12;
 f13 = f16 > f13 ? f16 : f13;
 f11 = f15 > f11 ? f15 : f11;
 f11 = f14 > f11 ? f14 : f11;
 f12 = f12 > f13 ? f13 : f12;
 f9 = f9 > f12 ? f12 : f9;
 i5 = f11 > Math_fround(0.0);
 HEAPF32[i7 >> 2] = i5 ? f11 : Math_fround(0.0);
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = f9 > f11 ? f11 : f9;
 HEAPF32[i6 >> 2] = f9;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 i7 = f9 > Math_fround(HEAPF32[i7 >> 2]);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN13GfxDeviceGLES13DeleteTextureE9TextureID(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i4 = i11 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i5;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i8, i1, i9);
  i2 = HEAP32[i8 >> 2] | 0;
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i6;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 __Z23DeleteSparseTextureGLES9TextureID(i8);
 __Z34register_external_gfx_deallocationPvPKci(i5, gb + 603515 | 0, 1075);
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i2 = i10 + 6648 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) __ZN4gles10InvalidateER20TextureUnitStateGLES(i2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0));
 }
 HEAP32[i9 >> 2] = i5;
 i4 = HEAP32[gb + 1157724 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i8, i4, i9);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  i3 = i4 + 12 | 0;
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  HEAP8[i4 + 48 >> 0] = 1;
 }
 __ZN7ApiGLES13DeleteTextureERj(i10 + 4620 | 0, i7);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63304 | 0);
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i9, i2, i10) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i12 = i13;
 HEAP32[i9 >> 2] = gb + 190148 + 8;
 i8 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i7 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i12 + 11 | 0;
 do if ((i8 | 0) != (i12 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 8 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 8 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  i12 = i9 + 20 | 0;
  HEAP32[i12 >> 2] = i10;
  STACKTOP = i13;
  return;
 }
 i8 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 i12 = i9 + 20 | 0;
 HEAP32[i12 >> 2] = i10;
 STACKTOP = i13;
 return;
}

function __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i11, i1, i12, i13) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i15 = i16 + 16 | 0;
 i10 = i16;
 i1 = __ZN16ScriptingManager18GetMonoScriptCacheEi(__Z19GetScriptingManagerv() | 0, i11) | 0;
 if (i1 | 0) {
  if (!i13) {
   i15 = i1;
   STACKTOP = i16;
   return i15 | 0;
  }
  HEAP32[i1 + 40 >> 2] = i13;
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i15 + 12 >> 2] = i1;
 HEAP32[i14 >> 2] = 66;
 HEAP32[i14 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i15 >> 2] = i1;
 i8 = i15 + 8 | 0;
 HEAP32[i8 >> 2] = -2147483632;
 i9 = i15 + 4 | 0;
 HEAP32[i9 >> 2] = 13;
 i2 = i1;
 i3 = gb + 455837 | 0;
 i4 = i2 + 13 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 13 >> 0] = 0;
 if (!i11) i2 = i15 + 11 | 0; else {
  __Z18BuildScriptClassIdP11Il2CppClass(i10, i11);
  i5 = i10 + 11 | 0;
  i7 = HEAP8[i5 >> 0] | 0;
  i2 = i7 << 24 >> 24 < 0;
  i6 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
  i7 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255;
  i2 = i15 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i1 = (HEAP32[i8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
  do if (i7 >>> 0 > i1 >>> 0) {
   i9 = i4 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i15, i1, i7 - i1 | 0, i9, 0, i9, i7, i6);
  } else {
   i1 = i4 ? HEAP32[i15 >> 2] | 0 : i15;
   if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
   HEAP8[i1 + i7 >> 0] = 0;
   if ((HEAP8[i2 >> 0] | 0) < 0) {
    HEAP32[i9 >> 2] = i7;
    break;
   } else {
    HEAP8[i2 >> 0] = i7;
    break;
   }
  } while (0);
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   i9 = HEAP32[i10 >> 2] | 0;
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i14 >> 2] = 66;
   HEAP32[i14 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i9, i14);
  }
 }
 i1 = __Z21CreateMonoScriptCacheRK8UnityStrP11Il2CppClass22InitScriptingCacheTypeP6Objecti(0, i11, 0, i12, i13) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i13 = HEAP32[i15 >> 2] | 0;
  i15 = HEAP32[i15 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i15;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i14);
 }
 i15 = i1;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN20TextRenderingPrivate11FormatStack10PushFormatERKNS_16TextFormatChangeE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i11 + 40 | 0;
 if (HEAP32[i9 >> 2] & 32768 | 0) {
  i12 = i10 + 12 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  STACKTOP = i13;
  return;
 }
 i12 = i10 + 12 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i1 + (i6 + -1 << 5) | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 i7 = i6 + 1 | 0;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i7 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i12 >> 2] << 5 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i12 >> 2] = i7;
 i1 = i1 + (i6 << 5) | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 & 1 | 0) {
  i8 = (HEAP32[i10 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
 }
 if (i1 & 2 | 0) {
  i8 = (HEAP32[i10 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 }
 if (i1 & 4) {
  HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) + 4 >> 2] = HEAP32[i11 + 12 >> 2];
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if (i1 & 8 | 0) HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) + 8 >> 2] = HEAP32[i11 + 16 >> 2];
 if (i1 & 16 | 0) HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 5) + 12 >> 2] = HEAP32[i11 + 20 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii(i9, i13, i11, i14) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0, d18 = 0.0, d19 = 0.0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 HEAP32[i15 >> 2] = i14;
 i10 = HEAP32[i9 >> 2] | 0;
 i12 = (HEAP32[i9 + 4 >> 2] | 0) - i10 >> 5;
 i1 = i11 + 1 | 0;
 if ((i1 | 0) < (i12 | 0)) {
  if ((i11 | 0) <= -2) i1 = i12 + -1 - ((-2 - i11 | 0) % (i12 | 0) | 0) | 0;
 } else i1 = (i1 | 0) % (i12 | 0) | 0;
 if ((i1 | 0) == (i14 | 0) | (i14 | 0) == (i11 | 0)) {
  i1 = i13 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i13 + 8 >> 2] | 0)) {
   __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i13, i15);
   STACKTOP = i16;
   return;
  } else {
   HEAP32[i2 >> 2] = i14;
   HEAP32[i1 >> 2] = i2 + 4;
   STACKTOP = i16;
   return;
  }
 }
 f17 = Math_fround(HEAPF32[i10 + (i11 << 5) >> 2]);
 f3 = Math_fround(HEAPF32[i10 + (i11 << 5) + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + (i14 << 5) >> 2]);
 f5 = Math_fround(f3 - Math_fround(HEAPF32[i10 + (i14 << 5) + 4 >> 2]));
 f6 = Math_fround(f6 - f17);
 f17 = Math_fround(f17 * f5);
 f3 = Math_fround(f3 * f6);
 f7 = Math_fround(Math_fround(-f17) - f3);
 f3 = Math_fround(Math_abs(Math_fround(f7 + Math_fround(f17 + f3))));
 i4 = f3 > Math_fround(-1.0);
 i8 = i12 + -1 | 0;
 i1 = i11;
 f3 = i4 ? f3 : Math_fround(-1.0);
 i4 = i4 ? i11 : -1;
 do {
  i2 = i1 + 1 | 0;
  if ((i2 | 0) < (i12 | 0)) if ((i1 | 0) > -2) i1 = i2; else i1 = i8 - ((-2 - i1 | 0) % (i12 | 0) | 0) | 0; else i1 = (i2 | 0) % (i12 | 0) | 0;
  f17 = Math_fround(HEAPF32[i10 + (i1 << 5) >> 2]);
  f17 = Math_fround(Math_abs(Math_fround(f7 + Math_fround(Math_fround(f5 * f17) + Math_fround(f6 * Math_fround(HEAPF32[i10 + (i1 << 5) + 4 >> 2]))))));
  i2 = f17 > f3;
  f3 = i2 ? f17 : f3;
  i4 = i2 ? i1 : i4;
 } while ((i1 | 0) != (i14 | 0));
 d18 = +Math_fround(Math_abs(Math_fround(f5))) * .5;
 d19 = +Math_fround(Math_abs(Math_fround(f6))) * .5;
 if (!((i4 | 0) < 0 ? 1 : f3 <= Math_fround(d18 < d19 ? d19 : d18))) {
  __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii(i9, i13, i11, i4);
  __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii(i9, i13, i4, i14);
  STACKTOP = i16;
  return;
 }
 i1 = i13 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i13 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i13, i15);
  STACKTOP = i16;
  return;
 } else {
  HEAP32[i2 >> 2] = i14;
  HEAP32[i1 >> 2] = i2 + 4;
  STACKTOP = i16;
  return;
 }
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 4 | 0;
 i12 = i15;
 i9 = i13 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i12 | 0, i2 | 0) | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP8[i12 >> 0] = i2 >>> 24;
 HEAP8[i12 + 3 >> 0] = i2;
 HEAP8[i12 + 1 >> 0] = i2 >>> 16;
 HEAP8[i12 + 2 >> 0] = (i2 & 65535) >>> 8;
 i2 = HEAP32[i12 >> 2] | 0;
 i9 = i2 << 4;
 i6 = HEAP32[i13 + 20 >> 2] | 0;
 i10 = i6 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i7 = i6 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1;
 i11 = i3 - i4 | 0;
 i5 = i11 + i9 | 0;
 if (i5) {
  i8 = i6 + 20 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i5 >>> 0) {
   i1 = i5 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i5 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i6 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i11 | 0) | 0;
    i6 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i3 = i1 + i11 | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i8 >> 2] = i1 + i4;
   i2 = HEAP32[i12 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i3 + i9;
 i3 = i1 + i11 | 0;
 if (!i2) {
  i13 = 0;
  i12 = i3;
  i13 = i3 + (i13 << 4) | 0;
  HEAP32[i14 >> 2] = i12;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = i13;
  STACKTOP = i15;
  return;
 }
 i2 = 0;
 do {
  i1 = i3 + (i2 << 4) | 0;
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 4 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 + 8 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 4) + 12 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 4) + 13 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 4) + 14 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i3 + (i2 << 4) + 15 | 0);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 i12 = i3;
 i13 = i3 + (i1 << 4) | 0;
 HEAP32[i14 >> 2] = i12;
 i14 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = i13;
 STACKTOP = i15;
 return;
}

function __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(i15, i1, f3, i16, f17, i18, i19) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 i18 = i18 | 0;
 i19 = i19 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i20 = 0, d21 = 0.0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i20;
 if (!(i19 & 1)) d2 = 1797693134862315708145274.0e284; else d2 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 32 >> 3];
 if (i19 & 2) {
  d21 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 64 >> 3];
  d2 = d21 < d2 ? d21 : d2;
 }
 if (!(i19 & 3)) d2 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 d2 = +f3 + d2;
 if (!(i19 & 8)) i9 = -1; else i9 = (HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2] | 0) + 1 | 0;
 i10 = f17 != Math_fround(0.0) & 1;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[(__Z21GetManagerFromContexti(8) | 0) + 44 >> 2] | 0;
 i11 = __Z21GetManagerFromContexti(8) | 0;
 i12 = i11 + 28 | 0;
 i13 = i11 + 32 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if (!i1) {
  i6 = i13;
  i5 = i13;
 } else {
  while (1) if (d2 < +HEAPF64[i1 + 16 >> 3]) {
   i4 = HEAP32[i1 >> 2] | 0;
   if (!i4) {
    i4 = 12;
    break;
   } else i1 = i4;
  } else {
   i5 = i1 + 4 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if (!i4) {
    i4 = 15;
    break;
   } else i1 = i4;
  }
  if ((i4 | 0) == 12) {
   i6 = i1;
   i5 = i1;
   break;
  } else if ((i4 | 0) == 15) {
   i6 = i1;
   break;
  }
 } while (0);
 i4 = __Znwj(64) | 0;
 HEAPF64[i4 + 16 >> 3] = d2;
 HEAP32[i4 + 24 >> 2] = i9;
 HEAPF32[i4 + 28 >> 2] = f17;
 HEAP8[i4 + 32 >> 0] = i10;
 i1 = i4 + 33 | 0;
 HEAP8[i1 >> 0] = HEAP8[i14 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i14 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i14 + 2 >> 0] | 0;
 HEAP32[i4 + 36 >> 2] = i16;
 HEAP32[i4 + 40 >> 2] = i15;
 HEAP32[i4 + 44 >> 2] = i18;
 HEAP32[i4 + 48 >> 2] = i7;
 HEAP32[i4 + 52 >> 2] = i19;
 HEAP32[i4 + 56 >> 2] = i8;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i5 >> 2] = i4;
 i1 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 if (!i1) {
  i19 = i4;
  i18 = HEAP32[i13 >> 2] | 0;
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i18, i19);
  i19 = i11 + 36 | 0;
  i18 = HEAP32[i19 >> 2] | 0;
  i18 = i18 + 1 | 0;
  HEAP32[i19 >> 2] = i18;
  STACKTOP = i20;
  return;
 }
 HEAP32[i12 >> 2] = i1;
 i19 = HEAP32[i5 >> 2] | 0;
 i18 = HEAP32[i13 >> 2] | 0;
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i18, i19);
 i19 = i11 + 36 | 0;
 i18 = HEAP32[i19 >> 2] | 0;
 i18 = i18 + 1 | 0;
 HEAP32[i19 >> 2] = i18;
 STACKTOP = i20;
 return;
}

function _h2v2_fancy_upsample(i2, i3, i19, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0;
 i18 = HEAP32[i1 >> 2] | 0;
 i17 = i2 + 276 | 0;
 if ((HEAP32[i17 >> 2] | 0) <= 0) return;
 i16 = i3 + 40 | 0;
 i14 = 0;
 i15 = 0;
 do {
  i12 = i19 + (i15 << 2) | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = HEAP32[i19 + (i15 + -1 << 2) >> 2] | 0;
  i13 = i14 | 1;
  i1 = HEAP32[i18 + (i14 << 2) >> 2] | 0;
  i6 = ((HEAPU8[i7 >> 0] | 0) * 3 | 0) + (HEAPU8[i8 >> 0] | 0) | 0;
  i3 = ((HEAPU8[i7 + 1 >> 0] | 0) * 3 | 0) + (HEAPU8[i8 + 1 >> 0] | 0) | 0;
  HEAP8[i1 >> 0] = ((i6 << 2) + 8 | 0) >>> 4;
  HEAP8[i1 + 1 >> 0] = ((i6 * 3 | 0) + 7 + i3 | 0) >>> 4;
  i4 = HEAP32[i16 >> 2] | 0;
  i5 = i4 + -2 | 0;
  i2 = i1 + 2 | 0;
  if (!i5) i4 = i6; else {
   i11 = i4 << 1;
   i10 = i1 + -2 | 0;
   i9 = i6;
   i7 = i7 + 2 | 0;
   i4 = i8 + 2 | 0;
   i6 = i1;
   while (1) {
    i8 = ((HEAPU8[i7 >> 0] | 0) * 3 | 0) + (HEAPU8[i4 >> 0] | 0) | 0;
    i20 = i3 * 3 | 0;
    HEAP8[i2 >> 0] = (i9 + 8 + i20 | 0) >>> 4;
    HEAP8[i6 + 3 >> 0] = (i20 + 7 + i8 | 0) >>> 4;
    i5 = i5 + -1 | 0;
    if (!i5) break; else {
     i6 = i2;
     i9 = i3;
     i3 = i8;
     i2 = i2 + 2 | 0;
     i7 = i7 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
   }
   i4 = i3;
   i3 = i8;
   i2 = i10 + i11 | 0;
   i1 = i1 + -4 + i11 | 0;
  }
  HEAP8[i2 >> 0] = (i4 + 8 + (i3 * 3 | 0) | 0) >>> 4;
  HEAP8[i1 + 3 >> 0] = ((i3 << 2) + 7 | 0) >>> 4;
  i7 = HEAP32[i12 >> 2] | 0;
  i15 = i15 + 1 | 0;
  i10 = HEAP32[i19 + (i15 << 2) >> 2] | 0;
  i1 = HEAP32[i18 + (i13 << 2) >> 2] | 0;
  i6 = ((HEAPU8[i7 >> 0] | 0) * 3 | 0) + (HEAPU8[i10 >> 0] | 0) | 0;
  i3 = ((HEAPU8[i7 + 1 >> 0] | 0) * 3 | 0) + (HEAPU8[i10 + 1 >> 0] | 0) | 0;
  HEAP8[i1 >> 0] = ((i6 << 2) + 8 | 0) >>> 4;
  HEAP8[i1 + 1 >> 0] = ((i6 * 3 | 0) + 7 + i3 | 0) >>> 4;
  i4 = HEAP32[i16 >> 2] | 0;
  i5 = i4 + -2 | 0;
  i2 = i1 + 2 | 0;
  if (!i5) i4 = i6; else {
   i12 = i4 << 1;
   i11 = i1 + -2 | 0;
   i9 = i6;
   i4 = i3;
   i8 = i7 + 2 | 0;
   i6 = i10 + 2 | 0;
   i7 = i1;
   while (1) {
    i3 = ((HEAPU8[i8 >> 0] | 0) * 3 | 0) + (HEAPU8[i6 >> 0] | 0) | 0;
    i20 = i4 * 3 | 0;
    HEAP8[i2 >> 0] = (i9 + 8 + i20 | 0) >>> 4;
    HEAP8[i7 + 3 >> 0] = (i20 + 7 + i3 | 0) >>> 4;
    i5 = i5 + -1 | 0;
    if (!i5) break; else {
     i7 = i2;
     i9 = i4;
     i4 = i3;
     i2 = i2 + 2 | 0;
     i8 = i8 + 1 | 0;
     i6 = i6 + 1 | 0;
    }
   }
   i2 = i11 + i12 | 0;
   i1 = i1 + -4 + i12 | 0;
  }
  HEAP8[i2 >> 0] = (i4 + 8 + (i3 * 3 | 0) | 0) >>> 4;
  HEAP8[i1 + 3 >> 0] = ((i3 << 2) + 7 | 0) >>> 4;
  i14 = i14 + 2 | 0;
 } while ((i14 | 0) < (HEAP32[i17 >> 2] | 0));
 return;
}

function __ZN15b2DistanceJoint24SolveVelocityConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, i24 = 0;
 i8 = i1 + 108 | 0;
 i20 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 28 | 0;
 i24 = HEAP32[i3 >> 2] | 0;
 i11 = i24 + (i20 * 12 | 0) | 0;
 f12 = Math_fround(HEAPF32[i11 >> 2]);
 i5 = i24 + (i20 * 12 | 0) + 4 | 0;
 f19 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(HEAPF32[i24 + (i20 * 12 | 0) + 8 >> 2]);
 i2 = i1 + 112 | 0;
 i20 = HEAP32[i2 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i24 + (i20 * 12 | 0) >> 2]);
 f17 = Math_fround(HEAPF32[i24 + (i20 * 12 | 0) + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i24 + (i20 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f23 = Math_fround(f18 * f9);
 f6 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f23 = Math_fround(f12 - f23);
 f15 = Math_fround(f19 + Math_fround(f18 * f6));
 f4 = Math_fround(HEAPF32[i1 + 136 >> 2]);
 f13 = Math_fround(f16 * f4);
 f14 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 f23 = Math_fround(Math_fround(f7 - f13) - f23);
 f15 = Math_fround(Math_fround(f17 + Math_fround(f16 * f14)) - f15);
 f13 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f23 = Math_fround(f13 * f23);
 f10 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f15 = Math_fround(f23 + Math_fround(f10 * f15));
 f23 = Math_fround(HEAPF32[i1 + 172 >> 2]);
 f15 = Math_fround(Math_fround(HEAPF32[i1 + 76 >> 2]) + f15);
 f21 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 i20 = i1 + 100 | 0;
 f22 = Math_fround(HEAPF32[i20 >> 2]);
 f21 = Math_fround(f23 * Math_fround(f15 + Math_fround(f21 * f22)));
 f15 = Math_fround(-f21);
 HEAPF32[i20 >> 2] = Math_fround(f22 - f21);
 f13 = Math_fround(f13 * f15);
 f15 = Math_fround(f10 * f15);
 f10 = Math_fround(HEAPF32[i1 + 156 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f13 * f10));
 f10 = Math_fround(f19 - Math_fround(f15 * f10));
 f9 = Math_fround(f18 - Math_fround(Math_fround(HEAPF32[i1 + 164 >> 2]) * Math_fround(Math_fround(f15 * f6) - Math_fround(f13 * f9))));
 f6 = Math_fround(HEAPF32[i1 + 160 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f13 * f6));
 f6 = Math_fround(f17 + Math_fround(f15 * f6));
 f4 = Math_fround(f16 + Math_fround(Math_fround(HEAPF32[i1 + 168 >> 2]) * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f4))));
 HEAPF32[i11 >> 2] = f12;
 HEAPF32[i5 >> 2] = f10;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i5 + ((HEAP32[i8 >> 2] | 0) * 12 | 0) + 8 >> 2] = f9;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i5 + (i1 * 12 | 0) >> 2] = f7;
 HEAPF32[i5 + (i1 * 12 | 0) + 4 >> 2] = f6;
 HEAPF32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 >> 2] = f4;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8MaterialELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i7 = i12 + 8 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 HEAP32[i10 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i4, i2, i10, 1);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 946436 | 0, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 946436 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx16PxsIslandManagerC2EjRNS_19PxcScratchAllocatorEPNS_2Cm13EventProfilerE(i5, i2, i3, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = -1;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = gb + 101688 + 8;
 HEAP32[i5 + 36 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 264 >> 2] = i5 + 72;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 268 >> 2] = i5 + 120;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 272 >> 2] = i5 + 168;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 276 >> 2] = i5 + 216;
 HEAP32[i5 + 284 >> 2] = 0;
 HEAP32[i5 + 288 >> 2] = 0;
 HEAP32[i5 + 292 >> 2] = 0;
 HEAP32[i5 + 296 >> 2] = -1;
 HEAP32[i5 + 300 >> 2] = 0;
 HEAP32[i5 + 280 >> 2] = gb + 101668 + 8;
 i1 = i5 + 372 | 0;
 HEAP32[i5 + 376 >> 2] = 0;
 HEAP32[i5 + 380 >> 2] = 0;
 HEAP32[i5 + 384 >> 2] = 0;
 i2 = i5 + 388 | 0;
 i3 = i5 + 304 | 0;
 i4 = i3 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 HEAP32[i5 + 392 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 101648 + 8;
 HEAP32[i5 + 412 >> 2] = 0;
 HEAP32[i5 + 416 >> 2] = 0;
 i1 = i5 + 396 | 0;
 HEAP32[i5 + 408 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 400 >> 2] = 0;
 HEAP32[i5 + 424 >> 2] = 0;
 HEAP32[i5 + 428 >> 2] = 0;
 HEAP32[i5 + 432 >> 2] = 0;
 HEAP32[i5 + 436 >> 2] = -1;
 HEAP32[i5 + 440 >> 2] = 0;
 HEAP32[i5 + 420 >> 2] = gb + 101628 + 8;
 i1 = i5 + 604 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = i5 + 444 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP8[i5 + 477 >> 0] = 1;
 HEAP8[i5 + 478 >> 0] = 0;
 HEAP32[i5 + 644 >> 2] = 0;
 HEAP32[i5 + 656 >> 2] = 0;
 HEAP32[i5 + 704 >> 2] = i5 + 668;
 HEAP32[i5 + 648 >> 2] = 0;
 HEAP32[i5 + 660 >> 2] = 0;
 HEAP32[i5 + 708 >> 2] = i5 + 680;
 HEAP32[i5 + 652 >> 2] = 0;
 HEAP32[i5 + 664 >> 2] = 0;
 HEAP32[i5 + 712 >> 2] = i5 + 692;
 HEAP32[i5 + 716 >> 2] = 0;
 HEAP32[i5 + 720 >> 2] = 0;
 HEAP32[i5 + 724 >> 2] = 0;
 i1 = i5 + 624 | 0;
 i3 = i5 + 480 | 0;
 i4 = i3 + 124 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN21AssetReferenceStorageC2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i4 = i7 + 9 | 0;
 HEAP8[i4 >> 0] = 0;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 32;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f10 = Math_fround((HEAP32[i6 >> 2] | 0) >>> 0);
 HEAP32[i7 + 44 >> 2] = ~~Math_fround(f10 * Math_fround(.5)) >>> 0;
 HEAP32[i7 + 40 >> 2] = ~~Math_fround(f10 * Math_fround(.200000003)) >>> 0;
 HEAP8[i7 + 48 >> 0] = 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6172 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 5404 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 5404 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 5404 + (i1 * 12 | 0) >> 2] = fb + 3407;
 HEAP8[i4 >> 0] = 1;
 i3 = i7 + 20 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] << 3;
 i2 = HEAP32[i7 + 52 >> 2] | 0;
 HEAP32[i5 >> 2] = 127;
 HEAP32[i5 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i7 + 28 >> 2] = i1;
 i2 = i1 + (HEAP32[i6 >> 2] << 3) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv(i7);
  HEAP8[i8 >> 0] = 1;
  i8 = i7 + 12 | 0;
  i7 = i8;
  HEAP32[i7 >> 2] = -1;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 do {
  i4 = i3;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i1;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv(i7);
 HEAP8[i8 >> 0] = 1;
 i8 = i7 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = -1;
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb(i4, i1, i3, i6, i13, i2, i10, i11, i12, i9, i7, i5, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i15 + 488 | 0;
 i21 = i15 + 264 | 0;
 i18 = i15 + 192 | 0;
 i20 = i15 + 80 | 0;
 i17 = i15 + 16 | 0;
 i16 = i15 + 128 | 0;
 i14 = i15;
 __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i21, i4);
 __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i21, i19);
 HEAP32[i19 + 32 >> 2] = gb + 656139;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i3, i5, i18);
 HEAPF32[i20 >> 2] = Math_fround(1.0);
 i4 = i20 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i20 + 20 >> 2] = Math_fround(1.0);
 i4 = i20 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i20 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i20 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i17 + 32 >> 2] = i6;
 HEAP32[i17 + 36 >> 2] = i20;
 HEAP32[i17 + 40 >> 2] = i20;
 HEAP8[i17 + 44 >> 0] = 1;
 HEAP32[i17 >> 2] = gb + 84376 + 8;
 HEAP32[i17 + 48 >> 2] = i1;
 HEAP32[i16 + 32 >> 2] = i13;
 HEAP32[i16 + 36 >> 2] = i3 + 96;
 HEAP32[i16 + 40 >> 2] = i3 + 144;
 HEAP8[i16 + 44 >> 0] = i5 & 1;
 HEAP32[i16 >> 2] = i5 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i16 + 48 >> 2] = i3;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!(__ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb(i19, i18, i17, i16, i2, i10, i7, i9, i8) | 0)) {
  i21 = 0;
  STACKTOP = i15;
  return i21 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 | 0) != (i3 | 0)) {
  i1 = i1 + -1 | 0;
  HEAP32[i10 >> 2] = i1;
  i2 = i2 + 48 | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj(i12, i2, i1);
 __ZN5physx2Gu25PersistentContactManifold14getWorldNormalERKNS_6shdfnd3aos12PsTransformVE(i14, i12, i13);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i12, i11, i14, i13);
 i21 = 1;
 STACKTOP = i15;
 return i21 | 0;
}

function __ZN13GfxDeviceGLES23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i6 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i8 + 4616 >> 2] | 0) | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i3, i1, i4);
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  __ZN18GfxFramebufferGLES7PrepareEv(i6);
  __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES(i6, i5);
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  __ZN18GfxFramebufferGLES7PrepareEv(i6);
  __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES(i6, i5);
  STACKTOP = i7;
  return;
 }
 i4 = i1 + 8 | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i8 + 7336 | 0;
 i3 = i1;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 if (!(i9 >>> 0 < i2 >>> 0 | ((i9 | 0) == (i2 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0 : 0))) {
  __ZN18GfxFramebufferGLES7PrepareEv(i6);
  __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES(i6, i5);
  STACKTOP = i7;
  return;
 }
 i9 = HEAP32[i8 + 4860 >> 2] | 0;
 i4 = i8 + 5480 | 0;
 mftCall_vi(i9 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i4 >> 2] | 0, 9) | 0);
 i9 = i8 + 7368 | 0;
 i3 = i9;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i11 = _i64Add(i2 | 0, i3 | 0, 1, 0) | 0;
 i10 = getTempRet0() | 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = i1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i3;
 i4 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i4 >> 2] | 0, 9) | 0);
 i9 = i8 + 7376 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & i4;
 __ZN18GfxFramebufferGLES7PrepareEv(i6);
 __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES(i6, i5);
 STACKTOP = i7;
 return;
}

function _cff_subfont_load(i10, i3, i1, i9, i8, i6) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i5 = i11 + 4 | 0;
 i2 = i11;
 HEAP32[i5 >> 2] = 0;
 _cff_parser_init(i7, 4096, i10, i6);
 _memset(i10 + 4 + 20 | 0, 0, 152) | 0;
 HEAP32[i10 + 32 >> 2] = -6553600;
 HEAP32[i10 + 36 >> 2] = 3276800;
 HEAP32[i10 + 44 >> 2] = 2;
 HEAP32[i10 + 48 >> 2] = 65536;
 HEAP32[i10 + 60 >> 2] = 65536;
 HEAP32[i10 + 156 >> 2] = 8720;
 HEAP32[i10 >> 2] = 65535;
 HEAP32[i10 + 4 >> 2] = 65535;
 HEAP32[i10 + 8 >> 2] = 65535;
 HEAP32[i10 + 12 >> 2] = 65535;
 HEAP32[i10 + 16 >> 2] = 65535;
 HEAP32[i10 + 20 >> 2] = 65535;
 HEAP32[i10 + 128 >> 2] = 65535;
 i4 = i10 + 132 | 0;
 HEAP32[i4 >> 2] = 65535;
 HEAP32[i10 + 136 >> 2] = 65535;
 HEAP32[i10 + 172 >> 2] = 65535;
 i1 = _cff_index_access_element(i3, i1, i5, i2) | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = _cff_parser_run(i7, i1, i1 + (HEAP32[i2 >> 2] | 0) | 0) | 0;
 }
 if (!(HEAP32[i3 + 28 >> 2] | 0)) _UNITY_FT_Stream_ReleaseFrame(HEAP32[i3 >> 2] | 0, i5);
 if (i1 | 0) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((HEAP32[i4 >> 2] | 0) != 65535) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i4 = i10 + 116 | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i2 = i10 + 120 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i3 = i10 + 176 | 0;
   _memset(i3 | 0, 0, 360) | 0;
   HEAP32[i10 + 376 >> 2] = 7;
   HEAP32[i10 + 380 >> 2] = 1;
   HEAP32[i10 + 508 >> 2] = -1;
   HEAP32[i10 + 516 >> 2] = 3932;
   HEAP32[i10 + 372 >> 2] = 2596864;
   _cff_parser_init(i7, 8192, i3, i6);
   i1 = _UNITY_FT_Stream_Seek(i9, (HEAP32[i4 >> 2] | 0) + i8 | 0) | 0;
   if (i1 | 0) {
    i10 = i1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i1 = _UNITY_FT_Stream_EnterFrame(i9, HEAP32[i2 >> 2] | 0) | 0;
   if (i1 | 0) {
    i10 = i1;
    STACKTOP = i11;
    return i10 | 0;
   }
   i1 = _cff_parser_run(i7, HEAP32[i9 + 32 >> 2] | 0, HEAP32[i9 + 36 >> 2] | 0) | 0;
   _UNITY_FT_Stream_ExitFrame(i9);
   if (!i1) {
    HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 254;
    break;
   } else {
    i10 = i1;
    STACKTOP = i11;
    return i10 | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i10 + 524 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = _UNITY_FT_Stream_Seek(i9, i1 + i8 + (HEAP32[i4 >> 2] | 0) | 0) | 0;
 if (i1 | 0) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = i10 + 536 | 0;
 i1 = _cff_index_init(i2, i9, 1) | 0;
 if (i1 | 0) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = _cff_index_get_pointers(i2, i10 + 568 | 0, 0) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNK14dtNavMeshQuery26closestPointOnPolyBoundaryEyPKfPf(i1, i2, i3, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f4 = f0, i5 = 0, i6 = 0, f7 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 983040 | 0) == 65536 & 0 == 0) {
  i6 = i2 & 65535;
  if (i6 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i9 = -2147483640;
   return i9 | 0;
  }
  i5 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i1 + (i6 * 104 | 0) | 0) == 0 ? 1 : (i5 | 0) != (HEAP32[i1 + (i6 * 104 | 0) + 92 >> 2] | 0)) {
   i9 = -2147483640;
   return i9 | 0;
  }
  f12 = Math_fround(HEAPF32[i8 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + (i6 * 104 | 0) + 12 >> 2]);
  f14 = Math_fround(f12 - f7);
  f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  i5 = i1 + (i6 * 104 | 0) + 16 | 0;
  f4 = Math_fround(f11 - Math_fround(HEAPF32[i5 >> 2]));
  f10 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  i2 = i1 + (i6 * 104 | 0) + 20 | 0;
  f13 = Math_fround(f10 - Math_fround(HEAPF32[i2 >> 2]));
  f13 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f4 * f4)) + Math_fround(f13 * f13));
  f4 = Math_fround(HEAPF32[i1 + (i6 * 104 | 0) + 44 >> 2]);
  f12 = Math_fround(f12 - f4);
  i3 = i1 + (i6 * 104 | 0) + 48 | 0;
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i3 >> 2]));
  i1 = i1 + (i6 * 104 | 0) + 52 | 0;
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i1 >> 2]));
  if (f13 < Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(f10 * f10))) {
   HEAPF32[i9 >> 2] = f7;
   HEAP32[i9 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i2 >> 2];
   i9 = 1073741824;
   return i9 | 0;
  } else {
   HEAPF32[i9 >> 2] = f4;
   HEAP32[i9 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i1 >> 2];
   i9 = 1073741824;
   return i9 | 0;
  }
 }
 if ((i2 | 0) == 0 & (i3 | 0) == 0) {
  i9 = -2147483640;
  return i9 | 0;
 }
 i5 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i2 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i9 = -2147483640;
  return i9 | 0;
 }
 i3 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i3 | 0)) {
  i9 = -2147483640;
  return i9 | 0;
 }
 i2 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i9 = -2147483640;
  return i9 | 0;
 }
 if (i6 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i9 = -2147483640;
  return i9 | 0;
 }
 __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf(i8, (HEAP32[i1 + (i5 * 56 | 0) + 16 >> 2] | 0) + (i6 << 5) | 0, i1 + (i5 * 56 | 0) | 0, i9);
 i9 = 1073741824;
 return i9 | 0;
}

function __ZN5physx17ConvexMeshBuilder19computeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_RNS_19PxAllocatorCallbackERjRPS3_S9_RPjS9_RPNS_13PxHullPolygonE(i13, i3, i7, i2, i6, i9, i4, i5, i10, i8, i11, i12) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 132 | 0;
 if (!(__ZN5physx17ConvexHullBuilder19ComputeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_(i1, i3, i7, i2, i6) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 726597 | 0, 270, gb + 726690 | 0, i14);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i7 = HEAP32[i13 + 152 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAPU8[i7 + 38 >> 0];
 HEAP32[i11 >> 2] = HEAPU8[i7 + 39 >> 0];
 i7 = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0, gb + 829437 | 0, gb + 726597 | 0, 277) | 0;
 HEAP32[i5 >> 2] = i7;
 _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
 HEAP32[i10 >> 2] = 0;
 if (!(HEAP32[i11 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i13 + 136 >> 2] | 0;
  i1 = 0;
  i3 = 0;
  do {
   i1 = i1 + (HEAPU8[i2 + (i3 * 20 | 0) + 18 >> 0] | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
  i1 = i1 << 2;
 }
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i1 | 0, gb + 827882 | 0, gb + 726597 | 0, 286) | 0;
 HEAP32[i8 >> 2] = i3;
 if (HEAP32[i10 >> 2] | 0) {
  i1 = HEAP32[i13 + 140 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i3 + (i2 << 2) >> 2] = HEAPU8[i1 + i2 >> 0];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, (HEAP32[i11 >> 2] | 0) * 20 | 0, gb + 726811 | 0, gb + 726597 | 0, 292) | 0;
 HEAP32[i12 >> 2] = i4;
 i3 = HEAP32[i11 >> 2] | 0;
 if (!i3) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = HEAP32[i13 + 136 >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i4 + (i2 * 20 | 0) >> 2] = HEAP32[i1 + (i2 * 20 | 0) >> 2];
  HEAP32[i4 + (i2 * 20 | 0) + 4 >> 2] = HEAP32[i1 + (i2 * 20 | 0) + 4 >> 2];
  HEAP32[i4 + (i2 * 20 | 0) + 8 >> 2] = HEAP32[i1 + (i2 * 20 | 0) + 8 >> 2];
  HEAP32[i4 + (i2 * 20 | 0) + 12 >> 2] = HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2];
  HEAP16[i4 + (i2 * 20 | 0) + 16 >> 1] = HEAPU8[i1 + (i2 * 20 | 0) + 18 >> 0] | 0;
  HEAP16[i4 + (i2 * 20 | 0) + 18 >> 1] = HEAP16[i1 + (i2 * 20 | 0) + 16 >> 1] | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 i1 = 1;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx11Adjacencies11MakeLastRefERNS_11AdjTriangleEjPNS_2Gu9TriangleTIjEE(i9, i7, i8, i6) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 727718 | 0, 245, gb + 773509 | 0, i10);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  i2 = HEAP32[i7 >> 2] | 0;
  i12 = i6 + 4 | 0;
  i5 = i7 + 4 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i11 = i6 + 8 | 0;
  i13 = HEAP32[i11 >> 2] | 0;
  i1 = i7 + 8 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i13;
  HEAP32[i11 >> 2] = i8;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2 & 536870911;
  if ((i1 | 0) != 536870911) {
   i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i2 >>> 30 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911 | 1073741824;
  }
  i1 = i3 & 536870911;
  if ((i1 | 0) != 536870911) {
   i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i3 >>> 30 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911 | -2147483648;
  }
  i1 = i4 & 536870911;
  if ((i1 | 0) == 536870911) {
   i13 = 1;
   STACKTOP = i10;
   return i13 | 0;
  }
  i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i4 >>> 30 << 2) | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911;
  i13 = 1;
  STACKTOP = i10;
  return i13 | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i8 | 0)) {
  i13 = (HEAP32[i6 + 8 >> 2] | 0) == (i8 | 0);
  STACKTOP = i10;
  return i13 | 0;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i11 = i6 + 8 | 0;
 i13 = i7 + 8 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i13 >> 2] = i3;
 i1 = i3 & 536870911;
 if ((i1 | 0) != 536870911) {
  i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i3 >>> 30 << 2) | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911 | -2147483648;
 }
 i1 = i4 & 536870911;
 if ((i1 | 0) != 536870911) {
  i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i4 >>> 30 << 2) | 0;
  HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911;
 }
 i1 = i5 & 536870911;
 if ((i1 | 0) == 536870911) {
  i13 = 1;
  STACKTOP = i10;
  return i13 | 0;
 }
 i13 = (HEAP32[i9 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i5 >>> 30 << 2) | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & 536870911 | 1073741824;
 i13 = 1;
 STACKTOP = i10;
 return i13 | 0;
}

function __Z10DecodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i12 = i18 + 8 | 0;
 i13 = i18 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i14 = i8 + 11 | 0;
 i1 = HEAP8[i14 >> 0] | 0;
 i15 = i8 + 4 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if (!((i1 << 24 >> 24 < 0 ? i3 : i1 & 255) | 0)) {
  STACKTOP = i18;
  return;
 }
 i9 = i12 + 11 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12 + 11 | 0;
 i2 = 0;
 while (1) {
  i4 = i1 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
  i4 = i4 ? i3 : i1 & 255;
  if (i4 >>> 0 <= i2 >>> 0) break;
  i1 = i6 + i2 | 0;
  i5 = i6 + i4 | 0;
  i3 = i5;
  L7 : do if (!((i4 | 0) == (i2 | 0) | (i3 - i1 | 0) < 1)) {
   while (1) {
    if ((HEAP8[i1 >> 0] | 0) == 95) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break L7;
   }
   i3 = i1;
  } while (0);
  i1 = i3 - i6 | 0;
  if ((i3 | 0) == (i5 | 0) | (i1 | 0) == -1) break;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i12, i8, i2, i1 - i2 | 0, i8);
   i6 = HEAP8[i9 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i5 ? HEAP32[i12 >> 2] | 0 : i12, i5 ? HEAP32[i10 >> 2] | 0 : i6 & 255) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i12, i8, i1, 3, i8);
  HEAP32[i13 >> 2] = 32;
  i2 = (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  HEAP32[i16 >> 2] = i13;
  _sscanf(i2, gb + 488900 | 0, i16) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, HEAP32[i13 >> 2] & 255);
  i2 = i1 + 3 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i1 = HEAP8[i14 >> 0] | 0;
  i3 = HEAP32[i15 >> 2] | 0;
  if (i2 >>> 0 >= (i1 << 24 >> 24 < 0 ? i3 : i1 & 255) >>> 0) {
   i17 = 13;
   break;
  }
 }
 if ((i17 | 0) == 13) {
  STACKTOP = i18;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i12, i8, i2, -1, i8);
 i17 = HEAP8[i12 + 11 >> 0] | 0;
 i16 = i17 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i16 ? HEAP32[i12 >> 2] | 0 : i12, i16 ? HEAP32[i12 + 4 >> 2] | 0 : i17 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i18;
 return;
}

function __ZNK5physx15PxsArticulation15computeMomentumEPKNS_12PxcFsInertiaE(i23, i17, i16) {
 i23 = i23 | 0;
 i17 = i17 | 0;
 i16 = i16 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, i32 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i24;
 i6 = HEAP32[i17 >> 2] | 0;
 i12 = (HEAP32[i6 >> 2] | 0) + 128 | 0;
 HEAP32[i23 >> 2] = 0;
 HEAP32[i23 + 4 >> 2] = 0;
 HEAP32[i23 + 8 >> 2] = 0;
 HEAP32[i23 + 12 >> 2] = 0;
 HEAP32[i23 + 16 >> 2] = 0;
 HEAP32[i23 + 20 >> 2] = 0;
 HEAP32[i23 + 24 >> 2] = 0;
 HEAP32[i23 + 28 >> 2] = 0;
 if (!(HEAP16[i6 + 36 >> 1] | 0)) {
  STACKTOP = i24;
  return;
 }
 i13 = i9 + 8 | 0;
 i14 = i9 + 4 | 0;
 i15 = i9 + 16 | 0;
 i10 = i9 + 20 | 0;
 i11 = i9 + 24 | 0;
 i18 = i23 + 4 | 0;
 i19 = i23 + 8 | 0;
 i20 = i23 + 16 | 0;
 i21 = i23 + 20 | 0;
 i22 = i23 + 24 | 0;
 f7 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f2 = Math_fround(0.0);
 f1 = Math_fround(0.0);
 i8 = 0;
 do {
  i32 = HEAP32[i6 + 12 >> 2] | 0;
  f31 = Math_fround(HEAPF32[i32 + (i8 * 28 | 0) + 16 >> 2]);
  f31 = Math_fround(f31 - Math_fround(HEAPF32[i32 + 16 >> 2]));
  f25 = Math_fround(HEAPF32[i32 + (i8 * 28 | 0) + 20 >> 2]);
  f25 = Math_fround(f25 - Math_fround(HEAPF32[i32 + 20 >> 2]));
  f26 = Math_fround(HEAPF32[i32 + (i8 * 28 | 0) + 24 >> 2]);
  f26 = Math_fround(f26 - Math_fround(HEAPF32[i32 + 24 >> 2]));
  __ZN5physx24PxcArticulationFnsScalar8multiplyERKNS_12PxcFsInertiaERKNS_2Cm13SpatialVectorE(i9, i16 + (i8 * 144 | 0) | 0, i12 + (i8 << 5) | 0);
  f28 = Math_fround(HEAPF32[i13 >> 2]);
  f27 = Math_fround(f25 * f28);
  f29 = Math_fround(HEAPF32[i14 >> 2]);
  f27 = Math_fround(f27 - Math_fround(f26 * f29));
  f30 = Math_fround(HEAPF32[i9 >> 2]);
  f26 = Math_fround(Math_fround(f26 * f30) - Math_fround(f31 * f28));
  f25 = Math_fround(Math_fround(f31 * f29) - Math_fround(f25 * f30));
  f27 = Math_fround(f27 + Math_fround(HEAPF32[i15 >> 2]));
  f26 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f26);
  f7 = Math_fround(f30 + f7);
  f5 = Math_fround(f29 + f5);
  f4 = Math_fround(f28 + f4);
  f3 = Math_fround(f27 + f3);
  f2 = Math_fround(f26 + f2);
  f1 = Math_fround(Math_fround(f25 + Math_fround(HEAPF32[i11 >> 2])) + f1);
  i8 = i8 + 1 | 0;
  i6 = HEAP32[i17 >> 2] | 0;
 } while (i8 >>> 0 < (HEAPU16[i6 + 36 >> 1] | 0) >>> 0);
 HEAPF32[i23 >> 2] = f7;
 HEAPF32[i18 >> 2] = f5;
 HEAPF32[i19 >> 2] = f4;
 HEAPF32[i20 >> 2] = f3;
 HEAPF32[i21 >> 2] = f2;
 HEAPF32[i22 >> 2] = f1;
 STACKTOP = i24;
 return;
}

function __ZN9Heightmap16CheckConsistencyEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i6 = i9 + 80 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = (16 << i4) + 1 | 0;
 i10 = i9 + 76 | 0;
 HEAP32[i10 >> 2] = i1;
 i11 = i9 + 72 | 0;
 HEAP32[i11 >> 2] = i1;
 i7 = i9 + 4 | 0;
 i8 = i9 + 16 | 0;
 if ((HEAP32[i8 >> 2] | 0) != (Math_imul(i1, i1) | 0)) {
  i2 = i9 + 20 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9 + 8 | 0);
   HEAP32[i7 >> 2] = 0;
   i3 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
  } else i3 = i1;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i4 = Math_imul(i3, i1) | 0;
  HEAP16[i5 >> 1] = 0;
  __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy(i7, i4, i5, 1);
  i4 = HEAP32[i6 >> 2] | 0;
 }
 if ((i4 | 0) > 0) {
  i1 = 1 << i4;
  i2 = 0;
  i3 = 0;
  while (1) {
   i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) break; else i1 = i1 >> 1;
  }
  i6 = i2 + 1 | 0;
 } else i6 = 1;
 i1 = i9 + 24 | 0;
 i2 = i9 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i9 + 56 >> 2] | 0) == (i6 << 1 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i2 >> 2] = i6;
 i3 = i9 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 << 2, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = i8;
  break;
 } while (0);
 i1 = i9 + 44 | 0;
 i2 = i6 << 1;
 i3 = i9 + 56 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i9 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 << 3, 4, i9 + 48 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 4, i9 + 48 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i8;
  break;
 } while (0);
 __ZN9Heightmap15PrecomputeErrorEiiiib(i9, 0, 0, HEAP32[i11 >> 2] | 0, HEAP32[i10 >> 2] | 0, 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj669ES2_RKNS_27PxVehicleDifferential4WDataES6_EEKNS_40PxVehicleDifferential4WDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 32 | 0;
 i7 = i8 + 88 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i3 + 608 | 0;
 i14 = i3 + 580 | 0;
 i13 = i3 + 552 | 0;
 i10 = i3 + 44 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx27PxRigidDynamicGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i12;
 HEAP32[i15 + 4 >> 2] = i11;
 HEAP32[i15 + 8 >> 2] = i5;
 HEAP32[i15 + 12 >> 2] = i6;
 HEAP32[i15 + 16 >> 2] = i7;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i4 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i10, i15, 0) | 0;
 HEAP32[i14 >> 2] = i12;
 HEAP32[i14 + 4 >> 2] = i11;
 HEAP32[i14 + 8 >> 2] = i5;
 HEAP32[i14 + 12 >> 2] = i6;
 HEAP32[i14 + 16 >> 2] = i7;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i14, i10 + 120 | 0, i4);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclERKNS_27PxRigidActorShapeCollectionEj(i14, i10 + 136 | 0, i4 + 1 | 0);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i10, i13, i4 + 3 | 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx27PxRigidDynamicGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i15 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __Z26RecalculateSplineSlopeLoopI8Vector3fEvR17AnimationCurveTplIT_Eif(i14, i15, f16) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 f16 = Math_fround(f16);
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i17 = 0;
 i1 = HEAP32[i14 + 132 >> 2] | 0;
 if ((i1 | 0) < 2) return;
 i17 = i15 + 1 | 0;
 i12 = (i15 | 0) == 0;
 i17 = i12 ? i17 : (i17 | 0) == (i1 | 0) ? 1 : i17;
 i1 = i12 ? i1 + -2 | 0 : i15 + -1 | 0;
 i12 = i14 + 120 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i13 + (i15 * 40 | 0) >> 2]);
 f4 = Math_fround(f10 - Math_fround(HEAPF32[i13 + (i1 * 40 | 0) >> 2]));
 f5 = Math_fround(HEAPF32[i13 + (i15 * 40 | 0) + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i13 + (i15 * 40 | 0) + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i13 + (i15 * 40 | 0) + 12 >> 2]);
 f10 = Math_fround(Math_fround(HEAPF32[i13 + (i17 * 40 | 0) >> 2]) - f10);
 f11 = Math_fround(Math_fround(HEAPF32[i13 + (i17 * 40 | 0) + 4 >> 2]) - f5);
 f9 = Math_fround(Math_fround(HEAPF32[i13 + (i17 * 40 | 0) + 8 >> 2]) - f2);
 f6 = Math_fround(Math_fround(HEAPF32[i13 + (i17 * 40 | 0) + 12 >> 2]) - f3);
 i17 = f4 < Math_fround(0.0);
 f8 = Math_fround(-f4);
 if ((i17 ? f8 : f4) > Math_fround(9.99999974e-06)) {
  f7 = Math_fround(f3 - Math_fround(HEAPF32[i13 + (i1 * 40 | 0) + 12 >> 2]));
  f8 = Math_fround(f2 - Math_fround(HEAPF32[i13 + (i1 * 40 | 0) + 8 >> 2]));
  f7 = Math_fround(f7 / f4);
  f8 = Math_fround(f8 / f4);
  f5 = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i13 + (i1 * 40 | 0) + 4 >> 2])) / f4);
 } else {
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f5 = Math_fround(0.0);
 }
 i17 = f10 < Math_fround(0.0);
 f4 = Math_fround(-f10);
 if ((i17 ? f4 : f10) > Math_fround(9.99999974e-06)) {
  f4 = Math_fround(f6 / f10);
  f3 = Math_fround(f9 / f10);
  f2 = Math_fround(f11 / f10);
 } else {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f9 = Math_fround(Math_fround(f16 + Math_fround(1.0)) * Math_fround(.5));
 f16 = Math_fround(Math_fround(Math_fround(1.0) - f16) * Math_fround(.5));
 f10 = Math_fround(Math_fround(f9 * f5) + Math_fround(f16 * f2));
 f11 = Math_fround(Math_fround(f9 * f8) + Math_fround(f16 * f3));
 f16 = Math_fround(Math_fround(f9 * f7) + Math_fround(f16 * f4));
 HEAPF32[i13 + (i15 * 40 | 0) + 16 >> 2] = f10;
 HEAPF32[i13 + (i15 * 40 | 0) + 20 >> 2] = f11;
 HEAPF32[i13 + (i15 * 40 | 0) + 24 >> 2] = f16;
 i17 = HEAP32[i12 >> 2] | 0;
 HEAPF32[i17 + (i15 * 40 | 0) + 28 >> 2] = f10;
 HEAPF32[i17 + (i15 * 40 | 0) + 32 >> 2] = f11;
 HEAPF32[i17 + (i15 * 40 | 0) + 36 >> 2] = f16;
 HEAPF32[i14 + 4 >> 2] = Math_fround(inf);
 HEAP32[i14 >> 2] = 0;
 HEAPF32[i14 + 64 >> 2] = Math_fround(inf);
 HEAP32[i14 + 60 >> 2] = 0;
 return;
}

function __ZNK5physx2Sc15ClothFabricCore9getPhasesEPNS_18PxClothFabricPhaseEj(i16, i19, i1) {
 i16 = i16 | 0;
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i20 + 104 | 0;
 i8 = i20 + 96 | 0;
 i7 = i20 + 88 | 0;
 i6 = i20 + 80 | 0;
 i5 = i20 + 72 | 0;
 i4 = i20 + 64 | 0;
 i3 = i20 + 52 | 0;
 i2 = i20 + 48 | 0;
 i10 = i20 + 40 | 0;
 i11 = i20 + 32 | 0;
 i12 = i20 + 24 | 0;
 i13 = i20 + 16 | 0;
 i14 = i20 + 8 | 0;
 i15 = i20;
 i18 = HEAP32[i16 >> 2] | 0;
 i18 = mftCall_ii(HEAP32[(HEAP32[i18 >> 2] | 0) + 12 >> 2] | 0, i18 | 0) | 0;
 if (i18 >>> 0 > i1 >>> 0) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i22 = i3 + 4 | 0;
 HEAP32[i22 >> 2] = 0;
 i17 = i3 + 8 | 0;
 HEAP32[i17 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i3, i18, i2);
 i1 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i21 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i22 = i3 + (HEAP32[i22 >> 2] << 2) | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 4 >> 2] = i22;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 mftCall_viiiiiiii(i21 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
 if (i18 | 0) {
  i1 = HEAP32[i16 + 8 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i19 + (i2 << 3) + 4 >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
   HEAP32[i19 + (i2 << 3) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i18 | 0));
 }
 i22 = HEAP32[i17 >> 2] | 0;
 if ((i22 & 2147483647 | 0) == 0 | (i22 | 0) < 0 | (i3 | 0) == 0) {
  i22 = i18;
  STACKTOP = i20;
  return i22 | 0;
 }
 i22 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 12 >> 2] | 0, i22 | 0, i3 | 0);
 i22 = i18;
 STACKTOP = i20;
 return i22 | 0;
}

function __ZN8GUIStyle8TransferI9JSONWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1034561 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 1034568 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 1034591 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1034599 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 76 | 0, gb + 1034608 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 96 | 0, gb + 1034618 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 116 | 0, gb + 1034629 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 136 | 0, gb + 1034639 | 0, 0);
 __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i2, i1 + 156 | 0, gb + 1034650 | 0, 0);
 __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i2, i1 + 176 | 0, gb + 1034662 | 0, 0);
 __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i2, i1 + 192 | 0, gb + 1034671 | 0, 0);
 __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i2, i1 + 208 | 0, gb + 1034680 | 0, 0);
 __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i2, i1 + 224 | 0, gb + 1034690 | 0, 0);
 __ZN9JSONWrite8TransferI4PPtrIN13TextRendering4FontEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 240 | 0, gb + 1034701 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 284 | 0, gb + 1034730 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 288 | 0, gb + 1034741 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 244 | 0, gb + 1034753 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 248 | 0, gb + 1034765 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 249 | 0, gb + 1034776 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 252 | 0, gb + 1034787 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 256 | 0, gb + 1034802 | 0, 0);
 __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags(i2, i1 + 260 | 0, gb + 1034818 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 276 | 0, gb + 1034834 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 280 | 0, gb + 1034847 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 292 | 0, gb + 1034861 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 293 | 0, gb + 1034876 | 0, 0);
 return;
}

function __ZN5physx14PxCloneDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_14PxRigidDynamicE(i1, i2, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 72 | 0;
 i4 = i11 + 60 | 0;
 i5 = i11 + 32 | 0;
 i6 = i11 + 20 | 0;
 i7 = i11 + 8 | 0;
 i9 = i11 + 4 | 0;
 i10 = i11;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN5physx12_GLOBAL__N_120copyStaticPropertiesERNS_12PxRigidActorERKS1_(i1, i8);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0;
 HEAP8[i3 >> 0] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 204 >> 2] | 0, i8 | 0) | 0;
 mftCall_vii(i2 | 0, i1 | 0, i3 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0;
 mftCall_vif(i3 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 132 >> 2] | 0, i8 | 0)));
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, i8 | 0);
 mftCall_vii(i3 | 0, i1 | 0, i4 | 0);
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i5 | 0, i8 | 0);
 mftCall_vii(i4 | 0, i1 | 0, i5 | 0);
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 152 >> 2] | 0, i6 | 0, i8 | 0);
 mftCall_viii(i5 | 0, i1 | 0, i6 | 0, 1);
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 160 >> 2] | 0, i7 | 0, i8 | 0);
 mftCall_viii(i6 | 0, i1 | 0, i7 | 0, 1);
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0;
 mftCall_vif(i7 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 244 >> 2] | 0, i8 | 0)));
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0;
 mftCall_vif(i7 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 244 >> 2] | 0, i8 | 0)));
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0;
 mftCall_vif(i7 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 252 >> 2] | 0, i8 | 0)));
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 296 >> 2] | 0, i8 | 0, i9 | 0, i10 | 0);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 292 >> 2] | 0, i1 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0;
 mftCall_vif(i10 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 264 >> 2] | 0, i8 | 0)));
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 304 >> 2] | 0;
 mftCall_vif(i10 | 0, i1 | 0, +Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 300 >> 2] | 0, i8 | 0)));
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5Unity10HingeJoint11SetUseMotorEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 56 | 0;
 i8 = i10 + 28 | 0;
 i9 = i10;
 i2 = i6 + 157 | 0;
 HEAP8[i2 >> 0] = i1 & 1;
 if (i1) i1 = 0; else i1 = HEAP8[i6 + 158 >> 0] | 0;
 i3 = i6 + 159 | 0;
 HEAP8[i3 >> 0] = i1;
 i5 = i6 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP8[i2 >> 0] | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if (i4 << 24 >> 24 != i3 << 24 >> 24) if ((i2 << 16 >> 16 == 261 | 0) != (i3 & 255 | 0)) {
  if (!i1) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 1065353216;
   HEAP32[i8 + 16 >> 2] = 0;
   HEAP32[i8 + 20 >> 2] = 0;
   HEAP32[i8 + 24 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 1065353216;
   HEAP32[i9 + 16 >> 2] = 0;
   HEAP32[i9 + 20 >> 2] = 0;
   HEAP32[i9 + 24 >> 2] = 0;
  } else {
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, i1 | 0, 0);
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   i5 = HEAP32[i5 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, i5 | 0, 1);
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i9 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i9 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
  }
  __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv(i6);
  __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_(i6, i8, i9);
  STACKTOP = i10;
  return;
 }
 if (i2 << 16 >> 16 == 261) {
  STACKTOP = i10;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, 2, i4 << 24 >> 24 != 0 | 0);
 i9 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i7 | 0, i8 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i8 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib(i9, i4, i2, d10, i11, i1) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 d10 = +d10;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13;
 i12 = i9 + 56 | 0;
 i7 = HEAP16[i12 >> 1] & -385;
 i8 = i9 + 96 | 0;
 HEAP32[i8 >> 2] = i2;
 i1 = i7 | (i1 & 1) << 8 & 65535;
 HEAP16[i12 >> 1] = i1;
 if (i2) {
  __ZN13AnimationClip8GetRangeEv(i3, i2);
  HEAP32[i9 + 88 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 92 >> 2] = HEAP32[i3 + 4 >> 2];
  i2 = i9 + 100 | 0;
  i3 = (HEAP32[i8 >> 2] | 0) + 80 | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = i9 + 104 | 0; else {
    i7 = i9 + 104 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i7 >> 2];
    HEAP32[HEAP32[i7 >> 2] >> 2] = i1;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    i1 = i7;
   }
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  }
  i1 = i9 + 112 | 0;
  do if ((i1 | 0) != (i4 | 0)) {
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   i7 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
   i6 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i9 + 120 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i6 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i9 + 116 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
    break;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i9 + 116 >> 2] = i6;
    break;
   } else {
    HEAP8[i4 >> 0] = i6;
    break;
   }
  } while (0);
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = (((HEAP32[i1 + 196 >> 2] | 0) == (HEAP32[i1 + 200 >> 2] | 0) & 1) << 7 & 65535 | HEAP16[i12 >> 1] & -129) ^ 128;
  HEAP16[i12 >> 1] = i1;
 }
 HEAP32[i9 + 72 >> 2] = 0;
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i9 + 60 >> 2] = -1;
 HEAPF64[i9 + 16 >> 3] = 0.0;
 HEAPF64[i9 + 24 >> 3] = d10;
 HEAP32[i9 + 32 >> 2] = 0;
 HEAPF32[i9 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 40 >> 2] = Math_fround(1.0);
 HEAP16[i12 >> 1] = i1 & -1648 | 512;
 __ZN14AnimationState11SetWrapModeEi(i9, i11);
 __ZN14AnimationState7SetTimeEf(i9, Math_fround(0.0));
 HEAP32[i9 + 64 >> 2] = 3;
 STACKTOP = i13;
 return;
}

function __Z25CreateUniqueTempDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i5, i9) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18 + 8 | 0;
 i16 = i18;
 i10 = i18 + 1096 | 0;
 i11 = i18 + 1084 | 0;
 i12 = i18 + 24 | 0;
 i13 = i18 + 12 | 0;
 L1 : do if (i9) {
  i14 = i11 + 11 | 0;
  i15 = i11 + 4 | 0;
  i6 = i1 + 11 | 0;
  i7 = i13 + 11 | 0;
  i8 = i13 + 11 | 0;
  i4 = 0;
  L4 : while (1) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   __ZN9UnityGUID4InitEv(i10);
   __Z12GUIDToStringRK9UnityGUID(i11, i10);
   i3 = HEAP8[i14 >> 0] | 0;
   i2 = i3 << 24 >> 24 < 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i2 ? HEAP32[i11 >> 2] | 0 : i11, i2 ? HEAP32[i15 >> 2] | 0 : i3 & 255) | 0;
   if ((HEAP8[i6 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
   __ZN15FileSystemEntryC2EPKc(i12, i2);
   if (__ZNK15FileSystemEntry6ExistsEv(i12) | 0) {
    if ((HEAP8[i6 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    HEAP32[i16 >> 2] = i2;
    __Z6FormatPKcz(i13, gb + 488267 | 0, i16);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 488305 | 0, 325, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    i2 = 0;
    i3 = 4;
   } else if (__ZN15FileSystemEntry11CreateAsDirEv(i12) | 0) {
    i2 = 1;
    i3 = 1;
   } else {
    if ((HEAP8[i6 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    HEAP32[i17 >> 2] = i2;
    __Z6FormatPKcz(i13, gb + 488381 | 0, i17);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 488305 | 0, 332, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
    i2 = 0;
    i3 = 0;
   }
   __ZN13FileEntryDataD2Ev(i12);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
   if (!i2) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   switch (i3 & 7) {
   case 4:
   case 0:
    break;
   default:
    break L4;
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= i9 >>> 0) break L1;
  }
  STACKTOP = i18;
  return;
 } while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN19AutoOffMeshLinkData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i5 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i3, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 28 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 2);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 30 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 31 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  return;
 }
}

function _jinit_c_prep_controller(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 if (!(i1 << 24 >> 24)) i16 = i7; else {
  i16 = HEAP32[i7 >> 2] | 0;
  HEAP32[i16 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i16 >> 2] | 0, i7 | 0);
  i16 = i7;
 }
 i17 = i7 + 4 | 0;
 i15 = mftCall_iiii(HEAP32[HEAP32[i17 >> 2] >> 2] | 0, i16 | 0, 1, 64) | 0;
 HEAP32[i7 + 324 >> 2] = i15;
 HEAP32[i15 >> 2] = fb + 2361;
 i1 = i15 + 4 | 0;
 if (!(HEAP8[(HEAP32[i7 + 340 >> 2] | 0) + 8 >> 0] | 0)) {
  HEAP32[i1 >> 2] = fb + 20;
  i4 = i7 + 60 | 0;
  if ((HEAP32[i4 >> 2] | 0) <= 0) return;
  i5 = i7 + 216 | 0;
  i6 = i7 + 220 | 0;
  i3 = i15 + 8 | 0;
  i2 = 0;
  i1 = HEAP32[i7 + 68 >> 2] | 0;
  while (1) {
   i15 = Math_imul(HEAP32[i1 + 28 >> 2] << 3, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i3 + (i2 << 2) >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, 1, (i15 | 0) / (HEAP32[i1 + 8 >> 2] | 0) | 0 | 0, HEAP32[i6 >> 2] | 0) | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (HEAP32[i4 >> 2] | 0)) break; else i1 = i1 + 84 | 0;
  }
  return;
 }
 HEAP32[i1 >> 2] = fb + 19;
 i13 = HEAP32[i7 + 220 >> 2] | 0;
 i14 = i7 + 60 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i17 >> 2] >> 2] | 0, i16 | 0, 1, Math_imul(i13 * 20 | 0, HEAP32[i14 >> 2] | 0) | 0) | 0;
 i2 = HEAP32[i7 + 68 >> 2] | 0;
 if ((HEAP32[i14 >> 2] | 0) <= 0) return;
 i9 = i7 + 216 | 0;
 i10 = i13 * 3 | 0;
 i11 = i13 * 12 | 0;
 i12 = i13 * 5 | 0;
 i7 = i13 << 1;
 i8 = i13 << 2;
 if ((i13 | 0) > 0) i6 = 0; else {
  i3 = 0;
  while (1) {
   i7 = Math_imul(HEAP32[i2 + 28 >> 2] << 3, HEAP32[i9 >> 2] | 0) | 0;
   i8 = i1 + (i13 << 2) | 0;
   _memcpy(i8 | 0, mftCall_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, 1, (i7 | 0) / (HEAP32[i2 + 8 >> 2] | 0) | 0 | 0, i10 | 0) | 0, i11 | 0) | 0;
   HEAP32[i15 + 8 + (i3 << 2) >> 2] = i8;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (HEAP32[i14 >> 2] | 0)) break; else {
    i2 = i2 + 84 | 0;
    i1 = i1 + (i12 << 2) | 0;
   }
  }
  return;
 }
 while (1) {
  i4 = Math_imul(HEAP32[i2 + 28 >> 2] << 3, HEAP32[i9 >> 2] | 0) | 0;
  i4 = mftCall_iiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, 1, (i4 | 0) / (HEAP32[i2 + 8 >> 2] | 0) | 0 | 0, i10 | 0) | 0;
  i5 = i1 + (i13 << 2) | 0;
  _memcpy(i5 | 0, i4 | 0, i11 | 0) | 0;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[i4 + (i3 + i7 << 2) >> 2];
   HEAP32[i1 + (i3 + i8 << 2) >> 2] = HEAP32[i4 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i13 | 0));
  HEAP32[i15 + 8 + (i6 << 2) >> 2] = i5;
  i6 = i6 + 1 | 0;
  if ((i6 | 0) >= (HEAP32[i14 >> 2] | 0)) break; else {
   i2 = i2 + 84 | 0;
   i1 = i1 + (i12 << 2) | 0;
  }
 }
 return;
}

function __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = (i4 - i5 | 0) / 20 | 0;
 i6 = i11 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i1 = i5;
 i8 = i10;
 i12 = i4;
 if (i9 >>> 0 > ((i2 - i10 | 0) / 20 | 0) >>> 0) {
  i4 = i10;
  if (i10) {
   i2 = i11 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i8 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i10 | 0) >>> 0) / 20 | 0) * 20 | 0);
   __ZdlPv(i4);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i2 = 0;
  }
  if (i9 >>> 0 > 214748364) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  } else i3 = 0;
  i10 = (i2 - i3 | 0) / 20 | 0;
  i3 = i10 << 1;
  i3 = i10 >>> 0 < 107374182 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 214748364;
  if (i3 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i2 = __Znwj(i3 * 20 | 0) | 0;
  i4 = i11 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i6 >> 2] = i2 + (i3 * 20 | 0);
  if ((i1 | 0) == (i12 | 0)) return;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i4 >> 2] | 0) + 20 | 0;
   HEAP32[i4 >> 2] = i2;
  } while ((i1 | 0) != (i12 | 0));
  return;
 } else {
  i6 = i11 + 4 | 0;
  i2 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 20 | 0;
  i3 = i9 >>> 0 > i2 >>> 0;
  i1 = i3 ? i1 + (i2 * 20 | 0) | 0 : i4;
  i2 = i1 - i5 | 0;
  if (i2 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i8 + (((i2 | 0) / 20 | 0) * 20 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   i1 = i1 + 20 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b(i14, i15, i3) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 HEAP8[i14 >> 0] = 0;
 i1 = i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i2) {
  i1 = HEAP32[i1 + 72 >> 2] | 0;
  if (i1 | 0) __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
  do if (!i3) {
   i1 = i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) | 0;
   if (HEAP32[i1 + 4 >> 2] & 4096 | 0) {
    HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
    __THREW__ = 0;
    i2 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i16 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__26localeD2Ev(i4);
     ___resumeException(i16 | 0);
    }
    __ZNSt3__26localeD2Ev(i4);
    i1 = HEAP32[i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    i4 = i2 + 8 | 0;
    i5 = i1;
    i6 = (i1 | 0) == 0;
    i7 = i5 + 12 | 0;
    i8 = i5 + 16 | 0;
    i9 = i1;
    i2 = i1;
    i10 = i2 + 12 | 0;
    i11 = i2 + 16 | 0;
    i12 = i1;
    i13 = i1;
    while (1) {
     if (i6) {
      i2 = 0;
      i1 = 0;
      break;
     }
     if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i8 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0) == -1) {
      i2 = 0;
      i1 = 0;
      break;
     }
     i3 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) i3 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i3 = HEAPU8[i3 >> 0] | 0;
     if ((i3 & 255) << 24 >> 24 <= -1) break;
     if (!(HEAP16[(HEAP32[i4 >> 2] | 0) + (i3 << 24 >> 24 << 1) >> 1] & 8192)) break;
     i3 = HEAP32[i10 >> 2] | 0;
     if ((i3 | 0) == (HEAP32[i11 >> 2] | 0)) {
      mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
      continue;
     } else {
      HEAP32[i10 >> 2] = i3 + 1;
      continue;
     }
    }
    if (i1 | 0) {
     if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) break;
     if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) != -1) break;
    }
    i13 = i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __ZNSt3__28ios_base5clearEj(i13, HEAP32[i13 + 16 >> 2] | 6);
   }
  } while (0);
  HEAP8[i14 >> 0] = (HEAP32[i15 + (HEAP32[(HEAP32[i15 >> 2] | 0) + -12 >> 2] | 0) + 16 >> 2] | 0) == 0 & 1;
 } else __ZNSt3__28ios_base5clearEj(i1, i2 | 4);
 STACKTOP = i16;
 return;
}

function __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) != (HEAP32[i6 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 424523 | 0, 0, gb + 424600 | 0, 527, 1, 0, 0, 0);
  STACKTOP = i20;
  return;
 }
 HEAP32[i19 >> 2] = HEAP32[i8 + 16 >> 2];
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i4 | 0) < (i1 | 0)) {
  i1 = (i1 << 16 | 0) / (i4 | 0) | 0;
  i2 = (i1 >>> 1) + -32768 | 0;
 } else {
  i18 = i4 + -1 | 0;
  i2 = 0;
  i1 = (((i1 << 16) + -65536 | 0) >>> 0) / ((i18 | 0 ? i18 : 1) >>> 0) | 0;
 }
 HEAP32[i19 + 20 >> 2] = i1;
 HEAP32[i19 + 16 >> 2] = i2;
 i18 = i8 + 8 | 0;
 i14 = HEAP32[i18 >> 2] | 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i14 | 0) < (i2 | 0)) {
  i7 = (i2 << 16 | 0) / (i14 | 0) | 0;
  i17 = i7;
  i7 = (i7 >>> 1) + -32768 | 0;
 } else {
  i17 = i14 + -1 | 0;
  i17 = (((i2 << 16) + -65536 | 0) >>> 0) / ((i17 | 0 ? i17 : 1) >>> 0) | 0;
  i7 = 0;
 }
 HEAP32[i19 + 12 >> 2] = i4;
 if ((i3 | 0) == 18) {
  i1 = 0;
  i5 = 11;
 } else if ((i3 | 0) == 19) {
  i1 = 1;
  i5 = 11;
 } else if ((i3 | 0) == 23) {
  i1 = 2;
  i5 = 11;
 } else if ((i3 | 0) == 20) {
  i1 = 3;
  i5 = 11;
 } else if ((i3 | 0) == 6) {
  i1 = 4;
  i5 = 11;
 } else if ((i3 | 0) == 15) {
  i1 = 5;
  i5 = 11;
 } else if ((i3 | 0) == 16) {
  i1 = 6;
  i5 = 11;
 } else if ((i3 | 0) == 17) {
  i1 = 7;
  i5 = 11;
 } else i16 = 0;
 if ((i5 | 0) == 11) i16 = HEAP32[gb + 57572 + (i1 << 2) >> 2] | 0;
 i15 = i6 + 16 | 0;
 i5 = HEAP32[i15 >> 2] | 0;
 i13 = i6 + 12 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i9 = i5 + (Math_imul(i2 + -1 | 0, i3) | 0) | 0;
 L24 : do if (i14 | 0) {
  i10 = i19 + 4 | 0;
  i11 = i19 + 8 | 0;
  i12 = i19 + 24 | 0;
  i8 = i8 + 12 | 0;
  i1 = 0;
  i6 = i7;
  i4 = i3;
  i2 = i5;
  i3 = i14;
  while (1) {
   i2 = i2 + (Math_imul(i4, i6 >>> 16) | 0) | 0;
   HEAP32[i10 >> 2] = i2;
   i14 = i2 + i4 | 0;
   HEAP32[i11 >> 2] = i14;
   if (i14 >>> 0 > i9 >>> 0 & (i1 | 0) == (i3 + -1 | 0)) HEAP32[i11 >> 2] = i2;
   HEAPF32[i12 >> 2] = Math_fround(Math_fround((i6 & 65535) >>> 0) * Math_fround(.0000152587891));
   mftCall_vi(i16 | 0, i19 | 0);
   HEAP32[i19 >> 2] = (HEAP32[i19 >> 2] | 0) + (HEAP32[i8 >> 2] | 0);
   i1 = i1 + 1 | 0;
   i3 = HEAP32[i18 >> 2] | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L24;
   i6 = i6 + i17 | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
  }
 } while (0);
 STACKTOP = i20;
 return;
}

function __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i6 + 352 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i3 = i6 + 356 | 0;
 if ((i1 | 0) != (HEAP32[i3 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i1;
  __ZN8Renderer13BoundsChangedEv(i6);
  HEAP8[i6 + 272 >> 0] = 1;
  i2 = i6 + 512 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i8 = i6 + 516 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + 232 | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i8 = i6 + 516 | 0;
    i5 = HEAP32[i1 >> 2] | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i5 + 4 >> 2] = i2;
    HEAP32[HEAP32[i8 >> 2] >> 2] = i2;
   }
  }
  if (HEAP32[i6 + 504 >> 2] | 0) __ZN19SkinnedMeshRenderer15UpdateClothDataEv(i6);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 116 >> 2] | 0) - (HEAP32[i1 + 112 >> 2] | 0) >> 4;
 HEAP32[i6 + 412 >> 2] = i1;
 i3 = i6 + 408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i6);
 i1 = i6 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i6 + 384 | 0;
 i2 = i6 + 400 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN19ComputeShaderKernelaSERKS_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 if ((i5 | 0) == (i6 | 0)) {
  i8 = i5 + 84 | 0;
  i7 = i6 + 84 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  return i5 | 0;
 }
 __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5 + 4 | 0, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0);
 __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5 + 16 | 0, HEAP32[i6 + 16 >> 2] | 0, HEAP32[i6 + 20 >> 2] | 0);
 __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5 + 28 | 0, HEAP32[i6 + 28 >> 2] | 0, HEAP32[i6 + 32 >> 2] | 0);
 __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5 + 40 | 0, HEAP32[i6 + 40 >> 2] | 0, HEAP32[i6 + 44 >> 2] | 0);
 __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5 + 52 | 0, HEAP32[i6 + 52 >> 2] | 0, HEAP32[i6 + 56 >> 2] | 0);
 i7 = HEAP32[i6 + 64 >> 2] | 0;
 i1 = HEAP32[i6 + 76 >> 2] | 0;
 i2 = i5 + 64 | 0;
 i8 = i5 + 76 | 0;
 HEAP32[i8 >> 2] = i1;
 i3 = i5 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i5 + 68 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i5 + 68 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  i1 = i4;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] | 0) | 0;
 i8 = i5 + 84 | 0;
 i7 = i6 + 84 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 return i5 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471259 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram16TextureParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471259 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram16TextureParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 60 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 946881 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 60 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 946881 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN9JSONWrite8TransferINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 24 | 0;
 i9 = i12 + 12 | 0;
 i6 = i12;
 i7 = i4 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = i8 + (i5 * 24 | 0) | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((HEAP16[gb + 1165980 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165980 | 0, i10);
  i11 = gb + 1165980 | 0;
 } else i11 = 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i10 | 0, i4 | 0, i5 | 0);
 i2 = i10 + 11 | 0;
 i13 = HEAP8[i2 >> 0] | 0;
 if ((i13 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i13 & 255) | 0) {
  __ZN17PersistentManager19RemapToAbsolutePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i4, i10);
  if (__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9) | 0) {
   if (!(__Z7StrICmpPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, gb + 588322 | 0) | 0)) i3 = 8; else if (!(__Z7StrICmpPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, gb + 466958 | 0) | 0)) i3 = 8; else i2 = 0;
   if ((i3 | 0) == 8) i2 = 16777216;
   i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, gb + 63416 | 0, 16, gb + 466989 | 0, gb + 1576256 | 0, gb + 466878 | 0, 2005) | 0;
   __ZN14SerializedFileC2Ev(i3);
   __Z19pop_allocation_rootv();
   HEAP32[i1 >> 2] = i3;
   i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i13 = __ZN14SerializedFile14InitializeReadERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER18ResourceImageGroupjj24TransferInstructionFlagsjj(HEAP32[i1 >> 2] | 0, i9, i6, 7168, HEAP32[i4 + 80 >> 2] | 0, i2, 0, -1) | 0;
   HEAP32[i8 + (i5 * 24 | 0) + 20 >> 2] = i13;
   if (!i13) {
    __ZN17PersistentManager23PostLoadStreamNameSpaceER15StreamNameSpacei(i4, i1, i5);
    i1 = (HEAP32[i7 >> 2] | 0) + (i5 * 24 | 0) | 0;
   } else {
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2) {
     __ZN14SerializedFile7ReleaseEv(i2);
     HEAP32[i1 >> 2] = 0;
    }
   }
   if (i3) __Z19pop_allocation_rootv();
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!i11) {
  i13 = i1;
  STACKTOP = i12;
  return i13 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 i13 = i1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN12_GLOBAL__N_110Connection24sendStreamInitializationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 56 | 0;
 i14 = i2 + 40 | 0;
 i8 = i2;
 i6 = i2 + 72 | 0;
 i9 = i1 + 24 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0) | 0;
 HEAP32[i8 >> 2] = gb + 150308 + 8;
 i11 = i8 + 4 | 0;
 HEAP32[i11 >> 2] = 837150850;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = 1;
 i4 = i8 + 16 | 0;
 __ZN5physx6shdfnd4Time19getCounterFrequencyEv(i7);
 i12 = i7;
 i12 = ___muldi3(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, 10, 0) | 0;
 i13 = getTempRet0() | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i13;
 i5 = i8 + 24 | 0;
 __ZN5physx6shdfnd4Time19getCounterFrequencyEv(i14);
 i14 = i14 + 8 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 i8 = i8 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 149708 + 8;
 HEAP32[i6 + 4 >> 2] = i10;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i11 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i3 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i4 | 0, 8) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i5 | 0, 8) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERj(i6, i7);
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i8 = HEAP32[i9 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 i8 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0) | 0;
 i10 = i1 + 64 | 0;
 i4 = i10;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, 1, 0) | 0;
 i3 = getTempRet0() | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = i3;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0);
 i3 = __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i8, i7, i6, i5, i4, i3) | 0;
 __ZN12_GLOBAL__N_110Connection22initializeProfileTypesERN5physx8debugger4comm31PvdCommStreamInternalDataStreamE(i1, i3);
 mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 88 >> 2] | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx25PxVehicleCopyDynamicsDataERKNS_24PxVehicleCopyDynamicsMapERKNS_15PxVehicleWheelsEPS3_(i9, i14, i15) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16 + 12 | 0;
 i3 = i16;
 i13 = i16 + 24 | 0;
 i8 = i14 + 8 | 0;
 i5 = HEAP32[i14 + 48 >> 2] | 0;
 i11 = i15 + 8 | 0;
 i12 = HEAP32[i15 + 48 >> 2] | 0;
 i1 = HEAP32[i15 + 104 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i4 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i3 | 0, i1 | 0);
 i10 = i14 + 113 | 0;
 switch (HEAPU8[i10 >> 0] | 0) {
 case 0:
  {
   __ZN5physx16PxVehicleDrive4W14setToRestStateEv(i15);
   break;
  }
 case 1:
  {
   __ZN5physx16PxVehicleDriveNW14setToRestStateEv(i15);
   break;
  }
 case 2:
  {
   __ZN5physx18PxVehicleDriveTank14setToRestStateEv(i15);
   break;
  }
 case 3:
  {
   __ZN5physx16PxVehicleNoDrive14setToRestStateEv(i15);
   break;
  }
 default:
  {}
 }
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i4 | 0, 1);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, i3 | 0, 1);
 i3 = i13;
 i4 = i3 + 20 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 if (!((i5 >>> 0 < i12 >>> 0 ? i5 : i12) | 0)) {
  f2 = Math_fround(0.0);
  i1 = 0;
 } else {
  i6 = i15 + 72 | 0;
  i7 = i14 + 72 | 0;
  i4 = i12 >>> 0 > i5 >>> 0 ? i5 : i12;
  f2 = Math_fround(0.0);
  i5 = 0;
  i1 = 0;
  do {
   i3 = HEAPU8[i9 + i5 >> 0] | 0;
   i17 = HEAPU8[i9 + 20 + i5 >> 0] | 0;
   __ZN5physx22PxVehicleWheelsDynData4copyERKS0_jj(i6, i7, i3, i17);
   HEAP8[i13 + i17 >> 0] = 1;
   if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i8, i3) | 0)) {
    f2 = Math_fround(f2 + Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj(i7, i3)));
    i1 = i1 + 1 | 0;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
 }
 f2 = Math_fround(f2 / Math_fround(i1 >>> 0));
 f2 = (i1 | 0) == 0 ? Math_fround(0.0) : f2;
 if (i12 | 0) {
  i1 = i15 + 72 | 0;
  i3 = 0;
  do {
   if (!(HEAP8[i13 + i3 >> 0] | 0)) if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i11, i3) | 0)) __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf(i1, i3, f2);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i12 | 0));
 }
 if ((HEAPU8[i10 >> 0] | 0) >= 3) {
  STACKTOP = i16;
  return;
 }
 i3 = i15 + 128 | 0;
 i1 = i14 + 128 | 0;
 i4 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 STACKTOP = i16;
 return;
}

function __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN16Physics2DManager12OverlapPointERK8Vector2fiffPK10Collider2D(i1, i14, i2, f3, f10, i5) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f10 = Math_fround(f10);
 i5 = i5 | 0;
 var f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i18 + 16 | 0;
 i11 = i18;
 i17 = i18 + 56 | 0;
 i12 = i18 + 24 | 0;
 if ((HEAP16[gb + 1457752 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457752 | 0, i7);
  i13 = gb + 1457752 | 0;
 } else i13 = 0;
 i16 = gb + 64016 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i8 + 4 >> 2] = i15;
 HEAP32[i17 >> 2] = 0;
 i8 = i17 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i15 = i17 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i17 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i11);
 i1 = i7;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i16;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i12 >> 2] = gb + 156168 + 8;
 i9 = i12 + 4 | 0;
 HEAP32[i12 + 12 >> 2] = i2;
 i2 = i12 + 16 | 0;
 i6 = i12 + 20 | 0;
 HEAP32[i12 + 24 >> 2] = i5;
 i1 = i12 + 28 | 0;
 HEAP32[i1 >> 2] = i17;
 i5 = f3 == Math_fround(-inf);
 f4 = i5 ? Math_fround(-3402823469999999843913219.0e14) : f3;
 HEAPF32[i2 >> 2] = f4;
 i5 = f10 == Math_fround(inf);
 f3 = i5 ? Math_fround(3402823469999999843913219.0e14) : f10;
 HEAPF32[i6 >> 2] = f3;
 if (!(f4 < f3)) {
  HEAPF32[i2 >> 2] = f3;
  HEAPF32[i6 >> 2] = f4;
 }
 i6 = HEAP32[i14 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 8 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i16);
 HEAP32[i17 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i14 = i11 + 8 | 0;
 HEAP32[i14 >> 2] = i8;
 HEAP32[i14 + 4 >> 2] = i9;
 i14 = i11;
 HEAP32[i14 >> 2] = i8;
 HEAP32[i14 + 4 >> 2] = i9;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i12, i11);
 i14 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i12, i12 + (HEAP32[i14 + 12 >> 2] << 2) | 0, i7);
 if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0) > 0) i1 = HEAP32[HEAP32[i17 >> 2] >> 2] | 0; else i1 = 0;
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i17 >> 2] | 0, i16);
  HEAP32[i17 >> 2] = 0;
 }
 if (!i13) {
  STACKTOP = i18;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i18;
 return i1 | 0;
}

function __Z16PresentAfterDrawN9GfxDevice11PresentModeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i4 = i5;
 switch (i1 | 0) {
 case 1:
  {
   if ((HEAP16[gb + 1450852 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450852 | 0, i3);
    i2 = gb + 1450852 | 0;
   } else i2 = 0;
   i1 = HEAP32[gb + 1450812 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, 1);
   if ((HEAP16[gb + 1450840 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450840 | 0, i3);
    i1 = gb + 1450840 | 0;
   } else i1 = 0;
   i4 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 508 >> 2] | 0, i4 | 0, 0);
   __Z15gpu_time_samplev();
   __Z20SetHasFrameToPresentb(0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   i1 = HEAP32[gb + 1450812 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, 0);
   if (!i2) {
    __Z15SetIsFirstFrameb(0);
    STACKTOP = i5;
    return;
   }
   __Z12profiler_endP19ProfilerInformation(i2);
   __Z15SetIsFirstFrameb(0);
   STACKTOP = i5;
   return;
  }
 case 0:
  {
   if (!(__Z12IsFirstFramev() | 0)) {
    __Z15SetIsFirstFrameb(0);
    STACKTOP = i5;
    return;
   }
   if ((HEAP16[gb + 1450852 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450852 | 0, i3);
    i2 = gb + 1450852 | 0;
   } else i2 = 0;
   i1 = HEAP32[gb + 1450812 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, 1);
   if ((HEAP16[gb + 1450840 + 6 >> 1] | 0) > -1) {
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450840 | 0, i3);
    i1 = gb + 1450840 | 0;
   } else i1 = 0;
   i4 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 508 >> 2] | 0, i4 | 0, 0);
   __Z15gpu_time_samplev();
   __Z20SetHasFrameToPresentb(0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   i1 = HEAP32[gb + 1450812 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, 0);
   if (!i2) {
    __Z15SetIsFirstFrameb(0);
    STACKTOP = i5;
    return;
   }
   __Z12profiler_endP19ProfilerInformation(i2);
   __Z15SetIsFirstFrameb(0);
   STACKTOP = i5;
   return;
  }
 default:
  {
   __Z15SetIsFirstFrameb(0);
   STACKTOP = i5;
   return;
  }
 }
}

function __ZN14SafeBinaryReadC2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 8 | 0;
 i12 = i11;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN12CachedReaderC2Ev(i6 + 16 | 0);
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 0;
 i10 = i6 + 88 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i6 + 100 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 104 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i6 + 92 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i3 = i13;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i6 + 108 | 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i12;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = 0;
 i2 = i6 + 120 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 112 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 + 4 >> 2] = i12;
 i5 = HEAP32[i3 >> 2] | 0;
 do if ((i5 & 2147483584) >>> 0 < 64) if ((i5 | 0) > -1) {
  HEAP32[i3 >> 2] = 64;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 768, 4, i4, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(768, 4, i4, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = 64;
  HEAP32[i1 >> 2] = i13;
  break;
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 & 2147483584) >>> 0 >= 64) {
  i13 = i6 + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i6 + 128 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i8 >> 2] = 64;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, 2048, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
  i13 = i6 + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i6 + 128 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i11;
  return;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2048, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i7 >> 2] << 5 | 0) | 0;
  HEAP32[i8 >> 2] = 64;
  HEAP32[i10 >> 2] = i13;
  i13 = i6 + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  i13 = i6 + 128 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN7Terrain15AddTreeInstanceERK12TreeInstance(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i2 = i11;
 i4 = i9 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i2);
   i2 = HEAP32[i10 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i11;
   return;
  }
 }
 i8 = i1 + 84 | 0;
 i2 = i1 + 100 | 0;
 i3 = i2 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0);
 if (!(__ZN12TreeDatabase7AddTreeERK12TreeInstance(i8, i6) | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = i9 + 228 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i9 + 240 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 28 | 0;
 i4 = i9 + 196 | 0;
 if (!i2) {
  do {
   __ZN12TreeRenderer10InjectTreeERK12TreeInstance(HEAP32[i1 + 8 >> 2] | 0, (HEAP32[i3 >> 2] | 0) + -40 | 0);
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 20 | 0) | 0));
  STACKTOP = i11;
  return;
 }
 do {
  i2 = i1 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) __ZN12TreeRendererD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63616 | 0);
  HEAP32[i2 >> 2] = 0;
  i9 = __ZnwjRK10MemLabelIdiPKci(440, gb + 63616 | 0, 16, gb + 930687 | 0, 623) | 0;
  __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN12TreeRendererC2ER12TreeDatabaseRK8Vector3f(i9, i8, i10);
  HEAP32[i2 >> 2] = i9;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 360 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 20 | 0) | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx12NpBatchQuery7raycastERKNS_6PxVec3ES3_ftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE(i13, i18, i19, f17, i12, i2, i3, i14, i11) {
 i13 = i13 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 f17 = Math_fround(f17);
 i12 = i12 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0, i16 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i20;
 i15 = i20 + 24 | 0;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i13 + 116 >> 2] | 0) >>> 0) {
  STACKTOP = i20;
  return;
 }
 i16 = i13 + 40 | 0;
 if ((__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i16, -1, 0) | 0) == 1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 532, gb + 687895 | 0, i20 + 16 | 0);
  STACKTOP = i20;
  return;
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = HEAP16[i2 >> 1] | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i7 = HEAP16[i3 + 16 >> 1] | 0;
 i1 = HEAP8[i3 + 18 >> 0] | 0;
 i9 = i13 + 12 | 0;
 i2 = i13 + 24 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i3 = i10 + 40 | 0;
 i4 = HEAP32[i13 + 20 >> 2] & 2147483647;
 if (i3 >>> 0 > i4 >>> 0) {
  i5 = (i3 * 3 | 0) + 256 | 0;
  if (i4 >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i9, i5);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i9, i3);
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + i5 >> 2] = -16;
 HEAP16[i4 + (i5 + 4) >> 1] = i6;
 i6 = i4 + (i5 + 8) | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP16[i4 + (i5 + 24) >> 1] = i7;
 HEAP8[i4 + (i5 + 26) >> 0] = i1;
 HEAP32[i4 + (i5 + 28) >> 2] = i14;
 HEAP32[i4 + (i5 + 32) >> 2] = i11;
 HEAP16[i4 + (i5 + 36) >> 1] = i12;
 HEAP8[i4 + (i5 + 38) >> 0] = 0;
 HEAP32[i2 >> 2] = i3;
 i2 = i13 + 144 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -16) i1 = i2; else i1 = (HEAP32[i9 >> 2] | 0) + i1 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i15 >> 2] = i18;
 HEAP32[i15 + 4 >> 2] = i19;
 HEAPF32[i15 + 8 >> 2] = f17;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 HEAPF32[i15 + 20 >> 2] = Math_fround(0.0);
 __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE(i9, i15);
 __ZN5physx6shdfnd14atomicExchangeEPVii(i16, 0) | 0;
 STACKTOP = i20;
 return;
}

function __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = i5 + 8 | 0;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i9 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 16 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 17 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i1 = i5 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  i2 = i4;
 }
 i4 = i5 + 20 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i4, i1, 1);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i3 = i5 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i3, i1, 1);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14UnityAnalytics13SetUserGenderENS_6GenderE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 88 | 0;
 i10 = i12 + 72 | 0;
 i11 = i12;
 if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0) | 0)) {
  i11 = 2;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = (i1 | 0) == 0 ? gb + 1083683 | 0 : (i1 | 0) == 1 ? gb + 1083669 | 0 : gb + 1083703 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i10 + 11 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = 0;
 __ZN11UnityEngine9Analytics13UserInfoEventC2Ev(i11);
 i1 = i11 + 48 | 0;
 i2 = i1 + 11 | 0;
 i3 = (HEAP8[i2 >> 0] | 0) < 0;
 if (i3) {
  i4 = HEAP32[i11 + 56 >> 2] & 2147483647;
  i5 = i4 + -1 | 0;
  if (!i5) {
   i3 = HEAP32[i11 + 52 >> 2] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, 2 - i4 | 0, i3, 0, i3, 1, i10);
  } else i7 = 4;
 } else i7 = 4;
 do if ((i7 | 0) == 4) {
  i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  HEAP8[i7 >> 0] = HEAP8[i10 >> 0] | 0;
  HEAP8[i7 + 1 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i11 + 52 >> 2] = 1;
   break;
  } else {
   HEAP8[i2 >> 0] = 1;
   break;
  }
 } while (0);
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i11, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i11 >> 2] = gb + 188648 + 8;
 i1 = i11 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i11 + 60 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i1 = i11 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i11 + 44 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 HEAP32[i11 >> 2] = gb + 190148 + 8;
 i1 = i11 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i11 = HEAP32[i11 + 16 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i11 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 }
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN12TextureInput32CheckFor16bOrGrayscaleConversionEbbi(i15, i1, i2, i14) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i10 = i15 + 28 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i16 = HEAP32[i5 + 4 >> 2] | 0;
 i17 = HEAP32[i5 + 8 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 if (i1 & i2) {
  if (!((i17 | 0) > 0 & (i16 | 0) > 0)) return;
  i7 = i16 * 3 | 0;
  i6 = 0;
  i2 = HEAP32[i15 + 32 >> 2] | 0;
  while (1) {
   i1 = 0;
   i3 = i5;
   i4 = i2;
   i2 = i2 + (i16 << 1) | 0;
   while (1) {
    HEAP16[i4 >> 1] = ((HEAPU8[i3 + 1 >> 0] | 0) + (HEAPU8[i3 >> 0] | 0) + (HEAPU8[i3 + 2 >> 0] | 0) << 8 >>> 0) / 3 | 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i16 | 0)) break; else {
     i3 = i3 + 3 | 0;
     i4 = i4 + 2 | 0;
    }
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i17 | 0)) break; else i5 = i5 + i7 | 0;
  }
  return;
 }
 if (i1) {
  i8 = __Znwj(20) | 0;
  __ZN5ImageC2Eii13TextureFormat(i8, i16, i17, 1);
  i9 = i8 + 16 | 0;
  if ((i17 | 0) > 0 & (i16 | 0) > 0) {
   i7 = i16 * 3 | 0;
   i4 = 0;
   i6 = HEAP32[i9 >> 2] | 0;
   while (1) {
    i1 = 0;
    i2 = i6;
    i6 = i6 + i16 | 0;
    i3 = i5;
    while (1) {
     HEAP8[i2 >> 0] = (((HEAPU8[i3 + 1 >> 0] | 0) + (HEAPU8[i3 >> 0] | 0) + (HEAPU8[i3 + 2 >> 0] | 0) | 0) >>> 0) / 3 | 0;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == (i16 | 0)) break; else {
      i2 = i2 + 1 | 0;
      i3 = i3 + 3 | 0;
     }
    }
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i17 | 0)) break; else i5 = i5 + i7 | 0;
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63184 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
   HEAP32[i10 >> 2] = 0;
  }
  HEAP32[i10 >> 2] = i8;
  HEAP32[i15 + 4 >> 2] = HEAP32[i9 >> 2];
  return;
 }
 if (!((i17 | 0) > 0 & i2)) return;
 i10 = (i14 | 0) > 0;
 if ((i16 | 0) <= 0) return;
 i13 = (i14 + -1 | 0) >>> 1;
 i11 = i13 + 1 | 0;
 i9 = i16 + -1 | 0;
 i12 = i13 + (Math_imul(i9, i11) | 0) + 1 | 0;
 i13 = Math_imul(i9, (i13 << 1) + 2 | 0) | 0;
 i9 = 0;
 i1 = HEAP32[i15 + 32 >> 2] | 0;
 do {
  if (i10) {
   i8 = i1 + (i11 << 1) + i13 | 0;
   i7 = 0;
   i3 = i5;
   while (1) {
    i2 = 0;
    i4 = i1;
    i6 = i3;
    i3 = i3 + i11 | 0;
    while (1) {
     HEAP16[i4 >> 1] = (HEAPU8[i6 >> 0] | 0) * 257;
     i2 = i2 + 2 | 0;
     if ((i2 | 0) >= (i14 | 0)) break; else {
      i4 = i4 + 2 | 0;
      i6 = i6 + 1 | 0;
     }
    }
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i16 | 0)) break; else i1 = i1 + (i11 << 1) | 0;
   }
   i5 = i5 + i12 | 0;
   i1 = i8;
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i17 | 0));
 return;
}

function __Z34register_external_gfx_deallocationPvPKci(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[gb + 1188412 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(16) | 0;
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[gb + 1188412 >> 2] = i1;
 }
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) i7 = 11; else {
  i2 = i5;
  L8 : while (1) {
   i4 = i3;
   while (1) {
    if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i6 >>> 0) break;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i3) break L8; else i4 = i3;
   }
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) {
    i2 = i4;
    break;
   } else i2 = i4;
  }
  if ((i2 | 0) == (i5 | 0)) i7 = 11; else if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 > i6 >>> 0) i7 = 11;
 }
 if ((i7 | 0) == 11) i2 = i5;
 if ((i2 | 0) != (i1 + 4 | 0)) {
  i5 = HEAP32[i2 + 20 >> 2] | 0;
  i6 = HEAP32[i2 + 24 >> 2] | 0;
  HEAP32[gb + 1188356 >> 2] = (HEAP32[gb + 1188356 >> 2] | 0) - i5;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) {
   i4 = i2;
   while (1) {
    i3 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break; else i4 = i3;
   }
  } else while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) break; else i3 = i4;
  }
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) HEAP32[i1 >> 2] = i3;
  i7 = i1 + 12 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i1 + 4 >> 2] | 0, i2);
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = 58;
  HEAP32[i8 + 4 >> 2] = i1;
  i1 = HEAP32[gb + 1188408 >> 2] | 0;
  do if (!i1) {
   i1 = HEAP32[gb + 73344 >> 2] | 0;
   i7 = i1 + 6960 | 0;
   HEAP32[gb + 73344 >> 2] = i7;
   if (i7 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
    __ZN13MemoryManagerC2Ev(i1);
    HEAP32[gb + 1188408 >> 2] = i1;
    i10 = i1;
    break;
   }
  } else i10 = i1; while (0);
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i10, i2, i8);
  __ZN14MemoryProfiler20UnregisterMemoryToIDEjj(HEAP32[gb + 1163236 >> 2] | 0, i6, i5);
  i1 = HEAP32[gb + 1188412 >> 2] | 0;
  if (!(HEAP32[i1 + 12 >> 2] | 0)) {
   if (i1 | 0) {
    __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE(i1, HEAP32[i1 + 4 >> 2] | 0);
    __ZdlPv(i1);
   }
   HEAP32[gb + 1188412 >> 2] = 0;
  }
 }
 STACKTOP = i9;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i10, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i5 = HEAP32[i5 + 24 >> 2] | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = i2 - i1 | 0;
 i3 = (i1 | 0) / 88 | 0;
 i2 = i5 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
  HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i4, __Z34scripting_class_array_element_sizeP11Il2CppClass(i4) | 0, i3) | 0;
  HEAP32[i2 >> 2] = i3;
 }
 if (i1 | 0) {
  i1 = 0;
  do {
   i6 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i5 >> 2] | 0, i1) | 0;
   __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i7, (HEAP32[i10 >> 2] | 0) + (i1 * 88 | 0) | 0, i6);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i8 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i11;
 return;
}

function _tt_cmap14_char_var_index(i1, i10, i12, i6) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = i9 + 10 | 0;
 i1 = 0;
 i3 = (HEAPU8[i9 + 7 >> 0] | 0) << 16 | (HEAPU8[i9 + 6 >> 0] | 0) << 24 | (HEAPU8[i9 + 8 >> 0] | 0) << 8 | (HEAPU8[i9 + 9 >> 0] | 0);
 L1 : while (1) while (1) {
  if (i1 >>> 0 >= i3 >>> 0) {
   i11 = 0;
   i8 = 21;
   break L1;
  }
  i5 = (i1 + i3 | 0) >>> 1;
  i7 = i4 + (i5 * 11 | 0) + 3 | 0;
  i2 = i7 + -3 | 0;
  i2 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
  if (i2 >>> 0 > i6 >>> 0) {
   i3 = i5;
   continue L1;
  }
  if (i2 >>> 0 < i6 >>> 0) i1 = i5 + 1 | 0; else break L1;
 }
 if ((i8 | 0) == 21) return i11 | 0;
 i1 = (HEAPU8[i7 + 1 >> 0] | 0) << 16 | (HEAPU8[i7 >> 0] | 0) << 24 | (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
 i7 = (HEAPU8[i7 + 5 >> 0] | 0) << 16 | (HEAPU8[i7 + 4 >> 0] | 0) << 24 | (HEAPU8[i7 + 6 >> 0] | 0) << 8 | (HEAPU8[i7 + 7 >> 0] | 0);
 L10 : do if (i1 | 0) {
  i1 = i9 + i1 | 0;
  i5 = i1 + 4 | 0;
  i1 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
  i4 = 0;
  while (1) {
   while (1) {
    if (i4 >>> 0 >= i1 >>> 0) break L10;
    i6 = (i1 + i4 | 0) >>> 1;
    i2 = i5 + (i6 << 2) + 3 | 0;
    i3 = i2 + -3 | 0;
    i3 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) << 16 | (HEAPU8[i3 + 2 >> 0] | 0);
    if (i3 >>> 0 > i12 >>> 0) i1 = i6; else break;
   }
   if (((HEAPU8[i2 >> 0] | 0) + i3 | 0) >>> 0 < i12 >>> 0) i4 = i6 + 1 | 0; else break;
  }
  i12 = mftCall_iii(HEAP32[(HEAP32[i10 + 12 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i12 | 0) | 0;
  return i12 | 0;
 } while (0);
 if (!i7) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = i9 + i7 | 0;
 i1 = (HEAPU8[i6 + 1 >> 0] | 0) << 16 | (HEAPU8[i6 >> 0] | 0) << 24 | (HEAPU8[i6 + 2 >> 0] | 0) << 8 | (HEAPU8[i6 + 3 >> 0] | 0);
 i6 = i6 + 4 | 0;
 if (!i1) {
  i12 = 0;
  return i12 | 0;
 } else i2 = 0;
 L26 : while (1) {
  while (1) {
   i4 = (i2 + i1 | 0) >>> 1;
   i5 = i6 + (i4 * 5 | 0) + 3 | 0;
   i3 = i5 + -3 | 0;
   i3 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) << 16 | (HEAPU8[i3 + 2 >> 0] | 0);
   if (i3 >>> 0 > i12 >>> 0) break;
   if (i3 >>> 0 >= i12 >>> 0) {
    i8 = 20;
    break L26;
   }
   i2 = i4 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    i11 = 0;
    i8 = 21;
    break L26;
   }
  }
  if (i2 >>> 0 < i4 >>> 0) i1 = i4; else {
   i11 = 0;
   i8 = 21;
   break;
  }
 }
 if ((i8 | 0) == 20) {
  i12 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
  return i12 | 0;
 } else if ((i8 | 0) == 21) return i11 | 0;
 return 0;
}

function __ZNK26AnimatorOverrideController12StringFromIDEj(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i6 = i11;
 i7 = i1 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i12 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i12 + 28 >> 2] | 0;
    i4 = HEAP32[i12 + 32 >> 2] | 0;
    i1 = i12;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i10 = 9;
  }
  if ((i10 | 0) == 7) i10 = 9;
  if ((i10 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i10 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 19;
   }
  }
  if ((i10 | 0) == 17) i10 = 19;
  if ((i10 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i8 | 0, i1 | 0, i9 | 0);
  STACKTOP = i11;
  return;
 } while (0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1576256 | 0, 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx8debugger17PvdNetworkStreams7connectERNS_19PxAllocatorCallbackEPKcijRPNS0_18PvdNetworkInStreamERPNS0_19PvdNetworkOutStreamE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i7 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, gb + 777228 | 0, gb + 775144 | 0, 692) | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i7 + 4 | 0;
 __ZN5physx6shdfnd6SocketC2Eb(i8, 0);
 i9 = i7 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 if (__ZN5physx6shdfnd6Socket7connectEPKctj(i8, i2, i3 & 65535, i4) | 0) {
  __ZN5physx6shdfnd6Socket11setBlockingEb(i8, 1);
  i9 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 777239 | 0, gb + 775144 | 0, 696) | 0;
  HEAP32[i9 >> 2] = gb + 150856 + 8;
  HEAP32[i9 + 4 >> 2] = i1;
  i8 = i9 + 8 | 0;
  HEAP32[i8 >> 2] = i7;
  i3 = i1;
  i10 = i9 + 16 | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = i9 + 20 | 0;
  HEAP32[i4 >> 2] = gb + 777261;
  HEAP32[i9 + 12 >> 2] = gb + 148172 + 8;
  i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i2 | 0, HEAP32[i4 >> 2] | 0, gb + 778794 | 0, 94) | 0;
  HEAP32[i9 + 24 >> 2] = i4;
  __ZN5physx6shdfnd9MutexImplC2Ev(i4);
  i8 = (HEAP32[i8 >> 2] | 0) + 12 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  HEAP32[i5 >> 2] = i9;
  i9 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 777291 | 0, gb + 775144 | 0, 697) | 0;
  HEAP32[i9 >> 2] = gb + 150892 + 8;
  HEAP32[i9 + 4 >> 2] = i1;
  i8 = i9 + 8 | 0;
  HEAP32[i8 >> 2] = i7;
  i4 = i9 + 16 | 0;
  HEAP32[i4 >> 2] = i3;
  i7 = i9 + 20 | 0;
  HEAP32[i7 >> 2] = gb + 777314;
  HEAP32[i9 + 12 >> 2] = gb + 148172 + 8;
  i5 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0, HEAP32[i7 >> 2] | 0, gb + 778794 | 0, 94) | 0;
  HEAP32[i9 + 24 >> 2] = i7;
  __ZN5physx6shdfnd9MutexImplC2Ev(i7);
  i7 = i9 + 32 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  i8 = (HEAP32[i8 >> 2] | 0) + 12 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  HEAP32[i6 >> 2] = i9;
  i9 = 1;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i10 = i1 + 1 | 0;
 HEAP32[i9 >> 2] = i10;
 if (i10 | 0) {
  HEAP32[i9 >> 2] = i1;
  if (i1 | 0) {
   i10 = 0;
   return i10 | 0;
  }
 }
 i10 = HEAP32[i7 >> 2] | 0;
 __ZN5physx6shdfnd6Socket10disconnectEv(i8);
 __ZN5physx6shdfnd6SocketD2Ev(i8);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i7 | 0);
 i10 = 0;
 return i10 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj278ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 80 | 0;
 i6 = i8;
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = HEAP32[i7 + 8 >> 2] | 0;
 i6 = HEAP32[i7 + 12 >> 2] | 0;
 i9 = HEAP32[i7 + 16 >> 2] | 0;
 i11 = HEAP32[i7 + 20 >> 2] | 0;
 i12 = HEAP32[i7 + 24 >> 2] | 0;
 i13 = HEAP32[i10 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[i5 + 12 >> 2] = i6;
 HEAP32[i5 + 16 >> 2] = i9;
 HEAP32[i5 + 20 >> 2] = i11;
 HEAP32[i5 + 24 >> 2] = i12;
 mftCall_vii(i13 | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5Unity5Joint7CleanupEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP8[i8 + 76 >> 0] = 1;
 i7 = i8 + 92 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i1 = i11;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 8; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 10;
  }
  if ((i9 | 0) == 8) i9 = 10;
  if ((i9 | 0) == 10) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i9 = 17; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 17; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 19;
   }
  }
  if ((i9 | 0) == 17) i9 = 19;
  if ((i9 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  __ZN9Rigidbody6WakeUpEv(i1);
 } while (0);
 __ZN9Rigidbody6WakeUpEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 67048 | 0) | 0);
 STACKTOP = i10;
 return;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i1 + 4 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i21 | 0)) return;
 i15 = HEAP32[i1 >> 2] | 0;
 i10 = i15 + 32 | 0;
 i17 = HEAP8[i10 + 11 >> 0] | 0;
 i16 = i17 << 24 >> 24 < 0;
 i17 = i17 & 255;
 i18 = i16 ? HEAP32[i15 + 36 >> 2] | 0 : i17;
 i19 = (i18 | 0) == 0;
 i11 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15 + 12 | 0;
 i14 = i13 + 11 | 0;
 i15 = i15 + 16 | 0;
 L4 : while (1) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  L6 : do if ((i18 | 0) == (i9 | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i16 ? i3 : i10;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   if (i16) {
    if (i19) break;
    if (!(_memcmp(i4, i1, i18) | 0)) break; else {
     i22 = 11;
     break;
    }
   }
   if (!i19) if ((i3 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i10;
    i4 = i17;
    while (1) {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) break L6;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 11;
      break;
     }
    }
   } else i22 = 11;
  } else i22 = 11; while (0);
  L16 : do if ((i22 | 0) == 11) {
   i22 = 0;
   if (!(HEAP8[i11 >> 0] | 0)) {
    i22 = 22;
    break L4;
   }
   if (!(HEAP32[i12 >> 2] | 0)) {
    i22 = 22;
    break L4;
   }
   i3 = HEAP8[i14 >> 0] | 0;
   i5 = i3 << 24 >> 24 < 0;
   i3 = i3 & 255;
   if (((i5 ? HEAP32[i15 >> 2] | 0 : i3) | 0) != (i9 | 0)) {
    i22 = 22;
    break L4;
   }
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = i5 ? i6 : i13;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = (i9 | 0) == 0;
   if (i5) {
    if (i4) break;
    if (!(_memcmp(i7, i1, i9) | 0)) break; else {
     i22 = 22;
     break L4;
    }
   }
   if (!i4) {
    if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i4 = i13; else {
     i22 = 22;
     break L4;
    }
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L16;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 22;
      break L4;
     }
    }
   }
  } while (0);
  i2 = i2 + 20 | 0;
  HEAP32[i20 >> 2] = i2;
  if ((i2 | 0) == (i21 | 0)) {
   i22 = 22;
   break;
  }
 }
 if ((i22 | 0) == 22) return;
}

function __ZN26AnimatorOverrideController13AwakeFromLoadE17AwakeFromLoadMode(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i7 = i9 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i11 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i11 + 28 >> 2] | 0;
    i4 = HEAP32[i11 + 32 >> 2] | 0;
    i1 = i11;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i10 = 9;
  }
  if ((i10 | 0) == 7) i10 = 9;
  if ((i10 | 0) == 9) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i10 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i10 = 18;
   }
  }
  if ((i10 | 0) == 16) i10 = 18;
  if ((i10 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  __ZN8UserList7AddUserER12UserListNode(i1 + 32 | 0, i9 + 120 | 0);
 } while (0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i9, gb + 1105796 | 0);
 if (HEAP32[i9 + 104 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 132 >> 2] | 0, i9 | 0);
 STACKTOP = i8;
 return;
}

function __ZN14b2CapsuleShape13SetByExtentsYEffRK6b2Vec2f(i11, f3, f2, i4, f1) {
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i4 + 4 | 0;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(+Math_sin(+f1));
 f10 = Math_fround(+Math_cos(+f1));
 HEAPF32[i11 + 8 >> 2] = f3;
 f6 = Math_fround(f2 * Math_fround(.5));
 f8 = Math_fround(-f6);
 f1 = Math_fround(f10 * Math_fround(0.0));
 f7 = Math_fround(f12 * Math_fround(0.0));
 f2 = Math_fround(f17 + Math_fround(f7 + Math_fround(f10 * f8)));
 HEAPF32[i11 + 12 >> 2] = Math_fround(f16 + Math_fround(f1 - Math_fround(f12 * f8)));
 HEAPF32[i11 + 16 >> 2] = f2;
 f7 = Math_fround(f17 + Math_fround(f7 + Math_fround(f6 * f10)));
 HEAPF32[i11 + 20 >> 2] = Math_fround(f16 + Math_fround(f1 - Math_fround(f6 * f12)));
 HEAPF32[i11 + 24 >> 2] = f7;
 i9 = i11 + 176 | 0;
 HEAP32[i9 >> 2] = 4;
 f7 = Math_fround(-f3);
 HEAPF32[i11 + 48 >> 2] = f7;
 HEAPF32[i11 + 52 >> 2] = f8;
 HEAPF32[i11 + 56 >> 2] = f3;
 HEAPF32[i11 + 60 >> 2] = f8;
 HEAPF32[i11 + 64 >> 2] = f3;
 HEAPF32[i11 + 68 >> 2] = f6;
 HEAPF32[i11 + 72 >> 2] = f7;
 HEAPF32[i11 + 76 >> 2] = f6;
 HEAPF32[i11 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 116 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 136 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 140 >> 2] = Math_fround(0.0);
 i15 = i4;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i11 + 40 | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i5 = 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(-1.0);
 while (1) {
  f17 = Math_fround(f6 + Math_fround(Math_fround(f10 * f8) + Math_fround(f12 * f7)));
  HEAPF32[i11 + 48 + (i5 << 3) >> 2] = Math_fround(f3 + Math_fround(Math_fround(f10 * f7) - Math_fround(f12 * f8)));
  HEAPF32[i11 + 48 + (i5 << 3) + 4 >> 2] = f17;
  f17 = Math_fround(Math_fround(f10 * f2) + Math_fround(f12 * f1));
  HEAPF32[i11 + 112 + (i5 << 3) >> 2] = Math_fround(Math_fround(f10 * f1) - Math_fround(f12 * f2));
  HEAPF32[i11 + 112 + (i5 << 3) + 4 >> 2] = f17;
  i4 = i5 + 1 | 0;
  if ((i4 | 0) >= (HEAP32[i9 >> 2] | 0)) break;
  f8 = Math_fround(HEAPF32[i11 + 48 + (i4 << 3) + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i11 + 112 + (i4 << 3) + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i11 + 48 + (i4 << 3) >> 2]);
  i5 = i4;
  f1 = Math_fround(HEAPF32[i11 + 112 + (i4 << 3) >> 2]);
 }
 return;
}

function __ZN14b2CapsuleShape13SetByExtentsXEffRK6b2Vec2f(i11, f3, f2, i4, f1) {
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i4 + 4 | 0;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(+Math_sin(+f1));
 f10 = Math_fround(+Math_cos(+f1));
 HEAPF32[i11 + 8 >> 2] = f3;
 f6 = Math_fround(f2 * Math_fround(.5));
 f7 = Math_fround(-f6);
 f1 = Math_fround(f12 * Math_fround(0.0));
 f8 = Math_fround(f10 * Math_fround(0.0));
 f2 = Math_fround(f17 + Math_fround(Math_fround(f12 * f7) + f8));
 HEAPF32[i11 + 12 >> 2] = Math_fround(f16 + Math_fround(Math_fround(f10 * f7) - f1));
 HEAPF32[i11 + 16 >> 2] = f2;
 f8 = Math_fround(f17 + Math_fround(Math_fround(f6 * f12) + f8));
 HEAPF32[i11 + 20 >> 2] = Math_fround(f16 + Math_fround(Math_fround(f6 * f10) - f1));
 HEAPF32[i11 + 24 >> 2] = f8;
 i9 = i11 + 176 | 0;
 HEAP32[i9 >> 2] = 4;
 f8 = Math_fround(-f3);
 HEAPF32[i11 + 48 >> 2] = f7;
 HEAPF32[i11 + 52 >> 2] = f8;
 HEAPF32[i11 + 56 >> 2] = f6;
 HEAPF32[i11 + 60 >> 2] = f8;
 HEAPF32[i11 + 64 >> 2] = f6;
 HEAPF32[i11 + 68 >> 2] = f3;
 HEAPF32[i11 + 72 >> 2] = f7;
 HEAPF32[i11 + 76 >> 2] = f3;
 HEAPF32[i11 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 116 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 136 >> 2] = Math_fround(-1.0);
 HEAPF32[i11 + 140 >> 2] = Math_fround(0.0);
 i15 = i4;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i11 + 40 | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i5 = 0;
 f1 = Math_fround(0.0);
 f2 = Math_fround(-1.0);
 while (1) {
  f17 = Math_fround(f6 + Math_fround(Math_fround(f10 * f8) + Math_fround(f12 * f7)));
  HEAPF32[i11 + 48 + (i5 << 3) >> 2] = Math_fround(f3 + Math_fround(Math_fround(f10 * f7) - Math_fround(f12 * f8)));
  HEAPF32[i11 + 48 + (i5 << 3) + 4 >> 2] = f17;
  f17 = Math_fround(Math_fround(f10 * f2) + Math_fround(f12 * f1));
  HEAPF32[i11 + 112 + (i5 << 3) >> 2] = Math_fround(Math_fround(f10 * f1) - Math_fround(f12 * f2));
  HEAPF32[i11 + 112 + (i5 << 3) + 4 >> 2] = f17;
  i4 = i5 + 1 | 0;
  if ((i4 | 0) >= (HEAP32[i9 >> 2] | 0)) break;
  f8 = Math_fround(HEAPF32[i11 + 48 + (i4 << 3) + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i11 + 112 + (i4 << 3) + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i11 + 48 + (i4 << 3) >> 2]);
  i5 = i4;
  f1 = Math_fround(HEAPF32[i11 + 112 + (i4 << 3) >> 2]);
 }
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 28 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471189 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram12UAVParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11);
     i1 = i1 + 28 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471189 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram12UAVParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 28 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f(i8, i1, i2, f13) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f13 = Math_fround(f13);
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 - f14);
 f14 = Math_fround(Math_fround(f13 - f14) / f5);
 if (f14 < Math_fround(-9.99999974e-06)) {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 if (f14 > Math_fround(1.00001001)) {
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
  return;
 }
 f9 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f10 = Math_fround(f5 * f9);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(f5 * f11);
 i1 = i1 + 4 | 0;
 i2 = i2 + 4 | 0;
 f6 = Math_fround(f14 * f14);
 f3 = Math_fround(f6 * Math_fround(6.0));
 f4 = Math_fround(f14 * Math_fround(6.0));
 f7 = Math_fround(f6 * Math_fround(3.0));
 if (f5 > Math_fround(1.74532929e-07)) {
  f17 = Math_fround(f4 - f3);
  f15 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround(f17 * f15);
  f16 = Math_fround(Math_fround(f7 - Math_fround(f14 * Math_fround(2.0))) * f12);
  f3 = Math_fround(f3 - f4);
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(Math_fround(f17 + Math_fround(f16 + Math_fround(Math_fround(Math_fround(Math_fround(f7 - Math_fround(f14 * Math_fround(4.0))) + Math_fround(1.0)) * f10) + Math_fround(f3 * f4)))) / f5);
  f3 = f15;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(HEAPF32[i2 >> 2]);
  i1 = 1252973140;
 }
 i2 = f9 == Math_fround(inf);
 i2 = i2 | f11 == Math_fround(inf);
 i1 = i2 ? 2139095040 : i1;
 HEAP32[i8 + 8 >> 2] = i1;
 HEAP32[i8 + 12 >> 2] = i1;
 HEAPF32[i8 >> 2] = f13;
 f16 = Math_fround(f14 * f6);
 f17 = Math_fround(f16 * Math_fround(2.0));
 f17 = Math_fround(Math_fround(Math_fround(f7 - f17) * f3) + Math_fround(Math_fround(Math_fround(f16 - f6) * f12) + Math_fround(Math_fround(Math_fround(f14 + Math_fround(f16 - Math_fround(f6 * Math_fround(2.0)))) * f10) + Math_fround(Math_fround(Math_fround(f17 - f7) + Math_fround(1.0)) * f4))));
 HEAPF32[i8 + 4 >> 2] = i2 ? f4 : f17;
 return;
}

function __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrENS_21AssetBundleLoadResultE(i13, i1, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 72 | 0;
 i9 = i14 + 64 | 0;
 i8 = i14 + 56 | 0;
 i7 = i14 + 48 | 0;
 i6 = i14 + 40 | 0;
 i5 = i14 + 32 | 0;
 i12 = i14 + 24 | 0;
 i11 = i14 + 16 | 0;
 i4 = i14 + 8 | 0;
 i3 = i14;
 do switch (i2 | 0) {
 case 0:
  {
   HEAP32[i13 >> 2] = 0;
   HEAP32[i13 + 4 >> 2] = 0;
   HEAP32[i13 + 8 >> 2] = 0;
   STACKTOP = i14;
   return;
  }
 case 1:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 367935 | 0, i3);
   STACKTOP = i14;
   return;
  }
 case 2:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 367971 | 0, i4);
   STACKTOP = i14;
   return;
  }
 case 3:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i11 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 366806 | 0, i11);
   STACKTOP = i14;
   return;
  }
 case 4:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i12 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 366764 | 0, i12);
   STACKTOP = i14;
   return;
  }
 case 5:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 365885 | 0, i5);
   STACKTOP = i14;
   return;
  }
 case 6:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 366067 | 0, i6);
   STACKTOP = i14;
   return;
  }
 case 7:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 365963 | 0, i7);
   STACKTOP = i14;
   return;
  }
 case 8:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 368005 | 0, i8);
   STACKTOP = i14;
   return;
  }
 case 9:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 366859 | 0, i9);
   STACKTOP = i14;
   return;
  }
 default:
  {
   i1 = i1 + 112 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   __Z6FormatPKcz(i13, gb + 368051 | 0, i10);
   STACKTOP = i14;
   return;
  }
 } while (0);
}

function __ZNK12b2ChainShape9TestPointERK11b2TransformRK6b2Vec2(i1, i14, i16) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, i27 = 0, i28 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 192 | 0;
 i18 = i20 + 184 | 0;
 i3 = i20;
 i19 = i1 + 8 | 0;
 f21 = Math_fround(HEAPF32[i19 >> 2]);
 f2 = Math_fround(HEAPF32[gb + 151644 >> 2]);
 if (f21 <= f2) {
  i19 = 0;
  STACKTOP = i20;
  return i19 | 0;
 }
 HEAP32[i3 >> 2] = gb + 151688 + 8;
 HEAP32[i3 + 28 >> 2] = gb + 151728 + 8;
 HEAP32[i3 + 32 >> 2] = 2;
 HEAPF32[i3 + 36 >> 2] = f2;
 HEAP32[i3 + 176 >> 2] = 0;
 HEAPF32[i3 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 4 >> 2] = 4;
 i15 = i3 + 8 | 0;
 HEAPF32[i15 >> 2] = f2;
 i12 = i3 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i12 = i3 + 12 | 0;
 i13 = i1 + 12 | 0;
 i5 = i1 + 16 | 0;
 i6 = i3 + 20 | 0;
 i7 = i16 + 4 | 0;
 i8 = i14 + 4 | 0;
 i9 = i14 + 12 | 0;
 i10 = i14 + 8 | 0;
 i11 = i17 + 4 | 0;
 i3 = i3 + 12 | 0;
 i4 = i18 + 4 | 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) >= (HEAP32[i5 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  i27 = HEAP32[i13 >> 2] | 0;
  i28 = i27 + (i1 << 3) | 0;
  i25 = HEAP32[i28 + 4 >> 2] | 0;
  i26 = i12;
  HEAP32[i26 >> 2] = HEAP32[i28 >> 2];
  HEAP32[i26 + 4 >> 2] = i25;
  i1 = i1 + 1 | 0;
  i27 = i27 + (i1 << 3) | 0;
  i26 = HEAP32[i27 + 4 >> 2] | 0;
  i25 = i6;
  HEAP32[i25 >> 2] = HEAP32[i27 >> 2];
  HEAP32[i25 + 4 >> 2] = i26;
  HEAP32[i15 >> 2] = HEAP32[i19 >> 2];
  f21 = Math_fround(HEAPF32[i16 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i14 >> 2]));
  f22 = Math_fround(HEAPF32[i7 >> 2]);
  f22 = Math_fround(f22 - Math_fround(HEAPF32[i8 >> 2]));
  f24 = Math_fround(HEAPF32[i9 >> 2]);
  f23 = Math_fround(f21 * f24);
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  f21 = Math_fround(Math_fround(f24 * f22) - Math_fround(f21 * f2));
  HEAPF32[i17 >> 2] = Math_fround(f23 + Math_fround(f22 * f2));
  HEAPF32[i11 >> 2] = f21;
  __Z20b2NearestPointOnLineRK6b2Vec2S1_S1_(i18, i17, i3, i6);
  f21 = Math_fround(HEAPF32[i18 >> 2]);
  f21 = Math_fround(f21 - Math_fround(HEAPF32[i17 >> 2]));
  f2 = Math_fround(HEAPF32[i4 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i11 >> 2]));
  f2 = Math_fround(Math_fround(f21 * f21) + Math_fround(f2 * f2));
  f21 = Math_fround(HEAPF32[i15 >> 2]);
  if (f2 <= Math_fround(f21 * f21)) {
   i1 = 1;
   break;
  }
 }
 i28 = i1;
 STACKTOP = i20;
 return i28 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj268ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 80 | 0;
 i6 = i8;
 i7 = i8 + 52 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = HEAP32[i7 + 8 >> 2] | 0;
 i6 = HEAP32[i7 + 12 >> 2] | 0;
 i9 = HEAP32[i7 + 16 >> 2] | 0;
 i11 = HEAP32[i7 + 20 >> 2] | 0;
 i12 = HEAP32[i7 + 24 >> 2] | 0;
 i13 = HEAP32[i10 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[i5 + 12 >> 2] = i6;
 HEAP32[i5 + 16 >> 2] = i9;
 HEAP32[i5 + 20 >> 2] = i11;
 HEAP32[i5 + 24 >> 2] = i12;
 mftCall_vii(i13 | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZNK16LightmapSettings23GetLightmapDecodeValuesEv(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 8 | 0;
 i6 = i10;
 if (!(HEAP32[i1 + 48 >> 2] | 0)) {
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i6 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i4 + (i6 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i6);
    i4 = HEAP32[i4 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i4 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i4 << 3) | 0;
    i4 = HEAP32[i6 + 28 >> 2] | 0;
    i6 = HEAP32[i6 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 + (i6 << 3) | 0)) i8 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 11;
   }
  }
  if ((i8 | 0) == 9) i8 = 11;
  if ((i8 | 0) == 11) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
   if (!i1) break;
  }
  i4 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  switch (i4 | 0) {
  case 4:
   {
    f5 = Math_fround(-1.0);
    f2 = Math_fround(2.0);
    f3 = Math_fround(1.0);
    break;
   }
  case 1:
  case 7:
   {
    f5 = Math_fround(0.0);
    f2 = (i1 | 0) == 0 ? Math_fround(2.0) : Math_fround(4.5947938);
    f3 = Math_fround(1.0);
    break;
   }
  case 5:
  case 2:
   {
    i11 = (i1 | 0) == 0;
    f3 = i11 ? Math_fround(1.0) : Math_fround(2.20000005);
    f5 = Math_fround(0.0);
    f2 = i11 ? Math_fround(5.0) : Math_fround(34.4932442);
    break;
   }
  default:
   {
    f5 = Math_fround(0.0);
    f2 = Math_fround(1.0);
    f3 = Math_fround(1.0);
   }
  }
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i9 + 4 >> 2] = f3;
  HEAPF32[i9 + 8 >> 2] = f5;
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i10;
  return;
 } while (0);
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i10;
 return;
}

function __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN22RenderingCommandBuffer25AddDrawProceduralIndirectERK10Matrix4x4fP8Materiali16GfxPrimitiveType15ComputeBufferIDiP19ShaderPropertySheet(i13, i2, i11, i15, i16, i12, i17, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 if (!i1) i6 = -1; else {
  i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 423766 | 0, 129) | 0;
  __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i3, i13 + 8 | 0, i1);
  i4 = i13 + 40 | 0;
  i5 = i13 + 52 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i8 = i13 + 56 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 2, 4, i13 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i7;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
 }
 i4 = i14;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 if (!i11) i10 = 0; else i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i13 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i13 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 3;
 i4 = i4 + 7 & -4;
 i5 = i4 + 96 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i1 = i1 + i4 | 0;
 i4 = i1;
 i2 = i14;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 HEAP32[i1 + 64 >> 2] = i10;
 HEAP32[i1 + 68 >> 2] = i15;
 HEAP32[i1 + 72 >> 2] = i16;
 HEAP32[i1 + 76 >> 2] = i9;
 HEAP32[i1 + 80 >> 2] = i17;
 HEAP32[i1 + 84 >> 2] = i6;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN13RenderTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i5, i1 + 80 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406071 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406086 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406100 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 411124 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406114 | 0, i5, i1 + 117 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 406129 | 0, i5, i1 + 118 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i1, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9UdpSocket4OpenEPKci(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 48 | 0;
 i7 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i6 = i11 + 8 | 0;
 i5 = i11 + 52 | 0;
 i10 = i1 + 4 | 0;
 if ((HEAP32[i10 >> 2] | 0) == -1) {
  __Z6FormatPKcz(i5, gb + 458812 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 458557 | 0, 494, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  HEAP8[i1 + 17 >> 0] = 0;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!i2) i3 = _htonl(0) | 0; else i3 = _inet_addr(i2 | 0) | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i6 >> 2] = i2;
  __Z6FormatPKcz(i5, gb + 458833 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 458557 | 0, 501, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = i1 + 17 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  _close(HEAP32[i10 >> 2] | 0) | 0;
  HEAP8[i1 >> 0] = 0;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = 2048;
 if ((_fcntl(i6, 4, i9) | 0) == -1) {
  __Z6FormatPKcz(i9, gb + 458740 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 458557 | 0, 390, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __Z6FormatPKcz(i7, gb + 458855 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 458557 | 0, 506, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = i1 + 17 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  _close(HEAP32[i10 >> 2] | 0) | 0;
  HEAP8[i1 >> 0] = 0;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = _htons(i4 & 65535) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP16[i9 >> 1] = 2;
 HEAP32[i9 + 4 >> 2] = i3;
 HEAP16[i9 + 2 >> 1] = i8;
 i1 = i1 + 17 | 0;
 if (!(_bind(HEAP32[i10 >> 2] | 0, i9, 16) | 0)) {
  HEAP8[i1 >> 0] = 1;
  i1 = 1;
 } else if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else {
  _close(HEAP32[i10 >> 2] | 0) | 0;
  HEAP8[i1 >> 0] = 0;
  i1 = 0;
 }
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN9JSONWrite8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 24 | 0;
 i15 = i16;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i15;
 i3 = i14 + 8 | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 if (!(HEAP32[i10 >> 2] & 1)) {
  __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1048093 | 0, 1);
  __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags(i10, i3, gb + 1048102 | 0, 1);
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i11 >> 2] | 0, i14);
  __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i14, gb + 1048093 | 0, 1);
  __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags(i10, i3, gb + 1048102 | 0, 1);
 }
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i15);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i4 + 16 | 0;
 i20 = i4;
 i22 = HEAP32[i3 + 4 >> 2] | 0;
 i19 = HEAP32[i3 + 8 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 i16 = i19 + 4 | 0;
 f10 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2])));
 i13 = i19 + 8 | 0;
 f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2])));
 i18 = i19 + 16 | 0;
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 i15 = i19 + 20 | 0;
 f11 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i15 >> 2])));
 i2 = i19 + 24 | 0;
 f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2])));
 i17 = i19 + 32 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 i14 = i19 + 36 | 0;
 f12 = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2])));
 i3 = i19 + 40 | 0;
 f8 = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i21 >> 2] = f10;
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f8;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i20, i22, i21);
 f8 = Math_fround(HEAPF32[i19 + 48 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 56 >> 2]);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f9 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 f7 = Math_fround(f12 * Math_fround(HEAPF32[i19 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2])));
 f7 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2])));
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i13 >> 2]));
 f9 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i2 >> 2])));
 f6 = Math_fround(f11 + f6);
 f5 = Math_fround(f10 + Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]))));
 HEAPF32[i1 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i1 + 4 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i21 | 0)) return;
 i15 = HEAP32[i1 >> 2] | 0;
 i10 = i15 + 32 | 0;
 i17 = HEAP8[i10 + 11 >> 0] | 0;
 i16 = i17 << 24 >> 24 < 0;
 i17 = i17 & 255;
 i18 = i16 ? HEAP32[i15 + 36 >> 2] | 0 : i17;
 i19 = (i18 | 0) == 0;
 i11 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15 + 12 | 0;
 i14 = i13 + 11 | 0;
 i15 = i15 + 16 | 0;
 L4 : while (1) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  L6 : do if ((i18 | 0) == (i9 | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i16 ? i3 : i10;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   if (i16) {
    if (i19) break;
    if (!(_memcmp(i4, i1, i18) | 0)) break; else {
     i22 = 11;
     break;
    }
   }
   if (!i19) if ((i3 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i10;
    i4 = i17;
    while (1) {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) break L6;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 11;
      break;
     }
    }
   } else i22 = 11;
  } else i22 = 11; while (0);
  L16 : do if ((i22 | 0) == 11) {
   i22 = 0;
   if (!(HEAP8[i11 >> 0] | 0)) {
    i22 = 22;
    break L4;
   }
   if (!(HEAP32[i12 >> 2] | 0)) {
    i22 = 22;
    break L4;
   }
   i3 = HEAP8[i14 >> 0] | 0;
   i5 = i3 << 24 >> 24 < 0;
   i3 = i3 & 255;
   if (((i5 ? HEAP32[i15 >> 2] | 0 : i3) | 0) != (i9 | 0)) {
    i22 = 22;
    break L4;
   }
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = i5 ? i6 : i13;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = (i9 | 0) == 0;
   if (i5) {
    if (i4) break;
    if (!(_memcmp(i7, i1, i9) | 0)) break; else {
     i22 = 22;
     break L4;
    }
   }
   if (!i4) {
    if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i4 = i13; else {
     i22 = 22;
     break L4;
    }
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L16;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 22;
      break L4;
     }
    }
   }
  } while (0);
  i2 = i2 + 20 | 0;
  HEAP32[i20 >> 2] = i2;
  if ((i2 | 0) == (i21 | 0)) {
   i22 = 22;
   break;
  }
 }
 if ((i22 | 0) == 22) return;
}

function __ZN12HingeJoint2D8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i3 = i5 + 112 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 803251 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 803262 | 0, gb + 803270 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 113 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 802926 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 104 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 801437 | 0, gb + 801451 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN18JointAngleLimits2D8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine7Connect18ConnectSessionInfoD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i2 + 176 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 188 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 160 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 172 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 144 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 156 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 128 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 140 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 124 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 96 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 108 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 60 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 72 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __Z41Physics2D_CUSTOM_INTERNAL_CALL_RaycastAllRK13Vector2fIcallS1_fiff(i1, i2, f5, i3, f6, f8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 i3 = i3 | 0;
 f6 = Math_fround(f6);
 f8 = Math_fround(f8);
 var i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12 + 8 | 0;
 i7 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i4 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i7);
 i16 = i13;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i10;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 i14 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 do if (!(__ZN16Physics2DManager10RaycastAllERK8Vector2fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i14, i13, i7, f5, i3, f6, f8, 0, 0, i11) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i7) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i7) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i3 = 0;
  while (1) {
   i14 = i2;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i16 = i4;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = i15;
   i16 = i2 + 8 | 0;
   i15 = HEAP32[i16 + 4 >> 2] | 0;
   i14 = i4 + 8 | 0;
   HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i14 + 4 >> 2] = i15;
   i14 = i2 + 16 | 0;
   i15 = HEAP32[i14 + 4 >> 2] | 0;
   i16 = i4 + 16 | 0;
   HEAP32[i16 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i16 + 4 >> 2] = i15;
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else {
    i4 = i4 + 36 | 0;
    i2 = i2 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i1 | 0;
}

function __Z13RemoveVehiclePN5physx16PxVehicleNoDriveEj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i7 >> 2] = i6;
 HEAP32[gb + 1458868 >> 2] = (HEAP32[gb + 1458868 >> 2] | 0) - (HEAP32[i1 + 48 >> 2] | 0) & -4;
 i3 = HEAP32[gb + 1458540 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = (i2 - i1 >> 2) + -1 | 0;
 if (i8 >>> 0 > i6 >>> 0) {
  i5 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
  HEAP32[i1 + (i6 << 2) >> 2] = i5;
  i1 = HEAP32[gb + 1458780 >> 2] | 0;
  if (!(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i6 >>> 5 << 2) >> 2] & 1 << (i6 & 31))) {
   i2 = HEAP32[gb + 1458700 >> 2] | 0;
   i3 = i2 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
    __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i2, i7);
    i1 = HEAP32[gb + 1458780 >> 2] | 0;
   } else {
    HEAP32[i4 >> 2] = i6;
    HEAP32[i3 >> 2] = i4 + 4;
   }
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = (HEAP32[i1 + 8 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i4 & 31);
  }
  i1 = HEAP32[i5 + 104 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 + 64 >> 2] = HEAP32[i7 >> 2];
  }
  HEAP32[(HEAP32[HEAP32[gb + 1458540 >> 2] >> 2] | 0) + (i8 << 2) >> 2] = 0;
  i2 = HEAP32[HEAP32[gb + 1458620 >> 2] >> 2] | 0;
  i3 = i2 + (i8 << 3) | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = i2 + (HEAP32[i7 >> 2] << 3) | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  i2 = (HEAP32[HEAP32[gb + 1458620 >> 2] >> 2] | 0) + (i8 << 3) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i2 = HEAP32[gb + 1458540 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 i5 = (HEAP32[(HEAP32[gb + 1458780 >> 2] | 0) + 8 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~(1 << (i8 & 31));
 i5 = i1 + (i8 << 2) | 0;
 i4 = i5 + 4 | 0;
 i6 = i3 + 4 | 0;
 i1 = i2 - i4 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + (i3 << 2) | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i6 = HEAP32[gb + 1458620 >> 2] | 0;
 i4 = (HEAP32[i6 >> 2] | 0) + (i8 << 3) | 0;
 i1 = i4 + 8 | 0;
 i6 = i6 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 | 0;
 i5 = i3 >> 3;
 if (i5) {
  _memmove(i4 | 0, i1 | 0, i3 | 0) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i4 + (i5 << 3) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 STACKTOP = i9;
 return;
}

function __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN12SkeletonBoneC2ERKS_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i8 = 12;
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i5;
  i8 = 12;
 }
 if ((i8 | 0) == 12) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i6 + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i6 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i7 + 40 >> 2];
 i10 = i6 + 44 | 0;
 i8 = i7 + 44 | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + 60 >> 2] = HEAP32[i7 + 60 >> 2];
 HEAP32[i6 + 64 >> 2] = HEAP32[i7 + 64 >> 2];
 HEAP32[i6 + 68 >> 2] = HEAP32[i7 + 68 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 36 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 451047 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 451047 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function _tlsf_free(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i1) return;
 i2 = i1 + -8 | 0;
 i8 = i1 + -4 | 0;
 i10 = ((HEAP32[i8 >> 2] | 0) + -4 & -4) + i1 | 0;
 HEAP32[i10 >> 2] = i2;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
 i10 = HEAP32[i8 >> 2] | 0;
 i1 = i10 | 1;
 HEAP32[i8 >> 2] = i1;
 if (!(i10 & 2)) i7 = i2; else {
  i7 = HEAP32[i2 >> 2] | 0;
  i6 = i7 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 & -4;
  if (i2 >>> 0 < 128) {
   i1 = i1 >>> 2;
   i4 = 0;
  } else {
   i4 = 31 - (Math_clz32(i2 | 0) | 0) | 0;
   i1 = i2 >>> (i4 + -5 | 0) ^ 32;
   i4 = i4 + -6 | 0;
  }
  i3 = HEAP32[i7 + 12 >> 2] | 0;
  i5 = i7 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  HEAP32[i3 + 8 >> 2] = i2;
  i3 = i11 + 116 + (i4 << 7) + (i1 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   HEAP32[i3 >> 2] = i2;
   if ((i2 | 0) == (i11 | 0)) {
    i9 = i11 + 20 + (i4 << 2) | 0;
    i10 = HEAP32[i9 >> 2] & ~(1 << i1);
    HEAP32[i9 >> 2] = i10;
    i1 = i11 + 16 | 0;
    if (!i10) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i4);
   }
  }
  i1 = ((HEAP32[i8 >> 2] | 0) + 4 & -4) + (HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[(i1 + -4 & -4) + i5 >> 2] = i7;
 }
 i10 = i7 + 8 | 0;
 i6 = i7 + 4 | 0;
 i9 = i10;
 i5 = (i1 + -4 & -4) + i9 | 0;
 i8 = i5 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 & 1) {
  i1 = i2 & -4;
  if (i1 >>> 0 < 128) {
   i1 = i2 >>> 2;
   i4 = 0;
  } else {
   i4 = 31 - (Math_clz32(i1 | 0) | 0) | 0;
   i1 = i1 >>> (i4 + -5 | 0) ^ 32;
   i4 = i4 + -6 | 0;
  }
  i3 = HEAP32[i5 + 12 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  HEAP32[i3 + 8 >> 2] = i2;
  i3 = i11 + 116 + (i4 << 7) + (i1 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) {
   HEAP32[i3 >> 2] = i2;
   if ((i2 | 0) == (i11 | 0)) {
    i3 = i11 + 20 + (i4 << 2) | 0;
    i5 = HEAP32[i3 >> 2] & ~(1 << i1);
    HEAP32[i3 >> 2] = i5;
    i1 = i11 + 16 | 0;
    if (!i5) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i4);
   }
  }
  i1 = ((HEAP32[i8 >> 2] | 0) + 4 & -4) + (HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[(i1 + -4 & -4) + i9 >> 2] = i7;
 }
 i2 = i1 & -4;
 if (i2 >>> 0 < 128) {
  i1 = i1 >>> 2;
  i2 = 0;
 } else {
  i9 = 31 - (Math_clz32(i2 | 0) | 0) | 0;
  i1 = i2 >>> (i9 + -5 | 0) ^ 32;
  i2 = i9 + -6 | 0;
 }
 i9 = i11 + 116 + (i2 << 7) + (i1 << 2) | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i7 + 12 >> 2] = i11;
 HEAP32[i8 + 12 >> 2] = i7;
 HEAP32[i9 >> 2] = i7;
 i10 = i11 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << i2;
 i11 = i11 + 20 + (i2 << 2) | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << i1;
 return;
}

function __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i1 + 4 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i21 | 0)) return;
 i15 = HEAP32[i1 >> 2] | 0;
 i10 = i15 + 32 | 0;
 i17 = HEAP8[i10 + 11 >> 0] | 0;
 i16 = i17 << 24 >> 24 < 0;
 i17 = i17 & 255;
 i18 = i16 ? HEAP32[i15 + 36 >> 2] | 0 : i17;
 i19 = (i18 | 0) == 0;
 i11 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15 + 12 | 0;
 i14 = i13 + 11 | 0;
 i15 = i15 + 16 | 0;
 L4 : while (1) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  L6 : do if ((i18 | 0) == (i9 | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i16 ? i3 : i10;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   if (i16) {
    if (i19) break;
    if (!(_memcmp(i4, i1, i18) | 0)) break; else {
     i22 = 11;
     break;
    }
   }
   if (!i19) if ((i3 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i10;
    i4 = i17;
    while (1) {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) break L6;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 11;
      break;
     }
    }
   } else i22 = 11;
  } else i22 = 11; while (0);
  L16 : do if ((i22 | 0) == 11) {
   i22 = 0;
   if (!(HEAP8[i11 >> 0] | 0)) {
    i22 = 22;
    break L4;
   }
   if (!(HEAP32[i12 >> 2] | 0)) {
    i22 = 22;
    break L4;
   }
   i3 = HEAP8[i14 >> 0] | 0;
   i5 = i3 << 24 >> 24 < 0;
   i3 = i3 & 255;
   if (((i5 ? HEAP32[i15 >> 2] | 0 : i3) | 0) != (i9 | 0)) {
    i22 = 22;
    break L4;
   }
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = i5 ? i6 : i13;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = (i9 | 0) == 0;
   if (i5) {
    if (i4) break;
    if (!(_memcmp(i7, i1, i9) | 0)) break; else {
     i22 = 22;
     break L4;
    }
   }
   if (!i4) {
    if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i4 = i13; else {
     i22 = 22;
     break L4;
    }
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L16;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 22;
      break L4;
     }
    }
   }
  } while (0);
  i2 = i2 + 20 | 0;
  HEAP32[i20 >> 2] = i2;
  if ((i2 | 0) == (i21 | 0)) {
   i22 = 22;
   break;
  }
 }
 if ((i22 | 0) == 22) return;
}

function __ZN5physx7NpScene14resetFilteringERNS_7PxActorE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 switch (HEAPU16[i3 + 4 >> 1] | 0) {
 case 6:
  {
   __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i3, i3 + 48 | 0, 0, 0) | 0;
   STACKTOP = i5;
   return;
  }
 case 5:
  {
   i2 = i3 + 48 | 0;
   __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i3, i2, 0, 0) | 0;
   if (!(HEAP32[i3 + 284 >> 2] & 4096)) i1 = i3 + 108 | 0; else i1 = (HEAP32[i3 + 56 >> 2] | 0) + 268 | 0;
   if (HEAP8[i1 >> 0] & 1) {
    STACKTOP = i5;
    return;
   }
   __ZN5physx14NpRigidDynamic29wakeUpInternalNoKinematicTestERNS_3Scb4BodyEbb(i3, i2, 0, 1);
   STACKTOP = i5;
   return;
  }
 case 15:
  {
   __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i3, i3 + 48 | 0, 0, 0) | 0;
   __ZN5physx14NpArticulation14wakeUpInternalEbb(HEAP32[i3 + 288 >> 2] | 0, 0, 1);
   STACKTOP = i5;
   return;
  }
 case 11:
  {
   i2 = i3 + 20 | 0;
   i3 = i2 + 4 | 0;
   switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
   case 3:
    {
     i1 = HEAP32[i2 >> 2] | 0;
     i4 = 13;
     break;
    }
   case 2:
    {
     i1 = HEAP32[i2 >> 2] | 0;
     if (!(HEAP8[i1 + 2433 >> 0] | 0)) i4 = 12; else i4 = 13;
     break;
    }
   default:
    i4 = 12;
   }
   if ((i4 | 0) == 12) {
    __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv(i2 + 12 | 0);
    STACKTOP = i5;
    return;
   } else if ((i4 | 0) == 13) {
    __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i2);
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 65536;
    STACKTOP = i5;
    return;
   }
   break;
  }
 case 12:
  {
   i2 = i3 + 20 | 0;
   i3 = i2 + 4 | 0;
   switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
   case 3:
    {
     i1 = HEAP32[i2 >> 2] | 0;
     i4 = 18;
     break;
    }
   case 2:
    {
     i1 = HEAP32[i2 >> 2] | 0;
     if (!(HEAP8[i1 + 2433 >> 0] | 0)) i4 = 17; else i4 = 18;
     break;
    }
   default:
    i4 = 17;
   }
   if ((i4 | 0) == 17) {
    __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv(i2 + 12 | 0);
    STACKTOP = i5;
    return;
   } else if ((i4 | 0) == 18) {
    __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i2);
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 65536;
    STACKTOP = i5;
    return;
   }
   break;
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 678666 | 0, 1785, gb + 707911 | 0, i1);
   STACKTOP = i5;
   return;
  }
 }
}

function __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN17CollisionMeshData8TransferI14SafeBinaryReadEEvRT_R4Mesh(i14, i4, i1) {
 i14 = i14 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 8 | 0;
 i15 = i13;
 i9 = i13 + 36 | 0;
 i12 = i13 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i15;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i15);
 i6 = i3;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i15;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i15);
 i15 = i3;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = i11;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 425997 | 0, i2, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i9, 0); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 426024 | 0, i2, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i12, 0); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i12 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = __Z11GetIPhysicsv() | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) HEAP32[i14 + 8 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 1, HEAP32[i9 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) HEAP32[i14 + 12 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 0, HEAP32[i12 >> 2] | 0, i1 | 0) | 0;
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = 0;
 }
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __Z11SkinGenericILi1ELb1ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0;
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 i8 = HEAP32[i1 + 44 >> 2] | 0;
 i9 = HEAP32[i1 + 60 >> 2] | 0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 while (1) {
  i25 = HEAP32[i1 >> 2] | 0;
  i10 = i2 + i5 | 0;
  f11 = Math_fround(HEAPF32[i6 + (i25 << 6) >> 2]);
  f17 = Math_fround(HEAPF32[i2 >> 2]);
  f16 = Math_fround(f11 * f17);
  f24 = Math_fround(HEAPF32[i6 + (i25 << 6) + 16 >> 2]);
  f20 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f24 * f20));
  f13 = Math_fround(HEAPF32[i6 + (i25 << 6) + 32 >> 2]);
  f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f16 = Math_fround(f16 + Math_fround(f13 * f14));
  f16 = Math_fround(Math_fround(HEAPF32[i6 + (i25 << 6) + 48 >> 2]) + f16);
  f23 = Math_fround(HEAPF32[i6 + (i25 << 6) + 4 >> 2]);
  f15 = Math_fround(f17 * f23);
  f22 = Math_fround(HEAPF32[i6 + (i25 << 6) + 20 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f20 * f22));
  f12 = Math_fround(HEAPF32[i6 + (i25 << 6) + 36 >> 2]);
  f15 = Math_fround(f15 + Math_fround(f14 * f12));
  f15 = Math_fround(Math_fround(HEAPF32[i6 + (i25 << 6) + 52 >> 2]) + f15);
  f21 = Math_fround(HEAPF32[i6 + (i25 << 6) + 8 >> 2]);
  f17 = Math_fround(f17 * f21);
  f19 = Math_fround(HEAPF32[i6 + (i25 << 6) + 24 >> 2]);
  f20 = Math_fround(f17 + Math_fround(f20 * f19));
  f17 = Math_fround(HEAPF32[i6 + (i25 << 6) + 40 >> 2]);
  f14 = Math_fround(f20 + Math_fround(f14 * f17));
  f14 = Math_fround(Math_fround(HEAPF32[i6 + (i25 << 6) + 56 >> 2]) + f14);
  f20 = Math_fround(HEAPF32[i10 >> 2]);
  f11 = Math_fround(f11 * f20);
  f18 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f24 = Math_fround(f11 + Math_fround(f24 * f18));
  f11 = Math_fround(HEAPF32[i10 + 8 >> 2]);
  f13 = Math_fround(f24 + Math_fround(f13 * f11));
  f12 = Math_fround(Math_fround(Math_fround(f23 * f20) + Math_fround(f22 * f18)) + Math_fround(f12 * f11));
  f11 = Math_fround(Math_fround(Math_fround(f21 * f20) + Math_fround(f19 * f18)) + Math_fround(f17 * f11));
  HEAPF32[i3 >> 2] = f16;
  HEAPF32[i3 + 4 >> 2] = f15;
  HEAPF32[i3 + 8 >> 2] = f14;
  i10 = i3 + i5 | 0;
  HEAPF32[i10 >> 2] = f13;
  HEAPF32[i10 + 4 >> 2] = f12;
  HEAPF32[i10 + 8 >> 2] = f11;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i9 | 0)) break; else {
   i2 = i2 + i7 | 0;
   i3 = i3 + i8 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN24PrepareSceneNodesJobDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 320 | 0;
 if ((HEAP32[i2 + 336 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 324 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 300 | 0;
 if ((HEAP32[i2 + 316 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 304 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 280 | 0;
 if ((HEAP32[i2 + 296 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 284 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 260 | 0;
 if ((HEAP32[i2 + 276 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 264 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 220 | 0;
 if ((HEAP32[i2 + 236 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 224 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 200 | 0;
 if ((HEAP32[i2 + 216 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 204 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 180 | 0;
 if ((HEAP32[i2 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 160 | 0;
 if ((HEAP32[i2 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 140 | 0;
 if ((HEAP32[i2 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 120 | 0;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z26CombineDepthNormalsTextureRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(HEAP32[gb + 1115128 >> 2] | 0)) {
  i1 = __Z15GetScriptMapperv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 387723 | 0, 35);
  i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  if (!i1) i1 = HEAP32[gb + 1115128 >> 2] | 0; else {
   i1 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
   HEAP32[gb + 1115128 >> 2] = i1;
  }
  if (!i1) {
   i4 = 0;
   STACKTOP = i3;
   return i4 | 0;
  }
 }
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, 0, 0, 0, 1, 0, 1) | 0;
 if (i1 | 0) {
  __ZN7Texture13SetFilterModeEi(i1, 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 387759 | 0);
 }
 i5 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 HEAPF32[i2 >> 2] = Math_fround(.5);
 HEAPF32[i2 + 4 >> 2] = Math_fround(.5);
 HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(1, i2, Math_fround(1.0), 0, i5);
 __Z15gpu_time_samplev();
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(i5, 0, i1, HEAP32[gb + 1115128 >> 2] | 0, 0, 0, -1, gb + 62472 | 0, gb + 1162356 | 0);
 __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(HEAP32[i4 + 1888 >> 2] | 0, 4, i1);
 if (!(HEAP8[gb + 1544229 >> 0] | 0)) {
  HEAP32[gb + 1115132 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115132 | 0, gb + 387779 | 0);
  HEAP8[gb + 1544229 >> 0] = 1;
 }
 if (!(HEAP8[gb + 1544230 >> 0] | 0)) {
  HEAP32[gb + 1115136 >> 2] = -1;
  __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1115136 | 0, gb + 387806 | 0);
  HEAP8[gb + 1544230 >> 0] = 1;
 }
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, gb + 1115132 | 0, i1);
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, gb + 1115136 | 0, i1);
 i5 = i1;
 STACKTOP = i3;
 return i5 | 0;
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i4 + 16 | 0;
 i20 = i4;
 i22 = HEAP32[i3 + 4 >> 2] | 0;
 i19 = HEAP32[i3 + 8 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f9 * Math_fround(HEAPF32[i19 >> 2]));
 i16 = i19 + 4 | 0;
 f10 = Math_fround(f10 + Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2])));
 i13 = i19 + 8 | 0;
 f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2])));
 i18 = i19 + 16 | 0;
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2]));
 i15 = i19 + 20 | 0;
 f11 = Math_fround(f11 + Math_fround(f12 * Math_fround(HEAPF32[i15 >> 2])));
 i2 = i19 + 24 | 0;
 f11 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i2 >> 2])));
 i17 = i19 + 32 | 0;
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i17 >> 2]));
 i14 = i19 + 36 | 0;
 f12 = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i14 >> 2])));
 i3 = i19 + 40 | 0;
 f8 = Math_fround(f12 + Math_fround(f8 * Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i21 >> 2] = f10;
 HEAPF32[i21 + 4 >> 2] = f11;
 HEAPF32[i21 + 8 >> 2] = f8;
 HEAPF32[i21 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i20, i22, i21);
 f8 = Math_fround(HEAPF32[i19 + 48 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 56 >> 2]);
 f12 = Math_fround(HEAPF32[i20 >> 2]);
 f9 = Math_fround(HEAPF32[i20 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 f7 = Math_fround(f12 * Math_fround(HEAPF32[i19 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i18 >> 2])));
 f7 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i17 >> 2])));
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i16 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i15 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i14 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i13 >> 2]));
 f9 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i2 >> 2])));
 f6 = Math_fround(f11 + f6);
 f5 = Math_fround(f10 + Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]))));
 HEAPF32[i1 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i10 = i1 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   i1 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 20 | 0) + i2 | 0;
 if (i6 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 20 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 107374182 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 214748364;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 20 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 20 | 0) * 20 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 20 | 0);
 do {
  i7 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i1 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i8, i10);
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i9 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx17PxsFluidCollision15updateCollisionEPKhRNS_10PxBaseTaskE(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i11 + 452 | 0;
 HEAP32[i11 + 468 >> 2] = 1;
 i9 = i11 + 464 | 0;
 HEAP32[i9 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 HEAP32[i11 + 460 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2];
 i9 = i11 + 96 | 0;
 i7 = (HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0) >>> 3;
 i8 = i2 + (HEAP32[i2 + 4 >> 2] | 0) | 0;
 i5 = i2 + 8 | 0;
 i6 = 0;
 i2 = 0;
 i7 = i7 >>> 0 < 128 ? 128 : i7;
 while (1) {
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 20 >> 2] = 2122317823;
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 24 >> 2] = 2122317823;
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 28 >> 2] = 2122317823;
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 32 >> 2] = -25165825;
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 36 >> 2] = -25165825;
  HEAP32[i11 + 100 + (i6 * 44 | 0) + 40 >> 2] = -25165825;
  i7 = (i6 | 0) == 7 ? -1 : i7;
  if (!i7) i1 = i5; else {
   i1 = i5;
   i3 = 0;
   while (1) {
    i4 = i1;
    if ((i4 | 0) == (i8 | 0)) break;
    i4 = i4 + (HEAP32[i4 + 4 >> 2] << 4 | 8) | 0;
    i3 = (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0) + 8 >> 2] | 0) + i3 | 0;
    if (i3 >>> 0 < i7 >>> 0) i1 = i4; else {
     i1 = i4;
     break;
    }
   }
   if (i3) {
    HEAP32[i11 + 100 + (i6 * 44 | 0) + 12 >> 2] = i5;
    HEAP32[i11 + 100 + (i6 * 44 | 0) + 16 >> 2] = i1;
    i2 = i2 + 1 | 0;
   }
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 8) break; else i5 = i1;
 }
 if (!i2) {
  i11 = HEAP32[i10 >> 2] | 0;
  i11 = i11 + 20 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vi(i11 | 0, i10 | 0);
  return;
 }
 i1 = 0;
 do {
  i7 = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0) + 6960 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
  i8 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i7, 28, 16) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
  HEAP16[i8 + 4 >> 1] = -1;
  HEAP16[i8 + 6 >> 1] = 0;
  i7 = i8 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = gb + 87404 + 8;
  i6 = i8 + 12 | 0;
  HEAP32[i6 >> 2] = 0;
  i5 = i8 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i8 >> 2] = gb + 147432 + 8;
  HEAP32[i8 + 20 >> 2] = i11;
  HEAP32[i8 + 24 >> 2] = i1;
  HEAP32[i5 >> 2] = 1;
  HEAP32[i6 >> 2] = i10;
  mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
  HEAP32[i7 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = i11 + 20 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vi(i11 | 0, i10 | 0);
 return;
}

function __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN15Cast2DQueryBase18ReportFixtureProxyEPK14b2FixtureProxy(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (HEAP8[i2 + 58 >> 0] | 0) if (!(HEAP8[(__Z21GetManagerFromContexti(16) | 0) + 92 >> 0] | 0)) {
  STACKTOP = i11;
  return 1;
 }
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i8 + 360 >> 2] | 0)) {
  STACKTOP = i11;
  return 1;
 }
 if ((HEAP32[i2 + 28 >> 2] | 0) == (HEAP32[i8 + 364 >> 2] | 0)) {
  STACKTOP = i11;
  return 1;
 }
 if (!i1) {
  STACKTOP = i11;
  return 1;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return 1;
 }
 if (!(1 << HEAP32[i1 + 48 >> 2] & HEAP32[i8 + 24 >> 2])) {
  STACKTOP = i11;
  return 1;
 }
 f12 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 32 >> 2]);
 __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0);
 f13 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 if (!(!(f13 > f14) & !(f13 < f12))) {
  STACKTOP = i11;
  return 1;
 }
 i2 = i10 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 i2 = i8 + 340 | 0;
 i3 = i8 + 352 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i9 + 1 | 0;
 i5 = i8 + 356 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 92 | 0, 4, i8 + 344 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 92 | 0, 4, i8 + 344 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 92 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i4;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + (i9 * 92 | 0) | 0;
 i1 = i10;
 i2 = i4 + 84 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAPF32[i3 + (i9 * 92 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
 STACKTOP = i11;
 return 1;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 48 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 48 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 48 | 0) + i2 | 0;
 if (i5 >>> 0 > 89478485) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 48 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 44739242 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 89478485;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 48 | 0) | 0;
 i7 = i5 + (((i1 - i4 | 0) / 48 | 0) * 48 | 0) | 0;
 i6 = i7;
 i3 = i5 + (i3 * 48 | 0) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i5 = i1 + 20 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  i1 = i8 + 48 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -48 | 0;
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2 + -48 | 0, i1);
   i2 = i3 + -48 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -48 | 0;
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i5 = i11 + 56 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i5 >> 2] = i14;
 i4 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 i1 = i4;
 while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
 i2 = i1 - i4 | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 if (i2 >>> 0 < 12) {
  HEAP32[i3 >> 2] = 7340037;
  HEAP8[i14 + 11 >> 0] = 11 - i2;
  i1 = i14;
 } else {
  HEAP32[i3 >> 2] = 3145733;
  HEAP32[i14 + 4 >> 2] = i2;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i14 >> 2] = i1;
 }
 _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 if (HEAP32[i5 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i6, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i5 >> 2] = i6;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_15PsMatTransformVE(i1, i20, i18, i19) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, i26 = 0, i27 = 0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i17 = i1 + 32 | 0;
 if (!(HEAP8[i17 >> 0] | 0)) {
  i19 = 0;
  i20 = i20 + 4096 | 0;
  HEAP32[i20 >> 2] = i19;
  return;
 }
 i9 = i1 + 44 | 0;
 i10 = i19 + 48 | 0;
 i11 = i19 + 52 | 0;
 i12 = i19 + 56 | 0;
 i13 = i19 + 16 | 0;
 i14 = i19 + 32 | 0;
 i15 = i19 + 4 | 0;
 i2 = i19 + 20 | 0;
 i3 = i19 + 36 | 0;
 i4 = i19 + 8 | 0;
 i5 = i19 + 24 | 0;
 i6 = i19 + 40 | 0;
 i7 = i18 + 4 | 0;
 i8 = i18 + 8 | 0;
 i16 = 0;
 while (1) {
  i21 = HEAP32[i9 >> 2] | 0;
  f31 = Math_fround(HEAPF32[i10 >> 2]);
  f30 = Math_fround(HEAPF32[i11 >> 2]);
  f29 = Math_fround(HEAPF32[i12 >> 2]);
  f32 = Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 16 >> 2]);
  f28 = Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 20 >> 2]);
  f23 = Math_fround(HEAPF32[i21 + (i16 * 48 | 0) + 24 >> 2]);
  f25 = Math_fround(f32 * Math_fround(HEAPF32[i19 >> 2]));
  f25 = Math_fround(f25 + Math_fround(f28 * Math_fround(HEAPF32[i13 >> 2])));
  f25 = Math_fround(f25 + Math_fround(f23 * Math_fround(HEAPF32[i14 >> 2])));
  f24 = Math_fround(f32 * Math_fround(HEAPF32[i15 >> 2]));
  f24 = Math_fround(f24 + Math_fround(f28 * Math_fround(HEAPF32[i2 >> 2])));
  f24 = Math_fround(f24 + Math_fround(f23 * Math_fround(HEAPF32[i3 >> 2])));
  f32 = Math_fround(f32 * Math_fround(HEAPF32[i4 >> 2]));
  f28 = Math_fround(f32 + Math_fround(f28 * Math_fround(HEAPF32[i5 >> 2])));
  f25 = Math_fround(f31 + f25);
  f24 = Math_fround(f30 + f24);
  f23 = Math_fround(f29 + Math_fround(f28 + Math_fround(f23 * Math_fround(HEAPF32[i6 >> 2]))));
  i21 = HEAP32[i21 + (i16 * 48 | 0) + 44 >> 2] | 0;
  i1 = i16 + 1 | 0;
  i27 = HEAP32[i7 >> 2] | 0;
  i26 = HEAP32[i8 >> 2] | 0;
  i22 = i20 + (i16 << 6) | 0;
  HEAP32[i22 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i22 + 4 >> 2] = i27;
  HEAP32[i22 + 8 >> 2] = i26;
  HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
  i22 = i20 + (i16 << 6) + 16 | 0;
  HEAPF32[i22 >> 2] = f25;
  HEAPF32[i22 + 4 >> 2] = f24;
  HEAPF32[i22 + 8 >> 2] = f23;
  HEAPF32[i22 + 12 >> 2] = Math_fround(0.0);
  HEAP32[i20 + (i16 << 6) + 12 >> 2] = i21;
  HEAP32[i20 + (i16 << 6) + 48 >> 2] = -1;
  HEAP32[i20 + (i16 << 6) + 52 >> 2] = -1;
  if (i1 >>> 0 < 64 & i1 >>> 0 < (HEAPU8[i17 >> 0] | 0) >>> 0) i16 = i1; else break;
 }
 i27 = i20 + 4096 | 0;
 HEAP32[i27 >> 2] = i1;
 return;
}

function __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i3 = i5 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i3 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 28 | 0;
 i3 = i4 + 2 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i4 >> 1] | 0;
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 30 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 31 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 }
}

function __ZN5physx6shdfnd8internal11HashMapBaseINS0_4PairIjjEEN12_GLOBAL__N_14EdgeENS0_4HashIS4_EENS0_9AllocatorEEixERKS4_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i7 = (i9 | 0) == 0;
 L1 : do if (i7) i2 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = i5 + ~(i5 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i2 = i4 + ~(i4 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = (i1 >>> 16 ^ i1 ^ (i2 ^ -57320555 ^ i2 >>> 16) * 1000007) & i9 + -1;
  i1 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i6 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i6 + (i1 * 20 | 0) + 4 >> 2] | 0) == (i5 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   i11 = i6 + (i1 * 20 | 0) | 0;
   i11 = i11 + 8 | 0;
   return i11 | 0;
  }
 } while (0);
 i4 = i11 + 36 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEEN12_GLOBAL__N_14EdgeEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i2 = HEAP32[i10 >> 2] | 0;
  i9 = i10 + 4 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i2 = i2 + ~(i2 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = (i3 >>> 16 ^ i3 ^ (i2 ^ -57320555 ^ i2 >>> 16) * 1000007) & i1 + -1;
  i3 = i10;
  i1 = i9;
 } else {
  i3 = i10;
  i1 = i10 + 4 | 0;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = HEAP32[i11 + 4 >> 2] | 0;
 i11 = i9 + (i10 * 20 | 0) | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i10 * 20 | 0) + 4 >> 2] = i8;
 HEAPF32[i9 + (i10 * 20 | 0) + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + (i10 * 20 | 0) + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + (i10 * 20 | 0) + 16 >> 2] = Math_fround(0.0);
 i11 = i11 + 8 | 0;
 return i11 | 0;
}

function __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i7, i6, i1, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i9 = i12 + 16 | 0;
 i10 = i12 + 4 | 0;
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i1);
 i1 = HEAP8[i7 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = i1 & 255;
  i1 = i7;
 }
 if (!i2) i1 = -1; else {
  i4 = i1 + i2 | 0;
  i3 = i4;
  i5 = i1;
  L7 : do if ((i2 | 0) < 1) i1 = i3; else while (1) {
   if ((HEAP8[i1 >> 0] | 0) == 63) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i3;
    break L7;
   }
  } while (0);
  i1 = (i1 | 0) == (i4 | 0) ? -1 : i1 - i5 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i7, 0, i1, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if (HEAP8[i6 >> 0] | 0) {
  i2 = __Z17GetPlayerSettingsv() | 0;
  i1 = i2 + 524 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 528 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i4, i1);
  i6 = HEAP8[i9 + 11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i5 ? HEAP32[i9 >> 2] | 0 : i9, i5 ? HEAP32[i9 + 4 >> 2] | 0 : i6 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 }
 i6 = i8;
 if ((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i6 + 4 >> 2] | 0) == 0) {
  i6 = i8 + 8 | 0;
  if ((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i6 + 4 >> 2] | 0) == 0) {
   STACKTOP = i12;
   return;
  }
 }
 __Z15Hash128ToStringRK7Hash128(i10, i8);
 HEAP32[i11 >> 2] = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 __Z6FormatPKcz(i9, gb + 1074693 | 0, i11);
 i11 = HEAP8[i9 + 11 >> 0] | 0;
 i8 = i11 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i8 ? HEAP32[i9 >> 2] | 0 : i9, i8 ? HEAP32[i9 + 4 >> 2] | 0 : i11 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i12;
 return;
}

function __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN13TriggerModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 28 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 32 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 40 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 44 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 48 | 0, i1);
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __Z29AddCanvasIntermediateRendererPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS3_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModebP6Camera(i1, i2, i7, i8, i9, i10, i11, i12, i13, i14, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i15;
 i17 = i15 + 8 | 0;
 i6 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1110384 >> 2] | 0, 320) | 0;
 HEAP16[i6 + 184 >> 1] = 0;
 HEAP16[i6 + 186 >> 1] = 0;
 HEAP32[i6 + 188 >> 2] = -2147450880;
 HEAP32[i6 + 192 >> 2] = 0;
 i19 = i6 + 236 | 0;
 i20 = (HEAPU16[i19 >> 1] | 0 | (HEAPU8[i19 + 2 >> 0] | 0) << 16) & 16515072 | 1353;
 HEAP16[i19 >> 1] = i20;
 HEAP8[i19 + 2 >> 0] = i20 >>> 16;
 HEAP16[i6 + 230 >> 1] = -1;
 HEAP16[i6 + 228 >> 1] = -1;
 HEAPF32[i6 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i6 + 232 >> 2] = -1;
 HEAP8[i6 + 240 >> 0] = 1;
 HEAP8[i6 + 241 >> 0] = 1;
 i19 = i6 + 244 | 0;
 i20 = i6 + 264 | 0;
 HEAP32[i19 >> 2] = 0;
 HEAP32[i19 + 4 >> 2] = 0;
 HEAP32[i19 + 8 >> 2] = 0;
 HEAP32[i19 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 33700 + 8;
 HEAP32[i20 >> 2] = gb + 33700 + 80;
 HEAP32[i6 + 268 >> 2] = 0;
 HEAP32[i6 + 272 >> 2] = 0;
 HEAP32[i6 + 276 >> 2] = i20;
 HEAP32[i6 + 280 >> 2] = 0;
 HEAP32[i6 + 284 >> 2] = 0;
 HEAP32[i6 + 300 >> 2] = 0;
 HEAP32[i6 + 312 >> 2] = 0;
 HEAP32[i6 + 316 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, gb + 63664 | 0);
 i20 = i16;
 i19 = HEAP32[i20 + 4 >> 2] | 0;
 i18 = i6 + 304 | 0;
 HEAP32[i18 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 + 4 >> 2] = i19;
 HEAP32[i17 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 __ZN31CanvasBatchIntermediateRenderer10InitializeEPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS4_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i6, i1, i2, i7, i8, i9, i10, i11, i12, i16, i14, i3, i4);
 if (!i5) {
  i20 = __Z16GetRendererScenev() | 0;
  __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i20, i6);
  STACKTOP = i15;
  return i6 | 0;
 } else {
  i20 = HEAP32[i5 + 1132 >> 2] | 0;
  __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i20, i6);
  STACKTOP = i15;
  return i6 | 0;
 }
 return 0;
}

function __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN2UI14CanvasRenderer12SyncMaterialENS0_8SyncFlagE(i15, i5) {
 i15 = i15 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (i5 & 1 | 0) {
  i7 = HEAP32[i15 + 204 >> 2] | 0;
  i6 = i7 + 112 | 0;
  HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 0 | 2;
  i6 = HEAP32[i15 + 208 >> 2] | 0;
  i7 = HEAP32[i7 + 84 >> 2] | 0;
  i8 = HEAP32[i15 + 136 >> 2] | 0;
  i9 = HEAP32[i15 + 140 >> 2] | 0;
  i10 = HEAP32[i15 + 144 >> 2] | 0;
  i11 = HEAP32[i15 + 148 >> 2] | 0;
  i12 = HEAP32[i15 + 152 >> 2] | 0;
  i13 = HEAP32[i15 + 156 >> 2] | 0;
  i14 = HEAP8[i15 + 160 >> 0] | 0;
  i3 = i15 + 108 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
   i4 = HEAP32[i15 + 96 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i7 + (i6 * 672 | 0) + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) < 8 & i2 >>> 0 < i1 >>> 0);
  }
  i4 = HEAP32[i15 + 88 >> 2] | 0;
  i4 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
  HEAP32[i7 + (i6 * 672 | 0) + 448 >> 2] = (i4 | 0) > 8 ? 8 : i4;
  HEAP32[i7 + (i6 * 672 | 0) + 452 >> 2] = i8;
  HEAP32[i7 + (i6 * 672 | 0) + 456 >> 2] = i9;
  HEAP32[i7 + (i6 * 672 | 0) + 460 >> 2] = i10;
  HEAP32[i7 + (i6 * 672 | 0) + 464 >> 2] = i11;
  HEAP32[i7 + (i6 * 672 | 0) + 468 >> 2] = i12;
  HEAP32[i7 + (i6 * 672 | 0) + 472 >> 2] = i13;
  HEAP8[i7 + (i6 * 672 | 0) + 666 >> 0] = i14;
  HEAP16[i7 + (i6 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!(i5 & 2)) return;
 i6 = HEAP32[i15 + 220 >> 2] | 0;
 i5 = i6 + 112 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 2;
 i5 = HEAP32[i15 + 224 >> 2] | 0;
 i6 = HEAP32[i6 + 84 >> 2] | 0;
 i7 = HEAP32[i15 + 136 >> 2] | 0;
 i8 = HEAP32[i15 + 140 >> 2] | 0;
 i9 = HEAP32[i15 + 144 >> 2] | 0;
 i10 = HEAP32[i15 + 148 >> 2] | 0;
 i11 = HEAP32[i15 + 152 >> 2] | 0;
 i12 = HEAP32[i15 + 156 >> 2] | 0;
 i13 = HEAP8[i15 + 160 >> 0] | 0;
 i3 = i15 + 128 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i4 = HEAP32[i15 + 116 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i6 + (i5 * 672 | 0) + (i2 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) < 8 & i2 >>> 0 < i1 >>> 0);
 }
 i15 = HEAP32[i15 + 88 >> 2] | 0;
 i15 = i15 >>> 0 < i1 >>> 0 ? i15 : i1;
 HEAP32[i6 + (i5 * 672 | 0) + 448 >> 2] = (i15 | 0) > 8 ? 8 : i15;
 HEAP32[i6 + (i5 * 672 | 0) + 452 >> 2] = i7;
 HEAP32[i6 + (i5 * 672 | 0) + 456 >> 2] = i8;
 HEAP32[i6 + (i5 * 672 | 0) + 460 >> 2] = i9;
 HEAP32[i6 + (i5 * 672 | 0) + 464 >> 2] = i10;
 HEAP32[i6 + (i5 * 672 | 0) + 468 >> 2] = i11;
 HEAP32[i6 + (i5 * 672 | 0) + 472 >> 2] = i12;
 HEAP8[i6 + (i5 * 672 | 0) + 666 >> 0] = i13;
 HEAP16[i6 + (i5 * 672 | 0) + 664 >> 1] = 2;
 return;
}

function __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i6 = i10;
 i9 = i6 + 8 | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i7 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  i7 = i8;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i3;
  }
  HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 8);
   i4 = i8 + 4 | 0;
   i1 = i8;
   i2 = i4;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
  } else {
   i4 = i3;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i8;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   i1 = i8;
   i2 = i8 + 4 | 0;
  }
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  i5 = i8;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 8 | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i10 = i6 + 16 | 0;
 HEAP32[i6 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(inf);
 HEAP32[i6 + 40 >> 2] = 0;
 i10 = i6 + 48 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAPF32[i6 + 72 >> 2] = Math_fround(inf);
 HEAP32[i6 + 68 >> 2] = 0;
 i10 = i6 + 76 | 0;
 HEAP32[i6 + 108 >> 2] = 0;
 i8 = i6 + 112 | 0;
 HEAP32[i8 >> 2] = 0;
 i3 = i6 + 100 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i6 + 120 >> 2] = 2;
 HEAP32[i6 + 116 >> 2] = 2;
 HEAP32[i6 + 124 >> 2] = 4;
 HEAP32[i6 + 128 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899368 | 0, i6, 0);
 __ZN13AnimationClip10FloatCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i6 + 96 | 0;
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i6 + 28 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 STACKTOP = i7;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj16EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i11 + 64 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i3) | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i7 = i12 + 8 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i4 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
 }
 __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy(i4, i2, i10, 1);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 6) | 0;
 do if (HEAP32[i3 >> 2] | 0) {
  i8 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034429 | 0, 0, 1) | 0;
  i5 = i12 + 80 | 0;
  i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i5 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i7 = i12 + 84 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  if ((i8 | 0) == 2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i8 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L11 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i6) | 0) + i8 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 64 | 0;
     if ((i1 | 0) == (i9 | 0)) break L11;
     i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, gb + 1034429 | 0, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN4FMOD8ChannelI11setPositionEjj(i9, i1, i3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i4 = i10;
 switch (i3 | 0) {
 case 2:
  break;
 case 1:
  {
   i1 = ~~Math_fround(Math_fround(i1 >>> 0) * Math_fround(44.0999985)) >>> 0;
   break;
  }
 default:
  {
   HEAP32[i4 >> 2] = gb + 859510;
   HEAP32[i4 + 4 >> 2] = 917;
   _printf(gb + 854600 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 37;
   HEAP32[i5 + 4 >> 2] = gb + 859510;
   _printf(gb + 853277 | 0, i5) | 0;
   i9 = 37;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i3 = i9 + 128 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d2 = +__Z19GetTimeSinceStartupv() * 44100.0;
 i6 = ~~d2 >>> 0;
 i7 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 f12 = Math_fround(+(i6 >>> 0) + 4294967296.0 * +(i7 >>> 0));
 f11 = Math_fround((0 > i3 >>> 0 | 0 == (i3 | 0) & i1 >>> 0 > i8 >>> 0 ? i8 : i1) >>> 0);
 i1 = i9 + 140 | 0;
 f12 = Math_fround(f12 - Math_fround(f11 * Math_fround(Math_fround(44100.0) / Math_fround(HEAPF32[i1 >> 2]))));
 i8 = +Math_abs(+f12) >= 1.0 ? (+f12 > 0.0 ? ~~+Math_min(+Math_floor(+f12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f12 - +(~~+f12 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i3 = i9 + 104 | 0;
 HEAP32[i3 >> 2] = ~~+f12 >>> 0;
 HEAP32[i3 + 4 >> 2] = i8;
 i3 = i9 + 64 | 0;
 i8 = i9 + 164 | 0;
 _JS_Sound_Play(HEAP32[(HEAP32[i3 >> 2] | 0) + 320 >> 2] | 0, HEAP32[i8 >> 2] | 0, +(+Math_fround(f11 / Math_fround(44100.0))), 0.0);
 i5 = i9 + 112 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 if (i5 >>> 0 > i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 > i6 >>> 0) {
  i13 = HEAP32[i8 >> 2] | 0;
  i7 = _i64Subtract(i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
  _JS_Sound_Stop(i13 | 0, +(+Math_fround(Math_fround(+(i7 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) / Math_fround(44100.0))));
 }
 i13 = HEAP32[i3 >> 2] | 0;
 _JS_Sound_SetLoopPoints(HEAP32[i8 >> 2] | 0, +(+HEAPF64[i13 + 328 >> 3]), +(+HEAPF64[i13 + 336 >> 3]));
 if (!(HEAP8[i9 + 161 >> 0] | 0)) {
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  d2 = +Math_fround(Math_fround(f12 * Math_fround(HEAPF32[i9 + 152 >> 2])) / Math_fround(44100.0));
 } else d2 = 1.0e-07;
 _JS_Sound_SetPitch(HEAP32[i8 >> 2] | 0, +d2);
 i1 = HEAP32[i9 + 72 >> 2] | 0;
 if (!(i1 & 3)) {
  i13 = 0;
  STACKTOP = i10;
  return i13 | 0;
 }
 _JS_Sound_SetLoop(HEAP32[i8 >> 2] | 0, (i1 & 2 | 0) != 0 | 0);
 i13 = 0;
 STACKTOP = i10;
 return i13 | 0;
}

function __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, f20 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 4 | 0;
 i18 = i19;
 i2 = HEAP32[i16 >> 2] | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i13 - i2 | 0;
 if (!i1) i3 = i2; else {
  i8 = HEAP32[i17 >> 2] | 0;
  i9 = i17 + 40 | 0;
  i10 = i17 + 44 | 0;
  i11 = i17 + 48 | 0;
  i1 = (i1 | 0) / 60 | 0;
  i3 = i2;
  do {
   i6 = (i1 | 0) / 2 | 0;
   i7 = i2 + (i6 * 60 | 0) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   do if ((i4 | 0) == (i8 | 0)) {
    i4 = HEAP32[i2 + (i6 * 60 | 0) + 40 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) {
     i12 = 11;
     break;
    } else {
     i1 = i6;
     break;
    }
    i4 = HEAP32[i2 + (i6 * 60 | 0) + 44 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) == (i5 | 0)) {
     f20 = Math_fround(HEAPF32[i2 + (i6 * 60 | 0) + 48 >> 2]);
     if (f20 < Math_fround(HEAPF32[i11 >> 2])) {
      i12 = 11;
      break;
     } else {
      i1 = i6;
      break;
     }
    } else if (i5 >>> 0 < i4 >>> 0) {
     i12 = 11;
     break;
    } else {
     i1 = i6;
     break;
    }
   } else if (i4 >>> 0 < i8 >>> 0) i12 = 11; else i1 = i6; while (0);
   if ((i12 | 0) == 11) {
    i12 = 0;
    i2 = i7 + 60 | 0;
    i1 = i1 + -1 - i6 | 0;
    i3 = i2;
   }
  } while ((i1 | 0) != 0);
 }
 i4 = i3;
 L18 : do if ((i3 | 0) != (i13 | 0)) {
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i1 = HEAP32[i17 + 40 >> 2] | 0;
   i2 = HEAP32[i3 + 40 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) if ((i1 | 0) < (i2 | 0)) break L18; else break;
   i1 = HEAP32[i17 + 44 >> 2] | 0;
   i2 = HEAP32[i3 + 44 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    f20 = Math_fround(HEAPF32[i17 + 48 >> 2]);
    if (f20 < Math_fround(HEAPF32[i3 + 48 >> 2])) break L18; else break;
   } else if (i2 >>> 0 < i1 >>> 0) break L18; else break;
  } else if (i1 >>> 0 < i2 >>> 0) break L18; while (0);
  HEAP32[i15 >> 2] = i4;
  HEAP8[i15 + 4 >> 0] = 0;
  STACKTOP = i19;
  return;
 } while (0);
 HEAP32[i18 >> 2] = i4;
 HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 >> 2] = __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i16, i14, i17) | 0;
 HEAP8[i15 + 4 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __Z9SetLocalR15TransformAccessRKN4math7_float4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i10 = i1;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i10 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 * f15);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f14 * f14);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(f13 * f13);
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f12 = Math_fround(Math_fround(f17 + f3) + Math_fround(f12 + Math_fround(f16 * f16)));
 f3 = Math_fround(Math_sqrt(Math_fround(f12)));
 f15 = Math_fround(f15 / f3);
 f14 = Math_fround(f14 / f3);
 f13 = Math_fround(f13 / f3);
 f3 = Math_fround(f16 / f3);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f15, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i9 = f12 > Math_fround(1.0e-30);
 i1 = i9 ? i1 : 0;
 i2 = i9 ? i2 : 0;
 i4 = i9 ? i4 : 0;
 i7 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 i19 = i5 + (i11 * 40 | 0) + 12 | 0;
 f17 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f17 != Math_fround(HEAPF32[i19 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i18 = i5 + (i11 * 40 | 0) + 16 | 0;
 i20 = f17 != Math_fround(HEAPF32[i18 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i5 + (i11 * 40 | 0) + 20 | 0;
 i21 = f17 != Math_fround(HEAPF32[i6 >> 2]);
 f17 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i8 = i5 + (i11 * 40 | 0) + 24 | 0;
 i9 = f17 != Math_fround(HEAPF32[i8 >> 2]) | (i21 | (i20 | i9));
 HEAP32[i19 >> 2] = i1;
 HEAP32[i18 >> 2] = i2;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i8 >> 2] = i7;
 if (!i9) {
  i21 = 0;
  return i21 | 0;
 }
 i5 = HEAP32[i10 + 44 >> 2] | HEAP32[i10 + 40 >> 2];
 i6 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i11 << 2) >> 2] | 0;
 if (!i6) {
  i21 = 1;
  return i21 | 0;
 }
 i7 = HEAP32[i10 + 60 >> 2] | 0;
 i8 = HEAP32[i10 + 56 >> 2] | 0;
 i9 = i10 + 36 | 0;
 i4 = HEAP32[i10 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i11;
 while (1) {
  i21 = HEAP32[i7 + (i1 << 2) >> 2] & i5;
  i20 = i8 + (i1 << 2) | 0;
  HEAP32[i20 >> 2] = HEAP32[i20 >> 2] | i21;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i21;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
 }
 return i1 | 0;
}

function __ZN9Rigidbody17AddRelativeTorqueERK8Vector3fi(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 28 | 0;
 i7 = i9;
 if (!(HEAP8[i2 + 80 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 i15 = f16 < Math_fround(0.0);
 f17 = Math_fround(-f16);
 i5 = i4 + 4 | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 i12 = f13 < Math_fround(0.0);
 f14 = Math_fround(-f13);
 i6 = i4 + 8 | 0;
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i3 = f10 < Math_fround(0.0);
 f11 = Math_fround(-f10);
 i15 = (i15 ? f17 : f16) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
 i12 = i15 & (i12 ? f14 : f13) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 if (i12 & (i3 ? f11 : f10) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
  STACKTOP = i9;
  return;
 }
 i2 = i2 + 52 | 0;
 i15 = HEAP32[i2 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 200 >> 2] | 0, i15 | 0) | 0) & 1) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i2 | 0);
 f20 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f20 = Math_fround(f20 * Math_fround(2.0));
 f13 = Math_fround(f13 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(2.0));
 f18 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f19 = Math_fround(Math_fround(f18 * f18) + Math_fround(-.5));
 f22 = Math_fround(HEAPF32[i7 >> 2]);
 f21 = Math_fround(f20 * f22);
 f11 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f13 * f11));
 f14 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f21 = Math_fround(f21 + Math_fround(f10 * f14));
 f16 = Math_fround(Math_fround(f11 * f21) + Math_fround(Math_fround(f13 * f19) + Math_fround(f18 * Math_fround(Math_fround(f20 * f14) - Math_fround(f10 * f22)))));
 f17 = Math_fround(Math_fround(Math_fround(f10 * f19) + Math_fround(f18 * Math_fround(Math_fround(f13 * f22) - Math_fround(f20 * f11)))) + Math_fround(f14 * f21));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(f22 * f21) + Math_fround(Math_fround(f20 * f19) + Math_fround(f18 * Math_fround(Math_fround(f10 * f11) - Math_fround(f13 * f14)))));
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f17;
 switch (i1 | 0) {
 case 5:
  {
   i1 = 3;
   break;
  }
 case 1:
  break;
 case 2:
  break;
 default:
  i1 = 0;
 }
 mftCall_viiii(i3 | 0, i2 | 0, i8 | 0, i1 | 0, 1);
 STACKTOP = i9;
 return;
}

function __ZN6Camera21SetScreenViewportRectERK5RectTIfE(i13, i3) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 16 | 0;
 i4 = i14;
 __ZL19GetCameraTargetRectRK6Camerab(i4, i13, 1);
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f2 - f5);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i4 + 4 >> 2]));
 f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 if (f2 > Math_fround(0.0)) {
  f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  if (f1 > Math_fround(0.0)) {
   f15 = Math_fround(Math_fround(1.0) / f2);
   f1 = Math_fround(Math_fround(1.0) / f1);
   f2 = Math_fround(f5 * f15);
   f5 = Math_fround(f9 * f15);
   f9 = Math_fround(f10 * f1);
   f1 = Math_fround(f11 * f1);
  } else {
   f2 = Math_fround(0.0);
   f5 = Math_fround(0.0);
   f9 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
 } else {
  f2 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 i8 = i13 + 864 | 0;
 HEAPF32[i8 >> 2] = f2;
 i6 = i13 + 868 | 0;
 HEAPF32[i6 >> 2] = f1;
 i4 = i13 + 872 | 0;
 HEAPF32[i4 >> 2] = f5;
 i3 = i13 + 876 | 0;
 HEAPF32[i3 >> 2] = f9;
 i7 = i13 + 1086 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i12, i13, 1);
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f1 = Math_fround(f1 * f16);
 f5 = Math_fround(f5 * f16);
 f2 = Math_fround(f2 * f10);
 f11 = Math_fround(f11 * f10);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f1 = Math_fround(f1 + f9);
 f2 = Math_fround(f2 + f15);
 f5 = Math_fround(f5 + f1);
 f11 = Math_fround(f11 + f2);
 f16 = Math_fround(f16 + f9);
 f10 = Math_fround(f10 + f15);
 f1 = Math_fround((f5 > f16 ? f16 : f5) - (f1 < f9 ? f9 : f1));
 f2 = Math_fround((f11 > f10 ? f10 : f11) - (f2 < f15 ? f15 : f2));
 i12 = f2 < Math_fround(0.0);
 f2 = i12 ? Math_fround(0.0) : f2;
 if (f2 != Math_fround(0.0)) {
  i12 = f1 < Math_fround(0.0);
  f1 = Math_fround((i12 ? Math_fround(0.0) : f1) / f2);
 } else f1 = Math_fround(1.0);
 HEAPF32[i13 + 1060 >> 2] = f1;
 HEAP8[i13 + 1077 >> 0] = 1;
 HEAP8[i13 + 1079 >> 0] = 1;
 HEAP8[i13 + 1078 >> 0] = 1;
 HEAP8[i7 >> 0] = 1;
 STACKTOP = i14;
 return;
}

function __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 48 | 0;
 i8 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i10 = i11;
 i4 = i5 + 68 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i10);
 i3 = i9 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i9);
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i4, i7, i8) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(32) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i8);
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 72 >> 2] | 0, i2);
  i2 = i5 + 76 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = 0;
 } else i2 = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (i2) {
  STACKTOP = i11;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 444372 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i7, i6, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i10 = __ZnwjRK10MemLabelIdiPKci(1060, gb + 63552 | 0, 16, gb + 444242 | 0, 446) | 0;
 __ZN15FileSystemEntryC2EPKc(i10, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7);
 __ZN15FileSystemEntry12CreateAsFileEv(i10) | 0;
 __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i10, 2, 0) | 0;
 HEAP32[i1 + 28 >> 2] = i10;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i11;
 return;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = i1 + 4 | 0;
 i2 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i21 | 0)) return;
 i15 = HEAP32[i1 >> 2] | 0;
 i10 = i15 + 36 | 0;
 i17 = HEAP8[i10 + 11 >> 0] | 0;
 i16 = i17 << 24 >> 24 < 0;
 i17 = i17 & 255;
 i18 = i16 ? HEAP32[i15 + 40 >> 2] | 0 : i17;
 i19 = (i18 | 0) == 0;
 i11 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15 + 12 | 0;
 i14 = i13 + 11 | 0;
 i15 = i15 + 16 | 0;
 L4 : while (1) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  L6 : do if ((i18 | 0) == (i9 | 0)) {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i16 ? i3 : i10;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   if (i16) {
    if (i19) break;
    if (!(_memcmp(i4, i1, i18) | 0)) break; else {
     i22 = 11;
     break;
    }
   }
   if (!i19) if ((i3 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) {
    i3 = i10;
    i4 = i17;
    while (1) {
     i4 = i4 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i4) break L6;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 11;
      break;
     }
    }
   } else i22 = 11;
  } else i22 = 11; while (0);
  L16 : do if ((i22 | 0) == 11) {
   i22 = 0;
   if (!(HEAP8[i11 >> 0] | 0)) {
    i22 = 22;
    break L4;
   }
   if (!(HEAP32[i12 >> 2] | 0)) {
    i22 = 22;
    break L4;
   }
   i3 = HEAP8[i14 >> 0] | 0;
   i5 = i3 << 24 >> 24 < 0;
   i3 = i3 & 255;
   if (((i5 ? HEAP32[i15 >> 2] | 0 : i3) | 0) != (i9 | 0)) {
    i22 = 22;
    break L4;
   }
   i6 = HEAP32[i13 >> 2] | 0;
   i7 = i5 ? i6 : i13;
   i1 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
   i4 = (i9 | 0) == 0;
   if (i5) {
    if (i4) break;
    if (!(_memcmp(i7, i1, i9) | 0)) break; else {
     i22 = 22;
     break L4;
    }
   }
   if (!i4) {
    if ((i6 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) i4 = i13; else {
     i22 = 22;
     break L4;
    }
    while (1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i3) break L16;
     i1 = i1 + 1 | 0;
     if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
      i22 = 22;
      break L4;
     }
    }
   }
  } while (0);
  i2 = i2 + 24 | 0;
  HEAP32[i20 >> 2] = i2;
  if ((i2 | 0) == (i21 | 0)) {
   i22 = 22;
   break;
  }
 }
 if ((i22 | 0) == 22) return;
}

function __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i1, i3, i12, i13, i14, i4, i2, i16) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 12 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20 + 4 | 0;
 i11 = i20;
 if ((i2 | 0) > -1) i10 = (HEAP32[i1 + 80 >> 2] | 0) + (i2 * 52 | 0) + 4 | 0; else i10 = i1 + 16 | 0;
 HEAP32[i11 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i11, i3);
 i9 = HEAP32[i11 >> 2] | 0;
 i2 = i4 & 255;
 i3 = i10 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 * 20 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 + (i4 * 20 | 0) >> 2] = i9;
 HEAP32[i10 + (i4 * 20 | 0) + 4 >> 2] = i12;
 HEAP32[i10 + (i4 * 20 | 0) + 8 >> 2] = i13;
 HEAP32[i10 + (i4 * 20 | 0) + 12 >> 2] = i14;
 HEAP8[i10 + (i4 * 20 | 0) + 16 >> 0] = 1;
 HEAP8[i10 + (i4 * 20 | 0) + 17 >> 0] = i2;
 HEAP8[i10 + (i4 * 20 | 0) + 18 >> 0] = 0;
 if (!i16) {
  STACKTOP = i20;
  return;
 }
 i6 = HEAP32[i11 >> 2] | 0;
 if ((i6 | 0) != -1 & i6 >>> 0 > 1073741823) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i18 >> 2] = i6;
 i2 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i7 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i19 = 14; else if ((HEAP32[i1 >> 2] | 0) > (i6 | 0)) i19 = 14;
 if ((i19 | 0) == 14) {
  HEAP32[i17 >> 2] = i2;
  HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i16, i15, i18) | 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 844241 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN22NavMeshProjectSettings15NavMeshAreaDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i11);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 844241 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN22NavMeshProjectSettings15NavMeshAreaDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_(i15, i16, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, f20 = f0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i19 + 4 | 0;
 i18 = i19;
 i2 = HEAP32[i16 >> 2] | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i13 - i2 | 0;
 if (!i1) i3 = i2; else {
  i8 = HEAP32[i17 >> 2] | 0;
  i9 = i17 + 40 | 0;
  i10 = i17 + 44 | 0;
  i11 = i17 + 48 | 0;
  i1 = (i1 | 0) / 60 | 0;
  i3 = i2;
  do {
   i6 = (i1 | 0) / 2 | 0;
   i7 = i2 + (i6 * 60 | 0) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   do if ((i4 | 0) == (i8 | 0)) {
    i4 = HEAP32[i2 + (i6 * 60 | 0) + 40 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) {
     i12 = 11;
     break;
    } else {
     i1 = i6;
     break;
    }
    i4 = HEAP32[i2 + (i6 * 60 | 0) + 44 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) == (i5 | 0)) {
     f20 = Math_fround(HEAPF32[i2 + (i6 * 60 | 0) + 48 >> 2]);
     if (f20 < Math_fround(HEAPF32[i11 >> 2])) {
      i12 = 11;
      break;
     } else {
      i1 = i6;
      break;
     }
    } else if (i5 >>> 0 < i4 >>> 0) {
     i12 = 11;
     break;
    } else {
     i1 = i6;
     break;
    }
   } else if (i4 >>> 0 < i8 >>> 0) i12 = 11; else i1 = i6; while (0);
   if ((i12 | 0) == 11) {
    i12 = 0;
    i2 = i7 + 60 | 0;
    i1 = i1 + -1 - i6 | 0;
    i3 = i2;
   }
  } while ((i1 | 0) != 0);
 }
 i4 = i3;
 L18 : do if ((i3 | 0) != (i13 | 0)) {
  i1 = HEAP32[i17 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i1 = HEAP32[i17 + 40 >> 2] | 0;
   i2 = HEAP32[i3 + 40 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) if ((i1 | 0) < (i2 | 0)) break L18; else break;
   i1 = HEAP32[i17 + 44 >> 2] | 0;
   i2 = HEAP32[i3 + 44 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    f20 = Math_fround(HEAPF32[i17 + 48 >> 2]);
    if (f20 < Math_fround(HEAPF32[i3 + 48 >> 2])) break L18; else break;
   } else if (i2 >>> 0 < i1 >>> 0) break L18; else break;
  } else if (i1 >>> 0 < i2 >>> 0) break L18; while (0);
  HEAP32[i15 >> 2] = i4;
  HEAP8[i15 + 4 >> 0] = 0;
  STACKTOP = i19;
  return;
 } while (0);
 HEAP32[i18 >> 2] = i4;
 HEAP32[i14 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i15 >> 2] = __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i16, i14, i17) | 0;
 HEAP8[i15 + 4 >> 0] = 1;
 STACKTOP = i19;
 return;
}

function __ZN5physxL22testTriangleFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_(i4, i1, i5, i8, i11, i10, i9, i12) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, i6 = 0, i7 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 32 | 0;
 i13 = i7 + 16 | 0;
 i6 = i7;
 i1 = i7 + 48 | 0;
 f21 = Math_fround(HEAPF32[i4 + 112 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 116 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 120 >> 2]);
 f17 = Math_fround(HEAPF32[i4 + 96 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 100 >> 2]);
 f3 = Math_fround(HEAPF32[i4 + 104 >> 2]);
 f21 = Math_fround(f21 - f17);
 f2 = Math_fround(f2 - f14);
 f22 = Math_fround(f22 - f3);
 f19 = Math_fround(HEAPF32[i4 + 128 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 132 >> 2]);
 f19 = Math_fround(f19 - f17);
 f20 = Math_fround(f20 - f14);
 f16 = Math_fround(Math_fround(HEAPF32[i4 + 136 >> 2]) - f3);
 f18 = Math_fround(Math_fround(f2 * f16) - Math_fround(f22 * f20));
 f16 = Math_fround(Math_fround(f22 * f19) - Math_fround(f21 * f16));
 f19 = Math_fround(Math_fround(f21 * f20) - Math_fround(f2 * f19));
 f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f18 * f18) + Math_fround(f16 * f16))))));
 f18 = Math_fround(f2 * f18);
 f16 = Math_fround(f2 * f16);
 f2 = Math_fround(f19 * f2);
 HEAPF32[i6 >> 2] = f18;
 HEAPF32[i6 + 4 >> 2] = f16;
 HEAPF32[i6 + 8 >> 2] = f2;
 HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
 f3 = Math_fround(Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * f14)) + Math_fround(f2 * f3));
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i6 | 0, i15 | 0, i13 | 0);
 f2 = Math_fround(HEAPF32[i15 >> 2]);
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = f2 > Math_fround(f3 + f14);
 if (i8 | f3 > Math_fround(f14 + Math_fround(HEAPF32[i13 >> 2]))) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f3 - f2) + Math_fround(-1.1920929e-07));
 i15 = i11 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i15 = 1;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN17Physics2DSettings5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 8;
 HEAP32[i1 + 44 >> 2] = 3;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = -1055066685;
 HEAP8[i1 + 92 >> 0] = 1;
 HEAP8[i1 + 93 >> 0] = 1;
 HEAP8[i1 + 94 >> 0] = 0;
 HEAP8[i1 + 95 >> 0] = 0;
 HEAP8[i1 + 96 >> 0] = 1;
 HEAP8[i1 + 97 >> 0] = 0;
 HEAP8[i1 + 98 >> 0] = 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 104 >> 2] = Math_fround(.568627477);
 HEAPF32[i1 + 108 >> 2] = Math_fround(.956862747);
 HEAPF32[i1 + 112 >> 2] = Math_fround(.545098066);
 HEAPF32[i1 + 116 >> 2] = Math_fround(.752941191);
 HEAPF32[i1 + 120 >> 2] = Math_fround(.568627477);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.956862747);
 HEAPF32[i1 + 128 >> 2] = Math_fround(.545098066);
 HEAPF32[i1 + 132 >> 2] = Math_fround(.360784322);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(.686274529);
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(.250980407);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 56 >> 2] = Math_fround(8.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(360.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(.00999999977);
 HEAPF32[i1 + 72 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 76 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 80 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.00999999977);
 HEAPF32[i1 + 88 >> 2] = Math_fround(2.0);
 HEAP32[gb + 151644 >> 2] = 1008981770;
 HEAP32[gb + 151876 >> 2] = 1065353216;
 HEAP32[gb + 151880 >> 2] = 1045220557;
 HEAPF32[gb + 151884 >> 2] = Math_fround(.139626339);
 HEAPF32[gb + 151888 >> 2] = Math_fround(100.0);
 HEAPF32[gb + 151892 >> 2] = Math_fround(1.0e4);
 HEAPF32[gb + 151896 >> 2] = Math_fround(6.28318548);
 HEAPF32[gb + 151900 >> 2] = Math_fround(39.4784203);
 HEAP32[gb + 151904 >> 2] = 1045220557;
 HEAP32[gb + 151908 >> 2] = 1061158912;
 HEAP32[gb + 151912 >> 2] = 1056964608;
 HEAP32[gb + 151916 >> 2] = 1008981770;
 HEAPF32[gb + 151920 >> 2] = Math_fround(.0349065848);
 i1 = i1 + 168 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i1, 32, i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i3;
 return;
}

function _match_bracket(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i2 = i1 + 1 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 switch (i3 << 24 >> 24) {
 case 33:
 case 94:
  {
   i3 = i1 + 2 | 0;
   i2 = i3;
   i1 = 1;
   i3 = HEAP8[i3 >> 0] | 0;
   break;
  }
 default:
  i1 = 0;
 }
 L4 : do switch (i3 << 24 >> 24) {
 case 93:
  if ((i8 | 0) == 93) {
   i1 = i1 ^ 1;
   break L4;
  } else {
   i2 = i2 + 1 | 0;
   i11 = 10;
   break L4;
  }
 case 45:
  if ((i8 | 0) == 45) {
   i1 = i1 ^ 1;
   break L4;
  } else {
   i2 = i2 + 1 | 0;
   i11 = 10;
   break L4;
  }
 default:
  i11 = 10;
 } while (0);
 L13 : do if ((i11 | 0) == 10) {
  HEAP32[i9 >> 2] = HEAP8[i2 + -1 >> 0];
  i7 = i1 ^ 1;
  L15 : while (1) {
   i4 = HEAP8[i2 >> 0] | 0;
   L17 : do switch (i4 << 24 >> 24) {
   case 93:
    break L13;
   case 45:
    {
     i3 = i2 + 1 | 0;
     if ((HEAP8[i3 >> 0] | 0) == 93) i11 = 27; else {
      i3 = _mbtowc(i10, i3, 4) | 0;
      if ((i3 | 0) < 0) {
       i1 = 0;
       break L15;
      }
      i4 = HEAP32[i9 >> 2] | 0;
      i5 = HEAP32[i10 >> 2] | 0;
      if ((i5 | 0) >= (i4 | 0)) if ((i8 - i4 | 0) >>> 0 <= (i5 - i4 | 0) >>> 0) {
       i1 = i7;
       break L15;
      }
      i2 = i2 + (i3 + -1) | 0;
     }
     break;
    }
   case 91:
    {
     i6 = HEAP8[i2 + 1 >> 0] | 0;
     switch (i6 << 24 >> 24) {
     case 61:
     case 46:
     case 58:
      break;
     default:
      {
       i11 = 27;
       break L17;
      }
     }
     i5 = i2 + 3 | 0;
     while (1) {
      i3 = i5 + -1 | 0;
      if ((HEAP8[i3 >> 0] | 0) == i6 << 24 >> 24) if ((HEAP8[i5 >> 0] | 0) == 93) break;
      i5 = i5 + 1 | 0;
     }
     i4 = i2 + 2 | 0;
     if (i6 << 24 >> 24 == 58) {
      i2 = i3 - i4 | 0;
      if ((i2 | 0) < 16) {
       _memcpy(i10 | 0, i4 | 0, i2 | 0) | 0;
       HEAP8[i10 + i2 >> 0] = 0;
       if (!(_iswctype(i8, _wctype(i10) | 0) | 0)) i2 = i5; else {
        i1 = i7;
        break L13;
       }
      } else i2 = i5;
     } else i2 = i5;
     break;
    }
   default:
    if (i4 << 24 >> 24 > -1) i11 = 27; else {
     i3 = _mbtowc(i9, i2, 4) | 0;
     if ((i3 | 0) < 0) {
      i1 = 0;
      break L13;
     }
     i2 = i2 + (i3 + -1) | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i11 = 30;
    }
   } while (0);
   if ((i11 | 0) == 27) {
    i3 = i4 & 255;
    HEAP32[i9 >> 2] = i3;
    i11 = 30;
   }
   if ((i11 | 0) == 30) {
    i11 = 0;
    if ((i3 | 0) == (i8 | 0)) {
     i1 = i7;
     break L13;
    }
   }
   i2 = i2 + 1 | 0;
  }
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_(i12, i13, i11, i10, i9, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) < (i14 | 0);
 i7 = i5;
 i2 = i3;
 i8 = i6;
 do if ((i14 | 0) < (i4 | 0)) {
  if (i1) {
   HEAP32[i12 >> 2] = i2;
   HEAP32[i11 >> 2] = i8;
   i4 = 1;
   i3 = i6;
   i2 = i8;
   break;
  }
  HEAP32[i12 >> 2] = i7;
  HEAP32[i13 >> 2] = i8;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  if ((HEAP32[i1 + 4 >> 2] | 0) < (i4 | 0)) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = i8;
   i4 = 2;
   i3 = i6;
   i2 = i8;
  } else {
   i4 = 1;
   i3 = i1;
  }
 } else if (i1) {
  HEAP32[i13 >> 2] = i2;
  HEAP32[i11 >> 2] = i7;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i2 + 4 >> 2] | 0)) {
   HEAP32[i12 >> 2] = i1;
   HEAP32[i13 >> 2] = i2;
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = 2;
   i3 = i2;
  } else {
   i4 = 1;
   i3 = i5;
   i2 = i7;
  }
 } else i4 = 0; while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i3 + 4 >> 2] | 0)) {
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i1 = i4 + 1 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) < (HEAP32[i3 + 4 >> 2] | 0)) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = i3;
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i2 + 4 >> 2] | 0)) {
    HEAP32[i12 >> 2] = i1;
    HEAP32[i13 >> 2] = i2;
    i3 = i4 + 3 | 0;
   } else i3 = i4 + 2 | 0;
  } else i3 = i1;
 } else i3 = i4;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
  i14 = i3;
  return i14 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
  i14 = i3 + 1 | 0;
  return i14 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
  i14 = i3 + 2 | 0;
  return i14 | 0;
 }
 HEAP32[i13 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >= (HEAP32[i2 + 4 >> 2] | 0)) {
  i14 = i3 + 3 | 0;
  return i14 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 i14 = i3 + 4 | 0;
 return i14 | 0;
}

function __ZN9b2Contact19InitializeRegistersEv() {
 HEAP32[gb + 1458112 >> 2] = fb + 145;
 HEAP32[gb + 1458112 + 4 >> 2] = fb + 3823;
 HEAP8[gb + 1458112 + 8 >> 0] = 1;
 HEAP32[gb + 1458112 + 120 >> 2] = fb + 146;
 HEAP32[gb + 1458112 + 124 >> 2] = fb + 3824;
 HEAP8[gb + 1458112 + 128 >> 0] = 1;
 HEAP32[gb + 1458112 + 24 >> 2] = fb + 146;
 HEAP32[gb + 1458112 + 28 >> 2] = fb + 3824;
 HEAP8[gb + 1458112 + 32 >> 0] = 0;
 HEAP32[gb + 1458112 + 144 >> 2] = fb + 147;
 HEAP32[gb + 1458112 + 148 >> 2] = fb + 3825;
 HEAP8[gb + 1458112 + 152 >> 0] = 1;
 HEAP32[gb + 1458112 + 60 >> 2] = fb + 148;
 HEAP32[gb + 1458112 + 64 >> 2] = fb + 3826;
 HEAP8[gb + 1458112 + 68 >> 0] = 1;
 HEAP32[gb + 1458112 + 12 >> 2] = fb + 148;
 HEAP32[gb + 1458112 + 16 >> 2] = fb + 3826;
 HEAP8[gb + 1458112 + 20 >> 0] = 0;
 HEAP32[gb + 1458112 + 84 >> 2] = fb + 149;
 HEAP32[gb + 1458112 + 88 >> 2] = fb + 3827;
 HEAP8[gb + 1458112 + 92 >> 0] = 1;
 HEAP32[gb + 1458112 + 132 >> 2] = fb + 149;
 HEAP32[gb + 1458112 + 136 >> 2] = fb + 3827;
 HEAP8[gb + 1458112 + 140 >> 0] = 0;
 HEAP32[gb + 1458112 + 180 >> 2] = fb + 150;
 HEAP32[gb + 1458112 + 184 >> 2] = fb + 3828;
 HEAP8[gb + 1458112 + 188 >> 0] = 1;
 HEAP32[gb + 1458112 + 36 >> 2] = fb + 150;
 HEAP32[gb + 1458112 + 40 >> 2] = fb + 3828;
 HEAP8[gb + 1458112 + 44 >> 0] = 0;
 HEAP32[gb + 1458112 + 204 >> 2] = fb + 151;
 HEAP32[gb + 1458112 + 208 >> 2] = fb + 3829;
 HEAP8[gb + 1458112 + 212 >> 0] = 1;
 HEAP32[gb + 1458112 + 156 >> 2] = fb + 151;
 HEAP32[gb + 1458112 + 160 >> 2] = fb + 3829;
 HEAP8[gb + 1458112 + 164 >> 0] = 0;
 HEAP32[gb + 1458112 + 288 >> 2] = fb + 152;
 HEAP32[gb + 1458112 + 292 >> 2] = fb + 3830;
 HEAP8[gb + 1458112 + 296 >> 0] = 1;
 HEAP32[gb + 1458112 + 240 >> 2] = fb + 153;
 HEAP32[gb + 1458112 + 244 >> 2] = fb + 3831;
 HEAP8[gb + 1458112 + 248 >> 0] = 1;
 HEAP32[gb + 1458112 + 48 >> 2] = fb + 153;
 HEAP32[gb + 1458112 + 52 >> 2] = fb + 3831;
 HEAP8[gb + 1458112 + 56 >> 0] = 0;
 HEAP32[gb + 1458112 + 168 >> 2] = fb + 154;
 HEAP32[gb + 1458112 + 172 >> 2] = fb + 3832;
 HEAP8[gb + 1458112 + 176 >> 0] = 1;
 HEAP32[gb + 1458112 + 264 >> 2] = fb + 154;
 HEAP32[gb + 1458112 + 268 >> 2] = fb + 3832;
 HEAP8[gb + 1458112 + 272 >> 0] = 0;
 HEAP32[gb + 1458112 + 108 >> 2] = fb + 155;
 HEAP32[gb + 1458112 + 112 >> 2] = fb + 3833;
 HEAP8[gb + 1458112 + 116 >> 0] = 1;
 HEAP32[gb + 1458112 + 252 >> 2] = fb + 155;
 HEAP32[gb + 1458112 + 256 >> 2] = fb + 3833;
 HEAP8[gb + 1458112 + 260 >> 0] = 0;
 HEAP32[gb + 1458112 + 228 >> 2] = fb + 156;
 HEAP32[gb + 1458112 + 232 >> 2] = fb + 3834;
 HEAP8[gb + 1458112 + 236 >> 0] = 1;
 HEAP32[gb + 1458112 + 276 >> 2] = fb + 156;
 HEAP32[gb + 1458112 + 280 >> 2] = fb + 3834;
 HEAP8[gb + 1458112 + 284 >> 0] = 0;
 return;
}

function __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i2, i16, i1) {
 i2 = i2 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i14 = i2 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i12 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i14 >> 2] = i3;
 }
 i7 = _llvm_bswap_i32(i1 | 0) | 0;
 i8 = i16 + 4 | 0;
 __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i16, HEAP32[i8 >> 2] | 0);
 i9 = i16 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i16 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 if ((i7 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i10 = i8;
 i11 = i16 + 4 | 0;
 i6 = 0;
 do {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4);
   i1 = HEAP32[i13 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i14 >> 2] = i2;
  }
  i5 = _llvm_bswap_i32(i1 | 0) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  do if (!i1) {
   HEAP32[i13 >> 2] = i8;
   i4 = i10;
   i3 = i8;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i5 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 13;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i5 >>> 0) {
      i2 = 18;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 17;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 13) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 17) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 18) {
    HEAP32[i13 >> 2] = i1;
    i4 = i1;
    i3 = i13;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(20) | 0;
   HEAP32[i1 + 16 >> 2] = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i16 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 >> 2] | 0, i1);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 STACKTOP = i15;
 return;
}

function __ZN17ProfilerFrameData10ThreadDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 84 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63576 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 104 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i1 = i1 + 120 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i10, i1);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i5 = HEAP32[i5 + 24 >> 2] | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = i2 - i1 | 0;
 i3 = (i1 | 0) / 88 | 0;
 i2 = i5 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
  HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i4, __Z34scripting_class_array_element_sizeP11Il2CppClass(i4) | 0, i3) | 0;
  HEAP32[i2 >> 2] = i3;
 }
 if (i1 | 0) {
  i1 = 0;
  do {
   i6 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i5 >> 2] | 0, i1) | 0;
   __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i7, (HEAP32[i10 >> 2] | 0) + (i1 * 88 | 0) | 0, i6);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i8 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i11;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE(i1, i7, i8, i9, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (!i1) i3 = 1; else {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i7 >> 2] = 0;
   i3 = 1;
   break;
  } else {
   i3 = (HEAP32[i7 >> 2] | 0) == 0;
   break;
  }
 } while (0);
 i2 = HEAP32[i8 >> 2] | 0;
 do if (!i2) i6 = 14; else {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i8 >> 2] = 0;
   i6 = 14;
   break;
  } else if (i3) {
   i5 = i2;
   i6 = 17;
   break;
  } else {
   i6 = 16;
   break;
  }
 } while (0);
 if ((i6 | 0) == 14) if (i3) i6 = 16; else {
  i5 = 0;
  i6 = 17;
 }
 L22 : do if ((i6 | 0) == 16) HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 6; else if ((i6 | 0) == 17) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i1 | 0, 0) | 0) << 24 >> 24 != 37) {
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
   break;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) i2 = 1; else i6 = 25;
  } else {
   HEAP32[i2 >> 2] = i3 + 4;
   i6 = 25;
  }
  do if ((i6 | 0) == 25) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == -1) {
    HEAP32[i7 >> 2] = 0;
    i2 = 1;
    break;
   } else {
    i2 = (HEAP32[i7 >> 2] | 0) == 0;
    break;
   }
  } while (0);
  do if (!i5) i6 = 37; else {
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i5 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) == -1) {
    HEAP32[i8 >> 2] = 0;
    i6 = 37;
    break;
   } else if (i2) break L22; else break;
  } while (0);
  if ((i6 | 0) == 37) if (!i2) break;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2;
 } while (0);
 return;
}

function __ZNK13b2DynamicTree5QueryI12b2BroadPhaseEEvPT_RK6b2AABB(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i16 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i16;
 i13 = i15 + 1028 | 0;
 i14 = i15 + 1032 | 0;
 HEAP32[i14 >> 2] = 256;
 HEAP32[i16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 >> 2] = 1;
 i9 = i1 + 4 | 0;
 i10 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 i8 = i12 + 12 | 0;
 i1 = 1;
 i2 = i16;
 L1 : while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i13 >> 2] = i1;
  i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  do if ((i5 | 0) != -1) {
   i6 = HEAP32[i9 >> 2] | 0;
   f21 = Math_fround(HEAPF32[i12 >> 2]);
   f21 = Math_fround(f21 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 8 >> 2]));
   f20 = Math_fround(HEAPF32[i10 >> 2]);
   f20 = Math_fround(f20 - Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 12 >> 2]));
   f19 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) >> 2]);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i7 >> 2]));
   f18 = Math_fround(HEAPF32[i6 + (i5 * 36 | 0) + 4 >> 2]);
   if (!(f21 > Math_fround(0.0) | f20 > Math_fround(0.0) | f19 > Math_fround(0.0) | Math_fround(f18 - Math_fround(HEAPF32[i8 >> 2])) > Math_fround(0.0))) {
    i3 = i6 + (i5 * 36 | 0) + 24 | 0;
    if ((HEAP32[i3 >> 2] | 0) == -1) {
     if (!(__ZN12b2BroadPhase13QueryCallbackEi(i11, i5) | 0)) break L1;
     i1 = HEAP32[i13 >> 2] | 0;
     break;
    }
    if ((i1 | 0) == (HEAP32[i14 >> 2] | 0)) {
     HEAP32[i14 >> 2] = i1 << 1;
     i4 = __Z7b2Alloci(i1 << 3) | 0;
     HEAP32[i15 >> 2] = i4;
     _memcpy(i4 | 0, i2 | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
     if ((i2 | 0) != (i16 | 0)) __Z6b2FreePv(i2);
    }
    i4 = HEAP32[i15 >> 2] | 0;
    HEAP32[i4 + (HEAP32[i13 >> 2] << 2) >> 2] = HEAP32[i3 >> 2];
    i2 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
    HEAP32[i13 >> 2] = i2;
    i1 = i6 + (i5 * 36 | 0) + 28 | 0;
    if ((i2 | 0) == (HEAP32[i14 >> 2] | 0)) {
     HEAP32[i14 >> 2] = i2 << 1;
     i6 = __Z7b2Alloci(i2 << 3) | 0;
     HEAP32[i15 >> 2] = i6;
     _memcpy(i6 | 0, i4 | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
     if ((i4 | 0) != (i16 | 0)) __Z6b2FreePv(i4);
    }
    HEAP32[(HEAP32[i15 >> 2] | 0) + (HEAP32[i13 >> 2] << 2) >> 2] = HEAP32[i1 >> 2];
    i1 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
    HEAP32[i13 >> 2] = i1;
   }
  } while (0);
  if ((i1 | 0) <= 0) break;
  i2 = HEAP32[i15 >> 2] | 0;
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if ((i1 | 0) == (i16 | 0)) {
  STACKTOP = i17;
  return;
 }
 __Z6b2FreePv(i1);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i17;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i19, i1) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i8 = i19 + 28 | 0;
 i18 = HEAP32[i8 >> 2] | 0;
 f20 = Math_fround(i1 >>> 0);
 i9 = ~~Math_fround(f20 * Math_fround(HEAPF32[i19 + 36 >> 2])) >>> 0;
 i14 = i1 << 2;
 i13 = (i9 << 2) + i14 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i10 = i19 + 4 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i13 + (i9 * 12 | 0) | 0, HEAP32[i19 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i12 = i11 + i14 | 0;
 i13 = i11 + i13 | 0;
 _memset(i11 | 0, -1, i14 | 0) | 0;
 i14 = i19 + 48 | 0;
 i7 = i19 + 16 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i15 = i1 + -1 | 0;
  i17 = 0;
  do {
   i16 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i16 + (i17 * 12 | 0) >> 2] | 0;
   i6 = HEAP32[i16 + (i17 * 12 | 0) + 4 >> 2] | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i3 = 5381; else {
    i3 = 5381;
    do {
     i3 = i3 * 33 ^ i2 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
    } while (i2 << 24 >> 24 != 0);
   }
   i2 = HEAP8[i6 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i5 = i2;
    i2 = 5381;
    i4 = i6;
    do {
     i2 = i2 * 33 ^ i5 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
    } while (i5 << 24 >> 24 != 0);
   }
   i4 = i11 + (((i2 ^ i3) & i15) << 2) | 0;
   HEAP32[i12 + (i17 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i17;
   i4 = i16 + (i17 * 12 | 0) | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i13 + (i17 * 12 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i13 + (i17 * 12 | 0) + 8 >> 2] = HEAP32[i16 + (i17 * 12 | 0) + 8 >> 2];
   i17 = i17 + 1 | 0;
  } while (i17 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 }
 i17 = i19 + 12 | 0;
 i16 = HEAP32[i10 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i11;
 HEAP32[i19 + 24 >> 2] = i11;
 HEAP32[i19 + 32 >> 2] = i1;
 HEAP32[i19 + 20 >> 2] = i12;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i8 >> 2] = i9;
 i1 = i19 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i18;
 return;
}

function __ZN5physx2Sc10NPhaseCore7convertEPNS0_21ElementSimInteractionENS0_15InteractionTypeERNS0_10FilterInfoEb(i10, i8, i4, i7, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 2 | 0;
 i3 = i11;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 i6 = HEAP32[i8 + 36 >> 2] | 0;
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 if (!(HEAP8[i1 + 51 >> 0] & 1)) if ((HEAP8[i1 + 50 >> 0] | 0) == 1) __ZN5physx2Sc7BodySim14internalWakeUpEf(i1, Math_fround(.399999976));
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!(HEAP8[i1 + 51 >> 0] & 1)) if ((HEAP8[i1 + 50 >> 0] | 0) == 1) __ZN5physx2Sc7BodySim14internalWakeUpEf(i1, Math_fround(.399999976));
 switch (i4 | 0) {
 case 2:
  {
   HEAP16[i3 >> 1] = HEAP16[i7 + 2 >> 1] | 0;
   i1 = __ZN5physx2Sc10NPhaseCore24createTriggerInteractionERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i10, i5, i6, i3) | 0;
   break;
  }
 case 3:
  {
   i2 = i10 + 1916 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i10 + 1624 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i4 = i10 + 1904 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i4 = i10 + 1908 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   if (!i1) i1 = 0; else {
    HEAP32[i1 >> 2] = gb + 101220 + 8;
    HEAP16[i1 + 4 >> 1] = -1;
    HEAP16[i1 + 6 >> 1] = 1;
    i4 = i1 + 8 | 0;
    __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i4, HEAP32[i5 + 8 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, 3, 5);
    HEAP32[i1 + 32 >> 2] = i5;
    HEAP32[i1 + 36 >> 2] = i6;
    HEAP32[i1 >> 2] = gb + 101244 + 8;
    HEAP32[i4 >> 2] = gb + 101244 + 52;
   }
   __ZN5physx2Sc24ElementInteractionMarker10initializeEv(i1);
   break;
  }
 case 0:
  {
   HEAP16[i2 >> 1] = HEAP16[i7 + 2 >> 1] | 0;
   i1 = __ZN5physx2Sc10NPhaseCore25createShapeInstancePairLLERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i10, i5, i6, i2) | 0;
   break;
  }
 default:
  i1 = 0;
 }
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if (i2 | 0) {
  i7 = i1 + 6 | 0;
  HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 4;
  HEAP8[i2 + 8 >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = i1;
 }
 i2 = i8 + 6 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(i3 & 4)) {
  __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i10, i8, 4, 0, i9);
  STACKTOP = i11;
  return i1 | 0;
 }
 HEAP16[i2 >> 1] = i3 & 65531;
 __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb(i10, i8, 4, 0, i9);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
  i1 = i1 + 88 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i4 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 24 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 56 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i5, i4 + 72 | 0, 0);
 i1 = i4 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 16 | 0;
 i16 = i17;
 i6 = HEAP32[i15 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i16 | 0);
 i6 = i16 + 12 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i16 + 8 | 0;
  i8 = i15 + 60 | 0;
  i1 = i15 + 340 | 0;
  i2 = i15 + 352 | 0;
  i3 = i15 + 344 | 0;
  i4 = i15 + 336 | 0;
  i9 = 0;
  do {
   i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
   if (i5 | 0) {
    mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i2 >> 2] = i5;
    i13 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i13 + 1;
    if ((i13 | 0) >= ((HEAP32[i4 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i8);
     HEAP32[i3 >> 2] = 0;
    }
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i5 = i16 + 4 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i6 = i15 + 356 | 0;
 i7 = i15 + 360 | 0;
 i8 = i15 + 352 | 0;
 i9 = i15 + 60 | 0;
 i10 = i15 + 340 | 0;
 i11 = i15 + 344 | 0;
 i12 = i15 + 364 | 0;
 i13 = 0;
 do {
  i2 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i9);
   i4 = HEAP32[i8 >> 2] | 0;
  } else i4 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  do if (!i4) {
   HEAP32[i14 >> 2] = 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  } else {
   __ZN5physx2Sc19ParticlePacketShapeC2ERNS0_17ParticleSystemSimEjPNS_16PxvParticleShapeE(i4, i15, i3, i2);
   HEAP32[i14 >> 2] = i4;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i4;
    HEAP32[i7 >> 2] = i1 + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i6, i14) | 0;
    break;
   }
  } while (0);
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx2Sc15ArticulationSimD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx10PxsContext19destroyArticulationERNS_15PxsArticulationE(HEAP32[(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1);
  HEAP32[HEAP32[i2 + 8 >> 2] >> 2] = 0;
 }
 i1 = HEAP32[i2 + 148 >> 2] | 0;
 i3 = HEAP32[i2 + 156 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i3 | 0) < 0 | (i3 & 2147483647 | 0) == 0))) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = HEAP32[i2 + 136 >> 2] | 0;
 i3 = HEAP32[i2 + 144 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i3 | 0) < 0 | (i3 & 2147483647 | 0) == 0))) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 132 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 124 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 120 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 112 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 108 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 100 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 96 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 88 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 44 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 36 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 24 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5physx41postProcessFrictionConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj(i2, i14, i4, i5, i8, i15, i12, i11) {
 i2 = i2 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16;
 i3 = i16 + 8 | 0;
 i13 = i2;
 if (i14 | 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 5) + 28 >> 2] = 0;
   HEAP16[i2 + (i1 << 5) + 14 >> 1] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i14 | 0));
 }
 if (!i5) {
  if (!i15) {
   STACKTOP = i16;
   return;
  } else i1 = 0;
  while (1) {
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i8 + 4 >> 2] | 0;
   i4 = (i2 - i13 | 0) >>> 5 >>> 0 < i14 >>> 0;
   if (i4) i5 = HEAPU16[i2 + 14 >> 1] | 0; else i5 = 65535;
   i6 = (i3 - i13 | 0) >>> 5 >>> 0 < i14 >>> 0;
   if (i6) i7 = HEAPU16[i3 + 14 >> 1] | 0; else i7 = 65535;
   HEAP16[i8 + 28 >> 1] = i5;
   HEAP16[i8 + 30 >> 1] = i7;
   if (i4) HEAP16[i2 + 14 >> 1] = i5 + 1;
   if (i6) HEAP16[i3 + 14 >> 1] = i7 + 1;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i15 | 0)) break; else i8 = i8 + 32 | 0;
  }
  STACKTOP = i16;
  return;
 }
 i2 = i5 << 2;
 i7 = i2 >>> 0 > 1024;
 i9 = i10 + 4 | 0;
 HEAP8[i9 >> 0] = i7 & 1;
 if (i7) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i3, i2, gb + 720042 | 0, 1272) | 0;
  HEAP32[i10 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i10 >> 2] = i1;
 }
 i2 = 0;
 do {
  i7 = HEAP32[i4 + (i2 * 40 | 0) >> 2] | 0;
  HEAP32[i1 + (i2 << 2) >> 2] = i7;
  HEAP32[i7 + 28 >> 2] = 0;
  HEAP16[i7 + 14 >> 1] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 __ZN5physx45updateAtomFrictionProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj(i8, i15, i13, i14, i1, i5);
 if (i11 | 0) {
  i6 = 0;
  do {
   i2 = HEAP32[i12 + (i6 << 4) + 4 >> 2] | 0;
   if (i2 | 0) {
    i3 = (HEAP32[i12 + (i6 << 4) + 12 >> 2] | 0) + 14 | 0;
    i4 = HEAP16[i3 >> 1] | 0;
    i5 = HEAP32[i12 + (i6 << 4) >> 2] | 0;
    i7 = 0;
    do {
     i15 = i5 + i7 | 0;
     HEAP16[i8 + (i15 << 5) + 28 >> 1] = i4;
     HEAP16[i8 + (i15 << 5) + 30 >> 1] = i4;
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < i2 >>> 0);
    HEAP16[i3 >> 1] = i4 + 1 << 16 >> 16;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i11 | 0));
 }
 if (!(HEAP8[i9 >> 0] | 0)) {
  STACKTOP = i16;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i10, i1);
 STACKTOP = i16;
 return;
}

function __Z29InitializeTextRenderingModulev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63392 | 0, 16, gb + 946549 | 0, gb + 1576256 | 0, gb + 946578 | 0, 46) | 0;
 HEAP32[i2 >> 2] = gb + 185828 + 8;
 __Z19pop_allocation_rootv();
 __ZN13TextRendering17SetITextRenderingEPNS_14ITextRenderingE(i2);
 HEAP32[gb + 1115296 + 428 >> 2] = fb + 328;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6944 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 6176 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 6176 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 6176 + (i1 * 12 | 0) >> 2] = fb + 329;
 i1 = HEAP32[gb + 1156068 + 768 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[gb + 1156068 + 768 >> 2] | 0;
 }
 HEAP32[gb + 1156068 + 768 >> 2] = i1 + 1;
 HEAP32[gb + 1156068 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[gb + 1156068 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[gb + 1156068 + (i1 * 12 | 0) >> 2] = fb + 330;
 i1 = HEAP32[gb + 1155296 + 768 >> 2] | 0;
 if (i1 >>> 0 <= 63) {
  i4 = i1;
  i3 = i4 + 1 | 0;
  HEAP32[gb + 1155296 + 768 >> 2] = i3;
  i3 = gb + 1155296 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = gb + 1155296 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = gb + 1155296 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 331;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[gb + 1155296 + 768 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[gb + 1155296 + 768 >> 2] = i3;
 i3 = gb + 1155296 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = gb + 1155296 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = gb + 1155296 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 331;
 STACKTOP = i5;
 return;
}

function _expm1(d1) {
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, d10 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i6 = i5 & 2147483647;
 i7 = _bitshift64Lshr(i4 | 0, i5 | 0, 63) | 0;
 getTempRet0() | 0;
 do if (i6 >>> 0 > 1078159481) {
  i6 = i5 & 2147483647;
  if (!(i6 >>> 0 > 2146435072 | (i6 | 0) == 2146435072 & i4 >>> 0 > 0)) if (!i7) if (d1 > 709.782712893384) d1 = d1 * 8988465674311579538646525.0e283; else i9 = 11; else d1 = -1.0;
 } else {
  if (i6 >>> 0 <= 1071001154) if (i6 >>> 0 < 1016070144) break; else {
   d8 = 0.0;
   i6 = 0;
   i9 = 14;
   break;
  }
  if (i6 >>> 0 < 1072734898) if (!i7) {
   i4 = 1;
   d2 = d1 + -.6931471803691238;
   d3 = 1.9082149292705877e-10;
   i9 = 12;
   break;
  } else {
   i4 = -1;
   d2 = d1 + .6931471803691238;
   d3 = -1.9082149292705877e-10;
   i9 = 12;
   break;
  } else i9 = 11;
 } while (0);
 if ((i9 | 0) == 11) {
  i4 = ~~(d1 * 1.4426950408889634 + (i7 | 0 ? -.5 : .5));
  d3 = +(i4 | 0);
  d2 = d1 - d3 * .6931471803691238;
  d3 = d3 * 1.9082149292705877e-10;
  i9 = 12;
 }
 if ((i9 | 0) == 12) {
  d8 = d2 - d3;
  d1 = d8;
  d8 = d2 - d8 - d3;
  i6 = i4;
  i9 = 14;
 }
 L18 : do if ((i9 | 0) == 14) {
  d3 = d1 * .5;
  d2 = d1 * d3;
  d10 = d2 * (d2 * (d2 * (d2 * (4.008217827329362e-06 - d2 * 2.0109921818362437e-07) + -7.93650757867488e-05) + 1.5873015872548146e-03) + -.03333333333333313) + 1.0;
  d3 = 3.0 - d3 * d10;
  d3 = d2 * ((d10 - d3) / (6.0 - d1 * d3));
  if (!i6) {
   d1 = d1 - (d1 * d3 - d2);
   break;
  }
  d2 = d1 * (d3 - d8) - d8 - d2;
  switch (i6 | 0) {
  case -1:
   {
    d1 = (d1 - d2) * .5 + -.5;
    break L18;
   }
  case 1:
   if (d1 < -.25) {
    d1 = (d2 - (d1 + .5)) * -2.0;
    break L18;
   } else {
    d1 = (d1 - d2) * 2.0 + 1.0;
    break L18;
   }
  default:
   {
    i7 = _bitshift64Shl(i6 + 1023 | 0, 0, 52) | 0;
    i9 = getTempRet0() | 0;
    HEAP32[tempDoublePtr >> 2] = i7;
    HEAP32[tempDoublePtr + 4 >> 2] = i9;
    d3 = +HEAPF64[tempDoublePtr >> 3];
    if (i6 >>> 0 > 56) {
     d1 = d1 - d2 + 1.0;
     d1 = ((i6 | 0) == 1024 ? d1 * 2.0 * 8988465674311579538646525.0e283 : d3 * d1) + -1.0;
     break L18;
    }
    i4 = _bitshift64Shl(1023 - i6 | 0, 0, 52) | 0;
    i5 = getTempRet0() | 0;
    if ((i6 | 0) < 20) {
     HEAP32[tempDoublePtr >> 2] = i4;
     HEAP32[tempDoublePtr + 4 >> 2] = i5;
     d1 = 1.0 - +HEAPF64[tempDoublePtr >> 3] + (d1 - d2);
    } else {
     HEAP32[tempDoublePtr >> 2] = i4;
     HEAP32[tempDoublePtr + 4 >> 2] = i5;
     d1 = d1 - (+HEAPF64[tempDoublePtr >> 3] + d2) + 1.0;
    }
    d1 = d3 * d1;
    break L18;
   }
  }
 } while (0);
 return +d1;
}

function __ZNK6Camera14GetHDRWarningsEv(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 if ((HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) > 0) if ((__ZNK6Camera22CalculateRenderingPathEv(i2) | 0) == 1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 377066 | 0, 191);
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i3, i4); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 i1 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 708 >> 2] | 0, i1 | 0) | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 233 + i1 >> 0] | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 377258 | 0, 104);
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i3, i4); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 if ((__ZNK6Camera22CalculateRenderingPathEv(i2) | 0) != 3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 144 >> 0] | 0) {
  STACKTOP = i6;
  return;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 377363 | 0, 173);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i3, i4); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN5physx13addConstraintERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, f22 = f0;
 i18 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i17 = HEAP32[i1 + 8 >> 2] | 0;
 f12 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f12 * Math_fround(HEAPF32[i2 >> 2]));
 f16 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 + Math_fround(f16 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f3 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 8 >> 2])));
 i8 = i4 + 62 | 0;
 i9 = HEAPU16[i8 >> 1] | 0;
 if (!(i9 & 1)) {
  i14 = HEAP32[i4 + 140 >> 2] | 0;
  HEAP32[i14 >> 2] = i18;
  HEAP32[i14 + 4 >> 2] = i19;
  HEAP32[i14 + 8 >> 2] = i17;
  HEAPF32[i14 + 12 >> 2] = f7;
  HEAP16[i8 >> 1] = i9 | 1;
  return;
 }
 if (!(i9 & 2)) {
  i14 = HEAP32[i4 + 156 >> 2] | 0;
  HEAP32[i14 >> 2] = i18;
  HEAP32[i14 + 4 >> 2] = i19;
  HEAP32[i14 + 8 >> 2] = i17;
  HEAPF32[i14 + 12 >> 2] = f7;
  HEAP16[i8 >> 1] = i9 | 2;
  return;
 }
 i10 = HEAP32[i4 + 140 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i10 >> 2]);
 f22 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f15 = Math_fround(f15 * f22);
 i11 = i10 + 4 | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f21 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f6 = Math_fround(f15 + Math_fround(f6 * f21));
 i13 = i10 + 8 | 0;
 f15 = Math_fround(HEAPF32[i13 >> 2]);
 f20 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 f15 = Math_fround(f6 + Math_fround(f15 * f20));
 i14 = i10 + 12 | 0;
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i14 >> 2]));
 i1 = HEAP32[i4 + 156 >> 2] | 0;
 f6 = Math_fround(f22 * Math_fround(HEAPF32[i1 >> 2]));
 i2 = i1 + 4 | 0;
 f6 = Math_fround(f6 + Math_fround(f21 * Math_fround(HEAPF32[i2 >> 2])));
 i4 = i1 + 8 | 0;
 f6 = Math_fround(f6 + Math_fround(f20 * Math_fround(HEAPF32[i4 >> 2])));
 i5 = i1 + 12 | 0;
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f12 * f22) + Math_fround(f16 * f21)) + Math_fround(f3 * f20)) - f7);
 if (f15 < f6) {
  if (!(f3 < f6)) return;
  HEAP32[i1 >> 2] = i18;
  HEAP32[i2 >> 2] = i19;
  HEAP32[i4 >> 2] = i17;
  HEAPF32[i5 >> 2] = f7;
  HEAP16[i8 >> 1] = i9 & 65525 | 2;
  return;
 } else {
  if (!(f3 < f15)) return;
  HEAP32[i10 >> 2] = i18;
  HEAP32[i11 >> 2] = i19;
  HEAP32[i13 >> 2] = i17;
  HEAPF32[i14 >> 2] = f7;
  HEAP16[i8 >> 1] = i9 & 65530 | 1;
  return;
 }
}

function __ZN21AssetBundleFileSystem10RemovePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i11 + 12 | 0;
 i1 = i10 + 96 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i10 + 100 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 i6 = __Z14SkipPathPrefixPKcS0_jb((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i3, i1, 1) | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i6, _strlen(i6) | 0);
 i6 = i10 + 72 | 0;
 i7 = i10 + 8 | 0;
 if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
  i2 = i10 + 64 | 0;
  i1 = i10 + 68 | 0;
  i4 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  i3 = i4;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_(i8, i5, i9);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = i10 + 64 | 0;
  i12 = HEAP32[i2 >> 2] | 0;
  i1 = i10 + 68 | 0;
  i13 = i12 + ((HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  i3 = i13;
  i4 = (i4 | 0) == -1 ? i13 : i12 + (i4 * 24 | 0) | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if ((i4 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) | 0)) {
  HEAP32[i8 >> 2] = i5;
  HEAP32[i8 + 4 >> 2] = i4;
  HEAP32[i8 + 8 >> 2] = i3;
  if (__ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E11set_deletedER30dense_hashtable_const_iteratorIS9_S7_SB_SJ_SE_SH_E(i5, i8) | 0) {
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   HEAP8[i10 + 84 >> 0] = 1;
  }
 }
 i2 = i10 + 108 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i6 >> 2] | 0) != (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 + 92 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) | 0) {
  STACKTOP = i11;
  return;
 }
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i10) | 0;
 HEAP8[i2 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 20 | 0) + i2 | 0;
 if (i6 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 20 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 107374182 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 214748364;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 20 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 20 | 0) * 20 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 20 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = i10 + 276 | 0;
  i6 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i7 >> 2] | 0;
   i5 = i2 + (i10 * 48 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i6 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    do if ((i13 | 0) == 15) {
     i13 = 0;
     i10 = HEAP32[i2 + 44 >> 2] | 0;
     if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
      i4 = HEAP32[i2 + 36 >> 2] | 0;
      if ((i2 | 0) == (i4 | 0)) {
       HEAP8[i2 + 32 >> 0] = 0;
       break;
      }
      if (i4) {
       i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
       mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i4 | 0);
      }
     }
    } while (0);
    i2 = i2 + 48 | 0;
   } while ((i2 | 0) != (i5 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN2UI14DepthSortLayer12AddWithDepthERKNS_23RenderableUIInstructionEi(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 20 | 0;
 i4 = i11 + 152 | 0;
 i5 = i10 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i10 + 36 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i2 = i9 & 2147483647;
 do if (i7 >>> 0 > i2 >>> 0) {
  i1 = i9 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i2 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 5, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] << 5 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (i6 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i2 = i2 + (i6 << 5) + 16 | 0;
 i3 = i11 + 168 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 5 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 + (i3 << 5) >> 2] = HEAP32[i11 + 84 >> 2];
 HEAP32[i10 + (i3 << 5) + 4 >> 2] = i12;
 HEAP32[i10 + (i3 << 5) + 8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + (i3 << 5) + 12 >> 2] = HEAP32[i11 + 4 >> 2];
 i12 = i10 + (i3 << 5) + 16 | 0;
 i11 = i11 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 return;
}

function __Z34SkinnedMeshRenderer_InternalRenderRK15RenderNodeQueuejRK14ChannelAssignsib(i1, i11, i13, i4, i7) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 32 | 0;
 i15 = i16;
 i2 = i14;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i8 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i8 + (i11 * 360 | 0) + 328 >> 2] | 0;
 if (!i1) {
  STACKTOP = i16;
  return;
 }
 if ((HEAP16[gb + 1161556 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1161556 | 0, HEAP32[i8 + (i11 * 360 | 0) + 352 >> 2] | 0);
  i9 = gb + 1161556 | 0;
 } else i9 = 0;
 i10 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i5 + 128 >> 2] | 0;
 i5 = (HEAP32[i5 + 132 >> 2] | 0) - i6 | 0;
 i5 = i5 | 0 ? ((i5 | 0) / 52 | 0) + -1 | 0 : 0;
 i5 = i5 >>> 0 < i4 >>> 0 ? i5 : i4;
 if (__ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i1, HEAP32[i13 >> 2] | 0, i14, 0, i7) | 0) {
  if (mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 200 >> 2] | 0, i10 | 0, 4) | 0) i4 = 1; else i4 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 200 >> 2] | 0, i10 | 0, 5) | 0;
  i1 = i15 + 4 | 0;
  i2 = i1 + 8 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i6 + (i5 * 52 | 0) + 32 >> 2];
  HEAP32[i15 + 16 >> 2] = HEAP32[i6 + (i5 * 52 | 0) + 44 >> 2];
  i2 = i15 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 + (i5 * 52 | 0) + 36 >> 2];
  i3 = HEAP32[i6 + (i5 * 52 | 0) + 40 >> 2] | 0;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i15 + 20 >> 2] = HEAP32[i6 + (i5 * 52 | 0) + 48 >> 2];
  if (i4) {
   if ((i3 | 0) == 1) i12 = 10;
  } else if ((i3 | 0) == 2) i12 = 10;
  if ((i12 | 0) == 10) {
   HEAP32[i15 >> 2] = 0;
   HEAP32[i1 >> 2] = HEAP32[i6 + (i5 * 52 | 0) >> 2];
   HEAP32[i2 >> 2] = HEAP32[i6 + (i5 * 52 | 0) + 4 >> 2];
  }
  __Z17SetupObjectMatrixRK10Matrix4x4fi(i8 + (i11 * 360 | 0) | 0, HEAP32[i8 + (i11 * 360 | 0) + 176 >> 2] | 0);
  i1 = HEAP32[i8 + (i11 * 360 | 0) + 188 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 188 >> 2] | 0, i10 | 0, i1 | 0);
  mftCall_viiiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 244 >> 2] | 0, i10 | 0, HEAP32[i14 >> 2] | 0, i14 + 8 | 0, HEAP32[i14 + 4 >> 2] | 0, i15 | 0, 1, HEAP32[i14 + 40 >> 2] | 0, i13 | 0);
  __Z15gpu_time_samplev();
 }
 if (!i9) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i16;
 return;
}

function __Z28IntersectAABBSphereInclusiveRK4AABBRK6Sphere(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 f8 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i19 = i1 + 12 | 0;
 f14 = Math_fround(HEAPF32[i19 >> 2]);
 f2 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f7 = Math_fround(f8 - f7);
 f11 = Math_fround(f9 - f11);
 f12 = Math_fround(f10 - f12);
 i19 = f7 < Math_fround(-f14);
 i17 = f11 < Math_fround(-f2);
 i15 = f12 < Math_fround(-f5);
 f10 = Math_fround(-f7);
 f9 = Math_fround(-f11);
 f8 = Math_fround(-f12);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = (HEAP32[tempDoublePtr >> 2] = i19 ? i1 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i17 ? i3 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f7 + f8);
 f9 = Math_fround(f11 + f9);
 f10 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i15 ? i6 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i4 = f7 > f14 ? i1 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f11 > f2 ? i3 : (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = f12 > f5 ? i6 : (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 - f5);
 f14 = Math_fround(f11 - f14);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0))) + Math_fround(0.0)));
 f14 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 return f12 <= Math_fround(f14 * f14) | 0;
}

function __ZN9InputAxisC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 HEAP32[i5 >> 2] = gb + 59740 + 8;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = i5 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i5 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i5 + 96 >> 2] = Math_fround(.00100000005);
 HEAPF32[i5 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 100 >> 2] = Math_fround(.100000001);
 HEAP8[i5 + 105 >> 0] = 0;
 HEAP8[i5 + 104 >> 0] = 0;
 HEAPF32[i5 + 80 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 88 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 11 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i7 >> 0] = 0;
 i4 = i2 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) HEAP32[i5 + 28 >> 2] = 0; else HEAP8[i4 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i7 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i7 >> 0] = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i5 + 44 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx7NpShape11setGeometryERKNS_10PxGeometryE(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = i5 + 116 | 0;
 if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 689543 | 0, 219, gb + 690199 | 0, i6);
  STACKTOP = i6;
  return;
 }
 switch (i2 | 0) {
 case 4:
  {
   if (!(HEAP32[i5 + 36 >> 2] & 1)) i2 = i1; else i2 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i2 + 32 >> 2] | 0;
   if (i2 | 0) {
    i2 = i2 + 8 | 0;
    i4 = 13;
   }
   break;
  }
 case 6:
  {
   if (!(HEAP32[i5 + 36 >> 2] & 1)) i2 = i1; else i2 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (i2 | 0) {
    i2 = i2 + 8 | 0;
    i4 = 13;
   }
   break;
  }
 case 5:
  {
   if (!(HEAP32[i5 + 36 >> 2] & 1)) i2 = i1; else i2 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i2 + 36 >> 2] | 0;
   if (i2 | 0) {
    i2 = i2 + 8 | 0;
    i4 = 13;
   }
   break;
  }
 default:
  {}
 }
 if ((i4 | 0) == 13) if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 4 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 __ZN5physx3Scb5Shape11setGeometryERKNS_10PxGeometryE(i5 + 32 | 0, i3) | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i5 + 36 >> 2] & 1) i1 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i4 = 25;
   }
   break;
  }
 case 6:
  {
   if (HEAP32[i5 + 36 >> 2] & 1) i1 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i4 = 25;
   }
   break;
  }
 case 5:
  {
   if (HEAP32[i5 + 36 >> 2] & 1) i1 = (HEAP32[i5 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i4 = 25;
   }
   break;
  }
 default:
  {}
 }
 if ((i4 | 0) == 25) __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 4 | 0) | 0;
 if (!(HEAP8[((HEAP32[i5 + 36 >> 2] & 64 | 0) == 0 ? i5 + 112 | 0 : (HEAP32[i5 + 40 >> 2] | 0) + 52 | 0) >> 0] & 2)) {
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE(i1 + 3392 | 0, __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(__ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i2 >> 2] | 0) | 0, i5) | 0);
 STACKTOP = i6;
 return;
}

function __ZN14UnityAnalytics15SendCustomEventERK8UnityStr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 88 | 0;
 i8 = i9;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) {
  i8 = 2;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr(i8, i1);
 do if ((HEAP32[i8 + 80 >> 2] | 0) >>> 0 > (HEAP32[i2 + 36 >> 2] | 0) >>> 0) i2 = 3; else if ((HEAP32[i8 + 84 >> 2] | 0) >>> 0 > (HEAP32[i2 + 40 >> 2] | 0) >>> 0) i2 = 4; else {
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  i6 = i2 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv() | 0;
  i2 = getTempRet0() | 0;
  i3 = i4 + 752 | 0;
  i10 = i3;
  i10 = _i64Subtract(i1 | 0, i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0) | 0;
  i11 = getTempRet0() | 0;
  if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 3599999) {
   i11 = i3;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i11 + 4 >> 2] = i2;
   i2 = 1;
   i1 = i4 + 760 | 0;
  } else {
   i1 = i4 + 760 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
   if (i2 >>> 0 > i5 >>> 0) {
    i2 = 5;
    break;
   }
  }
  HEAP32[i1 >> 2] = i2;
  i2 = HEAP32[i6 >> 2] | 0;
  __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i2, i8, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, 0) | 0;
  i2 = 0;
 } while (0);
 HEAP32[i8 >> 2] = gb + 188456 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i8 + 64 | 0, HEAP32[i8 + 68 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i8 + 48 | 0, HEAP32[i8 + 52 >> 2] | 0);
 i1 = i8 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i8 + 44 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
 }
 HEAP32[i8 >> 2] = gb + 190148 + 8;
 i1 = i8 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i8 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
 }
 i11 = i2;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN10GISettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 20 >> 0] = i1;
 i1 = i4 + 21 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __Z7LogGLESPKcS0_S0_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 36 | 0;
 i6 = i9 + 24 | 0;
 i7 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
 if (!i1) {
  i7 = i5 + 11 | 0;
  i8 = i5;
  i7 = HEAP8[i7 >> 0] | 0;
  i7 = i7 << 24 >> 24 < 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i7 ? i8 : i5;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i8, 0, i3, i4, 2, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, _strlen(i1) | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i10 = HEAP8[i8 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i8 + 4 >> 2] | 0 : i10 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i11 ? HEAP32[i8 >> 2] | 0 : i8, i10, i10 + 2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, gb + 1084762 | 0, 2) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i10 = HEAP8[i7 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i7 + 4 >> 2] | 0 : i10 & 255;
  i2 = i5 + 11 | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i11 ? HEAP32[i7 >> 2] | 0 : i7, i10, i1 + i10 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i7 = i2;
  i8 = i5;
  i7 = HEAP8[i7 >> 0] | 0;
  i7 = i7 << 24 >> 24 < 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i7 ? i8 : i5;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i8, 0, i3, i4, 2, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37316 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i12, i1, 0);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i12, i1, 0); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 60 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 946881 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 60 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 946881 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN11KeyframeTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i7 = HEAP16[i4 + 84 >> 1] | 0;
 HEAP32[i3 >> 2] = i7 << 16 >> 16;
 switch (i7 << 16 >> 16) {
 case 0:
  {
   HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
   HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 80 >> 2];
   return;
  }
 case 1:
  {
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 80 >> 2];
   i2 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
   HEAP32[i3 + 12 >> 2] = i2;
   i1 = __Znwj(88) | 0;
   i5 = i1;
   i6 = i4 + 88 | 0;
   i7 = i5 + 56 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i1 + 56 | 0, i4 + 144 | 0);
   i7 = i1 + 76 | 0;
   i6 = i4 + 164 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i2 + 8 >> 2] = i1;
   return;
  }
 case 3:
  {
   f9 = Math_fround(HEAPF32[(HEAP32[i4 + 232 >> 2] | 0) + 4 >> 2]);
   f8 = Math_fround(HEAPF32[i4 + 80 >> 2]);
   HEAPF32[i3 + 16 >> 2] = Math_fround(f9 * f8);
   HEAPF32[i3 + 20 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i4 + 144 >> 2] | 0) + 4 >> 2]) * f8);
   return;
  }
 default:
  {
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 80 >> 2];
   i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
   HEAP32[i3 + 8 >> 2] = i1;
   i2 = __Znwj(88) | 0;
   i5 = i2;
   i6 = i4 + 176 | 0;
   i7 = i5 + 56 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i2 + 56 | 0, i4 + 232 | 0);
   i5 = i2 + 76 | 0;
   i6 = i4 + 252 | 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i1 + 8 >> 2] = i2;
   i2 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
   HEAP32[i3 + 12 >> 2] = i2;
   i1 = __Znwj(88) | 0;
   i5 = i1;
   i6 = i4 + 88 | 0;
   i7 = i5 + 56 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i1 + 56 | 0, i4 + 144 | 0);
   i7 = i1 + 76 | 0;
   i6 = i4 + 164 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i2 + 8 >> 2] = i1;
   return;
  }
 }
}

function __ZNK14ParticleSystem34CalculateSubEmitterMaximumLifeTimeEfi(i11, f12, i13) {
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 32 | 0;
 i6 = i18 + 28 | 0;
 i7 = i18 + 24 | 0;
 i8 = i18 + 20 | 0;
 i10 = i18 + 16 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18;
 HEAP32[i14 >> 2] = 0;
 i17 = i14 + 4 | 0;
 i9 = gb + 63160 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i17;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 i5 = i11 + 916 | 0;
 i1 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i5 >> 2] | 0) | 0) << 2;
 do if (!i1) {
  i1 = 0;
  i4 = 0;
 } else {
  i4 = i1 | 3;
  if (i4 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i4 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i4 = 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 2400) | 0;
   i9 = gb + 64016 | 0;
   i19 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i4;
   i1 = i17;
   HEAP32[i1 >> 2] = i19;
   HEAP32[i1 + 4 >> 2] = i9;
   i1 = i4;
   break;
  }
 } while (0);
 i9 = i1 + 3 & -4;
 i7 = __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_(HEAP32[i5 >> 2] | 0, i9, 0, i6, i7, i8) | 0;
 HEAP32[i10 >> 2] = 0;
 if ((i7 | 0) <= 0) {
  f12 = Math_fround(0.0);
  i19 = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i19, i17);
  STACKTOP = i18;
  return Math_fround(f12);
 }
 i6 = i15 + 4 | 0;
 i5 = 0;
 f2 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 do {
  i1 = i9 + (i5 << 2) | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  if (!((i4 | 0) == 0 | (i4 | 0) == (i11 | 0))) {
   __ZNK11MinMaxCurve10FindMinMaxEv(i15, (HEAP32[i4 + 44 >> 2] | 0) + 8 | 0);
   f3 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f12);
   HEAPF32[i16 >> 2] = f3;
   i19 = HEAP32[(f2 < f3 ? i16 : i10) >> 2] | 0;
   HEAP32[i10 >> 2] = i19;
   f3 = Math_fround(__ZNK14ParticleSystem34CalculateSubEmitterMaximumLifeTimeEfi(HEAP32[i1 >> 2] | 0, f3, i13));
   HEAPF32[i16 >> 2] = f3;
   i19 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f3;
   i19 = HEAP32[(i19 ? i16 : i10) >> 2] | 0;
   HEAP32[i10 >> 2] = i19;
   f3 = (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   f2 = f3;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 f12 = f3;
 i19 = HEAP32[i14 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i19, i17);
 STACKTOP = i18;
 return Math_fround(f12);
}

function __ZN4FMOD8ChannelI15set3DAttributesEPK11FMOD_VECTORS3_(i11, i2, i3) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var d1 = 0.0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, d12 = 0.0, i13 = 0, i14 = 0;
 if (i2 | 0) {
  i10 = i11 + 76 | 0;
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  d12 = +Math_fround(HEAPF32[i2 >> 2]);
  d1 = +Math_fround(HEAPF32[i2 + 4 >> 2]);
  _JS_Sound_SetPosition(HEAP32[i11 + 164 >> 2] | 0, +d12, +d1, +(+Math_fround(HEAPF32[i2 + 8 >> 2])));
 }
 if (i3 | 0) {
  i10 = i11 + 88 | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 }
 __ZN4FMOD8ChannelI18UpdateDopplerPitchEv(i11);
 __ZN4FMOD8ChannelI9setVolumeEf(i11, Math_fround(HEAPF32[i11 + 136 >> 2])) | 0;
 i3 = i11 + 140 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f4 != f4 | Math_fround(0.0) != Math_fround(0.0))) return 0;
 i5 = i11 + 152 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i2 = i11 + 161 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  d12 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i10 = +Math_abs(d12) >= 1.0 ? (d12 > 0.0 ? ~~+Math_min(+Math_floor(d12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d12 - +(~~d12 >>> 0)) / 4294967296.0) >>> 0) : 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i9 = ~~d12 >>> 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  i2 = (HEAP8[i2 >> 0] | 0) == 0;
 } else {
  i10 = i11 + 120 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  f7 = f6;
  f8 = f4;
  i2 = 0;
 }
 i13 = i11 + 104 | 0;
 i14 = i13;
 i14 = _i64Subtract(i9 | 0, i10 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
 f8 = Math_fround(Math_fround(Math_fround(f7 * f8) / Math_fround(44100.0)) * Math_fround(+(i14 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)));
 i14 = +Math_abs(+f8) >= 1.0 ? (+f8 > 0.0 ? ~~+Math_min(+Math_floor(+f8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f8 - +(~~+f8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i5 >> 2] = f6;
 f4 = Math_fround(f4 * f6);
 f8 = Math_fround(Math_fround(+(i9 >>> 0) + 4294967296.0 * +(i10 >>> 0)) - Math_fround(Math_fround(Math_fround(44100.0) / f4) * Math_fround(+(~~+f8 >>> 0 >>> 0) + 4294967296.0 * +(i14 >>> 0))));
 i9 = +Math_abs(+f8) >= 1.0 ? (+f8 > 0.0 ? ~~+Math_min(+Math_floor(+f8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f8 - +(~~+f8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i10 = i13;
 HEAP32[i10 >> 2] = ~~+f8 >>> 0;
 HEAP32[i10 + 4 >> 2] = i9;
 if (i2) d1 = +Math_fround(f4 / Math_fround(44100.0)); else d1 = 1.0e-07;
 _JS_Sound_SetPitch(HEAP32[i11 + 164 >> 2] | 0, +d1);
 return 0;
}

function __ZN7dtCrowd26UpdateTopologyOptimizationEf(i12, f8) {
 i12 = i12 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 4 | 0;
 i2 = i14;
 if ((HEAP16[gb + 1459296 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459296 | 0, i1);
  i13 = gb + 1459296 | 0;
 } else i13 = 0;
 i6 = HEAP32[i12 + 400 >> 2] | 0;
 L4 : do if ((i6 | 0) > 0) {
  i7 = HEAP32[i12 + 16 >> 2] | 0;
  i5 = HEAP32[i12 + 392 >> 2] | 0;
  f3 = Math_fround(.5);
  i1 = -1;
  i4 = 0;
  do {
   i2 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
   if ((HEAP8[i7 + (i2 * 608 | 0) + 601 >> 0] | 0) == 1) if ((HEAP32[i7 + (i2 * 608 | 0) + 32 >> 2] | 0) >= 3) {
    i11 = i7 + (i2 * 608 | 0) + 556 | 0;
    f15 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
    HEAPF32[i11 >> 2] = f15;
    i11 = f15 > f3;
    f3 = i11 ? f15 : f3;
    i1 = i11 ? i4 : i1;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
  if ((i1 | 0) != -1) {
   i7 = HEAP32[(HEAP32[i12 + 392 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i9 = HEAP32[i12 + 16 >> 2] | 0;
   i10 = i9 + (i7 * 608 | 0) | 0;
   i11 = i12 + 464 | 0;
   __ZN14dtPathCorridor20optimizePathTopologyEP14dtNavMeshQueryPK13dtQueryFilter(i10, HEAP32[i11 >> 2] | 0, (HEAP32[i12 + 24 >> 2] | 0) + (i7 * 132 | 0) | 0) | 0;
   HEAPF32[i9 + (i7 * 608 | 0) + 556 >> 2] = Math_fround(0.0);
   if (HEAP8[i12 + 420 >> 0] | 0) {
    i5 = HEAP32[i12 + 428 >> 2] | 0;
    if ((i5 | 0) > 0) {
     i4 = HEAP32[i12 + 424 >> 2] | 0;
     i2 = 0;
     while (1) {
      i6 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
      i1 = HEAP32[i6 >> 2] | 0;
      if (!i1) i1 = -1; else i1 = HEAP32[i1 >> 2] | 0;
      if ((i1 | 0) == (i7 | 0)) break;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) >= (i5 | 0)) break L4;
     }
     if (i6 | 0) {
      i1 = HEAP32[i9 + (i7 * 608 | 0) + 32 >> 2] | 0;
      if (!i1) {
       i1 = 0;
       i2 = 0;
       i4 = 0;
       i5 = 0;
      } else {
       i5 = HEAP32[i9 + (i7 * 608 | 0) + 28 >> 2] | 0;
       i2 = i5;
       i5 = i5 + (i1 + -1 << 3) | 0;
       i1 = HEAP32[i2 >> 2] | 0;
       i2 = HEAP32[i2 + 4 >> 2] | 0;
       i4 = HEAP32[i5 >> 2] | 0;
       i5 = HEAP32[i5 + 4 >> 2] | 0;
      }
      __ZN15dtPathQueryInfo3setEyyPKfS1_PK14dtNavMeshQuery(i6, i1, i2, i4, i5, i10, i9 + (i7 * 608 | 0) + 12 | 0, HEAP32[i11 >> 2] | 0);
     }
    }
   }
  }
 } while (0);
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return;
}

function __ZN16Physics2DManager16GetProfilerStatsER14Physics2DStats(i1, i16) {
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i15 = HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0;
 if (!i15) return;
 i1 = HEAP32[i15 + 102956 >> 2] | 0;
 L4 : do if (!i1) {
  i10 = 0;
  i9 = 0;
  i8 = 0;
  i7 = 0;
  i6 = 0;
  i5 = 0;
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i11 = 0;
  i9 = 0;
  i8 = 0;
  i13 = 0;
  i6 = 0;
  i5 = 0;
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i12 = 0;
  while (1) {
   switch (HEAP32[i1 >> 2] | 0) {
   case 0:
    {
     i8 = (HEAP32[i1 + 104 >> 2] | 0) + i8 | 0;
     i3 = i3 + 1 | 0;
     i10 = i11;
     i7 = i13;
     break;
    }
   case 2:
    {
     i2 = i2 + 1 | 0;
     i14 = 8;
     break;
    }
   case 1:
    {
     i12 = i12 + 1 | 0;
     i14 = 8;
     break;
    }
   default:
    i14 = 8;
   }
   if ((i14 | 0) == 8) {
    i14 = 0;
    i10 = HEAP16[i1 + 4 >> 1] | 0;
    i7 = HEAP32[i1 + 104 >> 2] | 0;
    if (!(i10 & 2)) {
     i11 = i7 + i11 | 0;
     i5 = i5 + 1 | 0;
    } else {
     i9 = i7 + i9 | 0;
     i4 = i4 + 1 | 0;
    }
    i17 = (i10 & 65535) >>> 3 & 1;
    i10 = i11;
    i7 = i17 + i13 | 0;
    i6 = (i17 ^ 1) + i6 | 0;
   }
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (!i1) {
    i1 = i12;
    break L4;
   } else {
    i11 = i10;
    i13 = i7;
   }
  }
 } while (0);
 HEAP32[i16 >> 2] = (HEAP32[i15 + 102964 >> 2] | 0) + -1;
 HEAP32[i16 + 4 >> 2] = i4;
 HEAP32[i16 + 8 >> 2] = i5;
 HEAP32[i16 + 12 >> 2] = i2;
 HEAP32[i16 + 16 >> 2] = i1;
 HEAP32[i16 + 20 >> 2] = i3;
 HEAP32[i16 + 24 >> 2] = i6;
 HEAP32[i16 + 28 >> 2] = i7;
 HEAP32[i16 + 48 >> 2] = i8;
 HEAP32[i16 + 40 >> 2] = i9;
 HEAP32[i16 + 44 >> 2] = i10;
 HEAP32[i16 + 32 >> 2] = HEAP32[i15 + 102968 >> 2];
 HEAP32[i16 + 36 >> 2] = HEAP32[i15 + 102936 >> 2];
 HEAPF32[i16 + 52 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103e3 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 56 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103004 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 60 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103008 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 64 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103012 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 68 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103016 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 72 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103020 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 76 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103024 >> 2]) * Math_fround(1.0e6));
 HEAPF32[i16 + 80 >> 2] = Math_fround(Math_fround(HEAPF32[i15 + 103028 >> 2]) * Math_fround(1.0e6));
 return;
}

function __ZN15PointEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i1);
 i2 = i8 + 92 | 0;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 100 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i8 + 112 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i5 = i8 + 116 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i5 = i8 + 120 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i8 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402561 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI33EnlightenTerrainChunksInformationE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402561 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI33EnlightenTerrainChunksInformationE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i2 = i11 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i4 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 3;
 HEAP32[i2 >> 2] = i14;
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(HEAP32[(HEAP32[i11 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) >> 2] & 256)) {
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
  i10 = i14 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i10 = i14;
  HEAP32[i10 >> 2] = i1 & 255;
  HEAP32[i10 + 4 >> 2] = 0;
  i1 = 15878;
 } else {
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  i1 = i1 << 24 >> 24 ? 258 : 257;
 }
 HEAP32[i4 >> 2] = i1;
 if (HEAP32[i2 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i3, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i2 >> 2] = i3;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 28 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 36 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i4 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i5 = i13 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i8 + (i4 << 4) | 0, HEAP32[i13 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 48 | 0;
 i2 = i13 + 16 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i2 >> 2] | 0;
   i16 = HEAP32[i15 + (i11 << 4) >> 2] | 0;
   i17 = i16 + ~(i16 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i6 + (((i17 >>> 16 ^ i17) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i11;
   HEAP32[i8 + (i11 << 4) >> 2] = i16;
   HEAP8[i8 + (i11 << 4) + 4 >> 0] = HEAP8[i15 + (i11 << 4) + 4 >> 0] | 0;
   HEAP8[i8 + (i11 << 4) + 5 >> 0] = HEAP8[i15 + (i11 << 4) + 5 >> 0] | 0;
   i16 = i8 + (i11 << 4) + 6 | 0;
   i17 = i15 + (i11 << 4) + 6 | 0;
   i17 = HEAPU8[i17 >> 0] | HEAPU8[i17 + 1 >> 0] << 8 | HEAPU8[i17 + 2 >> 0] << 16 | HEAPU8[i17 + 3 >> 0] << 24;
   HEAP8[i16 >> 0] = i17;
   HEAP8[i16 + 1 >> 0] = i17 >> 8;
   HEAP8[i16 + 2 >> 0] = i17 >> 16;
   HEAP8[i16 + 3 >> 0] = i17 >> 24;
   HEAP8[i8 + (i11 << 4) + 10 >> 0] = HEAP8[i15 + (i11 << 4) + 10 >> 0] | 0;
   HEAP8[i8 + (i11 << 4) + 11 >> 0] = HEAP8[i15 + (i11 << 4) + 11 >> 0] | 0;
   HEAP8[i8 + (i11 << 4) + 12 >> 0] = HEAP8[i15 + (i11 << 4) + 12 >> 0] | 0;
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i17 = i13 + 12 | 0;
 i16 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i6;
 HEAP32[i13 + 24 >> 2] = i6;
 HEAP32[i13 + 32 >> 2] = i1;
 HEAP32[i13 + 20 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx2Sc32DefaultClothInterCollisionFilterEPvS1_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 64 | 0;
 i2 = i11 + 48 | 0;
 i9 = i11 + 80 | 0;
 i15 = i11 + 32 | 0;
 i14 = i11 + 16 | 0;
 i3 = i11;
 i4 = __ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i7 + 4 >> 2] | 0) | 0;
 i13 = HEAP32[i4 + 1116 >> 2] | 0;
 HEAP16[i9 >> 1] = 0;
 i5 = i7 + 44 | 0;
 HEAP32[i15 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i15 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i6 = i8 + 44 | 0;
 HEAP32[i14 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i12 = HEAP32[i4 + 1108 >> 2] | 0;
 i1 = HEAP32[i4 + 1112 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i1 = mftCall_iiiiiiii(i13 | 0, 5, i2 | 0, 5, i10 | 0, i9 | 0, i12 | 0, i1 | 0) | 0;
 if (i1 & 4) {
  i14 = i8;
  i14 = i14 + ~(i14 << 15) | 0;
  i14 = (i14 >>> 10 ^ i14) * 9 | 0;
  i14 = i14 >>> 6 ^ i14;
  i14 = i14 + ~(i14 << 11) | 0;
  i15 = i7;
  i15 = i15 + ~(i15 << 15) | 0;
  i15 = (i15 >>> 10 ^ i15) * 9 | 0;
  i15 = i15 >>> 6 ^ i15;
  i15 = i15 + ~(i15 << 11) | 0;
  i13 = HEAP32[i4 + 1120 >> 2] | 0;
  i12 = HEAP32[HEAP32[i13 >> 2] >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = HEAP32[gb + 1097392 + 32 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i1 = mftCall_iiiiiiiiiiii(i12 | 0, i13 | 0, i14 >>> 16 ^ i14 ^ (i15 ^ -57320555 ^ i15 >>> 16) * 1000007 | 0, 5, i2 | 0, i7 + i1 | 0, 0, 5, i10 | 0, i8 + i1 | 0, 0, i9 | 0) | 0;
 }
 i1 = i1 & 65535;
 if (!(i1 & 1)) {
  STACKTOP = i11;
  return (i1 & 2 | 0) == 0 | 0;
 } else {
  STACKTOP = i11;
  return 0;
 }
 return 0;
}

function __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 12 | 0, i6 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj84ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 28 | 0, i6 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 44 | 0, i6 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 60 | 0, i6 + 4 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i5, i7 + 76 | 0, i6 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj89ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 112 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj90ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 128 | 0, i6 + 8 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj91ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 144 | 0, i6 + 9 | 0);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i5, gb + 674324 | 0);
 __ZN5physx2Sn12readPropertyERNS0_21RepXVisitorReaderBaseINS_14PxArticulationEEEPS2_RKNS_32PxArticulationLinkCollectionPropE(i5, HEAP32[i5 + 24 >> 2] | 0, i7 + 160 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj93ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 176 | 0, i6 + 11 | 0);
 return i6 + 15 | 0;
}

function __ZN27AnimatorControllerParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i4 = i9 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i9 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i7 >> 2] = i5;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i7, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
 i6 = i3 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i5 = i9 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i7, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i1 = i9 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 28 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i11 = i9 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  i11 = i9 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 36 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471336 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471336 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 36 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471297 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471297 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z20AnimationEventToMonoRK14AnimationEventR18MonoAnimationEvent(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 i1 = i6 + 4 | 0;
 i9 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i9 << 24 >> 24 < 0;
 HEAP32[i7 + 4 >> 2] = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i6 + 8 >> 2] | 0 : i9 & 255) | 0;
 i9 = i6 + 20 | 0;
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 HEAP32[i7 + 8 >> 2] = __Z20scripting_string_newPKcj(i1 ? HEAP32[i9 >> 2] | 0 : i9, i1 ? HEAP32[i6 + 24 >> 2] | 0 : i4 & 255) | 0;
 i4 = i6 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 } while (0);
 HEAP32[i7 + 12 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 44 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 48 >> 2];
 i1 = HEAP32[i6 + 52 >> 2] | 0;
 if (!i1) i2 = HEAP32[i6 + 60 >> 2] | 0 ? 2 : 0; else i2 = 1;
 HEAP32[i7 + 28 >> 2] = i2;
 HEAP32[i7 + 32 >> 2] = __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i1, HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 4 >> 2] | 0) | 0;
 i1 = HEAP32[i6 + 56 >> 2] | 0;
 if (i1 | 0) {
  i3 = i7 + 36 | 0;
  i2 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
 }
 i1 = HEAP32[i6 + 60 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i1, i7 + 72 | 0);
 STACKTOP = i8;
 return;
}

function __ZN27GenericSlowGarbageCollector16ProcessReferenceEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 8 | 0;
 i4 = i11;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 if (i2 | 0) {
  if ((HEAP32[i1 + 80 >> 2] | 0) == (HEAP32[i1 + 48 >> 2] | 0)) {
   i2 = HEAP32[i1 + 72 >> 2] | 0;
   i3 = HEAP32[i1 + 76 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i3, i1 + 44 | 0, i4);
   i10 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i1 + 72 >> 2] | 0;
   i3 = HEAP32[i1 + 76 >> 2] | 0;
   i1 = (i10 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i10 << 3) | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i10 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i10 | 0) == -1) {
    STACKTOP = i11;
    return;
   }
   i8 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + (i10 << 3) + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 & 536870912 | 0) {
    STACKTOP = i11;
    return;
   }
   i9 = i8 + 8 | 0;
   HEAP32[i2 >> 2] = i3 | 536870912;
   i7 = i3 & 536870911;
   if (!((i7 | 0) != 78 & (((i7 | 0) == 43 | ((i7 | 0) == 142 | ((i7 | 0) == 84 | ((i7 | 0) == 158 | ((i7 | 0) == 171 | ((i7 | 0) == 89 | ((i7 + -187 | 0) >>> 0 < 2 | ((i7 | 0) == 117 | ((i7 + -27 | 0) >>> 0 < 2 | ((i7 | 0) == 150 | ((i7 | 0) == 147 | ((i7 | 0) == 115 | (i7 | 0) == 149)))))))))))) ^ 1) & 1 | (HEAPU8[i1 + 105 >> 0] | 0))) {
    STACKTOP = i11;
    return;
   }
   i2 = i8 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i8 + 24 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i10;
   STACKTOP = i11;
   return;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN24dtObstacleAvoidanceQuery7prepareEPKfS1_ffffPK25dtObstacleAvoidanceParams(i9, i1, i2, f3, f4, f10, f11, i12) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 var i5 = 0, f6 = f0, i7 = 0, i8 = 0, f13 = f0;
 i8 = i9 + 10460 | 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) i1 = 0; else {
  i8 = i9 + 10400 | 0;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  i12 = i9 + 10440 | 0;
  HEAPF32[i12 >> 2] = f11;
  f11 = Math_fround(Math_fround(1.0) / f11);
  i12 = i9 + 10444 | 0;
  HEAPF32[i12 >> 2] = f11;
  f11 = Math_fround(Math_fround(1.0) / f10);
  i12 = i9 + 10448 | 0;
  HEAPF32[i12 >> 2] = f11;
  return;
 }
 do {
  f3 = Math_fround(HEAPF32[i9 + 4992 + (i1 * 52 | 0) >> 2]);
  f4 = Math_fround(HEAPF32[i9 + 4992 + (i1 * 52 | 0) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i9 + 4992 + (i1 * 52 | 0) + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i9 + 4992 + (i1 * 52 | 0) + 12 >> 2]);
  HEAPF32[i9 + 4992 + (i1 * 52 | 0) + 24 >> 2] = Math_fround(Math_fround(f3 * Math_fround(.5)) + Math_fround(f13 * Math_fround(.5)));
  HEAPF32[i9 + 4992 + (i1 * 52 | 0) + 28 >> 2] = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(f6 * Math_fround(.5)));
  i2 = i9 + 4992 + (i1 * 52 | 0) + 32 | 0;
  f3 = Math_fround(f13 - f3);
  HEAPF32[i2 >> 2] = f3;
  f4 = Math_fround(f6 - f4);
  i5 = i9 + 4992 + (i1 * 52 | 0) + 36 | 0;
  HEAPF32[i5 >> 2] = f4;
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))));
  i7 = i9 + 4992 + (i1 * 52 | 0) + 40 | 0;
  HEAPF32[i7 >> 2] = f6;
  if (f6 < Math_fround(9.99999997e-07)) {
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i5 >> 2] = Math_fround(0.0);
  } else {
   f13 = Math_fround(Math_fround(1.0) / f6);
   HEAPF32[i2 >> 2] = Math_fround(f13 * f3);
   HEAPF32[i5 >> 2] = Math_fround(f13 * f4);
   HEAPF32[i7 >> 2] = Math_fround(f6 * Math_fround(.5));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i8 >> 2] | 0));
 i8 = i9 + 10400 | 0;
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 i12 = i9 + 10440 | 0;
 HEAPF32[i12 >> 2] = f11;
 f13 = Math_fround(Math_fround(1.0) / f11);
 i12 = i9 + 10444 | 0;
 HEAPF32[i12 >> 2] = f13;
 f13 = Math_fround(Math_fround(1.0) / f10);
 i12 = i9 + 10448 | 0;
 HEAPF32[i12 >> 2] = f13;
 return;
}

function __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i4, i3, i11, i5, i6, i7, i10, i8, i9) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0;
 i2 = (HEAP16[i4 + 12 >> 1] | 0) == -1;
 if ((HEAP16[i4 + 8 >> 1] | 0) == -1) {
  i1 = i3;
  HEAP32[i7 >> 2] = (HEAP32[i4 >> 2] | 0) - i1 >> 5;
  if (i2) {
   i6 = (HEAP32[i4 + 4 >> 2] | 0) - i1 >> 5;
   HEAP32[i10 >> 2] = i6;
   i10 = (HEAP32[i7 >> 2] | 0) >>> 0 < i11 >>> 0;
   HEAP8[i8 >> 0] = i10 & 1;
   i11 = i6 >>> 0 < i11 >>> 0;
   HEAP8[i9 >> 0] = i11 & 1;
   i11 = i10 & i11;
   return i11 | 0;
  }
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  L7 : do if (!i6) i1 = -1; else {
   i1 = 0;
   while (1) {
    if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break L7;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  HEAP32[i10 >> 2] = i1 + i11;
  i11 = (HEAP32[i7 >> 2] | 0) >>> 0 < i11 >>> 0;
  HEAP8[i8 >> 0] = i11 & 1;
  HEAP8[i9 >> 0] = 1;
  return i11 | 0;
 }
 if (i2) {
  i2 = HEAP32[i4 >> 2] | 0;
  L16 : do if (!i6) i1 = -1; else {
   i1 = 0;
   while (1) {
    if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break L16;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  HEAP32[i7 >> 2] = i1 + i11;
  i7 = (HEAP32[i4 + 4 >> 2] | 0) - i3 >> 5;
  HEAP32[i10 >> 2] = i7;
  HEAP8[i8 >> 0] = 1;
  i11 = i7 >>> 0 < i11 >>> 0;
  HEAP8[i9 >> 0] = i11 & 1;
  return i11 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
  i2 = i1;
  L25 : do if (!i6) i1 = -1; else {
   i1 = 0;
   while (1) {
    if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break L25;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i11 = i1 + i11 | 0;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i7 >> 2] = i11;
  HEAP8[i9 >> 0] = 1;
  HEAP8[i8 >> 0] = 1;
  i11 = 1;
  return i11 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 L32 : do if (!i6) {
  HEAP32[i7 >> 2] = i11 + -1;
  i1 = -1;
 } else {
  i1 = 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i6 >>> 0) {
    i1 = -1;
    break;
   }
  }
  HEAP32[i7 >> 2] = i1 + i11;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break L32;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i6 >>> 0) {
    i1 = -1;
    break;
   }
  }
 } while (0);
 HEAP32[i10 >> 2] = i1 + i11;
 HEAP8[i9 >> 0] = 1;
 HEAP8[i8 >> 0] = 1;
 i11 = 1;
 return i11 | 0;
}

function __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 12 | 0;
 i4 = i5;
 i3 = HEAP32[i6 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i3 = f9 < Math_fround(HEAPF32[i4 + 8 >> 2]);
 i1 = HEAP32[i7 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = f9 < Math_fround(HEAPF32[i4 + 8 >> 2]);
 if (!i3) {
  if (!i1) {
   i8 = 0;
   STACKTOP = i5;
   return i8 | 0;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i3;
  i8 = HEAP32[i6 >> 2] | 0;
  __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (!(f9 < Math_fround(HEAPF32[i4 + 8 >> 2]))) {
   i8 = 1;
   STACKTOP = i5;
   return i8 | 0;
  }
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i8;
  i8 = 2;
  STACKTOP = i5;
  return i8 | 0;
 }
 i3 = HEAP32[i6 >> 2] | 0;
 if (i1) {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i3;
  i8 = 1;
  STACKTOP = i5;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i3;
 __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f9 < Math_fround(HEAPF32[i4 + 8 >> 2]))) {
  i8 = 1;
  STACKTOP = i5;
  return i8 | 0;
 }
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i6;
 i8 = 2;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZN29BillboardTreeInstanceRenderer10UpdateWindEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i2 = i8;
 i4 = i6 + 252 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = 1; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i2);
    i2 = HEAP32[i7 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i1 = 1;
    break;
   }
  }
  i4 = i1 + 60 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i1 = 1; else {
   i5 = HEAP32[gb + 1467612 >> 2] | 0;
   i1 = i4;
   L16 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L16; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) == (i4 | 0)) i1 = 1; else if ((i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) i1 = 1; else i1 = Math_fround(HEAPF32[i1 + 20 >> 2]) == Math_fround(0.0) & 1;
  }
 } while (0);
 HEAP8[i6 + 300 >> 0] = i1;
 i2 = HEAP32[i6 + 268 >> 2] | 0;
 if (i1 << 24 >> 24) {
  i9 = -1;
  __ZN12TreeRenderer21ComputeWindPropertiesEib(i7, i2, i9, 1);
  i9 = HEAP32[i7 >> 2] | 0;
  __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i6, i9);
  i7 = i7 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i6 + 296 | 0;
  HEAP32[i9 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 i9 = HEAP32[i6 + 280 >> 2] | 0;
 __ZN12TreeRenderer21ComputeWindPropertiesEib(i7, i2, i9, 1);
 i9 = HEAP32[i7 >> 2] | 0;
 __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i6, i9);
 i7 = i7 + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i9 = i6 + 296 | 0;
 HEAP32[i9 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN16BlendShapeVertex8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z19IntersectAABBSphereRK4AABBRK6Sphere(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 f8 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i19 = i1 + 12 | 0;
 f14 = Math_fround(HEAPF32[i19 >> 2]);
 f2 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f7 = Math_fround(f8 - f7);
 f11 = Math_fround(f9 - f11);
 f12 = Math_fround(f10 - f12);
 i19 = f7 < Math_fround(-f14);
 i17 = f11 < Math_fround(-f2);
 i15 = f12 < Math_fround(-f5);
 f10 = Math_fround(-f7);
 f9 = Math_fround(-f11);
 f8 = Math_fround(-f12);
 i18 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = (HEAP32[tempDoublePtr >> 2] = i19 ? i1 : i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i17 ? i3 : i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f7 + f8);
 f9 = Math_fround(f11 + f9);
 f10 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i15 ? i6 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i4 = f7 > f14 ? i1 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f11 > f2 ? i3 : (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i19 = f12 > f5 ? i6 : (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 - f5);
 f14 = Math_fround(f11 - f14);
 f12 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i19, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f12 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f12 * f12) + Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0))) + Math_fround(0.0)));
 f14 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 return f12 < Math_fround(f14 * f14) | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 << 4) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i16 = i9 + (i11 << 4) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = _i64Add(i17 | 0, i16 | 0, -1, ~i17 | 0) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i15 | 0, i18 | 0, 22) | 0;
   i15 = i19 ^ i15;
   i18 = (getTempRet0() | 0) ^ i18;
   i19 = _bitshift64Shl(i15 | 0, i18 | 0, 13) | 0;
   i19 = _i64Add(i15 | 0, i18 | 0, ~i19 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i18 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i19 | 0, i18 | 0, 8) | 0;
   i18 = ___muldi3(i15 ^ i19 | 0, (getTempRet0() | 0) ^ i18 | 0, 9, 0) | 0;
   i19 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i18 | 0, i19 | 0, 15) | 0;
   i18 = i15 ^ i18;
   i19 = (getTempRet0() | 0) ^ i19;
   i15 = _bitshift64Shl(i18 | 0, i19 | 0, 27) | 0;
   i15 = _i64Add(i18 | 0, i19 | 0, ~i15 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i19 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i15 | 0, i19 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i19;
   i15 = i5 + (((i18 ^ i15) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i11;
   i15 = i7 + (i11 << 4) | 0;
   HEAP32[i15 >> 2] = i17;
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP32[i7 + (i11 << 4) + 8 >> 2] = HEAP32[i9 + (i11 << 4) + 8 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i19, i1) {
 i19 = i19 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f20 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i8 = i19 + 28 | 0;
 i18 = HEAP32[i8 >> 2] | 0;
 f20 = Math_fround(i1 >>> 0);
 i9 = ~~Math_fround(f20 * Math_fround(HEAPF32[i19 + 36 >> 2])) >>> 0;
 i14 = i1 << 2;
 i13 = (i9 << 2) + i14 | 0;
 i13 = (0 - i13 & 12) + i13 | 0;
 i10 = i19 + 4 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i13 + (i9 * 12 | 0) | 0, HEAP32[i19 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i12 = i11 + i14 | 0;
 i13 = i11 + i13 | 0;
 _memset(i11 | 0, -1, i14 | 0) | 0;
 i14 = i19 + 48 | 0;
 i7 = i19 + 16 | 0;
 if (HEAP32[i14 >> 2] | 0) {
  i15 = i1 + -1 | 0;
  i17 = 0;
  do {
   i16 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i16 + (i17 * 12 | 0) >> 2] | 0;
   i6 = HEAP32[i16 + (i17 * 12 | 0) + 4 >> 2] | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i3 = 5381; else {
    i3 = 5381;
    do {
     i3 = i3 * 33 ^ i2 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i2 = HEAP8[i4 >> 0] | 0;
    } while (i2 << 24 >> 24 != 0);
   }
   i2 = HEAP8[i6 >> 0] | 0;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i5 = i2;
    i2 = 5381;
    i4 = i6;
    do {
     i2 = i2 * 33 ^ i5 << 24 >> 24;
     i4 = i4 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
    } while (i5 << 24 >> 24 != 0);
   }
   i4 = i11 + (((i2 ^ i3) & i15) << 2) | 0;
   HEAP32[i12 + (i17 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i17;
   i4 = i16 + (i17 * 12 | 0) | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i13 + (i17 * 12 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i13 + (i17 * 12 | 0) + 8 >> 2] = HEAP32[i16 + (i17 * 12 | 0) + 8 >> 2];
   i17 = i17 + 1 | 0;
  } while (i17 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 }
 i17 = i19 + 12 | 0;
 i16 = HEAP32[i10 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i11;
 HEAP32[i19 + 24 >> 2] = i11;
 HEAP32[i19 + 32 >> 2] = i1;
 HEAP32[i19 + 20 >> 2] = i12;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i8 >> 2] = i9;
 i1 = i19 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i18;
 return;
}

function __ZN5physx20createContactPatchesERNS_18PxcNpThreadContextEjf(i12, i11, f10) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 f10 = Math_fround(f10);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i13 = i12 + 8724 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 + 4480 >> 2] | 0;
 i9 = i2 - i11 | 0;
 if ((i1 | 0) == 32) {
  i14 = 0;
  return i14 | 0;
 }
 if ((i2 | 0) != (i11 | 0)) {
  i2 = i12 + 4496 + (i1 * 12 | 0) | 0;
  i3 = i1 + 1 | 0;
  i7 = HEAP32[i12 + 384 + (i11 << 6) + 48 >> 2] | 0;
  i8 = HEAP32[i12 + 384 + (i11 << 6) + 52 >> 2] & 65535;
  HEAP16[i2 >> 1] = i11;
  HEAP16[i12 + 4496 + (i1 * 12 | 0) + 2 >> 1] = 1;
  HEAP16[i12 + 4496 + (i1 * 12 | 0) + 4 >> 1] = 0;
  HEAP16[i12 + 4496 + (i1 * 12 | 0) + 8 >> 1] = i7;
  HEAP16[i12 + 4496 + (i1 * 12 | 0) + 10 >> 1] = i7 >>> 16;
  HEAP16[i12 + 4496 + (i1 * 12 | 0) + 6 >> 1] = i8;
  if (i9 >>> 0 > 1) {
   i1 = i3;
   i3 = 1;
   i8 = 1;
   i7 = 0;
   while (1) {
    i4 = i8 + i11 | 0;
    i5 = i7 + i11 | 0;
    i6 = HEAP32[i12 + 384 + (i4 << 6) + 48 >> 2] | 0;
    if ((i6 | 0) == (HEAP32[i12 + 384 + (i5 << 6) + 48 >> 2] | 0)) if ((HEAP32[i12 + 384 + (i4 << 6) + 52 >> 2] | 0) == (HEAP32[i12 + 384 + (i5 << 6) + 52 >> 2] | 0)) {
     f15 = Math_fround(HEAPF32[i12 + 384 + (i4 << 6) >> 2]);
     f15 = Math_fround(f15 * Math_fround(HEAPF32[i12 + 384 + (i5 << 6) >> 2]));
     f16 = Math_fround(HEAPF32[i12 + 384 + (i4 << 6) + 4 >> 2]);
     f16 = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i12 + 384 + (i5 << 6) + 4 >> 2])));
     f15 = Math_fround(HEAPF32[i12 + 384 + (i4 << 6) + 8 >> 2]);
     if (!(Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i12 + 384 + (i5 << 6) + 8 >> 2]))) >= f10)) i14 = 8; else {
      i3 = i3 + 1 << 16 >> 16;
      i4 = i7;
     }
    } else i14 = 8; else i14 = 8;
    if ((i14 | 0) == 8) {
     i14 = 0;
     if ((i1 | 0) == 32) {
      i1 = 0;
      i14 = 14;
      break;
     }
     HEAP16[i2 + 2 >> 1] = i3;
     i2 = i12 + 4496 + (i1 * 12 | 0) | 0;
     i3 = HEAP32[i12 + 384 + (i4 << 6) + 52 >> 2] & 65535;
     HEAP16[i2 >> 1] = i4;
     HEAP16[i12 + 4496 + (i1 * 12 | 0) + 2 >> 1] = 1;
     HEAP16[i12 + 4496 + (i1 * 12 | 0) + 4 >> 1] = 0;
     HEAP16[i12 + 4496 + (i1 * 12 | 0) + 8 >> 1] = i6;
     HEAP16[i12 + 4496 + (i1 * 12 | 0) + 10 >> 1] = i6 >>> 16;
     HEAP16[i12 + 4496 + (i1 * 12 | 0) + 6 >> 1] = i3;
     i1 = i1 + 1 | 0;
     i3 = 1;
     i4 = i8;
    }
    i8 = i8 + 1 | 0;
    if (i8 >>> 0 >= i9 >>> 0) break; else i7 = i4;
   }
   if ((i14 | 0) == 14) return i1 | 0;
   if (i3 << 16 >> 16 != 1) HEAP16[i2 + 2 >> 1] = i3;
  } else i1 = i3;
 }
 HEAP32[i13 >> 2] = i1;
 i14 = 1;
 return i14 | 0;
}

function __ZN26DownloadHandlerAssetBundle14GetAssetBundleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i9 = i12 + 20 | 0;
 i3 = i12 + 16 | 0;
 i10 = i12 + 4 | 0;
 i6 = i1 + 20 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i8 = i1 + 24 | 0;
 if (!i2) {
  i11 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (HEAP32[i8 >> 2] | 0) {
  i11 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i7 = i1 + 28 | 0;
 if ((HEAP32[i7 >> 2] | 0) != 2) {
  i11 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZN33AssetBundleLoadFromAsyncOperation20IntegrateImmediatelyEv(i2);
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + 84 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i2 = 0; else {
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i3);
    i2 = HEAP32[i9 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 12;
   }
  }
  if ((i5 | 0) == 10) i5 = 12;
  if ((i5 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  i2 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 if (!(HEAP32[i1 + 92 >> 2] | 0)) {
  HEAP32[i7 >> 2] = 3;
  i13 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i12;
  return i13 | 0;
 } else {
  HEAP32[i7 >> 2] = -1;
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i10, i1);
  HEAP32[i11 >> 2] = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  __Z6FormatPKcz(i9, gb + 1026950 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 1026280 | 0, 176, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i13 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 return 0;
}

function __ZN13InitialModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.0500000007);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(.0500000007) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i3 = i1 + 352 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i3 = i1 + 772 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 778 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 692 | 0, i1 + 780 | 0, f2, HEAP16[i1 + 776 >> 1] | 0) | 0) & 1;
 i3 = i1 + 1036 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 1042 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 956 | 0, i1 + 1044 | 0, f2, HEAP16[i1 + 1040 >> 1] | 0) | 0) & 1;
 i3 = i1 + 1300 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 1306 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1220 | 0, i1 + 1308 | 0, f2, HEAP16[i1 + 1304 >> 1] | 0) | 0) & 1;
 i3 = i1 + 2356 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2276 | 0, i1 + 2364 | 0, f2, HEAP16[i1 + 2360 >> 1] | 0) | 0) & 1;
 i3 = i1 + 2548 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) > 0 ? i4 : 0;
 i1 = i1 + 2540 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN22UnityProfilerPerThread10BeginFrameE12ProfilerMode(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0;
 i2 = i6 + 4 | 0;
 __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj(i2, 0);
 HEAP32[i6 + 108 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 88 >> 2] = 0;
 HEAP32[i6 + 128 >> 2] = 0;
 i7 = i6 + 36 | 0;
 i8 = i6 + 48 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i6 + 52 | 0;
 HEAP32[i6 + 148 >> 2] = 0;
 HEAP8[i6 + 156 >> 0] = i1 >>> 4 & 1;
 __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE9push_backEv(i2) | 0;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 i5 = i6 + 16 | 0;
 i4 = (HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 >>> 14 << 2) >> 2] >> 2] | 0) + ((i4 & 16383) * 24 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i2 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 i5 = HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 14 << 2) >> 2] >> 2] | 0;
 d10 = +_emscripten_get_now() * 1.0e6;
 i4 = __Z17TimeToNanosecondsy(~~d10 >>> 0, +Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 i4 = ___udivdi3(i4 | 0, getTempRet0() | 0, 1e3, 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = i5 + ((i2 & 16383) * 24 | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i3 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 4, 8, i6 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 8, i6 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i3;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 + (i2 << 4) >> 2] = 0;
 i8 = i8 + (i2 << 4) + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 d10 = +_emscripten_get_now() * 1.0e6;
 i8 = +Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i9 = i6 + 224 | 0;
 HEAP32[i9 >> 2] = ~~d10 >>> 0;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i6 + 232 >> 2] = 0;
 i9 = i6 + 248 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 return;
}

function __ZN21LightProbeProxyVolume8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378243 | 0, i5, i1 + 36 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378261 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378275 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378289 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378303 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 378329 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 76 | 0, gb + 378347 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378367 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378384 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380944 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 48 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471230 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 48 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471230 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 48 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z15tessMeshZapFaceP8TESSmeshP8TESSface(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i11 + 8 >> 2] | 0;
 i13 = i10 + 136 | 0;
 i9 = i10 + 132 | 0;
 i7 = HEAP32[i12 + 12 >> 2] | 0;
 do {
  i8 = i7;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 0;
  i6 = i8 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!(HEAP32[i1 + 20 >> 2] | 0)) {
   i2 = i8 + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i8 + 16 >> 2] | 0;
   i4 = i5 + 8 | 0;
   if ((i3 | 0) == (i8 | 0)) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = i2;
    do {
     HEAP32[i1 + 16 >> 2] = 0;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
    i1 = HEAP32[i5 + 4 >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    HEAP32[i4 + 4 >> 2] = i1;
    HEAP32[i1 >> 2] = i4;
    i1 = HEAP32[i13 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i5;
    i1 = HEAP32[i6 >> 2] | 0;
   } else {
    HEAP32[i4 >> 2] = i3;
    i14 = HEAP32[i1 + 12 >> 2] | 0;
    i5 = i14 + 8 | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i14;
    HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] = i8;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i5 >> 2] = i3;
   }
   i2 = i1 + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i1 + 16 >> 2] | 0;
   i4 = i5 + 8 | 0;
   if ((i3 | 0) == (i1 | 0)) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = i2;
    do {
     HEAP32[i1 + 16 >> 2] = 0;
     i1 = HEAP32[i1 + 8 >> 2] | 0;
    } while ((i1 | 0) != (i2 | 0));
    i1 = HEAP32[i5 + 4 >> 2] | 0;
    i14 = HEAP32[i5 >> 2] | 0;
    HEAP32[i14 + 4 >> 2] = i1;
    HEAP32[i1 >> 2] = i14;
    i1 = HEAP32[i13 >> 2] | 0;
    HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i5;
    i1 = HEAP32[i6 >> 2] | 0;
   } else {
    HEAP32[i4 >> 2] = i3;
    i5 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] | 0;
    i14 = i5 + 8 | 0;
    i6 = HEAP32[i14 >> 2] | 0;
    HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i5;
    HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 12 >> 2] = i1;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i14 >> 2] = i3;
   }
   i14 = HEAP32[i9 >> 2] | 0;
   i6 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[HEAP32[i6 + 4 >> 2] >> 2] | 0;
   HEAP32[HEAP32[i4 + 4 >> 2] >> 2] = i5;
   HEAP32[HEAP32[i5 + 4 >> 2] >> 2] = i4;
   HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i6;
  }
 } while ((i8 | 0) != (i12 | 0));
 i14 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i14 >> 2] = i13;
 i14 = HEAP32[i10 + 140 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i11;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i2, i13, i4, i14, i11, i1, i3, i5) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i12 + 24 | 0;
 i9 = i12 + 12 | 0;
 i7 = HEAP32[i5 + 12 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i10 = i13 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i2 = 1;
  i1 = 0;
 } else {
  i2 = i1 + -1 | 0;
  i3 = i13 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i4 + (i2 << 3) + 4 >> 0] | 0)) {
   i2 = (mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, HEAP32[i4 + (i2 << 3) >> 2] | 0) | 0) & 1;
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   i4 = i1 + -1 | 0;
   HEAP8[i3 + (i4 << 3) + 5 >> 0] = i2;
   HEAP8[i3 + (i4 << 3) + 4 >> 0] = i2;
  } else i2 = 1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 HEAP8[i6 + 5 >> 0] = i2;
 if ((HEAP32[i13 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = (HEAP32[i13 + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i13, i6) | 0;
 HEAP32[i6 >> 2] = 0;
 if (i2 << 24 >> 24) {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
  i5 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 | 0, i6 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!((i1 | 0) == 0 | i5 ^ 1)) if (HEAP8[i1 >> 0] | 0) {
   HEAP32[i8 >> 2] = i1;
   __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i6, i9, i8);
   i5 = HEAP32[i9 + 4 >> 2] | 0;
   i8 = HEAP32[i9 + 8 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i6 + 8 >> 2] = i8;
   mftCall_vii(i7 | 0, i11 | 0, i6 | 0);
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return 1;
 }
 i3 = i1 + -1 | 0;
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 if (HEAP8[i2 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i2 + (i3 << 3) + 5 >> 0] | 0) {
  mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 40 >> 2] | 0, i14 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1 + -1;
 STACKTOP = i12;
 return 1;
}

function __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 56 | 0;
 i17 = i18;
 __ZN10InputEventC2ERKS_(i17, HEAP32[i6 + 280 >> 2] | 0);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) {
  f3 = Math_fround(HEAPF32[i17 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i17 + 8 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  if (f4 <= f3) if (Math_fround(f4 + Math_fround(HEAPF32[i1 + 60 >> 2])) > f3) {
   f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
   if (f3 <= f5) if (Math_fround(f3 + Math_fround(HEAPF32[i1 + 64 >> 2])) > f5) {
    i16 = i1;
    __ZN10InputEventD2Ev(i17);
    STACKTOP = i18;
    return i16 | 0;
   }
  }
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i12 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
  i16 = 0;
  __ZN10InputEventD2Ev(i17);
  STACKTOP = i18;
  return i16 | 0;
 }
 i13 = i6 + 96 | 0;
 i14 = i6 + 108 | 0;
 i15 = i6 + 172 | 0;
 i9 = i6 + 100 | 0;
 i10 = i17 + 4 | 0;
 i11 = i17 + 8 | 0;
 i8 = i1;
 while (1) {
  i1 = (HEAP32[i8 >> 2] | 0) + 180 | 0;
  i2 = i14;
  i6 = i1;
  i7 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   i2 = i2 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i2 | 0) < (i7 | 0));
  if (__Z20InvertMatrix4x4_FullPKfPf(i1, i16) | 0) {
   i2 = i14;
   i6 = i1;
   i7 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
    i2 = i2 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i2 | 0) < (i7 | 0));
   i2 = i15;
   i6 = i16;
   i7 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
    i2 = i2 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i2 | 0) < (i7 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i13 >> 2] | 0) != (i1 | 0)) __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i13, i17, i1 + -56 | 0);
  } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017878 | 0, 0, gb + 1017283 | 0, 258, 1, 0, 0, 0);
  i1 = HEAP32[i8 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f5 = Math_fround(HEAPF32[i11 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  if (f4 <= f3) if (Math_fround(f4 + Math_fround(HEAPF32[i1 + 60 >> 2])) > f3) {
   f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
   if (f3 <= f5) if (Math_fround(f3 + Math_fround(HEAPF32[i1 + 64 >> 2])) > f5) {
    i2 = 17;
    break;
   }
  }
  i8 = i8 + 4 | 0;
  if ((i8 | 0) == (HEAP32[i12 >> 2] | 0)) {
   i1 = 0;
   i2 = 17;
   break;
  }
 }
 if ((i2 | 0) == 17) {
  __ZN10InputEventD2Ev(i17);
  STACKTOP = i18;
  return i1 | 0;
 }
 return 0;
}

function __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i5 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i4 = i5 + 8 | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 96 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 << 4) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i16 = i9 + (i11 << 4) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = _i64Add(i17 | 0, i16 | 0, -1, ~i17 | 0) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i15 | 0, i18 | 0, 22) | 0;
   i15 = i19 ^ i15;
   i18 = (getTempRet0() | 0) ^ i18;
   i19 = _bitshift64Shl(i15 | 0, i18 | 0, 13) | 0;
   i19 = _i64Add(i15 | 0, i18 | 0, ~i19 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i18 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i19 | 0, i18 | 0, 8) | 0;
   i18 = ___muldi3(i15 ^ i19 | 0, (getTempRet0() | 0) ^ i18 | 0, 9, 0) | 0;
   i19 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i18 | 0, i19 | 0, 15) | 0;
   i18 = i15 ^ i18;
   i19 = (getTempRet0() | 0) ^ i19;
   i15 = _bitshift64Shl(i18 | 0, i19 | 0, 27) | 0;
   i15 = _i64Add(i18 | 0, i19 | 0, ~i15 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i19 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i15 | 0, i19 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i19;
   i15 = i5 + (((i18 ^ i15) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i11;
   i15 = i7 + (i11 << 4) | 0;
   HEAP32[i15 >> 2] = i17;
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP32[i7 + (i11 << 4) + 8 >> 2] = HEAP32[i9 + (i11 << 4) + 8 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx2Sc5Scene15prepareSimulateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i1 = i10 + 80 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[i10 + 2392 >> 0] = 0;
 HEAP32[i10 + 116 >> 2] = HEAP32[(HEAP32[i10 + 1196 >> 2] | 0) + 32 >> 2];
 i1 = i10 + 1204 | 0;
 i2 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0) + 5924 | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0);
 HEAP32[i10 + 196 >> 2] = 0;
 i2 = i10 + 1412 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0, 7)) != Math_fround(0.0)) i3 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0, 8)) != Math_fround(0.0)) i3 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0, 9)) != Math_fround(0.0)) i3 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0, 10)) != Math_fround(0.0)) i3 = 6;
  if ((i3 | 0) == 6) {
   i8 = i10 + 1188 | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
  }
  HEAP8[i2 >> 0] = 0;
 }
 i5 = i10 + 144 | 0;
 i6 = i10 + 148 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i10 + 136 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i8 = i10 + 152 | 0;
 if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5, i1);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (!i1) {
  __ZN5physx2Sc5Scene18visualizeStartStepEv(i10);
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 132 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  do if ((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i1) | 0) & 4) {
   i1 = __ZNK5physx2Sc18ParticleSystemCore6getSimEv(i1) | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    HEAP32[i6 >> 2] = i2 + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i9) | 0;
    break;
   }
  } while (0);
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 __ZN5physx2Sc5Scene18visualizeStartStepEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN29AssetBundleLoadAssetOperation34CollectFullPreloadDataDependenciesER13dynamic_arrayIiLj4EE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 8 | 0;
 i5 = i10;
 i6 = i8 + 160 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if ((HEAP16[gb + 1104044 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104044 | 0, i4);
  i7 = gb + 1104044 | 0;
 } else i7 = 0;
 i1 = i8 + 196 | 0;
 __ZN18AssetBundleManager30CollectPreloadDataDependenciesER4PPtrI11AssetBundleEbR13dynamic_arrayIiLj4EE(HEAP32[gb + 1104056 >> 2] | 0, i6, 0, i1);
 __ZN18AssetBundleManager30CollectPreloadDataDependenciesER4PPtrI11AssetBundleEbR13dynamic_arrayIiLj4EE(HEAP32[gb + 1104056 >> 2] | 0, i6, 0, i8 + 216 | 0);
 if ((i1 | 0) != (i9 | 0)) {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = i9 + 12 | 0;
  i1 = HEAP32[i8 + 208 >> 2] << 2;
  i2 = i1 >> 2;
  HEAP32[i6 >> 2] = i2;
  i3 = i9 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i9 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i1;
   break;
  } else i1 = HEAP32[i9 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 }
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i10;
 return;
}

function __ZN21ParticleSystemManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 33964 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 33196 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 289 | 0)) {
    i4 = i6 + 33196 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 33196 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 33196 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 33196 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 33196 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 33196 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 33196 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 33196 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = HEAP32[i2 + 37824 >> 2] | 0;
 L12 : do if (i3 | 0) {
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + 37056 + (i1 * 12 | 0) >> 2] | 0) == (fb + 153 | 0)) {
    if (!(HEAP8[i2 + 37056 + (i1 * 12 | 0) + 8 >> 0] | 0)) break;
    if (!(HEAP32[i2 + 37056 + (i1 * 12 | 0) + 4 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L12;
  }
  i6 = __ZN15GlobalCallbacks3GetEv() | 0;
  i7 = i6 + 37824 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  if (i5 | 0) {
   i1 = 0;
   while (1) {
    i3 = i6 + 37056 + (i1 * 12 | 0) | 0;
    if ((HEAP32[i3 >> 2] | 0) == (fb + 153 | 0)) {
     i4 = i6 + 37056 + (i1 * 12 | 0) + 8 | 0;
     i2 = i6 + 37056 + (i1 * 12 | 0) + 4 | 0;
     if (!(HEAP8[i4 >> 0] | 0)) break;
     if (!(HEAP32[i2 >> 2] | 0)) break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break L12;
   }
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP8[i4 >> 0] = 0;
   i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i5;
   if (i5 >>> 0 > i1 >>> 0) do {
    i5 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i6 + 37056 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 37056 + (i1 * 12 | 0) >> 2];
    HEAP32[i6 + 37056 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 37056 + (i1 * 12 | 0) + 4 >> 2];
    HEAP8[i6 + 37056 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 37056 + (i1 * 12 | 0) + 8 >> 0] | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
 } while (0);
 if ((HEAP32[i8 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i8 + 4 | 0);
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZN16ParticleRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048449 | 0, i5, i1 + 368 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048471 | 0, i6, i1 + 340 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048490 | 0, i5, i1 + 344 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048504 | 0, i5, i1 + 348 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048520 | 0, i5, i1 + 352 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 356 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048538 | 0, gb + 1048551 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048586 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048593 | 0, i6, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048600 | 0, i5, i1 + 364 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z42Physics2D_CUSTOM_INTERNAL_CALL_LinecastAllRK13Vector2fIcallS1_iff(i1, i2, i3, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11 + 8 | 0;
 i7 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i7);
 i15 = i12;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i9;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 i13 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 do if (!(__ZN16Physics2DManager11LinecastAllERK8Vector2fS2_iffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i13, i12, i7, i3, f5, f6, 0, 0, i10) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i2 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i7) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i7) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i3 = 0;
  while (1) {
   i13 = i2;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = i4;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = i14;
   i15 = i2 + 8 | 0;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i13 = i4 + 8 | 0;
   HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i13 + 4 >> 2] = i14;
   i13 = i2 + 16 | 0;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i15 = i4 + 16 | 0;
   HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i15 + 4 >> 2] = i14;
   HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else {
    i4 = i4 + 36 | 0;
    i2 = i2 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i8, i9, i13) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i12 = i9 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i7 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = ((i1 - i3 | 0) >>> 0) / (i7 >>> 0) | 0;
 i10 = i8 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6;
 if (i11 >>> 0 > i5 - i6 >> 3 >>> 0) {
  i4 = i6;
  if (!i6) i1 = i5; else {
   i1 = i8 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -8 - i6 | 0) >>> 3) << 3);
   __ZdlPv(i4);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = 0;
  }
  if (i11 >>> 0 > 536870911) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else i2 = 0;
  i7 = i1 - i2 | 0;
  i2 = i7 >> 2;
  i2 = i7 >> 3 >>> 0 < 268435455 ? (i2 >>> 0 < i11 >>> 0 ? i11 : i2) : 536870911;
  if (i2 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i1 = __Znwj(i2 << 3) | 0;
  i5 = i8 + 4 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i10 >> 2] = i1 + (i2 << 3);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) return;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i2 = i2 + i4 | 0;
   i1 = i1 + 8 | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i5 >> 2] = i1;
  return;
 }
 i9 = i8 + 4 | 0;
 i5 = (HEAP32[i9 >> 2] | 0) - i6 >> 3;
 i8 = HEAP32[i12 >> 2] | 0;
 if (i11 >>> 0 > i5 >>> 0) {
  i1 = i3;
  i6 = 1;
  i4 = i1;
  i1 = i1 + (Math_imul(i8, i5) | 0) | 0;
  i7 = i8;
 } else {
  i6 = 0;
  i4 = i3;
 }
 if ((i4 | 0) != (i1 | 0)) while (1) {
  i10 = i4;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i2;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  i3 = i3 + i8 | 0;
  i2 = i2 + 8 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i4 = i3;
 }
 if (!i6) {
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
  HEAP32[i9 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
  return;
 }
 i3 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 i2 = HEAP32[i9 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i1 = i1 + i7 | 0;
  i2 = i2 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i9 >> 2] = i2;
 return;
}

function __ZN5physx5cloth13MovingAverage4pushEjf(i10, i1, f5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i11 = i10 + 16 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i6 = i6 >>> 0 > i1 >>> 0 ? i1 : i6;
 i9 = i10 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) i7 = 3; else {
  i2 = i1 + -1 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  if (Math_fround(HEAPF32[i3 + (i2 << 3) + 4 >> 2]) != f5) i7 = 3; else {
   i8 = i3 + (i2 << 3) | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i6;
   i8 = i10;
  }
 }
 do if ((i7 | 0) == 3) {
  HEAP32[i4 >> 2] = i6;
  HEAPF32[i4 + 4 >> 2] = f5;
  if ((HEAP32[i10 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i7 = HEAP32[i4 + 4 >> 2] | 0;
   i8 = (HEAP32[i10 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 4 >> 2] = i7;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i8 = i10;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE15growAndPushBackERKS4_(i10, i4) | 0;
   i8 = i10;
   break;
  }
 } while (0);
 i7 = i10 + 12 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) + i6 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) i1 = i4; else {
  i10 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i9 = i10 >>> 0 < i11 >>> 0;
  i11 = i9 ? i10 : i11;
  HEAP32[i7 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 do {
  i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
  HEAP32[i1 >> 2] = i2 - i3;
  i1 = i1 + ((i2 >>> 0 <= i3 >>> 0 & 1) << 3) | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 if ((i1 | 0) == (i4 | 0)) {
  i10 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i9 = i10 >>> 0 < i11 >>> 0;
  i11 = i9 ? i10 : i11;
  HEAP32[i7 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj(i10, i4 + (HEAP32[i9 >> 2] << 3) - i1 >> 3);
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + (i10 << 3) | 0;
 if ((i10 | 0) <= 0) {
  i10 = HEAP32[i7 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i9 = i10 >>> 0 < i11 >>> 0;
  i11 = i9 ? i10 : i11;
  HEAP32[i7 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 while (1) {
  i8 = i1;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i2;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  i2 = i2 + 8 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
 }
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i9 = i10 >>> 0 < i11 >>> 0;
 i11 = i9 ? i10 : i11;
 HEAP32[i7 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 204 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899475 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN13AnimationClip15QuaternionCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 204 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899475 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13AnimationClip15QuaternionCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 204 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 24 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471245 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab20SerializedSubProgram13BufferBinding8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471245 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab20SerializedSubProgram13BufferBinding8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13GfxDeviceGLES20SetComputeBufferDataE15ComputeBufferIDPKvj(i6, i1, i7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i4) return;
 i5 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(HEAP32[i4 >> 2] | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i5) i9 = 12; else if ((HEAP32[i1 + 8 >> 2] | 0) >>> 0 < i8 >>> 0) i9 = 12; else {
  i3 = i4 + 16 | 0;
  i5 = i3;
  i11 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i6 + 7328 | 0;
  i10 = i2;
  i12 = HEAP32[i10 + 4 >> 2] | 0;
  if (i12 >>> 0 < i11 >>> 0 | ((i12 | 0) == (i11 | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0)) {
   i1 = HEAP32[i6 + 4860 >> 2] | 0;
   i12 = i6 + 5480 | 0;
   mftCall_vi(i1 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 8) | 0);
   i1 = i6 + 7368 | 0;
   i11 = i1;
   i10 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = _i64Add(i10 | 0, i11 | 0, 1, 0) | 0;
   i5 = getTempRet0() | 0;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i2;
   HEAP32[i1 >> 2] = i10;
   HEAP32[i1 + 4 >> 2] = i11;
   i12 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 8) | 0);
   i1 = i6 + 7376 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i12;
   i1 = HEAP32[i4 >> 2] | 0;
  }
 }
 if ((i9 | 0) == 12) {
  __ZN14DataBufferGLES7ReleaseEv(i1);
  i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, i8, 9, 0) | 0;
  HEAP32[i4 >> 2] = i1;
  i2 = i6 + 7328 | 0;
  i3 = i4 + 16 | 0;
 }
 __ZN14DataBufferGLES6UploadEiiPKv(i1, 0, i8, i7);
 i11 = i6 + 7368 | 0;
 i13 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = i3;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i2;
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 if (!(i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < i13 >>> 0 : 0))) return;
 i12 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i6 + 5480 >> 2] | 0, 8) | 0;
 i13 = i6 + 7376 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | i12;
 return;
}

function __ZL19b2FindMaxSeparationPiPK14b2PolygonShapeRK11b2TransformS2_S5_(i18, i12, i2, i15, i3) {
 i18 = i18 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, i16 = 0, i17 = 0, f19 = f0;
 i17 = HEAP32[i12 + 148 >> 2] | 0;
 i16 = HEAP32[i15 + 148 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f6 * f11);
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f8 * f14));
 f14 = Math_fround(Math_fround(f11 * f8) + Math_fround(f6 * f14));
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 4 >> 2]));
 f10 = Math_fround(Math_fround(f6 * f11) + Math_fround(f8 * f7));
 f11 = Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * f11));
 if ((i17 | 0) <= 0) {
  i17 = 0;
  f14 = Math_fround(-3402823469999999843913219.0e14);
  HEAP32[i18 >> 2] = i17;
  return Math_fround(f14);
 }
 if ((i16 | 0) > 0) {
  i9 = 0;
  f1 = Math_fround(-3402823469999999843913219.0e14);
  i2 = 0;
 } else {
  i3 = 0;
  f1 = Math_fround(-3402823469999999843913219.0e14);
  i2 = 0;
  do {
   i16 = f1 < Math_fround(3402823469999999843913219.0e14);
   f1 = i16 ? Math_fround(3402823469999999843913219.0e14) : f1;
   i2 = i16 ? i3 : i2;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i17 | 0));
  HEAP32[i18 >> 2] = i2;
  return Math_fround(f1);
 }
 do {
  f4 = Math_fround(HEAPF32[i12 + 84 + (i9 << 3) >> 2]);
  f5 = Math_fround(f14 * f4);
  f6 = Math_fround(HEAPF32[i12 + 84 + (i9 << 3) + 4 >> 2]);
  f5 = Math_fround(f5 - Math_fround(f13 * f6));
  f6 = Math_fround(Math_fround(f13 * f4) + Math_fround(f14 * f6));
  f4 = Math_fround(HEAPF32[i12 + 20 + (i9 << 3) >> 2]);
  f7 = Math_fround(f14 * f4);
  f8 = Math_fround(HEAPF32[i12 + 20 + (i9 << 3) + 4 >> 2]);
  f7 = Math_fround(f10 + Math_fround(f7 - Math_fround(f13 * f8)));
  f8 = Math_fround(f11 + Math_fround(Math_fround(f13 * f4) + Math_fround(f14 * f8)));
  i3 = 0;
  f4 = Math_fround(3402823469999999843913219.0e14);
  do {
   f19 = Math_fround(Math_fround(HEAPF32[i15 + 20 + (i3 << 3) >> 2]) - f7);
   f19 = Math_fround(Math_fround(f5 * f19) + Math_fround(f6 * Math_fround(Math_fround(HEAPF32[i15 + 20 + (i3 << 3) + 4 >> 2]) - f8)));
   f4 = f19 < f4 ? f19 : f4;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i16 | 0));
  i3 = f4 > f1;
  f1 = i3 ? f4 : f1;
  i2 = i3 ? i9 : i2;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i17 | 0));
 HEAP32[i18 >> 2] = i2;
 return Math_fround(f1);
}

function __Z28StateMachineValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object(i1, i2, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 40 | 0;
 i6 = i11 + 32 | 0;
 i4 = i11 + 24 | 0;
 i7 = i11 + 16 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 i14 = i2;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i4 = __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i10) | 0;
 __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i6, i4, i3, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 444 >> 2] | 0);
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i6 + 4 >> 0] | 0;
 L1 : do if (HEAP32[i2 >> 2] | 0) {
  i6 = i2;
  i4 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i14 = i7;
  HEAP32[i14 >> 2] = i4;
  HEAP32[i14 + 4 >> 2] = i6;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  switch (__Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i10) | 0) {
  case 2:
   {
    i12 = i8;
    HEAP32[i12 >> 2] = i4;
    HEAP32[i12 + 4 >> 2] = i6;
    i12 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 8 >> 2] | 0;
    i13 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
    i14 = __Z14GetMonoManagerv() | 0;
    HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    if (__Z22Check2MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_P6ObjectR11MonoManager(i10, i3, i12, i13, i5, i14) | 0) break L1;
    break;
   }
  case 3:
   {
    i8 = i9;
    HEAP32[i8 >> 2] = i4;
    HEAP32[i8 + 4 >> 2] = i6;
    i8 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 8 >> 2] | 0;
    i12 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
    i13 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 48 >> 2] | 0;
    i14 = __Z14GetMonoManagerv() | 0;
    HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    if (__Z22Check3MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_P6ObjectR11MonoManager(i10, i3, i8, i12, i13, i5, i14) | 0) break L1;
    break;
   }
  default:
   break L1;
  }
  HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
  HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 } while (0);
 i12 = i2;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 STACKTOP = i11;
 return;
}

function __Z24sweepCapsule_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i3, i9, i6, f7, i11, i2, f5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i11 = i11 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 var i4 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 12 | 0;
 i8 = i12 + 40 | 0;
 i13 = i12;
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(f22 * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f17 = Math_fround(f16 * Math_fround(2.0));
 f16 = Math_fround(Math_fround(f22 * f19) + Math_fround(Math_fround(f16 * f17) + Math_fround(-1.0)));
 f22 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(f22 * f17);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f19 * f15));
 f15 = Math_fround(Math_fround(f19 * f22) - Math_fround(f17 * f15));
 f17 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f16 = Math_fround(f17 * f16);
 f14 = Math_fround(f17 * f14);
 f15 = Math_fround(f17 * f15);
 f17 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f22 = Math_fround(f17 + f16);
 f19 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f21 = Math_fround(f19 + f14);
 f18 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f20 = Math_fround(f15 + f18);
 HEAPF32[i10 >> 2] = f22;
 HEAPF32[i10 + 4 >> 2] = f21;
 HEAPF32[i10 + 8 >> 2] = f20;
 f14 = Math_fround(f19 - f14);
 f15 = Math_fround(f18 - f15);
 HEAPF32[i10 + 12 >> 2] = Math_fround(f17 - f16);
 HEAPF32[i10 + 16 >> 2] = f14;
 HEAPF32[i10 + 20 >> 2] = f15;
 HEAPF32[i10 + 24 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + f5);
 i4 = HEAP16[i2 >> 1] | 0;
 f15 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f14 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
 HEAPF32[i13 >> 2] = f15;
 HEAPF32[i13 + 4 >> 2] = f14;
 HEAPF32[i13 + 8 >> 2] = f5;
 i3 = i11 + 40 | 0;
 if (!(__ZN5physx2Gu19sweepCapsuleCapsuleERKNS0_7CapsuleES3_RKNS_6PxVec3EfRfRS4_S8_jRt(i9, i10, i13, f7, i3, i11 + 16 | 0, i11 + 28 | 0, i4 & 65535, i8) | 0)) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 i1 = HEAP16[i8 >> 1] | 0;
 i2 = i11 + 12 | 0;
 HEAP16[i2 >> 1] = i1;
 if ((i4 & 512) == 0 ? 1 : Math_fround(HEAPF32[i3 >> 2]) != Math_fround(0.0)) {
  i13 = 1;
  STACKTOP = i12;
  return i13 | 0;
 }
 HEAP16[i2 >> 1] = i1 & 65535 | 1;
 i13 = __ZN5physx2Gu25computeCapsule_CapsuleMTDERKNS0_7CapsuleES3_RNS_10PxSweepHitE(i9, i10, i11) | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN9rapidjson8internal6u32toaEjPc(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 if (i6 >>> 0 < 1e4) {
  i2 = ((i6 >>> 0) / 100 | 0) << 1;
  i3 = ((i6 >>> 0) % 100 | 0) << 1;
  if (i6 >>> 0 > 999) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i7 = 5;
  } else if (i6 >>> 0 > 99) i7 = 5; else if (i6 >>> 0 > 9) i7 = 7;
  if ((i7 | 0) == 5) {
   HEAP8[i1 >> 0] = HEAP8[(i2 | 1) + (gb + 1035599) >> 0] | 0;
   i1 = i1 + 1 | 0;
   i7 = 7;
  }
  if ((i7 | 0) == 7) {
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i3 >> 0] | 0;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i1 >> 0] = HEAP8[(i3 | 1) + (gb + 1035599) >> 0] | 0;
  i7 = i1 + 1 | 0;
  return i7 | 0;
 }
 if (i6 >>> 0 >= 1e8) {
  i2 = (i6 >>> 0) / 1e8 | 0;
  i3 = (i6 >>> 0) % 1e8 | 0;
  if (i6 >>> 0 > 999999999) {
   i6 = i2 << 1;
   i7 = i1 + 1 | 0;
   HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i6 >> 0] | 0;
   HEAP8[i7 >> 0] = HEAP8[(i6 | 1) + (gb + 1035599) >> 0] | 0;
   i1 = i7;
  } else HEAP8[i1 >> 0] = i2 + 48;
  i7 = (i3 >>> 0) % 1e4 | 0;
  i4 = ((i3 >>> 0) / 1e6 | 0) << 1;
  i5 = ((((i3 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
  i6 = ((i7 >>> 0) / 100 | 0) << 1;
  i7 = ((i7 >>> 0) % 100 | 0) << 1;
  HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1035599 + i4 >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[(i4 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1035599 + i5 >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[(i5 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 5 >> 0] = HEAP8[gb + 1035599 + i6 >> 0] | 0;
  HEAP8[i1 + 6 >> 0] = HEAP8[(i6 | 1) + (gb + 1035599) >> 0] | 0;
  HEAP8[i1 + 7 >> 0] = HEAP8[gb + 1035599 + i7 >> 0] | 0;
  HEAP8[i1 + 8 >> 0] = HEAP8[(i7 | 1) + (gb + 1035599) >> 0] | 0;
  i7 = i1 + 9 | 0;
  return i7 | 0;
 }
 i5 = (i6 >>> 0) % 1e4 | 0;
 i2 = ((i6 >>> 0) / 1e6 | 0) << 1;
 i3 = ((((i6 >>> 0) / 1e4 | 0) >>> 0) % 100 | 0) << 1;
 i4 = ((i5 >>> 0) / 100 | 0) << 1;
 i5 = ((i5 >>> 0) % 100 | 0) << 1;
 if (i6 >>> 0 > 9999999) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i7 = 13;
 } else if (i6 >>> 0 > 999999) i7 = 13; else if (i6 >>> 0 > 99999) i7 = 15;
 if ((i7 | 0) == 13) {
  HEAP8[i1 >> 0] = HEAP8[(i2 | 1) + (gb + 1035599) >> 0] | 0;
  i1 = i1 + 1 | 0;
  i7 = 15;
 }
 if ((i7 | 0) == 15) {
  HEAP8[i1 >> 0] = HEAP8[gb + 1035599 + i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
 }
 HEAP8[i1 >> 0] = HEAP8[(i3 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1035599 + i4 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[(i4 | 1) + (gb + 1035599) >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1035599 + i5 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[(i5 | 1) + (gb + 1035599) >> 0] | 0;
 i7 = i1 + 5 | 0;
 return i7 | 0;
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_19PxHeightFieldSampleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i16, i3, i15, i17) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i18 + 4 | 0;
 i14 = i18;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i16 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i18;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i17; else {
  HEAP32[gb + 1457172 >> 2] = (HEAP32[gb + 1457172 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i14 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i13 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i14 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i13 = 9;
   } else i13 = 8;
  }
  if ((i13 | 0) == 8) {
   i12 = _strlen(i1) | 0;
   i11 = i1 + i12 | 0;
   if ((i12 | 0) > 0) {
    i4 = i1;
    i12 = 0;
    i5 = 0;
    i2 = 0;
    while (1) {
     if (!i4) i3 = 0; else if (!(HEAP8[i4 >> 0] | 0)) i3 = 0; else i3 = _strtoul(i4, i14, 10) | 0;
     i9 = i3 & 65535;
     i10 = i3 >>> 16 & 255;
     i8 = i3 >>> 24 & 255;
     i3 = i12 + 4 | 0;
     if (i5 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i6 = mftCall_iii(HEAP32[(HEAP32[i17 >> 2] | 0) + 8 >> 2] | 0, i17 | 0, i4 | 0) | 0;
      if (i12 | 0) _memcpy(i6 | 0, i2 | 0, i12 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i2 | 0);
      i7 = i6;
      i5 = i4;
      i2 = i6;
     } else i7 = i2;
     i4 = i7 + i12 | 0;
     HEAP8[i4 >> 0] = i9;
     HEAP8[i4 + 1 >> 0] = i9 >> 8;
     HEAP8[i7 + (i12 | 2) >> 0] = i10;
     HEAP8[i7 + (i12 | 3) >> 0] = i8;
     i4 = HEAP32[i14 >> 2] | 0;
     if (i4 >>> 0 >= i11 >>> 0) break; else i12 = i3;
    }
    i4 = i1;
    i3 = i3 >>> 2;
    i1 = i17;
   } else i13 = 9;
  }
  if ((i13 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i17;
  }
  HEAP32[i16 >> 2] = i2;
  HEAP32[i15 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, 0);
 STACKTOP = i18;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim20visualizeSpatialGridERNS_2Cm12RenderOutputE(i1, i24) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 32 | 0;
 i20 = i25;
 f21 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv(HEAP32[i1 + 52 >> 2] | 0));
 i22 = i1 + 360 | 0;
 if (!(HEAP32[i22 >> 2] | 0)) {
  STACKTOP = i25;
  return;
 }
 i16 = i1 + 356 | 0;
 i17 = i23 + 12 | 0;
 i18 = i23 + 4 | 0;
 i1 = i23 + 16 | 0;
 i2 = i23 + 8 | 0;
 i3 = i23 + 20 | 0;
 f4 = Math_fround(Math_fround(1.0) / f21);
 i5 = i20 + 4 | 0;
 i6 = i20 + 8 | 0;
 i7 = i20 + 12 | 0;
 i8 = i23 + 12 | 0;
 i9 = i20 + 16 | 0;
 i10 = i20 + 20 | 0;
 i11 = i20 + 24 | 0;
 i12 = i23 + 4 | 0;
 i13 = i23 + 8 | 0;
 i14 = i17 + 4 | 0;
 i15 = i17 + 8 | 0;
 i19 = 0;
 do {
  i26 = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + (i19 << 2) >> 2] | 0) + 44 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i23 | 0, i26 | 0);
  f29 = Math_fround(HEAPF32[i23 >> 2]);
  f29 = Math_fround(f29 + Math_fround(HEAPF32[i17 >> 2]));
  f28 = Math_fround(HEAPF32[i18 >> 2]);
  f28 = Math_fround(f28 + Math_fround(HEAPF32[i1 >> 2]));
  f27 = Math_fround(HEAPF32[i2 >> 2]);
  f29 = Math_fround(Math_fround(f29 * Math_fround(.5)) * f4);
  f28 = Math_fround(Math_fround(f28 * Math_fround(.5)) * f4);
  f27 = Math_fround(f4 * Math_fround(Math_fround(f27 + Math_fround(HEAPF32[i3 >> 2])) * Math_fround(.5)));
  HEAPF32[i23 >> 2] = Math_fround(f21 * Math_fround(Math_floor(Math_fround(f29))));
  HEAPF32[i12 >> 2] = Math_fround(f21 * Math_fround(Math_floor(Math_fround(f28))));
  HEAPF32[i13 >> 2] = Math_fround(f21 * Math_fround(Math_floor(Math_fround(f27))));
  HEAPF32[i17 >> 2] = Math_fround(f21 * Math_fround(Math_ceil(Math_fround(f29))));
  HEAPF32[i14 >> 2] = Math_fround(f21 * Math_fround(Math_ceil(Math_fround(f28))));
  HEAPF32[i15 >> 2] = Math_fround(f21 * Math_fround(Math_ceil(Math_fround(f27))));
  i26 = __ZN5physx2Cm12RenderOutputlsEj(i24, -16776961) | 0;
  HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP8[i11 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i26, i20) | 0;
  i19 = i19 + 1 | 0;
 } while (i19 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0);
 STACKTOP = i25;
 return;
}

function __ZN9Animation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 280 | 0, i5);
 i3 = i4 + 284 | 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i4 + 288 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 40 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 41 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i7 | 0) | 0;
  i7 = i7 | 16777216;
  i7 = (i7 | 0) == 50331648;
  i8 = i7 ? 1 : i8;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i7 = i8;
  i8 = _llvm_bswap_i32(i7 | 0) | 0;
  i7 = i7 | 16777216;
  i7 = (i7 | 0) == 50331648;
  i8 = i7 ? 1 : i8;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z47CopyWorldSpaceTransformDataWithoutNotificationsP6ObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i5 = i14 + 144 | 0;
 i6 = i14 + 128 | 0;
 i7 = i14 + 88 | 0;
 i8 = i14 + 80 | 0;
 i9 = i14 + 68 | 0;
 i10 = i14 + 16 | 0;
 i11 = i14 + 32 | 0;
 i12 = i14 + 8 | 0;
 i4 = i14;
 i3 = __Z37GetTransformFromComponentOrGameObjectP6Object(i1) | 0;
 i1 = __Z37GetTransformFromComponentOrGameObjectP6Object(i2) | 0;
 if (!((i3 | 0) != 0 & (i1 | 0) != 0)) {
  STACKTOP = i14;
  return;
 }
 __ZN9Transform18GetTransformAccessEv(i13, i3);
 i2 = i13;
 i15 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i16 = i10;
 HEAP32[i16 >> 2] = i15;
 HEAP32[i16 + 4 >> 2] = i2;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i13, i5, i6);
 i10 = i12;
 HEAP32[i10 >> 2] = i15;
 HEAP32[i10 + 4 >> 2] = i2;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E(i11, i13, i6);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i12 = HEAP32[i11 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i7 + 8 >> 2] = i12;
 i12 = HEAP32[i11 + 16 >> 2] | 0;
 i10 = HEAP32[i11 + 20 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = i12;
 HEAP32[i7 + 20 >> 2] = i10;
 i10 = HEAP32[i11 + 28 >> 2] | 0;
 i12 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP32[i7 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = i10;
 HEAP32[i7 + 32 >> 2] = i12;
 if ((HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) == 224) {
  __ZNK2UI13RectTransform13GetWorldSpaceER8Vector3fR8Vector2f(i3, i9, i8);
  __ZN9Transform18GetTransformAccessEv(i4, i1);
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E(i13, i5, i6, i7) | 0;
  __ZN2UI13RectTransform13SetWorldSpaceERK8Vector3fRK8Vector2fb(i1, i9, i8, 0);
 } else {
  __ZN9Transform18GetTransformAccessEv(i4, i1);
  HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E(i13, i5, i6, i7) | 0;
 }
 STACKTOP = i14;
 return;
}

function __ZNK5physx14NpArticulation14getWorldBoundsEf(i16, i1, f17) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 f17 = Math_fround(f17);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 i15 = i1 + 92 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  f7 = Math_fround(-8507058669999999534545717.0e13);
  f6 = Math_fround(-8507058669999999534545717.0e13);
  f5 = Math_fround(-8507058669999999534545717.0e13);
  f4 = Math_fround(8507058669999999534545717.0e13);
  f3 = Math_fround(8507058669999999534545717.0e13);
  f2 = Math_fround(8507058669999999534545717.0e13);
 } else {
  i1 = i1 + 88 | 0;
  i8 = i14 + 4 | 0;
  i9 = i14 + 8 | 0;
  i10 = i14 + 12 | 0;
  i11 = i14 + 16 | 0;
  i12 = i14 + 20 | 0;
  f2 = Math_fround(8507058669999999534545717.0e13);
  f3 = Math_fround(8507058669999999534545717.0e13);
  f4 = Math_fround(8507058669999999534545717.0e13);
  f5 = Math_fround(-8507058669999999534545717.0e13);
  f6 = Math_fround(-8507058669999999534545717.0e13);
  f7 = Math_fround(-8507058669999999534545717.0e13);
  i13 = 0;
  do {
   i20 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i13 << 2) >> 2] | 0;
   mftCall_viif(HEAP32[(HEAP32[i20 >> 2] | 0) + 40 >> 2] | 0, i14 | 0, i20 | 0, 1.00999999);
   f19 = Math_fround(HEAPF32[i14 >> 2]);
   f2 = f2 < f19 ? f2 : f19;
   f19 = Math_fround(HEAPF32[i8 >> 2]);
   f3 = f3 < f19 ? f3 : f19;
   f19 = Math_fround(HEAPF32[i9 >> 2]);
   f4 = f4 < f19 ? f4 : f19;
   f19 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = f5 > f19 ? f5 : f19;
   f19 = Math_fround(HEAPF32[i11 >> 2]);
   f6 = f6 > f19 ? f6 : f19;
   f19 = Math_fround(HEAPF32[i12 >> 2]);
   f7 = f7 > f19 ? f7 : f19;
   i13 = i13 + 1 | 0;
  } while (i13 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 }
 f21 = Math_fround(Math_fround(f5 + f2) * Math_fround(.5));
 f23 = Math_fround(Math_fround(f6 + f3) * Math_fround(.5));
 f22 = Math_fround(Math_fround(f7 + f4) * Math_fround(.5));
 f2 = Math_fround(Math_fround(Math_fround(f5 - f2) * Math_fround(.5)) * f17);
 f3 = Math_fround(Math_fround(Math_fround(f6 - f3) * Math_fround(.5)) * f17);
 f19 = Math_fround(Math_fround(Math_fround(f7 - f4) * Math_fround(.5)) * f17);
 f5 = Math_fround(f23 - f3);
 f6 = Math_fround(f22 - f19);
 f7 = Math_fround(f21 + f2);
 f17 = Math_fround(f23 + f3);
 f19 = Math_fround(f22 + f19);
 HEAPF32[i16 >> 2] = Math_fround(f21 - f2);
 HEAPF32[i16 + 4 >> 2] = f5;
 HEAPF32[i16 + 8 >> 2] = f6;
 HEAPF32[i16 + 12 >> 2] = f7;
 HEAPF32[i16 + 16 >> 2] = f17;
 HEAPF32[i16 + 20 >> 2] = f19;
 STACKTOP = i18;
 return;
}

function __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0;
 i8 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 i2 = (HEAP32[i1 + 72 >> 2] | 0) + (i8 & 1048575) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!(i8 & 1073741824)) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  return;
 }
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i8 = HEAP32[i2 + 12 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  do if (!(f3 <= Math_fround(0.0))) {
   if (f3 <= Math_fround(.00313080009)) {
    f6 = Math_fround(f3 * Math_fround(12.9200001));
    break;
   }
   if (f3 < Math_fround(1.0)) {
    f6 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
    break;
   }
   if (f3 == Math_fround(1.0)) f6 = Math_fround(1.0); else f6 = Math_fround(+Math_pow(+f3, .454545468));
  } else f6 = Math_fround(0.0); while (0);
  f3 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  do if (!(f3 <= Math_fround(0.0))) {
   if (f3 <= Math_fround(.00313080009)) {
    f5 = Math_fround(f3 * Math_fround(12.9200001));
    break;
   }
   if (f3 < Math_fround(1.0)) {
    f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
    break;
   }
   if (f3 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f3, .454545468));
  } else f5 = Math_fround(0.0); while (0);
  f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  do if (!(f3 <= Math_fround(0.0))) {
   if (f3 <= Math_fround(.00313080009)) {
    f3 = Math_fround(f3 * Math_fround(12.9200001));
    break;
   }
   if (f3 < Math_fround(1.0)) {
    f3 = Math_fround(Math_fround(Math_fround(+Math_pow(+f3, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
    break;
   }
   if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, .454545468));
  } else f3 = Math_fround(0.0); while (0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i2 = i7;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = i1;
 HEAP32[i9 + 12 >> 2] = i8;
 return;
}

function __ZN5physx5Elems4growEj(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16;
 i3 = (i14 * 24 | 0) + 15 & -16;
 i9 = (i14 << 2) + 15 & -16;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16 + 1 | 0, (i9 * 5 | 0) + i3 | 0, gb + 717789 | 0, 1582) | 0;
 i12 = i15 + 28 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i15 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i2 | 0) _memcpy(i10 | 0, i2 | 0, i1 * 24 | 0) | 0;
 _memset(i10 + (i1 * 24 | 0) | 0, 0, (i14 - i1 | 0) * 24 | 0) | 0;
 i4 = i10 + i3 | 0;
 HEAP32[i13 >> 2] = i10;
 i1 = HEAP32[i12 >> 2] | 0;
 i5 = i15 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) _memcpy(i4 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i4 + (i1 << 2) | 0, 0, i14 - i1 << 2 | 0) | 0;
 i3 = i3 + i9 | 0;
 i6 = i10 + i3 | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = HEAP32[i12 >> 2] | 0;
 i8 = i15 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) _memcpy(i6 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i6 + (i1 << 2) | 0, 0, i14 - i1 << 2 | 0) | 0;
 i3 = i3 + i9 | 0;
 i7 = i10 + i3 | 0;
 HEAP32[i8 >> 2] = i6;
 i1 = HEAP32[i12 >> 2] | 0;
 i5 = i15 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) _memcpy(i7 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i7 + (i1 << 2) | 0, 0, i14 - i1 << 2 | 0) | 0;
 i4 = i3 + i9 | 0;
 i6 = i10 + i4 | 0;
 HEAP32[i5 >> 2] = i7;
 i1 = HEAP32[i12 >> 2] | 0;
 i3 = i15 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) _memcpy(i6 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i6 + (i1 << 2) | 0, 0, i14 - i1 << 2 | 0) | 0;
 i4 = i10 + (i4 + i9) | 0;
 HEAP32[i3 >> 2] = i6;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i15 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) _memcpy(i4 | 0, i3 | 0, i1 << 2 | 0) | 0;
 _memset(i4 + (i1 << 2) | 0, 0, i14 - i1 << 2 | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 i3 = i15 + 32 | 0;
 i4 = i14 + -1 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 >>> 0 >= i4 >>> 0) {
  i10 = i1;
  HEAP32[i3 >> 2] = i10;
  i10 = HEAP32[i15 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
  i13 = HEAP32[i13 >> 2] | 0;
  HEAP32[i15 >> 2] = i13;
  HEAP32[i12 >> 2] = i14;
  STACKTOP = i16;
  return;
 }
 do {
  i10 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i2 + (i10 << 2) >> 2] = i1;
 } while ((i1 | 0) != (i4 | 0));
 i10 = HEAP32[i12 >> 2] | 0;
 HEAP32[i3 >> 2] = i10;
 i10 = HEAP32[i15 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i10);
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i15 >> 2] = i13;
 HEAP32[i12 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __ZN12AudioManager17MainThreadCleanupEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = i5 + 80 | 0;
 i3 = i5 + 84 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i4 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i2 = i5 + 44 | 0;
 i3 = i5 + 48 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i6 = i1 + 4 | 0;
  i4 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i2 = i5 + 52 | 0;
 i3 = i5 + 56 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i6 = i1 + 4 | 0;
  i4 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i2 = i5 + 60 | 0;
 i3 = i5 + 64 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i6 = i1 + 4 | 0;
  i4 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i2 = i5 + 68 | 0;
 i3 = i5 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i6 = i1 + 4 | 0;
  i4 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i1 = i5 + 88 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN12AudioManager9CloseFMODEv(i5);
  __ZN4FMOD6System7releaseEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 296 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN24AudioScriptBufferManagerD2Ev(i2);
  __ZdlPv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i5 + 240 | 0;
 i4 = i5 + 252 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i2 | 0) __ZN29AudioEffectInternalDefinitionD2Ev(i2);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i5 + 256 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  __ZN11GameManager17MainThreadCleanupEv(i5);
  HEAP32[gb + 1459924 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i5 + 244 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN11GameManager17MainThreadCleanupEv(i5);
 HEAP32[gb + 1459924 >> 2] = 0;
 return;
}

function _jpeg_fdct_ifast(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = i1;
 i3 = 7;
 while (1) {
  i7 = HEAP32[i2 >> 2] | 0;
  i4 = i2 + 28 | 0;
  i12 = HEAP32[i4 >> 2] | 0;
  i19 = i12 + i7 | 0;
  i12 = i7 - i12 | 0;
  i7 = i2 + 4 | 0;
  i16 = HEAP32[i7 >> 2] | 0;
  i13 = i2 + 24 | 0;
  i10 = HEAP32[i13 >> 2] | 0;
  i17 = i10 + i16 | 0;
  i10 = i16 - i10 | 0;
  i16 = i2 + 8 | 0;
  i8 = HEAP32[i16 >> 2] | 0;
  i11 = i2 + 20 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i14 = i6 + i8 | 0;
  i6 = i8 - i6 | 0;
  i8 = i2 + 12 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i18 = i2 + 16 | 0;
  i9 = HEAP32[i18 >> 2] | 0;
  i15 = i9 + i5 | 0;
  i20 = i15 + i19 | 0;
  i15 = i19 - i15 | 0;
  i19 = i14 + i17 | 0;
  HEAP32[i2 >> 2] = i20 + i19;
  HEAP32[i18 >> 2] = i20 - i19;
  i14 = (i17 - i14 + i15 | 0) * 181 >> 8;
  HEAP32[i16 >> 2] = i14 + i15;
  HEAP32[i13 >> 2] = i15 - i14;
  i9 = i5 - i9 + i6 | 0;
  i5 = i10 + i12 | 0;
  i13 = (i9 - i5 | 0) * 98 >> 8;
  i9 = i13 + (i9 * 139 >> 8) | 0;
  i5 = i13 + (i5 * 334 >> 8) | 0;
  i10 = (i6 + i10 | 0) * 181 >> 8;
  i6 = i10 + i12 | 0;
  i10 = i12 - i10 | 0;
  HEAP32[i11 >> 2] = i9 + i10;
  HEAP32[i8 >> 2] = i10 - i9;
  HEAP32[i7 >> 2] = i5 + i6;
  HEAP32[i4 >> 2] = i6 - i5;
  if ((i3 | 0) > 0) {
   i2 = i2 + 32 | 0;
   i3 = i3 + -1 | 0;
  } else {
   i2 = 7;
   break;
  }
 }
 while (1) {
  i17 = HEAP32[i1 >> 2] | 0;
  i20 = i1 + 224 | 0;
  i12 = HEAP32[i20 >> 2] | 0;
  i5 = i12 + i17 | 0;
  i12 = i17 - i12 | 0;
  i17 = i1 + 32 | 0;
  i8 = HEAP32[i17 >> 2] | 0;
  i11 = i1 + 192 | 0;
  i14 = HEAP32[i11 >> 2] | 0;
  i7 = i14 + i8 | 0;
  i14 = i8 - i14 | 0;
  i8 = i1 + 64 | 0;
  i16 = HEAP32[i8 >> 2] | 0;
  i13 = i1 + 160 | 0;
  i18 = HEAP32[i13 >> 2] | 0;
  i10 = i18 + i16 | 0;
  i18 = i16 - i18 | 0;
  i16 = i1 + 96 | 0;
  i19 = HEAP32[i16 >> 2] | 0;
  i6 = i1 + 128 | 0;
  i15 = HEAP32[i6 >> 2] | 0;
  i9 = i15 + i19 | 0;
  i4 = i9 + i5 | 0;
  i9 = i5 - i9 | 0;
  i5 = i10 + i7 | 0;
  HEAP32[i1 >> 2] = i4 + i5;
  HEAP32[i6 >> 2] = i4 - i5;
  i10 = (i7 - i10 + i9 | 0) * 181 >> 8;
  HEAP32[i8 >> 2] = i10 + i9;
  HEAP32[i11 >> 2] = i9 - i10;
  i15 = i19 - i15 + i18 | 0;
  i19 = i14 + i12 | 0;
  i11 = (i15 - i19 | 0) * 98 >> 8;
  i15 = i11 + (i15 * 139 >> 8) | 0;
  i19 = i11 + (i19 * 334 >> 8) | 0;
  i14 = (i18 + i14 | 0) * 181 >> 8;
  i18 = i14 + i12 | 0;
  i14 = i12 - i14 | 0;
  HEAP32[i13 >> 2] = i15 + i14;
  HEAP32[i16 >> 2] = i14 - i15;
  HEAP32[i17 >> 2] = i19 + i18;
  HEAP32[i20 >> 2] = i18 - i19;
  if ((i2 | 0) > 0) {
   i1 = i1 + 4 | 0;
   i2 = i2 + -1 | 0;
  } else break;
 }
 return;
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i12 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i3 - i1 | 0) / 68 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i12 = i1 + 44 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i12 + 8 >> 2] = 0;
   HEAP32[i12 + 12 >> 2] = 0;
   HEAP32[i12 + 16 >> 2] = 0;
   HEAP32[i12 + 20 >> 2] = 0;
   i1 = (HEAP32[i13 >> 2] | 0) + 68 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 68 | 0) + i2 | 0;
 if (i5 >>> 0 > 63161283) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i9 = (i3 - i4 | 0) / 68 | 0;
 i3 = i9 << 1;
 i5 = i9 >>> 0 < 31580641 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 63161283;
 i3 = (i1 - i4 | 0) / 68 | 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i10 + 8;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 68 | 0) | 0;
 HEAP32[i11 >> 2] = i6;
 i1 = i6 + (i3 * 68 | 0) | 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i11 + 12 | 0;
 HEAP32[i9 >> 2] = i6 + (i5 * 68 | 0);
 i4 = i3 + i2 | 0;
 i3 = i1;
 while (1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i5 = i3 + 44 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 68 | 0;
 }
 HEAP32[i7 >> 2] = i6 + (i4 * 68 | 0);
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i1 = i1 + -68 | 0;
   i2 = i2 + -68 | 0;
   __ZN19SpriteMeshGenerator4pathC2ERKS0_(i1, i2);
   HEAP32[i8 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i2;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i13;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__214__split_bufferIN19SpriteMeshGenerator4pathERNS_9allocatorIS2_EEED2Ev(i11);
 STACKTOP = i14;
 return;
}

function __ZN7Terrain13SetLightmapSTERK8Vector4f12LightmapType(i4, i2, i8) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i3 = i4 + 120 + (i8 << 4) | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if (f9 == Math_fround(HEAPF32[i3 >> 2])) {
  f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i1 = i4 + 120 + (i8 << 4) + 4 | 0;
  if (f9 == Math_fround(HEAPF32[i1 >> 2])) {
   f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   if (f9 == Math_fround(HEAPF32[i4 + 120 + (i8 << 4) + 8 >> 2])) {
    f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
    if (f9 == Math_fround(HEAPF32[i4 + 120 + (i8 << 4) + 12 >> 2])) return;
   }
  }
 } else i1 = i4 + 120 + (i8 << 4) + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i4 + 120 + (i8 << 4) + 8 >> 2] | 0;
 i1 = HEAP32[i4 + 120 + (i8 << 4) + 12 >> 2] | 0;
 if ((i8 | 0) == 1) {
  f11 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f11 * Math_fround(HEAPF32[i4 + 156 >> 2]));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f13 = Math_fround(f9 * Math_fround(HEAPF32[i4 + 160 >> 2]));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 164 >> 2])));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  f9 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i4 + 168 >> 2])));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = i3;
 i6 = i4 + 228 | 0;
 i4 = i4 + 240 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i6 >> 2] | 0;
 do {
  i14 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i14 + 76 + (i8 << 4) >> 2] = i2;
  HEAP32[i14 + 76 + (i8 << 4) + 4 >> 2] = i7;
  HEAP32[i14 + 76 + (i8 << 4) + 8 >> 2] = i5;
  HEAP32[i14 + 76 + (i8 << 4) + 12 >> 2] = i1;
  i14 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i14 + 32 + (i8 << 4) >> 2] = i2;
  HEAP32[i14 + 32 + (i8 << 4) + 4 >> 2] = i7;
  HEAP32[i14 + 32 + (i8 << 4) + 8 >> 2] = i5;
  HEAP32[i14 + 32 + (i8 << 4) + 12 >> 2] = i1;
  i3 = i3 + 20 | 0;
 } while ((i3 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE(i7, i8, f9, f1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f4 = Math_fround(f10 + f15);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f5 = Math_fround(f16 + f17);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f6 = Math_fround(f11 + f12);
 f13 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f4 = Math_fround(f4 + f13);
 f14 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f5 = Math_fround(f5 + f14);
 f3 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f4 = Math_fround(f4 * Math_fround(.333333343));
 f5 = Math_fround(f5 * Math_fround(.333333343));
 f6 = Math_fround(Math_fround(f6 + f3) * Math_fround(.333333343));
 f24 = Math_fround(f4 - Math_fround(HEAPF32[i7 >> 2]));
 f23 = Math_fround(f5 - Math_fround(HEAPF32[i7 + 4 >> 2]));
 f21 = Math_fround(f6 - Math_fround(HEAPF32[i7 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f19 = Math_fround(f24 * f18);
 f22 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f23 * f22));
 f20 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f21 * f20));
 i8 = f19 > Math_fround(0.0);
 f19 = i8 ? f19 : Math_fround(0.0);
 f19 = f19 < f9 ? f19 : f9;
 f18 = Math_fround(f24 - Math_fround(f18 * f19));
 f9 = Math_fround(f23 - Math_fround(f22 * f19));
 f19 = Math_fround(f21 - Math_fround(f20 * f19));
 f1 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f19 * f19) + Math_fround(Math_fround(f18 * f18) + Math_fround(f9 * f9))))) - f1) + Math_fround(-.0000999999974));
 if (f1 < Math_fround(0.0)) {
  i8 = 1;
  return i8 | 0;
 }
 f22 = Math_fround(f1 * f1);
 f19 = Math_fround(f4 - f10);
 f20 = Math_fround(f5 - f16);
 f21 = Math_fround(f6 - f11);
 f21 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f21 * f21));
 f20 = Math_fround(f4 - f15);
 f19 = Math_fround(f5 - f17);
 f23 = Math_fround(f6 - f12);
 f23 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f19 * f19)) + Math_fround(f23 * f23));
 f19 = Math_fround(f4 - f13);
 f20 = Math_fround(f5 - f14);
 f24 = Math_fround(f6 - f3);
 f24 = Math_fround(Math_fround(Math_fround(f19 * f19) + Math_fround(f20 * f20)) + Math_fround(f24 * f24));
 f23 = f21 > f23 ? f21 : f23;
 i8 = f22 <= (f23 > f24 ? f23 : f24);
 return i8 | 0;
}

function __ZN15ParticleEmitter20UpdateParticleSystemEf(i7, f8) {
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i2 = i9;
 if ((HEAP16[gb + 1469428 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469428 | 0, i1);
  i6 = gb + 1469428 | 0;
 } else i6 = 0;
 i5 = i7 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i4 = HEAP16[i7 + 204 >> 1] | 0;
  i1 = (i4 & 65535) >>> 8 & 255;
  if ((i4 & 255) << 24 >> 24) {
   i3 = HEAP32[i7 + 120 >> 2] | 0;
   i4 = i7 + 72 | 0;
   HEAP32[i7 + 100 >> 2] = i3;
   HEAP32[i7 + 96 >> 2] = i3;
   f10 = Math_fround(HEAPF32[i7 + 128 >> 2]);
   i3 = f10 < Math_fround(0.0);
   i2 = f10 > Math_fround(100000001999999991808.0);
   f10 = i2 ? Math_fround(100000001999999991808.0) : f10;
   HEAPF32[i7 + 104 >> 2] = i3 ? Math_fround(0.0) : f10;
   HEAP8[i7 + 108 >> 0] = HEAP8[i7 + 192 >> 0] | 0;
   if (i1 << 24 >> 24) HEAP8[i7 + 109 >> 0] = 1;
   i2 = i7 + 110 | 0;
   HEAP8[i2 >> 0] = i1;
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 190916 | 0) | 0;
   do if (!(HEAP8[i7 + 205 >> 0] | 0)) i1 = 18; else {
    if (i3 | 0) if (HEAP8[i7 + 206 >> 0] | 0) if ((HEAP32[i7 + 56 >> 2] | 0) == (HEAP32[i7 + 60 >> 2] | 0)) {
     i1 = i3 + 108 | 0;
     if (HEAP32[i1 >> 2] | 0) if (__Z14IsWorldPlayingv() | 0) {
      if ((HEAP32[i1 >> 2] | 0) == 2) {
       i1 = 19;
       break;
      }
      if (HEAP8[i7 + 109 >> 0] | 0) if (!(HEAP8[i2 >> 0] | 0)) {
       i1 = 19;
       break;
      }
     }
    }
    __ZN15ParticleEmitter9TimedEmitEf(i7, f8);
    i1 = 18;
   } while (0);
   if ((i1 | 0) == 18) if (i3 | 0) i1 = 19;
   if ((i1 | 0) == 19) __ZN16ParticleAnimator14UpdateAnimatorERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i3, i7 + 56 | 0, i4, f8);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 191360 | 0) | 0;
   if (i1 | 0) __ZN21WorldParticleCollider22UpdateParticleColliderERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i1, i7 + 56 | 0, i4, f8);
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 191192 | 0) | 0;
   if (i1 | 0) __ZN8Renderer18UpdateManagerStateEb(i1, 1);
  }
 }
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i9;
 return;
}

function __Z27GetMeshAssetPathDescriptivePK4Mesh(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 64 | 0;
 i7 = i11 + 48 | 0;
 i8 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i10 = i11;
 if (!i1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = -2147483616;
 HEAP32[i8 + 4 >> 2] = 17;
 i2 = i1;
 i3 = gb + 780571 | 0;
 i4 = i2 + 17 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 17 >> 0] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i7, i8, i9);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i10 + 11 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP8[i10 >> 0] = 34;
 HEAP8[i10 + 1 >> 0] = 0;
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i5, i7, i10);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i5 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
 }
 if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
 }
 if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(i1, i2, i17, i12, i13, i14, i15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 HEAP32[i16 >> 2] = i1;
 HEAP32[i16 + 4 >> 2] = i2;
 i8 = i17 + 4 | 0;
 i9 = i17 + 8 | 0;
 i10 = i14 + 256 | 0;
 i11 = i15 + 520 | 0;
 i1 = 0;
 i3 = 1;
 while (1) {
  i5 = i16 + (i1 << 3) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = i16 + (i1 << 3) + 4 | 0;
  i4 = i7 + 38 | 0;
  do if (!(HEAP8[i4 >> 0] | 0)) {
   i27 = HEAP8[i7 + 35 >> 0] | 0;
   f23 = Math_fround(HEAPF32[i12 + (i27 << 4) >> 2]);
   f26 = Math_fround(HEAPF32[i12 + (i27 << 4) + 4 >> 2]);
   f19 = Math_fround(HEAPF32[i12 + (i27 << 4) + 8 >> 2]);
   f24 = Math_fround(HEAPF32[i13 + (i27 << 4) >> 2]);
   f21 = Math_fround(HEAPF32[i13 + (i27 << 4) + 4 >> 2]);
   f24 = Math_fround(f23 - f24);
   f21 = Math_fround(f26 - f21);
   f19 = Math_fround(f19 - Math_fround(HEAPF32[i13 + (i27 << 4) + 8 >> 2]));
   f26 = Math_fround(HEAPF32[i7 >> 2]);
   f23 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f20 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f25 = Math_fround(HEAPF32[i17 >> 2]);
   f22 = Math_fround(HEAPF32[i8 >> 2]);
   if (Math_fround(Math_fround(Math_fround(f26 * Math_fround(f25 - f24)) + Math_fround(f23 * Math_fround(f22 - f21))) + Math_fround(f20 * Math_fround(Math_fround(HEAPF32[i9 >> 2]) - f19))) < Math_fround(0.0)) {
    i3 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i3 + 1;
    HEAP32[i14 + (i3 << 3) >> 2] = i7;
    HEAP32[i14 + (i3 << 3) + 4 >> 2] = i2;
    i3 = i1;
    break;
   }
   HEAP8[i4 >> 0] = 1;
   i4 = HEAP32[gb + 84752 + (i2 << 2) >> 2] | 0;
   i27 = HEAP32[gb + 84752 + (i4 << 2) >> 2] | 0;
   i1 = HEAP8[i7 + 32 + i27 >> 0] | 0;
   HEAP32[i5 >> 2] = HEAP32[i7 + 20 + (i27 << 2) >> 2];
   HEAP32[i6 >> 2] = i1;
   i1 = i3 + 1 | 0;
   i27 = HEAP8[i7 + 32 + i4 >> 0] | 0;
   HEAP32[i16 + (i3 << 3) >> 2] = HEAP32[i7 + 20 + (i4 << 2) >> 2];
   HEAP32[i16 + (i3 << 3) + 4 >> 2] = i27;
   if (!(HEAP8[i7 + 39 >> 0] | 0)) {
    i27 = HEAPU8[i7 + 40 >> 0] | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    HEAP32[i11 >> 2] = i3 + 1;
    HEAP32[i15 + 264 + (i3 << 2) >> 2] = i27;
    i3 = i1;
   } else i3 = i1;
  } else i3 = i1; while (0);
  i1 = i3 + -1 | 0;
  if (!i3) break;
  i2 = HEAP32[i16 + (i1 << 3) + 4 >> 2] | 0;
 }
 STACKTOP = i18;
 return;
}

function __ZN5physx2Gu15EdgeListBuilder18CreateEdgesToFacesEjPKjPKt(i9, i8, i1, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 if (!(__ZN5physx2Gu15EdgeListBuilder18CreateFacesToEdgesEjPKjPKt(i9, i8, i1, i2) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 1 | 0, HEAP32[i9 >> 2] << 3, gb + 728039 | 0, 225) | 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = i5;
 _memset(i5 | 0, 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
 i5 = (i8 | 0) == 0;
 if (i5) i2 = HEAP32[i7 >> 2] | 0; else {
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = 0;
  do {
   i4 = i2 + (HEAP32[i1 + (i3 * 12 | 0) >> 2] << 3) + 2 | 0;
   HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
   i4 = i2 + (HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] << 3) + 2 | 0;
   HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
   i4 = i2 + (HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] << 3) + 2 | 0;
   HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 HEAP32[i2 + 4 >> 2] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i3 = 0;
  i4 = 1;
  do {
   i3 = (HEAPU16[i2 + (i4 + -1 << 3) + 2 >> 1] | 0) + i3 | 0;
   HEAP32[i2 + (i4 << 3) + 4 >> 2] = i3;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i3 = i1 + -1 | 0;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, (HEAPU16[i2 + (i3 << 3) + 2 >> 1] | 0) + (HEAP32[i2 + (i3 << 3) + 4 >> 2] | 0) << 2, gb + 728039 | 0, 244) | 0;
 HEAP32[i9 + 20 >> 2] = i3;
 if (i5) i4 = HEAP32[i7 >> 2] | 0; else {
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  do {
   i6 = i4 + (HEAP32[i2 + (i1 * 12 | 0) >> 2] << 3) + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i7 + 1;
   HEAP32[i3 + (i7 << 2) >> 2] = i1;
   i7 = i4 + (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] << 3) + 4 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i6 + 1;
   HEAP32[i3 + (i6 << 2) >> 2] = i1;
   i6 = i4 + (HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] << 3) + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i7 + 1;
   HEAP32[i3 + (i7 << 2) >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 HEAP32[i4 + 4 >> 2] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i2 = 0;
  i3 = 1;
 } else {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 do {
  i2 = (HEAPU16[i4 + (i3 + -1 << 3) + 2 >> 1] | 0) + i2 | 0;
  HEAP32[i4 + (i3 << 3) + 4 >> 2] = i2;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 i1 = 1;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN4Mesh14SetBoneWeightsEPK13BoneInfluencei(i10, i8, i4) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i2 = i10 + 32 | 0;
 if ((HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i3 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i3, HEAP32[i2 >> 2] | 0);
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = i1 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
  HEAP32[i2 >> 2] = i3;
 }
 __ZN4Mesh14ClearSkinCacheEv(i10);
 i7 = HEAP32[i2 >> 2] | 0;
 if (!i4) {
  i1 = i7 + 164 | 0;
  i2 = i7 + 180 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 168 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 + 176 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  __ZN4Mesh18UpdateVertexFormatEv(i10);
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((HEAP32[i7 + 100 >> 2] | 0) != (i4 | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 428190 | 0, 0, gb + 425656 | 0, 1886, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i7 + 164 | 0;
 i6 = i7 + 176 | 0;
 i1 = i4 << 5;
 i2 = i1 >> 5;
 HEAP32[i6 >> 2] = i2;
 i3 = i7 + 180 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 16, i7 + 168 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i7 + 168 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i8 | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
 HEAP32[i9 >> 2] = gb + 30832;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = i10;
 i1 = HEAP32[i10 + 236 >> 2] | 0;
 i3 = i10 + 232 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i8 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i8 + 8 >> 2] | 0, gb + 1105196 | 0, i9);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 __ZN4Mesh18UpdateVertexFormatEv(i10);
 i10 = 1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN15LightmapSTCache5ApplyERK10RenderNode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 32 | 0;
 i3 = i5;
 i6 = i2 + 224 | 0;
 if ((HEAPU16[i6 >> 1] | 0) < 65534 ? 1 : (HEAPU16[i6 + 2 >> 1] | 0) < 65534) if (!(HEAP16[i2 + 182 >> 1] | 0)) {
  HEAP8[i1 >> 0] = 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP32[i1 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i1);
  i6 = i2 + 192 | 0;
  i3 = (HEAP32[i1 >> 2] | 0) + 976 | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i3 = i1 + 8 | 0;
  HEAP32[i4 >> 2] = 1073741885;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i3, i4, i6, 2);
  i6 = i2 + 208 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) + 992 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i4 >> 2] = 1073741886;
  __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i3, i4, i6, 2);
  STACKTOP = i5;
  return;
 }
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (HEAP32[i1 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i1);
 i2 = (HEAP32[i1 >> 2] | 0) + 976 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i2 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 1073741885;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i4, i3, 2);
 i6 = i3 + 16 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 992 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 >> 2] = 1073741886;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i2, i4, i6, 2);
 STACKTOP = i5;
 return;
}

function __ZN16Physics2DManager13CircleCastAllERK8Vector2ffS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i3, f8, i2, f9, i10, f11, f12, i13, i14, i15) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f8 = Math_fround(f8);
 i2 = i2 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i18 + 400 | 0;
 i16 = i18;
 if ((HEAP16[gb + 1457668 + 6 >> 1] | 0) > -1) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457668 | 0, i1);
  i17 = gb + 1457668 | 0;
 } else i17 = 0;
 if (!(f8 <= Math_fround(.0000999999974))) {
  i7 = f9 == Math_fround(inf);
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f6 * f6);
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f5 * f5));
  if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
  f6 = Math_fround(f6 * f4);
  f5 = Math_fround(f5 * f4);
  f9 = i7 ? Math_fround(1.0e5) : f9;
  f6 = Math_fround(f9 * f6);
  f9 = Math_fround(f9 * f5);
  f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f6);
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i3 + 4 >> 2]));
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i1 + 4 >> 2] = f9;
  __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i16, i3, i1, Math_fround(0.0), i10, f11, f12, i13, i14, i15);
  HEAP32[i16 >> 2] = gb + 156100 + 8;
  HEAP32[i16 + 372 >> 2] = gb + 151824 + 8;
  i1 = i16 + 376 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAPF32[i16 + 392 >> 2] = f8;
  i1 = __ZN15Cast2DQueryBase8RunQueryEb(i16, 0) | 0;
  if (!((i1 | 0) == 0 | i7 ^ 1)) {
   i2 = HEAP32[i15 + 12 >> 2] | 0;
   if (i2 | 0) {
    i15 = HEAP32[i15 >> 2] | 0;
    i3 = i15 + (i2 * 36 | 0) | 0;
    i2 = i15;
    do {
     i15 = i2 + 28 | 0;
     HEAPF32[i15 >> 2] = Math_fround(Math_fround(HEAPF32[i15 >> 2]) * Math_fround(1.0e5));
     i2 = i2 + 36 | 0;
    } while ((i2 | 0) != (i3 | 0));
   }
  }
  HEAP32[i16 >> 2] = gb + 156124 + 8;
  i2 = i16 + 340 | 0;
  if ((HEAP32[i16 + 356 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i16 + 344 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  __ZN16b2BlockAllocatorD2Ev(i16 + 268 | 0);
 } else i1 = 0;
 if (!i17) {
  STACKTOP = i18;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN5audio5mixer16SnapshotConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i1 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i1 + 24 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i7, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i2 = i7 + 8 | 0;
 i6 = i7 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i10 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i7 + 20 | 0;
 i5 = i7 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) i4 = 0; else {
  do {
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 >> 2] = i3;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 HEAP32[i8 >> 2] = i4;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN21ArchiveStorageCreator17StoreCurrentBlockEb(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i2 = i10 + 4 | 0;
 if (!(HEAP8[i1 + 1320 >> 0] | 0)) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 490305 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 490375 | 0, 655, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (!(HEAP16[i1 + 1316 >> 1] & 64)) {
  i9 = __ZN21ArchiveStorageCreator10StoreChunkEv(i1) | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 1308 >> 2] | 0;
 i3 = i1 + 1268 | 0;
 i7 = i1 + 1280 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i8 = _i64Add(i4 | 0, 0, i6 | 0, 0) | 0;
 i5 = getTempRet0() | 0;
 if (i5 >>> 0 > 0 | (i5 | 0) == 0 & i8 >>> 0 > 4294967295) {
  i8 = ~i6;
  HEAP32[i7 >> 2] = i8;
  i5 = i1 + 1284 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i8 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i8;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i8, 1, i1 + 1272 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, i1 + 1272 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i3 >> 2] = i2;
   break;
  } while (0);
  if (!(__ZN21ArchiveStorageCreator11StoreStreamEb(i1, 1) | 0)) {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
  HEAP32[i7 >> 2] = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i4, 1, i1 + 1272 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i3 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i1 + 1272 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i3 >> 2] = i2;
   break;
  } else i2 = HEAP32[i3 >> 2] | 0; while (0);
  _memmove(i2 | 0, i2 + i8 | 0, (HEAP32[i7 >> 2] | 0) - i8 | 0) | 0;
  HEAP32[i7 >> 2] = i6 + 1 + (HEAP32[i7 >> 2] | 0);
 }
 i9 = __ZN21ArchiveStorageCreator11StoreStreamEb(i1, i9) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN18ShadowMapJobHeaderC2ERK13ShadowJobDataPK15SharedLightDataPK10MinMaxAABB(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 8 | 0;
 i8 = i5;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 35724 + 8;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 3;
 i4 = i1 + 176 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 188 >> 2] = f11;
 HEAPF32[i1 + 192 >> 2] = f10;
 HEAPF32[i1 + 196 >> 2] = f9;
 __ZN13ShadowJobDataC2ERKS_(i1 + 200 | 0, i2);
 HEAP32[i1 + 1152 >> 2] = 0;
 HEAP32[i1 + 1156 >> 2] = 0;
 HEAP32[i1 + 1160 >> 2] = 0;
 HEAP32[i1 + 1164 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1168 >> 2] = 0;
 HEAP32[i1 + 1172 >> 2] = 0;
 HEAP32[i1 + 1176 >> 2] = 0;
 HEAP32[i1 + 1180 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1184 >> 2] = 0;
 HEAPF32[i1 + 1188 >> 2] = Math_fround(0.0);
 i4 = i1 + 1196 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAPF32[i1 + 1224 >> 2] = Math_fround(1.0);
 i4 = gb + 64024 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 1228 >> 2] = 0;
 HEAP32[i1 + 1240 >> 2] = 0;
 HEAP32[i1 + 1244 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i8);
 i2 = i7;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i1 + 1232 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId(i1 + 1248 | 0, gb + 383829 | 0, gb + 64024 | 0);
 HEAP32[i1 + 34032 >> 2] = 0;
 HEAP32[i1 + 34036 >> 2] = 0;
 HEAP32[i1 + 34296 >> 2] = 0;
 HEAP32[i1 + 34300 >> 2] = 0;
 i4 = i1 + 36856 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 _memset(i1 + 34040 | 0, 0, 256) | 0;
 _memset(i1 + 34304 | 0, 0, 2552) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 << 4) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i16 = i9 + (i11 << 4) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i16 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = _i64Add(i17 | 0, i16 | 0, -1, ~i17 | 0) | 0;
   i18 = getTempRet0() | 0;
   i19 = _bitshift64Lshr(i15 | 0, i18 | 0, 22) | 0;
   i15 = i19 ^ i15;
   i18 = (getTempRet0() | 0) ^ i18;
   i19 = _bitshift64Shl(i15 | 0, i18 | 0, 13) | 0;
   i19 = _i64Add(i15 | 0, i18 | 0, ~i19 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i18 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i19 | 0, i18 | 0, 8) | 0;
   i18 = ___muldi3(i15 ^ i19 | 0, (getTempRet0() | 0) ^ i18 | 0, 9, 0) | 0;
   i19 = getTempRet0() | 0;
   i15 = _bitshift64Lshr(i18 | 0, i19 | 0, 15) | 0;
   i18 = i15 ^ i18;
   i19 = (getTempRet0() | 0) ^ i19;
   i15 = _bitshift64Shl(i18 | 0, i19 | 0, 27) | 0;
   i15 = _i64Add(i18 | 0, i19 | 0, ~i15 | 0, ~(getTempRet0() | 0) | 0) | 0;
   i19 = getTempRet0() | 0;
   i18 = _bitshift64Lshr(i15 | 0, i19 | 0, 31) | 0;
   (getTempRet0() | 0) ^ i19;
   i15 = i5 + (((i18 ^ i15) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i11;
   i15 = i7 + (i11 << 4) | 0;
   HEAP32[i15 >> 2] = i17;
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP32[i7 + (i11 << 4) + 8 >> 2] = HEAP32[i9 + (i11 << 4) + 8 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 48 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 48 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 48 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 48 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferaSERKS1_(i2, i3) | 0;
   i3 = i3 + 48 | 0;
   i2 = i2 + 48 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -48 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i1);
   i1 = i1 + 48 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 48 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -48 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 89478485) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 48 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 44739242 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 89478485;
 if (i1 >>> 0 > 89478485) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 48 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 48 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i1);
  i1 = i1 + 48 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 48 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __Z12MoveCurveKeyR17AnimationCurveTplIfEi11KeyframeTplIfE(i13, i1, i14) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0;
 i2 = i13 + 56 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i6 = i10 + (i1 << 4) | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 i8 = i6 + 16 | 0;
 HEAPF32[i13 + 4 >> 2] = Math_fround(inf);
 HEAP32[i13 >> 2] = 0;
 HEAPF32[i13 + 32 >> 2] = Math_fround(inf);
 HEAP32[i13 + 28 >> 2] = 0;
 i7 = i13 + 68 | 0;
 _memmove(i6 | 0, i8 | 0, i10 + (HEAP32[i7 >> 2] << 4) - i8 | 0) | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i10 = i8 + -1 | 0;
 HEAP32[i7 >> 2] = i10;
 f11 = Math_fround(HEAPF32[i14 >> 2]);
 if (!i10) {
  f3 = Math_fround(inf);
  f4 = Math_fround(-inf);
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f4 = Math_fround(HEAPF32[i7 + (i8 + -2 << 4) >> 2]);
 }
 if (!(!(f3 >= f11) & !(f4 <= f11))) {
  i14 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i13, i14) | 0;
  return i14 | 0;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = i7;
 i1 = i10 << 4 >> 4;
 L7 : while (1) {
  while (1) {
   if (!i1) break L7;
   i2 = (i1 | 0) / 2 | 0;
   i5 = i6 + (i2 << 4) | 0;
   if (Math_fround(HEAPF32[i5 >> 2]) < f11) break; else i1 = i2;
  }
  i6 = i5 + 16 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 i6 = (i6 - i7 >> 4) + -1 | 0;
 i2 = i8 + -3 | 0;
 i2 = (i6 | 0) < (i2 | 0) ? i6 : i2;
 if ((i2 | 0) > 0) {
  i6 = i2 + -1 | 0;
  i1 = i8 + -2 | 0;
  f4 = Math_fround(f11 - Math_fround(HEAPF32[i7 + (((i6 | 0) > (i1 | 0) ? i1 : i6) << 4) >> 2]));
  i6 = f4 < Math_fround(0.0);
  f3 = Math_fround(-f4);
  if (!((i6 ? f3 : f4) < Math_fround(9.99999974e-06))) i9 = 12;
 } else {
  i2 = 0;
  i1 = i8 + -2 | 0;
  i9 = 12;
 }
 do if ((i9 | 0) == 12) {
  f4 = Math_fround(f11 - Math_fround(HEAPF32[i7 + (((i2 | 0) > (i1 | 0) ? i1 : i2) << 4) >> 2]));
  i9 = f4 < Math_fround(0.0);
  f3 = Math_fround(-f4);
  if (!((i9 ? f3 : f4) < Math_fround(9.99999974e-06))) {
   i2 = i2 + 1 | 0;
   i1 = i8 + -2 | 0;
   if ((i2 | 0) < (i10 | 0)) {
    f4 = Math_fround(f11 - Math_fround(HEAPF32[i7 + (((i2 | 0) > (i1 | 0) ? i1 : i2) << 4) >> 2]));
    i10 = f4 < Math_fround(0.0);
    f3 = Math_fround(-f4);
    if ((i10 ? f3 : f4) < Math_fround(9.99999974e-06)) break;
   }
   f11 = Math_fround(f11 - Math_fround(HEAPF32[i7 + (i1 << 4) >> 2]));
   i10 = f11 < Math_fround(0.0);
   f4 = Math_fround(-f11);
   if (!((i10 ? f4 : f11) < Math_fround(9.99999974e-06))) {
    i14 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i13, i14) | 0;
    return i14 | 0;
   }
  }
 } while (0);
 HEAP32[i14 >> 2] = i12;
 i14 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i13, i14) | 0;
 return i14 | 0;
}

function __ZN20ArchiveStorageReader9ReadBlockEjyyPvPy(i12, i1, i13, i14, i15, i16, i17, i18) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21;
 i20 = i12 + 104 | 0;
 if (!(HEAP16[(HEAP32[i20 >> 2] | 0) + (i1 * 12 | 0) + 8 >> 1] & 63)) {
  i20 = (HEAP32[i12 + 156 >> 2] | 0) + (i1 << 3) | 0;
  i20 = _i64Add(HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0, i13 | 0, i14 | 0) | 0;
  i20 = __ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy(i12, i20, getTempRet0() | 0, i15, i16, i17, i18) | 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 HEAP32[i19 >> 2] = 0;
 i2 = __ZN20ArchiveStorageReader18AcquireCachedBlockEjj(i12, i1, i13) | 0;
 if (!i2) {
  i1 = __ZN20ArchiveStorageReader28AcquireAndPrefillUnusedBlockEjPNS_11CacheResultE(i12, i1, i19) | 0;
  if (!i1) {
   if (i18 | 0) {
    i20 = i18;
    HEAP32[i20 >> 2] = 0;
    HEAP32[i20 + 4 >> 2] = 0;
   }
  } else {
   i11 = i1;
   i3 = 7;
  }
 } else {
  i11 = i2;
  i3 = 7;
 }
 if ((i3 | 0) == 7) {
  i4 = i11 + 4 | 0;
  i5 = i11 + 20 | 0;
  i6 = i11 + 8 | 0;
  L11 : do if ((i15 | 0) == 0 & (i16 | 0) == 0) {
   i2 = 0;
   i1 = 0;
  } else {
   i3 = 0;
   i9 = i14;
   i10 = i13;
   i2 = 0;
   i1 = 0;
   while (1) {
    while (1) {
     i7 = HEAP32[i4 >> 2] | 0;
     i8 = HEAP32[i5 >> 2] | 0;
     if (i9 >>> 0 < 0 | (i9 | 0) == 0 & i10 >>> 0 < (i8 + i7 | 0) >>> 0) break;
     i8 = __ZN20ArchiveStorageReader21FillStreamCachedBlockEPNS_11CachedBlockE(i12, i11) | 0;
     HEAP32[i19 >> 2] = i8;
     if (i8 | 0) break L11;
    }
    i7 = _i64Subtract(i10 | 0, i9 | 0, i7 | 0, 0) | 0;
    getTempRet0() | 0;
    i8 = i8 - i7 | 0;
    i1 = _i64Subtract(i15 | 0, i16 | 0, i2 | 0, i1 | 0) | 0;
    getTempRet0() | 0;
    i8 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
    _memcpy(i17 + i3 | 0, (HEAP32[i6 >> 2] | 0) + i7 | 0, i8 | 0) | 0;
    i2 = i8 + i3 | 0;
    i10 = _i64Add(i2 | 0, 0, i13 | 0, i14 | 0) | 0;
    i9 = getTempRet0() | 0;
    if (!(0 < i16 >>> 0 | 0 == (i16 | 0) & i2 >>> 0 < i15 >>> 0)) {
     i1 = 0;
     break;
    } else {
     i3 = i2;
     i1 = 0;
    }
   }
  } while (0);
  i17 = i11 + 28 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + -1;
  if (HEAP16[(HEAP32[i20 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 12 | 0) + 8 >> 1] & 64) HEAP32[i11 + 32 >> 2] = 0;
  if (i18 | 0) {
   i20 = i18;
   HEAP32[i20 >> 2] = i2;
   HEAP32[i20 + 4 >> 2] = i1;
  }
 }
 i20 = (HEAP32[i19 >> 2] | 0) > -1;
 STACKTOP = i21;
 return i20 | 0;
}

function __ZN12TreeRenderer24UpdateLegacyMeshPointersEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15;
 i11 = i14 + 364 | 0;
 i12 = i14 + 368 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1;
 if ((HEAP32[i12 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i15;
  return;
 }
 i7 = 0;
 i8 = 0;
 i6 = i2;
 i5 = i1;
 while (1) {
  i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + 28 >> 2] | 0;
  if ((HEAP32[i1 + (i8 * 156 | 0) + 4 >> 2] | 0) == 1) {
   i4 = HEAP32[i1 + (i8 * 156 | 0) + 16 >> 2] | 0;
   if (!i4) {
    i1 = 0;
    i3 = i5;
    i5 = i6;
   } else {
    HEAP32[i10 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 11; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 11; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 13;
     }
    }
    if ((i13 | 0) == 11) i13 = 13;
    if ((i13 | 0) == 13) {
     i13 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    }
    i5 = HEAP32[i11 >> 2] | 0;
    i2 = i5;
    i3 = i5;
   }
  } else {
   i1 = 0;
   i3 = i5;
   i5 = i6;
  }
  i2 = i2 + (i8 * 44 | 0) | 0;
  if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) i1 = i7; else {
   HEAP32[i2 >> 2] = i1;
   i1 = 1;
  }
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 >= (((HEAP32[i12 >> 2] | 0) - i3 | 0) / 44 | 0) >>> 0) break; else {
   i7 = i1;
   i6 = i5;
   i5 = i3;
   i2 = i3;
  }
 }
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i3 = HEAP32[i14 + 268 >> 2] | 0;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i14 + 256 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0;
 i1 = 0;
 do {
  i14 = HEAP32[i4 + (i1 * 24 | 0) >> 2] | 0;
  HEAP32[i14 + 280 >> 2] = HEAP32[i5 + ((HEAP32[i2 + ((HEAP32[i14 + 272 >> 2] | 0) * 40 | 0) + 32 >> 2] | 0) * 44 | 0) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 STACKTOP = i15;
 return;
}

function __ZNK7dtCrowd35InsertActiveAgentsIntoProximityGridEP15dtProximityGridii(i9, i10, i4, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((i4 | 0) > 0) {
  i5 = i9 + 16 | 0;
  i6 = i9 + 392 | 0;
  i7 = i9 + 444 | 0;
  i8 = i12 + 4 | 0;
  i2 = i12 + 8 | 0;
  i3 = i12 + 12 | 0;
  i1 = 0;
  do {
   i20 = HEAP32[i5 >> 2] | 0;
   i19 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   f16 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 292 >> 2]);
   f14 = Math_fround(HEAPF32[i7 >> 2]);
   f18 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 480 >> 2]);
   f17 = Math_fround(f18 + Math_fround(f14 * Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 516 >> 2])));
   f15 = Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 488 >> 2]);
   f14 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i20 + (i19 * 608 | 0) + 524 >> 2])));
   HEAPF32[i12 >> 2] = Math_fround((f18 < f17 ? f18 : f17) - f16);
   HEAPF32[i8 >> 2] = Math_fround((f15 < f14 ? f15 : f14) - f16);
   HEAPF32[i2 >> 2] = Math_fround(f16 + (f18 > f17 ? f18 : f17));
   HEAPF32[i3 >> 2] = Math_fround(f16 + (f15 > f14 ? f15 : f14));
   __ZN15dtProximityGrid7addItemEiPKf(i10, i1, i12);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i6 = HEAP32[i9 + 400 >> 2] | 0;
 if ((i11 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i7 = i9 + 416 | 0;
 i8 = i9 + 396 | 0;
 i2 = i9 + 444 | 0;
 i3 = i12 + 4 | 0;
 i4 = i12 + 8 | 0;
 i5 = i12 + 12 | 0;
 i1 = 0;
 do {
  i19 = HEAP32[i7 >> 2] | 0;
  i20 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  f18 = Math_fround(HEAPF32[i2 >> 2]);
  f14 = Math_fround(HEAPF32[i19 + (i20 * 92 | 0) >> 2]);
  f15 = Math_fround(f14 + Math_fround(f18 * Math_fround(HEAPF32[i19 + (i20 * 92 | 0) + 12 >> 2])));
  f17 = Math_fround(HEAPF32[i19 + (i20 * 92 | 0) + 8 >> 2]);
  f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i19 + (i20 * 92 | 0) + 20 >> 2])));
  f21 = Math_fround(HEAPF32[i19 + (i20 * 92 | 0) + 36 >> 2]);
  HEAPF32[i12 >> 2] = Math_fround((f14 < f15 ? f14 : f15) - f21);
  f16 = Math_fround(HEAPF32[i19 + (i20 * 92 | 0) + 44 >> 2]);
  HEAPF32[i3 >> 2] = Math_fround((f17 < f18 ? f17 : f18) - f16);
  HEAPF32[i4 >> 2] = Math_fround(f21 + (f14 > f15 ? f14 : f15));
  HEAPF32[i5 >> 2] = Math_fround(f16 + (f17 > f18 ? f17 : f18));
  __ZN15dtProximityGrid7addItemEiPKf(i10, i1 + i6 | 0, i12);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i13;
 return;
}

function __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i10 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 4 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 12 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i8 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i8 + 20 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i10);
 i5 = i8 + 28 | 0;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i9, 4);
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i8 + 24 >> 2] = i3;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i1 = i3 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i3 = i5;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, i2 + i3 | 0, i1 << 2);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 172 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899379 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN13AnimationClip12Vector3Curve8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 172 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899379 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13AnimationClip12Vector3Curve8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 172 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i3, i1, i9, i10, i8, i11, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0;
 if (!((HEAP8[i1 + 869 >> 0] | 0) != 0 & i8 >>> 0 < i11 >>> 0)) return;
 i4 = HEAP32[i1 + 500 >> 2] | 0;
 i5 = i10 + 4 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10 + 12 | 0;
 i2 = i3 + 80 | 0;
 i1 = i8;
 do {
  i24 = i4 + (i1 << 2) | 0;
  i8 = (HEAP32[i24 >> 2] | 0) + -13913692 | 0;
  i14 = (HEAP32[i24 + 4 >> 2] | 0) + -13913692 | 0;
  i19 = (HEAP32[i24 + 8 >> 2] | 0) + -13913692 | 0;
  i24 = (HEAP32[i24 + 12 >> 2] | 0) + -13913692 | 0;
  i3 = (Math_imul(i8, 1790253981) | 0) + 1900727103 | 0;
  i16 = (Math_imul(i14, 1790253981) | 0) + 1900727103 | 0;
  i23 = (Math_imul(i19, 1790253981) | 0) + 1900727103 | 0;
  i25 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i8 = i8 << 11 ^ i8;
  i14 = i14 << 11 ^ i14;
  i19 = i19 << 11 ^ i19;
  i24 = i24 << 11 ^ i24;
  f20 = Math_fround(Math_fround((i3 ^ i8 ^ i8 >>> 8) & 8388607 ^ i3 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f21 = Math_fround(Math_fround((i16 ^ i14 ^ i14 >>> 8) & 8388607 ^ i16 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f22 = Math_fround(Math_fround((i23 ^ i19 ^ i19 >>> 8) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f18 = Math_fround(Math_fround((i25 ^ i24 ^ i24 >>> 8) & 8388607 ^ i25 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i25 = f20 > Math_fround(HEAPF32[i10 >> 2]);
  i24 = f21 > Math_fround(HEAPF32[i5 >> 2]);
  i23 = f22 > Math_fround(HEAPF32[i6 >> 2]);
  i19 = f18 > Math_fround(HEAPF32[i7 >> 2]);
  i16 = i9 + (i1 << 2) | 0;
  f18 = Math_fround(HEAPF32[i16 >> 2]);
  i14 = i16 + 4 | 0;
  f22 = Math_fround(HEAPF32[i14 >> 2]);
  i3 = i16 + 8 | 0;
  f21 = Math_fround(HEAPF32[i3 >> 2]);
  i8 = i16 + 12 | 0;
  f20 = Math_fround(HEAPF32[i8 >> 2]);
  f12 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround((i25 ? Math_fround(1.0) : Math_fround(-1.0)) * f12);
  f15 = Math_fround(f12 * (i24 ? Math_fround(1.0) : Math_fround(-1.0)));
  f13 = Math_fround(f12 * (i23 ? Math_fround(1.0) : Math_fround(-1.0)));
  f15 = Math_fround(f22 + f15);
  f13 = Math_fround(f21 + f13);
  f12 = Math_fround(f20 + Math_fround(f12 * (i19 ? Math_fround(1.0) : Math_fround(-1.0))));
  HEAPF32[i16 >> 2] = Math_fround(f18 + f17);
  HEAPF32[i14 >> 2] = f15;
  HEAPF32[i3 >> 2] = f13;
  HEAPF32[i8 >> 2] = f12;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 return;
}

function __ZN22RenderingCommandBuffer17AddDrawProceduralERK10Matrix4x4fP8Materiali16GfxPrimitiveTypeiiP19ShaderPropertySheet(i12, i2, i11, i14, i15, i16, i17, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18;
 if (!i1) i6 = -1; else {
  i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 423766 | 0, 114) | 0;
  __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i3, i12 + 8 | 0, i1);
  i4 = i12 + 40 | 0;
  i5 = i12 + 52 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i8 = i12 + 56 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 2, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i4 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i7;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
 }
 i4 = i13;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 if (!i11) i9 = 0; else i9 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i12 + 8 | 0;
 i8 = i12 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i12 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i12 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 2;
 i4 = i4 + 7 & -4;
 i5 = i4 + 96 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i1 = i1 + i4 | 0;
 i4 = i1;
 i2 = i13;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 HEAP32[i1 + 64 >> 2] = i9;
 HEAP32[i1 + 68 >> 2] = i14;
 HEAP32[i1 + 72 >> 2] = i15;
 HEAP32[i1 + 76 >> 2] = i16;
 HEAP32[i1 + 80 >> 2] = i17;
 HEAP32[i1 + 84 >> 2] = i6;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 STACKTOP = i18;
 return;
}

function __ZN18GlslGpuProgramGLES19ApplyGpuProgramGLESERK20GpuProgramParametersPKh(i3, i9, i4) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 40 | 0;
 i11 = i15 + 36 | 0;
 i13 = i15 + 32 | 0;
 i14 = i15 + 24 | 0;
 i8 = i15;
 i2 = HEAP32[i3 + 88 >> 2] | 0;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 if (!(HEAP8[i3 + 84 >> 0] | 0)) i1 = (HEAP8[i3 + 85 >> 0] | 0) != 0; else i1 = 1;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, i2, i1, HEAP32[i3 + 96 >> 2] | 0);
 i7 = __Z16GetRealGfxDevicev() | 0;
 i6 = i7 + 6624 | 0;
 __ZN19ConstantBuffersGLES10ResetBindsEv(i6);
 HEAP32[i8 >> 2] = i3 + 16;
 HEAP32[i8 + 4 >> 2] = HEAP32[(__ZNK20GpuProgramParameters14GetValueParamsEv(i9) | 0) >> 2];
 HEAP32[i8 + 8 >> 2] = 0;
 i10 = i8 + 16 | 0;
 HEAP32[i10 >> 2] = i7;
 i5 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = -1;
 i1 = __ZN10GpuProgram20ApplyValueParametersI21GLESGpuProgramApplierEEPKhRT_RK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EES3_(i8, __ZNK20GpuProgramParameters14GetValueParamsEv(i9) | 0, i4) | 0;
 i2 = HEAP32[i9 + 80 >> 2] | 0;
 i3 = i9 + 84 | 0;
 if ((i2 | 0) != (HEAP32[i3 >> 2] | 0)) do {
  HEAP32[i5 >> 2] = __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i6, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0) | 0;
  i1 = __ZN10GpuProgram20ApplyValueParametersI21GLESGpuProgramApplierEEPKhRT_RK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EES3_(i8, i2 + 4 | 0, i1) | 0;
  i2 = i2 + 52 | 0;
 } while ((i2 | 0) != (HEAP32[i3 >> 2] | 0));
 i1 = __ZN10GpuProgram22ApplyTextureParametersEPKhR9GfxDevice10ShaderType(i1, i7, 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i7 = i9 + 60 | 0;
  i6 = i14 + 4 | 0;
  i5 = i1;
  i1 = i1 + 4 | 0;
  do {
   i3 = i5;
   i5 = i5 + 8 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i17 = HEAP32[i4 + (i2 << 4) + 8 >> 2] | 0;
    i16 = HEAP32[i4 + (i2 << 4) + 12 >> 2] | 0;
    i8 = HEAP32[i10 >> 2] | 0;
    HEAP32[i13 >> 2] = i1;
    i9 = HEAP32[i4 + (i2 << 4) + 4 >> 2] | 0;
    HEAP32[i14 >> 2] = i17;
    HEAP32[i6 >> 2] = i16;
    HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb(i8, i11, i9, i12, 0, 0);
   }
   i1 = i3 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != -1);
 }
 STACKTOP = i15;
 return;
}

function __ZN13SpeedTreeWind7SParamsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF32[i1 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(2.5);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 416 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 420 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 624 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 628 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 632 >> 2] = Math_fround(.300000012);
 i3 = i1 + 504 | 0;
 i4 = i3 + 120 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 + 756 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 760 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 764 >> 2] = Math_fround(.300000012);
 i3 = i1 + 636 | 0;
 i4 = i3 + 120 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i1 + 968 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 972 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 976 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 980 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 984 >> 2] = Math_fround(.00499999989);
 HEAPF32[i1 + 988 >> 2] = Math_fround(1.0);
 _memset(i1 + 768 | 0, 0, 200) | 0;
 HEAPF32[i1 + 1192 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 1196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1204 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 1208 >> 2] = Math_fround(.00499999989);
 HEAPF32[i1 + 1212 >> 2] = Math_fround(1.0);
 _memset(i1 + 992 | 0, 0, 200) | 0;
 HEAPF32[i1 + 1256 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 1260 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1264 >> 2] = Math_fround(.00499999989);
 HEAPF32[i1 + 1268 >> 2] = Math_fround(9.0);
 HEAPF32[i1 + 1272 >> 2] = Math_fround(32.0);
 HEAPF32[i1 + 1276 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 1280 >> 2] = Math_fround(.0500000007);
 HEAPF32[i1 + 1284 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 1288 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 1292 >> 2] = Math_fround(-.5);
 HEAPF32[i1 + 1296 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 1300 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 1304 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 1308 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 1312 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1316 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1320 >> 2] = Math_fround(4.0);
 HEAPF32[i1 + 1324 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 1328 >> 2] = Math_fround(1.0);
 _memset(i1 + 16 | 0, 0, 400) | 0;
 i2 = i1 + 1216 | 0;
 i3 = i1 + 424 | 0;
 i4 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i3 = i2;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 return;
}

function __ZNK5physx24MatrixNGaussSeidelSolver5solveEjfRKNS_8MatrixNNERKNS_7VectorNERS4_(i1, i14, f16, i12, i13, i15) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 f16 = Math_fround(f16);
 i12 = i12 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f17 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i8 = HEAP32[i12 + 2116 >> 2] | 0;
 HEAP32[i10 + 92 >> 2] = i8;
 i9 = (i8 | 0) == 0;
 if (i9) f6 = Math_fround(1.00000001e-10); else {
  f2 = Math_fround(0.0);
  i1 = 0;
  do {
   HEAPF32[i10 + (i1 << 2) >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i12 + (i1 * 92 | 0) + (i1 << 2) >> 2]));
   f6 = Math_fround(HEAPF32[i13 + (i1 << 2) >> 2]);
   f2 = Math_fround(f2 + Math_fround(f6 * f6));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
  f6 = Math_fround(f2 + Math_fround(1.00000001e-10));
 }
 if ((i14 | 0) != 0 & f16 < Math_fround(3402823469999999843913219.0e14)) i7 = 0; else {
  STACKTOP = i11;
  return;
 }
 do {
  if (i9) f2 = Math_fround(0.0); else {
   i5 = 0;
   do {
    if (!i5) f2 = Math_fround(0.0); else {
     i1 = 0;
     f2 = Math_fround(0.0);
     do {
      f3 = Math_fround(HEAPF32[i12 + (i5 * 92 | 0) + (i1 << 2) >> 2]);
      f2 = Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i15 + (i1 << 2) >> 2])));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i5 | 0));
    }
    i4 = i5;
    i5 = i5 + 1 | 0;
    if (i5 >>> 0 < i8 >>> 0) {
     i1 = i5;
     f3 = Math_fround(0.0);
     do {
      f17 = Math_fround(HEAPF32[i12 + (i4 * 92 | 0) + (i1 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f17 * Math_fround(HEAPF32[i15 + (i1 << 2) >> 2])));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
    } else f3 = Math_fround(0.0);
    f17 = Math_fround(HEAPF32[i10 + (i4 << 2) >> 2]);
    HEAPF32[i15 + (i4 << 2) >> 2] = Math_fround(f17 * Math_fround(Math_fround(Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]) - f2) - f3));
   } while ((i5 | 0) != (i8 | 0));
   if (i9) f2 = Math_fround(0.0); else {
    i4 = 0;
    f2 = Math_fround(0.0);
    do {
     f3 = Math_fround(-Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]));
     i1 = 0;
     do {
      f17 = Math_fround(HEAPF32[i12 + (i4 * 92 | 0) + (i1 << 2) >> 2]);
      f3 = Math_fround(f3 + Math_fround(f17 * Math_fround(HEAPF32[i15 + (i1 << 2) >> 2])));
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i8 | 0));
     f2 = Math_fround(f2 + Math_fround(f3 * f3));
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i8 | 0));
   }
  }
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < i14 >>> 0 ? Math_fround(f2 / f6) > f16 : 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(i8, i13, i7, f11, f12, i10, i9) {
 i8 = i8 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 28 | 0;
 i3 = i14;
 i4 = HEAP32[i8 + 16 >> 2] | 0;
 i5 = HEAP32[i8 + 28 >> 2] | 0;
 i6 = HEAP32[i8 + 12 >> 2] | 0;
 i1 = HEAP32[i8 + 36 >> 2] | 0;
 if (!i1) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
 } else {
  i1 = HEAP32[i1 + 64 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 }
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 if (!i1) {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 } else {
  i1 = HEAP32[i1 + 64 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 }
 i13 = __ZN5physx19PxsConstraintHelper21setupSolverConstraintERKNS_11PxTransformES3_PKNS_13PxcSolverBodyES6_PNS_17PxcSolverBodyDataES8_PFjPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvS3_S3_ESG_jffRNS_23PxcSolverConstraintDescERKNS_13PxsConstraintERNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE(i2, i3, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, i13 + (((HEAP16[i10 + 8 >> 1] | 0) == -1 ? HEAPU16[i10 + 10 >> 1] | 0 : 0) << 6) | 0, i13 + (((HEAP16[i10 + 12 >> 1] | 0) == -1 ? HEAPU16[i10 + 14 >> 1] | 0 : 0) << 6) | 0, i4, i5, i6, f11, f12, i10, i8, i7, i9) | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh(i6, i4, f10, f11, f2, f3, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, i20 = 0;
 i9 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f10 < Math_fround(0.0);
 i8 = i8 ? 2 : 0;
 i7 = f11 < Math_fround(0.0);
 i8 = (i7 ? i8 | 8 : i8) | f10 > f2;
 i8 = f11 > f3 ? i8 | 4 : i8;
 HEAP8[i1 >> 0] = i8;
 if (i8 | 0) {
  i9 = 0;
  return i9 | 0;
 }
 if ((i4 | 0) == 3) {
  f15 = Math_fround(HEAPF32[i6 >> 2]);
  f18 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f17 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) - f15);
  f16 = Math_fround(Math_fround(HEAPF32[i6 + 12 >> 2]) - f18);
  f14 = Math_fround(Math_fround(HEAPF32[i6 + 16 >> 2]) - f15);
  f13 = Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) - f18);
  f12 = Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16));
  f3 = Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * f13));
  f2 = Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13));
  f15 = Math_fround(f10 - f15);
  f10 = Math_fround(f11 - f18);
  f11 = Math_fround(Math_fround(f15 * f17) + Math_fround(f10 * f16));
  f13 = Math_fround(Math_fround(f15 * f14) + Math_fround(f10 * f13));
  f10 = Math_fround(Math_fround(f11 * f2) - Math_fround(f13 * f3));
  f11 = Math_fround(Math_fround(f12 * f13) - Math_fround(f11 * f3));
  i9 = f10 > Math_fround(0.0) & f11 > Math_fround(0.0) & Math_fround(Math_fround(f10 + f11) - Math_fround(Math_fround(f12 * f2) - Math_fround(f3 * f3))) < Math_fround(0.0);
  return i9 | 0;
 }
 i5 = i4 << 1;
 L8 : do if (!i4) i1 = 0; else {
  i1 = 0;
  i7 = i6 + (i5 + -2 << 2) | 0;
  i8 = i6;
  i6 = (HEAP32[i6 + (i5 + -1 << 2) >> 2] | 0) >= (i9 | 0) & 1;
  while (1) {
   i4 = i4 + -1 | 0;
   i20 = HEAP32[i8 + 4 >> 2] | 0;
   i5 = (i20 | 0) >= (i9 | 0);
   i19 = i6;
   i6 = i5 & 1;
   f2 = (HEAP32[tempDoublePtr >> 2] = i20, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if ((i19 | 0) != (i6 | 0)) {
    f16 = Math_fround(f2 - f11);
    f17 = Math_fround(HEAPF32[i7 >> 2]);
    f18 = Math_fround(HEAPF32[i8 >> 2]);
    f17 = Math_fround(f16 * Math_fround(f17 - f18));
    f18 = Math_fround(f18 - f10);
    if (!(i5 ^ f17 > Math_fround(f18 * Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) - f2)))) {
     if ((i1 | 0) == 1) {
      i1 = 0;
      break;
     }
     i1 = i1 + 1 | 0;
    }
   }
   if (!i4) break L8; else {
    i7 = i8;
    i8 = i8 + 8 | 0;
   }
  }
  return i1 | 0;
 } while (0);
 i20 = (i1 & 1 | 0) != 0;
 return i20 | 0;
}

function __ZN7mecanim12statemachine21SelectorStateConstant8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i2 = i9;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i6 + 4;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i2 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902998 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 903024 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i3 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 903037 | 0, HEAP32[gb + 36972 >> 2] | 0, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i7 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN27TrailModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 do switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 908 >> 2] | 0) + 8 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 908 >> 2] | 0) + 92 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 908 >> 2] | 0) + 276 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 908 >> 2] | 0) + 285 >> 0] | 0) != 0 & 1);
   break;
  }
 case 4:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 908 >> 2] | 0) + 286 >> 0] | 0) != 0 & 1);
   break;
  }
 case 5:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 908 >> 2] | 0) + 287 >> 0] | 0) != 0 & 1);
   break;
  }
 case 6:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 908 >> 2] | 0) + 288 >> 0] | 0) != 0 & 1);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 436 >> 0] | 0);
   break;
  }
 case 8:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 437 >> 0] | 0);
   break;
  }
 case 9:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 438 >> 0] | 0);
   break;
  }
 case 10:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 439 >> 0] | 0);
   break;
  }
 case 11:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 440 >> 0] | 0);
   break;
  }
 case 12:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 441 >> 0] | 0);
   break;
  }
 case 13:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 442 >> 0] | 0);
   break;
  }
 case 14:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 443 >> 0] | 0);
   break;
  }
 case 15:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 908 >> 2] | 0) + 528 >> 2]);
   break;
  }
 case 16:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 856 >> 0] | 0);
   break;
  }
 case 17:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 857 >> 0] | 0);
   break;
  }
 case 18:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 858 >> 0] | 0);
   break;
  }
 case 19:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 859 >> 0] | 0);
   break;
  }
 case 20:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 860 >> 0] | 0);
   break;
  }
 case 21:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 861 >> 0] | 0);
   break;
  }
 case 22:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 862 >> 0] | 0);
   break;
  }
 case 23:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 908 >> 2] | 0) + 863 >> 0] | 0);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 450747 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15ResourceManager10Dependency8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 450747 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15ResourceManager10Dependency8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E13find_positionERS3_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0;
 i22 = (HEAP32[i2 + 64 >> 2] | 0) + -1 | 0;
 i23 = HEAP32[i1 + 16 >> 2] | 0;
 i24 = HEAP32[i2 + 60 >> 2] | 0;
 i13 = HEAP32[i2 + 52 >> 2] | 0;
 i14 = i2 + 40 | 0;
 i15 = i2 + 36 | 0;
 i16 = i2 + 44 | 0;
 i17 = i2 + 48 | 0;
 i18 = i2 + 8 | 0;
 i19 = HEAP32[i1 + 4 >> 2] | 0;
 i20 = HEAP32[i1 >> 2] | 0;
 i21 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i8 = i2 + 28 | 0;
 i9 = i2 + 16 | 0;
 i10 = i2 + 12 | 0;
 i11 = i2 + 20 | 0;
 i4 = i2 + 24 | 0;
 i2 = 0;
 i3 = -1;
 i1 = i23;
 while (1) {
  i5 = i1 & i22;
  i1 = HEAP32[i24 + (i5 * 24 | 0) + 16 >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) if ((HEAP32[i14 >> 2] | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 4 >> 2] | 0)) if (!(_strcmp(HEAP32[i15 >> 2] | 0, HEAP32[i24 + (i5 * 24 | 0) >> 2] | 0) | 0)) if (!(_strcmp(HEAP32[i16 >> 2] | 0, HEAP32[i24 + (i5 * 24 | 0) + 8 >> 2] | 0) | 0)) if ((HEAP32[i17 >> 2] | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 12 >> 2] | 0)) break;
  if (!(HEAP8[i18 >> 0] | 0)) i25 = 18; else if (!(HEAP32[i7 >> 2] | 0)) i25 = 18; else if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 4 >> 2] | 0)) if (!(_strcmp(HEAP32[i10 >> 2] | 0, HEAP32[i24 + (i5 * 24 | 0) >> 2] | 0) | 0)) if (!(_strcmp(HEAP32[i11 >> 2] | 0, HEAP32[i24 + (i5 * 24 | 0) + 8 >> 2] | 0) | 0)) if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 12 >> 2] | 0)) i1 = (i3 | 0) == -1 ? i5 : i3; else i25 = 18; else i25 = 18; else i25 = 18; else i25 = 18; else i25 = 18;
  if ((i25 | 0) == 18) {
   i25 = 0;
   if ((i23 | 0) == (i1 | 0)) if ((i19 | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 4 >> 2] | 0)) if (!(_strcmp(i20, HEAP32[i24 + (i5 * 24 | 0) >> 2] | 0) | 0)) if (!(_strcmp(i21, HEAP32[i24 + (i5 * 24 | 0) + 8 >> 2] | 0) | 0)) if ((i6 | 0) == (HEAP32[i24 + (i5 * 24 | 0) + 12 >> 2] | 0)) {
    i25 = 23;
    break;
   } else i1 = i3; else i1 = i3; else i1 = i3; else i1 = i3; else i1 = i3;
  }
  i26 = i2 + 1 | 0;
  i2 = i26;
  i3 = i1;
  i1 = i26 + i5 | 0;
 }
 if ((i25 | 0) == 23) {
  HEAP32[i12 >> 2] = i5;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i12 >> 2] = -1;
 i1 = i12 + 4 | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i1 >> 2] = i5;
  return;
 } else {
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function __ZN9Transform11SetLocalTRSERK8Vector3fRK11QuaternionfS2_(i15, i1, i2, i8) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 64 | 0;
 i9 = i16 + 48 | 0;
 i10 = i16 + 32 | 0;
 i11 = i16 + 16 | 0;
 i12 = i16 + 8 | 0;
 i13 = i16;
 i7 = i15 + 32 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i9 + 8 >> 2] = i4;
 f20 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f21 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f17 = Math_fround(Math_fround(Math_fround(f20 * f20) + Math_fround(f19 * f19)) + Math_fround(Math_fround(f18 * f18) + Math_fround(f21 * f21)));
 f3 = Math_fround(Math_sqrt(Math_fround(f17)));
 f20 = Math_fround(f20 / f3);
 f19 = Math_fround(f19 / f3);
 f18 = Math_fround(f18 / f3);
 f3 = Math_fround(f21 / f3);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f20, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f19, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f18, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f17 > Math_fround(1.0e-30);
 i22 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i10 >> 2] = i5 ? i1 : 0;
 HEAP32[i10 + 4 >> 2] = i5 ? i2 : 0;
 HEAP32[i10 + 8 >> 2] = i5 ? i4 : 0;
 HEAP32[i10 + 12 >> 2] = i22;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = i12;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 i12 = __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i14, i9, i10) | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 i1 = __Z9SetLocalS15TransformAccessRKN4math7_float3E(i14, i11) | 0;
 if (!(i12 | i1)) {
  STACKTOP = i16;
  return;
 }
 i22 = i15 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i22 >> 2] | 0, HEAP32[i15 + 36 >> 2] | 0, i1 ? 11 : 3);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i22 >> 2] | 0);
 STACKTOP = i16;
 return;
}

function __ZN8Animator15UpdateWithDeltaEf(i5, f4) {
 i5 = i5 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 184 | 0;
 i8 = i10 + 176 | 0;
 i9 = i10;
 i7 = i10 + 192 | 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = i5 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) __ZN8Animator12CreateObjectEv(i5);
 if (!(HEAP8[i5 + 153 >> 0] | 0)) i2 = 7; else if (!(HEAP32[i5 + 168 >> 2] | 0)) i2 = 7;
 if ((i2 | 0) == 7) __ZN8Animator12CreateObjectEv(i5);
 if (HEAP32[i5 + 108 >> 2] | 0) {
  i1 = HEAP32[i5 + 624 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i5 + 420 >> 2];
  }
 }
 __ZN18PlayableControllerC2Ev(i9);
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) {
  __ZN18PlayableController4TickEf(i9, f4);
  i2 = HEAP32[(HEAP32[i5 + 628 >> 2] | 0) + 20 >> 2] | 0;
  i1 = gb + 64016 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i11 = i8;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = i3;
  HEAP32[i7 >> 2] = 0;
  i11 = i7 + 12 | 0;
  HEAP32[i11 >> 2] = 0;
  i3 = i7 + 16 | 0;
  i1 = i7 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i8);
  i12 = i6;
  i6 = HEAP32[i12 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i3 >> 2] = 1;
  i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 24, 8, i1, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i8;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i8 + 4 >> 2] = i5;
  HEAP32[i8 + 12 >> 2] = i2;
  __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb(i7, 1, 1, 1);
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i1);
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = i9 + 64 | 0;
 if ((HEAP32[i9 + 80 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 68 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 44 | 0;
 if ((HEAP32[i9 + 60 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 48 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 24 | 0;
 if ((HEAP32[i9 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 28 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 4 | 0;
 if ((HEAP32[i9 + 20 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 8 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 STACKTOP = i10;
 return;
}

function __ZN16BlendShapeVertex8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 32 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN5Cache17ReadCacheInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlS9_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i8 = i9 + 16 | 0;
 i3 = i9;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 444384 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i7, i2, i3);
 i6 = __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE(i8, i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (i6) {
  i1 = i8 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i6 = i3 << 24 >> 24 < 0;
  __Z27FindSeparatedPathComponentsPKcjc(i7, i6 ? HEAP32[i8 >> 2] | 0 : i8, i6 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255, 10);
  i3 = HEAP32[i7 >> 2] | 0;
  i6 = i7 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) i2 = 0; else {
   if (i4) {
    HEAP32[i4 >> 2] = __Z11StringToIntPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i3 + 12 | 0;
   if ((i4 | 0) == (i2 | 0)) i2 = 1; else if ((__Z11StringToIntPKc((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0) < 1) i2 = 0; else {
    i2 = i3 + 24 | 0;
    if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) i2 = 0; else if (!i5) i2 = 1; else {
     HEAP32[i5 >> 2] = __Z11StringToIntPKc((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
     i2 = 1;
    }
   }
   i3 = HEAP32[i7 >> 2] | 0;
  }
  if (i3 | 0) {
   i4 = HEAP32[i6 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) {
    do {
     i5 = i4 + -12 | 0;
     HEAP32[i6 >> 2] = i5;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
     i4 = HEAP32[i6 >> 2] | 0;
    } while ((i4 | 0) != (i3 | 0));
    i3 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i3);
  }
 } else {
  i2 = 0;
  i1 = i8 + 11 | 0;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return i2 | 0;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 STACKTOP = i9;
 return i2 | 0;
}

function __ZN17GeneralConnection18RegisterConnectionEji(i9, i10, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i5 = i9 + 92 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i1 = i5;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i10 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i10 | 0)) if (HEAP32[i1 + 20 >> 2] | 0) __ZN17GeneralConnection10DisconnectEj(i9, i10);
 }
 i7 = __Znwj(108) | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP8[i7 + 17 >> 0] = 0;
 HEAP8[i7 + 18 >> 0] = 0;
 __ZN20BufferedSocketStreamC2Eijj(i7 + 20 | 0, i4, 8388608, 8388608);
 i6 = i9 + 88 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i5;
  i4 = i5;
  i3 = i5;
  i2 = 20;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i10 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 13;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i10 | 0)) {
     i2 = 19;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 17;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 13) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   i2 = 20;
   break;
  } else if ((i2 | 0) == 17) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = 20;
   break;
  } else if ((i2 | 0) == 19) {
   HEAP32[i8 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i3 = i8;
    i2 = 20;
    break;
   } else break;
  }
 } while (0);
 if ((i2 | 0) == 20) {
  i1 = __Znwj(24) | 0;
  HEAP32[i1 + 16 >> 2] = i10;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i6 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 92 >> 2] | 0, i2);
  i8 = i9 + 96 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i1 + 20 >> 2] = i7;
 i4 = i9 + 112 | 0;
 i3 = i9 + 116 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 } else i2 = 0;
 do {
  mftCall_vi(HEAP32[i1 + (i2 << 2) >> 2] | 0, i10 | 0);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i11;
 return;
}

function __Z40TextGenerator_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 if (!i7) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1008413 | 0, i8);
 i3 = HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 24 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i1 >> 2] | 0) | 0;
 i6 = i5 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i3, 60, i2) | 0;
  HEAP32[i1 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
 }
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = 0;
 while (1) {
  i23 = HEAP32[i1 >> 2] | 0;
  i22 = HEAP32[i1 + 4 >> 2] | 0;
  i21 = HEAP32[i1 + 8 >> 2] | 0;
  i20 = HEAP32[i1 + 12 >> 2] | 0;
  i19 = HEAP32[i1 + 16 >> 2] | 0;
  i18 = HEAP32[i1 + 20 >> 2] | 0;
  i17 = HEAP32[i1 + 24 >> 2] | 0;
  i16 = HEAP32[i1 + 28 >> 2] | 0;
  i15 = HEAP32[i1 + 32 >> 2] | 0;
  i14 = HEAP32[i1 + 36 >> 2] | 0;
  i13 = HEAP32[i1 + 40 >> 2] | 0;
  i12 = HEAP32[i1 + 44 >> 2] | 0;
  i11 = HEAP32[i1 + 48 >> 2] | 0;
  i10 = HEAP32[i1 + 52 >> 2] | 0;
  i9 = HEAP32[i1 + 56 >> 2] | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 60) | 0;
  HEAP32[i5 >> 2] = i23;
  HEAP32[i5 + 4 >> 2] = i22;
  HEAP32[i5 + 8 >> 2] = i21;
  HEAP32[i5 + 12 >> 2] = i20;
  HEAP32[i5 + 16 >> 2] = i19;
  HEAP32[i5 + 20 >> 2] = i18;
  HEAP32[i5 + 24 >> 2] = i17;
  HEAP32[i5 + 28 >> 2] = i16;
  HEAP32[i5 + 32 >> 2] = i15;
  HEAP32[i5 + 36 >> 2] = i14;
  HEAP32[i5 + 40 >> 2] = i13;
  HEAP32[i5 + 44 >> 2] = i12;
  HEAP32[i5 + 48 >> 2] = i11;
  HEAP32[i5 + 52 >> 2] = i10;
  HEAP32[i5 + 56 >> 2] = i9;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 60 | 0;
 }
 i22 = HEAP32[i6 >> 2] | 0;
 i23 = i7 + 12 | 0;
 HEAP32[i23 >> 2] = i22;
 i23 = i7 + 16 | 0;
 i22 = HEAP32[i23 >> 2] | 0;
 i22 = i22 + 1 | 0;
 HEAP32[i23 >> 2] = i22;
 STACKTOP = i8;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR11IndexSorterPiEEbT0_S4_T_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   if ((Math_imul(HEAP32[i9 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i2 << 3) >> 2] | 0) | 0) <= (Math_imul(HEAP32[i9 + (i3 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i3 << 3) >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   HEAP32[i8 >> 2] = i2;
   HEAP32[i1 >> 2] = i3;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i3 = i8 + 8 | 0;
   __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i8, i8 + 4 | 0, i3, i9) | 0;
   i1 = i8 + 12 | 0;
   L3 : do if ((i1 | 0) == (i7 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i6 = HEAP32[i1 >> 2] | 0;
     i5 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
     i10 = Math_imul(HEAP32[i4 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i4 + (i6 << 3) >> 2] | 0) | 0;
     if ((i10 | 0) > (Math_imul(HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i4 + (i5 << 3) >> 2] | 0) | 0)) {
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = i5;
       if ((i3 | 0) == (i8 | 0)) {
        i3 = i8;
        break;
       }
       i4 = i3 + -4 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       i10 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
       i11 = Math_imul(HEAP32[i10 + (i6 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i6 << 3) >> 2] | 0) | 0;
       if ((i11 | 0) <= (Math_imul(HEAP32[i10 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i5 << 3) >> 2] | 0) | 0)) break; else {
        i11 = i3;
        i3 = i4;
        i4 = i11;
       }
      }
      HEAP32[i3 >> 2] = i6;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 4 | 0) == (i7 | 0);
       break L3;
      }
     }
     i3 = i1 + 4 | 0;
     if ((i3 | 0) == (i7 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i11 = i1;
      i1 = i3;
      i3 = i11;
     }
    }
   } while (0);
   i11 = i1 | i2;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj467ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 260 | 0, i6 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj468ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 276 | 0, i6 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj469ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 292 | 0, i6 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj470ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 308 | 0, i6 + 5 | 0);
 i1 = i7 + 324 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj471ENS_22PxRepXPropertyAccessorILj471ES4_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj472ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 340 | 0, i6 + 7 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj473ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 356 | 0, i6 + 8 | 0);
 STACKTOP = i8;
 return i6 + 10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 374071 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI23ShaderVariantCollectionE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 374071 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI23ShaderVariantCollectionE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZL31SetRenderStateForStencilMarkingR9GfxDeviceR17ShaderPassContextjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5 + 24 | 0;
 i8 = i5 + 12 | 0;
 i7 = i5 + 92 | 0;
 i6 = i5;
 i2 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(__ZN8Material23GetStencilWriteMaterialEv() | 0, 0, i2, 0, 1) | 0;
 HEAP8[i9 + 1 >> 0] = 1;
 HEAP8[i9 + 2 >> 0] = 0;
 HEAP8[i9 + 3 >> 0] = 1;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP8[i9 + 8 >> 0] = 15;
 HEAP8[i9 + 9 >> 0] = 1;
 HEAP8[i9 + 10 >> 0] = 0;
 HEAP8[i9 + 11 >> 0] = 1;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 15;
 HEAP8[i9 + 17 >> 0] = 1;
 HEAP8[i9 + 18 >> 0] = 0;
 HEAP8[i9 + 19 >> 0] = 1;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP8[i9 + 24 >> 0] = 15;
 HEAP8[i9 + 25 >> 0] = 1;
 HEAP8[i9 + 26 >> 0] = 0;
 HEAP8[i9 + 27 >> 0] = 1;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP8[i9 + 32 >> 0] = 15;
 HEAP8[i9 + 33 >> 0] = 1;
 HEAP8[i9 + 34 >> 0] = 0;
 HEAP8[i9 + 35 >> 0] = 1;
 HEAP32[i9 + 36 >> 2] = 0;
 HEAP8[i9 + 40 >> 0] = 15;
 HEAP8[i9 + 41 >> 0] = 1;
 HEAP8[i9 + 42 >> 0] = 0;
 HEAP8[i9 + 43 >> 0] = 1;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP8[i9 + 48 >> 0] = 15;
 HEAP8[i9 + 49 >> 0] = 1;
 HEAP8[i9 + 50 >> 0] = 0;
 HEAP8[i9 + 51 >> 0] = 1;
 HEAP32[i9 + 52 >> 2] = 0;
 HEAP8[i9 + 56 >> 0] = 15;
 HEAP8[i9 + 57 >> 0] = 1;
 HEAP8[i9 + 58 >> 0] = 0;
 HEAP8[i9 + 59 >> 0] = 1;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP8[i9 >> 0] = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i10 + 60 >> 2] | 0;
 mftCall_vii(i11 | 0, i1 | 0, mftCall_iii(HEAP32[i10 + 44 >> 2] | 0, i1 | 0, i9 | 0) | 0);
 HEAP32[i8 + 4 >> 2] = 0;
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i8 >> 2] = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i9 + 64 >> 2] | 0;
 mftCall_vii(i10 | 0, i1 | 0, mftCall_iii(HEAP32[i9 + 56 >> 2] | 0, i1 | 0, i8 | 0) | 0);
 HEAP8[i7 >> 0] = 0;
 HEAP8[i7 + 1 >> 0] = 4;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i8 + 68 >> 2] | 0;
 mftCall_vii(i9 | 0, i1 | 0, mftCall_iii(HEAP32[i8 + 48 >> 2] | 0, i1 | 0, i7 | 0) | 0);
 HEAP8[i6 + 3 >> 0] = 0;
 HEAP8[i6 + 6 >> 0] = 0;
 HEAP8[i6 + 10 >> 0] = 0;
 HEAP8[i6 >> 0] = 1;
 HEAP8[i6 + 1 >> 0] = -1;
 HEAP8[i6 + 2 >> 0] = 16;
 HEAP8[i6 + 11 >> 0] = 5;
 HEAP8[i6 + 7 >> 0] = 5;
 HEAP8[i6 + 9 >> 0] = 0;
 HEAP8[i6 + 5 >> 0] = 0;
 i7 = i3 | 0 ? 6 : 8;
 HEAP8[i6 + 8 >> 0] = i7;
 HEAP8[i6 + 4 >> 0] = i7;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i7 + 72 >> 2] | 0;
 mftCall_viii(i8 | 0, i1 | 0, mftCall_iii(HEAP32[i7 + 52 >> 2] | 0, i1 | 0, i6 | 0) | 0, i4 | i3 | 0);
 STACKTOP = i5;
 return i2 | 0;
}

function __Z39TrailRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517706 | 0, i2);
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517706 | 0, i2);
 if (!i3) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i9 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 + 384 >> 2] | 0;
 i8 = i6 + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i2 = i6 + 48 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i2 = i6 + 76 | 0;
 if ((i8 | 0) == (i9 | 0)) {
  i8 = i6 + 96 | 0;
  i9 = i9 + 76 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 + 56 >> 2] | 0;
 i8 = i6 + 88 | 0;
 i1 = HEAP32[i9 + 68 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i8 >> 2] = i3;
 i4 = i6 + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i6 + 80 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 80 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
 i8 = i6 + 96 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN9profiling14SamplerManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 12 | 0;
 i6 = i9;
 i7 = i2 + 84 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i8 = i2 + 88 | 0;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i3, i2, i4, i4 + ((HEAP32[i8 >> 2] | 0) * 36 | 0) | 0, 1);
 i4 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 36 | 0) | 0;
 __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i6, i2, i4, i4, 1);
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i5 >> 2] | 0)) do {
  i1 = HEAP32[i1 + 32 >> 2] | 0;
  if (HEAP16[i1 + 6 >> 1] & 1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
   HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] = 0;
  }
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i3) | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 36 | 0) | 0;
  __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b(i6, i2, i1, i1, 1);
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (HEAP32[i5 >> 2] | 0));
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5clearEv(i2);
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev(i2);
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 132 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899368 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN13AnimationClip10FloatCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 132 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899368 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13AnimationClip10FloatCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 132 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14NavMeshManager9LayerDataaSERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 i5 = i9 + 4 | 0;
 if ((i8 | 0) == (i9 | 0)) return i9 | 0;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i8 + 16 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 i2 = i9 + 24 | 0;
 i6 = HEAP32[i8 + 24 >> 2] | 0;
 i7 = i9 + 36 | 0;
 i1 = (HEAP32[i8 + 36 >> 2] | 0) * 24 | 0;
 i3 = (i1 | 0) / 24 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i9 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 24 | 0) | 0;
 i5 = i9 + 44 | 0;
 i6 = HEAP32[i8 + 44 >> 2] | 0;
 i7 = i9 + 56 | 0;
 i1 = HEAP32[i8 + 56 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 60 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 8, i9 + 48 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i9 + 48 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 return i9 | 0;
}

function __Z38LineRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517706 | 0, i2);
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517706 | 0, i2);
 if (!i3) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i9 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 + 344 >> 2] | 0;
 i8 = i6 + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i2 = i6 + 48 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i2 = i6 + 76 | 0;
 if ((i8 | 0) == (i9 | 0)) {
  i8 = i6 + 96 | 0;
  i9 = i9 + 76 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i9 + 56 >> 2] | 0;
 i8 = i6 + 88 | 0;
 i1 = HEAP32[i9 + 68 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i8 >> 2] = i3;
 i4 = i6 + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i6 + 80 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 80 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
 i8 = i6 + 96 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i10;
 return;
}

function __Z21SpriteRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi(i2, i17, i20, i1) {
 i2 = i2 | 0;
 i17 = i17 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i19 + 88 | 0;
 i18 = i19 + 72 | 0;
 i15 = i19 + 8 | 0;
 i16 = i19;
 i8 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i8 + (i17 * 360 | 0) + 328 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i19;
  return;
 }
 if ((HEAP16[gb + 1161692 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1161692 | 0, HEAP32[i8 + (i17 * 360 | 0) + 352 >> 2] | 0);
  i11 = gb + 1161692 | 0;
 } else i11 = 0;
 i12 = HEAP32[i20 >> 2] | 0;
 i12 = i12 >>> 6 & 2 | i12 >>> 1 & 1;
 i3 = HEAP32[gb + 1161636 + (i12 << 3) >> 2] | 0;
 i13 = __Z12GetGfxDevicev() | 0;
 i14 = __ZN9GfxDevice13GetDynamicVBOEv(i13) | 0;
 HEAP32[i18 >> 2] = 0;
 i4 = i18 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = -1;
 HEAP32[i18 + 12 >> 2] = 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = HEAP32[i1 + 40 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0;
 if (mftCall_iiiiiii(i2 | 0, i14 | 0, __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj(i3, gb + 1546313 | 0, 0) | 0, i5 | 0, i6 | 0, 0, i18 | 0) | 0) {
  __ZN10Matrix4x4f11SetIdentityEv(i15) | 0;
  i2 = HEAP16[i9 + 4 >> 1] | 0;
  if ((i2 & 255) << 24 >> 24) HEAPF32[i15 >> 2] = Math_fround(-Math_fround(HEAPF32[i15 >> 2]));
  if ((i2 & 65535) >= 256) {
   i2 = i15 + 20 | 0;
   HEAPF32[i2 >> 2] = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
  }
  __Z14GetDeviceColorRK10ColorRGBAf(i16, i9 + 8 | 0);
  HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
  __Z15TransformSpriteRPhRPtjPK10Matrix4x4fPK12SpriteVertexjPKtj11ColorRGBA32j(i18, i4, i3, i15, i7, i5, i1, i6, i10, 0);
  mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i18 | 0, i5 | 0, i6 | 0);
  i1 = HEAP32[i8 + (i17 * 360 | 0) + 188 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 188 >> 2] | 0, i13 | 0, i1 | 0);
  i15 = HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0;
  i17 = HEAP32[gb + 1161636 + (i12 << 3) + 4 >> 2] | 0;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  mftCall_viiiiiii(i15 | 0, i14 | 0, i18 | 0, i20 | 0, i16 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i17, HEAP32[i20 >> 2] | 0, 0) | 0, 0, 0);
  __Z15gpu_time_samplev();
 }
 if (!i11) {
  STACKTOP = i19;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i19;
 return;
}

function __ZNSt3__26vectorI14ResponseHelperNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = gb + 187844 + 8;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i1 + 12;
   i10 = i1 + 20 | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 32 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 4;
 i3 = i8 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 134217727;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 5) | 0;
 i7 = i5 + (i1 - i4 >> 5 << 5) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 5) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = gb + 187844 + 8;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i1 + 12;
  i5 = i1 + 20 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = i8 + 32 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   HEAP32[i2 + -32 >> 2] = gb + 187844 + 8;
   HEAP32[i2 + -28 >> 2] = HEAP32[i1 + -28 >> 2];
   __ZN12HeaderHelperC2ERKS_(i2 + -24 | 0, i1 + -24 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i1 + -12 | 0);
   i1 = i1 + -32 | 0;
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1 + -24 | 0, HEAP32[i1 + -20 >> 2] | 0);
  i1 = i1 + -32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN9Scripting22CreateScriptableObjectERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 28 | 0;
 i7 = i8 + 24 | 0;
 i6 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i2 = i8;
 i3 = __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE((__Z21GetManagerFromContexti(5) | 0) + 28 | 0, i1) | 0;
 if (!i3) {
  HEAP32[i5 >> 2] = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i4, gb + 465589 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 465174 | 0, 603, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((__ZNK10MonoScript13GetScriptTypeEv(i3) | 0) != 1) {
  HEAP32[i6 >> 2] = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i4, gb + 588063 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 465174 | 0, 614, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(__ZN10MonoScript8GetClassEv(i3) | 0)) {
  HEAP32[i7 >> 2] = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i4, gb + 588159 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 465174 | 0, 620, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  i7 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 465174 | 0, 624) | 0;
  i1 = gb + 63520 | 0;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = i2;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode(i7, i4, 0);
  __Z19pop_allocation_rootv();
  i7 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i7) | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i7, i4, 0);
  __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb(i7, 1);
  i7 = HEAP32[i7 + 20 >> 2] | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_(i1, i2, i7, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f3 = f0, i4 = 0, f5 = f0, i6 = 0, f8 = f0, i9 = 0, f10 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i15 = i2 + 88 | 0;
 i14 = i7 + 28 | 0;
 f3 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i11 >> 2]), i14));
 i13 = i2 + 80 | 0;
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i13 >> 2]));
 i4 = i11 + 4 | 0;
 f5 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i4 >> 2]), i14));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2]));
 i6 = i11 + 8 | 0;
 f8 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i6 >> 2]), i14));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i13 >> 2]));
 i9 = i11 + 12 | 0;
 f10 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i9 >> 2]), i14));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i13 >> 2]));
 if ((HEAP16[i2 + 84 >> 1] | 0) != 2) {
  HEAPF32[i1 >> 2] = f3;
  i15 = i1 + 4 | 0;
  HEAPF32[i15 >> 2] = f5;
  i15 = i1 + 8 | 0;
  HEAPF32[i15 >> 2] = f8;
  i15 = i1 + 12 | 0;
  HEAPF32[i15 >> 2] = f10;
  return;
 }
 i15 = i2 + 176 | 0;
 f16 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i11 >> 2]), i7));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i13 >> 2]));
 f17 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i4 >> 2]), i7));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i13 >> 2]));
 f18 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i6 >> 2]), i7));
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i13 >> 2]));
 f19 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i15, Math_fround(HEAPF32[i9 >> 2]), i7));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2]));
 f3 = Math_fround(f3 - f16);
 f5 = Math_fround(f5 - f17);
 f8 = Math_fround(f8 - f18);
 f10 = Math_fround(f10 - f19);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i12 >> 2]));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i12 + 4 >> 2]));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i12 + 8 >> 2]));
 f10 = Math_fround(f19 + Math_fround(f10 * Math_fround(HEAPF32[i12 + 12 >> 2])));
 f8 = Math_fround(f18 + f8);
 f5 = Math_fround(f17 + f5);
 f3 = Math_fround(f16 + f3);
 HEAPF32[i1 >> 2] = f3;
 i15 = i1 + 4 | 0;
 HEAPF32[i15 >> 2] = f5;
 i15 = i1 + 8 | 0;
 HEAPF32[i15 >> 2] = f8;
 i15 = i1 + 12 | 0;
 HEAPF32[i15 >> 2] = f10;
 return;
}

function __ZN5physx2Sc15ContactIterator11getNextPairEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 12 | 0;
 i3 = i15 + 8 | 0;
 i13 = i15 + 4 | 0;
 i4 = i15;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 >>> 0 >= (HEAP32[i14 + 4 >> 2] | 0) >>> 0) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = (i5 | 0) == 0 ? 0 : i5 + -8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i14 + 148 | 0;
 i1 = __ZN5physx2Sc19ShapeInstancePairLL19getContactPointDataERPKvRjS5_RPKfj(i5, i6, i3, i4, i13, HEAP32[i2 >> 2] | 0) | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 4; else HEAP32[i2 >> 2] = i1;
 i12 = i14 + 8 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i5 + 32 >> 2] | 0;
 i8 = HEAP32[i5 + 36 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i11) {
  i2 = 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 1;
  i7 = 0;
 } else {
  i6 = HEAP16[i1 + 2 >> 1] | 0;
  i5 = i6 & 65535;
  i7 = i5 & 2;
  i16 = (i7 | 0) != 0;
  i5 = i5 & 1;
  i2 = (i5 | 0) != 0;
  i3 = i16;
  i4 = i16 ? 4 : 32;
  i5 = i16 ? 72 : i5 << 3 | 16;
  i6 = (i6 & 4) != 0;
  i7 = i1 + (i7 << 3 | 4) | 0;
 }
 i19 = HEAP32[i13 >> 2] | 0;
 i18 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i10 + 28 >> 2] | 0) | 0;
 i17 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i8 + 28 >> 2] | 0) | 0;
 i16 = (HEAP32[i13 >> 2] | 0) != 0 & 1;
 i13 = i12;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = i9;
 HEAP32[i14 + 16 >> 2] = 0;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i7;
 HEAP32[i14 + 40 >> 2] = i7;
 HEAP32[i14 + 44 >> 2] = i7;
 HEAP32[i14 + 52 >> 2] = i11;
 HEAP32[i14 + 56 >> 2] = 0;
 HEAP32[i14 + 60 >> 2] = 0;
 HEAP32[i14 + 64 >> 2] = i4;
 HEAP32[i14 + 68 >> 2] = i5;
 HEAP32[i14 + 72 >> 2] = i2 & 1;
 HEAP32[i14 + 76 >> 2] = i3 & 1;
 HEAP32[i14 + 80 >> 2] = i6 & 1;
 HEAP32[i14 + 84 >> 2] = i19;
 i13 = i14 + 88 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i13 + 16 >> 2] = 0;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i14 + 112 >> 2] = i18;
 HEAP32[i14 + 116 >> 2] = i17;
 HEAPF32[i14 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 124 >> 2] = Math_fround(0.0);
 HEAP8[i14 + 136 >> 0] = i16;
 HEAP32[i14 + 140 >> 2] = i10;
 HEAP32[i14 + 144 >> 2] = i8;
 i16 = i12;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN15CapsuleCollider22FetchPoseFromTransformEv(i5) {
 i5 = i5 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 28 | 0;
 i7 = i8;
 i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i6, i9, i5 + 72 | 0);
 __ZNK9Transform11GetRotationEv(i7, i9);
 switch (HEAP32[i5 + 68 >> 2] | 0) {
 case 1:
  {
   f1 = Math_fround(Math_fround(HEAPF32[gb + 62548 >> 2]) * Math_fround(-.707106769));
   f4 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 4 >> 2]) * Math_fround(-.707106769));
   f2 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 8 >> 2]) * Math_fround(-.707106769));
   f3 = Math_fround(.707106769);
   break;
  }
 case 2:
  {
   f1 = Math_fround(Math_fround(HEAPF32[gb + 62536 >> 2]) * Math_fround(.707106769));
   f4 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 4 >> 2]) * Math_fround(.707106769));
   f2 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 8 >> 2]) * Math_fround(.707106769));
   f3 = Math_fround(.707106769);
   break;
  }
 default:
  {
   f1 = Math_fround(0.0);
   f2 = Math_fround(0.0);
   f3 = Math_fround(1.0);
   f4 = Math_fround(0.0);
  }
 }
 f18 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f14 = Math_fround(f1 * f18);
 f17 = Math_fround(HEAPF32[i7 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f3 * f17));
 f16 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f14 = Math_fround(f14 + Math_fround(f2 * f16));
 f15 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f14 = Math_fround(f14 - Math_fround(f4 * f15));
 f13 = Math_fround(Math_fround(Math_fround(f1 * f15) + Math_fround(Math_fround(f4 * f18) + Math_fround(f3 * f16))) - Math_fround(f2 * f17));
 f12 = Math_fround(Math_fround(Math_fround(f4 * f17) + Math_fround(Math_fround(f2 * f18) + Math_fround(f3 * f15))) - Math_fround(f1 * f16));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * f18) - Math_fround(f1 * f17)) - Math_fround(f4 * f16)) - Math_fround(f2 * f15));
 i9 = HEAP32[i5 + 36 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 64 >> 2] | 0, i9 | 0) | 0;
 i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + 88 >> 2] | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 HEAPF32[i7 >> 2] = f14;
 HEAPF32[i7 + 4 >> 2] = f13;
 HEAPF32[i7 + 8 >> 2] = f12;
 HEAPF32[i7 + 12 >> 2] = f4;
 HEAP32[i7 + 16 >> 2] = i11;
 HEAP32[i7 + 20 >> 2] = i10;
 HEAP32[i7 + 24 >> 2] = i6;
 mftCall_viii(i5 | 0, i9 | 0, i7 | 0, 1);
 STACKTOP = i8;
 return;
}

function _UNITY_png_handle_sCAL(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 4 | 0;
 i10 = i11;
 i1 = HEAP32[i6 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i6, gb + 352205 | 0);
 if (i1 & 4 | 0) {
  _UNITY_png_crc_finish(i6, i8) | 0;
  _UNITY_png_chunk_benign_error(i6, gb + 352423 | 0);
  STACKTOP = i11;
  return;
 }
 if (i7 | 0) if (HEAP32[i7 + 8 >> 2] & 16384 | 0) {
  _UNITY_png_crc_finish(i6, i8) | 0;
  _UNITY_png_chunk_benign_error(i6, gb + 352436 | 0);
  STACKTOP = i11;
  return;
 }
 if (i8 >>> 0 < 4) {
  _UNITY_png_crc_finish(i6, i8) | 0;
  _UNITY_png_chunk_benign_error(i6, gb + 352446 | 0);
  STACKTOP = i11;
  return;
 }
 i3 = i8 + 1 | 0;
 i4 = i6 + 644 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = 13; else {
  i2 = i6 + 648 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < i3 >>> 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   _UNITY_png_free(i6, i1);
   i5 = 13;
  }
 }
 do if ((i5 | 0) == 13) {
  i1 = _UNITY_png_malloc_base(i6, i3) | 0;
  if (i1 | 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 + 648 >> 2] = i3;
   break;
  }
  _UNITY_png_chunk_benign_error(i6, gb + 661520 | 0);
  _UNITY_png_crc_finish(i6, i8) | 0;
  STACKTOP = i11;
  return;
 } while (0);
 _UNITY_png_read_data(i6, i1, i8);
 _UNITY_png_calculate_crc(i6, i1, i8);
 HEAP8[i1 + i8 >> 0] = 0;
 if (_UNITY_png_crc_finish(i6, 0) | 0) {
  STACKTOP = i11;
  return;
 }
 if (((HEAP8[i1 >> 0] | 0) + -1 & 255) >= 2) {
  _UNITY_png_chunk_benign_error(i6, gb + 352599 | 0);
  STACKTOP = i11;
  return;
 }
 HEAP32[i9 >> 2] = 1;
 HEAP32[i10 >> 2] = 0;
 if (_UNITY_png_check_fp_number(i1, i8, i10, i9) | 0) {
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2 + 1 | 0;
   HEAP32[i9 >> 2] = i3;
   if (!(HEAP8[i1 + i2 >> 0] | 0)) {
    if ((HEAP32[i10 >> 2] & 392 | 0) != 264) {
     _UNITY_png_chunk_benign_error(i6, gb + 352629 | 0);
     STACKTOP = i11;
     return;
    }
    HEAP32[i10 >> 2] = 0;
    i5 = (_UNITY_png_check_fp_number(i1, i8, i10, i9) | 0) != 0;
    if (!(i5 & (HEAP32[i9 >> 2] | 0) == (i8 | 0))) {
     _UNITY_png_chunk_benign_error(i6, gb + 352648 | 0);
     STACKTOP = i11;
     return;
    }
    if ((HEAP32[i10 >> 2] & 392 | 0) == 264) {
     _UNITY_png_set_sCAL_s(i6, i7, HEAPU8[i1 >> 0] | 0, i1 + 1 | 0, i1 + i3 | 0);
     STACKTOP = i11;
     return;
    } else {
     _UNITY_png_chunk_benign_error(i6, gb + 352666 | 0);
     STACKTOP = i11;
     return;
    }
   }
  }
 }
 _UNITY_png_chunk_benign_error(i6, gb + 352612 | 0);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 36 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i1 = (HEAP32[i7 >> 2] | 0) + 36 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 36 | 0) + i2 | 0;
 if (i6 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 36 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 59652323 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 119304647;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 36 | 0) * 36 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 36 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i1 = i1 + 36 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 36 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i1 = (HEAP32[i7 >> 2] | 0) + 36 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 36 | 0) + i2 | 0;
 if (i6 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 36 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 59652323 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 119304647;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 36 | 0) * 36 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 36 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i1 = i1 + 36 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 24 | 0;
 i11 = i13;
 i5 = i10 + 12 | 0;
 i12 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 - i1 | 0;
 i3 = ((i9 | 0) / 132 | 0) + 1 | 0;
 if ((i9 | 0) < -132) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 132 | 0;
 i6 = i7 << 1;
 i6 = i7 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i5;
 if (!i6) i3 = 0; else {
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 >> 2] = 25;
  HEAP32[i4 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 132 | 0, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i11 >> 2] = i3;
 i2 = i3 + (((i2 - i1 | 0) / 132 | 0) * 132 | 0) | 0;
 i4 = i11 + 8 | 0;
 i5 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = i3 + (i6 * 132 | 0);
 __ZN13AnimationClip10FloatCurveC2ERKS0_(i2, i8);
 HEAP32[i4 >> 2] = i2 + 132;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i6 = i3;
  i8 = i1;
  i3 = i2;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i5 >> 2] = i6;
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i12 >> 2] = i10;
  HEAP32[i4 >> 2] = i8;
  i12 = HEAP32[i9 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i7 >> 2] = i12;
  i12 = HEAP32[i5 >> 2] | 0;
  HEAP32[i11 >> 2] = i12;
  __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
  STACKTOP = i13;
  return;
 }
 do {
  i1 = i1 + -132 | 0;
  __ZN13AnimationClip10FloatCurveC2ERKS0_(i2 + -132 | 0, i1);
  i2 = (HEAP32[i5 >> 2] | 0) + -132 | 0;
  HEAP32[i5 >> 2] = i2;
 } while ((i1 | 0) != (i3 | 0));
 i3 = i2;
 i6 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i5 >> 2] = i6;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i4 >> 2] = i8;
 i12 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i7 >> 2] = i12;
 i12 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = i12;
 __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 0) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 0) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif(i3, i4, i1, i2, i5, f6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) == 0;
 i8 = i8 ? gb + 33988 | 0 : gb + 33988 | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, i2, i5, 0, 0);
 i1 = __Z15GetGraphicsCapsv() | 0;
 if (!(HEAP8[i1 + 508 >> 0] | 0)) {
  if (HEAP8[i1 + 516 >> 0] | 0) i9 = 3;
 } else i9 = 3;
 if ((i9 | 0) == 3) {
  i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
  mftCall_viiifi(i9 | 0, i3 | 0, 1, i7 | 0, 1.0, 0);
 }
 i7 = HEAP32[i4 + 124 >> 2] | 0;
 i9 = i4 + 12 | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 184 >> 2] | 0, i7 | 0, i9 | 0);
 __ZN19ShaderPropertySheet5ClearEb(i9, 1);
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 580 >> 2] | 0, i3 | 0, 2, HEAP32[i4 + 8 >> 2] | 0);
 f11 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) >> 2]);
 f12 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 4 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 572 >> 2] | 0, i3 | 0, +f11, +f12, +Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 8 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 0.0, 0.0, +f6);
 f12 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 36 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 40 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 572 >> 2] | 0, i3 | 0, +f12, +f11, +Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 44 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 0.0, 1.0, +f6);
 f11 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 28 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 572 >> 2] | 0, i3 | 0, +f11, +f12, +Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 32 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 1.0, 1.0, +f6);
 f12 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 16 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 572 >> 2] | 0, i3 | 0, +f12, +f11, +Math_fround(HEAPF32[i8 + (i5 * 60 | 0) + 20 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 1.0, 0.0, +f6);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 584 >> 2] | 0, i3 | 0);
 STACKTOP = i10;
 return;
}

function __Z35UnityPropertySheet_MakeSortedColorsRKNSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEER10vector_mapIS2_S3_S5_NS6_INS7_IS2_S3_EEEEE(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i9 = i11 + 4 | 0;
 i10 = i11 + 12 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i7 | 0) / 20 | 0) >>> 0 < i6 >>> 0) {
  i1 = i11 + 8 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) - i7 | 0;
  if (!i6) i4 = 0; else i4 = __Znwj(i6 * 20 | 0) | 0;
  i3 = i4 + (((i2 | 0) / 20 | 0) * 20 | 0) | 0;
  i5 = i3 + (((i2 | 0) / -20 | 0) * 20 | 0) | 0;
  if ((i2 | 0) > 0) _memcpy(i5 | 0, i7 | 0, i2 | 0) | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i10 >> 2] = i4 + (i6 * 20 | 0);
  if (i7 | 0) __ZdlPv(i7);
 }
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i8 + 4 | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i9 = i11 + 8 | 0;
  i10 = i11 + 4 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = fb + 608;
  __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_(i10, i11, i12);
  STACKTOP = i13;
  return;
 }
 i5 = i12 + 4 | 0;
 i1 = i11 + 8 | 0;
 while (1) {
  i2 = i3 + 20 | 0;
  HEAP32[i12 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i9, i12); else {
   HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 20;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
 }
 i10 = i11 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 >> 2] = fb + 608;
 __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_(i10, i11, i12);
 STACKTOP = i13;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_4pairIifEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 3;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorINS0_4pairIifEE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37152 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN15SerializeTraitsINSt3__24pairIifEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIifEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN4math14float3_storageELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i4, HEAP32[i2 >> 2] | 0, i12 + 8 | 0);
 i9 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37324 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIN4math14float3_storageEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIN4math14float3_storageEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function _popen(i8, i12) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = g$___environ() | 0;
 i19 = i20 + 48 | 0;
 i16 = i20 + 40 | 0;
 i15 = i20 + 32 | 0;
 i10 = i20 + 24 | 0;
 i7 = i20 + 16 | 0;
 i3 = i20 + 8 | 0;
 i2 = i20;
 i5 = i20 + 152 | 0;
 i14 = i20 + 148 | 0;
 i17 = i20 + 72 | 0;
 i9 = i20 + 56 | 0;
 switch (HEAP8[i12 >> 0] | 0) {
 case 114:
  {
   i4 = 0;
   i18 = 4;
   break;
  }
 case 119:
  {
   i4 = 1;
   i18 = 4;
   break;
  }
 default:
  {
   HEAP32[(___errno_location() | 0) >> 2] = 22;
   i1 = 0;
  }
 }
 do if ((i18 | 0) == 4) if (!(_pipe2(i5, 524288) | 0)) {
  i13 = i5 + (i4 << 2) | 0;
  i1 = mftCall_iii(fb + 513 | 0, HEAP32[i13 >> 2] | 0, i12 | 0) | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   ___syscall6(6, i2 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 + 4 >> 2];
   ___syscall6(6, i3 | 0) | 0;
   i1 = 0;
   break;
  }
  if ((HEAP32[i1 + 76 >> 2] | 0) > -1) i6 = ___lockfile(i1) | 0; else i6 = 0;
  i3 = i4 ^ 1;
  i4 = i5 + (i3 << 2) | 0;
  do if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) {
   HEAP32[i7 >> 2] = 0;
   i2 = _fcntl(i3, 1030, i7) | 0;
   if ((i2 | 0) < 0) {
    i2 = HEAP32[(___errno_location() | 0) >> 2] | 0;
    break;
   } else {
    HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
    ___syscall6(6, i10 | 0) | 0;
    HEAP32[i4 >> 2] = i2;
    i18 = 13;
    break;
   }
  } else i18 = 13; while (0);
  if ((i18 | 0) == 13) if (!(_posix_spawn_file_actions_init(i17 | 0) | 0)) {
   if (!(_posix_spawn_file_actions_adddup2(i17 | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0)) {
    HEAP32[i9 >> 2] = gb + 1075254;
    HEAP32[i9 + 4 >> 2] = gb + 1075257;
    HEAP32[i9 + 8 >> 2] = i8;
    HEAP32[i9 + 12 >> 2] = 0;
    i2 = _posix_spawn(i14 | 0, gb + 1075260 | 0, i17 | 0, 0, i9 | 0, HEAP32[i11 >> 2] | 0) | 0;
    if (!i2) {
     _posix_spawn_file_actions_destroy(i17 | 0) | 0;
     HEAP32[i1 + 64 >> 2] = HEAP32[i14 >> 2];
     if (!(_strchr(i12, 101) | 0)) {
      i19 = HEAP32[i13 >> 2] | 0;
      HEAP32[i15 >> 2] = 0;
      _fcntl(i19, 2, i15) | 0;
     }
     HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
     ___syscall6(6, i16 | 0) | 0;
     if (!i6) break;
     ___unlockfile(i1);
     break;
    }
   } else i2 = 12;
   _posix_spawn_file_actions_destroy(i17 | 0) | 0;
  } else i2 = 12;
  _fclose(i1) | 0;
  HEAP32[i19 >> 2] = HEAP32[i4 >> 2];
  ___syscall6(6, i19 | 0) | 0;
  HEAP32[(___errno_location() | 0) >> 2] = i2;
  i1 = 0;
 } else i1 = 0; while (0);
 STACKTOP = i20;
 return i1 | 0;
}

function __ZN21RotationBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 i2 = i4 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1085989 | 0, gb + 620173 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1085998 | 0, gb + 620173 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899332 | 0, gb + 620173 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i3 = i4 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i8 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 804 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 898347 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN11UnityEngine9Animation14GenericBinding8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 898347 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11UnityEngine9Animation14GenericBinding8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z40Application_CUSTOM_SetLogCallbackDefinedh(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i7 = i12 + 4 | 0;
 i11 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i11 + 36280 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i2 = (i9 | 0) == 0;
 if (!(i1 << 24 >> 24)) {
  if (i2) {
   STACKTOP = i12;
   return;
  } else i1 = 0;
  while (1) {
   i2 = i11 + 35512 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i2 >> 2] | 0) == (fb + 223 | 0)) {
    i5 = i11 + 35512 + (i1 * 12 | 0) + 8 | 0;
    i4 = i11 + 35512 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i5 >> 0] | 0)) break;
    if (!(HEAP32[i4 >> 2] | 0)) break;
   }
   i3 = i1 + 1 | 0;
   if (i3 >>> 0 < i9 >>> 0) i1 = i3; else {
    i6 = 17;
    break;
   }
  }
  if ((i6 | 0) == 17) {
   STACKTOP = i12;
   return;
  }
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP8[i5 >> 0] = 0;
  i10 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
  HEAP32[i8 >> 2] = i10;
  if (i10 >>> 0 <= i1 >>> 0) {
   STACKTOP = i12;
   return;
  }
  do {
   i10 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i11 + 35512 + (i10 * 12 | 0) >> 2] = HEAP32[i11 + 35512 + (i1 * 12 | 0) >> 2];
   HEAP32[i11 + 35512 + (i10 * 12 | 0) + 4 >> 2] = HEAP32[i11 + 35512 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i11 + 35512 + (i10 * 12 | 0) + 8 >> 0] = HEAP8[i11 + 35512 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
  STACKTOP = i12;
  return;
 } else {
  L20 : do if (!i2) {
   i1 = 0;
   while (1) {
    if ((HEAP32[i11 + 35512 + (i1 * 12 | 0) >> 2] | 0) == (fb + 223 | 0)) {
     if (!(HEAP8[i11 + 35512 + (i1 * 12 | 0) + 8 >> 0] | 0)) {
      i6 = 17;
      break;
     }
     if (!(HEAP32[i11 + 35512 + (i1 * 12 | 0) + 4 >> 2] | 0)) {
      i6 = 17;
      break;
     }
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i9 >>> 0) break L20;
   }
   if ((i6 | 0) == 17) {
    STACKTOP = i12;
    return;
   }
  } while (0);
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i3 = i2 + 36280 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 >>> 0 > 63) {
   __Z6FormatPKcz(i7, gb + 1048800 | 0, i10);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP32[i2 + 35512 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 35512 + (i1 * 12 | 0) + 8 >> 0] = 0;
  HEAP32[i2 + 35512 + (i1 * 12 | 0) >> 2] = fb + 223;
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i1 = (HEAP32[i7 >> 2] | 0) + 24 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 24 | 0) + i2 | 0;
 if (i6 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 24 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 89478485 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 178956970;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 24 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 24 | 0) * 24 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 24 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i1 = i1 + 24 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -24 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -12 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERi(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i2 = i12 + 20 | 0;
 i5 = i12 + 16 | 0;
 i6 = i12 + 12 | 0;
 i1 = i12 + 28 | 0;
 i7 = i12 + 8 | 0;
 i8 = i12 + 4 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i11 | 0, 0);
 i13 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i13 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i9 | 0, gb + 1474604 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  do if (i13 & 1) i10 = 6; else {
   i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i14 | 0, i1 | 0, i2 | 0, i3 | 0, i13 | 0, i7 | 0, i8 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) i10 = 6; else {
    __ZNSt3__26localeD2Ev(i9);
    HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
    i14 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i10 | 0) == 6) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i9);
  }
  i2 = i11;
  i3 = i11;
  i10 = 12;
  break L1;
 } while (0); while (0);
 do if ((i10 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERi(i11, i4) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i2 = i12 + 20 | 0;
 i5 = i12 + 16 | 0;
 i6 = i12 + 12 | 0;
 i1 = i12 + 28 | 0;
 i7 = i12 + 8 | 0;
 i8 = i12 + 4 | 0;
 i9 = i12;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i11 | 0, 0);
 i13 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i13 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i11;
  i3 = i11;
  i10 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 >> 2] = __ZNKSt3__28ios_base6getlocEv(i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i9 | 0, gb + 1474580 | 0) | 0;
  i13 = __THREW__;
  __THREW__ = 0;
  do if (i13 & 1) i10 = 6; else {
   i13 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i14 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i14 | 0, i1 | 0, i2 | 0, i3 | 0, i13 | 0, i7 | 0, i8 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) i10 = 6; else {
    __ZNSt3__26localeD2Ev(i9);
    HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
    i14 = i11 + (HEAP32[(HEAP32[i11 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i14 | 0, HEAP32[i14 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i14 = __THREW__;
    __THREW__ = 0;
    if (i14 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i10 | 0) == 6) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i9);
  }
  i2 = i11;
  i3 = i11;
  i10 = 12;
  break L1;
 } while (0); while (0);
 do if ((i10 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (!(i14 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i14 = __THREW__;
  __THREW__ = 0;
  if (i14 & 1) {
   i14 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i14);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS8_(i11, i12, i15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = i12 + 32 | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i8 = i9 + -1 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i1 = (Math_imul(i7, 1419247029) | 0) & i8;
 i13 = i12 + 28 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
 i10 = HEAP8[i12 + 8 >> 0] | 0;
 L1 : do if ((i6 | 0) == (i4 | 0)) i4 = 16; else {
  i2 = i12 + 12 | 0;
  L3 : do if (!(i10 << 24 >> 24)) {
   i3 = 0;
   i2 = i4;
   while (1) {
    if ((i7 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i8;
    i2 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     i4 = 20;
     break L1;
    }
   }
  } else {
   if (!(HEAP32[i12 + 4 >> 2] | 0)) {
    i3 = 0;
    i2 = i4;
    while (1) {
     if ((i7 | 0) == (i2 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i8;
     i2 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
     if ((i6 | 0) == (i2 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else {
    i5 = HEAP32[i2 >> 2] | 0;
    i2 = -1;
    i3 = 0;
    do {
     if ((i5 | 0) == (i4 | 0)) i2 = (i2 | 0) == -1 ? i1 : i2; else if ((i7 | 0) == (i4 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i8;
     i4 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
    } while ((i6 | 0) != (i4 | 0));
   }
   i1 = (i2 | 0) == -1 ? i1 : i2;
   i4 = 16;
   break L1;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = -1;
   i4 = 16;
  } else {
   HEAP32[i11 >> 2] = i12;
   HEAP32[i11 + 4 >> 2] = i14 + (i1 << 3);
   HEAP32[i11 + 8 >> 2] = i14 + (i9 << 3);
   HEAP8[i11 + 12 >> 0] = 0;
   return;
  }
 } while (0);
 if ((i4 | 0) == 16) if (!(i10 << 24 >> 24)) i4 = 20; else {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i4 = 20; else if ((HEAP32[i12 + 12 >> 2] | 0) == (HEAP32[i14 + (i1 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i4 = 20;
 }
 if ((i4 | 0) == 20) {
  i10 = i12 + 36 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i9 = i15;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = i14 + (i1 << 3) | 0;
 HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i15 + 4 >> 2] = i10;
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = i15 + (HEAP32[i16 >> 2] << 3) | 0;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
 HEAP32[i11 + 8 >> 2] = i16;
 HEAP8[i11 + 12 >> 0] = 1;
 return;
}

function __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 40 | 0;
 i6 = i12 + 32 | 0;
 i7 = i12 + 24 | 0;
 i8 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i3 = i1 + ((i4 >> 1) * 212 | 0) | 0;
 if ((i4 | 0) < 65) {
  i8 = i5;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i6;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i1, i3, i2, i11);
  _memcpy(i11 | 0, i3 | 0, 212) | 0;
  _memcpy(i3 | 0, i2 | 0, 212) | 0;
  _memcpy(i2 | 0, i11 | 0, 212) | 0;
  STACKTOP = i12;
  return;
 } else {
  i14 = i4 >> 3;
  i13 = i14 << 1;
  i6 = i1 + (i14 * 212 | 0) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i15 = i7;
  HEAP32[i15 >> 2] = i4;
  HEAP32[i15 + 4 >> 2] = i5;
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i1, i6, i1 + (i13 * 212 | 0) | 0, i11);
  i7 = 0 - i14 | 0;
  i1 = i8;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i5;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i3 + (i7 * 212 | 0) | 0, i3, i3 + (i14 * 212 | 0) | 0, i11);
  i8 = i2 + (i7 * 212 | 0) | 0;
  i7 = i9;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i2 + ((0 - i13 | 0) * 212 | 0) | 0, i8, i2, i11);
  i9 = i10;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i9 + 4 >> 2] = i5;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_(i6, i3, i8, i11);
  _memcpy(i11 | 0, i3 | 0, 212) | 0;
  _memcpy(i3 | 0, i2 | 0, 212) | 0;
  _memcpy(i2 | 0, i11 | 0, 212) | 0;
  STACKTOP = i12;
  return;
 }
}

function __Z10AddVehiclePN5physx16PxVehicleNoDriveEjPNS_18PxWheelQueryResultE(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[gb + 1458868 >> 2] = (HEAP32[gb + 1458868 >> 2] | 0) + 3 + (HEAP32[i1 + 48 >> 2] | 0) & -4;
 i3 = HEAP32[gb + 1458540 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 - (HEAP32[i3 >> 2] | 0) >> 2;
 HEAP32[i7 >> 2] = i1;
 if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN5physx15PxVehicleWheelsENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i3, i7); else {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 }
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = i6;
 i1 = HEAP32[gb + 1458620 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1, i7); else {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 8;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[gb + 1458780 >> 2] | 0;
 if (i5 >>> 0 >= (HEAP32[i1 + 12 >> 2] | 0) >>> 0) {
  i2 = HEAP32[gb + 1458700 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
   __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i2, i8);
   i1 = HEAP32[gb + 1458780 >> 2] | 0;
  } else {
   HEAP32[i4 >> 2] = i5;
   HEAP32[i3 >> 2] = i4 + 4;
  }
  __ZN14dynamic_bitset6resizeEjb(i1, (HEAP32[i8 >> 2] | 0) + 1 | 0, 0);
  i6 = HEAP32[i8 >> 2] | 0;
  i7 = (HEAP32[(HEAP32[gb + 1458780 >> 2] | 0) + 8 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i6 & 31);
  i8 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31) | 0) {
  i8 = HEAP32[i8 >> 2] | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[gb + 1458700 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i2, i8);
  i1 = HEAP32[gb + 1458780 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 4;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = (HEAP32[i1 + 8 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i6 & 31);
 i8 = HEAP32[i8 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN6Sprite8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 32 | 0, gb + 410471 | 0, 0);
 i1 = i6 + 48 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i7, i6 + 56 | 0, gb + 1034662 | 0, 0);
 i1 = i6 + 140 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 76 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 144 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 148 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i8 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  i8 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN5physx2Sc5Scene9addStaticEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E(i13, i5, i12, i11) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i12 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i12 + 16 >> 2] | 0;
 i1 = i5 + i10 | 0;
 i10 = i5 + (i10 + 4) | 0;
 i2 = HEAP16[i10 >> 1] | 0;
 if (i2 << 16 >> 16 == 1) i3 = 4; else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i2 << 16 >> 16)) i7 = i1; else i3 = 4;
 }
 if ((i3 | 0) == 4) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = (HEAP32[i12 + 28 >> 2] | 0) + 144 | 0;
  i2 = i4;
  i6 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
  i7 = getTempRet0() | 0;
  i2 = _i64Add(i2 | 0, 0, -1, -1) | 0;
  i3 = _i64Add(i2 | 0, getTempRet0() | 0, i3 | 0, 0) | 0;
  i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
  i2 = getTempRet0() | 0;
  i7 = _i64Subtract(1, 0, i6 | 0, i7 | 0) | 0;
  i2 = _i64Add(i7 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  while (1) {
   i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i7 = i1;
    break;
   } else i4 = i4 + 64 | 0;
  }
 }
 __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE(i9, i13, i5 + (HEAP32[i12 + 12 >> 2] | 0) | 0);
 i6 = HEAP32[i13 + 1216 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 i3 = i1;
 i6 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 59, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i6 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyERPNS0_8ShapeSimEPNS_9PxBounds3E(i13, i7, HEAPU16[i10 >> 1] | 0, HEAP32[i12 + 28 >> 2] | 0, i9, 0, i12 + 8 | 0, i11);
 i13 = i13 + 1416 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 return;
}

function __ZN5Umbra12ReceiverMask7addAABBERKNS_7Vector3ES3_(i11, i1, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i6 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(1.0)) * Math_fround(.5)) * Math_fround(128.0));
 i6 = (i6 | 0) < 0 ? 0 : i6;
 i1 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + Math_fround(1.0)) * Math_fround(.5)) * Math_fround(128.0));
 i1 = (i1 | 0) < 0 ? 0 : i1;
 i10 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) + Math_fround(1.0)) * Math_fround(.5)) * Math_fround(128.0)) + 1 | 0;
 i10 = (i10 | 0) > 128 ? 128 : i10;
 i9 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) + Math_fround(1.0)) * Math_fround(.5)) * Math_fround(128.0)) + 1 | 0;
 i9 = (i9 | 0) > 128 ? 128 : i9;
 if (!((i10 | 0) > (i6 | 0) & (i1 | 0) < (i9 | 0))) {
  i11 = 0;
  return i11 | 0;
 }
 f2 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 if (f2 < Math_fround(0.0)) {
  i11 = 0;
  return i11 | 0;
 }
 i8 = ~~Math_fround(f2 * Math_fround(65534.0)) + 1 | 0;
 i5 = i10 - i6 & 3;
 i7 = i10 - i5 | 0;
 i5 = (i5 | 0) != 0;
 i8 = ((i8 | 0) > 65535 ? 65535 : i8) & 65535;
 if ((i6 | 0) < (i7 | 0)) {
  i3 = i1;
  do {
   i4 = i3 << 7;
   i1 = i6;
   do {
    i18 = i11 + 48 + (i1 + i4 << 1) | 0;
    i16 = i18 + 2 | 0;
    i19 = HEAP16[i18 >> 1] | 0;
    i14 = i18 + 4 | 0;
    i17 = HEAP16[i16 >> 1] | 0;
    i12 = i18 + 6 | 0;
    i15 = HEAP16[i14 >> 1] | 0;
    i13 = HEAP16[i12 >> 1] | 0;
    HEAP16[i18 >> 1] = (i19 & 65535) >= (i8 & 65535) ? i19 : i8;
    HEAP16[i16 >> 1] = (i17 & 65535) >= (i8 & 65535) ? i17 : i8;
    HEAP16[i14 >> 1] = (i15 & 65535) >= (i8 & 65535) ? i15 : i8;
    HEAP16[i12 >> 1] = (i13 & 65535) >= (i8 & 65535) ? i13 : i8;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i7 | 0));
   if (i5) {
    i1 = i7;
    do {
     i19 = i11 + 48 + (i1 + i4 << 1) | 0;
     i18 = HEAP16[i19 >> 1] | 0;
     HEAP16[i19 >> 1] = (i18 & 65535) >= (i8 & 65535) ? i18 : i8;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i10 | 0));
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i9 | 0));
  i1 = 1;
  return i1 | 0;
 } else {
  if (i5) i3 = i1; else {
   i19 = 1;
   return i19 | 0;
  }
  do {
   i4 = i3 << 7;
   i1 = i7;
   do {
    i19 = i11 + 48 + (i1 + i4 << 1) | 0;
    i18 = HEAP16[i19 >> 1] | 0;
    HEAP16[i19 >> 1] = (i18 & 65535) >= (i8 & 65535) ? i18 : i8;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i10 | 0));
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i9 | 0));
  i1 = 1;
  return i1 | 0;
 }
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS6_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034708 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034708 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (((i4 - i1 | 0) / 28 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i1 = (HEAP32[i7 >> 2] | 0) + 28 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 28 | 0) + i2 | 0;
 if (i6 >>> 0 > 153391689) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = (i4 - i5 | 0) / 28 | 0;
 i3 = i7 << 1;
 i3 = i7 >>> 0 < 76695844 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 153391689;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 28 | 0) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (((i1 - i5 | 0) / 28 | 0) * 28 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 * 28 | 0);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i1 = i1 + 28 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -28 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -16 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = i1 + 4 | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 i22 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i22 | 0)) return;
 i18 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i18 + 52 >> 2] | 0;
 i20 = i18 + 56 | 0;
 i3 = i18 + 60 | 0;
 i4 = i18 + 64 | 0;
 i5 = i18 + 68 | 0;
 i6 = i18 + 72 | 0;
 i7 = i18 + 76 | 0;
 i8 = i18 + 80 | 0;
 i9 = i18 + 4 | 0;
 i10 = i18 + 12 | 0;
 i11 = i18 + 16 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 24 | 0;
 i14 = i18 + 28 | 0;
 i15 = i18 + 32 | 0;
 i16 = i18 + 36 | 0;
 i17 = i18 + 40 | 0;
 i18 = i18 + 8 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i19 | 0) == (i1 | 0)) if ((HEAP32[i20 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i2 + 8 >> 2] | 0)) if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 + 12 >> 2] | 0)) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i2 + 20 >> 2] | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 + 24 >> 2] | 0)) {
   if ((HEAP32[i8 >> 2] | 0) != (HEAP32[i2 + 28 >> 2] | 0)) i23 = 11;
  } else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11;
  if ((i23 | 0) == 11) {
   i23 = 0;
   if (!(HEAP8[i18 >> 0] | 0)) {
    i23 = 22;
    break;
   }
   if (!(HEAP32[i9 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i10 >> 2] | 0) != (i1 | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i11 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i2 + 12 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i14 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i15 >> 2] | 0) != (HEAP32[i2 + 20 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i16 >> 2] | 0) != (HEAP32[i2 + 24 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i17 >> 2] | 0) != (HEAP32[i2 + 28 >> 2] | 0)) {
    i23 = 22;
    break;
   }
  }
  i2 = i2 + 40 | 0;
  HEAP32[i21 >> 2] = i2;
  if ((i2 | 0) == (i22 | 0)) {
   i23 = 22;
   break;
  }
 }
 if ((i23 | 0) == 22) return;
}

function __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i3, i6 + 72 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i3, i6 + 8 | 0, gb + 899468 | 0, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i3, i6 + 24 | 0, gb + 899468 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN19RenderEventsContextC2ERKS_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 i4 = i1 * 20 | 0;
 i4 = __Znaj(i1 >>> 0 > 214748364 | i4 >>> 0 > 4294967291 ? -1 : i4 + 4 | 0) | 0;
 HEAP32[i4 >> 2] = i1;
 i4 = i4 + 4 | 0;
 if (!i1) {
  HEAP32[i10 >> 2] = i4;
  STACKTOP = i13;
  return;
 }
 i1 = i4 + (i1 * 20 | 0) | 0;
 i2 = i4;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
  i7 = i3;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i2 = i2 + 20 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i9 = (HEAP32[i12 >> 2] | 0) > 0;
 HEAP32[i10 >> 2] = i4;
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i1 = 0;
 while (1) {
  i7 = i4 + (i1 * 20 | 0) | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  i8 = i9 + (i1 * 20 | 0) | 0;
  i9 = i9 + (i1 * 20 | 0) + 12 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i4 + (i1 * 20 | 0) + 12 | 0;
  HEAP32[i3 >> 2] = i2;
  i5 = i4 + (i1 * 20 | 0) + 16 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  do if ((i6 & 2147483647) >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 2, 4, i4 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i4 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i7 >> 2] = i6;
   break;
  } while (0);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = (i2 | 0) == 0;
  if (!i4) {
   i3 = 0;
   do {
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2];
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i2 >>> 0);
   if (!i4) {
    i3 = 0;
    do {
     if (HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0) {
      i2 = __Znwj(180) | 0;
      __ZN22RenderingCommandBufferC2ERKS_(i2, HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0);
      HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2] = i2;
      i2 = HEAP32[i9 >> 2] | 0;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i2 >>> 0);
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i12 >> 2] | 0)) break;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZNK17SizeBySpeedModule6UpdateERK23ParticleSystemParticlesPPf(i11, i12, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, f18 = f0, i19 = 0, f20 = f0, i21 = 0, f22 = f0, f23 = f0, i24 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i1 = i14;
 if ((HEAP16[gb + 1452140 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452140 | 0, i10);
  i6 = gb + 1452140 | 0;
 } else i6 = 0;
 __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i10, i11 + 800 | 0);
 i7 = HEAP8[i12 + 871 >> 0] | 0 ? 3 : 1;
 i8 = i11 + 808 | 0;
 i9 = i12 + 12 | 0;
 i5 = 0;
 do {
  i1 = HEAP8[i8 >> 0] | 0 ? i5 : 0;
  i2 = i11 + 8 + (i1 * 264 | 0) | 0;
  i3 = HEAP16[i11 + 8 + (i1 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i3 << 16 >> 16)) {
   i3 = HEAP32[i13 + (i5 << 2) >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   if (i4 | 0) {
    i2 = i11 + 8 + (i1 * 264 | 0) + 80 | 0;
    i1 = 0;
    do {
     i21 = i3 + (i1 << 2) | 0;
     f23 = Math_fround(HEAPF32[i21 >> 2]);
     i19 = i21 + 4 | 0;
     f20 = Math_fround(HEAPF32[i19 >> 2]);
     i17 = i21 + 8 | 0;
     f18 = Math_fround(HEAPF32[i17 >> 2]);
     i15 = i21 + 12 | 0;
     f16 = Math_fround(HEAPF32[i15 >> 2]);
     f22 = Math_fround(HEAPF32[i2 >> 2]);
     i24 = f22 < Math_fround(0.0);
     f22 = i24 ? Math_fround(0.0) : f22;
     f20 = Math_fround(f20 * f22);
     f18 = Math_fround(f18 * f22);
     f16 = Math_fround(f16 * f22);
     HEAPF32[i21 >> 2] = Math_fround(f23 * f22);
     HEAPF32[i19 >> 2] = f20;
     HEAPF32[i17 >> 2] = f18;
     HEAPF32[i15 >> 2] = f16;
     i1 = i1 + 4 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   }
  } else {
   if (!(HEAP8[i11 + 8 + (i1 * 264 | 0) + 86 >> 0] | 0)) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i2, i12, HEAP32[i13 + (i5 << 2) >> 2] | 0, i10);
    break;
   }
   i1 = HEAP32[i13 + (i5 << 2) >> 2] | 0;
   if ((i3 | 1) << 16 >> 16 == 3) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i2, i12, i1, i10);
    break;
   } else {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f(i2, i12, i1, i10);
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i14;
 return;
}

function __ZN5physx27integrateNoDriveWheelSpeedsEfPKfPKbS1_S1_S1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE(f5, i1, i4, i3, i6, i2, i8, i7) {
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f13 = Math_fround(Math_fround(HEAPF32[i8 + 232 >> 2]) * f5);
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 280 >> 2]) * f5);
 f10 = Math_fround(Math_fround(HEAPF32[i8 + 328 >> 2]) * f5);
 f5 = Math_fround(Math_fround(HEAPF32[i8 + 376 >> 2]) * f5);
 f17 = Math_fround(HEAPF32[i7 >> 2]);
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i3 >> 2]));
 f16 = Math_fround(f17 + Math_fround(f13 * Math_fround(f16 + Math_fround(HEAPF32[i1 >> 2]))));
 f13 = Math_fround(f16 / Math_fround(Math_fround(f13 * Math_fround(HEAPF32[i2 >> 2])) + Math_fround(1.0)));
 i11 = i7 + 4 | 0;
 f16 = Math_fround(HEAPF32[i11 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f15 = Math_fround(f16 + Math_fround(f12 * Math_fround(f15 + Math_fround(HEAPF32[i1 + 4 >> 2]))));
 f12 = Math_fround(f15 / Math_fround(Math_fround(f12 * Math_fround(HEAPF32[i2 + 4 >> 2])) + Math_fround(1.0)));
 i9 = i7 + 8 | 0;
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f14 = Math_fround(f15 + Math_fround(f10 * Math_fround(f14 + Math_fround(HEAPF32[i1 + 8 >> 2]))));
 f10 = Math_fround(f14 / Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i2 + 8 >> 2])) + Math_fround(1.0)));
 i8 = i7 + 12 | 0;
 f14 = Math_fround(HEAPF32[i8 >> 2]);
 f18 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f18 = Math_fround(f18 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 f18 = Math_fround(f14 + Math_fround(f5 * Math_fround(f18 + Math_fround(HEAPF32[i1 + 12 >> 2]))));
 f5 = Math_fround(f18 / Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i2 + 12 >> 2])) + Math_fround(1.0)));
 i6 = !(Math_fround(f17 * f13) <= Math_fround(0.0)) | (HEAP8[i4 >> 0] | 0) == 0;
 f13 = i6 ? f13 : Math_fround(0.0);
 i6 = !(Math_fround(f16 * f12) <= Math_fround(0.0)) | (HEAP8[i4 + 1 >> 0] | 0) == 0;
 f12 = i6 ? f12 : Math_fround(0.0);
 i6 = (HEAP8[i4 + 2 >> 0] | 0) == 0 | !(Math_fround(f10 * f15) <= Math_fround(0.0));
 f10 = i6 ? f10 : Math_fround(0.0);
 i6 = (HEAP8[i4 + 3 >> 0] | 0) == 0 | !(Math_fround(f5 * f14) <= Math_fround(0.0));
 f5 = i6 ? f5 : Math_fround(0.0);
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i11 >> 2] = f12;
 HEAPF32[i9 >> 2] = f10;
 HEAPF32[i8 >> 2] = f5;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 60 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899322 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN13AnimationClip9PPtrCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 60 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899322 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13AnimationClip9PPtrCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 60 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 88 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899392 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN24CompressedAnimationCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 88 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899392 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN24CompressedAnimationCurve8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN8LODGroup18UpgradeFrom50AssetERKNSt3__26vectorINS_11LODStruct50ENS0_9allocatorIS2_EEEE(i13, i10) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 i12 = i13 + 56 | 0;
 i1 = i2 - i1 >> 5;
 i6 = i13 + 60 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i2 = (i4 - i3 | 0) / 28 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj(i12, i1 - i2 | 0); else if (i1 >>> 0 < i2 >>> 0) {
  i5 = i3 + (i1 * 28 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i4;
   while (1) {
    i1 = i2 + -28 | 0;
    HEAP32[i6 >> 2] = i1;
    i3 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i3 >> 2] = 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
   }
  }
 }
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2;
 if ((i3 | 0) != (i2 | 0)) {
  i9 = 0;
  do {
   i7 = HEAP32[i12 >> 2] | 0;
   HEAP32[i7 + (i9 * 28 | 0) >> 2] = HEAP32[i1 + (i9 << 5) >> 2];
   HEAP32[i7 + (i9 * 28 | 0) + 4 >> 2] = HEAP32[i1 + (i9 << 5) + 8 >> 2];
   i8 = i7 + (i9 * 28 | 0) + 8 | 0;
   i4 = i1 + (i9 << 5) + 12 | 0;
   if ((i4 | 0) != (i8 | 0)) {
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = i7 + (i9 * 28 | 0) + 20 | 0;
    i1 = HEAP32[i1 + (i9 << 5) + 24 >> 2] << 2;
    i2 = i1 >> 2;
    HEAP32[i6 >> 2] = i2;
    i3 = i7 + (i9 * 28 | 0) + 24 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i3 >> 2] = i2;
     i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 4, i7 + (i9 * 28 | 0) + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     HEAP32[i8 >> 2] = i1;
     break;
    } else {
     i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i7 + (i9 * 28 | 0) + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
     HEAP32[i3 >> 2] = i2;
     HEAP32[i8 >> 2] = i1;
     break;
    } else i1 = HEAP32[i8 >> 2] | 0; while (0);
    _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   i9 = i9 + 1 | 0;
   i1 = i2;
  } while (i9 >>> 0 < i3 - i2 >> 5 >>> 0);
 }
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 2:
  {
   HEAP32[i13 + 48 >> 2] = 1;
   return;
  }
 case 1:
  {
   HEAP32[i13 + 48 >> 2] = 2;
   return;
  }
 default:
  return;
 }
}

function __ZN20FileSystemEnumerator18EnumerateDirectoryEPKcPFbR13FileEntryInfoPvES4_19FileEnumerationFlag(i7, i1, i9, i10, i11) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 8 | 0;
 i3 = i16;
 i12 = i16 + 36 | 0;
 i13 = i16 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i14 = i12 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i12 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i8 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i4 = i2;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 if (__ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(0, i1, i12, 0, i11) | 0) {
  i4 = gb + 64016 | 0;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i13 >> 2] = 0;
  i5 = i13 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  i6 = i13 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i6;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = HEAP32[i14 >> 2] | 0;
  HEAP32[i13 + 12 >> 2] = i1;
  L3 : do if (i1 | 0) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 1, i6, 0, gb + 1047584 | 0, 464) | 0;
   if (HEAP32[i14 >> 2] | 0) {
    i3 = 0;
    do {
     if (mftCall_iii(i9 | 0, (HEAP32[i12 >> 2] | 0) + (i3 * 1088 | 0) | 0, i10 | 0) | 0) i1 = (HEAP8[(HEAP32[i12 >> 2] | 0) + (i3 * 1088 | 0) + 1080 >> 0] | 0) != 0; else i1 = 0;
     i4 = HEAP32[i13 >> 2] | 0;
     HEAP8[i4 + i3 >> 0] = i1 & 1;
     i3 = i3 + 1 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
    } while (i3 >>> 0 < i2 >>> 0);
    if (i2 | 0) {
     i1 = 0;
     while (1) {
      if (HEAP8[i4 + i1 >> 0] | 0) {
       __ZN20FileSystemEnumerator18EnumerateDirectoryEPKcPFbR13FileEntryInfoPvES4_19FileEnumerationFlag(i7, (HEAP32[i12 >> 2] | 0) + (i1 * 1088 | 0) | 0, i9, i10, i11);
       i2 = HEAP32[i14 >> 2] | 0;
      }
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i2 >>> 0) break L3;
      i4 = HEAP32[i13 >> 2] | 0;
     }
    }
   }
  } while (0);
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i6);
   HEAP32[i13 >> 2] = 0;
  }
 }
 if ((HEAP32[i15 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i8);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZN10AudioMixer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 92 | 0, i8);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 44 | 0, i8);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i8, i7 + 48 | 0, 0);
 __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 68 | 0, i8);
 i6 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i8 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i7 + 100 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i2 = i7 + 32 | 0;
 HEAP32[i8 + 4 >> 2] = i2;
 i4 = i7 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 80, 4) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 28 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i4 >> 2] = i1;
 i7 = i1;
 __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN10AudioMixer24CheckForCyclicReferencesEPS_P15AudioMixerGroup(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 if ((i8 | 0) == 0 | (i1 | 0) == 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i6 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 10;
   }
  }
  if ((i7 | 0) == 8) i7 = 10;
  if ((i7 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  i10 = 1;
  STACKTOP = i9;
  return i10 | 0;
 }
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i6 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 19; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 19; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 21;
   }
  }
  if ((i7 | 0) == 19) i7 = 21;
  if ((i7 | 0) == 21) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 i10 = __ZN10AudioMixer24CheckForCyclicReferencesEPS_P15AudioMixerGroup(i8, i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil24findProjectionOnTriangleEjjjRKNS_6PxVec3ERS2_(i7, i4, i10, i9, i16, i17) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f5 = f0, f6 = f0, f8 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, f22 = f0;
 i18 = i4 >>> 1;
 i20 = HEAP32[i7 + 16 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i20 + 8 >> 2]);
 i21 = HEAP32[i7 + 12 >> 2] | 0;
 i19 = HEAP32[i21 + 36 >> 2] | 0;
 f1 = Math_fround(f5 * Math_fround(HEAP16[i19 + (i18 << 2) >> 1] | 0));
 f2 = Math_fround(f5 * Math_fround(HEAP16[i19 + (i18 + 1 << 2) >> 1] | 0));
 i21 = (HEAP32[i21 + 20 >> 2] | 0) + i18 | 0;
 f3 = Math_fround(f5 * Math_fround(HEAP16[i19 + (i21 << 2) >> 1] | 0));
 f5 = Math_fround(f5 * Math_fround(HEAP16[i19 + (i21 + 1 << 2) >> 1] | 0));
 i4 = (i4 & 1 | 0) == 0;
 f6 = Math_fround(HEAPF32[i20 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i20 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 do if ((HEAP8[i19 + (i18 << 2) + 2 >> 0] | 0) < 0) if (i4) {
  f15 = f3;
  i4 = i10 + 1 | 0;
  f13 = f5;
  f11 = Math_fround(-f11);
  break;
 } else {
  f15 = f2;
  i9 = i9 + 1 | 0;
  i4 = i10;
  f13 = f1;
  f1 = f5;
  f12 = Math_fround(-f12);
  break;
 } else if (i4) {
  f15 = f1;
  i4 = i10;
  f13 = f2;
  f1 = f3;
 } else {
  f15 = f5;
  i9 = i9 + 1 | 0;
  i4 = i10 + 1 | 0;
  f13 = f3;
  f1 = f2;
  f12 = Math_fround(-f12);
  f11 = Math_fround(-f11);
 } while (0);
 f8 = Math_fround(Math_fround(i4 >>> 0) * f6);
 f5 = Math_fround(Math_fround(i9 >>> 0) * f14);
 f22 = Math_fround(Math_fround(HEAPF32[i16 >> 2]) - f8);
 f6 = Math_fround(Math_fround(HEAPF32[i16 + 4 >> 2]) - f15);
 f14 = Math_fround(Math_fround(HEAPF32[i16 + 8 >> 2]) - f5);
 f13 = Math_fround(f12 * Math_fround(f13 - f15));
 f3 = Math_fround(-f13);
 f1 = Math_fround(f11 * Math_fround(f1 - f15));
 f2 = Math_fround(-f1);
 f1 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f13 * f13)) + Math_fround(1.0))) * Math_fround(Math_fround(Math_fround(f22 * f2) + f6) + Math_fround(f14 * f3)));
 f2 = Math_fround(f22 - Math_fround(f1 * f2));
 f3 = Math_fround(f14 - Math_fround(f1 * f3));
 f13 = Math_fround(f11 * f2);
 f14 = Math_fround(f12 * f3);
 if (!(f13 > Math_fround(0.0) & f14 > Math_fround(0.0) & Math_fround(f13 + f14) < Math_fround(1.0))) {
  i21 = 0;
  return i21 | 0;
 }
 f15 = Math_fround(f15 + Math_fround(f6 - f1));
 f22 = Math_fround(f5 + f3);
 HEAPF32[i17 >> 2] = Math_fround(f8 + f2);
 HEAPF32[i17 + 4 >> 2] = f15;
 HEAPF32[i17 + 8 >> 2] = f22;
 i21 = 1;
 return i21 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i11 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i11 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 4, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 4, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 4) | 0, 0, i5 - i4 << 4 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = i1 + (i7 << 4) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 12 | 0, i11);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx19NpArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 123300 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 123300 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 123300 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 123300 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 123300 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 123300 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 123300 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 123300 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754751;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 204;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 123332 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123332 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123332 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123332 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123332 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123332 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123332 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123332 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123364 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123364 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123364 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123364 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123364 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123364 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123396 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123396 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123396 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123396 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123396 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123396 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123396 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123396 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function _UNITY_png_deflate_claim(i11, i9, i5) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 i10 = i11 + 216 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 do if (i2 | 0) {
  HEAP8[i1 >> 0] = i9 >>> 24;
  HEAP8[i1 + 1 >> 0] = i9 >>> 16;
  HEAP8[i1 + 2 >> 0] = i9 >>> 8;
  HEAP8[i1 + 3 >> 0] = i9;
  HEAP8[i1 + 4 >> 0] = 58;
  HEAP8[i1 + 5 >> 0] = 32;
  HEAP8[i1 + 6 >> 0] = i2 >>> 24;
  HEAP8[i1 + 7 >> 0] = i2 >>> 16;
  HEAP8[i1 + 8 >> 0] = i2 >>> 8;
  HEAP8[i1 + 9 >> 0] = i2;
  _UNITY_png_safecat(i1, 64, 10, gb + 355064 | 0) | 0;
  if ((HEAP32[i10 >> 2] | 0) != 1229209940) {
   HEAP32[i10 >> 2] = 0;
   break;
  }
  HEAP32[i11 + 244 >> 2] = gb + 355079;
  i11 = -2;
  STACKTOP = i12;
  return i11 | 0;
 } while (0);
 i4 = HEAP32[i11 + 284 >> 2] | 0;
 i3 = HEAP32[i11 + 288 >> 2] | 0;
 i2 = HEAP32[i11 + 292 >> 2] | 0;
 i1 = HEAP32[i11 + 296 >> 2] | 0;
 do if ((i9 | 0) == 1229209940) if (!(HEAP32[i11 + 208 >> 2] & 1)) {
  i8 = (HEAP8[i11 + 430 >> 0] | 0) != 8 & 1;
  i7 = i3;
  i6 = i4;
  break;
 } else {
  i8 = HEAP32[i11 + 300 >> 2] | 0;
  i7 = i3;
  i6 = i4;
  break;
 } else {
  i8 = HEAP32[i11 + 320 >> 2] | 0;
  i1 = HEAP32[i11 + 316 >> 2] | 0;
  i2 = HEAP32[i11 + 312 >> 2] | 0;
  i7 = HEAP32[i11 + 308 >> 2] | 0;
  i6 = HEAP32[i11 + 304 >> 2] | 0;
 } while (0);
 if (i5 >>> 0 < 16385) {
  i3 = 1 << i2 + -1;
  i4 = i5 + 262 | 0;
  if (i4 >>> 0 <= i3 >>> 0) do {
   i3 = i3 >>> 1;
   i2 = i2 + -1 | 0;
  } while (i4 >>> 0 <= i3 >>> 0);
 }
 i5 = i11 + 208 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 do if (i3 & 2) {
  if ((HEAP32[i11 + 324 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i11 + 328 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i11 + 332 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i11 + 336 >> 2] | 0) == (i1 | 0)) if ((HEAP32[i11 + 340 >> 2] | 0) == (i8 | 0)) break;
  _unity_z_deflateEnd(i11 + 220 | 0) | 0;
  i3 = HEAP32[i5 >> 2] & -3;
  HEAP32[i5 >> 2] = i3;
 } while (0);
 i4 = i11 + 220 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 + 224 >> 2] = 0;
 HEAP32[i11 + 232 >> 2] = 0;
 HEAP32[i11 + 236 >> 2] = 0;
 if (!(i3 & 2)) {
  i1 = _unity_z_deflateInit2_(i4, i6, i7, i2, i1, i8, gb + 362978 | 0, 56) | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 2;
   i2 = 24;
  } else i2 = 25;
 } else {
  i1 = _unity_z_deflateReset(i4) | 0;
  if (!i1) i2 = 24; else i2 = 25;
 }
 if ((i2 | 0) == 24) {
  HEAP32[i10 >> 2] = i9;
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 } else if ((i2 | 0) == 25) {
  _UNITY_png_zstream_error(i11, i1);
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx18PxVehicleDriveTank17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 165872 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 165872 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 165872 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 165872 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 165872 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 165872 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 165872 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 165872 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 834990;
 HEAP32[i6 + 4 >> 2] = gb + 828300;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 768;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 165904 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 165904 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 165904 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 165904 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 165904 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 165904 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 165904 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 165904 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 165936 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 165936 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 165936 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 165936 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 165936 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 165936 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 165936 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 165936 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 165968 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 165968 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 165968 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 165968 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 165968 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 165968 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 165968 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 165968 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN2UI7Batches7DestroyEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i2 = i10;
 i4 = i6 + 32 | 0;
 i5 = i6 + 20 | 0;
 i8 = __Z12GetGfxDevicev() | 0;
 i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 256 >> 2] | 0;
 i9 = i6 + 112 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 mftCall_vii(i3 | 0, i8 | 0, i7 | 0);
 i7 = i6 + 40 | 0;
 i8 = i6 + 52 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = i2 + 4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   if (!(HEAP32[i3 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 i3 = i6 + 88 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if (!(HEAP32[i2 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
  }
 }
 i2 = i6 + 92 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1 + 4 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
  if (!(HEAP32[i11 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
  }
 }
 i1 = i6 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i6 + 4 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i6 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 24 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i6 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i11 = i6 + 60 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i11 = i6 + 100 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6 + 44 | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i11 = i6 + 60 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i11 = i6 + 100 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i13 = i16 + 80 | 0;
 i12 = i16 + 16 | 0;
 i14 = i16 + 12 | 0;
 HEAP16[i1 >> 1] = -1;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 i1 = HEAP32[(__ZN10builtintex16GetDefaultTexEnvE16TextureDimension(3) | 0) >> 2] | 0;
 f4 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f8 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 i2 = i12;
 i3 = gb + 1162292 | 0;
 i10 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i10 | 0));
 i11 = __Z12GetGfxDevicev() | 0;
 f8 = Math_fround(f5 - f8);
 f9 = Math_fround(f6 - f9);
 HEAPF32[i11 + 1700 >> 2] = Math_fround(f4 - f7);
 HEAPF32[i11 + 1704 >> 2] = f8;
 HEAPF32[i11 + 1708 >> 2] = f9;
 HEAPF32[i11 + 1712 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 1716 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 1720 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 1724 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 1728 >> 2] = Math_fround(0.0);
 i2 = i11 + 2916 | 0;
 i3 = i12;
 i10 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i10 | 0));
 HEAPF32[i11 + 1732 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 1736 >> 2] = Math_fround(1.0);
 HEAP32[i11 + 1740 >> 2] = 1065353216;
 HEAPF32[i11 + 1744 >> 2] = Math_fround(0.0);
 HEAP32[i14 >> 2] = -1073741803;
 HEAP32[i11 + 3400 >> 2] = i1;
 HEAP32[i11 + 3404 >> 2] = 3;
 i1 = HEAP32[i11 + 3408 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
 case 3:
  {
   i15 = i11 + 3412 | 0;
   HEAP32[i15 >> 2] = 0;
   STACKTOP = i16;
   return;
  }
 default:
  {}
 }
 i12 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
 i14 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i14) | 0;
 HEAP32[i15 >> 2] = gb + 478917;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i14;
 __Z6FormatPKcz(i13, gb + 478736 | 0, i15);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 i15 = i11 + 3412 | 0;
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = HEAP32[i5 + 24 >> 2] | 0;
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i1 = i2 - i1 | 0;
 i5 = (i1 | 0) / 12 | 0;
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i3, __Z34scripting_class_array_element_sizeP11Il2CppClass(i3) | 0, i5) | 0;
  HEAP32[i2 >> 2] = i5;
 }
 if (i1 | 0) {
  i2 = i9 + 16 | 0;
  i3 = i9 + 24 | 0;
  i4 = i9 + 20 | 0;
  i1 = 0;
  do {
   i7 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i1) | 0;
   HEAP32[i7 >> 2] = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return;
}

function __ZN6b2Body4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, d19 = 0.0, d20 = 0.0, i21 = 0, i22 = 0, i23 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 168 | 0;
 i4 = i6 + 160 | 0;
 i3 = i6 + 152 | 0;
 i7 = i6 + 136 | 0;
 i9 = i6 + 128 | 0;
 i10 = i6 + 120 | 0;
 i12 = i6 + 112 | 0;
 i13 = i6 + 104 | 0;
 i14 = i6 + 96 | 0;
 i15 = i6 + 88 | 0;
 i11 = i6 + 80 | 0;
 i16 = i6 + 72 | 0;
 i17 = i6 + 64 | 0;
 i18 = i6 + 48 | 0;
 i21 = i6 + 40 | 0;
 i22 = i6 + 24 | 0;
 i23 = i6 + 16 | 0;
 i8 = i1 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 803386 | 0, i6);
 __Z5b2LogPKcz(gb + 803389 | 0, i6 + 8 | 0);
 HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
 __Z5b2LogPKcz(gb + 803406 | 0, i23);
 d19 = +Math_fround(HEAPF32[i1 + 12 >> 2]);
 d20 = +Math_fround(HEAPF32[i1 + 16 >> 2]);
 HEAPF64[i22 >> 3] = d19;
 HEAPF64[i22 + 8 >> 3] = d20;
 __Z5b2LogPKcz(gb + 803435 | 0, i22);
 HEAPF64[i21 >> 3] = +Math_fround(HEAPF32[i1 + 56 >> 2]);
 __Z5b2LogPKcz(gb + 803473 | 0, i21);
 d20 = +Math_fround(HEAPF32[i1 + 64 >> 2]);
 d19 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 HEAPF64[i18 >> 3] = d20;
 HEAPF64[i18 + 8 >> 3] = d19;
 __Z5b2LogPKcz(gb + 803496 | 0, i18);
 HEAPF64[i17 >> 3] = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 __Z5b2LogPKcz(gb + 803540 | 0, i17);
 HEAPF64[i16 >> 3] = +Math_fround(HEAPF32[i1 + 132 >> 2]);
 __Z5b2LogPKcz(gb + 803573 | 0, i16);
 HEAPF64[i11 >> 3] = +Math_fround(HEAPF32[i1 + 136 >> 2]);
 __Z5b2LogPKcz(gb + 803604 | 0, i11);
 i11 = i1 + 4 | 0;
 HEAP32[i15 >> 2] = (HEAPU16[i11 >> 1] | 0) & 4;
 __Z5b2LogPKcz(gb + 803636 | 0, i15);
 HEAP32[i14 >> 2] = (HEAPU16[i11 >> 1] | 0) & 2;
 __Z5b2LogPKcz(gb + 803665 | 0, i14);
 HEAP32[i13 >> 2] = (HEAPU16[i11 >> 1] | 0) & 16;
 __Z5b2LogPKcz(gb + 803689 | 0, i13);
 HEAP32[i12 >> 2] = (HEAPU16[i11 >> 1] | 0) & 8;
 __Z5b2LogPKcz(gb + 803721 | 0, i12);
 HEAP32[i10 >> 2] = (HEAPU16[i11 >> 1] | 0) & 32;
 __Z5b2LogPKcz(gb + 803746 | 0, i10);
 HEAPF64[i9 >> 3] = +Math_fround(HEAPF32[i1 + 140 >> 2]);
 __Z5b2LogPKcz(gb + 803771 | 0, i9);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __Z5b2LogPKcz(gb + 803801 | 0, i7);
 __Z5b2LogPKcz(gb + 1074320 | 0, i6 + 144 | 0);
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  __Z5b2LogPKcz(gb + 1046929 | 0, i3);
  STACKTOP = i6;
  return;
 }
 do {
  __Z5b2LogPKcz(gb + 803843 | 0, i4);
  __ZN9b2Fixture4DumpEi(i1, i2);
  __Z5b2LogPKcz(gb + 803848 | 0, i5);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
 } while ((i1 | 0) != 0);
 __Z5b2LogPKcz(gb + 1046929 | 0, i3);
 STACKTOP = i6;
 return;
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = i1 + 4 | 0;
 i2 = HEAP32[i21 >> 2] | 0;
 i22 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i22 | 0)) return;
 i18 = HEAP32[i1 >> 2] | 0;
 i19 = HEAP32[i18 + 52 >> 2] | 0;
 i20 = i18 + 56 | 0;
 i3 = i18 + 60 | 0;
 i4 = i18 + 64 | 0;
 i5 = i18 + 68 | 0;
 i6 = i18 + 72 | 0;
 i7 = i18 + 76 | 0;
 i8 = i18 + 80 | 0;
 i9 = i18 + 4 | 0;
 i10 = i18 + 12 | 0;
 i11 = i18 + 16 | 0;
 i12 = i18 + 20 | 0;
 i13 = i18 + 24 | 0;
 i14 = i18 + 28 | 0;
 i15 = i18 + 32 | 0;
 i16 = i18 + 36 | 0;
 i17 = i18 + 40 | 0;
 i18 = i18 + 8 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i19 | 0) == (i1 | 0)) if ((HEAP32[i20 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i2 + 8 >> 2] | 0)) if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 + 12 >> 2] | 0)) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i2 + 20 >> 2] | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 + 24 >> 2] | 0)) {
   if ((HEAP32[i8 >> 2] | 0) != (HEAP32[i2 + 28 >> 2] | 0)) i23 = 11;
  } else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11; else i23 = 11;
  if ((i23 | 0) == 11) {
   i23 = 0;
   if (!(HEAP8[i18 >> 0] | 0)) {
    i23 = 22;
    break;
   }
   if (!(HEAP32[i9 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i10 >> 2] | 0) != (i1 | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i11 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i2 + 12 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i14 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i15 >> 2] | 0) != (HEAP32[i2 + 20 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i16 >> 2] | 0) != (HEAP32[i2 + 24 >> 2] | 0)) {
    i23 = 22;
    break;
   }
   if ((HEAP32[i17 >> 2] | 0) != (HEAP32[i2 + 28 >> 2] | 0)) {
    i23 = 22;
    break;
   }
  }
  i2 = i2 + 40 | 0;
  HEAP32[i21 >> 2] = i2;
  if ((i2 | 0) == (i22 | 0)) {
   i23 = 22;
   break;
  }
 }
 if ((i23 | 0) == 22) return;
}

function __ZN22BaseUnityConnectClient18RequestStateChangeENS_5StateE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 113 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP8[i4 >> 0] = 1;
 i2 = i3 + 4 | 0;
 L4 : do if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = 0; else {
  L6 : do switch (HEAP32[i2 >> 2] | 0) {
  case 5:
  case 0:
   {
    if ((i1 | 0) == 1) i2 = 12; else {
     i1 = 0;
     break L4;
    }
    break;
   }
  case 1:
   {
    switch (i1 | 0) {
    case 2:
    case 3:
     {
      i2 = 13;
      break;
     }
    case 5:
     {
      i2 = 16;
      break;
     }
    case 1:
     {
      i2 = 12;
      break;
     }
    default:
     {
      i1 = 0;
      break L4;
     }
    }
    break;
   }
  case 2:
   {
    switch (i1 | 0) {
    case 1:
     {
      i2 = 12;
      break L6;
     }
    case 2:
     {
      i2 = 13;
      break L6;
     }
    case 4:
     {
      i2 = 15;
      break L6;
     }
    case 5:
     {
      i2 = 16;
      break L6;
     }
    case 3:
     break;
    default:
     {
      i1 = 0;
      break L4;
     }
    }
    if (!(HEAP8[i3 + 112 >> 0] | 0)) i2 = 15; else i2 = 14;
    break;
   }
  case 4:
   {
    switch (i1 | 0) {
    case 1:
     {
      i2 = 12;
      break L6;
     }
    case 2:
     {
      i2 = 13;
      break L6;
     }
    case 4:
     {
      i2 = 15;
      break L6;
     }
    case 5:
     {
      i2 = 16;
      break L6;
     }
    case 3:
     break;
    default:
     {
      i1 = 0;
      break L4;
     }
    }
    if (!(HEAP8[i3 + 110 >> 0] | 0)) i2 = 13; else if (!(HEAP8[i3 + 108 >> 0] | 0)) i2 = 14; else i2 = 13;
    break;
   }
  default:
   switch (i1 | 0) {
   case 1:
    {
     i2 = 12;
     break;
    }
   case 2:
    {
     i2 = 13;
     break;
    }
   case 3:
    {
     i2 = 14;
     break;
    }
   case 4:
    {
     i2 = 15;
     break;
    }
   case 5:
    {
     i2 = 16;
     break;
    }
   default:
    {
     i1 = 0;
     break L4;
    }
   }
  } while (0);
  if ((i2 | 0) == 12) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   i1 = 1;
   break;
  } else if ((i2 | 0) == 13) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
   i1 = 1;
   break;
  } else if ((i2 | 0) == 14) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0);
   i1 = 1;
   break;
  } else if ((i2 | 0) == 15) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
   i1 = 1;
   break;
  } else if ((i2 | 0) == 16) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0);
   i1 = 1;
   break;
  }
 } while (0);
 HEAP8[i4 >> 0] = 0;
 i4 = i1;
 return i4 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher15SetupWebRequestEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 32 | 0;
 i10 = i12 + 16 | 0;
 i7 = i12;
 i8 = i12 + 36 | 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1046727 | 0, 11);
 i9 = i6 + 96 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 + 64 >> 2];
 __Z6FormatPKcz(i7, gb + 1084502 | 0, i10);
 mftCall_viii(i2 | 0, i3 | 0, i8 | 0, i7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = i6 + 112 | 0;
 i4 = i2 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i6 + 116 >> 2] | 0;
 } else {
  i5 = i2;
  i1 = i1 & 255;
 }
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i5 | 0, i1 | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i6 + 116 >> 2] | 0;
 } else i1 = i1 & 255;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i2, i1, i7, i7 + 8 | 0);
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1046739 | 0, 13);
 __Z15Hash128ToStringRK7Hash128(i8, i7);
 mftCall_viii(i4 | 0, i5 | 0, i10 | 0, i8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1046753 | 0, 23);
 i7 = i6 + 92 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 __Z6FormatPKcz(i10, gb + 1084502 | 0, i11);
 mftCall_viii(i6 | 0, i9 | 0, i8 | 0, i10 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z19BuildTransitionNameNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 24 | 0;
 i5 = i8 + 12 | 0;
 i6 = i8;
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, gb + 1576256 | 0, 0) | 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 913678 | 0, 5);
 } else i7 = 3; else i7 = 3;
 if ((i7 | 0) == 3) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i2);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i9 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i9 << 24 >> 24 < 0;
 i9 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i9 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i2 ? HEAP32[i5 >> 2] | 0 : i5, i9, i9 + 4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, gb + 913684 | 0, 4) | 0;
 i9 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i3, 0, -1, gb + 1576256 | 0, 0) | 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 913689 | 0, 4);
 } else i7 = 7; else i7 = 7;
 if ((i7 | 0) == 7) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i3);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 i7 = i6 + 11 | 0;
 i9 = HEAP8[i7 >> 0] | 0;
 i9 = i9 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i9 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i2 ? HEAP32[i4 >> 2] | 0 : i4, i3, i9 + i3 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __ZN22UnityAnalyticsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 i9 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i9, i1 + 8 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041805 | 0, i9, i1 + 9 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041676 | 0, i9, i1 + 10 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041687 | 0, i9, i1 + 12 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041702 | 0, i9, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Scb12Articulation17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 125380 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 125380 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 125380 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 125380 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 125380 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 125380 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 125380 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 125380 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 747791;
 HEAP32[i6 + 4 >> 2] = gb + 747700;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 56;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 125412 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125412 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125412 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125412 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125412 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125412 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125412 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125412 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 125444 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 125444 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 125444 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 125444 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 125444 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 125444 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 125444 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 125444 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125476 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125476 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125476 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125476 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125476 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125476 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125476 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125476 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN20TextRenderingPrivate17TextMeshGeneratorC2ERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i5, i1, i3, i11, i12, f13, f14, f15, i16, i17, i6, f7, i8, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 i16 = i16 | 0;
 i17 = i17 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i4 = 0, i10 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i19 + 8 | 0;
 i21 = i19;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i10 = i5 + 64 | 0;
 i23 = gb + 63672 | 0;
 i22 = HEAP32[i23 + 4 >> 2] | 0;
 i20 = i21;
 HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i20 + 4 >> 2] = i22;
 HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i5 + 68 | 0, i1, i4);
 HEAP32[i5 + 88 >> 2] = 0;
 HEAP32[i5 + 100 >> 2] = 0;
 HEAP32[i5 + 104 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i21 = i4;
 i20 = HEAP32[i21 + 4 >> 2] | 0;
 i1 = i5 + 92 | 0;
 HEAP32[i1 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i1 + 4 >> 2] = i20;
 if (!i3) {
  i1 = HEAP32[gb + 1467752 >> 2] | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1017543 | 0, 9);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i4) | 0;
   HEAP32[gb + 1467752 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   i1 = HEAP32[gb + 1467752 >> 2] | 0;
   i2 = i5 + 4 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i18 = 6;
  } else {
   i2 = i5 + 4 | 0;
   i18 = 6;
  }
  if ((i18 | 0) == 6) {
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
  }
  HEAP32[i1 >> 2] = i3;
 } else HEAP32[i2 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 52 >> 2] = i8;
 HEAP32[i5 + 60 >> 2] = i9;
 HEAPF32[i5 + 56 >> 2] = f7;
 HEAP32[i5 + 24 >> 2] = i11;
 HEAP32[i5 + 36 >> 2] = i12;
 HEAPF32[i5 + 32 >> 2] = f13;
 HEAPF32[i5 + 44 >> 2] = f14;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAPF32[i5 + 40 >> 2] = f15;
 HEAP32[i5 >> 2] = 0;
 HEAP8[i5 + 49 >> 0] = i16 & 1;
 HEAP8[i5 + 28 >> 0] = i17 & 1;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 STACKTOP = i19;
 return;
}

function __ZN9AudioClip21ScriptPCMReadCallbackEP10FMOD_SOUNDPvj(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 264 | 0;
 i5 = i13 + 248 | 0;
 i4 = i13 + 260 | 0;
 i8 = i13 + 256 | 0;
 i9 = i13 + 252 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13;
 __ZN4FMOD5Sound11getUserDataEPPv(i1, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) {
  i12 = 22;
  STACKTOP = i13;
  return i12 | 0;
 }
 i3 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
  i1 = gb + 874396 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 874396 + 88 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459916 >> 2] = i1;
  i2 = gb + 1098880 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459916 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = 0;
 i3 = __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE(i1) | 0;
 if (!i3) {
  i12 = 22;
  STACKTOP = i13;
  return i12 | 0;
 }
 i4 = i3 + 124 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP32[i5 >> 2] = gb + 854991;
  __Z6FormatPKcz(i12, gb + 854751 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 854901 | 0, 214, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 }
 i2 = (__Z21GetManagerFromContexti(3) | 0) + 296 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(28) | 0;
  __ZN24AudioScriptBufferManagerC2Ev(i1);
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i8 >> 2] = 0;
 __ZN24AudioScriptBufferManager15GetPCMReadArrayEjRP11Il2CppArray(i1, i7 >>> 2, i8);
 i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + 60 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i11;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i10, i5, i12);
 __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i10, HEAP32[i8 >> 2] | 0);
 HEAP32[i10 + 216 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i10, i9, 0) | 0;
 if (!(HEAP32[i9 >> 2] | 0)) _memcpy(i6 | 0, __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i8 >> 2] | 0, 0, 4) | 0, i7 | 0) | 0;
 i12 = 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN8Renderer12GetTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 if (!(HEAP16[i1 + 218 >> 1] | 0)) {
  i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i7 = i1 + 308 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i10 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i10 + 28 >> 2] | 0;
    i4 = HEAP32[i10 + 32 >> 2] | 0;
    i1 = i10;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 9; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 11;
  }
  if ((i8 | 0) == 9) i8 = 11;
  if ((i8 | 0) == 11) {
   if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) break;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  if (!i1) i8 = 18; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 18; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 20;
   }
  }
  if ((i8 | 0) == 18) i8 = 20;
  if ((i8 | 0) == 20) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
  i10 = i1;
  STACKTOP = i9;
  return i10 | 0;
 } while (0);
 i10 = HEAP32[gb + 1158204 >> 2] | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN8Remapper6RemoveEi(i12, i4) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i10 = i12 + 12 | 0;
 i5 = i12 + 16 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 if (!i11) return; else {
  i3 = i5;
  i2 = i11;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) return;
 if ((i3 | 0) == (i5 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) > (i4 | 0)) return;
 i5 = i12 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i9 = 20; else {
  i6 = HEAP32[i3 + 24 >> 2] | 0;
  i8 = i3 + 32 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i1 = i5;
  L18 : while (1) {
   i4 = i2;
   while (1) {
    i2 = HEAP32[i4 + 16 >> 2] | 0;
    if ((i2 | 0) >= (i6 | 0)) {
     if ((i2 | 0) > (i6 | 0)) break;
     i2 = i4 + 24 | 0;
     i13 = HEAP32[i2 + 4 >> 2] | 0;
     if (!((i13 | 0) < (i8 | 0) | ((i13 | 0) == (i8 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < i7 >>> 0 : 0))) break;
    }
    i2 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i2) break L18; else i4 = i2;
   }
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) {
    i1 = i4;
    break;
   } else i1 = i4;
  }
  if ((i1 | 0) == (i5 | 0)) i9 = 20; else {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i6 | 0) < (i2 | 0)) i9 = 20; else if ((i6 | 0) > (i2 | 0)) i5 = i1; else {
    i13 = i1 + 24 | 0;
    i6 = HEAP32[i13 + 4 >> 2] | 0;
    if ((i8 | 0) < (i6 | 0) | ((i8 | 0) == (i6 | 0) ? i7 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0 : 0)) i9 = 20; else i5 = i1;
   }
  }
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
 i1 = i12 + 20 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i11, i3);
 __ZdlPv(i3);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i5;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i12 >> 2] | 0) == (i5 | 0)) HEAP32[i12 >> 2] = i1;
 i13 = i12 + 8 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 4 >> 2] | 0, i5);
 __ZdlPv(i5);
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams8TransferI9JSONWriteEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i9 = i5 + 20 | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i10 = i8 + 20 | 0;
 i11 = i8 + 24 | 0;
 i12 = i8 + 4 | 0;
 i7 = i8 + 4 | 0;
 i2 = i1;
 while (1) {
  i4 = HEAP32[i2 + 20 >> 2] | 0;
  i4 = (i4 | 0) == 0 ? i2 + 24 | 0 : i4;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i14 = gb + 63648 | 0;
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i3 = i11;
  HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP8[i12 >> 0] = 0;
  i3 = _strlen(i4) | 0;
  if (i3 >>> 0 > 15) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i11, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i7 >> 2] = i3;
   i1 = (i1 | 0) == 0 ? i12 : i1;
  } else i1 = i12;
  _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  HEAP32[i10 >> 2] = i3;
  i1 = __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEEixERSE_(i5, i8) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (!((i3 | 0) == 0 | (HEAP32[i7 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i3, i11);
  switch (HEAP32[i1 >> 2] | 0) {
  case 0:
   {
    __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i6, i1 + 8 | 0, i4, 0);
    break;
   }
  case 1:
   {
    __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i6, i1 + 8 | 0, i4, 0);
    break;
   }
  case 2:
   {
    __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i6, i1 + 8 | 0, i4, 0);
    break;
   }
  case 3:
   {
    __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i6, i1 + 8 | 0, i4, 0);
    break;
   }
  case 4:
   {
    __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i6, i1 + 8 | 0, i4, 0);
    break;
   }
  case 5:
   {
    __ZN9JSONWrite8TransferIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_PKc17TransferMetaFlags(i6, i1 + 16 | 0, i4, 0);
    break;
   }
  default:
   {}
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 STACKTOP = i13;
 return;
}

function __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsStringERK8UnityStrS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 40 | 0;
 i6 = i10 + 24 | 0;
 i7 = i10 + 12 | 0;
 i8 = i10;
 i11 = HEAP8[i2 + 11 >> 0] | 0;
 i12 = i11 << 24 >> 24 < 0;
 i4 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i11 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, i2);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
 } else {
  i4 = i3;
  i2 = i2 & 255;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, i2);
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i6, i7, i8);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i4 = i2 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i12 = i1;
   i12 = i12 + i4 | 0;
   HEAP8[i12 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   STACKTOP = i10;
   return;
  }
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i11 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i12;
  HEAP32[i1 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i12;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i12 = i1;
 i12 = i12 + i4 | 0;
 HEAP8[i12 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i10;
 return;
}

function __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i22, i17) {
 i1 = i1 | 0;
 i22 = i22 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23;
 __ZN8GradientC2Ev(i19);
 i20 = i1 + 20 | 0;
 i3 = HEAP32[i20 >> 2] | 0;
 i21 = i22 + 4 | 0;
 i5 = HEAP32[i21 >> 2] | 0;
 i2 = HEAP8[i22 >> 0] | 0;
 i18 = i22 + 12 | 0;
 i4 = HEAP32[i18 >> 2] | 0;
 i1 = HEAP32[i5 + (i2 << 24 >> 24 == 0 ? i3 + -8 + i4 | 0 : i3) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i17 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  i2 = HEAP8[i22 >> 0] | 0;
  i3 = HEAP32[i20 >> 2] | 0;
  i4 = HEAP32[i18 >> 2] | 0;
  i5 = HEAP32[i21 >> 2] | 0;
 }
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i19 >> 2] = i1;
 i9 = i19 + 4 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 + 4 >> 2];
 i10 = i19 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 + 8 >> 2];
 i11 = i19 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 + 12 >> 2];
 i12 = i19 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i7 + 16 >> 2];
 i13 = i19 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i7 + 20 >> 2];
 i14 = i19 + 24 | 0;
 HEAP32[i14 >> 2] = HEAP32[i7 + 24 >> 2];
 i15 = i19 + 28 | 0;
 HEAP32[i15 >> 2] = HEAP32[i7 + 28 >> 2];
 i16 = i19 + 32 | 0;
 i6 = i16;
 i7 = i7 + 32 | 0;
 i8 = i6 + 40 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i6 = i6 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 i2 = HEAP32[i5 + (i2 << 24 >> 24 == 0 ? i3 + -8 + i4 | 0 : i3) >> 2] | 0;
 if (!i2) {
  i2 = _il2cpp_object_new(HEAP32[i17 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i2);
  i1 = HEAP32[i19 >> 2] | 0;
 }
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i15 >> 2];
 i6 = i6 + 32 | 0;
 i7 = i16;
 i8 = i6 + 40 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  i6 = i6 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 i20 = HEAP32[i20 >> 2] | 0;
 HEAP32[(HEAP32[i21 >> 2] | 0) + ((HEAP8[i22 >> 0] | 0) == 0 ? i20 + -8 + (HEAP32[i18 >> 2] | 0) | 0 : i20) >> 2] = i2;
 STACKTOP = i23;
 return;
}

function __Z19InterpolateKeyframeI11QuaternionfET_RK11KeyframeTplIS1_ES5_f(i11, i12, i13, f1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 f10 = Math_fround(HEAPF32[i13 >> 2]);
 f2 = Math_fround(HEAPF32[i12 >> 2]);
 f10 = Math_fround(f10 - f2);
 if (f10 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(f1 - f2) / f10);
  f5 = Math_fround(f10 * Math_fround(HEAPF32[i12 + 36 >> 2]));
  f7 = Math_fround(f10 * Math_fround(HEAPF32[i12 + 40 >> 2]));
  f9 = Math_fround(f10 * Math_fround(HEAPF32[i12 + 44 >> 2]));
  f2 = Math_fround(f10 * Math_fround(HEAPF32[i12 + 48 >> 2]));
  f4 = Math_fround(f10 * Math_fround(HEAPF32[i13 + 20 >> 2]));
  f6 = Math_fround(f10 * Math_fround(HEAPF32[i13 + 24 >> 2]));
  f8 = Math_fround(f10 * Math_fround(HEAPF32[i13 + 28 >> 2]));
  f1 = Math_fround(f10 * Math_fround(HEAPF32[i13 + 32 >> 2]));
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f15 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f21 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f20 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f22 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f16 = Math_fround(f3 * f3);
 f24 = Math_fround(f3 * f16);
 f18 = Math_fround(f24 * Math_fround(2.0));
 f23 = Math_fround(f16 * Math_fround(3.0));
 f14 = Math_fround(Math_fround(f18 - f23) + Math_fround(1.0));
 f3 = Math_fround(f3 + Math_fround(f24 - Math_fround(f16 * Math_fround(2.0))));
 f16 = Math_fround(f24 - f16);
 f18 = Math_fround(f23 - f18);
 f7 = Math_fround(Math_fround(f18 * f22) + Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f7 * f3) + Math_fround(f21 * f14))));
 f9 = Math_fround(Math_fround(Math_fround(f8 * f16) + Math_fround(Math_fround(f9 * f3) + Math_fround(f20 * f14))) + Math_fround(f18 * f19));
 f10 = Math_fround(Math_fround(Math_fround(f1 * f16) + Math_fround(Math_fround(f2 * f3) + Math_fround(f10 * f14))) + Math_fround(f18 * Math_fround(HEAPF32[i13 + 16 >> 2])));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f4 * f16) + Math_fround(Math_fround(f5 * f3) + Math_fround(f15 * f14))));
 HEAPF32[i11 + 4 >> 2] = f7;
 HEAPF32[i11 + 8 >> 2] = f9;
 HEAPF32[i11 + 12 >> 2] = f10;
 return;
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = i5 - i6 | 0;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i2 = i6;
 i8 = i3;
 i12 = i5;
 if (i4 >>> 0 > (i1 - i3 | 0) >>> 0) {
  if (i3) {
   i1 = i11 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i8 | 0)) HEAP32[i1 >> 2] = i8;
   i9 = HEAP32[i11 + 12 >> 2] | 0;
   HEAP32[i7 >> 2] = 14;
   HEAP32[i7 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i7);
   HEAP32[i10 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = 0;
  }
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i1 = HEAP32[i10 >> 2] | 0;
   i3 = HEAP32[i11 >> 2] | 0;
  } else i3 = 0;
  i9 = i1 - i3 | 0;
  i3 = i9 << 1;
  i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 14;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  i4 = i11 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1 + i3;
  if ((i2 | 0) == (i12 | 0)) {
   STACKTOP = i13;
   return;
  }
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 } else {
  i7 = i11 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
  i4 = i4 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + i1 | 0 : i5;
  i3 = i1 - i6 | 0;
  if (i3 | 0) _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i8 + i3 | 0;
  if (!i4) {
   if ((HEAP32[i7 >> 2] | 0) == (i2 | 0)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i7 >> 2] = i2;
   STACKTOP = i13;
   return;
  }
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   STACKTOP = i13;
   return;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i13;
  return;
 }
}

function __ZNK21FullParameterPreparer16OnPrepareTextureERPKN9ShaderLab6TexEnvERKN20GpuProgramParameters16TextureParameterEj(i16, i1, i6, i5) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 16 | 0;
 i4 = i17 + 8 | 0;
 i11 = i17;
 HEAP32[i4 >> 2] = -1;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i12 = HEAP32[i16 >> 2] | 0;
 i13 = HEAP32[i16 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 >> 2] = __ZN9ShaderLab11shaderprops9GetTexEnvEPK19ShaderPropertySheetS3_NS_16FastPropertyNameE16TextureDimensionRNS0_16PropertyLocationE(i12, i13, i14, i15, i4) | 0;
 i15 = HEAP32[i16 + 8 >> 2] | 0;
 if (!i15) {
  STACKTOP = i17;
  return 1;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = (i3 | 0) == 4;
 i14 = i1 & 1;
 i2 = i3 + -1 | 0;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i17;
  return 1;
 }
 if (!(11 >>> (i2 & 15) & 1)) {
  STACKTOP = i17;
  return 1;
 }
 if (!i1) {
  i13 = HEAP32[i4 >> 2] | 0;
  i12 = (i3 | 0) == 2 ? i13 | -1073741824 : HEAP32[i6 >> 2] | 0;
  i10 = (HEAP32[i16 + 12 >> 2] | 0) + i5 | 0;
  i11 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = HEAP32[i6 + 8 >> 2] & 65535;
  i3 = i15 + 60 | 0;
  i4 = i15 + 72 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i15 + 76 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 & 2147483647;
  do if (i6 >>> 0 > i9 >>> 0) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 20 | 0, 4, i15 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i15 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  i9 = HEAP32[i3 >> 2] | 0;
  HEAP32[i9 + (i5 * 20 | 0) >> 2] = i13;
  HEAP32[i9 + (i5 * 20 | 0) + 4 >> 2] = i12;
  HEAP32[i9 + (i5 * 20 | 0) + 8 >> 2] = i10;
  HEAP32[i9 + (i5 * 20 | 0) + 12 >> 2] = i11;
  HEAP16[i9 + (i5 * 20 | 0) + 16 >> 1] = 1;
  HEAP16[i9 + (i5 * 20 | 0) + 18 >> 1] = i2;
  i15 = i15 + 112 | 0;
  HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 }
 i16 = i16 + 16 | 0;
 HEAP8[i16 >> 0] = HEAP8[i16 >> 0] | i14;
 STACKTOP = i17;
 return 1;
}

function __ZN5physx9NpPhysics33unregisterDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj(i2, i4, i18, i17) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = i2 + 64 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i16 >> 2] | 0);
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (!i1) {
  i18 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
  return;
 }
 i15 = i4;
 i15 = i15 + ~(i15 << 15) | 0;
 i15 = (i15 >>> 10 ^ i15) * 9 | 0;
 i15 = i15 >>> 6 ^ i15;
 i15 = i15 + ~(i15 << 11) | 0;
 i1 = HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + ((i1 + -1 & (i15 >>> 16 ^ i15)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i18 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
  return;
 }
 i5 = HEAP32[i2 + 72 >> 2] | 0;
 i3 = i2 + 76 | 0;
 while (1) {
  i2 = i5 + (i1 << 3) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i6 = 16;
   break;
  }
 }
 if ((i6 | 0) == 16) {
  i18 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
  return;
 }
 if (!i2) {
  i18 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
  return;
 }
 i1 = HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0;
 if ((HEAP8[i1 + 41 >> 0] | 0) == 0 | (i17 | 0) == 0) {
  i18 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
  return;
 }
 i10 = i1 + 20 | 0;
 i11 = i1 + 12 | 0;
 i12 = i1 + 4 | 0;
 i13 = i1 + 8 | 0;
 i14 = i1 + 36 | 0;
 i15 = i1 + 32 | 0;
 i8 = i1 + 28 | 0;
 i9 = 0;
 do {
  i1 = HEAP32[i10 >> 2] | 0;
  L21 : do if (i1 | 0) {
   i7 = HEAP32[i18 + (i9 << 2) >> 2] | 0;
   i2 = i7;
   i2 = i2 + ~(i2 << 15) | 0;
   i2 = (i2 >>> 10 ^ i2) * 9 | 0;
   i2 = i2 >>> 6 ^ i2;
   i2 = i2 + ~(i2 << 11) | 0;
   i2 = (HEAP32[i11 >> 2] | 0) + (((i2 >>> 16 ^ i2) & i1 + -1) << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) != -1) {
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = HEAP32[i13 >> 2] | 0;
    i3 = i1;
    i4 = i2;
    while (1) {
     i1 = i4;
     i4 = i6 + (i3 << 2) | 0;
     i2 = i3;
     i3 = HEAP32[i4 >> 2] | 0;
     if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
     if ((i3 | 0) == -1) break L21;
    }
    HEAP32[i1 >> 2] = i3;
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
    HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i2;
   }
  } while (0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i17 | 0));
 i18 = HEAP32[i16 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i18);
 return;
}

function __ZN5physx19PxcContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 488 | 0;
 i11 = i1 + 464 | 0;
 i13 = i1 + 392 | 0;
 i14 = i1 + 168 | 0;
 i8 = i1 + 96 | 0;
 i10 = i1;
 i12 = i1 + 24 | 0;
 HEAP32[i9 >> 2] = 1065353216;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 1065353216;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 1065353216;
 HEAP32[i9 + 36 >> 2] = 1065353216;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 1065353216;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 68 >> 2] = 1065353216;
 i15 = i4 + 4 | 0;
 f18 = Math_fround(HEAPF32[i15 >> 2]);
 f21 = Math_fround(-f18);
 f17 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f20 = Math_fround(-f17);
 f16 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f19 = Math_fround(-f16);
 HEAPF32[i11 >> 2] = f21;
 HEAPF32[i11 + 4 >> 2] = f20;
 HEAPF32[i11 + 8 >> 2] = f19;
 HEAPF32[i11 + 12 >> 2] = f18;
 HEAPF32[i11 + 16 >> 2] = f17;
 HEAPF32[i11 + 20 >> 2] = f16;
 __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E(i14, i15);
 __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i14, i13);
 HEAP32[i8 >> 2] = 1065353216;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 1065353216;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1065353216;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1065353216;
 i5 = __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i5, i8, i10, i12) | 0;
 i7 = __ZL18PxcContactHullHullRKN5physx2Gu13PolygonalDataES3_RKNS_9PxBounds3ES6_RKNS_11PxTransformES9_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESF_bb(i13, i12, i11, i10, i6, i7, Math_fround(HEAPF32[i3 >> 2]), i2, i9, i8, 1, i5) | 0;
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i2, i1, i14, i3, i13, i15) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 20 | 0;
 i4 = i16 + 16 | 0;
 i11 = i16 + 12 | 0;
 i12 = i16;
 HEAP32[i3 >> 2] = 12;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i16;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i15; else {
  HEAP32[gb + 1457168 >> 2] = (HEAP32[gb + 1457168 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i11 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i9 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i11 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i9 = 9;
   } else i9 = 8;
  }
  if ((i9 | 0) == 8) {
   i7 = _strlen(i1) | 0;
   i8 = i1 + i7 | 0;
   if ((i7 | 0) > 0) {
    i5 = i1;
    i7 = 0;
    i4 = 0;
    i2 = 0;
    while (1) {
     if (i5 | 0) if (HEAP8[i5 >> 0] | 0) __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i10, i12, i11);
     i3 = i7 + 12 | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i15 >> 2] | 0) + 8 >> 2] | 0, i15 | 0, i4 | 0) | 0;
      if (i7 | 0) _memcpy(i5 | 0, i2 | 0, i7 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else i6 = i2;
     i5 = i6 + i7 | 0;
     i6 = i12;
     i7 = i5 + 12 | 0;
     do {
      HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
      i5 = i5 + 1 | 0;
      i6 = i6 + 1 | 0;
     } while ((i5 | 0) < (i7 | 0));
     i5 = HEAP32[i11 >> 2] | 0;
     if (i5 >>> 0 >= i8 >>> 0) break; else i7 = i3;
    }
    i4 = i1;
    i3 = (i3 >>> 0) / 12 | 0;
    i1 = i15;
   } else i9 = 9;
  }
  if ((i9 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i15;
  }
  HEAP32[i14 >> 2] = i2;
  HEAP32[i13 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, 0);
 STACKTOP = i16;
 return;
}

function __ZN15TerrainRenderer26CreateQuadTreeNodeRendererER12QuadTreeNodeRK10Matrix4x4fP8MaterialRKNS_22QuadTreeNodeParametersE(i9, i6, i3, i1, i10) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 32 | 0;
 i4 = i12 + 8 | 0;
 i5 = i12;
 i11 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1467168 >> 2] | 0, 272) | 0;
 __ZN20IntermediateRendererC2Ev(i11);
 HEAP32[i11 >> 2] = gb + 184124 + 8;
 i8 = i11 + 264 | 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i11 + 268 | 0;
 HEAP32[i7 >> 2] = 0;
 f15 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 44 >> 2]);
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i6 + 56 >> 2];
 HEAPF32[i4 >> 2] = Math_fround(f15 - Math_fround(HEAPF32[i9 + 32 >> 2]));
 HEAPF32[i4 + 4 >> 2] = Math_fround(f14 - Math_fround(HEAPF32[i9 + 36 >> 2]));
 HEAPF32[i4 + 8 >> 2] = Math_fround(f13 - Math_fround(HEAPF32[i9 + 40 >> 2]));
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i16 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = HEAP8[i10 + 8 >> 0] | 0 ? 2 : 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i11, i3, i4, i2, i16, i1, 1);
 i5 = HEAP32[i10 + 12 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i6;
 i8 = i11 + 236 | 0;
 i7 = (HEAPU16[i8 >> 1] | HEAPU8[i8 + 2 >> 0] << 16) & 16728063 | i5 << 14 & 49152;
 HEAP16[i8 >> 1] = i7;
 HEAP8[i8 + 2 >> 0] = i7 >>> 16;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i11 + 248 >> 2] = i1;
 i16 = i9 + 108 | 0;
 i7 = i9 + 76 | 0;
 HEAP16[i11 + 228 >> 1] = HEAP16[i16 >> 1] | 0;
 i8 = i11 + 196 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = i9 + 92 | 0;
 HEAP16[i11 + 230 >> 1] = HEAP16[i16 + 2 >> 1] | 0;
 i16 = i11 + 212 | 0;
 HEAP32[i16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i11, HEAP32[i9 + 112 >> 2] | 0);
 __Z23AddIntermediateRendererP20IntermediateRendererP6Camera(i11, HEAP32[i10 >> 2] | 0);
 STACKTOP = i12;
 return;
}

function __Z31AssetBundle_CUSTOM_LoadFromFileP12Il2CppStringjy(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 i10 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i10, i1);
 i7 = __ZnwjRK10MemLabelIdiPKci(216, gb + 64016 | 0, 16, gb + 495876 | 0, 97) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i10);
 __ZN37AssetBundleLoadFromFileAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i7, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 HEAP32[i7 + 88 >> 2] = i2;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7 + 192 | 0, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = i7 + 208 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 __ZN37AssetBundleLoadFromFileAsyncOperation20ExecuteSynchronouslyEv(i7);
 i4 = i7 + 84 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 9;
   }
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 if (!i7) {
  __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64016 | 0);
  i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64016 | 0);
 i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0;
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f13 * f7);
 i20 = f6 < Math_fround(0.0);
 f16 = Math_fround(-f6);
 f17 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f5 = Math_fround(f11 * f17);
 i18 = f5 < Math_fround(0.0);
 f9 = Math_fround(-f5);
 f5 = Math_fround((i20 ? f16 : f6) + (i18 ? f9 : f5));
 f9 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f6 = Math_fround(f4 * f9);
 i18 = f6 < Math_fround(0.0);
 f16 = Math_fround(-f6);
 f6 = Math_fround(f5 + (i18 ? f16 : f6));
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f13 * f16);
 i18 = f5 < Math_fround(0.0);
 f14 = Math_fround(-f5);
 f15 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f19 = Math_fround(f11 * f15);
 i20 = f19 < Math_fround(0.0);
 f8 = Math_fround(-f19);
 f19 = Math_fround((i18 ? f14 : f5) + (i20 ? f8 : f19));
 f8 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f5 = Math_fround(f4 * f8);
 i20 = f5 < Math_fround(0.0);
 f14 = Math_fround(-f5);
 f5 = Math_fround(f19 + (i20 ? f14 : f5));
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f13 * f14);
 i20 = f13 < Math_fround(0.0);
 f19 = Math_fround(-f13);
 f12 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f11 = Math_fround(f11 * f12);
 i18 = f11 < Math_fround(0.0);
 f10 = Math_fround(-f11);
 f11 = Math_fround((i20 ? f19 : f13) + (i18 ? f10 : f11));
 f10 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f4 = Math_fround(f4 * f10);
 i18 = f4 < Math_fround(0.0);
 f13 = Math_fround(-f4);
 f4 = Math_fround(f11 + (i18 ? f13 : f4));
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f7 * f13);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(f7 + Math_fround(f17 * f11));
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f17 + Math_fround(f9 * f7));
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 48 >> 2]) + f9);
 f8 = Math_fround(Math_fround(Math_fround(f16 * f13) + Math_fround(f15 * f11)) + Math_fround(f8 * f7));
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 52 >> 2]) + f8);
 f7 = Math_fround(Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * f11)) + Math_fround(f10 * f7));
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i2 + 56 >> 2]));
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = f6;
 HEAPF32[i3 + 16 >> 2] = f5;
 HEAPF32[i3 + 20 >> 2] = f4;
 return;
}

function __ZN5IMGUI19NamedKeyControlList15AddNamedControlERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEii(i9, i7, i10, i11) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i9 + 4 | 0;
 i6 = i1;
 L1 : do if ((i6 | 0) != (i3 | 0)) {
  i5 = i6;
  while (1) {
   if ((HEAP32[i5 + 28 >> 2] | 0) == (i10 | 0)) break;
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i3 | 0)) break L1; else {
    i1 = i2;
    i5 = i2;
   }
  }
  i4 = i1;
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i2) {
   i3 = i4;
   while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   }
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i6 | 0) == (i5 | 0)) HEAP32[i9 >> 2] = i2;
  i6 = i9 + 8 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 16 | 0);
  __ZdlPv(i1);
 } while (0);
 i2 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlENS_4lessIS6_EENS4_INS_4pairIKS6_S8_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSC_(i9, i8, i7) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i9 = i1;
  i9 = i9 + 28 | 0;
  i8 = i9;
  HEAP32[i8 >> 2] = i10;
  i10 = i9 + 4 | 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 i3 = __Znwj(36) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 16 | 0, i7);
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = -1;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i1);
 i9 = i9 + 8 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = i3;
 i9 = i9 + 28 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i10;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS5_L18MemLabelIdentifier77ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431362 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI17ProceduralTextureE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431362 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI17ProceduralTextureE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i3 = i11;
 i5 = i10 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 | 0) {
  if ((HEAP32[i4 + 80 >> 2] | 0) == (HEAP32[i4 + 48 >> 2] | 0)) {
   i2 = HEAP32[i4 + 72 >> 2] | 0;
   i3 = HEAP32[i4 + 76 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i2, i4 + 44 | 0, i3);
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i4 + 72 >> 2] | 0;
   i3 = HEAP32[i4 + 76 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i9 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i9 | 0) == -1) {
    STACKTOP = i11;
    return;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + (i9 << 3) + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 & 536870912 | 0) {
    STACKTOP = i11;
    return;
   }
   i8 = i10 + 8 | 0;
   HEAP32[i2 >> 2] = i3 | 536870912;
   i7 = i3 & 536870911;
   if (!((i7 | 0) != 78 & (((i7 | 0) == 43 | ((i7 | 0) == 142 | ((i7 | 0) == 84 | ((i7 | 0) == 158 | ((i7 | 0) == 171 | ((i7 | 0) == 89 | ((i7 + -187 | 0) >>> 0 < 2 | ((i7 | 0) == 117 | ((i7 + -27 | 0) >>> 0 < 2 | ((i7 | 0) == 150 | ((i7 | 0) == 147 | ((i7 | 0) == 115 | (i7 | 0) == 149)))))))))))) ^ 1) & 1 | (HEAPU8[i1 + 105 >> 0] | 0))) {
    STACKTOP = i11;
    return;
   }
   i2 = i10 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 24 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i10 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i8 >> 2] = i10;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2] = i9;
   STACKTOP = i11;
   return;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN7mecanim9animation28DestroyBlendTreeNodeConstantEPNS0_21BlendTreeNodeConstantERNS_6memory9AllocatorE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i1 | 0);
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i1 = i2 + i1 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i1 | 0);
 }
 i1 = i7 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i1 = i2 + i1 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i1 | 0);
 }
 i5 = i7 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = HEAP32[i8 >> 2] | 0;
  i6 = i6 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(i6 | 0, i8 | 0, i7 | 0);
  return;
 }
 i6 = i5;
 i2 = i1 + i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3) {
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i3 + i2 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i1 + i6 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3) {
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i3 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i1 + i6 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3) {
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i3 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i1 + i6 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i3 = i1; else {
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i3 | 0);
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i3 + i6 | 0;
 if (!(HEAP32[i2 + 36 >> 2] | 0)) {
  i6 = HEAP32[i8 >> 2] | 0;
  i6 = i6 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(i6 | 0, i8 | 0, i7 | 0);
  return;
 }
 i1 = i2 + 36 | 0;
 if (HEAP32[i2 + 32 >> 2] | 0) {
  i4 = 0;
  while (1) {
   i1 = (HEAP32[i1 >> 2] | 0) + i1 + (i4 << 3) + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i2 = i3; else {
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i1 + i2 | 0);
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   i3 = i2 + i6 | 0;
   i1 = i3 + 36 | 0;
   if (i4 >>> 0 >= (HEAP32[i3 + 32 >> 2] | 0) >>> 0) break; else i3 = i2;
  }
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i6 = HEAP32[i8 >> 2] | 0;
  i6 = i6 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(i6 | 0, i8 | 0, i7 | 0);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i2 + i1 | 0);
 i6 = HEAP32[i8 >> 2] | 0;
 i6 = i6 + 4 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(i6 | 0, i8 | 0, i7 | 0);
 return;
}

function __ZN5physx2Sc5Scene19islandGenSecondPassEPNS_10PxBaseTaskE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 24 | 0;
 i12 = i15 + 20 | 0;
 i7 = i15 + 16 | 0;
 i14 = i15 + 8 | 0;
 i13 = i15;
 i4 = i15 + 28 | 0;
 i6 = i1 + 1204 | 0;
 i9 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i6 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + 1e3 >> 2] | 0;
 __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_(i6, i10, i12, 0) | 0;
 i2 = HEAP32[i10 >> 2] << 3;
 i5 = i2 >>> 0 > 1024;
 i8 = i14 + 4 | 0;
 HEAP8[i8 >> 0] = i5 & 1;
 if (i5) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i15 + 29 | 0, i2, gb + 680241 | 0, 1378) | 0;
  HEAP32[i14 >> 2] = i1;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i14 >> 2] = i1;
 }
 i3 = HEAP32[i12 >> 2] << 3;
 i2 = i3 >>> 0 > 1024;
 i5 = i13 + 4 | 0;
 HEAP8[i5 >> 0] = i2 & 1;
 if (i2) {
  i2 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i4, i3, gb + 680241 | 0, 1379) | 0;
  HEAP32[i13 >> 2] = i2;
  i3 = i14;
  i1 = HEAP32[i14 >> 2] | 0;
 } else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i13 >> 2] = i2;
  i3 = i14;
 }
 __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_(i6, i1, i10, i2, i12, 0, i7) | 0;
 if ((HEAP32[i10 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __ZN5physx2Sc19ShapeInstancePairLL25postNarrowPhaseSecondPassERNS_16PxsIslandManagerEb(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, i9, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i10 >> 2] | 0));
 }
 if ((HEAP32[i12 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __ZN5physx2Sc19ShapeInstancePairLL25postNarrowPhaseSecondPassERNS_16PxsIslandManagerEb(HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, i9, 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i12 >> 2] | 0));
 }
 if (HEAP8[i5 >> 0] | 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 if (!(HEAP8[i8 >> 0] | 0)) {
  __ZN5physx16PxsIslandManager23updateIslandsSecondPassEPNS_10PxBaseTaskEj(i9, i11, 0);
  STACKTOP = i15;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i14, HEAP32[i14 >> 2] | 0);
 __ZN5physx16PxsIslandManager23updateIslandsSecondPassEPNS_10PxBaseTaskEj(i9, i11, 0);
 STACKTOP = i15;
 return;
}

function __Z31RegisterModuleClasses_Animationv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 946;
 HEAP32[i2 + 8 >> 2] = gb + 896226;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 111;
 HEAP32[i2 + 20 >> 2] = 332;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 176192;
 HEAP32[i2 + 44 >> 2] = fb + 298;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 299;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 176524;
 HEAP32[i2 + 4 >> 2] = fb + 947;
 HEAP32[i2 + 8 >> 2] = gb + 897916;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 74;
 HEAP32[i2 + 20 >> 2] = 296;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 65780;
 HEAP32[i2 + 44 >> 2] = fb + 302;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 303;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI25RuntimeAnimatorControllerEvv();
 HEAP32[i2 >> 2] = gb + 178436;
 HEAP32[i2 + 4 >> 2] = fb + 948;
 HEAP32[i2 + 8 >> 2] = gb + 902391;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 91;
 HEAP32[i2 + 20 >> 2] = 212;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 178256;
 HEAP32[i2 + 44 >> 2] = fb + 304;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 305;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 30072;
 HEAP32[i2 + 4 >> 2] = fb + 949;
 HEAP32[i2 + 8 >> 2] = gb + 902235;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 95;
 HEAP32[i2 + 20 >> 2] = 636;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67008;
 HEAP32[i2 + 44 >> 2] = fb + 306;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 307;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 __Z13RegisterClassI6AvatarEvv();
 __Z13RegisterClassI6MotionEvv();
 __Z13RegisterClassI26AnimatorOverrideControllerEvv();
 STACKTOP = i1;
 return;
}

function _UNITY_png_handle_bKGD(i9, i10, i5) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 10 | 0;
 i11 = i12;
 i1 = HEAP32[i9 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i9, gb + 352205 | 0);
 if (!(i1 & 4)) {
  i2 = i9 + 431 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i4 = i3 << 24 >> 24 == 3;
  if (!((i1 & 2 | 0) == 0 & i4)) {
   i6 = (i10 | 0) != 0;
   if (i6) if (HEAP32[i10 + 8 >> 2] & 32 | 0) {
    _UNITY_png_crc_finish(i9, i5) | 0;
    _UNITY_png_chunk_benign_error(i9, gb + 352436 | 0);
    STACKTOP = i12;
    return;
   }
   if (((i4 ? 1 : (i3 & 2) << 1 | 2) | 0) != (i5 | 0)) {
    _UNITY_png_crc_finish(i9, i5) | 0;
    _UNITY_png_chunk_benign_error(i9, gb + 352446 | 0);
    STACKTOP = i12;
    return;
   }
   _UNITY_png_read_data(i9, i7, i5);
   _UNITY_png_calculate_crc(i9, i7, i5);
   if (_UNITY_png_crc_finish(i9, 0) | 0) {
    STACKTOP = i12;
    return;
   }
   i2 = HEAP8[i2 >> 0] | 0;
   do if (i2 << 24 >> 24 == 3) {
    i1 = HEAP8[i7 >> 0] | 0;
    HEAP8[i11 >> 0] = i1;
    do if (i6) {
     i2 = HEAP16[i10 + 20 >> 1] | 0;
     if (!(i2 << 16 >> 16)) i8 = 18; else {
      i1 = i1 & 255;
      if (i1 >>> 0 < (i2 & 65535) >>> 0) {
       i7 = HEAP32[i9 + 412 >> 2] | 0;
       HEAP16[i11 + 2 >> 1] = HEAPU8[i7 + (i1 * 3 | 0) >> 0] | 0;
       HEAP16[i11 + 4 >> 1] = HEAPU8[i7 + (i1 * 3 | 0) + 1 >> 0] | 0;
       HEAP16[i11 + 6 >> 1] = HEAPU8[i7 + (i1 * 3 | 0) + 2 >> 0] | 0;
       break;
      }
      _UNITY_png_chunk_benign_error(i9, gb + 352912 | 0);
      STACKTOP = i12;
      return;
     }
    } else i8 = 18; while (0);
    if ((i8 | 0) == 18) {
     HEAP16[i11 + 6 >> 1] = 0;
     HEAP16[i11 + 4 >> 1] = 0;
     HEAP16[i11 + 2 >> 1] = 0;
    }
    HEAP16[i11 + 8 >> 1] = 0;
   } else {
    HEAP8[i11 >> 0] = 0;
    i1 = ((HEAPU8[i7 >> 0] | 0) << 8 | (HEAPU8[i7 + 1 >> 0] | 0)) & 65535;
    if (!(i2 & 2)) {
     HEAP16[i11 + 8 >> 1] = i1;
     HEAP16[i11 + 6 >> 1] = i1;
     HEAP16[i11 + 4 >> 1] = i1;
     HEAP16[i11 + 2 >> 1] = i1;
     break;
    } else {
     HEAP16[i11 + 2 >> 1] = i1;
     HEAP16[i11 + 4 >> 1] = (HEAPU8[i7 + 2 >> 0] | 0) << 8 | (HEAPU8[i7 + 3 >> 0] | 0);
     HEAP16[i11 + 6 >> 1] = (HEAPU8[i7 + 4 >> 0] | 0) << 8 | (HEAPU8[i7 + 5 >> 0] | 0);
     HEAP16[i11 + 8 >> 1] = 0;
     break;
    }
   } while (0);
   _UNITY_png_set_bKGD(i9, i10, i11);
   STACKTOP = i12;
   return;
  }
 }
 _UNITY_png_crc_finish(i9, i5) | 0;
 _UNITY_png_chunk_benign_error(i9, gb + 352423 | 0);
 STACKTOP = i12;
 return;
}

function __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 40 | 0;
 i15 = i3 + 24 | 0;
 i5 = i3 + 8 | 0;
 i21 = i3;
 i23 = i2 + 32 | 0;
 i22 = HEAP32[i23 + 4 >> 2] | 0;
 i2 = i21;
 HEAP32[i2 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i2 + 4 >> 2] = i22;
 HEAP32[i4 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i4, i15, i5);
 f20 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(f20 * Math_fround(-2.0));
 f17 = Math_fround(f20 * Math_fround(2.0));
 f16 = Math_fround(f20 * f12);
 f11 = Math_fround(f7 * Math_fround(-2.0));
 f9 = Math_fround(f7 * Math_fround(2.0));
 f10 = Math_fround(f7 * f11);
 f14 = Math_fround(Math_fround(f16 + f10) + Math_fround(1.0));
 f13 = Math_fround(Math_fround(Math_fround(f6 * f17) + Math_fround(f19 * f9)) + Math_fround(0.0));
 f12 = Math_fround(Math_fround(Math_fround(f12 * f19) + Math_fround(f6 * f9)) + Math_fround(0.0));
 f8 = Math_fround(f6 * Math_fround(2.0));
 f18 = Math_fround(f6 * Math_fround(-2.0));
 f6 = Math_fround(f6 * f18);
 f11 = Math_fround(Math_fround(Math_fround(f20 * f8) + Math_fround(f19 * f11)) + Math_fround(0.0));
 f10 = Math_fround(Math_fround(f6 + f10) + Math_fround(1.0));
 f9 = Math_fround(Math_fround(Math_fround(f19 * f8) + Math_fround(f20 * f9)) + Math_fround(0.0));
 f8 = Math_fround(Math_fround(Math_fround(f17 * f19) + Math_fround(f8 * f7)) + Math_fround(0.0));
 f7 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * f7)) + Math_fround(0.0));
 f6 = Math_fround(Math_fround(f16 + f6) + Math_fround(1.0));
 i5 = HEAP32[i15 >> 2] | 0;
 i4 = HEAP32[i15 + 4 >> 2] | 0;
 i2 = HEAP32[i15 + 8 >> 2] | 0;
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i1 + 16 >> 2] = f11;
 HEAPF32[i1 + 20 >> 2] = f10;
 HEAPF32[i1 + 24 >> 2] = f9;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = f8;
 HEAPF32[i1 + 36 >> 2] = f7;
 HEAPF32[i1 + 40 >> 2] = f6;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = i5;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 STACKTOP = i3;
 return;
}

function __ZN9ShaderLab9IntShaderD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = i5 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i6 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 __ZN9ShaderLab9IntShader27DeleteUnsupportedSubShadersEv(i5);
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i6 >> 2] | 0)) do {
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i4 = i3 + 12 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    do {
     __ZN9ShaderLab4Pass7ReleaseEv(HEAP32[i2 >> 2] | 0);
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
   }
   __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i3 + 24 | 0, HEAP32[i3 + 28 >> 2] | 0);
   if ((HEAP32[i3 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
    HEAP32[i3 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i6 >> 2] | 0));
 i3 = i5 + 132 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 136 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i7 = i2 + -24 | 0;
    HEAP32[i4 >> 2] = i7;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + -12 | 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 120 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 108 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 96 | 0);
 i1 = i5 + 72 | 0;
 if ((HEAP32[i5 + 88 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 76 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 return;
}

function __ZN5physx32PxArticulationJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 674002;
 HEAP32[i1 + 4 >> 2] = 62;
 HEAP32[i1 + 8 >> 2] = fb + 3510;
 HEAP32[i1 + 12 >> 2] = fb + 3511;
 HEAP32[i1 + 16 >> 2] = gb + 674013;
 HEAP32[i1 + 20 >> 2] = 63;
 HEAP32[i1 + 24 >> 2] = fb + 3512;
 HEAP32[i1 + 28 >> 2] = fb + 3513;
 HEAP32[i1 + 32 >> 2] = gb + 674023;
 HEAP32[i1 + 36 >> 2] = 64;
 HEAP32[i1 + 40 >> 2] = fb + 3514;
 HEAP32[i1 + 44 >> 2] = fb + 3515;
 HEAP32[i1 + 48 >> 2] = gb + 674041;
 HEAP32[i1 + 52 >> 2] = 65;
 HEAP32[i1 + 56 >> 2] = fb + 3516;
 HEAP32[i1 + 60 >> 2] = fb + 3517;
 HEAP32[i1 + 64 >> 2] = gb + 674056;
 HEAP32[i1 + 68 >> 2] = 66;
 HEAP32[i1 + 72 >> 2] = fb + 2126;
 HEAP32[i1 + 76 >> 2] = fb + 3518;
 HEAP32[i1 + 80 >> 2] = gb + 765184;
 HEAP32[i1 + 84 >> 2] = 67;
 HEAP32[i1 + 88 >> 2] = fb + 384;
 HEAP32[i1 + 92 >> 2] = fb + 326;
 HEAP32[i1 + 96 >> 2] = gb + 741403;
 HEAP32[i1 + 100 >> 2] = 68;
 HEAP32[i1 + 104 >> 2] = fb + 385;
 HEAP32[i1 + 108 >> 2] = fb + 327;
 HEAP32[i1 + 112 >> 2] = gb + 674066;
 HEAP32[i1 + 116 >> 2] = 69;
 HEAP32[i1 + 120 >> 2] = fb + 386;
 HEAP32[i1 + 124 >> 2] = fb + 328;
 HEAP32[i1 + 128 >> 2] = gb + 674085;
 HEAP32[i1 + 132 >> 2] = 70;
 HEAP32[i1 + 136 >> 2] = fb + 387;
 HEAP32[i1 + 140 >> 2] = fb + 329;
 HEAP32[i1 + 144 >> 2] = gb + 742709;
 HEAP32[i1 + 148 >> 2] = 71;
 HEAP32[i1 + 152 >> 2] = gb + 765133;
 HEAP32[i1 + 156 >> 2] = gb + 765149;
 HEAP32[i1 + 160 >> 2] = fb + 15;
 HEAP32[i1 + 164 >> 2] = fb + 771;
 HEAP32[i1 + 168 >> 2] = gb + 765211;
 HEAP32[i1 + 172 >> 2] = 72;
 HEAP32[i1 + 176 >> 2] = fb + 388;
 HEAP32[i1 + 180 >> 2] = fb + 330;
 HEAP32[i1 + 184 >> 2] = gb + 674104;
 HEAP32[i1 + 188 >> 2] = 73;
 HEAP32[i1 + 192 >> 2] = fb + 389;
 HEAP32[i1 + 196 >> 2] = fb + 331;
 HEAP32[i1 + 200 >> 2] = gb + 674122;
 HEAP32[i1 + 204 >> 2] = 74;
 HEAP32[i1 + 208 >> 2] = fb + 390;
 HEAP32[i1 + 212 >> 2] = fb + 332;
 HEAP32[i1 + 216 >> 2] = gb + 674148;
 HEAP32[i1 + 220 >> 2] = 75;
 HEAP32[i1 + 224 >> 2] = fb + 2127;
 HEAP32[i1 + 228 >> 2] = fb + 3519;
 HEAP32[i1 + 232 >> 2] = gb + 765156;
 HEAP32[i1 + 236 >> 2] = 76;
 HEAP32[i1 + 240 >> 2] = gb + 1084385;
 HEAP32[i1 + 244 >> 2] = gb + 1084403;
 HEAP32[i1 + 248 >> 2] = fb + 16;
 HEAP32[i1 + 252 >> 2] = fb + 772;
 HEAP32[i1 + 256 >> 2] = gb + 674166;
 HEAP32[i1 + 260 >> 2] = 77;
 HEAP32[i1 + 264 >> 2] = fb + 2128;
 HEAP32[i1 + 268 >> 2] = fb + 3520;
 HEAP32[i1 + 272 >> 2] = gb + 674184;
 HEAP32[i1 + 276 >> 2] = 78;
 HEAP32[i1 + 280 >> 2] = fb + 391;
 HEAP32[i1 + 284 >> 2] = fb + 333;
 HEAP32[i1 + 288 >> 2] = gb + 831985;
 HEAP32[i1 + 292 >> 2] = 79;
 HEAP32[i1 + 296 >> 2] = fb + 2129;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 12 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 12 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 12 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 12 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
   i2 = i2 + 12 | 0;
   i3 = i3 + 12 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -12 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1);
   i1 = i1 + 12 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 12 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -12 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 12 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 178956970 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 357913941;
 if (i3 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 12 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 12 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  i2 = i2 + 12 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 12 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7putbackEw(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 HEAP32[i7 + 4 >> 2] = 0;
 i5 = i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] & -3 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 do if (i5 & 1) i6 = 12; else {
  __THREW__ = 0;
  invoke_viii(fb + 1038 | 0, i2 | 0, i7 | 0, 1);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) i6 = 12; else {
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0;
   i3 = i7 + i4 | 0;
   do if (!(HEAP8[i2 >> 0] | 0)) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 4 | 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) i6 = 13; else i6 = 18;
   } else {
    i5 = HEAP32[i3 + 24 >> 2] | 0;
    if (!i5) i1 = i4; else {
     i3 = i5 + 12 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i5 + 8 >> 2] | 0) == (i2 | 0)) i6 = 7; else {
      i2 = i2 + -4 | 0;
      if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) HEAP32[i3 >> 2] = i2; else i6 = 7;
     }
     if ((i6 | 0) == 7) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i1 | 0) | 0;
      i6 = __THREW__;
      __THREW__ = 0;
      if (i6 & 1) {
       i6 = 13;
       break;
      }
     }
     if ((i1 | 0) != -1) {
      i6 = 18;
      break;
     }
     i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0;
    }
    i6 = i7 + i1 | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | 1 | 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) i6 = 13; else i6 = 18;
   } while (0);
   if ((i6 | 0) == 13) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i6 = 14;
    break;
   } else if ((i6 | 0) == 18) break;
  }
 } while (0);
 if ((i6 | 0) == 12) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i6 = 14;
 }
 do if ((i6 | 0) == 14) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i6);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i1 = i8 * 20 | 0;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 660493 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 * 20 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
   __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE(i1 + 8 | 0, i2 + 8 | 0);
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 20 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i5 + (i1 * 20 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP16[i3 + 4 >> 1] = HEAP16[i4 + 4 >> 1] | 0;
 __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE(i5 + (i1 * 20 | 0) + 8 | 0, i4 + 8 | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + (i4 * 20 | 0) | 0;
 if ((i4 | 0) > 0) do {
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 | 0);
   }
  }
  i1 = i1 + 20 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i6 >> 2] = i8;
  i9 = i5 + (i9 * 20 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i6 >> 2] = i8;
  i9 = i5 + (i9 * 20 | 0) | 0;
  return i9 | 0;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i6 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i6 >> 2] = i8;
 i9 = i5 + (i9 * 20 | 0) | 0;
 return i9 | 0;
}

function __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i5 = i9;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i8);
 i4 = i3 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 800860 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i8 + 16 | 0;
   i10 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i10 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i3 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 800878 | 0, gb + 1048681 | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i8 + 16 | 0;
    i10 = HEAP32[i8 + 20 >> 2] | 0;
    i2 = i10 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i10 >>> 0) i7 = 17; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
    if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
  if (__ZN14SafeBinaryRead12IsOldVersionEi(i8, 1) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 & 32 | 0) HEAP32[i4 >> 2] = i1 | -65536;
  }
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcRNS_6vectorIS5_NS3_IS5_EEEEi(i14, i10, i15, i2) {
 i14 = i14 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i13 = i14 + 11 | 0;
 L1 : do if ((i2 | 0) == 1) {
  i2 = 0;
  i1 = i14 + 4 | 0;
 } else {
  i1 = i14 + 4 | 0;
  i11 = i15 + 4 | 0;
  i12 = i15 + 8 | 0;
  i3 = i2;
  i2 = 0;
  do {
   i6 = HEAP8[i13 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   i8 = i5 ? HEAP32[i14 >> 2] | 0 : i14;
   i6 = i5 ? HEAP32[i1 >> 2] | 0 : i6 & 255;
   i5 = _strlen(i10) | 0;
   if (i6 >>> 0 <= i2 >>> 0 | (i5 | 0) == 0) break L1;
   i4 = i8 + i2 | 0;
   i9 = i8 + i6 | 0;
   i7 = i10 + i5 | 0;
   L7 : do if ((i6 | 0) != (i2 | 0)) while (1) {
    i6 = HEAP8[i4 >> 0] | 0;
    i5 = i10;
    do {
     if (i6 << 24 >> 24 == (HEAP8[i5 >> 0] | 0)) break L7;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i7 | 0));
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i9 | 0)) break L1;
   } while (0);
   i5 = i4 - i8 | 0;
   if ((i4 | 0) == (i9 | 0) | (i5 | 0) == -1) break L1;
   if (i5 >>> 0 > i2 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i16, i14, i2, i5 - i2 | 0, i14);
    i2 = HEAP32[i11 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i12 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i15, i16); else {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i16);
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 12;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
    i3 = i3 + -1 | 0;
   }
   i2 = i5 + 1 | 0;
  } while ((i3 | 0) != 1);
 } while (0);
 i13 = HEAP8[i13 >> 0] | 0;
 if (i2 >>> 0 >= (i13 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i13 & 255) >>> 0) {
  STACKTOP = i17;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i16, i14, i2, -1, i14);
 i1 = i15 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i15 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i15, i16); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i16);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 STACKTOP = i17;
 return;
}

function __ZN7mecanim5human9HumanPoseC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1065353216;
 HEAP32[i3 + 28 >> 2] = 1065353216;
 HEAP32[i3 + 32 >> 2] = 1065353216;
 HEAP32[i3 + 36 >> 2] = 1065353216;
 i4 = i3 + 40 | 0;
 i1 = i3 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 1065353216;
 HEAP32[i3 + 96 >> 2] = 1065353216;
 HEAP32[i3 + 100 >> 2] = 1065353216;
 HEAP32[i3 + 104 >> 2] = 1065353216;
 i1 = i3 + 160 | 0;
 i2 = i3 + 156 | 0;
 i5 = i3 + 108 | 0;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i3 + 164 >> 2] = 1065353216;
 HEAP32[i3 + 168 >> 2] = 1065353216;
 i1 = i3 + 224 | 0;
 i2 = i3 + 220 | 0;
 i5 = i3 + 172 | 0;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i3 + 228 >> 2] = 1065353216;
 HEAP32[i3 + 232 >> 2] = 1065353216;
 i1 = i3 + 288 | 0;
 i2 = i3 + 284 | 0;
 i5 = i3 + 236 | 0;
 i6 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i3 + 292 >> 2] = 1065353216;
 HEAP32[i3 + 296 >> 2] = 1065353216;
 i1 = i3 + 300 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = i3 + 324 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 348 >> 2] = 1065353216;
 HEAP32[i3 + 352 >> 2] = 1065353216;
 HEAP32[i3 + 356 >> 2] = 1065353216;
 HEAP32[i3 + 360 >> 2] = 1065353216;
 i1 = i3 + 488 | 0;
 i2 = i3 + 484 | 0;
 i5 = i3 + 364 | 0;
 i6 = i5 + 120 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i3 + 492 >> 2] = 1065353216;
 HEAP32[i3 + 496 >> 2] = 1065353216;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 _memset(i3 + 500 | 0, 0, 388) | 0;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470646 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab26SerializedShaderDependency8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470646 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab26SerializedShaderDependency8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 88 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034188 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 88 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034188 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z49Terrain_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i1 = i11;
 i10 = i11 + 32 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i10 >> 2] = 0;
 i6 = i10 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i1);
 i1 = i9;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = __Z19GetReflectionProbesv() | 0;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK7Terrain12GetWorldAABBEv(i9, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN16ReflectionProbes16GetClosestProbesERK4AABBP9Transform20ReflectionProbeUsageR13dynamic_arrayI24ReflectionProbeBlendInfoLj4EE(i3, i9, 0, HEAP32[i1 + 92 >> 2] | 0, i10);
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 308 >> 2] | 0;
 i2 = i5 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  while (1) {
   __Z35ReflectionProbeBlendInfoToScriptingRK24ReflectionProbeBlendInfoR33ScriptingReflectionProbeBlendInfo(i1, i9);
   i13 = i9;
   i14 = HEAP32[i13 >> 2] | 0;
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i12 >> 2] = i14;
   HEAP32[i12 + 4 >> 2] = i13;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 8 | 0;
  }
 }
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 >> 2];
 i14 = i5 + 16 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i8);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx10ChangeList11computeListEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 1 | 0;
 i8 = i11;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) {
  STACKTOP = i11;
  return;
 }
 i9 = i10 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i1 & 2147483647;
 if (i4) {
  i2 = 0;
  i5 = 0;
  do {
   i6 = HEAP32[i3 + (i5 << 2) >> 2] | 0;
   i6 = i6 - (i6 >>> 1 & 1431655765) | 0;
   i6 = (i6 >>> 2 & 858993459) + (i6 & 858993459) | 0;
   i2 = ((Math_imul((i6 >>> 4) + i6 & 252645135, 16843009) | 0) >>> 24) + i2 | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
  i5 = i10 + 20 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (i2 >>> 0 > i6 >>> 0) {
   i2 = i2 + 31 & -32;
   i3 = i10 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i2 << 2, gb + 717789 | 0, 59) | 0;
   if (i4 | 0) _memcpy(i1 | 0, i4 | 0, i6 << 2 | 0) | 0;
   _memset(i1 + (i6 << 2) | 0, 0, i2 - i6 << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i4);
   HEAP32[i3 >> 2] = i1;
   HEAP32[i5 >> 2] = i2;
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 i5 = i1 & 2147483647;
 L13 : do if (!i5) i1 = 0; else {
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i1 = 0;
    break L13;
   }
  }
  i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L19 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    break L19;
   }
   i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i4 | 0) == -1) i1 = 0; else {
   i6 = HEAP32[i10 + 12 >> 2] | 0;
   i3 = i1;
   i1 = 0;
   while (1) {
    i5 = i3 << 5;
    while (1) {
     HEAP32[i6 + (i1 << 2) >> 2] = i4;
     i1 = i1 + 1 | 0;
     if (!i2) break L13;
     i4 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i4 = HEAP32[gb + 90668 + (i4 << 2) >> 2] | i5;
     i2 = i2 + -1 & i2;
     if (!i2) {
      i5 = i4;
      break;
     }
     if ((i4 | 0) == -1) break L13;
    }
    i4 = HEAP32[i9 >> 2] & 2147483647;
    i2 = i3;
    while (1) {
     i3 = i2 + 1 | 0;
     if (i3 >>> 0 >= i4 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
     if (!i2) i2 = i3; else break;
    }
    if ((i5 | 0) == -1) break; else i4 = i5;
   }
  }
 } while (0);
 HEAP32[i10 + 16 >> 2] = i1;
 STACKTOP = i11;
 return;
}

function __ZN5Unity12PhysicsQuery10OverlapBoxERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction(i3, i4, i9, i10, i11, i12) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 108 | 0;
 i13 = i17 + 88 | 0;
 i14 = i17 + 72 | 0;
 i15 = i17 + 40 | 0;
 i16 = i17;
 if ((HEAP16[gb + 1452728 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452728 | 0, i1);
  i2 = gb + 1452728 | 0;
 } else i2 = 0;
 i5 = i3 + 36 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i3 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) != (i6 | 0)) HEAP32[i7 >> 2] = i8 + (~((i8 + -4 - i6 | 0) >>> 2) << 2);
 i8 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 + 8 >> 2] = 0;
 HEAP32[i16 + 12 >> 2] = -1;
 HEAP8[i16 + 20 >> 0] = 0;
 HEAP32[i16 + 24 >> 2] = i8;
 HEAP32[i16 + 28 >> 2] = 128;
 HEAP32[i16 + 32 >> 2] = 0;
 HEAP32[i16 >> 2] = gb + 151304 + 8;
 HEAP32[i16 + 36 >> 2] = i5;
 HEAP32[i1 >> 2] = gb + 114012 + 8;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i11;
 switch (i12 | 0) {
 case 0:
  {
   HEAP8[i1 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i1 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i1 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP16[i13 + 16 >> 1] = 7;
 HEAP8[i13 + 18 >> 0] = 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 i9 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = 3;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i9;
 i9 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 i12 = HEAP32[i4 + 8 >> 2] | 0;
 i6 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = HEAP32[i10 + 8 >> 2] | 0;
 i8 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i15 + 4 >> 2] = i6;
 HEAP32[i15 + 8 >> 2] = i7;
 HEAP32[i15 + 12 >> 2] = i8;
 HEAP32[i15 + 16 >> 2] = i9;
 HEAP32[i15 + 20 >> 2] = i11;
 HEAP32[i15 + 24 >> 2] = i12;
 i12 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_iiiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 356 >> 2] | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i13 | 0, i1 | 0) | 0;
 if (!i2) {
  STACKTOP = i17;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i17;
 return i5 | 0;
}

function __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags(i2, i16, i1) {
 i2 = i2 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 i14 = i2 + 16 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i14, i12, 4); else {
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i14 >> 2] = i3;
 }
 i6 = i16 + 4 | 0;
 __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i16, HEAP32[i6 >> 2] | 0);
 i7 = i16 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i16 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 if ((HEAP32[i12 >> 2] | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i8 = i6;
 i9 = i16 + 4 | 0;
 i5 = 0;
 do {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i14, i13, 4); else {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 >> 2] = i2;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  do if (!i1) {
   HEAP32[i11 >> 2] = i6;
   i4 = i8;
   i3 = i6;
  } else {
   i4 = HEAP32[i13 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i4 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 14;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i4 >>> 0) {
      i2 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 18;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 14) {
    HEAP32[i11 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 18) {
    HEAP32[i11 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 19) {
    HEAP32[i11 >> 2] = i1;
    i4 = i1;
    i3 = i11;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(20) | 0;
   HEAP32[i1 + 16 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i16 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i1);
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i12 >> 2] | 0));
 STACKTOP = i15;
 return;
}

function __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i10, i9, i11, i12) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = HEAP32[i10 + 24 >> 2] | 0;
 if (!i2) return;
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i3 = 22;
   break;
  }
 }
 if ((i3 | 0) == 22) return;
 if ((i9 | 0) != 3) {
  i6 = i10 + 88 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i7 = i10 + 84 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i13 = i3 - i2 >> 2;
  i5 = i10 + 96 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i8 = i10 + 100 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((((i13 | 0) == 0 ? 0 : (i13 * 341 | 0) + -1 | 0) | 0) == (i1 + i4 | 0)) {
   __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv(i10 + 80 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i1 = i1 + i4 | 0;
  if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (((i1 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i1 + 4 >> 2] = i12;
  HEAP32[i1 + 8 >> 2] = i9;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 }
 i6 = i10 + 60 | 0;
 i7 = i10 + 72 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 L20 : do if (i8 | 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) == 3) if ((HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0) == (i11 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i8 >>> 0) break L20;
  }
  return;
 } while (0);
 HEAP8[i11 + 144 >> 0] = 1;
 i2 = i8 + 1 | 0;
 i3 = i10 + 76 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 * 12 | 0, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i13;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i2;
 i13 = HEAP32[i6 >> 2] | 0;
 HEAP32[i13 + (i8 * 12 | 0) >> 2] = i11;
 HEAP32[i13 + (i8 * 12 | 0) + 4 >> 2] = i12;
 HEAP32[i13 + (i8 * 12 | 0) + 8 >> 2] = 3;
 return;
}

function __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i17, i12, i13, i1, i14, i15) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0;
 i16 = i17 + 88 | 0;
 i10 = HEAP32[i16 >> 2] & ~i1 | i13;
 HEAP32[i17 + 92 >> 2] = i12;
 HEAP32[i16 >> 2] = 0;
 i11 = i17 + 80 | 0;
 HEAP32[i11 >> 2] = 0;
 i9 = 0;
 i2 = 0;
 do {
  i8 = i17 + 32 + (i9 * 12 | 0) | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  i1 = HEAP32[i14 + (i9 << 2) >> 2] & i10;
  HEAP32[i8 >> 2] = i1;
  if (i1) {
   HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | i1;
   i3 = HEAP32[i8 >> 2] | 0;
   if (!i3) i1 = i17 + 32 + (i9 * 12 | 0) + 10 | 0; else {
    i7 = i9 & 255;
    i1 = i17 + 32 + (i9 * 12 | 0) + 10 | 0;
    i5 = 0;
    i6 = 1;
    do {
     if (i3 & i6) {
      HEAP8[i17 + (i5 << 2) >> 0] = i7;
      i3 = HEAP8[i1 >> 0] | 0;
      HEAP8[i17 + (i5 << 2) + 1 >> 0] = i3;
      if (!(i6 & i13)) i4 = i17 + (i5 << 2) + 2 | 0; else {
       i4 = i17 + (i5 << 2) + 2 | 0;
       HEAP8[i4 >> 0] = HEAP8[i15 + (i5 << 1) >> 0] | 0;
       HEAP8[i17 + (i5 << 2) + 3 >> 0] = HEAP8[i15 + (i5 << 1) + 1 >> 0] | 0;
       i3 = HEAP8[i1 >> 0] | 0;
      }
      i4 = HEAP16[i4 >> 1] | 0;
      HEAP8[i1 >> 0] = (i3 & 255) + (Math_imul((i4 & 65535) >>> 8 & 65535, HEAPU8[(i4 & 255) + (gb + 430676) >> 0] | 0) | 0);
      i3 = HEAP32[i8 >> 2] | 0;
     }
     i5 = i5 + 1 | 0;
     i6 = i6 << 1;
    } while ((i5 | 0) < 8 & i6 >>> 0 <= i3 >>> 0);
   }
   i2 = i2 + 15 & -16;
   HEAP32[i17 + 32 + (i9 * 12 | 0) + 4 >> 2] = i2;
   i8 = HEAPU8[i1 >> 0] | 0;
   i2 = (Math_imul(i8, i12) | 0) + i2 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i8;
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != 4);
 i1 = HEAP32[i16 >> 2] | 0;
 if (!(i1 & 1)) HEAP32[i17 >> 2] = 0;
 if (!(i1 & 2)) HEAP32[i17 + 4 >> 2] = 0;
 if (!(i1 & 4)) HEAP32[i17 + 8 >> 2] = 0;
 if (!(i1 & 8)) HEAP32[i17 + 12 >> 2] = 0;
 if (!(i1 & 16)) HEAP32[i17 + 16 >> 2] = 0;
 if (!(i1 & 32)) HEAP32[i17 + 20 >> 2] = 0;
 if (!(i1 & 64)) HEAP32[i17 + 24 >> 2] = 0;
 if (i1 & 128 | 0) {
  i16 = i17 + 96 | 0;
  HEAP32[i16 >> 2] = i2;
  i16 = __Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo(i17) | 0;
  i17 = i17 + 100 | 0;
  i16 = i16 & 1;
  HEAP8[i17 >> 0] = i16;
  return;
 }
 HEAP32[i17 + 28 >> 2] = 0;
 i16 = i17 + 96 | 0;
 HEAP32[i16 >> 2] = i2;
 i16 = __Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo(i17) | 0;
 i17 = i17 + 100 | 0;
 i16 = i16 & 1;
 HEAP8[i17 >> 0] = i16;
 return;
}

function __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i9, i11, i13, i14) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 4 | 0;
 i12 = i15;
 i8 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i9, 22, 0) | 0;
 i4 = HEAP32[i8 + 20 >> 2] | 0;
 i8 = (HEAP32[i8 + 24 >> 2] | 0) - i4 | 0;
 i3 = (i8 | 0) / 20 | 0;
 L1 : do if (i8 | 0) {
  i5 = HEAP32[i11 >> 2] | 0;
  i8 = 0;
  L3 : while (1) {
   i7 = HEAP32[i4 + (i8 * 20 | 0) + 8 >> 2] | 0;
   i6 = (HEAP32[i4 + (i8 * 20 | 0) + 12 >> 2] | 0) - i7 | 0;
   i2 = (i6 | 0) / 24 | 0;
   if (i6 | 0) {
    i6 = 0;
    while (1) {
     if ((HEAP32[i7 + (i6 * 24 | 0) >> 2] | 0) == (i5 | 0)) break L3;
     i1 = i6 + 1 | 0;
     if (i1 >>> 0 < i2 >>> 0) i6 = i1; else break;
    }
   }
   i1 = i8 + 1 | 0;
   if (i1 >>> 0 < i3 >>> 0) i8 = i1; else break L1;
  }
  i4 = HEAP32[i7 + (i6 * 24 | 0) + 8 >> 2] | 0;
  i1 = HEAP32[i7 + (i6 * 24 | 0) + 12 >> 2] | 0;
  i2 = HEAP32[i7 + (i6 * 24 | 0) + 20 >> 2] | 0;
  i3 = (i1 | 0) > 0;
  if ((HEAP32[i7 + (i6 * 24 | 0) + 16 >> 2] | 0) > 1) i1 = Math_imul(i2 << 4, i3 ? i1 : 1) | 0; else i1 = i3 ? i1 << 4 : i2 << 2;
  i12 = i9 + 60 | 0;
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1 << i8;
  _memcpy((HEAP32[i9 + 52 >> 2] | 0) + (HEAP32[i9 + 64 + (i8 << 2) >> 2] | 0) + i4 | 0, i14 | 0, ((i1 | 0) < (i13 | 0) ? i1 : i13) | 0) | 0;
  STACKTOP = i15;
  return 1;
 } while (0);
 i6 = i9 + 48 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i15;
  return 1;
 }
 i4 = i9 + 44 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[i4 >> 2] | 0;
  i9 = (HEAP32[i2 + (i3 * 976 | 0) + 968 >> 2] | 0) - (HEAP32[i2 + (i3 * 976 | 0) + 964 >> 2] | 0) | 0;
  i5 = (i9 | 0) / 24 | 0;
  L22 : do if (i9 | 0) {
   i1 = 0;
   while (1) {
    if ((HEAP32[(HEAP32[i2 + (i3 * 976 | 0) + 964 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0) == (HEAP32[i11 >> 2] | 0)) {
     i8 = __Z12GetGfxDevicev() | 0;
     i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 812 >> 2] | 0;
     i9 = HEAP32[i4 >> 2] | 0;
     HEAP32[i12 >> 2] = HEAP32[i9 + (i3 * 976 | 0) >> 2];
     i9 = (HEAP32[i9 + (i3 * 976 | 0) + 964 >> 2] | 0) + (i1 * 24 | 0) | 0;
     HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
     mftCall_viiiii(i7 | 0, i8 | 0, i10 | 0, i9 | 0, i13 | 0, i14 | 0);
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break L22;
    i2 = HEAP32[i4 >> 2] | 0;
   }
  } while (0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 STACKTOP = i15;
 return 1;
}

function __ZL16MouseMoveHandleriPK20EmscriptenMouseEventPv(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i10 = __Z15GetInputManagerv() | 0;
 i7 = __Z15GetInputManagerv() | 0;
 i9 = i4 + 44 | 0;
 f13 = Math_fround(HEAP32[i9 >> 2] | 0);
 i8 = i4 + 48 | 0;
 f12 = Math_fround(0 - (HEAP32[i8 >> 2] | 0) | 0);
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i7 + 100 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i7 + 104 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i7 + 108 >> 2]) + Math_fround(0.0));
 f6 = Math_fround(Math_fround(HEAPF32[i7 + 112 >> 2]) + Math_fround(0.0));
 HEAPF32[i10 + 100 >> 2] = f13;
 HEAPF32[i10 + 104 >> 2] = f12;
 HEAPF32[i10 + 108 >> 2] = f5;
 HEAPF32[i10 + 112 >> 2] = f6;
 i7 = i4 + 60 | 0;
 f6 = Math_fround(HEAP32[i7 >> 2] | 0);
 i11 = __Z16GetScreenManagerv() | 0;
 i11 = (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i11 | 0) | 0) + -1 | 0;
 i1 = i4 + 64 | 0;
 f5 = Math_fround(i11 - (HEAP32[i1 >> 2] | 0) | 0);
 HEAPF32[i10 + 116 >> 2] = f6;
 HEAPF32[i10 + 120 >> 2] = f5;
 HEAP32[i2 + 44 >> 2] = 0;
 __ZN10InputEvent4InitEi(i2, 0);
 i10 = __Z15GetInputManagerv() | 0;
 HEAP32[i2 >> 2] = (HEAP32[(HEAP32[i10 + 48 >> 2] | 0) + 40 >> 2] | HEAP32[(HEAP32[i10 + 68 >> 2] | 0) + 40 >> 2]) >>> 3 & 1 | 2;
 f5 = Math_fround(HEAP32[i9 >> 2] | 0);
 f6 = Math_fround(HEAP32[i8 >> 2] | 0);
 HEAPF32[i2 + 12 >> 2] = f5;
 HEAPF32[i2 + 16 >> 2] = f6;
 f6 = Math_fround(HEAP32[i7 >> 2] | 0);
 f5 = Math_fround(HEAP32[i1 >> 2] | 0);
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f5;
 switch (HEAP16[i4 + 40 >> 1] | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 1:
  {
   i1 = 2;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 3;
 }
 HEAP32[i2 + 20 >> 2] = i1;
 if (HEAP32[i4 + 24 >> 2] | 0) {
  i11 = i2 + 24 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 2;
 }
 if (HEAP32[i4 + 28 >> 2] | 0) {
  i11 = i2 + 24 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1;
 }
 if (HEAP32[i4 + 32 >> 2] | 0) {
  i11 = i2 + 24 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 4;
 }
 if (!(HEAP32[i4 + 36 >> 2] | 0)) {
  i11 = __Z18GetGUIEventManagerv() | 0;
  __ZN15GUIEventManager10QueueEventERK10InputEvent(i11, i2);
  __ZN10InputEventD2Ev(i2);
  STACKTOP = i3;
  return 1;
 }
 i11 = i2 + 24 | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 8;
 i11 = __Z18GetGUIEventManagerv() | 0;
 __ZN15GUIEventManager10QueueEventERK10InputEvent(i11, i2);
 __ZN10InputEventD2Ev(i2);
 STACKTOP = i3;
 return 1;
}

function __ZNK7Terrain12SampleHeightE8Vector3f(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 4 | 0;
 i2 = i9;
 i4 = i6 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i2);
    i2 = HEAP32[i8 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f11 = Math_fround(HEAPF32[i8 >> 2]);
  f11 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f11);
  HEAPF32[i7 >> 2] = f11;
  f13 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  i10 = i7 + 4 | 0;
  HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f13);
  f13 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  i8 = i7 + 8 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f13);
  HEAPF32[i8 >> 2] = f13;
  i10 = i1 + 248 | 0;
  f12 = Math_fround(HEAPF32[i10 + 88 >> 2]);
  f12 = Math_fround(f11 / Math_fround(f12 * Math_fround((HEAP32[i10 + 72 >> 2] | 0) + -1 | 0)));
  HEAPF32[i7 >> 2] = f12;
  f11 = Math_fround(HEAPF32[i10 + 96 >> 2]);
  f11 = Math_fround(f13 / Math_fround(f11 * Math_fround((HEAP32[i10 + 76 >> 2] | 0) + -1 | 0)));
  HEAPF32[i8 >> 2] = f11;
  f11 = Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i10, f12, f11));
  STACKTOP = i9;
  return Math_fround(f11);
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 936895 | 0, 0, gb + 930687 | 0, 682, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
 f13 = Math_fround(0.0);
 STACKTOP = i9;
 return Math_fround(f13);
}

function __Z21HandleGUITexturePropsP19ShaderPropertySheetP7Texture(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 24 | 0;
 i15 = i16 + 16 | 0;
 i8 = i16 + 8 | 0;
 i9 = i16;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i12, gb + 1114544 | 0, i13);
 i10 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 136 >> 2] | 0, i13 | 0) | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 140 >> 2] | 0, i13 | 0) | 0;
 i2 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i12 + 24 >> 2] | 0;
 if ((i2 | 0) >= (i4 | 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = HEAP32[i12 + 32 >> 2] | 0;
 i6 = HEAP32[gb + 1114544 >> 2] | 0;
 while (1) {
  if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i6 | 0)) break;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i4 | 0)) {
   i7 = 17;
   break;
  }
 }
 if ((i7 | 0) == 17) {
  STACKTOP = i16;
  return;
 }
 if ((i2 | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 if (!(i10 + -1 & i10)) i2 = (i11 + -1 & i11 | 0) == 0; else i2 = 0;
 if (!(i2 | (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 148 >> 2] | 0, i13 | 0) | 0) != 2)) if (!(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 128 >> 2] | 0, i13 | 0) | 0)) if ((HEAP32[i13 + 56 >> 2] | 0) != 6) {
  i4 = __ZN7Texture21GetMasterTextureLimitEv() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 112 >> 2] | 0, i13 | 0) | 0;
  i4 = i2 ? i4 : 0;
  i2 = (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 100 >> 2] | 0, i13 | 0) | 0) >> i4;
  i5 = (mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 104 >> 2] | 0, i13 | 0) | 0) >> i4;
  if ((i2 | 0) > 0) f3 = Math_fround(Math_fround(i10 >> i4 | 0) / Math_fround(i2 | 0)); else f3 = Math_fround(1.0);
  if ((i5 | 0) > 0) f1 = Math_fround(Math_fround(i11 >> i4 | 0) / Math_fround(i5 | 0)); else f1 = Math_fround(1.0);
  HEAPF32[i14 >> 2] = f3;
  HEAPF32[i14 + 4 >> 2] = f1;
  HEAP32[i15 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i15 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  __ZN19ShaderPropertySheet18SetTextureUnscaledERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i12, gb + 1114544 | 0, i13, i14, i15);
  STACKTOP = i16;
  return;
 }
 HEAP32[i8 >> 2] = HEAP32[gb + 62472 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_(i12, gb + 1114544 | 0, i8, i9);
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEEC2INS_11__wrap_iterIPS7_EEEET_SE_RKS8_PNS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeE(i6, i3, i4, i2, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 HEAP32[i6 >> 2] = 0;
 i11 = i6 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i3 = i9 - i1 | 0;
 i4 = i3 >> 4;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 if ((i3 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i2 + (i4 << 4);
 i3 = i1;
 if ((i3 | 0) == (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i10 + 4 | 0;
 while (1) {
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i5 = i2 + 12 | 0;
  HEAP32[i5 >> 2] = i4;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i6 = HEAP32[i3 >> 2] | 0;
   i7 = HEAP32[i3 + 4 >> 2] | 0;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i3 = HEAP32[i5 >> 2] | 0;
    i13 = 11;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i7;
    if (i7) i13 = 13;
   } else {
    i3 = i4;
    i13 = 11;
   }
   if ((i13 | 0) == 11) {
    i4 = i7 + 16 & -16;
    HEAP32[i10 >> 2] = 1;
    HEAP32[i8 >> 2] = i3;
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i5;
    HEAP32[i2 + 8 >> 2] = i4 | -2147483648;
    HEAP32[i2 + 4 >> 2] = i7;
    i2 = i5;
    i13 = 13;
   }
   if ((i13 | 0) == 13) {
    i13 = 0;
    _memcpy(i2 | 0, i6 | 0, i7 | 0) | 0;
   }
   HEAP8[i2 + i7 >> 0] = 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i1 = i3;
  }
  i3 = i1 + 16 | 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
  HEAP32[i11 >> 2] = i2;
  if ((i3 | 0) == (i9 | 0)) break; else i1 = i3;
 }
 STACKTOP = i12;
 return;
}

function __ZN15NavMeshSettings15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(140, gb + 63704 | 0, 16, gb + 842172 | 0, 1384) | 0;
 __ZN14NavMeshManagerC2Ev(i2);
 HEAP32[gb + 1459032 >> 2] = i2;
 HEAP32[gb + 1115296 + 192 >> 2] = fb + 264;
 HEAP32[gb + 1115296 + 212 >> 2] = fb + 265;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 2312 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = fb + 3770;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 4628 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 3860 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) >> 2] = fb + 905;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 6172 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 5404 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 5404 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 5404 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 3771;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 5404 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 5404 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 5404 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 3771;
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1033949 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1033949 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZL40PrepareRenderNodesOnMainThreadDeprecatedR35RenderNodeQueuePrepareThreadContext(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i24 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i24;
 HEAP32[i15 >> 2] = 0;
 i20 = i15 + 4 | 0;
 HEAPF32[i20 >> 2] = Math_fround(0.0);
 i21 = i15 + 8 | 0;
 HEAP32[i21 >> 2] = -1;
 HEAP32[i15 + 12 >> 2] = i2 + 16;
 i23 = i2 + 4 | 0;
 i1 = HEAP32[i23 >> 2] | 0;
 i22 = i2 + 12 | 0;
 i7 = HEAP32[i22 >> 2] | 0;
 i16 = i2 + 32 | 0;
 i6 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i7 << 2) >> 2] | 0;
 i17 = i2 + 48 | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i4 = HEAP32[i5 + (i6 * 24 | 0) >> 2] | 0;
 i18 = i4 + 236 | 0;
 i18 = HEAPU16[i18 >> 1] | 0 | (HEAPU8[i18 + 2 >> 0] | 0) << 16;
 i19 = i2 + 36 | 0;
 i8 = HEAP32[i19 >> 2] | 0;
 if (i7 >>> 0 >= i8 >>> 0) {
  i22 = i1;
  HEAP32[i23 >> 2] = i22;
  STACKTOP = i24;
  return;
 }
 i13 = i2 + 76 | 0;
 f14 = Math_fround(HEAPF32[gb + 1161204 >> 2]);
 i9 = i18;
 i12 = i4;
 i11 = i5;
 i10 = i6;
 i5 = i7;
 i4 = i8;
 while (1) {
  i2 = HEAP32[i13 >> 2] | 0;
  if ((i9 & 192 | 0) == 0 ? (HEAP32[i2 + 1504 >> 2] & 4 | 0) != 0 : 0) i2 = i5; else {
   HEAP32[i15 >> 2] = i12;
   i4 = HEAP32[i2 + 16 >> 2] | 0;
   i9 = HEAP16[i11 + (i10 * 24 | 0) + 14 >> 1] | 0;
   i5 = i9 & 65535;
   if (!(i9 << 16 >> 16)) f3 = f14; else {
    i6 = HEAP32[i11 + (i10 * 24 | 0) + 16 >> 2] | 0;
    if (!i6) f3 = f14; else {
     i2 = HEAPU16[i11 + (i10 * 24 | 0) + 12 >> 1] | 0;
     f3 = Math_fround(__ZN15LODGroupManager16CalculateLODFadeEjhf(i6, HEAP8[(HEAP32[i4 + (i2 * 12 | 0) >> 2] | 0) + i5 >> 0] | 0, Math_fround(HEAPF32[(HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2] | 0) + (i5 << 2) >> 2])));
     i2 = HEAP32[i13 >> 2] | 0;
    }
   }
   HEAPF32[i20 >> 2] = f3;
   HEAP32[i21 >> 2] = i1;
   i2 = mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, HEAP32[i2 >> 2] | 0, i15 | 0) | 0;
   i1 = (i2 | 0) == -1 ? i1 : i2 + 1 | 0;
   i2 = HEAP32[i22 >> 2] | 0;
   i4 = HEAP32[i19 >> 2] | 0;
  }
  i5 = i2 + 1 | 0;
  HEAP32[i22 >> 2] = i5;
  if (i5 >>> 0 >= i4 >>> 0) {
   i2 = 10;
   break;
  }
  i10 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i11 = HEAP32[i17 >> 2] | 0;
  i12 = HEAP32[i11 + (i10 * 24 | 0) >> 2] | 0;
  i9 = i12 + 236 | 0;
  i9 = HEAPU16[i9 >> 1] | 0 | (HEAPU8[i9 + 2 >> 0] | 0) << 16;
  if ((i9 ^ i18) & 63 | 0) {
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) {
  HEAP32[i23 >> 2] = i1;
  STACKTOP = i24;
  return;
 }
}

function __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i4, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 4 | 0, i5);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 12 | 0, i5);
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 20 | 0, i5);
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 28 | 0, i5);
 i1 = i4 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 36 | 0, i5);
 i1 = i4 + 40 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 44 | 0, i5);
 i1 = i4 + 48 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  i7 = i4 + 52 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i7 = i4 + 52 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 }
}

function __ZN6Camera13ClearNoSkyboxEb(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 32 | 0;
 i8 = i12 + 16 | 0;
 i9 = i12;
 i10 = (__ZNK6Camera17GetSkyboxMaterialEv(i6) | 0) != 0;
 i11 = i6 + 844 | 0;
 do if (i10 & (HEAP32[i11 >> 2] | 0) == 1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
 } else {
  i2 = i6 + 848 | 0;
  if ((__Z19GetActiveColorSpacev() | 0) != 1) {
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   break;
  }
  f1 = Math_fround(HEAPF32[i2 >> 2]);
  do if (!(f1 <= Math_fround(.0404499993))) {
   if (f1 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f1 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f1, 2.20000005));
  } else f4 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
  f1 = Math_fround(HEAPF32[i6 + 852 >> 2]);
  do if (!(f1 <= Math_fround(.0404499993))) {
   if (f1 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f1 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f1, 2.20000005));
  } else f3 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
  f1 = Math_fround(HEAPF32[i6 + 856 >> 2]);
  do if (!(f1 <= Math_fround(.0404499993))) {
   if (f1 < Math_fround(1.0)) {
    f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
  } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
  i2 = HEAP32[i6 + 860 >> 2] | 0;
  HEAPF32[i8 >> 2] = f4;
  HEAPF32[i8 + 4 >> 2] = f3;
  HEAPF32[i8 + 8 >> 2] = f1;
  HEAP32[i8 + 12 >> 2] = i2;
 } while (0);
 i11 = HEAP32[i11 >> 2] | 0;
 __ZNK6Camera18GetRenderRectangleEv(i9, i6);
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 __ZL16ClearFramebufferN6Camera9ClearModeE5RectTIfERK10ColorRGBAfbb(i11, i5, i8, i10, i7);
 STACKTOP = i12;
 return;
}

function __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i2 = i5 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 738066 | 0, gb + 738082 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 40 | 0;
 i4 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 946522 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 734913 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 800705 | 0, i4, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN20ComputeShaderVariant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i5 = i9 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469322 | 0, i4, i3, 0);
 i6 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469337 | 0, i4, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469349 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 76 >> 2] = 0;
 HEAP32[i5 + 80 >> 2] = 0;
 i4 = i5 + 68 | 0;
 i8 = i5 + 4 | 0;
 i10 = i8 + 64 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i10 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i11 = i3;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 88 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469487 | 0, i5, 0);
 __ZN19ComputeShaderKernel8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN19ComputeShaderKernelD2Ev(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 469357 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469373 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i9;
 return;
}

function __ZN13RenderTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 80 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 88 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 117 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 118 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 32 | 0;
  __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 32 | 0;
  __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZN12_GLOBAL__N_1L20GetIndexFromBoneNameENSt3__211__wrap_iterIPKN13AvatarBuilder14NamedTransformEEES6_RK8UnityStr(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i8 = i10 + 16 | 0;
 i9 = i10;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i11 = i3 << 24 >> 24 < 0;
 i4 = i11 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i11 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i9 + 11 >> 0] = i3;
  if (!i3) i2 = i9; else {
   i2 = i9;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i11 = i3 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i3;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i2 + i3 >> 0] = 0;
 i5 = HEAP8[i9 + 11 >> 0] | 0;
 L10 : do if ((i1 | 0) != (i6 | 0)) {
  i11 = i5 << 24 >> 24 < 0;
  i4 = i11 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
  if (!i11) while (1) {
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i11 << 24 >> 24 < 0;
   if (((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255) | 0) == (i4 | 0)) if (!(_strncmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, i9, i4) | 0)) break L10;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break L10;
   }
  }
  i3 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i11 << 24 >> 24 < 0;
   if (((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255) | 0) == (i4 | 0)) if (!(_strncmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, i3, i4) | 0)) break L10;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break;
   }
  }
 } while (0);
 i2 = i1;
 if (i5 << 24 >> 24 >= 0) {
  i9 = (i1 | 0) != (i6 | 0);
  i11 = i2 - i7 | 0;
  i11 = (i11 | 0) / 36 | 0;
  i11 = i9 ? i11 : -1;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 i9 = (i1 | 0) != (i6 | 0);
 i11 = i2 - i7 | 0;
 i11 = (i11 | 0) / 36 | 0;
 i11 = i9 ? i11 : -1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN6Sprite8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 32 | 0, gb + 410471 | 0, 0);
 i1 = i6 + 48 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i7, i6 + 56 | 0, gb + 1034662 | 0, 0);
 i1 = i6 + 140 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 76 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 144 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 148 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i8 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i8 = i6 + 80 | 0;
  __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN24RingBufferMemoryFileDataC2E10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 8 | 0;
 i12 = i11;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 71708 + 8;
 i9 = i1;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 32768;
 HEAP32[i2 + 24 >> 2] = 4;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 i3 = i2 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 i3 = i2 + 52 | 0;
 i4 = i12;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i4 + 4 >> 2] = i9;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i2 + 56 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i1 = i13;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i2 + 76 | 0;
 i8 = i12;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i2 + 88 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i2 + 92 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i2 + 80 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP8[i2 + 97 >> 0] = 1;
 HEAP8[i2 + 98 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if ((i1 & 2147483644) >>> 0 < 4) if ((i1 | 0) > -1) {
  HEAP32[i5 >> 2] = 4;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, 16, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i5 >> 2] = 4;
  HEAP32[i3 >> 2] = i13;
  break;
 } while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 & 2147483644) >>> 0 >= 4) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = 4;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 16, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i11;
  return;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = 4;
  HEAP32[i7 >> 2] = i13;
  STACKTOP = i11;
  return;
 }
}

function __ZN21LightProbeProxyVolume17MainThreadCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 i5 = i4 + 156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 9;
   }
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 __Z19DestroySingleObjectP6Object(i1);
 HEAP32[i5 >> 2] = 0;
 i4 = i4 + 160 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  __Z19DestroySingleObjectP6Object(i10);
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 19;
  }
 }
 if ((i8 | 0) == 18) i8 = 19;
 if ((i8 | 0) == 19) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i10 = i1;
 __Z19DestroySingleObjectP6Object(i10);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN15PolynomialCurve15DoubleIntegrateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0;
 HEAPF32[i6 + 128 >> 2] = Math_fround(0.0);
 i7 = i6 + 224 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i2 = 1;
  f3 = Math_fround(0.0);
  i5 = i6 + 192 | 0;
  f4 = Math_fround(0.0);
  do {
   f10 = f3;
   f3 = Math_fround(HEAPF32[i5 >> 2]);
   i1 = i2 + -1 | 0;
   f9 = Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]);
   f8 = Math_fround(HEAPF32[i6 + (i1 << 4) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i6 + (i1 << 4) + 8 >> 2]);
   f10 = Math_fround(f3 - f10);
   f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) + 12 >> 2]) + Math_fround(f10 * Math_fround(Math_fround(f11 * Math_fround(.5)) + Math_fround(f10 * Math_fround(Math_fround(f10 * Math_fround(f9 * Math_fround(.25))) + Math_fround(f8 * Math_fround(.333333343)))))))));
   HEAPF32[i6 + 128 + (i2 << 2) >> 2] = f4;
   i5 = i6 + 192 + (i2 << 2) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 if ((i1 | 0) > 0) i1 = 0; else return;
 do {
  i13 = i6 + (i1 << 4) | 0;
  f8 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) * Math_fround(.0500000007));
  i12 = i6 + (i1 << 4) + 4 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(.0833333358));
  i5 = i6 + (i1 << 4) + 8 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.166666672));
  i2 = i6 + (i1 << 4) + 12 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.5));
  HEAPF32[i13 >> 2] = f8;
  HEAPF32[i12 >> 2] = f9;
  HEAPF32[i5 >> 2] = f10;
  HEAPF32[i2 >> 2] = f11;
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) < (i2 | 0));
 if ((i2 | 0) > 0) {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i1 = 0;
 } else return;
 do {
  HEAPF32[i6 + 160 + (i1 << 2) >> 2] = f4;
  f10 = f3;
  f3 = Math_fround(HEAPF32[i6 + 192 + (i1 << 2) >> 2]);
  f10 = Math_fround(f3 - f10);
  i13 = f10 < Math_fround(0.0);
  f10 = i13 ? Math_fround(0.0) : f10;
  f11 = Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]) * f10);
  f11 = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) + 4 >> 2]) + f11));
  f11 = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) + 8 >> 2]) + f11));
  f11 = Math_fround(f10 * Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) + 12 >> 2]) + f11)));
  f4 = Math_fround(f4 + Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i6 + 128 + (i1 << 2) >> 2])) + f11));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 108 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 405527 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 108 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 405527 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 108 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 5) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402635 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN31EnlightenSystemAtlasInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402635 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN31EnlightenSystemAtlasInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN19MemoryProfilerStats16UnregisterObjectEP6Object(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i1 + 8 | 0;
 i4 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i5 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
 switch (i4 | 0) {
 case 28:
  {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   i2 = i3 + 12 | 0;
   i7 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i7 << 2) >> 2];
   if (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
   break;
  }
 case 43:
  {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   i2 = i3 + 20 | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = i3 + 32 | 0;
   i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i8;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i8 << 2) >> 2];
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
   break;
  }
 case 21:
  {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   i2 = i3 + 40 | 0;
   i7 = HEAP32[i2 >> 2] | 0;
   i8 = i3 + 52 | 0;
   i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
   if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
   break;
  }
 case 74:
  {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   i2 = i3 + 60 | 0;
   i7 = HEAP32[i2 >> 2] | 0;
   i8 = i3 + 72 | 0;
   i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
   if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
   break;
  }
 case 83:
  {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   i2 = i3 + 80 | 0;
   i7 = HEAP32[i2 >> 2] | 0;
   i8 = i3 + 92 | 0;
   i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
   if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
   break;
  }
 default:
  {}
 }
 i8 = (HEAP32[i3 + 120 >> 2] | 0) + (i4 << 2) | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (HEAP32[i5 >> 2] & 1048576 | 0) {
  i8 = i3 + 100 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  return;
 }
 i8 = i3 + 104 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if ((i4 | 0) != 1) return;
 i8 = i3 + 108 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 return;
}

function __ZL23CalculateProbeInfluenceRK4AABBS1_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 48 | 0;
 i9 = i7 + 24 | 0;
 i8 = i7;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f16 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f18 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f15 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i1 = i6 + 12 | 0;
 HEAPF32[i1 >> 2] = f16;
 i2 = i6 + 16 | 0;
 HEAPF32[i2 >> 2] = f18;
 i3 = i6 + 20 | 0;
 HEAPF32[i3 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f16 = Math_fround(f15 - f18);
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f10 = Math_fround(f17 - f12);
 f11 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f14 = Math_fround(f11 - f13);
 HEAPF32[i9 >> 2] = f16;
 HEAPF32[i9 + 4 >> 2] = f10;
 HEAPF32[i9 + 8 >> 2] = f14;
 f12 = Math_fround(f17 + f12);
 f13 = Math_fround(f11 + f13);
 HEAPF32[i9 + 12 >> 2] = Math_fround(f15 + f18);
 HEAPF32[i9 + 16 >> 2] = f12;
 HEAPF32[i9 + 20 >> 2] = f13;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f18 = Math_fround(f13 - f12);
 f15 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(f15 - f11);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(f14 - f10);
 HEAPF32[i8 >> 2] = f18;
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 f11 = Math_fround(f15 + f11);
 f10 = Math_fround(f14 + f10);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f13 + f12);
 HEAPF32[i8 + 16 >> 2] = f11;
 HEAPF32[i8 + 20 >> 2] = f10;
 if (!(__Z20IntersectionAABBAABBRK10MinMaxAABBS1_PS_(i9, i8, i6) | 0)) {
  f18 = Math_fround(-1.0);
  STACKTOP = i7;
  return Math_fround(f18);
 }
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i6 >> 2]));
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f18 = Math_fround(f18 - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f18) * Math_fround(f17 - Math_fround(HEAPF32[i6 + 8 >> 2])));
 f18 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 f18 = f18 < f17 ? f17 : f18;
 STACKTOP = i7;
 return Math_fround(f18);
}

function __ZN8VRDevice15BeforeRenderingEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i8 = i9;
 if (!(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0) | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i7 + 301 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i5 = __Z12GetGfxDevicev() | 0;
  i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  mftCall_viiifi(i4 | 0, i5 | 0, 7, i6 | 0, 1.0, 0);
  HEAP8[i1 >> 0] = 0;
 }
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = i7 + 320 | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 860 >> 2] | 0, i4 | 0, 0, HEAP32[i5 >> 2] | 0);
 if ((HEAP32[i7 + 156 >> 2] | 0) == 2) {
  i2 = i7 + 324 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
    HEAP32[i8 >> 2] = 0;
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i6);
    i1 = gb + 1469192 | 0;
   } else i1 = 0;
   i4 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 544 >> 2] | 0, i4 | 0, HEAP32[i2 >> 2] | 0);
   HEAP32[i2 >> 2] = 0;
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i6);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i4 = i7 + 204 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 | 0) mftCall_vii(i3 | 0, 2, i2 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i1 = i7 + 303 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  if (HEAP8[i7 + 300 >> 0] | 0) {
   __ZN8VRDevice18ReleaseEyeTexturesEv(i7);
   if (!(__ZN8VRDevice17CreateEyeTexturesEv(i7) | 0)) __ZN8VRDevice21StopRenderingToDeviceEv(i7);
  }
  HEAP8[i1 >> 0] = 0;
 }
 i1 = HEAP32[i7 + 288 >> 2] | 0;
 if (i1 | 0) __ZN19VREyeTextureManager16UpdateFrameCountEj(i1, HEAP32[i5 >> 2] | 0);
 __ZN8VRDevice39UpdateTrackedDevicesAndCameraTransformsEv(i7);
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i6);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 5, 0);
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc5Scene7addBodyEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E(i12, i5, i11, i10) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i11 + 24 >> 2] | 0;
 i1 = i5 + i9 | 0;
 i9 = i5 + (i9 + 4) | 0;
 i2 = HEAP16[i9 >> 1] | 0;
 if (i2 << 16 >> 16 == 1) i3 = 4; else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i2 << 16 >> 16)) i7 = i1; else i3 = 4;
 }
 if ((i3 | 0) == 4) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = (HEAP32[i11 + 28 >> 2] | 0) + 144 | 0;
  i2 = i4;
  i6 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
  i7 = getTempRet0() | 0;
  i2 = _i64Add(i2 | 0, 0, -1, -1) | 0;
  i3 = _i64Add(i2 | 0, getTempRet0() | 0, i3 | 0, 0) | 0;
  i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
  i2 = getTempRet0() | 0;
  i7 = _i64Subtract(1, 0, i6 | 0, i7 | 0) | 0;
  i2 = _i64Add(i7 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  while (1) {
   i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i7 = i1;
    break;
   } else i4 = i4 + 64 | 0;
  }
 }
 __ZN5physx2Sc7BodySimC2ERNS0_5SceneERNS0_8BodyCoreE(i8, i12, i5 + (HEAP32[i11 + 20 >> 2] | 0) | 0);
 i6 = HEAP32[i12 + 1220 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 i3 = i1;
 i6 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 191, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i6 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyERPNS0_8ShapeSimEPNS_9PxBounds3E(i12, i7, HEAPU16[i9 >> 1] | 0, HEAP32[i11 + 28 >> 2] | 0, i8, i8 + 64 | 0, i11 + 8 | 0, i10);
 i12 = i12 + 1420 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 return;
}

function __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i5 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 12 | 0, i5);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 28 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 29 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 30 >> 0] = i1;
 i1 = i6 + 31 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN4FMOD7Channel12setFrequencyEf(i2, f10) {
 i2 = i2 | 0;
 f10 = Math_fround(f10);
 var d1 = 0.0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i11 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i11 | 0) if (!(HEAP8[i11 + 16 >> 0] | 0)) if ((HEAP32[i11 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = i11 + 140 | 0;
   f4 = Math_fround(HEAPF32[i3 >> 2]);
   if (!(f4 != f10)) {
    i11 = 0;
    STACKTOP = i12;
    return i11 | 0;
   }
   i5 = i11 + 152 | 0;
   f6 = Math_fround(HEAPF32[i5 >> 2]);
   i2 = i11 + 161 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    d1 = +__Z19GetTimeSinceStartupv() * 44100.0;
    i9 = +Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0;
    f4 = Math_fround(HEAPF32[i3 >> 2]);
    i8 = ~~d1 >>> 0;
    f7 = Math_fround(HEAPF32[i5 >> 2]);
    i2 = (HEAP8[i2 >> 0] | 0) == 0;
   } else {
    i9 = i11 + 120 | 0;
    i8 = HEAP32[i9 >> 2] | 0;
    i9 = HEAP32[i9 + 4 >> 2] | 0;
    f7 = f6;
    i2 = 0;
   }
   i13 = i11 + 104 | 0;
   i14 = i13;
   i14 = _i64Subtract(i8 | 0, i9 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
   f7 = Math_fround(Math_fround(Math_fround(f7 * f4) / Math_fround(44100.0)) * Math_fround(+(i14 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)));
   i14 = +Math_abs(+f7) >= 1.0 ? (+f7 > 0.0 ? ~~+Math_min(+Math_floor(+f7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f7 - +(~~+f7 >>> 0)) / 4294967296.0) >>> 0) : 0;
   HEAPF32[i3 >> 2] = f10;
   HEAPF32[i5 >> 2] = f6;
   f4 = Math_fround(f6 * f10);
   f10 = Math_fround(Math_fround(+(i8 >>> 0) + 4294967296.0 * +(i9 >>> 0)) - Math_fround(Math_fround(Math_fround(44100.0) / f4) * Math_fround(+(~~+f7 >>> 0 >>> 0) + 4294967296.0 * +(i14 >>> 0))));
   i8 = +Math_abs(+f10) >= 1.0 ? (+f10 > 0.0 ? ~~+Math_min(+Math_floor(+f10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f10 - +(~~+f10 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i9 = i13;
   HEAP32[i9 >> 2] = ~~+f10 >>> 0;
   HEAP32[i9 + 4 >> 2] = i8;
   if (i2) d1 = +Math_fround(f4 / Math_fround(44100.0)); else d1 = 1.0e-07;
   _JS_Sound_SetPitch(HEAP32[i11 + 164 >> 2] | 0, +d1);
   i14 = 0;
   STACKTOP = i12;
   return i14 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 857878;
 _printf(gb + 853184 | 0, i5) | 0;
 i14 = 36;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 40 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402814 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN28EnlightenRendererInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402814 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN28EnlightenRendererInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_115StringTableImpl11registerStrEPKcRb(i9, i5, i7) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i11 + 4 | 0;
 HEAP8[i7 >> 0] = 0;
 i6 = i5 | 0 ? i5 : gb + 1576256 | 0;
 if ((HEAP8[i6 >> 0] | 0) <= 0) {
  i10 = gb + 1576256 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i4 = HEAP32[i9 + 40 >> 2] | 0;
 L4 : do if (i4 | 0) {
  i1 = HEAP8[i5 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i5;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i9 + 32 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i9 + 24 >> 2] | 0;
   i3 = i9 + 28 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L4;
   }
   if (i2 | 0) {
    i10 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    STACKTOP = i11;
    return i10 | 0;
   }
  }
 } while (0);
 HEAP8[i7 >> 0] = 1;
 i3 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = _strlen(i6) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 + 1 | 0, gb + 774868 | 0, gb + 774188 | 0, 178) | 0;
 _memcpy(i3 | 0, i6 | 0, i1 | 0) | 0;
 HEAP8[i3 + i1 >> 0] = 0;
 HEAP32[i8 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i9 + 8 | 0, i8, i10) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  i6 = i3;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 4 >> 2] = i6;
 }
 if (!(HEAP8[i7 >> 0] | 0)) {
  i10 = i3;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = i9 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i8 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i9 + 64 | 0, i8, i10) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
 }
 HEAP32[i8 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i9 + 116 | 0, i8, i10) | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i2;
 }
 i10 = i3;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN11SoundHandle8InstanceC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i4 = i7 + 8 | 0;
 i6 = i7;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i3;
 if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
  i1 = gb + 874396 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 874396 + 88 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459916 >> 2] = i1;
  i2 = gb + 1098880 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459916 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i3 + 16 >> 2] = i3;
 HEAP32[i3 + 20 >> 2] = gb + 874396;
 HEAP32[i3 + 24 >> 2] = -1;
 i9 = i3 + 28 | 0;
 HEAP32[i9 >> 2] = i9;
 HEAP32[i3 + 32 >> 2] = i9;
 i9 = i3 + 36 | 0;
 i1 = i3 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i3 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i3 + 96 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i3 + 100 >> 2] = i1;
 HEAP32[i3 + 104 >> 2] = i3;
 HEAP32[i3 + 108 >> 2] = i3;
 HEAP32[i3 + 112 >> 2] = 0;
 HEAP8[i3 + 116 >> 0] = 0;
 i1 = i3 + 120 | 0;
 i9 = gb + 63328 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  i9 = HEAP32[gb + 1459904 >> 2] | 0;
  i9 = i9 + 1 | 0;
  HEAP32[gb + 1459904 >> 2] = i9;
  STACKTOP = i7;
  return;
 } else {
  i9 = __ZnwjRK10MemLabelIdiPKci(20, i6, 16, gb + 854186 | 0, 74) | 0;
  i2 = i6;
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = i4;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN17WeakPtrSharedDataC2E10MemLabelId(i9, i5);
  HEAP32[i9 >> 2] = gb + 170680 + 8;
  HEAP32[i9 + 16 >> 2] = i3;
  HEAP32[gb + 1459920 >> 2] = (HEAP32[gb + 1459920 >> 2] | 0) + 1;
  HEAP32[i1 >> 2] = i9;
  i9 = HEAP32[gb + 1459904 >> 2] | 0;
  i9 = i9 + 1 | 0;
  HEAP32[gb + 1459904 >> 2] = i9;
  STACKTOP = i7;
  return;
 }
}

function __ZN11AudioSource7CleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i7 = i10;
 i8 = i10 + 32 | 0;
 __ZN11AudioSource4StopEb(i6, 1);
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1 + 40 | 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i4 = i1 + 28 | 0;
   i3 = 0;
   do {
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
    do if (i1 | 0) {
     if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) {
      i1 = i1 + 40 | 0;
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break;
      __ZN4FMOD3DSP7releaseEv(i2) | 0;
      HEAP32[i1 >> 2] = 0;
      break;
     }
     if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
      i1 = HEAP32[i1 + 144 >> 2] | 0;
      if (i1 | 0) __ZN17AudioCustomFilter7CleanupEv(i1);
     }
    } while (0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
  }
 }
 HEAP32[i6 + 544 >> 2] = 0;
 i1 = i6 + 540 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD3DSP7releaseEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i6 + 488 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD12ChannelGroup7releaseEv(i1) | 0;
  if (i1 | 0) {
   i5 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i7 >> 2] = gb + 855390;
   HEAP32[i7 + 4 >> 2] = 671;
   HEAP32[i7 + 8 >> 2] = gb + 859858;
   HEAP32[i7 + 12 >> 2] = i5;
   __Z6FormatPKcz(i8, gb + 883334 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i6 + 492 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i1 = __ZN4FMOD12ChannelGroup7releaseEv(i1) | 0;
 if (i1 | 0) {
  i7 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
  HEAP32[i9 >> 2] = gb + 855390;
  HEAP32[i9 + 4 >> 2] = 677;
  HEAP32[i9 + 8 >> 2] = gb + 859880;
  HEAP32[i9 + 12 >> 2] = i7;
  __Z6FormatPKcz(i8, gb + 883334 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK12PhysXRaycast9GetShapesERK4AABBiPN5physx12PxOverlapHitEjb23QueryTriggerInteraction(i1, i2, i8, i11, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 144 | 0;
 i9 = i10 + 84 | 0;
 i7 = i10 + 48 | 0;
 i12 = i10 + 32 | 0;
 i1 = i10;
 i15 = HEAP32[i2 >> 2] | 0;
 i14 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = HEAP32[i2 + 8 >> 2] | 0;
 i17 = HEAP32[i2 + 12 >> 2] | 0;
 i16 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP16[i6 + 16 >> 1] = i4 ? 7 : 5;
 HEAP8[i6 + 18 >> 0] = 0;
 __ZN24CollectBroadphaseTerrainC2EPN5physx12PxOverlapHitEij23QueryTriggerInteraction(i9, i11, i8, i3, i5);
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = -1;
 HEAP8[i7 + 20 >> 0] = 0;
 HEAP32[i7 + 24 >> 2] = i11;
 HEAP32[i7 + 28 >> 2] = 1;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 85608 + 8;
 i5 = HEAP32[gb + 1457404 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 356 >> 2] | 0;
 HEAP32[i12 >> 2] = 3;
 HEAP32[i12 + 4 >> 2] = i17;
 HEAP32[i12 + 8 >> 2] = i16;
 HEAP32[i12 + 12 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = i15;
 HEAP32[i1 + 20 >> 2] = i14;
 HEAP32[i1 + 24 >> 2] = i13;
 mftCall_iiiiiii(i3 | 0, i5 | 0, i12 | 0, i1 | 0, i7 | 0, i6 | 0, i9 | 0) | 0;
 i5 = i9 + 40 | 0;
 i6 = i9 + 20 | 0;
 i3 = HEAP32[i9 + 32 >> 2] | 0;
 i4 = i3 + (HEAP32[i9 + 52 >> 2] | 0) | 0;
 i4 = (i4 | 0) < (i8 | 0) ? i4 : i8;
 i7 = i4 + -1 | 0;
 i3 = (i3 | 0) < (i8 | 0) ? i3 : i8;
 if ((i3 | 0) > 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   i17 = i11 + (i7 - i1 << 4) | 0;
   i16 = i2 + (i1 << 4) | 0;
   HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i17 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
   HEAP32[i17 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
   HEAP32[i17 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
 }
 HEAP32[i9 >> 2] = gb + 114036 + 8;
 if ((HEAP32[i9 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9 + 44 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 if ((HEAP32[i9 + 36 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i4 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i9 + 24 | 0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i10;
 return i4 | 0;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI17AnimationCurveTplIfEEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 88 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Scb12Articulation9syncStateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i5 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 do if (!(i4 & 128)) {
  i1 = i5 + 12 | 0;
  HEAPF32[i5 + 48 >> 2] = Math_fround(__ZNK5physx2Sc16ArticulationCore14getWakeCounterEv(i1));
  i2 = __ZNK5physx2Sc16ArticulationCore10isSleepingEv(i1) | 0;
  if (!(i4 & 768)) i3 = 6; else i3 = 8;
 } else {
  i2 = i5 + 12 | 0;
  if (!(i4 & 768)) {
   __ZN5physx2Sc16ArticulationCore14setWakeCounterEf(i2, Math_fround(HEAPF32[i5 + 48 >> 2]));
   i1 = i2;
   i2 = __ZNK5physx2Sc16ArticulationCore10isSleepingEv(i2) | 0;
   i3 = 6;
   break;
  } else {
   __ZNK5physx2Sc16ArticulationCore10isSleepingEv(i2) | 0;
   i1 = i2;
   i3 = 8;
   break;
  }
 } while (0);
 do if ((i3 | 0) == 6) {
  if ((HEAP32[i7 >> 2] | 0) >>> 0 <= 3221225471) HEAP8[i5 + 52 >> 0] = i2 & 1;
 } else if ((i3 | 0) == 8) if (!(i4 & 256)) {
  __ZN5physx2Sc16ArticulationCore6wakeUpEf(i1, Math_fround(HEAPF32[i5 + 48 >> 2]));
  break;
 } else {
  __ZN5physx2Sc16ArticulationCore10putToSleepEv(i1);
  break;
 } while (0);
 i6 = i5 + 8 | 0;
 if (!(i4 & 16776319)) {
  HEAP32[i6 >> 2] = 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 & -16777216;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) >>> 24 & 15) | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (i3 & 2) {
  __ZN5physx2Sc16ArticulationCore26setExternalDriveIterationsEj(i1, HEAP32[i2 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (i3 & 1) {
  __ZN5physx2Sc16ArticulationCore26setInternalDriveIterationsEj(i1, HEAP32[i2 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (i3 & 4) {
  __ZN5physx2Sc16ArticulationCore26setMaxProjectionIterationsEj(i1, HEAP32[i2 + 8 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (i3 & 8) {
  __ZN5physx2Sc16ArticulationCore22setSeparationToleranceEf(i1, Math_fround(HEAPF32[i2 + 12 >> 2]));
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (i3 & 16) {
  __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf(i1, Math_fround(HEAPF32[i2 + 16 >> 2]));
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (i3 & 32) {
  __ZN5physx2Sc16ArticulationCore24setSolverIterationCountsEt(i1, HEAP16[i2 + 20 >> 1] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (!(i3 & 64)) {
  HEAP32[i6 >> 2] = 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 & -16777216;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 __ZN5physx2Sc16ArticulationCore18setFreezeThresholdEf(i1, Math_fround(HEAPF32[i2 + 24 >> 2]));
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 & -16777216;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN17SizeBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 899332 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085998 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1084342 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i3 + 808 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 192 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470954 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab20SerializedSubProgram8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 192 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470954 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab20SerializedSubProgram8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 192 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z14SetPlayerPause11PlayerPauseb(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i10 = i11 + 12 | 0;
 i9 = i11;
 if ((__Z14GetPlayerPausev() | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 if ((i4 | 0) == 1 & (__Z14GetPlayerPausev() | 0) == 2) {
  STACKTOP = i11;
  return;
 }
 if (!(__Z19GetBuildSettingsPtrv() | 0)) {
  STACKTOP = i11;
  return;
 }
 if (__Z12GetIVRDevicev() | 0) {
  i7 = __Z12GetIVRDevicev() | 0;
  if (!(mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 172 >> 2] | 0, i7 | 0, i4 | 0) | 0)) {
   STACKTOP = i11;
   return;
  }
 }
 i1 = (i4 | 0) != 0;
 i2 = __Z15GetIApplicationv() | 0;
 i3 = (i2 | 0) == 0;
 if (i1 | i3) i1 = i1 | i3 ^ 1; else i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 i2 = __Z9GetIAudiov() | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 i7 = (i4 | 0) == 2;
 __ZN11TimeManager8SetPauseEb(__Z14GetTimeManagerv() | 0, i7);
 if (i7) {
  i5 = __Z16GetScreenManagerv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 76 >> 2] | 0, i5 | 0, 0);
  __ZN13ScreenManager18SetAllowCursorLockEb(__Z16GetScreenManagerv() | 0, 0);
 } else {}
 __Z20SetPlayerPauseDirect11PlayerPause(i4);
 i5 = (i4 | 2 | 0) == 2;
 if (i5 & i6) {
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i3 = i2 + 19296 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = 0;
   do {
    i4 = i2 + 18528 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i2 + 18528 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i4 >> 2] | 0, i7 | 0); else mftCall_vii(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 18528 + (i1 * 12 | 0) + 4 >> 2] | 0, i7 | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
  HEAP32[i9 >> 2] = gb + 29232;
  HEAP32[i9 + 4 >> 2] = i7 & 1;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[gb + 1105716 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1105716 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1105716 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[gb + 1105716 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[gb + 1105716 + 16 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i10, i8);
 }
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i1 = __Z12GetIVRDevicev() | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i7 | 0);
 STACKTOP = i11;
 return;
}

function __ZN8Animator8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 104 | 0, i6);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 108 | 0, i6);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 96 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 417 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 418 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i5 + 561 >> 0] = i1;
 i1 = i5 + 560 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 905722 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 905722 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 85;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 85;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fES4_RKS0_I8Vector2fEiiiPK15TerrainRenderer(i17, i3, i4, i5, i1, i2, i27, i28) {
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 var i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, f24 = f0, f25 = f0, f26 = f0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, f34 = f0;
 i30 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i29 = i30;
 f18 = Math_fround(HEAPF32[i17 + 88 >> 2]);
 f21 = Math_fround(HEAPF32[i17 + 92 >> 2]);
 f19 = Math_fround(HEAPF32[i17 + 96 >> 2]);
 f20 = Math_fround(1 << i27 | 0);
 f21 = Math_fround(f21 / Math_fround(32766.0));
 f25 = Math_fround((HEAP32[i17 + 72 >> 2] | 0) + -1 | 0);
 f22 = Math_fround(f20 * Math_fround(Math_fround(1.0) / f25));
 i23 = i17 + 76 | 0;
 f26 = Math_fround((HEAP32[i23 >> 2] | 0) + -1 | 0);
 f24 = Math_fround(f20 * Math_fround(Math_fround(1.0) / f26));
 f25 = Math_fround(Math_fround(i1 << i27 << 4 | 0) / f25);
 f26 = Math_fround(Math_fround(i2 << i27 << 4 | 0) / f26);
 i16 = i1 << 4;
 i14 = i2 << 4;
 i15 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i17 + 4 | 0;
 i1 = 0;
 do {
  i5 = i1 + i16 | 0;
  i6 = i1 * 17 | 0;
  f7 = Math_fround(f20 * Math_fround(f18 * Math_fround(i5 | 0)));
  f8 = Math_fround(f25 + Math_fround(f22 * Math_fround(i1 | 0)));
  i9 = i5 << i27;
  i2 = 0;
  do {
   i32 = i2 + i14 | 0;
   i31 = (Math_imul(HEAP32[i23 >> 2] | 0, i5) | 0) + i32 << i27;
   f34 = Math_fround(f21 * Math_fround(HEAP16[(HEAP32[i4 >> 2] | 0) + (i31 << 1) >> 1] | 0));
   i31 = i2 + i6 | 0;
   i33 = i15 + (Math_imul(i31, i12) | 0) | 0;
   HEAPF32[i33 >> 2] = f7;
   HEAPF32[i33 + 4 >> 2] = f34;
   HEAPF32[i33 + 8 >> 2] = Math_fround(f20 * Math_fround(f19 * Math_fround(i32 | 0)));
   i33 = i11 + (Math_imul(i31, i3) | 0) | 0;
   HEAPF32[i33 >> 2] = f8;
   HEAPF32[i33 + 4 >> 2] = Math_fround(f26 + Math_fround(f24 * Math_fround(i2 | 0)));
   __ZNK9Heightmap39CalculateNormalSobelRespectingNeighborsEiiPK15TerrainRenderer(i29, i17, i9, i32 << i27, i28);
   i31 = i13 + (Math_imul(i31, i10) | 0) | 0;
   HEAP32[i31 >> 2] = HEAP32[i29 >> 2];
   HEAP32[i31 + 4 >> 2] = HEAP32[i29 + 4 >> 2];
   HEAP32[i31 + 8 >> 2] = HEAP32[i29 + 8 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 17);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 17);
 STACKTOP = i30;
 return;
}

function __ZN8LODGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 i1 = i7 + 32 | 0;
 i9 = i8 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i8 + 24 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 36 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i7 + 40 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 44 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i6 = i7 + 48 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i3 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = i3;
 i1 = i7 + 52 | 0;
 if ((i5 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i8, i7 + 56 | 0, 0);
 i1 = i7 + 72 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx12NpBatchQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformEtRKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE(i10, i16, i17, i9, i2, i11, i8) {
 i10 = i10 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i18;
 i14 = i18 + 24 | 0;
 i1 = i10 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 >= (HEAP32[i10 + 124 >> 2] | 0) >>> 0) {
  STACKTOP = i18;
  return;
 }
 i15 = i10 + 40 | 0;
 if ((__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i15, -1, 0) | 0) == 1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 553, gb + 687825 | 0, i18 + 16 | 0);
  STACKTOP = i18;
  return;
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i6 = HEAP16[i2 + 16 >> 1] | 0;
 i1 = HEAP8[i2 + 18 >> 0] | 0;
 i12 = i10 + 12 | 0;
 i2 = i10 + 24 | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i3 = i13 + 40 | 0;
 i4 = HEAP32[i10 + 20 >> 2] & 2147483647;
 if (i3 >>> 0 > i4 >>> 0) {
  i5 = (i3 * 3 | 0) + 256 | 0;
  if (i4 >>> 0 < i5 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i12, i5);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i12, i3);
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + i5 >> 2] = -16;
 HEAP16[i4 + (i5 + 4) >> 1] = 0;
 i19 = i4 + (i5 + 8) | 0;
 HEAP32[i19 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP16[i4 + (i5 + 24) >> 1] = i6;
 HEAP8[i4 + (i5 + 26) >> 0] = i1;
 HEAP32[i4 + (i5 + 28) >> 2] = i11;
 HEAP32[i4 + (i5 + 32) >> 2] = i8;
 HEAP16[i4 + (i5 + 36) >> 1] = i9;
 HEAP8[i4 + (i5 + 38) >> 0] = 1;
 HEAP32[i2 >> 2] = i3;
 i2 = i10 + 144 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -16) i1 = i2; else i1 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i2 >> 2] = i13;
 HEAP32[i14 + 12 >> 2] = i16;
 HEAP32[i14 + 16 >> 2] = i17;
 HEAPF32[i14 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE(i12, i14);
 __ZN5physx6shdfnd14atomicExchangeEPVii(i15, 0) | 0;
 STACKTOP = i18;
 return;
}

function __ZN2UI6Canvas13UpdateBatchesEb(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i2 = i12;
 i8 = i10 + 228 | 0;
 i1 = i10 + 332 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 if (i11) __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i10, 1);
 f9 = Math_fround(__ZNK2UI6Canvas20CalculateCanvasAlphaEv(i10));
 __ZN2UI6Canvas16UpdateBatchOrderEv(i10);
 __ZN2UI13CanvasManager20UpdateDirtyRenderersER8JobFencePNS_6CanvasE(HEAP32[gb + 1467948 >> 2] | 0, i1, i10);
 i6 = i10 + 224 | 0;
 if (HEAP16[i6 >> 1] & 2) {
  if ((HEAP16[gb + 1468024 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = i10;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468024 | 0, i7);
   i5 = gb + 1468024 | 0;
  } else i5 = 0;
  HEAP8[i7 >> 0] = (__ZNK2UI6Canvas13GetRenderModeEv(i10) | 0) != 2 & 1;
  i1 = i10;
  while (1) {
   i2 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  f4 = Math_fround(HEAPF32[i1 + 404 >> 2]);
  i1 = f4 == Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = i1 ? Math_fround(.100000001) : f4;
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
  if (!i1) i1 = 120; else {
   f4 = Math_fround(HEAPF32[i1 + 160 >> 2]);
   f3 = Math_fround(HEAPF32[i1 + 164 >> 2]);
   i1 = i10;
   while (1) {
    i2 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   f13 = Math_fround(HEAPF32[i1 + 404 >> 2]);
   i1 = f13 == Math_fround(0.0);
   f13 = i1 ? Math_fround(.100000001) : f13;
   i1 = ~~Math_fround((f4 >= f3 ? f4 : f3) * f13);
  }
  HEAP32[i7 + 8 >> 2] = (i1 | 0) > 1 ? i1 : 1;
  if (f9 > Math_fround(0.0)) i1 = HEAP32[i10 + 208 >> 2] | 0; else i1 = 0;
  __ZN2UI29ScheduleUIJobsForInstructionsERNS_7BatchesEjPKNS_13UIInstructionEfjjPNS_13CanvasJobDataE(i8, i1, HEAP32[i10 + 196 >> 2] | 0, f9, HEAP32[i10 + 216 >> 2] | 0, HEAP32[i10 + 220 >> 2] | 0, i7);
  HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] & 65533;
  i1 = i10;
  do {
   HEAP8[i1 + 400 >> 0] = 1;
   i1 = HEAP32[i1 + 344 >> 2] | 0;
  } while ((i1 | 0) != 0);
  if (i5 | 0) __Z12profiler_endP19ProfilerInformation(i5);
 }
 i1 = HEAP32[i10 + 424 >> 2] | 0;
 i2 = i10 + 428 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN2UI6Canvas13UpdateBatchesEb(HEAP32[i1 >> 2] | 0, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 STACKTOP = i12;
 return;
}

function __ZN12LineRenderer19UpdateTransformInfoEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i15 = i13 + 36 | 0;
 i1 = HEAP16[i13 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = __ZN8Renderer12GetTransformEv(i13) | 0;
  HEAP32[i13 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i15);
  i1 = HEAP8[i13 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i16;
  return;
 }
 i17 = HEAP32[i13 + 348 >> 2] | 0;
 i1 = HEAP32[i17 + 8 >> 2] | 0;
 i17 = HEAP32[i17 + 20 >> 2] | 0;
 i12 = i1 + (i17 * 12 | 0) | 0;
 if (!i17) {
  f3 = Math_fround(-inf);
  f7 = Math_fround(inf);
  f6 = Math_fround(-inf);
  f11 = Math_fround(inf);
  f5 = Math_fround(-inf);
  f2 = Math_fround(inf);
 } else {
  f3 = Math_fround(-inf);
  f7 = Math_fround(inf);
  f6 = Math_fround(-inf);
  f4 = Math_fround(inf);
  f5 = Math_fround(-inf);
  f2 = Math_fround(inf);
  do {
   f9 = Math_fround(HEAPF32[i1 >> 2]);
   f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f7 = f7 < f9 ? f7 : f9;
   f2 = f2 < f10 ? f2 : f10;
   f4 = f4 < f11 ? f4 : f11;
   f3 = f3 > f9 ? f3 : f9;
   f5 = f5 > f10 ? f5 : f10;
   f6 = f6 > f11 ? f6 : f11;
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i12 | 0));
  f11 = f4;
 }
 f8 = Math_fround(Math_fround(f3 + f7) * Math_fround(.5));
 f9 = Math_fround(Math_fround(f5 + f2) * Math_fround(.5));
 f10 = Math_fround(Math_fround(f6 + f11) * Math_fround(.5));
 f4 = Math_fround(Math_fround(f3 - f7) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f5 - f2) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f6 - f11) * Math_fround(.5));
 if (!(HEAP8[i13 + 340 >> 0] | 0)) {
  HEAPF32[i13 + 188 >> 2] = f8;
  HEAPF32[i13 + 192 >> 2] = f9;
  HEAPF32[i13 + 196 >> 2] = f10;
  HEAPF32[i13 + 200 >> 2] = f4;
  HEAPF32[i13 + 204 >> 2] = f3;
  HEAPF32[i13 + 208 >> 2] = f2;
  __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i13 + 188 | 0, i15, i13 + 164 | 0);
  STACKTOP = i16;
  return;
 } else {
  __Z25InvertMatrix4x4_General3DPKfPf(i15, i14) | 0;
  HEAPF32[i13 + 164 >> 2] = f8;
  HEAPF32[i13 + 168 >> 2] = f9;
  HEAPF32[i13 + 172 >> 2] = f10;
  HEAPF32[i13 + 176 >> 2] = f4;
  HEAPF32[i13 + 180 >> 2] = f3;
  HEAPF32[i13 + 184 >> 2] = f2;
  __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i13 + 164 | 0, i14, i13 + 188 | 0);
  STACKTOP = i16;
  return;
 }
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, i1);
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = HEAP32[i5 + 24 >> 2] | 0;
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i1 = i2 - i1 | 0;
 i5 = (i1 | 0) / 12 | 0;
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i3, __Z34scripting_class_array_element_sizeP11Il2CppClass(i3) | 0, i5) | 0;
  HEAP32[i2 >> 2] = i5;
 }
 if (i1 | 0) {
  i2 = i9 + 16 | 0;
  i3 = i9 + 24 | 0;
  i4 = i9 + 20 | 0;
  i1 = 0;
  do {
   i7 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i1) | 0;
   HEAP32[i7 >> 2] = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return;
}

function __ZNSt3__211__libcpp_db10__insert_cEPv(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i11 + 4 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i10 = i8 + 8 | 0;
 i7 = i8 + 4 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
 do if (((HEAP32[i10 >> 2] | 0) + 1 | 0) >>> 0 > i1 >> 2 >>> 0) {
  __THREW__ = 0;
  i3 = invoke_ii(fb + 2800 | 0, (i1 >> 1) + 1 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  }
  i4 = _calloc(i3, 4) | 0;
  if (!i4) {
   i1 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i1);
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13048 | 0, fb + 3215 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) break;
   i2 = HEAP32[i1 >> 2] | 0;
   while (1) {
    if (!i2) break;
    HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2];
    i13 = ((__ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6, i5, 4) | 0) >>> 0) % (i3 >>> 0) | 0;
    i14 = i2 + 8 | 0;
    i12 = HEAP32[i14 >> 2] | 0;
    i13 = i4 + (i13 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i13 >> 2] = i2;
    i2 = i12;
   }
   i1 = i1 + 4 | 0;
  }
  _free(HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = i4;
  HEAP32[i7 >> 2] = i4 + (i3 << 2);
  i2 = 13;
 } else i2 = 13; while (0);
 do if ((i2 | 0) == 13) {
  HEAP32[i5 >> 2] = i9;
  i14 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6, i5, 4) | 0;
  i13 = HEAP32[i8 >> 2] | 0;
  i14 = (i14 >>> 0) % ((HEAP32[i7 >> 2] | 0) - i13 >> 2 >>> 0) | 0;
  i13 = i13 + (i14 << 2) | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = _malloc(24) | 0;
  HEAP32[i13 >> 2] = i2;
  if (!(HEAP32[(HEAP32[i8 >> 2] | 0) + (i14 << 2) >> 2] | 0)) {
   i1 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i1);
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13048 | 0, fb + 3215 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  } else {
   HEAP32[i2 + 4 >> 2] = i9;
   HEAP32[i2 + 8 >> 2] = i1;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
   STACKTOP = i11;
   return i2 | 0;
  }
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN6Camera21PrepareLODCullingDataER11CullResultsPKS_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 8 | 0;
 i2 = i15;
 i14 = i15 + 20 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i14 >> 2] = 0;
 i9 = i14 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i14 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, i2);
 i2 = i12;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = i1;
 __ZN15LODGroupManager26CollectAllLODGroupManagersEPK6CameraR13dynamic_arrayIPS_Lj4EEb(i8, i14, 0);
 i13 = i7 + 1248 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i7 + 1260 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i7 + 1264 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 * 12 | 0, 4, i7 + 1252 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i7 + 1252 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i13 >> 2] = i6;
  break;
 } while (0);
 f5 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 384 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   if (!i2) {
    HEAP32[i3 + (i4 * 12 | 0) + 8 >> 2] = 0;
    HEAP32[i3 + (i4 * 12 | 0) >> 2] = 0;
    HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] = 0;
   } else {
    i1 = i3 + (i4 * 12 | 0) | 0;
    __ZN15LODGroupManager21CalculateLODDataArrayERK13LODParametersPK6Cameraf(i12, i2, i6, i8, f5);
    HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
    __ZN15LODGroupManager27GarbageCollectCameraLODDataEv(i2);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP32[i7 + 1196 >> 2] = HEAP32[i13 >> 2];
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i11);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim23scheduleShapeGenerationERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(i11, i9, i10) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16 + 36 | 0;
 i15 = i16 + 24 | 0;
 i5 = i16 + 20 | 0;
 i14 = i16 + 8 | 0;
 i8 = i16;
 i7 = i9 + 4 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 i13 = i15 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i15, i12, i5);
 i5 = HEAP32[i7 >> 2] | 0;
 i12 = i8;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 i12 = i14 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE6resizeEjRKS2_(i14, i5, i8);
 if (!(HEAP32[i7 >> 2] | 0)) i1 = 0; else {
  i8 = 0;
  do {
   i3 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] | 0;
   i5 = HEAP32[i14 >> 2] | 0;
   i2 = i3 + 360 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i2 = 0;
    i1 = 0;
   } else {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1 << 2, gb + 683965 | 0, 792) | 0;
    i2 = HEAP32[i2 >> 2] | 0;
    if (!i2) i2 = 0; else {
     i3 = i3 + 356 | 0;
     i4 = 0;
     do {
      HEAP32[i1 + (i4 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 44 >> 2];
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i2 | 0));
    }
   }
   HEAP32[i5 + (i8 << 3) >> 2] = i1;
   HEAP32[i5 + (i8 << 3) + 4 >> 2] = i2;
   HEAP32[(HEAP32[i15 >> 2] | 0) + (i8 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] | 0) + 56 >> 2];
   i8 = i8 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i8 >>> 0 < i1 >>> 0);
 }
 i1 = __ZN5physx24PxsParticleSystemBatcher23scheduleShapeGenerationEPPNS_20PxvParticleSystemSimEPNS_28PxvParticleShapesUpdateInputEjRNS_10PxBaseTaskE((HEAP32[i11 + 1e3 >> 2] | 0) + 324 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i14 >> 2] | 0, i1, i10) | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 | 0) > -1 & (i12 & 2147483647 | 0) != 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i14, HEAP32[i14 >> 2] | 0);
 i14 = HEAP32[i13 >> 2] | 0;
 if (!((i14 | 0) > -1 & (i14 & 2147483647 | 0) != 0)) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i15, HEAP32[i15 >> 2] | 0);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E15insert_noresizeERKS5_(i11, i12, i15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = i12 + 32 | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 i8 = i9 + -1 | 0;
 i7 = HEAP32[i15 >> 2] | 0;
 i1 = (Math_imul(i7, 1419247029) | 0) & i8;
 i13 = i12 + 28 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i12 + 20 >> 2] | 0;
 i4 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
 i10 = HEAP8[i12 + 8 >> 0] | 0;
 L1 : do if ((i6 | 0) == (i4 | 0)) i4 = 16; else {
  i2 = i12 + 12 | 0;
  L3 : do if (!(i10 << 24 >> 24)) {
   i3 = 0;
   i2 = i4;
   while (1) {
    if ((i7 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i8;
    i2 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
    if ((i6 | 0) == (i2 | 0)) {
     i4 = 20;
     break L1;
    }
   }
  } else {
   if (!(HEAP32[i12 + 4 >> 2] | 0)) {
    i3 = 0;
    i2 = i4;
    while (1) {
     if ((i7 | 0) == (i2 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i8;
     i2 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
     if ((i6 | 0) == (i2 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else {
    i5 = HEAP32[i2 >> 2] | 0;
    i2 = -1;
    i3 = 0;
    do {
     if ((i5 | 0) == (i4 | 0)) i2 = (i2 | 0) == -1 ? i1 : i2; else if ((i7 | 0) == (i4 | 0)) break L3;
     i3 = i3 + 1 | 0;
     i1 = i3 + i1 & i8;
     i4 = HEAP32[i14 + (i1 << 3) >> 2] | 0;
    } while ((i6 | 0) != (i4 | 0));
   }
   i1 = (i2 | 0) == -1 ? i1 : i2;
   i4 = 16;
   break L1;
  } while (0);
  if ((i1 | 0) == -1) {
   i1 = -1;
   i4 = 16;
  } else {
   HEAP32[i11 >> 2] = i12;
   HEAP32[i11 + 4 >> 2] = i14 + (i1 << 3);
   HEAP32[i11 + 8 >> 2] = i14 + (i9 << 3);
   HEAP8[i11 + 12 >> 0] = 0;
   return;
  }
 } while (0);
 if ((i4 | 0) == 16) if (!(i10 << 24 >> 24)) i4 = 20; else {
  i2 = i12 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i4 = 20; else if ((HEAP32[i12 + 12 >> 2] | 0) == (HEAP32[i14 + (i1 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i4 = 20;
 }
 if ((i4 | 0) == 20) {
  i10 = i12 + 36 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 i9 = i15;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = i14 + (i1 << 3) | 0;
 HEAP32[i15 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i15 + 4 >> 2] = i10;
 i15 = HEAP32[i13 >> 2] | 0;
 i16 = i15 + (HEAP32[i16 >> 2] << 3) | 0;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i11 + 4 >> 2] = i15 + (i1 << 3);
 HEAP32[i11 + 8 >> 2] = i16;
 HEAP8[i11 + 12 >> 0] = 1;
 return;
}

function __ZN14UnityWebStreamC2EPKc7Hash128jb(i9, i2, i4, i5, i6) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i7 = i11 + 28 | 0;
 i8 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 i12 = i9 + 24 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i12 = __Znwj(192) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i12, i1);
 i3 = i9 + 40 | 0;
 HEAP32[i3 >> 2] = i12;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (i6) {
  i12 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, _strlen(i2) | 0);
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i7, i12, i8, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_((HEAP32[i3 >> 2] | 0) + 176 | 0, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 88 >> 2] = i5;
 HEAP8[i1 + 188 >> 0] = 1;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP8[i9 + 19 >> 0] = 0;
 HEAP8[i9 + 20 >> 0] = 0;
 HEAP8[i9 + 18 >> 0] = 0;
 HEAP8[i9 + 17 >> 0] = 0;
 HEAP8[i9 + 21 >> 0] = 0;
 i1 = i9 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i9 + 16 >> 0] = 0;
 HEAP32[i9 + 36 >> 2] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[gb + 1451260 >> 2] | 0;
 if ((i9 | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[HEAP32[i10 >> 2] >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 843719 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN19AutoOffMeshLinkData8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 843719 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN19AutoOffMeshLinkData8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14CachingManager8IsCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = i8 + 52 | 0;
 i2 = i8 + 40 | 0;
 i6 = i8 + 28 | 0;
 i7 = i8 + 16 | 0;
 i9 = HEAP32[(__Z17GetCachingManagerv() | 0) + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i6, i9, i3, i5);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, (HEAP32[(__Z17GetCachingManagerv() | 0) + 4 >> 2] | 0) + 4 | 0, i6);
 __Z20GetPlatformCachePathv(i5);
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i5); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i5, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i9 = HEAP8[i7 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i9 & 255) | 0)) {
  i9 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = __ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE(i7, 0, i5) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i9 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i9;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i9 = i4;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return i9 | 0;
}

function __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i16 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i16) return;
 i15 = i1 + 152 | 0;
 i3 = HEAP32[i15 >> 2] | 0;
 if ((HEAP32[i3 >> 2] & 2139095040 | 0) == 2139095040) return;
 i1 = i16 + -1 | 0;
 if (!((i16 | 0) > 0 ? (HEAP32[i3 + (i1 * 52 | 0) >> 2] & 2139095040 | 0) != 2139095040 : 0)) return;
 f10 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 12 >> 2]);
 f2 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 8 >> 2]);
 i14 = 0;
 f13 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) + 4 >> 2]);
 while (1) {
  i7 = i3 + (i14 * 52 | 0) + 4 | 0;
  f4 = Math_fround(HEAPF32[i7 >> 2]);
  i9 = i3 + (i14 * 52 | 0) + 8 | 0;
  f12 = Math_fround(HEAPF32[i9 >> 2]);
  i8 = i3 + (i14 * 52 | 0) + 12 | 0;
  f5 = Math_fround(HEAPF32[i8 >> 2]);
  i1 = i3 + (i14 * 52 | 0) + 16 | 0;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  if (Math_fround(Math_fround(Math_fround(Math_fround(f13 * f4) + Math_fround(f2 * f12)) + Math_fround(f11 * f5)) + Math_fround(f10 * f6)) < Math_fround(0.0)) {
   f4 = Math_fround(-f4);
   f2 = Math_fround(-f12);
   f5 = Math_fround(-f5);
   f6 = Math_fround(-f6);
   HEAPF32[i7 >> 2] = f4;
   HEAPF32[i9 >> 2] = f2;
   HEAPF32[i8 >> 2] = f5;
   HEAPF32[i1 >> 2] = f6;
   i9 = HEAP32[i15 >> 2] | 0;
   i8 = i9 + (i14 * 52 | 0) + 20 | 0;
   f13 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
   i7 = i9 + (i14 * 52 | 0) + 24 | 0;
   f12 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
   i3 = i9 + (i14 * 52 | 0) + 28 | 0;
   f11 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
   i9 = i9 + (i14 * 52 | 0) + 32 | 0;
   f10 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
   HEAPF32[i8 >> 2] = f13;
   HEAPF32[i7 >> 2] = f12;
   HEAPF32[i3 >> 2] = f11;
   HEAPF32[i9 >> 2] = f10;
   i9 = HEAP32[i15 >> 2] | 0;
   i3 = i9 + (i14 * 52 | 0) + 36 | 0;
   f10 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
   i7 = i9 + (i14 * 52 | 0) + 40 | 0;
   f11 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
   i8 = i9 + (i14 * 52 | 0) + 44 | 0;
   f12 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
   i9 = i9 + (i14 * 52 | 0) + 48 | 0;
   f13 = Math_fround(-Math_fround(HEAPF32[i9 >> 2]));
   HEAPF32[i3 >> 2] = f10;
   HEAPF32[i7 >> 2] = f11;
   HEAPF32[i8 >> 2] = f12;
   HEAPF32[i9 >> 2] = f13;
  } else f2 = f12;
  i1 = i14 + 1 | 0;
  if ((i1 | 0) == (i16 | 0)) break;
  i14 = i1;
  f13 = f4;
  f11 = f5;
  f10 = f6;
  i3 = HEAP32[i15 >> 2] | 0;
 }
 return;
}

function __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 24 | 0;
 i12 = i13;
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 16 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i14;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i14) {
   i14 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i14 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i12, 0);
   HEAP8[i5 >> 0] = 1;
   i14 = i3 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i12, HEAP32[i9 + 24 >> 2] | 0, HEAP32[i8 + 28 >> 2] | 0);
 } while (0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i11 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i10 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i14 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i14, i11);
    i2 = HEAP32[i10 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i14 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__23mapIiN14NavMeshManager9LayerDataENS_4lessIiEENS_9allocatorINS_4pairIKiS2_EEEEEixERS7_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i6 = i10 + 8 | 0;
 i2 = i9 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i3 = i2;
  i5 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i5 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i5 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 5) {
   HEAP32[i6 >> 2] = i1;
   i6 = i1;
   i4 = i1;
   break;
  } else if ((i5 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i6 = i1;
   i4 = i3;
   break;
  } else if ((i5 | 0) == 10) {
   HEAP32[i6 >> 2] = i1;
   i3 = i1;
   i2 = i6;
   i5 = 12;
   break;
  }
 } while (0);
 if ((i5 | 0) == 12) if (!i1) {
  i6 = i3;
  i4 = i2;
 } else {
  i9 = i1;
  i9 = i9 + 20 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = __Znwj(84) | 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 >> 2];
 i1 = i5 + 28 | 0;
 i2 = i5 + 20 | 0;
 i3 = i2 + 60 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i2 = i8;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i3 = i8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i5 + 48 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 76 >> 2] = 0;
 HEAP32[i5 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i7 = i8;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5 + 68 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if (!i1) i1 = i5; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i1);
 i9 = i9 + 8 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = i5;
 i9 = i9 + 20 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb(i1, i9, i2, i3, i5) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 4 | 0;
 i4 = i10;
 L1 : do if (!(HEAP32[i2 + 4 >> 2] & 1)) {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  i1 = mftCall_iiiiii(i7 | 0, i1 | 0, i8 | 0, i2 | 0, i3 | 0, i5 & 1 | 0) | 0;
 } else {
  i1 = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
  HEAP32[i8 >> 2] = i1;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474572 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  do if (i6 & 1) {
   i10 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = i10;
  } else {
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i5) mftCall_vii(HEAP32[i1 + 24 >> 2] | 0, i8 | 0, i2 | 0); else mftCall_vii(HEAP32[i1 + 28 >> 2] | 0, i8 | 0, i2 | 0);
   i6 = i8 + 11 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) {
    i2 = i1;
    i1 = HEAP32[i8 >> 2] | 0;
    i7 = 9;
   } else i5 = i8;
   L13 : while (1) {
    if ((i7 | 0) == 9) {
     i5 = i1;
     i1 = i2;
    }
    i7 = i1 << 24 >> 24 < 0;
    if ((i5 | 0) == ((i7 ? HEAP32[i8 >> 2] | 0 : i8) + (i7 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255) | 0)) {
     i7 = 11;
     break;
    }
    i1 = HEAP8[i5 >> 0] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    do if (i2 | 0) {
     i3 = i2 + 24 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (HEAP32[i2 + 28 >> 2] | 0)) {
      HEAP32[i3 >> 2] = i4 + 1;
      HEAP8[i4 >> 0] = i1;
      break;
     }
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 & 255 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i7 = 20;
      break L13;
     }
     if ((i1 | 0) == -1) HEAP32[i9 >> 2] = 0;
    } while (0);
    i2 = HEAP8[i6 >> 0] | 0;
    i1 = i5 + 1 | 0;
    i7 = 9;
   }
   if ((i7 | 0) == 11) {
    i1 = HEAP32[i9 >> 2] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    break L1;
   } else if ((i7 | 0) == 20) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    break;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __Z28TestAssetBundleCompatibilityRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_(i1, i12, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 24 | 0;
 i15 = i18 + 16 | 0;
 i14 = i18;
 i10 = __ZN17PersistentManager25GetSerializedFileInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z20GetPersistentManagerv() | 0, i1) | 0;
 if (HEAP8[i10 + 52 >> 0] | 0) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i11 = __Z16GetBuildSettingsv() | 0;
 i6 = i10 + 12 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i17 = 1;
  STACKTOP = i18;
  return i17 | 0;
 }
 i7 = i14 + 8 | 0;
 i8 = i14 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 while (1) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i9 = (i1 | 0) == (gb + 27592 | 0);
  if (i9) {
   __ZNK13BuildSettings15GetHashOfScriptERK7Hash128(i14, i11, i5 + 8 | 0);
   i2 = i14;
   i4 = i7;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
  } else {
   __ZNK13BuildSettings13GetHashOfTypeEPKN5Unity4TypeE(i14, i11, i1);
   i2 = i14;
   i4 = i8;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
  }
  i19 = i5 + 24 | 0;
  if (!((i1 | 0) == (HEAP32[i19 >> 2] | 0) ? (i2 | 0) == (HEAP32[i19 + 4 >> 2] | 0) : 0)) break;
  i19 = i5 + 32 | 0;
  i5 = i5 + 56 | 0;
  if (!((i3 | 0) == (HEAP32[i19 >> 2] | 0) ? (i4 | 0) == (HEAP32[i19 + 4 >> 2] | 0) : 0)) break;
  if ((i5 | 0) == ((HEAP32[i10 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 56 | 0) | 0)) {
   i1 = 1;
   i17 = 13;
   break;
  }
 }
 if ((i17 | 0) == 13) {
  STACKTOP = i18;
  return i1 | 0;
 }
 if (i9) {
  HEAP32[i15 >> 2] = (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  __Z6FormatPKcz(i14, gb + 366414 | 0, i15);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i13, i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i19 = 0;
  STACKTOP = i18;
  return i19 | 0;
 } else {
  HEAP32[i16 >> 2] = (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
  __Z6FormatPKcz(i14, gb + 366584 | 0, i16);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i13, i14) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i19 = 0;
  STACKTOP = i18;
  return i19 | 0;
 }
 return 0;
}

function __ZN8Animator16GetBoneTransformEi(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 if (!(HEAP8[i6 + 153 >> 0] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = i6 + 104 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 10;
  }
 }
 if ((i7 | 0) == 8) i7 = 10;
 if ((i7 | 0) == 10) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
 }
 i4 = __ZN6Avatar8GetAssetEv(i1) | 0;
 if (!i4) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i2 = i4 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = i3 + i2 + 40 | 0;
 if (!(HEAP32[(HEAP32[i9 >> 2] | 0) + i9 >> 2] | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i1 = __ZN10HumanTrait9GetBoneIdERK6Avatari(i1, i5) | 0;
 if ((i1 | 0) == -1) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i4 = i4 + 28 | 0;
 i4 = HEAP32[(HEAP32[i4 >> 2] | 0) + i4 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i6 + 144 >> 2] | 0;
 if (HEAP8[i6 + 561 >> 0] | 0) {
  i9 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i3) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i7 = 22;
   break;
  }
 }
 if ((i7 | 0) == 22) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i9 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 52 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034351 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN11KeyframeTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 52 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034351 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11KeyframeTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 52 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14PreloadManager16UpdatePreloadingEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, d11 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i6 = i9;
 i7 = i8 + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  i2 = 0;
  do {
   i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i1 = i1 | (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 i4 = i8 + 32 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i3 = i8 + 20 | 0;
  i2 = 0;
  do {
   i10 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i1 = i1 | (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if (!i1) {
  if ((HEAP16[gb + 1163204 + 6 >> 1] | 0) > -1) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163204 | 0, i5);
   i2 = gb + 1163204 | 0;
  } else i2 = 0;
  d11 = +_emscripten_get_now() * 1.0e6;
  i3 = ~~d11 >>> 0;
  i4 = +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i1 = 10;
  do {
   if (!(__ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi(i8, 0, i1) | 0)) break;
   d11 = +_emscripten_get_now() * 1.0e6;
   i1 = _i64Subtract(~~d11 >>> 0 | 0, (+Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i3 | 0, i4 | 0) | 0;
   i1 = __Z17TimeToNanosecondsy(i1, getTempRet0() | 0) | 0;
   i1 = ___udivdi3(i1 | 0, getTempRet0() | 0, 1e6, 0) | 0;
   getTempRet0() | 0;
   i1 = 10 - i1 | 0;
  } while ((i1 | 0) > 0);
  if (!i2) {
   STACKTOP = i9;
   return;
  }
  __Z12profiler_endP19ProfilerInformation(i2);
  STACKTOP = i9;
  return;
 }
 if ((HEAP16[gb + 1163216 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163216 | 0, i5);
  i1 = gb + 1163216 | 0;
 } else i1 = 0;
 while (1) {
  if (!(HEAP32[i7 >> 2] | 0)) if (!(HEAP32[i4 >> 2] | 0)) break;
  __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi(i8, 2, 2147483647) | 0;
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i9;
 return;
}

function __ZN19CloudServiceHandler10InitializeERK8UnityStrNS_13InitModeFlagsE(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i9 + 1144 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i9 + 4 | 0;
 do if ((i6 | 0) != (i1 | 0)) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i7 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  i3 = i6 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 8 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i5 - i4 | 0, i1, 0, i1, i5, i7);
   break;
  }
  if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  if (i5 | 0) _memmove(i1 | 0, i7 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 8 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 __ZN19CloudServiceHandler17InitServiceFolderENS_13InitModeFlagsE(i9, i8);
 i1 = i9 + 188 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP32[i9 + 192 >> 2] = __ZnwjRK10MemLabelIdiPKci(1, gb + 63800 | 0, 16, gb + 1046485 | 0, 31) | 0;
  HEAP8[i1 >> 0] = 1;
 }
 i6 = i9 + 1140 | 0;
 HEAP32[i6 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(2048, 16, gb + 63800 | 0, 0, gb + 1047011 | 0, 79) | 0;
 i5 = i9 + 52 | 0;
 i7 = i9 + 184 | 0;
 __ZN11UnityEngine15CloudWebService19SessionEventManager10InitializeERK8UnityStrPNS0_18ICloudJobSchedulerE(i9 + 200 | 0, i5, i7) | 0;
 i8 = i9 + 792 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher10InitializeERK8UnityStrPvjRNS0_18ICloudJobSchedulerE(i8, i5, HEAP32[i6 >> 2] | 0, 2048, i7) | 0;
 HEAP32[i9 + 236 >> 2] = i8;
 i8 = __Z21GetManagerFromContexti(20) | 0;
 i7 = i8 + 44 | 0;
 i6 = HEAP32[i8 + 56 >> 2] | 0;
 HEAP32[i10 >> 2] = 85;
 HEAP32[i10 + 4 >> 2] = i6;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i10 + 8 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i7;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = i10;
 i10 = i8 + 52 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 HEAP32[i11 >> 2] = 1;
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN16DeveloperConsole9HandleLogERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType(i6, i1, i2, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7;
 if ((i3 | 0) > 1 & (i3 | 0) != 4) {
  STACKTOP = i7;
  return;
 }
 i8 = i6 + 16 | 0;
 i12 = i5 + 4 | 0;
 HEAP32[i12 >> 2] = i3;
 i3 = i5 + 12 | 0;
 i11 = gb + 63672 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 i10 = i5 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i9 = i5 + 20 | 0;
 HEAP8[i9 >> 0] = 0;
 i13 = i5 + 24 | 0;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i13 + 4 >> 2] = i11;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
 i1 = i4 + 11 | 0;
 i13 = HEAP8[i1 >> 0] | 0;
 HEAP32[i5 >> 2] = i13 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i13 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i4, gb + 1017155 | 0) | 0;
 i13 = HEAP8[i2 + 11 >> 0] | 0;
 i11 = i13 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, i11 ? HEAP32[i2 >> 2] | 0 : i2, i11 ? HEAP32[i2 + 4 >> 2] | 0 : i13 & 255) | 0;
 __Z17UTF8ToUTF16StringPKcR11UTF16String((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = __Znwj(40) | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i12 >> 2];
 i4 = i1 + 20 | 0;
 i12 = gb + 63672 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i2 = i1 + 28 | 0;
 HEAP8[i2 >> 0] = 0;
 i11 = i1 + 32 | 0;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i11 + 4 >> 2] = i12;
 __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i4, HEAP32[i5 + 12 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 HEAP8[i2 >> 0] = HEAP8[i9 >> 0] | 0;
 HEAP8[i9 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = i8;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i8 >> 2] = i1;
 i1 = i6 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 __ZN11UTF16StringD2Ev(i3);
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 <= 10) {
  STACKTOP = i7;
  return;
 }
 i14 = HEAP32[i6 + 20 >> 2] | 0;
 i13 = i14 + 4 | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[HEAP32[i13 >> 2] >> 2] = i12;
 HEAP32[i1 >> 2] = i2 + -1;
 __ZN11UTF16StringD2Ev(i14 + 20 | 0);
 __ZdlPv(i14);
 STACKTOP = i7;
 return;
}

function __ZN15LightProbeUtils32BarycentricCoordinates3DTriangleEPK8Vector3fRS1_(i18, i3, i7) {
 i18 = i18 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(f10 - f13);
 f11 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(f11 - f15);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(f6 - f9);
 f12 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f13 = Math_fround(f12 - f13);
 f14 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f15 = Math_fround(f14 - f15);
 f8 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f9 = Math_fround(f8 - f9);
 f1 = Math_fround(Math_fround(f16 * f9) - Math_fround(f4 * f15));
 f4 = Math_fround(Math_fround(f4 * f13) - Math_fround(f2 * f9));
 f16 = Math_fround(Math_fround(f2 * f15) - Math_fround(f16 * f13));
 i3 = f1 < Math_fround(0.0);
 f2 = Math_fround(-f1);
 f2 = i3 ? f2 : f1;
 i3 = f4 < Math_fround(0.0);
 f17 = Math_fround(-f4);
 f4 = i3 ? f17 : f4;
 i3 = f16 < Math_fround(0.0);
 f5 = Math_fround(-f16);
 f5 = i3 ? f5 : f16;
 do if (!(f2 >= f4) | !(f2 >= f5)) {
  f1 = Math_fround(HEAPF32[i7 >> 2]);
  if (!(f4 >= f2) | !(f4 >= f5)) {
   f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f1 - f10) * Math_fround(f11 - f14)) - Math_fround(Math_fround(f10 - f12) * Math_fround(f2 - f11)));
   f2 = Math_fround(Math_fround(Math_fround(f1 - f12) * f15) - Math_fround(f13 * Math_fround(f2 - f14)));
   f1 = f16;
   break;
  } else {
   f2 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f4 = Math_fround(Math_fround(Math_fround(f1 - f10) * Math_fround(f6 - f8)) - Math_fround(Math_fround(f10 - f12) * Math_fround(f2 - f6)));
   f2 = Math_fround(Math_fround(Math_fround(f1 - f12) * f9) - Math_fround(f13 * Math_fround(f2 - f8)));
   f1 = f17;
   break;
  }
 } else {
  f17 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f4 = Math_fround(Math_fround(Math_fround(f17 - f11) * Math_fround(f6 - f8)) - Math_fround(Math_fround(f2 - f6) * Math_fround(f11 - f14)));
  f2 = Math_fround(Math_fround(Math_fround(f17 - f14) * f9) - Math_fround(f15 * Math_fround(f2 - f8)));
 } while (0);
 f16 = Math_fround(Math_fround(1.0) / f1);
 f15 = Math_fround(f16 * f4);
 f16 = Math_fround(f2 * f16);
 f17 = Math_fround(Math_fround(Math_fround(1.0) - f15) - f16);
 HEAPF32[i18 >> 2] = f15;
 HEAPF32[i18 + 4 >> 2] = f16;
 HEAPF32[i18 + 8 >> 2] = f17;
 return;
}

function __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 20 | 0;
 i10 = i14 + 48 | 0;
 i11 = i14;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (HEAP32[i5 + 32 >> 2] | 0) == 17;
 i3 = i9;
 do if (!i9) {
  i1 = i5 + 12 | 0;
  if (i2) i2 = 0; else i2 = _il2cpp_object_new(HEAP32[i1 >> 2] | 0) | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i13 + 4 >> 2] = i2;
  HEAP32[i13 + 8 >> 2] = i8;
  HEAP32[i13 + 12 >> 2] = -1;
  i9 = 1;
  i3 = i2;
  i4 = -1;
 } else {
  if (!i2) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i13, HEAP32[i5 >> 2] | 0, i6, 1);
   i9 = HEAP8[i13 >> 0] | 0;
   i3 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = HEAP32[i13 + 8 >> 2] | 0;
   i4 = HEAP32[i13 + 12 >> 2] | 0;
   break;
  }
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  if (!(HEAP8[i6 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i6 + 12 >> 2] | 0) | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  } else {
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  }
  HEAP32[i13 + 8 >> 2] = i2;
  HEAP32[i13 + 12 >> 2] = i1;
  i9 = 0;
  i8 = i2;
  i4 = i1;
 } while (0);
 i15 = i13 + 1 | 0;
 HEAP8[i10 >> 0] = HEAP8[i15 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[i15 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[i15 + 2 >> 0] | 0;
 i15 = HEAP32[i5 + 44 >> 2] | 0;
 i5 = (HEAP32[i6 + 16 >> 2] | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 HEAP32[i5 >> 2] = i2;
 i5 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i13 + 20 >> 2] = i12;
 HEAP8[i13 >> 0] = i9;
 i12 = i13 + 1 | 0;
 HEAP8[i12 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i8;
 HEAP32[i13 + 12 >> 2] = i4;
 HEAP32[i13 + 16 >> 2] = i11;
 if (!i15) {
  STACKTOP = i14;
  return;
 }
 do {
  i16 = i1 + 64 | 0;
  HEAP32[i5 >> 2] = i16;
  HEAP32[i7 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i13 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyERPNS0_8ShapeSimEPNS_9PxBounds3E(i20, i19, i14, i17, i18, i13, i16, i15) {
 i20 = i20 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i14) return;
 i8 = _i64Add(i17 + 144 | 0, 0, -1, -1) | 0;
 i9 = getTempRet0() | 0;
 i10 = i20 + 1212 | 0;
 i7 = i17 + 68 | 0;
 i11 = 0;
 do {
  i12 = i11;
  i11 = i11 + 1 | 0;
  if (i11 >>> 0 < i14 >>> 0) {
   i3 = HEAP32[i19 + (i11 << 2) >> 2] | 0;
   i2 = i3;
   i5 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
   i6 = getTempRet0() | 0;
   i2 = _i64Add(i8 | 0, i9 | 0, i2 | 0, 0) | 0;
   i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
   i1 = getTempRet0() | 0;
   i6 = _i64Subtract(1, 0, i5 | 0, i6 | 0) | 0;
   i1 = _i64Add(i6 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
   i2 = getTempRet0() | 0;
   while (1) {
    i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
    i2 = getTempRet0() | 0;
    if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
   }
  }
  i6 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  i4 = HEAP32[i6 + 12 >> 2] | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = i4 + (i3 * 12 | 0) + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  do if (!i1) {
   i1 = i4 + (i3 * 12 | 0) + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
    HEAP32[i1 >> 2] = i2 + 1;
    i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
    if (i1 | 0) break;
   }
   i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
  } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
  i3 = i1;
  i6 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
  i4 = getTempRet0() | 0;
  i3 = _i64Add(i3 | 0, 0, 31, 0) | 0;
  i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
  i2 = getTempRet0() | 0;
  i4 = _i64Subtract(1, 0, i6 | 0, i4 | 0) | 0;
  i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  i4 = i1;
  while (1) {
   i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
  }
  i6 = HEAP32[i19 + (i12 << 2) >> 2] | 0;
  __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(HEAP32[i16 >> 2] | 0, i18, i6 + i17 | 0, i13, i15 + (i12 * 24 | 0) | 0);
  HEAP32[i16 >> 2] = i1;
  i12 = i20 + 1424 + (HEAP32[i6 + i7 >> 2] << 2) | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } while ((i11 | 0) != (i14 | 0));
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 28 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470681 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab19SerializedSubShader8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 28 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470681 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab19SerializedSubShader8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 28 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI26EnlightenSystemInformationLj8EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 56 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402687 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN26EnlightenSystemInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 56 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 402687 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN26EnlightenSystemInformation8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 56 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 20 | 0;
 i10 = i14 + 48 | 0;
 i11 = i14;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (HEAP32[i5 + 32 >> 2] | 0) == 17;
 i3 = i9;
 do if (!i9) {
  i1 = i5 + 12 | 0;
  if (i2) i2 = 0; else i2 = _il2cpp_object_new(HEAP32[i1 >> 2] | 0) | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i13 + 4 >> 2] = i2;
  HEAP32[i13 + 8 >> 2] = i8;
  HEAP32[i13 + 12 >> 2] = -1;
  i9 = 1;
  i3 = i2;
  i4 = -1;
 } else {
  if (!i2) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i13, HEAP32[i5 >> 2] | 0, i6, 1);
   i9 = HEAP8[i13 >> 0] | 0;
   i3 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = HEAP32[i13 + 8 >> 2] | 0;
   i4 = HEAP32[i13 + 12 >> 2] | 0;
   break;
  }
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  if (!(HEAP8[i6 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i6 + 12 >> 2] | 0) | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  } else {
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  }
  HEAP32[i13 + 8 >> 2] = i2;
  HEAP32[i13 + 12 >> 2] = i1;
  i9 = 0;
  i8 = i2;
  i4 = i1;
 } while (0);
 i15 = i13 + 1 | 0;
 HEAP8[i10 >> 0] = HEAP8[i15 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[i15 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[i15 + 2 >> 0] | 0;
 i15 = HEAP32[i5 + 44 >> 2] | 0;
 i5 = (HEAP32[i6 + 16 >> 2] | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 HEAP32[i5 >> 2] = i2;
 i5 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i13 + 20 >> 2] = i12;
 HEAP8[i13 >> 0] = i9;
 i12 = i13 + 1 | 0;
 HEAP8[i12 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i8;
 HEAP32[i13 + 12 >> 2] = i4;
 HEAP32[i13 + 16 >> 2] = i11;
 if (!i15) {
  STACKTOP = i14;
  return;
 }
 do {
  i16 = i1 + 64 | 0;
  HEAP32[i5 >> 2] = i16;
  HEAP32[i7 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i13 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i14;
 return;
}

function __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 20 | 0;
 i10 = i14 + 48 | 0;
 i11 = i14;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (HEAP32[i5 + 32 >> 2] | 0) == 17;
 i3 = i9;
 do if (!i9) {
  i1 = i5 + 12 | 0;
  if (i2) i2 = 0; else i2 = _il2cpp_object_new(HEAP32[i1 >> 2] | 0) | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP8[i13 >> 0] = 1;
  HEAP32[i13 + 4 >> 2] = i2;
  HEAP32[i13 + 8 >> 2] = i8;
  HEAP32[i13 + 12 >> 2] = -1;
  i9 = 1;
  i3 = i2;
  i4 = -1;
 } else {
  if (!i2) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i13, HEAP32[i5 >> 2] | 0, i6, 1);
   i9 = HEAP8[i13 >> 0] | 0;
   i3 = HEAP32[i13 + 4 >> 2] | 0;
   i8 = HEAP32[i13 + 8 >> 2] | 0;
   i4 = HEAP32[i13 + 12 >> 2] | 0;
   break;
  }
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  if (!(HEAP8[i6 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i6 + 12 >> 2] | 0) | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  } else {
   HEAP8[i13 >> 0] = 0;
   HEAP32[i13 + 4 >> 2] = i3;
  }
  HEAP32[i13 + 8 >> 2] = i2;
  HEAP32[i13 + 12 >> 2] = i1;
  i9 = 0;
  i8 = i2;
  i4 = i1;
 } while (0);
 i15 = i13 + 1 | 0;
 HEAP8[i10 >> 0] = HEAP8[i15 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[i15 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[i15 + 2 >> 0] | 0;
 i15 = HEAP32[i5 + 44 >> 2] | 0;
 i5 = (HEAP32[i6 + 16 >> 2] | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 HEAP32[i5 >> 2] = i2;
 i5 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 i6 = i11 + 8 | 0;
 HEAP32[i6 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i11 + 16 >> 2] = i16;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = i16;
 HEAP32[i13 + 20 >> 2] = i12;
 HEAP8[i13 >> 0] = i9;
 i12 = i13 + 1 | 0;
 HEAP8[i12 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i12 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP8[i12 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = i8;
 HEAP32[i13 + 12 >> 2] = i4;
 HEAP32[i13 + 16 >> 2] = i11;
 if (!i15) {
  STACKTOP = i14;
  return;
 }
 do {
  i16 = i1 + 64 | 0;
  HEAP32[i5 >> 2] = i16;
  HEAP32[i7 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i13 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i14;
 return;
}

function __ZN5physx29PxSphericalJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 741622;
 HEAP32[i1 + 240 >> 2] = 477;
 HEAP32[i1 + 244 >> 2] = fb + 3556;
 HEAP32[i1 + 248 >> 2] = fb + 3557;
 HEAP32[i1 + 252 >> 2] = gb + 741632;
 HEAP32[i1 + 256 >> 2] = 478;
 HEAP32[i1 + 260 >> 2] = fb + 2164;
 HEAP32[i1 + 264 >> 2] = fb + 3558;
 HEAP32[i1 + 268 >> 2] = gb + 741652;
 HEAP32[i1 + 272 >> 2] = 479;
 HEAP32[i1 + 276 >> 2] = fb + 427;
 HEAP32[i1 + 280 >> 2] = fb + 370;
 HEAP32[i1 + 284 >> 2] = gb + 831985;
 HEAP32[i1 + 288 >> 2] = 480;
 HEAP32[i1 + 292 >> 2] = fb + 2165;
 return;
}

function __ZN21BillboardBatchManager18MakeTempPropertiesER19ShaderPropertySheetRK6CameraRK19SharedBillboardData(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 56 | 0;
 i8 = i1 + 40 | 0;
 i7 = i1 + 32 | 0;
 i5 = i1 + 16 | 0;
 i6 = i1;
 __ZN19ShaderPropertySheet5ClearEb(i2, 1);
 i10 = i4 + 40 | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i2, i12 + 2 | 0);
 f14 = Math_fround(i12 >>> 0);
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(6.28318548) / f14));
 HEAPF32[i9 >> 2] = f14;
 HEAPF32[i9 + 4 >> 2] = f13;
 HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1159908 | 0, i9, 0);
 i12 = HEAP32[i4 + 20 >> 2] | 0;
 i11 = HEAP32[i4 + 24 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i8 + 8 >> 2] = i11;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1159912 | 0, i8, 0);
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i2, gb + 1159916 | 0, 1, HEAP32[i4 + 28 >> 2] | 0, 16, HEAP32[i10 >> 2] | 0) | 0;
 __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf(__ZNK6Camera22GetWorldToCameraMatrixEv(i3) | 0, i9, i8, i7);
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1159936 | 0, i5, 0);
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1159940 | 0, i5, 0);
 __ZNK6Camera11GetPositionEv(i6, i3);
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = i4;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1159944 | 0, i5, 0);
 __ZN19ShaderPropertySheet11ComputeHashEv(i2);
 STACKTOP = i1;
 return;
}

function __ZN18LoadSceneOperation13UnloadStreamsEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = __Z20GetPersistentManagerv() | 0;
 i2 = i5 + 164 | 0;
 i4 = i2 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i5 + 168 >> 2] | 0;
 } else {
  i3 = i2;
  i1 = i1 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i1);
 i3 = __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i7, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i3) {
  i1 = HEAP8[i4 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i5 + 168 >> 2] | 0;
  } else i1 = i1 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, i1);
  __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i7, i6, 1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i5 = i5 + 160 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 44 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, i1);
 i4 = __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i7, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (i4) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 44 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i3 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, i1);
 __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i7, i6, 1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i6 = i12 + 20 | 0;
 i4 = i12 + 16 | 0;
 i8 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc(i11, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i11 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i11 + 20 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 + 32 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i2 = _strtoull(i1, i6, 10) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i1 = 0;
    i9 = 14;
    break;
   }
   i1 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0) | 0;
   if (!i1) {
    i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i7 >> 2] = gb + 753858;
    i6 = i7 + 8 | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i6 + 4 >> 2] = i3;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i8, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i7);
    break;
   } else {
    i9 = 14;
    break;
   }
  }
  i1 = 0;
  i9 = 14;
 } else {
  i1 = 0;
  i9 = 14;
 } while (0);
 if ((i9 | 0) == 14) mftCall_vii(i8 | 0, HEAP32[i11 + 24 >> 2] | 0, i1 | 0);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i11 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i11 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN19RenderBufferManager14GarbageCollectEi(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 8 | 0;
 i11 = i15;
 i12 = i15 + 4 | 0;
 i13 = i9 + 32 | 0;
 i3 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
 HEAP32[i13 >> 2] = i3;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i9 | 0)) {
  STACKTOP = i15;
  return;
 }
 while (1) {
  i4 = i1;
  i7 = i3 - (HEAP32[i4 + 8 >> 2] | 0) | 0;
  if ((i7 | 0) > (i10 | 0) | (i7 | 0) < 0) {
   if ((HEAP16[gb + 1158304 + 6 >> 1] | 0) > -1) {
    HEAP32[i11 >> 2] = 0;
    HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158304 | 0, i8);
    i7 = gb + 1158304 | 0;
   } else i7 = 0;
   i6 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = i4 + 12 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i11 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i14 = 13; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i11);
      i3 = HEAP32[i8 >> 2] | 0;
      i16 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i16 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i14 = 13; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i14 = 15;
     }
    }
    if ((i14 | 0) == 13) i14 = 15;
    if ((i14 | 0) == 15) {
     i14 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __Z19DestroySingleObjectP6Object(i2);
   HEAP32[i12 >> 2] = i1;
   HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
   __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5eraseENS_21__list_const_iteratorIS9_PvEE(i9, i8) | 0;
   if (!i7) i1 = i6; else {
    __Z12profiler_endP19ProfilerInformation(i7);
    i1 = i6;
   }
  } else i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i9 | 0)) break;
  i3 = HEAP32[i13 >> 2] | 0;
 }
 STACKTOP = i15;
 return;
}

function __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj442ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 248 | 0, i6 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj443ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 264 | 0, i6 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj444ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 280 | 0, i6 + 3 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj445ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 296 | 0, i6 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj446ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 312 | 0, i6 + 5 | 0);
 i1 = i1 + 328 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj447ENS_22PxRepXPropertyAccessorILj447ES4_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 8 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 8 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 8 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 8 | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i4 + 12 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 40 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i4 + 52 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 68 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 80 | 0, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i4 + 92 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 108 | 0, gb + 1085935 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 120 | 0, gb + 902162 | 0, 0);
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i5 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 132 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i3;
  HEAP32[i6 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 136 >> 0] = i1;
 i1 = i4 + 137 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i8 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP32[i6 >> 2] = i3;
  i8 = i7;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN30VelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 618850 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618850 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 618874 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618874 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 618898 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618898 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN30RotationModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 617611 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617611 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617635 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617635 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617659 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617659 + 27 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN7mecanim5human10RemoveAxisEPKNS0_5HumanEiRKN4math7_float4E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i2 = i2 + 40 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i16 = i2 + 16 | 0;
 i2 = i2 + 4 | 0;
 i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
 i3 = i16 + (HEAP32[i16 >> 2] | 0) | 0;
 f9 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 76 | 0) + 16 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f13 * f8);
 f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f5 = Math_fround(f9 * f6);
 f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 76 | 0) + 20 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f11 * f12);
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + (i2 * 76 | 0) + 24 >> 2] ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f15 * f6)) - Math_fround(f9 * f12)) - Math_fround(f11 * f14));
 f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f13 * f14)) - Math_fround(f15 * f12)) - Math_fround(f11 * f8));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f15 * f8)) - Math_fround(f13 * f6)) - Math_fround(f9 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)) - Math_fround(f11 * f6)) - Math_fround(f9 * f8));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f8 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f8 * f8);
 f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f7 * f7);
 f6 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f10 + f9)))));
 f7 = Math_fround(f9 * f7);
 f6 = Math_fround(f9 * f6);
 f5 = Math_fround(f9 * f5);
 HEAPF32[i1 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f6;
 HEAPF32[i1 + 12 >> 2] = f5;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj(i14, i1, i12, i13) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 8 | 0;
 i9 = i15;
 i10 = i14 + 360 | 0;
 i6 = HEAP32[i14 + 364 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i7 = (HEAP32[i1 + 4 >> 2] | 0) - i11 >> 2 >>> 1;
 i8 = i12 - i13 + i6 + i7 | 0;
 if ((HEAP32[i14 + 368 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE8recreateEj(i10, i8);
 i5 = i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE6resizeEjRKS3_(i10, i8 >>> 0 > i6 >>> 0 ? i8 : i6, i2);
 if ((i8 | 0) != (i6 | 0)) {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i8 - i6 + i13 | 0;
  i5 = i1 >>> 0 > i13 >>> 0;
  i2 = i6 >>> 0 > i13 >>> 0;
  if (i5) if (i2) {
   i1 = i6;
   i2 = i8;
   do {
    i2 = i2 + -1 | 0;
    i1 = i1 + -1 | 0;
    i16 = i4 + (i1 << 3) | 0;
    i3 = HEAP32[i16 + 4 >> 2] | 0;
    i6 = i4 + (i2 << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i6 + 4 >> 2] = i3;
   } while (i1 >>> 0 > i13 >>> 0);
   i3 = 9;
  } else i3 = 10; else if (i2) {
   i2 = i13;
   while (1) {
    i17 = i4 + (i2 << 3) | 0;
    i2 = i2 + 1 | 0;
    i3 = HEAP32[i17 + 4 >> 2] | 0;
    i16 = i4 + (i1 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i16 + 4 >> 2] = i3;
    if ((i2 | 0) == (i6 | 0)) {
     i3 = 9;
     break;
    } else i1 = i1 + 1 | 0;
   }
  }
  if ((i3 | 0) == 9) if (i5) i3 = 10;
  if ((i3 | 0) == 10) {
   i1 = i7 + i12 | 0;
   i2 = i13;
   do {
    i7 = i11 + (i2 - i12 << 3) | 0;
    i16 = HEAP32[i7 + 4 >> 2] | 0;
    i17 = (HEAP32[i10 >> 2] | 0) + (i2 << 3) | 0;
    HEAP32[i17 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i17 + 4 >> 2] = i16;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  i17 = i9;
  HEAP32[i17 >> 2] = 0;
  HEAP32[i17 + 4 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE6resizeEjRKS3_(i10, i8, i9);
 }
 if (i12 >>> 0 >= i13 >>> 0) {
  i17 = i14 + 540 | 0;
  HEAP32[i17 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
 i1 = i12;
 do {
  i9 = i11 + (i1 - i12 << 3) | 0;
  i16 = HEAP32[i9 + 4 >> 2] | 0;
  i17 = (HEAP32[i10 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i17 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 i17 = i14 + 540 | 0;
 HEAP32[i17 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab18SerializedPropertyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 88 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471809 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab18SerializedProperty8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 88 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 471809 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab18SerializedProperty8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i2, i1, i8, i9, i5, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, i23 = 0, i24 = 0, i25 = 0;
 if (i5 >>> 0 >= i10 >>> 0) return;
 i6 = HEAP32[i1 + 500 >> 2] | 0;
 i7 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 i4 = i9 + 12 | 0;
 i2 = i2 + 80 | 0;
 i1 = i5;
 do {
  i24 = i6 + (i1 << 2) | 0;
  i5 = (HEAP32[i24 >> 2] | 0) + -13913692 | 0;
  i14 = (HEAP32[i24 + 4 >> 2] | 0) + -13913692 | 0;
  i19 = (HEAP32[i24 + 8 >> 2] | 0) + -13913692 | 0;
  i24 = (HEAP32[i24 + 12 >> 2] | 0) + -13913692 | 0;
  i12 = (Math_imul(i5, 1790253981) | 0) + 1900727103 | 0;
  i16 = (Math_imul(i14, 1790253981) | 0) + 1900727103 | 0;
  i23 = (Math_imul(i19, 1790253981) | 0) + 1900727103 | 0;
  i25 = (Math_imul(i24, 1790253981) | 0) + 1900727103 | 0;
  i5 = i5 << 11 ^ i5;
  i14 = i14 << 11 ^ i14;
  i19 = i19 << 11 ^ i19;
  i24 = i24 << 11 ^ i24;
  f20 = Math_fround(Math_fround((i12 ^ i5 ^ i5 >>> 8) & 8388607 ^ i12 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f21 = Math_fround(Math_fround((i16 ^ i14 ^ i14 >>> 8) & 8388607 ^ i16 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f22 = Math_fround(Math_fround((i23 ^ i19 ^ i19 >>> 8) & 8388607 ^ i23 >>> 19 | 0) * Math_fround(1.19209304e-07));
  f18 = Math_fround(Math_fround((i25 ^ i24 ^ i24 >>> 8) & 8388607 ^ i25 >>> 19 | 0) * Math_fround(1.19209304e-07));
  i25 = f20 > Math_fround(HEAPF32[i9 >> 2]);
  i24 = f21 > Math_fround(HEAPF32[i7 >> 2]);
  i23 = f22 > Math_fround(HEAPF32[i3 >> 2]);
  i19 = f18 > Math_fround(HEAPF32[i4 >> 2]);
  i16 = i8 + (i1 << 2) | 0;
  f18 = Math_fround(HEAPF32[i16 >> 2]);
  i14 = i16 + 4 | 0;
  f22 = Math_fround(HEAPF32[i14 >> 2]);
  i12 = i16 + 8 | 0;
  f21 = Math_fround(HEAPF32[i12 >> 2]);
  i5 = i16 + 12 | 0;
  f20 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(HEAPF32[i2 >> 2]);
  f17 = Math_fround((i25 ? Math_fround(1.0) : Math_fround(-1.0)) * f11);
  f15 = Math_fround(f11 * (i24 ? Math_fround(1.0) : Math_fround(-1.0)));
  f13 = Math_fround(f11 * (i23 ? Math_fround(1.0) : Math_fround(-1.0)));
  f15 = Math_fround(f22 + f15);
  f13 = Math_fround(f21 + f13);
  f11 = Math_fround(f20 + Math_fround(f11 * (i19 ? Math_fround(1.0) : Math_fround(-1.0))));
  HEAPF32[i16 >> 2] = Math_fround(f18 + f17);
  HEAPF32[i14 >> 2] = f15;
  HEAPF32[i12 >> 2] = f13;
  HEAPF32[i5 >> 2] = f11;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 return;
}

function _UNITY_FT_New_GlyphSlot(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i13 = i14;
 if (!i7) {
  i13 = 35;
  STACKTOP = i14;
  return i13 | 0;
 }
 i2 = i7 + 96 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i13 = 6;
  STACKTOP = i14;
  return i13 | 0;
 }
 i12 = HEAP32[i1 + 8 >> 2] | 0;
 i10 = _UNITY_ft_mem_alloc(i12, HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 44 >> 2] | 0, i13) | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) {
  if (!i8) {
   i13 = i1;
   STACKTOP = i14;
   return i13 | 0;
  }
  HEAP32[i8 >> 2] = 0;
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 i9 = i10 + 4 | 0;
 HEAP32[i9 >> 2] = i7;
 i2 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = _UNITY_ft_mem_alloc(i3, 40, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) {
  HEAP32[i10 + 156 >> 2] = i4;
  if (!(HEAP32[HEAP32[i2 >> 2] >> 2] & 512)) {
   i1 = _UNITY_FT_GlyphLoader_New(i3, i4) | 0;
   HEAP32[i6 >> 2] = i1;
   if (i1 | 0) {
    i11 = 9;
    break;
   }
  }
  i1 = HEAP32[i5 + 64 >> 2] | 0;
  if (!i1) HEAP32[i13 >> 2] = 0; else {
   i6 = mftCall_ii(i1 | 0, i10 | 0) | 0;
   HEAP32[i13 >> 2] = i6;
   if (i6 | 0) break;
  }
  i13 = i7 + 84 | 0;
  HEAP32[i10 + 8 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i10;
  if (!i8) {
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
  HEAP32[i8 >> 2] = i10;
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } else i11 = 9; while (0);
 if ((i11 | 0) == 9) HEAP32[i13 >> 2] = i1;
 i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + 96 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 68 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i10 | 0);
 i3 = i10 + 156 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i11 = 16; else if (!(HEAP32[i1 + 4 >> 2] & 1)) i11 = 16; else {
  i1 = i10 + 88 | 0;
  _UNITY_ft_mem_free(HEAP32[(HEAP32[i9 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i9 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & -2;
 }
 if ((i11 | 0) == 16) HEAP32[i10 + 88 >> 2] = 0;
 if (i1 | 0) {
  if (!(HEAP32[HEAP32[i2 >> 2] >> 2] & 512)) {
   _UNITY_FT_GlyphLoader_Done(HEAP32[i1 >> 2] | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
  }
  _UNITY_ft_mem_free(i4, i1);
  HEAP32[i3 >> 2] = 0;
 }
 _UNITY_ft_mem_free(i12, i10);
 i13 = HEAP32[i13 >> 2] | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN7SubMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 8 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  i9 = i6 + 20 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034420 | 0, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 8 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  i9 = i6 + 20 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034420 | 0, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i6 = i12 + 20 | 0;
 i4 = i12 + 16 | 0;
 i8 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i11, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i11 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i11 + 20 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 + 32 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i2 = _strtoull(i1, i6, 10) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i1 = 0;
    i9 = 14;
    break;
   }
   i1 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0) | 0;
   if (!i1) {
    i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i7 >> 2] = gb + 753780;
    i6 = i7 + 8 | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i6 + 4 >> 2] = i3;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i8, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i7);
    break;
   } else {
    i9 = 14;
    break;
   }
  }
  i1 = 0;
  i9 = 14;
 } else {
  i1 = 0;
  i9 = 14;
 } while (0);
 if ((i9 | 0) == 14) mftCall_vii(i8 | 0, HEAP32[i11 + 24 >> 2] | 0, i1 | 0);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i11 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i11 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __Z23XORDecryptFromHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_(i8, i4, i9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i3 = i4 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 i11 = i2 >>> 1;
 HEAP32[i13 >> 2] = 0;
 i12 = i13 + 4 | 0;
 i6 = gb + 63160 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = (i11 | 0) == 0;
 if (i10) i2 = 0; else {
  if (i2 >>> 0 < 4e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i11 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 1, gb + 64016 | 0, 0, gb + 585605 | 0, 986) | 0;
   i7 = gb + 64016 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i13 >> 2] = i2;
   i1 = i12;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i7;
   i1 = HEAP8[i3 >> 0] | 0;
  }
  i7 = i1 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i4;
  i6 = 0;
  do {
   i5 = i6 << 1;
   i3 = HEAP8[i7 + i5 >> 0] | 0;
   i1 = i3 << 24 >> 24;
   do if (i3 << 24 >> 24 < 58) i4 = (i1 << 4) + -768 | 0; else {
    i1 = i1 << 4;
    if (i3 << 24 >> 24 < 91) {
     i4 = i1 + -880 | 0;
     break;
    } else {
     i4 = i1 + 144 | 0;
     break;
    }
   } while (0);
   i1 = HEAP8[i7 + (i5 | 1) >> 0] | 0;
   i3 = i1 << 24 >> 24;
   do if (i1 << 24 >> 24 < 58) i1 = i3 + -48 | i4 & 255; else if (i1 << 24 >> 24 < 91) {
    i1 = i3 + -55 | i4 & 255;
    break;
   } else {
    i1 = i3 + 169 | i4;
    break;
   } while (0);
   HEAP8[i2 + i6 >> 0] = i1;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i11 | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i9, i11, 0);
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i4 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
 i3 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 if (i10) {
  i13 = HEAP32[i13 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
  STACKTOP = i14;
  return;
 } else i1 = 0;
 do {
  HEAP8[i3 + i1 >> 0] = HEAPU8[i2 + i1 >> 0] ^ (HEAPU8[i5 + ((i1 >>> 0) % (i4 >>> 0) | 0) >> 0] | 0) + i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 i13 = HEAP32[i13 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i12);
 STACKTOP = i14;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 40 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 370906 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI17SortingLayerEntryE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 370906 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI17SortingLayerEntryE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 84 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 843788 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN14HeightMeshData8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 84 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 843788 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14HeightMeshData8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 84 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN7mecanim9animation14AvatarConstant8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 905792 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 905809 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 905840 | 0, 0);
 i7 = i1 + 12 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 912312 | 0, 0);
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 16;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIjEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 905854 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim5human5HumanEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 905876 | 0, 0);
 i6 = i1 + 24 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 912334 | 0, 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 28;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i7;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 905890 | 0, 0);
 i7 = i1 + 32 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 912360 | 0, 0);
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 36;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 905916 | 0, 0);
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 905949 | 0, 0);
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 905971 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 84 | 0, gb + 905995 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 88 | 0, gb + 906016 | 0, 0);
 i6 = i1 + 92 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 912393 | 0, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 96;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i5;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906041 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim21prepareCollisionInputEPNS_10PxBaseTaskE(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16 + 4 | 0;
 i12 = i16;
 i14 = i17 + 360 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i13 = i17 + 368 | 0;
 i15 = (i11 << 3) + 8 | 0;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16 + 8 | 0, i15 + (HEAP32[i13 >> 2] << 4) | 0, gb + 683965 | 0, 810) | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = (i13 << 4) + i15;
 if (!(HEAP32[i14 >> 2] | 0)) {
  i17 = i17 + 56 | 0;
  i17 = HEAP32[i17 >> 2] | 0;
  i15 = HEAP32[i17 >> 2] | 0;
  i15 = i15 + 52 | 0;
  i15 = HEAP32[i15 >> 2] | 0;
  HEAP32[i12 >> 2] = i10;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  mftCall_vii(i15 | 0, i17 | 0, i9 | 0);
  STACKTOP = i16;
  return;
 }
 i11 = i17 + 356 | 0;
 i13 = i17 + 36 | 0;
 i1 = i10 + 8 | 0;
 i15 = 0;
 do {
  i6 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i15 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 + 44 >> 2];
  i8 = i1 + 4 | 0;
  i1 = i1 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  i2 = HEAP32[i6 + 36 >> 2] | 0;
  i6 = HEAP16[i6 + 42 >> 1] | 0;
  i7 = i2 + ((i6 & 65535) << 2) | 0;
  if (i6 << 16 >> 16) do {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!(HEAP8[(HEAP32[i3 + 40 >> 2] | 0) + 19 >> 0] | 0)) {
    i3 = HEAP32[i3 + 36 >> 2] | 0;
    i5 = i3 + 28 | 0;
    if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 64 >> 0] & 4)) {
     i6 = __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv(i3) | 0;
     i3 = (HEAP32[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i3) | 0) + 52 >> 2] | 0) + 16 | 0;
     if (i6) i4 = __ZNK5physx21PxsBodyTransformVault12getTransformERKNS_11PxsBodyCoreE((HEAP32[(HEAP32[i13 >> 2] | 0) + 1e3 >> 2] | 0) + 1444 | 0, i3) | 0; else i4 = 0;
     i18 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP8[i18 + 64 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i1 + 4 >> 2] = i18 + 32;
     HEAP32[i1 + 8 >> 2] = i4;
     HEAP8[i1 + 12 >> 0] = (i5 & 255) >>> 4 & 1;
     HEAP8[i1 + 13 >> 0] = i6 & 1;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     i1 = i1 + 16 | 0;
    }
   }
   i2 = i2 + 4 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  i15 = i15 + 1 | 0;
 } while (i15 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 i18 = i17 + 56 | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 i17 = i17 + 52 | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 mftCall_vii(i17 | 0, i18 | 0, i9 | 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE(i4, i5, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7;
 i6 = i4 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 80 >> 2] = 0;
 i11 = i4 + 16 | 0;
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 i1 = i4 + 32 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i4 + 192 >> 2] = i5;
 i6 = i5 + 40 | 0;
 i9 = i5 + 39 | 0;
 HEAP32[i4 + 200 >> 2] = (HEAP32[i6 >> 2] | 0) + ((HEAPU8[i9 >> 0] | 0) * 20 | 0);
 i8 = i5 + 38 | 0;
 HEAP8[i4 + 204 >> 0] = HEAP8[i8 >> 0] | 0;
 f15 = Math_fround(HEAPF32[i5 + 52 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 56 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 60 >> 2]);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(f15 * f13);
 f12 = Math_fround(f14 * f12);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f12 = f13 <= f12 ? f13 : f12;
 f10 = f12 <= f10 ? f12 : f10;
 HEAPF32[i11 >> 2] = Math_fround(f10 * Math_fround(.200000003));
 HEAPF32[i1 >> 2] = Math_fround(f10 * Math_fround(.100000001));
 __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_(i2, i3, i4 + 96 | 0, i4 + 144 | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = i4 + 196 | 0;
 HEAP32[i4 >> 2] = i1;
 i3 = ((HEAPU16[i5 + 36 >> 1] | 0) << 1) + ((HEAPU8[i9 >> 0] | 0) * 20 | 0) + ((HEAPU8[i8 >> 0] | 0) * 15 | 0) | 0;
 if ((i3 | 0) > 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i3;
  while (1) if ((i1 | 0) > 128) {
   i2 = i2 + 128 | 0;
   i1 = i1 + -128 | 0;
  } else break;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = (HEAP32[i1 + 8 >> 2] << 2) + (HEAPU16[i1 + 2 >> 1] | 0) + (HEAP32[i1 + 12 >> 2] | 0) | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2;
 while (1) if ((i1 | 0) > 128) {
  i3 = i3 + 128 | 0;
  i1 = i1 + -128 | 0;
 } else break;
 STACKTOP = i7;
 return;
}

function __ZN5Umbra20RuntimeTomeGeneratorD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 __ZN5Umbra20RuntimeStructBuilderD2Ev(i3 + 300 | 0);
 i1 = i3 + 288 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 284 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 292 >> 2] = 0;
 HEAP32[i3 + 296 >> 2] = 0;
 i1 = i3 + 272 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 268 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 276 >> 2] = 0;
 HEAP32[i3 + 280 >> 2] = 0;
 i1 = i3 + 248 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 244 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 252 >> 2] = 0;
 HEAP32[i3 + 256 >> 2] = 0;
 i1 = i3 + 232 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 228 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 236 >> 2] = 0;
 HEAP32[i3 + 240 >> 2] = 0;
 i1 = i3 + 180 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 176 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 184 >> 2] = 0;
 HEAP32[i3 + 188 >> 2] = 0;
 i1 = i3 + 164 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 160 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 168 >> 2] = 0;
 HEAP32[i3 + 172 >> 2] = 0;
 i1 = i3 + 148 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 144 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 152 >> 2] = 0;
 HEAP32[i3 + 156 >> 2] = 0;
 i1 = i3 + 132 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i3 + 128 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 136 >> 2] = 0;
 HEAP32[i3 + 140 >> 2] = 0;
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i4 = i3 + 72 | 0;
  HEAP32[i4 >> 2] = 0;
  i4 = i3 + 76 | 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i3 + 64 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = i3 + 72 | 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i3 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN26SizeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 617856 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617856 + 23 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617880 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617880 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 617900 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617900 + 19 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN14PhysicMaterial23GetInstantiatedMaterialEPS_R6Object(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 737252 | 0, 286) | 0;
  i8 = gb + 63520 | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
  HEAP32[i2 >> 2] = gb + 113008 + 8;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 52 >> 2] = 0;
  __Z19pop_allocation_rootv();
  i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, gb + 781428 | 0);
  HEAP32[i4 + 56 >> 2] = HEAP32[i1 + 4 >> 2];
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 0);
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i1 + 4 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
  i8 = i2;
  STACKTOP = i5;
  return i8 | 0;
 }
 i8 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 737252 | 0, 269) | 0;
 i9 = gb + 63520 | 0;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i8, i4, 0);
 HEAP32[i8 >> 2] = gb + 113008 + 8;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 0;
 __Z19pop_allocation_rootv();
 i8 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i8) | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0);
 __Z6AppendPKcS0_(i4, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, gb + 781416 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i8 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i8 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i1 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 0);
 STACKTOP = i5;
 return i8 | 0;
}

function __ZNK21FullParameterPreparer15OnPrepareMatrixER12PartialArrayI10Matrix4x4fERKN20GpuProgramParameters14ValueParameterEj(i4, i1, i6, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i3 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i9 = i14;
 HEAP32[i3 >> 2] = -1;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 __ZN9ShaderLab11shaderprops9GetMatrixEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i12, i10, i11, i13, i3);
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 i12 = HEAP16[i12 + 4 >> 1] | 0;
 i12 = i12 << 16 >> 16 == 0 ? 1 : i12;
 i13 = HEAP32[i6 + 8 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? 1 : i13 & 65535;
 HEAP16[i1 + 6 >> 1] = i13;
 HEAP16[i1 + 4 >> 1] = (i13 & 65535) < (i12 & 65535) ? i13 : i12;
 i12 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i12) {
  STACKTOP = i14;
  return 1;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i14;
  return 1;
 }
 if (!(11 >>> (i2 & 15) & 1)) {
  STACKTOP = i14;
  return 1;
 }
 i11 = (i1 | 0) == 4 ? -1 : HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i4 + 12 >> 2] | 0) + i5 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i12 + 40 | 0;
 i4 = i12 + 52 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i12 + 56 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 20 | 0, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i12 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 + (i5 * 20 | 0) >> 2] = i11;
 HEAP32[i9 + (i5 * 20 | 0) + 4 >> 2] = i2;
 HEAP32[i9 + (i5 * 20 | 0) + 8 >> 2] = i10;
 HEAP32[i9 + (i5 * 20 | 0) + 12 >> 2] = 0;
 HEAP16[i9 + (i5 * 20 | 0) + 16 >> 1] = i13;
 HEAP16[i9 + (i5 * 20 | 0) + 18 >> 1] = 0;
 i12 = i12 + 108 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + (i13 & 65535);
 STACKTOP = i14;
 return 1;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i6 = i12 + 20 | 0;
 i4 = i12 + 16 | 0;
 i8 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE8pushNameEPKc(i11, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i11 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i10 = i11 + 20 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 + 32 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i2 = _strtoull(i1, i6, 10) | 0;
   i3 = getTempRet0() | 0;
   if ((i2 | 0) == 0 & (i3 | 0) == 0) {
    i1 = 0;
    i9 = 14;
    break;
   }
   i1 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0) | 0;
   if (!i1) {
    i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i7 >> 2] = gb + 753930;
    i6 = i7 + 8 | 0;
    HEAP32[i6 >> 2] = i2;
    HEAP32[i6 + 4 >> 2] = i3;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i8, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i7);
    break;
   } else {
    i9 = 14;
    break;
   }
  }
  i1 = 0;
  i9 = 14;
 } else {
  i1 = 0;
  i9 = 14;
 } while (0);
 if ((i9 | 0) == 14) mftCall_vii(i8 | 0, HEAP32[i11 + 24 >> 2] | 0, i1 | 0);
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i11 + 36 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i11 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i12;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN16Physics2DManager12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP10Collider2Dj(i1, i24, i25, i26) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i27 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23 + 20 | 0;
 i20 = i23;
 i21 = i24 + 12 | 0;
 i1 = HEAP32[i21 >> 2] | 0;
 if (!i1) {
  STACKTOP = i23;
  return;
 }
 i17 = i20 + 4 | 0;
 i15 = i20 + 8 | 0;
 i16 = i20 + 12 | 0;
 i22 = i20 + 16 | 0;
 i18 = (i26 | 0) == 0;
 i14 = 0;
 do {
  i13 = HEAP32[i24 >> 2] | 0;
  i9 = i13 + (i14 * 144 | 0) + 16 | 0;
  i10 = i13 + (i14 * 144 | 0) + 32 | 0;
  i11 = i13 + (i14 * 144 | 0) + 64 | 0;
  i12 = i13 + (i14 * 144 | 0) + 80 | 0;
  i13 = i13 + (i14 * 144 | 0) + 128 | 0;
  if (i18) {
   HEAPF32[i22 >> 2] = Math_fround(1.0);
   i13 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i20 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i17 >> 2] = i13;
   i13 = HEAP32[i12 + 12 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i16 >> 2] = i13;
   HEAPF32[i22 >> 2] = Math_fround(1.0);
  } else {
   i6 = 0;
   do {
    i7 = HEAP32[i10 + (i6 << 2) >> 2] | 0;
    HEAP32[i20 >> 2] = HEAP32[i9 + (i6 << 2) >> 2];
    HEAP32[i17 >> 2] = i7;
    i7 = HEAP32[i12 + (i6 << 2) >> 2] | 0;
    HEAP32[i15 >> 2] = HEAP32[i11 + (i6 << 2) >> 2];
    HEAP32[i16 >> 2] = i7;
    HEAPF32[i22 >> 2] = Math_fround(1.0);
    i7 = i13 + (i6 << 2) | 0;
    i5 = 0;
    do {
     i1 = HEAP32[i25 + (i5 << 2) >> 2] | 0;
     i8 = i1 + 72 | 0;
     L12 : do if ((HEAP32[i8 >> 2] | 0) > 0) {
      i2 = i1 + 60 | 0;
      i1 = 0;
      while (1) {
       i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
       i3 = i4 + 32 | 0;
       i27 = HEAP32[i3 >> 2] | 0;
       i4 = i4 + 28 | 0;
       if (mftCall_iiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 16 >> 2] | 0, i27 | 0, (HEAP32[i4 >> 2] | 0) + 12 | 0, i20 | 0) | 0) break;
       i27 = HEAP32[i3 >> 2] | 0;
       i1 = i1 + 1 | 0;
       if (mftCall_iiiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 20 >> 2] | 0, i27 | 0, i19 | 0, i20 | 0, (HEAP32[i4 >> 2] | 0) + 12 | 0, 0) | 0) break;
       if ((i1 | 0) >= (HEAP32[i8 >> 2] | 0)) break L12;
      }
      HEAP32[i7 >> 2] = 1;
     } while (0);
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != (i26 | 0));
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != 4);
   i1 = HEAP32[i21 >> 2] | 0;
  }
  i14 = i14 + 1 | 0;
 } while (i14 >>> 0 < i1 >>> 0);
 STACKTOP = i23;
 return;
}

function __ZN13BoxCollider2D12SetPolygon2DEP9Polygon2D(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 f5 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f3 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f6 = Math_fround(-f5);
 f4 = Math_fround(-f3);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i11 = i1;
 if ((i2 - i1 | 0) > 0) {
  i10 = (i2 - i1 | 0) / 20 | 0;
  i9 = 0;
  do {
   i1 = HEAP32[i11 + (i9 * 20 | 0) + 12 >> 2] | 0;
   if (i1) {
    i15 = HEAP32[i11 + (i9 * 20 | 0) >> 2] | 0;
    i2 = i15 + (i1 << 3) | 0;
    i1 = i15;
    do {
     f7 = Math_fround(HEAPF32[i1 >> 2]);
     f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
     f5 = f7 < f5 ? f7 : f5;
     f3 = f8 < f3 ? f8 : f3;
     f6 = f6 < f7 ? f7 : f6;
     f4 = f4 < f8 ? f8 : f4;
     i1 = i1 + 8 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) < (i10 | 0));
 }
 f7 = Math_fround(Math_fround(f5 + f6) * Math_fround(.5));
 f8 = Math_fround(Math_fround(f3 + f4) * Math_fround(.5));
 f5 = Math_fround(f6 - f5);
 f3 = Math_fround(f4 - f3);
 f6 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 i1 = i12 + 40 | 0;
 f16 = Math_fround(f7 - Math_fround(HEAPF32[i1 >> 2]));
 i2 = i12 + 44 | 0;
 f4 = Math_fround(f8 - Math_fround(HEAPF32[i2 >> 2]));
 if (Math_fround(Math_fround(f16 * f16) + Math_fround(f4 * f4)) <= Math_fround(f6 * f6)) {
  HEAPF32[i13 >> 2] = f5;
  i15 = i13 + 4 | 0;
  HEAPF32[i15 >> 2] = f3;
  __ZN13BoxCollider2D7SetSizeERK8Vector2f(i12, i13);
  STACKTOP = i14;
  return;
 }
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i2 >> 2] = f8;
 __ZN10Collider2D19WakeAllBodyContactsEv(i12);
 i1 = HEAP32[i12 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i15 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 112 >> 2] | 0, i12 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i12, i15);
  if (!i15) {
   HEAPF32[i13 >> 2] = f5;
   i15 = i13 + 4 | 0;
   HEAPF32[i15 >> 2] = f3;
   __ZN13BoxCollider2D7SetSizeERK8Vector2f(i12, i13);
   STACKTOP = i14;
   return;
  }
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 140 >> 2] | 0, i12 | 0, 0);
  HEAPF32[i13 >> 2] = f5;
  i15 = i13 + 4 | 0;
  HEAPF32[i15 >> 2] = f3;
  __ZN13BoxCollider2D7SetSizeERK8Vector2f(i12, i13);
  STACKTOP = i14;
  return;
 }
 __ZN10Collider2D7CleanupEb(i12, 0);
 HEAPF32[i13 >> 2] = f5;
 i15 = i13 + 4 | 0;
 HEAPF32[i15 >> 2] = f3;
 __ZN13BoxCollider2D7SetSizeERK8Vector2f(i12, i13);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorIhNS_9allocatorIhEEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKhEES7_S7_(i12, i1, i13, i5) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i6 = i7;
 i14 = i7 + ((HEAP32[i1 >> 2] | 0) - i6) | 0;
 i4 = i5;
 i9 = i13;
 i8 = i4 - i9 | 0;
 if ((i8 | 0) <= 0) {
  i15 = i14;
  return i15 | 0;
 }
 i11 = i12 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i15 = i12 + 4 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 i1 = i10;
 if ((i8 | 0) <= (i2 - i1 | 0)) {
  i3 = i1 - i14 | 0;
  if ((i8 | 0) > (i3 | 0)) {
   i2 = i13 + i3 | 0;
   i1 = i4 - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i10 | 0, i2 | 0, i1 | 0) | 0;
    i1 = (HEAP32[i15 >> 2] | 0) + i1 | 0;
    HEAP32[i15 >> 2] = i1;
   } else i1 = i10;
   if ((i3 | 0) > 0) {
    i5 = i2;
    i4 = i1;
   } else {
    i15 = i14;
    return i15 | 0;
   }
  } else i4 = i10;
  i3 = i4 - (i14 + i8) | 0;
  i1 = i14 + i3 | 0;
  if (i1 >>> 0 < i10 >>> 0) {
   i2 = i4;
   do {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
    HEAP32[i15 >> 2] = i2;
   } while ((i1 | 0) != (i10 | 0));
  }
  if (i3 | 0) _memmove(i4 + (0 - i3) | 0, i14 | 0, i3 | 0) | 0;
  i1 = i5 - i9 | 0;
  if (!i1) {
   i15 = i14;
   return i15 | 0;
  }
  _memmove(i14 | 0, i13 | 0, i1 | 0) | 0;
  i15 = i14;
  return i15 | 0;
 }
 i3 = i1 - i6 + i8 | 0;
 if ((i3 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i6 = i1;
 } else i1 = i7;
 i10 = i2 - i6 | 0;
 i7 = i10 << 1;
 i3 = i10 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 i7 = i14;
 if (!i3) i4 = 0; else i4 = __Znwj(i3) | 0;
 i8 = i4 + (i7 - i6) | 0;
 i2 = i8;
 i6 = i4 + i3 | 0;
 if ((i13 | 0) != (i5 | 0)) {
  i3 = i13;
  i1 = i8;
  do {
   HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
   i1 = i2 + 1 | 0;
   i2 = i1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i3 = i7 - i1 | 0;
 i4 = i8 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i4 | 0, i1 | 0, i3 | 0) | 0;
 i3 = (HEAP32[i15 >> 2] | 0) - i7 | 0;
 if ((i3 | 0) > 0) {
  _memcpy(i2 | 0, i14 | 0, i3 | 0) | 0;
  i2 = i2 + i3 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i4;
 HEAP32[i15 >> 2] = i2;
 HEAP32[i11 >> 2] = i6;
 if (!i1) {
  i15 = i8;
  return i15 | 0;
 }
 __ZdlPv(i1);
 i15 = i8;
 return i15 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i4 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = -1;
   i1 = (HEAP32[i7 >> 2] | 0) + 32 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = (i1 - i5 >> 5) + i2 | 0;
 if (i6 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = i4 - i5 | 0;
 i3 = i7 >> 4;
 i3 = i7 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 134217727;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 << 5) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (i1 - i5 >> 5 << 5) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 << 5);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = -1;
  i1 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -32 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -20 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN26AnimatorControllerPlayable20GetAnimatorStateNameEib(i7, i6, i4, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = i8 + 4 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0) | 0) {
  if ((i4 | 0) >= 0) {
   if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0) | 0) i1 = HEAP32[HEAP32[i6 + 92 >> 2] >> 2] | 0; else i1 = 0;
   if ((i1 | 0) > (i4 | 0)) {
    i1 = HEAP32[i6 + 92 >> 2] | 0;
    if (!i1) {
     i3 = 0;
     i1 = 4;
     i2 = HEAP32[1] | 0;
    } else {
     i3 = i1 + 12 | 0;
     i2 = i1 + 4 | 0;
     i1 = i2;
     i2 = HEAP32[i2 >> 2] | 0;
     i9 = i2 + i1 + (i4 << 2) | 0;
     i9 = (HEAP32[i3 >> 2] | 0) + i3 + (HEAP32[i9 + (HEAP32[i9 >> 2] | 0) >> 2] << 2) | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i3 = (i3 | 0) == 0 ? 0 : i9 + i3 | 0;
    }
    i10 = (HEAP32[i6 + 100 >> 2] | 0) + 4 | 0;
    i9 = i2 + i1 + (i4 << 2) | 0;
    i9 = (HEAP32[i10 >> 2] | 0) + i10 + (HEAP32[i9 + (HEAP32[i9 >> 2] | 0) >> 2] << 2) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i1 = (i1 | 0) == 0 ? 0 : i9 + i1 | 0;
    do if (i5) i1 = i1 + 8 | 0; else if (!(HEAP8[i1 + 81 >> 0] | 0)) {
     i1 = i3;
     break;
    } else {
     i1 = i1 + 12 | 0;
     break;
    } while (0);
    i1 = HEAP32[i1 >> 2] | 0;
    if (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
     i9 = HEAP32[i6 + 84 >> 2] | 0;
     i10 = i3 + 4 | 0;
     i10 = (HEAP32[i10 >> 2] | 0) + i10 + (i1 << 2) | 0;
     mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 104 >> 2] | 0, i7 | 0, i9 | 0, HEAP32[i10 + (HEAP32[i10 >> 2] | 0) + 28 >> 2] | 0);
     STACKTOP = i8;
     return;
    } else {
     HEAP32[i7 >> 2] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
     HEAP32[i7 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1576256 | 0, 0);
     STACKTOP = i8;
     return;
    }
   }
  }
  HEAP32[i2 >> 2] = i4;
  __Z6FormatPKcz(i3, gb + 902210 | 0, i2);
  i1 = HEAP32[i6 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1576256 | 0, 0);
 STACKTOP = i8;
 return;
}

function __ZN13RenderTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 80 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 88 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 96 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 117 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 118 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZN11UnityEngine9Animation14GenericBinding8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898362 | 0, i7, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898367 | 0, i7, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898377 | 0, HEAP32[gb + 37176 >> 2] | 0, i7, 0);
 i6 = i8 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898384 | 0, HEAP32[gb + 37288 >> 2] | 0, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898392 | 0, i6, i1 + 14 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898403 | 0, i6, i1 + 15 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z49WebCamTexture_CUSTOM_Internal_CreateWebCamTextureP12Il2CppObjectP12Il2CppStringiii(i3, i1, i4, i5, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i2 = i9;
 i10 = i9 + 20 | 0;
 i7 = i9 + 8 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i10, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i10);
 if (__Z24IsWebCamDeviceRegisteredRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7) | 0) i1 = __Z19CreateWebCamTextureRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7) | 0; else {
  i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(128, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 894914 | 0, 29) | 0;
  i12 = gb + 63520 | 0;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i10 = i2;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN16BaseVideoTextureC2E10MemLabelId18ObjectCreationMode(i1, i8, 0);
  i10 = i1 + 96 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  HEAP32[i10 + 16 >> 2] = 0;
  HEAP32[i10 + 20 >> 2] = 0;
  HEAP32[i1 >> 2] = gb + 25856 + 8;
  HEAP8[i1 + 120 >> 0] = 0;
  HEAP32[i1 + 124 >> 2] = 0;
  __Z19pop_allocation_rootv();
  i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i3, i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 HEAP32[i1 + 96 >> 2] = i4;
 HEAP32[i1 + 100 >> 2] = i5;
 HEAPF32[i1 + 104 >> 2] = Math_fround(i6 | 0);
 i12 = HEAP8[i7 + 11 >> 0] | 0;
 if ((i12 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i12 & 255) | 0) {
  i12 = i1 + 108 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i12, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i9;
  return;
 }
 __ZNK17BaseWebCamTexture9GetDeviceEv(i8, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i12 = i1 + 108 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i12, i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 HEAP32[i2 >> 2] = i1;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(-f7);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(-f5);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(-f4);
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f9;
 HEAPF32[i2 + 16 >> 2] = f7;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f9;
 HEAPF32[i2 + 28 >> 2] = f7;
 HEAPF32[i2 + 32 >> 2] = f5;
 HEAPF32[i2 + 36 >> 2] = f9;
 HEAPF32[i2 + 40 >> 2] = f6;
 HEAPF32[i2 + 44 >> 2] = f5;
 HEAPF32[i2 + 48 >> 2] = f9;
 HEAPF32[i2 + 52 >> 2] = f6;
 HEAPF32[i2 + 56 >> 2] = f8;
 HEAPF32[i2 + 60 >> 2] = f4;
 HEAPF32[i2 + 64 >> 2] = f7;
 HEAPF32[i2 + 68 >> 2] = f8;
 HEAPF32[i2 + 72 >> 2] = f4;
 HEAPF32[i2 + 76 >> 2] = f7;
 HEAPF32[i2 + 80 >> 2] = f5;
 HEAPF32[i2 + 84 >> 2] = f4;
 HEAPF32[i2 + 88 >> 2] = f6;
 HEAPF32[i2 + 92 >> 2] = f5;
 HEAPF32[i2 + 96 >> 2] = f4;
 HEAP8[i2 + 118 >> 0] = 4;
 HEAP16[i2 + 116 >> 1] = 0;
 HEAP8[i2 + 138 >> 0] = 4;
 HEAP16[i2 + 136 >> 1] = 4;
 HEAP8[i2 + 158 >> 0] = 4;
 HEAP16[i2 + 156 >> 1] = 8;
 HEAP8[i2 + 178 >> 0] = 4;
 HEAP16[i2 + 176 >> 1] = 12;
 HEAP8[i2 + 198 >> 0] = 4;
 HEAP16[i2 + 196 >> 1] = 16;
 HEAP8[i2 + 218 >> 0] = 4;
 HEAP16[i2 + 216 >> 1] = 20;
 HEAP32[i2 + 120 >> 2] = 1065353216;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i2 + 132 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP32[i2 + 160 >> 2] = -1082130432;
 HEAP32[i2 + 164 >> 2] = 0;
 HEAP32[i2 + 168 >> 2] = 0;
 HEAPF32[i2 + 172 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP8[i2 + 139 >> 0] = 0;
 HEAP8[i2 + 179 >> 0] = 1;
 HEAP32[i2 + 180 >> 2] = 0;
 HEAP32[i2 + 184 >> 2] = 1065353216;
 HEAP32[i2 + 188 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAPF32[i2 + 192 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i2 + 204 >> 2] = -1082130432;
 HEAP32[i2 + 208 >> 2] = 0;
 HEAPF32[i2 + 212 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 HEAP8[i2 + 199 >> 0] = 0;
 HEAP8[i2 + 219 >> 0] = 2;
 HEAP32[i2 + 140 >> 2] = 0;
 HEAP32[i2 + 144 >> 2] = 0;
 HEAP32[i2 + 148 >> 2] = 1065353216;
 i1 = i1 + 8 | 0;
 HEAPF32[i2 + 152 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = -1082130432;
 HEAPF32[i2 + 112 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP8[i2 + 159 >> 0] = 0;
 HEAP8[i2 + 119 >> 0] = 4;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034351 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI11KeyframeTplIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034351 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI11KeyframeTplIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNK21FullParameterPreparer15OnPrepareVectorER12PartialArrayI8Vector4fERKN20GpuProgramParameters14ValueParameterEj(i4, i1, i6, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i3 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i9 = i14;
 HEAP32[i3 >> 2] = -1;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 __ZN9ShaderLab11shaderprops9GetVectorEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i12, i10, i11, i13, i3);
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 i12 = HEAP16[i12 + 4 >> 1] | 0;
 i12 = i12 << 16 >> 16 == 0 ? 1 : i12;
 i13 = HEAP32[i6 + 8 >> 2] | 0;
 i13 = (i13 | 0) == 0 ? 1 : i13 & 65535;
 HEAP16[i1 + 6 >> 1] = i13;
 HEAP16[i1 + 4 >> 1] = (i13 & 65535) < (i12 & 65535) ? i13 : i12;
 i12 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i12) {
  STACKTOP = i14;
  return 1;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i14;
  return 1;
 }
 if (!(11 >>> (i2 & 15) & 1)) {
  STACKTOP = i14;
  return 1;
 }
 i11 = (i1 | 0) == 4 ? -1 : HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i4 + 12 >> 2] | 0) + i5 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i12 + 20 | 0;
 i4 = i12 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i12 + 36 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 20 | 0, 4, i12 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i12 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 + (i5 * 20 | 0) >> 2] = i11;
 HEAP32[i9 + (i5 * 20 | 0) + 4 >> 2] = i2;
 HEAP32[i9 + (i5 * 20 | 0) + 8 >> 2] = i10;
 HEAP32[i9 + (i5 * 20 | 0) + 12 >> 2] = 0;
 HEAP16[i9 + (i5 * 20 | 0) + 16 >> 1] = i13;
 HEAP16[i9 + (i5 * 20 | 0) + 18 >> 1] = 0;
 i12 = i12 + 104 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + (i13 & 65535);
 STACKTOP = i14;
 return 1;
}

function __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i3 = i6;
 i13 = i6 + ((HEAP32[i2 >> 2] | 0) - i3 >> 2 << 2) | 0;
 i14 = i12 + 4 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i4 = i12 + 8 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 i2 = i7;
 i5 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i13 | 0) == (i7 | 0)) {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 >> 2] = i13 + 4;
   i14 = i13;
   return i14 | 0;
  }
  i4 = i2 - (i13 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i13 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i6 = (i7 + (0 - i5 << 2) + ~i13 | 0) >>> 2;
   i3 = i7;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
   }
   HEAP32[i14 >> 2] = i7 + (i6 + 1 << 2);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i13 | 0, i4 | 0) | 0;
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  i14 = i13;
  return i14 | 0;
 }
 i7 = (i2 - i3 >> 2) + 1 | 0;
 if (i7 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i3 = HEAP32[i12 >> 2] | 0;
  i11 = i4;
  i6 = i3;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i11 = i4;
  i2 = i5;
 }
 i10 = i2 - i3 | 0;
 i8 = i10 >> 1;
 i8 = i10 >> 2 >>> 0 < 536870911 ? (i8 >>> 0 < i7 >>> 0 ? i7 : i8) : 1073741823;
 i10 = i13;
 i4 = i10 - i3 | 0;
 i5 = i4 >> 2;
 if (!i8) i9 = 0; else i9 = __Znwj(i8 << 2) | 0;
 i2 = i9 + (i5 << 2) | 0;
 i3 = i2;
 i7 = i9 + (i8 << 2) | 0;
 do if ((i5 | 0) == (i8 | 0)) {
  if ((i4 | 0) > 0) {
   i2 = i2 + (((i8 + 1 | 0) / -2 | 0) << 2) | 0;
   i3 = i2;
   break;
  }
  i2 = i8 << 2 >> 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  i8 = __Znwj(i2 << 2) | 0;
  i4 = i8 + (i2 >>> 2 << 2) | 0;
  i3 = i4;
  i2 = i8 + (i2 << 2) | 0;
  if (!i9) {
   i7 = i2;
   i2 = i4;
  } else {
   __ZdlPv(i9);
   i7 = i2;
   i2 = i4;
   i6 = HEAP32[i12 >> 2] | 0;
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i2 = i10 - i6 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i4 | 0, i6 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i13 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i7;
 if (!i2) {
  i14 = i3;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i3;
 return i14 | 0;
}

function __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i3 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i4 + 4 | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i7;
  i1 = i3;
  i7 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i5;
  i5 = i4 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i7;
  i5 = i3 + 8 | 0;
  i7 = i4 + 12 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i7 >> 2] = i6;
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i7;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 do {
  i8 = i2 + -156 | 0;
  i9 = i1;
  i1 = i1 + -156 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i2 + -136 >> 2] = HEAP32[i9 + -136 >> 2];
  HEAP32[i2 + -132 >> 2] = HEAP32[i9 + -132 >> 2];
  HEAP32[i2 + -128 >> 2] = HEAP32[i9 + -128 >> 2];
  HEAP32[i2 + -124 >> 2] = HEAP32[i9 + -124 >> 2];
  HEAP32[i2 + -120 >> 2] = HEAP32[i9 + -120 >> 2];
  HEAP32[i2 + -116 >> 2] = HEAP32[i9 + -116 >> 2];
  HEAP32[i2 + -112 >> 2] = HEAP32[i9 + -112 >> 2];
  HEAP32[i2 + -108 >> 2] = HEAP32[i9 + -108 >> 2];
  HEAP32[i2 + -104 >> 2] = HEAP32[i9 + -104 >> 2];
  __ZN13dynamic_arrayIfLj4EEC2ERKS0_(i2 + -100 | 0, i9 + -100 | 0);
  __ZN13dynamic_arrayIP8MaterialLj4EEC2ERKS2_(i2 + -80 | 0, i9 + -80 | 0);
  __ZN13dynamic_arrayI10ColorRGBAfLj4EEC2ERKS1_(i2 + -60 | 0, i9 + -60 | 0);
  __ZN13dynamic_arrayIP8MaterialLj4EEC2ERKS2_(i2 + -40 | 0, i9 + -40 | 0);
  i8 = i2 + -20 | 0;
  i9 = i9 + -20 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  i2 = (HEAP32[i7 >> 2] | 0) + -156 | 0;
  HEAP32[i7 >> 2] = i2;
 } while ((i1 | 0) != (i5 | 0));
 i9 = i7;
 i7 = i3;
 i5 = i2;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i9 >> 2] = i8;
 i8 = i4 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i6 = i3 + 8 | 0;
 i8 = i4 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i4 >> 2] = i9;
 return;
}

function __ZNK5Umbra6Portal7getQuadERKNS_7Vector3ES3_fRS1_S4_S4_S4_(i1, i2, i3, f4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i10 = (HEAP32[i1 >> 2] | 0) >>> 30;
 f16 = Math_fround(HEAP32[i1 + 4 >> 2] & 65535 | 0);
 f15 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
 f16 = Math_fround(f15 * f16);
 f14 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[gb + 1451432 + 12 >> 2]);
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 f15 = Math_fround(f15 * Math_fround(i9 >>> 16 | 0));
 f14 = Math_fround(f14 * Math_fround(i9 & 65535 | 0));
 f13 = Math_fround(f13 * Math_fround(i1 >>> 16 | 0));
 f12 = Math_fround(f12 * Math_fround(i1 & 65535 | 0));
 f17 = Math_fround(HEAPF32[i2 + (i10 << 2) >> 2]);
 f16 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f16) * f17) + Math_fround(f16 * Math_fround(HEAPF32[i3 + (i10 << 2) >> 2])));
 HEAPF32[i7 + (i10 << 2) >> 2] = f16;
 HEAPF32[i5 + (i10 << 2) >> 2] = f16;
 i1 = ((i10 + 1 | 0) >>> 0) % 3 | 0;
 i9 = i2 + (i1 << 2) | 0;
 f16 = Math_fround(HEAPF32[i9 >> 2]);
 i11 = i3 + (i1 << 2) | 0;
 HEAPF32[i5 + (i1 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f15) * f16) + Math_fround(f15 * Math_fround(HEAPF32[i11 >> 2]))) - f4);
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 i9 = i7 + (i1 << 2) | 0;
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f14) * f15) + Math_fround(f14 * Math_fround(HEAPF32[i11 >> 2]))) + f4);
 i11 = ((i1 + 1 | 0) >>> 0) % 3 | 0;
 i2 = i2 + (i11 << 2) | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i3 + (i11 << 2) | 0;
 HEAPF32[i5 + (i11 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f13) * f14) + Math_fround(f13 * Math_fround(HEAPF32[i3 >> 2]))) - f4);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i7 + (i11 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f12) * f13) + Math_fround(f12 * Math_fround(HEAPF32[i3 >> 2]))) + f4);
 i3 = ((i10 + 2 | 0) >>> 0) % 3 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + (i3 << 2) >> 2] = HEAP32[i7 + (i3 << 2) >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
 return;
}

function __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14;
 __ZNK9Transform18GetWorldScaleLossyEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i1 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i1 + 8 >> 2]));
 i7 = i13 + 4 | 0;
 i8 = i13 + 8 | 0;
 f3 = Math_fround(Math_fround(HEAPF32[i6 + 72 >> 2]) * f3);
 f4 = Math_fround(Math_fround(HEAPF32[i6 + 76 >> 2]) * f4);
 f3 = Math_fround(f3 * Math_fround(.5));
 f4 = Math_fround(f4 * Math_fround(.5));
 f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i6 + 80 >> 2]) * f5) * Math_fround(.5));
 i12 = f3 < Math_fround(0.0);
 f9 = Math_fround(-f3);
 f9 = i12 ? f9 : f3;
 i12 = f4 < Math_fround(0.0);
 f10 = Math_fround(-f4);
 f10 = i12 ? f10 : f4;
 i12 = f5 < Math_fround(0.0);
 f11 = Math_fround(-f5);
 f11 = i12 ? f11 : f5;
 HEAPF32[i13 >> 2] = f9;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f11;
 i12 = i6 + 84 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i2 = i6 + 88 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 if (HEAP32[i6 + 36 >> 2] | 0) if (f3 != f9 | f4 != f10 | f5 != f11) {
  HEAP32[i6 + 96 >> 2] = gb + 733158;
  HEAP32[i6 + 100 >> 2] = i6;
  HEAP8[i6 + 104 >> 0] = 1;
  i2 = (__Z17GetPhysicsManagerv() | 0) + 716 | 0;
  if ((i12 | 0) != (i2 | 0)) {
   i1 = HEAP32[i12 >> 2] | 0;
   if (!i1) i1 = i6 + 88 | 0; else {
    i6 = i6 + 88 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
    HEAP32[i12 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    i1 = i6;
   }
   i6 = HEAP32[i2 >> 2] | 0;
   HEAP32[i12 >> 2] = i6;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i12;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i12;
  }
 }
 i12 = f9 > Math_fround(1.1920929e-07);
 f9 = i12 ? f9 : Math_fround(1.1920929e-07);
 i12 = f10 > Math_fround(1.1920929e-07);
 f10 = i12 ? f10 : Math_fround(1.1920929e-07);
 i12 = f11 > Math_fround(1.1920929e-07);
 f11 = i12 ? f11 : Math_fround(1.1920929e-07);
 HEAPF32[i13 >> 2] = f9;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f11;
 STACKTOP = i14;
 return;
}

function __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i5 = i1 + 32 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946425 | 0, gb + 737343 | 0, i5, 0);
  i6 = i3 + 8 | 0;
  i7 = i6;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
  i5 = i2 + 16 | 0;
  i3 = i2 + 24 | 0;
  HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
  HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 }
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0) {
  i3 = HEAP32[gb + 36972 >> 2] | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800918 | 0, i3, i1 + 40 | 0, 0);
  i6 = i2 + 16 | 0;
  i7 = i2 + 24 | 0;
  HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  i5 = i1 + 41 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i3, i5, 257);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i6 + (i7 * 24 | 0) + 12 | 0;
  HEAP32[i7 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
  STACKTOP = i4;
  return;
 } else {
  i7 = i2 + 24 | 0;
  i6 = i2 + 16 | 0;
  i3 = HEAP32[gb + 36972 >> 2] | 0;
  i5 = i1 + 41 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, i3, i5, 257);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i6 + (i7 * 24 | 0) + 12 | 0;
  HEAP32[i7 >> 2] = 1;
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx6shdfnd18integrateTransformERKNS_11PxTransformERKNS_6PxVec3ES6_fRS1_(i7, i1, i3, f9, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 f9 = Math_fround(f9);
 i8 = i8 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f6 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f9);
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f9);
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f9);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i7 + 16 >> 2]));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i7 + 20 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i7 + 24 >> 2]));
 HEAPF32[i8 + 16 >> 2] = f6;
 HEAPF32[i8 + 20 >> 2] = f2;
 HEAPF32[i8 + 24 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f6 * f6));
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f4 * f4));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_sqrt(Math_fround(f2)));
  if (f2 != Math_fround(0.0)) {
   f11 = Math_fround(Math_fround(f2 * f9) * Math_fround(.5));
   f10 = Math_fround(+Math_cos(+f11));
   f11 = Math_fround(Math_fround(+Math_sin(+f11)) / f2);
   f15 = Math_fround(f5 * f11);
   f14 = Math_fround(f6 * f11);
   f11 = Math_fround(f4 * f11);
   f4 = Math_fround(HEAPF32[i7 >> 2]);
   f12 = Math_fround(f4 * Math_fround(0.0));
   f9 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f15 * f9));
   f13 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f12 = Math_fround(f12 + Math_fround(f14 * f13));
   f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
   f5 = Math_fround(Math_fround(f10 * f2) + Math_fround(Math_fround(Math_fround(f4 * f11) + Math_fround(Math_fround(f14 * f9) + Math_fround(f2 * Math_fround(0.0)))) - Math_fround(f15 * f13)));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f2) + Math_fround(Math_fround(f11 * f9) + Math_fround(f13 * Math_fround(0.0)))) - Math_fround(f4 * f14)) + Math_fround(f10 * f13));
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(0.0)) - Math_fround(f4 * f15)) - Math_fround(f14 * f2)) - Math_fround(f11 * f13)) + Math_fround(f10 * f9));
   HEAPF32[i8 >> 2] = Math_fround(Math_fround(f12 - Math_fround(f11 * f2)) + Math_fround(f10 * f4));
   HEAPF32[i8 + 4 >> 2] = f5;
   HEAPF32[i8 + 8 >> 2] = f6;
   HEAPF32[i8 + 12 >> 2] = f9;
   return;
  }
 }
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 return;
}

function __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i10, i1, i3, i4) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i11 + 272 | 0;
 i9 = __ZNK5physx2Sc8BodyCore6getSimEv(i1) | 0;
 if (!i9) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 + 1236 >> 2] | 0;
 do if (!i1) {
  i2 = i5 + 256 | 0;
  i1 = i5 + 260 | 0;
  HEAP32[i5 + 264 >> 2] = 0;
  i8 = i5 + 268 | 0;
  HEAP8[i2 >> 0] = 1;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = 64;
  __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb(i10, i9, i5, i3, i4);
  i8 = HEAP32[i8 >> 2] | 0;
  if (!((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0)) break;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) == (i1 | 0)) HEAP8[i2 >> 0] = 0; else if (i1 | 0) {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
  }
 } else __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb(i10, i9, i1, i3, i4); while (0);
 i7 = HEAP32[i10 + 1220 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
 i8 = i7 + 24 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) i1 = i7 + 16 | 0; else {
  i1 = i7 + 16 | 0;
  __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i5, i6, 32);
 }
 i5 = Math_imul(HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 L20 : do if ((i1 | 0) >= 0) {
  i6 = HEAP32[i7 + 12 >> 2] | 0;
  i2 = 0;
  i4 = i1;
  L22 : while (1) {
   while (1) {
    i1 = i2 + i4 >> 1;
    i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
    if (i3 >>> 0 <= i9 >>> 0 & (i3 + i5 | 0) >>> 0 > i9 >>> 0) break L22;
    if (i3 >>> 0 >= i9 >>> 0) break;
    if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else break L20;
   }
   i1 = i1 + -1 | 0;
   if ((i2 | 0) > (i1 | 0)) break L20; else i4 = i1;
  }
  i6 = i6 + (i1 * 12 | 0) + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i9;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i7 + 8 >> 2] = i1;
  HEAP8[i8 >> 0] = 0;
 } while (0);
 i10 = i10 + 1420 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 STACKTOP = i11;
 return;
}

function __ZNK11UnityEngine9Animation28GenericAnimationBindingCache38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i9, i10, i13, i16) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 i7 = HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i13 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
 i11 = i10 + 12 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i8 = i7 + -1e5 | 0;
  i12 = i10 + 20 | 0;
  i14 = i9 + 11 | 0;
  i15 = i9 + 4 | 0;
  if ((i7 | 0) > 99999) {
   i6 = 0;
   while (1) {
    i4 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i4 + (i6 << 3) >> 2] | 0;
    i5 = HEAP32[i1 + 24 >> 2] | 0;
    if ((i3 | 0) > 99999) i1 = i5 + (i3 + -1e5 << 3) | 0; else i1 = (HEAP32[i1 + 4 >> 2] | 0) + (i3 << 3) | 0;
    if (((HEAP32[i5 + (i8 << 3) >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
     i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (HEAP32[i4 + (i6 << 3) + 4 >> 2] << 2) >> 2] | 0;
     mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, i1 | 0, i13 | 0, i16 | 0);
     i1 = HEAP8[i14 >> 0] | 0;
     if (i1 << 24 >> 24 < 0) i1 = HEAP32[i15 >> 2] | 0; else i1 = i1 & 255;
     if (i1 | 0) break;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     i2 = HEAP32[i11 >> 2] | 0;
    }
    i1 = i6 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
    i6 = i1;
    i1 = HEAP32[gb + 1110260 >> 2] | 0;
   }
   return;
  } else {
   i6 = 0;
   while (1) {
    i4 = HEAP32[i10 >> 2] | 0;
    i3 = HEAP32[i4 + (i6 << 3) >> 2] | 0;
    i5 = HEAP32[i1 + 4 >> 2] | 0;
    if ((i3 | 0) > 99999) i1 = (HEAP32[i1 + 24 >> 2] | 0) + (i3 + -1e5 << 3) | 0; else i1 = i5 + (i3 << 3) | 0;
    if (((HEAP32[i5 + (i7 << 3) >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
     i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (HEAP32[i4 + (i6 << 3) + 4 >> 2] << 2) >> 2] | 0;
     mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, i1 | 0, i13 | 0, i16 | 0);
     i1 = HEAP8[i14 >> 0] | 0;
     if (i1 << 24 >> 24 < 0) i1 = HEAP32[i15 >> 2] | 0; else i1 = i1 & 255;
     if (i1 | 0) break;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
     i2 = HEAP32[i11 >> 2] | 0;
    }
    i1 = i6 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
    i6 = i1;
    i1 = HEAP32[gb + 1110260 >> 2] | 0;
   }
   return;
  }
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 return;
}

function __ZN9ShaderLab9IntShader15ResolveFallbackERKNS_16SerializedShaderEP6ShaderRNSt3__26vectorI4PPtrIS4_ENS6_9allocatorIS9_EEEEb(i12, i5, i1, i3, i4) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i7 = i13;
 i11 = i13 + 16 | 0;
 i1 = i12 + 120 | 0;
 i8 = i1 + 11 | 0;
 i2 = HEAP8[i8 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i2 = HEAP32[i12 + 124 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 i2 = __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb(i1, i3, i4) | 0;
 if (!i2) {
  i2 = i5 + 24 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i1;
  _printf_console(gb + 481412 | 0, i6);
  STACKTOP = i13;
  return;
 }
 i10 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i10) {
  i2 = i5 + 24 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i1;
  _printf_console(gb + 481363 | 0, i7);
  STACKTOP = i13;
  return;
 }
 i7 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i1 = i3 >> 2;
 i8 = i10 + 4 | 0;
 i4 = ((HEAP32[i8 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) >> 2) + i1 | 0;
 i9 = i12 + 8 | 0;
 if ((HEAP32[i9 >> 2] | 0) - i2 >> 2 >>> 0 < i4 >>> 0) {
  if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
  i5 = i6 + (i1 << 2) | 0;
  i1 = i5 + (0 - i1 << 2) | 0;
  if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i9 >> 2] = i6 + (i4 << 2);
  if (i2 | 0) __ZdlPv(i2);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i13;
  return;
 }
 i3 = 0;
 do {
  i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
  i1 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63280 | 0, 16, gb + 481282 | 0, 65) | 0;
  __ZN9ShaderLab9SubShaderC2ERKS0_(i1, i2);
  HEAP32[i11 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i12, i11); else {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
  }
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } while (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i13;
 return;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 HEAP32[i2 >> 2] = i1;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(-f7);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(-f5);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(-f4);
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f9;
 HEAPF32[i2 + 16 >> 2] = f7;
 HEAPF32[i2 + 20 >> 2] = f8;
 HEAPF32[i2 + 24 >> 2] = f9;
 HEAPF32[i2 + 28 >> 2] = f7;
 HEAPF32[i2 + 32 >> 2] = f5;
 HEAPF32[i2 + 36 >> 2] = f9;
 HEAPF32[i2 + 40 >> 2] = f6;
 HEAPF32[i2 + 44 >> 2] = f5;
 HEAPF32[i2 + 48 >> 2] = f9;
 HEAPF32[i2 + 52 >> 2] = f6;
 HEAPF32[i2 + 56 >> 2] = f8;
 HEAPF32[i2 + 60 >> 2] = f4;
 HEAPF32[i2 + 64 >> 2] = f7;
 HEAPF32[i2 + 68 >> 2] = f8;
 HEAPF32[i2 + 72 >> 2] = f4;
 HEAPF32[i2 + 76 >> 2] = f7;
 HEAPF32[i2 + 80 >> 2] = f5;
 HEAPF32[i2 + 84 >> 2] = f4;
 HEAPF32[i2 + 88 >> 2] = f6;
 HEAPF32[i2 + 92 >> 2] = f5;
 HEAPF32[i2 + 96 >> 2] = f4;
 HEAP8[i2 + 118 >> 0] = 4;
 HEAP16[i2 + 116 >> 1] = 0;
 HEAP8[i2 + 138 >> 0] = 4;
 HEAP16[i2 + 136 >> 1] = 4;
 HEAP8[i2 + 158 >> 0] = 4;
 HEAP16[i2 + 156 >> 1] = 8;
 HEAP8[i2 + 178 >> 0] = 4;
 HEAP16[i2 + 176 >> 1] = 12;
 HEAP8[i2 + 198 >> 0] = 4;
 HEAP16[i2 + 196 >> 1] = 16;
 HEAP8[i2 + 218 >> 0] = 4;
 HEAP16[i2 + 216 >> 1] = 20;
 HEAP32[i2 + 120 >> 2] = 1065353216;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i2 + 132 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP32[i2 + 160 >> 2] = -1082130432;
 HEAP32[i2 + 164 >> 2] = 0;
 HEAP32[i2 + 168 >> 2] = 0;
 HEAPF32[i2 + 172 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP8[i2 + 139 >> 0] = 0;
 HEAP8[i2 + 179 >> 0] = 1;
 HEAP32[i2 + 180 >> 2] = 0;
 HEAP32[i2 + 184 >> 2] = 1065353216;
 HEAP32[i2 + 188 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAPF32[i2 + 192 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i2 + 204 >> 2] = -1082130432;
 HEAP32[i2 + 208 >> 2] = 0;
 HEAPF32[i2 + 212 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 HEAP8[i2 + 199 >> 0] = 0;
 HEAP8[i2 + 219 >> 0] = 2;
 HEAP32[i2 + 140 >> 2] = 0;
 HEAP32[i2 + 144 >> 2] = 0;
 HEAP32[i2 + 148 >> 2] = 1065353216;
 i1 = i1 + 8 | 0;
 HEAPF32[i2 + 152 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = -1082130432;
 HEAPF32[i2 + 112 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 HEAP8[i2 + 159 >> 0] = 0;
 HEAP8[i2 + 119 >> 0] = 4;
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE7PrepareEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i6 = i8;
 i2 = i7 + 72 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1047147 | 0, 12);
  i4 = i7 + 44 | 0;
  i3 = (__ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i5) | 0) == 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  if (i3) {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i1 + 12 | 0;
   i2 = HEAP8[i3 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 16 >> 2] | 0; else i1 = i2 & 255;
   if (!i1) {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1047147 | 0, 12);
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1031067 | 0, 24);
    if ((HEAP32[i7 + 108 >> 2] | 0) == 1) __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i4, i5, i6, 1) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    break;
   } else {
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1047147 | 0, 12);
    if ((HEAP32[i7 + 108 >> 2] | 0) == 1) __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i4, i5, i3, 1) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    break;
   }
  }
 } while (0);
 i1 = HEAP32[i7 + 68 >> 2] | 0;
 if (i1 | 0) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i7 + 104 >> 2] = i1;
  if ((i1 | 0) == 1 | (i1 | 1 | 0) != 1) {
   i7 = i1;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 i7 = __ZN19TransportJavaScript7PrepareEv(i7 + 8 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14StackAllocator10ReallocateEPvji(i13, i14, i12, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 4 | 0;
 i11 = i15;
 i7 = i1 & 7 | 0 ? 8 : i1;
 if (!i14) {
  i14 = mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i12 | 0, i7 | 0) | 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i9 = i13 + 52 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i4 = i13 + 32 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i2;
 } else {
  i2 = i13 + 32 | 0;
  i1 = i1 + ((HEAP32[i1 + -4 >> 2] | 0) >>> 1) | 0;
  i4 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i10 = i7 + -1 | 0;
 i6 = 0 - i7 | 0;
 i3 = (i1 + i10 & i6) - i2 | 0;
 i2 = i13 + 36 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = i5 >>> 0 < i3 >>> 0 ? 0 : i5 - i3 | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0, i14 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 <= i14 >>> 0) if ((i1 + (HEAP32[i2 >> 2] | 0) | 0) >>> 0 > i14 >>> 0) {
  i2 = i5 >>> 0 < i12 >>> 0;
  if (!(i2 & (HEAP32[i9 >> 2] | 0) != (i14 | 0))) if ((i3 + i5 | 0) >>> 0 > i12 >>> 0 ? (i10 + i14 & i6 | 0) == (i14 | 0) : 0) {
   i1 = i14 + -4 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 1 | i12 << 1;
   i1 = i13 + 16 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) - i5 | 0;
   i3 = i13 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + -1;
   i2 = i2 + i12 | 0;
   HEAP32[i1 >> 2] = i2;
   i1 = i13 + 24 | 0;
   if (i2 >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) HEAP32[i1 >> 2] = i2;
   HEAP32[i3 >> 2] = i4;
   STACKTOP = i15;
   return i14 | 0;
  }
  i1 = mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i12 | 0, i7 | 0) | 0;
  if (i1 | 0) _memcpy(i1 | 0, i14 | 0, (i2 ? i5 : i12) | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, i14 | 0);
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP16[gb + 1103840 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1103840 | 0, i8);
  i2 = gb + 1103840 | 0;
 } else i2 = 0;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i13 + 44 | 0) | 0;
 i1 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i14 | 0, i12 | 0, (i10 | 15) + 1 | 0) | 0;
 if (!i2) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37176 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z21SimulateClothingScenePN5physx7PxSceneE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 4 | 0;
 i1 = i9;
 i2 = i9 + 18 | 0;
 i7 = i9 + 16 | 0;
 if (__Z14IsWorldPlayingv() | 0) if (Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]) > Math_fround(0.0)) {
  __ZN14CompletionTask4InitEPN5physx7PxSceneE(gb + 1458956 | 0, i6);
  mftCall_vifiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 220 >> 2] | 0, i6 | 0, +Math_fround(HEAPF32[gb + 1459020 >> 2]), gb + 1458956 | 0, 0, 0, 1);
  mftCall_vi(HEAP32[(HEAP32[gb + 1458956 >> 2] | 0) + 20 >> 2] | 0, gb + 1458956 | 0);
  if ((HEAP16[gb + 1458932 + 6 >> 1] | 0) > -1) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458932 | 0, i8);
   i1 = gb + 1458932 | 0;
  } else i1 = 0;
  __ZN14CompletionTask22ProcessAllPhysicsTasksEv(gb + 1458956 | 0) | 0;
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 236 >> 2] | 0, i6 | 0, 1, 0) | 0;
 i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + 72 >> 2] | 0;
 HEAP16[i2 >> 1] = 32;
 i4 = mftCall_iii(i4 | 0, i6 | 0, i2 | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 4 | 0;
 i2 = gb + 63160 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i4 << 2;
 do if (!i1) {
  i1 = 0;
  i3 = 0;
 } else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i3 = 0;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 839517 | 0, 55) | 0;
   i2 = gb + 64016 | 0;
   i10 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = i3;
   i1 = i5;
   HEAP32[i1 >> 2] = i10;
   HEAP32[i1 + 4 >> 2] = i2;
   i1 = i3;
   break;
  }
 } while (0);
 i2 = i1 + 3 & -4;
 i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + 76 >> 2] | 0;
 HEAP16[i7 >> 1] = 32;
 mftCall_iiiiii(i10 | 0, i6 | 0, i7 | 0, i2 | 0, i4 | 0, 0) | 0;
 if ((i4 | 0) > 0) i1 = 0; else {
  i10 = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
  STACKTOP = i9;
  return;
 }
 do {
  __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv(HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i10 = HEAP32[i8 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 STACKTOP = i9;
 return;
}

function __Z13CameraProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b(i2, i7, i8, i9, i10, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f5 * Math_fround(HEAPF32[i8 + 12 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 28 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 44 >> 2])));
 f4 = Math_fround(Math_fround(HEAPF32[i8 + 60 >> 2]) + f4);
 i2 = f4 < Math_fround(0.0);
 f11 = Math_fround(-f4);
 if (!((i2 ? f11 : f4) > Math_fround(1.00000001e-07))) {
  i9 = 0;
  f11 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  HEAPF32[i10 >> 2] = f5;
  i8 = i10 + 4 | 0;
  HEAPF32[i8 >> 2] = f6;
  i10 = i10 + 8 | 0;
  HEAPF32[i10 >> 2] = f11;
  return i9 | 0;
 }
 f12 = Math_fround(f5 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 36 >> 2])));
 f12 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f12);
 f13 = Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f6 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 32 >> 2])));
 f11 = Math_fround(Math_fround(1.0) / f4);
 f13 = Math_fround(f11 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f13));
 f12 = Math_fround(f11 * f12);
 f11 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f5 = Math_fround(f5 - f11);
 f14 = Math_fround(f6 - f14);
 f11 = Math_fround(f3 - Math_fround(HEAPF32[i7 + 56 >> 2]));
 f4 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i7 + 36 >> 2]);
 f11 = Math_fround(Math_fround(Math_fround(-Math_fround(f14 * f6)) - Math_fround(f5 * f4)) - Math_fround(f11 * Math_fround(HEAPF32[i7 + 40 >> 2])));
 f4 = Math_fround(HEAP32[i9 >> 2] | 0);
 f5 = Math_fround(f13 + Math_fround(1.0));
 f5 = Math_fround(f4 + Math_fround(Math_fround(f5 * Math_fround(HEAP32[i9 + 8 >> 2] | 0)) * Math_fround(.5)));
 f4 = Math_fround(HEAP32[i9 + 4 >> 2] | 0);
 f6 = Math_fround(f12 + Math_fround(1.0));
 i8 = 1;
 f6 = Math_fround(f4 + Math_fround(Math_fround(f6 * Math_fround(HEAP32[i9 + 12 >> 2] | 0)) * Math_fround(.5)));
 HEAPF32[i10 >> 2] = f5;
 i9 = i10 + 4 | 0;
 HEAPF32[i9 >> 2] = f6;
 i10 = i10 + 8 | 0;
 HEAPF32[i10 >> 2] = f11;
 return i8 | 0;
}

function __Z20RegisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbPFP17BaseWebCamTexturevE(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i1 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1459968 >> 2] | 0;
 i9 = i2;
 L1 : do if ((i1 | 0) != (i2 | 0)) {
  i7 = HEAP8[i10 + 11 >> 0] | 0;
  i8 = i7 << 24 >> 24 < 0;
  i7 = i8 ? HEAP32[i10 + 4 >> 2] | 0 : i7 & 255;
  i8 = i8 ? HEAP32[i10 >> 2] | 0 : i10;
  i6 = (i1 - i2 | 0) / 20 | 0;
  if (!i7) {
   i1 = 0;
   while (1) {
    i8 = HEAP8[i9 + (i1 * 20 | 0) + 11 >> 0] | 0;
    if (!((i8 << 24 >> 24 < 0 ? HEAP32[i9 + (i1 * 20 | 0) + 4 >> 2] | 0 : i8 & 255) | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i6 >>> 0) break L1;
   }
   STACKTOP = i14;
   return;
  } else i5 = 0;
  L8 : while (1) {
   i3 = i9 + (i5 * 20 | 0) | 0;
   i1 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   i1 = i1 & 255;
   do if (((i2 ? HEAP32[i9 + (i5 * 20 | 0) + 4 >> 2] | 0 : i1) | 0) == (i7 | 0)) {
    i4 = HEAP32[i3 >> 2] | 0;
    if (i2) if (!(_memcmp(i4, i8, i7) | 0)) {
     i1 = 17;
     break L8;
    } else break;
    if ((i4 & 255) << 24 >> 24 == (HEAP8[i8 >> 0] | 0)) {
     i2 = i8;
     do {
      i1 = i1 + -1 | 0;
      i3 = i3 + 1 | 0;
      if (!i1) {
       i1 = 17;
       break L8;
      }
      i2 = i2 + 1 | 0;
     } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    }
   } while (0);
   i5 = i5 + 1 | 0;
   if (i5 >>> 0 >= i6 >>> 0) break L1;
  }
  if ((i1 | 0) == 17) {
   STACKTOP = i14;
   return;
  }
 } while (0);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i13, i10) | 0;
 i2 = i13 + 12 | 0;
 HEAP8[i2 >> 0] = i11 & 1;
 HEAP32[i13 + 16 >> 2] = i12;
 i1 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1459968 + 8 >> 2] | 0)) __ZNSt3__26vectorI12WebCamDeviceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(gb + 1459968 | 0, i13); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i13);
  i10 = i2;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i1 + 12 | 0;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[gb + 1459968 + 4 >> 2] = (HEAP32[gb + 1459968 + 4 >> 2] | 0) + 20;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
 STACKTOP = i14;
 return;
}

function __ZN5physx14PxsAABBManager14promoteBitmapsEPNS_9AggregateE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12;
 i9 = i10 + 1025 | 0;
 i8 = HEAP8[i9 >> 0] | 0;
 i1 = i8 & 255;
 _memcpy(i2 | 0, i10 | 0, 1024) | 0;
 _memset(i10 | 0, 0, 1024) | 0;
 if (i8 << 24 >> 24) {
  i3 = 0;
  do {
   i4 = i3;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 < i1 >>> 0) {
    i5 = i3;
    do {
     i8 = ((Math_imul(i5 + -1 | 0, i5) | 0) >>> 1) + i4 | 0;
     i6 = i5;
     i5 = i5 + 1 | 0;
     if (1 << (i8 & 31) & HEAP32[i2 + (i8 >>> 5 << 2) >> 2] | 0) {
      i7 = ((Math_imul(i5, i6) | 0) >>> 1) + i3 | 0;
      i8 = i10 + (i7 >>> 5 << 2) | 0;
      HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i7 & 31);
     }
    } while ((i5 | 0) != (i1 | 0));
   }
  } while ((i3 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i11 + 49860 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i7 = i11 + 24 | 0;
 i8 = i11 + 180 | 0;
 i6 = HEAP32[i11 + 49856 >> 2] | 0;
 do {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i3 + (HEAP32[i6 >> 2] << 2) >> 2] | 0;
  if (!(i2 & 1)) i5 = 0; else i5 = (HEAP32[i8 >> 2] | 0) + ((i2 >>> 1) * 1048 | 0) | 0;
  i2 = HEAP32[i3 + (HEAP32[i6 + 4 >> 2] << 2) >> 2] | 0;
  if (!(i2 & 1)) i3 = 0; else i3 = (HEAP32[i8 >> 2] | 0) + ((i2 >>> 1) * 1048 | 0) | 0;
  i2 = (i3 | 0) != 0;
  do if (!i5) {
   if (i2 & (i3 | 0) == (i10 | 0)) {
    i5 = i6 + 8 | 0;
    HEAP32[i5 >> 2] = __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj(i11, HEAP32[i5 >> 2] | 0, HEAPU8[i9 >> 0] | 0, 1, 0, -1) | 0;
   }
  } else {
   i4 = (i5 | 0) == (i10 | 0);
   if (!i2) {
    if (!i4) break;
    i5 = i6 + 8 | 0;
    HEAP32[i5 >> 2] = __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj(i11, HEAP32[i5 >> 2] | 0, HEAPU8[i9 >> 0] | 0, 1, 0, -1) | 0;
    break;
   }
   if (i4) {
    i5 = i6 + 8 | 0;
    HEAP32[i5 >> 2] = __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj(i11, HEAP32[i5 >> 2] | 0, HEAPU8[i9 >> 0] | 0, HEAPU8[i3 + 1025 >> 0] | 0, 0, -1) | 0;
    break;
   }
   if ((i3 | 0) == (i10 | 0)) {
    i4 = i6 + 8 | 0;
    HEAP32[i4 >> 2] = __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj(i11, HEAP32[i4 >> 2] | 0, HEAPU8[i5 + 1025 >> 0] | 0, HEAPU8[i9 >> 0] | 0, -1, 0) | 0;
   }
  } while (0);
  i6 = i6 + 12 | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i12;
 return;
}

function __ZN17PolygonCollider2D10SmartResetEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 24 | 0;
 i3 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i6 = i8 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i11 = 18; else {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31792 | 0) | 0;
  if (i1) {
   i5 = HEAP32[i1 + 340 >> 2] | 0;
   do if (i5 | 0) {
    HEAP32[i3 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 11; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i3);
      i3 = HEAP32[i7 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 11; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 13;
     }
    }
    if ((i11 | 0) == 11) i11 = 13;
    if ((i11 | 0) == 13) {
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
     if (!i1) break;
    }
    i13 = i8 + 160 | 0;
    __ZN9Polygon2D12GenerateFromEP6SpriteRK8Vector2ffhb(i13, i1, gb + 1162356 | 0, Math_fround(.25), -56, 1);
    if (((HEAP32[i8 + 164 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0) > 0) {
     STACKTOP = i12;
     return;
    }
   } while (0);
  }
  if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(HEAP32[i6 >> 2] | 0, i7) | 0) {
   f2 = Math_fround(HEAPF32[i7 + 12 >> 2]);
   f14 = Math_fround(HEAPF32[i7 + 16 >> 2]);
   f2 = f2 < f14 ? f14 : f2;
   i3 = !(f2 <= Math_fround(0.0));
   f2 = i3 ? f2 : Math_fround(1.0);
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i7 + 4 >> 2] | 0;
  } else i11 = 18;
 }
 if ((i11 | 0) == 18) {
  i1 = gb + 1162356 | 0;
  f2 = Math_fround(1.0);
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 HEAPF32[i9 >> 2] = f2;
 HEAPF32[i9 + 4 >> 2] = f2;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 4 >> 2] = i1;
 __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_(i8 + 160 | 0, 5, i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, HEAP32[i2 >> 2] | 0, i12 + 8 | 0);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 36980 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z17MakeFileNameValidRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 12 | 0;
 i9 = i10;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i1);
 i5 = i9 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i6 = i9 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 L1 : do if ((i1 << 24 >> 24 < 0 ? i2 : i1 & 255) | 0) do {
  if ((HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9) >> 0] | 0) != 32) break L1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i9, 0, 1) | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } while (((i1 << 24 >> 24 < 0 ? i2 : i1 & 255) | 0) != 0); while (0);
 i3 = i1 << 24 >> 24 < 0;
 i4 = i3 ? i2 : i1 & 255;
 if (!i4) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
 i3 = (i3 ? HEAP32[i9 >> 2] | 0 : i9) + (i4 + -1) | 0;
 switch (HEAP8[i3 >> 0] | 0) {
 case 46:
 case 32:
  {
   HEAP8[i3 >> 0] = 95;
   i1 = HEAP8[i5 >> 0] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   break;
  }
 default:
  {}
 }
 if ((i1 << 24 >> 24 < 0 ? i2 : i1 & 255) | 0) {
  i2 = 0;
  do {
   i4 = HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9) + i2 >> 0] | 0;
   i3 = HEAP32[gb + 70304 >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, _strlen(i3) | 0);
   i4 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i8, i4, 0) | 0) == -1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   if (!i4) HEAP8[((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) + i2 >> 0] = 95;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i5 >> 0] | 0;
  } while (i2 >>> 0 < (i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i1 & 255) >>> 0);
 }
 if (!(__Z24CheckValidFileNameDetailRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18PxsSolverStartTask10startTasksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i8 + 20 | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i6 | 0, i7 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i7 = i1 + 19 & -16;
   HEAP32[i7 + -4 >> 2] = i7 - i1;
   i1 = i7;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
 }
 HEAP32[HEAP32[i8 + 24 >> 2] >> 2] = i1;
 i5 = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0) + 7600 >> 2] | 0;
 HEAP32[i1 + 8764 >> 2] = i5;
 HEAP32[i1 + 9052 >> 2] = 0;
 HEAP32[i1 + 9056 >> 2] = 0;
 HEAP32[i1 + 9028 >> 2] = 0;
 HEAP32[i1 + 9068 >> 2] = HEAP32[i1 + 8892 >> 2];
 HEAP32[i1 + 9076 >> 2] = HEAP32[i1 + 8916 >> 2];
 i6 = i1 + 8796 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i6 = HEAP32[i8 + 52 >> 2] & 2147483647;
 if (!i6) i2 = 0; else {
  i3 = HEAP32[i8 + 32 >> 2] | 0;
  i4 = 0;
  i2 = 0;
  do {
   i2 = (HEAPU16[(HEAP32[HEAP32[i3 + (i4 << 2) >> 2] >> 2] | 0) + 36 >> 1] | 0) + i2 | 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i6 >>> 0);
 }
 i4 = HEAP32[i8 + 56 >> 2] | 0;
 i7 = i8 + 48 | 0;
 __ZN5physx16PxsThreadContext12resizeArraysEjjjjj(i1, HEAP32[i7 >> 2] | 0, i4, i4 + i2 + (HEAP32[i8 + 60 >> 2] | 0) | 0, (i5 | 0) == 0 ? 0 : i4, i6);
 i4 = HEAP32[i1 + 8856 >> 2] | 0;
 i3 = HEAP32[i1 + 8868 >> 2] | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 if (!i6) return;
 i2 = i8 + 28 | 0;
 i1 = 0;
 do {
  HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 64 >> 2];
  i8 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
  HEAP32[i3 + (i1 << 5) >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + (i1 << 5) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i3 + (i1 << 5) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAPF32[i3 + (i1 << 5) + 12 >> 2] = Math_fround(0.0);
  HEAP32[i3 + (i1 << 5) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i3 + (i1 << 5) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i3 + (i1 << 5) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAPF32[i3 + (i1 << 5) + 28 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 } while (i1 >>> 0 < i8 >>> 0);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 6;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 898218 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN14AnimationEvent8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 64 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 898218 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14AnimationEvent8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i9, i1, i2, i5) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 if (!(__ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i1, i2, 0, 0) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 945671 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i8 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i8 >>> 0) i4 = 7; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i4 = 7; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  i7 = i9 + 100 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i8 = i1 + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (!i8) i1 = 0; else i1 = (HEAP32[i9 + 88 >> 2] | 0) + (i1 + -2 << 5) | 0;
  HEAP32[i9 + 80 >> 2] = i1;
  HEAP8[i9 + 128 >> 0] = 1;
 }
 i2 = i9 + 108 | 0;
 i3 = i9 + 120 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 124 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 12 | 0, 4, i9 + 112 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i9 + 112 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + (i4 * 12 | 0) >> 2] = 0;
 HEAP32[i8 + (i4 * 12 | 0) + 4 >> 2] = -1;
 HEAP32[i8 + (i4 * 12 | 0) + 8 >> 2] = 2147483647;
 HEAP32[i9 + 84 >> 2] = (HEAP32[i2 >> 2] | 0) + (((HEAP32[i3 >> 2] | 0) + -1 | 0) * 12 | 0);
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNK15HeightMeshQuery16GetTerrainHeightERK8Vector3fPf(i2, i12, i13) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 8 | 0;
 i15 = i17;
 i1 = i12 + 4 | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 i16 = __Z18GetITerrainManagerv() | 0;
 if (!i16) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = i2 + 8 | 0;
 if ((i1 | 0) == (i10 | 0)) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 f3 = Math_fround(-inf);
 do {
  i8 = HEAP32[i1 + 24 >> 2] | 0;
  if (i8) {
   i9 = i8 + 12 | 0;
   if (HEAP32[i9 >> 2] | 0) {
    i7 = 0;
    do {
     i6 = HEAP32[i8 >> 2] | 0;
     HEAP32[i15 >> 2] = HEAP32[i6 + (i7 << 4) + 12 >> 2];
     i2 = HEAP32[gb + 1104264 >> 2] | 0;
     if (!i2) i2 = 0; else {
      if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
       i4 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[i2 + 32 >> 2] | 0;
       i2 = i4 + (i5 << 3) | 0;
      } else {
       __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i14, i2, i15);
       i4 = HEAP32[i14 >> 2] | 0;
       i18 = HEAP32[i2 + 28 >> 2] | 0;
       i5 = HEAP32[gb + 1104264 >> 2] | 0;
       i2 = (i4 | 0) == -1 ? i18 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i18 + (i4 << 3) | 0;
       i4 = HEAP32[i5 + 28 >> 2] | 0;
       i5 = HEAP32[i5 + 32 >> 2] | 0;
      }
      if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
     }
     if (mftCall_iiiiii(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i16 | 0, i2 | 0, i6 + (i7 << 4) | 0, i12 | 0, i14 | 0) | 0) {
      f19 = Math_fround(HEAPF32[i14 >> 2]);
      f3 = f19 > f3 & f19 < f11 ? f19 : f3;
     }
     i7 = i7 + 1 | 0;
    } while (i7 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
   }
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
 } while ((i1 | 0) != (i10 | 0));
 if (f3 == Math_fround(-inf)) {
  i18 = 0;
  STACKTOP = i17;
  return i18 | 0;
 }
 HEAPF32[i13 >> 2] = f3;
 i18 = 1;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZN19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i10, i7, i8) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 8 | 0;
 i5 = i11;
 i2 = i11 + 4 | 0;
 i9 = i10 + 356 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i10 = -1;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN4Mesh18CheckIfBuffersLostEv(i1);
 if (HEAP8[i1 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i1);
 if (!(HEAP8[i10 + 500 >> 0] | 0)) {
  i1 = HEAP32[i10 + 468 >> 2] | 0;
  if (!i1) i3 = 8; else {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i1) i3 = 8; else if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) i3 = 8;
  }
 } else i3 = 8;
 if ((i3 | 0) == 8) {
  HEAP32[i2 >> 2] = i10;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161544 | 0, i4);
  i6 = __ZN19SkinnedMeshRenderer17SkinMeshImmediateEv(i10) | 0;
  __Z12profiler_endP19ProfilerInformation(gb + 1161544 | 0);
  if (!i6) {
   i10 = -1;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i1 = i10 + 348 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 256 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  mftCall_vii(i3 | 0, i6 | 0, i4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i6 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i7, i8) | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 + (i6 * 360 | 0) + 248 >> 2] = HEAP32[i1 + 228 >> 2];
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 + 28 | 0) >>> 0 > (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i3, 32768);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
 HEAP32[i4 >> 2] = i2 + 28;
 HEAP32[i5 + (i6 * 360 | 0) + 328 >> 2] = i9;
 __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i9, i1, 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i10 + 468 >> 2] | 0, HEAP32[i10 + 472 >> 2] | 0);
 HEAP32[i5 + (i6 * 360 | 0) + 332 >> 2] = fb + 220;
 HEAP32[i5 + (i6 * 360 | 0) + 336 >> 2] = fb + 221;
 i9 = i5 + (i6 * 360 | 0) + 232 | 0;
 i10 = (HEAPU16[i9 >> 1] | HEAPU8[i9 + 2 >> 0] << 16) & 16776703 | HEAPU8[i10 + 465 >> 0] << 9;
 HEAP16[i9 >> 1] = i10;
 HEAP8[i9 + 2 >> 0] = i10 >>> 16;
 HEAP32[i5 + (i6 * 360 | 0) + 344 >> 2] = fb + 2371;
 i10 = i6;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 872 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470745 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9ShaderLab14SerializedPass8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 872 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 470745 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9ShaderLab14SerializedPass8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 872 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 0) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 0) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i1, 1); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i7, i4, i6, i3, f2) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var f1 = f0, f5 = f0;
 do if ((i3 | 0) == 1) {
  if (f2 <= Math_fround(.0404499993)) {
   f1 = Math_fround(f2 / Math_fround(12.9200001));
   break;
  }
  if (f2 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f2 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f2, 2.20000005));
 } else f1 = f2; while (0);
 L11 : do switch (i4 | 0) {
 case 0:
  {
   f5 = Math_fround(0.0);
   f2 = Math_fround(1.0);
   break;
  }
 case 1:
 case 7:
  {
   f1 = Math_fround(f2 * Math_fround(2.0));
   if (!i6) {
    f5 = Math_fround(0.0);
    f2 = Math_fround(1.0);
   } else {
    if (f1 <= Math_fround(.0404499993)) {
     f5 = Math_fround(0.0);
     f1 = Math_fround(f1 / Math_fround(12.9200001));
     f2 = Math_fround(1.0);
     break L11;
    }
    if (f1 < Math_fround(1.0)) {
     f5 = Math_fround(0.0);
     f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     f2 = Math_fround(1.0);
     break L11;
    }
    if (f1 == Math_fround(1.0)) {
     f5 = Math_fround(0.0);
     f1 = Math_fround(1.0);
     f2 = Math_fround(1.0);
    } else {
     f5 = Math_fround(0.0);
     f1 = Math_fround(+Math_pow(+f1, 2.20000005));
     f2 = Math_fround(1.0);
    }
   }
   break;
  }
 case 5:
 case 2:
  {
   if (!i6) {
    f5 = Math_fround(0.0);
    f1 = Math_fround(f1 * Math_fround(5.0));
    f2 = Math_fround(1.0);
    break L11;
   }
   do if (!(f2 <= Math_fround(.0404499993))) {
    if (f2 < Math_fround(1.0)) {
     f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f2 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f2 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f2, 2.20000005));
   } else f1 = Math_fround(f2 / Math_fround(12.9200001)); while (0);
   f5 = Math_fround(0.0);
   f1 = Math_fround(f1 * Math_fround(34.4932442));
   f2 = Math_fround(2.20000005);
   break;
  }
 case 4:
  {
   f5 = Math_fround(-1.0);
   f1 = Math_fround(2.0);
   f2 = Math_fround(1.0);
   break;
  }
 default:
  {
   f5 = Math_fround(0.0);
   f1 = Math_fround(1.0);
   f2 = Math_fround(1.0);
  }
 } while (0);
 HEAPF32[i7 >> 2] = f1;
 HEAPF32[i7 + 4 >> 2] = f2;
 HEAPF32[i7 + 8 >> 2] = f5;
 HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
 return;
}

function _UNITY_png_do_write_transformations(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i5) return;
 i6 = i5 + 212 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 & 1048576) {
  i2 = HEAP32[i5 + 192 >> 2] | 0;
  if (i2) {
   mftCall_viii(i2 | 0, i5 | 0, i7 | 0, (HEAP32[i5 + 380 >> 2] | 0) + 1 | 0);
   i1 = HEAP32[i6 >> 2] | 0;
  }
 }
 if (i1 & 32768) {
  _UNITY_png_do_strip_channel(i7, (HEAP32[i5 + 380 >> 2] | 0) + 1 | 0, (HEAP32[i5 + 208 >> 2] | 0) >>> 7 & 1 ^ 1);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (i1 & 16) {
  _UNITY_png_do_swap(i7, (HEAP32[i5 + 380 >> 2] | 0) + 1 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 L14 : do if (i1 & 131072 | 0) {
  i4 = (HEAP32[i5 + 380 >> 2] | 0) + 1 | 0;
  i3 = HEAP16[i7 + 8 >> 1] | 0;
  i1 = (i3 & 65535) >>> 8 & 255;
  switch ((i3 & 255) << 24 >> 24) {
  case 6:
   {
    if (i1 << 24 >> 24 != 8) break L14;
    i3 = HEAP32[i7 >> 2] | 0;
    if (!i3) break L14; else {
     i2 = 0;
     i1 = i4;
    }
    while (1) {
     i10 = i1 + 1 | 0;
     i8 = HEAP8[i1 >> 0] | 0;
     i9 = i1 + 2 | 0;
     HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
     i4 = i1 + 3 | 0;
     HEAP8[i10 >> 0] = HEAP8[i9 >> 0] | 0;
     HEAP8[i9 >> 0] = HEAP8[i4 >> 0] | 0;
     HEAP8[i4 >> 0] = i8;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
    }
    break;
   }
  case 4:
   {
    if (i1 << 24 >> 24 != 8) break L14;
    i3 = HEAP32[i7 >> 2] | 0;
    if (!i3) break L14; else {
     i2 = 0;
     i1 = i4;
    }
    while (1) {
     i10 = i1 + 1 | 0;
     i9 = HEAP8[i1 >> 0] | 0;
     HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
     HEAP8[i10 >> 0] = i9;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
    }
    break;
   }
  default:
   break L14;
  }
 } while (0);
 if (!(HEAP32[i6 >> 2] & 524288)) return;
 i1 = (HEAP32[i5 + 380 >> 2] | 0) + 1 | 0;
 i10 = HEAP16[i7 + 8 >> 1] | 0;
 i2 = (i10 & 65535) >>> 8 & 255;
 switch ((i10 & 255) << 24 >> 24) {
 case 6:
  {
   if (i2 << 24 >> 24 != 8) return;
   i3 = HEAP32[i7 >> 2] | 0;
   if (!i3) return; else i2 = 0;
   while (1) {
    i10 = i1 + 3 | 0;
    HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) ^ 255;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
   }
   return;
  }
 case 4:
  {
   if (i2 << 24 >> 24 != 8) return;
   i3 = HEAP32[i7 >> 2] | 0;
   if (!i3) return; else i2 = 0;
   while (1) {
    i10 = i1 + 1 | 0;
    HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) ^ 255;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
   }
   return;
  }
 default:
  return;
 }
}

function __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 77;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 77;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI8GUIStyleEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 296 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN4FMOD7Channel11getPositionEPjj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i9 = i10 + 16 | 0;
 i8 = i10 + 8 | 0;
 i4 = i10;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!(HEAP8[i3 + 161 >> 0] | 0)) {
    d11 = +__Z19GetTimeSinceStartupv() * 44100.0;
    i1 = ~~d11 >>> 0;
    i2 = +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0;
   } else {
    i2 = i3 + 120 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
   }
   i4 = i3 + 104 | 0;
   i2 = _i64Subtract(i1 | 0, i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   f12 = Math_fround(+(i2 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
   f12 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i3 + 140 >> 2]) / Math_fround(44100.0)));
   i2 = +Math_abs(+f12) >= 1.0 ? (+f12 > 0.0 ? ~~+Math_min(+Math_floor(+f12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f12 - +(~~+f12 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i1 = i3 + 128 | 0;
   i1 = ___uremdi3(~~+f12 >>> 0 | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
   i2 = getTempRet0() | 0;
   switch (i6 | 0) {
   case 2:
    {
     if (!i5) {
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
     HEAP32[i5 >> 2] = i1;
     i9 = 0;
     STACKTOP = i10;
     return i9 | 0;
    }
   case 1:
    {
     if (!i5) {
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
     HEAP32[i5 >> 2] = ~~((+(i1 >>> 0) + 4294967296.0 * +(i2 >>> 0)) * 1.0e3 / 44100.0) >>> 0;
     i9 = 0;
     STACKTOP = i10;
     return i9 | 0;
    }
   default:
    {
     HEAP32[i8 >> 2] = gb + 868575;
     HEAP32[i8 + 4 >> 2] = 584;
     _printf(gb + 854600 | 0, i8) | 0;
     HEAP32[i9 >> 2] = 37;
     HEAP32[i9 + 4 >> 2] = gb + 868575;
     _printf(gb + 853277 | 0, i9) | 0;
     HEAP32[i7 >> 2] = 37;
     HEAP32[i7 + 4 >> 2] = gb + 868575;
     _printf(gb + 853343 | 0, i7) | 0;
     i9 = 37;
     STACKTOP = i10;
     return i9 | 0;
    }
   }
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868575;
 _printf(gb + 853184 | 0, i4) | 0;
 i9 = 36;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10BlendShapeLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426442 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI10BlendShapeE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426442 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI10BlendShapeE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI8GradientEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx16PxVehicleDrive4WC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP16[i3 + 4 >> 1] = 513;
 HEAP16[i3 + 6 >> 1] = 3;
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(.230800003);
 HEAPF32[i3 + 16 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(.333333343);
 HEAP32[i3 >> 2] = gb + 159216 + 8;
 __ZN5physx21PxVehicleDriveDynDataC2Ev(i3 + 128 | 0);
 HEAP32[i3 >> 2] = gb + 159256 + 8;
 HEAPF32[i3 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 308 >> 2] = Math_fround(500.0);
 HEAPF32[i3 + 312 >> 2] = Math_fround(600.0);
 HEAPF32[i3 + 316 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 320 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 324 >> 2] = Math_fround(.349999994);
 HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 228 >> 2] = Math_fround(.800000011);
 HEAPF32[i3 + 232 >> 2] = Math_fround(.330000013);
 HEAPF32[i3 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 240 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 244 >> 2] = Math_fround(.800000011);
 HEAP32[i3 + 288 >> 2] = 3;
 HEAPF32[i3 + 328 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 332 >> 2] = Math_fround(.00166666671);
 HEAPF32[i3 + 464 >> 2] = Math_fround(4.0);
 HEAP32[i3 + 468 >> 2] = 7;
 HEAPF32[i3 + 472 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 336 >> 2] = Math_fround(-4.0);
 HEAPF32[i3 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 344 >> 2] = Math_fround(4.0);
 HEAPF32[i3 + 348 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 352 >> 2] = Math_fround(1.5);
 HEAPF32[i3 + 356 >> 2] = Math_fround(1.10000002);
 HEAPF32[i3 + 360 >> 2] = Math_fround(1.0);
 i1 = i3 + 364 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i3 + 480 >> 2] = Math_fround(10.0);
 HEAP32[i3 + 484 >> 2] = 1;
 HEAP32[i3 + 488 >> 2] = 5;
 i1 = 0;
 do {
  HEAPF32[i3 + 496 + (i1 << 2) >> 2] = Math_fround(.649999976);
  HEAPF32[i3 + 624 + (i1 << 2) >> 2] = Math_fround(.5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAPF32[i3 + 500 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 624 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 752 >> 2] = Math_fround(.449999988);
 HEAPF32[i3 + 756 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 760 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 764 >> 2] = Math_fround(1.29999995);
 HEAPF32[i3 + 768 >> 2] = Math_fround(1.29999995);
 HEAPF32[i3 + 772 >> 2] = Math_fround(1.29999995);
 HEAP32[i3 + 776 >> 2] = 0;
 HEAPF32[i3 + 784 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 788 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 792 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 796 >> 2] = Math_fround(0.0);
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 i5 = i8;
 i2 = i8 + 16 | 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i4 = i1;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = gb + 63280 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i5);
 i4 = i1;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i2 + 52 >> 2] = 0;
 i6 = gb + 63280 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i5);
 i5 = i1;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 60 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i2 + 108 | 0;
 i4 = i2 + 120 | 0;
 i5 = i2 + 132 | 0;
 i6 = i2 + 28 | 0;
 i7 = i2 + 76 | 0;
 i9 = i7 + 116 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i6 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 3;
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i3, 8);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i4, 4);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i5, 4);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i10, gb + 1041885 | 0, gb + 1041885 | 0, i1, i11);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i10, gb + 1041891 | 0, gb + 470954 | 0, i2, 0);
 __ZN9ShaderLab20SerializedSubProgram8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i10);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i10);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i10);
 __ZN9ShaderLab20SerializedSubProgramD2Ev(i2);
 STACKTOP = i8;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7putbackEc(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i5 + 4 >> 2] = 0;
 i3 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] & -3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i2 = 12; else {
  __THREW__ = 0;
  invoke_viii(fb + 1037 | 0, i2 | 0, i5 | 0, 1);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i2 = 12; else {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0;
   i3 = i5 + i1 | 0;
   do if (!(HEAP8[i2 >> 0] | 0)) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 4 | 0);
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) i2 = 13; else i2 = 18;
   } else {
    i3 = HEAP32[i3 + 24 >> 2] | 0;
    if (i3) {
     i2 = i3 + 12 | 0;
     i1 = HEAP32[i2 >> 2] | 0;
     if ((HEAP32[i3 + 8 >> 2] | 0) != (i1 | 0)) {
      i1 = i1 + -1 | 0;
      if ((HEAP8[i1 >> 0] | 0) == i4 << 24 >> 24) {
       HEAP32[i2 >> 2] = i1;
       i2 = 18;
       break;
      }
     }
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i4 & 255 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (i4 & 1) {
      i2 = 13;
      break;
     }
     if ((i1 | 0) != -1) {
      i2 = 18;
      break;
     }
     i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0;
    }
    i4 = i5 + i1 | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i4 | 0, HEAP32[i4 + 16 >> 2] | 1 | 0);
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) i2 = 13; else i2 = 18;
   } while (0);
   if ((i2 | 0) == 13) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i2 = 14;
    break;
   } else if ((i2 | 0) == 18) break;
  }
 } while (0);
 if ((i2 | 0) == 12) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = 14;
 }
 do if ((i2 | 0) == 14) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj156ES2_RKNS_19PxClothTetherConfigES6_EEKNS_32PxClothTetherConfigGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i6 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i5 >> 2] = i14;
 HEAP32[i5 + 4 >> 2] = i12;
 i12 = i5 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i2;
 HEAP32[i5 + 24 >> 2] = i6;
 HEAP32[i5 + 28 >> 2] = i3;
 HEAP32[i5 + 32 >> 2] = i4;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i7;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj395ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i9, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj396ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i9 + 16 | 0, 1);
 if (HEAP8[i7 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 i11 = i6;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i7;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i7 | 0);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i4, i7, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i1 = i11;
 i9 = i4 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i6 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i4 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i7 + 12 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i6 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i6 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, -1, i6 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  HEAP8[i8 >> 0] = HEAP32[i1 >> 2];
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i8 >> 0] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = i2 << 24 >> 24;
  i5 = i1 + 4 | 0;
  HEAP8[i8 >> 0] = HEAP32[i5 >> 2];
  i2 = i3 + 1 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
  } else {
   i7 = HEAP8[i3 >> 0] | 0;
   HEAP8[i8 >> 0] = i7;
   HEAP32[i9 >> 2] = i2;
   i2 = i7;
  }
  HEAP32[i5 >> 2] = i2 << 24 >> 24;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 108 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 590318 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 108 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 590318 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 108 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z39ParticleSystemRenderer_CUSTOM_GetMeshesP12Il2CppObjectP11Il2CppArray(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 8 | 0;
 i11 = i13;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i9) | 0;
 if (!i8) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i2) {
  i7 = i8;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i6 = __ZNK22ParticleSystemRenderer12GetMeshCountEv(i2) | 0;
 i6 = (i6 | 0) < (i1 | 0) ? i6 : i1;
 if (!i6) {
  STACKTOP = i13;
  return i6 | 0;
 }
 i5 = i6;
 L10 : while (1) {
  i7 = i6 - i5 | 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
  if (!i1) {
   i12 = 7;
   break;
  }
  while (1) {
   i4 = HEAP32[i1 + 552 + (i7 << 2) >> 2] | 0;
   if (i4 | 0) {
    HEAP32[i11 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
      i2 = HEAP32[i10 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (i1 | 0) break;
     }
    }
    if ((i12 | 0) == 14) i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (i1 | 0) break;
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
   if (!i1) {
    i12 = 7;
    break L10;
   }
  }
  i5 = i5 + -1 | 0;
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i9, i7, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
  if (!i5) {
   i12 = 19;
   break;
  }
 }
 if ((i12 | 0) == 7) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8); else if ((i12 | 0) == 19) {
  STACKTOP = i13;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_(i4, i5, i3, i2, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 64 | 0;
 i8 = i9;
 i6 = __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i4, i5, i3, i1) | 0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f10 < Math_fround(HEAPF32[i3 >> 2]))) {
  i8 = i6;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i8, i3);
 __ZN14AnimationEventaSERKS_(i3, i2) | 0;
 __ZN14AnimationEventaSERKS_(i2, i8) | 0;
 i1 = i8 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i8 + 32 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 }
 i1 = i8 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i8 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 }
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 if (!(f10 < Math_fround(HEAPF32[i5 >> 2]))) {
  i8 = i6 + 1 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i8, i5);
 __ZN14AnimationEventaSERKS_(i5, i3) | 0;
 __ZN14AnimationEventaSERKS_(i3, i8) | 0;
 i1 = i8 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i8 + 32 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
 }
 i1 = i8 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i8 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
 }
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 if (!(f10 < Math_fround(HEAPF32[i4 >> 2]))) {
  i8 = i6 + 2 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN14AnimationEventC2ERKS_(i8, i4);
 __ZN14AnimationEventaSERKS_(i4, i5) | 0;
 __ZN14AnimationEventaSERKS_(i5, i8) | 0;
 i1 = i8 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i8 + 32 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
 }
 i1 = i8 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i8 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
 }
 i8 = i6 + 3 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 25;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 25;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
   i8 = i9;
   i10 = HEAP32[i8 + 4 >> 2] | 0;
   i11 = i1 + 4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   i1 = (HEAP32[i12 >> 2] | 0) + 20 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if (i5 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 20 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 107374182 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 214748364;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 20 | 0) | 0;
 i7 = i6 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i3 = i7;
 i4 = i6 + (i5 * 20 | 0) | 0;
 i8 = i3;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
  i14 = i9;
  i5 = HEAP32[i14 + 4 >> 2] | 0;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i8 + 20 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i1 = i1 + -20 | 0;
   __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i2 + -20 | 0, i1);
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i5);
 STACKTOP = i13;
 return;
}

function __ZN5physx14PxsAABBManager19createAggregateElemEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i10 + 328 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != 1073741823) {
  i8 = i10 + 308 | 0;
  HEAP32[i9 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
  i9 = HEAP32[i10 + 300 >> 2] | 0;
  HEAP32[i9 + (i1 * 24 | 0) + 8 >> 2] = -8388609;
  HEAP32[i9 + (i1 * 24 | 0) + 4 >> 2] = -8388609;
  HEAP32[i9 + (i1 * 24 | 0) >> 2] = -8388609;
  HEAP32[i9 + (i1 * 24 | 0) + 20 >> 2] = 8388608;
  HEAP32[i9 + (i1 * 24 | 0) + 16 >> 2] = 8388608;
  HEAP32[i9 + (i1 * 24 | 0) + 12 >> 2] = 8388608;
  HEAP32[(HEAP32[i10 + 304 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i10 + 312 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i10 + 320 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  HEAP32[(HEAP32[i10 + 316 >> 2] | 0) + (i1 << 2) >> 2] = 1073741823;
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i10 + 324 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 32 : i2 << 1;
 __ZN5physx5Elems4growEj(i10 + 296 | 0, i2);
 i1 = i10 + 356 | 0;
 i2 = ((i2 + 31 | 0) >>> 5) + 3 & 268435452;
 i3 = i10 + 360 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 if (i2 >>> 0 > i5 >>> 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, i2 << 2, gb + 717789 | 0, 59) | 0;
  if (i6 | 0) _memcpy(i7 | 0, i6 | 0, i4 << 2 | 0) | 0;
  _memset(i7 + (i5 << 2) | 0, 0, i2 - i4 << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i6);
  HEAP32[i1 >> 2] = i7;
  HEAP32[i3 >> 2] = i2 | -2147483648;
 }
 i8 = HEAP32[i9 >> 2] | 0;
 i7 = i10 + 308 | 0;
 HEAP32[i9 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2];
 i9 = HEAP32[i10 + 300 >> 2] | 0;
 HEAP32[i9 + (i8 * 24 | 0) + 8 >> 2] = -8388609;
 HEAP32[i9 + (i8 * 24 | 0) + 4 >> 2] = -8388609;
 HEAP32[i9 + (i8 * 24 | 0) >> 2] = -8388609;
 HEAP32[i9 + (i8 * 24 | 0) + 20 >> 2] = 8388608;
 HEAP32[i9 + (i8 * 24 | 0) + 16 >> 2] = 8388608;
 HEAP32[i9 + (i8 * 24 | 0) + 12 >> 2] = 8388608;
 HEAP32[(HEAP32[i10 + 304 >> 2] | 0) + (i8 << 2) >> 2] = 0;
 HEAP32[(HEAP32[i7 >> 2] | 0) + (i8 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i10 + 312 >> 2] | 0) + (i8 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i10 + 320 >> 2] | 0) + (i8 << 2) >> 2] = 1073741823;
 HEAP32[(HEAP32[i10 + 316 >> 2] | 0) + (i8 << 2) >> 2] = 1073741823;
 i10 = i8;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl21AddCharacterInfoEntryERK5RectTIfES4_fibijf(i11, i3, i4, f9, i2, i7, i1, i8, f10) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f9 = Math_fround(f9);
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 f10 = Math_fround(f10);
 var i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 64 | 0;
 i12 = i14;
 i15 = i2 - (HEAP32[i11 + 28 >> 2] | 0) | 0;
 i2 = i12 + 48 | 0;
 i5 = i12 + 4 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i5 = i12 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i12 + 56 | 0;
 HEAP8[i6 >> 0] = 0;
 i16 = i12 + 4 | 0;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i3 = i12 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAPF32[i12 + 36 >> 2] = f9;
 HEAP32[i12 >> 2] = i15;
 if (!i1) i1 = HEAP32[(HEAP32[i11 + 76 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i12 + 40 >> 2] = i1;
 HEAP32[i12 + 44 >> 2] = i8;
 HEAPF32[i2 >> 2] = f10;
 HEAP32[i5 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2];
 HEAP8[i6 >> 0] = i7 & 1;
 i2 = i11 + 40 | 0;
 i3 = i11 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 56 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 60 | 0, 4, i11 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 60 | 0, 4, i11 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i16 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 60 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i16;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i1 = (HEAP32[i2 >> 2] | 0) + (i4 * 60 | 0) | 0;
 i2 = i12;
 i3 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_(i13, i11 + 60 | 0, i12);
 STACKTOP = i14;
 return;
}

function __ZN16RenderTextureMap6UpdateEPK17RenderSurfaceBaseP13RenderTexture(i7, i11) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 16 | 0;
 i13 = i16;
 i14 = i7;
 if (!i7) {
  STACKTOP = i16;
  return;
 }
 i15 = HEAP32[gb + 1158228 >> 2] | 0;
 i3 = HEAP32[i15 + 4 >> 2] | 0;
 L4 : do if ((HEAP32[i15 + 36 >> 2] | 0) == (i3 | 0)) {
  i2 = HEAP32[i15 + 28 >> 2] | 0;
  i1 = HEAP32[i15 + 32 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i15 + 32 >> 2] | 0;
  i8 = i10 + -1 | 0;
  i1 = i8 & (Math_imul(i14, 1419247029) | 0);
  i2 = HEAP32[i15 + 28 >> 2] | 0;
  i9 = HEAP32[i15 + 20 >> 2] | 0;
  i6 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L7 : do if ((i9 | 0) != (i6 | 0)) {
   i4 = i15 + 12 | 0;
   L9 : do if (!(HEAP8[i15 + 8 >> 0] | 0)) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i3 | 0) == (i7 | 0)) break L9;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L7;
    }
   } else {
    if (!i3) {
     i4 = 0;
     i3 = i6;
     while (1) {
      if ((i3 | 0) == (i7 | 0)) break L9;
      i4 = i4 + 1 | 0;
      i1 = i4 + i1 & i8;
      i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
      if ((i9 | 0) == (i3 | 0)) break L7;
     }
    }
    i5 = HEAP32[i4 >> 2] | 0;
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i5 | 0) != (i3 | 0) & (i3 | 0) == (i7 | 0)) break L9;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L7;
    }
   } while (0);
   if ((i1 | 0) != -1) {
    i3 = i2 + (i1 << 3) | 0;
    i1 = i10;
    break L4;
   }
  } while (0);
  i3 = i2 + (i10 << 3) | 0;
  i1 = i10;
 } while (0);
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) {
  HEAP32[i12 >> 2] = i14;
  HEAP32[i12 + 4 >> 2] = i11;
  __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj(i15, 1, 0);
  __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS8_(i13, i15, i12);
  STACKTOP = i16;
  return;
 } else {
  HEAP32[i3 + 4 >> 2] = i11;
  STACKTOP = i16;
  return;
 }
}

function __ZN13EmscriptenWWWC2EPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i7, i1, i8, i9, i5, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 HEAP32[i7 >> 2] = gb + 73968 + 8;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP8[i7 + 8 >> 0] = 0;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP8[i7 + 33 >> 0] = i2 & 1;
 i6 = i7 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i7 + 56 >> 2] = i4;
 HEAP32[i7 + 60 >> 2] = 2;
 i6 = i7 + 64 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 + 76 >> 2] = 1;
 HEAP32[i7 >> 2] = gb + 25328 + 8;
 i6 = i7 + 100 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAPF32[i7 + 84 >> 2] = Math_fround(0.0);
 HEAP32[i7 + 88 >> 2] = 0;
 HEAP32[i7 + 92 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, i1) | 0;
 HEAP8[i7 + 96 >> 0] = 0;
 i1 = _JS_WebRequest_Create(i1 | 0, ((i8 | 0) != 0 & (i9 | 0) > -1 ? gb + 1030900 | 0 : gb + 1030905 | 0) | 0) | 0;
 i6 = i7 + 80 | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 i5 = i5 + 4 | 0;
 if ((i2 | 0) == (i5 | 0)) {
  i5 = i1;
  _JS_WebRequest_SetResponseHandler(i5 | 0, i7 | 0, fb + 118 | 0);
  i5 = HEAP32[i6 >> 2] | 0;
  _JS_WebRequest_SetProgressHandler(i5 | 0, i7 | 0, fb + 491 | 0);
  i7 = HEAP32[i6 >> 2] | 0;
  _JS_WebRequest_Send(i7 | 0, i8 | 0, i9 | 0);
  return;
 }
 do {
  i3 = i2 + 16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  i4 = i2 + 28 | 0;
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i4 = HEAP32[i4 >> 2] | 0;
  _JS_WebRequest_SetRequestHeader(i1 | 0, i3 | 0, i4 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i2 | 0) != (i5 | 0));
 _JS_WebRequest_SetResponseHandler(i1 | 0, i7 | 0, fb + 118 | 0);
 i5 = HEAP32[i6 >> 2] | 0;
 _JS_WebRequest_SetProgressHandler(i5 | 0, i7 | 0, fb + 491 | 0);
 i7 = HEAP32[i6 >> 2] | 0;
 _JS_WebRequest_Send(i7 | 0, i8 | 0, i9 | 0);
 return;
}

function __Z26SkinVerticesGenericMathLibILi1ELb1ELb0EEvPKhiiiiPhiPKvS4_(i2, i4, i5, i3, i6, i1, i7, i8, i9) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0;
 if ((i4 | 0) <= 0) return;
 i3 = i2;
 i2 = 0;
 while (1) {
  i10 = HEAP32[i9 + (i2 << 2) >> 2] | 0;
  f26 = Math_fround(HEAPF32[i8 + (i10 << 6) >> 2]);
  f24 = Math_fround(HEAPF32[i8 + (i10 << 6) + 4 >> 2]);
  f22 = Math_fround(HEAPF32[i8 + (i10 << 6) + 8 >> 2]);
  f25 = Math_fround(HEAPF32[i8 + (i10 << 6) + 16 >> 2]);
  f23 = Math_fround(HEAPF32[i8 + (i10 << 6) + 20 >> 2]);
  f20 = Math_fround(HEAPF32[i8 + (i10 << 6) + 24 >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i10 << 6) + 32 >> 2]);
  f13 = Math_fround(HEAPF32[i8 + (i10 << 6) + 36 >> 2]);
  f18 = Math_fround(HEAPF32[i8 + (i10 << 6) + 40 >> 2]);
  f17 = Math_fround(HEAPF32[i8 + (i10 << 6) + 48 >> 2]);
  f16 = Math_fround(HEAPF32[i8 + (i10 << 6) + 52 >> 2]);
  f12 = Math_fround(HEAPF32[i8 + (i10 << 6) + 56 >> 2]);
  f19 = Math_fround(HEAPF32[i3 >> 2]);
  f21 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i10 = HEAP32[i3 + 12 >> 2] | 0;
  f17 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f26 * f19) + Math_fround(f25 * f21)) + Math_fround(f14 * f15)));
  f16 = Math_fround(f16 + Math_fround(Math_fround(Math_fround(f24 * f19) + Math_fround(f23 * f21)) + Math_fround(f13 * f15)));
  f15 = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f22 * f19) + Math_fround(f20 * f21)) + Math_fround(f18 * f15)));
  i11 = i3 + i5 | 0;
  f21 = Math_fround(HEAPF32[i11 >> 2]);
  f19 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  f14 = Math_fround(Math_fround(Math_fround(f26 * f21) + Math_fround(f25 * f19)) + Math_fround(f14 * f12));
  f13 = Math_fround(Math_fround(Math_fround(f24 * f21) + Math_fround(f23 * f19)) + Math_fround(f13 * f12));
  f12 = Math_fround(Math_fround(Math_fround(f22 * f21) + Math_fround(f20 * f19)) + Math_fround(f18 * f12));
  HEAPF32[i1 >> 2] = f17;
  HEAPF32[i1 + 4 >> 2] = f16;
  HEAPF32[i1 + 8 >> 2] = f15;
  HEAP32[i1 + 12 >> 2] = i10;
  i10 = i1 + i5 | 0;
  HEAPF32[i10 >> 2] = f14;
  HEAPF32[i10 + 4 >> 2] = f13;
  HEAPF32[i10 + 8 >> 2] = f12;
  HEAP32[i10 + 12 >> 2] = i11;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else {
   i3 = i3 + i6 | 0;
   i1 = i1 + i7 | 0;
  }
 }
 return;
}

function __ZN5physx31PxComputeHeightFieldPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES5_Rj(i20, i9, i8, i1, i10, i11, i21) {
 i20 = i20 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i21 = i21 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22 + 16 | 0;
 i12 = i22 + 4 | 0;
 i7 = i22;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i14 = i13 + 16 | 0;
 i18 = i1 + 16 | 0;
 i24 = HEAP32[i18 >> 2] | 0;
 HEAP32[i14 >> 2] = i24;
 i15 = i13 + 20 | 0;
 i19 = i1 + 20 | 0;
 i23 = HEAP32[i19 >> 2] | 0;
 HEAP32[i15 >> 2] = i23;
 i16 = i13 + 24 | 0;
 i17 = i1 + 24 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 HEAP32[i16 >> 2] = i1;
 i5 = i12 + 4 | 0;
 i6 = i12 + 8 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 L1 : do if (!i9) i1 = 0; else {
  i1 = 0;
  while (1) {
   if (!(__ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_(i12, i7, i8, i13, i10, i11) | 0)) break;
   f28 = Math_fround(HEAPF32[i7 >> 2]);
   f27 = Math_fround(HEAPF32[i12 >> 2]);
   f26 = Math_fround(HEAPF32[i5 >> 2]);
   f25 = Math_fround(HEAPF32[i6 >> 2]);
   f4 = Math_fround(HEAPF32[i14 >> 2]);
   f3 = Math_fround(HEAPF32[i15 >> 2]);
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   i1 = i1 + 1 | 0;
   f26 = Math_fround(f28 * f26);
   f25 = Math_fround(f28 * f25);
   f4 = Math_fround(Math_fround(f28 * f27) + f4);
   HEAPF32[i14 >> 2] = f4;
   f3 = Math_fround(f26 + f3);
   HEAPF32[i15 >> 2] = f3;
   f2 = Math_fround(f25 + f2);
   HEAPF32[i16 >> 2] = f2;
   if (i1 >>> 0 >= i9 >>> 0) break L1;
  }
  f4 = Math_fround(HEAPF32[i14 >> 2]);
  f3 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i16 >> 2]);
 } while (0);
 HEAP32[i21 >> 2] = i1;
 f26 = Math_fround(f4 - Math_fround(HEAPF32[i18 >> 2]));
 f27 = Math_fround(f3 - Math_fround(HEAPF32[i19 >> 2]));
 f28 = Math_fround(f2 - Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i20 >> 2] = f26;
 HEAPF32[i20 + 4 >> 2] = f27;
 HEAPF32[i20 + 8 >> 2] = f28;
 STACKTOP = i22;
 return;
}

function __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
 i10 = i6 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i9 >> 0] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP8[i8 + 112 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i2 = i3;
 }
 HEAP32[i8 + 100 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 i1 = i5 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
  i1 = HEAP8[i9 >> 0] | 0;
 } else {
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i9 >> 0] = i5;
  HEAP32[i10 >> 2] = i1;
  i1 = i5;
 }
 HEAP8[i8 + 113 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i8 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i8 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i10 >> 2] = i2;
  i10 = i8;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZNK5Umbra6KDTree8getPathsEPji(i13, i14, i15) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i16 >> 2] = 2;
 i17 = i13 + 4 | 0;
 i10 = 0;
 i2 = 0;
 i1 = 0;
 i3 = 0;
 while (1) {
  i8 = i16 + (i10 << 3) | 0;
  i9 = i16 + (i10 << 3) + 4 | 0;
  i12 = i3 << 1;
  if (((HEAP32[(HEAP32[i17 >> 2] | 0) + (i12 >> 5 << 2) >> 2] | 0) >>> (i12 & 30) & 3 | 0) == 3) HEAP32[i8 >> 2] = 0;
  i11 = _bitshift64Shl(1, 0, i10 | 0) | 0;
  i12 = getTempRet0() | 0;
  i6 = _i64Add(i11 | 0, i12 | 0, -1, -1) | 0;
  i2 = i6 & i2;
  i1 = (getTempRet0() | 0) & i1;
  i6 = Math_imul(i3, i15) | 0;
  i7 = i6 + i15 | 0;
  i19 = i6 >> 5;
  i3 = i14 + (i19 << 2) | 0;
  i4 = 1 << (i6 & 31);
  i5 = 0 - i4 | 0;
  if ((i5 | 0) == -1 | (i19 | 0) == (i7 >> 5 | 0)) i4 = i15; else {
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4 + -1;
   i5 = -1;
   i4 = (i6 | -32) + i15 | 0;
   i3 = i3 + 4 | 0;
  }
  if ((i4 | 0) > 31) {
   i4 = i4 + -32 | 0;
   i19 = i4 >>> 5;
   _memset(i3 | 0, 0, (i19 << 2) + 4 | 0) | 0;
   i4 = i4 - (i19 << 5) | 0;
   i3 = i3 + (i19 + 1 << 2) | 0;
  }
  if (i4 | 0) HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~(i5 & (1 << (i7 & 31)) + -1);
  i3 = i7 - i10 | 0;
  i7 = i3 + -1 | 0;
  i19 = i14 + (i7 >> 5 << 2) | 0;
  HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | 1 << (i7 & 31);
  if (i10 | 0) {
   i4 = i10;
   i5 = i2;
   i7 = i1;
   while (1) {
    i4 = i4 + -1 | 0;
    i6 = 1 << (i3 & 31);
    if ((i5 & 1 | 0) == 0 & 0 == 0) {
     i19 = i14 + (i3 >> 5 << 2) | 0;
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] & ~i6;
    } else {
     i19 = i14 + (i3 >> 5 << 2) | 0;
     HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i6;
    }
    i5 = _bitshift64Lshr(i5 | 0, i7 | 0, 1) | 0;
    i7 = getTempRet0() | 0;
    if (!i4) break; else i3 = i3 + 1 | 0;
   }
  }
  i5 = HEAP32[i8 >> 2] | 0;
  do if (!i5) i4 = i10 + -1 | 0; else {
   i4 = i10 + 1 | 0;
   HEAP32[i16 + (i4 << 3) >> 2] = 2;
   HEAP32[i8 >> 2] = i5 + -1;
   i3 = (__ZNK5Umbra6KDTree4rankEi(i13, HEAP32[i9 >> 2] | 0) | 0) << 1;
   if ((i5 | 0) == 2) {
    HEAP32[i16 + (i4 << 3) + 4 >> 2] = i3 + -1;
    i2 = i2 | i11;
    i1 = i1 | i12;
    break;
   } else {
    HEAP32[i16 + (i4 << 3) + 4 >> 2] = i3;
    i2 = i2 & ~i11;
    i1 = i1 & ~i12;
    break;
   }
  } while (0);
  if ((i4 | 0) <= -1) break;
  i10 = i4;
  i3 = HEAP32[i16 + (i4 << 3) + 4 >> 2] | 0;
 }
 STACKTOP = i18;
 return;
}

function __ZN7mecanim12statemachine18EvaluateTransitionEPKNS0_18TransitionConstantEPKNS0_15TransitionInputEPNS0_16TransitionOutputEPKNS0_16TransitionMemoryEPNS0_21StateMachineWorkspaceE(i13, i14, i15, i16, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i18 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 4 | 0;
 i3 = i12;
 i1 = (HEAP32[i13 >> 2] | 0) != 0 & 1;
 HEAP8[i15 >> 0] = i1;
 i10 = i15 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 do if (!(HEAP8[i13 + 36 >> 0] | 0)) i11 = 11; else {
  HEAP8[i15 >> 0] = 0;
  i1 = i13 + 32 | 0;
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  if (!(f5 <= Math_fround(1.0))) {
   if (!(Math_fround(HEAPF32[i14 + 8 >> 2]) < f5)) {
    STACKTOP = i12;
    return;
   }
   f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
   if (!(f4 >= f5)) {
    STACKTOP = i12;
    return;
   } else {
    HEAP8[i15 >> 0] = 1;
    HEAPF32[i10 >> 2] = Math_fround(f4 - f5);
    break;
   }
  } else {
   HEAPF32[i2 >> 2] = Math_fround(0.0);
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   i18 = i14 + 8 | 0;
   Math_fround(_modff(Math_fround(HEAPF32[i18 >> 2]), i2));
   i17 = i14 + 4 | 0;
   Math_fround(_modff(Math_fround(HEAPF32[i17 >> 2]), i3));
   f9 = Math_fround(HEAPF32[i18 >> 2]);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   f5 = Math_fround(f9 - f6);
   f7 = Math_fround(HEAPF32[i17 >> 2]);
   f4 = Math_fround(f7 - f6);
   f8 = Math_fround(HEAPF32[i1 >> 2]);
   if (f5 < f8 & f4 >= f8) i11 = 6; else {
    f5 = Math_fround(HEAPF32[i3 >> 2]);
    if (f6 != f5) {
     f4 = Math_fround(f7 - f5);
     if (Math_fround(f9 - f5) < f8 & f4 >= f8) i11 = 6;
    }
   }
   if ((i11 | 0) == 6) {
    HEAP8[i15 >> 0] = 1;
    HEAPF32[i10 >> 2] = Math_fround(f4 - f8);
   }
   i1 = HEAP8[i15 >> 0] | 0;
   i11 = 11;
   break;
  }
 } while (0);
 if ((i11 | 0) == 11) if (!(i1 << 24 >> 24)) {
  STACKTOP = i12;
  return;
 }
 i2 = i13 + 4 | 0;
 i3 = i2;
 i1 = 0;
 while (1) {
  if (i1 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) {
   i11 = 14;
   break;
  }
  i17 = (HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) | 0;
  i18 = HEAP32[i17 >> 2] | 0;
  i18 = __ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE((i18 | 0) == 0 ? 0 : i17 + i18 | 0, HEAP32[i16 >> 2] | 0, HEAP32[i14 >> 2] | 0) | 0;
  HEAP8[i15 >> 0] = i18 & 1;
  if (i18) i1 = i1 + 1 | 0; else {
   i11 = 14;
   break;
  }
 }
 if ((i11 | 0) == 14) {
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx21AggregateActorManager6resizeEj(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 20 | 0;
 i15 = HEAP32[i11 >> 2] | 0;
 i10 = (i14 + 31 | 0) >>> 5;
 i4 = (i14 * 24 | 0) + 15 & -16;
 i8 = (i14 << 2) + 15 & -16;
 i6 = i4 + (i14 + 15 & -16) | 0;
 i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i16 + 1 | 0, i6 + ((i10 << 3) + 30 & 2147483616) + (i8 << 1) | 0, gb + 717789 | 0, 978) | 0;
 i12 = i13 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) _memcpy(i9 | 0, i1 | 0, i15 * 24 | 0) | 0;
 i5 = i14 - i15 | 0;
 _memset(i9 + (i15 * 24 | 0) | 0, 0, i5 * 24 | 0) | 0;
 i2 = i9 + i4 | 0;
 HEAP32[i12 >> 2] = i9;
 i3 = i13 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i2 | 0, i1 | 0, i15 | 0) | 0;
 _memset(i9 + (i15 + i4) | 0, 0, i5 | 0) | 0;
 i7 = i9 + i6 | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i13 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i7 | 0, i1 | 0, i15 << 2 | 0) | 0;
 i4 = i5 << 2;
 _memset(i7 + (i15 << 2) | 0, 0, i4 | 0) | 0;
 i2 = i6 + i8 | 0;
 i6 = i9 + i2 | 0;
 HEAP32[i3 >> 2] = i7;
 i3 = i13 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i6 | 0, i1 | 0, i15 << 2 | 0) | 0;
 _memset(i6 + (i15 << 2) | 0, 0, i4 | 0) | 0;
 i4 = i2 + i8 | 0;
 i5 = i9 + i4 | 0;
 HEAP32[i3 >> 2] = i6;
 i6 = i13 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i13 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) _memcpy(i5 | 0, i2 | 0, i1 << 2 | 0) | 0;
 _memset(i5 + ((i1 & 2147483647) << 2) | 0, 0, i10 - i1 << 2 | 0) | 0;
 i7 = i9 + (i4 + ((i10 << 2) + 15 & 1073741808)) | 0;
 HEAP32[i3 >> 2] = i5;
 i5 = i10 | -2147483648;
 HEAP32[i6 >> 2] = i5;
 i1 = i13 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i13 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) _memcpy(i7 | 0, i4 | 0, i2 << 2 | 0) | 0;
 _memset(i7 + ((i2 & 2147483647) << 2) | 0, 0, i10 - i2 << 2 | 0) | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i1 >> 2] = i5;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i16, i1);
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i11 >> 2] = i14;
 i4 = i13 + 48 | 0;
 i1 = i14 + -1 | 0;
 HEAP32[i2 + (i1 * 24 | 0) >> 2] = HEAP32[i4 >> 2];
 if (i15 >>> 0 < i1 >>> 0) i3 = i15; else {
  HEAP32[i4 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 do {
  i14 = i3;
  i3 = i3 + 1 | 0;
  HEAP32[i2 + (i14 * 24 | 0) >> 2] = i3;
 } while ((i3 | 0) != (i1 | 0));
 HEAP32[i4 >> 2] = i15;
 STACKTOP = i16;
 return;
}

function __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(i10, i8, i11, i5, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i10 + 20 >> 2] | 0;
 i2 = HEAP32[i10 + 16 >> 2] | 0;
 i7 = (i11 | 0) != 0;
 if (i7) {
  i3 = i8 - i6 | 0;
  HEAP32[i9 >> 2] = (i3 * 3 | 0) + 2;
  HEAP32[i9 + 4 >> 2] = i3;
  HEAP32[i9 + 8 >> 2] = i11 + -1;
  HEAP32[i9 + 12 >> 2] = i5;
  i3 = 1;
 } else i3 = 0;
 if ((i6 + -1 | 0) >>> 0 > i5 >>> 0) {
  if (i7) {
   i1 = i8 - i6 | 0;
   if ((HEAP8[(HEAP32[i10 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >= 0) {
    HEAP32[i9 + (i3 << 4) >> 2] = (i1 * 3 | 0) + 1;
    HEAP32[i9 + (i3 << 4) + 4 >> 2] = i1;
    HEAP32[i9 + (i3 << 4) + 8 >> 2] = i11 + -1;
    HEAP32[i9 + (i3 << 4) + 12 >> 2] = i5;
    i3 = i3 + 1 | 0;
   }
  }
  i4 = i8 * 3 | 0;
  HEAP32[i9 + (i3 << 4) >> 2] = i4;
  HEAP32[i9 + (i3 << 4) + 4 >> 2] = i8;
  HEAP32[i9 + (i3 << 4) + 8 >> 2] = i11;
  HEAP32[i9 + (i3 << 4) + 12 >> 2] = i5;
  i1 = i3 + 1 | 0;
  i2 = i2 + -1 | 0;
  if (i2 >>> 0 > i11 >>> 0) if ((HEAP8[(HEAP32[i10 + 36 >> 2] | 0) + (i8 << 2) + 2 >> 0] | 0) < 0) {
   HEAP32[i9 + (i1 << 4) >> 2] = i4 + 1;
   HEAP32[i9 + (i1 << 4) + 4 >> 2] = i8;
   HEAP32[i9 + (i1 << 4) + 8 >> 2] = i11;
   HEAP32[i9 + (i1 << 4) + 12 >> 2] = i5;
   i1 = i3 + 2 | 0;
  }
 } else {
  i2 = i2 + -1 | 0;
  i1 = i3;
 }
 i2 = i2 >>> 0 > i11 >>> 0;
 if (i2) {
  HEAP32[i9 + (i1 << 4) >> 2] = (i8 * 3 | 0) + 2;
  HEAP32[i9 + (i1 << 4) + 4 >> 2] = i8;
  HEAP32[i9 + (i1 << 4) + 8 >> 2] = i11;
  HEAP32[i9 + (i1 << 4) + 12 >> 2] = i5;
  i1 = i1 + 1 | 0;
 }
 if (!i5) {
  i11 = i1;
  return i11 | 0;
 }
 i3 = i8 + -1 | 0;
 if (i2) if ((HEAP8[(HEAP32[i10 + 36 >> 2] | 0) + (i3 << 2) + 2 >> 0] | 0) < 0) i4 = i1; else {
  HEAP32[i9 + (i1 << 4) >> 2] = (i3 * 3 | 0) + 1;
  HEAP32[i9 + (i1 << 4) + 4 >> 2] = i3;
  HEAP32[i9 + (i1 << 4) + 8 >> 2] = i11;
  HEAP32[i9 + (i1 << 4) + 12 >> 2] = i5 + -1;
  i4 = i1 + 1 | 0;
 } else i4 = i1;
 HEAP32[i9 + (i4 << 4) >> 2] = i3 * 3;
 HEAP32[i9 + (i4 << 4) + 4 >> 2] = i3;
 HEAP32[i9 + (i4 << 4) + 8 >> 2] = i11;
 i2 = i5 + -1 | 0;
 HEAP32[i9 + (i4 << 4) + 12 >> 2] = i2;
 i3 = i4 + 1 | 0;
 if (!i7) {
  i11 = i3;
  return i11 | 0;
 }
 i1 = i8 - i6 + -1 | 0;
 if ((HEAP8[(HEAP32[i10 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >= 0) {
  i11 = i3;
  return i11 | 0;
 }
 HEAP32[i9 + (i3 << 4) >> 2] = (i1 * 3 | 0) + 1;
 HEAP32[i9 + (i3 << 4) + 4 >> 2] = i1;
 HEAP32[i9 + (i3 << 4) + 8 >> 2] = i11 + -1;
 HEAP32[i9 + (i3 << 4) + 12 >> 2] = i2;
 i11 = i4 + 2 | 0;
 return i11 | 0;
}

function __ZN5Umbra12QueryContext13visualizeCellEPKNS_7ImpTileEi(i10, i15, i2) {
 i10 = i10 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 1680 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17 + 16 | 0;
 i16 = i17;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i11 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i11 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 i3 = i11 + 1636 | 0;
 i1 = i11 + 36 | 0;
 do {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i1 + 12 >> 2] = -1;
  HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i11 + 1640 >> 2] = i15;
 HEAP32[i11 + 1644 >> 2] = i10;
 HEAP32[i11 + 1648 >> 2] = i2;
 i18 = (HEAP32[i15 + 24 >> 2] | 0) >>> 5;
 i7 = HEAP32[i15 + 28 >> 2] | 0;
 i7 = (i7 | 0) == 0 ? 0 : i15 + i7 | 0;
 i20 = HEAP32[i15 + 40 >> 2] | 0;
 i19 = HEAP32[i15 + 36 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i15 + 4 >> 2] | 0;
 i4 = HEAP32[i15 + 8 >> 2] | 0;
 i9 = i15 + 12 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i15 + 16 >> 2] | 0;
 i2 = HEAP32[i15 + 20 >> 2] | 0;
 i8 = i11 + 32 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i12 >> 2] = i18;
 HEAP32[i13 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i7 + (((i18 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i14 >> 2] = i15;
 HEAP32[i11 + 20 >> 2] = i20;
 HEAP32[i11 + 24 >> 2] = 4;
 HEAP32[i11 + 28 >> 2] = i19;
 if (i18 | 0) {
  i20 = HEAP32[i7 >> 2] & 3;
  HEAP32[i11 + 36 >> 2] = i1;
  HEAP32[i11 + 40 >> 2] = i3;
  HEAP32[i11 + 44 >> 2] = i4;
  HEAP32[i11 + 48 >> 2] = 0;
  HEAP32[i11 + 52 >> 2] = i5;
  HEAP32[i11 + 56 >> 2] = i6;
  HEAP32[i11 + 60 >> 2] = i2;
  HEAP8[i11 + 64 >> 0] = 0;
  HEAP8[i11 + 65 >> 0] = i20;
  HEAP8[i11 + 66 >> 0] = 63;
  HEAP8[i11 + 67 >> 0] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 HEAP8[i11 + 1636 >> 0] = 1;
 __ZN14CellVisualizer7executeEv(i11);
 HEAPF32[i16 >> 2] = Math_fround(1.0);
 HEAPF32[i16 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i16 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i16 + 12 >> 2] = Math_fround(1.0);
 i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i15 | 0, i9 | 0, i16 | 0);
 STACKTOP = i17;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 3;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469578 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN27ComputeShaderBuiltinSampler8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469578 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN27ComputeShaderBuiltinSampler8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 76;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 76;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZNK7ApiGLES6VerifyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 662 >> 0] | 0) {
  i3 = i1 + 764 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = i1 + 860 | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i2 >> 2] | 0, 3) | 0) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_ii(i3 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i2 >> 2] | 0, 2) | 0) | 0;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 511 >> 0] | 0) {
  i4 = HEAP32[i1 + 764 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 + 860 >> 2] | 0, 11) | 0) | 0;
 }
 i2 = i1 + 764 | 0;
 if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -5 | 0) >>> 0 < 8) {
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = i1 + 860 | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 6) | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 7) | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 8) | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 10) | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 16) | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 15) | 0) | 0;
 } else i1 = i1 + 860 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 0) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 1) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 4) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 5) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 9) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 12) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 13) | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i1 >> 2] | 0, 14) | 0) | 0;
 return 1;
}

function __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 731490 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i12 = i2 + 24 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1 + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 << 5) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + (i1 << 5) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + (i1 << 5) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + (i1 << 5) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + (i1 << 5) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + (i1 << 5) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 i10 = i6 + 24 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 5) + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 5) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 5) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 5) | 0;
 return i12 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 192 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 192 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 192 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 192 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN9ShaderLab20SerializedSubProgramaSERKS0_(i2, i3) | 0;
   i3 = i3 + 192 | 0;
   i2 = i2 + 192 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -192 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i2, i1);
   i1 = i1 + 192 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 192 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -192 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 22369621) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 192 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 11184810 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 22369621;
 if (i1 >>> 0 > 22369621) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 192 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 192 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i2, i1);
  i1 = i1 + 192 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 192 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN5audio5mixer14EffectConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i5 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i4 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS9_(i8, i9, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 __ZNK15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E13find_positionERS5_(i1, i9, i7);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i6 = HEAP32[i9 + 92 >> 2] | 0;
  i7 = i6 + ((HEAP32[i9 + 96 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i8 + 4 >> 2] = i6 + (i2 * 40 | 0);
  HEAP32[i8 + 8 >> 2] = i7;
  HEAP8[i8 + 12 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i9 + 8 >> 0] | 0)) i5 = 14; else {
  i2 = i9 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i5 = 14; else {
   i4 = i9 + 92 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) >> 2] | 0)) if ((HEAP32[i9 + 16 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 4 >> 2] | 0)) if ((HEAP32[i9 + 20 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 8 >> 2] | 0)) if ((HEAP32[i9 + 24 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 12 >> 2] | 0)) if ((HEAP32[i9 + 28 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 16 >> 2] | 0)) if ((HEAP32[i9 + 32 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 20 >> 2] | 0)) if ((HEAP32[i9 + 36 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 24 >> 2] | 0)) if ((HEAP32[i9 + 40 >> 2] | 0) == (HEAP32[i1 + (i6 * 40 | 0) + 28 >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i5 = 14; else i5 = 14; else i5 = 14; else i5 = 14; else i5 = 14; else i5 = 14; else i5 = 14; else i5 = 14;
  }
 }
 if ((i5 | 0) == 14) {
  i1 = i9 + 100 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i9 + 92 | 0;
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i1 + (i6 * 40 | 0) | 0;
 i1 = i7;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i5 = HEAP32[i4 >> 2] | 0;
 i7 = i5 + ((HEAP32[i9 + 96 >> 2] | 0) * 40 | 0) | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i5 + (i6 * 40 | 0);
 HEAP32[i8 + 8 >> 2] = i7;
 HEAP8[i8 + 12 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 479385 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 479385 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13TrailRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 24 | 0;
 i5 = i4;
 i10 = i4 + 16 | 0;
 i7 = i4 + 8 | 0;
 i14 = i2;
 i8 = HEAP32[i14 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 5, i6, i3);
 HEAP32[i1 >> 2] = gb + 55828 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 55828 + 184;
 HEAP8[i1 + 340 >> 0] = 0;
 HEAP8[i1 + 341 >> 0] = 0;
 HEAP32[i1 + 348 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 i3 = i1 + 360 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f13 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 372 >> 2] = f13;
 HEAPF32[i1 + 376 >> 2] = f12;
 HEAPF32[i1 + 380 >> 2] = f11;
 HEAPF32[i1 + 388 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 392 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 396 >> 0] = 0;
 HEAP32[i1 + 400 >> 2] = 0;
 HEAP32[i1 + 404 >> 2] = 0;
 HEAP32[i1 + 408 >> 2] = -1;
 HEAP32[i1 + 412 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(196, i2, 16, gb + 421073 | 0, 54) | 0;
 i10 = i2;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN14LineParametersC2E10MemLabelId(i3, i6);
 HEAP32[i1 + 384 >> 2] = i3;
 i3 = __ZnwjRK10MemLabelIdiPKci(28, i2, 16, gb + 421073 | 0, 55) | 0;
 i7 = i2;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 56200 + 8;
 i2 = i5;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 + 344 >> 2] = i3;
 i3 = i1 + 268 | 0;
 i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16531455;
 HEAP16[i3 >> 1] = i2;
 HEAP8[i3 + 2 >> 0] = i2 >>> 16;
 STACKTOP = i4;
 return;
}

function __Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i18 = i2 + 12 | 0;
 f13 = Math_fround(HEAPF32[i18 >> 2]);
 f3 = Math_fround(HEAPF32[i18 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i18 + 8 >> 2]);
 f7 = Math_fround(f8 - f7);
 f11 = Math_fround(f9 - f11);
 f12 = Math_fround(f10 - f12);
 i18 = f7 < Math_fround(-f13);
 i16 = f11 < Math_fround(-f3);
 i14 = f12 < Math_fround(-f5);
 f10 = Math_fround(-f7);
 f9 = Math_fround(-f11);
 f8 = Math_fround(-f12);
 i17 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i15 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = (HEAP32[tempDoublePtr >> 2] = i18 ? i1 : i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i16 ? i2 : i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f7 + f8);
 f9 = Math_fround(f11 + f9);
 f10 = Math_fround(f12 + (HEAP32[tempDoublePtr >> 2] = i14 ? i6 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i4 = f7 > f13 ? i1 : (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f11 > f3 ? i2 : (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i18 = f12 > f5 ? i6 : (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 - f5);
 f11 = Math_fround(f11 - f13);
 f13 = Math_fround(f12 - (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 return Math_fround(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f11 * f11)) + Math_fround(Math_fround(f13 * f13) + Math_fround(0.0))) + Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0))) + Math_fround(0.0)));
}

function __Z19InitializeGfxDevicej(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __Z20GetPlayerSettingsPtrv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 396642 | 0, 14);
 i6 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (i6) HEAP8[i1 + 415 >> 0] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 9260 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 8492 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 8492 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 8492 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i2 = _JS_SystemInfo_HasWebGL() | 0;
 i1 = __Z16GetBuildSettingsv() | 0;
 i6 = i1 + 168 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 L12 : do if (!i4) i7 = 21; else {
  i5 = i1 + 156 | 0;
  if ((i2 | 0) > 1) {
   i3 = 0;
   i1 = 0;
   do {
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if ((i1 | 0) == 0 & (i2 | 0) == 11) i1 = __Z19CreateGLESGfxDevice17GfxDeviceRenderer(11) | 0;
    if ((i2 | 0) == 8 & (i1 | 0) == 0) i1 = __Z19CreateGLESGfxDevice17GfxDeviceRenderer(8) | 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
  } else {
   if ((i2 | 0) == 1) {
    i3 = 0;
    i1 = 0;
    i2 = i4;
   } else {
    i1 = 0;
    while (1) {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) {
      i7 = 21;
      break L12;
     }
    }
   }
   do {
    if ((i1 | 0) == 0 ? (HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) == 8 : 0) {
     i1 = __Z19CreateGLESGfxDevice17GfxDeviceRenderer(8) | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i2 >>> 0);
  }
  if (!i1) i7 = 21;
 } while (0);
 if ((i7 | 0) == 21) {
  i1 = __Z19CreateNullGfxDevicev() | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[gb + 1157628 >> 2] = i1;
 __Z19GetActiveColorSpacev() | 0;
 __ZN12GraphicsCaps24SharedCapsPostInitializeEv(__Z15GetGraphicsCapsv() | 0);
 __ZN12TextureIdMap10InitializeEv();
 __ZN16RenderTextureMap10InitializeEv();
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 HEAP32[gb + 1115296 + 240 >> 2] = fb + 39;
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN17GenericDynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i11 = HEAP32[i3 + 12 >> 2] | 0;
 i11 = (i11 | 0) < 0 ? gb + 1161312 | 0 : gb + 1161272 + ((i11 & 1) * 20 | 0) | 0;
 if (!i2) {
  i10 = i3 + 8 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i10 * 36 | 0) | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i11 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i3 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i7 >>> 0 > i1 >>> 0) {
  i10 = i8;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + (i10 * 36 | 0) | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i5 = i1 + 1 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = i5;
 i2 = i11 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i4 >>> 0 < i5 >>> 0) {
  i1 = i3 << 1;
  i1 = i1 >>> 0 > i5 >>> 0 ? i1 : i5;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 * 36 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 36 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 >> 2] = i4;
   break;
  }
 } while (0);
 if (i5 >>> 0 > i7 >>> 0) {
  i3 = (HEAP32[i11 >> 2] | 0) + (i7 * 36 | 0) | 0;
  i2 = i5 - i7 | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    i7 = i3 + (i1 * 36 | 0) | 0;
    HEAP8[i7 >> 0] = 0;
    i6 = i7 + 1 | 0;
    HEAP8[i6 >> 0] = HEAP8[i9 >> 0] | 0;
    HEAP8[i6 + 1 >> 0] = HEAP8[i9 + 1 >> 0] | 0;
    HEAP8[i6 + 2 >> 0] = HEAP8[i9 + 2 >> 0] | 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    HEAP32[i7 + 12 >> 2] = 0;
    HEAP32[i7 + 16 >> 2] = -1;
    i7 = i7 + 20 | 0;
    HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 i10 = i8;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i11 = i11 + (i10 * 36 | 0) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i3 = i9;
 i4 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, 0) | 0;
 if (!i4) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 9;
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i4) | 0)) {
  i10 = -1;
  STACKTOP = i9;
  return i10 | 0;
 }
 i5 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i6, i7) | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 24 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i10 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 24;
 HEAP32[i4 + (i5 * 360 | 0) + 328 >> 2] = i10;
 HEAP32[i4 + (i5 * 360 | 0) + 332 >> 2] = fb + 219;
 HEAP32[i4 + (i5 * 360 | 0) + 344 >> 2] = fb + 2414;
 HEAP32[i4 + (i5 * 360 | 0) + 348 >> 2] = 1;
 HEAP32[i4 + (i5 * 360 | 0) + 340 >> 2] = fb + 517;
 i7 = HEAP32[(HEAP32[i8 + 360 >> 2] | 0) + 32 >> 2] | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP32[i10 >> 2] = i7;
 i7 = HEAP32[i8 + 376 >> 2] | 0;
 i4 = HEAP32[i8 + 368 >> 2] | 0;
 i6 = HEAP32[i8 + 372 >> 2] | 0;
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 364 >> 2];
 HEAP32[i10 + 8 >> 2] = i4;
 HEAP32[i10 + 12 >> 2] = i6;
 HEAP32[i10 + 16 >> 2] = i7;
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 4 >> 2];
 i10 = i5;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i4, HEAP32[i2 >> 2] | 0, i12 + 8 | 0);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37212 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN13WheelCollider24SetForceAppPointDistanceEf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i5 + 92 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) != f1) HEAPF32[i7 >> 2] = f1;
 i4 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0;
 i2 = i5 + 148 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i3 + 52 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i3 + 56 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = i5 + 28 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i5 + 72 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i6 + 4 >> 2]));
 i5 = f10 < Math_fround(0.0);
 f11 = Math_fround(-f10);
 f10 = i5 ? f11 : f10;
 i5 = f10 < Math_fround(9.99999974e-06);
 f10 = i5 ? Math_fround(9.99999974e-06) : f10;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i7 = f1 < Math_fround(0.0);
 f9 = Math_fround(-f1);
 f1 = Math_fround(f11 * (i7 ? f9 : f1));
 i7 = i4 + 56 | 0;
 i5 = (HEAP32[i7 >> 2] | 0) + 8 | 0;
 i4 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i5, HEAP32[i2 >> 2] | 0) | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i5, HEAP32[i2 >> 2] | 0) | 0;
 f1 = Math_fround(f10 - f1);
 f10 = Math_fround(f1 * Math_fround(HEAPF32[i3 >> 2]));
 f9 = Math_fround(f1 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i4 >> 2]));
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i4 + 4 >> 2]));
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 HEAPF32[i6 >> 2] = f10;
 HEAPF32[i6 + 4 >> 2] = f9;
 HEAPF32[i6 + 8 >> 2] = f1;
 __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i5, HEAP32[i2 >> 2] | 0, i6);
 __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i5, HEAP32[i2 >> 2] | 0, i6);
 i7 = HEAP32[(HEAP32[i7 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 284 >> 2] | 0, i7 | 0);
 STACKTOP = i8;
 return;
}

function __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i1, i2, i7, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, i8 = 0, f9 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i13 = i2 + 88 | 0;
 f12 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i7 >> 2]), 0));
 i11 = i2 + 80 | 0;
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i11 >> 2]));
 i3 = i7 + 4 | 0;
 f4 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i3 >> 2]), 0));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i11 >> 2]));
 i5 = i7 + 8 | 0;
 f6 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i5 >> 2]), 0));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
 i8 = i7 + 12 | 0;
 f9 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i8 >> 2]), 0));
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i11 >> 2]));
 if ((HEAP16[i2 + 84 >> 1] | 0) != 2) {
  HEAPF32[i1 >> 2] = f12;
  i13 = i1 + 4 | 0;
  HEAPF32[i13 >> 2] = f4;
  i13 = i1 + 8 | 0;
  HEAPF32[i13 >> 2] = f6;
  i13 = i1 + 12 | 0;
  HEAPF32[i13 >> 2] = f9;
  return;
 }
 i13 = i2 + 176 | 0;
 f14 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i7 >> 2]), 0));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i11 >> 2]));
 f15 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i3 >> 2]), 0));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i11 >> 2]));
 f16 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i5 >> 2]), 0));
 f16 = Math_fround(f16 * Math_fround(HEAPF32[i11 >> 2]));
 f17 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i13, Math_fround(HEAPF32[i8 >> 2]), 0));
 f17 = Math_fround(f17 * Math_fround(HEAPF32[i11 >> 2]));
 f20 = Math_fround(f12 - f14);
 f19 = Math_fround(f4 - f15);
 f18 = Math_fround(f6 - f16);
 f12 = Math_fround(f9 - f17);
 f4 = Math_fround(f20 * Math_fround(HEAPF32[i10 >> 2]));
 f6 = Math_fround(f19 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 f9 = Math_fround(f18 * Math_fround(HEAPF32[i10 + 8 >> 2]));
 f12 = Math_fround(f17 + Math_fround(f12 * Math_fround(HEAPF32[i10 + 12 >> 2])));
 f9 = Math_fround(f16 + f9);
 f6 = Math_fround(f15 + f6);
 f4 = Math_fround(f14 + f4);
 HEAPF32[i1 >> 2] = f4;
 i13 = i1 + 4 | 0;
 HEAPF32[i13 >> 2] = f6;
 i13 = i1 + 8 | 0;
 HEAPF32[i13 >> 2] = f9;
 i13 = i1 + 12 | 0;
 HEAPF32[i13 >> 2] = f12;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 24 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     if (HEAP32[i2 + 20 >> 2] | 0) __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv(i2);
     i10 = (HEAP32[i2 >> 2] | 0) + 46 | 0;
     HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + -1 << 16 >> 16;
     i10 = (HEAP32[i2 + 4 >> 2] | 0) + 46 | 0;
     HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + -1 << 16 >> 16;
    }
    i2 = i2 + 24 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_(i15, i16, i14, i13, i18, i17) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = i15;
 i12 = 1;
 i2 = i15;
 L1 : while (1) {
  i1 = i3;
  L3 : while (1) {
   i11 = i1 * 3 | 0;
   i9 = (HEAP32[i13 + (i11 << 2) >> 2] | 0) == (i16 | 0);
   i10 = (i1 | 0) == (i15 | 0);
   i11 = i13 + (i11 + 1 << 2) | 0;
   i4 = i2;
   while (1) {
    i8 = (i4 | 0) == (i15 | 0);
    while (1) {
     if (i9) {
      i3 = 0;
      i6 = 1;
     } else {
      i3 = (HEAP32[i11 >> 2] | 0) != (i16 | 0) & 1;
      i6 = 2;
     }
     i2 = HEAP32[i14 + (i1 * 12 | 0) + (i3 << 2) >> 2] | 0;
     i7 = HEAP32[i14 + (i1 * 12 | 0) + (i6 << 2) >> 2] | 0;
     i5 = (i7 & 536870912 | 0) == 0;
     if (i2 & 536870912 | 0) {
      i7 = 8;
      break L3;
     }
     if (!i5) {
      i2 = i6;
      i7 = 16;
      break L3;
     }
     if (i10) {
      i1 = 0;
      i7 = 21;
      break L1;
     }
     i2 = i2 & 536870911;
     i3 = (i2 | 0) == (i15 | 0);
     if (i8) break;
     if (i3) {
      i1 = 0;
      i7 = 21;
      break L1;
     }
     if ((i2 | 0) != (i4 | 0)) {
      i11 = i1;
      i1 = i2;
      i2 = i11;
      continue L3;
     }
     i2 = i7 & 536870911;
     if ((i2 | 0) == (i15 | 0)) {
      i1 = 0;
      i7 = 21;
      break L1;
     }
     if ((i2 | 0) != (i4 | 0)) {
      i11 = i1;
      i1 = i2;
      i2 = i11;
      continue L3;
     }
    }
    if (!i3) {
     i11 = i1;
     i1 = i2;
     i2 = i11;
     continue L3;
    }
    i2 = i7 & 536870911;
    if ((i2 | 0) == (i15 | 0)) i4 = i15; else {
     i11 = i1;
     i1 = i2;
     i2 = i11;
     continue L3;
    }
   }
  }
  if ((i7 | 0) == 8) if (i5) {
   i3 = i6;
   i5 = i4;
  } else {
   i1 = 0;
   i7 = 21;
   break;
  } else if ((i7 | 0) == 16) {
   i2 = HEAP32[i14 + (i1 * 12 | 0) + (i2 << 2) >> 2] | 0;
   i5 = i4;
  }
  i11 = (i2 & 536870912 | 0) == 0;
  i4 = i11 & i12;
  if (!(i12 | i11)) {
   i7 = 18;
   break;
  }
  i2 = HEAP32[i14 + (i1 * 12 | 0) + (i3 << 2) >> 2] | 0;
  if (i2 & 536870912 | 0) {
   i3 = i1;
   i12 = i4;
   i2 = i5;
   continue;
  }
  i3 = i2 & 536870911;
  i2 = (i3 | 0) == (i15 | 0);
  i3 = i2 ? i1 : i3;
  i12 = i4;
  i2 = i2 ? i5 : i1;
 }
 if ((i7 | 0) == 18) {
  HEAP32[i18 >> 2] = i2 & 536870911;
  HEAP32[i17 >> 2] = i1;
  i18 = 1;
  return i18 | 0;
 } else if ((i7 | 0) == 21) return i1 | 0;
 return 0;
}

function __ZN5physx24PxComputeMeshPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES5_Rj(i20, i9, i8, i1, i10, i11, i21) {
 i20 = i20 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i21 = i21 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i22 = 0, i23 = 0, i24 = 0, f25 = f0, f26 = f0, f27 = f0, f28 = f0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i22 + 16 | 0;
 i12 = i22 + 4 | 0;
 i7 = i22;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i14 = i13 + 16 | 0;
 i18 = i1 + 16 | 0;
 i24 = HEAP32[i18 >> 2] | 0;
 HEAP32[i14 >> 2] = i24;
 i15 = i13 + 20 | 0;
 i19 = i1 + 20 | 0;
 i23 = HEAP32[i19 >> 2] | 0;
 HEAP32[i15 >> 2] = i23;
 i16 = i13 + 24 | 0;
 i17 = i1 + 24 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 HEAP32[i16 >> 2] = i1;
 i5 = i12 + 4 | 0;
 i6 = i12 + 8 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f3 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f2 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 L1 : do if (!i9) i1 = 0; else {
  i1 = 0;
  while (1) {
   if (!(__ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_(i12, i7, i8, i13, i10, i11) | 0)) break;
   f28 = Math_fround(HEAPF32[i7 >> 2]);
   f27 = Math_fround(HEAPF32[i12 >> 2]);
   f26 = Math_fround(HEAPF32[i5 >> 2]);
   f25 = Math_fround(HEAPF32[i6 >> 2]);
   f4 = Math_fround(HEAPF32[i14 >> 2]);
   f3 = Math_fround(HEAPF32[i15 >> 2]);
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   i1 = i1 + 1 | 0;
   f26 = Math_fround(f28 * f26);
   f25 = Math_fround(f28 * f25);
   f4 = Math_fround(Math_fround(f28 * f27) + f4);
   HEAPF32[i14 >> 2] = f4;
   f3 = Math_fround(f26 + f3);
   HEAPF32[i15 >> 2] = f3;
   f2 = Math_fround(f25 + f2);
   HEAPF32[i16 >> 2] = f2;
   if (i1 >>> 0 >= i9 >>> 0) break L1;
  }
  f4 = Math_fround(HEAPF32[i14 >> 2]);
  f3 = Math_fround(HEAPF32[i15 >> 2]);
  f2 = Math_fround(HEAPF32[i16 >> 2]);
 } while (0);
 HEAP32[i21 >> 2] = i1;
 f26 = Math_fround(f4 - Math_fround(HEAPF32[i18 >> 2]));
 f27 = Math_fround(f3 - Math_fround(HEAPF32[i19 >> 2]));
 f28 = Math_fround(f2 - Math_fround(HEAPF32[i17 >> 2]));
 HEAPF32[i20 >> 2] = f26;
 HEAPF32[i20 + 4 >> 2] = f27;
 HEAPF32[i20 + 8 >> 2] = f28;
 STACKTOP = i22;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 * 40 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 40 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 * 40 | 0) | 0, 0, (i4 - i5 | 0) * 40 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 * 40 | 0) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i12, i1 + 4 | 0, gb + 1034365 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i12, i1 + 16 | 0, gb + 1034371 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i12, i1 + 28 | 0, gb + 1034379 | 0, 0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 51;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 51;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZN16ReflectionProbes8AddProbeE4PPtrI15ReflectionProbeE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i3 = i11;
 i10 = i9 + 12 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i3 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 i3 = i9 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 28 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i11;
  return;
 }
 i2 = i7 << 1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 if (i8 >>> 0 >= i2 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i11;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 2, 4, i9 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i11;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE10addContentEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i10 = i12;
 i8 = i12 + 48 | 0;
 i9 = i12 + 16 | 0;
 i1 = i2 + 28 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i7 = HEAP32[i2 + 8 >> 2] | 0;
  mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
  mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086447 | 0, 1) | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i12;
  return;
 }
 i7 = i2 + 8 | 0;
 do {
  i6 = i1 << 24 >> 24;
  L9 : do switch (i6 | 0) {
  case 60:
   {
    i6 = HEAP32[i7 >> 2] | 0;
    mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 767358 | 0, 4) | 0;
    break;
   }
  case 62:
   {
    i6 = HEAP32[i7 >> 2] | 0;
    mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 767417 | 0, 4) | 0;
    break;
   }
  case 38:
   {
    i6 = HEAP32[i7 >> 2] | 0;
    mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 767352 | 0, 5) | 0;
    break;
   }
  case 39:
   {
    i6 = HEAP32[i7 >> 2] | 0;
    mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 767429 | 0, 6) | 0;
    break;
   }
  case 34:
   {
    i6 = HEAP32[i7 >> 2] | 0;
    mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 767422 | 0, 6) | 0;
    break;
   }
  default:
   {
    i5 = i1 + -9 << 24 >> 24;
    i2 = (i5 & 255) < 5;
    if (i2) i4 = (19 >>> (i5 & 31) & 1) != 0; else i4 = 0;
    if (i1 << 24 >> 24 > 31 | i4) {
     if (i2) if (19 >>> (i5 & 31) & 1) {
      HEAP32[i10 >> 2] = i6;
      __ZN5physx6string9sprintf_sEPcjPKcz(i9, 32, gb + 766933 | 0, i10) | 0;
      i1 = HEAP32[i7 >> 2] | 0;
      if (!(HEAP8[i9 >> 0] | 0)) break L9;
      i6 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
      mftCall_iiii(i6 | 0, i1 | 0, i9 | 0, _strlen(i9) | 0) | 0;
      break L9;
     }
     i1 = HEAP32[i7 >> 2] | 0;
     i2 = i8;
     i4 = i2 + 128 | 0;
     do {
      HEAP8[i2 >> 0] = 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) < (i4 | 0));
     HEAP32[i11 >> 2] = i6;
     __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 766942 | 0, i11) | 0;
     if (HEAP8[i8 >> 0] | 0) {
      i6 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
      mftCall_iiii(i6 | 0, i1 | 0, i8 | 0, _strlen(i8) | 0) | 0;
     }
    }
   }
  } while (0);
  i3 = i3 + 1 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
 } while (i1 << 24 >> 24 != 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferEPNS_12PxFoundationEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = (i3 | 0) == 0;
 if (i2) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 152, gb + 766896 | 0, gb + 740601 | 0, 170) | 0;
 HEAP32[i12 >> 2] = gb + 147756 + 8;
 HEAP32[i12 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i12 + 8 >> 2] = gb + 147756 + 80;
 i11 = i12 + 16 | 0;
 if (i2) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i11 >> 2] = gb + 147848 + 8;
 i7 = i12 + 20 | 0;
 HEAP32[i7 >> 2] = i1;
 i6 = i12 + 24 | 0;
 HEAP32[i6 >> 2] = i7;
 i2 = i12 + 28 | 0;
 HEAP32[i2 >> 2] = gb + 773653;
 i8 = i12 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i12 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 40 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 44 >> 2] = i7;
 HEAP32[i12 + 48 >> 2] = 0;
 HEAP32[i12 + 52 >> 2] = 0;
 HEAP32[i12 + 56 >> 2] = 0;
 HEAP32[i12 + 60 >> 2] = i4;
 HEAP32[i12 + 88 >> 2] = 0;
 HEAP8[i12 + 92 >> 0] = 0;
 HEAP32[i12 + 96 >> 2] = i6;
 i1 = i4 + 68 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3;
 i5 = (HEAP32[i9 >> 2] | 0) - i4 | 0;
 if (((HEAP32[i10 >> 2] | 0) - i4 | 0) >>> 0 <= i1 >>> 0) {
  i4 = i1 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i2 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i5 | 0) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) {
    i6 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
   }
  }
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i2 + i5;
  HEAP32[i10 >> 2] = i2 + i4;
 }
 HEAP32[i11 >> 2] = gb + 147876 + 8;
 i11 = i12 + 100 | 0;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i12 + 104 >> 2] = gb + 773688;
 i10 = i12 + 108 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAPF32[i12 + 132 >> 2] = Math_fround(.75);
 HEAP32[i12 + 136 >> 2] = -1;
 HEAP32[i12 + 140 >> 2] = 0;
 HEAP32[i12 + 144 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, 64);
 return i12 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 296 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034552 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 296 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034552 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 296 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14ParticleTrails10ReallocateEjj(i14, i15, i1) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i16;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i14 + 84 >> 2] | 0;
  i1 = i1 >>> 0 < 4 ? 4 : i1;
 }
 i13 = i14 + 80 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 < i15 >>> 0) {
  HEAP32[i3 >> 2] = i1 + -1;
  __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i14 + 20 | 0, i15, i3, 1);
  HEAP32[i3 >> 2] = 0;
  __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i14 + 40 | 0, i15, i3, 1);
  HEAP32[i3 >> 2] = 0;
  __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i14 + 60 | 0, i15, i3, 1);
  i2 = HEAP32[i13 >> 2] | 0;
 }
 if (i2 >>> 0 >= i15 >>> 0) if ((HEAP32[i14 + 84 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i16;
  return;
 }
 i11 = Math_imul(i1, i15) | 0;
 i10 = i14 + 4 | 0;
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11 << 4, 4, i10, 0, gb + 613155 | 0, 45) | 0;
 if (i15 | 0) {
  i6 = i14 + 60 | 0;
  i7 = i14 + 40 | 0;
  i8 = i14 + 20 | 0;
  i9 = i14 + 84 | 0;
  i5 = 0;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   if (HEAP32[i2 + (i5 << 2) >> 2] | 0) {
    i4 = Math_imul(i5, i1) | 0;
    i3 = 0;
    do {
     i2 = i12 + (i3 + i4 << 4) | 0;
     i18 = HEAP32[i9 >> 2] | 0;
     i17 = Math_imul(i18, i5) | 0;
     i17 = (HEAP32[i14 >> 2] | 0) + (((((HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] | 0) + i3 | 0) >>> 0) % (i18 >>> 0) | 0) + i17 << 4) | 0;
     HEAP32[i2 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     i3 = i3 + 1 | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    } while (i3 >>> 0 < (HEAP32[i2 + (i5 << 2) >> 2] | 0) >>> 0);
   }
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] = 0;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] = (((HEAP32[i2 + (i5 << 2) >> 2] | 0) + -1 | 0) >>> 0) % (i1 >>> 0) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i15 | 0));
 }
 i3 = i14 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i10);
  HEAP32[i14 >> 2] = 0;
  i2 = i14;
 } else i2 = i14;
 i18 = i12 + (i11 << 4) - i12 >> 4;
 HEAP32[i14 + 12 >> 2] = i18;
 HEAP32[i2 >> 2] = i12;
 HEAP32[i3 >> 2] = i18 & 2147483647;
 HEAP32[i13 >> 2] = i15;
 HEAP32[i14 + 84 >> 2] = i1;
 STACKTOP = i16;
 return;
}

function __Z13tessTesselateP14TESStesselatoriiiiPKf(i8, i3, i9, i10, i4, i5) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i11 = 0;
 i1 = i8 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[i8 + 112 >> 2] | 0, HEAP32[i8 + 116 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[i8 + 112 >> 2] | 0, HEAP32[i8 + 116 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[i8 + 112 >> 2] | 0, HEAP32[i8 + 116 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i8 + 80 >> 2] = 0;
 if (i5 | 0) {
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 8 >> 2];
 }
 HEAP32[i8 + 60 >> 2] = i3;
 i5 = (i4 | 0) < 2 ? 2 : i4;
 i5 = (i5 | 0) > 3 ? 3 : i5;
 if (!(HEAP32[i8 >> 2] | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 __Z18tessProjectPolygonP14TESStesselator(i8);
 if (!(__Z19tessComputeInteriorP14TESStesselator(i8) | 0)) _longjmp(i8 + 144 | 0, 1);
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = (i9 | 0) == 2;
 L19 : do if (i7) {
  i4 = i6 + 68 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) i11 = 24; else {
   while (1) {
    i2 = i1;
    i1 = HEAP32[i1 >> 2] | 0;
    i3 = HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 21 >> 0] | 0;
    if ((HEAP8[(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 20 >> 2] | 0) + 21 >> 0] | 0) == i3 << 24 >> 24) {
     if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(i6, i2) | 0)) break;
    } else HEAP32[i2 + 28 >> 2] = i3 << 24 >> 24 ? 1 : -1;
    if ((i1 | 0) == (i4 | 0)) {
     i11 = 23;
     break L19;
    }
   }
   i10 = i8 + 144 | 0;
   _longjmp(i10 | 0, 1);
  }
 } else {
  i3 = i6 + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i11 = 25; else {
   while (1) {
    i2 = i1;
    i1 = HEAP32[i1 >> 2] | 0;
    if (HEAP8[i2 + 21 >> 0] | 0) if (!(__Z28tessMeshTessellateMonoRegionP8TESSmeshP8TESSface(i6, i2) | 0)) break;
    if ((i1 | 0) == (i3 | 0)) {
     i11 = 23;
     break L19;
    }
   }
   i10 = i8 + 144 | 0;
   _longjmp(i10 | 0, 1);
  }
 } while (0);
 if ((i11 | 0) == 23) if (i7) i11 = 24; else i11 = 25;
 if ((i11 | 0) == 24) __Z14OutputContoursP14TESStesselatorP8TESSmeshi(i8, i6, i5); else if ((i11 | 0) == 25) __Z14OutputPolymeshP14TESStesselatorP8TESSmeshiii(i8, i6, i9, i10, i5);
 __Z18tessMeshDeleteMeshP9TESSallocP8TESSmesh(i8 + 104 | 0, i6);
 HEAP32[i8 >> 2] = 0;
 i11 = (HEAP32[i8 + 4 >> 2] | 0) == 0 & 1;
 return i11 | 0;
}

function __ZNK17MonoScriptManager20GetAllRuntimeScriptsER13dynamic_arrayIP10MonoScriptLj4EE(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i14 = i16;
 i2 = HEAP32[i1 >> 2] | 0;
 i9 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i10 = i12 + 12 | 0;
 i11 = i12 + 16 | 0;
 i8 = i12 + 4 | 0;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i14 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
     i3 = HEAP32[i13 >> 2] | 0;
     i7 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i15 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i15 = 11;
    }
   }
   if ((i15 | 0) == 9) i15 = 11;
   if ((i15 | 0) == 11) {
    i15 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i11 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i3 = i6 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i11 >> 2] = i3;
     HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i3 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
     HEAP32[i11 >> 2] = i3;
     HEAP32[i12 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i10 >> 2] = i5;
   HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i1;
  } while (0);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sc17ParticleSystemSimC2ERNS0_5SceneERNS0_18ParticleSystemCoreE(i4, i1, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE(i4, i1, i7, 8);
 HEAP32[i4 >> 2] = gb + 91148 + 8;
 HEAP32[i4 + 328 >> 2] = 0;
 HEAP8[i4 + 320 >> 0] = 1;
 HEAP32[i4 + 324 >> 2] = i4 + 64;
 HEAP32[i4 + 332 >> 2] = 64;
 HEAP32[i4 + 336 >> 2] = 32;
 HEAP32[i4 + 340 >> 2] = 0;
 HEAP32[i4 + 344 >> 2] = 0;
 HEAP32[i4 + 348 >> 2] = 1664;
 i6 = i4 + 352 | 0;
 i1 = i4 + 372 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP16[i4 + 376 >> 1] = -1;
 HEAP16[i4 + 378 >> 1] = 0;
 HEAP32[i4 + 380 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i4 + 384 >> 2] = 0;
 HEAP32[i4 + 388 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 91176 + 8;
 HEAP32[i4 + 392 >> 2] = i4;
 HEAP32[i4 + 396 >> 2] = gb + 683923;
 i1 = i4 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 32) __ZN5physx2Sc5Actor19reallocInteractionsERPPNS0_11InteractionERjjj(i4, i4 + 20 | 0, i1, HEAP32[i4 + 28 >> 2] | 0, 32);
 i2 = HEAP32[(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0) + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i5 = __ZN5physx2Sc18ParticleSystemCore20obtainStandaloneDataEv(i7) | 0;
 i6 = i4 + 52 | 0;
 i9 = ((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i6 >> 2] | 0) | 0) & 64) != 0;
 i3 = i7 + 52 | 0;
 i1 = __ZN5physx10PxsContext17addParticleSystemEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb(i2, i5, i3, i9) | 0;
 i4 = i4 + 56 | 0;
 HEAP32[i4 >> 2] = i1;
 if (!((i1 | 0) != 0 | i9 ^ 1)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 683965 | 0, 57, gb + 684071 | 0, i8);
  HEAP32[i4 >> 2] = __ZN5physx10PxsContext17addParticleSystemEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb(i2, i5, i3, 0) | 0;
  __ZN5physx2Sc18ParticleSystemCore17notifyCpuFallbackEv(HEAP32[i6 >> 2] | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!i1) {
  HEAP32[i7 + 4 >> 2] = 0;
  __ZN5physx2Sc18ParticleSystemCore20returnStandaloneDataEPNS_15PxsParticleDataE(i7, i5);
  STACKTOP = i8;
  return;
 }
 if (!((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i6 >> 2] | 0) | 0) & 4)) {
  STACKTOP = i8;
  return;
 }
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, 1);
 STACKTOP = i8;
 return;
}

function __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i1, i3, i13) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i1) if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i11 = HEAP32[i2 + 40 >> 2] | 0;
 i12 = i1 + (i11 << 3) | 0;
 if (!i11) {
  i13 = 0;
  return i13 | 0;
 }
 i11 = i3 + 8 | 0;
 i10 = i1;
 i1 = 0;
 do {
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[i10 >> 2] << 2) >> 2] | 0;
  if ((i2 | 0) == (gb + 27592 | 0)) i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i10 + 4 >> 2] | 0) | 0; else {
   i9 = __Z21GetManagerFromContexti(5) | 0;
   i2 = HEAP32[(HEAP32[i9 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
  }
  if (i2) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i3) | 0) {
   i6 = HEAP32[i10 + 4 >> 2] | 0;
   i7 = HEAP32[i13 >> 2] | 0;
   i8 = i7 + 12 | 0;
   i9 = i7 + 16 | 0;
   do if (!(HEAP32[i8 >> 2] | 0)) {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 & 2147483646) >>> 0 < 10) if ((i1 | 0) > -1) {
     HEAP32[i9 >> 2] = 10;
     HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
     HEAP32[i9 >> 2] = 10;
     HEAP32[i7 >> 2] = i5;
     break;
    }
   } while (0);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i8 >> 2] = i3;
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   i1 = 1;
  }
  i10 = i10 + 8 | 0;
 } while ((i10 | 0) != (i12 | 0));
 return i1 | 0;
}

function __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i6 = i8;
 i13 = i8 + ((HEAP32[i2 >> 2] | 0) - i6 >> 2 << 2) | 0;
 i14 = i12 + 4 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i3 = i12 + 8 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i2 = i7;
 i4 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i13 | 0) == (i7 | 0)) {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 4;
   i14 = i13;
   return i14 | 0;
  }
  i4 = i2 - (i13 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i13 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i3 = i7;
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 4 | 0;
    HEAP32[i14 >> 2] = i3;
   } while (i2 >>> 0 < i7 >>> 0);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i13 | 0, i4 | 0) | 0;
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  i14 = i13;
  return i14 | 0;
 }
 i5 = (i2 - i6 >> 2) + 1 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i8 = HEAP32[i12 >> 2] | 0;
  i11 = i3;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i8;
 } else {
  i11 = i3;
  i2 = i4;
  i3 = i6;
 }
 i10 = i2 - i3 | 0;
 i7 = i10 >> 1;
 i7 = i10 >> 2 >>> 0 < 536870911 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 1073741823;
 i10 = i13;
 i5 = i10 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i9 = 0; else i9 = __Znwj(i7 << 2) | 0;
 i3 = i9 + (i6 << 2) | 0;
 i2 = i3;
 i4 = i9 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i3 = i3 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i3;
   i5 = i8;
   break;
  }
  i4 = i7 << 2 >> 1;
  i4 = (i4 | 0) == 0 ? 1 : i4;
  i7 = __Znwj(i4 << 2) | 0;
  i3 = i7 + (i4 >>> 2 << 2) | 0;
  i2 = i3;
  i4 = i7 + (i4 << 2) | 0;
  if (!i9) i5 = i8; else {
   __ZdlPv(i9);
   i5 = HEAP32[i12 >> 2] | 0;
  }
 } else i5 = i8; while (0);
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i3 = i2;
 i2 = i10 - i5 | 0;
 i6 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i6 | 0, i5 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i13 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 if (!i2) {
  i14 = i3;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i3;
 return i14 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE(i1, i5, i6, i7, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  do if (!i1) i3 = 1; else {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == -1) {
    HEAP32[i5 >> 2] = 0;
    i3 = 1;
    break;
   } else {
    i3 = (HEAP32[i5 >> 2] | 0) == 0;
    break;
   }
  } while (0);
  i2 = HEAP32[i6 >> 2] | 0;
  do if (!i2) i8 = 15; else {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) == -1) {
    HEAP32[i6 >> 2] = 0;
    i8 = 15;
    break;
   } else if (i3) {
    i3 = i2;
    break;
   } else {
    i3 = i2;
    break L1;
   }
  } while (0);
  if ((i8 | 0) == 15) {
   i8 = 0;
   if (i3) {
    i3 = 0;
    break;
   } else i3 = 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if (!(mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 8192, i1 | 0) | 0)) break;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   continue;
  } else {
   HEAP32[i2 >> 2] = i3 + 4;
   continue;
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) i2 = 1; else {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i2 = 1;
   break;
  } else {
   i2 = (HEAP32[i5 >> 2] | 0) == 0;
   break;
  }
 } while (0);
 do if (!i3) i8 = 37; else {
  i1 = HEAP32[i3 + 12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i3 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0; else i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i6 >> 2] = 0;
   i8 = 37;
   break;
  } else if (i2) break; else {
   i8 = 39;
   break;
  }
 } while (0);
 if ((i8 | 0) == 37) if (i2) i8 = 39;
 if ((i8 | 0) == 39) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI11KeyframeTplIfEEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i11 + 40 | 0;
 i8 = i11 + 24 | 0;
 i7 = i11 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 100; else i1 = (HEAP32[i1 >> 2] | 0) + 100 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i4 + 8 >> 2] | 0);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i6, i7) | 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = i9;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i10 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i9, 128, gb + 832323 | 0, i10) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  HEAP8[i10 >> 0] = 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  mftCall_iiii(i9 | 0, i6 | 0, i10 | 0, 1) | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + 8 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i6 + 20 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  mftCall_viii(i9 | 0, i5 | 0, i4 | 0, i10 | 0);
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i6 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_iiii(i8 | 0, i6 | 0, i9 | 0, _strlen(i9) | 0) | 0;
 HEAP8[i10 >> 0] = 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_iiii(i9 | 0, i6 | 0, i10 | 0, 1) | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = i9 + 8 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i6 + 20 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(i9 | 0, i5 | 0, i4 | 0, i10 | 0);
 i10 = i6 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i6 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831648;
 HEAP32[i1 + 4 >> 2] = 612;
 HEAP32[i1 + 8 >> 2] = fb + 537;
 HEAP32[i1 + 12 >> 2] = gb + 831660;
 HEAP32[i1 + 16 >> 2] = 613;
 HEAP32[i1 + 20 >> 2] = fb + 880;
 HEAP32[i1 + 24 >> 2] = fb + 881;
 HEAP32[i1 + 32 >> 2] = fb + 2386;
 HEAP32[i1 + 36 >> 2] = gb + 831675;
 HEAP32[i1 + 40 >> 2] = 614;
 HEAP32[i1 + 44 >> 2] = fb + 882;
 HEAP32[i1 + 48 >> 2] = fb + 883;
 HEAP32[i1 + 56 >> 2] = fb + 2387;
 HEAP32[i1 + 60 >> 2] = gb + 831685;
 HEAP32[i1 + 64 >> 2] = 615;
 HEAP32[i1 + 68 >> 2] = fb + 884;
 HEAP32[i1 + 72 >> 2] = fb + 885;
 HEAP32[i1 + 80 >> 2] = fb + 2388;
 HEAP32[i1 + 84 >> 2] = gb + 831694;
 HEAP32[i1 + 88 >> 2] = 616;
 HEAP32[i1 + 92 >> 2] = fb + 886;
 HEAP32[i1 + 96 >> 2] = fb + 887;
 HEAP32[i1 + 104 >> 2] = fb + 2389;
 HEAP32[i1 + 108 >> 2] = gb + 831714;
 HEAP32[i1 + 112 >> 2] = 617;
 HEAP32[i1 + 116 >> 2] = fb + 888;
 HEAP32[i1 + 120 >> 2] = fb + 889;
 HEAP32[i1 + 128 >> 2] = fb + 2390;
 HEAP32[i1 + 132 >> 2] = gb + 831738;
 HEAP32[i1 + 136 >> 2] = 618;
 HEAP32[i1 + 140 >> 2] = fb + 890;
 HEAP32[i1 + 144 >> 2] = fb + 891;
 HEAP32[i1 + 152 >> 2] = fb + 2391;
 HEAP32[i1 + 156 >> 2] = gb + 831762;
 HEAP32[i1 + 160 >> 2] = 619;
 HEAP32[i1 + 164 >> 2] = fb + 892;
 HEAP32[i1 + 168 >> 2] = fb + 893;
 HEAP32[i1 + 176 >> 2] = fb + 2392;
 HEAP32[i1 + 180 >> 2] = gb + 831780;
 HEAP32[i1 + 184 >> 2] = 620;
 HEAP32[i1 + 188 >> 2] = fb + 894;
 HEAP32[i1 + 192 >> 2] = fb + 899;
 HEAP32[i1 + 200 >> 2] = fb + 2393;
 HEAP32[i1 + 204 >> 2] = gb + 831798;
 HEAP32[i1 + 208 >> 2] = 621;
 HEAP32[i1 + 212 >> 2] = fb + 895;
 HEAP32[i1 + 216 >> 2] = fb + 896;
 HEAP32[i1 + 224 >> 2] = fb + 2394;
 HEAP32[i1 + 228 >> 2] = gb + 831819;
 HEAP32[i1 + 232 >> 2] = 622;
 HEAP32[i1 + 236 >> 2] = fb + 3928;
 HEAP32[i1 + 240 >> 2] = fb + 3929;
 HEAP32[i1 + 244 >> 2] = gb + 831838;
 HEAP32[i1 + 248 >> 2] = 623;
 HEAP32[i1 + 252 >> 2] = fb + 623;
 HEAP32[i1 + 256 >> 2] = fb + 538;
 HEAP32[i1 + 260 >> 2] = gb + 831861;
 HEAP32[i1 + 264 >> 2] = 624;
 HEAP32[i1 + 268 >> 2] = fb + 624;
 HEAP32[i1 + 272 >> 2] = fb + 539;
 HEAP32[i1 + 276 >> 2] = gb + 831880;
 HEAP32[i1 + 280 >> 2] = 625;
 HEAP32[i1 + 284 >> 2] = fb + 2395;
 HEAP32[i1 + 288 >> 2] = fb + 3930;
 HEAP32[i1 + 292 >> 2] = gb + 831908;
 HEAP32[i1 + 296 >> 2] = 626;
 HEAP32[i1 + 300 >> 2] = fb + 2396;
 HEAP32[i1 + 304 >> 2] = fb + 3931;
 HEAP32[i1 + 308 >> 2] = gb + 831937;
 HEAP32[i1 + 312 >> 2] = 627;
 HEAP32[i1 + 316 >> 2] = fb + 897;
 HEAP32[i1 + 320 >> 2] = fb + 900;
 HEAP32[i1 + 328 >> 2] = fb + 2397;
 return;
}

function __ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_(i3, i12, f1, i2, f10, i14, i13) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 f10 = Math_fround(f10);
 i14 = i14 | 0;
 i13 = i13 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f7 - f4);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(f8 - f18);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(f9 - f15);
 f11 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f16 * f16)) + Math_fround(f11 * f11)))) - f10) + Math_fround(-10.0));
 i2 = f11 > Math_fround(0.0);
 f11 = i2 ? f11 : Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i12 >> 2]);
 i2 = i12 + 4 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i12 + 8 | 0;
 f17 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f16 * f11));
 f8 = Math_fround(f8 + Math_fround(f5 * f11));
 f9 = Math_fround(f9 + Math_fround(f17 * f11));
 f6 = Math_fround(f1 - f11);
 f4 = Math_fround(f4 - f7);
 f1 = Math_fround(f18 - f8);
 f15 = Math_fround(f15 - f9);
 f5 = Math_fround(Math_fround(f17 * f15) + Math_fround(Math_fround(f16 * f4) + Math_fround(f5 * f1)));
 f1 = Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f4 * f4) + Math_fround(f1 * f1)));
 f4 = Math_fround(f10 * f10);
 if (!(f1 <= f4)) {
  if (f5 <= Math_fround(0.0) | Math_fround(f5 - f6) > f10) {
   i14 = 0;
   return i14 | 0;
  }
  f1 = Math_fround(f4 - Math_fround(f1 - Math_fround(f5 * f5)));
  if (f1 < Math_fround(0.0)) {
   i14 = 0;
   return i14 | 0;
  }
  f1 = Math_fround(f5 - Math_fround(Math_sqrt(Math_fround(f1))));
  HEAPF32[i14 >> 2] = f1;
  if (f1 > f6) {
   i14 = 0;
   return i14 | 0;
  }
  if (i13) {
   f17 = Math_fround(f1 * Math_fround(HEAPF32[i12 >> 2]));
   f18 = Math_fround(f1 * Math_fround(HEAPF32[i2 >> 2]));
   f18 = Math_fround(f8 + f18);
   f1 = Math_fround(f9 + Math_fround(f1 * Math_fround(HEAPF32[i3 >> 2])));
   HEAPF32[i13 >> 2] = Math_fround(f7 + f17);
   HEAPF32[i13 + 4 >> 2] = f18;
   HEAPF32[i13 + 8 >> 2] = f1;
   f1 = Math_fround(HEAPF32[i14 >> 2]);
  }
 } else {
  if (i13 | 0) {
   HEAPF32[i13 >> 2] = f7;
   HEAPF32[i13 + 4 >> 2] = f8;
   HEAPF32[i13 + 8 >> 2] = f9;
  }
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i14 >> 2] = Math_fround(f11 + f1);
 i14 = 1;
 return i14 | 0;
}

function __ZN16Physics2DManager8LinecastERK8Vector2fS2_iffPK10Collider2DbP12RaycastHit2Di(i1, i4, i5, i3, f7, f10, i6, i11, i2, i12) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 f7 = Math_fround(f7);
 f10 = Math_fround(f10);
 i6 = i6 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i8 = 0, f9 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i17 + 8 | 0;
 i1 = i17;
 i13 = i17 + 48 | 0;
 if ((HEAP16[gb + 1457608 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457608 | 0, i8);
  i16 = gb + 1457608 | 0;
 } else i16 = 0;
 if (!i12) i1 = 0; else {
  i19 = gb + 64016 | 0;
  i15 = HEAP32[i19 + 4 >> 2] | 0;
  i14 = i1;
  HEAP32[i14 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i14 + 4 >> 2] = i15;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  i14 = i13 + 16 | 0;
  HEAP32[i14 >> 2] = 0;
  i15 = i13 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i1);
  i19 = i8;
  i18 = HEAP32[i19 + 4 >> 2] | 0;
  i1 = i15;
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = i18;
  HEAP32[i8 >> 2] = gb + 156148 + 8;
  HEAP32[i8 + 4 >> 2] = i3;
  i1 = i8 + 8 | 0;
  i3 = i8 + 12 | 0;
  HEAP32[i8 + 16 >> 2] = i6;
  HEAP32[i8 + 20 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 24 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 28 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 32 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i8 + 36 >> 2] = i13;
  i6 = f7 == Math_fround(-inf);
  f9 = i6 ? Math_fround(-3402823469999999843913219.0e14) : f7;
  HEAPF32[i1 >> 2] = f9;
  i6 = f10 == Math_fround(inf);
  f7 = i6 ? Math_fround(3402823469999999843913219.0e14) : f10;
  HEAPF32[i3 >> 2] = f7;
  if (!(f9 < f7)) {
   HEAPF32[i1 >> 2] = f7;
   HEAPF32[i3 >> 2] = f9;
  }
  i1 = __ZN14Raycast2DQuery8RunQueryEb(i8, i11) | 0;
  i1 = (i1 | 0) > (i12 | 0) ? i12 : i1;
  if ((i1 | 0) > 0) {
   i8 = HEAP32[i13 >> 2] | 0;
   i3 = 0;
   do {
    i4 = i2;
    i2 = i2 + 36 | 0;
    i5 = i8 + (i3 * 36 | 0) | 0;
    i6 = i4 + 36 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + 4 | 0;
     i5 = i5 + 4 | 0;
    } while ((i4 | 0) < (i6 | 0));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
  }
  if ((HEAP32[i14 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i15);
   HEAP32[i13 >> 2] = 0;
  }
 }
 if (!i16) {
  STACKTOP = i17;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i16);
 STACKTOP = i17;
 return i1 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i11 + 40 | 0;
 i8 = i11 + 24 | 0;
 i7 = i11 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 100; else i1 = (HEAP32[i1 >> 2] | 0) + 100 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i4 + 8 >> 2] | 0);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i6, i7) | 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = i9;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i10 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i9, 128, gb + 832323 | 0, i10) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  HEAP8[i10 >> 0] = 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  mftCall_iiii(i9 | 0, i6 | 0, i10 | 0, 1) | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + 8 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i6 + 20 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  mftCall_viii(i9 | 0, i5 | 0, i4 | 0, i10 | 0);
  i10 = i6 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = i6 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_iiii(i8 | 0, i6 | 0, i9 | 0, _strlen(i9) | 0) | 0;
 HEAP8[i10 >> 0] = 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_iiii(i9 | 0, i6 | 0, i10 | 0, 1) | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = i9 + 8 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i6 + 20 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 mftCall_viii(i9 | 0, i5 | 0, i4 | 0, i10 | 0);
 i10 = i6 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i6 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 72 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1033990 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 72 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1033990 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 72 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 3;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937633 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsI13TreePrototypeE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937633 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsI13TreePrototypeE8TransferI14SafeBinaryReadEEvRS0_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function _longest_match(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i7 = HEAP32[i2 + 124 >> 2] | 0;
 i17 = HEAP32[i2 + 56 >> 2] | 0;
 i12 = HEAP32[i2 + 108 >> 2] | 0;
 i18 = i17 + i12 | 0;
 i6 = HEAP32[i2 + 120 >> 2] | 0;
 i11 = HEAP32[i2 + 144 >> 2] | 0;
 i10 = (HEAP32[i2 + 44 >> 2] | 0) + -262 | 0;
 i10 = i12 >>> 0 > i10 >>> 0 ? i12 - i10 | 0 : 0;
 i12 = HEAP32[i2 + 64 >> 2] | 0;
 i13 = HEAP32[i2 + 52 >> 2] | 0;
 i19 = HEAP32[i2 + 116 >> 2] | 0;
 i11 = i11 >>> 0 > i19 >>> 0 ? i19 : i11;
 i14 = i2 + 112 | 0;
 i15 = i18 + 1 | 0;
 i16 = i18 + 258 | 0;
 i3 = HEAP8[i18 + i6 >> 0] | 0;
 i8 = HEAP8[i18 + (i6 + -1) >> 0] | 0;
 i9 = i1;
 i1 = i6;
 i7 = i6 >>> 0 < (HEAP32[i2 + 140 >> 2] | 0) >>> 0 ? i7 : i7 >>> 2;
 while (1) {
  i2 = i17 + i9 | 0;
  if ((HEAP8[i2 + i1 >> 0] | 0) == i3 << 24 >> 24) if ((HEAP8[i2 + (i1 + -1) >> 0] | 0) == i8 << 24 >> 24) if ((HEAP8[i2 >> 0] | 0) == (HEAP8[i18 >> 0] | 0)) {
   i2 = i2 + 1 | 0;
   if ((HEAP8[i2 >> 0] | 0) == (HEAP8[i15 >> 0] | 0)) {
    i6 = 2;
    i5 = i2;
    do {
     i4 = i18 + i6 | 0;
     i2 = i4 + 1 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 2 >> 0] | 0)) break;
     i2 = i4 + 2 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 3 >> 0] | 0)) break;
     i2 = i4 + 3 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 4 >> 0] | 0)) break;
     i2 = i4 + 4 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 5 >> 0] | 0)) break;
     i2 = i4 + 5 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 6 >> 0] | 0)) break;
     i2 = i4 + 6 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 + 7 >> 0] | 0)) break;
     i2 = i4 + 7 | 0;
     i4 = i5;
     i5 = i5 + 8 | 0;
     if ((HEAP8[i2 >> 0] | 0) != (HEAP8[i5 >> 0] | 0)) break;
     i6 = i6 + 8 | 0;
     i2 = i18 + i6 | 0;
    } while ((i6 | 0) < 258 ? (HEAP8[i2 >> 0] | 0) == (HEAP8[i4 + 9 >> 0] | 0) : 0);
    i2 = i2 - i16 | 0;
    i4 = i2 + 258 | 0;
    if ((i4 | 0) > (i1 | 0)) {
     HEAP32[i14 >> 2] = i9;
     if ((i4 | 0) >= (i11 | 0)) {
      i1 = i4;
      i2 = 19;
      break;
     }
     i3 = HEAP8[i18 + i4 >> 0] | 0;
     i2 = HEAP8[i18 + (i2 + 257) >> 0] | 0;
     i1 = i4;
    } else i2 = i8;
   } else i2 = i8;
  } else i2 = i8; else i2 = i8; else i2 = i8;
  i9 = HEAPU16[i12 + ((i9 & i13) << 1) >> 1] | 0;
  if (i9 >>> 0 <= i10 >>> 0) {
   i2 = 19;
   break;
  }
  i7 = i7 + -1 | 0;
  if (!i7) {
   i2 = 19;
   break;
  } else i8 = i2;
 }
 if ((i2 | 0) == 19) return (i1 >>> 0 > i19 >>> 0 ? i19 : i1) | 0;
 return 0;
}

function __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j(i5, i1);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 88 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 24 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 56 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i6, i5 + 72 | 0, 0);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN9JSONWrite8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = (HEAP32[i10 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1085989 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1084342 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1085899 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834304;
 HEAP32[i1 + 4 >> 2] = 643;
 HEAP32[i1 + 8 >> 2] = fb + 63;
 HEAP32[i1 + 12 >> 2] = fb + 31;
 HEAP32[i1 + 20 >> 2] = fb + 2411;
 HEAP32[i1 + 24 >> 2] = gb + 834316;
 HEAP32[i1 + 28 >> 2] = 644;
 HEAP32[i1 + 32 >> 2] = fb + 2412;
 HEAP32[i1 + 36 >> 2] = fb + 3955;
 HEAP32[i1 + 40 >> 2] = gb + 834323;
 HEAP32[i1 + 44 >> 2] = 645;
 HEAP32[i1 + 48 >> 2] = fb + 2413;
 HEAP32[i1 + 52 >> 2] = fb + 3956;
 HEAP32[i1 + 56 >> 2] = gb + 834332;
 HEAP32[i1 + 60 >> 2] = 646;
 HEAP32[i1 + 64 >> 2] = fb + 2414;
 HEAP32[i1 + 68 >> 2] = fb + 3957;
 HEAP32[i1 + 72 >> 2] = gb + 834345;
 HEAP32[i1 + 76 >> 2] = 647;
 HEAP32[i1 + 80 >> 2] = fb + 2415;
 HEAP32[i1 + 84 >> 2] = fb + 3958;
 HEAP32[i1 + 88 >> 2] = gb + 834357;
 HEAP32[i1 + 92 >> 2] = 648;
 HEAP32[i1 + 96 >> 2] = fb + 2416;
 HEAP32[i1 + 100 >> 2] = fb + 3959;
 HEAP32[i1 + 104 >> 2] = gb + 834368;
 HEAP32[i1 + 108 >> 2] = 649;
 HEAP32[i1 + 112 >> 2] = fb + 647;
 HEAP32[i1 + 116 >> 2] = fb + 560;
 HEAP32[i1 + 120 >> 2] = gb + 834388;
 HEAP32[i1 + 124 >> 2] = 650;
 HEAP32[i1 + 128 >> 2] = fb + 2417;
 HEAP32[i1 + 132 >> 2] = fb + 3960;
 HEAP32[i1 + 136 >> 2] = gb + 834399;
 HEAP32[i1 + 140 >> 2] = 651;
 HEAP32[i1 + 144 >> 2] = fb + 648;
 HEAP32[i1 + 148 >> 2] = fb + 561;
 HEAP32[i1 + 152 >> 2] = gb + 834414;
 HEAP32[i1 + 156 >> 2] = 652;
 HEAP32[i1 + 160 >> 2] = fb + 649;
 HEAP32[i1 + 164 >> 2] = fb + 562;
 HEAP32[i1 + 168 >> 2] = gb + 834432;
 HEAP32[i1 + 172 >> 2] = 653;
 HEAP32[i1 + 176 >> 2] = fb + 2418;
 HEAP32[i1 + 180 >> 2] = fb + 3961;
 HEAP32[i1 + 184 >> 2] = gb + 834446;
 HEAP32[i1 + 188 >> 2] = 654;
 HEAP32[i1 + 192 >> 2] = fb + 2419;
 HEAP32[i1 + 196 >> 2] = fb + 3962;
 HEAP32[i1 + 200 >> 2] = gb + 834461;
 HEAP32[i1 + 204 >> 2] = 655;
 HEAP32[i1 + 208 >> 2] = fb + 2420;
 HEAP32[i1 + 212 >> 2] = fb + 3963;
 HEAP32[i1 + 216 >> 2] = gb + 834478;
 HEAP32[i1 + 220 >> 2] = 656;
 HEAP32[i1 + 224 >> 2] = fb + 2421;
 HEAP32[i1 + 228 >> 2] = fb + 3964;
 HEAP32[i1 + 232 >> 2] = gb + 834491;
 HEAP32[i1 + 236 >> 2] = 657;
 HEAP32[i1 + 240 >> 2] = fb + 2422;
 HEAP32[i1 + 244 >> 2] = fb + 3965;
 HEAP32[i1 + 248 >> 2] = gb + 834503;
 HEAP32[i1 + 252 >> 2] = 658;
 HEAP32[i1 + 256 >> 2] = fb + 650;
 HEAP32[i1 + 260 >> 2] = fb + 563;
 HEAP32[i1 + 264 >> 2] = gb + 834516;
 HEAP32[i1 + 268 >> 2] = 659;
 HEAP32[i1 + 272 >> 2] = fb + 651;
 HEAP32[i1 + 276 >> 2] = fb + 564;
 HEAP32[i1 + 280 >> 2] = gb + 834532;
 HEAP32[i1 + 284 >> 2] = 660;
 HEAP32[i1 + 288 >> 2] = fb + 652;
 HEAP32[i1 + 292 >> 2] = fb + 565;
 return;
}

function __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 16 | 0;
 f3 = Math_fround(HEAPF32[i8 + 6160 >> 2]);
 f4 = Math_fround(HEAPF32[i8 + 6164 >> 2]);
 f5 = Math_fround(HEAPF32[i8 + 6168 >> 2]);
 i6 = i8 + 5924 | 0;
 i7 = i1 + 36 | 0;
 i9 = i1;
 i10 = i9 + 36 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i10 | 0));
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i9 = i1 + 40 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 i9 = i1 + 60 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i1 + 76 >> 2] = Math_fround(1.0);
 i9 = i1 + 80 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 100 >> 2] = i6;
 __ZN5physx18PxcNpThreadContextC2EfffRKNS_2Cm12RenderOutputERNS_17PxcNpMemBlockPoolEb(i2, f3, f4, f5, i1, i8 + 44 | 0, (HEAP8[i8 + 1440 >> 0] | 0) != 0);
 HEAP32[i11 + 8796 >> 2] = 0;
 HEAP32[i11 + 8804 >> 2] = 0;
 HEAP32[i11 + 8812 >> 2] = 0;
 i1 = i11 + 8820 | 0;
 HEAP32[i11 + 9028 >> 2] = 0;
 HEAP8[i11 + 9032 >> 0] = 0;
 HEAP32[i11 + 9036 >> 2] = 0;
 HEAP32[i11 + 9044 >> 2] = 0;
 i8 = i11 + 9052 | 0;
 HEAP32[i11 + 9076 >> 2] = 0;
 i9 = i11 + 9112 | 0;
 i10 = i11 + 9148 | 0;
 i7 = i11 + 9168 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 _memset(i1 | 0, 0, 192) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 if ((HEAP32[i11 + 8852 >> 2] & 2147483136) >>> 0 < 512) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i11 + 8844 | 0, 512);
 if ((HEAP32[i11 + 8828 >> 2] & 2147483520) >>> 0 >= 128) {
  STACKTOP = i12;
  return;
 }
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1, 128);
 STACKTOP = i12;
 return;
}

function __ZN14TerrainManager21OffsetLightmapIndicesER18AwakeFromLoadQueueii(i1, i2, i13, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i11 = i2 + 232 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i2 + 220 | 0;
 i7 = 0;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 do {
  HEAP32[i10 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 * 12 | 0) + 4 >> 2];
  if (!i1) {
   i1 = 0;
   i15 = 9;
  } else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i4 = HEAP32[i1 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i1 + 28 >> 2] | 0;
    i6 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
    i3 = HEAP32[i6 + 28 >> 2] | 0;
    i4 = HEAP32[i6 + 32 >> 2] | 0;
    i1 = i6;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i15 = 9; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (i2) if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 35740 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 35740 + 28 >> 2] | 0) >>> 0) {
     i5 = i2 + 152 | 0;
     i6 = HEAP32[i5 >> 2] | 0;
     i3 = i6 >>> 16;
     i3 = ((i3 & 65535) < 65534 ? i14 : 0) + i3 << 16 | ((i6 & 65535) < 65534 ? i13 : 0) + i6 & 65535;
     if ((i6 | 0) != (i3 | 0)) {
      HEAP32[i5 >> 2] = i3;
      i6 = i2 + 228 | 0;
      i4 = i2 + 240 | 0;
      if (HEAP32[i4 >> 2] | 0) {
       i2 = HEAP32[i6 >> 2] | 0;
       HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 108 >> 2] = i3;
       HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i5 >> 2];
       i2 = i2 + 20 | 0;
       if ((i2 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0)) do {
        HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i5 >> 2];
        HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i5 >> 2];
        i2 = i2 + 20 | 0;
       } while ((i2 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0));
      }
     }
    }
   }
  }
  if ((i15 | 0) == 9) i15 = 0;
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i6 = i8;
 i13 = i8 + ((HEAP32[i2 >> 2] | 0) - i6 >> 2 << 2) | 0;
 i14 = i12 + 4 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i3 = i12 + 8 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i2 = i7;
 i4 = i11;
 if (i7 >>> 0 < i11 >>> 0) {
  if ((i13 | 0) == (i7 | 0)) {
   HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 4;
   i14 = i13;
   return i14 | 0;
  }
  i4 = i2 - (i13 + 4) | 0;
  i5 = i4 >> 2;
  i2 = i13 + (i5 << 2) | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i3 = i7;
   do {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    i2 = i2 + 4 | 0;
    i3 = (HEAP32[i14 >> 2] | 0) + 4 | 0;
    HEAP32[i14 >> 2] = i3;
   } while (i2 >>> 0 < i7 >>> 0);
  }
  if (i5 | 0) _memmove(i7 + (0 - i5 << 2) | 0, i13 | 0, i4 | 0) | 0;
  if (i13 >>> 0 <= i1 >>> 0) i1 = (HEAP32[i14 >> 2] | 0) >>> 0 > i1 >>> 0 ? i1 + 4 | 0 : i1;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  i14 = i13;
  return i14 | 0;
 }
 i5 = (i2 - i6 >> 2) + 1 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i8 = HEAP32[i12 >> 2] | 0;
  i11 = i3;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i8;
 } else {
  i11 = i3;
  i2 = i4;
  i3 = i6;
 }
 i10 = i2 - i3 | 0;
 i7 = i10 >> 1;
 i7 = i10 >> 2 >>> 0 < 536870911 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 1073741823;
 i10 = i13;
 i5 = i10 - i3 | 0;
 i6 = i5 >> 2;
 if (!i7) i9 = 0; else i9 = __Znwj(i7 << 2) | 0;
 i3 = i9 + (i6 << 2) | 0;
 i2 = i3;
 i4 = i9 + (i7 << 2) | 0;
 do if ((i6 | 0) == (i7 | 0)) {
  if ((i5 | 0) > 0) {
   i3 = i3 + (((i7 + 1 | 0) / -2 | 0) << 2) | 0;
   i2 = i3;
   i5 = i8;
   break;
  }
  i4 = i7 << 2 >> 1;
  i4 = (i4 | 0) == 0 ? 1 : i4;
  i7 = __Znwj(i4 << 2) | 0;
  i3 = i7 + (i4 >>> 2 << 2) | 0;
  i2 = i3;
  i4 = i7 + (i4 << 2) | 0;
  if (!i9) i5 = i8; else {
   __ZdlPv(i9);
   i5 = HEAP32[i12 >> 2] | 0;
  }
 } else i5 = i8; while (0);
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i1 = i2 + 4 | 0;
 i3 = i2;
 i2 = i10 - i5 | 0;
 i6 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i6 | 0, i5 | 0, i2 | 0) | 0;
 i2 = (HEAP32[i14 >> 2] | 0) - i10 | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i1 | 0, i13 | 0, i2 | 0) | 0;
  i1 = i1 + (i2 >> 2 << 2) | 0;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 if (!i2) {
  i14 = i3;
  return i14 | 0;
 }
 __ZdlPv(i2);
 i14 = i3;
 return i14 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERPv(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERPv(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri(i11, i14, i1, i13, i12) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i15 = 0, f16 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f3 * Math_fround(HEAPF32[i14 + 96 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i14 + 100 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f10 * Math_fround(HEAPF32[i14 + 104 >> 2])));
 f9 = Math_fround(f3 * Math_fround(HEAPF32[i14 + 112 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i14 + 116 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f10 * Math_fround(HEAPF32[i14 + 120 >> 2])));
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i14 + 128 >> 2]));
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i14 + 132 >> 2])));
 f10 = Math_fround(f5 + Math_fround(f10 * Math_fround(HEAPF32[i14 + 136 >> 2])));
 HEAPF32[i2 >> 2] = f8;
 HEAPF32[i2 + 4 >> 2] = f9;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 if (!(HEAP32[i14 + 196 >> 2] | 0)) {
  i6 = i14 + 200 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i14 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f5 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f8);
   f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f9));
   f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f10));
   i2 = 1;
   i1 = 0;
   while (1) {
    i4 = HEAP32[i6 >> 2] | 0;
    f16 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) >> 2]);
    f3 = Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 4 >> 2]);
    f3 = Math_fround(Math_fround(Math_fround(f16 * f8) + Math_fround(f3 * f9)) + Math_fround(Math_fround(HEAPF32[i4 + (i2 * 12 | 0) + 8 >> 2]) * f10));
    i4 = f3 > f5;
    i1 = i4 ? i2 : i1;
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f5 = i4 ? f3 : f5; else break;
   }
  } else i1 = 0;
 } else i1 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i14, i2) | 0;
 HEAP32[i12 >> 2] = i1;
 __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE(i11, i14, i1, i14 + 16 | 0);
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = (HEAP32[i10 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1084155 | 0, 1);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1086064 | 0, 1);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1085890 | 0, 1);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1085926 | 0, 1);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469624 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN21ComputeShaderResource8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469624 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN21ComputeShaderResource8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z31RemoteSettings_CUSTOM_GetStringP12Il2CppStringS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 92 | 0;
 i3 = i11 + 88 | 0;
 i10 = i11 + 56 | 0;
 i6 = i11 + 12 | 0;
 i9 = i11 + 24 | 0;
 i7 = i11;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 __ZNK11ICallString6ToUTF8Ev(i6, i3);
 i2 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 HEAP32[i10 >> 2] = 0;
 i3 = i10 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i8 = i10 + 24 | 0;
 i12 = gb + 63648 | 0;
 i4 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i10 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 15) {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i8, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i10 >> 2] = i12;
  HEAP32[i10 + 4 >> 2] = i4;
  i1 = (i12 | 0) == 0 ? i1 : i12;
 }
 _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i3 >> 2] = i4;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNK11ICallString6ToUTF8Ev(i7, i5);
 i2 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 HEAP32[i9 >> 2] = 0;
 i3 = i9 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i9 + 24 | 0;
 i12 = gb + 63648 | 0;
 i4 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 15) {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i5, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i9 >> 2] = i12;
  HEAP32[i9 + 4 >> 2] = i4;
  i1 = (i12 | 0) == 0 ? i1 : i12;
 }
 _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i3 >> 2] = i4;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i2 = __Z20scripting_string_newPKc(__ZN11UnityEngine7Connect14RemoteSettings9GetStringERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEES8_((__Z21GetUnityConnectClientv() | 0) + 768 | 0, i9, i10) | 0) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i9 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 if (!(HEAP32[i10 + 4 >> 2] | 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERy(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERx(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERt(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERm(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERl(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERj(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERf(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERe(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERd(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERb(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474604 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERy(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERx(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERt(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERm(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERl(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERj(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERf(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERe(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERd(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERb(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = i11 + 24 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i10 | 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i12 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i10;
  i3 = i10;
  i9 = 12;
 } else L4 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = __ZNKSt3__28ios_base6getlocEv(i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474580 | 0) | 0;
  i12 = __THREW__;
  __THREW__ = 0;
  do if (i12 & 1) i9 = 8; else {
   i12 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
   i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 + 24 >> 2];
   HEAP32[i6 >> 2] = 0;
   __THREW__ = 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   invoke_iiiiiii(i13 | 0, i1 | 0, i2 | 0, i3 | 0, i12 | 0, i7 | 0, i4 | 0) | 0;
   i12 = __THREW__;
   __THREW__ = 0;
   if (i12 & 1) i9 = 8; else {
    __ZNSt3__26localeD2Ev(i8);
    i13 = i10 + (HEAP32[(HEAP32[i10 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i13 | 0, HEAP32[i13 + 16 >> 2] | HEAP32[i7 >> 2] | 0);
    i13 = __THREW__;
    __THREW__ = 0;
    if (i13 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break;
    } else break L4;
   }
  } while (0);
  if ((i9 | 0) == 8) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__26localeD2Ev(i8);
  }
  i2 = i10;
  i3 = i10;
  i9 = 12;
  break L1;
 } while (0); while (0);
 do if ((i9 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (!(i13 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i13 = __THREW__;
  __THREW__ = 0;
  if (i13 & 1) {
   i13 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i13);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i4, i7, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i4 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i6 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i4 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i7 + 12 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i6 * 20 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 20 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i6 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 * 20 | 0) | 0, 0, (i6 - i4 | 0) * 20 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + (i7 * 20 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN8LODGroup3LOD8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425174 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425195 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 425215 | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i9, i2, 0); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN15RelativeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802602 | 0, i5, i1 + 76 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802613 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802625 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802643 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 88 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802665 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802680 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI7SubMesh13stl_allocatorIS3_L18MemLabelIdentifier16ELi16EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 52 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426521 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN7SubMesh8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 52 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426521 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7SubMesh8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 52 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow1P12Il2CppObjectRK8Vector3fRK11Quaternionfi(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i2 = i10;
 i1 = HEAP32[gb + 1188344 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i2);
    i2 = HEAP32[i9 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i4 = 9;
  }
  if ((i4 | 0) == 7) i4 = 9;
  if ((i4 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1188344 >> 2] | 0) | 0)) break;
  i4 = __Z12GetGfxDevicev() | 0;
  i1 = i9;
  i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (i1 | 0) {
   i11 = HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0;
   mftCall_vii(i11 | 0, i4 | 0, __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0);
  }
  i1 = HEAP32[gb + 1188348 >> 2] | 0;
  if (!i5) {
   i11 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
  }
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i2) {
   i11 = i5;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
  }
  __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK8Vector3fRK11Quaternionfi(i1, i2, i6, i7, i8);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, i9 | 0);
  STACKTOP = i10;
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 517821 | 0, 0, gb + 517579 | 0, 3781, 1, 0, 0, 0);
 STACKTOP = i10;
 return;
}

function __ZN9JSONWrite8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = (HEAP32[i10 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1085989 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1084342 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1085899 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI11QuaternionfLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE6createERSB_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i4 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i4;
  i2 = i2 + ~(i2 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = i3;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i2 >>> 16 ^ i2 ^ (i1 ^ -57320555 ^ i1 >>> 16) * 1000007) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   while (1) {
    if ((HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i6 + (i1 * 12 | 0) | 0;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10 ^ (i11 ^ -57320555 ^ i11 >>> 16) * 1000007) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 * 12 | 0) | 0;
 return i12 | 0;
}

function __ZN5physx17AggregateAABBTaskC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 104368 + 8;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 44 | 0;
 HEAP16[i1 + 48 >> 1] = -1;
 HEAP16[i1 + 50 >> 1] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 64 >> 2] = 0;
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 104 | 0;
 HEAP16[i1 + 108 >> 1] = -1;
 HEAP16[i1 + 110 >> 1] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 124 >> 2] = 0;
 i2 = i1 + 148 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 164 | 0;
 HEAP16[i1 + 168 >> 1] = -1;
 HEAP16[i1 + 170 >> 1] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 184 >> 2] = 0;
 i2 = i1 + 208 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 224 | 0;
 HEAP16[i1 + 228 >> 1] = -1;
 HEAP16[i1 + 230 >> 1] = 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 244 >> 2] = 0;
 i2 = i1 + 268 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 284 | 0;
 HEAP16[i1 + 288 >> 1] = -1;
 HEAP16[i1 + 290 >> 1] = 0;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 296 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 304 >> 2] = 0;
 i2 = i1 + 328 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 344 | 0;
 HEAP16[i1 + 348 >> 1] = -1;
 HEAP16[i1 + 350 >> 1] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104412 + 8;
 HEAP32[i1 + 364 >> 2] = 0;
 i1 = i1 + 388 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i4 = i9 + 16 | 0;
 i2 = i9;
 i5 = i9 + 48 | 0;
 i6 = i8 + 164 | 0;
 HEAP32[i6 >> 2] = i3;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i1 = __ZN4FMOD7Channel11setUserDataEPv(i3, i8 + 152 | 0) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i2 >> 2] = gb + 853918;
  HEAP32[i2 + 4 >> 2] = 117;
  HEAP32[i2 + 8 >> 2] = gb + 859103;
  HEAP32[i2 + 12 >> 2] = i1;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i1 = __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E(i3, fb + 167 | 0) | 0;
 if (i1 | 0) {
  i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853918;
  HEAP32[i4 + 4 >> 2] = 118;
  HEAP32[i4 + 8 >> 2] = gb + 859141;
  HEAP32[i4 + 12 >> 2] = i2;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i1 = __ZN4FMOD7Channel12getFrequencyEPf(i3, i8 + 232 | 0) | 0;
 if (i1 | 0) {
  i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i7 >> 2] = gb + 853918;
  HEAP32[i7 + 4 >> 2] = 119;
  HEAP32[i7 + 8 >> 2] = gb + 859187;
  HEAP32[i7 + 12 >> 2] = i4;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE(i8 + 4 | 0, i1);
 __ZN20SoundChannelInstance12UpdateVolumeEv(i8);
 __ZN20SoundChannelInstance11UpdatePitchEv(i8);
 __ZN20SoundChannelInstance16UpdatePauseStateEv(i8);
 i1 = HEAP32[i8 + 240 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i1, 0);
 STACKTOP = i9;
 return;
}

function __ZN18BuoyancyEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 56 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i1 = i6 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 112 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 116 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN10GameObject13AwakeFromLoadE17AwakeFromLoadMode(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((i1 | 0) == 3) HEAP8[i10 + 55 >> 0] = -1;
 i9 = i10 + 60 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 if (!(HEAP32[i10 + 56 >> 2] & 16)) {
  HEAP32[i9 >> 2] = 0;
  i7 = i10 + 28 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i8 = i10 + 40 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i5 = i3;
   i2 = 0;
   i4 = i3;
   do {
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    if (i3) {
     i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0) | 0;
     i2 = HEAP32[i9 >> 2] | i2;
     HEAP32[i9 >> 2] = i2;
     i4 = HEAP32[i7 >> 2] | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    i5 = i5 + 8 | 0;
   } while ((i5 | 0) != (i4 + (i1 << 3) | 0));
   if (!((i6 | 0) == (i2 | 0) | (i1 | 0) == 0)) {
    i5 = i4;
    i3 = i4;
    while (1) {
     i2 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i2) i2 = i3; else {
      mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, HEAP32[i9 >> 2] | 0);
      i2 = HEAP32[i7 >> 2] | 0;
      i1 = HEAP32[i8 >> 2] | 0;
     }
     i5 = i5 + 8 | 0;
     if ((i5 | 0) == (i2 + (i1 << 3) | 0)) break; else i3 = i2;
    }
   }
  }
 }
 i3 = i10 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i9 = i10 + 72 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
 }
 do if (__ZNK10GameObject8IsActiveEv(i10) | 0) {
  i2 = HEAP32[gb + 1104660 >> 2] | 0;
  if (!(HEAP16[i10 + 52 >> 1] | 0)) {
   i2 = i2 + 8 | 0;
   if ((i3 | 0) == (i2 | 0)) break;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i10 + 72 | 0; else {
    i9 = i10 + 72 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = i9;
   }
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
   break;
  } else {
   if ((i3 | 0) == (i2 | 0)) break;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = i10 + 72 | 0; else {
    i9 = i10 + 72 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = i9;
   }
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i3;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
   break;
  }
 } while (0);
 i1 = HEAP32[gb + 1104576 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(i1 | 0, i10 | 0);
 return;
}

function __ZN9Rigidbody8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827258 | 0, i5, i1 + 68 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802440 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802447 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 839070 | 0, i5, i1 + 83 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802877 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802800 | 0, HEAP32[gb + 37300 >> 2] | 0, i1 + 102 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802850 | 0, i5, i1 + 88 | 0, 4194305);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802829 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 2) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx16PxsIslandManager11preAllocateEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 1 | 0;
 i5 = i7;
 if (i1 | 0) {
  i3 = i1 + 31 & -32;
  i1 = i6 + 12 | 0;
  if ((HEAP32[i6 + 24 >> 2] | 0) >>> 0 < i3 >>> 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
  i1 = i6 + 280 | 0;
  i2 = i3 << 1;
  if ((HEAP32[i6 + 292 >> 2] | 0) >>> 0 < i2 >>> 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0);
  __ZN5physx17NodeChangeManager4initEj(i6 + 308 | 0, i3);
  __ZN5physx17EdgeChangeManager4initEj(i6 + 332 | 0, i2);
  i1 = i6 + 372 | 0;
  if ((HEAP32[i6 + 384 >> 2] | 0) >>> 0 < i3 >>> 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
  i1 = i6 + 420 | 0;
  if ((HEAP32[i6 + 432 >> 2] | 0) >>> 0 >= 32) {
   STACKTOP = i7;
   return;
  }
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 32);
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 12 | 0;
 if ((HEAP32[i6 + 24 >> 2] | 0) >>> 0 < 256) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 256);
 i1 = i6 + 280 | 0;
 if ((HEAP32[i6 + 292 >> 2] | 0) >>> 0 < 256) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 256);
 i1 = i6 + 308 | 0;
 i2 = i6 + 328 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i2 >> 2] = 256;
  i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 2048, gb + 681489 | 0, 1416) | 0;
  HEAP32[i1 >> 2] = i4;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 + 316 >> 2] = i4 + (i5 << 2);
  HEAP32[i6 + 324 >> 2] = i5;
 } else {
  i3 = i6 + 324 | 0;
  if ((HEAP32[i3 >> 2] | 0) >>> 0 < 256) {
   i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 2048, gb + 681489 | 0, 1482) | 0;
   i8 = i9 + 1024 | 0;
   _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 + 312 >> 2] << 2 | 0) | 0;
   i4 = i6 + 316 | 0;
   _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 + 320 >> 2] << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = i9;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i3 >> 2] = 256;
   HEAP32[i2 >> 2] = 256;
  }
 }
 __ZN5physx17EdgeChangeManager4initEj(i6 + 332 | 0, 256);
 i1 = i6 + 372 | 0;
 if ((HEAP32[i6 + 384 >> 2] | 0) >>> 0 < 256) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 256);
 i1 = i6 + 420 | 0;
 if ((HEAP32[i6 + 432 >> 2] | 0) >>> 0 >= 32) {
  STACKTOP = i7;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 32);
 STACKTOP = i7;
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 40 | 0;
 i4 = i6;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 120 | 0, 1);
 i5 = i4;
 i7 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034351 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i4, 0);
 i5 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4 + 4 | 0, gb + 1034365 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4 + 16 | 0, gb + 1034371 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4 + 28 | 0, gb + 1034379 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034211 | 0, i4, i1 + 140 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034225 | 0, i4, i1 + 144 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034240 | 0, i4, i1 + 148 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i6;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 36 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469301 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN20ComputeShaderVariant8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 36 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469301 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN20ComputeShaderVariant8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI19LightProbeOcclusionLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 3) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378473 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN19LightProbeOcclusion8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378473 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN19LightProbeOcclusion8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 40 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426504 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN16BlendShapeVertex8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426504 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN16BlendShapeVertex8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i11, i9) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 __ZN8GradientC2Ev(i10);
 i7 = HEAP32[i11 + 20 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i3 + 24 >> 2] | 0;
 i4 = i7 + 36 | 0;
 HEAP8[i4 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i7 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i12;
  return;
 }
 i5 = i7 + 40 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if (!i6) {
   STACKTOP = i12;
   return;
  }
  if ((HEAP32[i6 + 16 >> 2] | 0) != 3) {
   STACKTOP = i12;
   return;
  }
 }
 i13 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i6, i1) | 0;
 HEAP32[i5 >> 2] = i13;
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1033990;
 if (!i13) {
  i13 = HEAP8[i4 >> 0] | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = i2;
  if (!(i13 << 24 >> 24)) {
   STACKTOP = i12;
   return;
  }
 } else {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, i8);
  __ZN8Gradient8TransferI8JSONReadEEvRT_(i10, i7);
  HEAP8[i4 >> 0] = 1;
  i13 = i7 + 56 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = i2;
 }
 i5 = i3 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i11 + 4 | 0;
 i7 = i11 + 12 | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i11 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i7 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i9 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 i4 = i4 + 32 | 0;
 i2 = i10 + 32 | 0;
 i3 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i11 >> 0] | 0) == 0 ? i13 + -8 + (HEAP32[i7 >> 2] | 0) | 0 : i13) >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 6) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI10Matrix4x4fEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN19SpriteMeshGenerator4mask5mdistEPjR14dynamic_bitset(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i9) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = i8 + 4 | 0;
 if ((HEAP32[i10 >> 2] | 0) <= 0) {
  i10 = 1;
  return i10 | 0;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do {
  if ((i1 | 0) > 0) if ((i5 | 0) > 0) {
   i4 = 0;
   do {
    i3 = (Math_imul(i1, i5) | 0) + i4 | 0;
    if (!(HEAP32[i6 + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
     i1 = (HEAP32[i10 >> 2] | 0) + i1 | 0;
     i2 = i9 + (i3 << 2) | 0;
     HEAP32[i2 >> 2] = i1;
     i7 = (HEAP32[i9 + (i3 - (HEAP32[i8 >> 2] | 0) << 2) >> 2] | 0) + 1 | 0;
     i1 = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
     HEAP32[i2 >> 2] = i1;
     if ((i4 | 0) > 0) {
      i7 = (HEAP32[i9 + (i3 + -1 << 2) >> 2] | 0) + 1 | 0;
      HEAP32[i2 >> 2] = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
     }
    } else HEAP32[i9 + (i3 << 2) >> 2] = 0;
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while ((i4 | 0) < (i1 | 0));
  } else {
   i4 = 0;
   do {
    i3 = (Math_imul(i1, i5) | 0) + i4 | 0;
    if (!(HEAP32[i6 + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
     i1 = (HEAP32[i10 >> 2] | 0) + i1 | 0;
     i2 = i9 + (i3 << 2) | 0;
     HEAP32[i2 >> 2] = i1;
     if ((i4 | 0) > 0) {
      i7 = (HEAP32[i9 + (i3 + -1 << 2) >> 2] | 0) + 1 | 0;
      HEAP32[i2 >> 2] = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
     }
    } else HEAP32[i9 + (i3 << 2) >> 2] = 0;
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while ((i4 | 0) < (i1 | 0));
  }
  i5 = i5 + 1 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 } while ((i5 | 0) < (i2 | 0));
 if ((i2 | 0) <= 0) {
  i10 = 1;
  return i10 | 0;
 }
 while (1) {
  i7 = i2;
  i2 = i2 + -1 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  L33 : do if ((i1 | 0) > 0) {
   i6 = i1;
   while (1) {
    i3 = i6 + -1 | 0;
    i4 = Math_imul(i1, i2) | 0;
    i5 = i4 + i3 | 0;
    if ((i7 | 0) < (HEAP32[i10 >> 2] | 0)) {
     i11 = i9 + (i5 << 2) | 0;
     i12 = (HEAP32[i9 + (i5 + i1 << 2) >> 2] | 0) + 1 | 0;
     i1 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = i12 >>> 0 < i1 >>> 0 ? i12 : i1;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    if ((i6 | 0) < (i1 | 0)) {
     i12 = i9 + (i5 << 2) | 0;
     i5 = (HEAP32[i9 + (i4 + i6 << 2) >> 2] | 0) + 1 | 0;
     i11 = HEAP32[i12 >> 2] | 0;
     HEAP32[i12 >> 2] = i5 >>> 0 < i11 >>> 0 ? i5 : i11;
    }
    if ((i6 | 0) <= 1) break L33;
    i6 = i3;
    i1 = HEAP32[i8 >> 2] | 0;
   }
  } while (0);
  if ((i7 | 0) <= 1) {
   i1 = 1;
   break;
  }
 }
 return i1 | 0;
}

function __ZNK5Umbra15OcclusionBuffer20testAARectVisibilityERKNS_7Vector2ES3_fj(i1, i4, i5, f6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i9 = i10;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 if (!(HEAP8[i1 + 1412 >> 0] | 0)) {
  i9 = i7 << 1 & 2 | 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = i1 + 1408 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i2 = 1; else {
  i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
  i12 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 4 >> 2] = i12;
  i12 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
  i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
  HEAP32[i9 >> 2] = i12;
  HEAP32[i9 + 4 >> 2] = i2;
  f11 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
  i2 = __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f(i1, i8, i9, (HEAP32[i1 + 1200 >> 2] | 0) == 1 ? f11 : f6) | 0;
 }
 if ((i7 & 1 | 0) == 0 | i2 ^ 1) {
  i12 = i2 & 1;
  STACKTOP = i10;
  return i12 | 0;
 }
 if (HEAP32[i3 >> 2] | 0) {
  i12 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
  i7 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
  HEAP32[i8 >> 2] = i12;
  HEAP32[i8 + 4 >> 2] = i7;
  i7 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
  i12 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
  HEAP32[i9 >> 2] = i7;
  HEAP32[i9 + 4 >> 2] = i12;
  f11 = Math_fround(Math_fround(f6 * Math_fround(.5)) + Math_fround(.5));
  if (!(__ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f(i1, i8, i9, (HEAP32[i1 + 1200 >> 2] | 0) == 1 ? f11 : f6) | 0)) {
   i12 = 1;
   STACKTOP = i10;
   return i12 | 0;
  }
 }
 i12 = 3;
 STACKTOP = i10;
 return i12 | 0;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 * 12 | 0) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN19RuntimeSceneManager11CreateSceneEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 296 | 0;
 i3 = i15 + 16 | 0;
 i9 = i15;
 i13 = __ZnwjRK10MemLabelIdiPKci(108, gb + 63824 | 0, 16, gb + 462762 | 0, 144) | 0;
 i11 = __Z28AllocateNextLowestInstanceIDv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i12 = i3 + 11 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i14 + 11 >> 0] = 0;
 HEAP8[i14 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 __ZN10UnitySceneC2EiRK8UnityStrS2_RK9UnityGUIDi(i13, i11, i3, i14, i9, -1);
 if ((HEAP8[i12 >> 0] | 0) < 0) {
  i12 = HEAP32[i3 >> 2] | 0;
  i11 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i14 >> 2] = 66;
  HEAP32[i14 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i14);
 }
 i4 = i13;
 i5 = i2 + 4 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i10 = i2 + 20 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i11 & 2147483647;
 do if (i8 >>> 0 > i12 >>> 0) {
  i1 = i11 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i12 >>> 0 < i1 >>> 0) if ((i11 | 0) > -1) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 2, 4, i2 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i5 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 HEAP32[(HEAP32[i5 >> 2] | 0) + (i7 << 2) >> 2] = i4;
 i10 = gb + 64016 | 0;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i3, i14);
 __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue(i13, i3);
 __ZN18AwakeFromLoadQueueD2Ev(i3);
 HEAP32[i13 + 80 >> 2] = 2;
 STACKTOP = i15;
 return i13 | 0;
}

function __ZN10GUIManager14InitGUIManagerEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 __Z26InitializeDeveloperConsolev();
 HEAP32[gb + 1115296 + 416 >> 2] = fb + 3876;
 HEAP32[gb + 1115296 + 184 >> 2] = fb + 362;
 i1 = __Znwj(648) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP32[i1 + 480 >> 2] = 0;
 HEAP32[i1 + 488 >> 2] = 0;
 HEAP32[i1 + 504 >> 2] = -1;
 HEAP32[i1 + 492 >> 2] = 1;
 HEAP32[i1 + 496 >> 2] = 0;
 HEAP32[i1 + 500 >> 2] = 0;
 HEAP32[i1 + 508 >> 2] = 0;
 HEAP32[i1 + 524 >> 2] = -1;
 HEAP32[i1 + 512 >> 2] = 1;
 HEAP32[i1 + 516 >> 2] = 0;
 HEAP32[i1 + 520 >> 2] = 0;
 HEAP32[i1 + 528 >> 2] = 0;
 HEAP32[i1 + 544 >> 2] = -1;
 HEAP32[i1 + 532 >> 2] = 1;
 HEAP32[i1 + 536 >> 2] = 0;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP32[i1 + 548 >> 2] = 0;
 HEAP32[i1 + 564 >> 2] = -1;
 HEAP32[i1 + 552 >> 2] = 1;
 HEAP32[i1 + 556 >> 2] = 0;
 HEAP32[i1 + 560 >> 2] = 0;
 HEAP32[i1 + 568 >> 2] = 0;
 HEAP32[i1 + 584 >> 2] = -1;
 HEAP32[i1 + 572 >> 2] = 1;
 HEAP32[i1 + 576 >> 2] = 0;
 HEAP32[i1 + 580 >> 2] = 0;
 HEAP32[i1 + 588 >> 2] = 0;
 HEAP32[i1 + 604 >> 2] = -1;
 HEAP32[i1 + 592 >> 2] = 1;
 HEAP32[i1 + 596 >> 2] = 0;
 HEAP32[i1 + 600 >> 2] = 0;
 HEAP32[i1 + 608 >> 2] = 0;
 HEAP32[i1 + 624 >> 2] = -1;
 HEAP32[i1 + 612 >> 2] = 1;
 HEAP32[i1 + 616 >> 2] = 0;
 HEAP32[i1 + 620 >> 2] = 0;
 HEAP32[i1 + 628 >> 2] = 0;
 HEAP32[i1 + 644 >> 2] = -1;
 HEAP32[i1 + 632 >> 2] = 1;
 HEAP32[i1 + 636 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 424 >> 2] = 0;
 HEAP32[i1 + 476 >> 2] = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[gb + 1468156 >> 2] = i1;
 __Z12InitGUIStatei(0);
 __Z12InitGUIStatei(1);
 __Z12InitGUIStatei(2);
 __Z12InitGUIStatei(3);
 __Z12InitGUIStatei(4);
 __Z12InitGUIStatei(5);
 __Z12InitGUIStatei(6);
 __Z12InitGUIStatei(7);
 return;
}

function __ZL11EncodeValueRK9PrefValue(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i6 = i10;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 + -253 | 0) >>> 0 < 2) {
  HEAP8[i5 >> 0] = i2;
  i9 = i5 + 1 | 0;
  i8 = i3 + 4 | 0;
  i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
  HEAP8[i9 >> 0] = i8;
  HEAP8[i9 + 1 >> 0] = i8 >> 8;
  HEAP8[i9 + 2 >> 0] = i8 >> 16;
  HEAP8[i9 + 3 >> 0] = i8 >> 24;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, 5);
  STACKTOP = i10;
  return;
 }
 i9 = i3 + 8 | 0;
 i7 = i9 + 11 | 0;
 i4 = HEAP8[i7 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 do if (i8) {
  i2 = i3 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) < 128) {
   i4 = i4 & 255;
   i2 = i3;
   break;
  }
  HEAP8[i5 >> 0] = -128;
  i4 = i5 + 1 | 0;
  HEAP8[i4 >> 0] = i3;
  HEAP8[i4 + 1 >> 0] = i3 >> 8;
  HEAP8[i4 + 2 >> 0] = i3 >> 16;
  HEAP8[i4 + 3 >> 0] = i3 >> 24;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i5, 5);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i5 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255;
  i8 = HEAP8[i7 >> 0] | 0;
  i8 = i8 << 24 >> 24 < 0 ? HEAP32[i2 >> 2] | 0 : i8 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i4 ? HEAP32[i6 >> 2] | 0 : i6, i5, i8 + i5 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i10;
  return;
 } else {
  i6 = i4 & 255;
  i4 = i6;
  i2 = HEAP32[i3 + 12 >> 2] | 0;
  i3 = i6;
 } while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i8 = i8 ? i2 : i4;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, gb + 1086395 | 0, 1, i8 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, i8) | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = i3;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 48 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 48 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 48 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 48 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferaSERKS1_(i3, i2) | 0;
   i2 = i2 + 48 | 0;
   i3 = i3 + 48 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -48 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i1);
   i1 = i1 + 48 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 48 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -48 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 89478485) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 48 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 44739242 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 89478485;
 if (i3 >>> 0 > 89478485) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 48 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 48 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i1, i2);
  i2 = i2 + 48 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 48 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN5physx2Gu5RTree17validateRecursiveEjNS0_10RTreeNodeQEPNS0_9RTreePageE(i19, i2, i1, i18) {
 i19 = i19 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i17 + 56 | 0;
 i14 = i17 + 28 | 0;
 i16 = i17;
 HEAP32[gb + 1457440 >> 2] = (HEAP32[gb + 1457440 >> 2] | 0) + 1;
 if (Math_fround(HEAPF32[i18 >> 2]) == Math_fround(3402823469999999843913219.0e14)) {
  __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE(i18, i16);
  STACKTOP = i17;
  return;
 }
 if (Math_fround(HEAPF32[i18 + 4 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i12 = 1; else if (Math_fround(HEAPF32[i18 + 8 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i12 = 2; else if (Math_fround(HEAPF32[i18 + 12 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i12 = 3; else i12 = 4;
 i15 = i19 + 92 | 0;
 i1 = i2 + 1 | 0;
 i2 = i14 + 4 | 0;
 i3 = i14 + 8 | 0;
 i4 = i14 + 12 | 0;
 i5 = i14 + 16 | 0;
 i6 = i14 + 20 | 0;
 i7 = i14 + 24 | 0;
 i11 = 0;
 do {
  i8 = HEAP32[i18 + (i11 << 2) >> 2] | 0;
  i9 = HEAP32[i18 + 48 + (i11 << 2) >> 2] | 0;
  i10 = HEAP32[i18 + 96 + (i11 << 2) >> 2] | 0;
  f20 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (!(f20 > (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]))) & (i10 & 1 | 0) == 0) {
   i22 = HEAP32[i18 + 80 + (i11 << 2) >> 2] | 0;
   i23 = HEAP32[i18 + 64 + (i11 << 2) >> 2] | 0;
   i24 = HEAP32[i18 + 32 + (i11 << 2) >> 2] | 0;
   i25 = HEAP32[i18 + 16 + (i11 << 2) >> 2] | 0;
   i21 = (HEAP32[i15 >> 2] | 0) + i10 | 0;
   HEAP32[i14 >> 2] = i8;
   HEAP32[i2 >> 2] = i25;
   HEAP32[i3 >> 2] = i24;
   HEAP32[i4 >> 2] = i9;
   HEAP32[i5 >> 2] = i23;
   HEAP32[i6 >> 2] = i22;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i13 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i13 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   HEAP32[i13 + 24 >> 2] = HEAP32[i14 + 24 >> 2];
   __ZN5physx2Gu5RTree17validateRecursiveEjNS0_10RTreeNodeQEPNS0_9RTreePageE(i19, i1, i13, i21);
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i12 | 0));
 __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE(i18, i16);
 STACKTOP = i17;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19ComputeShaderKernelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 96 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469487 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN19ComputeShaderKernel8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 96 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469487 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN19ComputeShaderKernel8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 96 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN10AudioMixer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 92 | 0, i9);
 __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 44 | 0, i9);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i9, i8 + 48 | 0, 0);
 __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 68 | 0, i9);
 i3 = i8 + 96 | 0;
 i7 = i9 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i5 = i9 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
  i3 = i1;
 }
 i1 = i8 + 100 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i3 = i8 + 104 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i2 = i8 + 32 | 0;
 HEAP32[i9 + 4 >> 2] = i2;
 i4 = i8 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 80, 4) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 28 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i4 >> 2] = i1;
 i8 = i1;
 __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 STACKTOP = i10;
 return;
}

function __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaAllRK13Vector2fIcallS1_iff(i1, i2, i3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 8 | 0;
 i14 = i11;
 i12 = i11 + 48 | 0;
 i6 = i11 + 40 | 0;
 i10 = i11 + 16 | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(Math_fround(f18 + f15) * Math_fround(.5));
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(f17 + f16) * Math_fround(.5));
 HEAPF32[i12 + 4 >> 2] = f19;
 f15 = Math_fround(Math_abs(Math_fround(f18 - f15)));
 HEAPF32[i6 >> 2] = Math_fround(Math_abs(Math_fround(f17 - f16)));
 HEAPF32[i6 + 4 >> 2] = f15;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i14;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i14);
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(__Z19GetPhysicsManager2Dv() | 0, i12, i6, Math_fround(0.0), i3, f4, f5, 0, i10) | 0;
 i3 = __Z19GetScriptingManagerv() | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[gb + 32588 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i7 >> 2] | 0) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i3, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i10 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i6 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return i3 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return i3 | 0;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i4 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 + 12 >> 2] = i4;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i3 + 11 >> 0] = i6;
   if (!i6) i4 = i3; else {
    i4 = i3;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i6 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i4;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i3 + 4 >> 2] = i6;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i4 | 0, i5 | 0, i6 | 0) | 0;
  }
  HEAP8[i4 + i6 >> 0] = 0;
  i4 = i3 + 16 | 0;
  i13 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
  HEAP32[i3 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i3 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i3 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
  i4 = i3 + 60 | 0;
  i1 = i1 + 60 | 0;
  i3 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  i1 = i2 + 108 | 0;
  i3 = (HEAP32[i8 >> 2] | 0) + 108 | 0;
  HEAP32[i8 >> 2] = i3;
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab9SubShaderC2ERKS0_(i14, i7) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i9 = i15 + 4 | 0;
 i10 = i15;
 __ZN13dynamic_arrayIPN9ShaderLab4PassELj4EEC2ERKS3_(i14, i7);
 HEAP32[i14 + 20 >> 2] = HEAP32[i7 + 12 >> 2];
 i11 = i14 + 24 | 0;
 i12 = i14 + 28 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 i1 = i14 + 28 | 0;
 HEAP32[i11 >> 2] = i1;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i8 = i7 + 28 | 0;
 if ((i2 | 0) != (i8 | 0)) {
  i3 = i2;
  while (1) {
   i4 = i3 + 16 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   i5 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i11, i6, i9, i4) | 0;
   if (!(HEAP32[i5 >> 2] | 0)) {
    i3 = __Znwj(24) | 0;
    i17 = i4;
    i16 = HEAP32[i17 + 4 >> 2] | 0;
    i4 = i3 + 16 | 0;
    HEAP32[i4 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i4 + 4 >> 2] = i16;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = i4;
    HEAP32[i5 >> 2] = i3;
    i4 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
    if (i4) {
     HEAP32[i11 >> 2] = i4;
     i3 = HEAP32[i5 >> 2] | 0;
    }
    __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i3);
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     break;
    } else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
   }
   if ((i2 | 0) == (i8 | 0)) break; else i3 = i2;
  }
 }
 HEAP32[i14 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 i3 = i14 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i14 + 48 >> 0] = HEAP8[i7 + 48 >> 0] | 0;
 HEAP32[i14 + 52 >> 2] = HEAP32[i7 + 52 >> 2];
 HEAP32[i14 + 56 >> 2] = -1;
 i3 = HEAP32[i14 + 12 >> 2] | 0;
 if (!i3) {
  STACKTOP = i15;
  return;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = 0;
 do {
  i17 = (HEAP32[i2 + (i1 << 2) >> 2] | 0) + 748 | 0;
  HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 STACKTOP = i15;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451057 | 0, i6, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451077 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 455706 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 8 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451094 | 0, i6, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451109 | 0, i6, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451123 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN8TypeTreeaSERKS_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i8 | 0) == (i9 | 0)) return i9 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i9 + 12 | 0;
 i1 = (HEAP32[i8 + 12 >> 2] | 0) * 24 | 0;
 i2 = (i1 | 0) / 24 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  break;
 } else i1 = HEAP32[i9 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
 i5 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = i9 + 20 | 0;
 i6 = i9 + 32 | 0;
 HEAP32[i6 >> 2] = i1;
 i3 = i9 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i7;
  i1 = i7;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0;
 i5 = i9 + 40 | 0;
 i6 = HEAP32[i8 + 40 >> 2] | 0;
 i7 = i9 + 52 | 0;
 i1 = HEAP32[i8 + 52 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx2Sc8BodyCore18setKinematicTargetEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEERKNS_11PxTransformEf(i6, i3, i5, f7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0;
 i4 = i6 + 156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i2 = i3 + 292 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i3);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i3 + 280 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i3 + 284 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  i2 = i1;
  i3 = i2 + 56 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP8[i1 + 31 >> 0] = 1;
  i8 = i6 + 120 | 0;
  HEAP32[i1 + 48 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i6 + 124 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i6 + 128 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i6 + 132 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i6 + 136 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i6 + 140 >> 2];
  i2 = i6 + 112 | 0;
  HEAP32[i1 + 56 >> 2] = HEAP32[i2 >> 2];
  i3 = i6 + 116 | 0;
  HEAP32[i1 + 60 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i4 >> 2] = i1;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP8[i1 + 28 >> 0] = 1;
  i1 = i6 + 4 | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP8[i1 + 28 >> 0] = 1;
  i1 = i6 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2) __ZN5physx2Sc7BodySim22postSetKinematicTargetEv(i2);
 }
 HEAPF32[i6 + 152 >> 2] = f7;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc7BodySim6wakeUpEv(i1);
 __ZN5physx2Sc7BodySim18postSetWakeCounterEfb(i1, f7, 1);
 return;
}

function __ZN5physx20PxsConstraintProjectEPKNS_13PxsConstraintEbf(i7, i8, f1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 28 | 0;
 i5 = i6;
 i2 = HEAP32[i7 + 36 >> 2] | 0;
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 if (!i2) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
 } else {
  i9 = HEAP32[i2 + 64 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 }
 if (!i3) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
 } else {
  i9 = HEAP32[i3 + 64 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i5 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 }
 mftCall_viiii(HEAP32[i7 + 20 >> 2] | 0, HEAP32[i7 + 28 >> 2] | 0, i4 | 0, i5 | 0, i8 | 0);
 if (i8) {
  i9 = HEAP32[i3 + 64 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  STACKTOP = i6;
  return;
 } else {
  i9 = HEAP32[i2 + 64 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 16 | 0;
 i8 = i11;
 i4 = i5 + 1144 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i9 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63800 | 0, 16, gb + 1047202 | 0, 20) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 i10 = i9 + 12 | 0;
 HEAP32[i10 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i6 = i9 + 20 | 0;
 HEAP32[i6 >> 2] = 1;
 do if ((i9 | 0) != (i1 | 0)) {
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  i12 = i2 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i1 >> 2] | 0 : i1;
  i1 = i12 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255;
  i2 = i9 + 11 | 0;
  if (i1 >>> 0 > 10) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, 10, i1 + -10 | 0, 0, 0, 0, i1, i3);
   break;
  }
  if (i1 | 0) _memmove(i9 | 0, i3 | 0, i1 | 0) | 0;
  HEAP8[i9 + i1 >> 0] = 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i1;
   break;
  } else {
   HEAP8[i2 >> 0] = i1;
   break;
  }
 } while (0);
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_(i5, i9, i8) | 0;
  i1 = HEAP32[i5 + 1168 >> 2] | 0;
  if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i9 | 0, i8 | 0, i2 | 0);
 }
 if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 }
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (HEAP32[i6 >> 2] | 0) {
  i12 = 1;
  STACKTOP = i11;
  return i12 | 0;
 }
 if ((HEAP8[i9 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i9 >> 2] | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 63800 | 0);
 i12 = 1;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup11LODStruct50ENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN8LODGroup11LODStruct50ENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 425261 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN8LODGroup11LODStruct508TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 425261 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8LODGroup11LODStruct508TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13InitialModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 4 | 0;
 HEAP8[i1 >> 0] = 1;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = 1;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 8 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 272 | 0, i6);
 __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 536 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 692 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 956 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1220 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1484 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 1748 | 0, i6);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 2012 | 0, i6);
 i1 = i5 + 2540 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 2548 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 2552 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 2553 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  i8 = i5 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __Z29ScriptingToNativeVertexLayoutPK25ScriptingVertexDataLayoutiR19VertexStreamsLayoutR20VertexChannelsLayout(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i9 = i13 + 4 | 0;
 if ((i6 + -1 | 0) >>> 0 > 3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430028 | 0, 0, gb + 429904 | 0, 67, 1, 0, 0, 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 L5 : do if ((i6 | 0) > 0) {
  i10 = i9 + 11 | 0;
  i4 = 0;
  L7 : while (1) {
   i11 = i7 + (i4 << 2) | 0;
   i1 = 0;
   do {
    i2 = HEAP32[i5 + (i4 << 5) + (i1 << 2) >> 2] | 0;
    if (i2 | 0) {
     if (HEAP8[i8 + (i1 << 1) + 1 >> 0] | 0) break L7;
     HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << i1;
     switch (i2 | 0) {
     case 7:
      {
       i2 = 2;
       i3 = 1024;
       break;
      }
     case 1:
      {
       i2 = 0;
       i3 = 256;
       break;
      }
     case 2:
      {
       i2 = 0;
       i3 = 512;
       break;
      }
     case 3:
      {
       i2 = 0;
       i3 = 768;
       break;
      }
     case 4:
      {
       i2 = 0;
       i3 = 1024;
       break;
      }
     case 5:
      {
       i2 = 1;
       i3 = 512;
       break;
      }
     case 6:
      {
       i2 = 1;
       i3 = 1024;
       break;
      }
     default:
      {
       __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429881 | 0, 0, gb + 429904 | 0, 24, 1, 0, 0, 0);
       i2 = 0;
       i3 = 0;
      }
     }
     i14 = i8 + (i1 << 1) | 0;
     i3 = i2 | i3;
     HEAP8[i14 >> 0] = i3;
     HEAP8[i14 + 1 >> 0] = i3 >> 8;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < 8);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i6 | 0)) break L5;
  }
  HEAP32[i12 >> 2] = HEAP32[gb + 58624 + (i1 << 2) >> 2];
  __Z6FormatPKcz(i9, gb + 430111 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 429904 | 0, 80, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i14 = 0;
  STACKTOP = i13;
  return i14 | 0;
 } while (0);
 if (!(HEAP8[i8 >> 0] | 0)) if ((HEAPU8[i8 + 1 >> 0] | 0) >= 3) {
  i14 = 1;
  STACKTOP = i13;
  return i14 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 430061 | 0, 0, gb + 429904 | 0, 90, 1, 0, 0, 0);
 i14 = 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN9JSONWrite8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector4fLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI5RectTIfELj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx14PxRigidBodyExt19getVelocityAtOffsetERKNS_11PxRigidBodyERKNS_6PxVec3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 56 | 0;
 i17 = i4 + 28 | 0;
 i18 = i4;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i17 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i18 | 0, i2 | 0);
 f11 = Math_fround(Math_fround(HEAPF32[i18 + 16 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i18 + 20 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i18 + 24 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i17 + 12 >> 2]);
 f15 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f9 = Math_fround(HEAPF32[i17 >> 2]);
 f6 = Math_fround(f11 * f9);
 f7 = Math_fround(HEAPF32[i17 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f13 * f7));
 f5 = Math_fround(HEAPF32[i17 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f16 * f5));
 f8 = Math_fround(Math_fround(f9 * f6) + Math_fround(Math_fround(f11 * f15) + Math_fround(f14 * Math_fround(Math_fround(f16 * f7) - Math_fround(f13 * f5)))));
 f10 = Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f13 * f15) + Math_fround(f14 * Math_fround(Math_fround(f11 * f5) - Math_fround(f16 * f9)))));
 f6 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * Math_fround(Math_fround(f13 * f9) - Math_fround(f11 * f7)))) + Math_fround(f5 * f6));
 f8 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f8);
 f10 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f10);
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f6);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i12 | 0, i2 | 0);
 f5 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f7 = Math_fround(f6 * f5);
 f11 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f10 * f11));
 f11 = Math_fround(f8 * f11);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(f11 - Math_fround(f6 * f9));
 f5 = Math_fround(Math_fround(f10 * f9) - Math_fround(f8 * f5));
 HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
 STACKTOP = i4;
 return;
}

function __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier(i7, i8, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i12 = i13;
 if ((HEAP16[gb + 1165896 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165896 | 0, i8);
  i6 = gb + 1165896 | 0;
 } else i6 = 0;
 if (!i8) {
  HEAP32[i10 >> 2] = 0;
  i12 = i10 + 8 | 0;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
 } else {
  HEAP32[i11 >> 2] = 0;
  i9 = i11 + 8 | 0;
  i3 = i9;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = HEAP32[i7 + 56 >> 2] | 0;
  i1 = HEAP32[i3 + 36 >> 2] | 0;
  if ((i1 | 0) == -1) i5 = 9; else {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   if ((i2 | 0) > (i8 | 0)) i5 = 9; else if ((HEAP32[i3 + 32 >> 2] | 0) < (i8 | 0)) i5 = 9; else {
    HEAP32[i11 >> 2] = i1;
    i8 = (i8 - i2 | 0) / 2 | 0;
    i5 = i9;
    HEAP32[i5 >> 2] = i8;
    HEAP32[i5 + 4 >> 2] = ((i8 | 0) < 0) << 31 >> 31;
    i5 = 18;
   }
  }
  do if ((i5 | 0) == 9) {
   i4 = i3 + 16 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i1 = i4;
    L14 : while (1) {
     i3 = i2;
     while (1) {
      if ((HEAP32[i3 + 16 >> 2] | 0) >= (i8 | 0)) break;
      i2 = HEAP32[i3 + 4 >> 2] | 0;
      if (!i2) break L14; else i3 = i2;
     }
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i1 = i3;
      break;
     } else i1 = i3;
    }
    if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i8 | 0)) {
     i5 = i1 + 24 | 0;
     HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
     i5 = 18;
     break;
    }
   }
   HEAP32[i11 >> 2] = -1;
   i12 = i9;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i12 = i10 + 8 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i12 + 4 >> 2] = 0;
  } while (0);
  if ((i5 | 0) == 18) {
   __ZN17PersistentManager40GlobalToLocalSerializedFileIndexInternalERK26SerializedObjectIdentifier(i12, i7, i11);
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  }
 }
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i13;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector2fLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 3) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI8BitFieldLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 2) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN8Animator24GetRightFeetBottomHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  STACKTOP = i9;
  return Math_fround(f10);
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i11 + 28 >> 2] | 0;
   i4 = HEAP32[i11 + 32 >> 2] | 0;
   i1 = i11;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  f10 = Math_fround(0.0);
  STACKTOP = i9;
  return Math_fround(f10);
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 f10 = Math_fround(__ZNK6Avatar24GetRightFeetBottomHeightEv(i1));
 STACKTOP = i9;
 return Math_fround(f10);
}

function __ZN21RotationBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, i6, i1 + 4 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620483 | 0, i6, i1 + 800 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 804 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 808 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI18ComputeShaderParamNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 24 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469440 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN18ComputeShaderParam8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469440 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN18ComputeShaderParam8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 85;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 85;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib(i9, i14, i11, i13, i7, i12) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i10 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17 + 8 | 0;
 i15 = i17;
 i8 = HEAP32[i14 + 280 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i14 + 276 >> 2] | 0) + 4 >> 2] | 0;
 i10 = (HEAP32[i14 + 60 >> 2] | 0) != 0;
 f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 if (!(f5 <= f3)) {
  i2 = 0;
  i4 = 0;
  i8 = 0;
 } else if (Math_fround(f5 + Math_fround(HEAPF32[i11 + 8 >> 2])) > f3) {
  f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  if (!(f3 <= f6)) {
   i2 = 0;
   i4 = 0;
   i8 = 0;
  } else if (Math_fround(f3 + Math_fround(HEAPF32[i11 + 12 >> 2])) > f6) if (!(HEAP32[i14 + 268 >> 2] | 0)) {
   i2 = 1;
   i4 = 0;
   i8 = 0;
  } else {
   HEAP32[i14 + 272 >> 2] = 1;
   i2 = 1;
   i4 = (i1 | 0) == (i7 | 0) | (i1 | 0) == 0;
   i8 = 1;
  } else {
   i2 = 0;
   i4 = 0;
   i8 = 0;
  }
 } else {
  i2 = 0;
  i4 = 0;
  i8 = 0;
 }
 i1 = (i1 | 0) == (i7 | 0);
 if ((HEAP32[i14 >> 2] | 0) != (i7 | 0) | i10 ^ 1) i7 = 0; else i7 = (HEAP32[i14 + 72 >> 2] | 0) != 0;
 __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb(i9, i14, i11, i13, i4, i1 & (i10 & i2), i12, i7);
 i4 = i13 + 20 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 if (!(HEAP32[i13 + 24 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 if (i1 | i8) {
  i1 = i14 + 84 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN11UTF16StringD2Ev(i2);
   __ZdlPv(i2);
  }
  i13 = __Znwj(20) | 0;
  i10 = gb + 63672 | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i12 = i15;
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  __ZN11UTF16StringC2ERKS_10MemLabelId(i13, i4, i16);
  HEAP32[i1 >> 2] = i13;
 }
 if (!i7) {
  STACKTOP = i17;
  return;
 }
 i1 = i14 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 i14 = __Znwj(20) | 0;
 i11 = gb + 63672 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i15;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i14, i4, i16);
 HEAP32[i1 >> 2] = i14;
 STACKTOP = i17;
 return;
}

function __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0) | 0) {
  i2 = i5 + 32 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 946425 | 0, gb + 737343 | 0, i6, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrI14PhysicMaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
 }
 if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i5 | 0) | 0) {
  i4 = i5 + 40 | 0;
  i1 = HEAP32[gb + 36972 >> 2] | 0;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 800918 | 0, i1, i6, 0) | 0;
  if (i2 | 0) {
   do if ((i2 | 0) > 0) {
    i2 = i7 + 16 | 0;
    i9 = HEAP32[i7 + 20 >> 2] | 0;
    i3 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i2 >> 2] = i3;
    if (i3 >>> 0 >= i9 >>> 0) if ((i3 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     break;
    }
    __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
   } else {
    i2 = HEAP32[i6 >> 2] | 0;
    if (i2 | 0) mftCall_iii(i2 | 0, i4 | 0, i7 | 0) | 0;
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
 } else i1 = HEAP32[gb + 36972 >> 2] | 0;
 i3 = i5 + 41 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047713 | 0, i1, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap11freeBuffersEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 5 | 0;
 i6 = i12 + 4 | 0;
 i7 = i12 + 3 | 0;
 i8 = i12 + 2 | 0;
 i9 = i12 + 1 | 0;
 i10 = i12;
 HEAP32[i11 + 236 >> 2] = 0;
 HEAP32[i11 + 248 >> 2] = 0;
 i3 = i11 + 232 | 0;
 i4 = i11 + 240 | 0;
 if ((HEAP32[i4 >> 2] | 0) != 64) {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, 512, gb + 716671 | 0, 603) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = 64;
 }
 i3 = i11 + 244 | 0;
 i4 = i11 + 252 | 0;
 if ((HEAP32[i4 >> 2] | 0) != 64) {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, 512, gb + 716671 | 0, 603) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = 64;
 }
 HEAP32[i11 + 184 >> 2] = 0;
 i1 = i11 + 188 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 1024) {
  i6 = i11 + 180 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i6 >> 2] | 0);
  HEAP32[i6 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, 4096, gb + 716671 | 0, 623) | 0;
  HEAP32[i1 >> 2] = 1024;
 }
 i1 = i11 + 292 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 8192) {
  i8 = i11 + 284 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, 65536, gb + 716671 | 0, 633) | 0;
  HEAP32[i1 >> 2] = 8192;
 }
 HEAP32[i11 + 288 >> 2] = 0;
 i1 = i11 + 332 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 8192) {
  i8 = i11 + 324 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, 65536, gb + 716671 | 0, 633) | 0;
  HEAP32[i1 >> 2] = 8192;
 }
 HEAP32[i11 + 328 >> 2] = 0;
 i1 = i11 + 372 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 8192) {
  i10 = i11 + 368 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i11 + 192 | 0;
  __ZN5physx14SapPairManager12shrinkMemoryEv(i11);
  STACKTOP = i12;
  return;
 }
 i8 = i11 + 364 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, 65536, gb + 716671 | 0, 633) | 0;
 HEAP32[i1 >> 2] = 8192;
 i10 = i11 + 368 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i11 + 192 | 0;
 __ZN5physx14SapPairManager12shrinkMemoryEv(i11);
 STACKTOP = i12;
 return;
}

function __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i3 = i11 + 16 | 0;
 if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 12 >> 2] | 0) == -1) i4 = 4; else if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] & 32768)) {
  i10 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i10;
 } else i4 = 4;
 do if ((i4 | 0) == 4) {
  if (!(HEAP8[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 3 >> 0] | 0)) {
   __ZNK16TypeTreeIterator8ChildrenEv(i9, i5);
   if (HEAP32[i9 >> 2] | 0) do {
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i9, i6, i7, i8);
    __ZNK16TypeTreeIterator4NextEv(i10, i9);
    i2 = i10;
    i4 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i9;
    HEAP32[i3 >> 2] = i4;
    HEAP32[i3 + 4 >> 2] = i2;
   } while ((i4 | 0) != 0);
   break;
  }
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i2 + (HEAP32[i7 >> 2] | 0) + (Math_imul(HEAP32[i6 + 20 >> 2] | 0, 0 - (HEAP32[i6 + 16 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 8; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 8 >> 2] | 0) >>> 0) i4 = 8; else {
    HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i6 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i9, 4);
  if (i8) HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
  __ZNK16TypeTreeIterator8ChildrenEv(i3, i5);
  __ZNK16TypeTreeIterator4NextEv(i10, i3);
  if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i10) | 0) + 12 >> 2] | 0) == -1) i4 = 13; else if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i10) | 0) + 20 >> 2] & 49152)) {
   i9 = HEAP32[i9 >> 2] | 0;
   i10 = Math_imul(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i10) | 0) + 12 >> 2] | 0, i9) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i10;
  } else i4 = 13;
  if ((i4 | 0) == 13) if ((HEAP32[i9 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i10, i6, i7, i8);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
  }
 } while (0);
 if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] & 16384)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 STACKTOP = i11;
 return;
}

function __Z20MarkInstanceIDAsRootiR21GarbageCollectorState(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = i1;
 if (i1 | 0) {
  if ((HEAP32[i10 + 80 >> 2] | 0) == (HEAP32[i10 + 48 >> 2] | 0)) {
   i2 = HEAP32[i10 + 72 >> 2] | 0;
   i3 = HEAP32[i10 + 76 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i2, i10 + 44 | 0, i3);
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i10 + 72 >> 2] | 0;
   i3 = HEAP32[i10 + 76 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i8 | 0) == -1) {
    STACKTOP = i11;
    return;
   }
   i1 = (HEAP32[i10 >> 2] | 0) + (i8 << 3) + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 & 536870912 | 0) {
    STACKTOP = i11;
    return;
   }
   i9 = i10 + 20 | 0;
   HEAP32[i1 >> 2] = i2 | 536870912;
   i7 = i2 & 536870911;
   if (!((i7 | 0) != 78 & (((i7 | 0) == 43 | ((i7 | 0) == 142 | ((i7 | 0) == 84 | ((i7 | 0) == 158 | ((i7 | 0) == 171 | ((i7 | 0) == 89 | ((i7 + -187 | 0) >>> 0 < 2 | ((i7 | 0) == 117 | ((i7 + -27 | 0) >>> 0 < 2 | ((i7 | 0) == 150 | ((i7 | 0) == 147 | ((i7 | 0) == 115 | (i7 | 0) == 149)))))))))))) ^ 1) & 1 | (HEAPU8[i10 + 105 >> 0] | 0))) {
    STACKTOP = i11;
    return;
   }
   i2 = i10 + 32 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i10 + 36 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = i10;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i8;
   STACKTOP = i11;
   return;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i6, i7, i8, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 f10 = Math_fround(HEAPF32[i7 + 108 >> 2]);
 i3 = i1 + 36 | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = i4 + 2148 | 0;
 i1 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i1 | 0));
 __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef(i3, gb + 1114932 | 0, i8);
 if ((HEAP32[i7 + 40 >> 2] | 0) == 2) {
  i3 = HEAP32[i7 + 268 >> 2] | 0;
  i5 = HEAP32[i7 + 272 >> 2] | 0;
  f12 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i7 + 48 >> 2]));
  HEAP32[i4 + 676 >> 2] = HEAP32[i7 + 264 >> 2];
  HEAP32[i4 + 680 >> 2] = i3;
  HEAP32[i4 + 684 >> 2] = i5;
  HEAPF32[i4 + 688 >> 2] = f12;
 }
 f12 = Math_fround(HEAPF32[i6 + 360 >> 2]);
 __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f(HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 8 >> 2] | 0, f10, f12, Math_fround(HEAPF32[i6 + 364 >> 2]), i9);
 i7 = i4 + 708 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i7 = i4 + 788 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 f10 = Math_fround(Math_fround(.5) / Math_fround(HEAPF32[i8 + 20 >> 2]));
 f12 = Math_fround(Math_fround(.5) / Math_fround(HEAPF32[i8 + 24 >> 2]));
 f13 = Math_fround(-f10);
 f14 = Math_fround(-f12);
 HEAPF32[i4 + 724 >> 2] = f13;
 HEAPF32[i4 + 728 >> 2] = f14;
 HEAPF32[i4 + 732 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 736 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 740 >> 2] = f10;
 HEAPF32[i4 + 744 >> 2] = f14;
 HEAPF32[i4 + 748 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 752 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 756 >> 2] = f13;
 HEAPF32[i4 + 760 >> 2] = f12;
 HEAPF32[i4 + 764 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 768 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 772 >> 2] = f10;
 HEAPF32[i4 + 776 >> 2] = f12;
 HEAPF32[i4 + 780 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 784 >> 2] = Math_fround(0.0);
 STACKTOP = i11;
 return;
}

function __ZN8Animator23GetLeftFeetBottomHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(0.0);
  STACKTOP = i9;
  return Math_fround(f10);
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i11 + 28 >> 2] | 0;
   i4 = HEAP32[i11 + 32 >> 2] | 0;
   i1 = i11;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  f10 = Math_fround(0.0);
  STACKTOP = i9;
  return Math_fround(f10);
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 f10 = Math_fround(__ZNK6Avatar23GetLeftFeetBottomHeightEv(i1));
 STACKTOP = i9;
 return Math_fround(f10);
}

function __ZNK21FullParameterPreparer14OnPrepareFloatER12PartialArrayIfERKN20GpuProgramParameters14ValueParameterEj(i4, i1, i6, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i3 = i13 + 16 | 0;
 i11 = i13 + 8 | 0;
 i8 = i13;
 HEAP32[i3 >> 2] = -1;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i9 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i11, i9, i10, i12, i3);
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 i11 = HEAP16[i11 + 4 >> 1] | 0;
 i11 = i11 << 16 >> 16 == 0 ? 1 : i11;
 i12 = HEAP32[i6 + 8 >> 2] | 0;
 i12 = (i12 | 0) == 0 ? 1 : i12 & 65535;
 HEAP16[i1 + 6 >> 1] = i12;
 HEAP16[i1 + 4 >> 1] = (i12 & 65535) < (i11 & 65535) ? i12 : i11;
 i11 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i11) {
  STACKTOP = i13;
  return 1;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i13;
  return 1;
 }
 if (!(11 >>> (i2 & 15) & 1)) {
  STACKTOP = i13;
  return 1;
 }
 i10 = (i1 | 0) == 4 ? -1 : HEAP32[i3 >> 2] | 0;
 i9 = (HEAP32[i4 + 12 >> 2] | 0) + i5 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i11 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i11 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 + (i4 * 20 | 0) >> 2] = i10;
 HEAP32[i8 + (i4 * 20 | 0) + 4 >> 2] = i2;
 HEAP32[i8 + (i4 * 20 | 0) + 8 >> 2] = i9;
 HEAP32[i8 + (i4 * 20 | 0) + 12 >> 2] = 0;
 HEAP16[i8 + (i4 * 20 | 0) + 16 >> 1] = i12;
 HEAP16[i8 + (i4 * 20 | 0) + 18 >> 1] = 0;
 i11 = i11 + 100 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i12 & 65535);
 STACKTOP = i13;
 return 1;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayI4AABBLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 * 24 | 0) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferI4AABBEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5Light17RemoveFromManagerEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 if (HEAP32[i6 + 36 >> 2] | 0) __ZN12LightManager11RemoveLightEP5Light(__Z15GetLightManagerv() | 0, i6);
 i8 = i6 + 56 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i4 | 0) {
  i2 = HEAP32[gb + 1110376 >> 2] | 0;
  i7 = i2 + 4 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((i2 | 0) == (i1 | 0)) break;
   i3 = i2 + 40 | 0;
   if ((HEAP32[i2 + 32 >> 2] | 0) == (i4 | 0)) {
    i5 = 7;
    break;
   } else i2 = i3;
  }
  do if ((i5 | 0) == 7) {
   if ((i3 | 0) != (i1 | 0)) {
    do {
     HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
     i5 = i2 + 28 | 0;
     i4 = i3 + 28 | 0;
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
     HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
     i3 = i3 + 40 | 0;
     i2 = i2 + 40 | 0;
    } while ((i3 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) break;
   }
   HEAP32[i7 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
  } while (0);
  HEAP32[i8 >> 2] = 0;
 }
 i2 = i6 + 60 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) return;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i8;
   i8 = i1 + 12 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i8;
   i8 = i1 + 12 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 52 | 0) + 49 >> 0] = 0;
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN24CompressedAnimationCurveaSERKS_(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i8 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i1 = (i8 | 0) == (i3 | 0);
 if (i1) {
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  i7 = i8 + 36 | 0;
  i6 = i3 + 36 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP8[i7 + 12 >> 0] = HEAP8[i6 + 12 >> 0] | 0;
 } else {
  __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i8 + 8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0);
  HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i8 + 24 | 0, HEAP32[i3 + 24 >> 2] | 0, HEAP32[i3 + 28 >> 2] | 0);
  i7 = i8 + 36 | 0;
  i6 = i3 + 36 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP8[i7 + 12 >> 0] = HEAP8[i6 + 12 >> 0] | 0;
  __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i8 + 52 | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 56 >> 2] | 0);
 }
 i6 = i3 + 64 | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i8 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i2;
 i7 = i8 + 72 | 0;
 i2 = i3 + 72 | 0;
 if (i1) return i8 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 i6 = i1 ? HEAP32[i2 >> 2] | 0 : i2;
 i5 = i1 ? HEAP32[i3 + 76 >> 2] | 0 : i5 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i8 + 80 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i5 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i8 + 76 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
  return i8 | 0;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i8 + 76 >> 2] = i5;
  return i8 | 0;
 } else {
  HEAP8[i3 >> 0] = i5;
  return i8 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_110DataStream18setPropertyMessageEPKvRKN5physx8debugger14NamespacedNameENS4_7DataRefIKhEE(i17, i15, i16, i14) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 32 | 0;
 i11 = i18;
 i13 = HEAP32[i17 + 64 >> 2] | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 80 >> 2] | 0, i3 | 0, i12 | 0, i16 | 0);
 i12 = i14 + 4 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i10;
 i6 = i1 - i2 | 0;
 if (i6 >>> 0 < (HEAP32[i3 + 36 >> 2] | 0) >>> 0) {
  i17 = 2;
  i16 = HEAP32[i13 >> 2] | 0;
  i16 = i16 + 20 | 0;
  i16 = HEAP32[i16 >> 2] | 0;
  mftCall_vi(i16 | 0, i13 | 0);
  STACKTOP = i18;
  return i17 | 0;
 }
 i7 = HEAP32[i3 + 44 >> 2] | 0;
 i3 = HEAP32[i3 + 40 >> 2] | 0;
 i9 = i3;
 if ((i7 | 0) != (i9 | 0)) {
  i4 = i17 + 356 | 0;
  i5 = i17 + 368 | 0;
  i8 = i17 + 372 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(i4, i10, i6);
  i1 = i7 - i3 >> 2;
  i2 = 0;
  do {
   i7 = i10 + (HEAP32[i9 + (i2 << 2) >> 2] | 0) | 0;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i7 = i7 | 0 ? i7 : gb + 1576256 | 0;
   __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j(i4, i7, (_strlen(i7) | 0) + 1 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i12 >> 2] = i1;
 i9 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i17, HEAP32[i16 >> 2] | 0) | 0;
 i10 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i17, HEAP32[i16 + 4 >> 2] | 0) | 0;
 i14 = HEAP32[i14 >> 2] | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = gb + 150160 + 8;
 i12 = i11 + 8 | 0;
 HEAP32[i12 >> 2] = i15;
 HEAP32[i12 + 4 >> 2] = 0;
 i15 = i11 + 16 | 0;
 HEAP32[i15 >> 2] = i9;
 HEAP32[i15 + 4 >> 2] = i10;
 HEAP32[i11 + 24 >> 2] = i14;
 HEAP32[i11 + 28 >> 2] = i16;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i17, i11, 11);
 i17 = (HEAPU8[i17 + 392 >> 0] | 0) ^ 1;
 i16 = HEAP32[i13 >> 2] | 0;
 i16 = i16 + 20 | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 mftCall_vi(i16 | 0, i13 | 0);
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN11UnityEngine7Connect14RemoteSettings10UnregisterEPNS0_13ConfigHandlerE(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 i11 = i8 + 17 | 0;
 if (!((i2 | 0) != 0 & (HEAP8[i11 >> 0] | 0) != 0)) {
  STACKTOP = i12;
  return;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i3 = _strlen(gb + 1041415 | 0) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i4 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i10 + 11 >> 0] = i3;
  if (!i3) i1 = i10; else {
   i1 = i10;
   i4 = 7;
  }
 } else i4 = 5;
 if ((i4 | 0) == 5) {
  i7 = i3 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i3;
  i4 = 7;
 }
 if ((i4 | 0) == 7) _memcpy(i1 | 0, gb + 1041415 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i6 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i2, i10) | 0;
 i7 = i6 + 768 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L13 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 1003 | 0)) {
    i4 = i6 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L13;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i8;
  if (i8 >>> 0 > i1 >>> 0) do {
   i8 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 HEAP8[i11 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __Z35CalculateTriangleAreaRadialFrustum2P8Vector3ffff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i5;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f13 = Math_fround(f9 * f9);
 i16 = i14 + 4 | 0;
 f7 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f7 * f7));
 f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f8 * f8)))) * f2) + f3)) * f4);
 f9 = Math_fround(f9 * f8);
 HEAPF32[i14 >> 2] = f9;
 f8 = Math_fround(f7 * f8);
 HEAPF32[i16 >> 2] = f8;
 i16 = i14 + 12 | 0;
 i15 = i1 + 12 | 0;
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 f7 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = Math_fround(f7 * f7);
 i15 = i14 + 16 | 0;
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f11 * f11));
 f6 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f6 * f6)))) * f2) + f3)) * f4);
 f7 = Math_fround(f7 * f6);
 HEAPF32[i16 >> 2] = f7;
 f6 = Math_fround(f11 * f6);
 HEAPF32[i15 >> 2] = f6;
 i15 = i14 + 24 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i15 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 f13 = Math_fround(f11 * f11);
 f10 = Math_fround(HEAPF32[i14 + 28 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f10 * f10));
 f12 = Math_fround(HEAPF32[i14 + 32 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f12 * f12)))) * f2) + f3)) * f4);
 f3 = Math_fround(f11 * f4);
 f4 = Math_fround(f10 * f4);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f9 - f3) * Math_fround(f8 + f4)) + Math_fround(Math_fround(Math_fround(f7 - f9) * Math_fround(f6 + f8)) + Math_fround(Math_fround(f3 - f7) * Math_fround(f6 + f4)))) * Math_fround(.5));
 i1 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 STACKTOP = i5;
 return Math_fround(i1 ? f3 : f4);
}

function __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5, i13, i2) {
 i5 = i5 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i8 = i2;
 i7 = i13;
 i6 = i8 - i7 | 0;
 i12 = i6 >> 2;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 i10 = i9;
 if (i12 >>> 0 <= i1 - i9 >> 2 >>> 0) {
  i6 = i5 + 4 | 0;
  i4 = (HEAP32[i6 >> 2] | 0) - i9 >> 2;
  i5 = i12 >>> 0 > i4 >>> 0;
  i4 = i5 ? i13 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i9 | 0, i13 | 0, i1 | 0) | 0;
  i2 = i10 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i14;
    return;
   }
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (i1 >> 2 << 2);
   STACKTOP = i14;
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    STACKTOP = i14;
    return;
   }
   HEAP32[i6 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   STACKTOP = i14;
   return;
  }
 }
 i3 = i9;
 if (i9) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i10 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i9 | 0) >>> 2) << 2);
  i10 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i3 = i10 >> 1;
 i3 = i10 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i12 >>> 0 ? i12 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i11 >> 2] = i1 + (i3 << 2);
 if ((i6 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 _memcpy(i1 | 0, i13 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i12 << 2);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI13dynamic_arrayI21TreePrototypeColliderLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEjRKS3_(i10, i2, i9) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_(i1, i9);
   i1 = (HEAP32[i12 >> 2] | 0) + 20 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i15;
  return;
 }
 i13 = i10 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 20 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = 1;
  HEAP32[i14 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 20 | 0, 16, i14, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i6 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i3 = i7;
 i4 = i6 + (i5 * 20 | 0) | 0;
 i8 = i3;
 i1 = i7;
 do {
  __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_(i1, i9);
  i1 = i8 + 20 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i1 = i1 + -20 | 0;
   __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_(i2 + -20 | 0, i1);
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) {
  STACKTOP = i15;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i14 >> 2] = 1;
 HEAP32[i14 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i2, i1, i13, i3, i12, i14) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 4 | 0;
 i11 = i15;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i14; else {
  HEAP32[gb + 1457176 >> 2] = (HEAP32[gb + 1457176 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i11 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i10 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i11 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i10 = 9;
   } else i10 = 8;
  }
  if ((i10 | 0) == 8) {
   i9 = _strlen(i1) | 0;
   i8 = i1 + i9 | 0;
   if ((i9 | 0) > 0) {
    i5 = i1;
    i9 = 0;
    i4 = 0;
    i2 = 0;
    i3 = 0;
    while (1) {
     if (!i5) i7 = i3; else if (!(HEAP8[i5 >> 0] | 0)) i7 = i3; else i7 = _strtoul(i5, i11, 10) | 0;
     i3 = i9 + 4 | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i4 | 0) | 0;
      if (i9 | 0) _memcpy(i5 | 0, i2 | 0, i9 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else i6 = i2;
     i5 = i6 + i9 | 0;
     HEAP8[i5 >> 0] = i7;
     HEAP8[i5 + 1 >> 0] = i7 >> 8;
     HEAP8[i5 + 2 >> 0] = i7 >> 16;
     HEAP8[i5 + 3 >> 0] = i7 >> 24;
     i5 = HEAP32[i11 >> 2] | 0;
     if (i5 >>> 0 >= i8 >>> 0) break; else {
      i9 = i3;
      i3 = i7;
     }
    }
    i4 = i1;
    i3 = i3 >>> 2;
    i1 = i14;
   } else i10 = 9;
  }
  if ((i10 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i14;
  }
  HEAP32[i13 >> 2] = i2;
  HEAP32[i12 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, 0);
 STACKTOP = i15;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431299 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN17SubstanceEnumItem8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431299 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN17SubstanceEnumItem8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378809 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN13ProbeSetIndex8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 24 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378809 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN13ProbeSetIndex8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_(i8, i9, i1, i2, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i12 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_(i8, i9, i1, i11) | 0;
 if (!(mftCall_iii(HEAP32[i11 >> 2] | 0, i2 | 0, i1 | 0) | 0)) return i12 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i10;
 i10 = i1 + 4 | 0;
 i17 = i2 + 4 | 0;
 i18 = HEAP32[i10 >> 2] | 0;
 i5 = i1 + 8 | 0;
 i16 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + 12 | 0;
 i14 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i15 = i2 + 8 | 0;
 i20 = HEAP32[i15 >> 2] | 0;
 i13 = i2 + 12 | 0;
 i19 = HEAP32[i13 >> 2] | 0;
 i4 = i2 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i5 >> 2] = i20;
 HEAP32[i6 >> 2] = i19;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i17 >> 2] = i18;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i4 >> 2] = i3;
 if (!(mftCall_iii(HEAP32[i11 >> 2] | 0, i1 | 0, i9 | 0) | 0)) {
  i20 = i12 + 1 | 0;
  return i20 | 0;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i4 = i9 + 4 | 0;
 i17 = HEAP32[i4 >> 2] | 0;
 i1 = i9 + 8 | 0;
 i18 = HEAP32[i1 >> 2] | 0;
 i2 = i9 + 12 | 0;
 i19 = HEAP32[i2 >> 2] | 0;
 i3 = i9 + 16 | 0;
 i20 = HEAP32[i3 >> 2] | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i15 = HEAP32[i6 >> 2] | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 >> 2] = i14;
 HEAP32[i2 >> 2] = i15;
 HEAP32[i3 >> 2] = i16;
 HEAP32[i10 >> 2] = i17;
 HEAP32[i5 >> 2] = i18;
 HEAP32[i6 >> 2] = i19;
 HEAP32[i7 >> 2] = i20;
 if (!(mftCall_iii(HEAP32[i11 >> 2] | 0, i9 | 0, i8 | 0) | 0)) {
  i20 = i12 + 2 | 0;
  return i20 | 0;
 }
 i17 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i17;
 i9 = i8 + 4 | 0;
 i17 = HEAP32[i9 >> 2] | 0;
 i11 = i8 + 8 | 0;
 i18 = HEAP32[i11 >> 2] | 0;
 i14 = i8 + 12 | 0;
 i19 = HEAP32[i14 >> 2] | 0;
 i16 = i8 + 16 | 0;
 i20 = HEAP32[i16 >> 2] | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i11 >> 2] = i10;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i16 >> 2] = i15;
 HEAP32[i4 >> 2] = i17;
 HEAP32[i1 >> 2] = i18;
 HEAP32[i2 >> 2] = i19;
 HEAP32[i3 >> 2] = i20;
 i20 = i12 + 3 | 0;
 return i20 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 88 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 88 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 88 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 88 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN9ShaderLab18SerializedPropertyaSERKS0_(i2, i3) | 0;
   i3 = i3 + 88 | 0;
   i2 = i2 + 88 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -88 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN9ShaderLab18SerializedPropertyD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i1);
   i1 = i1 + 88 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 88 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -88 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 48806446) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 88 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 24403223 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 48806446;
 if (i1 >>> 0 > 48806446) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 88 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 88 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i1);
  i1 = i1 + 88 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 88 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 if (!(HEAP32[i3 + 236 >> 2] & 2)) i1 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i3 + 16 | 0) | 0; else i1 = (HEAP32[i3 + 8 >> 2] | 0) + 96 | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 176 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 180 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 184 >> 2]);
 f19 = Math_fround(HEAPF32[i3 + 188 >> 2]);
 f11 = Math_fround(f5 + f5);
 f21 = Math_fround(f4 + f4);
 f20 = Math_fround(f6 + f6);
 f9 = Math_fround(f4 * f21);
 f13 = Math_fround(f6 * f20);
 f4 = Math_fround(f11 * f4);
 f10 = Math_fround(f11 * f6);
 f15 = Math_fround(f11 * f19);
 f6 = Math_fround(f21 * f6);
 f21 = Math_fround(f21 * f19);
 f19 = Math_fround(f20 * f19);
 f20 = Math_fround(Math_fround(Math_fround(1.0) - f9) - f13);
 f14 = Math_fround(f4 + f19);
 f7 = Math_fround(f10 - f21);
 f19 = Math_fround(f4 - f19);
 f11 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f11));
 f13 = Math_fround(f11 - f13);
 f5 = Math_fround(f6 + f15);
 f21 = Math_fround(f10 + f21);
 f15 = Math_fround(f6 - f15);
 f9 = Math_fround(f11 - f9);
 f11 = Math_fround(f17 * f20);
 f6 = Math_fround(f17 * f14);
 f17 = Math_fround(f17 * f7);
 f10 = Math_fround(f16 * f19);
 f4 = Math_fround(f16 * f13);
 f16 = Math_fround(f16 * f5);
 f12 = Math_fround(f18 * f21);
 f8 = Math_fround(f18 * f15);
 f18 = Math_fround(f18 * f9);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f21 * f12) + Math_fround(Math_fround(f20 * f11) + Math_fround(f19 * f10)));
 i1 = i2 + 12 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(f15 * f8) + Math_fround(Math_fround(f14 * f6) + Math_fround(f13 * f4)));
 i3 = i2 + 24 | 0;
 HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f9 * f18) + Math_fround(Math_fround(f7 * f17) + Math_fround(f5 * f16)));
 f13 = Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f14 * f11) + Math_fround(f13 * f10)));
 HEAPF32[i2 + 4 >> 2] = f13;
 HEAPF32[i1 >> 2] = f13;
 f10 = Math_fround(Math_fround(f9 * f12) + Math_fround(Math_fround(f7 * f11) + Math_fround(f5 * f10)));
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i3 >> 2] = f10;
 f4 = Math_fround(Math_fround(f9 * f8) + Math_fround(Math_fround(f7 * f6) + Math_fround(f5 * f4)));
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i3 + 4 >> 2] = f4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 * 36 | 0;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 656742 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 * 36 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i1 = i1 + 36 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 36 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i4 + (i6 * 36 | 0) + 32 >> 2] = HEAP32[i7 + 32 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 36 | 0) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 36 | 0) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 * 36 | 0) | 0;
 return i10 | 0;
}

function __ZN5physx13ActorAABBTaskC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 104456 + 8;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 44 | 0;
 HEAP16[i1 + 48 >> 1] = -1;
 HEAP16[i1 + 50 >> 1] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 84 | 0;
 HEAP16[i1 + 88 >> 1] = -1;
 HEAP16[i1 + 90 >> 1] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 124 | 0;
 HEAP16[i1 + 128 >> 1] = -1;
 HEAP16[i1 + 130 >> 1] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 164 | 0;
 HEAP16[i1 + 168 >> 1] = -1;
 HEAP16[i1 + 170 >> 1] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i2 = i1 + 184 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 204 | 0;
 HEAP16[i1 + 208 >> 1] = -1;
 HEAP16[i1 + 210 >> 1] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i2 = i1 + 224 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 244 | 0;
 HEAP16[i1 + 248 >> 1] = -1;
 HEAP16[i1 + 250 >> 1] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 104500 + 8;
 i1 = i1 + 264 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN20ComputeShaderVariant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i13 = i11 + 24 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 i1 = i10 + 4 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
  i8 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i8 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i3 = i10 + 8 | 0;
 i7 = i10 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = (i2 - i1 | 0) / 96 | 0;
 HEAP32[i9 >> 2] = i5;
 i6 = i8 + 4 | 0;
 if (i6 >>> 0 < i4 >>> 0) {
  HEAP32[i8 >> 2] = i5;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19ComputeShaderKernel8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 96 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i10 + 20 | 0;
 i7 = i10 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 20 | 0;
 HEAP32[i9 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i10 + 32 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
}

function _finish_pass_huff(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i16 + 16 | 0;
 i13 = i16;
 i14 = HEAP32[i10 + 348 >> 2] | 0;
 i15 = i10 + 24 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i11 = i14 + 12 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i12 = i14 + 16 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i14 = i14 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 i7 = i1 >>> 0 < 128;
 i3 = i9;
 i2 = i7 ? i8 : i3;
 i6 = i6 << 7 | 127;
 if ((i4 | 0) > 0) {
  i5 = i4 + 7 | 0;
  do {
   i5 = i5 + -8 | 0;
   i17 = i6 >>> i5;
   i4 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = i17;
   if ((i17 & 255 | 0) == 255) {
    HEAP8[i4 >> 0] = 0;
    i2 = i2 + 2 | 0;
   } else i2 = i4;
  } while ((i5 | 0) > 7);
 }
 i4 = i2;
 L9 : do if (i7) {
  i2 = i4 - i8 | 0;
  if (!i2) i2 = i9; else {
   i6 = i2;
   i5 = i8;
   i2 = i9;
   while (1) {
    i4 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
    _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
    i3 = i2 + i4 | 0;
    i2 = i3;
    i5 = i5 + i4 | 0;
    i1 = i1 - i4 | 0;
    if (!i1) {
     i1 = HEAP32[i15 >> 2] | 0;
     if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) break;
     i3 = HEAP32[i1 >> 2] | 0;
     i2 = i3;
     i1 = HEAP32[i1 + 4 >> 2] | 0;
    }
    i6 = i6 - i4 | 0;
    if (!i6) break L9;
   }
   i9 = HEAP32[i10 >> 2] | 0;
   HEAP32[i9 + 20 >> 2] = 24;
   mftCall_vi(HEAP32[i9 >> 2] | 0, i10 | 0);
   i9 = i2;
   i10 = 0;
   i17 = HEAP32[i15 >> 2] | 0;
   HEAP32[i17 >> 2] = i9;
   i17 = i17 + 4 | 0;
   HEAP32[i17 >> 2] = i10;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   STACKTOP = i16;
   return;
  }
 } else {
  i2 = i4;
  i1 = i1 + i9 - i4 | 0;
 } while (0);
 i9 = i2;
 i10 = i1;
 i17 = HEAP32[i15 >> 2] | 0;
 HEAP32[i17 >> 2] = i9;
 i17 = i17 + 4 | 0;
 HEAP32[i17 >> 2] = i10;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 STACKTOP = i16;
 return;
}

function __ZN9ShaderLabL17FindLightModePassEPNS_9SubShaderE14ShaderPassType(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i7 + 20 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  i11 = -1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i10 = i8 + 11 | 0;
 i1 = 0;
 while (1) {
  i6 = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 760 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4) {
   i3 = i6;
   L7 : while (1) {
    i5 = i4;
    while (1) {
     if ((HEAP32[i5 + 16 >> 2] | 0) >= 0) break;
     i4 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i4) break L7; else i5 = i4;
    }
    i4 = HEAP32[i5 >> 2] | 0;
    if (!i4) {
     i3 = i5;
     break;
    } else i3 = i5;
   }
   if ((i3 | 0) != (i6 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) < 1) {
    i4 = HEAP32[i3 + 20 >> 2] | 0;
    i2 = HEAP32[gb + 1166564 >> 2] | 0;
    i5 = i2 + 4 | 0;
    i2 = HEAP32[i2 >> 2] | 0;
    i3 = i2;
    L16 : do if ((i3 | 0) == (i5 | 0)) i11 = 18; else {
     while (1) {
      if ((HEAP32[i3 + 20 >> 2] | 0) == (i4 | 0)) break;
      i3 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i3) while (1) {
       i3 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) break; else i2 = i3;
      } else {
       i2 = i3;
       while (1) {
        i3 = HEAP32[i2 >> 2] | 0;
        if (!i3) {
         i3 = i2;
         break;
        } else i2 = i3;
       }
      }
      if ((i3 | 0) == (i5 | 0)) {
       i11 = 18;
       break L16;
      } else i2 = i3;
     }
     i6 = HEAP32[i3 + 16 >> 2] | 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i6, _strlen(i6) | 0);
    } while (0);
    if ((i11 | 0) == 18) {
     i11 = 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 480497 | 0, 13);
    }
    i6 = (__Z7StrICmpPKcS0_((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, HEAP32[gb + 68848 + 32 >> 2] | 0) | 0) == 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    if (i6) {
     i11 = 22;
     break;
    }
    i2 = HEAP32[i9 >> 2] | 0;
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = -1;
   i11 = 22;
   break;
  }
 }
 if ((i11 | 0) == 22) {
  STACKTOP = i12;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_18RelativeStartEventEEEvhtRKT_(i10, i1, i2, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP8[i9 >> 0] = i1;
 i4 = i9 + 1 | 0;
 HEAP16[i9 + 2 >> 1] = i2;
 i6 = i8;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i10 + 104 | 0;
 i2 = i7;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP8[i4 >> 0] = 3;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i4 = i5;
  i2 = i6;
  i1 = 3;
 } else {
  i2 = _i64Subtract(i5 | 0, i6 | 0, i1 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 256) i1 = 0; else if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 65536) i1 = 1; else i1 = i3 >>> 0 < 1 | (i3 | 0) == 1 & i2 >>> 0 < 0 ? 2 : 3;
  HEAP8[i4 >> 0] = i1;
  i12 = (i1 | 0) == 3;
  i4 = i12 ? i5 : i2;
  i2 = i12 ? i6 : i3;
 }
 i12 = i8;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i10 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i9, i7);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i8, i1 & 3);
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 < (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[i10 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (i9) i3 = i1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2;
 i4 = i3 - i1 | 0;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (i5) {
  i1 = i10 + 32 | 0;
  i3 = 0;
  do {
   i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, i4 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i9) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i14, i11, i7, i15, i8, i9) {
 i14 = i14 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 32 | 0;
 i6 = i16 + 16 | 0;
 i12 = i16;
 if (!i9) {
  i15 = -1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i3 = Math_imul(i9, i8) | 0;
 i2 = HEAP32[i14 + 8 + (i7 << 2) >> 2] | 0;
 i1 = HEAP32[i14 + 8 + (i7 + 1 << 2) >> 2] | 0;
 L4 : do if ((i2 | 0) < (i1 | 0)) {
  i4 = HEAP32[i14 + 32 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i5 | 0)) break;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i1 | 0)) {
    i13 = 7;
    break L4;
   }
  }
  if ((i2 | 0) < 0) i13 = 7; else {
   i4 = HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   i1 = i4 & 1048575;
   i4 = i4 >>> 20 & 1023;
   if (i4 >>> 0 < i9 >>> 0) {
    HEAP32[i10 >> 2] = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i11) | 0;
    HEAP32[i10 + 4 >> 2] = i9;
    HEAP32[i10 + 8 >> 2] = i4;
    __Z6FormatPKcz(i12, gb + 479096 | 0, i10);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 479016 | 0, 347, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
    i3 = Math_imul(i4, i8) | 0;
   }
  }
 } else i13 = 7; while (0);
 if ((i13 | 0) == 7) {
  if (i9 >>> 0 > 1023) {
   HEAP32[i6 >> 2] = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i11) | 0;
   HEAP32[i6 + 4 >> 2] = i9;
   HEAP32[i6 + 8 >> 2] = 1023;
   __Z6FormatPKcz(i12, gb + 478947 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 479016 | 0, 336, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
   i1 = 1023;
  } else i1 = i9;
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i12, i14, i11, i7, i3, i1, 0);
  i1 = i12;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 i1 = (HEAP32[i14 + 72 >> 2] | 0) + i1 | 0;
 if (!i15) {
  _memset(i1 | 0, 0, i3 | 0) | 0;
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 } else {
  _memcpy(i1 | 0, i15 | 0, i3 | 0) | 0;
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 }
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN5Flare12FlareElementENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 5;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 373622 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN5Flare12FlareElement8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 373622 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN5Flare12FlareElement8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13InitialModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 4 | 0;
 HEAP8[i1 >> 0] = 1;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 8 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 272 | 0, i6);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 536 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 692 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 956 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1220 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1484 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 1748 | 0, i6);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 2012 | 0, i6);
 i1 = i5 + 2540 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 2548 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 2552 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 2553 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  i8 = i5 + 2276 | 0;
  __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  return;
 }
}

function __ZN9BlobWrite8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP8[i2 + 20 >> 0] = 0;
  HEAP8[i2 + 21 >> 0] = i6 & 1;
  HEAP8[i2 + 22 >> 0] = i7;
  i7 = i2 + 16 | 0;
  HEAP32[i7 >> 2] = 0;
  __ZN7mecanim8skeleton8Skeleton8TransferI8BlobSizeEEvRT_(i5, i2);
  i7 = HEAP32[i7 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i4, (0 - i7 & 3) + i7 | 0, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i5, gb + 912455 | 0, 0);
 i9 = i4 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i2 >> 2] = i5 + 4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i10;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 906508 | 0, 0);
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i2 >> 2] = i5 + 8;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i10;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIjEEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 910040 | 0, 0);
 i10 = i5 + 12 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i10, gb + 912463 | 0, 0);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i2 >> 2] = i5 + 16;
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i2 + 8 >> 2] = i9;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 906515 | 0, 0);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_17RelativeStopEventEEEvhtRKT_(i10, i1, i2, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP8[i9 >> 0] = i1;
 i4 = i9 + 1 | 0;
 HEAP16[i9 + 2 >> 1] = i2;
 i6 = i8;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i10 + 104 | 0;
 i2 = i7;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP8[i4 >> 0] = 3;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i4 = i5;
  i2 = i6;
  i1 = 3;
 } else {
  i2 = _i64Subtract(i5 | 0, i6 | 0, i1 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 256) i1 = 0; else if (i3 >>> 0 < 0 | (i3 | 0) == 0 & i2 >>> 0 < 65536) i1 = 1; else i1 = i3 >>> 0 < 1 | (i3 | 0) == 1 & i2 >>> 0 < 0 ? 2 : 3;
  HEAP8[i4 >> 0] = i1;
  i12 = (i1 | 0) == 3;
  i4 = i12 ? i5 : i2;
  i2 = i12 ? i6 : i3;
 }
 i12 = i8;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i10 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i9, i7);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i8, i1 & 3);
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 < (HEAP32[i10 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i11;
  return;
 }
 i8 = HEAP32[i10 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (i9) i3 = i1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2;
 i4 = i3 - i1 | 0;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (i5) {
  i1 = i10 + 32 | 0;
  i3 = 0;
  do {
   i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, i4 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i9) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __Z5SlerpRK11QuaternionfS1_f(i9, i2, i4, f11) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f11 = Math_fround(f11);
 var f1 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f12 * f3);
 f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f13 * f6));
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f10 * f7));
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f8 * f1));
 if (f5 < Math_fround(0.0)) {
  f5 = Math_fround(-f5);
  f3 = Math_fround(-f3);
  f7 = Math_fround(-f7);
  f1 = Math_fround(-f1);
  f6 = Math_fround(-f6);
 }
 if (f5 < Math_fround(.949999988)) {
  f5 = Math_fround(+Math_acos(+f5));
  f15 = Math_fround(Math_fround(1.0) / Math_fround(+Math_sin(+f5)));
  f14 = Math_fround(+Math_sin(+Math_fround(f5 * f11)));
  f5 = Math_fround(+Math_sin(+Math_fround(Math_fround(Math_fround(1.0) - f11) * f5)));
  f6 = Math_fround(f15 * Math_fround(Math_fround(f6 * f14) + Math_fround(f5 * f13)));
  f11 = Math_fround(f15 * Math_fround(Math_fround(f7 * f14) + Math_fround(f5 * f10)));
  f13 = Math_fround(f15 * Math_fround(Math_fround(f1 * f14) + Math_fround(f5 * f8)));
  HEAPF32[i9 >> 2] = Math_fround(f15 * Math_fround(Math_fround(f3 * f14) + Math_fround(f5 * f12)));
  HEAPF32[i9 + 4 >> 2] = f6;
  HEAPF32[i9 + 8 >> 2] = f11;
  HEAPF32[i9 + 12 >> 2] = f13;
  return;
 }
 if (Math_fround(Math_fround(Math_fround(Math_fround(f3 * f12) + Math_fround(f6 * f13)) + Math_fround(f7 * f10)) + Math_fround(f1 * f8)) < Math_fround(0.0)) {
  f7 = Math_fround(-f7);
  f5 = Math_fround(-f6);
  f3 = Math_fround(-f3);
  f1 = Math_fround(-f1);
 } else f5 = f6;
 f6 = Math_fround(f12 + Math_fround(Math_fround(f3 - f12) * f11));
 f13 = Math_fround(f13 + Math_fround(Math_fround(f5 - f13) * f11));
 f14 = Math_fround(f10 + Math_fround(Math_fround(f7 - f10) * f11));
 f15 = Math_fround(f8 + Math_fround(Math_fround(f1 - f8) * f11));
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f14 * f14) + Math_fround(Math_fround(f13 * f13) + Math_fround(f6 * f6))))));
 f13 = Math_fround(f13 / f12);
 f14 = Math_fround(f14 / f12);
 f15 = Math_fround(f15 / f12);
 HEAPF32[i9 >> 2] = Math_fround(f6 / f12);
 HEAPF32[i9 + 4 >> 2] = f13;
 HEAPF32[i9 + 8 >> 2] = f14;
 HEAPF32[i9 + 12 >> 2] = f15;
 return;
}

function __Z43TerrainData_Get_Custom_PropDetailPrototypesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 if (!i1) {
  i15 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i15);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i15 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i15);
 }
 i3 = i2 + 128 | 0;
 i14 = i3 + 16 | 0;
 i15 = HEAP32[(__Z26GetTerrainScriptingClassesv() | 0) >> 2] | 0;
 i3 = i3 + 20 | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i15, 4, ((HEAP32[i3 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0) / 136 | 0) | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i17;
  return i4 | 0;
 }
 i5 = i16 + 8 | 0;
 i6 = i16 + 12 | 0;
 i7 = i16 + 16 | 0;
 i8 = i16 + 20 | 0;
 i9 = i16 + 24 | 0;
 i10 = i16 + 28 | 0;
 i11 = i16 + 32 | 0;
 i12 = i16 + 36 | 0;
 i13 = i16 + 40 | 0;
 i2 = 0;
 do {
  __Z21DetailPrototypeToMonoRK15DetailPrototypeR19MonoDetailPrototype(i1 + (i2 * 136 | 0) | 0, i16);
  i18 = _il2cpp_object_new(i15 | 0) | 0;
  i21 = i16;
  i20 = HEAP32[i21 + 4 >> 2] | 0;
  i19 = i18 + 8 | 0;
  HEAP32[i19 >> 2] = HEAP32[i21 >> 2];
  HEAP32[i19 + 4 >> 2] = i20;
  i19 = HEAP32[i6 >> 2] | 0;
  i20 = HEAP32[i7 >> 2] | 0;
  i21 = HEAP32[i8 >> 2] | 0;
  HEAP32[i18 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i18 + 20 >> 2] = i19;
  HEAP32[i18 + 24 >> 2] = i20;
  HEAP32[i18 + 28 >> 2] = i21;
  i21 = HEAP32[i10 >> 2] | 0;
  i20 = HEAP32[i11 >> 2] | 0;
  i19 = HEAP32[i12 >> 2] | 0;
  HEAP32[i18 + 32 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i18 + 36 >> 2] = i21;
  HEAP32[i18 + 40 >> 2] = i20;
  HEAP32[i18 + 44 >> 2] = i19;
  i19 = i18 + 48 | 0;
  HEAP32[i19 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i19 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i19 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i19 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i19 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i19 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
  HEAP32[i19 + 24 >> 2] = HEAP32[i13 + 24 >> 2];
  HEAP32[i19 + 28 >> 2] = HEAP32[i13 + 28 >> 2];
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i2, i18);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i3 >> 2] | 0) - i1 | 0) / 136 | 0) >>> 0);
 STACKTOP = i17;
 return i4 | 0;
}

function __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i10 = i14;
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i15 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i15;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i15) {
   i15 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i15 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   i16 = i3 + 8 | 0;
   i4 = HEAP32[i16 + 4 >> 2] | 0;
   i15 = i10;
   HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i15 + 4 >> 2] = i4;
   HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags(i3, i11, i13, 0);
   HEAP8[i5 >> 0] = 1;
   i15 = i3 + 56 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i11, HEAP32[i9 + 24 >> 2] | 0, HEAP32[i8 + 28 >> 2] | 0);
 } while (0);
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i16 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
 STACKTOP = i14;
 return;
}

function __ZNK5physx29PxVehicleDriveNWGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 624 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i6 = i11 + 544 | 0;
 i7 = HEAP32[i1 + 116 >> 2] | 0;
 i5 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i8 >> 2] = i5;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i12 = i8;
  i4 = HEAP32[i12 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i8) | 0;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6;
 i2 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev(i6);
 mftCall_vii(i7 | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i3 = i9 + 4 | 0;
 __ZN5physx2Sn18writeAllPropertiesINS_23PxVehicleDriveSimDataNWEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(HEAP32[i9 >> 2] | 0, i8, HEAP32[i3 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0, HEAP32[i9 + 16 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i12 = i10 + 2 | 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i12 = i10 + 2 | 0;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if (!(HEAP32[i2 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63304 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i3 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = i3 + 180 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = i3 + 216 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  i4 = i3 + 240 | 0;
  HEAP8[i4 >> 0] = 3;
  i4 = i3 + 241 | 0;
  HEAP8[i4 >> 0] = 2;
  i4 = i3 + 242 | 0;
  HEAP8[i4 >> 0] = 1;
  i4 = i3 + 243 | 0;
  HEAP8[i4 >> 0] = 0;
  return;
 }
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i4 = i3 + 216 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i4 = i3 + 240 | 0;
 HEAP8[i4 >> 0] = 3;
 i4 = i3 + 241 | 0;
 HEAP8[i4 >> 0] = 2;
 i4 = i3 + 242 | 0;
 HEAP8[i4 >> 0] = 1;
 i4 = i3 + 243 | 0;
 HEAP8[i4 >> 0] = 0;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue8TransferI8JSONReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5, gb + 1040830 | 0, 0, 0);
 i3 = i5 + 4 | 0;
 i7 = i6 + 36 | 0;
 HEAP8[i7 >> 0] = 0;
 i8 = i6 + 40 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (!i4) HEAP8[i7 >> 0] = 0; else {
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1040838 | 0) | 0;
   HEAP32[i8 >> 2] = i9;
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[gb + 37260 >> 2];
   if (i9 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i3);
    HEAP8[i7 >> 0] = 1;
    i9 = i6 + 56 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   }
   HEAP32[i8 >> 2] = i4;
   HEAP32[i1 >> 2] = i2;
  }
  i1 = i5 + 20 | 0;
  HEAP8[i7 >> 0] = 0;
  if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
   i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1040855 | 0) | 0;
   HEAP32[i8 >> 2] = i9;
   i2 = i6 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[gb + 37260 >> 2];
   if (i9 | 0) {
    __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
    __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i1);
    HEAP8[i7 >> 0] = 1;
    i9 = i6 + 56 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   }
   HEAP32[i8 >> 2] = i4;
   HEAP32[i2 >> 2] = i3;
  }
 }
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 52 | 0, gb + 1040876 | 0, 0, 0);
 __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 56 | 0, gb + 1040893 | 0, 0, 0);
 HEAP8[i7 >> 0] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) != 3) return;
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i1, gb + 1040926 | 0) | 0;
 HEAP32[i8 >> 2] = i9;
 i2 = i6 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 1040934;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
  __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig8TransferI8JSONReadEEvRT_(i5 + 60 | 0, i6);
  HEAP8[i7 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i8 = i10 + 28 | 0;
 i9 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i12 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
 i2 = i12;
 i11 = i10 + 40 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 44 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 3, 4, i10 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i10 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i4;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 + (i3 << 3) >> 2] = i9;
 HEAP32[i7 + (i3 << 3) + 4 >> 2] = i2;
 HEAP32[i12 + 28 >> 2] = i10;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 48 >> 2] | 0, i12 | 0, (HEAP32[i10 + 8 >> 2] | 0) >>> 13 & 127 | 0);
 i7 = i10 + 60 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 if (!(HEAP32[i10 + 56 >> 2] & 16)) {
  HEAP32[i7 >> 2] = 0;
  i8 = i10 + 28 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   i5 = i3;
   i2 = 0;
   i4 = i3;
   do {
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    if (i3) {
     i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0) | 0;
     i2 = HEAP32[i7 >> 2] | i2;
     HEAP32[i7 >> 2] = i2;
     i4 = HEAP32[i8 >> 2] | 0;
     i1 = HEAP32[i11 >> 2] | 0;
    }
    i5 = i5 + 8 | 0;
   } while ((i5 | 0) != (i4 + (i1 << 3) | 0));
   if (!((i6 | 0) == (i2 | 0) | (i1 | 0) == 0)) {
    i5 = i4;
    i3 = i4;
    while (1) {
     i2 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i2) i2 = i3; else {
      mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, HEAP32[i7 >> 2] | 0);
      i2 = HEAP32[i8 >> 2] | 0;
      i1 = HEAP32[i11 >> 2] | 0;
     }
     i5 = i5 + 8 | 0;
     if ((i5 | 0) == (i2 + (i1 << 3) | 0)) break; else i3 = i2;
    }
   }
  }
 }
 i11 = __ZNK10GameObject8IsActiveEv(i10) | 0;
 i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0;
 if (i11) {
  mftCall_vii(i1 | 0, i12 | 0, 8);
  return;
 } else {
  mftCall_vii(i1 | 0, i12 | 0, 0);
  return;
 }
}

function __ZNK11AudioSource28CalculateDistanceAttenuationEv(i6) {
 i6 = i6 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i8 = i10;
 i2 = __ZNK12AudioManager16GetAudioListenerEv(__Z15GetAudioManagerv() | 0) | 0;
 if (!i2) f7 = Math_fround(0.0); else {
  __ZNK9Transform11GetPositionEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 36 >> 2]));
  f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 40 >> 2]));
  f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 44 >> 2]));
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f7 * f7))));
 }
 f1 = Math_fround(HEAPF32[(__Z15GetAudioManagerv() | 0) + 36 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 400 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 396 >> 2]);
 switch (HEAP32[i6 + 416 >> 2] | 0) {
 case 1:
  {
   f1 = Math_fround(f3 - f4);
   if (!(f1 <= Math_fround(0.0))) f1 = Math_fround(Math_fround(f3 - f7) / f1); else f1 = Math_fround(1.0);
   break;
  }
 case 0:
  {
   if (f1 != Math_fround(1.0) & f4 < f7) f1 = Math_fround(f4 + Math_fround(f1 * Math_fround(f7 - f4))); else f1 = f7;
   i5 = f1 < Math_fround(9.99999997e-07);
   f1 = Math_fround(f4 / (i5 ? Math_fround(9.99999997e-07) : f1));
   break;
  }
 case 2:
  {
   if (f3 > Math_fround(0.0)) f1 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i6 + 300 | 0, Math_fround(f7 / f3), 0)); else f1 = Math_fround(1.0);
   break;
  }
 default:
  f1 = Math_fround(1.0);
 }
 i5 = f1 < Math_fround(0.0);
 f3 = i5 ? Math_fround(0.0) : f1;
 i5 = f3 > Math_fround(1.0);
 f3 = i5 ? Math_fround(1.0) : f3;
 i5 = HEAP32[i6 + 540 >> 2] | 0;
 do if (i5 | 0) {
  i6 = i6 + 544 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) if (HEAP32[i2 + 144 >> 2] | 0) {
   HEAPF32[i9 >> 2] = Math_fround(0.0);
   HEAP32[i8 >> 2] = 0;
   i5 = (__ZN4FMOD3DSP11getUserDataEPPv(i5, i8) | 0) == 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if (!(i5 & (i2 | 0) != 0)) break;
   i8 = mftCall_iiffi(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, +f7, +f3, i9 | 0) | 0;
   f1 = Math_fround(HEAPF32[i9 >> 2]);
   if (!i8) {
    f7 = f1;
    STACKTOP = i10;
    return Math_fround(f7);
   }
  }
 } while (0);
 f7 = f3;
 STACKTOP = i10;
 return Math_fround(f7);
}

function __ZN5physx7NpShape16setFlagsInternalENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i13, i8) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 16 | 0;
 i2 = i14 + 8 | 0;
 i1 = i14;
 i10 = i14 + 20 | 0;
 i11 = i13 + 32 | 0;
 i7 = i13 + 116 | 0;
 i3 = HEAP8[i8 >> 0] | 0;
 if (((HEAP32[i7 >> 2] | 0) + -5 | 0) >>> 0 < 2) if (!(i3 & 4)) i6 = 1; else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 689543 | 0, 610, gb + 689612 | 0, i1);
  STACKTOP = i14;
  return;
 } else i6 = 0;
 if ((i3 & 5) == 5) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 689543 | 0, 617, gb + 689691 | 0, i2);
  STACKTOP = i14;
  return;
 }
 i5 = HEAPU8[((HEAP32[i13 + 36 >> 2] & 64 | 0) == 0 ? i13 + 112 | 0 : (HEAP32[i13 + 40 >> 2] | 0) + 52 | 0) >> 0] | 0;
 i4 = (i5 & 1 | 0) != 0;
 i2 = i3 & 1;
 i12 = i13 + 20 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 do if (i1 | 0) {
  i3 = HEAP16[i1 + 4 >> 1] | 0;
  if (i3 << 16 >> 16 == 5) i1 = ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1) != 0; else i1 = 0;
  if (!(i4 | (i2 << 24 >> 24 == 0 | (i3 << 16 >> 16 == 6 | i1)))) {
   if (!i6) if ((HEAP32[i7 >> 2] | 0) != 1) break;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 689543 | 0, 641, gb + 689782 | 0, i9);
   STACKTOP = i14;
   return;
  }
 } while (0);
 i9 = HEAP8[i8 >> 0] | 0;
 i3 = (i9 & 2) != 0;
 HEAP8[i10 >> 0] = i9;
 __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj64ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i11, i13 + 48 | 0, i10);
 if (!((i5 & 2 | 0) != 0 ^ i3)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i12 >> 2] | 0) | 0;
 i1 = i1 + 3392 | 0;
 if (i3) {
  __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorERKNS_7NpShapeE(i2, i1, HEAP32[i12 >> 2] | 0, i13);
  STACKTOP = i14;
  return;
 } else {
  __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerERKNS_7NpShapeE(i2, i1, i13);
  STACKTOP = i14;
  return;
 }
}

function __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet(i10, i3, i1, i2) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 44 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 if (!((i3 | 0) != 0 & i1 >>> 0 < 13)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i8 + 32 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i7 = i10 + 32 | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i10 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i5 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i5 | 0)) {
     i2 = 11;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   i2 = 12;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  } else if ((i2 | 0) == 11) {
   HEAP32[i6 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i3 = i6;
    i2 = 12;
    break;
   } else break;
  }
 } while (0);
 if ((i2 | 0) == 12) {
  i1 = __Znwj(32) | 0;
  HEAP32[i1 + 16 >> 2] = i5;
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i7 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 + 36 >> 2] | 0, i2);
  i7 = i10 + 40 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE10insert_oneERKS1_(i9, i1 + 20 | 0, i8);
 i1 = (HEAP8[i9 + 4 >> 0] | 0) != 0;
 if (i1) HEAP8[i10 + 44 >> 0] = 0;
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15DetailPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 136 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937557 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15DetailPrototype8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 136 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937557 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15DetailPrototype8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 136 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, HEAP32[i2 >> 2] | 0, i12 + 8 | 0);
 i9 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37208 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Gu29checkOverlapSphere_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = i1 + 4 | 0;
 L1 : do if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(1.0)) {
  f12 = Math_fround(HEAPF32[i9 >> 2]);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i8 + 16 >> 2]));
  f14 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f14 = Math_fround(f14 - Math_fround(HEAPF32[i8 + 20 >> 2]));
  f17 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f12 = Math_fround(f12 * Math_fround(2.0));
  f14 = Math_fround(f14 * Math_fround(2.0));
  f17 = Math_fround(Math_fround(f17 - Math_fround(HEAPF32[i8 + 24 >> 2])) * Math_fround(2.0));
  f15 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f16 = Math_fround(Math_fround(f15 * f15) + Math_fround(-.5));
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  f5 = Math_fround(f12 * f13);
  f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f14 * f11));
  f10 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f17 * f10));
  f3 = Math_fround(Math_fround(f13 * f5) + Math_fround(Math_fround(f12 * f16) - Math_fround(f15 * Math_fround(Math_fround(f17 * f11) - Math_fround(f14 * f10)))));
  f4 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f14 * f16) - Math_fround(f15 * Math_fround(Math_fround(f12 * f10) - Math_fround(f17 * f13)))));
  f5 = Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f11)))) + Math_fround(f10 * f5));
  i1 = HEAP8[i6 + 55 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   i9 = 1;
   return i9 | 0;
  }
  i1 = i1 & 255;
  i2 = HEAP32[i6 + 56 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   f17 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
   f17 = Math_fround(f17 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 4 >> 2])));
   f17 = Math_fround(f17 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2])));
   if (Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f17) > Math_fround(0.0)) break L1;
   if (!i1) {
    i1 = 1;
    break;
   } else i2 = i2 + 20 | 0;
  }
  return i1 | 0;
 } while (0);
 i9 = __ZN5physx2Gu21intersectSphereConvexERKNS0_6SphereERKNS0_10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformEPNS_6PxVec3E(i9, i6, i7, i8, 0) | 0;
 return i9 | 0;
}

function __ZN15TerrainRenderer16ForceSplitParentER12QuadTreeNode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i2 = __ZN15TerrainRenderer7GetNodeEiii(i4, (HEAP32[i1 + 24 >> 2] | 0) / 2 | 0, (HEAP32[i1 + 28 >> 2] | 0) / 2 | 0, (HEAP32[i1 + 32 >> 2] | 0) + 1 | 0) | 0;
 i3 = i2 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN15TerrainRenderer16ForceSplitParentER12QuadTreeNode(i4, i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((i1 | 0) != 2) return;
 i5 = i4 + 48 | 0;
 i6 = i4 + 68 | 0;
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 0) | 0;
 HEAP32[i1 + 16 >> 2] = 2;
 f7 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i5, i1 + 36 | 0));
 i8 = i1 + 60 | 0;
 i9 = f7 < Math_fround(HEAPF32[i6 >> 2]) & 1;
 HEAP8[i8 >> 0] = HEAP8[i8 >> 0] & -2 | i9;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, 0);
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 1) | 0;
 HEAP32[i1 + 16 >> 2] = 2;
 f7 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i5, i1 + 36 | 0));
 i8 = i1 + 60 | 0;
 i9 = f7 < Math_fround(HEAPF32[i6 >> 2]) & 1;
 HEAP8[i8 >> 0] = HEAP8[i8 >> 0] & -2 | i9;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, 0);
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 2) | 0;
 HEAP32[i1 + 16 >> 2] = 2;
 f7 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i5, i1 + 36 | 0));
 i8 = i1 + 60 | 0;
 i9 = f7 < Math_fround(HEAPF32[i6 >> 2]) & 1;
 HEAP8[i8 >> 0] = HEAP8[i8 >> 0] & -2 | i9;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, 0);
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 3) | 0;
 HEAP32[i1 + 16 >> 2] = 2;
 f7 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i5, i1 + 36 | 0));
 i5 = i1 + 60 | 0;
 i6 = f7 < Math_fround(HEAPF32[i6 >> 2]) & 1;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2 | i6;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, 0);
 __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 0) | 0);
 __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 1) | 0);
 __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 2) | 0);
 __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i2, 3) | 0);
 HEAP32[i3 >> 2] = 1;
 return;
}

function __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, f22 = f0, i23 = 0, i24 = 0, i25 = 0, f26 = f0, i27 = 0, i28 = 0;
 HEAP32[i1 + 216 >> 2] = i2;
 HEAP32[i1 + 220 >> 2] = i3;
 __ZN20SphericalHarmonicsL27SetZeroEv(i1);
 __ZN20SphericalHarmonicsL27SetZeroEv(i1 + 108 | 0);
 i3 = __Z12GetGfxDevicev() | 0;
 i28 = HEAP32[i1 + 4 >> 2] | 0;
 i27 = HEAP32[i1 + 8 >> 2] | 0;
 f26 = Math_fround(HEAPF32[i1 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f26 = Math_fround(f26 - f15);
 i25 = HEAP32[i1 + 48 >> 2] | 0;
 i24 = HEAP32[i1 + 40 >> 2] | 0;
 i23 = HEAP32[i1 + 44 >> 2] | 0;
 f22 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f22 = Math_fround(f22 - f11);
 i21 = HEAP32[i1 + 84 >> 2] | 0;
 i20 = HEAP32[i1 + 76 >> 2] | 0;
 i19 = HEAP32[i1 + 80 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f18 = Math_fround(f18 - f7);
 i17 = HEAP32[i1 + 16 >> 2] | 0;
 i16 = HEAP32[i1 + 20 >> 2] | 0;
 f15 = Math_fround(f15 * Math_fround(3.0));
 i14 = HEAP32[i1 + 28 >> 2] | 0;
 i13 = HEAP32[i1 + 52 >> 2] | 0;
 i12 = HEAP32[i1 + 56 >> 2] | 0;
 f11 = Math_fround(f11 * Math_fround(3.0));
 i10 = HEAP32[i1 + 64 >> 2] | 0;
 i9 = HEAP32[i1 + 88 >> 2] | 0;
 i8 = HEAP32[i1 + 92 >> 2] | 0;
 f7 = Math_fround(f7 * Math_fround(3.0));
 i6 = HEAP32[i1 + 100 >> 2] | 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = HEAP32[i1 + 68 >> 2] | 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 HEAP32[i3 + 1012 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 1016 >> 2] = i28;
 HEAP32[i3 + 1020 >> 2] = i27;
 HEAPF32[i3 + 1024 >> 2] = f26;
 HEAP32[i3 + 1028 >> 2] = i25;
 HEAP32[i3 + 1032 >> 2] = i24;
 HEAP32[i3 + 1036 >> 2] = i23;
 HEAPF32[i3 + 1040 >> 2] = f22;
 HEAP32[i3 + 1044 >> 2] = i21;
 HEAP32[i3 + 1048 >> 2] = i20;
 HEAP32[i3 + 1052 >> 2] = i19;
 HEAPF32[i3 + 1056 >> 2] = f18;
 HEAP32[i3 + 1060 >> 2] = i17;
 HEAP32[i3 + 1064 >> 2] = i16;
 HEAPF32[i3 + 1068 >> 2] = f15;
 HEAP32[i3 + 1072 >> 2] = i14;
 HEAP32[i3 + 1076 >> 2] = i13;
 HEAP32[i3 + 1080 >> 2] = i12;
 HEAPF32[i3 + 1084 >> 2] = f11;
 HEAP32[i3 + 1088 >> 2] = i10;
 HEAP32[i3 + 1092 >> 2] = i9;
 HEAP32[i3 + 1096 >> 2] = i8;
 HEAPF32[i3 + 1100 >> 2] = f7;
 HEAP32[i3 + 1104 >> 2] = i6;
 HEAP32[i3 + 1108 >> 2] = i5;
 HEAP32[i3 + 1112 >> 2] = i4;
 HEAP32[i3 + 1116 >> 2] = i2;
 HEAPF32[i3 + 1120 >> 2] = Math_fround(1.0);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI14OcclusionSceneLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 5) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 379042 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN14OcclusionScene8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 32 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 379042 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14OcclusionScene8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 32 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i13, i14, i11, i10, i7, i1) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i12 = 0;
 i12 = __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i13, i14, i11, i10, i1) | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 if (f5 < f6) {
  i2 = i10 + 4 | 0;
  i3 = i7 + 4 | 0;
  i1 = i3;
  i9 = i2;
  i3 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i14 = i12;
   return i14 | 0;
  }
  i1 = i7 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i10 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i2 >>> 0) {
   i9 = i3;
   i3 = i4;
  } else {
   i14 = i12;
   return i14 | 0;
  }
 }
 HEAPF32[i10 >> 2] = f5;
 HEAPF32[i7 >> 2] = f6;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i1 >> 2] = i2;
 i2 = i12 + 1 | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 if (f5 < f6) {
  i1 = i11 + 4 | 0;
  i8 = i1;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i14 = i2;
   return i14 | 0;
  }
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i11 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i1 >>> 0) {
   i8 = i3;
   i2 = i4;
  } else {
   i14 = i2;
   return i14 | 0;
  }
 }
 HEAPF32[i11 >> 2] = f5;
 HEAPF32[i10 >> 2] = f6;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i1;
 i2 = i12 + 2 | 0;
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i14 >> 2]);
 if (f5 < f6) {
  i1 = i14 + 4 | 0;
  i7 = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i14 = i2;
   return i14 | 0;
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i14 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i1 >>> 0) {
   i7 = i3;
   i2 = i4;
  } else {
   i14 = i2;
   return i14 | 0;
  }
 }
 HEAPF32[i14 >> 2] = f5;
 HEAPF32[i11 >> 2] = f6;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i1;
 i2 = i12 + 3 | 0;
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 f6 = Math_fround(HEAPF32[i13 >> 2]);
 if (f5 < f6) {
  i1 = i13 + 4 | 0;
  i3 = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i14 = i2;
   return i14 | 0;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i13 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i1 >>> 0) i2 = i4; else {
   i14 = i2;
   return i14 | 0;
  }
 }
 HEAPF32[i13 >> 2] = f5;
 HEAPF32[i14 >> 2] = f6;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i7 >> 2] = i1;
 i14 = i12 + 4 | 0;
 return i14 | 0;
}

function __ZNK9profiling14SamplerManager18SetSamplersEnabledEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i9 = i12;
 if ((HEAP16[gb + 1451028 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451028 | 0, i4);
  i5 = gb + 1451028 | 0;
 } else i5 = 0;
 i10 = i6 + 84 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i11 = i6 + 88 | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i4, i6, i7, i7 + ((HEAP32[i11 >> 2] | 0) * 36 | 0) | 0, 1);
 i7 = (HEAP32[i10 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 36 | 0) | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i9, i6, i7, i7, 1);
 i7 = i4 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 4 | 0;
 if ((i2 | 0) != (HEAP32[i8 >> 2] | 0)) {
  i3 = 0 - (i1 & 1 ^ 1) | 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i1 + 32 >> 2] | 0) + 6 | 0;
   i13 = HEAPU16[i2 >> 1] | 0;
   HEAP16[i2 >> 1] = (i13 ^ i3) & 32768 ^ i13;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv(i4) | 0;
   i2 = (HEAP32[i10 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 36 | 0) | 0;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i9, i6, i2, i2, 1);
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != (HEAP32[i8 >> 2] | 0));
 }
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i12;
 return;
}

function __Z23StringScriptingToVectorINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvP11Il2CppArrayRT_(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i12) | 0;
 i15 = i13 + 4 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i5 = i1 - i3 >> 4;
 i2 = i1;
 if (i4 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj(i13, i4 - i5 | 0);
  i1 = HEAP32[i15 >> 2] | 0;
 } else if (i4 >>> 0 < i5 >>> 0) {
  i4 = i3 + (i4 << 4) | 0;
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i14 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i15 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i11 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i14 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i14);
     i1 = HEAP32[i15 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i16;
  return;
 }
 i10 = i14 + 11 | 0;
 i11 = i14 + 4 | 0;
 i9 = 0;
 i1 = i2;
 do {
  i2 = i1 + (i9 << 4) | 0;
  __Z24scripting_cpp_string_forP12Il2CppString(i14, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i12, i9) | 0);
  i8 = HEAP8[i10 >> 0] | 0;
  i5 = i8 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i14 >> 2] | 0 : i14;
  i8 = i5 ? HEAP32[i11 >> 2] | 0 : i8 & 255;
  i5 = i2 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i6 = (HEAP32[i1 + (i9 << 4) + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  do if (i8 >>> 0 > i6 >>> 0) {
   if (i4) i1 = HEAP32[i1 + (i9 << 4) + 4 >> 2] | 0; else i1 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i6, i8 - i6 | 0, i1, 0, i1, i8, i7);
  } else {
   if (i4) i2 = HEAP32[i2 >> 2] | 0;
   if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
   HEAP8[i2 + i8 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i1 + (i9 << 4) + 4 >> 2] = i8;
    break;
   } else {
    HEAP8[i5 >> 0] = i8;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  i9 = i9 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while (i9 >>> 0 < (HEAP32[i15 >> 2] | 0) - i1 >> 4 >>> 0);
 STACKTOP = i16;
 return;
}

function __ZN8Animator8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 104 | 0, i8);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 108 | 0, i8);
 i4 = i7 + 92 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i10 = i8 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i8 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i5 = i7 + 96 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i3;
 i1 = i7 + 417 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 418 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i1 = i7 + 561 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i7 + 560 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Sc5Scene36collectPostSolverVelocitiesBeforeCCDEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!(HEAP8[i1 + 2392 >> 0] | 0)) return;
 i10 = i1 + 1104 | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i12 = HEAP32[i12 + 8 >> 2] | 0;
 if (!i12) return;
 i9 = i12 + -1 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
  i2 = i8 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i8);
   i3 = HEAP32[i2 >> 2] | 0;
  }
  i5 = i3 + 10 | 0;
  i4 = HEAPU16[i5 >> 1] | 0;
  if (!(i4 & 2)) {
   i6 = HEAP32[(HEAP32[i10 >> 2] | 0) + 44 >> 2] | 0;
   i7 = HEAP32[i3 >> 2] | 0;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i12 >>> 0) {
    i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
    i13 = i2 + 20 | 0;
    i13 = HEAP32[i13 >> 2] | 0;
    if (!i13) __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2);
   }
   if (!((i4 & 8 | 0) == 0 | (HEAP16[i3 + 8 >> 1] | 0) == 0)) {
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i8 + 4 >> 2] | 0;
    if (!(HEAP8[i3 + 50 >> 0] | 0)) {
     HEAP32[i6 + (i7 + 12) >> 2] = 0;
     HEAP32[i6 + (i7 + 16) >> 2] = 0;
     HEAP32[i6 + (i7 + 20) >> 2] = 0;
     HEAP32[i6 + (i7 + 36) >> 2] = 0;
     HEAP32[i6 + (i7 + 40) >> 2] = 0;
     HEAP32[i6 + (i7 + 44) >> 2] = 0;
    } else {
     i13 = HEAP32[i3 + 52 >> 2] | 0;
     HEAP32[i6 + (i7 + 12) >> 2] = HEAP32[i13 + 80 >> 2];
     HEAP32[i6 + (i7 + 16) >> 2] = HEAP32[i13 + 84 >> 2];
     HEAP32[i6 + (i7 + 20) >> 2] = HEAP32[i13 + 88 >> 2];
     HEAP32[i6 + (i7 + 36) >> 2] = HEAP32[i13 + 96 >> 2];
     HEAP32[i6 + (i7 + 40) >> 2] = HEAP32[i13 + 100 >> 2];
     HEAP32[i6 + (i7 + 44) >> 2] = HEAP32[i13 + 104 >> 2];
    }
    if (!(HEAP8[i2 + 50 >> 0] | 0)) {
     HEAP32[i6 + (i7 + 24) >> 2] = 0;
     HEAP32[i6 + (i7 + 28) >> 2] = 0;
     HEAP32[i6 + (i7 + 32) >> 2] = 0;
     HEAP32[i6 + (i7 + 48) >> 2] = 0;
     HEAP32[i6 + (i7 + 52) >> 2] = 0;
     HEAP32[i6 + (i7 + 56) >> 2] = 0;
    } else {
     i13 = HEAP32[i2 + 52 >> 2] | 0;
     HEAP32[i6 + (i7 + 24) >> 2] = HEAP32[i13 + 80 >> 2];
     HEAP32[i6 + (i7 + 28) >> 2] = HEAP32[i13 + 84 >> 2];
     HEAP32[i6 + (i7 + 32) >> 2] = HEAP32[i13 + 88 >> 2];
     HEAP32[i6 + (i7 + 48) >> 2] = HEAP32[i13 + 96 >> 2];
     HEAP32[i6 + (i7 + 52) >> 2] = HEAP32[i13 + 100 >> 2];
     HEAP32[i6 + (i7 + 56) >> 2] = HEAP32[i13 + 104 >> 2];
    }
    HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] & 65527;
   }
  } else i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 return;
}

function __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 56 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i1 = i6 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 104 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 112 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 116 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 20 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469391 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15ComputeShaderCB8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 20 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 469391 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15ComputeShaderCB8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11TetrahedronLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 80 | 0) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378847 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN11Tetrahedron8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 80 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 378847 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11Tetrahedron8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN7dtCrowdC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 232 >> 2] = -1;
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 188 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 228 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 1;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 i2 = i1 + 364 | 0;
 HEAP32[i1 + 384 >> 2] = 0;
 HEAP32[i1 + 388 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = i1 + 384;
 i2 = i1 + 392 | 0;
 HEAP32[i1 + 424 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i2 + 28 >> 0] = 0;
 HEAPF32[i1 + 444 >> 2] = Math_fround(2.0);
 HEAP32[i1 + 448 >> 2] = 100;
 i1 = i1 + 452 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 156 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431150 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN14SubstanceInput8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 156 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 431150 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SubstanceInput8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 156 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN11Tetrahedron8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378859 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378870 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378881 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378892 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378903 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378916 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378929 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378942 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378955 | 0, gb + 378962 | 0, i1, 0);
 __ZN10Matrix3x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 8 | 0;
 i2 = i17;
 i13 = i17 + 16 | 0;
 if ((HEAP16[gb + 1450988 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450988 | 0, i1);
  i11 = gb + 1450988 | 0;
 } else i11 = 0;
 i16 = gb + 64016 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i2;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i13 >> 2] = 0;
 i14 = i13 + 12 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i13 + 16 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i9 = i1;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i16;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 28900 | 0, i13, 0);
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i8 = i12 + 12 | 0;
  i9 = i12 + 16 | 0;
  i10 = i12 + 4 | 0;
  i7 = 0;
  do {
   i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   if (!(HEAP32[i2 + 8 >> 2] & 1081344)) {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i9 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i12 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i4;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i2;
    i1 = HEAP32[i14 >> 2] | 0;
   }
   i7 = i7 + 1 | 0;
  } while (i7 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i16);
  HEAP32[i13 >> 2] = 0;
 }
 if (!i11) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i17;
 return;
}

function _sincosf(f2, i7, i8) {
 f2 = Math_fround(f2);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var d1 = 0.0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = i6 >>> 31;
 i6 = i6 & 2147483647;
 L1 : do if (i6 >>> 0 < 1061752795) if (i6 >>> 0 < 964689920) {
  HEAPF32[i7 >> 2] = f2;
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  break;
 } else {
  d1 = +f2;
  HEAPF32[i7 >> 2] = Math_fround(___sindf(d1));
  HEAPF32[i8 >> 2] = Math_fround(___cosdf(d1));
  break;
 } else {
  if (i6 >>> 0 < 1081824210) {
   i4 = (i4 | 0) != 0;
   d1 = +f2;
   if (i6 >>> 0 >= 1075235812) {
    d1 = d1 + (i4 ? 3.141592653589793 : -3.141592653589793);
    HEAPF32[i7 >> 2] = Math_fround(-Math_fround(___sindf(d1)));
    HEAPF32[i8 >> 2] = Math_fround(-Math_fround(___cosdf(d1)));
    break;
   }
   if (i4) {
    d1 = d1 + 1.5707963267948966;
    HEAPF32[i7 >> 2] = Math_fround(-Math_fround(___cosdf(d1)));
   } else {
    d1 = 1.5707963267948966 - d1;
    HEAPF32[i7 >> 2] = Math_fround(___cosdf(d1));
   }
   HEAPF32[i8 >> 2] = Math_fround(___sindf(d1));
   break;
  }
  if (i6 >>> 0 < 1088565718) {
   i4 = (i4 | 0) != 0;
   d1 = +f2;
   if (i6 >>> 0 >= 1085271520) {
    d1 = d1 + (i4 ? 6.283185307179586 : -6.283185307179586);
    HEAPF32[i7 >> 2] = Math_fround(___sindf(d1));
    HEAPF32[i8 >> 2] = Math_fround(___cosdf(d1));
    break;
   }
   if (i4) {
    d1 = d1 + 4.71238898038469;
    HEAPF32[i7 >> 2] = Math_fround(___cosdf(d1));
    f2 = Math_fround(-Math_fround(___sindf(d1)));
   } else {
    d1 = d1 + -4.71238898038469;
    HEAPF32[i7 >> 2] = Math_fround(-Math_fround(___cosdf(d1)));
    f2 = Math_fround(___sindf(d1));
   }
   HEAPF32[i8 >> 2] = f2;
   break;
  }
  if (i6 >>> 0 > 2139095039) {
   f3 = Math_fround(f2 - f2);
   HEAPF32[i8 >> 2] = f3;
   HEAPF32[i7 >> 2] = f3;
   break;
  }
  i6 = ___rem_pio2f(f2, i5) | 0;
  f3 = Math_fround(___sindf(+HEAPF64[i5 >> 3]));
  f2 = Math_fround(___cosdf(+HEAPF64[i5 >> 3]));
  switch (i6 & 3) {
  case 0:
   {
    HEAPF32[i7 >> 2] = f3;
    HEAPF32[i8 >> 2] = f2;
    break L1;
   }
  case 1:
   {
    HEAPF32[i7 >> 2] = f2;
    HEAPF32[i8 >> 2] = Math_fround(-f3);
    break L1;
   }
  case 2:
   {
    HEAPF32[i7 >> 2] = Math_fround(-f3);
    HEAPF32[i8 >> 2] = Math_fround(-f2);
    break L1;
   }
  case 3:
   {
    HEAPF32[i7 >> 2] = Math_fround(-f2);
    HEAPF32[i8 >> 2] = f3;
    break L1;
   }
  default:
   {}
  }
 } while (0);
 STACKTOP = i9;
 return;
}

function __ZN9JSONWrite8TransferI17AnimationCurveTplIfEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite10SetVersionEi(i10, 2);
 __ZN9JSONWrite8TransferI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_PKc17TransferMetaFlags(i10, i11 + 56 | 0, gb + 1034203 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 76 | 0, gb + 1034211 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 80 | 0, gb + 1034225 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 84 | 0, gb + 1034240 | 0, 1);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Ext23DefaultBufferedProfilerC2ERNS_12PxFoundationEPKc(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 HEAP32[i11 >> 2] = gb + 87220 + 8;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = gb + 87160 + 8;
 i1 = i11 + 24 | 0;
 i2 = i11 + 36 | 0;
 i5 = i11 + 44 | 0;
 i6 = i11 + 52 | 0;
 i3 = i11 + 20 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i11 + 20 | 0, 512);
 i4 = (HEAP32[i11 + 40 >> 2] & 2147483640) >>> 0 < 8;
 HEAP32[i11 + 12 >> 2] = 99999789;
 if (i4) __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i11 + 32 | 0, 8);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i11 + 32 >> 2] | 0;
  do {
   i1 = i1 + -1 | 0;
   HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
  } while ((i1 | 0) != 0);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i11 + 60 | 0;
 HEAP32[i4 >> 2] = gb + 87256 + 8;
 HEAP32[i11 + 64 >> 2] = i7;
 HEAP32[i11 + 68 >> 2] = 0;
 HEAP32[i11 + 72 >> 2] = 0;
 HEAP32[i11 + 76 >> 2] = 0;
 HEAP32[i11 + 80 >> 2] = i8;
 i1 = i11 + 84 | 0;
 i2 = i11 + 100 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i3) {
  i8 = 0;
  HEAP32[i2 >> 2] = i8;
  __ZN5physx6shdfnd9MutexImplC2Ev(i8);
  i10 = __ZN5physx20PxProfileZoneManager24createProfileZoneManagerEPNS_12PxFoundationE(i10) | 0;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i1 >> 2] = i11;
  i11 = HEAP32[i10 >> 2] | 0;
  i11 = i11 + 20 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(i11 | 0, i10 | 0, i4 | 0);
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i8 = _PxGetFoundation() | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
 i8 = mftCall_iiiiii(i6 | 0, i7 | 0, i3 | 0, (i8 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i2 >> 2] = i8;
 __ZN5physx6shdfnd9MutexImplC2Ev(i8);
 i10 = __ZN5physx20PxProfileZoneManager24createProfileZoneManagerEPNS_12PxFoundationE(i10) | 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i1 >> 2] = i11;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = i11 + 20 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vii(i11 | 0, i10 | 0, i4 | 0);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426398 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN17BlendShapeChannel8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 426398 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN17BlendShapeChannel8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc10NPhaseCore24releaseShapeInstancePairEPNS0_19ShapeInstancePairLLEjj(i9, i7, i5, i2) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i7 + 48 >> 2] | 0;
 i6 = i7 + 44 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!((i1 & 476 | 0) == 0 | (i1 & 32768 | 0) == 0)) {
  __ZN5physx2Sc19ShapeInstancePairLL19sendLostTouchReportEbj(i7, (i5 & 1 | 0) != 0, i2);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (!(i1 & 32768)) {
  i2 = HEAP32[i7 + 56 >> 2] | 0;
  if (!i2) i1 = i1 & 98304; else i1 = HEAPU16[i2 + 114 >> 1] & 3;
  if (!i1) i3 = 8;
 } else i3 = 8;
 do if ((i3 | 0) == 8) {
  i3 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i7 + 32 >> 2] | 0) | 0;
  i4 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i7 + 36 >> 2] | 0) | 0;
  if (i5 & 4 | 0) {
   i1 = (i3 | 0) == 0;
   i2 = (i4 | 0) == 0;
   if (!(i1 | i2)) {
    if (HEAP32[i6 >> 2] & 262144 | 0) break;
    __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_(HEAP32[i9 >> 2] | 0, i3, i4);
    break;
   }
   if (!i1) __ZN5physx2Sc7BodySim14internalWakeUpEf(i3, Math_fround(.399999976));
   if (!i2) __ZN5physx2Sc7BodySim14internalWakeUpEf(i4, Math_fround(.399999976));
  }
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0);
 i2 = i9 + 736 | 0;
 if (i7 | 0) {
  mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
  i1 = i9 + 1016 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i9 + 1028 | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i7;
  i1 = i9 + 1020 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  if ((i7 | 0) >= ((HEAP32[i9 + 1012 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2);
   HEAP32[i1 >> 2] = 0;
  }
 }
 if (HEAP16[i8 + 16 >> 1] | 0) return;
 if (HEAP32[i8 + 20 >> 2] | 0) __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv(i8);
 i1 = (HEAP32[i8 >> 2] | 0) + 46 | 0;
 HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + -1 << 16 >> 16;
 i1 = (HEAP32[i8 + 4 >> 2] | 0) + 46 | 0;
 HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + -1 << 16 >> 16;
 i1 = i9 + 424 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i9 + 436 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i8;
 i1 = i9 + 428 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i8 + 1;
 if ((i8 | 0) < ((HEAP32[i9 + 420 >> 2] | 0) * 50 | 0)) return;
 __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i9 + 144 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN24CollectBroadphaseTerrain9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE(i9, i1, i10, i11, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(__ZN10CastFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE(i9, i1, i10, i11, i2) | 0)) return 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0) | 0) == 6) {
  i2 = i9 + 20 | 0;
  i3 = i9 + 32 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i9 + 36 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  if (i4 >>> 0 >= i7 >>> 0) return 0;
  i8 = i4 + 1 | 0;
  do if (i8 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i8;
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 + (i4 << 4) >> 2] = i11;
  HEAP32[i9 + (i4 << 4) + 4 >> 2] = i10;
  HEAP32[i9 + (i4 << 4) + 8 >> 2] = -1;
  return 0;
 } else {
  i2 = i9 + 40 | 0;
  i3 = i9 + 52 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i9 + 56 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  if (i4 >>> 0 >= i7 >>> 0) return 0;
  i8 = i4 + 1 | 0;
  do if (i8 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i9 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i8;
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 + (i4 << 4) >> 2] = i11;
  HEAP32[i9 + (i4 << 4) + 4 >> 2] = i10;
  HEAP32[i9 + (i4 << 4) + 8 >> 2] = -1;
  return 0;
 }
 return 0;
}

function __ZN20ArchiveStorageHeader18WriteDirectoryInfoER12FileAccessorRKNS_13DirectoryInfoE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i9 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = _llvm_bswap_i32(((HEAP32[i9 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) / 40 | 0 | 0) | 0;
 i4 = __ZN12FileAccessor5WriteEyPKvPy(i6, 4, 0, i7, i8) | 0;
 i5 = i8;
 if (!(i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0))) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i7 + 4 | 0;
 i5 = i7 + 4 | 0;
 while (1) {
  i2 = i1;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i6, 8, 0, i7, i8) | 0;
  i3 = i8;
  if (!(i2 & ((HEAP32[i3 >> 2] | 0) == 8 & (HEAP32[i3 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 11;
   break;
  }
  i2 = i1 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i7 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i5 >> 2] = i2;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i6, 8, 0, i7, i8) | 0;
  i3 = i8;
  if (!(i2 & ((HEAP32[i3 >> 2] | 0) == 8 & (HEAP32[i3 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 11;
   break;
  }
  HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 16 >> 2] | 0) | 0;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i6, 4, 0, i7, i8) | 0;
  i3 = i8;
  if (!(i2 & ((HEAP32[i3 >> 2] | 0) == 4 & (HEAP32[i3 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 11;
   break;
  }
  i11 = i1 + 20 | 0;
  i2 = i11 + 11 | 0;
  i13 = HEAP8[i2 >> 0] | 0;
  i12 = i13 << 24 >> 24 < 0;
  i3 = i1 + 24 | 0;
  if (!(__ZN12FileAccessor5WriteEyPKvPy(i6, (i12 ? HEAP32[i3 >> 2] | 0 : i13 & 255) + 1 | 0, 0, i12 ? HEAP32[i11 >> 2] | 0 : i11, i7) | 0)) {
   i2 = 9;
   break;
  }
  i12 = i7;
  i13 = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 40 | 0;
  if (!((HEAP32[i12 + 4 >> 2] | 0) == 0 ? (HEAP32[i12 >> 2] | 0) == ((i13 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i13 & 255) + 1 | 0) : 0)) {
   i1 = 0;
   i2 = 11;
   break;
  }
  if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
   i1 = 1;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  i13 = 0;
  STACKTOP = i10;
  return i13 | 0;
 } else if ((i2 | 0) == 11) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801092 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 48 | 0;
 i8 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801108 | 0, i8, i6, 0);
 i7 = i2 + 20 | 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801116 | 0, i8, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801132 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __GLOBAL__sub_I_runtime_terrain_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1170688 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170688 | 0, gb + 487065 | 0);
 HEAP32[gb + 1170692 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170692 | 0, gb + 487080 | 0);
 HEAP32[gb + 1170696 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170696 | 0, gb + 487095 | 0);
 HEAP32[gb + 1170700 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170700 | 0, gb + 487110 | 0);
 HEAP32[gb + 1170704 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170704 | 0, gb + 487131 | 0);
 HEAP32[gb + 1170708 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170708 | 0, gb + 487150 | 0);
 HEAP32[gb + 1170712 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170712 | 0, gb + 487171 | 0);
 HEAP32[gb + 1170716 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170716 | 0, gb + 487196 | 0);
 HEAP32[gb + 1170720 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170720 | 0, gb + 487216 | 0);
 HEAP32[gb + 1170724 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170724 | 0, gb + 487236 | 0);
 HEAP32[gb + 1170728 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170728 | 0, gb + 487256 | 0);
 HEAP32[gb + 1170732 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170732 | 0, gb + 487276 | 0);
 HEAP32[gb + 1170736 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170736 | 0, gb + 487296 | 0);
 HEAP32[gb + 1170740 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170740 | 0, gb + 487316 | 0);
 HEAP32[gb + 1170744 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170744 | 0, gb + 487336 | 0);
 HEAP32[gb + 1170748 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170748 | 0, gb + 487356 | 0);
 HEAP32[gb + 1170752 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1170752 | 0, gb + 936483 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546617 | 0, fb + 3446 | 0, fb + 3447 | 0, 1, 0);
 HEAP32[gb + 1170608 >> 2] = 0;
 i3 = gb + 63400 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1170608 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1170608 + 12 >> 2] = 16;
 i1 = gb + 1170608 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3448 | 0, fb + 3449 | 0, 0, gb + 1170608 | 0);
 return;
}

function __ZNK8Animator12GetClipStatsEv(i38, i3) {
 i38 = i38 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0, i33 = 0, i34 = 0, i35 = 0, i36 = 0, i37 = 0, i39 = 0, i40 = 0;
 i40 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i39 = i40;
 i1 = i38;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP8[i3 + 153 >> 0] | 0)) {
  STACKTOP = i40;
  return;
 }
 if (!(HEAP32[i3 + 168 >> 2] | 0)) {
  STACKTOP = i40;
  return;
 }
 i37 = i3 + 616 | 0;
 if (!(HEAP32[i37 >> 2] | 0)) {
  __ZN8Animator24SetupAnimationClipsCacheEv(i3);
  if (!(HEAP32[i37 >> 2] | 0)) {
   STACKTOP = i40;
   return;
  }
 }
 i2 = i3 + 604 | 0;
 i3 = i39 + 4 | 0;
 i4 = i38 + 4 | 0;
 i5 = i39 + 8 | 0;
 i6 = i38 + 8 | 0;
 i7 = i39 + 12 | 0;
 i8 = i38 + 12 | 0;
 i9 = i39 + 16 | 0;
 i10 = i38 + 16 | 0;
 i11 = i39 + 20 | 0;
 i12 = i38 + 20 | 0;
 i13 = i39 + 24 | 0;
 i14 = i38 + 24 | 0;
 i15 = i39 + 28 | 0;
 i16 = i38 + 28 | 0;
 i17 = i39 + 32 | 0;
 i18 = i38 + 32 | 0;
 i19 = i39 + 36 | 0;
 i20 = i38 + 36 | 0;
 i21 = i39 + 40 | 0;
 i22 = i38 + 40 | 0;
 i23 = i39 + 44 | 0;
 i24 = i38 + 44 | 0;
 i1 = 0;
 i25 = 0;
 i26 = 0;
 i27 = 0;
 i28 = 0;
 i29 = 0;
 i30 = 0;
 i31 = 0;
 i32 = 0;
 i33 = 0;
 i34 = 0;
 i35 = 0;
 i36 = 0;
 do {
  __ZN13AnimationClip8GetStatsER18AnimationClipStats(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i39);
  i25 = i25 + (HEAP32[i39 >> 2] | 0) | 0;
  HEAP32[i38 >> 2] = i25;
  i26 = i26 + (HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i26;
  i27 = i27 + (HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i27;
  i28 = i28 + (HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = i28;
  i29 = i29 + (HEAP32[i9 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = i29;
  i30 = i30 + (HEAP32[i11 >> 2] | 0) | 0;
  HEAP32[i12 >> 2] = i30;
  i31 = i31 + (HEAP32[i13 >> 2] | 0) | 0;
  HEAP32[i14 >> 2] = i31;
  i32 = i32 + (HEAP32[i15 >> 2] | 0) | 0;
  HEAP32[i16 >> 2] = i32;
  i33 = i33 + (HEAP32[i17 >> 2] | 0) | 0;
  HEAP32[i18 >> 2] = i33;
  i34 = i34 + (HEAP32[i19 >> 2] | 0) | 0;
  HEAP32[i20 >> 2] = i34;
  i35 = i35 + (HEAP32[i21 >> 2] | 0) | 0;
  HEAP32[i22 >> 2] = i35;
  i36 = i36 + (HEAP32[i23 >> 2] | 0) | 0;
  HEAP32[i24 >> 2] = i36;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i37 >> 2] | 0) >>> 0);
 STACKTOP = i40;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIyLj8EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 3) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIxLj8EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 3) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayItLj2EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 1) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIsLj2EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 1) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIsEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIjLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 2) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIiLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 2) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIfLj4EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 2) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIdLj8EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + (i10 << 3) | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 451007 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 451020 | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i2, 1); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 451033 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 23; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SplatPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 44 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937573 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN14SplatPrototype8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 44 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937573 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN14SplatPrototype8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 44 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i8 = gb + 1466996 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i10 = gb + 1466996 | 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5Unity12PhysicsQuery18OverlapBoxNonAllocERK8Vector3fS3_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction(i1, i5, i8, i9, i2, i3, i10, i11) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 116 | 0;
 i12 = i15 + 96 | 0;
 i13 = i15 + 80 | 0;
 i6 = i15 + 48 | 0;
 i7 = i15;
 if ((HEAP16[gb + 1452764 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452764 | 0, i4);
  i14 = gb + 1452764 | 0;
 } else i14 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = -1;
 HEAP8[i7 + 20 >> 0] = 0;
 HEAP32[i7 + 24 >> 2] = i1;
 HEAP32[i7 + 28 >> 2] = 128;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 151400 + 8;
 HEAP32[i7 + 36 >> 2] = i2;
 HEAP32[i7 + 40 >> 2] = i3;
 i1 = i7 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 114012 + 8;
 HEAP32[i4 + 4 >> 2] = 1;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i10;
 switch (i11 | 0) {
 case 0:
  {
   HEAP8[i4 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i4 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i4 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP16[i12 + 16 >> 1] = 7;
 HEAP8[i12 + 18 >> 0] = 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 i8 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i13 >> 2] = 3;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i10;
 HEAP32[i13 + 12 >> 2] = i8;
 i8 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i5 + 4 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = HEAP32[i9 + 8 >> 2] | 0;
 i5 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i5;
 HEAP32[i6 + 16 >> 2] = i8;
 HEAP32[i6 + 20 >> 2] = i10;
 HEAP32[i6 + 24 >> 2] = i11;
 i11 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_iiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 356 >> 2] | 0, i11 | 0, i13 | 0, i6 | 0, i7 | 0, i12 | 0, i4 | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i14) {
  STACKTOP = i15;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i14);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN24CollectBroadphaseTerrainC2EPN5physx12PxOverlapHitEij23QueryTriggerInteraction(i6, i12, i13, i1, i2) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 8 | 0;
 i3 = i14;
 HEAP32[i6 >> 2] = gb + 114012 + 8;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = i1;
 switch (i2 | 0) {
 case 0:
  {
   HEAP8[i6 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i6 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i6 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i6 >> 2] = gb + 114036 + 8;
 i7 = i6 + 20 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i6 + 36 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i6 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i3);
 i5 = i11;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 52 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = i6 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i6 = i11;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = HEAP32[i9 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i13 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i13;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i13 << 4, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 << 4, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i7 >> 2] = i11;
  break;
 } while (0);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  i13 = i13 << 4;
  i13 = i13 >> 4;
  i13 = i13 | -2147483648;
  HEAP32[i5 >> 2] = i13;
  HEAP32[i3 >> 2] = i12;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i13 = i13 << 4;
 i13 = i13 >> 4;
 i13 = i13 | -2147483648;
 HEAP32[i5 >> 2] = i13;
 HEAP32[i3 >> 2] = i12;
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN15AudioReverbZone13AwakeFromLoadE17AwakeFromLoadMode(i27, i1) {
 i27 = i27 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i27, i1);
 i1 = HEAP32[i27 + 56 >> 2] | 0;
 if ((i1 | 0) < 27) {
  i2 = i27 + 60 | 0;
  i3 = i27 + 64 | 0;
  i4 = i27 + 72 | 0;
  i5 = i27 + 76 | 0;
  i6 = i27 + 80 | 0;
  i7 = i27 + 84 | 0;
  i8 = i27 + 88 | 0;
  i9 = i27 + 92 | 0;
  i10 = i27 + 96 | 0;
  i11 = i27 + 108 | 0;
  i12 = i27 + 112 | 0;
  i13 = i27 + 68 | 0;
  i14 = i27 + 100 | 0;
  i15 = gb + 171848 + (i1 * 80 | 0) + 24 | 0;
  i16 = gb + 171848 + (i1 * 80 | 0) + 28 | 0;
  i17 = gb + 171848 + (i1 * 80 | 0) + 36 | 0;
  i18 = gb + 171848 + (i1 * 80 | 0) + 40 | 0;
  i19 = gb + 171848 + (i1 * 80 | 0) + 44 | 0;
  i20 = gb + 171848 + (i1 * 80 | 0) + 48 | 0;
  i21 = gb + 171848 + (i1 * 80 | 0) + 60 | 0;
  i22 = gb + 171848 + (i1 * 80 | 0) + 64 | 0;
  i23 = gb + 171848 + (i1 * 80 | 0) + 68 | 0;
  i24 = gb + 171848 + (i1 * 80 | 0) + 72 | 0;
  i25 = gb + 171848 + (i1 * 80 | 0) + 12 | 0;
  i26 = gb + 171848 + (i1 * 80 | 0) + 16 | 0;
  i1 = gb + 171848 + (i1 * 80 | 0) + 20 | 0;
 } else {
  i25 = i27 + 60 | 0;
  i26 = i27 + 64 | 0;
  i15 = i27 + 72 | 0;
  i16 = i27 + 76 | 0;
  i17 = i27 + 80 | 0;
  i18 = i27 + 84 | 0;
  i19 = i27 + 88 | 0;
  i20 = i27 + 92 | 0;
  i21 = i27 + 96 | 0;
  i23 = i27 + 108 | 0;
  i24 = i27 + 112 | 0;
  i1 = i27 + 68 | 0;
  i22 = i27 + 100 | 0;
  i2 = i25;
  i3 = i26;
  i4 = i15;
  i5 = i16;
  i6 = i17;
  i7 = i18;
  i8 = i19;
  i9 = i20;
  i10 = i21;
  i11 = i23;
  i12 = i24;
  i13 = i1;
  i14 = i22;
 }
 i28 = HEAP32[i26 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i26 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i23 >> 2] | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i3 >> 2] = i28;
 HEAP32[i4 >> 2] = i15;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i6 >> 2] = i17;
 HEAP32[i7 >> 2] = i18;
 HEAP32[i8 >> 2] = i19;
 HEAP32[i9 >> 2] = i20;
 HEAP32[i10 >> 2] = i21;
 HEAPF32[i27 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i11 >> 2] = i23;
 HEAP32[i12 >> 2] = i24;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i14 >> 2] = i26;
 __ZN15AudioReverbZone13SetFMODValuesEv(i27);
 return;
}

function __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 872 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 872 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 872 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 872 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN9ShaderLab14SerializedPassaSERKS0_(i2, i3) | 0;
   i3 = i3 + 872 | 0;
   i2 = i2 + 872 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -872 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN9ShaderLab14SerializedPassD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i1);
   i1 = i1 + 872 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 872 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -872 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN9ShaderLab14SerializedPassD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 4925421) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 872 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 2462710 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 4925421;
 if (i1 >>> 0 > 4925421) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 872 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 872 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i1);
  i1 = i1 + 872 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 872 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN9DepthPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceDatab(i11, i1, i12, i13, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f14 = f0, f15 = f0;
 i4 = i11 + 40 | 0;
 i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i10 = __Z18GetQualitySettingsv() | 0;
 HEAP32[i11 + 104 >> 2] = HEAP32[(HEAP32[i10 + 28 >> 2] | 0) + ((HEAP32[i10 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2];
 if ((HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0) == 0 | i3) i1 = 0; else i1 = HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] ^ 1;
 HEAP8[i11 + 108 >> 0] = i1;
 HEAP8[i11 + 109 >> 0] = 1;
 i10 = HEAP32[i12 + 32804 >> 2] | 0;
 i1 = i11 + 12 | 0;
 i2 = i11 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i10 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10 * 24 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 * 24 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i11 + 24 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = i8;
  break;
 } while (0);
 if (!i10) return;
 i4 = i11 + 48 | 0;
 i5 = i11 + 64 | 0;
 i6 = i11 + 80 | 0;
 i7 = i11 + 96 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i12 >> 2] | 0;
  i8 = i1 + (i3 * 360 | 0) | 0;
  i2 = i1 + (i3 * 360 | 0) + 232 | 0;
  if (((HEAPU16[i2 >> 1] | HEAPU8[i2 + 2 >> 0] << 16) & 192 | 0) != 192) {
   f15 = Math_fround(HEAPF32[i1 + (i3 * 360 | 0) + 128 >> 2]);
   f14 = Math_fround(HEAPF32[i1 + (i3 * 360 | 0) + 132 >> 2]);
   f9 = Math_fround(HEAPF32[i1 + (i3 * 360 | 0) + 136 >> 2]);
   f15 = Math_fround(f15 * Math_fround(HEAPF32[i4 >> 2]));
   f14 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i5 >> 2])));
   f9 = Math_fround(f14 + Math_fround(f9 * Math_fround(HEAPF32[i6 >> 2])));
   f9 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f9);
   i2 = HEAP32[i1 + (i3 * 360 | 0) + 244 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i1 = 0;
    do {
     __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i11, i3, i8, i1, f9, i13);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i10 | 0));
 return;
}

function __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 16 | 0;
 i2 = i8;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 i7 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i1 >> 2] = 1;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 }
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 i7 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6 + 4 | 0, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i1 >> 2] = 1;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 }
 i1 = i6 + 8 | 0;
 i7 = i3 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  STACKTOP = i8;
  return;
 }
}

function __ZN20DeviceBlendStateGLESC2ERK13GfxBlendState(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i1 = i13;
 i2 = i14;
 i3 = i1 + 68 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i13 + 180 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 >> 0] = HEAP32[i14 + 64 >> 2] & 1;
 i1 = 0;
 do {
  i2 = i13 + 68 + (i1 * 14 | 0) | 0;
  HEAP16[i2 >> 1] = __ZNK13TranslateGLES11BlendFactorE9BlendMode(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i14 + (i1 << 3) + 1 >> 0] | 0) | 0;
  i4 = i13 + 68 + (i1 * 14 | 0) + 2 | 0;
  HEAP16[i4 >> 1] = __ZNK13TranslateGLES11BlendFactorE9BlendMode(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i14 + (i1 << 3) + 2 >> 0] | 0) | 0;
  i5 = i13 + 68 + (i1 * 14 | 0) + 4 | 0;
  HEAP16[i5 >> 1] = __ZNK13TranslateGLES11BlendFactorE9BlendMode(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i14 + (i1 << 3) + 3 >> 0] | 0) | 0;
  i6 = i13 + 68 + (i1 * 14 | 0) + 6 | 0;
  HEAP16[i6 >> 1] = __ZNK13TranslateGLES11BlendFactorE9BlendMode(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i14 + (i1 << 3) + 4 >> 0] | 0) | 0;
  i11 = i14 + (i1 << 3) + 5 | 0;
  i7 = i13 + 68 + (i1 * 14 | 0) + 8 | 0;
  HEAP16[i7 >> 1] = __ZNK13TranslateGLES13BlendEquationE7BlendOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i11 >> 0] | 0) | 0;
  i8 = i14 + (i1 << 3) + 6 | 0;
  i9 = (__ZNK13TranslateGLES13BlendEquationE7BlendOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i8 >> 0] | 0) | 0) & 65535;
  HEAP16[i13 + 68 + (i1 * 14 | 0) + 10 >> 1] = i9;
  i10 = i13 + 68 + (i1 * 14 | 0) + 12 | 0;
  HEAP16[i10 >> 1] = 0;
  i11 = HEAP8[i11 >> 0] | 0;
  if ((i11 + -3 & 255) < 2) i15 = 5; else if (((HEAP8[i8 >> 0] | 0) + -3 & 255) < 2) i15 = 5; else i12 = 2;
  if ((i15 | 0) == 5) {
   i15 = 0;
   HEAP16[i10 >> 1] = 1;
   i12 = 3;
  }
  if ((i11 + -21 & 255) < 15) i15 = 8; else if (((HEAP8[i8 >> 0] | 0) + -21 & 255) < 15) i15 = 8;
  if ((i15 | 0) == 8) {
   i15 = 0;
   HEAP16[i10 >> 1] = i12;
  }
  if ((HEAP16[i2 >> 1] | 0) == 1) if (!(HEAP16[i4 >> 1] | 0)) if ((HEAP16[i5 >> 1] | 0) == 1) if (!(HEAP16[i6 >> 1] | 0)) {
   if (!((HEAP16[i7 >> 1] | 0) == -32762 & i9 << 16 >> 16 == -32762)) i15 = 14;
  } else i15 = 14; else i15 = 14; else i15 = 14; else i15 = 14;
  if ((i15 | 0) == 14) {
   i15 = 0;
   HEAP8[i3 >> 0] = 1;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 return;
}

function __ZN5Unity17ConfigurableJoint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(360, i1, 16, gb + 1048932 | 0, 0, gb + 779710 | 0, 18) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i3 = i4 + 40 | 0;
 i2 = i4 + 52 | 0;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 111796 + 8;
 i1 = i4 + 212 | 0;
 i2 = i4 + 120 | 0;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 216 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 224 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 228 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 236 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 248 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 256 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 260 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 264 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 268 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 272 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13AvatarBuilder17GetRootMotionNodeERK8UnityStrRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i9 = i10;
 i1 = HEAP32[i2 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i11 = i2 << 24 >> 24 < 0;
 i4 = i11 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i11 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i2 = HEAP32[i9 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i9 + 11 >> 0] = i3;
  if (!i3) i2 = i9; else {
   i2 = i9;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i11 = i3 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i3;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i2 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i2 + i3 >> 0] = 0;
 i5 = HEAP8[i9 + 11 >> 0] | 0;
 L10 : do if ((i1 | 0) != (i6 | 0)) {
  i3 = i5 & 255;
  if (i5 << 24 >> 24 >= 0) while (1) {
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i11 << 24 >> 24 < 0;
   if ((i3 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255) | 0)) if (!(_strncmp(i9, i2 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0)) break L10;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break L10;
   }
  }
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i11 = HEAP8[i1 + 11 >> 0] | 0;
   i2 = i11 << 24 >> 24 < 0;
   if ((i3 | 0) == ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i11 & 255) | 0)) if (!(_strncmp(i4, i2 ? HEAP32[i1 >> 2] | 0 : i1, i3) | 0)) break L10;
   i1 = i1 + 36 | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i1 = i6;
    break;
   }
  }
 } while (0);
 if (i5 << 24 >> 24 < 0) {
  i11 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[i1 + 32 >> 2] | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN10MemoryFile21CreateFileSystemEntryE10MemLabelId14FilePermissionPvjb(i5, i6, i4, i1, i2, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i9 = i10;
 i11 = i10 + 8 | 0;
 i7 = __ZnwjRK10MemLabelIdiPKci(40, i6, 16, gb + 492276 | 0, 129) | 0;
 i14 = i6;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb(i7, i8, i1, i2, i3);
 i3 = __ZnwjRK10MemLabelIdiPKci(32, i6, 16, gb + 492276 | 0, 130) | 0;
 i11 = i6;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = gb + 71428 + 8;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i4;
 i1 = i3 + 12 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = i12;
 HEAP32[i4 + 4 >> 2] = i11;
 i4 = i3 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 if (!i7) {
  i14 = __ZnwjRK10MemLabelIdiPKci(48, i1, 16, gb + 492276 | 0, 15) | 0;
  i12 = i1;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i14, i8, 8192);
  HEAP32[i2 >> 2] = i14;
  i1 = 4;
 } else {
  i1 = i7 + 4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 }
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!(HEAP32[i1 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i6);
 }
 i11 = i6;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i14 = i9;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 4 >> 2] = i12;
 i14 = i8 + 1040 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 i14 = __ZnwjRK10MemLabelIdiPKci(20, i9, 16, gb + 586372 | 0, 37) | 0;
 i12 = i9;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i14 >> 2] = gb + 70720 + 8;
 HEAP32[i14 + 4 >> 2] = i3;
 i13 = i14 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP8[i14 + 16 >> 0] = 1;
 HEAP32[i8 + 1044 >> 2] = i14;
 __ZN15FileSystemEntryC2ERK13FileEntryData(i5, i8);
 __ZN13FileEntryDataD2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf(f1, f3, f4, i2, f9, i5, i10) {
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 f9 = Math_fround(f9);
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f11 = f0, f12 = f0, f13 = f0;
 f11 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f1);
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f3));
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f4));
 i7 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * f1);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f3));
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * f4));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = f11 > f8;
 f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6 ? i7 : i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f11 = Math_fround(Math_fround(HEAPF32[i5 + 36 >> 2]) * f1);
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i5 + 40 >> 2]) * f3));
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i5 + 44 >> 2]) * f4));
 f13 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * f1);
 f13 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * f3));
 f13 = Math_fround(Math_abs(Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * f4))));
 f13 = Math_fround(f13 * Math_fround(HEAPF32[i5 + 48 >> 2]));
 f12 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) * f1);
 f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i5 + 16 >> 2]) * f3));
 f12 = Math_fround(Math_abs(Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i5 + 20 >> 2]) * f4))));
 f12 = Math_fround(f13 + Math_fround(f12 * Math_fround(HEAPF32[i5 + 52 >> 2])));
 f1 = Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) * f1);
 f3 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i5 + 28 >> 2]) * f3));
 f4 = Math_fround(Math_abs(Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i5 + 32 >> 2]) * f4))));
 f4 = Math_fround(f12 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 56 >> 2])));
 f3 = Math_fround(f11 - f4);
 f4 = Math_fround(f11 + f4);
 if (f8 < f3) {
  i10 = 0;
  return i10 | 0;
 }
 f1 = Math_fround((HEAP32[tempDoublePtr >> 2] = i6 ? i2 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) - f9);
 if (f4 < f1) {
  i10 = 0;
  return i10 | 0;
 }
 f12 = Math_fround(f8 - f3);
 f13 = Math_fround(f4 - f1);
 HEAPF32[i10 >> 2] = f12 < f13 ? f12 : f13;
 i10 = 1;
 return i10 | 0;
}

function __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 52 | 0) + 1 | 0;
 if (i3 >>> 0 > 82595524) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 52 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 41297762 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 82595524;
 i1 = (i2 - i1 | 0) / 52 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 52 | 0) | 0;
 i2 = i4 + (i1 * 52 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 52 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i4 + (i1 * 52 | 0) + 4 | 0, i6 + 4 | 0);
 i5 = i4 + (i1 * 52 | 0) + 24 | 0;
 i6 = i6 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i6 = i2 + 52 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i3;
  i4 = i5;
  i1 = i5;
 } else {
  do {
   i11 = i1;
   i1 = i1 + -52 | 0;
   HEAP32[i2 + -52 >> 2] = HEAP32[i1 >> 2];
   __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i2 + -48 | 0, i11 + -48 | 0);
   i4 = i2 + -28 | 0;
   i11 = i11 + -28 | 0;
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   i2 = i3 + -52 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i2 = i3;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -48 | 0;
  if ((HEAP32[i1 + -32 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -44 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -52 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) return;
 __ZdlPv(i4);
 return;
}

function __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 56 | 0) + 1 | 0;
 if (i4 >>> 0 > 76695844) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 56 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 38347922 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 76695844;
 i5 = (i1 - i2 | 0) / 56 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 56 | 0) | 0;
 i7 = i6 + (i5 * 56 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 56 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 44 >> 2] = HEAP32[i8 + 44 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 48 >> 2] = HEAP32[i8 + 48 >> 2];
 HEAP32[i6 + (i5 * 56 | 0) + 52 >> 2] = HEAP32[i8 + 52 >> 2];
 i4 = i7 + 56 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i7 = i1 + -56 | 0;
   i8 = i3;
   i3 = i3 + -56 | 0;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i7 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i7 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i8 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i8 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i8 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i8 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i8 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i8 + -4 >> 2];
   i1 = i2 + -56 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK8Animator13GetHumanScaleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  f10 = Math_fround(1.0);
  STACKTOP = i9;
  return Math_fround(f10);
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i11 + 28 >> 2] | 0;
   i4 = HEAP32[i11 + 32 >> 2] | 0;
   i1 = i11;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  f10 = Math_fround(1.0);
  STACKTOP = i9;
  return Math_fround(f10);
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 f10 = Math_fround(__ZNK6Avatar13GetHumanScaleEv(i1));
 STACKTOP = i9;
 return Math_fround(f10);
}

function __ZN19CharacterController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 88 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __Z32CustomEventData_CUSTOM_AddStringP12Il2CppObjectP12Il2CppStringS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i9 = i13 + 56 | 0;
 i4 = i13 + 48 | 0;
 i6 = i13 + 32 | 0;
 i10 = i13 + 36 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 __ZN11ICallStringC2EP12Il2CppString(i6, i3);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i5);
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i7) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i5);
 __ZNK11ICallString6ToUTF8Ev(i10, i4);
 i5 = (HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10;
 __ZNK11ICallString6ToUTF8Ev(i12, i6);
 i4 = HEAP8[i12 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
 i4 = i1 ? HEAP32[i12 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i8 = 7;
 } else if (i4 >>> 0 < 11) {
  i2 = i11 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i11; else {
   i1 = i11;
   i8 = 9;
  }
 } else i8 = 7;
 if ((i8 | 0) == 7) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i4;
  i2 = i11 + 11 | 0;
  i8 = 9;
 }
 if ((i8 | 0) == 9) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcRK8UnityStr(i7, i5, i11) | 0) & 1;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i13;
  return i1 | 0;
 }
 i8 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEbT0_S7_T_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 switch (i9 - i8 >> 3 | 0) {
 case 2:
  {
   i1 = i9 + -8 | 0;
   if ((_strcmp(HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0) >= 0) {
    i9 = 1;
    return i9 | 0;
   }
   i7 = i8;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i4 = i1;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = i8;
   HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 + 4 >> 2] = i5;
   i9 = i1;
   HEAP32[i9 >> 2] = i6;
   HEAP32[i9 + 4 >> 2] = i7;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i8, i8 + 8 | 0, i9 + -8 | 0) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i9 + -8 | 0) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i8 + 24 | 0, i9 + -8 | 0) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i3 = i8 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i8, i8 + 8 | 0, i3) | 0;
   i1 = i8 + 24 | 0;
   L3 : do if ((i1 | 0) == (i9 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     i5 = HEAP32[i1 >> 2] | 0;
     i6 = i5;
     if ((_strcmp(i5, HEAP32[i3 >> 2] | 0) | 0) < 0) {
      i7 = HEAP32[i1 + 4 >> 2] | 0;
      i4 = i1;
      while (1) {
       i11 = i3;
       i10 = HEAP32[i11 + 4 >> 2] | 0;
       HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
       HEAP32[i4 + 4 >> 2] = i10;
       if ((i3 | 0) == (i8 | 0)) {
        i3 = i8;
        break;
       }
       i4 = i3 + -8 | 0;
       if ((_strcmp(i5, HEAP32[i4 >> 2] | 0) | 0) < 0) {
        i11 = i3;
        i3 = i4;
        i4 = i11;
       } else break;
      }
      HEAP32[i3 >> 2] = i6;
      HEAP32[i3 + 4 >> 2] = i7;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 8 | 0) == (i9 | 0);
       break L3;
      }
     }
     i3 = i1 + 8 | 0;
     if ((i3 | 0) == (i9 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i11 = i1;
      i1 = i3;
      i3 = i11;
     }
    }
   } while (0);
   i11 = i1 | i2;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034905 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034905 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i15, i8) {
 i15 = i15 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = i15 + 4 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i3 = ((i1 - i2 | 0) / 112 | 0) + 1 | 0;
 if (i3 >>> 0 > 38347922) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i15);
  i1 = HEAP32[i16 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
 }
 i13 = i2;
 i4 = i1;
 i14 = i15 + 8 | 0;
 i12 = ((HEAP32[i14 >> 2] | 0) - i2 | 0) / 112 | 0;
 i5 = i12 << 1;
 i3 = i12 >>> 0 < 19173961 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 38347922;
 i5 = (i1 - i2 | 0) / 112 | 0;
 if (!i3) i6 = 0; else i6 = __Znwj(i3 * 112 | 0) | 0;
 i7 = i6 + (i5 * 112 | 0) | 0;
 i2 = i7;
 i12 = i6 + (i3 * 112 | 0) | 0;
 i9 = i7;
 i10 = i8;
 i11 = i9 + 76 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  i9 = i9 + 4 | 0;
  i10 = i10 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i6 + (i5 * 112 | 0) + 76 >> 2] = HEAP32[i8 + 76 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 80 >> 2] = HEAP32[i8 + 80 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 84 >> 2] = HEAP32[i8 + 84 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 88 >> 2] = HEAP32[i8 + 88 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 92 >> 2] = HEAP32[i8 + 92 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 96 >> 2] = HEAP32[i8 + 96 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 100 >> 2] = HEAP32[i8 + 100 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 104 >> 2] = HEAP32[i8 + 104 >> 2];
 HEAP32[i6 + (i5 * 112 | 0) + 108 >> 2] = HEAP32[i8 + 108 >> 2];
 i5 = i7 + 112 | 0;
 if ((i4 | 0) != (i13 | 0)) {
  i3 = i7;
  do {
   i1 = i4;
   i4 = i4 + -112 | 0;
   i9 = i3 + -112 | 0;
   i10 = i4;
   i11 = i9 + 76 | 0;
   do {
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i9 = i9 + 4 | 0;
    i10 = i10 + 4 | 0;
   } while ((i9 | 0) < (i11 | 0));
   HEAP32[i3 + -36 >> 2] = HEAP32[i1 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i1 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i1 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i1 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i1 + -20 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i1 + -16 >> 2];
   HEAP32[i3 + -12 >> 2] = HEAP32[i1 + -12 >> 2];
   HEAP32[i3 + -8 >> 2] = HEAP32[i1 + -8 >> 2];
   HEAP32[i3 + -4 >> 2] = HEAP32[i1 + -4 >> 2];
   i3 = i2 + -112 | 0;
   i2 = i3;
  } while ((i4 | 0) != (i13 | 0));
  i1 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i15 >> 2] = i2;
 HEAP32[i16 >> 2] = i5;
 HEAP32[i14 >> 2] = i12;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIhLj1EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + i10 | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI13dynamic_arrayIaLj1EEEEvRT_PKc17TransferMetaFlags(i11, i10, i13, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i11 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i11 + 36 | 0;
 i12 = i11 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i11 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i3 = i11 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i1 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i3 >> 2] = i14;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 4;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i2 = i1 + i10 | 0;
 if (i10 | 0) do {
  __ZN9JSONWrite8TransferIaEEvRT_PKc17TransferMetaFlags(i11, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i3 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i11, i4, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i8, i7, i3) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i6 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i7 | 0, 0) | 0;
 if ((i6 | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i2 + (i6 * 24 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (i3) {
  i3 = i2 + (i6 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63416 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) i5 = 8;
 } else i5 = 8;
 if ((i5 | 0) == 8) {
  __ZN14SerializedFile7ReleaseEv(i1);
  HEAP32[i4 >> 2] = 0;
 }
 i2 = HEAP32[i8 + 24 >> 2] | 0;
 i1 = HEAP32[i2 + (i6 * 20 | 0) + 4 >> 2] | 0;
 i2 = i2 + (i6 * 20 | 0) + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + (i6 * 20 | 0) + 4 >> 2] | 0;
 i1 = i1 + (i6 * 20 | 0) + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3);
 i4 = i8 + 96 | 0;
 i3 = __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE4findIS6_EENS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEERKT_(i4, i7) | 0;
 if ((i3 | 0) != (i8 + 100 | 0)) {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i3;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
  i7 = i8 + 108 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 100 >> 2] | 0, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
  i8 = HEAP32[i8 + 104 >> 2] | 0;
  HEAP32[i9 >> 2] = 37;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
 }
 STACKTOP = i10;
 return;
}

function __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb(i1, i2, i5, i6, i7, i8, i9, i10, f11, f12, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb(i1, i2, i5, i6, i7, i8, i10, f11, f12, i3, i4);
 i18 = (HEAP32[i5 + 480 >> 2] | 0) + (i6 << 2) | 0;
 i20 = HEAP32[i18 >> 2] | 0;
 i13 = i18 + 4 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 i5 = i18 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i10 = i18 + 12 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i16 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = HEAP32[i9 + 8 >> 2] | 0;
 i23 = HEAP32[i9 + 12 >> 2] | 0;
 i21 = (Math_imul(i16 & 255, i20 & 255) | 0) + 128 | 0;
 i22 = (Math_imul(i16 >>> 8 & 255, i20 >>> 8 & 255) | 0) + 128 | 0;
 i19 = (Math_imul(i16 >>> 16 & 255, i20 >>> 16 & 255) | 0) + 128 | 0;
 i20 = (Math_imul(i16 >>> 24, i20 >>> 24) | 0) + 128 | 0;
 i16 = (Math_imul(i2 & 255, i15 & 255) | 0) + 128 | 0;
 i17 = (Math_imul(i2 >>> 8 & 255, i15 >>> 8 & 255) | 0) + 128 | 0;
 i14 = (Math_imul(i2 >>> 16 & 255, i15 >>> 16 & 255) | 0) + 128 | 0;
 i15 = (Math_imul(i2 >>> 24, i15 >>> 24) | 0) + 128 | 0;
 i2 = (Math_imul(i7 & 255, i3 & 255) | 0) + 128 | 0;
 i1 = (Math_imul(i7 >>> 8 & 255, i3 >>> 8 & 255) | 0) + 128 | 0;
 i4 = (Math_imul(i7 >>> 16 & 255, i3 >>> 16 & 255) | 0) + 128 | 0;
 i3 = (Math_imul(i7 >>> 24, i3 >>> 24) | 0) + 128 | 0;
 i7 = (Math_imul(i23 & 255, i8 & 255) | 0) + 128 | 0;
 i6 = (Math_imul(i23 >>> 8 & 255, i8 >>> 8 & 255) | 0) + 128 | 0;
 i9 = (Math_imul(i23 >>> 16 & 255, i8 >>> 16 & 255) | 0) + 128 | 0;
 i8 = (Math_imul(i23 >>> 24, i8 >>> 24) | 0) + 128 | 0;
 HEAP32[i18 >> 2] = (i22 >>> 8) + i22 & 261888 | ((i21 >>> 8) + i21 | 0) >>> 8 | ((i20 >>> 8) + i20 | 0) >>> 8 << 24 | ((i19 >>> 8) + i19 | 0) >>> 8 << 16;
 HEAP32[i13 >> 2] = (i17 >>> 8) + i17 & 261888 | ((i16 >>> 8) + i16 | 0) >>> 8 | ((i15 >>> 8) + i15 | 0) >>> 8 << 24 | ((i14 >>> 8) + i14 | 0) >>> 8 << 16;
 HEAP32[i5 >> 2] = (i1 >>> 8) + i1 & 261888 | ((i2 >>> 8) + i2 | 0) >>> 8 | ((i3 >>> 8) + i3 | 0) >>> 8 << 24 | ((i4 >>> 8) + i4 | 0) >>> 8 << 16;
 HEAP32[i10 >> 2] = (i6 >>> 8) + i6 & 261888 | ((i7 >>> 8) + i7 | 0) >>> 8 | ((i8 >>> 8) + i8 | 0) >>> 8 << 24 | ((i9 >>> 8) + i9 | 0) >>> 8 << 16;
 return;
}

function __ZN26AnimatorOverrideController8GetAssetEb(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 i7 = i1 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i11 + 28 >> 2] | 0;
   i4 = HEAP32[i11 + 32 >> 2] | 0;
   i1 = i11;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i9 = 9;
 }
 if ((i9 | 0) == 7) i9 = 9;
 do if ((i9 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i9 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 18;
  }
 }
 if ((i9 | 0) == 16) i9 = 18;
 if ((i9 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i11 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i8 | 0) | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN15SerializeTraitsIN7mecanim5human6HandleEE8TransferI14SafeBinaryReadEEvRS2_RT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906345 | 0, gb + 905989 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 40 | 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 906446 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 910040 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 23; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 28 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 590097 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN8LODGroup3LOD8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 28 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 590097 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8LODGroup3LOD8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 28 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI12TreeInstanceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 40 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937620 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN12TreeInstance8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 40 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 937620 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN12TreeInstance8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 6) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034429 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 64 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 1034429 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14DetailDatabase29ComputeVertexAndTriangleCountER11DetailPatch16DetailRenderModefPiS3_(i1, i2, i22, f23, i24, i25) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 f23 = Math_fround(f23);
 i24 = i24 | 0;
 i25 = i25 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i26 = 0, i27 = 0, i28 = 0, f29 = f0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i24 >> 2] = 0;
 i26 = HEAP32[i1 + 40 >> 2] | 0;
 i27 = i2 + 28 | 0;
 i28 = i2 + 32 | 0;
 i4 = HEAP32[i28 >> 2] | 0;
 i3 = HEAP32[i27 >> 2] | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i20 = i1 + 16 | 0;
 i21 = (i26 | 0) > 0;
 i19 = i2 + 40 | 0;
 i18 = 0;
 i1 = 0;
 do {
  i16 = HEAPU8[i3 + i18 >> 0] | 0;
  i17 = HEAP32[i20 >> 2] | 0;
  if ((HEAP32[i17 + (i16 * 136 | 0) + 68 >> 2] | 0) == (i22 | 0)) {
   i14 = i17 + (i16 * 136 | 0) + 76 | 0;
   i11 = HEAP32[i14 >> 2] | 0;
   i13 = i17 + (i16 * 136 | 0) + 80 | 0;
   i12 = HEAP32[i13 >> 2] | 0;
   i2 = i12;
   i15 = i11;
   if ((i11 | 0) != (i12 | 0)) {
    if (i21) {
     i9 = Math_imul(i18, i26) | 0;
     i10 = HEAP32[i19 >> 2] | 0;
     i7 = 0;
     i6 = 0;
     do {
      i12 = Math_imul(i7 + i9 | 0, i26) | 0;
      i11 = i7 & 7;
      i8 = 0;
      do {
       i5 = HEAP8[i10 + (i12 + i8) >> 0] | 0;
       if (i5 << 24 >> 24) {
        f29 = Math_fround(Math_fround(i5 & 255) * f23);
        i6 = ~~Math_fround(f29 + Math_fround(Math_fround(Math_fround(HEAPF32[gb + 184836 + ((i8 << 3 & 56 | i11) << 2) >> 2]) + Math_fround(-.5)) * Math_fround(.015625))) + i6 | 0;
       }
       i8 = i8 + 1 | 0;
      } while ((i8 | 0) != (i26 | 0));
      i7 = i7 + 1 | 0;
     } while ((i7 | 0) != (i26 | 0));
    } else i6 = 0;
    i5 = ((65e3 - i1 | 0) >>> 0) / (((i2 - i15 | 0) / 12 | 0) >>> 0) | 0;
    if ((i6 | 0) > (i5 | 0)) {
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 934809 | 0, 0, gb + 932993 | 0, 1066, 512, 0, 0, 0);
     i4 = HEAP32[i28 >> 2] | 0;
     i3 = HEAP32[i27 >> 2] | 0;
     i2 = HEAP32[i13 >> 2] | 0;
     i1 = HEAP32[i14 >> 2] | 0;
    } else i1 = i15;
    i15 = (i6 | 0) < (i5 | 0) ? i6 : i5;
    i17 = Math_imul((HEAP32[i17 + (i16 * 136 | 0) + 128 >> 2] | 0) - (HEAP32[i17 + (i16 * 136 | 0) + 124 >> 2] | 0) >> 1, i15) | 0;
    HEAP32[i25 >> 2] = i17 + (HEAP32[i25 >> 2] | 0);
    i1 = Math_imul((i2 - i1 | 0) / 12 | 0, i15) | 0;
    i1 = i1 + (HEAP32[i24 >> 2] | 0) | 0;
    HEAP32[i24 >> 2] = i1;
   }
  }
  i18 = i18 + 1 | 0;
 } while (i18 >>> 0 < (i4 - i3 | 0) >>> 0);
 return;
}

function __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 448 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 208 | 0;
 i9 = i13 + 128 | 0;
 i10 = i13 + 48 | 0;
 i11 = i13;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i12 = i1 + 8 | 0;
 if (!i5) i8 = 0; else {
  i4 = i1 + 72 | 0;
  i3 = 0;
  i1 = 0;
  do {
   if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i12, i3) | 0)) {
    i14 = __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj(i4, i3) | 0;
    i8 = HEAP32[i14 + 148 >> 2] | 0;
    __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i14);
    i14 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i12, i8) | 0;
    HEAP32[i6 + (i1 * 12 | 0) >> 2] = HEAP32[i14 >> 2];
    HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i14 + 4 >> 2];
    HEAP32[i6 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i14 + 8 >> 2];
    HEAP32[i9 + (i1 << 2) >> 2] = i8;
    i1 = i1 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i8 = i1;
 }
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx28PxVehicleComputeSprungMassesEjPKNS_6PxVec3ERS1_fjPf(i8, i6, i11, f2, 1, i10);
 i3 = (i8 | 0) == 0;
 if (i3) {
  STACKTOP = i13;
  return;
 } else i1 = 0;
 do {
  if (Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]) < Math_fround(0.0)) {
   i7 = 11;
   break;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i8 >>> 0);
 if ((i7 | 0) == 11) {
  f2 = Math_fround(f2 / Math_fround(i8 >>> 0));
  i1 = 0;
  do {
   HEAPF32[i10 + (i1 << 2) >> 2] = f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 if (i3) {
  STACKTOP = i13;
  return;
 }
 i3 = i11 + 16 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  f2 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
  i5 = i11;
  i6 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i12, i4) | 0;
  i7 = i5 + 48 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   i5 = i5 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  i14 = f2 < Math_fround(9.99999974e-06);
  HEAP32[i3 >> 2] = i14 ? 925353388 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i12, i4, i11);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation10GetWeightsERKNS0_21BlendTreeNodeConstantERNS0_18BlendTreeWorkspaceEPfff(i1, i2, i8, f4, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 f4 = Math_fround(f4);
 f3 = Math_fround(f3);
 var i5 = 0, f6 = f0, i7 = 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 0:
  {
   i7 = i1 + 20 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i7 = (i2 | 0) == 0 ? 0 : i2 + i7 | 0;
   i2 = i7 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + i1 | 0;
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   i7 = HEAP32[i7 >> 2] | 0;
   f6 = Math_fround(HEAPF32[i2 + (i7 + -1 << 2) >> 2]);
   f6 = Math_fround(_fminf(Math_fround(_fmaxf(f4, f3)), f6));
   if (!i7) return;
   i2 = (i1 | 0) == 0 ? 0 : i2;
   i5 = 0;
   do {
    f3 = Math_fround(HEAPF32[i2 + (i5 << 2) >> 2]);
    if (!(f3 <= f6)) if (!i5) f3 = Math_fround(1.0); else {
     f4 = Math_fround(HEAPF32[i2 + (i5 + -1 << 2) >> 2]);
     if (f4 > f6) f3 = Math_fround(0.0); else {
      f3 = Math_fround(f3 - f4);
      if (f3 != Math_fround(0.0)) f3 = Math_fround(Math_fround(f6 - f4) / f3); else f3 = Math_fround(1.0);
     }
    } else {
     i1 = i5 + 1 | 0;
     if ((i1 | 0) == (i7 | 0)) f3 = Math_fround(1.0); else {
      f4 = Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
      if (f4 < f6) f3 = Math_fround(0.0); else {
       f3 = Math_fround(f3 - f4);
       if (f3 != Math_fround(0.0)) f3 = Math_fround(Math_fround(f6 - f4) / f3); else f3 = Math_fround(1.0);
      }
     }
    }
    HEAPF32[i8 + (i5 << 2) >> 2] = f3;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != (i7 | 0));
   return;
  }
 case 1:
  {
   i7 = i1 + 24 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim9animation27GetWeightsSimpleDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb((i5 | 0) == 0 ? 0 : i5 + i7 | 0, i8, 0, 0, f4, f3, 0);
   return;
  }
 case 2:
  {
   i7 = i1 + 24 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim9animation29GetWeightsFreeformDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb((i5 | 0) == 0 ? 0 : i5 + i7 | 0, i8, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, f4, f3, 0);
   return;
  }
 case 3:
  {
   i7 = i1 + 24 | 0;
   i5 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim9animation27GetWeightsFreeformCartesianERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb((i5 | 0) == 0 ? 0 : i5 + i7 | 0, i8, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, f4, f3, 0);
   return;
  }
 case 4:
  {
   i1 = i1 + 28 | 0;
   i7 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[((i7 | 0) == 0 ? 0 : i7 + i1 | 0) >> 2] | 0;
   if (!i1) return;
   _memset(i8 | 0, 0, i1 << 2 | 0) | 0;
   return;
  }
 default:
  return;
 }
}

function __ZN5Umbra20RuntimeStructBuilder8finalizeEPNS_9AllocatorE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (HEAP8[i8 + 137 >> 0] | 0) {
  i2 = i8 + 144 | 0;
  i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  i1 = i8 + 148 | 0;
  if ((HEAP32[i1 >> 2] | 0) < 0) {
   i4 = i8 + 140 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 16, 0) | 0;
   if (!i5) {
    i8 = i3;
    return i8 | 0;
   }
   HEAP32[i5 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    i7 = HEAP32[i4 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 + -16 | 0);
   }
   HEAP32[i2 >> 2] = i5 + 16;
  }
  HEAP32[i8 + 152 >> 2] = 0;
  i8 = i3;
  return i8 | 0;
 }
 i7 = i8 + 152 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i8 = 0;
  return i8 | 0;
 }
 i5 = HEAP32[i8 + 144 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 do {
  i2 = (HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 - (HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i4 | 0));
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 + 20 | 0, 0) | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 i5 = i1 + 4 + 15 & -16;
 i6 = i5;
 HEAP32[i5 + -4 >> 2] = i5 - i1;
 if (!i5) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i4 = i8 + 144 | 0;
  i1 = i6;
  i2 = 0;
  do {
   i9 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i9 + (i2 * 12 | 0) >> 2] | 0;
   _memcpy(i1 | 0, i5 | 0, (HEAP32[i9 + (i2 * 12 | 0) + 4 >> 2] | 0) - i5 | 0) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0;
   i1 = i1 + ((HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0) - i9) | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   i3 = i9;
   if (i9 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i7 >> 2] | 0));
 }
 i1 = i8 + 148 | 0;
 if ((HEAP32[i1 >> 2] | 0) < 0) {
  i3 = i8 + 140 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 16, 0) | 0;
  if (!i4) {
   i9 = i6;
   return i9 | 0;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = i8 + 144 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i9 = HEAP32[i3 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = i4 + 16;
 }
 HEAP32[i7 >> 2] = 0;
 i9 = i6;
 return i9 | 0;
}

function __Z25CreatePxMeshFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypef(i2, i9, i3, i4, i5, f6) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 88 | 0;
 i11 = i12 + 44 | 0;
 i7 = i12;
 i1 = (i5 | 0) == 0 ? gb + 1452884 | 0 : gb + 1452896 | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = i2;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i10);
  i8 = i1;
 } else i8 = 0;
 __ZN12MemoryStreamC2EPhj(i10, 0, 0);
 i1 = __Z10GetCookingv() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i13 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i11 + 28 >> 2] = i13;
 i14 = i11 + 32 | 0;
 i1 = i1 + 32 | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = i13;
 _memmove(i7 + 32 | 0, i1 | 0, 12) | 0;
 HEAPF32[i7 + 4 >> 2] = f6;
 i1 = __Z10GetCookingv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i7 | 0);
 do if (__Z27CreatePxStreamFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypeR12MemoryStream(i2, i9, i3, i4, i5, i10) | 0) {
  i1 = __Z14GetDynamicsSDKv() | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i9) {
   i1 = mftCall_iii(HEAP32[i2 + 64 >> 2] | 0, i1 | 0, i10 + 4 | 0) | 0;
   break;
  } else {
   i1 = mftCall_iii(HEAP32[i2 + 36 >> 2] | 0, i1 | 0, i10 + 4 | 0) | 0;
   break;
  }
 } else i1 = 0; while (0);
 i14 = __Z10GetCookingv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0, i14 | 0, i11 | 0);
 __ZN12MemoryStreamD2Ev(i10);
 if (!i8) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 16 | 0;
 i7 = i8 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 16 | 0;
 i7 = i8 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i1, i3, i13) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i1) if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i11 = HEAP32[i2 + 40 >> 2] | 0;
 i12 = i1 + (i11 << 3) | 0;
 if (!i11) {
  i13 = 0;
  return i13 | 0;
 }
 i11 = i3 + 8 | 0;
 i10 = i1;
 i1 = 0;
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  do if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i10 >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
   i3 = i10 + 4 | 0;
   i4 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i3 >> 2] | 0) | 0;
   if (i4) {
    if ((i4 | 0) != (i2 | 0)) if (!(__Z26scripting_class_has_parentP11Il2CppClassS0_(i4, i2) | 0)) break;
    i6 = HEAP32[i3 >> 2] | 0;
    i7 = HEAP32[i13 >> 2] | 0;
    i8 = i7 + 12 | 0;
    i9 = i7 + 16 | 0;
    do if (!(HEAP32[i8 >> 2] | 0)) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i1 & 2147483646) >>> 0 < 10) if ((i1 | 0) > -1) {
      HEAP32[i9 >> 2] = 10;
      HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = 10;
      HEAP32[i7 >> 2] = i5;
      break;
     }
    } while (0);
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i9 >> 2] = i1;
      HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i7 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i8 >> 2] = i3;
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = i6;
    i1 = 1;
   }
  } while (0);
  i10 = i10 + 8 | 0;
 } while ((i10 | 0) != (i12 | 0));
 return i1 | 0;
}

function __Z13DecompressBC7iiiPKjPj(i6, i7, i10, i12, i13) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 if ((i7 | 0) <= 0) {
  STACKTOP = i18;
  return;
 }
 i16 = i6 << 2;
 i17 = i10 << 2;
 if ((i6 | 0) > 0) i2 = 0; else {
  STACKTOP = i18;
  return;
 }
 do {
  i8 = Math_imul(i17, i2) | 0;
  i3 = 0;
  i4 = i12 + ((Math_imul(i16, i2) | 0) << 2) | 0;
  while (1) {
   i9 = i13 + (i3 << 2 << 2) + (i8 << 2) | 0;
   __Z14DecodeBC7BlockP9HDRColorAPKh(i14, i4);
   i1 = 0;
   do {
    i11 = i1 << 2;
    i15 = Math_imul(i1, i10) | 0;
    i5 = 0;
    do {
     i20 = i5 + i11 | 0;
     f23 = Math_fround(HEAPF32[i14 + (i20 << 4) >> 2]);
     f24 = Math_fround(HEAPF32[i14 + (i20 << 4) + 4 >> 2]);
     f22 = Math_fround(HEAPF32[i14 + (i20 << 4) + 8 >> 2]);
     f21 = Math_fround(HEAPF32[i14 + (i20 << 4) + 12 >> 2]);
     i20 = f23 > Math_fround(0.0);
     f23 = i20 ? f23 : Math_fround(0.0);
     i20 = f23 < Math_fround(1.0);
     f23 = i20 ? f23 : Math_fround(1.0);
     i20 = f24 > Math_fround(0.0);
     f24 = i20 ? f24 : Math_fround(0.0);
     i20 = f24 < Math_fround(1.0);
     f24 = i20 ? f24 : Math_fround(1.0);
     i20 = f22 > Math_fround(0.0);
     f22 = i20 ? f22 : Math_fround(0.0);
     i20 = f22 < Math_fround(1.0);
     f22 = i20 ? f22 : Math_fround(1.0);
     i20 = f21 > Math_fround(0.0);
     f21 = i20 ? f21 : Math_fround(0.0);
     i20 = f21 < Math_fround(1.0);
     i19 = i9 + (i5 << 2) + (i15 << 2) | 0;
     i20 = (~~Math_fround(Math_fround(f24 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 8 | ~~Math_fround(Math_fround(f23 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255 | (~~Math_fround(Math_fround(f22 * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 16 | (~~Math_fround(Math_fround((i20 ? f21 : Math_fround(1.0)) * Math_fround(255.0)) + Math_fround(.00100000005)) & 255) << 24;
     HEAP8[i19 >> 0] = i20;
     HEAP8[i19 + 1 >> 0] = i20 >> 8;
     HEAP8[i19 + 2 >> 0] = i20 >> 16;
     HEAP8[i19 + 3 >> 0] = i20 >> 24;
     i5 = i5 + 1 | 0;
    } while ((i5 | 0) != 4);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 4);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) break; else i4 = i4 + 16 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 STACKTOP = i18;
 return;
}

function __ZN21TreeBinaryTreeBuilder18CalculatePosBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERK8Vector3fSE_(i14, i2, i1, i15, i16) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0;
 f11 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 f13 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 f17 = Math_fround(-f11);
 f18 = Math_fround(-f13);
 f19 = Math_fround(-f12);
 i10 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i10) {
  f8 = f11;
  f7 = f12;
  f6 = f17;
  f5 = f18;
  f4 = f19;
  f3 = f13;
 } else {
  i9 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = 0;
  f8 = f11;
  f7 = f12;
  f6 = f17;
  f5 = f18;
  f4 = f19;
  f3 = f13;
  do {
   i23 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   f22 = Math_fround(HEAPF32[i2 + (i23 * 40 | 0) >> 2]);
   f8 = f22 < f8 ? f22 : f8;
   f21 = Math_fround(HEAPF32[i2 + (i23 * 40 | 0) + 4 >> 2]);
   f3 = f21 < f3 ? f21 : f3;
   f20 = Math_fround(HEAPF32[i2 + (i23 * 40 | 0) + 8 >> 2]);
   f7 = f20 < f7 ? f20 : f7;
   f6 = f6 < f22 ? f22 : f6;
   f5 = f5 < f21 ? f21 : f5;
   f4 = f4 < f20 ? f20 : f4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i10 >>> 0);
 }
 do if (!(f8 == f11 & f3 == f13 & f7 == f12)) {
  if (f6 == f17) if (!(f4 != f19 | f5 != f18)) break;
  f11 = Math_fround(HEAPF32[i16 >> 2]);
  f17 = Math_fround(f8 * f11);
  f12 = Math_fround(HEAPF32[i16 + 4 >> 2]);
  f18 = Math_fround(f3 * f12);
  f13 = Math_fround(HEAPF32[i16 + 8 >> 2]);
  f19 = Math_fround(f7 * f13);
  f20 = Math_fround(HEAPF32[i15 >> 2]);
  f17 = Math_fround(f17 + f20);
  f21 = Math_fround(HEAPF32[i15 + 4 >> 2]);
  f18 = Math_fround(f18 + f21);
  f22 = Math_fround(HEAPF32[i15 + 8 >> 2]);
  f19 = Math_fround(f19 + f22);
  f20 = Math_fround(Math_fround(f6 * f11) + f20);
  f21 = Math_fround(Math_fround(f5 * f12) + f21);
  f22 = Math_fround(Math_fround(f4 * f13) + f22);
  HEAPF32[i14 >> 2] = f17;
  HEAPF32[i14 + 4 >> 2] = f18;
  HEAPF32[i14 + 8 >> 2] = f19;
  HEAPF32[i14 + 12 >> 2] = f20;
  HEAPF32[i14 + 16 >> 2] = f21;
  HEAPF32[i14 + 20 >> 2] = f22;
  return;
 } while (0);
 i10 = HEAP32[i15 >> 2] | 0;
 HEAP32[i14 >> 2] = i10;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 HEAP32[i14 + 4 >> 2] = i16;
 i23 = HEAP32[i15 + 8 >> 2] | 0;
 HEAP32[i14 + 8 >> 2] = i23;
 HEAP32[i14 + 12 >> 2] = i10;
 HEAP32[i14 + 16 >> 2] = i16;
 HEAP32[i14 + 20 >> 2] = i23;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 52 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 932704 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN11DetailPatch8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 52 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 932704 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN11DetailPatch8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 52 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE8__appendEj(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i9 = gb + 63648 | 0;
   i10 = HEAP32[i9 + 4 >> 2] | 0;
   i11 = i1 + 24 | 0;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   HEAP8[i1 + 4 >> 0] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 32 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i9 = i3 - i4 | 0;
 i3 = i9 >> 4;
 i3 = i9 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 134217727;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 5) | 0;
 i8 = i5 + (i1 - i4 >> 5 << 5) | 0;
 i7 = i8;
 i3 = i5 + (i3 << 5) | 0;
 i5 = gb + 63648 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i9 = i7;
 i1 = i8;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i6 = i1 + 24 | 0;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP8[i1 + 4 >> 0] = 0;
  i1 = i9 + 32 | 0;
  i9 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = i3;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i7;
  i5 = i4;
  i1 = i4;
 } else {
  i3 = i7;
  i2 = i8;
  do {
   i8 = i2 + -32 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i2 + -12 >> 2] = 0;
   i13 = i1 + -8 | 0;
   i1 = i1 + -32 | 0;
   i5 = HEAP32[i13 + 4 >> 2] | 0;
   i7 = i2 + -8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i7 + 4 >> 2] = i5;
   HEAP8[i2 + -28 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i8, i1);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i9;
 HEAP32[i11 >> 2] = i6;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -32 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -28 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN2UI13CanvasManager20UpdateDirtyRenderersER8JobFencePNS_6CanvasE(i9, i10, i4) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i4;
 if (!i4) {
  STACKTOP = i11;
  return;
 }
 i8 = i9 + 12 | 0;
 i2 = i9 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i5 = i2;
  i4 = 12;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i4 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i4 = 5;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i4 = 11;
     break;
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i4 = 9;
     break;
    } else i1 = i3;
   }
  }
  if ((i4 | 0) == 5) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i2 = i1;
   i4 = 12;
   break;
  } else if ((i4 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i4 = 12;
   break;
  } else if ((i4 | 0) == 11) {
   HEAP32[i6 >> 2] = i1;
   if (!i1) {
    i5 = i1;
    i2 = i6;
    i4 = 12;
    break;
   } else {
    i3 = i1;
    break;
   }
  }
 } while (0);
 if ((i4 | 0) == 12) {
  i3 = __Znwj(32) | 0;
  HEAP32[i3 + 16 >> 2] = i7;
  i1 = i3 + 24 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = i5;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  if (!i1) i1 = i3; else {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 16 >> 2] | 0, i1);
  i9 = i9 + 20 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 }
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 24 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   __ZN2UI14CanvasRenderer17SyncDirtyElementsER8JobFence(HEAP32[i2 + 16 >> 2] | 0, i10);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN23TransformChangeDispatch28GetAndClearChangedTransformsE27TransformChangeSystemHandleR13dynamic_arrayI23TransformAccessReadOnlyLj4EE(i9, i1, i12) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 12 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13;
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = 1 << i7;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 if (!i6) i1 = 0; else {
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = 0;
  i3 = 0;
  do {
   i2 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
   if (HEAP32[i2 + 36 >> 2] & i5) i1 = (HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i6 | 0));
 }
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i12 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 3, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i12 >> 2] = i1;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i12 >> 2] = i6;
  i1 = i6;
  break;
 } else i1 = HEAP32[i12 >> 2] | 0; while (0);
 HEAP32[i11 >> 2] = i1;
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZN23TransformChangeDispatch40GetAndClearChangedAsBatchedJobs_InternalE27TransformChangeSystemHandlePFvPvPK23TransformAccessReadOnlyjES1_PFvS1_E(i9, i8, fb + 516 | 0, i11, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 >= i1 >>> 0) {
  i12 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((i2 | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 3, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  i12 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i12 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i12 >> 2] = i11;
  i12 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 return 0;
}

function __ZN9JSONWrite8TransferIN11UnityEngine9Analytics16TransactionEvent11ReceiptDataEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = HEAP8[i11 + 11 >> 0] | 0;
 if ((i9 << 24 >> 24 < 0 ? HEAP32[i11 + 4 >> 2] | 0 : i9 & 255) | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1041891 | 0, 0);
 i3 = i11 + 16 | 0;
 i9 = HEAP8[i3 + 11 >> 0] | 0;
 if ((i9 << 24 >> 24 < 0 ? HEAP32[i11 + 20 >> 2] | 0 : i9 & 255) | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i10, i3, gb + 1037843 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5Unity5Joint30CalculateGlobalConnectedAnchorEb(i7, i8, i6) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i10 = i11;
 i4 = i8 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i2 = 0; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) {
    i2 = 0;
    break;
   }
  }
  i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 } while (0);
 if (i6) {
  __ZNK9Transform14TransformPointERK8Vector3f(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i8 + 40 | 0);
  i1 = i8 + 52 | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  } else {
   __ZNK9Transform21InverseTransformPointERK8Vector3f(i10, i2, i9);
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  }
 }
 if (!i2) {
  i12 = i8 + 52 | 0;
  HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  STACKTOP = i11;
  return;
 } else {
  __ZNK9Transform14TransformPointERK8Vector3f(i9, i2, i8 + 52 | 0);
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  STACKTOP = i11;
  return;
 }
}

function __ZN2UI14CanvasRenderer17MainThreadCleanupEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i9 = i7 + 188 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = (i1 | 0) == 0;
 i1 = i4 ? i6 : i1 + 332 | 0;
 i6 = i7 + 204 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) != 0;
 i8 = i7 + 220 | 0;
 i5 = (HEAP32[i8 >> 2] | 0) != 0;
 if (!(i4 | (i2 | i5) ^ 1)) if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 if (i2) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i2 = i7 + 208 | 0;
   i3 = (HEAP32[i1 + 84 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 672 | 0) + 476 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) {
    i11 = i4 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    if (!(HEAP32[i11 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63232 | 0);
    }
    HEAP32[i3 >> 2] = 0;
   }
   i11 = i7 + 212 | 0;
   HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 >> 2] = -1;
   HEAP32[i11 >> 2] = -1;
   HEAP32[i7 + 216 >> 2] = -1;
  }
  i11 = i1 + 112 | 0;
  HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 6;
 }
 if (!i5) {
  __ZN2UI14CanvasRenderer5ClearEv(i7);
  i8 = HEAP32[gb + 1467948 >> 2] | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i8, i11, i7);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i2 = i7 + 224 | 0;
  i3 = (HEAP32[i1 + 84 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 672 | 0) + 476 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i11 = i4 + 4 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   if (!(HEAP32[i11 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63232 | 0);
   }
   HEAP32[i3 >> 2] = 0;
  }
  i11 = i7 + 228 | 0;
  HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i2 >> 2] = -1;
  HEAP32[i11 >> 2] = -1;
  HEAP32[i7 + 232 >> 2] = -1;
 }
 i8 = i1 + 112 | 0;
 HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 0 | 6;
 __ZN2UI14CanvasRenderer5ClearEv(i7);
 i8 = HEAP32[gb + 1467948 >> 2] | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(i8, i11, i7);
 STACKTOP = i10;
 return;
}

function __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i2 = i11;
 i1 = HEAP32[i6 + 248 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i1 = 0; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i2);
    i2 = HEAP32[i10 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
 }
 i5 = i7 + 128 | 0;
 __Z29FindReflectionProbeFromAnchorP9TransformRK4AABBRS1_RsS5_(i1, i5, i9 + 276 | 0, i9 + 272 | 0, i9 + 274 | 0) | 0;
 i12 = __Z30GetLightProbeProxyVolumeHandleRK28LightProbeProxyVolumeContextRK12BaseRenderer((__Z31GetLightProbeProxyVolumeManagerv() | 0) + 20 | 0, i6) | 0;
 HEAP16[i9 + 268 >> 1] = i12;
 i2 = i9 + 232 | 0;
 i3 = HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16;
 i4 = (i3 & 16777215) >>> 16 & 3;
 if (i12 << 16 >> 16 == -1 & (i4 & 16777215 | 0) == 2) {
  i3 = i3 & 16580607 | 65536;
  HEAP16[i2 >> 1] = i3;
  HEAP8[i2 + 2 >> 0] = i3 >>> 16;
 } else if (((i4 & 16777215) + -1 | 0) >>> 0 >= 2) {
  STACKTOP = i11;
  return;
 }
 i2 = i6 + 232 | 0;
 if (i3 & 8192 | 0) {
  __Z38CalculateExplicitLightProbeCoordinatesiR29LightProbeSamplingCoordinates(HEAP32[i2 >> 2] | 0, i9 + 300 | 0);
  STACKTOP = i11;
  return;
 }
 if (!i1) {
  HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 132 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i7 + 136 >> 2];
 } else __ZNK9Transform11GetPositionEv(i10, i1);
 __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates(i8, i10, HEAP32[i2 >> 2] | 0, i9 + 300 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 + 320 >> 2];
 STACKTOP = i11;
 return;
}

function __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei(i11, i12, i15) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i16 = Math_imul(i11 << 2, i11) | 0;
 i16 = i16 >>> 0 > 1073741823 ? -1 : i16 << 2;
 f17 = Math_fround(i11 | 0);
 f18 = Math_fround(Math_fround(1.0) / f17);
 i19 = (i11 | 0) > 0;
 i10 = 0;
 do {
  i20 = i12 + (i10 << 4) | 0;
  HEAP32[i20 >> 2] = 0;
  i13 = i12 + (i10 << 4) + 4 | 0;
  HEAP32[i13 >> 2] = 0;
  i14 = i12 + (i10 << 4) + 8 | 0;
  HEAP32[i14 >> 2] = 0;
  i2 = i12 + (i10 << 4) + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  HEAP32[i20 >> 2] = i11;
  HEAP32[i13 >> 2] = i11;
  HEAP32[i14 >> 2] = 4;
  i1 = __Znaj(i16) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i19) {
   i9 = 0;
   i3 = i11;
   i2 = i11;
   do {
    if ((i3 | 0) > 0) {
     f4 = Math_fround(i9 | 0);
     f6 = Math_fround(Math_fround(Math_fround(Math_fround(f4 + Math_fround(.5)) * Math_fround(2.0)) / f17) + Math_fround(-1.0));
     f5 = Math_fround(f6 - f18);
     f6 = Math_fround(f18 + f6);
     f7 = Math_fround(f5 * f5);
     f8 = Math_fround(f6 * f6);
     i2 = 0;
     do {
      f22 = Math_fround(i2 | 0);
      __Z16TexelCoordToVectiffiPfi(i10, f22, f4, i11, i1, i15);
      f22 = Math_fround(Math_fround(Math_fround(Math_fround(f22 + Math_fround(.5)) * Math_fround(2.0)) / f17) + Math_fround(-1.0));
      f24 = Math_fround(f22 - f18);
      f22 = Math_fround(f18 + f22);
      f23 = Math_fround(f24 * f24);
      f21 = Math_fround(f22 * f22);
      HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(+Math_atan2(+Math_fround(f5 * f24), +Math_fround(Math_sqrt(Math_fround(Math_fround(f7 + f23) + Math_fround(1.0)))))) - Math_fround(+Math_atan2(+Math_fround(f6 * f24), +Math_fround(Math_sqrt(Math_fround(Math_fround(f8 + f23) + Math_fround(1.0))))))) - Math_fround(+Math_atan2(+Math_fround(f5 * f22), +Math_fround(Math_sqrt(Math_fround(Math_fround(f7 + f21) + Math_fround(1.0))))))) + Math_fround(+Math_atan2(+Math_fround(f6 * f22), +Math_fround(Math_sqrt(Math_fround(Math_fround(f8 + f21) + Math_fround(1.0)))))));
      i1 = i1 + (HEAP32[i14 >> 2] << 2) | 0;
      i2 = i2 + 1 | 0;
      i3 = HEAP32[i20 >> 2] | 0;
     } while ((i2 | 0) < (i3 | 0));
     i2 = HEAP32[i13 >> 2] | 0;
    }
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) < (i2 | 0));
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != 6);
 return;
}

function __ZN18AsyncUploadManager35ManageTextureUploadRingBufferMemoryEi(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i3 = i1 << 20;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i6 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i2 >> 2] = 0;
  i1 = i6 + 12 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   HEAP32[i6 + 16 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = i6 + 1324 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  i4 = i6 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = (i1 | 0) > (i3 | 0) ? i1 : i3;
  HEAP32[i4 >> 2] = i3;
  i1 = i6 + 12 | 0;
  if ((i3 | 0) <= (HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i7;
   return;
  }
  i2 = i6 + 1324 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) if (HEAP8[i3 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 8 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63304 | 0);
  HEAP32[i2 >> 2] = 0;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  i6 = i6 + 28 | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = (i4 | 0) > (i8 | 0) ? i4 : i8;
  i6 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63304 | 0, 16, gb + 397649 | 0, 180) | 0;
  i8 = gb + 63304 | 0;
  i4 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  HEAP32[i6 + 20 >> 2] = 0;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 32 >> 2] = 0;
  i3 = (i3 << 1) + -1 | 0;
  i1 = i3 >>> 0 > 65535;
  i3 = i1 ? i3 >>> 16 : i3;
  i1 = i1 ? 16 : 0;
  i4 = (i3 & 65280 | 0) == 0;
  i3 = i4 ? i3 : i3 >>> 8;
  i1 = i4 ? i1 : i1 | 8;
  i4 = (i3 & 240 | 0) == 0;
  i3 = 1 << (i4 ? i1 : i1 | 4) + (HEAP8[(i4 ? i3 : i3 >>> 4) + (gb + 936717) >> 0] | 0);
  HEAP32[i6 + 16 >> 2] = i3;
  HEAP32[i6 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 397808 | 0, 62) | 0;
  HEAP8[i6 + 4 >> 0] = 1;
  i3 = i5;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i2 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 8 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 12 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i12, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j(i4, HEAP32[i2 >> 2] | 0);
 i9 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[gb + 37324 >> 2] | 0;
  i5 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, 0, 1) | 0;
  i6 = i12 + 80 | 0;
  i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i6 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i8 = i12 + 84 | 0;
  HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
  if ((i5 | 0) == 2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i9 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i7) | 0) + i5 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i10, i2);
     i13 = i10;
     i3 = HEAP32[i13 + 4 >> 2] | 0;
     i4 = i2 + 24 | 0;
     HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i4 + 4 >> 2] = i3;
     i4 = HEAP32[i8 >> 2] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i1, i12);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i9 | 0)) break L8;
     i3 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i12);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i9 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i12, gb + 1041891 | 0, i3, i10, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i1, i12); else {
     i2 = HEAP32[i10 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i12 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i12);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i9 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if (!(HEAP8[i2 + 53 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i10 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 i3 = i1 & 1 ^ 1;
 HEAP8[i9 + 36 >> 0] = i3;
 HEAP32[i9 + 32 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i2;
 if (!(HEAP32[i2 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i2 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 20 >> 2] = i4;
 if (!(HEAP32[i4 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i4 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i9 + 16 >> 2] = i1;
 if (!(i3 << 24 >> 24)) {
  HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 52 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 60 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 48 >> 2];
  i1 = i5 + 56 | 0;
 } else {
  HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 48 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 56 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 52 >> 2];
  i1 = i5 + 60 | 0;
 }
 HEAP32[i9 + 28 >> 2] = HEAP32[i1 >> 2];
 if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 152 >> 2] | 0, i10 | 0) | 0) {
  i2 = i10 + 36 | 0;
  i3 = i10 + 48 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = i10 + 52 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 & 2147483647;
  do if (i5 >>> 0 > i8 >>> 0) {
   i1 = i7 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 40 | 0, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 40 | 0, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 40 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
    HEAP32[i2 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i5;
  i1 = (HEAP32[i2 >> 2] | 0) + (i4 * 40 | 0) | 0;
  i2 = i9;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
 }
 if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 140 >> 2] | 0, i10 | 0, i9 | 0);
 STACKTOP = i11;
 return;
}

function __Z15TransformVector23TransformAccessReadOnlyRKN4math7_float3E(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i8 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 i2 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 do {
  f20 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 28 >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 32 >> 2]);
  f20 = Math_fround(f3 * f20);
  f13 = Math_fround(f4 * f13);
  f17 = Math_fround(f5 * Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 36 >> 2]));
  f12 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 16 >> 2]);
  f16 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 12 >> 2]);
  f10 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 24 >> 2]);
  f22 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 20 >> 2]);
  f23 = Math_fround(f12 * Math_fround(-2.0));
  f14 = Math_fround(f12 * Math_fround(2.0));
  f19 = Math_fround(f23 * f10);
  f11 = Math_fround(f22 * Math_fround(2.0));
  f18 = Math_fround(f22 * Math_fround(-2.0));
  f24 = Math_fround(f10 * f18);
  f15 = Math_fround(f16 * Math_fround(-2.0));
  f21 = Math_fround(f16 * Math_fround(2.0));
  f10 = Math_fround(f10 * f15);
  f3 = Math_fround(Math_fround(f20 + Math_fround(f20 * Math_fround(Math_fround(f12 * f23) - Math_fround(f22 * f11)))) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f21 * f22) - f19)) + Math_fround(f13 * Math_fround(f24 - Math_fround(f12 * f15)))));
  f4 = Math_fround(Math_fround(f13 + Math_fround(f20 * Math_fround(Math_fround(f16 * f14) - f24))) + Math_fround(Math_fround(f17 * Math_fround(f10 - Math_fround(f23 * f22))) + Math_fround(f13 * Math_fround(Math_fround(f22 * f18) - Math_fround(f16 * f21)))));
  f5 = Math_fround(Math_fround(f17 + Math_fround(f20 * Math_fround(f19 - Math_fround(f16 * f18)))) + Math_fround(Math_fround(f17 * Math_fround(Math_fround(f16 * f15) - Math_fround(f12 * f14))) + Math_fround(f13 * Math_fround(Math_fround(f12 * f11) - f10))));
  i1 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) > -1);
 HEAPF32[i9 >> 2] = f3;
 HEAPF32[i2 >> 2] = f4;
 HEAPF32[i6 >> 2] = f5;
 return;
}

function __ZN12LineRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405193 | 0, HEAP32[gb + 37316 >> 2] | 0, (HEAP32[i1 + 348 >> 2] | 0) + 8 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 12 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37324 >> 2] | 0, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i7, i6 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[i1 + 344 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421169 | 0, gb + 421182 | 0, i6, 0);
 __ZN14LineParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405205 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 340 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEj(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i7 = (i10 >>> 0) / 3 | 0;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i8 = (i7 >>> 0) / (i3 >>> 0) | 0;
 i9 = (i7 >>> 0) % (i3 >>> 0) | 0;
 switch ((Math_imul(i7, -3) | 0) + i10 | 0) {
 case 0:
  {
   if (i9 >>> 0 < (i3 + -1 | 0) >>> 0) {
    if (!i8) i1 = 0; else {
     i1 = i7 - i3 | 0;
     HEAP32[i5 >> 2] = (i1 << 1 | 1) - ((HEAPU8[(HEAP32[i6 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >>> 7 & 255);
     i1 = 1;
    }
    if (i8 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0) {
     HEAP32[i5 + (i1 << 2) >> 2] = (HEAPU8[(HEAP32[i6 + 36 >> 2] | 0) + (i7 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i7 << 1;
     i4 = 14;
    } else i4 = 19;
   } else i4 = 19;
   break;
  }
 case 1:
  {
   if (i9 >>> 0 < (i3 + -1 | 0) >>> 0 ? i8 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0 : 0) {
    i2 = i7 << 1;
    HEAP32[i5 >> 2] = i2;
    i1 = i2 | 1;
    HEAP32[i5 + 4 >> 2] = i1;
   } else i4 = 19;
   break;
  }
 case 2:
  {
   if (i8 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0) {
    if (!i9) i1 = 0; else {
     HEAP32[i5 >> 2] = (i7 << 1) + -1;
     i1 = 1;
    }
    if (i9 >>> 0 < (i3 + -1 | 0) >>> 0) {
     HEAP32[i5 + (i1 << 2) >> 2] = i7 << 1;
     i4 = 14;
    } else i4 = 19;
   } else i4 = 19;
   break;
  }
 default:
  i4 = 19;
 }
 if ((i4 | 0) == 14) if (!i1) i4 = 19; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
 }
 if ((i4 | 0) == 19) {
  if (HEAP16[i6 + 48 >> 1] & 1) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  i8 = HEAP32[i5 >> 2] | 0;
  i10 = i8 >>> 1;
  i9 = HEAP32[i6 + 36 >> 2] | 0;
  i10 = (HEAP8[((i8 & 1 | 0) == 0 ? i9 + (i10 << 2) + 2 | 0 : i9 + (i10 << 2) + 3 | 0) >> 0] & 127) != 127;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i2 >>> 1;
 i4 = HEAP32[i6 + 36 >> 2] | 0;
 i3 = i1 >>> 1;
 i1 = (HEAPU8[((i1 & 1 | 0) == 0 ? i4 + (i3 << 2) + 2 | 0 : i4 + (i3 << 2) + 3 | 0) >> 0] | 0) & 127;
 if ((HEAP8[((i2 & 1 | 0) == 0 ? i4 + (i5 << 2) + 2 | 0 : i4 + (i5 << 2) + 3 | 0) >> 0] & 127) == 127) {
  i10 = i1 << 16 >> 16 != 127;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (i1 << 16 >> 16 == 127) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = __ZNK5physx2Gu11HeightField12isConvexEdgeEjjjj(i6, i10, i7, i8, i9) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx2Gu21SweepCapsuleTrianglesEjPKNS_10PxTriangleEbRKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS_6PxVec3EfPKjRSA_SF_RfRjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i12, i14, i6, i2, i3, i5, f11, i1, i8, i13, i4, i9, f10, i7) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f11 = Math_fround(f11);
 i1 = i1 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i7 = i7 | 0;
 var i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, f27 = f0, f28 = f0, f29 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i15 + 72 | 0;
 i20 = i15 + 100 | 0;
 i16 = i15 + 12 | 0;
 i18 = i15 + 162 | 0;
 i17 = i15 + 160 | 0;
 f29 = Math_fround(HEAPF32[i3 >> 2]);
 f26 = Math_fround(f29 * Math_fround(2.0));
 f23 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f24 = Math_fround(f23 * Math_fround(2.0));
 f23 = Math_fround(Math_fround(f29 * f26) + Math_fround(Math_fround(f23 * f24) + Math_fround(-1.0)));
 f29 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f22 = Math_fround(f29 * f24);
 f21 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f22 = Math_fround(f22 + Math_fround(f26 * f21));
 f21 = Math_fround(Math_fround(f26 * f29) - Math_fround(f24 * f21));
 f24 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f23 = Math_fround(f24 * f23);
 f22 = Math_fround(f24 * f22);
 f21 = Math_fround(f24 * f21);
 f24 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f29 = Math_fround(f24 + f23);
 f26 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f28 = Math_fround(f26 + f22);
 f25 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f27 = Math_fround(f21 + f25);
 HEAPF32[i19 >> 2] = f29;
 HEAPF32[i19 + 4 >> 2] = f28;
 HEAPF32[i19 + 8 >> 2] = f27;
 f22 = Math_fround(f26 - f22);
 f21 = Math_fround(f25 - f21);
 HEAPF32[i19 + 12 >> 2] = Math_fround(f24 - f23);
 HEAPF32[i19 + 16 >> 2] = f22;
 HEAPF32[i19 + 20 >> 2] = f21;
 HEAPF32[i19 + 24 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) + f10);
 __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE(i19, i20);
 __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f(i16, i20 + 48 | 0, i20 + 36 | 0, i20, i5, f11);
 HEAP16[i18 >> 1] = 0;
 HEAP16[i17 >> 1] = HEAP16[i7 >> 1] | 0;
 i14 = __ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE(i12, i14, i19, i5, f11, i1, i18, i4, i13, i8, i9, i15, i17, i6, i16) | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5Umbra10PathFinderC2ERNS_12QueryContextE(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 HEAP32[i10 >> 2] = i7;
 i2 = i7 + 4 | 0;
 HEAP32[i10 + 4 >> 2] = i2;
 i6 = i7 + 44 | 0;
 HEAP32[i10 + 16 >> 2] = i6;
 i9 = i7 + 48 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 + 20 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = 20;
 HEAP32[i10 + 40 >> 2] = i2;
 HEAP32[i10 + 52 >> 2] = i6;
 HEAP32[i10 + 56 >> 2] = i1 + 1;
 HEAP32[i10 + 60 >> 2] = 8;
 HEAP32[i10 + 76 >> 2] = i2;
 HEAP32[i10 + 88 >> 2] = i6;
 HEAP32[i10 + 92 >> 2] = i1 + 2;
 HEAP32[i10 + 96 >> 2] = 16;
 HEAP32[i10 + 112 >> 2] = i2;
 HEAP32[i10 + 124 >> 2] = i6;
 HEAP32[i9 >> 2] = i1 + 4;
 HEAP32[i10 + 128 >> 2] = i1 + 3;
 HEAP32[i10 + 132 >> 2] = 16;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  i3 = (HEAP32[i1 + 124 >> 2] | 0) + -1 | 0;
  i9 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
  i3 = (HEAP32[i9 + (i3 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i9 + (i3 * 20 | 0) >> 2] | 0) | 0;
 } else i3 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
 i6 = i3 + 2 | 0;
 HEAP32[i10 + 148 >> 2] = i2;
 i9 = i10 + 160 | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i10 + 164 >> 2] = 0;
 i1 = i10 + 24168 | 0;
 i2 = i10 + 8168 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 33 >> 5;
 i2 = i1 << 1;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + ((i1 << 3) + 31 & -16) | 0;
 if (i5 >>> 0 > (HEAP32[i7 + 12 >> 2] | 0) >>> 0) i8 = 8; else {
  HEAP32[i3 >> 2] = i5;
  if (!i4) i8 = 8; else {
   HEAP32[i4 >> 2] = i2;
   i6 = i4 + 16 | 0;
   HEAP32[i10 + 152 >> 2] = i6;
   HEAP32[i10 + 156 >> 2] = i6 + (i1 << 2);
   _memset(i6 | 0, 0, (HEAP32[i9 >> 2] | 0) + 31 >> 5 << 3 | 0) | 0;
   i6 = HEAP32[i9 >> 2] | 0;
  }
 }
 if ((i8 | 0) == 8) {
  HEAP32[i10 + 152 >> 2] = 0;
  HEAP32[i7 + 28 >> 2] = 2;
 }
 if ((i6 | 0) > 65534) return;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 2) {
  HEAP32[i2 >> 2] = 2;
  return;
 }
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + ((i6 << 1) + 31 & -16) | 0;
 if (i5 >>> 0 <= (HEAP32[i1 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i5;
  if (i4 | 0) {
   HEAP32[i4 >> 2] = i6;
   HEAP32[i10 + 24168 >> 2] = i4 + 16;
   i9 = HEAP32[i9 >> 2] | 0;
   HEAP16[i10 + 24172 >> 1] = i9 + 65535;
   HEAP16[i10 + 24174 >> 1] = i9 + 65534;
   return;
  }
 }
 HEAP32[i10 + 24168 >> 2] = 0;
 HEAP32[i2 >> 2] = 2;
 return;
}

function __ZN23RaycastCallbackNonAlloc14processTouchesEPKN5physx12PxRaycastHitEj(i1, i15, i16) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20;
 i18 = i1 + 92 | 0;
 if (!i16) {
  i19 = 1;
  STACKTOP = i20;
  return i19 | 0;
 }
 i19 = i1 + 88 | 0;
 i12 = i1 + 84 | 0;
 i13 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 i3 = i17 + 12 | 0;
 i4 = i17 + 16 | 0;
 i5 = i17 + 20 | 0;
 i6 = i17 + 24 | 0;
 i7 = i17 + 28 | 0;
 i8 = i17 + 32 | 0;
 i9 = i17 + 36 | 0;
 i1 = 0;
 while (1) {
  i10 = HEAP32[i18 >> 2] | 0;
  if ((i10 | 0) >= (HEAP32[i19 >> 2] | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
  HEAP32[i18 >> 2] = i10 + 1;
  i11 = HEAP32[i12 >> 2] | 0;
  i21 = i11 + (i10 * 44 | 0) | 0;
  i2 = i15 + (i1 << 6) + 4 | 0;
  HEAP32[i11 + (i10 * 44 | 0) + 40 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
  i22 = i15 + (i1 << 6) + 16 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  i21 = i11 + (i10 * 44 | 0) + 12 | 0;
  i22 = i15 + (i1 << 6) + 28 | 0;
  HEAP32[i21 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i21 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i21 + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  HEAP32[i17 >> 2] = 5;
  HEAPF32[i13 >> 2] = Math_fround(1.0);
  HEAPF32[i14 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  i21 = i8;
  HEAP32[i21 >> 2] = 0;
  HEAP32[i21 + 4 >> 2] = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i17 | 0) | 0) {
   i2 = HEAP32[i9 >> 2] | 0;
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
   i2 = HEAP32[i2 + (HEAP32[i15 + (i1 << 6) + 8 >> 2] << 2) >> 2] | 0;
  } else i2 = -1;
  HEAP32[i11 + (i10 * 44 | 0) + 24 >> 2] = i2;
  HEAP32[i11 + (i10 * 44 | 0) + 28 >> 2] = HEAP32[i15 + (i1 << 6) + 40 >> 2];
  HEAP32[i11 + (i10 * 44 | 0) + 32 >> 2] = HEAP32[i15 + (i1 << 6) + 44 >> 2];
  HEAP32[i11 + (i10 * 44 | 0) + 36 >> 2] = HEAP32[i15 + (i1 << 6) + 48 >> 2];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i16 >>> 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  STACKTOP = i20;
  return i1 | 0;
 }
 return 0;
}

function __ZN13GfxDeviceGLES19CreateComputeBufferE15ComputeBufferIDjjj(i9, i6, i3, i4, i5) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0)) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 i2 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, Math_imul(i4, i3) | 0, 9, 1) | 0;
 if (!(i5 & 6)) i1 = 0; else i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, 4, 9, 1) | 0;
 i11 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 603515 | 0, 2379) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 24 >> 2] = i1;
 HEAP32[i11 + 28 >> 2] = -1;
 HEAP32[i11 + 32 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i11 + 8 >> 2] = i4;
 HEAP32[i11 + 12 >> 2] = i5;
 i7 = i11 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i7 = i11 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i11 + 36 >> 2] = -1;
 i7 = i9 + 8452 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i11;
 i2 = i9 + 8456 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i5 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 13;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 12;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 8) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 12) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 13) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i8;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 8456 >> 2] | 0, i1);
  i11 = i9 + 8460 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 STACKTOP = i10;
 return;
}

function __ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i7, i2, i5) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i10 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i5 + 244 >> 2] = i10;
 if ((i10 | 0) <= 0) {
  HEAP32[i5 + 324 >> 2] = 0;
  STACKTOP = i12;
  return 1;
 }
 i3 = i10 << 3;
 i4 = i2 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 + i3 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, i3 >>> 0 < 32768 ? 32768 : i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i6 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i4 >> 2] = i1 + i3;
 HEAP32[i5 + 324 >> 2] = i6;
 i5 = 0;
 do {
  i4 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, i5 | 0) | 0;
  do if (!i4) i11 = 15; else {
   HEAP32[i9 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 11; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 13;
    }
   }
   if ((i11 | 0) == 11) i11 = 13;
   if ((i11 | 0) == 13) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
    if (!i1) {
     i11 = 15;
     break;
    }
   }
   HEAP32[i6 + (i5 << 3) >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(i1) | 0;
   HEAP32[i6 + (i5 << 3) + 4 >> 2] = HEAP32[i1 + 36 >> 2];
  } while (0);
  if ((i11 | 0) == 15) {
   i11 = 0;
   HEAP32[i6 + (i5 << 3) >> 2] = __ZN8Material25AcquireSharedMaterialDataEv(__ZN8Material10GetDefaultEv() | 0) | 0;
   HEAP32[i6 + (i5 << 3) + 4 >> 2] = -1;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i10 | 0));
 STACKTOP = i12;
 return 1;
}

function __ZN8Material14CreateMaterialERKS_ib(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i3 = i7 + 8 | 0;
 i6 = i7;
 i10 = gb + 63520 | 0;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 i6 = __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId(4, i4) | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, i2 | 0);
 i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0;
 mftCall_vii(i5 | 0, i6 | 0, mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0);
 i5 = i6 + 32 | 0;
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  i10 = 0;
  i9 = i6 + 100 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + 8 | 0;
  HEAP32[i9 >> 2] = i10;
  i9 = i6 + 44 | 0;
  i10 = i8 + 44 | 0;
  __ZN18UnityPropertySheet21AddNewSerializedPropsERKS_(i9, i10);
  __ZN8Material15BuildPropertiesEv(i6);
  __ZN8Material21CopySettingsFromOtherERKS_(i6, i8);
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i3);
   i2 = HEAP32[i4 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 9;
  }
 }
 if ((i9 | 0) == 7) i9 = 9;
 if ((i9 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i1;
 i9 = i6 + 100 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i9 = i9 + 8 | 0;
 HEAP32[i9 >> 2] = i10;
 i9 = i6 + 44 | 0;
 i10 = i8 + 44 | 0;
 __ZN18UnityPropertySheet21AddNewSerializedPropsERKS_(i9, i10);
 __ZN8Material15BuildPropertiesEv(i6);
 __ZN8Material21CopySettingsFromOtherERKS_(i6, i8);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_17PxTolerancesScaleEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 148 | 0;
 i15 = i11 + 96 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i14 = i11 + 36 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx30PxTolerancesScaleGeneratedInfoC2Ev(i14);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = i9;
 i16 = i15 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i15 + 20 >> 2] = i5;
 HEAP32[i15 + 24 >> 2] = i4;
 HEAP32[i15 + 28 >> 2] = i1;
 HEAP32[i15 + 32 >> 2] = i3;
 HEAP8[i15 + 36 >> 0] = 1;
 HEAP32[i15 + 40 >> 2] = i13;
 HEAP32[i15 + 44 >> 2] = 0;
 HEAP32[i15 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj207ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 12 | 0, 1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj208ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 28 | 0, 2);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj209ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i15, i14 + 44 | 0, 3);
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN20BufferedSocketStream14FillRecvbufferEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i5 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 72 | 0;
 i2 = i1 - (HEAP32[i7 >> 2] | 0) | 0;
 if (!i2) if (!(HEAP8[i5 + 17 >> 0] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i1 - (HEAP32[i7 >> 2] | 0) | 0;
 i1 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 i4 = i5 + 80 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i2 + 24 | 0;
 i11 = HEAP32[i2 + 16 >> 2] | 0;
 i10 = i11 - (HEAP32[i3 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = i11 + -1 & HEAP32[i3 >> 2];
 i11 = i11 - i3 | 0;
 i10 = i11 >>> 0 < i10 >>> 0 ? i11 : i10;
 i1 = i10 >>> 0 < i1 >>> 0 ? i10 : i1;
 if (!i1) {
  i11 = 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 i1 = __ZN6Socket4RecvEPvjP12RecvUserData(i5, (HEAP32[i2 >> 2] | 0) + i3 | 0, i1, 0) | 0;
 do if (i1 | 0) {
  if ((i1 | 0) < 0) {
   if (__ZN6Socket15WouldBlockErrorEv() | 0) i1 = 0; else break;
   STACKTOP = i9;
   return i1 | 0;
  }
  i11 = (HEAP32[i4 >> 2] | 0) + 24 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
  i11 = HEAP32[i4 >> 2] | 0;
  if (((HEAP32[i11 + 16 >> 2] | 0) - (HEAP32[i11 + 24 >> 2] | 0) | 0) != (0 - (HEAP32[i11 + 20 >> 2] | 0) | 0)) {
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
  if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
   i11 = 1;
   STACKTOP = i9;
   return i11 | 0;
  }
  i7 = __Znwj(32) | 0;
  i3 = i5 + 60 | 0;
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i11 = i5 + 68 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i10 = i8;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 + 4 >> 2] = i6;
  HEAP32[i7 + 20 >> 2] = 0;
  HEAP32[i7 + 24 >> 2] = 0;
  i5 = 1 << 31 - (Math_clz32((i5 << 1) + -1 | 0) | 0);
  i10 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = i5;
  HEAP32[i7 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i8, 0, gb + 584872 | 0, 112) | 0;
  HEAP8[i7 + 4 >> 0] = 1;
  i5 = i8;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i7 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i7 + 28 >> 2] = 0;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] = i7;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 >> 2] | 0);
  i11 = 1;
  STACKTOP = i9;
  return i11 | 0;
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0);
 i11 = 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN15DirectorManager18FinishConstructionEP12Il2CppObjectR9HPlayable(i1, i8, i3) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 456 | 0;
 i1 = i7 + 448 | 0;
 i4 = i7 + 248 | 0;
 i5 = i7 + 8 | 0;
 i2 = i7;
 if (!i8) {
  STACKTOP = i7;
  return i8 | 0;
 }
 if (__Z28scripting_class_is_valuetypeP11Il2CppClass(__Z26scripting_object_get_classP12Il2CppObject(i8) | 0) | 0) {
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i8 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 } else {
  __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i1, __Z26scripting_object_get_classP12Il2CppObject(i8) | 0, gb + 582824 | 0, 1);
  if (HEAP32[i1 >> 2] | 0) {
   __ZN18ScriptingArgumentsC2Ev(i4);
   __ZN18ScriptingArguments6AddIntEi(i4, HEAP32[i3 + 4 >> 2] | 0);
   __ZN18ScriptingArguments9AddIntPtrEPv(i4, HEAP32[i3 >> 2] | 0);
   i9 = i1;
   i3 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = i2;
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i8, i6);
   HEAP32[i6 >> 2] = 0;
   i1 = i5;
   i2 = i4;
   i3 = i1 + 96 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP32[i5 + 96 >> 2] = HEAP32[i4 + 96 >> 2];
   HEAP32[i5 + 100 >> 2] = HEAP32[i4 + 100 >> 2];
   HEAP32[i5 + 104 >> 2] = HEAP32[i4 + 104 >> 2];
   HEAP32[i5 + 108 >> 2] = HEAP32[i4 + 108 >> 2];
   HEAP32[i5 + 112 >> 2] = HEAP32[i4 + 112 >> 2];
   HEAP32[i5 + 116 >> 2] = HEAP32[i4 + 116 >> 2];
   HEAP32[i5 + 120 >> 2] = HEAP32[i4 + 120 >> 2];
   HEAP32[i5 + 124 >> 2] = HEAP32[i4 + 124 >> 2];
   HEAP32[i5 + 128 >> 2] = HEAP32[i4 + 128 >> 2];
   HEAP32[i5 + 132 >> 2] = HEAP32[i4 + 132 >> 2];
   HEAP32[i5 + 136 >> 2] = HEAP32[i4 + 136 >> 2];
   HEAP32[i5 + 140 >> 2] = HEAP32[i4 + 140 >> 2];
   i1 = i5 + 144 | 0;
   i2 = i4 + 144 | 0;
   i3 = i1 + 52 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i6, 0) | 0;
  }
 }
 HEAP32[i6 >> 2] = 0;
 __Z43scripting_object_invoke_default_constructorP12Il2CppObjectPP15Il2CppException(i8, i6);
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNK26AnimatorOverrideController28HasMultiThreadedStateMachineEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 80 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN6Skybox16RenderSingleFaceEP8Materiali(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 48 | 0;
 i7 = i9;
 i8 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[gb + 1114336 >> 2] | 0;
 do if (!i1) i2 = 5; else if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
  i2 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 236 >> 2] | 0, i2 | 0, HEAP32[gb + 1114336 >> 2] | 0);
  HEAP32[gb + 1114336 >> 2] = 0;
  i2 = 5;
  break;
 } else {
  i1 = HEAP32[gb + 1114336 >> 2] | 0;
  if (!i1) {
   i2 = 5;
   break;
  } else break;
 } while (0);
 if ((i2 | 0) == 5) {
  i3 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 220 >> 2] | 0, i3 | 0) | 0;
  HEAP32[gb + 1114336 >> 2] = i1;
  mftCall_viiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 224 >> 2] | 0, i3 | 0, i1 | 0, 0, 0, 864, gb + 1113472 | 0, 0);
  i1 = HEAP32[gb + 1114336 >> 2] | 0;
 }
 i2 = __ZN8Material9GetShaderEv(i4) | 0;
 i3 = __ZNK6Shader23GetActiveSubShaderIndexEv(i2) | 0;
 i3 = HEAP32[(HEAP32[HEAP32[(HEAP32[HEAP32[i2 + 32 >> 2] >> 2] | 0) + (i3 << 2) >> 2] >> 2] | 0) + (i5 << 2) >> 2] | 0;
 if (HEAP32[i3 + 744 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i4 = __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib(i4, i3, HEAP32[gb + 1166248 >> 2] | 0, i2, i5, 1) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i5 * 6;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 6;
 i2 = i7;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = 24;
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 i11 = HEAP32[gb + 1113464 + 4 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7 + 40 | 0;
 HEAP32[i5 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i11, i10, 0) | 0;
 __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj(i8, i7, i6, i10, i1);
 mftCall_viiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 244 >> 2] | 0, i8 | 0, 0, i2 | 0, HEAP32[i3 >> 2] | 0, i6 | 0, 1, HEAP32[i5 >> 2] | 0, i4 | 0);
 __Z15gpu_time_samplev();
 STACKTOP = i9;
 return;
}

function __ZN5physx7NpShape12setMaterialsEPKPNS_10PxMaterialEt(i3, i9, i7) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i6 = i3 + 32 | 0;
 i2 = i3 + 36 | 0;
 if (!(HEAP32[i2 >> 2] & 2)) i8 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i3 + 48 | 0) | 0; else i8 = HEAP16[(HEAP32[i3 + 40 >> 2] | 0) + 116 >> 1] | 0;
 i11 = i8 & 65535;
 i1 = i11 << 2;
 i10 = i1 >>> 0 > 1024;
 i12 = i13 + 4 | 0;
 HEAP8[i12 >> 0] = i10 & 1;
 if (i10) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i14 + 8 | 0, i1, gb + 689543 | 0, 487) | 0;
  HEAP32[i13 >> 2] = i1;
  i10 = i13;
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i11 << 2) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i13 >> 2] = i1;
  i10 = i13;
 }
 i4 = HEAP32[gb + 1457324 >> 2] | 0;
 do if (!(HEAP32[i2 >> 2] & 2)) {
  i2 = i3 + 48 | 0;
  i5 = __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i2) | 0;
  i2 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i2) | 0;
 } else {
  i3 = HEAP32[i3 + 40 >> 2] | 0;
  i2 = HEAP16[i3 + 116 >> 1] | 0;
  if (i2 << 16 >> 16 == 1) {
   i2 = 1;
   i5 = i3 + 112 | 0;
   break;
  } else {
   i5 = (HEAP32[(HEAP32[i6 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i3 + 112 >> 2] << 1) | 0;
   break;
  }
 } while (0);
 i2 = i2 & 65535;
 if ((i2 >>> 0 < i11 >>> 0 ? i2 : i11) | 0) {
  i4 = i4 + 52 | 0;
  i2 = i2 >>> 0 > i11 >>> 0 ? i11 : i2;
  i3 = 0;
  do {
   HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (HEAPU16[i5 + (i3 << 1) >> 1] << 2) >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 if (__ZN5physx3Scb5Shape12setMaterialsEPKPNS_10PxMaterialEt(i6, i9, i7) | 0) {
  if (i7 << 16 >> 16) {
   i1 = i7 & 65535;
   i2 = 0;
   do {
    __ZN5physx6shdfnd15atomicIncrementEPVi((HEAP32[i9 + (i2 << 2) >> 2] | 0) + 16 | 0) | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  if (i8 << 16 >> 16) {
   i2 = 0;
   do {
    i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i1 = i9 + 12 | 0;
    if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i9 + 16 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i11 | 0));
  }
 }
 if (!(HEAP8[i12 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 640 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i9 + 600 | 0;
 i5 = mftCall_ii(HEAP32[i1 + 8 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx32PxArticulationJointGeneratedInfoC2Ev(i9 + 300 | 0);
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  i2 = 0;
 } else {
  i1 = i2 + -1 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + (i1 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i4;
 }
 HEAP32[i6 >> 2] = gb + 780838;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = i6;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i4 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i4 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i3 = i8 + 4 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 i2 = HEAP32[i8 + 16 >> 2] | 0;
 __ZN5physx32PxArticulationJointGeneratedInfoC2Ev(i6);
 HEAP32[i7 >> 2] = i10;
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i7 + 8 >> 2] = i5;
 HEAP32[i7 + 12 >> 2] = i1;
 HEAP32[i7 + 16 >> 2] = i2;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEEEEjT_j(i6, i7, 0) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
 }
 STACKTOP = i9;
 return;
}

function __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i4 + 8 | 0;
 i5 = i8 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i8 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i4 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i4 + 10 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i4 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i3, i1, 1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i4 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i3, i1, 1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 479385 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 479385 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN9Animation19ValidateBoundCurvesEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 8 | 0;
 i7 = i14;
 i8 = i11;
 if ((HEAP16[gb + 1466548 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = i8;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466548 | 0, i6);
  i10 = gb + 1466548 | 0;
 } else i10 = 0;
 i12 = i11 + 84 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 96 | 0;
 i5 = HEAP32[i13 >> 2] | 0;
 i9 = i1 + (i5 * 24 | 0) | 0;
 L4 : do if (i5 | 0) {
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  while (1) {
   HEAP32[i7 >> 2] = HEAP32[i1 + 16 >> 2];
   if (!i2) {
    i3 = 0;
    i2 = 0;
   } else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i4 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[i2 + 32 >> 2] | 0;
     i3 = i4 + (i5 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
     i3 = HEAP32[i6 >> 2] | 0;
     i4 = HEAP32[i2 + 28 >> 2] | 0;
     i15 = HEAP32[gb + 1104264 >> 2] | 0;
     i3 = (i3 | 0) == -1 ? i4 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i4 + (i3 << 3) | 0;
     i4 = HEAP32[i15 + 28 >> 2] | 0;
     i5 = HEAP32[i15 + 32 >> 2] | 0;
     i2 = i15;
    }
    if ((i3 | 0) == (i4 + (i5 << 3) | 0)) i3 = 0; else i3 = HEAP32[i3 + 4 >> 2] | 0;
   }
   if ((i3 | 0) != (HEAP32[i1 + 12 >> 2] | 0)) break;
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i9 | 0)) break L4;
  }
  if ((HEAP16[gb + 1466560 + 6 >> 1] | 0) > -1) {
   HEAP32[i7 >> 2] = i8;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466560 | 0, i6);
   i1 = gb + 1466560 | 0;
  } else i1 = 0;
  if (HEAP32[i13 >> 2] | 0) {
   i2 = i11 + 100 | 0;
   if ((HEAP32[i2 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11 + 88 | 0);
    HEAP32[i12 >> 2] = 0;
   }
   HEAP32[i12 >> 2] = 0;
   HEAP32[i13 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   i15 = i11 + 252 | 0;
   HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | 1;
  }
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 } while (0);
 if (!i10) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i14;
 return;
}

function __ZN7mecanim12statemachine26CreateStateMachineConstantEPPNS0_13StateConstantEjjPPNS0_18TransitionConstantEjPPNS0_21SelectorStateConstantEjjRNS_6memory9AllocatorE(i17, i18, i15, i19, i20, i22, i23, i16, i3) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 i15 = i15 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i21 = 0;
 i21 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, 32, 4) | 0;
 i10 = i21 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i21 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i21 + 28 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i21 + 4 >> 2] = 0;
 HEAP32[i21 + 8 >> 2] = 0;
 HEAP32[i21 + 12 >> 2] = 0;
 i13 = i21 + 4 | 0;
 i14 = (i18 | 0) == 0;
 if (i14) i1 = 0; else {
  i2 = i18 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i18 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i6 = i13;
 HEAP32[i13 >> 2] = i1 | 0 ? i1 - i6 | 0 : 0;
 i8 = i21 + 12 | 0;
 i9 = (i20 | 0) == 0;
 if (i9) i1 = 0; else {
  i2 = i20 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i20 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i5 = i8;
 HEAP32[i8 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 i7 = (i23 | 0) == 0;
 if (i7) i1 = 0; else {
  i2 = i23 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i23 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i4 = i10;
 i3 = i1 | 0 ? i1 - i4 | 0 : 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i21 >> 2] = i18;
 HEAP32[i11 >> 2] = i15;
 HEAP32[i21 + 8 >> 2] = i20;
 HEAP32[i21 + 16 >> 2] = i23;
 HEAP32[i12 >> 2] = i16;
 if (!i14) {
  i2 = (HEAP32[i13 >> 2] | 0) + i6 | 0;
  i1 = 0;
  do {
   i16 = i2 + (i1 << 2) | 0;
   i15 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
   HEAP32[i16 >> 2] = i15 | 0 ? i15 - i16 | 0 : 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i18 | 0));
 }
 if (!i9) {
  i2 = (HEAP32[i8 >> 2] | 0) + i5 | 0;
  i1 = 0;
  do {
   i18 = i2 + (i1 << 2) | 0;
   i17 = HEAP32[i19 + (i1 << 2) >> 2] | 0;
   HEAP32[i18 >> 2] = i17 | 0 ? i17 - i18 | 0 : 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i20 | 0));
 }
 if (i7) return i21 | 0;
 i2 = i3 + i4 | 0;
 i1 = 0;
 do {
  i20 = i2 + (i1 << 2) | 0;
  i19 = HEAP32[i22 + (i1 << 2) >> 2] | 0;
  HEAP32[i20 >> 2] = i19 | 0 ? i19 - i20 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i23 | 0));
 return i21 | 0;
}

function __ZN5physx22PxcContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i5, i6, i2, i4, i13, i1, i18) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 var f3 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f16 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f11 = Math_fround(f16 - Math_fround(HEAPF32[i4 + 16 >> 2]));
 f17 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f17 - Math_fround(HEAPF32[i4 + 20 >> 2]));
 f15 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f7 = Math_fround(f15 - Math_fround(HEAPF32[i4 + 24 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f12 * f12)) + Math_fround(f7 * f7));
 f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f14 = Math_fround(f9 + f8);
 f10 = Math_fround(f14 + Math_fround(HEAPF32[i13 >> 2]));
 if (!(f3 < Math_fround(f10 * f10))) {
  i18 = 0;
  return i18 | 0;
 }
 f10 = Math_fround(Math_sqrt(Math_fround(f3)));
 if (!(f10 <= Math_fround(9.99999974e-06))) {
  f3 = Math_fround(Math_fround(1.0) / f10);
  f11 = Math_fround(f11 * f3);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  f12 = Math_fround(f12 * f3);
  i5 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
  f12 = Math_fround(f7 * f3);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i4 = 0;
  i5 = 0;
  i6 = 1065353216;
 }
 f3 = Math_fround(Math_fround(Math_fround(f10 + f9) - f8) * Math_fround(-.5));
 i1 = i18 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i18 = 1;
  return i18 | 0;
 }
 f14 = Math_fround(f10 - f14);
 f15 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3) + f15);
 f17 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3) + f17);
 f16 = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3) + f16);
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i18 + (i2 << 6) >> 2] = i6;
 HEAP32[i18 + (i2 << 6) + 4 >> 2] = i5;
 HEAP32[i18 + (i2 << 6) + 8 >> 2] = i4;
 HEAPF32[i18 + (i2 << 6) + 16 >> 2] = f16;
 HEAPF32[i18 + (i2 << 6) + 20 >> 2] = f17;
 HEAPF32[i18 + (i2 << 6) + 24 >> 2] = f15;
 HEAPF32[i18 + (i2 << 6) + 12 >> 2] = f14;
 HEAP32[i18 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i18 + (i2 << 6) + 52 >> 2] = -1;
 i18 = 1;
 return i18 | 0;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = ((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) / 108 | 0;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j(i3, HEAP32[i2 >> 2] | 0);
 i8 = HEAP32[i1 >> 2] | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 434600 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN9InputAxis8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 108 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 434600 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN9InputAxis8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 108 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN14ParticleSystem13AwakeFromLoadE17AwakeFromLoadMode(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, f9 = f0, d10 = 0.0;
 if ((i1 | 0) == 16) return;
 i7 = i8 + 44 | 0;
 i6 = i8 + 36 | 0;
 __ZN13InitialModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(HEAP32[i7 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0);
 __ZN11ShapeModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i8 + 48 | 0, i8, HEAP32[i6 >> 2] | 0);
 __ZN15CollisionModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(HEAP32[i8 + 904 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0);
 __ZN12LightsModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(HEAP32[i8 + 920 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0);
 __ZN11ForceModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(HEAP32[i8 + 876 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0);
 __ZN11NoiseModule13AwakeFromLoadEv(HEAP32[i8 + 888 >> 2] | 0);
 i2 = i8 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((i1 | 0) == 0 | (__ZNK10GameObject8IsActiveEv(i3) | 0) ^ 1) return;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0;
 i2 = i8 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i8, i1, i3 + 52 | 0, i3 + 244 | 0, i3 + 304 | 0, i3 + 316 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i3 + 52 | 0, i3 + 180 | 0) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i3 + 392 >> 2] = Math_fround(0.0);
 HEAP8[i3 + 26 >> 0] = 0;
 HEAP8[i3 + 28 >> 0] = 0;
 HEAP8[i3 + 29 >> 0] = 0;
 if (__Z14IsWorldPlayingv() | 0) if (HEAP8[(HEAP32[i6 >> 2] | 0) + 279 >> 0] | 0) __ZN14ParticleSystem4PlayEb(i8, 1);
 if (!(HEAP32[(HEAP32[i8 + 32 >> 2] | 0) + 12 >> 2] | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i1 + 30 >> 0] | 0) {
   d5 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
   i1 = HEAP32[i2 >> 2] | 0;
   d4 = +HEAPF64[i1 + 40 >> 3];
   i2 = HEAP32[i6 >> 2] | 0;
   if (!(HEAP8[i2 + 277 >> 0] | 0)) {
    d10 = d5 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
    f9 = Math_fround(HEAPF32[i2 + 264 >> 2]);
    if (d10 > +Math_fround(f9 + Math_fround(HEAPF32[(HEAP32[i7 >> 2] | 0) + 88 >> 2]))) return;
   }
   if (HEAP8[i1 + 13 >> 0] | 0) if (d5 - d4 > +Math_fround(HEAPF32[(HEAP32[i7 >> 2] | 0) + 88 >> 2])) return;
  }
  if ((HEAP32[i1 + 8 >> 2] | 0) != 1) return;
 }
 __ZN14ParticleSystem12AddToManagerEv(i8);
 return;
}

function _UNITY_png_icc_set_sRGB(i18, i19, i20, i1) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i3 = (HEAPU8[i20 + 85 >> 0] | 0) << 16 | (HEAPU8[i20 + 84 >> 0] | 0) << 24 | (HEAPU8[i20 + 86 >> 0] | 0) << 8 | (HEAPU8[i20 + 87 >> 0] | 0);
 i4 = i20 + 88 | 0;
 i5 = i20 + 89 | 0;
 i6 = i20 + 90 | 0;
 i7 = i20 + 91 | 0;
 i8 = i20 + 92 | 0;
 i9 = i20 + 93 | 0;
 i10 = i20 + 94 | 0;
 i11 = i20 + 95 | 0;
 i12 = i20 + 96 | 0;
 i13 = i20 + 97 | 0;
 i14 = i20 + 98 | 0;
 i15 = i20 + 99 | 0;
 i17 = 0;
 while (1) {
  if ((i3 | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 12 >> 2] | 0)) if (((HEAPU8[i5 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i6 >> 0] | 0) << 8 | (HEAPU8[i7 >> 0] | 0) | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 16 >> 2] | 0)) if (((HEAPU8[i9 >> 0] | 0) << 16 | (HEAPU8[i8 >> 0] | 0) << 24 | (HEAPU8[i10 >> 0] | 0) << 8 | (HEAPU8[i11 >> 0] | 0) | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 20 >> 2] | 0)) if (((HEAPU8[i13 >> 0] | 0) << 16 | (HEAPU8[i12 >> 0] | 0) << 24 | (HEAPU8[i14 >> 0] | 0) << 8 | (HEAPU8[i15 >> 0] | 0) | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 24 >> 2] | 0)) break;
  i2 = i17 + 1 | 0;
  if (i2 >>> 0 < 7) i17 = i2; else {
   i16 = 19;
   break;
  }
 }
 if ((i16 | 0) == 19) return;
 i2 = (HEAPU8[i20 + 1 >> 0] | 0) << 16 | (HEAPU8[i20 >> 0] | 0) << 24 | (HEAPU8[i20 + 2 >> 0] | 0) << 8 | (HEAPU8[i20 + 3 >> 0] | 0);
 if ((i2 | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 8 >> 2] | 0)) {
  i3 = i20 + 64 | 0;
  i4 = i20 + 65 | 0;
  i5 = i20 + 66 | 0;
  i6 = i20 + 67 | 0;
  if (((HEAPU8[i4 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i6 >> 0] | 0) | 0) == (HEAPU16[gb + 14444 + (i17 << 5) + 30 >> 1] | 0 | 0)) {
   if (!i1) i1 = _unity_z_adler32(_unity_z_adler32(0, 0, 0) | 0, i20, i2) | 0;
   if ((i1 | 0) == (HEAP32[gb + 14444 + (i17 << 5) >> 2] | 0)) {
    i20 = _unity_z_crc32(_unity_z_crc32(0, 0, 0) | 0, i20, i2) | 0;
    if ((i20 | 0) == (HEAP32[gb + 14444 + (i17 << 5) + 4 >> 2] | 0)) {
     if ((i17 + -5 | 0) >>> 0 < 2) _UNITY_png_chunk_report(i18, gb + 351779 | 0, 2); else if (i17 >>> 0 >= 4) _UNITY_png_chunk_report(i18, gb + 351808 | 0, 0);
     _UNITY_png_colorspace_set_sRGB(i18, i19, (HEAPU8[i4 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i6 >> 0] | 0)) | 0;
     return;
    }
   }
  }
 }
 _UNITY_png_chunk_report(i18, gb + 351851 | 0, 0);
 return;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb(i1, i9, i2, i3, i5) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 4 | 0;
 i4 = i10;
 L1 : do if (!(HEAP32[i2 + 4 >> 2] & 1)) {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  i1 = mftCall_iiiiii(i7 | 0, i1 | 0, i8 | 0, i2 | 0, i3 | 0, i5 & 1 | 0) | 0;
 } else {
  i1 = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
  HEAP32[i8 >> 2] = i1;
  __THREW__ = 0;
  i2 = invoke_iii(fb + 1145 | 0, i8 | 0, gb + 1474596 | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  do if (i7 & 1) {
   i10 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = i10;
  } else {
   __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i5) mftCall_vii(HEAP32[i1 + 24 >> 2] | 0, i8 | 0, i2 | 0); else mftCall_vii(HEAP32[i1 + 28 >> 2] | 0, i8 | 0, i2 | 0);
   i6 = i8 + 8 + 3 | 0;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i7 = i8 + 4 | 0;
   i5 = i1 << 24 >> 24 < 0 ? i2 : i8;
   while (1) {
    i4 = i1 << 24 >> 24 < 0;
    if ((i5 | 0) == ((i4 ? i2 : i8) + ((i4 ? HEAP32[i7 >> 2] | 0 : i1 & 255) << 2) | 0)) {
     i2 = 9;
     break;
    }
    i1 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    if (i2 | 0) {
     i3 = i2 + 24 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) == (HEAP32[i2 + 28 >> 2] | 0)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (i4 & 1) {
       i2 = 18;
       break;
      }
     } else {
      HEAP32[i3 >> 2] = i4 + 4;
      HEAP32[i4 >> 2] = i1;
     }
     if ((i1 | 0) == -1) HEAP32[i9 >> 2] = 0;
    }
    i5 = i5 + 4 | 0;
    i1 = HEAP8[i6 >> 0] | 0;
    i2 = HEAP32[i8 >> 2] | 0;
   }
   if ((i2 | 0) == 9) {
    i1 = HEAP32[i9 >> 2] | 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    break L1;
   } else if ((i2 | 0) == 18) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    break;
   }
  } while (0);
  ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN6Camera13AwakeFromLoadE17AwakeFromLoadMode(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i8, i2);
 if (!(i2 & 1)) if (HEAP8[i8 + 33 >> 0] | 0) {
  __ZN13RenderManager12RemoveCameraEP6Camera(__Z16GetRenderManagerv() | 0, i8);
  __ZN13RenderManager9AddCameraEP6Camera(__Z16GetRenderManagerv() | 0, i8);
 }
 if (i2 & 4 | 0) {
  i2 = HEAP32[i8 + 28 >> 2] | 0;
  i6 = i2 + 40 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i5 = i2 + 28 | 0;
   i4 = 0;
   do {
    i2 = HEAP32[i5 >> 2] | 0;
    if (((HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i4 << 3) >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
     i2 = HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0;
     if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) __ZN13MonoBehaviour33AddImageEffectCallbacksToManagersEv(i2);
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
  }
 }
 i2 = i8 + 1086 | 0;
 HEAP32[i8 + 1076 >> 2] = 16843009;
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i7, i8, 1);
 f1 = Math_fround(HEAPF32[i8 + 864 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 868 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 872 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 876 >> 2]);
 f15 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f1 = Math_fround(f1 * f15);
 f14 = Math_fround(f14 * f15);
 f3 = Math_fround(f3 * f12);
 f11 = Math_fround(f11 * f12);
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f1 = Math_fround(f1 + f13);
 f3 = Math_fround(f3 + f10);
 f14 = Math_fround(f14 + f1);
 f11 = Math_fround(f11 + f3);
 f15 = Math_fround(f15 + f13);
 f12 = Math_fround(f12 + f10);
 f1 = Math_fround((f14 > f15 ? f15 : f14) - (f1 < f13 ? f13 : f1));
 f3 = Math_fround((f11 > f12 ? f12 : f11) - (f3 < f10 ? f10 : f3));
 i7 = f3 < Math_fround(0.0);
 f3 = i7 ? Math_fround(0.0) : f3;
 if (f3 != Math_fround(0.0)) {
  i7 = f1 < Math_fround(0.0);
  f1 = Math_fround((i7 ? Math_fround(0.0) : f1) / f3);
 } else f1 = Math_fround(1.0);
 HEAPF32[i8 + 1060 >> 2] = f1;
 HEAP8[i8 + 1077 >> 0] = 1;
 HEAP8[i8 + 1079 >> 0] = 1;
 HEAP8[i8 + 1078 >> 0] = 1;
 HEAP8[i2 >> 0] = 1;
 STACKTOP = i9;
 return;
}

function __Z59AssetBundleManifest_CUSTOM_INTERNAL_CALL_GetAssetBundleHashP12Il2CppObjectP12Il2CppStringR7Hash128(i2, i1, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 56 | 0;
 i3 = i12 + 48 | 0;
 i8 = i12;
 i9 = i12 + 32 | 0;
 i10 = i12 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK11ICallString6ToUTF8Ev(i10, i3);
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i11 = 7;
 } else if (i4 >>> 0 < 11) {
  i1 = i9 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i9; else {
   i2 = i9;
   i11 = 9;
  }
 } else i11 = 7;
 if ((i11 | 0) == 7) {
  i13 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i13 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i4;
  i1 = i9 + 11 | 0;
  i11 = 9;
 }
 if ((i11 | 0) == 9) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN19AssetBundleManifest18GetAssetBundleHashERK8UnityStr(i8, i5, i9);
 i5 = i8;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = i13;
 i8 = i8 + 8 | 0;
 i11 = HEAP32[i8 + 4 >> 2] | 0;
 i13 = i6 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i13 + 4 >> 2] = i11;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 STACKTOP = i12;
 return;
}

function _ps_dimension_set_mask_bits(i8, i13, i14, i5, i1, i11) {
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i10 = i8 + 12 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i2 | 0) HEAP32[(HEAP32[i8 + 20 >> 2] | 0) + (i2 << 4) + -16 + 12 >> 2] = i1;
 i7 = i2 + 1 | 0;
 i9 = i8 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 do if (i7 >>> 0 > i3 >>> 0) {
  HEAP32[i12 >> 2] = 0;
  i2 = i2 + 8 & -8;
  i1 = i8 + 20 | 0;
  i4 = _UNITY_ft_mem_realloc(i11, 16, i3, i2, HEAP32[i1 >> 2] | 0, i12) | 0;
  HEAP32[i1 >> 2] = i4;
  i1 = HEAP32[i12 >> 2] | 0;
  if (!i1) {
   HEAP32[i9 >> 2] = i2;
   i1 = i4;
   i6 = i4;
   i3 = i2;
   i2 = i4;
   break;
  }
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 } else {
  i2 = HEAP32[i8 + 20 >> 2] | 0;
  i1 = i2;
  i6 = i2;
 } while (0);
 i6 = i6 + (i7 << 4) + -16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i10 >> 2] = i7;
 if (!i7) {
  do if (!i3) {
   HEAP32[i12 >> 2] = 0;
   i1 = _UNITY_ft_mem_realloc(i11, 16, 0, 8, i2, i12) | 0;
   HEAP32[i8 + 20 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   if (!i2) {
    HEAP32[i9 >> 2] = 8;
    break;
   }
   i14 = i2;
   STACKTOP = i15;
   return i14 | 0;
  } while (0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i10 >> 2] = 1;
  i6 = i1;
 } else i6 = i1 + (i7 << 4) + -16 | 0;
 i4 = i6 + 4 | 0;
 i2 = ((HEAP32[i4 >> 2] | 0) + 7 | 0) >>> 3;
 i1 = (i5 + 7 | 0) >>> 3;
 HEAP32[i12 >> 2] = 0;
 do if (i1 >>> 0 > i2 >>> 0) {
  i3 = i1 + 7 & 1073741816;
  i10 = i6 + 8 | 0;
  i1 = _UNITY_ft_mem_realloc(i11, 1, i2, i3, HEAP32[i10 >> 2] | 0, i12) | 0;
  HEAP32[i10 >> 2] = i1;
  i2 = HEAP32[i12 >> 2] | 0;
  if (!i2) {
   HEAP32[i4 >> 2] = i3 << 3;
   break;
  }
  i14 = i2;
  STACKTOP = i15;
  return i14 | 0;
 } else i1 = HEAP32[i6 + 8 >> 2] | 0; while (0);
 HEAP32[i6 >> 2] = i5;
 if (!i5) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i8 = 128;
 i2 = 128 >>> (i14 & 7);
 i7 = i13 + (i14 >>> 3) | 0;
 while (1) {
  HEAP8[i1 >> 0] = (((HEAPU8[i7 >> 0] | 0) & i2 | 0) == 0 ? 0 : i8) | (HEAPU8[i1 >> 0] | 0) & (i8 ^ 255);
  i3 = i2 >> 1;
  i6 = (i3 | 0) == 0;
  i2 = i8 >> 1;
  i4 = (i2 | 0) == 0;
  i5 = i5 + -1 | 0;
  if (!i5) {
   i1 = 0;
   break;
  } else {
   i8 = i4 ? 128 : i2;
   i1 = i4 ? i1 + 1 | 0 : i1;
   i2 = i6 ? 128 : i3;
   i7 = i6 ? i7 + 1 | 0 : i7;
  }
 }
 STACKTOP = i15;
 return i1 | 0;
}

function __ZNSt3__210__stdinbufIcE9__getcharEb(i10, i14) {
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 16 | 0;
 i13 = i16 + 8 | 0;
 i8 = i16 + 4 | 0;
 i9 = i16;
 i3 = i10 + 52 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i10 + 44 >> 2] | 0;
  i1 = (i1 | 0) > 1 ? i1 : 1;
  i11 = i10 + 32 | 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) >= (i1 | 0)) {
    i15 = 8;
    break;
   }
   i3 = _getc(HEAP32[i11 >> 2] | 0) | 0;
   if ((i3 | 0) == -1) {
    i1 = -1;
    break;
   }
   HEAP8[i12 + i2 >> 0] = i3;
   i2 = i2 + 1 | 0;
  }
  if ((i15 | 0) == 8) {
   do if (!(HEAP8[i10 + 53 >> 0] | 0)) {
    i5 = i10 + 40 | 0;
    i6 = i10 + 36 | 0;
    i7 = i13 + 1 | 0;
    L11 : while (1) {
     i17 = HEAP32[i5 >> 2] | 0;
     i3 = i17;
     i2 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     i18 = HEAP32[i6 >> 2] | 0;
     i4 = i12 + i1 | 0;
     switch (mftCall_iiiiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0, i17 | 0, i12 | 0, i4 | 0, i8 | 0, i13 | 0, i7 | 0, i9 | 0) | 0) {
     case 3:
      {
       i15 = 15;
       break L11;
      }
     case 2:
      {
       i15 = 17;
       break L11;
      }
     case 1:
      break;
     default:
      break L11;
     }
     i18 = HEAP32[i5 >> 2] | 0;
     HEAP32[i18 >> 2] = i2;
     HEAP32[i18 + 4 >> 2] = i3;
     if ((i1 | 0) == 8) {
      i15 = 17;
      break;
     }
     i2 = _getc(HEAP32[i11 >> 2] | 0) | 0;
     if ((i2 | 0) == -1) {
      i15 = 17;
      break;
     }
     HEAP8[i4 >> 0] = i2;
     i1 = i1 + 1 | 0;
    }
    if ((i15 | 0) == 15) HEAP8[i13 >> 0] = HEAP8[i12 >> 0] | 0; else if ((i15 | 0) == 17) {
     i1 = -1;
     break;
    }
    i15 = 18;
   } else {
    HEAP8[i13 >> 0] = HEAP8[i12 >> 0] | 0;
    i15 = 18;
   } while (0);
   L21 : do if ((i15 | 0) == 18) {
    if (i14) {
     i1 = HEAP8[i13 >> 0] | 0;
     HEAP32[i10 + 48 >> 2] = i1 & 255;
    } else {
     while (1) {
      if ((i1 | 0) <= 0) break;
      i1 = i1 + -1 | 0;
      if ((_ungetc(HEAPU8[i12 + i1 >> 0] | 0, HEAP32[i11 >> 2] | 0) | 0) == -1) {
       i1 = -1;
       break L21;
      }
     }
     i1 = HEAP8[i13 >> 0] | 0;
    }
    i1 = i1 & 255;
   } while (0);
  }
 } else {
  i2 = i10 + 48 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i14) {
   HEAP32[i2 >> 2] = -1;
   HEAP8[i3 >> 0] = 0;
  }
 }
 STACKTOP = i16;
 return i1 | 0;
}

function __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i4 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i8, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i9, 0); else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) {
  i5 = HEAP32[i3 + 24 >> 2] | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
  i4 = (i2 | 0) / 88 | 0;
  i3 = i5 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) {
   HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i4) | 0;
   HEAP32[i3 >> 2] = i4;
  }
  if (i2 | 0) {
   i1 = 0;
   do {
    i3 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i5 >> 2] | 0, i1) | 0;
    __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i6, (HEAP32[i9 >> 2] | 0) + (i1 * 88 | 0) | 0, i3);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i7 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function _cf2_glyphpath_computeOffset(i8, i4, i5, i1, i2, i9, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i3 = i1 - i4 | 0;
 i1 = i2 - i5 | 0;
 i6 = (HEAP8[(HEAP32[i8 >> 2] | 0) + 192 >> 0] | 0) == 0;
 i7 = i6 ? i3 : 0 - i3 | 0;
 i6 = i6 ? i1 : 0 - i1 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 if (!(HEAP8[i8 + 11666 >> 0] | 0)) return;
 i5 = (Math_imul(i1 >> 16, i4 >> 16) | 0) - (Math_imul(i3 >> 16, i5 >> 16) | 0) | 0;
 i1 = (HEAP32[i8 + 4 >> 2] | 0) + 16 | 0;
 HEAP32[i1 >> 2] = i5 + (HEAP32[i1 >> 2] | 0);
 i1 = (i6 | 0) > -1;
 if ((i7 | 0) > -1) if (i1) {
  if ((i7 | 0) > (i6 << 1 | 0)) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   return;
  }
  i1 = HEAP32[i8 + 11688 >> 2] | 0;
  if ((i6 | 0) > (i7 << 1 | 0)) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2];
   return;
  } else {
   HEAP32[i9 >> 2] = _UNITY_FT_MulFix(45875, i1) | 0;
   HEAP32[i10 >> 2] = _UNITY_FT_MulFix(19661, HEAP32[i8 + 11692 >> 2] | 0) | 0;
   return;
  }
 } else {
  if ((i7 | 0) > (Math_imul(i6, -2) | 0)) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   return;
  }
  i1 = HEAP32[i8 + 11688 >> 2] | 0;
  if ((i7 << 1 | 0) < (0 - i6 | 0)) {
   HEAP32[i9 >> 2] = 0 - i1;
   HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2];
   return;
  } else {
   HEAP32[i9 >> 2] = _UNITY_FT_MulFix(-45874, i1) | 0;
   HEAP32[i10 >> 2] = _UNITY_FT_MulFix(19661, HEAP32[i8 + 11692 >> 2] | 0) | 0;
   return;
  }
 } else {
  i2 = 0 - i7 | 0;
  if (i1) {
   if ((i6 << 1 | 0) < (i2 | 0)) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2] << 1;
    return;
   }
   i7 = (i6 | 0) > (Math_imul(i7, -2) | 0);
   i1 = HEAP32[i8 + 11688 >> 2] | 0;
   if (i7) {
    HEAP32[i9 >> 2] = i1;
    HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2];
    return;
   } else {
    HEAP32[i9 >> 2] = _UNITY_FT_MulFix(45875, i1) | 0;
    HEAP32[i10 >> 2] = _UNITY_FT_MulFix(111411, HEAP32[i8 + 11692 >> 2] | 0) | 0;
    return;
   }
  } else {
   if ((Math_imul(i6, -2) | 0) < (i2 | 0)) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2] << 1;
    return;
   }
   i7 = (Math_imul(i7, -2) | 0) < (0 - i6 | 0);
   i1 = HEAP32[i8 + 11688 >> 2] | 0;
   if (i7) {
    HEAP32[i9 >> 2] = 0 - i1;
    HEAP32[i10 >> 2] = HEAP32[i8 + 11692 >> 2];
    return;
   } else {
    HEAP32[i9 >> 2] = _UNITY_FT_MulFix(-45874, i1) | 0;
    HEAP32[i10 >> 2] = _UNITY_FT_MulFix(111411, HEAP32[i8 + 11692 >> 2] | 0) | 0;
    return;
   }
  }
 }
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5ungetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] & -3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i2 = 11; else {
  __THREW__ = 0;
  invoke_viii(fb + 1038 | 0, i2 | 0, i4 | 0, 1);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i2 = 11; else {
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
   i3 = i4 + i1 | 0;
   do if (!(HEAP8[i2 >> 0] | 0)) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 4 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) i2 = 12; else i2 = 17;
   } else {
    i3 = HEAP32[i3 + 24 >> 2] | 0;
    if (i3) {
     i1 = i3 + 12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((HEAP32[i3 + 8 >> 2] | 0) == (i2 | 0)) {
      __THREW__ = 0;
      i1 = invoke_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, -1) | 0;
      i3 = __THREW__;
      __THREW__ = 0;
      if (i3 & 1) {
       i2 = 12;
       break;
      }
     } else {
      i3 = i2 + -4 | 0;
      HEAP32[i1 >> 2] = i3;
      i1 = HEAP32[i3 >> 2] | 0;
     }
     if ((i1 | 0) != -1) {
      i2 = 17;
      break;
     }
     i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
    }
    i3 = i4 + i1 | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) i2 = 12; else i2 = 17;
   } while (0);
   if ((i2 | 0) == 12) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i2 = 13;
    break;
   } else if ((i2 | 0) == 17) break;
  }
 } while (0);
 if ((i2 | 0) == 11) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = 13;
 }
 do if ((i2 | 0) == 13) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (!(i3 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN9dtNavMesh15connectIntLinksEP10dtMeshTile(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 20 >> 2] | 0;
 i1 = i17 << 2;
 i2 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i1 | 0) | 0;
 i18 = i3 + 12 | 0;
 HEAP32[i18 >> 2] = i2;
 i4 = (i17 | 0) > 0;
 if (i4) _memset(i2 | 0, -1, i1 | 0) | 0;
 i14 = (i3 - (HEAP32[i5 + 20 >> 2] | 0) | 0) / 56 | 0;
 i15 = _bitshift64Shl(HEAP32[i3 + 4 >> 2] | 0, 0, 48) | 0;
 i16 = getTempRet0() | 0;
 i14 = _bitshift64Shl(i14 | 0, 0, 20) | 0;
 i15 = i14 | i15;
 i16 = getTempRet0() | 0 | i16;
 if (!i4) return;
 i12 = i3 + 16 | 0;
 i13 = i5 + 28 | 0;
 i14 = i5 + 32 | 0;
 i10 = i5 + 36 | 0;
 i9 = 0;
 do {
  i11 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP8[i11 + (i9 << 5) + 28 >> 0] | 0;
  if (i1 << 24 >> 24) {
   i7 = i1 & 255;
   do {
    i8 = i7;
    i7 = i7 + -1 | 0;
    i6 = i11 + (i9 << 5) + 12 + (i7 << 1) | 0;
    i2 = HEAP16[i6 >> 1] | 0;
    do if (i2 << 16 >> 16 >= 1) {
     i1 = HEAP32[i13 >> 2] | 0;
     if ((i1 | 0) == -1) {
      i5 = HEAP32[i14 >> 2] | 0;
      i2 = (i5 | 0) == 0 ? 4 : i5 << 1;
      if (i5 >>> 0 >= i2 >>> 0) break;
      i4 = mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, HEAP32[i10 >> 2] | 0, i2 << 4 | 0) | 0;
      if (!i4) i1 = HEAP32[i13 >> 2] | 0; else {
       HEAP32[i10 >> 2] = i4;
       i1 = HEAP32[i14 >> 2] | 0;
       i5 = i2 + -1 | 0;
       if (i1 >>> 0 < i5 >>> 0) {
        i3 = i1;
        do {
         i19 = i3;
         i3 = i3 + 1 | 0;
         HEAP32[i4 + (i19 << 4) + 8 >> 2] = i3;
        } while ((i3 | 0) != (i5 | 0));
       }
       HEAP32[i4 + (i5 << 4) + 8 >> 2] = -1;
       HEAP32[i13 >> 2] = i1;
       HEAP32[i14 >> 2] = i2;
      }
      if ((i1 | 0) == -1) break;
      i2 = HEAP16[i6 >> 1] | 0;
     }
     i19 = HEAP32[i10 >> 2] | 0;
     i6 = i19 + (i1 << 4) + 8 | 0;
     HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i6 >> 2] = 0;
     i5 = i19 + (i1 << 4) | 0;
     HEAP32[i5 >> 2] = i15 | (i2 & 65535) + -1;
     HEAP32[i5 + 4 >> 2] = i16;
     HEAP8[i19 + (i1 << 4) + 12 >> 0] = i7;
     HEAP8[i19 + (i1 << 4) + 13 >> 0] = -1;
     HEAP8[i19 + (i1 << 4) + 15 >> 0] = 0;
     HEAP8[i19 + (i1 << 4) + 14 >> 0] = 0;
     i19 = (HEAP32[i18 >> 2] | 0) + (i9 << 2) | 0;
     HEAP32[i6 >> 2] = HEAP32[i19 >> 2];
     HEAP32[i19 >> 2] = i1;
    } while (0);
   } while ((i8 | 0) > 1);
  }
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i17 | 0));
 return;
}

function __ZN9Rigidbody13AwakeFromLoadE17AwakeFromLoadMode(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i4 + 28 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 __ZN9Rigidbody6CreateEb(i4, i1);
 if (!(i5 & 1)) {
  __ZN9Rigidbody14SetIsKinematicEb(i4, (HEAP8[i4 + 84 >> 0] | 0) != 0);
  i3 = i4 + 68 | 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = f2 < Math_fround(1.00000001e-07);
  i10 = f2 > Math_fround(1.0e9);
  f9 = i10 ? Math_fround(1.0e9) : f2;
  HEAPF32[i3 >> 2] = i1 ? Math_fround(1.00000001e-07) : f9;
  if (!(HEAP8[i4 + 81 >> 0] | 0)) {
   i10 = HEAP32[i4 + 52 >> 2] | 0;
   mftCall_vif(HEAP32[(HEAP32[i10 >> 2] | 0) + 128 >> 2] | 0, i10 | 0, +f2);
  } else __ZN9Rigidbody22UpdateMassDistributionEv(i4);
  i1 = i4 + 56 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i10 = __Z12GetIVehiclesv() | 0;
   mftCall_viif(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i3 >> 2]));
  }
  f9 = Math_fround(HEAPF32[i4 + 72 >> 2]);
  i1 = i4 + 52 | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i10 >> 2] | 0) + 232 >> 2] | 0, i10 | 0, +f9);
  f9 = Math_fround(HEAPF32[i4 + 76 >> 2]);
  i10 = HEAP32[i1 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i10 >> 2] | 0) + 240 >> 2] | 0, i10 | 0, +f9);
  i10 = i4 + 83 | 0;
  i3 = HEAP8[i10 >> 0] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 2, i3 << 24 >> 24 == 0 | 0);
  HEAP8[i10 >> 0] = i3;
  __ZN9Rigidbody25SetCollisionDetectionModeEi(i4, HEAP32[i4 + 92 >> 2] | 0);
  __ZN9Rigidbody19SetDetectCollisionsEb(i4, (HEAP8[i4 + 100 >> 0] | 0) != 0);
 }
 __ZN9Rigidbody23UpdateInterpolationNodeEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) __ZN9Rigidbody22FetchPoseFromTransformEv(i4);
 if (!(HEAP8[i4 + 84 >> 0] | 0)) {
  i10 = i4 + 104 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -2;
 }
 if (!(i5 & 8)) {
  __ZN9Rigidbody16UpdateSortedBodyEv(i4);
  STACKTOP = i8;
  return;
 }
 i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i10, gb + 1105496 | 0, i6);
 __ZN9Rigidbody16UpdateSortedBodyEv(i4);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Gu12TriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx20InternalTriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i7 >> 2] = HEAP32[gb + 133732 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 133732 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 133732 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 133732 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 133732 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 133732 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 133732 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 133732 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754619;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 240;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754619;
 HEAP32[i5 + 4 >> 2] = gb + 752142;
 HEAP32[i5 + 8 >> 2] = 8;
 HEAP32[i5 + 12 >> 2] = 240;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 133764 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 133764 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 133764 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 133764 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 133764 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 133764 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 133764 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 133764 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 133796 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 133796 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 133796 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 133796 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 133796 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 133796 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 133796 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 133796 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN17BufferManagerGLES24UpdateLiveSetFromPendingEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i11 + 4 | 0;
 i13 = i11 + 8 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i5 = i3;
 i2 = i4;
 if ((i4 - i3 | 0) > 0) {
  i10 = 0;
  i1 = i2;
  i7 = i2;
  i6 = i5;
  i2 = i4;
  i4 = i5;
 } else return;
 L3 : while (1) {
  i9 = i10;
  i10 = i10 + 1 | 0;
  i8 = i3;
  while (1) {
   i4 = HEAP32[i4 + (i9 << 2) >> 2] | 0;
   i3 = HEAP32[i4 + 32 >> 2] | 0;
   i4 = HEAP32[i4 >> 2] | 0;
   if (i3 >>> 0 <= (HEAP32[i4 >> 2] | 0) >>> 0) if ((HEAP32[i4 + 160 >> 2] | 0) >>> 0 < i3 >>> 0) break;
   i3 = i6 + (i9 << 2) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i8 = i4;
   if ((i10 | 0) != (i2 - i6 >> 2 | 0)) {
    i1 = i7 + -4 | 0;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i8;
    i1 = HEAP32[i13 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = i1 + -4;
   i7 = HEAP32[i4 + 12 >> 2] | 0;
   i6 = i11 + 16 + (i7 * 12 | 0) | 0;
   i5 = HEAP32[i4 + 8 >> 2] | 0;
   i2 = i11 + 16 + (i7 * 12 | 0) + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   do if (!i1) {
    i4 = i2;
    i3 = i2;
   } else {
    while (1) if ((i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 10;
      break;
     } else i1 = i2;
    } else {
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 13;
      break;
     } else i1 = i2;
    }
    if ((i2 | 0) == 10) {
     i4 = i1;
     i3 = i1;
     break;
    } else if ((i2 | 0) == 13) {
     i4 = i1;
     break;
    }
   } while (0);
   i1 = __Znwj(24) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i2 + 4 >> 2] = i8;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i6 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 16 + (i7 * 12 | 0) + 4 >> 2] | 0, i1);
   i2 = i11 + 16 + (i7 * 12 | 0) + 8 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i1 = i3;
   i5 = i2;
   if ((i9 | 0) < (i2 - i3 >> 2 | 0)) {
    i4 = i1;
    i6 = i1;
    i7 = i5;
    i8 = i3;
    i1 = i5;
   } else {
    i2 = 19;
    break L3;
   }
  }
  if ((i10 | 0) >= (i2 - i8 >> 2 | 0)) {
   i2 = 19;
   break;
  } else {
   i3 = i8;
   i4 = i8;
  }
 }
 if ((i2 | 0) == 19) return;
}

function _remquof(f1, f4, i12) {
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i3 >>> 23 & 255;
 i7 = i8 >>> 23 & 255;
 i13 = i3 >>> 31;
 i11 = i8 >>> 31;
 HEAP32[i12 >> 2] = 0;
 i2 = i8 & 2147483647;
 do if (!i2) i10 = 3; else if (i2 >>> 0 > 2139095040 | (i5 | 0) == 255) i10 = 3; else if (i3 & 2147483647) {
  if (!i5) {
   i2 = i3 << 9;
   if ((i2 | 0) > -1) {
    i5 = 0;
    do {
     i5 = i5 + -1 | 0;
     i2 = i2 << 1;
    } while ((i2 | 0) > -1);
   } else i5 = 0;
   i3 = i3 << 1 - i5;
  } else i3 = i3 & 8388607 | 8388608;
  if (!i7) {
   i7 = i8 << 9;
   if ((i7 | 0) > -1) {
    i2 = 0;
    do {
     i2 = i2 + -1 | 0;
     i7 = i7 << 1;
    } while ((i7 | 0) > -1);
   } else i2 = 0;
   i9 = i2;
   i7 = i8 << 1 - i2;
  } else {
   i9 = i7;
   i7 = i8 & 8388607 | 8388608;
  }
  if ((i5 | 0) < (i9 | 0)) if ((i5 + 1 | 0) == (i9 | 0)) {
   i2 = 0;
   i10 = 22;
  } else break; else {
   i10 = i3 - i7 | 0;
   i2 = i10 >>> 31 ^ 1;
   i3 = (i10 | 0) > -1 ? i10 : i3;
   if ((i5 | 0) > (i9 | 0)) {
    do {
     i3 = i3 << 1;
     i5 = i5 + -1 | 0;
     i10 = i3 - i7 | 0;
     i2 = (i10 >>> 31 | i2 << 1) ^ 1;
     i3 = (i10 | 0) > -1 ? i10 : i3;
    } while ((i5 | 0) > (i9 | 0));
    i5 = i9;
   }
   if (!i3) {
    i5 = -30;
    i3 = 0;
    i10 = 24;
   } else if (i3 >>> 0 < 8388608) {
    do {
     i3 = i3 << 1;
     i5 = i5 + -1 | 0;
    } while (i3 >>> 0 < 8388608);
    i10 = 22;
   } else i10 = 22;
  }
  if ((i10 | 0) == 22) if ((i5 | 0) > 0) {
   i7 = i5;
   i3 = i3 + -8388608 | i5 << 23;
  } else i10 = 24;
  if ((i10 | 0) == 24) {
   i7 = i5;
   i3 = i3 >>> (1 - i5 | 0);
  }
  f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f6 = Math_fround(-f4);
  f6 = (i11 | 0) == 0 ? f4 : f6;
  if ((i7 | 0) == (i9 | 0)) i10 = 29; else if ((i7 + 1 | 0) == (i9 | 0)) {
   f4 = Math_fround(f1 * Math_fround(2.0));
   if (f4 > f6) i10 = 29; else if (!((i2 & 1 | 0) == 0 | f4 != f6)) i10 = 29;
  }
  if ((i10 | 0) == 29) {
   f1 = Math_fround(f1 - f6);
   i2 = i2 + 1 | 0;
  }
  i9 = i2 & 2147483647;
  HEAP32[i12 >> 2] = (i13 | 0) != (i11 | 0) ? 0 - i9 | 0 : i9;
  f6 = Math_fround(-f1);
  f1 = i13 | 0 ? f6 : f1;
 } while (0);
 if ((i10 | 0) == 3) {
  f1 = Math_fround(f1 * f4);
  f1 = Math_fround(f1 / f1);
 }
 return Math_fround(f1);
}

function _decompress_data(i18, i19) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i21 = HEAP32[i18 + 392 >> 2] | 0;
 i22 = i18 + 284 | 0;
 i23 = (HEAP32[i22 >> 2] | 0) + -1 | 0;
 i4 = i18 + 124 | 0;
 i5 = i18 + 132 | 0;
 i6 = i18 + 400 | 0;
 i1 = i18 + 128 | 0;
 i20 = i18 + 136 | 0;
 while (1) {
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) >= (i3 | 0)) {
   if ((i2 | 0) != (i3 | 0)) break;
   if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i20 >> 2] | 0) >>> 0) break;
  }
  if (!(mftCall_ii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i18 | 0) | 0)) {
   i1 = 0;
   i7 = 21;
   break;
  }
 }
 if ((i7 | 0) == 21) return i1 | 0;
 i14 = i18 + 36 | 0;
 if ((HEAP32[i14 >> 2] | 0) > 0) {
  i15 = i18 + 4 | 0;
  i16 = i18 + 412 | 0;
  i12 = HEAP32[i18 + 196 >> 2] | 0;
  i13 = 0;
  while (1) {
   if (HEAP8[i12 + 48 >> 0] | 0) {
    i1 = i12 + 12 | 0;
    i17 = HEAP32[i1 >> 2] | 0;
    i17 = mftCall_iiiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 32 >> 2] | 0, i18 | 0, HEAP32[i21 + 76 + (i13 << 2) >> 2] | 0, Math_imul(i17, HEAP32[i20 >> 2] | 0) | 0, i17 | 0, 0) | 0;
    if ((HEAP32[i20 >> 2] | 0) >>> 0 < i23 >>> 0) i7 = HEAP32[i1 >> 2] | 0; else {
     i11 = HEAP32[i1 >> 2] | 0;
     i7 = ((HEAP32[i12 + 32 >> 2] | 0) >>> 0) % (i11 >>> 0) | 0;
     i7 = (i7 | 0) == 0 ? i11 : i7;
    }
    i9 = HEAP32[(HEAP32[i16 >> 2] | 0) + 4 + (i13 << 2) >> 2] | 0;
    if ((i7 | 0) > 0) {
     i10 = i12 + 28 | 0;
     i11 = i12 + 36 | 0;
     i6 = HEAP32[i19 + (i13 << 2) >> 2] | 0;
     i8 = 0;
     i1 = HEAP32[i10 >> 2] | 0;
     while (1) {
      if (!i1) {
       i2 = HEAP32[i11 >> 2] | 0;
       i1 = 0;
      } else {
       i3 = 0;
       i4 = HEAP32[i17 + (i8 << 2) >> 2] | 0;
       i5 = 0;
       while (1) {
        mftCall_viiiii(i9 | 0, i18 | 0, i12 | 0, i4 | 0, i6 | 0, i3 | 0);
        i2 = HEAP32[i11 >> 2] | 0;
        i5 = i5 + 1 | 0;
        i1 = HEAP32[i10 >> 2] | 0;
        if (i5 >>> 0 >= i1 >>> 0) break; else {
         i3 = i2 + i3 | 0;
         i4 = i4 + 128 | 0;
        }
       }
      }
      i8 = i8 + 1 | 0;
      if ((i8 | 0) == (i7 | 0)) break; else i6 = i6 + (i2 << 2) | 0;
     }
    }
   }
   i13 = i13 + 1 | 0;
   if ((i13 | 0) >= (HEAP32[i14 >> 2] | 0)) break; else i12 = i12 + 84 | 0;
  }
 }
 i23 = (HEAP32[i20 >> 2] | 0) + 1 | 0;
 HEAP32[i20 >> 2] = i23;
 i23 = i23 >>> 0 < (HEAP32[i22 >> 2] | 0) >>> 0 ? 3 : 4;
 return i23 | 0;
}

function __ZN5physx15PxCollectionExt6removeERNS_12PxCollectionEtPS1_(i9, i7, i4) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i5 = i11;
 HEAP32[i10 >> 2] = 0;
 i6 = i10 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i8 = i10 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0) | 0) {
  if (!i4) {
   i3 = 0;
   do {
    i1 = mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, i3 | 0) | 0;
    do if ((HEAP16[i1 + 4 >> 1] | 0) == i7 << 16 >> 16) {
     HEAP32[i5 >> 2] = i1;
     i2 = HEAP32[i6 >> 2] | 0;
     if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i1;
      HEAP32[i6 >> 2] = i2 + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) | 0;
      break;
     }
    } while (0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0) | 0) >>> 0);
  } else {
   i3 = 0;
   do {
    i1 = mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, i3 | 0) | 0;
    do if ((HEAP16[i1 + 4 >> 1] | 0) == i7 << 16 >> 16) {
     mftCall_viiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 0, 0);
     HEAP32[i5 >> 2] = i1;
     i2 = HEAP32[i6 >> 2] | 0;
     if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i1;
      HEAP32[i6 >> 2] = i2 + 1;
      break;
     } else {
      __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) | 0;
      break;
     }
    } while (0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0) | 0) >>> 0);
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i10 >> 2] | 0;
   i3 = 0;
   do {
    mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, HEAP32[i2 + (i3 << 2) >> 2] | 0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
 }
 i9 = HEAP32[i8 >> 2] | 0;
 if (!((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i11;
 return;
}

function __ZN19CharacterController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 88 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI7Hash128Lj8EEEEvRT_17TransferMetaFlags(i11, i3, i1) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = i10 + 8 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, HEAP32[i2 >> 2] | 0, i11 + 8 | 0);
 i8 = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] << 4) | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 455698 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 16 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 455698 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher26OnSessionContainerArchivedERNS0_16SessionContainerE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 i9 = i8 + 36 | 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i7 = i3 << 24 >> 24 < 0;
 i2 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
 i3 = i7 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i11 + 11 | 0;
 do if ((i9 | 0) != (i11 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i7 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 44 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 40 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 40 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return;
}

function __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow2P12Il2CppObjectRK10Matrix4x4fi(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i2 = i9;
 i1 = HEAP32[gb + 1188344 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i2);
    i2 = HEAP32[i8 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i4 = 9;
  }
  if ((i4 | 0) == 7) i4 = 9;
  if ((i4 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1188344 >> 2] | 0) | 0)) break;
  i4 = __Z12GetGfxDevicev() | 0;
  i1 = i8;
  i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (i1 | 0) {
   i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0;
   mftCall_vii(i10 | 0, i4 | 0, __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0);
  }
  i1 = HEAP32[gb + 1188348 >> 2] | 0;
  if (!i5) {
   i10 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
  }
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i2) {
   i10 = i5;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
  }
  __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(i1, i2, i6, i7);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, i8 | 0);
  STACKTOP = i9;
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 517821 | 0, 0, gb + 517579 | 0, 3809, 1, 0, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_(i13, i16, i1, i2, i4) {
 i13 = i13 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i14 = (i1 | 0) == 0;
 i12 = i14 ? i13 + 1228 | 0 : i1 + 4 | 0;
 i14 = HEAP32[(i14 ? i13 + 1196 | 0 : i1) >> 2] | 0;
 i5 = (i14 | 0) > 0;
 if (!i5) {
  i15 = 0;
  HEAP32[i16 >> 2] = i15;
  i16 = (i15 | 0) > 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i11 = HEAP32[i4 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
  i25 = HEAP32[i13 + 832 + (i4 << 4) >> 2] | 0;
  i24 = HEAP32[i13 + 832 + (i4 << 4) + 4 >> 2] | 0;
  i23 = HEAP32[i13 + 832 + (i4 << 4) + 8 >> 2] | 0;
  i22 = HEAP32[i13 + 832 + (i4 << 4) + 12 >> 2] | 0;
  f19 = (HEAP32[tempDoublePtr >> 2] = i7 & ~i25 | i6 & i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i13 + 480 + (i4 << 4) >> 2]));
  f18 = (HEAP32[tempDoublePtr >> 2] = i9 & ~i24 | i8 & i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f18 = Math_fround(f18 * Math_fround(HEAPF32[i13 + 480 + (i4 << 4) + 4 >> 2]));
  f20 = (HEAP32[tempDoublePtr >> 2] = i11 & ~i23 | i10 & i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i13 + 480 + (i4 << 4) + 8 >> 2]));
  f21 = (HEAP32[tempDoublePtr >> 2] = i2 & ~i22 | i3 & i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i15 + (i1 << 2) >> 2] = Math_fround(Math_fround(f21 * Math_fround(HEAPF32[i13 + 480 + (i4 << 4) + 12 >> 2])) + Math_fround(f20 + Math_fround(f19 + f18)));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i14 | 0));
 if (i5) {
  i1 = 0;
  i2 = 0;
 } else {
  i25 = 0;
  HEAP32[i16 >> 2] = i25;
  i25 = (i25 | 0) > 0;
  STACKTOP = i17;
  return i25 | 0;
 }
 do {
  if (Math_fround(HEAPF32[i15 + (i2 << 2) >> 2]) <= Math_fround(0.0)) {
   HEAP32[i16 + 4 + (i1 << 2) >> 2] = i2 & 255;
   i1 = i1 + 1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i14 | 0));
 HEAP32[i16 >> 2] = i1;
 i25 = (i1 | 0) > 0;
 STACKTOP = i17;
 return i25 | 0;
}

function __ZN21EnlightenSceneMapping8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 402495 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i6, i5, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 402507 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI26EnlightenSystemInformationLj8EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 402517 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI7Hash128Lj8EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 402529 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 402545 | 0, i3, i4, 1) | 0;
 if (!i1) {
  __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i5);
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i5);
 STACKTOP = i7;
 return;
}

function __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619424 | 0, gb + 1033990 | 0, i1, 0);
 __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 72 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619436 | 0, gb + 1033990 | 0, i5, 0);
 __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[i1 + 144 >> 2] | 0;
 f7 = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f8 = Math_fround(Math_fround(i5 >>> 16 & 255) / Math_fround(255.0));
 f9 = Math_fround(Math_fround(i5 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(i5 & 255) / Math_fround(255.0));
 HEAPF32[i6 + 4 >> 2] = f7;
 HEAPF32[i6 + 8 >> 2] = f8;
 HEAPF32[i6 + 12 >> 2] = f9;
 i5 = HEAP32[i1 + 148 >> 2] | 0;
 f9 = Math_fround(Math_fround((i5 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f8 = Math_fround(Math_fround(i5 >>> 16 & 255) / Math_fround(255.0));
 f7 = Math_fround(Math_fround(i5 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(i5 & 255) / Math_fround(255.0));
 HEAPF32[i4 + 4 >> 2] = f9;
 HEAPF32[i4 + 8 >> 2] = f8;
 HEAPF32[i4 + 12 >> 2] = f7;
 i5 = HEAP32[gb + 36980 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619448 | 0, i5, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619457 | 0, i5, i4, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619491 | 0, HEAP32[gb + 37240 >> 2] | 0, i1 + 152 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i16 = HEAP32[i6 + 12 >> 2] | 0;
 i17 = HEAP32[i6 + 4 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i17 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i17 + 148 >> 2]);
 f9 = Math_fround(HEAPF32[i17 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f15 = Math_fround(-f13);
 f11 = Math_fround(-f9);
 f8 = HEAP32[gb + 48 + (i1 << 4) >> 2] | 0 ? f14 : f8;
 f15 = HEAP32[gb + 48 + (i1 << 4) + 4 >> 2] | 0 ? f13 : f15;
 f11 = HEAP32[gb + 48 + (i1 << 4) + 8 >> 2] | 0 ? f9 : f11;
 f9 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f15 = Math_fround(f8 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f13 + f12);
 f11 = Math_fround(f14 + Math_fround(f15 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 152 >> 2]);
 f9 = Math_fround(-f15);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f9 = HEAP32[gb + 48 + (i2 << 4) >> 2] | 0 ? f15 : f9;
 f8 = HEAP32[gb + 48 + (i2 << 4) + 4 >> 2] | 0 ? f14 : f8;
 f7 = HEAP32[gb + 48 + (i2 << 4) + 8 >> 2] | 0 ? f13 : f7;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5Umbra9Matrix4x46invertERKNS_9Matrix4x3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f18 = Math_fround(Math_fround(f11 * f16) - Math_fround(f15 * f3));
 f14 = Math_fround(Math_fround(f15 * f12) - Math_fround(f9 * f16));
 f5 = Math_fround(Math_fround(f9 * f3) - Math_fround(f11 * f12));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f17 * f5) + Math_fround(Math_fround(f10 * f18) + Math_fround(f7 * f14))));
 f18 = Math_fround(f18 * f13);
 f14 = Math_fround(f14 * f13);
 f5 = Math_fround(f5 * f13);
 f10 = Math_fround(f10 * f13);
 f7 = Math_fround(f7 * f13);
 f13 = Math_fround(f17 * f13);
 f17 = Math_fround(Math_fround(f3 * f13) - Math_fround(f16 * f7));
 f19 = Math_fround(Math_fround(f15 * f7) - Math_fround(f11 * f13));
 HEAPF32[i1 >> 2] = f18;
 HEAPF32[i1 + 4 >> 2] = f17;
 HEAPF32[i1 + 8 >> 2] = f19;
 HEAPF32[i1 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f19) + Math_fround(Math_fround(f6 * f18) + Math_fround(f4 * f17))));
 f15 = Math_fround(Math_fround(f9 * f13) - Math_fround(f15 * f10));
 f13 = Math_fround(Math_fround(f16 * f10) - Math_fround(f12 * f13));
 HEAPF32[i1 + 16 >> 2] = f14;
 HEAPF32[i1 + 20 >> 2] = f13;
 HEAPF32[i1 + 24 >> 2] = f15;
 HEAPF32[i1 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f15) + Math_fround(Math_fround(f6 * f14) + Math_fround(f4 * f13))));
 f3 = Math_fround(Math_fround(f12 * f7) - Math_fround(f3 * f10));
 f7 = Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f7));
 HEAPF32[i1 + 32 >> 2] = f5;
 HEAPF32[i1 + 36 >> 2] = f3;
 HEAPF32[i1 + 40 >> 2] = f7;
 HEAPF32[i1 + 44 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f7) + Math_fround(Math_fround(f6 * f5) + Math_fround(f4 * f3))));
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 3) | 0, -1, i5 - i3 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i8 >> 0] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = i2 << 24 >> 24;
  i2 = i3 + 1 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
  } else {
   i7 = HEAP8[i3 >> 0] | 0;
   HEAP8[i8 >> 0] = i7;
   HEAP32[i9 >> 2] = i2;
   i2 = i7;
  }
  HEAP32[i1 + 4 >> 2] = i2 << 24 >> 24;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18AwakeFromLoadQueue17ExtractAllObjectsER13dynamic_arrayI4PPtrI6ObjectELj4EE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i1 = (HEAP32[i13 + 272 >> 2] | 0) + ((HEAP32[i13 + 252 >> 2] | 0) + ((HEAP32[i13 + 232 >> 2] | 0) + ((HEAP32[i13 + 212 >> 2] | 0) + ((HEAP32[i13 + 192 >> 2] | 0) + ((HEAP32[i13 + 172 >> 2] | 0) + ((HEAP32[i13 + 152 >> 2] | 0) + ((HEAP32[i13 + 132 >> 2] | 0) + ((HEAP32[i13 + 112 >> 2] | 0) + ((HEAP32[i13 + 92 >> 2] | 0) + ((HEAP32[i13 + 72 >> 2] | 0) + ((HEAP32[i13 + 52 >> 2] | 0) + ((HEAP32[i13 + 32 >> 2] | 0) + (HEAP32[i13 + 12 >> 2] | 0))))))))))))) | 0;
 i15 = i14 + 16 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i15 >> 2] = i1;
  i3 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i1 << 2, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
  i4 = i14;
  break;
 } else {
  i3 = i14 + 4 | 0;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 12 >> 2] << 2 | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i14 >> 2] = i4;
  i4 = i14;
  break;
 } else {
  i3 = i14 + 4 | 0;
  i4 = i14;
 } while (0);
 i6 = i14 + 12 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i13 + (i1 * 20 | 0) + 12 >> 2] | 0;
  i8 = HEAP32[i13 + (i1 * 20 | 0) >> 2] | 0;
  if ((i7 | 0) > 0) {
   i2 = 0;
   do {
    i9 = HEAP32[i6 >> 2] | 0;
    i10 = i9 + 1 | 0;
    i11 = HEAP32[i15 >> 2] | 0;
    i12 = i11 & 2147483647;
    do if (i10 >>> 0 > i12 >>> 0) {
     i5 = i11 << 1;
     i5 = (i5 | 0) == 0 ? 1 : i5;
     if (i12 >>> 0 < i5 >>> 0) if ((i11 | 0) > -1) {
      HEAP32[i15 >> 2] = i5;
      HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5 << 2, 4, i3, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i3, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i12 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
      HEAP32[i15 >> 2] = i5;
      HEAP32[i4 >> 2] = i12;
      break;
     }
    } while (0);
    HEAP32[i6 >> 2] = i10;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i9 << 2) >> 2] = HEAP32[i8 + (i2 * 12 | 0) + 4 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i7 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 14);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i7 >>> 0 > 7 ? 7 : i7;
 HEAP32[i2 >> 2] = i8;
 i1 = i2 + 4 | 0;
 i8 = (HEAP32[i1 >> 2] | 0) + (i8 * 12 | 0) | 0;
 do if (i7 | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 906560 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11);
     i1 = i1 + 12 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 906560 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function _jpeg_set_defaults(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if ((i1 | 0) != 100) {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
 }
 i1 = i4 + 68 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 + 4 >> 2] >> 2] | 0, i4 | 0, 0, 840) | 0;
 i1 = i4 + 56 | 0;
 HEAP32[i1 >> 2] = 8;
 _jpeg_set_linear_quality(i4, 50, 1);
 _add_huff_table(i4, i4 + 88 | 0, gb + 360942 | 0, gb + 360959 | 0);
 _add_huff_table(i4, i4 + 104 | 0, gb + 360971 | 0, gb + 360988 | 0);
 _add_huff_table(i4, i4 + 92 | 0, gb + 361150 | 0, gb + 361167 | 0);
 _add_huff_table(i4, i4 + 108 | 0, gb + 361179 | 0, gb + 361196 | 0);
 HEAP8[i4 + 120 >> 0] = 0;
 HEAP8[i4 + 136 >> 0] = 1;
 HEAP8[i4 + 152 >> 0] = 5;
 HEAP8[i4 + 121 >> 0] = 0;
 HEAP8[i4 + 137 >> 0] = 1;
 HEAP8[i4 + 153 >> 0] = 5;
 HEAP8[i4 + 122 >> 0] = 0;
 HEAP8[i4 + 138 >> 0] = 1;
 HEAP8[i4 + 154 >> 0] = 5;
 HEAP8[i4 + 123 >> 0] = 0;
 HEAP8[i4 + 139 >> 0] = 1;
 HEAP8[i4 + 155 >> 0] = 5;
 HEAP8[i4 + 124 >> 0] = 0;
 HEAP8[i4 + 140 >> 0] = 1;
 HEAP8[i4 + 156 >> 0] = 5;
 HEAP8[i4 + 125 >> 0] = 0;
 HEAP8[i4 + 141 >> 0] = 1;
 HEAP8[i4 + 157 >> 0] = 5;
 HEAP8[i4 + 126 >> 0] = 0;
 HEAP8[i4 + 142 >> 0] = 1;
 HEAP8[i4 + 158 >> 0] = 5;
 HEAP8[i4 + 127 >> 0] = 0;
 HEAP8[i4 + 143 >> 0] = 1;
 HEAP8[i4 + 159 >> 0] = 5;
 HEAP8[i4 + 128 >> 0] = 0;
 HEAP8[i4 + 144 >> 0] = 1;
 HEAP8[i4 + 160 >> 0] = 5;
 HEAP8[i4 + 129 >> 0] = 0;
 HEAP8[i4 + 145 >> 0] = 1;
 HEAP8[i4 + 161 >> 0] = 5;
 HEAP8[i4 + 130 >> 0] = 0;
 HEAP8[i4 + 146 >> 0] = 1;
 HEAP8[i4 + 162 >> 0] = 5;
 HEAP8[i4 + 131 >> 0] = 0;
 HEAP8[i4 + 147 >> 0] = 1;
 HEAP8[i4 + 163 >> 0] = 5;
 HEAP8[i4 + 132 >> 0] = 0;
 HEAP8[i4 + 148 >> 0] = 1;
 HEAP8[i4 + 164 >> 0] = 5;
 HEAP8[i4 + 133 >> 0] = 0;
 HEAP8[i4 + 149 >> 0] = 1;
 HEAP8[i4 + 165 >> 0] = 5;
 HEAP8[i4 + 134 >> 0] = 0;
 HEAP8[i4 + 150 >> 0] = 1;
 HEAP8[i4 + 166 >> 0] = 5;
 HEAP8[i4 + 135 >> 0] = 0;
 HEAP8[i4 + 151 >> 0] = 1;
 HEAP8[i4 + 167 >> 0] = 5;
 i2 = i4 + 168 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP16[i2 + 8 >> 1] = 0;
 HEAP8[i2 + 10 >> 0] = 0;
 HEAP8[i4 + 178 >> 0] = (HEAP32[i1 >> 2] | 0) > 8 & 1;
 i1 = i4 + 197 | 0;
 i2 = i4 + 179 | 0;
 i3 = i2 + 17 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i4 + 198 >> 0] = 1;
 HEAP8[i4 + 199 >> 0] = 0;
 HEAP16[i4 + 200 >> 1] = 1;
 HEAP16[i4 + 202 >> 1] = 1;
 _jpeg_default_colorspace(i4);
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj686ES2_RKNS_27PxVehicleDifferentialNWDataES6_EEKNS_40PxVehicleDifferentialNWDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 16 | 0;
 i7 = i8 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i9, 0);
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI8JSONRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i8, i10) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i14 + 8 | 0;
 i4 = i14;
 i13 = i14 + 16 | 0;
 i12 = gb + 64016 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i13 >> 2] = 0;
 i9 = i13 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i13 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i4 = HEAP32[i10 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) {
    i1 = 0;
    break;
   }
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) {
    i1 = 0;
    break;
   }
  }
  i15 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i15;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i15 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags(i3, i13, 0);
   HEAP8[i5 >> 0] = 1;
   i15 = i3 + 56 | 0;
   HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
  }
  HEAP32[i6 >> 2] = i7;
  HEAP32[i1 >> 2] = i2;
  i1 = HEAP32[i9 >> 2] | 0;
 } else i1 = 0; while (0);
 i2 = i8 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i8 >> 2] | 0; else {
  i15 = i10 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i15 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i15 >> 2] | 0, i1, HEAP32[i9 >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 }
 i15 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 64) | 0;
 _memcpy(i15 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i12);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i8, i1, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18 + 20 | 0;
 i15 = i18 + 16 | 0;
 i16 = i18;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = (i6 | HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2] | 120) & i1;
 if (!i10) {
  i12 = 0;
  i13 = i6;
 } else {
  i12 = HEAP32[i10 >> 2] | 0;
  i13 = i6;
 }
 i11 = i8 + 44 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i9 = i8 + 48 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = i7 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i19 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i19 << 4) | 0;
   i3 = i4;
   i20 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i20 >>> 0 < i12 >>> 0 | ((i20 | 0) == (i12 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i13 >>> 0 : 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i19 | 0 : i19;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i7 | 0)) {
  i20 = i1;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  if (!(i12 >>> 0 < i19 >>> 0 | ((i12 | 0) == (i19 | 0) ? i13 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0 : 0) | (i1 | 0) == (i7 | 0))) {
   i20 = HEAP32[i1 + 8 >> 2] | 0;
   STACKTOP = i18;
   return i20 | 0;
  }
 }
 i7 = __ZN16MeshVertexFormat23CreateVertexDeclarationEjPKS_(i8, i6, i10) | 0;
 i2 = i16;
 HEAP32[i2 >> 2] = i13;
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i16 + 8 >> 2] = i7;
 i2 = HEAP32[i11 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i20 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i20 << 4) | 0;
   i3 = i4;
   i19 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i19 >>> 0 < i12 >>> 0 | ((i19 | 0) == (i12 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i13 >>> 0 : 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i20 | 0 : i20;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i6 | 0)) i17 = 12; else {
  i20 = i1;
  i19 = HEAP32[i20 + 4 >> 2] | 0;
  if (i12 >>> 0 < i19 >>> 0 | ((i12 | 0) == (i19 | 0) ? i13 >>> 0 < (HEAP32[i20 >> 2] | 0) >>> 0 : 0)) i17 = 12;
 }
 if ((i17 | 0) == 12) {
  HEAP32[i15 >> 2] = i2;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_(i11, i14, i16) | 0;
 }
 i20 = i7;
 STACKTOP = i18;
 return i20 | 0;
}

function __ZN11AssetBundle9AssetInfo8TransferI14SafeBinaryReadEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 365604 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i5 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i5 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i5 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i5 = i7 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 365617 | 0, i4, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i4 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i4 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i4 >>> 0) i6 = 17; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i2 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 365629 | 0, HEAP32[gb + 37176 >> 2] | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_Pf(i12, i2, i3, i4, i23) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i23 = i23 | 0;
 var f1 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 f22 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f22 = Math_fround(f22 - f9);
 f21 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f21 = Math_fround(f21 - f10);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f13 - f5);
 f19 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f9);
 f20 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - f10);
 f15 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) - f5);
 f16 = Math_fround(HEAPF32[i12 + 16 >> 2]);
 f6 = Math_fround(f16 * f15);
 f17 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f20 * f17));
 f7 = Math_fround(f19 * f17);
 f18 = Math_fround(HEAPF32[i12 + 12 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f15 * f18));
 f8 = Math_fround(Math_fround(f20 * f18) - Math_fround(f19 * f16));
 f1 = Math_fround(Math_fround(f13 * f8) + Math_fround(Math_fround(f22 * f6) + Math_fround(f21 * f7)));
 i4 = f1 < Math_fround(0.0);
 f14 = Math_fround(-f1);
 if ((i4 ? f14 : f1) < Math_fround(9.99999997e-07)) {
  i23 = 0;
  return i23 | 0;
 }
 f14 = Math_fround(Math_fround(1.0) / f1);
 f11 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f9);
 f9 = Math_fround(Math_fround(HEAPF32[i12 + 4 >> 2]) - f10);
 f1 = Math_fround(Math_fround(HEAPF32[i12 + 8 >> 2]) - f5);
 f6 = Math_fround(f14 * Math_fround(Math_fround(Math_fround(f6 * f11) + Math_fround(f7 * f9)) + Math_fround(f8 * f1)));
 if (f6 < Math_fround(0.0) | f6 > Math_fround(1.0)) {
  i23 = 0;
  return i23 | 0;
 }
 f7 = Math_fround(Math_fround(f13 * f9) - Math_fround(f21 * f1));
 f5 = Math_fround(Math_fround(f22 * f1) - Math_fround(f13 * f11));
 f1 = Math_fround(Math_fround(f21 * f11) - Math_fround(f22 * f9));
 f22 = Math_fround(f14 * Math_fround(Math_fround(f17 * f1) + Math_fround(Math_fround(f18 * f7) + Math_fround(f16 * f5))));
 if (f22 < Math_fround(0.0) | Math_fround(f6 + f22) > Math_fround(1.0)) {
  i23 = 0;
  return i23 | 0;
 }
 f1 = Math_fround(f14 * Math_fround(Math_fround(f15 * f1) + Math_fround(Math_fround(f19 * f7) + Math_fround(f20 * f5))));
 if (f1 < Math_fround(0.0)) {
  i23 = 0;
  return i23 | 0;
 }
 HEAPF32[i23 >> 2] = f1;
 i23 = 1;
 return i23 | 0;
}

function __ZNK26AnimatorOverrideController16GetOverrideClipsEv(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i17;
 i12 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i2) | 0;
 HEAP32[i10 >> 2] = 0;
 i13 = i10 + 12 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i10 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 i15 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i15;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i1;
 i11 = i12 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i17;
  return;
 }
 HEAP32[i14 >> 2] = i1;
 HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
 if (!(HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i17;
  return;
 }
 i9 = i2 + 84 | 0;
 i8 = i2 + 96 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 do {
  i1 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + (i6 << 3) | 0;
  L9 : do if (!i6) i16 = 8; else {
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
     i16 = 8;
     break L9;
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  } while (0);
  do if ((i16 | 0) == 8) {
   i16 = 0;
   if ((i1 | 0) == (i3 | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    break;
   } else {
    i2 = __Z15return_overrideRK21AnimationClipOverride(i1) | 0;
    break;
   }
  } while (0);
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i14 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i15, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i15, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
    HEAP32[i14 >> 2] = i1;
    HEAP32[i10 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i13 >> 2] = i4;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) != ((HEAP32[i12 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) | 0));
 STACKTOP = i17;
 return;
}

function __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 8 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 96 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 460 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 464 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 465 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 352 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i5, i4 + 360 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i5, i4 + 416 | 0, 0);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 380 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 436 | 0, gb + 1034411 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 448 | 0, gb + 1034420 | 0, 0);
 i1 = i4 + 466 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN15ContactFilter2D13ShouldCollideEP9b2FixtureS1_(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = i12 + 4 | 0;
 i9 = HEAP32[i6 + 60 >> 2] | 0;
 i10 = HEAP32[i7 + 60 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 112 >> 2] | 0, i9 | 0) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 112 >> 2] | 0, i10 | 0) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i2 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 do if ((i4 | 0) != 2) {
  i5 = HEAP32[i2 >> 2] | 0;
  if ((i5 | 0) != 2) {
   i3 = HEAP32[i1 + 148 >> 2] | 0;
   i1 = HEAP32[i2 + 148 >> 2] | 0;
   if ((i4 | 0) == 1 & (i3 | 0) != 0) if (HEAP8[i3 + 50 >> 0] | 0) break;
   if ((i1 | 0) != 0 & (i5 | 0) == 1) if (HEAP8[i1 + 50 >> 0] | 0) break;
   if (!(HEAP8[i6 + 58 >> 0] | 0)) if (!(HEAP8[i7 + 58 >> 0] | 0)) {
    i11 = 0;
    STACKTOP = i12;
    return i11 | 0;
   }
  }
 } while (0);
 if (!(HEAP8[i9 + 53 >> 0] | 0)) i4 = 14; else {
  i1 = HEAP32[i9 + 156 >> 2] | 0;
  if (!i1) i4 = 14; else if (!(HEAP8[i1 + 56 >> 0] | 0)) i4 = 14; else i4 = 17;
 }
 do if ((i4 | 0) == 14) {
  if (HEAP8[i10 + 53 >> 0] | 0) {
   i1 = HEAP32[i10 + 156 >> 2] | 0;
   if (i1 | 0) if (HEAP8[i1 + 56 >> 0] | 0) {
    i4 = 17;
    break;
   }
  }
  i1 = HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + 48 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i10 + 28 >> 2] | 0) + 48 >> 2] | 0;
  i3 = __Z21GetManagerFromContexti(16) | 0;
  if ((i2 | 0) > 31 | ((i1 | 0) > 31 | (i2 | i1 | 0) < 0)) {
   HEAP32[i11 >> 2] = 31;
   __Z6FormatPKcz(i8, gb + 806509 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 805767 | 0, 427, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   break;
  }
  if (!(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (i1 << 2) >> 2] & 1 << i2)) {
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 } while (0);
 if ((i4 | 0) == 17) if (!(__ZN10Effector2D25CheckEffectorColliderMaskEP10Collider2DS1_(i9, i10) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i11 = (__ZNK16Physics2DManager18GetIgnoreCollisionEP10Collider2DS1_(HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0, i9, i10) | 0) ^ 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 120 | 0;
 i6 = i11 + 64 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __GLOBAL__sub_I_runtime_graphics3_lump_cpp() {
 var i1 = 0;
 HEAP32[gb + 1157936 >> 2] = 0;
 HEAP32[gb + 1157936 + 4 >> 2] = 0;
 HEAP32[gb + 1157936 + 8 >> 2] = 0;
 HEAP32[gb + 1157936 + 12 >> 2] = 0;
 HEAP32[gb + 1157936 + 16 >> 2] = 0;
 HEAP32[gb + 1157936 + 20 >> 2] = 0;
 HEAP32[gb + 1157936 + 24 >> 2] = 0;
 HEAP32[gb + 1157964 >> 2] = 0;
 HEAP32[gb + 1157964 + 4 >> 2] = 0;
 HEAP32[gb + 1157964 + 8 >> 2] = 1;
 HEAP32[gb + 1157964 + 12 >> 2] = 0;
 HEAP32[gb + 1157964 + 16 >> 2] = -1;
 HEAP32[gb + 1157964 + 20 >> 2] = 0;
 HEAP32[gb + 1157964 + 24 >> 2] = 0;
 HEAP32[gb + 1157964 + 28 >> 2] = 1;
 HEAP32[gb + 1157964 + 32 >> 2] = 0;
 HEAP32[gb + 1157964 + 36 >> 2] = -1;
 HEAP32[gb + 1157964 + 40 >> 2] = 0;
 HEAP32[gb + 1157964 + 44 >> 2] = 0;
 HEAP32[gb + 1157964 + 48 >> 2] = 1;
 HEAP32[gb + 1157964 + 52 >> 2] = 0;
 HEAP32[gb + 1157964 + 56 >> 2] = -1;
 HEAP32[gb + 1157964 + 60 >> 2] = 0;
 HEAP32[gb + 1157964 + 64 >> 2] = 0;
 HEAP32[gb + 1157964 + 68 >> 2] = 1;
 HEAP32[gb + 1157964 + 72 >> 2] = 0;
 HEAP32[gb + 1157964 + 76 >> 2] = -1;
 HEAP32[gb + 1157964 + 80 >> 2] = 0;
 HEAP32[gb + 1157964 + 84 >> 2] = 0;
 HEAP32[gb + 1157964 + 88 >> 2] = 1;
 HEAP32[gb + 1157964 + 92 >> 2] = 0;
 HEAP32[gb + 1157964 + 96 >> 2] = -1;
 HEAP32[gb + 1157964 + 100 >> 2] = 0;
 HEAP32[gb + 1157964 + 104 >> 2] = 0;
 HEAP32[gb + 1157964 + 108 >> 2] = 1;
 HEAP32[gb + 1157964 + 112 >> 2] = 0;
 HEAP32[gb + 1157964 + 116 >> 2] = -1;
 HEAP32[gb + 1157964 + 120 >> 2] = 0;
 HEAP32[gb + 1157964 + 124 >> 2] = 0;
 HEAP32[gb + 1157964 + 128 >> 2] = 1;
 HEAP32[gb + 1157964 + 132 >> 2] = 0;
 HEAP32[gb + 1157964 + 136 >> 2] = -1;
 HEAP32[gb + 1477028 >> 2] = 0;
 HEAP32[gb + 1477032 >> 2] = 1;
 HEAP32[gb + 1477036 >> 2] = 1812433254;
 HEAP32[gb + 1477040 >> 2] = 1900727103;
 HEAP32[gb + 1157924 >> 2] = gb + 1157924;
 HEAP32[gb + 1157924 + 4 >> 2] = gb + 1157924;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158104 | 0, gb + 402891 | 0, 8, 0);
 i1 = gb + 1098088 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1158116 >> 2] = 0;
 HEAP32[gb + 1158116 + 4 >> 2] = 0;
 HEAP32[gb + 1158116 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158128 | 0, gb + 402904 | 0, 8, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158140 | 0, gb + 402940 | 0, 8, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1545907 | 0, fb + 3373 | 0, fb + 3374 | 0, 0, 0);
 return;
}

function __ZN11AudioSource19UpdateReverbZoneMixE12SoundChannelf(i4, i6, f5) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, f2 = f0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i3 = i10;
 i8 = i10 + 48 | 0;
 i7 = i10 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZN20SoundChannelInstance19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i1, i7) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
  HEAP32[i3 >> 2] = gb + 855390;
  HEAP32[i3 + 4 >> 2] = 858;
  HEAP32[i3 + 8 >> 2] = gb + 865917;
  HEAP32[i3 + 12 >> 2] = i1;
  __Z6FormatPKcz(i8, gb + 883334 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = -1e4;
 do if (!(HEAP32[i4 + 544 >> 2] | 0)) if (!(HEAP8[i4 + 426 >> 0] | 0)) {
  f2 = Math_fround(HEAPF32[i4 + 400 >> 2]);
  if (f2 > Math_fround(0.0) ? (HEAP32[i4 + 192 >> 2] | 0) != 1 : 0) f2 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i4 + 124 | 0, Math_fround(f5 / f2), 0)); else f2 = Math_fround(HEAPF32[(HEAP32[i4 + 180 >> 2] | 0) + 4 >> 2]);
  if (!(f2 < Math_fround(0.0))) {
   if (f2 > Math_fround(1.10000002)) f2 = Math_fround(1.10000002); else if (!(f2 > Math_fround(1.0))) {
    if (!(f2 > Math_fround(0.0))) break;
    HEAP32[i1 >> 2] = ~~Math_fround(Math_fround(_log10f(f2)) * Math_fround(2.0e3));
    break;
   }
   HEAP32[i1 >> 2] = ~~Math_fround(Math_fround(f2 + Math_fround(-1.0)) * Math_fround(1.0e4));
  }
 } while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZN20SoundChannelInstance19setReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i1, i7) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i7 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
 HEAP32[i9 >> 2] = gb + 855390;
 HEAP32[i9 + 4 >> 2] = 880;
 HEAP32[i9 + 8 >> 2] = gb + 865955;
 HEAP32[i9 + 12 >> 2] = i7;
 __Z6FormatPKcz(i8, gb + 883334 | 0, i9);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZL35InitializeAnimationScriptingClassesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63728 | 0, 16, gb + 897355 | 0, 16) | 0;
 HEAP32[gb + 1466572 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 898218 | 0) | 0;
 HEAP32[HEAP32[gb + 1466572 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897481 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 4 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 902235 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 8 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897496 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 12 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897513 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 16 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897541 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 20 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897559 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 24 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 897616 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 28 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 897638 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 32 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 900116 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 36 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 906895 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 40 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 899910 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 44 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 897666 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 48 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 897582 | 0, gb + 897693 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 52 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897717 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 56 >> 2] = i1;
 i1 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 897727 | 0) | 0;
 HEAP32[(HEAP32[gb + 1466572 >> 2] | 0) + 60 >> 2] = i1;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 120 | 0;
 i6 = i11 + 64 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 120 | 0;
 i6 = i11 + 64 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 120 | 0;
 i6 = i11 + 64 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 28; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN15CapsuleCollider16TransformChangedEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 96 | 0;
 i6 = i9 + 64 | 0;
 i7 = i9;
 i8 = i3 + 36 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!((i4 & 64 | 0) == 0 | (i1 | 0) == 0)) {
  i2 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if ((__ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i3, 0) | 0) != (i2 | 0)) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (i4 & 8) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 172 >> 2] | 0, i3 | 0);
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 28 | 0;
 if (__ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0, i7) | 0) {
  i10 = HEAP32[i8 >> 2] | 0;
  i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0;
  __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i7, i5);
  i13 = HEAP32[i7 + 48 >> 2] | 0;
  i12 = HEAP32[i7 + 52 >> 2] | 0;
  i7 = HEAP32[i7 + 56 >> 2] | 0;
  i16 = HEAP32[i5 + 4 >> 2] | 0;
  i15 = HEAP32[i5 + 8 >> 2] | 0;
  i14 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i16;
  HEAP32[i6 + 8 >> 2] = i15;
  HEAP32[i6 + 12 >> 2] = i14;
  HEAP32[i6 + 16 >> 2] = i13;
  HEAP32[i6 + 20 >> 2] = i12;
  HEAP32[i6 + 24 >> 2] = i7;
  mftCall_vii(i11 | 0, i10 | 0, i6 | 0);
  if (!((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 5)) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0) | 0) & 1)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
 }
 if (!((i4 & -2147483640 | 0) == 0 ? (HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 28 >> 2] | 0) : 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
   if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
  }
 }
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ES2_RKNS_19PxVehicleClutchDataES6_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i11, i1, i10, i9) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 16 | 0;
 i7 = i8 + 72 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + -1 | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = i11 + 36 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
    i3 = HEAP32[i11 + 20 >> 2] | 0;
    i4 = (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i2 >> 0] = i4;
    i1 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = i4;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP8[(HEAP32[i4 + 4 >> 2] | 0) + ((HEAP32[i4 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
  }
 }
 if (!(HEAP8[i11 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i11 + 24 | 0;
 mftCall_vii(HEAP32[i10 + 16 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 i13 = i11 + 8 | 0;
 i14 = HEAP32[i11 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = HEAP32[i11 + 20 >> 2] | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i4 = HEAP32[i11 + 32 >> 2] | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i5;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j(i9, i6, 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP8[HEAP32[i11 + 40 >> 2] >> 0] = 1;
 i14 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 mftCall_vii(HEAP32[i10 + 20 >> 2] | 0, i14 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback(i18, i19, i13, i15, i20) {
 i18 = i18 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i20 = i20 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i16 = i19 + 20 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 L1 : do if ((i2 | 0) > 0) {
  i6 = (HEAP32[i18 + 60 >> 2] | 0) + ((HEAP32[i19 + 16 >> 2] | 0) * 28 | 0) | 0;
  i11 = i13 + 8 | 0;
  i12 = i15 + 8 | 0;
  i14 = i19 + 8 | 0;
  i1 = 0;
  i3 = 0;
  do {
   f7 = Math_fround(HEAPF32[i13 >> 2]);
   f8 = Math_fround(HEAPF32[i15 >> 2]);
   f9 = Math_fround(HEAPF32[i11 >> 2]);
   f10 = Math_fround(HEAPF32[i12 >> 2]);
   i5 = i3;
   while (1) {
    i3 = i6 + (i5 * 28 | 0) | 0;
    i4 = i6 + (i5 * 28 | 0) + 12 | 0;
    if (!(f7 > Math_fround(HEAPF32[i4 >> 2]))) if (!(f8 < Math_fround(HEAPF32[i3 >> 2]))) if (!(f9 > Math_fround(HEAPF32[i4 + 8 >> 2]))) if (!(f10 < Math_fround(HEAPF32[i3 + 8 >> 2]))) {
     i17 = 10;
     break;
    }
    i3 = HEAP32[i6 + (i5 * 28 | 0) + 24 >> 2] | 0;
    if ((i3 | 0) > -1) break;
    i3 = i5 - i3 | 0;
    if ((i3 | 0) < (i2 | 0)) i5 = i3; else break L1;
   }
   if ((i17 | 0) == 10) {
    i17 = 0;
    i4 = i6 + (i5 * 28 | 0) + 24 | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    if ((i3 | 0) >= 0) {
     if ((i1 | 0) > 31) {
      mftCall_viiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i18 | 0, i19 | 0, i21 | 0, i1 | 0);
      i1 = 0;
      i2 = HEAP32[i16 >> 2] | 0;
      i3 = HEAP32[i4 >> 2] | 0;
     }
     HEAP32[i21 + (i1 << 2) >> 2] = i3 + (HEAP32[i14 >> 2] | 0);
     i1 = i1 + 1 | 0;
    }
   }
   i3 = i5 + 1 | 0;
  } while ((i3 | 0) < (i2 | 0));
 } else {
  i6 = i19 + 12 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) <= 0) {
   STACKTOP = i22;
   return;
  }
  i5 = i19 + 8 | 0;
  i4 = 0;
  i1 = 0;
  do {
   if ((i1 | 0) > 31) {
    mftCall_viiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i18 | 0, i19 | 0, i21 | 0, i1 | 0);
    i3 = 0;
    i2 = HEAP32[i6 >> 2] | 0;
   } else i3 = i1;
   i1 = i3 + 1 | 0;
   HEAP32[i21 + (i3 << 2) >> 2] = (HEAP32[i5 >> 2] | 0) + i4;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
 } while (0);
 if ((i1 | 0) <= 0) {
  STACKTOP = i22;
  return;
 }
 mftCall_viiiii(HEAP32[HEAP32[i20 >> 2] >> 2] | 0, i20 | 0, i18 | 0, i19 | 0, i21 | 0, i1 | 0);
 STACKTOP = i22;
 return;
}

function __Z31FindAttributeInTypeTreeNoArraysRK16TypeTreeIteratorPKc(i14, i1, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20;
 i13 = i15;
 L1 : while (1) {
  switch (HEAP8[i13 >> 0] | 0) {
  case 0:
  case 46:
   break L1;
  default:
   {}
  }
  i13 = i13 + 1 | 0;
 }
 i17 = i13 - i15 | 0;
 i18 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i18 >> 2] | 0;
 i3 = i2 + (i1 * 24 | 0) | 0;
 L5 : do if ((i3 + 24 | 0) >>> 0 < (i2 + ((HEAP32[i18 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i3 + 26 >> 0] | 0) == ((HEAPU8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i1 = i1 + 1 | 0;
  HEAP32[i16 >> 2] = i18;
  HEAP32[i16 + 4 >> 2] = i1;
  if (i18 | 0) {
   i7 = HEAP32[gb + 36932 >> 2] | 0;
   i6 = i16 + 4 | 0;
   i8 = HEAP32[i18 >> 2] | 0;
   i9 = HEAP32[i18 + 20 >> 2] | 0;
   i10 = i18 + 12 | 0;
   i11 = i18;
   i12 = (i18 | 0) == 0;
   L9 : while (1) {
    i2 = HEAP32[i8 + (i1 * 24 | 0) + 8 >> 2] | 0;
    i2 = ((i2 | 0) < 0 ? i7 : i9) + (i2 & 2147483647) | 0;
    if (!(_strncmp(i2, i15, i17) | 0)) if (!(HEAP8[i2 + i17 >> 0] | 0)) break;
    i2 = HEAP32[i18 >> 2] | 0;
    i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
    i4 = i2 + ((HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
    i5 = i2;
    i2 = i2 + (i1 * 24 | 0) | 0;
    do {
     i1 = i2;
     i2 = i2 + 24 | 0;
     if (i2 >>> 0 >= i4 >>> 0) {
      i19 = 18;
      break L9;
     }
     i1 = HEAP8[i1 + 26 >> 0] | 0;
    } while ((i1 & 255) > (i3 & 255));
    if (i1 << 24 >> 24 != i3 << 24 >> 24) {
     i19 = 18;
     break;
    }
    i1 = (i2 - i5 | 0) / 24 | 0;
    HEAP32[i16 >> 2] = i11;
    HEAP32[i6 >> 2] = i1;
    if (i12) break L5;
   }
   if ((i19 | 0) == 18) {
    HEAP32[i16 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    break;
   }
   if (!(HEAP8[i13 >> 0] | 0)) {
    i17 = i16;
    i18 = HEAP32[i17 + 4 >> 2] | 0;
    i19 = i14;
    HEAP32[i19 >> 2] = HEAP32[i17 >> 2];
    HEAP32[i19 + 4 >> 2] = i18;
    STACKTOP = i20;
    return;
   } else {
    __Z31FindAttributeInTypeTreeNoArraysRK16TypeTreeIteratorPKc(i14, i16, i13 + 1 | 0);
    STACKTOP = i20;
    return;
   }
  }
 } else i19 = 6; else i19 = 6; while (0);
 if ((i19 | 0) == 6) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i16 + 4 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 STACKTOP = i20;
 return;
}

function __ZN15AudioReverbZone15SetReverbPresetEi(i28, i27) {
 i28 = i28 | 0;
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i29 = 0;
 i1 = i28 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i27 | 0)) return;
 HEAP32[i1 >> 2] = i27;
 if ((i27 | 0) < 27) {
  i2 = i28 + 60 | 0;
  i3 = i28 + 64 | 0;
  i4 = i28 + 72 | 0;
  i5 = i28 + 76 | 0;
  i6 = i28 + 80 | 0;
  i7 = i28 + 84 | 0;
  i8 = i28 + 88 | 0;
  i9 = i28 + 92 | 0;
  i10 = i28 + 96 | 0;
  i11 = i28 + 108 | 0;
  i12 = i28 + 112 | 0;
  i13 = i28 + 68 | 0;
  i14 = i28 + 100 | 0;
  i15 = gb + 171848 + (i27 * 80 | 0) + 24 | 0;
  i16 = gb + 171848 + (i27 * 80 | 0) + 28 | 0;
  i17 = gb + 171848 + (i27 * 80 | 0) + 36 | 0;
  i18 = gb + 171848 + (i27 * 80 | 0) + 40 | 0;
  i19 = gb + 171848 + (i27 * 80 | 0) + 44 | 0;
  i20 = gb + 171848 + (i27 * 80 | 0) + 48 | 0;
  i21 = gb + 171848 + (i27 * 80 | 0) + 60 | 0;
  i22 = gb + 171848 + (i27 * 80 | 0) + 64 | 0;
  i23 = gb + 171848 + (i27 * 80 | 0) + 68 | 0;
  i24 = gb + 171848 + (i27 * 80 | 0) + 72 | 0;
  i25 = gb + 171848 + (i27 * 80 | 0) + 12 | 0;
  i26 = gb + 171848 + (i27 * 80 | 0) + 16 | 0;
  i1 = gb + 171848 + (i27 * 80 | 0) + 20 | 0;
 } else {
  i25 = i28 + 60 | 0;
  i26 = i28 + 64 | 0;
  i15 = i28 + 72 | 0;
  i16 = i28 + 76 | 0;
  i17 = i28 + 80 | 0;
  i18 = i28 + 84 | 0;
  i19 = i28 + 88 | 0;
  i20 = i28 + 92 | 0;
  i21 = i28 + 96 | 0;
  i23 = i28 + 108 | 0;
  i24 = i28 + 112 | 0;
  i1 = i28 + 68 | 0;
  i22 = i28 + 100 | 0;
  i2 = i25;
  i3 = i26;
  i4 = i15;
  i5 = i16;
  i6 = i17;
  i7 = i18;
  i8 = i19;
  i9 = i20;
  i10 = i21;
  i11 = i23;
  i12 = i24;
  i13 = i1;
  i14 = i22;
 }
 i29 = HEAP32[i26 >> 2] | 0;
 i26 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i27 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i23 >> 2] | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i3 >> 2] = i29;
 HEAP32[i4 >> 2] = i15;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i6 >> 2] = i17;
 HEAP32[i7 >> 2] = i18;
 HEAP32[i8 >> 2] = i19;
 HEAP32[i9 >> 2] = i20;
 HEAP32[i10 >> 2] = i21;
 HEAPF32[i28 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i11 >> 2] = i23;
 HEAP32[i12 >> 2] = i24;
 HEAP32[i13 >> 2] = i26;
 HEAP32[i14 >> 2] = i27;
 return;
}

function __ZN13RuntimeStaticI12AdsIdHandlerE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(84, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP8[i4 + 16 >> 0] = 0;
  i3 = i4 + 20 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAPF32[i4 + 36 >> 2] = Math_fround(0.0);
  HEAP8[i4 + 40 >> 0] = 0;
  HEAP8[i4 + 41 >> 0] = 0;
  HEAP32[i4 + 44 >> 2] = 0;
  i3 = i4 + 48 | 0;
  HEAP32[i3 >> 2] = i3;
  HEAP32[i4 + 52 >> 2] = i3;
  HEAP32[i4 + 56 >> 2] = 0;
  HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i3 = i4 + 64 | 0;
  HEAP32[i3 >> 2] = i3;
  HEAP32[i4 + 68 >> 2] = i3;
  HEAP32[i4 + 72 >> 2] = 0;
  HEAP32[i4 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(84, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP8[i4 + 16 >> 0] = 0;
  i3 = i4 + 20 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAPF32[i4 + 36 >> 2] = Math_fround(0.0);
  HEAP8[i4 + 40 >> 0] = 0;
  HEAP8[i4 + 41 >> 0] = 0;
  HEAP32[i4 + 44 >> 2] = 0;
  i3 = i4 + 48 | 0;
  HEAP32[i3 >> 2] = i3;
  HEAP32[i4 + 52 >> 2] = i3;
  HEAP32[i4 + 56 >> 2] = 0;
  HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  i3 = i4 + 64 | 0;
  HEAP32[i3 >> 2] = i3;
  HEAP32[i4 + 68 >> 2] = i3;
  HEAP32[i4 + 72 >> 2] = 0;
  HEAP32[i4 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 152 | 0;
 i6 = i11 + 96 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN13RenderManager12RemoveCameraEP6Camera(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i7 = i11 + 4 | 0;
 i5 = i11;
 i2 = (i10 | 0) == 0;
 if (i2) {
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
  i4 = i5;
 } else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  i4 = i5;
 }
 HEAP32[i6 >> 2] = i1;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i9 + 28 | 0, i6);
 i3 = i9 + 40 | 0;
 if (i2) i1 = 0; else i1 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i3, i6);
 if (!(HEAP8[i9 + 52 >> 0] | 0)) {
  __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i9 + 4 | 0, i5);
  __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_(i9 + 16 | 0, i5);
 } else {
  i5 = __Znwj(12) | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i4 + 4 >> 2] = i5;
  HEAP32[i3 >> 2] = i5;
  i5 = i9 + 48 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 15; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 17;
   }
  }
  if ((i8 | 0) == 15) i8 = 17;
  if ((i8 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i9 >> 2] | 0) | 0;
 }
 if ((i1 | 0) != (i10 | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i9 + 12 >> 2] | 0)) {
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i9 >> 2] = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 8 >> 2];
  STACKTOP = i11;
  return;
 }
}

function __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i7 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   i8 = i6 + 32 | 0;
   i7 = i7 + 32 | 0;
   i7 = HEAP32[i7 >> 2] | 0;
   HEAP32[i8 >> 2] = i7;
   STACKTOP = i9;
   return;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i10 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i10 = i1;
 i10 = i10 + i4 | 0;
 HEAP8[i10 >> 0] = 0;
 i10 = i6 + 32 | 0;
 i8 = i7 + 32 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i8;
 STACKTOP = i9;
 return;
}

function __Z20PreApiCallChecksGLESPK7ApiGLESPKcS3_l(i1, i2, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 36 | 0;
 i3 = i9 + 24 | 0;
 i4 = i9 + 12 | 0;
 i5 = i9;
 __ZNK9DebugGLES10LogApiCallEPKcS1_l(HEAP32[i1 + 864 >> 2] | 0, i2, i6, i7);
 if ((__ZN2gl17GetCurrentContextEv() | 0) != (-559030611 | 0)) {
  STACKTOP = i9;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 601091 | 0, 18);
 if (!i2) {
  i1 = i8 + 11 | 0;
  i2 = i8;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i10 = HEAP8[i5 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i11 ? HEAP32[i5 >> 2] | 0 : i5, i10, i10 + 2 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, gb + 1084762 | 0, 2) | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i10 = HEAP8[i4 + 11 >> 0] | 0;
  i11 = i10 << 24 >> 24 < 0;
  i10 = i11 ? HEAP32[i4 + 4 >> 2] | 0 : i10 & 255;
  i1 = i8 + 11 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i2 = i2 << 24 >> 24 < 0 ? HEAP32[i8 + 4 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i3, i11 ? HEAP32[i4 >> 2] | 0 : i4, i10, i2 + i10 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i3, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i2 = i8;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i8, 0, i6, i7, 2, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __Z16ReleaseLightmapsR12LightmapData(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  __ZN7Texture7ReleaseEv(i1);
 } while (0);
 i4 = i4 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 19;
  }
 }
 if ((i7 | 0) == 18) i7 = 19;
 if ((i7 | 0) == 19) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
 }
 __ZN7Texture7ReleaseEv(i1);
 STACKTOP = i8;
 return;
}

function __ZNK8GUIStyle10CalcHeightER10GUIContentf(i11, i8, f9) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 var f1 = f0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i4 = i12;
 f1 = Math_fround(HEAPF32[i11 + 280 >> 2]);
 if (f1 != Math_fround(0.0)) {
  f9 = f1;
  STACKTOP = i12;
  return Math_fround(f9);
 }
 i6 = i8 + 40 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if (!i2) f3 = Math_fround(0.0); else {
  HEAP32[i4 >> 2] = i2;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i7 = 8; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i4 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i4 + (i5 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i4);
    i4 = HEAP32[i10 >> 2] | 0;
    i13 = HEAP32[i2 + 28 >> 2] | 0;
    i5 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i4 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i4 << 3) | 0;
    i4 = HEAP32[i5 + 28 >> 2] | 0;
    i5 = HEAP32[i5 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i7 = 8; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i7 = 10;
   }
  }
  if ((i7 | 0) == 8) i7 = 10;
  if ((i7 | 0) == 10) {
   i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   if (!i2) {
    f3 = Math_fround(0.0);
    break;
   }
  }
  mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
  f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0);
 } while (0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = f9;
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0e3);
 i2 = __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent(i11, i10, i8) | 0;
 if (!i2) f1 = Math_fround(0.0); else f1 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 switch (HEAP32[i11 + 256 >> 2] | 0) {
 case 0:
  {
   f1 = f1 < f3 ? f3 : f1;
   break;
  }
 case 1:
  {
   f1 = Math_fround(f3 + f1);
   break;
  }
 case 2:
  {
   f1 = f3;
   break;
  }
 case 3:
  break;
 default:
  f1 = Math_fround(0.0);
 }
 f9 = Math_fround(f1 + Math_fround(HEAP32[i11 + 216 >> 2] | 0));
 f9 = Math_fround(f9 + Math_fround(HEAP32[i11 + 220 >> 2] | 0));
 STACKTOP = i12;
 return Math_fround(f9);
}

function __ZNK10SizeModule6UpdateERK23ParticleSystemParticlesPPf(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, i23 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1452280 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452280 | 0, i1);
  i6 = gb + 1452280 | 0;
 } else i6 = 0;
 i9 = HEAP8[i11 + 871 >> 0] | 0 ? 3 : 1;
 i7 = i10 + 800 | 0;
 i8 = i11 + 12 | 0;
 i5 = 0;
 do {
  i1 = HEAP8[i7 >> 0] | 0 ? i5 : 0;
  i2 = i10 + 8 + (i1 * 264 | 0) | 0;
  i3 = HEAP16[i10 + 8 + (i1 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i3 << 16 >> 16)) {
   i3 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   if (i4 | 0) {
    i2 = i10 + 8 + (i1 * 264 | 0) + 80 | 0;
    i1 = 0;
    do {
     i20 = i3 + (i1 << 2) | 0;
     f22 = Math_fround(HEAPF32[i20 >> 2]);
     i18 = i20 + 4 | 0;
     f19 = Math_fround(HEAPF32[i18 >> 2]);
     i16 = i20 + 8 | 0;
     f17 = Math_fround(HEAPF32[i16 >> 2]);
     i14 = i20 + 12 | 0;
     f15 = Math_fround(HEAPF32[i14 >> 2]);
     f21 = Math_fround(HEAPF32[i2 >> 2]);
     i23 = f21 < Math_fround(0.0);
     f21 = i23 ? Math_fround(0.0) : f21;
     f19 = Math_fround(f19 * f21);
     f17 = Math_fround(f17 * f21);
     f15 = Math_fround(f15 * f21);
     HEAPF32[i20 >> 2] = Math_fround(f22 * f21);
     HEAPF32[i18 >> 2] = f19;
     HEAPF32[i16 >> 2] = f17;
     HEAPF32[i14 >> 2] = f15;
     i1 = i1 + 4 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   }
  } else {
   if (!(HEAP8[i10 + 8 + (i1 * 264 | 0) + 86 >> 0] | 0)) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i2, i11, HEAP32[i12 + (i5 << 2) >> 2] | 0);
    break;
   }
   i1 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
   if ((i3 | 1) << 16 >> 16 == 3) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i2, i11, i1);
    break;
   } else {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf(i2, i11, i1);
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i9 | 0));
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf(i1, i14, i15, i16, f17, i18) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 i18 = i18 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i19;
 f7 = Math_fround(HEAPF32[i16 >> 2]);
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f7 = Math_fround(f7 - f4);
 f8 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f8 = Math_fround(f8 - f3);
 f9 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f9 = Math_fround(f9 - f2);
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f12 - f4);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f13 - f3);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f10 - f2);
 f5 = Math_fround(Math_fround(Math_fround(f7 * f4) + Math_fround(f8 * f3)) + Math_fround(f9 * f2));
 do if (!(f5 <= Math_fround(0.0))) {
  f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
  if (!(f5 >= f6)) {
   f6 = Math_fround(f5 / f6);
   f4 = Math_fround(f4 - Math_fround(f7 * f6));
   f3 = Math_fround(f3 - Math_fround(f8 * f6));
   f2 = Math_fround(f2 - Math_fround(f9 * f6));
   break;
  } else {
   f4 = Math_fround(f4 - f7);
   f3 = Math_fround(f3 - f8);
   f2 = Math_fround(f2 - f9);
   break;
  }
 } while (0);
 f2 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))))) - f17) + Math_fround(-10.0));
 i1 = f2 > Math_fround(0.0);
 f2 = i1 ? f2 : Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i14 >> 2]);
 f9 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f9 = Math_fround(f13 + Math_fround(f9 * f2));
 f13 = Math_fround(Math_fround(Math_fround(HEAPF32[i14 + 8 >> 2]) * f2) + f10);
 HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(f8 * f2));
 HEAPF32[i11 + 4 >> 2] = f9;
 HEAPF32[i11 + 8 >> 2] = f13;
 i1 = __ZN5physx2Gu27intersectRayCapsuleInternalERKNS_6PxVec3ES3_S3_S3_fPf(i11, i14, i15, i16, f17, i18) | 0;
 if (!i1) {
  STACKTOP = i19;
  return i1 | 0;
 }
 HEAPF32[i18 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i18 >> 2]));
 if (i1 >>> 0 <= 1) {
  STACKTOP = i19;
  return i1 | 0;
 }
 i18 = i18 + 4 | 0;
 HEAPF32[i18 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i18 >> 2]));
 STACKTOP = i19;
 return i1 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 152 | 0;
 i6 = i11 + 96 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i8, i1, i9, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 152 | 0;
 i6 = i11 + 96 | 0;
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!(HEAP8[i2 + (i5 << 3) + 4 >> 0] | 0)) {
   i3 = i8 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) i3 = 0; else {
    i4 = HEAP32[i8 + 20 >> 2] | 0;
    i5 = (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[i2 + (i5 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i5;
    i2 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i3 = i5;
   }
   HEAP8[i2 + (i4 + -1 << 3) + 5 >> 0] = i3;
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP32[i5 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i3;
  }
 }
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 24 | 0;
 mftCall_vii(HEAP32[i9 + 16 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 i13 = i8 + 8 | 0;
 i14 = HEAP32[i8 >> 2] | 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = HEAP32[i8 + 28 >> 2] | 0;
 i5 = HEAP32[i8 + 32 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i12;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i3;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i4;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j(i7, i6, 0) | 0;
 if (HEAP8[i10 >> 0] | 0) HEAP8[HEAP32[i8 + 40 >> 2] >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i4 = i10;
 i2 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 mftCall_vii(i3 | 0, i5 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __Z26AddEulerCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb(i11, i12, i13, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf(i11, i1, Math_fround(HEAPF32[i13 + 1084 >> 2])) | 0;
 if ((i10 | 0) == -1) return;
 i8 = i13 + 620 + (i10 * 148 | 0) + 20 | 0;
 i9 = i11;
 i2 = i13 + 620 + (i10 * 148 | 0) + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i13 + 620 + (i10 * 148 | 0) + 36 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i13 + 620 + (i10 * 148 | 0) + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13 + 620 + (i10 * 148 | 0) + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2] = i9;
 i2 = i13 + 620 + (i10 * 148 | 0) + 128 | 0;
 i3 = i13 + 620 + (i10 * 148 | 0) + 140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i13 + 620 + (i10 * 148 | 0) + 144 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i13 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i13 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i13;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i13 = HEAP32[i2 >> 2] | 0;
 __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE(i12, 4, i13 + (i4 << 4) | 0);
 HEAP8[i13 + (i4 << 4) + 14 >> 0] = (HEAP32[i11 + 148 >> 2] | 0) + 10;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i2 = i11 + 24 | 0;
 __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_(i11, i11 + 12 | 0, i2, i1) | 0;
 i1 = i11 + 36 | 0;
 if ((i1 | 0) == (i12 | 0)) {
  STACKTOP = i15;
  return;
 }
 i9 = i13 + 11 | 0;
 i10 = i13 + 4 | 0;
 i8 = i1;
 while (1) {
  i5 = HEAP8[i8 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
  i6 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
  i1 = i6 >>> 0 < i5 >>> 0 ? i6 : i5;
  if (!i1) i14 = 6; else {
   i1 = _memcmp(i3 ? HEAP32[i8 >> 2] | 0 : i8, i4 ? HEAP32[i2 >> 2] | 0 : i2, i1) | 0;
   if (!i1) i14 = 6; else if ((i1 | 0) < 0) i14 = 8;
  }
  if ((i14 | 0) == 6) {
   i14 = 0;
   if (i5 >>> 0 < i6 >>> 0) i14 = 8;
  }
  if ((i14 | 0) == 8) {
   i14 = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i13, i8);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i2) | 0;
   L13 : do if ((i2 | 0) == (i11 | 0)) i1 = i11; else while (1) {
    i1 = i2;
    i2 = i2 + -12 | 0;
    i6 = HEAP8[i9 >> 0] | 0;
    i4 = i6 << 24 >> 24 < 0;
    i6 = i4 ? HEAP32[i10 >> 2] | 0 : i6 & 255;
    i7 = HEAP8[i2 + 11 >> 0] | 0;
    i5 = i7 << 24 >> 24 < 0;
    i7 = i5 ? HEAP32[i1 + -8 >> 2] | 0 : i7 & 255;
    i3 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
    if (!i3) i14 = 11; else {
     i3 = _memcmp(i4 ? HEAP32[i13 >> 2] | 0 : i13, i5 ? HEAP32[i2 >> 2] | 0 : i2, i3) | 0;
     if (!i3) i14 = 11; else if ((i3 | 0) >= 0) break L13;
    }
    if ((i14 | 0) == 11) {
     i14 = 0;
     if (i6 >>> 0 >= i7 >>> 0) break L13;
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i2) | 0;
    if ((i2 | 0) == (i11 | 0)) {
     i1 = i11;
     break;
    }
   } while (0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i13) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  }
  i1 = i8 + 12 | 0;
  if ((i1 | 0) == (i12 | 0)) break; else {
   i2 = i8;
   i8 = i1;
  }
 }
 STACKTOP = i15;
 return;
}

function __ZN9Rigidbody8AddForceERK8Vector3fi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 i15 = f16 < Math_fround(0.0);
 f17 = Math_fround(-f16);
 i6 = i3 + 4 | 0;
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f13 < Math_fround(0.0);
 f14 = Math_fround(-f13);
 i7 = i3 + 8 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = f4 < Math_fround(0.0);
 f12 = Math_fround(-f4);
 i15 = (i15 ? f17 : f16) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
 i5 = i15 & (i5 ? f14 : f13) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 if (i5 & (i8 ? f12 : f4) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
  STACKTOP = i11;
  return;
 }
 i8 = i1 + 52 | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 200 >> 2] | 0, i15 | 0) | 0) & 1) {
  STACKTOP = i11;
  return;
 }
 f4 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 switch (i2 | 0) {
 case 5:
  {
   f14 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f16 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f17 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 0;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 case 1:
  {
   i1 = 1;
   i10 = 6;
   break;
  }
 case 2:
  {
   f14 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
   f16 = Math_fround(f4 * Math_fround(HEAPF32[i6 >> 2]));
   f17 = Math_fround(f4 * Math_fround(HEAPF32[i7 >> 2]));
   i5 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
   i1 = 1;
   i3 = (HEAPF32[tempDoublePtr >> 2] = f16, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = (HEAPF32[tempDoublePtr >> 2] = f17, HEAP32[tempDoublePtr >> 2] | 0);
   break;
  }
 default:
  {
   i1 = 0;
   i10 = 6;
  }
 }
 if ((i10 | 0) == 6) {
  i5 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i15 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i15 >> 2] | 0) + 168 >> 2] | 0;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i2;
 mftCall_viiii(i10 | 0, i15 | 0, i9 | 0, i1 | 0, 1);
 STACKTOP = i11;
 return;
}

function __ZN9AnimationC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 176044 + 8;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = i1;
 i2 = i1 + 268 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAP32[i1 + 308 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = i2;
 HEAP32[i1 + 316 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 328 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 1;
 HEAP8[i1 + 41 >> 0] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP8[i1 + 42 >> 0] = 0;
 i1 = i1 + 120 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i4;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine9Animation18FindAnimatedObjectER10GameObjectRK18EditorCurveBinding(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i2 = HEAP32[i3 >> 2] | 0; else i2 = i3;
 i7 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i1, i2, 0) | 0;
 if (!i7) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i3 + 24 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   i8 = HEAP32[i7 + 28 >> 2] | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 114:
  {
   i4 = HEAP32[i3 + 28 >> 2] | 0;
   do if (!i4) i8 = 17; else {
    HEAP32[i6 >> 2] = i4;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i8 = 13; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
      i2 = HEAP32[i5 >> 2] | 0;
      i6 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 13; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i8 = 15;
     }
    }
    if ((i8 | 0) == 13) i8 = 15;
    if ((i8 | 0) == 15) {
     i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
     if (!i1) {
      i8 = 17;
      break;
     }
    }
    if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27480 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27480 + 28 >> 2] | 0) >>> 0) i8 = 17;
   } while (0);
   if ((i8 | 0) == 17) i1 = 0;
   i8 = __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(HEAP32[i7 + 28 >> 2] | 0, 114, i1) | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
   if (!i1) i1 = 0; else i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, i1) | 0;
   i8 = i1;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 return 0;
}

function __Z21TransferBlobSerializeIN7mecanim9animation14AvatarConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i6, i7, i5, i1, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i1, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i4 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, HEAP32[i5 >> 2] | 0);
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 100, 4) | 0;
  i1 = i2 + 40 | 0;
  i3 = i2;
  i4 = i3 + 40 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i1 >> 2] = -1;
  i5 = i2 + 44 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i2 + 68 >> 2] = 1065353216;
  HEAP32[i2 + 72 >> 2] = 1065353216;
  HEAP32[i2 + 76 >> 2] = 1065353216;
  HEAP32[i2 + 80 >> 2] = 1065353216;
  i5 = i2 + 84 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = i2;
 } else i2 = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i7, gb + 910045 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN7mecanim9animation14AvatarConstant8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z15RetainLightmapsR12LightmapData(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 9;
   }
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  __ZN7Texture6RetainEv(i1);
 } while (0);
 i4 = i4 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 18; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 18; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 19;
  }
 }
 if ((i7 | 0) == 18) i7 = 19;
 if ((i7 | 0) == 19) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
 }
 __ZN7Texture6RetainEv(i1);
 STACKTOP = i8;
 return;
}

function _tt_cmap14_char_var_isdefault(i1, i10, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = i9 + 10 | 0;
 i1 = 0;
 i3 = (HEAPU8[i9 + 7 >> 0] | 0) << 16 | (HEAPU8[i9 + 6 >> 0] | 0) << 24 | (HEAPU8[i9 + 8 >> 0] | 0) << 8 | (HEAPU8[i9 + 9 >> 0] | 0);
 L1 : while (1) while (1) {
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i8 = 21;
   break L1;
  }
  i5 = (i1 + i3 | 0) >>> 1;
  i6 = i4 + (i5 * 11 | 0) + 3 | 0;
  i2 = i6 + -3 | 0;
  i2 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
  if (i2 >>> 0 > i7 >>> 0) {
   i3 = i5;
   continue L1;
  }
  if (i2 >>> 0 < i7 >>> 0) i1 = i5 + 1 | 0; else break L1;
 }
 if ((i8 | 0) == 21) return i1 | 0;
 i1 = (HEAPU8[i6 + 1 >> 0] | 0) << 16 | (HEAPU8[i6 >> 0] | 0) << 24 | (HEAPU8[i6 + 2 >> 0] | 0) << 8 | (HEAPU8[i6 + 3 >> 0] | 0);
 i7 = (HEAPU8[i6 + 5 >> 0] | 0) << 16 | (HEAPU8[i6 + 4 >> 0] | 0) << 24 | (HEAPU8[i6 + 6 >> 0] | 0) << 8 | (HEAPU8[i6 + 7 >> 0] | 0);
 L10 : do if (i1 | 0) {
  i1 = i9 + i1 | 0;
  i5 = i1 + 4 | 0;
  i1 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
  i4 = 0;
  while (1) {
   while (1) {
    if (i4 >>> 0 >= i1 >>> 0) break L10;
    i6 = (i1 + i4 | 0) >>> 1;
    i2 = i5 + (i6 << 2) + 3 | 0;
    i3 = i2 + -3 | 0;
    i3 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) << 16 | (HEAPU8[i3 + 2 >> 0] | 0);
    if (i3 >>> 0 > i10 >>> 0) i1 = i6; else break;
   }
   if (((HEAPU8[i2 >> 0] | 0) + i3 | 0) >>> 0 < i10 >>> 0) i4 = i6 + 1 | 0; else {
    i1 = 1;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 L20 : do if (i7 | 0) {
  i6 = i9 + i7 | 0;
  i1 = (HEAPU8[i6 + 1 >> 0] | 0) << 16 | (HEAPU8[i6 >> 0] | 0) << 24 | (HEAPU8[i6 + 2 >> 0] | 0) << 8 | (HEAPU8[i6 + 3 >> 0] | 0);
  i6 = i6 + 4 | 0;
  if (i1 | 0) {
   i2 = 0;
   L22 : while (1) {
    while (1) {
     i5 = (i2 + i1 | 0) >>> 1;
     i3 = i6 + (i5 * 5 | 0) + 3 | 0;
     i4 = i3 + -3 | 0;
     i4 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0) << 16 | (HEAPU8[i4 + 2 >> 0] | 0);
     if (i4 >>> 0 > i10 >>> 0) break;
     if (i4 >>> 0 >= i10 >>> 0) break L22;
     i2 = i5 + 1 | 0;
     if (i2 >>> 0 >= i1 >>> 0) break L20;
    }
    if (i2 >>> 0 < i5 >>> 0) i1 = i5; else break L20;
   }
   if ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i3 + 1 >> 0] | 0) | 0) {
    i10 = 0;
    return i10 | 0;
   }
  }
 } while (0);
 i10 = -1;
 return i10 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 20 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 36 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 44 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i9 = HEAP32[i7 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN12TreeRenderer28UpdateBillboardAssetPointersEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14;
 i10 = i13 + 364 | 0;
 i11 = i13 + 368 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2;
 if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 i6 = 0;
 i7 = 0;
 i3 = i1;
 i5 = i1;
 while (1) {
  i4 = i3 + (i7 * 44 | 0) + 36 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = i2;
  } else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 14;
    }
   }
   if ((i12 | 0) == 12) i12 = 14;
   if ((i12 | 0) == 14) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i5 = HEAP32[i10 >> 2] | 0;
   i3 = i5;
   i4 = i5;
  }
  i2 = i3 + (i7 * 44 | 0) + 40 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i6; else {
   HEAP32[i2 >> 2] = i1;
   i1 = 1;
  }
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= (((HEAP32[i11 >> 2] | 0) - i4 | 0) / 44 | 0) >>> 0) break; else {
   i6 = i1;
   i3 = i4;
   i2 = i4;
  }
 }
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i13 + 412 >> 2] | 0;
 if (!i2) {
  STACKTOP = i14;
  return;
 }
 i3 = HEAP32[i13 + 400 >> 2] | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i3 + (i1 * 24 | 0) >> 2] | 0;
  if ((HEAP32[i4 + 264 >> 2] | 0) == 2) HEAP32[i4 + 276 >> 2] = HEAP32[i5 + ((HEAP32[(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0) + ((HEAP32[i4 + 272 >> 2] | 0) * 40 | 0) + 32 >> 2] | 0) * 44 | 0) + 40 >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i6 = i7 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i10 + 4;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i8 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 i5 = i10 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i11 = i7 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
 }
 HEAP32[i10 + 8 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, i2 + i4 | 0, i1 << 2);
 }
 i2 = i10 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i3 = i1;
  i4 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i6 = i2;
  i1 = i1 | 0 ? i1 - i6 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i6;
 }
 __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + i2 | 0, i7);
 i4 = i10 + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i10 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 1);
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRS7_(i14, i1, i17) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = (_strlen(HEAP32[i17 >> 2] | 0) | 0) + 1 | 0;
 i11 = i15 & 255;
 i12 = i15 >>> 8 & 255;
 i13 = i15 >>> 16 & 255;
 i16 = i15 >>> 24;
 i9 = i16 & 255;
 i5 = HEAP32[i14 >> 2] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3;
 i7 = i1 - i4 | 0;
 i2 = i7 + 4 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i11;
 HEAP8[i1 + 1 >> 0] = i12;
 HEAP8[i1 + 2 >> 0] = i13;
 HEAP8[i1 + 3 >> 0] = i9;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 i10 = HEAP32[i14 >> 2] | 0;
 i11 = HEAP32[i17 >> 2] | 0;
 i8 = i15 & 16777215 | i16 << 24;
 if (!((i8 | 0) != 0 & (i11 | 0) != 0)) return;
 i9 = i10 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i10 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i17 = i3;
 i6 = i1 - i17 | 0;
 i2 = i6 + i8 | 0;
 i7 = i10 + 16 | 0;
 if (((HEAP32[i7 >> 2] | 0) - i17 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i10 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    i17 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 12 >> 2] | 0, i17 | 0, i1 | 0);
   }
  }
  HEAP32[i5 >> 2] = i2;
  i1 = i2 + i6 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2 + i4;
 }
 _memcpy(i1 | 0, i11 | 0, i8 | 0) | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 28; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i9, i10, i11, i12, i13) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i7 = HEAP32[i12 >> 2] | 0;
 i7 = (i7 | 0) == 0 ? 0 : i7 + i12 | 0;
 i2 = i11 + 12 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i3 = i8 + 1 | 0;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 * 12 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i11 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i3;
 i6 = HEAP32[i11 >> 2] | 0;
 i5 = ~HEAP32[i10 >> 2];
 HEAP32[i6 + (i8 * 12 | 0) >> 2] = i5;
 HEAP32[i6 + (i8 * 12 | 0) + 4 >> 2] = i9;
 if (i13) {
  if (!i7) i1 = -1; else i1 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i7, i5) | 0;
  HEAP32[i6 + (i8 * 12 | 0) + 8 >> 2] = i1;
 } else {
  i2 = HEAP32[i12 + 12 >> 2] | 0;
  i3 = i12 + 16 | 0;
  i4 = i3;
  i1 = 0;
  while (1) {
   if ((i1 | 0) >= (i2 | 0)) {
    i1 = -1;
    break;
   }
   if ((HEAP32[(HEAP32[i3 >> 2] | 0) + i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i6 + (i8 * 12 | 0) + 8 >> 2] = i1;
 }
 i1 = HEAP32[i9 + 80 >> 2] | 0;
 i9 = HEAP32[i9 + 92 >> 2] | 0;
 i2 = i1 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i15;
  return;
 }
 do {
  i9 = HEAP32[i1 >> 2] | 0;
  HEAP32[i14 >> 2] = __Z16AppendPathToHashRKN7mecanim5crc32EPKc(i10, mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0) | 0;
  __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb(i9, i14, i11, i12, i13);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i15;
 return;
}

function __ZN5physx27createContactPatchesCoulombERNS_27PxcCorrelationBufferCoulombERNS_2Gu13ContactBufferEfj(i10, i9, f11, i12) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 i13 = i10 + 1792 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i9 + 4096 >> 2] | 0;
 i8 = i2 - i12 | 0;
 if ((i1 | 0) == 32) {
  i14 = 0;
  return i14 | 0;
 }
 if ((i2 | 0) != (i12 | 0)) {
  i2 = i10 + (i1 * 12 | 0) | 0;
  i3 = i1 + 1 | 0;
  i6 = HEAP32[i9 + (i12 << 6) + 48 >> 2] | 0;
  i7 = HEAP32[i9 + (i12 << 6) + 52 >> 2] & 65535;
  HEAP16[i2 >> 1] = i12;
  HEAP16[i10 + (i1 * 12 | 0) + 2 >> 1] = 1;
  HEAP16[i10 + (i1 * 12 | 0) + 4 >> 1] = 0;
  HEAP16[i10 + (i1 * 12 | 0) + 8 >> 1] = i6;
  HEAP16[i10 + (i1 * 12 | 0) + 10 >> 1] = i6 >>> 16;
  HEAP16[i10 + (i1 * 12 | 0) + 6 >> 1] = i7;
  if (i8 >>> 0 > 1) {
   i7 = i12 + -1 | 0;
   i1 = i3;
   i3 = 1;
   i6 = 1;
   do {
    i4 = i6 + i12 | 0;
    i5 = i7 + i6 | 0;
    f15 = Math_fround(HEAPF32[i9 + (i4 << 6) >> 2]);
    f15 = Math_fround(f15 * Math_fround(HEAPF32[i9 + (i5 << 6) >> 2]));
    f16 = Math_fround(HEAPF32[i9 + (i4 << 6) + 4 >> 2]);
    f16 = Math_fround(f15 + Math_fround(f16 * Math_fround(HEAPF32[i9 + (i5 << 6) + 4 >> 2])));
    f15 = Math_fround(HEAPF32[i9 + (i4 << 6) + 8 >> 2]);
    if (!(Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i9 + (i5 << 6) + 8 >> 2]))) >= f11)) i14 = 9; else if ((HEAP32[i9 + (i4 << 6) + 48 >> 2] | 0) == (HEAP32[i9 + (i5 << 6) + 48 >> 2] | 0)) if ((HEAP32[i9 + (i4 << 6) + 52 >> 2] | 0) == (HEAP32[i9 + (i5 << 6) + 52 >> 2] | 0)) i3 = i3 + 1 << 16 >> 16; else i14 = 9; else i14 = 9;
    if ((i14 | 0) == 9) {
     i14 = 0;
     if ((i1 | 0) == 32) {
      i1 = 0;
      i14 = 15;
      break;
     }
     HEAP16[i2 + 2 >> 1] = i3;
     i2 = i10 + (i1 * 12 | 0) | 0;
     i5 = HEAP32[i9 + (i4 << 6) + 48 >> 2] | 0;
     i3 = HEAP32[i9 + (i4 << 6) + 52 >> 2] & 65535;
     HEAP16[i2 >> 1] = i4;
     HEAP16[i10 + (i1 * 12 | 0) + 2 >> 1] = 1;
     HEAP16[i10 + (i1 * 12 | 0) + 4 >> 1] = 0;
     HEAP16[i10 + (i1 * 12 | 0) + 8 >> 1] = i5;
     HEAP16[i10 + (i1 * 12 | 0) + 10 >> 1] = i5 >>> 16;
     HEAP16[i10 + (i1 * 12 | 0) + 6 >> 1] = i3;
     i1 = i1 + 1 | 0;
     i3 = 1;
    }
    i6 = i6 + 1 | 0;
   } while (i6 >>> 0 < i8 >>> 0);
   if ((i14 | 0) == 15) return i1 | 0;
   if (i3 << 16 >> 16 != 1) HEAP16[i2 + 2 >> 1] = i3;
  } else i1 = i3;
 }
 HEAP32[i13 >> 2] = i1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5Umbra16TileTraverseTreeC2EPNS_12QueryContextEi(i11, i7, i3) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 HEAP32[i11 >> 2] = i7;
 HEAPF32[i11 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 i4 = i11 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i11 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i11 + 36 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i9 = i11 + 56 | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i11 + 64 >> 2] = 0;
 HEAP32[i11 + 68 >> 2] = 0;
 i1 = i11 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = i11 + 1696 | 0;
 i2 = i11 + 96 | 0;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 12 >> 2] = -1;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i12 = HEAP32[i2 + 48 >> 2] | 0;
 i8 = (HEAP32[i2 + 44 >> 2] | 0) >>> 5;
 i12 = (i12 | 0) == 0 ? 0 : i2 + i12 | 0;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i11 + 32 >> 2] = i12 + (((i8 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i6 >> 2] = i2;
 HEAP32[i11 + 40 >> 2] = i1;
 HEAP32[i11 + 44 >> 2] = 4;
 HEAP32[i11 + 48 >> 2] = i8;
 i4 = (HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + 44 | 0;
 i5 = (((HEAP32[i4 >> 2] | 0) >>> 5) + 31 | 0) >>> 5;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i1 + ((i5 << 2) + 31 & 67108848) | 0;
 i7 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i6 >>> 0 > i2 >>> 0) i10 = 5; else {
  HEAP32[i8 >> 2] = i6;
  if (!i1) {
   i1 = i6;
   i10 = 5;
  } else {
   HEAP32[i1 >> 2] = i5;
   i3 = i1 + 16 | 0;
   HEAP32[i11 + 20 >> 2] = i3;
   _memset(i3 | 0, 0, (((HEAP32[i4 >> 2] | 0) >>> 5) + 31 | 0) >>> 5 << 2 | 0) | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
 }
 if ((i10 | 0) == 5) {
  HEAP32[i11 + 20 >> 2] = 0;
  i4 = i1;
 }
 i1 = i4 + ((i3 << 1) + 15 & -16) | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  i12 = 0;
  i11 = i11 + 52 | 0;
  HEAP32[i11 >> 2] = i12;
  HEAP16[i12 >> 1] = 0;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 i12 = i4;
 i11 = i11 + 52 | 0;
 HEAP32[i11 >> 2] = i12;
 HEAP16[i12 >> 1] = 0;
 return;
}

function __ZN5physx2Sc18ParticleSystemCoreC2ERKNS_11PxActorType4EnumEjb(i8, i7, i10, i11) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh(i8, HEAP32[i7 >> 2] | 0, 1, 0, 0, 0);
 i9 = i8 + 16 | 0;
 i5 = i8 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAPF32[i8 + 48 >> 2] = Math_fround(.00100000005);
 i6 = i8 + 52 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i8 + 36 >> 2] = 0;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP16[i8 + 132 >> 1] = 9;
 i5 = i8 + 72 | 0;
 i1 = i11 ? 54 : 38;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP32[i7 >> 2] | 0) == 2) {
  HEAPF32[i6 >> 2] = Math_fround(.0599999987);
  HEAPF32[i8 + 56 >> 2] = Math_fround(1.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i1 = __Z25computePacketSizeMultLog2ff(Math_fround(.600000024), Math_fround(.0599999987)) | 0;
 } else {
  HEAP32[i5 >> 2] = i1 | 65536;
  HEAPF32[i6 >> 2] = Math_fround(.0199999996);
  HEAPF32[i8 + 56 >> 2] = Math_fround(2.0);
  f2 = Math_fround(1.0e3);
  f3 = Math_fround(6.0);
  f4 = Math_fround(20.0);
  i1 = __Z25computePacketSizeMultLog2ff(Math_fround(.600000024), Math_fround(.0399999991)) | 0;
 }
 HEAP32[i8 + 76 >> 2] = i1;
 HEAPF32[i8 + 100 >> 2] = f4;
 HEAPF32[i8 + 60 >> 2] = f3;
 HEAPF32[i8 + 92 >> 2] = f2;
 HEAPF32[i8 + 104 >> 2] = Math_fround(.0599999987);
 HEAPF32[i8 + 108 >> 2] = Math_fround(.00400000019);
 HEAPF32[i8 + 112 >> 2] = Math_fround(.00800000038);
 HEAPF32[i8 + 96 >> 2] = Math_fround(0.0);
 HEAP32[i8 + 136 >> 2] = 0;
 HEAPF32[i8 + 80 >> 2] = Math_fround(.5);
 HEAPF32[i8 + 84 >> 2] = Math_fround(.0500000007);
 HEAPF32[i8 + 88 >> 2] = Math_fround(0.0);
 HEAP32[i8 + 116 >> 2] = 0;
 HEAP32[i8 + 120 >> 2] = 0;
 HEAP32[i8 + 124 >> 2] = 1065353216;
 HEAP32[i8 + 128 >> 2] = 0;
 i8 = i10 >>> 0 < 4294967294 ? i10 : -2;
 i1 = __ZN5physx15PxsParticleData6createEjb(i8, i11) | 0;
 HEAP32[i9 >> 2] = i1;
 if ((i8 | 0) == 0 | i11 ^ 1) {
  STACKTOP = i12;
  return;
 }
 _memset(HEAP32[i1 + 52 >> 2] | 0, 0, (i10 >>> 0 < 4294967294 ? -4 - (i10 << 2 ^ -4) | 0 : -8) | 0) | 0;
 STACKTOP = i12;
 return;
}

function __Z14OrthoNormalizeP8Vector3fS0_(i9, i11) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0;
 f1 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(f1 * f1);
 i10 = i9 + 4 | 0;
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f2 * f2));
 i8 = i9 + 8 | 0;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f4 * f4))));
 if (f3 > Math_fround(9.99999974e-06)) {
  f1 = Math_fround(f1 / f3);
  HEAPF32[i9 >> 2] = f1;
  f5 = Math_fround(f2 / f3);
  HEAPF32[i10 >> 2] = f5;
  f2 = f1;
  f1 = Math_fround(f4 / f3);
 } else {
  HEAPF32[i9 >> 2] = Math_fround(1.0);
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  f2 = Math_fround(1.0);
  f5 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i8 >> 2] = f1;
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f2 * f14);
 i6 = i11 + 4 | 0;
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f5 * f12));
 i7 = i11 + 8 | 0;
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f1 * f4));
 f5 = Math_fround(f5 * f13);
 f3 = Math_fround(f1 * f13);
 f1 = Math_fround(f14 - Math_fround(f2 * f13));
 HEAPF32[i11 >> 2] = f1;
 f2 = Math_fround(f12 - f5);
 HEAPF32[i6 >> 2] = f2;
 f3 = Math_fround(f4 - f3);
 HEAPF32[i7 >> 2] = f3;
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(Math_fround(f2 * f2) + Math_fround(f1 * f1)))));
 if (!(f4 < Math_fround(9.99999974e-06))) {
  HEAPF32[i11 >> 2] = Math_fround(f1 / f4);
  HEAPF32[i6 >> 2] = Math_fround(f2 / f4);
  f14 = Math_fround(f3 / f4);
  HEAPF32[i7 >> 2] = f14;
  return;
 }
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = f1 < Math_fround(0.0);
 f14 = Math_fround(-f1);
 if ((i8 ? f14 : f1) > Math_fround(.707106769)) {
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f3 * f3)))));
  f3 = Math_fround(f3 * f2);
  f1 = Math_fround(-Math_fround(f1 * f2));
  f2 = Math_fround(0.0);
 } else {
  f1 = Math_fround(HEAPF32[i9 >> 2]);
  f2 = Math_fround(f1 * f1);
  f14 = Math_fround(HEAPF32[i10 >> 2]);
  f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f2 + Math_fround(f14 * f14)))));
  f3 = Math_fround(0.0);
  f1 = Math_fround(f1 * f2);
  f2 = Math_fround(-Math_fround(f14 * f2));
 }
 HEAPF32[i11 >> 2] = f2;
 HEAPF32[i6 >> 2] = f1;
 f14 = f3;
 HEAPF32[i7 >> 2] = f14;
 return;
}

function __ZN8Animator8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN14DirectorPlayer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 __ZN4PPtrI6AvatarE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 104 | 0, i8);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 108 | 0, i8);
 i5 = i7 + 92 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i10 = i8 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i8 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i5 = i7 + 96 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i7 + 417 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 418 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i1 = i7 + 561 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i7 + 560 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN24GenerateTypeTreeTransfer8TransferI12WheelJoint2DEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 803207 | 0, i2, i4);
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i1);
 i3 = i2 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803220 | 0, gb + 803233 | 0, i3, 0);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803283 | 0, i5, i3, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 853582 | 0, i5, i2 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803298 | 0, i5, i2 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803251 | 0, HEAP32[gb + 36972 >> 2] | 0, i2 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 i6 = i2 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803262 | 0, gb + 803270 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803306 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 803319 | 0, i5, i2 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __Z24Sprite_Get_Custom_PropUvP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i3) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 HEAP32[i6 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 76 >> 2];
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE(i2, 0, i6, i1 + 32 | 0);
 i5 = i2 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0, 8, i3) | 0;
 if (!i3) {
  STACKTOP = i7;
  return i4 | 0;
 }
 i2 = i1 + 8 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i5 + (i1 * 20 | 0) + 12 >> 2] | 0;
  i5 = HEAP32[i5 + (i1 * 20 | 0) + 16 >> 2] | 0;
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 8) | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return i4 | 0;
}

function __ZNK14RenderSettings6GetSunEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i1 + 388 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
  }
  if ((i7 | 0) == 7) i7 = 9;
  if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) break;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 16; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 16; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 18;
   }
  }
  if ((i7 | 0) == 16) i7 = 18;
  if ((i7 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
  i9 = i1;
  STACKTOP = i8;
  return i9 | 0;
 } while (0);
 i9 = __Z29FindBrightestDirectionalLightb(0) | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN20OcclusionCullingData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 32 | 0;
 i7 = i5;
 i4 = i5 + 40 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i11 = gb + 64016 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379023 | 0, i9, i4, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379033 | 0, i9, i1 + 36 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 379042 | 0, i7, 0);
 __ZN14OcclusionScene8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i3);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z26NavMesh_CUSTOM_TriangulatePP11Il2CppArrayS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10;
 i5 = i10 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i8 = i5 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i4 = i14;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = i9;
 HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i5 + 20 >> 2] = 0;
 i13 = i5 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 i3 = i5 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i6 = i14;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 HEAP32[i5 + 40 >> 2] = 0;
 i12 = i5 + 52 | 0;
 HEAP32[i12 >> 2] = 0;
 i11 = i5 + 56 | 0;
 HEAP32[i11 >> 2] = 0;
 i6 = i5 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, gb + 63664 | 0);
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i7 + 4 >> 2] = i15;
 __ZNK14NavMeshManager11TriangulateERNS_13TriangulationE(__Z17GetNavMeshManagerv() | 0, i5);
 i7 = i5 + 40 | 0;
 i15 = HEAP32[i7 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
 i12 = (i15 | 0) == 0 ? 0 : i12;
 i14 = __Z19scripting_array_newP11Il2CppClassjj(i14, 12, i12) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i14, 0, 12) | 0, i15 | 0, i12 * 12 | 0) | 0;
 HEAP32[i1 >> 2] = i14;
 i1 = i5 + 20 | 0;
 i14 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i13 = (i14 | 0) == 0 ? 0 : i13;
 i12 = __Z19scripting_array_newP11Il2CppClassjj(i12, 4, i13) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i12, 0, 4) | 0, i14 | 0, i13 << 2 | 0) | 0;
 HEAP32[i2 >> 2] = i12;
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
  HEAP32[i7 >> 2] = 0;
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function _cff_make_private_dict(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 _memset(i10 | 0, 0, 196) | 0;
 i8 = HEAP32[i9 + 176 >> 2] | 0;
 i1 = i8 & 255;
 HEAP8[i10 + 8 >> 0] = i1;
 i2 = i8 & 255;
 i3 = (i8 & 65535) >>> 8;
 i4 = i3 & 255;
 i5 = i8 >>> 16;
 i6 = i5 & 255;
 i8 = i8 >>> 24;
 i7 = i8 & 255;
 if (i1 << 24 >> 24) {
  i1 = 0;
  do {
   HEAP16[i10 + 12 + (i1 << 1) >> 1] = HEAP32[i9 + 180 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP8[i10 + 9 >> 0] = i4;
 i2 = i3 & 65535;
 if (i4 << 24 >> 24) {
  i1 = 0;
  do {
   HEAP16[i10 + 40 + (i1 << 1) >> 1] = HEAP32[i9 + 236 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP8[i10 + 10 >> 0] = i6;
 i2 = i5 & 255;
 if (i6 << 24 >> 24) {
  i1 = 0;
  do {
   HEAP16[i10 + 60 + (i1 << 1) >> 1] = HEAP32[i9 + 276 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP8[i10 + 11 >> 0] = i7;
 if (i7 << 24 >> 24) {
  i1 = 0;
  do {
   HEAP16[i10 + 88 + (i1 << 1) >> 1] = HEAP32[i9 + 332 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 HEAP32[i10 + 108 >> 2] = HEAP32[i9 + 372 >> 2];
 HEAP32[i10 + 112 >> 2] = HEAP32[i9 + 376 >> 2];
 HEAP32[i10 + 116 >> 2] = HEAP32[i9 + 380 >> 2];
 HEAP16[i10 + 120 >> 1] = HEAP32[i9 + 384 >> 2];
 HEAP16[i10 + 122 >> 1] = HEAP32[i9 + 388 >> 2];
 i3 = HEAP16[i9 + 392 >> 1] | 0;
 i8 = i3 & 255;
 HEAP8[i10 + 124 >> 0] = i8;
 i2 = i3 & 255;
 i3 = (i3 & 65535) >>> 8;
 i4 = i3 & 255;
 if (i8 << 24 >> 24) {
  i1 = 0;
  do {
   HEAP16[i10 + 128 + (i1 << 1) >> 1] = HEAP32[i9 + 396 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP8[i10 + 125 >> 0] = i4;
 i2 = i3 & 65535;
 if (!(i4 << 24 >> 24)) {
  i8 = i9 + 500 | 0;
  i8 = HEAP8[i8 >> 0] | 0;
  i7 = i10 + 126 | 0;
  HEAP8[i7 >> 0] = i8;
  i7 = i9 + 512 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = i10 + 184 | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i9 + 508 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  return;
 } else i1 = 0;
 do {
  HEAP16[i10 + 154 + (i1 << 1) >> 1] = HEAP32[i9 + 448 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i8 = i9 + 500 | 0;
 i8 = HEAP8[i8 >> 0] | 0;
 i7 = i10 + 126 | 0;
 HEAP8[i7 >> 0] = i8;
 i7 = i9 + 512 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i10 + 184 | 0;
 HEAP32[i8 >> 2] = i7;
 i9 = i9 + 508 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i9;
 return;
}

function __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 96 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 96 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 96 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 96 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN19ComputeShaderKernelaSERKS_(i2, i3) | 0;
   i3 = i3 + 96 | 0;
   i2 = i2 + 96 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -96 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN19ComputeShaderKernelD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN19ComputeShaderKernelC2ERKS_(i2, i1);
   i1 = i1 + 96 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 96 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -96 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN19ComputeShaderKernelD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 44739242) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 96 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 22369621 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 44739242;
 if (i1 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 96 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 96 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN19ComputeShaderKernelC2ERKS_(i2, i1);
  i1 = i1 + 96 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 96 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function _UNITY_png_write_tEXt(i10, i4, i11, i1) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 80 | 0;
 i7 = i8;
 if (!i4) {
  HEAP8[i7 >> 0] = 0;
  _UNITY_png_error(i10, gb + 355356 | 0);
 }
 i3 = HEAP8[i4 >> 0] | 0;
 L5 : do if (!(i3 << 24 >> 24)) {
  i3 = 1;
  i2 = 0;
  i1 = i7;
 } else {
  i5 = 1;
  i2 = 0;
  i1 = i7;
  while (1) {
   L8 : do if (!i5) {
    i12 = (i3 & 255) > 160 | (i3 + -33 & 255) < 94;
    i5 = i12 & 1 ^ 1;
    i4 = i4 + 1 | 0;
    i3 = i12 ? i3 : 32;
   } else while (1) {
    i4 = i4 + 1 | 0;
    if ((i3 & 255) > 160 | (i3 + -33 & 255) < 94) {
     i5 = 0;
     break L8;
    }
    i3 = HEAP8[i4 >> 0] | 0;
    if (!(i3 << 24 >> 24)) {
     i3 = i5;
     break L5;
    }
   } while (0);
   HEAP8[i1 >> 0] = i3;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
   i3 = HEAP8[i4 >> 0] | 0;
   if (!(i2 >>> 0 < 79 & i3 << 24 >> 24 != 0)) {
    i3 = i5;
    break;
   }
  }
 } while (0);
 i12 = (i2 | 0) != 0 & (i3 | 0) != 0;
 i2 = (i12 << 31 >> 31) + i2 | 0;
 HEAP8[(i12 ? i1 + -1 | 0 : i1) >> 0] = 0;
 if (!i2) _UNITY_png_error(i10, gb + 355356 | 0);
 if (!i11) i9 = 0; else if (!(HEAP8[i11 >> 0] | 0)) i9 = 0; else {
  i1 = _strlen(i11) | 0;
  if (i1 >>> 0 > (2147483646 - i2 | 0) >>> 0) _UNITY_png_error(i10, gb + 355378 | 0); else i9 = i1;
 }
 i1 = i2 + 1 | 0;
 i2 = i1 + i9 | 0;
 i3 = (i10 | 0) == 0;
 if (i3) {
  STACKTOP = i8;
  return;
 }
 i12 = i10 + 656 | 0;
 HEAP32[i12 >> 2] = 34;
 HEAP8[i6 >> 0] = i2 >>> 24;
 HEAP8[i6 + 1 >> 0] = i2 >>> 16;
 HEAP8[i6 + 2 >> 0] = i2 >>> 8;
 HEAP8[i6 + 3 >> 0] = i2;
 i5 = i6 + 4 | 0;
 HEAP8[i5 >> 0] = 116;
 HEAP8[i6 + 5 >> 0] = 69;
 HEAP8[i6 + 6 >> 0] = 88;
 HEAP8[i6 + 7 >> 0] = 116;
 _UNITY_png_write_data(i10, i6, 8);
 HEAP32[i10 + 372 >> 2] = 1950701684;
 _UNITY_png_reset_crc(i10);
 _UNITY_png_calculate_crc(i10, i5, 4);
 HEAP32[i12 >> 2] = 66;
 if (i1 | 0) {
  _UNITY_png_write_data(i10, i7, i1);
  _UNITY_png_calculate_crc(i10, i7, i1);
 }
 if ((i9 | 0) != 0 & (i11 | 0) != 0) {
  _UNITY_png_write_data(i10, i11, i9);
  _UNITY_png_calculate_crc(i10, i11, i9);
 }
 if (i3) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i10 + 656 >> 2] = 130;
 i12 = HEAP32[i10 + 408 >> 2] | 0;
 HEAP8[i6 >> 0] = i12 >>> 24;
 HEAP8[i6 + 1 >> 0] = i12 >>> 16;
 HEAP8[i6 + 2 >> 0] = i12 >>> 8;
 HEAP8[i6 + 3 >> 0] = i12;
 _UNITY_png_write_data(i10, i6, 4);
 STACKTOP = i8;
 return;
}

function __ZNK5Light16UnshareLightDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i6 = i1 + 44 | 0;
 if ((HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0) == 1) {
  STACKTOP = i7;
  return;
 }
 __ZNK6Object14GetMemoryLabelEv(i2, i1);
 i5 = __ZnwjRK10MemLabelIdiPKci(344, i2, 16, gb + 374128 | 0, 408) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = gb + 33936 + 8;
 i2 = i5 + 8 | 0;
 i3 = i1 + 8 | 0;
 i4 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 i2 = i5 + 60 | 0;
 i3 = i1 + 60 | 0;
 i4 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i5 + 124 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i5 + 128 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i5 + 132 >> 2] = HEAP32[i1 + 132 >> 2];
 HEAP32[i5 + 136 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i5 + 140 >> 2] = HEAP32[i1 + 140 >> 2];
 HEAP32[i5 + 144 >> 2] = HEAP32[i1 + 144 >> 2];
 HEAP32[i5 + 148 >> 2] = HEAP32[i1 + 148 >> 2];
 HEAP32[i5 + 152 >> 2] = HEAP32[i1 + 152 >> 2];
 i2 = i5 + 156 | 0;
 i3 = i1 + 156 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 i2 = i5 + 188 | 0;
 i3 = i1 + 188 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 + 204 >> 2] = HEAP32[i1 + 204 >> 2];
 __ZN19RenderEventsContextC2ERKS_(i5 + 208 | 0, i1 + 208 | 0);
 i2 = i5 + 216 | 0;
 i3 = i1 + 216 | 0;
 i4 = i2 + 128 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 HEAP32[i6 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZN4crnd12symbol_codec11decode_bitsEj(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 if (!i12) {
  i12 = 0;
  return i12 | 0;
 }
 if (i12 >>> 0 <= 16) {
  i8 = i10 + 20 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) < (i12 | 0)) {
   i6 = i10 + 4 | 0;
   i3 = i10 + 16 | 0;
   i5 = HEAP32[i10 + 8 >> 2] | 0;
   i7 = i1 + (i12 + -1 - i1 & -8) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   while (1) {
    if ((i2 | 0) == (i5 | 0)) {
     i2 = 0;
     i4 = i5;
    } else {
     i4 = i2 + 1 | 0;
     HEAP32[i6 >> 2] = i4;
     i2 = HEAPU8[i2 >> 0] | 0;
    }
    i11 = i1;
    i1 = i1 + 8 | 0;
    HEAP32[i8 >> 2] = i1;
    i2 = HEAP32[i3 >> 2] | i2 << 24 - i11;
    HEAP32[i3 >> 2] = i2;
    if ((i1 | 0) >= (i12 | 0)) break; else i2 = i4;
   }
   i1 = i7 + 8 | 0;
  } else {
   i2 = i10 + 16 | 0;
   i3 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i2 << i12;
  HEAP32[i8 >> 2] = i1 - i12;
  i12 = i2 >>> (32 - i12 | 0);
  return i12 | 0;
 }
 i8 = i12 + -16 | 0;
 i11 = i10 + 20 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if ((i4 | 0) < (i8 | 0)) {
  i6 = i10 + 4 | 0;
  i2 = i10 + 16 | 0;
  i5 = HEAP32[i10 + 8 >> 2] | 0;
  i7 = i4 + (i12 + -17 - i4 & -8) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if ((i1 | 0) == (i5 | 0)) {
    i1 = 0;
    i3 = i5;
   } else {
    i3 = i1 + 1 | 0;
    HEAP32[i6 >> 2] = i3;
    i1 = HEAPU8[i1 >> 0] | 0;
   }
   i9 = i4;
   i4 = i4 + 8 | 0;
   HEAP32[i11 >> 2] = i4;
   i1 = HEAP32[i2 >> 2] | i1 << 24 - i9;
   HEAP32[i2 >> 2] = i1;
   if ((i4 | 0) >= (i8 | 0)) break; else i1 = i3;
  }
  i4 = i7 + 8 | 0;
 } else {
  i1 = i10 + 16 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i9 = i1 >>> (48 - i12 | 0);
 HEAP32[i2 >> 2] = i1 << i8;
 i1 = i4 - i8 | 0;
 HEAP32[i11 >> 2] = i1;
 if ((i1 | 0) < 16) {
  i6 = i10 + 4 | 0;
  i3 = i10 + 16 | 0;
  i5 = HEAP32[i10 + 8 >> 2] | 0;
  i7 = i4 + (i12 + -1 - i4 & -8) + 24 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if ((i2 | 0) == (i5 | 0)) {
    i2 = 0;
    i4 = i5;
   } else {
    i4 = i2 + 1 | 0;
    HEAP32[i6 >> 2] = i4;
    i2 = HEAPU8[i2 >> 0] | 0;
   }
   i10 = i1;
   i1 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | i2 << 24 - i10;
   HEAP32[i3 >> 2] = i2;
   if ((i1 | 0) >= 16) break; else i2 = i4;
  }
  i1 = i7 - i12 | 0;
 } else {
  i2 = i10 + 16 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2 << 16;
 HEAP32[i11 >> 2] = i1 + -16;
 i12 = i2 >>> 16 | i9 << 16;
 return i12 | 0;
}

function __Z19TransferField_ArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 i6 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i8, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) {
  i4 = HEAP32[i3 + 24 >> 2] | 0;
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  i3 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) >> 4;
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
   HEAP32[i4 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i3) | 0;
   HEAP32[i2 >> 2] = i3;
  }
  if (i3 | 0) {
   i1 = 0;
   do {
    i5 = __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(HEAP32[i4 >> 2] | 0, i1) | 0;
    i2 = (HEAP32[i8 >> 2] | 0) + (i1 << 4) | 0;
    HEAP32[i5 >> 2] = __Z20scripting_string_newPKc((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i7 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i6 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i5 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
    i2 = HEAP32[i6 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i9;
 return;
}

function __ZN5physx7NpScene15removeAggregateERNS_11PxAggregateEb(i9, i10, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i1 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0) | 0;
 if ((i9 | 0) != (i1 | 0)) {
  i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i2 >> 2] = gb + 708987;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 8, gb + 678666 | 0, 76, gb + 708910 | 0, i2);
  STACKTOP = i11;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 52 >> 2] | 0, i10 | 0) | 0) != (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (!i5) i1 = i10 + 8 | 0; else {
  i6 = i10 + 40 | 0;
  i1 = i10 + 8 | 0;
  i7 = 0;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0) == 4) {
    if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) {
     i2 = HEAP32[i2 + 288 >> 2] | 0;
     i3 = HEAP32[i2 + 88 >> 2] | 0;
     if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0) | 0) {
      i4 = 0;
      do {
       __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i1, (HEAP32[i3 + (i4 << 2) >> 2] | 0) + 48 | 0, 0);
       i4 = i4 + 1 | 0;
      } while (i4 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0) | 0) >>> 0);
     }
     __ZN5physx7NpScene26removeArticulationInternalERNS_14PxArticulationEbb(i9, i2, i8, 0);
    }
   } else {
    __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i1, i2 + (HEAP32[gb + 1457020 + 68 + ((HEAPU16[i2 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0);
    __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb(i9, i2, i8, 0);
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i5 | 0));
 }
 __ZN5physx3Scb5Scene15removeAggregateERNS0_9AggregateE(i9 + 16 | 0, i1);
 i5 = i9 + 3576 | 0;
 i3 = i9 + 3580 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L23 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i10 | 0)) break L23;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 i9 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i9;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 + (i1 << 2) >> 2] = HEAP32[i10 + (i9 << 2) >> 2];
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyItEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i2, i1, i13, i3, i12, i14) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 4 | 0;
 i11 = i15;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i14; else {
  HEAP32[gb + 1457160 >> 2] = (HEAP32[gb + 1457160 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i11 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i10 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i11 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i10 = 9;
   } else i10 = 8;
  }
  if ((i10 | 0) == 8) {
   i9 = _strlen(i1) | 0;
   i8 = i1 + i9 | 0;
   if ((i9 | 0) > 0) {
    i5 = i1;
    i9 = 0;
    i4 = 0;
    i2 = 0;
    i3 = 0;
    while (1) {
     if (!i5) i7 = i3; else if (!(HEAP8[i5 >> 0] | 0)) i7 = i3; else i7 = (_strtoul(i5, i11, 10) | 0) & 65535;
     i3 = i9 + 2 | 0;
     if (i4 >>> 0 < i3 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i3 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i4 | 0) | 0;
      if (i9 | 0) _memcpy(i5 | 0, i2 | 0, i9 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 | 0);
      i6 = i5;
      i2 = i5;
     } else i6 = i2;
     i5 = i6 + i9 | 0;
     HEAP8[i5 >> 0] = i7;
     HEAP8[i5 + 1 >> 0] = i7 >> 8;
     i5 = HEAP32[i11 >> 2] | 0;
     if (i5 >>> 0 >= i8 >>> 0) break; else {
      i9 = i3;
      i3 = i7;
     }
    }
    i4 = i1;
    i3 = i3 >>> 1;
    i1 = i14;
   } else i10 = 9;
  }
  if ((i10 | 0) == 9) {
   i4 = i1;
   i2 = 0;
   i3 = 0;
   i1 = i14;
  }
  HEAP32[i13 >> 2] = i2;
  HEAP32[i12 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, 0);
 STACKTOP = i15;
 return;
}

function __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiiiiiS0_iiiii(i10, i3, i15, i16, i2, i17, i18, i19, i20, i8, i11, i12, i1, i13, i14) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i1 = HEAP32[i3 + 32 >> 2] | 0;
  i4 = i2 + (i1 << 3) | 0;
  i5 = i3;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i6, i3, i7);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i5 = HEAP32[gb + 1157724 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[i5 + 32 >> 2] | 0;
 }
 i3 = i2 + (i1 << 3) | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 if ((HEAP32[i5 + 36 >> 2] | 0) != (HEAP32[i5 + 4 >> 2] | 0)) {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i6, i5, i7);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i2 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i2 + (i3 << 3) | 0;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10 + 4620 | 0;
 if (!(__ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_(i1, i4, i2) | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii(i1, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, HEAP32[i4 + 20 >> 2] | 0, i15, i16, i17, i18, 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0, i11, i12, i13, i14, 0, 1, 1, i19, i20, 1);
 STACKTOP = i9;
 return;
}

function __ZL39WriteQueueForTransferFunctionIntoCache2I9JSONWriteEvP11Il2CppClassR23CachedSerializationDataRb(i1, i7, i14) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16;
 i11 = i16 + 32 | 0;
 i15 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP16[i11 + 16 >> 1] = 8;
 HEAP32[i15 >> 2] = 0;
 i1 = i15 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i8 = i15 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i5;
 i10 = i15 + 20 | 0;
 HEAP8[i10 >> 0] = HEAP8[i14 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i11, i15, i7, 0, 0);
 i11 = i7 + 4 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i5 + 1;
 i11 = i7 + 8 + (i5 * 24 | 0) | 0;
 i6 = i7 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i15 | 0) != (i6 | 0)) {
  i12 = HEAP32[i15 >> 2] | 0;
  i13 = i7 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i13 >> 2] = i2;
  i3 = i7 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i7 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i7 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i13 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i12 | 0, HEAP32[i13 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i11 >> 0] = 8;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i14 >> 0] = (HEAP8[i14 >> 0] | 0) == 0 ? HEAP8[i10 >> 0] | 0 : 1;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i9);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZNSt3__26vectorIN12FlareManager10FlareEntryENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 52 | 0) + 1 | 0;
 if (i4 >>> 0 > 82595524) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 52 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 41297762 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 82595524;
 i5 = (i1 - i2 | 0) / 52 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 52 | 0) | 0;
 i7 = i6 + (i5 * 52 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 52 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + (i5 * 52 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + (i5 * 52 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + (i5 * 52 | 0) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i4 = i6 + (i5 * 52 | 0) + 28 | 0;
 i8 = i8 + 28 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP16[i4 + 20 >> 1] = HEAP16[i8 + 20 >> 1] | 0;
 i4 = i7 + 52 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i8 = i1 + -52 | 0;
   i7 = i3;
   i3 = i3 + -52 | 0;
   HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   i8 = i1 + -24 | 0;
   i7 = i7 + -24 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP16[i8 + 20 >> 1] = HEAP16[i7 + 20 >> 1] | 0;
   i1 = i2 + -52 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9JSONWrite8TransferI11KeyframeTplIfEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite10SetVersionEi(i10, 2);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1034360 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1034365 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1034371 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1034379 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx17ConvexHullBuilder19ComputeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_(i9, i2, i3, i1, i6) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i5 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 i8 = i9 + 32 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = i9 + 20 | 0;
 HEAP8[(HEAP32[i4 >> 2] | 0) + 38 >> 0] = i2;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 8 | 0, (i2 & 255) * 12 | 0, gb + 726825 | 0, 1657) | 0;
 HEAP32[i9 >> 2] = i2;
 _memcpy(i2 | 0, i3 | 0, (HEAPU8[(HEAP32[i4 >> 2] | 0) + 38 >> 0] | 0) * 12 | 0) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = i2 >>> 0 > 357913941 ? -1 : i2 * 12 | 0;
 if (!i1) {
  i3 = 0;
  i1 = i2;
 } else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i3 = mftCall_iiiiii(i11 | 0, i2 | 0, i1 | 0, (i3 ? gb + 726918 | 0 : gb + 837976 | 0) | 0, gb + 726825 | 0, 1660) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i9 + 36 >> 2] = i3;
 if (i1 | 0) {
  i1 = 0;
  do {
   i11 = i1 * 3 | 0;
   HEAP32[i3 + (i1 * 12 | 0) >> 2] = HEAP32[i6 + (i11 << 2) >> 2];
   HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i11 + 1 << 2) >> 2];
   HEAP32[i3 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i6 + (i11 + 2 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 HEAP32[i5 >> 2] = HEAPU8[(HEAP32[i4 >> 2] | 0) + 38 >> 0];
 __ZL9CleanHullRjPN5physx2Gu9TriangleTIjEES_PNS0_6PxVec3E(i8, i3, i5, HEAP32[i9 >> 2] | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP8[(HEAP32[i4 >> 2] | 0) + 38 >> 0] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 if (!(__ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb(i7, i3, 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!(__ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb(i2 & 255, i1, HEAP32[i7 >> 2] | 0, i3, 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!(__ZN5physx17ConvexHullBuilder17CreatePolygonDataEv(i9) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv(i9) | 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb(i8, i7, i5, i1, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0;
 if (!((i7 | 0) != 0 | i1 ^ 1)) {
  i1 = i8 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i8 = 1;
  return i8 | 0;
 }
 i3 = i8 + 8 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) < (i7 | 0) | (i6 | 0) > (i7 | 0) & i1) {
  if (i2) i2 = i7; else {
   i2 = i7 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 * 28 | 0) + 16 | 0, 0) | 0;
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i6 = i1 + 16 | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[i6 + (i1 * 28 | 0) + 8 >> 2] = 2147483647;
    HEAP32[i6 + (i1 * 28 | 0) + 12 >> 2] = 2147483647;
    HEAP32[i6 + (i1 * 28 | 0) + 16 >> 2] = -2147483647;
    HEAP32[i6 + (i1 * 28 | 0) + 20 >> 2] = -2147483647;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i2;
  i4 = i8 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   if (i5) {
    i2 = HEAP32[i8 + 12 >> 2] | 0;
    if (i2) {
     i3 = (i2 | 0) <= (i7 | 0) ? i2 : i7;
     if ((i3 | 0) > 0) {
      i2 = 0;
      do {
       i10 = i1 + (i2 * 28 | 0) | 0;
       i9 = HEAP32[i10 + 4 >> 2] | 0;
       i5 = i6 + (i2 * 28 | 0) | 0;
       HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i5 + 4 >> 2] = i9;
       i5 = i1 + (i2 * 28 | 0) + 8 | 0;
       i9 = HEAP32[i5 + 4 >> 2] | 0;
       i10 = i6 + (i2 * 28 | 0) + 8 | 0;
       HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
       HEAP32[i10 + 4 >> 2] = i9;
       i10 = i1 + (i2 * 28 | 0) + 16 | 0;
       i9 = HEAP32[i10 + 4 >> 2] | 0;
       i5 = i6 + (i2 * 28 | 0) + 16 | 0;
       HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
       HEAP32[i5 + 4 >> 2] = i9;
       HEAP32[i6 + (i2 * 28 | 0) + 24 >> 2] = HEAP32[i1 + (i2 * 28 | 0) + 24 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i3 | 0));
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) break;
     }
    }
   }
   i10 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 + -16 | 0);
  } while (0);
  HEAP32[i4 >> 2] = i6;
 }
 HEAP32[i8 + 12 >> 2] = i7;
 i10 = 1;
 return i10 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i19 = HEAP32[i5 + 4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f23 = Math_fround(-f17);
 f22 = Math_fround(-f16);
 f6 = Math_fround(-f15);
 f7 = Math_fround(HEAPF32[i19 + 96 >> 2]);
 f18 = Math_fround(HEAPF32[i19 + 100 >> 2]);
 f13 = Math_fround(HEAPF32[i19 + 104 >> 2]);
 f8 = Math_fround(HEAPF32[i19 + 112 >> 2]);
 f12 = Math_fround(HEAPF32[i19 + 116 >> 2]);
 f14 = Math_fround(HEAPF32[i19 + 120 >> 2]);
 f9 = Math_fround(HEAPF32[i19 + 128 >> 2]);
 f11 = Math_fround(HEAPF32[i19 + 132 >> 2]);
 f10 = Math_fround(HEAPF32[i19 + 136 >> 2]);
 f21 = Math_fround(Math_fround(Math_fround(f7 * f23) + Math_fround(f18 * f22)) + Math_fround(f13 * f6));
 f20 = Math_fround(Math_fround(Math_fround(f8 * f23) + Math_fround(f12 * f22)) + Math_fround(f14 * f6));
 f6 = Math_fround(Math_fround(Math_fround(f9 * f23) + Math_fround(f11 * f22)) + Math_fround(f10 * f6));
 i19 = f21 > f20 & f21 > f6;
 i1 = f20 > f6;
 f9 = i19 ? f7 : i1 ? f8 : f9;
 f11 = i19 ? f18 : i1 ? f12 : f11;
 f10 = i19 ? f13 : i1 ? f14 : f10;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i5 + 96 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 100 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 104 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * f13)) + Math_fround(f15 * f12));
 f8 = Math_fround(HEAPF32[i5 + 112 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 116 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 120 >> 2]);
 i5 = f18 > Math_fround(Math_fround(Math_fround(f17 * f8) + Math_fround(f16 * f7)) + Math_fround(f15 * f6));
 f8 = i5 ? f14 : f8;
 f7 = i5 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14dynamic_bitset6resizeEjb(i9, i10, i8) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i9 + 12 | 0;
 if ((HEAP32[i11 >> 2] | 0) == (i10 | 0)) return;
 if (!i10) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  i13 = i9 + 8 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i9);
  HEAP32[i13 >> 2] = 0;
  return;
 }
 i12 = (i10 + 31 | 0) >>> 5;
 i1 = i12 << 2;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9, 0, gb + 391709 | 0, 399) | 0;
 i6 = i7;
 i13 = i9 + 8 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i11 >> 2] | 0) >>> 0 > i10 >>> 0) {
  if (!i12) i1 = i3; else {
   _memmove(i7 | 0, i3 | 0, i1 | 0) | 0;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  HEAP32[i13 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  i1 = i9 + 16 | 0;
 } else {
  i1 = i9 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i4 = 0; else {
   _memmove(i7 | 0, i3 | 0, i2 << 2 | 0) | 0;
   i4 = HEAP32[i1 >> 2] | 0;
  }
  i5 = i8 << 31 >> 31;
  i2 = i12 - i4 << 2;
  if ((i2 | 0) > 0) {
   i3 = i2 >> 2;
   i2 = i7 + (i4 << 2) | 0;
   while (1) {
    HEAP32[i2 >> 2] = i5;
    if ((i3 | 0) > 1) {
     i3 = i3 + -1 | 0;
     i2 = i2 + 4 | 0;
    } else break;
   }
   i2 = HEAP32[i1 >> 2] | 0;
  } else i2 = i4;
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = i6;
  i3 = HEAP32[i11 >> 2] | 0;
  do if (i3 >>> 0 < i2 << 5 >>> 0) {
   i2 = 1 << (i3 & 31);
   if (i8) {
    i8 = i7 + (i3 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i2;
    i2 = i3 + 1 | 0;
    if (i2 >>> 0 >= HEAP32[i1 >> 2] << 5 >>> 0) break;
    do {
     i8 = (HEAP32[i13 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i2 & 31);
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < HEAP32[i1 >> 2] << 5 >>> 0);
   } else {
    i8 = i7 + (i3 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~i2;
    i2 = i3 + 1 | 0;
    if (i2 >>> 0 >= HEAP32[i1 >> 2] << 5 >>> 0) break;
    do {
     i8 = (HEAP32[i13 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
     HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~(1 << (i2 & 31));
     i2 = i2 + 1 | 0;
    } while (i2 >>> 0 < HEAP32[i1 >> 2] << 5 >>> 0);
   }
  } while (0);
  if (i4) __Z19free_alloc_internalPvRK10MemLabelId(i4, i9);
 }
 HEAP32[i11 >> 2] = i10;
 HEAP32[i1 >> 2] = i12;
 i1 = i10 & 31;
 if (!i1) return;
 i13 = (HEAP32[i13 >> 2] | 0) + (i12 + -1 << 2) | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & ~(-1 << i1);
 return;
}

function __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIN7mecanim5human9HumanGoalELi4EEEEvRT_17TransferMetaFlags(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i11, gb + 1041885 | 0, gb + 1041885 | 0, i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i7 >>> 0 > 4 ? 4 : i7;
 HEAP32[i2 >> 2] = i8;
 i1 = i2 + 4 | 0;
 i8 = (HEAP32[i1 >> 2] | 0) + (i8 << 6) | 0;
 do if (i7 | 0) {
  i7 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899270 | 0, 0, 1) | 0;
  i4 = i11 + 80 | 0;
  i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i4 >> 2] | 0) | 0) + 12 >> 2] | 0;
  i6 = i11 + 84 | 0;
  HEAP32[HEAP32[i6 >> 2] >> 2] = 0;
  if ((i7 | 0) == 2) {
   i2 = HEAP32[i4 >> 2] | 0;
   i7 = HEAP32[i2 + 12 >> 2] | 0;
   i1 = HEAP32[i1 >> 2] | 0;
   L8 : do if ((i1 | 0) != (i8 | 0)) {
    i3 = 0;
    while (1) {
     i13 = (Math_imul(i3, i5) | 0) + i7 | 0;
     HEAP32[i2 + 20 >> 2] = i13;
     HEAP32[i2 + 12 >> 2] = i13;
     __ZNK16TypeTreeIterator8ChildrenEv(i9, i2);
     i13 = i9;
     i12 = HEAP32[i13 + 4 >> 2] | 0;
     i3 = i2 + 24 | 0;
     HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
     HEAP32[i3 + 4 >> 2] = i12;
     i3 = HEAP32[i6 >> 2] | 0;
     HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
     __ZN7mecanim5human9HumanGoal8TransferI14SafeBinaryReadEEvRT_(i1, i11);
     i1 = i1 + 64 | 0;
     if ((i1 | 0) == (i8 | 0)) break L8;
     i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
     i2 = HEAP32[i4 >> 2] | 0;
    }
   } while (0);
   __ZN14SafeBinaryRead11EndTransferEv(i11);
   break;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i11);
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i8 | 0)) do {
   i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i11, gb + 1041891 | 0, gb + 899270 | 0, i9, 1) | 0;
   if (i2 | 0) {
    if ((i2 | 0) > 0) __ZN7mecanim5human9HumanGoal8TransferI14SafeBinaryReadEEvRT_(i1, i11); else {
     i2 = HEAP32[i9 >> 2] | 0;
     if (i2 | 0) mftCall_iii(i2 | 0, i1 | 0, i11 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i11);
   }
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i8 | 0));
 } while (0);
 __ZN14SafeBinaryRead16EndArrayTransferEv(i11);
 STACKTOP = i10;
 return;
}

function __ZN13SplatDatabase21SetAlphamapResolutionEi(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i13 = i16;
 i14 = i11 + 36 | 0;
 HEAP32[i14 >> 2] = i1;
 i9 = i11 + 12 | 0;
 i10 = i11 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) == (i1 | 0)) {
  __ZN13SplatDatabase18RecalculateBasemapEb(i11, 0);
  STACKTOP = i16;
  return;
 }
 i6 = i12 + 4 | 0;
 i7 = i12 + 8 | 0;
 i8 = i12 + 12 | 0;
 i5 = 0;
 do {
  i4 = i1 + (i5 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i13 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i15 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i1, i13);
     i2 = HEAP32[i12 >> 2] | 0;
     i17 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i17 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i17 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i15 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i15 = 12;
    }
   }
   if ((i15 | 0) == 10) i15 = 12;
   if ((i15 | 0) == 12) {
    i15 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i17 = HEAP32[i14 >> 2] | 0;
   __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i1, i17, i17, 5, 1) | 0;
   if (!i5) {
    HEAPF32[i12 >> 2] = Math_fround(1.0);
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i7 >> 2] = Math_fround(0.0);
    HEAPF32[i8 >> 2] = Math_fround(0.0);
   } else {
    HEAP32[i12 >> 2] = 0;
    HEAP32[i12 + 4 >> 2] = 0;
    HEAP32[i12 + 8 >> 2] = 0;
    HEAP32[i12 + 12 >> 2] = 0;
   }
   __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf(i1, i12);
  } while (0);
  i5 = i5 + 1 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } while (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) - i1 >> 2 >>> 0);
 __ZN13SplatDatabase18RecalculateBasemapEb(i11, 0);
 STACKTOP = i16;
 return;
}

function __ZL39WriteQueueForTransferFunctionIntoCache2I8JSONReadEvP11Il2CppClassR23CachedSerializationDataRb(i1, i7, i14) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i16;
 i11 = i16 + 32 | 0;
 i15 = i16 + 8 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i1;
 HEAP32[i11 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP16[i11 + 16 >> 1] = 9;
 HEAP32[i15 >> 2] = 0;
 i1 = i15 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i8 = i15 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i5;
 i10 = i15 + 20 | 0;
 HEAP8[i10 >> 0] = HEAP8[i14 >> 0] | 0;
 __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i11, i15, i7, 0, 0);
 i11 = i7 + 4 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i5 + 1;
 i11 = i7 + 8 + (i5 * 24 | 0) | 0;
 i6 = i7 + 8 + (i5 * 24 | 0) + 4 | 0;
 if ((i15 | 0) != (i6 | 0)) {
  i12 = HEAP32[i15 >> 2] | 0;
  i13 = i7 + 8 + (i5 * 24 | 0) + 16 | 0;
  i1 = HEAP32[i1 >> 2] << 6;
  i2 = i1 >> 6;
  HEAP32[i13 >> 2] = i2;
  i3 = i7 + 8 + (i5 * 24 | 0) + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i7 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i7 + 8 + (i5 * 24 | 0) + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i13 >> 2] << 6 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  } else i1 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i12 | 0, HEAP32[i13 >> 2] << 6 | 0) | 0;
 }
 HEAP8[i11 >> 0] = 9;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i14 >> 0] = (HEAP8[i14 >> 0] | 0) == 0 ? HEAP8[i10 >> 0] | 0 : 1;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i16;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i9);
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i16;
 return;
}

function __ZL27BindVertexProgramAttributesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER14ChannelAssignsj(i13, i14, i15) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21;
 i16 = i21 + 4 | 0;
 i17 = i13 + 11 | 0;
 i18 = i13 + 4 | 0;
 i12 = 0;
 i1 = 0;
 L1 : while (1) {
  i11 = HEAP32[gb + 77044 + (i12 << 3) >> 2] | 0;
  i3 = HEAP8[i17 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i13 >> 2] | 0 : i13;
  i3 = i4 ? HEAP32[i18 >> 2] | 0 : i3 & 255;
  i4 = _strlen(i11) | 0;
  do if (i3 >>> 0 >= i4 >>> 0) {
   if (i4 | 0) {
    i9 = i2 + i3 | 0;
    i7 = i11 + i4 | 0;
    i8 = i9;
    i10 = i2;
    L7 : do if ((i3 | 0) < (i4 | 0)) i2 = i8; else {
     i5 = i9 + (1 - i4) | 0;
     if ((i5 | 0) == (i2 | 0)) i2 = i8; else {
      i6 = HEAP8[i11 >> 0] | 0;
      L10 : while (1) {
       while (1) {
        if ((HEAP8[i2 >> 0] | 0) == i6 << 24 >> 24) {
         i3 = i11;
         i4 = i2;
         break;
        }
        i2 = i2 + 1 | 0;
        if ((i2 | 0) == (i5 | 0)) {
         i2 = i8;
         break L7;
        }
       }
       do {
        i3 = i3 + 1 | 0;
        if ((i3 | 0) == (i7 | 0)) break L10;
        i4 = i4 + 1 | 0;
       } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
       i2 = i2 + 1 | 0;
       if ((i2 | 0) == (i5 | 0)) {
        i2 = i8;
        break L7;
       }
      }
     }
    } while (0);
    if ((i2 | 0) == (i9 | 0) | (i2 - i10 | 0) == -1) break;
   }
   i2 = HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 8 >> 2] | 0;
   if ((i1 | 0) >= (i2 | 0)) break L1;
   mftCall_viii(HEAP32[HEAP32[gb + 1451080 >> 2] >> 2] | 0, i15 | 0, i1 | 0, i11 | 0);
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1 << HEAP32[gb + 77044 + (i12 << 3) + 4 >> 2];
   i1 = i1 + 1 | 0;
  } while (0);
  i12 = i12 + 1 | 0;
  if (i12 >>> 0 >= 18) {
   i1 = 1;
   i20 = 19;
   break;
  }
 }
 if ((i20 | 0) == 19) {
  STACKTOP = i21;
  return i1 | 0;
 }
 HEAP32[i19 >> 2] = i2;
 __Z6FormatPKcz(i16, gb + 604892 | 0, i19);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i16 + 11 >> 0] | 0) < 0 ? HEAP32[i16 >> 2] | 0 : i16, 0, gb + 604722 | 0, 864, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i16);
 i20 = 0;
 STACKTOP = i21;
 return i20 | 0;
}

function _UNITY_png_handle_tRNS(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 i3 = HEAP32[i4 + 204 >> 2] | 0;
 if (!(i3 & 1)) _UNITY_png_chunk_error(i4, gb + 352205 | 0);
 if (i3 & 4 | 0) {
  _UNITY_png_crc_finish(i4, i1) | 0;
  _UNITY_png_chunk_benign_error(i4, gb + 352423 | 0);
  STACKTOP = i7;
  return;
 }
 if (i5 | 0) if (HEAP32[i5 + 8 >> 2] & 16 | 0) {
  _UNITY_png_crc_finish(i4, i1) | 0;
  _UNITY_png_chunk_benign_error(i4, gb + 352436 | 0);
  STACKTOP = i7;
  return;
 }
 L13 : do switch (HEAP8[i4 + 431 >> 0] | 0) {
 case 0:
  {
   if ((i1 | 0) == 2) {
    _UNITY_png_read_data(i4, i2, 2);
    _UNITY_png_calculate_crc(i4, i2, 2);
    i1 = i4 + 424 | 0;
    HEAP16[i1 >> 1] = 1;
    HEAP16[i4 + 536 >> 1] = HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0];
    break L13;
   }
   _UNITY_png_crc_finish(i4, i1) | 0;
   _UNITY_png_chunk_benign_error(i4, gb + 352446 | 0);
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   if ((i1 | 0) == 6) {
    _UNITY_png_read_data(i4, i2, 6);
    _UNITY_png_calculate_crc(i4, i2, 6);
    i1 = i4 + 424 | 0;
    HEAP16[i1 >> 1] = 1;
    HEAP16[i4 + 530 >> 1] = HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0];
    HEAP16[i4 + 532 >> 1] = HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
    HEAP16[i4 + 534 >> 1] = HEAPU8[i2 + 4 >> 0] << 8 | HEAPU8[i2 + 5 >> 0];
    break L13;
   }
   _UNITY_png_crc_finish(i4, i1) | 0;
   _UNITY_png_chunk_benign_error(i4, gb + 352446 | 0);
   STACKTOP = i7;
   return;
  }
 case 3:
  {
   if (!(i3 & 2)) {
    _UNITY_png_crc_finish(i4, i1) | 0;
    _UNITY_png_chunk_benign_error(i4, gb + 352423 | 0);
    STACKTOP = i7;
    return;
   }
   if (!(i1 >>> 0 > 256 ? 1 : (i1 + -1 | 0) >>> 0 >= (HEAPU16[i4 + 416 >> 1] | 0) >>> 0)) {
    _UNITY_png_read_data(i4, i6, i1);
    _UNITY_png_calculate_crc(i4, i6, i1);
    i3 = i4 + 424 | 0;
    HEAP16[i3 >> 1] = i1;
    i1 = i3;
    break L13;
   }
   _UNITY_png_crc_finish(i4, i1) | 0;
   _UNITY_png_chunk_benign_error(i4, gb + 352446 | 0);
   STACKTOP = i7;
   return;
  }
 default:
  {
   _UNITY_png_crc_finish(i4, i1) | 0;
   _UNITY_png_chunk_benign_error(i4, gb + 352454 | 0);
   STACKTOP = i7;
   return;
  }
 } while (0);
 if (!(_UNITY_png_crc_finish(i4, 0) | 0)) {
  _UNITY_png_set_tRNS(i4, i5, i6, HEAPU16[i1 >> 1] | 0, i4 + 528 | 0);
  STACKTOP = i7;
  return;
 } else {
  HEAP16[i1 >> 1] = 0;
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_(i7, i8, i6, i4, i5, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0;
 i3 = __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i7, i8, i6, i9) | 0;
 if (mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i6 | 0) | 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i2;
  i2 = i6 + 4 | 0;
  i1 = i4 + 4 | 0;
  i10 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i10;
  i1 = i3 + 1 | 0;
  if (mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, i8 | 0) | 0) {
   i1 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i6 >> 2] = i1;
   i1 = i8 + 4 | 0;
   i10 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i10;
   if (mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0) {
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i2;
    i2 = i7 + 4 | 0;
    i10 = HEAP32[i2 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i10;
    i3 = i3 + 3 | 0;
   } else i3 = i3 + 2 | 0;
  } else i3 = i1;
 }
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
  i10 = i3;
  return i10 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i1;
 i1 = i4 + 4 | 0;
 i10 = i5 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i5;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
  i10 = i3 + 1 | 0;
  return i10 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i2 = i6 + 4 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i6 | 0, i8 | 0) | 0)) {
  i10 = i3 + 2 | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i1;
 i1 = i8 + 4 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i10;
 if (!(mftCall_iii(HEAP32[i9 >> 2] | 0, i8 | 0, i7 | 0) | 0)) {
  i10 = i3 + 3 | 0;
  return i10 | 0;
 }
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i9;
 i9 = i7 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i10;
 i10 = i3 + 4 | 0;
 return i10 | 0;
}

function __ZNK14ParticleSystem27GetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticlei(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 switch (i3 | 0) {
 case 0:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 8 >> 2] | 0) != 2) {
    i5 = 0;
    return i5 | 0;
   }
   i1 = HEAP32[i5 + 652 >> 2] | 0;
   i1 = (i1 | 0) < (i4 | 0) ? i1 : i4;
   if ((i1 | 0) <= 0) {
    i5 = i1;
    return i5 | 0;
   }
   i4 = i5 + 640 | 0;
   i3 = 0;
   while (1) {
    __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i5, i2, 1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i1 | 0)) break; else i2 = i2 + 120 | 0;
   }
   return i1 | 0;
  }
 case 1:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 12 >> 2] | 0) != 2) {
    i5 = 0;
    return i5 | 0;
   }
   i1 = HEAP32[i5 + 672 >> 2] | 0;
   i1 = (i1 | 0) < (i4 | 0) ? i1 : i4;
   if ((i1 | 0) <= 0) {
    i5 = i1;
    return i5 | 0;
   }
   i4 = i5 + 660 | 0;
   i3 = 0;
   while (1) {
    __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i5, i2, 1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i1 | 0)) break; else i2 = i2 + 120 | 0;
   }
   return i1 | 0;
  }
 case 2:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 16 >> 2] | 0) != 2) {
    i5 = 0;
    return i5 | 0;
   }
   i1 = HEAP32[i5 + 692 >> 2] | 0;
   i1 = (i1 | 0) < (i4 | 0) ? i1 : i4;
   if ((i1 | 0) <= 0) {
    i5 = i1;
    return i5 | 0;
   }
   i4 = i5 + 680 | 0;
   i3 = 0;
   while (1) {
    __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i5, i2, 1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i1 | 0)) break; else i2 = i2 + 120 | 0;
   }
   return i1 | 0;
  }
 case 3:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 20 >> 2] | 0) != 2) {
    i5 = 0;
    return i5 | 0;
   }
   i1 = HEAP32[i5 + 712 >> 2] | 0;
   i1 = (i1 | 0) < (i4 | 0) ? i1 : i4;
   if ((i1 | 0) <= 0) {
    i5 = i1;
    return i5 | 0;
   }
   i4 = i5 + 700 | 0;
   i3 = 0;
   while (1) {
    __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i5, i2, 1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) >= (i1 | 0)) break; else i2 = i2 + 120 | 0;
   }
   return i1 | 0;
  }
 default:
  {
   i5 = 0;
   return i5 | 0;
  }
 }
 return 0;
}

function __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii(i9, i10, i6, i11, i12, i7, i13) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i14 = i9 + 72 + (i7 << 2) | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i9 + 40 | 0;
  i3 = i1;
  i2 = -1;
 } else {
  i3 = i9 + 40 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = i3;
  __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i8, (i4 | 0) == 0 ? 0 : i4 + i1 | 0, i12, i2);
  i4 = 124830 >>> i7 & 1;
  if (i4 | 0) HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i8 >> 2];
  i5 = 15106022 >>> i7 & 1;
  if (i5 | 0) HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) + 4 >> 2] << 2) >> 2] = HEAP32[i8 + 4 >> 2];
  if (i7 | 0) HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) >> 2] << 2) >> 2] = HEAP32[i8 + 8 >> 2];
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 | 0) == -1) i2 = -1; else {
   i16 = HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) + 4 >> 2] << 2) >> 2] & 0 - i5;
   i5 = i7 | 0 ? HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) >> 2] << 2) >> 2] | 0 : 0;
   HEAP32[i8 >> 2] = HEAP32[i6 + 596 + (HEAP32[gb + 177812 + (i7 * 12 | 0) + 8 >> 2] << 2) >> 2] & 0 - i4;
   HEAP32[i8 + 4 >> 2] = i16;
   HEAP32[i8 + 8 >> 2] = i5;
   i7 = HEAP32[i3 >> 2] | 0;
   __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei((i7 | 0) == 0 ? 0 : i7 + i1 | 0, i12, i8, i2);
   i2 = HEAP32[i14 >> 2] | 0;
  }
 }
 i8 = HEAP32[i3 >> 2] | 0;
 i16 = i9 + 72 + (i13 << 2) | 0;
 __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i8 | 0) == 0 ? 0 : i8 + i1 | 0, i12, i11, i2, HEAP32[i16 >> 2] | 0);
 i13 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_i((i13 | 0) == 0 ? 0 : i13 + i1 | 0, i10, i11, HEAP32[i14 >> 2] | 0);
 i13 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i13 | 0) == 0 ? 0 : i13 + i1 | 0, i11, i12, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc21ArticulationJointCoreC2ERKNS_11PxTransformES4_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = i3 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i12 >> 2] = 1065353216;
 i11 = i3 + 20 | 0;
 i10 = i3 + 44 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i10 >> 2] = 1065353216;
 i9 = i3 + 48 | 0;
 HEAP32[i9 >> 2] = 0;
 i8 = i3 + 52 | 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i3 + 56 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i3 + 144 | 0;
 HEAPF32[i6 >> 2] = Math_fround(.0500000007);
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 36 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 1065353216;
 i2 = i3 + 76 | 0;
 HEAP8[i3 + 125 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAPF32[i3 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 112 >> 2] = Math_fround(.785398185);
 HEAPF32[i3 + 116 >> 2] = Math_fround(.785398185);
 HEAPF32[i3 + 120 >> 2] = Math_fround(.0500000007);
 HEAP8[i3 + 124 >> 0] = 0;
 HEAPF32[i3 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 140 >> 2] = Math_fround(-.785398185);
 HEAPF32[i3 + 136 >> 2] = Math_fround(.785398185);
 HEAPF32[i6 >> 2] = Math_fround(.0500000007);
 HEAP8[i3 + 148 >> 0] = 0;
 f5 = Math_fround(+Math_tan(.196349546));
 HEAPF32[i3 + 152 >> 2] = f5;
 HEAPF32[i3 + 156 >> 2] = f5;
 f4 = Math_fround(+Math_tan(.0125000002));
 HEAPF32[i3 + 160 >> 2] = f4;
 HEAPF32[i3 + 164 >> 2] = f5;
 HEAPF32[i3 + 168 >> 2] = Math_fround(+Math_tan(-.196349546));
 HEAPF32[i3 + 172 >> 2] = f4;
 return;
}

function __ZNSt3__23mapI4PPtrI9TransformEN7VRInput18ReferenceTransformENS_4lessIS3_EE13stl_allocatorINS_4pairIKS3_S5_EEL18MemLabelIdentifier87ELi16EEEixERSA_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i5 = i10;
 i2 = i9 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i3 = i2;
  i4 = 12;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i4 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i4 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i4 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i4 | 0) == 5) {
   HEAP32[i5 >> 2] = i1;
   i6 = i1;
   i5 = i1;
   break;
  } else if ((i4 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i6 = i1;
   i5 = i3;
   break;
  } else if ((i4 | 0) == 10) {
   HEAP32[i5 >> 2] = i1;
   i3 = i1;
   i2 = i5;
   i4 = 12;
   break;
  }
 } while (0);
 if ((i4 | 0) == 12) if (!i1) {
  i6 = i3;
  i5 = i2;
 } else {
  i9 = i1;
  i9 = i9 + 20 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = 87;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(112, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
 i1 = i4 + 48 | 0;
 i2 = gb + 1162292 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i5 >> 2] = i4;
 i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if (!i1) i1 = i4; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i1);
 i9 = i9 + 12 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = i4;
 i9 = i9 + 20 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNK9dtNavMesh24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyPKfPf(i1, i3, i27, i28, i29) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f30 = f0, f31 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i25 = i26;
 i1 = i27 - (HEAP32[i3 + 16 >> 2] | 0) >> 5;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 i20 = i2 + (i1 * 12 | 0) + 10 | 0;
 if (!(HEAP16[i20 >> 1] | 0)) {
  STACKTOP = i26;
  return;
 }
 i21 = i2 + (i1 * 12 | 0) + 4 | 0;
 i22 = i3 + 32 | 0;
 i23 = i27 + 28 | 0;
 i24 = i3 + 20 | 0;
 i19 = i2 + (i1 * 12 | 0) | 0;
 i12 = i3 + 28 | 0;
 i13 = i25 + 4 | 0;
 i14 = i28 + 4 | 0;
 i15 = i25 + 8 | 0;
 i16 = i28 + 8 | 0;
 i17 = i29 + 4 | 0;
 i18 = i29 + 8 | 0;
 i11 = 0;
 f4 = Math_fround(3402823469999999843913219.0e14);
 do {
  i2 = (HEAP32[i22 >> 2] | 0) + ((HEAP32[i21 >> 2] | 0) + i11 << 2 << 1) | 0;
  i9 = HEAPU8[i23 >> 0] | 0;
  i1 = HEAPU16[i2 >> 1] | 0;
  if (i1 >>> 0 < i9 >>> 0) i10 = (HEAP32[i24 >> 2] | 0) + ((HEAPU16[i27 + (i1 << 1) >> 1] | 0) * 3 << 2) | 0; else i10 = (HEAP32[i12 >> 2] | 0) + ((i1 - i9 + (HEAP32[i19 >> 2] | 0) | 0) * 3 << 2) | 0;
  i1 = HEAPU16[i2 + 2 >> 1] | 0;
  if (i1 >>> 0 < i9 >>> 0) i3 = (HEAP32[i24 >> 2] | 0) + ((HEAPU16[i27 + (i1 << 1) >> 1] | 0) * 3 << 2) | 0; else i3 = (HEAP32[i12 >> 2] | 0) + ((i1 - i9 + (HEAP32[i19 >> 2] | 0) | 0) * 3 << 2) | 0;
  i1 = HEAPU16[i2 + 4 >> 1] | 0;
  if (i1 >>> 0 < i9 >>> 0) i1 = (HEAP32[i24 >> 2] | 0) + ((HEAPU16[i27 + (i1 << 1) >> 1] | 0) * 3 << 2) | 0; else i1 = (HEAP32[i12 >> 2] | 0) + ((i1 - i9 + (HEAP32[i19 >> 2] | 0) | 0) * 3 << 2) | 0;
  __Z24dtClosestPtPointTrianglePfPKfS1_S1_S1_(i25, i28, i10, i3, i1);
  f6 = Math_fround(HEAPF32[i25 >> 2]);
  f31 = Math_fround(f6 - Math_fround(HEAPF32[i28 >> 2]));
  f7 = Math_fround(HEAPF32[i13 >> 2]);
  f30 = Math_fround(f7 - Math_fround(HEAPF32[i14 >> 2]));
  f8 = Math_fround(HEAPF32[i15 >> 2]);
  f5 = Math_fround(f8 - Math_fround(HEAPF32[i16 >> 2]));
  f5 = Math_fround(Math_fround(Math_fround(f31 * f31) + Math_fround(f30 * f30)) + Math_fround(f5 * f5));
  if (f5 < f4) {
   HEAPF32[i29 >> 2] = f6;
   HEAPF32[i17 >> 2] = f7;
   HEAPF32[i18 >> 2] = f8;
   f4 = f5;
  }
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) < (HEAPU16[i20 >> 1] | 0));
 STACKTOP = i26;
 return;
}

function __ZNK19CollisionListener2D16IsTouchingLayersEPK10Collider2Di(i9, i11, i12) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0;
 i1 = HEAP32[i9 + 176 >> 2] | 0;
 i10 = HEAP32[i9 + 180 >> 2] | 0;
 i13 = i1 + (i10 * 80 | 0) | 0;
 L1 : do if (i10) {
  i3 = HEAP32[i9 + 96 >> 2] | 0;
  i4 = i9 + 100 | 0;
  i5 = i9 + 8 | 0;
  i6 = i9 + 16 | 0;
  i7 = i9 + 20 | 0;
  i8 = i9 + 12 | 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) {
    if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i14 = 5;
   } else i14 = 5;
   if ((i14 | 0) == 5) {
    i14 = 0;
    if (!(HEAP8[i8 >> 0] | 0)) break L1;
    if (!(HEAP32[i5 >> 2] | 0)) break L1;
    if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) break L1;
    if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break L1;
   }
   i1 = i1 + 80 | 0;
   if ((i1 | 0) == (i13 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i13 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i5 = i9 + 96 | 0;
 i6 = i9 + 100 | 0;
 i7 = i9 + 8 | 0;
 i8 = i9 + 16 | 0;
 i10 = i9 + 20 | 0;
 i4 = i9 + 12 | 0;
 L18 : while (1) {
  L20 : do if (HEAP8[i1 + 79 >> 0] | 0) {
   switch (HEAP32[i1 + 72 >> 2] | 0) {
   case 4:
   case 1:
    break;
   default:
    break L20;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if ((i3 | 0) == (i11 | 0)) {
    i2 = HEAP32[i2 >> 2] | 0;
    if (1 << HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 48 >> 2] & i12) {
     i1 = 1;
     i14 = 29;
     break L18;
    }
   } else i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) == (i11 | 0)) if (1 << HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 48 >> 2] & i12 | 0) {
    i1 = 1;
    i14 = 29;
    break L18;
   }
  } while (0);
  i1 = i1 + 80 | 0;
  if ((i1 | 0) == (i13 | 0)) {
   i1 = 0;
   i14 = 29;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) {
    if ((HEAP32[i6 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i14 = 24;
   } else i14 = 24;
   if ((i14 | 0) == 24) {
    i14 = 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i7 >> 2] | 0)) break;
    if ((HEAP32[i8 >> 2] | 0) != (i2 | 0)) break;
    if ((HEAP32[i10 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break;
   }
   i1 = i1 + 80 | 0;
   if ((i1 | 0) == (i13 | 0)) {
    i1 = 0;
    i14 = 29;
    break L18;
   }
  }
  if ((i1 | 0) == (i13 | 0)) {
   i1 = 0;
   i14 = 29;
   break;
  }
 }
 if ((i14 | 0) == 29) return i1 | 0;
 return 0;
}

function __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i21, i7) {
 i21 = i21 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i22 = 0;
 f15 = Math_fround(HEAPF32[i21 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i7 + 36 >> 2]));
 f20 = Math_fround(HEAPF32[i21 + 4 >> 2]);
 f20 = Math_fround(f20 - Math_fround(HEAPF32[i7 + 40 >> 2]));
 f9 = Math_fround(HEAPF32[i21 + 8 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i7 + 44 >> 2]));
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(f15 * f10);
 f11 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f20 * f11));
 f12 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f9 * f12));
 f13 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f5 = Math_fround(f15 * f13);
 f14 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f20 * f14));
 f16 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f9 * f16));
 f17 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f8 = Math_fround(f15 * f17);
 f18 = Math_fround(HEAPF32[i7 + 28 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f20 * f18));
 f19 = Math_fround(HEAPF32[i7 + 32 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f9 * f19));
 f2 = Math_fround(HEAPF32[i7 + 48 >> 2]);
 f3 = Math_fround(-f2);
 if (f1 < f3) {
  f2 = f3;
  i4 = 1;
 } else if (f1 > f2) i4 = 1; else {
  f2 = f1;
  i4 = 0;
 }
 f1 = Math_fround(HEAPF32[i7 + 52 >> 2]);
 f3 = Math_fround(-f1);
 if (f5 < f3) i6 = 1; else if (f5 > f1) {
  f3 = f1;
  i6 = 1;
 } else {
  f3 = f5;
  i6 = i4;
 }
 f5 = Math_fround(HEAPF32[i7 + 56 >> 2]);
 f1 = Math_fround(-f5);
 if (f8 < f1) i22 = 9; else {
  i4 = f8 > f5;
  if (i6 | i4) {
   f1 = i4 ? f5 : f8;
   i22 = 9;
  }
 }
 if ((i22 | 0) == 9) {
  f17 = Math_fround(f15 - Math_fround(Math_fround(Math_fround(f2 * f10) + Math_fround(f3 * f13)) + Math_fround(f1 * f17)));
  f20 = Math_fround(f20 - Math_fround(Math_fround(Math_fround(f2 * f11) + Math_fround(f3 * f14)) + Math_fround(f1 * f18)));
  f19 = Math_fround(f9 - Math_fround(Math_fround(Math_fround(f2 * f12) + Math_fround(f3 * f16)) + Math_fround(f1 * f19)));
  f19 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f20 * f20)) + Math_fround(f19 * f19));
  f20 = Math_fround(HEAPF32[i21 + 12 >> 2]);
  if (f19 > Math_fround(f20 * f20)) {
   i22 = 0;
   return i22 | 0;
  }
 }
 i22 = 1;
 return i22 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i3 = i13;
 i12 = i13 + 16 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i7 = i12 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 12) | 0;
 i2 = i1 + ((HEAP32[i2 + 4 >> 2] | 0) * 12 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i11);
 i2 = (i2 - i1 | 0) / 12 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i10 >> 2] = i2 | -2147483648;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i9 = i5 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = i1 + (i7 * 12 | 0) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZNK15NavMeshObstacle8HasMovedEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i4 + 136 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i1 & 8 | 0) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (i1 & 1) {
  __ZNK9Transform11GetPositionEv(i6, i2);
  f10 = Math_fround(HEAPF32[i4 + 92 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i6 >> 2]));
  f9 = Math_fround(HEAPF32[i4 + 96 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i6 + 4 >> 2]));
  f8 = Math_fround(HEAPF32[i4 + 100 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i6 + 8 >> 2]));
  if (!(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f8 * f8)) > Math_fround(f5 * f5))) {
   i1 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i6 = 1;
   STACKTOP = i7;
   return i6 | 0;
  }
 } while (0);
 do if (i1 & 2) {
  __ZNK9Transform11GetRotationEv(i6, i2);
  f11 = Math_fround(__Z15AngularDistanceRK11QuaternionfS1_(i4 + 104 | 0, i6));
  f8 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f10 = Math_fround(f10 * f10);
  f9 = Math_fround(HEAPF32[i4 + 124 >> 2]);
  f9 = Math_fround(f10 + Math_fround(f9 * f9));
  f10 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  if (!(Math_fround(Math_fround(f11 * f11) * Math_fround(f8 * Math_fround(f9 + Math_fround(f10 * f10)))) > Math_fround(f5 * f5))) {
   i1 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i6 = 1;
   STACKTOP = i7;
   return i6 | 0;
  }
 } while (0);
 if (i1 & 4 | 0) {
  __ZNK9Transform18GetWorldScaleLossyEv(i6, i2);
  f8 = Math_fround(HEAPF32[i4 + 132 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 120 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i6 >> 2]));
  f10 = Math_fround(HEAPF32[i4 + 124 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i6 + 4 >> 2]));
  f11 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i6 + 8 >> 2]));
  if (Math_fround(f8 * Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f11 * f11))) > Math_fround(f5 * f5)) {
   i6 = 1;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN14AvatarPlayback11RecordFrameEfPKN7mecanim9animation12AvatarMemoryEPNS1_16ControllerMemoryE(i9, f4, i2, i3) {
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i5 = i11;
 i7 = i9 + 16 | 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 901289 | 0, 0, gb + 901345 | 0, 104, 512, 0, 0, 0);
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = 0;
 i6 = i10 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i10 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i8 = i9 + 20 | 0;
 if ((HEAP32[i8 >> 2] | 0) != -1) HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP32[i9 + 28 >> 2] | 0) * 12 | 0) + 8 >> 2]) + f4);
 HEAP32[i5 >> 2] = 0;
 i1 = i9 + 32 | 0;
 HEAP32[i10 >> 2] = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i2, i1, i5) | 0;
 HEAP32[i5 >> 2] = 0;
 if (i3 | 0) HEAP32[i6 >> 2] = __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i3, i1, i5) | 0;
 i6 = i9 + 28 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = (i3 | 0) > 0;
 i1 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 if (i5) i1 = (i1 | 0) % (i3 | 0) | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0) | (i2 | 0) == -1) {
  i2 = i2 + 1 | 0;
  if (i5) i2 = (i2 | 0) % (i3 | 0) | 0;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i9 + 24 >> 2] = i1;
 i3 = i9 + 4 | 0;
 do if (i5) {
  i9 = i9 + 36 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, i9);
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 12 | 0) + 4 >> 2] | 0, i9);
  i9 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 } else {
  i1 = i9 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i9 + 12 >> 2] | 0)) {
   __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i10);
   break;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
   break;
  }
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZN14AreaEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800830 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 116 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800847 | 0, i6, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802350 | 0, i6, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802367 | 0, i6, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 112 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802414 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802440 | 0, i6, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802447 | 0, i6, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 136 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 136 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 136 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 136 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN15DetailPrototypeaSERKS_(i2, i3) | 0;
   i3 = i3 + 136 | 0;
   i2 = i2 + 136 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -136 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN15DetailPrototypeD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN15DetailPrototypeC2ERKS_(i2, i1);
   i1 = i1 + 136 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 136 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -136 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN15DetailPrototypeD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 31580641) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 136 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 15790320 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 31580641;
 if (i1 >>> 0 > 31580641) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 136 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 136 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN15DetailPrototypeC2ERKS_(i2, i1);
  i1 = i1 + 136 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 136 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZNK19CharacterController31ArePropertiesValidExplainErrorsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i4 + 80 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 if (f2 > Math_fround(90.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734120 | 0, 0, gb + 734039 | 0, 619, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  i1 = 0;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
 } else i1 = 1;
 if (f2 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734165 | 0, 0, gb + 734039 | 0, 624, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  i1 = 0;
 }
 if (Math_fround(HEAPF32[i4 + 76 >> 2]) <= Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734223 | 0, 0, gb + 734039 | 0, 629, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  i1 = 0;
 }
 i3 = i4 + 84 | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) <= Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734252 | 0, 0, gb + 734039 | 0, 634, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  i1 = 0;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f2 = Math_fround(HEAPF32[i4 + 88 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i5 + 4 >> 2]));
 i10 = f2 < Math_fround(0.0);
 f7 = Math_fround(-f2);
 f2 = i10 ? f7 : f2;
 i10 = f2 < Math_fround(9.99999974e-06);
 f2 = i10 ? Math_fround(9.99999974e-06) : f2;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i10 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i10 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i5 ? f9 : f8;
 f7 = Math_fround(Math_fround(HEAPF32[i4 + 92 >> 2]) * (f7 < f8 ? f8 : f7));
 f2 = Math_fround(f2 - Math_fround(f7 * Math_fround(2.0)));
 i5 = f2 < Math_fround(9.99999974e-06);
 f2 = i5 ? Math_fround(9.99999974e-06) : f2;
 i5 = f7 < Math_fround(9.99999974e-06);
 f7 = i5 ? Math_fround(9.99999974e-06) : f7;
 if (!(Math_fround(HEAPF32[i3 >> 2]) > Math_fround(Math_fround(f7 * Math_fround(2.0)) + f2))) {
  i10 = i1;
  STACKTOP = i6;
  return i10 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734282 | 0, 0, gb + 734039 | 0, 642, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
 i10 = 0;
 STACKTOP = i6;
 return i10 | 0;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i5 = i7 >>> 16 & 255;
  i6 = i7 >>> 24;
  f3 = Math_fround(Math_fround((i7 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 >> 1] = i2;
  f3 = Math_fround(Math_fround(i5 >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 2 >> 1] = i2;
  f3 = Math_fround(Math_fround(i6 >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 4 >> 1] = i2;
  f3 = Math_fround(Math_fround((i7 & 255) >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 6 >> 1] = i2;
  if (!i1) break; else {
   i9 = i9 + 8 | 0;
   i8 = i8 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i4 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i4 + ~(i4 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = i3 + ~(i3 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i2 >>> 16 ^ i2 ^ (i1 ^ -57320555 ^ i1 >>> 16) * 1000007) & i10 + -1;
  i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   while (1) {
    if ((HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i6 + (i1 * 12 | 0) | 0;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10 ^ (i11 ^ -57320555 ^ i11 >>> 16) * 1000007) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 * 12 | 0) | 0;
 return i12 | 0;
}

function __ZN13BuildSettings13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i13 = i16 + 4 | 0;
 i14 = i2 + 40 | 0;
 i5 = (HEAP32[i2 + 32 >> 2] | 0) - (HEAP32[i2 + 28 >> 2] | 0) >> 4;
 i12 = i2 + 44 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i14 >> 2] | 0;
 i3 = i1 - i4 >> 4;
 i2 = i1;
 if (i5 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj(i14, i5 - i3 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 } else if (i5 >>> 0 < i3 >>> 0) {
  i4 = i4 + (i5 << 4) | 0;
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i13 + 4 | 0;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i12 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i11 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i13 >> 2] = 66;
     HEAP32[i3 >> 2] = i11;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i13);
     i1 = HEAP32[i12 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 i2 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i16;
  return;
 }
 i10 = i13 + 11 | 0;
 i11 = i13 + 4 | 0;
 i9 = 0;
 i1 = i2;
 do {
  i2 = i1 + (i9 << 4) | 0;
  HEAP32[i15 >> 2] = i9;
  __Z6FormatPKcz(i13, gb + 443721 | 0, i15);
  i8 = HEAP8[i10 >> 0] | 0;
  i5 = i8 << 24 >> 24 < 0;
  i7 = i5 ? HEAP32[i13 >> 2] | 0 : i13;
  i8 = i5 ? HEAP32[i11 >> 2] | 0 : i8 & 255;
  i5 = i2 + 11 | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  if (i4) i6 = (HEAP32[i1 + (i9 << 4) + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
  do if (i8 >>> 0 > i6 >>> 0) {
   if (i4) i1 = HEAP32[i1 + (i9 << 4) + 4 >> 2] | 0; else i1 = i3 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i2, i6, i8 - i6 | 0, i1, 0, i1, i8, i7);
  } else {
   if (i4) i2 = HEAP32[i2 >> 2] | 0;
   if (i8 | 0) _memmove(i2 | 0, i7 | 0, i8 | 0) | 0;
   HEAP8[i2 + i8 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i1 + (i9 << 4) + 4 >> 2] = i8;
    break;
   } else {
    HEAP8[i5 >> 0] = i8;
    break;
   }
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i9 = i9 + 1 | 0;
  i1 = HEAP32[i14 >> 2] | 0;
 } while (i9 >>> 0 < (HEAP32[i12 >> 2] | 0) - i1 >> 4 >>> 0);
 STACKTOP = i16;
 return;
}

function __Z22UnregisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i3 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1459968 >> 2] | 0;
 i4 = i2;
 if ((i3 | 0) == (i2 | 0)) return;
 i15 = i14 + 11 | 0;
 i16 = i14 + 4 | 0;
 i13 = 0;
 i1 = i3;
 i6 = i4;
 i5 = i3;
 L4 : while (1) {
  i12 = i5;
  i3 = i2;
  i2 = i4;
  L6 : while (1) {
   i5 = i2 + (i13 * 20 | 0) | 0;
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i11 = i4 << 24 >> 24 < 0;
   i4 = i4 & 255;
   i8 = i11 ? HEAP32[i2 + (i13 * 20 | 0) + 4 >> 2] | 0 : i4;
   i10 = HEAP8[i15 >> 0] | 0;
   i2 = i10 << 24 >> 24 < 0;
   if ((i8 | 0) != ((i2 ? HEAP32[i16 >> 2] | 0 : i10 & 255) | 0)) break;
   i9 = HEAP32[i5 >> 2] | 0;
   i10 = i11 ? i9 : i5;
   i2 = i2 ? HEAP32[i14 >> 2] | 0 : i14;
   i7 = (i8 | 0) == 0;
   L9 : do if (i11) {
    if (!i7) if (_memcmp(i10, i2, i8) | 0) break L6;
   } else if (!i7) {
    if ((i9 & 255) << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) break L6;
    while (1) {
     i4 = i4 + -1 | 0;
     i5 = i5 + 1 | 0;
     if (!i4) break L9;
     i2 = i2 + 1 | 0;
     if ((HEAP8[i5 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) break L6;
    }
   } while (0);
   i3 = i6 + (i13 * 20 | 0) | 0;
   i2 = i3 + 20 | 0;
   if ((i2 | 0) == (i1 | 0)) i17 = 17; else {
    do {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
     i10 = i2 + 12 | 0;
     i11 = HEAP32[i10 + 4 >> 2] | 0;
     i12 = i3 + 12 | 0;
     HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i12 + 4 >> 2] = i11;
     i2 = i2 + 20 | 0;
     i3 = i3 + 20 | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
    if ((i1 | 0) != (i3 | 0)) i17 = 17;
   }
   if ((i17 | 0) == 17) {
    i17 = 0;
    do {
     i1 = i1 + -20 | 0;
     HEAP32[gb + 1459968 + 4 >> 2] = i1;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
     i1 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i2 = i1;
   i3 = HEAP32[gb + 1459968 >> 2] | 0;
   i4 = i3;
   if (i13 >>> 0 < ((i2 - i3 | 0) / 20 | 0) >>> 0) {
    i6 = i4;
    i12 = i2;
    i2 = i4;
   } else {
    i17 = 4;
    break L4;
   }
  }
  i13 = i13 + 1 | 0;
  if (i13 >>> 0 >= ((i12 - i3 | 0) / 20 | 0) >>> 0) {
   i17 = 4;
   break;
  } else {
   i2 = i3;
   i5 = i12;
   i4 = i3;
  }
 }
 if ((i17 | 0) == 4) return;
}

function _gray_move_to(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i10 + 44 | 0;
 L1 : do if (!(HEAP32[i11 >> 2] | 0)) {
  i6 = HEAP32[i10 + 36 >> 2] | 0;
  i7 = HEAP32[i10 + 40 >> 2] | 0;
  if (i7 | i6 | 0) {
   i5 = HEAP32[i10 + 4 >> 2] | 0;
   i2 = HEAP32[i10 + 28 >> 2] | 0;
   i5 = (i5 | 0) > (i2 | 0) ? i2 : i5;
   i2 = (HEAP32[i10 + 1256 >> 2] | 0) + (HEAP32[i10 + 8 >> 2] << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   L4 : do if (!i1) i4 = 7; else while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) > (i5 | 0)) {
     i4 = 7;
     break L4;
    }
    if ((i3 | 0) == (i5 | 0)) break L4;
    i2 = i1 + 12 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i4 = 7;
     break;
    }
   } while (0);
   do if ((i4 | 0) == 7) {
    i1 = i10 + 56 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) < (HEAP32[i10 + 52 >> 2] | 0)) {
     i8 = HEAP32[i10 + 48 >> 2] | 0;
     HEAP32[i1 >> 2] = i3 + 1;
     i1 = i8 + (i3 << 4) | 0;
     HEAP32[i1 >> 2] = i5;
     HEAP32[i8 + (i3 << 4) + 8 >> 2] = 0;
     HEAP32[i8 + (i3 << 4) + 4 >> 2] = 0;
     HEAP32[i8 + (i3 << 4) + 12 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i2 >> 2] = i1;
     if (!i1) break L1; else break;
    } else {
     HEAP32[i10 >> 2] = 64;
     break L1;
    }
   } while (0);
   i8 = i1 + 8 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i6;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i7;
  }
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i11 = i1;
  return i11 | 0;
 }
 i8 = HEAP32[i9 >> 2] << 2;
 i7 = HEAP32[i9 + 4 >> 2] << 2;
 i12 = i8 >> 8;
 i13 = HEAP32[i10 + 16 >> 2] | 0;
 i12 = (i13 | 0) < (i12 | 0) ? i13 : i12;
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 i12 = (i12 | 0) < (i1 | 0) ? i1 + -1 | 0 : i12;
 i2 = i10 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i10 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i12 - i1 | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = i9;
 i5 = (i7 >> 8) - (HEAP32[i10 + 20 >> 2] | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i11 >> 2] = 0;
 i1 = ((i13 | 0) < (i12 | 0) ? i13 : i12) - i1 | 0;
 i1 = (i1 | 0) > -1 ? i1 : -1;
 if ((i1 | 0) != (i9 | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i6 >> 2] = i5;
 }
 if (i5 >>> 0 < (HEAP32[i10 + 32 >> 2] | 0) >>> 0) i1 = (i1 | 0) >= (HEAP32[i10 + 28 >> 2] | 0); else i1 = 1;
 HEAP32[i11 >> 2] = i1 & 1;
 HEAP32[i10 + 60 >> 2] = i8;
 HEAP32[i10 + 64 >> 2] = i7;
 i13 = 0;
 return i13 | 0;
}

function _gray_conic_to(i2, i1, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i8 + 844 | 0;
 i7 = i8 + 68 | 0;
 i5 = HEAP32[i1 >> 2] << 2;
 HEAP32[i7 >> 2] = i5;
 i4 = i4 << 2;
 HEAP32[i8 + 72 >> 2] = i4;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + 76 >> 2] = i10 << 2;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = i9 << 2;
 HEAP32[i8 + 80 >> 2] = i2;
 i1 = HEAP32[i8 + 60 >> 2] | 0;
 HEAP32[i8 + 84 >> 2] = i1;
 i3 = HEAP32[i8 + 64 >> 2] | 0;
 HEAP32[i8 + 88 >> 2] = i3;
 i1 = i5 - (i10 << 3) + i1 | 0;
 i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i9 = i4 - (i9 << 3) + i3 | 0;
 i9 = (i9 | 0) < 0 ? 0 - i9 | 0 : i9;
 i1 = (i1 | 0) < (i9 | 0) ? i9 : i1;
 if ((i1 | 0) < 64) {
  i2 = i7;
  i3 = 0;
  i1 = i5;
  i4 = 9;
 } else {
  i10 = (i2 | 0) < (i4 | 0) ? i2 : i4;
  i2 = (i2 | 0) > (i4 | 0) ? i2 : i4;
  if ((((i3 | 0) < (i10 | 0) ? i3 : i10) >> 8 | 0) < (HEAP32[i8 + 24 >> 2] | 0)) if ((((i3 | 0) > (i2 | 0) ? i3 : i2) >> 8 | 0) < (HEAP32[i8 + 20 >> 2] | 0)) {
   i2 = i7;
   i3 = 0;
   i1 = i5;
   i4 = 9;
  } else {
   i2 = 0;
   do {
    i1 = i1 >> 2;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) > 64);
   HEAP32[i6 >> 2] = i2;
   i1 = i7;
   i3 = 0;
   i4 = 6;
  } else {
   i2 = i7;
   i3 = 0;
   i1 = i5;
   i4 = 9;
  }
 }
 L7 : while (1) {
  do if ((i4 | 0) == 6) if ((i2 | 0) > 0) {
   i10 = i1 + 16 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + 32 >> 2] = i9;
   i7 = i1 + 8 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i9 = (i6 + i9 | 0) / 2 | 0;
   HEAP32[i1 + 24 >> 2] = i9;
   i6 = ((HEAP32[i1 >> 2] | 0) + i6 | 0) / 2 | 0;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i10 >> 2] = (i6 + i9 | 0) / 2 | 0;
   i10 = i1 + 20 | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   HEAP32[i1 + 36 >> 2] = i9;
   i6 = i1 + 12 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i9 = (i7 + i9 | 0) / 2 | 0;
   HEAP32[i1 + 28 >> 2] = i9;
   i7 = ((HEAP32[i1 + 4 >> 2] | 0) + i7 | 0) / 2 | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i10 >> 2] = (i7 + i9 | 0) / 2 | 0;
   i10 = i3 + 1 | 0;
   i2 = i2 + -1 | 0;
   HEAP32[i8 + 844 + (i3 << 2) >> 2] = i2;
   HEAP32[i8 + 844 + (i10 << 2) >> 2] = i2;
   i1 = i1 + 16 | 0;
   i2 = i10;
   break;
  } else {
   i2 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i4 = 9;
   continue L7;
  } else if ((i4 | 0) == 9) {
   _gray_render_line(i8, i1, HEAP32[i2 + 4 >> 2] | 0);
   i1 = i2 + -16 | 0;
   i2 = i3 + -1 | 0;
  } while (0);
  if ((i2 | 0) <= -1) break;
  i3 = i2;
  i2 = HEAP32[i8 + 844 + (i2 << 2) >> 2] | 0;
  i4 = 6;
 }
 return 0;
}

function __ZN9JSONWrite8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite10SetVersionEi(i10, 2);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1085989 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1034504 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1034510 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn5UnionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i1 = i8 << 4;
  if (!i1) i5 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i6 | 0, i1 | 0, (i5 ? gb + 671783 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE(i1 + 4 | 0, i2 + 4 | 0);
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i5 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE(i5 + (i1 << 4) + 4 | 0, i4 + 4 | 0);
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + (i4 << 4) | 0;
 if ((i4 | 0) > 0) do {
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (i2 | 0) {
    i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 | 0);
   }
  }
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i6 >> 2] = i8;
  i9 = i5 + (i9 << 4) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i6 >> 2] = i8;
  i9 = i5 + (i9 << 4) | 0;
  return i9 | 0;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i6 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i6 >> 2] = i8;
 i9 = i5 + (i9 << 4) | 0;
 return i9 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 626; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj626ENS_22PxRepXPropertyAccessorILj626ES4_KjjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 625; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj625ENS_22PxRepXPropertyAccessorILj625ES4_KjjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5Unity12PhysicsQuery13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction(i3, i4, f9, i10, i11) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 100 | 0;
 i12 = i16 + 80 | 0;
 i13 = i16 + 72 | 0;
 i14 = i16 + 40 | 0;
 i15 = i16;
 if ((HEAP16[gb + 1452632 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452632 | 0, i1);
  i2 = gb + 1452632 | 0;
 } else i2 = 0;
 i5 = i3 + 36 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i3 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) != (i6 | 0)) HEAP32[i7 >> 2] = i8 + (~((i8 + -4 - i6 | 0) >>> 2) << 2);
 i8 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = -1;
 HEAP8[i15 + 20 >> 0] = 0;
 HEAP32[i15 + 24 >> 2] = i8;
 HEAP32[i15 + 28 >> 2] = 128;
 HEAP32[i15 + 32 >> 2] = 0;
 HEAP32[i15 >> 2] = gb + 151304 + 8;
 HEAP32[i15 + 36 >> 2] = i5;
 HEAP32[i1 >> 2] = gb + 114012 + 8;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i10;
 switch (i11 | 0) {
 case 0:
  {
   HEAP8[i1 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i1 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i1 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP16[i12 + 16 >> 1] = 7;
 HEAP8[i12 + 18 >> 0] = 0;
 f17 = Math_fround(HEAPF32[gb + 1452812 >> 2]);
 i11 = HEAP32[gb + 1457404 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 356 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAPF32[i13 + 4 >> 2] = f17 < f9 ? f17 : f9;
 i6 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = HEAP32[i4 + 8 >> 2] | 0;
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i14 + 16 >> 2] = i6;
 HEAP32[i14 + 20 >> 2] = i7;
 HEAP32[i14 + 24 >> 2] = i8;
 mftCall_iiiiiii(i10 | 0, i11 | 0, i13 | 0, i14 | 0, i15 | 0, i12 | 0, i1 | 0) | 0;
 if (!i2) {
  STACKTOP = i16;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i16;
 return i5 | 0;
}

function __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i4 = i9 + 8 | 0;
 __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i8, i1, i4);
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 i2 = i1 + (i3 * 40 | 0) | 0;
 if (i3 | 0) do {
  __ZN16BlendShapeVertex8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = i1 + (i4 * 12 | 0) | 0;
 if (i4 | 0) do {
  __ZN10BlendShape8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 44 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i8 = i8 + 52 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i9, i8, 0);
  STACKTOP = i10;
  return;
 }
 do {
  __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i8 = i8 + 52 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i9, i8, 0);
 STACKTOP = i10;
 return;
}

function __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 HEAP32[i5 >> 2] = 0;
 i8 = i5 + 4 | 0;
 HEAP8[i8 >> 0] = 1;
 i9 = i5 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i5 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i5 + 16 | 0;
 HEAP32[i11 >> 2] = -1;
 i12 = i5 + 28 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i5 + 32 | 0;
 HEAP8[i13 >> 0] = 1;
 HEAP32[i5 + 36 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = -1;
 i1 = __Z24scripting_field_get_typeP9FieldInfo(i7) | 0;
 i2 = i5 + 24 | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(i1) | 0) == 29) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i5 + 20 >> 2] = __Z41scripting_type_get_class_or_element_classPK10Il2CppType(i1) | 0;
  STACKTOP = i14;
  return;
 }
 HEAP32[i2 >> 2] = 1;
 i3 = __Z25scripting_class_from_typePK10Il2CppType(i1) | 0;
 HEAP32[i5 >> 2] = __ZN9Scripting27BackingArrayFieldForListOfTEP11Il2CppClass(i3) | 0;
 i1 = i6 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(i7) | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i6 + 12 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i1 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i7) | 0) | 0;
  if (!i2) {
   i2 = _il2cpp_object_new(i1 | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i2);
  }
 }
 HEAP8[i8 >> 0] = 1;
 i8 = i5 + 5 | 0;
 HEAP8[i8 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i8 + 1 >> 0] = HEAP8[i4 + 1 >> 0] | 0;
 HEAP8[i8 + 2 >> 0] = HEAP8[i4 + 2 >> 0] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = -1;
 if (!i2) _il2cpp_object_new(i3 | 0) | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 20 >> 2] = __Z41scripting_type_get_class_or_element_classPK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(HEAP32[i5 >> 2] | 0) | 0) | 0;
 STACKTOP = i14;
 return;
}

function __ZN19CollisionListener2D21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE(i12, i13, i10) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0;
 i1 = HEAP32[i12 + 176 >> 2] | 0;
 i9 = HEAP32[i12 + 180 >> 2] | 0;
 i11 = i1 + (i9 * 80 | 0) | 0;
 L1 : do if (!i9) i14 = 10; else {
  i3 = HEAP32[i12 + 96 >> 2] | 0;
  i4 = i12 + 100 | 0;
  i5 = i12 + 8 | 0;
  i6 = i12 + 16 | 0;
  i7 = i12 + 20 | 0;
  i8 = i12 + 12 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) {
    if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i14 = 5;
   } else i14 = 5;
   if ((i14 | 0) == 5) {
    i14 = 0;
    if (!(HEAP8[i8 >> 0] | 0)) {
     i14 = 10;
     break L1;
    }
    if (!(HEAP32[i5 >> 2] | 0)) {
     i14 = 10;
     break L1;
    }
    if ((HEAP32[i6 >> 2] | 0) != (i2 | 0)) {
     i14 = 10;
     break L1;
    }
    if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i14 = 10;
     break L1;
    }
   }
   i1 = i1 + 80 | 0;
  } while ((i1 | 0) != (i11 | 0));
 } while (0);
 L13 : do if ((i14 | 0) == 10) if ((i1 | 0) != (i11 | 0)) {
  i4 = i12 + 96 | 0;
  i5 = i12 + 100 | 0;
  i6 = i12 + 8 | 0;
  i7 = i12 + 16 | 0;
  i8 = i12 + 20 | 0;
  i9 = i12 + 12 | 0;
  do {
   i2 = i1 + 72 | 0;
   do if (HEAP32[i2 >> 2] | 0) {
    if ((HEAP32[i1 >> 2] | 0) != (i13 | 0)) if ((HEAP32[i1 + 4 >> 2] | 0) != (i13 | 0)) break;
    HEAP32[i2 >> 2] = i10;
   } while (0);
   i1 = i1 + 80 | 0;
   if ((i1 | 0) == (i11 | 0)) break L13;
   i3 = HEAP32[i4 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i3 | 0) == (i2 | 0)) {
     if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) i14 = 28;
    } else i14 = 28;
    if ((i14 | 0) == 28) {
     i14 = 0;
     if (!(HEAP8[i9 >> 0] | 0)) break;
     if (!(HEAP32[i6 >> 2] | 0)) break;
     if ((HEAP32[i7 >> 2] | 0) != (i2 | 0)) break;
     if ((HEAP32[i8 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) break;
    }
    i1 = i1 + 80 | 0;
    if ((i1 | 0) == (i11 | 0)) break L13;
   }
  } while ((i1 | 0) != (i11 | 0));
 } while (0);
 i1 = HEAP32[i12 + 216 >> 2] | 0;
 if (!i1) return;
 i12 = HEAP32[i12 + 204 >> 2] | 0;
 i2 = i12 + (i1 * 72 | 0) | 0;
 i1 = i12;
 do {
  if ((HEAP32[i1 + 8 >> 2] | 0) == (i13 | 0)) i14 = 16; else if ((HEAP32[i1 + 12 >> 2] | 0) == (i13 | 0)) i14 = 16;
  if ((i14 | 0) == 16) {
   i14 = 0;
   HEAP32[i1 + 64 >> 2] = 0;
  }
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEventC2ERK8UnityStrb(i3, i1, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i3, gb + 1040589 | 0, 2);
 HEAP32[i3 >> 2] = gb + 188936 + 8;
 __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoC2Ev(i3 + 32 | 0);
 i4 = i3 + 392 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 404 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 408 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 420 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 424 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 436 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 440 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 452 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 476 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 488 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 if ((i4 | 0) == (i1 | 0)) {
  i6 = i3 + 492 | 0;
  i5 = i5 & 1;
  HEAP8[i6 >> 0] = i5;
  return;
 }
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i2 << 24 >> 24 < 0;
 i6 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255;
 i2 = i4 + 11 | 0;
 if (i1 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, 10, i1 + -10 | 0, 0, 0, 0, i1, i6);
  i7 = i3 + 492 | 0;
  i6 = i5 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 }
 if (i1 | 0) _memmove(i4 | 0, i6 | 0, i1 | 0) | 0;
 HEAP8[i4 + i1 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP32[i3 + 480 >> 2] = i1;
  i7 = i3 + 492 | 0;
  i6 = i5 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 } else {
  HEAP8[i2 >> 0] = i1;
  i7 = i3 + 492 | 0;
  i6 = i5 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 }
}

function _trinkle(i4, i10, i11, i3, i1, i2, i12) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i13 >> 2] = i4;
 i9 = 0 - i10 | 0;
 L1 : do if ((i6 | 0) != 0 | (i5 | 0) != 1) {
  i7 = i4 + (0 - (HEAP32[i12 + (i1 << 2) >> 2] | 0)) | 0;
  if ((mftCall_iii(i11 | 0, i7 | 0, i4 | 0) | 0) < 1) {
   i3 = i4;
   i4 = 1;
   i14 = 18;
  } else {
   i8 = 1;
   i2 = (i2 | 0) == 0;
   i3 = i4;
   while (1) {
    if (i2 & (i1 | 0) > 1) {
     i2 = i3 + i9 | 0;
     i4 = HEAP32[i12 + (i1 + -2 << 2) >> 2] | 0;
     if ((mftCall_iii(i11 | 0, i2 | 0, i7 | 0) | 0) > -1) {
      i2 = i8;
      i14 = 19;
      break L1;
     }
     if ((mftCall_iii(i11 | 0, i2 + (0 - i4) | 0, i7 | 0) | 0) > -1) {
      i2 = i8;
      i14 = 19;
      break L1;
     }
    }
    i2 = i8 + 1 | 0;
    HEAP32[i13 + (i8 << 2) >> 2] = i7;
    i3 = i5 + -1 | 0;
    do if (!i3) {
     i3 = 0;
     i4 = 32;
     i14 = 15;
    } else {
     if (!(i3 & 1)) {
      i4 = 0;
      do {
       i4 = i4 + 1 | 0;
       i3 = i3 >>> 1;
      } while (!(i3 & 1 | 0));
     } else {
      if (!i6) i3 = 32; else {
       if (!(i6 & 1)) {
        i4 = i6;
        i3 = 0;
       } else {
        i3 = 0;
        i4 = 0;
        break;
       }
       do {
        i3 = i3 + 1 | 0;
        i4 = i4 >>> 1;
       } while (!(i4 & 1 | 0));
      }
      i4 = i3 + 32 | 0;
     }
     if (i4 >>> 0 > 31) {
      i3 = i4 + -32 | 0;
      i14 = 15;
     } else i3 = i4;
    } while (0);
    if ((i14 | 0) == 15) {
     i14 = 0;
     i5 = i6;
     i6 = 0;
    }
    i5 = i6 << 32 - i3 | i5 >>> i3;
    i6 = i6 >>> i3;
    i1 = i4 + i1 | 0;
    if (!((i6 | 0) != 0 | (i5 | 0) != 1)) {
     i3 = i7;
     i14 = 19;
     break L1;
    }
    i3 = i7 + (0 - (HEAP32[i12 + (i1 << 2) >> 2] | 0)) | 0;
    if ((mftCall_iii(i11 | 0, i3 | 0, HEAP32[i13 >> 2] | 0) | 0) < 1) {
     i3 = i7;
     i4 = i2;
     i2 = 0;
     i14 = 18;
     break;
    } else {
     i4 = i7;
     i8 = i2;
     i2 = 1;
     i7 = i3;
     i3 = i4;
    }
   }
  }
 } else {
  i3 = i4;
  i4 = 1;
  i14 = 18;
 } while (0);
 if ((i14 | 0) == 18) if (!i2) {
  i2 = i4;
  i14 = 19;
 }
 if ((i14 | 0) == 19) {
  _cycle(i10, i13, i2);
  _sift(i3, i10, i11, i1, i12);
 }
 STACKTOP = i15;
 return;
}

function _jpeg_read_coefficients(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = i9 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 switch (i1 | 0) {
 case 202:
  {
   HEAP8[i9 + 64 >> 0] = 1;
   do if (!(HEAP8[i9 + 201 >> 0] | 0)) if (!(HEAP8[i9 + 200 >> 0] | 0)) {
    _jinit_huff_decoder(i9);
    break;
   } else {
    _jinit_phuff_decoder(i9);
    break;
   } else {
    i7 = HEAP32[i9 >> 2] | 0;
    HEAP32[i7 + 20 >> 2] = 1;
    mftCall_vi(HEAP32[i7 >> 2] | 0, i9 | 0);
   } while (0);
   _jinit_d_coef_controller(i9, 1);
   mftCall_vi(HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + 24 >> 2] | 0, i9 | 0);
   i3 = i9 + 400 | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i9 | 0);
   i4 = i9 + 8 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    if (!(HEAP8[i9 + 200 >> 0] | 0)) if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 16 >> 0] | 0)) i1 = 1; else i1 = HEAP32[i9 + 36 >> 2] | 0; else i1 = ((HEAP32[i9 + 36 >> 2] | 0) * 3 | 0) + 2 | 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = Math_imul(HEAP32[i9 + 284 >> 2] | 0, i1) | 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 1;
   }
   HEAP32[i8 >> 2] = 209;
   i7 = i9;
   i5 = 15;
   break;
  }
 case 209:
  {
   i4 = i9 + 8 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i3 = i9 + 400 | 0;
   i7 = i9;
   i5 = 15;
   break;
  }
 case 207:
 case 210:
  {
   i5 = 23;
   break;
  }
 default:
  {}
 }
 do if ((i5 | 0) == 15) {
  i6 = i9 + 284 | 0;
  L21 : while (1) {
   if (i2 | 0) mftCall_vi(HEAP32[i2 >> 2] | 0, i7 | 0);
   i1 = mftCall_ii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i9 | 0) | 0;
   switch (i1 | 0) {
   case 2:
    {
     i5 = 22;
     break L21;
    }
   case 0:
    {
     i1 = 0;
     i5 = 26;
     break L21;
    }
   default:
    {}
   }
   i2 = HEAP32[i4 >> 2] | 0;
   if (!((i1 | 2 | 0) == 3 & (i2 | 0) != 0)) continue;
   i1 = i2 + 4 | 0;
   i10 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
   HEAP32[i1 >> 2] = i10;
   i1 = i2 + 8 | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   if ((i10 | 0) < (i5 | 0)) continue;
   HEAP32[i1 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
  }
  if ((i5 | 0) == 22) {
   HEAP32[i8 >> 2] = 210;
   i1 = 210;
   i5 = 23;
   break;
  } else if ((i5 | 0) == 26) return i1 | 0;
 } while (0);
 if ((i5 | 0) == 23) if (HEAP8[i9 + 64 >> 0] | 0) {
  i10 = HEAP32[(HEAP32[i9 + 392 >> 2] | 0) + 16 >> 2] | 0;
  return i10 | 0;
 }
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 + 20 >> 2] = 20;
 HEAP32[i10 + 24 >> 2] = i1;
 mftCall_vi(HEAP32[i10 >> 2] | 0, i9 | 0);
 i10 = 0;
 return i10 | 0;
}

function __ZNSt3__26gslice6__initEj(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i11 = i7 + 4 | 0;
 i4 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 2;
 HEAP32[i12 >> 2] = 0;
 i6 = i12 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZNSt3__28valarrayIjE6resizeEjj(i12, i4, 0);
 i11 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i11 - i4 >> 2;
 i3 = i4;
 i1 = 0;
 i4 = (i11 | 0) != (i4 | 0) & 1;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) break;
  i11 = Math_imul(HEAP32[i3 + (i1 << 2) >> 2] | 0, i4) | 0;
  i1 = i1 + 1 | 0;
  i4 = i11;
 }
 i2 = i7 + 16 | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1063 | 0, i2 | 0, i4 | 0, 0);
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1063 | 0, i12 | 0, 0, 0);
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i11 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i11);
  } else ___resumeException(i1 | 0);
 }
 i10 = HEAP32[i2 >> 2] | 0;
 i11 = i10;
 L11 : do if ((HEAP32[i7 + 20 >> 2] | 0) != (i10 | 0)) {
  HEAP32[i11 >> 2] = i5;
  i9 = HEAP32[i6 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i8 = i7 + 8 | 0;
  i5 = 0;
  L13 : while (1) {
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = i1;
   i1 = i9 - i1 >> 2;
   while (1) {
    i4 = i1 + -1 | 0;
    i3 = i2 + (i4 << 2) | 0;
    i7 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
    HEAP32[i3 >> 2] = i7;
    if (i7 >>> 0 < (HEAP32[i10 + (i4 << 2) >> 2] | 0) >>> 0) break;
    if (!i4) break L11;
    HEAP32[i3 >> 2] = 0;
    i1 = i4;
   }
   i6 = i5 + 1 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   HEAP32[i11 + (i6 << 2) >> 2] = (HEAP32[i7 + (i4 << 2) >> 2] | 0) + (HEAP32[i11 + (i5 << 2) >> 2] | 0);
   i2 = i9 - (HEAP32[i12 >> 2] | 0) >> 2;
   i3 = i11 + (i6 << 2) | 0;
   while (1) {
    if ((i1 | 0) == (i2 | 0)) {
     i5 = i6;
     continue L13;
    }
    i5 = Math_imul((HEAP32[i10 + (i1 << 2) >> 2] | 0) + -1 | 0, HEAP32[i7 + (i1 << 2) >> 2] | 0) | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i5;
    i1 = i1 + 1 | 0;
   }
  }
 } while (0);
 __THREW__ = 0;
 invoke_viii(fb + 1063 | 0, i12 | 0, 0, 0);
 i12 = __THREW__;
 __THREW__ = 0;
 if (i12 & 1) {
  i13 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i13);
 } else {
  STACKTOP = i13;
  return;
 }
}

function __ZNK5physx11PxTransform12transformInvERKS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f14 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[i3 + 4 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 f17 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f12 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 + 20 >> 2]));
 f16 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f15 = Math_fround(f15 * Math_fround(2.0));
 f12 = Math_fround(f12 * Math_fround(2.0));
 f16 = Math_fround(Math_fround(f16 - Math_fround(HEAPF32[i3 + 24 >> 2])) * Math_fround(2.0));
 f7 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f4 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f12 * f13)) + Math_fround(f16 * f10));
 f6 = Math_fround(Math_fround(f4 * f14) + Math_fround(Math_fround(f7 * f15) + Math_fround(f17 * Math_fround(Math_fround(f16 * f13) - Math_fround(f12 * f10)))));
 f5 = Math_fround(Math_fround(f4 * f13) + Math_fround(Math_fround(f7 * f12) + Math_fround(f17 * Math_fround(Math_fround(f15 * f10) - Math_fround(f16 * f14)))));
 f4 = Math_fround(Math_fround(Math_fround(f7 * f16) + Math_fround(f17 * Math_fround(Math_fround(f12 * f14) - Math_fround(f15 * f13)))) + Math_fround(f4 * f10));
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f17 * f15);
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f16 * f14));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f7 * f13));
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f15 * f10) + Math_fround(Math_fround(f16 * f13) + Math_fround(f17 * f11))) - Math_fround(f7 * f14));
 f8 = Math_fround(Math_fround(Math_fround(f11 * f14) + Math_fround(Math_fround(f16 * f10) + Math_fround(f17 * f7))) - Math_fround(f15 * f13));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14)) - Math_fround(f11 * f13)) - Math_fround(f7 * f10));
 HEAPF32[i1 >> 2] = Math_fround(f12 - Math_fround(f11 * f10));
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 return;
}

function __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i5 = i10 + 12 | 0;
 i6 = i10 + 8 | 0;
 i8 = i10 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0) | 0)) {
  HEAP32[i1 >> 2] = __ZNK6Object12GetClassNameEv(i4) | 0;
  __Z6FormatPKcz(i5, gb + 733735 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 733088 | 0, 649, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i7 = i4 + 32 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) i1 = i3; else HEAP32[i7 >> 2] = i1;
 i4 = i4 + 36 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 do if (!i1) i9 = 15; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 12; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 14;
   }
  }
  if ((i9 | 0) == 12) i9 = 14;
  if ((i9 | 0) == 14) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
   if (!i1) {
    i9 = 15;
    break;
   }
  }
  i7 = HEAP32[i1 + 52 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  if (!i7) i9 = 17;
 } while (0);
 if ((i9 | 0) == 15) {
  HEAP32[i8 >> 2] = 0;
  i9 = 17;
 }
 if ((i9 | 0) == 17) {
  i9 = __Z14GetDynamicsSDKv() | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 152 >> 2] | 0, i9 | 0, i8 | 0, 1, 0) | 0;
 }
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 96 >> 2] | 0, i9 | 0, i8 | 0, 1);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i1, i14, i15) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i2 = HEAP32[i15 + 12 >> 2] | 0;
 if (!i2) {
  STACKTOP = i17;
  return;
 }
 i7 = i15 + 8 | 0;
 i8 = i15 + 5 | 0;
 i9 = i16 + 45 | 0;
 i10 = i16 + 40 | 0;
 i11 = i15 + 4 | 0;
 i12 = i16 + 44 | 0;
 i13 = i16 + 32 | 0;
 i3 = i1 + 36 | 0;
 i4 = i16 + 16 | 0;
 i5 = i16 + 20 | 0;
 i6 = i16 + 8 | 0;
 i1 = i2;
 do {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
  HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
  HEAP8[i12 >> 0] = HEAP8[i11 >> 0] | 0;
  i18 = i2 + (i1 << 5) + 8 | 0;
  i19 = HEAP32[i18 + 4 >> 2] | 0;
  i20 = i13;
  HEAP32[i20 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i20 + 4 >> 2] = i19;
  HEAP32[i4 >> 2] = __ZN5physx3Ext20ProfileZoneInterface19getProfileEventNameEy(HEAP32[i3 >> 2] | 0, HEAPU16[i2 + (i1 << 5) >> 1] | 0, 0) | 0;
  i20 = HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i20 >> 2] | 0) + 20 >> 2] | 0, i20 | 0) | 0;
  i20 = __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv() | 0;
  i19 = i2 + (i1 << 5) + 16 | 0;
  i18 = i20;
  i19 = ___muldi3(HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, HEAP32[i19 >> 2] | 0, HEAP32[i19 + 4 >> 2] | 0) | 0;
  i18 = getTempRet0() | 0;
  i20 = i20 + 8 | 0;
  i20 = ___udivdi3(i19 | 0, i18 | 0, HEAP32[i20 >> 2] | 0, HEAP32[i20 + 4 >> 2] | 0) | 0;
  i20 = ___muldi3(i20 | 0, getTempRet0() | 0, 10, 0) | 0;
  i18 = getTempRet0() | 0;
  i19 = i16;
  HEAP32[i19 >> 2] = i20;
  HEAP32[i19 + 4 >> 2] = i18;
  i19 = __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv() | 0;
  i2 = i2 + (i1 << 5) + 24 | 0;
  i18 = i19;
  i2 = ___muldi3(HEAP32[i18 >> 2] | 0, HEAP32[i18 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i18 = getTempRet0() | 0;
  i19 = i19 + 8 | 0;
  i19 = ___udivdi3(i2 | 0, i18 | 0, HEAP32[i19 >> 2] | 0, HEAP32[i19 + 4 >> 2] | 0) | 0;
  i19 = ___muldi3(i19 | 0, getTempRet0() | 0, 10, 0) | 0;
  i18 = getTempRet0() | 0;
  i2 = i6;
  HEAP32[i2 >> 2] = i19;
  HEAP32[i2 + 4 >> 2] = i18;
  mftCall_vii(HEAP32[HEAP32[i14 >> 2] >> 2] | 0, i14 | 0, i16 | 0);
 } while ((i1 | 0) != 0);
 STACKTOP = i17;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 650; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj650ENS_22PxRepXPropertyAccessorILj650ES4_KjjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __Z14FromJsonSharedR11ICallStringP12Il2CppObjectP11Il2CppClass(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 72 | 0;
 i11 = i13 + 40 | 0;
 i9 = i13 + 8 | 0;
 __ZNK11ICallString6ToUTF8Ev(i10, i1);
 i3 = HEAP8[i10 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i2 = i4 ? HEAP32[i10 >> 2] | 0 : i10;
 i3 = i4 ? HEAP32[i10 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i11 >> 2] = 0;
 i4 = i11 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i11 + 24 | 0;
 i14 = gb + 64016 | 0;
 i5 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i11 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 if (i3 >>> 0 > 15) {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i8, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i11 >> 2] = i14;
  HEAP32[i11 + 4 >> 2] = i3;
  i1 = (i14 | 0) == 0 ? i1 : i14;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i9 >> 2] = 0;
 i1 = i9 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i9 + 24 | 0;
 i4 = gb + 64016 | 0;
 i14 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i14;
 i3 = i9 + 4 | 0;
 HEAP8[i3 >> 0] = 0;
 if (!i6) i4 = __ZN11JSONUtility17DeserializeObjectERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP11Il2CppClassS5_24TransferInstructionFlags(i11, i7, i9, 0) | 0; else {
  __ZN11JSONUtility28DeserializeObjectOverwritingERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP12Il2CppObjectS5_24TransferInstructionFlags(i11, i6, i9, 0) | 0;
  i4 = i6;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i1 + 1 | 0) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i14 = HEAP32[i9 >> 2] | 0;
  _strcpy(i2, (i14 | 0) == 0 ? i3 : i14) | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i9 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i11 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!i2) {
  STACKTOP = i13;
  return i4 | 0;
 } else {
  HEAP32[i12 >> 2] = i2;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1074693 | 0, i12);
 }
 return 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 192 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 192 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 192 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 192 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN9ShaderLab20SerializedSubProgramaSERKS0_(i3, i2) | 0;
   i2 = i2 + 192 | 0;
   i3 = i3 + 192 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -192 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i2, i1);
   i1 = i1 + 192 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 192 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -192 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN9ShaderLab20SerializedSubProgramD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 22369621) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 192 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 11184810 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 22369621;
 if (i3 >>> 0 > 22369621) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 192 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 192 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i1, i2);
  i2 = i2 + 192 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 192 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 63; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx15PxVehicleUpdate11shiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE(i17, i16, i18) {
 i17 = i17 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, f20 = f0, i21 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i19;
 if (!i16) {
  STACKTOP = i19;
  return;
 }
 i5 = i17 + 4 | 0;
 i7 = i17 + 8 | 0;
 i8 = i13 + 3 | 0;
 i9 = i13 + 2 | 0;
 i10 = i13 + 1 | 0;
 i14 = 0;
 do {
  i11 = HEAP32[i18 + (i14 << 2) >> 2] | 0;
  i12 = HEAP32[i11 + 72 >> 2] | 0;
  i6 = HEAP32[i11 + 44 >> 2] | 0;
  if (i6 | 0) {
   i15 = 0;
   do {
    HEAP32[i13 >> 2] = 0;
    i1 = HEAP32[i11 + 52 + ((i15 >>> 3 & 134217727) << 2) >> 2] | 0;
    i2 = i15 << 2 & 28;
    if (i1 & 1 << i2 | 0) HEAP8[i13 >> 0] = 1;
    if (i1 & 1 << (i2 | 1) | 0) HEAP8[i10 >> 0] = 1;
    if (i1 & 1 << (i2 | 2) | 0) HEAP8[i9 >> 0] = 1;
    if (i1 & 1 << (i2 | 3) | 0) HEAP8[i8 >> 0] = 1;
    i1 = i12 + (i15 * 224 | 0) + 212 | 0;
    if (HEAP32[i1 >> 2] | 0) {
     i2 = i12 + (i15 * 224 | 0) + 96 | 0;
     i4 = 0;
     do {
      if (HEAP8[i13 + i4 >> 0] | 0) {
       f20 = Math_fround(HEAPF32[i17 >> 2]);
       i3 = i2 + (i4 * 12 | 0) | 0;
       HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f20);
       f20 = Math_fround(HEAPF32[i5 >> 2]);
       i3 = i2 + (i4 * 12 | 0) + 4 | 0;
       HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f20);
       f20 = Math_fround(HEAPF32[i7 >> 2]);
       i3 = i2 + (i4 * 12 | 0) + 8 | 0;
       HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f20);
       i3 = HEAP32[i1 >> 2] | 0;
       if (HEAP8[i3 + (i4 * 80 | 0) + 77 >> 0] | 0) {
        f20 = Math_fround(HEAPF32[i17 >> 2]);
        i21 = i3 + (i4 * 80 | 0) + 16 | 0;
        HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f20);
        f20 = Math_fround(HEAPF32[i5 >> 2]);
        i21 = i3 + (i4 * 80 | 0) + 20 | 0;
        HEAPF32[i21 >> 2] = Math_fround(Math_fround(HEAPF32[i21 >> 2]) - f20);
        f20 = Math_fround(HEAPF32[i7 >> 2]);
        i3 = i3 + (i4 * 80 | 0) + 24 | 0;
        HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f20);
       }
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != 4);
    }
    i15 = i15 + 1 | 0;
   } while ((i15 | 0) != (i6 | 0));
  }
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != (i16 | 0));
 STACKTOP = i19;
 return;
}

function __ZN15TerrainRenderer7GetNodeEiii(i1, i2, i3, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i8 | 0) < 0) {
  i8 = 0;
  return i8 | 0;
 } else i7 = i2;
 L3 : while (1) {
  i5 = (i7 | 0) == -1;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i2 = (i4 | 0) < (i8 | 0);
  if ((i7 | 0) >= 0) {
   if (i2) {
    i1 = 0;
    i6 = 28;
    break;
   } else {
    i5 = i1;
    i1 = i4;
   }
   while (1) {
    i2 = 1 << i1 - i8;
    if ((i2 | 0) > (i3 | 0) & ((i3 | 0) > -1 & (i2 | 0) > (i7 | 0))) {
     i6 = 25;
     break L3;
    }
    if ((i2 | 0) == (i7 | 0)) {
     i1 = HEAP32[i5 + 4 >> 2] | 0;
     if (i1 | 0) {
      i7 = 0;
      continue L3;
     }
    }
    if ((i2 | 0) == (i3 | 0)) {
     i1 = HEAP32[i5 >> 2] | 0;
     if (!i1) i6 = 21; else i3 = 0;
    } else i6 = 21;
    if ((i6 | 0) == 21) {
     i6 = 0;
     if ((i3 | 0) != -1) {
      i1 = 0;
      i6 = 28;
      break L3;
     }
     i1 = HEAP32[i5 + 8 >> 2] | 0;
     if (!i1) {
      i1 = 0;
      i6 = 28;
      break L3;
     }
     i3 = i2 + -1 | 0;
    }
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    if ((i2 | 0) < (i8 | 0)) {
     i1 = 0;
     i6 = 28;
     break L3;
    } else {
     i5 = i1;
     i1 = i2;
    }
   }
  }
  if (i2) {
   i1 = 0;
   i6 = 28;
   break;
  } else i2 = i4;
  while (1) {
   i4 = 1 << i2 - i8;
   if (i5) {
    i2 = HEAP32[i1 + 12 >> 2] | 0;
    if (i2 | 0) break;
   }
   if ((i4 | 0) == (i7 | 0)) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (i2 | 0) {
     i1 = i2;
     i7 = 0;
     continue L3;
    }
   }
   if ((i4 | 0) == (i3 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) i6 = 11; else {
     i3 = 0;
     i1 = i2;
    }
   } else i6 = 11;
   if ((i6 | 0) == 11) {
    i6 = 0;
    if ((i3 | 0) != -1) {
     i1 = 0;
     i6 = 28;
     break L3;
    }
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     i6 = 28;
     break L3;
    }
    i3 = i4 + -1 | 0;
   }
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i2 | 0) < (i8 | 0)) {
    i1 = 0;
    i6 = 28;
    break L3;
   }
  }
  i1 = i2;
  i7 = i4 + -1 | 0;
 }
 if ((i6 | 0) == 25) {
  i1 = 1 << i1;
  if ((i8 | 0) > 0) {
   i2 = i1;
   i1 = 0;
   i4 = 0;
   do {
    i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
    i2 = i2 >> 1;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i8 | 0));
  } else {
   i2 = i1;
   i1 = 0;
  }
  i8 = i1 + i7 + (Math_imul(i2, i3) | 0) | 0;
  i8 = (HEAP32[i5 + 16 >> 2] | 0) + (i8 << 6) | 0;
  return i8 | 0;
 } else if ((i6 | 0) == 28) return i1 | 0;
 return 0;
}

function __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1, i6);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj284ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 16 | 0, i6 + 1 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj285ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 32 | 0, i6 + 2 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj286ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 48 | 0, i6 + 3 | 0);
 i1 = i1 + 64 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEE14handleAccessorILj287ENS_22PxRepXPropertyAccessorILj287ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 5 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 5 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 5 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 5 | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 550; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEE14handleAccessorILj550ENS_22PxRepXPropertyAccessorILj550ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 36; else i1 = (HEAP32[i1 >> 2] | 0) + 36 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 657; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj657ENS_22PxRepXPropertyAccessorILj657ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 656; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj656ENS_22PxRepXPropertyAccessorILj656ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = (i5 - i3 | 0) / 156 | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= ((i1 - i6 | 0) / 156 | 0) >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i6 | 0) / 156 | 0;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 * 156 | 0) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN14SubstanceInputaSERKS_(i2, i3) | 0;
   i3 = i3 + 156 | 0;
   i2 = i2 + 156 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -156 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN14SubstanceInputD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN14SubstanceInputC2ERKS_(i2, i1);
   i1 = i1 + 156 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 156 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -156 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN14SubstanceInputD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 27531841) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = (i1 - i2 | 0) / 156 | 0;
 i1 = i6 << 1;
 i1 = i6 >>> 0 < 13765920 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 27531841;
 if (i1 >>> 0 > 27531841) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 * 156 | 0) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 * 156 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  __ZN14SubstanceInputC2ERKS_(i2, i1);
  i1 = i1 + 156 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 156 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZNSt3__210__stdinbufIwE9__getcharEb(i10, i14) {
 i10 = i10 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 16 | 0;
 i13 = i16 + 8 | 0;
 i8 = i16 + 4 | 0;
 i9 = i16;
 i3 = i10 + 52 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i10 + 44 >> 2] | 0;
  i1 = (i1 | 0) > 1 ? i1 : 1;
  i11 = i10 + 32 | 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) >= (i1 | 0)) {
    i15 = 8;
    break;
   }
   i3 = _getc(HEAP32[i11 >> 2] | 0) | 0;
   if ((i3 | 0) == -1) {
    i1 = -1;
    break;
   }
   HEAP8[i12 + i2 >> 0] = i3;
   i2 = i2 + 1 | 0;
  }
  if ((i15 | 0) == 8) {
   do if (!(HEAP8[i10 + 53 >> 0] | 0)) {
    i5 = i10 + 40 | 0;
    i6 = i10 + 36 | 0;
    i7 = i13 + 4 | 0;
    L11 : while (1) {
     i17 = HEAP32[i5 >> 2] | 0;
     i3 = i17;
     i2 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     i18 = HEAP32[i6 >> 2] | 0;
     i4 = i12 + i1 | 0;
     switch (mftCall_iiiiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0, i17 | 0, i12 | 0, i4 | 0, i8 | 0, i13 | 0, i7 | 0, i9 | 0) | 0) {
     case 3:
      {
       i15 = 15;
       break L11;
      }
     case 2:
      {
       i15 = 17;
       break L11;
      }
     case 1:
      break;
     default:
      break L11;
     }
     i18 = HEAP32[i5 >> 2] | 0;
     HEAP32[i18 >> 2] = i2;
     HEAP32[i18 + 4 >> 2] = i3;
     if ((i1 | 0) == 8) {
      i15 = 17;
      break;
     }
     i2 = _getc(HEAP32[i11 >> 2] | 0) | 0;
     if ((i2 | 0) == -1) {
      i15 = 17;
      break;
     }
     HEAP8[i4 >> 0] = i2;
     i1 = i1 + 1 | 0;
    }
    if ((i15 | 0) == 15) HEAP32[i13 >> 2] = HEAP8[i12 >> 0]; else if ((i15 | 0) == 17) {
     i1 = -1;
     break;
    }
    i15 = 18;
   } else {
    HEAP32[i13 >> 2] = HEAP8[i12 >> 0];
    i15 = 18;
   } while (0);
   L21 : do if ((i15 | 0) == 18) {
    if (i14) {
     i1 = HEAP32[i13 >> 2] | 0;
     HEAP32[i10 + 48 >> 2] = i1;
     break;
    }
    while (1) {
     if ((i1 | 0) <= 0) break;
     i1 = i1 + -1 | 0;
     if ((_ungetc(HEAP8[i12 + i1 >> 0] | 0, HEAP32[i11 >> 2] | 0) | 0) == -1) {
      i1 = -1;
      break L21;
     }
    }
    i1 = HEAP32[i13 >> 2] | 0;
   } while (0);
  }
 } else {
  i2 = i10 + 48 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i14) {
   HEAP32[i2 >> 2] = -1;
   HEAP8[i3 >> 0] = 0;
  }
 }
 STACKTOP = i16;
 return i1 | 0;
}

function __ZNK5Unity5Joint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, f5 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 24 | 0;
 i11 = i14 + 12 | 0;
 i12 = i14;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i18 = HEAP32[i6 + 64 >> 2] | 0;
 HEAP32[i10 >> 2] = i18;
 i3 = i10 + 4 | 0;
 i17 = HEAP32[i6 + 68 >> 2] | 0;
 HEAP32[i3 >> 2] = i17;
 i4 = i10 + 8 | 0;
 i16 = HEAP32[i6 + 72 >> 2] | 0;
 HEAP32[i4 >> 2] = i16;
 f1 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f1 * f1);
 f2 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f15 + Math_fround(f2 * f2));
 f5 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f15 = Math_fround(f15 + Math_fround(f5 * f5));
 if (f15 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  HEAPF32[i10 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(1.0);
 }
 i18 = i6 + 40 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i11, i13, i18);
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 f15 = Math_fround(-Math_fround(HEAPF32[i18 >> 2]));
 f21 = Math_fround(-Math_fround(HEAPF32[i6 + 44 >> 2]));
 f20 = Math_fround(-Math_fround(HEAPF32[i6 + 48 >> 2]));
 f19 = Math_fround(Math_fround(f1 * f20) - Math_fround(f5 * f15));
 f15 = Math_fround(Math_fround(f2 * f15) - Math_fround(f1 * f21));
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(f5 * f21) - Math_fround(f2 * f20));
 HEAPF32[i11 + 4 >> 2] = f19;
 HEAPF32[i11 + 8 >> 2] = f15;
 __Z14OrthoNormalizeP8Vector3fS0_(i10, i11);
 __ZNK9Transform18TransformDirectionERK8Vector3f(i12, i13, i10);
 HEAP32[i8 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 __ZNK9Transform18TransformDirectionERK8Vector3f(i12, i13, i11);
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 STACKTOP = i14;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 648; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj648ENS_22PxRepXPropertyAccessorILj648ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 647; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj647ENS_22PxRepXPropertyAccessorILj647ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function _encode_mcu_gather(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = HEAP32[i14 + 348 >> 2] | 0;
 i4 = i14 + 188 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 | 0) {
  i5 = i16 + 36 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i2 = i14 + 228 | 0;
   if ((HEAP32[i2 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i16 + 20 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
    i1 = HEAP32[i4 >> 2] | 0;
   } else i1 = i3;
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i5 >> 2] = i1 + -1;
 }
 i9 = i14 + 256 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) return 1;
 i8 = 0;
 do {
  i12 = HEAP32[i14 + 260 + (i8 << 2) >> 2] | 0;
  i13 = HEAP32[i14 + 232 + (i12 << 2) >> 2] | 0;
  i10 = i15 + (i8 << 2) | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i12 = i16 + 20 + (i12 << 2) | 0;
  i4 = HEAP32[i16 + 76 + (HEAP32[i13 + 20 >> 2] << 2) >> 2] | 0;
  i13 = HEAP32[i16 + 92 + (HEAP32[i13 + 24 >> 2] << 2) >> 2] | 0;
  i1 = (HEAP16[i11 >> 1] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
  i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
  if (!i1) i1 = 0; else {
   i3 = 0;
   i2 = i1;
   while (1) {
    i1 = i3 + 1 | 0;
    i2 = i2 >> 1;
    if (!i2) break; else i3 = i1;
   }
   if ((i3 | 0) > 10) {
    i7 = HEAP32[i14 >> 2] | 0;
    HEAP32[i7 + 20 >> 2] = 6;
    mftCall_vi(HEAP32[i7 >> 2] | 0, i14 | 0);
   }
  }
  i7 = i4 + (i1 << 2) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  i7 = i13 + 960 | 0;
  i6 = 1;
  i1 = 0;
  do {
   i4 = HEAP16[i11 + (HEAP32[gb + 15416 + (i6 << 2) >> 2] << 1) >> 1] | 0;
   i5 = i4 << 16 >> 16;
   if (!(i4 << 16 >> 16)) i1 = i1 + 1 | 0; else {
    i2 = i1 + -16 | 0;
    i3 = i2 >>> 4;
    if ((i1 | 0) > 15) {
     HEAP32[i7 >> 2] = i3 + 1 + (HEAP32[i7 >> 2] | 0);
     i1 = i2 - (i3 << 4) | 0;
    }
    i3 = 1;
    i2 = i4 << 16 >> 16 < 0 ? 0 - i5 | 0 : i5;
    while (1) {
     i2 = i2 >> 1;
     if (!i2) break; else i3 = i3 + 1 | 0;
    }
    if ((i3 | 0) > 10) {
     i5 = HEAP32[i14 >> 2] | 0;
     HEAP32[i5 + 20 >> 2] = 6;
     mftCall_vi(HEAP32[i5 >> 2] | 0, i14 | 0);
    }
    i1 = i13 + (i3 + (i1 << 4) << 2) | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    i1 = 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != 64);
  if ((i1 | 0) > 0) HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  HEAP32[i12 >> 2] = HEAP16[HEAP32[i10 >> 2] >> 1];
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (HEAP32[i9 >> 2] | 0));
 return 1;
}

function __ZN9GfxDevice18EndDynamicBatchingE13TransformType(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, d9 = 0.0;
 i8 = i7 + 4536 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) return;
 i4 = i7 + 4512 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 896 >> 2] | 0, i7 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i3 = i7 + 4588 | 0;
 i6 = i7 + 4568 | 0;
 i5 = i7 + 4572 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0);
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 104 >> 2] | 0, i7 | 0, gb + 1162292 | 0, i2 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 896 >> 2] | 0, i7 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 mftCall_viiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i3 | 0, i7 + 4552 | 0, HEAP32[i7 + 4556 >> 2] | 0, HEAP32[i7 + 4612 >> 2] | 0, 0, 0);
 HEAP32[i7 + 4588 >> 2] = 0;
 HEAP32[i7 + 4592 >> 2] = 0;
 HEAP32[i7 + 4596 >> 2] = -1;
 HEAP32[i7 + 4600 >> 2] = 0;
 i2 = i7 + 4544 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 d9 = +_emscripten_get_now() * 1.0e6;
 i2 = _i64Subtract(~~d9 >>> 0 | 0, (+Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 switch (HEAP32[i7 + 4580 >> 2] | 0) {
 case 0:
  {
   i1 = (i1 | 0) / 3 | 0;
   break;
  }
 case 1:
  {
   i1 = i1 + -2 | 0;
   break;
  }
 case 2:
  {
   i1 = ((i1 | 0) / 4 | 0) << 1;
   break;
  }
 case 3:
  {
   i1 = (i1 | 0) / 2 | 0;
   break;
  }
 case 4:
  {
   i1 = i1 + -1 | 0;
   break;
  }
 case 5:
  break;
 default:
  i1 = 0;
 }
 if (HEAP8[i7 + 3896 >> 0] | 0) {
  i4 = HEAP32[i7 + 4576 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i5 = i7 + 3660 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = i7 + 3664 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i4;
  i5 = i7 + 3720 | 0;
  i4 = i5;
  i3 = _i64Add(i2 | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
  i4 = getTempRet0() | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i4;
  i5 = i7 + 3668 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
  i7 = i7 + 3672 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i6;
 }
 HEAP8[i8 >> 0] = 0;
 return;
}

function __ZN31EnlightenSystemAtlasInformation8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402667 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i4 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402677 | 0, gb + 455698 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402595 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 23; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 23; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z24InitializeGUIClipTexturev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 8 | 0;
 i1 = i15;
 if (HEAP32[gb + 1468868 >> 2] | 0) {
  STACKTOP = i15;
  return;
 }
 i13 = gb + 63520 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i1;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i11 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i14) | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, 125);
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 188 >> 2] | 0, i11 | 0, 16, 16, 1, 0, 1, -1, 0) | 0;
 __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i11, 0);
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0, gb + 1017472 | 0);
 HEAP32[i11 + 36 >> 2] = 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0) | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0;
 __ZN9Texture2D18UnshareTextureDataEv(i11);
 i1 = HEAP32[i11 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i11 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 i7 = __Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0;
 if ((i12 | 0) > 0 & (i13 | 0) > 0) {
  i8 = Math_imul(i7, i12) | 0;
  i9 = i12 + -1 | 0;
  i10 = i13 + -1 | 0;
  i6 = 0;
  while (1) {
   i4 = (i6 | 0) == 0;
   i5 = (i10 | 0) == (i6 | 0);
   i2 = 0;
   i3 = i1;
   while (1) {
    HEAP8[i3 >> 0] = ((i5 | ((i9 | 0) == (i2 | 0) | (i4 | (i2 | 0) == 0))) ^ 1) << 31 >> 31;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i12 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == (i13 | 0)) break; else i1 = i1 + i8 | 0;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 196 >> 2] | 0, i11 | 0);
 HEAP32[gb + 1468868 >> 2] = i11;
 __ZN7Texture13SetFilterModeEi(i11, 0);
 __ZN7Texture11SetWrapModeEi(HEAP32[gb + 1468868 >> 2] | 0, 1);
 i13 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i14 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i14, gb + 1017485 | 0);
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i13, i14, HEAP32[gb + 1468868 >> 2] | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 532; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj532ENS_22PxRepXPropertyAccessorILj532ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 3) | 0, 0, i5 - i3 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 i4 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 8);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i7 = i2;
   i2 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i6 = i8;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i7;
   HEAP32[i9 >> 2] = i3;
   i3 = i7;
  }
  i6 = _llvm_bswap_i32(i2 | 0) | 0;
  HEAP32[i8 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  i3 = i8;
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = i1;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 3) | 0, 0, i5 - i3 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 i4 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 8);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i7 = i2;
   i2 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i6 = i8;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i7;
   HEAP32[i9 >> 2] = i3;
   i3 = i7;
  }
  i6 = _llvm_bswap_i32(i2 | 0) | 0;
  HEAP32[i8 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  i3 = i8;
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = i1;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __ZN13ProbeSetIndex8TransferI14SafeBinaryReadEEvRT_(i6, i9) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 431143 | 0, gb + 455698 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i6, i9); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 800947 | 0, i5, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i8 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i8 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 842535 | 0, i5, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 23; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 23; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 23) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZNK26AnimatorControllerPlayable25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = i8 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((i6 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0) | 0) i1 = HEAP32[HEAP32[i5 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i6 | 0)) {
   i1 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i1) {
    i4 = 0;
    i1 = 4;
    i2 = HEAP32[1] | 0;
   } else {
    i4 = i1 + 12 | 0;
    i2 = i1 + 4 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    i3 = i2 + i1 + (i6 << 2) | 0;
    i3 = (HEAP32[i4 >> 2] | 0) + i4 + (HEAP32[i3 + (HEAP32[i3 >> 2] | 0) >> 2] << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i4 = (i4 | 0) == 0 ? 0 : i3 + i4 | 0;
   }
   i3 = (HEAP32[i5 + 100 >> 2] | 0) + 4 | 0;
   i6 = i2 + i1 + (i6 << 2) | 0;
   i6 = (HEAP32[i3 >> 2] | 0) + i3 + (HEAP32[i6 + (HEAP32[i6 >> 2] | 0) >> 2] << 2) | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i3 = (i3 | 0) == 0 ? 0 : i6 + i3 | 0;
   if (!(HEAP8[i3 + 81 >> 0] | 0)) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   i1 = __ZN7mecanim12statemachine21GetTransitionConstantEPKNS0_20StateMachineConstantEPKNS0_18StateMachineMemoryE(i4, i3) | 0;
   if (!i1) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i7 + 4 >> 2] = 0;
    HEAP32[i7 + 8 >> 2] = 0;
    i1 = 0;
    i2 = 1;
   } else {
    HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 16 >> 2];
    i2 = (__ZN7mecanim12statemachine27IsCurrentTransitionAnyStateEPKNS0_18StateMachineMemoryE(i3) | 0) & 1;
    i1 = HEAP32[i3 + 28 >> 2] | 0;
   }
   HEAP8[i7 + 16 >> 0] = i2;
   HEAP32[i7 + 20 >> 2] = i1;
   HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 68 >> 2];
   i7 = 1;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i2 >> 2] = i6;
 __Z6FormatPKcz(i3, gb + 902210 | 0, i2);
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN8WindZone8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx7NpShape17resolveReferencesERNS_24PxDeserializationContextE(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 48 | 0;
 i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i9) | 0;
 i3 = __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i9) | 0;
 if (i1 << 16 >> 16) {
  i1 = i1 & 65535;
  i2 = 0;
  do {
   __ZN5physx2Sc9ShapeCore24resolveMaterialReferenceEjt(i9, i2, HEAP32[(mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, 1, HEAPU16[i3 + (i2 << 1) >> 1] | 0) | 0) + 52 >> 2] & 65535);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i1 = i8 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i2 | 0) | 0;
 __ZN5physx2Sc9ShapeCore17resolveReferencesERNS_24PxDeserializationContextE(i9, i4);
 i1 = i8 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i8 + 36 >> 2] & 1) i1 = (HEAP32[i8 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i5 = 16;
   }
   break;
  }
 case 6:
  {
   if (HEAP32[i8 + 36 >> 2] & 1) i1 = (HEAP32[i8 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i5 = 16;
   }
   break;
  }
 case 5:
  {
   if (HEAP32[i8 + 36 >> 2] & 1) i1 = (HEAP32[i8 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i5 = 16;
   }
   break;
  }
 default:
  {}
 }
 if ((i5 | 0) == 16) __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 4 | 0) | 0;
 i6 = i8 + 36 | 0;
 if (!(HEAP32[i6 >> 2] & 2)) i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i9) | 0; else i1 = HEAP16[(HEAP32[i8 + 40 >> 2] | 0) + 116 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i7 = i8 + 40 | 0;
 i5 = i8 + 32 | 0;
 i3 = i1 & 65535;
 i4 = 0;
 do {
  i2 = HEAP32[gb + 1457324 >> 2] | 0;
  if (!(HEAP32[i6 >> 2] & 2)) {
   i1 = HEAPU16[(__ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i9) | 0) + (i4 << 1) >> 1] | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((HEAP16[i1 + 116 >> 1] | 0) == 1) i1 = i1 + 112 | 0; else i1 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (HEAPU16[i1 + (i4 << 1) >> 1] << 2) | 0;
  }
  __ZN5physx6shdfnd15atomicIncrementEPVi((HEAP32[i1 >> 2] | 0) + 16 | 0) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __Z18OrthoNormalizeFastP8Vector3fS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, i18 = 0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f14 * f14);
 i17 = i1 + 4 | 0;
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f12 * f12));
 i16 = i1 + 8 | 0;
 f11 = Math_fround(HEAPF32[i16 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f11 * f11))));
 f14 = Math_fround(f14 / f10);
 f12 = Math_fround(f12 / f10);
 f10 = Math_fround(f11 / f10);
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i17 >> 2] = f12;
 HEAPF32[i16 >> 2] = f10;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(f14 * f11);
 i18 = i2 + 4 | 0;
 f13 = Math_fround(HEAPF32[i18 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f12 * f13));
 i5 = i2 + 8 | 0;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f10 * f9));
 f14 = Math_fround(f11 - Math_fround(f14 * f15));
 f12 = Math_fround(f13 - Math_fround(f12 * f15));
 f15 = Math_fround(f9 - Math_fround(f10 * f15));
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f15 * f15) + Math_fround(Math_fround(f12 * f12) + Math_fround(f14 * f14)))));
 f14 = Math_fround(f14 / f10);
 f12 = Math_fround(f12 / f10);
 f10 = Math_fround(f15 / f10);
 HEAPF32[i2 >> 2] = f14;
 HEAPF32[i18 >> 2] = f12;
 HEAPF32[i5 >> 2] = f10;
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f14 * f15);
 i5 = i3 + 4 | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f12 * f13));
 i2 = i3 + 8 | 0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f10 * f11));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f15 * f8);
 f6 = Math_fround(HEAPF32[i17 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f13 * f6));
 f7 = Math_fround(HEAPF32[i16 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f11 * f7));
 f8 = Math_fround(f15 - Math_fround(Math_fround(f14 * f9) + Math_fround(f8 * f4)));
 f6 = Math_fround(f13 - Math_fround(Math_fround(f12 * f9) + Math_fround(f6 * f4)));
 f4 = Math_fround(f11 - Math_fround(Math_fround(f10 * f9) + Math_fround(f7 * f4)));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f6 * f6) + Math_fround(f8 * f8)))));
 f6 = Math_fround(f6 / f7);
 f4 = Math_fround(f4 / f7);
 HEAPF32[i3 >> 2] = Math_fround(f8 / f7);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i2 >> 2] = f4;
 return;
}

function __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(Math_fround(1.0) - f5);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i9 = i2 >>> 16 << 2;
  f10 = Math_fround(Math_fround((i2 & 65535) >>> 0) * Math_fround(.0000152587891));
  f12 = Math_fround(Math_fround(1.0) - f10);
  i15 = i9 + 4 | 0;
  f11 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i9 << 2) >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 | 1;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i16 = i9 + 5 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i16 << 2) >> 2])))));
  i16 = i9 | 2;
  f11 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  i15 = i9 + 6 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i16 << 2) >> 2]);
  HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 | 3;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i9 = i9 + 7 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 12 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i9 << 2) >> 2])))));
  i1 = i1 + -1 | 0;
  if (!i1) break; else {
   i3 = i3 + 16 | 0;
   i2 = i4 + i2 | 0;
  }
 }
 return;
}

function __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(Math_fround(1.0) - f5);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i9 = i2 >>> 16 << 2;
  f10 = Math_fround(Math_fround((i2 & 65535) >>> 0) * Math_fround(.0000152587891));
  f12 = Math_fround(Math_fround(1.0) - f10);
  i15 = i9 + 4 | 0;
  f11 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i9 << 2) >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 | 1;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i16 = i9 + 5 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i16 << 2) >> 2])))));
  i16 = i9 | 2;
  f11 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  i15 = i9 + 6 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i16 << 2) >> 2]);
  HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 | 3;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i9 = i9 + 7 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 12 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i9 << 2) >> 2])))));
  i1 = i1 + -1 | 0;
  if (!i1) break; else {
   i3 = i3 + 16 | 0;
   i2 = i4 + i2 | 0;
  }
 }
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 561; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj561ENS_22PxRepXPropertyAccessorILj561ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN2UI6Canvas17RemoveFromManagerEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i9 + 344 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 L1 : do if (!i6) i8 = 3; else if (!(HEAP8[i9 + 375 >> 0] | 0)) {
  i7 = i6 + 428 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = i2;
  i5 = HEAP32[i6 + 424 >> 2] | 0;
  while (1) {
   if ((i5 | 0) == (i2 | 0)) break L1;
   i3 = i5 + 4 | 0;
   if ((HEAP32[i5 >> 2] | 0) == (i9 | 0)) break; else i5 = i3;
  }
  i1 = i1 - i3 | 0;
  i4 = i1 >> 2;
  if (i4) {
   _memmove(i5 | 0, i3 | 0, i1 | 0) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i1 = i5 + (i4 << 2) | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  i1 = i6 + 224 | 0;
  HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 4;
  i1 = HEAP32[gb + 1467948 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  if (i9 | 0) __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i1 + 12 | 0, i10) | 0;
 } else i8 = 3; while (0);
 if ((i8 | 0) == 3) {
  i7 = HEAP32[gb + 1467948 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  i6 = i7 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i2;
  i5 = HEAP32[i7 >> 2] | 0;
  while (1) {
   if ((i5 | 0) == (i2 | 0)) break;
   i4 = i5 + 4 | 0;
   if ((HEAP32[i5 >> 2] | 0) == (i9 | 0)) {
    i8 = 6;
    break;
   } else i5 = i4;
  }
  if ((i8 | 0) == 6) {
   i1 = i1 - i4 | 0;
   i3 = i1 >> 2;
   if (i3) {
    _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i1 = i5 + (i3 << 2) | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i7 + 12 | 0, i10) | 0;
  }
 }
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i8, gb + 1106096 | 0, i10);
 HEAP32[i11 >> 2] = 0;
 __ZN2UI17DestroyCanvasDataER8JobFenceRNS_10CanvasDataE(i9 + 332 | 0, i9 + 112 | 0);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i12 = i9 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i2 - i1 | 0) / 60 | 0) >>> 0 >= i3 >>> 0) {
  do {
   HEAP32[i1 >> 2] = -1;
   i2 = i1 + 48 | 0;
   i4 = i1 + 4 | 0;
   i5 = i4 + 44 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAPF32[i2 >> 2] = Math_fround(1.0);
   HEAP32[i1 + 52 >> 2] = 0;
   HEAP8[i1 + 56 >> 0] = 0;
   i1 = (HEAP32[i13 >> 2] | 0) + 60 | 0;
   HEAP32[i13 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i11 = i9 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 60 | 0) + i3 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i8 = (i2 - i4 | 0) / 60 | 0;
 i2 = i8 << 1;
 i2 = i8 >>> 0 < 1073741823 ? (i2 >>> 0 < i5 >>> 0 ? i5 : i2) : 2147483647;
 if (!i2) i5 = 0; else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 60 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i5 + (((i1 - i4 | 0) / 60 | 0) * 60 | 0) | 0;
 i8 = i5 + (i2 * 60 | 0) | 0;
 i6 = i7;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = -1;
  i2 = i1 + 48 | 0;
  i4 = i1 + 4 | 0;
  i5 = i4 + 44 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i5 | 0));
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAP32[i1 + 52 >> 2] = 0;
  HEAP8[i1 + 56 >> 0] = 0;
  i1 = i6 + 60 | 0;
  i6 = i1;
  i3 = i3 + -1 | 0;
 } while ((i3 | 0) != 0);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
 i3 = i7 + (((i2 | 0) / -60 | 0) * 60 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i13 >> 2] = i6;
 HEAP32[i12 >> 2] = i8;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i14;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5ungetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i4 + 4 >> 2] = 0;
 i3 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] & -3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i2 = 11; else {
  __THREW__ = 0;
  invoke_viii(fb + 1037 | 0, i2 | 0, i4 | 0, 1);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i2 = 11; else {
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
   i3 = i4 + i1 | 0;
   do if (!(HEAP8[i2 >> 0] | 0)) {
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 4 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) i2 = 12; else i2 = 17;
   } else {
    i3 = HEAP32[i3 + 24 >> 2] | 0;
    if (i3) {
     i1 = i3 + 12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((HEAP32[i3 + 8 >> 2] | 0) != (i2 | 0)) {
      HEAP32[i1 >> 2] = i2 + -1;
      i2 = 17;
      break;
     }
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, -1) | 0;
     i3 = __THREW__;
     __THREW__ = 0;
     if (i3 & 1) {
      i2 = 12;
      break;
     }
     if ((i1 | 0) != -1) {
      i2 = 17;
      break;
     }
     i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0;
    }
    i3 = i4 + i1 | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) i2 = 12; else i2 = 17;
   } while (0);
   if ((i2 | 0) == 12) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i2 = 13;
    break;
   } else if ((i2 | 0) == 17) break;
  }
 } while (0);
 if ((i2 | 0) == 11) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = 13;
 }
 do if ((i2 | 0) == 13) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (!(i3 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN12TreeRenderer17UpdateShaderPropsERK6Cameraf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 24 | 0;
 i9 = i4 + 20 | 0;
 i14 = i4 + 16 | 0;
 i5 = i4;
 __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i2 = HEAP32[i1 + 196 >> 2] | 0;
 i17 = HEAP32[i2 + 52 >> 2] | 0;
 i16 = HEAP32[i2 + 56 >> 2] | 0;
 i15 = HEAP32[i2 + 60 >> 2] | 0;
 i13 = HEAP32[i2 + 68 >> 2] | 0;
 i12 = HEAP32[i2 + 72 >> 2] | 0;
 i11 = HEAP32[i2 + 76 >> 2] | 0;
 i10 = HEAP32[i2 + 84 >> 2] | 0;
 i6 = HEAP32[i2 + 88 >> 2] | 0;
 i7 = HEAP32[i2 + 92 >> 2] | 0;
 __ZNK21ImposterRenderTexture18GetBillboardParamsERfS0_(i2, i9, i14);
 i2 = i1 + 8 | 0;
 __ZN19ShaderPropertySheet5ClearEb(i2, 1);
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i2, 5);
 HEAP32[i5 >> 2] = i17;
 HEAP32[i5 + 4 >> 2] = i16;
 HEAP32[i5 + 8 >> 2] = i15;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467484 | 0, i5, 0);
 i1 = HEAP32[i14 >> 2] | 0;
 HEAP32[i5 >> 2] = i13;
 HEAP32[i5 + 4 >> 2] = i12;
 HEAP32[i5 + 8 >> 2] = i11;
 HEAP32[i5 + 12 >> 2] = i1;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467488 | 0, i5, 0);
 HEAP32[i5 >> 2] = i10;
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i5 + 8 >> 2] = i7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467492 | 0, i5, 0);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAP32[i5 + 12 >> 2] = i1;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467496 | 0, i5, 0);
 HEAPF32[i5 >> 2] = f3;
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2, gb + 1467500 | 0, i5, 0);
 __ZN19ShaderPropertySheet11ComputeHashEv(i2);
 STACKTOP = i4;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 604; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj604ENS_22PxRepXPropertyAccessorILj604ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __GLOBAL__sub_I_runtime_ui_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467952 | 0, gb + 1011778 | 0, 0, 0);
 HEAP32[gb + 1467964 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467964 | 0, gb + 1046318 | 0);
 HEAP32[gb + 1467968 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467968 | 0, gb + 1011800 | 0);
 HEAP32[gb + 1467972 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467972 | 0, gb + 1011810 | 0);
 HEAP32[gb + 1467976 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467976 | 0, gb + 1011829 | 0);
 HEAP32[gb + 1467980 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467980 | 0, gb + 1011847 | 0);
 HEAP32[gb + 1467984 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467984 | 0, gb + 1011860 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467988 | 0, gb + 1011870 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468e3 | 0, gb + 1011882 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468012 | 0, gb + 1011896 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468024 | 0, gb + 1011918 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468036 | 0, gb + 1011936 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468048 | 0, gb + 1011970 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468060 | 0, gb + 1011999 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468072 | 0, gb + 1012028 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468084 | 0, gb + 1012056 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468096 | 0, gb + 1012084 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468108 | 0, gb + 1012114 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468120 | 0, gb + 1012129 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468132 | 0, gb + 1012154 | 0, 0, 0);
 return;
}

function __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = (HEAP32[i10 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1085989 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1084342 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN6Camera21PostMultiCustomRenderENS_10RenderFlagEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  if ((HEAP16[gb + 1110508 + 6 >> 1] | 0) > -1) {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110508 | 0, i6);
   i1 = gb + 1110508 | 0;
  } else i1 = 0;
  i8 = HEAP32[gb + 1110508 >> 2] | 0;
  i9 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 648 >> 2] | 0, i9 | 0, i8 | 0);
  i8 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 652 >> 2] | 0, i8 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if (i2 & 64 | 0) {
  i9 = __Z12GetGfxDevicev() | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i8 = i8 + 148 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i8 | 0, i9 | 0, 0);
  __ZN6Shader23HandleShadersWithErrorsEv();
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i3 + 1156 >> 2] | 0;
 i9 = HEAP32[i3 + 1168 >> 2] | 0;
 i2 = i1 + (i9 << 3) | 0;
 if (i9 | 0) do {
  mftCall_vii(HEAP32[i1 >> 2] | 0, i3 | 0, HEAP32[i1 + 4 >> 2] | 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1105376 | 0, i6);
 if (!(__Z17GetMonoManagerPtrv() | 0)) {
  i9 = __Z12GetGfxDevicev() | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i8 = i8 + 148 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i8 | 0, i9 | 0, 0);
  __ZN6Shader23HandleShadersWithErrorsEv();
  STACKTOP = i7;
  return;
 }
 i2 = (__Z23GetCoreScriptingClassesv() | 0) + 96 | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i6);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0);
 HEAP32[i6 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 i9 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i8 = i8 + 148 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(i8 | 0, i9 | 0, 0);
 __ZN6Shader23HandleShadersWithErrorsEv();
 STACKTOP = i7;
 return;
}

function __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i1 = i9;
 i6 = i9 + 16 | 0;
 switch ((HEAP32[i8 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 3;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0) i2 = 3;
   break;
  }
 default:
  {}
 }
 if ((i2 | 0) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 700634 | 0, 298, gb + 699741 | 0, i1);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = i8 + 152 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i3 | 0, 204, (i1 ? gb + 699801 | 0 : gb + 837976 | 0) | 0, gb + 700634 | 0, 304) | 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 12;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 12;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 4;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 2;
  HEAP32[i1 + 48 >> 2] = 0;
  HEAP32[i1 + 52 >> 2] = 12;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 60 >> 2] = 12;
  HEAP32[i1 + 64 >> 2] = 0;
  HEAP32[i1 + 68 >> 2] = 4;
  HEAP32[i1 >> 2] = gb + 96560 + 8;
  HEAP8[i1 + 72 >> 0] = 0;
  HEAP8[i1 + 201 >> 0] = 1;
  _strncpy(i1 + 73 | 0, gb + 699935 | 0, 128) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 i3 = i1 + 72 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) i2 = i1 + 73 | 0; else {
  i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i2 = i1 + 73 | 0;
  HEAP32[i5 >> 2] = gb + 700118;
  HEAP32[i5 + 4 >> 2] = i2;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i5);
 }
 _strncpy(i2, gb + 700118 | 0, 128) | 0;
 HEAP8[i1 + 200 >> 0] = 0;
 HEAP8[i3 >> 0] = 1;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0;
 HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
 mftCall_vii(i5 | 0, i10 | 0, i6 | 0);
 __ZNK5physx2Sc18ParticleSystemCore19getParticleReadDataERNS_23PxParticleFluidReadDataE(i8 + 12 | 0, HEAP32[i4 >> 2] | 0);
 i10 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx11PxMeshQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleERNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKjfb(i18, f1, i13, i15, i16, i17, i8, i2, i11, f14, i12) {
 i18 = i18 | 0;
 f1 = Math_fround(f1);
 i13 = i13 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 f14 = Math_fround(f14);
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i19;
 i3 = i19 + 18 | 0;
 i4 = i19 + 16 | 0;
 i9 = i19 + 14 | 0;
 i10 = i19 + 12 | 0;
 i6 = f1 < Math_fround(1.0e8);
 f1 = i6 ? f1 : Math_fround(1.0e8);
 i6 = HEAPU16[i2 >> 1] | 0;
 i7 = (i6 | 7) & 65535;
 switch (HEAP32[i13 >> 2] | 0) {
 case 0:
  {
   i13 = HEAP32[i13 + 4 >> 2] | 0;
   HEAP32[i5 >> 2] = 2;
   HEAP32[i5 + 4 >> 2] = i13;
   HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
   HEAP16[i3 >> 1] = i7;
   i18 = __ZN5physx2Gu21SweepCapsuleTrianglesEjPKNS_10PxTriangleEbRKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS_6PxVec3EfPKjRSA_SF_RfRjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i16, i17, i12, i5, i15, i18, f1, i11, i8 + 16 | 0, i8 + 28 | 0, i8 + 40 | 0, i8 + 8 | 0, f14, i3) | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 2:
  {
   HEAP16[i4 >> 1] = i7;
   i18 = __ZN5physx2Gu21SweepCapsuleTrianglesEjPKNS_10PxTriangleEbRKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS_6PxVec3EfPKjRSA_SF_RfRjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i16, i17, i12, i13, i15, i18, f1, i11, i8 + 16 | 0, i8 + 28 | 0, i8 + 40 | 0, i8 + 8 | 0, f14, i4) | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 case 3:
  {
   i3 = i8 + 16 | 0;
   i4 = i8 + 28 | 0;
   i5 = i8 + 40 | 0;
   i2 = i8 + 8 | 0;
   if (!(i6 & 256)) {
    HEAP16[i10 >> 1] = i7;
    i18 = __ZN5physx2Gu17SweepBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i16, i17, i12, i13, i15, i18, f1, i3, i4, i5, i2, i11, f14, i10) | 0;
    STACKTOP = i19;
    return i18 | 0;
   } else {
    HEAP16[i9 >> 1] = i7;
    i18 = __ZN5physx2Gu20sweepCCTBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i16, i17, i12, i13, i15, i18, f1, i3, i4, i5, i2, i11, f14, i9) | 0;
    STACKTOP = i19;
    return i18 | 0;
   }
  }
 default:
  {
   i18 = 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 }
 return 0;
}

function __ZN2UI6Canvas13AwakeFromLoadE17AwakeFromLoadMode(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i7, i1);
 i8 = i7 + 224 | 0;
 HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 6;
 if (!((i1 & 5 | 0) == 0 | (HEAP8[i7 + 33 >> 0] | 0) == 0)) {
  __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i7, 1);
  i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1106036 | 0, i6);
 }
 if (i1 & 13 | 0) {
  i4 = __Z13GetTagManagerv() | 0;
  HEAP16[i7 + 420 >> 1] = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i4, HEAP32[i7 + 368 >> 2] | 0) | 0;
 }
 if (!(i1 & 16)) {
  STACKTOP = i9;
  return;
 }
 f2 = Math_fround(HEAPF32[i7 + 364 >> 2]);
 if (f2 != Math_fround(HEAPF32[i7 + 408 >> 2])) {
  HEAPF32[i7 + 408 >> 2] = f2;
  if (!(HEAP32[i7 + 344 >> 2] | 0)) {
   i4 = HEAP32[gb + 1467948 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = fb + 1103;
   __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i3, i4, i6);
   HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 6;
  }
 }
 i1 = HEAP8[i7 + 360 >> 0] | 0;
 i3 = i7 + 412 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 if (i1 << 24 >> 24 == (i4 & 255) << 24 >> 24) i1 = (i4 & 65535) >>> 8 & 255; else {
  HEAP8[i3 >> 0] = i1;
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1106036 | 0, i6);
  i1 = HEAP8[i7 + 413 >> 0] | 0;
 }
 if ((HEAP8[i7 + 375 >> 0] | 0) != i1 << 24 >> 24) __ZN2UI6Canvas27UpdateCanvasOverrideSortingEv(i7);
 i3 = i7 + 404 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = i7 + 416 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f2 != f5)) {
  STACKTOP = i9;
  return;
 }
 i7 = f2 < Math_fround(0.0);
 i6 = f2 > Math_fround(1.0);
 f2 = i6 ? Math_fround(1.0) : f2;
 f2 = i7 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 if (!(f2 != f5)) {
  STACKTOP = i9;
  return;
 }
 HEAPF32[i1 >> 2] = f2;
 HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 6;
 STACKTOP = i9;
 return;
}

function __ZN12TreeInstance8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 932479 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 24 >> 2] = i2;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 28 >> 2] = i1;
 i1 = i6 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS7_RS8_EE(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i16;
 i1 = HEAP32[i13 >> 2] | 0;
 i15 = i13 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i12 = i14 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i12;
  i4 = i13;
  i2 = HEAP32[i12 >> 2] | 0;
 } else {
  i10 = i9 + 4 | 0;
  i8 = i2;
  i2 = HEAP32[i12 >> 2] | 0;
  do {
   i6 = i2 + -16 | 0;
   i4 = i8;
   i8 = i8 + -16 | 0;
   i3 = HEAP32[i4 + -4 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i5 = i2 + -4 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i8 >> 2] | 0;
    i4 = HEAP32[i4 + -12 >> 2] | 0;
    if (i4 >>> 0 > 2147483631) {
     __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
     i3 = HEAP32[i5 >> 2] | 0;
     i11 = 9;
    } else if (i4 >>> 0 < 11) {
     HEAP8[i6 + 11 >> 0] = i4;
     if (!i4) i2 = i6; else {
      i2 = i6;
      i11 = 11;
     }
    } else i11 = 9;
    if ((i11 | 0) == 9) {
     i17 = i4 + 16 & -16;
     HEAP32[i9 >> 2] = 1;
     HEAP32[i10 >> 2] = i3;
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
     HEAP32[i6 >> 2] = i5;
     HEAP32[i2 + -8 >> 2] = i17 | -2147483648;
     HEAP32[i2 + -12 >> 2] = i4;
     i2 = i5;
     i11 = 11;
    }
    if ((i11 | 0) == 11) {
     i11 = 0;
     _memcpy(i2 | 0, i7 | 0, i4 | 0) | 0;
    }
    HEAP8[i2 + i4 >> 0] = 0;
   } else {
    HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   }
   i2 = (HEAP32[i12 >> 2] | 0) + -16 | 0;
   HEAP32[i12 >> 2] = i2;
  } while ((i8 | 0) != (i1 | 0));
  i3 = i12;
  i4 = i13;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i17 = i14 + 8 | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i12;
 i13 = i13 + 8 | 0;
 i17 = i14 + 12 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i15;
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i16;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 292; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj292ENS_22PxRepXPropertyAccessorILj292ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 291; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj291ENS_22PxRepXPropertyAccessorILj291ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5Umbra12QueryContext12clusterColorEi(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f11 = f0, f12 = f0, f13 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 + 8 >> 2] = 253983;
 HEAP32[i7 + 12 >> 2] = -66585089;
 HEAP32[i7 + 16 >> 2] = 1958451267;
 HEAP32[i7 + 20 >> 2] = -238253862;
 HEAP32[i7 + 24 >> 2] = 2049502865;
 HEAP32[i7 + 28 >> 2] = -1733996308;
 HEAP32[i7 + 32 >> 2] = 1705115568;
 HEAP32[i7 + 36 >> 2] = 279806459;
 HEAP32[i7 + 40 >> 2] = -1295742990;
 HEAP32[i7 + 44 >> 2] = 1700793103;
 HEAP32[i7 + 48 >> 2] = -465897233;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 7;
 i1 = 0;
 i5 = 0;
 i2 = 253983;
 i3 = 279806459;
 i4 = 7;
 while (1) {
  i2 = i2 + i3 | 0;
  HEAP32[i7 + 8 + (i5 << 2) >> 2] = i2 << 13 | i2 >>> 19;
  i2 = i5 + -1 | 0;
  i2 = (i2 >> 31 & 11) + i2 | 0;
  i4 = i4 + -1 | 0;
  i4 = (i4 >> 31 & 11) + i4 | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 9) break;
  i5 = i2;
  i2 = HEAP32[i7 + 8 + (i2 << 2) >> 2] | 0;
  i3 = HEAP32[i7 + 8 + (i4 << 2) >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 2;
 HEAP32[i6 >> 2] = 9;
 __ZN5Umbra6Random5resetEj(i7, (i10 * 444 | 0) + 555 | 0);
 i10 = HEAP32[i7 >> 2] | 0;
 i5 = i7 + 8 + (i10 << 2) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i4 = (HEAP32[i7 + 8 + (i6 << 2) >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0;
 i4 = i4 << 13 | i4 >>> 19;
 HEAP32[i5 >> 2] = i4;
 i10 = i10 + -1 | 0;
 i10 = (i10 >> 31 & 11) + i10 | 0;
 i6 = i6 + -1 | 0;
 i6 = (i6 >> 31 & 11) + i6 | 0;
 f13 = Math_fround((HEAP32[tempDoublePtr >> 2] = i4 & 8388607 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 i4 = i7 + 8 + (i10 << 2) | 0;
 i5 = (HEAP32[i7 + 8 + (i6 << 2) >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0;
 i5 = i5 << 13 | i5 >>> 19;
 HEAP32[i4 >> 2] = i5;
 i10 = i10 + -1 | 0;
 i6 = i6 + -1 | 0;
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i5 & 8388607 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 i10 = (HEAP32[i7 + 8 + ((i6 >> 31 & 11) + i6 << 2) >> 2] | 0) + (HEAP32[i7 + 8 + ((i10 >> 31 & 11) + i10 << 2) >> 2] | 0) | 0;
 f11 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10 << 13 & 8380416 | i10 >>> 19 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
 HEAPF32[i9 >> 2] = f13;
 HEAPF32[i9 + 4 >> 2] = f12;
 HEAPF32[i9 + 8 >> 2] = f11;
 HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 62; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN23ArchiveStorageConverter21FinalizeTargetArchiveEPj(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN24RingBufferMemoryFileData15NotifyWriteDoneEv(HEAP32[i2 + 4 >> 2] | 0);
 if (__ZN23ArchiveStorageConverter18DecompressAndStoreEv(i2) | 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i2 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  i6 = i2 + 64 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i2 + 28 >> 2] | 0;
   if (!(HEAP8[i2 + 184 >> 0] | 0)) {
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   }
   i5 = i2 + 120 | 0;
   i4 = i2 + 124 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i4 >> 2] | 0) != (i2 | 0)) {
    i3 = 0;
    do {
     i2 = i2 + (i3 * 40 | 0) + 20 | 0;
     if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
     HEAP32[i7 >> 2] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
     HEAP32[i7 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, _strlen(i2) | 0);
     i11 = HEAP32[i5 >> 2] | 0;
     i10 = i11 + (i3 * 40 | 0) | 0;
     i2 = i11 + (i3 * 40 | 0) + 8 | 0;
     __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy(i1, i7, HEAP32[i11 + (i3 * 40 | 0) + 16 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
     i3 = i3 + 1 | 0;
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    } while (i3 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i2 | 0) / 40 | 0) >>> 0);
   }
   if (!(__ZN21ArchiveStorageCreator8FinalizeEPj(i1, i8) | 0)) {
    i11 = 0;
    STACKTOP = i9;
    return i11 | 0;
   }
  }
 } else {
  i1 = __ZN12FileAccessor5CloseEv(i1) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i3 >> 2] = 0;
  if (i1) {
   if (!i8) break;
   HEAP32[i8 >> 2] = 0;
   break;
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 490699 | 0, 0, gb + 490147 | 0, 162, 1, 0, 0, 0);
   i11 = 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 } while (0);
 i11 = 1;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN18AsyncUploadManagerC2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i8 + 40 >> 2] = 0;
 i1 = i8 + 1324 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i8 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 3;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAP8[i2 + 36 >> 0] = 0;
  HEAP32[i2 + 32 >> 2] = 0;
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i8 + 1324 >> 2] = 0;
 i7 = gb + 63304 | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i8 + 1332 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = i8 + 1328 | 0;
 HEAP32[i3 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 i1 = 32;
 while (1) {
  i6 = __ZnwjRK10MemLabelIdiPKci(16, i2, 16, gb + 397729 | 0, 17) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i6;
  if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
 }
 i7 = gb + 63304 | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i8 + 1344 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = i8 + 1340 | 0;
 HEAP32[i3 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 i1 = 32;
 while (1) {
  i6 = __ZnwjRK10MemLabelIdiPKci(16, i2, 16, gb + 397729 | 0, 17) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i6;
  if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
 }
 i7 = gb + 63304 | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i8 + 1356 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 i3 = i8 + 1352 | 0;
 HEAP32[i3 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 i1 = 32;
 while (1) {
  i4 = __ZnwjRK10MemLabelIdiPKci(184, i2, 16, gb + 397729 | 0, 17) | 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 132 >> 2] = 0;
  HEAP32[i4 + 136 >> 2] = 0;
  HEAP32[i4 + 140 >> 2] = 1;
  i5 = i4 + 144 | 0;
  i6 = i5;
  i7 = i6 + 36 | 0;
  do {
   HEAP32[i6 >> 2] = 0;
   i6 = i6 + 4 | 0;
  } while ((i6 | 0) < (i7 | 0));
  HEAP8[i5 + 36 >> 0] = 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i4;
  if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
 }
 HEAP32[i8 + 32 >> 2] = __Z22CreateMutexLockedQueuev() | 0;
 HEAP32[i8 + 36 >> 2] = __Z22CreateMutexLockedQueuev() | 0;
 return;
}

function __ZNK5physx2Sc9ClothCore16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES4_PNS_24PxClothCollisionTriangleE(i1, i15, i12, i14, i13, i21) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i21 = i21 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i22 = 0, i23 = 0, i24 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i22 + 72 | 0;
 i19 = i22 + 64 | 0;
 i18 = i22 + 56 | 0;
 i17 = i22 + 48 | 0;
 i16 = i22 + 40 | 0;
 i3 = i22 + 32 | 0;
 i4 = i22 + 24 | 0;
 i6 = i22 + 16 | 0;
 i8 = i22 + 8 | 0;
 i10 = i22;
 if (!i15) i5 = 0; else {
  i5 = HEAP32[i1 + 28 >> 2] | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 168 >> 2] | 0, i5 | 0) | 0;
 }
 if (!i12) i7 = 0; else {
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i7 = (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 176 >> 2] | 0, i7 | 0) | 0) << 1;
 }
 if (!i14) i9 = 0; else {
  i9 = HEAP32[i1 + 28 >> 2] | 0;
  i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 184 >> 2] | 0, i9 | 0) | 0;
 }
 if (!i13) i11 = 0; else {
  i11 = HEAP32[i1 + 28 >> 2] | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 192 >> 2] | 0, i11 | 0) | 0;
 }
 i1 = i1 + 28 | 0;
 if (!i21) i2 = 0; else {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0) | 0) * 3 | 0;
 }
 i23 = HEAP32[i1 >> 2] | 0;
 i23 = mftCall_ii(HEAP32[(HEAP32[i23 >> 2] | 0) + 16 >> 2] | 0, i23 | 0) | 0;
 i24 = HEAP32[(HEAP32[i23 >> 2] | 0) + 28 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i15;
 HEAP32[i3 + 4 >> 2] = i15 + (i5 << 4);
 HEAP32[i4 >> 2] = i12;
 HEAP32[i4 + 4 >> 2] = i12 + (i7 << 2);
 HEAP32[i6 >> 2] = i14;
 HEAP32[i6 + 4 >> 2] = i14 + (i9 << 4);
 HEAP32[i8 >> 2] = i13;
 HEAP32[i8 + 4 >> 2] = i13 + (i11 << 2);
 HEAP32[i10 >> 2] = i21;
 HEAP32[i10 + 4 >> 2] = i21 + (i2 * 12 | 0);
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i17 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i19 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i20 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i20 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 mftCall_viiiiiii(i24 | 0, i23 | 0, i1 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0);
 STACKTOP = i22;
 return;
}

function __ZN9SubModule13AddSubEmitterEP14ParticleSystem21ParticleSystemSubTypei(i8, i4, i9, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 8 | 0;
 i3 = i13;
 i11 = i8 + 8 | 0;
 i12 = i8 + 20 | 0;
 do if ((HEAP32[i12 >> 2] | 0) == 1) {
  i5 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
     i2 = HEAP32[i2 >> 2] | 0;
     i7 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else if (HEAP32[i1 + 4 >> 2] | 0) break;
   }
   if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) break;
  }
  HEAP32[i12 >> 2] = 0;
 } while (0);
 if (!i4) i1 = 0; else i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i2 = i6 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2 * 12 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i12 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i11 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + (i3 * 12 | 0) >> 2] = i1;
 HEAP32[i12 + (i3 * 12 | 0) + 4 >> 2] = i9;
 HEAP32[i12 + (i3 * 12 | 0) + 8 >> 2] = i10;
 STACKTOP = i13;
 return;
}

function __Z6GetTagR11UTF16StringRiRb(i5, i10, i1) {
 i5 = i5 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((HEAP16[i3 + (i2 << 1) >> 1] | 0) != 60) {
  i10 = -1;
  return i10 | 0;
 }
 i4 = i2 + 1 | 0;
 i6 = i5 + 4 | 0;
 if ((i4 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i10 = -1;
  return i10 | 0;
 }
 i3 = (HEAP16[i3 + (i4 << 1) >> 1] | 0) == 47;
 HEAP8[i1 >> 0] = i3 & 1;
 i8 = i3 ? i2 + 2 | 0 : i4;
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 L7 : do if (i3) {
  i2 = 0;
  while (1) {
   i1 = HEAP32[gb + 185396 + (i2 << 2) >> 2] | 0;
   i3 = HEAP8[i1 >> 0] | 0;
   L10 : do if (!(i3 << 24 >> 24)) i9 = 16; else {
    i5 = 0;
    while (1) {
     i4 = i5 + i8 | 0;
     if ((i4 | 0) == (i6 | 0)) break L10;
     i11 = HEAP16[i7 + (i4 << 1) >> 1] & 255;
     i4 = i11 << 24 >> 24;
     i5 = i5 + 1 | 0;
     if ((((i11 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255) << 24 >> 24 != i3 << 24 >> 24) break L10;
     i3 = HEAP8[i1 + i5 >> 0] | 0;
     if (!(i3 << 24 >> 24)) {
      i9 = 16;
      break;
     }
    }
   } while (0);
   if ((i9 | 0) == 16) {
    i9 = 0;
    i3 = HEAP16[i7 + ((_strlen(i1) | 0) + i8 << 1) >> 1] | 0;
    if ((i2 | 0) == 5 & i3 << 16 >> 16 == 32) {
     i2 = 5;
     break L7;
    }
    if (i3 << 16 >> 16 == 62) break L7;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= 10) {
    i1 = -1;
    break;
   }
  }
  return i1 | 0;
 } else {
  i2 = 0;
  while (1) {
   i1 = HEAP32[gb + 185396 + (i2 << 2) >> 2] | 0;
   i3 = HEAP8[i1 >> 0] | 0;
   L22 : do if (!(i3 << 24 >> 24)) i9 = 8; else {
    i5 = 0;
    while (1) {
     i4 = i5 + i8 | 0;
     if ((i4 | 0) == (i6 | 0)) break L22;
     i4 = HEAP16[i7 + (i4 << 1) >> 1] & 255;
     i11 = i4 << 24 >> 24;
     i5 = i5 + 1 | 0;
     if ((((i4 + -65 & 255) < 26 ? i11 + 32 | 0 : i11) & 255) << 24 >> 24 != i3 << 24 >> 24) break L22;
     i3 = HEAP8[i1 + i5 >> 0] | 0;
     if (!(i3 << 24 >> 24)) {
      i9 = 8;
      break;
     }
    }
   } while (0);
   if ((i9 | 0) == 8) {
    i9 = 0;
    i3 = HEAP16[i7 + ((_strlen(i1) | 0) + i8 << 1) >> 1] | 0;
    if (i3 << 16 >> 16 == 61) break L7;
    if ((i2 | 0) == 5 & i3 << 16 >> 16 == 32) {
     i2 = 5;
     break L7;
    }
    if (i3 << 16 >> 16 == 62) break L7;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= 10) {
    i1 = -1;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 HEAP32[i10 >> 2] = (_strlen(i1) | 0) + i8;
 i11 = i2;
 return i11 | 0;
}

function __Z19TransferField_ArrayI14SafeBinaryRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i8 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i4 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i8, 0); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) {
  i6 = HEAP32[i3 + 24 >> 2] | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
  i5 = (i2 | 0) / 12 | 0;
  i3 = i6 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i5 | 0)) {
   HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i5) | 0;
   HEAP32[i3 >> 2] = i5;
  }
  if (i2 | 0) {
   i2 = i8 + 16 | 0;
   i3 = i8 + 24 | 0;
   i4 = i8 + 20 | 0;
   i1 = 0;
   do {
    i11 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i1) | 0;
    HEAP32[i11 >> 2] = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i11 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_123DebugKHRDefaultCallbackEjjjjiPKcPKv(i2, i6, i9, i5, i1, i10, i11) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 switch (i2 | 0) {
 case 33350:
  {
   i3 = gb + 606238 | 0;
   break;
  }
 case 33351:
  {
   i3 = gb + 597825 | 0;
   break;
  }
 case 33352:
  {
   i3 = gb + 597833 | 0;
   break;
  }
 case 33353:
  {
   i3 = gb + 597849 | 0;
   break;
  }
 case 33354:
  {
   i3 = gb + 597861 | 0;
   break;
  }
 default:
  i3 = (i2 | 0) == 33355 ? gb + 597819 | 0 : 0;
 }
 switch (i6 | 0) {
 case 33356:
  {
   i4 = gb + 597964 | 0;
   break;
  }
 case 33357:
  {
   i4 = gb + 597883 | 0;
   break;
  }
 case 33358:
  {
   i4 = gb + 597903 | 0;
   break;
  }
 case 33359:
  {
   i4 = gb + 597922 | 0;
   break;
  }
 case 33360:
  {
   i4 = gb + 597934 | 0;
   break;
  }
 case 33361:
  {
   i4 = gb + 1039657 | 0;
   break;
  }
 case 33384:
  {
   i4 = gb + 597946 | 0;
   break;
  }
 case 33385:
  {
   i4 = gb + 597953 | 0;
   break;
  }
 default:
  i4 = (i6 | 0) == 33386 ? gb + 597873 | 0 : 0;
 }
 switch (i5 | 0) {
 case 37190:
  {
   i2 = gb + 597990 | 0;
   break;
  }
 case 37191:
  {
   i2 = gb + 597983 | 0;
   break;
  }
 case 37192:
  {
   i2 = gb + 748477 | 0;
   break;
  }
 default:
  i2 = (i5 | 0) == 33387 ? gb + 597970 | 0 : 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 643 >> 0] | 0)) {
  if ((i6 | 0) == 33360 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 642 >> 0] | 0) != 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) {
    if (!(_strcmp(i1, gb + 1053978 | 0) | 0)) if (_strstr(i10, gb + 597995 | 0) | 0) {
     STACKTOP = i8;
     return;
    }
    if (!(_strcmp(i1, gb + 598024 | 0) | 0)) if (_strstr(i10, gb + 598041 | 0) | 0) {
     STACKTOP = i8;
     return;
    }
   }
  }
 } else if ((i9 | 0) == 131222) if (!(_strcmp(HEAP32[i11 >> 2] | 0, gb + 1055768 | 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = HEAP32[i11 + 8 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAP32[i7 + 12 >> 2] = i9;
 HEAP32[i7 + 16 >> 2] = i10;
 HEAP32[i7 + 20 >> 2] = i5 | 0 ? i5 : gb + 1576256 | 0;
 HEAP32[i7 + 24 >> 2] = i6;
 HEAP32[i7 + 28 >> 2] = i11 | 0 ? i11 : gb + 1576256 | 0;
 _printf_console(gb + 598074 | 0, i7);
 STACKTOP = i8;
 return;
}

function __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i7, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 HEAP32[i2 >> 2] = 0;
 i1 = _il2cpp_class_get_methods(i3 | 0, i2 | 0) | 0;
 L1 : do if (i1 | 0) {
  L3 : do if ((i5 | 0) == -1) while (1) {
   do if (!(_strcmp(_il2cpp_method_get_name(i1 | 0) | 0, i4) | 0)) {
    if (!(_il2cpp_method_is_inflated(i1 | 0) | 0)) if (_il2cpp_method_is_generic(i1 | 0) | 0) break;
    if (!(__ZN24ScriptingMethodFiltering17FilterOnSignatureENS_18MethodSearchFilterE(i6) | 0)) {
     i2 = 15;
     break L3;
    }
    i9 = _il2cpp_method_is_instance(i1 | 0) | 0;
    if (__ZN24ScriptingMethodFiltering36MethodDescriptionMatchesSearchFilterENS_18MethodSearchFilterEbi(i6, i9, _il2cpp_method_get_param_count(i1 | 0) | 0) | 0) {
     i2 = 17;
     break L3;
    }
   } while (0);
   i1 = _il2cpp_class_get_methods(i3 | 0, i2 | 0) | 0;
   if (!i1) break L1;
  } else while (1) {
   do if (!(_strcmp(_il2cpp_method_get_name(i1 | 0) | 0, i4) | 0)) if ((_il2cpp_method_get_param_count(i1 | 0) | 0) == (i5 | 0)) {
    if (!(_il2cpp_method_is_inflated(i1 | 0) | 0)) if (_il2cpp_method_is_generic(i1 | 0) | 0) break;
    if (!(__ZN24ScriptingMethodFiltering17FilterOnSignatureENS_18MethodSearchFilterE(i6) | 0)) {
     i2 = 15;
     break L3;
    }
    i9 = _il2cpp_method_is_instance(i1 | 0) | 0;
    if (__ZN24ScriptingMethodFiltering36MethodDescriptionMatchesSearchFilterENS_18MethodSearchFilterEbi(i6, i9, _il2cpp_method_get_param_count(i1 | 0) | 0) | 0) {
     i2 = 17;
     break L3;
    }
   } while (0);
   i1 = _il2cpp_class_get_methods(i3 | 0, i2 | 0) | 0;
   if (!i1) break L1;
  } while (0);
  if ((i2 | 0) == 15) {
   HEAP32[i7 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else if ((i2 | 0) == 17) {
   HEAP32[i7 >> 2] = i1;
   STACKTOP = i8;
   return;
  }
 } while (0);
 if (i6 & 8 | 0) {
  i9 = i7;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i1 = _il2cpp_class_get_parent(i3 | 0) | 0;
 if (!i1) {
  i9 = i7;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  STACKTOP = i8;
  return;
 } else {
  __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i7, i1, i4, i5, i6);
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i8 = i5 - i3 >> 2;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i2 = i6;
 i10 = i5;
 if (i8 >>> 0 <= i1 - i6 >> 2 >>> 0) {
  i7 = i9 + 4 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i6 >> 2;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i3 + (i1 << 2) | 0 : i5;
  if ((i3 | 0) != (i1 | 0)) do {
   __ZN14ConstantStringaSERKS_(i2, i3);
   i3 = i3 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i3 | 0) != (i1 | 0));
  if (!i4) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   do {
    i10 = i1 + -4 | 0;
    HEAP32[i7 >> 2] = i10;
    __ZN14ConstantStringD2Ev(i10);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   return;
  }
  if ((i1 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i2, i1);
   i1 = i1 + 4 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i10 | 0));
  return;
 }
 if (i6) {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i6; else {
   do {
    i6 = i1 + -4 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN14ConstantStringD2Ev(i6);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i9 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else i2 = 0;
 i6 = i1 - i2 | 0;
 i1 = i6 >> 1;
 i1 = i6 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i8 >>> 0 ? i8 : i1) : 1073741823;
 if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
 i2 = __Znwj(i1 << 2) | 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 2);
 if ((i3 | 0) == (i10 | 0)) return;
 i1 = i3;
 do {
  HEAP32[i2 >> 2] = 0;
  __ZN14ConstantString6assignERKS_(i2, i1);
  i1 = i1 + 4 | 0;
  i2 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
  HEAP32[i4 >> 2] = i2;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN17ArchiveFileSystem24UnmountArchiveFromMemoryEPKv(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = i10 + 1060 | 0;
 i9 = i8 + 120 | 0;
 i5 = i8 + 124 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  i3 = i5;
  i2 = i1;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i3 | 0) == (i5 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = i3 + 24 | 0;
 __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader(i8, HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 152 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = i8 + 156 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i5 + 1;
  HEAP32[i7 >> 2] = i5;
  __Z6FormatPKcz(i6, gb + 490134 | 0, i7);
  i5 = i7 + 1040 | 0;
  HEAP8[i7 >> 0] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  i5 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  _memcpy(i7 | 0, (i4 ? HEAP32[i6 >> 2] | 0 : i6) | 0, (i4 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255) + 1 | 0) | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0, i7 | 0, 0) | 0;
  __ZN13FileEntryDataD2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) HEAP32[i9 >> 2] = i1;
 i9 = i8 + 128 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 124 >> 2] | 0, i3);
 __ZdlPv(i3);
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx15computeTankDiffEffjPKbPfS2_S2_(f7, f8, i15, i12, i13, i14, i16) {
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i15 = i15 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f9 = f0, f10 = f0, i11 = 0;
 f5 = Math_fround(Math_abs(Math_fround(f7)));
 f6 = Math_fround(Math_abs(Math_fround(f8)));
 i11 = (i15 | 0) == 0;
 if (i11) {
  f10 = Math_fround(0.0);
  i4 = 0;
  f2 = Math_fround(0.0);
 } else {
  i1 = 0;
  f2 = Math_fround(0.0);
  do {
   f10 = Math_fround(f2 + Math_fround(1.0));
   f2 = (HEAP8[i12 + i1 >> 0] | 0) == 0 ? f2 : f10;
   i1 = i1 + 2 | 0;
  } while (i1 >>> 0 < i15 >>> 0);
  i4 = f2 > Math_fround(0.0);
  f3 = Math_fround(Math_fround(1.0) / f2);
  f3 = i4 ? f3 : Math_fround(0.0);
  i4 = i15 >>> 0 > 1;
  if (i4) {
   i1 = 1;
   f2 = Math_fround(0.0);
   do {
    f10 = Math_fround(f2 + Math_fround(1.0));
    f2 = (HEAP8[i12 + i1 >> 0] | 0) == 0 ? f2 : f10;
    i1 = i1 + 2 | 0;
   } while (i1 >>> 0 < i15 >>> 0);
   f10 = f3;
  } else {
   f10 = f3;
   i4 = 0;
   f2 = Math_fround(0.0);
  }
 }
 i1 = f2 > Math_fround(0.0);
 f9 = Math_fround(Math_fround(1.0) / f2);
 f9 = i1 ? f9 : Math_fround(0.0);
 f2 = Math_fround(f5 + f6);
 if (f2 > Math_fround(.00100000005)) {
  f3 = Math_fround(Math_fround(Math_fround(f5 - f6) * Math_fround(.5)) / f2);
  f2 = Math_fround(f3 + Math_fround(.5));
  f3 = Math_fround(Math_fround(.5) - f3);
  i1 = f7 <= Math_fround(-0.0);
  f6 = i1 ? Math_fround(0.0) : Math_fround(1.0);
  i1 = f7 >= Math_fround(0.0);
  f7 = i1 ? f6 : Math_fround(-1.0);
  i1 = f8 <= Math_fround(-0.0);
  f6 = i1 ? Math_fround(0.0) : Math_fround(1.0);
  i1 = f8 >= Math_fround(0.0);
  f8 = i1 ? f6 : Math_fround(-1.0);
 } else {
  f3 = Math_fround(.5);
  f2 = Math_fround(.5);
  f7 = Math_fround(1.0);
  f8 = Math_fround(1.0);
 }
 f5 = Math_fround(f10 * f2);
 f6 = Math_fround(f9 * f3);
 f2 = Math_fround(f10 * Math_fround(.5));
 f3 = Math_fround(f9 * Math_fround(.5));
 if (!i11) {
  i1 = 0;
  do {
   if (HEAP8[i12 + i1 >> 0] | 0) {
    HEAPF32[i13 + (i1 << 2) >> 2] = f2;
    HEAPF32[i14 + (i1 << 2) >> 2] = f5;
    HEAPF32[i16 + (i1 << 2) >> 2] = f7;
   }
   i1 = i1 + 2 | 0;
  } while (i1 >>> 0 < i15 >>> 0);
 }
 if (i4) i1 = 1; else return;
 do {
  if (HEAP8[i12 + i1 >> 0] | 0) {
   HEAPF32[i13 + (i1 << 2) >> 2] = f3;
   HEAPF32[i14 + (i1 << 2) >> 2] = f6;
   HEAPF32[i16 + (i1 << 2) >> 2] = f8;
  }
  i1 = i1 + 2 | 0;
 } while (i1 >>> 0 < i15 >>> 0);
 return;
}

function __ZN16PlayerConnection26InitializeMulticastAddressEt(i8, i12) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i10 = i13;
 i2 = i8 + 4 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i3 = i1 & 255;
 if (i3 >>> 0 < 7) i9 = 15; else {
  i6 = i2 + i3 | 0;
  i1 = i6;
  i7 = i2;
  L7 : do if ((i3 | 0) >= 7) {
   i5 = i6 + -6 | 0;
   if ((i5 | 0) != (i2 | 0)) {
    L9 : while (1) {
     while (1) {
      if ((HEAP8[i2 >> 0] | 0) == 49) {
       i3 = gb + 460058 | 0;
       i4 = i2;
       break;
      }
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i5 | 0)) break L7;
     }
     do {
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == (gb + 460058 + 7 | 0)) break L9;
      i4 = i4 + 1 | 0;
     } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break L7;
    }
    i1 = i2;
   }
  } while (0);
  if ((i1 | 0) == (i6 | 0)) i9 = 15; else {
   i2 = i8 + 16 | 0;
   if ((i1 | 0) == (i7 | 0)) {
    if (!(__ZN15MulticastSocket10InitializeEPKctb(i2, gb + 460066 | 0, i12, 0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 460082 | 0, 0, gb + 459789 | 0, 190, 1, 0, 0, 0);
    if (!(__ZN15MulticastSocket12SetBroadcastEb(i2, 1) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 460138 | 0, 0, gb + 459789 | 0, 192, 1, 0, 0, 0);
    i1 = i8 + 180 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = gb + 460066;
    HEAP32[i10 + 8 >> 2] = i12 & 65535;
    _printf_console(gb + 460197 | 0, i10);
    STACKTOP = i13;
    return;
   }
  }
 }
 if ((i9 | 0) == 15) i2 = i8 + 16 | 0;
 if (!(__ZN15MulticastSocket10InitializeEPKctb(i2, gb + 460230 | 0, i12, 0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 460082 | 0, 0, gb + 459789 | 0, 199, 1, 0, 0, 0);
 i1 = i8 + 180 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = gb + 460230;
 HEAP32[i11 + 8 >> 2] = i12 & 65535;
 _printf_console(gb + 460242 | 0, i11);
 __ZN15MulticastSocket6SetTTLEh(i2, 31) | 0;
 __ZN15MulticastSocket7SetLoopEb(i2, 1) | 0;
 STACKTOP = i13;
 return;
}

function __ZN9Transform25CompleteTransformTransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 16 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) {
  STACKTOP = i5;
  return;
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863909 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 80 | 0, 65);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 842702 | 0, i4, 0);
 i9 = i3 + 8 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i3, 1);
 i6 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i9, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421284 | 0, gb + 842702 | 0, i1 + 100 | 0, 1);
 i1 = i3 + 8 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i3, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i7, i1, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd18BufferedSocketImpl5writeEPKhj(i11, i6, i2) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 24 | 0;
 i9 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 i7 = i12;
 i5 = i11 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = 32768 - i1 | 0;
 L1 : do if (i4 >>> 0 < i2 >>> 0) {
  i3 = i2;
  i2 = 0;
  while (1) {
   _memcpy(i11 + 20 + i1 | 0, i6 + i2 | 0, i4 | 0) | 0;
   HEAP32[i5 >> 2] = 32768;
   if (!(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0)) {
    i5 = i2;
    break;
   }
   i2 = i4 + i2 | 0;
   i3 = i3 - i4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = 32768 - i1 | 0;
   if (i3 >>> 0 <= i4 >>> 0) break L1;
  }
  i4 = i11 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i11 + 14 | 0;
  if ((i1 | 0) != -1) {
   if (HEAP8[i3 >> 0] | 0) {
    i2 = i11 + 15 | 0;
    if ((HEAP8[i2 >> 0] | 0) != 1) {
     HEAP32[i7 >> 2] = 0;
     i9 = (_fcntl(i1, 3, i7) | 0) & -2049;
     i10 = HEAP32[i4 >> 2] | 0;
     HEAP32[i8 >> 2] = i9;
     if ((_fcntl(i10, 4, i8) | 0) != -1) HEAP8[i2 >> 0] = 1;
    }
    _shutdown(HEAP32[i4 >> 2] | 0, 2) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   _close(i1) | 0;
   HEAP32[i4 >> 2] = -1;
  }
  HEAP8[i3 >> 0] = 0;
  HEAP16[i11 + 12 >> 1] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  i11 = i5;
  STACKTOP = i12;
  return i11 | 0;
 } else {
  i3 = i2;
  i2 = 0;
 } while (0);
 if (!i3) i5 = i2; else {
  _memcpy(i11 + 20 + i1 | 0, i6 + i2 | 0, i3 | 0) | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + i3 | 0;
  HEAP32[i5 >> 2] = i1;
  i5 = i2 + i3 | 0;
 }
 if ((i1 | 0) != 32768) {
  i11 = i5;
  STACKTOP = i12;
  return i11 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0) | 0) {
  i11 = i5;
  STACKTOP = i12;
  return i11 | 0;
 }
 i4 = i11 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i11 + 14 | 0;
 if ((i1 | 0) != -1) {
  if (HEAP8[i3 >> 0] | 0) {
   i2 = i11 + 15 | 0;
   if ((HEAP8[i2 >> 0] | 0) != 1) {
    HEAP32[i9 >> 2] = 0;
    i8 = (_fcntl(i1, 3, i9) | 0) & -2049;
    i9 = HEAP32[i4 >> 2] | 0;
    HEAP32[i10 >> 2] = i8;
    if ((_fcntl(i9, 4, i10) | 0) != -1) HEAP8[i2 >> 0] = 1;
   }
   _shutdown(HEAP32[i4 >> 2] | 0, 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  _close(i1) | 0;
  HEAP32[i4 >> 2] = -1;
 }
 HEAP8[i3 >> 0] = 0;
 HEAP16[i11 + 12 >> 1] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i11 = i5;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 372; else i1 = (HEAP32[i1 >> 2] | 0) + 372 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 434; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx12NpConstraintC2EPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i10, i5, i7, i1, i3, i2) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP16[i10 + 4 >> 1] = 9;
 HEAP16[i10 + 6 >> 1] = 1;
 HEAP32[i10 >> 2] = gb + 93148 + 8;
 HEAP32[i10 + 8 >> 2] = i5;
 HEAP32[i10 + 12 >> 2] = i7;
 i9 = i10 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 i4 = i10 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx2Sc14ConstraintCoreC2ERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i10 + 28 | 0, i1, i3, i2);
 i6 = i10 + 100 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP16[i6 + 24 >> 1] = 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -251658241 | 100663296;
 HEAP8[i10 + 128 >> 0] = 1;
 i4 = (i5 | 0) == 0;
 if (!i4) __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i5 + (HEAP32[gb + 1457020 + ((HEAPU16[i5 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10, gb + 688433 | 0);
 i6 = (i7 | 0) == 0;
 if (!i6) __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i7 + (HEAP32[gb + 1457020 + ((HEAPU16[i7 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, 0, i10, gb + 688494 | 0);
 if (i4) i2 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0) & 8)) i2 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0) | 0; else i2 = 0;
 if (i6) i3 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0) & 8)) i3 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0; else i3 = 0;
 i1 = (i2 | 0) != 0;
 if (!(i4 | i1)) {
  STACKTOP = i11;
  return;
 }
 i4 = i1 ? i2 : i3;
 if ((i4 | 0) == 0 | (i6 | (i3 | 0) != 0) ^ 1) {
  STACKTOP = i11;
  return;
 }
 i1 = i4 + 3540 | 0;
 HEAP32[i8 >> 2] = i10;
 i2 = i4 + 3544 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 3548 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i10;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i8) | 0;
 __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE(i4 + 16 | 0, i9);
 STACKTOP = i11;
 return;
}

function __ZN10FileSystem25MountDataFolderFileSystemERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i9, i3, i4) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i2 = i13;
 i11 = i13 + 1072 | 0;
 i12 = i13 + 12 | 0;
 i5 = i4 + 11 | 0;
 i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i10 = i12 + 1040 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 __ZN15FileSystemEntry3SetEPKc(i12, i1);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 do if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i12 | 0) | 0) {
  i8 = i9 + 8 | 0;
  if (HEAP32[i8 >> 2] | 0) {
   _printf_console(gb + 491691 | 0, i2);
   break;
  }
  i7 = __ZnwjRK10MemLabelIdiPKci(160, gb + 63552 | 0, 16, gb + 491603 | 0, 152) | 0;
  __ZN17ArchiveFileSystemC2EPKc(i7, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
  if (!(__ZN17ArchiveFileSystem12MountArchiveEPKcS1_(i7, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0) | 0)) {
   HEAP32[i6 >> 2] = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   _printf_console(gb + 491731 | 0, i6);
   if (i7 | 0) mftCall_vi(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63552 | 0);
   break;
  }
  i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63552 | 0, 16, gb + 491603 | 0, 163) | 0;
  HEAP32[i2 >> 2] = gb + 70844 + 8;
  i3 = i2 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i2 + 8 | 0;
  HEAP32[i4 >> 2] = 0;
  i6 = i2 + 12 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i9 + 4 >> 2];
  __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i11);
  i1 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i11 >> 2] = i7;
  if ((i1 | 0) == (i6 | 0)) __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i11); else {
   HEAP32[i1 >> 2] = i7;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  }
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i12 | 0);
 STACKTOP = i13;
 return;
}

function _UNITY_FT_Raccess_Guess(i2, i3, i4, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i2 + 188 | 0;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, 0, i4 | 0, i5 | 0, i6 | 0) | 0;
  i10 = i5 + 4 | 0;
  HEAP32[i10 >> 2] = 0;
  i8 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 0, i4 | 0, i10 | 0, i6 + 4 | 0) | 0;
  i8 = i5 + 8 | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = i7 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, 0, i4 | 0, i8 | 0, i6 + 8 | 0) | 0;
  i10 = i5 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i8 = i7 + 12 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, 0, i4 | 0, i10 | 0, i6 + 12 | 0) | 0;
  i8 = i5 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 100 >> 2] | 0, i2 | 0, 0, i4 | 0, i8 | 0, i6 + 16 | 0) | 0;
  i10 = i5 + 20 | 0;
  HEAP32[i10 >> 2] = 0;
  i8 = i7 + 20 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, 0, i4 | 0, i10 | 0, i6 + 20 | 0) | 0;
  i8 = i5 + 24 | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = i7 + 24 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, 0, i4 | 0, i8 | 0, i6 + 24 | 0) | 0;
  i10 = i5 + 28 | 0;
  HEAP32[i10 >> 2] = 0;
  i8 = i7 + 28 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, 0, i4 | 0, i10 | 0, i6 + 28 | 0) | 0;
  i8 = i5 + 32 | 0;
  HEAP32[i8 >> 2] = 0;
  i10 = i7 + 32 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 132 >> 2] | 0, i2 | 0, 0, i4 | 0, i8 | 0, i6 + 32 | 0) | 0;
  return;
 } else i1 = 0;
 do {
  i8 = i5 + (i1 << 2) | 0;
  HEAP32[i8 >> 2] = 0;
  i11 = _UNITY_FT_Stream_Seek(i3, 0) | 0;
  i10 = i7 + (i1 << 2) | 0;
  HEAP32[i10 >> 2] = i11;
  if (!i11) HEAP32[i10 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 68 + (i1 << 3) >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i8 | 0, i6 + (i1 << 2) | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 9);
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i3 = i13 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 36 | 0) + 1 | 0;
 if (i4 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i13);
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = ((HEAP32[i13 + 8 >> 2] | 0) - i2 | 0) / 36 | 0;
 i3 = i9 << 1;
 i3 = i9 >>> 0 < 59652323 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 119304647;
 i9 = (i1 - i2 | 0) / 36 | 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = i13 + 8;
 if (!i3) i10 = 0; else i10 = __Znwj(i3 * 36 | 0) | 0;
 HEAP32[i15 >> 2] = i10;
 i11 = i10 + (i9 * 36 | 0) | 0;
 i12 = i15 + 8 | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i15 + 4 >> 2] = i11;
 HEAP32[i15 + 12 >> 2] = i10 + (i3 * 36 | 0);
 i8 = i14;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i10 + (i9 * 36 | 0) + 8 | 0;
 i1 = i14 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i8 = i10 + (i9 * 36 | 0) + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + (i9 * 36 | 0) + 16 >> 2] = 0;
 i3 = i14 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i4 - i2 | 0;
 i7 = (i5 | 0) / 96 | 0;
 if (i5 | 0) {
  if (i7 >>> 0 > 44739242) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
  }
  i1 = __Znwj(i5) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i10 + (i9 * 36 | 0) + 16 >> 2] = i1 + (i7 * 96 | 0);
  if ((i2 | 0) != (i4 | 0)) do {
   __ZN19ComputeShaderKernelC2ERKS_(i1, i2);
   i2 = i2 + 96 | 0;
   i1 = (HEAP32[i8 >> 2] | 0) + 96 | 0;
   HEAP32[i8 >> 2] = i1;
  } while ((i2 | 0) != (i4 | 0));
 }
 __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_(i10 + (i9 * 36 | 0) + 20 | 0, i14 + 20 | 0);
 HEAP8[i10 + (i9 * 36 | 0) + 32 >> 0] = HEAP8[i14 + 32 >> 0] | 0;
 HEAP32[i12 >> 2] = i11 + 36;
 __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i13, i15);
 __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN5physx16PxsIslandManager7addBodyEPvRNS_20PxsIslandManagerHookIjLj4294967295EEEb(i11, i5, i4, i10) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 1 | 0;
 i9 = i12;
 i2 = i11 + 12 | 0;
 i3 = i11 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  i1 = HEAP32[i11 + 24 >> 2] | 0;
  if (!i1) {
   i7 = -1;
   i1 = i11 + 16 | 0;
   break;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 << 1 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   i6 = 5;
   break;
  }
 } else i6 = 5; while (0);
 if ((i6 | 0) == 5) {
  i6 = (HEAP32[i11 + 20 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = -1;
  i6 = i11 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2] = -1;
  HEAP8[i7 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i7 = i11 + 32 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  i7 = i1;
  i1 = i6;
 }
 HEAP32[i4 >> 2] = i7;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + (i7 * 12 | 0) + 4 >> 2] = -1;
 HEAP32[i2 + (i7 * 12 | 0) >> 2] = i5;
 HEAP8[i2 + (i7 * 12 | 0) + 8 >> 0] = i10 & 1 | 64;
 i2 = i11 + 308 | 0;
 i4 = i11 + 312 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i11 + 324 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = i1 << 1;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8, i1 << 4, gb + 681489 | 0, 1482) | 0;
  i5 = i1 + (i6 << 2) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  i8 = i11 + 316 | 0;
  _memcpy(i5 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i11 + 320 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i3 >> 2] = i6;
  i2 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + (i1 << 2) >> 2] = i7;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i8 = i10 & 1;
 i9 = i11 + 444 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (i8 ^ 1);
 i9 = i11 + 452 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i8;
 if (!i10) {
  i11 = i11 + 477 | 0;
  HEAP8[i11 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 i10 = (HEAP32[HEAP32[i11 + 264 >> 2] >> 2] | 0) + (i7 >>> 5 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << (i7 & 31);
 i11 = i11 + 477 | 0;
 HEAP8[i11 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __Z23sweepCapsule_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf(i1, i5, i9, i6, f3, i11, i7, f2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 f3 = Math_fround(f3);
 i11 = i11 | 0;
 i7 = i7 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 32 | 0;
 i14 = i12 + 16 | 0;
 i13 = i12 + 48 | 0;
 i8 = i12;
 f15 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + f2);
 HEAP32[i10 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAPF32[i10 + 12 >> 2] = f15;
 f15 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f2 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
 HEAPF32[i14 >> 2] = f15;
 HEAPF32[i14 + 4 >> 2] = f2;
 HEAPF32[i14 + 8 >> 2] = f4;
 i5 = i11 + 40 | 0;
 HEAP16[i13 >> 1] = HEAP16[i7 >> 1] | 0;
 if (!(__ZN5physx2Gu18sweepSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleERKNS_6PxVec3EfRfRS7_SB_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i10, i9, i14, f3, i5, i11 + 16 | 0, i11 + 28 | 0, i13) | 0)) {
  i14 = 0;
  STACKTOP = i12;
  return i14 | 0;
 }
 if (!(HEAP16[i7 >> 1] & 512)) {
  i1 = i11 + 12 | 0;
  if (Math_fround(HEAPF32[i5 >> 2]) != Math_fround(0.0)) {
   HEAP16[i1 >> 1] = 7;
   i14 = 1;
   STACKTOP = i12;
   return i14 | 0;
  } else {
   HEAP16[i1 >> 1] = 6;
   i14 = 1;
   STACKTOP = i12;
   return i14 | 0;
  }
 }
 HEAP16[i11 + 12 >> 1] = 7;
 if (!(Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0))) {
  i14 = 1;
  STACKTOP = i12;
  return i14 | 0;
 }
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 if (f2 == Math_fround(HEAPF32[i9 + 12 >> 2])) {
  f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  if (f3 == Math_fround(HEAPF32[i9 + 16 >> 2])) {
   f4 = Math_fround(HEAPF32[i9 + 8 >> 2]);
   if (f4 == Math_fround(HEAPF32[i9 + 20 >> 2])) {
    i14 = HEAP32[i9 + 24 >> 2] | 0;
    HEAPF32[i8 >> 2] = f2;
    HEAPF32[i8 + 4 >> 2] = f3;
    HEAPF32[i8 + 8 >> 2] = f4;
    HEAP32[i8 + 12 >> 2] = i14;
    i14 = __ZN5physx2Gu23computeSphere_SphereMTDERKNS0_6SphereES3_RNS_10PxSweepHitE(i10, i8, i11) | 0;
    STACKTOP = i12;
    return i14 | 0;
   }
  }
 }
 i14 = __ZN5physx2Gu24computeSphere_CapsuleMTDERKNS0_6SphereERKNS0_7CapsuleERNS_10PxSweepHitE(i10, i9, i11) | 0;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 86; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj86ENS_22PxRepXPropertyAccessorILj86ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 85; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj85ENS_22PxRepXPropertyAccessorILj85ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN14SubstanceInputD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i8 + 144 | 0, HEAP32[i8 + 148 >> 2] | 0);
 i6 = i8 + 128 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 132 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i5 = i9 + 4 | 0;
   i3 = i2;
   while (1) {
    i2 = i3 + -20 | 0;
    HEAP32[i7 >> 2] = i2;
    i4 = i3 + -16 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i3 + -4 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i5 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
     i2 = HEAP32[i7 >> 2] | 0;
    }
    if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
   }
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 104 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i8 + 108 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i9 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i7 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i9 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i8 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 60 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i1 = i8 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 44 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 i1 = i8 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i8 + 28 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 }
 if ((HEAP8[i8 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
 STACKTOP = i10;
 return;
}

function __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiS0_iii(i10, i3, i11, i12, i1, i8, i13, i14, i2) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i1 = HEAP32[i3 + 32 >> 2] | 0;
  i4 = i2 + (i1 << 3) | 0;
  i5 = i3;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i3, i6);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i5 = HEAP32[gb + 1157724 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[i5 + 32 >> 2] | 0;
 }
 i3 = i2 + (i1 << 3) | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 if ((HEAP32[i5 + 36 >> 2] | 0) != (HEAP32[i5 + 4 >> 2] | 0)) {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i5, i6);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i2 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i2 + (i3 << 3) | 0;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10 + 4620 | 0;
 if (!(__ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_(i1, i4, i2) | 0)) {
  STACKTOP = i9;
  return;
 }
 i8 = HEAP32[i4 + 24 >> 2] >> i12;
 i10 = HEAP32[i4 + 28 >> 2] >> i12;
 __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii(i1, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, HEAP32[i4 + 20 >> 2] | 0, i11, i12, 0, 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0, i13, i14, 0, 0, 0, 1, 1, (i8 | 0) < 1 ? 1 : i8, (i10 | 0) < 1 ? 1 : i10, 1);
 STACKTOP = i9;
 return;
}

function __ZN7mecanim10ValueArray8TransferI8BlobSizeEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 20 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i3 = i2 + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1 + 4 + (0 - i1 & 3);
 } else HEAP8[i4 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i3 = i2 + 16 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i2 & 3) | 0;
  i1 = (i1 & 65535) < 256 ? i2 : i2 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  HEAP8[i4 >> 0] = 0;
  i1 = i2 + 16 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i4 >> 0] = 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i4 >> 0] = 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i4 >> 0] = 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i4 >> 0] = 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i2 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  HEAP32[i3 >> 2] = (0 - i2 & 3) + i2;
  return;
 } else {
  HEAP8[i4 >> 0] = 0;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 83; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj83ENS_22PxRepXPropertyAccessorILj83ES4_jjEEEEvjRKT0_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN4Mesh19GetInstantiatedMeshEPS_R6Object(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = (i1 | 0) != 0;
 if (i4) if ((HEAP32[i1 + 248 >> 2] | 0) == (HEAP32[i6 + 4 >> 2] | 0)) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__Z14IsWorldPlayingv() | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 428047 | 0, 0, gb + 425656 | 0, 1337, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
 if (i1 | 0) if (HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 92 >> 2] | 0) {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 425656 | 0, 1352) | 0;
  i9 = gb + 63520 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i2 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
  __Z19pop_allocation_rootv();
  i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
  __Z14CopySerializedRK6ObjectRS_(i1, i4);
  __Z6AppendPKcS0_(i5, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0, gb + 428180 | 0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  HEAP32[i4 + 248 >> 2] = HEAP32[i6 + 4 >> 2];
  i6 = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!i4) {
  i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 425656 | 0, 1342) | 0;
  i4 = gb + 63520 | 0;
  i8 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = i2;
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i1, i5, 0);
  __Z19pop_allocation_rootv();
  i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 mftCall_vii(i9 | 0, i1 | 0, mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0);
 HEAP32[i1 + 248 >> 2] = HEAP32[i6 + 4 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZNK8Animator13HasRootMotionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i10 = __ZNK6Avatar13HasRootMotionEv(i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx5cloth8SwSolver8addClothEPNS0_5ClothE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 44 | 0;
 i4 = i12 + 40 | 0;
 i7 = i12;
 i8 = i11 + 32 | 0;
 i9 = i7 + 4 | 0;
 HEAP16[i9 >> 1] = -1;
 HEAP16[i7 + 6 >> 1] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 87404 + 8;
 i10 = i7 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i5 = i7 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 168492 + 8;
 i6 = i7 + 20 | 0;
 HEAP32[i6 >> 2] = i1 + 12;
 HEAP32[i7 + 24 >> 2] = i11 + 44;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAPF32[i7 + 36 >> 2] = Math_fround(0.0);
 i1 = i11 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i11 + 40 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i11 = HEAP32[i8 >> 2] | 0;
  i7 = i11 + (i2 * 40 | 0) | 0;
  i13 = i9;
  i15 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i9 = i11 + (i2 * 40 | 0) + 4 | 0;
  i14 = i9;
  HEAP16[i14 >> 1] = i15;
  HEAP16[i14 + 2 >> 1] = i15 >>> 16;
  i9 = i9 + 4 | 0;
  HEAP16[i9 >> 1] = i13;
  HEAP16[i9 + 2 >> 1] = i13 >>> 16;
  HEAP32[i7 >> 2] = gb + 87404 + 8;
  i9 = i11 + (i2 * 40 | 0) + 12 | 0;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + (i2 * 40 | 0) + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 >> 2] = gb + 168492 + 8;
  i11 = i11 + (i2 * 40 | 0) + 20 | 0;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  i11 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  HEAP32[i1 >> 2] = i11;
  i10 = i8;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i4 >> 2] = fb + 903;
  __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i10, i11, i4, i3, 32);
  STACKTOP = i12;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_5cloth8SwSolver22CpuClothSimulationTaskENS0_9AllocatorEE15growAndPushBackERKS4_(i8, i7) | 0;
  i14 = i8;
  i15 = HEAP32[i1 >> 2] | 0;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i4 >> 2] = fb + 903;
  __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i14, i15, i4, i3, 32);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx25PxFixedJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 HEAP32[i1 + 236 >> 2] = gb + 741652;
 HEAP32[i1 + 240 >> 2] = 451;
 HEAP32[i1 + 244 >> 2] = fb + 458;
 HEAP32[i1 + 248 >> 2] = fb + 393;
 HEAP32[i1 + 252 >> 2] = gb + 742267;
 HEAP32[i1 + 256 >> 2] = 452;
 HEAP32[i1 + 260 >> 2] = fb + 459;
 HEAP32[i1 + 264 >> 2] = fb + 394;
 HEAP32[i1 + 268 >> 2] = gb + 831985;
 HEAP32[i1 + 272 >> 2] = 453;
 HEAP32[i1 + 276 >> 2] = fb + 2174;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEclILj681ES3_KNS_30PxVehicleDriveTankControlModel4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 834971 | 0) {
  i2 = gb + 834971 | 0;
  i3 = gb + 166984 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN5Flare8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i6 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373571 | 0, gb + 944590 | 0, i5, 0);
 i9 = i7 + 8 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i9, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373586 | 0, i8, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373602 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 32 | 0, 0);
 HEAP8[i6 + 31 >> 0] = 1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 373622 | 0, i6, 0);
 __ZN5Flare12FlareElement8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373613 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN16BaseVideoTexture22UploadGfxTextureBufferEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 8 | 0;
 i8 = i13 + 4 | 0;
 i10 = i13;
 i12 = HEAP32[i1 + 48 >> 2] | 0;
 i6 = i1 + 84 | 0;
 i7 = i1 + 88 | 0;
 i11 = Math_imul(HEAP32[i6 >> 2] << 2, HEAP32[i7 >> 2] | 0) | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i8 >> 2] = i12;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 436 >> 2] | 0;
 HEAP32[i10 >> 2] = i12;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i9 = HEAP32[i1 + 60 >> 2] | 0; else i9 = 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 mftCall_viiiiiiiiiiii(i5 | 0, i4 | 0, i3 | 0, 2, i2 | 0, i11 | 0, i6 | 0, i7 | 0, i8 | 0, 1, 0, 0, i9 | 0);
 i6 = i1;
 i7 = HEAP32[gb + 1158372 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i12 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 6;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i12 >>> 0) {
     i2 = 11;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 10;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 6) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 11) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i13;
  return;
 }
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i12;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 STACKTOP = i13;
 return;
}

function __ZN11TimeManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8;
 i7 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(216, i1, 16, gb + 1048932 | 0, 0, gb + 441481 | 0, 48) | 0;
 i6 = i1;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i7, i3, i2);
 HEAP32[i7 >> 2] = gb + 62144 + 8;
 i1 = i7 + 32 | 0;
 i2 = i7 + 64 | 0;
 i3 = i7 + 96 | 0;
 HEAP32[i7 + 140 >> 2] = 0;
 HEAP8[i7 + 192 >> 0] = 0;
 HEAP8[i7 + 193 >> 0] = 0;
 i4 = i7 + 48 | 0;
 i5 = i1;
 i6 = i5 + 96 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i4 >> 2] = Math_fround(.0199999996);
 HEAPF64[i7 + 208 >> 3] = 0.0;
 i6 = __Z14IsWorldPlayingv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 f11 = i6 ? Math_fround(.0199999996) : Math_fround(0.0);
 f10 = i6 ? Math_fround(50.0) : Math_fround(0.0);
 HEAPF32[i7 + 80 >> 2] = f11;
 HEAPF32[i7 + 92 >> 2] = f10;
 HEAPF32[i7 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 88 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i7 + 60 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i4 >> 2]));
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP8[i7 + 128 >> 0] = 1;
 HEAP8[i7 + 129 >> 0] = 1;
 HEAP8[i7 + 130 >> 0] = 1;
 HEAP32[i7 + 132 >> 2] = 0;
 HEAP32[i7 + 136 >> 2] = 0;
 d9 = +__Z19GetTimeSinceStartupv();
 HEAPF64[i7 + 152 >> 3] = d9;
 HEAPF64[i7 + 160 >> 3] = d9;
 i6 = i7 + 168 | 0;
 HEAP32[i7 + 144 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK5Umbra4AABB17getPlaneEquationsEPNS_7Vector4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i4 + 12 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 >> 2] = Math_fround(-f8);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i7 = i2 + 16 | 0;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i6 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(-1.0);
 HEAP32[i5 >> 2] = i9;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i7 = i2 + 32 | 0;
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i9 = i4 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 HEAPF32[i5 >> 2] = Math_fround(-f8);
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i7 = i2 + 48 | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAPF32[i9 >> 2] = Math_fround(-1.0);
 HEAP32[i5 >> 2] = i6;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i7 = i2 + 64 | 0;
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i4 + 8 | 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i5 >> 2] = Math_fround(-f8);
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i2 = i2 + 80 | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAPF32[i6 >> 2] = Math_fround(-1.0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 116; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 HEAP8[i8 >> 0] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i8 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i9 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (!i1) i1 = 141; else {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i7 + 1;
  i1 = i7;
 }
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_(i9, i1, i8);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + (i7 << 3) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 + 8 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   i6 = i1;
   i13 = i6;
   i13 = HEAPU8[i13 >> 0] | HEAPU8[i13 + 1 >> 0] << 8 | HEAPU8[i13 + 2 >> 0] << 16 | HEAPU8[i13 + 3 >> 0] << 24;
   i6 = i6 + 4 | 0;
   i6 = HEAPU8[i6 >> 0] | HEAPU8[i6 + 1 >> 0] << 8 | HEAPU8[i6 + 2 >> 0] << 16 | HEAPU8[i6 + 3 >> 0] << 24;
   i7 = i2;
   i4 = i7;
   HEAP8[i4 >> 0] = i13;
   HEAP8[i4 + 1 >> 0] = i13 >> 8;
   HEAP8[i4 + 2 >> 0] = i13 >> 16;
   HEAP8[i4 + 3 >> 0] = i13 >> 24;
   i7 = i7 + 4 | 0;
   HEAP8[i7 >> 0] = i6;
   HEAP8[i7 + 1 >> 0] = i6 >> 8;
   HEAP8[i7 + 2 >> 0] = i6 >> 16;
   HEAP8[i7 + 3 >> 0] = i6 >> 24;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 8;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 8);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z21FormatScriptTypeError14MonoScriptTypeRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 40 | 0;
 i8 = i12 + 32 | 0;
 i11 = i12 + 24 | 0;
 i10 = i12 + 16 | 0;
 i7 = i12 + 8 | 0;
 i6 = i12;
 i4 = i12 + 56 | 0;
 i5 = i12 + 44 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
 i1 = i4 + 11 | 0;
 i13 = HEAP8[i1 >> 0] | 0;
 if (!((i13 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i13 & 255) | 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 585672 | 0, 7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 switch (i3 | 0) {
 case -3:
  {
   HEAP32[i6 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457581 | 0, i6);
   break;
  }
 case -2:
  {
   HEAP32[i7 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457618 | 0, i7);
   break;
  }
 case -4:
  {
   HEAP32[i10 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457694 | 0, i10);
   break;
  }
 case -5:
  {
   HEAP32[i11 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457764 | 0, i11);
   break;
  }
 case -6:
  {
   HEAP32[i8 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457836 | 0, i8);
   break;
  }
 case -1:
  {
   HEAP32[i9 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
   __Z6FormatPKcz(i2, gb + 457911 | 0, i9);
   break;
  }
 case -7:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 457956 | 0, 51);
   break;
  }
 default:
  {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i12;
 return;
}

function _ft_raster1_render(i11, i14, i1, i2) {
 i11 = i11 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 64 | 0;
 i3 = i16 + 48 | 0;
 i13 = i16;
 i15 = i14 + 72 | 0;
 if ((HEAP32[i15 >> 2] | 0) != (HEAP32[i11 + 16 >> 2] | 0)) {
  HEAP32[i12 >> 2] = 6;
  i15 = 6;
  STACKTOP = i16;
  return i15 | 0;
 }
 if ((i1 | 0) != 2) {
  i15 = 19;
  STACKTOP = i16;
  return i15 | 0;
 }
 i10 = i14 + 108 | 0;
 if (i2 | 0) _UNITY_FT_Outline_Translate(i10, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 _UNITY_FT_Outline_Get_CBox(i10, i3);
 i2 = HEAP32[i3 >> 2] | 0;
 i9 = i2 + 32 & -64;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i4 + 32 & -64;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = i1 + 32 & -64;
 i8 = (i7 + 32 & -64) - i9 >> 6;
 i6 = (i8 | 0) == 0;
 i2 = i2 & -64;
 i9 = i6 ? i2 : i9;
 i8 = i6 ? (i7 + 63 & -64) - i2 >> 6 : i8;
 i2 = i3 - i5 >> 6;
 if (!i2) {
  i5 = i4 & -64;
  i3 = i1 + 63 & -64;
  i2 = i3 - i5 >> 6;
 }
 if ((i2 | i8) >>> 0 > 65535) {
  HEAP32[i12 >> 2] = 6;
  i15 = 6;
  STACKTOP = i16;
  return i15 | 0;
 }
 i6 = i14 + 76 | 0;
 i4 = HEAP32[i11 + 8 >> 2] | 0;
 i7 = i14 + 156 | 0;
 i1 = i14 + 88 | 0;
 if (HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] & 1 | 0) {
  _UNITY_ft_mem_free(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i17 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & -2;
 }
 i17 = (i8 + 15 | 0) >>> 4 << 1;
 HEAP8[i14 + 94 >> 0] = 1;
 HEAP32[i14 + 80 >> 2] = i8;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i14 + 84 >> 2] = i17;
 HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i4, i2, 0, i17, 0, i12) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i17 = i1;
  STACKTOP = i16;
  return i17 | 0;
 }
 i1 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
 _UNITY_FT_Outline_Translate(i10, 0 - i9 | 0, 0 - i5 | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 4 >> 2] = i10;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i12 >> 2] = mftCall_iii(HEAP32[i11 + 56 >> 2] | 0, HEAP32[i11 + 52 >> 2] | 0, i13 | 0) | 0;
 _UNITY_FT_Outline_Translate(i10, i9, i5);
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  i17 = i1;
  STACKTOP = i16;
  return i17 | 0;
 }
 HEAP32[i15 >> 2] = 1651078259;
 HEAP32[i14 + 100 >> 2] = i9 >> 6;
 HEAP32[i14 + 104 >> 2] = i3 >> 6;
 i17 = 0;
 STACKTOP = i16;
 return i17 | 0;
}

function __ZNSt3__211__sift_downIR26RenderDeferredObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i9, i10, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i3 - i8 | 0;
 if ((i10 | 0) < 2) {
  STACKTOP = i7;
  return;
 }
 i5 = (i10 + -2 | 0) / 2 | 0;
 if ((i5 | 0) < (i1 >> 5 | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i1 >> 4;
 i1 = i4 + 1 | 0;
 i2 = i8 + (i1 << 5) | 0;
 i4 = i4 + 2 | 0;
 if ((i4 | 0) < (i10 | 0)) {
  i12 = i2 + 32 | 0;
  i11 = __ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i9, i2, i12) | 0;
  i2 = i11 ? i12 : i2;
  i1 = i11 ? i4 : i1;
 }
 if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i9, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 while (1) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  if ((i5 | 0) < (i1 | 0)) break;
  i1 = i1 << 1 | 1;
  i3 = i8 + (i1 << 5) | 0;
  i4 = i1 + 1 | 0;
  if ((i4 | 0) < (i10 | 0)) {
   i11 = i3 + 32 | 0;
   i12 = __ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i9, i3, i11) | 0;
   i3 = i12 ? i11 : i3;
   i1 = i12 ? i4 : i1;
  }
  if (__ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i9, i3, i6) | 0) break; else {
   i12 = i2;
   i2 = i3;
   i3 = i12;
  }
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj560ES3_NS_27PxVehicleClutchAccuracyMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 834918 | 0) {
  i2 = gb + 834918 | 0;
  i3 = gb + 166960 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = i5 + 104;
 i4 = i5 + 128 | 0;
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i5 + 132 >> 2] = i2;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i1, i2);
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 24, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
 }
 __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i6, i5 + 140 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i6, i5 + 80 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags(i6, i5 + 156 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i6, i5 + 172 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i6, i5 + 192 | 0, 0);
 i1 = i5 + 152 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP32[i9 >> 2] = i3;
  i9 = i7;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i10 = i1 + 68 | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i12;
  return;
 }
 i7 = i2 + 4 | 0;
 do {
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i5 = HEAP32[i6 + 92 >> 2] | 0;
  do if (i5 | 0) {
   HEAP32[i9 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i11 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 12;
    }
   }
   if ((i11 | 0) == 10) i11 = 12;
   if ((i11 | 0) == 12) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) break;
   }
   if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i1 + 52 >> 2] | 0)) {
    i1 = i6 + 76 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    i4 = i6 + 72 | 0;
    if (i2 | 0) {
     i13 = HEAP32[i4 >> 2] | 0;
     __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i2, i13, HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i6 + 32 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE(i1, i6 + 32 | 0);
     HEAP32[i4 >> 2] = 0;
    }
    __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer(__Z21GetManagerFromContexti(3) | 0, i6);
   }
  } while (0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i12;
 return;
}

function __Z17ExtractStacktraceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_Piii(i1, i13, i12, i2, i10, i8, i11, i3) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i4 = i9;
 i2 = i9 + 48 | 0;
 i3 = i9 + 44 | 0;
 i7 = i9 + 32 | 0;
 i5 = i9 + 20 | 0;
 if (i11 & 262144 | 0) {
  STACKTOP = i9;
  return;
 }
 if (!(_il2cpp_thread_current() | 0)) {
  STACKTOP = i9;
  return;
 }
 i14 = HEAP32[gb + 66596 >> 2] | 0;
 i1 = HEAP32[gb + 66600 >> 2] | 0;
 i1 = __ZN11MonoManager17GetScriptingClassEPKcS1_S1_(__Z14GetMonoManagerv() | 0, i14, i1, gb + 590730 | 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i2, i1, gb + 590748 | 0, 0, 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = _il2cpp_runtime_invoke(i1 | 0, 0, 0, i3 | 0) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __Z24scripting_cpp_string_forP12Il2CppString(i7, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i12, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i3 = i12 + 11 | 0;
  i14 = HEAP8[i3 >> 0] | 0;
  if ((i14 << 24 >> 24 < 0 ? HEAP32[i12 + 4 >> 2] | 0 : i14 & 255) | 0) {
   i1 = HEAP32[i8 >> 2] | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i10);
   if (!(i11 & 16384)) {
    i2 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
    HEAP32[i6 >> 2] = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12;
    HEAP32[i6 + 4 >> 2] = i2;
    HEAP32[i6 + 8 >> 2] = i1;
    __Z6FormatPKcz(i5, gb + 463792 | 0, i6);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i12, i5) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    i2 = i12;
    i1 = i12;
   } else {
    i2 = i12;
    i1 = i12;
   }
   __Z21PostprocessStacktracePKcRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i2, i13);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  }
 } else _printf_console(gb + 463738 | 0, i4);
 STACKTOP = i9;
 return;
}

function __GLOBAL__sub_I_runtime_misc2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162744 | 0, gb + 451138 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162756 | 0, gb + 451166 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162768 | 0, gb + 451186 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162780 | 0, gb + 451212 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162792 | 0, gb + 451240 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162804 | 0, gb + 451266 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162816 | 0, gb + 451288 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162828 | 0, gb + 451315 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162840 | 0, gb + 451334 | 0, 10, 0);
 HEAPF32[gb + 1162568 >> 2] = Math_fround(.13333334);
 HEAPF32[gb + 1162568 + 4 >> 2] = Math_fround(.172549024);
 HEAPF32[gb + 1162568 + 8 >> 2] = Math_fround(.211764708);
 HEAPF32[gb + 1162568 + 12 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1162584 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162584 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162584 + 12 >> 2] = 16;
 i1 = gb + 1162584 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3408 | 0, fb + 3409 | 0, 0, gb + 1162584 | 0);
 HEAP32[gb + 1162664 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162664 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162664 + 12 >> 2] = 16;
 i1 = gb + 1162664 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3410 | 0, fb + 3411 | 0, 0, gb + 1162664 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546594 | 0, fb + 3412 | 0, fb + 3413 | 0, 0, 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj66ES3_NS_28PxArticulationJointDriveType4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 673987 | 0) {
  i2 = gb + 673987 | 0;
  i3 = gb + 89968 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 112 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i2 + 11 | 0;
 HEAP8[i6 >> 0] = 7;
 HEAP8[i2 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
 HEAP8[i2 + 7 >> 0] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 1;
 HEAP32[i2 + 32 >> 2] = 1;
 HEAPF32[i2 + 36 >> 2] = Math_fround(15.0);
 HEAPF32[i2 + 40 >> 2] = Math_fround(3.0);
 HEAPF32[i2 + 44 >> 2] = Math_fround(.333333343);
 HEAPF32[i2 + 48 >> 2] = Math_fround(.0666666701);
 HEAPF32[i2 + 52 >> 2] = Math_fround(.200000003);
 HEAPF32[i2 + 56 >> 2] = Math_fround(.466666669);
 HEAP32[i2 + 60 >> 2] = 1;
 HEAP32[i2 + 64 >> 2] = 1;
 i7 = i2 + 68 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i2 + 84 >> 2] = Math_fround(.300000012);
 HEAP32[i2 + 88 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 4;
 HEAPF32[i2 + 96 >> 2] = Math_fround(512.0);
 HEAP32[i2 + 100 >> 2] = 2;
 HEAP32[i2 + 104 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 405527 | 0, i2, 0);
 __ZN15QualitySettings14QualitySetting8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 STACKTOP = i3;
 return;
}

function __Z9SetLocalS15TransformAccessRKN4math7_float3E(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0;
 i6 = i1;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i6 + 8 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i8 = i10 + (i1 * 40 | 0) + 28 | 0;
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i10 + (i1 * 40 | 0) + 32 | 0;
 f12 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i10 + (i1 * 40 | 0) + 36 | 0;
 i11 = f3 != f13 | f4 != f12 | f2 != Math_fround(HEAPF32[i10 >> 2]);
 HEAPF32[i8 >> 2] = f3;
 HEAPF32[i9 >> 2] = f4;
 HEAPF32[i10 >> 2] = f2;
 if (!i11) {
  i11 = 0;
  return i11 | 0;
 }
 i8 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
 i8 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i8;
 i8 = (HEAP32[tempDoublePtr >> 2] = i8 ^ (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
 i7 = ((Math_fround(Math_abs(Math_fround(f2 - f3))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f3 - f4))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f4 - f2))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i8) ^ 1;
 i7 = (i8 << 2 | 3) & ~(i7 << 1) & (i7 & ((Math_fround(Math_abs(Math_fround(f3 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f4 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f2 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
 HEAP32[(HEAP32[i6 + 64 >> 2] | 0) + (i1 << 2) >> 2] = i7;
 i7 = HEAP32[i6 + 44 >> 2] | HEAP32[i6 + 40 >> 2] | HEAP32[i6 + 48 >> 2];
 i8 = HEAP32[(HEAP32[i6 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i8) {
  i11 = 1;
  return i11 | 0;
 }
 i9 = HEAP32[i6 + 60 >> 2] | 0;
 i10 = HEAP32[i6 + 56 >> 2] | 0;
 i11 = i6 + 36 | 0;
 i6 = HEAP32[i6 + 68 >> 2] | 0;
 i5 = 0;
 while (1) {
  i14 = HEAP32[i9 + (i1 << 2) >> 2] & i7;
  i15 = i10 + (i1 << 2) | 0;
  HEAP32[i15 >> 2] = HEAP32[i15 >> 2] | i14;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | i14;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i8 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
 }
 return i1 | 0;
}

function __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb(i1, i3, i6, i17, i4, i5, i2, i14, i15, i16, i11, i9, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i7 = 0, i8 = 0, i12 = 0, i13 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i19 + 216 | 0;
 i13 = i19 + 144 | 0;
 i7 = i19 + 80 | 0;
 i8 = i19 + 16 | 0;
 i18 = i19;
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i1, i4, i12);
 __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i3, i5, i13);
 HEAP32[i7 + 32 >> 2] = i6;
 HEAP32[i7 + 36 >> 2] = i1 + 96;
 HEAP32[i7 + 40 >> 2] = i1 + 144;
 HEAP8[i7 + 44 >> 0] = i4 & 1;
 HEAP32[i7 >> 2] = i4 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i7 + 48 >> 2] = i1;
 HEAP32[i8 + 32 >> 2] = i17;
 HEAP32[i8 + 36 >> 2] = i3 + 96;
 HEAP32[i8 + 40 >> 2] = i3 + 144;
 HEAP8[i8 + 44 >> 0] = i5 & 1;
 HEAP32[i8 >> 2] = i5 ? gb + 84224 + 8 | 0 : gb + 84252 + 8 | 0;
 HEAP32[i8 + 48 >> 2] = i3;
 i3 = HEAP32[i14 >> 2] | 0;
 if (!(__ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb(i12, i13, i7, i8, i2, i14, i9, i11, i10) | 0)) {
  i18 = 0;
  STACKTOP = i19;
  return i18 | 0;
 }
 i1 = HEAP32[i14 >> 2] | 0;
 if (!((i1 | 0) != (i3 | 0) | i10)) {
  __ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb(i12, i13, i7, i8, i2, i14, i9, i11, 1) | 0;
  i1 = HEAP32[i14 >> 2] | 0;
 }
 if ((i3 | 0) != 0 & (i1 | 0) != (i3 | 0)) {
  i1 = i1 + -1 | 0;
  HEAP32[i14 >> 2] = i1;
  i2 = i2 + 48 | 0;
 }
 __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj(i16, i2, i1);
 __ZN5physx2Gu25PersistentContactManifold14getWorldNormalERKNS_6shdfnd3aos12PsTransformVE(i18, i16, i17);
 __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE(i16, i15, i18, i17);
 i18 = 1;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN18MecanimClipBuilderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 1064 | 0;
 i4 = i1 + 620 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i8 = i2;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i4 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 32 >> 2] = 0;
  HEAP32[i4 + 36 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i4 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 + 40 >> 2] = 0;
  HEAP32[i4 + 52 >> 2] = 0;
  HEAP32[i4 + 56 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i8 = i2;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i4 + 44 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i4 + 60 >> 2] = 0;
  HEAP32[i4 + 72 >> 2] = 0;
  HEAP32[i4 + 76 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i4 + 64 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 + 80 >> 2] = 0;
  HEAP32[i4 + 92 >> 2] = 0;
  HEAP32[i4 + 96 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i8 = i2;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i4 + 84 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i4 + 100 >> 2] = 0;
  HEAP32[i4 + 112 >> 2] = 0;
  HEAP32[i4 + 116 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i4 + 104 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 + 128 >> 2] = 0;
  HEAP32[i4 + 140 >> 2] = 0;
  HEAP32[i4 + 144 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i8 = i2;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i4 + 132 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  i4 = i4 + 148 | 0;
 } while ((i4 | 0) != (i3 | 0));
 HEAP8[i1 + 1072 >> 0] = 0;
 HEAPF32[i1 + 1076 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 1080 >> 2] = Math_fround(-inf);
 HEAPF32[i1 + 1084 >> 2] = Math_fround(30.0);
 _memset(i1 | 0, -1, 620) | 0;
 STACKTOP = i5;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i4 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = (i1 - i5 >> 4) + i2 | 0;
 if (i6 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = i4 - i5 | 0;
 i3 = i7 >> 3;
 i3 = i7 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 268435455;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i8 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 << 4) | 0;
 HEAP32[i10 >> 2] = i4;
 i1 = i4 + (i1 - i5 >> 4 << 4) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i4 + (i3 << 4);
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i1 + 16 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i8, i10);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i6 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZNK8Animator13IsOptimizableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i10 = __ZNK6Avatar7IsValidEv(i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx24NpPtrTableStorageManager8allocateEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = i3 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 if (i2 >>> 0 < 17) {
  i2 = i3 + 300 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 8 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i3 + 288 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i3 = i3 + 292 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
  }
  i3 = i1;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 if (i2 >>> 0 < 65) {
  i2 = i3 + 596 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 304 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i3 + 584 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i3 = i3 + 588 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else {
   i2 = i1;
   i3 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
  }
  i3 = i1;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 if (i2 >>> 0 >= 257) {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i2 << 2, gb + 768065 | 0, 43) | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 i2 = i3 + 892 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 600 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i3 + 880 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i3 = i3 + 884 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!i1) i1 = 0; else _memset(i1 | 0, 0, 256) | 0;
 i3 = i1;
 i4 = HEAP32[i4 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN4crnd25static_huffman_data_model4initEjPKhj(i10, i5, i6, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i7 = i12 + 16 | 0;
 i8 = i12 + 12 | 0;
 i4 = i1 >>> 0 < 16 ? i1 : 16;
 i11 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  if (i1 >>> 0 <= i5 >>> 0) {
   do if ((HEAP32[i10 + 12 >> 2] | 0) >>> 0 < i5 >>> 0) {
    if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i11, i5, (i1 + 1 | 0) == (i5 | 0), 1, 0) | 0) {
     i1 = HEAP32[i2 >> 2] | 0;
     break;
    }
    HEAP8[i10 + 16 >> 0] = 1;
    i11 = 0;
    STACKTOP = i12;
    return i11 | 0;
   } while (0);
   _memset((HEAP32[i11 >> 2] | 0) + i1 | 0, 0, i5 - i1 | 0) | 0;
  }
  HEAP32[i2 >> 2] = i5;
 }
 if (!i5) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = 0;
 i2 = 0;
 i3 = -1;
 do {
  i14 = HEAP8[i6 + i1 >> 0] | 0;
  i13 = i14 & 255;
  HEAP8[(HEAP32[i11 >> 2] | 0) + i1 >> 0] = i14;
  i3 = i3 >>> 0 < i13 >>> 0 ? i3 : i13;
  i2 = i2 >>> 0 > i13 >>> 0 ? i2 : i13;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 if (i2 >>> 0 > i4 >>> 0 | (i3 >>> 0 > i4 >>> 0 | (i2 + -1 | 0) >>> 0 > 31)) {
  i14 = 0;
  STACKTOP = i12;
  return i14 | 0;
 }
 i2 = i10 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = 180;
  i1 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, 0, 180, i8 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  if ((i1 | 0) == 0 | (HEAP32[i8 >> 2] | 0) >>> 0 < 180) {
   HEAP32[i9 >> 2] = gb + 401209;
   HEAP32[i9 + 4 >> 2] = 2513;
   HEAP32[i9 + 8 >> 2] = gb + 401368;
   _sprintf(i7, gb + 401176 | 0, i9) | 0;
   _puts(i7) | 0;
   i1 = 0;
  } else {
   i14 = i1 + 164 | 0;
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   HEAP32[i14 + 12 >> 2] = 0;
  }
  HEAP32[i2 >> 2] = i1;
  i6 = i1;
 } else i6 = i1;
 i5 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i5 >>> 0 > 16) {
  i1 = i5;
  i2 = 0;
  while (1) {
   i3 = i2 + 1 | 0;
   if (i1 >>> 0 > 3) {
    i1 = i1 >>> 1;
    i2 = i3;
   } else break;
  }
  i1 = i2 + 2 + ((i3 | 0) != 32 & 1 << i3 >>> 0 < i5 >>> 0 & 1) | 0;
  i1 = (i1 >>> 0 < 11 ? i1 : 11) & 255;
 } else i1 = 0;
 i14 = __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj(i6, i5, i4, i1) | 0;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE12__find_equalIS1_EERPNS_16__tree_node_baseIPvEESD_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i8 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = HEAP32[i2 + 12 >> 2] | 0;
 i7 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255;
 i6 = i6 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 L5 : while (1) {
  i5 = i1 + 16 | 0;
  i2 = HEAP32[i1 + 32 >> 2] | 0;
  L7 : do if ((i8 | 0) == (i2 | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   do if ((i9 | 0) == (i2 | 0)) {
    i4 = HEAP8[i5 + 11 >> 0] | 0;
    i3 = i4 << 24 >> 24 < 0;
    i4 = i3 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255;
    i2 = i4 >>> 0 < i7 >>> 0 ? i4 : i7;
    if (i2 | 0) {
     i2 = _memcmp(i6, i3 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
     if (i2 | 0) if ((i2 | 0) < 0) {
      i2 = 11;
      break L7;
     } else break;
    }
    if (i7 >>> 0 < i4 >>> 0) {
     i2 = 11;
     break L7;
    }
   } else if ((i9 | 0) < (i2 | 0)) {
    i2 = 11;
    break L7;
   } while (0);
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i2 | 0) != (i9 | 0)) if ((i2 | 0) < (i9 | 0)) {
    i2 = 20;
    break;
   } else {
    i2 = 23;
    break L5;
   }
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255;
   i2 = i7 >>> 0 < i4 >>> 0 ? i7 : i4;
   if (i2 | 0) {
    i2 = _memcmp(i3 ? HEAP32[i5 >> 2] | 0 : i5, i6, i2) | 0;
    if (i2 | 0) if ((i2 | 0) < 0) {
     i2 = 20;
     break;
    } else {
     i2 = 23;
     break L5;
    }
   }
   if (i4 >>> 0 < i7 >>> 0) i2 = 20; else {
    i2 = 23;
    break L5;
   }
  } else if ((i8 | 0) < (i2 | 0)) i2 = 11; else if ((i2 | 0) < (i8 | 0)) i2 = 20; else {
   i2 = 23;
   break L5;
  } while (0);
  if ((i2 | 0) == 11) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = 12;
    break;
   } else i1 = i2;
  } else if ((i2 | 0) == 20) {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 22;
    break;
   } else i1 = i2;
  }
 }
 if ((i2 | 0) == 12) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i2 | 0) == 22) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i2 | 0) == 23) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__211__sift_downIR25RenderPrePassObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_(i8, i1, i9, i10, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i3 - i8 | 0;
 if ((i10 | 0) < 2) {
  STACKTOP = i7;
  return;
 }
 i5 = (i10 + -2 | 0) / 2 | 0;
 if ((i5 | 0) < (i1 >> 5 | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i1 >> 4;
 i1 = i4 + 1 | 0;
 i2 = i8 + (i1 << 5) | 0;
 i4 = i4 + 2 | 0;
 if ((i4 | 0) < (i10 | 0)) {
  i12 = i2 + 32 | 0;
  i11 = __ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i9, i2, i12) | 0;
  i2 = i11 ? i12 : i2;
  i1 = i11 ? i4 : i1;
 }
 if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i9, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 while (1) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  if ((i5 | 0) < (i1 | 0)) break;
  i1 = i1 << 1 | 1;
  i3 = i8 + (i1 << 5) | 0;
  i4 = i1 + 1 | 0;
  if ((i4 | 0) < (i10 | 0)) {
   i11 = i3 + 32 | 0;
   i12 = __ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i9, i3, i11) | 0;
   i3 = i12 ? i11 : i3;
   i1 = i12 ? i4 : i1;
  }
  if (__ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i9, i3, i6) | 0) break; else {
   i12 = i2;
   i2 = i3;
   i3 = i12;
  }
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 STACKTOP = i7;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __Z11FitTangentsI8Vector3fEvR11KeyframeTplIT_ES4_ffRKS2_S6_(i4, i5, f1, f2, i17, i18) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i17 = i17 | 0;
 i18 = i18 | 0;
 var f3 = f0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, d24 = 0.0, d25 = 0.0, d26 = 0.0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 12 | 0;
 i20 = i21;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i4 >> 2]));
 if (Math_fround(Math_abs(Math_fround(f3))) < Math_fround(1.1920929e-07)) {
  i19 = i4 + 28 | 0;
  i20 = i5 + 16 | 0;
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i20 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i20 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i21;
  return;
 }
 i23 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = i23;
 HEAP32[i19 + 4 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i4 + 12 >> 2];
 i22 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i20 >> 2] = i22;
 HEAP32[i20 + 4 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i20 + 8 >> 2] = HEAP32[i5 + 12 >> 2];
 d14 = +f1;
 d15 = d14 * d14;
 d12 = d14 * d15;
 d16 = d12 * 2.0;
 d24 = d15 * 3.0;
 d13 = d16 - d24 + 1.0;
 d14 = d14 + (d12 - d15 * 2.0);
 d15 = d12 - d15;
 d16 = d24 - d16;
 d24 = +f2;
 d12 = d24 * d24;
 d8 = d24 * d12;
 d11 = d8 * 2.0;
 d25 = d12 * 3.0;
 d9 = d11 - d25 + 1.0;
 d10 = d8 - d12;
 d11 = d25 - d11;
 d12 = d14 / d15 - (d24 + (d8 - d12 * 2.0)) / d10;
 d8 = +f3;
 i7 = i4 + 28 | 0;
 i6 = i5 + 16 | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i5 = 0;
 f1 = (HEAP32[tempDoublePtr >> 2] = i22, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 while (1) {
  d24 = +Math_fround(HEAPF32[i17 + (i5 << 2) >> 2]);
  d26 = +f2;
  d25 = +f1;
  d24 = d24 - d13 * d26 - d16 * d25;
  d25 = (d24 / d15 - (+Math_fround(HEAPF32[i18 + (i5 << 2) >> 2]) - d9 * d26 - d11 * d25) / d10) / d12;
  HEAPF32[i7 + (i5 << 2) >> 2] = Math_fround(d25 / d8);
  HEAPF32[i6 + (i5 << 2) >> 2] = Math_fround((d24 - d14 * d25) / d15 / d8);
  i4 = i5 + 1 | 0;
  if ((i4 | 0) == 3) break;
  f2 = Math_fround(HEAPF32[i19 + (i4 << 2) >> 2]);
  i5 = i4;
  f1 = Math_fround(HEAPF32[i20 + (i4 << 2) >> 2]);
 }
 STACKTOP = i21;
 return;
}

function __ZN9BlobWrite8TransferIN4math8ColliderEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN4math8Collider8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i5, i6, gb + 906345 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i5, i6 + 40 | 0, gb + 913271 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i5, i6 + 44 | 0, gb + 906349 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i5, i6 + 48 | 0, gb + 906363 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i5, i6 + 52 | 0, gb + 906377 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 56 | 0, gb + 906391 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 60 | 0, gb + 906403 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 64 | 0, gb + 906415 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 68 | 0, gb + 906427 | 0, 0);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function _cf2_blues_capture(i11, i12, i13) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = HEAP32[i11 + 20 >> 2] | 0;
 i6 = i11 + 4 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i7 = i13 + 8 | 0;
 i8 = i12 + 8 | 0;
 i10 = 0;
 while (1) {
  i1 = i11 + 68 + (i10 * 20 | 0) | 0;
  i2 = i11 + 68 + (i10 * 20 | 0) + 16 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i9 = 13; else {
   if ((_cf2_hint_isBottom(i12) | 0) << 24 >> 24) {
    i3 = HEAP32[i8 >> 2] | 0;
    if (((HEAP32[i1 >> 2] | 0) - i5 | 0) <= (i3 | 0)) {
     i4 = HEAP32[i11 + 68 + (i10 * 20 | 0) + 4 >> 2] | 0;
     if ((i3 | 0) <= (i4 + i5 | 0)) {
      i9 = 7;
      break;
     }
    }
   }
   if (!(HEAP8[i2 >> 0] | 0)) i9 = 13;
  }
  if ((i9 | 0) == 13) {
   i9 = 0;
   if ((_cf2_hint_isTop(i13) | 0) << 24 >> 24) {
    i3 = HEAP32[i1 >> 2] | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    if ((i3 - i5 | 0) <= (i4 | 0)) if ((i4 | 0) <= ((HEAP32[i11 + 68 + (i10 * 20 | 0) + 4 >> 2] | 0) + i5 | 0)) {
     i9 = 16;
     break;
    }
   }
  }
  i1 = i10 + 1 | 0;
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) i10 = i1; else {
   i1 = 0;
   i9 = 26;
   break;
  }
 }
 if ((i9 | 0) == 7) {
  if (!(HEAP8[i11 + 8 >> 0] | 0)) {
   i1 = HEAP32[i12 + 12 >> 2] | 0;
   i2 = i1 + 32768 & -65536;
   if ((i4 - i3 | 0) >= (HEAP32[i11 + 16 >> 2] | 0)) {
    i11 = (HEAP32[i11 + 68 + (i10 * 20 | 0) + 12 >> 2] | 0) + -65536 | 0;
    i2 = (i2 | 0) < (i11 | 0) ? i2 : i11;
   }
  } else {
   i2 = HEAP32[i11 + 68 + (i10 * 20 | 0) + 12 >> 2] | 0;
   i1 = HEAP32[i12 + 12 >> 2] | 0;
  }
  i1 = i2 - i1 | 0;
 } else if ((i9 | 0) == 16) {
  if (!(HEAP8[i11 + 8 >> 0] | 0)) {
   i1 = HEAP32[i13 + 12 >> 2] | 0;
   i2 = i1 + 32768 & -65536;
   if ((i4 - i3 | 0) >= (HEAP32[i11 + 16 >> 2] | 0)) {
    i11 = (HEAP32[i11 + 68 + (i10 * 20 | 0) + 12 >> 2] | 0) + 65536 | 0;
    i2 = (i2 | 0) > (i11 | 0) ? i2 : i11;
   }
  } else {
   i2 = HEAP32[i11 + 68 + (i10 * 20 | 0) + 12 >> 2] | 0;
   i1 = HEAP32[i13 + 12 >> 2] | 0;
  }
  i1 = i2 - i1 | 0;
 } else if ((i9 | 0) == 26) return i1 | 0;
 if ((_cf2_hint_isValid(i12) | 0) << 24 >> 24) {
  i11 = i12 + 12 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
  _cf2_hint_lock(i12);
 }
 if (!((_cf2_hint_isValid(i13) | 0) << 24 >> 24)) {
  i13 = 1;
  return i13 | 0;
 }
 i12 = i13 + 12 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i1;
 _cf2_hint_lock(i13);
 i13 = 1;
 return i13 | 0;
}

function __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1084155 | 0, 0);
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i10, i11 + 1 | 0, gb + 1086064 | 0, 0);
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i10, i11 + 2 | 0, gb + 1085890 | 0, 0);
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i10, i11 + 3 | 0, gb + 1085926 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1033960 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1033967 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 8 | 0, gb + 1033975 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1033981 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i10, i2, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = i9 + 40 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i10 >> 2] | 0)) {
   i9 = i2;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i10 + 4 | 0;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
  }
  HEAP32[i10 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i5 = i2;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 3) | 0, 0, i6 - i5 << 3 | 0) | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i1 + (i8 * 24 | 0) | 0;
 if (i8 | 0) {
  i6 = HEAP32[gb + 37296 >> 2] | 0;
  i7 = i9 + 20 | 0;
  i8 = i9 + 56 | 0;
  i4 = i9 + 44 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i7 >> 2] = i6;
   if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) + -1 << 3) + 4 >> 2] & 16777216)) {
    i2 = i1;
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = i3;
    HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
   } else {
    if (!(HEAP32[i1 + 16 >> 2] & 4194304)) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    __Z16HexStringToBytesPKcjPv(i2, 8, i3);
   }
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i3 = i3 + 8 | 0;
  }
 }
 HEAP32[i11 >> 2] = i12;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i10, i2, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = i9 + 40 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i10 >> 2] | 0)) {
   i9 = i2;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i12 = i10 + 4 | 0;
   HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
  }
  HEAP32[i10 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i6 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i5 = i2;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i10 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 3) | 0, 0, i6 - i5 << 3 | 0) | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i1 + (i8 * 24 | 0) | 0;
 if (i8 | 0) {
  i6 = HEAP32[gb + 37248 >> 2] | 0;
  i7 = i9 + 20 | 0;
  i8 = i9 + 56 | 0;
  i4 = i9 + 44 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i7 >> 2] = i6;
   if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) + -1 << 3) + 4 >> 2] & 16777216)) {
    i2 = i1;
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i10 = i3;
    HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 + 4 >> 2] = i9;
   } else {
    if (!(HEAP32[i1 + 16 >> 2] & 4194304)) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    __Z16HexStringToBytesPKcjPv(i2, 8, i3);
   }
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i3 = i3 + 8 | 0;
  }
 }
 HEAP32[i11 >> 2] = i12;
 return;
}

function __ZNSt3__218__insertion_sort_3IR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(i16, i17, i1) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i18 = 0;
 i2 = i16 + 8 | 0;
 __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_(i16, i16 + 4 | 0, i2, i1) | 0;
 i1 = i16 + 12 | 0;
 if ((i1 | 0) == (i17 | 0)) return;
 while (1) {
  i11 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i11 + 32 >> 2] | 0;
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  i15 = i11;
  i10 = i5;
  do if ((i3 | 0) == (i4 | 0)) {
   i6 = i11 + 112 | 0;
   i7 = i5 + 112 | 0;
   i9 = HEAP8[i7 + 11 >> 0] | 0;
   i8 = i9 << 24 >> 24 < 0;
   i5 = i8 ? HEAP32[i5 + 116 >> 2] | 0 : i9 & 255;
   i9 = HEAP8[i6 + 11 >> 0] | 0;
   i4 = i9 << 24 >> 24 < 0;
   i9 = i4 ? HEAP32[i11 + 116 >> 2] | 0 : i9 & 255;
   i3 = i9 >>> 0 < i5 >>> 0 ? i9 : i5;
   if (i3 | 0) {
    i3 = _memcmp(i8 ? HEAP32[i7 >> 2] | 0 : i7, i4 ? HEAP32[i6 >> 2] | 0 : i6, i3) | 0;
    if (i3 | 0) if ((i3 | 0) < 0) {
     i18 = 9;
     break;
    } else break;
   }
   if (i5 >>> 0 < i9 >>> 0) i18 = 9;
  } else if ((i3 | 0) > (i4 | 0)) i18 = 9; while (0);
  if ((i18 | 0) == 9) {
   i18 = 0;
   HEAP32[i1 >> 2] = i10;
   L14 : do if ((i2 | 0) != (i16 | 0)) {
    i12 = i11 + 112 | 0;
    i13 = i12 + 11 | 0;
    i14 = i11 + 116 | 0;
    i11 = HEAP32[i11 + 32 >> 2] | 0;
    while (1) {
     i9 = i2 + -4 | 0;
     i4 = HEAP32[i9 >> 2] | 0;
     i3 = HEAP32[i4 + 32 >> 2] | 0;
     i10 = i4;
     do if ((i11 | 0) == (i3 | 0)) {
      i5 = i4 + 112 | 0;
      i7 = HEAP8[i5 + 11 >> 0] | 0;
      i6 = i7 << 24 >> 24 < 0;
      i7 = i6 ? HEAP32[i4 + 116 >> 2] | 0 : i7 & 255;
      i8 = HEAP8[i13 >> 0] | 0;
      i4 = i8 << 24 >> 24 < 0;
      i8 = i4 ? HEAP32[i14 >> 2] | 0 : i8 & 255;
      i3 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
      if (i3 | 0) {
       i3 = _memcmp(i6 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i12 >> 2] | 0 : i12, i3) | 0;
       if (i3 | 0) if ((i3 | 0) < 0) break; else break L14;
      }
      if (i7 >>> 0 >= i8 >>> 0) break L14;
     } else if ((i11 | 0) <= (i3 | 0)) break L14; while (0);
     HEAP32[i2 >> 2] = i10;
     if ((i9 | 0) == (i16 | 0)) {
      i2 = i9;
      break;
     } else i2 = i9;
    }
   } while (0);
   HEAP32[i2 >> 2] = i15;
  }
  i2 = i1 + 4 | 0;
  if ((i2 | 0) == (i17 | 0)) break; else {
   i15 = i1;
   i1 = i2;
   i2 = i15;
  }
 }
 return;
}

function __Z28delete_object_internal_step1P6Object(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 __Z26profiler_unregister_objectP6Object(i9);
 i5 = i9 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[gb + 1104268 >> 2] | 0;
  i1 = i2;
  do {
   i6 = i1 + 12 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } while ((i1 | 0) != 0);
  do {
   i3 = i2 + 12 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 1) mftCall_viii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i9 | 0, 2);
   i1 = i2;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   if (!(HEAP32[i3 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i4, i1);
  } while ((i2 | 0) != 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[gb + 1104268 >> 2] | 0;
   do {
    i2 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i6 = i2 + 12 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    if (!(HEAP32[i6 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i3, i2);
   } while ((i1 | 0) != 0);
  }
  HEAP32[i5 >> 2] = 0;
 }
 i4 = HEAP32[gb + 1104264 >> 2] | 0;
 i6 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i5 = i4 + 4 | 0;
 if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i4, i8);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  i3 = i4 + 12 | 0;
  i7 = HEAP32[i3 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  HEAP8[i4 + 48 >> 0] = 1;
 }
 i1 = HEAP32[gb + 1104580 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, HEAP32[i6 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0);
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i9 + 20 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 56 >> 2] | 0, i9 | 0, 0);
 STACKTOP = i10;
 return;
}

function __Z16RandomQuaternionR4Rand(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i16 = i16 << 11 ^ i16;
 i15 = i2 + 4 | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 i14 = i2 + 8 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i16 = i16 >>> 8 ^ i16 ^ i13;
 i17 = i16 ^ i13 >>> 19;
 f8 = Math_fround(Math_fround((i17 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f8 = Math_fround(Math_fround(Math_fround(1.0) - f8) - f8);
 i12 = i12 << 11 ^ i12;
 i12 = i12 >>> 8 ^ i12 ^ i17;
 i16 = i12 ^ i16 >>> 19;
 f6 = Math_fround(Math_fround((i16 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f6 = Math_fround(Math_fround(Math_fround(1.0) - f6) - f6);
 i11 = i11 << 11 ^ i11;
 i11 = i11 >>> 8 ^ i11 ^ i16;
 i12 = i11 ^ i12 >>> 19;
 f3 = Math_fround(Math_fround((i12 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround(Math_fround(1.0) - f3) - f3);
 i13 = i13 << 11 ^ i13;
 HEAP32[i2 >> 2] = i17;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i14 >> 2] = i12;
 i2 = i13 >>> 8 ^ i13 ^ i12 ^ i11 >>> 19;
 HEAP32[i10 >> 2] = i2;
 f1 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f1 = Math_fround(Math_fround(Math_fround(1.0) - f1) - f1);
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f6 * f6)) + Math_fround(f3 * f3)) + Math_fround(f1 * f1))));
 if (f7 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f5 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f5 = Math_fround(f1 / f7);
  f4 = Math_fround(f3 / f7);
  f3 = Math_fround(f6 / f7);
  f1 = Math_fround(f8 / f7);
 }
 if (!(Math_fround(f5 + Math_fround(Math_fround(Math_fround(f1 * Math_fround(0.0)) + Math_fround(f3 * Math_fround(0.0))) + Math_fround(f4 * Math_fround(0.0)))) < Math_fround(0.0))) {
  f8 = f5;
  f7 = f4;
  f6 = f3;
  f5 = f1;
  HEAPF32[i9 >> 2] = f5;
  i17 = i9 + 4 | 0;
  HEAPF32[i17 >> 2] = f6;
  i17 = i9 + 8 | 0;
  HEAPF32[i17 >> 2] = f7;
  i17 = i9 + 12 | 0;
  HEAPF32[i17 >> 2] = f8;
  return;
 }
 f8 = Math_fround(-f5);
 f7 = Math_fround(-f4);
 f6 = Math_fround(-f3);
 f5 = Math_fround(-f1);
 HEAPF32[i9 >> 2] = f5;
 i17 = i9 + 4 | 0;
 HEAPF32[i17 >> 2] = f6;
 i17 = i9 + 8 | 0;
 HEAPF32[i17 >> 2] = f7;
 i17 = i9 + 12 | 0;
 HEAPF32[i17 >> 2] = f8;
 return;
}

function __ZN9Polygon2D8CopyFromERKS_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i6 = (HEAP32[i10 + 4 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
 i11 = (i6 | 0) / 20 | 0;
 if (!i6) {
  i4 = HEAP32[i12 >> 2] | 0;
  i3 = i12 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i4 | 0)) return;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i3 >> 2] = i2;
   if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i3 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
  return;
 }
 i5 = i12 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = (i3 - i2 | 0) / 20 | 0;
 if (i11 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i12, i11 - i1 | 0); else if (i11 >>> 0 < i1 >>> 0) {
  i4 = i2 + (i11 * 20 | 0) | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i2 = i3;
   while (1) {
    i1 = i2 + -20 | 0;
    HEAP32[i5 >> 2] = i1;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i1 >> 2] = 0;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 if ((i6 | 0) <= 0) return;
 i7 = 0;
 do {
  i5 = HEAP32[i12 >> 2] | 0;
  i6 = i5 + (i7 * 20 | 0) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) {
   i8 = HEAP32[i1 + (i7 * 20 | 0) >> 2] | 0;
   i9 = i5 + (i7 * 20 | 0) + 12 | 0;
   i1 = HEAP32[i1 + (i7 * 20 | 0) + 12 >> 2] << 3;
   i2 = i1 >> 3;
   HEAP32[i9 >> 2] = i2;
   i3 = i5 + (i7 * 20 | 0) + 16 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i5 + (i7 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i6 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + (i7 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i6 >> 2] = i1;
    break;
   } else i1 = HEAP32[i6 >> 2] | 0; while (0);
   _memcpy(i1 | 0, i8 | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i11 | 0));
 return;
}

function __ZN5physx21PxcContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i9, i2, i3, i7, i13, i1, i17) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, f14 = f0, f15 = f0, f16 = f0, f18 = f0, f19 = f0;
 f15 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f18 = Math_fround(f15 - Math_fround(HEAPF32[i7 + 16 >> 2]));
 f16 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f12 = Math_fround(f16 - Math_fround(HEAPF32[i7 + 20 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f18 = Math_fround(f18 * Math_fround(2.0));
 f12 = Math_fround(f12 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f14 - Math_fround(HEAPF32[i7 + 24 >> 2])) * Math_fround(2.0));
 f4 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f6 = Math_fround(Math_fround(f4 * f4) + Math_fround(-.5));
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f19 = Math_fround(f18 * f5);
 f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f19 = Math_fround(f19 + Math_fround(f12 * f10));
 f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f12 = Math_fround(Math_fround(f5 * Math_fround(f19 + Math_fround(f11 * f8))) + Math_fround(Math_fround(f18 * f6) - Math_fround(f4 * Math_fround(Math_fround(f11 * f10) - Math_fround(f12 * f8)))));
 f11 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f12 = Math_fround(f12 - f11);
 if (!(f12 <= Math_fround(HEAPF32[i13 >> 2]))) {
  i17 = 0;
  return i17 | 0;
 }
 f18 = Math_fround(f5 * Math_fround(2.0));
 f19 = Math_fround(f4 * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f5 * f18) + Math_fround(Math_fround(f4 * f19) + Math_fround(-1.0)));
 f6 = Math_fround(Math_fround(f8 * f19) + Math_fround(f18 * f10));
 f4 = Math_fround(Math_fround(f18 * f8) - Math_fround(f19 * f10));
 i1 = i17 + 4096 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  i17 = 1;
  return i17 | 0;
 }
 f19 = Math_fround(f14 - Math_fround(f11 * f4));
 f18 = Math_fround(f16 - Math_fround(f11 * f6));
 f16 = Math_fround(f15 - Math_fround(f11 * f5));
 HEAP32[i1 >> 2] = i2 + 1;
 HEAPF32[i17 + (i2 << 6) >> 2] = f5;
 HEAPF32[i17 + (i2 << 6) + 4 >> 2] = f6;
 HEAPF32[i17 + (i2 << 6) + 8 >> 2] = f4;
 HEAPF32[i17 + (i2 << 6) + 16 >> 2] = f16;
 HEAPF32[i17 + (i2 << 6) + 20 >> 2] = f18;
 HEAPF32[i17 + (i2 << 6) + 24 >> 2] = f19;
 HEAPF32[i17 + (i2 << 6) + 12 >> 2] = f12;
 HEAP32[i17 + (i2 << 6) + 48 >> 2] = -1;
 HEAP32[i17 + (i2 << 6) + 52 >> 2] = -1;
 i17 = 1;
 return i17 | 0;
}

function __ZNK8Animator7IsHumanEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 104 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = i3 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i2 = (i2 | 0) == -1 ? i3 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i3 + (i2 << 3) | 0;
   i3 = HEAP32[i10 + 28 >> 2] | 0;
   i4 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = i10;
  }
  if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 7; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 do if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  break;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 if (!i1) i8 = 16; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 16; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 18;
  }
 }
 if ((i8 | 0) == 16) i8 = 18;
 if ((i8 | 0) == 18) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 i10 = __ZNK6Avatar7IsHumanEv(i1) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj293ES3_NS_19PxHeightFieldFormat4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 673360 | 0) {
  i2 = gb + 673360 | 0;
  i3 = gb + 89672 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN16MemoryFileSystemD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 HEAP32[i6 >> 2] = gb + 71492 + 8;
 i8 = i6 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i6 + 8 | 0;
 if ((i1 | 0) != (i9 | 0)) {
  i5 = i7 + 4 | 0;
  i2 = i1;
  while (1) {
   i4 = i2 + 32 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!(HEAP32[i1 >> 2] | 0)) i3 = 9; else {
    i3 = HEAP32[i1 >> 2] | 0;
    i11 = i3 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    if (!(HEAP32[i11 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     i3 = 9;
    } else i3 = 10;
   }
   if ((i3 | 0) == 9) {
    i3 = 0;
    if (!i1) i1 = 0; else i3 = 10;
   }
   if ((i3 | 0) == 10) {
    i3 = i1 + 24 | 0;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i11 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i1 + 36 >> 2] | 0;
     HEAP32[i7 >> 2] = 54;
     HEAP32[i5 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
   HEAP32[i4 >> 2] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
  }
 }
 i1 = i6 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  i11 = HEAP32[i9 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE(i8, i11);
  STACKTOP = i10;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i6 + 36 >> 2] | 0;
 HEAP32[i7 >> 2] = 54;
 HEAP32[i7 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
 i11 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE(i8, i11);
 STACKTOP = i10;
 return;
}

function __Z37Transform_CUSTOM_INTERNAL_CALL_LookAtP12Il2CppObjectRK8Vector3fS3_(i11, i1, i6) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 64 | 0;
 i12 = i13 + 48 | 0;
 i9 = i13 + 12 | 0;
 i10 = i13;
 if (!i11) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i4) {
  i14 = i11;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i14);
 }
 __ZNK9Transform11GetPositionEv(i12, i4);
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i12 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i12 + 4 >> 2]));
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i12 + 8 >> 2]));
 HEAPF32[i7 >> 2] = f3;
 i1 = i7 + 4 | 0;
 HEAPF32[i1 >> 2] = f5;
 i4 = i7 + 8 | 0;
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 12 >> 2] = Math_fround(1.0);
 if (__Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i7, i6, i12) | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
  __ZN9Transform11SetRotationERK11Quaternionf(i1, i12);
  STACKTOP = i13;
  return;
 }
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = Math_fround(f8 * f8);
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  STACKTOP = i13;
  return;
 }
 HEAPF32[i10 >> 2] = Math_fround(f8 / f3);
 HEAPF32[i10 + 4 >> 2] = Math_fround(f5 / f3);
 HEAPF32[i10 + 8 >> 2] = Math_fround(f2 / f3);
 __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i9, gb + 62548 | 0, i10) | 0;
 __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i9, i12);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 __ZN9Transform11SetRotationERK11Quaternionf(i1, i12);
 STACKTOP = i13;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 112 | 0;
 i10 = i8 + 96 | 0;
 i1 = i8 + 80 | 0;
 i13 = i8 + 32 | 0;
 i12 = i8 + 16 | 0;
 i2 = i8;
 i15 = HEAP32[i3 + 4 >> 2] | 0;
 i14 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i15;
 HEAP32[i11 + 8 >> 2] = i14;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 i14 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = i14;
 HEAP32[i10 + 8 >> 2] = i3;
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i6 + 92 >> 2] | 0;
 i4 = HEAP32[i6 + 96 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i6 + 88 >> 2];
 HEAP32[i13 + 4 >> 2] = i5;
 HEAP32[i13 + 8 >> 2] = i4;
 HEAPF32[i13 + 12 >> 2] = Math_fround(0.0);
 i4 = HEAP32[i6 + 104 >> 2] | 0;
 i5 = HEAP32[i6 + 108 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 + 100 >> 2];
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i5;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_(i2, i13, i12, i11, i10, i1, i8 + 64 | 0, i8 + 48 | 0);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f9 <= Math_fround(HEAPF32[i6 + 72 >> 2]))) {
  i15 = 1;
  STACKTOP = i8;
  return i15 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i15 = 0;
  STACKTOP = i8;
  return i15 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i15 = 1;
  STACKTOP = i8;
  return i15 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i15 = 1;
  STACKTOP = i8;
  return i15 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i15 = 1;
  STACKTOP = i8;
  return i15 | 0;
 }
 return 0;
}

function __ZN22UnityWebRequestManager7CleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!(HEAP8[gb + 1573588 >> 0] | 0)) return;
 i1 = HEAP32[gb + 1468908 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (gb + 1468908 | 0)) do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAP32[i1 + 108 >> 2] | 0) == 2) __ZN19TransportJavaScript5AbortEv(i1 + 8 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (gb + 1468908 | 0));
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 1540 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L11 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 772 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 380 | 0)) {
    i4 = i6 + 772 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 772 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L11;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 772 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 772 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 772 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 10032 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L22 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 9264 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 381 | 0)) {
    i4 = i6 + 9264 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 9264 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L22;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 9264 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 9264 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 9264 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 9264 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 9264 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 9264 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 HEAP8[gb + 1573588 >> 0] = 0;
 return;
}

function __ZN14UnityAnalytics25UnregisterGlobalCallbacksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 16 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 5400 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i4 = i6 + 4632 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (fb + 329 | 0)) {
    i3 = i6 + 4632 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 4632 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i3 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L4;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i3 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 4632 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 4632 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 4632 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 4632 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i5 = HEAP32[gb + 1163400 + 768 >> 2] | 0;
 L15 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = gb + 1163400 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 1e3 | 0)) {
    i4 = gb + 1163400 + (i1 * 12 | 0) + 8 | 0;
    i2 = gb + 1163400 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L15;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i7 = (HEAP32[gb + 1163400 + 768 >> 2] | 0) + -1 | 0;
  HEAP32[gb + 1163400 + 768 >> 2] = i7;
  if (i7 >>> 0 > i1 >>> 0) do {
   i7 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[gb + 1163400 + (i7 * 12 | 0) >> 2] = HEAP32[gb + 1163400 + (i1 * 12 | 0) >> 2];
   HEAP32[gb + 1163400 + (i7 * 12 | 0) + 4 >> 2] = HEAP32[gb + 1163400 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[gb + 1163400 + (i7 * 12 | 0) + 8 >> 0] = HEAP8[gb + 1163400 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[gb + 1163400 + 768 >> 2] | 0) >>> 0);
 } while (0);
 i7 = i8 + 20 | 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfig10UnregisterERNS_7Connect13ConfigHandlerE(i8 + 24 | 0, HEAP32[i7 >> 2] | 0);
 __ZN11UnityEngine7Connect13ConfigHandler7ReleaseEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __ZNSt3__26vectorI12QuadTreeNodeNS_9allocatorIS1_EEE8__appendEj(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i11 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i3 - i1 >> 6 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 + 8 >> 2] = -1;
   HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i12 = i1 + 60 | 0;
   HEAP8[i12 >> 0] = HEAP8[i12 >> 0] & -7;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = (HEAP32[i13 >> 2] | 0) + 64 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = (i1 - i4 >> 6) + i2 | 0;
 if (i5 >>> 0 > 67108863) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i10 = i3 - i4 | 0;
 i3 = i10 >> 5;
 i3 = i10 >> 6 >>> 0 < 33554431 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 67108863;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 6) | 0;
 i6 = i5 + (i1 - i4 >> 6 << 6) | 0;
 i4 = i6;
 i3 = i5 + (i3 << 6) | 0;
 i10 = i4;
 i1 = i6;
 do {
  HEAP32[i1 + 8 >> 2] = -1;
  HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i9 = i1 + 60 | 0;
  HEAP8[i9 >> 0] = HEAP8[i9 >> 0] & -7;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = i10 + 64 | 0;
  i10 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i4; else {
  i9 = i2;
  i2 = i4;
  i5 = i6;
  do {
   i4 = i9;
   i9 = i9 + -64 | 0;
   i6 = i5 + -64 | 0;
   i7 = i9;
   i8 = i6 + 36 | 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
    i6 = i6 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i6 | 0) < (i8 | 0));
   HEAP32[i5 + -28 >> 2] = HEAP32[i4 + -28 >> 2];
   HEAP32[i5 + -24 >> 2] = HEAP32[i4 + -24 >> 2];
   HEAP32[i5 + -20 >> 2] = HEAP32[i4 + -20 >> 2];
   HEAP32[i5 + -16 >> 2] = HEAP32[i4 + -16 >> 2];
   HEAP32[i5 + -12 >> 2] = HEAP32[i4 + -12 >> 2];
   HEAP32[i5 + -8 >> 2] = HEAP32[i4 + -8 >> 2];
   HEAP8[i5 + -4 >> 0] = HEAP8[i4 + -4 >> 0] | 0;
   i5 = i2 + -64 | 0;
   i2 = i5;
  } while ((i9 | 0) != (i1 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = i10;
 HEAP32[i12 >> 2] = i3;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN19CloudServiceHandler14SetServiceInfoENS_11ServiceTypeE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 16 | 0;
 i12 = i13;
 i8 = i9 + 20 | 0;
 i2 = HEAP32[gb + 190212 + (i10 << 2) >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i12 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i3;
  if (!i3) i1 = i12; else {
   i1 = i12;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i7 = i3 + 16 & -16;
  HEAP32[i11 >> 2] = 66;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i12 + 11 | 0;
 do if ((i8 | 0) != (i12 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
  i7 = i3 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 24 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 24 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  HEAP32[i9 >> 2] = i10;
  STACKTOP = i13;
  return;
 }
 i8 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 66;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i11);
 HEAP32[i9 >> 2] = i10;
 STACKTOP = i13;
 return;
}

function __Z28ScriptingStructArrayToVectorI12SkeletonBone16MonoSkeletonBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i4 = HEAP32[i11 >> 2] | 0;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i8 + 4 | 0;
  i6 = i8 + 4 | 0;
  do {
   i2 = i1 + -72 | 0;
   HEAP32[i9 >> 2] = i2;
   i3 = i1 + -56 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -44 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i5 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + -60 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
   }
   i1 = HEAP32[i9 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i10) | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = (i3 - i2 | 0) / 72 | 0;
 if (i7 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI12SkeletonBoneNS_9allocatorIS1_EEE8__appendEj(i11, i7 - i1 | 0); else if (i7 >>> 0 < i1 >>> 0) {
  i4 = i2 + (i7 * 72 | 0) | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i5 = i8 + 4 | 0;
   i6 = i8 + 4 | 0;
   do {
    i1 = i3 + -72 | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = i3 + -56 | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i14 = HEAP32[i3 + -44 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i5 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i3 + -60 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i3 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
 }
 if ((i7 | 0) > 0) i1 = 0; else {
  STACKTOP = i13;
  return;
 }
 do {
  i14 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i10, i1, 48) | 0;
  mftCall_vii(i12 | 0, i14 | 0, (HEAP32[i11 >> 2] | 0) + (i1 * 72 | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 872 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 872 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 872 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 872 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN9ShaderLab14SerializedPassaSERKS0_(i3, i2) | 0;
   i2 = i2 + 872 | 0;
   i3 = i3 + 872 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -872 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN9ShaderLab14SerializedPassD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN9ShaderLab14SerializedPassC2ERKS0_(i2, i1);
   i1 = i1 + 872 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 872 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -872 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN9ShaderLab14SerializedPassD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 4925421) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 872 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 2462710 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 4925421;
 if (i3 >>> 0 > 4925421) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 872 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 872 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN9ShaderLab14SerializedPassC2ERKS0_(i1, i2);
  i2 = i2 + 872 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 872 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 16 | 0;
 i1 = i10;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i9 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  i9 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i4 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i4);
 }
 i6 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i5 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i5;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = i8 + 8 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 12 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZNK7dtCrowd22CalculateRemainingPathERK13dtCrowdHandle(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 40 | 0;
 i8 = i12 + 88 | 0;
 i5 = i12 + 32 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i10 = HEAP32[i3 + 16 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 552 >> 2]);
 if (f1 >= Math_fround(0.0)) {
  f7 = f1;
  STACKTOP = i12;
  return Math_fround(f7);
 }
 if ((HEAP8[i10 + (i9 * 608 | 0) + 601 >> 0] | 0) == 2) {
  f7 = Math_fround(inf);
  STACKTOP = i12;
  return Math_fround(f7);
 }
 i2 = HEAP32[i3 + 464 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i10 + (i9 * 608 | 0) | 0, i11, i8, i12, i5, 4, i2) | 0;
 i2 = i10 + (i9 * 608 | 0) + 480 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) if ((HEAP32[i10 + (i9 * 608 | 0) + 32 >> 2] | 0) == 1) {
  f6 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 12 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 >> 2]));
  f7 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 16 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 484 >> 2]));
  f1 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 20 >> 2]);
  f1 = Math_fround(f1 - Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 488 >> 2]));
  f1 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f1 * f1))));
 } else f1 = Math_fround(inf); else if (!(HEAP8[i8 + (i3 + -1) >> 0] & 2)) f1 = Math_fround(inf); else if ((i3 | 0) > 0) {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f7 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 484 >> 2]);
  f1 = Math_fround(0.0);
  i2 = 0;
  f4 = Math_fround(HEAPF32[i10 + (i9 * 608 | 0) + 488 >> 2]);
  do {
   i10 = i11 + (i2 * 3 << 2) | 0;
   f15 = f6;
   f6 = Math_fround(HEAPF32[i10 >> 2]);
   f15 = Math_fround(f15 - f6);
   f14 = f7;
   f7 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f14 = Math_fround(f14 - f7);
   f13 = f4;
   f4 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f13 = Math_fround(f13 - f4);
   f1 = Math_fround(f1 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(f13 * f13)))));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } else f1 = Math_fround(0.0);
 f15 = f1;
 STACKTOP = i12;
 return Math_fround(f15);
}

function __ZN9Animation8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 280 | 0, i6);
 i3 = i5 + 284 | 0;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 288 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 36 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 40 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i5 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i9 = HEAP32[i7 >> 2] | 0;
  i8 = i9 | 1;
  i8 = (i8 | 0) == 3;
  i9 = i8 ? 1 : i9;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  i8 = i9 | 1;
  i8 = (i8 | 0) == 3;
  i9 = i8 ? 1 : i9;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 656520 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 << 5) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + (i1 << 5) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + (i1 << 5) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + (i1 << 5) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + (i1 << 5) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + (i1 << 5) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + (i1 << 5) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i4 + (i1 << 5) + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN5physx16NpParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 124132 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124132 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124132 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124132 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124132 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124132 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124132 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124132 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754793;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 200;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754793;
 HEAP32[i5 + 4 >> 2] = gb + 747076;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 200;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124164 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124164 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124164 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124164 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124164 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124164 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124164 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 24 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  i9 = i6 + 40 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 24 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  i9 = i6 + 40 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN23ForwardShaderRenderLoop23RenderForwardShadowMapsEPK11ActiveLightbN6Camera10RenderFlagER17ShaderPassContext(i8, i1, i9, i11, i12) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14;
 i5 = __Z12GetGfxDevicev() | 0;
 __Z20SetNoShadowsKeywordsR17ShaderPassContext(i12);
 i3 = __Z16GetBuildSettingsv() | 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 i10 = HEAP32[i2 + 44 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i3 = HEAP16[i3 + 116 >> 1] | 0;
 i10 = __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf((i3 & 255) << 24 >> 24 != 0, (i3 & 65535) > 255, HEAP32[i2 + (i10 * 108 | 0) + 20 >> 2] | 0, Math_fround(HEAPF32[i2 + (i10 * 108 | 0) + 36 >> 2])) | 0;
 i2 = i8 + 524 | 0;
 i3 = HEAP8[i2 >> 0] & -9 | (i10 & 1) << 3 & 255;
 HEAP8[i2 >> 0] = i3;
 if (!i1) i1 = (HEAP32[i8 + 352 >> 2] | 0) != 0 & 1; else i1 = 1;
 HEAP8[i2 >> 0] = i3 & -2 | i1;
 i6 = i1 << 24 >> 24 == 0;
 i7 = i8 + 8 | 0;
 __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i4, i8 + 360 | 0, i8 + 364 | 0);
 i1 = i5 + 948 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i1 = i8 + 188 | 0;
 if (!(HEAP32[i8 + 328 >> 2] | 0)) {
  if (HEAP32[i8 + 332 >> 2] | 0) i13 = 5;
 } else i13 = 5;
 if ((i13 | 0) == 5) __ZN23ForwardShaderRenderLoop21RenderLightShadowMapsER16ForwardShadowMapbbR17ShaderPassContext(i8, i1, i10, i9, i12);
 i2 = HEAP32[i8 + 352 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i3 = i8 + 340 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + (i1 * 152 | 0) | 0;
   if (!(HEAP32[i4 + (i1 * 152 | 0) + 140 >> 2] | 0)) {
    if (HEAP32[i4 + (i1 * 152 | 0) + 144 >> 2] | 0) i13 = 11;
   } else i13 = 11;
   if ((i13 | 0) == 11) {
    i13 = 0;
    __ZN23ForwardShaderRenderLoop21RenderLightShadowMapsER16ForwardShadowMapbbR17ShaderPassContext(i8, i5, i10, i9, i12);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if (i6) {
  STACKTOP = i14;
  return;
 }
 __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i12, i11 | 4);
 __Z20SetNoShadowsKeywordsR17ShaderPassContext(i12);
 STACKTOP = i14;
 return;
}

function _tt_delta_interpolate(i14, i15, i1, i2, i9, i12) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 if ((i14 | 0) > (i15 | 0)) return;
 i11 = (HEAP32[i9 + (i1 << 3) >> 2] | 0) > (HEAP32[i9 + (i2 << 3) >> 2] | 0);
 i13 = i11 ? i1 : i2;
 i11 = i11 ? i2 : i1;
 i4 = HEAP32[i9 + (i11 << 3) >> 2] | 0;
 i5 = HEAP32[i9 + (i13 << 3) >> 2] | 0;
 i6 = HEAP32[i12 + (i11 << 3) >> 2] | 0;
 i1 = HEAP32[i12 + (i13 << 3) >> 2] | 0;
 i7 = i6 - i4 | 0;
 i8 = i1 - i5 | 0;
 if ((i5 | 0) == (i4 | 0) | (i1 | 0) == (i6 | 0)) {
  i2 = i14;
  while (1) {
   i1 = HEAP32[i9 + (i2 << 3) >> 2] | 0;
   if ((i1 | 0) > (i4 | 0)) i1 = (i1 | 0) < (i5 | 0) ? i6 : i1 + i8 | 0; else i1 = i1 + i7 | 0;
   HEAP32[i12 + (i2 << 3) >> 2] = i1;
   if ((i2 | 0) < (i15 | 0)) i2 = i2 + 1 | 0; else break;
  }
 } else {
  i3 = _UNITY_FT_DivFix(i1 - i6 | 0, i5 - i4 | 0) | 0;
  i2 = i14;
  while (1) {
   i1 = HEAP32[i9 + (i2 << 3) >> 2] | 0;
   do if ((i1 | 0) > (i4 | 0)) if ((i1 | 0) < (i5 | 0)) {
    i1 = (_UNITY_FT_MulFix(i1 - i4 | 0, i3) | 0) + i6 | 0;
    break;
   } else {
    i1 = i1 + i8 | 0;
    break;
   } else i1 = i1 + i7 | 0; while (0);
   HEAP32[i12 + (i2 << 3) >> 2] = i1;
   if ((i2 | 0) < (i15 | 0)) i2 = i2 + 1 | 0; else break;
  }
 }
 i10 = i9 + 4 | 0;
 i9 = i12 + 4 | 0;
 i6 = (HEAP32[i10 + (i11 << 3) >> 2] | 0) > (HEAP32[i10 + (i13 << 3) >> 2] | 0);
 i1 = i6 ? i11 : i13;
 i6 = i6 ? i13 : i11;
 i4 = HEAP32[i10 + (i6 << 3) >> 2] | 0;
 i5 = HEAP32[i10 + (i1 << 3) >> 2] | 0;
 i6 = HEAP32[i9 + (i6 << 3) >> 2] | 0;
 i1 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
 i7 = i6 - i4 | 0;
 i8 = i1 - i5 | 0;
 if ((i5 | 0) == (i4 | 0) | (i1 | 0) == (i6 | 0)) {
  i2 = i14;
  while (1) {
   i1 = HEAP32[i10 + (i2 << 3) >> 2] | 0;
   if ((i1 | 0) > (i4 | 0)) i1 = (i1 | 0) < (i5 | 0) ? i6 : i1 + i8 | 0; else i1 = i1 + i7 | 0;
   HEAP32[i9 + (i2 << 3) >> 2] = i1;
   if ((i2 | 0) < (i15 | 0)) i2 = i2 + 1 | 0; else break;
  }
  return;
 }
 i3 = _UNITY_FT_DivFix(i1 - i6 | 0, i5 - i4 | 0) | 0;
 i2 = i14;
 while (1) {
  i1 = HEAP32[i10 + (i2 << 3) >> 2] | 0;
  do if ((i1 | 0) > (i4 | 0)) if ((i1 | 0) < (i5 | 0)) {
   i1 = (_UNITY_FT_MulFix(i1 - i4 | 0, i3) | 0) + i6 | 0;
   break;
  } else {
   i1 = i1 + i8 | 0;
   break;
  } else i1 = i1 + i7 | 0; while (0);
  HEAP32[i9 + (i2 << 3) >> 2] = i1;
  if ((i2 | 0) < (i15 | 0)) i2 = i2 + 1 | 0; else break;
 }
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i14 = i11 + 4 | 0;
 if ((i1 | 0) == (i12 | 0)) {
  i9 = i14;
  i8 = i10;
  i14 = HEAP32[i14 >> 2] | 0;
  HEAP32[i8 >> 2] = i14;
  HEAP32[i9 >> 2] = i12;
  i12 = i11 + 8 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  HEAP32[i13 >> 2] = i8;
  HEAP32[i12 >> 2] = i14;
  i12 = i10 + 8 | 0;
  i14 = i11 + 12 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i10 = HEAP32[i14 >> 2] | 0;
  HEAP32[i12 >> 2] = i10;
  HEAP32[i14 >> 2] = i13;
  i14 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = i14;
  return;
 }
 i9 = HEAP32[i14 >> 2] | 0;
 do {
  i7 = i1;
  i1 = i1 + -36 | 0;
  i8 = i1;
  i4 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = i9 + -36 | 0;
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i9 + -28 | 0;
  i4 = i7 + -28 | 0;
  HEAP32[i3 >> 2] = 0;
  i8 = i9 + -24 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 + -20 >> 2] = 0;
  i6 = i7 + -24 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = (i2 | 0) / 96 | 0;
  if (i2 | 0) {
   if (i5 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i2 = __Znwj(i2) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 + -20 >> 2] = i2 + (i5 * 96 | 0);
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i4 | 0)) do {
    __ZN19ComputeShaderKernelC2ERKS_(i2, i3);
    i3 = i3 + 96 | 0;
    i2 = (HEAP32[i8 >> 2] | 0) + 96 | 0;
    HEAP32[i8 >> 2] = i2;
   } while ((i3 | 0) != (i4 | 0));
  }
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_(i9 + -16 | 0, i7 + -16 | 0);
  HEAP8[i9 + -4 >> 0] = HEAP8[i7 + -4 >> 0] | 0;
  i9 = (HEAP32[i14 >> 2] | 0) + -36 | 0;
  HEAP32[i14 >> 2] = i9;
 } while ((i1 | 0) != (i12 | 0));
 i8 = i10;
 i12 = HEAP32[i10 >> 2] | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i14 >> 2] = i12;
 i12 = i11 + 8 | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i12 >> 2] = i9;
 i10 = i10 + 8 | 0;
 i13 = i11 + 12 | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i13 >> 2] = i12;
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP32[i11 >> 2] = i14;
 return;
}

function __ZN5physx15NpParticleFluid17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 124196 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 124196 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 124196 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 124196 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 124196 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 124196 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 124196 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 124196 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754810;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 200;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754810;
 HEAP32[i5 + 4 >> 2] = gb + 747076;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 200;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 124164 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 124164 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 124164 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 124164 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 124164 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 124164 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 124164 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 124164 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __Z30TransferField_LinearCollectionI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 40 | 0;
 i6 = i12;
 i7 = i12 + 8 | 0;
 i8 = HEAP32[i4 + 20 >> 2] | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i10, i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i11 = i6 + 4 | 0;
 HEAP32[i11 >> 2] = -1;
 do if (!(HEAP32[i4 + 4 >> 2] | 0)) i9 = 8; else {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i10 >> 2] | 0) | 0;
  i1 = HEAP32[i10 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + ((HEAP8[i10 + 4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i10 + 16 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i5 = i2;
  if (!i2) {
   HEAP32[i6 >> 2] = i5;
   HEAP32[i6 + 4 >> 2] = -1;
   i9 = 8;
   break;
  }
  if (!(HEAP32[i10 + 24 >> 2] | 0)) i1 = __Z22scripting_array_lengthP11Il2CppArray(i2) | 0; else i1 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i6 + 4 >> 2] = i1;
  if ((i1 | 0) == -1) i9 = 8;
 } while (0);
 if ((i9 | 0) == 8) {
  i9 = HEAP32[i10 + 20 >> 2] | 0;
  HEAP32[i6 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i9, __Z34scripting_class_array_element_sizeP11Il2CppClass(i9) | 0, 0) | 0;
  HEAP32[i11 >> 2] = 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = i6;
 mftCall_vii(HEAP32[i3 + 40 >> 2] | 0, i3 | 0, i7 | 0);
 if ((HEAP8[i8 + 40 >> 0] | 0) == 0 | (HEAP32[i11 >> 2] | 0) == -1) {
  STACKTOP = i12;
  return;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i10 >> 2] | 0) | 0;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i1 + ((HEAP8[i10 + 4 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i10 + 16 >> 2] | 0) | 0 : i9) >> 2] = i8;
 if ((HEAP32[i10 + 24 >> 2] | 0) != 1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i1 + 12 >> 2] = HEAP32[i11 >> 2];
 i11 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i10 + 28 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i10 + 36 >> 2] | 0) + ((HEAP8[i10 + 32 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i10 + 44 >> 2] | 0) | 0 : i11) >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i2;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 1) if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) != 4) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
  f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f12 = Math_fround(f12 * Math_fround(-2.0));
  f13 = Math_fround(f13 * Math_fround(-2.0));
  f15 = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(-2.0));
  f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f14 = Math_fround(Math_fround(f8 * f8) + Math_fround(-.5));
  f11 = Math_fround(HEAPF32[i1 >> 2]);
  f5 = Math_fround(f12 * f11);
  f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f13 * f10));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(f15 * f9));
  f7 = Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f12 * f14) - Math_fround(f8 * Math_fround(Math_fround(f15 * f10) - Math_fround(f13 * f9)))));
  f6 = Math_fround(Math_fround(f10 * f5) + Math_fround(Math_fround(f13 * f14) - Math_fround(f8 * Math_fround(Math_fround(f12 * f9) - Math_fround(f15 * f11)))));
  f5 = Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f8 * Math_fround(Math_fround(f13 * f11) - Math_fround(f12 * f10)))) + Math_fround(f9 * f5));
  f10 = Math_fround(-f10);
  f9 = Math_fround(-f9);
  HEAPF32[i4 >> 2] = Math_fround(-f11);
  HEAPF32[i4 + 4 >> 2] = f10;
  HEAPF32[i4 + 8 >> 2] = f9;
  HEAPF32[i4 + 12 >> 2] = f8;
  HEAPF32[i4 + 16 >> 2] = f7;
  HEAPF32[i4 + 20 >> 2] = f6;
  HEAPF32[i4 + 24 >> 2] = f5;
  STACKTOP = i2;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN17PersistentManager27IntegrateAllThreadedObjectsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 288 | 0;
 i6 = i8 + 8 | 0;
 i4 = i8;
 i3 = gb + 64016 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i6, i7);
 __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue(i5, i6);
 i4 = i5 + 168 | 0;
 i2 = i5 + 172 | 0;
 HEAP32[i2 >> 2] = 32;
 HEAP32[i5 + 184 >> 2] = 16;
 HEAP32[i5 + 180 >> 2] = 6;
 HEAP8[i5 + 188 >> 0] = 0;
 i1 = __Znwj(640) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) i2 = 32; else {
  __ZdlPv(i3);
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i2 = i1 + (i2 * 20 | 0) | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = i5 + 148 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i5 + 176 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 0;
 i1 = 0;
 do {
  i3 = HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0;
  i4 = HEAP32[i6 + (i1 * 20 | 0) + 12 >> 2] | 0;
  if (i4 | 0) {
   i2 = 0;
   do {
    __ZN6Object24RegisterInstanceIDNoLockEPS_(HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 14);
 i1 = 0;
 while (1) {
  i2 = HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0;
  i3 = HEAP32[i6 + (i1 * 20 | 0) + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = fb + 599;
  __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i2, i2 + (i3 * 12 | 0) | 0, i7);
  if ((i1 | 0) == 1) {
   i1 = __Z24SetExecutionRestrictions21ExecutionRestrictions(4) | 0;
   __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i2, i3, 3);
   __Z24SetExecutionRestrictions21ExecutionRestrictions(i1) | 0;
   i1 = 2;
   continue;
  } else {
   __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i2, i3, 3);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 14) break; else continue;
  }
 }
 __ZN18AwakeFromLoadQueueD2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = i3 + 76 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 if (f7 != Math_fround(HEAPF32[i9 >> 2])) i2 = 4; else {
  f7 = Math_fround(HEAPF32[i3 + 80 >> 2]);
  if (f7 != Math_fround(HEAPF32[i9 + 4 >> 2])) i2 = 4; else {
   f7 = Math_fround(HEAPF32[i3 + 84 >> 2]);
   if (f7 != Math_fround(HEAPF32[i9 + 8 >> 2])) i2 = 4;
  }
 }
 if ((i2 | 0) == 4) {
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 i8 = i3 + 148 | 0;
 if ((HEAP32[i8 >> 2] | 0) == -1) {
  STACKTOP = i11;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 i4 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i4 ? f7 : f6;
 i4 = f6 < Math_fround(9.99999974e-06);
 f6 = i4 ? Math_fround(9.99999974e-06) : f6;
 f7 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 i4 = i2 + 56 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + 8 | 0;
 __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i3);
 i1 = i10;
 i2 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i5, HEAP32[i8 >> 2] | 0) | 0;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAPF32[i10 + 8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f7) * f6);
 HEAPF32[i10 + 12 >> 2] = Math_fround(f7 * f6);
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i5, HEAP32[i8 >> 2] | 0, i10);
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 284 >> 2] | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn25readStridedBufferPropertyIhEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i2, i1, i13, i3, i12, i14) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 4 | 0;
 i11 = i15;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i14; else {
  HEAP32[gb + 1457156 >> 2] = (HEAP32[gb + 1457156 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) {
   HEAP32[i11 >> 2] = gb + 1576256;
   i1 = gb + 1576256 | 0;
   i10 = 8;
  } else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
   }
   i1 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 + 2 | 0) | 0;
   _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
   HEAP8[i1 + i3 >> 0] = 0;
   HEAP32[i11 >> 2] = i1;
   if (!i1) {
    i1 = 0;
    i10 = 9;
   } else i10 = 8;
  }
  if ((i10 | 0) == 8) {
   i9 = _strlen(i1) | 0;
   i8 = i1 + i9 | 0;
   if ((i9 | 0) > 0) {
    i5 = i1;
    i9 = 0;
    i4 = 0;
    i3 = 0;
    i2 = 0;
    while (1) {
     if (!i5) i7 = i2; else if (!(HEAP8[i5 >> 0] | 0)) i7 = i2; else i7 = (_strtoul(i5, i11, 10) | 0) & 255;
     i2 = i9 + 1 | 0;
     if (i4 >>> 0 < i2 >>> 0) {
      i4 = 32;
      while (1) if (i4 >>> 0 < i2 >>> 0) i4 = i4 << 1; else break;
      i5 = mftCall_iii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i4 | 0) | 0;
      if (i9 | 0) _memcpy(i5 | 0, i3 | 0, i9 | 0) | 0;
      mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i3 | 0);
      i6 = i5;
      i3 = i5;
     } else i6 = i3;
     HEAP8[i6 + i9 >> 0] = i7;
     i5 = HEAP32[i11 >> 2] | 0;
     if (i5 >>> 0 >= i8 >>> 0) {
      i4 = i1;
      i1 = i14;
      break;
     } else {
      i9 = i2;
      i2 = i7;
     }
    }
   } else i10 = 9;
  }
  if ((i10 | 0) == 9) {
   i4 = i1;
   i3 = 0;
   i2 = 0;
   i1 = i14;
  }
  HEAP32[i13 >> 2] = i3;
  HEAP32[i12 >> 2] = i2;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i4 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, 0);
 STACKTOP = i15;
 return;
}

function __ZN24RingBufferMemoryFileData5WriteEyyPKv(i15, i1, i2, i16, i17, i18) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (HEAP8[i15 + 98 >> 0] | 0) {
  i17 = 0;
  i18 = 0;
  setTempRet0(i17 | 0);
  return i18 | 0;
 }
 L4 : do if ((i16 | 0) == 0 & (i17 | 0) == 0) i1 = 0; else {
  i7 = i15 + 20 | 0;
  i8 = i15 + 28 | 0;
  i9 = i15 + 32 | 0;
  i10 = i15 + 52 | 0;
  i11 = i15 + 64 | 0;
  i12 = i15 + 68 | 0;
  i13 = i15 + 56 | 0;
  i14 = i15 + 48 | 0;
  i1 = 0;
  i6 = 0;
  i2 = 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i4 = _i64Subtract(i16 | 0, i17 | 0, i6 | 0, i2 | 0) | 0;
   getTempRet0() | 0;
   i6 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
   i4 = i6 >>> 0 < i4 >>> 0 ? i6 : i4;
   if (!i4) break L4;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) {
    i2 = __ZN24RingBufferMemoryFileData16GetNewWriteBlockEv(i15) | 0;
    HEAP32[i9 >> 2] = i2;
    HEAP32[i8 >> 2] = 0;
    if (!i2) break L4; else i3 = 0;
   }
   _memcpy(i2 + i3 | 0, i18 + i1 | 0, i4 | 0) | 0;
   i6 = i4 + i1 | 0;
   i1 = (HEAP32[i8 >> 2] | 0) + i4 | 0;
   HEAP32[i8 >> 2] = i1;
   if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
    i2 = HEAP32[i11 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i12 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i12 >> 2] = i1;
      HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i10 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i3;
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i9 >> 2];
    HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP32[i8 >> 2] | 0);
    HEAP32[i9 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
    i3 = 0;
   } else i3 = i1;
   if (!(0 < i17 >>> 0 | 0 == (i17 | 0) & i6 >>> 0 < i16 >>> 0)) {
    i1 = i6;
    break;
   } else {
    i1 = i6;
    i2 = 0;
   }
  }
 } while (0);
 i17 = 0;
 i18 = i1;
 setTempRet0(i17 | 0);
 return i18 | 0;
}

function __ZNK5physx17ConvexMeshBuilder4saveERNS_14PxOutputStreamEb(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 if (!(__ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE(67, 86, 88, 77, 13, i5, i6) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(0, i5, i6);
 i1 = i7 + 132 | 0;
 if (!(__ZNK5physx17ConvexHullBuilder4SaveERNS_14PxOutputStreamEb(i1, i6, i5) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(0.0), i5, i6);
 i3 = i7 + 16 | 0;
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i3 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 20 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 24 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 28 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 32 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 36 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 88 >> 2]), i5, i6);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i7 + 92 | 0, 9, i5, i6);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i7 + 40 | 0, 3, i5, i6);
 i2 = i7 + 84 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(-1.0), i5, i6); else {
  __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(1.0), i5, i6);
  __ZN5physx20BigConvexDataBuilderC2EPKNS_2Gu14ConvexHullDataEPNS_13BigConvexDataEPKNS_6PxVec3E(i4, i3, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEbjPKNS_16HullTriangleDataE(i4, i6, i5, HEAP32[i7 + 164 >> 2] | 0, HEAP32[i7 + 168 >> 2] | 0) | 0;
 }
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 64 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 68 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 72 >> 2]), i5, i6);
 __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(Math_fround(HEAPF32[i7 + 76 >> 2]), i5, i6);
 i7 = 1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx20PxsParticleSystemSimC2EPNS_10PxsContextEj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = gb + 109916 + 8;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 __ZN5physx16PxsFluidDynamicsC2ERNS_20PxsParticleSystemSimE(i3 + 80 | 0, i3);
 __ZN5physx17PxsFluidCollisionC2ERNS_20PxsParticleSystemSimE(i3 + 624 | 0, i3);
 HEAP32[i3 + 1124 >> 2] = i2;
 i2 = i3 + 1128 | 0;
 HEAP16[i3 + 1132 >> 1] = -1;
 HEAP16[i3 + 1134 >> 1] = 0;
 HEAP32[i3 + 1136 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1140 >> 2] = 0;
 HEAP32[i3 + 1144 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147168 + 8;
 HEAP32[i3 + 1148 >> 2] = i3;
 HEAP32[i3 + 1152 >> 2] = gb + 769219;
 i2 = i3 + 1156 | 0;
 HEAP16[i3 + 1160 >> 1] = -1;
 HEAP16[i3 + 1162 >> 1] = 0;
 HEAP32[i3 + 1164 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1168 >> 2] = 0;
 HEAP32[i3 + 1172 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147212 + 8;
 HEAP32[i3 + 1176 >> 2] = i3;
 HEAP32[i3 + 1180 >> 2] = gb + 769259;
 i2 = i3 + 1184 | 0;
 HEAP16[i3 + 1188 >> 1] = -1;
 HEAP16[i3 + 1190 >> 1] = 0;
 HEAP32[i3 + 1192 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1196 >> 2] = 0;
 HEAP32[i3 + 1200 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147256 + 8;
 HEAP32[i3 + 1204 >> 2] = i3;
 HEAP32[i3 + 1208 >> 2] = gb + 769305;
 i2 = i3 + 1212 | 0;
 HEAP16[i3 + 1216 >> 1] = -1;
 HEAP16[i3 + 1218 >> 1] = 0;
 HEAP32[i3 + 1220 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1224 >> 2] = 0;
 HEAP32[i3 + 1228 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147300 + 8;
 HEAP32[i3 + 1232 >> 2] = i3;
 HEAP32[i3 + 1236 >> 2] = gb + 769341;
 i2 = i3 + 1240 | 0;
 HEAP16[i3 + 1244 >> 1] = -1;
 HEAP16[i3 + 1246 >> 1] = 0;
 HEAP32[i3 + 1248 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1252 >> 2] = 0;
 HEAP32[i3 + 1256 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147344 + 8;
 HEAP32[i3 + 1260 >> 2] = i3;
 HEAP32[i3 + 1264 >> 2] = gb + 769378;
 i2 = i3 + 1268 | 0;
 HEAP16[i3 + 1272 >> 1] = -1;
 HEAP16[i3 + 1274 >> 1] = 0;
 HEAP32[i3 + 1276 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 1280 >> 2] = 0;
 HEAP32[i3 + 1284 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 147388 + 8;
 HEAP32[i3 + 1288 >> 2] = i3;
 HEAP32[i3 + 1292 >> 2] = gb + 769421;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEclILj547ES3_NS3_4EnumES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 835009 | 0) {
  i2 = gb + 835009 | 0;
  i3 = gb + 167008 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN19AssetBundleManifest8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i6 = i9 + 56 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 + 52 >> 2] | 0;
 i5 = i4 - i1 >> 3;
 HEAP32[i8 >> 2] = i5;
 i12 = i10 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i9 + 52 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1 + 4 | 0, i10);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i2 = i9 + 64 | 0;
 i7 = i9 + 68 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i4 - i1 >> 2;
 HEAP32[i8 >> 2] = i3;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i8, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i12 = i9 + 32 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i10, i12, 0);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i12 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i12 = i9 + 32 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i10, i12, 0);
 STACKTOP = i13;
 return;
}

function __ZN13SliderJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 118 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 100 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 117 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 108 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13MonoBehaviour7SetNameEPKc(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
  STACKTOP = i12;
  return;
 }
 i8 = i9 + 40 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = 6;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i4 = 8;
  }
 } else i4 = 6;
 if ((i4 | 0) == 6) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i4 = 8;
 }
 if ((i4 | 0) == 8) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i11 + 11 | 0;
 do if ((i8 | 0) != (i11 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i7 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
  i3 = i8 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 48 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 44 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 44 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i9 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 }
 STACKTOP = i12;
 return;
}

function __Z29ConvertCollision2DToScriptingP11Collision2D(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i10 = HEAP8[i9 + 71 >> 0] | 0;
 i1 = i9 + 68 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 >> 2] | 0) | 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 8 >> 2] | 0) | 0;
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 12 >> 2] | 0) | 0;
  i8 = i9 + 56 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
 } else {
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 4 >> 2] | 0) | 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 12 >> 2] | 0) | 0;
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i9 + 8 >> 2] | 0) | 0;
  f14 = Math_fround(-Math_fround(HEAPF32[i9 + 56 >> 2]));
  f13 = Math_fround(-Math_fround(HEAPF32[i9 + 60 >> 2]));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
  i8 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i12 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 4 >> 2] | 0;
 i11 = i9 + 16 | 0;
 i12 = __Z19scripting_array_newP11Il2CppClassjj(i12, 24, HEAP32[i11 >> 2] | 0) | 0;
 i2 = i9 + 24 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i9 + 28 >> 2] | 0;
 } else {
  f13 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
  f14 = Math_fround(-Math_fround(HEAPF32[i9 + 28 >> 2]));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f14, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (HEAP32[i11 >> 2] | 0) {
  i1 = 0;
  do {
   i15 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i12, i1, 24) | 0;
   i16 = HEAP32[i9 + 32 + (i1 << 3) + 4 >> 2] | 0;
   HEAP32[i15 >> 2] = HEAP32[i9 + 32 + (i1 << 3) >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   HEAP32[i15 + 8 >> 2] = i2;
   HEAP32[i15 + 12 >> 2] = i3;
   HEAP32[i15 + 16 >> 2] = i6;
   HEAP32[i15 + 20 >> 2] = i4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 }
 i16 = _il2cpp_object_new(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) >> 2] | 0) | 0;
 HEAP32[i16 + 8 >> 2] = i5;
 HEAP32[i16 + 12 >> 2] = i6;
 HEAP32[i16 + 16 >> 2] = i12;
 i15 = i16 + 20 | 0;
 HEAP32[i15 >> 2] = i7;
 HEAP32[i15 + 4 >> 2] = i8;
 HEAP8[i16 + 28 >> 0] = i10;
 return i16 | 0;
}

function _UNITY_FT_Bitmap_Copy(i1, i7, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 HEAP32[i13 >> 2] = 0;
 if (!i1) {
  i13 = 33;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!((i7 | 0) != 0 & (i11 | 0) != 0)) {
  i13 = 6;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((i7 | 0) == (i11 | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 i9 = i3 >> 31 | 1;
 i2 = i11 + 8 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i10 = i5 >> 31 | 1;
 i8 = i7 + 12 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  if ((i9 | 0) == (i10 | 0)) {
   i13 = 0;
   STACKTOP = i14;
   return i13 | 0;
  }
  HEAP32[i2 >> 2] = 0 - (HEAP32[i2 >> 2] | 0);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i12 = (i3 | 0) < 0 ? 0 - i3 | 0 : i3;
 i6 = Math_imul(HEAP32[i7 >> 2] | 0, i12) | 0;
 i3 = i11 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i5 = _UNITY_ft_mem_qalloc(i4, i6, i13) | 0;
  HEAP32[i3 >> 2] = i5;
 } else {
  i1 = Math_imul(HEAP32[i11 >> 2] | 0, (i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0;
  if ((i1 | 0) == (i6 | 0)) i5 = i2; else {
   i5 = _UNITY_ft_mem_qrealloc(i4, 1, i1, i6, i2, i13) | 0;
   HEAP32[i3 >> 2] = i5;
  }
 }
 do if (!(HEAP32[i13 >> 2] | 0)) {
  HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i3 >> 2] = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i9 | 0) == (i10 | 0)) {
   _memcpy(i5 | 0, i2 | 0, i6 | 0) | 0;
   break;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   i4 = 0 - i12 | 0;
   i3 = i1;
   i1 = i5 + (Math_imul(i1 + -1 | 0, i12) | 0) | 0;
   while (1) {
    _memcpy(i1 | 0, i2 | 0, i12 | 0) | 0;
    i3 = i3 + -1 | 0;
    if (!i3) break; else {
     i2 = i2 + i12 | 0;
     i1 = i1 + i4 | 0;
    }
   }
  }
 } while (0);
 i13 = HEAP32[i13 >> 2] | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN15DirectorManager14ConnectionPool10CreateItemEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i14;
 i12 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63784 | 0, 16, gb + 582681 | 0, 684) | 0;
 i2 = i12 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i12 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i12 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i12 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i10 = i15;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i12 + 36 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i12 + 48 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 52 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 40 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i15, gb + 63664 | 0);
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i1;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 56 >> 2] = i7;
 i13 = 4 << i7;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i13 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i13;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i13 << 3, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 << 3, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i13;
  HEAP32[i2 >> 2] = i15;
  break;
 } while (0);
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i13 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i10 >> 2] = i13;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i13 << 3, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i15 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 << 3, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i15 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
  HEAP32[i10 >> 2] = i13;
  HEAP32[i8 >> 2] = i15;
  break;
 } while (0);
 HEAP32[i9 >> 2] = 0;
 i15 = i6 + 8 + (i7 << 2) | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 i15 = i6 + 28 + (i7 << 2) | 0;
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 STACKTOP = i14;
 return i12 | 0;
}

function __ZN14LineParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405221 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 16 | 0, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405237 | 0, gb + 1034188 | 0, i7, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 108 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405248 | 0, gb + 1033990 | 0, i7, 0);
 __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405262 | 0, i7, i1 + 180 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405280 | 0, i7, i1 + 184 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = i1 + 188 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405295 | 0, i7, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i1 = i1 + 192 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619278 | 0, i7, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN12_GLOBAL__N_116CollectionSorter7processERN5physx6PxBaseE(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i7 = i8 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i5 = i6;
  i5 = i5 + ~(i5 << 15) | 0;
  i5 = (i5 >>> 10 ^ i5) * 9 | 0;
  i5 = i5 >>> 6 ^ i5;
  i5 = i5 + ~(i5 << 11) | 0;
  i1 = HEAP32[(HEAP32[i8 + 16 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i8 + 8 >> 2] | 0;
   i3 = i8 + 12 | 0;
   while (1) {
    i2 = i5 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i10 = HEAP32[i8 + 76 >> 2] | 0;
    i4 = i10 + 16 | 0;
    i1 = i5 + (i1 << 3) + 4 | 0;
    i2 = i10 + 20 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((HEAP32[i10 + 24 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i1) | 0;
     break;
    }
   }
  }
 } while (0);
 if (!(HEAP8[i8 + 80 >> 0] | 0)) return;
 if ((HEAP16[i6 + 4 >> 1] | 0) != 15) return;
 i4 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 224 >> 2] | 0, i6 | 0) | 0;
 i6 = HEAP32[i8 + 76 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) return;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) return;
 i2 = i4;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i2 = HEAP32[(HEAP32[i8 + 16 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) >> 2] | 0;
 if ((i2 | 0) == -1) return;
 i5 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = i8 + 12 | 0;
 while (1) {
  i1 = i5 + (i2 << 3) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   i9 = 22;
   break;
  }
 }
 if ((i9 | 0) == 22) return;
 if (!i1) return;
 i4 = i6 + 16 | 0;
 i2 = i5 + (i2 << 3) + 4 | 0;
 i3 = i6 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 24 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i4, i2) | 0;
  return;
 }
}

function __ZNK8Animator23GetAnimationSetBindingsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i1 + 108 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 15; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 15; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 17;
  }
 }
 if ((i7 | 0) == 15) i7 = 17;
 if ((i7 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN9Heightmap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i7, i6 + 4 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 24 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 44 | 0, 0);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 88 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 932253 | 0, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 88 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 932253 | 0, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN12_GLOBAL__N_115StringTableImplD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i10 >> 2] = gb + 148508 + 8;
 i9 = i10 + 36 | 0;
 i7 = i10 + 32 | 0;
 L1 : do if (!(HEAP32[i9 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i10 + 40 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L1;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i10 + 4 | 0;
 i6 = i10 + 24 | 0;
 i8 = i10 + 28 | 0;
 i4 = i10 + 40 | 0;
 L8 : while (1) {
  do {
   if ((i1 | 0) == -1) break L8;
   i3 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L8;
   }
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L8;
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i10 + 56 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   _memset(HEAP32[i7 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i4 = i2 + -1 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i4) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i8 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i10 + 48 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 HEAP32[i10 + 116 >> 2] = gb + 148580 + 8;
 i1 = HEAP32[i10 + 128 >> 2] | 0;
 if (i1 | 0) {
  i9 = HEAP32[i10 + 120 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 }
 HEAP32[i10 + 64 >> 2] = gb + 148564 + 8;
 i1 = HEAP32[i10 + 76 >> 2] | 0;
 if (i1 | 0) {
  i9 = HEAP32[i10 + 68 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 }
 HEAP32[i10 + 8 >> 2] = gb + 148548 + 8;
 i1 = HEAP32[i10 + 20 >> 2] | 0;
 if (!i1) return;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 return;
}

function __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 - i1 | 0;
 i3 = ((i9 | 0) / 204 | 0) + 1 | 0;
 if ((i9 | 0) < -204) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 204 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 2147483647;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 204 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i4 + (((i2 - i1 | 0) / 204 | 0) * 204 | 0) | 0;
 i5 = i2;
 i8 = i4 + (i3 * 204 | 0) | 0;
 __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i2, i6);
 i7 = i2 + 204 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i6 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -204 | 0;
   __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i2 + -204 | 0, i1);
   i2 = i3 + -204 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i9 >> 2] = i8;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -204 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -192 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i9 = (i4 - i5 | 0) / 12 | 0;
 i6 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i2 = i5;
 i8 = i10;
 i12 = i4;
 if (i9 >>> 0 <= ((i1 - i10 | 0) / 12 | 0) >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 12 | 0;
  i3 = i9 >>> 0 > i1 >>> 0;
  i1 = i3 ? i2 + (i1 * 12 | 0) | 0 : i4;
  i2 = i1 - i5 | 0;
  if (i2 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i8 + (((i2 | 0) / 12 | 0) * 12 | 0) | 0;
  if (!i3) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = i1 + 12 | 0;
   i2 = i2 + 12 | 0;
  } while ((i1 | 0) != (i3 | 0));
  HEAP32[i6 >> 2] = i2;
  return;
 }
 i4 = i10;
 if (i10) {
  i1 = i11 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i8 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -12 - i10 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i4);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if (i9 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i10 = (i1 - i3 | 0) / 12 | 0;
 i3 = i10 << 1;
 i3 = i10 >>> 0 < 178956970 ? (i3 >>> 0 < i9 >>> 0 ? i9 : i3) : 357913941;
 if (i3 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = __Znwj(i3 * 12 | 0) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i1 + (i3 * 12 | 0);
 if ((i2 | 0) == (i12 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i2 + 12 | 0;
  i1 = i1 + 12 | 0;
 } while ((i2 | 0) != (i12 | 0));
 HEAP32[i4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 48 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 48 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx17PxcNpMemBlockPool4initEjj(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i12 + 4 | 0;
 HEAP32[i11 + 144 >> 2] = i1;
 HEAP32[i11 + 148 >> 2] = i10;
 i1 = i10 >>> 0 < 64 ? 64 : i10;
 if ((HEAP32[i11 + 12 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i11 + 4 | 0, i1);
 if ((HEAP32[i11 + 108 >> 2] & 2147483632) >>> 0 < 16) __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i11 + 100 | 0, 16);
 if ((HEAP32[i11 + 48 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i11 + 40 | 0, i1);
 if ((HEAP32[i11 + 60 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i11 + 52 | 0, i1);
 if ((HEAP32[i11 + 72 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i11 + 64 | 0, i1);
 if ((HEAP32[i11 + 84 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i11 + 76 | 0, i1);
 i6 = i11 + 112 | 0;
 i7 = i11 + 120 | 0;
 if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i1);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 i1 = HEAP32[i11 + 152 >> 2] | 0;
 if (i1 >>> 0 >= i10 >>> 0) {
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 }
 i4 = i11 + 116 | 0;
 i5 = i11 + 140 | 0;
 do {
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, 16384, gb + 703366 | 0, 83) | 0;
  HEAP32[i8 >> 2] = i2;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   HEAP32[i4 >> 2] = i3 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i8) | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i11 = HEAP32[i11 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN5physx10NpMaterial17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 128 | 0;
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i7 >> 2] = HEAP32[gb + 122820 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 122820 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 122820 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 122820 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[gb + 122820 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[gb + 122820 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[gb + 122820 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[gb + 122820 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, 32) | 0;
 HEAP32[i6 >> 2] = gb + 754681;
 HEAP32[i6 + 4 >> 2] = gb + 827530;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 64;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 1;
 HEAP32[i6 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754681;
 HEAP32[i5 + 4 >> 2] = gb + 752142;
 HEAP32[i5 + 8 >> 2] = 12;
 HEAP32[i5 + 12 >> 2] = 64;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122884 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122884 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122884 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122884 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122884 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122884 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122884 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122884 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN14SpriteRenderer8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i2 = i5 + 340 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 429505 | 0, gb + 450632 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6SpriteE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 __ZN14SafeBinaryRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(i7, i5 + 344 | 0, gb + 946541 | 0, 0);
 i3 = i5 + 360 | 0;
 i4 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 429514 | 0, i4, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 361 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 429522 | 0, i4, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN12TreeInstance8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z28ScriptingStructArrayToVectorI9HumanBone13MonoHumanBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i4 = HEAP32[i11 >> 2] | 0;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i8 + 4 | 0;
  i6 = i8 + 4 | 0;
  do {
   i2 = i1 + -76 | 0;
   HEAP32[i9 >> 2] = i2;
   i3 = i1 + -60 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -48 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i5 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i1 + -64 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
   }
   i1 = HEAP32[i9 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i10) | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = (i3 - i2 | 0) / 76 | 0;
 if (i7 >>> 0 > i1 >>> 0) __ZNSt3__26vectorI9HumanBoneNS_9allocatorIS1_EEE8__appendEj(i11, i7 - i1 | 0); else if (i7 >>> 0 < i1 >>> 0) {
  i4 = i2 + (i7 * 76 | 0) | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i5 = i8 + 4 | 0;
   i6 = i8 + 4 | 0;
   do {
    i1 = i3 + -76 | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = i3 + -60 | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i14 = HEAP32[i3 + -48 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i5 >> 2] = i14;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i14 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i3 + -64 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i14, i8);
    }
    i3 = HEAP32[i9 >> 2] | 0;
   } while ((i3 | 0) != (i4 | 0));
  }
 }
 if ((i7 | 0) > 0) i1 = 0; else {
  STACKTOP = i13;
  return;
 }
 do {
  i14 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i10, i1, 52) | 0;
  mftCall_vii(i12 | 0, i14 | 0, (HEAP32[i11 >> 2] | 0) + (i1 * 76 | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i13;
 return;
}

function __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i7, i2, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 426246 | 0, HEAP32[gb + 37300 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i6 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i1 = i5 + 16 | 0;
  i2 = i3 + 16 | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i5 + 48 >> 2] = HEAP32[i3 + 48 >> 2];
  HEAP32[i5 + 52 >> 2] = HEAP32[i3 + 52 >> 2];
  HEAP32[i5 + 56 >> 2] = HEAP32[i3 + 56 >> 2];
  i1 = i5 + 60 | 0;
  i2 = i3 + 60 | 0;
  i4 = i1 + 48 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  i3 = i3 + 108 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 108 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj8ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 757377 | 0) {
  i2 = gb + 757377 | 0;
  i3 = gb + 89304 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj7ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i6 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = mftCall_ii(i7 | 0, HEAP32[i8 + 8 >> 2] | 0) | 0;
 if (gb + 757377 | 0) {
  i2 = gb + 757377 | 0;
  i3 = gb + 89304 | 0;
  do {
   if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i2 | 0);
   i3 = i3 + 8 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i9;
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) return i10 | 0;
 i8 = HEAP8[i2 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i5 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
 i8 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255;
 i9 = i5 + i8 | 0;
 L4 : do if (!i8) {
  i1 = i3;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
 } else {
  i1 = i10;
  while (1) {
   i2 = i3;
   L9 : while (1) {
    i4 = i2 + 16 | 0;
    i3 = HEAP8[i4 + 11 >> 0] | 0;
    i6 = i3 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
    i3 = i4 + (i6 ? HEAP32[i2 + 20 >> 2] | 0 : i3 & 255) | 0;
    i6 = i5;
    while (1) {
     if ((i4 | 0) == (i3 | 0)) break;
     i8 = HEAP8[i4 >> 0] | 0;
     i11 = HEAP8[i6 >> 0] | 0;
     i7 = i8 & 255;
     i7 = ((i8 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255;
     i8 = i11 & 255;
     i8 = ((i11 + -65 & 255) < 26 ? i8 + 32 | 0 : i8) & 255;
     if ((i7 & 255) < (i8 & 255)) break;
     if ((i8 & 255) < (i7 & 255)) break L9;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i9 | 0)) break L9; else i4 = i4 + 1 | 0;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L4;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
 } while (0);
 if ((i1 | 0) == (i10 | 0)) {
  i11 = i10;
  return i11 | 0;
 }
 i2 = i1 + 16 | 0;
 i11 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i11 << 24 >> 24 < 0;
 i2 = i6 ? HEAP32[i2 >> 2] | 0 : i2;
 i11 = i6 ? HEAP32[i1 + 20 >> 2] | 0 : i11 & 255;
 i6 = i2 + i11 | 0;
 if (!i11) {
  i11 = i1;
  return i11 | 0;
 }
 while (1) {
  if ((i5 | 0) == (i9 | 0)) {
   i1 = i10;
   i2 = 18;
   break;
  }
  i4 = HEAP8[i5 >> 0] | 0;
  i11 = HEAP8[i2 >> 0] | 0;
  i3 = i4 & 255;
  i3 = ((i4 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255;
  i4 = i11 & 255;
  i4 = ((i11 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
  if ((i3 & 255) < (i4 & 255)) {
   i1 = i10;
   i2 = 18;
   break;
  }
  if ((i4 & 255) < (i3 & 255)) {
   i2 = 18;
   break;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i2 = 18;
   break;
  } else i5 = i5 + 1 | 0;
 }
 if ((i2 | 0) == 18) return i1 | 0;
 return 0;
}

function __Z52Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionAllRK3Rayfi(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10 + 8 | 0;
 i5 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i4 = i9 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i5);
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 do if (!(__ZN16Physics2DManager21GetRayIntersectionAllERK8Vector3fS2_fiPK10Collider2DP13dynamic_arrayI12RaycastHit2DLj4EE(__Z19GetPhysicsManager2Dv() | 0, i1, i1 + 12 | 0, f2, i3, 0, i9) | 0)) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0, 4, 0) | 0; else {
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[(__Z28GetPhysics2DScriptingClassesv() | 0) + 24 >> 2] | 0;
  if (!i6) {
   i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, 0) | 0;
   break;
  }
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 36, i6) | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 36) | 0;
  i4 = 0;
  while (1) {
   i13 = i3;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i5;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i11 = i3 + 8 | 0;
   i12 = HEAP32[i11 + 4 >> 2] | 0;
   i13 = i5 + 8 | 0;
   HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i13 + 4 >> 2] = i12;
   i13 = i3 + 16 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i5 + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i5 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   HEAP32[i5 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
   HEAP32[i5 + 32 >> 2] = HEAP32[i3 + 32 >> 2];
   __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i5);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i6 | 0)) break; else {
    i5 = i5 + 36 | 0;
    i3 = i3 + 36 | 0;
   }
  }
 } while (0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteDoubleEd(i13, d1) {
 i13 = i13 | 0;
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 4 | 0;
 i4 = i14;
 i7 = i14 + 8 | 0;
 if (d1 == 0.0) {
  HEAP8[i7 >> 0] = 48;
  HEAP8[i7 + 1 >> 0] = 46;
  HEAP8[i7 + 2 >> 0] = 48;
  i12 = i7 + 3 | 0;
 } else {
  if (d1 < 0.0) {
   HEAP8[i7 >> 0] = 45;
   i2 = i7 + 1 | 0;
   d1 = -d1;
  } else i2 = i7;
  __ZN9rapidjson8internal6Grisu2EdPcPiS2_(d1, i2, i3, i4);
  i12 = __ZN9rapidjson8internal8PrettifyEPcii(i2, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + (i12 - i7) | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 do if ((i6 & 2147483647) >>> 0 < i4 >>> 0) if ((i6 | 0) > -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i4, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i2 >> 2] = i11;
  break;
 } while (0);
 if ((i7 | 0) == (i12 | 0)) {
  STACKTOP = i14;
  return 1;
 } else i2 = i7;
 do {
  i4 = HEAP32[i13 >> 2] | 0;
  i5 = HEAP8[i2 >> 0] | 0;
  i6 = i4 + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i9 = i4 + 16 | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  i11 = i10 & 2147483647;
  do if (i8 >>> 0 > i11 >>> 0) {
   i3 = i10 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i11 >>> 0 < i3 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i9 >> 2] = i3;
    HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
    HEAP32[i9 >> 2] = i3;
    HEAP32[i4 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i8;
  HEAP8[(HEAP32[i4 >> 2] | 0) + i7 >> 0] = i5;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i12 | 0));
 STACKTOP = i14;
 return 1;
}

function __ZN9JSONWrite8TransferIsEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = HEAP16[i11 >> 1] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i8 = i14 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 5638;
 i8 = i11 << 16 >> 16;
 i9 = i14;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = ((i8 | 0) < 0) << 31 >> 31;
 if (i11 << 16 >> 16 > -1) HEAP32[i3 >> 2] = 15878;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i10, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i2 + 16 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i13, i12, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i7 = i10 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i5 = i1 << 24 >> 24 < 0;
 i9 = i10 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i6 = i1 & 255;
 i4 = i5 ? i3 : i6;
 do if (i2 >>> 0 > i4 >>> 0) {
  i4 = i2 - i4 | 0;
  if (!i4) i8 = 17; else {
   if (i5) i2 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i4 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i10, i2, i4 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i7 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
   _memset(i2 + i3 | 0, 1, i4 | 0) | 0;
   i1 = i3 + i4 | 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i9 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
   i8 = 17;
  }
 } else if (i5) {
  HEAP8[(HEAP32[i10 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i9 >> 2] = i2;
  i8 = 17;
  break;
 } else {
  HEAP8[i10 + i2 >> 0] = 0;
  i2 = i2 & 255;
  HEAP8[i7 >> 0] = i2;
  i1 = i10;
  break;
 } while (0);
 if ((i8 | 0) == 17) {
  i1 = i10;
  i2 = HEAP8[i7 >> 0] | 0;
 }
 i4 = i2 << 24 >> 24 < 0;
 i1 = i4 ? HEAP32[i10 >> 2] | 0 : i1;
 i10 = i4 ? HEAP32[i9 >> 2] | 0 : i2 & 255;
 i4 = i1 + i10 | 0;
 if (!i10) {
  STACKTOP = i14;
  return;
 } else i3 = i1;
 do {
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i1 + 1 | 0;
  if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i13, i12, 1);
   i1 = HEAP8[i12 >> 0] | 0;
  } else {
   i1 = HEAP8[i1 >> 0] | 0;
   HEAP8[i12 >> 0] = i1;
   HEAP32[i13 >> 2] = i2;
  }
  HEAP8[i3 >> 0] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i14;
 return;
}

function __ZN16b2PrismaticJointC2EPK19b2PrismaticJointDef(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, i8 = 0, i9 = 0, f10 = f0;
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 56 >> 2] = 0;
 HEAP8[i6 + 61 >> 0] = HEAP8[i7 + 16 >> 0] | 0;
 HEAP8[i6 + 60 >> 0] = 0;
 HEAP32[i6 + 64 >> 2] = HEAP32[i7 + 4 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 152424 + 8;
 i3 = i6 + 84 | 0;
 i8 = i7 + 20 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i6 + 68 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i7 + 28 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i6 + 76 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 i8 = i7 + 36 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i8;
 f4 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f4 * f4);
 f2 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(Math_sqrt(Math_fround(f5 + Math_fround(f2 * f2))));
 if (!(f5 < Math_fround(1.1920929e-07))) {
  f10 = Math_fround(Math_fround(1.0) / f5);
  f5 = Math_fround(f4 * f10);
  HEAPF32[i3 >> 2] = f5;
  f2 = Math_fround(f2 * f10);
  HEAPF32[i6 + 88 >> 2] = f2;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAPF32[i6 + 92 >> 2] = Math_fround(-f2);
 HEAP32[i6 + 96 >> 2] = i1;
 HEAP32[i6 + 100 >> 2] = HEAP32[i7 + 44 >> 2];
 i9 = i6 + 104 | 0;
 HEAPF32[i6 + 252 >> 2] = Math_fround(0.0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i6 + 120 >> 2] = HEAP32[i7 + 52 >> 2];
 HEAP32[i6 + 124 >> 2] = HEAP32[i7 + 56 >> 2];
 HEAP32[i6 + 128 >> 2] = HEAP32[i7 + 64 >> 2];
 HEAP32[i6 + 132 >> 2] = HEAP32[i7 + 68 >> 2];
 HEAP8[i6 + 136 >> 0] = HEAP8[i7 + 48 >> 0] | 0;
 HEAP8[i6 + 137 >> 0] = HEAP8[i7 + 60 >> 0] | 0;
 HEAP32[i6 + 140 >> 2] = 0;
 i9 = i6 + 184 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 return;
}

function __ZN15DetailPrototypeaSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 i4 = HEAP32[i2 + 40 >> 2] | 0;
 i5 = HEAP32[i2 + 44 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = i3;
 HEAP32[i1 + 40 >> 2] = i4;
 HEAP32[i1 + 44 >> 2] = i5;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 i4 = HEAP32[i2 + 56 >> 2] | 0;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = i5;
 HEAP32[i1 + 56 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = i3;
 i3 = i1 + 64 | 0;
 i4 = i2 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 if ((i1 | 0) == (i2 | 0)) return i1 | 0;
 __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 76 | 0, HEAP32[i2 + 76 >> 2] | 0, HEAP32[i2 + 80 >> 2] | 0);
 __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 88 | 0, HEAP32[i2 + 88 >> 2] | 0, HEAP32[i2 + 92 >> 2] | 0);
 __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 100 | 0, HEAP32[i2 + 100 >> 2] | 0, HEAP32[i2 + 104 >> 2] | 0);
 __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1 + 112 | 0, HEAP32[i2 + 112 >> 2] | 0, HEAP32[i2 + 116 >> 2] | 0);
 __ZNSt3__26vectorItNS_9allocatorItEEE6assignIPtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i1 + 124 | 0, HEAP32[i2 + 124 >> 2] | 0, HEAP32[i2 + 128 >> 2] | 0);
 return i1 | 0;
}

function __ZN11NoiseModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83480 + 8;
 i1 = i2 + 1852 | 0;
 if ((HEAP32[i2 + 1868 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1856 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1764 | 0;
 if ((HEAP32[i2 + 1780 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1768 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1588 | 0;
 if ((HEAP32[i2 + 1604 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1592 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1500 | 0;
 if ((HEAP32[i2 + 1516 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1504 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1324 | 0;
 if ((HEAP32[i2 + 1340 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1328 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1236 | 0;
 if ((HEAP32[i2 + 1252 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1240 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 1056 | 0;
 if ((HEAP32[i2 + 1072 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1060 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 968 | 0;
 if ((HEAP32[i2 + 984 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 972 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN9JSONWrite8TransferIaEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = HEAP8[i11 >> 0] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i8 = i14 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 5638;
 i8 = i11 << 24 >> 24;
 i9 = i14;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = ((i8 | 0) < 0) << 31 >> 31;
 if (i11 << 24 >> 24 > -1) HEAP32[i3 >> 2] = 15878;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN11Rigidbody2D19RecalculateContactsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i3 = i10;
 i7 = i10 + 16 | 0;
 if ((HEAP16[gb + 1457884 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457884 | 0, i1);
  i6 = gb + 1457884 | 0;
 } else i6 = 0;
 i5 = i2 + 92 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i9 = gb + 64016 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = i3;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = i8;
  HEAP32[i7 >> 2] = 0;
  i4 = i7 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i8 = i7 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i7 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i3);
  i11 = i1;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i3 = i9;
  HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  do if (__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i2, i7) | 0) {
   if (HEAP32[i4 >> 2] | 0) {
    i2 = i2 + 68 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    do {
     i3 = HEAP32[i1 >> 2] | 0;
     if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) if (!(HEAP8[i3 + 53 >> 0] | 0)) if (HEAP32[i3 + 72 >> 2] | 0) {
      __ZN10Collider2D19RecalculateContactsEv(i3);
      if ((HEAP32[i2 >> 2] | 0) == 2) __ZN10Collider2D19WakeAllBodyContactsEv(i3);
     }
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != ((HEAP32[i7 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    i2 = i1 + 4 | 0;
    i3 = HEAPU16[i2 >> 1] | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     HEAP16[i2 >> 1] = i3 & 65533;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
     i11 = i1 + 64 | 0;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i11 + 4 >> 2] = 0;
     HEAP32[i11 + 8 >> 2] = 0;
     HEAP32[i11 + 12 >> 2] = 0;
     HEAP32[i11 + 16 >> 2] = 0;
     HEAP32[i11 + 20 >> 2] = 0;
     break;
    }
    if (!(i3 & 2)) {
     HEAP16[i2 >> 1] = i3 | 2;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    }
   }
  } while (0);
  if ((HEAP32[i8 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9);
   HEAP32[i7 >> 2] = 0;
  }
 }
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i10;
 return;
}

function __ZN11ForceModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff(i1, i5, i3, f2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i8 + 104 | 0;
 i12 = i8 + 96 | 0;
 i4 = i8 + 88 | 0;
 i6 = i8 + 24 | 0;
 i7 = i8;
 __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv(i13, i1 + 8 | 0);
 __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv(i12, i1 + 272 | 0);
 __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv(i4, i1 + 536 | 0);
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f10 = Math_fround(Math_fround(f10 * f2) * f2);
 f11 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2) * f2);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(f9 * f2) * f2);
 HEAPF32[i5 + 4 >> 2] = f10;
 HEAPF32[i5 + 8 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f10 = Math_fround(Math_fround(f10 * f2) * f2);
 f9 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f2) * f2);
 HEAPF32[i5 + 12 >> 2] = Math_fround(Math_fround(f11 * f2) * f2);
 HEAPF32[i5 + 16 >> 2] = f10;
 HEAPF32[i5 + 20 >> 2] = f9;
 if (!(HEAP8[i1 + 800 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i6;
 i1 = i3;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 HEAP32[i6 + 48 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i7 + 12 >> 2] = f9;
 HEAPF32[i7 + 16 >> 2] = f10;
 HEAPF32[i7 + 20 >> 2] = f11;
 __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i5, i6, i7);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 STACKTOP = i8;
 return;
}

function __ZNK5physx7NpCloth14getWorldBoundsEf(i10, i1, f11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13;
 i9 = i13 + 8 | 0;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i12 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i12 = 3; else i12 = 4;
   break;
  }
 default:
  i12 = 3;
 }
 if ((i12 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore14getWorldBoundsEv(i9, i1 + 32 | 0);
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 } else if ((i12 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1046, gb + 698755 | 0, i2);
  HEAP32[i9 >> 2] = 2122317823;
  HEAP32[i9 + 4 >> 2] = 2122317823;
  HEAP32[i9 + 8 >> 2] = 2122317823;
  HEAP32[i9 + 12 >> 2] = -25165825;
  HEAP32[i9 + 16 >> 2] = -25165825;
  HEAP32[i9 + 20 >> 2] = -25165825;
  f4 = Math_fround(8507058669999999534545717.0e13);
  f5 = Math_fround(-8507058669999999534545717.0e13);
  f6 = Math_fround(8507058669999999534545717.0e13);
  f7 = Math_fround(-8507058669999999534545717.0e13);
  f8 = Math_fround(8507058669999999534545717.0e13);
  f3 = Math_fround(-8507058669999999534545717.0e13);
 }
 f14 = Math_fround(Math_fround(f4 + f5) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f6 + f7) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f8 + f3) * Math_fround(.5));
 f4 = Math_fround(Math_fround(Math_fround(f5 - f4) * Math_fround(.5)) * f11);
 f16 = Math_fround(Math_fround(Math_fround(f7 - f6) * Math_fround(.5)) * f11);
 f11 = Math_fround(Math_fround(Math_fround(f3 - f8) * Math_fround(.5)) * f11);
 f5 = Math_fround(f17 - f16);
 f6 = Math_fround(f15 - f11);
 f7 = Math_fround(f14 + f4);
 f8 = Math_fround(f17 + f16);
 f11 = Math_fround(f15 + f11);
 HEAPF32[i10 >> 2] = Math_fround(f14 - f4);
 HEAPF32[i10 + 4 >> 2] = f5;
 HEAPF32[i10 + 8 >> 2] = f6;
 HEAPF32[i10 + 12 >> 2] = f7;
 HEAPF32[i10 + 16 >> 2] = f8;
 HEAPF32[i10 + 20 >> 2] = f11;
 STACKTOP = i13;
 return;
}

function __ZN7b2World12DestroyJointEP7b2Joint(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 if (HEAP32[i7 + 102868 >> 2] & 2 | 0) return;
 i9 = HEAP8[i8 + 61 >> 0] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i1 = i8 + 12 | 0;
 if (i3 | 0) HEAP32[i3 + 12 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 + 8 >> 2] = i3;
 i1 = i7 + 102960 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) HEAP32[i1 >> 2] = i2;
 i6 = HEAP32[i8 + 48 >> 2] | 0;
 i5 = HEAP32[i8 + 52 >> 2] | 0;
 i1 = i6 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
  i4 = i6 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = i5 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
  i4 = i5 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
 }
 i3 = i8 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i8 + 28 | 0;
 if (i1 | 0) HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
 i4 = HEAP32[i2 >> 2] | 0;
 if (i4 | 0) HEAP32[i4 + 8 >> 2] = i1;
 i1 = i6 + 108 | 0;
 if ((i8 + 16 | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i8 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i8 + 44 | 0;
 if (i1 | 0) HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
 i4 = HEAP32[i2 >> 2] | 0;
 if (i4 | 0) HEAP32[i4 + 8 >> 2] = i1;
 i1 = i5 + 108 | 0;
 if ((i8 + 32 | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN7b2Joint7DestroyEPS_P16b2BlockAllocator(i8, i7);
 i8 = i7 + 102968 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (i9 << 24 >> 24) return;
 i1 = HEAP32[i5 + 112 >> 2] | 0;
 if (!i1) return;
 do {
  if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) {
   i9 = (HEAP32[i1 + 4 >> 2] | 0) + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 8;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Gu31checkOverlapCapsule_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 48 | 0;
 i7 = i4 + 36 | 0;
 i9 = i4 + 8 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(f6 * Math_fround(2.0));
 f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(f11 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f6 * f15) + Math_fround(Math_fround(f11 * f16) + Math_fround(-1.0)));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f6 * f16);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f15 * f12));
 f12 = Math_fround(Math_fround(f15 * f6) - Math_fround(f16 * f12));
 f16 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround(f16 * f11);
 f13 = Math_fround(f16 * f13);
 f12 = Math_fround(f16 * f12);
 f16 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f6 = Math_fround(f16 + f11);
 f15 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(f15 + f13);
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f10 = Math_fround(f12 + f14);
 HEAPF32[i9 >> 2] = f6;
 HEAPF32[i9 + 4 >> 2] = f5;
 HEAPF32[i9 + 8 >> 2] = f10;
 f11 = Math_fround(f16 - f11);
 f13 = Math_fround(f15 - f13);
 f12 = Math_fround(f14 - f12);
 HEAPF32[i9 + 12 >> 2] = f11;
 HEAPF32[i9 + 16 >> 2] = f13;
 HEAPF32[i9 + 20 >> 2] = f12;
 i2 = i9 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 f5 = Math_fround(f13 - f5);
 f10 = Math_fround(f12 - f10);
 HEAPF32[i8 >> 2] = Math_fround(f11 - f6);
 HEAPF32[i8 + 4 >> 2] = f5;
 HEAPF32[i8 + 8 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 4 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i7 + 4 >> 2] = f5;
 HEAPF32[i7 + 8 >> 2] = f6;
 f6 = Math_fround(__ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i9, i8, i3, i7, i4 + 4 | 0, i4));
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 + 24 >> 2]));
 i3 = f6 <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z37TextGenerator_CUSTOM_GetVerticesArrayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = i1 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 if (!(HEAP8[i1 + 60 >> 0] | 0)) i2 = 0; else i2 = HEAP32[i1 + 72 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 24 >> 2] | 0, 60, i2) | 0;
 if (!i2) {
  STACKTOP = i7;
  return i4 | 0;
 } else i1 = 0;
 while (1) {
  i3 = HEAP32[i5 >> 2] | 0;
  if (!i3) {
   i1 = 9;
   break;
  }
  i8 = HEAP32[i3 >> 2] | 0;
  i22 = HEAP32[i8 + (i1 * 60 | 0) >> 2] | 0;
  i21 = HEAP32[i8 + (i1 * 60 | 0) + 4 >> 2] | 0;
  i20 = HEAP32[i8 + (i1 * 60 | 0) + 8 >> 2] | 0;
  i19 = HEAP32[i8 + (i1 * 60 | 0) + 12 >> 2] | 0;
  i18 = HEAP32[i8 + (i1 * 60 | 0) + 16 >> 2] | 0;
  i17 = HEAP32[i8 + (i1 * 60 | 0) + 20 >> 2] | 0;
  i16 = HEAP32[i8 + (i1 * 60 | 0) + 24 >> 2] | 0;
  i15 = HEAP32[i8 + (i1 * 60 | 0) + 28 >> 2] | 0;
  i14 = HEAP32[i8 + (i1 * 60 | 0) + 32 >> 2] | 0;
  i13 = HEAP32[i8 + (i1 * 60 | 0) + 36 >> 2] | 0;
  i12 = HEAP32[i8 + (i1 * 60 | 0) + 40 >> 2] | 0;
  i11 = HEAP32[i8 + (i1 * 60 | 0) + 44 >> 2] | 0;
  i10 = HEAP32[i8 + (i1 * 60 | 0) + 48 >> 2] | 0;
  i9 = HEAP32[i8 + (i1 * 60 | 0) + 52 >> 2] | 0;
  i8 = HEAP32[i8 + (i1 * 60 | 0) + 56 >> 2] | 0;
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 60) | 0;
  HEAP32[i3 >> 2] = i22;
  HEAP32[i3 + 4 >> 2] = i21;
  HEAP32[i3 + 8 >> 2] = i20;
  HEAP32[i3 + 12 >> 2] = i19;
  HEAP32[i3 + 16 >> 2] = i18;
  HEAP32[i3 + 20 >> 2] = i17;
  HEAP32[i3 + 24 >> 2] = i16;
  HEAP32[i3 + 28 >> 2] = i15;
  HEAP32[i3 + 32 >> 2] = i14;
  HEAP32[i3 + 36 >> 2] = i13;
  HEAP32[i3 + 40 >> 2] = i12;
  HEAP32[i3 + 44 >> 2] = i11;
  HEAP32[i3 + 48 >> 2] = i10;
  HEAP32[i3 + 52 >> 2] = i9;
  HEAP32[i3 + 56 >> 2] = i8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  STACKTOP = i7;
  return i4 | 0;
 } else if ((i1 | 0) == 9) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 return 0;
}

function __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i9 + 12 | 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 40 | 0) + 1 | 0;
 if ((i8 | 0) < -40) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 40 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 1073741823 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 2147483647;
 i1 = (i2 - i1 | 0) / 40 | 0;
 if (!i5) i4 = 0; else {
  i4 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 40 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i4 + (i1 * 40 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 40 | 0) | 0;
 __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i2, i6);
 __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i4 + (i1 * 40 | 0) + 20 | 0, i6 + 20 | 0);
 i6 = i2 + 40 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i5 = i4;
  i1 = i4;
 } else {
  do {
   i5 = i1;
   i1 = i1 + -40 | 0;
   __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i2 + -40 | 0, i1);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + -20 | 0, i5 + -20 | 0);
   i2 = i3 + -40 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = i2 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -36 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
 STACKTOP = i13;
 return;
}

function __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i17, i20, i18, i19) {
 i17 = i17 | 0;
 i20 = i20 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i2 = HEAP32[i17 + 16 >> 2] | 0;
 i15 = HEAP16[i17 + 26 >> 1] | 0;
 i16 = i2 + ((i15 & 65535) << 4) | 0;
 if (!(i15 << 16 >> 16)) return;
 f4 = Math_fround(0.0);
 i12 = HEAP32[i17 + 20 >> 2] | 0;
 while (1) {
  i6 = i2 + 32 | 0;
  i15 = HEAP8[i2 + 4 >> 0] | 0;
  i5 = HEAP8[i2 + 5 >> 0] | 0;
  i8 = i5 & 255;
  i14 = HEAP8[i2 + 6 >> 0] | 0;
  i13 = (HEAP8[i2 >> 0] | 0) == 3;
  i9 = i13 ? 112 : 80;
  if (!i12) {
   i2 = i2 + ((Math_imul(i9, i8) | 0) + 32) | 0;
   i11 = 0;
  } else if (!(i5 << 24 >> 24)) {
   i2 = i6;
   i11 = i12;
  } else {
   i11 = i12 + (i8 << 2) | 0;
   i10 = Math_imul(i9, i8) | 0;
   i7 = 0;
   i5 = i12;
   while (1) {
    f3 = Math_fround(HEAPF32[i6 + 28 >> 2]);
    HEAPF32[i5 >> 2] = f3;
    f4 = Math_fround(f4 + f3);
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i8 | 0)) break; else {
     i6 = i6 + i9 | 0;
     i5 = i5 + 4 | 0;
    }
   }
   i2 = i2 + (i10 + 32) | 0;
  }
  i10 = i13 ? 128 : 96;
  if (i14 << 24 >> 24) {
   i6 = i14 & 255;
   i5 = Math_imul(i10, i6) | 0;
   i8 = i2;
   i9 = 0;
   do {
    i7 = HEAP32[i8 + 80 >> 2] | 0;
    if (i7 | 0) if (HEAP32[i8 + 60 >> 2] | 0) HEAP8[i7 >> 0] = 1;
    i8 = i8 + i10 | 0;
    i9 = i9 + 1 | 0;
   } while ((i9 | 0) != (i6 | 0));
   i2 = i2 + i5 | 0;
  }
  if (i2 >>> 0 < i16 >>> 0) i12 = i11; else {
   i2 = i15;
   break;
  }
 }
 if (!(i2 & 1)) return;
 if ((HEAP16[i17 + 8 >> 1] | 0) != -1) return;
 if (!(f4 != Math_fround(0.0) ? (HEAP16[i17 + 12 >> 1] | 0) == -1 : 0)) return;
 f3 = Math_fround(HEAPF32[i18 + 36 >> 2]);
 i17 = f3 < Math_fround(3402823469999999843913219.0e14);
 f1 = Math_fround(HEAPF32[i19 + 36 >> 2]);
 if (!(i17 | f1 < Math_fround(3402823469999999843913219.0e14))) return;
 i17 = HEAP32[i18 + 40 >> 2] | 0;
 i18 = HEAP32[i19 + 40 >> 2] | 0;
 i16 = i18 >>> 0 < i17 >>> 0;
 i15 = i20 + 8 | 0;
 i19 = HEAP32[i15 >> 2] | 0;
 HEAP32[i15 >> 2] = i19 + 1;
 i20 = HEAP32[i20 + 4 >> 2] | 0;
 HEAP32[i20 + (i19 << 4) >> 2] = i16 ? i18 : i17;
 HEAP32[i20 + (i19 << 4) + 4 >> 2] = i16 ? i17 : i18;
 HEAPF32[i20 + (i19 << 4) + 8 >> 2] = f4;
 HEAPF32[i20 + (i19 << 4) + 12 >> 2] = f3 < f1 ? f3 : f1;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 - i1 | 0;
 i3 = ((i9 | 0) / 172 | 0) + 1 | 0;
 if ((i9 | 0) < -172) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 172 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 2147483647;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 172 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i4 + (((i2 - i1 | 0) / 172 | 0) * 172 | 0) | 0;
 i5 = i2;
 i8 = i4 + (i3 * 172 | 0) | 0;
 __ZN13AnimationClip12Vector3CurveC2ERKS0_(i2, i6);
 i7 = i2 + 172 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i6 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -172 | 0;
   __ZN13AnimationClip12Vector3CurveC2ERKS0_(i2 + -172 | 0, i1);
   i2 = i3 + -172 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i9 >> 2] = i8;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -172 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -160 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i6) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 44 | 0) + 1 | 0;
 if (i4 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 44 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 48806446 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 97612893;
 i5 = (i1 - i2 | 0) / 44 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 44 | 0) | 0;
 i7 = i6 + (i5 * 44 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 44 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i15 = i8 + 24 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i4 = i6 + (i5 * 44 | 0) + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i4 + 4 >> 2] = i14;
 HEAP32[i6 + (i5 * 44 | 0) + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 i4 = i7 + 44 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i15 = i3;
   i3 = i3 + -44 | 0;
   HEAP32[i1 + -44 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i15 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i15 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i15 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i15 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i15 + -24 >> 2];
   i7 = i15 + -20 | 0;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i14 = i1 + -20 | 0;
   HEAP32[i14 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i14 + 4 >> 2] = i8;
   HEAP32[i1 + -12 >> 2] = HEAP32[i15 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i15 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i15 + -4 >> 2];
   i1 = i2 + -44 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN22CreateGpuProgramOutput12CreateParamsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(244) | 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = i6;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i3 + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = i3 + 36 | 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i7 = i6;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3 + 64 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i3 + 80 | 0;
 HEAP32[i3 + 104 >> 2] = 0;
 HEAP32[i3 + 108 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 96 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 112 >> 2] = 0;
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 120 >> 2] = 0;
 HEAP32[i3 + 124 >> 2] = -1;
 i4 = i3 + 128 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 + 144 >> 2] = -1;
 i4 = i3 + 148 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 + 164 >> 2] = -1;
 i4 = i3 + 168 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 + 184 >> 2] = -1;
 i4 = i3 + 188 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 + 204 >> 2] = -1;
 i4 = i3 + 208 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 + 224 >> 2] = -1;
 i4 = i3 + 228 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i1 >> 2] = i3;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN15ResourceManager10Dependency8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i7 = i3 + 16 | 0;
 i10 = HEAP32[gb + 37176 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450774 | 0, i10, i1, 0);
 i11 = i9 + 8 | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i11, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470499 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i10, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function _UNITY_png_write_row(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 i9 = i8 + 368 | 0;
 do if (!(HEAP32[i9 >> 2] | 0)) if (!(HEAP8[i8 + 429 >> 0] | 0)) if (!(HEAP32[i8 + 204 >> 2] & 1024)) _UNITY_png_error(i8, gb + 355937 | 0); else {
  _UNITY_png_write_start_row(i8);
  break;
 } while (0);
 i6 = i7 + 8 | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 + 431 >> 0] | 0;
 i2 = HEAP32[i8 + 356 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = HEAP8[i8 + 436 >> 0] | 0;
 HEAP8[i7 + 10 >> 0] = i3;
 i1 = HEAP8[i8 + 433 >> 0] | 0;
 HEAP8[i7 + 9 >> 0] = i1;
 i3 = Math_imul(i1 & 255, i3 & 255) | 0;
 i1 = i3 & 255;
 i5 = i7 + 11 | 0;
 HEAP8[i5 >> 0] = i1;
 i3 = i3 & 255;
 if (i3 >>> 0 > 7) i2 = Math_imul(i3 >>> 3, i2) | 0; else i2 = ((Math_imul(i2, i3) | 0) + 7 | 0) >>> 3;
 HEAP32[i7 + 4 >> 2] = i2;
 i3 = i8 + 380 | 0;
 _memcpy((HEAP32[i3 >> 2] | 0) + 1 | 0, i4 | 0, i2 | 0) | 0;
 if (HEAP32[i8 + 212 >> 2] | 0) {
  _UNITY_png_do_write_transformations(i8, i7);
  i1 = HEAP8[i5 >> 0] | 0;
 }
 if (i1 << 24 >> 24 != (HEAP8[i8 + 434 >> 0] | 0)) _UNITY_png_error(i8, gb + 355990 | 0);
 if (i1 << 24 >> 24 != (HEAP8[i8 + 439 >> 0] | 0)) _UNITY_png_error(i8, gb + 355990 | 0);
 L24 : do if (HEAP32[i8 + 596 >> 2] & 4 | 0) if ((HEAP8[i8 + 600 >> 0] | 0) == 64) {
  i4 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP16[i6 >> 1] | 0;
  i1 = i3 & 255;
  if ((i1 & 2) != 0 & (i3 & -256) << 16 >> 16 == 2048) {
   switch (i1 << 24 >> 24) {
   case 2:
    {
     i3 = 3;
     break;
    }
   case 6:
    {
     i3 = 4;
     break;
    }
   default:
    break L24;
   }
   if (i5 | 0) {
    i2 = 0;
    i1 = i4;
    while (1) {
     i11 = HEAPU8[i1 + 1 >> 0] | 0;
     HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) - i11;
     i4 = i1 + 2 | 0;
     HEAP8[i4 >> 0] = (HEAPU8[i4 >> 0] | 0) - i11;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + i3 | 0;
    }
   }
  }
 } while (0);
 if ((HEAP8[i6 >> 0] | 0) == 3) if ((HEAP32[i8 + 420 >> 2] | 0) > -1) _UNITY_png_do_check_palette_indexes(i8, i7);
 _UNITY_png_write_find_filter(i8, i7);
 i1 = HEAP32[i8 + 544 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 mftCall_viii(i1 | 0, i8 | 0, HEAP32[i9 >> 2] | 0, HEAPU8[i8 + 429 >> 0] | 0);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) return i10 | 0;
 i8 = HEAP8[i2 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i5 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
 i8 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255;
 i9 = i5 + i8 | 0;
 L4 : do if (!i8) {
  i1 = i3;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
 } else {
  i1 = i10;
  while (1) {
   i2 = i3;
   L9 : while (1) {
    i4 = i2 + 16 | 0;
    i3 = HEAP8[i4 + 11 >> 0] | 0;
    i6 = i3 << 24 >> 24 < 0;
    i4 = i6 ? HEAP32[i4 >> 2] | 0 : i4;
    i3 = i4 + (i6 ? HEAP32[i2 + 20 >> 2] | 0 : i3 & 255) | 0;
    i6 = i5;
    while (1) {
     if ((i4 | 0) == (i3 | 0)) break;
     i8 = HEAP8[i4 >> 0] | 0;
     i11 = HEAP8[i6 >> 0] | 0;
     i7 = i8 & 255;
     i7 = ((i8 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255;
     i8 = i11 & 255;
     i8 = ((i11 + -65 & 255) < 26 ? i8 + 32 | 0 : i8) & 255;
     if ((i7 & 255) < (i8 & 255)) break;
     if ((i8 & 255) < (i7 & 255)) break L9;
     i6 = i6 + 1 | 0;
     if ((i6 | 0) == (i9 | 0)) break L9; else i4 = i4 + 1 | 0;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L4;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
 } while (0);
 if ((i1 | 0) == (i10 | 0)) {
  i11 = i10;
  return i11 | 0;
 }
 i2 = i1 + 16 | 0;
 i11 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i11 << 24 >> 24 < 0;
 i2 = i6 ? HEAP32[i2 >> 2] | 0 : i2;
 i11 = i6 ? HEAP32[i1 + 20 >> 2] | 0 : i11 & 255;
 i6 = i2 + i11 | 0;
 if (!i11) {
  i11 = i1;
  return i11 | 0;
 }
 while (1) {
  if ((i5 | 0) == (i9 | 0)) {
   i1 = i10;
   i2 = 18;
   break;
  }
  i4 = HEAP8[i5 >> 0] | 0;
  i11 = HEAP8[i2 >> 0] | 0;
  i3 = i4 & 255;
  i3 = ((i4 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255;
  i4 = i11 & 255;
  i4 = ((i11 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255;
  if ((i3 & 255) < (i4 & 255)) {
   i1 = i10;
   i2 = 18;
   break;
  }
  if ((i4 & 255) < (i3 & 255)) {
   i2 = 18;
   break;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i2 = 18;
   break;
  } else i5 = i5 + 1 | 0;
 }
 if ((i2 | 0) == 18) return i1 | 0;
 return 0;
}

function __ZNK6Camera25GetSkyboxProjectionMatrixEfR10Matrix4x4f(i6, f7, i8) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 if (HEAP8[i6 + 1082 >> 0] | 0) {
  i2 = i6 + 1079 | 0;
  if (HEAP8[i2 >> 0] | 0) {
   i1 = i6 + 228 | 0;
   if (!(HEAP8[i6 + 1088 >> 0] | 0)) {
    if (HEAP8[i6 + 1087 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
     i9 = __Z12GetIVRDevicev() | 0;
     if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 116 >> 2] | 0, i9 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i6) | 0) {
      i10 = __Z14IsWorldPlayingv() | 0;
      i9 = HEAP32[i6 + 1108 >> 2] | 0;
      if ((i9 | 0) == 8 | i10 & (i9 | 0) == 1) {
       i10 = __Z12GetIVRDevicev() | 0;
       HEAPF32[i6 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i10 >> 2] | 0) + 120 >> 2] | 0, i10 | 0));
      }
     }
    }
    f5 = Math_fround(HEAPF32[i6 + 292 >> 2]);
    if (!(HEAP8[i6 + 1086 >> 0] | 0)) i3 = 16; else if (!(__Z12GetIVRDevicev() | 0)) i3 = 16; else if (__ZNK6Camera16GetStereoEnabledEv(i6) | 0) {
     i9 = __Z14IsWorldPlayingv() | 0;
     i10 = HEAP32[i6 + 1108 >> 2] | 0;
     if ((i10 | 0) == 8 | i9 & (i10 | 0) == 1) {
      i10 = __Z12GetIVRDevicev() | 0;
      if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 124 >> 2] | 0, i10 | 0) | 0) {
       i10 = __Z12GetIVRDevicev() | 0;
       f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i10 >> 2] | 0) + 128 >> 2] | 0, i10 | 0));
      } else i3 = 16;
     } else i3 = 16;
    } else i3 = 16;
    if ((i3 | 0) == 16) f4 = Math_fround(HEAPF32[i6 + 1060 >> 2]);
    f11 = Math_fround(HEAPF32[i6 + 920 >> 2]);
    __ZN10Matrix4x4f14SetPerspectiveEffff(i1, f5, f4, f11, Math_fround(HEAPF32[i6 + 924 >> 2])) | 0;
   } else {
    f5 = Math_fround(HEAPF32[i6 + 916 >> 2]);
    f4 = Math_fround(-f5);
    f12 = Math_fround(HEAPF32[i6 + 1060 >> 2]);
    f13 = Math_fround(f12 * f4);
    f12 = Math_fround(f5 * f12);
    f11 = Math_fround(HEAPF32[i6 + 920 >> 2]);
    __ZN10Matrix4x4f8SetOrthoEffffff(i1, f13, f12, f4, f5, f11, Math_fround(HEAPF32[i6 + 924 >> 2])) | 0;
   }
   HEAP8[i2 >> 0] = 0;
  }
 }
 i1 = i8;
 i2 = i6 + 228 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 f13 = Math_fround(HEAPF32[i6 + 920 >> 2]);
 __ZN10Matrix4x4f16AdjustDepthRangeEfff(i8, f13, f7, Math_fround(HEAPF32[i6 + 924 >> 2])) | 0;
 return;
}

function __ZN9dtNavMesh17removeLinkBetweenEyy(i12, i1, i2, i9, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0;
 if ((i1 & 983040 | 0) == 65536 & 0 == 0) {
  i7 = i1 & 65535;
  if (i7 >>> 0 > (HEAP32[i12 + 44 >> 2] | 0) >>> 0) return;
  i6 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
  getTempRet0() | 0;
  i5 = HEAP32[i12 + 48 >> 2] | 0;
  if ((i5 + (i7 * 104 | 0) | 0) == 0 ? 1 : (i6 | 0) != (HEAP32[i5 + (i7 * 104 | 0) + 92 >> 2] | 0)) return;
  i6 = i5 + (i7 * 104 | 0) + 88 | 0;
  i1 = i12 + 36 | 0;
  i3 = i6;
  i4 = -1;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i11 = 23;
    break;
   }
   i8 = HEAP32[i1 >> 2] | 0;
   i13 = i8 + (i2 << 4) | 0;
   i3 = i8 + (i2 << 4) + 8 | 0;
   if ((HEAP32[i13 >> 2] | 0) == (i9 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i10 | 0) : 0) break; else i4 = i2;
  }
  if ((i11 | 0) == 23) return;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == -1) HEAP32[i6 >> 2] = i1; else HEAP32[i8 + (i4 << 4) + 8 >> 2] = i1;
  i13 = i5 + (i7 * 104 | 0) + ((HEAPU8[i8 + (i2 << 4) + 12 >> 0] | 0) << 5) + 24 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  i13 = i12 + 28 | 0;
  HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i13 >> 2] = i2;
  return;
 }
 if ((i1 | 0) == 0 & (i2 | 0) == 0) return;
 i3 = _bitshift64Lshr(i1 | 0, i2 | 0, 20) | 0;
 getTempRet0() | 0;
 i3 = i3 & 268435455;
 i4 = i1 & 65535;
 if (i3 >>> 0 >= (HEAP32[i12 + 16 >> 2] | 0) >>> 0) return;
 i13 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i12 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i3 * 56 | 0) + 4 >> 2] | 0) != (i13 | 0)) return;
 i2 = HEAP32[i1 + (i3 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) return;
 if (i4 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) return;
 i5 = (HEAP32[i1 + (i3 * 56 | 0) + 12 >> 2] | 0) + (i4 << 2) | 0;
 i1 = i12 + 36 | 0;
 i2 = -1;
 i4 = i5;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) == -1) {
   i11 = 23;
   break;
  }
  i6 = HEAP32[i1 >> 2] | 0;
  i13 = i6 + (i3 << 4) | 0;
  i4 = i6 + (i3 << 4) + 8 | 0;
  if ((HEAP32[i13 >> 2] | 0) == (i9 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i10 | 0) : 0) break; else i2 = i3;
 }
 if ((i11 | 0) == 23) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == -1) HEAP32[i5 >> 2] = i1; else HEAP32[i6 + (i2 << 4) + 8 >> 2] = i1;
 i13 = i12 + 28 | 0;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i3;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i8 = i10 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i6 >> 2] | 0)) {
   i8 = i2;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i6 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
  }
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i4 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  break;
 } while (0);
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) {
  i3 = HEAP32[gb + 37328 >> 2] | 0;
  i4 = i10 + 20 | 0;
  i6 = i10 + 56 | 0;
  i7 = i10 + 44 | 0;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
   i11 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 3) + 4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 2097152;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5, gb + 1085989 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 4 | 0, gb + 1085998 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 8 | 0, gb + 1084342 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 12 | 0, gb + 1085899 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i5 = i5 + 16 | 0;
  }
 }
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN18LoadSceneOperation14SetFinalTimingEffff(i1, f3, f4, f5, f6) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 48 | 0;
 i10 = i13 + 32 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13;
 HEAPF32[i10 >> 2] = f3;
 HEAPF32[i10 + 4 >> 2] = f4;
 HEAPF32[i10 + 8 >> 2] = f5;
 HEAPF32[i10 + 12 >> 2] = f6;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i12 | 0, i1 | 0);
 i7 = HEAP8[i12 + 11 >> 0] | 0;
 i1 = i7 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i1 ? HEAP32[i12 + 4 >> 2] | 0 : i7 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 if (i7 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i7 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i7;
  if (!i7) i1 = i11; else {
   i1 = i11;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i14 = i7 + 16 & -16;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i14 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i7;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if (HEAP32[gb + 1163400 + 768 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = gb + 1163400 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[gb + 1163400 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i2 >> 2] | 0, i10 | 0, i11 | 0); else mftCall_viii(HEAP32[i2 >> 2] | 0, HEAP32[gb + 1163400 + (i1 * 12 | 0) + 4 >> 2] | 0, i10 | 0, i11 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[gb + 1163400 + 768 >> 2] | 0) >>> 0);
 }
 if ((HEAP8[i11 + 11 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 66;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i14, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 STACKTOP = i13;
 return;
}

function __ZN15CapsuleCollider9SetHeightEf(i4, f2) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i6 = i9 + 12 | 0;
 i7 = i9;
 i8 = i4 + 64 | 0;
 if (Math_fround(HEAPF32[i8 >> 2]) != f2) HEAPF32[i8 >> 2] = f2;
 i1 = i4 + 36 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = 2;
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 i10 = i7 + 8 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i7 | 0) | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f11 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f2 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f12 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f12 = Math_fround(f12 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 HEAPF32[i5 >> 2] = f11;
 HEAPF32[i5 + 4 >> 2] = f2;
 HEAPF32[i5 + 8 >> 2] = f12;
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i4 + 68 >> 2] | 0;
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i5 + (i8 << 2) >> 2]));
 i6 = f12 < Math_fround(0.0);
 f2 = Math_fround(-f12);
 f12 = i6 ? f2 : f12;
 i6 = f12 < Math_fround(9.99999974e-06);
 f12 = i6 ? Math_fround(9.99999974e-06) : f12;
 f2 = Math_fround(HEAPF32[i5 + (((i8 + 1 | 0) % 3 | 0) << 2) >> 2]);
 f11 = Math_fround(HEAPF32[i5 + (((i8 + 2 | 0) % 3 | 0) << 2) >> 2]);
 i8 = f2 < Math_fround(0.0);
 f13 = Math_fround(-f2);
 f2 = i8 ? f13 : f2;
 i8 = f11 < Math_fround(0.0);
 f13 = Math_fround(-f11);
 f11 = i8 ? f13 : f11;
 f2 = Math_fround(f12 - Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 60 >> 2]) * (f2 < f11 ? f11 : f2)) * Math_fround(2.0)));
 i8 = f2 < Math_fround(9.99999974e-06);
 HEAPF32[i10 >> 2] = Math_fround((i8 ? Math_fround(9.99999974e-06) : f2) * Math_fround(.5));
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, i7 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 }
 STACKTOP = i9;
 return;
}

function __ZN12TreeRenderer11RenderBatchER14TreeBinaryTreef(i12, i5, f1) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 8 | 0;
 i2 = i11;
 i3 = i5 + 60 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i10 = i5 + 48 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i10 >> 2] | 0);
  HEAP32[i10 >> 2] = 0;
  i7 = gb + 63520 | 0;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i2;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i9 = __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId(4, i4) | 0;
  HEAP32[i10 >> 2] = i9;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0, i9 | 0, 61);
  i9 = HEAP32[i10 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 40 >> 2] | 0, i9 | 0, gb + 934721 | 0);
  __ZN12TreeRenderer21GenerateBillboardMeshER4MeshRK13dynamic_arrayIjLj4EEb(i12, HEAP32[i10 >> 2] | 0, i5 + 4 | 0, 0);
  HEAP32[i5 + 52 >> 2] = -1;
 }
 HEAP32[i3 >> 2] = 1;
 i10 = i12 + 176 | 0;
 i3 = i12 + 188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i6 = i4 + 1 | 0;
 i7 = i12 + 192 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 if (i6 >>> 0 <= i9 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + (i4 << 2) | 0;
  HEAP32[i12 >> 2] = i5;
  STACKTOP = i11;
  return;
 }
 i2 = i8 << 1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 if (i9 >>> 0 >= i2 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + (i4 << 2) | 0;
  HEAP32[i12 >> 2] = i5;
  STACKTOP = i11;
  return;
 }
 if ((i8 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 2, 4, i12 + 180 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i6;
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + (i4 << 2) | 0;
  HEAP32[i12 >> 2] = i5;
  STACKTOP = i11;
  return;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12 + 180 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i10 >> 2] = i12;
  HEAP32[i3 >> 2] = i6;
  i12 = HEAP32[i10 >> 2] | 0;
  i12 = i12 + (i4 << 2) | 0;
  HEAP32[i12 >> 2] = i5;
  STACKTOP = i11;
  return;
 }
}

function __ZL31InitializeIMGUIScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63728 | 0, 16, gb + 1018253 | 0, 16) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[gb + 1468884 >> 2] = i4;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018375 | 0, gb + 1018381 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = (HEAP32[gb + 1468884 >> 2] | 0) + 8 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018413 | 0, gb + 1018417 | 0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018436 | 0) | 0;
 HEAP32[(HEAP32[gb + 1468884 >> 2] | 0) + 16 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1034552 | 0) | 0;
 i2 = HEAP32[gb + 1468884 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = i4;
 i2 = i2 + 24 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018444 | 0, gb + 1018463 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468884 >> 2] | 0) + 32 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018485 | 0, gb + 1018496 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468884 >> 2] | 0) + 40 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018485 | 0, gb + 1018516 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468884 >> 2] | 0) + 48 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018485 | 0, gb + 1018525 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1033949 | 0) | 0;
 HEAP32[(HEAP32[gb + 1468884 >> 2] | 0) + 56 >> 2] = i2;
 i2 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1018532 | 0) | 0;
 HEAP32[(HEAP32[gb + 1468884 >> 2] | 0) + 60 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN5physx2Gu25computeMTD_CapsuleCapsuleERNS_6PxVec3ERfRKNS0_7CapsuleES6_(i11, i10, i5, i6) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i7 = 0, i8 = 0, f9 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i8 = i12;
 f4 = Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i5, i6, i7, i8));
 f9 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i6 + 24 >> 2]));
 if (f4 > Math_fround(f9 * f9)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f18 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f18 = Math_fround(f18 - f2);
 f16 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f16 = Math_fround(f16 - f17);
 f4 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f18 = Math_fround(f2 + Math_fround(f1 * f18));
 f16 = Math_fround(f17 + Math_fround(f1 * f16));
 f14 = Math_fround(f14 + Math_fround(f1 * Math_fround(f4 - f14)));
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f1 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = Math_fround(f1 - f17);
 f2 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(f2 - f15);
 f13 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f1 = Math_fround(f18 - Math_fround(f17 + Math_fround(f4 * f1)));
 f2 = Math_fround(f16 - Math_fround(f15 + Math_fround(f4 * f2)));
 f3 = Math_fround(f14 - Math_fround(f3 + Math_fround(f4 * Math_fround(f13 - f3))));
 f13 = Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(f3 * f3));
 f4 = Math_fround(Math_sqrt(Math_fround(f13)));
 if (f13 < Math_fround(9.99999997e-07)) {
  HEAP32[i11 >> 2] = 1065353216;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
 } else {
  f16 = Math_fround(Math_fround(1.0) / f4);
  f17 = Math_fround(f2 * f16);
  f18 = Math_fround(f3 * f16);
  HEAPF32[i11 >> 2] = Math_fround(f1 * f16);
  HEAPF32[i11 + 4 >> 2] = f17;
  HEAPF32[i11 + 8 >> 2] = f18;
 }
 f18 = Math_fround(f9 - f4);
 i11 = f18 > Math_fround(0.0);
 HEAPF32[i10 >> 2] = i11 ? f18 : Math_fround(0.0);
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) > (i9 | 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i7 = (HEAP32[i11 + 52 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 32 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 36 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 56 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 44 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 40 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i7) | 0) + i3 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 } else {
  i7 = (HEAP32[i11 + 56 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 40 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 44 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 52 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 36 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 32 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i3) | 0) + i7 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 }
 return 0;
}

function _processblock_41(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0, i30 = 0, i31 = 0, i32 = 0;
 i27 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i26 = i27;
 i1 = 0;
 do {
  i25 = i1 << 2;
  HEAP32[i26 + (i1 << 2) >> 2] = (HEAPU8[i2 + (i25 | 2) >> 0] | 0) << 8 | ((HEAPU8[i2 + (i25 | 1) >> 0] | 0) << 16 | (HEAPU8[i2 + i25 >> 0] | 0) << 24) | (HEAPU8[i2 + (i25 | 3) >> 0] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 i1 = 16;
 i2 = HEAP32[i26 >> 2] | 0;
 do {
  i25 = HEAP32[i26 + (i1 + -2 << 2) >> 2] | 0;
  i24 = i2;
  i2 = HEAP32[i26 + (i1 + -15 << 2) >> 2] | 0;
  HEAP32[i26 + (i1 << 2) >> 2] = i24 + (HEAP32[i26 + (i1 + -7 << 2) >> 2] | 0) + ((i25 << 13 | i25 >>> 19) ^ i25 >>> 10 ^ (i25 << 15 | i25 >>> 17)) + ((i2 << 14 | i2 >>> 18) ^ i2 >>> 3 ^ (i2 << 25 | i2 >>> 7));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 i12 = i3 + 8 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i14 = i3 + 12 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i16 = i3 + 16 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 i18 = i3 + 20 | 0;
 i19 = HEAP32[i18 >> 2] | 0;
 i20 = i3 + 24 | 0;
 i21 = HEAP32[i20 >> 2] | 0;
 i22 = i3 + 28 | 0;
 i23 = HEAP32[i22 >> 2] | 0;
 i24 = i3 + 32 | 0;
 i25 = HEAP32[i24 >> 2] | 0;
 i10 = i3 + 36 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i3 = i25;
 i4 = i23;
 i5 = i21;
 i1 = i19;
 i6 = i17;
 i7 = i15;
 i8 = i13;
 i2 = i11;
 i9 = 0;
 while (1) {
  i2 = ((i5 << 26 | i5 >>> 6) ^ (i5 << 21 | i5 >>> 11) ^ (i5 << 7 | i5 >>> 25)) + i2 + ((i3 ^ i4) & i5 ^ i3) + (HEAP32[gb + 198756 + (i9 << 2) >> 2] | 0) + (HEAP32[i26 + (i9 << 2) >> 2] | 0) | 0;
  i1 = i2 + i1 | 0;
  i2 = ((i8 << 30 | i8 >>> 2) ^ (i8 << 19 | i8 >>> 13) ^ (i8 << 10 | i8 >>> 22)) + (i6 & (i7 | i8) | i7 & i8) + i2 | 0;
  i9 = i9 + 1 | 0;
  if ((i9 | 0) == 64) break; else {
   i32 = i8;
   i31 = i7;
   i30 = i6;
   i29 = i5;
   i28 = i4;
   i5 = i1;
   i8 = i2;
   i2 = i3;
   i7 = i32;
   i6 = i31;
   i1 = i30;
   i4 = i29;
   i3 = i28;
  }
 }
 HEAP32[i12 >> 2] = i13 + i2;
 HEAP32[i14 >> 2] = i15 + i8;
 HEAP32[i16 >> 2] = i17 + i7;
 HEAP32[i18 >> 2] = i19 + i6;
 HEAP32[i20 >> 2] = i21 + i1;
 HEAP32[i22 >> 2] = i23 + i5;
 HEAP32[i24 >> 2] = i25 + i4;
 HEAP32[i10 >> 2] = i11 + i3;
 STACKTOP = i27;
 return;
}

function __ZN8Renderer32GetAndAssignInstantiatedMaterialEib(i7, i8, i5) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i2 = i10;
 if ((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0) | 0) > (i8 | 0)) {
  i4 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, i8 | 0) | 0;
  if (!i4) i6 = 11; else {
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i6 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i2);
     i2 = HEAP32[i9 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i2) i6 = 10;
    }
   }
   if ((i6 | 0) == 8) i6 = 10;
   if ((i6 | 0) == 10) i2 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   i1 = __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb(i2, i7, i5) | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i11 = i2;
    STACKTOP = i10;
    return i11 | 0;
   } else i3 = i1;
  }
 } else i6 = 11;
 if ((i6 | 0) == 11) i3 = __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb(0, i7, i5) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0) | 0;
 i2 = i8 + 1 | 0;
 i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
 i2 = i7 + 300 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) {
  HEAP32[i9 >> 2] = 0;
  __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i7 + 288 | 0, i1, i9, 1);
  i11 = i7 + 218 | 0;
  i6 = HEAP32[i2 >> 2] & 65535;
  i9 = HEAP16[i11 >> 1] | 0;
  HEAP16[i11 >> 1] = (i6 & 65535) < (i9 & 65535) ? i6 : i9;
  __ZN8Renderer13BoundsChangedEv(i7);
 }
 HEAP32[(HEAP32[i7 + 288 >> 2] | 0) + (i8 << 2) >> 2] = HEAP32[i3 + 4 >> 2];
 i11 = i3;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i14, i13, i9, i11, i12) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i10 = 0, f15 = f0, f16 = f0;
 i1 = HEAP32[i14 + 20 >> 2] | 0;
 i8 = HEAP32[i14 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i8 | 0)) {
  i2 = HEAP32[i14 + 32 >> 2] | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) {
    i10 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i8 = HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i10 = 7;
 } else i10 = 7; while (0);
 if ((i10 | 0) == 7) i8 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i14, i13, 0) | 0;
 __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i14, i8, i13, i9, 1);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f15 = Math_fround(f5 + Math_fround(-1.0));
 i12 = f15 < Math_fround(0.0);
 f16 = Math_fround(-f15);
 if ((i12 ? f16 : f15) <= Math_fround(9.99999997e-07)) {
  f16 = Math_fround(f3 + Math_fround(-1.0));
  i12 = f16 < Math_fround(0.0);
  f15 = Math_fround(-f16);
  i12 = (i12 ? f15 : f16) <= Math_fround(9.99999997e-07);
  f5 = i12 ? Math_fround(1.0) : f5;
  f3 = i12 ? Math_fround(1.0) : f3;
 }
 i12 = f7 < Math_fround(0.0);
 f16 = Math_fround(-f7);
 if ((i12 ? f16 : f7) <= Math_fround(9.99999997e-07)) {
  i12 = f4 < Math_fround(0.0);
  f16 = Math_fround(-f4);
  i12 = (i12 ? f16 : f4) <= Math_fround(9.99999997e-07);
  f7 = i12 ? Math_fround(0.0) : f7;
  f4 = i12 ? Math_fround(0.0) : f4;
 }
 i6 = i14 + 72 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + i8 + 20 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i14, i13, gb + 478716 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 + i8 + 20 >> 2] = i2;
 }
 i14 = i1 + (HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + ((HEAP32[i14 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i14 >> 2] = f5;
 HEAPF32[i14 + 4 >> 2] = f3;
 HEAPF32[i14 + 8 >> 2] = f7;
 HEAPF32[i14 + 12 >> 2] = f4;
 return;
}

function __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_(i8, i9, i7, i6, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 | 0) < (i1 | 0);
 do if ((i1 | 0) < (i2 | 0)) {
  if (i4) {
   HEAP32[i8 >> 2] = i3;
   HEAP32[i7 >> 2] = i2;
   i3 = i8 + 4 | 0;
   i5 = i7 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i4;
   i5 = 1;
   break;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i3 = i8 + 4 | 0;
  i1 = i9 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   i5 = i7 + 4 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i4;
   i5 = 2;
  } else i5 = 1;
 } else if (i4) {
  HEAP32[i9 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i9 + 4 | 0;
  i2 = i7 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i3;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
   i4 = i8 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i5;
   i5 = 2;
  } else i5 = 1;
 } else i5 = 0; while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i9 = i5;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i4 = i7 + 4 | 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i9 = i5 + 1 | 0;
  return i9 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i9 = i5 + 2 | 0;
  return i9 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 i8 = i8 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i9;
 i9 = i5 + 3 | 0;
 return i9 | 0;
}

function __ZN5physx2Gu32PCMConvexVsMeshContactGeneration31generatePolyDataContactManifoldERNS0_9TriangleVEjjhPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNS8_5Vec3VE(i7, i3, i2, i9, i8, i4, i5, i1, i6) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10;
 i13 = i7 + 4420 | 0;
 i20 = HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0;
 i12 = i20 + (i2 * 20 | 0) | 0;
 i7 = i7 + 4424 | 0;
 i18 = HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i12 >> 2]);
 f14 = Math_fround(HEAPF32[i20 + (i2 * 20 | 0) + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i20 + (i2 * 20 | 0) + 8 >> 2]);
 f16 = Math_fround(f19 * Math_fround(HEAPF32[i18 >> 2]));
 f16 = Math_fround(f16 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 4 >> 2])));
 f16 = Math_fround(f16 + Math_fround(f17 * Math_fround(HEAPF32[i18 + 8 >> 2])));
 f15 = Math_fround(f19 * Math_fround(HEAPF32[i18 + 16 >> 2]));
 f15 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 20 >> 2])));
 f15 = Math_fround(f15 + Math_fround(f17 * Math_fround(HEAPF32[i18 + 24 >> 2])));
 f19 = Math_fround(f19 * Math_fround(HEAPF32[i18 + 32 >> 2]));
 f14 = Math_fround(f19 + Math_fround(f14 * Math_fround(HEAPF32[i18 + 36 >> 2])));
 f17 = Math_fround(f14 + Math_fround(f17 * Math_fround(HEAPF32[i18 + 40 >> 2])));
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f15 * f15)) + Math_fround(f17 * f17)))));
 f16 = Math_fround(f16 * f14);
 f15 = Math_fround(f15 * f14);
 f14 = Math_fround(f17 * f14);
 HEAPF32[i11 >> 2] = f16;
 HEAPF32[i11 + 4 >> 2] = f15;
 HEAPF32[i11 + 8 >> 2] = f14;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 f15 = Math_fround(-f15);
 f14 = Math_fround(-f14);
 HEAPF32[i6 >> 2] = Math_fround(-f16);
 HEAPF32[i6 + 4 >> 2] = f15;
 HEAPF32[i6 + 8 >> 2] = f14;
 HEAPF32[i6 + 12 >> 2] = Math_fround(0.0);
 __ZN5physxL21generatedPolyContactsERKNS_2Gu13PolygonalDataERKNS0_15HullPolygonDataERKNS0_9TriangleVEjhPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE(HEAP32[i13 >> 2] | 0, i12, i3, i9, i8, HEAP32[i7 >> 2] | 0, i4, i5, i1, i11);
 STACKTOP = i10;
 return 1;
}

function __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i1 = i9 + 8 | 0;
 i4 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i7 = i1 + 11 | 0;
 i5 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i6, i5, i8);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 i7 = i2 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i5 = i2 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i11 = HEAP32[i8 >> 2] | 0;
  i11 = _llvm_bswap_i32(i11 | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i9;
  return;
 } else {
  i11 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i7 >> 2] = i2;
  i11 = _llvm_bswap_i32(i11 | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE8__appendEj(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (((i1 - i3 | 0) / 192 | 0) >>> 0 >= i5 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE18__construct_at_endEj(i9, i5);
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = ((i3 - i2 | 0) / 192 | 0) + i5 | 0;
 if (i4 >>> 0 > 22369621) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i1 - i2 | 0) / 192 | 0;
 i1 = i8 << 1;
 i1 = i8 >>> 0 < 11184810 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 22369621;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i9 + 8;
 if (!i1) i4 = 0; else i4 = __Znwj(i1 * 192 | 0) | 0;
 HEAP32[i12 >> 2] = i4;
 i6 = i4 + (((i3 - i2 | 0) / 192 | 0) * 192 | 0) | 0;
 i8 = i12 + 8 | 0;
 HEAP32[i8 >> 2] = i6;
 i7 = i12 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = i4 + (i1 * 192 | 0);
 __ZNSt3__214__split_bufferIN9ShaderLab20SerializedSubProgramERNS_9allocatorIS2_EEE18__construct_at_endEj(i12, i5);
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = i7;
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  do {
   i2 = i2 + -192 | 0;
   __ZN9ShaderLab20SerializedSubProgramC2ERKS0_(i1 + -192 | 0, i2);
   i1 = (HEAP32[i7 >> 2] | 0) + -192 | 0;
   HEAP32[i7 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i4 = i7;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  do {
   i11 = i1 + -192 | 0;
   HEAP32[i8 >> 2] = i11;
   __ZN9ShaderLab20SerializedSubProgramD2Ev(i11);
   i1 = HEAP32[i8 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE10visitCellsERKNS4_11OverlapLineE(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) > (i9 | 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i7 = (HEAP32[i11 + 52 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 32 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 36 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 56 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 44 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 40 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i7) | 0) + i3 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 } else {
  i7 = (HEAP32[i11 + 56 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 40 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 44 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 52 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 36 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 32 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i3) | 0) + i7 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 }
 return 0;
}

function __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_S2_S2_b(i1, i2, d3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 120 | 0;
 i9 = i10;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
  i9 = 2;
  STACKTOP = i10;
  return i9 | 0;
 }
 i11 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i11 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i11 & 255) | 0)) {
  i11 = 6;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP8[i4 + 11 >> 0] | 0;
 if (!((i11 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i11 & 255) | 0)) {
  i11 = 6;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = __ZN11UnityEngine15PlatformWrapper16GenerateRandomIdEv() | 0;
 __ZN11UnityEngine9Analytics16TransactionEventC2ERK8UnityStrdS4_S4_S4_yb(i9, i2, d3, i4, i5, i6, i11, getTempRet0() | 0, i7);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i9, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i9 >> 2] = gb + 188628 + 8;
 i1 = i9 + 84 | 0;
 i2 = i9 + 100 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i9 + 112 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 96 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 i1 = i9 + 56 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 68 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 i1 = i9 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 44 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 HEAP32[i9 >> 2] = gb + 190148 + 8;
 i1 = i9 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i9 + 16 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
 }
 i11 = 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN12_GLOBAL__N_127PrepareReadback_ResolveMSAAER18GfxFramebufferGLESR7ApiGLESP17RenderSurfaceGLESS5_(i4, i5, i6, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i7 = i8;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!i1) i2 = 6; else if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 125 >> 0] | 0)) i2 = 6; else {
  i9 = __ZN2gl15IsFormatIEEE754ENS_9TexFormatE(HEAP32[i6 + 40 >> 2] | 0) | 0;
  if (!(i9 ^ (__ZN2gl15IsFormatIEEE754ENS_9TexFormatE(HEAP32[i1 + 40 >> 2] | 0) | 0))) i2 = 6;
 }
 do if ((i2 | 0) == 6) if (!(HEAP8[i6 + 31 >> 0] | 0)) {
  if ((HEAP32[i6 + 16 >> 2] | 0) >>> 0 > 1) break; else i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 } else {
  if ((__ZNK7ApiGLES3GetEj(i5, 32937) | 0) > 0) break; else i1 = 0;
  STACKTOP = i8;
  return i1 | 0;
 } while (0);
 if (!(HEAP8[i1 + 31 >> 0] | 0)) i1 = HEAP32[i1 + 40 >> 2] | 0; else {
  i1 = (HEAP32[i1 + 20 >> 2] | 0) >>> 2 & 1;
  i9 = HEAP32[i5 + 860 >> 2] | 0;
  i1 = __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i9, HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0, i1) | 0;
 }
 i11 = __Z16GetRealGfxDevicev() | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 420 >> 2] | 0, i11 | 0) | 0;
 i10 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 i9 = __Z16GetRealGfxDevicev() | 0;
 i9 = mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 384 >> 2] | 0, i9 | 0, 1) | 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i9 + 8 >> 2] = i2;
 HEAP32[i9 + 12 >> 2] = 1;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 2;
 HEAP32[i9 + 16 >> 2] = 1;
 HEAP8[i9 + 31 >> 0] = 0;
 __ZN4gles24CreateColorRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE(i5, i9, i1);
 __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_(i4, i9, i6);
 __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i7, i4, i9);
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i5, 1, i3);
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN21LightProbeProxyVolume27ValidateBoundingBoxSettingsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 24 | 0;
 i7 = i10;
 if ((HEAP32[i1 + 36 >> 2] | 0) != 2) {
  STACKTOP = i10;
  return;
 }
 i8 = i1 + 64 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(HEAPF32[gb + 62500 >> 2]);
 if (!(f6 == f9)) {
  STACKTOP = i10;
  return;
 }
 i3 = i1 + 68 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62500 + 4 >> 2]);
 if (!(f6 == f4)) {
  STACKTOP = i10;
  return;
 }
 i5 = i1 + 72 | 0;
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = Math_fround(HEAPF32[gb + 62500 + 8 >> 2]);
 if (!(f11 == f6)) {
  STACKTOP = i10;
  return;
 };
 HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f16 = Math_fround(-f4);
 f4 = Math_fround(-f6);
 i19 = i7 + 12 | 0;
 HEAPF32[i19 >> 2] = Math_fround(-f9);
 i18 = i7 + 16 | 0;
 HEAPF32[i18 >> 2] = f16;
 i17 = i7 + 20 | 0;
 HEAPF32[i17 >> 2] = f4;
 i20 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i2, i20);
 __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB(i2, i20, i7);
 f4 = Math_fround(HEAPF32[i19 >> 2]);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 f16 = Math_fround(f4 - f6);
 f13 = Math_fround(HEAPF32[i18 >> 2]);
 f9 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f15 = Math_fround(f13 - f9);
 f12 = Math_fround(HEAPF32[i17 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f15 = Math_fround(Math_fround(f15 * Math_fround(.5)) * Math_fround(2.0));
 f14 = Math_fround(Math_fround(Math_fround(f12 - f11) * Math_fround(.5)) * Math_fround(2.0));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(f16 * Math_fround(.5)) * Math_fround(2.0));
 HEAPF32[i3 >> 2] = f15;
 HEAPF32[i5 >> 2] = f14;
 f9 = Math_fround(Math_fround(f13 + f9) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f12 + f11) * Math_fround(.5));
 HEAPF32[i1 + 76 >> 2] = Math_fround(Math_fround(f4 + f6) * Math_fround(.5));
 HEAPF32[i1 + 80 >> 2] = f9;
 HEAPF32[i1 + 84 >> 2] = f11;
 STACKTOP = i10;
 return;
}

function __ZN20ArchiveStorageHeader6HeaderC2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = HEAP32[gb + 70780 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i4;
  if (!i4) i1 = i6; else {
   i1 = i6;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i8 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i4;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i6 + 16 >> 2] = 6;
 i2 = i6 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 5;
 HEAP8[i2 >> 0] = HEAP8[gb + 490128 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[gb + 490128 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 490128 + 2 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 490128 + 3 >> 0] | 0;
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 490128 + 4 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = 0;
 i2 = i6 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 48 >> 2] = i1;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 + 44 >> 2] = -2147483632;
 HEAP32[i6 + 40 >> 2] = 13;
 i2 = i1;
 i3 = gb + 1040146 | 0;
 i4 = i2 + 13 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i1 + 13 >> 0] = 0;
 i8 = i6 + 56 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN13RuntimeStaticI13ModuleManagerE10InitializeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = __ZnwjRK10MemLabelIdiPKci(3092, i2, i3, gb + 1041912 | 0, 65) | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 768 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 1540 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 2312 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 2316 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 3084 >> 2] = 0;
  HEAP8[i2 + 3088 >> 0] = 0;
  HEAP32[i4 >> 2] = i2;
  return;
 } else {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(3092, i2, i3, i1, i4 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 768 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 1540 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 2312 >> 2] = 0;
  i1 = 0;
  do {
   HEAP32[i2 + 2316 + (i1 * 12 | 0) >> 2] = 0;
   HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] = 0;
   HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  HEAP32[i2 + 3084 >> 2] = 0;
  HEAP8[i2 + 3088 >> 0] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i4 >> 2] = i2;
  return;
 }
}

function __ZN12_GLOBAL__N_112UserRenderer21visualizeAngularLimitERKN5physx11PxTransformEffb(i4, i3, f2, f5, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 48 | 0;
 i9 = i6 + 40 | 0;
 i14 = i6;
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 i17 = i14 + 4 | 0;
 HEAP32[i17 >> 2] = HEAP32[i3 + 4 >> 2];
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i3 + 8 >> 2];
 i15 = i14 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 i13 = i14 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 + 20 >> 2];
 i12 = i14 + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i3 + 24 >> 2];
 i11 = i14 + 28 | 0;
 HEAPF32[i11 >> 2] = f2;
 i10 = i14 + 32 | 0;
 HEAPF32[i10 >> 2] = f5;
 i7 = i14 + 36 | 0;
 HEAP8[i7 >> 0] = i1 & 1;
 i19 = i4 + 8 | 0;
 HEAP32[i9 >> 2] = gb + 150564 + 8;
 HEAP32[i9 + 4 >> 2] = i19;
 i1 = i4 + 24 | 0;
 i3 = i4 + 20 | 0;
 i18 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i19, i18 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i18 >> 0] = 7;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i17 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i15 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i14 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i11 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i10 | 0);
 HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, i8 | 0);
 HEAP8[i7 >> 0] = (HEAP8[i8 >> 0] | 0) != 0 & 1;
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i6;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra15KDTraverseStackIjE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbjj(i6, i7, f8, i1, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i2 = (i7 | 0) == 3;
 i11 = i2 & 1;
 i12 = i6 + 28 | 0;
 if (i2) {
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = i6 + 32 + ((i4 + 1 | 0) * 40 | 0) | 0;
  i4 = i6 + 32 + (i4 * 40 | 0) | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 }
 i1 = i2 & i1 & 1;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = __ZNK5Umbra6KDTree4rankEi(i6, HEAP32[i6 + 32 + (i2 * 40 | 0) + 12 >> 2] | 0) | 0;
 i4 = i3 << 1;
 i5 = HEAPU8[i6 + 32 + (i2 * 40 | 0) + 29 >> 0] | 0;
 if (i7 & 2 | 0) {
  i2 = i2 + ((i1 ^ 1) & i11) | 0;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 12 >> 2] = i4;
  i3 = i3 << 2;
  HEAP8[i6 + 32 + (i2 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (i3 >> 5 << 2) >> 2] | 0) >>> (i3 & 28) & 3;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 32 >> 2] = 2;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 36 >> 2] = i10;
  HEAPF32[i6 + 32 + (i2 * 40 | 0) + (i5 << 2) >> 2] = f8;
  i10 = i6 + 32 + (i2 * 40 | 0) + 28 | 0;
  HEAP8[i10 >> 0] = (HEAP8[i10 >> 0] | 0) + 1 << 24 >> 24;
  i10 = i6 + 32 + (i2 * 40 | 0) + 30 | 0;
  HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) & (1 << (i5 << 1) ^ 255);
 }
 if (!(i7 & 1)) {
  i10 = HEAP32[i12 >> 2] | 0;
  i11 = i10 + i11 | 0;
  HEAP32[i12 >> 2] = i11;
  return;
 }
 i10 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
 i7 = i4 + -1 | 0;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 12 >> 2] = i7;
 i7 = i7 << 1;
 HEAP8[i6 + 32 + (i10 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (i7 >> 5 << 2) >> 2] | 0) >>> (i7 & 30) & 3;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 32 >> 2] = 1;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 36 >> 2] = i9;
 HEAPF32[i6 + 32 + (i10 * 40 | 0) + 16 + (i5 << 2) >> 2] = f8;
 i9 = i6 + 32 + (i10 * 40 | 0) + 28 | 0;
 HEAP8[i9 >> 0] = (HEAP8[i9 >> 0] | 0) + 1 << 24 >> 24;
 i10 = i6 + 32 + (i10 * 40 | 0) + 30 | 0;
 HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) & (2 << (i5 << 1) ^ 255);
 i10 = HEAP32[i12 >> 2] | 0;
 i11 = i10 + i11 | 0;
 HEAP32[i12 >> 2] = i11;
 return;
}

function __ZN5Umbra15KDTraverseStackIiE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbii(i6, i7, f8, i1, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i2 = (i7 | 0) == 3;
 i11 = i2 & 1;
 i12 = i6 + 28 | 0;
 if (i2) {
  i4 = HEAP32[i12 >> 2] | 0;
  i5 = i6 + 32 + ((i4 + 1 | 0) * 40 | 0) | 0;
  i4 = i6 + 32 + (i4 * 40 | 0) | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 }
 i1 = i2 & i1 & 1;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = __ZNK5Umbra6KDTree4rankEi(i6, HEAP32[i6 + 32 + (i2 * 40 | 0) + 12 >> 2] | 0) | 0;
 i4 = i3 << 1;
 i5 = HEAPU8[i6 + 32 + (i2 * 40 | 0) + 29 >> 0] | 0;
 if (i7 & 2 | 0) {
  i2 = i2 + ((i1 ^ 1) & i11) | 0;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 12 >> 2] = i4;
  i3 = i3 << 2;
  HEAP8[i6 + 32 + (i2 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (i3 >> 5 << 2) >> 2] | 0) >>> (i3 & 28) & 3;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 32 >> 2] = 2;
  HEAP32[i6 + 32 + (i2 * 40 | 0) + 36 >> 2] = i10;
  HEAPF32[i6 + 32 + (i2 * 40 | 0) + (i5 << 2) >> 2] = f8;
  i10 = i6 + 32 + (i2 * 40 | 0) + 28 | 0;
  HEAP8[i10 >> 0] = (HEAP8[i10 >> 0] | 0) + 1 << 24 >> 24;
  i10 = i6 + 32 + (i2 * 40 | 0) + 30 | 0;
  HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) & (1 << (i5 << 1) ^ 255);
 }
 if (!(i7 & 1)) {
  i10 = HEAP32[i12 >> 2] | 0;
  i11 = i10 + i11 | 0;
  HEAP32[i12 >> 2] = i11;
  return;
 }
 i10 = (HEAP32[i12 >> 2] | 0) + i1 | 0;
 i7 = i4 + -1 | 0;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 12 >> 2] = i7;
 i7 = i7 << 1;
 HEAP8[i6 + 32 + (i10 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + (i7 >> 5 << 2) >> 2] | 0) >>> (i7 & 30) & 3;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 32 >> 2] = 1;
 HEAP32[i6 + 32 + (i10 * 40 | 0) + 36 >> 2] = i9;
 HEAPF32[i6 + 32 + (i10 * 40 | 0) + 16 + (i5 << 2) >> 2] = f8;
 i9 = i6 + 32 + (i10 * 40 | 0) + 28 | 0;
 HEAP8[i9 >> 0] = (HEAP8[i9 >> 0] | 0) + 1 << 24 >> 24;
 i10 = i6 + 32 + (i10 * 40 | 0) + 30 | 0;
 HEAP8[i10 >> 0] = (HEAPU8[i10 >> 0] | 0) & (2 << (i5 << 1) ^ 255);
 i10 = HEAP32[i12 >> 2] | 0;
 i11 = i10 + i11 | 0;
 HEAP32[i12 >> 2] = i11;
 return;
}

function __ZN19ShaderPropertySheet18SetTextureUnscaledERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i14, i13, i9, i11, i12) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i10 = 0, f15 = f0, f16 = f0;
 i1 = HEAP32[i14 + 20 >> 2] | 0;
 i8 = HEAP32[i14 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i8 | 0)) {
  i2 = HEAP32[i14 + 32 >> 2] | 0;
  i6 = HEAP32[i13 >> 2] | 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) {
    i10 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i8 = HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i10 = 7;
 } else i10 = 7; while (0);
 if ((i10 | 0) == 7) i8 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i14, i13, 0) | 0;
 __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i14, i8, i13, i9, 0);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f15 = Math_fround(f5 + Math_fround(-1.0));
 i12 = f15 < Math_fround(0.0);
 f16 = Math_fround(-f15);
 if ((i12 ? f16 : f15) <= Math_fround(9.99999997e-07)) {
  f16 = Math_fround(f3 + Math_fround(-1.0));
  i12 = f16 < Math_fround(0.0);
  f15 = Math_fround(-f16);
  i12 = (i12 ? f15 : f16) <= Math_fround(9.99999997e-07);
  f5 = i12 ? Math_fround(1.0) : f5;
  f3 = i12 ? Math_fround(1.0) : f3;
 }
 i12 = f7 < Math_fround(0.0);
 f16 = Math_fround(-f7);
 if ((i12 ? f16 : f7) <= Math_fround(9.99999997e-07)) {
  i12 = f4 < Math_fround(0.0);
  f16 = Math_fround(-f4);
  i12 = (i12 ? f16 : f4) <= Math_fround(9.99999997e-07);
  f7 = i12 ? Math_fround(0.0) : f7;
  f4 = i12 ? Math_fround(0.0) : f4;
 }
 i6 = i14 + 72 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + i8 + 20 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i14, i13, gb + 478716 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 + i8 + 20 >> 2] = i2;
 }
 i14 = i1 + (HEAP32[(HEAP32[i14 + 52 >> 2] | 0) + ((HEAP32[i14 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i14 >> 2] = f5;
 HEAPF32[i14 + 4 >> 2] = f3;
 HEAPF32[i14 + 8 >> 2] = f7;
 HEAPF32[i14 + 12 >> 2] = f4;
 return;
}

function __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 92 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 76 | 0;
 i8 = HEAP32[gb + 37320 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946522 | 0, i8, i6, 0);
 i7 = i2 + 20 | 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 84 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800705 | 0, i8, i6, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i7) | 0) + 20 >> 2] | 2097152;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14ParticleSystem15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 618922 | 0, gb + 621745 | 0, gb + 621751 | 0);
 i4 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63264 | 0, 16, gb + 612988 | 0, 238) | 0;
 __ZN21ParticleSystemManagerC2Ev(i4);
 HEAP32[gb + 1451700 >> 2] = i4;
 if (__Z13GetIAnimationv() | 0) {
  i4 = __ZnwjRK10MemLabelIdiPKci(100, gb + 63264 | 0, 16, gb + 621767 | 0, 17) | 0;
  __ZN29ParticleSystemPropertyBindingC2Ev(i4);
  HEAP32[gb + 1452340 >> 2] = i4;
  i4 = __Z13GetIAnimationv() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, 198, 27, HEAP32[gb + 1452340 >> 2] | 0);
 }
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 80300 | 0, gb + 1105016 | 0, fb + 749 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 80300 | 0, gb + 1105156 | 0, fb + 750 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 80300 | 0, gb + 1105196 | 0, fb + 751 | 0, 0);
 HEAP32[gb + 1115296 + 244 >> 2] = fb + 194;
 HEAP32[gb + 1115296 + 284 >> 2] = fb + 195;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6944 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 <= 63) {
  i1 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 6176 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 6176 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i2 + 6176 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 196;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i1, gb + 1048800 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 + 1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i2 + 6176 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 6176 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i2 + 6176 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 196;
 STACKTOP = i5;
 return;
}

function __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 118 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 100 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 104 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 117 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 108 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z15reserve_trimmedINSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 32 | 0;
 i6 = i15 + 24 | 0;
 i14 = i15;
 i7 = i15 + 20 | 0;
 i8 = i15 + 16 | 0;
 i11 = i9 + 8 | 0;
 if (((HEAP32[i11 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) >> 2 | 0) == (i5 | 0)) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i14 >> 2] = 0;
 i13 = i14 + 4 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i14 + 12 >> 2] = i1;
 i10 = i14 + 8 | 0;
 if (!i5) i1 = i13; else {
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) - i1 | 0;
  i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
  if ((i2 | 0) > 0) {
   _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
   i1 = HEAP32[i14 >> 2] | 0;
  }
  HEAP32[i14 >> 2] = i4;
  HEAP32[i13 >> 2] = i3;
  HEAP32[i10 >> 2] = i3 + (i5 << 2);
  if (!i1) i1 = i13; else {
   i5 = HEAP32[i14 + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 1;
   HEAP32[i12 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
   i1 = i13;
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i14, i6, i12);
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 HEAP32[i14 >> 2] = i3;
 HEAP32[i9 >> 2] = i2;
 i9 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i5 >> 2] = i9;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i1;
 i1 = i3;
 if (i3 | 0) {
  if ((i2 | 0) != (i3 | 0)) HEAP32[i13 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
  i14 = HEAP32[i14 + 12 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 }
 STACKTOP = i15;
 return;
}

function __ZN21AssetReferenceStorage12AddReferenceEi(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 16 | 0;
 i4 = i12 + 8 | 0;
 i10 = i12;
 HEAP32[i4 >> 2] = i1;
 i6 = i9 + 36 | 0;
 i7 = i9 + 4 | 0;
 if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
  i8 = i9 + 28 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i5, i9, i4);
  i1 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 28 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  i11 = i1;
  i11 = i11 + 4 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i10 = i10 + 1 | 0;
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj(i9, 1, 0);
 __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i5, i9, i10);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i3 = i5 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i9 + 8 >> 0] | 0)) i11 = 11; else {
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) i11 = 11; else {
    i1 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[i9 + 12 >> 2] | 0) == (HEAP32[i1 + (i4 << 3) >> 2] | 0)) HEAP32[i7 >> 2] = i2 + -1; else i11 = 11;
   }
  }
  if ((i11 | 0) == 11) {
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = i1 + (i4 << 3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = i11;
  i1 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i3 >> 2] << 3) | 0;
 } else i1 = (HEAP32[i8 >> 2] | 0) + (i1 << 3) | 0;
 i11 = i1;
 i11 = i11 + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValues18TransferBaseValuesI8JSONReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i5 + 4 | 0;
 i7 = i6 + 36 | 0;
 HEAP8[i7 >> 0] = 0;
 i8 = i6 + 40 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i4 | 0) if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
  i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1041356 | 0) | 0;
  HEAP32[i8 >> 2] = i9;
  i1 = i6 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37260 >> 2];
  if (i9 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
   __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i3);
   HEAP8[i7 >> 0] = 1;
   i9 = i6 + 56 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  }
  HEAP32[i8 >> 2] = i4;
  HEAP32[i1 >> 2] = i2;
 }
 __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 52 | 0, gb + 1041368 | 0, 0, 0);
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i6, i5 + 56 | 0, gb + 1041382 | 0, 0, 0);
 i1 = i5 + 20 | 0;
 HEAP8[i7 >> 0] = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (!i4) {
  HEAP8[i7 >> 0] = 0;
  return;
 }
 if ((HEAP32[i4 + 16 >> 2] | 0) == 3) {
  i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1041396 | 0) | 0;
  HEAP32[i8 >> 2] = i9;
  i2 = i6 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 37260 >> 2];
  if (i9 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
   __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i1);
   HEAP8[i7 >> 0] = 1;
   i9 = i6 + 56 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  }
  HEAP32[i8 >> 2] = i4;
  HEAP32[i2 >> 2] = i3;
 }
 HEAP8[i7 >> 0] = 0;
 if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, gb + 1041407 | 0) | 0;
 HEAP32[i8 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37260 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, 0);
  __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_(i6, i5 + 36 | 0);
  HEAP8[i7 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZL50StaticRegisterSceneLoadedCallback_LightmapSettingsPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 5400 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 4632 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) >> 2] = fb + 504;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 2312 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 1544 + (i1 * 12 | 0) >> 2] = fb + 3375;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 37052 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 36284 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 36284 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 36284 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 2402;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 36284 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 36284 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 36284 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 2402;
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = i4 + 76 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0);
 if (!(HEAP32[i6 >> 2] | 0)) {
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i4 + 36 | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
  i2 = i3 + 4 | 0;
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i4 + 40 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  i6 = i3 + 8 | 0;
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i4 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i4 + 80 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i7 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = i7 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i7 + 24 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i4 + 64 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f8);
 i2 = i3 + 4 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i4 + 68 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
 i6 = i3 + 8 | 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i4 + 72 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i4 + 80 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i7 + 44 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i7 + 48 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f8);
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0);
 STACKTOP = i5;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i6 + 84 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = 54;
 HEAP32[i8 + 4 >> 2] = i10;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i11 = i6 + 60 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = i6 + 64 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
 i4 = i1 + (i5 * 24 | 0) | 0;
 if (i5) {
  i3 = i10;
  while (1) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 12 | 0, i1 + 12 | 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 24 | 0;
  }
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i10 + (i2 * 24 | 0) | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i4 = i6 + 36 | 0;
  i2 = i6 + 48 | 0;
  i1 = i10 + (i3 * 24 | 0) | 0;
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 12 | 0, i2);
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != (i5 | 0));
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if (!i2) {
  i7 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i12;
  return;
 } else i1 = 0;
 do {
  i7 = HEAP32[i11 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7 + (i1 * 24 | 0) + 12 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7 + (i1 * 24 | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = HEAP32[i11 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = 54;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer18visualizeLimitConeERKN5physx11PxTransformEffb(i3, i2, f4, f5, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 48 | 0;
 i9 = i6 + 40 | 0;
 i14 = i6;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 i17 = i14 + 4 | 0;
 HEAP32[i17 >> 2] = HEAP32[i2 + 4 >> 2];
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 + 8 >> 2];
 i15 = i14 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i14 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 i13 = i14 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 + 20 >> 2];
 i12 = i14 + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 + 24 >> 2];
 i11 = i14 + 28 | 0;
 HEAPF32[i11 >> 2] = f4;
 i10 = i14 + 32 | 0;
 HEAPF32[i10 >> 2] = f5;
 i7 = i14 + 36 | 0;
 HEAP8[i7 >> 0] = i1 & 1;
 i19 = i3 + 8 | 0;
 HEAP32[i9 >> 2] = gb + 150564 + 8;
 HEAP32[i9 + 4 >> 2] = i19;
 i1 = i3 + 24 | 0;
 i2 = i3 + 20 | 0;
 i18 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i19, i18 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i18 >> 0] = 8;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i17 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i15 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i14 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i11 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i10 | 0);
 HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, i8 | 0);
 HEAP8[i7 >> 0] = (HEAP8[i8 >> 0] | 0) != 0 & 1;
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i6;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0);
 STACKTOP = i6;
 return;
}

function __ZN12TreeInstance8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}
function __Z11FitTangentsI11QuaternionfEvR11KeyframeTplIT_ES4_ffRKS2_S6_(i3, i4, f1, f2, i16, i17) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i16 = i16 | 0;
 i17 = i17 | 0;
 var f5 = f0, i6 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, i18 = 0, i19 = 0, i20 = 0, d21 = 0.0, d22 = 0.0, d23 = 0.0, d24 = 0.0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20 + 16 | 0;
 i19 = i20;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 >> 2]));
 if (Math_fround(Math_abs(Math_fround(f5))) < Math_fround(1.1920929e-07)) {
  i18 = i3 + 36 | 0;
  i19 = i4 + 20 | 0;
  HEAPF32[i18 >> 2] = Math_fround(0.0);
  HEAPF32[i19 >> 2] = Math_fround(0.0);
  HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i18 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
  STACKTOP = i20;
  return;
 }
 i6 = i3 + 4 | 0;
 HEAP32[i18 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i18 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i18 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i18 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i6 = i4 + 4 | 0;
 HEAP32[i19 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i19 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i19 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i19 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 d13 = +f1;
 d14 = d13 * d13;
 d11 = d13 * d14;
 d15 = d11 * 2.0;
 d21 = d14 * 3.0;
 d12 = d15 - d21 + 1.0;
 d13 = d13 + (d11 - d14 * 2.0);
 d14 = d11 - d14;
 d15 = d21 - d15;
 d21 = +f2;
 d11 = d21 * d21;
 d7 = d21 * d11;
 d10 = d7 * 2.0;
 d22 = d11 * 3.0;
 d8 = d10 - d22 + 1.0;
 d9 = d7 - d11;
 d10 = d22 - d10;
 d11 = d13 / d14 - (d21 + (d7 - d11 * 2.0)) / d9;
 d7 = +f5;
 i6 = i3 + 36 | 0;
 i4 = i4 + 20 | 0;
 i3 = 0;
 do {
  d21 = +Math_fround(HEAPF32[i16 + (i3 << 2) >> 2]);
  d24 = +Math_fround(HEAPF32[i17 + (i3 << 2) >> 2]);
  d23 = +Math_fround(HEAPF32[i18 + (i3 << 2) >> 2]);
  d22 = +Math_fround(HEAPF32[i19 + (i3 << 2) >> 2]);
  d21 = d21 - d12 * d23 - d15 * d22;
  d22 = (d21 / d14 - (d24 - d8 * d23 - d10 * d22) / d9) / d11;
  HEAPF32[i6 + (i3 << 2) >> 2] = Math_fround(d22 / d7);
  HEAPF32[i4 + (i3 << 2) >> 2] = Math_fround((d21 - d13 * d22) / d14 / d7);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 4);
 STACKTOP = i20;
 return;
}

function _decode_mcu_DC_refine(i5, i10) {
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i16 = HEAP32[i5 + 408 >> 2] | 0;
 i11 = 1 << HEAP32[i5 + 376 >> 2];
 i4 = i5 + 252 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i16 + 40 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i13 = i16 + 16 | 0;
   i14 = HEAP32[i5 + 404 >> 2] | 0;
   i12 = i14 + 20 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) / 8 | 0);
   HEAP32[i13 >> 2] = 0;
   if (!((mftCall_ii(HEAP32[i14 + 8 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
    i16 = 0;
    STACKTOP = i17;
    return i16 | 0;
   }
   i3 = i5 + 292 | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    i1 = 0;
    do {
     HEAP32[i16 + 24 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
   }
   HEAP32[i16 + 20 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   if (!(HEAP32[i5 + 380 >> 2] | 0)) HEAP8[i16 + 8 >> 0] = 0;
  }
 }
 HEAP32[i15 + 16 >> 2] = i5;
 i9 = i5 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i15 >> 2] = i2;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i12 = i15 + 4 | 0;
 HEAP32[i12 >> 2] = i1;
 i13 = i16 + 12 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i14 = i16 + 16 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i8 = i5 + 320 | 0;
 do if ((HEAP32[i8 >> 2] | 0) > 0) {
  i5 = i15 + 8 | 0;
  i7 = i15 + 12 | 0;
  i3 = 0;
  i1 = i6;
  while (1) {
   i2 = HEAP32[i10 + (i3 << 2) >> 2] | 0;
   if ((i1 | 0) < 1) {
    if (!((_jpeg_fill_bit_buffer(i15, i4, i1, 1) | 0) << 24 >> 24)) {
     i1 = 0;
     i5 = 18;
     break;
    }
    i1 = HEAP32[i7 >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
   }
   i1 = i1 + -1 | 0;
   if (1 << i1 & i4 | 0) HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | i11;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (HEAP32[i8 >> 2] | 0)) {
    i5 = 16;
    break;
   }
  }
  if ((i5 | 0) == 16) {
   i6 = i1;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i15 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
   break;
  } else if ((i5 | 0) == 18) {
   STACKTOP = i17;
   return i1 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i14 >> 2] = i6;
 i16 = i16 + 40 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + -1;
 i16 = 1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx7Cooking19computeHullPolygonsERKNS_20PxSimpleTriangleMeshERNS_19PxAllocatorCallbackERjRPNS_6PxVec3ES6_RPjS6_RPNS_13PxHullPolygonE(i1, i10, i16, i20, i21, i18, i17, i19, i15) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i19 = i19 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i11 = i10 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i1 * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i2 = i12;
  i3 = HEAP32[i10 + 4 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   i5 = i2;
   i6 = i3;
   i7 = i5 + 12 | 0;
   do {
    HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
    i5 = i5 + 1 | 0;
    i6 = i6 + 1 | 0;
   } while ((i5 | 0) < (i7 | 0));
   if (!i1) break; else {
    i2 = i2 + 12 | 0;
    i3 = i3 + i4 | 0;
   }
  }
 }
 i4 = i10 + 12 | 0;
 i8 = i10 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i1 * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP16[i10 + 24 >> 1] & 2)) {
  i4 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i3 = i9;
   i2 = HEAP32[i10 + 16 >> 2] | 0;
   while (1) {
    i1 = i1 + -1 | 0;
    i5 = i3;
    i6 = i2;
    i7 = i5 + 12 | 0;
    do {
     HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
     i5 = i5 + 1 | 0;
     i6 = i6 + 1 | 0;
    } while ((i5 | 0) < (i7 | 0));
    if (!i1) break; else {
     i3 = i3 + 12 | 0;
     i2 = i2 + i4 | 0;
    }
   }
  }
 } else {
  i2 = i9 + (i1 * 3 << 2) | 0;
  if (i9 >>> 0 < i2 >>> 0) {
   i3 = i9;
   i1 = HEAP32[i10 + 16 >> 2] | 0;
   while (1) {
    HEAP32[i3 >> 2] = HEAPU16[i1 >> 1];
    HEAP32[i3 + 4 >> 2] = HEAPU16[i1 + 2 >> 1];
    HEAP32[i3 + 8 >> 2] = HEAPU16[i1 + 4 >> 1];
    i3 = i3 + 12 | 0;
    if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + (HEAP32[i4 >> 2] | 0) | 0;
   }
  }
 }
 __ZN5physx17ConvexMeshBuilderC2Ev(i13);
 i21 = __ZN5physx17ConvexMeshBuilder19computeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_RNS_19PxAllocatorCallbackERjRPS3_S9_RPjS9_RPNS_13PxHullPolygonE(i13, i11, i12, i8, i9, i16, i20, i21, i18, i17, i19, i15) | 0;
 __ZN5physx17ConvexMeshBuilderD2Ev(i13);
 STACKTOP = i14;
 return i21 | 0;
}

function __ZN19MeshParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047999 | 0, i6, i1 + 220 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048022 | 0, i6, i1 + 221 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048035 | 0, i6, i1 + 224 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048055 | 0, i6, i1 + 228 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 236 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i6, 0);
 i1 = i7 + 8 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN8JSONReadC2EPKc24TransferInstructionFlagsRK10MemLabelIdbPNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEi(i9, i10, i11, i12, i13, i1, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i1 = i9 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = i5;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 76 >> 2] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9 + 68 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i9 + 88 | 0;
 i2 = i9 + 108 | 0;
 i3 = i9 + 112 | 0;
 i4 = i9 + 136 | 0;
 i6 = i1;
 i8 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i4 >> 2] = 1024;
 HEAP32[i9 + 140 >> 2] = 0;
 HEAP32[i9 + 144 >> 2] = 0;
 i4 = __Znwj(1) | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i9 + 152 >> 2] = 0;
 HEAP32[i9 + 164 >> 2] = 0;
 HEAP32[i9 + 168 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i9 + 156 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 __ZN8JSONRead4InitE24TransferInstructionFlagsRK10MemLabelId(i9, i11, i12);
 if (i13) {
  HEAP32[i5 >> 2] = i10;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = i10;
  __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj1ES2_NS_25GenericInsituStringStreamIS2_EEEERS4_RT1_(i1, i5) | 0;
  i13 = i9 + 40 | 0;
  HEAP32[i13 >> 2] = i1;
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i5 >> 2] = i10;
  HEAP32[i5 + 4 >> 2] = i10;
  __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj0ES2_NS_19GenericStringStreamIS2_EEEERS4_RT1_(i1, i5) | 0;
  i13 = i9 + 40 | 0;
  HEAP32[i13 >> 2] = i1;
  STACKTOP = i7;
  return;
 }
}

function __ZN7Texture21SetMasterTextureLimitEib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i7 = i12;
 i10 = i12 + 36 | 0;
 i11 = i12 + 16 | 0;
 if ((HEAP32[gb + 1158376 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[gb + 1158376 >> 2] = i1;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i11 >> 2] = 0;
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i3 = i6;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 26572 | 0, i11, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i3 | 0) | 0) {
    mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 160 >> 2] | 0, i3 | 0, 0);
    mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0, i3 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = 0;
 i2 = i10 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i10 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i3 = i6;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31832 | 0, i10, 1);
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   HEAP8[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 132 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i5);
  HEAP32[i10 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i9);
  HEAP32[i11 >> 2] = 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN24MaterialDisplayListCache24GetCachedPassForMaterialERK18SharedMaterialDataPN9ShaderLab4PassE(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i10 + 188 | 0;
 i8 = i10 + 200 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 L1 : do if (i9 | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i9 >>> 0) break L1;
  }
  i10 = (HEAP32[i10 + 208 >> 2] | 0) + (i1 * 244 | 0) | 0;
  return i10 | 0;
 } while (0);
 i2 = i9 + 1 | 0;
 i3 = i10 + 204 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i10 + 192 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 192 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 HEAP32[(HEAP32[i7 >> 2] | 0) + (i9 << 2) >> 2] = i6;
 i2 = i10 + 208 | 0;
 i3 = i10 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 224 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 244 | 0, 4, i10 + 212 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 244 | 0, 4, i10 + 212 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 244 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i9 = HEAP32[i2 >> 2] | 0;
 i10 = i9 + (i4 * 244 | 0) | 0;
 _memset(i10 | 0, 0, 240) | 0;
 HEAP8[i9 + (i4 * 244 | 0) + 240 >> 0] = 3;
 HEAP8[i9 + (i4 * 244 | 0) + 241 >> 0] = 2;
 HEAP8[i9 + (i4 * 244 | 0) + 242 >> 0] = 1;
 HEAP8[i9 + (i4 * 244 | 0) + 243 >> 0] = 0;
 return i10 | 0;
}

function __ZN14MemoryProfiler18RegisterMemoryToIDEjj(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i7 = i12;
 i11 = HEAP32[i1 + 160 >> 2] | 0;
 i6 = i11 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = (i1 | 0) == 0;
 do if (i5) i2 = 18; else {
  i2 = i6;
  i4 = i1;
  L3 : while (1) {
   i3 = i4;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 >= i9 >>> 0) break;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) break L3;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) != (i6 | 0)) if (!((i2 | 0) == (i6 | 0) ? 1 : (HEAP32[i2 + 16 >> 2] | 0) >>> 0 > i9 >>> 0)) {
   i11 = i2 + 20 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i10;
   STACKTOP = i12;
   return;
  }
  if (i5) i2 = 18; else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i2 >>> 0 > i9 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 12;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i9 >>> 0) {
      i2 = 17;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 16;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 12) {
    HEAP32[i7 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 16) {
    HEAP32[i7 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 17) {
    HEAP32[i7 >> 2] = i1;
    i4 = i1;
    i3 = i7;
    break;
   }
  }
 } while (0);
 if ((i2 | 0) == 18) {
  HEAP32[i7 >> 2] = i6;
  i4 = i6;
  i3 = i6;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = 58;
  HEAP32[i8 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i2 + 4 >> 2] = i10;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i11 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 4 >> 2] | 0, i1);
  i11 = i11 + 12 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 }
 STACKTOP = i12;
 return;
}

function __ZL19BlitFramebufferImplRN4gles23BlitFramebufferDrawQuadER9GfxDevice9TextureIDRK8Vector4f(i4, i5, i1, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0, 0);
 __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv(HEAP32[gb + 1451080 >> 2] | 0, 0, HEAP32[i4 + 4 >> 2] | 0, 0, 4, 0, 0, 0);
 __ZN7ApiGLES22BindElementArrayBufferEj(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0);
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i2, i1, i3);
  i2 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(HEAP32[gb + 1451096 >> 2] | 0, HEAP32[i1 >> 2] | 0, 2, 0, 4);
 mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 128 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0, 0);
 mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, 1, i6 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 60 >> 2] | 0, i5 | 0, HEAP32[i4 + 28 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 68 >> 2] | 0, i5 | 0, HEAP32[i4 + 20 >> 2] | 0);
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 72 >> 2] | 0, i5 | 0, HEAP32[i4 + 24 >> 2] | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 64 >> 2] | 0, i5 | 0, HEAP32[i4 + 32 >> 2] | 0);
 __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj(HEAP32[gb + 1451080 >> 2] | 0, 0, 0, 3, 0, 1);
 __ZN7ApiGLES22BindElementArrayBufferEj(HEAP32[gb + 1451080 >> 2] | 0, 0);
 STACKTOP = i7;
 return;
}

function __Z13DrawWaterMarkb(i3) {
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 216 | 0;
 i4 = i8 + 20 | 0;
 i5 = i8;
 i6 = i8 + 16 | 0;
 i2 = HEAP32[gb + 42988 + 52 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[gb + 42988 + 48 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, _strlen(i2) | 0);
  i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 32032 | 0, i7) | 0;
  HEAP32[gb + 42988 + 52 >> 2] = i2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i2 = HEAP32[gb + 42988 + 52 >> 2] | 0;
  if (!i2) {
   STACKTOP = i8;
   return;
  }
 }
 f1 = Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
 if (f1 > Math_fround(9.0) & (i3 ^ 1)) {
  STACKTOP = i8;
  return;
 }
 if (f1 < Math_fround(2.5)) f1 = Math_fround(f1 + Math_fround(-1.5)); else if (i3) f1 = Math_fround(1.0); else f1 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f1 + Math_fround(-7.5)) / Math_fround(1.5)));
 i3 = f1 < Math_fround(0.0);
 i10 = f1 > Math_fround(1.0);
 f1 = i10 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 f1 = Math_fround(Math_fround(f1 * Math_fround(f1 * Math_fround(3.0))) + Math_fround(f1 * Math_fround(f1 * Math_fround(f1 * Math_fround(-2.0)))));
 f1 = Math_fround(Math_fround(f1 * Math_fround(128.0)) + Math_fround(Math_fround(Math_fround(1.0) - f1) * Math_fround(0.0)));
 i3 = __Z16GetScreenManagerv() | 0;
 f9 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i3 | 0) | 0);
 mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i4, __Z12GetGfxDevicev() | 0);
 __Z28SetupPixelCorrectCoordinatesv();
 HEAPF32[i5 >> 2] = Math_fround(f9 - f1);
 HEAPF32[i5 + 8 >> 2] = Math_fround(128.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(62.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(-58.0);
 HEAP32[i6 >> 2] = -2139062144;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i5, i2, i7, 0, -1);
 __ZN22DeviceMVPMatricesStateD2Ev(i4);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = i2 + 12 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) > (i9 | 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i7 = (HEAP32[i11 + 52 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 32 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 36 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 56 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 44 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 40 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i7) | 0) + i3 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 } else {
  i7 = (HEAP32[i11 + 56 >> 2] | 0) + i1 | 0;
  if ((i7 | 0) < (HEAP32[i11 + 40 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  if ((i7 | 0) >= (HEAP32[i11 + 44 >> 2] | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i8 = i11 + 52 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = i1 + i3 | 0;
  i4 = i11 + 36 | 0;
  if ((i3 | 0) > (i1 + i9 | 0)) {
   i11 = 1;
   return i11 | 0;
  }
  i5 = i11 + 32 | 0;
  i6 = i11 + 48 | 0;
  i2 = i9;
  while (1) {
   if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) {
    i1 = 1;
    i2 = 21;
    break;
   }
   if ((i3 | 0) >= (HEAP32[i5 >> 2] | 0)) {
    if (!(__ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj(i11, (Math_imul(HEAP32[i6 >> 2] | 0, i3) | 0) + i7 | 0) | 0)) {
     i1 = 0;
     i2 = 21;
     break;
    }
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) < (i1 + i2 | 0)) i3 = i3 + 1 | 0; else {
    i1 = 1;
    i2 = 21;
    break;
   }
  }
  if ((i2 | 0) == 21) return i1 | 0;
 }
 return 0;
}

function __ZN15AudioReverbZone16ChangePropertiesEv(i27) {
 i27 = i27 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i28 = 0;
 i1 = HEAP32[i27 + 56 >> 2] | 0;
 if ((i1 | 0) < 27) {
  i2 = i27 + 64 | 0;
  i3 = i27 + 72 | 0;
  i4 = i27 + 76 | 0;
  i5 = i27 + 80 | 0;
  i6 = i27 + 84 | 0;
  i7 = i27 + 88 | 0;
  i8 = i27 + 92 | 0;
  i9 = i27 + 96 | 0;
  i10 = i27 + 108 | 0;
  i11 = i27 + 112 | 0;
  i12 = i27 + 68 | 0;
  i13 = i27 + 100 | 0;
  i14 = i27 + 60 | 0;
  i15 = gb + 171848 + (i1 * 80 | 0) + 24 | 0;
  i16 = gb + 171848 + (i1 * 80 | 0) + 28 | 0;
  i17 = gb + 171848 + (i1 * 80 | 0) + 36 | 0;
  i18 = gb + 171848 + (i1 * 80 | 0) + 40 | 0;
  i19 = gb + 171848 + (i1 * 80 | 0) + 44 | 0;
  i20 = gb + 171848 + (i1 * 80 | 0) + 48 | 0;
  i21 = gb + 171848 + (i1 * 80 | 0) + 60 | 0;
  i22 = gb + 171848 + (i1 * 80 | 0) + 64 | 0;
  i23 = gb + 171848 + (i1 * 80 | 0) + 68 | 0;
  i24 = gb + 171848 + (i1 * 80 | 0) + 72 | 0;
  i25 = gb + 171848 + (i1 * 80 | 0) + 12 | 0;
  i26 = gb + 171848 + (i1 * 80 | 0) + 16 | 0;
  i1 = gb + 171848 + (i1 * 80 | 0) + 20 | 0;
 } else {
  i25 = i27 + 60 | 0;
  i26 = i27 + 64 | 0;
  i15 = i27 + 72 | 0;
  i16 = i27 + 76 | 0;
  i17 = i27 + 80 | 0;
  i18 = i27 + 84 | 0;
  i19 = i27 + 88 | 0;
  i20 = i27 + 92 | 0;
  i21 = i27 + 96 | 0;
  i23 = i27 + 108 | 0;
  i24 = i27 + 112 | 0;
  i1 = i27 + 68 | 0;
  i22 = i27 + 100 | 0;
  i2 = i26;
  i3 = i15;
  i4 = i16;
  i5 = i17;
  i6 = i18;
  i7 = i19;
  i8 = i20;
  i9 = i21;
  i10 = i23;
  i11 = i24;
  i12 = i1;
  i13 = i22;
  i14 = i25;
 }
 i28 = HEAP32[i26 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i17 = HEAP32[i17 >> 2] | 0;
 i18 = HEAP32[i18 >> 2] | 0;
 i19 = HEAP32[i19 >> 2] | 0;
 i20 = HEAP32[i20 >> 2] | 0;
 i21 = HEAP32[i21 >> 2] | 0;
 i26 = HEAP32[i22 >> 2] | 0;
 i23 = HEAP32[i23 >> 2] | 0;
 i24 = HEAP32[i24 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i25 >> 2];
 HEAP32[i2 >> 2] = i28;
 HEAP32[i3 >> 2] = i15;
 HEAP32[i4 >> 2] = i16;
 HEAP32[i5 >> 2] = i17;
 HEAP32[i6 >> 2] = i18;
 HEAP32[i7 >> 2] = i19;
 HEAP32[i8 >> 2] = i20;
 HEAP32[i9 >> 2] = i21;
 HEAPF32[i27 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i10 >> 2] = i23;
 HEAP32[i11 >> 2] = i24;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i26;
 return;
}

function __ZN13UnityProfiler21FinalizeAndStoreFrameEP17ProfilerFrameData(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 i2 = i9 + 4 | 0;
 i1 = __Z14IsWorldPlayingv() | 0;
 i7 = i5 + 24 | 0;
 if (HEAP32[i7 >> 2] & (i1 ? 2 : 8) | 0) {
  i1 = HEAP32[i5 + 72 >> 2] | 0;
  i10 = i1 + 248 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  if ((HEAP32[i5 >> 2] & 255) << 24 >> 24) {
   i11 = i5 + 4 | 0;
   i10 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i10 + 1;
   if (!i10) {
    i11 = i5 + 2 | 0;
    HEAP8[i11 >> 0] = 1;
    __ZN22UnityProfilerPerThread11SetIsActiveEb(i1, 1);
    i10 = __Z12GetGfxDevicev() | 0;
    mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 656 >> 2] | 0, i10 | 0, 2, 1);
    if (HEAP8[i11 >> 0] | 0) {
     d12 = +_emscripten_get_now() * 1.0e6;
     i10 = +Math_abs(d12) >= 1.0 ? (d12 > 0.0 ? ~~+Math_min(+Math_floor(d12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d12 - +(~~d12 >>> 0)) / 4294967296.0) >>> 0) : 0;
     i11 = i5 + 48 | 0;
     HEAP32[i11 >> 2] = ~~d12 >>> 0;
     HEAP32[i11 + 4 >> 2] = i10;
    }
   }
  }
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451004 | 0, i3);
 HEAP32[i6 + 1148 >> 2] = __ZN11GPUProfiler14ComputeGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE((HEAP32[i6 + 1124 >> 2] | 0) + 20 | 0) | 0;
 __ZN13UnityProfiler8LogFrameEP17ProfilerFrameData(i5, i6);
 __ZN18ProfilerConnection21SendFrameDataToEditorER17ProfilerFrameData(HEAP32[gb + 1163256 >> 2] | 0, i6);
 i1 = i5 + 16 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) i8 = 8; else {
  i1 = i5 + 20 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) i8 = 8; else {
   __Z6FormatPKcz(i3, gb + 585356 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 585151 | 0, 939, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  }
 }
 if ((i8 | 0) == 8) HEAP32[i1 >> 2] = i6;
 __Z12profiler_endP19ProfilerInformation(gb + 1451004 | 0);
 i11 = __Z14IsWorldPlayingv() | 0;
 if (!(HEAP32[i7 >> 2] & (i11 ? 2 : 8))) {
  STACKTOP = i9;
  return;
 }
 __ZN13UnityProfiler11SetIsActiveEb(i5, 0);
 STACKTOP = i9;
 return;
}

function __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 i4 = i7 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i9 + 4;
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i3 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i7, i3, 0);
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i9 + 12;
 HEAP32[i3 + 4 >> 2] = i9 + 8;
 HEAP32[i3 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i7, i3, 0);
 i5 = i9 + 20 | 0;
 i6 = i9 + 16 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i10 = i7 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i3, 4);
  i2 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i2 = i1;
 }
 HEAP32[i6 >> 2] = i2;
 if (!i2) HEAP32[i5 >> 2] = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
  i2 = i5;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i5 >> 2] = i1;
  i6 = HEAP32[i6 >> 2] | 0;
  i1 = i1 + i2 | 0;
  i2 = i1 + (i6 << 2) | 0;
  if (i6 | 0) do {
   __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i1, i7);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i1 = i9 + 24 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i9 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 }
}

function __ZN22ProceduralMaterialData16CopyFromMaterialEP18ProceduralMaterial(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16 + 8 | 0;
 i14 = i16;
 __ZN22ProceduralMaterialData12CopyFromDataERKS_(i1, i2 + 144 | 0);
 i3 = HEAP32[i1 + 60 >> 2] | 0;
 i12 = i1 + 64 | 0;
 if ((i3 | 0) == (HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i11 = i2 + 124 | 0;
 i10 = i2 + 128 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = i4;
 i1 = i4;
 do {
  i9 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  if ((i5 | 0) != (i1 | 0)) {
   i7 = i3 + 60 | 0;
   i8 = (i9 | 0) == 0;
   while (1) {
    if ((HEAP32[i5 >> 2] | 0) == (i9 | 0)) {
     if (i8) i1 = 0; else {
      HEAP32[i14 >> 2] = i9;
      i1 = HEAP32[gb + 1104264 >> 2] | 0;
      if (!i1) i15 = 14; else {
       if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
        i2 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[i1 + 32 >> 2] | 0;
        i1 = i2 + (i4 << 3) | 0;
       } else {
        __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i1, i14);
        i2 = HEAP32[i13 >> 2] | 0;
        i6 = HEAP32[i1 + 28 >> 2] | 0;
        i4 = HEAP32[gb + 1104264 >> 2] | 0;
        i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
        i2 = HEAP32[i4 + 28 >> 2] | 0;
        i4 = HEAP32[i4 + 32 >> 2] | 0;
       }
       if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i15 = 14; else {
        i1 = HEAP32[i1 + 4 >> 2] | 0;
        if (!i1) i15 = 16;
       }
      }
      if ((i15 | 0) == 14) i15 = 16;
      if ((i15 | 0) == 16) {
       i15 = 0;
       i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
      }
      i1 = (i1 | 0) != 0;
      i2 = HEAP32[i10 >> 2] | 0;
     }
     HEAP8[i7 >> 0] = i1 & 1;
     i1 = i2;
     i6 = i2;
    } else {
     i1 = i2;
     i6 = i4;
    }
    i5 = i5 + 4 | 0;
    if ((i5 | 0) == (i6 | 0)) {
     i2 = i1;
     i4 = i6;
     i1 = i6;
     break;
    } else {
     i2 = i1;
     i4 = i6;
    }
   }
  }
  i3 = i3 + 72 | 0;
 } while ((i3 | 0) != (HEAP32[i12 >> 2] | 0));
 STACKTOP = i16;
 return;
}

function __ZN5Unity17ConfigurableJointC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i3 = i4 + 40 | 0;
 i2 = i4 + 52 | 0;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 111796 + 8;
 i1 = i4 + 212 | 0;
 i2 = i4 + 120 | 0;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 216 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 224 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 228 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 232 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 236 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 240 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 244 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 248 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 252 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 256 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 260 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 264 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 268 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 272 >> 2] = Math_fround(3402823469999999843913219.0e14);
 STACKTOP = i5;
 return;
}

function __ZN5Unity12PhysicsQuery21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction(i1, i5, f7, i2, i3, i8, i9) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 f7 = Math_fround(f7);
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i4 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 108 | 0;
 i10 = i14 + 88 | 0;
 i11 = i14 + 80 | 0;
 i12 = i14 + 48 | 0;
 i6 = i14;
 if ((HEAP16[gb + 1452740 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452740 | 0, i4);
  i13 = gb + 1452740 | 0;
 } else i13 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = 128;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151400 + 8;
 HEAP32[i6 + 36 >> 2] = i2;
 HEAP32[i6 + 40 >> 2] = i3;
 i1 = i6 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 114012 + 8;
 HEAP32[i4 + 4 >> 2] = 1;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i8;
 switch (i9 | 0) {
 case 0:
  {
   HEAP8[i4 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i4 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i4 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP16[i10 + 16 >> 1] = 7;
 HEAP8[i10 + 18 >> 0] = 0;
 f15 = Math_fround(HEAPF32[gb + 1452812 >> 2]);
 i9 = HEAP32[gb + 1457404 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 356 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAPF32[i11 + 4 >> 2] = f15 < f7 ? f15 : f7;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i12 + 16 >> 2] = i2;
 HEAP32[i12 + 20 >> 2] = i3;
 HEAP32[i12 + 24 >> 2] = i5;
 mftCall_iiiiiii(i8 | 0, i9 | 0, i11 | 0, i12 | 0, i6 | 0, i10 | 0, i4 | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i13) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 92 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 104 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 105 >> 0] = i1;
 i1 = i4 + 106 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __Z18ReadBufferFromFileP13dynamic_arrayIhLj1EERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 1088 | 0;
 i5 = i10 + 8 | 0;
 i9 = i10 + 20 | 0;
 i6 = i10;
 i4 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i5, i4, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i8, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = __ZNK15FileSystemEntry4SizeEv(i8) | 0;
 getTempRet0() | 0;
 __ZN12FileAccessorC2Ev(i9);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i9, i8, 0, 0) | 0)) {
  i7 = 0;
  __ZN12FileAccessorD2Ev(i9);
  __ZN13FileEntryDataD2Ev(i8);
  STACKTOP = i10;
  return i7 | 0;
 }
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i7 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
  break;
 } while (0);
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 if (!i1) {
  __ZN12FileAccessor5CloseEv(i9) | 0;
  i2 = 0;
  i3 = 9;
 } else {
  i3 = __ZN12FileAccessor4ReadEyPvPy(i9, i1, 0, HEAP32[i7 >> 2] | 0, i6) | 0;
  __ZN12FileAccessor5CloseEv(i9) | 0;
  if (i3) {
   i2 = 0;
   i3 = 9;
  } else {
   i1 = i7;
   i3 = 11;
  }
 }
 if ((i3 | 0) == 9) if ((HEAP32[i6 >> 2] | 0) == (i1 | 0) ? (HEAP32[i6 + 4 >> 2] | 0) == (i2 | 0) : 0) i1 = 1; else {
  i1 = i7;
  i3 = 11;
 }
 if ((i3 | 0) == 11) {
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 4 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 i7 = i1;
 __ZN12FileAccessorD2Ev(i9);
 __ZN13FileEntryDataD2Ev(i8);
 STACKTOP = i10;
 return i7 | 0;
}

function __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 396 | 0;
 if ((HEAP32[i2 + 412 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 400 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 376 | 0;
 if ((HEAP32[i2 + 392 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 380 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 356 | 0;
 if ((HEAP32[i2 + 372 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 360 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 332 | 0;
 if ((HEAP32[i2 + 348 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 336 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN11UTF16StringD2Ev(i2 + 196 | 0);
 i1 = i2 + 160 | 0;
 if ((HEAP32[i2 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 140 | 0;
 if ((HEAP32[i2 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 120 | 0;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14GfxDeviceStats14AddUsedTextureE9TextureID(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i3 = i13;
 if (!(HEAP8[i12 + 280 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 i11 = i12 + 120 | 0;
 i8 = i12 + 124 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = (i1 | 0) == 0;
 do if (i6) i2 = 21; else {
  i7 = HEAP32[i10 >> 2] | 0;
  i2 = i8;
  i5 = i1;
  L7 : while (1) {
   i4 = i5;
   while (1) {
    if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i7 >>> 0) break;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (!i4) break L7;
   }
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) {
    i2 = i4;
    break;
   } else i2 = i4;
  }
  if ((i2 | 0) != (i8 | 0)) if (i7 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   STACKTOP = i13;
   return;
  }
  if (i6) i2 = 21; else {
   i5 = HEAP32[i10 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i5 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 15;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i5 >>> 0) {
      i2 = 20;
      break;
     }
     i4 = i1 + 4 | 0;
     i2 = HEAP32[i4 >> 2] | 0;
     if (!i2) {
      i2 = 19;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 15) {
    HEAP32[i3 >> 2] = i1;
    i5 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 19) {
    HEAP32[i3 >> 2] = i1;
    i5 = i1;
    i3 = i4;
    break;
   } else if ((i2 | 0) == 20) {
    HEAP32[i3 >> 2] = i1;
    i5 = i1;
    break;
   }
  }
 } while (0);
 if ((i2 | 0) == 21) {
  HEAP32[i3 >> 2] = i8;
  i5 = i8;
  i3 = i8;
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i12 + 128 >> 2] | 0;
  HEAP32[i9 >> 2] = 57;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(20, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 + 16 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i11 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 + 124 >> 2] | 0, i1);
  i12 = i12 + 132 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 }
 STACKTOP = i13;
 return;
}

function __ZNK16LightmapSettings23HasLightProbeTetrahedraEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i1 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 15; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 15; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 17;
  }
 }
 if ((i7 | 0) == 15) i7 = 17;
 if ((i7 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i9 = (HEAP32[i1 + 44 >> 2] | 0) > 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZNK5physx20PxsSolverCoreGeneral6solveVEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE(i7, f3, i1, i13, i9, i2, i4, i8, i12, i11, i14, i15, i5, i6, i10) {
 i7 = i7 | 0;
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP8[i4 + 1 >> 0] = 0;
 do if ((i1 | 0) > 0) {
  if (!i15) {
   while (1) if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
   HEAP8[i4 >> 0] = (i1 | 0) < 4 & 1;
   break;
  }
  while (1) {
   HEAP8[i4 >> 0] = (i1 | 0) < 4 & 1;
   i2 = 0;
   do {
    mftCall_vii(HEAP32[gb + 103784 + ((HEAPU8[HEAP32[i14 + (i2 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i2 << 5) | 0, i4 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i15 | 0));
   if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
  }
 } while (0);
 if (i8 | 0) {
  i1 = 0;
  do {
   HEAP32[i10 + (i1 << 5) >> 2] = HEAP32[i9 + (i1 << 5) >> 2];
   HEAP32[i10 + (i1 << 5) + 4 >> 2] = HEAP32[i9 + (i1 << 5) + 4 >> 2];
   HEAP32[i10 + (i1 << 5) + 8 >> 2] = HEAP32[i9 + (i1 << 5) + 8 >> 2];
   HEAP32[i10 + (i1 << 5) + 16 >> 2] = HEAP32[i9 + (i1 << 5) + 16 >> 2];
   HEAP32[i10 + (i1 << 5) + 20 >> 2] = HEAP32[i9 + (i1 << 5) + 20 >> 2];
   HEAP32[i10 + (i1 << 5) + 24 >> 2] = HEAP32[i9 + (i1 << 5) + 24 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 if (i11 | 0) {
  i2 = 0;
  do {
   i1 = HEAP32[gb + 1457372 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i12 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i11 | 0));
 }
 i2 = (i15 | 0) == 0;
 if (!i2) {
  i1 = 0;
  do {
   mftCall_vii(HEAP32[gb + 103812 + ((HEAPU8[HEAP32[i14 + (i1 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i1 << 5) | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i15 | 0));
 }
 i1 = 1 - i13 | 0;
 if ((i1 | 0) > 0 | i2) {
  STACKTOP = i5;
  return;
 }
 while (1) {
  i2 = 0;
  do {
   mftCall_vii(HEAP32[gb + 103784 + ((HEAPU8[HEAP32[i14 + (i2 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i14 + (i2 << 5) | 0, i4 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i15 | 0));
  if ((i1 | 0) < 0) i1 = i1 + 1 | 0; else break;
 }
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sn5ConvX7convertEPKvi(i10, i1, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 24 | 0;
 i4 = i11 + 8 | 0;
 i8 = i11 + 36 | 0;
 i3 = i11 + 40 | 0;
 i9 = i11 + 32 | 0;
 HEAP32[i8 >> 2] = i5;
 i7 = i1;
 if (i7 & 15 | 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i10, i2);
 HEAP32[i8 >> 2] = i5 + -4;
 if ((i2 | 0) != 1145193811) {
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 4, gb + 668507 | 0, i11);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i10, i1);
 HEAP32[i8 >> 2] = i5 + -8;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i10, i2);
 HEAP32[i8 >> 2] = i5 + -12;
 if (!(__ZN5physx2Sn18checkCompatibilityEjj(i1, i2) | 0)) {
  __ZN5physx2Sn27getCompatibilityVersionsStrEPcj(i3, 512);
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i3;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 4, gb + 668599 | 0, i4);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN5physx2Sn5ConvX6outputEi(i10, HEAP32[i7 + 12 >> 2] | 0);
 HEAP32[i8 >> 2] = i5 + -16;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + -20;
 __ZN5physx2Sn5ConvX6outputEi(i10, HEAP32[(HEAP32[i10 + 8 >> 2] | 0) + 48 >> 2] | 0);
 i2 = i10 + 4 | 0;
 if ((i1 | 0) != (HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0)) {
  i8 = __ZN5physx2Sn21getBinaryPlatformNameEj(i1) | 0;
  i9 = __ZN5physx2Sn21getBinaryPlatformNameEj(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i6 + 4 >> 2] = i9;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 4, gb + 668732 | 0, i6);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + -24;
 i2 = i10 + 326 | 0;
 HEAP8[i2 >> 0] = (i1 | 0) != 0 & 1;
 __ZN5physx2Sn5ConvX6outputEi(i10, 1);
 i1 = __ZN5physx2Sn5ConvX22convertReferenceTablesEPKvRiS4_(i10, i7 + 24 | 0, i8, i9) | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = __ZN5physx2Sn5ConvX17convertCollectionEPKvii(i10, i1, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
 HEAP8[i2 >> 0] = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN12b2EPCollider24ComputePolygonSeparationEv(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0, i22 = 0, i23 = 0, f24 = f0, f25 = f0;
 HEAP32[i7 >> 2] = 0;
 i13 = i7 + 4 | 0;
 HEAP32[i13 >> 2] = -1;
 i19 = i7 + 8 | 0;
 HEAPF32[i19 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 f20 = Math_fround(HEAPF32[i8 + 216 >> 2]);
 f21 = Math_fround(HEAPF32[i8 + 212 >> 2]);
 i22 = HEAP32[i8 + 128 >> 2] | 0;
 if ((i22 | 0) <= 0) return;
 f9 = Math_fround(HEAPF32[i8 + 164 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 168 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 172 >> 2]);
 f12 = Math_fround(HEAPF32[i8 + 176 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 244 >> 2]);
 i15 = i8 + 228 | 0;
 i16 = i8 + 232 | 0;
 i17 = i8 + 236 | 0;
 i18 = i8 + 240 | 0;
 i1 = 0;
 f6 = Math_fround(-3402823469999999843913219.0e14);
 while (1) {
  f3 = Math_fround(HEAPF32[i8 + 64 + (i1 << 3) >> 2]);
  f4 = Math_fround(-f3);
  f5 = Math_fround(-Math_fround(HEAPF32[i8 + 64 + (i1 << 3) + 4 >> 2]));
  f25 = Math_fround(HEAPF32[i8 + (i1 << 3) >> 2]);
  f24 = Math_fround(f25 - f9);
  f2 = Math_fround(HEAPF32[i8 + (i1 << 3) + 4 >> 2]);
  f24 = Math_fround(Math_fround(f24 * f4) + Math_fround(Math_fround(f2 - f10) * f5));
  f2 = Math_fround(Math_fround(Math_fround(f25 - f11) * f4) + Math_fround(Math_fround(f2 - f12) * f5));
  f2 = f24 < f2 ? f24 : f2;
  if (f2 > f14) break;
  if (!(Math_fround(Math_fround(f20 * f3) + Math_fround(f21 * f5)) >= Math_fround(0.0))) {
   f25 = Math_fround(f4 - Math_fround(HEAPF32[i15 >> 2]));
   if (f2 > f6 ? !(Math_fround(Math_fround(f25 * f21) + Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i16 >> 2])) * f20)) < Math_fround(-.0349065885)) : 0) i23 = 7; else f2 = f6;
  } else {
   f25 = Math_fround(f4 - Math_fround(HEAPF32[i17 >> 2]));
   if (f2 > f6 ? !(Math_fround(Math_fround(f25 * f21) + Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i18 >> 2])) * f20)) < Math_fround(-.0349065885)) : 0) i23 = 7; else f2 = f6;
  }
  if ((i23 | 0) == 7) {
   i23 = 0;
   HEAP32[i7 >> 2] = 2;
   HEAP32[i13 >> 2] = i1;
   HEAPF32[i19 >> 2] = f2;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) < (i22 | 0)) f6 = f2; else {
   i23 = 10;
   break;
  }
 }
 if ((i23 | 0) == 10) return;
 HEAP32[i7 >> 2] = 2;
 HEAP32[i13 >> 2] = i1;
 HEAPF32[i19 >> 2] = f2;
 return;
}

function __ZNSt3__26vectorItNS_9allocatorItEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 - i10 | 0;
 i7 = i5 >> 2;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i11 = i10;
 i2 = i6;
 i12 = i3;
 if (i7 >>> 0 > i1 - i6 >> 1 >>> 0) {
  i4 = i6;
  if (i6) {
   i1 = i9 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -2 - i6 | 0) >>> 1) << 1);
   __ZdlPv(i4);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   i1 = 0;
  }
  if ((i5 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  } else i2 = 0;
  i1 = i1 - i2 | 0;
  i1 = i1 >> 1 >>> 0 < 1073741823 ? (i1 >>> 0 < i7 >>> 0 ? i7 : i1) : 2147483647;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i4 = __Znwj(i1 << 1) | 0;
  i5 = i9 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i4;
  HEAP32[i8 >> 2] = i4 + (i1 << 1);
  if ((i11 | 0) == (i12 | 0)) return;
  i3 = i12 + -4 - i10 | 0;
  i1 = i11;
  i2 = i4;
  while (1) {
   HEAP16[i2 >> 1] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 2 | 0;
  }
  HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 1);
  return;
 }
 i9 = i9 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = i5 - i6 >> 1;
 i8 = i7 >>> 0 > i1 >>> 0;
 i7 = i8 ? i11 + (i1 << 2) | 0 : i3;
 i1 = i7;
 i6 = i5;
 if ((i11 | 0) != (i1 | 0)) {
  i5 = i1 + -4 - i10 | 0;
  i3 = i11;
  i4 = i2;
  while (1) {
   HEAP16[i4 >> 1] = HEAP32[i3 >> 2];
   i3 = i3 + 4 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else i4 = i4 + 2 | 0;
  }
  i2 = i2 + ((i5 >>> 2) + 1 << 1) | 0;
 }
 if (!i8) {
  if ((i6 | 0) == (i2 | 0)) return;
  HEAP32[i9 >> 2] = i6 + (~((i6 + -2 - i2 | 0) >>> 1) << 1);
  return;
 }
 if ((i1 | 0) == (i12 | 0)) return;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i12 + -4 - i7 | 0;
 i2 = i4;
 while (1) {
  HEAP16[i2 >> 1] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 2 | 0;
 }
 HEAP32[i9 >> 2] = i4 + ((i3 >>> 2) + 1 << 1);
 return;
}

function __ZN5physx2Sc5Scene18postReportsCleanupEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i2 = i11 + 1196 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i10 = i1 + 32 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i5 = i1 + 28 | 0;
  i6 = i1 + 4 | 0;
  i7 = i1 + 12 | 0;
  i8 = i1 + 8 | 0;
  i9 = 0;
  do {
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   HEAP32[i12 >> 2] = i3;
   do if (((HEAP32[i1 >> 2] | 0) + -1 | 0) == (i3 | 0)) HEAP32[i1 >> 2] = i3; else {
    i4 = HEAP32[i8 >> 2] | 0;
    if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
     HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i3;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i6, i12) | 0;
     break;
    }
   } while (0);
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = 0;
 _memset(HEAP32[i1 + 16 >> 2] | 0, 0, HEAP32[i1 + 20 >> 2] << 2 | 0) | 0;
 i1 = i11 + 1200 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 32 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i12 = i2;
  HEAP32[i3 >> 2] = 0;
  i11 = i12 + 16 | 0;
  i12 = i12 + 20 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  i12 = i12 << 2;
  _memset(i11 | 0, 0, i12 | 0) | 0;
  STACKTOP = i13;
  return;
 }
 i4 = i2 + 28 | 0;
 i5 = i2 + 4 | 0;
 i6 = i2 + 12 | 0;
 i7 = i2 + 8 | 0;
 i10 = 0;
 do {
  i8 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i10 << 2) >> 2] | 0;
  HEAP32[i12 >> 2] = i8;
  do if (((HEAP32[i2 >> 2] | 0) + -1 | 0) == (i8 | 0)) HEAP32[i2 >> 2] = i8; else {
   i9 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i9 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i9 << 2) >> 2] = i8;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i5, i12) | 0;
    break;
   }
  } while (0);
  i10 = i10 + 1 | 0;
 } while (i10 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 i11 = i12 + 16 | 0;
 i12 = i12 + 20 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i12 = i12 << 2;
 _memset(i11 | 0, 0, i12 | 0) | 0;
 STACKTOP = i13;
 return;
}

function __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii(i10, i1, i11, i16, i12, i13) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i20 + 12 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20 + 4 | 0;
 i14 = i20;
 HEAP32[i14 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i14, i1);
 i9 = i10 + 60 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i10 + 72 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 76 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 4, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i10 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 + (i4 << 4) >> 2] = i2;
 HEAP32[i10 + (i4 << 4) + 4 >> 2] = i11;
 HEAP32[i10 + (i4 << 4) + 8 >> 2] = i12;
 HEAP32[i10 + (i4 << 4) + 12 >> 2] = i13;
 if (!i16) {
  STACKTOP = i20;
  return;
 }
 i6 = HEAP32[i14 >> 2] | 0;
 if ((i6 | 0) != -1 & i6 >>> 0 > 1073741823) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i18 >> 2] = i6;
 i2 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i7 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i19 = 12; else if ((HEAP32[i1 >> 2] | 0) > (i6 | 0)) i19 = 12;
 if ((i19 | 0) == 12) {
  HEAP32[i17 >> 2] = i2;
  HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i16, i15, i18) | 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i10 = i11;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 52 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 52 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 52 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i11;
  return;
 }
 i3 = i1 + (i6 * 52 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 * 52 | 0) | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i6 = i7 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i7 = i7 + 36 | 0;
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZNK16LightmapSettings19AreLightProbesBakedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 i6 = i1 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 9;
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 15; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 15; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 17;
  }
 }
 if ((i7 | 0) == 15) i7 = 17;
 if ((i7 | 0) == 17) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i9 = (HEAP32[i1 + 104 >> 2] | 0) > 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = HEAP32[i11 >> 2] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 5638;
 i9 = i14;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = ((i11 | 0) < 0) << 31 >> 31;
 if ((i11 | 0) > -1) HEAP32[i3 >> 2] = 15878;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN14dtPathCorridor20optimizePathTopologyEP14dtNavMeshQueryPK13dtQueryFilter(i6, i3, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i4 = i14 + 64 | 0;
 i13 = i6 + 32 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) < 3) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 28 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i10 = i11;
 i11 = i11 + (i2 + -1 << 3) | 0;
 i1 = __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter(i3, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i6, i6 + 12 | 0, i1) | 0;
 if ((i1 | 0) >= 0) i1 = __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi(i3, 8, 0) | 0;
 if (i1 & 1073741824) {
  i1 = __ZN14dtNavMeshQuery29finalizeSlicedFindPathPartialEPiPKyi(i3, i4, HEAP32[i5 >> 2] | 0, HEAP32[i13 >> 2] | 0) | 0;
  if (i1 & 1073741824) i1 = __ZN14dtNavMeshQuery7getPathEPyPii(i3, i12, i4, 8) | 0;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 if ((i1 & 1073741824 | 0) != 0 & (i10 | 0) > 0) {
  i11 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i9 = HEAP32[i6 + 36 >> 2] | 0;
  i4 = -1;
  i6 = i1;
  i3 = -1;
  do {
   if ((i6 | 0) <= 0) break;
   i6 = i6 + -1 | 0;
   i8 = i11 + (i6 << 3) | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i8 + 4 >> 2] | 0;
   i2 = i10;
   i5 = 0;
   do {
    i15 = i2;
    i2 = i2 + -1 | 0;
    i16 = i12 + (i2 << 3) | 0;
    i16 = (i7 | 0) == (HEAP32[i16 >> 2] | 0) ? (i8 | 0) == (HEAP32[i16 + 4 >> 2] | 0) : 0;
    i3 = i16 ? i2 : i3;
    i5 = i5 | i16;
    i4 = i16 ? i6 : i4;
   } while ((i15 | 0) > 1);
  } while (!i5);
  if (!((i3 | 0) < 1 | (i4 | 0) == -1)) {
   i2 = i1 - i4 | 0;
   i2 = (i2 | 0) < 0 ? 0 : i2;
   i2 = (i2 + i3 | 0) > (i9 | 0) ? i9 - i3 | 0 : i2;
   if (i2 | 0) _memmove(i11 + (i3 << 3) | 0, i11 + (i4 << 3) | 0, i2 << 3 | 0) | 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     i10 = i12 + (i1 << 3) | 0;
     i15 = HEAP32[i10 + 4 >> 2] | 0;
     i16 = i11 + (i1 << 3) | 0;
     HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i16 + 4 >> 2] = i15;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i1 = i2 + i3 | 0;
  }
  HEAP32[i13 >> 2] = i1;
  i1 = 1;
 } else i1 = 0;
 i16 = i1;
 STACKTOP = i14;
 return i16 | 0;
}

function __ZN13GfxDeviceGLES28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE(i7, i8, i15, i17) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0)) {
  if (!i8) {
   STACKTOP = i19;
   return;
  }
  _memset(i17 | 0, 0, i8 << 2 | 0) | 0;
  STACKTOP = i19;
  return;
 }
 i9 = __Z20GetBufferManagerGLESv() | 0;
 if (!i8) {
  STACKTOP = i19;
  return;
 }
 i10 = i7 + 8464 | 0;
 i11 = i7 + 8468 | 0;
 i12 = i11;
 i13 = i7 + 8468 | 0;
 i14 = i7 + 8472 | 0;
 i6 = 0;
 do {
  i16 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 744 >> 2] | 0, i7 | 0) | 0;
  i5 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i9, HEAP32[i15 + (i6 << 2) >> 2] | 0, 8, 0) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  do if (!i1) {
   HEAP32[i18 >> 2] = i11;
   i4 = i12;
   i3 = i11;
  } else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if (i16 >>> 0 < i2 >>> 0) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = 9;
      break;
     } else i1 = i2;
    } else {
     if (i2 >>> 0 >= i16 >>> 0) {
      i2 = 14;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i2 = 13;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == 9) {
    HEAP32[i18 >> 2] = i1;
    i4 = i1;
    i3 = i1;
    break;
   } else if ((i2 | 0) == 13) {
    HEAP32[i18 >> 2] = i1;
    i4 = i1;
    break;
   } else if ((i2 | 0) == 14) {
    HEAP32[i18 >> 2] = i1;
    i4 = i1;
    i3 = i18;
    break;
   }
  } while (0);
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(24) | 0;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = i16;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i10 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i13 >> 2] | 0, i1);
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  }
  HEAP32[i17 + (i6 << 2) >> 2] = i16;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 STACKTOP = i19;
 return;
}

function __Z34PrepareParametersCullShadowCastersRK11ActiveLightRK14ShadowCullDataR22SceneCullingParametersR13ShadowedLight(i2, i8, i9, i1) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 40 | 0;
 i3 = i12 + 28 | 0;
 i11 = i12;
 __Z19CreateCullingOutputPK16RendererCullDataR13CullingOutput(i9 + 752 | 0, i1 + 4 | 0);
 i1 = HEAP32[i2 + 132 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = (i1 | 0) == 1;
 if (i5) {
  i6 = HEAP32[i4 + 252 >> 2] | 0;
  i7 = HEAP32[i4 + 256 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 + 248 >> 2];
  HEAP32[i3 + 4 >> 2] = i6;
  HEAP32[i3 + 8 >> 2] = i7;
 } else {
  i6 = HEAP32[i4 + 268 >> 2] | 0;
  i7 = HEAP32[i4 + 272 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 + 264 >> 2];
  HEAP32[i3 + 4 >> 2] = i6;
  HEAP32[i3 + 8 >> 2] = i7;
 }
 i6 = i8 + 549 | 0;
 i7 = i8 + 516 | 0;
 __Z25CalculateShadowCasterCullbPK5PlaneRK10Matrix4x4fRK8Vector3fff9LightTypeS7_R16ShadowCasterCullPKb((HEAP8[i6 >> 0] | 0) != 0, i8 + 660 | 0, i8 + 64 | 0, i7, Math_fround(1.0), Math_fround(HEAPF32[i8 + 808 >> 2]), i1, i3, i10, gb + 1544221 | 0);
 i1 = i9 + 544 | 0;
 i2 = i8 + 448 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i9 + 608 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i3 = i11 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i8 + 800 >> 2];
 HEAP8[i11 >> 0] = HEAP8[i6 >> 0] | 0;
 HEAP32[i11 + 20 >> 2] = HEAP32[i8 + 552 >> 2];
 HEAP32[i11 + 24 >> 2] = ~~Math_fround(HEAPF32[i8 + 556 >> 2]);
 __Z32CalculateCustomCullingParametersR17CullingParametersRK13LODParametersjPK5Planei(i9, i11, HEAP32[i8 + 512 >> 2] | 0, i10, HEAP32[i10 + 160 >> 2] | 0);
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 f15 = Math_fround(HEAPF32[i4 + 248 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 252 >> 2]);
 f14 = Math_fround(-f14);
 f13 = Math_fround(-Math_fround(HEAPF32[i4 + 256 >> 2]));
 HEAPF32[i9 + 328 >> 2] = Math_fround(-f15);
 HEAPF32[i9 + 332 >> 2] = f14;
 HEAPF32[i9 + 336 >> 2] = f13;
 STACKTOP = i12;
 return;
}

function _Bezier_Up(i9, i14, i13, i6, i4) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i16 = i9 + 52 | 0;
 i1 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i1 + (i14 << 3) + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i15 = i9 + 40 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 if (!((i7 | 0) > (i4 | 0) | (i3 | 0) < (i6 | 0))) {
  i12 = i9 + 4 | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  i5 = 0 - i8 | 0;
  i11 = i3 & i5;
  i11 = (i11 | 0) > (i4 | 0) ? i4 : i11;
  if ((i7 | 0) < (i6 | 0)) {
   i5 = i6;
   i4 = i6;
  } else {
   i4 = i7 + -1 + i8 & i5;
   if (!(i7 & 65535 & i8 + 65535)) {
    i3 = i9 + 87 | 0;
    if (HEAP8[i3 >> 0] | 0) {
     HEAP8[i3 >> 0] = 0;
     i2 = i2 + -4 | 0;
    }
    HEAP32[i2 >> 2] = HEAP32[i1 + (i14 << 3) >> 2];
    i5 = i4;
    i4 = i8 + i4 | 0;
    i2 = i2 + 4 | 0;
   } else i5 = i4;
  }
  i3 = i9 + 86 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP32[(HEAP32[i9 + 88 >> 2] | 0) + 20 >> 2] = i5 >> HEAP32[i9 >> 2];
   HEAP8[i3 >> 0] = 0;
  }
  if ((i11 | 0) >= (i4 | 0)) {
   if ((i2 + (i11 - i4 >> HEAP32[i9 >> 2] << 2) + 4 | 0) >>> 0 >= (HEAP32[i9 + 36 >> 2] | 0) >>> 0) {
    HEAP32[i15 >> 2] = i2;
    HEAP32[i9 + 44 >> 2] = 98;
    i16 = 1;
    return i16 | 0;
   }
   i10 = i9 + 87 | 0;
   i8 = i9 + 16 | 0;
   i9 = 0 - i14 | 0;
   i7 = i1;
   i3 = i4;
   while (1) {
    HEAP8[i10 >> 0] = 0;
    i4 = HEAP32[i7 + 4 >> 2] | 0;
    do if ((i4 | 0) > (i3 | 0)) {
     i5 = i7 + (i14 << 3) | 0;
     i6 = HEAP32[i7 + (i14 << 3) + 4 >> 2] | 0;
     i4 = i4 - i6 | 0;
     if ((i4 | 0) < (HEAP32[i8 >> 2] | 0)) {
      i5 = HEAP32[i5 >> 2] | 0;
      HEAP32[i2 >> 2] = ((Math_imul((HEAP32[i7 >> 2] | 0) - i5 | 0, i3 - i6 | 0) | 0) / (i4 | 0) | 0) + i5;
      i4 = i7 + (i9 << 3) | 0;
      i3 = (HEAP32[i12 >> 2] | 0) + i3 | 0;
      i2 = i2 + 4 | 0;
      break;
     } else {
      mftCall_vi(i13 | 0, i7 | 0);
      i4 = i5;
      break;
     }
    } else {
     if ((i4 | 0) == (i3 | 0)) {
      HEAP8[i10 >> 0] = 1;
      HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
      i3 = (HEAP32[i12 >> 2] | 0) + i3 | 0;
      i2 = i2 + 4 | 0;
     }
     i4 = i7 + (i9 << 3) | 0;
    } while (0);
    if ((i3 | 0) > (i11 | 0) | i4 >>> 0 < i1 >>> 0) break; else i7 = i4;
   }
   i1 = HEAP32[i16 >> 2] | 0;
  }
 }
 HEAP32[i15 >> 2] = i2;
 HEAP32[i16 >> 2] = i1 + (0 - i14 << 3);
 i16 = 0;
 return i16 | 0;
}

function __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = i3 - i5 >> 3;
 i6 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i2 = i5;
 i9 = i10;
 i12 = i3;
 if (i8 >>> 0 <= i1 - i10 >> 3 >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i10 >> 3;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 << 3) | 0 : i3;
  i2 = i1 - i5 | 0;
  i3 = i2 >> 3;
  if (i3 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i9 + (i3 << 3) | 0;
  if (!i4) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 8 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i4 = i10;
 if (i10) {
  i1 = i11 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -8 - i10 | 0) >>> 3) << 3);
  __ZdlPv(i4);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i10 = i1 - i3 | 0;
 i3 = i10 >> 2;
 i3 = i10 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 536870911;
 if (i3 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = __Znwj(i3 << 3) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i1 + (i3 << 3);
 if ((i2 | 0) == (i12 | 0)) return;
 do {
  i9 = i2;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i2 = i2 + 8 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 8 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 return;
}

function __ZN14AnimationState18ShouldMixTransformER9Transform(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 if (!(HEAP32[i1 + 152 >> 2] | 0)) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = HEAP32[i1 + 144 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i6 = i1 + 148 | 0;
 if ((i2 | 0) == (i6 | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 L7 : while (1) {
  i5 = i2 + 16 | 0;
  do if (!(HEAP8[i2 + 20 >> 0] | 0)) {
   if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
    i1 = 1;
    i11 = 21;
    break L7;
   }
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 11; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i3 = HEAP32[i8 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 11; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 13;
     }
    }
    if ((i11 | 0) == 11) i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
     if (!i1) break;
    }
    if (__Z22IsChildOrSameTransformR9TransformS0_(i7, i1) | 0) {
     i1 = 1;
     i11 = 21;
     break L7;
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i6 | 0)) {
   i1 = 0;
   i11 = 21;
   break;
  } else i2 = i1;
 }
 if ((i11 | 0) == 21) {
  STACKTOP = i12;
  return i1 | 0;
 }
 return 0;
}

function __ZNK12b2ChainShape11ComputeAABBEP6b2AABBRK11b2Transformib(i2, i10, i11, i3, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i12 = i3 + 1 | 0;
 i12 = (i12 | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? 0 : i12;
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i1 = !(f9 <= Math_fround(HEAPF32[gb + 151644 >> 2]));
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i2 + (i3 << 3) >> 2]);
 f4 = Math_fround(HEAPF32[i2 + (i3 << 3) + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + (i12 << 3) >> 2]);
 f6 = Math_fround(HEAPF32[i2 + (i12 << 3) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 if (i1) {
  f13 = Math_fround(f8 * f7);
  f15 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f13 = Math_fround(f13 - Math_fround(f4 * f15));
  f14 = Math_fround(Math_fround(f4 * f7) + Math_fround(f8 * f15));
  f4 = Math_fround(HEAPF32[i11 >> 2]);
  f13 = Math_fround(f4 + f13);
  f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f14 = Math_fround(f8 + f14);
  f4 = Math_fround(f4 + Math_fround(Math_fround(f5 * f7) - Math_fround(f6 * f15)));
  f6 = Math_fround(f8 + Math_fround(Math_fround(f6 * f7) + Math_fround(f5 * f15)));
  f8 = Math_fround(f9 + (f14 > f6 ? f14 : f6));
  f7 = Math_fround(f9 + (f13 > f4 ? f13 : f4));
  f6 = Math_fround((f14 < f6 ? f14 : f6) - f9);
  f9 = Math_fround((f13 < f4 ? f13 : f4) - f9);
  HEAPF32[i10 >> 2] = f9;
  i12 = i10 + 4 | 0;
  HEAPF32[i12 >> 2] = f6;
  i12 = i10 + 8 | 0;
  HEAPF32[i12 >> 2] = f7;
  i12 = i10 + 12 | 0;
  HEAPF32[i12 >> 2] = f8;
  return;
 } else {
  f16 = Math_fround(f7 * f8);
  f13 = Math_fround(HEAPF32[i11 + 8 >> 2]);
  f16 = Math_fround(f16 - Math_fround(f13 * f4));
  f9 = Math_fround(HEAPF32[i11 >> 2]);
  f16 = Math_fround(f9 + f16);
  f8 = Math_fround(Math_fround(f8 * f13) + Math_fround(f7 * f4));
  f15 = Math_fround(HEAPF32[i11 + 4 >> 2]);
  f8 = Math_fround(f8 + f15);
  f9 = Math_fround(f9 + Math_fround(Math_fround(f7 * f5) - Math_fround(f13 * f6)));
  f13 = Math_fround(f15 + Math_fround(Math_fround(f13 * f5) + Math_fround(f7 * f6)));
  f15 = f8 > f13 ? f8 : f13;
  f14 = f16 > f9 ? f16 : f9;
  f13 = f8 < f13 ? f8 : f13;
  f9 = f16 < f9 ? f16 : f9;
  HEAPF32[i10 >> 2] = f9;
  i12 = i10 + 4 | 0;
  HEAPF32[i12 >> 2] = f13;
  i12 = i10 + 8 | 0;
  HEAPF32[i12 >> 2] = f14;
  i12 = i10 + 12 | 0;
  HEAPF32[i12 >> 2] = f15;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 613;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx24PxcPCMContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i14, i2, i3, i13, i16, i1, i15) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f17 = f0, f18 = f0, f19 = f0;
 i3 = i3 + 16 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i3 = i13 + 16 | 0;
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f18 = Math_fround(f7 - f18);
 f5 = Math_fround(f11 - f5);
 f17 = Math_fround(f12 - f17);
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f8 * Math_fround(Math_fround(Math_fround(f18 * f8) + Math_fround(f5 * f9)) + Math_fround(f17 * f10))) + Math_fround(Math_fround(f18 * Math_fround(Math_fround(f6 * f6) + Math_fround(-.5))) - Math_fround(f6 * Math_fround(Math_fround(f17 * f9) - Math_fround(f5 * f10))))) * Math_fround(2.0)) - f4);
 if (!(Math_fround(HEAPF32[i16 >> 2]) >= f5)) {
  i16 = 0;
  return i16 | 0;
 }
 f18 = Math_fround(f8 * Math_fround(2.0));
 f17 = Math_fround(f6 * Math_fround(2.0));
 f19 = Math_fround(Math_fround(f18 * f9) + Math_fround(f10 * f17));
 f9 = Math_fround(Math_fround(f18 * f10) - Math_fround(f9 * f17));
 f8 = Math_fround(Math_fround(Math_fround(f8 * f18) + Math_fround(f6 * f17)) + Math_fround(-1.0));
 f10 = Math_fround(f7 - Math_fround(f4 * f8));
 f17 = Math_fround(f11 - Math_fround(f4 * f19));
 f18 = Math_fround(f12 - Math_fround(f4 * f9));
 i14 = i15 + 4096 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = i16 + 1;
 i14 = i15 + (i16 << 6) | 0;
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i14 + 4 >> 2] = f19;
 HEAPF32[i14 + 8 >> 2] = f9;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 i14 = i15 + (i16 << 6) + 16 | 0;
 HEAPF32[i14 >> 2] = f10;
 HEAPF32[i14 + 4 >> 2] = f17;
 HEAPF32[i14 + 8 >> 2] = f18;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + (i16 << 6) + 12 >> 2] = f5;
 HEAP32[i15 + (i16 << 6) + 48 >> 2] = -1;
 HEAP32[i15 + (i16 << 6) + 52 >> 2] = -1;
 i16 = 1;
 return i16 | 0;
}

function __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i2 + 64 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i2 + 92 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i2 + 104 | 0, i1 | 0);
 HEAP16[i2 + 124 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 128 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 132 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 136 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 140 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 144 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 148 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 152 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 156 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i2 + 4 | 0);
 i9 = i10 + 4 | 0;
 i8 = i10 + 8 | 0;
 i7 = i10 + 12 | 0;
 i6 = i10 + 16 | 0;
 i5 = i10 + 20 | 0;
 i4 = i10 + 24 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i10 | 0, i1 | 0, 0);
 HEAP32[i2 + 8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i10 | 0, i1 | 0, 1);
 HEAP32[i2 + 36 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i2 + 116 | 0, i2 + 120 | 0);
 STACKTOP = i3;
 return;
}

function __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(i8, i9, i6) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i7 = i8 + 4 | 0;
 i1 = i8 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) {
  HEAP32[i5 >> 2] = i1;
  i4 = i1;
  i3 = i1;
  i1 = 11;
 } else {
  while (1) {
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i1 | 0) > (i6 | 0)) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i1 = 4;
     break;
    } else i2 = i1;
   } else {
    if ((i1 | 0) >= (i6 | 0)) {
     i1 = 10;
     break;
    }
    i3 = i2 + 4 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i1 = 8;
     break;
    } else i2 = i1;
   }
  }
  if ((i1 | 0) == 4) {
   HEAP32[i5 >> 2] = i2;
   i4 = i2;
   i3 = i2;
   i1 = 11;
   break;
  } else if ((i1 | 0) == 8) {
   HEAP32[i5 >> 2] = i2;
   i4 = i2;
   i1 = 11;
   break;
  } else if ((i1 | 0) == 10) {
   HEAP32[i5 >> 2] = i2;
   if (!i2) {
    i4 = i2;
    i3 = i5;
    i1 = 11;
    break;
   } else break;
  }
 } while (0);
 if ((i1 | 0) == 11) {
  i2 = __Znwj(28) | 0;
  HEAP32[i2 + 16 >> 2] = i6;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (!i1) i1 = i2; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 8 >> 2] | 0, i1);
  i8 = i8 + 12 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 i1 = i2 + 20 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i8 = __Znwj(8) | 0;
  HEAP32[i8 >> 2] = i8;
  HEAP32[i8 + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = i8;
  i8 = __Znwj(8) | 0;
  HEAP32[i8 >> 2] = i8;
  HEAP32[i8 + 4 >> 2] = i8;
  HEAP32[i2 + 24 >> 2] = i8;
  i2 = i8;
 } else i2 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i9 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) i1 = i9 + 4 | 0; else {
  i8 = i9 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  i1 = i8;
 }
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __Z26AddScaleCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb(i2, i11, i12, i1) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf(i2, i1, Math_fround(HEAPF32[i12 + 1084 >> 2])) | 0;
 if ((i10 | 0) == -1) return;
 i9 = i12 + 620 + (i10 * 148 | 0) + 60 | 0;
 i3 = i12 + 620 + (i10 * 148 | 0) + 72 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 620 + (i10 * 148 | 0) + 76 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i12 + 620 + (i10 * 148 | 0) + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 620 + (i10 * 148 | 0) + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i2 = i12 + 620 + (i10 * 148 | 0) + 128 | 0;
 i3 = i12 + 620 + (i10 * 148 | 0) + 140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 620 + (i10 * 148 | 0) + 144 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i12 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i12 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE(i11, 3, (HEAP32[i2 >> 2] | 0) + (i4 << 4) | 0);
 return;
}

function __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, i2, i5, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i6 = 5; else {
     i7 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i7 + 1;
     HEAP32[i2 >> 2] = i3 + -1;
     i1 = i1 & 255;
     i2 = 0;
    }
   } else i6 = 5;
   if ((i6 | 0) == 5) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   i7 = i5;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   return;
  }
 case 1:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 2) i6 = 10; else {
     i8 = HEAP32[i4 >> 2] | 0;
     i7 = HEAP8[i8 >> 0] | 0;
     i1 = i8 + 1 | 0;
     HEAP32[i4 >> 2] = i1;
     HEAP32[i2 >> 2] = i3 + -1;
     i1 = HEAP8[i1 >> 0] | 0;
     HEAP32[i4 >> 2] = i8 + 2;
     HEAP32[i2 >> 2] = i3 + -2;
     i1 = i1 & 255;
     i2 = (i7 & 255) << 8 & 65535;
    }
   } else i6 = 10;
   if ((i6 | 0) == 10) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   i8 = i5;
   HEAP32[i8 >> 2] = (i1 | i2) & 65535;
   HEAP32[i8 + 4 >> 2] = 0;
   return;
  }
 case 2:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 4) i6 = 15; else {
     i10 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i10 >> 0] | 0;
     i9 = i10 + 1 | 0;
     HEAP32[i4 >> 2] = i9;
     HEAP32[i2 >> 2] = i3 + -1;
     i9 = HEAP8[i9 >> 0] | 0;
     i7 = i10 + 2 | 0;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i2 >> 2] = i3 + -2;
     i7 = HEAP8[i7 >> 0] | 0;
     i8 = i10 + 3 | 0;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i2 >> 2] = i3 + -3;
     i8 = HEAP8[i8 >> 0] | 0;
     HEAP32[i4 >> 2] = i10 + 4;
     HEAP32[i2 >> 2] = i3 + -4;
     i2 = i9;
     i3 = i7;
     i4 = i8;
    }
   } else i6 = 15;
   if ((i6 | 0) == 15) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
    i3 = 0;
    i4 = 0;
   }
   i10 = i5;
   HEAP32[i10 >> 2] = (i2 & 255) << 16 | (i1 & 255) << 24 | (i3 & 255) << 8 | i4 & 255;
   HEAP32[i10 + 4 >> 2] = 0;
   return;
  }
 default:
  {
   __ZN5physx7profile17EventDeserializerILb1EE9streamifyIyEEvPKcRT_(i4, i2, i5);
   return;
  }
 }
}

function __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, i2, i5, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i6 = 5; else {
     i7 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i7 + 1;
     HEAP32[i2 >> 2] = i3 + -1;
     i1 = i1 & 255;
     i2 = 0;
    }
   } else i6 = 5;
   if ((i6 | 0) == 5) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   i7 = i5;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   return;
  }
 case 1:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 2) i6 = 10; else {
     i8 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i8 >> 0] | 0;
     i7 = i8 + 1 | 0;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i2 >> 2] = i3 + -1;
     i7 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i8 + 2;
     HEAP32[i2 >> 2] = i3 + -2;
     i1 = i1 & 255;
     i2 = (i7 & 255) << 8 & 65535;
    }
   } else i6 = 10;
   if ((i6 | 0) == 10) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   i8 = i5;
   HEAP32[i8 >> 2] = (i1 | i2) & 65535;
   HEAP32[i8 + 4 >> 2] = 0;
   return;
  }
 case 2:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 4) i6 = 15; else {
     i10 = HEAP32[i4 >> 2] | 0;
     i8 = HEAP8[i10 >> 0] | 0;
     i7 = i10 + 1 | 0;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i2 >> 2] = i3 + -1;
     i7 = HEAP8[i7 >> 0] | 0;
     i9 = i10 + 2 | 0;
     HEAP32[i4 >> 2] = i9;
     HEAP32[i2 >> 2] = i3 + -2;
     i9 = HEAP8[i9 >> 0] | 0;
     i1 = i10 + 3 | 0;
     HEAP32[i4 >> 2] = i1;
     HEAP32[i2 >> 2] = i3 + -3;
     i1 = HEAP8[i1 >> 0] | 0;
     HEAP32[i4 >> 2] = i10 + 4;
     HEAP32[i2 >> 2] = i3 + -4;
     i2 = i9;
     i3 = i7;
     i4 = i8;
    }
   } else i6 = 15;
   if ((i6 | 0) == 15) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
    i3 = 0;
    i4 = 0;
   }
   i10 = i5;
   HEAP32[i10 >> 2] = (i2 & 255) << 16 | (i1 & 255) << 24 | (i3 & 255) << 8 | i4 & 255;
   HEAP32[i10 + 4 >> 2] = 0;
   return;
  }
 default:
  {
   __ZN5physx7profile17EventDeserializerILb0EE9streamifyIyEEvPKcRT_(i4, i2, i5);
   return;
  }
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 8, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 3) | 0, 0, i5 - i3 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 i4 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 8);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  } else {
   i7 = i2;
   i2 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i6 = i8;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i7;
   HEAP32[i9 >> 2] = i3;
   i3 = i7;
  }
  i7 = _llvm_bswap_i32(i2 | 0) | 0;
  HEAP32[i8 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  HEAPF64[i1 >> 3] = +HEAPF64[i8 >> 3];
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function _tt_cmap8_validate(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i3 = i1 + 8208 | 0;
 i2 = i12 + 8 | 0;
 if (i3 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 i13 = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
 if (i13 >>> 0 < 8208 ? 1 : i13 >>> 0 > ((HEAP32[i2 >> 2] | 0) - i1 | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 i13 = i1 + 12 | 0;
 i11 = (HEAPU8[i1 + 8205 >> 0] | 0) << 16 | (HEAPU8[i1 + 8204 >> 0] | 0) << 24 | (HEAPU8[i1 + 8206 >> 0] | 0) << 8 | (HEAPU8[i1 + 8207 >> 0] | 0);
 if (i11 >>> 0 > ((((HEAP32[i2 >> 2] | 0) - i3 | 0) >>> 0) / 12 | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 if (!i11) return 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 20 | 0;
 i7 = 0;
 i8 = 0;
 do {
  i5 = (HEAPU8[i3 + 1 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24;
  i1 = i5 | (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0);
  i6 = (HEAPU8[i3 + 5 >> 0] | 0) << 16 | (HEAPU8[i3 + 4 >> 0] | 0) << 24;
  i2 = i8;
  i8 = i6 | (HEAPU8[i3 + 6 >> 0] | 0) << 8 | (HEAPU8[i3 + 7 >> 0] | 0);
  i4 = (HEAPU8[i3 + 9 >> 0] | 0) << 16 | (HEAPU8[i3 + 8 >> 0] | 0) << 24 | (HEAPU8[i3 + 10 >> 0] | 0) << 8 | (HEAPU8[i3 + 11 >> 0] | 0);
  i3 = i3 + 12 | 0;
  if (i8 >>> 0 < i1 >>> 0) _UNITY_ft_validator_error(i12, 8);
  if (!((i7 | 0) == 0 | i1 >>> 0 > i2 >>> 0)) _UNITY_ft_validator_error(i12, 8);
  do if (HEAP32[i9 >> 2] | 0) {
   i2 = i8 - i1 | 0;
   i14 = HEAP32[i10 >> 2] | 0;
   if (!(i14 >>> 0 >= i2 >>> 0 & i4 >>> 0 < (i14 - i2 | 0) >>> 0)) _UNITY_ft_validator_error(i12, 16);
   i2 = i2 + 1 | 0;
   if (!i5) {
    if (i6 | 0) _UNITY_ft_validator_error(i12, 8);
    if (!i2) break;
    while (1) {
     if ((HEAPU8[i13 + (i1 >>> 3 & 8191) >> 0] | 0) & 128 >>> (i1 & 7) | 0) _UNITY_ft_validator_error(i12, 8);
     i2 = i2 + -1 | 0;
     if (!i2) break; else i1 = i1 + 1 | 0;
    }
   } else {
    if (!i2) break;
    while (1) {
     if (!((HEAPU8[i13 + (i1 >>> 19) >> 0] | 0) & 128 >>> (i1 >>> 16 & 7))) _UNITY_ft_validator_error(i12, 8);
     if (!((HEAPU8[i13 + (i1 >>> 3 & 8191) >> 0] | 0) & 128 >>> (i1 & 7))) _UNITY_ft_validator_error(i12, 8);
     i2 = i2 + -1 | 0;
     if (!i2) break; else i1 = i1 + 1 | 0;
    }
   }
  } while (0);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i11 | 0));
 return 0;
}

function _jinit_downsampler(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i7 + 4 >> 2] >> 2] | 0, i7 | 0, 1, 52) | 0;
 HEAP32[i7 + 340 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 3260;
 HEAP32[i1 + 4 >> 2] = fb + 105;
 i12 = i1 + 8 | 0;
 HEAP8[i12 >> 0] = 0;
 if (HEAP8[i7 + 179 >> 0] | 0) {
  i11 = HEAP32[i7 >> 2] | 0;
  HEAP32[i11 + 20 >> 2] = 25;
  mftCall_vi(HEAP32[i11 >> 2] | 0, i7 | 0);
 }
 i8 = i7 + 60 | 0;
 if ((HEAP32[i8 >> 2] | 0) <= 0) return;
 i9 = i7 + 216 | 0;
 i10 = i7 + 220 | 0;
 i11 = i7 + 180 | 0;
 i6 = i1 + 12 | 0;
 i4 = HEAP32[i7 + 68 >> 2] | 0;
 i5 = 0;
 i1 = 1;
 while (1) {
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  do if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
   i2 = i6 + (i5 << 2) | 0;
   if (!(HEAP32[i11 >> 2] | 0)) {
    HEAP32[i2 >> 2] = fb + 189;
    break;
   } else {
    HEAP32[i2 >> 2] = fb + 188;
    HEAP8[i12 >> 0] = 1;
    break;
   }
  } else i13 = 10; else i13 = 10; while (0);
  do if ((i13 | 0) == 10) {
   i13 = 0;
   if ((i2 << 1 | 0) == (i3 | 0)) {
    if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
     i1 = i6 + (i5 << 2) | 0;
     if (!(_jsimd_can_h2v1_downsample() | 0)) {
      HEAP32[i1 >> 2] = fb + 191;
      i1 = 0;
      break;
     } else {
      HEAP32[i1 >> 2] = fb + 190;
      i1 = 0;
      break;
     }
    }
    if ((HEAP32[i4 + 12 >> 2] << 1 | 0) == (HEAP32[i10 >> 2] | 0)) {
     if (HEAP32[i11 >> 2] | 0) {
      HEAP32[i6 + (i5 << 2) >> 2] = fb + 192;
      HEAP8[i12 >> 0] = 1;
      break;
     }
     i2 = i6 + (i5 << 2) | 0;
     if (!(_jsimd_can_h2v2_downsample() | 0)) {
      HEAP32[i2 >> 2] = fb + 194;
      break;
     } else {
      HEAP32[i2 >> 2] = fb + 193;
      break;
     }
    }
   }
   if (!((i3 | 0) % (i2 | 0) | 0)) if (!((HEAP32[i10 >> 2] | 0) % (HEAP32[i4 + 12 >> 2] | 0) | 0)) {
    HEAP32[i6 + (i5 << 2) >> 2] = fb + 195;
    i1 = 0;
    break;
   }
   i3 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 38;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i7 | 0);
  } while (0);
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (HEAP32[i8 >> 2] | 0)) break; else i4 = i4 + 84 | 0;
 }
 if (i1 << 24 >> 24 != 0 | (HEAP32[i11 >> 2] | 0) == 0) return;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i13 + 20 >> 2] = 99;
 mftCall_vii(HEAP32[i13 + 4 >> 2] | 0, i7 | 0, 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 660329 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN5physx29PxParticleBaseGeneratedValuesC2EPKNS_14PxParticleBaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAPF32[i2 + 24 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i2 + 28 | 0, i1 | 0);
 HEAPF32[i2 + 40 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 44 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 48 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 52 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i2 + 56 | 0, i1 | 0);
 HEAP16[i2 + 72 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 76 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 80 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 84 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 88 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 216 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 92 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0));
 HEAP16[i2 + 96 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 100 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, i3 | 0, i2 + 112 | 0);
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 i8 = i3 + 32 | 0;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i11 = i9;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 28 | 0, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 0);
 i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i4 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i7 = i4 + 16 | 0;
 i5 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 20 >> 2] = i9;
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1085989 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1085998 | 0, i9, i8 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z27TransformVerticesStridedREFPhRK10Matrix4x4fjPKhiiiS4_ii25GfxTransformVerticesFlags(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i16;
 __ZN10Matrix3x3fC2ERK10Matrix4x4f(i4, i2);
 if (i3 & 16 | 0) __ZN10Matrix3x3f15InvertTransposeEv(i4);
 i5 = (i10 | 0) < 0;
 i6 = (i11 | 0) < 0;
 i7 = (i11 & i10 | 0) < 0;
 if (!(i3 & 15)) {
  if (i7) {
   __Z26TransformVerticesInnerLoopILb0ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
  if (i6) {
   __Z26TransformVerticesInnerLoopILb1ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
  if (i5) {
   __Z26TransformVerticesInnerLoopILb0ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  } else {
   __Z26TransformVerticesInnerLoopILb1ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
 } else {
  if (i7) {
   __Z26TransformVerticesInnerLoopILb0ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
  if (i6) {
   __Z26TransformVerticesInnerLoopILb1ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
  if (i5) {
   __Z26TransformVerticesInnerLoopILb0ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  } else {
   __Z26TransformVerticesInnerLoopILb1ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags(i1, i2, i4, i8, i9, i10, i11, i12, i13, i14, i15, i3);
   STACKTOP = i16;
   return;
  }
 }
}

function __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 96 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 96 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 96 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 96 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN19ComputeShaderKernelaSERKS_(i3, i2) | 0;
   i2 = i2 + 96 | 0;
   i3 = i3 + 96 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -96 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN19ComputeShaderKernelD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN19ComputeShaderKernelC2ERKS_(i2, i1);
   i1 = i1 + 96 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 96 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -96 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN19ComputeShaderKernelD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 44739242) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 96 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 22369621 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 44739242;
 if (i3 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 96 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 96 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN19ComputeShaderKernelC2ERKS_(i1, i2);
  i2 = i2 + 96 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 96 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i7, i8, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
  break;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  break;
 } while (0);
 i2 = (i1 | 0) == 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (!i1) i5 = 11; else {
  if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
   HEAP32[i7 >> 2] = 0;
   i5 = 11;
   break;
  }
  if (i2) {
   i4 = i1;
   i5 = 13;
  } else i5 = 12;
 } while (0);
 if ((i5 | 0) == 11) if (i2) i5 = 12; else {
  i4 = 0;
  i5 = 13;
 }
 L16 : do if ((i5 | 0) == 12) HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 6; else if ((i5 | 0) == 13) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAPU8[i2 >> 0] | 0;
  if ((mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i1 & 255 | 0, 0) | 0) << 24 >> 24 != 37) {
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
   break;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = 0; else i5 = 21;
  } else {
   HEAP32[i2 >> 2] = i3 + 1;
   i5 = 21;
  }
  do if ((i5 | 0) == 21) if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
   HEAP32[i6 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   break;
  } while (0);
  i1 = (i1 | 0) == 0;
  do if (!i4) i5 = 30; else {
   if ((HEAP32[i4 + 12 >> 2] | 0) == (HEAP32[i4 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0) == -1) {
    HEAP32[i7 >> 2] = 0;
    i5 = 30;
    break;
   }
   if (i1) break L16;
  } while (0);
  if ((i5 | 0) == 30) if (!i1) break;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 } while (0);
 return;
}

function __ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f12 - f17);
 f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(f13 - f15);
 f14 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(f12 * Math_fround(.5));
 f13 = Math_fround(f13 * Math_fround(.5));
 f14 = Math_fround(Math_fround(f14 - f10) * Math_fround(.5));
 f16 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f16 - f6);
 f11 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f11 - f7);
 f9 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(f3 * Math_fround(.5));
 f4 = Math_fround(f4 * Math_fround(.5));
 f5 = Math_fround(Math_fround(f9 - f8) * Math_fround(.5));
 f6 = Math_fround(Math_fround(f17 + f12) - Math_fround(Math_fround(f16 + f6) * Math_fround(.5)));
 f7 = Math_fround(Math_fround(f15 + f13) - Math_fround(Math_fround(f11 + f7) * Math_fround(.5)));
 f8 = Math_fround(Math_fround(f10 + f14) - Math_fround(Math_fround(f9 + f8) * Math_fround(.5)));
 f9 = Math_fround(Math_abs(Math_fround(f12)));
 f10 = Math_fround(Math_abs(Math_fround(f13)));
 f11 = Math_fround(Math_abs(Math_fround(f14)));
 if (Math_fround(Math_abs(Math_fround(f6))) > Math_fround(f3 + f9)) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_abs(Math_fround(f7))) > Math_fround(f4 + f10)) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_abs(Math_fround(f8))) > Math_fround(f5 + f11)) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_abs(Math_fround(Math_fround(f13 * f8) - Math_fround(f14 * f7)))) > Math_fround(Math_fround(f5 * f10) + Math_fround(f4 * f11))) {
  i2 = 0;
  return i2 | 0;
 }
 if (Math_fround(Math_abs(Math_fround(Math_fround(f14 * f6) - Math_fround(f12 * f8)))) > Math_fround(Math_fround(f9 * f5) + Math_fround(f3 * f11))) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = !(Math_fround(Math_abs(Math_fround(Math_fround(f12 * f7) - Math_fround(f13 * f6)))) > Math_fround(Math_fround(f4 * f9) + Math_fround(f3 * f10)));
 return i2 | 0;
}

function __Z29AddPositionCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb(i2, i11, i12, i1) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf(i2, i1, Math_fround(HEAPF32[i12 + 1084 >> 2])) | 0;
 if ((i10 | 0) == -1) return;
 i9 = i12 + 620 + (i10 * 148 | 0) | 0;
 i3 = i12 + 620 + (i10 * 148 | 0) + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 620 + (i10 * 148 | 0) + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i12 + 620 + (i10 * 148 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 620 + (i10 * 148 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i2 = i12 + 620 + (i10 * 148 | 0) + 128 | 0;
 i3 = i12 + 620 + (i10 * 148 | 0) + 140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i12 + 620 + (i10 * 148 | 0) + 144 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i12 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i12 + 620 + (i10 * 148 | 0) + 132 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE(i11, 1, (HEAP32[i2 >> 2] | 0) + (i4 << 4) | 0);
 return;
}

function __Z12GetParameterR11UTF16StringRib(i7, i5, i6, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((HEAP16[i2 + (i1 << 1) >> 1] | 0) == 61) {
  i1 = i1 + 1 | 0;
  HEAP32[i6 >> 2] = i1;
  i4 = i5 + 4 | 0;
  i2 = HEAP16[i2 + (i1 << 1) >> 1] | 0;
  if (i2 << 16 >> 16 != 62) {
   if (i3) while (1) {
    if (!(i2 << 16 >> 16 != 32 ? (i1 | 0) < (HEAP32[i4 >> 2] | 0) : 0)) break L1;
    HEAP32[i6 >> 2] = i1 + 1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i2 & 255);
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = HEAP16[(HEAP32[i5 >> 2] | 0) + (i1 << 1) >> 1] | 0;
    if (i2 << 16 >> 16 == 62) break L1;
   }
   i2 = i2 & 255;
   i3 = i1;
   while (1) {
    if ((i3 | 0) >= (HEAP32[i4 >> 2] | 0)) break L1;
    HEAP32[i6 >> 2] = i3 + 1;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i2);
    i3 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP16[(HEAP32[i5 >> 2] | 0) + (i3 << 1) >> 1] | 0;
    if (i1 << 16 >> 16 == 62) break; else i2 = i1 & 255;
   }
  }
 } while (0);
 i5 = HEAP8[i7 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 if (i6) i1 = HEAP32[i7 + 4 >> 2] | 0; else i1 = i5 & 255;
 if (i1 >>> 0 <= 2) {
  STACKTOP = i9;
  return;
 }
 if (i6) {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = i4;
  i3 = HEAP8[i4 >> 0] | 0;
  i4 = i4 & 255;
 } else {
  i4 = HEAP8[i7 >> 0] | 0;
  i1 = i5 & 255;
  i2 = i7;
  i3 = i4;
 }
 if (i3 << 24 >> 24 != (HEAP8[i2 + (i1 + -1) >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (i6) {
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i1 = i1 & 255;
 } else {
  i2 = i4;
  i1 = i4;
 }
 if (i2 << 24 >> 24 != 39) {
  if (i6) i1 = HEAP8[HEAP32[i7 >> 2] >> 0] | 0;
  if (i1 << 24 >> 24 != 34) {
   STACKTOP = i9;
   return;
  }
 }
 if (i6) i1 = HEAP32[i7 + 4 >> 2] | 0; else i1 = i5 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i7, 1, i1 + -2 | 0, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sq17SceneQueryManagerC2ERNS_3Scb5SceneERKNS_11PxSceneDescE(i8, i1, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = __ZN5physx2Gu19GetRaycastFuncTableEv() | 0;
 HEAP32[i8 + 4 >> 2] = __ZN5physx2Gu17GetGeomSweepFuncsEv() | 0;
 HEAP32[i8 + 8 >> 2] = __ZN5physx2Gu25GetGeomOverlapMethodTableEv() | 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 0;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 76 >> 2] = i1;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i6 = _PxGetFoundation() | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
  i1 = mftCall_iiiiii(i4 | 0, i5 | 0, i1 | 0, (i6 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i8 + 80 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i3 = i7 + 116 | 0;
 i2 = i8 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i1 = i7 + 120 | 0;
 i5 = i8 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 i4 = i8 + 12 | 0;
 HEAP32[i4 >> 2] = __ZN5physx2Sq17SceneQueryManager12createPrunerENS_18PxPruningStructure4EnumE(HEAP32[i3 >> 2] | 0) | 0;
 i1 = __ZN5physx2Sq17SceneQueryManager12createPrunerENS_18PxPruningStructure4EnumE(HEAP32[i1 >> 2] | 0) | 0;
 i3 = i8 + 16 | 0;
 HEAP32[i3 >> 2] = i1;
 i6 = HEAP32[i7 + 124 >> 2] | 0;
 HEAP32[i8 + 72 >> 2] = i6;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4) if ((HEAP32[i2 >> 2] | 0) == 1) {
  __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(i4, i6);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (!i1) {
  i6 = i7 + 56 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i7 + 60 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  __ZN5physx2Sq17SceneQueryManager11preallocateEjj(i8, i6, i7);
  return;
 }
 if ((HEAP32[i5 >> 2] | 0) != 1) {
  i6 = i7 + 56 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i7 + 60 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  __ZN5physx2Sq17SceneQueryManager11preallocateEjj(i8, i6, i7);
  return;
 }
 __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(i1, i6);
 i6 = i7 + 56 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i7 + 60 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 __ZN5physx2Sq17SceneQueryManager11preallocateEjj(i8, i6, i7);
 return;
}

function __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4 + 8 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 28 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i6, i4, i10, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = i6 + 16 + (i10 * 12 | 0) | 0;
 i5 = i6 + 16 + (i10 * 12 | 0) + 4 | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 if (i9 | 0) {
  i3 = i5;
  i2 = i9;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i5 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) < ((i4 * 3 | 0) / 2 | 0 | 0)) {
   i4 = HEAP32[i3 + 20 >> 2] | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) HEAP32[i8 >> 2] = i1;
   i8 = i6 + 16 + (i10 * 12 | 0) + 8 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i9, i3);
   __ZdlPv(i3);
   if (!i7) {
    i10 = i4;
    return i10 | 0;
   }
   i2 = HEAP32[gb + 1451080 >> 2] | 0;
   i3 = HEAP32[i4 + 4 >> 2] | 0;
   switch (i10 | 0) {
   case 2:
   case 1:
   case 0:
    {
     if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
      i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
      i1 = i1 ? 1 : 2;
     } else i1 = 1;
     break;
    }
   case 6:
   case 5:
   case 4:
    {
     if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
      i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
      i1 = i1 ? 0 : 2;
     } else i1 = 0;
     break;
    }
   case 10:
   case 9:
   case 3:
   case 8:
   case 7:
    {
     i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
     i1 = i1 ? 1 : 2;
     break;
    }
   default:
    i1 = -559030611;
   }
   __ZN7ApiGLES18ClearBufferSubDataEjN2gl12BufferTargetEll(i2, i3, i1, 0, HEAP32[i4 + 8 >> 2] | 0);
   i10 = i4;
   return i10 | 0;
  }
 }
 i9 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63304 | 0, 16, gb + 602218 | 0, 332) | 0;
 __ZN14DataBufferGLESC2ER17BufferManagerGLESiNS_11BufferUsageEb(i9, i6, i4, i10, i7);
 i10 = i9;
 return i10 | 0;
}

function __ZN13AnimationClip8GetStatsER18AnimationClipStats(i3, i16) {
 i3 = i3 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i1 = i16 + 4 | 0;
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i15 = HEAP32[i3 + 220 >> 2] | 0;
 HEAP32[i16 >> 2] = i15;
 i14 = i3 + 216 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if ((i1 | 0) == 0 | (i15 | 0) == 0) return;
 i15 = i16 + 32 | 0;
 HEAP32[i15 >> 2] = 0;
 i13 = i3 + 236 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i5 = i3 + 224 | 0;
  i6 = i16 + 4 | 0;
  i7 = i16 + 8 | 0;
  i8 = i16 + 12 | 0;
  i9 = i16 + 16 | 0;
  i10 = i16 + 20 | 0;
  i11 = i16 + 24 | 0;
  i12 = i16 + 28 | 0;
  i4 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = i2 + (i4 << 4) | 0;
   L8 : do if ((HEAP16[i2 + (i4 << 4) + 12 >> 1] | 0) == 4) switch (HEAP32[i2 + (i4 << 4) + 4 >> 2] | 0) {
   case 1:
    {
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
     i1 = i1 + 3 | 0;
     HEAP32[i15 >> 2] = i1;
     break L8;
    }
   case 2:
    {
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     i1 = i1 + 4 | 0;
     HEAP32[i15 >> 2] = i1;
     break L8;
    }
   case 4:
    {
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
     i1 = i1 + 3 | 0;
     HEAP32[i15 >> 2] = i1;
     break L8;
    }
   case 3:
    {
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
     i1 = i1 + 3 | 0;
     HEAP32[i15 >> 2] = i1;
     break L8;
    }
   default:
    break L8;
   } else {
    if (HEAP8[i2 + (i4 << 4) + 15 >> 0] | 0) {
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
     i1 = i1 + 1 | 0;
     HEAP32[i15 >> 2] = i1;
     break;
    }
    if (__ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE(i3) | 0) {
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
     i1 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
     HEAP32[i15 >> 2] = i1;
     break;
    } else {
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i1 = (HEAP32[i15 >> 2] | 0) + 1 | 0;
     HEAP32[i15 >> 2] = i1;
     break;
    }
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
  i1 = HEAP32[i14 >> 2] | 0;
 }
 i15 = i1 + 1060 | 0;
 i15 = i15 + (HEAP32[i15 >> 2] | 0) | 0;
 HEAP32[i16 + 36 >> 2] = HEAP32[i15 + 36 >> 2];
 HEAP32[i16 + 40 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i16 + 44 >> 2] = HEAP32[i15 + 8 >> 2];
 return;
}

function __ZN12b2MouseJoint24SolveVelocityConstraintsERK12b2SolverData(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i13 = i9 + 116 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i16 = i3 + 28 | 0;
 i7 = HEAP32[i16 >> 2] | 0;
 i17 = i7 + (i6 * 12 | 0) | 0;
 f18 = Math_fround(HEAPF32[i17 >> 2]);
 i8 = i7 + (i6 * 12 | 0) + 4 | 0;
 f19 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + (i6 * 12 | 0) + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i9 + 124 >> 2]);
 f5 = Math_fround(f10 * f11);
 f12 = Math_fround(HEAPF32[i9 + 120 >> 2]);
 f5 = Math_fround(f18 - f5);
 f2 = Math_fround(f19 + Math_fround(f10 * f12));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i9 + 160 >> 2]));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i9 + 164 >> 2]));
 f1 = Math_fround(HEAPF32[i9 + 108 >> 2]);
 i6 = i9 + 96 | 0;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(f1 * f14);
 i7 = i9 + 100 | 0;
 f15 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(-Math_fround(f5 + f4));
 f1 = Math_fround(-Math_fround(f2 + Math_fround(f1 * f15)));
 f2 = Math_fround(Math_fround(HEAPF32[i9 + 144 >> 2]) * f4);
 f2 = Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i9 + 152 >> 2]) * f1));
 f4 = Math_fround(Math_fround(HEAPF32[i9 + 148 >> 2]) * f4);
 f1 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i9 + 156 >> 2]) * f1));
 f2 = Math_fround(f14 + f2);
 HEAPF32[i6 >> 2] = f2;
 f1 = Math_fround(f1 + f15);
 HEAPF32[i7 >> 2] = f1;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i9 + 104 >> 2]));
 f5 = Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2));
 if (f5 > Math_fround(f4 * f4)) {
  f5 = Math_fround(f4 / Math_fround(Math_sqrt(Math_fround(f5))));
  f2 = Math_fround(f2 * f5);
  HEAPF32[i6 >> 2] = f2;
  f1 = Math_fround(f5 * f1);
  HEAPF32[i7 >> 2] = f1;
 }
 f14 = Math_fround(f2 - f14);
 f5 = Math_fround(f1 - f15);
 f4 = Math_fround(HEAPF32[i9 + 136 >> 2]);
 f15 = Math_fround(f18 + Math_fround(f14 * f4));
 f18 = Math_fround(f19 + Math_fround(f5 * f4));
 f19 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i9 + 140 >> 2]) * Math_fround(Math_fround(f5 * f12) - Math_fround(f14 * f11))));
 HEAPF32[i17 >> 2] = f15;
 HEAPF32[i8 >> 2] = f18;
 HEAPF32[(HEAP32[i16 >> 2] | 0) + ((HEAP32[i13 >> 2] | 0) * 12 | 0) + 8 >> 2] = f19;
 return;
}

function __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEEC2INS_11__wrap_iterIPS2_EEEET_SB_RKS5_PNS_9enable_ifIXaasr21__is_forward_iteratorISB_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeE(i6, i3, i4, i2, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 HEAP32[i6 >> 2] = 0;
 i14 = i6 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 i3 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i2 = i12 - i3 | 0;
 if (!i2) {
  STACKTOP = i15;
  return;
 }
 if ((i2 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i13 >> 2] = 51;
 HEAP32[i13 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i1 + (((i2 | 0) / 20 | 0) * 20 | 0);
 if ((i3 | 0) == (i12 | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = i13 + 4 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i6 = i1 + 4 | 0;
  i7 = i3 + 4 | 0;
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  i10 = i1 + 8 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = i2;
  i9 = i3 + 8 | 0;
  i5 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
  i8 = i5 >> 2;
  if (i8 | 0) {
   if ((i5 | 0) < 0) {
    __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   }
   HEAP32[i13 >> 2] = 51;
   HEAP32[i11 >> 2] = i2;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i10 >> 2] = i4;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i1 + 12 >> 2] = i4 + (i8 << 2);
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i1 >> 2 << 2);
   }
  }
  i3 = i3 + 20 | 0;
  i1 = (HEAP32[i14 >> 2] | 0) + 20 | 0;
  HEAP32[i14 >> 2] = i1;
 } while ((i3 | 0) != (i12 | 0));
 STACKTOP = i15;
 return;
}

function __ZN9profiling14SamplerManagerC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP8[i3 + 9 >> 0] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i7 = gb + 63648 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3 + 36 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 i1 = i3 + 72 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP8[i3 + 52 >> 0] = 0;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 i1 = i3 + 88 | 0;
 HEAP32[i1 >> 2] = 32;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 f8 = Math_fround((HEAP32[i1 >> 2] | 0) >>> 0);
 HEAP32[i3 + 100 >> 2] = ~~Math_fround(f8 * Math_fround(.5)) >>> 0;
 HEAP32[i3 + 96 >> 2] = ~~Math_fround(f8 * Math_fround(.200000003)) >>> 0;
 HEAP8[i3 + 104 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i1 = i4 + 24 | 0;
 i7 = gb + 63648 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP8[i4 + 4 >> 0] = 0;
 __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE13set_empty_keyERSE_(i3, i4);
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i4 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 HEAP32[i4 >> 2] = 0;
 i2 = i4 + 24 | 0;
 i6 = gb + 63648 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i4 + 4 | 0;
 HEAP8[i1 >> 0] = 33;
 HEAP8[i1 + 1 >> 0] = 0;
 HEAP32[i4 + 20 >> 2] = 1;
 __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE15set_deleted_keyERSE_(i3, i4);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP32[i4 + 4 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 STACKTOP = i5;
 return;
}

function __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i5 = i9;
 if (!i1) i8 = __ZN8Material25GetDefaultDiffuseMaterialEv() | 0; else i8 = i1;
 i2 = i2 + 4 | 0;
 if ((HEAP32[i8 + 40 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!i3) if (!(__Z14IsWorldPlayingv() | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 477766 | 0, 0, gb + 469775 | 0, 724, 1, HEAP32[i2 >> 2] | 0, 0, 0);
 i4 = i8 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i6 = 9; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i6 = 9;
 if ((i6 | 0) == 9) __ZN8Material15BuildPropertiesEv(i8);
 if ((HEAP32[gb + 1106156 + 4 + ((HEAP32[i8 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) == (gb + 31152 | 0)) i3 = __ZN18ProceduralMaterial5CloneEv(i8) | 0; else {
  i1 = gb + 63520 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i6;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i3 = __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId(4, i7) | 0;
 }
 __Z6AppendPKcS0_(i7, mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0, gb + 781416 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 HEAP32[i3 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i2 >> 2];
 i1 = i3 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63288 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i7 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 743) | 0;
 __ZN18SharedMaterialDataC2ERKS_(i7, HEAP32[i4 >> 2] | 0);
 HEAP32[i1 >> 2] = i7;
 HEAP32[i7 + 168 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN8Material21CopySettingsFromOtherERKS_(i3, i8);
 __ZN18UnityPropertySheetaSERKS_(i3 + 44 | 0, i8 + 44 | 0) | 0;
 i8 = i3;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Sn5ConvX12getMetaClassENS_14PxConcreteType4EnumENS0_12MetaDataTypeE(i9, i8, i7) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 L1 : do if ((i7 | 0) == 1) {
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = HEAP32[i6 + 68 >> 2] | 0;
  if (i3 | 0) {
   i2 = HEAP32[i6 + 64 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i2 + (i1 << 3) >> 2] | 0) == (i8 | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i3 >>> 0) {
     i1 = 0;
     i2 = 13;
     break L1;
    }
   }
   i1 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
   if ((i1 | 0) == (-1 | 0)) i4 = 0; else i4 = (HEAP32[i6 + 16 >> 2] | 0) + i1 | 0;
   i5 = HEAP32[i6 + 24 >> 2] | 0;
   if (!i5) {
    i1 = 0;
    i2 = 13;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i3 = 0;
    while (1) {
     i1 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
     i3 = i3 + 1 | 0;
     if (!(_strcmp(HEAP32[i1 + 12 >> 2] | 0, i4) | 0)) break;
     if (i3 >>> 0 >= i5 >>> 0) {
      i1 = 0;
      i2 = 13;
      break L1;
     }
    }
    while (1) {
     i2 = HEAP32[i1 + 8 >> 2] | 0;
     if (!i2) {
      i2 = 13;
      break;
     } else i1 = i2;
    }
   }
  }
 } else {
  i1 = 0;
  i2 = 13;
 } while (0);
 L17 : do if ((i2 | 0) == 13) {
  if ((i7 | 0) == 2) {
   i6 = HEAP32[i9 + 8 >> 2] | 0;
   i2 = HEAP32[i6 + 68 >> 2] | 0;
   if (!i2) break;
   i3 = HEAP32[i6 + 64 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i8 | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L17;
   }
   i1 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   if ((i1 | 0) == (-1 | 0)) i4 = 0; else i4 = (HEAP32[i6 + 16 >> 2] | 0) + i1 | 0;
   i5 = HEAP32[i6 + 24 >> 2] | 0;
   if (!i5) break;
   i2 = HEAP32[i6 + 20 >> 2] | 0;
   i3 = 0;
   while (1) {
    i1 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
    i3 = i3 + 1 | 0;
    if (!(_strcmp(HEAP32[i1 + 12 >> 2] | 0, i4) | 0)) break;
    if (i3 >>> 0 >= i5 >>> 0) break L17;
   }
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  if (i1 | 0) {
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
 } while (0);
 HEAP32[i10 >> 2] = i8;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i9, 32, gb + 669675 | 0, i10);
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN15CapsuleCollider10SmartResetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i3 = 9; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i2) | 0) {
  f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  __ZN15CapsuleCollider9SetRadiusEf(i4, f7 < f8 ? f8 : f7);
  __ZN15CapsuleCollider9SetHeightEf(i4, Math_fround(f6 * Math_fround(2.0)));
  i1 = i4 + 72 | 0;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  if (f6 != Math_fround(HEAPF32[i2 >> 2])) i3 = 6; else {
   f8 = Math_fround(HEAPF32[i4 + 76 >> 2]);
   if (f8 != Math_fround(HEAPF32[i2 + 4 >> 2])) i3 = 6; else {
    f8 = Math_fround(HEAPF32[i4 + 80 >> 2]);
    if (f8 != Math_fround(HEAPF32[i2 + 8 >> 2])) i3 = 6;
   }
  }
  if ((i3 | 0) == 6) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  }
  if (HEAP32[i4 + 36 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 168 >> 2] | 0, i4 | 0, -2147483645);
 } else i3 = 9;
 if ((i3 | 0) == 9) {
  __ZN15CapsuleCollider9SetRadiusEf(i4, Math_fround(.5));
  __ZN15CapsuleCollider9SetHeightEf(i4, Math_fround(1.0));
  i1 = i4 + 72 | 0;
  f8 = Math_fround(HEAPF32[i1 >> 2]);
  if (f8 != Math_fround(HEAPF32[gb + 1162364 >> 2])) i3 = 12; else {
   f8 = Math_fround(HEAPF32[i4 + 76 >> 2]);
   if (f8 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) i3 = 12; else {
    f8 = Math_fround(HEAPF32[i4 + 80 >> 2]);
    if (f8 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) i3 = 12;
   }
  }
  if ((i3 | 0) == 12) {
   HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  }
  if (HEAP32[i4 + 36 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 168 >> 2] | 0, i4 | 0, -2147483645);
 }
 i1 = i4 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 1) {
  i3 = HEAP32[i4 >> 2] | 0;
  i3 = i3 + 168 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(i3 | 0, i4 | 0, -2147483648);
  STACKTOP = i5;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 i3 = HEAP32[i4 >> 2] | 0;
 i3 = i3 + 168 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(i3 | 0, i4 | 0, -2147483648);
 STACKTOP = i5;
 return;
}

function __ZN12AudioManager31GetCurrentSpatializerDefinitionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i18 + 8 | 0;
 i4 = i18;
 i14 = i18 + 16 | 0;
 i15 = i2 + 140 | 0;
 i5 = i15 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 144 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) {
  i12 = gb + 64016 | 0;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i10 = i4;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i14 >> 2] = 0;
  i10 = i14 + 12 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i14 + 16 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i14 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
  i7 = i3;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i12;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  __Z30GetAudioSpatializerDefinitionsR13dynamic_arrayIP29AudioEffectInternalDefinitionLj4EE(i14);
  L7 : do if (!(HEAP32[i10 >> 2] | 0)) {
   i13 = 0;
   i16 = 1;
  } else {
   i9 = i2 + 144 | 0;
   i1 = 0;
   i8 = HEAP8[i5 >> 0] | 0;
   while (1) {
    i3 = (HEAP32[HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] >> 2] | 0) + 128 | 0;
    i4 = _strlen(i3) | 0;
    if (i8 << 24 >> 24 < 0) i6 = HEAP32[i9 >> 2] | 0; else i6 = i8 & 255;
    if ((i4 | 0) == -1) {
     i17 = 11;
     break;
    }
    if (i8 << 24 >> 24 < 0) i7 = HEAP32[i15 >> 2] | 0; else i7 = i15;
    i5 = i6 >>> 0 > i4 >>> 0;
    i2 = i5 ? i4 : i6;
    if (!i2) i17 = 16; else if (!(_memcmp(i7, i3, i2) | 0)) i17 = 16;
    if ((i17 | 0) == 16) {
     i17 = 0;
     if (i6 >>> 0 >= i4 >>> 0 & (i5 ^ 1)) {
      i17 = 18;
      break;
     }
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
     i13 = 0;
     i16 = 1;
     break L7;
    }
   }
   if ((i17 | 0) == 11) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i15); else if ((i17 | 0) == 18) {
    i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    i16 = 0;
    break;
   }
  } while (0);
  if ((HEAP32[i11 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i12);
   HEAP32[i14 >> 2] = 0;
  }
  if (!i16) {
   i17 = i13;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 i17 = 0;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 40 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 40 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function _UNITY_FT_Vector_Rotate(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!((i9 | 0) != 0 & (i2 | 0) != 0)) return;
 i4 = i9;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(i4 | i3)) return;
 i1 = _FT_MSB(((i4 | 0) < 0 ? 0 - i4 | 0 : i4) | ((i3 | 0) < 0 ? 0 - i3 | 0 : i3)) | 0;
 if ((i1 | 0) < 30) {
  i7 = 29 - i1 | 0;
  i8 = i7;
  i1 = i3 << i7;
  i3 = i4 << i7;
 } else {
  i7 = i1 + -29 | 0;
  i8 = 29 - i1 | 0;
  i1 = i3 >> i7;
  i3 = i4 >> i7;
 }
 if ((i2 | 0) < -2949120) while (1) {
  i1 = 0 - i1 | 0;
  i2 = i2 + 5898240 | 0;
  if ((i2 | 0) < -2949120) {
   i7 = i3;
   i3 = i1;
   i1 = i7;
  } else {
   i5 = 1;
   i6 = 1;
   i7 = gb + 186464 | 0;
   i4 = i3;
   break;
  }
 } else if ((i2 | 0) > 2949120) while (1) {
  i3 = 0 - i3 | 0;
  i2 = i2 + -5898240 | 0;
  if ((i2 | 0) > 2949120) {
   i7 = i1;
   i1 = i3;
   i3 = i7;
  } else {
   i5 = 1;
   i6 = 1;
   i7 = gb + 186464 | 0;
   i4 = i3;
   break;
  }
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = i1;
  i1 = i3;
 }
 while (1) {
  i3 = i1 + i5 >> i6;
  if ((i2 | 0) < 0) {
   i1 = i1 - (i4 + i5 >> i6) | 0;
   i3 = i3 + i4 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i1 = (i4 + i5 >> i6) + i1 | 0;
   i3 = i4 - i3 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
   i4 = i3;
  }
 }
 i7 = (i3 | 0) < 0;
 i6 = i7 ? 0 - i3 | 0 : i3;
 i2 = i6 & 65535;
 i6 = i6 >>> 16;
 i5 = i6 * 23318 | 0;
 i4 = (i2 * 56281 | 0) + i5 | 0;
 i3 = i4 << 16;
 i2 = i3 + (i2 * 23318 | 0) | 0;
 i2 = (i4 >>> 16) + (i6 * 56281 | 0) + ((i4 >>> 0 < i5 >>> 0 & 1) << 16) + (i2 >>> 0 < i3 >>> 0 & 1) + (i2 >>> 0 > 3221225471 & 1) | 0;
 i2 = i7 ? 0 - i2 | 0 : i2;
 i7 = (i1 | 0) < 0;
 i3 = i7 ? 0 - i1 | 0 : i1;
 i1 = i3 & 65535;
 i3 = i3 >>> 16;
 i5 = i3 * 23318 | 0;
 i4 = (i1 * 56281 | 0) + i5 | 0;
 i6 = i4 << 16;
 i1 = i6 + (i1 * 23318 | 0) | 0;
 i1 = (i4 >>> 16) + (i3 * 56281 | 0) + ((i4 >>> 0 < i5 >>> 0 & 1) << 16) + (i1 >>> 0 < i6 >>> 0 & 1) + (i1 >>> 0 > 3221225471 & 1) | 0;
 i1 = i7 ? 0 - i1 | 0 : i1;
 if ((i8 | 0) > 0) {
  i7 = 1 << i8 + -1;
  HEAP32[i9 >> 2] = i2 + i7 + (i2 >> 31) >> i8;
  HEAP32[i9 + 4 >> 2] = i1 + i7 + (i1 >> 31) >> i8;
  return;
 } else {
  i8 = 0 - i8 | 0;
  HEAP32[i9 >> 2] = i2 << i8;
  HEAP32[i9 + 4 >> 2] = i1 << i8;
  return;
 }
}

function __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 52 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i10 = i1 + 28 | 0;
   HEAP8[i1 + 24 >> 0] = 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i10 + 16 >> 2] = 0;
   HEAP32[i10 + 20 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 52 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 52 | 0) + i2 | 0;
 if (i5 >>> 0 > 82595524) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 52 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 41297762 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 82595524;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 52 | 0) | 0;
 i7 = i5 + (((i1 - i4 | 0) / 52 | 0) * 52 | 0) | 0;
 i6 = i7;
 i3 = i5 + (i3 * 52 | 0) | 0;
 i8 = i6;
 i1 = i7;
 do {
  i5 = i1 + 28 | 0;
  HEAP8[i1 + 24 >> 0] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  i1 = i8 + 52 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i1 = i6;
  i6 = i4;
  i3 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -52 | 0;
   __ZN11DetailPatchC2ERKS_(i2 + -52 | 0, i1);
   i2 = i3 + -52 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i1 = i3;
  i6 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i4 = i6;
 if ((i3 | 0) != (i4 | 0)) do {
  i1 = HEAP32[i3 + -12 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 + -8 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i1 = HEAP32[i3 + -24 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 + -20 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i3 = i3 + -52 | 0;
 } while ((i3 | 0) != (i4 | 0));
 if (!i6) return;
 __ZdlPv(i6);
 return;
}

function __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE(i4, i5, i6 + 236 | 0, gb + 115536 | 0, i1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj430ES3_RKNS_18PxJointLinearLimitES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 288 | 0, i5 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj431ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 304 | 0, i5 + 5 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj432ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 320 | 0, i5 + 6 | 0);
 i2 = i6 + 336 | 0;
 i3 = i5 + 7 | 0;
 i7 = i1;
 i9 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev(i1);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_(i4, i3, i2, gb + 115592 | 0, i1);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 352 | 0, i5 + 8 | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj(i4, i6 + 368 | 0, i5 + 9 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj436ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 392 | 0, i5 + 10 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj437ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i4, i6 + 408 | 0, i5 + 11 | 0);
 STACKTOP = i8;
 return i5 + 13 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext5Local18OverflowRecordPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 660181 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN19RenderBufferManager24IsReusableWithParametersERKNSt3__24pairIK4PPtrI13RenderTextureENS_23RenderTextureParametersEEERKS6_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 9;
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 32 >> 2] | 0) != (HEAP32[i5 + 28 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 36 >> 2] | 0) != (HEAP32[i5 + 32 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 4 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 8 >> 2] | 0) != (HEAP32[i5 + 4 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 12 >> 2] | 0) != (HEAP32[i5 + 8 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP8[i4 + 16 >> 0] | 0) != (HEAP8[i5 + 12 >> 0] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 20 >> 2] | 0) != (HEAP32[i5 + 16 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if ((HEAP32[i4 + 24 >> 2] | 0) != (HEAP32[i5 + 20 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = (HEAP8[i4 + 28 >> 0] | 0) == (HEAP8[i5 + 24 >> 0] | 0);
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 136 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 136 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 136 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 136 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN15DetailPrototypeaSERKS_(i3, i2) | 0;
   i2 = i2 + 136 | 0;
   i3 = i3 + 136 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -136 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN15DetailPrototypeD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN15DetailPrototypeC2ERKS_(i2, i1);
   i1 = i1 + 136 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 136 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -136 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN15DetailPrototypeD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 31580641) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 136 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 15790320 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 31580641;
 if (i3 >>> 0 > 31580641) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 136 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 136 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN15DetailPrototypeC2ERKS_(i1, i2);
  i2 = i2 + 136 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 136 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i11, i1, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = i3 - i5 >> 3;
 i6 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i2 = i5;
 i9 = i10;
 i12 = i3;
 if (i8 >>> 0 <= i1 - i10 >> 3 >>> 0) {
  i6 = i11 + 4 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) - i10 >> 3;
  i4 = i8 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + (i1 << 3) | 0 : i3;
  i2 = i1 - i5 | 0;
  i3 = i2 >> 3;
  if (i3 | 0) _memmove(i10 | 0, i5 | 0, i2 | 0) | 0;
  i2 = i9 + (i3 << 3) | 0;
  if (!i4) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
   return;
  }
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   i10 = i1;
   i11 = HEAP32[i10 + 4 >> 2] | 0;
   i12 = i2;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 8 | 0;
   HEAP32[i6 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
 i4 = i10;
 if (i10) {
  i1 = i11 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i3 + (~((i3 + -8 - i10 | 0) >>> 3) << 3);
  __ZdlPv(i4);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  i1 = 0;
 }
 if (i8 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i3 = 0;
 i10 = i1 - i3 | 0;
 i3 = i10 >> 2;
 i3 = i10 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i8 >>> 0 ? i8 : i3) : 536870911;
 if (i3 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
 i1 = __Znwj(i3 << 3) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i1 + (i3 << 3);
 if ((i2 | 0) == (i12 | 0)) return;
 do {
  i9 = i2;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i2 = i2 + 8 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 8 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i12 | 0));
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 40 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 40 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN25RuntimeAnimatorController21BuildCustomControllerERK13AnimationClipPKN7mecanim9animation18ControllerConstantERNS3_6memory9AllocatorE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 24 | 0;
 i7 = i11 + 20 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 12 | 0;
 i10 = i11;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 HEAP32[i6 >> 2] = __ZN7mecanim9animation23CreateBlendTreeConstantEjRNS_6memory9AllocatorE(0, i5) | 0;
 HEAP32[i7 >> 2] = __ZN7mecanim12statemachine19CreateStateConstantEPPNS0_18TransitionConstantEjfjbbbjfjPPNS_9animation17BlendTreeConstantEjjjjjbRNS_6memory9AllocatorE(0, 0, Math_fround(1.0), 0, 1, 1, 0, 0, Math_fround(0.0), 0, i6, 1, i1, i1, i1, 0, 1, i5) | 0;
 HEAP32[i8 >> 2] = __ZN7mecanim12statemachine26CreateStateMachineConstantEPPNS0_13StateConstantEjjPPNS0_18TransitionConstantEjPPNS0_21SelectorStateConstantEjjRNS_6memory9AllocatorE(i7, 1, 0, 0, 0, 0, 0, 1, i5) | 0;
 i7 = __ZN7mecanim9animation19CreateLayerConstantEjjRNS_6memory9AllocatorE(0, 0, i5) | 0;
 HEAP32[i9 >> 2] = i7;
 i6 = i7 + 8 | 0;
 __ZN7mecanim5human12FullBodyMaskEv(i10);
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 + 20 >> 2] = 0;
 i7 = i4 + 16 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 i7 = i10 + i7 | 0;
 i7 = __ZN7mecanim28CreateValueArrayConstantCopyEPKNS_18ValueArrayConstantEjRNS_6memory9AllocatorE((i10 | 0) == 0 ? 0 : i7, HEAP32[i7 >> 2] | 0, i5) | 0;
 i10 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(i7, i5) | 0;
 i6 = i4 + 20 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_((i4 | 0) == 0 ? 0 : i4 + i6 | 0, i10);
 i10 = __ZN7mecanim9animation24CreateControllerConstantEjPPNS0_13LayerConstantEjPPNS_12statemachine20StateMachineConstantEPNS_18ValueArrayConstantEPNS_10ValueArrayEjRNS_6memory9AllocatorE(1, i9, 1, i8, i7, i10, 1, i5) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE19FileEnumerationFlagRNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i10 + 44 | 0;
 i2 = i10 + 12 | 0;
 i9 = i10 + 24 | 0;
 i13 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i2, i13, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i8, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i1 = i9 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i13 = i7;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i2;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i11, __ZNK15FileSystemEntry4PathEv(i8) | 0, i9, 0, i3) | 0;
 switch (i5 | 0) {
 case 0:
  {
   __ZNK10FileSystem16CurrentDirectoryEv(i7, __Z13GetFileSystemv() | 0);
   __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE(i7, i9, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   break;
  }
 case 1:
  {
   __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE(i6, i9, i4);
   break;
  }
 case 2:
  {
   __ZL41FileEntryInfoListToFolderContentsAbsoluteRK13dynamic_arrayI13FileEntryInfoLj8EERNSt3__23setINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS4_4lessISB_EENS9_ISB_EEEE(i9, i4);
   break;
  }
 default:
  {}
 }
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  __ZN13FileEntryDataD2Ev(i8);
  STACKTOP = i10;
  return 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i2);
 HEAP32[i9 >> 2] = 0;
 __ZN13FileEntryDataD2Ev(i8);
 STACKTOP = i10;
 return 1;
}

function __ZN9Texture3D11SetPixels32EiPK11ColorRGBA32i(i11, i12, i13, i10) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 20 | 0;
 i15 = i16;
 if ((i12 | 0) == 0 | (i13 | 0) == 0) {
  STACKTOP = i16;
  return;
 }
 i1 = i11 + 96 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418864 | 0, 0, gb + 411375 | 0, 264, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i16;
  return;
 }
 if (!((i10 | 0) > -1 & (mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 116 >> 2] | 0, i11 | 0) | 0) > (i10 | 0))) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 411375 | 0, 271, 1, HEAP32[i11 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i16;
  return;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i11 + 80 >> 2] | 0;
 i6 = HEAP32[i11 + 84 >> 2] | 0;
 i7 = HEAP32[i11 + 88 >> 2] | 0;
 i9 = i11 + 92 | 0;
 i2 = HEAP32[gb + 45784 + (HEAP32[i9 >> 2] << 2) >> 2] | 0;
 if ((i10 | 0) > 0) {
  i1 = 0;
  i4 = 0;
  i3 = 0;
  do {
   i19 = i5 >> i1;
   i18 = i6 >> i1;
   i17 = i7 >> i1;
   i17 = Math_imul(Math_imul(Math_imul((i19 | 0) < 1 ? 1 : i19, i2) | 0, (i18 | 0) < 1 ? 1 : i18) | 0, (i17 | 0) < 1 ? 1 : i17) | 0;
   i4 = _i64Add(i17 | 0, ((i17 | 0) < 0) << 31 >> 31 | 0, i4 | 0, i3 | 0) | 0;
   i3 = getTempRet0() | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
 } else i4 = 0;
 i3 = i5 >> i10;
 i3 = (i3 | 0) < 1 ? 1 : i3;
 i2 = i6 >> i10;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i1 = i7 >> i10;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if ((Math_imul(Math_imul(i2, i3) | 0, i1) | 0) == (i12 | 0)) {
  i18 = Math_imul(i1, i2) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i14, i3, i18, i3 << 2, 4, i13);
  i19 = HEAP32[i9 >> 2] | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i15, i3, i18, Math_imul(HEAP32[gb + 45784 + (i19 << 2) >> 2] | 0, i3) | 0, i19, i8 + i4 | 0);
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i15, i14, 0);
  STACKTOP = i16;
  return;
 }
 if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418272 | 0, 0, gb + 411375 | 0, 305, 1, i1, 0, 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx2Sc8BodyCore13getSerialCoreERNS_11PxsBodyCoreE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP8[i7 + 28 >> 0] = HEAP8[i1 + 44 >> 0] | 0;
 i3 = i7 + 29 | 0;
 i4 = i1 + 45 | 0;
 HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[i4 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[i4 + 2 >> 0] | 0;
 HEAP32[i7 + 32 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i7 + 36 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i7 + 60 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i7 + 64 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i7 + 68 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i7 + 72 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i7 + 76 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i7 + 80 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i7 + 84 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i7 + 88 >> 2] = HEAP32[i1 + 104 >> 2];
 i3 = i7 + 92 | 0;
 i4 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 i3 = i7 + 112 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 128 >> 2];
 i4 = i7 + 116 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 132 >> 2];
 i5 = i7 + 120 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 136 >> 2];
 i6 = i7 + 124 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 140 >> 2];
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i7 = i2;
  return i7 | 0;
 }
 if ((HEAP8[i1 + 31 >> 0] | 0) != 1) {
  i7 = i2;
  return i7 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i7 + 104 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i7 + 108 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i7 + 96 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i7 + 100 >> 2] = HEAP32[i1 + 60 >> 2];
 i7 = i2;
 return i7 | 0;
}

function __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData(i4, i6, i3, i5, i7) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (i1 | 0) {
  i10 = (__ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i6, i1, i8) | 0) == 0;
  i10 = i10 ? HEAP32[i8 >> 2] | 0 : 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = __ZnwjRK10MemLabelIdiPKci(120, gb + 63328 | 0, 16, gb + 860370 | 0, 310) | 0;
 i9 = i10 + 112 | 0;
 i1 = i10;
 i2 = i1 + 120 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i10 >> 2] = 80;
 HEAP32[i10 + 28 >> 2] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 200 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i5;
 HEAP32[i10 + 36 >> 2] = gb + 1097872;
 HEAP32[i10 + 48 >> 2] = 66304;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(0 == 0 ? (HEAP32[i1 + 120 >> 2] & 1 | 0) == 0 : 0)) HEAP32[i10 + 32 >> 2] = 8;
 HEAP32[i1 + 88 >> 2] = i10;
 i3 = i10 + 116 | 0;
 if (!(__ZN4FMOD6System9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE(i6, i1, i3) | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i10 + 40 >> 2] | 0;
   if ((i7 | 0) != 0 & (i2 | 0) != 0) {
    HEAP32[i7 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   HEAP32[i8 >> 2] = i1;
   i10 = i1;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i7 = HEAP32[i9 >> 2] | 0;
 if (i7 | 0) {
  i6 = i7 + 200 | 0;
  i8 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  HEAP32[i6 >> 2] = i8;
  if (!i8) {
   i5 = i7 + 60 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = i7 + 64 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) > 0) {
    i4 = 0;
    do {
     i3 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
     if (i3) {
      __ZdaPv(i3);
      i2 = HEAP32[i5 >> 2] | 0;
      i1 = HEAP32[i6 >> 2] | 0;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) < (i2 | 0));
   }
   if (i1 | 0) __ZdaPv(i1);
   i1 = HEAP32[i7 + 180 >> 2] | 0;
   if (i1 | 0) __ZdaPv(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63328 | 0);
  }
 }
 HEAP32[i9 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 63328 | 0);
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 40 | 0) + 1 | 0;
 if (i3 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 40 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 53687091 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 107374182;
 i1 = (i2 - i1 | 0) / 40 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 40 | 0) | 0;
 i2 = i4 + (i1 * 40 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 40 | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + (i1 * 40 | 0) + 20 >> 2] = 0;
 i12 = i6 + 24 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = i4 + (i1 * 40 | 0) + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i11;
 HEAP8[i4 + (i1 * 40 | 0) + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i6);
 i4 = i4 + (i1 * 40 | 0) + 32 | 0;
 i6 = i6 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i6 + 4 >> 0] | 0;
 i6 = i2 + 40 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i5 = i4;
  i1 = i4;
 } else {
  do {
   i12 = i2 + -40 | 0;
   i11 = i1;
   i1 = i1 + -40 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i2 + -20 >> 2] = 0;
   i14 = i11 + -16 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i5 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = i13;
   HEAP8[i2 + -36 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i12, i1);
   i12 = i2 + -8 | 0;
   i11 = i11 + -8 | 0;
   HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
   HEAP8[i12 + 4 >> 0] = HEAP8[i11 + 4 >> 0] | 0;
   i2 = i3 + -40 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -36 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN5physx11NpAggregate15addArticulationERNS_14PxArticulationE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 36 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0) | 0) + i5 | 0;
 i4 = i6 + 8 | 0;
 if (i5 >>> 0 > (HEAP32[i6 + 28 >> 2] | 0) >>> 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 202, gb + 678409 | 0, i8);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 128 >> 2] | 0, i7 | 0) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 208, gb + 678481 | 0, i8 + 8 | 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 214, gb + 678576 | 0, i8 + 16 | 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i7 + 100 >> 2] = i6;
 i2 = HEAP32[i7 + 88 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0) | 0) {
  i3 = i6 + 40 | 0;
  i5 = 0;
  do {
   i9 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
   __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i9 + (HEAP32[gb + 1457020 + ((HEAPU16[i9 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, i6, i9);
   i10 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i10 + 1;
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i10 << 2) >> 2] = i9;
   __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE(i4, i9 + 48 | 0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0) | 0) >>> 0);
 }
 if ((((HEAP32[i6 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i10 = 1;
  STACKTOP = i8;
  return i10 | 0;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 if (!i1) {
  i10 = 1;
  STACKTOP = i8;
  return i10 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 if (!i1) {
  i10 = 1;
  STACKTOP = i8;
  return i10 | 0;
 }
 __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE(i1, i7);
 i10 = 1;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator13GeneratorTileEE6updateEibbb(i8, i7, i5, i1, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i9 = 0;
 if (!((i7 | 0) != 0 | i1 ^ 1)) {
  i1 = i8 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i8 = 1;
  return i8 | 0;
 }
 i3 = i8 + 8 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) < (i7 | 0) | (i6 | 0) > (i7 | 0) & i1) {
  if (i2) i2 = i7; else {
   i2 = i7 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
  }
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 << 5 | 16 | 0, 0) | 0;
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i6 = i1 + 16 | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    HEAP32[i6 + (i1 << 5) >> 2] = 0;
    HEAP32[i6 + (i1 << 5) + 4 >> 2] = 0;
    HEAP32[i6 + (i1 << 5) + 8 >> 2] = 0;
    HEAP32[i6 + (i1 << 5) + 12 >> 2] = -1;
    HEAP32[i6 + (i1 << 5) + 16 >> 2] = 63;
    HEAP32[i6 + (i1 << 5) + 20 >> 2] = 63;
    HEAP32[i6 + (i1 << 5) + 24 >> 2] = 0;
    HEAP32[i6 + (i1 << 5) + 28 >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i2;
  i4 = i8 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   if (i5) {
    i2 = HEAP32[i8 + 12 >> 2] | 0;
    if (i2) {
     i3 = (i2 | 0) <= (i7 | 0) ? i2 : i7;
     if ((i3 | 0) > 0) {
      i2 = 0;
      do {
       i5 = i6 + (i2 << 5) | 0;
       i9 = i1 + (i2 << 5) | 0;
       HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
       HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
       HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
       HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
       HEAP32[i5 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
       HEAP32[i5 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
       HEAP32[i5 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
       HEAP32[i5 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
       i2 = i2 + 1 | 0;
      } while ((i2 | 0) != (i3 | 0));
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) break;
     }
    }
   }
   i9 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 + -16 | 0);
  } while (0);
  HEAP32[i4 >> 2] = i6;
 }
 HEAP32[i8 + 12 >> 2] = i7;
 i9 = 1;
 return i9 | 0;
}

function __ZN18ProceduralMaterial7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(296, i1, 16, gb + 1048932 | 0, 0, gb + 432281 | 0, 294) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8MaterialC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 59244 + 8;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 9;
 HEAP32[i4 + 116 >> 2] = 9;
 HEAP8[i4 + 120 >> 0] = 1;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 144 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i4 + 168 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 167 >> 0] = 0;
 HEAP8[i4 + 156 >> 0] = 0;
 i2 = i4 + 172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i4 + 208 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = 0;
 HEAP32[i4 + 216 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 224 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 232 >> 2] = 0;
 HEAP32[i4 + 220 >> 2] = i2;
 i2 = i4 + 240 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i4 + 256 >> 2] = 1;
 HEAP32[i4 + 264 >> 2] = 42;
 HEAPF32[i4 + 268 >> 2] = Math_fround(0.0);
 i2 = i4 + 276 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 280 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 284 >> 2] = 0;
 HEAP32[i4 + 272 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 368 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 340 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 344 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 348 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 352 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 356 | 0;
  __ZN16ParticleRenderer11UVAnimation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 356 | 0;
  __ZN16ParticleRenderer11UVAnimation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN13GfxDeviceGLES11CopyTextureE9TextureIDS0_(i9, i1, i6) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i1 = HEAP32[i3 + 32 >> 2] | 0;
  i4 = i2 + (i1 << 3) | 0;
  i5 = i3;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i3, i8);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i5 = HEAP32[gb + 1157724 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i4 << 3) | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[i5 + 32 >> 2] | 0;
 }
 i3 = i2 + (i1 << 3) | 0;
 if ((i4 | 0) == (i3 | 0)) i4 = 0; else i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 if ((HEAP32[i5 + 36 >> 2] | 0) != (HEAP32[i5 + 4 >> 2] | 0)) {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i5, i8);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i2 + (HEAP32[i5 + 32 >> 2] << 3) | 0 : i2 + (i3 << 3) | 0;
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i1 = HEAP32[i1 + 32 >> 2] | 0;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9 + 4620 | 0;
 if (!(__ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_(i1, i4, i2) | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = (i7 | 0) == 3;
 i9 = HEAP32[i4 + 32 >> 2] | 0;
 __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii(i1, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, HEAP32[i4 + 20 >> 2] | 0, 0, 0, 0, 0, 0, HEAP32[i2 >> 2] | 0, i7, HEAP32[i2 + 20 >> 2] | 0, 0, 0, 0, 0, 0, i8 ? 1 : i9, HEAP32[i4 + 36 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0, HEAP32[i4 + 28 >> 2] | 0, i8 ? i9 : 1);
 STACKTOP = i10;
 return;
}

function __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_(i4, i8, i9, i10) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, i11 = 0, f12 = f0;
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   i3 = i1 + -20 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   } else i1 = i3;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i11 = i1 - i2 | 0;
 i3 = (i11 | 0) / 20 | 0;
 if (!i11) __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i4, 1 - i3 | 0); else if (i3 >>> 0 > 1) {
  i3 = i2 + 20 | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i2 = i1 + -20 | 0;
   HEAP32[i7 >> 2] = i2;
   if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i1 >> 2] = i8;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i8 << 3, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 3, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i4 >> 2] = i11;
  break;
 } while (0);
 f6 = Math_fround(Math_fround(6.28318548) / Math_fround(i8 | 0));
 if ((i8 | 0) <= 0) return;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i10 + 4 | 0;
 i4 = i9 + 4 | 0;
 f5 = Math_fround(0.0);
 i1 = 0;
 do {
  f12 = Math_fround(HEAPF32[i10 >> 2]);
  HEAPF32[i2 + (i1 << 3) >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(+Math_sin(+f5))));
  f12 = Math_fround(HEAPF32[i3 >> 2]);
  HEAPF32[i2 + (i1 << 3) + 4 >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(+Math_cos(+f5))));
  i1 = i1 + 1 | 0;
  f5 = Math_fround(f6 + f5);
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN5Unity12PhysicsQuery7BoxTestERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction(i1, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 100 | 0;
 i2 = i12 + 64 | 0;
 i3 = i12 + 48 | 0;
 i4 = i12 + 20 | 0;
 i5 = i12;
 if ((HEAP16[gb + 1452692 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452692 | 0, i1);
  i6 = gb + 1452692 | 0;
 } else i6 = 0;
 i16 = HEAP32[i8 >> 2] | 0;
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 i14 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = i16;
 HEAP32[i3 + 8 >> 2] = i13;
 HEAP32[i3 + 12 >> 2] = i14;
 i14 = HEAP32[i7 >> 2] | 0;
 i13 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = HEAP32[i7 + 8 >> 2] | 0;
 i16 = HEAP32[i9 + 4 >> 2] | 0;
 i15 = HEAP32[i9 + 8 >> 2] | 0;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i16;
 HEAP32[i4 + 8 >> 2] = i15;
 HEAP32[i4 + 12 >> 2] = i7;
 HEAP32[i4 + 16 >> 2] = i14;
 HEAP32[i4 + 20 >> 2] = i13;
 HEAP32[i4 + 24 >> 2] = i8;
 HEAP32[i5 >> 2] = gb + 114012 + 8;
 HEAP32[i5 + 4 >> 2] = 2;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = i10;
 switch (i11 | 0) {
 case 0:
  {
   HEAP8[i5 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i5 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i5 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i15 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 55;
 HEAP8[i1 + 18 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 i16 = i2 + 20 | 0;
 HEAP8[i16 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 85608 + 8;
 mftCall_iiiiiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 356 >> 2] | 0, i15 | 0, i3 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
 i1 = (HEAP8[i16 >> 0] | 0) != 0;
 if (!i6) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN10VertexDataC2ERKS_jRK19VertexStreamsLayoutRK20VertexChannelsLayout(i6, i7, i8, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i6 + 100 | 0;
 i4 = i6;
 i5 = i4 + 100 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i3 >> 0] = 1;
 __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i6, HEAP32[i7 + 92 >> 2] | 0, i8, 0, i1, i2);
 i2 = i6 + 96 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + 16 | 0;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (i4 | 0) _memset(i4 | 0, 0, i1 | 0) | 0;
 HEAP32[i6 + 84 >> 2] = i4;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 | 0) == (HEAP32[i7 + 96 >> 2] | 0)) if ((HEAP32[i7 + 88 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) if ((HEAP32[i6 + 4 >> 2] | 0) == (HEAP32[i7 + 4 >> 2] | 0)) if ((HEAP32[i6 + 8 >> 2] | 0) == (HEAP32[i7 + 8 >> 2] | 0)) if ((HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i7 + 12 >> 2] | 0)) if ((HEAP32[i6 + 16 >> 2] | 0) == (HEAP32[i7 + 16 >> 2] | 0)) if ((HEAP32[i6 + 20 >> 2] | 0) == (HEAP32[i7 + 20 >> 2] | 0)) if ((HEAP32[i6 + 24 >> 2] | 0) == (HEAP32[i7 + 24 >> 2] | 0)) if ((HEAP32[i6 + 28 >> 2] | 0) == (HEAP32[i7 + 28 >> 2] | 0)) {
  i2 = i6 + 32 | 0;
  i3 = i7 + 32 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) if ((HEAP32[i2 + 8 >> 2] | 0) == (HEAP32[i3 + 8 >> 2] | 0)) if ((HEAP32[i6 + 44 >> 2] | 0) == (HEAP32[i7 + 44 >> 2] | 0)) if ((HEAP32[i2 + 16 >> 2] | 0) == (HEAP32[i3 + 16 >> 2] | 0)) if ((HEAP32[i2 + 20 >> 2] | 0) == (HEAP32[i3 + 20 >> 2] | 0)) if ((HEAP32[i6 + 56 >> 2] | 0) == (HEAP32[i7 + 56 >> 2] | 0)) if ((HEAP32[i2 + 28 >> 2] | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
   if ((HEAP32[i2 + 32 >> 2] | 0) != (HEAP32[i3 + 32 >> 2] | 0)) break;
   if ((HEAP32[i6 + 68 >> 2] | 0) != (HEAP32[i7 + 68 >> 2] | 0)) break;
   if ((HEAP32[i2 + 40 >> 2] | 0) != (HEAP32[i3 + 40 >> 2] | 0)) break;
   if ((HEAP32[i2 + 44 >> 2] | 0) != (HEAP32[i3 + 44 >> 2] | 0)) break;
   _memcpy(i4 | 0, HEAP32[i7 + 84 >> 2] | 0, i1 | 0) | 0;
   return;
  }
 } while (0);
 __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph(HEAP32[i6 + 92 >> 2] | 0, i8, i7 + 32 | 0, i7, HEAP32[i7 + 84 >> 2] | 0, i6 + 32 | 0, i6, i4);
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReaddEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 36996 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else if ((i2 + 8 | 0) >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
   HEAP8[tempDoublePtr >> 0] = HEAP8[i2 >> 0];
   HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i2 + 1 >> 0];
   HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i2 + 2 >> 0];
   HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i2 + 3 >> 0];
   HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i2 + 4 >> 0];
   HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i2 + 5 >> 0];
   HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i2 + 6 >> 0];
   HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i2 + 7 >> 0];
   HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
   HEAP8[i4 >> 0] = HEAP8[tempDoublePtr >> 0];
   HEAP8[i4 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
   HEAP8[i4 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
   HEAP8[i4 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
   HEAP8[i4 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
   HEAP8[i4 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
   HEAP8[i4 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
   HEAP8[i4 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
  if (HEAP32[i6 >> 2] & 512 | 0) {
   i3 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   i5 = i4 + 4 | 0;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i5 >> 2] = i3;
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN4Mesh18UpdateVertexFormatEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i11 = i13 + 32 | 0;
 i12 = i13;
 i7 = i9 + 32 | 0;
 __ZNK14VertexDataInfo17GetChannelsLayoutEv(i11, (HEAP32[i7 >> 2] | 0) + 8 | 0);
 i1 = 0;
 i2 = 0;
 i6 = 1;
 while (1) {
  i4 = i11 + (i2 << 1) + 1 | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i3 = i1;
   i8 = 18;
  } else {
   i5 = i11 + (i2 << 1) | 0;
   i3 = HEAP8[i5 >> 0] | 0;
   do if (i3 << 24 >> 24 == 1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 512 >> 0] | 0)) {
    HEAP8[i5 >> 0] = 0;
    i1 = i1 | i6;
    break;
   } else {
    i3 = HEAP8[i5 >> 0] | 0;
    i8 = 12;
    break;
   } else i8 = 12; while (0);
   if ((i8 | 0) == 12) {
    i8 = 0;
    if (i3 << 24 >> 24 == 3) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 513 >> 0] | 0)) {
     HEAP8[i5 >> 0] = 0;
     i1 = i1 | i6;
    }
   }
   if ((i2 | 0) == 1) if (!(HEAP8[i5 >> 0] | 0)) {
    HEAP8[i4 >> 0] = 3;
    i3 = i1;
    i8 = 18;
   } else i2 = 2; else {
    i3 = i1;
    i8 = 18;
   }
  }
  if ((i8 | 0) == 18) {
   i8 = 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 8) break; else i1 = i3;
  }
  i6 = i6 << 1;
 }
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i1 = HEAP32[i8 + 100 >> 2] | 0;
 if (!(HEAP32[i8 + 176 >> 2] | 0)) if ((HEAP32[i9 + 116 >> 2] | 0) == (HEAP32[i9 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i10, i2);
  HEAP32[i10 >> 2] = (HEAP32[i10 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i10 + 8 >> 2] & ~HEAP32[i10 + 12 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i2, i1, i3, 0, i12, i11);
  __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i9, 1);
  STACKTOP = i13;
  return;
 };
 HEAP32[i12 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i2, i1, i3, 0, i12, i11);
 __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i9, 1);
 STACKTOP = i13;
 return;
}

function __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i6, i9, i8, i10, i11) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i12 = i14 + 24 | 0;
 i5 = i14 + 16 | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i6 + 32 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i7 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) {
   i2 = HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   i1 = i6 + 72 | 0;
  } else i7 = 7;
 } else i7 = 7; while (0);
 if ((i7 | 0) == 7) {
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i5, i6, i9, 3, 32, 0, 0);
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i6 + 72 | 0;
  i7 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 1;
  HEAP32[i7 + 12 >> 2] = 0;
  i7 = i7 + 16 | 0;
  HEAP32[i7 >> 2] = -1;
  HEAP32[i7 + 4 >> 2] = -1;
  HEAP32[i7 + 8 >> 2] = -1;
  HEAP32[i7 + 12 >> 2] = -1;
 }
 i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i10;
 if (!(i8 | i10)) {
  i13 = i2 + 12 | 0;
  HEAP32[i13 >> 2] = i11;
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i1 | 0) == 1 | (i1 | 0) == (i10 | 0)) {
  i13 = i2 + 12 | 0;
  HEAP32[i13 >> 2] = i11;
  STACKTOP = i14;
  return;
 }
 i7 = HEAP32[gb + 68604 + (i10 << 2) >> 2] | 0;
 i8 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
 i10 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i9) | 0;
 HEAP32[i13 >> 2] = i7;
 HEAP32[i13 + 4 >> 2] = i8;
 HEAP32[i13 + 8 >> 2] = i10;
 __Z6FormatPKcz(i12, gb + 478736 | 0, i13);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 i13 = i2 + 12 | 0;
 HEAP32[i13 >> 2] = i11;
 STACKTOP = i14;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i12 = i14;
 i5 = i9 + 4 | 0;
 HEAP32[i11 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i12 | 0, i11 | 0) | 0;
 i11 = (HEAP32[i12 >> 2] | 0) * 48 | 0;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i3;
 i10 = i1 - i2 | 0;
 i4 = i10 + i11 | 0;
 if (!i4) i6 = i3; else {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i2 | 0) >>> 0 > i4 >>> 0) i6 = i3; else {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = i5 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i4 | 0, i2 | 0, i10 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i4;
   i6 = i4 + i10 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 >> 2] = i4 + i1;
   i1 = i6;
   i6 = i4;
  }
 }
 HEAP32[i8 >> 2] = i1 + i11;
 i4 = i6 + i10 | 0;
 if (!i11) {
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i4;
  i12 = i4 + (i12 * 48 | 0) | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 16 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i2 = i9 + 8 | 0;
  i3 = i2;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i9 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i9 + 12 >> 2] | 0) - i2 | 0;
 }
 i1 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 if (i11 >>> 0 > i1 >>> 0) _memset(i6 + (i1 + i10) | 0, 0, i11 - i1 | 0) | 0;
 HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) == 0 ? 0 : (i11 | 0) == (i1 | 0) & 1;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i4;
 i12 = i4 + (i12 * 48 | 0) | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function _ialloc(i11, i12, i6, i2) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i10 = i1 & -16 ^ 1431655768;
  HEAP32[i1 >> 2] = i10;
  HEAP32[gb + 1470876 >> 2] = i10;
 }
 i1 = (i11 | 0) == 0;
 do if (!i2) {
  if (!i1) {
   i3 = i11 << 2;
   i5 = 0;
   i3 = i3 >>> 0 < 11 ? 16 : i3 + 11 & -8;
   break;
  }
  i12 = _malloc(0) | 0;
  STACKTOP = i13;
  return i12 | 0;
 } else if (i1) {
  i12 = i2;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i5 = i2;
  i3 = 0;
 } while (0);
 if (!(i6 & 1)) {
  i2 = 0;
  i1 = 0;
  do {
   i10 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
   i1 = (i10 >>> 0 < 11 ? 16 : i10 + 11 & -8) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i11 | 0));
  i9 = 0;
 } else {
  i1 = HEAP32[i12 >> 2] | 0;
  i1 = i1 >>> 0 < 11 ? 16 : i1 + 11 & -8;
  i9 = i1;
  i1 = Math_imul(i1, i11) | 0;
 }
 i8 = _malloc(i3 + -4 + i1 | 0) | 0;
 if (!i8) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i2 = i8 + -8 | 0;
 i4 = HEAP32[i8 + -4 >> 2] & -8;
 if (i6 & 2 | 0) _memset(i8 | 0, 0, -4 - i3 + i4 | 0) | 0;
 i3 = i2 + i1 | 0;
 if (!i5) {
  HEAP32[i3 + 4 >> 2] = i4 - i1 | 3;
  i10 = i3 + 8 | 0;
 } else {
  i1 = i4;
  i10 = i5;
 }
 HEAP32[i10 >> 2] = i8;
 i7 = i11 + -1 | 0;
 L27 : do if (i7) {
  if (!i9) {
   i3 = 0;
   while (1) {
    i11 = HEAP32[i12 + (i3 << 2) >> 2] | 0;
    i11 = i11 >>> 0 < 11 ? 16 : i11 + 11 & -8;
    i1 = i1 - i11 | 0;
    HEAP32[i2 + 4 >> 2] = i11 | 3;
    i2 = i2 + i11 | 0;
    i3 = i3 + 1 | 0;
    HEAP32[i10 + (i3 << 2) >> 2] = i2 + 8;
    if ((i3 | 0) == (i7 | 0)) break L27;
   }
  }
  i6 = Math_imul(i9, 1 - i11 | 0) | 0;
  i4 = (Math_imul(i9, i7) | 0) + -8 | 0;
  i5 = i9 | 3;
  i3 = 0;
  do {
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i2 + i9 | 0;
   i3 = i3 + 1 | 0;
   HEAP32[i10 + (i3 << 2) >> 2] = i2 + 8;
  } while ((i3 | 0) != (i7 | 0));
  i2 = i8 + i4 | 0;
  i1 = i1 + i6 | 0;
 } while (0);
 HEAP32[i2 + 4 >> 2] = i1 | 3;
 i12 = i10;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN3WWW27SetErrorFromResponseHeadersEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 16 | 0;
 i8 = i11 + 4 | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i7 | 0, i6 | 0);
 i9 = i7 + 11 | 0;
 if (!(__Z10BeginsWithPKcS0_((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, gb + 1046953 | 0) | 0)) {
  i10 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP8[i9 >> 0] | 0;
 i5 = i2 << 24 >> 24 < 0;
 i1 = i5 ? HEAP32[i7 >> 2] | 0 : i7;
 i2 = i5 ? HEAP32[i7 + 4 >> 2] | 0 : i2 & 255;
 if (!i2) i1 = -1; else {
  i4 = i1 + i2 | 0;
  i3 = i4;
  i5 = i1;
  L6 : do if ((i2 | 0) < 1) i1 = i3; else while (1) {
   if ((HEAP8[i1 >> 0] | 0) == 10) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i3;
    break L6;
   }
  } while (0);
  i1 = (i1 | 0) == (i4 | 0) ? -1 : i1 - i5 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i7, 0, i1, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, 32, 0) | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i7, i1 + 1 | 0, -1, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i8 >> 2] = 0;
 i9 = (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 HEAP32[i10 >> 2] = i8;
 i10 = (_sscanf(i9, gb + 1084492 | 0, i10) | 0) != 0;
 if (i10 & (HEAP32[i8 >> 2] | 0) > 399) {
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, i7 | 0);
  i10 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i10 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i11;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i7, i2, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = (i9 - i2 | 0) / 156 | 0;
 i8 = i7 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5;
 if (i6 >>> 0 <= ((i1 - i5 | 0) / 156 | 0) >>> 0) {
  i7 = i7 + 4 | 0;
  i1 = ((HEAP32[i7 >> 2] | 0) - i5 | 0) / 156 | 0;
  i5 = i6 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 156 | 0) | 0;
  i4 = i5 ? i1 : i9;
  if ((i4 | 0) != (i2 | 0)) do {
   __ZN14SubstanceInputaSERKS_(i3, i2) | 0;
   i2 = i2 + 156 | 0;
   i3 = i3 + 156 | 0;
  } while ((i2 | 0) != (i4 | 0));
  if (!i5) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) return;
   do {
    i9 = i1 + -156 | 0;
    HEAP32[i7 >> 2] = i9;
    __ZN14SubstanceInputD2Ev(i9);
    i1 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   return;
  }
  if ((i4 | 0) == (i9 | 0)) return;
  i2 = HEAP32[i7 >> 2] | 0;
  do {
   __ZN14SubstanceInputC2ERKS_(i2, i1);
   i1 = i1 + 156 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + 156 | 0;
   HEAP32[i7 >> 2] = i2;
  } while ((i1 | 0) != (i9 | 0));
  return;
 }
 if (i5) {
  i4 = i7 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) i1 = i5; else {
   do {
    i5 = i1 + -156 | 0;
    HEAP32[i4 >> 2] = i5;
    __ZN14SubstanceInputD2Ev(i5);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i7 >> 2] | 0;
  }
  __ZdlPv(i1);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 }
 if (i6 >>> 0 > 27531841) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else i3 = 0;
 i5 = (i1 - i3 | 0) / 156 | 0;
 i3 = i5 << 1;
 i3 = i5 >>> 0 < 13765920 ? (i3 >>> 0 < i6 >>> 0 ? i6 : i3) : 27531841;
 if (i3 >>> 0 > 27531841) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
 i1 = __Znwj(i3 * 156 | 0) | 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = i1 + (i3 * 156 | 0);
 if ((i2 | 0) == (i9 | 0)) return;
 do {
  __ZN14SubstanceInputC2ERKS_(i1, i2);
  i2 = i2 + 156 | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + 156 | 0;
  HEAP32[i4 >> 2] = i1;
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN20ArchiveStorageReaderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 70808 + 8;
 __ZN20ArchiveStorageHeader6HeaderC2Ev(i1 + 8 | 0);
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i7 = i5;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1 + 140 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = i5;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 160 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP8[i1 + 184 >> 0] = 0;
 __ZN15FileSystemEntryC2Ev(i1 + 188 | 0);
 __ZN12FileAccessorC2Ev(i1 + 1248 | 0);
 i7 = i1 + 2320 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i7 = i1 + 2344 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i1 + 2356 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP8[i1 + 2360 >> 0] = 0;
 i7 = gb + 63552 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 2364 >> 2] = 0;
 HEAP32[i1 + 2376 >> 2] = 0;
 HEAP32[i1 + 2380 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 2368 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i1 = i1 + 2388 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN7mecanim5human7AddAxisEPKNS0_5HumanEiRKN4math7_float4E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i2 = i2 + 40 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i16 = i2 + 16 | 0;
 i2 = i2 + 4 | 0;
 i2 = HEAP32[i2 + (HEAP32[i2 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
 i3 = i16 + (HEAP32[i16 >> 2] | 0) | 0;
 f13 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + (i2 * 76 | 0) + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f7 = Math_fround(f13 * f8);
 f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f5 = Math_fround(f9 * f6);
 f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f10 = Math_fround(f11 * f12);
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(Math_fround(Math_fround(f7 - Math_fround(f15 * f6)) - Math_fround(f9 * f12)) - Math_fround(f11 * f14));
 f5 = Math_fround(Math_fround(Math_fround(f5 - Math_fround(f13 * f14)) - Math_fround(f15 * f12)) - Math_fround(f11 * f8));
 f10 = Math_fround(Math_fround(Math_fround(f10 - Math_fround(f15 * f8)) - Math_fround(f13 * f6)) - Math_fround(f9 * f14));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)) - Math_fround(f11 * f6)) - Math_fround(f9 * f8));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ -2147483648;
 f8 = (HEAP32[tempDoublePtr >> 2] = i2 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f8 * f8);
 f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(f7 * f7);
 f6 = (HEAP32[tempDoublePtr >> 2] = i4 ^ -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f10 + f9)))));
 f7 = Math_fround(f9 * f7);
 f6 = Math_fround(f9 * f6);
 f5 = Math_fround(f9 * f5);
 HEAPF32[i1 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f6;
 HEAPF32[i1 + 12 >> 2] = f5;
 return;
}

function __ZN7mecanim9animation22CreateControllerMemoryEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, 28, 4) | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 i4 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = i3;
 i9 = i10 + 4 | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i7 = i9;
 HEAP32[i9 >> 2] = i1 | 0 ? i1 - i7 | 0 : 0;
 i5 = i10 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i2 = i5;
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i2 | 0 : 0;
 i1 = i10 + 16 | 0;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE((i3 | 0) == 0 ? 0 : i3 + i4 | 0, i8) | 0;
 i3 = i1;
 i4 = i4 | 0 ? i4 - i3 | 0 : 0;
 HEAP32[i1 >> 2] = i4;
 i1 = i6 + 20 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_((i11 | 0) == 0 ? 0 : i11 + i1 | 0, (i4 | 0) == 0 ? 0 : i4 + i3 | 0);
 i3 = HEAP32[i6 >> 2] | 0;
 if (i3 | 0) {
  i4 = i6 + 4 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + i2 | 0;
  i1 = 0;
  do {
   i11 = i4 + (i1 << 2) | 0;
   HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i11 + (HEAP32[i11 >> 2] | 0) + 32 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 if (!(HEAP32[i10 >> 2] | 0)) return i10 | 0;
 i2 = i6 + 12 | 0;
 i3 = i2;
 i1 = 0;
 do {
  i11 = (HEAP32[i9 >> 2] | 0) + i7 + (i1 << 2) | 0;
  i5 = (HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i6 = __ZN7mecanim12statemachine24CreateStateMachineMemoryEPKNS0_20StateMachineConstantERNS_6memory9AllocatorE((i6 | 0) == 0 ? 0 : i5 + i6 | 0, i8) | 0;
  HEAP32[i11 >> 2] = i6 | 0 ? i6 - i11 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 return i10 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 614;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13set_empty_keyERKSC_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 HEAP8[i2 + 9 >> 0] = 1;
 i13 = i2 + 32 | 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i2, i13, i1);
 i7 = HEAP32[i2 + 56 >> 2] | 0;
 i1 = __Znwj(i7 * 20 | 0) | 0;
 HEAP32[i2 + 52 >> 2] = i1;
 i7 = i1 + (i7 * 20 | 0) | 0;
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i15;
  return;
 }
 i8 = i2 + 44 | 0;
 i9 = i13 + 11 | 0;
 i10 = i2 + 36 | 0;
 i11 = i12 + 4 | 0;
 i6 = i2 + 48 | 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = i2;
  if ((HEAP8[i9 >> 0] | 0) < 0) {
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i2 = HEAP32[i3 >> 2] | 0;
    i14 = 8;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i1 + 11 >> 0] = i5;
    if (!i5) i2 = i1; else {
     i2 = i1;
     i14 = 10;
    }
   } else i14 = 8;
   if ((i14 | 0) == 8) {
    i3 = i5 + 16 & -16;
    HEAP32[i12 >> 2] = 54;
    HEAP32[i11 >> 2] = i2;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i5;
    i14 = 10;
   }
   if ((i14 | 0) == 10) {
    i14 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  }
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i15;
 return;
}

function _cf2_doFlex(i10, i11, i12, i13, i9, i8) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i2 = HEAP32[i11 >> 2] | 0;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 >> 2];
 i6 = (HEAP8[i9 + 9 >> 0] | 0) == 0;
 i7 = i6 ? 9 : 10;
 i4 = 0;
 i3 = 0;
 while (1) {
  i1 = i14 + (i4 + 2 << 2) | 0;
  HEAP32[i1 >> 2] = i2;
  if (!(HEAP8[i9 + i4 >> 0] | 0)) i5 = i3; else {
   HEAP32[i1 >> 2] = i2 + (_cf2_stack_getReal(i10, i3) | 0);
   i5 = i3 + 1 | 0;
  }
  i1 = i4 + 1 | 0;
  if ((i1 | 0) >= (i7 | 0)) break;
  i4 = i1;
  i3 = i5;
  i2 = HEAP32[i14 + (i1 << 2) >> 2] | 0;
 }
 if (i6) HEAP32[i14 + 44 >> 2] = HEAP32[i12 >> 2];
 do if (!(i8 << 24 >> 24)) {
  if (!(HEAP8[i9 + 10 >> 0] | 0)) {
   i2 = i5;
   i1 = HEAP32[i11 >> 2] | 0;
  } else {
   i1 = HEAP32[i14 + 40 >> 2] | 0;
   i2 = i5 + 1 | 0;
   i1 = (_cf2_stack_getReal(i10, i5) | 0) + i1 | 0;
  }
  HEAP32[i14 + 48 >> 2] = i1;
  if (!(HEAP8[i9 + 11 >> 0] | 0)) {
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 + 52 >> 2] = i2;
   i3 = HEAP32[i14 + 44 >> 2] | 0;
   break;
  } else {
   i3 = HEAP32[i14 + 44 >> 2] | 0;
   i2 = (_cf2_stack_getReal(i10, i2) | 0) + i3 | 0;
   HEAP32[i14 + 52 >> 2] = i2;
   break;
  }
 } else {
  i2 = HEAP32[i14 + 40 >> 2] | 0;
  i8 = i2 - (HEAP32[i11 >> 2] | 0) | 0;
  i3 = HEAP32[i14 + 44 >> 2] | 0;
  i9 = i3 - (HEAP32[i12 >> 2] | 0) | 0;
  i1 = _cf2_stack_getReal(i10, i5) | 0;
  if ((((i8 | 0) < 0 ? 0 - i8 | 0 : i8) | 0) > (((i9 | 0) < 0 ? 0 - i9 | 0 : i9) | 0)) {
   i1 = i2 + i1 | 0;
   HEAP32[i14 + 48 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i14 + 52 >> 2] = i2;
   break;
  } else {
   i9 = HEAP32[i11 >> 2] | 0;
   HEAP32[i14 + 48 >> 2] = i9;
   i2 = i3 + i1 | 0;
   HEAP32[i14 + 52 >> 2] = i2;
   i1 = i9;
   break;
  }
 } while (0);
 _cf2_glyphpath_curveTo(i13, HEAP32[i14 + 8 >> 2] | 0, HEAP32[i14 + 12 >> 2] | 0, HEAP32[i14 + 16 >> 2] | 0, HEAP32[i14 + 20 >> 2] | 0, HEAP32[i14 + 24 >> 2] | 0, HEAP32[i14 + 28 >> 2] | 0);
 _cf2_glyphpath_curveTo(i13, HEAP32[i14 + 32 >> 2] | 0, HEAP32[i14 + 36 >> 2] | 0, HEAP32[i14 + 40 >> 2] | 0, i3, i1, i2);
 _cf2_stack_clear(i10);
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 670846 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN19RuntimeSceneManager31CollectDontDestroyOnLoadObjectsERNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i9 = i6 + 4 | 0;
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i6, HEAP32[i9 >> 2] | 0);
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 i9 = i1 + 68 | 0;
 i5 = i1 + 80 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 L4 : while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if (i3) {
    HEAP32[i8 >> 2] = i3;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i10 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i2 = HEAP32[i7 >> 2] | 0;
      i12 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 10; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (i1 | 0) break;
     }
    }
    if ((i10 | 0) == 10) i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    if (i1 | 0) break;
    i1 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
   }
   i3 = HEAP32[i2 + (i1 + -1 << 2) >> 2] | 0;
   HEAP32[i4 >> 2] = i3;
   i1 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((i4 | 0) == (i2 + (i1 << 2) | 0)) {
    i10 = 16;
    break L4;
   }
  }
  __Z12CollectPPtrsRK6ObjectRNSt3__23setIiNS2_4lessIiEENS2_9allocatorIiEEEE(i1, i6);
  i4 = i4 + 4 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i2 + (i1 << 2) | 0)) {
   i10 = 16;
   break;
  }
 }
 if ((i10 | 0) == 16) {
  STACKTOP = i11;
  return;
 }
}

function __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i3 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = HEAP32[i11 >> 2] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 14854;
 i9 = i14;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = 0;
 if ((i11 | 0) >= 0) HEAP32[i3 >> 2] = 15878;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = (HEAP32[i10 + 36 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + -1 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1085989 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1085998 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 8 | 0;
 i11 = i15;
 i12 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
 i13 = (i12 | 0) == 0;
 if (!i13) __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
 if (i8 | 0) {
  i5 = 0;
  do {
   i4 = i7 + (i5 * 12 | 0) + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if ((HEAP16[gb + 1165848 + 6 >> 1] | 0) > -1) {
    __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165848 | 0, i1);
    i6 = gb + 1165848 | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   } else i6 = 0;
   do if (i1 | 0) {
    HEAP32[i11 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i14 = 16; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
      i2 = HEAP32[i10 >> 2] | 0;
      i16 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i14 = 16; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i14 = 18;
     }
    }
    if ((i14 | 0) == 16) i14 = 18;
    if ((i14 | 0) == 18) {
     i14 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i9 | 0);
   } while (0);
   if (i6 | 0) __Z12profiler_endP19ProfilerInformation(i6);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 if (i13) {
  STACKTOP = i15;
  return;
 }
 __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i12);
 STACKTOP = i15;
 return;
}

function __Z38AlignedCylinderOverlapsOrientedCapsulePfPKfS1_S1_S1_fff(i17, i2, i3, i4, i6, f15, f1, f5) {
 i17 = i17 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 f15 = Math_fround(f15);
 f1 = Math_fround(f1);
 f5 = Math_fround(f5);
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i16 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 16 | 0;
 i14 = i18;
 HEAPF32[i17 >> 2] = Math_fround(0.0);
 i2 = __Z23CalculateClippedCapsulePfS_PKfS1_S1_ff(i14, i16, i2, i3, i4, f1, f5) | 0;
 if (!i2) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 switch (i2 | 0) {
 case 1:
  {
   f13 = Math_fround(f13 - f11);
   f1 = Math_fround(f10 - f12);
   f1 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(f1 * f1)))) - Math_fround(HEAPF32[i16 >> 2])) - f15);
   if (f1 > Math_fround(0.0)) {
    i17 = 0;
    STACKTOP = i18;
    return i17 | 0;
   }
   HEAPF32[i17 >> 2] = Math_fround(-f1);
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i14 + 12 >> 2]);
   f8 = Math_fround(f13 - f11);
   f9 = Math_fround(f10 - f12);
   f5 = Math_fround(Math_fround(HEAPF32[i14 + 8 >> 2]) - f11);
   f1 = Math_fround(f1 - f12);
   f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f5 * f5))));
   if (f7 > Math_fround(HEAPF32[gb + 62456 >> 2])) {
    f5 = Math_fround(f5 / f7);
    f1 = Math_fround(f1 / f7);
   }
   f9 = Math_fround(Math_fround(f8 * f5) + Math_fround(f9 * f1));
   i14 = f9 < Math_fround(0.0);
   f9 = i14 ? Math_fround(0.0) : f9 > f7 ? f7 : f9;
   f13 = Math_fround(Math_fround(f11 + Math_fround(f5 * f9)) - f13);
   f1 = Math_fround(Math_fround(f12 + Math_fround(f1 * f9)) - f10);
   f1 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(f1 * f1)))) - Math_fround(HEAPF32[i16 >> 2])) - f15);
   if (f1 > Math_fround(0.0)) {
    i17 = 0;
    STACKTOP = i18;
    return i17 | 0;
   }
   HEAPF32[i17 >> 2] = Math_fround(-f1);
   i17 = 1;
   STACKTOP = i18;
   return i17 | 0;
  }
 default:
  {
   i17 = 0;
   STACKTOP = i18;
   return i17 | 0;
  }
 }
 return 0;
}

function __Z22Light_CUSTOM_GetLights9LightTypei(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 16 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i5 = 1 << i1;
 i6 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  i4 = i9 + 8 | 0;
  do {
   i3 = i1 + -36 | 0;
   HEAP32[i8 >> 2] = i3;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   do if ((HEAP32[i1 + 40 >> 2] | 0) == (i7 | 0)) if (HEAP32[i1 + 36 >> 2] & i5 | 0) {
    i1 = HEAP32[i10 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
     __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i8);
     break;
    } else {
     HEAP32[i1 >> 2] = i3;
     HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
     break;
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i6 | 0));
 }
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(108) | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE(i1) | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, (HEAP32[i10 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) >> 2) | 0;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i10 >> 2] | 0));
 }
 if ((i1 | 0) < (i3 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i4 | 0;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return i4 | 0;
}

function __ZNK5Unity17ConfigurableJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 24 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11;
 i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i16 = HEAP32[i1 + 64 >> 2] | 0;
 HEAP32[i7 >> 2] = i16;
 i3 = i7 + 4 | 0;
 i15 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i3 >> 2] = i15;
 i4 = i7 + 8 | 0;
 i14 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i4 >> 2] = i14;
 f12 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f12 * f12);
 f13 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f12 + Math_fround(f13 * f13));
 f12 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f13 + Math_fround(f12 * f12));
 if (f12 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
 }
 HEAP32[i8 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 356 >> 2];
 __Z14OrthoNormalizeP8Vector3fS0_(i7, i8);
 __ZNK9Transform14TransformPointERK8Vector3f(i9, i10, i1 + 40 | 0);
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 if (!(HEAP8[i1 + 292 >> 0] | 0)) {
  __ZNK9Transform18TransformDirectionERK8Vector3f(i9, i10, i7);
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  __ZNK9Transform18TransformDirectionERK8Vector3f(i9, i10, i8);
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  STACKTOP = i11;
  return;
 }
}

function __ZN9Rigidbody5ResetEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i3 + 68 | 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 if (!i1) {
  HEAPF32[i3 + 76 >> 2] = Math_fround(.0500000007);
  HEAPF32[i3 + 72 >> 2] = Math_fround(0.0);
  HEAP32[i3 + 88 >> 2] = 0;
  HEAP8[i3 + 84 >> 0] = 0;
  HEAP8[i3 + 83 >> 0] = 1;
  HEAP32[i3 + 92 >> 2] = 0;
  HEAP32[i3 + 96 >> 2] = 0;
  HEAP8[i3 + 100 >> 0] = 1;
  HEAP8[i3 + 101 >> 0] = 1;
  i4 = i3 + 102 | 0;
  HEAP8[i4 >> 0] = 0;
  return;
 }
 if (!(HEAP8[i3 + 81 >> 0] | 0)) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0, 1.0); else __ZN9Rigidbody22UpdateMassDistributionEv(i3);
 i1 = i3 + 56 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i5 = __Z12GetIVehiclesv() | 0;
  mftCall_viif(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i2 >> 2]));
 }
 HEAPF32[i3 + 76 >> 2] = Math_fround(.0500000007);
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i1 | 0, .0500000007);
 HEAPF32[i3 + 72 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0, 0.0);
 i1 = i3 + 88 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) if ((HEAP16[i2 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 256 >> 2] | 0, i2 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
  __ZN9Rigidbody22UpdateMassDistributionEv(i3);
 }
 __ZN9Rigidbody14SetIsKinematicEb(i3, 0);
 i1 = i3 + 83 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) if ((HEAP16[i2 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 256 >> 2] | 0, i2 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
 }
 i5 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, 2, 0);
 HEAP8[i1 >> 0] = 1;
 __ZN9Rigidbody25SetCollisionDetectionModeEi(i3, 0);
 i5 = i3 + 102 | 0;
 HEAP8[i5 >> 0] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_15PxMetaDataEntryENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 746754 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 615;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sn18writeAllPropertiesINS_13PxBoxGeometryEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i13, i7, i14, i11, i1) {
 i13 = i13 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15;
 i10 = i15 + 36 | 0;
 i8 = i15 + 24 | 0;
 i6 = i15 + 8 | 0;
 __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i6);
 i5 = HEAP32[i6 + 8 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 8 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = i1 + -1 | 0;
  i3 = i13 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!(HEAP8[i4 + (i2 << 3) + 4 >> 0] | 0)) {
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, HEAP32[i4 + (i2 << 3) >> 2] | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i3 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] = 1;
  }
 }
 HEAP32[i9 >> 2] = i6;
 HEAP8[i9 + 4 >> 0] = 0;
 if ((HEAP32[i13 + 12 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i3 = i9;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = (HEAP32[i13 + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i13, i9) | 0;
 mftCall_vii(i5 | 0, i10 | 0, i7 | 0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i13 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i11, i8) | 0;
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, i1 | 0, HEAP32[i11 + 20 >> 2] | 0);
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(HEAP32[i13 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i1 + -1;
 STACKTOP = i15;
 return;
}

function __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i7, i1, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i5 = i7 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
  i4 = i3;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = i7 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 28 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i9 = i7 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i8);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i9 = i7 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i9, i8);
  STACKTOP = i10;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i13 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i11 = i13 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i8 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i5 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i6 = i13 + 4 | 0;
 i7 = i9 + 4 | 0;
 i8 = i9 + 8 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i6 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  i4 = i2 + i3 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
   i2 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i3;
  }
  HEAP32[i4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = i4 + 8;
  HEAP32[i7 >> 2] = i4 + 4;
  HEAP32[i8 >> 2] = i3;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i13, i9, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i12;
 return;
}

function __Z19UnityObjectToStringP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i8 = i10;
 i4 = i10 + 56 | 0;
 i5 = i10 + 44 | 0;
 i6 = i10 + 32 | 0;
 i7 = i10 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 448034 | 0, 4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i10;
  return;
 }
 i3 = (HEAP32[i2 + 8 >> 2] | 0) >>> 21;
 if ((HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + (i3 << 2) >> 2] | 0) + 16 >> 2] | 0) == 114) {
  __ZN13MonoBehaviour22GetScriptFullClassNameEv(i7, (i3 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0 ? i2 : 0);
  i8 = i7 + 11 | 0;
  i3 = HEAP8[i8 >> 0] | 0;
  i12 = i3 << 24 >> 24 < 0;
  i11 = i12 ? HEAP32[i7 >> 2] | 0 : i7;
  i3 = i12 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i11, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  if ((HEAP8[i8 >> 0] | 0) < 0) {
   i12 = HEAP32[i7 >> 2] | 0;
   i11 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i4 >> 2] = 66;
   HEAP32[i4 + 4 >> 2] = i11;
   __Z19free_alloc_internalPvRK10MemLabelId(i12, i4);
  }
 } else {
  HEAP32[i8 >> 2] = __ZNK6Object12GetClassNameEv(i2) | 0;
  __Z6FormatPKcz(i4, gb + 448039 | 0, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 i11 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 i12 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i9 + 4 >> 2] = i12;
 __Z6FormatPKcz(i1, gb + 448054 | 0, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i10;
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE9DoRequestEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = i11 + 72 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i3 = i11 + 56 | 0;
 i4 = i11 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) i10 = 1; else if (__ZNK12StatusHelper10IsRedirectEv(i1 + -32 | 0) | 0) i10 = (HEAP32[i1 + -28 >> 2] | 0) == 307; else i10 = 1;
 i9 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = i9;
 if ((i9 - i2 | 0) == -32) {
  if ((i1 | 0) != (i2 | 0)) {
   do {
    HEAP32[i4 >> 2] = i1 + -32;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
    __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1 + -24 | 0, HEAP32[i1 + -20 >> 2] | 0);
    i1 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = i2;
  }
 } else {
  __ZNSt3__26vectorI14ResponseHelperNS_9allocatorIS1_EEE8__appendEj(i3, 1);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i1 = i1 + -32 | 0;
 HEAP32[i11 + 108 >> 2] = 2;
 i2 = i11 + 8 | 0;
 i3 = i11 + 76 | 0;
 i4 = HEAP32[i11 + 116 >> 2] | 0;
 i5 = HEAP32[i11 + 88 >> 2] | 0;
 i6 = i11 + 92 | 0;
 i8 = HEAP16[i11 + 120 >> 1] | 0;
 i7 = (i8 & 255) << 24 >> 24 != 0;
 i8 = (i8 & 65535) > 255;
 i9 = i11 + 44 | 0;
 if (!i10) {
  i10 = 0;
  i12 = i11 + 68 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  i12 = __ZN19TransportJavaScript9DoRequestERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEm21UnityWebRequestMethodS8_bbP12HeaderHelperP13UploadHandlerP15DownloadHandlerP14ResponseHelperP15UnityWebRequest(i2, i3, i4, i5, i6, i7, i8, i9, i10, i12, i1, i11) | 0;
  return i12 | 0;
 }
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = i11 + 68 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = __ZN19TransportJavaScript9DoRequestERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEm21UnityWebRequestMethodS8_bbP12HeaderHelperP13UploadHandlerP15DownloadHandlerP14ResponseHelperP15UnityWebRequest(i2, i3, i4, i5, i6, i7, i8, i9, i10, i12, i1, i11) | 0;
 return i12 | 0;
}

function __ZN9Rigidbody8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 68 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 83 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + 102 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i7 = i8;
 __ZN5Unity10HingeJoint14WriteUseLimitsEv(i3);
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = i1 >>> 24 & 255; else {
  __ZN5Unity10HingeJoint16WriteJointLimitsEv(i3);
  i1 = HEAP8[i3 + 159 >> 0] | 0;
 }
 if (i1 << 24 >> 24) __ZN5Unity10HingeJoint16WriteJointSpringEv(i3);
 i2 = i3 + 32 | 0;
 if (HEAP8[i3 + 157 >> 0] | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, 2, 1);
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i6 | 0, i7 | 0);
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP16[i1 + 4 >> 1] | 0) != 261) {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, +Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(HEAPF32[i3 + 128 >> 2])) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i3 + 132 >> 2]));
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, 4, (HEAP32[i3 + 136 >> 2] | 0) != 0 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i6 | 0, i7 | 0);
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, 0, i4 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0, 1, i5 | 0);
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i6 | 0, i7 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return;
}

function __ZN12AdsIdHandler17RequestAdsIdAsyncEP12Il2CppObject(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = __Z22scripting_gchandle_newP12Il2CppObject(i1) | 0;
 i5 = i7 + 48 | 0;
 i6 = i7 + 60 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = 5;
 HEAP32[i8 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i5;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i5 >> 2] = i4;
 i4 = i7 + 56 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i1 = i7 + 40 | 0;
 do if (HEAP8[i1 >> 0] | 0) {
  f10 = Math_fround(+__Z19GetTimeSinceStartupv());
  if (Math_fround(f10 - Math_fround(HEAPF32[i7 + 36 >> 2])) > Math_fround(120.0)) {
   HEAP8[i1 >> 0] = 0;
   break;
  }
  if (HEAP8[i1 >> 0] | 0) {
   i3 = i7 + 52 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) != (i5 | 0)) do {
    i11 = i1 + 8 | 0;
    __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj(i7, HEAP32[i11 >> 2] | 0);
    __Z23scripting_gchandle_freej(HEAP32[i11 >> 2] | 0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
   } while ((i2 | 0) != (i5 | 0));
   if (!(HEAP32[i4 >> 2] | 0)) {
    i11 = i7 + 44 | 0;
    i11 = HEAP32[i11 >> 2] | 0;
    i11 = (i11 | 0) != 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i1 = HEAP32[i3 >> 2] | 0;
   i11 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[HEAP32[i11 >> 2] >> 2] = i3;
   HEAP32[i4 >> 2] = 0;
   if ((i1 | 0) == (i5 | 0)) {
    i11 = i7 + 44 | 0;
    i11 = HEAP32[i11 >> 2] | 0;
    i11 = (i11 | 0) != 1;
    STACKTOP = i9;
    return i11 | 0;
   }
   i2 = i8 + 4 | 0;
   do {
    i11 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = HEAP32[i6 >> 2] | 0;
    HEAP32[i8 >> 2] = 5;
    HEAP32[i2 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
   } while ((i1 | 0) != (i5 | 0));
   i11 = i7 + 44 | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   i11 = (i11 | 0) != 1;
   STACKTOP = i9;
   return i11 | 0;
  }
 } while (0);
 HEAP32[i7 + 44 >> 2] = 1;
 i11 = i7 + 44 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i11 = (i11 | 0) != 1;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN10Matrix4x4f16AdjustDepthRangeEfff(i2, f3, f4, f5) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i1 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 28 | 0;
 if (!(Math_fround(HEAPF32[i6 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i2 + 44 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i2 + 60 >> 2]) != Math_fround(1.0))) {
  f3 = Math_fround(f5 - f4);
  HEAPF32[i2 + 40 >> 2] = Math_fround(Math_fround(-2.0) / f3);
  HEAPF32[i2 + 56 >> 2] = Math_fround(Math_fround(-Math_fround(f4 + f5)) / f3);
  return i2 | 0;
 }
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 i10 = i2 + 20 | 0;
 f11 = Math_fround(HEAPF32[i10 >> 2]);
 i12 = i2 + 32 | 0;
 f13 = Math_fround(HEAPF32[i12 >> 2]);
 i7 = i2 + 36 | 0;
 f8 = Math_fround(f3 * Math_fround(2.0));
 f15 = Math_fround(f8 / f15);
 f13 = Math_fround(f13 + Math_fround(1.0));
 f11 = Math_fround(f8 / f11);
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + Math_fround(1.0));
 f3 = Math_fround(f4 / f3);
 f14 = Math_fround(f3 * Math_fround(f15 * Math_fround(f13 * Math_fround(.5))));
 f9 = Math_fround(f3 * Math_fround(f11 * Math_fround(f8 * Math_fround(.5))));
 f13 = Math_fround(f3 * Math_fround(+f15 * (+f13 * .5 + -1.0)));
 f8 = Math_fround(f3 * Math_fround(+f11 * (+f8 * .5 + -1.0)));
 f11 = Math_fround(f4 * Math_fround(2.0));
 f3 = Math_fround(f14 - f13);
 HEAPF32[i2 >> 2] = Math_fround(f11 / f3);
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(f14 + f13) / f3);
 HEAPF32[i2 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 f3 = Math_fround(f9 - f8);
 HEAPF32[i10 >> 2] = Math_fround(f11 / f3);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f9 + f8) / f3);
 HEAPF32[i2 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
 f3 = Math_fround(f5 - f4);
 HEAPF32[i2 + 40 >> 2] = Math_fround(Math_fround(-Math_fround(f4 + f5)) / f3);
 HEAPF32[i2 + 56 >> 2] = Math_fround(Math_fround(-Math_fround(Math_fround(f5 * Math_fround(2.0)) * f4)) / f3);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 44 >> 2] = Math_fround(-1.0);
 HEAPF32[i2 + 60 >> 2] = Math_fround(0.0);
 return i2 | 0;
}

function __ZL16CalculateBoxHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff(i2, i3, i6, f12, f19) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 f12 = Math_fround(f12);
 f19 = Math_fround(f19);
 var i1 = 0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, i24 = 0, f25 = f0, i26 = 0, f27 = f0, f28 = f0, f29 = f0, f30 = f0, f31 = f0, f32 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i26;
 f25 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f25 = Math_fround(f25 - Math_fround(HEAPF32[i6 >> 2]));
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i6 + 8 >> 2]));
 i1 = i3 + 16 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(-f7);
 f9 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(-f13);
 f15 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f20 = Math_fround(-f18);
 f21 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f22 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 f23 = Math_fround(HEAPF32[i3 + 60 >> 2]);
 i1 = 0;
 do {
  f27 = i1 & 1 | 0 ? f7 : f8;
  f31 = Math_fround(Math_fround(f9 * f27) + f25);
  f29 = Math_fround(Math_fround(f27 * f10) + f4);
  f27 = Math_fround(Math_fround(f27 * f11) + f5);
  f32 = i1 & 2 | 0 ? f13 : f14;
  f31 = Math_fround(Math_fround(f15 * f32) + f31);
  f29 = Math_fround(Math_fround(f32 * f16) + f29);
  f27 = Math_fround(Math_fround(f32 * f17) + f27);
  f32 = i1 & 4 | 0 ? f18 : f20;
  f30 = Math_fround(f32 * f22);
  f28 = Math_fround(f32 * f23);
  HEAPF32[i24 + (i1 * 12 | 0) >> 2] = Math_fround(Math_fround(f21 * f32) + f31);
  HEAPF32[i24 + (i1 * 12 | 0) + 4 >> 2] = Math_fround(f30 + f29);
  HEAPF32[i24 + (i1 * 12 | 0) + 8 >> 2] = Math_fround(f28 + f27);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i24 = __ZL28CalculateCarveHullFromPointsR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fffPS7_i(i2, i3, i6, f12, f19, i24, 8) | 0;
 STACKTOP = i26;
 return i24 | 0;
}

function __ZN8Animator17GetTargetRotationEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP8[i3 + 153 >> 0] | 0) {
  i1 = (HEAP32[(HEAP32[i3 + 128 >> 2] | 0) + 4 >> 2] | 0) + -2 | 0;
  if (i1 >>> 0 < 4) {
   __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE(i4, i1);
   f13 = Math_fround(HEAPF32[i4 >> 2]);
   f14 = Math_fround(f13 * f13);
   f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f15 = Math_fround(f9 * f9);
   f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
   f16 = Math_fround(f6 * f6);
   f11 = Math_fround(HEAPF32[i4 + 12 >> 2]);
   f16 = Math_fround(Math_fround(f14 + f15) + Math_fround(f16 + Math_fround(f11 * f11)));
   f15 = Math_fround(Math_sqrt(Math_fround(f16)));
   f13 = Math_fround(f13 / f15);
   f9 = Math_fround(f9 / f15);
   f6 = Math_fround(f6 / f15);
   f15 = Math_fround(f11 / f15);
   i4 = f16 > Math_fround(1.0e-30);
   f16 = Math_fround(HEAPF32[i3 + 360 >> 2]);
   f13 = i4 ? f13 : Math_fround(0.0);
   f11 = Math_fround(f16 * f13);
   f14 = Math_fround(HEAPF32[i3 + 348 >> 2]);
   f15 = i4 ? f15 : Math_fround(1.0);
   f11 = Math_fround(f11 + Math_fround(f14 * f15));
   f12 = Math_fround(HEAPF32[i3 + 352 >> 2]);
   f6 = i4 ? f6 : Math_fround(0.0);
   f11 = Math_fround(Math_fround(f12 * f6) + f11);
   f10 = Math_fround(HEAPF32[i3 + 356 >> 2]);
   f9 = i4 ? f9 : Math_fround(0.0);
   f8 = Math_fround(Math_fround(Math_fround(f13 * f10) + Math_fround(Math_fround(f12 * f15) + Math_fround(f16 * f9))) - Math_fround(f14 * f6));
   f7 = Math_fround(Math_fround(Math_fround(f14 * f9) + Math_fround(Math_fround(f16 * f6) + Math_fround(f15 * f10))) - Math_fround(f12 * f13));
   f6 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13)) - Math_fround(f12 * f9)) - Math_fround(f6 * f10));
   HEAPF32[i2 >> 2] = Math_fround(f11 - Math_fround(f10 * f9));
   HEAPF32[i2 + 4 >> 2] = f8;
   HEAPF32[i2 + 8 >> 2] = f7;
   HEAPF32[i2 + 12 >> 2] = f6;
   STACKTOP = i5;
   return;
  }
 }
 i4 = i3 + 348 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN7mecanim12statemachine13StateConstant39Transfer_Pre_5_2_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i19 + 16 | 0;
 i4 = i19 + 4 | 0;
 i17 = i19;
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i3, 2) | 0)) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i17 >> 2] = 0;
 i18 = i5 + 8 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i17;
 HEAP32[i4 + 4 >> 2] = i18;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, gb + 903541 | 0, HEAP32[gb + 37316 >> 2] | 0, i2, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim12statemachine16LeafInfoConstantEEEEvRT_17TransferMetaFlags(i3, i4, 0); else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
 }
 i16 = HEAP32[i5 + 16 >> 2] | 0;
 if (i16 | 0) {
  i14 = i5 + 20 | 0;
  i13 = i17;
  i14 = (HEAP32[i14 >> 2] | 0) + i14 | 0;
  i11 = 0;
  do {
   i1 = i14 + (i11 << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i15 = HEAP32[i1 >> 2] | 0;
   if (i15 | 0) {
    i12 = HEAP32[i18 >> 2] | 0;
    i10 = i1 + 4 | 0;
    i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
    i9 = 0;
    i1 = i12;
    do {
     i7 = i10 + (i9 << 2) | 0;
     i7 = i7 + (HEAP32[i7 >> 2] | 0) + 32 | 0;
     i8 = HEAP32[i7 >> 2] | 0;
     if (!i1) i1 = 0; else {
      i3 = (HEAP32[i17 >> 2] | 0) + i13 | 0;
      i1 = 0;
      do {
       i4 = HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0;
       if (i4 | 0) {
        i5 = i3 + (i1 * 12 | 0) + 4 | 0;
        i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
        i6 = i3 + (i1 * 12 | 0) + 8 | 0;
        i2 = 0;
        do {
         if ((i8 | 0) == (HEAP32[i5 + (i2 << 2) >> 2] | 0)) HEAP32[i7 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
         i2 = i2 + 1 | 0;
        } while (i2 >>> 0 < i4 >>> 0);
       }
       i1 = i1 + 1 | 0;
      } while (i1 >>> 0 < i12 >>> 0);
      i1 = i12;
     }
     i9 = i9 + 1 | 0;
    } while (i9 >>> 0 < i15 >>> 0);
   }
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < i16 >>> 0);
 }
 STACKTOP = i19;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 204 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 204 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 5;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 731704 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 5) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 5) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 << 5) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZN5Unity10HingeJoint12SetUseSpringEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 56 | 0;
 i7 = i10 + 28 | 0;
 i8 = i10;
 HEAP8[i5 + 158 >> 0] = i1 & 1;
 i9 = i5 + 157 | 0;
 i2 = i5 + 159 | 0;
 HEAP8[i2 >> 0] = (HEAP8[i9 >> 0] | 0) == 0 & i1 & 1;
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP8[i2 >> 0] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if ((HEAP8[i9 >> 0] | 0) != i3 << 24 >> 24) if ((i2 << 16 >> 16 == 261 | 0) != (i3 & 255 | 0)) {
  if (!i1) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 1065353216;
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 1065353216;
   HEAP32[i8 + 16 >> 2] = 0;
   HEAP32[i8 + 20 >> 2] = 0;
   HEAP32[i8 + 24 >> 2] = 0;
  } else {
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, i1 | 0, 0);
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i7 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
   i9 = HEAP32[i4 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, i9 | 0, 1);
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
  }
  __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv(i5);
  __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_(i5, i7, i8);
  STACKTOP = i10;
  return;
 }
 if (i2 << 16 >> 16 != 261) {
  STACKTOP = i10;
  return;
 }
 __ZN5Unity10HingeJoint16WriteJointSpringEv(i5);
 STACKTOP = i10;
 return;
}

function __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[i7 >> 2] | 0;
 i1 = i9 + 240 | 0;
 i6 = HEAP16[i1 >> 1] | 0;
 if ((i6 & 65535) > 255 | (i6 & 255) << 24 >> 24 != 0) {
  mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 48 >> 2] | 0, i9 | 0);
  HEAP8[i1 >> 0] = 0;
  HEAP8[i9 + 241 >> 0] = 0;
 }
 i6 = HEAP32[i7 + 8 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i4 + (i6 * 360 | 0) | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i4 + (i6 * 360 | 0) + 248 >> 2] = 0;
 HEAP16[i4 + (i6 * 360 | 0) + 270 >> 1] = 0;
 HEAPF32[i4 + (i6 * 360 | 0) + 256 >> 2] = Math_fround(0.0);
 HEAP16[i4 + (i6 * 360 | 0) + 268 >> 1] = -1;
 HEAP16[i4 + (i6 * 360 | 0) + 272 >> 1] = -1;
 HEAP32[i4 + (i6 * 360 | 0) + 348 >> 2] = 0;
 _memcpy(i5 | 0, i9 + 4 | 0, 235) | 0;
 i1 = HEAP32[i4 + (i6 * 360 | 0) + 188 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = HEAP32[i1 + 96 >> 2] | 0;
  i1 = HEAP32[i1 + 92 >> 2] | 0;
 }
 HEAP32[i4 + (i6 * 360 | 0) + 260 >> 2] = i1;
 HEAP32[i4 + (i6 * 360 | 0) + 264 >> 2] = i2;
 HEAP32[i4 + (i6 * 360 | 0) + 236 >> 2] = 0;
 HEAP32[i4 + (i6 * 360 | 0) + 252 >> 2] = i3;
 HEAP32[i4 + (i6 * 360 | 0) + 240 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0;
 i3 = i9 + 236 | 0;
 if (((HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 63) >>> 0 < 9) i1 = HEAP32[i9 + -32 + 4 >> 2] | 0; else i1 = 0;
 HEAP32[i4 + (i6 * 360 | 0) + 352 >> 2] = i1;
 HEAP32[i4 + (i6 * 360 | 0) + 356 >> 2] = i9;
 i3 = __Z19GetLightmapSettingsv() | 0;
 __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings(i8, i3, __Z17GetRenderSettingsv() | 0);
 __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode(i9, i9 + 4 | 0, i8, i5);
 __ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode(i9, HEAP32[i7 + 12 >> 2] | 0, i5) | 0;
 i9 = i4 + (i6 * 360 | 0) + 328 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 STACKTOP = i10;
 return i6 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 68 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 68 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 52 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 52 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation14ConvertArchiveEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i1 = i10;
 i5 = i10 + 36 | 0;
 i6 = i10 + 16 | 0;
 __ZN12FileAccessorC2Ev(i5);
 i8 = i2 + 192 | 0;
 if (!(__ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i5, (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, 0) | 0)) {
  i9 = 0;
  __ZN12FileAccessorD2Ev(i5);
  STACKTOP = i10;
  return i9 | 0;
 }
 i11 = i2 + 208 | 0;
 __ZN12FileAccessor4SeekEx10FileOrigin(i5, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, 1) | 0;
 i11 = __ZNK12FileAccessor4SizeEv(i5) | 0;
 getTempRet0() | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 12 | 0;
 i7 = i6 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i13 = i3;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = i11 >>> 0 < 131072 ? i11 : 131072;
 HEAP32[i4 >> 2] = i1;
 if (!i1) i1 = 0; else {
  HEAP32[i7 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 1, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP8[i2 + 188 >> 0] = 0;
 i13 = (__ZN12FileAccessor4ReadEyPvPy(i5, HEAP32[i4 >> 2] | 0, 0, i1, i3) | 0) ^ 1;
 i12 = i3;
 i1 = HEAP32[i12 >> 2] | 0;
 L7 : do if ((i1 | 0) == 0 & (HEAP32[i12 + 4 >> 2] | 0) == 0 | i13) i9 = 6; else while (1) {
  if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i2, HEAP32[i6 >> 2] | 0, i1) | 0)) {
   i1 = 0;
   break L7;
  }
  i13 = (__ZN12FileAccessor4ReadEyPvPy(i5, HEAP32[i4 >> 2] | 0, 0, HEAP32[i6 >> 2] | 0, i3) | 0) ^ 1;
  i12 = i3;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == 0 & (HEAP32[i12 + 4 >> 2] | 0) == 0 | i13) {
   i9 = 6;
   break;
  }
 } while (0);
 if ((i9 | 0) == 6) i1 = __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(i2) | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i8);
  HEAP32[i6 >> 2] = 0;
 }
 i13 = i1;
 __ZN12FileAccessorD2Ev(i5);
 STACKTOP = i10;
 return i13 | 0;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefIhEE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i12 = i14;
 i5 = i9 + 4 | 0;
 HEAP32[i11 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i12 | 0, i11 | 0) | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = i3;
 i10 = i1 - i2 | 0;
 i4 = i10 + i11 | 0;
 if (!i4) i6 = i3; else {
  i6 = i5 + 20 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i2 | 0) >>> 0 > i4 >>> 0) i6 = i3; else {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = i5 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i4 | 0, i2 | 0, i10 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i4;
   i7 = i4 + i10 | 0;
   HEAP32[i8 >> 2] = i7;
   HEAP32[i6 >> 2] = i4 + i1;
   i1 = i7;
   i6 = i4;
  }
 }
 HEAP32[i8 >> 2] = i1 + i11;
 i4 = i6 + i10 | 0;
 if (!i11) {
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i4;
  i12 = i12 + i10 | 0;
  i12 = i6 + i12 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 16 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i2 = i9 + 8 | 0;
  i3 = i2;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i9 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i9 + 12 >> 2] | 0) - i2 | 0;
 }
 i1 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 if (i11 >>> 0 > i1 >>> 0) _memset(i6 + (i1 + i10) | 0, 0, i11 - i1 | 0) | 0;
 HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) == 0 ? 0 : (i11 | 0) == (i1 | 0) & 1;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i4;
 i12 = i12 + i10 | 0;
 i12 = i6 + i12 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZL29CalculateSphericalShadowRangeRK6CameraR8Vector3fRf(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 64 | 0;
 i6 = i7;
 i8 = __Z18GetQualitySettingsv() | 0;
 if (!(HEAP32[(HEAP32[i8 + 28 >> 2] | 0) + ((HEAP32[i8 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 __ZNK6Camera11GetPositionEv(i2, i3);
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i5 >> 2] = Math_fround(__ZNK6Camera23CalculateShadowDistanceEv(i3));
 i8 = (HEAP8[i3 + 1088 >> 0] | 0) == 0;
 f1 = Math_fround(__ZNK6Camera6GetFovEv(i3));
 if (i8) {
  f1 = Math_fround(Math_fround(1.0) - Math_fround(f1 / Math_fround(180.0)));
  i8 = f1 < Math_fround(0.0);
  i2 = f1 > Math_fround(1.0);
  f1 = Math_fround((i2 ? Math_fround(1.0) : f1) * Math_fround(.400000006));
  f1 = i8 ? Math_fround(0.0) : f1;
 } else f1 = Math_fround(.400000006);
 f9 = Math_fround(-Math_fround(f1 * Math_fround(HEAPF32[i5 >> 2])));
 __ZNK6Camera22GetCameraToWorldMatrixEv(i6, i3);
 f11 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(0.0));
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i6 + 16 >> 2]) * Math_fround(0.0)));
 f11 = Math_fround(f11 + Math_fround(Math_fround(HEAPF32[i6 + 32 >> 2]) * f9));
 f10 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * Math_fround(0.0));
 f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i6 + 20 >> 2]) * Math_fround(0.0)));
 f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i6 + 36 >> 2]) * f9));
 f12 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) * Math_fround(0.0));
 f12 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) * Math_fround(0.0)));
 f9 = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i6 + 40 >> 2]) * f9));
 HEAPF32[i4 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
 i8 = i4 + 4 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i8 >> 2]));
 i8 = i4 + 8 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i8 >> 2]));
 f1 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(f1 * Math_fround(HEAPF32[i5 >> 2]));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Cm10Collection8removeIdEy(i10, i4, i5) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i1 = i9;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = HEAP32[i10 + 24 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i6 = _i64Add(-1, ~i4 | 0, i4 | 0, i5 | 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = _bitshift64Lshr(i6 | 0, i3 | 0, 22) | 0;
 i6 = i2 ^ i6;
 i3 = (getTempRet0() | 0) ^ i3;
 i2 = _bitshift64Shl(i6 | 0, i3 | 0, 13) | 0;
 i2 = _i64Add(i6 | 0, i3 | 0, ~i2 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i3 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 8) | 0;
 i3 = ___muldi3(i6 ^ i2 | 0, (getTempRet0() | 0) ^ i3 | 0, 9, 0) | 0;
 i2 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i3 | 0, i2 | 0, 15) | 0;
 i3 = i6 ^ i3;
 i2 = (getTempRet0() | 0) ^ i2;
 i6 = _bitshift64Shl(i3 | 0, i2 | 0, 27) | 0;
 i6 = _i64Add(i3 | 0, i2 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i2 = getTempRet0() | 0;
 i3 = _bitshift64Lshr(i6 | 0, i2 | 0, 31) | 0;
 (getTempRet0() | 0) ^ i2;
 i1 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + ((i1 + -1 & (i3 ^ i6)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i11;
  return;
 }
 i6 = HEAP32[i10 + 8 >> 2] | 0;
 i3 = i10 + 12 | 0;
 while (1) {
  i2 = i6 + (i1 << 4) | 0;
  i12 = i2;
  if ((HEAP32[i12 >> 2] | 0) == (i4 | 0) ? (HEAP32[i12 + 4 >> 2] | 0) == (i5 | 0) : 0) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i7 = 11;
   break;
  }
 }
 if ((i7 | 0) == 11) {
  STACKTOP = i11;
  return;
 }
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 i1 = i6 + (i1 << 4) + 8 | 0;
 i2 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i10 + 44 | 0, i1, i8) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i2 + 8 | 0;
  i12 = i1;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
 } else i1 = i2 + 8 | 0;
 i12 = i1;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i10 + 4 | 0, i9) | 0;
 STACKTOP = i11;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i15, i5, i1) {
 i15 = i15 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 4 | 0;
 i1 = i14;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i13 = i15 + 16 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i15 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i13 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
 i10 = i5 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i14;
  return;
 }
 i2 = i1;
 while (1) {
  i1 = i2 + 16 | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i13 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 4);
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
  }
  i8 = i2 + 20 | 0;
  i1 = i8 + 11 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i9 = i2 + 24 | 0;
  i6 = i3 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
  HEAP32[i12 >> 2] = i6;
  i7 = i4 + 4 | 0;
  if (i7 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = i6;
   HEAP32[i13 >> 2] = i7;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i12, 4);
   i3 = HEAP8[i1 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i1 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
  i9 = i4 ? HEAP32[i9 >> 2] | 0 : i3 & 255;
  i4 = i1 + i9 | 0;
  if (i9 | 0) do {
   i3 = HEAP32[i13 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i13, i1, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i15);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
 }
 STACKTOP = i14;
 return;
}

function __ZN18SharedMaterialDataC2ERKS_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 HEAP32[i7 + 4 >> 2] = 1;
 HEAP32[i7 >> 2] = gb + 67612 + 8;
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i7 + 12 | 0, gb + 63288 | 0, i1 + 12 | 0);
 i3 = i7 + 124 | 0;
 i4 = i1 + 124 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i7 + 156 >> 2] = HEAP32[i1 + 156 >> 2];
 HEAP32[i7 + 160 >> 2] = HEAP32[i1 + 160 >> 2];
 i3 = i7 + 164 | 0;
 i4 = i1 + 164 | 0;
 i9 = HEAP8[i3 >> 0] & -2 | HEAP8[i4 >> 0] & 1;
 HEAP8[i3 >> 0] = i9;
 HEAP8[i3 >> 0] = i9 & -3 | HEAP8[i4 >> 0] & 2;
 HEAP32[i7 + 168 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP8[i7 + 172 >> 0] = HEAP8[i1 + 172 >> 0] | 0;
 i3 = i7 + 176 | 0;
 i4 = i1 + 176 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i7 + 180 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i7 + 184 >> 2] = 0;
 i5 = i1 + 180 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i2 = i1 >> 3;
 if (i2 | 0) {
  if (i2 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
  i6 = __Znwj(i1) | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i7 + 184 >> 2] = i6 + (i2 << 3);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i9 >> 2] = i6 + (i1 >> 3 << 3);
  }
 }
 HEAP32[i7 + 188 >> 2] = 0;
 HEAP32[i7 + 200 >> 2] = 0;
 HEAP32[i7 + 204 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i5 = i8;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = i7 + 192 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i7 + 208 >> 2] = 0;
 HEAP32[i7 + 220 >> 2] = 0;
 HEAP32[i7 + 224 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i6 = i8;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i7 + 212 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function __ZNSt3__23mapI26SerializedObjectIdentifieriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEixERS6_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12;
 i3 = i11 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  HEAP32[i2 >> 2] = i3;
  i4 = i3;
  i2 = i3;
  i9 = 14;
 } else {
  i8 = HEAP32[i10 >> 2] | 0;
  i7 = i10 + 8 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  L4 : while (1) {
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   do if ((i8 | 0) < (i3 | 0)) i9 = 6; else {
    if ((i8 | 0) <= (i3 | 0)) {
     i4 = i1 + 24 | 0;
     i3 = HEAP32[i4 >> 2] | 0;
     i4 = HEAP32[i4 + 4 >> 2] | 0;
     if ((i7 | 0) < (i4 | 0) | (i7 | 0) == (i4 | 0) & i6 >>> 0 < i3 >>> 0) {
      i9 = 6;
      break;
     }
     if (!((i4 | 0) < (i7 | 0) | (i4 | 0) == (i7 | 0) & i3 >>> 0 < i6 >>> 0)) {
      i9 = 12;
      break L4;
     }
    }
    i5 = i1 + 4 | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    if (!i3) {
     i9 = 11;
     break L4;
    } else i1 = i3;
   } while (0);
   if ((i9 | 0) == 6) {
    i9 = 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i9 = 7;
     break;
    } else i1 = i3;
   }
  }
  if ((i9 | 0) == 7) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i9 | 0) == 11) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i2 = i5;
   break;
  } else if ((i9 | 0) == 12) {
   HEAP32[i2 >> 2] = i1;
   i4 = i1;
   i9 = 14;
   break;
  }
 } while (0);
 if ((i9 | 0) == 14) if (i1) {
  i11 = i1;
  i11 = i11 + 32 | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = __Znwj(40) | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i11 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i11 + 4 >> 2] | 0, i1);
 i11 = i11 + 8 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i3;
 i11 = i11 + 32 | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN10UnitySceneC2EiRK8UnityStrS2_RK9UnityGUIDi(i6, i1, i7, i2, i8, i9) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 66456 + 8;
 HEAP32[i6 + 8 >> 2] = i1;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i6 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i6 + 44 | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i12 = i4 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 56 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 56 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i10 = 6;
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i13 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i12;
  HEAP32[i6 + 52 >> 2] = i13 | -2147483648;
  HEAP32[i6 + 48 >> 2] = i4;
  i1 = i12;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i13 = i6 + 60 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = i9;
 i13 = i6 + 84 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i13 = i6 + 100 | 0;
 HEAP32[i13 >> 2] = i13;
 HEAP32[i6 + 104 >> 2] = i13;
 __ZN10UnityScene14SetPathAndGUIDERK8UnityStrRK9UnityGUID(i6, i7, i8);
 HEAP32[i6 + 80 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEEN12_GLOBAL__N_14EdgeEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + (i4 * 20 | 0) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i15 = HEAP32[i2 >> 2] | 0;
   i16 = i15 + (i10 * 20 | 0) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i14 = i15 + (i10 * 20 | 0) + 4 | 0;
   i18 = HEAP32[i14 >> 2] | 0;
   i18 = i18 + ~(i18 << 15) | 0;
   i18 = (i18 >>> 10 ^ i18) * 9 | 0;
   i18 = i18 >>> 6 ^ i18;
   i18 = i18 + ~(i18 << 11) | 0;
   i17 = i17 + ~(i17 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i5 + (((i18 >>> 16 ^ i18 ^ (i17 ^ -57320555 ^ i17 >>> 16) * 1000007) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i10;
   HEAP32[i7 + (i10 * 20 | 0) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i7 + (i10 * 20 | 0) + 4 >> 2] = HEAP32[i14 >> 2];
   i14 = i7 + (i10 * 20 | 0) + 8 | 0;
   i15 = i15 + (i10 * 20 | 0) + 8 | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 336 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 336 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN16Physics2DManager14OverlapCapsuleERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2D(i1, i2, i3, i4, f5, i6, f7, f8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 248 | 0;
 i11 = i16;
 i15 = i16 + 256 | 0;
 if ((HEAP16[gb + 1457800 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457800 | 0, i10);
  i12 = gb + 1457800 | 0;
 } else i12 = 0;
 i18 = gb + 64016 | 0;
 i14 = HEAP32[i18 + 4 >> 2] | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 i13 = i15 + 16 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i15 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
 i18 = i10;
 i17 = HEAP32[i18 + 4 >> 2] | 0;
 i1 = i14;
 HEAP32[i1 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i1 + 4 >> 2] = i17;
 __ZN21OverlapCapsuleQuery2DC2ERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DR13dynamic_arrayIPS5_Lj4EE(i11, i2, i3, i4, Math_fround(f5 * Math_fround(.0174532924)), i6, f7, f8, i9, i15);
 i1 = i11 + 240 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i11, i11 + 208 | 0);
 i18 = HEAP32[i1 >> 2] | 0;
 i17 = HEAP32[i18 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i17, i17 + (HEAP32[i18 + 12 >> 2] << 2) | 0, i10);
 if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0) > 0) i1 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0; else i1 = 0;
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, i14);
  HEAP32[i15 >> 2] = 0;
 }
 if (!i12) {
  STACKTOP = i16;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return i1 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 60 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 60 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx22PxPrismaticJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i9 | 0, i12 | 0, 84, (i1 ? gb + 742354 | 0 : gb + 837976 | 0) | 0, gb + 742480 | 0, 37) | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i1 + 4 >> 1] = 258;
 HEAP16[i1 + 6 >> 1] = 3;
 i9 = i1 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i8 = i1 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 88228 + 8;
 HEAP32[i9 >> 2] = gb + 88228 + 216;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 112, gb + 742569 | 0, 77) | 0;
 HEAP32[i1 + 80 >> 2] = i10;
 f13 = Math_fround(HEAPF32[i12 >> 2]);
 f11 = Math_fround(f13 * Math_fround(.00999999977));
 i12 = f11 < Math_fround(1111589019999999947238623.0e14);
 f11 = i12 ? f11 : Math_fround(1111589019999999947238623.0e14);
 f13 = Math_fround(f13 * Math_fround(2.0));
 HEAPF32[i10 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 76 >> 2] = f13;
 i12 = i10 + 80 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAPF32[i10 + 88 >> 2] = f11;
 HEAPF32[i10 + 92 >> 2] = Math_fround(1134274490000000073900846.0e14);
 HEAPF32[i10 + 96 >> 2] = Math_fround(-1134274490000000073900846.0e14);
 HEAPF32[i10 + 100 >> 2] = Math_fround(1.0e10);
 HEAPF32[i10 + 104 >> 2] = Math_fround(3.14159274);
 HEAP16[i10 + 108 >> 1] = 0;
 __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i1, i10, i2, i4, i3, i5);
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, i2 | 0, i3 | 0, i9 | 0, gb + 88208 | 0, 112) | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 | 0) {
  i12 = i1;
  STACKTOP = i7;
  return i12 | 0;
 }
 if (!i1) {
  i12 = 0;
  STACKTOP = i7;
  return i12 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i12 = 0;
 STACKTOP = i7;
 return i12 | 0;
}

function __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(i2, i3, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i9 = i3 + 4 | 0;
 i10 = i3 + 8 | 0;
 i11 = i3 + 16 | 0;
 i12 = i3 + 20 | 0;
 i13 = i3 + 24 | 0;
 i14 = i3 + 32 | 0;
 i15 = i3 + 36 | 0;
 i4 = i3 + 40 | 0;
 i5 = i3 + 48 | 0;
 i6 = i3 + 52 | 0;
 i7 = i3 + 56 | 0;
 i1 = 0;
 do {
  i20 = i2 + (i1 << 2) | 0;
  f17 = Math_fround(HEAPF32[i20 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i3 >> 2]));
  i22 = i1 + 4 | 0;
  i19 = i2 + (i22 << 2) | 0;
  f18 = Math_fround(HEAPF32[i19 >> 2]);
  f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i9 >> 2])));
  i21 = i1 + 8 | 0;
  i16 = i2 + (i21 << 2) | 0;
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i8 + (i1 << 2) >> 2] = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i10 >> 2])));
  f17 = Math_fround(HEAPF32[i20 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i11 >> 2]));
  f18 = Math_fround(HEAPF32[i19 >> 2]);
  f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i12 >> 2])));
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i8 + (i22 << 2) >> 2] = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i13 >> 2])));
  f17 = Math_fround(HEAPF32[i20 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i14 >> 2]));
  f18 = Math_fround(HEAPF32[i19 >> 2]);
  f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i15 >> 2])));
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  HEAPF32[i8 + (i21 << 2) >> 2] = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i4 >> 2])));
  f17 = Math_fround(HEAPF32[i20 >> 2]);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i5 >> 2]));
  f18 = Math_fround(HEAPF32[i19 >> 2]);
  f18 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i6 >> 2])));
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  f17 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i7 >> 2])));
  i16 = i1 + 12 | 0;
  HEAPF32[i8 + (i16 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i2 + (i16 << 2) >> 2]) + f17);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0;
 i1 = i5 + (HEAPU16[i5 + 10 >> 1] | 0) | 0;
 i2 = i5 + 8 | 0;
 if ((HEAPU16[i2 >> 1] | 0) > 1) i3 = 1; else return;
 do {
  i25 = HEAPU8[i5 + 64 + i3 >> 0] | 0;
  f18 = Math_fround(HEAPF32[i6 + (i25 << 5) >> 2]);
  f24 = Math_fround(HEAPF32[i6 + (i25 << 5) + 4 >> 2]);
  f23 = Math_fround(HEAPF32[i6 + (i25 << 5) + 8 >> 2]);
  f22 = Math_fround(HEAPF32[i6 + (i25 << 5) + 16 >> 2]);
  f17 = Math_fround(HEAPF32[i6 + (i25 << 5) + 20 >> 2]);
  f15 = Math_fround(HEAPF32[i6 + (i25 << 5) + 24 >> 2]);
  f13 = Math_fround(HEAPF32[i6 + (i3 << 5) >> 2]);
  f8 = Math_fround(HEAPF32[i6 + (i3 << 5) + 4 >> 2]);
  f20 = Math_fround(HEAPF32[i6 + (i3 << 5) + 8 >> 2]);
  f19 = Math_fround(HEAPF32[i6 + (i3 << 5) + 16 >> 2]);
  f12 = Math_fround(HEAPF32[i6 + (i3 << 5) + 20 >> 2]);
  f10 = Math_fround(HEAPF32[i6 + (i3 << 5) + 24 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + (i3 << 5) + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i1 + (i3 << 5) + 20 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + (i3 << 5) + 24 >> 2]);
  f21 = Math_fround(HEAPF32[i1 + (i3 << 5) >> 2]);
  f14 = Math_fround(HEAPF32[i1 + (i3 << 5) + 4 >> 2]);
  f21 = Math_fround(f7 + f21);
  f14 = Math_fround(f9 + f14);
  f16 = Math_fround(f11 + Math_fround(HEAPF32[i1 + (i3 << 5) + 8 >> 2]));
  f8 = Math_fround(Math_fround(f24 + Math_fround(Math_fround(f15 * f21) - Math_fround(f22 * f16))) - Math_fround(f8 + Math_fround(Math_fround(f10 * f7) - Math_fround(f19 * f11))));
  f7 = Math_fround(Math_fround(f23 + Math_fround(Math_fround(f22 * f14) - Math_fround(f17 * f21))) - Math_fround(f20 + Math_fround(Math_fround(f19 * f9) - Math_fround(f12 * f7))));
  HEAPF32[i4 + (i3 << 4) >> 2] = Math_fround(Math_fround(f18 + Math_fround(Math_fround(f17 * f16) - Math_fround(f15 * f14))) - Math_fround(f13 + Math_fround(Math_fround(f12 * f11) - Math_fround(f10 * f9))));
  HEAPF32[i4 + (i3 << 4) + 4 >> 2] = f8;
  HEAPF32[i4 + (i3 << 4) + 8 >> 2] = f7;
  HEAPF32[i4 + (i3 << 4) + 12 >> 2] = Math_fround(0.0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAPU16[i2 >> 1] | 0) >>> 0);
 return;
}

function __ZN18PlatformEffector2D19RecalculateContactsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i8 = i15;
 i14 = i15 + 16 | 0;
 i13 = gb + 64016 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i8;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = 0;
 i11 = i14 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i14 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i14 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i13;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i10 + 36 | 0;
 i8 = i10 + 48 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = 0;
  i6 = 0;
  while (1) {
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i9 = i4 + 1 | 0;
   i5 = i6 & 2147483647;
   do if (i9 >>> 0 > i5 >>> 0) {
    i2 = i6 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i5 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i14 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i11 >> 2] = i9;
   HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 2) >> 2] = i3;
   i1 = i1 + 40 | 0;
   if ((i1 | 0) == ((HEAP32[i7 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 40 | 0) | 0)) break;
   i4 = i9;
   i6 = HEAP32[i12 >> 2] | 0;
  }
  i2 = (HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102872 | 0;
  if (i9 | 0) {
   i1 = HEAP32[i14 >> 2] | 0;
   do {
    __ZN16b2ContactManager7DestroyEP9b2Contact(i2, HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i14 >> 2] | 0) + (HEAP32[i11 >> 2] << 2) | 0));
  }
 }
 __ZN10Effector2D19RecalculateContactsEv(i10);
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  STACKTOP = i15;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i13);
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(i10, i8, i11) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i9 = i10 + 100 | 0;
 i6 = i10 + 104 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do if (!i1) i4 = 18; else {
  i2 = i6;
  i4 = i1;
  L3 : while (1) {
   i3 = i4;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i8 | 0)) break;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i3) break L3;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) != (i6 | 0)) if ((HEAP32[i2 + 16 >> 2] | 0) <= (i8 | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459456 | 0, 0, gb + 459188 | 0, 195, 1, 0, 0, 0);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (!i1) i4 = 18; else {
   while (1) {
    i2 = HEAP32[i1 + 16 >> 2] | 0;
    if ((i2 | 0) > (i8 | 0)) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i4 = 13;
      break;
     } else i1 = i2;
    } else {
     if ((i2 | 0) >= (i8 | 0)) {
      i4 = 19;
      break;
     }
     i3 = i1 + 4 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) {
      i4 = 17;
      break;
     } else i1 = i2;
    }
   }
   if ((i4 | 0) == 13) {
    HEAP32[i7 >> 2] = i1;
    i5 = i1;
    i2 = i1;
    break;
   } else if ((i4 | 0) == 17) {
    HEAP32[i7 >> 2] = i1;
    i5 = i1;
    i2 = i3;
    break;
   } else if ((i4 | 0) == 19) {
    HEAP32[i7 >> 2] = i1;
    if (!i1) {
     i5 = i1;
     i2 = i7;
     break;
    }
    i10 = i1 + 20 | 0;
    HEAP32[i10 >> 2] = i11;
    STACKTOP = i12;
    return;
   }
  }
 } while (0);
 if ((i4 | 0) == 18) {
  HEAP32[i7 >> 2] = i6;
  i5 = i6;
  i2 = i6;
 }
 i3 = __Znwj(24) | 0;
 HEAP32[i3 + 16 >> 2] = i8;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i9 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 + 104 >> 2] | 0, i1);
 i10 = i10 + 108 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i3;
 i10 = i10 + 20 | 0;
 HEAP32[i10 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorIN19ControllerHitReport29RecordedControllerColliderHitENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 44 | 0) + 1 | 0;
 if (i4 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 44 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 48806446 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 97612893;
 i5 = (i1 - i2 | 0) / 44 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 44 | 0) | 0;
 i7 = i6 + (i5 * 44 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 44 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i6 + (i5 * 44 | 0) + 40 >> 2] = HEAP32[i8 + 40 >> 2];
 i4 = i7 + 44 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i8 = i3;
   i3 = i3 + -44 | 0;
   HEAP32[i1 + -44 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i8 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i8 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i8 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i8 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i8 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i8 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i8 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i8 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i8 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i8 + -4 >> 2];
   i1 = i2 + -44 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5Flare12FlareElement8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373635 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 407233 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i5, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373648 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373664 | 0, i5, i1 + 29 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373673 | 0, i5, i1 + 30 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 373680 | 0, i5, i1 + 31 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11LightProbes14LightProbeDataaSERKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 __ZN26ProbeSetTetrahedralizationaSERKS_(i8, i9) | 0;
 i5 = i8 + 40 | 0;
 i10 = (i9 | 0) == (i8 | 0);
 if (i10) {
  HEAP8[i8 + 80 >> 0] = HEAP8[i9 + 80 >> 0] | 0;
  return i8 | 0;
 }
 i7 = HEAP32[i9 + 40 >> 2] | 0;
 i6 = i8 + 52 | 0;
 i1 = (HEAP32[i9 + 52 >> 2] | 0) * 24 | 0;
 i2 = (i1 | 0) / 24 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i8 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 8, i8 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
 i2 = i8 + 60 | 0;
 i6 = HEAP32[i9 + 60 >> 2] | 0;
 i7 = i8 + 72 | 0;
 i1 = (HEAP32[i9 + 72 >> 2] | 0) * 12 | 0;
 i3 = (i1 | 0) / 12 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 HEAP8[i8 + 80 >> 0] = HEAP8[i9 + 80 >> 0] | 0;
 if (i10) return i8 | 0;
 __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i8 + 84 | 0, HEAP32[i9 + 84 >> 2] | 0, HEAP32[i9 + 88 >> 2] | 0);
 return i8 | 0;
}

function __Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i9 = i11;
 i8 = i11 + 12 | 0;
 i4 = __Z10BeginsWithPKcS0_(i1, gb + 445049 | 0) | 0;
 i4 = i4 ? i1 + 12 | 0 : i1;
 i3 = __ZN6Object15StringToClassIDEPKc(i4) | 0;
 i5 = (i3 | 0) == -1;
 if (!i5) {
  i1 = HEAP32[gb + 1110260 >> 2] | 0;
  if ((i3 | 0) > 99999) {
   i2 = (HEAP32[i1 + 24 >> 2] | 0) + (i3 + -1e5 << 3) | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = i1 + (i3 << 3) | 0;
  }
  if (((HEAP32[i2 >> 2] | 0) - (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i10 = __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i6, i3, 0, i7) | 0;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i1 = (__Z19GetScriptingManagerv() | 0) + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, _strlen(i4) | 0);
 i1 = __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if (i1 | 0) {
  i10 = __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i6, 114, __ZN10MonoScript8GetClassEv(i1) | 0, i7) | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (i5) {
  HEAP32[i9 >> 2] = i4;
  __Z6FormatPKcz(i8, gb + 445062 | 0, i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  HEAP32[i10 >> 2] = i4;
  __Z6FormatPKcz(i8, gb + 445116 | 0, i10);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 return 0;
}

function __ZNK5physx7NpShape32getMaterialFromInternalFaceIndexEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7 + 32 | 0;
 i1 = (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0) == 6;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0) == 5;
 if ((i5 | 0) == -1 & (i1 | i2)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 689543 | 0, 528, gb + 689905 | 0, i7);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i1) {
  HEAP32[i3 >> 2] = 6;
  i1 = i3 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAPF32[i3 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 16 >> 2] = Math_fround(1.0);
  HEAP32[i3 + 20 >> 2] = 0;
  mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 60 >> 2] | 0, i6 | 0, i3 | 0) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i5 | 0) | 0;
 } else if (i2) {
  HEAP32[i4 >> 2] = 5;
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 28 >> 2] = Math_fround(1.0);
  i1 = i4 + 32 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i6 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 + 36 >> 2] | 0;
  if (!(HEAP32[i1 + 176 >> 2] | 0)) i1 = 0; else i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i5 | 0) | 0;
 } else i1 = 0;
 i2 = i1 & 65535;
 i3 = HEAP32[gb + 1457324 >> 2] | 0;
 if (!(HEAP32[i6 + 36 >> 2] & 2)) {
  i1 = HEAPU16[(__ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i6 + 48 | 0) | 0) + (i2 << 1) >> 1] | 0;
  i1 = (HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) | 0;
 } else {
  i1 = HEAP32[i6 + 40 >> 2] | 0;
  if ((HEAP16[i1 + 116 >> 1] | 0) == 1) i1 = i1 + 112 | 0; else i1 = (HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
  i1 = (HEAP32[i3 + 52 >> 2] | 0) + (HEAPU16[i1 + (i2 << 1) >> 1] << 2) | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i10 = i11;
 i2 = i8 + 4 | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) {
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i8 + 8 >> 2] | 0;
 } else i3 = i4 & 255;
 if (!(_strncmp(i1, i2, i3) | 0)) {
  if (i5) i2 = HEAP32[i8 + 8 >> 2] | 0; else i2 = i4 & 255;
  i1 = i1 + i2 | 0;
 }
 i3 = (HEAP8[i1 >> 0] | 0) == 47 ? i1 + 1 | 0 : i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 + 12 >> 2] | 0;
  i6 = 12;
 } else if (i4 >>> 0 < 11) {
  i2 = i10 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i10; else {
   i1 = i10;
   i6 = 14;
  }
 } else i6 = 12;
 if ((i6 | 0) == 12) {
  i2 = i4 + 16 & -16;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i10 + 4 >> 2] = i4;
  i2 = i10 + 11 | 0;
  i6 = 14;
 }
 if ((i6 | 0) == 14) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i8 + 136 | 0, i10) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i9);
 }
 if ((i1 | 0) == (i8 + 140 | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  STACKTOP = i11;
  return;
 } else {
  i8 = i1 + 32 | 0;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i7;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i10, i6, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 48 | 0, 4) | 0;
  i2 = i4 + (i1 * 48 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    i11 = i1 + 40 | 0;
    HEAP32[i11 >> 2] = -1;
    HEAP32[i11 + 4 >> 2] = -1;
    i1 = i1 + 48 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i11 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i11 * 48 | 0) | 0;
 if (!i11) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i1, i10);
  i2 = i1 + 40 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  if (i4 >>> 0 > i5 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = i4;
  }
  i2 = i1 + 44 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i5 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN13b2DynamicTree10RemoveLeafEi(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i7 >> 2] = -1;
  return;
 }
 i8 = i7 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i4 + (i3 * 36 | 0) + 20 >> 2] | 0;
 i6 = i4 + (i5 * 36 | 0) + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i4 + (i5 * 36 | 0) + 24 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i2 = HEAP32[i4 + (i5 * 36 | 0) + 28 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 + (i2 * 36 | 0) + 20 >> 2] = -1;
  i8 = i7 + 16 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + (i5 * 36 | 0) + 32 >> 2] = -1;
  HEAP32[i8 >> 2] = i5;
  i8 = i7 + 8 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  return;
 }
 i3 = i4 + (i1 * 36 | 0) + 24 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) HEAP32[i3 >> 2] = i2; else HEAP32[i4 + (i1 * 36 | 0) + 28 >> 2] = i2;
 HEAP32[i4 + (i2 * 36 | 0) + 20 >> 2] = i1;
 i3 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + (i5 * 36 | 0) + 32 >> 2] = -1;
 HEAP32[i3 >> 2] = i5;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 do {
  i6 = __ZN13b2DynamicTree7BalanceEi(i7, i1) | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 + (i6 * 36 | 0) + 24 >> 2] | 0;
  i4 = HEAP32[i5 + (i6 * 36 | 0) + 28 >> 2] | 0;
  f9 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) >> 2]);
  f10 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) >> 2]);
  f11 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 4 >> 2]);
  HEAPF32[i5 + (i6 * 36 | 0) >> 2] = f9 < f10 ? f9 : f10;
  HEAPF32[i5 + (i6 * 36 | 0) + 4 >> 2] = f11 < f12 ? f11 : f12;
  f12 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i5 + (i3 * 36 | 0) + 12 >> 2]);
  f9 = Math_fround(HEAPF32[i5 + (i4 * 36 | 0) + 12 >> 2]);
  HEAPF32[i5 + (i6 * 36 | 0) + 8 >> 2] = f12 > f11 ? f12 : f11;
  HEAPF32[i5 + (i6 * 36 | 0) + 12 >> 2] = f10 > f9 ? f10 : f9;
  i5 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 + (i3 * 36 | 0) + 32 >> 2] | 0;
  i4 = HEAP32[i5 + (i4 * 36 | 0) + 32 >> 2] | 0;
  HEAP32[i5 + (i6 * 36 | 0) + 32 >> 2] = ((i3 | 0) > (i4 | 0) ? i3 : i4) + 1;
  i1 = HEAP32[i5 + (i6 * 36 | 0) + 20 >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i12 = i14;
 i5 = i9 + 4 | 0;
 HEAP32[i11 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i12 | 0, i11 | 0) | 0;
 i11 = HEAP32[i12 >> 2] << 4;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i3;
 i10 = i1 - i2 | 0;
 i4 = i10 + i11 | 0;
 if (!i4) i6 = i3; else {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i2 | 0) >>> 0 > i4 >>> 0) i6 = i3; else {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = i5 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i4 | 0, i2 | 0, i10 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i4;
   i6 = i4 + i10 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 >> 2] = i4 + i1;
   i1 = i6;
   i6 = i4;
  }
 }
 HEAP32[i8 >> 2] = i1 + i11;
 i4 = i6 + i10 | 0;
 if (!i11) {
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i4;
  i12 = i4 + (i12 << 4) | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 16 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i2 = i9 + 8 | 0;
  i3 = i2;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i9 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i9 + 12 >> 2] | 0) - i2 | 0;
 }
 i1 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 if (i11 >>> 0 > i1 >>> 0) _memset(i6 + (i1 + i10) | 0, 0, i11 - i1 | 0) | 0;
 HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) == 0 ? 0 : (i11 | 0) == (i1 | 0) & 1;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i4;
 i12 = i4 + (i12 << 4) | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZN11LightProbes8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 108 | 0;
 i4 = i5;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899468 | 0, gb + 378416 | 0, i6, 0);
 __ZN11LightProbes14LightProbeData8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378431 | 0, i6, i1 + 148 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 590318 | 0, i4, 0);
 __ZN20SphericalHarmonicsL28TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378451 | 0, i6, i1 + 168 | 0, 0);
 HEAP32[i4 >> 2] = -2;
 HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 378473 | 0, i4, 0);
 __ZN19LightProbeOcclusion8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i4 + 38596 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 } else i1 = 0;
 do {
  i3 = i4 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i4 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i3 >> 2] | 0); else mftCall_vi(HEAP32[i3 >> 2] | 0, HEAP32[i4 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 STACKTOP = i5;
 return;
}

function _malloc_trim(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i6 = i1 & -16 ^ 1431655768;
  HEAP32[i1 >> 2] = i6;
  HEAP32[gb + 1470876 >> 2] = i6;
 }
 if (i2 >>> 0 >= 4294967232) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
 if (!i4) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[gb + 1470404 + 12 >> 2] | 0;
 if (i1 >>> 0 > (i2 + 40 | 0) >>> 0) {
  i6 = HEAP32[gb + 1470876 + 8 >> 2] | 0;
  i1 = ((-41 - i2 + i1 + i6 | 0) >>> 0) / (i6 >>> 0) | 0;
  i3 = gb + 1470404 + 448 | 0;
  while (1) {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2 >>> 0 <= i4 >>> 0) {
    i5 = i3 + 4 | 0;
    if ((i2 + (HEAP32[i5 >> 2] | 0) | 0) >>> 0 > i4 >>> 0) break;
   }
   i3 = HEAP32[i3 + 8 >> 2] | 0;
  }
  i1 = Math_imul(i1 + -1 | 0, i6) | 0;
  if (!(HEAP32[i3 + 12 >> 2] & 8)) {
   i2 = _sbrk(0) | 0;
   if ((i2 | 0) == ((HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0)) {
    i4 = _sbrk(0 - (i1 >>> 0 > 2147483646 ? -2147483648 - i6 | 0 : i1) | 0) | 0;
    i6 = _sbrk(0) | 0;
    i1 = i2 - i6 | 0;
    if (!((i4 | 0) == (-1 | 0) | i6 >>> 0 >= i2 >>> 0 | (i1 | 0) == 0)) {
     HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1;
     HEAP32[gb + 1470404 + 432 >> 2] = (HEAP32[gb + 1470404 + 432 >> 2] | 0) - i1;
     i5 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
     i6 = i5 + 8 | 0;
     i6 = (i6 & 7 | 0) == 0 ? 0 : 0 - i6 & 7;
     i5 = i5 + i6 | 0;
     i6 = (HEAP32[gb + 1470404 + 12 >> 2] | 0) - i1 - i6 | 0;
     HEAP32[gb + 1470404 + 24 >> 2] = i5;
     HEAP32[gb + 1470404 + 12 >> 2] = i6;
     HEAP32[i5 + 4 >> 2] = i6 | 1;
     HEAP32[i5 + i6 + 4 >> 2] = 40;
     HEAP32[gb + 1470404 + 28 >> 2] = HEAP32[gb + 1470876 + 16 >> 2];
     i6 = 1;
     STACKTOP = i7;
     return i6 | 0;
    }
   }
  }
 }
 if ((HEAP32[gb + 1470404 + 12 >> 2] | 0) >>> 0 <= (HEAP32[gb + 1470404 + 28 >> 2] | 0) >>> 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[gb + 1470404 + 28 >> 2] = -1;
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK9profiling14SamplerManager10GetSamplerERKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 12 | 0;
 i7 = i9;
 if ((HEAP32[i6 + 92 >> 2] | 0) == (HEAP32[i6 + 4 >> 2] | 0)) {
  i1 = i6 + 84 | 0;
  i2 = i6 + 88 | 0;
  i5 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 36 | 0) | 0;
  __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i7, i6, i5, i5, 1);
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_(i8, i6, i1);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = i6 + 84 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = i6 + 88 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == -1) {
   i5 = i4 + (i5 * 36 | 0) | 0;
   __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i7, i6, i5, i5, 1);
  } else {
   HEAP32[i7 >> 2] = i6;
   HEAP32[i7 + 4 >> 2] = i4 + (i3 * 36 | 0);
   HEAP32[i7 + 8 >> 2] = i4 + (i5 * 36 | 0);
  }
 }
 i1 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 36 | 0) | 0;
 __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b(i8, i6, i1, i1, 1);
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i8 + 4 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i14 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = i12 >> 3;
 i4 = i14 + 7 >> 3;
 i9 = i11 >> 2;
 i12 = HEAP32[gb + 78880 + ((i12 & 7) << 2) >> 2] | 0;
 i14 = HEAP32[gb + 78912 + ((i14 & 7) << 2) >> 2] | 0;
 i1 = HEAP32[gb + 78944 + ((i11 & 3) << 2) >> 2] | 0;
 i11 = HEAP32[gb + 78960 + ((i8 & 3) << 2) >> 2] | 0;
 i7 = HEAPU8[i2 + 2 >> 0] | 0;
 i10 = HEAP16[i2 >> 1] | 0;
 i3 = i10 & 255;
 i3 = i5 - i3 + (Math_imul(i9 - ((i10 & 65535) >>> 8 & 65535) | 0, i7 - i3 | 0) | 0) | 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (i3 << 2) | 0;
 i13 = i4 - i5 | 0;
 i10 = i7 - i13 - (i10 & 255) | 0;
 i2 = (i8 + 3 >> 2) - i9 + -1 | 0;
 i13 = i13 + -1 | 0;
 if (!i2) i2 = 0; else {
  if (!i13) {
   while (1) {
    i1 = i1 & i12 & i14 & HEAP32[i3 >> 2];
    i3 = i3 + 4 + (i10 << 2) | 0;
    i2 = i2 + -1 | 0;
    if (!((i2 | 0) != 0 & (i1 | 0) == 0)) break; else i1 = -1;
   }
   i12 = i11 & i12;
   i13 = i1;
   i11 = i3;
   i12 = i12 & i14;
   i14 = HEAP32[i11 >> 2] | 0;
   i14 = i12 & i14;
   i14 = i14 | i13;
   i14 = (i14 | 0) != 0;
   return i14 | 0;
  }
  i9 = i4 + -2 - i5 | 0;
  while (1) {
   i8 = i3 + (i9 << 2) | 0;
   i4 = i1 & i12;
   i5 = i3;
   i6 = 0;
   i7 = i13;
   while (1) {
    i6 = HEAP32[i5 >> 2] & i4 | i6;
    i7 = i7 + -1 | 0;
    if (!i7) break; else {
     i4 = i1;
     i5 = i5 + 4 | 0;
    }
   }
   i1 = i1 & i14 & HEAP32[i3 + (i13 << 2) >> 2] | i6;
   i3 = i8 + 8 + (i10 << 2) | 0;
   i2 = i2 + -1 | 0;
   if (!((i2 | 0) != 0 & (i1 | 0) == 0)) {
    i2 = i1;
    i1 = -1;
    break;
   } else i1 = -1;
  }
 }
 i6 = i1 & i11;
 i1 = i6 & i12;
 if (!i13) {
  i12 = i1;
  i13 = i2;
  i11 = i3;
  i12 = i12 & i14;
  i14 = HEAP32[i11 >> 2] | 0;
  i14 = i12 & i14;
  i14 = i14 | i13;
  i14 = (i14 | 0) != 0;
  return i14 | 0;
 } else {
  i5 = i3;
  i4 = i13;
 }
 while (1) {
  i2 = HEAP32[i5 >> 2] & i1 | i2;
  i4 = i4 + -1 | 0;
  if (!i4) break; else {
   i1 = i6;
   i5 = i5 + 4 | 0;
  }
 }
 i10 = i6;
 i12 = i2;
 i11 = i3 + (i13 << 2) | 0;
 i13 = i10 & i14;
 i14 = HEAP32[i11 >> 2] | 0;
 i14 = i13 & i14;
 i14 = i14 | i12;
 i14 = (i14 | 0) != 0;
 return i14 | 0;
}

function __ZN14VRSplashScreen6UpdateEPFvRK11QuaternionfRK8Vector3fS5_E(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 i7 = i6 + 4 | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i3 = i6 + 16 | 0;
  i5 = HEAP16[i3 >> 1] | 0;
  if (!((i5 & 255) << 24 >> 24)) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __ZN14VRSplashScreen19CreateSplashObjectsE4PPtrI9Texture2DEf(i6, i1, Math_fround(1.0));
   if (HEAP8[i6 + 18 >> 0] | 0) {
    i5 = __Z21PlayerStartFirstSceneb(1) | 0;
    HEAP32[i6 + 12 >> 2] = i5;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, 0);
   }
   HEAPF64[i6 + 24 >> 3] = +__Z19GetTimeSinceStartupv();
   HEAP8[i3 >> 0] = 1;
   break;
  }
  i3 = i6 + 17 | 0;
  if ((i5 & 65535) >= 256) if (HEAP8[i6 + 44 >> 0] | 0) __ZN14VRSplashScreen23UpdateTagalongTransformEPFvRK11QuaternionfRK8Vector3fS5_E(i6, i4);
  d9 = +__Z19GetTimeSinceStartupv();
  if (d9 >= +HEAPF64[i6 + 24 >> 3] + +HEAPF64[i6 + 32 >> 3]) {
   i2 = i6 + 18 | 0;
   i1 = (HEAP8[i2 >> 0] | 0) != 0;
   if (HEAP8[i3 >> 0] | 0) {
    if (i1) if ((HEAP32[(HEAP32[i6 + 12 >> 2] | 0) + 24 >> 2] | 0) != 1) break;
    __ZN10GameObject10DeactivateE19DeactivateOperation(HEAP32[i6 + 8 >> 2] | 0, 0);
    HEAP8[i3 >> 0] = 0;
    i7 = 1;
    STACKTOP = i8;
    return i7 | 0;
   }
   if (i1) {
    i5 = HEAP32[i6 + 12 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, 1);
    if (HEAP8[i2 >> 0] | 0) {
     i1 = i6 + 12 | 0;
     i5 = HEAP32[i1 >> 2] | 0;
     if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0) | 0)) break;
     if (HEAP8[i2 >> 0] | 0) {
      HEAP32[i6 + 8 >> 2] = 0;
      HEAP32[i7 >> 2] = 0;
      i6 = __Z12GetIVRDevicev() | 0;
      mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0);
      i6 = HEAP32[i1 >> 2] | 0;
      mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0);
      break;
     }
    }
   }
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   i6 = __Z12GetIVRDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0);
   __Z15UnloadGameScenev();
   __Z21PlayerStartFirstSceneb(0) | 0;
  }
 } while (0);
 i7 = (HEAP32[i7 >> 2] | 0) != 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14PhysicsManager12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i3 = i9;
 i8 = i9 + 16 | 0;
 i1 = __Z19GetRaycastInterfacev() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __Z19SetRaycastInterfaceP8IRaycast(0);
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN19CharacterController24CleanupControllerManagerEv();
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i3 = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i7);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 113108 | 0, i8, 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i2 = (HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 52 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i5 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0, i5 | 0, 0, 0);
 __ZN14PhysicsManager20CleanupDynamicsSceneEv();
 i5 = HEAP32[gb + 1457456 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
 HEAP32[gb + 1457456 >> 2] = 0;
 _PxCloseExtensions();
 if (__Z12GetIVehiclesv() | 0) {
  i5 = __Z12GetIVehiclesv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0);
 }
 i5 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 HEAP32[gb + 1457408 >> 2] = 0;
 i5 = HEAP32[gb + 1457460 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
 HEAP32[gb + 1457460 >> 2] = 0;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
  HEAP32[i8 >> 2] = 0;
 }
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 4 | 0;
 i12 = i14;
 i5 = i9 + 4 | 0;
 HEAP32[i11 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i12 | 0, i11 | 0) | 0;
 i11 = HEAP32[i12 >> 2] << 5;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i3;
 i10 = i1 - i2 | 0;
 i4 = i10 + i11 | 0;
 if (!i4) i6 = i3; else {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i2 | 0) >>> 0 > i4 >>> 0) i6 = i3; else {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = i5 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i4 | 0, i2 | 0, i10 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i4;
   i6 = i4 + i10 | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i7 >> 2] = i4 + i1;
   i1 = i6;
   i6 = i4;
  }
 }
 HEAP32[i8 >> 2] = i1 + i11;
 i4 = i6 + i10 | 0;
 if (!i11) {
  i12 = HEAP32[i12 >> 2] | 0;
  i11 = i4;
  i12 = i4 + (i12 << 5) | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i5 = i9 + 16 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i2 = i9 + 8 | 0;
  i3 = i2;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i9 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i9 + 12 >> 2] | 0) - i2 | 0;
 }
 i1 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 if (i11 >>> 0 > i1 >>> 0) _memset(i6 + (i1 + i10) | 0, 0, i11 - i1 | 0) | 0;
 HEAP8[i5 >> 0] = (HEAP8[i5 >> 0] | 0) == 0 ? 0 : (i11 | 0) == (i1 | 0) & 1;
 i12 = HEAP32[i12 >> 2] | 0;
 i11 = i4;
 i12 = i4 + (i12 << 5) | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZN12TreeRenderer23UpdateWindAssetPointersEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14;
 i10 = i13 + 364 | 0;
 i11 = i13 + 368 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = i2;
 if ((HEAP32[i11 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 i6 = 0;
 i7 = 0;
 i3 = i1;
 i5 = i1;
 while (1) {
  i4 = i3 + (i7 * 44 | 0) + 24 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = i2;
  } else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 14;
    }
   }
   if ((i12 | 0) == 12) i12 = 14;
   if ((i12 | 0) == 14) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
   i5 = HEAP32[i10 >> 2] | 0;
   i3 = i5;
   i4 = i5;
  }
  i2 = i3 + (i7 * 44 | 0) + 28 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = i6; else {
   HEAP32[i2 >> 2] = i1;
   i1 = 1;
  }
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= (((HEAP32[i11 >> 2] | 0) - i4 | 0) / 44 | 0) >>> 0) break; else {
   i6 = i1;
   i3 = i4;
   i2 = i4;
  }
 }
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i3 = HEAP32[i13 + 392 >> 2] | 0;
 if (!i3) {
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i13 + 380 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 88 | 0) + 28 >> 2] = HEAP32[i5 + ((HEAPU16[i2 + (i1 * 88 | 0) + 2 >> 1] | 0) * 44 | 0) + 28 >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN11Tetrahedron8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZNK15CapsuleCollider18CalculateTransformEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i7, i11, i1 + 72 | 0);
 __ZNK9Transform11GetRotationEv(i9, i11);
 switch (HEAP32[i1 + 68 >> 2] | 0) {
 case 1:
  {
   f2 = Math_fround(Math_fround(HEAPF32[gb + 62548 >> 2]) * Math_fround(-.707106769));
   f5 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 4 >> 2]) * Math_fround(-.707106769));
   f3 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 8 >> 2]) * Math_fround(-.707106769));
   f4 = Math_fround(.707106769);
   break;
  }
 case 2:
  {
   f2 = Math_fround(Math_fround(HEAPF32[gb + 62536 >> 2]) * Math_fround(.707106769));
   f5 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 4 >> 2]) * Math_fround(.707106769));
   f3 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 8 >> 2]) * Math_fround(.707106769));
   f4 = Math_fround(.707106769);
   break;
  }
 default:
  {
   f2 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f4 = Math_fround(1.0);
   f5 = Math_fround(0.0);
  }
 }
 f18 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f15 = Math_fround(f2 * f18);
 f17 = Math_fround(HEAPF32[i9 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f4 * f17));
 f16 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f3 * f16));
 f14 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f2 * f14) + Math_fround(Math_fround(f5 * f18) + Math_fround(f4 * f16))) - Math_fround(f3 * f17));
 f12 = Math_fround(Math_fround(Math_fround(f5 * f17) + Math_fround(Math_fround(f3 * f18) + Math_fround(f4 * f14))) - Math_fround(f2 * f16));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f4 * f18) - Math_fround(f2 * f17)) - Math_fround(f5 * f16)) - Math_fround(f3 * f14));
 HEAPF32[i8 >> 2] = Math_fround(f15 - Math_fround(f5 * f14));
 HEAPF32[i8 + 4 >> 2] = f13;
 HEAPF32[i8 + 8 >> 2] = f12;
 HEAPF32[i8 + 12 >> 2] = f4;
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i6, i7, i8);
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 200 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 200 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx26PxSceneDescGeneratedValuesC2EPKNS_11PxSceneDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP8[i2 >> 0] = (__ZNK5physx11PxSceneDesc7isValidEv(i1) | 0) & 1;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 44 >> 2];
 i3 = i2 + 52 | 0;
 i4 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i2 + 88 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i2 + 92 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i2 + 100 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP16[i2 + 104 >> 1] = HEAP16[i1 + 100 >> 1] | 0;
 HEAP32[i2 + 108 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 112 >> 2] = HEAP32[i1 + 108 >> 2];
 HEAP32[i2 + 116 >> 2] = HEAP32[i1 + 112 >> 2];
 HEAP32[i2 + 120 >> 2] = HEAP32[i1 + 116 >> 2];
 HEAP32[i2 + 124 >> 2] = HEAP32[i1 + 120 >> 2];
 HEAP32[i2 + 128 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i2 + 136 >> 2] = HEAP32[i1 + 132 >> 2];
 HEAP32[i2 + 140 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i2 + 144 >> 2] = HEAP32[i1 + 140 >> 2];
 HEAP32[i2 + 148 >> 2] = HEAP32[i1 + 144 >> 2];
 HEAP32[i2 + 152 >> 2] = HEAP32[i1 + 148 >> 2];
 HEAP32[i2 + 156 >> 2] = HEAP32[i1 + 152 >> 2];
 HEAP32[i2 + 160 >> 2] = HEAP32[i1 + 156 >> 2];
 HEAP32[i2 + 164 >> 2] = HEAP32[i1 + 160 >> 2];
 HEAP32[i2 + 168 >> 2] = HEAP32[i1 + 164 >> 2];
 HEAP32[i2 + 172 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP32[i2 + 176 >> 2] = HEAP32[i1 + 172 >> 2];
 HEAP32[i2 + 180 >> 2] = HEAP32[i1 + 176 >> 2];
 HEAP32[i2 + 184 >> 2] = HEAP32[i1 + 180 >> 2];
 return;
}

function __ZN14CompressedMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843803 | 0, gb + 899432 | 0, i1, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425891 | 0, gb + 899432 | 0, i3, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 56 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425913 | 0, gb + 899432 | 0, i3, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 104 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425902 | 0, gb + 899432 | 0, i3, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1 + 180 | 0, gb + 426158 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1 + 84 | 0, gb + 426168 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1 + 132 | 0, gb + 426182 | 0, 0);
 i3 = i1 + 152 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426197 | 0, gb + 899432 | 0, i3, 0);
 __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1 + 200 | 0, gb + 426211 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i2, i1 + 220 | 0, gb + 426225 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426237 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 240 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12HingeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803251 | 0, i6, i1 + 112 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803262 | 0, gb + 803270 | 0, i7, 0);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803306 | 0, i5, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803319 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802926 | 0, i6, i1 + 113 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 104 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801437 | 0, gb + 801451 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801470 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801483 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i9 = i13;
 i10 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
 i11 = (i10 | 0) == 0;
 if (!i11) __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
 if (i8 | 0) {
  i5 = 0;
  do {
   i4 = i7 + (i5 * 12 | 0) + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i12 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i9);
      i2 = HEAP32[i6 >> 2] | 0;
      i14 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i12 = 16;
     }
    }
    if ((i12 | 0) == 14) i12 = 16;
    if ((i12 | 0) == 16) {
     i12 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    if ((HEAP16[gb + 1165860 + 6 >> 1] | 0) > -1) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
     __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165860 | 0, i6);
     i2 = gb + 1165860 | 0;
    } else i2 = 0;
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
    if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i8 | 0));
 }
 if (i11) {
  STACKTOP = i13;
  return;
 }
 __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i10);
 STACKTOP = i13;
 return;
}

function __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 HEAP8[i9 + 868 >> 0] = 1;
 i7 = HEAP32[i9 + 16 >> 2] | 0;
 i6 = i7 & 2147483647;
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 i7 = i7 << 2;
 i8 = i10 << 2;
 i3 = 0;
 do {
  i4 = i9 + 240 + (i3 * 20 | 0) | 0;
  i5 = i9 + 240 + (i3 * 20 | 0) + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i5 >> 2] = i6;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i7, 4, i9 + 240 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 4, i9 + 240 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i9 + 240 + (i3 * 20 | 0) + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i4 >> 2] = i1;
   i1 = i6;
   break;
  } while (0);
  i2 = i9 + 240 + (i3 * 20 | 0) + 12 | 0;
  HEAP32[i2 >> 2] = i10;
  do if ((i1 & 2147483647) >>> 0 < i10 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i5 >> 2] = i10;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i8, 4, i9 + 240 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 4, i9 + 240 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i10;
   HEAP32[i4 >> 2] = i1;
   break;
  } while (0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 3);
 if (!i10) return;
 i3 = HEAP32[i9 + 240 >> 2] | 0;
 i4 = HEAP32[i9 + 260 >> 2] | 0;
 i2 = HEAP32[i9 + 280 >> 2] | 0;
 i1 = 0;
 do {
  i9 = i3 + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i9 = i4 + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = 1065353216;
  HEAP32[i9 + 4 >> 2] = 1065353216;
  HEAP32[i9 + 8 >> 2] = 1065353216;
  HEAP32[i9 + 12 >> 2] = 1065353216;
  i9 = i2 + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 return;
}

function __Z33InitializeWebGLPersistentDataPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 56 | 0;
 i8 = i2 + 40 | 0;
 i6 = i2 + 24 | 0;
 i4 = i2 + 12 | 0;
 i5 = i2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i3, i1, 0, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i1, 63, 0) | 0, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i3, 0, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i3, 47, -1) | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i9 = HEAP8[i3 + 11 >> 0] | 0;
 i7 = i9 << 24 >> 24 < 0;
 __Z3md5PhiS_(i7 ? HEAP32[i3 >> 2] | 0 : i3, i7 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255, i8);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 363891 | 0, 7);
 __Z11MD5ToStringPh(i5, i8);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = HEAP8[i4 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i8 = i9 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
 i7 = i5 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i1 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i6, i9 ? HEAP32[i4 >> 2] | 0 : i4, i8, i1 + i8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(gb + 1103752 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(gb + 1103752 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 200 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 200 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture(i6, i7, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i8 = i12;
 i2 = (i7 | 0) == 0;
 if (i2 & (i11 | 0) != 0) {
  f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0) | 0);
  f1 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0) | 0);
  i2 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (!i2) {
   f4 = Math_fround(0.0);
   f5 = Math_fround(0.0);
  } else {
   __ZNK6Camera18GetRenderRectangleEv(i10, i2);
   f4 = Math_fround(HEAPF32[i10 >> 2]);
   f5 = Math_fround(HEAPF32[i10 + 4 >> 2]);
   f3 = Math_fround(HEAPF32[i10 + 8 >> 2]);
   f1 = Math_fround(HEAPF32[i10 + 12 >> 2]);
  }
  f13 = Math_fround(f4 + Math_fround(.5));
  i9 = f13 >= Math_fround(0.0);
  f14 = Math_fround(f13 + Math_fround(-.99999994));
  i9 = ~~(i9 ? f13 : f14);
  f14 = Math_fround(f5 + Math_fround(.5));
  i10 = f14 >= Math_fround(0.0);
  f13 = Math_fround(f14 + Math_fround(-.99999994));
  i10 = ~~(i10 ? f14 : f13);
  __ZN13RenderTexture10GrabPixelsEiiii(i11, i9, i10, (~~Math_fround(Math_fround(f4 + f3) + Math_fround(.5)) >>> 0) - i9 | 0, (~~Math_fround(Math_fround(f5 + f1) + Math_fround(.5)) >>> 0) - i10 | 0);
  STACKTOP = i12;
  return;
 }
 if (i2) i9 = 8; else if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 124 >> 2] | 0, i7 | 0) | 0) i2 = __ZN12ImageFilters24GetBlitCopyDepthMaterialEv() | 0; else i9 = 8;
 if ((i9 | 0) == 8) i2 = __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 i15 = HEAP32[i2 + 100 >> 2] | 0;
 i9 = __ZN8Material9GetShaderEv(i2) | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1110892 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 i10 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i10) | 0;
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_(i6, i7, i11, i15, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, i9, -1, i10 ? 3 : 1, -1, gb + 62472 | 0, gb + 1162356 | 0);
 STACKTOP = i12;
 return;
}

function __ZL22SRGB_LinearToGamma_JobP17ImageSliceJobDataj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i8 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 if ((i4 | 0) >= (i8 | 0)) return;
 i7 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 do {
  i2 = 0;
  i3 = i7 + (Math_imul(i6, i4) | 0) | 0;
  while (1) {
   i1 = i3 + 4 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(0.0))) {
    if (f5 <= Math_fround(.00313080009)) {
     f5 = Math_fround(f5 * Math_fround(12.9200001));
     break;
    }
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f5, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, .454545468));
   } else f5 = Math_fround(0.0); while (0);
   HEAPF32[i1 >> 2] = f5;
   i1 = i3 + 8 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(0.0))) {
    if (f5 <= Math_fround(.00313080009)) {
     f5 = Math_fround(f5 * Math_fround(12.9200001));
     break;
    }
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f5, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, .454545468));
   } else f5 = Math_fround(0.0); while (0);
   HEAPF32[i1 >> 2] = f5;
   i1 = i3 + 12 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(0.0))) {
    if (f5 <= Math_fround(.00313080009)) {
     f5 = Math_fround(f5 * Math_fround(12.9200001));
     break;
    }
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(Math_fround(Math_fround(+Math_pow(+f5, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, .454545468));
   } else f5 = Math_fround(0.0); while (0);
   HEAPF32[i1 >> 2] = f5;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i9 | 0)) break; else i3 = i3 + 16 | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i8 | 0));
 return;
}

function __ZN9Rigidbody8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 68 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 76 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 83 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 84 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 102 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 24 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 658514 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 24 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i10 = i1 + 12 | 0;
   i11 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 * 24 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + (i1 * 24 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + (i1 * 24 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i11 = i4 + (i1 * 24 | 0) + 12 | 0;
 i10 = i6 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i11 = HEAP32[i5 >> 2] | 0;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i4 + (i11 * 24 | 0) | 0;
  return i11 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i11 = HEAP32[i5 >> 2] | 0;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i4 + (i11 * 24 | 0) | 0;
  return i11 | 0;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i11 = HEAP32[i5 >> 2] | 0;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i4 + (i11 * 24 | 0) | 0;
 return i11 | 0;
}

function __ZN5physx14PxsAABBManager19removeAggregatePairEjj(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i6 = i1 >>> 0 < i2 >>> 0;
 i7 = i6 ? i1 : i2;
 i6 = i6 ? i2 : i1;
 i11 = i8 + 49860 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i9 = i8 + 49856 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = 0;
 while (1) {
  if ((HEAP32[i1 + (i3 * 12 | 0) >> 2] | 0) == (i7 | 0)) if ((HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] | 0) == (i6 | 0)) break;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i4 = 24;
   break;
  }
 }
 if ((i4 | 0) == 24) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i5 = HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] | 0;
 if (i5) {
  i2 = HEAP32[i8 + 24 >> 2] | 0;
  i1 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
  if (!(i1 & 1)) i4 = 0; else i4 = (HEAP32[i8 + 180 >> 2] | 0) + ((i1 >>> 1) * 1048 | 0) | 0;
  i1 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
  if (!(i1 & 1)) i2 = 0; else i2 = (HEAP32[i8 + 180 >> 2] | 0) + ((i1 >>> 1) * 1048 | 0) | 0;
  i1 = (i2 | 0) != 0;
  do if (!i4) {
   if (i1) __ZN5physx14PxsAABBManager25removeAggregateSinglePairEjPNS_9AggregateEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i8, i7, i2, i5);
  } else if (i1) {
   __ZN5physx14PxsAABBManager28removeAggregateAggregatePairEPNS_9AggregateES2_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i8, i4, i2, i5);
   break;
  } else {
   __ZN5physx14PxsAABBManager25removeAggregateSinglePairEjPNS_9AggregateEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i8, i6, i4, i5);
   break;
  } while (0);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) if ((HEAP32[i2 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 8 | 0, i1);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] = 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i10 = i1 + (i3 * 12 | 0) | 0;
 i9 = i2 + -1 | 0;
 HEAP32[i11 >> 2] = i9;
 i11 = i1 + (i9 * 12 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN19SpriteMeshGenerator10FindBoundsER5RectTIfE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f10 = f0, i11 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i8 = i6;
 i7 = i5;
 if ((i5 | 0) == (i6 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i6 = (i8 | 0) == (i7 | 0);
 do if (i6) {
  i3 = i8;
  i4 = i8;
  i2 = i8;
  i1 = i8;
 } else {
  i1 = i8 + 68 | 0;
  if ((i1 | 0) == (i7 | 0)) i1 = i8; else {
   i2 = i1;
   i1 = i8;
   i3 = i8;
   do {
    f10 = Math_fround(HEAPF32[i2 + 28 >> 2]);
    i5 = f10 < Math_fround(HEAPF32[i3 + 28 >> 2]);
    i1 = i5 ? i2 : i1;
    i3 = i5 ? i2 : i3;
    i2 = i2 + 68 | 0;
   } while ((i2 | 0) != (i7 | 0));
   if (i6) {
    i3 = i8;
    i4 = i8;
    i2 = i8;
    break;
   }
  }
  i2 = i8 + 68 | 0;
  if ((i2 | 0) == (i7 | 0)) i5 = i8; else {
   i5 = i8;
   i3 = i8;
   do {
    f10 = Math_fround(HEAPF32[i2 + 32 >> 2]);
    i4 = f10 < Math_fround(HEAPF32[i3 + 32 >> 2]);
    i5 = i4 ? i2 : i5;
    i3 = i4 ? i2 : i3;
    i2 = i2 + 68 | 0;
   } while ((i2 | 0) != (i7 | 0));
   if (i6) {
    i3 = i8;
    i4 = i8;
    i2 = i5;
    break;
   }
  }
  i2 = i8 + 68 | 0;
  if ((i2 | 0) == (i7 | 0)) i6 = i8; else {
   i4 = i8;
   i3 = i8;
   do {
    f10 = Math_fround(HEAPF32[i3 + 36 >> 2]);
    i11 = f10 < Math_fround(HEAPF32[i2 + 36 >> 2]);
    i4 = i11 ? i2 : i4;
    i3 = i11 ? i2 : i3;
    i2 = i2 + 68 | 0;
   } while ((i2 | 0) != (i7 | 0));
   if (i6) {
    i3 = i8;
    i2 = i5;
    break;
   } else i6 = i4;
  }
  i2 = i8 + 68 | 0;
  if ((i2 | 0) == (i7 | 0)) {
   i3 = i8;
   i4 = i6;
   i2 = i5;
  } else {
   i3 = i8;
   i4 = i8;
   do {
    f10 = Math_fround(HEAPF32[i4 + 40 >> 2]);
    i11 = f10 < Math_fround(HEAPF32[i2 + 40 >> 2]);
    i3 = i11 ? i2 : i3;
    i4 = i11 ? i2 : i4;
    i2 = i2 + 68 | 0;
   } while ((i2 | 0) != (i7 | 0));
   i4 = i6;
   i2 = i5;
  }
 } while (0);
 i11 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i9 >> 2] = i11;
 f10 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 HEAPF32[i9 + 8 >> 2] = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i11 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i9 + 4 >> 2] = i11;
 f10 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 HEAPF32[i9 + 12 >> 2] = Math_fround(f10 - (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i11 = 1;
 return i11 | 0;
}

function __ZN13SparseTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl17getPropertiesImplEN5physx8debugger18NonNegativeIntegerERPNS2_19PropertyDescriptionERjS7_(i2, i1, i9, i8, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if ((i1 | 0) <= -1) {
  i10 = 0;
  return i10 | 0;
 }
 if ((HEAP32[i2 + 128 >> 2] | 0) <= (i1 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i4 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i4) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if ((i1 | 0) > -1) i7 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl17getPropertiesImplEN5physx8debugger18NonNegativeIntegerERPNS2_19PropertyDescriptionERjS7_(i2, i1, i9, i8, i10) | 0; else i7 = 0;
 i2 = HEAP32[i4 + 88 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i5 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
 i3 = HEAP32[i8 >> 2] | 0;
 i6 = i2 - i5 | 0;
 i6 = i3 >>> 0 < i6 >>> 0 ? i3 : i6;
 if (i6) {
  i4 = i4 + 84 | 0;
  i2 = -2 - i2 - ~(i1 >>> 0 > i2 >>> 0 ? i2 : i1) | 0;
  i1 = ~i3;
  i1 = ~(i2 >>> 0 > i1 >>> 0 ? i2 : i1);
  i2 = 0;
  do {
   i3 = HEAP32[i9 >> 2] | 0;
   i12 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + i5 << 2) >> 2] | 0;
   i11 = i12 + 4 | 0;
   i13 = HEAP32[i11 + 4 >> 2] | 0;
   i14 = i3 + (i2 * 52 | 0) + 4 | 0;
   HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   HEAP32[i3 + (i2 * 52 | 0) + 12 >> 2] = HEAP32[i12 + 12 >> 2];
   i14 = i12 + 16 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i11 = i3 + (i2 * 52 | 0) + 16 | 0;
   HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i11 + 4 >> 2] = i13;
   HEAP32[i3 + (i2 * 52 | 0) + 24 >> 2] = HEAP32[i12 + 24 >> 2];
   i11 = i3 + (i2 * 52 | 0) + 28 | 0;
   i13 = i12 + 28 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i3 + (i2 * 52 | 0) + 40 >> 2] = HEAP32[i12 + 40 >> 2];
   i12 = i12 + 44 | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i3 + (i2 * 52 | 0) + 44 | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = i11;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1 - i5;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i6;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (i6 * 52 | 0);
 i14 = i6 + i7 | 0;
 return i14 | 0;
}

function __ZN9DepthPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceDatab(i10, i1, i11, i12, i13, i3) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i10 + 40 | 0;
 i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i9 = __Z18GetQualitySettingsv() | 0;
 HEAP32[i10 + 104 >> 2] = HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + ((HEAP32[i9 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2];
 if ((HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0) == 0 | i3) i1 = 0; else i1 = HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] ^ 1;
 HEAP8[i10 + 108 >> 0] = i1;
 HEAP8[i10 + 109 >> 0] = 1;
 i2 = i10 + 12 | 0;
 i9 = i11 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i10 + 28 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 8, i10 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 8, i10 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i10 + 24 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
  }
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if (!i1) return;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = i2;
 do {
  i5 = i8 + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i6 = i7 + (i4 * 360 | 0) | 0;
  i7 = HEAP32[i7 + (i4 * 360 | 0) + 244 >> 2] | 0;
  if ((i7 | 0) > 0) {
   i2 = i8 + 18 | 0;
   i3 = i8 + 20 | 0;
   __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i10, i4, i6, HEAPU16[i2 >> 1] | 0, Math_fround(HEAPF32[i3 >> 2]), i13);
   if ((i7 | 0) != 1) {
    i1 = 1;
    do {
     __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i10, HEAP32[i5 >> 2] | 0, i6, HEAPU16[i2 >> 1] | 0, Math_fround(HEAPF32[i3 >> 2]), i13);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i7 | 0));
   }
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i8 = i8 + 32 | 0;
 } while ((i8 | 0) != (i2 + (i1 << 5) | 0));
 return;
}

function __ZN9Animation8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9);
 __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 280 | 0, i9);
 i5 = i8 + 284 | 0;
 i7 = i8 + 288 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 - i1 >> 2;
 HEAP32[i12 >> 2] = i6;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 36 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i8 + 40 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i8 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i1 >> 2] = i12;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 288 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 288 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 108 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 108 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN2UI16PointInRectangleERK8Vector2fPNS_13RectTransformEP6Camera(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10;
 if (!i2) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = __ZNK2UI13RectTransform7GetRectEv(i2) | 0;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 HEAPF32[i7 >> 2] = f14;
 HEAPF32[i7 + 4 >> 2] = f11;
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 f13 = Math_fround(f11 + f13);
 HEAPF32[i7 + 12 >> 2] = f14;
 HEAPF32[i7 + 16 >> 2] = f13;
 HEAPF32[i7 + 20 >> 2] = Math_fround(0.0);
 f12 = Math_fround(f14 + f12);
 HEAPF32[i7 + 24 >> 2] = f12;
 HEAPF32[i7 + 28 >> 2] = f13;
 HEAPF32[i7 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 36 >> 2] = f12;
 HEAPF32[i7 + 40 >> 2] = f11;
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i2, i7);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i3 = i7 + 12 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i2, i3);
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i4 = i7 + 24 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i2, i4);
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i5 = i7 + 36 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i2, i5);
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 if (!i6) {
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i1 = Math_fround(__ZN2UI19DistanceToRectangleEP8Vector3f8Vector2f(i7, i9)) == Math_fround(0.0);
 } else {
  __ZNK6Camera16ScreenPointToRayERK8Vector2f(i8, i6, i1);
  if (__Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_(i8, i7, i3, i4) | 0) i1 = 1; else i1 = __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_(i8, i7, i4, i5) | 0;
 }
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN14CellVisualizer7executeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 16 | 0;
 i14 = i16;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 i15 = i5 + 12 | 0;
 HEAP32[i15 >> 2] = -1;
 HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
 if (!(__ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE(i4, i5) | 0)) {
  STACKTOP = i16;
  return;
 }
 i6 = i4 + 1640 | 0;
 i7 = i4 + 4 | 0;
 i8 = i4 + 1648 | 0;
 i9 = i4 + 1644 | 0;
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 i12 = i14 + 12 | 0;
 i13 = i5 + 16 | 0;
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  do if (i3 | 0) {
   i2 = i2 - (__ZNK5Umbra6KDTree4rankEi(i7, i2) | 0) | 0;
   i17 = HEAP32[i1 + 24 >> 2] & 31;
   i2 = Math_imul(i17, i2) | 0;
   i3 = i1 + i3 + (i2 >> 5 << 2) | 0;
   i18 = i3 + 4 | 0;
   i1 = i2 & 31;
   i2 = (1 << i17) + -1 | 0;
   i1 = ((HEAPU8[i18 >> 0] | HEAPU8[i18 + 1 >> 0] << 8 | HEAPU8[i18 + 2 >> 0] << 16 | HEAPU8[i18 + 3 >> 0] << 24) << 32 - i1 & -1 << (i1 ^ 31) | (HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24) >>> i1) & i2;
   if (i1 & 1 << i17 + -1) if ((i1 | 0) == (i2 | 0)) break; else i1 = i1 & i2 >>> 1 | -2147483648;
   if ((i1 | 0) != -1) {
    if ((i1 | 0) < 0) {
     if (!(__ZN14CellVisualizer21containsCellRecursiveEii(i4, i1 & 2147483647, HEAP32[i8 >> 2] | 0) | 0)) break;
    } else if ((i1 | 0) != (HEAP32[i8 >> 2] | 0)) break;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAPF32[i14 >> 2] = Math_fround(.5);
    HEAPF32[i10 >> 2] = Math_fround(.5);
    HEAPF32[i11 >> 2] = Math_fround(.5);
    HEAPF32[i12 >> 2] = Math_fround(.5);
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
    if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i5 | 0, i13 | 0, i14 | 0);
   }
  } while (0);
 } while (__ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE(i4, i5) | 0);
 STACKTOP = i16;
 return;
}

function __ZN7ApiGLES12CheckProgramERj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i3 = i10 + 40 | 0;
 i4 = i10 + 36 | 0;
 i5 = i10 + 24 | 0;
 i6 = i10 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i8 + 92 | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0, 35714, i3 | 0);
 if ((HEAP32[i3 >> 2] | 0) == 1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0, 35716, i4 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __Z6FormatPKcz(i5, gb + 599842 | 0, i10 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 599732 | 0, 749, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 } else {
  HEAP32[i5 >> 2] = 0;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i2 = __Znwj(i1) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 8 >> 2] = i2 + i1;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
   HEAP32[i3 >> 2] = i2;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
  mftCall_viiii(HEAP32[i8 + 528 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0, HEAP32[i5 >> 2] | 0);
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  __Z6FormatPKcz(i6, gb + 599811 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 599732 | 0, 746, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
   __ZdlPv(i1);
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 switch (i1 | 0) {
 case -1:
 case 0:
  break;
 default:
  {
   i2 = i8 + 868 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i8 + 872 >> 2] = 0;
    mftCall_vi(HEAP32[i8 + 516 >> 2] | 0, 0);
    i1 = HEAP32[i9 >> 2] | 0;
   }
   mftCall_vi(HEAP32[i8 + 508 >> 2] | 0, i1 | 0);
   HEAP32[i9 >> 2] = -1;
  }
 }
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN23TextDOMTransferReadBaseI8JSONReadE14BeginMetaGroupEPKc(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i3 = i9 + 64 | 0;
 i12 = i9 + 40 | 0;
 i4 = i9 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i9 + 80 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = i8 & 2147483647;
 do if (i6 >>> 0 > i2 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i2 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i9 + 68 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 68 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i12 >> 2];
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if ((i1 & 255 | 0) == 3) {
  i1 = i10;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i11 + 16 >> 2] = 1048581;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i11 + 4 >> 2] = i1 - i10;
  i10 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i2, i11) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i11);
  i11 = (i10 | 0) == ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 48 | 0) | 0) ? 0 : i10 + 24 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 } else {
  if ((i1 | 0) != 4) {
   i11 = 0;
   HEAP32[i12 >> 2] = i11;
   STACKTOP = i13;
   return;
  }
  i10 = (HEAP32[i9 + 152 >> 2] | 0) + ((HEAP32[i9 + 164 >> 2] | 0) + -1 << 2) | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i11 + 1;
  i11 = (HEAP32[i2 >> 2] | 0) + (i11 * 24 | 0) | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
}

function __ZN15CarveDataArrays8PushBackERK16NavMeshCarveData(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i2 + 12 | 0;
 i5 = i2 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i2 + 28 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i7 >>> 0 > i10 >>> 0) {
  i1 = i9 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 * 88 | 0, 4, i2 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 88 | 0, 4, i2 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 88 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 + (i6 * 88 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 32 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 36 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 40 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 44 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 48 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 52 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 56 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 60 >> 2] = HEAP32[i3 + 60 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 64 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 68 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 72 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 80 >> 2] = HEAP32[i3 + 80 >> 2];
 HEAP32[i10 + (i6 * 88 | 0) + 84 >> 2] = HEAP32[i3 + 84 >> 2];
 return;
}

function __ZNK26AnimatorOverrideController17GetAnimationClipsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i2) | 0;
 i12 = i2 + 132 | 0;
 i13 = i2 + 148 | 0;
 if ((HEAP32[i13 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i2 + 136 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 HEAP32[i12 >> 2] = 0;
 i14 = i2 + 144 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 i15 = i11 + 12 | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (!i1) return i12 | 0;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1 << 2, 4, i2 + 136 | 0, 0, gb + 1047584 | 0, 464) | 0;
 if (!(HEAP32[i15 >> 2] | 0)) return i12 | 0;
 i9 = i2 + 84 | 0;
 i10 = i2 + 96 | 0;
 i8 = i2 + 136 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 do {
  i1 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i3 = i1 + (i6 << 3) | 0;
  L12 : do if (!i6) i16 = 11; else {
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
     i16 = 11;
     break L12;
    }
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != (i3 | 0));
  } while (0);
  do if ((i16 | 0) == 11) {
   i16 = 0;
   if ((i1 | 0) == (i3 | 0)) {
    i2 = HEAP32[i7 >> 2] | 0;
    break;
   } else {
    i2 = __Z16return_effectiveRK21AnimationClipOverride(i1) | 0;
    break;
   }
  } while (0);
  i3 = HEAP32[i14 >> 2] | 0;
  i4 = i3 + 1 | 0;
  i5 = HEAP32[i13 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i4 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i13 >> 2] = i1;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
    HEAP32[i13 >> 2] = i1;
    HEAP32[i12 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i14 >> 2] = i4;
  HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i2;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i15 >> 2] << 2) | 0));
 return i12 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim21visualizeInteractionsERNS_2Cm12RenderOutputE(i1, i24) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 56 | 0;
 i19 = i25 + 40 | 0;
 i20 = i25 + 28 | 0;
 i21 = i25;
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsEj(i24, -16711936) | 0, 1) | 0;
 i22 = i1 + 360 | 0;
 i2 = HEAP32[i22 >> 2] | 0;
 if (!i2) {
  STACKTOP = i25;
  return;
 }
 i16 = i1 + 356 | 0;
 i17 = i23 + 12 | 0;
 i18 = i23 + 4 | 0;
 i6 = i23 + 16 | 0;
 i7 = i23 + 8 | 0;
 i8 = i23 + 20 | 0;
 i9 = i19 + 4 | 0;
 i10 = i19 + 8 | 0;
 i11 = i21 + 16 | 0;
 i12 = i20 + 4 | 0;
 i13 = i21 + 20 | 0;
 i14 = i20 + 8 | 0;
 i15 = i21 + 24 | 0;
 i5 = 0;
 do {
  i3 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = HEAP32[i3 + 36 >> 2] | 0;
  i26 = HEAP16[i3 + 42 >> 1] | 0;
  i4 = i1 + ((i26 & 65535) << 2) | 0;
  if (i26 << 16 >> 16) {
   i2 = i3 + 44 | 0;
   do {
    i3 = HEAP32[i1 >> 2] | 0;
    i26 = HEAP32[i2 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i26 >> 2] | 0) + 8 >> 2] | 0, i23 | 0, i26 | 0);
    f29 = Math_fround(HEAPF32[i23 >> 2]);
    f29 = Math_fround(f29 + Math_fround(HEAPF32[i17 >> 2]));
    f28 = Math_fround(HEAPF32[i18 >> 2]);
    f28 = Math_fround(f28 + Math_fround(HEAPF32[i6 >> 2]));
    f27 = Math_fround(HEAPF32[i7 >> 2]);
    f28 = Math_fround(f28 * Math_fround(.5));
    f27 = Math_fround(Math_fround(f27 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
    HEAPF32[i19 >> 2] = Math_fround(f29 * Math_fround(.5));
    HEAPF32[i9 >> 2] = f28;
    HEAPF32[i10 >> 2] = f27;
    i26 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i24, i19) | 0;
    __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i21, HEAP32[i3 + 36 >> 2] | 0);
    HEAP32[i20 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
    __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i26, i20) | 0;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
   i2 = HEAP32[i22 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i2 >>> 0);
 STACKTOP = i25;
 return;
}

function __ZN5physx2Gu25computeCapsule_CapsuleMTDERKNS0_7CapsuleES3_RNS_10PxSweepHitE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i4 + 4 | 0;
 i17 = i4;
 Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i1, i2, i18, i17));
 f12 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f12 + f8);
 f9 = Math_fround(HEAPF32[i18 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f7 - f11);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f6 - f16);
 f14 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(f11 + Math_fround(f9 * f7));
 f6 = Math_fround(f16 + Math_fround(f9 * f6));
 f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(f14 - f5)));
 f14 = Math_fround(HEAPF32[i17 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f9 - f16);
 f11 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(f11 - f15);
 f13 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f16 + Math_fround(f14 * f9));
 f11 = Math_fround(f15 + Math_fround(f14 * f11));
 f10 = Math_fround(f10 + Math_fround(f14 * Math_fround(f13 - f10)));
 f7 = Math_fround(f7 - f9);
 f6 = Math_fround(f6 - f11);
 f5 = Math_fround(f5 - f10);
 f13 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5))));
 f14 = Math_fround(Math_fround(1.0) / f13);
 f7 = Math_fround(f7 * f14);
 f6 = Math_fround(f14 * f6);
 f5 = Math_fround(f14 * f5);
 HEAPF32[i3 + 28 >> 2] = f7;
 HEAPF32[i3 + 32 >> 2] = f6;
 HEAPF32[i3 + 36 >> 2] = f5;
 HEAPF32[i3 + 40 >> 2] = Math_fround(f13 - f12);
 f6 = Math_fround(f11 + Math_fround(f8 * f6));
 f5 = Math_fround(f10 + Math_fround(f8 * f5));
 HEAPF32[i3 + 16 >> 2] = Math_fround(f9 + Math_fround(f8 * f7));
 HEAPF32[i3 + 20 >> 2] = f6;
 HEAPF32[i3 + 24 >> 2] = f5;
 STACKTOP = i4;
 return 1;
}

function __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i8 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i8 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i3 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = (HEAP32[i12 >> 2] | 0) + 16 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 4) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = i3 - i4 | 0;
 i3 = i7 >> 3;
 i3 = i7 >> 4 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i7 = i5 + (i1 - i4 >> 4 << 4) | 0;
 i1 = i7;
 i4 = i5 + (i3 << 4) | 0;
 i3 = i7;
 i6 = i1;
 do {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  i3 = i6 + 16 | 0;
  i6 = i3;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) {
  i3 = i2 + -16 - i5 | 0;
  i1 = i2;
  i2 = i7;
  while (1) {
   i14 = i1;
   i1 = i1 + -16 | 0;
   HEAP32[i2 + -16 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + -12 >> 2] = HEAP32[i14 + -12 >> 2];
   HEAP32[i2 + -8 >> 2] = HEAP32[i14 + -8 >> 2];
   HEAP32[i2 + -4 >> 2] = HEAP32[i14 + -4 >> 2];
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + -16 | 0;
  }
  i1 = i7 + (~(i3 >>> 4) << 4) | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i11 >> 2] = i4;
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i10);
 STACKTOP = i13;
 return;
}

function __ZNK5physx2Gu11HeightField9getHeightEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0;
 i6 = f1 > Math_fround(0.0);
 f1 = i6 ? f1 : Math_fround(0.0);
 i6 = f2 > Math_fround(0.0);
 f2 = i6 ? f2 : Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f1 + Math_fround(1.0)))) * Math_fround(9.99999997e-07)));
 f5 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f2 + Math_fround(1.0)))) * Math_fround(9.99999997e-07)));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f4);
 f4 = f1 < f4 ? f1 : f4;
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) + f5);
 f5 = f2 < f5 ? f2 : f5;
 f2 = Math_fround(Math_floor(Math_fround(f4)));
 f4 = Math_fround(f4 - f2);
 f1 = Math_fround(Math_floor(Math_fround(f5)));
 f5 = Math_fround(f5 - f1);
 i6 = ~~Math_fround(f1 + Math_fround(f2 * Math_fround(HEAPF32[i3 + 32 >> 2]))) >>> 0;
 i7 = HEAP32[i3 + 36 >> 2] | 0;
 if ((HEAP8[i7 + (i6 << 2) + 2 >> 0] | 0) < 0) {
  f2 = Math_fround(HEAP16[i7 + (i6 << 2) >> 1] | 0);
  i3 = (HEAP32[i3 + 20 >> 2] | 0) + i6 | 0;
  f1 = Math_fround(HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0);
  if (f5 > f4) {
   f8 = Math_fround(HEAP16[i7 + (i6 + 1 << 2) >> 1] | 0);
   f5 = Math_fround(Math_fround(f4 * Math_fround(f1 - f8)) + Math_fround(f2 + Math_fround(f5 * Math_fround(f8 - f2))));
   return Math_fround(f5);
  } else {
   f8 = Math_fround(HEAP16[i7 + (i3 << 2) >> 1] | 0);
   f8 = Math_fround(Math_fround(f5 * Math_fround(f1 - f8)) + Math_fround(f2 + Math_fround(f4 * Math_fround(f8 - f2))));
   return Math_fround(f8);
  }
 } else {
  i3 = (HEAP32[i3 + 20 >> 2] | 0) + i6 | 0;
  f1 = Math_fround(HEAP16[i7 + (i3 << 2) >> 1] | 0);
  f2 = Math_fround(HEAP16[i7 + (i6 + 1 << 2) >> 1] | 0);
  if (Math_fround(f4 + f5) < Math_fround(1.0)) {
   f8 = Math_fround(HEAP16[i7 + (i6 << 2) >> 1] | 0);
   f8 = Math_fround(Math_fround(f4 * Math_fround(f1 - f8)) + Math_fround(f8 + Math_fround(f5 * Math_fround(f2 - f8))));
   return Math_fround(f8);
  } else {
   f8 = Math_fround(HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0);
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f4) * Math_fround(f2 - f8)) + Math_fround(f8 + Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(f1 - f8))));
   return Math_fround(f8);
  }
 }
 return f0;
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 112 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 112 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5Umbra15BufferAllocator8allocateEib(i11, i3, i4) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = i11 + 136 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i9 = i11 + 132 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i6 - i2 | 0;
 L1 : do if ((i1 | 0) < (i3 | 0)) {
  i8 = i2;
  while (1) {
   if ((i8 | 0) <= 0) break;
   i2 = i8 + -1 | 0;
   if (HEAP32[i11 + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31) | 0) break;
   HEAP32[i9 >> 2] = i2;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i10 = 5;
    break L1;
   } else i8 = i2;
  }
  i7 = i6 >> 5;
  if ((i7 | 0) > 0) {
   i1 = 0;
   i6 = 0;
   i2 = 0;
  } else {
   i11 = 0;
   return i11 | 0;
  }
  L9 : while (1) {
   i4 = HEAP32[i11 + (i6 << 2) >> 2] | 0;
   if ((i2 | 0) >= (i3 | 0)) break;
   switch (i4 | 0) {
   case 0:
    {
     i4 = i1;
     i2 = i2 + 32 | 0;
     break;
    }
   case -1:
    {
     i4 = (i6 << 5) + 32 | 0;
     i2 = 0;
     break;
    }
   default:
    {
     while (1) {
      i12 = _llvm_cttz_i32(i4 | 0) | 0;
      i5 = i12 + i2 | 0;
      i2 = i4 >>> i12;
      if ((i5 | 0) >= (i3 | 0)) break L9;
      i12 = _llvm_cttz_i32(~i2 | 0) | 0;
      i4 = i2 >>> i12;
      i1 = i5 + i1 + i12 | 0;
      if (!i4) break; else i2 = 0;
     }
     i4 = i1;
     i2 = 0 - i1 & 31;
    }
   }
   i6 = i6 + 1 | 0;
   if ((i6 | 0) >= (i7 | 0)) {
    i1 = 0;
    i10 = 24;
    break;
   } else i1 = i4;
  }
  if ((i10 | 0) == 24) return i1 | 0;
  if ((i1 | 0) == -1) {
   i12 = 0;
   return i12 | 0;
  } else {
   i2 = i1 + i3 | 0;
   i2 = (i8 | 0) >= (i2 | 0) ? i8 : i2;
   i10 = 19;
   break;
  }
 } else i10 = 5; while (0);
 do if ((i10 | 0) == 5) if (i4) {
  i1 = i6 - i3 | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = i2;
  i2 = i2 + i3 | 0;
  i10 = 19;
  break;
 } while (0);
 if ((i10 | 0) == 19) {
  HEAP32[i9 >> 2] = i2;
  i5 = i1 + i3 | 0;
  i12 = i1 >> 5;
  i2 = i11 + (i12 << 2) | 0;
  i10 = i1 & 31;
  i4 = -1 << i10;
  if (!((i10 | 0) == 0 | (i12 | 0) == (i5 >> 5 | 0))) {
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i4;
   i2 = i2 + 4 | 0;
   i4 = -1;
   i3 = (i1 | -32) + i3 | 0;
  }
  i12 = i3 >> 5;
  _memset(i2 | 0, -1, i12 << 2 | 0) | 0;
  i2 = i2 + (i12 << 2) | 0;
  if (i3 & 31) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i4 & (1 << (i5 & 31)) + -1;
 }
 i12 = (i1 << 5) + (i11 + 144) | 0;
 return i12 | 0;
}

function __ZN7mecanim5human30HumanPoseAdjustForMissingBonesEPKNS0_5HumanEPNS0_9HumanPoseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 if ((HEAP32[i1 + 108 >> 2] | 0) < 0) {
  i3 = i2 + 620 | 0;
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i2 + 632 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i3 = i2 + 624 | 0;
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i2 + 636 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i3 = i2 + 628 | 0;
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  i4 = i2 + 640 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 104 >> 2] | 0) < 0) {
  i4 = i2 + 608 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i2 + 596 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i4 = i2 + 612 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i2 + 600 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i4 = i2 + 616 | 0;
  f5 = Math_fround(HEAPF32[i4 >> 2]);
  i3 = i2 + 604 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 116 >> 2] | 0) < 0) {
  i4 = i2 + 732 | 0;
  f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.150000006));
  i3 = i2 + 740 | 0;
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i4 = i2 + 736 | 0;
  f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.28125));
  i3 = i2 + 744 | 0;
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 120 >> 2] | 0) >= 0) return;
 i4 = i2 + 768 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.150000006));
 i3 = i2 + 776 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i4 = i2 + 772 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.28125));
 i3 = i2 + 780 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 return;
}

function __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 4);
 i5 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800723 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 40 | 0, i5);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i7 = i1 + 36 | 0;
 i6 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800741 | 0, gb + 800762 | 0, i7, i6);
 i6 = i8 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800780 | 0, i6, i1 + 44 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800793 | 0, i6, i1 + 48 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN18DelayedCallManager8ClearAllEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 i8 = i5 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i5 + 32 | 0;
 if ((i1 | 0) == (i9 | 0)) {
  i7 = HEAP32[i9 >> 2] | 0;
  __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i8, i7);
  i7 = i5 + 36 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 i2 = i1;
 while (1) {
  do if (HEAP32[i2 + 52 >> 2] & 64 | 0) {
   HEAP32[i7 >> 2] = HEAP32[i2 + 48 >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (i1 | 0) {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i3 = HEAP32[i6 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) != (i3 + (i4 << 3) | 0)) {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) break;
     mftCall_iii(HEAP32[i2 + 40 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
     break;
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  if (i1 | 0) mftCall_ii(i1 | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 i11 = HEAP32[i9 >> 2] | 0;
 __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i8, i11);
 i11 = i5 + 36 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN18AwakeFromLoadQueueD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 260 | 0;
 if ((HEAP32[i2 + 276 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 264 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 220 | 0;
 if ((HEAP32[i2 + 236 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 224 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 200 | 0;
 if ((HEAP32[i2 + 216 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 204 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 180 | 0;
 if ((HEAP32[i2 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 160 | 0;
 if ((HEAP32[i2 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 140 | 0;
 if ((HEAP32[i2 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 120 | 0;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z31RegisterModule_CloudWebServicesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 429;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 430;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 431;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 431;
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 36 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 36 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i5 = i3 + 24 | 0;
 i4 = i3 + 16 | 0;
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898314 | 0, i7, i1, 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 898347 | 0, i5, 0);
 __ZN11UnityEngine9Animation14GenericBinding8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898330 | 0, i7, i1 + 20 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37176 >> 2] | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z30RegisterModule_UnityWebRequestv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 382;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 383;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 384;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 384;
 STACKTOP = i5;
 return;
}

function __Z30RegisterModule_ParticlesLegacyv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 444;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 445;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 446;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 446;
 STACKTOP = i5;
 return;
}

function __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i10 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i11 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i11 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i8 = i7 + 72 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i7 + 60 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i11 = i6;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, gb + 1034188 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i7, i5); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (HEAP8[i5 + 128 >> 0] | 0) {
  i11 = i2 + 20 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i3 + 4 | 0;
  i5 = i3 + 12 | 0;
  HEAP32[i6 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + ((HEAP8[i3 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i1) >> 2];
  __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i4, i7, i6);
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[(HEAP32[i2 >> 2] | 0) + ((HEAP8[i3 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i11) >> 2] = HEAP32[i6 >> 2];
 }
 i1 = i7 + 56 | 0;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i8 = HEAP16[i11 >> 1] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i11 = i14;
 HEAP32[i11 >> 2] = i8 & 65535;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 15878;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj(i14, i13, i1, i2, i3, i4, i5, i15) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i15 = i15 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 switch (HEAP32[i15 >> 2] | 0) {
 case 1:
  {
   HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   return;
  }
 case 2:
  {
   f6 = Math_fround(HEAPF32[i13 >> 2]);
   f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
   f12 = Math_fround(HEAPF32[i13 + 8 >> 2]);
   f7 = Math_fround(HEAPF32[i13 + 16 >> 2]);
   f7 = Math_fround(f7 - f6);
   f8 = Math_fround(Math_fround(HEAPF32[i13 + 20 >> 2]) - f11);
   f9 = Math_fround(Math_fround(HEAPF32[i13 + 24 >> 2]) - f12);
   f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
   if (!(f10 <= Math_fround(1.1920929e-07))) {
    f10 = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f11 * f8)) - Math_fround(f6 * f7)) - Math_fround(f12 * f9)) / f10);
    i15 = f10 > Math_fround(1.0);
    f10 = i15 ? Math_fround(1.0) : f10;
    i15 = f10 > Math_fround(0.0);
    f10 = i15 ? f10 : Math_fround(0.0);
    f11 = Math_fround(f11 + Math_fround(f8 * f10));
    f12 = Math_fround(f12 + Math_fround(f9 * f10));
    HEAPF32[i14 >> 2] = Math_fround(f6 + Math_fround(f7 * f10));
    HEAPF32[i14 + 4 >> 2] = f11;
    HEAPF32[i14 + 8 >> 2] = f12;
    HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
    return;
   } else {
    HEAP32[i15 >> 2] = 1;
    HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
    HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
    HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
    return;
   }
  }
 case 3:
  {
   __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj(i14, i13, i1, i2, i3, i4, i15);
   return;
  }
 case 4:
  {
   __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj(i14, i13, i1, i2, i3, i4, i15);
   return;
  }
 default:
  {
   HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   return;
  }
 }
}

function __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 104 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN15DirectorManager12ExecuteStageE13DirectorStage(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 8 | 0;
 __ZN15DirectorManager31AddScheduledPlayableControllersEv(i8);
 __ZN15DirectorManager32StopScheduledPlayableControllersEv(i8);
 __ZN15DirectorManager23DestroyPendingPlayablesEv(0);
 i10 = i8 + 440 | 0;
 HEAP8[i10 >> 0] = 1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i1 = HEAP32[i8 + (i9 * 20 | 0) + 12 >> 2] | 0;
 if (i1 | 0) __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i7, fb + 3164 | 0, HEAP32[i8 + (i9 * 20 | 0) >> 2] | 0, i1, 0, 0);
 i2 = i8 + 140 + (i9 * 20 | 0) | 0;
 i3 = i8 + 140 + (i9 * 20 | 0) + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  do {
   i4 = i6;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i4 = i1 + 12 | 0;
   __ZN18PlayableController12PrepareFrameEP8PlayableRy(HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
   i5 = i1 + 16 | 0;
   i13 = i5;
   i12 = i6;
   if (!((HEAP32[i13 >> 2] | 0) == (HEAP32[i12 >> 2] | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (HEAP32[i12 + 4 >> 2] | 0) : 0)) {
    i13 = (__ZN18PlayableController12GetFrameDataEv(HEAP32[i1 >> 2] | 0) | 0) + 64 | 0;
    HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
    i13 = HEAP32[i1 + 4 >> 2] | 0;
    i14 = HEAP32[(HEAP32[i13 >> 2] | 0) + 144 >> 2] | 0;
    i12 = __ZN18PlayableController12GetFrameDataEv(HEAP32[i1 >> 2] | 0) | 0;
    mftCall_viiii(i14 | 0, i13 | 0, i12 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
    i4 = i6;
    i12 = HEAP32[i4 + 4 >> 2] | 0;
    i13 = i5;
    HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i13 + 4 >> 2] = i12;
   }
   i1 = i1 + 24 | 0;
  } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0));
 }
 if (HEAP32[i7 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i7);
 i1 = HEAP32[i8 + 280 + (i9 * 12 | 0) >> 2] | 0;
 i2 = i8 + 280 + (i9 * 12 | 0) + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 do {
  mftCall_vi(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 HEAP8[i10 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __Z29RegisterModule_UnityAnalyticsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 397;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 398;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 399;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 399;
 STACKTOP = i5;
 return;
}

function __Z29RegisterModule_TerrainPhysicsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 359;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 360;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 361;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 361;
 STACKTOP = i5;
 return;
}

function __Z29RegisterModule_ParticleSystemv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 200;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 201;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 202;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 202;
 STACKTOP = i5;
 return;
}

function __Z29RegisterModule_CrashReportingv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 400;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 401;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 402;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 402;
 STACKTOP = i5;
 return;
}

function __Z27GetDeepFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i9 + 44 | 0;
 i2 = i9 + 12 | 0;
 i8 = i9 + 24 | 0;
 i12 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i2, i12, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i7, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i1 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i12 = i6;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 i10 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i10, __ZNK15FileSystemEntry4PathEv(i7) | 0, i8, 1, 0) | 0;
 switch (i4 | 0) {
 case 0:
  {
   __ZNK10FileSystem16CurrentDirectoryEv(i6, __Z13GetFileSystemv() | 0);
   __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE(i6, i8, i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   break;
  }
 case 1:
  {
   __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE(i5, i8, i3);
   break;
  }
 case 2:
  {
   __ZL41FileEntryInfoListToFolderContentsAbsoluteRK13dynamic_arrayI13FileEntryInfoLj8EERNSt3__23setINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS4_4lessISB_EENS9_ISB_EEEE(i8, i3);
   break;
  }
 default:
  {}
 }
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  __ZN13FileEntryDataD2Ev(i7);
  STACKTOP = i9;
  return 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i2);
 HEAP32[i8 >> 2] = 0;
 __ZN13FileEntryDataD2Ev(i7);
 STACKTOP = i9;
 return 1;
}

function __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 132 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 132 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __Z28RegisterModule_TextRenderingv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 336;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 337;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 338;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 338;
 STACKTOP = i5;
 return;
}

function __Z28RegisterModule_JSONSerializev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 385;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 386;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 387;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 387;
 STACKTOP = i5;
 return;
}

function __ZN9rapidjson8internal8PrettifyEPcii(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = i1 + i3 | 0;
 if ((i1 | 0) > -1 & (i5 | 0) < 22) {
  if ((i1 | 0) > 0) {
   i2 = i3 + 1 | 0;
   _memset(i4 + i3 | 0, 48, ((i5 | 0) > (i2 | 0) ? i5 : i2) - i3 | 0) | 0;
  }
  HEAP8[i4 + i5 >> 0] = 46;
  HEAP8[i4 + (i5 + 1) >> 0] = 48;
  i5 = i4 + (i5 + 2) | 0;
  return i5 | 0;
 }
 i2 = i5 + -1 | 0;
 if (i2 >>> 0 < 21) {
  i2 = i4 + i5 | 0;
  _memmove(i4 + (i5 + 1) | 0, i2 | 0, 0 - i1 | 0) | 0;
  HEAP8[i2 >> 0] = 46;
  i5 = i4 + (i3 + 1) | 0;
  return i5 | 0;
 }
 if ((i5 + 5 | 0) >>> 0 < 6) {
  i1 = 2 - i5 | 0;
  _memmove(i4 + i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i4 >> 0] = 48;
  HEAP8[i4 + 1 >> 0] = 46;
  if ((i5 | 0) < 0) _memset(i4 + 2 | 0, 48, ((i1 | 0) > 3 ? i1 : 3) + -2 | 0) | 0;
  i5 = i4 + (i1 + i3) | 0;
  return i5 | 0;
 }
 if ((i3 | 0) == 1) {
  HEAP8[i4 + 1 >> 0] = 101;
  i1 = i4 + 2 | 0;
  if ((i2 | 0) < 0) {
   HEAP8[i1 >> 0] = 45;
   i2 = 1 - i5 | 0;
   i1 = i4 + 3 | 0;
  }
  if ((i2 | 0) > 99) {
   HEAP8[i1 >> 0] = ((i2 >>> 0) / 100 | 0) + 48;
   i5 = (((i2 >>> 0) % 100 | 0) << 1) + (gb + 1035599) | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
   i5 = i1 + 3 | 0;
   return i5 | 0;
  }
  if ((i2 | 0) > 9) {
   i5 = (i2 << 1) + (gb + 1035599) | 0;
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
   i5 = i1 + 2 | 0;
   return i5 | 0;
  } else {
   HEAP8[i1 >> 0] = i2 + 48;
   i5 = i1 + 1 | 0;
   return i5 | 0;
  }
 } else {
  i1 = i4 + 1 | 0;
  _memmove(i4 + 2 | 0, i1 | 0, i3 + -1 | 0) | 0;
  HEAP8[i1 >> 0] = 46;
  HEAP8[i4 + (i3 + 1) >> 0] = 101;
  i1 = i4 + (i3 + 2) | 0;
  if ((i2 | 0) < 0) {
   HEAP8[i1 >> 0] = 45;
   i2 = 1 - i5 | 0;
   i1 = i1 + 1 | 0;
  }
  if ((i2 | 0) > 99) {
   HEAP8[i1 >> 0] = ((i2 >>> 0) / 100 | 0) + 48;
   i5 = (((i2 >>> 0) % 100 | 0) << 1) + (gb + 1035599) | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
   i5 = i1 + 3 | 0;
   return i5 | 0;
  }
  if ((i2 | 0) > 9) {
   i5 = (i2 << 1) + (gb + 1035599) | 0;
   HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
   i5 = i1 + 2 | 0;
   return i5 | 0;
  } else {
   HEAP8[i1 >> 0] = i2 + 48;
   i5 = i1 + 1 | 0;
   return i5 | 0;
  }
 }
 return 0;
}

function __ZN7dtCrowd5purgeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i2 = i3 + 12 | 0;
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i5 = HEAP32[i2 >> 2] | 0;
   i4 = i5 + (i1 * 608 | 0) + 28 | 0;
   __Z6dtFreePv(HEAP32[i4 >> 2] | 0);
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 + (i1 * 608 | 0) + 32 >> 2] = 0;
   HEAP32[i5 + (i1 * 608 | 0) + 36 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 408 >> 2] = 0;
 i1 = i3 + 20 | 0;
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 24 | 0;
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 372 | 0;
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 456 | 0;
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 460 >> 2] = 0;
 i1 = i3 + 368 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z6dtFreePv(HEAP32[i2 + 20 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i2 + 8 >> 2] | 0);
  __Z6dtFreePv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 364 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __Z6dtFreePv(i2);
 HEAP32[i1 >> 2] = 0;
 i5 = i3 + 464 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 416 | 0;
 __Z6dtFreePv(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 392 | 0;
 __Z6dtFreePv(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 396 | 0;
 __Z6dtFreePv(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 428 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i3 + 424 | 0;
 if ((i1 | 0) > 0) i3 = 0; else {
  i3 = HEAP32[i4 >> 2] | 0;
  __Z6dtFreePv(i3);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  __Z17FreeStaticQueriesv();
  return;
 }
 do {
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if (i2) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    __Z6dtFreePv(HEAP32[i1 + 48 >> 2] | 0);
    __Z6dtFreePv(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0);
    __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
   }
   HEAP32[i2 >> 2] = 0;
   __Z6dtFreePv(i2);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 i3 = HEAP32[i4 >> 2] | 0;
 __Z6dtFreePv(i3);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __Z17FreeStaticQueriesv();
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 621;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx16collideWithPlaneERNS_19PxsParticleCollDataEf(i13, f1) {
 i13 = i13 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0;
 f12 = Math_fround(HEAPF32[i13 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 112 >> 2]);
 i9 = f10 <= Math_fround(0.0);
 if (!(f12 <= f1)) {
  i2 = 0;
  i3 = 3;
 } else {
  i2 = f12 > Math_fround(0.0);
  if (!(f12 <= Math_fround(HEAPF32[i13 + 92 >> 2]))) i3 = 3; else i11 = 1;
 }
 if ((i3 | 0) == 3) if (i9 | i2) i11 = 0; else return;
 f1 = Math_fround(f12 - f10);
 i7 = i13 + 132 | 0;
 i5 = i13 + 116 | 0;
 i8 = i13 + 136 | 0;
 i6 = i13 + 120 | 0;
 if (f1 == Math_fround(0.0)) if (f12 > Math_fround(0.0)) {
  f1 = Math_fround(-3402823469999999843913219.0e14);
  i4 = 1;
 } else {
  f1 = Math_fround(-3402823469999999843913219.0e14);
  i4 = 0;
 } else if (f1 < Math_fround(0.0)) {
  f1 = Math_fround(Math_fround(-f10) / f1);
  i4 = 0;
 } else {
  f1 = Math_fround(-3402823469999999843913219.0e14);
  i4 = 0;
 }
 if (i9) {
  i11 = i13 + 124 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 8;
  HEAPF32[i13 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i13 + 144 >> 2] = 1065353216;
  HEAP32[i13 + 148 >> 2] = 0;
  HEAP32[i13 + 152 >> 2] = 0;
  HEAP32[i13 + 164 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i13 + 168 >> 2] = HEAP32[i6 >> 2];
  HEAPF32[i13 + 160 >> 2] = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i13 + 92 >> 2]) - f10));
  return;
 }
 if (f1 >= Math_fround(0.0)) {
  i3 = i13 + 44 | 0;
  if (!(i4 | !(f1 < Math_fround(HEAPF32[i3 >> 2])))) {
   HEAP32[i13 + 144 >> 2] = 1065353216;
   HEAP32[i13 + 148 >> 2] = 0;
   HEAP32[i13 + 152 >> 2] = 0;
   HEAPF32[i13 + 160 >> 2] = f10;
   HEAP32[i13 + 164 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i13 + 168 >> 2] = HEAP32[i6 >> 2];
   HEAPF32[i3 >> 2] = f1;
   i13 = i13 + 124 | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 8;
   return;
  }
 }
 i4 = i13 + 124 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 & 2 | 0) return;
 if (i2) {
  i2 = i3 | 32;
  HEAP32[i4 >> 2] = i2;
 } else i2 = i3;
 if (i11) HEAP32[i4 >> 2] = i2 | 16;
 HEAP32[i13 + 144 >> 2] = 1065353216;
 HEAP32[i13 + 148 >> 2] = 0;
 HEAP32[i13 + 152 >> 2] = 0;
 HEAP32[i13 + 164 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 168 >> 2] = HEAP32[i8 >> 2];
 HEAPF32[i13 + 160 >> 2] = Math_fround(f12 + Math_fround(Math_fround(HEAPF32[i13 + 92 >> 2]) - f12));
 return;
}

function __ZN21ComputeShaderResource8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1037646 | 0, gb + 469407 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469646 | 0, gb + 469407 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469614 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1039692 | 0, gb + 469660 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN20ComputeBufferCounter8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN15NavMeshObstacle17SnapshotTransformEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i9 = i1 + 28 | 0;
 i11 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0;
 i10 = i1 + 92 | 0;
 __ZNK9Transform11GetPositionEv(i8, i11);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i10 = i1 + 104 | 0;
 __ZNK9Transform11GetRotationEv(i8, i11);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i10 = i1 + 120 | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i8, i11);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZNK9Transform18GetWorldScaleLossyEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = f2 < Math_fround(0.0);
 f3 = Math_fround(-f2);
 f2 = i9 ? f3 : f2;
 f3 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 i9 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i9 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i8 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f4 = i8 ? f5 : f4;
 f5 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 if (!(HEAP32[i1 + 40 >> 2] | 0)) {
  f5 = Math_fround(f5 * (f2 < f4 ? f4 : f2));
  f4 = f5;
  f6 = Math_fround(f3 * f6);
  f5 = Math_fround(f5 * f5);
  f6 = Math_fround(f6 * f6);
  f5 = Math_fround(f6 + f5);
  f6 = Math_fround(f4 * f4);
  f6 = Math_fround(f5 + f6);
  i11 = i1 + 132 | 0;
  HEAPF32[i11 >> 2] = f6;
  i11 = i1 + 136 | 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  f5 = Math_fround(f2 * f5);
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i1 + 64 >> 2]));
  f6 = Math_fround(f3 * f6);
  f5 = Math_fround(f5 * f5);
  f6 = Math_fround(f6 * f6);
  f5 = Math_fround(f6 + f5);
  f6 = Math_fround(f4 * f4);
  f6 = Math_fround(f5 + f6);
  i11 = i1 + 132 | 0;
  HEAPF32[i11 >> 2] = f6;
  i11 = i1 + 136 | 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 32 | 0;
  __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __Z27RegisterModule_UnityConnectv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 404;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 405;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 406;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 406;
 STACKTOP = i5;
 return;
}

function _jpeg_resync_to_restart(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i9 = i11 + 380 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 20 >> 2] = 121;
 HEAP32[i12 + 24 >> 2] = i10;
 HEAP32[i12 + 28 >> 2] = i1;
 mftCall_vii(HEAP32[i12 + 4 >> 2] | 0, i11 | 0, -1);
 i12 = i1 + 1 & 7 | 208;
 i6 = i1 + 2 & 7 | 208;
 i7 = i1 + 7 & 7 | 208;
 i5 = i1 + 6 & 7 | 208;
 L1 : while (1) {
  i4 = (i10 & -8 | 0) == 208;
  i8 = (i10 | 0) == (i12 | 0);
  i1 = (i10 | 0) == (i6 | 0);
  i2 = (i10 | 0) == (i7 | 0);
  i3 = (i10 | 0) == (i5 | 0);
  L3 : do if ((i10 | 0) < 192) {
   i1 = HEAP32[i11 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 97;
   i2 = i1 + 24 | 0;
   if (i4) {
    HEAP32[i2 >> 2] = i10;
    HEAP32[i1 + 28 >> 2] = 2;
    mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i11 | 0, 4);
    break;
   }
   if (i8) {
    HEAP32[i2 >> 2] = i12;
    HEAP32[i1 + 28 >> 2] = 2;
    mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i11 | 0, 4);
    break;
   } else {
    HEAP32[i2 >> 2] = i10;
    HEAP32[i1 + 28 >> 2] = 2;
    mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i11 | 0, 4);
    break;
   }
  } else {
   if (!i4) {
    i2 = 11;
    break L1;
   }
   i1 = i8 | i1 ? 3 : i2 | i3 ? 2 : 1;
   i2 = i1 & 255;
   while (1) {
    i8 = HEAP32[i11 >> 2] | 0;
    HEAP32[i8 + 20 >> 2] = 97;
    HEAP32[i8 + 24 >> 2] = i10;
    HEAP32[i8 + 28 >> 2] = i1;
    mftCall_vii(HEAP32[i8 + 4 >> 2] | 0, i11 | 0, 4);
    switch (i2 & 3) {
    case 1:
     {
      i2 = 14;
      break L1;
     }
    case 3:
     {
      i1 = 1;
      i2 = 17;
      break L1;
     }
    case 2:
     break L3;
    default:
     {}
    }
   }
  } while (0);
  if (!((_next_marker(i11) | 0) << 24 >> 24)) {
   i1 = 0;
   i2 = 17;
   break;
  }
  i10 = HEAP32[i9 >> 2] | 0;
 }
 if ((i2 | 0) == 11) {
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 97;
  i2 = i1 + 24 | 0;
  if (i8) {
   HEAP32[i2 >> 2] = i12;
   HEAP32[i1 + 28 >> 2] = 3;
   mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i11 | 0, 4);
   i12 = 1;
   return i12 | 0;
  } else {
   HEAP32[i2 >> 2] = i10;
   HEAP32[i1 + 28 >> 2] = 3;
   mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i11 | 0, 4);
   i12 = 1;
   return i12 | 0;
  }
 } else if ((i2 | 0) == 14) {
  HEAP32[i9 >> 2] = 0;
  i12 = 1;
  return i12 | 0;
 } else if ((i2 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZN8GUIState13MoveAllDataToERS_b(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i6 = HEAP32[i2 + 16 >> 2] | 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = i6;
 HEAP32[i3 + 20 >> 2] = i5;
 HEAP32[i3 + 24 >> 2] = i4;
 i4 = HEAP32[i2 + 32 >> 2] | 0;
 i5 = HEAP32[i2 + 36 >> 2] | 0;
 i6 = HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = i4;
 HEAP32[i3 + 36 >> 2] = i5;
 HEAP32[i3 + 40 >> 2] = i6;
 i6 = HEAP32[i2 + 48 >> 2] | 0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 i4 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i3 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i3 + 48 >> 2] = i6;
 HEAP32[i3 + 52 >> 2] = i5;
 HEAP32[i3 + 56 >> 2] = i4;
 i4 = i3 + 60 | 0;
 i5 = i2 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 i4 = i2 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i3 + 344 >> 2] = HEAP32[i2 + 344 >> 2];
 HEAP32[i3 + 92 >> 2] = HEAP32[i2 + 92 >> 2];
 if ((i3 | 0) != (i2 | 0)) __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i3 + 96 | 0, HEAP32[i2 + 96 >> 2] | 0, HEAP32[i2 + 100 >> 2] | 0);
 _memcpy(i3 + 108 | 0, i2 + 108 | 0, 164) | 0;
 HEAP32[i3 + 272 >> 2] = HEAP32[i2 + 272 >> 2];
 HEAP32[i3 + 276 >> 2] = HEAP32[i2 + 276 >> 2];
 if (!i1) {
  i1 = HEAP32[i3 + 280 >> 2] | 0;
  if (!i1) return;
  __ZN10InputEventaSERKS_(i1, i2 + 288 | 0);
  return;
 }
 i2 = i2 + 280 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 __ZN10InputEventaSERKS_(i3 + 288 | 0, i1);
 i1 = HEAP32[i3 + 280 >> 2] | 0;
 if (!i1) return;
 __ZN10InputEventaSERKS_(i1, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(i3, i1, i14) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 4 | 0;
 i13 = i16;
 i2 = __ZN5physx2Sc19ConstraintGroupNode7getRootEv(i1) | 0;
 i1 = i2 + 44 | 0;
 if (HEAP8[i1 >> 0] & 4) {
  HEAP32[i15 >> 2] = i2;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3 + 340 | 0, i15) | 0;
  HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] & 251;
 }
 i8 = i3 + 300 | 0;
 i9 = i3 + 284 | 0;
 i10 = i3 + 296 | 0;
 i11 = i3 + 288 | 0;
 i12 = i3 + 280 | 0;
 i7 = i3 + 4 | 0;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i1 + 20 >> 2] | 0;
  i5 = HEAP32[i1 + 28 >> 2] | 0;
  i6 = i3 + (i5 << 2) | 0;
  if ((i5 | 0) > 0) {
   do {
    i1 = HEAP32[i3 >> 2] | 0;
    if ((HEAP8[i1 + 20 >> 0] | 0) == 1) {
     i1 = HEAP32[i1 + 32 >> 2] | 0;
     if ((i1 | 0) != (i14 | 0)) if (__ZN5physx2Sc13ConstraintSim15needsProjectionEv(i1) | 0) {
      i4 = i1 + 116 | 0;
      if (!(HEAP8[i4 >> 0] & 1)) {
       HEAP32[i13 >> 2] = i1;
       i5 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i8, i13, i15) | 0;
       if (!(HEAP8[i15 >> 0] | 0)) HEAP32[i5 >> 2] = i1;
       HEAP8[i4 >> 0] = HEAP8[i4 >> 0] | 1;
      }
     }
    }
    i3 = i3 + 4 | 0;
   } while (i3 >>> 0 < i6 >>> 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i3 = i2;
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i1 + 60 >> 2] = 0;
  if (HEAP32[i3 + 20 >> 2] | 0) __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE(i3);
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i3;
  i6 = HEAP32[i11 >> 2] | 0;
  HEAP32[i11 >> 2] = i6 + 1;
  if ((i6 | 0) >= ((HEAP32[i12 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i7);
   HEAP32[i11 >> 2] = 0;
  }
 } while ((i2 | 0) != 0);
 STACKTOP = i16;
 return;
}

function __ZN2UI14CanvasRenderer18OnTransformChangedEi(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i1 = i9;
 if ((HEAP16[gb + 1468036 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468036 | 0, i7);
  i6 = gb + 1468036 | 0;
 } else i6 = 0;
 i1 = i8 + 200 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i4 = 12; else {
  HEAP8[i1 >> 0] = 0;
  i3 = i8 + 188 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else if ((__ZNK2UI6Canvas13GetRenderModeEv(i1) | 0) == 2) i1 = 0; else {
   i1 = HEAP32[i3 >> 2] | 0;
   while (1) {
    i2 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i2) break;
    if (!(HEAP8[i1 + 361 >> 0] | 0)) i1 = i2; else break;
   }
   i1 = (HEAP8[i1 + 360 >> 0] | 0) != 0;
  }
  if ((i5 & 16 | 0) == 0 | i1) i4 = 12; else {
   i7 = i8 + 162 | 0;
   HEAP16[i7 >> 1] = HEAP16[i7 >> 1] | 19;
   __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i3 >> 2] | 0, i8);
  }
 }
 if ((i4 | 0) == 12) {
  if (!(i5 & 64)) i1 = 1; else i1 = __ZN2UI14CanvasRenderer18OnParentingChangedEv(i8) | 0;
  if (i5 & 256) {
   i2 = HEAP32[i8 + 204 >> 2] | 0;
   if (i2) {
    i1 = i2 + 112 | 0;
    HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 4;
    i1 = 0;
   }
  }
  if (i5 & 11 | 0) {
   i2 = i8 + 188 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) if ((__ZNK2UI6Canvas13GetRenderModeEv(i3) | 0) != 2) {
    i2 = HEAP32[i2 >> 2] | 0;
    while (1) {
     i3 = HEAP32[i2 + 344 >> 2] | 0;
     if (!i3) break;
     if (!(HEAP8[i2 + 361 >> 0] | 0)) i2 = i3; else break;
    }
    if (HEAP8[i2 + 360 >> 0] | 0) {
     HEAP32[i7 >> 2] = 0;
     HEAP32[i7 + 4 >> 2] = 0;
     HEAP32[i7 + 8 >> 2] = 0;
     __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i8, gb + 1106036 | 0, i7);
    }
   }
  }
  if (i1) {
   i7 = i8 + 162 | 0;
   HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 2067;
   __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i8 + 188 >> 2] | 0, i8);
  }
 }
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i9;
 return;
}

function __ZN20SpeedTreeWindManager25GetCachedGlobalWindVectorEv(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, f19 = f0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i17 = i16 + 48 | 0;
 f8 = Math_fround(HEAPF32[i17 >> 2]);
 i14 = i16 + 52 | 0;
 f5 = Math_fround(HEAPF32[i14 >> 2]);
 if (!(f8 != f5)) {
  i17 = HEAP32[i16 + 36 >> 2] | 0;
  i14 = HEAP32[i16 + 40 >> 2] | 0;
  i16 = HEAP32[i16 + 44 >> 2] | 0;
  HEAP32[i15 >> 2] = i17;
  i17 = i15 + 4 | 0;
  HEAP32[i17 >> 2] = i14;
  i17 = i15 + 8 | 0;
  HEAP32[i17 >> 2] = i16;
  STACKTOP = i18;
  return;
 }
 i13 = HEAP32[gb + 1170608 >> 2] | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i1;
 if ((i6 | 0) == (i13 | 0)) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i9 = i12 + 4 | 0;
  i10 = i12 + 8 | 0;
  i11 = i12 + 12 | 0;
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if (!(HEAP32[i1 + 36 >> 2] | 0)) if (__ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, gb + 1155204 | 0, i12) | 0) {
    f19 = Math_fround(HEAPF32[i12 >> 2]);
    f2 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(HEAPF32[i10 >> 2]);
    f4 = Math_fround(HEAPF32[i11 >> 2]);
    f5 = Math_fround(f5 + Math_fround(f19 * f4));
    f8 = Math_fround(f8 + Math_fround(f2 * f4));
    f7 = Math_fround(f7 + Math_fround(f3 * f4));
    f4 = f5;
    f3 = f8;
    f2 = f7;
   }
   i1 = HEAP32[i6 + 4 >> 2] | 0;
   i6 = i1;
  } while ((i6 | 0) != (i13 | 0));
  i1 = HEAP32[i14 >> 2] | 0;
 }
 HEAPF32[i16 + 36 >> 2] = f4;
 HEAPF32[i16 + 40 >> 2] = f3;
 HEAPF32[i16 + 44 >> 2] = f2;
 HEAP32[i17 >> 2] = i1;
 i17 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i14 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i16 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i15 >> 2] = i17;
 i17 = i15 + 4 | 0;
 HEAP32[i17 >> 2] = i14;
 i17 = i15 + 8 | 0;
 HEAP32[i17 >> 2] = i16;
 STACKTOP = i18;
 return;
}

function __ZN19CloudServiceHandlerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN19CloudServiceHandler12CloseServiceEv(i5) | 0;
 i1 = __Z24GetManagerPtrFromContexti(20) | 0;
 if (i1 | 0) __ZN23CloudWebServicesManager25RemoveCloudServiceHandlerEP19CloudServiceHandler(i1, i5);
 i3 = HEAP32[i5 + 1152 >> 2] | 0;
 i4 = i5 + 1156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i3;
 if ((i1 | 0) == (i3 | 0)) i1 = i3; else {
  i1 = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 if (i3 | 0) {
  if ((i1 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 1164 >> 2] | 0;
  HEAP32[i6 >> 2] = 85;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
 }
 __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev(i5 + 1072 | 0);
 __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev(i5 + 792 | 0);
 __ZN11UnityEngine15CloudWebService19SessionEventManagerD2Ev(i5 + 200 | 0);
 HEAP32[i5 + 184 >> 2] = gb + 189712 + 8;
 i1 = i5 + 188 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i3 = i5 + 192 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63800 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 __ZN11UnityEngine15CloudWebService18CloudServiceConfigD2Ev(i5 + 68 | 0);
 i1 = i5 + 52 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 64 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 48 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 32 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 STACKTOP = i7;
 return;
}

function __ZN11KeyframeTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN14SafeBinaryRead10SetVersionEi(i7, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i3 = HEAP32[gb + 37208 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034365 | 0, i3, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034371 | 0, i3, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034379 | 0, i3, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNK11LightProbes47GetNonTetrahedralizedProbeSetIndexOffsetAndSizeERK7Hash128(i13, i14, i16) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i2 = HEAP32[i14 + 116 >> 2] | 0;
 i15 = HEAP32[i14 + 120 >> 2] | 0;
 i1 = i15 - i2 | 0;
 if (!i1) i1 = i2; else {
  i9 = i16;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i16 + 8 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = (i1 | 0) / 24 | 0;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i7 | 0) / 2 | 0;
   i4 = i3 + (i2 * 24 | 0) | 0;
   i6 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i5 | 0) == (i8 | 0) & (i6 | 0) == (i9 | 0)) {
    i6 = i3 + (i2 * 24 | 0) + 8 | 0;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    if (i5 >>> 0 < i11 >>> 0 | ((i5 | 0) == (i11 | 0) ? (HEAP32[i6 >> 2] | 0) >>> 0 < i10 >>> 0 : 0)) i12 = 7;
   } else if (i6 >>> 0 < i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0) i12 = 7;
   if ((i12 | 0) == 7) {
    i12 = 0;
    i3 = i4 + 24 | 0;
    i2 = i7 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i7 = i2;
  }
 }
 if ((i1 | 0) == (i15 | 0)) {
  i15 = 0;
  i16 = -1;
  HEAP32[i13 >> 2] = i16;
  i16 = i13 + 4 | 0;
  HEAP32[i16 >> 2] = i15;
  return;
 }
 i3 = i16;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
  i12 = i16 + 8 | 0;
  i10 = HEAP32[i12 + 4 >> 2] | 0;
  i16 = i1 + 8 | 0;
  i11 = HEAP32[i16 + 4 >> 2] | 0;
  if (i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0 : 0) | (i1 | 0) == (i15 | 0)) {
   i15 = 0;
   i16 = -1;
   HEAP32[i13 >> 2] = i16;
   i16 = i13 + 4 | 0;
   HEAP32[i16 >> 2] = i15;
   return;
  }
 } else if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0 | (i1 | 0) == (i15 | 0)) {
  i15 = 0;
  i16 = -1;
  HEAP32[i13 >> 2] = i16;
  i16 = i13 + 4 | 0;
  HEAP32[i16 >> 2] = i15;
  return;
 }
 i16 = HEAP32[i1 + 16 >> 2] | 0;
 i14 = HEAP32[i14 + 72 >> 2] | 0;
 i15 = HEAP32[i14 + (i16 * 24 | 0) + 20 >> 2] | 0;
 i16 = HEAP32[i14 + (i16 * 24 | 0) + 16 >> 2] | 0;
 HEAP32[i13 >> 2] = i16;
 i16 = i13 + 4 | 0;
 HEAP32[i16 >> 2] = i15;
 return;
}

function __ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj(i8, i9, i10, i4, i3) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i5 = i12;
 i11 = i8 + 1320 | 0;
 if (HEAP8[i11 >> 0] | 0) if (!(__ZN21ArchiveStorageCreator17StoreCurrentBlockEb(i8, 1) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i7 = i8 + 1260 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i1 | 0) {
  if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) == (i10 | 0)) {
   if (!i9) break;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = i8 + 1264 | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0) break;
  } else i1 = i8 + 1264 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i13 = HEAP32[i7 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0, i2 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i13 = HEAP32[i7 >> 2] | 0;
  if ((mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0) | 0) != (i10 | 0)) {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
   HEAP32[i7 >> 2] = 0;
  }
 } while (0);
 HEAP32[i8 + 1256 >> 2] = i3;
 i3 = i8 + 1252 | 0;
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i10 | 0) != 0 & (i1 | 0) == 0) {
  i4 = gb + 63552 | 0;
  i13 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i5;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i1 = __Z16CreateCompressor15CompressionType10MemLabelId(i10, i6) | 0;
  HEAP32[i7 >> 2] = i1;
  if (!i1) {
   i13 = 0;
   STACKTOP = i12;
   return i13 | 0;
  }
 }
 if (i9) {
  i2 = i8 + 1264 | 0;
  if (!((HEAP32[i2 >> 2] | 0) != 0 | (i1 | 0) == 0)) if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, HEAP32[i3 >> 2] | 0) | 0)) {
   i13 = 0;
   STACKTOP = i12;
   return i13 | 0;
  }
 }
 HEAP32[i8 + 1308 >> 2] = 0;
 HEAP32[i8 + 1312 >> 2] = 0;
 HEAP16[i8 + 1316 >> 1] = i10 & 63 | (i9 ? 64 : 0);
 HEAP8[i11 >> 0] = 1;
 i13 = 1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN11TimeManagerC2E10MemLabelId18ObjectCreationMode(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, d9 = 0.0, f10 = f0, f11 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i8 = i1;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i6, i3, i2);
 HEAP32[i6 >> 2] = gb + 62144 + 8;
 i1 = i6 + 64 | 0;
 i2 = i6 + 96 | 0;
 HEAP32[i6 + 140 >> 2] = 0;
 HEAP8[i6 + 192 >> 0] = 0;
 HEAP8[i6 + 193 >> 0] = 0;
 i3 = i6 + 48 | 0;
 i4 = i6 + 32 | 0;
 i5 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i3 >> 2] = Math_fround(.0199999996);
 HEAPF64[i6 + 208 >> 3] = 0.0;
 i8 = __Z14IsWorldPlayingv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 f11 = i8 ? Math_fround(.0199999996) : Math_fround(0.0);
 f10 = i8 ? Math_fround(50.0) : Math_fround(0.0);
 HEAPF32[i6 + 80 >> 2] = f11;
 HEAPF32[i6 + 92 >> 2] = f10;
 HEAPF32[i6 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 88 >> 2] = Math_fround(0.0);
 i8 = i6 + 32 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAPF32[i6 + 60 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 >> 2]));
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i6 + 128 >> 0] = 1;
 HEAP8[i6 + 129 >> 0] = 1;
 HEAP8[i6 + 130 >> 0] = 1;
 HEAP32[i6 + 132 >> 2] = 0;
 HEAP32[i6 + 136 >> 2] = 0;
 d9 = +__Z19GetTimeSinceStartupv();
 HEAPF64[i6 + 152 >> 3] = d9;
 HEAPF64[i6 + 160 >> 3] = d9;
 i8 = i6 + 168 | 0;
 HEAP32[i6 + 144 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z43Animator_CUSTOM_GetAnimatorClipInfoInternalP12Il2CppObjectihS0_(i1, i2, i3, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i13 = i11;
 i10 = i11 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i10 >> 2] = 0;
 i5 = i10 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i13);
 i13 = i9;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 if (!i1) {
  i13 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i13 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i13);
 }
 __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(i4, i2, i3 << 24 >> 24 != 0, i10) | 0;
 i1 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i13 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i5 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = 0;
  while (1) {
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i1, i9);
   i12 = i9;
   i14 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i13 >> 2] = i14;
   HEAP32[i13 + 4 >> 2] = i12;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 8 | 0;
  }
 }
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 >> 2];
 i14 = i8 + 16 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i7);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z24RegisterModule_Physics2Dv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 246;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 247;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 248;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 248;
 STACKTOP = i5;
 return;
}

function __Z24RegisterModule_Animationv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 311;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 312;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 313;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 313;
 STACKTOP = i5;
 return;
}

function _sha512_sum(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i4 >> 2] & 127;
 i2 = i3 + 1 | 0;
 i1 = i4 + 72 | 0;
 HEAP8[i4 + 72 + i3 >> 0] = -128;
 if (i2 >>> 0 > 112) {
  _memset(i4 + 72 + i2 | 0, 0, i3 ^ 127 | 0) | 0;
  _processblock_51(i4, i1);
  i2 = 0;
 }
 _memset(i4 + 72 + i2 | 0, 0, 120 - i2 | 0) | 0;
 i2 = i4;
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = _bitshift64Shl(i6 | 0, i2 | 0, 3) | 0;
 i8 = getTempRet0() | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 53) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 192 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 45) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 193 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 37) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 194 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 29) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 195 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 21) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 196 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 13) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 197 >> 0] = i7;
 i2 = _bitshift64Lshr(i6 | 0, i2 | 0, 5) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 198 >> 0] = i2;
 HEAP8[i4 + 199 >> 0] = i3;
 _processblock_51(i4, i1);
 i1 = 0;
 do {
  i7 = i4 + 8 + (i1 << 3) | 0;
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 56) | 0;
  getTempRet0() | 0;
  i8 = i1 << 3;
  HEAP8[i5 + i8 >> 0] = i6;
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 48) | 0;
  getTempRet0() | 0;
  HEAP8[i5 + (i8 | 1) >> 0] = i6;
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 40) | 0;
  getTempRet0() | 0;
  HEAP8[i5 + (i8 | 2) >> 0] = i6;
  HEAP8[i5 + (i8 | 3) >> 0] = HEAP32[i7 + 4 >> 2];
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 24) | 0;
  getTempRet0() | 0;
  HEAP8[i5 + (i8 | 4) >> 0] = i6;
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 16) | 0;
  getTempRet0() | 0;
  HEAP8[i5 + (i8 | 5) >> 0] = i6;
  i6 = i7;
  i6 = _bitshift64Lshr(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, 8) | 0;
  getTempRet0() | 0;
  HEAP8[i5 + (i8 | 6) >> 0] = i6;
  HEAP8[i5 + (i8 | 7) >> 0] = HEAP32[i7 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i8 = i10 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i6 >> 2] | 0)) {
   i8 = i2;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i6 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
  }
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i4 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  break;
 } while (0);
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) {
  i3 = HEAP32[gb + 37324 >> 2] | 0;
  i4 = i10 + 20 | 0;
  i6 = i10 + 56 | 0;
  i7 = i10 + 44 | 0;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
   i11 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 3) + 4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 2097152;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5, gb + 1085989 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 4 | 0, gb + 1085998 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 8 | 0, gb + 1084342 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i5 = i5 + 12 | 0;
  }
 }
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN22RenderingCommandBuffer18AddSetRenderTargetEiPK18RenderTextureParamRS1_i11CubemapFacei(i11, i3, i6, i7, i8, i9, i10) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i4 = i12 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 i4 = i12 + 68 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i4 + 8 >> 2] = -1;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP32[i4 + 16 >> 2] = -1;
 HEAP32[i4 + 20 >> 2] = -1;
 HEAP32[i4 + 24 >> 2] = -1;
 HEAP32[i4 + 28 >> 2] = -1;
 i4 = i12 + 100 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i12 + 108 | 0;
 HEAP32[i5 >> 2] = -1;
 i1 = i12 + 160 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i12 >> 2] = i3;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i12 + 4 + (i1 << 2) >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 8 >> 2];
   HEAP32[i12 + 36 + (i1 << 2) >> 2] = HEAP32[i6 + (i1 * 12 | 0) >> 2];
   HEAP32[i12 + 68 + (i1 << 2) >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i4 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i12 + 104 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i12 + 112 >> 2] = i8;
 HEAP32[i12 + 116 >> 2] = i9;
 HEAP32[i12 + 120 >> 2] = i10;
 i7 = i11 + 8 | 0;
 i8 = i11 + 24 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i6 + 4 | 0;
 i1 = i11 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i6, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i4 = i11 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 + i6 >> 2] = 6;
 i1 = i6 + 7 & -4;
 i3 = i1 + 196 | 0;
 if (i3 >>> 0 <= i2 >>> 0) {
  i11 = i5;
  HEAP32[i8 >> 2] = i3;
  i11 = i11 + i1 | 0;
  _memcpy(i11 | 0, i12 | 0, 196) | 0;
  STACKTOP = i13;
  return;
 }
 __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i1, i3);
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i3;
 i11 = i11 + i1 | 0;
 _memcpy(i11 | 0, i12 | 0, 196) | 0;
 STACKTOP = i13;
 return;
}

function __Z23RegisterModule_Vehiclesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 251;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 252;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 253;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 253;
 STACKTOP = i5;
 return;
}

function __Z23RegisterModule_UnityAdsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 394;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 395;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 396;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 396;
 STACKTOP = i5;
 return;
}

function __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 24 | 0;
 i12 = i13;
 HEAP32[i12 >> 2] = 0;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i12 + 16 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 i5 = i3 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 do if ((i4 & 524288 | 0) == 0 | (HEAP32[i3 >> 2] & 2 | 0) == 0) {
  i6 = i3 + 40 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   if (!i7) break;
   if ((HEAP32[i7 + 16 >> 2] | 0) != 3) break;
  }
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i3, i7, i1) | 0;
  HEAP32[i6 >> 2] = i14;
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37316 >> 2];
  if (!i14) {
   i14 = HEAP8[i5 >> 0] | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
   if (!(i14 << 24 >> 24)) break;
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i4);
   __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i12, 0);
   HEAP8[i5 >> 0] = 1;
   i14 = i3 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2;
  }
  __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i12, HEAP32[i9 + 24 >> 2] | 0, HEAP32[i8 + 28 >> 2] | 0);
 } while (0);
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i10 >> 2] = i2 + -72;
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i14 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = 1;
 HEAP32[i11 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgENS_4fposI11__mbstate_tEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i3 = i7 + 32 | 0;
 i4 = i7;
 i8 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] & -3 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) i5 = 7; else {
  __THREW__ = 0;
  invoke_viii(fb + 1038 | 0, i3 | 0, i6 | 0, 1);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) i5 = 7; else do if (HEAP8[i3 >> 0] | 0) {
   i8 = HEAP32[i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0;
   __THREW__ = 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   invoke_viiii(i3 | 0, i4 | 0, i8 | 0, i1 | 0, 8);
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   } else {
    i8 = i4 + 8 | 0;
    if (!((HEAP32[i8 >> 2] | 0) == -1 ? (HEAP32[i8 + 4 >> 2] | 0) == -1 : 0)) break;
    i8 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] | 4 | 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) break;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i5 = 12;
   break L1;
  } while (0);
 } while (0);
 if ((i5 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i5 = 12;
 }
 do if ((i5 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgENS_4fposI11__mbstate_tEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i3 = i7 + 32 | 0;
 i4 = i7;
 i8 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] & -3 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i8 & 1) i5 = 7; else {
  __THREW__ = 0;
  invoke_viii(fb + 1037 | 0, i3 | 0, i6 | 0, 1);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) i5 = 7; else do if (HEAP8[i3 >> 0] | 0) {
   i8 = HEAP32[i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0;
   __THREW__ = 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   invoke_viiii(i3 | 0, i4 | 0, i8 | 0, i1 | 0, 8);
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   } else {
    i8 = i4 + 8 | 0;
    if (!((HEAP32[i8 >> 2] | 0) == -1 ? (HEAP32[i8 + 4 >> 2] | 0) == -1 : 0)) break;
    i8 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] | 4 | 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (!(i8 & 1)) break;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i5 = 12;
   break L1;
  } while (0);
 } while (0);
 if ((i5 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i5 = 12;
 }
 do if ((i5 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (!(i8 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 44 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 44 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx15PxVehicleUpdate6updateEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f11, i9, i13, i10, i15, i14, i12) {
 f11 = Math_fround(f11);
 i9 = i9 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[gb + 1458536 >> 2] = 0;
 i1 = gb + 1458456 | 0;
 i2 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[gb + 1458452 >> 2] = 0;
 HEAP32[gb + 1458448 >> 2] = 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f3 = Math_fround(f3 * f3);
 f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f3 * f3))));
 f4 = Math_fround(Math_fround(1.0) / f3);
 if (!i10) return;
 i2 = (i14 | 0) == 0;
 i5 = (i12 | 0) == 0;
 i8 = 0;
 do {
  i6 = HEAP32[i15 + (i8 << 2) >> 2] | 0;
  i1 = i2 ? 0 : i14 + (i8 << 3) | 0;
  i7 = i5 ? 0 : i12 + (i8 * 36 | 0) | 0;
  switch (HEAPU8[i6 + 113 >> 0] | 0 | 0) {
  case 0:
   {
    __ZN5physx15PxVehicleUpdate13updateDrive4WEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDrive4WEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f11, i9, f3, f4, i13, i6, i1, i7);
    break;
   }
  case 1:
   {
    __ZN5physx15PxVehicleUpdate13updateDriveNWEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDriveNWEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f11, i9, f3, f4, i13, i6, i1, i7);
    break;
   }
  case 2:
   {
    __ZN5physx15PxVehicleUpdate10updateTankEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_18PxVehicleDriveTankEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f11, i9, f3, f4, i13, i6, i1, i7);
    break;
   }
  case 3:
   {
    __ZN5physx15PxVehicleUpdate13updateNoDriveEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleNoDriveEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f11, i9, f3, f4, i13, i6, i1, i7);
    break;
   }
  default:
   {}
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i10 | 0));
 return;
}

function __ZN17MonoScriptManager14CollectGarbageEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i7 = i13 + 8 | 0;
 i11 = i9 + 4 | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i1 = i2 >> 2;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 64016 | 0, 0, gb + 458008 | 0, 86) | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i6 = i3 + (i1 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i12;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   do if (i2) {
    HEAP32[i7 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i8 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i4 = HEAP32[i2 + 28 >> 2] | 0;
      i5 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i4 + (i5 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i2, i7);
      i4 = HEAP32[i10 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i5 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i4 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i4 << 3) | 0;
      i4 = HEAP32[i5 + 28 >> 2] | 0;
      i5 = HEAP32[i5 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i8 = 10; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i8 = 12;
    }
    if ((i8 | 0) == 10) i8 = 12;
    if ((i8 | 0) == 12) {
     i8 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i3 >> 2] | 0) | 0)) break;
    }
    HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
    i1 = i1 + 4 | 0;
   } while (0);
   i3 = i3 + 4 | 0;
  } while (i3 >>> 0 < i6 >>> 0);
 } else i1 = i12;
 __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i9, i12, i1);
 __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_(HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] | 0, i10);
 __Z19free_alloc_internalPvRK10MemLabelId(i12, gb + 64016 | 0);
 STACKTOP = i13;
 return;
}

function __Z22RegisterModule_Terrainv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 321;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 322;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 323;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 323;
 STACKTOP = i5;
 return;
}

function __Z22RegisterModule_Physicsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 225;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 226;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 227;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 227;
 STACKTOP = i5;
 return;
}

function __Z19updateCollShapeDataRN5physx19PxsParticleCollDataERbjffRKNS_6PxVec3ES5_S5_S5_RKNS_11PxTransformE(i7, i8, i1, f6, f2, i10, i11, i3, i4, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 f2 = Math_fround(f2);
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i5 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 HEAPF32[i5 >> 2] = f2;
 if (i1 & 8 | 0) {
  i1 = i7 + 44 | 0;
  if (Math_fround(HEAPF32[i1 >> 2]) > f6) {
   HEAP32[i7 + 144 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i7 + 148 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i7 + 152 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i7 + 160 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 164 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 168 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAPF32[i1 >> 2] = f6;
   HEAP32[i7 + 124 >> 2] = 8;
  }
  __Z17setConstraintDataRN5physx19PxsParticleCollDataERKfRKNS_6PxVec3ES6_RKNS_11PxTransformE(i7, i5, i10, i11, i9);
  HEAP8[i8 >> 0] = 1;
  STACKTOP = i12;
  return;
 }
 if (HEAP8[i8 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 if (i1 & 32 | 0) {
  __Z17setConstraintDataRN5physx19PxsParticleCollDataERKfRKNS_6PxVec3ES6_RKNS_11PxTransformE(i7, i5, i3, i4, i9);
  i9 = i7 + 124 | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 32;
 }
 if (!(i1 & 16)) {
  STACKTOP = i12;
  return;
 }
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 i9 = i7 + 144 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 i9 = i7 + 148 | 0;
 HEAPF32[i9 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i9 >> 2]));
 f6 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 i10 = i7 + 152 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i10 >> 2]));
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 i10 = i7 + 160 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i10 >> 2]));
 f6 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 i10 = i7 + 164 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i10 >> 2]));
 f6 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 i11 = i7 + 168 | 0;
 HEAPF32[i11 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i11 >> 2]));
 i11 = i7 + 172 | 0;
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(1.0));
 i11 = i7 + 124 | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 16;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn24readStridedFlagsPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorEPKNS_11PxU32ToNameE(i2, i1, i12, i3, i11, i13, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 4 | 0;
 i10 = i14;
 HEAP32[i3 >> 2] = 4;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, i4 | 0) | 0)) {
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) i1 = i13; else {
  HEAP32[gb + 1457436 >> 2] = (HEAP32[gb + 1457436 >> 2] | 0) + 1;
  if (!(HEAP8[i4 >> 0] | 0)) i8 = gb + 1576256 | 0; else {
   i2 = i4;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
    if (!(HEAP8[i2 >> 0] | 0)) {
     i2 = i3;
     break;
    } else i1 = i3;
   }
   i8 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i1 + 2 | 0) | 0;
   _memcpy(i8 | 0, i4 | 0, i2 | 0) | 0;
   HEAP8[i8 + i2 >> 0] = 0;
  }
  i2 = _strtok(i8, gb + 743898 | 0) | 0;
  if (!i2) {
   i3 = 0;
   i2 = 0;
   i1 = i13;
  } else {
   i7 = 0;
   i3 = 0;
   i1 = 0;
   i6 = i2;
   while (1) {
    __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i6, i13, i10, i9);
    i6 = _strtok(0, gb + 743898 | 0) | 0;
    i2 = i7 + 4 | 0;
    if (i3 >>> 0 < i2 >>> 0) {
     i3 = 32;
     while (1) if (i3 >>> 0 < i2 >>> 0) i3 = i3 << 1; else break;
     i4 = mftCall_iii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, i3 | 0) | 0;
     if (i7 | 0) _memcpy(i4 | 0, i1 | 0, i7 | 0) | 0;
     mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
     i5 = i4;
     i1 = i4;
    } else i5 = i1;
    i7 = i5 + i7 | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    HEAP8[i7 >> 0] = i5;
    HEAP8[i7 + 1 >> 0] = i5 >> 8;
    HEAP8[i7 + 2 >> 0] = i5 >> 16;
    HEAP8[i7 + 3 >> 0] = i5 >> 24;
    if (!i6) break; else i7 = i2;
   }
   i3 = i1;
   i2 = i2 >>> 2;
   i1 = i13;
  }
  HEAP32[i12 >> 2] = i3;
  HEAP32[i11 >> 2] = i2;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i8 | 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData4copyERKS0_jj(i4, i2, i3, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = i3 >>> 2;
 i7 = i2 + 32 | 0;
 i1 = i3 & 3;
 i9 = i5 >>> 2;
 i10 = i4 + 32 | 0;
 i8 = i5 & 3;
 __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + (i1 * 48 | 0) | 0);
 __ZN5physx23PxVehicleWheels4SimData12setWheelDataEjRKNS_18PxVehicleWheelDataE((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 192 + (i1 * 48 | 0) | 0);
 __ZN5physx23PxVehicleWheels4SimData11setTireDataEjRKNS_17PxVehicleTireDataE((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 384 + (i1 << 6) | 0);
 __ZN5physx23PxVehicleWheels4SimData22setSuspTravelDirectionEjRKNS_6PxVec3E((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 640 + (i1 * 12 | 0) | 0);
 __ZN5physx23PxVehicleWheels4SimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 688 + (i1 * 12 | 0) | 0);
 __ZN5physx23PxVehicleWheels4SimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 736 + (i1 * 12 | 0) | 0);
 __ZN5physx23PxVehicleWheels4SimData20setWheelCentreOffsetEjRKNS_6PxVec3E((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 784 + (i1 * 12 | 0) | 0);
 i11 = HEAP8[(HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 928 + i1 >> 0] | 0;
 __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, i11 << 24 >> 24 == -1 ? -1 : i11 & 255);
 __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i10 >> 2] | 0) + (i9 * 944 | 0) | 0, i8, (HEAP32[i7 >> 2] | 0) + (i6 * 944 | 0) + 864 + (i1 << 4) | 0);
 i1 = 1 << (i5 & 31);
 if (!(HEAP32[i2 + 44 + (i3 >>> 5 << 2) >> 2] & 1 << (i3 & 31))) {
  i11 = i4 + 44 + (i5 >>> 5 << 2) | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & ~i1;
  return;
 } else {
  i11 = i4 + 44 + (i5 >>> 5 << 2) | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | i1;
  return;
 }
}

function __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 12 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 13 >> 0] = i1;
 i1 = i4 + 14 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN15TerrainRenderer12ReloadBoundsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i1 = i9;
 i4 = i7 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i5 = 6; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i6 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i6 + (i3 << 3) | 0;
   i2 = i6;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i1);
   i1 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i6 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i6 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i3 = i1 + 248 | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i4 = i7 + 20 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i5 = i7 + 32 | 0;
 i6 = i7 + 36 | 0;
 i2 = i7 + 40 | 0;
 do {
  i7 = i1 + 36 | 0;
  __ZNK9Heightmap15CalculateBoundsEiii(i8, i3, HEAP32[i1 + 24 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0);
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
  f10 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i1 + 40 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  i7 = i1 + 44 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i7 >> 2]));
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
 STACKTOP = i9;
 return;
}

function __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_(i12, i13, i11, i10, i9, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i1 = i4 >>> 0 < i3 >>> 0;
 i6 = i3;
 i2 = i4;
 i7 = i5;
 do if (i3 >>> 0 < i5 >>> 0) {
  if (i1) {
   HEAP32[i12 >> 2] = i2;
   HEAP32[i11 >> 2] = i7;
   i8 = 1;
   i3 = i5;
   i2 = i7;
   break;
  }
  HEAP32[i12 >> 2] = i6;
  HEAP32[i13 >> 2] = i7;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = i1;
  if (i1 >>> 0 < i5 >>> 0) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = i7;
   i8 = 2;
   i3 = i5;
   i2 = i7;
  } else {
   i8 = 1;
   i3 = i1;
  }
 } else if (i1) {
  HEAP32[i13 >> 2] = i2;
  HEAP32[i11 >> 2] = i6;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   HEAP32[i12 >> 2] = i1;
   HEAP32[i13 >> 2] = i2;
   i2 = HEAP32[i11 >> 2] | 0;
   i8 = 2;
   i3 = i2;
  } else {
   i8 = 1;
   i2 = i6;
  }
 } else {
  i8 = 0;
  i3 = i4;
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i2;
  i1 = i8 + 1 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i11 >> 2] = i3;
   i1 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   if (i1 >>> 0 < i2 >>> 0) {
    HEAP32[i12 >> 2] = i1;
    HEAP32[i13 >> 2] = i2;
    i3 = i8 + 3 | 0;
   } else i3 = i8 + 2 | 0;
  } else i3 = i1;
 } else i3 = i8;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i13 = i3;
  return i13 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i9 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i13 = i3 + 1 | 0;
  return i13 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i13 = i3 + 2 | 0;
  return i13 | 0;
 }
 HEAP32[i13 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i13 = i3 + 3 | 0;
  return i13 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 i13 = i3 + 4 | 0;
 return i13 | 0;
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5, i11, i3) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i8 = i3;
 i6 = i11;
 i10 = i8 - i6 | 0;
 i9 = i5 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i2;
 if (i10 >>> 0 <= (i1 - i2 | 0) >>> 0) {
  i5 = i5 + 4 | 0;
  i2 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  i4 = i10 >>> 0 > i2 >>> 0;
  i3 = i4 ? i11 + i2 | 0 : i3;
  i2 = i3;
  i1 = i2 - i6 | 0;
  if (i1 | 0) _memmove(i7 | 0, i11 | 0, i1 | 0) | 0;
  i1 = i7 + i1 | 0;
  if (i4) {
   i1 = i8 - i2 | 0;
   if ((i1 | 0) <= 0) {
    STACKTOP = i12;
    return;
   }
   _memcpy(HEAP32[i5 >> 2] | 0, i3 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
   STACKTOP = i12;
   return;
  } else {
   if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) {
    STACKTOP = i12;
    return;
   }
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i12;
   return;
  }
 }
 if (i2) {
  i1 = i5 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i7;
  i8 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 14;
  HEAP32[i4 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if ((i10 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i8 = i1 - i2 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i10 >>> 0 ? i10 : i3) : 2147483647;
 if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 14;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + i3;
 if ((i10 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 _memcpy(i1 | 0, i11 | 0, i10 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i10;
 STACKTOP = i12;
 return;
}

function __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i11, i7, i3) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 24 | 0;
 i10 = i13 + 16 | 0;
 i8 = i13;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i12 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i12 = 3;
 if ((i12 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i5 = i2 + 12 | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 L6 : do if ((i1 | 0) < (i6 | 0)) {
  i4 = HEAP32[i2 + 44 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) break L6;
  }
  if ((i1 | 0) >= 0) {
   __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi(i8, i5, i1);
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   STACKTOP = i13;
   return;
  }
 } while (0);
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i12 = 15; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
    i2 = HEAP32[i9 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 15; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 } while (0);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = i11 + 152 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (!i3) i4 = 3; else {
  i10 = i3 + -1 | 0;
  i9 = HEAP32[i11 + 144 >> 2] | 0;
  if (((HEAP32[i9 + (i10 * 12 | 0) + 8 >> 2] | 0) - (HEAP32[i9 + (i10 * 12 | 0) + 4 >> 2] | 0) + (HEAP32[i9 + (i10 * 12 | 0) >> 2] | 0) | 0) >>> 0 < i1 >>> 0) i4 = 3;
 }
 if ((i4 | 0) == 3) {
  if (HEAP8[i11 + 137 >> 0] | 0) {
   i12 = 0;
   return i12 | 0;
  }
  i9 = (i1 >>> 0 > i2 >>> 0 ? 0 : i2) + i1 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 + 20 | 0, 0) | 0;
  if (!i1) {
   i12 = 0;
   return i12 | 0;
  }
  i8 = i1 + 4 + 15 & -16;
  i10 = i8;
  HEAP32[i8 + -4 >> 2] = i8 - i1;
  if (!i8) {
   i12 = 0;
   return i12 | 0;
  }
  i7 = HEAP32[i12 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i3 = i11 + 148 | 0;
  if ((HEAP32[i3 >> 2] | 0) > (i7 | 0)) i1 = HEAP32[i11 + 144 >> 2] | 0; else {
   i2 = i8 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
   i6 = i11 + 140 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 * 12 | 0) + 16 | 0, 0) | 0;
   if (!i1) {
    i12 = 0;
    return i12 | 0;
   }
   HEAP32[i1 >> 2] = i2;
   i1 = i1 + 16 | 0;
   HEAP32[i3 >> 2] = i2;
   i5 = i11 + 144 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   do if (i2 | 0) {
    i3 = HEAP32[i12 >> 2] | 0;
    if (i3) {
     i4 = (i3 | 0) <= (i8 | 0) ? i3 : i8;
     if ((i4 | 0) > 0) {
      i3 = 0;
      do {
       i13 = i1 + (i3 * 12 | 0) | 0;
       i14 = i2 + (i3 * 12 | 0) | 0;
       HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
       HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
       HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i4 | 0));
      i2 = HEAP32[i5 >> 2] | 0;
      if (!i2) break;
     }
    }
    i14 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 + -16 | 0);
   } while (0);
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i12 >> 2] = i8;
  HEAP32[i1 + (i7 * 12 | 0) >> 2] = i10;
  HEAP32[i1 + (i7 * 12 | 0) + 4 >> 2] = i10;
  HEAP32[i1 + (i7 * 12 | 0) + 8 >> 2] = i9;
 }
 HEAP8[i11 + 136 >> 0] = 1;
 i14 = 1;
 return i14 | 0;
}

function __ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i6, i3, i7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP16[i9 + 60 >> 1] | 0;
 i5 = HEAP16[(HEAP32[i7 >> 2] | 0) + 60 >> 1] | 0;
 if (i4 << 16 >> 16 != i5 << 16 >> 16) {
  i9 = i4 << 16 >> 16 > i5 << 16 >> 16;
  STACKTOP = i10;
  return i9 | 0;
 }
 f1 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f11 = Math_fround(f1 - f2);
 f11 = Math_fround(f11 * f11);
 if (f11 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  i9 = f1 > f2;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f14 = Math_fround(HEAPF32[i8 >> 2]);
  f14 = Math_fround(f14 + Math_fround(HEAPF32[i9 + 76 >> 2]));
  f13 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i9 + 80 >> 2]));
  f12 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f12 = Math_fround(f12 + Math_fround(HEAPF32[i9 + 84 >> 2]));
  i9 = HEAP32[i7 >> 2] | 0;
  __ZNK9Transform11GetPositionEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f17 = Math_fround(HEAPF32[i8 >> 2]);
  f17 = Math_fround(f17 + Math_fround(HEAPF32[i9 + 76 >> 2]));
  f16 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f16 = Math_fround(f16 + Math_fround(HEAPF32[i9 + 80 >> 2]));
  f15 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f15 = Math_fround(f15 + Math_fround(HEAPF32[i9 + 84 >> 2]));
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  f14 = Math_fround(f14 - f1);
  f2 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f13 = Math_fround(f13 - f2);
  f11 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f12 = Math_fround(f12 - f11);
  f1 = Math_fround(f17 - f1);
  f2 = Math_fround(f16 - f2);
  f11 = Math_fround(f15 - f11);
  i9 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) + Math_fround(f12 * f12)) < Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)) + Math_fround(f11 * f11));
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function __ZN13TargetJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 76 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 88 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 92 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __Z20RegisterModule_WebGLv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 185;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 186;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 187;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 187;
 STACKTOP = i5;
 return;
}

function __Z20RegisterModule_Umbrav() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 191;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 192;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 193;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 193;
 STACKTOP = i5;
 return;
}

function __Z20RegisterModule_IMGUIv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 365;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 366;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 367;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 367;
 STACKTOP = i5;
 return;
}

function __Z20RegisterModule_Clothv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 255;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 256;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 257;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 257;
 STACKTOP = i5;
 return;
}

function __Z20RegisterModule_Audiov() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 292;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 293;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 294;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 294;
 STACKTOP = i5;
 return;
}

function __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i7, i8, i3, i2, i9, i10, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 i6 = i2;
 if (!(i4 & 2)) i5 = 4; else if ((i6 - i3 | 0) < 3) i1 = 1; else {
  HEAP32[i9 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -17;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -69;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -65;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L4;
   }
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 >>> 0 > i10 >>> 0 | (i3 & -2048 | 0) == 55296) {
    i1 = 2;
    break L4;
   }
   do if (i3 >>> 0 < 128) {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i6 - i1 | 0) < 1) {
     i1 = 1;
     break L4;
    }
    HEAP32[i9 >> 2] = i1 + 1;
    HEAP8[i1 >> 0] = i3;
   } else {
    if (i3 >>> 0 < 2048) {
     i1 = HEAP32[i9 >> 2] | 0;
     if ((i6 - i1 | 0) < 2) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3 >>> 6 | 192;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 & 63 | 128;
     break;
    }
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = i6 - i1 | 0;
    if (i3 >>> 0 < 65536) {
     if ((i2 | 0) < 3) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3 >>> 12 | 224;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 >>> 6 & 63 | 128;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 & 63 | 128;
     break;
    } else {
     if ((i2 | 0) < 4) {
      i1 = 1;
      break L4;
     }
     HEAP32[i9 >> 2] = i1 + 1;
     HEAP8[i1 >> 0] = i3 >>> 18 | 240;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 >>> 12 & 63 | 128;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 >>> 6 & 63 | 128;
     i5 = HEAP32[i9 >> 2] | 0;
     HEAP32[i9 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i3 & 63 | 128;
     break;
    }
   } while (0);
   i1 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i13, i15) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0;
 i14 = i13 + 172 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i16 = i13 + 184 | 0;
 i17 = HEAP32[i16 >> 2] | 0;
 i11 = i1 + (i17 << 5) | 0;
 L1 : do if (!i17) {
  i2 = i1;
  i12 = 12;
 } else {
  i10 = HEAP32[i15 >> 2] | 0;
  i3 = HEAP32[i15 + 4 >> 2] | 0;
  i4 = HEAP32[i15 + 8 >> 2] | 0;
  i5 = HEAP32[i15 + 12 >> 2] | 0;
  i6 = HEAP32[i15 + 16 >> 2] | 0;
  i7 = HEAP32[i15 + 20 >> 2] | 0;
  i8 = HEAP32[i15 + 24 >> 2] | 0;
  i9 = HEAP32[i15 + 28 >> 2] | 0;
  i2 = i1;
  do {
   if ((HEAP32[i2 >> 2] | 0) == (i10 | 0)) if ((HEAP32[i2 + 4 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i2 + 8 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i2 + 16 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i2 + 20 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i2 + 24 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i2 + 28 >> 2] | 0) == (i9 | 0)) {
    i12 = 12;
    break L1;
   }
   i2 = i2 + 32 | 0;
  } while ((i2 | 0) != (i11 | 0));
 } while (0);
 if ((i12 | 0) == 12) if ((i2 | 0) != (i11 | 0)) return;
 i6 = i17 + 1 | 0;
 i3 = i13 + 188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i6 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 5, 4, i13 + 176 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i14 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 4, i13 + 176 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i16 >> 2] << 5 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i14 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i16 >> 2] = i6;
 i17 = i1 + (i17 << 5) | 0;
 HEAP32[i17 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i17 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i17 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i17 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i17 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i17 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 HEAP32[i17 + 24 >> 2] = HEAP32[i15 + 24 >> 2];
 HEAP32[i17 + 28 >> 2] = HEAP32[i15 + 28 >> 2];
 return;
}

function __ZN14NavMeshCarving17ApplyCarveResultsEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 4 | 0;
 i2 = i12;
 if ((HEAP16[gb + 1459104 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459104 | 0, i1);
  i10 = gb + 1459104 | 0;
 } else i10 = 0;
 if (HEAP32[i11 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i11);
 i8 = i11 + 80 | 0;
 i9 = i11 + 84 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i2 = i7;
 if ((i1 | 0) == (i7 | 0)) i4 = i2; else {
  i7 = i11 + 92 | 0;
  i6 = 0;
  do {
   i5 = HEAP32[i2 + (i6 << 5) >> 2] | 0;
   i3 = HEAP32[i2 + (i6 << 5) + 4 >> 2] | 0;
   i1 = HEAP32[i2 + (i6 << 5) + 8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i4 + (i6 * 12 | 0) + 8 >> 2] | 0;
   if ((i2 | 0) == 1) __ZN14NavMeshManager13RestoreTileAtEiii(__Z17GetNavMeshManagerv() | 0, i5, i3, i1); else {
    __ZN14NavMeshManager12RemoveTileAtEiii(__Z17GetNavMeshManagerv() | 0, i5, i3, i1);
    if (!i2) {
     i2 = i4 + (i6 * 12 | 0) | 0;
     if (HEAP32[i2 >> 2] | 0) {
      i1 = i4 + (i6 * 12 | 0) + 4 | 0;
      if ((HEAP32[i1 >> 2] | 0) > 0) {
       i4 = __Z17GetNavMeshManagerv() | 0;
       __ZN14NavMeshManager7AddTileEPhii(i4, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, i5);
      }
     }
    }
   }
   i6 = i6 + 1 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
   i2 = i5;
  } while (i6 >>> 0 < i1 - i5 >> 5 >>> 0);
  i4 = i2;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1 + -32 | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i11 + 92 | 0;
 i2 = i11 + 108 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i11 + 96 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i11 + 104 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i12;
 return;
}

function __Z37GeomOverlapCallback_SphereHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 24 | 0;
 i7 = i1;
 f13 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i5 + 16 >> 2]));
 f15 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i5 + 20 >> 2]));
 f18 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f13 = Math_fround(f13 * Math_fround(2.0));
 f15 = Math_fround(f15 * Math_fround(2.0));
 f18 = Math_fround(Math_fround(f18 - Math_fround(HEAPF32[i5 + 24 >> 2])) * Math_fround(2.0));
 f16 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(f13 * f14);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f15 * f12));
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f18 * f11));
 f10 = Math_fround(Math_fround(f14 * f8) + Math_fround(Math_fround(f13 * f17) - Math_fround(f16 * Math_fround(Math_fround(f18 * f12) - Math_fround(f15 * f11)))));
 f9 = Math_fround(Math_fround(f12 * f8) + Math_fround(Math_fround(f15 * f17) - Math_fround(f16 * Math_fround(Math_fround(f13 * f11) - Math_fround(f18 * f14)))));
 f8 = Math_fround(Math_fround(Math_fround(f18 * f17) - Math_fround(f16 * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12)))) + Math_fround(f11 * f8));
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAPF32[i6 >> 2] = f10;
 HEAPF32[i6 + 4 >> 2] = f9;
 HEAPF32[i6 + 8 >> 2] = f8;
 HEAP32[i6 + 12 >> 2] = i5;
 HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 i5 = __ZN5physx2Gu26intersectHeightFieldSphereERKNS0_15HeightFieldUtilERKNS0_6SphereE(i7, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __Z28LogToPlayerConnectionMessage7LogTypeN17GeneralConnection9MessageIDEPKcPi(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 16 | 0;
 i9 = i12;
 i1 = HEAP32[gb + 1163120 >> 2] | 0;
 if (!(HEAP32[i1 + 96 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i10 = i1 + 140 | 0;
 if (!(HEAP8[i10 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP8[i10 >> 0] = 0;
 i2 = __Z13VFormatLengthPKcPi(i5, i6) | 0;
 i3 = i2 + 1 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i9 + 4 | 0;
 i13 = gb + 63160 | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i7 = i11;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 do if (!i3) {
  i7 = 0;
  i1 = 0;
 } else if (i3 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i7 = i1;
  i1 = 0;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, gb + 64016 | 0, 0, gb + 459789 | 0, 474) | 0;
  i13 = gb + 64016 | 0;
  i14 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  i7 = i11;
  HEAP32[i7 >> 2] = i14;
  HEAP32[i7 + 4 >> 2] = i13;
  i7 = i1;
  break;
 } while (0);
 __Z13VFormatBufferPciPKcPi(i7, i3, i5, i6) | 0;
 if ((i2 | 0) > -1 & (i7 | 0) != 0) if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[gb + 1163120 >> 2] | 0;
  HEAP16[i8 >> 1] = 20111;
  HEAP16[i8 + 2 >> 1] = i4;
  HEAP32[i8 + 4 >> 2] = i2;
  i4 = i3 + 140 | 0;
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i4 >> 0] = 0;
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  i3 = i3 + 92 | 0;
  if ((i2 | 0) != (i3 | 0)) {
   while (1) {
    __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv(HEAP32[i2 + 20 >> 2] | 0, i8, i7);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP8[i4 >> 0] = i5;
 }
 HEAP8[i10 >> 0] = 1;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i12;
 return;
}

function _per_scan_setup(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = i6 + 228 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((i1 | 0) == 1) {
  i5 = HEAP32[i6 + 232 >> 2] | 0;
  HEAP32[i6 + 248 >> 2] = HEAP32[i5 + 28 >> 2];
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  HEAP32[i6 + 252 >> 2] = i4;
  HEAP32[i5 + 52 >> 2] = 1;
  HEAP32[i5 + 56 >> 2] = 1;
  HEAP32[i5 + 60 >> 2] = 1;
  HEAP32[i5 + 64 >> 2] = 8;
  HEAP32[i5 + 68 >> 2] = 1;
  i3 = HEAP32[i5 + 12 >> 2] | 0;
  i4 = (i4 >>> 0) % (i3 >>> 0) | 0;
  HEAP32[i5 + 72 >> 2] = (i4 | 0) == 0 ? i3 : i4;
  HEAP32[i6 + 256 >> 2] = 1;
  HEAP32[i6 + 260 >> 2] = 0;
 } else {
  if ((i1 + -1 | 0) >>> 0 > 3) {
   i4 = HEAP32[i6 >> 2] | 0;
   HEAP32[i4 + 20 >> 2] = 26;
   HEAP32[i4 + 24 >> 2] = i1;
   HEAP32[i4 + 28 >> 2] = 4;
   mftCall_vi(HEAP32[i4 >> 2] | 0, i6 | 0);
  }
  HEAP32[i6 + 248 >> 2] = _jdiv_round_up(HEAP32[i6 + 28 >> 2] | 0, HEAP32[i6 + 216 >> 2] << 3) | 0;
  HEAP32[i6 + 252 >> 2] = _jdiv_round_up(HEAP32[i6 + 32 >> 2] | 0, HEAP32[i6 + 220 >> 2] << 3) | 0;
  i4 = i6 + 256 | 0;
  HEAP32[i4 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i1 = 0;
   i3 = 0;
   while (1) {
    i7 = HEAP32[i6 + 232 + (i1 << 2) >> 2] | 0;
    i10 = HEAP32[i7 + 8 >> 2] | 0;
    HEAP32[i7 + 52 >> 2] = i10;
    i9 = HEAP32[i7 + 12 >> 2] | 0;
    HEAP32[i7 + 56 >> 2] = i9;
    i2 = Math_imul(i9, i10) | 0;
    HEAP32[i7 + 60 >> 2] = i2;
    HEAP32[i7 + 64 >> 2] = i10 << 3;
    i8 = ((HEAP32[i7 + 28 >> 2] | 0) >>> 0) % (i10 >>> 0) | 0;
    HEAP32[i7 + 68 >> 2] = (i8 | 0) == 0 ? i10 : i8;
    i8 = ((HEAP32[i7 + 32 >> 2] | 0) >>> 0) % (i9 >>> 0) | 0;
    HEAP32[i7 + 72 >> 2] = (i8 | 0) == 0 ? i9 : i8;
    if ((i3 + i2 | 0) > 10) {
     i10 = HEAP32[i6 >> 2] | 0;
     HEAP32[i10 + 20 >> 2] = 13;
     mftCall_vi(HEAP32[i10 >> 2] | 0, i6 | 0);
    }
    if ((i2 | 0) > 0) while (1) {
     i10 = HEAP32[i4 >> 2] | 0;
     HEAP32[i4 >> 2] = i10 + 1;
     HEAP32[i6 + 260 + (i10 << 2) >> 2] = i1;
     if ((i2 | 0) > 1) i2 = i2 + -1 | 0; else break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (HEAP32[i5 >> 2] | 0)) break L1;
    i3 = HEAP32[i4 >> 2] | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i6 + 192 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 i10 = Math_imul(HEAP32[i6 + 248 >> 2] | 0, i1) | 0;
 HEAP32[i6 + 188 >> 2] = (i10 | 0) < 65535 ? i10 : 65535;
 return;
}

function __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE8__appendEj(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (((i1 - i3 | 0) / 156 | 0) >>> 0 >= i5 >>> 0) {
  __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE18__construct_at_endEj(i9, i5);
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = ((i3 - i2 | 0) / 156 | 0) + i5 | 0;
 if (i4 >>> 0 > 27531841) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i1 - i2 | 0) / 156 | 0;
 i1 = i8 << 1;
 i1 = i8 >>> 0 < 13765920 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 27531841;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i9 + 8;
 if (!i1) i4 = 0; else i4 = __Znwj(i1 * 156 | 0) | 0;
 HEAP32[i12 >> 2] = i4;
 i6 = i4 + (((i3 - i2 | 0) / 156 | 0) * 156 | 0) | 0;
 i8 = i12 + 8 | 0;
 HEAP32[i8 >> 2] = i6;
 i7 = i12 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 i6 = i12 + 12 | 0;
 HEAP32[i6 >> 2] = i4 + (i1 * 156 | 0);
 __ZNSt3__214__split_bufferI14SubstanceInputRNS_9allocatorIS1_EEE18__construct_at_endEj(i12, i5);
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = i7;
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  do {
   i2 = i2 + -156 | 0;
   __ZN14SubstanceInputC2ERKS_(i1 + -156 | 0, i2);
   i1 = (HEAP32[i7 >> 2] | 0) + -156 | 0;
   HEAP32[i7 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i4 = i7;
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2;
  do {
   i11 = i1 + -156 | 0;
   HEAP32[i8 >> 2] = i11;
   __ZN14SubstanceInputD2Ev(i11);
   i1 = HEAP32[i8 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN8LODGroup10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 32 | 0;
 i6 = i9;
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i7 = i6 + 24 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAPF32[i6 >> 2] = Math_fround(.600000024);
 i4 = i1 + 56 | 0;
 i5 = i1 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 64 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i6);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i11 = i6;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = i2;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = i10;
  __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + 8 | 0, i6 + 8 | 0);
  i1 = (HEAP32[i5 >> 2] | 0) + 28 | 0;
  HEAP32[i5 >> 2] = i1;
 }
 HEAPF32[i6 >> 2] = Math_fround(.300000012);
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i6);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = i6;
  i10 = HEAP32[i2 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i1 + 8 | 0, i6 + 8 | 0);
  i1 = (HEAP32[i5 >> 2] | 0) + 28 | 0;
  HEAP32[i5 >> 2] = i1;
 }
 HEAPF32[i6 >> 2] = Math_fround(.100000001);
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i6);
  i1 = i6 + 8 | 0;
 } else {
  i4 = i6;
  i10 = HEAP32[i4 + 4 >> 2] | 0;
  i11 = i1;
  HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i11 + 4 >> 2] = i10;
  i11 = i6 + 8 | 0;
  __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i1 + 8 | 0, i11);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 28;
  i1 = i11;
 }
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8);
 HEAP32[i6 + 8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5Umbra9Matrix4x36invertERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f18 = Math_fround(Math_fround(f11 * f16) - Math_fround(f15 * f3));
 f14 = Math_fround(Math_fround(f15 * f12) - Math_fround(f9 * f16));
 f5 = Math_fround(Math_fround(f9 * f3) - Math_fround(f11 * f12));
 f13 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f17 * f5) + Math_fround(Math_fround(f10 * f18) + Math_fround(f7 * f14))));
 f18 = Math_fround(f18 * f13);
 f14 = Math_fround(f14 * f13);
 f5 = Math_fround(f5 * f13);
 f10 = Math_fround(f10 * f13);
 f7 = Math_fround(f7 * f13);
 f13 = Math_fround(f17 * f13);
 f17 = Math_fround(Math_fround(f3 * f13) - Math_fround(f16 * f7));
 f19 = Math_fround(Math_fround(f15 * f7) - Math_fround(f11 * f13));
 HEAPF32[i1 >> 2] = f18;
 HEAPF32[i1 + 4 >> 2] = f17;
 HEAPF32[i1 + 8 >> 2] = f19;
 HEAPF32[i1 + 12 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f19) + Math_fround(Math_fround(f6 * f18) + Math_fround(f4 * f17))));
 f15 = Math_fround(Math_fround(f9 * f13) - Math_fround(f15 * f10));
 f13 = Math_fround(Math_fround(f16 * f10) - Math_fround(f12 * f13));
 HEAPF32[i1 + 16 >> 2] = f14;
 HEAPF32[i1 + 20 >> 2] = f13;
 HEAPF32[i1 + 24 >> 2] = f15;
 HEAPF32[i1 + 28 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f15) + Math_fround(Math_fround(f6 * f14) + Math_fround(f4 * f13))));
 f3 = Math_fround(Math_fround(f12 * f7) - Math_fround(f3 * f10));
 f7 = Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f7));
 HEAPF32[i1 + 32 >> 2] = f5;
 HEAPF32[i1 + 36 >> 2] = f3;
 HEAPF32[i1 + 40 >> 2] = f7;
 HEAPF32[i1 + 44 >> 2] = Math_fround(-Math_fround(Math_fround(f8 * f7) + Math_fround(Math_fround(f6 * f5) + Math_fround(f4 * f3))));
 return i1 | 0;
}

function __ZN5Umbra13MatrixFactory6rotateEffff(i5, f6, f4, f1, f2) {
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f3 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 i8 = i5 + 4 | 0;
 i9 = i5 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 i10 = i5 + 24 | 0;
 i11 = i5 + 40 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAPF32[i11 >> 2] = Math_fround(1.0);
 i12 = i5 + 44 | 0;
 i7 = i5 + 60 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 if (!(f6 != Math_fround(0.0))) return;
 if (!(f4 != Math_fround(0.0) | f1 != Math_fround(0.0) | f2 != Math_fround(0.0))) return;
 f3 = Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f1 * f1)) + Math_fround(f2 * f2));
 if (f3 != Math_fround(0.0)) {
  d13 = 1.0 / +Math_sqrt(+(+f3));
  f4 = Math_fround(+f4 * d13);
  f2 = Math_fround(+f2 * d13);
  f1 = Math_fround(+f1 * d13);
 }
 f20 = Math_fround(f1 * f2);
 f15 = Math_fround(+Math_cos(+f6));
 f16 = Math_fround(+Math_sin(+f6));
 f6 = Math_fround(Math_fround(1.0) - f15);
 f19 = Math_fround(Math_fround(f4 * f1) * f6);
 f18 = Math_fround(f2 * f16);
 f21 = Math_fround(f19 + f18);
 f14 = Math_fround(Math_fround(f4 * f2) * f6);
 f3 = Math_fround(f1 * f16);
 f17 = Math_fround(f14 - f3);
 HEAPF32[i5 >> 2] = Math_fround(f15 + Math_fround(Math_fround(f4 * f4) * f6));
 HEAPF32[i5 + 16 >> 2] = f21;
 HEAPF32[i5 + 32 >> 2] = f17;
 f17 = Math_fround(f15 + Math_fround(Math_fround(f1 * f1) * f6));
 f1 = Math_fround(f20 * f6);
 f4 = Math_fround(f4 * f16);
 f16 = Math_fround(f1 + f4);
 HEAPF32[i8 >> 2] = Math_fround(f19 - f18);
 HEAPF32[i9 >> 2] = f17;
 HEAPF32[i5 + 36 >> 2] = f16;
 f4 = Math_fround(f1 - f4);
 f6 = Math_fround(f15 + Math_fround(Math_fround(f2 * f2) * f6));
 HEAPF32[i5 + 8 >> 2] = Math_fround(f14 + f3);
 HEAPF32[i10 >> 2] = f4;
 HEAPF32[i11 >> 2] = f6;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i7 >> 2] = 1065353216;
 return;
}

function __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i13 = i9 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((i3 - i1 | 0) / 72 | 0) >>> 0 >= i2 >>> 0) {
  do {
   __ZN8GradientC2Ev(i1);
   i1 = (HEAP32[i13 >> 2] | 0) + 72 | 0;
   HEAP32[i13 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i14;
  return;
 }
 i11 = i9 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 72 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 72 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 72 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i5 + (((i1 - i4 | 0) / 72 | 0) * 72 | 0) | 0;
 i6 = i4;
 i3 = i5 + (i3 * 72 | 0) | 0;
 i8 = i6;
 i1 = i4;
 do {
  __ZN8GradientC2Ev(i1);
  i1 = i8 + 72 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  i2 = i6;
  i4 = i7;
  i1 = i7;
 } else {
  i2 = i4;
  do {
   i1 = i1 + -72 | 0;
   i2 = i2 + -72 | 0;
   i4 = i1;
   i5 = i2 + 72 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    i2 = i2 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i2 | 0) < (i5 | 0));
   i2 = i6 + -72 | 0;
   i6 = i2;
  } while ((i1 | 0) != (i7 | 0));
  i2 = i6;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i10 >> 2] = i3;
 i2 = i4;
 if ((i1 | 0) != (i2 | 0)) do i1 = i1 + -72 | 0; while ((i1 | 0) != (i2 | 0));
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i12);
 STACKTOP = i14;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i15 = HEAP32[i5 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f24 = Math_fround(-f12);
 f23 = Math_fround(-f13);
 f20 = Math_fround(-f14);
 f19 = Math_fround(HEAPF32[i15 + 96 >> 2]);
 f17 = Math_fround(HEAPF32[i15 + 100 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 104 >> 2]);
 f18 = Math_fround(HEAPF32[i15 + 112 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 116 >> 2]);
 f8 = Math_fround(HEAPF32[i15 + 120 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 128 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + 132 >> 2]);
 f10 = Math_fround(HEAPF32[i15 + 136 >> 2]);
 f22 = Math_fround(Math_fround(Math_fround(f19 * f24) + Math_fround(f17 * f23)) + Math_fround(f7 * f20));
 f21 = Math_fround(Math_fround(Math_fround(f18 * f24) + Math_fround(f6 * f23)) + Math_fround(f8 * f20));
 f20 = Math_fround(Math_fround(Math_fround(f9 * f24) + Math_fround(f11 * f23)) + Math_fround(f10 * f20));
 i15 = f22 > f21 & f22 > f20;
 i16 = f21 > f20;
 f9 = i15 ? f19 : i16 ? f18 : f9;
 f11 = i15 ? f17 : i16 ? f6 : f11;
 f10 = i15 ? f7 : i16 ? f8 : f10;
 i16 = HEAP32[i5 + 8 >> 2] | 0;
 i15 = f12 > Math_fround(0.0);
 i1 = f13 > Math_fround(0.0);
 i5 = f14 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f6 = Math_fround(-f12);
 f8 = i15 ? f14 : f8;
 f7 = i1 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f11 = f0, f12 = f0, f13 = f0;
 i8 = i10 + 28 | 0;
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 if (f7 == f9) {
  f7 = Math_fround(HEAPF32[i10 + 32 >> 2]);
  f1 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  if (f7 == f1) {
   f7 = Math_fround(HEAPF32[i10 + 36 >> 2]);
   if (f7 == Math_fround(HEAPF32[i3 + 8 >> 2])) return;
  }
 } else {
  f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f1 = f7;
  i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 }
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(f1 * Math_fround(0.0));
 f5 = Math_fround(f7 * Math_fround(0.0));
 f6 = Math_fround(f5 + Math_fround(f4 + f9));
 if (!(f6 <= Math_fround(-.999989986))) {
  f13 = Math_fround(f9 * Math_fround(0.0));
  f6 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 + Math_fround(1.0)) * Math_fround(2.0))));
  f12 = Math_fround(Math_fround(1.0) / f6);
  f11 = Math_fround(Math_fround(f5 - f4) * f12);
  f5 = Math_fround(Math_fround(f13 - f7) * f12);
  f4 = Math_fround(Math_fround(f1 - f13) * f12);
  f1 = Math_fround(f6 * Math_fround(.5));
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f11 * f11) + Math_fround(f5 * f5)))))));
  f1 = Math_fround(f1 * f6);
  f4 = Math_fround(f4 * f6);
  f5 = Math_fround(f5 * f6);
  f6 = Math_fround(f11 * f6);
 } else {
  i3 = Math_fround(Math_abs(Math_fround(1.0))) < Math_fround(.100000001);
  f4 = i3 ? Math_fround(-0.0) : Math_fround(0.0);
  f13 = i3 ? Math_fround(0.0) : Math_fround(-1.0);
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f13 * f13) + Math_fround(0.0))) + Math_fround(0.0)))));
  f6 = Math_fround(f5 * Math_fround(0.0));
  f1 = f6;
  f4 = Math_fround(f4 * f5);
  f5 = Math_fround(f13 * f5);
 }
 HEAPF32[i10 + 12 >> 2] = f6;
 HEAPF32[i10 + 16 >> 2] = f5;
 HEAPF32[i10 + 20 >> 2] = f4;
 HEAPF32[i10 + 24 >> 2] = f1;
 HEAPF32[i8 >> 2] = f9;
 HEAP32[i10 + 32 >> 2] = i2;
 HEAPF32[i10 + 36 >> 2] = f7;
 return;
}

function __ZN11UnityEngine15CloudWebService16WWWRestHeaderMapaSERKS1_(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i12 = i14;
 if ((i10 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return i10 | 0;
 }
 i2 = i10 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i10, HEAP32[i2 >> 2] | 0);
 i13 = i10 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i8 = i1 + 4 | 0;
 if ((i3 | 0) == (i8 | 0)) {
  STACKTOP = i14;
  return i10 | 0;
 }
 i7 = i10 + 4 | 0;
 i6 = i3;
 i1 = i3;
 while (1) {
  i4 = i6 + 16 | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
  i5 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_(i10, i9, i11, i4) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   i3 = __Znwj(40) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 16 | 0, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 28 | 0, i6 + 28 | 0);
   i4 = HEAP32[i11 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   i4 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i10 >> 2] = i4;
    i3 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i3);
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
    i1 = i3;
    break;
   } else i1 = i3;
  } else {
   i1 = i3;
   while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
  }
  if ((i1 | 0) == (i8 | 0)) break; else i6 = i1;
 }
 STACKTOP = i14;
 return i10 | 0;
}

function __Z17RegisterModule_VRv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 411;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 412;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 413;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 413;
 STACKTOP = i5;
 return;
}

function __Z17RegisterModule_UIv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 354;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 355;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 356;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 356;
 STACKTOP = i5;
 return;
}

function __Z17RegisterModule_AIv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 20 | 0;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 272;
 i2 = __ZN13ModuleManager3GetEv() | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 273;
 i1 = __ZN13ModuleManager3GetEv() | 0;
 i2 = i1 + 2312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 274;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 1544 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 1544 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 274;
 STACKTOP = i5;
 return;
}

function __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE(i2, f9, f10, f11, i12, i13) {
 i2 = i2 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0, f15 = f0, f16 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 4 | 0;
 i5 = i14;
 i6 = HEAP32[i2 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i6 + (i12 * 180 | 0) + 168 >> 2]);
 i3 = HEAP32[i6 + (i12 * 180 | 0) >> 2] | 0;
 i2 = HEAP32[i3 + 40 >> 2] | 0;
 if ((i2 | 0) == 1) {
  f11 = Math_fround(f1 * Math_fround(16.0));
  f1 = (HEAP32[i3 + 96 >> 2] | 0) == 0 ? f1 : f11;
 } else {
  f15 = Math_fround(HEAPF32[i3 + 264 >> 2]);
  f16 = Math_fround(HEAPF32[i3 + 268 >> 2]);
  f15 = Math_fround(f9 - f15);
  f9 = Math_fround(f10 - f16);
  f10 = Math_fround(f11 - Math_fround(HEAPF32[i3 + 272 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
  f10 = Math_fround(HEAPF32[i3 + 204 >> 2]);
  f11 = Math_fround(HEAPF32[i3 + 48 >> 2]);
  f11 = (i2 | 0) == 3 ? f10 : f11;
  HEAPF32[i5 >> 2] = Math_fround(f11 * f11);
  f1 = Math_fround(f1 * Math_fround(__Z20LightAttenuateApproxRKfS0_(i4, i5)));
 }
 f1 = Math_fround(f1 + Math_fround(__Z21GetRenderModeSortBias15LightRenderMode(HEAP32[i6 + (i12 * 180 | 0) + 128 >> 2] | 0)));
 i3 = i13 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i13 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 3, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i13 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i13 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 + (i4 << 3) >> 2] = i12;
 HEAPF32[i13 + (i4 << 3) + 4 >> 2] = f1;
 STACKTOP = i14;
 return;
}

function __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 24 | 0;
 i2 = i10 + 20 | 0;
 i9 = i10;
 if (HEAP32[gb + 1170808 >> 2] | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i5);
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i9 + 16 >> 2] = i8;
  i4 = __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE4findIS1_EENS_15__tree_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEERKT_(HEAP32[gb + 1170808 >> 2] | 0, i9) | 0;
  i7 = HEAP32[gb + 1170808 >> 2] | 0;
  if ((i4 | 0) != (i7 + 4 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   STACKTOP = i10;
   return;
  }
  i4 = __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE12__find_equalIS1_EERPNS_16__tree_node_baseIPvEESD_RKT_(i7, i2, i9) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i12 = HEAP32[i7 + 8 >> 2] | 0;
   HEAP32[i1 >> 2] = 70;
   HEAP32[i1 + 4 >> 2] = i12;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i9);
   i12 = i3;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i1 + 28 | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = i11;
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i4 >> 2] = i1;
   i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i7 >> 2] = i2;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
   i12 = i7 + 12 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1576256 | 0, 0, i6, i8, 0, 0);
 STACKTOP = i10;
 return;
}

function __Z24SetupActiveLightsContextR21ActiveLightingContextRK12ActiveLightsRK11CullResultsP14ShadowMapCacheRK10MinMaxAABB(i2, i3, i8, i12, i15) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 if (!(HEAP8[i3 + 20 >> 0] | 0)) i6 = 0; else i6 = HEAP32[i3 >> 2] | 0;
 i4 = (HEAP32[i3 + 32 >> 2] | 0) + (HEAP32[i3 + 24 >> 2] | 0) + (HEAP32[i3 + 28 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = i6;
 i7 = (i6 | 0) != 0;
 i9 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i4 + (i7 << 31 >> 31) | 0) * 12 | 0, 4, gb + 64016 | 0, 0, gb + 387852 | 0, 518) | 0;
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   i10 = HEAP32[i3 >> 2] | 0;
   i11 = i10 + (i1 * 180 | 0) | 0;
   if (!((i11 | 0) == (i6 | 0) ? 1 : (HEAP8[i10 + (i1 * 180 | 0) + 9 >> 0] | 0) == 0)) {
    i13 = HEAP32[i2 >> 2] | 0;
    i14 = HEAP32[i9 >> 2] | 0;
    HEAP32[i14 + (i13 * 12 | 0) >> 2] = i11;
    i17 = __Z20FindShadowMapInCacheP14ShadowMapCachei(i12, HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0) | 0;
    HEAP32[i14 + (i13 * 12 | 0) + 8 >> 2] = i17;
    if (!i17) if ((HEAP32[i10 + (i1 * 180 | 0) + 4 >> 2] | 0) == -1) i16 = 11; else {
     i17 = __Z18GetQualitySettingsv() | 0;
     if (!(HEAP32[(HEAP32[i17 + 28 >> 2] | 0) + ((HEAP32[i17 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0)) i16 = 11; else HEAP32[i14 + (i13 * 12 | 0) + 4 >> 2] = __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB(i8, i11, i15) | 0;
    } else i16 = 11;
    if ((i16 | 0) == 11) {
     i16 = 0;
     HEAP32[i14 + (i13 * 12 | 0) + 4 >> 2] = 0;
    }
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) return;
 HEAP32[i5 >> 2] = i6;
 i17 = __Z20FindShadowMapInCacheP14ShadowMapCachei(i12, HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0) | 0;
 HEAP32[i2 + 16 >> 2] = i17;
 if (!i17) if ((HEAP32[i6 + 4 >> 2] | 0) != -1) {
  i17 = __Z18GetQualitySettingsv() | 0;
  if (HEAP32[(HEAP32[i17 + 28 >> 2] | 0) + ((HEAP32[i17 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0) {
   HEAP32[i2 + 12 >> 2] = __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB(i8, i6, i15) | 0;
   return;
  }
 }
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __Z12InitGUIStatei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(352, gb + 63864 | 0, 16, gb + 1018102 | 0, 618) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 1065353216;
 HEAP32[i2 + 48 >> 2] = 1065353216;
 HEAP32[i2 + 52 >> 2] = 1065353216;
 HEAP32[i2 + 56 >> 2] = 1065353216;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i2 + 32 >> 2] = 1065353216;
 HEAP32[i2 + 36 >> 2] = 1065353216;
 HEAP32[i2 + 40 >> 2] = 1065353216;
 HEAP32[i2 + 12 >> 2] = 1065353216;
 HEAP32[i2 + 16 >> 2] = 1065353216;
 HEAP32[i2 + 20 >> 2] = 1065353216;
 HEAP32[i2 + 24 >> 2] = 1065353216;
 HEAP32[i2 + 60 >> 2] = 1;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 1;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i3 = i2 + 252 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 + 332 >> 2] = 0;
 HEAP32[i2 + 328 >> 2] = i1;
 HEAP32[i2 + 280 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 340 >> 2] = 0;
 HEAPF32[i2 + 344 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 348 >> 2] = i1;
 i3 = gb + 1468832 + (i1 << 2) | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = HEAP32[gb + 1468876 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2;
  i2 = i4;
  i4 = i5 + 276 | 0;
  HEAP32[i4 >> 2] = i2;
  i4 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63864 | 0, 16, gb + 1018102 | 0, 620) | 0;
  i2 = i4 + 44 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i2 = i3 + 280 | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = i3 + 284 | 0;
  HEAP8[i3 >> 0] = 1;
  __ZN10InputEvent4InitEi(i4, i1);
  return;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63864 | 0, 16, gb + 1018102 | 0, 94) | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP8[i4 + 8 >> 0] = 1;
 HEAP32[gb + 1468876 >> 2] = i4;
 i5 = HEAP32[i3 >> 2] | 0;
 i5 = i5 + 276 | 0;
 HEAP32[i5 >> 2] = i4;
 i5 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63864 | 0, 16, gb + 1018102 | 0, 620) | 0;
 i4 = i5 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = i4 + 280 | 0;
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 284 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZN10InputEvent4InitEi(i5, i1);
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i16 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = 1 - i1 | 0;
 i17 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f8 = Math_fround(HEAPF32[i17 + (i1 << 4) >> 2]);
 f15 = Math_fround(HEAPF32[i17 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i17 + (i1 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f15 = Math_fround(f8 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f13 + f12);
 f11 = Math_fround(f14 + Math_fround(f15 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 152 >> 2]);
 f9 = Math_fround(-f15);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f9 = HEAP32[gb + 48 + (i2 << 4) >> 2] | 0 ? f15 : f9;
 f8 = HEAP32[gb + 48 + (i2 << 4) + 4 >> 2] | 0 ? f14 : f8;
 f7 = HEAP32[gb + 48 + (i2 << 4) + 8 >> 2] | 0 ? f13 : f7;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9ShaderLab9IntShader27DeleteUnsupportedSubShadersEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i12 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = (HEAP32[i8 >> 2] | 0) - i2 >> 2;
 L1 : do if (!i1) i6 = i12 + 16 | 0; else {
  i11 = i12 + 96 | 0;
  i6 = i12 + 16 | 0;
  i9 = i12 + 20 | 0;
  i10 = i12 + 12 | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   if (!(__ZN9ShaderLab9SubShader20IsSubShaderSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(HEAP32[i2 + (i1 << 2) >> 2] | 0, i11) | 0)) {
    i7 = (HEAP32[i12 >> 2] | 0) + (i1 << 2) | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i7); else {
     HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 4;
    }
    i2 = i7 + 4 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
    i4 = i3 - i2 | 0;
    i5 = i4 >> 2;
    if (i5) {
     _memmove(i7 | 0, i2 | 0, i4 | 0) | 0;
     i3 = HEAP32[i8 >> 2] | 0;
    }
    i2 = i7 + (i5 << 2) | 0;
    if ((i3 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   }
   if (!i1) break L1;
   i2 = HEAP32[i12 >> 2] | 0;
  }
 } while (0);
 i5 = i12 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) return;
 while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i4 = i3 + 12 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    do {
     __ZN9ShaderLab4Pass7ReleaseEv(HEAP32[i2 >> 2] | 0);
     i2 = i2 + 4 | 0;
    } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
   }
   __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i3 + 24 | 0, HEAP32[i3 + 28 >> 2] | 0);
   if ((HEAP32[i3 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
    HEAP32[i3 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  HEAP32[i1 >> 2] = 0;
  i3 = i1 + 4 | 0;
  if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) break; else i1 = i3;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 HEAP32[i6 >> 2] = i3 + (~((i1 - i2 | 0) >>> 2) << 2);
 return;
}

function __Z32Collider_Get_Custom_PropMaterialP12Il2CppObject(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i2 = i9;
 i8 = i9 + 4 | 0;
 if (!i7) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) {
  i4 = i7;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN8Collider11GetMaterialEv(i1) | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 12;
   }
  }
  if ((i5 | 0) == 10) i5 = 12;
  if ((i5 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 i2 = __ZN14PhysicMaterial23GetInstantiatedMaterialEPS_R6Object(i1, i2) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 HEAP32[i8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE(i1, i6);
 i10 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 << 6) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 64 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 56 | 0, gb + 842460 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 72 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 68 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 69 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i5, i4 + 44 | 0, gb + 1034411 | 0, 0);
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function _UNITY_png_text_compress(i13, i1, i17, i14) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i17 = i17 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i15 = i17 + 4 | 0;
 i1 = _UNITY_png_deflate_claim(i13, i1, HEAP32[i15 >> 2] | 0) | 0;
 if (i1 | 0) {
  i17 = i1;
  return i17 | 0;
 }
 i2 = HEAP32[i15 >> 2] | 0;
 i7 = i13 + 220 | 0;
 HEAP32[i7 >> 2] = HEAP32[i17 >> 2];
 i8 = i13 + 224 | 0;
 HEAP32[i8 >> 2] = 0;
 i16 = i17 + 12 | 0;
 i9 = i13 + 232 | 0;
 HEAP32[i9 >> 2] = i16;
 i10 = i13 + 236 | 0;
 HEAP32[i10 >> 2] = 1024;
 i11 = i13 + 280 | 0;
 i3 = 1024;
 i1 = i13 + 276 | 0;
 i4 = 1024;
 do {
  HEAP32[i8 >> 2] = i2;
  do if (!i4) if ((i3 + i14 | 0) < 0) {
   i2 = 0;
   i5 = 2;
   i6 = -4;
  } else {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = _UNITY_png_malloc_base(i13, (HEAP32[i11 >> 2] | 0) + 4 | 0) | 0;
    if (!i2) {
     i2 = 0;
     i5 = 2;
     i6 = -4;
     break;
    }
    HEAP32[i2 >> 2] = 0;
    HEAP32[i1 >> 2] = i2;
    i1 = i2;
   } else i1 = i2;
   HEAP32[i9 >> 2] = i1 + 4;
   i12 = HEAP32[i11 >> 2] | 0;
   HEAP32[i10 >> 2] = i12;
   i3 = i12 + i3 | 0;
   i12 = 9;
  } else i12 = 9; while (0);
  if ((i12 | 0) == 9) {
   i12 = 0;
   i6 = _unity_z_deflate(i7, 4) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   i5 = 0;
  }
  i4 = HEAP32[i10 >> 2] | 0;
 } while (!(i5 | i6 | 0));
 i12 = i3 - i4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = i12;
 if ((i12 + i14 | 0) >>> 0 > 2147483646) {
  HEAP32[i13 + 244 >> 2] = gb + 355039;
  HEAP32[i13 + 216 >> 2] = 0;
  i17 = -4;
  return i17 | 0;
 }
 _UNITY_png_zstream_error(i13, i6);
 HEAP32[i13 + 216 >> 2] = 0;
 if (!((i6 | 0) == 1 & (i2 | 0) == 0)) {
  i17 = i6;
  return i17 | 0;
 }
 i3 = HEAP32[i15 >> 2] | 0;
 if (i3 >>> 0 >= 16385) {
  i17 = 0;
  return i17 | 0;
 }
 i1 = HEAPU8[i16 >> 0] | 0;
 if (!((i1 & 15 | 0) == 8 & (i1 & 240) >>> 0 < 113)) {
  i17 = 0;
  return i17 | 0;
 }
 i1 = i1 >>> 4;
 i2 = 1 << i1 + 7;
 if (i2 >>> 0 < i3 >>> 0) {
  i17 = 0;
  return i17 | 0;
 }
 do {
  i2 = i2 >>> 1;
  i1 = i1 + -1 | 0;
 } while (!((i1 | 0) == 0 | i2 >>> 0 < i3 >>> 0));
 i15 = i1 << 4 | 8;
 HEAP8[i16 >> 0] = i15;
 i17 = i17 + 13 | 0;
 i16 = (HEAPU8[i17 >> 0] | 0) & 224;
 HEAP8[i17 >> 0] = (((i16 | i15 << 8) >>> 0) % 31 | 0 | i16) ^ 31;
 i17 = 0;
 return i17 | 0;
}

function _pop_arg_481(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, d6 = 0.0;
 L1 : do if (i2 >>> 0 <= 20) do switch (i2 | 0) {
 case 9:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   HEAP32[i1 >> 2] = i2;
   break L1;
  }
 case 10:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   i4 = i1;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 11:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   i4 = i1;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = 0;
   break L1;
  }
 case 12:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   i2 = i4;
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 8;
   i4 = i1;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i4 + 4 >> 2] = i2;
   break L1;
  }
 case 13:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i4 = (i4 & 65535) << 16 >> 16;
   i5 = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 14:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i5 = i1;
   HEAP32[i5 >> 2] = i4 & 65535;
   HEAP32[i5 + 4 >> 2] = 0;
   break L1;
  }
 case 15:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i4 = (i4 & 255) << 24 >> 24;
   i5 = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 16:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i5 = i1;
   HEAP32[i5 >> 2] = i4 & 255;
   HEAP32[i5 + 4 >> 2] = 0;
   break L1;
  }
 case 17:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d6 = +HEAPF64[i5 >> 3];
   HEAP32[i3 >> 2] = i5 + 8;
   HEAPF64[i1 >> 3] = d6;
   break L1;
  }
 case 18:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d6 = +HEAPF64[i5 >> 3];
   HEAP32[i3 >> 2] = i5 + 8;
   HEAPF64[i1 >> 3] = d6;
   break L1;
  }
 default:
  break L1;
 } while (0); while (0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 619;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 618;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 617;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 616;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __Z32AddPathRemapsForBuiltinResourcesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6 + 12 | 0;
 i2 = i6;
 i7 = __Z20GetPersistentManagerv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 588322 | 0, 31);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 583999 | 0, 33);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i1, i2);
 __ZN17PersistentManager12SetPathRemapERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i7, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 584033 | 0, 29);
 i2 = i4 + 11 | 0;
 i7 = HEAP8[i2 >> 0] | 0;
 i1 = i7 << 24 >> 24 < 0;
 i3 = i4 + 4 | 0;
 if ((i1 ? HEAP32[i3 >> 2] | 0 : i7 & 255) | 0) {
  i1 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
  do {
   i8 = HEAP8[i1 >> 0] | 0;
   i7 = i8 << 24 >> 24;
   HEAP8[i1 >> 0] = (i8 + -65 & 255) < 26 ? i7 + 32 | 0 : i7;
   i1 = i1 + 1 | 0;
   i7 = HEAP8[i2 >> 0] | 0;
   i8 = i7 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i8 ? HEAP32[i4 >> 2] | 0 : i4) + (i8 ? HEAP32[i3 >> 2] | 0 : i7 & 255) | 0));
 }
 i8 = __Z20GetPersistentManagerv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 584033 | 0, 29);
 __ZN17PersistentManager12SetPathRemapERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i8, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __Z11GetTypePathRK16TypeTreeIteratorRNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = (HEAPU8[i3 + (i2 * 24 | 0) + 2 >> 0] | 0) + -1 | 0;
 i4 = i3 + (i2 * 24 | 0) | 0;
 while (1) {
  i5 = i4;
  i4 = i4 + -24 | 0;
  if (i4 >>> 0 < i3 >>> 0) break;
  if ((HEAPU8[i5 + -22 >> 0] | 0 | 0) == (i6 | 0)) {
   i8 = 5;
   break;
  }
 }
 if ((i8 | 0) == 5) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, gb + 913684 | 0) | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = (HEAPU8[i5 + (i3 * 24 | 0) + 2 >> 0] | 0) + -1 | 0;
  i3 = i5 + (i3 * 24 | 0) | 0;
  while (1) {
   i1 = i3;
   i3 = i3 + -24 | 0;
   if (i3 >>> 0 < i5 >>> 0) {
    i8 = 9;
    break;
   }
   if ((HEAPU8[i1 + -22 >> 0] | 0 | 0) == (i2 | 0)) {
    i8 = 8;
    break;
   }
  }
  if ((i8 | 0) == 8) {
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = (i3 - i5 | 0) / 24 | 0;
  } else if ((i8 | 0) == 9) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
  __Z11GetTypePathRK16TypeTreeIteratorRNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i7, i10);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i3 + (i2 * 24 | 0) + 8 >> 2] | 0;
 i8 = HEAP32[gb + 36932 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, ((i7 | 0) < 0 ? i8 : HEAP32[i1 + 20 >> 2] | 0) + (i7 & 2147483647) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i10, 40);
 i9 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP32[i11 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, ((i11 | 0) < 0 ? i8 : HEAP32[i9 + 20 >> 2] | 0) + (i11 & 2147483647) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i10, gb + 1087675 | 0) | 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i1, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i4 - i12 >> 2;
 i9 = i10 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i1 = i12;
 i7 = i8;
 i11 = i4;
 if (i6 >>> 0 <= i2 - i8 >> 2 >>> 0) {
  i9 = i10 + 4 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i8 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i12 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i8 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i7 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i9 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) return;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i9 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  return;
 }
 i4 = i8;
 if (i8) {
  i2 = i10 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i8 | 0) >>> 2) << 2);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i2 = 0;
 }
 if (i6 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i8 = i2 - i3 | 0;
 i2 = i8 >> 1;
 i2 = i8 >> 2 >>> 0 < 536870911 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 1073741823;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i4 = __Znwj(i2 << 2) | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i11 | 0)) return;
 i3 = i11 + -4 - i12 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 << 7) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     __ZN5physx2Sc13ConstraintSimD2Ev(i2);
    }
    i2 = i2 + 128 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EE6extendEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 4 | 0;
 i1 = i13;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13 + 8 | 0, 384, gb + 702172 | 0, 169) | 0;
 HEAP32[i11 >> 2] = i5;
 i10 = i5;
 if (!i5) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i6 = i12 + 12 | 0;
 i7 = i12 + 20 | 0;
 if ((HEAP32[i7 >> 2] & 2147483616) >>> 0 < 32) __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, 32);
 i9 = i12 + 4 | 0;
 i2 = i12 + 16 | 0;
 i8 = 31;
 while (1) {
  HEAP32[i5 + (i8 * 12 | 0) >> 2] = (HEAP32[i9 >> 2] << 5) + i8;
  i3 = i5 + (i8 * 12 | 0) | 0;
  HEAP32[i1 >> 2] = i3;
  i4 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i3;
   HEAP32[i2 >> 2] = i4 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i6, i1) | 0;
  if ((i8 | 0) > 0) i8 = i8 + -1 | 0; else break;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i12 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2] = i10;
  i1 = i1 + 1 | 0;
  HEAP32[i9 >> 2] = i1;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i12, i11) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i12 + 24 | 0;
 i7 = (i1 << 5) + -1 | 0;
 i4 = i1 & 134217727;
 i5 = i12 + 28 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i2 = i12 + 32 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i4 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i1 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i6 >> 2] | 0);
  }
  i12 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i12 & 2147483647) << 2) | 0, 0, i4 - i12 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 } else i1 = HEAP32[i6 >> 2] | 0;
 i12 = i1 + (i7 >>> 5 << 2) | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & 2147483647;
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN12_GLOBAL__N_115offsetTrianglesEPN5physx6PxVec3ES2_f(i1, i24, f25) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 f25 = Math_fround(f25);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, f15 = f0, i16 = 0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, f21 = f0, i22 = 0, f23 = f0, f26 = f0, f27 = f0;
 if (i1 >>> 0 >= i24 >>> 0) return;
 do {
  f7 = Math_fround(HEAPF32[i1 >> 2]);
  i16 = i1 + 4 | 0;
  f17 = Math_fround(HEAPF32[i16 >> 2]);
  i18 = i1 + 8 | 0;
  f19 = Math_fround(HEAPF32[i18 >> 2]);
  i20 = i1 + 12 | 0;
  f21 = Math_fround(HEAPF32[i20 >> 2]);
  i22 = i1 + 16 | 0;
  f23 = Math_fround(HEAPF32[i22 >> 2]);
  i8 = i1 + 20 | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  i10 = i1 + 24 | 0;
  f11 = Math_fround(HEAPF32[i10 >> 2]);
  i12 = i1 + 28 | 0;
  f13 = Math_fround(HEAPF32[i12 >> 2]);
  i14 = i1 + 32 | 0;
  f15 = Math_fround(HEAPF32[i14 >> 2]);
  f26 = Math_fround(f21 - f7);
  f3 = Math_fround(f23 - f17);
  f27 = Math_fround(f9 - f19);
  f2 = Math_fround(f11 - f7);
  f4 = Math_fround(f13 - f17);
  f5 = Math_fround(f15 - f19);
  f6 = Math_fround(Math_fround(f3 * f5) - Math_fround(f27 * f4));
  f5 = Math_fround(Math_fround(f27 * f2) - Math_fround(f26 * f5));
  f2 = Math_fround(Math_fround(f26 * f4) - Math_fround(f3 * f2));
  f3 = Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)));
  if (f3 > Math_fround(0.0)) {
   f27 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
   f4 = Math_fround(f2 * f27);
   f3 = Math_fround(f5 * f27);
   f2 = Math_fround(f6 * f27);
  } else {
   f4 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   f2 = Math_fround(0.0);
  }
  f6 = Math_fround(f2 * f25);
  f26 = Math_fround(f3 * f25);
  f27 = Math_fround(f4 * f25);
  f17 = Math_fround(f17 + f26);
  f19 = Math_fround(f19 + f27);
  HEAPF32[i1 >> 2] = Math_fround(f7 + f6);
  HEAPF32[i16 >> 2] = f17;
  HEAPF32[i18 >> 2] = f19;
  f19 = Math_fround(f23 + f26);
  f23 = Math_fround(f9 + f27);
  HEAPF32[i20 >> 2] = Math_fround(f21 + f6);
  HEAPF32[i22 >> 2] = f19;
  HEAPF32[i8 >> 2] = f23;
  f26 = Math_fround(f13 + f26);
  f27 = Math_fround(f15 + f27);
  HEAPF32[i10 >> 2] = Math_fround(f11 + f6);
  HEAPF32[i12 >> 2] = f26;
  HEAPF32[i14 >> 2] = f27;
  i1 = i1 + 36 | 0;
 } while (i1 >>> 0 < i24 >>> 0);
 return;
}

function __Z48Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff(i1, i2, i3, f4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i12 + 8 | 0;
 i13 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i17 = i14;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i10;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 i15 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN16Physics2DManager17OverlapCapsuleAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DP13dynamic_arrayIPS5_Lj4EE(i15, i14, i13, i3, f4, i5, f6, f7, 0, i11) | 0;
 i3 = __Z19GetScriptingManagerv() | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[gb + 32588 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i8 >> 2] | 0) | 0;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i3, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i5 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i3 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i3 | 0;
}

function __Z11PxcPoolFreePvj(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = HEAP32[gb + 1457392 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 do if (i2 >>> 0 < 9) {
  i3 = HEAP32[gb + 1457392 >> 2] | 0;
  if (!i4) {
   i2 = i3 + 288 | 0;
   i1 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  } else {
   i1 = i3 + 284 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i3 + 296 | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i4;
   i1 = i3 + 288 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
   HEAP32[i1 >> 2] = i2;
  }
  if ((i2 | 0) > ((HEAP32[i3 + 280 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i3 + 4 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } else {
  if (i2 >>> 0 < 17) {
   i3 = HEAP32[gb + 1457392 >> 2] | 0;
   if (!i4) {
    i2 = i3 + 584 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
   } else {
    i1 = i3 + 580 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
    i1 = i3 + 592 | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i1 >> 2] = i4;
    i1 = i3 + 584 | 0;
    i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
    HEAP32[i1 >> 2] = i2;
   }
   if ((i2 | 0) <= ((HEAP32[i3 + 576 >> 2] | 0) * 50 | 0)) break;
   __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i3 + 300 | 0);
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i2 >>> 0 >= 33) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i4);
   break;
  }
  i3 = HEAP32[gb + 1457392 >> 2] | 0;
  if (!i4) {
   i2 = i3 + 880 | 0;
   i1 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  } else {
   i1 = i3 + 876 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i3 + 888 | 0;
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i4;
   i1 = i3 + 880 | 0;
   i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
   HEAP32[i1 >> 2] = i2;
  }
  if ((i2 | 0) > ((HEAP32[i3 + 872 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i3 + 596 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIyyEEPyEEbT0_S5_T_(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 switch (i10 - i11 >> 3 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i5 = i10 + -8 | 0;
   i2 = i5;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i11;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 4 >> 2] = i2;
    i1 = i5;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i11 + 24 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i11 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i2, i1) | 0;
   i9 = i11 + 24 | 0;
   i1 = 0;
   while (1) {
    if ((i9 | 0) == (i10 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i8 = i9;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i4 = i2;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (i8 >>> 0 < i4 >>> 0 | (i8 | 0) == (i4 | 0) & i7 >>> 0 < i3 >>> 0) {
     i5 = i9;
     i6 = i3;
     while (1) {
      HEAP32[i5 >> 2] = i6;
      HEAP32[i5 + 4 >> 2] = i4;
      if ((i2 | 0) == (i11 | 0)) {
       i2 = i11;
       break;
      }
      i3 = i2 + -8 | 0;
      i4 = i3;
      i6 = HEAP32[i4 >> 2] | 0;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
      if (!(i8 >>> 0 < i4 >>> 0 | (i8 | 0) == (i4 | 0) & i7 >>> 0 < i6 >>> 0)) break; else {
       i5 = i2;
       i2 = i3;
      }
     }
     i6 = i2;
     HEAP32[i6 >> 2] = i7;
     HEAP32[i6 + 4 >> 2] = i8;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i9 + 8 | 0) == (i10 | 0);
      break;
     }
    }
    i2 = i9;
    i9 = i9 + 8 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 switch (i10 - i11 >> 3 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i5 = i10 + -8 | 0;
   i2 = i5;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i11;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i11 + 4 >> 2] = i2;
    i1 = i5;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i11, i11 + 8 | 0, i11 + 16 | 0, i11 + 24 | 0, i10 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i11 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i11, i11 + 8 | 0, i2, i1) | 0;
   i9 = i11 + 24 | 0;
   i1 = 0;
   while (1) {
    if ((i9 | 0) == (i10 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i8 = i9;
    i7 = HEAP32[i8 >> 2] | 0;
    i8 = HEAP32[i8 + 4 >> 2] | 0;
    i4 = i2;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i8 | 0) < (i4 | 0) | (i8 | 0) == (i4 | 0) & i7 >>> 0 < i3 >>> 0) {
     i5 = i9;
     i6 = i3;
     while (1) {
      HEAP32[i5 >> 2] = i6;
      HEAP32[i5 + 4 >> 2] = i4;
      if ((i2 | 0) == (i11 | 0)) {
       i2 = i11;
       break;
      }
      i3 = i2 + -8 | 0;
      i4 = i3;
      i6 = HEAP32[i4 >> 2] | 0;
      i4 = HEAP32[i4 + 4 >> 2] | 0;
      if (!((i8 | 0) < (i4 | 0) | (i8 | 0) == (i4 | 0) & i7 >>> 0 < i6 >>> 0)) break; else {
       i5 = i2;
       i2 = i3;
      }
     }
     i6 = i2;
     HEAP32[i6 >> 2] = i7;
     HEAP32[i6 + 4 >> 2] = i8;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i9 + 8 | 0) == (i10 | 0);
      break;
     }
    }
    i2 = i9;
    i9 = i9 + 8 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[(HEAP32[i6 + 4 >> 2] | 0) + 200 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i16 + (i1 * 12 | 0) + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i10 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i10 + 52 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 56 >> 2]);
 f9 = Math_fround(f15 * Math_fround(HEAPF32[i10 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 16 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 32 >> 2])));
 f8 = Math_fround(f15 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 20 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 36 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i10 + 8 >> 2]));
 f11 = Math_fround(f15 + Math_fround(f11 * Math_fround(HEAPF32[i10 + 24 >> 2])));
 f9 = Math_fround(f14 + f9);
 f8 = Math_fround(f13 + f8);
 f7 = Math_fround(f12 + Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i10 + 40 >> 2]))));
 i6 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 200 >> 2] | 0;
 i10 = HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAPF32[i4 >> 2] = f9;
 HEAPF32[i4 + 4 >> 2] = f8;
 HEAPF32[i4 + 8 >> 2] = f7;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = i10;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 56 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 657235 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 56 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 56 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 56 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 20 | 0, i3);
 i7 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0);
 i3 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i6 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 STACKTOP = i6;
 return;
}

function __Z16GetClothingScenev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = __Z14GetDynamicsSDKv() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 i2 = i5 + 80 | 0;
 i3 = i5;
 i4 = i3 + 80 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(f8 * Math_fround(.00999999977));
 HEAP32[i5 + 84 >> 2] = 0;
 HEAPF32[i5 + 88 >> 2] = Math_fround(f8 * Math_fround(.0250000004));
 HEAPF32[i5 + 92 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(.200000003));
 HEAPF32[i5 + 96 >> 2] = Math_fround(f8 * Math_fround(.0399999991));
 HEAP16[i5 + 100 >> 1] = 0;
 i4 = i5 + 104 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 112 >> 2] = 0;
 HEAP32[i5 + 116 >> 2] = 1;
 HEAP32[i5 + 120 >> 2] = 1;
 HEAP32[i5 + 124 >> 2] = 100;
 HEAP32[i5 + 128 >> 2] = 0;
 HEAP32[i5 + 132 >> 2] = 32;
 HEAP32[i5 + 136 >> 2] = 0;
 HEAP32[i5 + 140 >> 2] = 65536;
 HEAP32[i5 + 144 >> 2] = 8192;
 HEAP32[i5 + 148 >> 2] = 1;
 HEAP32[i5 + 152 >> 2] = 0;
 HEAPF32[i5 + 156 >> 2] = Math_fround(.399999976);
 HEAP32[i5 + 160 >> 2] = -25165825;
 HEAP32[i5 + 164 >> 2] = -25165825;
 HEAP32[i5 + 168 >> 2] = -25165825;
 HEAP32[i5 + 172 >> 2] = 2122317823;
 HEAP32[i5 + 176 >> 2] = 2122317823;
 HEAP32[i5 + 180 >> 2] = 2122317823;
 i3 = i5 + 184 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 >> 2] = __Z19GetCpuDispatcherPtrv() | 0;
 HEAP32[i5 + 32 >> 2] = fb + 97;
 i4 = __Z14GetDynamicsSDKv() | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i5 | 0) | 0;
 HEAP32[gb + 1459016 >> 2] = i5;
 i5 = __Z17GetPhysicsManagerv() | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 + 32 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 40 >> 2];
 i5 = HEAP32[gb + 1459016 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 248 >> 2] | 0, i5 | 0, i6 | 0);
 i6 = HEAP32[gb + 1459016 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = (HEAP8[i11 >> 0] | 0) != 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = i11 ? 258 : 257;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 521;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN28EnlightenRendererInformation8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 425237 | 0, HEAP32[gb + 37176 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402843 | 0, HEAP32[gb + 37328 >> 2] | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402869 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 18; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 18; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 402878 | 0, gb + 455698 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function _pop_arg(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, d6 = 0.0;
 L1 : do if (i2 >>> 0 <= 20) do switch (i2 | 0) {
 case 9:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   HEAP32[i1 >> 2] = i2;
   break L1;
  }
 case 10:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   i4 = i1;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 11:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i2 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 4;
   i4 = i1;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = 0;
   break L1;
  }
 case 12:
  {
   i4 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   i2 = i4;
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i3 >> 2] = i4 + 8;
   i4 = i1;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i4 + 4 >> 2] = i2;
   break L1;
  }
 case 13:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i4 = (i4 & 65535) << 16 >> 16;
   i5 = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 14:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i5 = i1;
   HEAP32[i5 >> 2] = i4 & 65535;
   HEAP32[i5 + 4 >> 2] = 0;
   break L1;
  }
 case 15:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i4 = (i4 & 255) << 24 >> 24;
   i5 = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
   break L1;
  }
 case 16:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 >> 2] = i5 + 4;
   i5 = i1;
   HEAP32[i5 >> 2] = i4 & 255;
   HEAP32[i5 + 4 >> 2] = 0;
   break L1;
  }
 case 17:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d6 = +HEAPF64[i5 >> 3];
   HEAP32[i3 >> 2] = i5 + 8;
   HEAPF64[i1 >> 3] = d6;
   break L1;
  }
 case 18:
  {
   i5 = (HEAP32[i3 >> 2] | 0) + (8 - 1) & ~(8 - 1);
   d6 = +HEAPF64[i5 >> 3];
   HEAP32[i3 >> 2] = i5 + 8;
   HEAPF64[i1 >> 3] = d6;
   break L1;
  }
 default:
  break L1;
 } while (0); while (0);
 return;
}

function __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i10, i1, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i4 - i12 >> 2;
 i9 = i10 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i1 = i12;
 i7 = i8;
 i11 = i4;
 if (i6 >>> 0 <= i2 - i8 >> 2 >>> 0) {
  i9 = i10 + 4 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i8 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i12 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i8 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i7 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i9 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) return;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i9 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  return;
 }
 i4 = i8;
 if (i8) {
  i2 = i10 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i8 | 0) >>> 2) << 2);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i2 = 0;
 }
 if (i6 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i8 = i2 - i3 | 0;
 i2 = i8 >> 1;
 i2 = i8 >> 2 >>> 0 < 536870911 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 1073741823;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i4 = __Znwj(i2 << 2) | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i11 | 0)) return;
 i3 = i11 + -4 - i12 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 return;
}

function __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_(i4, i20, i21, i18, i19, i16, i17) {
 i4 = i4 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = i4 + 1344 | 0;
 i15 = HEAP32[i4 + 1348 >> 2] & 2147483647;
 L1 : do if (!i15) {
  i3 = i20;
  i2 = i18;
  i1 = i16;
 } else {
  i1 = HEAP32[i14 >> 2] | 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
   if (i3 | 0) {
    i5 = i2;
    break;
   }
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i15 >>> 0) {
    i3 = i20;
    i2 = i18;
    i1 = i16;
    break L1;
   }
  }
  i12 = i4 + 708 | 0;
  i13 = i4 + 720 | 0;
  i11 = i4 + 696 | 0;
  i4 = i20;
  i2 = i18;
  i1 = i16;
  while (1) {
   L9 : while (1) {
    while (1) {
     i6 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i6 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | i5 << 5;
     i3 = i3 + -1 & i3;
     L13 : do if (!i3) {
      i3 = i5;
      while (1) {
       i5 = i3 + 1 | 0;
       if (i5 >>> 0 >= i15 >>> 0) {
        i3 = 0;
        break L13;
       }
       i3 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i5 << 2) >> 2] | 0;
       if (!i3) i3 = i5; else break;
      }
     } while (0);
     if ((i6 | 0) == -1) {
      i3 = i4;
      break L1;
     }
     i8 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 >>> (HEAP32[i12 >> 2] | 0) << 2) >> 2] | 0;
     i7 = (HEAP32[i11 >> 2] | 0) + -1 & i6;
     i6 = i8 + (i7 << 7) | 0;
     i10 = i8 + (i7 << 7) + 114 | 0;
     i9 = HEAPU16[i10 >> 1] | 0;
     if (!(i9 & 2)) break;
     if (i9 & 8 | 0) break L9;
     HEAP32[i4 >> 2] = i6;
     HEAP32[i4 + 4 >> 2] = HEAP32[i8 + (i7 << 7) + 12 >> 2];
     i4 = i4 + 8 | 0;
     if (!i3) {
      i3 = i4;
      break L1;
     }
    }
    HEAP32[i2 >> 2] = i6;
    HEAP32[i2 + 4 >> 2] = HEAP32[i8 + (i7 << 7) + 12 >> 2];
    i2 = i2 + 8 | 0;
    if (!i3) {
     i3 = i4;
     break L1;
    }
   }
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + (i7 << 7) + 12 >> 2];
   HEAP16[i10 >> 1] = i9 & 65527;
   i1 = i1 + 8 | 0;
   if (!i3) {
    i3 = i4;
    break;
   }
  }
 } while (0);
 HEAP32[i21 >> 2] = i3 - i20 >> 3;
 HEAP32[i19 >> 2] = i2 - i18 >> 3;
 HEAP32[i17 >> 2] = i1 - i16 >> 3;
 return 1;
}

function __ZN16DeveloperConsoleD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = HEAP32[i4 + 120 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i3 = HEAP32[i1 >> 2] | 0;
   i6 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i2 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i4 + 124 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i6 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i2 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i2);
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i4 + 128 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i6 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i2 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i2);
  }
  __ZdlPv(i1);
 }
 __ZN11UTF16StringD2Ev(i4 + 172 | 0);
 __ZN11UTF16StringD2Ev(i4 + 152 | 0);
 __ZN11UTF16StringD2Ev(i4 + 132 | 0);
 __ZN11UTF16StringD2Ev(i4 + 96 | 0);
 __ZN11UTF16StringD2Ev(i4 + 76 | 0);
 i1 = i4 + 52 | 0;
 if ((HEAP32[i4 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i4 + 16 | 0;
 i2 = i4 + 24 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i6 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i7;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i7 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZN11UTF16StringD2Ev(i7 + 20 | 0);
   __ZdlPv(i7);
  } while ((i1 | 0) != (i3 | 0));
 }
 i3 = i4 + 4 | 0;
 i2 = i4 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i7 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[HEAP32[i7 >> 2] >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i5;
  return;
 }
 do {
  i7 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11UTF16StringD2Ev(i7 + 20 | 0);
  __ZdlPv(i7);
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i5;
 return;
}

function __ZN13UnityProfilerD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i5 = i4 + 56 | 0;
 i6 = i4 + 60 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2) {
   i8 = i1 + 4 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[HEAP32[i8 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
 } while ((i1 | 0) != (i5 | 0));
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1576256 | 0, 0);
 __ZN13UnityProfiler10SetLogPathENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i8 = i1 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 } while ((i1 | 0) != (i5 | 0));
 HEAP32[i6 >> 2] = i5;
 HEAP32[i5 >> 2] = i5;
 i1 = i4 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN4FileD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN4FileD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i8 = i1 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 } while ((i1 | 0) != (i5 | 0));
 HEAP32[i6 >> 2] = i5;
 HEAP32[i5 >> 2] = i5;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
  HEAP32[i1 >> 2] = 0;
  i8 = i4 + 88 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 __ZN9profiling14SamplerManagerD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
 HEAP32[i1 >> 2] = 0;
 i8 = i4 + 88 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN11KeyframeTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN14SafeBinaryRead10SetVersionEi(i7, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034365 | 0, i3, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034371 | 0, i3, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034379 | 0, i3, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN13BoneInfluence8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426278 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426288 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426298 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426308 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426318 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426331 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426344 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426357 | 0, i5, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb(i5, i6, i8, i10, i2, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i5 + 28 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i7 = i5 + 32 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i9 = Math_imul(HEAP32[i6 + 40 >> 2] | 0, i8) | 0;
 i4 = i6 + 28 | 0;
 i3 = i6 + 32 | 0;
 i1 = i6 + 36 | 0;
 i9 = (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i10) | 0) + i9 | 0;
 i9 = (HEAP32[i6 + 8 >> 2] | 0) + i9 | 0;
 i4 = HEAP32[i4 >> 2] >> i10;
 i4 = (i4 | 0) < 1 ? 1 : i4;
 i3 = HEAP32[i3 >> 2] >> i10;
 i3 = (i3 | 0) < 1 ? 1 : i3;
 L7 : do if (i2) {
  i1 = HEAP32[i1 >> 2] | 0;
  do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
   i2 = i1 + -30 | 0;
   if (i2 >>> 0 < 15) if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break; else break L7; else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break; else break L7;
  } while (0);
  i12 = HEAP32[i13 >> 2] | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i6 = __Z21SourceMipLevelForBlitiiii(i12, i11, i4, i3) | 0;
  i10 = (HEAP32[i5 + 48 >> 2] | 0) + -1 | 0;
  i6 = (i10 | 0) < (i6 | 0) ? i10 : i6;
  i10 = i5 + 36 | 0;
  i11 = __Z21CalculateMipMapOffsetii13TextureFormati(i12, i11, HEAP32[i10 >> 2] | 0, i6) | 0;
  i12 = HEAP32[i13 >> 2] >> i6;
  i13 = HEAP32[i7 >> 2] >> i6;
  __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib(HEAP32[i10 >> 2] | 0, (HEAP32[i5 + 8 >> 2] | 0) + ((Math_imul(HEAP32[i5 + 40 >> 2] | 0, i8) | 0) + i11) | 0, (i12 | 0) < 1 ? 1 : i12, (i13 | 0) < 1 ? 1 : i13, i9, i4, i3, 1);
  STACKTOP = i14;
  return;
 } while (0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i6, i12, i8, i10) | 0;
 __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i5, i12, i11 ? 2 : 0, 1, i8) | 0;
 STACKTOP = i14;
 return;
}

function __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, d16 = 0.0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 d16 = +Math_fround(HEAPF32[i11 >> 2]);
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 16902;
 HEAPF64[i14 >> 3] = d16;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture(i2, i7, i9) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i8 = (i9 | 0) == 0;
 if (i8) i1 = 0; else i1 = HEAP32[i9 + 48 >> 2] | 0;
 switch (HEAP32[i7 + 36 >> 2] | 0) {
 case 0:
  {
   i5 = i7 + 156 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i4 = i2 + 124 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = __ZN10builtintex21GetBlackCubeTextureIDEv() | 0;
   HEAP32[i2 + (i6 * 40 | 0) >> 2] = i1;
   i4 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 40 | 0) + 4 | 0;
   f3 = Math_fround(HEAPF32[i7 + 132 >> 2]);
   if (i8) __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i10, 0, 0); else {
    i2 = HEAP32[i9 + 56 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i9 + 60 >> 2] | 0; else i1 = 0;
    __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i10, i2, i1, __Z19GetActiveColorSpacev() | 0, f3);
   };
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   STACKTOP = i11;
   return;
  }
 case 1:
  {
   i5 = i7 + 156 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i2 = i2 + 164 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = __ZN10builtintex17GetBlackTextureIDEv() | 0;
   HEAP32[i4 + (i6 * 44 | 0) + 24 >> 2] = i1;
   i4 = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 44 | 0) + 28 | 0;
   f3 = Math_fround(HEAPF32[i7 + 132 >> 2]);
   if (i8) __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i10, 0, 0); else {
    i2 = HEAP32[i9 + 56 >> 2] | 0;
    if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i9 + 60 >> 2] | 0; else i1 = 0;
    __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i10, i2, i1, __Z19GetActiveColorSpacev() | 0, f3);
   };
   HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   STACKTOP = i11;
   return;
  }
 default:
  {
   STACKTOP = i11;
   return;
  }
 }
}

function __ZN14UnityAnalytics9SetUserIdERK8UnityStr(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 72 | 0;
 i10 = i11;
 if (!(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0) | 0)) {
  i10 = 2;
  STACKTOP = i11;
  return i10 | 0;
 }
 __ZN11UnityEngine9Analytics13UserInfoEventC2Ev(i10);
 i6 = i10 + 32 | 0;
 do if ((i6 | 0) != (i1 | 0)) {
  i4 = HEAP8[i1 + 11 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  i8 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
  i4 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
  i5 = i6 + 11 | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i10 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i4 >>> 0 > i3 >>> 0) {
   i5 = i2 ? HEAP32[i10 + 36 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i3, i4 - i3 | 0, i5, 0, i5, i4, i8);
   break;
  }
  i1 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
  if (i4 | 0) _memmove(i1 | 0, i8 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i10 + 36 >> 2] = i4;
   break;
  } else {
   HEAP8[i5 >> 0] = i4;
   break;
  }
 } while (0);
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i10, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i10 >> 2] = gb + 188648 + 8;
 i1 = i10 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i10 + 60 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 i1 = i10 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i10 + 44 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 HEAP32[i10 >> 2] = gb + 190148 + 8;
 i1 = i10 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i10 + 16 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN11ShapeModule16CheckConsistencyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 8 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i6 | 0) < 0 ? 0 : (i6 | 0) > 16 ? 16 : i6;
 i2 = i4 + 40 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i6 | 0) < 0 ? 0 : (i6 | 0) > 2 ? 2 : i6;
 i2 = i4 + 16 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(90.0);
 f3 = i7 ? Math_fround(90.0) : f3;
 HEAPF32[i2 >> 2] = i6 ? Math_fround(0.0) : f3;
 i2 = i4 + 12 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = f3 > Math_fround(.00999999977);
 HEAP32[i2 >> 2] = i6 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1008981770;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i7 = i4 + 20 | 0;
 i6 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0);
 HEAP32[i7 >> 2] = HEAP32[(i6 ? i7 : i1) >> 2];
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i7 = i4 + 24 | 0;
 i6 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0);
 HEAP32[i7 >> 2] = HEAP32[(i6 ? i7 : i1) >> 2];
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i7 = i4 + 28 | 0;
 i6 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0);
 HEAP32[i7 >> 2] = HEAP32[(i6 ? i7 : i1) >> 2];
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i7 = i4 + 32 | 0;
 i6 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0);
 HEAP32[i7 >> 2] = HEAP32[(i6 ? i7 : i1) >> 2];
 i1 = i4 + 36 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(360.0);
 f3 = i6 ? Math_fround(360.0) : f3;
 HEAPF32[i1 >> 2] = i7 ? Math_fround(0.0) : f3;
 i1 = i4 + 204 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(1.0);
 f3 = i6 ? Math_fround(1.0) : f3;
 HEAPF32[i1 >> 2] = i7 ? Math_fround(0.0) : f3;
 i1 = i4 + 208 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(1.0);
 f3 = i6 ? Math_fround(1.0) : f3;
 HEAPF32[i1 >> 2] = i7 ? Math_fround(0.0) : f3;
 i1 = HEAP32[i4 + 72 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i7 = i4 + 56 | 0;
 i4 = (__ZNK4Mesh15GetSubMeshCountEv(i1) | 0) + -1 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = (i6 | 0) < 0 ? 0 : (i6 | 0) > (i4 | 0) ? i4 : i6;
 STACKTOP = i5;
 return;
}

function __ZL20PrepareSceneNodesJobP24PrepareSceneNodesJobDataj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17 + 4 | 0;
 i2 = i17;
 if ((HEAP16[gb + 1110704 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110704 | 0, i1);
  i8 = gb + 1110704 | 0;
 } else i8 = 0;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 + 340 + (i4 * 12 | 0) >> 2] | 0;
 i9 = (HEAP32[i3 + 340 + (i4 * 12 | 0) + 4 >> 2] | 0) + i1 | 0;
 if ((i1 | 0) < (i9 | 0)) {
  i10 = HEAP32[i3 >> 2] | 0;
  i11 = i3 + 20 + (i4 * 20 | 0) | 0;
  i12 = i3 + 20 + (i4 * 20 | 0) + 12 | 0;
  i13 = i3 + 20 + (i4 * 20 | 0) + 16 | 0;
  i7 = i3 + 20 + (i4 * 20 | 0) + 4 | 0;
  i6 = i1;
  do {
   i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if (!(HEAP8[i14 + (i1 * 24 | 0) + 20 >> 0] & 1)) {
    i5 = (HEAP32[i14 + (i1 * 24 | 0) >> 2] | 0) + 236 | 0;
    if (HEAP8[i15 + ((HEAPU16[i5 >> 1] | HEAPU8[i5 + 2 >> 0] << 16) & 63) >> 0] | 0) i16 = 10;
   } else i16 = 10;
   if ((i16 | 0) == 10) {
    i16 = 0;
    i2 = HEAP32[i12 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i13 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i13 >> 2] = i1;
      HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
      HEAP32[i13 >> 2] = i1;
      HEAP32[i11 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i12 >> 2] = i3;
    HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i9 | 0));
 }
 if (!i8) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i17;
 return;
}

function __Z22TransferField_NonArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 24 >> 2] | 0;
 i4 = i7 + 36 | 0;
 HEAP8[i4 >> 0] = 0;
 do if ((i3 & 524288 | 0) == 0 | (HEAP32[i7 >> 2] & 2 | 0) == 0) {
  i5 = i7 + 40 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   if (!i6) {
    i13 = 8;
    break;
   }
   if ((HEAP32[i6 + 16 >> 2] | 0) != 3) {
    i13 = 8;
    break;
   }
  }
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i6, i1) | 0;
  HEAP32[i5 >> 2] = i14;
  i1 = i7 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 37260 >> 2];
  if (!i14) {
   i14 = HEAP8[i4 >> 0] | 0;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i1 >> 2] = i2;
   if (!(i14 << 24 >> 24)) {
    i13 = 8;
    break;
   }
  } else {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, i3);
   __ZN8JSONRead18TransferStringDataINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_(i7, i11);
   HEAP8[i4 >> 0] = 1;
   i14 = i7 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i1 >> 2] = i2;
  }
  i1 = i11 + 11 | 0;
  i7 = __Z20scripting_string_newPKc((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i11 >> 2] | 0 : i11) | 0;
  i14 = HEAP32[i8 + 20 >> 2] | 0;
  HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + ((HEAP8[i9 >> 0] | 0) == 0 ? i14 + -8 + (HEAP32[i9 + 12 >> 2] | 0) | 0 : i14) >> 2] = i7;
 } else i13 = 8; while (0);
 if ((i13 | 0) == 8) i1 = i11 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i14 = HEAP32[i11 >> 2] | 0;
 i13 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i14, i10);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i6, i1, i12) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i1;
 i5 = i12 - i11 >> 3;
 i7 = i6 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i8 = i10;
 if (i5 >>> 0 <= i2 - i10 >> 3 >>> 0) {
  i9 = i6 + 4 | 0;
  i7 = (HEAP32[i9 >> 2] | 0) - i10 >> 3;
  i5 = i5 >>> 0 > i7 >>> 0;
  i7 = i1 + (i7 << 3) | 0;
  i4 = i5 ? i7 : i12;
  i6 = i4;
  i2 = i6 - i11 | 0;
  i3 = i2 >> 3;
  if (i3 | 0) _memmove(i10 | 0, i1 | 0, i2 | 0) | 0;
  i2 = i8 + (i3 << 3) | 0;
  if (!i5) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i9 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
   return;
  }
  if ((i4 | 0) == (i12 | 0)) return;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i12 + -8 - i6 | 0;
  i1 = i7;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 8 | 0;
  }
  HEAP32[i9 >> 2] = i4 + ((i3 >>> 3) + 1 << 3);
  return;
 }
 i4 = i10;
 if (i10) {
  i2 = i6 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i8 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i10 | 0) >>> 3) << 3);
  __ZdlPv(i4);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i2 = 0;
 }
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i3 = 0;
 i10 = i2 - i3 | 0;
 i2 = i10 >> 2;
 i2 = i10 >> 3 >>> 0 < 268435455 ? (i2 >>> 0 < i5 >>> 0 ? i5 : i2) : 536870911;
 if (i2 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i4 = __Znwj(i2 << 3) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i7 >> 2] = i4 + (i2 << 3);
 if ((i1 | 0) == (i12 | 0)) return;
 i3 = i12 + -8 - i11 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i12 | 0)) break; else i2 = i2 + 8 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 3) + 1 << 3);
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE(i1, i5, i6, i7, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i8 = 0;
 i4 = i2 + 8 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  } while (0);
  i1 = (i1 | 0) == 0;
  i2 = HEAP32[i6 >> 2] | 0;
  do if (!i2) i8 = 12; else {
   if ((HEAP32[i2 + 12 >> 2] | 0) != (HEAP32[i2 + 16 >> 2] | 0)) if (i1) break; else break L1;
   if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) == -1) {
    HEAP32[i6 >> 2] = 0;
    i8 = 12;
    break;
   } else if (i1) break; else break L1;
  } while (0);
  if ((i8 | 0) == 12) {
   i8 = 0;
   if (i1) {
    i2 = 0;
    break;
   } else i2 = 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAPU8[i3 >> 0] | 0;
  if ((i1 & 255) << 24 >> 24 <= -1) break;
  if (!(HEAP16[(HEAP32[i4 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 8192)) break;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1 + 12 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   continue;
  } else {
   HEAP32[i2 >> 2] = i3 + 1;
   continue;
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) i1 = 0; else if ((HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) {
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
  break;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  break;
 } while (0);
 i1 = (i1 | 0) == 0;
 do if (!i2) i8 = 32; else {
  if ((HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i2 + 16 >> 2] | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) == -1) {
   HEAP32[i6 >> 2] = 0;
   i8 = 32;
   break;
  }
  if (!i1) i8 = 33;
 } while (0);
 if ((i8 | 0) == 32) if (i1) i8 = 33;
 if ((i8 | 0) == 33) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2;
 return;
}

function __ZN5physx7profile10EventValue9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 1 | 0;
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 900348 | 0, i2, (HEAPU8[i10 >> 0] | 0) & 3);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i3, gb + 660697 | 0, i2 + 8 | 0, (HEAPU8[i10 >> 0] | 0) >>> 2 & 3);
 i10 = i2 + 16 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3;
 i8 = i1 - i4 | 0;
 i2 = i8 + 4 | 0;
 i9 = i5 + 16 | 0;
 if (((HEAP32[i9 >> 2] | 0) - i4 | 0) >>> 0 > i2 >>> 0) {
  i8 = i1;
  i9 = HEAP8[i10 >> 0] | 0;
  HEAP8[i8 >> 0] = i9;
  i9 = i10 + 1 | 0;
  i9 = HEAP8[i9 >> 0] | 0;
  i7 = i8 + 1 | 0;
  HEAP8[i7 >> 0] = i9;
  i7 = i10 + 2 | 0;
  i7 = HEAP8[i7 >> 0] | 0;
  i9 = i8 + 2 | 0;
  HEAP8[i9 >> 0] = i7;
  i9 = i10 + 3 | 0;
  i9 = HEAP8[i9 >> 0] | 0;
  i10 = i8 + 3 | 0;
  HEAP8[i10 >> 0] = i9;
  i10 = HEAP32[i6 >> 2] | 0;
  i10 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = i10;
  return;
 }
 i4 = i2 << 1;
 if (!i4) {
  i2 = 0;
  i1 = i3;
 } else {
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (i1 | 0) {
  _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 HEAP32[i7 >> 2] = i2;
 i8 = i2 + i8 | 0;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i9 >> 2] = i2 + i4;
 i9 = HEAP8[i10 >> 0] | 0;
 HEAP8[i8 >> 0] = i9;
 i9 = i10 + 1 | 0;
 i9 = HEAP8[i9 >> 0] | 0;
 i7 = i8 + 1 | 0;
 HEAP8[i7 >> 0] = i9;
 i7 = i10 + 2 | 0;
 i7 = HEAP8[i7 >> 0] | 0;
 i9 = i8 + 2 | 0;
 HEAP8[i9 >> 0] = i7;
 i9 = i10 + 3 | 0;
 i9 = HEAP8[i9 >> 0] | 0;
 i10 = i8 + 3 | 0;
 HEAP8[i10 >> 0] = i9;
 i10 = HEAP32[i6 >> 2] | 0;
 i10 = i10 + 4 | 0;
 HEAP32[i6 >> 2] = i10;
 return;
}

function __Z29FindReflectionProbeFromAnchorP9TransformRK4AABBRS1_RsS5_(i6, i7, i8, i2, i3) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP16[i2 >> 1] = -1;
 HEAP16[i3 >> 1] = -1;
 if (!i6) {
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP16[i2 >> 1] = -1;
  HEAP16[i3 >> 1] = -1;
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i6 + 28 | 0;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 31272 | 0) | 0;
 if (i5 | 0) if (!(HEAP32[i5 + 36 >> 2] | 0)) {
  i1 = i5 + 156 | 0;
  if ((HEAP32[i1 >> 2] | 0) != -1) {
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP16[i2 >> 1] = HEAP32[i1 >> 2];
   HEAP16[i3 >> 1] = HEAP16[i5 + 60 >> 1] | 0;
   i9 = i5;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i1 = __ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 35740 | 0) | 0;
 if (i1 | 0) {
  i2 = __Z18GetITerrainManagerv() | 0;
  if (i2 | 0) {
   mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i9 | 0, i2 | 0, i1 | 0);
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 __ZNK9Transform11GetPositionEv(i9, i6);
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 i9 = i8 + 12 | 0;
 i8 = i7 + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERNS_20RuntimeStructBuilderERNS_18SerializedTreeDataEPNS_5ArrayIiEEPPjPPfRKNS_4AABBE(i4, i5, i6, i7, i8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i2 = i12;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_(i4, 0, i11, i2);
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 >>> 16;
 i1 = i2 >>> 8;
 i1 = 3 - i1 + (i2 >>> 4) + (((i2 << 1) + 31 >> 5) + i3 + ((1 - i3 + i1 | 0) >>> 1) << 2) & -4;
 i2 = i2 << 2;
 if (!(__ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj(i5, i2 + 32 + i1 | 0, 65536) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i16 = i1 + 15 & -16;
 i1 = i5 + 152 | 0;
 i15 = i5 + 144 | 0;
 i14 = (HEAP32[i15 >> 2] | 0) + (((HEAP32[i1 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 _memset(i3 | 0, 0, i16 | 0) | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i16;
 i14 = i5 + 132 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = (HEAP32[i5 + 4 + (i13 << 3) + 4 >> 2] | 0) - (HEAP32[i5 + 4 + (i13 << 3) >> 2] | 0);
 i13 = i5 + 4 + (HEAP32[i14 >> 2] << 3) + 4 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i16;
 i13 = i2 + 15 & -16;
 i2 = (HEAP32[i15 >> 2] | 0) + (((HEAP32[i1 >> 2] | 0) + -1 | 0) * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 _memset(i1 | 0, 0, i13 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i13;
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = (HEAP32[i5 + 4 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i5 + 4 + (i2 << 3) >> 2] | 0);
 i2 = i5 + 4 + (HEAP32[i14 >> 2] << 3) + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i13;
 HEAP8[i5 + 136 >> 0] = 0;
 if (i8 | 0) HEAP32[i8 >> 2] = i3;
 if (i9 | 0) HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 if (__ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERiPjPfPNS_5ArrayIiEERKNS_4AABBE(i4, i11, i3, i1, i7, i10) | 0) {
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 31 | i1 << 5;
  HEAP32[i6 + 12 >> 2] = i1;
  i1 = 1;
 } else i1 = 0;
 i16 = i1;
 STACKTOP = i12;
 return i16 | 0;
}

function __ZN10GISettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i9 = i8 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i8 + 24 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i7, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 4 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i7 + 12 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i7 + 20 | 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = (HEAP8[i5 >> 0] | 0) == 0 & (i3 | 0) == 1 ? 0 : i3;
 HEAP32[i6 >> 2] = i3;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if ((i2 + 1 | 0) >>> 0 < i1 >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i7 + 21 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 208 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 208 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i2 = i14;
 i8 = i14 + 17 | 0;
 i9 = i14 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i7 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i6 = i10 + 276 | 0;
  i5 = i1 + (i2 << 2) | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i4 = i2 + (i10 * 152 | 0) | 0;
   if (i10) do {
    if ((i1 | 0) == (i5 | 0)) i13 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i1 = i1 + 4 | 0; else i13 = 15;
    if ((i13 | 0) == 15) {
     i13 = 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    }
    i2 = i2 + 152 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i7 | 0));
 }
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i13 & 2147483647 | 0) == 0 | (i13 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZL8ClipPolyPK8Vector3fiPS_RS0_f(i9, i10, i11, f3, f4, f5, f6) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, f18 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i7 = (i10 | 0) > 0;
 if (i7) i1 = 0; else {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 do {
  f14 = Math_fround(Math_fround(HEAPF32[i9 + (i1 * 12 | 0) >> 2]) * f3);
  f14 = Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2]) * f4));
  HEAPF32[i12 + (i1 << 2) >> 2] = Math_fround(Math_fround(f14 + Math_fround(Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2]) * f5)) + f6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i2 = i10 + -1 | 0;
 if (!i7) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = 0;
 i8 = 0;
 i7 = i2;
 f4 = Math_fround(HEAPF32[i12 + (i2 << 2) >> 2]);
 while (1) {
  i15 = f4 >= Math_fround(0.0);
  f3 = f4;
  f4 = Math_fround(HEAPF32[i12 + (i8 << 2) >> 2]);
  i2 = f4 >= Math_fround(0.0);
  if (i15 ^ i2) {
   f3 = Math_fround(f3 / Math_fround(f3 - f4));
   f5 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) >> 2]);
   f16 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) >> 2]);
   f5 = Math_fround(f5 - f16);
   f6 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 4 >> 2]);
   f18 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) + 4 >> 2]);
   f6 = Math_fround(f6 - f18);
   f17 = Math_fround(HEAPF32[i9 + (i8 * 12 | 0) + 8 >> 2]);
   f14 = Math_fround(HEAPF32[i9 + (i7 * 12 | 0) + 8 >> 2]);
   f6 = Math_fround(f18 + Math_fround(f3 * f6));
   f14 = Math_fround(f14 + Math_fround(f3 * Math_fround(f17 - f14)));
   HEAPF32[i11 + (i1 * 12 | 0) >> 2] = Math_fround(f16 + Math_fround(f3 * f5));
   HEAPF32[i11 + (i1 * 12 | 0) + 4 >> 2] = f6;
   HEAPF32[i11 + (i1 * 12 | 0) + 8 >> 2] = f14;
   i1 = i1 + 1 | 0;
  }
  if (i2) {
   i7 = i9 + (i8 * 12 | 0) | 0;
   i15 = i11 + (i1 * 12 | 0) | 0;
   HEAP32[i15 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i15 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i15 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   i1 = i1 + 1 | 0;
  }
  i2 = i8 + 1 | 0;
  if ((i2 | 0) == (i10 | 0)) break; else {
   i7 = i8;
   i8 = i2;
  }
 }
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i7 = HEAP32[i1 + 16 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f13 = Math_fround(f14 * Math_fround(0.0));
 f3 = Math_fround(f8 * Math_fround(0.0));
 f4 = Math_fround(f11 * Math_fround(0.0));
 f2 = Math_fround(f3 * Math_fround(0.0));
 f12 = Math_fround(f4 * Math_fround(0.0));
 f14 = Math_fround(Math_fround(f14 + f2) + f12);
 f10 = Math_fround(Math_fround(f13 + f3) + f12);
 f9 = Math_fround(f4 + Math_fround(f13 + f2));
 f13 = Math_fround(f13 * Math_fround(0.0));
 f12 = Math_fround(Math_fround(f8 + f13) + f12);
 f4 = Math_fround(Math_fround(f13 + f3) + f4);
 f2 = Math_fround(f11 + Math_fround(f13 + f2));
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i7 + 56 >> 2]);
 f11 = Math_fround(f13 * f14);
 f3 = Math_fround(f13 * f10);
 f13 = Math_fround(f13 * f9);
 f8 = Math_fround(HEAPF32[i7 + 60 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f8 * f10));
 f3 = Math_fround(f3 + Math_fround(f8 * f12));
 f8 = Math_fround(f13 + Math_fround(f4 * f8));
 f13 = Math_fround(HEAPF32[i7 + 64 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f4 * f13));
 f8 = Math_fround(f8 + Math_fround(f2 * f13));
 HEAPF32[i6 >> 2] = Math_fround(f11 + Math_fround(f9 * f13));
 i1 = i6 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i6 + 8 >> 2] = f8;
 f8 = Math_fround(HEAPF32[i7 + 68 >> 2]);
 f14 = Math_fround(f14 * f8);
 f13 = Math_fround(f10 * f8);
 f8 = Math_fround(f9 * f8);
 f11 = Math_fround(HEAPF32[i7 + 72 >> 2]);
 f10 = Math_fround(f14 + Math_fround(f10 * f11));
 f12 = Math_fround(f13 + Math_fround(f12 * f11));
 f11 = Math_fround(f8 + Math_fround(f4 * f11));
 f8 = Math_fround(HEAPF32[i7 + 76 >> 2]);
 f4 = Math_fround(f12 + Math_fround(f4 * f8));
 f2 = Math_fround(f11 + Math_fround(f2 * f8));
 HEAPF32[i6 + 12 >> 2] = Math_fround(f10 + Math_fround(f9 * f8));
 i5 = i6 + 16 | 0;
 HEAPF32[i5 >> 2] = f4;
 HEAPF32[i6 + 20 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i7 + 40 >> 2]);
 if (f2 < Math_fround(0.0)) {
  HEAPF32[i1 >> 2] = Math_fround(f2 + f3);
  return;
 } else {
  HEAPF32[i5 >> 2] = Math_fround(f2 + f4);
  return;
 }
}

function __ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 160 | 0;
 i8 = i7 + 96 | 0;
 i9 = i7 + 32 | 0;
 i5 = i7 + 16 | 0;
 i6 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 mftCall_viii(i10 | 0, i1 | 0, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i8 | 0);
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i9, i2);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i9, i8, i3);
 if (((HEAP32[i3 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i3 + 4 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i3 + 8 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 16 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 20 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 24 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 32 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 36 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 40 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 48 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 52 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 56 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i3 + 60 >> 2] & 2139095040 | 0) != 2139095040) {
  i10 = 1;
  STACKTOP = i7;
  return i10 | 0;
 }
 __Z32GetSceneHierarchyPathDescriptivePK6Object(i6, i1);
 __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_(i5, gb + 732987 | 0, i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
 }
 i10 = i5 + 11 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 733088 | 0, 172, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 if ((HEAP8[i10 >> 0] | 0) < 0) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
 }
 i10 = 0;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN22BaseUnityConnectClient24OnSaveFileFromServerDoneERK8UnityStrS2_bi(i12, i1, i4, i2, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i10 = i11;
 i8 = i12 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2];
 if ((HEAP32[i8 >> 2] | 0) == 5) {
  STACKTOP = i11;
  return;
 }
 i8 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i8 << 24 >> 24 < 0;
 i8 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
 do if (i8 | 0) {
  i6 = HEAP32[i12 + 660 >> 2] | 0;
  i7 = i6 + 4 | 0;
  if ((i7 | 0) != (i4 | 0)) {
   i5 = i1 ? HEAP32[i4 >> 2] | 0 : i4;
   i3 = i7 + 11 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   i2 = i1 << 24 >> 24 < 0;
   if (i2) i4 = (HEAP32[i6 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
   if (i8 >>> 0 > i4 >>> 0) {
    if (i2) i1 = HEAP32[i6 + 8 >> 2] | 0; else i1 = i1 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i8 - i4 | 0, i1, 0, i1, i8, i5);
    break;
   }
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   _memmove(i1 | 0, i5 | 0, i8 | 0) | 0;
   HEAP8[i1 + i8 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i6 + 8 >> 2] = i8;
    break;
   } else {
    HEAP8[i3 >> 0] = i8;
    break;
   }
  }
 } while (0);
 i8 = HEAP32[i12 + 280 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i12 = i10 + 11 | 0;
 HEAP8[i12 >> 0] = 6;
 HEAP8[i10 >> 0] = HEAP8[gb + 1040788 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[gb + 1040788 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[gb + 1040788 + 2 >> 0] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[gb + 1040788 + 3 >> 0] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[gb + 1040788 + 4 >> 0] | 0;
 HEAP8[i10 + 5 >> 0] = HEAP8[gb + 1040788 + 5 >> 0] | 0;
 HEAP8[i10 + 6 >> 0] = 0;
 __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr(i8, i10) | 0;
 if ((HEAP8[i12 >> 0] | 0) < 0) {
  i12 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i9);
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i1 = HEAP32[i12 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i11 = i13 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i11;
  i4 = i12;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i8 + 4 | 0;
  i6 = i2;
  i2 = HEAP32[i11 >> 2] | 0;
  do {
   i4 = i2 + -16 | 0;
   i3 = i6;
   i6 = i6 + -16 | 0;
   i7 = HEAP8[i6 + 11 >> 0] | 0;
   i16 = i7 << 24 >> 24 < 0;
   i5 = i16 ? HEAP32[i6 >> 2] | 0 : i6;
   i7 = i16 ? HEAP32[i3 + -12 >> 2] | 0 : i7 & 255;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + -4 >> 2] = i3;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    i10 = 7;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i4 + 11 >> 0] = i7;
    if (!i7) i2 = i4; else {
     i2 = i4;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i17 = i7 + 16 & -16;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i9 >> 2] = i3;
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i4 >> 2] = i16;
    HEAP32[i2 + -8 >> 2] = i17 | -2147483648;
    HEAP32[i2 + -12 >> 2] = i7;
    i2 = i16;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i5 | 0, i7 | 0) | 0;
   }
   HEAP8[i2 + i7 >> 0] = 0;
   i2 = (HEAP32[i11 >> 2] | 0) + -16 | 0;
   HEAP32[i11 >> 2] = i2;
  } while ((i6 | 0) != (i1 | 0));
  i3 = i11;
  i4 = i12;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i17 = i13 + 8 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 i14 = i12 + 8 | 0;
 i17 = i13 + 12 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i1 = HEAP32[i12 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i11 = i13 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i11;
  i4 = i12;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i8 + 4 | 0;
  i6 = i2;
  i2 = HEAP32[i11 >> 2] | 0;
  do {
   i4 = i2 + -16 | 0;
   i3 = i6;
   i6 = i6 + -16 | 0;
   i7 = HEAP8[i6 + 11 >> 0] | 0;
   i16 = i7 << 24 >> 24 < 0;
   i5 = i16 ? HEAP32[i6 >> 2] | 0 : i6;
   i7 = i16 ? HEAP32[i3 + -12 >> 2] | 0 : i7 & 255;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + -4 >> 2] = i3;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    i10 = 7;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i4 + 11 >> 0] = i7;
    if (!i7) i2 = i4; else {
     i2 = i4;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i17 = i7 + 16 & -16;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i9 >> 2] = i3;
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i4 >> 2] = i16;
    HEAP32[i2 + -8 >> 2] = i17 | -2147483648;
    HEAP32[i2 + -12 >> 2] = i7;
    i2 = i16;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i5 | 0, i7 | 0) | 0;
   }
   HEAP8[i2 + i7 >> 0] = 0;
   i2 = (HEAP32[i11 >> 2] | 0) + -16 | 0;
   HEAP32[i11 >> 2] = i2;
  } while ((i6 | 0) != (i1 | 0));
  i3 = i11;
  i4 = i12;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i17 = i13 + 8 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 i14 = i12 + 8 | 0;
 i17 = i13 + 12 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i15;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i16 = HEAP32[i6 + 12 >> 2] | 0;
 i17 = HEAP32[i6 + 4 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i17 + 96 + (i1 << 4) >> 2]);
 f15 = Math_fround(HEAPF32[i17 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i17 + 96 + (i1 << 4) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 48 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 52 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i16 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 32 >> 2])));
 f12 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 36 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i16 + 8 >> 2]));
 f15 = Math_fround(f8 + Math_fround(f15 * Math_fround(HEAPF32[i16 + 24 >> 2])));
 f10 = Math_fround(f9 + f10);
 f12 = Math_fround(f13 + f12);
 f11 = Math_fround(f14 + Math_fround(f15 + Math_fround(f11 * Math_fround(HEAPF32[i16 + 40 >> 2]))));
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 152 >> 2]);
 f9 = Math_fround(-f15);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f9 = HEAP32[gb + 48 + (i2 << 4) >> 2] | 0 ? f15 : f9;
 f8 = HEAP32[gb + 48 + (i2 << 4) + 4 >> 2] | 0 ? f14 : f8;
 f7 = HEAP32[gb + 48 + (i2 << 4) + 8 >> 2] | 0 ? f13 : f7;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK21FullParameterPreparer22OnPrepareComputeBufferER15ComputeBufferIDRKN20GpuProgramParameters15BufferParameterEj(i4, i1, i6, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 16 | 0;
 i3 = i13 + 8 | 0;
 i9 = i13;
 HEAP32[i3 >> 2] = -1;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 >> 2] = HEAP32[(__ZN9ShaderLab11shaderprops16GetComputeBufferEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i11, i12, i3) | 0) >> 2];
 i12 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i12) {
  STACKTOP = i13;
  return 1;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + -1 | 0;
 if (i2 >>> 0 >= 4) {
  STACKTOP = i13;
  return 1;
 }
 if (!(11 >>> (i2 & 15) & 1)) {
  STACKTOP = i13;
  return 1;
 }
 i11 = (i1 | 0) == 4 ? -1 : HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i4 + 12 >> 2] | 0) + i5 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i12 + 80 | 0;
 i4 = i12 + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i12 + 96 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 20 | 0, 4, i12 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i12 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 + (i5 * 20 | 0) >> 2] = i11;
 HEAP32[i9 + (i5 * 20 | 0) + 4 >> 2] = i2;
 HEAP32[i9 + (i5 * 20 | 0) + 8 >> 2] = i10;
 HEAP32[i9 + (i5 * 20 | 0) + 12 >> 2] = 0;
 HEAP16[i9 + (i5 * 20 | 0) + 16 >> 1] = 1;
 HEAP16[i9 + (i5 * 20 | 0) + 18 >> 1] = 0;
 i12 = i12 + 116 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 STACKTOP = i13;
 return 1;
}

function __ZN6b2BodyC2EPK9b2BodyDefP7b2World(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, f7 = f0, f8 = f0;
 i6 = i3 + 4 | 0;
 HEAP16[i6 >> 1] = 0;
 i1 = (HEAP8[i4 + 39 >> 0] | 0) == 0 ? 0 : 8;
 HEAP16[i6 >> 1] = i1;
 if (HEAP8[i4 + 38 >> 0] | 0) {
  i1 = (i1 & 65535 | 16) & 65535;
  HEAP16[i6 >> 1] = i1;
 }
 i2 = HEAP16[i4 + 36 >> 1] | 0;
 if ((i2 & 255) << 24 >> 24) {
  i1 = (i1 & 65535 | 4) & 65535;
  HEAP16[i6 >> 1] = i1;
 }
 if ((i2 & 65535) >= 256) {
  i1 = (i1 & 65535 | 2) & 65535;
  HEAP16[i6 >> 1] = i1;
 }
 if (HEAP8[i4 + 40 >> 0] | 0) HEAP16[i6 >> 1] = i1 & 65535 | 32;
 HEAP32[i3 + 88 >> 2] = i5;
 i6 = i4 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = i4 + 12 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i3 + 20 >> 2] = Math_fround(+Math_sin(+f8));
 HEAPF32[i3 + 24 >> 2] = Math_fround(+Math_cos(+f8));
 HEAPF32[i3 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 32 >> 2] = Math_fround(0.0);
 i5 = i3 + 36 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i3 + 44 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i6;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 + 52 >> 2] = i2;
 HEAP32[i3 + 56 >> 2] = i2;
 HEAPF32[i3 + 60 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 108 >> 2] = 0;
 HEAP32[i3 + 112 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 i2 = i4 + 16 | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i3 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i3 + 72 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 132 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i3 + 136 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i3 + 140 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAPF32[i3 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 i6 = (i6 | 0) == 2;
 f8 = i6 ? Math_fround(1.0) : Math_fround(0.0);
 f7 = i6 ? Math_fround(1.0) : Math_fround(0.0);
 HEAPF32[i3 + 116 >> 2] = f8;
 HEAPF32[i3 + 120 >> 2] = f7;
 HEAPF32[i3 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 128 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 148 >> 2] = HEAP32[i4 + 44 >> 2];
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 return;
}

function __ZN19TouchPhaseEmulationC2Efbb(i5, f3, i1, i2) {
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i5 >> 2] = gb + 62260 + 8;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i5 + 16 >> 2] = f3;
 HEAP8[i5 + 20 >> 0] = i2 & 1;
 i2 = i1 & 1;
 HEAP8[i5 + 22 >> 0] = i2 ^ 1;
 HEAP8[i5 + 23 >> 0] = i2;
 i2 = __Znaj(3072) | 0;
 i1 = i2 + 3072 | 0;
 i4 = i2;
 do {
  HEAP32[i4 >> 2] = -1;
  HEAP32[i4 + 36 >> 2] = 4;
  HEAP32[i4 + 92 >> 2] = 0;
  HEAP32[i4 + 84 >> 2] = 0;
  HEAP32[i4 + 88 >> 2] = 0;
  i8 = i4 + 4 | 0;
  i9 = i4 + 72 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
  HEAP32[i8 + 28 >> 2] = 0;
  HEAP32[i4 + 80 >> 2] = -1;
  HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
  HEAP32[i4 + 40 >> 2] = 0;
  i8 = i4 + 52 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i4 = i4 + 96 | 0;
 } while ((i4 | 0) != (i1 | 0));
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 i1 = 0;
 while (1) {
  HEAP32[i2 + (i1 * 96 | 0) >> 2] = -1;
  HEAP32[i2 + (i1 * 96 | 0) + 36 >> 2] = 4;
  HEAP32[i2 + (i1 * 96 | 0) + 92 >> 2] = 0;
  HEAP32[i2 + (i1 * 96 | 0) + 84 >> 2] = 0;
  HEAP32[i2 + (i1 * 96 | 0) + 88 >> 2] = 0;
  i9 = i2 + (i1 * 96 | 0) + 4 | 0;
  i8 = i2 + (i1 * 96 | 0) + 72 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  HEAP32[i9 + 28 >> 2] = 0;
  HEAP32[i2 + (i1 * 96 | 0) + 80 >> 2] = -1;
  HEAPF32[i2 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
  HEAP32[i2 + (i1 * 96 | 0) + 40 >> 2] = 0;
  i9 = i2 + (i1 * 96 | 0) + 52 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 1;
 return;
}

function __ZN17SizeBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 800 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 804 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 808 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN13sorted_vectorINSt3__24pairIP11Il2CppClassPKN5Unity4TypeEEEN10vector_mapIS3_S7_NS0_4lessIS3_EENS0_9allocatorIS8_EEE13value_compareESD_E21sort_clear_duplicatesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 16 | 0;
 i6 = i14 + 12 | 0;
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 i10 = i14;
 i11 = i1 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i13 = i1 + 8 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
 i4 = i2 - i3 | 0;
 i5 = i4 >> 3;
 if ((i4 | 0) > 0) {
  i1 = i5;
  while (1) {
   i4 = __ZnwjRKSt9nothrow_t(i1 << 3, gb + 1576254 | 0) | 0;
   if (i4 | 0) break;
   i1 = i1 >>> 1;
   if (!i1) {
    i4 = 0;
    i1 = 0;
    break;
   }
  }
 } else {
  i4 = 0;
  i1 = 0;
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi(i6, i7, i10, i5, i4, i1);
 if (i4 | 0) __ZdlPv(i4);
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i7 | 0)) {
  i2 = i1;
  while (1) {
   i5 = i2 + 8 | 0;
   if ((i5 | 0) == (i7 | 0)) {
    i12 = 20;
    break;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if (i3 >>> 0 < i4 >>> 0) i2 = i5; else break;
  }
  if ((i12 | 0) == 20) {
   STACKTOP = i14;
   return;
  }
  i1 = i2;
  L20 : do if ((i2 | 0) != (i7 | 0)) {
   i2 = i5;
   i6 = i3;
   i3 = i5;
   while (1) {
    if (i6 >>> 0 < i4 >>> 0) {
     i12 = i2;
     HEAP32[i2 >> 2] = i4;
     HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     i2 = i12 + 8 | 0;
    }
    i5 = i3 + 8 | 0;
    i3 = i1 + 8 | 0;
    if ((i5 | 0) == (i7 | 0)) {
     i1 = i2;
     break L20;
    }
    i1 = i3;
    i6 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i3 = i5;
   }
  } while (0);
 }
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i13 >> 2] = i7 + (~((i7 + -8 - i1 | 0) >>> 3) << 3);
 STACKTOP = i14;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3 + 8 | 0;
 i8 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i11 = i9;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i9, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 0);
 i9 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i4 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i7 = i4 + 16 | 0;
 i5 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 20 >> 2] = i9;
 i9 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1085989 | 0, i9, i8, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1085998 | 0, i9, i8 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z18CalculateImageSizeii13TextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) < 1 | (i2 | 0) < 1) {
  i3 = 0;
  return i3 | 0;
 }
 switch (i3 | 0) {
 case 10:
 case 26:
 case 35:
  {
   i3 = Math_imul((i1 + 3 | 0) >>> 2 << 3, (i2 + 3 | 0) >>> 2) | 0;
   return i3 | 0;
  }
 case 11:
 case 12:
 case 24:
 case 25:
 case 27:
 case 36:
  {
   i3 = Math_imul((i1 + 3 | 0) >>> 2 << 4, (i2 + 3 | 0) >>> 2) | 0;
   return i3 | 0;
  }
 default:
  switch (i3 | 1 | 0) {
  case 33:
   {
    i3 = ((Math_imul((i1 >>> 0 < 8 ? 8 : i1) << 2, i2 >>> 0 < 8 ? 8 : i2) | 0) + 7 | 0) >>> 3;
    return i3 | 0;
   }
  case 31:
   {
    i3 = ((Math_imul((i1 >>> 0 < 16 ? 16 : i1) << 1, i2 >>> 0 < 8 ? 8 : i2) | 0) + 7 | 0) >>> 3;
    return i3 | 0;
   }
  default:
   {
    L8 : do if (((i3 & -5) + -41 | 0) >>> 0 >= 2) switch (i3 | 0) {
    case 34:
    case 60:
     break L8;
    case 43:
    case 44:
    case 47:
    case 61:
     {
      i3 = (Math_imul(i2 >>> 0 < 4 ? 4 : i2, i1 >>> 0 < 4 ? 4 : i1) | 0) & 536870911;
      return i3 | 0;
     }
    case 21:
     {
      i3 = Math_imul(i1 << 1, i2) | 0;
      return i3 | 0;
     }
    case 48:
    case 54:
     {
      i3 = Math_imul((i1 + 3 | 0) >>> 2 << 4, (i2 + 3 | 0) >>> 2) | 0;
      return i3 | 0;
     }
    case 49:
    case 55:
     {
      i3 = Math_imul((((i1 + 4 | 0) >>> 0) / 5 | 0) << 4, ((i2 + 4 | 0) >>> 0) / 5 | 0) | 0;
      return i3 | 0;
     }
    case 50:
    case 56:
     {
      i3 = Math_imul((((i1 + 5 | 0) >>> 0) / 6 | 0) << 4, ((i2 + 5 | 0) >>> 0) / 6 | 0) | 0;
      return i3 | 0;
     }
    case 51:
    case 57:
     {
      i3 = Math_imul((i1 + 7 | 0) >>> 3 << 4, (i2 + 7 | 0) >>> 3) | 0;
      return i3 | 0;
     }
    case 52:
    case 58:
     {
      i3 = Math_imul((((i1 + 9 | 0) >>> 0) / 10 | 0) << 4, ((i2 + 9 | 0) >>> 0) / 10 | 0) | 0;
      return i3 | 0;
     }
    case 53:
    case 59:
     {
      i3 = Math_imul((((i1 + 11 | 0) >>> 0) / 12 | 0) << 4, ((i2 + 11 | 0) >>> 0) / 12 | 0) | 0;
      return i3 | 0;
     }
    default:
     {
      i3 = Math_imul(__Z29GetRowBytesFromWidthAndFormati13TextureFormat(i1, i3) | 0, i2) | 0;
      return i3 | 0;
     }
    } while (0);
    i3 = ((Math_imul((i1 >>> 0 < 4 ? 4 : i1) << 2, i2 >>> 0 < 4 ? 4 : i2) | 0) + 7 | 0) >>> 3;
    return i3 | 0;
   }
  }
 }
 return 0;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i1 = HEAP32[i12 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i11 = i13 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i11;
  i4 = i12;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i8 + 4 | 0;
  i6 = i2;
  i2 = HEAP32[i11 >> 2] | 0;
  do {
   i4 = i2 + -16 | 0;
   i3 = i6;
   i6 = i6 + -16 | 0;
   i7 = HEAP8[i6 + 11 >> 0] | 0;
   i16 = i7 << 24 >> 24 < 0;
   i5 = i16 ? HEAP32[i6 >> 2] | 0 : i6;
   i7 = i16 ? HEAP32[i3 + -12 >> 2] | 0 : i7 & 255;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + -4 >> 2] = i3;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    i10 = 7;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i4 + 11 >> 0] = i7;
    if (!i7) i2 = i4; else {
     i2 = i4;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i17 = i7 + 16 & -16;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i9 >> 2] = i3;
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i4 >> 2] = i16;
    HEAP32[i2 + -8 >> 2] = i17 | -2147483648;
    HEAP32[i2 + -12 >> 2] = i7;
    i2 = i16;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i5 | 0, i7 | 0) | 0;
   }
   HEAP8[i2 + i7 >> 0] = 0;
   i2 = (HEAP32[i11 >> 2] | 0) + -16 | 0;
   HEAP32[i11 >> 2] = i2;
  } while ((i6 | 0) != (i1 | 0));
  i3 = i11;
  i4 = i12;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i17 = i13 + 8 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 i14 = i12 + 8 | 0;
 i17 = i13 + 12 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 76 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 88 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 104 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 92 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN8Collider15IgnoreCollisionEPS_b(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13 + 4 | 0;
 i12 = i13;
 HEAP32[i12 >> 2] = i1;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i7 + 76 >> 2] | 0;
  mftCall_vii(HEAP32[i7 + 80 >> 2] | 0, i9 | 0, i1 | 0);
  mftCall_vii(i8 | 0, i1 | 0, i9 | 0);
 }
 i8 = i2 + 44 | 0;
 if (i3) {
  i6 = HEAP32[i8 >> 2] | 0;
  i7 = HEAP32[i2 + 48 >> 2] | 0;
  i1 = i7 - i6 >> 2;
  i2 = i6;
  if (!i1) i1 = i2; else {
   i6 = HEAP32[i12 >> 2] | 0;
   i5 = i1;
   i1 = i2;
   while (1) {
    i14 = (i5 | 0) / 2 | 0;
    i4 = i2 + (i14 << 2) | 0;
    i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i6 >>> 0;
    i4 = i4 + 4 | 0;
    i1 = i3 ? i4 : i1;
    i5 = i3 ? i5 + -1 - i14 | 0 : i14;
    if (!i5) break; else i2 = i3 ? i4 : i2;
   }
  }
  i2 = i1;
  if ((i1 | 0) == (i7 | 0)) i11 = 10; else if ((HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0) i11 = 10;
  if ((i11 | 0) == 10) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i8, i9, i12) | 0;
  }
  STACKTOP = i13;
  return;
 }
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i2 + 48 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 - i3 >> 2;
 i2 = i8;
 if (!i1) i5 = i3; else {
  i7 = HEAP32[i12 >> 2] | 0;
  i5 = i3;
  while (1) {
   i14 = (i1 | 0) / 2 | 0;
   i6 = i3 + (i14 << 2) | 0;
   i4 = (HEAP32[i6 >> 2] | 0) >>> 0 < i7 >>> 0;
   i6 = i6 + 4 | 0;
   i5 = i4 ? i6 : i5;
   i1 = i4 ? i1 + -1 - i14 | 0 : i14;
   if (!i1) break; else i3 = i4 ? i6 : i3;
  }
 }
 if ((i5 | 0) == (i2 | 0)) {
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  STACKTOP = i13;
  return;
 }
 i3 = i5 + 4 | 0;
 i1 = i8 - i3 | 0;
 i4 = i1 >> 2;
 if (i4) {
  _memmove(i5 | 0, i3 | 0, i1 | 0) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + (i4 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 STACKTOP = i13;
 return;
}

function __ZN17PersistentManager17IsObjectAvailableEi(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 if ((HEAP16[gb + 1165968 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165968 | 0, i5);
  i8 = gb + 1165968 | 0;
 } else i8 = 0;
 i3 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 7; else {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  if ((i2 | 0) > (i5 | 0)) i6 = 7; else if ((HEAP32[i3 + 32 >> 2] | 0) < (i5 | 0)) i6 = 7; else {
   i4 = (i5 - i2 | 0) / 2 | 0;
   i5 = i4;
   i4 = ((i4 | 0) < 0) << 31 >> 31;
   i6 = 15;
  }
 }
 if ((i6 | 0) == 7) {
  i4 = i3 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i2 = i4;
   L10 : while (1) {
    i3 = i1;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) break L10; else i3 = i1;
    }
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i2 = i3;
     break;
    } else i2 = i3;
   }
   if ((i2 | 0) == (i4 | 0)) i1 = 0; else if ((HEAP32[i2 + 16 >> 2] | 0) > (i5 | 0)) i1 = 0; else {
    i1 = HEAP32[i2 + 24 >> 2] | 0;
    i2 = i2 + 32 | 0;
    if ((i1 | 0) == -1) i1 = 0; else {
     i5 = HEAP32[i2 >> 2] | 0;
     i4 = HEAP32[i2 + 4 >> 2] | 0;
     i6 = 15;
    }
   }
  }
 }
 L19 : do if ((i6 | 0) == 15) {
  i3 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i7, i1) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else if (__ZNK14SerializedFile11IsAvailableEx(i1, i5, i4) | 0) {
   i2 = HEAP32[i3 + 16 >> 2] | 0;
   L23 : do if (i2 | 0) {
    i1 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i2 + 12 >> 2] | 0;
    i2 = i1 + (i7 << 3) | 0;
    L25 : do if (i7) while (1) {
     i7 = i1;
     if ((HEAP32[i7 >> 2] | 0) == (i5 | 0) ? (HEAP32[i7 + 4 >> 2] | 0) == (i4 | 0) : 0) break L25;
     i1 = i1 + 8 | 0;
     if ((i1 | 0) == (i2 | 0)) break L23;
    } while (0);
    if ((i1 | 0) != (i2 | 0)) {
     i1 = 0;
     break L19;
    }
   } while (0);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = __ZNK14SerializedFile7GetTypeEx(i1, i5, i4) | 0;
    if (i1 | 0) if (!(HEAP8[i1 + 32 >> 0] | 0)) {
     i1 = 1;
     break;
    }
    i1 = 0;
   }
  } else i1 = 0;
 } while (0);
 if (!i8) return i1 | 0;
 __Z12profiler_endP19ProfilerInformation(i8);
 return i1 | 0;
}

function __Z11MD5ToStringPh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 120 | 0;
 i6 = i3 + 112 | 0;
 i7 = i3 + 104 | 0;
 i8 = i3 + 96 | 0;
 i9 = i3 + 88 | 0;
 i10 = i3 + 80 | 0;
 i11 = i3 + 72 | 0;
 i12 = i3 + 64 | 0;
 i13 = i3 + 56 | 0;
 i14 = i3 + 48 | 0;
 i15 = i3 + 40 | 0;
 i16 = i3 + 32 | 0;
 i17 = i3 + 24 | 0;
 i18 = i3 + 16 | 0;
 i19 = i3 + 8 | 0;
 i20 = i3;
 i4 = i3 + 124 | 0;
 HEAP32[i20 >> 2] = HEAPU8[i2 >> 0];
 _snprintf(i4, 3, gb + 585600 | 0, i20) | 0;
 HEAP32[i19 >> 2] = HEAPU8[i2 + 1 >> 0];
 _snprintf(i4 + 2 | 0, 3, gb + 585600 | 0, i19) | 0;
 HEAP32[i18 >> 2] = HEAPU8[i2 + 2 >> 0];
 _snprintf(i4 + 4 | 0, 3, gb + 585600 | 0, i18) | 0;
 HEAP32[i17 >> 2] = HEAPU8[i2 + 3 >> 0];
 _snprintf(i4 + 6 | 0, 3, gb + 585600 | 0, i17) | 0;
 HEAP32[i16 >> 2] = HEAPU8[i2 + 4 >> 0];
 _snprintf(i4 + 8 | 0, 3, gb + 585600 | 0, i16) | 0;
 HEAP32[i15 >> 2] = HEAPU8[i2 + 5 >> 0];
 _snprintf(i4 + 10 | 0, 3, gb + 585600 | 0, i15) | 0;
 HEAP32[i14 >> 2] = HEAPU8[i2 + 6 >> 0];
 _snprintf(i4 + 12 | 0, 3, gb + 585600 | 0, i14) | 0;
 HEAP32[i13 >> 2] = HEAPU8[i2 + 7 >> 0];
 _snprintf(i4 + 14 | 0, 3, gb + 585600 | 0, i13) | 0;
 HEAP32[i12 >> 2] = HEAPU8[i2 + 8 >> 0];
 _snprintf(i4 + 16 | 0, 3, gb + 585600 | 0, i12) | 0;
 HEAP32[i11 >> 2] = HEAPU8[i2 + 9 >> 0];
 _snprintf(i4 + 18 | 0, 3, gb + 585600 | 0, i11) | 0;
 HEAP32[i10 >> 2] = HEAPU8[i2 + 10 >> 0];
 _snprintf(i4 + 20 | 0, 3, gb + 585600 | 0, i10) | 0;
 HEAP32[i9 >> 2] = HEAPU8[i2 + 11 >> 0];
 _snprintf(i4 + 22 | 0, 3, gb + 585600 | 0, i9) | 0;
 HEAP32[i8 >> 2] = HEAPU8[i2 + 12 >> 0];
 _snprintf(i4 + 24 | 0, 3, gb + 585600 | 0, i8) | 0;
 HEAP32[i7 >> 2] = HEAPU8[i2 + 13 >> 0];
 _snprintf(i4 + 26 | 0, 3, gb + 585600 | 0, i7) | 0;
 HEAP32[i6 >> 2] = HEAPU8[i2 + 14 >> 0];
 _snprintf(i4 + 28 | 0, 3, gb + 585600 | 0, i6) | 0;
 HEAP32[i5 >> 2] = HEAPU8[i2 + 15 >> 0];
 _snprintf(i4 + 30 | 0, 3, gb + 585600 | 0, i5) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, 32);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 8) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 256 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 4 | 0;
 i3 = i12;
 HEAP32[i2 >> 2] = i10;
 i8 = HEAP8[i10 + 20 >> 0] | 0;
 i9 = i10 + 4 | 0;
 i7 = i10;
 switch (HEAP8[(HEAP32[i9 >> 2] | 0) + 50 >> 0] | 0) {
 case 1:
 case 4:
  {
   i1 = HEAP8[(HEAP32[i10 + 8 >> 2] | 0) + 50 >> 0] | 0;
   i1 = (i8 & -2) << 24 >> 24 == 2 | i1 << 24 >> 24 != 4 & i1 << 24 >> 24 != 1;
   break;
  }
 default:
  i1 = 1;
 }
 i5 = i11 + 20 | 0;
 i4 = HEAP32[i11 + 28 >> 2] | 0;
 if (i4 >>> 0 > 65534) {
  STACKTOP = i12;
  return;
 }
 do if (i1) {
  __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_(i5, i2, i11);
  i1 = i4 & 65535;
  if ((HEAP32[i9 >> 2] | 0) == (i11 | 0)) {
   HEAP16[i10 + 16 >> 1] = i1;
   break;
  } else {
   HEAP16[i10 + 18 >> 1] = i1;
   break;
  }
 } else {
  i6 = i11 + 44 | 0;
  i1 = HEAPU16[i6 >> 1] | 0;
  do if ((i4 | 0) == (i1 | 0)) {
   __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_(i5, i2, i11);
   i1 = i4 & 65535;
   if ((HEAP32[i9 >> 2] | 0) == (i11 | 0)) {
    HEAP16[i10 + 16 >> 1] = i1;
    break;
   } else {
    HEAP16[i10 + 18 >> 1] = i1;
    break;
   }
  } else {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i3 >> 2] = i2;
   __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_(i5, i3, i11);
   i1 = i4 & 65535;
   if ((HEAP32[i2 + 4 >> 2] | 0) == (i11 | 0)) HEAP16[i2 + 16 >> 1] = i1; else HEAP16[i2 + 18 >> 1] = i1;
   i1 = HEAP16[i6 >> 1] | 0;
   HEAP32[(HEAP32[i5 >> 2] | 0) + ((i1 & 65535) << 2) >> 2] = i7;
   if ((HEAP32[i9 >> 2] | 0) == (i11 | 0)) {
    HEAP16[i10 + 16 >> 1] = i1;
    break;
   } else {
    HEAP16[i10 + 18 >> 1] = i1;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = (HEAP16[i6 >> 1] | 0) + 1 << 16 >> 16;
 } while (0);
 if ((i8 & 255) >= 2) {
  STACKTOP = i12;
  return;
 }
 i11 = i11 + 48 | 0;
 HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
 STACKTOP = i12;
 return;
}

function __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 64 | 0;
 i7 = i4 + 24 | 0;
 i5 = i4 + 8 | 0;
 i11 = i4 + 48 | 0;
 i14 = i4;
 i17 = i4 + 36 | 0;
 i15 = i1 + 32 | 0;
 i16 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i18 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i17 + 8 >> 2] = i2;
 i2 = i5;
 HEAP32[i2 >> 2] = i16;
 HEAP32[i2 + 4 >> 2] = i15;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E(i7, i6, i17);
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f13 = Math_fround(f9 - f13);
 f12 = Math_fround(f10 - f12);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i7 + 8 >> 2]));
 i2 = i14;
 HEAP32[i2 >> 2] = i16;
 HEAP32[i2 + 4 >> 2] = i15;
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
 __Z23CalculateGlobalPosition23TransformAccessReadOnly(i11, i6);
 f10 = Math_fround(HEAPF32[i11 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f10 = Math_fround(f13 + f10);
 f9 = Math_fround(f12 + f9);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i11 + 8 >> 2]));
 i11 = i1 + 32 | 0;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAPF32[i5 >> 2] = f10;
 HEAPF32[i5 + 4 >> 2] = f9;
 HEAPF32[i5 + 8 >> 2] = f8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 if (!(__Z10SetGlobalT15TransformAccessRKN4math7_float3E(i6, i5) | 0)) {
  STACKTOP = i4;
  return;
 }
 i18 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i18 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 1);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i18 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 6) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 64 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i7, i8, i9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 4 | 0;
 i2 = i12;
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i6 = 11; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i2);
    i2 = HEAP32[i5 >> 2] | 0;
    i13 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) i6 = 11;
 } while (0);
 if ((i6 | 0) == 11) {
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 469921 | 0, 27);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i5) | 0;
   HEAP32[gb + 1166240 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i1 = HEAP32[gb + 1166240 >> 2] | 0;
   HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
  }
 }
 i13 = __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib(i7, HEAP32[(HEAP32[HEAP32[(HEAP32[HEAP32[i1 + 32 >> 2] >> 2] | 0) + (i10 << 2) >> 2] >> 2] | 0) + (i8 << 2) >> 2] | 0, i9, i1, i8, i11) | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN4Mesh17MainThreadCleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 HEAP32[i3 >> 2] = gb + 30832;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = i6;
 i5 = i6 + 236 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) == (i4 | 0)) i1 = i6 + 232 | 0; else {
  do {
   i8 = i2;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i8 + 8 >> 2] | 0, gb + 1105156 | 0, i3);
   i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i6 + 232 | 0;
  if ((i2 | 0) != (i1 | 0)) do {
   i8 = i2 + 4 | 0;
   i4 = i2;
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 + 232 >> 2] = i1;
 i3 = i6 + 240 | 0;
 i4 = i6 + 244 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i8 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i8 = i1 + 4 | 0;
   i5 = i1;
   i1 = HEAP32[i8 >> 2] | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i4 >> 2] = i3;
 HEAP32[i3 >> 2] = i3;
 __ZN17CollisionMeshData7CleanupEv(i6 + 204 | 0);
 __ZN4Mesh19UnloadFromGfxDeviceEv(i6);
 i2 = i6 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!(HEAP32[i8 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i6 + 36 >> 2] | 0;
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!(HEAP32[i8 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i6 + 228 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 __ZN17UniqueIDGenerator16DestroyPureIndexEj(HEAP32[gb + 1161344 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferI11DetailPatchEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5;
 i6 = i5 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 932704 | 0, i2, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 932716 | 0, gb + 1034406 | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i2, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i2 + 12 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i9 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 932723 | 0, i9, i2 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 i7 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i7, i6, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 932736 | 0, i9, i2 + 40 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i3 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i4 = i5 + 16 | 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i2 ? HEAP32[i5 + 20 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i8 = i1;
   i8 = i8 + i3 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i9;
   return;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i5 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i6 + 24 >> 2] = i5 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i3;
  i1 = i8;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 i8 = i1;
 i8 = i8 + i3 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc8ShapeSim20createLowLevelVolumeEjRKNS_9PxBounds3EjNS_9AABBMgrIdE(i7, i4, i3, i2, i1) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i6 = i10;
 if (!(__ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE(i7, i4, i3, i2, i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i3 = i1 + 32 | 0;
 switch (HEAP32[i1 + 68 >> 2] | 0) {
 case 4:
  {
   i2 = HEAP32[i1 + 104 >> 2] | 0;
   break;
  }
 case 5:
  {
   i2 = (HEAP32[i1 + 108 >> 2] | 0) + 128 | 0;
   break;
  }
 case 6:
  {
   i2 = (HEAP32[i1 + 92 >> 2] | 0) + 40 | 0;
   break;
  }
 default:
  i2 = 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 1e3 >> 2] | 0;
 switch (HEAP8[i1 + 50 >> 0] | 0) {
 case 1:
 case 4:
  {
   HEAP32[i5 >> 2] = i3;
   HEAP32[i5 + 12 >> 2] = i2;
   HEAP32[i5 + 8 >> 2] = (HEAP32[i1 + 52 >> 2] | 0) + 16;
   HEAP32[i5 + 4 >> 2] = i1 + 64;
   i1 = i7 + 12 | 0;
   __ZN5physx14PxsAABBManager18setDynamicAABBDataEjRKNS_18PxcAABBDataDynamicE(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i1 >> 2] & 1073741823, i5);
   break;
  }
 default:
  {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = (HEAP32[i1 + 52 >> 2] | 0) + 16;
   i1 = i7 + 12 | 0;
   __ZN5physx14PxsAABBManager17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE(HEAP32[i9 + 8 >> 2] | 0, HEAP32[i1 >> 2] & 1073741823, i6);
  }
 }
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i7 & 1073741823;
 i4 = i9 + 5912 | 0;
 i5 = (i8 + 32 | 0) >>> 5;
 i6 = i9 + 5916 | 0;
 if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
  i2 = i9 + 5920 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i1 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
  }
  i9 = HEAP32[i6 >> 2] | 0;
  _memset(i1 + ((i9 & 2147483647) << 2) | 0, 0, i5 - i9 << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i6 >> 2] = i5;
 } else i1 = HEAP32[i4 >> 2] | 0;
 i9 = i1 + (i8 >>> 5 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1 << (i7 & 31);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 12 | 0;
 i11 = i16;
 i8 = i10 + 12 | 0;
 i9 = i10 + 16 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i12 = i10 + 8 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i15 = HEAP32[i10 + 4 >> 2] | 0;
 L1 : do if (i6 | 0) {
  i1 = 0;
  while (1) {
   if ((i1 | 0) != (i7 | 0)) {
    i4 = HEAP32[i8 >> 2] | 0;
    i3 = i4 + (i1 * 12 | 0) + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) {
     i13 = 5;
     break;
    }
    i2 = i4 + (i1 * 12 | 0) + 8 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i14 | 0)) {
     HEAP32[i2 >> 2] = i3 + 1;
     i2 = (HEAP32[i4 + (i1 * 12 | 0) >> 2] | 0) + (Math_imul(i3, i15) | 0) | 0;
     if (i2 | 0) break;
    }
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i6 >>> 0) break L1;
  }
  if ((i13 | 0) == 5) HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 >> 2] = i1;
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 } while (0);
 HEAP32[i12 >> 2] = i6;
 HEAP8[i10 + 24 >> 0] = 1;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, Math_imul(i15, i14) | 0, gb + 681700 | 0, 43) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 + 20 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i3 = (HEAP32[i8 >> 2] | 0) + (i1 * 12 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i3 + 1;
  i3 = (HEAP32[i8 >> 2] | 0) + (i3 * 12 | 0) | 0;
 } else i3 = __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i11) | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i15 = i2;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i14 | 0)) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i1 >> 2] = i2 + 1;
 i15 = (HEAP32[i3 >> 2] | 0) + (Math_imul(i2, i15) | 0) | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZN12ScriptMapper8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i3 = i7;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 if (!(HEAP32[i6 >> 2] & 33554432)) i2 = 3; else {
  i1 = i4 + 28 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) i3 = i1; else i2 = 3;
 }
 if ((i2 | 0) == 3) {
  i2 = i4 + 32 | 0;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 479375 | 0, gb + 476540 | 0, i3, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 476556 | 0, HEAP32[gb + 37052 >> 2] | 0, i5, 1) | 0;
    if (i1 | 0) {
     if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
      i1 = HEAP32[i5 >> 2] | 0;
      if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i6);
    }
    __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv(i2);
   } else {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i3 = i4 + 28 | 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 476571 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i5 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z35UnityPropertySheet_MakeSortedFloatsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_fEEEEEER10vector_mapIS2_fS4_NS5_INS6_IS2_fEEEEE(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i9 = i11 + 4 | 0;
 i10 = i11 + 12 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) - i7 >> 3 >>> 0 < i6 >>> 0) {
  i2 = i11 + 8 | 0;
  i3 = (HEAP32[i2 >> 2] | 0) - i7 | 0;
  i1 = i3 >> 3;
  if (!i6) i5 = 0; else i5 = __Znwj(i6 << 3) | 0;
  i4 = i5 + (i1 << 3) | 0;
  i1 = i4 + (0 - i1 << 3) | 0;
  if ((i3 | 0) > 0) _memcpy(i1 | 0, i7 | 0, i3 | 0) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i10 >> 2] = i5 + (i6 << 3);
  if (i7 | 0) __ZdlPv(i7);
 }
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i8 + 4 | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i9 = i11 + 8 | 0;
  i10 = i11 + 4 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 >> 2] = fb + 607;
  __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_(i10, i11, i12);
  STACKTOP = i13;
  return;
 }
 i5 = i12 + 4 | 0;
 i1 = i11 + 8 | 0;
 while (1) {
  i2 = HEAP32[i3 + 20 >> 2] | 0;
  HEAP32[i12 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i5 >> 2] = i2;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEfEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i9, i12); else {
   i6 = i12;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i8 = i2;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = i7;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
 }
 i10 = i11 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 >> 2] = fb + 607;
 __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_(i10, i11, i12);
 STACKTOP = i13;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i14 = HEAP32[i5 + 4 >> 2] | 0;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f23 = Math_fround(-f23);
 f22 = Math_fround(-f22);
 f19 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f18 = Math_fround(HEAPF32[i14 + 96 >> 2]);
 f16 = Math_fround(HEAPF32[i14 + 100 >> 2]);
 f8 = Math_fround(HEAPF32[i14 + 104 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + 112 >> 2]);
 f15 = Math_fround(HEAPF32[i14 + 116 >> 2]);
 f9 = Math_fround(HEAPF32[i14 + 120 >> 2]);
 f10 = Math_fround(HEAPF32[i14 + 128 >> 2]);
 f12 = Math_fround(HEAPF32[i14 + 132 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 136 >> 2]);
 f21 = Math_fround(Math_fround(Math_fround(f18 * f23) + Math_fround(f16 * f22)) + Math_fround(f8 * f19));
 f20 = Math_fround(Math_fround(Math_fround(f17 * f23) + Math_fround(f15 * f22)) + Math_fround(f9 * f19));
 f19 = Math_fround(Math_fround(Math_fround(f10 * f23) + Math_fround(f12 * f22)) + Math_fround(f7 * f19));
 i14 = f21 > f20 & f21 > f19;
 i13 = f20 > f19;
 f10 = i14 ? f18 : i13 ? f17 : f10;
 f12 = i14 ? f16 : i13 ? f15 : f12;
 f7 = i14 ? f8 : i13 ? f9 : f7;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN9LDRColorAC2ERK9HDRColorA(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i3 + 20 | 0;
 i15 = i3 + 16 | 0;
 i20 = i3 + 12 | 0;
 i19 = i3 + 8 | 0;
 i18 = i3 + 4 | 0;
 i17 = i3;
 i21 = HEAP32[i2 >> 2] | 0;
 HEAP32[i20 >> 2] = i21;
 i14 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i19 >> 2] = i14;
 i12 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i18 >> 2] = i12;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i17 >> 2] = i10;
 HEAPF32[i16 >> 2] = Math_fround(0.0);
 HEAPF32[i15 >> 2] = Math_fround(1.0);
 i2 = (HEAP32[tempDoublePtr >> 2] = i21, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 f8 = Math_fround(HEAPF32[i20 >> 2]);
 f8 = i2 ? f8 : Math_fround(0.0);
 i2 = f8 < Math_fround(1.0);
 f7 = Math_fround(HEAPF32[i15 >> 2]);
 i14 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 f6 = Math_fround(HEAPF32[i19 >> 2]);
 f13 = Math_fround(HEAPF32[i16 >> 2]);
 f13 = i14 ? f6 : f13;
 i14 = f13 < Math_fround(1.0);
 f6 = Math_fround(HEAPF32[i15 >> 2]);
 i12 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 f5 = Math_fround(HEAPF32[i18 >> 2]);
 f11 = Math_fround(HEAPF32[i16 >> 2]);
 f11 = i12 ? f5 : f11;
 i12 = f11 < Math_fround(1.0);
 f5 = Math_fround(HEAPF32[i15 >> 2]);
 i10 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i17 >> 2]);
 f9 = Math_fround(HEAPF32[i16 >> 2]);
 f9 = i10 ? f4 : f9;
 i10 = f9 < Math_fround(1.0);
 f4 = Math_fround(HEAPF32[i15 >> 2]);
 f6 = Math_fround((i14 ? f13 : f6) * Math_fround(255.0));
 f5 = Math_fround((i12 ? f11 : f5) * Math_fround(255.0));
 f4 = Math_fround((i10 ? f9 : f4) * Math_fround(255.0));
 HEAP8[i1 >> 0] = ~~Math_fround(Math_fround((i2 ? f8 : f7) * Math_fround(255.0)) + Math_fround(.00100000005));
 HEAP8[i1 + 1 >> 0] = ~~Math_fround(f6 + Math_fround(.00100000005));
 HEAP8[i1 + 2 >> 0] = ~~Math_fround(f5 + Math_fround(.00100000005));
 HEAP8[i1 + 3 >> 0] = ~~Math_fround(f4 + Math_fround(.00100000005));
 STACKTOP = i3;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fEclERKNS0_14IterationStateIS2_EE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i2 = i7;
 HEAP32[i6 + 440 >> 2] = 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesERKNS0_14IterationStateIS2_EE(i6, i3);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesERKNS0_14IterationStateIS2_EE(i6, i3);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE13computeBoundsEv(i6);
 i5 = i6 + 432 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP32[i1 + 152 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = (HEAP32[i3 + 192 >> 2] | 0) == 1;
 i1 = HEAP32[i1 + 148 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 if (i8) __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fPKS1_EEvPT_RKT0_j(HEAP32[i6 + 424 >> 2] | 0, i4, HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0); else {
  i8 = HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0;
  __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ES4_S4_f(i2, i8, i1, Math_fround(__ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv(i3)));
  __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j(HEAP32[i6 + 424 >> 2] | 0, i2, HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0);
 }
 i2 = i6 + 424 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN12_GLOBAL__N_113generateConesEPN5physx5cloth8ConeDataEPKNS1_10SphereDataEPKNS1_9IndexPairEj(HEAP32[i6 + 428 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i8 + 156 >> 2] | 0, HEAP32[i8 + 160 >> 2] | 0);
 if (__ZN5physx5cloth11SwCollisionI8Scalar4fE17buildAccelerationEv(i6) | 0) {
  if (HEAP8[(HEAP32[i5 >> 2] | 0) + 212 >> 0] | 0) __ZN5physx5cloth11SwCollisionI8Scalar4fE26collideContinuousParticlesEv(i6);
  __ZN5physx5cloth11SwCollisionI8Scalar4fE17mergeAccelerationEPj(i6);
  __ZN5physx5cloth11SwCollisionI8Scalar4fE17mergeAccelerationEPj(i6 + 192 | 0);
  if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 212 >> 0] | 0)) __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideParticlesEv(i6);
  __ZN5physx5cloth11SwCollisionI8Scalar4fE23collideVirtualParticlesEv(i6);
 }
 i1 = i6 + 416 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZN5physx6shdfnd4swapINS_5cloth11SwCollisionI8Scalar4fE13CollisionDataEEEvRT_S8_(i2, i1);
 STACKTOP = i7;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i10 + 268 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i11 = i10 + 272 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i1 = HEAP32[i10 + 260 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAPF32[i10 + 304 >> 2] = Math_fround(0.0);
  i8 = i10 + 308 | 0;
  HEAP32[i8 >> 2] = HEAP32[i10 + 320 >> 2];
  i2 = i1 + -1 | 0;
  i9 = i10 + 276 | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP8[i10 + 352 >> 0] = 0;
 } else {
  i2 = i10 + 276 | 0;
  i8 = i10 + 308 | 0;
  i9 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii(i10, i3, i2, i1 + -1 | 0);
 i3 = i10 + 316 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = f7 < Math_fround(HEAPF32[i8 >> 2]);
 HEAP32[i3 >> 2] = HEAP32[(i2 ? i8 : i3) >> 2];
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 if (!(__ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf(i10, HEAP32[i11 >> 2] | 0, HEAP32[i5 >> 2] | 0, i4) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i10 + 356 >> 2] | 0) + (i5 << 3) | 0;
 i2 = (HEAP32[i10 + 260 >> 2] | 0) - i5 + 1 | 0;
 if (i2 | 0) {
  i3 = (HEAP32[i10 + 440 >> 2] | 0) + ((i5 << 2) * 60 | 0) | 0;
  i4 = i2 << 2;
  while (1) {
   i4 = i4 + -1 | 0;
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f7);
   i13 = i3 + 4 | 0;
   HEAPF32[i13 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i13 >> 2]));
   if (!i4) break; else i3 = i3 + 60 | 0;
  }
  while (1) {
   i2 = i2 + -1 | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f7);
   i13 = i1 + 4 | 0;
   HEAPF32[i13 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i13 >> 2]));
   if (!i2) break; else i1 = i1 + 8 | 0;
  }
 }
 i13 = i10 + 320 | 0;
 HEAPF32[i13 >> 2] = Math_fround(Math_fround(HEAPF32[i13 >> 2]) - f7);
 HEAP32[i10 + 300 >> 2] = HEAP32[i10 + 304 >> 2];
 HEAP32[i11 >> 2] = i5;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAP32[i9 >> 2] = i5;
 i13 = 1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i12 = i11 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i13 = i11 + 24 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 >> 2] = i2;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i1 = i10 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i5 = i10 + 16 | 0;
 i8 = i10 + 20 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i3 - i1 | 0;
 HEAP32[i9 >> 2] = i6;
 i7 = i2 + 4 | 0;
 if (i7 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i12 >> 2] = i7;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i10 + 12 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
}

function __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, d16 = 0.0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i9 = i14 + 16 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i9 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 d16 = +HEAPF64[i11 >> 3];
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 i11 = i14 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 16902;
 HEAPF64[i14 >> 3] = d16;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 4) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15HeightFieldDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 28 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 669537 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 28 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 28 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 28 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 28 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 28 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx3Scb5Shape9syncStateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 5 | 0;
 i6 = i13;
 i8 = i13 + 4 | 0;
 i9 = i5 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i2 & 16777215;
 if (!i10) {
  i12 = i5 + 8 | 0;
  HEAP32[i12 >> 2] = 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i12 = i12 & -16777216;
  HEAP32[i9 >> 2] = i12;
  STACKTOP = i13;
  return;
 }
 i11 = i5 + 16 | 0;
 i12 = HEAP8[i5 + 80 >> 0] | 0;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i2 >>> 24 & 15) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 if (i2 & 1 | 0) __ZN5physx2Sc9ShapeCore11setGeometryERKNS_10PxGeometryE(i11, i1 + 56 | 0);
 if (i2 & 2 | 0) {
  i3 = HEAP16[i1 + 116 >> 1] | 0;
  if (i3 << 16 >> 16 == 1) i2 = i1 + 112 | 0; else i2 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
  __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt(i11, i2, i3);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 & 4) {
  __ZN5physx2Sc9ShapeCore14setShape2ActorERKNS_11PxTransformE(i11, i1);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (i2 & 8) {
  __ZN5physx2Sc9ShapeCore23setSimulationFilterDataERKNS_12PxFilterDataE(i11, i1 + 28 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (i2 & 16 | 0) HEAP32[i5 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
 if (i2 & 32) {
  __ZN5physx2Sc9ShapeCore13setRestOffsetEf(i11, Math_fround(HEAPF32[i1 + 48 >> 2]));
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if (i2 & 64 | 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 + 52 >> 0] | 0;
  __ZN5physx2Sc9ShapeCore8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i11, i4);
 }
 i1 = __ZN5physx34NpShapeGetScRigidObjectFromScbSLOWERKNS_3Scb5ShapeE(i5) | 0;
 if (!i1) {
  i12 = i7;
  HEAP32[i12 >> 2] = 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i12 = i12 & -16777216;
  HEAP32[i9 >> 2] = i12;
  STACKTOP = i13;
  return;
 }
 HEAP32[i6 >> 2] = i10;
 HEAP8[i8 >> 0] = i12;
 __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1, i11, i6, i8);
 i12 = i7;
 HEAP32[i12 >> 2] = 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i12 = i12 & -16777216;
 HEAP32[i9 >> 2] = i12;
 STACKTOP = i13;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 3) | 0, 0, i4 - i5 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i12);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i12);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 627;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 620;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 632;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 631;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN13AnimationClip19FireAnimationEventsEffRN5Unity9ComponentEP17AnimatorStateInfoP16AnimatorClipInfob(i2, f8, f10, i11, i12, i13, i1) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, i9 = 0, i14 = 0;
 i14 = i2 + 196 | 0;
 if (f8 == f10) return;
 i3 = (HEAP32[i2 + 200 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0;
 i9 = i3 >> 6;
 if (f8 < f10 & (i1 ^ 1)) {
  f7 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0));
  if (f7 < f10) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) {
   i1 = ~~Math_fround(Math_fround(Math_floor(Math_fround(f10 / Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0))))) + Math_fround(1.0));
   if ((i1 | 0) <= 0) return;
  } else i1 = 1; else i1 = 1;
  if ((i3 | 0) > 0) i2 = 0; else return;
  do {
   f4 = Math_fround(f7 * Math_fround(i2 | 0));
   i3 = 0;
   do {
    i5 = (HEAP32[i14 >> 2] | 0) + (i3 << 6) | 0;
    f6 = Math_fround(f4 + Math_fround(HEAPF32[i5 >> 2]));
    if (!(!(f6 > f8) | !(f6 <= f10))) __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo(i5, i11, 0, i12, i13) | 0;
    i3 = i3 + 1 | 0;
   } while (!(f6 > f10) & (i3 | 0) < (i9 | 0));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
  return;
 }
 if (!(f10 < f8)) return;
 f7 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0));
 if (f7 < f10) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) {
  i1 = ~~Math_fround(Math_fround(Math_floor(Math_fround(f10 / Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0))))) + Math_fround(1.0));
  if ((i1 | 0) <= 0) return;
 } else i1 = 1; else i1 = 1;
 i3 = 0;
 do {
  f4 = Math_fround(f7 * Math_fround(i3 | 0));
  i2 = i9;
  do {
   if ((i2 | 0) <= 0) break;
   i2 = i2 + -1 | 0;
   i5 = (HEAP32[i14 >> 2] | 0) + (i2 << 6) | 0;
   f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f4);
   if (!(!(f6 < f8) | !(f6 >= f10))) __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo(i5, i11, 0, i12, i13) | 0;
  } while (!(f6 <= f10));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig8TransferI8JSONReadEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 8 | 0;
 i10 = i13;
 i1 = i13 + 36 | 0;
 i11 = i13 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i9, i1, gb + 1040948 | 0, 0, 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) HEAP32[i8 >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i6 = i11 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i3 = i12;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i9 + 36 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = i9 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i3 + 16 >> 2] | 0) == 3) {
  i14 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i9, i3, gb + 1040970 | 0) | 0;
  HEAP32[i2 >> 2] = i14;
  i4 = i9 + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i14 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i9, 0);
   i16 = i9 + 8 | 0;
   i15 = HEAP32[i16 + 4 >> 2] | 0;
   i14 = i10;
   HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i14 + 4 >> 2] = i15;
   HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i11, i12, 0);
   HEAP8[i1 >> 0] = 1;
   i14 = i9 + 56 | 0;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
  }
  HEAP32[i2 >> 2] = i3;
  HEAP32[i4 >> 2] = i5;
 }
 __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig32RestoreNetworkRetryTimeoutConfigER13dynamic_arrayIiLj4EE(i8, i11);
 __ZN8JSONRead8TransferIN11UnityEngine7Connect13ConnectConfig14GroupingConfigEEEvRT_PKc17TransferMetaFlagsb(i9, i8 + 20 | 0, gb + 1040992 | 0, 0, 0);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i7);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN11DynamicMeshC2Ef(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i4 = i7;
 i5 = gb + 64016 | 0;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i4);
 i8 = i1;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 i5 = i2 + 20 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i4);
 i6 = i1;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i2 + 24 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i4);
 i6 = i1;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i2 + 44 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 HEAPF32[i2 + 60 >> 2] = f3;
 i6 = i2 + 64 | 0;
 HEAP32[i6 >> 2] = 0;
 i10 = i4;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i4);
 i10 = i1;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i2 + 72 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 _memset(i2 + 88 | 0, -1, 8192) | 0;
 HEAPF32[i2 + 8280 >> 2] = f3;
 if ((HEAP16[gb + 1459068 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459068 | 0, i1);
  HEAP32[i6 >> 2] = i5;
  __Z12profiler_endP19ProfilerInformation(gb + 1459068 | 0);
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i6 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
}

function __ZL10UpdateLinkjjjjPN5physx11AdjTriangleERKNS_17ADJACENCIESCREATEE(i14, i15, i12, i11, i13, i1, i7) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 if (!i1) {
  i4 = 0;
  i3 = 0;
  i2 = 0;
  i6 = 0;
  i5 = 0;
  i1 = 0;
 } else {
  i2 = i14 * 3 | 0;
  i10 = i15 * 3 | 0;
  i4 = HEAP32[i1 + (i2 + 2 << 2) >> 2] | 0;
  i3 = HEAP32[i1 + (i2 + 1 << 2) >> 2] | 0;
  i2 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  i6 = HEAP32[i1 + (i10 + 2 << 2) >> 2] | 0;
  i5 = HEAP32[i1 + (i10 + 1 << 2) >> 2] | 0;
  i1 = HEAP32[i1 + (i10 << 2) >> 2] | 0;
 }
 if (!i7) {
  i8 = i1;
  i9 = i5;
  i10 = i6;
 } else {
  i4 = i14 * 3 | 0;
  i10 = i15 * 3 | 0;
  i2 = HEAPU16[i7 + (i4 << 1) >> 1] | 0;
  i3 = HEAPU16[i7 + (i4 + 1 << 1) >> 1] | 0;
  i4 = HEAPU16[i7 + (i4 + 2 << 1) >> 1] | 0;
  i8 = HEAPU16[i7 + (i10 << 1) >> 1] | 0;
  i9 = HEAPU16[i7 + (i10 + 1 << 1) >> 1] | 0;
  i10 = HEAPU16[i7 + (i10 + 2 << 1) >> 1] | 0;
 }
 i6 = (i2 | 0) == (i12 | 0);
 i7 = (i3 | 0) == (i11 | 0);
 if (i7 & i6) i7 = 0; else {
  i5 = (i2 | 0) == (i11 | 0);
  i2 = (i3 | 0) == (i12 | 0);
  if (i2 & i5) i7 = 0; else {
   i3 = (i4 | 0) == (i11 | 0);
   i1 = (i4 | 0) == (i12 | 0);
   if (i3 & i6 | i1 & i5) i7 = 1; else if (i3 & i2) i7 = 2; else i7 = i1 & i7 ? 2 : -1;
  }
 }
 i5 = (i8 | 0) == (i12 | 0);
 i6 = (i9 | 0) == (i11 | 0);
 if (i6 & i5) i2 = 0; else {
  i4 = (i8 | 0) == (i11 | 0);
  i3 = (i9 | 0) == (i12 | 0);
  if (i3 & i4) i2 = 0; else {
   i2 = (i10 | 0) == (i11 | 0);
   i1 = (i10 | 0) == (i12 | 0);
   if (i2 & i5 | i1 & i4) i2 = 1; else if (i2 & i3) i2 = 2; else i2 = i1 & i6 ? 2 : -1;
  }
 }
 i3 = i7 & 255;
 if (i7 << 24 >> 24 != -1) {
  i1 = i2 & 255;
  if (i2 << 24 >> 24 != -1) {
   HEAP32[i13 + (i14 * 12 | 0) + (i3 << 2) >> 2] = i1 << 30 | i15;
   HEAP32[i13 + (i15 * 12 | 0) + (i1 << 2) >> 2] = i3 << 30 | i14;
   i16 = 1;
   STACKTOP = i17;
   return i16 | 0;
  }
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 727718 | 0, 692, gb + 728696 | 0, i16);
 i16 = 0;
 STACKTOP = i17;
 return i16 | 0;
}

function __Z33AudioSource_CUSTOM_SetCustomCurveP12Il2CppObject24MonoAudioSourceCurveTypeS0_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 68 >> 2] | 0)) {
  if (!i4) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884310 | 0, 0, gb + 875076 | 0, 1284, 1, i1, 0, 0);
  return;
 }
 switch (i2 | 0) {
 case 0:
  {
   if (!i4) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
   __ZN11AudioSource21SetCustomRolloffCurveERK17AnimationCurveTplIfE(i1, i3);
   return;
  }
 case 1:
  {
   if (!i4) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
   __ZN11AudioSource26SetCustomSpatialBlendCurveERK17AnimationCurveTplIfE(i1, i3);
   return;
  }
 case 2:
  {
   if (!i4) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
   __ZN11AudioSource27SetCustomReverbZoneMixCurveERK17AnimationCurveTplIfE(i1, i3);
   return;
  }
 case 3:
  {
   if (!i4) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
   __ZN11AudioSource20SetCustomSpreadCurveERK17AnimationCurveTplIfE(i1, i3);
   return;
  }
 default:
  {
   if (!i4) i1 = 0; else {
    i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884395 | 0, 0, gb + 875076 | 0, 1303, 1, i1, 0, 0);
   return;
  }
 }
}

function __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 3);
 i2 = i9 + 4 | 0;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i5;
 i8 = i1;
 if ((i1 + 8 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i6 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 + 8 >> 2] = i6;
   }
   i1 = HEAP32[i9 + 24 >> 2] | 0;
  } else {
   i1 = i6 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i8 - i5 | 0;
  i8 = i5 + 8 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 8;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 return 0;
}

function __ZN2UI13CanvasManager21EmitGeometryForCameraEP6Camera(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i10 = i13;
 i11 = i13 + 16 | 0;
 i2 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i9 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i9, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i2, i9, Math_fround(4.0), 0);
 HEAP16[i11 >> 1] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = i6;
  while (1) {
   i3 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i3) break; else i1 = i3;
  }
  i5 = HEAP32[i1 + 40 >> 2] | 0;
  if (!i5) i1 = 0; else {
   HEAP32[i10 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i12 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 14;
    }
   }
   if ((i12 | 0) == 12) i12 = 14;
   if ((i12 | 0) == 14) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   }
  }
  if ((__ZNK2UI6Canvas13GetRenderModeEv(i6) | 0) == 2) i12 = 18; else if ((i1 | 0) == (i8 | 0) & (__ZNK2UI6Canvas13GetRenderModeEv(i6) | 0) == 1) i12 = 18;
  if ((i12 | 0) == 18) {
   i12 = 0;
   __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i6, i8, i11, 1);
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i7 >> 2] | 0));
 STACKTOP = i13;
 return;
}

function __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i5, i6, i8, f3, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i9 = 0;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = i8 + 52 | 0;
 i9 = HEAP32[i8 + 104 >> 2] | 0;
 i2 = HEAP32[i8 + 108 >> 2] | 0;
 HEAP32[i8 + 280 >> 2] = HEAP32[i8 + 100 >> 2];
 HEAP32[i8 + 284 >> 2] = i9;
 HEAP32[i8 + 288 >> 2] = i2;
 __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_(i5, i7, i1, i8 + 244 | 0, i8 + 304 | 0, i8 + 316 | 0);
 i7 = i8 + 180 | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i1, i7) | 0;
 __ZN14ParticleSystem19UpdateVelocityStateERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemState(i5, i6, i8);
 i1 = i5 + 916 | 0;
 if (!(HEAP8[(HEAP32[i1 >> 2] | 0) + 4 >> 0] | 0)) i1 = 0; else {
  i2 = __ZN14ParticleSystem16SetupSubEmittersERS_R19ParticleSystemState(i5, i8) | 0;
  if (HEAP8[(HEAP32[i1 >> 2] | 0) + 4 >> 0] | 0) {
   i1 = HEAP32[i8 + 412 >> 2] | 0;
   if (i1 | 0) __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(HEAP32[i5 + 32 >> 2] | 0, (i1 | 0) > 2 ? 2 : i1);
  }
  if (!i2) i1 = 0; else {
   i1 = __ZN14ParticleSystem35CalculateMaximumSubEmitterEmitCountERS_R19ParticleSystemStatefbi(i5, i8, f3, (i4 & 1 | 0) != 0, i2) | 0;
   if (!i1) i1 = 0; else HEAP32[i8 + 456 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 112 | 0, 4, gb + 64016 | 0, 0, gb + 612988 | 0, 3126) | 0;
  }
 }
 HEAP32[i8 + 460 >> 2] = 0;
 HEAP32[i8 + 464 >> 2] = i1;
 if (HEAP8[(HEAP32[i5 + 880 >> 2] | 0) + 4 >> 0] | 0) {
  __ZN20ExternalForcesModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i6, i8);
  __ZN20ExternalForcesModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i6, i8);
 }
 i1 = HEAP32[i5 + 904 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN15CollisionModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i6, i8);
 if (HEAP8[i5 + 52 >> 0] | 0) __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f(i5 + 48 | 0, i7);
 i1 = HEAP32[i5 + 920 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) return;
 __ZN12LightsModule5CacheER19ParticleSystemState(i1, i8);
 return;
}

function __ZN12CullingGroup20SetBoundingDistancesEPKfj(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i3 = i9 + 4 | 0;
 i6 = (i7 | 0) == 0 ? 0 : i1;
 if (i6 >>> 0 > 127) {
  HEAP32[i4 >> 2] = ~~Math_fround(_log2f(Math_fround(128.0)));
  __Z6FormatPKcz(i3, gb + 385358 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 385204 | 0, 226, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i9;
  return;
 }
 L5 : do if (i6 >>> 0 > 1) {
  i1 = 1;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  while (1) {
   f10 = f2;
   f2 = Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]);
   i1 = i1 + 1 | 0;
   if (f2 < f10) break;
   if (i1 >>> 0 >= i6 >>> 0) break L5;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 385421 | 0, 0, gb + 385204 | 0, 234, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 } while (0);
 i5 = i8 + 84 | 0;
 i1 = i8 + 96 | 0;
 HEAP32[i1 >> 2] = i6;
 i3 = i8 + 100 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i6 << 4, 16, i8 + 88 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i8 + 88 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = i4;
  break;
 } while (0);
 i4 = (i6 | 0) == 0;
 if (i4) i1 = 0; else {
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   f10 = Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]);
   f10 = Math_fround(f10 * f10);
   HEAPF32[i3 + (i1 << 4) >> 2] = f10;
   HEAPF32[i3 + (i1 << 4) + 4 >> 2] = f10;
   HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f10;
   HEAPF32[i3 + (i1 << 4) + 12 >> 2] = f10;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  if (i4) i1 = 0; else i1 = Math_fround(HEAPF32[i7 + (i6 + -1 << 2) >> 2]) >= Math_fround(inf) & 1;
 }
 HEAP8[i8 + 104 >> 0] = i1;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 643;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 24 | 0;
 i2 = i3;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, i5);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i7 = i2 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 32 | 0, 0);
 i6 = i4 + 16 | 0;
 i5 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 STACKTOP = i3;
 return;
}

function __ZN14VelocityModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff(i1, i5, i3, f2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i8 + 104 | 0;
 i12 = i8 + 96 | 0;
 i4 = i8 + 88 | 0;
 i6 = i8 + 24 | 0;
 i7 = i8;
 __ZNK11MinMaxCurve20FindMinMaxIntegratedEv(i13, i1 + 8 | 0);
 __ZNK11MinMaxCurve20FindMinMaxIntegratedEv(i12, i1 + 272 | 0);
 __ZNK11MinMaxCurve20FindMinMaxIntegratedEv(i4, i1 + 536 | 0);
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f10 = Math_fround(f10 * f2);
 f11 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f2);
 HEAPF32[i5 >> 2] = Math_fround(f9 * f2);
 HEAPF32[i5 + 4 >> 2] = f10;
 HEAPF32[i5 + 8 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f10 = Math_fround(f10 * f2);
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * f2);
 HEAPF32[i5 + 12 >> 2] = Math_fround(f11 * f2);
 HEAPF32[i5 + 16 >> 2] = f10;
 HEAPF32[i5 + 20 >> 2] = f9;
 if (!(HEAP8[i1 + 800 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i6;
 i1 = i3;
 i3 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 HEAP32[i6 + 48 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f10 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f11 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i7 + 12 >> 2] = f9;
 HEAPF32[i7 + 16 >> 2] = f10;
 HEAPF32[i7 + 20 >> 2] = f11;
 __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i5, i6, i7);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 STACKTOP = i8;
 return;
}

function _prepare_for_pass(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i4 + 316 >> 2] | 0;
 i1 = i5 + 16 | 0;
 L1 : do switch (HEAP32[i1 >> 2] | 0) {
 case 0:
  {
   _select_scan_parameters(i4);
   _per_scan_setup(i4);
   if (!(HEAP8[i4 + 176 >> 0] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 + 336 >> 2] >> 2] | 0, i4 | 0);
    mftCall_vi(HEAP32[HEAP32[i4 + 340 >> 2] >> 2] | 0, i4 | 0);
    mftCall_vii(HEAP32[HEAP32[i4 + 324 >> 2] >> 2] | 0, i4 | 0, 0);
   }
   mftCall_vi(HEAP32[HEAP32[i4 + 344 >> 2] >> 2] | 0, i4 | 0);
   i3 = i4 + 178 | 0;
   mftCall_vii(HEAP32[HEAP32[i4 + 348 >> 2] >> 2] | 0, i4 | 0, HEAP8[i3 >> 0] | 0);
   mftCall_vii(HEAP32[HEAP32[i4 + 328 >> 2] >> 2] | 0, i4 | 0, ((HEAP32[i5 + 24 >> 2] | 0) > 1 ? 3 : 0) | 0);
   mftCall_vii(HEAP32[HEAP32[i4 + 320 >> 2] >> 2] | 0, i4 | 0, 0);
   i1 = i5 + 12 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    HEAP8[i1 >> 0] = 1;
    break L1;
   } else {
    HEAP8[i1 >> 0] = 0;
    break L1;
   }
  }
 case 1:
  {
   _select_scan_parameters(i4);
   _per_scan_setup(i4);
   if (!(HEAP32[i4 + 300 >> 2] | 0)) if (HEAP32[i4 + 308 >> 2] | 0) if (!(HEAP8[i4 + 177 >> 0] | 0)) {
    HEAP32[i1 >> 2] = 2;
    i2 = i5 + 20 | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    i2 = 12;
    break L1;
   }
   mftCall_vii(HEAP32[HEAP32[i4 + 348 >> 2] >> 2] | 0, i4 | 0, 1);
   mftCall_vii(HEAP32[HEAP32[i4 + 328 >> 2] >> 2] | 0, i4 | 0, 2);
   HEAP8[i5 + 12 >> 0] = 0;
   break;
  }
 case 2:
  {
   i2 = 12;
   break;
  }
 default:
  {
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 48;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
  }
 } while (0);
 if ((i2 | 0) == 12) {
  if (!(HEAP8[i4 + 178 >> 0] | 0)) {
   _select_scan_parameters(i4);
   _per_scan_setup(i4);
  }
  mftCall_vii(HEAP32[HEAP32[i4 + 348 >> 2] >> 2] | 0, i4 | 0, 0);
  mftCall_vii(HEAP32[HEAP32[i4 + 328 >> 2] >> 2] | 0, i4 | 0, 2);
  i1 = i4 + 332 | 0;
  if (!(HEAP32[i5 + 28 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
  HEAP8[i5 + 12 >> 0] = 0;
 }
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP8[i5 + 13 >> 0] = (i2 | 0) == (i3 + -1 | 0) & 1;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 16 >> 2] = i3;
 return;
}

function __ZNSt3__26vectorIjNS_9allocatorIjEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i1, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i4 - i12 >> 2;
 i9 = i10 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i1 = i12;
 i7 = i8;
 i11 = i4;
 if (i6 >>> 0 <= i2 - i8 >> 2 >>> 0) {
  i9 = i10 + 4 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) - i8 >> 2;
  i3 = i6 >>> 0 > i2 >>> 0;
  i6 = i3 ? i1 + (i2 << 2) | 0 : i4;
  i1 = i6 - i12 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i8 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i7 + (i2 << 2) | 0;
  if (!i3) {
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i9 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
  i5 = HEAP32[i5 >> 2] | 0;
  i1 = i6;
  if ((i1 | 0) == (i5 | 0)) return;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = i5 + -4 - i6 | 0;
  i2 = i4;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i9 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
  return;
 }
 i4 = i8;
 if (i8) {
  i2 = i10 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i8 | 0) >>> 2) << 2);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  i2 = 0;
 }
 if (i6 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i3 = 0;
 i8 = i2 - i3 | 0;
 i2 = i8 >> 1;
 i2 = i8 >> 2 >>> 0 < 536870911 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 1073741823;
 if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
 i4 = __Znwj(i2 << 2) | 0;
 i5 = i10 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i4 + (i2 << 2);
 if ((i1 | 0) == (i11 | 0)) return;
 i3 = i11 + -4 - i12 | 0;
 i2 = i4;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 4 | 0;
 }
 HEAP32[i5 >> 2] = i4 + ((i3 >>> 2) + 1 << 2);
 return;
}

function __ZN5physx14NpArticulation10createLinkEPNS_18PxArticulationLinkERKNS_11PxTransformE(i7, i3, i4) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i5 = i8;
 i1 = i8 + 12 | 0;
 i2 = (HEAP32[i7 + 92 >> 2] | 0) == 0;
 if (!i3) {
  if (!i2) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686006 | 0, 324, gb + 686136 | 0, i6);
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 } else if (i2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686006 | 0, 318, gb + 686082 | 0, i5);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f13 * f13);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f11 * f11));
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f10 * f10));
 f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f9 * f9)))));
 f11 = Math_fround(f11 * f12);
 f10 = Math_fround(f10 * f12);
 f9 = Math_fround(f9 * f12);
 HEAPF32[i1 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i1 + 4 >> 2] = f11;
 HEAPF32[i1 + 8 >> 2] = f10;
 HEAPF32[i1 + 12 >> 2] = f9;
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 i2 = __ZN5physx9NpFactory22createArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE(i2, i7, i3, i1) | 0;
 if (!i2) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((((HEAP32[i7 + 16 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i7 = i2;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (!i1) {
  i7 = i2;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 if (!i1) {
  i7 = i2;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZN5physx7NpScene19addArticulationLinkERNS_18NpArticulationLinkE(i1, i2);
 i7 = i2;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i13, i4, i3) {
 i13 = i13 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i13 + 24 | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i13 + 48 >> 2] = i1;
 }
 i11 = i13 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i13 + 48 >> 2] = i1;
 }
 i12 = i13 + 36 | 0;
 i1 = HEAP32[i13 + 40 >> 2] | 0;
 i9 = i13 + 48 | 0;
 HEAP32[i9 >> 2] = i1;
 i10 = HEAP32[i13 + 44 >> 2] | 0;
 HEAP32[i13 + 52 >> 2] = i10 - i1;
 HEAP32[i13 >> 2] = 0;
 i2 = i13 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 if (!i3) i3 = 0; else {
  HEAP32[i2 >> 2] = i3;
  i4 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if (!i4) return;
 if ((HEAP32[i4 >> 2] & 65535 | 0) != 18) return;
 HEAP32[i13 >> 2] = i4;
 i2 = i1 + 48 | 0;
 if (i2 >>> 0 > i10 >>> 0) i7 = 0; else {
  HEAP32[i9 >> 2] = i2;
  i7 = i1;
  i1 = i2;
 }
 i8 = i13 + 80 | 0;
 if (!i3) i2 = 4; else i2 = HEAP8[i3 + 24 >> 0] | 0 ? 8 : 4;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i7 + 12 >> 2] = i8;
 i3 = i13 + 84 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i7 + 16 >> 2] = i5;
 HEAP32[i7 + 20 >> 2] = i2;
 HEAP32[i11 >> 2] = i7;
 i2 = HEAP32[i4 + 160 >> 2] | 0;
 HEAP32[i7 + 32 >> 2] = (HEAP32[i4 + 44 >> 2] | 0) >>> 5;
 HEAP32[i7 + 4 >> 2] = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
 i2 = i1 + 48 | 0;
 if (i2 >>> 0 > i10 >>> 0) i1 = 0; else HEAP32[i9 >> 2] = i2;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i1 + 12 >> 2] = i8;
 HEAP32[i3 >> 2] = i5 + 2;
 HEAP32[i1 + 16 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 4;
 HEAP32[i14 >> 2] = i1;
 i12 = HEAP32[i4 + 152 >> 2] | 0;
 i14 = HEAP32[i4 + 148 >> 2] | 0;
 i11 = (Math_imul(i14, HEAP32[i4 + 144 >> 2] | 0) | 0) + 31 >> 5;
 HEAP32[i1 + 32 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = (i12 | 0) == 0 ? 0 : i4 + i12 | 0;
 HEAP32[i13 + 28 >> 2] = i14;
 HEAP32[i13 + 92 >> 2] = 0;
 HEAP32[i13 + 96 >> 2] = 0;
 HEAP32[i13 + 100 >> 2] = i4;
 HEAP32[i13 + 104 >> 2] = i4;
 HEAP32[i13 + 108 >> 2] = 0;
 HEAP32[i13 + 112 >> 2] = 0;
 HEAP32[i13 + 116 >> 2] = 0;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = (i5 - i4 | 0) / 40 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj(i2, i1 - i3 | 0);
  i4 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i3 >>> 0) {
  i4 = i4 + (i1 * 40 | 0) | 0;
  if ((i5 | 0) == (i4 | 0)) i4 = i5; else {
   i2 = i5;
   while (1) {
    i1 = i2 + -40 | 0;
    HEAP32[i6 >> 2] = i1;
    i3 = HEAP32[i2 + -16 >> 2] | 0;
    i5 = i3;
    if (i3) {
     i1 = i2 + -12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i5 | 0) >>> 2) << 2);
     __ZdlPv(i3);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 } else i4 = i5;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i12);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS3_9allocatorIiEEEEEvRT_17TransferMetaFlags(i12, i1 + 24 | 0, 0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __Z33Gradient_Get_Custom_PropAlphaKeysP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 8 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3); else {
  i5 = HEAPU8[i1 + 65 >> 0] | 0;
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 3 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 48 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 7 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 12 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 50 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 16 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 11 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 20 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 52 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 24 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 15 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 28 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 54 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 32 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 19 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 36 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 56 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 40 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 23 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 44 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 58 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 48 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 27 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 52 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 60 >> 1] | 0) / Math_fround(65535.0));
  HEAPF32[i2 + 56 >> 2] = Math_fround(Math_fround(HEAPU8[i1 + 31 >> 0] | 0) / Math_fround(255.0));
  HEAPF32[i2 + 60 >> 2] = Math_fround(Math_fround(HEAPU16[i1 + 62 >> 1] | 0) / Math_fround(65535.0));
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 204 >> 2] | 0, 8, i5) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 8) | 0, i2 | 0, i5 << 3 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __GLOBAL__sub_I_runtime_terrain2_lump_cpp() {
 HEAP32[gb + 1467612 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467612 | 0, gb + 936470 | 0);
 HEAP32[gb + 1467476 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467476 | 0, gb + 935526 | 0);
 HEAP32[gb + 1467480 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467480 | 0, gb + 935554 | 0);
 HEAPF32[gb + 1467504 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1467504 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 36 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1467504 + 40 >> 2] = 0;
 HEAP32[gb + 1467504 + 40 + 4 >> 2] = 0;
 HEAP32[gb + 1467504 + 40 + 8 >> 2] = 0;
 HEAP32[gb + 1467504 + 40 + 12 >> 2] = 0;
 HEAP32[gb + 1467504 + 40 + 16 >> 2] = 0;
 HEAPF32[gb + 1467504 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 64 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 68 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 72 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1467504 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 80 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1467504 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 92 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1467504 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1467504 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1467504 + 104 >> 2] = Math_fround(-1.0);
 HEAP32[gb + 1467484 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467484 | 0, gb + 935578 | 0);
 HEAP32[gb + 1467488 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467488 | 0, gb + 935604 | 0);
 HEAP32[gb + 1467492 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467492 | 0, gb + 935627 | 0);
 HEAP32[gb + 1467496 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467496 | 0, gb + 935653 | 0);
 HEAP32[gb + 1467500 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1467500 | 0, gb + 935677 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 28 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 731374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 28 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 28 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 28 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 28 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 28 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i10, i11, i12, i13, i9, i1, i8) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 168 | 0;
 i3 = i7 + 96 | 0;
 i4 = i7;
 i6 = i7 + 24 | 0;
 i1 = i11 + 4 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i11 + 8 >> 2]) == Math_fround(1.0)) i2 = Math_fround(HEAPF32[i11 + 12 >> 2]) == Math_fround(1.0); else i2 = 0; else i2 = 0;
 HEAP32[i5 >> 2] = 1065353216;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 1065353216;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 1065353216;
 HEAP32[i5 + 36 >> 2] = 1065353216;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 1065353216;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 1065353216;
 if (!i2) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i5, i1, i11 + 16 | 0);
 HEAP32[i3 >> 2] = 1065353216;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 1065353216;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 1065353216;
 HEAP32[i3 + 36 >> 2] = 1065353216;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 1065353216;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 1065353216;
 i10 = __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i10, i3, i4, i6) | 0;
 i13 = __ZL16contactHullMesh2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESI_bb(i6, i4, i11, i12, i13, Math_fround(HEAPF32[i9 >> 2]), i8, i3, i5, i10, i2) | 0;
 STACKTOP = i7;
 return i13 | 0;
}

function __ZN5physx18PxVehicleDriveTank12createObjectERPhRNS_24PxDeserializationContextE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 159336 + 8;
 HEAPF32[i3 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 308 >> 2] = Math_fround(500.0);
 HEAPF32[i3 + 312 >> 2] = Math_fround(600.0);
 HEAPF32[i3 + 316 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 320 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 324 >> 2] = Math_fround(.349999994);
 HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 228 >> 2] = Math_fround(.800000011);
 HEAPF32[i3 + 232 >> 2] = Math_fround(.330000013);
 HEAPF32[i3 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 240 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 244 >> 2] = Math_fround(.800000011);
 HEAP32[i3 + 288 >> 2] = 3;
 HEAPF32[i3 + 328 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 332 >> 2] = Math_fround(.00166666671);
 HEAPF32[i3 + 464 >> 2] = Math_fround(4.0);
 HEAP32[i3 + 468 >> 2] = 7;
 HEAPF32[i3 + 472 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 336 >> 2] = Math_fround(-4.0);
 HEAPF32[i3 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 344 >> 2] = Math_fround(4.0);
 HEAPF32[i3 + 348 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 352 >> 2] = Math_fround(1.5);
 HEAPF32[i3 + 356 >> 2] = Math_fround(1.10000002);
 HEAPF32[i3 + 360 >> 2] = Math_fround(1.0);
 i1 = i3 + 364 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i3 + 480 >> 2] = Math_fround(10.0);
 HEAP32[i3 + 484 >> 2] = 1;
 HEAP32[i3 + 488 >> 2] = 5;
 i1 = 0;
 do {
  HEAPF32[i3 + 496 + (i1 << 2) >> 2] = Math_fround(.649999976);
  HEAPF32[i3 + 624 + (i1 << 2) >> 2] = Math_fround(.5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAPF32[i3 + 500 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 624 >> 2] = Math_fround(2.0);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 768;
 i4 = i3 + 44 | 0;
 i6 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i4 >> 2] | 0) | 0;
 i1 = i5 + 4 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 15 & -16;
 HEAP32[i1 >> 2] = i2 + i6;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i3, i2, HEAP32[i4 >> 2] | 0, HEAP32[i3 + 48 >> 2] | 0, 0) | 0;
 __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE(i3, i5);
 return i3 | 0;
}

function __ZNSt3__210to_wstringEy(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i10, 23, 0);
 i1 = i10 + 8 | 0;
 i6 = i1 + 3 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i6 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  __THREW__ = 0;
  i2 = i7;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215384 | 0, i7 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i6 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i3 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210to_wstringEx(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i10, 23, 0);
 i1 = i10 + 8 | 0;
 i6 = i1 + 3 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i6 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  __THREW__ = 0;
  i2 = i7;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215364 | 0, i7 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i6 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i3 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15disposeElementsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 4 | 0;
 i2 = i13;
 i6 = i13 + 17 | 0;
 i7 = i13 + 16 | 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i5 = i8 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i9 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i12, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j(i1, i2, i6, i8, 32);
 i2 = i8 + 264 | 0;
 i6 = i8 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7, i8, 32);
 i2 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = i2 + (i7 << 2) | 0;
 if (i7 | 0) {
  i5 = i8 + 276 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i5 >> 2] | 0;
   i4 = i3 + (i8 << 6) | 0;
   if (i8) do {
    if ((i1 | 0) == ((HEAP32[i12 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0)) i11 = 15; else if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) i1 = i1 + 4 | 0; else i11 = 15;
    if ((i11 | 0) == 15) i11 = 0;
    i3 = i3 + 64 | 0;
   } while ((i3 | 0) != (i4 | 0));
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i6 | 0));
 }
 i11 = HEAP32[i10 >> 2] | 0;
 if (!((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold20reduceContactSegmentERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE(i1, i4, i5, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i1 = i1 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f11 = Math_fround(f11 - f8);
 f10 = Math_fround(f10 - f7);
 f9 = Math_fround(f9 - f6);
 f8 = Math_fround(f13 - f8);
 f7 = Math_fround(f12 - f7);
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) - f6);
 if (Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f9 * f9)) > Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6))) {
  i2 = i2 + 48 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i4 = (HEAP32[i1 >> 2] | 0) + 64 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  return 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i4 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i5 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  return 0;
 }
 return 0;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient17PlayerLoopHandlerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i5 = i1 + 28 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = i1 + 32 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0)) {
  i4 = HEAP32[i6 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0) | 0)) {
   STACKTOP = i7;
   return;
  }
 }
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if (i8 & (i4 | 0) == 0) {
  i8 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i8 | 0);
  i8 = i1 + 36 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc(0, i2, i1 + 56 | 0, i8, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0) | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  if (((HEAP32[i8 >> 2] | 0) + -200 | 0) >>> 0 < 5) {
   HEAP32[i3 >> 2] = 1;
   i1 = 13;
   break;
  } else {
   HEAP32[i3 >> 2] = 2;
   i1 = 10;
   break;
  }
 } else if ((i4 | 0) == 1) i1 = 13; else i1 = 10; while (0);
 if ((i1 | 0) == 10) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   __ZN3WWW7ReleaseEv(i1);
   HEAP32[i6 >> 2] = 0;
  }
  i8 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 13) {
  i4 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = mftCall_ii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  mftCall_iiii(i3 | 0, i4 | 0, i8 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   __ZN3WWW7ReleaseEv(i1);
   HEAP32[i6 >> 2] = 0;
  }
  i8 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
  STACKTOP = i7;
  return;
 }
}

function __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE(i9, 4);
 i2 = i9 + 4 | 0;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i5;
 i8 = i1;
 if ((i1 + 8 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i6 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 + 8 >> 2] = i6;
   }
   i1 = HEAP32[i9 + 24 >> 2] | 0;
  } else {
   i1 = i6 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i8 - i5 | 0;
  i8 = i5 + 8 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 8;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 return 0;
}

function __ZN5physx2Sc5Scene13postIslandGenEPNS_10PxBaseTaskE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i11 + 1204 | 0;
 i9 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i8 >> 2] | 0) | 0;
 i3 = HEAP32[i9 + 496 >> 2] | 0;
 i5 = (HEAP32[i9 + 500 >> 2] | 0) - i3 | 0;
 i6 = i9 + 488 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3) {
  i7 = 0;
  do {
   i1 = HEAP32[i4 + (i5 + i7 << 2) >> 2] | 0;
   i2 = i1;
   if (!(i2 & 15)) if (!i1) {
    i1 = 0;
    i10 = 6;
   } else __ZN5physx2Sc5Actor9setActiveEbj(i1, 0, 2); else {
    i1 = i2 & -2;
    i10 = 6;
   }
   if ((i10 | 0) == 6) {
    i10 = 0;
    __ZN5physx2Sc15ArticulationSim9setActiveEbj(i1, 0, 2);
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i3 | 0));
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i3 = HEAP32[i9 + 492 >> 2] | 0;
 if (i3 | 0) {
  i5 = 0;
  do {
   i1 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
   i2 = i1;
   if (!(i2 & 15)) if (!i1) {
    i1 = 0;
    i10 = 14;
   } else __ZN5physx2Sc5Actor9setActiveEbj(i1, 1, 2); else {
    i1 = i2 & -2;
    i10 = 14;
   }
   if ((i10 | 0) == 14) {
    i10 = 0;
    __ZN5physx2Sc15ArticulationSim9setActiveEbj(i1, 1, 2);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 __ZN5physx2Sc10NPhaseCore11narrowPhaseEv(HEAP32[i11 + 1104 >> 2] | 0);
 __ZN5physx16PxsIslandManager27setWokenPairContactManagersEv(i9);
 i1 = HEAP32[i9 + 508 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i9 + 504 >> 2] | 0;
 i9 = i11 + 2012 | 0;
 i6 = i11 + 1984 | 0;
 HEAP32[i11 + 2028 >> 2] = 1;
 i10 = i11 + 2024 | 0;
 HEAP32[i10 >> 2] = i6;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
 HEAP32[i11 + 2020 >> 2] = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2];
 i10 = i11 + 2040 | 0;
 HEAP32[i11 + 2056 >> 2] = 1;
 i6 = i11 + 2052 | 0;
 HEAP32[i6 >> 2] = i9;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0);
 HEAP32[i11 + 2048 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
 __ZN5physx10PxsContext30secondPassUpdateContactManagerEfPNS_25NarrowPhaseContactManagerEjPNS_10PxBaseTaskE(HEAP32[(HEAP32[i8 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(HEAPF32[i11 + 64 >> 2]), i7, i1, i10);
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0);
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0);
 return;
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 24 | 0;
 i12 = i14;
 i13 = i10 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if ((((HEAP32[i13 >> 2] | 0) - i5 | 0) / 84 | 0) >>> 0 >= i7 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i1 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i1;
 if (!i7) {
  i6 = 0;
  i3 = i4;
  i8 = i5;
  i2 = i4;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = 73;
  HEAP32[i2 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 84 | 0, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
  i8 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i6;
 i1 = i6 + (((i4 - i5 | 0) / 84 | 0) * 84 | 0) | 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i9 = i12 + 12 | 0;
 HEAP32[i9 >> 2] = i6 + (i7 * 84 | 0);
 if ((i3 | 0) != (i8 | 0)) {
  i2 = i3;
  do {
   i7 = i2;
   i2 = i2 + -84 | 0;
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i1 + -84 | 0, i2);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i1 + -64 | 0, i7 + -64 | 0);
   __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i1 + -44 | 0, i7 + -44 | 0);
   HEAP32[i1 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i7 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   i1 = (HEAP32[i5 >> 2] | 0) + -84 | 0;
   HEAP32[i5 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__214__split_bufferI14HeightMeshDataR13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZNK5physx29PxVehicleDrive4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i10 + 8 | 0;
 i5 = i1 + 108 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj678ENS_22PxRepXPropertyAccessorILj678ES4_NS_23PxVehicleDriveSimData4WES9_EEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i9 = i9 + 2 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i9 = i9 + 2 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 40 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 40 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5Umbra11Transformer4initEPKNS_7Vector4Ei(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i2 + 1392 >> 2] = 0;
 HEAP32[i2 + 1396 >> 2] = 1;
 HEAP8[i2 + 1224 >> 0] = 0;
 i1 = i2 + 1208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 + 1196 >> 2] = i4;
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   i5 = i2 + 128 + (i1 << 4) | 0;
   i8 = i3 + (i1 << 4) | 0;
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i2 + 1228 + (i1 << 2) >> 2] = i1;
   i8 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i5 + 4 >> 2] | 0;
   i6 = HEAP32[i5 + 8 >> 2] | 0;
   i5 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i2 + 480 + (i1 << 4) >> 2] = i8;
   HEAP32[i2 + 480 + (i1 << 4) + 4 >> 2] = i7;
   HEAP32[i2 + 480 + (i1 << 4) + 8 >> 2] = i6;
   HEAP32[i2 + 480 + (i1 << 4) + 12 >> 2] = i5;
   i8 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i7 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i6 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0);
   i5 = ((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) > Math_fround(0.0)) << 31 >> 31;
   HEAP32[i2 + 832 + (i1 << 4) >> 2] = i8 << 31 >> 31;
   HEAP32[i2 + 832 + (i1 << 4) + 4 >> 2] = i7 << 31 >> 31;
   HEAP32[i2 + 832 + (i1 << 4) + 8 >> 2] = i6 << 31 >> 31;
   HEAP32[i2 + 832 + (i1 << 4) + 12 >> 2] = i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAPF32[i2 + 1316 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i2 + 1320 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i2 + 1324 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i2 + 1328 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i2 + 1332 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 1336 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 1340 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 1344 >> 2] = Math_fround(3402823469999999843913219.0e14);
 return;
}

function __ZN19TouchPhaseEmulationC2Efb(i5, f2, i1) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i5 >> 2] = gb + 62260 + 8;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i5 + 16 >> 2] = f2;
 HEAP8[i5 + 20 >> 0] = 0;
 i3 = i1 & 1;
 HEAP8[i5 + 22 >> 0] = i3 ^ 1;
 HEAP8[i5 + 23 >> 0] = i3;
 i3 = __Znaj(3072) | 0;
 i1 = i3 + 3072 | 0;
 i4 = i3;
 do {
  HEAP32[i4 >> 2] = -1;
  HEAP32[i4 + 36 >> 2] = 4;
  HEAP32[i4 + 92 >> 2] = 0;
  HEAP32[i4 + 84 >> 2] = 0;
  HEAP32[i4 + 88 >> 2] = 0;
  i8 = i4 + 4 | 0;
  i9 = i4 + 72 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 24 >> 2] = 0;
  HEAP32[i8 + 28 >> 2] = 0;
  HEAP32[i4 + 80 >> 2] = -1;
  HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
  HEAP32[i4 + 40 >> 2] = 0;
  i8 = i4 + 52 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  i4 = i4 + 96 | 0;
 } while ((i4 | 0) != (i1 | 0));
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = 0;
 while (1) {
  HEAP32[i3 + (i1 * 96 | 0) >> 2] = -1;
  HEAP32[i3 + (i1 * 96 | 0) + 36 >> 2] = 4;
  HEAP32[i3 + (i1 * 96 | 0) + 92 >> 2] = 0;
  HEAP32[i3 + (i1 * 96 | 0) + 84 >> 2] = 0;
  HEAP32[i3 + (i1 * 96 | 0) + 88 >> 2] = 0;
  i9 = i3 + (i1 * 96 | 0) + 4 | 0;
  i8 = i3 + (i1 * 96 | 0) + 72 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
  HEAP32[i9 + 28 >> 2] = 0;
  HEAP32[i3 + (i1 * 96 | 0) + 80 >> 2] = -1;
  HEAPF32[i3 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
  HEAP32[i3 + (i1 * 96 | 0) + 40 >> 2] = 0;
  i9 = i3 + (i1 * 96 | 0) + 52 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  HEAP32[i9 + 12 >> 2] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break;
  i3 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 1;
 return;
}

function __ZN14LineParametersC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 40 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 44780 + 8;
 i7 = i2;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 i6 = i1 + 20 | 0;
 HEAPF32[i1 + 24 >> 2] = Math_fround(inf);
 HEAP32[i6 >> 2] = 0;
 i9 = i1 + 28 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAPF32[i1 + 52 >> 2] = Math_fround(inf);
 HEAP32[i1 + 48 >> 2] = 0;
 i9 = i1 + 56 | 0;
 i7 = i1 + 88 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i1 + 100 >> 2] = 2;
 HEAP32[i1 + 96 >> 2] = 2;
 HEAP32[i1 + 104 >> 2] = 4;
 i2 = i1 + 108 | 0;
 __ZN8GradientC2Ev(i2);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i5, Math_fround(0.0), i4);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i6, i5) | 0;
 HEAP32[i5 >> 2] = 1065353216;
 HEAP32[i5 + 4 >> 2] = 1065353216;
 HEAP32[i5 + 8 >> 2] = 1065353216;
 HEAP32[i5 + 12 >> 2] = 1065353216;
 HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 20 >> 2] = 1065353216;
 HEAP32[i5 + 24 >> 2] = 1065353216;
 HEAP32[i5 + 28 >> 2] = 1065353216;
 HEAP32[i5 + 32 >> 2] = 1065353216;
 HEAPF32[i5 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i2, i5, 2);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i2, i4, 2);
 i2 = i1 + 180 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN10DynamicVBO19FillQuadIndexBufferER21DynamicVBOChunkHandle(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 if ((HEAP16[gb + 1161260 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161260 | 0, i1);
  i6 = gb + 1161260 | 0;
 } else i6 = 0;
 i9 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0, i3 | 0, 0) | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i7 = i9 + 12 | 0;
 i4 = HEAP32[(i2 << 24 >> 24 == 0 ? i9 + 8 | 0 : i7) >> 2] | 0;
 if (i4 | 0) {
  i1 = i4 >>> 2;
  i8 = i1 * 6 | 0;
  i1 = i1 * 12 | 0;
  if (!i1) i1 = HEAP32[i3 + 4 >> 2] | 0; else {
   i1 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, i1 | 0, i3 | 0) | 0;
   HEAP32[i3 + 4 >> 2] = i1;
   i2 = HEAP8[i9 >> 0] | 0;
  }
  do if (!(i2 << 24 >> 24)) {
   i2 = i4 & -4;
   if (i2 | 0) i10 = 9;
  } else {
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   i2 = i4 & -4;
   i3 = (i2 | 0) != 0;
   if (!i5) if (i3) {
    i10 = 9;
    break;
   } else break;
   if (i3) {
    i4 = 0;
    i3 = i5;
    while (1) {
     HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
     HEAP16[i1 + 2 >> 1] = HEAP16[i3 + 2 >> 1] | 0;
     i5 = i3 + 4 | 0;
     HEAP16[i1 + 4 >> 1] = HEAP16[i5 >> 1] | 0;
     HEAP16[i1 + 6 >> 1] = HEAP16[i3 >> 1] | 0;
     HEAP16[i1 + 8 >> 1] = HEAP16[i5 >> 1] | 0;
     HEAP16[i1 + 10 >> 1] = HEAP16[i3 + 6 >> 1] | 0;
     i4 = i4 + 4 | 0;
     if (i4 >>> 0 >= i2 >>> 0) break; else {
      i3 = i3 + 8 | 0;
      i1 = i1 + 12 | 0;
     }
    }
   }
  } while (0);
  if ((i10 | 0) == 9) {
   i3 = 0;
   while (1) {
    i5 = i3 & 65535;
    HEAP16[i1 >> 1] = i5;
    HEAP16[i1 + 2 >> 1] = i3 | 1;
    i10 = (i3 | 2) & 65535;
    HEAP16[i1 + 4 >> 1] = i10;
    HEAP16[i1 + 6 >> 1] = i5;
    HEAP16[i1 + 8 >> 1] = i10;
    HEAP16[i1 + 10 >> 1] = i3 | 3;
    i3 = i3 + 4 | 0;
    if (i3 >>> 0 >= i2 >>> 0) break; else i1 = i1 + 12 | 0;
   }
  }
  HEAP32[i9 + 16 >> 2] = 0;
  HEAP32[i7 >> 2] = i8;
  HEAP8[i9 >> 0] = 1;
 }
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return;
}

function __ZN6Shader7SetNameEPKc(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 i9 = i8 + 44 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i1;
 i3 = _strlen(i2) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  i4 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i3;
  if (!i3) i1 = i11; else {
   i1 = i11;
   i4 = 6;
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i7 = i3 + 16 & -16;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i7 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i3;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i5 = i11 + 11 | 0;
 do if ((i9 | 0) != (i11 | 0)) {
  i7 = HEAP8[i5 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
  i7 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 52 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 48 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 48 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i9, i1, i2, i11, i4) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 32 | 0;
 i5 = i14 + 16 | 0;
 i3 = i14;
 i8 = i14 + 48 | 0;
 i10 = i14 + 44 | 0;
 i13 = i9 + 8 | 0;
 if ((HEAP32[i13 >> 2] | 0) >>> 0 >= i1 >>> 0) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (i2) {
  i2 = i1 + -1 | 0;
  if (!((i1 | 0) != 0 & (i2 & i1 | 0) == 0)) {
   i1 = i2 >>> 16 | i2;
   i1 = i1 >>> 8 | i1;
   i1 = i1 >>> 4 | i1;
   i1 = i1 >>> 2 | i1;
   i1 = (i1 >>> 1 | i1) + 1 | 0;
  }
 }
 i7 = Math_imul(i1, i11) | 0;
 do if (!i4) {
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 & 7 | 0) {
   HEAP32[i3 >> 2] = gb + 401209;
   HEAP32[i3 + 4 >> 2] = 2513;
   HEAP32[i3 + 8 >> 2] = gb + 401301;
   _sprintf(i8, gb + 401176 | 0, i3) | 0;
   _puts(i8) | 0;
   i1 = 0;
   break;
  }
  if (i7 >>> 0 > 2147418112) {
   HEAP32[i5 >> 2] = gb + 401209;
   HEAP32[i5 + 4 >> 2] = 2513;
   HEAP32[i5 + 8 >> 2] = gb + 401323;
   _sprintf(i8, gb + 401176 | 0, i5) | 0;
   _puts(i8) | 0;
   i1 = 0;
   break;
  }
  HEAP32[i8 >> 2] = i7;
  i3 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, i7 | 0, i8 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  if (!i3) i1 = 0; else {
   HEAP32[i9 >> 2] = i3;
   i12 = 18;
  }
 } else {
  i3 = __ZN4crnd11crnd_mallocEjPj(i7, i10) | 0;
  if (!i3) i1 = 0; else {
   mftCall_viii(i4 | 0, i3 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   do if (i2 | 0) if (!(i2 & 7)) {
    mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
    break;
   } else {
    HEAP32[i6 >> 2] = gb + 401209;
    HEAP32[i6 + 4 >> 2] = 2513;
    HEAP32[i6 + 8 >> 2] = gb + 401349;
    _sprintf(i8, gb + 401176 | 0, i6) | 0;
    _puts(i8) | 0;
    break;
   } while (0);
   HEAP32[i9 >> 2] = i3;
   i2 = HEAP32[i10 >> 2] | 0;
   i12 = 18;
  }
 } while (0);
 if ((i12 | 0) == 18) {
  if (i2 >>> 0 > i7 >>> 0) i1 = (i2 >>> 0) / (i11 >>> 0) | 0;
  HEAP32[i13 >> 2] = i1;
  i1 = 1;
 }
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i7 + 120 | 0;
 i4 = (HEAP32[i7 + 176 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) | 0;
 i5 = i4 * 12 | 0;
 i1 = 0;
 while (1) {
  if (!i1) {
   i1 = 1;
   continue;
  }
  i6 = i9 + (i1 * 20 | 0) | 0;
  i2 = i9 + (i1 * 20 | 0) + 16 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i5, 4, i9 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i9 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i9 + (i1 * 20 | 0) + 12 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i6 >> 2] = i8;
   break;
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 14) break;
 }
 i1 = HEAP32[i7 + 168 >> 2] | 0;
 i6 = HEAP32[i7 + 172 >> 2] | 0;
 i8 = i1 + (i6 * 20 | 0) | 0;
 L11 : do if (i6) {
  i3 = HEAP32[i7 + 148 >> 2] | 0;
  i4 = i7 + 124 | 0;
  i5 = i7 + 128 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    if (!(HEAP8[i4 >> 0] | 0)) break L11;
    if (!(HEAP32[i10 >> 2] | 0)) break L11;
    if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) break L11;
   }
   i1 = i1 + 20 | 0;
  } while ((i1 | 0) != (i8 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i8 | 0)) return;
 i5 = i7 + 148 | 0;
 i6 = i7 + 124 | 0;
 i4 = i7 + 128 | 0;
 i2 = i1;
 L25 : while (1) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if (i1 | 0) __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode(i9, i1, 0, 0, 0);
  i2 = i2 + 20 | 0;
  if ((i2 | 0) == (i8 | 0)) {
   i1 = 17;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break;
    if (!(HEAP32[i10 >> 2] | 0)) break;
    if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) break;
   }
   i2 = i2 + 20 | 0;
   if ((i2 | 0) == (i8 | 0)) {
    i1 = 17;
    break L25;
   }
  }
  if ((i2 | 0) == (i8 | 0)) {
   i1 = 17;
   break;
  }
 }
 if ((i1 | 0) == 17) return;
}

function __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i3 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i8 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) i1 = i6; else {
   i1 = i6;
   i8 = 6;
  }
 } else i8 = 4;
 if ((i8 | 0) == 4) {
  i4 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
  i8 = 6;
 }
 if ((i8 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i4 = i5 + 16 | 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i2 ? HEAP32[i5 + 20 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i8 = 10;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i8 = i1;
   i8 = i8 + i3 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i9;
   return;
  }
 } else i8 = 10;
 if ((i8 | 0) == 10) {
  i5 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i6 + 24 >> 2] = i5 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i3;
  i1 = i8;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 i8 = i1;
 i8 = i8 + i3 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i9;
 return;
}

function __ZNK16b2PrismaticJoint13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i17 = HEAP32[i1 + 48 >> 2] | 0;
 i16 = HEAP32[i1 + 52 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i17 + 28 >> 2]));
 f14 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i17 + 32 >> 2]));
 f9 = Math_fround(HEAPF32[i17 + 24 >> 2]);
 f3 = Math_fround(f12 * f9);
 f11 = Math_fround(HEAPF32[i17 + 20 >> 2]);
 f3 = Math_fround(f3 - Math_fround(f14 * f11));
 f12 = Math_fround(Math_fround(f9 * f14) + Math_fround(f12 * f11));
 f14 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i16 + 28 >> 2]));
 f15 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f15 = Math_fround(f15 - Math_fround(HEAPF32[i16 + 32 >> 2]));
 f4 = Math_fround(HEAPF32[i16 + 24 >> 2]);
 f6 = Math_fround(f14 * f4);
 f10 = Math_fround(HEAPF32[i16 + 20 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f15 * f10));
 f10 = Math_fround(Math_fround(f4 * f15) + Math_fround(f14 * f10));
 f14 = Math_fround(f3 + Math_fround(HEAPF32[i17 + 44 >> 2]));
 f15 = Math_fround(f12 + Math_fround(HEAPF32[i17 + 48 >> 2]));
 f4 = Math_fround(f6 + Math_fround(HEAPF32[i16 + 44 >> 2]));
 f14 = Math_fround(f4 - f14);
 f15 = Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i16 + 48 >> 2])) - f15);
 f4 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f13 = Math_fround(f9 * f4);
 f8 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f11 * f8));
 f8 = Math_fround(Math_fround(f11 * f4) + Math_fround(f9 * f8));
 f9 = Math_fround(HEAPF32[i17 + 64 >> 2]);
 f4 = Math_fround(HEAPF32[i17 + 68 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 64 >> 2]);
 f7 = Math_fround(HEAPF32[i16 + 68 >> 2]);
 f2 = Math_fround(HEAPF32[i17 + 72 >> 2]);
 f5 = Math_fround(HEAPF32[i16 + 72 >> 2]);
 return Math_fround(Math_fround(Math_fround(f15 * Math_fround(f13 * f2)) - Math_fround(f14 * Math_fround(f8 * f2))) + Math_fround(Math_fround(f13 * Math_fround(Math_fround(f12 * f2) + Math_fround(Math_fround(f11 - Math_fround(f10 * f5)) - f9))) + Math_fround(f8 * Math_fround(Math_fround(Math_fround(f7 + Math_fround(f6 * f5)) - f4) - Math_fround(f3 * f2)))));
}

function __ZN5physx9NpFactory17createClothFabricERKNS_17PxClothFabricDescE(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 if (!(HEAP32[gb + 1457384 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 427, gb + 690476 | 0, i10);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 4552 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 4548 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 4256 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i7 = i2 + 4536 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = i2 + 4540 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 do if (!i1) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i1 = 0;
 } else {
  __ZN5physx13NpClothFabricC2Ev(i1);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  if (!(__ZN5physx13NpClothFabric4loadERKNS_17PxClothFabricDescE(i1, i5) | 0)) {
   i2 = i1 + 8 | 0;
   if (__ZN5physx6shdfnd15atomicDecrementEPVi(i1 + 12 | 0) | 0) {
    i1 = 0;
    break;
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
   i1 = 0;
   break;
  }
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i5 = i8 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
  i6 = i8 + 3944 | 0;
  i7 = i8 + 3948 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i8 + 3952 | 0;
  if (!i2) if ((HEAP32[i3 >> 2] & 2147483584) >>> 0 < 64) {
   __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, 64);
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] = i4;
   HEAP32[i7 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i9) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 } while (0);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx12SubSortQuickC2EPjPKNS_10PxBounds3VEjf(i15, i2, i1, i13, f14) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16;
 i12 = i15 + 8 | 0;
 HEAP32[i12 >> 2] = i1;
 i8 = i15 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i15 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i15 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i15 >> 2] = i2 + (i13 << 2);
 HEAP32[i15 + 4 >> 2] = i2;
 if (!i13) {
  i12 = f14 < Math_fround(0.0);
  f14 = Math_fround(f14 * Math_fround(9.0));
  i13 = ~~f14 >>> 0;
  i13 = i12 ? 0 : i13;
  i12 = i13 >>> 0 < 8;
  i13 = i12 ? i13 : 8;
  i13 = gb + 110296 + (i13 << 2) | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i15 = i15 + 24 | 0;
  HEAP32[i15 >> 2] = i13;
  STACKTOP = i16;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i8, i13);
 i2 = i11 + 4 | 0;
 i6 = i11 + 8 | 0;
 i7 = 0;
 do {
  i1 = HEAP32[i12 >> 2] | 0;
  f3 = Math_fround(HEAPF32[i1 + (i7 << 5) >> 2]);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i1 + (i7 << 5) + 16 >> 2]));
  f4 = Math_fround(HEAPF32[i1 + (i7 << 5) + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i1 + (i7 << 5) + 20 >> 2]));
  f5 = Math_fround(HEAPF32[i1 + (i7 << 5) + 8 >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 + (i7 << 5) + 24 >> 2]));
  HEAPF32[i11 >> 2] = f3;
  HEAPF32[i2 >> 2] = f4;
  HEAPF32[i6 >> 2] = f5;
  i1 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i17 = HEAP32[i8 >> 2] | 0;
   HEAPF32[i17 + (i1 * 12 | 0) >> 2] = f3;
   HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2] = f4;
   HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2] = f5;
   HEAP32[i9 >> 2] = i1 + 1;
  } else __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i8, i11) | 0;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i13 | 0));
 i17 = f14 < Math_fround(0.0);
 f14 = Math_fround(f14 * Math_fround(9.0));
 i13 = ~~f14 >>> 0;
 i13 = i17 ? 0 : i13;
 i17 = i13 >>> 0 < 8;
 i13 = i17 ? i13 : 8;
 i13 = gb + 110296 + (i13 << 2) | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i17 = i15 + 24 | 0;
 HEAP32[i17 >> 2] = i13;
 STACKTOP = i16;
 return;
}

function __ZN5physx11NpConnector17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i6 >> 2] = HEAP32[gb + 122340 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 122340 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 122340 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 122340 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 122340 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 122340 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 122340 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 122340 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 122372 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122372 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122372 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122372 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122372 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122372 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122372 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122372 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122404 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122404 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122404 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122404 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122404 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122404 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122404 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122404 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122436 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122436 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122436 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122436 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122436 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122436 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122436 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122436 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN10SampleClip15AllocateChannelEby(i1, i2, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 16 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = i1 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) i5 = 5; else if (!(HEAP32[i4 + 16 >> 2] | 0)) i5 = 5;
 if ((i5 | 0) == 5) __ZN10SampleClip13LoadBaseSoundEv(i1);
 i2 = __ZN11SoundHandle13CreateChannelEb(i3, i2) | 0;
 i3 = (i2 | 0) == 0;
 if (!i3) {
  i1 = i2 + 16 | 0;
  if (((i6 | 0) != 0 | (i7 | 0) != 0) & (HEAP32[i1 >> 2] | 0) != 0) {
   i1 = __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(HEAP32[i1 >> 2] | 0, 1, i7, i6) | 0;
   if (i1 | 0) {
    i7 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
    HEAP32[i9 >> 2] = gb + 854464;
    HEAP32[i9 + 4 >> 2] = 135;
    HEAP32[i9 + 8 >> 2] = gb + 865148;
    HEAP32[i9 + 12 >> 2] = i7;
    __Z6FormatPKcz(i8, gb + 883334 | 0, i9);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   }
  }
 }
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i1 = i2;
 if (i3) {
  HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
  HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
  i9 = i1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (HEAP32[i9 >> 2] | 0) {
  i9 = i1;
  STACKTOP = i10;
  return i9 | 0;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i6, i2, i10) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i2;
 i5 = (i10 - i3 | 0) / 12 | 0;
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = i8;
 if (i5 >>> 0 <= ((i1 - i8 | 0) / 12 | 0) >>> 0) {
  i6 = i6 + 4 | 0;
  i1 = ((HEAP32[i6 >> 2] | 0) - i8 | 0) / 12 | 0;
  i5 = i5 >>> 0 > i1 >>> 0;
  i1 = i2 + (i1 * 12 | 0) | 0;
  i4 = i5 ? i1 : i10;
  i3 = i4 - i3 | 0;
  if (i3 | 0) _memmove(i8 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i7 + (((i3 | 0) / 12 | 0) * 12 | 0) | 0;
  if (!i5) {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
   return;
  }
  if ((i4 | 0) == (i10 | 0)) return;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = i1 + 12 | 0;
   i2 = i2 + 12 | 0;
  } while ((i1 | 0) != (i10 | 0));
  HEAP32[i6 >> 2] = i2;
  return;
 }
 i4 = i8;
 if (i8) {
  i1 = i6 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i3 + (~(((i3 + -12 - i8 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i4);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = 0;
 }
 if (i5 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i3 = 0;
 i8 = (i1 - i3 | 0) / 12 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 178956970 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 357913941;
 if (i3 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
 i1 = __Znwj(i3 * 12 | 0) | 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + (i3 * 12 | 0);
 if ((i2 | 0) == (i10 | 0)) return;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i2 = i2 + 12 | 0;
  i1 = i1 + 12 | 0;
 } while ((i2 | 0) != (i10 | 0));
 HEAP32[i4 >> 2] = i1;
 return;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 149176 + 8;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = gb + 149176 + 52;
 i3 = i4 + 8 | 0;
 __ZN5physx6shdfnd10ThreadImpl10signalQuitEv(HEAP32[i3 >> 2] | 0);
 __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv(HEAP32[i3 >> 2] | 0) | 0;
 i1 = i4 + 100 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
 i5 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = gb + 148172 + 8;
 i1 = i4 + 116 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i5 = HEAP32[i4 + 108 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i1 >> 2] | 0);
 i1 = i4 + 96 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 i1 = i4 + 92 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 HEAP32[i4 + 76 >> 2] = gb + 148172 + 8;
 i5 = i4 + 88 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i1 = HEAP32[i4 + 80 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i4 + 44 >> 2] = gb + 148752 + 8;
 i5 = HEAP32[i4 + 64 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i5 = HEAP32[i4 + 48 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i4 + 56 >> 2] | 0);
 }
 HEAP32[i4 + 20 >> 2] = gb + 148752 + 8;
 i5 = HEAP32[i4 + 40 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i5 = HEAP32[i4 + 24 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i4 + 32 >> 2] | 0);
 }
 HEAP32[i2 >> 2] = gb + 86828 + 8;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 return;
}

function __Z24EncodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 12 | 0;
 i8 = HEAP8[i6 + 11 >> 0] | 0;
 i3 = i8 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i6 + 4 >> 2] | 0 : i8 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i3 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i1 = _strpbrk(i3, gb + 585719 | 0) | 0;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, (i8 >>> 4) + i8 | 0);
  i4 = i3;
  i2 = i3;
  do {
   i10 = i2;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i7, i6, i10 - i4 | 0, i1 - i10 | 0) | 0;
   i2 = i1 + 1 | 0;
   switch (HEAP8[i1 >> 0] | 0) {
   case 10:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 585723 | 0) | 0;
     break;
    }
   case 13:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 585726 | 0) | 0;
     break;
    }
   case 92:
    {
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, gb + 585729 | 0) | 0;
     break;
    }
   default:
    {}
   }
   i1 = _strpbrk(i2, gb + 585719 | 0) | 0;
  } while ((i1 | 0) != 0);
  if ((i2 | 0) != (i3 | 0)) {
   i1 = i2 - i3 | 0;
   if (i8 >>> 0 > i1 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i7, i6, i1, i8 - i1 | 0) | 0;
  }
 }
 i10 = HEAP8[i7 + 11 >> 0] | 0;
 if (!((i10 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i10 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i9;
  return;
 };
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(i12, i10, i13) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = (i10 | 0) != 0;
 if (i7 & (i13 | 0) != 0) {
  i8 = i12 + 16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i6 = i12 + 12 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1;
  i9 = i2 - i3 | 0;
  i4 = i9 + i13 | 0;
  if (i4) {
   i5 = i12 + 20 | 0;
   if (((HEAP32[i5 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
    i1 = i4 << 1;
    if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
    i2 = i12 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i12 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (i3 | 0) {
     _memcpy(i1 | 0, i3 | 0, i9 | 0) | 0;
     i11 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i6 >> 2] | 0);
    }
    HEAP32[i6 >> 2] = i1;
    i2 = i1 + i9 | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i1 + i4;
   }
  }
  HEAP32[i8 >> 2] = i2 + i13;
  _memcpy(i1 + i9 | 0, i10 | 0, i13 | 0) | 0;
 }
 if (i7 | (i13 | 0) == 0) return;
 i8 = i12 + 16 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 20 | 0;
 i11 = i12 + 4 | 0;
 i5 = i12 + 8 | 0;
 i7 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = i1;
  i6 = i2 - i3 | 0;
  i4 = i6 + 1 | 0;
  if (i4) if (((HEAP32[i10 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i3 | 0, i2 | 0, i6 | 0) | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i9 >> 2] | 0);
   }
   HEAP32[i9 >> 2] = i3;
   i2 = i3 + i6 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i10 >> 2] = i3 + i1;
   i1 = i3;
  }
  HEAP32[i8 >> 2] = i2 + 1;
  HEAP8[i1 + i6 >> 0] = 0;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i13 | 0));
 return;
}

function __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j(i12, i10, i13) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = (i10 | 0) != 0;
 if (i7 & (i13 | 0) != 0) {
  i8 = i12 + 16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i6 = i12 + 12 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1;
  i9 = i2 - i3 | 0;
  i4 = i9 + i13 | 0;
  if (i4) {
   i5 = i12 + 20 | 0;
   if (((HEAP32[i5 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
    i1 = i4 << 1;
    if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
    i2 = i12 + 4 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i12 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (i3 | 0) {
     _memcpy(i1 | 0, i3 | 0, i9 | 0) | 0;
     i11 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i6 >> 2] | 0);
    }
    HEAP32[i6 >> 2] = i1;
    i2 = i1 + i9 | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i1 + i4;
   }
  }
  HEAP32[i8 >> 2] = i2 + i13;
  _memcpy(i1 + i9 | 0, i10 | 0, i13 | 0) | 0;
 }
 if (i7 | (i13 | 0) == 0) return;
 i8 = i12 + 16 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 20 | 0;
 i11 = i12 + 4 | 0;
 i5 = i12 + 8 | 0;
 i7 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = i1;
  i6 = i2 - i3 | 0;
  i4 = i6 + 1 | 0;
  if (i4) if (((HEAP32[i10 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i3 | 0, i2 | 0, i6 | 0) | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i9 >> 2] | 0);
   }
   HEAP32[i9 >> 2] = i3;
   i2 = i3 + i6 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i10 >> 2] = i3 + i1;
   i1 = i3;
  }
  HEAP32[i8 >> 2] = i2 + 1;
  HEAP8[i1 + i6 >> 0] = 0;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i13 | 0));
 return;
}

function __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i4, i2, i6, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i5 = 5; else {
     i7 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i7 + 1;
     HEAP32[i2 >> 2] = i3 + -1;
    }
   } else i5 = 5;
   if ((i5 | 0) == 5) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
   }
   HEAP32[i6 >> 2] = i1 & 255;
   return;
  }
 case 1:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 2) i5 = 10; else {
     i8 = HEAP32[i4 >> 2] | 0;
     i7 = HEAP8[i8 >> 0] | 0;
     i1 = i8 + 1 | 0;
     HEAP32[i4 >> 2] = i1;
     HEAP32[i2 >> 2] = i3 + -1;
     i1 = HEAP8[i1 >> 0] | 0;
     HEAP32[i4 >> 2] = i8 + 2;
     HEAP32[i2 >> 2] = i3 + -2;
     i1 = i1 & 255;
     i2 = (i7 & 255) << 8;
    }
   } else i5 = 10;
   if ((i5 | 0) == 10) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   HEAP32[i6 >> 2] = i1 | i2;
   return;
  }
 default:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 4) {
     HEAP8[i6 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
     i3 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     i5 = i6 + 1 | 0;
     HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
     i3 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     i8 = i6 + 2 | 0;
     HEAP8[i8 >> 0] = HEAP8[i3 >> 0] | 0;
     i3 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i3;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     i7 = i6 + 3 | 0;
     HEAP8[i7 >> 0] = HEAP8[i3 >> 0] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     i4 = HEAP8[i6 >> 0] | 0;
     HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
     HEAP8[i7 >> 0] = i4;
     i7 = HEAP8[i5 >> 0] | 0;
     HEAP8[i5 >> 0] = HEAP8[i8 >> 0] | 0;
     HEAP8[i8 >> 0] = i7;
     return;
    }
   }
   HEAP8[i1 >> 0] = 1;
   return;
  }
 }
}

function __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i9 = i11;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i2 = HEAP32[i1 + 32 >> 2] | 0;
  i3 = i7 + (i2 << 3) | 0;
  i8 = i1;
  i1 = i7;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i6, i1, i4);
  i3 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i1 + 28 >> 2] | 0;
  i2 = HEAP32[gb + 1157724 >> 2] | 0;
  i3 = (i3 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i3 << 3) | 0;
  i8 = i2;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  i2 = HEAP32[i2 + 32 >> 2] | 0;
 }
 i7 = i8 + 28 | 0;
 if ((i3 | 0) != (i1 + (i2 << 3) | 0)) {
  HEAP32[i3 + 4 >> 2] = i5;
  STACKTOP = i11;
  return;
 }
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i8, 1, 0);
 __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i6, i8, i9);
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  if (!(HEAP8[i8 + 8 >> 0] | 0)) i10 = 11; else {
   i2 = i8 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) i10 = 11; else {
    i1 = HEAP32[i7 >> 2] | 0;
    if ((HEAP32[i8 + 12 >> 2] | 0) == (HEAP32[i1 + (i4 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i10 = 11;
   }
  }
  if ((i10 | 0) == 11) {
   i1 = i8 + 36 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i8 = i9;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i1 + (i4 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i6) i5 = 0; else {
  i1 = i6 * 28 | 0;
  if (!i1) i5 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 722497 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = i7 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + (i2 * 28 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i9 = i2 + 4 | 0;
   i11 = i9;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i9 = i9 + 4 | 0;
   i9 = HEAPU16[i9 >> 1] | HEAPU16[i9 + 2 >> 1] << 16;
   i10 = i1 + 4 | 0;
   i8 = i10;
   HEAP16[i8 >> 1] = i11;
   HEAP16[i8 + 2 >> 1] = i11 >>> 16;
   i10 = i10 + 4 | 0;
   HEAP16[i10 >> 1] = i9;
   HEAP16[i10 + 2 >> 1] = i9 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i10 = i1 + 12 | 0;
   i9 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 >> 2] = gb + 106576 + 8;
   i10 = i2 + 20 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1 + 20 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i11 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1 + (i11 * 28 | 0) | 0;
  if ((i11 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = i7 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i2 | 0);
 HEAP32[i7 >> 2] = i5;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx3Scb14ParticleSystem16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i6, i9, i5) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i1 = i10;
 i7 = HEAP32[i6 + 152 >> 2] | 0;
 i8 = (i7 | 0) == 0;
 if (!i8) {
  i2 = i7 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i7 + 73 | 0; else {
   i12 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i11 = i7 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 699672;
   HEAP32[i1 + 4 >> 2] = i11;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i12, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i11;
  }
  _strncpy(i1, gb + 699672 | 0, 128) | 0;
  HEAP8[i7 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 do if (i9 | 0) {
  switch ((HEAP32[i6 + 4 >> 2] | 0) >>> 30 | 0) {
  case 3:
   {
    i4 = 9;
    break;
   }
  case 2:
   {
    if (HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0) i4 = 9;
    break;
   }
  default:
   {}
  }
  if ((i4 | 0) == 9) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 100, gb + 699279 | 0, i3);
   break;
  }
  __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i6 + 12 | 0, i9, i5);
  if (HEAP8[i6 + 164 >> 0] | 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i5 + 4 | 0;
   i3 = HEAP32[HEAP32[i6 + 156 >> 2] >> 2] | 0;
   i4 = 0;
   do {
    i11 = HEAP32[i1 + (Math_imul(HEAP32[i2 >> 2] | 0, i4) | 0) >> 2] | 0;
    i12 = i3 + (i11 >>> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~(1 << (i11 & 31));
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i9 | 0));
  }
  if (HEAP8[i6 + 176 >> 0] | 0) {
   i4 = HEAP32[i5 >> 2] | 0;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[HEAP32[i6 + 168 >> 2] >> 2] | 0;
   i2 = 0;
   do {
    i11 = HEAP32[i4 + (Math_imul(HEAP32[i3 >> 2] | 0, i2) | 0) >> 2] | 0;
    i12 = i1 + (i11 >>> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~(1 << (i11 & 31));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i9 | 0));
  }
 } while (0);
 if (i8) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 695;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 694;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i12, i7, i9, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i10 = i13 + 24 | 0;
 i11 = i13 + 8 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i12 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 HEAP32[i10 >> 2] = 693;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i9;
 __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i12, i10, i11, i8);
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i13;
 return;
}

function __ZN5physx3Cct10ControllerC2ERKNS_16PxControllerDescEPNS_7PxSceneE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i3 >> 2] = gb + 83836 + 8;
 i8 = i3 + 8 | 0;
 __ZN5physx3Cct9CCTParamsC2Ev(i8);
 __ZN5physx3Cct9SweepTestC2Ev(i3 + 88 | 0);
 i7 = i3 + 408 | 0;
 i6 = i3 + 432 | 0;
 HEAP32[i3 + 456 >> 2] = i2;
 HEAP32[i3 + 460 >> 2] = -1;
 i9 = i3 + 464 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP16[i9 + 20 >> 1] = 0;
 HEAP32[i3 + 4 >> 2] = 2147483647;
 HEAP32[i8 >> 2] = HEAP32[i1 + 88 >> 2];
 i8 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i3 + 40 >> 2] = i8;
 HEAP32[i3 + 44 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i3 + 52 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i3 + 56 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP8[i3 + 65 >> 0] = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])) != Math_fround(0.0) & 1;
 HEAP32[i3 + 72 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i3 + 76 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i3 + 80 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i3 + 400 >> 2] = 0;
 i8 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i3 + 476 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i3 + 480 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i3 + 376 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP8[i3 + 486 >> 0] = HEAP8[i1 + 92 >> 0] | 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E(i3, i1 + 32 | 0);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 mftCall_viiii(i1 | 0, i2 | 0, i3 | 0, i5 | 0, 0);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra10TomeLoader4loadERNS_11InputStreamEPNS_9AllocatorE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 if ((mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0, 12) | 0) != 12) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 do if ((i2 & -65536 | 0) == -704643072) i6 = i1; else if ((i2 & 65535 | 0) == 214) {
  i6 = _llvm_bswap_i32(i1 | 0) | 0;
  break;
 } else {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 } while (0);
 i1 = i6 + 20 | 0;
 if (!i3) i1 = _malloc(i1) | 0; else i1 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, 0) | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = i1 + 20 & -16;
 i7 = i2;
 i3 = i2;
 HEAP32[i3 + -4 >> 2] = i2 - i1;
 if (!i2) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 i5 = i6 + -12 | 0;
 if ((mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i7 + 12 | 0, i5 | 0) | 0) != (i5 | 0)) {
  _free(i7 + (0 - (HEAP32[i7 + -4 >> 2] | 0)) | 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 & -65536 | 0) != -704643072 & (i2 & 65535 | 0) == 214) {
  i1 = i6 >>> 2;
  if (i1) {
   i1 = i1 + -1 | 0;
   i2 = _llvm_bswap_i32(i2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   if (i1) {
    i2 = i3;
    do {
     i2 = i2 + 4 | 0;
     i1 = i1 + -1 | 0;
     HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
    } while ((i1 | 0) != 0);
    i2 = HEAP32[i3 >> 2] | 0;
   }
  }
 }
 if ((i2 | 0) == -1163018018 | (i2 & 65534) >>> 0 < 2) i8 = 19; else if ((HEAP32[i7 + 8 >> 2] | 0) >>> 0 > i6 >>> 0) i1 = 0; else i8 = 19;
 if ((i8 | 0) == 19) {
  i1 = i2 & 65535;
  if ((i2 & -65536 | 0) == -704643072) i1 = (i1 | 0) == 18 ? 0 : i1 >>> 0 > 18 ? 4 : 3; else i1 = (i1 | 0) == 214 ? 5 : 2;
  i1 = (i1 | 0) == 3 ? 0 : i7;
  i1 = i1 | 0 ? i1 : i7;
 }
 if ((i1 | 0) == (i7 | 0)) {
  i8 = i7;
  STACKTOP = i9;
  return i8 | 0;
 }
 _free(i7 + (0 - (HEAP32[i7 + -4 >> 2] | 0)) | 0);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i9, i5, i10, i6) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i11 = i9 + 44 | 0;
 i12 = i9 + 24 | 0;
 i13 = i9 + 36 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 while (1) {
  if (i1 >>> 0 >= i14 >>> 0) break;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = i1 + 1 | 0;
  if ((HEAP32[i2 + (i1 * 28 | 0) >> 2] | 0) == (i10 | 0)) {
   i4 = 4;
   break;
  } else i1 = i3;
 }
 if ((i4 | 0) == 4) {
  HEAP32[i11 >> 2] = i3;
  i1 = HEAP32[i2 + (i1 * 28 | 0) + 4 >> 2] | 0;
  if (i1 | 0) {
   i14 = i1;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 i2 = HEAP32[i5 + 276 >> 2] | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7 + 1;
 i2 = i6 & 1;
 i3 = i14 + 1 | 0;
 i4 = i9 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 * 28 | 0, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 28 | 0, 4, i9 + 28 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 28 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i12 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = i3;
 i12 = HEAP32[i12 >> 2] | 0;
 i9 = i12 + (i14 * 28 | 0) | 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i12 + (i14 * 28 | 0) + 4 >> 2] = i7;
 HEAP8[i12 + (i14 * 28 | 0) + 8 >> 0] = i2;
 i10 = i9 + 9 | 0;
 HEAP8[i10 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[i8 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[i8 + 2 >> 0] | 0;
 HEAPF32[i12 + (i14 * 28 | 0) + 12 >> 2] = Math_fround(-1.0);
 HEAPF32[i12 + (i14 * 28 | 0) + 16 >> 2] = Math_fround(-1.0);
 HEAPF32[i12 + (i14 * 28 | 0) + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i12 + (i14 * 28 | 0) + 24 >> 2] = Math_fround(-1.0);
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 i14 = i7;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN14BillboardAssetC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 i9 = i4 + 8 | 0;
 i10 = i2;
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i3);
 HEAP32[i1 >> 2] = gb + 56216 + 8;
 i3 = __ZnwjRK10MemLabelIdiPKci(88, i2, 16, gb + 422702 | 0, 12) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 56576 + 8;
 i9 = i2;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i3 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i9 = i6;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i3 + 32 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i9 = i6;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i3 + 52 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = i3;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__23mapINS_4pairIPcS2_EENS_3setIS2_15compare_tstringIPKcENS_9allocatorIS2_EEEE20smaller_tstring_pairIS7_ENS9_INS1_IKS3_SB_EEEEEixERSE_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i2 = i10 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = 16;
 } else {
  i7 = i9 + 4 | 0;
  while (1) {
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = i1 + 16 | 0;
   i5 = i1 + 20 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = __Z6StrCmpPKcS0_(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (!i2) i2 = __Z6StrCmpPKcS0_(i4, i3) | 0;
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = 7;
     break;
    } else i1 = i2;
   } else {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    i2 = __Z6StrCmpPKcS0_(HEAP32[i6 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
    if (!i2) i2 = __Z6StrCmpPKcS0_(i3, i4) | 0;
    if ((i2 | 0) >= 0) {
     i3 = 14;
     break;
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = 13;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 7) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i3 | 0) == 13) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i3 | 0) == 14) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i8;
   i3 = 16;
   break;
  }
 } while (0);
 if ((i3 | 0) == 16) if (i1) {
  i10 = i1;
  i10 = i10 + 24 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = __Znwj(36) | 0;
 i8 = i9;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = i3 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 + 4 >> 2] | 0, i1);
 i10 = i10 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i3;
 i10 = i10 + 24 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNK5physx2Gu11HeightField19getTriangleVerticesEjjjRNS_6PxVec3ES3_S3_(i1, i8, i7, i6, i9, i10, i11) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i12 = i8 >>> 1;
 i13 = HEAP32[i1 + 36 >> 2] | 0;
 f4 = Math_fround(HEAP16[i13 + (i12 << 2) >> 1] | 0);
 f5 = Math_fround(HEAP16[i13 + (i12 + 1 << 2) >> 1] | 0);
 i1 = (HEAP32[i1 + 20 >> 2] | 0) + i12 | 0;
 f2 = Math_fround(HEAP16[i13 + (i1 << 2) >> 1] | 0);
 f3 = Math_fround(HEAP16[i13 + (i1 + 1 << 2) >> 1] | 0);
 i1 = (HEAP8[i13 + (i12 << 2) + 2 >> 0] | 0) < 0;
 if (!(i8 & 1)) if (i1) {
  f14 = Math_fround((i7 + 1 | 0) >>> 0);
  f5 = Math_fround(i6 >>> 0);
  HEAPF32[i9 >> 2] = f14;
  HEAPF32[i9 + 4 >> 2] = f2;
  HEAPF32[i9 + 8 >> 2] = f5;
  HEAPF32[i10 >> 2] = Math_fround(i7 >>> 0);
  HEAPF32[i10 + 4 >> 2] = f4;
  HEAPF32[i10 + 8 >> 2] = f5;
  f5 = Math_fround((i6 + 1 | 0) >>> 0);
  HEAPF32[i11 >> 2] = f14;
  HEAPF32[i11 + 4 >> 2] = f3;
  HEAPF32[i11 + 8 >> 2] = f5;
  return;
 } else {
  f3 = Math_fround(i7 >>> 0);
  f14 = Math_fround(i6 >>> 0);
  HEAPF32[i9 >> 2] = f3;
  HEAPF32[i9 + 4 >> 2] = f4;
  HEAPF32[i9 + 8 >> 2] = f14;
  f4 = Math_fround((i6 + 1 | 0) >>> 0);
  HEAPF32[i10 >> 2] = f3;
  HEAPF32[i10 + 4 >> 2] = f5;
  HEAPF32[i10 + 8 >> 2] = f4;
  HEAPF32[i11 >> 2] = Math_fround((i7 + 1 | 0) >>> 0);
  HEAPF32[i11 + 4 >> 2] = f2;
  HEAPF32[i11 + 8 >> 2] = f14;
  return;
 } else if (i1) {
  f2 = Math_fround(i7 >>> 0);
  f14 = Math_fround((i6 + 1 | 0) >>> 0);
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i9 + 4 >> 2] = f5;
  HEAPF32[i9 + 8 >> 2] = f14;
  HEAPF32[i10 >> 2] = Math_fround((i7 + 1 | 0) >>> 0);
  HEAPF32[i10 + 4 >> 2] = f3;
  HEAPF32[i10 + 8 >> 2] = f14;
  f14 = Math_fround(i6 >>> 0);
  HEAPF32[i11 >> 2] = f2;
  HEAPF32[i11 + 4 >> 2] = f4;
  HEAPF32[i11 + 8 >> 2] = f14;
  return;
 } else {
  f15 = Math_fround((i7 + 1 | 0) >>> 0);
  f14 = Math_fround((i6 + 1 | 0) >>> 0);
  HEAPF32[i9 >> 2] = f15;
  HEAPF32[i9 + 4 >> 2] = f3;
  HEAPF32[i9 + 8 >> 2] = f14;
  f4 = Math_fround(i6 >>> 0);
  HEAPF32[i10 >> 2] = f15;
  HEAPF32[i10 + 4 >> 2] = f2;
  HEAPF32[i10 + 8 >> 2] = f4;
  HEAPF32[i11 >> 2] = Math_fround(i7 >>> 0);
  HEAPF32[i11 + 4 >> 2] = f5;
  HEAPF32[i11 + 8 >> 2] = f14;
  return;
 }
}

function __ZN4math8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13MonoBehaviour5DoGUIENS_13GUILayoutTypeEii(i6, i7, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 24 | 0;
 i14 = i15 + 16 | 0;
 i4 = i15;
 i12 = i15 + 8 | 0;
 i13 = i15 + 32 | 0;
 if (!(HEAP32[i6 + 20 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i6 + 60 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i2 + 120 >> 2] | 0;
 i9 = HEAP32[i2 + 124 >> 2] | 0;
 if (!i8) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i1 = i6 + 141 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  i1 = HEAP32[i2 + 96 >> 2] | 0;
  if (i1) {
   i2 = HEAPU8[i2 + 100 >> 0] | 0;
   HEAP32[i14 >> 2] = i1;
   HEAP32[i14 + 4 >> 2] = i2;
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i6, i5, 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i1 = HEAP32[i2 + 88 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAPU8[i2 + 92 >> 0] | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i6, i5, 0) | 0;
  }
 }
 i3 = __Z9GetIIMGUIv() | 0;
 i4 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
 i2 = i6 + 132 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(48) | 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
  i18 = i5;
  i17 = HEAP32[i18 + 4 >> 2] | 0;
  i16 = i1 + 28 | 0;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  HEAP32[i16 + 4 >> 2] = i17;
  HEAP32[i1 + 44 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i12 >> 2] = i8;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i13 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 i18 = mftCall_iiiiiiii(i4 | 0, i3 | 0, i11 | 0, i1 | 0, i7 | 0, i10 | 0, i14 | 0, i5 | 0) | 0;
 STACKTOP = i15;
 return i18 | 0;
}

function __Z45CommandBuffer_CUSTOM_SetRenderTarget_MultipleP12Il2CppObjectP11Il2CppArrayR26MonoRenderTargetIdentifier(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 16 | 0;
 i8 = i11 + 4 | 0;
 i9 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 if ((i9 + -1 | 0) >>> 0 > 7) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 558334 | 0, 0, gb + 558381 | 0, 257, 1, 0, 0, 0);
  STACKTOP = i11;
  return;
 }
 HEAP32[i7 >> 2] = 16;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 16;
 HEAP32[i7 + 16 >> 2] = -1;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 16;
 HEAP32[i7 + 28 >> 2] = -1;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 16;
 HEAP32[i7 + 40 >> 2] = -1;
 HEAP32[i7 + 44 >> 2] = 0;
 HEAP32[i7 + 48 >> 2] = 16;
 HEAP32[i7 + 52 >> 2] = -1;
 HEAP32[i7 + 56 >> 2] = 0;
 HEAP32[i7 + 60 >> 2] = 16;
 HEAP32[i7 + 64 >> 2] = -1;
 HEAP32[i7 + 68 >> 2] = 0;
 HEAP32[i7 + 72 >> 2] = 16;
 HEAP32[i7 + 76 >> 2] = -1;
 HEAP32[i7 + 80 >> 2] = 0;
 HEAP32[i7 + 84 >> 2] = 16;
 HEAP32[i7 + 88 >> 2] = -1;
 HEAP32[i7 + 92 >> 2] = 0;
 HEAP32[i8 >> 2] = 16;
 i5 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = -1;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 if ((i9 | 0) > 0) {
  i1 = 0;
  do {
   i13 = HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0;
   i12 = HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0;
   HEAP32[i7 + (i1 * 12 | 0) >> 2] = HEAP32[i2 + (i1 * 12 | 0) >> 2];
   HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2] = i13;
   HEAP32[i7 + (i1 * 12 | 0) + 8 >> 2] = i12;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i13 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 >> 2] = i12;
 HEAP32[i6 >> 2] = i13;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i10);
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i10);
 __ZN22RenderingCommandBuffer18AddSetRenderTargetEiPK18RenderTextureParamRS1_i11CubemapFacei(i1, i9, i7, i8, 0, -1, 0);
 STACKTOP = i11;
 return;
}

function __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i15, i16, i17, i18) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (i16) i1 = 3; else if (__ZNK10GameObject8IsActiveEv(i15) | 0) i1 = 3;
 if ((i1 | 0) == 3) {
  i12 = i15 + 40 | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i13 = i15 + 28 | 0;
   i14 = i17 + 24 | 0;
   i8 = i17 + 28 | 0;
   i9 = i18 + 12 | 0;
   i10 = i18 + 16 | 0;
   i11 = i18 + 4 | 0;
   i7 = 0;
   do {
    i2 = HEAP32[i13 >> 2] | 0;
    if (((HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i7 << 3) >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[i14 >> 2] | 0) | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
     i2 = HEAP32[i2 + (i7 << 3) + 4 >> 2] | 0;
     i3 = HEAP32[i9 >> 2] | 0;
     i4 = i3 + 1 | 0;
     i5 = HEAP32[i10 >> 2] | 0;
     i6 = i5 & 2147483647;
     do if (i4 >>> 0 > i6 >>> 0) {
      i1 = i5 << 1;
      i1 = (i1 | 0) == 0 ? 1 : i1;
      if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
       HEAP32[i10 >> 2] = i1;
       HEAP32[i18 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i18 >> 2] | 0, i1 << 2, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
       break;
      } else {
       i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11, 0, gb + 1047584 | 0, 446) | 0;
       _memcpy(i6 | 0, HEAP32[i18 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
       HEAP32[i10 >> 2] = i1;
       HEAP32[i18 >> 2] = i6;
       break;
      }
     } while (0);
     HEAP32[i9 >> 2] = i4;
     HEAP32[(HEAP32[i18 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     i1 = HEAP32[i12 >> 2] | 0;
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) < (i1 | 0));
  }
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i15, gb + 28940 | 0) | 0;
 if (!i1) return;
 i3 = i1 + 80 | 0;
 i2 = i1 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 do {
  __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i16, i17, i18);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
 return;
}

function __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 HEAP32[i4 >> 2] = 0;
 i9 = i4 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj(i4, HEAP32[gb + 1170792 >> 2] | 0);
 if ((HEAP32[gb + 1170792 >> 2] | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i10 = i4 + 8 | 0;
 i11 = i5 + 11 | 0;
 i6 = i5 + 4 | 0;
 i7 = i8 + 11 | 0;
 i3 = 0;
 i1 = 0;
 while (1) {
  i2 = (HEAP32[gb + 1170796 >> 2] | 0) + (i3 << 2) | 0;
  if (i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((HEAP8[i1 >> 0] | 0) == 45) {
    i1 = 11;
    break;
   };
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, _strlen(i1) | 0);
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i4, i8); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i8);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 1;
  } else {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   i1 = HEAP8[i11 >> 0] | 0;
   i1 = i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, gb + 1087656 | 0, 1, i1 + 1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i1) | 0;
   i1 = (__Z7StrICmpPKcS0_(HEAP32[i2 >> 2] | 0, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0) == 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (HEAP32[gb + 1170792 >> 2] | 0)) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 11) {
  STACKTOP = i12;
  return;
 }
}

function _Compute_Point_Displacement(i8, i9, i10, i11, i14) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15;
 if (!(HEAP8[i8 + 368 >> 0] & 1)) {
  i13 = i8 + 72 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i5 = HEAP32[i8 + 80 >> 2] | 0;
  i6 = HEAP32[i8 + 84 >> 2] | 0;
  i7 = HEAP32[i8 + 88 >> 2] | 0;
  i1 = i8 + 92 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i1 = i8 + 288 | 0;
 } else {
  i13 = i8 + 36 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i13 = HEAP32[i13 + 4 >> 2] | 0;
  i5 = HEAP32[i8 + 44 >> 2] | 0;
  i6 = HEAP32[i8 + 48 >> 2] | 0;
  i7 = HEAP32[i8 + 52 >> 2] | 0;
  i1 = i8 + 56 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i1 = i8 + 286 | 0;
 }
 i4 = i5 & 65535;
 i1 = HEAP16[i1 >> 1] | 0;
 i2 = i1 & 65535;
 if ((i1 & 65535) < (i4 & 65535)) {
  i16 = i11;
  HEAP32[i16 >> 2] = i12;
  HEAP32[i16 + 4 >> 2] = i13;
  HEAP16[i11 + 8 >> 1] = i4;
  HEAP16[i11 + 10 >> 1] = i5 >>> 16;
  HEAP32[i11 + 12 >> 2] = i6;
  HEAP32[i11 + 16 >> 2] = i7;
  i13 = i11 + 20 | 0;
  HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP16[i14 >> 1] = i1;
  i13 = mftCall_iiii(HEAP32[i8 + 572 >> 2] | 0, i8 | 0, (HEAP32[i7 + (i2 << 3) >> 2] | 0) - (HEAP32[i6 + (i2 << 3) >> 2] | 0) | 0, (HEAP32[i7 + (i2 << 3) + 4 >> 2] | 0) - (HEAP32[i6 + (i2 << 3) + 4 >> 2] | 0) | 0) | 0;
  i14 = i8 + 564 | 0;
  HEAP32[i9 >> 2] = _UNITY_FT_MulDiv(i13, HEAP16[i8 + 298 >> 1] | 0, HEAP32[i14 >> 2] | 0) | 0;
  HEAP32[i10 >> 2] = _UNITY_FT_MulDiv(i13, HEAP16[i8 + 300 >> 1] | 0, HEAP32[i14 >> 2] | 0) | 0;
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 if (HEAP8[i8 + 561 >> 0] | 0) HEAP32[i8 + 12 >> 2] = 134;
 HEAP16[i14 >> 1] = 0;
 i16 = 1;
 STACKTOP = i15;
 return i16 | 0;
}

function __ZN7ApiGLES16BindStencilStateEPK15GfxStencilStatei(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = i4 + 1584 | 0;
 i2 = i4 + 1588 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) return;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = i6;
 i3 = HEAP8[i4 + 1992 >> 0] | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i1 = i4 + 1592 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i3 << 24 >> 24 != 0 & (i2 & 16384 | 0) == 0)) {
   HEAP32[i1 >> 2] = i2 & -16385;
   i3 = HEAP32[i4 + 772 >> 2] | 0;
   mftCall_vi(i3 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i4 + 860 >> 2] | 0, 14) | 0);
  }
 } else {
  i1 = i4 + 1592 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i3 << 24 >> 24 == 0 | (i2 & 16384 | 0) == 0) {
   HEAP32[i1 >> 2] = i2 | 16384;
   i3 = HEAP32[i4 + 768 >> 2] | 0;
   mftCall_vi(i3 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i4 + 860 >> 2] | 0, 14) | 0);
  }
 }
 i8 = i4 + 756 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 i3 = i4 + 860 | 0;
 i1 = __ZNK13TranslateGLES4FuncE15CompareFunction(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 4 >> 0] | 0) | 0;
 i2 = i5 + 1 | 0;
 mftCall_viiii(i10 | 0, 1028, i1 | 0, i6 | 0, HEAPU8[i2 >> 0] | 0);
 i1 = i4 + 760 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i9 = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 6 >> 0] | 0) | 0;
 i7 = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 7 >> 0] | 0) | 0;
 mftCall_viiii(i10 | 0, 1028, i9 | 0, i7 | 0, __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 5 >> 0] | 0) | 0);
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = __ZNK13TranslateGLES4FuncE15CompareFunction(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 8 >> 0] | 0) | 0;
 mftCall_viiii(i8 | 0, 1029, i7 | 0, i6 | 0, HEAPU8[i2 >> 0] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 10 >> 0] | 0) | 0;
 i6 = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 11 >> 0] | 0) | 0;
 mftCall_viiii(i1 | 0, 1029, i2 | 0, i6 | 0, __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[i3 >> 2] | 0, HEAPU8[i5 + 9 >> 0] | 0) | 0);
 mftCall_vi(HEAP32[i4 + 752 >> 2] | 0, HEAPU8[i5 + 2 >> 0] | 0);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 96 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 96 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 4 | 0;
 i1 = i13;
 i11 = i14 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i14 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i11, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i11 >> 2] = i3;
  i1 = i9;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i9 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i7 = i14 + 4 | 0;
 i8 = i10 + 4 | 0;
 i9 = i10 + 8 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  i2 = i2 + i3 | 0;
  i3 = i2;
  i4 = HEAP32[i11 >> 2] | 0;
  i5 = i4 + 4 | 0;
  if (i5 >>> 0 > (HEAP32[i12 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i11, i2, 4); else {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i11 >> 2] = i5;
  }
  i5 = HEAP32[i7 >> 2] | 0;
  HEAP32[i10 >> 2] = i3 + 8;
  HEAP32[i8 >> 2] = i3 + 4;
  HEAP32[i9 >> 2] = i5;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i14, i10, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i13;
 return;
}

function __ZL28GeomMTDCallback_PlaneCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i10, i9, i1, i7, i6, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i1;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(f4 * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f3 = Math_fround(f14 * Math_fround(2.0));
 f14 = Math_fround(Math_fround(f4 * f2) + Math_fround(Math_fround(f14 * f3) + Math_fround(-1.0)));
 f4 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f13 = Math_fround(f4 * f3);
 f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f2 * f11));
 f11 = Math_fround(Math_fround(f2 * f4) - Math_fround(f3 * f11));
 f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f14 = Math_fround(f3 * f14);
 f13 = Math_fround(f3 * f13);
 f11 = Math_fround(f3 * f11);
 f3 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f4 = Math_fround(f3 + f14);
 f2 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f15 = Math_fround(f2 + f13);
 f5 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 f12 = Math_fround(f11 + f5);
 f14 = Math_fround(f3 - f14);
 f13 = Math_fround(f2 - f13);
 f11 = Math_fround(f5 - f11);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i16, i7);
 f2 = Math_fround(HEAPF32[i16 >> 2]);
 f4 = Math_fround(f4 * f2);
 f3 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f15 = Math_fround(f4 + Math_fround(f15 * f3));
 f4 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f12 = Math_fround(f15 + Math_fround(f12 * f4));
 f15 = Math_fround(HEAPF32[i16 + 12 >> 2]);
 f12 = Math_fround(f15 + f12);
 f11 = Math_fround(f15 + Math_fround(Math_fround(Math_fround(f14 * f2) + Math_fround(f13 * f3)) + Math_fround(f11 * f4)));
 f5 = Math_fround((f12 < f11 ? f12 : f11) - f5);
 if (f5 > Math_fround(0.0)) {
  i16 = 0;
  STACKTOP = i1;
  return i16 | 0;
 }
 f14 = Math_fround(-f3);
 f15 = Math_fround(-f4);
 HEAPF32[i10 >> 2] = Math_fround(-f2);
 HEAPF32[i10 + 4 >> 2] = f14;
 HEAPF32[i10 + 8 >> 2] = f15;
 f15 = Math_fround(-f5);
 i16 = f5 < Math_fround(-0.0);
 HEAPF32[i9 >> 2] = i16 ? f15 : Math_fround(0.0);
 i16 = 1;
 STACKTOP = i1;
 return i16 | 0;
}

function __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 if (!(HEAP8[i1 + 184 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i9 = i1 + 72 | 0;
 i3 = i2;
 if ((i3 | 0) == (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i6 = i10 + 4 | 0;
 i7 = i10 + 8 | 0;
 i8 = i11 + 4 | 0;
 i1 = i2;
 while (1) {
  i4 = i3 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i4); else {
   i5 = HEAP8[i4 + 11 >> 0] | 0;
   i14 = i5 << 24 >> 24 < 0;
   i4 = i14 ? HEAP32[i4 >> 2] | 0 : i4;
   i5 = i14 ? HEAP32[i3 + 20 >> 2] | 0 : i5 & 255;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + 12 >> 2] = i3;
   if (i5 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
    i3 = HEAP32[i2 + 12 >> 2] | 0;
    i12 = 8;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i2 + 11 >> 0] = i5;
    if (i5) i12 = 10;
   } else i12 = 8;
   if ((i12 | 0) == 8) {
    i15 = i5 + 16 & -16;
    HEAP32[i11 >> 2] = 66;
    HEAP32[i8 >> 2] = i3;
    i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i15, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i2 >> 2] = i14;
    HEAP32[i2 + 8 >> 2] = i15 | -2147483648;
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = i14;
    i12 = 10;
   }
   if ((i12 | 0) == 10) {
    i12 = 0;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
   }
   HEAP8[i2 + i5 >> 0] = 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 16;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i9 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 STACKTOP = i13;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyEN5physx8debugger18NonNegativeIntegerEPKc(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) if ((HEAP32[i3 + 128 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[i3 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropImplERKN5physx8debugger14NamespacedNameEPKc(i3, i1 + 4 | 0, i2) | 0;
   HEAP32[i4 >> 2] = gb + 148864 + 8;
   if (!i1) {
    HEAP32[i4 + 4 >> 2] = gb + 1576256;
    HEAP32[i4 + 8 >> 2] = gb + 1576256;
    HEAP32[i4 + 12 >> 2] = -1;
    HEAP32[i4 + 16 >> 2] = gb + 1576256;
    HEAP32[i4 + 20 >> 2] = gb + 1576256;
    HEAP32[i4 + 24 >> 2] = -1;
    HEAP32[i4 + 28 >> 2] = gb + 1576256;
    HEAP32[i4 + 32 >> 2] = gb + 1576256;
    HEAP32[i4 + 36 >> 2] = 0;
    HEAP32[i4 + 40 >> 2] = -1;
    HEAP32[i4 + 44 >> 2] = 0;
    HEAP32[i4 + 48 >> 2] = 0;
    HEAP8[i4 + 52 >> 0] = 0;
    return;
   } else {
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    i5 = i4 + 4 | 0;
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = i3;
    HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    i5 = i1 + 16 | 0;
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    i2 = i4 + 16 | 0;
    HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i2 + 4 >> 2] = i3;
    HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
    i2 = i4 + 28 | 0;
    i3 = i1 + 28 | 0;
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
    HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
    i1 = i1 + 44 | 0;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = i4 + 44 | 0;
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 + 4 >> 2] = i2;
    HEAP8[i4 + 52 >> 0] = 1;
    return;
   }
  }
 }
 HEAP32[i4 >> 2] = gb + 148864 + 8;
 HEAP32[i4 + 4 >> 2] = gb + 1576256;
 HEAP32[i4 + 8 >> 2] = gb + 1576256;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP32[i4 + 16 >> 2] = gb + 1576256;
 HEAP32[i4 + 20 >> 2] = gb + 1576256;
 HEAP32[i4 + 24 >> 2] = -1;
 HEAP32[i4 + 28 >> 2] = gb + 1576256;
 HEAP32[i4 + 32 >> 2] = gb + 1576256;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = -1;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP8[i4 + 52 >> 0] = 0;
 return;
}

function __ZN4gles24CreateDepthRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 i2 = i8 + 40 | 0;
 HEAP32[i2 >> 2] = i1;
 i6 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 150) | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i8 + 32 >> 2] = i6;
 i6 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = i1 >>> 0 > i5 >>> 0 ? i5 : i1;
 i1 = __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES(i7, i8) | 0;
 if (i1 | 0) HEAP32[i1 + 20 >> 2] = HEAP32[i2 >> 2];
 i5 = i8 + 20 | 0;
 if (HEAP32[i5 >> 2] & 64 | 0) {
  STACKTOP = i9;
  return;
 }
 __ZN4gles21InitRenderSurfaceGLESEP7ApiGLESR17RenderSurfaceGLESN2gl17TextureSrgbDecodeE(i7, i8, 0);
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i3, i1, i4);
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i5 >> 2] & 8)) {
  STACKTOP = i9;
  return;
 }
 if ((HEAP32[i6 >> 2] | 0) >>> 0 > 1) {
  STACKTOP = i9;
  return;
 }
 i8 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i7 + 860 >> 2] | 0, HEAP32[i8 + 24 >> 2] | 0) | 0;
 i7 = i7 + 180 | 0;
 mftCall_viii(HEAP32[i7 >> 2] | 0, i8 | 0, 34892, 34894);
 mftCall_viii(HEAP32[i7 >> 2] | 0, i8 | 0, 34893, 515);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 240 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 240 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture(i8, i2, i5, i10, i6) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i3 = i12;
 i11 = i12 + 28 | 0;
 if ((i2 | 0) == 1) {
  HEAP32[i6 >> 2] = __ZN13RenderTexture9GetActiveEi(0) | 0;
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((i2 + -1 | 0) >>> 0 < 15) {
  i9 = HEAP32[i8 + 100 + (i2 << 2) >> 2] | 0;
  HEAP32[i6 >> 2] = i9;
  if (!((i2 | 0) != 2 & (i9 | 0) == 0)) {
   i11 = 1;
   STACKTOP = i12;
   return i11 | 0;
  }
  i1 = i8 + 164 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = i10;
  __Z6FormatPKcz(i11, gb + 423864 | 0, i3);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i11, 512, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = HEAP32[i8 + 72 >> 2] | 0;
 L19 : do if (!i3) i7 = 14; else {
  i4 = HEAP32[i8 + 60 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 3) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i7 = 14;
    break L19;
   }
  }
  i4 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i4;
  if (i4 | 0) {
   i11 = 1;
   STACKTOP = i12;
   return i11 | 0;
  }
 } while (0);
 if ((i7 | 0) == 14) HEAP32[i6 >> 2] = 0;
 i2 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i5) | 0;
 i1 = i8 + 164 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = i10;
 __Z6FormatPKcz(i11, gb + 423945 | 0, i9);
 __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i11, 512, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 __ZNK15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E13find_positionERS3_(i1, i7, i8);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i8 = HEAP32[i7 + 60 >> 2] | 0;
  i9 = i8 + ((HEAP32[i7 + 64 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i6 + 4 >> 2] = i8 + (i2 * 24 | 0);
  HEAP32[i6 + 8 >> 2] = i9;
  HEAP8[i6 + 12 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i7 + 8 >> 0] | 0)) i9 = 11; else {
  i3 = i7 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) i9 = 11; else {
   i2 = i7 + 60 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i7 + 28 >> 2] | 0) == (HEAP32[i1 + (i5 * 24 | 0) + 16 >> 2] | 0)) if ((HEAP32[i7 + 16 >> 2] | 0) == (HEAP32[i1 + (i5 * 24 | 0) + 4 >> 2] | 0)) if (!(_strcmp(HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 + (i5 * 24 | 0) >> 2] | 0) | 0)) if (!(_strcmp(HEAP32[i7 + 20 >> 2] | 0, HEAP32[i1 + (i5 * 24 | 0) + 8 >> 2] | 0) | 0)) if ((HEAP32[i7 + 24 >> 2] | 0) == (HEAP32[i1 + (i5 * 24 | 0) + 12 >> 2] | 0)) HEAP32[i3 >> 2] = i4 + -1; else i9 = 11; else i9 = 11; else i9 = 11; else i9 = 11; else i9 = 11;
  }
 }
 if ((i9 | 0) == 11) {
  i1 = i7 + 68 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i7 + 60 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i9 = i1 + (i5 * 24 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i8 = HEAP32[i2 >> 2] | 0;
 i9 = i8 + ((HEAP32[i7 + 64 >> 2] | 0) * 24 | 0) | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i8 + (i5 * 24 | 0);
 HEAP32[i6 + 8 >> 2] = i9;
 HEAP8[i6 + 12 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN11TerrainData24NotifyUsersOnTreeUpdatedEi(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 4 | 0;
 i11 = i13;
 i2 = HEAP32[i1 + 352 >> 2] | 0;
 i7 = i1 + 356 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 i8 = i10 + 8 | 0;
 i6 = i10 + 4 | 0;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i11 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i3 = HEAP32[i10 >> 2] | 0;
     i5 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i12 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i12 = 12;
    }
   }
   if ((i12 | 0) == 10) i12 = 12;
   if ((i12 | 0) == 12) {
    i12 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 35740 | 0) | 0;
   if (i3 | 0) {
    i5 = i3 + 228 | 0;
    i4 = i3 + 240 | 0;
    if (HEAP32[i4 >> 2] | 0) {
     i3 = HEAP32[i5 >> 2] | 0;
     do {
      __ZN12TreeRenderer11TreeUpdatedEi(HEAP32[i3 + 8 >> 2] | 0, i9);
      i3 = i3 + 20 | 0;
     } while ((i3 | 0) != ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0));
    }
   }
   HEAP32[i10 >> 2] = gb + 29192;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i6 >> 2] = 2;
   __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105776 | 0, i10);
  } while (0);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i7 >> 2] | 0));
 STACKTOP = i13;
 return;
}

function __ZN10VertexData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i2 = i8 + 28 | 0;
 i7 = i8 + 8 | 0;
 i11 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 430604 | 0, i11, i1 + 88 | 0, 1);
 i6 = i4 + 16 | 0;
 i5 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 430622 | 0, i11, i1 + 92 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i5 = i7 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i11 = i3;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 853571 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1);
 HEAP32[i2 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 430636 | 0, i2, 0);
 __ZN11ChannelInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 i2 = i1 + 96 | 0;
 __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i4, i2, gb + 430648 | 0, 1);
 i3 = HEAP32[i1 + 84 >> 2] | 0;
 if (!i3) i1 = 0; else i1 = HEAP32[i2 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i4, i1, i3, 0);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i1, i3, i13) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i1) if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i11 = HEAP32[i2 + 40 >> 2] | 0;
 i12 = i1 + (i11 << 3) | 0;
 if (!i11) {
  i13 = 0;
  return i13 | 0;
 }
 i11 = i3 + 4 | 0;
 i10 = i1;
 i1 = 0;
 do {
  i9 = HEAP32[i11 >> 2] | 0;
  if (((HEAP32[i10 >> 2] | 0) - (HEAP32[i9 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i9 + 28 >> 2] | 0) >>> 0) {
   i6 = HEAP32[i10 + 4 >> 2] | 0;
   i7 = HEAP32[i13 >> 2] | 0;
   i8 = i7 + 12 | 0;
   i9 = i7 + 16 | 0;
   do if (!(HEAP32[i8 >> 2] | 0)) {
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 & 2147483646) >>> 0 < 10) if ((i1 | 0) > -1) {
     HEAP32[i9 >> 2] = 10;
     HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, 40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
     HEAP32[i9 >> 2] = 10;
     HEAP32[i7 >> 2] = i5;
     break;
    }
   } while (0);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i8 >> 2] = i3;
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   i1 = 1;
  }
  i10 = i10 + 8 | 0;
 } while ((i10 | 0) != (i12 | 0));
 return i1 | 0;
}

function __Z11tessNewTessP9TESSalloc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (i1 | 0) == 0 ? gb + 25288 | 0 : i1;
 i8 = mftCall_iii(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, 300) | 0;
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 i7 = i8 + 104 | 0;
 i3 = i7;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i1 = i8 + 120 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 512;
 i1 = i8 + 124 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 512;
 i1 = i8 + 128 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 256;
 i1 = i8 + 132 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 512;
 i2 = i8 + 136 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 256;
  i1 = 256;
 }
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
 i6 = i8 + 44 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 if ((i1 | 0) < 16) {
  HEAP32[i2 >> 2] = 16;
  i2 = 16;
 } else if ((i1 | 0) > 4096) {
  HEAP32[i2 >> 2] = 4096;
  i2 = 4096;
 } else i2 = i1;
 i3 = i8 + 116 | 0;
 i1 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, 24) | 0;
 HEAP32[i1 + 20 >> 2] = i7;
 HEAP32[i1 + 16 >> 2] = gb + 363025;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 28;
 i6 = i1 + 12 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, (i2 * 28 | 0) + 4 | 0) | 0;
 if (!i7) {
  mftCall_vii(HEAP32[i8 + 112 >> 2] | 0, HEAP32[i3 >> 2] | 0, i1 | 0);
  i1 = 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i7;
  i4 = HEAP32[i4 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i6 >> 2] | 0, i4) | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  do {
   i2 = i2 - i4 | 0;
   i6 = i3;
   i3 = i7 + i2 | 0;
   HEAP32[i3 >> 2] = i6;
  } while ((i2 | 0) != 4);
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i8 + 76 >> 2] = i1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i7 = i8 + 80 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i6) i5 = 0; else {
  i1 = i6 * 28 | 0;
  if (!i1) i5 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 722272 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = i7 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + (i2 * 28 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i9 = i2 + 4 | 0;
   i11 = i9;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i9 = i9 + 4 | 0;
   i9 = HEAPU16[i9 >> 1] | HEAPU16[i9 + 2 >> 1] << 16;
   i10 = i1 + 4 | 0;
   i8 = i10;
   HEAP16[i8 >> 1] = i11;
   HEAP16[i8 + 2 >> 1] = i11 >>> 16;
   i10 = i10 + 4 | 0;
   HEAP16[i10 >> 1] = i9;
   HEAP16[i10 + 2 >> 1] = i9 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i10 = i1 + 12 | 0;
   i9 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 >> 2] = gb + 106620 + 8;
   i10 = i2 + 20 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1 + 20 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i11 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1 + (i11 * 28 | 0) | 0;
  if ((i11 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = i7 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i2 | 0);
 HEAP32[i7 >> 2] = i5;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSapD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 103840 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 19 | 0, HEAP32[i1 + 112 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 18 | 0, HEAP32[i1 + 116 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 17 | 0, HEAP32[i1 + 120 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 16 | 0, HEAP32[i1 + 124 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 15 | 0, HEAP32[i1 + 128 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 14 | 0, HEAP32[i1 + 132 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 13 | 0, HEAP32[i1 + 136 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 12 | 0, HEAP32[i1 + 140 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 11 | 0, HEAP32[i1 + 144 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 10 | 0, HEAP32[i1 + 180 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 9 | 0, HEAP32[i1 + 232 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 8 | 0, HEAP32[i1 + 244 >> 2] | 0);
 __ZN5physx14SapPairManager7releaseEv(i1 + 192 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 7 | 0, HEAP32[i1 + 284 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 6 | 0, HEAP32[i1 + 324 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 5 | 0, HEAP32[i1 + 364 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 4 | 0, HEAP32[i1 + 160 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i1 + 164 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i1 + 152 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i1 + 156 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 148 >> 2] | 0);
 HEAP32[i1 + 336 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 344 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5Unity10HingeJoint16WriteJointSpringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 32 | 0;
 i3 = i4;
 if (!(HEAP8[i1 + 159 >> 0] | 0)) {
  i1 = i1 + 32 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i2 + 12 >> 2] = 0;
  mftCall_viii(i6 | 0, i5 | 0, 4, i2 | 0);
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i5 = i5 + 28 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_viii(i5 | 0, i1 | 0, i2 | 0, i3 | 0);
  i2 = HEAP32[i2 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i2);
  i3 = HEAP32[i3 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i3);
  STACKTOP = i4;
  return;
 } else {
  i6 = HEAP32[i1 + 120 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 116 >> 2];
  HEAP32[i2 + 4 >> 2] = i6;
  HEAPF32[i2 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAP32[i2 + 12 >> 2] = 0;
  i6 = i1 + 32 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0, i5 | 0, 4, i2 | 0);
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(HEAPF32[i1 + 124 >> 2])) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)) * Math_fround(.5));
  f9 = Math_fround(+Math_sin(+f7));
  f7 = Math_fround(+Math_cos(+f7));
  f8 = Math_fround(f9 * Math_fround(0.0));
  HEAPF32[i3 >> 2] = f9;
  HEAPF32[i3 + 4 >> 2] = f8;
  HEAPF32[i3 + 8 >> 2] = f8;
  HEAPF32[i3 + 12 >> 2] = f7;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  i5 = HEAP32[i6 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 172 >> 2] | 0, i5 | 0, i3 | 0);
  i6 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 28 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_viii(i5 | 0, i6 | 0, i2 | 0, i3 | 0);
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i6);
  i6 = HEAP32[i3 >> 2] | 0;
  __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i6);
  STACKTOP = i4;
  return;
 }
}

function __ZN16TimerQueriesGLES15EndTimerQueriesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i1 + 564 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 788 >> 2] | 0, 35007);
 i8 = i1 + 560 | 0;
 if ((HEAP32[i8 >> 2] | 0) > 1) {
  i2 = i1 + 552 | 0;
  i3 = i1 + 544 | 0;
  i4 = i1 + 548 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i3 | 0)) {
   i10 = HEAP32[i2 >> 2] | 0;
   HEAP32[i10 + 4 >> 2] = i5;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 >> 2] = i10;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i3 >> 2] = i3;
  }
 }
 L8 : do if ((HEAP32[i1 + 556 >> 2] | 0) != (i1 + 552 | 0)) {
  mftCall_v(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 48 >> 2] | 0);
  while (1) {
   i3 = HEAP32[gb + 1098256 + 556 >> 2] | 0;
   while (1) {
    if ((i3 | 0) == (gb + 1098256 + 552 | 0)) break L8;
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 720 >> 0] | 0)) i1 = HEAP8[i3 + 8 >> 0] | 0; else {
     i1 = (__ZNK7ApiGLES3GetEj(HEAP32[gb + 1451080 >> 2] | 0, 36795) | 0) != 0 & 1;
     HEAP8[i3 + 8 >> 0] = i1;
    }
    i10 = i6;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i10 + 4 >> 2] = 0;
    if (!(i1 << 24 >> 24)) {
     mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 800 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, 34918, i6 | 0);
     i2 = i6;
     i1 = HEAP32[i2 >> 2] | 0;
     i2 = HEAP32[i2 + 4 >> 2] | 0;
    } else {
     i1 = 0;
     i2 = 0;
    }
    i4 = gb + 1098256 + 520 | 0;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i10 = i3 + 20 | 0;
    HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i10 + 4 >> 2] = i5;
    i10 = gb + 1098256 + 520 | 0;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = i2;
    i1 = HEAP32[gb + 1098256 + 556 >> 2] | 0;
    if ((i1 | 0) == (gb + 1098256 + 552 | 0)) i3 = gb + 1098256 + 552 | 0; else break;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) continue;
   i10 = i1 + 4 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
   HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
  }
 } while (0);
 HEAP32[i8 >> 2] = 0;
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i9;
 return;
}

function __ZN15CapsuleCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f(i1, i2, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11 + 16 | 0;
 i10 = i11;
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i2, i1 + 72 | 0);
 __ZNK9Transform11GetRotationEv(i10, i2);
 switch (HEAP32[i1 + 68 >> 2] | 0) {
 case 1:
  {
   f3 = Math_fround(Math_fround(HEAPF32[gb + 62548 >> 2]) * Math_fround(-.707106769));
   f6 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 4 >> 2]) * Math_fround(-.707106769));
   f4 = Math_fround(Math_fround(HEAPF32[gb + 62548 + 8 >> 2]) * Math_fround(-.707106769));
   f5 = Math_fround(.707106769);
   break;
  }
 case 2:
  {
   f3 = Math_fround(Math_fround(HEAPF32[gb + 62536 >> 2]) * Math_fround(.707106769));
   f6 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 4 >> 2]) * Math_fround(.707106769));
   f4 = Math_fround(Math_fround(HEAPF32[gb + 62536 + 8 >> 2]) * Math_fround(.707106769));
   f5 = Math_fround(.707106769);
   break;
  }
 default:
  {
   f3 = Math_fround(0.0);
   f4 = Math_fround(0.0);
   f5 = Math_fround(1.0);
   f6 = Math_fround(0.0);
  }
 }
 f18 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f15 = Math_fround(f3 * f18);
 f17 = Math_fround(HEAPF32[i10 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f5 * f17));
 f16 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f15 = Math_fround(f15 + Math_fround(f4 * f16));
 f14 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f13 = Math_fround(Math_fround(Math_fround(f3 * f14) + Math_fround(Math_fround(f6 * f18) + Math_fround(f5 * f16))) - Math_fround(f4 * f17));
 f12 = Math_fround(Math_fround(Math_fround(f6 * f17) + Math_fround(Math_fround(f4 * f18) + Math_fround(f5 * f14))) - Math_fround(f3 * f16));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f18) - Math_fround(f3 * f17)) - Math_fround(f6 * f16)) - Math_fround(f4 * f14));
 HEAPF32[i9 >> 2] = Math_fround(f15 - Math_fround(f6 * f14));
 HEAPF32[i9 + 4 >> 2] = f13;
 HEAPF32[i9 + 8 >> 2] = f12;
 HEAPF32[i9 + 12 >> 2] = f5;
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i7, i8, i9);
 STACKTOP = i11;
 return;
}

function __GLOBAL__sub_I_runtime_physics2d_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457896 | 0, gb + 798734 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457908 | 0, gb + 798762 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457920 | 0, gb + 798794 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457932 | 0, gb + 798825 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457944 | 0, gb + 798851 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457956 | 0, gb + 798885 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457968 | 0, gb + 798920 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457980 | 0, gb + 798961 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1457992 | 0, gb + 799001 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458004 | 0, gb + 799052 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458016 | 0, gb + 799083 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458028 | 0, gb + 799121 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458040 | 0, gb + 799154 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458052 | 0, gb + 799184 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458064 | 0, gb + 799212 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458076 | 0, gb + 799239 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458088 | 0, gb + 799271 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458100 | 0, gb + 799305 | 0, 3, 0);
 return;
}

function __ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_(i6, i9, i10) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = HEAP32[i9 + 8 >> 2] | 0;
 i12 = HEAP32[HEAP32[i6 + 4 >> 2] >> 2] | 0;
 i13 = HEAP32[i10 + 8 >> 2] | 0;
 i1 = HEAP32[i12 + (i11 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i12 + (i13 * 360 | 0) + 184 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i13 = i1 >>> 0 < i2 >>> 0;
  return i13 | 0;
 }
 i1 = HEAP16[i9 + 12 >> 1] | 0;
 i2 = HEAP16[i10 + 12 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i13 = i1 << 16 >> 16 < i2 << 16 >> 16;
  return i13 | 0;
 }
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = (HEAP16[i12 + (i11 * 360 | 0) + 182 >> 1] | 0) != 0;
 i5 = (HEAP16[i12 + (i13 * 360 | 0) + 182 >> 1] | 0) != 0;
 i1 = i5 ^ 1;
 if (!(i2 ^ 1 | i1)) {
  if ((i7 | 0) != (i8 | 0)) {
   i13 = i7 >>> 0 < i8 >>> 0;
   return i13 | 0;
  }
  i1 = HEAP32[i12 + (i11 * 360 | 0) + 248 >> 2] | 0;
  i2 = HEAP32[i12 + (i13 * 360 | 0) + 248 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i13 = (HEAPU16[i12 + (i11 * 360 | 0) + 180 >> 1] | 0) < (HEAPU16[i12 + (i13 * 360 | 0) + 180 >> 1] | 0);
   return i13 | 0;
  } else {
   i13 = (i1 | 0) < (i2 | 0);
   return i13 | 0;
  }
 }
 if (i2 ^ i5) {
  i13 = i2 & i1;
  return i13 | 0;
 }
 if (HEAP8[i6 >> 0] | 0) {
  i1 = (HEAP32[i9 + 20 >> 2] | 0) >>> 24;
  i2 = (HEAP32[i10 + 20 >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i2 | 0)) {
   i13 = i1 >>> 0 < i2 >>> 0;
   return i13 | 0;
  }
 }
 i1 = HEAP32[i12 + (i11 * 360 | 0) + 224 >> 2] | 0;
 i2 = HEAP32[i12 + (i13 * 360 | 0) + 224 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i13 = i1 >>> 0 < i2 >>> 0;
  return i13 | 0;
 }
 if ((i7 | 0) != (i8 | 0)) {
  i13 = (i7 | 0) < (i8 | 0);
  return i13 | 0;
 }
 i1 = HEAP32[i9 + 28 >> 2] | 0;
 i2 = HEAP32[i10 + 28 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i13 = i1 >>> 0 > i2 >>> 0;
  return i13 | 0;
 }
 f4 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 if (f4 == f3) {
  i2 = HEAP16[i12 + (i11 * 360 | 0) + 270 >> 1] | 0;
  i1 = HEAP16[i12 + (i13 * 360 | 0) + 270 >> 1] | 0;
  if (i2 << 16 >> 16 != i1 << 16 >> 16) {
   i13 = (i2 & 65535) > (i1 & 65535);
   return i13 | 0;
  }
 }
 i13 = f4 > f3;
 return i13 | 0;
}

function __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite8TransferI4PPtrI9Texture2DEEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1034892 | 0, 0);
 __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(i10, i11 + 4 | 0, gb + 1034921 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx9NpFactory17createClothFabricERNS_13PxInputStreamE(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 if (!(HEAP32[gb + 1457388 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 410, gb + 690476 | 0, i10);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 4552 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 4548 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 4256 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i7 = i2 + 4536 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = i2 + 4540 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 do if (!i1) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i1 = 0;
 } else {
  __ZN5physx13NpClothFabricC2Ev(i1);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  if (!(__ZN5physx13NpClothFabric4loadERNS_13PxInputStreamE(i1, i5) | 0)) {
   i2 = i1 + 8 | 0;
   if (__ZN5physx6shdfnd15atomicDecrementEPVi(i1 + 12 | 0) | 0) {
    i1 = 0;
    break;
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
   i1 = 0;
   break;
  }
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
  i5 = i8 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
  i6 = i8 + 3944 | 0;
  i7 = i8 + 3948 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i8 + 3952 | 0;
  if (!i2) if ((HEAP32[i3 >> 2] & 2147483584) >>> 0 < 64) {
   __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, 64);
   i2 = HEAP32[i7 >> 2] | 0;
  } else i2 = 0;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] = i4;
   HEAP32[i7 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i9) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 } while (0);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 4 | 0, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 24 | 0, i5);
 i1 = i4 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z22ReplaceDirectoryInPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 36 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i3);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i4 = i2 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255;
 i2 = i1 + i4 | 0;
 if (i4 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 11 | 0;
 i11 = HEAP8[i3 >> 0] | 0;
 i2 = i11 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i7 + 4 | 0;
 i11 = i2 ? HEAP32[i4 >> 2] | 0 : i11 & 255;
 i2 = i1 + i11 | 0;
 if (i11 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i11 = HEAP8[i8 + 11 >> 0] | 0;
 i2 = i11 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
 i11 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i11 & 255;
 i2 = i1 + i11 | 0;
 if (i11 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i11 = HEAP8[i3 >> 0] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i6, 0, i11 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i11 & 255) | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_(i8, i9, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i10;
 return;
}

function __ZNK15ReflectionProbe10GetTextureEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = i8 + 8 | 0;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i7 + 40 >> 2] | 0;
 switch (i1 | 0) {
 case 0:
  {
   i7 = HEAP32[i7 + 124 >> 2] | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 case 2:
  {
   i7 = HEAP32[i7 + 128 >> 2] | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 case 1:
  {
   i5 = i7 + 172 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i4 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i6 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
      i2 = HEAP32[i3 >> 2] | 0;
      i4 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 12;
    }
    if ((i6 | 0) == 10) i6 = 12;
    if ((i6 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
    i7 = HEAP32[i5 >> 2] | 0;
    STACKTOP = i8;
    return i7 | 0;
   } while (0);
   i1 = HEAP32[i7 + 164 >> 2] | 0;
   if (i1 | 0) if (HEAP8[i7 + 176 >> 0] | 0) {
    i7 = HEAP32[i1 + 4 >> 2] | 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   i7 = HEAP32[i7 + 124 >> 2] | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 default:
  {
   HEAP32[i2 >> 2] = i1;
   __Z6FormatPKcz(i3, gb + 380829 | 0, i2);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 380852 | 0, 445, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i6) i5 = 0; else {
  i1 = i6 * 28 | 0;
  if (!i1) i5 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 722990 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = i7 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + (i2 * 28 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 106664 + 8;
   i9 = i2 + 4 | 0;
   i11 = i9;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i9 = i9 + 4 | 0;
   i9 = HEAPU16[i9 >> 1] | HEAPU16[i9 + 2 >> 1] << 16;
   i10 = i1 + 4 | 0;
   i8 = i10;
   HEAP16[i8 >> 1] = i11;
   HEAP16[i8 + 2 >> 1] = i11 >>> 16;
   i10 = i10 + 4 | 0;
   HEAP16[i10 >> 1] = i9;
   HEAP16[i10 + 2 >> 1] = i9 >>> 16;
   HEAP32[i1 >> 2] = gb + 87404 + 8;
   i10 = i1 + 12 | 0;
   i9 = i2 + 12 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 >> 2] = gb + 106532 + 8;
   i10 = i2 + 20 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1 + 20 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 28 | 0;
  }
  i11 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1 + (i11 * 28 | 0) | 0;
  if ((i11 | 0) > 0) do {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i1 + 28 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = i7 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i2 | 0);
 HEAP32[i7 >> 2] = i5;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN3MBP5resetEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 2 | 0;
 i7 = i11 + 1 | 0;
 i8 = i11;
 i5 = i10 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 20 | 0;
 if (i1 | 0) {
  i4 = HEAP32[i10 + 28 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   i2 = i4 + 28 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    __ZN9BoxPrunerD2Ev(i3);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i3);
    HEAP32[i2 >> 2] = 0;
   }
   if (!i1) break; else i4 = i4 + 40 | 0;
  }
 }
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = -1;
 HEAP32[i10 + 16 >> 2] = -1;
 i1 = 0;
 do {
  __ZN5physx2Gu9Container5EmptyEv(i10 + 96 + (i1 << 4) | 0) | 0;
  HEAP32[i10 + 4208 + (i1 << 2) >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 257);
 __ZN5physx2Gu9Container5EmptyEv(i6) | 0;
 __ZN5physx2Gu9Container5EmptyEv(i10 + 36 | 0) | 0;
 i1 = i10 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i10 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i10 + 56 >> 2] = 0;
 HEAP32[i10 + 60 >> 2] = 0;
 i1 = i10 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 + 84 >> 2] = 0;
 i1 = i10 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 + 92 >> 2] = 0;
 __ZN5physx2Gu9Container5EmptyEv(i10 + 5236 | 0) | 0;
 i1 = i10 + 5252 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i10 = i10 + 5256 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i10 = i10 + 5256 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN11Rigidbody2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(228, i1, 16, gb + 1048932 | 0, 0, gb + 807731 | 0, 117) | 0;
 i8 = i1;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i7, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 157332 + 8;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 0;
 HEAP8[i4 + 77 >> 0] = 0;
 i1 = HEAP32[gb + 1162356 >> 2] | 0;
 HEAP32[i4 + 80 >> 2] = i1;
 i2 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 HEAP32[i4 + 84 >> 2] = i2;
 HEAPF32[i4 + 88 >> 2] = Math_fround(1.0);
 i7 = i4 + 92 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = i4;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = 0;
 i7 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i4 + 128 >> 2] = i7;
 i6 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i4 + 132 >> 2] = i6;
 i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i4 + 136 >> 2] = i5;
 HEAPF32[i4 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 152 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 156 >> 2] = i7;
 HEAP32[i4 + 160 >> 2] = i6;
 HEAP32[i4 + 164 >> 2] = i5;
 HEAPF32[i4 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 180 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 184 >> 2] = i7;
 HEAP32[i4 + 188 >> 2] = i6;
 HEAP32[i4 + 192 >> 2] = i5;
 HEAPF32[i4 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 208 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 212 >> 2] = i1;
 HEAP32[i4 + 216 >> 2] = i2;
 i2 = i4 + 220 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = i4;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL6IsInYZffPPK10VertexInfo(f17, f18, i1) {
 f17 = Math_fround(f17);
 f18 = Math_fround(f18);
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i15 = HEAP32[i1 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 if (Math_fround(Math_fround(Math_fround(f18 - f14) * Math_fround(f16 - f13)) - Math_fround(Math_fround(f17 - f13) * Math_fround(f5 - f14))) >= Math_fround(0.0)) {
  f18 = Math_fround(-1.0);
  return Math_fround(f18);
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f9 = Math_fround(f7 - f16);
 f10 = Math_fround(f18 - f5);
 f11 = Math_fround(f8 - f5);
 f12 = Math_fround(f17 - f16);
 if (Math_fround(Math_fround(f10 * f9) - Math_fround(f12 * f11)) >= Math_fround(0.0)) {
  f18 = Math_fround(-1.0);
  return Math_fround(f18);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (Math_fround(Math_fround(Math_fround(f18 - f8) * Math_fround(f2 - f7)) - Math_fround(Math_fround(f17 - f7) * Math_fround(f3 - f8))) >= Math_fround(0.0)) {
  f18 = Math_fround(-1.0);
  return Math_fround(f18);
 }
 if (Math_fround(Math_fround(Math_fround(f18 - f3) * Math_fround(f13 - f2)) - Math_fround(Math_fround(f17 - f2) * Math_fround(f14 - f3))) >= Math_fround(0.0)) {
  f18 = Math_fround(-1.0);
  return Math_fround(f18);
 }
 f17 = Math_fround(HEAPF32[i15 >> 2]);
 f18 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f17);
 f9 = Math_fround(f17 + Math_fround(Math_fround(f18 * Math_fround(Math_fround(f12 * f9) + Math_fround(f10 * f11))) / Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f9 * f9)) + Math_fround(f11 * f11))));
 f11 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f17);
 f17 = Math_fround(f13 - f16);
 f18 = Math_fround(f14 - f5);
 f18 = Math_fround(f9 + Math_fround(Math_fround(f11 * Math_fround(Math_fround(f12 * f17) + Math_fround(f10 * f18))) / Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f17 * f17)) + Math_fround(f18 * f18))));
 return Math_fround(f18);
}

function __GLOBAL__sub_I_runtime_baseclasses_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544211 | 0, fb + 3309 | 0, fb + 3310 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104664 | 0, gb + 369485 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104676 | 0, gb + 369516 | 0, 11, 0);
 HEAP32[gb + 1104268 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1104268 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1104268 + 12 >> 2] = 16;
 i1 = gb + 1104268 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3311 | 0, fb + 3312 | 0, 0, gb + 1104268 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104688 | 0, gb + 369534 | 0, 1, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104700 | 0, gb + 369554 | 0, 1, 0);
 i1 = gb + 1104348 | 0;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104712 | 0, gb + 369576 | 0, 10, 0);
 HEAP32[gb + 1104584 >> 2] = 0;
 HEAP32[gb + 1104584 + 4 >> 2] = 0;
 i1 = gb + 63168 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = gb + 1104584 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[gb + 1104584 + 16 >> 2] = 0;
 HEAP32[gb + 1104584 + 16 + 4 >> 2] = 0;
 HEAP32[gb + 1104584 + 16 + 8 >> 2] = 0;
 HEAP32[gb + 1104584 + 16 + 12 >> 2] = 0;
 HEAP32[gb + 1104584 + 16 + 16 >> 2] = 0;
 HEAP32[gb + 1104584 + 16 + 20 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1104584 + 40 >> 2] = i3;
 HEAP32[gb + 1104584 + 68 >> 2] = 0;
 HEAP32[gb + 1104584 + 72 >> 2] = 0;
 HEAP32[gb + 1104584 + 44 >> 2] = 0;
 HEAP32[gb + 1104584 + 44 + 4 >> 2] = 0;
 HEAP32[gb + 1104584 + 44 + 8 >> 2] = 0;
 HEAP32[gb + 1104584 + 44 + 12 >> 2] = 0;
 HEAP32[gb + 1104584 + 44 + 16 >> 2] = 0;
 HEAP32[gb + 1104584 + 64 >> 2] = gb + 1104584 + 68;
 return;
}

function __ZThn4_N5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_(i8, i3, i4, i6, i5, i2, i1, i7) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0, i28 = 0, i29 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 88 | 0;
 i11 = i9 + 80 | 0;
 i12 = i9 + 72 | 0;
 i13 = i9 + 64 | 0;
 i14 = i9 + 56 | 0;
 i15 = i9 + 48 | 0;
 i21 = i9 + 40 | 0;
 i20 = i9 + 32 | 0;
 i19 = i9 + 24 | 0;
 i18 = i9 + 16 | 0;
 i17 = i9 + 8 | 0;
 i16 = i9;
 i22 = i7;
 i23 = HEAP32[i22 >> 2] | 0;
 i22 = HEAP32[i22 + 4 >> 2] | 0;
 i24 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i25 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i26 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i27 = i6;
 i28 = HEAP32[i27 >> 2] | 0;
 i27 = HEAP32[i27 + 4 >> 2] | 0;
 i29 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = __ZN5physx5cloth8allocateEj(96) | 0;
 i6 = i21;
 HEAP32[i6 >> 2] = i29;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = i20;
 HEAP32[i6 >> 2] = i28;
 HEAP32[i6 + 4 >> 2] = i27;
 i6 = i19;
 HEAP32[i6 >> 2] = i26;
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = i18;
 HEAP32[i6 >> 2] = i25;
 HEAP32[i6 + 4 >> 2] = i2;
 i6 = i17;
 HEAP32[i6 >> 2] = i24;
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i16;
 HEAP32[i6 >> 2] = i23;
 HEAP32[i6 + 4 >> 2] = i22;
 i6 = __ZN5physx5cloth15getNextFabricIdEv() | 0;
 HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 __ZN5physx5cloth8SwFabricC2ERNS0_9SwFactoryEjNS0_5RangeIKjEES6_NS4_IKfEES6_S6_S8_j(i7, i8 + -4 | 0, i3, i15, i14, i13, i12, i11, i10, i6);
 STACKTOP = i9;
 return ((i7 | 0) == 0 ? 0 : i7 + 4 | 0) | 0;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15;
 i1 = HEAP32[i12 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i11 = i13 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i11;
  i4 = i12;
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  i9 = i8 + 4 | 0;
  i6 = i2;
  i2 = HEAP32[i11 >> 2] | 0;
  do {
   i4 = i2 + -16 | 0;
   i3 = i6;
   i6 = i6 + -16 | 0;
   i7 = HEAP8[i6 + 11 >> 0] | 0;
   i16 = i7 << 24 >> 24 < 0;
   i5 = i16 ? HEAP32[i6 >> 2] | 0 : i6;
   i7 = i16 ? HEAP32[i3 + -12 >> 2] | 0 : i7 & 255;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i2 + -4 >> 2] = i3;
   if (i7 >>> 0 > 2147483631) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    i10 = 7;
   } else if (i7 >>> 0 < 11) {
    HEAP8[i4 + 11 >> 0] = i7;
    if (!i7) i2 = i4; else {
     i2 = i4;
     i10 = 9;
    }
   } else i10 = 7;
   if ((i10 | 0) == 7) {
    i17 = i7 + 16 & -16;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i9 >> 2] = i3;
    i16 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i17, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i4 >> 2] = i16;
    HEAP32[i2 + -8 >> 2] = i17 | -2147483648;
    HEAP32[i2 + -12 >> 2] = i7;
    i2 = i16;
    i10 = 9;
   }
   if ((i10 | 0) == 9) {
    i10 = 0;
    _memcpy(i2 | 0, i5 | 0, i7 | 0) | 0;
   }
   HEAP8[i2 + i7 >> 0] = 0;
   i2 = (HEAP32[i11 >> 2] | 0) + -16 | 0;
   HEAP32[i11 >> 2] = i2;
  } while ((i6 | 0) != (i1 | 0));
  i3 = i11;
  i4 = i12;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i17 = i13 + 8 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 i14 = i12 + 8 | 0;
 i17 = i13 + 12 | 0;
 i16 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i16;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i15;
 return;
}

function __ZN9Animation4PlayEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i5 + 280 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 9;
  }
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
 }
 __ZN9Animation20BuildAnimationStatesEv(i5);
 i2 = HEAP32[i5 + 104 >> 2] | 0;
 i4 = HEAP32[i5 + 108 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) i7 = 18; else {
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i3 + 96 >> 2] | 0) == (i1 | 0)) {
    i7 = 13;
    break;
   }
  } while ((i2 | 0) != (i4 | 0));
  if ((i7 | 0) == 13) if (i3 | 0) if ((i6 | 0) == 1) {
   __ZN9Animation14QueueCrossFadeER14AnimationStatefii(i5, i3, Math_fround(0.0), 0, 0) | 0;
   i9 = 1;
   STACKTOP = i8;
   return i9 | 0;
  } else {
   __ZN9Animation9CrossFadeER14AnimationStatefib(i5, i3, Math_fround(0.0), i6, 1);
   i9 = 1;
   STACKTOP = i8;
   return i9 | 0;
  }
  if (!i5) i1 = 0; else i7 = 18;
 }
 if ((i7 | 0) == 18) i1 = HEAP32[i5 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 896346 | 0, 0, gb + 896407 | 0, 403, 4, i1, 0, 0);
 i9 = 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN8Material12UpdateHashesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i3 = i10;
 i7 = HEAP32[i1 + 100 >> 2] | 0;
 i6 = i7 + 164 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] & -3;
 i8 = i7 + 156 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i7 + 160 | 0;
 HEAP32[i9 >> 2] = 0;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i11 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9; else i3 = i1;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i10;
   return;
  } else i3 = i1;
 }
 if (!(HEAP8[i6 >> 0] & 1)) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[gb + 1166248 >> 2] | 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (!i1) i1 = i7 + 12 | 0; else {
  i11 = i7 + 12 | 0;
  HEAP32[i8 >> 2] = __ZNK9ShaderLab4Pass21ComputePassValuesHashERK16ShaderKeywordSetPK19ShaderPropertySheetRK17ShaderPassContextP6Shader(i1, i7 + 124 | 0, i11, i2, i3) | 0;
  i1 = i11;
 }
 i7 = i3 + 32 | 0;
 i11 = i2 + 36 | 0;
 i8 = __ZN9ShaderLab27ComputeStateBlockValuesHashERK13dynamic_arrayIiLj4EEPK19ShaderPropertySheetS6_((HEAP32[i7 >> 2] | 0) + 72 | 0, i1, i11) | 0;
 HEAP32[i9 >> 2] = i8;
 __ZN9ShaderLab9IntShader23CreateStateBlocksForKeyEjPK19ShaderPropertySheetS3_(HEAP32[i7 >> 2] | 0, i8, i1, i11);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc8ClothSim20clearCollisionShapesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i12 = i7 + 24 | 0;
 i11 = i7 + 16 | 0;
 i9 = i7 + 8 | 0;
 i1 = i7;
 i3 = HEAP32[i6 + 52 >> 2] | 0;
 i5 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i2 + 164 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i10 = HEAP32[i3 + 72 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[i2 + 168 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 mftCall_viiii(i8 | 0, i5 | 0, i4 | 0, i10 | 0, i2 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i2 + 180 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i8 = HEAP32[i3 + 80 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[i2 + 184 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 mftCall_viiii(i10 | 0, i5 | 0, i4 | 0, i8 | 0, i2 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i2 + 196 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i3 = HEAP32[i3 + 88 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[i2 + 204 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 mftCall_viiii(i8 | 0, i5 | 0, i4 | 0, i3 | 0, i2 | 0);
 i2 = i6 + 84 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 i2 = HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i6) | 0) + 1104 >> 2] | 0;
 i3 = i6 + 116 | 0;
 i4 = HEAP32[i6 + 120 >> 2] | 0;
 if (!i4) {
  HEAP32[i1 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE6resizeEjRKS5_(i3, 0, i1);
  STACKTOP = i7;
  return;
 }
 i5 = 0;
 do {
  __ZN5physx2Sc10NPhaseCore18removeClothOverlapEPNS0_8ClothSimEPKNS0_8ShapeSimE(i2, i6, HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i4 | 0));
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE6resizeEjRKS5_(i3, 0, i1);
 STACKTOP = i7;
 return;
}

function __ZN14EdgeCollider2D10SmartResetEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 16 | 0;
 i4 = i10;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__Z18CalculateLocalAABBRK10GameObjectP4AABB(i1, i3) | 0)) {
  STACKTOP = i10;
  return;
 }
 f2 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 if (!(f2 < Math_fround(.000050249997))) {
  f11 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(f11 - f2);
  f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f11 = Math_fround(f11 + f2);
  f2 = Math_fround(Math_fround(Math_fround(f14 - f13) + Math_fround(f14 + f13)) * Math_fround(.5));
  HEAPF32[i4 >> 2] = f12;
  HEAPF32[i4 + 4 >> 2] = f2;
  HEAPF32[i4 + 8 >> 2] = f11;
  HEAPF32[i4 + 12 >> 2] = f2;
  __ZN14EdgeCollider2D9SetPointsEPK8Vector2fj(i5, i4, 2) | 0;
  STACKTOP = i10;
  return;
 }
 i7 = i5 + 160 | 0;
 i8 = i5 + 176 | 0;
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i6 = i5 + 164 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
  HEAP32[i7 >> 2] = 0;
 } else i6 = i5 + 164 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i5 + 172 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 >> 2] = 1;
 i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 8, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i1 >> 2] = -1090519040;
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < 2) {
  i3 = i4 << 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i8 >> 2] = i3;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i3 << 3, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i7 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = 2;
 HEAP32[i1 + 8 >> 2] = 1056964608;
 HEAP32[i1 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN14AnimationEventaSERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i7 = i8 + 4 | 0;
 i1 = i9 + 4 | 0;
 do if ((i8 | 0) != (i9 | 0)) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i3 ? HEAP32[i9 + 8 >> 2] | 0 : i6 & 255;
  i3 = i7 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  do if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 8 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  } else {
   if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
   if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i3 >> 0] | 0) < 0) {
    HEAP32[i8 + 8 >> 2] = i6;
    break;
   } else {
    HEAP8[i3 >> 0] = i6;
    break;
   }
  } while (0);
  i1 = i8 + 20 | 0;
  i6 = i9 + 20 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i4 = i7 << 24 >> 24 < 0;
  i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i4 ? HEAP32[i9 + 24 >> 2] | 0 : i7 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 28 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i7 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 24 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 24 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 i7 = i8 + 36 | 0;
 i9 = i9 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 return i8 | 0;
}

function __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i1 = HEAP32[gb + 37304 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1048334 | 0, i1, i2, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i6 + 16 | 0;
    i3 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i4 = 19; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 19; else {
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i4 | 0) == 19) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
    if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i2 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  STACKTOP = i7;
  return;
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1048334 | 0, i1, i2, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i6 + 16 | 0;
    i3 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i3 >>> 0) i4 = 7; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 7; else {
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i4 | 0) == 7) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
    if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i2 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN10AudioMixer25FindGroupsWithPartialPathEPKcR13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EE(i2, i3, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i8 = i11;
 i1 = i7 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i7 + 4 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 i10 = i8 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZN5audio5mixer32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRNSt3__26vectorI9UnityGUIDNS6_9allocatorIS8_EEEE(HEAP32[i2 + 72 >> 2] | 0, i3, i8);
 i6 = i2 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 11;
  }
 }
 if ((i9 | 0) == 9) i9 = 11;
 if ((i9 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 __ZN15AudioMixerGroup27GetGroupInGUIDListRecursiveERKNSt3__26vectorI9UnityGUIDNS0_9allocatorIS2_EEEER13dynamic_arrayI4PPtrIS_ELj4EE(i1, i8, i7);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i10 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i3 + (~((i3 + -16 - i2 | 0) >>> 4) << 4);
  __ZdlPv(i1);
 }
 STACKTOP = i11;
 return;
}

function __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i12, i8, i6, i5, i1, i2, i3) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i7 = i13 + 24 | 0;
 i9 = i13 + 20 | 0;
 i10 = i13 + 8 | 0;
 if (!i12) {
  i12 = 37;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (!i3) {
  _memset(i7 + 4 | 0, 0, 132) | 0;
  HEAP32[i7 >> 2] = 136;
  if (!(i6 & 65536)) HEAP32[i7 + 72 >> 2] = 8;
  HEAP32[i7 + 8 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i1;
  i3 = i7;
 }
 if (!i5) i1 = __Z18GetAudioManagerPtrv() | 0; else i1 = i5;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(128, gb + 63328 | 0, 16, gb + 853741 | 0, 858) | 0;
 __ZN11SoundHandle8InstanceC2Ev(i1);
 HEAP32[i12 >> 2] = i1;
 HEAP32[i1 + 44 >> 2] = 2 - (i6 >>> 16 & 1);
 HEAP32[i1 + 48 >> 2] = i6;
 HEAP32[i1 + 52 >> 2] = i5;
 HEAP32[i3 + 68 >> 2] = (HEAP32[i12 >> 2] | 0) + 12;
 HEAP32[i9 >> 2] = 0;
 i1 = __ZN4FMOD6System11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i8, i6, i3, i9) | 0;
 if ((i1 | 0) == 25) {
  HEAP32[i7 + 72 >> 2] = 0;
  i1 = __ZN4FMOD6System11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i8, i6, i3, i9) | 0;
 }
 if (!i1) {
  HEAP32[(HEAP32[i12 >> 2] | 0) + 36 >> 2] = HEAP32[i9 >> 2];
  HEAP32[(HEAP32[i12 >> 2] | 0) + 40 >> 2] = 0;
  i1 = 0;
 } else {
  i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i11 >> 2] = i8;
  HEAP32[i11 + 4 >> 2] = i2;
  __Z6FormatPKcz(i10, gb + 853818 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 853741 | 0, 878, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i2 = HEAP32[i12 >> 2] | 0;
  if (i2 | 0) __ZN11SoundHandle8InstanceD2Ev(i2);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 if (i4) __Z19pop_allocation_rootv();
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_(i5, i1, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 16 | 0;
 i17 = HEAP32[i1 >> 2] | 0;
 f9 = Math_fround((i17 & 255) >>> 0);
 i16 = HEAP32[i1 + 4 >> 2] | 0;
 f8 = Math_fround((i16 & 255) >>> 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 f7 = Math_fround((i1 & 255) >>> 0);
 f15 = (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + 4 >> 2] & -256, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = Math_fround(Math_fround(f9 * f15) * Math_fround(.0000999999974));
 f8 = Math_fround(Math_fround(f8 * f15) * Math_fround(.0000999999974));
 f7 = Math_fround(Math_fround(f15 * f7) * Math_fround(.0000999999974));
 f15 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f15 - f9);
 f14 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(f14 - f8);
 f13 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(f13 - f7);
 f9 = Math_fround(f15 + f9);
 f8 = Math_fround(f14 + f8);
 f7 = Math_fround(f13 + f7);
 HEAPF32[i2 >> 2] = f12;
 HEAPF32[i2 + 4 >> 2] = f11;
 HEAPF32[i2 + 8 >> 2] = f10;
 HEAPF32[i2 + 12 >> 2] = f9;
 HEAPF32[i2 + 16 >> 2] = f8;
 HEAPF32[i2 + 20 >> 2] = f7;
 HEAP8[i2 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i4, i2) | 0;
 i1 = i3;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 & 1 | 0) == 0 & 0 == 0)) {
  STACKTOP = i6;
  return;
 }
 i17 = _bitshift64Lshr(i2 | 0, HEAP32[i1 + 4 >> 2] | 0, 21) | 0;
 getTempRet0() | 0;
 __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_(i5, i5 + ((i17 & 524287) * 24 | 0) | 0, i4);
 i17 = i3;
 i17 = _bitshift64Lshr(HEAP32[i17 >> 2] | 0, HEAP32[i17 + 4 >> 2] | 0, 21) | 0;
 getTempRet0() | 0;
 i17 = i17 & 524287;
 __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_(i5, i17 | 0 ? i5 + ((i17 + 1 | 0) * 24 | 0) | 0 : i5, i4);
 STACKTOP = i6;
 return;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi(i12, i13) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18;
 if ((i13 | 0) == -1) {
  i17 = 0;
  STACKTOP = i18;
  return i17 | 0;
 }
 i14 = i12 + 12 | 0;
 i15 = i12 + 8 | 0;
 i16 = (HEAP32[i14 >> 2] | 0) - (HEAP32[i15 >> 2] | 0) | 0;
 i17 = i12 + 24 | 0;
 i7 = HEAP32[i17 >> 2] | 0;
 i9 = i12 + 28 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i7 | 0) == (i1 | 0)) {
  i6 = i12 + 48 | 0;
  if (!(HEAP32[i6 >> 2] & 16)) {
   i17 = -1;
   STACKTOP = i18;
   return i17 | 0;
  }
  i4 = i12 + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i10 = i12 + 44 | 0;
  i8 = (HEAP32[i10 >> 2] | 0) - i5 | 0;
  i3 = i12 + 32 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i3, 0);
  i1 = i3 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) i2 = (HEAP32[i12 + 40 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i3, i2, 0);
  i1 = HEAP8[i1 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i12 + 36 >> 2] | 0;
  } else {
   i2 = i3;
   i1 = i1 & 255;
  }
  i1 = i2 + i1 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i7 = i2 + (i7 - i5) | 0;
  HEAP32[i17 >> 2] = i7;
  i2 = i2 + i8 | 0;
  HEAP32[i10 >> 2] = i2;
  i8 = i10;
  i3 = i10;
  i5 = i1;
 } else {
  i2 = i12 + 44 | 0;
  i8 = i2;
  i6 = i12 + 48 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i5 = i1;
 }
 i4 = i7 + 1 | 0;
 HEAP32[i11 >> 2] = i4;
 i2 = HEAP32[(i4 >>> 0 < i2 >>> 0 ? i3 : i11) >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 if (HEAP32[i6 >> 2] & 8 | 0) {
  i1 = i12 + 32 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i14 >> 2] = i1 + i16;
  HEAP32[i12 + 16 >> 2] = i2;
 }
 if ((i7 | 0) == (i5 | 0)) {
  i17 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 52 >> 2] | 0, i12 | 0, i13 & 255 | 0) | 0;
  STACKTOP = i18;
  return i17 | 0;
 } else {
  HEAP32[i17 >> 2] = i4;
  HEAP8[i7 >> 0] = i13;
  i17 = i13 & 255;
  STACKTOP = i18;
  return i17 | 0;
 }
 return 0;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i9, 3);
 i2 = i9 + 4 | 0;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i5;
 i8 = i1;
 if ((i1 + 8 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i6 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 + 8 >> 2] = i6;
   }
   i1 = HEAP32[i9 + 24 >> 2] | 0;
  } else {
   i1 = i6 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i8 - i5 | 0;
  i8 = i5 + 8 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 8;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 123;
  return 1;
 }
 return 0;
}

function __ZN9Transform24MakeEditorValuesLookNiceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 20 | 0;
 i12 = i15;
 i13 = i15 + 8 | 0;
 i11 = i1 + 32 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i10;
 i4 = i1 + 8 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i8 + (i11 * 40 | 0) >> 2]);
 f18 = Math_fround(HEAPF32[i8 + (i11 * 40 | 0) + 4 >> 2]);
 __ZL14MakeNiceFloat3RKN4math7_float3E(i14, f17, f18, Math_fround(HEAPF32[i8 + (i11 * 40 | 0) + 8 >> 2]));
 i8 = HEAP32[i4 >> 2] | 0;
 f18 = Math_fround(HEAPF32[i14 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 i6 = i8 + (i11 * 40 | 0) | 0;
 f20 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i8 + (i11 * 40 | 0) + 4 | 0;
 f19 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i8 + (i11 * 40 | 0) + 8 | 0;
 i9 = f18 != f20 | f17 != f19 | f16 != Math_fround(HEAPF32[i8 >> 2]);
 HEAPF32[i6 >> 2] = f18;
 HEAPF32[i7 >> 2] = f17;
 HEAPF32[i8 >> 2] = f16;
 if (i9) {
  i5 = HEAP32[i1 + 40 >> 2] | 0;
  i6 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  if (i6 | 0) {
   i7 = HEAP32[i1 + 60 >> 2] | 0;
   i8 = HEAP32[i1 + 56 >> 2] | 0;
   i9 = i1 + 36 | 0;
   i3 = HEAP32[i1 + 68 >> 2] | 0;
   i1 = 0;
   i2 = i11;
   while (1) {
    i21 = HEAP32[i7 + (i2 << 2) >> 2] & i5;
    i22 = i8 + (i2 << 2) | 0;
    HEAP32[i22 >> 2] = HEAP32[i22 >> 2] | i21;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i21;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i6 | 0)) break; else i2 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   }
  }
 }
 i22 = i12;
 HEAP32[i22 >> 2] = i10;
 HEAP32[i22 + 4 >> 2] = i11;
 i22 = HEAP32[i4 >> 2] | 0;
 f19 = Math_fround(HEAPF32[i22 + (i11 * 40 | 0) + 28 >> 2]);
 f20 = Math_fround(HEAPF32[i22 + (i11 * 40 | 0) + 32 >> 2]);
 __ZL14MakeNiceFloat3RKN4math7_float3E(i13, f19, f20, Math_fround(HEAPF32[i22 + (i11 * 40 | 0) + 36 >> 2]));
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __Z9SetLocalS15TransformAccessRKN4math7_float3E(i14, i13) | 0;
 STACKTOP = i15;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i3, i6, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i3 = i3 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i5 = i1 + (i2 << 3) | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i8 >> 2] = i2;
   i2 = i6;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14dtPathCorridor18moveTargetPositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i14, i1, i15, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i20 + 136 | 0;
 i13 = i20;
 i3 = i20 + 132 | 0;
 i18 = i20 + 128 | 0;
 HEAP32[i3 >> 2] = 0;
 i19 = i14 + 32 | 0;
 i12 = i14 + 28 | 0;
 i11 = (HEAP32[i12 >> 2] | 0) + ((HEAP32[i19 >> 2] | 0) + -1 << 3) | 0;
 i16 = i14 + 12 | 0;
 if ((__ZNK14dtNavMeshQuery16moveAlongSurfaceEyPKfS1_PK13dtQueryFilterPfPyPii(i15, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i16, i1, i2, i17, i13, i3, 16) | 0) < 0) {
  i19 = i14 + 44 | 0;
  HEAP8[i19 >> 0] = (HEAPU8[i19 >> 0] | 0) & 254;
  STACKTOP = i20;
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i19 >> 2] | 0;
 i11 = HEAP32[i14 + 36 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) > 0 & (i10 | 0) > 0) {
  i4 = -1;
  i3 = -1;
  i7 = 0;
  do {
   i9 = i1 + (i7 << 3) | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i5 = i10;
   i6 = 0;
   do {
    i21 = i5;
    i5 = i5 + -1 | 0;
    i22 = i13 + (i5 << 3) | 0;
    i22 = (i8 | 0) == (HEAP32[i22 >> 2] | 0) ? (i9 | 0) == (HEAP32[i22 + 4 >> 2] | 0) : 0;
    i6 = i6 | i22;
    i3 = i22 ? i5 : i3;
    i4 = i22 ? i7 : i4;
   } while ((i21 | 0) > 1);
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) < (i2 | 0) & (i6 ^ 1));
  if (!((i3 | 0) == -1 | (i4 | 0) == -1)) {
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
   i22 = i10 - i3 | 0;
   i2 = i11 - i4 | 0;
   i2 = (i22 | 0) < (i2 | 0) ? i22 : i2;
   if (i2) {
    _memcpy(i1 + (i4 << 3) | 0, i13 + (i3 << 3) | 0, i2 << 3 | 0) | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
   i2 = i2 + i4 | 0;
  }
 }
 HEAP32[i19 >> 2] = i2;
 i22 = i14 + 16 | 0;
 HEAP32[i18 >> 2] = HEAP32[i22 >> 2];
 i21 = i1 + (i2 + -1 << 3) | 0;
 __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i15, HEAP32[i21 >> 2] | 0, HEAP32[i21 + 4 >> 2] | 0, i17, i18) | 0;
 i21 = HEAP32[i18 >> 2] | 0;
 HEAP32[i17 + 4 >> 2] = i21;
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i22 >> 2] = i21;
 HEAP32[i14 + 20 >> 2] = HEAP32[i17 + 8 >> 2];
 STACKTOP = i20;
 return;
}

function __ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_(i3, i2, i5, i4, f1, i7, i6) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 i7 = i7 | 0;
 i6 = i6 | 0;
 var f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(Math_abs(Math_fround(f14)));
 i15 = f13 > Math_fround(9.99999971e-10);
 f13 = i15 ? f13 : Math_fround(9.99999971e-10);
 i15 = f14 >= Math_fround(0.0);
 f13 = Math_fround(Math_fround(1.0) / Math_fround((i15 ? Math_fround(1.0) : Math_fround(-1.0)) * f13));
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f13 * Math_fround(f14 - f11));
 f11 = Math_fround(f13 * Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f11));
 f13 = f14 < f11 ? f14 : f11;
 f11 = f14 > f11 ? f14 : f11;
 f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(Math_abs(Math_fround(f14)));
 i15 = f12 > Math_fround(9.99999971e-10);
 f12 = i15 ? f12 : Math_fround(9.99999971e-10);
 i15 = f14 >= Math_fround(0.0);
 f12 = Math_fround(Math_fround(1.0) / Math_fround((i15 ? Math_fround(1.0) : Math_fround(-1.0)) * f12));
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f14 = Math_fround(f12 * Math_fround(f14 - f10));
 f10 = Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) - f10));
 f12 = f14 < f10 ? f14 : f10;
 f10 = f14 > f10 ? f14 : f10;
 f14 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f9 = Math_fround(Math_abs(Math_fround(f14)));
 i4 = f9 > Math_fround(9.99999971e-10);
 f9 = i4 ? f9 : Math_fround(9.99999971e-10);
 i4 = f14 >= Math_fround(0.0);
 f9 = Math_fround(Math_fround(1.0) / Math_fround((i4 ? Math_fround(1.0) : Math_fround(-1.0)) * f9));
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(f9 * Math_fround(f14 - f8));
 f8 = Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f8));
 f9 = f14 < f8 ? f14 : f8;
 f8 = f14 > f8 ? f14 : f8;
 f12 = f13 > f12 ? f13 : f12;
 f9 = f12 > f9 ? f12 : f9;
 f10 = f11 < f10 ? f11 : f10;
 f8 = f10 < f8 ? f10 : f8;
 i5 = f9 > Math_fround(0.0);
 HEAPF32[i7 >> 2] = i5 ? f9 : Math_fround(0.0);
 f1 = f8 < f1 ? f8 : f1;
 HEAPF32[i6 >> 2] = f1;
 return Math_fround(HEAPF32[i7 >> 2]) < f1 | 0;
}

function __ZN5physx20InternalTriangleMesh15importExtraDataERNS_24PxDeserializationContextE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i9 + 16 | 0;
 __ZN5physx2Gu13RTreeMidphase15importExtraDataERNS_24PxDeserializationContextE(i7, i8);
 i1 = i9 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) i6 = 0; else {
  i5 = i8 + 4 | 0;
  i4 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
  i6 = i4;
  HEAP32[i5 >> 2] = i4 + ((HEAP32[i9 >> 2] | 0) * 12 | 0);
  HEAP32[i1 >> 2] = i6;
 }
 i1 = i9 + 12 | 0;
 do if (!(HEAP32[i1 >> 2] | 0)) i4 = 0; else {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i8 + 4 | 0;
  i4 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
  i5 = i4;
  if (!(HEAP8[i9 + 156 >> 0] & 2)) {
   HEAP32[i3 >> 2] = i5 + (i2 * 12 | 0);
   HEAP32[i1 >> 2] = i4;
   break;
  } else {
   HEAP32[i3 >> 2] = i5 + (i2 * 6 | 0);
   HEAP32[i1 >> 2] = i4;
   break;
  }
 } while (0);
 i1 = i9 + 152 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i8 + 4 | 0;
  i5 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
  HEAP32[i3 >> 2] = i5 + (HEAP32[i9 + 4 >> 2] | 0);
  HEAP32[i1 >> 2] = i5;
 }
 i1 = i9 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i8 + 4 | 0;
  i5 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
  HEAP32[i3 >> 2] = i5 + (HEAP32[i9 + 4 >> 2] << 1);
  HEAP32[i1 >> 2] = i5;
 }
 i1 = i9 + 164 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i8 + 4 | 0;
  i5 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
  HEAP32[i3 >> 2] = i5 + (HEAP32[i9 + 4 >> 2] << 2);
  HEAP32[i1 >> 2] = i5;
 }
 i2 = i9 + 168 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i8 = i9 + 180 | 0;
  HEAP32[i7 >> 2] = i8;
  i5 = HEAP32[i9 >> 2] | 0;
  i7 = i9 + 184 | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i1;
  i9 = i9 + 156 | 0;
  i9 = HEAP8[i9 >> 0] | 0;
  i9 = i9 & 2;
  i9 = i9 << 24 >> 24 != 0;
  __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E(i8, i4, i9, i6) | 0;
  return;
 }
 i5 = i8 + 4 | 0;
 i8 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 HEAP32[i5 >> 2] = i8 + (i1 * 12 | 0);
 HEAP32[i2 >> 2] = i8;
 i8 = i9 + 180 | 0;
 HEAP32[i7 >> 2] = i8;
 i5 = HEAP32[i9 >> 2] | 0;
 i7 = i9 + 184 | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = i1;
 i9 = i9 + 156 | 0;
 i9 = HEAP8[i9 >> 0] | 0;
 i9 = i9 & 2;
 i9 = i9 << 24 >> 24 != 0;
 __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E(i8, i4, i9, i6) | 0;
 return;
}

function __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i3, i4, i5, i8, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i2 = HEAP32[i3 + 916 >> 2] | 0;
 if (HEAP8[i2 + 4 >> 0] | 0) {
  i10 = HEAP32[i8 + 12 >> 2] | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 + 12 >> 2] = i11;
  HEAP32[i1 + 8 >> 2] = i11;
  HEAP32[i1 + 4 >> 2] = i11;
  HEAP32[i1 >> 2] = i11;
  __ZNK9SubModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i2, i4, i5, i8, i6, i10, i1);
 }
 i1 = HEAP32[i3 + 904 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN15CollisionModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i1, i4, i5, i8, i6, i7);
 i1 = HEAP32[i3 + 912 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN13TriggerModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i1, i4, i5, i8, i6, i7);
 i1 = HEAP32[i3 + 920 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) __ZN12LightsModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK14ParticleSystem(i1, i4, i5, i8, i3);
 i1 = HEAP32[i3 + 908 >> 2] | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) {
  __ZN11TrailModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjRKf(i1, i4, i5, i8, i6, i7);
  STACKTOP = i9;
  return;
 }
 i3 = i8 + 824 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i4 = i8 + 772 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i5 = HEAP32[i8 + 760 >> 2] | 0;
 i6 = HEAP32[i8 + 780 >> 2] | 0;
 i2 = HEAP32[i8 + 800 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 > 1) i1 = 1; else {
  STACKTOP = i9;
  return;
 }
 do {
  HEAP32[i5 + (i1 << 2) >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  HEAP32[i6 + (i1 << 2) >> 2] = 0;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __ZN12LightsModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK14ParticleSystem(i13, i3, i4, i11, i12) {
 i13 = i13 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 4 | 0;
 i2 = i14;
 i5 = i4 + 452 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = i13 + 584 | 0;
  i3 = i13 + 576 | 0;
  i1 = i13 + 580 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   STACKTOP = i14;
   return;
  }
  i13 = HEAP32[i4 >> 2] | 0;
  HEAP32[i13 + 4 >> 2] = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i13;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i3 >> 2] = i3;
  STACKTOP = i14;
  return;
 }
 if ((HEAP16[gb + 1451716 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451716 | 0, i1);
  i8 = gb + 1451716 | 0;
 } else i8 = 0;
 i9 = i13 + 584 | 0;
 i10 = i13 + 576 | 0;
 i1 = i13 + 580 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i10 | 0)) {
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 + 4 >> 2] = i2;
  HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 >> 2] = i7;
  HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] = i9;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i10 >> 2] = i10;
 }
 i7 = (HEAP32[i3 + 280 >> 2] | 0) == 1 ? gb + 1162292 | 0 : i4 + 52 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i13 + 20 >> 2] | 0;
 i3 = (i5 & 255) << 24 >> 24 != 0;
 i4 = (i5 & 65280 | 0) != 0;
 i5 = (i5 & 16711680 | 0) != 0;
 i6 = i13 + 24 | 0;
 i1 = i13 + 288 | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) == 2) __Z15UpdateLightsTplILb0EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem(i10, i9, i2, i3, i4, i5, i6, i1, i7, i11, i12); else __Z15UpdateLightsTplILb1EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem(i10, i9, i2, i3, i4, i5, i6, i1, i7, i11, i12);
 if (!i8) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i14;
 return;
}

function __ZN9TextAsset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10);
 i6 = i8 + 48 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 52 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i11 = i10 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i8 + 32 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 36 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (!i9) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i13;
 return;
}

function __ZN9ShaderLab28UpdateGlobalShaderPropertiesEf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i13 = __Z14GetTimeManagerv() | 0;
 f4 = Math_fround(+HEAPF64[i13 + 96 >> 3] + +HEAPF64[i13 + 168 >> 3]);
 i14 = !(f1 >= Math_fround(0.0));
 f4 = i14 ? f4 : f1;
 f5 = Math_fround(HEAPF32[i13 + 112 >> 2]);
 i14 = f5 < Math_fround(.00499999989);
 i15 = f5 > Math_fround(.200000003);
 f5 = i15 ? Math_fround(.200000003) : f5;
 f5 = i14 ? Math_fround(.00499999989) : f5;
 f3 = Math_fround(HEAPF32[i13 + 116 >> 2]);
 i13 = f3 < Math_fround(.00499999989);
 i14 = f3 > Math_fround(.200000003);
 f3 = i14 ? Math_fround(.200000003) : f3;
 f3 = i13 ? Math_fround(.00499999989) : f3;
 f6 = Math_fround(f4 * Math_fround(2.0));
 f1 = Math_fround(f4 * Math_fround(3.0));
 HEAPF32[i2 + 1124 >> 2] = Math_fround(f4 * Math_fround(.0500000007));
 HEAPF32[i2 + 1128 >> 2] = f4;
 HEAPF32[i2 + 1132 >> 2] = f6;
 HEAPF32[i2 + 1136 >> 2] = f1;
 f10 = Math_fround(f4 * Math_fround(.125));
 f9 = Math_fround(f4 * Math_fround(.25));
 f12 = Math_fround(+Math_sin(+f9));
 f8 = Math_fround(f4 * Math_fround(.5));
 f11 = Math_fround(+Math_sin(+f8));
 f7 = Math_fround(+Math_sin(+f4));
 HEAPF32[i2 + 1140 >> 2] = Math_fround(+Math_sin(+f10));
 HEAPF32[i2 + 1144 >> 2] = f12;
 HEAPF32[i2 + 1148 >> 2] = f11;
 HEAPF32[i2 + 1152 >> 2] = f7;
 f9 = Math_fround(+Math_cos(+f9));
 f8 = Math_fround(+Math_cos(+f8));
 f7 = Math_fround(+Math_cos(+f4));
 HEAPF32[i2 + 1156 >> 2] = Math_fround(+Math_cos(+f10));
 HEAPF32[i2 + 1160 >> 2] = f9;
 HEAPF32[i2 + 1164 >> 2] = f8;
 HEAPF32[i2 + 1168 >> 2] = f7;
 f7 = Math_fround(_fmodf(f4, Math_fround(3.14159274)));
 f6 = Math_fround(_fmodf(f6, Math_fround(3.14159274)));
 f1 = Math_fround(_fmodf(f1, Math_fround(3.14159274)));
 f4 = Math_fround(_fmodf(Math_fround(f4 * Math_fround(4.0)), Math_fround(3.14159274)));
 HEAPF32[i2 + 1172 >> 2] = f7;
 HEAPF32[i2 + 1176 >> 2] = f6;
 HEAPF32[i2 + 1180 >> 2] = f1;
 HEAPF32[i2 + 1184 >> 2] = f4;
 f4 = Math_fround(Math_fround(1.0) / f5);
 f1 = Math_fround(Math_fround(1.0) / f3);
 HEAPF32[i2 + 1188 >> 2] = f5;
 HEAPF32[i2 + 1192 >> 2] = f4;
 HEAPF32[i2 + 1196 >> 2] = f3;
 HEAPF32[i2 + 1200 >> 2] = f1;
 return;
}

function __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i9 + 8 | 0;
 i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 16, 0, i2, i7) | 0;
 i6 = i7;
 if (!(i5 & ((HEAP32[i6 >> 2] | 0) == 16 & (HEAP32[i6 + 4 >> 2] | 0) == 0))) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = __ZN12FileAccessor4ReadEyPvPy(i8, 4, 0, i1, i7) | 0;
 i6 = i7;
 L4 : do if (i5 & ((HEAP32[i6 >> 2] | 0) == 4 & (HEAP32[i6 + 4 >> 2] | 0) == 0)) {
  i5 = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  i4 = i2 + 16 | 0;
  i6 = i2 + 20 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = (i1 - i2 | 0) / 12 | 0;
  if (i5 >>> 0 > i3 >>> 0) {
   __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i4, i5 - i3 | 0);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } else if (i5 >>> 0 < i3 >>> 0) {
   i3 = i2 + (i5 * 12 | 0) | 0;
   if ((i1 | 0) != (i3 | 0)) {
    i1 = i1 + (~(((i1 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
   }
  }
  if ((i2 | 0) == (i1 | 0)) i1 = 0; else while (1) {
   i4 = __ZN12FileAccessor4ReadEyPvPy(i8, 4, 0, i2, i7) | 0;
   i5 = i7;
   if (!(i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0))) {
    i1 = 1;
    break L4;
   }
   HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
   i1 = i2 + 4 | 0;
   i4 = __ZN12FileAccessor4ReadEyPvPy(i8, 4, 0, i1, i7) | 0;
   i5 = i7;
   if (!(i4 & ((HEAP32[i5 >> 2] | 0) == 4 & (HEAP32[i5 + 4 >> 2] | 0) == 0))) {
    i1 = 1;
    break L4;
   }
   HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
   i1 = i2 + 8 | 0;
   i4 = __ZN12FileAccessor4ReadEyPvPy(i8, 2, 0, i1, i7) | 0;
   i5 = i7;
   if (!(i4 & ((HEAP32[i5 >> 2] | 0) == 2 & (HEAP32[i5 + 4 >> 2] | 0) == 0))) {
    i1 = 1;
    break L4;
   }
   HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
   i2 = i2 + 12 | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    i1 = 0;
    break;
   }
  }
 } else i1 = 1; while (0);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN16StreamedResource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i1, i8, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i1);
 i10 = i1 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i2 + 8 | 0;
 i7 = i1 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i6 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 8);
  i5 = i9 + 4 | 0;
  i1 = i9;
  i2 = i5;
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = i2;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i5;
  HEAP32[i10 >> 2] = i6;
  i1 = i9;
  i2 = i9 + 4 | 0;
 }
 i7 = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i5 | 0) | 0;
 HEAP32[i2 >> 2] = i7;
 i7 = i9;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i8 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i8 + 24 | 0;
 i2 = i6 + 8 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 8);
  i6 = i9 + 4 | 0;
  i8 = i9;
  i7 = i6;
  i10 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i10;
  i7 = i9;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i9 + 4 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i1;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 } else {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i9;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i10 >> 2] = i2;
  i8 = i9;
  i7 = i9 + 4 | 0;
  i10 = i5;
  i10 = _llvm_bswap_i32(i10 | 0) | 0;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i10;
  i7 = i9;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i9 + 4 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i1;
  i8 = i10;
  HEAP32[i8 >> 2] = i7;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
}

function _UNITY_tt_face_load_strike_metrics(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 if ((HEAP32[i4 + 736 >> 2] | 0) >>> 0 <= i1 >>> 0) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 }
 switch (HEAP32[i4 + 732 >> 2] | 0) {
 case 2:
 case 1:
  {
   i6 = (HEAP32[i4 + 724 >> 2] | 0) + 8 + (i1 * 48 | 0) | 0;
   HEAP16[i5 >> 1] = HEAPU8[i6 + 44 >> 0] | 0;
   HEAP16[i5 + 2 >> 1] = HEAPU8[i6 + 45 >> 0] | 0;
   i3 = HEAP8[i6 + 16 >> 0] << 6;
   HEAP32[i5 + 12 >> 2] = i3;
   i4 = HEAP8[i6 + 17 >> 0] << 6;
   HEAP32[i5 + 16 >> 2] = i4;
   HEAP32[i5 + 20 >> 2] = i3 - i4;
   HEAP32[i5 + 24 >> 2] = (HEAPU8[i6 + 18 >> 0] | 0) + (HEAP8[i6 + 22 >> 0] | 0) + (HEAP8[i6 + 23 >> 0] | 0) << 6;
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 3:
  {
   i6 = HEAP32[i4 + 104 >> 2] | 0;
   i2 = (HEAP32[i4 + 724 >> 2] | 0) + 8 + (i1 << 2) + 4 + -4 | 0;
   i2 = HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
   i1 = mftCall_iiiii(HEAP32[i4 + 508 >> 2] | 0, i4 | 0, 1935829368, i6 | 0, i3 | 0) | 0;
   if (!i1) if ((i2 + 4 | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) i1 = 3; else {
    i1 = _UNITY_FT_Stream_Seek(i6, (_UNITY_FT_Stream_Pos(i6) | 0) + i2 | 0) | 0;
    if (!i1) {
     i1 = _UNITY_FT_Stream_EnterFrame(i6, 4) | 0;
     if (!i1) {
      i3 = _UNITY_FT_Stream_GetUShort(i6) | 0;
      _UNITY_FT_Stream_GetUShort(i6) | 0;
      _UNITY_FT_Stream_ExitFrame(i6);
      i1 = HEAPU16[i4 + 178 >> 1] | 0;
      HEAP16[i5 >> 1] = i3;
      HEAP16[i5 + 2 >> 1] = i3;
      i2 = HEAP32[i4 + 220 >> 2] | 0;
      i8 = i2 << 16 >> 16;
      i3 = (i3 & 65535) << 6;
      HEAP32[i5 + 12 >> 2] = (Math_imul(i3, i8) | 0) / (i1 | 0) | 0;
      i2 = i2 >> 16;
      HEAP32[i5 + 16 >> 2] = (Math_imul(i3, i2) | 0) / (i1 | 0) | 0;
      i6 = HEAP32[i4 + 224 >> 2] | 0;
      HEAP32[i5 + 20 >> 2] = (Math_imul(i3, i8 - i2 + (i6 << 16 >> 16) | 0) | 0) / (i1 | 0) | 0;
      HEAP32[i5 + 24 >> 2] = (Math_imul(i3, i6 >>> 16) | 0) / (i1 | 0) | 0;
      i1 = 0;
     }
    }
   }
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 default:
  {
   i8 = 2;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 return 0;
}

function _Line_Up(i11, i4, i2, i1, i6, i3, i7) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i5 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i1 - i4 | 0;
 i13 = i6 - i2 | 0;
 if ((i13 | 0) < 1 | (i6 | 0) < (i3 | 0) | (i2 | 0) > (i7 | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 if ((i3 | 0) > (i2 | 0)) {
  i4 = (_UNITY_FT_MulDiv(i12, i3 - i2 | 0, i13) | 0) + i4 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i9 = 0;
  i5 = i3 >> i2;
 } else {
  i10 = HEAP32[i11 >> 2] | 0;
  i9 = (HEAP32[i11 + 4 >> 2] | 0) + -1 & i2;
  i5 = i2 >> i10;
  i2 = i10;
 }
 if ((i6 | 0) > (i7 | 0)) {
  i8 = 0;
  i1 = i7;
 } else {
  i8 = (HEAP32[i11 + 4 >> 2] | 0) + -1 & i6;
  i1 = i6;
 }
 i3 = i1 >> i2;
 do if ((i9 | 0) > 0) if ((i5 | 0) == (i3 | 0)) {
  i13 = 0;
  return i13 | 0;
 } else {
  i2 = i5 + 1 | 0;
  i4 = (_UNITY_FT_MulDiv(i12, (HEAP32[i11 + 4 >> 2] | 0) - i9 | 0, i13) | 0) + i4 | 0;
  i1 = i11 + 87 | 0;
  break;
 } else {
  i1 = i11 + 87 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) i2 = i5; else {
   i2 = i11 + 40 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -4;
   HEAP8[i1 >> 0] = 0;
   i2 = i5;
  }
 } while (0);
 HEAP8[i1 >> 0] = (i8 | 0) == 0 & 1;
 i1 = i11 + 86 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  HEAP32[(HEAP32[i11 + 88 >> 2] | 0) + 20 >> 2] = i2;
  HEAP8[i1 >> 0] = 0;
 }
 i3 = i3 - i2 | 0;
 i6 = i3 + 1 | 0;
 i10 = i11 + 40 | 0;
 if (((HEAP32[i10 >> 2] | 0) + (i6 << 2) | 0) >>> 0 >= (HEAP32[i11 + 36 >> 2] | 0) >>> 0) {
  HEAP32[i11 + 44 >> 2] = 98;
  i13 = 1;
  return i13 | 0;
 }
 i2 = i11 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i12 | 0) > 0) {
  i8 = _UNITY_FT_MulDiv_No_Round(i1, i12, i13) | 0;
  i9 = 1;
  i1 = Math_imul(HEAP32[i2 >> 2] | 0, i12) | 0;
 } else {
  i12 = 0 - i12 | 0;
  i8 = 0 - (_UNITY_FT_MulDiv_No_Round(i1, i12, i13) | 0) | 0;
  i9 = -1;
  i1 = Math_imul(HEAP32[i2 >> 2] | 0, i12) | 0;
 }
 i7 = (i1 | 0) % (i13 | 0) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i3 | 0) > -1) {
  i5 = 0 - i13 | 0;
  while (1) {
   i2 = i1 + 4 | 0;
   HEAP32[i1 >> 2] = i4;
   i1 = i5 + i7 | 0;
   i3 = (i1 | 0) > -1;
   if ((i6 | 0) > 1) {
    i5 = i1 - (i3 ? i13 : 0) | 0;
    i6 = i6 + -1 | 0;
    i1 = i2;
    i4 = i4 + i8 + (i3 ? i9 : 0) | 0;
   } else {
    i1 = i2;
    break;
   }
  }
 }
 HEAP32[i10 >> 2] = i1;
 i13 = 0;
 return i13 | 0;
}

function __ZN5physx16PxVehicleDriveNWC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP16[i3 + 4 >> 1] = 514;
 HEAP16[i3 + 6 >> 1] = 3;
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(.230800003);
 HEAPF32[i3 + 16 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(.333333343);
 HEAP32[i3 >> 2] = gb + 159216 + 8;
 __ZN5physx21PxVehicleDriveDynDataC2Ev(i3 + 128 | 0);
 HEAP32[i3 >> 2] = gb + 159296 + 8;
 HEAPF32[i3 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 308 >> 2] = Math_fround(500.0);
 HEAPF32[i3 + 312 >> 2] = Math_fround(600.0);
 HEAPF32[i3 + 316 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 320 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 324 >> 2] = Math_fround(.349999994);
 HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 228 >> 2] = Math_fround(.800000011);
 HEAPF32[i3 + 232 >> 2] = Math_fround(.330000013);
 HEAPF32[i3 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 240 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 244 >> 2] = Math_fround(.800000011);
 HEAP32[i3 + 288 >> 2] = 3;
 HEAPF32[i3 + 328 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 332 >> 2] = Math_fround(.00166666671);
 HEAPF32[i3 + 464 >> 2] = Math_fround(4.0);
 HEAP32[i3 + 468 >> 2] = 7;
 HEAPF32[i3 + 472 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 336 >> 2] = Math_fround(-4.0);
 HEAPF32[i3 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 344 >> 2] = Math_fround(4.0);
 HEAPF32[i3 + 348 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 352 >> 2] = Math_fround(1.5);
 HEAPF32[i3 + 356 >> 2] = Math_fround(1.10000002);
 HEAPF32[i3 + 360 >> 2] = Math_fround(1.0);
 i1 = i3 + 364 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i3 + 480 >> 2] = Math_fround(10.0);
 HEAP32[i3 + 484 >> 2] = 1;
 HEAP32[i3 + 488 >> 2] = 5;
 i1 = 0;
 do {
  HEAPF32[i3 + 496 + (i1 << 2) >> 2] = Math_fround(.649999976);
  HEAPF32[i3 + 624 + (i1 << 2) >> 2] = Math_fround(.5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAPF32[i3 + 500 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 624 >> 2] = Math_fround(2.0);
 i2 = i3 + 752 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 HEAP32[i3 + 756 >> 2] = 0;
 HEAPF32[i3 + 760 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5Umbra15KDTraverseStackINS_10NoUserDataEE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbS1_S1_(i8, i9, f10, i3, i1, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = (i9 | 0) == 3;
 i6 = i1 & 1;
 i7 = i8 + 28 | 0;
 if (i1) {
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = i8 + 32 + ((i4 + 1 | 0) * 40 | 0) | 0;
  i4 = i8 + 32 + (i4 * 40 | 0) | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 }
 i1 = i1 & i3 & 1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = __ZNK5Umbra6KDTree4rankEi(i8, HEAP32[i8 + 32 + (i2 * 40 | 0) + 12 >> 2] | 0) | 0;
 i4 = i3 << 1;
 i5 = HEAPU8[i8 + 32 + (i2 * 40 | 0) + 29 >> 0] | 0;
 if (i9 & 2 | 0) {
  i2 = i2 + ((i1 ^ 1) & i6) | 0;
  HEAP32[i8 + 32 + (i2 * 40 | 0) + 12 >> 2] = i4;
  i3 = i3 << 2;
  HEAP8[i8 + 32 + (i2 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + (i3 >> 5 << 2) >> 2] | 0) >>> (i3 & 28) & 3;
  HEAP32[i8 + 32 + (i2 * 40 | 0) + 32 >> 2] = 2;
  HEAPF32[i8 + 32 + (i2 * 40 | 0) + (i5 << 2) >> 2] = f10;
  i3 = i8 + 32 + (i2 * 40 | 0) + 28 | 0;
  HEAP8[i3 >> 0] = (HEAP8[i3 >> 0] | 0) + 1 << 24 >> 24;
  i3 = i8 + 32 + (i2 * 40 | 0) + 30 | 0;
  HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & (1 << (i5 << 1) ^ 255);
 }
 if (!(i9 & 1)) {
  i9 = HEAP32[i7 >> 2] | 0;
  i9 = i9 + i6 | 0;
  HEAP32[i7 >> 2] = i9;
  return;
 }
 i9 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
 i4 = i4 + -1 | 0;
 HEAP32[i8 + 32 + (i9 * 40 | 0) + 12 >> 2] = i4;
 i4 = i4 << 1;
 HEAP8[i8 + 32 + (i9 * 40 | 0) + 29 >> 0] = (HEAP32[(HEAP32[i8 + 4 >> 2] | 0) + (i4 >> 5 << 2) >> 2] | 0) >>> (i4 & 30) & 3;
 HEAP32[i8 + 32 + (i9 * 40 | 0) + 32 >> 2] = 1;
 HEAPF32[i8 + 32 + (i9 * 40 | 0) + 16 + (i5 << 2) >> 2] = f10;
 i4 = i8 + 32 + (i9 * 40 | 0) + 28 | 0;
 HEAP8[i4 >> 0] = (HEAP8[i4 >> 0] | 0) + 1 << 24 >> 24;
 i9 = i8 + 32 + (i9 * 40 | 0) + 30 | 0;
 HEAP8[i9 >> 0] = (HEAPU8[i9 >> 0] | 0) & (2 << (i5 << 1) ^ 255);
 i9 = HEAP32[i7 >> 2] | 0;
 i9 = i9 + i6 | 0;
 HEAP32[i7 >> 2] = i9;
 return;
}

function __ZN10VertexData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i11 = i12 + 8 | 0;
 i1 = i8 + 88 | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i7 = i10 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 HEAP32[i11 >> 2] = 0;
 i3 = i11 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i11 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i13 = i9;
 i2 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i5);
 HEAP32[i3 >> 2] = 8;
 HEAP32[i4 >> 2] = -2147483640;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i9 >> 2] = 8;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = 8;
  HEAP32[i6 >> 2] = i2;
  i1 = i8;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i13 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + (i13 << 2) | 0;
 if (i13 | 0) do {
  __ZN11ChannelInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i9 >> 2] = 0;
 i2 = i8 + 84 | 0;
 i1 = i8 + 96 | 0;
 __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i10, (HEAP32[i2 >> 2] | 0) == 0 ? i9 : i1, gb + 430648 | 0, 1);
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i10, i1, i2, 0);
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i5);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i6, i11, i3) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i9 = i3;
 i4 = i11;
 i7 = i9 - i4 | 0;
 i10 = i7 >> 4;
 i8 = i6 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = i5;
 if (i10 >>> 0 > i2 - i5 >> 4 >>> 0) {
  i4 = i5;
  if (!i5) i1 = i2; else {
   i2 = i6 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i5 | 0) >>> 4) << 4);
   __ZdlPv(i4);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i1 = 0;
  }
  if (i10 >>> 0 > 268435455) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else i2 = 0;
  i9 = i1 - i2 | 0;
  i1 = i9 >> 3;
  i1 = i9 >> 4 >>> 0 < 134217727 ? (i1 >>> 0 < i10 >>> 0 ? i10 : i1) : 268435455;
  if (i1 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i2 = __Znwj(i1 << 4) | 0;
  i3 = i6 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i8 >> 2] = i2 + (i1 << 4);
  if ((i7 | 0) <= 0) return;
  _memcpy(i2 | 0, i11 | 0, i7 | 0) | 0;
  HEAP32[i3 >> 2] = i2 + (i10 << 4);
  return;
 }
 i8 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i2 - i5 >> 4;
 i7 = i10 >>> 0 > i6 >>> 0;
 i6 = i7 ? i11 + (i6 << 4) | 0 : i3;
 i5 = i2;
 if ((i6 | 0) != (i11 | 0)) {
  i4 = i6 + -16 - i4 | 0;
  i2 = i11;
  i3 = i1;
  while (1) {
   i12 = i2;
   i10 = HEAP32[i12 + 4 >> 2] | 0;
   i11 = i3;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = i10;
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i2 = i2 + 16 | 0;
   if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 16 | 0;
  }
  i1 = i1 + ((i4 >>> 4) + 1 << 4) | 0;
 }
 if (i7) {
  i1 = i9 - i6 | 0;
  if ((i1 | 0) <= 0) return;
  _memcpy(HEAP32[i8 >> 2] | 0, i6 | 0, i1 | 0) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 4 << 4);
  return;
 } else {
  if ((i5 | 0) == (i1 | 0)) return;
  HEAP32[i8 >> 2] = i5 + (~((i5 + -16 - i1 | 0) >>> 4) << 4);
  return;
 }
}

function __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 16 | 0;
 i5 = i11;
 i3 = i11 + 8 | 0;
 i9 = i11 + 4 | 0;
 i1 = i8 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 30912 | 0) | 0;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 i1 = __ZN20TextRenderingPrivate8TextMesh7GetMeshEv(i8) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 __ZN12MeshRenderer13SetSharedMeshE4PPtrI4MeshE(i6, i7);
 if ((mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] | 0, i6 | 0) | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i4 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i6 | 0, 0) | 0;
 if (i4 | 0) {
  HEAP32[i5 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i10 = 13; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i5);
    i2 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 13; else if (HEAP32[i1 + 4 >> 2] | 0) {
    STACKTOP = i11;
    return;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(i4) | 0) {
   STACKTOP = i11;
   return;
  }
 }
 HEAP32[i9 >> 2] = __ZNK13TextRendering4Font11GetMaterialEv(__ZNK20TextRenderingPrivate8TextMesh7GetFontEv(i8) | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i6, i7, 0);
 STACKTOP = i11;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i9, 4);
 i2 = i9 + 4 | 0;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i9 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i5;
 i8 = i1;
 if ((i1 + 8 | 0) >>> 0 >= i5 >>> 0) {
  i3 = i9 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i2 >> 2] | 0)) {
    i6 = __Znwj(1) | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i9 + 8 >> 2] = i6;
   }
   i1 = HEAP32[i9 + 24 >> 2] | 0;
  } else {
   i1 = i6 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i8 - i5 | 0;
  i8 = i5 + 8 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i3 >> 2] = i6;
  i1 = i6 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i7 >> 2] = i6 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 8;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + i4 | 0;
  HEAP8[i10 >> 0] = 91;
  return 1;
 }
 return 0;
}

function __Z34ProcessIndexListIsNodeVisibleStep2RK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(i8, i9, i18, i19) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, f29 = f0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i26;
 i25 = i19 + 4 | 0;
 i21 = HEAP32[i25 >> 2] | 0;
 if ((i21 | 0) <= 0) {
  i24 = 0;
  HEAP32[i25 >> 2] = i24;
  STACKTOP = i26;
  return;
 }
 i22 = i8 + 324 | 0;
 i23 = i8 + 108 | 0;
 i10 = i20 + 4 | 0;
 i11 = i8 + 112 | 0;
 i12 = i20 + 8 | 0;
 i13 = i8 + 116 | 0;
 i14 = i20 + 12 | 0;
 i15 = i8 + 608 | 0;
 i16 = i8 + 612 | 0;
 i17 = i8 + 616 | 0;
 i7 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i19 >> 2] | 0;
  i6 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
  i5 = i18 + (i6 * 24 | 0) | 0;
  i3 = HEAP32[i9 + (i6 * 24 | 0) + 4 >> 2] | 0;
  switch (HEAP32[i22 >> 2] | 0) {
  case 1:
   {
    HEAP32[i20 >> 2] = HEAP32[i23 >> 2];
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i14 >> 2] = HEAP32[i8 + 196 + (i3 << 2) >> 2];
    if (__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i5, i20, 1) | 0) i24 = 8;
    break;
   }
  case 2:
   {
    f4 = Math_fround(HEAPF32[i8 + 196 + (i3 << 2) >> 2]);
    if (f4 == Math_fround(0.0)) i24 = 9; else {
     f29 = Math_fround(HEAPF32[i5 >> 2]);
     f29 = Math_fround(f29 - Math_fround(HEAPF32[i15 >> 2]));
     f28 = Math_fround(HEAPF32[i18 + (i6 * 24 | 0) + 4 >> 2]);
     f28 = Math_fround(f28 - Math_fround(HEAPF32[i16 >> 2]));
     f27 = Math_fround(HEAPF32[i18 + (i6 * 24 | 0) + 8 >> 2]);
     f27 = Math_fround(f27 - Math_fround(HEAPF32[i17 >> 2]));
     if (!(Math_fround(Math_fround(Math_fround(f29 * f29) + Math_fround(f28 * f28)) + Math_fround(f27 * f27)) > Math_fround(f4 * f4))) i24 = 8;
    }
    break;
   }
  default:
   i24 = 9;
  }
  if ((i24 | 0) == 8) {
   i2 = HEAP32[i19 >> 2] | 0;
   i24 = 9;
  }
  if ((i24 | 0) == 9) {
   i24 = 0;
   HEAP32[i2 + (i1 << 2) >> 2] = i6;
   i1 = i1 + 1 | 0;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i21 | 0));
 HEAP32[i25 >> 2] = i1;
 STACKTOP = i26;
 return;
}

function _jpeg_fill_bit_buffer(i11, i4, i3, i9) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i10 = HEAP32[i11 + 16 >> 2] | 0;
 i8 = i10 + 380 | 0;
 L1 : do if (!(HEAP32[i8 >> 2] | 0)) {
  if ((i3 | 0) < 25) {
   i7 = i10 + 24 | 0;
   i6 = i3;
   L4 : while (1) {
    if (!i2) {
     if (!((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
      i1 = 0;
      i13 = 19;
      break;
     }
     i1 = HEAP32[i7 >> 2] | 0;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     i1 = HEAP32[i1 >> 2] | 0;
    }
    i2 = i2 + -1 | 0;
    i5 = i1 + 1 | 0;
    i3 = HEAP8[i1 >> 0] | 0;
    i1 = i3 & 255;
    L10 : do if (i3 << 24 >> 24 == -1) {
     i1 = i5;
     while (1) {
      if (!i2) {
       if (!((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i10 | 0) | 0) << 24 >> 24)) {
        i1 = 0;
        i13 = 19;
        break L4;
       }
       i3 = HEAP32[i7 >> 2] | 0;
       i2 = HEAP32[i3 + 4 >> 2] | 0;
       i3 = HEAP32[i3 >> 2] | 0;
      } else i3 = i1;
      i2 = i2 + -1 | 0;
      i1 = i3 + 1 | 0;
      i3 = HEAP8[i3 >> 0] | 0;
      switch (i3 << 24 >> 24) {
      case 0:
       {
        i3 = 255;
        break L10;
       }
      case -1:
       break;
      default:
       {
        i13 = 13;
        break L4;
       }
      }
     }
    } else {
     i3 = i1;
     i1 = i5;
    } while (0);
    i4 = i3 | i4 << 8;
    i3 = i6 + 8 | 0;
    if ((i3 | 0) < 25) i6 = i3; else break L1;
   }
   if ((i13 | 0) == 13) {
    HEAP32[i8 >> 2] = i3 & 255;
    i3 = i6;
    i5 = i2;
    i13 = 14;
    break;
   } else if ((i13 | 0) == 19) return i1 | 0;
  }
 } else {
  i5 = i2;
  i13 = 14;
 } while (0);
 if ((i13 | 0) == 14) if ((i3 | 0) < (i9 | 0)) {
  i2 = i10 + 408 | 0;
  if (!(HEAP8[(HEAP32[i2 >> 2] | 0) + 8 >> 0] | 0)) {
   i13 = HEAP32[i10 >> 2] | 0;
   HEAP32[i13 + 20 >> 2] = 117;
   mftCall_vii(HEAP32[i13 + 4 >> 2] | 0, i10 | 0, -1);
   HEAP8[(HEAP32[i2 >> 2] | 0) + 8 >> 0] = 1;
  }
  i4 = i4 << 25 - i3;
  i3 = 25;
  i2 = i5;
 } else i2 = i5;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i4;
 HEAP32[i11 + 12 >> 2] = i3;
 i13 = 1;
 return i13 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 if (i1 >>> 0 > 1073741807) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i10 = i8 + 8 | 0;
 i7 = i10 + 3 | 0;
 i4 = HEAP8[i7 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) {
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = (HEAP32[i10 >> 2] & 2147483647) + -1 | 0;
 } else {
  i9 = i4 & 255;
  i3 = 1;
 }
 i6 = i9 >>> 0 > i1 >>> 0 ? i9 : i1;
 i1 = i6 >>> 0 < 2;
 i6 = i1 ? 1 : (i6 + 4 & -4) + -1 | 0;
 L8 : do if ((i6 | 0) != (i3 | 0)) {
  do if (i1) {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i5) {
    i2 = i1;
    i3 = 0;
    i1 = i8;
    i4 = 21;
   } else {
    __ZNSt3__211char_traitsIwE4copyEPwPKwj(i8, i1, (i4 & 255) + 1 | 0) | 0;
    __ZdlPv(i1);
    i4 = 23;
   }
  } else {
   i1 = i6 + 1 | 0;
   i2 = i1 >>> 0 > 1073741823;
   do if (i6 >>> 0 > i3 >>> 0) if (i2) {
    i10 = ___cxa_allocate_exception(4) | 0;
    __ZNSt9bad_allocC2Ev(i10);
    ___cxa_throw(i10 | 0, gb + 13048 | 0, fb + 3215 | 0);
   } else {
    i1 = __Znwj(i1 << 2) | 0;
    break;
   } else {
    if (i2) {
     i10 = ___cxa_allocate_exception(4) | 0;
     __ZNSt9bad_allocC2Ev(i10);
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i10 | 0, gb + 13048 | 0, fb + 3215 | 0);
     __THREW__ = 0;
    } else {
     __THREW__ = 0;
     i1 = invoke_ii(fb + 1570 | 0, i1 << 2 | 0) | 0;
     i3 = __THREW__;
     __THREW__ = 0;
     if (!(i3 & 1)) break;
    }
    i10 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___cxa_begin_catch(i10 | 0) | 0;
    ___cxa_end_catch();
    break L8;
   } while (0);
   if (i5) {
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = 1;
    i4 = 21;
    break;
   } else {
    __ZNSt3__211char_traitsIwE4copyEPwPKwj(i1, i8, (i4 & 255) + 1 | 0) | 0;
    i4 = 22;
    break;
   }
  } while (0);
  if ((i4 | 0) == 21) {
   __ZNSt3__211char_traitsIwE4copyEPwPKwj(i1, i2, (HEAP32[i8 + 4 >> 2] | 0) + 1 | 0) | 0;
   __ZdlPv(i2);
   if (i3) i4 = 22; else i4 = 23;
  }
  if ((i4 | 0) == 22) {
   HEAP32[i10 >> 2] = i6 + 1 | -2147483648;
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i8 >> 2] = i1;
   break;
  } else if ((i4 | 0) == 23) {
   HEAP8[i7 >> 0] = i9;
   break;
  }
 } while (0);
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i2 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i2 = 15; else {
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? i4 : i2;
 }
 if (i2 >>> 0 < i3 >>> 0) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i7, i3);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i3;
 i6 = i7 + 4 | 0;
 HEAP8[((i1 | 0) == 0 ? i6 : i1) + i3 >> 0] = 0;
 if (i3 >>> 0 > i4 >>> 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  _memset(((i2 | 0) == 0 ? i6 : i2) + i4 | 0, 1, i3 - i4 | 0) | 0;
 }
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = (i1 | 0) == 0;
 do if (!(HEAP32[i4 >> 2] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i3) {
   i2 = 0;
   i4 = i6 + i1 | 0;
   break;
  }
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i7, i1);
  i2 = HEAP32[i7 >> 2] | 0;
  i12 = (i2 | 0) == 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = (i12 ? i6 : i2) + i1 | 0;
  if (i12 | (HEAP32[i4 >> 2] | 0) != 0) i4 = i3; else {
   __ZN4core20StringStorageDefaultIcE10reallocateEj(i7, i1);
   i2 = HEAP32[i7 >> 2] | 0;
   i4 = i3;
  }
 } else {
  i2 = i1;
  i4 = (i3 ? i6 : i1) + (HEAP32[i5 >> 2] | 0) | 0;
 } while (0);
 i1 = (i2 | 0) == 0 ? i6 : i2;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 1);
   i2 = HEAP8[i9 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i9 >> 0] = i2;
   HEAP32[i10 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN16ParticleRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 368 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 340 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 344 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 348 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 352 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 356 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 360 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 364 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN5Unity5Joint22JointTransferPreNoAxisI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i5, i7);
 i2 = i5 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 738066 | 0, gb + 738082 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 40 | 0;
 i4 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 946522 | 0, i4, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i5 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 800705 | 0, i4, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i13, i15, i16, i17) {
 i13 = i13 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i18 + 64 | 0;
 i12 = i18;
 i1 = i13 + 332 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i10 = __Z12GetGfxDevicev() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 256 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i13 + 340 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 mftCall_vii(i9 | 0, i10 | 0, i11 | 0);
 if ((i15 | 0) != 0 & (i17 ^ 1)) if (!(HEAP8[i15 + 33 >> 0] | 0)) {
  STACKTOP = i18;
  return;
 }
 i10 = HEAP32[(HEAP32[i13 + 28 >> 2] | 0) + 48 >> 2] | 0;
 i1 = i13;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetLocalToWorldMatrixEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = HEAP32[i13 + 424 >> 2] | 0;
 i7 = i13 + 228 | 0;
 i8 = i13 + 240 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i14 = 15; else {
  i9 = i13 + 428 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  do {
   if (!(HEAP8[i6 >> 0] | 0)) i14 = 12; else if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) i14 = 12; else {
    __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(HEAP32[i1 >> 2] | 0, i15, i16, i17);
    i1 = i1 + 4 | 0;
   }
   if ((i14 | 0) == 12) {
    i14 = 0;
    i2 = (HEAP16[i16 >> 1] | 0) + 1 << 16 >> 16;
    HEAP16[i16 >> 1] = i2;
    i3 = i11;
    i4 = i12;
    i5 = i3 + 64 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    __ZN2UI6Canvas24DrawIntermediateRendererERNS_5BatchE10Matrix4x4fiP6Camerat(i13, i6, i11, i10, i15, i2);
   }
   i6 = i6 + 16 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i6 | 0) != ((HEAP32[i7 >> 2] | 0) + (i2 << 4) | 0));
  if (!i2) i14 = 15;
 }
 if ((i14 | 0) == 15) {
  i2 = i13 + 428 | 0;
  if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
   __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(HEAP32[i1 >> 2] | 0, i15, i16, i17);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 }
 STACKTOP = i18;
 return;
}

function __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_(i13, i12, i10, i11) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, f14 = f0, f15 = f0;
 i1 = HEAP32[i13 + 20 >> 2] | 0;
 i8 = HEAP32[i13 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i8 | 0)) {
  i2 = HEAP32[i13 + 32 >> 2] | 0;
  i6 = HEAP32[i12 >> 2] | 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) {
    i9 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i8 = HEAP32[(HEAP32[i13 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i9 = 7;
 } else i9 = 7; while (0);
 if ((i9 | 0) == 7) i8 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i13, i12, 0) | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i11 >> 2]);
 f4 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f14 = Math_fround(f5 + Math_fround(-1.0));
 i11 = f14 < Math_fround(0.0);
 f15 = Math_fround(-f14);
 if ((i11 ? f15 : f14) <= Math_fround(9.99999997e-07)) {
  f15 = Math_fround(f3 + Math_fround(-1.0));
  i11 = f15 < Math_fround(0.0);
  f14 = Math_fround(-f15);
  i11 = (i11 ? f14 : f15) <= Math_fround(9.99999997e-07);
  f5 = i11 ? Math_fround(1.0) : f5;
  f3 = i11 ? Math_fround(1.0) : f3;
 }
 i11 = f7 < Math_fround(0.0);
 f15 = Math_fround(-f7);
 if ((i11 ? f15 : f7) <= Math_fround(9.99999997e-07)) {
  i11 = f4 < Math_fround(0.0);
  f15 = Math_fround(-f4);
  i11 = (i11 ? f15 : f4) <= Math_fround(9.99999997e-07);
  f7 = i11 ? Math_fround(0.0) : f7;
  f4 = i11 ? Math_fround(0.0) : f4;
 }
 i6 = i13 + 72 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + i8 + 20 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i13, i12, gb + 478716 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i1 + i8 + 20 >> 2] = i2;
 }
 i13 = i1 + (HEAP32[(HEAP32[i13 + 52 >> 2] | 0) + ((HEAP32[i13 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i13 >> 2] = f5;
 HEAPF32[i13 + 4 >> 2] = f3;
 HEAPF32[i13 + 8 >> 2] = f7;
 HEAPF32[i13 + 12 >> 2] = f4;
 return;
}

function __ZN14SerializedFile27PatchRemapDeprecatedClassesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 i9 = i8 + 36 | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) return;
 i10 = i8 + 72 | 0;
 i11 = i8 + 92 | 0;
 i12 = i8 + 108 | 0;
 do {
  i7 = i1 + 16 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 + (i5 * 56 | 0) >> 2] | 0;
  switch (i2 | 0) {
  case 114:
   {
    i2 = HEAP16[i6 + (i5 * 56 | 0) + 42 >> 1] | 0;
    if (i2 << 16 >> 16 >= 0) {
     i3 = i2 << 16 >> 16;
     i4 = HEAP32[i10 >> 2] | 0;
     i2 = HEAP32[i4 + (i3 << 4) >> 2] | 0;
     if ((i2 | 0) >= 1) {
      i14 = i4 + (i3 << 4) + 8 | 0;
      i15 = HEAP32[i14 >> 2] | 0;
      i14 = HEAP32[i14 + 4 >> 2] | 0;
      i4 = i2 + -1 | 0;
      i3 = HEAP32[i11 >> 2] | 0;
      i2 = (i4 >>> 0) % (i3 >>> 0) | 0;
      i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + (((i4 >>> 0) / (i3 >>> 0) | 0) << 2) >> 2] | 0;
      i4 = i3 + (i2 * 36 | 0) | 0;
      i4 = (__Z6StrCmpPKcS0_((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, gb + 588322 | 0) | 0) == 0;
      if ((i15 | 0) == 12e3 & (i14 | 0) == 0) {
       if (!(HEAP32[i3 + (i2 * 36 | 0) + 20 >> 2] | 0)) if (!(HEAP32[i3 + (i2 * 36 | 0) + 24 >> 2] | 0)) if ((HEAP32[i3 + (i2 * 36 | 0) + 28 >> 2] | 0) == 14) i2 = (HEAP32[i3 + (i2 * 36 | 0) + 32 >> 2] | 0) == 0; else i2 = 0; else i2 = 0; else i2 = 0;
       if (i4 | i2) HEAP32[i7 >> 2] = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i8, 218, (HEAP8[i6 + (i5 * 56 | 0) + 40 >> 0] | 0) != 0, -1, HEAP32[i7 >> 2] | 0) | 0;
      }
     }
    }
    break;
   }
  case 241:
   {
    i3 = 240;
    i13 = 8;
    break;
   }
  default:
   if ((i2 | 0) == 243) {
    i3 = 273;
    i13 = 8;
   } else if ((i2 | 0) == 245) {
    i3 = 272;
    i13 = 8;
   } else {
    i3 = (i2 | 0) == 1012 ? 1011 : i2;
    i13 = 8;
   }
  }
  if ((i13 | 0) == 8) {
   i13 = 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i7 >> 2] = __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi(i8, i3, (HEAP8[i6 + (i5 * 56 | 0) + 40 >> 0] | 0) != 0, -1, i5) | 0;
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (HEAP32[i9 >> 2] | 0));
 return;
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i1 | 0) == (i3 + 16 | 0)) i2 = 5; else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i4 = i3 + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   }
  }
  do if ((i2 | 0) == 5) {
   i1 = i3 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
    i4 = __Znwj(88) | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP8[i4 + 16 >> 0] = 1;
    HEAP32[i4 + 20 >> 2] = 0;
    i5 = i4 + 24 | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i4 + 28 >> 2] = i5;
    HEAP32[i4 + 32 >> 2] = i5;
    HEAPF32[i4 + 40 >> 2] = Math_fround(1.0);
    HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
    HEAP32[i4 + 48 >> 2] = 0;
    i5 = i4 + 52 | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i4 + 56 >> 2] = i5;
    HEAP32[i4 + 60 >> 2] = i5;
    i5 = i4 + 64 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i4 + 68 >> 2] = i5;
    HEAP32[i4 + 72 >> 2] = i5;
    i5 = i4 + 76 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i4 + 80 >> 2] = i5;
    HEAP32[i4 + 84 >> 2] = i5;
    HEAP32[i4 + 8 >> 2] = i2;
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    i1 = i4;
    break;
   } else {
    i5 = 0;
    return i5 | 0;
   }
  } while (0);
  i4 = i3 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = i1 + 24 | 0;
  i2 = i1 + 32 | 0;
  i6 = i1 + 28 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
  i5 = i3 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 >> 2] = i3 + 28;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] = i4;
  HEAP32[i5 >> 2] = i4;
 } else {
  i1 = HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = i4 << 16 & 268369920 | i5 << 28 | i6 & 65535;
 i6 = i1;
 return i6 | 0;
}

function __Z23TransferScriptingObjectI9JSONWriteEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i9 = i14 + 60 | 0;
 i3 = i14 + 80 | 0;
 i2 = i14 + 82 | 0;
 i4 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i3 >> 0] = 8;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 i2 = __Z19FindCommandsInCachePK15MonoScriptCacheRK24TransferRequestSignatureRb(i1, i3, i2) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i15 = i12;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i11;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i8;
  HEAP32[i12 + 4 >> 2] = i8;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = HEAP16[i3 >> 1] | 0;
  __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i4, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i9 >> 2] = i1;
 i4 = i9 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i9 + 16 >> 2] = i16;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i6;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i7;
 HEAP32[i12 + 8 >> 2] = i8;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i9;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i11);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZNSt3__210to_wstringEf(i8, f3) {
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, d5 = 0.0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i10, 20, 0);
 i1 = i10 + 8 | 0;
 i6 = i1 + 3 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i6 >> 0] | 0;
 d5 = +f3;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i4 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  __THREW__ = 0;
  HEAPF64[i7 >> 3] = d5;
  i4 = invoke_iiiii(fb + 215 | 0, i4 | 0, i1 + 1 | 0, gb + 215404 | 0, i7 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i4 | 0) > -1) if (i4 >>> 0 > i1 >>> 0) i1 = i4; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i1 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i6 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i10 | 0, i4 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZN18GfxFramebufferGLES22EnsureDefaultFBOInitedEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i5 + 520 | 0;
 if (HEAP8[i7 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 i8 = i6 + 68 | 0;
 i1 = i5 + 52 | 0;
 i2 = i6;
 i3 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i5 + 16 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i6 >> 2] = 1;
  i2 = i6;
  i4 = 7;
  break;
 } else {
  HEAP32[i6 >> 2] = 0;
  break;
 } else {
  HEAP32[i6 >> 2] = i1;
  if (i1 | 0) {
   i2 = i6;
   i4 = 7;
  }
 } while (0);
 if ((i4 | 0) == 7) {
  i1 = 0;
  do {
   i4 = HEAP32[i5 + 16 + (i1 << 2) >> 2] | 0;
   HEAP32[i6 + 4 + (i1 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 36 + (i1 << 2) >> 2] = HEAP32[i4 + 36 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 do if (!i1) HEAP8[i6 + 92 >> 0] = 0; else {
  i2 = i6 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i6 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i6 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   break;
  } else {
   HEAP8[i2 >> 0] = 0;
   break;
  }
 } while (0);
 HEAP32[i6 + 80 >> 2] = HEAP32[i5 + 56 >> 2];
 HEAP32[i6 + 84 >> 2] = HEAP32[i5 + 64 >> 2];
 HEAP32[i6 + 88 >> 2] = HEAP32[i5 + 60 >> 2];
 i4 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i5, i6) | 0;
 i8 = i5 + 376 | 0;
 i2 = i8;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 if (HEAP32[i8 >> 2] | 0) {
  i2 = i6 + 4 | 0;
  i3 = i2 + 92 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i6 >> 2] = 1;
  HEAP8[i6 + 92 >> 0] = 1;
  HEAP32[i6 + 88 >> 2] = -1;
  i8 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i5, i6) | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = -1;
 }
 HEAP8[i7 >> 0] = 1;
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE(i14, i15) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 4 | 0;
 i13 = i16;
 i12 = i16 + 8 | 0;
 i9 = i14 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i13 | 0, i2 | 0) | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 HEAP8[i13 >> 0] = i2 >>> 24;
 HEAP8[i13 + 3 >> 0] = i2;
 HEAP8[i13 + 1 >> 0] = i2 >>> 16;
 HEAP8[i13 + 2 >> 0] = (i2 & 65535) >>> 8;
 i2 = HEAP32[i13 >> 2] | 0;
 i9 = i2 * 48 | 0;
 i6 = HEAP32[i14 + 20 >> 2] | 0;
 i10 = i6 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i7 = i6 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i1;
 i11 = i3 - i4 | 0;
 i5 = i11 + i9 | 0;
 if (i5) {
  i8 = i6 + 20 | 0;
  if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i5 >>> 0) {
   i1 = i5 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i5 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i6 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i6 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i11 | 0) | 0;
    i6 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i3 = i1 + i11 | 0;
   HEAP32[i10 >> 2] = i3;
   HEAP32[i8 >> 2] = i1 + i4;
   i2 = HEAP32[i13 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i3 + i9;
 i3 = i1 + i11 | 0;
 if (!i2) {
  i14 = 0;
  i13 = i3;
  i14 = i3 + (i14 * 48 | 0) | 0;
  HEAP32[i15 >> 2] = i13;
  i15 = i15 + 4 | 0;
  HEAP32[i15 >> 2] = i14;
  STACKTOP = i16;
  return;
 }
 i2 = 0;
 do {
  __ZN5physx8debugger8renderer19RenderSerializerMapINS1_11PvdTriangleEE9serializeERNS1_16RenderSerializerERS3_(i12, i14, i3 + (i2 * 48 | 0) | 0);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 i13 = i3;
 i14 = i3 + (i1 * 48 | 0) | 0;
 HEAP32[i15 >> 2] = i13;
 i15 = i15 + 4 | 0;
 HEAP32[i15 >> 2] = i14;
 STACKTOP = i16;
 return;
}

function __ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i4, i7, i8, i9) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i10 = 0;
 HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 i5 = HEAP32[i4 + 40 >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 L1 : do if (i5 | 0) {
  i5 = i8 + 8 | 0;
  while (1) {
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
   if ((i2 | 0) == (gb + 27592 | 0)) i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i1 + 4 >> 2] | 0) | 0; else {
    i10 = __Z21GetManagerFromContexti(5) | 0;
    i2 = HEAP32[(HEAP32[i10 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
   }
   if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i3) | 0) break;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i6 | 0)) break L1;
  }
  HEAP32[HEAP32[i9 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
  i10 = 1;
  return i10 | 0;
 } while (0);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
 i5 = HEAP32[i1 + 92 >> 2] | 0;
 L15 : do if ((i5 | 0) > 0) {
  i4 = i1 + 80 | 0;
  if (i7) {
   i1 = 0;
   while (1) {
    i2 = __ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i8, i9) | 0;
    if (i2) {
     i2 = i2 & 1;
     i1 = 1;
     break L15;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i5 | 0)) {
     i2 = 2;
     i1 = 0;
     break L15;
    }
   }
  } else {
   i1 = 0;
   i3 = 0;
  }
  while (1) {
   i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
   if (!(HEAP8[i2 + 54 >> 0] | 0)) i2 = 4; else {
    i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i8, i9) | 0);
    i2 = i1 & 1;
   }
   switch (i2 & 7) {
   case 4:
   case 0:
    break;
   default:
    break L15;
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i5 | 0)) {
    i2 = 2;
    break L15;
   }
  }
 } else {
  i2 = 2;
  i1 = 0;
 } while (0);
 i10 = i1 | (i2 | 0) != 2;
 return i10 | 0;
}

function __Z30ExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i8 + 104 | 0;
 if ((i2 | 0) == 2) if (!i3) {
  __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf(i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 16) | 0);
  STACKTOP = i8;
  return;
 } else {
  __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32(i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 4) | 0);
  STACKTOP = i8;
  return;
 }
 switch (i4 | 0) {
 case 2:
  {
   i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 8) | 0;
   i5 = i1 + 32 | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i6);
   HEAP8[i7 >> 0] = 0;
   HEAP8[i7 + 1 >> 0] = 2;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i6, i3, i4, i2, i7);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i4, HEAP32[i6 + 88 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + 8 | 0, i6);
   STACKTOP = i8;
   return;
  }
 case 3:
  {
   i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 12) | 0;
   i5 = i1 + 32 | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i6);
   HEAP8[i7 >> 0] = 0;
   HEAP8[i7 + 1 >> 0] = 3;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i6, i3, i4, i2, i7);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i4, HEAP32[i6 + 88 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + 8 | 0, i6);
   STACKTOP = i8;
   return;
  }
 case 4:
  {
   i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 16) | 0;
   i5 = i1 + 32 | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0;
   __ZN14VertexDataInfoC2Ev(i6);
   HEAP8[i7 >> 0] = 0;
   HEAP8[i7 + 1 >> 0] = 4;
   __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i6, i3, i4, i2, i7);
   __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i4, HEAP32[i6 + 88 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + 8 | 0, i6);
   STACKTOP = i8;
   return;
  }
 default:
  {
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN5physx8debugger18MemPvdOutputStream5writeEPKhj(i12, i10, i13) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = (i10 | 0) != 0;
 if (i7 & (i13 | 0) != 0) {
  i8 = i12 + 20 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i6 = i12 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1;
  i9 = i2 - i3 | 0;
  i4 = i9 + i13 | 0;
  if (i4) {
   i5 = i12 + 24 | 0;
   if (((HEAP32[i5 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
    i1 = i4 << 1;
    if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
    i2 = i12 + 8 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i12 + 12 >> 2] | 0, gb + 776765 | 0, 228) | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    if (i3 | 0) {
     _memcpy(i1 | 0, i3 | 0, i9 | 0) | 0;
     i11 = HEAP32[i2 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i6 >> 2] | 0);
    }
    HEAP32[i6 >> 2] = i1;
    i2 = i1 + i9 | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i1 + i4;
   }
  }
  HEAP32[i8 >> 2] = i2 + i13;
  _memcpy(i1 + i9 | 0, i10 | 0, i13 | 0) | 0;
 }
 if (i7 | (i13 | 0) == 0) return 1;
 i8 = i12 + 20 | 0;
 i9 = i12 + 16 | 0;
 i10 = i12 + 24 | 0;
 i11 = i12 + 8 | 0;
 i5 = i12 + 12 | 0;
 i7 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = i1;
  i6 = i2 - i3 | 0;
  i4 = i6 + 1 | 0;
  if (i4) if (((HEAP32[i10 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = HEAP32[i11 >> 2] | 0;
   i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i3 | 0, i2 | 0, i6 | 0) | 0;
    i12 = HEAP32[i11 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, HEAP32[i9 >> 2] | 0);
   }
   HEAP32[i9 >> 2] = i3;
   i2 = i3 + i6 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i10 >> 2] = i3 + i1;
   i1 = i3;
  }
  HEAP32[i8 >> 2] = i2 + 1;
  HEAP8[i1 + i6 >> 0] = 0;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i13 | 0));
 return 1;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 3) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN4math8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z23TransferScriptingObjectI8JSONReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i9 = i14 + 60 | 0;
 i3 = i14 + 80 | 0;
 i2 = i14 + 82 | 0;
 i4 = i14 + 56 | 0;
 i13 = i14 + 32 | 0;
 HEAP8[i3 >> 0] = 9;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 i2 = __Z19FindCommandsInCachePK15MonoScriptCacheRK24TransferRequestSignatureRb(i1, i3, i2) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 i10 = i13 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i13 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i15 = i12;
 i1 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i11;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP8[i13 + 20 >> 0] = 0;
 if (!i2) {
  HEAP32[i12 >> 2] = i8;
  HEAP32[i12 + 4 >> 2] = i8;
  HEAP32[i12 + 8 >> 2] = __Z23GetCoreScriptingClassesv() | 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP16[i12 + 16 >> 1] = HEAP16[i3 >> 1] | 0;
  __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info(i12, i13, i4, 0, 0);
  i2 = i13;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i15 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i15 << 6) | 0;
 i3 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i9 >> 2] = i1;
 i4 = i9 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 i16 = i15 << 6 >> 6;
 HEAP32[i9 + 16 >> 2] = i16;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = i16;
 HEAP32[i12 + 20 >> 2] = i6;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i12 + 4 >> 2] = i7;
 HEAP32[i12 + 8 >> 2] = i8;
 HEAP32[i12 + 12 >> 2] = -1;
 HEAP32[i12 + 16 >> 2] = i9;
 if (i15 | 0) do {
  i16 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = i16;
  HEAP32[i5 >> 2] = i2 - i16 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i12 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i14;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i11);
 HEAP32[i13 >> 2] = 0;
 STACKTOP = i14;
 return;
}

function __ZN29InitialModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 do switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround((__ZNK14ParticleSystem7GetLoopEv(i3) | 0) & 1);
   break;
  }
 case 1:
  {
   f1 = Math_fround(__ZNK14ParticleSystem18GetSimulationSpeedEv(i3));
   break;
  }
 case 2:
  {
   f1 = Math_fround(__ZNK14ParticleSystem13GetStartDelayEv(i3));
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 772 >> 2]);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 1036 >> 2]);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 1300 >> 2]);
   break;
  }
 case 8:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 1564 >> 2]);
   break;
  }
 case 9:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 1828 >> 2]);
   break;
  }
 case 10:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 2092 >> 2]);
   break;
  }
 case 11:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 680 >> 0] | 0);
   break;
  }
 case 12:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 681 >> 0] | 0);
   break;
  }
 case 13:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 682 >> 0] | 0);
   break;
  }
 case 14:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 683 >> 0] | 0);
   break;
  }
 case 15:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 684 >> 0] | 0);
   break;
  }
 case 16:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 685 >> 0] | 0);
   break;
  }
 case 17:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 686 >> 0] | 0);
   break;
  }
 case 18:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 44 >> 2] | 0) + 687 >> 0] | 0);
   break;
  }
 case 19:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 2540 >> 2]);
   break;
  }
 case 20:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 2356 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN21InheritVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj(i7, i1, i5, i8, i9, i10) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 8 | 0;
 i3 = i11;
 if ((HEAP32[i1 + 280 >> 2] | 0) != 1) {
  STACKTOP = i11;
  return;
 }
 i2 = i7 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 L4 : do if (!i1) {
  switch (HEAP16[i7 + 96 >> 1] | 0) {
  case 0:
  case 3:
   break;
  default:
   break L4;
  }
  STACKTOP = i11;
  return;
 } while (0);
 if ((HEAP16[gb + 1451812 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451812 | 0, i4);
  i6 = gb + 1451812 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else i6 = 0;
 i3 = i5 + 292 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 28 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i2;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = i2;
 HEAP32[i4 + 44 >> 2] = i3;
 HEAP32[i4 + 40 >> 2] = i3;
 HEAP32[i4 + 36 >> 2] = i3;
 HEAP32[i4 + 32 >> 2] = i3;
 i3 = (i1 | 0) == 1 ? i4 : 0;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[i7 + 96 >> 2] | 0;
 i2 = i1 & 65535;
 do if (!(i2 << 16 >> 16)) __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i4, i8, i9, i10, i3); else {
  if (!(i1 & 16711680)) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i4, i8, i9, i10, i3);
   break;
  }
  if ((i2 | 1) << 16 >> 16 == 3) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i4, i8, i9, i10, i3);
   break;
  } else {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E(i4, i8, i9, i10, i3);
   break;
  }
 } while (0);
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return;
}

function __Z11CopyBuffersRN5physx13PxcNpWorkUnitERNS_18PxcNpThreadContextEb(i14, i15, i13) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = HEAP32[i14 + 32 >> 2] | 0;
 if (i10 | 0) {
  i11 = i14 + 28 | 0;
  i12 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP16[i14 + 22 >> 1] | 0;
  i2 = i1 & 65535;
  do if (!(i2 & 1)) if (!(HEAP8[i15 + 8758 >> 0] | 0)) {
   if (i2 & 32 | 0) if ((HEAP32[(HEAP32[i14 + 64 >> 2] | 0) + 92 >> 2] | 0) != 2139095039) {
    i3 = 8;
    break;
   }
   if (!(i1 & 64)) i9 = 0; else if ((HEAP32[(HEAP32[i14 + 68 >> 2] | 0) + 92 >> 2] | 0) == 2139095039) i9 = 0; else i3 = 8;
  } else i3 = 8; else i3 = 8; while (0);
  if ((i3 | 0) == 8) i9 = HEAPU16[i14 + 20 >> 1] << 2;
  i3 = i10 + 15 | 0;
  i8 = i3 & -16;
  i2 = i15 + 332 | 0;
  i3 = (i3 | 15) + i9 & -16;
  do if (i3 >>> 0 > 16384) i1 = __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(HEAP32[i2 >> 2] | 0, i3) | 0; else {
   i4 = i15 + 336 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i1 = i15 + 340 | 0;
   if (i5 | 0) {
    i6 = HEAP32[i1 >> 2] | 0;
    i7 = i6 + i3 | 0;
    if (i7 >>> 0 <= 16384) {
     HEAP32[i1 >> 2] = i7;
     i1 = i5 + i6 | 0;
     break;
    }
   }
   i7 = __ZN5physx17PxcNpMemBlockPool19acquireContactBlockEv(HEAP32[i2 >> 2] | 0) | 0;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i1 >> 2] = i3;
   i1 = i7;
  } while (0);
  _memcpy(i1 | 0, i12 | 0, i10 | 0) | 0;
  if (!i9) {
   i12 = i14 + 98 | 0;
   HEAP16[i12 >> 1] = HEAPU16[i12 >> 1] & 65519;
  } else _memset(i1 + i8 | 0, 0, i9 | 0) | 0;
  HEAP32[i11 >> 2] = i1;
 }
 i3 = i14 + 44 | 0;
 if (HEAP32[i3 >> 2] & 1 | 0) {
  i1 = i14 + 56 | 0;
  i2 = HEAP16[i1 >> 1] | 0;
  if (!(i2 << 16 >> 16)) return;
  i15 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i15 + 356 | 0, i2 & 65535) | 0;
  _memcpy(i15 | 0, HEAP32[i3 >> 2] & -16 | 0, HEAPU16[i1 >> 1] | 0) | 0;
  HEAP32[i3 >> 2] = i15 | 1;
  return;
 }
 if (!i13) return;
 i1 = i14 + 56 | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 if (!(i2 << 16 >> 16)) return;
 i14 = i14 + 52 | 0;
 i13 = HEAP32[i14 >> 2] | 0;
 i15 = __ZN5physx20PxcNpCacheStreamPair7reserveEj(i15 + 356 | 0, (i2 & 65535) + 15 & 65520) | 0;
 _memcpy(i15 | 0, i13 | 0, HEAPU16[i1 >> 1] | 0) | 0;
 HEAP32[i14 >> 2] = i15;
 return;
}

function _UNITY_FT_Glyph_StrokeBorder(i13, i12, i4, i14) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i15;
 if (!i13) {
  i14 = 6;
  STACKTOP = i15;
  return i14 | 0;
 }
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 6;
  STACKTOP = i15;
  return i14 | 0;
 }
 if ((HEAP32[i2 + 4 >> 2] | 0) != ((HEAP32[(HEAP32[i12 + 128 >> 2] | 0) + 188 >> 2] | 0) + 4 | 0)) {
  i14 = 6;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = _UNITY_FT_Glyph_Copy(i2, i1) | 0;
 i9 = (i3 | 0) == 0;
 i10 = i9 ? HEAP32[i1 >> 2] | 0 : i2;
 if (!i9) {
  i14 = i3;
  STACKTOP = i15;
  return i14 | 0;
 }
 i9 = i10 + 20 | 0;
 i8 = ((_UNITY_FT_Outline_Get_Orientation(i9) | 0) != 0 ^ i4 << 24 >> 24 != 0) & 1;
 i1 = _UNITY_FT_Stroker_ParseOutline(i12, i9, 0) | 0;
 if (!i1) {
  i1 = HEAP32[i12 + 64 + (i8 << 5) >> 2] | 0;
  L15 : do if (!i1) {
   i2 = 0;
   i1 = 0;
   i11 = 13;
  } else {
   i7 = HEAP32[i12 + 64 + (i8 << 5) + 12 >> 2] | 0;
   i5 = i1;
   i2 = 0;
   i1 = 0;
   i3 = 0;
   while (1) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = (i3 | 0) == 0;
    if (!(i6 & 4)) {
     if (i4) {
      i2 = 0;
      i1 = 0;
      break L15;
     }
    } else if (i4) i3 = 1; else {
     i2 = 0;
     i1 = 0;
     break L15;
    }
    i6 = i6 & 8;
    i2 = ((i6 & 255) >>> 3 & 255) + i2 | 0;
    i3 = i6 << 24 >> 24 == 0 ? i3 : 0;
    i5 = i5 + -1 | 0;
    i1 = i1 + 1 | 0;
    if (!i5) break; else i7 = i7 + 1 | 0;
   }
   if (!i3) i11 = 13; else {
    i2 = 0;
    i1 = 0;
   }
  } while (0);
  if ((i11 | 0) == 13) HEAP8[i12 + 64 + (i8 << 5) + 28 >> 0] = 1;
  _UNITY_FT_Outline_Done(HEAP32[i10 >> 2] | 0, i9) | 0;
  i1 = _UNITY_FT_Outline_New(HEAP32[i10 >> 2] | 0, i1, i2, i9) | 0;
  if (!i1) {
   HEAP16[i9 + 2 >> 1] = 0;
   HEAP16[i9 >> 1] = 0;
   _UNITY_FT_Stroker_ExportBorder(i12, i8, i9);
   if (i14 << 24 >> 24) _UNITY_FT_Done_Glyph(HEAP32[i13 >> 2] | 0);
   HEAP32[i13 >> 2] = i10;
   i14 = 0;
   STACKTOP = i15;
   return i14 | 0;
  }
 }
 _UNITY_FT_Done_Glyph(i10);
 if (i14 << 24 >> 24) {
  i14 = i1;
  STACKTOP = i15;
  return i14 | 0;
 }
 HEAP32[i13 >> 2] = 0;
 i14 = i1;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 36 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 36 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN4Halo12AddToManagerEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 16 | 0;
 i9 = i11;
 i3 = HEAP32[gb + 1110376 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) i8 = 1; else i8 = (HEAP32[i5 + -8 >> 2] | 0) + 1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 i2 = i1 + 24 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i1 + 25 >> 0] = 0;
 HEAP8[i1 + 26 >> 0] = 0;
 HEAP8[i1 + 27 >> 0] = -1;
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = i8;
 HEAP32[i1 + 36 >> 2] = 1;
 if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i1);
  i3 = HEAP32[gb + 1110376 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  i7 = i5 + 24 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 40;
 }
 HEAP32[i6 + 44 >> 2] = i8;
 i5 = i6 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 28940 | 0) | 0);
 i7 = HEAP32[i6 + 36 >> 2] | 0;
 i4 = HEAP32[i6 + 40 >> 2] | 0;
 i5 = 1 << HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2];
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i8 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i10 = 10;
   break;
  }
 }
 if ((i10 | 0) == 10) {
  STACKTOP = i11;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = i7;
 HEAP32[i1 + 28 >> 2] = i4;
 HEAP32[i1 + 36 >> 2] = i5;
 STACKTOP = i11;
 return;
}

function __ZN11LightProbes8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9);
 __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8 + 32 | 0, i9);
 i3 = i8 + 148 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i4 = i9 + 8 | 0;
 __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i8 + 160 >> 2] | 0;
 i2 = i1 + (i3 * 108 | 0) | 0;
 if (i3 | 0) do {
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 168 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i8 + 180 >> 2] | 0;
 i2 = i1 + (i8 << 3) | 0;
 if (i8 | 0) do {
  __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f4 = Math_fround(HEAPF32[i8 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  do if (f4 == Math_fround(0.0)) i2 = 0; else {
   i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i3 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i3) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i3 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 2 >> 1] = i2;
  do if (f6 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 4 >> 1] = i2;
  do if (f7 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 6 >> 1] = i2;
  if (!i1) break; else {
   i9 = i9 + 8 | 0;
   i8 = i8 + 16 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f4 = Math_fround(HEAPF32[i8 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  f6 = Math_fround(HEAPF32[i8 + 12 >> 2]);
  f7 = Math_fround(HEAPF32[i8 >> 2]);
  do if (f4 == Math_fround(0.0)) i2 = 0; else {
   i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i3 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i3) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i3 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 2 >> 1] = i2;
  do if (f6 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 4 >> 1] = i2;
  do if (f7 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i9 + 6 >> 1] = i2;
  if (!i1) break; else {
   i9 = i9 + 8 | 0;
   i8 = i8 + 16 | 0;
  }
 }
 return;
}

function __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 32 | 0;
 i10 = i11;
 if (!i7) {
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i7 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i7 + 40 >> 2] | 0;
  if (!i1) {
   HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
   HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = i6 + 16 | 0;
 i3 = i2;
 L10 : do if ((i3 | 0) != (i4 | 0)) {
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 44 >> 2] | 0) == 3) if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) break;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
   if ((i3 | 0) == (i4 | 0)) break L10;
  }
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  i1 = HEAP32[i2 + 120 >> 2] | 0;
  i2 = i1;
  if (!i1) {
   i10 = i2;
   STACKTOP = i11;
   return i10 | 0;
  }
  i10 = i1 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  i10 = i2;
  STACKTOP = i11;
  return i10 | 0;
 } while (0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = i10 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i6, i7, i10, i8, -1, 1) | 0;
 if ((HEAP8[i10 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 }
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN12LightsModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = i4 + 4 | 0;
 i6 = i5 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 16 | 0, i5);
 i1 = i4 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i4 + 20 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i4 + 21 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i4 + 22 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 24 | 0, i5);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 288 | 0, i5);
 i1 = i4 + 552 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  return;
 }
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor7kdSplitEif(i12, i1, f11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i10 = i1 & 3;
 i13 = i12 + 8 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) > (HEAP32[i4 + 36 >> 2] | 0)) i3 = 4; else {
  i1 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + (i1 << 3) >> 2] | 0;
  if (!(i1 & 3)) {
   i2 = i1 >>> 2;
   i1 = HEAP32[i4 + 24 >> 2] | 0;
   HEAP32[i1 + (i2 << 3) >> 2] = i10;
   HEAPF32[i1 + (i2 << 3) + 4 >> 2] = f11;
   i1 = HEAP32[i12 >> 2] | 0;
  } else i3 = 4;
 }
 if ((i3 | 0) == 4) {
  i7 = i4 + 32 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 1 | 0;
  i3 = i4 + 28 | 0;
  if ((HEAP32[i3 >> 2] | 0) > (i8 | 0)) i1 = HEAP32[i4 + 24 >> 2] | 0; else {
   i2 = i9 << 1;
   i2 = (i2 | 0) > 16 ? i2 : 16;
   i6 = i4 + 20 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 3) + 16 | 0, 0) | 0;
   if (!i1) {
    i13 = 0;
    return i13 | 0;
   }
   HEAP32[i1 >> 2] = i2;
   i1 = i1 + 16 | 0;
   HEAP32[i3 >> 2] = i2;
   i5 = i4 + 24 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   do if (i2 | 0) {
    i3 = HEAP32[i7 >> 2] | 0;
    if (i3) {
     i4 = (i3 | 0) <= (i9 | 0) ? i3 : i9;
     if ((i4 | 0) > 0) {
      i3 = 0;
      do {
       i16 = i2 + (i3 << 3) | 0;
       i15 = HEAP32[i16 + 4 >> 2] | 0;
       i14 = i1 + (i3 << 3) | 0;
       HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
       HEAP32[i14 + 4 >> 2] = i15;
       i3 = i3 + 1 | 0;
      } while ((i3 | 0) != (i4 | 0));
      i2 = HEAP32[i5 >> 2] | 0;
      if (!i2) break;
     }
    }
    i16 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i2 + -16 | 0);
   } while (0);
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i7 >> 2] = i9;
  HEAP32[i1 + (i8 << 3) >> 2] = i10;
  HEAPF32[i1 + (i8 << 3) + 4 >> 2] = f11;
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = (HEAP32[i1 + 32 >> 2] | 0) + -1 | 0;
 }
 HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i13 >> 2] << 3) >> 2] = i2 << 2;
 i16 = i1 + 36 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 HEAP32[i16 >> 2] = (i14 | 0) >= (i15 | 0) ? i14 : i15;
 i16 = 1;
 return i16 | 0;
}

function __ZN11LightProbes14SetPendingDataERK13dynamic_arrayI13ProbeSetIndexLj8EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i12 = i9 + 136 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i9 + 140 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) i3 = i2; else {
  i3 = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0) | 0;
  HEAP32[i13 >> 2] = i3;
 }
 i8 = i10 + 12 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  i12 = i2;
  i13 = i3;
  i10 = i9 + 132 | 0;
  i10 = HEAP8[i10 >> 0] | 0;
  HEAP8[i11 >> 0] = i10;
  __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i12, i13, i11);
  STACKTOP = i14;
  return;
 }
 i5 = i11 + 16 | 0;
 i6 = i9 + 144 | 0;
 i7 = i9 + 136 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i3;
 while (1) {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_4pairI7Hash12813ProbeSetIndexEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i7, i11); else {
   i3 = i11;
   i4 = i2 + 40 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 40;
  }
  i1 = i1 + 24 | 0;
  if (((HEAP32[i10 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 24 | 0) | 0) == (i1 | 0)) break;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i10 = i9 + 132 | 0;
 i10 = HEAP8[i10 >> 0] | 0;
 HEAP8[i11 >> 0] = i10;
 __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i12, i13, i11);
 STACKTOP = i14;
 return;
}

function __Z35RandomQuaternionUniformDistributionR4Rand(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i10 = i10 << 11 ^ i10;
 i13 = i1 + 4 | 0;
 i9 = HEAP32[i13 >> 2] | 0;
 i12 = i1 + 8 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i8 = i1 + 12 | 0;
 i15 = HEAP32[i8 >> 2] | 0;
 i10 = i10 >>> 8 ^ i10 ^ i15;
 i14 = i10 ^ i15 >>> 19;
 f7 = Math_fround(Math_fround((i14 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f7 = Math_fround(Math_fround(f7 * Math_fround(0.0)) + Math_fround(Math_fround(1.0) - f7));
 i9 = i9 << 11 ^ i9;
 i9 = i9 >>> 8 ^ i9 ^ i14;
 i10 = i9 ^ i10 >>> 19;
 f3 = Math_fround(Math_fround((i10 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround(f3 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(6.28318548)));
 i11 = i11 << 11 ^ i11;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i12 >> 2] = i10;
 i1 = i11 >>> 8 ^ i11 ^ i10 ^ i9 >>> 19;
 HEAP32[i8 >> 2] = i1;
 f5 = Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(f5 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(6.28318548)));
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - f7)));
 f7 = Math_fround(Math_sqrt(Math_fround(f7)));
 f2 = Math_fround(f4 * Math_fround(+Math_sin(+f3)));
 f3 = Math_fround(f4 * Math_fround(+Math_cos(+f3)));
 f4 = Math_fround(f7 * Math_fround(+Math_sin(+f5)));
 f5 = Math_fround(f7 * Math_fround(+Math_cos(+f5)));
 if (!(Math_fround(f5 + Math_fround(Math_fround(Math_fround(f2 * Math_fround(0.0)) + Math_fround(f3 * Math_fround(0.0))) + Math_fround(f4 * Math_fround(0.0)))) < Math_fround(0.0))) {
  f7 = f5;
  f5 = f4;
  f4 = f3;
  f3 = f2;
  HEAPF32[i6 >> 2] = f3;
  i15 = i6 + 4 | 0;
  HEAPF32[i15 >> 2] = f4;
  i15 = i6 + 8 | 0;
  HEAPF32[i15 >> 2] = f5;
  i15 = i6 + 12 | 0;
  HEAPF32[i15 >> 2] = f7;
  return;
 }
 f7 = Math_fround(-f5);
 f5 = Math_fround(-f4);
 f4 = Math_fround(-f3);
 f3 = Math_fround(-f2);
 HEAPF32[i6 >> 2] = f3;
 i15 = i6 + 4 | 0;
 HEAPF32[i15 >> 2] = f4;
 i15 = i6 + 8 | 0;
 HEAPF32[i15 >> 2] = f5;
 i15 = i6 + 12 | 0;
 HEAPF32[i15 >> 2] = f7;
 return;
}

function __ZNK5physx29PxSphereGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEEEEEjT_j(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i10 + 8 | 0;
 i5 = i1 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0);
   i2 = HEAP32[i8 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i5;
 HEAP8[i6 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = i6;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i6) | 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_(i8, i7);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  i9 = i9 + 2 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i9 = i9 + 2 | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx13PxCreatePlaneERNS_9PxPhysicsERKNS_7PxPlaneERNS_10PxMaterialE(i11, i8, i6) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 60 | 0;
 i1 = i12 + 64 | 0;
 i9 = i12 + 32 | 0;
 i2 = i12 + 28 | 0;
 i10 = i12;
 i13 = HEAP32[i8 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i13 & 2139095040) >>> 0 >= 2139095040) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i13 & 2139095040) >>> 0 >= 2139095040) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 i13 = HEAP32[i8 + 8 >> 2] | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i13 & 2139095040) >>> 0 >= 2139095040) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 if (!(Math_fround(Math_abs(Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3)) + Math_fround(f4 * f4)))) + Math_fround(-1.0)))) < Math_fround(.0000999999974))) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 __ZN5physx28PxTransformFromPlaneEquationERKNS_7PxPlaneE(i9, i8);
 HEAP32[i2 >> 2] = 1;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i7 >> 2] = i6;
 i13 = HEAP32[(HEAP32[i11 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = 11;
 i2 = mftCall_iiiiiii(i13 | 0, i11 | 0, i2 | 0, i7 | 0, 1, 1, i1 | 0) | 0;
 if (!i2) {
  i13 = 0;
  STACKTOP = i12;
  return i13 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i10 | 0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 104 >> 2] | 0, i11 | 0, i9 | 0) | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 i13 = i1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN28InstanceIdToObjectPtrHashMapC2Ei(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP32[i5 + 4 >> 2] = 0;
 i6 = i5 + 8 | 0;
 HEAP8[i6 >> 0] = 0;
 i3 = i5 + 9 | 0;
 HEAP8[i3 >> 0] = 0;
 i1 = i5 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = 32;
 while (1) {
  if (i1 >>> 0 >= i2 >>> 0) if (!(Math_fround(Math_fround(i1 >>> 0) * Math_fround(.5)) <= Math_fround(0.0))) break;
  i1 = i1 << 1;
 }
 i2 = i5 + 32 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 + 36 >> 2] = 0;
 i8 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 52 >> 2] = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 f10 = Math_fround(i1 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f10 * Math_fround(.5)) >>> 0;
 HEAP32[i5 + 40 >> 2] = ~~Math_fround(f10 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 HEAP8[i3 >> 0] = 1;
 i3 = i5 + 20 | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = -1;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 65;
 HEAP32[i4 + 4 >> 2] = i8;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 28 >> 2] = i1;
 i2 = i1 + (HEAP32[i2 >> 2] << 3) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv(i5);
  HEAP8[i6 >> 0] = 1;
  i9 = i5 + 12 | 0;
  i8 = i9;
  HEAP32[i8 >> 2] = -2;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 do {
  i4 = i3;
  i8 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv(i5);
 HEAP8[i6 >> 0] = 1;
 i9 = i5 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = -2;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN9JSONWrite8TransferI4AABBEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1034411 | 0, 0);
 __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i10, i11 + 12 | 0, gb + 1034420 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN7mecanim9animation24CreateControllerConstantEjPPNS0_13LayerConstantEjPPNS_12statemachine20StateMachineConstantEPNS_18ValueArrayConstantEPNS_10ValueArrayEjRNS_6memory9AllocatorE(i3, i5, i7, i9, i10, i11, i1, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i8 = 0, i12 = 0;
 i8 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 24, 4) | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i8 >> 2] = i3;
 i4 = i8 + 4 | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i2 = i4;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i4 >> 2] = i1;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i3 | 0) {
  i2 = i1 + i2 | 0;
  i1 = 0;
  do {
   i4 = i2 + (i1 << 2) | 0;
   i12 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   HEAP32[i4 >> 2] = i12 | 0 ? i12 - i4 | 0 : 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i8 + 12 | 0;
 if (!i7) i1 = 0; else {
  i2 = i7 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i7 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i2 = i4;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i4 >> 2] = i1;
 i3 = HEAP32[i3 >> 2] | 0;
 if (!i3) {
  i12 = i8 + 16 | 0;
  i9 = (i10 | 0) != 0;
  i7 = i10;
  i10 = i12;
  i10 = i7 - i10 | 0;
  i10 = i9 ? i10 : 0;
  HEAP32[i12 >> 2] = i10;
  i12 = i8 + 20 | 0;
  i10 = (i11 | 0) != 0;
  i9 = i11;
  i11 = i12;
  i11 = i9 - i11 | 0;
  i11 = i10 ? i11 : 0;
  HEAP32[i12 >> 2] = i11;
  return i8 | 0;
 }
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  i12 = i2 + (i1 << 2) | 0;
  i7 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  HEAP32[i12 >> 2] = i7 | 0 ? i7 - i12 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 i12 = i8 + 16 | 0;
 i9 = (i10 | 0) != 0;
 i7 = i10;
 i10 = i12;
 i10 = i7 - i10 | 0;
 i10 = i9 ? i10 : 0;
 HEAP32[i12 >> 2] = i10;
 i12 = i8 + 20 | 0;
 i10 = (i11 | 0) != 0;
 i9 = i11;
 i11 = i12;
 i11 = i9 - i11 | 0;
 i11 = i10 ? i11 : 0;
 HEAP32[i12 >> 2] = i11;
 return i8 | 0;
}

function __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i12, i11, i3) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i10 = i12 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = ((i4 >>> 30) + -1 | 0) >>> 0 < 2;
 if (i2) i1 = HEAP32[i12 >> 2] | 0; else i1 = 0;
 if (i4 >>> 0 > 3221225471) {
  STACKTOP = i13;
  return;
 }
 if (i1 | 0) if (HEAP8[i1 + 2433 >> 0] | 0) {
  i1 = i12 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i12 >> 2] | 0, i4 >>> 24 & 15) | 0;
   HEAP32[i1 >> 2] = i2;
  }
  i4 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i12 >> 2] | 0;
  L13 : do if ((i4 | 0) != -1) {
   i5 = HEAP32[i8 + 2528 >> 2] | 0;
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if (i7 | 0) {
    i3 = 0;
    while (1) {
     i1 = i5 + (i3 + i4 << 2) | 0;
     i3 = i3 + 1 | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) break;
     if (i3 >>> 0 >= i7 >>> 0) break L13;
    }
    HEAP32[i1 >> 2] = HEAP32[i5 + (i4 + -1 + i7 << 2) >> 2];
    HEAP32[i6 >> 2] = i7 + -1;
    STACKTOP = i13;
    return;
   }
  } while (0);
  i1 = i2 + 8 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) == -1) {
   i7 = i8 + 2528 | 0;
   i8 = HEAP32[i8 + 2532 >> 2] | 0;
   i6 = i8 + (HEAP32[i12 + 20 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i7, i6, i9);
   HEAP32[i1 >> 2] = i8;
   i1 = (HEAP32[i7 >> 2] | 0) + (i8 << 2) | 0;
  } else i1 = (HEAP32[i8 + 2528 >> 2] | 0) + (i3 << 2) | 0;
  i9 = i2 + 12 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  HEAP32[i1 + (i8 << 2) >> 2] = i11;
  HEAP32[i9 >> 2] = i8 + 1;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i12 >> 2] | 0, i12);
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
  STACKTOP = i13;
  return;
 }
 i1 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i11 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i11 | 0;
 HEAP32[i1 >> 2] = -1;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i12 >> 2] | 0) == 0 | i3 ^ 1) {
  STACKTOP = i13;
  return;
 }
 __ZN5physx2Sc9ActorCore14reinsertShapesEv(i1);
 STACKTOP = i13;
 return;
}

function __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 if (!(__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i13, i3, 0, 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 934273 | 0, 0, gb + 930755 | 0, 637, 1, 0, 0, 0);
  STACKTOP = i14;
  return;
 }
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i11 = f6 < Math_fround(0.0);
 f6 = i11 ? Math_fround(0.0) : f6;
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i11 = f8 < Math_fround(0.0);
 f8 = i11 ? Math_fround(0.0) : f8;
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i11 = f7 < Math_fround(0.0);
 f7 = i11 ? Math_fround(0.0) : f7;
 f2 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i11 = f2 < Math_fround(0.0);
 f2 = i11 ? Math_fround(0.0) : f2;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i12 = HEAP32[i3 + 8 >> 2] | 0;
 if ((i12 | 0) > 0) {
  i5 = f2 > Math_fround(1.0);
  i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f2) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i4 = f7 > Math_fround(1.0);
  i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i15 = f8 > Math_fround(1.0);
  i15 = ~~Math_fround(Math_fround((i15 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = f6 > Math_fround(1.0);
  i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i10 = HEAP32[i3 + 16 >> 2] | 0;
  i9 = i3 + 12 | 0;
  i5 = i15 << 16 & 16711680 | i1 << 8 & 65280 | i4 << 24 | i5 & 255;
  if ((i11 | 0) > 0) {
   i3 = 0;
   do {
    i1 = i10 + (Math_imul(HEAP32[i9 >> 2] | 0, i3) | 0) | 0;
    i4 = 0;
    while (1) {
     HEAP32[i1 >> 2] = i5;
     i4 = i4 + 1 | 0;
     if ((i4 | 0) == (i11 | 0)) break; else i1 = i1 + 4 | 0;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != (i12 | 0));
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 192 >> 2] | 0, i13 | 0);
 STACKTOP = i14;
 return;
}

function __ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i9 = i10;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i5 = i2 + 12 | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = HEAP32[i2 + 24 >> 2] | 0;
 L6 : do if ((i1 | 0) < (i6 | 0)) {
  i3 = HEAP32[i2 + 44 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) break L6;
  }
  if ((i1 | 0) >= 0) {
   f11 = Math_fround(__ZNK19ShaderPropertySheet24GetFloatValueInsRGBSpaceEi(i5, i1));
   STACKTOP = i10;
   return Math_fround(f11);
  }
 } while (0);
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  f11 = Math_fround(0.0);
  STACKTOP = i10;
  return Math_fround(f11);
 }
 HEAP32[i9 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) if (!(HEAP32[i1 + 4 >> 2] | 0)) {
   i9 = HEAP32[i4 >> 2] | 0;
   __Z31ReadObjectFromPersistentManageri(i9) | 0;
   STACKTOP = i10;
   return Math_fround(0.0);
  } else {
   f11 = Math_fround(0.0);
   STACKTOP = i10;
   return Math_fround(f11);
  }
 }
 i9 = HEAP32[i4 >> 2] | 0;
 __Z31ReadObjectFromPersistentManageri(i9) | 0;
 STACKTOP = i10;
 return Math_fround(0.0);
}

function __ZN5physx2Sn5ConvX20convertExtraData_PtrEPKcS3_RKNS0_15PxMetaDataEntryEiii(i11, i10, i1, i4, i3, i2, i5) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 32 | 0;
 i1 = i9 + 16 | 0;
 i7 = i9 + 72 | 0;
 i6 = i9 + 40 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 i2 = Math_imul(i2, i3) | 0;
 HEAP32[i7 + 12 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i6 + 16 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = Math_imul(i5, i3) | 0;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i11, 1, gb + 669174 | 0, i9);
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i11, 1, gb + 669191 | 0, i9 + 8 | 0);
 i3 = HEAPU8[i10 >> 0] | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i5;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i11, 1, gb + 669238 | 0, i1);
 if ((i2 | 0) > 1) i1 = 1; else {
  __ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_(i11, i10, i7, i6);
  i11 = i10 + i2 | 0;
  STACKTOP = i9;
  return i11 | 0;
 }
 do {
  i4 = i10 + i1 | 0;
  i5 = HEAPU8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i8 + 4 >> 2] = i5;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i11, 1, gb + 669252 | 0, i8);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_(i11, i10, i7, i6);
 i11 = i10 + i2 | 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f(i10, i1, f11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i9 = i1;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i10 + 4 | 0;
 i5 = i8 >> 5;
 i6 = 1 << (i8 & 31);
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i6 & HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2])) {
  HEAP32[i1 >> 2] = i2 + 1;
  L3 : do if ((i2 | 0) > 0) {
   i1 = i2;
   while (1) {
    i2 = i1 + 1 >> 1;
    i3 = i2 + -1 | 0;
    f4 = Math_fround(HEAPF32[i10 + 20 + (i3 << 2) >> 2]);
    if (f4 <= f11) break L3;
    HEAPF32[i10 + 20 + (i1 << 2) >> 2] = f4;
    i13 = i10 + 8020 + (i3 << 3) | 0;
    i12 = HEAP32[i13 + 4 >> 2] | 0;
    i1 = i10 + 8020 + (i1 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i1 + 4 >> 2] = i12;
    if ((i2 | 0) > 1) i1 = i3; else {
     i1 = i3;
     break;
    }
   }
  } else i1 = i2; while (0);
  HEAPF32[i10 + 20 + (i1 << 2) >> 2] = f11;
  i13 = i10 + 8020 + (i1 << 3) | 0;
  HEAP32[i13 >> 2] = i8;
  HEAP32[i13 + 4 >> 2] = i9;
  i13 = (HEAP32[i7 >> 2] | 0) + (i5 << 2) | 0;
  HEAP32[i13 >> 2] = i6 | HEAP32[i13 >> 2];
  i13 = 1;
  return i13 | 0;
 }
 if ((i2 | 0) > 0) i1 = 0; else {
  i13 = 0;
  return i13 | 0;
 }
 while (1) {
  if ((HEAP32[i10 + 8020 + (i1 << 3) >> 2] | 0) == (i8 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = 0;
   i3 = 14;
   break;
  }
 }
 if ((i3 | 0) == 14) return i1 | 0;
 i2 = i10 + 20 + (i1 << 2) | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) <= f11) {
  i13 = 0;
  return i13 | 0;
 }
 HEAPF32[i2 >> 2] = f11;
 L21 : do if ((i1 | 0) > 0) while (1) {
  i2 = i1 + 1 >> 1;
  i3 = i2 + -1 | 0;
  f4 = Math_fround(HEAPF32[i10 + 20 + (i3 << 2) >> 2]);
  if (f4 <= f11) break L21;
  HEAPF32[i10 + 20 + (i1 << 2) >> 2] = f4;
  i7 = i10 + 8020 + (i3 << 3) | 0;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  i13 = i10 + 8020 + (i1 << 3) | 0;
  HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  if ((i2 | 0) > 1) i1 = i3; else {
   i1 = i3;
   break;
  }
 } while (0);
 HEAPF32[i10 + 20 + (i1 << 2) >> 2] = f11;
 i13 = i10 + 8020 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i13 + 4 >> 2] = i9;
 i13 = 1;
 return i13 | 0;
}

function __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f10 * Math_fround(-.488602519));
 f16 = Math_fround(f11 * Math_fround(.488602519));
 f15 = Math_fround(f9 * Math_fround(-.488602519));
 f14 = Math_fround(Math_fround(f9 * f10) * Math_fround(1.09254849));
 f13 = Math_fround(Math_fround(f10 * f11) * Math_fround(-1.09254849));
 f12 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(-.333333343)) * Math_fround(.946174681));
 f11 = Math_fround(Math_fround(f9 * f11) * Math_fround(-1.09254849));
 f10 = Math_fround(Math_fround(Math_fround(f9 * f9) - Math_fround(f10 * f10)) * Math_fround(.546274245));
 HEAPF32[i6 + 36 >> 2] = f10;
 HEAPF32[i6 + 40 >> 2] = f10;
 HEAPF32[i6 + 44 >> 2] = f10;
 f9 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.95679307));
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(2.95679307));
 f7 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * Math_fround(2.95679307));
 f17 = Math_fround(f17 * Math_fround(-.325734973));
 f16 = Math_fround(f16 * Math_fround(.325734973));
 f15 = Math_fround(f15 * Math_fround(-.325734973));
 HEAPF32[i6 >> 2] = Math_fround(.0795774683);
 HEAPF32[i6 + 4 >> 2] = f17;
 HEAPF32[i6 + 8 >> 2] = f16;
 HEAPF32[i6 + 12 >> 2] = f15;
 f13 = Math_fround(f13 * Math_fround(-.273137093));
 f12 = Math_fround(f12 * Math_fround(.0788478925));
 f11 = Math_fround(f11 * Math_fround(-.273137093));
 HEAPF32[i6 + 16 >> 2] = Math_fround(f14 * Math_fround(.273137093));
 HEAPF32[i6 + 20 >> 2] = f13;
 HEAPF32[i6 + 24 >> 2] = f12;
 HEAPF32[i6 + 28 >> 2] = f11;
 HEAPF32[i6 + 32 >> 2] = Math_fround(f10 * Math_fround(.136568546));
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 __ZN20SphericalHarmonicsL217AddToCoefficientsEPKN4math7_float4EPKf(i1, i6, i5);
 STACKTOP = i4;
 return;
}

function __Z20UnloadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 if (__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1162872 >> 2] | 0, i5) | 0) {
  i4 = HEAP32[gb + 1162872 >> 2] | 0;
  i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_(i4, i2, i5) | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i1 = __Znwj(32) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i5);
   HEAP32[i1 + 28 >> 2] = 0;
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   if (i2) {
    HEAP32[i4 >> 2] = i2;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i1);
   i4 = i4 + 8 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  }
 }
 i4 = HEAP32[gb + 1162872 >> 2] | 0;
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_(i4, i5) | 0;
 if ((i3 | 0) == (i4 + 4 | 0)) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
 __ZdlPv(i3);
 STACKTOP = i6;
 return;
}

function __ZNK5physx18PxsDynamicsContext17integrateAtomPoseEPNS_12PxsRigidBodyERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERKNS_6PxVec3ESB_(i8, i5, i9, i7, i6) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 i3 = i7 + 4 | 0;
 HEAP32[i11 + 4 >> 2] = HEAP32[i3 >> 2];
 i4 = i7 + 8 | 0;
 HEAP32[i11 + 8 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i11 + 16 >> 2] = HEAP32[i6 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i11 + 20 >> 2] = HEAP32[i1 >> 2];
 i2 = i6 + 8 | 0;
 HEAP32[i11 + 24 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i11 + 28 >> 2] = Math_fround(0.0);
 i8 = i8 + 124 | 0;
 __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf(HEAP32[i5 + 64 >> 2] | 0, i5, i11, Math_fround(HEAPF32[i8 >> 2]));
 if (!(Math_fround(HEAPF32[i8 >> 2]) != Math_fround(0.0))) {
  STACKTOP = i10;
  return;
 }
 i11 = Math_fround(HEAPF32[i7 >> 2]) == Math_fround(0.0);
 i11 = i11 & Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0);
 if (i11 & Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0)) {
  i11 = Math_fround(HEAPF32[i6 >> 2]) == Math_fround(0.0);
  i11 = i11 & Math_fround(HEAPF32[i1 >> 2]) == Math_fround(0.0);
  if (i11 & Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) {
   STACKTOP = i10;
   return;
  }
 }
 i6 = HEAP32[i5 + 72 >> 2] | 0;
 if ((i6 | 0) == 1073741823) {
  STACKTOP = i10;
  return;
 }
 i2 = (i6 + 32 | 0) >>> 5;
 i3 = i9 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i3 >> 2] & 2147483647) >>> 0) {
  i4 = i9 + 8 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i2 << 2, gb + 769739 | 0, 329) | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  if (i5 | 0) {
   _memcpy(i1 | 0, i5 | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i9 >> 2] | 0);
  }
  i11 = HEAP32[i3 >> 2] | 0;
  _memset(i1 + ((i11 & 2147483647) << 2) | 0, 0, i2 - i11 << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
 } else i1 = HEAP32[i9 >> 2] | 0;
 i11 = i1 + (i6 >>> 5 << 2) | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << (i6 & 31);
 STACKTOP = i10;
 return;
}

function __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE(i16, i2, i17, i1) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19;
 HEAP32[i18 >> 2] = 0;
 HEAP32[i18 + 4 >> 2] = 0;
 HEAP32[i18 + 8 >> 2] = 0;
 HEAP32[i18 + 12 >> 2] = 0;
 HEAP32[i18 + 16 >> 2] = 0;
 HEAP32[i18 + 20 >> 2] = 0;
 HEAP32[i18 + 24 >> 2] = 0;
 HEAP32[i18 + 28 >> 2] = 0;
 i15 = HEAP32[i1 + 16 >> 2] | 0;
 i13 = HEAP32[i1 + 20 >> 2] | 0;
 i9 = HEAP32[i16 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f14 * Math_fround(HEAPF32[i17 + (i9 * 12 | 0) >> 2]));
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f12 * Math_fround(HEAPF32[i17 + (i9 * 12 | 0) + 4 >> 2])));
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i11 = i9;
 f3 = Math_fround(f3 + Math_fround(f10 * Math_fround(HEAPF32[i17 + (i9 * 12 | 0) + 8 >> 2])));
 while (1) {
  i1 = HEAP16[i15 + (i11 << 2) >> 1] | 0;
  i2 = HEAP16[i15 + (i11 << 2) + 2 >> 1] | 0;
  HEAP32[i16 >> 2] = i11;
  if (!(i1 << 16 >> 16)) {
   i1 = 10;
   break;
  }
  i4 = i1;
  f8 = f3;
  i9 = i11;
  i1 = i13 + (i2 & 65535) | 0;
  L4 : while (1) {
   i2 = i4;
   i7 = i1;
   while (1) {
    i2 = i2 + -1 << 16 >> 16;
    i1 = HEAPU8[i7 >> 0] | 0;
    i7 = i7 + 1 | 0;
    i4 = i18 + (i1 >>> 5 << 2) | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    i6 = 1 << (i1 & 31);
    if (!(i6 & i5)) {
     HEAP32[i4 >> 2] = i6 | i5;
     f3 = Math_fround(f14 * Math_fround(HEAPF32[i17 + (i1 * 12 | 0) >> 2]));
     f3 = Math_fround(f3 + Math_fround(f12 * Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 4 >> 2])));
     f3 = Math_fround(f3 + Math_fround(f10 * Math_fround(HEAPF32[i17 + (i1 * 12 | 0) + 8 >> 2])));
     if (f3 > f8) {
      i5 = i7;
      break;
     }
    }
    if (!(i2 << 16 >> 16)) {
     f3 = f8;
     i1 = i9;
     break L4;
    }
   }
   if (!(i2 << 16 >> 16)) break; else {
    i4 = i2;
    f8 = f3;
    i9 = i1;
    i1 = i5;
   }
  }
  if ((i1 | 0) == (i11 | 0)) {
   i1 = 10;
   break;
  } else i11 = i1;
 }
 if ((i1 | 0) == 10) {
  STACKTOP = i19;
  return;
 }
}

function __ZNSt3__28ios_base4swapERS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i1 + 4 | 0;
 i7 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i6;
 i7 = i1 + 8 | 0;
 i6 = i2 + 8 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 i6 = i1 + 12 | 0;
 i5 = i2 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i7;
 i5 = i1 + 16 | 0;
 i7 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i6;
 i7 = i1 + 20 | 0;
 i6 = i2 + 20 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 i6 = i1 + 28 | 0;
 i5 = i2 + 28 | 0;
 __ZNSt3__26localeC2ERKS0_(i4, i6);
 __ZNSt3__26localeaSERKS0_(i6, i5) | 0;
 __ZNSt3__26localeaSERKS0_(i5, i4) | 0;
 __ZNSt3__26localeD2Ev(i4);
 i4 = i1 + 32 | 0;
 i5 = i2 + 32 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 36 | 0;
 i6 = i2 + 36 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 40 | 0;
 i4 = i2 + 40 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 44 | 0;
 i5 = i2 + 44 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 48 | 0;
 i6 = i2 + 48 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 52 | 0;
 i4 = i2 + 52 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 56 | 0;
 i5 = i2 + 56 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 60 | 0;
 i6 = i2 + 60 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 64 | 0;
 i4 = i2 + 64 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 68 | 0;
 i2 = i2 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZN5physx18PxcNpThreadContextC2EfffRKNS_2Cm12RenderOutputERNS_17PxcNpMemBlockPoolEb(i6, f4, f1, f7, i5, i3, i2) {
 i6 = i6 | 0;
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 f7 = Math_fround(f7);
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i6 + 32 >> 2] = HEAP32[i5 + 32 >> 2];
 HEAP32[i6 + 36 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i5 + 40 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i6 + 48 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i5 + 52 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i5 + 56 >> 2];
 HEAP32[i6 + 60 >> 2] = HEAP32[i5 + 60 >> 2];
 HEAP32[i6 + 64 >> 2] = HEAP32[i5 + 64 >> 2];
 HEAP32[i6 + 68 >> 2] = HEAP32[i5 + 68 >> 2];
 HEAP32[i6 + 72 >> 2] = HEAP32[i5 + 72 >> 2];
 HEAP32[i6 + 76 >> 2] = HEAP32[i5 + 76 >> 2];
 HEAP32[i6 + 80 >> 2] = HEAP32[i5 + 80 >> 2];
 HEAP32[i6 + 84 >> 2] = HEAP32[i5 + 84 >> 2];
 HEAP32[i6 + 88 >> 2] = HEAP32[i5 + 88 >> 2];
 HEAP32[i6 + 92 >> 2] = HEAP32[i5 + 92 >> 2];
 HEAP32[i6 + 96 >> 2] = HEAP32[i5 + 96 >> 2];
 HEAP32[i6 + 100 >> 2] = HEAP32[i5 + 100 >> 2];
 HEAP32[i6 + 300 >> 2] = 0;
 HEAP32[i6 + 304 >> 2] = 0;
 HEAP32[i6 + 308 >> 2] = 0;
 HEAP32[i6 + 312 >> 2] = i3;
 HEAP32[i6 + 316 >> 2] = i3;
 HEAP32[i6 + 320 >> 2] = 0;
 HEAP32[i6 + 324 >> 2] = 0;
 HEAP32[i6 + 332 >> 2] = i3;
 HEAP32[i6 + 336 >> 2] = 0;
 HEAP32[i6 + 340 >> 2] = 0;
 __ZN5physx26PxcFrictionPatchStreamPairC2ERNS_17PxcNpMemBlockPoolE(i6 + 344 | 0, i3);
 __ZN5physx20PxcNpCacheStreamPairC2ERNS_17PxcNpMemBlockPoolE(i6 + 356 | 0, i3);
 HEAP32[i6 + 8748 >> 2] = 0;
 HEAP8[i6 + 8756 >> 0] = 0;
 HEAP8[i6 + 8757 >> 0] = 0;
 HEAP8[i6 + 8758 >> 0] = i2 & 1;
 HEAP8[i6 + 8759 >> 0] = 0;
 HEAPF32[i6 + 8768 >> 2] = f7;
 HEAPF32[i6 + 8772 >> 2] = f1;
 HEAPF32[i6 + 4484 >> 2] = f4;
 _memset(i6 + 104 | 0, 0, 196) | 0;
 HEAP32[i6 + 8760 >> 2] = 0;
 HEAP32[i6 + 8764 >> 2] = 0;
 return;
}

function __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK9Rigidbody(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i4 + 136 >> 2] | 0;
 i9 = i4 + 140 | 0;
 i3 = i1;
 i2 = i1;
 if ((i3 | 0) != (i9 | 0)) if (HEAP8[i3 + 24 >> 0] | 0) while (1) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i9 | 0)) {
   i1 = i9;
   break;
  }
  if (!(HEAP8[i1 + 24 >> 0] | 0)) break; else i2 = i1;
 }
 i2 = i1;
 if ((i2 | 0) == (i9 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 4 | 0;
 i5 = i4 + 104 | 0;
 L21 : while (1) {
  i4 = i2 + 28 | 0;
  i2 = i2 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i4 >> 2] | 0) {
   i11 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i11 | 0) == (i7 | 0) | (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0) == (i7 | 0)) {
    i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0;
    HEAP32[i8 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2];
    HEAP32[i6 >> 2] = i11;
    i11 = __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_(i5, i8) | 0;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    HEAP8[i11 >> 0] = 0;
    HEAP32[i11 + 4 >> 2] = i3;
    HEAP32[i11 + 8 >> 2] = i4;
   }
  }
  while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i9 | 0)) {
    i1 = 24;
    break L21;
   }
   if (!(HEAP8[i2 + 24 >> 0] | 0)) break; else i1 = i2;
  }
  if ((i2 | 0) == (i9 | 0)) {
   i1 = 24;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == 24) {
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS9_RSA_EE(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i1 = HEAP32[i15 >> 2] | 0;
 i17 = i15 + 4 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i14 = i16 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i14;
  i4 = i15;
  i2 = HEAP32[i14 >> 2] | 0;
 } else {
  i13 = i12 + 4 | 0;
  i10 = i2;
  i2 = HEAP32[i14 >> 2] | 0;
  do {
   i9 = i10;
   i10 = i10 + -20 | 0;
   HEAP8[i2 + -20 >> 0] = HEAP8[i10 >> 0] | 0;
   i6 = i2 + -16 | 0;
   i7 = i9 + -16 | 0;
   i3 = HEAP32[i9 + -4 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   i11 = i2 + -12 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i2 + -8 >> 2] = 0;
   i4 = i2 + -4 | 0;
   HEAP32[i4 >> 2] = i3;
   i9 = i9 + -12 | 0;
   i5 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = i5 >> 3;
   if (i8 | 0) {
    if ((i5 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
     i3 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = 37;
    HEAP32[i13 >> 2] = i3;
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i11 >> 2] = i4;
    HEAP32[i6 >> 2] = i4;
    HEAP32[i2 + -8 >> 2] = i4 + (i8 << 3);
    i3 = HEAP32[i7 >> 2] | 0;
    i2 = (HEAP32[i9 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i2 >> 3 << 3);
    }
   }
   i2 = (HEAP32[i14 >> 2] | 0) + -20 | 0;
   HEAP32[i14 >> 2] = i2;
  } while ((i10 | 0) != (i1 | 0));
  i3 = i14;
  i4 = i15;
  i1 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i14 = i16 + 8 | 0;
 i13 = HEAP32[i17 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i13;
 i14 = i15 + 8 | 0;
 i17 = i16 + 12 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i15;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 52 | 0;
 i3 = i2;
 i4 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i2 + 56 >> 2] = 1065353216;
 HEAP32[i2 + 60 >> 2] = 1065353216;
 HEAP32[i2 + 64 >> 2] = 1065353216;
 i1 = i2 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 1065353216;
 HEAP32[i2 + 96 >> 2] = 1065353216;
 HEAP32[i2 + 100 >> 2] = 1065353216;
 HEAP32[i2 + 104 >> 2] = 1065353216;
 i1 = i2 + 108 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 1065353216;
 HEAP32[i2 + 136 >> 2] = 1065353216;
 HEAP32[i2 + 140 >> 2] = 1065353216;
 HEAP32[i2 + 144 >> 2] = 1065353216;
 i1 = i2 + 148 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 172 >> 2] = 1065353216;
 HEAP32[i2 + 176 >> 2] = 1065353216;
 HEAP32[i2 + 180 >> 2] = 1065353216;
 HEAP32[i2 + 184 >> 2] = 1065353216;
 i1 = i2 + 188 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 212 >> 2] = 1065353216;
 HEAP32[i2 + 216 >> 2] = 1065353216;
 HEAP32[i2 + 220 >> 2] = 1065353216;
 HEAP32[i2 + 224 >> 2] = 1065353216;
 i1 = i2 + 228 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 252 >> 2] = 1065353216;
 HEAP32[i2 + 256 >> 2] = 1065353216;
 HEAP32[i2 + 260 >> 2] = 1065353216;
 HEAP32[i2 + 264 >> 2] = 1065353216;
 i1 = i2 + 316 | 0;
 i3 = i2 + 268 | 0;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i2 + 320 >> 2] = 1065353216;
 HEAP32[i2 + 324 >> 2] = 1065353216;
 HEAP32[i2 + 328 >> 2] = 1065353216;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i7, i2, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i7 >> 2] | 0)) {
   i8 = i2;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i7 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
  }
  HEAP32[i7 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i7 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i7 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 2) | 0, 0, i6 - i5 << 2 | 0) | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + (i6 * 24 | 0) | 0;
 if (i6 | 0) {
  i5 = i10 + 20 | 0;
  i6 = i10 + 16 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = gb + 1048681;
   HEAP32[i6 >> 2] = 2;
   __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i10, i3, gb + 1048690 | 0, 4194305, 0);
   if ((__ZN8JSONRead14GetDataVersionEv(i10) | 0) == 1) {
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 & 32 | 0) HEAP32[i3 >> 2] = i2 | -65536;
   }
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 148 | 0;
 i5 = i2 + 96 | 0;
 i6 = i2 + 48 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i11 = i1 + 32 | 0;
 i12 = i11;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 0;
 i11 = i11 + 4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN18BackgroundJobQueue21ExecuteMainThreadJobsEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i19 + 8 | 0;
 i2 = i19;
 i18 = i19 + 16 | 0;
 if (!(HEAP8[i14 + 21 >> 0] | 0)) {
  STACKTOP = i19;
  return;
 }
 i17 = gb + 63456 | 0;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i2;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 HEAP32[i18 >> 2] = 0;
 i15 = i18 + 12 | 0;
 HEAP32[i15 >> 2] = 0;
 i16 = i18 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 i17 = i18 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i12 = i1;
 i9 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i17;
 HEAP32[i13 >> 2] = i9;
 HEAP32[i13 + 4 >> 2] = i12;
 i13 = i14 + 12 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i2 = i12;
 if (i3) {
  i1 = HEAP32[i14 >> 2] | 0;
  if (!i1) {
   i6 = i14;
   i7 = i14 + 4 | 0;
   i8 = i18;
   i10 = 0;
   i11 = 0;
   i4 = 0;
   i5 = 0;
   i2 = i9;
   i1 = i12;
  } else {
   i7 = i14 + 4 | 0;
   __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i7, i2);
   i1 = i17;
   i6 = i14;
   i8 = i18;
   i10 = HEAP32[i14 >> 2] | 0;
   i11 = HEAP32[i18 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
   i4 = HEAP32[i15 >> 2] | 0;
   i5 = HEAP32[i16 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = i10;
  HEAP32[i6 >> 2] = i11;
  HEAP32[i15 >> 2] = i3;
  HEAP32[i13 >> 2] = i4;
  i12 = i14 + 16 | 0;
  HEAP32[i16 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i5;
  i12 = i7;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i17;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  i14 = i7;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i14 + 4 >> 2] = i1;
  if (HEAP32[i15 >> 2] | 0) {
   i1 = HEAP32[i18 >> 2] | 0;
   do {
    mftCall_vi(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
    i1 = i1 + 8 | 0;
   } while ((i1 | 0) != ((HEAP32[i18 >> 2] | 0) + (HEAP32[i15 >> 2] << 3) | 0));
  }
 }
 if ((HEAP32[i16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i18 >> 2] | 0, i17);
  HEAP32[i18 >> 2] = 0;
 }
 STACKTOP = i19;
 return;
}

function __ZN12MeshCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 40 | 0;
 i3 = i6;
 i4 = i1 + 36 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = __ZN12MeshCollider19ExtractMeshGeometryER8Vector3f(i1, i2) | 0;
 do if (!i5) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 736408 | 0, 0, gb + 736492 | 0, 218, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0); else if (!(HEAP8[i1 + 60 >> 0] | 0)) {
  HEAP32[i3 >> 2] = 5;
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  i7 = i3 + 8 | 0;
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  i1 = i3 + 12 | 0;
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 28 >> 2] = Math_fround(1.0);
  i8 = i3 + 32 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i8 = HEAP32[i4 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 56 >> 2] | 0, i8 | 0, i3 | 0) | 0;
  HEAP32[i3 + 36 >> 2] = i5;
  i8 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i8;
  HEAP32[i1 >> 2] = i5;
  i5 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i3 | 0);
  break;
 } else {
  HEAP32[i3 >> 2] = 4;
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  i1 = i3 + 8 | 0;
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  i8 = i3 + 12 | 0;
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 28 >> 2] = Math_fround(1.0);
  i7 = i3 + 32 | 0;
  HEAP32[i7 >> 2] = 0;
  i9 = HEAP32[i4 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i9 >> 2] | 0) + 52 >> 2] | 0, i9 | 0, i3 | 0) | 0;
  HEAP32[i7 >> 2] = i5;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i7;
  i8 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, i3 | 0);
  break;
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZN11LightProbes17SetLightProbeDataERKNS_14LightProbeDataE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11LightProbes14LightProbeDataaSERKS0_(i8 + 32 | 0, i1) | 0;
 i4 = HEAP32[i8 + 104 >> 2] | 0;
 i5 = i8 + 148 | 0;
 i6 = i8 + 160 | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i8 + 164 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4 * 108 | 0, 4, i8 + 152 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 108 | 0, 4, i8 + 152 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 108 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i5 >> 2] = i7;
  break;
 } while (0);
 i1 = i8 + 168 | 0;
 i7 = i8 + 180 | 0;
 HEAP32[i7 >> 2] = i4;
 i2 = i8 + 184 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i4 << 3, 4, i8 + 172 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i8 + 172 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  break;
 } while (0);
 _memset(HEAP32[i5 >> 2] | 0, 0, (HEAP32[i6 >> 2] | 0) * 108 | 0) | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i8 + 168 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 + (i1 << 3) >> 2] = -2;
  HEAP32[i8 + (i1 << 3) + 4 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE18__construct_at_endINS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESH_SH_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i4 + 4 | 0;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = i1;
 i6 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i5 = i2 + 16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i10 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i12 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i2, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i12 = 9; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i12 = 11;
    }
   }
   if ((i12 | 0) == 9) i12 = 11;
   if ((i12 | 0) == 11) {
    i12 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  HEAP32[i6 >> 2] = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  i6 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i6;
  if ((i1 | 0) == (i8 | 0)) break; else i2 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx16PxsIslandManager19addArticulationLinkERNS_20PxsIslandManagerHookIjLj4294967295EEE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 1 | 0;
 i7 = i10;
 i2 = i9 + 12 | 0;
 i3 = i9 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  i1 = HEAP32[i9 + 24 >> 2] | 0;
  if (!i1) {
   i5 = -1;
   i1 = i9 + 16 | 0;
   break;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 << 1 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = 5;
   break;
  }
 } else i4 = 5; while (0);
 if ((i4 | 0) == 5) {
  i4 = (HEAP32[i9 + 20 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = -1;
  i4 = i9 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = -1;
  HEAP8[i5 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i5 = i9 + 32 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i5 = i1;
  i1 = i4;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] = -1;
 HEAP32[i1 + (i5 * 12 | 0) >> 2] = -1;
 HEAP8[i1 + (i5 * 12 | 0) + 8 >> 0] = 66;
 i1 = i9 + 308 | 0;
 i2 = i9 + 312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i9 + 324 | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) {
  i11 = i3 << 1;
  i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i3 << 4, gb + 681489 | 0, 1482) | 0;
  i12 = i6 + (i11 << 2) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  i3 = i9 + 316 | 0;
  _memcpy(i12 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i9 + 320 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = i6;
  HEAP32[i3 >> 2] = i12;
  HEAP32[i4 >> 2] = i11;
  i7 = i6;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i7 + (i9 << 2) | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = HEAP32[i2 >> 2] | 0;
  i9 = i9 + 1 | 0;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i8 >> 2] = i5;
  STACKTOP = i10;
  return;
 } else {
  i11 = HEAP32[i1 >> 2] | 0;
  i12 = i3;
  i12 = i11 + (i12 << 2) | 0;
  HEAP32[i12 >> 2] = i5;
  i12 = HEAP32[i2 >> 2] | 0;
  i12 = i12 + 1 | 0;
  HEAP32[i2 >> 2] = i12;
  HEAP32[i8 >> 2] = i5;
  STACKTOP = i10;
  return;
 }
}

function __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_11djb2_hash_tIS6_ENS0_8equal_toIS6_EE13stl_allocatorINS0_4pairIKS6_S6_EEL18MemLabelIdentifier54ELi16EEEixERSD_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 32 | 0;
 i7 = i9;
 i8 = i9 + 16 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  i6 = HEAP32[i2 + 64 >> 2] | 0;
  i1 = i5 + (i6 * 24 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_(i4, i2, i3);
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  i6 = HEAP32[i2 + 64 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i5 + (i6 * 24 | 0) | 0 : i5 + (i1 * 24 | 0) | 0;
 }
 if ((i1 | 0) != (i5 + (i6 * 24 | 0) | 0)) {
  i8 = i1;
  i8 = i8 + 12 | 0;
  STACKTOP = i9;
  return i8 | 0;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i3);
 i6 = i4 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12resize_deltaEjj(i2, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15insert_noresizeERKS9_(i8, i2, i4);
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i8 = i8 + 12 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i12 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 3) | 0, 0, i4 - i5 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i12);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN17GenericDynamicVBO17DrawChunkInternalERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationP16DrawBuffersRangeij(i9, i1, i10, i11, i12, i13, i14, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0, i1 | 0, 0) | 0;
 i1 = i15;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i5 = i15 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i15 + 12 >> 2] = i8;
 i6 = i15 + 4 | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i15 + 40 >> 2] = i12;
 i7 = i3 + 24 | 0;
 if ((i14 | 0) > 0) {
  i1 = i3 + 28 | 0;
  i2 = i8 + -1 | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   i3 = i2 + (HEAP32[i1 >> 2] | 0) | 0;
   i1 = 0;
   i2 = 0;
   do {
    i17 = i13 + (i2 << 5) + 16 | 0;
    i4 = ((i3 + (HEAP32[i17 >> 2] | 0) | 0) >>> 0) / (i8 >>> 0) | 0;
    HEAP32[i17 >> 2] = i4;
    i4 = i4 + (HEAP32[i13 + (i2 << 5) + 12 >> 2] | 0) + (HEAP32[i13 + (i2 << 5) + 20 >> 2] | 0) | 0;
    i1 = i1 >>> 0 < i4 >>> 0 ? i4 : i1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
  } else {
   i4 = HEAP32[i3 + 32 >> 2] | 0;
   i3 = i2 + (HEAP32[i1 >> 2] | 0) | 0;
   i1 = 0;
   i2 = 0;
   do {
    i18 = i13 + (i2 << 5) + 4 | 0;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + i4;
    i18 = i13 + (i2 << 5) + 12 | 0;
    i17 = ((i3 + (HEAP32[i18 >> 2] | 0) | 0) >>> 0) / (i8 >>> 0) | 0;
    HEAP32[i18 >> 2] = i17;
    i17 = (HEAP32[i13 + (i2 << 5) + 16 >> 2] | 0) + i17 + (HEAP32[i13 + (i2 << 5) + 20 >> 2] | 0) | 0;
    i1 = i1 >>> 0 < i17 >>> 0 ? i17 : i1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i14 | 0));
  }
 } else i1 = 0;
 i18 = i9 + 28 | 0;
 __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj(HEAP32[i18 >> 2] | 0, i15, i1, HEAP32[i10 >> 2] | 0, i11);
 i18 = HEAP32[i18 >> 2] | 0;
 mftCall_viiiiiiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 244 >> 2] | 0, i18 | 0, HEAP32[i7 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0, i13 | 0, i14 | 0, i12 | 0, i10 | 0);
 STACKTOP = i16;
 return;
}

function __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 368 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 340 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 344 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 348 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 352 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 356 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 360 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 364 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var f3 = f0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 12 | 0;
 i7 = i10;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f3 = Math_fround(f11 + Math_fround(Math_fround(Math_fround(f11 + f3) - Math_fround(f11 - f3)) * Math_fround(.25)));
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i6, i4);
 if (!(HEAP32[i1 + 36 >> 2] | 0)) {
  __ZNK9Transform18TransformDirectionERK8Vector3f(i7, i4, gb + 62548 | 0);
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  f11 = Math_fround(f8 * f8);
  f9 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f11 = Math_fround(f11 + Math_fround(f9 * f9));
  f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  f11 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f3 * f3))));
  f8 = Math_fround(f8 / f11);
  f9 = Math_fround(f9 / f11);
  f11 = Math_fround(f3 / f11);
  i7 = HEAP32[i1 + 44 >> 2] | 0;
  HEAPF32[i5 >> 2] = f8;
  HEAPF32[i5 + 4 >> 2] = f9;
  HEAPF32[i5 + 8 >> 2] = f11;
  HEAP32[i5 + 12 >> 2] = i7;
  i7 = 1;
  STACKTOP = i10;
  return i7 | 0;
 }
 f12 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i6, i2));
 f11 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 if (!(Math_fround(Math_fround(1.0) - Math_fround(f12 / Math_fround(f11 * f11))) > Math_fround(0.0))) {
  i7 = 0;
  STACKTOP = i10;
  return i7 | 0;
 }
 f13 = Math_fround(f8 - Math_fround(HEAPF32[i6 >> 2]));
 f11 = Math_fround(f3 - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f8 = Math_fround(f9 - Math_fround(HEAPF32[i6 + 8 >> 2]));
 f12 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f11 * f11)) + Math_fround(f8 * f8))));
 f9 = Math_fround(f13 / f12);
 f11 = Math_fround(f11 / f12);
 f12 = Math_fround(f8 / f12);
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f11;
 HEAPF32[i5 + 8 >> 2] = f12;
 HEAP32[i5 + 12 >> 2] = i7;
 i7 = 1;
 STACKTOP = i10;
 return i7 | 0;
}

function __ZN7b2World9DrawJointEP7b2Joint(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i4 = i10;
 i5 = i10 + 56 | 0;
 i6 = i10 + 48 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10 + 24 | 0;
 i9 = i10 + 16 | 0;
 i13 = (HEAP32[i2 + 52 >> 2] | 0) + 12 | 0;
 i14 = (HEAP32[i2 + 48 >> 2] | 0) + 12 | 0;
 i11 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i3;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i5 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, i2 | 0);
 HEAPF32[i7 >> 2] = Math_fround(.5);
 HEAPF32[i7 + 4 >> 2] = Math_fround(.800000011);
 HEAPF32[i7 + 8 >> 2] = Math_fround(.800000011);
 switch (HEAP32[i2 + 4 >> 2] | 0) {
 case 3:
  {
   i14 = HEAP32[i1 + 102988 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, i5 | 0, i6 | 0, i7 | 0);
   STACKTOP = i10;
   return;
  }
 case 4:
  {
   __ZNK13b2PulleyJoint16GetGroundAnchorAEv(i8, i2);
   __ZNK13b2PulleyJoint16GetGroundAnchorBEv(i9, i2);
   i14 = i1 + 102988 | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i8 | 0, i5 | 0, i7 | 0);
   i13 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i9 | 0, i6 | 0, i7 | 0);
   i14 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, i8 | 0, i9 | 0, i7 | 0);
   STACKTOP = i10;
   return;
  }
 case 5:
  {
   STACKTOP = i10;
   return;
  }
 default:
  {
   i14 = i1 + 102988 | 0;
   i13 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i3 | 0, i5 | 0, i7 | 0);
   i13 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 32 >> 2] | 0, i13 | 0, i5 | 0, i6 | 0, i7 | 0);
   i14 = HEAP32[i14 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 32 >> 2] | 0, i14 | 0, i4 | 0, i6 | 0, i7 | 0);
   STACKTOP = i10;
   return;
  }
 }
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 5) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 32 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 4) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 16 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sc5Scene31scheduleParticleShapeGenerationERNS_10PxBaseTaskES3_(i11, i2, i10) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i6 = i11 + 1696 | 0;
 i8 = i11 + 1784 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i3 = i11 + 1708 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i3) | 0;
 i4 = i11 + 1704 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 >> 2] = i2;
 i9 = i11 + 1744 | 0;
 i7 = i11 + 1740 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i11 + 1736 >> 2] | 0) + (i1 << 2) >> 2] = i2;
  HEAP32[i7 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11 + 1716 | 0, i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 i2 = i11 + 1780 | 0;
 HEAP8[i2 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i3) | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 >> 2] = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i11 + 1736 >> 2] | 0) + (i1 << 2) >> 2] = i10;
  HEAP32[i7 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11 + 1716 | 0, i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 HEAP8[i2 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 if (!(HEAP32[i11 + 148 >> 2] | 0)) {
  i11 = i6;
  STACKTOP = i12;
  return i11 | 0;
 } else {
  i11 = __ZN5physx2Sc17ParticleSystemSim23scheduleShapeGenerationERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i11 + 1204 >> 2] | 0, i11 + 144 | 0, i6) | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
  STACKTOP = i12;
  return i11 | 0;
 }
 return 0;
}

function __ZN9JSONWrite6UnwrapEPKc(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 i6 = i3 + 80 | 0;
 if (!i2) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i2;
 } else {
  i1 = i2;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 1048581;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i1 - i2;
  i1 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i6, i4) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + ((HEAP32[i6 + 4 >> 2] | 0) * 48 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i2 = i3 + 96 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i5);
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_17DeallocationEventEEEvT_(i13, i12) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = i12;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 256) i9 = -61; else if (i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < 65536) i9 = -45; else i9 = i2 >>> 0 < 1 | (i2 | 0) == 1 & i1 >>> 0 < 0 ? -29 : -13;
 i10 = i13 + 80 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i11 = i5 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3;
 i7 = i1 - i4 | 0;
 i2 = i7 + 2 | 0;
 i8 = i5 + 16 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i7 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i6 >> 2] = i2;
  i1 = i2 + i7 | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i8 >> 2] = i2 + i4;
 }
 HEAP8[i1 >> 0] = i9;
 HEAP8[i1 + 1 >> 0] = 63;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 2;
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i10, gb + 773712 | 0, i12, (i9 & 255) >>> 4 & 3);
 i7 = i13 + 20 | 0;
 i3 = i13 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4;
 i5 = (HEAP32[i7 >> 2] | 0) - i1 | 0;
 if (i5 >>> 0 < (HEAP32[i13 + 44 >> 2] | 0) >>> 0) return;
 i6 = HEAP32[i13 + 36 >> 2] | 0;
 if (i6) {
  i1 = i13 + 32 | 0;
  i2 = 0;
  do {
   i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i4 | 0, i5 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0);
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 148 | 0;
 i5 = i2 + 96 | 0;
 i6 = i2 + 48 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i11 = i1 + 32 | 0;
 i12 = i11;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 0;
 i11 = i11 + 4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN31CanvasBatchIntermediateRenderer10InitializeEPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS4_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i13, i1, i7, i8, i9, i10, i14, i11, i15, i12, i3, i4, i5) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i16 = 0;
 if (i1 | 0) {
  i6 = i13 + 268 | 0;
  i2 = i1 + 436 | 0;
  if ((i6 | 0) != (i2 | 0)) {
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i1) i1 = i13 + 272 | 0; else {
    i16 = i13 + 272 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i16 >> 2];
    HEAP32[HEAP32[i16 >> 2] >> 2] = i1;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i16 >> 2] = 0;
    i1 = i16;
   }
   i16 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i16;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i16 + 4 >> 2] = i6;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i6;
  }
 }
 HEAP16[i13 + 296 >> 1] = i11;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i13 + 280 >> 2] = i7;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i13 + 284 >> 2] = i10;
 HEAP32[i13 + 292 >> 2] = i8;
 HEAP32[i13 + 288 >> 2] = i9;
 HEAP32[i13 + 252 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 260 >> 2] = i3 >>> 0 > 31 ? 0 : i3;
 i1 = i13 + 236 | 0;
 i2 = (i5 & 1) << 8 | i4 << 6 & 192 | (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773183;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i13 + 4 | 0;
 i2 = i14;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i13 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i14, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0;
 i16 = i13 + 156 | 0;
 HEAP32[i16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i16 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i16 + 16 >> 2] = HEAP32[i15 + 16 >> 2];
 HEAP32[i16 + 20 >> 2] = HEAP32[i15 + 20 >> 2];
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i15, i14, i13 + 132 | 0);
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0);
 HEAP8[i13 + 240 >> 0] = 0;
 HEAP8[i13 + 241 >> 0] = 0;
 return;
}

function __ZN16BlendShapeVertex8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 602071 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i4, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 428867 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 428913 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 944884 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 24; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 24; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 24) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 40 | 0;
 i7 = i9;
 i8 = i6 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i3 = i6;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __Z30scripting_stack_trace_info_forP15Il2CppExceptionR14StackTraceInfo(i1, i6);
 if (!i2) {
  i1 = i6;
  i2 = i6 + 11 | 0;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i3 = _strlen(i2) | 0;
  i4 = i6 + 11 | 0;
  i1 = HEAP8[i4 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i2, i3, i1 + i3 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i7) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = i6;
  i2 = i4;
 }
 i10 = i7 + 20 | 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i6;
 i4 = i6 + 12 | 0;
 HEAP32[i7 + 4 >> 2] = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i3 = i6 + 24 | 0;
 HEAP32[i7 + 8 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i7 + 16 >> 2] = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
 HEAP32[i10 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i7 + 24 >> 2] = 131332;
 HEAP32[i7 + 28 >> 2] = i5;
 __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 148 | 0;
 i5 = i2 + 96 | 0;
 i6 = i2 + 48 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i11 = i1 + 32 | 0;
 i12 = i11;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 0;
 i11 = i11 + 4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z50ScriptingGetComponentsOfTypeFromGameObjectFastPathP10GameObjectP12Il2CppObject(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i6 = __Z21GetManagerFromContexti(5) | 0;
 i7 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i9) | 0;
 i2 = HEAP32[i6 + 200 >> 2] | 0;
 i6 = HEAP32[i6 + 204 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i7 >>> 0;
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) >>> 0 <= i7 >>> 0) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i8, i1) | 0;
   if (!i3) {
    i13 = 0;
    STACKTOP = i12;
    return i13 | 0;
   }
   i1 = HEAP32[i3 + 20 >> 2] | 0;
   if (i1 | 0) {
    i13 = i1;
    STACKTOP = i12;
    return i13 | 0;
   }
   i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
   if ((i1 | 0) == (gb + 27592 | 0)) {
    i13 = 0;
    STACKTOP = i12;
    return i13 | 0;
   }
   while (1) {
    i2 = __Z21GetManagerFromContexti(5) | 0;
    i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
    if (i2 | 0) break;
    i1 = HEAP32[i1 >> 2] | 0;
    if ((i1 | 0) == (gb + 28304 | 0)) {
     i1 = 0;
     i11 = 13;
     break;
    }
   }
   if ((i11 | 0) == 13) {
    STACKTOP = i12;
    return i1 | 0;
   }
   i13 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
   STACKTOP = i12;
   return i13 | 0;
  }
 }
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP8[i10 + 12 >> 0] = 0;
 HEAP8[i10 + 13 >> 0] = 1;
 HEAP8[i10 + 14 >> 0] = 1;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP8[i10 + 20 >> 0] = 1;
 HEAP8[i10 + 21 >> 0] = 1;
 HEAP8[i10 + 22 >> 0] = 1;
 i13 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i10) | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function _UNITY_png_do_check_palette_indexes(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP16[i4 + 416 >> 1] | 0;
 i5 = HEAP8[i1 + 9 >> 0] | 0;
 if (i7 << 16 >> 16 == 0 | (i7 & 65535 | 0) >= (1 << (i5 & 255) | 0)) return;
 i2 = (Math_imul(HEAP32[i1 >> 2] | 0, 0 - (HEAPU8[i1 + 11 >> 0] | 0) | 0) | 0) & 7;
 i7 = HEAP32[i4 + 380 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i7 + i3 | 0;
 switch (i5 << 24 >> 24) {
 case 1:
  {
   if ((i3 | 0) <= 0) return;
   i3 = i4 + 420 | 0;
   while (1) {
    if ((HEAPU8[i1 >> 0] | 0) >>> i2 | 0) HEAP32[i3 >> 2] = 1;
    i1 = i1 + -1 | 0;
    if (i1 >>> 0 <= i7 >>> 0) break; else i2 = 0;
   }
   return;
  }
 case 2:
  {
   if ((i3 | 0) <= 0) return;
   i6 = i4 + 420 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i4 = HEAP8[i1 >> 0] | 0;
    i5 = (i4 & 255) >>> i2 & 3;
    if ((i5 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i5;
     i4 = HEAP8[i1 >> 0] | 0;
     i3 = i5;
    }
    i5 = (i4 & 255) >>> i2 >>> 2 & 3;
    if ((i5 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i5;
     i4 = HEAP8[i1 >> 0] | 0;
     i3 = i5;
    }
    i5 = (i4 & 255) >>> i2 >>> 4 & 3;
    if ((i5 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i5;
     i4 = HEAP8[i1 >> 0] | 0;
     i3 = i5;
    }
    i2 = (i4 & 255) >>> i2 >>> 6 & 3;
    if ((i2 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i2;
     i3 = i2;
    }
    i1 = i1 + -1 | 0;
    if (i1 >>> 0 <= i7 >>> 0) break; else i2 = 0;
   }
   return;
  }
 case 4:
  {
   if ((i3 | 0) <= 0) return;
   i6 = i4 + 420 | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i4 = HEAP8[i1 >> 0] | 0;
    i5 = (i4 & 255) >>> i2 & 15;
    if ((i5 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i5;
     i4 = HEAP8[i1 >> 0] | 0;
     i3 = i5;
    }
    i2 = (i4 & 255) >>> i2 >>> 4 & 15;
    if ((i2 | 0) > (i3 | 0)) {
     HEAP32[i6 >> 2] = i2;
     i3 = i2;
    }
    i1 = i1 + -1 | 0;
    if (i1 >>> 0 <= i7 >>> 0) break; else i2 = 0;
   }
   return;
  }
 case 8:
  {
   if ((i3 | 0) <= 0) return;
   i4 = i4 + 420 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   while (1) {
    i2 = HEAPU8[i1 >> 0] | 0;
    if ((i2 | 0) > (i3 | 0)) HEAP32[i4 >> 2] = i2; else i2 = i3;
    i1 = i1 + -1 | 0;
    if (i1 >>> 0 <= i7 >>> 0) break; else i3 = i2;
   }
   return;
  }
 default:
  return;
 }
}

function __ZNK12b2ChainShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i2, i3, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, f4 = f0, f5 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i8 + 1 | 0;
 i1 = (i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0) ? 0 : i1;
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 151644 >> 2]);
 if (!(f4 <= f5)) {
  HEAP32[i9 >> 2] = gb + 151688 + 8;
  HEAP32[i9 + 28 >> 2] = gb + 151728 + 8;
  HEAP32[i9 + 32 >> 2] = 2;
  HEAPF32[i9 + 36 >> 2] = f5;
  HEAP32[i9 + 176 >> 2] = 0;
  HEAPF32[i9 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 44 >> 2] = Math_fround(0.0);
  HEAP32[i9 + 4 >> 2] = 4;
  i11 = i9 + 8 | 0;
  HEAPF32[i11 >> 2] = f5;
  i13 = i9 + 12 | 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  i13 = i2 + (i8 << 3) | 0;
  i12 = HEAP32[i13 + 4 >> 2] | 0;
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i8 + 4 >> 2] = i12;
  i1 = i2 + (i1 << 3) | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i9 + 20 | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = i2;
  HEAPF32[i11 >> 2] = Math_fround(f4 - f5);
  i9 = __ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i9, i3, i6, i7, 0) | 0;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  HEAP32[i9 >> 2] = gb + 151648 + 8;
  HEAP32[i9 + 4 >> 2] = 1;
  HEAPF32[i9 + 8 >> 2] = f5;
  i11 = i9 + 28 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP16[i11 + 16 >> 1] = 0;
  i11 = HEAP32[i2 + 12 >> 2] | 0;
  i8 = i11 + (i8 << 3) | 0;
  i13 = HEAP32[i8 + 4 >> 2] | 0;
  i12 = i9 + 12 | 0;
  HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i12 + 4 >> 2] = i13;
  i11 = i11 + (i1 << 3) | 0;
  i12 = HEAP32[i11 + 4 >> 2] | 0;
  i13 = i9 + 20 | 0;
  HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i13 + 4 >> 2] = i12;
  i13 = __ZNK11b2EdgeShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i9, i3, i6, i7, 0) | 0;
  STACKTOP = i10;
  return i13 | 0;
 }
 return 0;
}

function __ZN7b2World11DestroyBodyEP6b2Body(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 if (HEAP32[i10 + 102868 >> 2] & 2 | 0) return;
 i4 = i11 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i10 + 102984 | 0;
  do {
   i2 = i1;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if (!i3) i2 = i2 + 4 | 0; else {
    i2 = i2 + 4 | 0;
    mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
   }
   __ZN7b2World12DestroyJointEP7b2Joint(i10, HEAP32[i2 >> 2] | 0);
   HEAP32[i4 >> 2] = i1;
  } while ((i1 | 0) != 0);
 }
 HEAP32[i4 >> 2] = 0;
 i2 = i11 + 112 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i3 = i10 + 102872 | 0;
  do {
   i9 = i1;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   __ZN16b2ContactManager7DestroyEP9b2Contact(i3, HEAP32[i9 + 4 >> 2] | 0);
  } while ((i1 | 0) != 0);
 }
 HEAP32[i2 >> 2] = 0;
 i9 = i11 + 100 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) i1 = i11 + 104 | 0; else {
  i7 = i10 + 102984 | 0;
  i8 = i10 + 102872 | 0;
  i1 = i11 + 104 | 0;
  do {
   i6 = i2;
   i2 = HEAP32[i2 + 24 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if (i3 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i6 | 0);
   i4 = i6 + 48 | 0;
   if ((HEAP32[i4 >> 2] | 0) > 0) {
    i5 = i6 + 44 | 0;
    i3 = 0;
    do {
     i12 = (HEAP32[i5 >> 2] | 0) + (i3 * 28 | 0) + 24 | 0;
     __ZN12b2BroadPhase12DestroyProxyEi(i8, HEAP32[i12 >> 2] | 0);
     HEAP32[i12 >> 2] = -1;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < (HEAP32[i4 >> 2] | 0));
   }
   HEAP32[i4 >> 2] = 0;
   __ZN9b2Fixture7DestroyEP16b2BlockAllocator(i6, i10);
   __ZN16b2BlockAllocator4FreeEPvi(i10, i6, 64);
   HEAP32[i9 >> 2] = i2;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  } while ((i2 | 0) != 0);
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i11 + 92 >> 2] | 0;
 i1 = i11 + 96 | 0;
 if (i2 | 0) HEAP32[i2 + 96 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) HEAP32[i3 + 92 >> 2] = i2;
 i1 = i10 + 102956 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) HEAP32[i1 >> 2] = i3;
 i12 = i10 + 102964 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 __ZN16b2BlockAllocator4FreeEPvi(i10, i11, 152);
 return;
}

function __ZN8Animator20SetBoneLocalRotationEi11Quaternionf(i7, i6, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i3 = i9;
 if (!(HEAP8[i7 + 153 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i4 = i7 + 104 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 10;
  }
 }
 if ((i5 | 0) == 8) i5 = 10;
 if ((i5 | 0) == 10) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i9;
   return;
  }
 }
 i2 = __ZN6Avatar8GetAssetEv(i1) | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i2 = i2 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i10 = i3 + i2 + 40 | 0;
 if (!(HEAP32[(HEAP32[i10 >> 2] | 0) + i10 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = __ZN10HumanTrait9GetBoneIdERK6Avatari(i1, i6) | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i9;
  return;
 }
 i10 = (HEAP32[HEAP32[i7 + 140 >> 2] >> 2] | 0) + 4 | 0;
 i10 = i10 + (HEAP32[i10 >> 2] | 0) | 0;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i7 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i10 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + (i1 * 40 | 0) + 16 >> 2] = i5;
 HEAP32[i10 + (i1 * 40 | 0) + 20 >> 2] = i6;
 HEAP32[i10 + (i1 * 40 | 0) + 24 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i10, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i2 + 16 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i13, i12, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i8 = i10 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i9 = i10 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i1 & 255;
 i3 = i4 ? i5 : i6;
 do if (i2 >>> 0 > i3 >>> 0) {
  i7 = i2 - i3 | 0;
  if (i7 | 0) {
   if (i4) {
    i2 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0;
    i3 = i5;
   } else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i7 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i10, i2, i7 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i8 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
   _memset(i2 + i3 | 0, 1, i7 | 0) | 0;
   i1 = i3 + i7 | 0;
   if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i9 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } else if (i4) {
  HEAP8[(HEAP32[i10 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i9 >> 2] = i2;
  break;
 } else {
  HEAP8[i10 + i2 >> 0] = 0;
  HEAP8[i8 >> 0] = i2;
  break;
 } while (0);
 i4 = HEAP8[i8 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i10 >> 2] | 0 : i10;
 i10 = i8 ? HEAP32[i9 >> 2] | 0 : i4 & 255;
 i4 = i1 + i10 | 0;
 if (!i10) {
  STACKTOP = i14;
  return;
 }
 do {
  i2 = HEAP32[i13 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i13, i12, 1);
   i2 = HEAP8[i12 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i12 >> 0] = i2;
   HEAP32[i13 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i14;
 return;
}

function __Z33RegisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = i5;
 i1 = HEAP32[gb + 1163040 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1163040 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1163040 + 16 >> 0] | 0)) {
   i6 = __ZnwjRK10MemLabelIdiPKci(12, gb + 1163040 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i4 = i6 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[gb + 1163040 >> 2] = i6;
   break;
  } else {
   i6 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, gb + 1163040 + 4 | 0, i1, gb + 1163040 + 16 | 0, gb + 1163040 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i4 = i6 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 >> 2] = i4;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1163040 >> 2] = i6;
   break;
  }
 } else i6 = i1; while (0);
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 >>> 0 > i5 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i5 >>> 0) {
     i2 = 13;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 12;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 8) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 12) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 13) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 i1 = __Znwj(20) | 0;
 HEAP32[i1 + 16 >> 2] = i7;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 STACKTOP = i8;
 return;
}

function _UNITY_png_set_alpha_mode_fixed(i9, i5, i1) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 if (!i9) return;
 i6 = i9 + 208 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 & 64 | 0) {
  _UNITY_png_app_error(i9, gb + 353836 | 0);
  return;
 }
 HEAP32[i6 >> 2] = i2 | 16384;
 L8 : do if ((i1 | 0) < -2) if ((i1 | 0) < -5e4) switch (i1 | 0) {
 case -1e5:
  {
   i3 = 5;
   break L8;
  }
 default:
  {
   i3 = 6;
   break L8;
  }
 } else switch (i1 | 0) {
 case -5e4:
  {
   i4 = 151724;
   break L8;
  }
 default:
  {
   i3 = 6;
   break L8;
  }
 } else switch (i1 | 0) {
 case -1:
  {
   i3 = 5;
   break;
  }
 case -2:
  {
   i4 = 151724;
   break;
  }
 default:
  i3 = 6;
 } while (0);
 if ((i3 | 0) == 5) {
  HEAP32[i6 >> 2] = i2 | 20480;
  i4 = 22e4;
 } else if ((i3 | 0) == 6) if ((i1 + -7e4 | 0) >>> 0 > 23e4) _UNITY_png_error(i9, gb + 353914 | 0); else i4 = i1;
 i1 = _UNITY_png_reciprocal(i4) | 0;
 switch (i5 | 0) {
 case 0:
  {
   i7 = i9 + 212 | 0;
   i10 = HEAP32[i7 >> 2] & -8388609;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -8193;
   i7 = i4;
   i8 = 0;
   break;
  }
 case 1:
  {
   i7 = i9 + 212 | 0;
   i10 = HEAP32[i7 >> 2] & -8388609;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -8193;
   i7 = 1e5;
   i8 = 1;
   break;
  }
 case 2:
  {
   i7 = i9 + 212 | 0;
   i10 = HEAP32[i7 >> 2] & -8388609;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 8192;
   i7 = i4;
   i8 = 1;
   break;
  }
 case 3:
  {
   i7 = i9 + 212 | 0;
   i10 = HEAP32[i7 >> 2] | 8388608;
   HEAP32[i7 >> 2] = i10;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -8193;
   i7 = i4;
   i8 = 1;
   break;
  }
 default:
  _UNITY_png_error(i9, gb + 353949 | 0);
 }
 i2 = i9 + 680 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = i1;
  i6 = i9 + 754 | 0;
  HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 0 | 1;
 } else i1 = i3;
 HEAP32[i9 + 484 >> 2] = i7;
 if (!i8) return;
 i2 = i9 + 448 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP16[i2 + 8 >> 1] = 0;
 HEAP32[i9 + 444 >> 2] = i1;
 HEAP8[i9 + 442 >> 0] = 2;
 i1 = i9 + 212 | 0;
 i2 = i10 & -257;
 HEAP32[i1 >> 2] = i2;
 if (i10 & 128 | 0) _UNITY_png_error(i9, gb + 353968 | 0);
 HEAP32[i1 >> 2] = i2 | 128;
 return;
}

function _jinit_d_main_controller(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 4 | 0;
 i8 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i10 | 0, 1, 80) | 0;
 i2 = i10 + 388 | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i8 >> 2] = fb + 2367;
 if (i1 << 24 >> 24) {
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i10 | 0);
 }
 i9 = i10 + 280 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!(HEAP8[(HEAP32[i10 + 416 >> 2] | 0) + 8 >> 0] | 0)) {
  i1 = i10 + 36 | 0;
  i6 = i3;
  i5 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i3;
 } else {
  if ((i3 | 0) < 2) {
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 47;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i10 | 0);
   i3 = HEAP32[i9 >> 2] | 0;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  i7 = i10 + 36 | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i10 | 0, 1, HEAP32[i7 >> 2] << 3 | 0) | 0;
  i5 = i6 + 56 | 0;
  HEAP32[i5 >> 2] = i4;
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 60 | 0;
  HEAP32[i6 >> 2] = i4 + (i1 << 2);
  if ((i1 | 0) > 0) {
   i4 = i3 + 4 | 0;
   i2 = HEAP32[i10 + 196 >> 2] | 0;
   i3 = 0;
   while (1) {
    i12 = Math_imul(HEAP32[i2 + 36 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
    i12 = (i12 | 0) / (HEAP32[i9 >> 2] | 0) | 0;
    i1 = Math_imul(i12, i4) | 0;
    i12 = (mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i10 | 0, 1, i1 << 3 | 0) | 0) + (i12 << 2) | 0;
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] = i12;
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i12 + (i1 << 2);
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    if ((i3 | 0) >= (i1 | 0)) break; else i2 = i2 + 84 | 0;
   }
  }
  i2 = HEAP32[i9 >> 2] | 0;
  i6 = i2 + 2 | 0;
  i5 = i7;
 }
 if ((i1 | 0) <= 0) return;
 i4 = i8 + 8 | 0;
 i1 = 0;
 i3 = HEAP32[i10 + 196 >> 2] | 0;
 while (1) {
  i8 = HEAP32[i3 + 36 >> 2] | 0;
  i12 = (Math_imul(i8, HEAP32[i3 + 12 >> 2] | 0) | 0) / (i2 | 0) | 0;
  HEAP32[i4 + (i1 << 2) >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, 1, Math_imul(HEAP32[i3 + 28 >> 2] | 0, i8) | 0, Math_imul(i12, i6) | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i5 >> 2] | 0)) break;
  i3 = i3 + 84 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 return;
}

function __ZNKSt3__28messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i1, i3, i4, i5, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i8 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i10 = i9 << 24 >> 24 < 0;
 i1 = i10 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i1 + (i10 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255) | 0;
 while (1) {
  if (i1 >>> 0 >= i2 >>> 0) {
   i2 = 8;
   break;
  }
  __THREW__ = 0;
  invoke_vii(fb + 4511 | 0, i8 | 0, HEAP8[i1 >> 0] | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i2 = 9;
   break;
  }
  i1 = i1 + 1 | 0;
 }
 do if ((i2 | 0) == 8) {
  __THREW__ = 0;
  i1 = invoke_iiiii(fb + 209 | 0, ((i3 | 0) == -1 ? -1 : i3 << 1) | 0, i4 | 0, i5 | 0, ((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0) | 0;
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i2 = 0;
  while (1) {
   if ((i2 | 0) == 3) break;
   HEAP32[i7 + (i2 << 2) >> 2] = 0;
   i2 = i2 + 1 | 0;
  }
  i2 = i1 + (_strlen(i1) | 0) | 0;
  while (1) {
   if (i1 >>> 0 >= i2 >>> 0) {
    i2 = 19;
    break;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4511 | 0, i7 | 0, HEAP8[i1 >> 0] | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) {
    i2 = 18;
    break;
   }
   i1 = i1 + 1 | 0;
  }
  if ((i2 | 0) == 18) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   break;
  } else if ((i2 | 0) == 19) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   STACKTOP = i6;
   return;
  }
 } else if ((i2 | 0) == 9) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i1 | 0);
}

function __Z22AddCurveToStreamedClipI11QuaternionfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i7, i8, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i17;
 i13 = i11 + 164 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 i14 = i12 + 4 | 0;
 i15 = i12 + 8 | 0;
 i16 = i11 + 152 | 0;
 i9 = i12 + 12 | 0;
 i10 = i12 + 60 | 0;
 i6 = -1;
 do {
  HEAPF32[i14 >> 2] = Math_fround(inf);
  HEAP32[i12 >> 2] = 0;
  i3 = i15;
  i4 = i3 + 68 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  do if ((i6 | 0) == (i1 + -1 | 0)) {
   i1 = HEAP32[i16 >> 2] | 0;
   HEAP32[i14 >> 2] = HEAP32[i1 + (i6 * 52 | 0) >> 2];
   i3 = i9;
   i4 = i3 + 48 | 0;
   do {
    HEAP32[i3 >> 2] = 0;
    i3 = i3 + 4 | 0;
   } while ((i3 | 0) < (i4 | 0));
   i5 = i1 + (i6 * 52 | 0) + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i5 = 10;
  } else {
   if ((i6 | 0) != -1) {
    __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif(i11, i12, i6, i6 + 1 | 0, Math_fround(0.0));
    i5 = 10;
    break;
   }
   i2 = HEAP32[i16 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i2 >> 2]) == Math_fround(-3402823469999999843913219.0e14))) {
    HEAPF32[i14 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    i3 = i9;
    i4 = i3 + 48 | 0;
    do {
     HEAP32[i3 >> 2] = 0;
     i3 = i3 + 4 | 0;
    } while ((i3 | 0) < (i4 | 0));
    i5 = i2 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    i5 = 10;
   }
  } while (0);
  if ((i5 | 0) == 10) {
   i5 = 0;
   __Z23ConvertCacheToBuildKeysI11QuaternionfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i12, i8, i7);
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) < (i1 | 0));
 STACKTOP = i17;
 return;
}

function __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimit10updateNodeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0, gb + 765133 | 0) | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, gb + 1075318 | 0) | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, gb + 765140 | 0);
  }
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0, gb + 765149 | 0) | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, gb + 1075318 | 0) | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, gb + 765140 | 0);
  }
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0, gb + 765156 | 0) | 0) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f4 = Math_fround(+_strtod(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, 0));
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(+_strtod(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, 0));
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
 if (!(f4 >= f3)) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, gb + 1084385 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, gb + 765167 | 0);
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, gb + 1084403 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, gb + 765140 | 0);
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (((i3 - i1 | 0) / 44 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i4 = i1 + 44 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i4 | 0));
   i1 = (HEAP32[i10 >> 2] | 0) + 44 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 44 | 0) + i2 | 0;
 if (i5 >>> 0 > 97612893) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 44 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 48806446 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 97612893;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 44 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 44 | 0) * 44 | 0) | 0;
 i7 = i3;
 i5 = i6 + (i5 * 44 | 0) | 0;
 i1 = i3;
 i6 = i7;
 do {
  i4 = i1 + 44 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  i1 = i6 + 44 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i4 = i2;
  i2 = i7;
  do {
   i7 = i4;
   i4 = i4 + -44 | 0;
   HEAP32[i3 + -44 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i7 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   i13 = i7 + -20 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i3 + -20 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP32[i3 + -12 >> 2] = HEAP32[i7 + -12 >> 2];
   HEAP32[i3 + -8 >> 2] = HEAP32[i7 + -8 >> 2];
   HEAP32[i3 + -4 >> 2] = HEAP32[i7 + -4 >> 2];
   i3 = i2 + -44 | 0;
   i2 = i3;
  } while ((i4 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx14PxVehicleGraph19computeGraphChannelEjPfPNS_6PxVec3EPcj(i17, i12, i20, i15, i18, i19) {
 i17 = i17 | 0;
 i12 = i12 | 0;
 i20 = i20 | 0;
 i15 = i15 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i13 = 0, i14 = 0, i16 = 0, i21 = 0, i22 = 0, f23 = f0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i21 + 12 | 0;
 i13 = i21;
 f8 = Math_fround(HEAPF32[i17 + 15812 >> 2]);
 i5 = i17 + 15808 | 0;
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(f8 - f9);
 f11 = Math_fround(HEAPF32[i17 + 15820 >> 2]);
 i10 = i17 + 15816 | 0;
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i10 >> 2]));
 f2 = Math_fround(HEAPF32[i17 + (i12 << 2) >> 2]);
 f3 = Math_fround(HEAPF32[i17 + 48 + (i12 << 2) >> 2]);
 f4 = Math_fround(HEAPF32[i17 + 96 + (i12 << 2) >> 2]);
 HEAP32[i14 >> 2] = HEAP32[i17 + 144 + (i12 * 12 | 0) >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i17 + 144 + (i12 * 12 | 0) + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i17 + 144 + (i12 * 12 | 0) + 8 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i17 + 288 + (i12 * 12 | 0) >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i17 + 288 + (i12 * 12 | 0) + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i17 + 288 + (i12 * 12 | 0) + 8 >> 2];
 f6 = Math_fround(f3 - f2);
 i1 = HEAP32[i17 + 15824 >> 2] | 0;
 i16 = 0;
 while (1) {
  i7 = i16 + 1 | 0;
  i22 = i16 << 1;
  HEAPF32[i20 + (i22 << 2) >> 2] = Math_fround(Math_fround(Math_fround(f8 * Math_fround(i16 >>> 0)) * Math_fround(.00390625)) + f9);
  f9 = Math_fround(HEAPF32[i17 + 3504 + (i12 << 10) + ((i7 + i1 & 255) << 2) >> 2]);
  f9 = f2 > f9 ? f2 : f9;
  f9 = f9 > f3 ? f3 : f9;
  f23 = Math_fround(Math_fround(f9 - f2) / f6);
  HEAPF32[i20 + ((i22 | 1) << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(f11 * f23));
  i22 = f9 < f4 ? i14 : i13;
  HEAP32[i15 + (i16 * 12 | 0) >> 2] = HEAP32[i22 >> 2];
  HEAP32[i15 + (i16 * 12 | 0) + 4 >> 2] = HEAP32[i22 + 4 >> 2];
  HEAP32[i15 + (i16 * 12 | 0) + 8 >> 2] = HEAP32[i22 + 8 >> 2];
  if ((i7 | 0) == 256) break;
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  i16 = i7;
 }
 _strncpy(i18, i17 + 432 + (i12 << 8) | 0, i19) | 0;
 HEAP8[i18 + (i19 + -1) >> 0] = 0;
 STACKTOP = i21;
 return;
}

function ___do_des(i3, i4, i11, i12, i8, i9, i10) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0;
 if (!(i4 | i3)) {
  i6 = 0;
  i5 = 0;
 } else {
  i6 = 0;
  i1 = 28;
  i2 = 0;
  i5 = 0;
  while (1) {
   i14 = i3 >>> i1 & 15;
   i7 = i4 >>> i1 & 15;
   i13 = i2 + 8 | 0;
   i6 = HEAP32[gb + 191988 + (i2 << 6) + (i14 << 2) >> 2] | i6 | HEAP32[gb + 191988 + (i13 << 6) + (i7 << 2) >> 2];
   i5 = HEAP32[gb + 193012 + (i2 << 6) + (i14 << 2) >> 2] | i5 | HEAP32[gb + 193012 + (i13 << 6) + (i7 << 2) >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == 8) break; else i1 = i1 + -4 | 0;
  }
 }
 if (i8) {
  i7 = i10 + 64 | 0;
  i4 = i8;
  do {
   i1 = i7;
   i2 = i10;
   i3 = 16;
   while (1) {
    i3 = i3 + -1 | 0;
    i13 = i5 << 23 & 8388608 | i5 >>> 9 & 8126464 | i5 >>> 11 & 258048 | i5 >>> 13 & 4032 | i5 >>> 15 & 63;
    i14 = i5 << 5 & 258048 | i5 >>> 31 | i5 << 7 & 16515072 | i5 << 3 & 4032 | i5 << 1 & 62;
    i8 = (i13 ^ i14) & i9;
    i13 = i8 ^ i13 ^ HEAP32[i2 >> 2];
    i14 = i8 ^ i14 ^ HEAP32[i1 >> 2];
    i6 = (HEAP32[gb + 194036 + 256 + ((i13 >>> 12 & 63) << 2) >> 2] | HEAP32[gb + 194036 + (i13 >>> 18 << 2) >> 2] | HEAP32[gb + 194036 + 512 + ((i13 >>> 6 & 63) << 2) >> 2] | HEAP32[gb + 194036 + 768 + ((i13 & 63) << 2) >> 2] | HEAP32[gb + 194036 + 1024 + (i14 >>> 18 << 2) >> 2] | HEAP32[gb + 194036 + 1280 + ((i14 >>> 12 & 63) << 2) >> 2] | HEAP32[gb + 194036 + 1536 + ((i14 >>> 6 & 63) << 2) >> 2] | HEAP32[gb + 194036 + 1792 + ((i14 & 63) << 2) >> 2]) ^ i6;
    if (!i3) break; else {
     i14 = i5;
     i1 = i1 + 4 | 0;
     i2 = i2 + 4 | 0;
     i5 = i6;
     i6 = i14;
    }
   }
   i4 = i4 + -1 | 0;
  } while ((i4 | 0) != 0);
 }
 i1 = 0;
 i2 = 28;
 i3 = 0;
 i4 = 0;
 while (1) {
  i13 = i3 + 4 | 0;
  i4 = HEAP32[gb + 196084 + (i3 << 6) + ((i6 >>> i2 & 15) << 2) >> 2] | i4 | HEAP32[gb + 196084 + (i13 << 6) + ((i5 >>> i2 & 15) << 2) >> 2];
  i14 = i2 + -4 | 0;
  i1 = HEAP32[gb + 196084 + (i3 << 6) + ((i6 >>> i14 & 15) << 2) >> 2] | i1 | HEAP32[gb + 196084 + (i13 << 6) + ((i5 >>> i14 & 15) << 2) >> 2];
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 4) break; else i2 = i2 + -8 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i4;
 return;
}

function __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE12__move_rangeEPS4_S8_S8_(i1, i15, i14, i3) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i1 + 4 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i12 = i2 - i3 | 0;
 i4 = i15 + (((i12 | 0) / 40 | 0) * 40 | 0) | 0;
 if (i4 >>> 0 < i14 >>> 0) {
  i10 = i4;
  i3 = i2;
  do {
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   i5 = i3 + 8 | 0;
   i6 = i10 + 8 | 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i5 = i3 + 24 | 0;
   i6 = i10 + 24 | 0;
   HEAP32[i5 >> 2] = 0;
   i11 = i3 + 28 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i3 + 32 >> 2] = 0;
   i8 = i10 + 28 | 0;
   i1 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
   i7 = i1 >> 2;
   if (i7 | 0) {
    if (i7 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
    i9 = __Znwj(i1) | 0;
    HEAP32[i11 >> 2] = i9;
    HEAP32[i5 >> 2] = i9;
    HEAP32[i3 + 32 >> 2] = i9 + (i7 << 2);
    i3 = HEAP32[i6 >> 2] | 0;
    i1 = (HEAP32[i8 >> 2] | 0) - i3 | 0;
    if ((i1 | 0) > 0) {
     _memcpy(i9 | 0, i3 | 0, i1 | 0) | 0;
     HEAP32[i11 >> 2] = i9 + (i1 >> 2 << 2);
    }
   }
   i10 = i10 + 40 | 0;
   i3 = (HEAP32[i13 >> 2] | 0) + 40 | 0;
   HEAP32[i13 >> 2] = i3;
  } while (i10 >>> 0 < i14 >>> 0);
 }
 if (!i12) return;
 do {
  i3 = i2;
  i2 = i2 + -40 | 0;
  i1 = i4;
  i4 = i4 + -40 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i14 = i1 + -32 | 0;
  i13 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i3 + -32 | 0;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = i13;
  i12 = i1 + -24 | 0;
  i13 = HEAP32[i12 + 4 >> 2] | 0;
  i14 = i3 + -24 | 0;
  HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i14 + 4 >> 2] = i13;
  if ((i3 | 0) != (i1 | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i3 + -16 | 0, HEAP32[i1 + -16 >> 2] | 0, HEAP32[i1 + -12 >> 2] | 0);
 } while ((i4 | 0) != (i15 | 0));
 return;
}

function __ZN5physx14PxsAABBManager15createAggregateEPvb(i9, i5, i4) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 1 | 0;
 i11 = i12;
 i3 = i9 + 176 | 0;
 i6 = i9 + 196 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = i9 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) {
  i1 = i9 + 192 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < i7 >>> 0) {
   i3 = (HEAP32[i9 + 180 >> 2] | 0) + (i2 * 1048 | 0) | 0;
   HEAP32[i1 >> 2] = i2 + 1;
   i8 = i2;
   break;
  } else {
   __ZN5physx16AggregateManager6resizeEj(i3, i2 + 32 | 0);
   i8 = HEAP32[i1 >> 2] | 0;
   i3 = (HEAP32[i9 + 180 >> 2] | 0) + (i8 * 1048 | 0) | 0;
   HEAP32[i1 >> 2] = i8 + 1;
   break;
  }
 } else {
  i3 = i2 + -1 | 0;
  i8 = HEAP32[(HEAP32[i9 + 200 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  i3 = (HEAP32[i9 + 180 >> 2] | 0) + (i8 * 1048 | 0) | 0;
 } while (0);
 HEAP8[i3 + 1024 >> 0] = i4 & 1;
 HEAP32[i3 + 1044 >> 2] = i5;
 i1 = (HEAP32[i9 + 220 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << (i8 & 31));
 i1 = i9 + 216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = i9 + 208 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 + -1;
 } else {
  i4 = i2 + -1 | 0;
  i5 = HEAP32[(HEAP32[i9 + 212 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  i1 = i5;
 }
 HEAP32[i3 + 1036 >> 2] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 <= i7 >>> 0) {
  i11 = i8 << 1;
  i11 = i11 | 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i7 = i9 + 356 | 0;
 i6 = ((i1 + 31 | 0) >>> 5) + 3 & 268435452;
 i2 = i9 + 360 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i6 >>> 0 <= i4 >>> 0) {
  i11 = i8 << 1;
  i11 = i11 | 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i6 << 2, gb + 717789 | 0, 59) | 0;
 if (i5 | 0) _memcpy(i1 | 0, i5 | 0, i3 << 2 | 0) | 0;
 _memset(i1 + (i4 << 2) | 0, 0, i6 - i3 << 2 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i5);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i2 >> 2] = i6 | -2147483648;
 i11 = i8 << 1;
 i11 = i11 | 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx11Adjacencies19GetBoundaryVerticesEjPbPKNS_2Gu9TriangleTIjEE(i1, i7, i5, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 if (!((i7 | 0) != 0 & ((i5 | 0) != 0 & (HEAP32[i2 >> 2] | 0) != 0))) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 727718 | 0, 147, gb + 773459 | 0, i8);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!i6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 727718 | 0, 154, gb + 773459 | 0, i8 + 8 | 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 _memset(i5 | 0, 0, i7 | 0) | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = 0;
 while (1) {
  if ((HEAP32[i2 + (i3 * 12 | 0) >> 2] & 536870911 | 0) == 536870911) {
   i1 = HEAP32[i6 + (i3 * 12 | 0) >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
   i1 = HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
  }
  if ((HEAP32[i2 + (i3 * 12 | 0) + 4 >> 2] & 536870911 | 0) == 536870911) {
   i1 = HEAP32[i6 + (i3 * 12 | 0) >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
   i1 = HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
  }
  if ((HEAP32[i2 + (i3 * 12 | 0) + 8 >> 2] & 536870911 | 0) == 536870911) {
   i1 = HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
   i1 = HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2] | 0;
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    i2 = 20;
    break;
   }
   HEAP8[i5 + i1 >> 0] = 1;
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i4 >>> 0) {
   i1 = 1;
   i2 = 20;
   break;
  }
 }
 if ((i2 | 0) == 20) {
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_112UserRenderer19visualizeDoubleConeERKN5physx11PxTransformEfb(i4, i3, f2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 48 | 0;
 i8 = i5 + 40 | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 i15 = i12 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i3 + 4 >> 2];
 i14 = i12 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i3 + 8 >> 2];
 i13 = i12 + 12 | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i12 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 i11 = i12 + 20 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 + 20 >> 2];
 i10 = i12 + 24 | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 + 24 >> 2];
 i9 = i12 + 28 | 0;
 HEAPF32[i9 >> 2] = f2;
 i6 = i12 + 32 | 0;
 HEAP8[i6 >> 0] = i1 & 1;
 i17 = i4 + 8 | 0;
 HEAP32[i8 >> 2] = gb + 150564 + 8;
 HEAP32[i8 + 4 >> 2] = i17;
 i1 = i4 + 24 | 0;
 i3 = i4 + 20 | 0;
 i16 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i17, i16 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i16 >> 0] = 9;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i15 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i12 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i11 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i10 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i9 | 0);
 HEAP8[i7 >> 0] = HEAP8[i6 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i7 | 0);
 HEAP8[i6 >> 0] = (HEAP8[i7 >> 0] | 0) != 0 & 1;
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i5;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i12, i9, i10) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 16 | 0;
 i11 = i13 + 8 | 0;
 i2 = i13;
 i3 = i12 + 392 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  STACKTOP = i13;
  return;
 }
 i4 = i12 + 208 | 0;
 i5 = i12 + 212 | 0;
 i6 = i12 + 228 | 0;
 i7 = i12 + 224 | 0;
 i14 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) + (HEAP32[i7 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = gb + 149652 + 8;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i2 >> 2] = 1;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i8 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 >>> 0 > i14 >>> 0) {
  mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 100 >> 2] | 0, i12 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 >>> 0 <= (HEAP32[i4 >> 2] | 0) >>> 0) if (HEAP8[i12 + 408 >> 0] | 0) {
  HEAP32[i8 >> 2] = gb + 149764 + 8;
  HEAP32[i8 + 4 >> 2] = i5;
  i14 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
  __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i5, i14 + 1 | 0);
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  HEAP8[(HEAP32[i7 >> 2] | 0) + i14 >> 0] = i10;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i8 | 0);
  i14 = i12 + 380 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
  STACKTOP = i13;
  return;
 }
 i14 = i12 + 388 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i12 = i12 + 400 | 0;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, i1 | 0, 1, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
 HEAP32[i11 >> 2] = gb + 149708 + 8;
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP8[i8 >> 0] = i10;
 mftCall_iiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i8 | 0, 1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i11 | 0);
 i12 = HEAP32[i14 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0);
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP8[i3 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0) & 1;
 STACKTOP = i13;
 return;
}

function __ZN12LightsModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = i4 + 4 | 0;
 i6 = i5 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4 + 16 | 0, i5);
 i1 = i4 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i4 + 20 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i4 + 21 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i4 + 22 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4 + 24 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4 + 288 | 0, i5);
 i1 = i4 + 552 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  return;
 }
}

function __ZL8BatchJobP18BatchJobDataSingle(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i25 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i23 = i25 + 8 | 0;
 i1 = i25;
 if ((HEAP16[gb + 1159876 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i23 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159876 | 0, i23);
  i24 = gb + 1159876 | 0;
 } else i24 = 0;
 i21 = HEAP32[i2 >> 2] | 0;
 i22 = HEAP32[i2 + 4 >> 2] | 0;
 i20 = HEAP32[i21 + 8 + (i22 * 12 | 0) >> 2] | 0;
 i22 = i21 + 8 + (i22 * 12 | 0) + 4 | 0;
 i13 = (HEAP32[i22 >> 2] | 0) + i20 | 0;
 i14 = HEAP32[HEAP32[i21 + 4 >> 2] >> 2] | 0;
 i15 = 1 << HEAP32[i21 >> 2];
 if (i20 >>> 0 < i13 >>> 0) {
  i16 = i21 + 220 | 0;
  i17 = ~i15;
  i18 = i21 + 212 | 0;
  i19 = i21 + 208 | 0;
  i3 = 0;
  i12 = i20;
  i1 = 0;
  do {
   i11 = HEAP32[i14 + (i12 << 2) >> 2] | 0;
   i7 = i11 + 36 | 0;
   i4 = HEAP32[i7 >> 2] & ~HEAP32[i16 >> 2];
   if (i4 & i15) {
    i8 = i11 + 56 | 0;
    i9 = i11 + 68 | 0;
    i10 = i11;
    i6 = 0;
    do {
     i2 = (HEAP32[i8 >> 2] | 0) + (i6 << 2) | 0;
     i5 = HEAP32[i2 >> 2] | 0;
     if (i5 & i15) {
      HEAP32[i2 >> 2] = i5 & i17;
      HEAP32[i23 + (i3 << 3) >> 2] = i10;
      HEAP32[i23 + (i3 << 3) + 4 >> 2] = i6;
      i3 = i3 + 1 | 0;
      if ((i3 | 0) == 128) {
       mftCall_viii(HEAP32[i18 >> 2] | 0, HEAP32[i19 >> 2] | 0, i23 | 0, 128);
       i3 = 0;
      }
     }
     i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    } while ((i6 | 0) != -1);
    i4 = i4 & i17;
    HEAP32[i7 >> 2] = i4;
   }
   i2 = i11 + 32 | 0;
   if (!i4) HEAP32[i2 >> 2] = -1; else {
    HEAP32[i2 >> 2] = -2;
    HEAP32[i14 + (i1 + i20 << 2) >> 2] = i11;
    i1 = i1 + 1 | 0;
   }
   i12 = i12 + 1 | 0;
  } while ((i12 | 0) != (i13 | 0));
  if (i3) mftCall_viii(HEAP32[i21 + 212 >> 2] | 0, HEAP32[i21 + 208 >> 2] | 0, i23 | 0, i3 | 0);
 } else i1 = 0;
 HEAP32[i22 >> 2] = i1;
 if (!i24) {
  STACKTOP = i25;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i24);
 STACKTOP = i25;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i2 + 16 >> 2] | 0;
 i1 = i10;
 if ((i10 | 0) == (HEAP32[i2 + 12 >> 2] | 0)) {
  HEAP8[i2 + 28 >> 0] = 1;
  return;
 }
 i10 = i1 + -8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[i1 + -4 >> 0] | 0)) {
   i2 = (i3 & 1 | 0) == 0 ? 44 : 58;
   i3 = i9 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i9 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i9 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP8[(HEAP32[i9 >> 2] | 0) + i4 >> 0] = i2;
   break;
  } else {
   i2 = i9 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = i9 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i4 >>> 0 > i7 >>> 0) {
    i1 = i6 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
     HEAP32[i5 >> 2] = i1;
     HEAP32[i9 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i2 >> 2] = i4;
   HEAP8[(HEAP32[i9 >> 2] | 0) + i3 >> 0] = 44;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 3) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5Umbra18ReceiverMaskBufferaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = (i1 | 0) == 0 ? 0 : i1 + 1 & -2;
 i5 = i2 + 1 & -2;
 _memcpy(i4 | 0, i5 | 0, 32768) | 0;
 i4 = i4 + 32768 + 3 & -4;
 i2 = i4;
 i5 = i5 + 32768 + 3 & -4;
 i3 = i5;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i3 + 60 >> 2];
 _memcpy(i2 + 64 | 0, i3 + 64 | 0, 276) | 0;
 HEAP32[i2 + 340 >> 2] = HEAP32[i3 + 340 >> 2];
 HEAP32[i2 + 344 >> 2] = HEAP32[i3 + 344 >> 2];
 HEAP32[i2 + 348 >> 2] = HEAP32[i3 + 348 >> 2];
 HEAP32[i2 + 352 >> 2] = HEAP32[i3 + 352 >> 2];
 HEAP32[i2 + 356 >> 2] = HEAP32[i3 + 356 >> 2];
 HEAP32[i2 + 360 >> 2] = HEAP32[i3 + 360 >> 2];
 HEAP32[i2 + 364 >> 2] = HEAP32[i3 + 364 >> 2];
 HEAP32[i2 + 368 >> 2] = HEAP32[i3 + 368 >> 2];
 HEAP32[i2 + 372 >> 2] = HEAP32[i3 + 372 >> 2];
 HEAP32[i2 + 376 >> 2] = HEAP32[i3 + 376 >> 2];
 HEAP32[i2 + 380 >> 2] = HEAP32[i3 + 380 >> 2];
 HEAP32[i2 + 384 >> 2] = HEAP32[i3 + 384 >> 2];
 HEAP32[i2 + 388 >> 2] = HEAP32[i3 + 388 >> 2];
 HEAP32[i2 + 392 >> 2] = HEAP32[i3 + 392 >> 2];
 HEAP32[i2 + 396 >> 2] = HEAP32[i3 + 396 >> 2];
 HEAP32[i2 + 400 >> 2] = HEAP32[i3 + 400 >> 2];
 i2 = i2 + 404 | 0;
 i3 = i3 + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP8[i2 + 32 >> 0] = HEAP8[i3 + 32 >> 0] | 0;
 return i1 | 0;
}

function __ZN11LightProbes18ApplyFromSceneLoadEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i12 = i10 + 136 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i13 = i10 + 140 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) i3 = i2; else {
  i3 = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0) | 0;
  HEAP32[i13 >> 2] = i3;
 }
 i8 = i10 + 72 | 0;
 i9 = i10 + 84 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  i12 = i2;
  i13 = i3;
  i10 = i10 + 132 | 0;
  i10 = HEAP8[i10 >> 0] | 0;
  HEAP8[i11 >> 0] = i10;
  __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i12, i13, i11);
  STACKTOP = i14;
  return;
 }
 i5 = i11 + 16 | 0;
 i6 = i10 + 144 | 0;
 i7 = i10 + 136 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i3;
 while (1) {
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_4pairI7Hash12813ProbeSetIndexEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i7, i11); else {
   i3 = i11;
   i4 = i2 + 40 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 40;
  }
  i1 = i1 + 24 | 0;
  if (((HEAP32[i8 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) | 0) == (i1 | 0)) break;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i10 = i10 + 132 | 0;
 i10 = HEAP8[i10 >> 0] | 0;
 HEAP8[i11 >> 0] = i10;
 __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_(i12, i13, i11);
 STACKTOP = i14;
 return;
}

function _write_tables_only(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i2 = i3 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = -1;
 i5 = i1 + 4 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i4;
 if (!i4) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24)) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = -40;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (!i5) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24)) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 }
 if (HEAP32[i3 + 72 >> 2] | 0) _emit_dqt(i3, 0) | 0;
 if (HEAP32[i3 + 76 >> 2] | 0) _emit_dqt(i3, 1) | 0;
 if (HEAP32[i3 + 80 >> 2] | 0) _emit_dqt(i3, 2) | 0;
 if (HEAP32[i3 + 84 >> 2] | 0) _emit_dqt(i3, 3) | 0;
 if (!(HEAP8[i3 + 177 >> 0] | 0)) {
  if (HEAP32[i3 + 88 >> 2] | 0) _emit_dht(i3, 0, 0);
  if (HEAP32[i3 + 104 >> 2] | 0) _emit_dht(i3, 0, 1);
  if (HEAP32[i3 + 92 >> 2] | 0) _emit_dht(i3, 1, 0);
  if (HEAP32[i3 + 108 >> 2] | 0) _emit_dht(i3, 1, 1);
  if (HEAP32[i3 + 96 >> 2] | 0) _emit_dht(i3, 2, 0);
  if (HEAP32[i3 + 112 >> 2] | 0) _emit_dht(i3, 2, 1);
  if (HEAP32[i3 + 100 >> 2] | 0) _emit_dht(i3, 3, 0);
  if (HEAP32[i3 + 116 >> 2] | 0) _emit_dht(i3, 3, 1);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = -1;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (!i5) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24)) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = -39;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (i5 | 0) return;
 if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24) return;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 20 >> 2] = 24;
 mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim5human6HandleEEEvRT_PKc17TransferMetaFlags(i6, i7, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i5 = (HEAP8[i6 + 24 >> 0] | 0) != 0;
 if (i5) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i6) | 0;
  i2 = HEAP8[i6 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i2;
  i2 = i1 + 20 | 0;
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i7, i1);
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
  if (!(HEAP8[i2 >> 0] | 0)) {
   i1 = (0 - i1 & 3) + i1 | 0;
   i1 = i1 + 4 + (0 - i1 & 3) | 0;
   HEAP32[i3 >> 2] = i1;
  } else HEAP8[i2 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  __ZN9BlobWrite4PushEjPKvj(i6, (0 - i1 & 3) + i1 | 0, i7, 4);
  i1 = i7;
 } else i1 = i7;
 i2 = i6 + 48 | 0;
 i3 = i6 + 44 | 0;
 i10 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i6 + 32 | 0;
 i11 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i6, i1, gb + 906345 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i6, i7 + 40 | 0, gb + 906446 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i6, i7 + 44 | 0, gb + 910040 | 0, 0);
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i11 + -1;
 i1 = i6 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i3 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN18ProceduralMaterialC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8MaterialC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 59244 + 8;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 9;
 HEAP32[i1 + 116 >> 2] = 9;
 HEAP8[i1 + 120 >> 0] = 1;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i1 + 144 | 0;
 i3 = i1 + 156 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i3 + 11 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 i3 = i1 + 172 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 200 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 224 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = i1 + 224;
 i3 = i1 + 240 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 1;
 HEAP32[i1 + 264 >> 2] = 42;
 HEAPF32[i1 + 268 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 276 >> 2] = 0;
 HEAP32[i1 + 280 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = i1 + 276;
 STACKTOP = i4;
 return;
}

function __Z21XOREncryptToHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_(i3, i5, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i1 = i5 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i9 = i2 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
 HEAP32[i11 >> 2] = 0;
 i10 = i11 + 4 | 0;
 i4 = gb + 63160 | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = (i9 | 0) == 0;
 do if (i8) {
  i7 = 0;
  i1 = i2;
 } else if (i9 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i9 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i7 = i1;
  i1 = i2;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 1, gb + 64016 | 0, 0, gb + 585605 | 0, 976) | 0;
  i2 = gb + 64016 | 0;
  i13 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i11 >> 2] = i7;
  i4 = i10;
  HEAP32[i4 >> 2] = i13;
  HEAP32[i4 + 4 >> 2] = i2;
  i1 = HEAP8[i1 >> 0] | 0;
  break;
 } while (0);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i13 = i2 << 24 >> 24 < 0;
 i4 = i13 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i13 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
 i2 = i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 if (!i8) {
  i1 = 0;
  do {
   HEAP8[i7 + i1 >> 0] = HEAPU8[i2 + i1 >> 0] ^ (HEAPU8[i4 + ((i1 >>> 0) % (i3 >>> 0) | 0) >> 0] | 0) + i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i6, i9 << 1, 0);
 i2 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 if (i8) {
  i13 = HEAP32[i11 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
  STACKTOP = i12;
  return;
 } else i1 = 0;
 do {
  i8 = HEAPU8[i7 + i1 >> 0] | 0;
  i13 = i1 << 1;
  HEAP8[i2 + i13 >> 0] = HEAP8[(i8 >>> 4) + (gb + 488429) >> 0] | 0;
  HEAP8[i2 + (i13 | 1) >> 0] = HEAP8[(i8 & 15) + (gb + 488429) >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i9 | 0));
 i13 = HEAP32[i11 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i10);
 STACKTOP = i12;
 return;
}

function __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = 0;
 i13 = i9 + 11 | 0;
 i1 = HEAP8[i13 >> 0] | 0;
 i14 = i9 + 4 | 0;
 i1 = (i1 << 24 >> 24 < 0 ? HEAP32[i14 >> 2] | 0 : i1 & 255) + 1 | 0;
 HEAP32[i12 >> 2] = 0;
 i11 = i12 + 4 | 0;
 i6 = gb + 63160 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i11;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 do if (!i1) i2 = 0; else if (i1 >>> 0 < 2e3) {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, gb + 64016 | 0, 0, gb + 469960 | 0, 171) | 0;
  i7 = gb + 64016 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i12 >> 2] = i2;
  i8 = i11;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = i7;
  break;
 } while (0);
 i7 = 0;
 while (1) {
  i6 = HEAP8[i13 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  i5 = HEAP32[i14 >> 2] | 0;
  i6 = i6 & 255;
  i8 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
  i1 = i3 ? i5 : i6;
  if (i1 >>> 0 > i7 >>> 0) {
   i1 = i1 - i7 | 0;
   if (!i1) i15 = 9; else {
    i4 = _memchr(i8 + i7 | 0, 32, i1) | 0;
    i1 = i4 - i8 | 0;
    if ((i4 | 0) == 0 | (i1 | 0) == -1) i15 = 9; else {
     i4 = i1;
     i3 = 0;
    }
   }
  } else i15 = 9;
  if ((i15 | 0) == 9) {
   i15 = 0;
   i4 = -1;
   i1 = i3 ? i5 : i6;
   i3 = 1;
  }
  i6 = i1 - i7 | 0;
  _memcpy(i2 | 0, i8 + i7 | 0, i6 | 0) | 0;
  HEAP8[i2 + i6 >> 0] = 0;
  if (i6 | 0) {
   i7 = __ZN8keywords6CreateEPKc(i2) | 0;
   i8 = i10 + (i7 >>> 5 << 2) | 0;
   HEAP32[i8 >> 2] = 1 << (i7 & 31) | HEAP32[i8 >> 2];
  }
  if (i3) break; else i7 = i4 + 1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 STACKTOP = i16;
 return;
}

function __ZN9JSONWrite8TransferI4PPtrIN13TextRendering4FontEEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 24 | 0;
 i15 = i16;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i14, gb + 1034719 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i15);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN5physx35PxSimulationStatisticsGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 772698;
 HEAP32[i1 + 4 >> 2] = 354;
 HEAP32[i1 + 8 >> 2] = fb + 2259;
 HEAP32[i1 + 12 >> 2] = fb + 3647;
 HEAP32[i1 + 16 >> 2] = gb + 772718;
 HEAP32[i1 + 20 >> 2] = 355;
 HEAP32[i1 + 24 >> 2] = fb + 2260;
 HEAP32[i1 + 28 >> 2] = fb + 3648;
 HEAP32[i1 + 32 >> 2] = gb + 772740;
 HEAP32[i1 + 36 >> 2] = 356;
 HEAP32[i1 + 40 >> 2] = fb + 2261;
 HEAP32[i1 + 44 >> 2] = fb + 3649;
 HEAP32[i1 + 48 >> 2] = gb + 772764;
 HEAP32[i1 + 52 >> 2] = 357;
 HEAP32[i1 + 56 >> 2] = fb + 2262;
 HEAP32[i1 + 60 >> 2] = fb + 3650;
 HEAP32[i1 + 64 >> 2] = gb + 772779;
 HEAP32[i1 + 68 >> 2] = 358;
 HEAP32[i1 + 72 >> 2] = fb + 2263;
 HEAP32[i1 + 76 >> 2] = fb + 3651;
 HEAP32[i1 + 80 >> 2] = gb + 772795;
 HEAP32[i1 + 84 >> 2] = 359;
 HEAP32[i1 + 88 >> 2] = fb + 2264;
 HEAP32[i1 + 92 >> 2] = fb + 3652;
 HEAP32[i1 + 96 >> 2] = gb + 772819;
 HEAP32[i1 + 100 >> 2] = 360;
 HEAP32[i1 + 104 >> 2] = fb + 2265;
 HEAP32[i1 + 108 >> 2] = fb + 3653;
 HEAP32[i1 + 112 >> 2] = gb + 772841;
 HEAP32[i1 + 116 >> 2] = 361;
 HEAP32[i1 + 120 >> 2] = fb + 2266;
 HEAP32[i1 + 124 >> 2] = fb + 3654;
 HEAP32[i1 + 128 >> 2] = gb + 772873;
 HEAP32[i1 + 132 >> 2] = 362;
 HEAP32[i1 + 136 >> 2] = fb + 2267;
 HEAP32[i1 + 140 >> 2] = fb + 3655;
 HEAP32[i1 + 144 >> 2] = gb + 772894;
 HEAP32[i1 + 148 >> 2] = 363;
 HEAP32[i1 + 152 >> 2] = fb + 2268;
 HEAP32[i1 + 156 >> 2] = fb + 3656;
 HEAP32[i1 + 160 >> 2] = gb + 772928;
 HEAP32[i1 + 164 >> 2] = 364;
 HEAP32[i1 + 168 >> 2] = fb + 2269;
 HEAP32[i1 + 172 >> 2] = fb + 3657;
 HEAP32[i1 + 176 >> 2] = gb + 772954;
 HEAP32[i1 + 180 >> 2] = 365;
 HEAP32[i1 + 184 >> 2] = fb + 2270;
 HEAP32[i1 + 188 >> 2] = fb + 3658;
 HEAP32[i1 + 192 >> 2] = gb + 772980;
 HEAP32[i1 + 196 >> 2] = 366;
 HEAP32[i1 + 200 >> 2] = fb + 489;
 HEAP32[i1 + 204 >> 2] = fb + 421;
 __ZN5physx30NbDiscreteContactPairsPropertyC2Ev(i1 + 208 | 0);
 __ZN5physx30NbModifiedContactPairsPropertyC2Ev(i1 + 224 | 0);
 __ZN5physx18NbCCDPairsPropertyC2Ev(i1 + 240 | 0);
 __ZN5physx22NbTriggerPairsPropertyC2Ev(i1 + 256 | 0);
 __ZN5physx24NbBroadPhaseAddsPropertyC2Ev(i1 + 272 | 0);
 __ZN5physx27NbBroadPhaseRemovesPropertyC2Ev(i1 + 288 | 0);
 __ZN5physx16NbShapesPropertyC2Ev(i1 + 304 | 0);
 return;
}

function _int_upsample(i3, i2, i18, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i13 = HEAP32[i3 + 416 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP8[i13 + 140 + i2 >> 0] | 0;
 i12 = i1 & 255;
 i2 = HEAP8[i13 + 150 + i2 >> 0] | 0;
 i13 = i2 & 255;
 i14 = i3 + 276 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 if ((i10 | 0) <= 0) return;
 i11 = i3 + 92 | 0;
 i9 = i1 << 24 >> 24 != 0;
 i8 = i13 + -1 | 0;
 if ((i2 & 255) > 1) {
  i7 = (i1 << 24 >> 24 == 0 ? ~i12 : -2) + i12 + 2 | 0;
  i5 = 0;
  i6 = 0;
  while (1) {
   i2 = HEAP32[i15 + (i6 << 2) >> 2] | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i4 = i2 + i1 | 0;
   if ((i1 | 0) > 0) {
    if (!i9) {
     i1 = 7;
     break;
    }
    i3 = HEAP32[i18 + (i5 << 2) >> 2] | 0;
    i1 = i2;
    while (1) {
     _memset(i1 | 0, HEAP8[i3 >> 0] | 0, i7 | 0) | 0;
     i2 = i12;
     while (1) {
      i1 = i1 + 1 | 0;
      if ((i2 | 0) <= 1) break; else i2 = i2 + -1 | 0;
     }
     if (i1 >>> 0 < i4 >>> 0) i3 = i3 + 1 | 0; else break;
    }
    i1 = HEAP32[i11 >> 2] | 0;
   }
   _jcopy_sample_rows(i15, i6, i15, i6 + 1 | 0, i8, i1);
   i6 = i6 + i13 | 0;
   if ((i6 | 0) >= (HEAP32[i14 >> 2] | 0)) {
    i1 = 24;
    break;
   } else i5 = i5 + 1 | 0;
  }
  if ((i1 | 0) == 7) while (1) {} else if ((i1 | 0) == 24) return;
 }
 if (i9) {
  i16 = 0;
  i17 = 0;
 } else {
  i2 = (HEAP32[i11 >> 2] | 0) > 0;
  i1 = 0;
  while (1) {
   if (i2) {
    i1 = 22;
    break;
   }
   i1 = i1 + i13 | 0;
   if ((i1 | 0) >= (i10 | 0)) {
    i1 = 24;
    break;
   }
  }
  if ((i1 | 0) == 22) while (1) {} else if ((i1 | 0) == 24) return;
 }
 while (1) {
  i1 = HEAP32[i15 + (i17 << 2) >> 2] | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i4 = i1 + i10 | 0;
  if ((i10 | 0) > 0) {
   i3 = HEAP32[i18 + (i16 << 2) >> 2] | 0;
   while (1) {
    _memset(i1 | 0, HEAP8[i3 >> 0] | 0, i12 | 0) | 0;
    i2 = i12;
    while (1) {
     i1 = i1 + 1 | 0;
     if ((i2 | 0) <= 1) break; else i2 = i2 + -1 | 0;
    }
    if (i1 >>> 0 < i4 >>> 0) i3 = i3 + 1 | 0; else break;
   }
  }
  i17 = i17 + i13 | 0;
  if ((i17 | 0) >= (HEAP32[i14 >> 2] | 0)) break; else i16 = i16 + 1 | 0;
 }
 return;
}

function __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv(i8, i9, i10, i11, i12, i6, i13, i14) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i15 = 0;
 i7 = i8 + 1992 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i2 = i8 + 1572 | 0;
  i1 = 1 << i9;
  i15 = 4;
 } else {
  i2 = i8 + 1572 | 0;
  i1 = 1 << i9;
  if (!(HEAP32[i2 >> 2] & i1)) i15 = 4;
 }
 if ((i15 | 0) == 4) {
  mftCall_vi(HEAP32[i8 + 712 >> 2] | 0, i9 | 0);
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i1;
 }
 i3 = i14;
 i4 = i8 + 860 | 0;
 i5 = __ZNK13TranslateGLES23VertexArrayKindBitfieldEN2gl21VertexArrayAttribKindE(HEAP32[i4 >> 2] | 0, i11) | 0;
 i5 = __ZNK13TranslateGLES23VertexArraySizeBitfieldEi(HEAP32[i4 >> 2] | 0, i12) | 0 | i5;
 i5 = i5 | (__ZNK13TranslateGLES23VertexArrayTypeBitfieldE19VertexChannelFormat(HEAP32[i4 >> 2] | 0, i6) | 0);
 i2 = i5 & 255;
 i1 = i8 + 1324 + (i9 << 4) | 0;
 if (HEAP8[i7 >> 0] | 0) if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) if ((HEAP32[i8 + 1324 + (i9 << 4) + 4 >> 2] | 0) == (i13 | 0)) if ((HEAP32[i8 + 1324 + (i9 << 4) + 8 >> 2] | 0) == (i10 | 0)) if ((i2 | 0) == (HEAP32[i8 + 1324 + (i9 << 4) + 12 >> 2] | 0)) return;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i8 + 1324 + (i9 << 4) + 4 >> 2] = i13;
 HEAP32[i8 + 1324 + (i9 << 4) + 8 >> 2] = i10;
 HEAP8[i8 + 1324 + (i9 << 4) + 12 >> 0] = i5;
 i2 = __ZNK13TranslateGLES10VertexTypeE19VertexChannelFormat(HEAP32[i4 >> 2] | 0, i6) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  if (i10 | 0) {
   i1 = i8 + 896 | 0;
   i15 = 14;
  }
 } else {
  i1 = i8 + 896 | 0;
  if (!((i10 | 0) == 0 ? 1 : (HEAP32[i1 >> 2] | 0) == (i10 | 0))) i15 = 14;
 }
 if ((i15 | 0) == 14) {
  HEAP32[i1 >> 2] = i10;
  mftCall_vii(HEAP32[i8 + 644 >> 2] | 0, 34962, i10 | 0);
 }
 switch (i11 | 0) {
 case 1:
 case 0:
  {
   mftCall_viiiiii(HEAP32[i8 + 696 >> 2] | 0, i9 | 0, i12 | 0, i2 | 0, (i11 | 0) == 1 | 0, i13 | 0, i14 | 0);
   return;
  }
 case 2:
  {
   mftCall_viiiii(HEAP32[i8 + 700 >> 2] | 0, i9 | 0, i12 | 0, i2 | 0, i13 | 0, i14 | 0);
   return;
  }
 case 3:
  {
   mftCall_viiiii(HEAP32[i8 + 704 >> 2] | 0, i9 | 0, i12 | 0, i2 | 0, i13 | 0, i14 | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 148 | 0;
 i5 = i2 + 96 | 0;
 i6 = i2 + 48 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 40, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i11 = i1 + 32 | 0;
 i12 = i11;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 0;
 i11 = i11 + 4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 272; else i1 = (HEAP32[i1 >> 2] | 0) + 272 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 272; else i1 = (HEAP32[i1 >> 2] | 0) + 272 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_110DataStream16setPropertyValueEPKvPKcN5physx8debugger7DataRefIKhEERKNS6_14NamespacedNameE(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i6 + 80 | 0;
 i12 = i6 + 72 | 0;
 i14 = i6 + 48 | 0;
 i11 = i6 + 40 | 0;
 i7 = i6;
 i13 = HEAP32[i5 + 64 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, i8 | 0, i2 | 0);
 i8 = HEAP32[i15 + 28 >> 2] | 0;
 i18 = i15 + 32 | 0;
 i19 = HEAP32[i18 >> 2] | 0;
 i18 = HEAP32[i18 + 4 >> 2] | 0;
 i16 = HEAP32[i15 + 40 >> 2] | 0;
 i15 = HEAP32[i15 + 44 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 20 >> 2] | 0, i13 | 0);
 i13 = i1 + 4 | 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = i8;
 i17 = i14 + 4 | 0;
 HEAP32[i17 >> 2] = i19;
 HEAP32[i17 + 4 >> 2] = i18;
 HEAP32[i14 + 12 >> 2] = i16;
 HEAP32[i14 + 16 >> 2] = i15;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 __ZN12_GLOBAL__N_110DataStream19bufferPropertyValueEN5physx8debugger24ClassDescriptionSizeInfoENS2_7DataRefIKhEE(i12, i5, i14, i11);
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i12 + 4 >> 2];
 i12 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i5, i4) | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i1 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i5, HEAP32[i2 >> 2] | 0) | 0;
 i2 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i5, HEAP32[i2 + 4 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = gb + 150240 + 8;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = i3;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i12;
 HEAP32[i7 + 20 >> 2] = i11;
 HEAP32[i7 + 24 >> 2] = i4;
 i4 = i7 + 28 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i7 + 36 >> 2] = ((i10 - i9 | 0) >>> 0) / (i8 >>> 0) | 0;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i5, i7, 7);
 STACKTOP = i6;
 return (HEAPU8[i5 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZNSt3__214__split_bufferIN9ShaderLab20SerializedSubProgramERNS_9allocatorIS2_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 i9 = i1 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 do {
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = gb + 63280 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i11;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  HEAP32[i1 + 48 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 36 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 52 >> 2] = 0;
  i3 = gb + 63280 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i11;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 68 >> 2] = 0;
  HEAP32[i1 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 60 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i1 + 108 | 0;
  i4 = i1 + 120 | 0;
  i5 = i1 + 132 | 0;
  i6 = i1 + 28 | 0;
  i7 = i1 + 76 | 0;
  i8 = i7 + 116 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  HEAP32[i6 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 >> 2] = 3;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i3, 8);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i4, 4);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i5, 4);
  i1 = (HEAP32[i9 >> 2] | 0) + 192 | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 24 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 659991 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 24 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 24 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 24 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx36computeAckermannCorrectedSteerAnglesERKNS_23PxVehicleDriveSimData4WERKNS_23PxVehicleWheels4SimDataEfPf(i6, i8, f3, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f5 = f0, f9 = f0, i10 = 0, f11 = f0;
 f4 = Math_fround(HEAPF32[i6 + 560 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 572 >> 2]);
 f2 = Math_fround(HEAPF32[i8 + 220 >> 2]);
 f1 = Math_fround(HEAPF32[i8 + 268 >> 2]);
 f1 = Math_fround((f2 > f1 ? f2 : f1) * f3);
 if (f1 == Math_fround(0.0)) {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 } else {
  f9 = Math_fround(Math_abs(Math_fround(f1)));
  f11 = Math_fround(f9 + Math_fround(f4 * Math_fround(Math_fround(+Math_atan(+Math_fround(f5 / Math_fround(Math_fround(HEAPF32[i6 + 564 >> 2]) + Math_fround(f5 / Math_fround(+Math_tan(+f9))))))) - f9)));
  f2 = Math_fround(-f11);
  i10 = f1 >= Math_fround(0.0);
  f1 = Math_fround(-f9);
  f1 = i10 ? f11 : f1;
  f2 = i10 ? f9 : f2;
 }
 HEAPF32[i7 >> 2] = Math_fround(f1 + Math_fround(HEAPF32[i8 + 224 >> 2]));
 HEAPF32[i7 + 4 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i8 + 272 >> 2]));
 f11 = Math_fround(HEAPF32[i8 + 316 >> 2]);
 f1 = Math_fround(HEAPF32[i8 + 364 >> 2]);
 f1 = Math_fround((f11 > f1 ? f11 : f1) * f3);
 if (f1 == Math_fround(0.0)) {
  f9 = Math_fround(0.0);
  f11 = Math_fround(0.0);
  i10 = i8 + 320 | 0;
  f5 = Math_fround(HEAPF32[i10 >> 2]);
  f9 = Math_fround(f5 - f9);
  i10 = i7 + 8 | 0;
  HEAPF32[i10 >> 2] = f9;
  i10 = i8 + 368 | 0;
  f9 = Math_fround(HEAPF32[i10 >> 2]);
  f11 = Math_fround(f9 - f11);
  i10 = i7 + 12 | 0;
  HEAPF32[i10 >> 2] = f11;
  return;
 }
 f3 = Math_fround(Math_abs(Math_fround(f1)));
 f5 = Math_fround(f3 + Math_fround(f4 * Math_fround(Math_fround(+Math_atan(+Math_fround(f5 / Math_fround(Math_fround(HEAPF32[i6 + 568 >> 2]) + Math_fround(f5 / Math_fround(+Math_tan(+f3))))))) - f3)));
 f11 = Math_fround(-f5);
 i10 = f1 >= Math_fround(0.0);
 f9 = Math_fround(-f3);
 f9 = i10 ? f5 : f9;
 f11 = i10 ? f3 : f11;
 i10 = i8 + 320 | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f5 - f9);
 i10 = i7 + 8 | 0;
 HEAPF32[i10 >> 2] = f9;
 i10 = i8 + 368 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f11 = Math_fround(f9 - f11);
 i10 = i7 + 12 | 0;
 HEAPF32[i10 >> 2] = f11;
 return;
}

function __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i2, i9, i3) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  HEAP32[i3 >> 2] = i1;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 i2 = i8 + 28 | 0;
 i7 = i9 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i2 = i8 + 56 | 0;
 if ((i8 | 0) == (i9 | 0)) {
  i8 = i8 + 76 | 0;
  i9 = i9 + 76 | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  return;
 }
 i6 = HEAP32[i9 + 56 >> 2] | 0;
 i7 = i8 + 68 | 0;
 i1 = HEAP32[i9 + 68 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i8 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i8 = i8 + 76 | 0;
 i9 = i9 + 76 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 return;
}

function __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) | 0;
 i2 = _strlen(i1) | 0;
 i8 = i11 + 11 | 0;
 do if (i2 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, 10, i2 + -10 | 0, 0, 0, 0, i2, i1);
  i5 = i11 + 4 | 0;
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  if (i2 | 0) _memmove(i11 | 0, i1 | 0, i2 | 0) | 0;
  HEAP8[i11 + i2 >> 0] = 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i5 = i11 + 4 | 0;
   HEAP32[i5 >> 2] = i2;
   break;
  } else {
   i1 = i2 & 255;
   HEAP8[i8 >> 0] = i1;
   i5 = i11 + 4 | 0;
   break;
  }
 } while (0);
 i2 = i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 HEAP32[i10 >> 2] = i2;
 i6 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i10, 4);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 i3 = i1 << 24 >> 24 < 0;
 i2 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 i3 = i2 + i5 | 0;
 if (i5 | 0) {
  i1 = i2;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN7mecanim9animation12StreamedClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 12 | 0, i7);
 i5 = i6 + 40 | 0;
 i9 = i7 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i6 + 36 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, i2 + i4 | 0, i1 << 2);
 }
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = HEAP32[i9 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, 8, 4) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = i1;
  i4 = i4 | 0 ? i4 - i5 | 0 : 0;
  HEAP32[i1 >> 2] = i4;
  i5 = i4 + i5 | 0;
  i4 = i5 + 4 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = i8 + 8 | 0;
  HEAP32[i9 >> 2] = i6;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i7, i8, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = i1;
  i4 = i2;
  i5 = i4 + i5 | 0;
  i4 = i5 + 4 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  i9 = i8 + 4 | 0;
  HEAP32[i9 >> 2] = i5;
  i9 = i8 + 8 | 0;
  HEAP32[i9 >> 2] = i6;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i7, i8, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_(i2, i3, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  HEAP32[i3 >> 2] = i1;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i2 = i9 + 28 | 0;
 i7 = i8 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 i2 = i9 + 56 | 0;
 if ((i8 | 0) == (i9 | 0)) {
  i9 = i9 + 76 | 0;
  i8 = i8 + 76 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  return;
 }
 i6 = HEAP32[i8 + 56 >> 2] | 0;
 i7 = i9 + 68 | 0;
 i1 = HEAP32[i8 + 68 >> 2] << 4;
 i3 = i1 >> 4;
 HEAP32[i7 >> 2] = i3;
 i4 = i9 + 72 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i2 >> 2] = i1;
  break;
 } else i1 = HEAP32[i2 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
 i9 = i9 + 76 | 0;
 i8 = i8 + 76 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 return;
}

function __ZNK11AssetBundle14GetPreloadDataEiR13dynamic_arrayIiLj4EE(i4, i1, i14) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 8 | 0;
 i3 = i15;
 HEAP32[i3 >> 2] = i1;
 if ((HEAP32[i4 + 128 >> 2] | 0) == (HEAP32[i4 + 96 >> 2] | 0)) {
  i2 = HEAP32[i4 + 120 >> 2] | 0;
  i3 = HEAP32[i4 + 124 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_(i2, i4 + 92 | 0, i3);
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 + 120 >> 2] | 0;
  i3 = HEAP32[i4 + 124 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 }
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = i12 + 4 | 0;
 if ((HEAP32[i13 >> 2] | 0) <= 0) {
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i3 = i4 + 48 | 0;
 i4 = i14 + 12 | 0;
 i5 = i14 + 16 | 0;
 i6 = i14 + 4 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i12 >> 2] | 0) + i1 << 2) >> 2] | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i9 = i8 + 1 | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  i11 = i10 & 2147483647;
  do if (i9 >>> 0 > i11 >>> 0) {
   i2 = i10 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i11 >>> 0 < i2 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i5 >> 2] = i2;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 2, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i14 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i9;
  HEAP32[(HEAP32[i14 >> 2] | 0) + (i8 << 2) >> 2] = i7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i13 >> 2] | 0));
 i1 = 1;
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 48 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 48 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN14NavMeshManager10UnloadDataEi(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i10 = i11;
 i1 = HEAP32[i9 + 104 >> 2] | 0;
 if (i1 | 0) __ZN14NavMeshCarving17ApplyCarveResultsEv(i1);
 i4 = i9 + 128 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 } else {
  i3 = i4;
  i2 = i1;
 }
 L6 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i7 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i3;
    break L6;
   }
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i3 = i1;
 }
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) > (i7 | 0)) {
  STACKTOP = i11;
  return;
 }
 i6 = i1;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZN15HeightMeshQuery16RemoveHeightDataEi(HEAP32[i9 + 116 >> 2] | 0, i7);
 i3 = i1 + 36 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i1 + 24 | 0;
  i5 = i9 + 108 | 0;
  i2 = 0;
  do {
   i13 = HEAP32[i4 >> 2] | 0;
   i13 = __ZNK9dtNavMesh12getTileRefAtEiii(HEAP32[i5 >> 2] | 0, i7, HEAP32[i13 + (i2 << 3) >> 2] | 0, HEAP32[i13 + (i2 << 3) + 4 >> 2] | 0) | 0;
   i12 = getTempRet0() | 0;
   __ZN9dtNavMesh10removeTileEyPPKhPi(HEAP32[i5 >> 2] | 0, i13, i12, 0, 0) | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i3 = i1 + 76 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i9 + 108 | 0;
  i2 = i1 + 64 | 0;
  i1 = 0;
  do {
   i13 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
   __ZN9dtNavMesh23removeOffMeshConnectionEy(HEAP32[i4 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE5eraseENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_PvEEiEE(i9 + 124 | 0, i8) | 0;
 if (HEAP32[i9 + 132 >> 2] | 0) {
  STACKTOP = i11;
  return;
 }
 __ZN14NavMeshManager7CleanupEv(i9);
 STACKTOP = i11;
 return;
}

function __ZN13dynamic_arrayIN14SerializedFile4TypeELj8EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 56 | 0, 8, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 56 | 0, 8, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 56 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 < i7 >>> 0) {
  i6 = (HEAP32[i2 >> 2] | 0) + (i8 * 56 | 0) | 0;
  i2 = i7 - i8 | 0;
  if (!i2) return;
  i1 = 0;
  do {
   i3 = i6 + (i1 * 56 | 0) | 0;
   i4 = i9;
   i5 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
 if (i8 >>> 0 <= i7 >>> 0) return;
 i6 = (HEAP32[i2 >> 2] | 0) + (i7 * 56 | 0) | 0;
 i2 = i8 - i7 | 0;
 if (!i2) return; else i1 = 0;
 do {
  i3 = i6 + (i1 * 56 | 0) + 44 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i5 = i4 + 40 | 0;
   if ((HEAP32[i4 + 56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 44 | 0);
    HEAP32[i5 >> 2] = 0;
   }
   if ((HEAP32[i4 + 36 >> 2] | 0) > -1) {
    i10 = i4 + 20 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i4 + 24 | 0);
    HEAP32[i10 >> 2] = 0;
   }
   if ((HEAP32[i4 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
    HEAP32[i4 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63720 | 0);
  HEAP32[i3 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z27RegisterAllowNameConversionR20AllowNameConversionsPKcS2_S2_(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 12 | 0;
 if (!(HEAP8[i9 >> 0] | 0)) i6 = i1; else {
  i7 = _strlen(i1) | 0;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, gb + 63416 | 0, 0, gb + 469031 | 0, 37) | 0;
  _strncpy(i6, i1, i7) | 0;
  HEAP8[i6 + i7 >> 0] = 0;
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i4;
 i7 = __ZNSt3__23mapINS_4pairIPcS2_EENS_3setIS2_15compare_tstringIPKcENS_9allocatorIS2_EEEE20smaller_tstring_pairIS7_ENS9_INS1_IKS3_SB_EEEEEixERSE_(i2, i8) | 0;
 i5 = i6;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((__Z6StrCmpPKcS0_(i6, HEAP32[i2 >> 2] | 0) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 6;
     break;
    } else i1 = i2;
   } else {
    if ((__Z6StrCmpPKcS0_(HEAP32[i2 >> 2] | 0, i6) | 0) >= 0) {
     i2 = 11;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 10;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 6) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 11) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i8;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(20) | 0;
  HEAP32[i1 + 16 >> 2] = i5;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
  i9 = i7 + 8 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 } else {
  if (!(HEAP8[i9 >> 0] | 0)) {
   STACKTOP = i10;
   return;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63416 | 0);
  STACKTOP = i10;
  return;
 }
}

function __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 24 | 0;
 i10 = i13 + 20 | 0;
 i11 = i13;
 i1 = gb + 64016 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i11 + 8 >> 2] = i1;
 __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb(gb + 28900 | 0, i11, 0);
 if (HEAP32[i7 >> 2] | 0) {
  i4 = 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i4 << 2) >> 2];
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i12 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i14 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 13; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i5, i6);
    }
   }
   if ((i12 | 0) == 13) i12 = 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i11 + 4 | 0);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 256; else i1 = (HEAP32[i1 >> 2] | 0) + 256 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 256; else i1 = (HEAP32[i1 >> 2] | 0) + 256 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN19SharedRendererSceneD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 33972 + 8;
 i1 = i5 + 65680 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i5 + 65940 | 0;
 if ((HEAP32[i5 + 65956 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65944 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i5 + 65728 | 0;
 i1 = i5 + 65788 | 0;
 if ((HEAP32[i5 + 65804 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65792 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 65768 | 0;
 if ((HEAP32[i5 + 65784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 65748 | 0;
 if ((HEAP32[i5 + 65764 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65752 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i5 + 65744 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5 + 65732 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i5 + 65708 | 0;
 if ((HEAP32[i5 + 65724 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65712 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 65688 | 0;
 if ((HEAP32[i5 + 65704 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 65692 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i5 + 65632 | 0;
 i3 = i5 + 65644 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 180 | 0) >> 2] | 0;
   i6 = i4 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   if (!(HEAP32[i6 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i5 + 65648 >> 2] | 0) <= -1) {
  i6 = i5 + 32820 | 0;
  __ZN15RenderNodeQueueD2Ev(i6);
  i6 = i5 + 8 | 0;
  __ZN15RenderNodeQueueD2Ev(i6);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5 + 65636 | 0);
 HEAP32[i2 >> 2] = 0;
 i6 = i5 + 32820 | 0;
 __ZN15RenderNodeQueueD2Ev(i6);
 i6 = i5 + 8 | 0;
 __ZN15RenderNodeQueueD2Ev(i6);
 return;
}

function __ZN19AssetBundleManifest8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i4);
 i6 = i1 + 48 | 0;
 i3 = HEAP32[gb + 37052 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 367192 | 0, i3, i6, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags(i4, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 367209 | 0, HEAP32[gb + 37228 >> 2] | 0, i1 + 64 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i5 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 367233 | 0, i3, i1 + 32 | 0, 0);
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEEEvRT_17TransferMetaFlags(i4, i2, 0);
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i3) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
  STACKTOP = i5;
  return;
 }
 i1 = i2 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN14CachingManager10CleanCacheENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 24 | 0;
 i1 = i9 + 12 | 0;
 i7 = i9;
 __Z20GetPlatformCachePathv(i6);
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i6); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i6, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZN15FileSystemEntryC2EPKc(i6, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7);
 if (__ZNK15FileSystemEntry6ExistsEv(i6) | 0) if (__ZN15FileSystemEntry8IsLockedEv(i6) | 0) i1 = 0; else if (__ZN15FileSystemEntry6DeleteEb(i6, 1) | 0) i8 = 7; else i1 = 0; else i8 = 7;
 if ((i8 | 0) == 7) {
  i1 = HEAP32[gb + 1162492 >> 2] | 0;
  if (!i1) {
   i1 = __Znwj(4) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[gb + 1162492 >> 2] = i1;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 1; else {
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i5 = i3;
    i4 = i3;
    i8 = 16;
   } else {
    i4 = i3;
    while (1) {
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) i3 = i2; else {
      __ZN5CacheD2Ev(i3);
      __ZdlPv(i3);
      i3 = HEAP32[i1 >> 2] | 0;
     }
     i4 = i4 + 4 | 0;
     if ((i4 | 0) == (HEAP32[i3 + 4 >> 2] | 0)) break; else i2 = i3;
    }
    if (i3 | 0) {
     i2 = i3;
     i5 = HEAP32[i3 >> 2] | 0;
     i8 = 16;
    }
   }
   if ((i8 | 0) == 16) {
    i3 = i5;
    if (i5 | 0) {
     if ((i4 | 0) != (i5 | 0)) HEAP32[i2 + 4 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
     __ZdlPv(i5);
    }
    __ZdlPv(i2);
   }
   HEAP32[i1 >> 2] = 0;
   i1 = 1;
  }
 }
 __ZN13FileEntryDataD2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZL17sweepVolumeVsMeshPKN5physx3Cct9SweepTestEPKNS0_11TouchedMeshERNS0_12SweptContactERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleEj(i13, i14, i11, i10, i6, i8, i7, i9, i2) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0, d18 = 0.0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i15;
 i12 = i15 + 8 | 0;
 i17 = i15 + 56 | 0;
 HEAP32[i16 >> 2] = i2;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i3 = i12 + 8 | 0;
 HEAP32[i3 >> 2] = -1;
 HEAP16[i12 + 12 >> 1] = 0;
 i4 = i12 + 16 | 0;
 i2 = i12 + 40 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i5 = i11 + 36 | 0;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 HEAP16[i17 >> 1] = (HEAP8[i13 + 283 >> 0] | 0) == 0 ? 7 : 263;
 if (!(__ZN5physx11PxMeshQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleERNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKjfb(i10, f1, i6, i8, i7, i9, i12, i17, i16, Math_fround(0.0), 0) | 0)) {
  i17 = 0;
  STACKTOP = i15;
  return i17 | 0;
 }
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if (f1 >= Math_fround(HEAPF32[i5 >> 2])) {
  i17 = 0;
  STACKTOP = i15;
  return i17 | 0;
 }
 HEAPF32[i5 >> 2] = f1;
 HEAP32[i11 + 24 >> 2] = HEAP32[i12 + 28 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i12 + 32 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i12 + 36 >> 2];
 d18 = +Math_fround(HEAPF32[i4 >> 2]);
 HEAPF64[i11 >> 3] = d18 + +HEAPF64[i14 + 16 >> 3];
 d18 = +Math_fround(HEAPF32[i12 + 20 >> 2]);
 HEAPF64[i11 + 8 >> 3] = d18 + +HEAPF64[i14 + 24 >> 3];
 d18 = +Math_fround(HEAPF32[i12 + 24 >> 2]);
 HEAPF64[i11 + 16 >> 3] = d18 + +HEAPF64[i14 + 32 >> 3];
 i17 = HEAP32[i3 >> 2] | 0;
 HEAP32[i13 + 100 + (HEAP32[i13 + 96 >> 2] << 2) >> 2] = i17;
 i17 = (HEAP32[i14 + 44 >> 2] | 0) + i17 | 0;
 HEAP32[i11 + 40 >> 2] = i17;
 HEAP32[i11 + 44 >> 2] = HEAP32[(HEAP32[i13 + 20 >> 2] | 0) + (i17 << 2) >> 2];
 i17 = 1;
 STACKTOP = i15;
 return i17 | 0;
}

function _scanexp(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 100 | 0;
 if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i6 >> 2] = i1 + 1;
  i1 = HEAPU8[i1 >> 0] | 0;
 } else i1 = ___shgetc(i5) | 0;
 switch (i1 | 0) {
 case 43:
 case 45:
  {
   i2 = (i1 | 0) == 45 & 1;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i1 + 1;
    i1 = HEAPU8[i1 >> 0] | 0;
   } else i1 = ___shgetc(i5) | 0;
   if ((i3 | 0) != 0 & (i1 + -48 | 0) >>> 0 > 9) if (HEAP32[i7 >> 2] | 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   break;
  }
 default:
  i2 = 0;
 }
 if ((i1 + -48 | 0) >>> 0 > 9) if (!(HEAP32[i7 >> 2] | 0)) {
  i2 = -2147483648;
  i1 = 0;
 } else {
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  i2 = -2147483648;
  i1 = 0;
 } else {
  i4 = 0;
  do {
   i4 = i1 + -48 + (i4 * 10 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i1 + 1;
    i1 = HEAPU8[i1 >> 0] | 0;
   } else i1 = ___shgetc(i5) | 0;
  } while ((i1 + -48 | 0) >>> 0 < 10 & (i4 | 0) < 214748364);
  i3 = ((i4 | 0) < 0) << 31 >> 31;
  if ((i1 + -48 | 0) >>> 0 < 10) do {
   i3 = ___muldi3(i4 | 0, i3 | 0, 10, 0) | 0;
   i4 = getTempRet0() | 0;
   i1 = _i64Add(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, -48, -1) | 0;
   i4 = _i64Add(i1 | 0, getTempRet0() | 0, i3 | 0, i4 | 0) | 0;
   i3 = getTempRet0() | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i1 + 1;
    i1 = HEAPU8[i1 >> 0] | 0;
   } else i1 = ___shgetc(i5) | 0;
  } while ((i1 + -48 | 0) >>> 0 < 10 & ((i3 | 0) < 21474836 | (i3 | 0) == 21474836 & i4 >>> 0 < 2061584302));
  if ((i1 + -48 | 0) >>> 0 < 10) do {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP32[i6 >> 2] = i1 + 1;
    i1 = HEAPU8[i1 >> 0] | 0;
   } else i1 = ___shgetc(i5) | 0;
  } while ((i1 + -48 | 0) >>> 0 < 10);
  if (HEAP32[i7 >> 2] | 0) HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  i7 = (i2 | 0) != 0;
  i1 = _i64Subtract(0, 0, i4 | 0, i3 | 0) | 0;
  i2 = getTempRet0() | 0;
  i2 = i7 ? i2 : i3;
  i1 = i7 ? i1 : i4;
 }
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN19CloudServiceHandler18SaveFileFromServerERK8UnityStrS2_PN11UnityEngine15CloudWebService16WWWRestHeaderMapE(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!(HEAP32[i5 + 1144 >> 2] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(2272, gb + 63800 | 0, 16, gb + 1047011 | 0, 199) | 0;
 __ZN11UnityEngine15CloudWebService18RestFileDownloaderC2EPNS0_23IRestDownloaderListenerE(i4, 0);
 HEAP32[i4 >> 2] = gb + 190224 + 8;
 __ZN11UnityEngine15CloudWebService13WWWRestClientC2Ev(i4 + 2168 | 0);
 i6 = i4 + 2236 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i4 + 2248 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP8[i4 + 2252 >> 0] = 0;
 i6 = i4 + 2256 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i4 + 2268 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = i4;
 i6 = i4;
 if (__ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStrS7_S7_(i4, i5 + 36 | 0, i1, i2) | 0) {
  if (i3 | 0) __ZN11UnityEngine15CloudWebService16WWWRestHeaderMapaSERKS1_(i4 + 2212 | 0, i3) | 0;
  i3 = i5 + 1152 | 0;
  i1 = i5 + 1156 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i5 + 1160 >> 2] | 0)) {
   __ZNSt3__26vectorIPN11UnityEngine15CloudWebService17WebFileDownloaderINS2_13WWWRestClientENS2_16WWWRestHeaderMapEEE13stl_allocatorIS7_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS7_EEvRT_(i3, i7);
   i1 = HEAP32[i1 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = i6;
   i6 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
   HEAP32[i1 >> 2] = i6;
   i1 = i6;
  }
  if ((i1 - (HEAP32[i3 >> 2] | 0) | 0) == 4) {
   __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformWWWEv((HEAP32[i7 >> 2] | 0) + 2168 | 0) | 0;
   i1 = 1;
  } else i1 = 1;
 } else i1 = 0;
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 * 76 | 0, 4) | 0;
  i2 = i3 + (i2 * 76 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 60 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 64 >> 2] = Math_fround(-1.0);
    HEAP32[i1 + 68 >> 2] = 1065353216;
    HEAP32[i1 + 72 >> 2] = 3;
    i1 = i1 + 76 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i6 * 76 | 0) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN4math4Axes8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 76 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN18PlatformEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802226 | 0, i5, i1 + 88 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802245 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802257 | 0, i6, i1 + 77 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802277 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802290 | 0, i6, i1 + 78 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802308 | 0, i6, i1 + 79 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802324 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13TrailRenderer5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i3 = i5;
 HEAPF32[i1 + 388 >> 2] = Math_fround(5.0);
 HEAP8[i1 + 340 >> 0] = 1;
 HEAPF32[i1 + 392 >> 2] = Math_fround(.100000001);
 i2 = HEAP32[i1 + 384 >> 2] | 0;
 HEAPF32[i2 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 88 >> 2] = 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i6, Math_fround(0.0), i3);
 __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i2 + 20 | 0, i6) | 0;
 HEAP32[i6 >> 2] = 1065353216;
 HEAP32[i6 + 4 >> 2] = 1065353216;
 HEAP32[i6 + 8 >> 2] = 1065353216;
 HEAP32[i6 + 12 >> 2] = 1065353216;
 HEAPF32[i6 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i6 + 20 >> 2] = 1065353216;
 HEAP32[i6 + 24 >> 2] = 1065353216;
 HEAP32[i6 + 28 >> 2] = 1065353216;
 HEAP32[i6 + 32 >> 2] = 1065353216;
 HEAPF32[i6 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
 i4 = i2 + 108 | 0;
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i4, i6, 2);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i4, i3, 2);
 i2 = i2 + 180 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = HEAP32[i1 + 344 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 24 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 348 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 i6 = i1 + 360 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 372 >> 2] = f9;
 HEAPF32[i1 + 376 >> 2] = f8;
 HEAPF32[i1 + 380 >> 2] = f7;
 STACKTOP = i5;
 return;
}

function __ZNK8Material6GetTagEib(i7, i11, i12) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i9 = i13;
 i6 = HEAP32[i7 + 100 >> 2] | 0;
 i2 = HEAP32[i6 + 176 >> 2] | 0;
 i6 = HEAP32[i6 + 180 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i11 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i11 | 0)) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i1 | 0) > -1) {
   i14 = i1;
   STACKTOP = i13;
   return i14 | 0;
  }
 }
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i14 = -1;
  STACKTOP = i13;
  return i14 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i10 = 12; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i14 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i14 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i14 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 12; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i10 = 14;
  }
 }
 if ((i10 | 0) == 12) i10 = 14;
 if ((i10 | 0) == 14) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i14 = -1;
   STACKTOP = i13;
   return i14 | 0;
  }
 }
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  i14 = -1;
  STACKTOP = i13;
  return i14 | 0;
 }
 i14 = __ZNK9ShaderLab9IntShader6GetTagEib(i1, i11, i12) | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN5physx2Sc5Scene24resizeReleasedBodyIDMapsEjj(i7, i1, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = i7 + 1252 | 0;
 i8 = (i1 + 31 | 0) >>> 5;
 i2 = i7 + 1256 | 0;
 if (i8 >>> 0 > (HEAP32[i2 >> 2] & 2147483647) >>> 0) {
  i3 = i7 + 1260 | 0;
  i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i8 << 2, gb + 769739 | 0, 329) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   _memcpy(i4 | 0, i1 | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i2 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i5 >> 2] | 0);
  }
  i6 = HEAP32[i2 >> 2] | 0;
  _memset(i4 + ((i6 & 2147483647) << 2) | 0, 0, i8 - i6 << 2 | 0) | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i2 >> 2] = i8;
 }
 i1 = HEAP32[i7 + 1200 >> 2] | 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 20 | 0;
 if (i8 >>> 0 > (HEAP32[i3 >> 2] & 2147483647) >>> 0) {
  i4 = i1 + 24 | 0;
  i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i8 << 2, gb + 769739 | 0, 329) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  if (i6 | 0) {
   _memcpy(i5 | 0, i6 | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i2 >> 2] | 0);
  }
  i6 = HEAP32[i3 >> 2] | 0;
  _memset(i5 + ((i6 & 2147483647) << 2) | 0, 0, i8 - i6 << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i3 >> 2] = i8;
 }
 if ((HEAP32[i1 + 36 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1 + 28 | 0, i9);
 i1 = HEAP32[i7 + 1196 >> 2] | 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 20 | 0;
 if (i8 >>> 0 > (HEAP32[i3 >> 2] & 2147483647) >>> 0) {
  i4 = i1 + 24 | 0;
  i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i8 << 2, gb + 769739 | 0, 329) | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  if (i6 | 0) {
   _memcpy(i5 | 0, i6 | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i2 >> 2] | 0);
  }
  i7 = HEAP32[i3 >> 2] | 0;
  _memset(i5 + ((i7 & 2147483647) << 2) | 0, 0, i8 - i7 << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i3 >> 2] = i8;
 }
 if ((HEAP32[i1 + 36 >> 2] & 2147483647) >>> 0 >= i9 >>> 0) return;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1 + 28 | 0, i9);
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL12onDeactivateEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 do if (!(i4 & 4)) {
  if ((HEAP32[i5 + 52 >> 2] | 0) != -1) {
   i3 = i5 + 44 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i1 << 1 & 4194304 | i1;
   i1 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0;
   i1 = HEAP32[i1 + 1104 >> 2] | 0;
   if (!(HEAP32[i3 >> 2] & 8388608)) {
    __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i1, i5);
    break;
   } else {
    __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i1, i5);
    break;
   }
  }
 } else {
  i2 = (HEAP16[(HEAP32[i5 + 56 >> 2] | 0) + 114 >> 1] & 2) != 0;
  i3 = i5 + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!(i2 ^ (i1 & 32768 | 0) != 0)) {
   if ((HEAP32[i5 + 52 >> 2] | 0) == -1) break;
   HEAP32[i3 >> 2] = i1 << 1 & 4194304 | i1;
   i1 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0;
   i1 = HEAP32[i1 + 1104 >> 2] | 0;
   if (!(HEAP32[i3 >> 2] & 8388608)) {
    __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i1, i5);
    break;
   } else {
    __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i1, i5);
    break;
   }
  }
  if (i2) {
   i2 = i1 & -98305;
   HEAP32[i3 >> 2] = i2 | 32768;
   if (!(i1 & 456)) break;
   HEAP32[i3 >> 2] = i2 | 4227072;
   break;
  }
  if (i1 & 456) {
   i1 = i1 & -4194305;
   HEAP32[i3 >> 2] = i1;
  }
  HEAP32[i3 >> 2] = i1 & -98305 | 65536;
 } while (0);
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 if (i1 | 0) {
  i2 = i5 + 44 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!(i3 & 98304)) {
   i1 = HEAPU16[i1 + 114 >> 1] | 0;
   if ((i1 & 3 | 0) != 0 & (i1 & 2 | 0) == 0) HEAP32[i2 >> 2] = i3 | 65536;
  }
  __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv(i5);
 }
 if (i4 & 6 | 0) return 1;
 if (HEAP32[i5 + 44 >> 2] & 262144 | 0) return 1;
 __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, i5 + 60 | 0);
 return 1;
}

function __ZN20UnityConnectSettings10InitializeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP8[i3 + 196 >> 0] = 0;
 HEAP8[i3 + 197 >> 0] = 0;
 i1 = i3 + 28 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i3 + 168 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i3 + 172 | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 164 | 0, i4); else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = i3 + 56 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 164 | 0, i4); else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = i3 + 68 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 164 | 0, i4); else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = i3 + 112 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 164 | 0, i4); else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = HEAP32[gb + 1469024 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  i6 = i6 + 789 | 0;
  HEAP8[i6 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 __ZN13RuntimeStaticI18UnityConnectClientE10InitializeEv(gb + 1469024 | 0);
 i6 = HEAP32[gb + 1469024 >> 2] | 0;
 i6 = i6 + 789 | 0;
 HEAP8[i6 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN17TransformInternal24CreateTransformHierarchyEj(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 __ZN14BatchAllocatorC2Ev(i2);
 HEAP32[i5 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, i5, -1, 76, 1, 4);
 HEAP32[i5 >> 2] = 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, 8, 0, 40, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 12 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 16 | 0, 0, 4, i4, 4);
 i3 = (HEAP32[i5 >> 2] | 0) + 20 | 0;
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, i3, 0, 4, __ZN13BitSetUtility17GetNumberOfBlocksEj(i4) | 0, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 24 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 28 | 0, 0, 1, i4, 1);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 64 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 56 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 60 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 68 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator16AllocateInternalEPPvijjj(i2, (HEAP32[i5 >> 2] | 0) + 72 | 0, 0, 4, i4, 4);
 __ZN14BatchAllocator6CommitERK10MemLabelId(i2, gb + 63160 | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i2 = HEAP32[i5 + 72 >> 2] | 0;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 if (i4 | 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = i1 + -1;
   i7 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i3 + (i7 << 2) >> 2] = i1;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 >> 2] = -1;
 HEAP32[i3 + (i4 + -1 << 2) >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = -1;
 HEAP32[i5 + 36 >> 2] = 0;
 i7 = HEAP32[gb + 1158396 >> 2] | 0;
 HEAP32[i5 + 40 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i5 + 48 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i7 + 40 >> 2];
 STACKTOP = i6;
 return i5 | 0;
}

function __Z37Cloth_Get_Custom_PropCapsuleCollidersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i7 = i2 + 148 | 0;
 i8 = HEAP32[i7 + 12 >> 2] | 0;
 i6 = __Z19GetScriptingManagerv() | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i6 + 168 >> 2] | 0) + (HEAP32[gb + 64328 + 24 >> 2] << 2) >> 2] | 0, 4, i8) | 0;
 if (!i8) {
  STACKTOP = i12;
  return i6 | 0;
 }
 i5 = 0;
 do {
  i4 = (HEAP32[i7 >> 2] | 0) + (i5 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 13; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i2 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 13; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 15;
    }
   }
   if ((i11 | 0) == 13) i11 = 15;
   if ((i11 | 0) == 15) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i5, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i8 | 0));
 STACKTOP = i12;
 return i6 | 0;
}

function __ZN13GfxDeviceGLES11SetTexturesE10ShaderTypeiPK15GfxTextureParam(i2, i1, i14, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i9 = i13;
 if ((i14 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i10 = i2 + 6616 | 0;
 i11 = i2 + 7288 | 0;
 i12 = i2 + 5480 | 0;
 i7 = i2 + 7376 | 0;
 i6 = 0;
 while (1) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 + 8 >> 2];
  i1 = HEAP32[gb + 1157724 >> 2] | 0;
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i4 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i16 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[gb + 1157724 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i16 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i16 + (i2 << 3) | 0;
   i2 = HEAP32[i4 + 28 >> 2] | 0;
   i4 = HEAP32[i4 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i4 << 3) | 0)) i15 = 13; else {
   i16 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i16;
   if (!i16) i15 = 13; else {
    i16 = i1 + 8 | 0;
    i2 = HEAP32[i16 + 4 >> 2] | 0;
    i4 = i11;
    i17 = HEAP32[i4 + 4 >> 2] | 0;
    if (i17 >>> 0 < i2 >>> 0 | ((i17 | 0) == (i2 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0 : 0)) {
     i17 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i12 >> 2] | 0, 3) | 0;
     HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i17;
    }
    __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(i10, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0, i5, 4);
   }
  }
  if ((i15 | 0) == 13) {
   i15 = 0;
   __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(i10, 0, 2, i5, 4);
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == (i14 | 0)) break; else i3 = i3 + 12 | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i6, i3, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i6 >> 2] | 0)) {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i6 + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
  }
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i3;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i6 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + (i6 * 24 | 0) | 0;
 if (i6 | 0) {
  i4 = HEAP32[gb + 36980 >> 2] | 0;
  i5 = i9 + 20 | 0;
  while (1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i9, i2, gb + 1084155 | 0, 0, 0);
   __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 1 | 0, gb + 1086064 | 0, 0, 0);
   __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 2 | 0, gb + 1085890 | 0, 0, 0);
   __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 3 | 0, gb + 1085926 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 4 | 0;
  }
 }
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 88 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj670ES3_RKNS_30PxVehicleAckermannGeometryDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 88 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 560; else i1 = (HEAP32[i1 >> 2] | 0) + 560 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj670ES2_RKNS_30PxVehicleAckermannGeometryDataES6_EEKNS_43PxVehicleAckermannGeometryDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 88 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN14VelocityModule8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085989 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085998 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1084342 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i3 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620372 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function _UNITY_tt_face_load_kern(i12, i2) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i1 = mftCall_iiiii(HEAP32[i12 + 508 >> 2] | 0, i12 | 0, 1801810542, i2 | 0, i4 | 0) | 0;
 if (i1 | 0) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < 4) {
  i12 = 142;
  STACKTOP = i13;
  return i12 | 0;
 }
 i3 = i12 + 740 | 0;
 i1 = _UNITY_FT_Stream_ExtractFrame(i2, i1, i3) | 0;
 if (i1 | 0) {
  i12 = i1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 + 744 >> 2] = i11;
 i1 = HEAP32[i3 >> 2] | 0;
 i11 = i1 + i11 | 0;
 i10 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
 i10 = i10 >>> 0 > 32 ? 32 : i10;
 L10 : do if (!i10) {
  i3 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i9 = i1 + 4 | 0;
  i3 = 0;
  i2 = 0;
  i1 = 0;
  do {
   i8 = 1 << i3;
   i5 = i9 + 6 | 0;
   if (i5 >>> 0 > i11 >>> 0) break L10;
   i4 = (HEAPU8[i9 + 2 >> 0] | 0) << 8 | (HEAPU8[i9 + 3 >> 0] | 0);
   if (i4 >>> 0 < 15) break L10;
   i4 = i9 + i4 | 0;
   i7 = i9;
   i9 = i4 >>> 0 > i11 >>> 0 ? i11 : i4;
   i4 = i7 + 14 | 0;
   L16 : do if (!(i4 >>> 0 > i11 >>> 0 ? 1 : ((HEAPU8[i7 + 4 >> 0] | 0) << 8 | (HEAPU8[i7 + 5 >> 0] | 0) & 247 | 0) != 1)) {
    i5 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i7 + 7 >> 0] | 0);
    i6 = i9 - i4 | 0;
    i5 = (i6 | 0) < (i5 * 6 | 0) ? (i6 | 0) / 6 | 0 : i5;
    i1 = i8 | i1;
    if (i5) {
     i6 = (HEAPU8[i7 + 15 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i7 + 16 >> 0] | 0) << 8 | (HEAPU8[i7 + 17 >> 0] | 0);
     i4 = i7 + 20 | 0;
     while (1) {
      i5 = i5 + -1 | 0;
      if (!i5) break;
      i7 = i6;
      i6 = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
      if (i6 >>> 0 <= i7 >>> 0) break L16; else i4 = i4 + 6 | 0;
     }
     i2 = i8 | i2;
    }
   } while (0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i10 >>> 0);
 } while (0);
 HEAP32[i12 + 748 >> 2] = i3;
 HEAP32[i12 + 752 >> 2] = i1;
 HEAP32[i12 + 756 >> 2] = i2;
 i12 = 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN9allocutil14BuddyAllocatorC2E10MemLabelIdjjj(i6, i1, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 8 | 0;
 i10 = i13;
 i7 = i1;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i6 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 i5 = (i2 >>> 0 > 1 ? i2 : 1) + -1 | 0;
 i5 = i5 >>> 16 | i5;
 i5 = i5 >>> 8 | i5;
 i5 = i5 >>> 4 | i5;
 i5 = i5 >>> 2 | i5;
 i5 = (i5 >>> 1 | i5) + 1 | 0;
 HEAP32[i6 + 12 >> 2] = i5;
 i3 = (i5 >>> 0 > i3 >>> 0 ? i5 : i3) + -1 | 0;
 i3 = i3 >>> 16 | i3;
 i3 = i3 >>> 8 | i3;
 i3 = i3 >>> 4 | i3;
 i3 = i3 >>> 2 | i3;
 i3 = (i3 >>> 1 | i3) + 1 | 0;
 HEAP32[i6 + 16 >> 2] = i3;
 i12 = i6 + 20 | 0;
 i1 = i4 >>> 0 > 1 ? i4 : 1;
 HEAP32[i12 >> 2] = i1;
 if (!i5) i2 = -1; else i2 = 31 - (Math_clz32(i5 | 0) | 0) & 255;
 HEAP8[i6 + 24 >> 0] = i2;
 i14 = 31 - (Math_clz32(i3 | 0) | 0) | 0;
 i14 = (i3 | 0) == 0 ? -1 : i14;
 HEAP8[i6 + 25 >> 0] = i14;
 i4 = i6 + 26 | 0;
 i2 = i14 - (i2 & 255) | 0;
 HEAP8[i4 >> 0] = i2;
 i3 = (Math_imul(i1, i3) | 0) + -1 | 0;
 i3 = i3 >>> 16 | i3;
 i3 = i3 >>> 8 | i3;
 i3 = i3 >>> 4 | i3;
 i3 = i3 >>> 2 | i3;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, i6, 16, gb + 396938 | 0, 233) | 0;
 i6 = i10;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN9allocutil14BuddyAllocator17FreeBlockRegistryC2E10MemLabelIdhj(i1, i11, i2 + 1 & 255, (((i3 >>> 1 | i3) + 1 | 0) >>> 0) / (i5 >>> 0) | 0);
 HEAP32[i8 >> 2] = i1;
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i13;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAPU8[i4 >> 0] | 0;
 i2 = HEAP32[i1 + (i4 << 5) >> 2] | 0;
 i3 = i1 + (i4 << 5) + 20 | 0;
 i4 = i1 + (i4 << 5) + 28 | 0;
 i1 = 0;
 do {
  i14 = i1 >>> 5;
  i11 = i2 + (i14 << 2) | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (1 << (i1 & 31));
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  HEAP32[i4 >> 2] = i14;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 STACKTOP = i13;
 return;
}

function __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE(i1, i8, i9, i10, i11, f12, i13, i14, i15) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 80 | 0;
 i1 = i7 + 52 | 0;
 i2 = i7 + 32 | 0;
 i3 = i7 + 12 | 0;
 i4 = i7;
 i5 = i7 + 96 | 0;
 i19 = HEAP32[i9 >> 2] | 0;
 i16 = HEAP32[i9 + 4 >> 2] | 0;
 i17 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 3;
 HEAP32[i6 + 4 >> 2] = i19;
 HEAP32[i6 + 8 >> 2] = i16;
 HEAP32[i6 + 12 >> 2] = i17;
 i17 = HEAP32[i8 >> 2] | 0;
 i16 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i19 = HEAP32[i11 + 4 >> 2] | 0;
 i18 = HEAP32[i11 + 8 >> 2] | 0;
 i8 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i19;
 HEAP32[i1 + 8 >> 2] = i18;
 HEAP32[i1 + 12 >> 2] = i8;
 HEAP32[i1 + 16 >> 2] = i17;
 HEAP32[i1 + 20 >> 2] = i16;
 HEAP32[i1 + 24 >> 2] = i9;
 HEAP32[i2 >> 2] = gb + 114012 + 8;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i13;
 switch (i14 | 0) {
 case 0:
  {
   HEAP8[i2 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i2 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i2 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 + 16 >> 1] = 7;
 HEAP8[i3 + 18 >> 0] = 0;
 i17 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i19 = HEAP32[gb + 1457404 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i19 >> 2] | 0) + 352 >> 2] | 0;
 i14 = HEAP32[i10 + 4 >> 2] | 0;
 i16 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = i14;
 HEAP32[i4 + 8 >> 2] = i16;
 HEAP16[i5 >> 1] = i17 ? 143 : 15;
 mftCall_iiiiifiiiiif(i18 | 0, i19 | 0, i6 | 0, i1 | 0, i4 | 0, +f12, i15 | 0, i5 | 0, i3 | 0, i2 | 0, 0, 0.0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i4, i6, i8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 i9 = HEAP32[i4 >> 2] | 0;
 if ((HEAP16[gb + 1157656 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157656 | 0, i1);
  i7 = gb + 1157656 | 0;
 } else i7 = 0;
 i3 = i9 + (i8 << 5) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) if (!(HEAP32[i9 + (i8 << 5) + 4 >> 2] | 0)) {
  i3 = i9 + (i8 << 5) + 24 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i9 + (i8 << 5) + 28 >> 2] | 0)) break;
  i1 = i9 + (i8 << 5) + 16 | 0;
  if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
  i1 = i6 + 4512 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 896 >> 2] | 0, i6 | 0) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  }
  i1 = i4 + 20 | 0;
  if (__ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle(i2, i1) | 0) {
   i9 = i9 + (i8 << 5) + 28 | 0;
   mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i9 >> 2] | 0);
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i4 + 24 >> 2] = 0;
   HEAP32[i4 + 28 >> 2] = -1;
   HEAP32[i4 + 32 >> 2] = 0;
   i1 = i9;
  } else i1 = i9 + (i8 << 5) + 28 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 } else i5 = 5; else i5 = 5; while (0);
 if ((i5 | 0) == 5) {
  i2 = i9 + (i8 << 5) + 16 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   __Z21CompleteFenceInternalR8JobFence(i2);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  if (i1 | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 232 >> 2] | 0, i6 | 0, i1 | 0, HEAP32[i9 + (i8 << 5) + 8 >> 2] | 0);
  i1 = i9 + (i8 << 5) + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 232 >> 2] | 0, i6 | 0, i2 | 0, HEAP32[i9 + (i8 << 5) + 12 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i10;
 return;
}

function __ZN14RotationModule8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085989 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085998 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 899332 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i3 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN14LineParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 20 | 0, i3);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 108 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 180 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 184 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 188 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 192 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z20SetupForwardAddLightRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_(i8, f9, i13, i1, i10, i11) {
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i13 = i13 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i12 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i12 = i8 + 40 | 0;
 if ((HEAP32[i12 >> 2] | 0) == 1) {
  f4 = Math_fround(HEAPF32[i8 + 248 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 252 >> 2]);
  f4 = Math_fround(-f4);
  f5 = Math_fround(-f5);
  f6 = Math_fround(-Math_fround(HEAPF32[i8 + 256 >> 2]));
  f7 = Math_fround(0.0);
 } else {
  f4 = Math_fround(HEAPF32[i8 + 264 >> 2]);
  f5 = Math_fround(HEAPF32[i8 + 268 >> 2]);
  f6 = Math_fround(HEAPF32[i8 + 272 >> 2]);
  f7 = Math_fround(1.0);
 }
 HEAPF32[i2 + 548 >> 2] = f4;
 HEAPF32[i2 + 552 >> 2] = f5;
 HEAPF32[i2 + 556 >> 2] = f6;
 HEAPF32[i2 + 560 >> 2] = f7;
 __Z20CalculateLightMatrixRK15SharedLightDataP10Matrix4x4f(i8, i2 + 2724 | 0);
 i2 = i13 + 4 | 0;
 i3 = HEAP32[i2 >> 2] & -32;
 HEAP32[i2 >> 2] = i3;
 L5 : do switch (HEAP32[i12 >> 2] | 0) {
 case 0:
  {
   HEAP32[i2 >> 2] = i3 | 1;
   break;
  }
 case 2:
  if (!(HEAP8[i8 + 84 >> 0] | 0)) {
   HEAP32[i2 >> 2] = i3 | 8;
   break L5;
  } else {
   HEAP32[i2 >> 2] = i3 | 16;
   break L5;
  }
 case 1:
  if (!(HEAP8[i8 + 84 >> 0] | 0)) {
   HEAP32[i2 >> 2] = i3 | 2;
   break L5;
  } else {
   HEAP32[i2 >> 2] = i3 | 4;
   break L5;
  }
 default:
  {}
 } while (0);
 i3 = __Z12GetGfxDevicev() | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i8 + 156 >> 2]) * f9);
 f6 = Math_fround(Math_fround(HEAPF32[i8 + 160 >> 2]) * f9);
 f7 = Math_fround(Math_fround(HEAPF32[i8 + 164 >> 2]) * f9);
 f9 = Math_fround(Math_fround(HEAPF32[i8 + 168 >> 2]) * f9);
 HEAPF32[i3 + 564 >> 2] = f5;
 HEAPF32[i3 + 568 >> 2] = f6;
 HEAPF32[i3 + 572 >> 2] = f7;
 HEAPF32[i3 + 576 >> 2] = f9;
 switch (HEAP32[i12 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP8[i8 + 84 >> 0] | 0 ? i1 : i10;
   break;
  }
 case 2:
  {
   i1 = HEAP8[i8 + 84 >> 0] | 0 ? i1 : i11;
   break;
  }
 case 1:
  {
   if (!(HEAP8[i8 + 84 >> 0] | 0)) return;
   break;
  }
 default:
  return;
 }
 __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef(i13 + 36 | 0, gb + 1111220 | 0, i1);
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 i9 = i1 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 do {
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = gb + 63280 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i11;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  HEAP32[i1 + 48 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 36 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 52 >> 2] = 0;
  i3 = gb + 63280 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i11;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 68 >> 2] = 0;
  HEAP32[i1 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i11);
  i5 = i10;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i1 + 60 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i1 + 108 | 0;
  i4 = i1 + 120 | 0;
  i5 = i1 + 132 | 0;
  i6 = i1 + 28 | 0;
  i7 = i1 + 76 | 0;
  i8 = i7 + 116 | 0;
  do {
   HEAP32[i7 >> 2] = 0;
   i7 = i7 + 4 | 0;
  } while ((i7 | 0) < (i8 | 0));
  HEAP32[i6 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 >> 2] = 3;
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i3, 8);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i4, 4);
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i5, 4);
  i1 = (HEAP32[i9 >> 2] | 0) + 192 | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i12;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIR15ReflProbeSorterPP15ReflectionProbeEEbT0_S6_T_(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 switch (i8 - i7 >> 2 | 0) {
 case 2:
  {
   i1 = i8 + -4 | 0;
   if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i9, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0)) {
    i9 = 1;
    return i9 | 0;
   }
   i9 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i9;
   i9 = 1;
   return i9 | 0;
  }
 case 3:
  {
   __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i7, i7 + 4 | 0, i8 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 4:
  {
   __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_(i7, i7 + 4 | 0, i7 + 8 | 0, i8 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 5:
  {
   __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_(i7, i7 + 4 | 0, i7 + 8 | 0, i7 + 12 | 0, i8 + -4 | 0, i9) | 0;
   i9 = 1;
   return i9 | 0;
  }
 case 1:
 case 0:
  {
   i9 = 1;
   return i9 | 0;
  }
 default:
  {
   i3 = i7 + 8 | 0;
   __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i7, i7 + 4 | 0, i3, i9) | 0;
   i1 = i7 + 12 | 0;
   L3 : do if ((i1 | 0) == (i8 | 0)) {
    i2 = 1;
    i1 = 0;
   } else {
    i2 = 0;
    while (1) {
     if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i9, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) {
      i5 = HEAP32[i1 >> 2] | 0;
      i6 = i5;
      i4 = i1;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
       if ((i3 | 0) == (i7 | 0)) break;
       i4 = i3 + -4 | 0;
       if (__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i9, i6, HEAP32[i4 >> 2] | 0) | 0) {
        i10 = i3;
        i3 = i4;
        i4 = i10;
       } else break;
      }
      HEAP32[i3 >> 2] = i5;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == 8) {
       i2 = 0;
       i1 = (i1 + 4 | 0) == (i8 | 0);
       break L3;
      }
     }
     i3 = i1 + 4 | 0;
     if ((i3 | 0) == (i8 | 0)) {
      i2 = 1;
      i1 = 0;
      break;
     } else {
      i10 = i1;
      i1 = i3;
      i3 = i10;
     }
    }
   } while (0);
   i10 = i1 | i2;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN9JSONWrite8TransferI4PPtrI9Texture2DEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 24 | 0;
 i15 = i16;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i16;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i15 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i15;
 HEAP32[i14 >> 2] = HEAP32[i11 >> 2];
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i10, i14, gb + 1034719 | 0, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i15);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i15);
 STACKTOP = i16;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 * 12 | 0) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i15 = i9 + (i11 * 12 | 0) + 4 | 0;
   i18 = HEAP32[i15 >> 2] | 0;
   i18 = i18 + ~(i18 << 15) | 0;
   i18 = (i18 >>> 10 ^ i18) * 9 | 0;
   i18 = i18 >>> 6 ^ i18;
   i18 = i18 + ~(i18 << 11) | 0;
   i16 = i9 + (i11 * 12 | 0) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i17 = i17 + ~(i17 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i5 + (((i18 >>> 16 ^ i18 ^ (i17 ^ -57320555 ^ i17 >>> 16) * 1000007) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i11;
   HEAP32[i7 + (i11 * 12 | 0) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i7 + (i11 * 12 | 0) + 4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i7 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i9 + (i11 * 12 | 0) + 8 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5Umbra18ReceiverMaskBufferC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 1 & -2;
 i4 = i2 + 1 & -2;
 _memcpy(i3 | 0, i4 | 0, 32768) | 0;
 i3 = i3 + 32768 + 3 & -4;
 i2 = i3;
 i4 = i4 + 32768 + 3 & -4;
 i1 = i4;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 _memcpy(i2 + 64 | 0, i1 + 64 | 0, 276) | 0;
 HEAP32[i2 + 340 >> 2] = HEAP32[i1 + 340 >> 2];
 HEAP32[i2 + 344 >> 2] = HEAP32[i1 + 344 >> 2];
 HEAP32[i2 + 348 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i2 + 352 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i2 + 356 >> 2] = HEAP32[i1 + 356 >> 2];
 HEAP32[i2 + 360 >> 2] = HEAP32[i1 + 360 >> 2];
 HEAP32[i2 + 364 >> 2] = HEAP32[i1 + 364 >> 2];
 HEAP32[i2 + 368 >> 2] = HEAP32[i1 + 368 >> 2];
 HEAP32[i2 + 372 >> 2] = HEAP32[i1 + 372 >> 2];
 HEAP32[i2 + 376 >> 2] = HEAP32[i1 + 376 >> 2];
 HEAP32[i2 + 380 >> 2] = HEAP32[i1 + 380 >> 2];
 HEAP32[i2 + 384 >> 2] = HEAP32[i1 + 384 >> 2];
 HEAP32[i2 + 388 >> 2] = HEAP32[i1 + 388 >> 2];
 HEAP32[i2 + 392 >> 2] = HEAP32[i1 + 392 >> 2];
 HEAP32[i2 + 396 >> 2] = HEAP32[i1 + 396 >> 2];
 HEAP32[i2 + 400 >> 2] = HEAP32[i1 + 400 >> 2];
 i2 = i2 + 404 | 0;
 i1 = i1 + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i2 + 32 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
 return;
}

function __ZN12NavMeshAgent14UpdateRotationER9Transformf(i5, i8, f6) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 f6 = Math_fround(f6);
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, i7 = 0, i9 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i2 = i10;
 i7 = i5 + 56 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) == Math_fround(inf)) {
  __ZNK9Transform11GetRotationEv(i2, i8);
  __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i9, i2, 4);
  HEAP32[i7 >> 2] = HEAP32[i9 + 4 >> 2];
 }
 i2 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i5 + 68 | 0) | 0;
 f1 = Math_fround(HEAPF32[i2 + 516 >> 2]);
 f4 = Math_fround(f1 * f1);
 f3 = Math_fround(HEAPF32[i2 + 524 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f3 * f3));
 if (f4 > Math_fround(.00100000005)) {
  f1 = Math_fround(+Math_atan2(+f1, +f3));
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f1 = Math_fround(f1 - f3);
  f1 = Math_fround(f1 - Math_fround(Math_fround(Math_floor(Math_fround(f1 / Math_fround(6.28318548)))) * Math_fround(6.28318548)));
  i2 = f1 > Math_fround(3.14159274);
  f11 = Math_fround(f1 + Math_fround(-6.28318548));
  f1 = i2 ? f11 : f1;
  i2 = f1 < Math_fround(0.0);
  f11 = Math_fround(-f1);
  f1 = i2 ? f11 : f1;
  f4 = Math_fround(Math_fround(Math_fround(Math_sqrt(Math_fround(f4))) + Math_fround(1.0)) * f1);
  f11 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 52 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
  f6 = Math_fround((f11 < f4 ? f11 : f4) * f6);
  f1 = Math_fround(f3 + Math_fround((i2 ? Math_fround(-1.0) : Math_fround(1.0)) * (f6 < f1 ? f6 : f1)));
  HEAPF32[i7 >> 2] = f1;
 } else f1 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(f1 * Math_fround(.5));
 f11 = Math_fround(+Math_sin(+f6));
 HEAPF32[i9 + 12 >> 2] = Math_fround(+Math_cos(+f6));
 HEAPF32[i9 >> 2] = Math_fround(f11 * Math_fround(HEAPF32[gb + 62536 >> 2]));
 HEAPF32[i9 + 4 >> 2] = Math_fround(f11 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2]));
 HEAPF32[i9 + 8 >> 2] = Math_fround(f11 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]));
 __ZN9Transform30SetRotationWithoutNotificationERK11Quaternionf(i8, i9);
 STACKTOP = i10;
 return;
}

function __Z7ApplySHR15SHConstantCacheRK17LightProbeContextRK10RenderNodeb(i9, i7, i1, i2) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 if (!i2) {
  i2 = i9 + 108 | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) != (HEAP32[i7 + (i1 << 2) >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= 27) {
    i10 = 20;
    break;
   }
  }
  if ((i10 | 0) == 20) {
   STACKTOP = i11;
   return;
  }
  i1 = i7;
  i3 = i2 + 108 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2(HEAP32[i9 + 216 >> 2] | 0, i7);
  STACKTOP = i11;
  return;
 }
 i6 = i1 + 232 | 0;
 if (!((HEAPU16[i6 >> 1] | 0 | (HEAPU8[i6 + 2 >> 0] | 0) << 16) & 8192)) __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i7, i1 + 300 | 0, i8); else {
  i5 = HEAP32[i1 + 320 >> 2] | 0;
  i6 = i7 + 124 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i4 = 0; else i4 = (HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i5 >>> 0;
  i1 = HEAP32[i7 + 116 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i5 >>> 0) {
   i2 = i8;
   i1 = (HEAP32[i1 >> 2] | 0) + (i5 * 108 | 0) | 0;
   i3 = i2 + 108 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    i2 = i2 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
  } else __ZN20SphericalHarmonicsL27SetZeroEv(i8);
  if (i4) __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i8, (HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + (i5 * 108 | 0) | 0, Math_fround(HEAPF32[i7 + 108 >> 2]));
 }
 i2 = i9 + 108 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) != (HEAP32[i8 + (i1 << 2) >> 2] | 0)) {
   i10 = 18;
   break;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < 27);
 if ((i10 | 0) == 18) {
  i1 = i8;
  i3 = i2 + 108 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2(HEAP32[i9 + 216 >> 2] | 0, i8);
 }
 STACKTOP = i11;
 return;
}

function __Z26GetScriptClassIdComponentsP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES9_S9_(i9, i8, i4, i10) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = __Z29scripting_class_get_namespaceP11Il2CppClass(i9) | 0;
 i6 = _strlen(i5) | 0;
 i7 = i4 + 11 | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i1 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 do if (i6 >>> 0 > i1 >>> 0) {
  i7 = i3 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i1, i6 - i1 | 0, i7, 0, i7, i6, i5);
 } else {
  i1 = i3 ? HEAP32[i4 >> 2] | 0 : i4;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i4 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 i4 = __Z32scripting_class_get_assemblynameP11Il2CppClass(i9) | 0;
 i5 = _strlen(i4) | 0;
 i6 = i8 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i7 = i2 ? HEAP32[i8 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i3, i5 - i3 | 0, i7, 0, i7, i5, i4);
 } else {
  i1 = i2 ? HEAP32[i8 >> 2] | 0 : i8;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i6 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i6 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i10 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i10 >> 2] >> 0] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i9, i10);
  return;
 } else {
  HEAP8[i10 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
  __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i9, i10);
  return;
 }
}

function __GLOBAL__sub_I_runtime_camera2_lump_cpp() {
 var i1 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111076 | 0, gb + 379446 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111088 | 0, gb + 379482 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111100 | 0, gb + 379525 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111112 | 0, gb + 379559 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111124 | 0, gb + 379581 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111136 | 0, gb + 379598 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111148 | 0, gb + 379628 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111160 | 0, gb + 379649 | 0, 0, 0);
 i1 = gb + 1098008 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1111172 >> 2] = 0;
 HEAP32[gb + 1111172 + 4 >> 2] = 0;
 HEAP32[gb + 1111172 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111184 | 0, gb + 379670 | 0, 0, 0);
 HEAPF32[gb + 1111044 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1111044 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1111044 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1111044 + 12 >> 2] = Math_fround(.5);
 HEAPF32[gb + 1111044 + 16 >> 2] = Math_fround(.5);
 HEAPF32[gb + 1111044 + 20 >> 2] = Math_fround(.5);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111196 | 0, gb + 379682 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111208 | 0, gb + 379718 | 0, 0, 0);
 HEAP32[gb + 1111220 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1111220 | 0, gb + 386536 | 0);
 HEAP32[gb + 1111068 >> 2] = gb + 1111068;
 HEAP32[gb + 1111068 + 4 >> 2] = gb + 1111068;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1111224 | 0, gb + 379738 | 0, 0, 0);
 return;
}

function __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i15, i16) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i18;
 i1 = HEAP32[i15 >> 2] | 0;
 i17 = i15 + 4 | 0;
 i2 = HEAP32[i17 >> 2] | 0;
 i14 = i16 + 4 | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i14;
  i4 = i15;
  i2 = HEAP32[i14 >> 2] | 0;
 } else {
  i13 = i12 + 4 | 0;
  i10 = i2;
  i2 = HEAP32[i14 >> 2] | 0;
  do {
   i9 = i10;
   i10 = i10 + -20 | 0;
   HEAP32[i2 + -20 >> 2] = HEAP32[i10 >> 2];
   i6 = i2 + -16 | 0;
   i7 = i9 + -16 | 0;
   i3 = HEAP32[i9 + -4 >> 2] | 0;
   HEAP32[i6 >> 2] = 0;
   i11 = i2 + -12 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i2 + -8 >> 2] = 0;
   i4 = i2 + -4 | 0;
   HEAP32[i4 >> 2] = i3;
   i9 = i9 + -12 | 0;
   i5 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = i5 >> 2;
   if (i8 | 0) {
    if ((i5 | 0) < 0) {
     __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
     i3 = HEAP32[i4 >> 2] | 0;
    }
    HEAP32[i12 >> 2] = 51;
    HEAP32[i13 >> 2] = i3;
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
    HEAP32[i11 >> 2] = i4;
    HEAP32[i6 >> 2] = i4;
    HEAP32[i2 + -8 >> 2] = i4 + (i8 << 2);
    i3 = HEAP32[i7 >> 2] | 0;
    i2 = (HEAP32[i9 >> 2] | 0) - i3 | 0;
    if ((i2 | 0) > 0) {
     _memcpy(i4 | 0, i3 | 0, i2 | 0) | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (i2 >> 2 << 2);
    }
   }
   i2 = (HEAP32[i14 >> 2] | 0) + -20 | 0;
   HEAP32[i14 >> 2] = i2;
  } while ((i10 | 0) != (i1 | 0));
  i3 = i14;
  i4 = i15;
  i1 = HEAP32[i15 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = i1;
 i14 = i16 + 8 | 0;
 i13 = HEAP32[i17 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i14 >> 2] = i13;
 i14 = i15 + 8 | 0;
 i17 = i16 + 12 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i17 >> 2] = i15;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i18;
 return;
}

function __ZN9JSONWrite8TransferIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i9 = HEAP32[i11 >> 2] | 0;
 __ZN9JSONWrite27TransferStringToCurrentNodeEPKc(i10, (i9 | 0) == 0 ? i11 + 4 | 0 : i9);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 if (!(HEAP8[i8 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i11 = i10 + 11 | 0;
 HEAP8[i11 >> 0] = 7;
 HEAP8[i10 >> 0] = HEAP8[gb + 1040810 >> 0] | 0;
 HEAP8[i10 + 1 >> 0] = HEAP8[gb + 1040810 + 1 >> 0] | 0;
 HEAP8[i10 + 2 >> 0] = HEAP8[gb + 1040810 + 2 >> 0] | 0;
 HEAP8[i10 + 3 >> 0] = HEAP8[gb + 1040810 + 3 >> 0] | 0;
 HEAP8[i10 + 4 >> 0] = HEAP8[gb + 1040810 + 4 >> 0] | 0;
 HEAP8[i10 + 5 >> 0] = HEAP8[gb + 1040810 + 5 >> 0] | 0;
 HEAP8[i10 + 6 >> 0] = HEAP8[gb + 1040810 + 6 >> 0] | 0;
 HEAP8[i10 + 7 >> 0] = 0;
 i6 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i1, i10) | 0;
 i7 = i6 + 768 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 1002 | 0)) {
    i4 = i6 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L4;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if ((HEAP8[i11 >> 0] | 0) < 0) {
  i11 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 }
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNKSt3__214__codecvt_utf8IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_(i2, i1, i4, i10, i12, i3, i11, i13) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i4;
 i8 = i10;
 if ((i8 - i1 | 0) > 2 ? (HEAP32[i2 + 12 >> 2] & 4 | 0) != 0 : 0) if ((HEAP8[i4 >> 0] | 0) == -17) if ((HEAP8[i4 + 1 >> 0] | 0) == -69) if ((HEAP8[i4 + 2 >> 0] | 0) == -65) i7 = i4 + 3 | 0; else i7 = i1; else i7 = i1; else i7 = i1; else i7 = i1;
 L6 : while (1) {
  i6 = i7;
  i1 = i6 >>> 0 < i10 >>> 0;
  if (!(i1 & i3 >>> 0 < i11 >>> 0)) {
   i14 = 26;
   break;
  }
  i1 = HEAP8[i6 >> 0] | 0;
  i5 = i1 & 255;
  do if (i1 << 24 >> 24 > -1) {
   if (i5 >>> 0 > i9 >>> 0) {
    i1 = 2;
    break L6;
   }
   HEAP16[i3 >> 1] = i1 & 255;
   i1 = i6 + 1 | 0;
  } else {
   if ((i1 & 255) < 194) {
    i1 = 2;
    break L6;
   }
   if ((i1 & 255) < 224) {
    if ((i8 - i7 | 0) < 2) {
     i1 = 1;
     break L6;
    }
    i1 = HEAPU8[i6 + 1 >> 0] | 0;
    if ((i1 & 192 | 0) != 128) {
     i1 = 2;
     break L6;
    }
    i1 = i1 & 63 | i5 << 6 & 1984;
    if (i1 >>> 0 > i9 >>> 0) {
     i1 = 2;
     break L6;
    }
    HEAP16[i3 >> 1] = i1;
    i1 = i6 + 2 | 0;
    break;
   }
   if ((i1 & 255) >= 240) {
    i1 = 2;
    break L6;
   }
   if ((i8 - i7 | 0) < 3) {
    i1 = 1;
    break L6;
   }
   i4 = HEAP8[i6 + 1 >> 0] | 0;
   i2 = HEAP8[i6 + 2 >> 0] | 0;
   switch (i1 << 24 >> 24) {
   case -32:
    {
     if ((i4 & -32) << 24 >> 24 != -96) {
      i1 = 2;
      break L6;
     }
     break;
    }
   case -19:
    {
     if ((i4 & -32) << 24 >> 24 != -128) {
      i1 = 2;
      break L6;
     }
     break;
    }
   default:
    if ((i4 & -64) << 24 >> 24 != -128) {
     i1 = 2;
     break L6;
    }
   }
   i1 = i2 & 255;
   if ((i1 & 192 | 0) != 128) {
    i1 = 2;
    break L6;
   }
   i1 = (i4 & 255) << 6 & 4032 | i5 << 12 | i1 & 63;
   if ((i1 & 65535) >>> 0 > i9 >>> 0) {
    i1 = 2;
    break L6;
   }
   HEAP16[i3 >> 1] = i1;
   i1 = i6 + 3 | 0;
  } while (0);
  i3 = i3 + 2 | 0;
  i7 = i1;
 }
 if ((i14 | 0) == 26) i1 = i1 & 1;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i13 >> 2] = i3;
 return i1 | 0;
}

function __ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_(i3, i6, i7, i1, i2, i9, i10) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 if (!((i1 & 983040 | 0) == 65536 & 0 == 0)) {
  i10 = -2147483640;
  return i10 | 0;
 }
 i8 = i1 & 65535;
 if (i8 >>> 0 > (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
  i10 = -2147483640;
  return i10 | 0;
 }
 i2 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i4 = HEAP32[i3 + 48 >> 2] | 0;
 i5 = i4 + (i8 * 104 | 0) | 0;
 if ((i5 | 0) == 0 ? 1 : (i2 | 0) != (HEAP32[i4 + (i8 * 104 | 0) + 92 >> 2] | 0)) {
  i10 = -2147483640;
  return i10 | 0;
 }
 i1 = HEAP32[i4 + (i8 * 104 | 0) + 88 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = -2147483648;
  return i10 | 0;
 }
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (i1 << 4) | 0;
 if (!i1) {
  i10 = -2147483648;
  return i10 | 0;
 }
 i2 = i3 + 36 | 0;
 while (1) {
  i3 = i1;
  if ((HEAP32[i3 >> 2] | 0) == (i6 | 0) ? (HEAP32[i3 + 4 >> 2] | 0) == (i7 | 0) : 0) {
   i2 = 10;
   break;
  }
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = -2147483648;
   i2 = 13;
   break;
  }
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0;
  if (!i1) {
   i1 = -2147483648;
   i2 = 13;
   break;
  }
 }
 if ((i2 | 0) == 10) switch (HEAP8[i1 + 12 >> 0] | 0) {
 case 0:
  {
   HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 8 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 32 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 36 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 40 >> 2];
   i10 = 1073741824;
   return i10 | 0;
  }
 case 1:
  {
   HEAP32[i9 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 32 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 36 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 40 >> 2];
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i4 + (i8 * 104 | 0) + 8 >> 2];
   i10 = 1073741824;
   return i10 | 0;
  }
 default:
  {
   i10 = -2147483648;
   return i10 | 0;
  }
 } else if ((i2 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZNK9Polygon2D14GetNearestEdgeERK8Vector2fRiS3_S3_Rfb(i1, i24, i25, i26, i27, i28, i2) {
 i1 = i1 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i29 = 0;
 i23 = HEAP32[i1 >> 2] | 0;
 i21 = (HEAP32[i1 + 4 >> 2] | 0) - i23 | 0;
 i22 = (i21 | 0) / 20 | 0;
 if ((i21 | 0) <= 0) {
  i28 = 0;
  return i28 | 0;
 }
 i16 = (i2 ^ 1) << 31 >> 31;
 i17 = i24 + 4 | 0;
 f18 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 i1 = 0;
 f3 = Math_fround(3402823469999999843913219.0e14);
 i15 = 0;
 do {
  i19 = HEAP32[i23 + (i15 * 20 | 0) + 12 >> 2] | 0;
  i20 = i19 + i16 | 0;
  i21 = i23 + (i15 * 20 | 0) | 0;
  i2 = 0;
  L6 : while (1) {
   f13 = Math_fround(HEAPF32[i24 >> 2]);
   f14 = Math_fround(HEAPF32[i17 >> 2]);
   while (1) {
    if ((i2 | 0) >= (i20 | 0)) break L6;
    i11 = i2 + 1 | 0;
    i12 = (i11 | 0) % (i19 | 0) | 0;
    i29 = HEAP32[i21 >> 2] | 0;
    f6 = Math_fround(HEAPF32[i29 + (i2 << 3) >> 2]);
    f7 = Math_fround(f13 - f6);
    f8 = Math_fround(HEAPF32[i29 + (i2 << 3) + 4 >> 2]);
    f9 = Math_fround(f14 - f8);
    f5 = Math_fround(Math_fround(HEAPF32[i29 + (i12 << 3) >> 2]) - f6);
    f4 = Math_fround(Math_fround(HEAPF32[i29 + (i12 << 3) + 4 >> 2]) - f8);
    f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4))));
    if (f10 > f18) {
     f5 = Math_fround(f5 / f10);
     f4 = Math_fround(f4 / f10);
    }
    f9 = Math_fround(Math_fround(f7 * f5) + Math_fround(f9 * f4));
    i29 = f9 < Math_fround(0.0);
    f9 = i29 ? Math_fround(0.0) : f9 > f10 ? f10 : f9;
    f10 = Math_fround(Math_fround(f6 + Math_fround(f5 * f9)) - f13);
    f4 = Math_fround(Math_fround(f8 + Math_fround(f4 * f9)) - f14);
    f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f4 * f4))));
    if (f4 < f3) break; else i2 = i11;
   }
   HEAP32[i25 >> 2] = i15;
   HEAP32[i26 >> 2] = i2;
   HEAP32[i27 >> 2] = i12;
   HEAPF32[i28 >> 2] = f4;
   i2 = i11;
   i1 = 1;
   f3 = f4;
  }
  i15 = i15 + 1 | 0;
 } while ((i15 | 0) < (i22 | 0));
 return i1 | 0;
}

function __ZN9AudioClip15CreateUserSoundERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjsjb(i6, i7, i8, i3, i4, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN9AudioClip16EnableLegacyModeEv(i6);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0);
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (!i1) i2 = 4; else if (!(HEAP8[i1 + 224 >> 0] | 0)) i2 = 4;
 if ((i2 | 0) == 4) {
  __ZN11SoundHandle7ReleaseEv(i6 + 56 | 0);
  i1 = HEAP8[i6 + 72 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i6 + 76 >> 2] | 0; else i1 = i1 & 255;
  if (i1 | 0) if (__Z24GetManagerPtrFromContexti(3) | 0) __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i6);
 }
 HEAP32[i6 + 36 >> 2] = i3 << 16 >> 16;
 HEAP32[i6 + 32 >> 2] = i4;
 HEAP32[i6 + 40 >> 2] = 32;
 if (i5) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 870767 | 0, 0, gb + 854464 | 0, 424, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
 i1 = i6 + 124 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 + 24 >> 0] = 1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP8[i5 + 32 >> 0] = 0;
 HEAP32[i5 + 4 >> 2] = 5;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0, i6 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  __ZN9AudioClip16EnableLegacyModeEv(i6);
  if (__ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0) {
   i8 = (HEAP32[i1 >> 2] | 0) + 60 | 0;
   i7 = __Z24GetAudioScriptingClassesv() | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP8[i8 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
   i8 = (HEAP32[i1 >> 2] | 0) + 68 | 0;
   i7 = (__Z24GetAudioScriptingClassesv() | 0) + 8 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP8[i8 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
  }
 }
 HEAP32[i9 >> 2] = __ZN9AudioClip11CreateSoundEv(i6) | 0;
 __ZN11SoundHandleaSERKS_(i6 + 56 | 0, i9);
 __ZN11SoundHandleD2Ev(i9);
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN4Mesh13SetVertexDataEPKvjjji(i7, i8, i10, i11, i5, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i3 = i13 + 8 | 0;
 if (i12 >>> 0 > 3) {
  if (!i7) i1 = 0; else i1 = HEAP32[i7 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427019 | 0, 0, gb + 425656 | 0, 731, 1, i1, 0, 0);
  STACKTOP = i13;
  return;
 }
 i6 = i7 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i9 = i1 + 8 | 0;
 i2 = HEAPU8[i9 + 32 + (i12 * 12 | 0) + 10 >> 0] | 0;
 if ((i2 | 0) != (i10 | 0)) {
  HEAP32[i4 >> 2] = i10;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z6FormatPKcz(i3, gb + 427057 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 425656 | 0, 738, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i1 + 100 >> 2] | 0;
 if (i2 >>> 0 < i5 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427131 | 0, 0, gb + 425656 | 0, 745, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i13;
  return;
 }
 if ((i2 - i5 | 0) >>> 0 < i11 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427174 | 0, 0, gb + 425656 | 0, 752, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i6 >> 2] | 0);
  i2 = HEAP32[i6 >> 2] | 0;
  i5 = i2 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i6 >> 2] = i1;
 }
 _memcpy((HEAP32[i1 + 92 >> 2] | 0) + (HEAP32[i9 + 32 + (i12 * 12 | 0) + 4 >> 2] | 0) | 0, i8 | 0, Math_imul(i11, i10) | 0) | 0;
 __ZN4Mesh16SetChannelsDirtyEjb(i7, HEAP32[i9 + 32 + (i12 * 12 | 0) >> 2] | 0, 0);
 STACKTOP = i13;
 return;
}

function __ZN16b2PulleyJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_S4_S4_f(i1, i2, i3, i4, i5, i6, i7, f8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 i11 = i4;
 i15 = HEAP32[i11 + 4 >> 2] | 0;
 i16 = i1 + 20 | 0;
 HEAP32[i16 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i16 + 4 >> 2] = i15;
 i16 = i5;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i11 = i1 + 28 | 0;
 HEAP32[i11 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i11 + 4 >> 2] = i15;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i11 = i6 + 4 | 0;
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 f14 = Math_fround(f14 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f10 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f13 = Math_fround(f9 * f10);
 f12 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f9 = Math_fround(Math_fround(f10 * f14) - Math_fround(f9 * f12));
 HEAPF32[i1 + 36 >> 2] = Math_fround(f13 + Math_fround(f14 * f12));
 HEAPF32[i1 + 40 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 i2 = i7 + 4 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f14 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f13 = Math_fround(f9 * f14);
 f10 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f9 = Math_fround(Math_fround(f14 * f12) - Math_fround(f9 * f10));
 HEAPF32[i1 + 44 >> 2] = Math_fround(f13 + Math_fround(f12 * f10));
 HEAPF32[i1 + 48 >> 2] = f9;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i4 >> 2]));
 f10 = Math_fround(HEAPF32[i11 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i4 + 4 >> 2]));
 HEAPF32[i1 + 52 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10))));
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i5 >> 2]));
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i5 + 4 >> 2]));
 HEAPF32[i1 + 56 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9))));
 HEAPF32[i1 + 60 >> 2] = f8;
 return;
}

function __ZN14SubstanceValue8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431322 | 0, i6, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431332 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431342 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431352 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932887 | 0, gb + 1034905 | 0, i6, 0);
 i1 = i7 + 8 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 16 | 0;
 i6 = i14 + 12 | 0;
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 i10 = i14;
 i11 = i1 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i13 = i1 + 8 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
 i4 = i2 - i3 | 0;
 i5 = i4 >> 3;
 if ((i4 | 0) > 0) {
  i1 = i5;
  while (1) {
   i4 = __ZnwjRKSt9nothrow_t(i1 << 3, gb + 1576254 | 0) | 0;
   if (i4 | 0) break;
   i1 = i1 >>> 1;
   if (!i1) {
    i4 = 0;
    i1 = 0;
    break;
   }
  }
 } else {
  i4 = 0;
  i1 = 0;
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi(i6, i7, i10, i5, i4, i1);
 if (i4 | 0) __ZdlPv(i4);
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) != (i7 | 0)) {
  i2 = i1;
  while (1) {
   i5 = i2 + 8 | 0;
   if ((i5 | 0) == (i7 | 0)) {
    i12 = 20;
    break;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) < (i4 | 0)) i2 = i5; else break;
  }
  if ((i12 | 0) == 20) {
   STACKTOP = i14;
   return;
  }
  i1 = i2;
  L20 : do if ((i2 | 0) != (i7 | 0)) {
   i2 = i5;
   i6 = i3;
   i3 = i5;
   while (1) {
    if ((i6 | 0) < (i4 | 0)) {
     HEAP32[i2 >> 2] = i4;
     HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     i2 = i2 + 8 | 0;
    }
    i5 = i3 + 8 | 0;
    i3 = i1 + 8 | 0;
    if ((i5 | 0) == (i7 | 0)) {
     i1 = i2;
     break L20;
    }
    i1 = i3;
    i6 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i5 >> 2] | 0;
    i3 = i5;
   }
  } while (0);
 }
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i13 >> 2] = i7 + (~((i7 + -8 - i1 | 0) >>> 3) << 3);
 STACKTOP = i14;
 return;
}

function __ZN13GfxDeviceGLESD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 75860 + 8;
 __Z24PluginsSetGraphicsDevicePvi18GfxDeviceEventType(0, HEAP32[i3 + 4388 >> 2] | 0, 1);
 __ZN25TransformFeedbackSkinning31CleanupTransformFeedbackShadersEv();
 __ZN9GfxDevice20CleanupSharedBuffersEv(i3);
 __ZN19ConstantBuffersGLES5ClearEv(i3 + 6624 | 0);
 __ZN9GfxDevice16DeleteDynamicVBOEv(i3);
 __Z24ReleaseBufferManagerGLESv();
 i4 = i3 + 7384 | 0;
 __ZN22VertexDeclarationCache5ClearEv(i4);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 690 >> 0] | 0) {
  i2 = i3 + 4620 | 0;
  __ZN7ApiGLES13DeleteSamplerERj(i2, i3 + 7044 | 0);
  __ZN7ApiGLES13DeleteSamplerERj(i2, i3 + 7048 | 0);
  __ZN7ApiGLES13DeleteSamplerERj(i2, i3 + 7052 | 0);
  __ZN7ApiGLES13DeleteSamplerERj(i2, i3 + 7056 | 0);
 }
 i1 = i3 + 4616 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN14GfxContextGLESD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 __ZN11ContextGLES7DestroyEv();
 i1 = i3 + 8476 | 0;
 if ((HEAP32[i3 + 8492 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 8480 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3 + 8464 | 0, HEAP32[i3 + 8468 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3 + 8452 | 0, HEAP32[i3 + 8456 >> 2] | 0);
 HEAP32[i4 >> 2] = gb + 41128 + 8;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3 + 7404 | 0, HEAP32[i3 + 7408 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3 + 7388 | 0, HEAP32[i3 + 7392 >> 2] | 0);
 __ZN15DeviceStateGLESD2Ev(i3 + 6616 | 0);
 __ZN7ApiGLESD2Ev(i3 + 4620 | 0);
 __ZN9GfxDeviceD2Ev(i3);
 return;
}

function __ZN12LODFadeCache14ApplyValueOnlyEf(i1, f5) {
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 i10 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = i1 + 8 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i2 = (i11 & 2147483647 | 0) == 0 ? 0 : i11 >> 31 | 1;
 i3 = (i10 & 2147483647 | 0) == 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if ((i2 | 0) == ((i3 ? 0 : i10 >> 31 | 1) | 0)) {
  if ((i2 | 0) < 0) {
   f4 = Math_fround(f4 - f5);
   i11 = f4 < Math_fround(0.0);
   f12 = Math_fround(-f4);
   if (!((i11 ? f12 : f4) <= Math_fround(9.99999997e-07))) break;
   STACKTOP = i9;
   return;
  }
  if (i3) {
   STACKTOP = i9;
   return;
  }
  f14 = Math_fround(f4 * Math_fround(16.0));
  i10 = f14 >= Math_fround(0.0);
  f13 = Math_fround(f14 + Math_fround(-.99999994));
  f4 = Math_fround(f5 * Math_fround(16.0));
  i11 = f4 >= Math_fround(0.0);
  f12 = Math_fround(f4 + Math_fround(-.99999994));
  if ((~~(i10 ? f14 : f13) | 0) == (~~(i11 ? f4 : f12) | 0)) {
   STACKTOP = i9;
   return;
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (HEAP32[i1 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i1);
 f13 = Math_fround(Math_abs(Math_fround(f5)));
 f12 = Math_fround(f13 * Math_fround(16.0));
 i11 = f12 >= Math_fround(0.0);
 f14 = Math_fround(f12 + Math_fround(-.99999994));
 i11 = ~~(i11 ? f12 : f14);
 f14 = Math_fround(Math_fround(((i11 | 0) > 15 ? 15 : i11) | 0) * Math_fround(.0625));
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i7 + 4 >> 2] = f14;
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 i11 = (HEAP32[i1 >> 2] | 0) + 960 | 0;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 >> 2] = 1073741884;
 __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE(i1 + 8 | 0, i6, i7, 2);
 HEAPF32[i8 >> 2] = f5;
 STACKTOP = i9;
 return;
}

function __ZN10SizeModule8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 899332 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 272 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085998 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 536 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1084342 | 0, gb + 620173 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i3 + 800 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function _cff_index_init(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 4 | 0;
 i11 = i13;
 i12 = HEAP32[i8 + 28 >> 2] | 0;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i10 >> 2] = i8;
 i4 = i10 + 4 | 0;
 HEAP32[i4 >> 2] = _UNITY_FT_Stream_Pos(i8) | 0;
 i1 = _UNITY_FT_Stream_ReadUShort(i8, i11) | 0;
 do if (!(HEAP32[i11 >> 2] | 0)) {
  i3 = i1 & 65535;
  if (!(i1 << 16 >> 16)) {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  i1 = _UNITY_FT_Stream_ReadChar(i8, i11) | 0;
  if (!(HEAP32[i11 >> 2] | 0)) {
   i2 = i1 & 255;
   if ((i1 + -1 & 255) > 3) {
    HEAP32[i11 >> 2] = 8;
    break;
   }
   HEAP32[i10 + 8 >> 2] = i3;
   i5 = i10 + 12 | 0;
   HEAP8[i5 >> 0] = i1;
   i6 = Math_imul(i2, i3 + 1 | 0) | 0;
   HEAP32[i10 + 16 >> 2] = i6 + 3 + (HEAP32[i4 >> 2] | 0);
   i6 = _UNITY_FT_Stream_Skip(i8, Math_imul(i2, i3) | 0) | 0;
   HEAP32[i11 >> 2] = i6;
   if (!i6) {
    i4 = _UNITY_FT_Stream_Read(HEAP32[i10 >> 2] | 0, i7, HEAPU8[i5 >> 0] | 0) | 0;
    i6 = (i4 | 0) == 0;
    if (!i6) {
     HEAP32[i11 >> 2] = i4;
     break;
    }
    i1 = HEAP8[i5 >> 0] | 0;
    if (!(i1 << 24 >> 24)) HEAP32[i11 >> 2] = i4; else {
     i3 = i1 & 255;
     i1 = 0;
     i2 = 0;
     do {
      i1 = HEAPU8[i7 + i2 >> 0] | 0 | i1 << 8;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
     HEAP32[i11 >> 2] = i4;
     if (!i6) break;
     if (i1 | 0) {
      i1 = i1 + -1 | 0;
      HEAP32[i10 + 20 >> 2] = i1;
      if (!(i9 << 24 >> 24)) i1 = _UNITY_FT_Stream_Skip(i8, i1) | 0; else i1 = _UNITY_FT_Stream_ExtractFrame(i8, i1, i10 + 28 | 0) | 0;
      HEAP32[i11 >> 2] = i1;
      if (!i1) i1 = 0; else break;
      STACKTOP = i13;
      return i1 | 0;
     }
    }
    HEAP32[i11 >> 2] = 8;
   }
  }
 } while (0);
 i10 = i10 + 24 | 0;
 _UNITY_ft_mem_free(i12, HEAP32[i10 >> 2] | 0);
 HEAP32[i10 >> 2] = 0;
 i12 = HEAP32[i11 >> 2] | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i11, i12, i9, i8, i5, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i11, i12, i9, i8, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  i1 = i5 + 4 | 0;
  i7 = i8 + 4 | 0;
 } else {
  if (i4 >>> 0 < i3 >>> 0) {
   i12 = i10;
   return i12 | 0;
  }
  i1 = i5 + 4 | 0;
  i2 = i8 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i7 = i2; else {
   i12 = i10;
   return i12 | 0;
  }
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i5 >> 2] = i4;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 i1 = i10 + 1 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) i6 = i9 + 4 | 0; else {
  if (i4 >>> 0 < i3 >>> 0) {
   i12 = i1;
   return i12 | 0;
  }
  i2 = i9 + 4 | 0;
  if ((HEAP32[i7 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i6 = i2; else {
   i12 = i1;
   return i12 | 0;
  }
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i8 >> 2] = i4;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i1 = i10 + 2 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) i5 = i12 + 4 | 0; else {
  if (i4 >>> 0 < i3 >>> 0) {
   i12 = i1;
   return i12 | 0;
  }
  i2 = i12 + 4 | 0;
  if ((HEAP32[i6 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i5 = i2; else {
   i12 = i1;
   return i12 | 0;
  }
 }
 HEAP32[i12 >> 2] = i3;
 HEAP32[i9 >> 2] = i4;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i2 = i10 + 3 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) i1 = i11 + 4 | 0; else {
  if (i4 >>> 0 < i3 >>> 0) {
   i12 = i2;
   return i12 | 0;
  }
  i1 = i11 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
   i12 = i2;
   return i12 | 0;
  }
 }
 HEAP32[i11 >> 2] = i3;
 HEAP32[i12 >> 2] = i4;
 i12 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i12;
 i12 = i10 + 4 | 0;
 return i12 | 0;
}

function __ZN9Animation25GetClipWithNameSerializedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i10 = i12;
 i2 = HEAP32[i1 + 284 >> 2] | 0;
 i6 = i1 + 288 | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i7 = i8 + 11 | 0;
 i5 = i8 + 4 | 0;
 L4 : while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i10 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i11 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i13 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i11 = 11;
    }
   }
   if ((i11 | 0) == 9) i11 = 11;
   if ((i11 | 0) == 11) {
    i11 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   i4 = _strlen(i3) | 0;
   i13 = HEAP8[i7 >> 0] | 0;
   if ((i4 | 0) == ((i13 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i13 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, i3, i4) | 0)) break L4;
  } while (0);
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
   i1 = 0;
   i11 = 16;
   break;
  }
 }
 if ((i11 | 0) == 16) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i13 = i1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 24 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 24 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i1 = HEAP32[i10 + 1088 + (i8 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i9 = 0; else {
  i9 = i10 + 1712 | 0;
  i9 = HEAP32[(HEAP32[i9 >> 2] | 0) + i9 + (i1 << 3) + 4 >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i7 = 0; else {
  i7 = i10 + 1712 | 0;
  i7 = HEAP32[(HEAP32[i7 >> 2] | 0) + i7 + (i1 << 3) + 4 >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 2 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 0; else {
  i6 = i10 + 1712 | 0;
  i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i1 << 3) + 4 >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 3 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f5 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) + 4 >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 4 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f4 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f4 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) + 4 >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 5 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) + 4 >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 6 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f2 = Math_fround(1.0); else {
  i12 = i10 + 1712 | 0;
  f2 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) + 4 >> 2]);
 }
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))))));
 f14 = Math_fround(f5 * f15);
 f13 = Math_fround(f4 * f15);
 f4 = Math_fround(f3 * f15);
 f5 = Math_fround(f2 * f15);
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i11 + 8 >> 2] = i6;
 HEAPF32[i11 + 12 >> 2] = f14;
 HEAPF32[i11 + 16 >> 2] = f13;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i11 + 24 >> 2] = f5;
 HEAP32[i11 + 28 >> 2] = 1065353216;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 return;
}

function __ZN13MonoBehaviour12AddToManagerEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 256 | 0;
 i6 = i11 + 8 | 0;
 i7 = i11;
 i3 = i11 + 248 | 0;
 i8 = i5 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (!i9) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP32[i2 + 88 >> 2] | 0)) {
  if (HEAP32[i2 + 96 >> 2] | 0) i4 = 6;
 } else i4 = 6;
 if ((i4 | 0) == 6) {
  HEAP32[i3 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 694 | 0, i10, Math_fround(-10.0), 0, Math_fround(0.0), 0, 7);
 }
 __ZN13MonoBehaviour31AddBehaviourCallbacksToManagersEv(i5);
 if (!(HEAP8[i5 + 140 >> 0] | 0)) {
  __ZN13MonoBehaviour9CallAwakeEv(i5);
  if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0)) {
   STACKTOP = i11;
   return;
  }
  if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0)) {
   STACKTOP = i11;
   return;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 64 >> 2] | 0;
 i3 = i4;
 if (i4 | 0) {
  i1 = HEAP32[i1 + 68 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
   i8 = HEAP32[i8 >> 2] | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i7 + 4 >> 2] = i1;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i8, i10);
   HEAP32[i6 + 216 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i10 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i10, 0) | 0;
  }
  if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0)) {
   STACKTOP = i11;
   return;
  }
  if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0)) {
   STACKTOP = i11;
   return;
  }
 }
 __ZN13MonoBehaviour40AddExternalDependencyCallbacksToManagersEv(i5);
 STACKTOP = i11;
 return;
}

function __ZNK5physx18PxFabricCookerImpl4saveERNS_14PxOutputStreamEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i1;
 i5 = i1 + 8 | 0;
 HEAP32[i11 >> 2] = 1;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i11 | 0, 4) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i11 = i5 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 + 8 >> 2];
 i12 = i5 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i3 + 4 >> 2];
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i3 + 20 >> 2] | 0) + -1;
 i10 = i5 + 16 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i3 + 16 >> 2] | 0) + 4;
 i8 = i5 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 + 28 >> 2];
 i7 = i5 + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 + 40 >> 2];
 i4 = i5 + 28 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 + 56 >> 2];
 i6 = i5 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 + 52 >> 2];
 i5 = i5 + 36 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 + 64 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i11 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i9 | 0, 4) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i4 | 0, 4) | 0;
 i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 2) >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i8 >> 2] | 0, i3 << 2 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i7 >> 2] | 0, i3 << 3 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZN9JSONWrite8TransferIN11UnityEngine15CloudWebService17CloudServiceEvent8MsgValueEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i10 | 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN7mecanim9animation29MotionOutputSetDeltaTransformEPNS0_12MotionOutputERKN4math4trsXE(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, f5 = f0, f7 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f2 = Math_fround(f2 / f7);
 f4 = Math_fround(f4 / f7);
 f5 = Math_fround(Math_fround(HEAPF32[i6 + 8 >> 2]) / f7);
 i9 = f7 != Math_fround(0.0);
 i3 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i14 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i1;
 HEAP32[i8 + 12 >> 2] = i14;
 f2 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f13 = Math_fround(f2 * f2);
 f4 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f12 = Math_fround(f4 * f4);
 f10 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f5 = Math_fround(f10 * f10);
 f11 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f11 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f13 + f12) + Math_fround(f5 + Math_fround(f11 * f11))))));
 f2 = Math_fround(f2 * f11);
 f4 = Math_fround(f4 * f11);
 f11 = Math_fround(f10 * f11);
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f11 * f11) + Math_fround(0.0)))));
 f5 = Math_fround(Math_fround(+Math_asin(+f10)) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 * f5) / f10);
 f4 = Math_fround(Math_fround(f4 * f5) / f10);
 f5 = Math_fround(Math_fround(f11 * f5) / f10);
 i6 = f10 != Math_fround(0.0);
 f2 = i6 ? f2 : Math_fround(0.0);
 f4 = i6 ? f4 : Math_fround(0.0);
 f2 = Math_fround(f2 / f7);
 f4 = Math_fround(f4 / f7);
 f5 = Math_fround((i6 ? f5 : Math_fround(0.0)) / f7);
 i3 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i14 = i9 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i8 + 16 >> 2] = i3;
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i14;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj669ES3_RKNS_27PxVehicleDifferential4WDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 528; else i1 = (HEAP32[i1 >> 2] | 0) + 528 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj669ES2_RKNS_27PxVehicleDifferential4WDataES6_EEKNS_40PxVehicleDifferential4WDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN2UI13CanvasManager39EmitScreenSpaceCamerasGeometryForCameraEP6CameraS2_(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i11 = i14;
 i12 = i14 + 16 | 0;
 i2 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i10 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i10, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i2, i10, Math_fround(4.0), 0);
 HEAP16[i12 >> 1] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = i6;
  while (1) {
   i3 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i3) break; else i1 = i3;
  }
  i5 = HEAP32[i1 + 40 >> 2] | 0;
  if (!i5) i1 = 0; else {
   HEAP32[i11 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i13 = 12; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
     i3 = HEAP32[i10 >> 2] | 0;
     i15 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 12; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i13 = 14;
    }
   }
   if ((i13 | 0) == 12) i13 = 14;
   if ((i13 | 0) == 14) {
    i13 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   }
  }
  if ((i1 | 0) == (i8 | 0) & (__ZNK2UI6Canvas13GetRenderModeEv(i6) | 0) == 1) __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i6, i9, i12, 1);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i7 >> 2] | 0));
 STACKTOP = i14;
 return;
}

function __ZNKSt3__214__codecvt_utf8IDsE9do_lengthER11__mbstate_tPKcS5_j(i2, i1, i12, i10, i11) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i8 = i10;
 if (!(HEAP32[i2 + 12 >> 2] & 4)) {
  i7 = 0;
  i1 = i12;
 } else if ((i8 - i12 | 0) > 2) if ((HEAP8[i12 >> 0] | 0) == -17) if ((HEAP8[i12 + 1 >> 0] | 0) == -69) {
  i7 = 0;
  i1 = (HEAP8[i12 + 2 >> 0] | 0) == -65 ? i12 + 3 | 0 : i12;
 } else {
  i7 = 0;
  i1 = i12;
 } else {
  i7 = 0;
  i1 = i12;
 } else {
  i7 = 0;
  i1 = i12;
 }
 L6 : while (1) {
  if (!(i7 >>> 0 < i11 >>> 0 & i1 >>> 0 < i10 >>> 0)) {
   i2 = 28;
   break;
  }
  i2 = HEAP8[i1 >> 0] | 0;
  i6 = i2 & 255;
  do if (i2 << 24 >> 24 > -1) {
   if (i6 >>> 0 > i9 >>> 0) {
    i2 = 28;
    break L6;
   }
   i1 = i1 + 1 | 0;
  } else {
   if ((i2 & 255) < 194) {
    i2 = 28;
    break L6;
   }
   if ((i2 & 255) < 224) {
    if ((i8 - i1 | 0) < 2) {
     i2 = 28;
     break L6;
    }
    i2 = HEAPU8[i1 + 1 >> 0] | 0;
    if ((i2 & 192 | 0) != 128) {
     i2 = 28;
     break L6;
    }
    if ((i2 & 63 | i6 << 6 & 1984) >>> 0 > i9 >>> 0) {
     i2 = 28;
     break L6;
    }
    i1 = i1 + 2 | 0;
    break;
   }
   if ((i2 & 255) >= 240) {
    i2 = 28;
    break L6;
   }
   i4 = i1;
   if ((i8 - i4 | 0) < 3) {
    i2 = 28;
    break L6;
   }
   i5 = HEAP8[i1 + 1 >> 0] | 0;
   i3 = HEAP8[i1 + 2 >> 0] | 0;
   switch (i2 << 24 >> 24) {
   case -32:
    {
     if ((i5 & -32) << 24 >> 24 != -96) {
      i2 = 20;
      break L6;
     }
     break;
    }
   case -19:
    {
     if ((i5 & -32) << 24 >> 24 != -128) {
      i2 = 22;
      break L6;
     }
     break;
    }
   default:
    if ((i5 & -64) << 24 >> 24 != -128) {
     i2 = 24;
     break L6;
    }
   }
   i2 = i3 & 255;
   if ((i2 & 192 | 0) != 128) {
    i2 = 28;
    break L6;
   }
   if (((i5 & 255) << 6 & 4032 | i6 << 12 & 61440 | i2 & 63) >>> 0 > i9 >>> 0) {
    i2 = 28;
    break L6;
   } else i1 = i1 + 3 | 0;
  } while (0);
  i7 = i7 + 1 | 0;
 }
 if ((i2 | 0) == 20) i1 = i4 - i12 | 0; else if ((i2 | 0) == 22) i1 = i4 - i12 | 0; else if ((i2 | 0) == 24) i1 = i4 - i12 | 0; else if ((i2 | 0) == 28) i1 = i1 - i12 | 0;
 return i1 | 0;
}

function __ZN8VRDevice14AfterRenderingEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i5 = i7;
 if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i6 + 288 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  if ((HEAP16[gb + 1469320 + 6 >> 1] | 0) > -1) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469320 | 0, i4);
   i1 = gb + 1469320 | 0;
  } else i1 = 0;
  i3 = HEAP32[gb + 1469320 >> 2] | 0;
  i8 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 648 >> 2] | 0, i8 | 0, i3 | 0);
  __ZN19VREyeTextureManager20FlushToDeviceTextureEf(HEAP32[i2 >> 2] | 0, Math_fround(HEAPF32[i6 + 312 >> 2]));
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 652 >> 2] | 0, i3 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 i8 = __Z12GetGfxDevicev() | 0;
 i2 = i6 + 320 | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 860 >> 2] | 0, i8 | 0, 2, HEAP32[i2 >> 2] | 0);
 if ((HEAP32[i6 + 156 >> 2] | 0) == 1) {
  if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i4);
   i1 = gb + 1469192 | 0;
  } else i1 = 0;
  i8 = __Z12GetGfxDevicev() | 0;
  i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 536 >> 2] | 0, i8 | 0) | 0;
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 544 >> 2] | 0, i3 | 0, i8 | 0);
  __Z15gpu_time_samplev();
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i4);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i6 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 7, i3 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 HEAP8[i6 + 330 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN7mecanim9animation18CreateAnimationSetEjjjRNS_6memory9AllocatorE(i2, i1, i8, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i10 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, 40, 4) | 0;
 i5 = i10 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = -1;
 HEAP32[i10 + 32 >> 2] = -1;
 HEAP8[i10 + 36 >> 0] = 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i2;
 i5 = i7;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 if (!i2) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i2 * 40 | 0, 4) | 0;
  i3 = i1 + (i2 * 40 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    i5 = i2;
    i4 = i7;
    i6 = i5 + 40 | 0;
    do {
     HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
     i5 = i5 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i5 | 0) < (i6 | 0));
    i2 = i2 + 40 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i10 + 8 >> 2] = i1;
 i3 = i10 + 12 | 0;
 HEAP32[i3 >> 2] = i8;
 if (!i8) i2 = 0; else {
  i1 = i8 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i8 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 }
 HEAP32[i10 + 16 >> 2] = i2;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 i2 = i10 + 24 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = HEAP32[i10 >> 2] | 0;
 if (!i3) {
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 if ((i3 | 0) == 1) {
  STACKTOP = i11;
  return i10 | 0;
 } else i1 = 1;
 do {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 24 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 706277 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 24 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP8[i1 + 20 >> 0] = HEAP8[i2 + 20 >> 0] | 0;
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 24 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP8[i4 + (i1 * 24 | 0) + 20 >> 0] = HEAP8[i6 + 20 >> 0] | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 24 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx3Cct18computeTemporalBoxERNS_17PxExtendedBounds3EffffRKNS_6PxVec3ERKNS_14PxExtendedVec3ES5_(i20, f4, f3, f2, f19, i6, i11, i12) {
 i20 = i20 | 0;
 f4 = Math_fround(f4);
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 f19 = Math_fround(f19);
 i6 = i6 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var d1 = 0.0, d5 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0, d24 = 0.0, d25 = 0.0, d26 = 0.0, f27 = f0, f28 = f0, f29 = f0, f30 = f0;
 f30 = Math_fround(f4 + f2);
 f27 = Math_fround(f3 * Math_fround(.5));
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f29 = Math_fround(f30 + Math_fround(f27 * Math_fround(Math_abs(Math_fround(f3)))));
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f28 = Math_fround(f30 + Math_fround(f27 * Math_fround(Math_abs(Math_fround(f4)))));
 f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f27 = Math_fround(f30 + Math_fround(f27 * Math_fround(Math_abs(Math_fround(f2)))));
 d17 = +HEAPF64[i11 >> 3];
 d18 = +HEAPF64[i11 + 8 >> 3];
 d13 = +HEAPF64[i11 + 16 >> 3];
 d14 = +f29;
 d8 = d17 - d14;
 d15 = +f28;
 d9 = d18 - d15;
 d16 = +f27;
 d10 = d13 - d16;
 d7 = d14 + d17;
 d5 = d15 + d18;
 d1 = d13 + d16;
 d23 = d17 + +Math_fround(HEAPF32[i12 >> 2]);
 d22 = d18 + +Math_fround(HEAPF32[i12 + 4 >> 2]);
 d21 = d13 + +Math_fround(HEAPF32[i12 + 8 >> 2]);
 d26 = d23 - d14;
 d25 = d22 - d15;
 d24 = d21 - d16;
 d23 = d14 + d23;
 d22 = d15 + d22;
 d21 = d16 + d21;
 d8 = d8 > d26 ? d26 : d8;
 d9 = d9 > d25 ? d25 : d9;
 d10 = d10 > d24 ? d24 : d10;
 d7 = d7 < d23 ? d23 : d7;
 d5 = d5 < d22 ? d22 : d5;
 d1 = d1 < d21 ? d21 : d1;
 if (f19 != Math_fround(0.0)) {
  d25 = d17 - +Math_fround(f3 * f19);
  d26 = d18 - +Math_fround(f4 * f19);
  d13 = d13 - +Math_fround(f2 * f19);
  d22 = d25 - d14;
  d23 = d26 - d15;
  d24 = d13 - d16;
  d25 = d14 + d25;
  d26 = d15 + d26;
  d13 = d16 + d13;
  d8 = d8 > d22 ? d22 : d8;
  d9 = d9 > d23 ? d23 : d9;
  d10 = d10 > d24 ? d24 : d10;
  d7 = d7 < d25 ? d25 : d7;
  d5 = d5 < d26 ? d26 : d5;
  if (d1 < d13) d1 = d13;
 }
 HEAPF64[i20 >> 3] = d8;
 HEAPF64[i20 + 8 >> 3] = d9;
 HEAPF64[i20 + 16 >> 3] = d10;
 HEAPF64[i20 + 24 >> 3] = d7;
 HEAPF64[i20 + 32 >> 3] = d5;
 HEAPF64[i20 + 40 >> 3] = d1;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 420 | 0;
 i14 = i11 + 368 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i15 = i11 + 36 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i15);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i5;
 HEAP32[i14 + 24 >> 2] = i4;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i13;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN7SubMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426529 | 0, i6, i1 + 32 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426539 | 0, i6, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 40 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426550 | 0, HEAP32[gb + 37040 >> 2] | 0, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426457 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426469 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426559 | 0, gb + 1034406 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i2 = i9 + 68 | 0;
 L1 : do if (HEAP32[i2 >> 2] | 0) {
  i3 = i9 + 64 | 0;
  i1 = 0;
  while (1) {
   i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if ((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0) | 0) == (i8 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break L1;
  }
  i6 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
  HEAP32[i2 >> 2] = i6;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
 } while (0);
 HEAP32[i4 >> 2] = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0) | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i4 | 0, 1, 0) | 0;
 i1 = HEAP32[i9 + 96 >> 2] | 0;
 L8 : do if (i1 | 0) {
  i7 = HEAP32[i4 >> 2] | 0;
  i2 = i7;
  i2 = i2 + ~(i2 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = (HEAP32[i9 + 88 >> 2] | 0) + (((i2 >>> 16 ^ i2) & i1 + -1) << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i9 + 80 >> 2] | 0;
   i6 = HEAP32[i9 + 84 >> 2] | 0;
   i3 = i1;
   i4 = i2;
   while (1) {
    i1 = i4;
    i4 = i6 + (i3 << 2) | 0;
    i2 = i3;
    i3 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
    if ((i3 | 0) == -1) break L8;
   }
   HEAP32[i1 >> 2] = i3;
   i7 = i9 + 112 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   i7 = i9 + 108 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i9 = i9 + 104 | 0;
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i9 >> 2] = i2;
  }
 } while (0);
 if ((mftCall_ii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0) | 0) == 1) {
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 104 >> 2] | 0, i8 | 0);
  STACKTOP = i10;
  return;
 }
 if (mftCall_ii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0) | 0) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 104 >> 2] | 0, i8 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc19ContactReportBuffer23reallocateNotThreadSafeEjRjjj(i9, i13, i11, i1, i6) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 1 | 0;
 i8 = i14;
 i12 = i9 + 16 | 0;
 if ((HEAP32[i12 >> 2] | 0) == (i6 | 0)) {
  i5 = i9 + 4 | 0;
  HEAP32[i5 >> 2] = i6;
  i4 = i1 + -1 + i6 & 0 - i1;
  HEAP32[i11 >> 2] = i4;
  i2 = i9 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i4 + i13 | 0) >>> 0 > i3 >>> 0) if (!(HEAP8[i9 + 20 >> 0] | 0)) {
   i1 = i3;
   do {
    i1 = i1 << 1;
    HEAP32[i2 >> 2] = i1;
   } while (((HEAP32[i11 >> 2] | 0) + i13 | 0) >>> 0 > i1 >>> 0);
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i1, gb + 705933 | 0, 150) | 0;
   _memcpy(i2 | 0, HEAP32[i9 >> 2] | 0, i3 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, HEAP32[i9 >> 2] | 0);
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   i10 = 14;
  } else i1 = 0; else {
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i4;
   i10 = 14;
  }
  if ((i10 | 0) == 14) {
   HEAP32[i12 >> 2] = i1;
   HEAP32[i5 >> 2] = i13 - i6 + i4 + (HEAP32[i5 >> 2] | 0);
   i1 = i2 + i1 | 0;
  }
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 } else {
  i5 = i9 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i4 = i1 + -1 + i6 & 0 - i1;
  HEAP32[i11 >> 2] = i4;
  i2 = i9 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i4 + i13 | 0) >>> 0 > i3 >>> 0) if (!(HEAP8[i9 + 20 >> 0] | 0)) {
   i1 = i3;
   do {
    i1 = i1 << 1;
    HEAP32[i2 >> 2] = i1;
   } while (((HEAP32[i11 >> 2] | 0) + i13 | 0) >>> 0 > i1 >>> 0);
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i1, gb + 705933 | 0, 150) | 0;
   _memcpy(i2 | 0, HEAP32[i9 >> 2] | 0, i3 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, HEAP32[i9 >> 2] | 0);
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   i10 = 7;
  } else i1 = 0; else {
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = i4;
   i10 = 7;
  }
  if ((i10 | 0) == 7) {
   HEAP32[i12 >> 2] = i1;
   HEAP32[i5 >> 2] = i13 - i6 + i4 + (HEAP32[i5 >> 2] | 0);
   i1 = i2 + i1 | 0;
  }
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 return 0;
}

function __ZN19CharacterController9GetBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 if (!(HEAP32[i2 + 36 >> 2] | 0)) {
  __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i4 = i1 + 12 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i5;
  return;
 } else {
  i10 = i2 + 28 | 0;
  __ZNK9Transform14TransformPointERK8Vector3f(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 96 | 0);
  __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0);
  f7 = Math_fround(HEAPF32[i2 + 88 >> 2]);
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
  i10 = f7 < Math_fround(0.0);
  f6 = Math_fround(-f7);
  f7 = i10 ? f6 : f7;
  i10 = f7 < Math_fround(9.99999974e-06);
  f7 = i10 ? Math_fround(9.99999974e-06) : f7;
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  i10 = f6 < Math_fround(0.0);
  f8 = Math_fround(-f6);
  f6 = i10 ? f8 : f6;
  f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i3 = f8 < Math_fround(0.0);
  f9 = Math_fround(-f8);
  f8 = i3 ? f9 : f8;
  f6 = Math_fround(Math_fround(HEAPF32[i2 + 92 >> 2]) * (f6 < f8 ? f8 : f6));
  f7 = Math_fround(f7 - Math_fround(f6 * Math_fround(2.0)));
  i3 = f7 < Math_fround(9.99999974e-06);
  f7 = i3 ? Math_fround(9.99999974e-06) : f7;
  i3 = f6 < Math_fround(9.99999974e-06);
  f6 = i3 ? Math_fround(9.99999974e-06) : f6;
  f7 = Math_fround(f6 + Math_fround(f7 * Math_fround(.5)));
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAPF32[i1 + 12 >> 2] = f6;
  HEAPF32[i1 + 16 >> 2] = f7;
  HEAPF32[i1 + 20 >> 2] = f6;
  STACKTOP = i5;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i10 + 12 | 0;
 i9 = i2 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i4;
  i1 = i5;
 }
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 12 | 0, 4) | 0;
  i2 = i4 + (i1 * 12 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i9 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7GetFreeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i1 | 0) == (i3 + 16 | 0)) i2 = 5; else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i4 = i3 + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   }
  }
  do if ((i2 | 0) == 5) {
   i1 = i3 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
    i4 = __Znwj(344) | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP8[i4 + 16 >> 0] = 1;
    HEAP32[i4 + 20 >> 2] = 0;
    i6 = i4 + 24 | 0;
    HEAP32[i6 >> 2] = i4;
    HEAP32[i4 + 28 >> 2] = i6;
    HEAP32[i4 + 32 >> 2] = i6;
    i6 = i4 + 36 | 0;
    i5 = i4 + 52 | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
    HEAP32[i6 + 16 >> 2] = 0;
    HEAP32[i4 + 56 >> 2] = i5;
    HEAP32[i4 + 60 >> 2] = i5;
    HEAP32[i4 + 320 >> 2] = 0;
    i5 = i4 + 328 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 + 12 >> 2] = 0;
    HEAP32[i4 + 8 >> 2] = i2;
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    i1 = i4;
    break;
   } else {
    i6 = 0;
    return i6 | 0;
   }
  } while (0);
  i5 = i3 + 12 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = i1 + 24 | 0;
  i4 = i1 + 32 | 0;
  i2 = i1 + 28 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i2 >> 2] = i5;
  i6 = i3 + 32 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = i3 + 28;
  HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] = i5;
  HEAP32[i6 >> 2] = i5;
 } else {
  i1 = HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = i4 << 16 & 268369920 | i5 << 28 | i6 & 65535;
 i6 = i1;
 return i6 | 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i12, i1, i9) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i8 = i9 + 11 | 0;
 i11 = HEAP8[i8 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i11 & 255;
 i5 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = i11 + i7 | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  i10 = 5;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i7;
  i1 = i12;
 } else {
  i1 = i3;
  i10 = 5;
 }
 if ((i10 | 0) == 5) {
  i10 = i2 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i10 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 i5 = i12 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i11 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i11 - i3 + i1 | 0, i1, i1, 0, i11, i4);
  STACKTOP = i13;
  return;
 }
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 if (i2) i2 = HEAP32[i12 >> 2] | 0; else i2 = i12;
 _memcpy(i2 + i1 | 0, i4 | 0, i11 | 0) | 0;
 i1 = i1 + i11 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i12, i1, i9) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i8 = i9 + 11 | 0;
 i11 = HEAP8[i8 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i11 & 255;
 i5 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = i11 + i7 | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  i10 = 5;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i7;
  i1 = i12;
 } else {
  i1 = i3;
  i10 = 5;
 }
 if ((i10 | 0) == 5) {
  i10 = i2 + 16 & -16;
  HEAP32[i6 >> 2] = 54;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i10 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 i5 = i12 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i11 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i11 - i3 + i1 | 0, i1, i1, 0, i11, i4);
  STACKTOP = i13;
  return;
 }
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 if (i2) i2 = HEAP32[i12 >> 2] | 0; else i2 = i12;
 _memcpy(i2 + i1 | 0, i4 | 0, i11 | 0) | 0;
 i1 = i1 + i11 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN8VRDevice17CreateEyeTexturesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i8 = i9;
 i6 = (__ZNK14PlayerSettings13GetColorSpaceEv(__Z17GetPlayerSettingsv() | 0) | 0) == 1;
 i5 = __Z19GetGraphicsSettingsv() | 0;
 i5 = HEAP32[i5 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) >> 2] | 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0;
 i2 = (i5 | 1 | 0) == 3 | (i2 | 0) < 1 ? 1 : i2;
 switch (HEAP32[(__Z17GetPlayerSettingsv() | 0) + 328 >> 2] | 0) {
 case 2:
  {
   i3 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 504 >> 0] | 0) != 0;
   i3 = i3 ? 2 : 0;
   break;
  }
 case 1:
  {
   i3 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 520 >> 2] | 0;
   break;
  }
 default:
  i3 = 0;
 }
 if ((HEAP32[i4 + 132 >> 2] | 0) <= 0) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i4 + 288 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(108, gb + 63816 | 0, 16, gb + 1044184 | 0, 1426) | 0;
  __ZN19VREyeTextureManagerC2Ev(i1);
  HEAP32[i5 >> 2] = i1;
 }
 __ZN19VREyeTextureManager21SetUnityTextureFormatE28UnityVREyeTextureLayoutFlagsbi(i1, (i3 | 0) == 2 ? 4 : (i3 | 0) == 1 ? 2 : 1, i6, i2);
 __ZN19VREyeTextureManager22SetDeviceTextureFormatERK30UnityVREyeTextureConfiguration(HEAP32[i5 >> 2] | 0, i4 + 116 | 0);
 i2 = __ZN19VREyeTextureManager17CreateEyeTexturesEf(HEAP32[i5 >> 2] | 0, Math_fround(HEAPF32[i4 + 308 >> 2])) | 0;
 if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i7);
  i1 = gb + 1469192 | 0;
 } else i1 = 0;
 i8 = __Z12GetGfxDevicev() | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 536 >> 2] | 0, i8 | 0) | 0;
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 544 >> 2] | 0, i7 | 0, i8 | 0);
 __Z15gpu_time_samplev();
 if (!i1) {
  i8 = i2;
  STACKTOP = i9;
  return i8 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 i8 = i2;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8Material9GetMatrixEN9ShaderLab16FastPropertyNameE(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i9 = i10;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 L6 : do if ((i1 | 0) < (i5 | 0)) {
  i6 = HEAP32[i2 + 44 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if ((HEAP32[i6 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) break L6;
  }
  if ((i1 | 0) > -1) {
   i9 = (HEAP32[i2 + 84 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 64 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 } while (0);
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i9 = gb + 1162292 | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) if (!(HEAP32[i1 + 4 >> 2] | 0)) {
   i9 = HEAP32[i4 >> 2] | 0;
   __Z31ReadObjectFromPersistentManageri(i9) | 0;
   STACKTOP = i10;
   return gb + 1162292 | 0;
  } else {
   i9 = gb + 1162292 | 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i9 = HEAP32[i4 >> 2] | 0;
 __Z31ReadObjectFromPersistentManageri(i9) | 0;
 STACKTOP = i10;
 return gb + 1162292 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i10 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i8 = i7 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i14 = i1;
 i6 = HEAP32[i14 + 4 >> 2] | 0;
 i5 = i9;
 HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 i5 = i7 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i14 = i1;
 i4 = HEAP32[i14 + 4 >> 2] | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i11 + 4 >> 2] = i4;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 0;
 i11 = i7 + 56 | 0;
 HEAP32[i11 >> 2] = 0;
 i4 = i7 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i14 = i1;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i4;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 843788 | 0, i7, 0);
 __ZN14HeightMeshData8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i7 + 40 | 0;
 if ((HEAP32[i11 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE9push_backEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i2 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + 12 | 0;
 i10 = i8 + 24 | 0;
 if (i2 >>> 0 < HEAP32[i10 >> 2] << 14 >>> 0) {
  i10 = i2;
  i9 = i10 + 1 | 0;
  HEAP32[i8 >> 2] = i9;
  i9 = i10 >>> 14;
  i8 = i8 + 12 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i8 + (i9 << 2) | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i10 & 16383;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i9 + (i10 * 24 | 0) | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = i8 + 4 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(20, i6, 16, gb + 461790 | 0, 94) | 0;
 HEAP32[i2 + 12 >> 2] = 16384;
 HEAP32[i2 + 16 >> 2] = 16384;
 i3 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i6);
 i6 = i1;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(393216, 8, i3, 0, gb + 1047584 | 0, 446) | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 28 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i8 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i9 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i4;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = i2;
 i10 = HEAP32[i8 >> 2] | 0;
 i9 = i10 + 1 | 0;
 HEAP32[i8 >> 2] = i9;
 i9 = i10 >>> 14;
 i8 = i8 + 12 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + (i9 << 2) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 & 16383;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i9 + (i10 * 24 | 0) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z49Application_CUSTOM_CanStreamedLevelBeLoadedByNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 52 | 0;
 i2 = i7 + 48 | 0;
 i4 = i7 + 32 | 0;
 i5 = i7 + 16 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 __ZNK11ICallStringcv8UnityStrEv(i4, i2);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = __Z16GetBuildSettingsv() | 0;
 i1 = i4 + 11 | 0;
 i8 = HEAP8[i1 >> 0] | 0;
 i10 = i8 << 24 >> 24 < 0;
 i9 = i10 ? HEAP32[i4 >> 2] | 0 : i4;
 i8 = i10 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i9, i8);
 if ((__ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i3) | 0) == -1) i2 = (__Z35GetHasLateBoundSceneFromAssetBundleRK8UnityStrRS_S2_(i4, i5, i6) | 0) & 1; else i2 = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i3);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i3);
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return i2 | 0;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i3);
 STACKTOP = i7;
 return i2 | 0;
}

function __ZN5physx2Sc5Scene29scheduleParticleCollisionPrepERNS_10PxBaseTaskES3_(i11, i2, i10) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i6 = i11 + 1604 | 0;
 i8 = i11 + 1692 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i3 = i11 + 1616 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i3) | 0;
 i4 = i11 + 1612 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 >> 2] = i2;
 i9 = i11 + 1652 | 0;
 i7 = i11 + 1648 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i11 + 1644 >> 2] | 0) + (i1 << 2) >> 2] = i2;
  HEAP32[i7 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11 + 1624 | 0, i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 i2 = i11 + 1688 | 0;
 HEAP8[i2 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i3) | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i5 >> 2] = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i11 + 1644 >> 2] | 0) + (i1 << 2) >> 2] = i10;
  HEAP32[i7 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11 + 1624 | 0, i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 HEAP8[i2 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 __ZN5physx2Cm10FanoutTask15removeReferenceEv(i6);
 if (!(HEAP32[i11 + 148 >> 2] | 0)) {
  i11 = i6;
  STACKTOP = i12;
  return i11 | 0;
 } else {
  i11 = __ZN5physx2Sc17ParticleSystemSim21scheduleCollisionPrepERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i11 + 1204 >> 2] | 0, i11 + 144 | 0, i6) | 0;
  __ZN5physx2Cm10FanoutTask15removeReferenceEv(i6);
  STACKTOP = i12;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj156ES3_RKNS_19PxClothTetherConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 248; else i1 = (HEAP32[i1 >> 2] | 0) + 248 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj156ES2_RKNS_19PxClothTetherConfigES6_EEKNS_32PxClothTetherConfigGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 56 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN13GfxDeviceGLES4InitE16GfxDeviceLevelGL(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 i4 = i9 + 40 | 0;
 i5 = i9 + 28 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[gb + 39076 >> 2] = i2;
 i1 = (i2 | 0) == 1;
 __ZN11ContextGLES6CreateEi(i1 ? 2 : 3) | 0;
 i6 = i3 + 6616 | 0;
 HEAP32[gb + 1451096 >> 2] = i6;
 do if (i1) {
  i1 = i3 + 4388 | 0;
  HEAP32[i1 >> 2] = 8;
 } else {
  if ((i2 + -1 | 0) >>> 0 < 4) {
   i1 = i3 + 4388 | 0;
   HEAP32[i1 >> 2] = 11;
   break;
  }
  i1 = i3 + 4388 | 0;
  if ((i2 + -5 | 0) >>> 0 < 8) HEAP32[i1 >> 2] = 17;
 } while (0);
 i11 = __Znwj(28) | 0;
 __ZN14GfxContextGLESC2Ev(i11);
 HEAP32[i3 + 4616 >> 2] = i11;
 i12 = i3 + 4620 | 0;
 __ZN7ApiGLES4InitERK14GfxContextGLESR16GfxDeviceLevelGL(i12, i11, i4);
 HEAP32[i6 >> 2] = i12;
 HEAP32[gb + 1451080 >> 2] = i12;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 616 >> 2] | 0, i3 | 0, 1);
 __ZN7ApiGLES9InitDebugEv(i12);
 i11 = HEAP32[i3 + 5484 >> 2] | 0;
 __Z6FormatPKcz(i5, gb + 603235 | 0, i7);
 __ZNK9DebugGLES3LogEPKc(i11, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i11 = ((HEAP32[i4 >> 2] | 0) + -1 | 0) >>> 0 < 4 ? gb + 603298 | 0 : gb + 1086395 | 0;
 i10 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 728 >> 2] | 0;
 i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 732 >> 2] | 0;
 i5 = __Z23GetGfxDeviceLevelString16GfxDeviceLevelGL(HEAP32[i4 >> 2] | 0) | 0;
 i7 = __ZNK7ApiGLES10GetContextEv(i12) | 0;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i8 + 8 >> 2] = i2;
 HEAP32[i8 + 12 >> 2] = i5;
 HEAP32[i8 + 16 >> 2] = i7;
 _printf_console(gb + 603303 | 0, i8);
 __ZN13GfxDeviceGLES15InitCommonStateER15DeviceStateGLES(i3, i6);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 HEAP8[i3 + 4194 >> 0] = 1;
 HEAPF32[i3 + 4372 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4368 >> 2] = Math_fround(0.0);
 _memset(i3 + 7424 | 0, 0, 1028) | 0;
 __Z24PluginsSetGraphicsDevicePvi18GfxDeviceEventType(0, HEAP32[i1 >> 2] | 0, 0);
 STACKTOP = i9;
 return 1;
}

function _cf2_glyphpath_curveTo(i11, i1, i2, i9, i10, i14, i15) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i16 + 20 | 0;
 i17 = i16 + 16 | 0;
 i3 = i16 + 12 | 0;
 i4 = i16 + 8 | 0;
 i8 = i16;
 i12 = i11 + 11720 | 0;
 i13 = i11 + 11724 | 0;
 _cf2_glyphpath_computeOffset(i11, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] | 0, i1, i2, i7, i17);
 _cf2_glyphpath_computeOffset(i11, i9, i10, i14, i15, i3, i4);
 i6 = (Math_imul(i10 - i2 >> 16, i1 >> 16) | 0) - (Math_imul(i9 - i1 >> 16, i2 >> 16) | 0) | 0;
 i5 = (HEAP32[i11 + 4 >> 2] | 0) + 16 | 0;
 HEAP32[i5 >> 2] = i6 + (HEAP32[i5 >> 2] | 0);
 i7 = HEAP32[i7 >> 2] | 0;
 i5 = i7 + (HEAP32[i12 >> 2] | 0) | 0;
 HEAP32[i8 >> 2] = i5;
 i17 = HEAP32[i17 >> 2] | 0;
 i6 = i17 + (HEAP32[i13 >> 2] | 0) | 0;
 HEAP32[i8 + 4 >> 2] = i6;
 i7 = i7 + i1 | 0;
 i2 = i17 + i2 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = i11 + 11667 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  _cf2_glyphpath_pushMove(i11, i5, i6);
  HEAP8[i1 >> 0] = 0;
  HEAP8[i11 + 11664 >> 0] = 1;
  i17 = i11 + 11712 | 0;
  HEAP32[i17 >> 2] = i7;
  HEAP32[i17 + 4 >> 2] = i2;
 }
 i1 = i11 + 11744 | 0;
 if (HEAP8[i1 >> 0] | 0) _cf2_glyphpath_pushPrevElem(i11, i11 + 8 | 0, i8, i7, i2, 0);
 HEAP8[i1 >> 0] = 1;
 HEAP32[i11 + 11748 >> 2] = 4;
 i17 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i11 + 11752 | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i17;
 i1 = i11 + 11760 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i11 + 11768 >> 2] = i3 + i9;
 HEAP32[i11 + 11772 >> 2] = i4 + i10;
 HEAP32[i11 + 11776 >> 2] = i3 + i14;
 HEAP32[i11 + 11780 >> 2] = i4 + i15;
 i1 = i11 + 11676 | 0;
 if (!((_cf2_hintmask_isNew(HEAP32[i1 >> 2] | 0) | 0) << 24 >> 24)) {
  HEAP32[i12 >> 2] = i14;
  HEAP32[i13 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 _cf2_hintmap_build(i11 + 8 | 0, HEAP32[i11 + 11668 >> 2] | 0, HEAP32[i11 + 11672 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i11 + 11680 >> 2] | 0, 0);
 HEAP32[i12 >> 2] = i14;
 HEAP32[i13 >> 2] = i15;
 STACKTOP = i16;
 return;
}

function __ZNSt3__210to_wstringEm(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 23, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAP32[i6 >> 2] = i4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215348 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210to_wstringEl(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 23, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAP32[i6 >> 2] = i4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215332 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210to_wstringEj(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 23, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAP32[i6 >> 2] = i4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215320 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210to_wstringEi(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 23, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAP32[i6 >> 2] = i4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215308 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10WriteInt64Ex(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 if ((i2 | 0) < 0) {
  i1 = _i64Subtract(0, 0, i1 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  HEAP8[i6 >> 0] = 45;
  i3 = i6 + 1 | 0;
 } else i3 = i6;
 i11 = __ZN9rapidjson8internal6u64toaEyPc(i1, i2, i3) | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + (i11 - i6) | 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i10;
  break;
 } while (0);
 if ((i6 | 0) == (i11 | 0)) {
  STACKTOP = i13;
  return 1;
 } else i1 = i6;
 do {
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  i5 = i3 + 12 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i8 = i3 + 16 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i2 = i9 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i3 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i7;
  HEAP8[(HEAP32[i3 >> 2] | 0) + i6 >> 0] = i4;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i13;
 return 1;
}

function __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_(i9, i10, i6) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 16 | 0;
 i14 = i15 + 32 | 0;
 i11 = i15;
 i12 = i15 + 8 | 0;
 i13 = i15 + 24 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 157 >> 0] | 0) {
  STACKTOP = i15;
  return;
 }
 i1 = i9 + 124 | 0;
 if ((HEAP8[(HEAP32[i1 >> 2] | 0) + 29 >> 0] | 0) == 1) {
  i7 = i8;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i9, i8, 1);
  HEAP8[(HEAP32[i1 >> 2] | 0) + 29 >> 0] = 0;
 }
 i7 = i9 + 336 | 0;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i11, HEAP32[i7 >> 2] | 0, 0);
 i4 = HEAP32[i9 + 128 >> 2] | 0;
 i5 = i6 + 36 | 0;
 L10 : do if (!i4) i1 = 0; else {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i9 + 92 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
   do if (!i3) {
    i2 = HEAP32[i2 >> 2] | 0;
    if (!i2) if (!(HEAP32[i6 >> 2] | HEAP32[i5 >> 2])) break L10; else break; else if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) break L10; else break;
   } else if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) break L10; while (0);
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i1 = i4;
    break;
   }
  }
 } while (0);
 i6 = HEAP32[i7 >> 2] | 0;
 i5 = i11;
 i11 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i11;
 __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i13, i9, i10);
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_iiNS0_15FramebufferMaskE(i6, i14, i1 + 3 | 0, i8, i7, i11, 0);
 __ZN18GfxFramebufferGLES21InvalidateAttachmentsEv(i9);
 STACKTOP = i15;
 return;
}

function __ZN16PhysicsUtility2D21XRotUpdateFromRBAngleERK11Quaternionff(i6, i2, f7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i8 = f5 < Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 if (i8) {
  f4 = Math_fround(-f4);
  f5 = Math_fround(-f5);
  f3 = Math_fround(-f3);
  f1 = Math_fround(-f1);
 }
 f7 = Math_fround(f7 * Math_fround(.5));
 f10 = Math_fround(+Math_sin(+f7));
 f7 = Math_fround(+Math_cos(+f7));
 i8 = f5 < Math_fround(0.0);
 f13 = Math_fround(-f1);
 f9 = Math_fround(-f5);
 f9 = i8 ? f9 : f5;
 f13 = i8 ? f13 : f1;
 i8 = f9 < Math_fround(0.0);
 f11 = Math_fround(-f13);
 f14 = Math_fround(-f9);
 f9 = Math_fround(Math_fround(Math_fround(+Math_atan2(+(i8 ? f11 : f13), +(i8 ? f14 : f9))) * Math_fround(2.0)) * Math_fround(.5));
 f14 = Math_fround(+Math_sin(+f9));
 f9 = Math_fround(+Math_cos(+f9));
 f13 = Math_fround(-f14);
 f11 = Math_fround(Math_fround(f9 * Math_fround(0.0)) - Math_fround(f7 * Math_fround(0.0)));
 f14 = Math_fround(f14 * Math_fround(-0.0));
 f15 = Math_fround(f10 * Math_fround(-0.0));
 f12 = Math_fround(Math_fround(f14 + f11) - f15);
 f14 = Math_fround(Math_fround(f15 + f11) - f14);
 f11 = Math_fround(Math_fround(Math_fround(f7 * f13) + Math_fround(f10 * f9)) + Math_fround(0.0));
 f13 = Math_fround(Math_fround(Math_fround(f7 * f9) + Math_fround(0.0)) - Math_fround(f10 * f13));
 f10 = Math_fround(Math_fround(Math_fround(f4 * f11) + Math_fround(Math_fround(f3 * f13) + Math_fround(f5 * f14))) - Math_fround(f1 * f12));
 f9 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f13) + Math_fround(f5 * f11)) + Math_fround(f3 * f12)) - Math_fround(f4 * f14));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f13) - Math_fround(f4 * f12)) - Math_fround(f3 * f14)) - Math_fround(f1 * f11));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(f1 * f14) + Math_fround(Math_fround(f4 * f13) + Math_fround(f5 * f12))) - Math_fround(f3 * f11));
 HEAPF32[i6 + 4 >> 2] = f10;
 HEAPF32[i6 + 8 >> 2] = f9;
 HEAPF32[i6 + 12 >> 2] = f7;
 return;
}

function __ZN13AvatarBuilder14NamedTransformaSERKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i8 | 0) == (i9 | 0)) {
  i7 = i9 + 32 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 32 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 }
 i5 = HEAP8[i9 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i6 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
 i5 = i3 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
 i3 = i8 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i5 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
 } else {
  if (i2) i1 = HEAP32[i8 >> 2] | 0; else i1 = i8;
  if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i8 + 16 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = i4 ? HEAP32[i9 + 20 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 20 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  i7 = i9 + 32 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 32 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i8 + 20 >> 2] = i7;
  i7 = i9 + 32 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 32 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 } else {
  HEAP8[i4 >> 0] = i7;
  i7 = i9 + 32 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i9 = i8 + 32 | 0;
  HEAP32[i9 >> 2] = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_(i12, i1, i9) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = i12 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i8 = i9 + 11 | 0;
 i11 = HEAP8[i8 >> 0] | 0;
 i11 = i11 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i11 & 255;
 i5 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = i11 + i7 | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i4 >> 2] | 0;
  i10 = 5;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i12 + 11 >> 0] = i7;
  i1 = i12;
 } else {
  i1 = i3;
  i10 = 5;
 }
 if ((i10 | 0) == 5) {
  i10 = i2 + 16 & -16;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i10 | -2147483648;
  HEAP32[i12 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 i5 = i12 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i12 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i11 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i12, i3, i11 - i3 + i1 | 0, i1, i1, 0, i11, i4);
  STACKTOP = i13;
  return;
 }
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 if (i2) i2 = HEAP32[i12 >> 2] | 0; else i2 = i12;
 _memcpy(i2 + i1 | 0, i4 | 0, i11 | 0) | 0;
 i1 = i1 + i11 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i12 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZNK6Camera27GetUsesScreenForCompositingEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 if (i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = i6 + 744 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else if (HEAP32[i1 + 4 >> 2] | 0) {
    i8 = 0;
    STACKTOP = i7;
    return i8 | 0;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i1 = HEAP32[i6 + 748 >> 2] | 0;
 if (i1 | 0) if (!(HEAP8[i1 + 31 >> 0] | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = __Z18GetQualitySettingsv() | 0;
 if ((HEAP32[(HEAP32[i8 + 28 >> 2] | 0) + ((HEAP32[i8 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) <= 1) {
  i8 = i6 + 844 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + -1 | 0;
  i8 = i8 >>> 0 > 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  i8 = i6 + 844 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + -1 | 0;
  i8 = i8 >>> 0 > 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 158 >> 0] | 0)) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 } else {
  i8 = i6 + 844 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + -1 | 0;
  i8 = i8 >>> 0 > 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType(i10, i12, i13, i1) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0;
 i14 = i10 + 24 | 0;
 HEAP16[i14 >> 1] = 0;
 HEAP32[i10 + 12 >> 2] = 1;
 HEAP32[i10 + 16 >> 2] = i1;
 i11 = i10 + 28 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAPF64[i10 + 32 >> 3] = 0.0;
 HEAP32[i10 + 20 >> 2] = 0;
 i2 = i10 + 52 | 0;
 HEAP16[i2 >> 1] = HEAP16[i2 >> 1] & -4;
 HEAP32[i10 + 48 >> 2] = 0;
 __Z18GetDirectorManagerv() | 0;
 i2 = __ZN15DirectorManager14ConnectionPool8AllocateEi(gb + 1188456 | 0, 0) | 0;
 HEAP32[i10 + 8 >> 2] = i2;
 i3 = i2 + 36 | 0;
 i4 = i2 + 48 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 52 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 3, 4, i2 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + (i5 << 3) + 4 >> 2] = 0;
 HEAPF32[i1 + (i5 << 3) >> 2] = Math_fround(0.0);
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = i13;
 if (i13 | 0) {
  HEAP32[i11 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i13) | 0;
  i13 = __Z18GetDirectorManagerv() | 0;
  HEAP16[i14 >> 1] = __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass(i13, __Z26scripting_object_get_classP12Il2CppObject(HEAP32[i1 >> 2] | 0) | 0) | 0;
  return;
 }
 if (!i12) return;
 i13 = __Z20scripting_object_newP11Il2CppClass(i12) | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i11 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i13) | 0;
 HEAP16[i14 >> 1] = __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass(__Z18GetDirectorManagerv() | 0, i12) | 0;
 return;
}

function __ZN8Material14SetOverrideTagEii(i1, i13, i11) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 12 | 0;
 i9 = i14 + 8 | 0;
 i10 = i14;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if ((i11 | 0) >= 0) {
  i7 = i1 + 176 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i1 + 180 >> 2] | 0;
  i1 = i6 - i2 >> 3;
  if (!i1) i1 = i2; else {
   i5 = i1;
   i1 = i2;
   while (1) {
    i15 = (i5 | 0) / 2 | 0;
    i4 = i2 + (i15 << 3) | 0;
    i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
    i4 = i4 + 8 | 0;
    i1 = i3 ? i4 : i1;
    i5 = i3 ? i5 + -1 - i15 | 0 : i15;
    if (!i5) break; else i2 = i3 ? i4 : i2;
   }
  }
  i2 = i1;
  if ((i1 | 0) == (i6 | 0)) i12 = 15; else if ((HEAP32[i1 >> 2] | 0) > (i13 | 0)) i12 = 15;
  if ((i12 | 0) == 15) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i13;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   i1 = __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i7, i8, i10) | 0;
  }
  HEAP32[i1 + 4 >> 2] = i11;
  STACKTOP = i14;
  return;
 }
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 i6 = i1 + 180 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i15 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i15 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i13 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i15 | 0 : i15;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i14;
  return;
 }
 if ((i1 | 0) == (i7 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) > (i13 | 0)) {
  STACKTOP = i14;
  return;
 }
 i4 = i1 + 8 | 0;
 if ((i4 | 0) != (i7 | 0)) {
  i2 = i4;
  i3 = i1;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i2 = i2 + 8 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + 8 | 0;
  }
  i1 = i1 + (((i7 + -8 - i4 | 0) >>> 3) + 1 << 3) | 0;
 }
 if ((i7 | 0) == (i1 | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i6 >> 2] = i7 + (~((i7 + -8 - i1 | 0) >>> 3) << 3);
 STACKTOP = i14;
 return;
}

function __ZN8Animator20SetupBindingsDataSetEPKN7mecanim9animation18ControllerConstantEPN11UnityEngine9Animation20AnimationSetBindingsERNS_15BindingsDataSetERNS_13AvatarDataSetE(i8, i4, i5, i9, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 if ((HEAP16[gb + 1466784 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466784 | 0, i1);
  i7 = gb + 1466784 | 0;
 } else i7 = 0;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = __ZN8Animator13GetAvatarRootEv(i8) | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP8[i8 + 560 >> 0] | 0;
 if (!(HEAP8[i8 + 561 >> 0] | 0)) i1 = __ZN11UnityEngine9Animation32CreateAnimatorGenericBindingsOptERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEPKNS0_21AvatarBindingConstantEbRNS6_6memory9AllocatorER8Animator(i5, i1, i2, i4, HEAP32[i10 + 20 >> 2] | 0, i3 << 24 >> 24 != 0, i9 + 8 | 0, i8) | 0; else i1 = __ZN11UnityEngine9Animation29CreateAnimatorGenericBindingsERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEbRNS6_6memory9AllocatorER8Animator(i5, i1, i2, i4, i3 << 24 >> 24 != 0, i9 + 8 | 0, i8) | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = HEAP32[HEAP32[i1 + 32 >> 2] >> 2] | 0;
 if (!(HEAP8[i8 + 417 >> 0] | 0)) {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!(HEAP32[i1 + 20 >> 2] | 0)) if ((HEAP32[i1 + 40 >> 2] | 0) == -1) i1 = (HEAP8[(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0) + 36 >> 0] | 0) != 0; else i1 = 1; else i1 = 1;
 } else i1 = 1;
 i10 = i10 + 8 | 0;
 __ZN7mecanim9animation30AllocateAvatarOuputForBindingsEPNS0_12AvatarOutputEbPKNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i10 >> 2] | 0, i1, i2, i9 + 8 | 0);
 __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_(HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0) + 4 >> 2] | 0, HEAP32[HEAP32[i10 >> 2] >> 2] | 0);
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj278ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj278ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 56 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN4FMOD8ChannelI8setDelayE14FMOD_DELAYTYPEjj(i6, i2, i1, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 d10 = +__Z19GetTimeSinceStartupv() * 44100.0;
 i7 = ~~d10 >>> 0;
 i8 = +Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i4 = _i64Subtract(i3 | 0, 0, i7 | 0, i8 | 0) | 0;
 f5 = Math_fround(Math_fround(+(i4 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) / Math_fround(44100.0));
 f5 = 0 < i8 >>> 0 | 0 == (i8 | 0) & i3 >>> 0 < i7 >>> 0 ? Math_fround(0.0) : f5;
 switch (i2 | 0) {
 case 1:
  {
   i1 = i6 + 104 | 0;
   i4 = i1;
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   if (!(i2 >>> 0 < 0 | ((i2 | 0) == 0 ? (HEAP32[i4 >> 2] | 0) >>> 0 < i3 >>> 0 : 0))) {
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   }
   i4 = i1;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = 0;
   i3 = i6 + 64 | 0;
   i4 = i6 + 164 | 0;
   _JS_Sound_Play(HEAP32[(HEAP32[i3 >> 2] | 0) + 320 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0.0, +(+f5));
   i2 = i6 + 112 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (i2 >>> 0 > i8 >>> 0 | (i2 | 0) == (i8 | 0) & i1 >>> 0 > i7 >>> 0) {
    i6 = HEAP32[i4 >> 2] | 0;
    i8 = _i64Subtract(i1 | 0, i2 | 0, i7 | 0, i8 | 0) | 0;
    _JS_Sound_Stop(i6 | 0, +(+Math_fround(Math_fround(+(i8 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) / Math_fround(44100.0))));
   }
   i8 = HEAP32[i3 >> 2] | 0;
   _JS_Sound_SetLoopPoints(HEAP32[i4 >> 2] | 0, +(+HEAPF64[i8 + 328 >> 3]), +(+HEAPF64[i8 + 336 >> 3]));
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 2:
  {
   i8 = i6 + 112 | 0;
   HEAP32[i8 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = 0;
   if (!i3) {
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   }
   _JS_Sound_Stop(HEAP32[i6 + 164 >> 2] | 0, +(+f5));
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   HEAP32[i1 >> 2] = 78;
   HEAP32[i1 + 4 >> 2] = gb + 859018;
   _printf(gb + 857490 | 0, i1) | 0;
   i8 = 78;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = _strlen(i1) | 0;
 i8 = i11 + 11 | 0;
 do if (i2 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, 10, i2 + -10 | 0, 0, 0, 0, i2, i1);
  i5 = i11 + 4 | 0;
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  if (i2 | 0) _memmove(i11 | 0, i1 | 0, i2 | 0) | 0;
  HEAP8[i11 + i2 >> 0] = 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i5 = i11 + 4 | 0;
   HEAP32[i5 >> 2] = i2;
   break;
  } else {
   i1 = i2 & 255;
   HEAP8[i8 >> 0] = i1;
   i5 = i11 + 4 | 0;
   break;
  }
 } while (0);
 i2 = i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 HEAP32[i10 >> 2] = i2;
 i6 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i10, 4);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 i3 = i1 << 24 >> 24 < 0;
 i2 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i1 & 255;
 i3 = i2 + i5 | 0;
 if (i5 | 0) {
  i1 = i2;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
 STACKTOP = i12;
 return;
}

function __ZNSt3__210to_wstringEe(i7, d4) {
 i7 = i7 | 0;
 d4 = +d4;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 20, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAPF64[i6 >> 3] = d4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215416 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210to_wstringEd(i7, d4) {
 i7 = i7 | 0;
 d4 = +d4;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, 20, 0);
 i1 = i9 + 8 | 0;
 i5 = i1 + 3 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 __THREW__ = 0;
 invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i5 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  __THREW__ = 0;
  HEAPF64[i6 >> 3] = d4;
  i3 = invoke_iiiii(fb + 215 | 0, i3 | 0, i1 + 1 | 0, gb + 215404 | 0, i6 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = 17;
   break;
  }
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 12;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 17;
   break;
  }
  i2 = HEAP8[i5 >> 0] | 0;
 }
 do if ((i2 | 0) == 12) {
  __THREW__ = 0;
  invoke_viii(fb + 1060 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 17) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i6, i2, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i8 = i10 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i6 >> 2] | 0)) {
   i8 = i2;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i6 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
  }
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i4 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i5;
  break;
 } while (0);
 i7 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) {
  i3 = HEAP32[gb + 37320 >> 2] | 0;
  i4 = i10 + 20 | 0;
  i6 = i10 + 56 | 0;
  i7 = i10 + 44 | 0;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
   i11 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 3) + 4 | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 2097152;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5, gb + 1085989 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i5 + 4 | 0, gb + 1085998 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i5 = i5 + 8 | 0;
  }
 }
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 96 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i6, i7, i3, i4, i5, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 112 | 0;
 i10 = i8 + 96 | 0;
 i1 = i8 + 80 | 0;
 i2 = i8 + 16 | 0;
 i12 = i8;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = i14;
 HEAP32[i11 + 8 >> 2] = i13;
 HEAPF32[i11 + 12 >> 2] = Math_fround(0.0);
 i13 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = i13;
 HEAP32[i10 + 8 >> 2] = i3;
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 i4 = HEAP32[i6 + 80 >> 2] | 0;
 i5 = HEAP32[i6 + 84 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 + 76 >> 2];
 HEAP32[i12 + 4 >> 2] = i4;
 HEAP32[i12 + 8 >> 2] = i5;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 __ZN5physx2Gu28distancePointTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_RS3_(i2, i12, i11, i10, i1, i8 + 64 | 0, i8 + 48 | 0, i8 + 32 | 0);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f9 <= Math_fround(HEAPF32[i6 + 72 >> 2]))) {
  i14 = 1;
  STACKTOP = i8;
  return i14 | 0;
 }
 HEAP8[i6 + 68 >> 0] = 1;
 i6 = HEAP32[i6 + 116 >> 2] | 0;
 if (!i6) {
  i14 = 0;
  STACKTOP = i8;
  return i14 | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  HEAP8[i6 + 20 >> 0] = 1;
  i14 = 1;
  STACKTOP = i8;
  return i14 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 >>> 0 < (HEAP32[i6 + 12 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i5 + 1;
  i14 = 1;
  STACKTOP = i8;
  return i14 | 0;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i1;
  i14 = 1;
  STACKTOP = i8;
  return i14 | 0;
 }
 return 0;
}

function __Z61ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentSize3DP12Il2CppObjectR22ParticleSystemParticleR8Vector3f(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i2 + 84 >> 2];
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 88 >> 2];
 i7 = i5 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 92 >> 2];
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i9 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 do if (HEAP8[(HEAP32[i1 + 852 >> 2] | 0) + 4 >> 0] | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(HEAP32[i1 + 852 >> 2] | 0, i2, 1, i5);
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 do if (HEAP8[(HEAP32[i1 + 892 >> 2] | 0) + 4 >> 0] | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(HEAP32[i1 + 892 >> 2] | 0, i2, 1, i5);
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (HEAP8[(__ZN14ParticleSystem12GetParticlesEi(i1, 0) | 0) + 871 >> 0] | 0) {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  STACKTOP = i8;
  return;
 }
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i8;
 return;
}

function __Z24dtIntersectSegmentPoly2DPKfS0_S0_iRfS1_RiS2_(i1, i2, i13, i15, i16, i17, i18, i19) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f14 = f0, f20 = f0, f21 = f0, i22 = 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f12 - f14);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f10 - f9);
 L1 : do if ((i15 | 0) > 0) {
  f4 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  i2 = -1;
  i1 = i15 + -1 | 0;
  i8 = 0;
  i11 = -1;
  while (1) {
   i22 = i13 + (i8 * 3 << 2) | 0;
   i7 = i13 + (i1 * 3 << 2) | 0;
   f20 = Math_fround(HEAPF32[i22 >> 2]);
   f21 = Math_fround(HEAPF32[i7 >> 2]);
   f20 = Math_fround(f20 - f21);
   f6 = Math_fround(HEAPF32[i22 + 8 >> 2]);
   f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
   f6 = Math_fround(f6 - f5);
   f5 = Math_fround(Math_fround(f6 * Math_fround(f14 - f21)) - Math_fround(f20 * Math_fround(f9 - f5)));
   f6 = Math_fround(Math_fround(f10 * f20) - Math_fround(f12 * f6));
   do if (Math_fround(Math_abs(Math_fround(f6))) < Math_fround(9.99999993e-09)) if (f5 < Math_fround(0.0)) {
    i7 = i8;
    i1 = i11;
    break L1;
   } else i1 = i11; else {
    f5 = Math_fround(f5 / f6);
    if (f6 < Math_fround(0.0)) {
     if (!(f5 > f4)) {
      i1 = i11;
      break;
     }
     if (f5 > f3) {
      i7 = i8;
      f4 = f5;
      i2 = i1;
      i1 = i11;
      break L1;
     } else {
      i2 = i1;
      i1 = i11;
      f4 = f5;
      break;
     }
    } else {
     if (!(f5 < f3)) {
      i1 = i11;
      break;
     }
     if (f5 < f4) {
      i7 = i8;
      f3 = f5;
      break L1;
     } else {
      f3 = f5;
      break;
     }
    }
   } while (0);
   i7 = i8 + 1 | 0;
   if ((i7 | 0) < (i15 | 0)) {
    i22 = i8;
    i8 = i7;
    i11 = i1;
    i1 = i22;
   } else break;
  }
 } else {
  i7 = 0;
  f4 = Math_fround(0.0);
  f3 = Math_fround(1.0);
  i2 = -1;
  i1 = -1;
 } while (0);
 HEAPF32[i16 >> 2] = f4;
 HEAPF32[i17 >> 2] = f3;
 HEAP32[i18 >> 2] = i2;
 HEAP32[i19 >> 2] = i1;
 return (i7 | 0) == (i15 | 0) | 0;
}

function __ZN8Material14CreateMaterialER6Shaderib(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i4 = i8 + 8 | 0;
 i7 = i8;
 i10 = gb + 63520 | 0;
 i6 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 i7 = __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId(4, i5) | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 48 >> 2] | 0, i7 | 0, i3 | 0);
 i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0;
 mftCall_vii(i1 | 0, i7 | 0, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  i9 = 0;
  i10 = i7 + 100 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + 8 | 0;
  HEAP32[i10 >> 2] = i9;
  __ZN8Material15BuildPropertiesEv(i7);
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i9 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i4);
   i2 = HEAP32[i5 >> 2] | 0;
   i10 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i9 = 9;
  }
 }
 if ((i9 | 0) == 7) i9 = 9;
 if ((i9 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 i9 = i1;
 i10 = i7 + 100 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 + 8 | 0;
 HEAP32[i10 >> 2] = i9;
 __ZN8Material15BuildPropertiesEv(i7);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN7mecanim10ValueArray8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 901525 | 0, 0);
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 4;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902750 | 0, 0);
 i6 = i1 + 8 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 901541 | 0, 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 12;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i7;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902767 | 0, 0);
 i7 = i1 + 16 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 901559 | 0, 0);
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 20;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902786 | 0, 0);
 i6 = i1 + 24 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 901572 | 0, 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 28;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i7;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902800 | 0, 0);
 i7 = i1 + 32 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i7, gb + 901585 | 0, 0);
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 36;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902814 | 0, 0);
 i6 = i1 + 40 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 901596 | 0, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 44;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i5;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIbEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 902826 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 * 384 | 0) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 384 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx25PxcPCMContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i12, i3, i5, i1, i2, i17) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i17 = i17 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f18 = f0, f19 = f0;
 f18 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = i3 + 16 | 0;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i5 = i5 + 16 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f7 = Math_fround(f14 - f7);
 f8 = Math_fround(f15 - f8);
 f9 = Math_fround(f16 - f9);
 f10 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f9 * f9));
 f11 = Math_fround(f13 + f6);
 f18 = Math_fround(f18 + f11);
 if (!(Math_fround(f18 * f18) > f10)) {
  i17 = 0;
  return i17 | 0;
 }
 f18 = Math_fround(Math_sqrt(Math_fround(f10)));
 i5 = f18 <= Math_fround(9.99999974e-06);
 f10 = Math_fround(Math_fround(1.0) / f18);
 f19 = Math_fround(f7 * f10);
 f7 = Math_fround(f8 * f10);
 f10 = Math_fround(f9 * f10);
 f8 = i5 ? Math_fround(1.0) : f19;
 f9 = i5 ? Math_fround(0.0) : f7;
 f10 = i5 ? Math_fround(0.0) : f10;
 f13 = Math_fround(Math_fround(Math_fround(f13 + f18) - f6) * Math_fround(-.5));
 f14 = Math_fround(f14 + Math_fround(f8 * f13));
 f15 = Math_fround(f15 + Math_fround(f9 * f13));
 f16 = Math_fround(f16 + Math_fround(f10 * f13));
 f18 = Math_fround(f18 - f11);
 i5 = i17 + 4096 | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i12 + 1;
 i5 = i17 + (i12 << 6) | 0;
 HEAPF32[i5 >> 2] = f8;
 HEAPF32[i5 + 4 >> 2] = f9;
 HEAPF32[i5 + 8 >> 2] = f10;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 i5 = i17 + (i12 << 6) + 16 | 0;
 HEAPF32[i5 >> 2] = f14;
 HEAPF32[i5 + 4 >> 2] = f15;
 HEAPF32[i5 + 8 >> 2] = f16;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + (i12 << 6) + 12 >> 2] = f18;
 HEAP32[i17 + (i12 << 6) + 48 >> 2] = -1;
 HEAP32[i17 + (i12 << 6) + 52 >> 2] = -1;
 i17 = 1;
 return i17 | 0;
}

function __ZN5IMGUI16GetWindowsBoundsER8GUIState(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i11 = 0, f12 = f0, f13 = f0;
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i9) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  HEAP32[i10 + 12 >> 2] = 0;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  f5 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
 } else {
  f6 = Math_fround(3402823469999999843913219.0e14);
  f7 = Math_fround(3402823469999999843913219.0e14);
  f3 = Math_fround(-3402823469999999843913219.0e14);
  f2 = Math_fround(-3402823469999999843913219.0e14);
  while (1) {
   i11 = HEAP32[i1 >> 2] | 0;
   f12 = Math_fround(HEAPF32[i11 + 52 >> 2]);
   f5 = f12 < f6 ? f12 : f6;
   f3 = Math_fround(Math_fround(f3 + f6) - f5);
   f6 = Math_fround(HEAPF32[i11 + 56 >> 2]);
   f4 = f6 < f7 ? f6 : f7;
   f2 = Math_fround(Math_fround(f2 + f7) - f4);
   f3 = Math_fround(f5 + f3);
   f7 = Math_fround(f12 + Math_fround(HEAPF32[i11 + 60 >> 2]));
   f3 = Math_fround((f3 < f7 ? f7 : f3) - f5);
   f2 = Math_fround(f4 + f2);
   f7 = Math_fround(f6 + Math_fround(HEAPF32[i11 + 64 >> 2]));
   f2 = Math_fround((f2 < f7 ? f7 : f2) - f4);
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i8 | 0)) break; else {
    f6 = f5;
    f7 = f4;
   }
  }
 }
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (i1) {
  f13 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f6 = f13 < f5 ? f13 : f5;
  f3 = Math_fround(Math_fround(f3 + f5) - f6);
  f7 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  f12 = f7 < f4 ? f7 : f4;
  f2 = Math_fround(Math_fround(f2 + f4) - f12);
  f3 = Math_fround(f6 + f3);
  f5 = Math_fround(f13 + Math_fround(HEAPF32[i1 + 60 >> 2]));
  f3 = Math_fround((f3 < f5 ? f5 : f3) - f6);
  f2 = Math_fround(f12 + f2);
  f7 = Math_fround(f7 + Math_fround(HEAPF32[i1 + 64 >> 2]));
  f5 = f6;
  f4 = f12;
  f2 = Math_fround((f2 < f7 ? f7 : f2) - f12);
 }
 HEAPF32[i10 >> 2] = f5;
 HEAPF32[i10 + 4 >> 2] = f4;
 HEAPF32[i10 + 8 >> 2] = f3;
 HEAPF32[i10 + 12 >> 2] = f2;
 return;
}

function __ZN11LightProbes8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 32 | 0, i9);
 i3 = i8 + 148 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i4 = i9 + 8 | 0;
 __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i8 + 160 >> 2] | 0;
 i2 = i1 + (i3 * 108 | 0) | 0;
 if (i3 | 0) do {
  __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 168 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i8 + 180 >> 2] | 0;
 i2 = i1 + (i8 << 3) | 0;
 if (i8 | 0) do {
  __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __Z61AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoInternal9HPlayableRS_ihP12Il2CppObject(i1, i2, i3, i4, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i13 = i10;
 i9 = i10 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i13);
 i13 = i8;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 if (__Z22PlayableValidityChecksRK9HPlayable(i2) | 0) __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, i4 << 24 >> 24 != 0, i9) | 0;
 i1 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = i11 + 8 | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i13 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i5 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  while (1) {
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i1, i8);
   i12 = i8;
   i14 = HEAP32[i12 >> 2] | 0;
   i12 = HEAP32[i12 + 4 >> 2] | 0;
   i13 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
   HEAP32[i13 >> 2] = i14;
   HEAP32[i13 + 4 >> 2] = i12;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 8 | 0;
  }
 }
 HEAP32[i11 + 12 >> 2] = HEAP32[i5 >> 2];
 i14 = i11 + 16 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i7);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z35CreateQuaternionFromAxisQuaternionsRK11QuaternionfS1_S1_RS_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f7 * f9);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f6 * f8));
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f16 * f14));
 f15 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(f13 - Math_fround(f15 * f11));
 f12 = Math_fround(Math_fround(Math_fround(f9 * f15) + Math_fround(Math_fround(f8 * f16) + Math_fround(f7 * f11))) - Math_fround(f6 * f14));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f14) + Math_fround(f8 * f15)) + Math_fround(f6 * f11)) - Math_fround(f9 * f16));
 f15 = Math_fround(Math_fround(Math_fround(Math_fround(f7 * f8) - Math_fround(f9 * f6)) - Math_fround(f16 * f11)) - Math_fround(f14 * f15));
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(f14 * f15);
 f16 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f11 = Math_fround(Math_fround(f13 * f16) + f11);
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f6 * f12));
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f8 = Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(Math_fround(f16 * f12) + Math_fround(f15 * f9))) - Math_fround(f13 * f6));
 f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f6) + Math_fround(f16 * f10)) + Math_fround(f13 * f9)) - Math_fround(f14 * f12));
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13)) - Math_fround(f12 * f9)) - Math_fround(f6 * f10));
 HEAPF32[i5 >> 2] = Math_fround(f11 - Math_fround(f10 * f9));
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = f6;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 return;
}

function _UNITY_png_set_filter(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i5) return;
 if (!((i1 | 0) == 0 | ((i1 | 0) == 64 ? (HEAP32[i5 + 596 >> 2] & 4 | 0) != 0 : 0))) _UNITY_png_error(i5, gb + 356120 | 0);
 i1 = i2 & 255;
 switch (i1 << 24 >> 24) {
 case 7:
 case 6:
 case 5:
  {
   _UNITY_png_app_error(i5, gb + 356088 | 0);
   i3 = 5;
   break;
  }
 case 0:
  {
   i3 = 5;
   break;
  }
 case 1:
  {
   HEAP8[i5 + 430 >> 0] = 16;
   i1 = 16;
   break;
  }
 case 2:
  {
   HEAP8[i5 + 430 >> 0] = 32;
   i1 = 32;
   break;
  }
 case 3:
  {
   HEAP8[i5 + 430 >> 0] = 64;
   i1 = 64;
   break;
  }
 case 4:
  {
   HEAP8[i5 + 430 >> 0] = -128;
   i1 = -128;
   break;
  }
 default:
  HEAP8[i5 + 430 >> 0] = i1;
 }
 if ((i3 | 0) == 5) {
  HEAP8[i5 + 430 >> 0] = 8;
  i1 = 8;
 }
 if (!(HEAP32[i5 + 380 >> 2] | 0)) return;
 i4 = i5 + 430 | 0;
 if (i1 & 16) {
  i2 = i5 + 384 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i1 = _UNITY_png_malloc(i5, (HEAP32[i5 + 360 >> 2] | 0) + 1 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP8[i1 >> 0] = 1;
   i1 = HEAP8[i4 >> 0] | 0;
  }
 }
 i2 = i1 & 255;
 do if (i2 & 32) {
  i3 = i5 + 388 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i5 + 376 >> 2] | 0)) {
   i1 = i2 & 223;
   HEAP8[i4 >> 0] = i1;
   break;
  } else {
   i1 = _UNITY_png_malloc(i5, (HEAP32[i5 + 360 >> 2] | 0) + 1 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP8[i1 >> 0] = 2;
   i1 = HEAP8[i4 >> 0] | 0;
   break;
  }
 } while (0);
 i2 = i1 & 255;
 do if (i2 & 64) {
  i3 = i5 + 392 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i5 + 376 >> 2] | 0)) {
   i1 = i2 & 191;
   HEAP8[i4 >> 0] = i1;
   break;
  } else {
   i1 = _UNITY_png_malloc(i5, (HEAP32[i5 + 360 >> 2] | 0) + 1 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP8[i1 >> 0] = 3;
   i1 = HEAP8[i4 >> 0] | 0;
   break;
  }
 } while (0);
 i2 = i1 & 255;
 do if (i2 & 128) {
  i3 = i5 + 396 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i5 + 376 >> 2] | 0)) {
   i1 = i2 & 127;
   HEAP8[i4 >> 0] = i1;
   break;
  } else {
   i1 = _UNITY_png_malloc(i5, (HEAP32[i5 + 360 >> 2] | 0) + 1 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP8[i1 >> 0] = 4;
   i1 = HEAP8[i4 >> 0] | 0;
   break;
  }
 } while (0);
 if (i1 << 24 >> 24) return;
 HEAP8[i4 >> 0] = 8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 32 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 16 >> 2] | 0;
   i3 = i11 + 20 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 * 48 | 0) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 * 48 | 0) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 48 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 16 >> 2] | 0) + (i10 * 48 | 0) | 0;
 return i11 | 0;
}

function __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStream5writeEPKvj(i12, i11, i10) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = HEAP32[i11 + 24 >> 2] | 0;
 if (!(i1 & 4)) {
  if (i1 & 1 | 0) if (!(HEAP32[i11 + 4 >> 2] | 0)) i9 = 4;
 } else i9 = 4;
 if ((i9 | 0) == 4) {
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  i5 = i12 + 16 | 0;
  i6 = i12 + 20 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i2;
  L6 : do if (!i1) {
   i1 = 0;
   i9 = 8;
  } else {
   i3 = HEAP32[i5 >> 2] | 0;
   i4 = 0;
   while (1) {
    if (!(_strcmp(HEAP32[i3 + (i4 << 2) >> 2] | 0, i2) | 0)) {
     i1 = 0;
     break L6;
    }
    i4 = i4 + 1 | 0;
    if (i4 >>> 0 >= i1 >>> 0) {
     i9 = 8;
     break;
    }
   }
  } while (0);
  do if ((i9 | 0) == 8) if ((HEAP32[i12 + 24 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i7;
   HEAP32[i6 >> 2] = i1 + 1;
   i1 = 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPKcNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i8) | 0;
   i1 = 1;
   break;
  } while (0);
  HEAP8[i12 + 28 >> 0] = i1;
 }
 if (!(HEAP8[i12 + 28 >> 0] | 0)) {
  STACKTOP = i13;
  return i10 | 0;
 }
 i1 = i12 + 4 | 0;
 i2 = i12 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i12 + 12 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i12 = (HEAP32[i1 >> 2] | 0) + (i3 << 5) | 0;
  HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i12 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i12 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i12 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
  HEAP32[i12 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  STACKTOP = i13;
  return i10 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayINS_15PxMetaDataEntryENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i11) | 0;
  STACKTOP = i13;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 40 | 0) + 1 | 0;
 if (i4 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 40 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 53687091 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 107374182;
 i5 = (i1 - i2 | 0) / 40 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 40 | 0) | 0;
 i7 = i6 + (i5 * 40 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 40 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i4 = i6 + (i5 * 40 | 0) + 24 | 0;
 i8 = i8 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i7 + 40 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i7 = i3;
   i3 = i3 + -40 | 0;
   HEAP32[i1 + -40 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   i8 = i1 + -16 | 0;
   i7 = i7 + -16 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i1 = i2 + -40 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 7) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 128 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx16PxsFluidDynamics29updateParticlesBruteForceHaloENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i22, i1, i18, i21, i20, i19, i2) {
 i22 = i22 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = i2 + 36 | 0;
 i17 = i2 + 8 | 0;
 i14 = (i1 | 0) == 0;
 i15 = i2 + 28 | 0;
 i11 = i2 + 32 | 0;
 i13 = 0;
 do {
  i12 = i20 + (i13 << 2) | 0;
  if (HEAP32[i12 >> 2] | 0) {
   i10 = HEAP32[i20 + 108 + (i13 << 2) >> 2] | 0;
   i9 = i21 + (i10 << 5) | 0;
   i10 = i18 + (i10 * 12 | 0) | 0;
   i7 = HEAP32[gb + 107804 + (i13 * 80 | 0) >> 2] | 0;
   if (i7 | 0) {
    i8 = 0;
    i1 = 0;
    do {
     i3 = HEAP32[gb + 107804 + (i13 * 80 | 0) + 4 + (i8 << 2) >> 2] | 0;
     i6 = i19 + (i3 << 2) | 0;
     i2 = HEAP32[i6 >> 2] | 0;
     do if (i2) {
      if ((i2 + i1 | 0) >>> 0 > 512) {
       __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i10, i18, i9, i21, HEAP32[i16 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i1, 0, i14, i22, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] | 0);
       if (!(HEAP32[i6 >> 2] | 0)) {
        i1 = 0;
        break;
       } else i1 = 0;
      }
      i5 = HEAP32[i17 >> 2] | 0;
      i3 = HEAP32[i19 + 392 + (i3 << 2) >> 2] | 0;
      i4 = 0;
      i2 = i1;
      while (1) {
       i1 = i2 + 1 | 0;
       HEAP32[i5 + (i2 << 2) >> 2] = i3;
       i4 = i4 + 1 | 0;
       if (i4 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else {
        i3 = i3 + 1 | 0;
        i2 = i1;
       }
      }
     } while (0);
     i8 = i8 + 1 | 0;
    } while ((i8 | 0) != (i7 | 0));
    if (i1 | 0) __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i10, i18, i9, i21, HEAP32[i16 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i17 >> 2] | 0, i1, 0, i14, i22, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] | 0);
   }
  }
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 26);
 return;
}

function __ZN15ReplacementPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceData(i11, i1, i12, i13) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f14 = f0, f15 = f0;
 i3 = i11 + 40 | 0;
 i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0)) i1 = 0; else i1 = HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] ^ 1;
 HEAP8[i11 + 104 >> 0] = i1;
 i10 = HEAP32[i12 + 32804 >> 2] | 0;
 i1 = i11 + 12 | 0;
 i2 = i11 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i10 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i10 * 40 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 * 40 | 0, 8, i11 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i11 + 24 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i1 >> 2] = i9;
  break;
 } while (0);
 if (!i10) return;
 i3 = i11 + 48 | 0;
 i4 = i11 + 64 | 0;
 i5 = i11 + 80 | 0;
 i6 = i11 + 96 | 0;
 i1 = 0;
 do {
  i9 = HEAP32[i12 >> 2] | 0;
  i7 = i9 + (i1 * 360 | 0) | 0;
  f15 = Math_fround(HEAPF32[i9 + (i1 * 360 | 0) + 128 >> 2]);
  f14 = Math_fround(HEAPF32[i9 + (i1 * 360 | 0) + 132 >> 2]);
  f8 = Math_fround(HEAPF32[i9 + (i1 * 360 | 0) + 136 >> 2]);
  f15 = Math_fround(f15 * Math_fround(HEAPF32[i3 >> 2]));
  f14 = Math_fround(f15 + Math_fround(f14 * Math_fround(HEAPF32[i4 >> 2])));
  f8 = Math_fround(f14 + Math_fround(f8 * Math_fround(HEAPF32[i5 >> 2])));
  f8 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f8);
  i9 = HEAP32[i9 + (i1 * 360 | 0) + 244 >> 2] | 0;
  if ((i9 | 0) > 0) {
   i2 = 0;
   do {
    __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i11, i1, i7, i2, f8, i13);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i9 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN13LoadOperation7PerformEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 8 | 0;
 i2 = i11;
 i3 = i11 + 16 | 0;
 if ((HEAP16[gb + 1163152 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163152 | 0, i1);
  i4 = gb + 1163152 | 0;
 } else i4 = 0;
 i8 = i5 + 64 | 0;
 i9 = i5 + 76 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 60 | 0;
 HEAP32[i3 >> 2] = i10;
 HEAPF32[i3 + 4 >> 2] = Math_fround(.899999976);
 HEAPF32[i3 + 8 >> 2] = Math_fround(i7 >>> 0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 i7 = gb + 63416 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i13 = i2;
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 4 >> 2] = i6;
 HEAP32[i3 + 16 >> 2] = 0;
 i13 = i3 + 28 | 0;
 HEAP32[i13 >> 2] = 0;
 i6 = i3 + 32 | 0;
 i7 = i3 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i12 = i1;
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 84 | 0;
 i2 = i3 + 16 | 0;
 HEAP32[i6 >> 2] = 1;
 i12 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 8, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i2 >> 2] = i12;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i12 >> 2] = fb + 2755;
 HEAP32[i12 + 4 >> 2] = i1;
 i12 = __Z20GetPersistentManagerv() | 0;
 __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress(i12, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0, i3);
 __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue(i12, i1);
 i1 = i5 + 80 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i5 + 68 | 0);
  HEAP32[i8 >> 2] = 0;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i10 >> 2] = Math_fround(1.0);
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i7);
  HEAP32[i2 >> 2] = 0;
 }
 if (!i4) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 6) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 64 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i3 = i11;
 i10 = i11 + 16 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i1 = i10 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i7, i10, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i2 = i6 + 32 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  HEAP32[i2 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 }
 i4 = i6 + 36 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, _llvm_bswap_i32(i1 | 0) | 0, i7 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i6 + 48 >> 2] | 0;
 i2 = i1 + (i6 << 5) | 0;
 if (i6 | 0) do {
  __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i1 = i7 * 24 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 739625 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 24 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 24 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 24 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 24 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj268ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 56 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5Unity12PhysicsQuery11RaycastTestERK3Rayfi23QueryTriggerInteraction(i1, i7, f2, i8, i9) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 f2 = Math_fround(f2);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 104 | 0;
 i3 = i10 + 20 | 0;
 i4 = i10 + 124 | 0;
 i5 = i10;
 if ((HEAP16[gb + 1452596 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452596 | 0, i1);
  i6 = gb + 1452596 | 0;
 } else i6 = 0;
 i11 = f2 == Math_fround(inf);
 f2 = i11 ? Math_fround(3402823469999999843913219.0e14) : f2;
 HEAP32[i5 >> 2] = gb + 114012 + 8;
 HEAP32[i5 + 4 >> 2] = 2;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = i8;
 switch (i9 | 0) {
 case 0:
  {
   HEAP8[i5 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i5 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i5 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i9 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 31;
 HEAP8[i1 + 18 >> 0] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP16[i3 + 16 >> 1] = 0;
 i11 = i3 + 20 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAPF32[i3 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i3 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 52 >> 2] = Math_fround(0.0);
 i11 = i3 + 68 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = 0;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 85940 + 8;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 348 >> 2] | 0;
 HEAP16[i4 >> 1] = 0;
 mftCall_iiiifiiiii(i8 | 0, i9 | 0, i7 | 0, i7 + 12 | 0, +f2, i3 | 0, i4 | 0, i1 | 0, i5 | 0, 0) | 0;
 i1 = (HEAP8[i11 >> 0] | 0) != 0;
 if (!i6) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN16b2PrismaticJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 136 | 0;
 i4 = i2 + 128 | 0;
 i5 = i2 + 120 | 0;
 i6 = i2 + 112 | 0;
 i7 = i2 + 104 | 0;
 i8 = i2 + 96 | 0;
 i9 = i2 + 88 | 0;
 i10 = i2 + 80 | 0;
 i11 = i2 + 64 | 0;
 i14 = i2 + 48 | 0;
 i15 = i2 + 32 | 0;
 i16 = i2 + 24 | 0;
 i17 = i2 + 16 | 0;
 i19 = i2 + 8 | 0;
 i20 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800004 | 0, i2);
 HEAP32[i19 >> 2] = i20;
 __Z5b2LogPKcz(gb + 799360 | 0, i19);
 HEAP32[i17 >> 2] = i18;
 __Z5b2LogPKcz(gb + 799386 | 0, i17);
 HEAP32[i16 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i16);
 d13 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d12 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i15 >> 3] = d13;
 HEAPF64[i15 + 8 >> 3] = d12;
 __Z5b2LogPKcz(gb + 799447 | 0, i15);
 d12 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d13 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i14 >> 3] = d12;
 HEAPF64[i14 + 8 >> 3] = d13;
 __Z5b2LogPKcz(gb + 799489 | 0, i14);
 d13 = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 d12 = +Math_fround(HEAPF32[i1 + 88 >> 2]);
 HEAPF64[i11 >> 3] = d13;
 HEAPF64[i11 + 8 >> 3] = d12;
 __Z5b2LogPKcz(gb + 800031 | 0, i11);
 HEAPF64[i10 >> 3] = +Math_fround(HEAPF32[i1 + 100 >> 2]);
 __Z5b2LogPKcz(gb + 800071 | 0, i10);
 HEAP32[i9 >> 2] = HEAPU8[i1 + 136 >> 0];
 __Z5b2LogPKcz(gb + 800103 | 0, i9);
 HEAPF64[i8 >> 3] = +Math_fround(HEAPF32[i1 + 120 >> 2]);
 __Z5b2LogPKcz(gb + 800133 | 0, i8);
 HEAPF64[i7 >> 3] = +Math_fround(HEAPF32[i1 + 124 >> 2]);
 __Z5b2LogPKcz(gb + 800167 | 0, i7);
 HEAP32[i6 >> 2] = HEAPU8[i1 + 137 >> 0];
 __Z5b2LogPKcz(gb + 800201 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 132 >> 2]);
 __Z5b2LogPKcz(gb + 800231 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 128 >> 2]);
 __Z5b2LogPKcz(gb + 800259 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN9JSONWrite8TransferIN11UnityEngine9Analytics15UserCustomEvent12CustomParamsEEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams8TransferI9JSONWriteEEvRT_(i11, i10);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE5eraseERS8_(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = i13 + 20 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i2) {
  i13 = 0;
  return i13 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = i6;
 i3 = i3 + ~(i3 << 15) | 0;
 i3 = (i3 >>> 10 ^ i3) * 9 | 0;
 i3 = i3 >>> 6 ^ i3;
 i3 = i3 + ~(i3 << 11) | 0;
 i11 = i13 + 12 | 0;
 i3 = (HEAP32[i11 >> 2] | 0) + (((i3 >>> 16 ^ i3) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i13 = 0;
  return i13 | 0;
 }
 i9 = i13 + 4 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = i13 + 8 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i1;
 while (1) {
  i1 = i3;
  i3 = i5 + (i2 << 2) | 0;
  i4 = i2;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i7 + (i4 * 12 | 0) >> 2] | 0) == (i6 | 0)) {
   i5 = i4;
   break;
  }
  if ((i2 | 0) == -1) {
   i1 = 0;
   i10 = 11;
   break;
  }
 }
 if ((i10 | 0) == 11) return i1 | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i13 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i10 = i13 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i7 + (i5 * 12 | 0) >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
  i2 = i7 + (i1 * 12 | 0) + 4 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i7 + (i5 * 12 | 0) + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  i4 = HEAP32[i8 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (HEAP32[i3 >> 2] << 2) >> 2];
  i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 * 12 | 0) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i11 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i12 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i13 = i13 + 28 | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
 i13 = 1;
 return i13 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 8) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 256 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 7) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 128 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx21PxRevoluteJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i8 | 0, i9 | 0, 84, (i1 ? gb + 736008 | 0 : gb + 837976 | 0) | 0, gb + 736132 | 0, 48) | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i1 + 4 >> 1] = 257;
 HEAP16[i1 + 6 >> 1] = 3;
 i9 = i1 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i8 = i1 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 88500 + 8;
 HEAP32[i9 >> 2] = gb + 88500 + 240;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 136, gb + 736220 | 0, 90) | 0;
 HEAP32[i1 + 80 >> 2] = i10;
 __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i1, i10, i2, i4, i3, i5);
 HEAPF32[i10 + 124 >> 2] = Math_fround(1.0e10);
 HEAPF32[i10 + 128 >> 2] = Math_fround(3.14159274);
 HEAPF32[i10 + 76 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i10 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i10 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 88 >> 2] = Math_fround(.5);
 i5 = i10 + 92 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i10 + 100 >> 2] = Math_fround(.100000001);
 HEAPF32[i10 + 104 >> 2] = Math_fround(1.57079637);
 HEAPF32[i10 + 108 >> 2] = Math_fround(-1.57079637);
 HEAP16[i10 + 132 >> 1] = 0;
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, i2 | 0, i3 | 0, i9 | 0, gb + 88480 | 0, 136) | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 | 0) {
  i10 = i1;
  STACKTOP = i7;
  return i10 | 0;
 }
 if (!i1) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i10 = 0;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 96 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 96 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 96 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx15PxSerialization23createCollectionFromXmlERNS_11PxInputDataERNS_9PxCookingERNS_23PxSerializationRegistryEPKNS_12PxCollectionEPNS_13PxStringTableEPNS0_18PxXmlMiscParameterE(i1, i7, i10, i8, i11, i9) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 24 | 0;
 i2 = i12 + 12 | 0;
 i3 = i12;
 i4 = __Z18PxCreateCollectionv() | 0;
 i5 = (i8 | 0) != 0;
 if (i5) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i8 | 0);
 i14 = _PxGetFoundation() | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 20 >> 2] | 0, i14 | 0) | 0;
 i13 = mftCall_iiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 8 >> 2] | 0, i14 | 0, 164, gb + 766713 | 0, gb + 766736 | 0, 698) | 0;
 __ZN5physx2Sn18RepXCollectionImplC2ERNS_23PxSerializationRegistryERNS_19PxAllocatorCallbackERNS_12PxCollectionE(i13, i10, i14, i4);
 __ZN5physx2Sn18RepXCollectionImpl4loadERNS_11PxInputDataERNS0_21SerializationRegistryE(i13, i1, i10);
 i1 = __ZN5physx2Sn12RepXUpgrader17upgradeCollectionERNS0_14RepXCollectionE(i13) | 0;
 HEAP32[i6 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i11;
 if (!(mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i6 | 0, i4 | 0) | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i14 = 0;
  STACKTOP = i12;
  return i14 | 0;
 }
 if (i5) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i8 | 0);
 if (i9 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
  HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i14 = i9 + 12 | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i1 | 0);
  HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i14 = i4;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZN2UI18SortForBatchingJobEPNS_14SortingJobDataE(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, f12 = f0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 if ((HEAP16[gb + 1468108 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468108 | 0, i1);
  i2 = gb + 1468108 | 0;
 } else i2 = 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i7 = i8 + 8 | 0;
 i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i7 >> 2] | 0) * 252 | 0, 16, gb + 64024 | 0, 0, gb + 1012316 | 0, 164) | 0;
 HEAP32[i8 + 16 >> 2] = i9;
 i7 = HEAP32[i7 >> 2] | 0;
 do if (i7 >>> 0 > 1) {
  f6 = Math_fround(HEAPF32[i8 + 24 >> 2]);
  f3 = Math_fround(HEAPF32[gb + 62500 >> 2]);
  if (f6 == f3) {
   f5 = Math_fround(HEAPF32[i8 + 28 >> 2]);
   if (f5 == Math_fround(HEAPF32[gb + 62500 + 4 >> 2])) {
    f5 = Math_fround(HEAPF32[i8 + 32 >> 2]);
    if (f5 == Math_fround(HEAPF32[gb + 62500 + 8 >> 2])) {
     i1 = 120;
     break;
    }
   }
  }
  f3 = Math_fround(-f3);
  f4 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  f5 = Math_fround(HEAPF32[i8 + 36 >> 2]);
  if (f5 == f3) {
   f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
   f3 = Math_fround(HEAPF32[i8 + 40 >> 2]);
   if (f3 == f12) if (!(Math_fround(HEAPF32[i8 + 44 >> 2]) != f4)) {
    i1 = 120;
    break;
   }
  } else f3 = Math_fround(HEAPF32[i8 + 40 >> 2]);
  f6 = Math_fround(f5 - f6);
  f12 = Math_fround(f3 - Math_fround(HEAPF32[i8 + 28 >> 2]));
  f5 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  i1 = ~~Math_fround(f5 * (f6 >= f12 ? f6 : f12));
 } else i1 = 120; while (0);
 i13 = HEAP32[i10 + 8 >> 2] | 0;
 i8 = i8 + 12 | 0;
 __ZN2UI15SortForBatchingEPKNS_23RenderableUIInstructionEjPS0_i(HEAP32[i8 >> 2] | 0, i7, i9, (i13 | 0) < (i1 | 0) ? i1 : i13);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, gb + 64024 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i10, gb + 64024 | 0);
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i11;
 return;
}

function __ZN20OcclusionCullingData8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i11 = i10;
 i9 = i10 + 16 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i2, i6);
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i11;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i3 = i9 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i11);
 i11 = i5;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379023 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i6, i9, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (HEAP8[i6 + 128 >> 0] | 0) {
  i1 = i2 + 32 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i11 = __Z9GetIUmbrav() | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0, i11 | 0, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  if (HEAP32[i3 >> 2] | 0) {
   i11 = __Z9GetIUmbrav() | 0;
   HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  }
 }
 i2 = i2 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379033 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI14OcclusionSceneLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z44SceneUtility_CUSTOM_GetScenePathByBuildIndexi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 72 | 0;
 i4 = i5 + 16 | 0;
 i2 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i6 = i4 + 16 | 0;
 HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i6 = i4 + 32 | 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i2 + 11 | 0;
 HEAP8[i6 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 i1 = __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo(i2, i1, i4) | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if (i1) {
  i2 = HEAP8[i4 + 11 >> 0] | 0;
  i6 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255) | 0;
 } else i2 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
 i1 = i4 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 i1 = i4 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return i2 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 STACKTOP = i5;
 return i2 | 0;
}

function __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9;
 i12 = HEAP32[i1 + 124 >> 2] | 0;
 i19 = HEAP32[i1 + 128 >> 2] | 0;
 i18 = HEAP32[i1 + 132 >> 2] | 0;
 i17 = HEAP32[i1 + 136 >> 2] | 0;
 i16 = HEAP32[i1 + 140 >> 2] | 0;
 i15 = HEAP32[i1 + 144 >> 2] | 0;
 i14 = HEAP32[i1 + 148 >> 2] | 0;
 i13 = HEAP32[i1 + 152 >> 2] | 0;
 i10 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
 HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
 HEAP32[i11 + 28 >> 2] = HEAP32[i10 + 28 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i12;
 i12 = i2 + 8 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i19;
 i12 = i2 + 12 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i18;
 i12 = i2 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i17;
 i12 = i2 + 20 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i16;
 i12 = i2 + 24 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i15;
 i12 = i2 + 28 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i14;
 i12 = i2 + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i13;
 i8 = __Z26ApplyMaterialPassWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i1, i2, i3, i4, i5, i6, i7, i8) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i11 + 28 >> 2];
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 5) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 32 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i1, i8, i2, f3, f6, i5, i13) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f6 = Math_fround(f6);
 i5 = i5 | 0;
 i13 = i13 | 0;
 var f4 = f0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 16 | 0;
 i10 = i14;
 i11 = i14 + 24 | 0;
 if ((HEAP16[gb + 1457764 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457764 | 0, i7);
  i12 = gb + 1457764 | 0;
 } else i12 = 0;
 HEAP32[i11 >> 2] = gb + 156168 + 8;
 i9 = i11 + 4 | 0;
 HEAP32[i11 + 12 >> 2] = i2;
 i1 = i11 + 16 | 0;
 i2 = i11 + 20 | 0;
 HEAP32[i11 + 24 >> 2] = i5;
 i5 = i11 + 28 | 0;
 HEAP32[i5 >> 2] = i13;
 i15 = f3 == Math_fround(-inf);
 f4 = i15 ? Math_fround(-3402823469999999843913219.0e14) : f3;
 HEAPF32[i1 >> 2] = f4;
 i15 = f6 == Math_fround(inf);
 f3 = i15 ? Math_fround(3402823469999999843913219.0e14) : f6;
 HEAPF32[i2 >> 2] = f3;
 if (!(f4 < f3)) {
  HEAPF32[i1 >> 2] = f3;
  HEAPF32[i2 >> 2] = f4;
 }
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 8 >> 2] = i1;
 i1 = i13 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i13 >> 2] | 0, i13 + 4 | 0);
  HEAP32[i13 >> 2] = 0;
 }
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i15 = i9;
 i13 = HEAP32[i15 >> 2] | 0;
 i15 = HEAP32[i15 + 4 >> 2] | 0;
 i1 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i15;
 i1 = i10;
 HEAP32[i1 >> 2] = i13;
 HEAP32[i1 + 4 >> 2] = i15;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i11, i10);
 i1 = HEAP32[i5 >> 2] | 0;
 i15 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i15, i15 + (HEAP32[i1 + 12 >> 2] << 2) | 0, i7);
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0;
 if (!i12) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i4 = i7 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i7 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i5;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i3 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i6 = i7 + 16 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i7 + 20 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN14VelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj(i9, i2, i3, i11, i12, i13) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 4 | 0;
 i1 = i14;
 if ((HEAP16[gb + 1452104 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452104 | 0, i10);
  i8 = gb + 1452104 | 0;
 } else i8 = 0;
 i6 = __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_(i10, (HEAP32[i2 + 280 >> 2] | 0) == 1, (HEAP8[i9 + 800 >> 0] | 0) != 0, i3 + 52 | 0, i3 + 180 | 0) | 0;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i9 + 92 >> 2] | 0;
 i2 = i1 & 65535;
 if (!(i2 << 16 >> 16)) if (!(HEAP16[i9 + 356 >> 1] | 0)) i4 = (HEAP16[i9 + 620 >> 1] | 0) == 0; else i4 = 0; else i4 = 0;
 if (!(i1 & 16711680)) i5 = 0; else if (!(HEAP8[i9 + 358 >> 0] | 0)) i5 = 0; else i5 = (HEAP8[i9 + 622 >> 0] | 0) != 0;
 if ((i2 | 1) << 16 >> 16 == 3) if ((HEAP16[i9 + 356 >> 1] | 1) << 16 >> 16 == 3) i3 = (HEAP16[i9 + 620 >> 1] | 1) << 16 >> 16 != 3; else i3 = 1; else i3 = 1;
 do if (i4) __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i7, i9 + 272 | 0, i9 + 536 | 0, i11, i12, i13, i6, i10); else {
  i2 = i9 + 272 | 0;
  i1 = i9 + 536 | 0;
  if (!(i3 | i5 ^ 1)) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i7, i2, i1, i11, i12, i13, i6, i10);
   break;
  }
  if (i5) {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i7, i2, i1, i11, i12, i13, i6, i10);
   break;
  } else {
   __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E(i7, i2, i1, i11, i12, i13, i6, i10);
   break;
  }
 } while (0);
 if (!i8) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i14;
 return;
}

function __Z35computeBlockStreamByteSizesCoulomb4PN5physx21PxcSolverContact4DescERNS_18PxcNpThreadContextERKNS_27PxcCorrelationBufferCoulombERjPjS7_(i16, i1, i10, i15, i9, i14) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0, i19 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 128 | 0;
 i12 = i13;
 i1 = i11;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i12;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i8 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i16 + (i8 * 56 | 0) + 8 >> 2] | 0;
  if (!i2) {
   i2 = 0;
   i3 = 0;
  } else {
   i6 = HEAP32[i16 + (i8 * 56 | 0) + 4 >> 2] | 0;
   i3 = 0;
   i7 = 0;
   do {
    i5 = i6 + i7 | 0;
    i4 = HEAP32[i10 + 1408 + (i5 << 2) >> 2] | 0;
    if (i4) {
     i17 = (HEAP16[i10 + 768 + (i5 * 20 | 0) + 18 >> 1] & 1) == 0;
     i18 = i11 + (i7 << 2) | 0;
     i19 = HEAP32[i18 >> 2] | 0;
     HEAP32[i18 >> 2] = i4 >>> 0 < i19 >>> 0 ? i19 : i4;
     i3 = i4 + i3 | 0;
     if (i17) {
      i19 = HEAPU16[i10 + 768 + (i5 * 20 | 0) + 16 >> 1] | 0;
      i18 = i12 + (i7 << 2) | 0;
      i17 = HEAP32[i18 >> 2] | 0;
      HEAP32[i18 >> 2] = i19 >>> 0 < i17 >>> 0 ? i17 : i19;
      i3 = i19 + i3 | 0;
     }
    }
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i2 >>> 0);
  }
  i1 = i2 >>> 0 < i1 >>> 0 ? i1 : i2;
  HEAP32[i9 + (i8 << 2) >> 2] = i3;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 4);
 i4 = i1;
 if (!i4) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = 0;
  i2 = 0;
  i1 = 0;
  do {
   i2 = (HEAP32[i11 + (i3 << 2) >> 2] | 0) + i2 | 0;
   i1 = (HEAP32[i12 + (i3 << 2) >> 2] | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i15 >> 2] = (Math_imul(((HEAP16[(HEAP32[i16 + 56 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i16 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i16 + 112 >> 2] | 0) + 22 >> 1] | HEAP16[(HEAP32[i16 + 168 >> 2] | 0) + 22 >> 1]) & 64) == 0 ? 192 : 288, i1 + i2 | 0) | 0) + (i4 * 176 | 0);
 STACKTOP = i13;
 return;
}

function __ZNK15ParticleEmitter13ReadParticlesEP14SimpleParticleii(i2, i5, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 if ((i6 | 0) >= 0) {
  i4 = i1 + i6 | 0;
  i1 = HEAP32[i2 + 56 >> 2] | 0;
  i3 = i1;
  if ((i4 | 0) <= (((HEAP32[i2 + 60 >> 2] | 0) - i1 | 0) / 48 | 0 | 0)) {
   if ((i4 | 0) > 0) i1 = 0; else return;
   do {
    i10 = i5 + (i1 * 60 | 0) | 0;
    i2 = i1 + i6 | 0;
    i11 = i3 + (i2 * 48 | 0) | 0;
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    i10 = i5 + (i1 * 60 | 0) + 12 | 0;
    i11 = i3 + (i2 * 48 | 0) + 12 | 0;
    HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
    HEAP32[i5 + (i1 * 60 | 0) + 24 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 24 >> 2];
    HEAPF32[i5 + (i1 * 60 | 0) + 28 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 28 >> 2]) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0));
    HEAPF32[i5 + (i1 * 60 | 0) + 32 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + (i2 * 48 | 0) + 32 >> 2]) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0));
    HEAP32[i5 + (i1 * 60 | 0) + 36 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 36 >> 2];
    HEAP32[i5 + (i1 * 60 | 0) + 40 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 40 >> 2];
    i2 = HEAP32[i3 + (i2 * 48 | 0) + 44 >> 2] | 0;
    f9 = Math_fround(Math_fround((i2 & 65535) >>> 8 & 255) / Math_fround(255.0));
    f8 = Math_fround(Math_fround(i2 >>> 16 & 255) / Math_fround(255.0));
    f7 = Math_fround(Math_fround(i2 >>> 24 & 255) / Math_fround(255.0));
    HEAPF32[i5 + (i1 * 60 | 0) + 44 >> 2] = Math_fround(Math_fround(i2 & 255) / Math_fround(255.0));
    HEAPF32[i5 + (i1 * 60 | 0) + 48 >> 2] = f9;
    HEAPF32[i5 + (i1 * 60 | 0) + 52 >> 2] = f8;
    HEAPF32[i5 + (i1 * 60 | 0) + 56 >> 2] = f7;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1049297 | 0, 0, gb + 1049329 | 0, 375, 1, 0, 0, 0);
 return;
}

function __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i12 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i3 >>> 30;
 if ((i10 + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) if (HEAP8[i1 + 2433 >> 0] | 0) {
   i1 = i12 + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i12 >> 2] | 0, i3 >>> 24 & 15) | 0;
    HEAP32[i1 >> 2] = i2;
   }
   i4 = HEAP32[i2 + 8 >> 2] | 0;
   L8 : do if ((i4 | 0) != -1) {
    i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 2528 >> 2] | 0;
    i6 = i2 + 12 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    if (i7 | 0) {
     i3 = 0;
     while (1) {
      i1 = i5 + (i3 + i4 << 2) | 0;
      i3 = i3 + 1 | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) break;
      if (i3 >>> 0 >= i7 >>> 0) break L8;
     }
     HEAP32[i1 >> 2] = HEAP32[i5 + (i4 + -1 + i7 << 2) >> 2];
     HEAP32[i6 >> 2] = i7 + -1;
    }
   } while (0);
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i7 = i3 + 2528 | 0;
    i1 = HEAP32[i3 + 2532 >> 2] | 0;
    i6 = i1 + (HEAP32[i12 + 20 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = 0;
    __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i7, i6, i8);
    HEAP32[i2 >> 2] = i1;
    i1 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
   } else i1 = (HEAP32[i3 + 2528 >> 2] | 0) + (i1 << 2) | 0;
   i8 = i2 + 4 | 0;
   i7 = HEAP32[i8 >> 2] | 0;
   HEAP32[i1 + (i7 << 2) >> 2] = i11;
   HEAP32[i8 >> 2] = i7 + 1;
   if ((i10 | 0) == 1) {
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
    STACKTOP = i13;
    return;
   } else {
    __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i12 >> 2] | 0, i12);
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
    STACKTOP = i13;
    return;
   }
  }
 } else if ((i10 | 0) == 3) {
  STACKTOP = i13;
  return;
 }
 HEAP32[(HEAP32[gb + 90260 + 24 + (((HEAP32[i11 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i11 >> 2] = HEAP32[i12 + 16 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN5Unity12PhysicsQuery10SphereTestERK8Vector3ffi23QueryTriggerInteraction(i1, i7, f8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 92 | 0;
 i2 = i11 + 56 | 0;
 i3 = i11 + 48 | 0;
 i4 = i11 + 20 | 0;
 i5 = i11;
 if ((HEAP16[gb + 1452656 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452656 | 0, i1);
  i6 = gb + 1452656 | 0;
 } else i6 = 0;
 f14 = Math_fround(HEAPF32[gb + 1452812 >> 2]);
 HEAP32[i3 >> 2] = 0;
 HEAPF32[i3 + 4 >> 2] = f14 < f8 ? f14 : f8;
 i13 = HEAP32[i7 >> 2] | 0;
 i12 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 16 >> 2] = i13;
 HEAP32[i4 + 20 >> 2] = i12;
 HEAP32[i4 + 24 >> 2] = i7;
 HEAP32[i5 >> 2] = gb + 114012 + 8;
 HEAP32[i5 + 4 >> 2] = 2;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = i9;
 switch (i10 | 0) {
 case 0:
  {
   HEAP8[i5 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i5 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i5 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 i12 = HEAP32[gb + 1457404 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 55;
 HEAP8[i1 + 18 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 i13 = i2 + 20 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 85608 + 8;
 mftCall_iiiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 356 >> 2] | 0, i12 | 0, i3 | 0, i4 | 0, i2 | 0, i1 | 0, i5 | 0) | 0;
 i1 = (HEAP8[i13 >> 0] | 0) != 0;
 if (!i6) {
  STACKTOP = i11;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj(i11, i3) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i13 = i11 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((((HEAP32[i13 >> 2] | 0) - i2 | 0) / 88 | 0) >>> 0 >= i3 >>> 0) {
  STACKTOP = i16;
  return;
 }
 i14 = i11 + 12 | 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i3) {
  i4 = 0;
  i7 = i1;
  i9 = i2;
 } else {
  i4 = HEAP32[i14 >> 2] | 0;
  HEAP32[i15 >> 2] = 1;
  HEAP32[i15 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 88 | 0, 16, i15, 0, gb + 1049224 | 0, 75) | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i4 + (((i1 - i2 | 0) / 88 | 0) * 88 | 0) | 0;
 i10 = i1;
 i8 = i4 + (i3 * 88 | 0) | 0;
 if ((i7 | 0) == (i9 | 0)) {
  i2 = i10;
  i4 = i7;
  i1 = i7;
 } else {
  i2 = i10;
  do {
   i3 = i7;
   i7 = i7 + -88 | 0;
   i4 = i1 + -88 | 0;
   i5 = i7;
   i6 = i4 + 56 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i1 + -32 | 0, i3 + -32 | 0);
   i6 = i1 + -12 | 0;
   i5 = i3 + -12 | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   i1 = i2 + -88 | 0;
   i2 = i1;
  } while ((i7 | 0) != (i9 | 0));
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i13 >> 2] = i8;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -32 | 0;
  if ((HEAP32[i1 + -16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -28 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -88 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i16;
  return;
 }
 i14 = HEAP32[i14 >> 2] | 0;
 HEAP32[i15 >> 2] = 1;
 HEAP32[i15 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i15);
 STACKTOP = i16;
 return;
}

function __ZN20TextRenderingPrivate22ScriptingTextGenerator13GetTextOffsetERK8Vector2fRK5RectTIfEiS3_b(i7, i4, i2, i3, i6, i8) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var f1 = f0, f5 = f0, i9 = 0, i10 = 0, f11 = f0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i9 = i7 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 switch (i3 | 0) {
 case 6:
 case 3:
 case 0:
  {
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   f1 = Math_fround(0.0);
   break;
  }
 case 7:
 case 4:
 case 1:
  {
   f1 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.5));
   HEAPF32[i7 >> 2] = f1;
   break;
  }
 case 8:
 case 5:
 case 2:
  {
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP32[i7 >> 2] = i10;
   f1 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  }
 default:
  {
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
 }
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(f1 - Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 HEAPF32[i7 >> 2] = f5;
 switch (i3 | 0) {
 case 2:
 case 1:
 case 0:
  {
   f1 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
   HEAPF32[i9 >> 2] = f1;
   break;
  }
 case 5:
 case 4:
 case 3:
  {
   f1 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - Math_fround(HEAPF32[i2 + 12 >> 2])) * Math_fround(.5)) - Math_fround(HEAPF32[i2 + 4 >> 2]));
   HEAPF32[i9 >> 2] = f1;
   break;
  }
 case 8:
 case 7:
 case 6:
  {
   f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
   f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) + Math_fround(HEAPF32[i2 + 12 >> 2])));
   HEAPF32[i9 >> 2] = f1;
   break;
  }
 default:
  {
   HEAPF32[i9 >> 2] = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
 }
 f11 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f1 = Math_fround(f1 - Math_fround(f11 * Math_fround(HEAPF32[i4 + 4 >> 2])));
 HEAPF32[i9 >> 2] = f1;
 if (i8) {
  HEAPF32[i7 >> 2] = Math_fround(Math_floor(Math_fround(f5 + Math_fround(.5))));
  f11 = Math_fround(Math_floor(Math_fround(f1 + Math_fround(.5))));
  HEAPF32[i9 >> 2] = f11;
  return;
 } else {
  HEAPF32[i7 >> 2] = f5;
  f11 = f1;
  HEAPF32[i9 >> 2] = f11;
  return;
 }
}

function __Z20Material_CUSTOM_LerpP12Il2CppObjectS0_S0_f(i7, i1, i4, f8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 f8 = Math_fround(f8);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i6 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i6 = 6;
 if ((i6 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i5 = i1 + 12 | 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i6 = 12; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i6 = 12;
 if ((i6 | 0) == 12) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i3 = i1 + 12 | 0;
 if (!i7) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 i1 = i4 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i2 + 164 >> 0] & 1) if (HEAP32[i2 + 8 >> 2] | 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i7);
  i7 = i7 + 12 | 0;
  i6 = f8 < Math_fround(0.0);
  i4 = f8 > Math_fround(1.0);
  f8 = i4 ? Math_fround(1.0) : f8;
  f8 = i6 ? Math_fround(0.0) : f8;
  __ZN19ShaderPropertySheet14LerpPropertiesERKS_S1_f(i7, i5, i3, f8);
  return;
 }
 __ZN8Material15BuildPropertiesEv(i4);
 i7 = HEAP32[i1 >> 2] | 0;
 __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i7);
 i7 = i7 + 12 | 0;
 i6 = f8 < Math_fround(0.0);
 i4 = f8 > Math_fround(1.0);
 f8 = i4 ? Math_fround(1.0) : f8;
 f8 = i6 ? Math_fround(0.0) : f8;
 __ZN19ShaderPropertySheet14LerpPropertiesERKS_S1_f(i7, i5, i3, f8);
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 24 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i2 >> 2];
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 24 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i6 = (HEAP32[i9 >> 2] | 0) + (i1 << 4) | 0;
    i5 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i2 - i1 >> 4;
 HEAP32[i8 >> 2] = i3;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return;
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0;
 i21 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f4 * f11);
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f17 * f16));
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f19 * f14));
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f12 = Math_fround(f4 * f9);
 f15 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f17 * f15));
 f13 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f19 * f13));
 f7 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f4 = Math_fround(f4 * f7);
 f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f17 = Math_fround(f4 + Math_fround(f17 * f5));
 f4 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 i20 = f10 > Math_fround(0.0);
 i18 = f12 > Math_fround(0.0);
 i2 = Math_fround(f17 + Math_fround(f19 * f4)) > Math_fround(0.0);
 f19 = Math_fround(HEAPF32[i21 + 144 >> 2]);
 f17 = Math_fround(HEAPF32[i21 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + 152 >> 2]);
 f10 = Math_fround(-f19);
 f8 = Math_fround(-f17);
 f6 = Math_fround(-f12);
 f10 = i20 ? f19 : f10;
 f8 = i18 ? f17 : f8;
 f6 = i2 ? f12 : f6;
 f12 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f5 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f15 * f8)) + Math_fround(f5 * f6)));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) + Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(f13 * f8)) + Math_fround(f4 * f6)));
 HEAPF32[i1 >> 2] = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f8)) + Math_fround(f7 * f6)));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i2 = i13;
 i8 = i13 + 17 | 0;
 i9 = i13 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 i5 = i10 + 292 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  i11 = 0;
 } else {
  i3 = 0;
  i4 = 0;
  while (1) {
   HEAP32[i2 >> 2] = i1;
   if ((i3 & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE15growAndPushBackERKS2_(i6, i2) | 0;
   i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   if (!i1) break;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  }
  i11 = HEAP32[i6 >> 2] | 0;
  i1 = i11;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j(i1, i2, i8, i10, 32);
 i3 = i10 + 264 | 0;
 i8 = i10 + 268 | 0;
 __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j(HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] | 0, i9, i10, 32);
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = i3 + (i9 << 2) | 0;
 if (i9 | 0) {
  i7 = HEAP32[i10 + 276 >> 2] | 0;
  i5 = i1 + (i2 << 2) | 0;
  i6 = (i7 | 0) == 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + (i7 << 6) | 0;
   if (!i6) do {
    if ((i1 | 0) == (i5 | 0)) i1 = i5; else i1 = (HEAP32[i1 >> 2] | 0) == (i2 | 0) ? i1 + 4 | 0 : i1;
    i2 = i2 + 64 | 0;
   } while ((i2 | 0) != (i4 | 0));
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i8 | 0));
 }
 i12 = HEAP32[i12 >> 2] | 0;
 if ((i12 & 2147483647 | 0) == 0 | (i12 | 0) < 0 | (i11 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i11 | 0);
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj622ES3_RKNS_27PxVehicleTireLoadFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 100 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj622ES2_RKNS_27PxVehicleTireLoadFilterDataES6_EEKNS_40PxVehicleTireLoadFilterDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN2UI13RectTransform16UpdatePosAndRectEb(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i4 = i10;
 __ZNK9Transform16GetLocalPositionEv(i4, i11);
 __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i9, i11);
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f2 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i6 = i11 + 168 | 0;
 f2 = Math_fround(f5 + Math_fround(f2 * Math_fround(HEAPF32[i6 >> 2])));
 f5 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 i8 = i11 + 172 | 0;
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i8 >> 2])));
 __ZNK9Transform16GetLocalPositionEv(i9, i11);
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 if (Math_fround(HEAPF32[i4 >> 2]) != f2) i7 = 4; else if (Math_fround(HEAPF32[i4 + 4 >> 2]) != f3) i7 = 4; else {
  f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  if (f5 != (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i7 = 4; else i4 = 0;
 }
 if ((i7 | 0) == 4) {
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i9 + 4 >> 2] = f3;
  HEAP32[i9 + 8 >> 2] = i1;
  __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i11, i9);
  i4 = 1;
 }
 __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i9, i11);
 f5 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f12 = Math_fround(-Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])));
 HEAPF32[i9 >> 2] = f12;
 f3 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f2 = Math_fround(-Math_fround(f3 * Math_fround(HEAPF32[i8 >> 2])));
 HEAPF32[i9 + 4 >> 2] = f2;
 i1 = i11 + 120 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f12)) if (!(Math_fround(HEAPF32[i11 + 124 >> 2]) != f2)) if (!(f5 != Math_fround(HEAPF32[i11 + 128 >> 2]))) if (!(f3 != Math_fround(HEAPF32[i11 + 132 >> 2]))) {
  i9 = i4;
  i11 = i11 + 177 | 0;
  HEAP8[i11 >> 0] = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i9 = i4 | 2;
 i11 = i11 + 177 | 0;
 HEAP8[i11 >> 0] = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN14SphereCollider10SmartResetEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i1 = i7 + 4 | 0;
 i2 = i7;
 i3 = HEAP32[i5 + 28 >> 2] | 0;
 if (i3 | 0) if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i4) | 0) {
  i10 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  i3 = HEAP32[i4 + 16 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  f9 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f8 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i3 = f8 < (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(HEAPF32[(i3 ? i2 : i1) >> 2]);
  __ZN14SphereCollider9SetRadiusEf(i5, f8 < f9 ? f9 : f8);
  i1 = i5 + 64 | 0;
  f8 = Math_fround(HEAPF32[i1 >> 2]);
  if (f8 != Math_fround(HEAPF32[i4 >> 2])) i6 = 6; else {
   f9 = Math_fround(HEAPF32[i5 + 68 >> 2]);
   if (f9 != Math_fround(HEAPF32[i4 + 4 >> 2])) i6 = 6; else {
    f9 = Math_fround(HEAPF32[i5 + 72 >> 2]);
    if (f9 != Math_fround(HEAPF32[i4 + 8 >> 2])) i6 = 6;
   }
  }
  if ((i6 | 0) == 6) {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  }
  if (HEAP32[i5 + 36 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 168 >> 2] | 0, i5 | 0, -2147483645);
  STACKTOP = i7;
  return;
 }
 __ZN14SphereCollider9SetRadiusEf(i5, Math_fround(.5));
 i1 = i5 + 64 | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 if (f9 != Math_fround(HEAPF32[gb + 1162364 >> 2])) i6 = 13; else {
  f9 = Math_fround(HEAPF32[i5 + 68 >> 2]);
  if (f9 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) i6 = 13; else {
   f9 = Math_fround(HEAPF32[i5 + 72 >> 2]);
   if (f9 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) i6 = 13;
  }
 }
 if ((i6 | 0) == 13) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 if (!(HEAP32[i5 + 36 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 168 >> 2] | 0, i5 | 0, -2147483645);
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 24 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 24 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 2;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (((i1 - i4 | 0) / 24 | 0) * 24 | 0) | 0;
 i5 = i5 + (i3 * 24 | 0) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i1 = i4 + 24 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 2;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = i6 + 16 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i3 = i6 + 20 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 24 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i6 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
  STACKTOP = i10;
  return;
 }
}

function __ZN8Animator15WritePropertiesEff(i9, f10, f3) {
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f3 = Math_fround(f3);
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i9 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i8 = i9 + 100 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 16;
 i1 = i9 + 168 | 0;
 i4 = i9 + 132 | 0;
 __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(HEAP32[i1 >> 2] | 0, HEAP32[HEAP32[i4 >> 2] >> 2] | 0);
 if (HEAP8[i9 + 153 >> 0] | 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  if (i5 | 0) {
   __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(i5, HEAP32[HEAP32[i4 >> 2] >> 2] | 0);
   if (!(HEAP8[i9 + 561 >> 0] | 0)) {
    if (HEAP32[i9 + 124 >> 2] | 0) {
     i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0;
     __ZN11UnityEngine9Animation40SetFlattenedSkeletonTransformsMainThreadER9TransformRKNS0_21AvatarBindingConstantE(i6, HEAP32[i9 + 144 >> 2] | 0);
    }
   } else {
    i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0;
    __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE(i6, HEAP32[i1 >> 2] | 0, HEAP32[i9 + 144 >> 2] | 0);
   }
   if ((HEAP32[i9 + 96 >> 2] | 0) == 2) {
    if (!(__Z14IsWorldPlayingv() | 0)) i7 = 11;
   } else i7 = 11;
   if ((i7 | 0) == 11) f3 = f10;
   if (HEAP32[i9 + 108 >> 2] | 0) {
    i1 = HEAP32[i9 + 624 >> 2] | 0;
    if (i1 | 0) if ((HEAP32[i9 + 548 >> 2] | 0) == 2) {
     f2 = Math_fround(HEAPF32[i9 + 420 >> 2]);
     if (f2 >= Math_fround(0.0)) {
      f3 = Math_fround(f3 * f2);
      __ZN14AvatarPlayback11RecordFrameEfPKN7mecanim9animation12AvatarMemoryEPNS1_16ControllerMemoryE(i9 + 504 | 0, f3, HEAP32[i9 + 136 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0);
     }
    }
   }
   __ZN7mecanim9animation31UpdateAvatarMemoryFirstEvalFlagEPNS0_12AvatarMemoryEf(HEAP32[i9 + 136 >> 2] | 0, f10);
  }
 }
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -17;
 return;
}

function __ZN5physx2Sc5Scene18visualizeStartStepEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 if (!(Math_fround(HEAPF32[i7 + 1408 >> 2]) != Math_fround(0.0))) {
  STACKTOP = i9;
  return;
 }
 i6 = i7 + 1204 | 0;
 i1 = (HEAP32[i6 >> 2] | 0) + 1e3 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 5924 | 0;
 i3 = i8 + 36 | 0;
 i4 = i8;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i5 = i8 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i8 + 56 >> 2] = Math_fround(1.0);
 i5 = i8 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i8 + 76 >> 2] = Math_fround(1.0);
 i5 = i8 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i8 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i8 + 100 >> 2] = i2;
 if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[i1 >> 2] | 0, 15)) != Math_fround(0.0)) __ZN5physx14PxsAABBManager9visualizeERNS_2Cm12RenderOutputE(HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i8);
 i1 = i7 + 88 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i7 + 84 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sc13ConstraintSim9visualizeERNS_14PxRenderBufferE(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 68 >> 2] | 0, (HEAP32[(HEAP32[i6 >> 2] | 0) + 1e3 >> 2] | 0) + 5924 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 __ZN5physx2Sc10NPhaseCore9visualizeERNS_2Cm12RenderOutputE(HEAP32[i7 + 1104 >> 2] | 0, i8);
 i3 = i7 + 136 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = i7 + 132 | 0;
  i2 = 0;
  do {
   __ZN5physx2Sc17ParticleSystemSim18visualizeStartStepERNS_2Cm12RenderOutputE(__ZNK5physx2Sc18ParticleSystemCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0, i8);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 STACKTOP = i9;
 return;
}

function __ZN5physx18PxsSolverStartTask16articulationTaskEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i20;
 i19 = HEAP32[HEAP32[i1 + 24 >> 2] >> 2] | 0;
 i15 = HEAP32[i19 + 9124 >> 2] | 0;
 i16 = i19 + 332 | 0;
 HEAP32[i19 + 336 >> 2] = 0;
 HEAP32[i19 + 340 >> 2] = 0;
 i17 = i1 + 52 | 0;
 if (!(HEAP32[i17 >> 2] & 2147483647)) {
  i18 = 0;
  i16 = 0;
  i17 = 0;
  i15 = i19 + 9052 | 0;
  __ZN5physx6shdfnd9atomicMaxEPVii(i15, i16) | 0;
  i16 = i19 + 9056 | 0;
  __ZN5physx6shdfnd9atomicMaxEPVii(i16, i17) | 0;
  i19 = i19 + 9064 | 0;
  HEAP32[i19 >> 2] = i18;
  STACKTOP = i20;
  return;
 }
 i14 = i1 + 32 | 0;
 i9 = i1 + 20 | 0;
 i10 = i19 + 9068 | 0;
 i11 = i19 + 9028 | 0;
 i12 = i19 + 316 | 0;
 i13 = 0;
 i3 = 0;
 i2 = 0;
 i1 = 0;
 do {
  i8 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i13 << 2) >> 2] | 0;
  i7 = i15 + (i13 * 40 | 0) | 0;
  i4 = i7;
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = i4 + 40 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   i4 = i4 + 4 | 0;
   i5 = i5 + 4 | 0;
  } while ((i4 | 0) < (i6 | 0));
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = HEAP32[gb + 1457380 >> 2] | 0;
  if (!i5) i4 = 0; else i4 = mftCall_iifiiiii(i5 | 0, i7 | 0, +Math_fround(HEAPF32[i4 + 124 >> 2]), i16 | 0, HEAP32[i10 >> 2] | 0, i18 | 0, HEAP32[(HEAP32[i4 + 96 >> 2] | 0) + 6964 >> 2] | 0, i12 | 0) | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + (i4 << 5);
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i18 >> 2] | 0);
  i7 = HEAPU16[i15 + (i13 * 40 | 0) + 32 >> 1] | 0;
  i3 = i3 >>> 0 < i7 >>> 0 ? i7 : i3;
  i8 = HEAPU16[(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0) + 12 >> 1] | 0;
  i7 = i8 >>> 8;
  i1 = i7 >>> 0 < i1 >>> 0 ? i1 : i7;
  i8 = i8 & 255;
  i2 = i8 >>> 0 < i2 >>> 0 ? i2 : i8;
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i17 >> 2] & 2147483647) >>> 0);
 i18 = i19 + 9052 | 0;
 __ZN5physx6shdfnd9atomicMaxEPVii(i18, i2) | 0;
 i18 = i19 + 9056 | 0;
 __ZN5physx6shdfnd9atomicMaxEPVii(i18, i1) | 0;
 i19 = i19 + 9064 | 0;
 HEAP32[i19 >> 2] = i3;
 STACKTOP = i20;
 return;
}

function __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxAllRK13Vector2fIcallS1_fiff(i1, i2, f3, i4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12 + 8 | 0;
 i7 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i7);
 i16 = i13;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i10;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 i14 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i14, i13, i7, f3, i4, f5, f6, 0, i11) | 0;
 i4 = __Z19GetScriptingManagerv() | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i4 + 168 >> 2] | 0) + (HEAP32[gb + 32588 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i8 >> 2] | 0) | 0;
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i7 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i4 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i4 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, _llvm_bswap_i32(i1 | 0) | 0, i5 + 8 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 4) | 0;
 if (!i4) i1 = 0; else {
  do {
   __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function ___ipparse(i8, i5, i6) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i7 = i11;
 i1 = i9;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 L1 : do if ((i5 | 0) == 10) i10 = 17; else {
  i3 = i6;
  i1 = 0;
  L2 : while (1) {
   HEAP32[i9 + (i1 << 2) >> 2] = _strtoul(i3, i7, 0) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   if ((i4 | 0) == (i3 | 0)) {
    i10 = 5;
    break;
   }
   i2 = HEAP8[i4 >> 0] | 0;
   switch (i2 << 24 >> 24) {
   case 46:
   case 0:
    break;
   default:
    {
     i10 = 5;
     break L2;
    }
   }
   if (((HEAP8[i3 >> 0] | 0) + -48 | 0) >>> 0 >= 10) {
    i10 = 5;
    break;
   }
   if (!(i2 << 24 >> 24)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) < 4) i3 = i4 + 1 | 0; else break;
  }
  if ((i10 | 0) == 5) if ((i5 | 0) == 2) {
   i1 = -1;
   break;
  } else {
   i10 = 17;
   break;
  }
  switch (i1 | 0) {
  case 4:
   {
    i1 = -1;
    break L1;
   }
  case 0:
   {
    i10 = HEAP32[i9 >> 2] | 0;
    i2 = i10 & 16777215;
    i1 = i9 + 4 | 0;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i9 >> 2] = i10 >>> 24;
    i10 = 12;
    break;
   }
  case 1:
   {
    i2 = i9 + 4 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    i10 = 12;
    break;
   }
  case 2:
   {
    i2 = i9 + 8 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    i10 = 13;
    break;
   }
  default:
   {}
  }
  if ((i10 | 0) == 12) {
   i7 = i2 & 65535;
   i6 = i9 + 8 | 0;
   HEAP32[i6 >> 2] = i7;
   HEAP32[i1 >> 2] = i2 >>> 16;
   i1 = i6;
   i2 = i7;
   i10 = 13;
  }
  if ((i10 | 0) == 13) {
   HEAP32[i9 + 12 >> 2] = i2 & 255;
   HEAP32[i1 >> 2] = i2 >>> 8;
  }
  HEAP16[i8 >> 1] = 2;
  i2 = i8 + 4 | 0;
  i1 = 0;
  while (1) {
   i3 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if (i3 >>> 0 > 255) {
    i1 = -1;
    break L1;
   }
   HEAP8[i2 + i1 >> 0] = i3;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 4) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 if ((i10 | 0) == 17) {
  HEAP16[i8 >> 1] = 10;
  i1 = ((_inet_pton(10, i6, i8 + 8 | 0) | 0) < 1) << 31 >> 31;
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNK8GUIStyle21DrawWithTextSelectionER8GUIStateRK5RectTIfER10GUIContentbbbbbiiRK10ColorRGBAfSA_(i5, i6, i1, i11, i2, i3, i4, i12, i13, i14, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, f23 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 f23 = Math_fround(HEAPF32[i1 >> 2]);
 f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i5 + 276 >> 2]);
 i21 = f20 != Math_fround(0.0);
 f19 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 280 >> 2]);
 i18 = f17 != Math_fround(0.0);
 f16 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 HEAPF32[i10 >> 2] = Math_fround(Math_floor(Math_fround(f23 + Math_fround(.5))));
 HEAPF32[i10 + 4 >> 2] = Math_fround(Math_floor(Math_fround(f22 + Math_fround(.5))));
 HEAPF32[i10 + 8 >> 2] = Math_fround(Math_floor(Math_fround((i21 ? f20 : f19) + Math_fround(.5))));
 HEAPF32[i10 + 12 >> 2] = Math_fround(Math_floor(Math_fround((i18 ? f17 : f16) + Math_fround(.5))));
 i1 = __ZNK8GUIStyle16GetGUIStyleStateER8GUIStatebbbb(i5, i6, i2, i3, i4, i12) | 0;
 __ZNK8GUIStyle14DrawBackgroundER8GUIStateRK5RectTIfEPK13GUIStyleState(i5, i6, i10, i1);
 if (!i12) {
  __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState(i5, i6, i10, i11, i1);
  STACKTOP = i15;
  return;
 }
 if (i13) {
  __ZNK8GUIStyle17DrawTextUnderlineER8GUIStateRK5RectTIfER10GUIContentiiPK13GUIStyleState(i5, i6, i10, i11, i14, i7, i1);
  __ZNK8GUIStyle17DrawTextSelectionER8GUIStateRK5RectTIfER10GUIContentiiRK10ColorRGBAfSA_(i5, i6, i10, i11, i7, i7, i8, i9);
  __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState(i5, i6, i10, i11, i1);
  STACKTOP = i15;
  return;
 } else {
  __ZNK8GUIStyle17DrawTextSelectionER8GUIStateRK5RectTIfER10GUIContentiiRK10ColorRGBAfSA_(i5, i6, i10, i11, i14, i7, i8, i9);
  __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState(i5, i6, i10, i11, i1);
  STACKTOP = i15;
  return;
 }
}

function __ZN9BlobWrite8TransferIN4math4AxesEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN4math4Axes8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i5, i6, gb + 906532 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i5, i6 + 16 | 0, gb + 906546 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i6 + 32 | 0, gb + 906554 | 0, 0);
 __ZN9BlobWrite8TransferIN4math5LimitEEEvRT_PKc17TransferMetaFlags(i5, i6 + 44 | 0, gb + 906567 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 68 | 0, gb + 906581 | 0, 0);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i5, i6 + 72 | 0, gb + 913271 | 0, 0);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN8DrawUtil15DrawTextMeshRawERK14ChannelAssignsR4MeshR23DefaultMeshVertexFormat(i8, i2, i9) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i1 = i10;
 if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) != 18) {
  __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i2, i7, HEAP32[i8 >> 2] | 0, 0, 0) | 0;
  if (HEAP32[i7 >> 2] | 0) __ZN8DrawUtil18DrawMeshBuffersRawERK11MeshBuffersR4MeshRK14ChannelAssignsii(i7, i2, i8, 0, 0);
  STACKTOP = i10;
  return;
 }
 if ((HEAP16[gb + 1157808 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157808 | 0, i7);
  i4 = gb + 1157808 | 0;
 } else i4 = 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = 0;
 i6 = __ZN9GfxDevice13GetDynamicVBOEv(__Z12GetGfxDevicev() | 0) | 0;
 i1 = i2 + 32 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i2 = ((HEAP32[i11 + 116 >> 2] | 0) - (HEAP32[i11 + 112 >> 2] | 0) | 0) >>> 1;
 i11 = HEAP32[i11 + 100 >> 2] | 0;
 i3 = __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj(HEAP32[i9 >> 2] | 0, gb + 1546313 | 0, 0) | 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i3 | 0, i11 | 0, i2 | 0, 0, i7 | 0) | 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  _memcpy(HEAP32[i7 >> 2] | 0, HEAP32[i11 + 92 >> 2] | 0, Math_imul(HEAP32[i11 + 100 >> 2] | 0, i3) | 0) | 0;
  _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i2 << 1 | 0) | 0;
  mftCall_viiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i7 | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i2 | 0);
  i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
  i11 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = HEAP32[i11 + 4 >> 2] | 0;
  mftCall_viiiiiii(i3 | 0, i6 | 0, i7 | 0, i8 | 0, i5 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i11, HEAP32[i9 >> 2] | 0, 0) | 0, 0, 0);
  __Z15gpu_time_samplev();
 }
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i10;
 return;
}

function __ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii(i7, i1, i2, i3, i5, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 16 | 0;
 i6 = i11 + 8 | 0;
 i4 = i11;
 i9 = i11 + 24 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(HEAP32[i7 + 92 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400506 | 0, 0, gb + 397053 | 0, 252, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (i3 >>> 0 > 5) {
  HEAP32[i4 >> 2] = i3;
  __Z6FormatPKcz(i9, gb + 400531 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 397053 | 0, 257, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 172 >> 2] | 0, i7 | 0) | 0;
 if (!((i5 | 0) > -1 & (i1 | 0) > (i5 | 0))) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = i5;
  __Z6FormatPKcz(i9, gb + 400560 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 397053 | 0, 263, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 116 >> 2] | 0, i7 | 0) | 0;
 if ((i8 | 0) > -1 & (i1 | 0) > (i8 | 0)) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 4 >> 2] = i8;
 __Z6FormatPKcz(i9, gb + 400627 | 0, i10);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 397053 | 0, 269, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z56AnimatorOverrideController_CUSTOM_Internal_GetClipByNameP12Il2CppObjectP12Il2CppStringh(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i4 = i9 + 12 | 0;
 i7 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i4);
 i4 = __ZNK26AnimatorOverrideController7GetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i7, i3 << 24 >> 24 != 0) | 0;
 if (!i4) {
  i8 = 0;
  i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 12;
  }
 }
 if ((i8 | 0) == 10) i8 = 12;
 if ((i8 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i8 = i1;
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return i8 | 0;
}

function _cf2_computeDarkening(i15, i14, i3, i16, i17, i1, i2) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 HEAP32[i16 >> 2] = 0;
 i1 = i1 << 24 >> 24 != 0;
 if ((i15 | 0) < 655 | ((i17 | 0) != 0 | i1) ^ 1) return;
 if (i1) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = HEAP32[i2 + 8 >> 2] | 0;
  i8 = HEAP32[i2 + 12 >> 2] | 0;
  i9 = HEAP32[i2 + 16 >> 2] | 0;
  i13 = HEAP32[i2 + 20 >> 2] | 0;
  i10 = HEAP32[i2 + 24 >> 2] | 0;
  i12 = HEAP32[i2 + 28 >> 2] | 0;
  i11 = _UNITY_FT_MulFix(i17 + i3 | 0, i15) | 0;
  i3 = _FT_MSB(i11) | 0;
  if (((_FT_MSB(i14) | 0) + i3 | 0) > 45) i2 = i10 << 16; else i2 = _UNITY_FT_MulFix(i11, i14) | 0;
  i1 = i4 << 16;
  L10 : do if ((i2 | 0) < (i1 | 0)) {
   i1 = _UNITY_FT_DivFix(i5 << 16, i14) | 0;
   HEAP32[i16 >> 2] = i1;
  } else {
   i3 = i6 << 16;
   if ((i2 | 0) < (i3 | 0)) {
    i2 = i6 - i4 | 0;
    i1 = _UNITY_FT_DivFix(i1, i14) | 0;
    if (!i2) i7 = 12; else {
     i1 = _UNITY_FT_MulDiv(i11 - i1 | 0, i8 - i5 | 0, i2) | 0;
     i1 = (_UNITY_FT_DivFix(i5 << 16, i14) | 0) + i1 | 0;
     HEAP32[i16 >> 2] = i1;
     break;
    }
   } else {
    i1 = i9 << 16;
    if ((i2 | 0) < (i1 | 0)) i7 = 12; else if ((i2 | 0) < (i10 << 16 | 0)) i7 = 16;
   }
   do if ((i7 | 0) == 12) {
    i2 = i9 - i6 | 0;
    i1 = _UNITY_FT_DivFix(i3, i14) | 0;
    if (!i2) {
     i1 = i9 << 16;
     i7 = 16;
     break;
    } else {
     i1 = _UNITY_FT_MulDiv(i11 - i1 | 0, i13 - i8 | 0, i2) | 0;
     i1 = (_UNITY_FT_DivFix(i8 << 16, i14) | 0) + i1 | 0;
     HEAP32[i16 >> 2] = i1;
     break L10;
    }
   } while (0);
   if ((i7 | 0) == 16) {
    i2 = i10 - i9 | 0;
    i1 = _UNITY_FT_DivFix(i1, i14) | 0;
    if (i2 | 0) {
     i1 = _UNITY_FT_MulDiv(i11 - i1 | 0, i12 - i13 | 0, i2) | 0;
     i1 = (_UNITY_FT_DivFix(i13 << 16, i14) | 0) + i1 | 0;
     HEAP32[i16 >> 2] = i1;
     break;
    }
   }
   i1 = _UNITY_FT_DivFix(i12 << 16, i14) | 0;
   HEAP32[i16 >> 2] = i1;
  } while (0);
  i1 = _UNITY_FT_DivFix(i1, i15 << 1) | 0;
  HEAP32[i16 >> 2] = i1;
 } else i1 = 0;
 HEAP32[i16 >> 2] = i1 + ((i17 | 0) / 2 | 0);
 return;
}

function __ZN9ShaderLab27SerializedShaderVectorValue8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085989 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085998 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1084342 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085899 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1037646 | 0, gb + 469407 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN9JSONWrite8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i10, i11, 0);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_17PxHeightFieldDescEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 212 | 0;
 i14 = i11 + 160 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i15 = i11 + 36 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx30PxHeightFieldDescGeneratedInfoC2Ev(i15);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i5;
 HEAP32[i14 + 24 >> 2] = i4;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i13;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 36, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb(i6, i4, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = i6 + 156 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (i3) {
  if (i2) {
   i2 = i4 + 292 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i3 = i4 + 280 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i4 = i4 + 284 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  }
  i2 = i1;
  i3 = i2 + 60 | 0;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP8[i1 + 31 >> 0] = 1;
  HEAP8[i1 + 28 >> 0] = i5 & 1;
  i4 = i6 + 120 | 0;
  HEAP32[i1 + 48 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i6 + 124 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i6 + 128 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i6 + 132 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i6 + 136 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i6 + 140 >> 2];
  i5 = i6 + 112 | 0;
  HEAP32[i1 + 56 >> 2] = HEAP32[i5 >> 2];
  i6 = i6 + 116 | 0;
  HEAP32[i1 + 60 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAPF32[i5 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i6 = i1;
  HEAP32[i7 >> 2] = i6;
  return 1;
 } else {
  if (i2) {
   i2 = i4 + 292 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i6 = i4 + 280 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i6 = i4 + 284 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  }
  i2 = i1;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i6 = i1;
  HEAP32[i7 >> 2] = i6;
  return 1;
 }
 return 0;
}

function __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_R4Mesh(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10 + 8 | 0;
 i13 = i10;
 i6 = i10 + 36 | 0;
 i9 = i10 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i3 = i14;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i13;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i3 = i9 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i8;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, i9, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i2 = __Z11GetIPhysicsv() | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) HEAP32[i11 + 8 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 1, HEAP32[i6 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i11 + 12 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 0, HEAP32[i9 >> 2] | 0, i1 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
  HEAP32[i9 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_R4Mesh(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10 + 8 | 0;
 i13 = i10;
 i6 = i10 + 36 | 0;
 i9 = i10 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i3 = i14;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i13;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i3 = i9 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i8;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, i9, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i2 = __Z11GetIPhysicsv() | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) HEAP32[i11 + 8 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 1, HEAP32[i6 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i11 + 12 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, 0, HEAP32[i9 >> 2] | 0, i1 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
  HEAP32[i9 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i5, i9) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i2 + 24 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 i4 = __Z14SkipPathPrefixPKcS0_jb(i5, i3, i1, 0) | 0;
 i5 = _strlen(i4) | 0;
 i8 = i9 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i5 >>> 0 > i3 >>> 0) {
  i1 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i5 - i3 | 0, i1, 0, i1, i5, i4);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
  if (i5 | 0) _memmove(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  i1 = HEAP8[i8 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   HEAP32[i9 + 4 >> 2] = i5;
   break;
  } else {
   i1 = i5 & 255;
   HEAP8[i8 >> 0] = i1;
   break;
  }
 } while (0);
 i4 = i1 << 24 >> 24 < 0;
 i7 = i9 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = i4 ? i3 : i1 & 255;
 do if (!i2) {
  i6 = i9;
  i4 = i9;
 } else {
  i5 = i2 + -1 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((HEAP8[(i4 ? i2 : i9) + i5 >> 0] | 0) == 47) if (i4) {
   HEAP8[i2 + i5 >> 0] = 0;
   HEAP32[i7 >> 2] = i5;
   i6 = i9;
   i4 = i9;
   i1 = HEAP8[i8 >> 0] | 0;
   i3 = i5;
   break;
  } else {
   HEAP8[i9 + i5 >> 0] = 0;
   i1 = i5 & 255;
   HEAP8[i8 >> 0] = i1;
   i6 = i9;
   i4 = i9;
   i3 = HEAP32[i7 >> 2] | 0;
   break;
  } else {
   i6 = i9;
   i4 = i9;
  }
 } while (0);
 i2 = i1 << 24 >> 24 < 0;
 if (!((i2 ? i3 : i1 & 255) | 0)) return;
 i1 = i2 ? HEAP32[i6 >> 2] | 0 : i4;
 do {
  i5 = HEAP8[i1 >> 0] | 0;
  i9 = i5 << 24 >> 24;
  HEAP8[i1 >> 0] = (i5 + -65 & 255) < 26 ? i9 + 32 | 0 : i9;
  i1 = i1 + 1 | 0;
  i9 = HEAP8[i8 >> 0] | 0;
  i5 = i9 << 24 >> 24 < 0;
 } while ((i1 | 0) != ((i5 ? HEAP32[i6 >> 2] | 0 : i4) + (i5 ? HEAP32[i7 >> 2] | 0 : i9 & 255) | 0));
 return;
}

function __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 4 | 0, i7);
 i8 = i6 + 56 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i7, (HEAP32[i8 >> 2] | 0) + 8 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i7, (HEAP32[i8 >> 2] | 0) + 28 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i7);
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i9, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 28 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i9, 4);
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 36 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 36 | 0;
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, _llvm_bswap_i32(i1 | 0) | 0, i5 + 8 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 6) | 0;
 if (!i4) i1 = 0; else {
  do {
   __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 64) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, _llvm_bswap_i32(i1 | 0) | 0, i5 + 8 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 4) | 0;
 if (!i4) i1 = 0; else {
  do {
   __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _UNITY_tt_face_load_name(i13, i14) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16 + 4 | 0;
 i2 = i16;
 i4 = HEAP32[i14 + 28 >> 2] | 0;
 HEAP32[i13 + 360 >> 2] = i14;
 i1 = mftCall_iiiii(HEAP32[i13 + 508 >> 2] | 0, i13 | 0, 1851878757, i14 | 0, i2 | 0) | 0;
 HEAP32[i15 >> 2] = i1;
 if (i1 | 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i11 = _UNITY_FT_Stream_Pos(i14) | 0;
 i1 = _UNITY_FT_Stream_ReadFields(i14, gb + 223416 | 0, i13 + 344 | 0) | 0;
 HEAP32[i15 >> 2] = i1;
 if (i1 | 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i12 = i13 + 348 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i3 = i5 * 12 | 0;
 i9 = i11 + 6 + i3 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + i11 | 0;
 if (i9 >>> 0 > i8 >>> 0) {
  HEAP32[i15 >> 2] = 145;
  i15 = 145;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i12 >> 2] = 0;
 i10 = i13 + 356 | 0;
 HEAP32[i10 >> 2] = _UNITY_ft_mem_realloc(i4, 20, 0, i5, 0, i15) | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = _UNITY_FT_Stream_EnterFrame(i14, i3) | 0;
 HEAP32[i15 >> 2] = i1;
 if (i1 | 0) {
  i15 = i1;
  STACKTOP = i16;
  return i15 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i5) i2 = i1; else {
  i7 = i13 + 352 | 0;
  i6 = i5;
  i2 = i1;
  do {
   i5 = _UNITY_FT_Stream_ReadFields(i14, gb + 223436 | 0, i2) | 0;
   HEAP32[i15 >> 2] = i5;
   do if (!i5) {
    i1 = i2 + 8 | 0;
    i3 = HEAP16[i1 >> 1] | 0;
    if (i3 << 16 >> 16) {
     i4 = i2 + 12 | 0;
     i5 = (HEAP32[i7 >> 2] | 0) + i11 + (HEAP32[i4 >> 2] | 0) | 0;
     HEAP32[i4 >> 2] = i5;
     if (i5 >>> 0 >= i9 >>> 0) if (((i3 & 65535) + i5 | 0) >>> 0 <= i8 >>> 0) {
      i2 = i2 + 20 | 0;
      break;
     }
     HEAP32[i4 >> 2] = 0;
     HEAP16[i1 >> 1] = 0;
    }
   } while (0);
   i6 = i6 + -1 | 0;
  } while ((i6 | 0) != 0);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = (i2 - i1 | 0) / 20 | 0;
 _UNITY_FT_Stream_ExitFrame(i14);
 HEAP16[i13 + 340 >> 1] = HEAP32[i12 >> 2];
 i15 = HEAP32[i15 >> 2] | 0;
 STACKTOP = i16;
 return i15 | 0;
}

function __ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[(HEAP32[i9 + 16 >> 2] | 0) + 8 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + 8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i10 = (i2 | 0) > (i1 | 0);
  return i10 | 0;
 }
 i1 = HEAP32[i9 + 12 >> 2] | 0;
 i2 = (i1 & 65535) << 16 >> 16 == 4;
 i7 = i1 >>> 24 & 255;
 i8 = i1 >>> 16 & 255;
 i3 = HEAP32[i10 + 12 >> 2] | 0;
 i4 = (i3 & 65535) << 16 >> 16 == 4;
 if (i2 & i4) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  L7 : do if ((i2 | 0) != (i1 | 0)) {
   switch (i2 | 0) {
   case 2:
   case 4:
    {
     switch (i1 | 0) {
     case 2:
     case 4:
      break L7;
     default:
      {}
     }
     switch (i2 | 0) {
     case 2:
     case 4:
      {
       i2 = 2;
       break;
      }
     default:
      i5 = 8;
     }
     break;
    }
   default:
    i5 = 8;
   }
   switch (i1 | 0) {
   case 2:
   case 4:
    {
     i1 = 2;
     break;
    }
   default:
    {}
   }
   i10 = i2 >>> 0 < i1 >>> 0;
   return i10 | 0;
  } while (0);
  i10 = (HEAP32[i9 >> 2] | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0;
  return i10 | 0;
 }
 i5 = i3 >>> 24 & 255;
 i6 = i3 >>> 16 & 255;
 i2 = i2 ? -1 : i1 & 65535;
 i1 = i4 ? -1 : i3 & 65535;
 if ((i2 | 0) != (i1 | 0)) {
  i10 = (i2 | 0) < (i1 | 0);
  return i10 | 0;
 }
 if (i7 << 24 >> 24 != i5 << 24 >> 24) {
  i10 = (i7 & 255) < (i5 & 255);
  return i10 | 0;
 }
 if (i8 << 24 >> 24 != i6 << 24 >> 24) {
  i10 = (i8 & 255) < (i6 & 255);
  return i10 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i10 = i1 >>> 0 < i2 >>> 0;
  return i10 | 0;
 }
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 i2 = HEAP32[i10 + 8 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i10 = (i1 | 0) < (i2 | 0);
  return i10 | 0;
 }
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 switch (i1 | 0) {
 case 2:
 case 4:
  {
   i2 = 2;
   break;
  }
 default:
  i2 = i1;
 }
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 switch (i1 | 0) {
 case 2:
 case 4:
  {
   i1 = 2;
   break;
  }
 default:
  {}
 }
 i10 = i2 >>> 0 < i1 >>> 0;
 return i10 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f17 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i13 = i16 + 24 | 0;
 i15 = HEAP32[i13 >> 2] | 0;
 f17 = Math_fround(i1 >>> 0);
 i14 = ~~Math_fround(f17 * Math_fround(HEAPF32[i16 + 32 >> 2])) >>> 0;
 i4 = i1 << 2;
 i3 = (i14 << 2) + i4 | 0;
 i3 = (0 - i3 & 12) + i3 | 0;
 i2 = i3 + (i14 << 3) | 0;
 if (!i2) i11 = 0; else {
  i11 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  i11 = mftCall_iiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i2 | 0, HEAP32[i16 + 4 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 }
 i12 = i11 + i4 | 0;
 i10 = i11 + i3 | 0;
 _memset(i11 | 0, -1, i4 | 0) | 0;
 i6 = i16 + 44 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i1 + -1 | 0;
  i5 = HEAP32[i16 + 12 >> 2] | 0;
  i9 = 0;
  do {
   i3 = HEAP32[i5 + (i9 << 3) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i8 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i11 + ((i2 & i7) << 2) | 0;
   HEAP32[i12 + (i9 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i9;
   HEAP32[i10 + (i9 << 3) >> 2] = i8;
   HEAP32[i10 + (i9 << 3) + 4 >> 2] = HEAP32[i5 + (i9 << 3) + 4 >> 2];
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i2 = i16 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i9 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i11;
 HEAP32[i16 + 20 >> 2] = i11;
 HEAP32[i16 + 28 >> 2] = i1;
 HEAP32[i16 + 16 >> 2] = i12;
 HEAP32[i16 + 12 >> 2] = i10;
 HEAP32[i13 >> 2] = i14;
 i1 = i16 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i15;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 76 | 0, 4) | 0;
  i2 = i4 + (i1 * 76 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAPF32[i1 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
    HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
    HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 60 >> 2] = Math_fround(-1.0);
    HEAPF32[i1 + 64 >> 2] = Math_fround(-1.0);
    HEAP32[i1 + 68 >> 2] = 1065353216;
    HEAP32[i1 + 72 >> 2] = 3;
    i1 = i1 + 76 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i6 * 76 | 0) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN4math4Axes8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 76 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEiP11Il2CppArrayRKT_i(i11, i6, i1) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 8 | 0;
 i8 = i14;
 i9 = i6 + 12 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i8 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i10 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i15 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 10; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i10 = 12;
     }
    }
    if ((i10 | 0) == 10) i10 = 12;
    if ((i10 | 0) == 12) {
     i10 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i11, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i11, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return i12 | 0;
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0, i20 = 0, i21 = 0;
 i21 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f4 * f11);
 f16 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f17 * f16));
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f19 * f14));
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f12 = Math_fround(f4 * f9);
 f15 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f17 * f15));
 f13 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f19 * f13));
 f7 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f4 = Math_fround(f4 * f7);
 f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f17 = Math_fround(f4 + Math_fround(f17 * f5));
 f4 = Math_fround(HEAPF32[i3 + 40 >> 2]);
 i20 = f10 > Math_fround(0.0);
 i18 = f12 > Math_fround(0.0);
 i2 = Math_fround(f17 + Math_fround(f19 * f4)) > Math_fround(0.0);
 f19 = Math_fround(HEAPF32[i21 + 144 >> 2]);
 f17 = Math_fround(HEAPF32[i21 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i21 + 152 >> 2]);
 f10 = Math_fround(-f19);
 f8 = Math_fround(-f17);
 f6 = Math_fround(-f12);
 f10 = i20 ? f19 : f10;
 f8 = i18 ? f17 : f8;
 f6 = i2 ? f12 : f6;
 f12 = Math_fround(HEAPF32[i3 + 48 >> 2]);
 f17 = Math_fround(HEAPF32[i3 + 52 >> 2]);
 f5 = Math_fround(f17 + Math_fround(Math_fround(Math_fround(f16 * f10) + Math_fround(f15 * f8)) + Math_fround(f5 * f6)));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) + Math_fround(Math_fround(Math_fround(f14 * f10) + Math_fround(f13 * f8)) + Math_fround(f4 * f6)));
 HEAPF32[i1 >> 2] = Math_fround(f12 + Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f8)) + Math_fround(f7 * f6)));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN29AssetBundleLoadAssetOperation14GetLoadedAssetEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i7 = i9;
 i8 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 + 160 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i7);
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if ((HEAP16[gb + 1104148 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104148 | 0, i5);
  i2 = gb + 1104148 | 0;
 } else i2 = 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i8 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i7);
 i10 = i5;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 __ZN29AssetBundleLoadAssetOperation15GetLoadedAssetsER13dynamic_arrayIP6ObjectLj4EEb(i6, i8, 1);
 if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i4);
  HEAP32[i8 >> 2] = 0;
 }
 if (!i2) {
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN25CapsuleTraceSegmentReport7onEventEjPj(i13, i5, i10) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0, f15 = f0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 2352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 48 | 0;
 i8 = i14 + 40 | 0;
 i11 = i14 + 28 | 0;
 i9 = i14 + 16 | 0;
 i6 = i14 + 4 | 0;
 i12 = i14;
 i4 = i14 + 44 | 0;
 if (i5 | 0) {
  i1 = i13 + 32 | 0;
  i2 = i13 + 28 | 0;
  i3 = 0;
  do {
   __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i7 + (i3 * 36 | 0) | 0, 0, 0, HEAP32[i10 + (i3 << 2) >> 2] | 0, 1, 1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 }
 HEAP32[i8 >> 2] = -1;
 HEAPF32[i12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i16 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = HEAP32[i13 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 i1 = i13 + 16 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP16[i4 >> 1] = HEAP16[HEAP32[i13 + 20 >> 2] >> 1] | 0;
 do if (__ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE(i5, i7, i16, i2, f15, 0, i3, i12, i11, i9, i8, i6, i4, (HEAP8[i13 + 36 >> 0] | 0) != 0, 0) | 0) {
  f15 = Math_fround(HEAPF32[i12 >> 2]);
  i1 = HEAP32[i1 >> 2] | 0;
  if (f15 <= Math_fround(HEAPF32[i1 + 40 >> 2])) {
   HEAP32[i1 + 8 >> 2] = HEAP32[i10 + (HEAP32[i8 >> 2] << 2) >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i12 >> 2];
   HEAP8[i13 + 24 >> 0] = 1;
   if (Math_fround(HEAPF32[i12 >> 2]) == Math_fround(0.0)) {
    HEAP8[i13 + 25 >> 0] = 1;
    i16 = 0;
    STACKTOP = i14;
    return i16 | 0;
   } else {
    if (!(HEAP8[i13 + 37 >> 0] | 0)) break; else i1 = 0;
    STACKTOP = i14;
    return i1 | 0;
   }
  }
 } while (0);
 i16 = 1;
 STACKTOP = i14;
 return i16 | 0;
}

function __ZN9JSONWrite8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite10SetVersionEi(i10, 2);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i10, i11, gb + 1048690 | 0, 4194305);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN7mecanim9animation9DenseClip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899065 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899078 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898090 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899091 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1 + 20;
 HEAP32[i7 + 4 >> 2] = i1 + 16;
 HEAP32[i7 + 8 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899103 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i3 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 36, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i(i11, i6, i1) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 8 | 0;
 i8 = i14;
 i9 = i6 + 12 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i8 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i10 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i15 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 10; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i10 = 12;
     }
    }
    if ((i10 | 0) == 10) i10 = 12;
    if ((i10 | 0) == 12) {
     i10 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i11, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i11, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return i12 | 0;
}

function __ZN9ShaderLab22SerializedBindChannels4BindE13ShaderChannel15VertexComponentbP12ShaderErrors(i8, i9, i10, i1, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i3 = i11 + 8 | 0;
 if (i1) if (!((i10 | i9 | 0) == 0 | ((i10 | 0) == -1 | (i10 + -12 | 0) >>> 0 < 16))) if (!((i9 | 0) == 1 & (i10 | 0) == 2)) if (!((i9 | 0) == 2 & (i10 | 0) == 1)) if (!((i9 + -3 | 0) >>> 0 < 5 & (i10 + -3 | 0) >>> 0 < 9)) {
  HEAP32[i4 >> 2] = i9;
  HEAP32[i4 + 4 >> 2] = i10;
  __Z6FormatPKcz(i3, gb + 478009 | 0, i4);
  __ZN12ShaderErrors21AddShaderCompileErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEib(i2, i3, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i11;
  return;
 }
 L9 : do if ((i10 | 0) != -1) {
  i6 = i8 + 12 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  L11 : do if (i7 | 0) {
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i10 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i7 | 0)) break L11;
   }
   HEAP32[i2 + (i1 << 3) >> 2] = i9;
   break L9;
  } while (0);
  i2 = i7 + 1 | 0;
  i3 = i8 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i2 >>> 0 > i5 >>> 0) {
   i1 = i4 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i1;
    HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    HEAP32[i8 >> 2] = i5;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i2;
  i7 = (HEAP32[i8 >> 2] | 0) + (i7 << 3) | 0;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i7 + 4 >> 2] = i10;
 } while (0);
 i10 = i8 + 20 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << i9;
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab21SerializedBindChannel8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i8 = i9 + 4 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i8 >> 0] = i1;
 i5 = HEAP32[gb + 37252 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 670513 | 0, i5, i6, 0) | 0;
 if (i2) {
  do if ((i2 | 0) > 0) {
   i1 = i7 + 16 | 0;
   i3 = HEAP32[i7 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i3 >>> 0) {
    i3 = i2 + 1 | 0;
    if (i3 >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
     HEAP8[i8 >> 0] = HEAP8[i2 >> 0] | 0;
     HEAP32[i1 >> 2] = i3;
     break;
    }
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 HEAP32[i4 >> 2] = i1 << 24 >> 24;
 i4 = i4 + 4 | 0;
 i2 = HEAP32[i4 >> 2] & 255;
 HEAP8[i8 >> 0] = i2;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 670520 | 0, i5, i6, 0) | 0;
 if (!i1) {
  i8 = i2;
  i8 = i8 << 24 >> 24;
  HEAP32[i4 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i6 >>> 0) {
   i3 = i2 + 1 | 0;
   if (i3 >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i8 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = i3;
    break;
   }
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 i8 = HEAP8[i8 >> 0] | 0;
 i8 = i8 << 24 >> 24;
 HEAP32[i4 >> 2] = i8;
 STACKTOP = i9;
 return;
}

function __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i1 = HEAP32[i10 + 1088 + (i8 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i9 = 0; else {
  i9 = i10 + 1712 | 0;
  i9 = HEAP32[(HEAP32[i9 >> 2] | 0) + i9 + (i1 << 3) >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i7 = 0; else {
  i7 = i10 + 1712 | 0;
  i7 = HEAP32[(HEAP32[i7 >> 2] | 0) + i7 + (i1 << 3) >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 2 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 0; else {
  i6 = i10 + 1712 | 0;
  i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (i1 << 3) >> 2] | 0;
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 3 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f5 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 4 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f4 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f4 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 5 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else {
  i12 = i10 + 1712 | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) >> 2]);
 }
 i1 = HEAP32[i10 + 1088 + (i8 + 6 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f2 = Math_fround(1.0); else {
  i12 = i10 + 1712 | 0;
  f2 = Math_fround(HEAPF32[(HEAP32[i12 >> 2] | 0) + i12 + (i1 << 3) >> 2]);
 }
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))))));
 f14 = Math_fround(f5 * f15);
 f13 = Math_fround(f4 * f15);
 f4 = Math_fround(f3 * f15);
 f5 = Math_fround(f2 * f15);
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i11 + 8 >> 2] = i6;
 HEAPF32[i11 + 12 >> 2] = f14;
 HEAPF32[i11 + 16 >> 2] = f13;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i11 + 24 >> 2] = f5;
 HEAP32[i11 + 28 >> 2] = 1065353216;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 * 12 | 0) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i9 + (i11 * 12 | 0) + 4 >> 2] | 0;
   i18 = i15 + ~(i15 << 15) | 0;
   i18 = (i18 >>> 10 ^ i18) * 9 | 0;
   i18 = i18 >>> 6 ^ i18;
   i18 = i18 + ~(i18 << 11) | 0;
   i16 = HEAP32[i9 + (i11 * 12 | 0) >> 2] | 0;
   i17 = i16 + ~(i16 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i5 + (((i18 >>> 16 ^ i18 ^ (i17 ^ -57320555 ^ i17 >>> 16) * 1000007) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i11;
   HEAP32[i7 + (i11 * 12 | 0) >> 2] = i16;
   HEAP32[i7 + (i11 * 12 | 0) + 4 >> 2] = i15;
   HEAP32[i7 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i9 + (i11 * 12 | 0) + 8 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 36, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx2Sc8ClothSim26removeCollisionHeightfieldEPKNS0_8ShapeSimE(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i8 = HEAP32[i10 + 104 >> 2] | 0;
 i1 = (HEAP32[i10 + 88 >> 2] | 0) + (HEAP32[i10 + 84 >> 2] | 0) + (HEAP32[i10 + 92 >> 2] | 0) + (HEAP32[i10 + 96 >> 2] | 0) + (HEAP32[i10 + 100 >> 2] | 0) + i8 | 0;
 i9 = i10 + 116 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i11 = i10 + 108 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 if (!i12) return; else i5 = 0;
 while (1) {
  i4 = i1 + i5 | 0;
  i2 = i7 + (i4 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break;
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i12 >>> 0) {
   i6 = 11;
   break;
  }
 }
 if ((i6 | 0) == 11) return;
 i1 = i4 + 1 | 0;
 i3 = i10 + 120 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 < i6 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
  i1 = i4 + 2 | 0;
  if (i1 >>> 0 < i6 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 HEAP32[i3 >> 2] = i6 + -1;
 i3 = i8 + i5 | 0;
 i1 = i3 + 1 | 0;
 i5 = i10 + 132 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 < i6 >>> 0) {
  i4 = HEAP32[i10 + 128 >> 2] | 0;
  i2 = i1;
  i1 = i4 + (i3 * 48 | 0) | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i4 + (i2 * 48 | 0) >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i4 + (i2 * 48 | 0) + 44 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + 48 | 0;
  }
 }
 HEAP32[i5 >> 2] = i6 + -1;
 HEAP32[i11 >> 2] = i12 + -1;
 return;
}

function __ZN19CharacterController16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, d12 = 0.0, d13 = 0.0, d14 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i6 + 24 | 0;
 i5 = i1 + 60 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 if (i2 & 8 | 0) {
  __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f7 = Math_fround(HEAPF32[i1 + 88 >> 2]);
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
  i8 = f7 < Math_fround(0.0);
  f9 = Math_fround(-f7);
  f7 = i8 ? f9 : f7;
  i8 = f7 < Math_fround(9.99999974e-06);
  f7 = i8 ? Math_fround(9.99999974e-06) : f7;
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  i8 = f9 < Math_fround(0.0);
  f10 = Math_fround(-f9);
  f9 = i8 ? f10 : f9;
  f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i8 = f10 < Math_fround(0.0);
  f11 = Math_fround(-f10);
  f10 = i8 ? f11 : f10;
  f9 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * (f9 < f10 ? f10 : f9));
  f7 = Math_fround(f7 - Math_fround(f9 * Math_fround(2.0)));
  i8 = f7 < Math_fround(9.99999974e-06);
  f7 = i8 ? Math_fround(9.99999974e-06) : f7;
  i8 = f9 < Math_fround(9.99999974e-06);
  f9 = i8 ? Math_fround(9.99999974e-06) : f9;
  i8 = HEAP32[i5 >> 2] | 0;
  mftCall_iif(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0, +f9) | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  mftCall_iif(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, i8 | 0, +f7) | 0;
 }
 if (!(i2 & 1)) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i1 + 96 | 0);
 d14 = +Math_fround(HEAPF32[i4 >> 2]);
 d13 = +Math_fround(HEAPF32[i4 + 4 >> 2]);
 d12 = +Math_fround(HEAPF32[i4 + 8 >> 2]);
 HEAPF64[i3 >> 3] = d14;
 HEAPF64[i3 + 8 >> 3] = d13;
 HEAPF64[i3 + 16 >> 3] = d12;
 mftCall_iii(i5 | 0, i8 | 0, i3 | 0) | 0;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab26SerializedShaderDependency8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i4 = i7 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i7 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i5;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i3 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i6 = i7 + 16 | 0;
 i5 = i6 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i7 + 20 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i8 >> 2] = i1;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i8 = i2 << 24 >> 24 < 0;
 i1 = i8 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i8 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN31CanvasBatchIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i11, i2, i3) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = HEAP32[i11 + 312 >> 2] | 0;
 if (!i12) {
  i12 = -1;
  return i12 | 0;
 }
 i1 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i2, i3) | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i3 = i3 + 12 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 if ((i2 + 24 | 0) >>> 0 > i4 >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i5, 32768);
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i9 = i4;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
 } else i9 = i5;
 i7 = (HEAP32[i5 >> 2] | 0) + i2 | 0;
 HEAP32[i6 >> 2] = i2 + 24;
 i5 = i10 + (i1 * 360 | 0) + 328 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP16[i10 + (i1 * 360 | 0) + 270 >> 1] = HEAP16[i11 + 296 >> 1] | 0;
 i8 = i12 * 36 | 0;
 i6 = i9 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + i8 | 0) >>> 0 > i4 >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i9, i8 >>> 0 < 32768 ? 32768 : i8);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = i2;
  i2 = i7;
 }
 i9 = (HEAP32[i9 >> 2] | 0) + i3 | 0;
 HEAP32[i6 >> 2] = i3 + i8;
 HEAP32[i10 + (i1 * 360 | 0) + 332 >> 2] = fb + 212;
 HEAP32[i10 + (i1 * 360 | 0) + 344 >> 2] = fb + 2372;
 i10 = HEAP32[i11 + 280 >> 2] | 0;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = i10;
 i10 = HEAP32[i11 + 284 >> 2] | 0;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i2 + 8 >> 2] = HEAP32[i11 + 288 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i11 + 292 >> 2];
 HEAP32[i2 + 16 >> 2] = i12;
 HEAP32[i2 + 20 >> 2] = i9;
 i2 = i11 + 300 | 0;
 _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, i8 | 0) | 0;
 if ((i12 | 0) <= 0) {
  i12 = i1;
  return i12 | 0;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = 0;
 do {
  i4 = HEAP32[i3 + (i2 * 36 | 0) + 32 >> 2] | 0;
  if (i4 | 0) {
   i11 = i4 + 4 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i12 | 0));
 return i1 | 0;
}

function __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf(i11, i12, i13, i2, i14, i15, i16, f17) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 f17 = Math_fround(f17);
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 if (!i13) return;
 if (!i2) {
  i1 = i11 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = i11 + 8 | 0;
  HEAP8[i1 >> 0] = 1;
  i10 = 5;
 } else {
  i1 = i11 + 8 | 0;
  if (HEAP8[i1 >> 0] | 0) i10 = 5;
 }
 if ((i10 | 0) == 5) if (!(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0) | 0)) HEAP8[i1 >> 0] = 0;
 if (f17 > Math_fround(0.0)) mftCall_viiiiii(HEAP32[i11 >> 2] | 0, i12 | 0, i13 | 0, i2 | 0, i14 | 0, i15 | 0, i16 | 0);
 i6 = HEAP32[i13 + 8 >> 2] | 0;
 i5 = i6 + 16 | 0;
 i6 = i6 + 28 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i7 = i11 + 16 | 0;
 i8 = i11 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = 0;
 do {
  i9 = i2 + 4 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i10 = ___muldi3(i1 | 0, 0, 1419247029, 275155412) | 0;
  i19 = getTempRet0() | 0;
  i21 = i4;
  i4 = i4 + 1 | 0;
  i20 = _bitshift64Shl(i10 | 0, i19 | 0, i4 | 0) | 0;
  i18 = getTempRet0() | 0;
  i21 = _bitshift64Lshr(i10 | 0, i19 | 0, 63 - i21 | 0) | 0;
  i18 = getTempRet0() | 0 | i18;
  i19 = i7;
  i18 = i18 ^ HEAP32[i19 + 4 >> 2];
  i10 = i7;
  HEAP32[i10 >> 2] = (i21 | i20) ^ HEAP32[i19 >> 2];
  HEAP32[i10 + 4 >> 2] = i18;
  if (!i1) i10 = 15; else if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == 1) if (!(HEAP8[i8 >> 0] | 0)) i10 = 15; else {
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   i10 = 17;
  } else i10 = 15;
  if ((i10 | 0) == 15) {
   i10 = 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) > 0) {
    f3 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    i10 = 17;
   }
  }
  if ((i10 | 0) == 17) __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf(i11, i12, HEAP32[i9 >> 2] | 0, i13, i14, i15, i16, Math_fround(f3 * f17));
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != ((HEAP32[i5 >> 2] | 0) + (HEAP32[i6 >> 2] << 3) | 0));
 return;
}

function __ZN20ExternalForcesModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, i17 = 0, i18 = 0, i19 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = __ZN11WindManager7GetListEv(__ZN11WindManager11GetInstanceEv() | 0) | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i3;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i14;
  return;
 }
 i12 = i2 + 432 | 0;
 i13 = i10 + 48 | 0;
 i5 = i10 + 52 | 0;
 i6 = i10 + 56 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10 + 36 | 0;
 i9 = i10 + 40 | 0;
 i4 = i2 + 440 | 0;
 i2 = 0;
 while (1) {
  i17 = HEAP32[i3 + 8 >> 2] | 0;
  i15 = HEAP32[i12 >> 2] | 0;
  __ZNK9Transform21GetLocalToWorldMatrixEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i17 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i18 = HEAP32[i5 >> 2] | 0;
  i19 = HEAP32[i6 >> 2] | 0;
  HEAP32[i15 + (i2 * 40 | 0) >> 2] = HEAP32[i13 >> 2];
  HEAP32[i15 + (i2 * 40 | 0) + 4 >> 2] = i18;
  HEAP32[i15 + (i2 * 40 | 0) + 8 >> 2] = i19;
  i19 = HEAP32[i8 >> 2] | 0;
  i18 = HEAP32[i9 >> 2] | 0;
  HEAP32[i15 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i15 + (i2 * 40 | 0) + 16 >> 2] = i19;
  HEAP32[i15 + (i2 * 40 | 0) + 20 >> 2] = i18;
  HEAP32[i15 + (i2 * 40 | 0) + 24 >> 2] = HEAP32[i17 + 36 >> 2];
  HEAP32[i15 + (i2 * 40 | 0) + 28 >> 2] = HEAP32[i17 + 40 >> 2];
  f16 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(3.14159274));
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i17 + 56 >> 2]));
  f16 = Math_fround(Math_fround(Math_fround(Math_fround(+Math_cos(+f16)) + Math_fround(+Math_cos(+Math_fround(f16 * Math_fround(.375))))) + Math_fround(+Math_cos(+Math_fround(f16 * Math_fround(.0500000007))))) * Math_fround(.333000004));
  f16 = Math_fround(Math_fround(Math_fround(HEAPF32[i17 + 52 >> 2]) * f16) + Math_fround(1.0));
  HEAPF32[i15 + (i2 * 40 | 0) + 32 >> 2] = Math_fround(Math_fround(HEAPF32[i17 + 44 >> 2]) * f16);
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i3;
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 1 | 0;
 }
 STACKTOP = i14;
 return;
}

function __ZN12_GLOBAL__N_110DataStream21beginSetPropertyValueEPKvPKcRKN5physx8debugger14NamespacedNameE(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i4 + 204 >> 2] = 1;
 i7 = HEAP32[i4 + 64 >> 2] | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, i11 | 0, i1 | 0);
 i11 = i9 + 4 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i4 + 240 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i4 + 248 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i4 + 252 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i4 + 256 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i4 + 260 >> 2] = HEAP32[i9 + 24 >> 2];
 i8 = i4 + 264 | 0;
 i10 = i9 + 28 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 276 >> 2] = HEAP32[i9 + 40 >> 2];
 HEAP32[i4 + 280 >> 2] = HEAP32[i9 + 44 >> 2];
 i8 = i4 + 284 | 0;
 i10 = i9 + 48 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i4 + 296 >> 2] = HEAP32[i9 + 60 >> 2];
 HEAP32[i4 + 300 >> 2] = HEAP32[i9 + 64 >> 2];
 i8 = i4 + 304 | 0;
 i9 = HEAP16[i9 + 68 >> 1] | 0;
 HEAP8[i8 >> 0] = i9;
 HEAP8[i8 + 1 >> 0] = i9 >> 8;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 i3 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i4, i3) | 0;
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i4, HEAP32[i1 >> 2] | 0) | 0;
 i1 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i4, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = gb + 150220 + 8;
 i8 = i6 + 8 | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i3;
 i3 = i6 + 20 | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i4, i6, 8);
 STACKTOP = i5;
 return (HEAPU8[i4 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN11Rigidbody2D11SetPositionERK8Vector2f(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = i7 + 92 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f10 < Math_fround(-1.0e6);
 i5 = f10 > Math_fround(1.0e6);
 f10 = i5 ? Math_fround(1.0e6) : f10;
 f10 = i6 ? Math_fround(-1.0e6) : f10;
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i1 = f9 < Math_fround(-1.0e6);
 i6 = f9 > Math_fround(1.0e6);
 f9 = i6 ? Math_fround(1.0e6) : f9;
 f9 = i1 ? Math_fround(-1.0e6) : f9;
 HEAPF32[i2 >> 2] = f10;
 HEAPF32[i2 + 4 >> 2] = f9;
 __ZN6b2Body12SetTransformERK6b2Vec2f(i4, i2, Math_fround(HEAPF32[i4 + 56 >> 2]));
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i6 = i1 + 64 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = i7 + 226 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  HEAP8[i1 >> 0] = 0;
  i3 = i7 + 124 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i1 + 92 >> 2] | 0;
  if (i6 | 0) {
   i4 = HEAP32[i7 + 212 >> 2] | 0;
   i5 = HEAP32[i7 + 216 >> 2] | 0;
   if (HEAP32[i6 >> 2] | 0) {
    f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    f9 = Math_fround(f9 * f9);
    f10 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
    if (Math_fround(f9 + Math_fround(f10 * f10)) > Math_fround(0.0)) {
     i1 = i6 + 4 | 0;
     i2 = HEAPU16[i1 >> 1] | 0;
     if (!(i2 & 2)) {
      HEAP16[i1 >> 1] = i2 | 2;
      HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
     }
    }
    HEAP32[i6 + 64 >> 2] = i4;
    HEAP32[i6 + 68 >> 2] = i5;
    i1 = HEAP32[i3 >> 2] | 0;
   }
   HEAP32[i6 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
  }
 }
 HEAP8[i7 + 225 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZNSt3__23mapINS_4pairIPcS2_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS_9allocatorINS1_IKS3_S8_EEEEEixERSE_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i2 = i10 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = 16;
 } else {
  i7 = i9 + 4 | 0;
  while (1) {
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = i1 + 16 | 0;
   i5 = i1 + 20 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = __Z6StrCmpPKcS0_(HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (!i2) i2 = __Z6StrCmpPKcS0_(i4, i3) | 0;
   if ((i2 | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = 7;
     break;
    } else i1 = i2;
   } else {
    i3 = HEAP32[i5 >> 2] | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    i2 = __Z6StrCmpPKcS0_(HEAP32[i6 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
    if (!i2) i2 = __Z6StrCmpPKcS0_(i3, i4) | 0;
    if ((i2 | 0) >= 0) {
     i3 = 14;
     break;
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = 13;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 7) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i3 | 0) == 13) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i3 | 0) == 14) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i2 = i8;
   i3 = 16;
   break;
  }
 } while (0);
 if ((i3 | 0) == 16) if (i1) {
  i10 = i1;
  i10 = i10 + 24 | 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = __Znwj(28) | 0;
 i8 = i9;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i10 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 + 4 >> 2] | 0, i1);
 i10 = i10 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i3;
 i10 = i10 + 24 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNSt3__213move_backwardIP10InputEventS1_S2_RS1_PS2_iLi0EEENS_16__deque_iteratorIT0_T1_T2_T3_T4_XT5_EEET_SC_SB_PNS_9enable_ifIXsr27__is_random_access_iteratorISC_EE5valueEvE4typeE(i9, i10, i2, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 if ((i2 | 0) == (i10 | 0)) {
  i10 = i11;
  i8 = i10;
  i8 = HEAP32[i8 >> 2] | 0;
  i10 = i10 + 4 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i9;
  i9 = i11;
  HEAP32[i9 >> 2] = i8;
  i11 = i11 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  return;
 }
 i7 = i10;
 i8 = i11 + 4 | 0;
 do {
  i4 = i11;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  i4 = (HEAP32[i4 + 4 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
  i1 = (i4 | 0) / 52 | 0;
  i3 = i1 + -1 | 0;
  if ((i4 | 0) > 52) {
   i4 = i6 + (((i3 >>> 0) / 78 | 0) << 2) | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + (((i3 >>> 0) % 78 | 0) * 52 | 0) | 0;
  } else {
   i1 = 78 - i1 | 0;
   i4 = i6 + (((i1 | 0) / -78 | 0) << 2) | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + ((77 - ((i1 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
  }
  i3 = i1 + 52 | 0;
  i12 = (i3 - (HEAP32[i4 >> 2] | 0) | 0) / 52 | 0;
  i4 = (i2 - i7 | 0) / 52 | 0;
  i13 = (i4 | 0) > (i12 | 0);
  i4 = i13 ? i12 : i4;
  i1 = i2;
  i2 = i13 ? i2 + ((0 - i12 | 0) * 52 | 0) | 0 : i10;
  if ((i1 | 0) != (i2 | 0)) do {
   i3 = i3 + -52 | 0;
   i1 = i1 + -52 | 0;
   __ZN10InputEventaSERKS_(i3, i1);
  } while ((i1 | 0) != (i2 | 0));
  do if (i4 | 0) {
   i1 = (((HEAP32[i8 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 52 | 0) - i4 | 0;
   if ((i1 | 0) > 0) {
    i13 = i6 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
    HEAP32[i11 >> 2] = i13;
    HEAP32[i8 >> 2] = (HEAP32[i13 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0);
    break;
   } else {
    i13 = 77 - i1 | 0;
    i12 = i6 + (((i13 | 0) / -78 | 0) << 2) | 0;
    HEAP32[i11 >> 2] = i12;
    HEAP32[i8 >> 2] = (HEAP32[i12 >> 2] | 0) + ((77 - ((i13 | 0) % 78 | 0) | 0) * 52 | 0);
    break;
   }
  } while (0);
 } while ((i2 | 0) != (i10 | 0));
 i12 = i11;
 i10 = i12;
 i10 = HEAP32[i10 >> 2] | 0;
 i12 = i12 + 4 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i13 = i9;
 i11 = i13;
 HEAP32[i11 >> 2] = i10;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 return;
}

function __ZN11prophecysdk4half7convertEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i1 >>> 16 & 32768;
 i3 = i1 >>> 23 & 255;
 i2 = i3 + -112 | 0;
 i7 = i1 & 8388607;
 if ((i2 | 0) < 1) {
  if ((i2 | 0) < -10) {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
  i7 = (i7 | 8388608) >>> (113 - i3 | 0);
  i7 = (((i7 & 4096 | 0) == 0 ? i7 : i7 + 8192 | 0) >>> 13 | i6) & 65535;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((i2 | 0) == 143) {
  i1 = i6 | 31744;
  if (!i7) {
   i7 = i1 & 65535;
   STACKTOP = i8;
   return i7 | 0;
  } else {
   i7 = (i1 | i7 >>> 13) & 65535;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 i4 = i7 + 8192 | 0;
 if (!(i1 & 4096)) i1 = i7; else {
  i1 = (i4 & 8388608 | 0) == 0;
  i2 = i1 ? i2 : i3 + -111 | 0;
  i1 = i1 ? i4 : 0;
 }
 if ((i2 | 0) > 30) {
  HEAPF32[i5 >> 2] = Math_fround(1.0e10);
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i5 >> 2]));
  i7 = (i6 | 31744) & 65535;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  i7 = (i2 << 10 | i6 | i1 >>> 13) & 65535;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i3 = i13;
 i12 = i13 + 16 | 0;
 i11 = gb + 64016 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i12 >> 2] = 0;
 i7 = i12 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i10 = i12 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i11);
 i2 = i2 - i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i10 >> 2] = i2 | -2147483648;
 HEAP32[i12 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i9 = i5 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __Z12BuildTextureIA4_tPFvP9Texture2DPS0_iiiiEES2_PKcii13TextureFormatRKT0_17TextureColorSpaceb(i1, i2, i3, i4, i9, i5, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i8 = i12;
 i13 = gb + 63520 | 0;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i10 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i10) | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, 125);
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 188 >> 2] | 0, i10 | 0, i2 | 0, i3 | 0, i4 | 0, i11 & 1 | 0, 1, -1, 0) | 0;
 __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i10, i5);
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i1 | 0);
 HEAP32[i10 + 36 >> 2] = 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 100 >> 2] | 0, i10 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0) | 0;
 __ZN9Texture2D18UnshareTextureDataEv(i10);
 i1 = HEAP32[i10 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i10 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 i5 = (__Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0) >>> 3;
 if ((i7 | 0) > 0 & (i8 | 0) > 0) {
  i6 = Math_imul(i5, i7) | 0;
  i4 = 0;
  while (1) {
   i2 = 0;
   i3 = i1;
   while (1) {
    mftCall_viiiiii(HEAP32[i9 >> 2] | 0, i10 | 0, i3 | 0, i2 | 0, i4 | 0, i7 | 0, i8 | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + (i5 << 3) | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i8 | 0)) break; else i1 = i1 + (i6 << 3) | 0;
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i11) {
  mftCall_vi(HEAP32[i1 + 192 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 } else {
  mftCall_vi(HEAP32[i1 + 196 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEC2ERKSB_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = 0;
 i6 = i9 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i9 + 24 | 0;
 i7 = i10 + 24 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i8 = (i9 | 0) == (i10 | 0);
 do if (!i8) {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = (i4 | 0) == 0;
  i4 = i7 ? i10 + 4 | 0 : i4;
  i5 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + 4 | 0;
  if (!((HEAP32[i10 + 4 >> 2] | 0) != 0 | i7)) {
   HEAP32[i9 >> 2] = i4;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i5 >>> 0 > 15) {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i2 >> 2] = i5;
   i1 = (i7 | 0) == 0 ? i1 : i7;
  }
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i6 >> 2] = i5;
 } while (0);
 i3 = i9 + 32 | 0;
 i7 = i10 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 68 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i9 + 72 | 0;
 i5 = i10 + 72 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i9 + 52 | 0;
 HEAP8[i1 >> 0] = 0;
 if (i8) return;
 i5 = HEAP32[i10 + 48 >> 2] | 0;
 i8 = (i5 | 0) == 0;
 i5 = i8 ? i10 + 52 | 0 : i5;
 i6 = HEAP32[i10 + 68 >> 2] | 0;
 i2 = i9 + 52 | 0;
 if (!((HEAP32[i10 + 52 >> 2] | 0) != 0 | i8)) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 if (i6 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i2 >> 2] = i6;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj686ES3_RKNS_27PxVehicleDifferentialNWDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 528; else i1 = (HEAP32[i1 >> 2] | 0) + 528 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj686ES2_RKNS_27PxVehicleDifferentialNWDataES6_EEKNS_40PxVehicleDifferentialNWDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 40 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i1, i2, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11 + 4 | 0;
 i13 = i11;
 i3 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1110380 >> 2] | 0, 288) | 0;
 HEAP16[i3 + 184 >> 1] = 0;
 HEAP16[i3 + 186 >> 1] = 0;
 HEAP32[i3 + 188 >> 2] = -2147450880;
 HEAP32[i3 + 192 >> 2] = 0;
 i15 = i3 + 236 | 0;
 i14 = (HEAPU16[i15 >> 1] | 0 | (HEAPU8[i15 + 2 >> 0] | 0) << 16) & 16515072 | 1353;
 HEAP16[i15 >> 1] = i14;
 HEAP8[i15 + 2 >> 0] = i14 >>> 16;
 HEAP16[i3 + 230 >> 1] = -1;
 HEAP16[i3 + 228 >> 1] = -1;
 HEAPF32[i3 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i3 + 232 >> 2] = -1;
 HEAP8[i3 + 240 >> 0] = 1;
 HEAP8[i3 + 241 >> 0] = 1;
 i15 = i3 + 244 | 0;
 i14 = i3 + 264 | 0;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i15 + 8 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 33604 + 8;
 HEAP32[i14 >> 2] = gb + 33604 + 84;
 HEAP32[i3 + 268 >> 2] = 0;
 HEAP32[i3 + 272 >> 2] = 0;
 HEAP32[i3 + 276 >> 2] = i14;
 HEAP32[i3 + 280 >> 2] = 0;
 HEAP32[i3 + 284 >> 2] = 0;
 HEAP32[i13 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 __ZN24MeshIntermediateRenderer10InitializeERK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebi(i3, i1, i2, i4, i12, i6, i7, i8, i9);
 if (!i10) {
  i15 = __Z16GetRendererScenev() | 0;
  __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i15, i3);
  STACKTOP = i11;
  return i3 | 0;
 } else {
  i15 = HEAP32[i10 + 1132 >> 2] | 0;
  __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i15, i3);
  STACKTOP = i11;
  return i3 | 0;
 }
 return 0;
}

function __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i1, i12, i14, i15) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, f23 = f0, f24 = f0, f25 = f0, f26 = f0, i27 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 24 | 0;
 i17 = i20 + 8 | 0;
 i18 = i20;
 i19 = i1 + 48 | 0;
 if ((HEAP32[i19 >> 2] | 0) <= 0) {
  STACKTOP = i20;
  return;
 }
 i13 = i1 + 44 | 0;
 i2 = i1 + 32 | 0;
 i3 = i16 + 4 | 0;
 i4 = i17 + 4 | 0;
 i5 = i16 + 8 | 0;
 i6 = i17 + 8 | 0;
 i7 = i16 + 12 | 0;
 i8 = i17 + 12 | 0;
 i9 = i15 + 4 | 0;
 i10 = i14 + 4 | 0;
 i11 = i18 + 4 | 0;
 i1 = 0;
 do {
  i22 = HEAP32[i13 >> 2] | 0;
  i27 = HEAP32[i2 >> 2] | 0;
  i21 = i22 + (i1 * 28 | 0) + 20 | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0, i16 | 0, i14 | 0, HEAP32[i21 >> 2] | 0, 1);
  i27 = HEAP32[i2 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i27 >> 2] | 0) + 24 >> 2] | 0, i27 | 0, i17 | 0, i15 | 0, HEAP32[i21 >> 2] | 0, 1);
  i21 = i22 + (i1 * 28 | 0) | 0;
  f24 = Math_fround(HEAPF32[i16 >> 2]);
  f23 = Math_fround(HEAPF32[i17 >> 2]);
  f25 = Math_fround(HEAPF32[i3 >> 2]);
  f26 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i21 >> 2] = f24 < f23 ? f24 : f23;
  HEAPF32[i22 + (i1 * 28 | 0) + 4 >> 2] = f25 < f26 ? f25 : f26;
  f26 = Math_fround(HEAPF32[i5 >> 2]);
  f25 = Math_fround(HEAPF32[i6 >> 2]);
  f23 = Math_fround(HEAPF32[i7 >> 2]);
  f24 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i22 + (i1 * 28 | 0) + 8 >> 2] = f26 > f25 ? f26 : f25;
  HEAPF32[i22 + (i1 * 28 | 0) + 12 >> 2] = f23 > f24 ? f23 : f24;
  f24 = Math_fround(HEAPF32[i15 >> 2]);
  f24 = Math_fround(f24 - Math_fround(HEAPF32[i14 >> 2]));
  f23 = Math_fround(HEAPF32[i9 >> 2]);
  f23 = Math_fround(f23 - Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i18 >> 2] = f24;
  HEAPF32[i11 >> 2] = f23;
  __ZN12b2BroadPhase9MoveProxyEiRK6b2AABBRK6b2Vec2(i12, HEAP32[i22 + (i1 * 28 | 0) + 24 >> 2] | 0, i21, i18);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i19 >> 2] | 0));
 STACKTOP = i20;
 return;
}

function __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = i6 + 56 | 0;
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i4 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i6 + 68 >> 2] | 0;
 i2 = i1 + (i3 << 4) | 0;
 if (i3 | 0) do {
  __ZN11KeyframeTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i8 = i5;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN15FrictionJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i9);
 i5 = i4 + 96 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802602 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i4 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 802613 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN13MemoryManager27InitializeDefaultAllocatorsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[gb + 73344 >> 2] | 0;
 i5 = i2 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i5;
 if (i5 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc(i2, gb + 582509 | 0);
 i5 = i4 + 1544 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 1;
 HEAP32[i4 + 1568 + (i1 << 2) >> 2] = i2;
 i1 = 0;
 do {
  HEAP32[i4 + 3824 + (i1 * 24 | 0) >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 128);
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i1 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN25ThreadsafeLinearAllocatorC2EiiPKc(i1, 262144, 64, gb + 582523 | 0);
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i3 + 1;
 HEAP32[i4 + 1568 + (i3 << 2) >> 2] = i1;
 HEAP32[i4 + 3872 >> 2] = i1;
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i1 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc(i1, gb + 582538 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i2 + 1;
 HEAP32[i4 + 1568 + (i2 << 2) >> 2] = i1;
 i2 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i2 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc(i2, gb + 582555 | 0);
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i3 + 1;
 HEAP32[i4 + 1568 + (i3 << 2) >> 2] = i2;
 i3 = HEAP32[gb + 73344 >> 2] | 0;
 i6 = i3 + 80 | 0;
 HEAP32[gb + 73344 >> 2] = i6;
 if (i6 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
  __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc(i3, gb + 582565 | 0);
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i6 + 1;
  HEAP32[i4 + 1568 + (i6 << 2) >> 2] = i3;
  HEAP32[i4 + 4280 >> 2] = i2;
  HEAP32[i4 + 4232 >> 2] = i2;
  HEAP32[i4 + 4160 >> 2] = i2;
  HEAP32[i4 + 4208 >> 2] = i2;
  HEAP32[i4 + 4184 >> 2] = i2;
  HEAP32[i4 + 4136 >> 2] = i2;
  HEAP32[i4 + 5024 >> 2] = i1;
  HEAP32[i4 + 5240 >> 2] = i3;
  HEAP32[i4 + 5216 >> 2] = i3;
  HEAP32[i4 + 5192 >> 2] = i3;
  return;
 }
}

function __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI9TransformELj4EEEiP11Il2CppArrayRKT_i(i11, i6, i1) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 8 | 0;
 i8 = i14;
 i9 = i6 + 12 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i8 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i10 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i15 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 10; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i10 = 12;
     }
    }
    if ((i10 | 0) == 10) i10 = 12;
    if ((i10 | 0) == 12) {
     i10 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i11, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i11, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return i12 | 0;
}

function __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i2, i6, i9, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i2 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx9NpFactory21acquireConnectorArrayEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i1;
 }
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 if ((i2 | 0) > -1) {
  i5 = i1;
  i4 = i1;
 } else if ((HEAP32[i1 + 40 >> 2] | 0) == (i2 & 2147483647 | 0)) {
  i4 = __ZN5physx9NpFactory21acquireConnectorArrayEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i2 + 36 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj(i4, HEAP32[i2 + 40 >> 2] << 3 >> 3);
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  i10 = HEAP32[i4 + 40 >> 2] | 0;
  i3 = i2 + (i10 << 3) | 0;
  if ((i10 | 0) > 0) while (1) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i10 = HEAP32[i1 + 44 >> 2] | 0;
  do if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 36 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    HEAP8[i1 + 32 >> 0] = 0;
    break;
   }
   if (i2 | 0) {
    i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
   }
  } while (0);
  HEAP32[i5 >> 2] = i4;
  i5 = i4;
 } else {
  i5 = i1;
  i4 = i1;
 }
 i1 = i6 & 255;
 HEAP8[i7 >> 0] = i1;
 HEAP32[i7 + 4 >> 2] = i9;
 i2 = i5 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 + 44 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i10 = (HEAP32[i5 + 36 >> 2] | 0) + (i3 << 3) | 0;
  HEAP8[i10 >> 0] = i1;
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i4, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx14PxsComputeAABBEbPKNS_12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_(i7, i3, i6, i5, i8) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 48 | 0;
 i4 = i9 + 24 | 0;
 i2 = i9;
 if (i7) if (HEAP8[i6 + 28 >> 0] & 4) {
  __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i1, i3 + 32 | 0, i5);
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  i16 = i8 + 4 | 0;
  HEAP32[i16 >> 2] = HEAP32[i1 + 4 >> 2];
  i2 = i8 + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i3 = i8 + 16 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 + 16 >> 2];
  i7 = i8 + 20 | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
  __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i4, i6, i5);
  f10 = Math_fround(HEAPF32[i8 >> 2]);
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f12 = Math_fround(HEAPF32[i16 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i2 >> 2]);
  f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  HEAPF32[i8 >> 2] = f10 < f11 ? f10 : f11;
  HEAPF32[i16 >> 2] = f12 < f13 ? f12 : f13;
  HEAPF32[i2 >> 2] = f14 < f15 ? f14 : f15;
  i8 = i8 + 12 | 0;
  f15 = Math_fround(HEAPF32[i8 >> 2]);
  f14 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  f11 = Math_fround(HEAPF32[i7 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  HEAPF32[i8 >> 2] = f15 > f14 ? f15 : f14;
  HEAPF32[i3 >> 2] = f13 > f12 ? f13 : f12;
  HEAPF32[i7 >> 2] = f11 > f10 ? f11 : f10;
  f10 = Math_fround(1.0);
  STACKTOP = i9;
  return Math_fround(f10);
 }
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i2, i6, i5);
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 f15 = Math_fround(0.0);
 STACKTOP = i9;
 return Math_fround(f15);
}

function __ZN20TextRenderingPrivate19NativeTextGenerator11InsertSpaceEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i3 = (HEAP32[i4 + 344 >> 2] | 0) + -1 | 0;
 i5 = HEAP32[i4 + 332 >> 2] | 0;
 i1 = i4 + 248 | 0;
 f2 = Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(HEAP32[i4 + 184 >> 2] | 0, 32, HEAP32[i5 + (i3 << 5) + 8 >> 2] | 0, HEAP32[i5 + (i3 << 5) >> 2] | 0, Math_fround(HEAPF32[i1 >> 2]), 0));
 if (HEAP8[i4 + 229 >> 0] | 0) {
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  f2 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f2 * f6) + Math_fround(.5)))) / f6);
 }
 i3 = i4 + 436 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 180 | 0;
 i1 = i4 + 320 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 _memmove(i8 | 0, i1 | 0, 12) | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 60 | 0;
 i5 = i8 + 120 | 0;
 f10 = Math_fround(f2 + Math_fround(HEAPF32[i1 >> 2]));
 f9 = Math_fround(Math_fround(HEAPF32[i4 + 324 >> 2]) + Math_fround(0.0));
 f6 = Math_fround(Math_fround(HEAPF32[i4 + 328 >> 2]) + Math_fround(0.0));
 HEAPF32[i8 + 120 >> 2] = f10;
 HEAPF32[i8 + 124 >> 2] = f9;
 HEAPF32[i8 + 128 >> 2] = f6;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 240;
 i3 = HEAP32[i4 + 260 >> 2] | 0;
 HEAPF32[(HEAP32[i4 + 376 >> 2] | 0) + (i3 << 2) >> 2] = f2;
 i7 = i4 + 312 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 1;
 if (i5 | 0) {
  i8 = i4 + 300 | 0;
  f10 = Math_fround(HEAPF32[i8 >> 2]);
  f10 = Math_fround(f2 + f10);
  HEAPF32[i8 >> 2] = f10;
  i8 = i4 + 304 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  f10 = Math_fround(HEAPF32[i1 >> 2]);
  f10 = Math_fround(f2 + f10);
  HEAPF32[i1 >> 2] = f10;
  return;
 }
 HEAP32[i4 + 276 >> 2] = i3 + -1;
 i8 = i4 + 300 | 0;
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f2 + f10);
 HEAPF32[i8 >> 2] = f10;
 i8 = i4 + 304 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f2 + f10);
 HEAPF32[i1 >> 2] = f10;
 return;
}

function __ZN19AudioHighPassFilter8TransferI14SafeBinaryReadEEvRT_(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i4, i9);
 i5 = i4 + 44 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855631 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i4 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 855649 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI8MaterialELj4EEEiP11Il2CppArrayRKT_i(i11, i6, i1) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 8 | 0;
 i8 = i14;
 i9 = i6 + 12 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!i2) i2 = 0; else {
    HEAP32[i8 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i10 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i15 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 10; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) i10 = 12;
     }
    }
    if ((i10 | 0) == 10) i10 = 12;
    if ((i10 | 0) == 12) {
     i10 = 0;
     i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    }
   }
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i11, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i11, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return i12 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i11, _llvm_bswap_i32(i1 | 0) | 0, i5 + 8 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 4) | 0;
 if (!i4) i1 = 0; else {
  do {
   __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
   i1 = i1 + 16 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z18LoadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[gb + 1162872 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1162872 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1162872 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 1162872 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[gb + 1162872 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, gb + 1162872 + 4 | 0, i1, gb + 1162872 + 16 | 0, gb + 1162872 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i4;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1162872 >> 2] = i1;
   break;
  }
 } while (0);
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_(i1, i2) | 0;
 i4 = HEAP32[gb + 1162872 >> 2] | 0;
 if ((i3 | 0) == (i4 + 4 | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_(i4, i5, i2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(32) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i2);
  HEAP32[i1 + 28 >> 2] = 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
  i5 = i4 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_(i2, i1, i10, i8, i11) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 4 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 8 >> 2])));
 f9 = Math_fround(f5 * Math_fround(HEAPF32[i8 + 12 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 20 >> 2])));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i8 + 24 >> 2]));
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 28 >> 2])));
 f4 = Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 32 >> 2])));
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(-f3);
 if (f6 < f5) {
  f3 = Math_fround(f6 + f3);
  f3 = Math_fround(Math_fround(f3 * f3) + Math_fround(0.0));
 } else if (f6 > f3) {
  f7 = Math_fround(f6 - f3);
  f5 = f3;
  f3 = Math_fround(Math_fround(f7 * f7) + Math_fround(0.0));
 } else {
  f5 = f6;
  f3 = Math_fround(0.0);
 }
 f6 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f7 = Math_fround(-f6);
 if (f9 < f7) {
  f6 = Math_fround(f9 + f6);
  f9 = f7;
  f3 = Math_fround(f3 + Math_fround(f6 * f6));
 } else if (f9 > f6) {
  f7 = Math_fround(f9 - f6);
  f9 = f6;
  f3 = Math_fround(f3 + Math_fround(f7 * f7));
 }
 f6 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f7 = Math_fround(-f6);
 if (f4 < f7) {
  f6 = Math_fround(f4 + f6);
  f4 = f7;
  f3 = Math_fround(f3 + Math_fround(f6 * f6));
 } else if (f4 > f6) {
  f7 = Math_fround(f4 - f6);
  f4 = f6;
  f3 = Math_fround(f3 + Math_fround(f7 * f7));
 }
 if (!i11) return Math_fround(f3);
 HEAPF32[i11 >> 2] = f5;
 HEAPF32[i11 + 4 >> 2] = f9;
 HEAPF32[i11 + 8 >> 2] = f4;
 return Math_fround(f3);
}

function __Z25AddPPtrCurveToClipBuilderR13dynamic_arrayI12PPtrKeyframeLj4EERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilder(i1, i10, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(HEAP32[i1 + 12 >> 2] | 0)) return;
 if ((HEAP16[i10 + 12 >> 1] | 0) == 4) return;
 i9 = i11 + 720 | 0;
 i3 = i11 + 732 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 736 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i11 + 724 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11 + 724 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 i2 = i11 + 748 | 0;
 i3 = i11 + 760 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 764 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i11 + 752 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i11 + 752 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i11 = (HEAP32[i2 >> 2] | 0) + (i4 << 4) | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 return;
}

function __ZN5physx31PxClothGeodesicTetherCookerImplD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 96 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 84 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 76 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 68 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 64 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 56 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 52 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i3 | 0) < 0 | (i3 & 2147483647 | 0) == 0))) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 28 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_14PxArticulationEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 324 | 0;
 i14 = i11 + 272 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i15 = i11 + 40 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx27PxArticulationGeneratedInfoC2Ev(i15);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i5;
 HEAP32[i14 + 24 >> 2] = i4;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i13;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate15DynamicFontData21GetFontMetricsForFaceERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEiRKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEPfSI_(i6, i1, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 16 | 0;
 i12 = i14;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i4 = i11 + 12 | 0;
 while (1) {
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
  } else {
   i3 = i2;
   i1 = i1 & 255;
  };
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i12, i3, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i11, i12);
  HEAP32[i4 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
  i1 = __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE(i6, i11, i8) | 0;
  if (i1 | 0) break;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i2 = i2 + 16 | 0;
  if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
   i1 = 0;
   i13 = 9;
   break;
  }
 }
 if ((i13 | 0) == 9) {
  STACKTOP = i14;
  return i1 | 0;
 }
 _UNITY_FT_Set_Pixel_Sizes(i1, i7, 0) | 0;
 f17 = Math_fround(HEAP16[i1 + 70 >> 1] | 0);
 f16 = Math_fround(HEAPU16[(HEAP32[i1 + 88 >> 2] | 0) + 14 >> 1] | 0);
 f17 = Math_fround(f17 * f16);
 f15 = Math_fround(HEAPU16[i1 + 68 >> 1] | 0);
 HEAPF32[i9 >> 2] = Math_fround(f17 / f15);
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(Math_fround(HEAP16[i1 + 74 >> 1] | 0) * f16) / f15);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN19ClampVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 800 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620320 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620330 | 0, i5, i1 + 1065 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620372 | 0, i5, i1 + 1064 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620086 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 1068 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17PhysicsMaterial2D8TransferI14SafeBinaryReadEEvRT_(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i4, i9);
 i5 = i4 + 32 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 835574 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i4 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 801720 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN12FixedJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i9);
 i5 = i4 + 96 | 0;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 803283 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i4 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 853582 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __Z16GetLoadedLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[gb + 1162872 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1162872 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1162872 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 1162872 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i4;
   HEAP32[gb + 1162872 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, gb + 1162872 + 4 | 0, i1, gb + 1162872 + 16 | 0, gb + 1162872 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i4;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1162872 >> 2] = i1;
   break;
  }
 } while (0);
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_(i1, i2) | 0;
 i4 = HEAP32[gb + 1162872 >> 2] | 0;
 if ((i3 | 0) == (i4 + 4 | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_(i4, i5, i2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(32) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i2);
  HEAP32[i1 + 28 >> 2] = 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i4 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
  i5 = i4 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z12BuildTextureItPFvP9Texture2DPtiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(i1, i2, i3, i4, i9, i5, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i8 = i12;
 i13 = gb + 63520 | 0;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i10 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i10) | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, 125);
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 188 >> 2] | 0, i10 | 0, i2 | 0, i3 | 0, i4 | 0, i11 & 1 | 0, 1, -1, 0) | 0;
 __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i10, i5);
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i1 | 0);
 HEAP32[i10 + 36 >> 2] = 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 100 >> 2] | 0, i10 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0) | 0;
 __ZN9Texture2D18UnshareTextureDataEv(i10);
 i1 = HEAP32[i10 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i10 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 i5 = (__Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0) >>> 1;
 if ((i7 | 0) > 0 & (i8 | 0) > 0) {
  i6 = Math_imul(i5, i7) | 0;
  i4 = 0;
  while (1) {
   i2 = 0;
   i3 = i1;
   while (1) {
    mftCall_viiiiii(HEAP32[i9 >> 2] | 0, i10 | 0, i3 | 0, i2 | 0, i4 | 0, i7 | 0, i8 | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + (i5 << 1) | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i8 | 0)) break; else i1 = i1 + (i6 << 1) | 0;
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i11) {
  mftCall_vi(HEAP32[i1 + 192 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 } else {
  mftCall_vi(HEAP32[i1 + 196 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 }
 return 0;
}

function __ZN9Transform28ApplySerializedToRuntimeDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i9 = i1 + 32 | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i16 = i1 + 56 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = HEAP32[i16 + 8 >> 2] | 0;
 i10 = i1 + 40 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i12 = HEAP32[i10 + 4 >> 2] | 0;
 i11 = HEAP32[i10 + 8 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i7 = i1 + 68 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i9 + (i2 * 40 | 0) >> 2] = HEAP32[i16 >> 2];
 HEAP32[i9 + (i2 * 40 | 0) + 4 >> 2] = i15;
 HEAP32[i9 + (i2 * 40 | 0) + 8 >> 2] = i14;
 HEAP32[i9 + (i2 * 40 | 0) + 12 >> 2] = i13;
 HEAP32[i9 + (i2 * 40 | 0) + 16 >> 2] = i12;
 HEAP32[i9 + (i2 * 40 | 0) + 20 >> 2] = i11;
 HEAP32[i9 + (i2 * 40 | 0) + 24 >> 2] = i10;
 HEAP32[i9 + (i2 * 40 | 0) + 28 >> 2] = i3;
 HEAP32[i9 + (i2 * 40 | 0) + 32 >> 2] = i8;
 HEAP32[i9 + (i2 * 40 | 0) + 36 >> 2] = i7;
 f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i7 = (HEAP32[tempDoublePtr >> 2] = i8 & -2147483648 ^ (i3 & -2147483648 | 1065353216) ^ i7 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
 i3 = ((Math_fround(Math_abs(Math_fround(f4 - f6))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f6 - f5))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f5 - f4))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i7) ^ 1;
 i3 = (i7 << 2 | 3) & ~(i3 << 1) & (i3 & ((Math_fround(Math_abs(Math_fround(f6 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f5 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f4 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
 HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 return;
}

function __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj(i10, i11, i6) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 8 | 0;
 i8 = i12;
 if ((i6 | 0) == -1) {
  i5 = 0;
  i7 = 0;
 } else {
  i7 = HEAP16[(HEAP32[i10 + 104 >> 2] | 0) + (i6 * 12 | 0) + 8 >> 1] | 0;
  i5 = (i7 & 64) != 0;
  i7 = i7 & 63;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i4 = HEAP16[(HEAP32[i10 + 104 >> 2] | 0) + (i1 * 12 | 0) + 8 >> 1] | 0;
  i2 = i4 & 63;
  if (!((i4 & 64) == 0 | i5 & (i2 | 0) == (i7 | 0))) {
   i4 = i11 + 40 | 0;
   do if (HEAP32[i4 >> 2] | 0) {
    i3 = i10 + 2392 + (i2 << 2) | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i14 = gb + 63552 | 0;
     i13 = HEAP32[i14 + 4 >> 2] | 0;
     i1 = i8;
     HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
     HEAP32[i1 + 4 >> 2] = i13;
     HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     i1 = __Z18CreateDecompressor15CompressionType10MemLabelId(i2, i9) | 0;
     HEAP32[i3 >> 2] = i1;
     if (!i1) break;
    }
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i4 >> 2] | 0);
   } while (0);
   HEAP32[i4 >> 2] = 0;
  }
 }
 HEAP32[i11 >> 2] = i6;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 do if (i5 & (i7 | 0) != 0) {
  i2 = i10 + 2392 + (i7 << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i13 = gb + 63552 | 0;
   i14 = HEAP32[i13 + 4 >> 2] | 0;
   i1 = i8;
   HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i1 + 4 >> 2] = i14;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   i1 = __Z18CreateDecompressor15CompressionType10MemLabelId(i7, i9) | 0;
   HEAP32[i2 >> 2] = i1;
   if (!i1) break;
  }
  mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i11 + 40 | 0) | 0;
 } while (0);
 HEAP32[i11 + 56 >> 2] = 0;
 HEAP32[i11 + 64 >> 2] = 0;
 HEAP32[i11 + 68 >> 2] = 0;
 i13 = i10 + 2388 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i14 + 1;
 HEAP32[i11 + 36 >> 2] = i14;
 STACKTOP = i12;
 return;
}

function __Z33AudioSource_CUSTOM_GetCustomCurveP12Il2CppObject24MonoAudioSourceCurveType(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do switch (i1 | 0) {
 case 0:
  {
   if (!i3) {
    i1 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
    i2 = __ZNK11AudioSource25GetCustomRolloffCurveCopyEv(i1) | 0;
    break L1;
   }
   break;
  }
 case 1:
  {
   if (!i3) {
    i1 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
    i2 = __ZNK11AudioSource30GetCustomSpatialBlendCurveCopyEv(i1) | 0;
    break L1;
   }
   break;
  }
 case 2:
  {
   if (!i3) {
    i1 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
    i2 = __ZNK11AudioSource31GetCustomReverbZoneMixCurveCopyEv(i1) | 0;
    break L1;
   }
   break;
  }
 case 3:
  {
   if (!i3) {
    i1 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
   }
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
    i2 = __ZNK11AudioSource24GetCustomSpreadCurveCopyEv(i1) | 0;
    break L1;
   }
   break;
  }
 default:
  {
   if (!i3) i1 = 0; else {
    i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884462 | 0, 0, gb + 875076 | 0, 1335, 1, i1, 0, 0);
   i3 = 0;
   return i3 | 0;
  }
 } while (0);
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
 HEAP32[i3 + 8 >> 2] = i2;
 return i3 | 0;
}

function __Z24AudioClip_CUSTOM_SetDataP12Il2CppObjectP11Il2CppArrayi(i9, i6, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i3 = i10 + 8 | 0;
 i2 = i10;
 i8 = i10 + 20 | 0;
 if (!i9) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) {
  i4 = i9;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZNK9AudioClip15GetChannelCountEv(i1) | 0;
 if ((i4 | 0) < 1) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i8, gb + 883609 | 0, i2);
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 875076 | 0, 390, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i7 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 883665 | 0, i3);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 if ((__ZNK9AudioClip14GetSampleCountEv(i1) | 0) <= (i7 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 883665 | 0, i3);
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 if (!i2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 883713 | 0, i5);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 i9 = (__ZN9AudioClip7SetDataEPKfjj(i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0, (i2 | 0) / (i4 | 0) | 0, i7) | 0) & 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN9allocutil14BuddyAllocator16InternalAllocateEhRj(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i1 & 255;
 if ((HEAPU8[i9 + 26 >> 0] | 0) < (i1 & 255)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i8 = i9 + 8 | 0;
 i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i6 = i2 + (i12 << 5) + 20 | 0;
 L4 : do if (HEAP32[i6 >> 2] | 0) {
  i3 = HEAP32[i2 + (i12 << 5) + 28 >> 2] | 0;
  i7 = HEAP32[i2 + (i12 << 5) >> 2] | 0;
  i4 = i7 + (i3 << 2) | 0;
  while (1) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) break;
   if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
    i5 = 6;
    break;
   }
  }
  if ((i5 | 0) == 6) {
   i12 = _llvm_cttz_i32(i1 | 0) | 0;
   HEAP32[i4 >> 2] = i1 & ~(1 << i12);
   HEAP32[i10 >> 2] = i12 | i3 << 5;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
  i4 = HEAP32[i2 + (i12 << 5) + 24 >> 2] | 0;
  if (i4 | 0) {
   i1 = 0;
   L13 : while (1) {
    i3 = i7 + (i1 << 2) | 0;
    while (1) {
     i2 = HEAP32[i3 >> 2] | 0;
     if (!i2) break;
     if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) break L13;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) break L4;
   }
   i12 = _llvm_cttz_i32(i2 | 0) | 0;
   HEAP32[i3 >> 2] = i2 & ~(1 << i12);
   HEAP32[i10 >> 2] = i12 | i1 << 5;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   i12 = 1;
   STACKTOP = i13;
   return i12 | 0;
  }
 } while (0);
 if (__ZN9allocutil14BuddyAllocator16InternalAllocateEhRj(i9, i12 + 1 & 255, i11) | 0) {
  i7 = HEAP32[i11 >> 2] | 0;
  i9 = i7 << 1;
  HEAP32[i11 >> 2] = i9;
  i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  i8 = i7 >>> 4 & 134217727;
  i7 = (HEAP32[i11 + (i12 << 5) >> 2] | 0) + (i8 << 2) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (1 << (i9 & 30 | 1));
  i7 = i11 + (i12 << 5) + 20 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  HEAP32[i11 + (i12 << 5) + 28 >> 2] = i8;
  HEAP32[i10 >> 2] = i9;
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 return 0;
}

function __ZN21AssetBundleFileSystem19InitializeFileEntryER13FileEntryData(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i6 = i8;
 i1 = i5 + 96 | 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i5 + 100 >> 2] | 0;
 } else {
  i2 = i1;
  i1 = i3 & 255;
 }
 i3 = __Z14SkipPathPrefixPKcS0_jb(i7, i2, i1, 1) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, _strlen(i3) | 0);
 if ((HEAP32[i5 + 72 >> 2] | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  i4 = i5 + 64 | 0;
  i3 = i5 + 68 | 0;
  i1 = i3;
  i2 = i4;
  i3 = (HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_(i4, i5 + 4 | 0, i6);
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i5 + 64 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i9 = i5 + 68 | 0;
  i1 = i9;
  i3 = (i3 | 0) == -1 ? i4 + ((HEAP32[i9 >> 2] | 0) * 24 | 0) | 0 : i4 + (i3 * 24 | 0) | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if ((i3 | 0) == ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) | 0)) {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  if (!i1) {
   i9 = __ZNK10FileSystem15LocalFileSystemEv(__Z13GetFileSystemv() | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2] | 0, i9 | 0, i7 | 0);
   STACKTOP = i8;
   return;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i7 | 0);
   STACKTOP = i8;
   return;
  }
 } else {
  i1 = i3 + 12 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  _strncpy(i7, i1, 1040) | 0;
  i9 = __ZNK10FileSystem17GetHandlerForPathEPKc(__Z13GetFileSystemv() | 0, i7) | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 60 >> 2] | 0, i9 | 0, i7 | 0);
  STACKTOP = i8;
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7SetSizeEi(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i7 + 40 | 0;
 i6 = i7 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = i4 + 76 | 0;
    i2 = i4 + 84 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 80 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i11;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 64 | 0;
    i2 = i4 + 72 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i11 = i4 + 68 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i11 = i4 + 56 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i11 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i11;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = __Znaj(i8 >>> 0 > 1073741823 ? -1 : i8 << 2) | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i6 >> 2] = i8;
 if ((i8 | 0) > 0) {
  HEAP32[i1 >> 2] = 0;
  if ((i8 | 0) != 1) {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  }
 }
 i11 = i7 + 28 | 0;
 HEAP32[i7 + 32 >> 2] = i11;
 HEAP32[i7 + 36 >> 2] = i11;
 i11 = i7 + 16 | 0;
 HEAP32[i7 + 20 >> 2] = i11;
 HEAP32[i7 + 24 >> 2] = i11;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function _UNITY_png_read_finish_row(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = i11 + 368 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i9;
 i10 = i11 + 352 | 0;
 if (i9 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) return;
 L4 : do if (HEAP8[i11 + 428 >> 0] | 0) {
  HEAP32[i1 >> 2] = 0;
  _memset(HEAP32[i11 + 376 >> 2] | 0, 0, (HEAP32[i11 + 360 >> 2] | 0) + 1 | 0) | 0;
  i6 = i11 + 429 | 0;
  i2 = (HEAP8[i6 >> 0] | 0) + 1 << 24 >> 24;
  HEAP8[i6 >> 0] = i2;
  i1 = i2 & 255;
  if ((i2 & 255) <= 6) {
   i7 = (HEAP32[i11 + 344 >> 2] | 0) + -1 | 0;
   i9 = i11 + 364 | 0;
   do if (!(HEAP32[i11 + 212 >> 2] & 2)) {
    i8 = (HEAP32[i11 + 348 >> 2] | 0) + -1 | 0;
    while (1) {
     i5 = HEAPU8[gb + 353251 + i1 >> 0] | 0;
     i1 = i7 + i5 - (HEAPU8[gb + 353258 + i1 >> 0] | 0) | 0;
     i4 = i2 & 255;
     i3 = HEAPU8[gb + 353660 + i4 >> 0] | 0;
     i4 = i8 + i3 - (HEAPU8[gb + 353667 + i4 >> 0] | 0) | 0;
     if (!(i3 >>> 0 > i4 >>> 0 | i5 >>> 0 > i1 >>> 0)) {
      i2 = 9;
      break;
     }
     i2 = i2 + 1 << 24 >> 24;
     HEAP8[i6 >> 0] = i2;
     if ((i2 & 255) > 6) {
      i2 = 11;
      break;
     } else i1 = i2 & 255;
    }
    if ((i2 | 0) == 9) {
     HEAP32[i10 >> 2] = (i4 >>> 0) / (i3 >>> 0) | 0;
     i1 = (i1 >>> 0) / (i5 >>> 0) | 0;
     break;
    } else if ((i2 | 0) == 11) {
     HEAP32[i10 >> 2] = (i4 >>> 0) / (i3 >>> 0) | 0;
     HEAP32[i9 >> 2] = (i1 >>> 0) / (i5 >>> 0) | 0;
     break L4;
    }
   } else {
    i11 = HEAPU8[gb + 353251 + i1 >> 0] | 0;
    i1 = ((i7 + i11 - (HEAPU8[gb + 353258 + i1 >> 0] | 0) | 0) >>> 0) / (i11 >>> 0) | 0;
   } while (0);
   HEAP32[i9 >> 2] = i1;
   return;
  }
 } while (0);
 i1 = i11 + 208 | 0;
 if (!(HEAP32[i1 >> 2] & 8)) {
  _UNITY_png_read_IDAT_data(i11, 0, 0);
  HEAP32[i11 + 232 >> 2] = 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i11 + 204 | 0;
  if (!(i2 & 8)) {
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 8;
   HEAP32[i1 >> 2] = i2 | 8;
  }
 }
 i1 = i11 + 216 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1229209940) return;
 HEAP32[i11 + 220 >> 2] = 0;
 HEAP32[i11 + 224 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 _UNITY_png_crc_finish(i11, HEAP32[i11 + 404 >> 2] | 0) | 0;
 return;
}

function _UNITY_png_chunk_error(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 if (!i7) _UNITY_png_error(0, i5);
 i4 = HEAP32[i7 + 372 >> 2] | 0;
 i1 = i4 >>> 24;
 if ((i1 + -65 | 0) >>> 0 > 57 | (i1 + -91 | 0) >>> 0 < 6) {
  HEAP8[i6 >> 0] = 91;
  HEAP8[i6 + 1 >> 0] = HEAP8[(i4 >>> 28) + (gb + 1057519) >> 0] | 0;
  HEAP8[i6 + 2 >> 0] = HEAP8[(i1 & 15) + (gb + 1057519) >> 0] | 0;
  HEAP8[i6 + 3 >> 0] = 93;
  i2 = 4;
 } else {
  HEAP8[i6 >> 0] = i1;
  i2 = 1;
 }
 i1 = i4 >>> 16;
 i3 = i1 & 255;
 if ((i3 + -65 | 0) >>> 0 > 57 | (i3 + -91 | 0) >>> 0 < 6) {
  HEAP8[i6 + (i2 + 1) >> 0] = HEAP8[(i4 >>> 20 & 15) + (gb + 1057519) >> 0] | 0;
  i3 = i2 + 3 | 0;
  HEAP8[i6 + (i2 | 2) >> 0] = HEAP8[(i1 & 15) + (gb + 1057519) >> 0] | 0;
  HEAP8[i6 + i3 >> 0] = 93;
  i1 = 91;
 } else {
  i3 = i2;
  i1 = i1 & 255;
 }
 HEAP8[i6 + i2 >> 0] = i1;
 i2 = i3 + 1 | 0;
 i1 = i4 >>> 8;
 i8 = i1 & 255;
 if ((i8 + -65 | 0) >>> 0 > 57 | (i8 + -91 | 0) >>> 0 < 6) {
  HEAP8[i6 + (i3 + 2) >> 0] = HEAP8[(i4 >>> 12 & 15) + (gb + 1057519) >> 0] | 0;
  i8 = i3 + 4 | 0;
  HEAP8[i6 + (i3 + 3) >> 0] = HEAP8[(i1 & 15) + (gb + 1057519) >> 0] | 0;
  HEAP8[i6 + i8 >> 0] = 93;
  i3 = i8;
  i1 = 91;
 } else {
  i3 = i2;
  i1 = i1 & 255;
 }
 HEAP8[i6 + i2 >> 0] = i1;
 i2 = i3 + 1 | 0;
 i8 = i4 & 255;
 if ((i8 + -65 | 0) >>> 0 > 57 | (i8 + -91 | 0) >>> 0 < 6) {
  HEAP8[i6 + (i3 + 2) >> 0] = HEAP8[(i4 >>> 4 & 15) + (gb + 1057519) >> 0] | 0;
  i1 = i3 + 4 | 0;
  HEAP8[i6 + (i3 + 3) >> 0] = HEAP8[(i4 & 15) + (gb + 1057519) >> 0] | 0;
  HEAP8[i6 + i1 >> 0] = 93;
  i3 = i1;
  i1 = 91;
 } else {
  i3 = i2;
  i1 = i4 & 255;
 }
 HEAP8[i6 + i2 >> 0] = i1;
 i1 = i3 + 1 | 0;
 if (!i5) {
  HEAP8[i6 + i1 >> 0] = 0;
  _UNITY_png_error(i7, i6);
 }
 HEAP8[i6 + i1 >> 0] = 58;
 HEAP8[i6 + (i3 + 2) >> 0] = 32;
 i4 = 0;
 i1 = i3 + 3 | 0;
 while (1) {
  i2 = HEAP8[i5 + i4 >> 0] | 0;
  if (!(i2 << 24 >> 24)) break;
  i4 = i4 + 1 | 0;
  i3 = i1 + 1 | 0;
  HEAP8[i6 + i1 >> 0] = i2;
  if ((i4 | 0) >= 195) {
   i1 = i3;
   break;
  } else i1 = i3;
 }
 HEAP8[i6 + i1 >> 0] = 0;
 _UNITY_png_error(i7, i6);
}

function __ZN5physx3Ext21InertiaTensorComputer10setCapsuleEiff(i6, i5, f2, f1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f10 = Math_fround(Math_fround(f2 * Math_fround(3.14159274)) * f2);
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(4.18879032)) * f2) * f2) + Math_fround(f10 * Math_fround(f1 * Math_fround(2.0))));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * f2) * f2) * Math_fround(8.0)) / Math_fround(15.0));
 f9 = Math_fround(Math_fround(f2 * f1) * f2);
 f3 = Math_fround(f10 * Math_fround(f9 + f8));
 f7 = Math_fround(f1 * f1);
 f1 = Math_fround(f10 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(3.0)) * Math_fround(.5)) + f8) + Math_fround(Math_fround(Math_fround(f7 * f2) * Math_fround(4.0)) / Math_fround(3.0))) + Math_fround(Math_fround(Math_fround(f7 * f1) * Math_fround(2.0)) / Math_fround(3.0))));
 switch (i5 | 0) {
 case 0:
  {
   HEAPF32[i6 + 48 >> 2] = f4;
   HEAPF32[i6 >> 2] = f3;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f1;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f1;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 case 1:
  {
   HEAPF32[i6 + 48 >> 2] = f4;
   HEAPF32[i6 >> 2] = f1;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f3;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f1;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 default:
  {
   HEAPF32[i6 + 48 >> 2] = f4;
   HEAPF32[i6 >> 2] = f1;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f1;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f3;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 }
}

function __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i3 = i11;
 i10 = i11 + 16 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i1 = i10 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i7, i10, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i2 = i6 + 32 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  HEAP32[i2 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 }
 i4 = i6 + 36 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, i1, i7 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i6 + 48 >> 2] | 0;
 i2 = i1 + (i6 << 5) | 0;
 if (i6 | 0) do {
  __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 12 | 0;
 i9 = i10 + 16 | 0;
 i7 = i10;
 if (!i5) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i8 + 44 >> 2] | 0;
 L7 : do if (i4 | 0) {
  i2 = i1;
  i1 = 5381;
  i3 = i5;
  do {
   i1 = i1 * 33 ^ i2 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i1 = HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i8 + 28 >> 2] | 0;
   i3 = i8 + 32 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i5) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L7;
   }
   if (i2 | 0) {
    i9 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  }
 } while (0);
 i4 = HEAP32[i8 + 64 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0) | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i5 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = gb + 149820 + 8;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i2;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i8, i7, 1);
 HEAP32[i6 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i8 + 12 | 0, i6, i9) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i2;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 i9 = i2;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i5, i8, i9, i10) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i6 = HEAP32[i5 + 40 >> 2] | 0;
 i7 = i1 + (i6 << 3) | 0;
 L1 : do if (i6 | 0) {
  i6 = i9 + 8 | 0;
  while (1) {
   i2 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
    i3 = i1 + 4 | 0;
    i4 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i3 >> 2] | 0) | 0;
    if (i4 | 0) {
     if ((i4 | 0) == (i2 | 0)) break;
     if (__Z26scripting_class_has_parentP11Il2CppClassS0_(i4, i2) | 0) break;
    }
   }
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i7 | 0)) break L1;
  }
  HEAP32[HEAP32[i10 >> 2] >> 2] = HEAP32[i3 >> 2];
  i10 = 1;
  return i10 | 0;
 } while (0);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i5, gb + 28940 | 0) | 0;
 i5 = HEAP32[i1 + 92 >> 2] | 0;
 L13 : do if ((i5 | 0) > 0) {
  i4 = i1 + 80 | 0;
  if (i8) {
   i1 = 0;
   while (1) {
    i2 = __ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i9, i10) | 0;
    if (i2) {
     i2 = i2 & 1;
     i1 = 1;
     break L13;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i5 | 0)) {
     i2 = 2;
     i1 = 0;
     break L13;
    }
   }
  } else {
   i1 = 0;
   i3 = 0;
  }
  while (1) {
   i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
   if (!(HEAP8[i2 + 54 >> 0] | 0)) i2 = 4; else {
    i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i9, i10) | 0);
    i2 = i1 & 1;
   }
   switch (i2 & 7) {
   case 4:
   case 0:
    break;
   default:
    break L13;
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i5 | 0)) {
    i2 = 2;
    break L13;
   }
  }
 } else {
  i2 = 2;
  i1 = 0;
 } while (0);
 i10 = i1 | (i2 | 0) != 2;
 return i10 | 0;
}

function __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_(i11, i2, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = (HEAP32[i2 + 40 >> 2] | 0) + -1 | 0;
 i4 = i1;
 i17 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = _bitshift64Shl(i4 | 0, 0, 16) | 0;
 getTempRet0() | 0 | i4;
 i12 = HEAP32[i2 + 36 >> 2] | 0;
 i13 = HEAP32[i2 + 24 >> 2] | 0;
 i14 = HEAP32[i2 + 28 >> 2] | 0;
 i15 = i2 + 8 | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i2 + 4 | 0;
 i10 = i2 + 12 | 0;
 i6 = i2 + 16 | 0;
 i5 = 0;
 i1 = (i17 | 0) < (i4 | 0) ? i17 << 16 | i4 : i7 | i17;
 i2 = -1;
 while (1) {
  i7 = i1 & i16;
  i1 = HEAP32[i12 + (i7 * 12 | 0) >> 2] | 0;
  if ((i13 | 0) == (i1 | 0)) if ((i14 | 0) == (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) break;
  if ((i14 | 0) == (i1 | 0)) if ((i13 | 0) == (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) break;
  do if (!(HEAP8[i15 >> 0] | 0)) i18 = 16; else if (!(HEAP32[i9 >> 2] | 0)) i18 = 16; else {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) == (i1 | 0)) {
    if ((i4 | 0) != (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) i18 = 13;
   } else i18 = 13;
   if ((i18 | 0) == 13) {
    i18 = 0;
    if ((i4 | 0) != (i1 | 0)) {
     i18 = 16;
     break;
    }
    if ((i3 | 0) != (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) {
     i18 = 16;
     break;
    }
   }
   i2 = (i2 | 0) == -1 ? i7 : i2;
  } while (0);
  if ((i18 | 0) == 16) {
   i18 = 0;
   if ((i17 | 0) == (i1 | 0)) if ((i8 | 0) == (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) {
    i18 = 20;
    break;
   }
   if ((i8 | 0) == (i1 | 0)) if ((i17 | 0) == (HEAP32[i12 + (i7 * 12 | 0) + 4 >> 2] | 0)) {
    i18 = 20;
    break;
   }
  }
  i1 = i5 + 1 | 0;
  i5 = i1;
  i1 = i1 + i7 | 0;
 }
 if ((i18 | 0) == 20) {
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 4 >> 2] = -1;
  return;
 }
 HEAP32[i11 >> 2] = -1;
 i1 = i11 + 4 | 0;
 if ((i2 | 0) == -1) {
  HEAP32[i1 >> 2] = i7;
  return;
 } else {
  HEAP32[i1 >> 2] = i2;
  return;
 }
}

function __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 36, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj666ES3_RKNS_20PxVehicleAutoBoxDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 272; else i1 = (HEAP32[i1 >> 2] | 0) + 272 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ES2_RKNS_20PxVehicleAutoBoxDataES6_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN16ScriptingManager22GetAllMonoScriptCachesER13dynamic_arrayIP15MonoScriptCacheLj4EE(i4, i10) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 12 | 0;
 i1 = i4 + 180 | 0;
 i2 = (HEAP32[i4 + 192 >> 2] | 0) + (HEAP32[i11 >> 2] | 0) | 0;
 i12 = i10 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i12 >> 2] = i2;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i2;
  HEAP32[i10 >> 2] = i9;
  break;
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 i8 = i4 + 184 | 0;
 i2 = i1;
 if ((i2 | 0) == (i8 | 0)) return;
 i9 = i10 + 4 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 while (1) {
  i3 = i2 + 20 | 0;
  i4 = i7;
  i7 = i7 + 1 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i7 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i12 >> 2] = i2;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
    HEAP32[i12 >> 2] = i2;
    HEAP32[i10 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i11 >> 2] = i7;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i8 | 0)) break; else i1 = i2;
 }
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings8RegisterEPNS0_13ConfigHandlerE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i7 = i10 + 24 | 0;
 i8 = i10 + 8 | 0;
 i9 = i6 + 17 | 0;
 if (!((i2 | 0) != 0 & (HEAP8[i9 >> 0] | 0) == 0)) {
  STACKTOP = i10;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 i3 = _strlen(gb + 1041415 | 0) | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i4 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i8 + 11 >> 0] = i3;
  if (!i3) i1 = i8; else {
   i1 = i8;
   i4 = 7;
  }
 } else i4 = 5;
 if ((i4 | 0) == 5) {
  i11 = i3 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i3;
  i4 = 7;
 }
 if ((i4 | 0) == 7) _memcpy(i1 | 0, gb + 1041415 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 i2 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i2, i8) | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i7, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = i6;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 1003;
 if ((HEAP8[i8 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i7);
 }
 HEAP8[i9 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZN2UI13RectTransform8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN9Transform8TransferI14SafeBinaryReadEEvRT_(i5, i6);
 i2 = i5 + 136 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 405998 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 144 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 406010 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 152 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 406022 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 160 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 406041 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 902162 | 0, i3, i4, 1) | 0;
 if (!i1) {
  i6 = i5 + 177 | 0;
  HEAP8[i6 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 i6 = i5 + 177 | 0;
 HEAP8[i6 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function _int_downsample(i2, i1, i18, i19) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0;
 i20 = HEAP32[i1 + 28 >> 2] << 3;
 i17 = (HEAP32[i2 + 216 >> 2] | 0) / (HEAP32[i1 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i2 + 220 >> 2] | 0;
 i13 = i1 + 12 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i14 = (i4 | 0) / (i1 | 0) | 0;
 i15 = Math_imul(i14, i17) | 0;
 i16 = (i15 | 0) / 2 | 0;
 i3 = HEAP32[i2 + 28 >> 2] | 0;
 i2 = Math_imul(i17, i20) | 0;
 if ((i4 | 0) > 0 & (i2 - i3 | 0) > 0) {
  i1 = i3 + ~i2 | 0;
  i2 = (i2 | 2) - i3 + ((i1 | 0) > -2 ? i1 : -2) | 0;
  i1 = 0;
  do {
   i12 = (HEAP32[i18 + (i1 << 2) >> 2] | 0) + i3 | 0;
   _memset(i12 | 0, HEAP8[i12 + -1 >> 0] | 0, i2 | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP32[i13 >> 2] | 0;
 }
 if ((i1 | 0) <= 0) return;
 i10 = (i20 | 0) == 0;
 i11 = (i14 | 0) > 0;
 i12 = (i17 | 0) > 0;
 i8 = 0;
 i9 = 0;
 while (1) {
  i1 = HEAP32[i19 + (i9 << 2) >> 2] | 0;
  L12 : do if (!i10) {
   if (i11) {
    i6 = 0;
    i7 = 0;
   } else {
    i3 = ((i16 | 0) / (i15 | 0) | 0) & 255;
    if (i12) {
     i2 = 0;
     while (1) {
      HEAP8[i1 >> 0] = i3;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break L12; else i1 = i1 + 1 | 0;
     }
    } else {
     i2 = 0;
     while (1) {
      HEAP8[i1 >> 0] = i3;
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i20 | 0)) break L12; else i1 = i1 + 1 | 0;
     }
    }
   }
   while (1) {
    if (i12) {
     i4 = 0;
     i2 = 0;
     do {
      i3 = (HEAP32[i18 + (i4 + i8 << 2) >> 2] | 0) + i6 | 0;
      i5 = 0;
      while (1) {
       i2 = (HEAPU8[i3 >> 0] | 0) + i2 | 0;
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i17 | 0)) break; else i3 = i3 + 1 | 0;
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i14 | 0));
    } else i2 = 0;
    HEAP8[i1 >> 0] = (i2 + i16 | 0) / (i15 | 0) | 0;
    i7 = i7 + 1 | 0;
    if ((i7 | 0) == (i20 | 0)) break; else {
     i1 = i1 + 1 | 0;
     i6 = i6 + i17 | 0;
    }
   }
  } while (0);
  i9 = i9 + 1 | 0;
  if ((i9 | 0) >= (HEAP32[i13 >> 2] | 0)) break; else i8 = i8 + i14 | 0;
 }
 return;
}

function __ZN15AnimationBinder17InitCurveIDLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP8[i4 + 9 >> 0] = 1;
 i3 = i4 + 36 | 0;
 HEAP32[i4 + 36 >> 2] = gb + 1576256;
 HEAP32[i4 + 40 >> 2] = -1;
 HEAP32[i4 + 44 >> 2] = gb + 1576256;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 i2 = i4 + 64 | 0;
 i6 = (HEAP32[i2 >> 2] | 0) * 24 | 0;
 i7 = HEAP32[i4 + 84 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 60 >> 2] = i1;
 i2 = i1 + ((HEAP32[i2 >> 2] | 0) * 24 | 0) | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E14squash_deletedEv(i4);
 HEAP8[i4 + 8 >> 0] = 1;
 HEAP32[i4 + 12 >> 2] = gb + 1576256;
 HEAP32[i4 + 16 >> 2] = -1;
 HEAP32[i4 + 20 >> 2] = gb + 1576256;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 if (HEAP8[i4 + 80 >> 0] | 0) __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12maybe_shrinkEv(i4);
 i1 = HEAP32[i4 + 68 >> 2] | 0;
 if (i1 >>> 0 >= 1024) {
  STACKTOP = i5;
  return;
 }
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i4, 1024 - i1 | 0, 0);
 STACKTOP = i5;
 return;
}

function __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 52 >> 0] = i1;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 53 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__29to_stringEy(i8, i5, i6) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i10 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i10 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  i2 = i7;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084511 | 0, i7) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i3 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZNSt3__29to_stringEx(i8, i5, i6) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i10 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i10 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  i2 = i7;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084506 | 0, i7) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i3 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEC2ERKSA_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = 0;
 i6 = i9 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i9 + 24 | 0;
 i7 = i10 + 24 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i8 = (i9 | 0) == (i10 | 0);
 do if (!i8) {
  i4 = HEAP32[i10 >> 2] | 0;
  i7 = (i4 | 0) == 0;
  i4 = i7 ? i10 + 4 | 0 : i4;
  i5 = HEAP32[i10 + 20 >> 2] | 0;
  i2 = i9 + 4 | 0;
  if (!((HEAP32[i10 + 4 >> 2] | 0) != 0 | i7)) {
   HEAP32[i9 >> 2] = i4;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i2 >> 2] = 0;
   break;
  }
  if (i5 >>> 0 > 15) {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i9 >> 2] = i7;
   HEAP32[i2 >> 2] = i5;
   i1 = (i7 | 0) == 0 ? i1 : i7;
  }
  _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  HEAP32[i6 >> 2] = i5;
 } while (0);
 i3 = i9 + 32 | 0;
 i7 = i10 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i3 = i9 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i9 + 68 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i9 + 72 | 0;
 i5 = i10 + 72 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i9 + 52 | 0;
 HEAP8[i1 >> 0] = 0;
 if (i8) return;
 i5 = HEAP32[i10 + 48 >> 2] | 0;
 i8 = (i5 | 0) == 0;
 i5 = i8 ? i10 + 52 | 0 : i5;
 i6 = HEAP32[i10 + 68 >> 2] | 0;
 i2 = i9 + 52 | 0;
 if (!((HEAP32[i10 + 52 >> 2] | 0) != 0 | i8)) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 if (i6 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i2 >> 2] = i6;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj467ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj467ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN24OcclusionCullingSettings8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_(i5, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i2 = i5 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379174 | 0, gb + 863904 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379186 | 0, gb + 379209 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI20OcclusionCullingDataE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 32 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379236 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379254 | 0, i3, i4, 1) | 0;
 if (!i1) {
  __ZN24OcclusionCullingSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i5, i6);
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 __ZN24OcclusionCullingSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i5, i6);
 STACKTOP = i7;
 return;
}

function __ZL25GeomMTDCallback_SphereBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i9 = i7;
 HEAP32[i8 + 36 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f20 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f10 = Math_fround(f14 + f14);
 f12 = Math_fround(f13 + f13);
 f17 = Math_fround(f20 + f20);
 f19 = Math_fround(f13 * f12);
 f18 = Math_fround(f20 * f17);
 f13 = Math_fround(f10 * f13);
 f21 = Math_fround(f10 * f20);
 f11 = Math_fround(f10 * f15);
 f20 = Math_fround(f12 * f20);
 f12 = Math_fround(f12 * f15);
 f15 = Math_fround(f17 * f15);
 f17 = Math_fround(f13 + f15);
 f16 = Math_fround(f21 - f12);
 f15 = Math_fround(f13 - f15);
 f10 = Math_fround(Math_fround(1.0) - Math_fround(f14 * f10));
 f14 = Math_fround(f10 - f18);
 f13 = Math_fround(f20 + f11);
 f12 = Math_fround(f21 + f12);
 f11 = Math_fround(f20 - f11);
 f10 = Math_fround(f10 - f19);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f19) - f18);
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 HEAPF32[i8 + 12 >> 2] = f15;
 HEAPF32[i8 + 16 >> 2] = f14;
 HEAPF32[i8 + 20 >> 2] = f13;
 HEAPF32[i8 + 24 >> 2] = f12;
 HEAPF32[i8 + 28 >> 2] = f11;
 HEAPF32[i8 + 32 >> 2] = f10;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 12 >> 2] = i6;
 i6 = __ZN5physx2Gu20computeMTD_SphereBoxERNS_6PxVec3ERfRKNS0_6SphereERKNS0_3BoxE(i4, i1, i9, i8) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _UNITY_png_handle_IHDR(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i2 = i10 + 204 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 & 1 | 0) _UNITY_png_chunk_error(i10, gb + 352423 | 0);
 if ((i1 | 0) != 13) _UNITY_png_chunk_error(i10, gb + 352446 | 0);
 HEAP32[i2 >> 2] = i3 | 1;
 _UNITY_png_read_data(i10, i4, 13);
 _UNITY_png_calculate_crc(i10, i4, 13);
 _UNITY_png_crc_finish(i10, 0) | 0;
 i3 = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
 if ((i3 | 0) < 0) _UNITY_png_error(i10, gb + 353053 | 0);
 i5 = (HEAPU8[i4 + 5 >> 0] | 0) << 16 | (HEAPU8[i4 + 4 >> 0] | 0) << 24 | (HEAPU8[i4 + 6 >> 0] | 0) << 8 | (HEAPU8[i4 + 7 >> 0] | 0);
 if ((i5 | 0) < 0) _UNITY_png_error(i10, gb + 353053 | 0);
 i15 = HEAP8[i4 + 8 >> 0] | 0;
 i6 = i15 & 255;
 i1 = HEAP8[i4 + 9 >> 0] | 0;
 i7 = i1 & 255;
 i13 = HEAP8[i4 + 10 >> 0] | 0;
 i8 = i13 & 255;
 i14 = HEAP8[i4 + 11 >> 0] | 0;
 i9 = i14 & 255;
 i4 = HEAP8[i4 + 12 >> 0] | 0;
 i2 = i4 & 255;
 HEAP32[i10 + 344 >> 2] = i3;
 HEAP32[i10 + 348 >> 2] = i5;
 HEAP8[i10 + 432 >> 0] = i15;
 HEAP8[i10 + 428 >> 0] = i4;
 HEAP8[i10 + 431 >> 0] = i1;
 HEAP8[i10 + 600 >> 0] = i14;
 HEAP8[i10 + 620 >> 0] = i13;
 switch (i1 << 24 >> 24) {
 case 6:
  {
   HEAP8[i10 + 435 >> 0] = 4;
   i1 = 4;
   break;
  }
 case 4:
  {
   HEAP8[i10 + 435 >> 0] = 2;
   i1 = 2;
   break;
  }
 case 2:
  {
   HEAP8[i10 + 435 >> 0] = 3;
   i1 = 3;
   break;
  }
 default:
  {
   HEAP8[i10 + 435 >> 0] = 1;
   i1 = 1;
  }
 }
 i1 = Math_imul(i1, i6) | 0;
 HEAP8[i10 + 434 >> 0] = i1;
 i1 = i1 & 255;
 if (i1 >>> 0 > 7) {
  i14 = Math_imul(i1 >>> 3, i3) | 0;
  i15 = i10 + 360 | 0;
  HEAP32[i15 >> 2] = i14;
  _UNITY_png_set_IHDR(i10, i11, i3, i5, i6, i7, i2, i8, i9);
  STACKTOP = i12;
  return;
 } else {
  i14 = ((Math_imul(i1, i3) | 0) + 7 | 0) >>> 3;
  i15 = i10 + 360 | 0;
  HEAP32[i15 >> 2] = i14;
  _UNITY_png_set_IHDR(i10, i11, i3, i5, i6, i7, i2, i8, i9);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_19PxContactModifyPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 80 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 721715 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 80 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 68 >> 2];
   i9 = i2 + 72 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1 + 72 | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 80 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 80 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj665ES3_RKNS_19PxVehicleClutchDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 256; else i1 = (HEAP32[i1 >> 2] | 0) + 256 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ES2_RKNS_19PxVehicleClutchDataES6_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj458ES3_RKNS_22PxJointLinearLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj458ES2_RKNS_22PxJointLinearLimitPairES6_EEKNS_35PxJointLinearLimitPairGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5Unity17ConfigurableJoint24SetTargetAngularVelocityERK8Vector3f(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f13 < Math_fround(340282326000000008404918.0e15);
 f13 = i1 ? f13 : Math_fround(340282326000000008404918.0e15);
 i1 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(340282326000000008404918.0e15);
 i1 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(340282326000000008404918.0e15);
 i1 = f13 > Math_fround(-340282326000000008404918.0e15);
 f13 = i1 ? f13 : Math_fround(-340282326000000008404918.0e15);
 i1 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(-340282326000000008404918.0e15);
 i1 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i5 + 336 >> 2] = f13;
 i1 = i5 + 340 | 0;
 HEAPF32[i1 >> 2] = f12;
 i2 = i5 + 344 | 0;
 HEAPF32[i2 >> 2] = f11;
 i3 = i5 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0) | 0) & 1) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 184 >> 2] | 0, i4 | 0, i8 | 0, i9 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 + 336 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 8 >> 2] = i4;
 i5 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0, i8 | 0, i9 | 0);
 i9 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i6 | 0, i7 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj(i12, i15, i8, i9, i10, i11) {
 i12 = i12 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 if (!i15) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i14 = _PxGetFoundation() | 0;
 i14 = mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0;
 i14 = mftCall_iiiiii(i7 | 0, i2 | 0, 12, (i14 ? gb + 699407 | 0 : gb + 837976 | 0) | 0, gb + 676016 | 0, 2639) | 0;
 HEAP32[i14 >> 2] = 0;
 i2 = i14 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = ((i10 | 0) != -1 & 1) + i8 | 0;
 i1 = Math_imul(((i11 | 0) != -1 & 1) + i9 | 0, i7) | 0;
 i1 = ((i1 & 127 | 0 ? i1 + 128 & -128 : i1) + 31 | 0) >>> 5;
 if (!i1) {
  i3 = 0;
  i1 = 0;
 } else {
  HEAP32[i2 >> 2] = i1;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14 + 8 | 0, i1 << 2, gb + 769739 | 0, 352) | 0;
  HEAP32[i14 >> 2] = i3;
  i1 = HEAP32[i2 >> 2] << 2;
 }
 _memset(i3 | 0, 0, i1 | 0) | 0;
 if (!((i9 | 0) == 0 | (i8 | 0) == 0)) {
  i5 = HEAP32[i15 >> 2] | 0;
  i1 = 0;
  i2 = 0;
  i6 = 0;
  while (1) {
   i1 = ((i2 | 0) == (i11 | 0) ? i7 : 0) + i1 | 0;
   i3 = 0;
   i4 = i6;
   while (1) {
    i1 = ((i3 | 0) == (i10 | 0) & 1) + i1 | 0;
    if (HEAP32[i12 + 384 + ((i4 & 31) << 2) >> 2] & HEAP32[i5 + (i4 >>> 5 << 2) >> 2] | 0) {
     i17 = (HEAP32[i14 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
     HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | HEAP32[i12 + 384 + ((i1 & 31) << 2) >> 2];
    }
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i8 | 0)) break; else i4 = i4 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i9 | 0)) break; else i6 = i6 + i8 | 0;
  }
 }
 i1 = HEAP32[i15 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i15 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i15 + 8 | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i15);
 i17 = i14;
 STACKTOP = i16;
 return i17 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj690ES3_NS_23PxVehicleDriveSimDataNWES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 104 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 212; else i1 = (HEAP32[i1 >> 2] | 0) + 212 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj690ES2_NS_23PxVehicleDriveSimDataNWES6_EEKNS_36PxVehicleDriveSimDataNWGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj678ES3_NS_23PxVehicleDriveSimData4WES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 120 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 212; else i1 = (HEAP32[i1 >> 2] | 0) + 212 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj678ES2_NS_23PxVehicleDriveSimData4WES6_EEKNS_36PxVehicleDriveSimData4WGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __Z34FillScriptingArrayFromUnityObjectsINSt3__26vectorI4PPtrI6ObjectENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i7 = i13;
 i8 = i2 + 4 | 0;
 i12 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2;
 i11 = __Z21GetScriptingArraySizeP11Il2CppArray(i10) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) != (HEAP32[i8 >> 2] | 0)) {
  i5 = i2;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   do if (!i2) i2 = 0; else {
    HEAP32[i7 >> 2] = i2;
    i2 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i2) i9 = 10; else {
     if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
      i3 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[i2 + 32 >> 2] | 0;
      i2 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
      i3 = HEAP32[i6 >> 2] | 0;
      i14 = HEAP32[i2 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i2 = (i3 | 0) == -1 ? i14 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i14 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i9 = 10; else {
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (i2 | 0) break;
     }
    }
    if ((i9 | 0) == 10) i9 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   } while (0);
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i10, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
 }
 if ((i1 | 0) >= (i11 | 0)) {
  STACKTOP = i13;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i10, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE17handleBufferFlushEPKhj(i7, i13, i14) {
 i7 = i7 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[i7 + 72 >> 2] | 0;
 i12 = (i11 | 0) == 0;
 if (!i12) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 + 4 >> 2] | 0);
 L4 : do if ((i13 | 0) != 0 & (i14 | 0) != 0) {
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
  i8 = i7 + 8 | 0;
  i10 = i7 + 20 | 0;
  i9 = i7 + 16 | 0;
  i2 = i7 + 44 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (((HEAP32[i10 >> 2] | 0) + i14 - (HEAP32[i9 >> 2] | 0) | 0) >>> 0 >= i1 >>> 0) {
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (i1 >>> 0 <= i14 >>> 0) {
   i3 = HEAP32[i7 + 36 >> 2] | 0;
   if (!i3) break;
   i1 = i7 + 32 | 0;
   i2 = 0;
   while (1) {
    i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i13 | 0, i14 | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break L4;
   }
  }
  i1 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i3;
  i5 = i1 - i4 | 0;
  i2 = i5 + i14 | 0;
  i6 = i7 + 24 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
   i4 = i2 << 1;
   if (!i4) {
    i2 = 0;
    i1 = i3;
   } else {
    i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
    i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i7 + 12 >> 2] | 0, gb + 740723 | 0, 100) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   if (i1 | 0) {
    _memcpy(i2 | 0, i1 | 0, i5 | 0) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    if (i1 | 0) {
     i8 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
    }
   }
   HEAP32[i9 >> 2] = i2;
   i1 = i2 + i5 | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = i2 + i4;
  }
  _memcpy(i1 | 0, i13 | 0, i14 | 0) | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i14;
 } while (0);
 if (i12) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i11 + 4 >> 2] | 0);
 return;
}

function __ZN22RenderingCommandBufferC2ERK10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i6 = i5;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 56592 + 8;
 __ZN14GrowableBufferC2ERK10MemLabelIdjj(i2 + 8 | 0, i1, 256, 8192);
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 i7 = i1;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i6);
 i8 = i4;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i2 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i1;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i6);
 i8 = i4;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i2 + 64 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i1;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i6);
 i6 = i4;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2 + 84 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i2 + 164 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 176 >> 2] = i3;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(32, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 + 172 >> 2] = -2147483616;
 HEAP32[i2 + 168 >> 2] = 22;
 i1 = i4;
 i2 = gb + 423743 | 0;
 i3 = i1 + 22 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i4 + 22 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 24 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i6 = HEAP32[i9 >> 2] | 0;
    HEAP32[i6 + (i1 * 12 | 0) >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 12 | 0;
 HEAP32[i8 >> 2] = i3;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i8, 4);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc5Scene10removeBodyERNS0_7BodySimE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 60 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(HEAP32[i8 + 96 >> 2] | 0, i1, 0);
 i6 = HEAP32[i7 + 52 >> 2] | 0;
 i3 = i8 + 1124 | 0;
 i4 = i8 + 1128 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L4 : do if (!i5) i1 = 0; else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i2;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
 }
 i3 = i8 + 1136 | 0;
 i4 = i8 + 1140 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L13 : do if (!i5) i1 = 0; else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L13;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 if ((i1 | 0) != (i5 | 0)) {
  i5 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
 }
 i4 = HEAP32[i7 + 56 >> 2] | 0;
 i5 = i8 + 1252 | 0;
 i6 = (i4 + 32 | 0) >>> 5;
 i7 = i8 + 1256 | 0;
 if (i6 >>> 0 <= (HEAP32[i7 >> 2] & 2147483647) >>> 0) {
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i4 & 31;
  i7 = 1 << i7;
  i8 = i4 >>> 5;
  i8 = i6 + (i8 << 2) | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  i7 = i6 | i7;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i1 = i8 + 1260 | 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i6 << 2, gb + 769739 | 0, 329) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  _memcpy(i2 | 0, i3 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  if ((HEAP32[i7 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i5 >> 2] | 0);
 }
 i8 = HEAP32[i7 >> 2] | 0;
 _memset(i2 + ((i8 & 2147483647) << 2) | 0, 0, i6 - i8 << 2 | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i7 >> 2] = i6;
 i6 = i2;
 i7 = i4 & 31;
 i7 = 1 << i7;
 i8 = i4 >>> 5;
 i8 = i6 + (i8 << 2) | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i6 | i7;
 HEAP32[i8 >> 2] = i7;
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 32 | 0;
 i2 = i3;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 28 | 0, i5);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer8TransferIN11AssetBundle9AssetInfoEEEvRT_PKc17TransferMetaFlags(i4, i2 + 16 | 0, HEAP32[gb + 37224 >> 2] | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i1;
 i4 = i5 + 120 | 0;
 if ((HEAP32[i5 + 176 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[i5 + 168 >> 2] | 0;
  i3 = HEAP32[i5 + 172 >> 2] | 0;
  i1 = i2 + (i3 * 20 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i6, i5 + 116 | 0, i2);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 + 168 >> 2] | 0;
  i3 = HEAP32[i5 + 172 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 * 20 | 0) | 0 : i2 + (i1 * 20 | 0) | 0;
 }
 if ((i1 | 0) != (i2 + (i3 * 20 | 0) | 0)) if (HEAP8[i1 + 17 >> 0] | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  if (!(HEAP8[i5 + 124 >> 0] | 0)) i7 = 8; else if (!(HEAP32[i4 >> 2] | 0)) i7 = 8; else {
   i3 = (HEAP32[i5 + 128 >> 2] | 0) == (HEAP32[i1 >> 2] | 0);
   i2 = i5 + 128 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   if (!i3) i7 = 10;
  }
  if ((i7 | 0) == 8) {
   i3 = i5 + 128 | 0;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   i7 = 10;
  }
  if ((i7 | 0) == 10) {
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP8[i5 + 188 >> 0] = 1;
  }
  __ZN17PersistentManager63RegisterAndAwakeThreadedObjectAndUnlockIntegrationMutexInternalERK17ThreadedAwakeData(i5, i6);
  i7 = HEAP32[i6 + 8 >> 2] | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN15TerrainRenderer22ReloadPrecomputedErrorEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 8 | 0;
 i2 = i12;
 i4 = i6 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i11 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i11 + 28 >> 2] | 0;
   i3 = HEAP32[i11 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 8;
  }
 }
 if ((i5 | 0) == 6) i5 = 8;
 if ((i5 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i1 = i1 + 248 | 0;
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 i9 = i6 + 20 | 0;
 if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i10 = i1 + 80 | 0;
 i11 = i1 + 24 | 0;
 i8 = i1 + 92 | 0;
 do {
  i6 = HEAP32[i2 + 24 >> 2] | 0;
  i7 = HEAP32[i2 + 28 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  i1 = 1 << HEAP32[i10 >> 2];
  if ((i5 | 0) > 0) {
   i3 = i1;
   i1 = 0;
   i4 = 0;
   do {
    i1 = (Math_imul(i3, i3) | 0) + i1 | 0;
    i3 = i3 >> 1;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
  } else {
   i3 = i1;
   i1 = 0;
  }
  i7 = i1 + i6 + (Math_imul(i3, i7) | 0) | 0;
  f13 = Math_fround(HEAPF32[(HEAP32[i11 >> 2] | 0) + (i7 << 2) >> 2]);
  HEAPF32[i2 + 12 >> 2] = Math_fround(f13 * Math_fround(HEAPF32[i8 >> 2]));
  i7 = i2 + 60 | 0;
  HEAP8[i7 >> 0] = HEAP8[i7 >> 0] | 2;
  i2 = i2 + 64 | 0;
 } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
 STACKTOP = i12;
 return;
}

function __ZN10HttpHelper18IsHeaderValueValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP8[i1 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i1 >> 2] | 0 : i1;
 L1 : do if (!i9) {
  i2 = 0;
  i1 = 0;
 } else {
  i7 = i2 ? 4 : 1;
  i6 = i2 & 1;
  i2 = 0;
  i1 = 0;
  i3 = 0;
  L3 : while (1) {
   i4 = HEAP8[i8 + i3 >> 0] | 0;
   L5 : do switch (i4 << 24 >> 24) {
   case 92:
    {
     i5 = i2;
     i4 = i2 ? 4 : 1;
     i3 = (i2 & 1) + i3 | 0;
     i10 = 15;
     break;
    }
   case 34:
    {
     i2 = i2 ^ 1;
     break;
    }
   default:
    {
     L7 : do if (i2) {
      if (i4 << 24 >> 24 != 13) i10 = 14;
     } else switch (i4 << 24 >> 24) {
     case 13:
      break L7;
     case 41:
      if ((i1 | 0) < 1) {
       i1 = 0;
       i10 = 18;
       break L3;
      } else {
       i1 = i1 + -1 | 0;
       i10 = 14;
       break L7;
      }
     case 40:
      {
       i5 = 0;
       i4 = i7;
       i1 = i1 + i6 | 0;
       i10 = 15;
       break L5;
      }
     default:
      {
       i10 = 14;
       break L7;
      }
     } while (0);
     if ((i10 | 0) == 14) {
      i5 = i2;
      i4 = (i4 << 24 >> 24 < 32 | i4 << 24 >> 24 == 127) & 1;
      i10 = 15;
      break L5;
     }
     i4 = i3 + 2 | 0;
     if (i4 >>> 0 >= i9 >>> 0) {
      i1 = 0;
      i10 = 18;
      break L3;
     }
     if ((HEAP8[i8 + (i3 + 1) >> 0] | 0) != 10) {
      i1 = 0;
      i10 = 18;
      break L3;
     }
     switch (HEAP8[i8 + i4 >> 0] | 0) {
     case 9:
     case 32:
      {
       i3 = i4;
       break;
      }
     default:
      {
       i1 = 0;
       i10 = 18;
       break L3;
      }
     }
    }
   } while (0);
   if ((i10 | 0) == 15) {
    i10 = 0;
    switch (i4 & 7) {
    case 4:
    case 0:
     {
      i2 = i5;
      break;
     }
    default:
     {
      i1 = 0;
      i10 = 18;
      break L3;
     }
    }
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i9 >>> 0) break L1;
  }
  if ((i10 | 0) == 18) return i1 | 0;
 } while (0);
 i10 = (i2 | (i1 | 0) != 0) ^ 1;
 return i10 | 0;
}

function __ZNK5Umbra18ReceiverMaskCuller21computeLightSpaceAABBERNS_7Vector3ES2_RKS1_S4_(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i7 = i5 + 4 | 0;
 i8 = i6 + 4 | 0;
 i9 = i5 + 8 | 0;
 i10 = i6 + 8 | 0;
 i1 = 0;
 do {
  f16 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
  f14 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
  f15 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
  f17 = Math_fround(f16 * Math_fround(HEAPF32[i5 >> 2]));
  f13 = Math_fround(f16 * Math_fround(HEAPF32[i6 >> 2]));
  i11 = i3 + (i1 << 2) | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + (f17 <= f13 ? f17 : f13));
  HEAPF32[i11 >> 2] = f13;
  f17 = Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2]));
  f18 = Math_fround(f14 * Math_fround(HEAPF32[i8 >> 2]));
  f18 = Math_fround(f13 + (f17 <= f18 ? f17 : f18));
  HEAPF32[i11 >> 2] = f18;
  f17 = Math_fround(f12 * Math_fround(HEAPF32[i9 >> 2]));
  f13 = Math_fround(f12 * Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i11 >> 2] = Math_fround(f15 + Math_fround(f18 + (f17 <= f13 ? f17 : f13)));
  f13 = Math_fround(f16 * Math_fround(HEAPF32[i5 >> 2]));
  f16 = Math_fround(f16 * Math_fround(HEAPF32[i6 >> 2]));
  i11 = i4 + (i1 << 2) | 0;
  f16 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + (f13 >= f16 ? f13 : f16));
  HEAPF32[i11 >> 2] = f16;
  f13 = Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2]));
  f14 = Math_fround(f14 * Math_fround(HEAPF32[i8 >> 2]));
  f14 = Math_fround(f16 + (f13 >= f14 ? f13 : f14));
  HEAPF32[i11 >> 2] = f14;
  f13 = Math_fround(f12 * Math_fround(HEAPF32[i9 >> 2]));
  f12 = Math_fround(f12 * Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i11 >> 2] = Math_fround(f15 + Math_fround(f14 + (f13 >= f12 ? f13 : f12)));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 return;
}

function __ZNK5Umbra11Transformer16getFrustumCornerEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 i20 = i3 >> 2;
 f4 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 12 >> 2]);
 i20 = i3 >>> 1 & 1 | 2;
 f19 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 128 + (i20 << 4) + 12 >> 2]);
 i3 = i3 & 1 | 4;
 f17 = Math_fround(HEAPF32[i2 + 128 + (i3 << 4) >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 128 + (i3 << 4) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 128 + (i3 << 4) + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 128 + (i3 << 4) + 12 >> 2]);
 f12 = Math_fround(Math_fround(f15 * f7) - Math_fround(f16 * f9));
 f5 = Math_fround(Math_fround(f16 * f17) - Math_fround(f19 * f7));
 f18 = Math_fround(Math_fround(f19 * f9) - Math_fround(f15 * f17));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f10 * f18) + Math_fround(Math_fround(f4 * f12) + Math_fround(f8 * f5))));
 f5 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f10 * f19) - Math_fround(f4 * f16)) * f14) + Math_fround(Math_fround(f13 * f5) + Math_fround(f11 * Math_fround(Math_fround(f4 * f7) - Math_fround(f10 * f17))))) * f6));
 f4 = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f4 * f15) - Math_fround(f8 * f19)) * f14) + Math_fround(Math_fround(f13 * f18) + Math_fround(f11 * Math_fround(Math_fround(f8 * f17) - Math_fround(f4 * f9))))) * f6));
 HEAPF32[i1 >> 2] = Math_fround(-Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f16) - Math_fround(f10 * f15)) * f14) + Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * Math_fround(Math_fround(f10 * f9) - Math_fround(f8 * f7))))) * f6));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj664ES3_RKNS_18PxVehicleGearsDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 88 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ES2_RKNS_18PxVehicleGearsDataES6_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5Unity5Joint22JointTransferPreNoAxisI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 92 | 0, i5);
 i1 = i7 + 40 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN30AudioEffectInternalDescriptionC2EP26UnityAudioEffectDefinition(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 HEAP32[i4 + 200 >> 2] = 0;
 i1 = i4;
 i3 = i1 + 92 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i4 + 96 | 0;
 i2 = i5;
 i3 = i1 + 104 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i9 = i5 + 32 | 0;
 _strncpy(i4, i9, 32) | 0;
 _strncpy(i4 + 128 | 0, i9, 32) | 0;
 i9 = i5 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = i1;
 i10 = i1 * 48 | 0;
 i6 = __Znaj(i1 >>> 0 > 89478485 ? -1 : i10) | 0;
 i8 = i4 + 64 | 0;
 HEAP32[i8 >> 2] = i6;
 _memset(i6 | 0, 0, i10 | 0) | 0;
 HEAP32[i4 + 40 >> 2] = fb + 2472;
 HEAP32[i4 + 44 >> 2] = fb + 2473;
 HEAP32[i4 + 48 >> 2] = fb + 2474;
 HEAP32[i4 + 52 >> 2] = fb + 138;
 HEAP32[i4 + 56 >> 2] = fb + 922;
 HEAP32[i4 + 68 >> 2] = fb + 3;
 HEAP32[i4 + 72 >> 2] = fb + 168;
 i10 = i1 * 56 | 0;
 i3 = __Znaj(i1 >>> 0 > 76695844 ? -1 : i10) | 0;
 i7 = i4 + 180 | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i5 + 84 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 _memcpy(i3 | 0, i2 | 0, i10 | 0) | 0;
 if (!i1) return;
 i1 = 0;
 i4 = i6;
 while (1) {
  HEAP32[i4 + (i1 * 48 | 0) + 8 >> 2] = HEAP32[i2 + (i1 * 56 | 0) + 44 >> 2];
  HEAP32[i3 + (i1 * 56 | 0) + 44 >> 2] = HEAP32[i2 + (i1 * 56 | 0) + 44 >> 2];
  i10 = (_strlen(HEAP32[i2 + (i1 * 56 | 0) + 32 >> 2] | 0) | 0) + 1 | 0;
  i6 = __Znaj(i10) | 0;
  HEAP32[i4 + (i1 * 48 | 0) + 44 >> 2] = i6;
  _strncpy(i6, HEAP32[i2 + (i1 * 56 | 0) + 32 >> 2] | 0, i10) | 0;
  _strncpy((HEAP32[i8 >> 2] | 0) + (i1 * 48 | 0) + 28 | 0, (HEAP32[i5 >> 2] | 0) + (i1 * 56 | 0) + 16 | 0, 16) | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + (i1 * 48 | 0) >> 2] = HEAP32[i10 + (i1 * 56 | 0) + 36 >> 2];
  HEAP32[i6 + (i1 * 48 | 0) + 4 >> 2] = HEAP32[i10 + (i1 * 56 | 0) + 40 >> 2];
  _strncpy(i6 + (i1 * 48 | 0) + 12 | 0, i10 + (i1 * 56 | 0) | 0, 16) | 0;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) break;
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 return;
}

function __ZN12MeshCollider6CreateEPK9Rigidbody(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 16 | 0;
 i3 = i10 + 12 | 0;
 i9 = i10;
 if (HEAP32[i6 + 36 >> 2] | 0) mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0);
 i4 = i6 + 64 | 0;
 HEAP32[i6 + 68 >> 2] = HEAP32[i4 >> 2];
 HEAP8[i6 + 122 >> 0] = HEAP8[i6 + 121 >> 0] | 0;
 i8 = __ZN12MeshCollider19ExtractMeshGeometryER8Vector3f(i6, i9) | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i5 = 9; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i11 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i11 + (i3 << 3) | 0;
   i2 = i11;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i2, i3);
   i1 = HEAP32[i1 >> 2] | 0;
   i11 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 11;
  }
 }
 if ((i5 | 0) == 9) i5 = 11;
 if ((i5 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i3 = i6 + 72 | 0;
 i2 = i1 + 232 | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i6 + 76 | 0; else {
   i11 = i6 + 76 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
   i1 = i11;
  }
  i11 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i11;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 }
 __ZN12MeshCollider11CreateShapeEPvPK9RigidbodyRK8Vector3f(i6, i8, i7, i9);
 HEAP8[i6 + 120 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function _UNITY_png_handle_PLTE(i9, i8, i3) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i7 = i11;
 i1 = i9 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 1)) _UNITY_png_chunk_error(i9, gb + 352205 | 0);
 if (i2 & 2 | 0) _UNITY_png_chunk_error(i9, gb + 352436 | 0);
 if (i2 & 4 | 0) {
  _UNITY_png_crc_finish(i9, i3) | 0;
  _UNITY_png_chunk_benign_error(i9, gb + 352423 | 0);
  STACKTOP = i11;
  return;
 }
 HEAP32[i1 >> 2] = i2 | 2;
 i1 = i9 + 431 | 0;
 if (!(HEAP8[i1 >> 0] & 2)) {
  _UNITY_png_crc_finish(i9, i3) | 0;
  _UNITY_png_chunk_benign_error(i9, gb + 352926 | 0);
  STACKTOP = i11;
  return;
 }
 if (!(i3 >>> 0 < 769 & ((i3 >>> 0) % 3 | 0 | 0) == 0)) {
  _UNITY_png_crc_finish(i9, i3) | 0;
  if ((HEAP8[i1 >> 0] | 0) == 3) _UNITY_png_chunk_error(i9, gb + 352446 | 0);
  _UNITY_png_chunk_benign_error(i9, gb + 352446 | 0);
  STACKTOP = i11;
  return;
 }
 i5 = (i3 | 0) / 3 | 0;
 if ((i3 | 0) > 2) {
  i3 = i7 + 1 | 0;
  i4 = i7 + 2 | 0;
  i1 = 0;
  i2 = i6;
  while (1) {
   _UNITY_png_read_data(i9, i7, 3);
   _UNITY_png_calculate_crc(i9, i7, 3);
   HEAP8[i2 >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP8[i2 + 1 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i2 + 2 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) break; else i2 = i2 + 3 | 0;
  }
 }
 _UNITY_png_crc_finish(i9, 0) | 0;
 _UNITY_png_set_PLTE(i9, i8, i6, i5);
 i2 = i9 + 424 | 0;
 do if (!(HEAP16[i2 >> 1] | 0)) {
  if (!i8) {
   STACKTOP = i11;
   return;
  }
  i3 = i8 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 & 16) {
   HEAP16[i2 >> 1] = 0;
   i1 = i3;
   i10 = 23;
  }
 } else {
  HEAP16[i2 >> 1] = 0;
  if (i8 | 0) {
   i1 = i8 + 8 | 0;
   i10 = 23;
   break;
  }
  _UNITY_png_chunk_benign_error(i9, gb + 352951 | 0);
  STACKTOP = i11;
  return;
 } while (0);
 if ((i10 | 0) == 23) {
  HEAP16[i8 + 22 >> 1] = 0;
  _UNITY_png_chunk_benign_error(i9, gb + 352951 | 0);
  i1 = HEAP32[i1 >> 2] | 0;
 }
 if (!(i1 & 32)) {
  STACKTOP = i11;
  return;
 }
 _UNITY_png_chunk_benign_error(i9, gb + 352970 | 0);
 STACKTOP = i11;
 return;
}

function __ZNK17ProceduralTexture11GetPixels32EiiiiP11ColorRGBA32(i7, i1, i2, i3, i4, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i1 = i6;
 i4 = i6 + 32 | 0;
 i5 = i6 + 12 | 0;
 if ((HEAP32[i7 + 176 >> 2] | 0) != 1) {
  i8 = HEAP32[i7 + 84 >> 2] | 0;
  HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __Z6FormatPKcz(i4, gb + 431504 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 431386 | 0, 375, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 i1 = HEAP32[i7 + 84 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 172 >> 2] & 4096)) {
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i4, gb + 431590 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 431386 | 0, 380, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 i1 = i7 + 104 | 0;
 if ((HEAP32[i7 + 108 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 i2 = i7 + 140 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 & -2 | 0) != 4) {
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 i10 = i7 + 128 | 0;
 i12 = HEAP32[i10 >> 2] | 0;
 i9 = i7 + 132 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 i7 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i12, i3) | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i4, i12, i11, i7, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 i7 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i5, i7, i3, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i7, 4) | 0, 4, i8);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i4, 0);
 i8 = 1;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj154ES3_RKNS_29PxClothMotionConstraintConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 72 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 156; else i1 = (HEAP32[i1 >> 2] | 0) + 156 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj154ES2_RKNS_29PxClothMotionConstraintConfigES6_EEKNS_42PxClothMotionConstraintConfigGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj683ES3_NS_21PxVehicleDriveSimDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 88 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 216; else i1 = (HEAP32[i1 >> 2] | 0) + 216 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj683ES2_NS_21PxVehicleDriveSimDataES6_EEKNS_34PxVehicleDriveSimDataGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN2UI13CanvasManager30EmitScreenSpaceCamerasGeometryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i10 = i12 + 16 | 0;
 i2 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i8 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i2, i8, Math_fround(4.0), 0);
 HEAP16[i10 >> 1] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  if ((__ZNK2UI6Canvas13GetRenderModeEv(i6) | 0) == 1) {
   i1 = i6;
   while (1) {
    i3 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
   i5 = HEAP32[i1 + 40 >> 2] | 0;
   if (!i5) i1 = 0; else {
    HEAP32[i9 >> 2] = i5;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 12; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i3 = HEAP32[i8 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i11 = 12; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 14;
     }
    }
    if ((i11 | 0) == 12) i11 = 14;
    if ((i11 | 0) == 14) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    }
   }
   __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb(i6, i1, i10, 0);
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i7 >> 2] | 0));
 STACKTOP = i12;
 return;
}

function __ZN18UnityConnectClientD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i4 >> 2] = gb + 189004 + 8;
 HEAP32[i4 + 680 >> 2] = gb + 189004 + 68;
 __ZN18UnityConnectClient25UnregisterGlobalCallbacksEv(i4);
 i1 = i4 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i4 + 280 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i2 = i4 + 113 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    HEAP8[i2 >> 0] = 1;
    L5 : do if ((HEAP32[i1 >> 2] | 0) != 5) {
     switch (HEAP32[i1 >> 2] | 0) {
     case 5:
     case 0:
      break L5;
     default:
      {}
     }
     mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0);
    } while (0);
    HEAP8[i2 >> 0] = 0;
    __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE(i4 + 548 | 0, HEAP32[i4 + 544 >> 2] | 0);
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) {
     __ZN19CloudServiceHandler7ReleaseEv(i1);
     HEAP32[i3 >> 2] = 0;
    }
   }
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE(i4 + 768 | 0, HEAP32[i4 + 772 >> 2] | 0);
 HEAP32[i4 + 688 >> 2] = gb + 189084 + 8;
 i1 = i4 + 724 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i4 + 736 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 }
 i1 = i4 + 708 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i4 + 720 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 }
 i1 = i4 + 692 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN22BaseUnityConnectClientD2Ev(i4);
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i4 + 704 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 __ZN22BaseUnityConnectClientD2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i2 = HEAP32[i2 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 while (1) {
  i7 = i1;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = i3;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i4 + 4 >> 2] = i6;
  i4 = i3 + 8 | 0;
  i6 = i1 + 8 | 0;
  i7 = HEAP8[i6 + 11 >> 0] | 0;
  i5 = i7 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i6 >> 2] | 0 : i6;
  i7 = i5 ? HEAP32[i1 + 12 >> 2] | 0 : i7 & 255;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i5 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 + 20 >> 2] = i5;
  if (i7 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
   i5 = HEAP32[i3 + 20 >> 2] | 0;
   i13 = 6;
  } else if (i7 >>> 0 < 11) {
   HEAP8[i4 + 11 >> 0] = i7;
   if (i7) i13 = 8;
  } else i13 = 6;
  if ((i13 | 0) == 6) {
   i14 = i7 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i8 >> 2] = i5;
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i4 >> 2] = i5;
   HEAP32[i3 + 16 >> 2] = i14 | -2147483648;
   HEAP32[i3 + 12 >> 2] = i7;
   i4 = i5;
   i13 = 8;
  }
  if ((i13 | 0) == 8) {
   i13 = 0;
   _memcpy(i4 | 0, i6 | 0, i7 | 0) | 0;
  }
  HEAP8[i4 + i7 >> 0] = 0;
  i3 = i3 + 24 | 0;
  i1 = i1 + 24 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP8[i3 + 8 >> 0] = HEAP8[i1 + 8 >> 0] | 0;
  i1 = i2 + 36 | 0;
  i3 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
  HEAP32[i9 >> 2] = i3;
  if ((i1 | 0) == (i10 | 0)) break; else i2 = i1;
 }
 STACKTOP = i12;
 return;
}

function __ZNK5physx16PxsBroadPhaseMBP10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i1, i14, i2, i13) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[i1 + 84 >> 2] | 0;
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 i11 = HEAP32[i11 + 28 >> 2] | 0;
 i12 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 if (!i12) return i12 | 0;
 i9 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 i10 = 0;
 do {
  i8 = i10 + i13 | 0;
  i1 = i14 + (i10 * 40 | 0) | 0;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 4 >> 2] << 1;
  HEAP32[i1 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 8 >> 2] << 1;
  i2 = i14 + (i10 * 40 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 12 >> 2] << 1;
  i3 = i14 + (i10 * 40 | 0) + 8 | 0;
  HEAP32[i3 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 16 >> 2] << 1;
  i4 = i14 + (i10 * 40 | 0) + 12 | 0;
  HEAP32[i4 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 20 >> 2] << 1;
  i5 = i14 + (i10 * 40 | 0) + 16 | 0;
  HEAP32[i5 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 24 >> 2] << 1;
  i6 = i14 + (i10 * 40 | 0) + 20 | 0;
  HEAP32[i6 >> 2] = (i7 | 0) < 0 ? i7 & 2147483646 : ~i7;
  i7 = HEAP32[i11 + (i8 * 40 | 0) + 28 >> 2] | 0;
  if (!i7) {
   HEAP32[i1 >> 2] = 2122317823;
   HEAP32[i2 >> 2] = 2122317823;
   HEAP32[i3 >> 2] = 2122317823;
   HEAP32[i4 >> 2] = -25165825;
   HEAP32[i5 >> 2] = -25165825;
   HEAP32[i6 >> 2] = -25165825;
   HEAP32[i14 + (i10 * 40 | 0) + 24 >> 2] = 0;
   i4 = 0;
   i3 = 0;
   i1 = 0;
   i2 = 0;
  } else {
   HEAP32[i14 + (i10 * 40 | 0) + 24 >> 2] = HEAP32[i11 + (i8 * 40 | 0) + 36 >> 2];
   i4 = HEAP32[i7 + 92 >> 2] | 0;
   i3 = HEAP32[i7 + 84 >> 2] | 0;
   i1 = (HEAP32[i11 + (i8 * 40 | 0) + 32 >> 2] | 0) != 0 & 1;
   i2 = 1;
  }
  HEAP8[i14 + (i10 * 40 | 0) + 36 >> 0] = i2;
  HEAP8[i14 + (i10 * 40 | 0) + 37 >> 0] = i1;
  HEAP32[i14 + (i10 * 40 | 0) + 28 >> 2] = i3;
  HEAP32[i14 + (i10 * 40 | 0) + 32 >> 2] = i4;
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i9 | 0));
 return i12 | 0;
}

function __ZN6b2Body11SetMassDataEPK10b2MassData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 if (HEAP32[(HEAP32[i1 + 88 >> 2] | 0) + 102868 >> 2] & 2 | 0) return;
 if ((HEAP32[i1 >> 2] | 0) != 2) return;
 i3 = i1 + 124 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i1 + 128 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = !(f6 <= Math_fround(0.0));
 f6 = i7 ? f6 : Math_fround(1.0);
 HEAPF32[i1 + 116 >> 2] = f6;
 HEAPF32[i1 + 120 >> 2] = Math_fround(Math_fround(1.0) / f6);
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 if (f5 > Math_fround(0.0)) if (!(HEAP16[i1 + 4 >> 1] & 16)) {
  f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f9 = Math_fround(f9 * f9);
  f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f6 = Math_fround(f5 - Math_fround(f6 * Math_fround(f9 + Math_fround(f8 * f8))));
  HEAPF32[i3 >> 2] = f6;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(1.0) / f6);
 }
 i4 = i1 + 44 | 0;
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = i1 + 48 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i3 = i2 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = i1 + 28 | 0;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i3;
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f12 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f5 * f12);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 - Math_fround(f11 * f10));
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f6);
 f10 = Math_fround(Math_fround(f12 * f11) + Math_fround(f5 * f10));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i1 + 16 >> 2]));
 HEAPF32[i4 >> 2] = f6;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i1 + 36 >> 2] = f6;
 HEAPF32[i1 + 40 >> 2] = f10;
 f5 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f8 = Math_fround(f5 * Math_fround(f10 - f8));
 f9 = Math_fround(f5 * Math_fround(f6 - f9));
 i7 = i1 + 64 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 i7 = i1 + 68 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i7 >> 2]));
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 8 >> 2] | 0;
   i3 = i11 + 12 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 << 3) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 40 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 20 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 36 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 8 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i15, i6, i1) {
 i15 = i15 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 4 | 0;
 i4 = i14;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = (i8 - i1 | 0) / 20 | 0;
 HEAP32[i4 >> 2] = i5;
 i11 = i15 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i12 = i15 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i14;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i12 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i12 >> 2] | 0;
  }
  i9 = i1 + 4 | 0;
  i2 = i9 + 11 | 0;
  i5 = HEAP8[i2 >> 0] | 0;
  i10 = i1 + 8 | 0;
  i6 = i5 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i5 & 255;
  HEAP32[i13 >> 2] = i6;
  i7 = i3 + 4 | 0;
  if (i7 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = i6;
   HEAP32[i11 >> 2] = i7;
   i3 = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i13, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
  i10 = i4 ? HEAP32[i10 >> 2] | 0 : i3 & 255;
  i4 = i2 + i10 | 0;
  if (i10 | 0) do {
   i3 = HEAP32[i11 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i15);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i14;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 8 | 0;
 i4 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, i1, i5 + 8 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i4 << 6) | 0;
 if (!i4) i1 = 0; else {
  do {
   __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
   i1 = i1 + 64 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 64) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i5 = i10 + 16 | 0;
 i3 = i10 + 8 | 0;
 i2 = i10;
 i6 = i10 + 32 | 0;
 d1 = +Math_fround(HEAPF32[i4 >> 2]);
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAPF64[i2 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 832323 | 0, i2) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 d1 = +Math_fround(HEAPF32[i4 + 4 >> 2]);
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAPF64[i3 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 832323 | 0, i3) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 d1 = +Math_fround(HEAPF32[i4 + 8 >> 2]);
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAPF64[i5 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 832323 | 0, i5) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 d1 = +Math_fround(HEAPF32[i4 + 12 >> 2]);
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAPF64[i8 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 832323 | 0, i8) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  STACKTOP = i10;
  return i7 | 0;
 }
 i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 STACKTOP = i10;
 return i7 | 0;
}

function __ZN5Unity17ConfigurableJoint17SetTargetVelocityERK8Vector3f(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f13 < Math_fround(340282326000000008404918.0e15);
 f13 = i1 ? f13 : Math_fround(340282326000000008404918.0e15);
 i1 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(340282326000000008404918.0e15);
 i1 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(340282326000000008404918.0e15);
 i1 = f13 > Math_fround(-340282326000000008404918.0e15);
 f13 = i1 ? f13 : Math_fround(-340282326000000008404918.0e15);
 i1 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(-340282326000000008404918.0e15);
 i1 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i5 + 324 >> 2] = f13;
 i1 = i5 + 328 | 0;
 HEAPF32[i1 >> 2] = f12;
 i2 = i5 + 332 | 0;
 HEAPF32[i2 >> 2] = f11;
 i3 = i5 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0) | 0) & 1) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 184 >> 2] | 0, i4 | 0, i8 | 0, i9 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 + 324 >> 2];
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i4;
 i5 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0, i8 | 0, i9 | 0);
 i9 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i6 | 0, i7 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __GLOBAL__sub_I_GfxDeviceNull_cpp() {
 HEAP8[gb + 1451292 >> 0] = 15;
 HEAP8[gb + 1451292 + 1 >> 0] = 1;
 HEAP8[gb + 1451292 + 2 >> 0] = 0;
 HEAP8[gb + 1451292 + 3 >> 0] = 1;
 HEAP32[gb + 1451292 + 4 >> 2] = 0;
 HEAP8[gb + 1451292 + 8 >> 0] = 15;
 HEAP8[gb + 1451292 + 9 >> 0] = 1;
 HEAP8[gb + 1451292 + 10 >> 0] = 0;
 HEAP8[gb + 1451292 + 11 >> 0] = 1;
 HEAP32[gb + 1451292 + 12 >> 2] = 0;
 HEAP8[gb + 1451292 + 16 >> 0] = 15;
 HEAP8[gb + 1451292 + 17 >> 0] = 1;
 HEAP8[gb + 1451292 + 18 >> 0] = 0;
 HEAP8[gb + 1451292 + 19 >> 0] = 1;
 HEAP32[gb + 1451292 + 20 >> 2] = 0;
 HEAP8[gb + 1451292 + 24 >> 0] = 15;
 HEAP8[gb + 1451292 + 25 >> 0] = 1;
 HEAP8[gb + 1451292 + 26 >> 0] = 0;
 HEAP8[gb + 1451292 + 27 >> 0] = 1;
 HEAP32[gb + 1451292 + 28 >> 2] = 0;
 HEAP8[gb + 1451292 + 32 >> 0] = 15;
 HEAP8[gb + 1451292 + 33 >> 0] = 1;
 HEAP8[gb + 1451292 + 34 >> 0] = 0;
 HEAP8[gb + 1451292 + 35 >> 0] = 1;
 HEAP32[gb + 1451292 + 36 >> 2] = 0;
 HEAP8[gb + 1451292 + 40 >> 0] = 15;
 HEAP8[gb + 1451292 + 41 >> 0] = 1;
 HEAP8[gb + 1451292 + 42 >> 0] = 0;
 HEAP8[gb + 1451292 + 43 >> 0] = 1;
 HEAP32[gb + 1451292 + 44 >> 2] = 0;
 HEAP8[gb + 1451292 + 48 >> 0] = 15;
 HEAP8[gb + 1451292 + 49 >> 0] = 1;
 HEAP8[gb + 1451292 + 50 >> 0] = 0;
 HEAP8[gb + 1451292 + 51 >> 0] = 1;
 HEAP32[gb + 1451292 + 52 >> 2] = 0;
 HEAP8[gb + 1451292 + 56 >> 0] = 15;
 HEAP8[gb + 1451292 + 57 >> 0] = 1;
 HEAP8[gb + 1451292 + 58 >> 0] = 0;
 HEAP8[gb + 1451292 + 59 >> 0] = 1;
 HEAP32[gb + 1451292 + 60 >> 2] = 0;
 HEAP32[gb + 1451292 + 64 >> 2] = 0;
 HEAP8[gb + 1548981 >> 0] = 1;
 HEAP8[gb + 1548981 + 1 >> 0] = 2;
 HEAP8[gb + 1451280 >> 0] = 0;
 HEAP8[gb + 1451280 + 1 >> 0] = -1;
 HEAP8[gb + 1451280 + 2 >> 0] = -1;
 HEAP8[gb + 1451280 + 3 >> 0] = 0;
 HEAP8[gb + 1451280 + 4 >> 0] = 8;
 HEAP8[gb + 1451280 + 5 >> 0] = 0;
 HEAP8[gb + 1451280 + 6 >> 0] = 0;
 HEAP8[gb + 1451280 + 7 >> 0] = 0;
 HEAP8[gb + 1451280 + 8 >> 0] = 8;
 HEAP8[gb + 1451280 + 9 >> 0] = 0;
 HEAP8[gb + 1451280 + 10 >> 0] = 0;
 HEAP8[gb + 1451280 + 11 >> 0] = 0;
 HEAP32[gb + 1451268 >> 2] = 2;
 HEAP32[gb + 1451268 + 4 >> 2] = 0;
 HEAPF32[gb + 1451268 + 8 >> 2] = Math_fround(0.0);
 HEAP32[gb + 1451360 >> 2] = 0;
 HEAP32[gb + 1451392 >> 2] = 0;
 return;
}

function __ZN5physx2Sn17readAllPropertiesINS_10PxMaterialEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 228 | 0;
 i14 = i11 + 176 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i15 = i11 + 40 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx23PxMaterialGeneratedInfoC2Ev(i15);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i5;
 HEAP32[i14 + 24 >> 2] = i4;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i13;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 20 | 0;
 i8 = i12;
 i6 = i12 + 16 | 0;
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 if (!(i7 & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 8); else {
   i6 = i3;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = i7;
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i5 = i2 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i2 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 >> 2] = i3;
 }
 i1 = i3 + 8 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 8); else {
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!(i7 & 8388608)) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZN5Unity12PhysicsQuery21OverlapBoxUserCollectERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE(i1, i7, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 120 | 0;
 i4 = i6 + 96 | 0;
 i5 = i6 + 80 | 0;
 i1 = i6 + 52 | 0;
 i2 = i6;
 HEAP32[i3 >> 2] = gb + 114012 + 8;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = i10;
 switch (i11 | 0) {
 case 0:
  {
   HEAP8[i3 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i3 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i3 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i3 >> 2] = gb + 151424 + 8;
 HEAP32[i3 + 20 >> 2] = i12;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP16[i4 + 16 >> 1] = 11;
 HEAP8[i4 + 18 >> 0] = 0;
 i12 = HEAP32[i8 >> 2] | 0;
 i11 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = 3;
 HEAP32[i5 + 4 >> 2] = i12;
 HEAP32[i5 + 8 >> 2] = i11;
 HEAP32[i5 + 12 >> 2] = i10;
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i7 + 4 >> 2] | 0;
 i12 = HEAP32[i7 + 8 >> 2] | 0;
 i13 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = HEAP32[i9 + 8 >> 2] | 0;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i1 + 12 >> 2] = i8;
 HEAP32[i1 + 16 >> 2] = i10;
 HEAP32[i1 + 20 >> 2] = i11;
 HEAP32[i1 + 24 >> 2] = i12;
 i12 = i2 + 36 | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = i12;
 HEAP32[i2 + 28 >> 2] = 1;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151448 + 8;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = -1;
 i12 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_iiiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 356 >> 2] | 0, i12 | 0, i5 | 0, i1 | 0, i2 | 0, i4 | 0, i3 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN10GISettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402298 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402312 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402334 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402348 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402377 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402403 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402426 | 0, i5, i1 + 21 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __Z22CalculateTransformPathRK9TransformPS0_(i3, i1, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 24 | 0;
 i7 = i12 + 12 | 0;
 i8 = i12;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i12;
  return;
 }
 i9 = i3 + 11 | 0;
 i10 = i3 + 4 | 0;
 i11 = i8 + 11 | 0;
 i4 = i8 + 4 | 0;
 i2 = 0;
 while (1) {
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i10 >> 2] | 0; else i2 = i2 & 255;
  if (!i2) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i3, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) | 0; else {
   i14 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
   HEAP8[i6 >> 0] = 47;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   i13 = HEAP8[i9 >> 0] | 0;
   i13 = i13 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i13 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i8, i6, 1, i13 + 1 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, i13) | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   i13 = _strlen(i14) | 0;
   i2 = HEAP8[i11 >> 0] | 0;
   i2 = i2 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i14, i13, i2 + i13 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, (HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, i2) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i7) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!((i1 | 0) != (i5 | 0) & (i1 | 0) != 0)) break;
  i2 = HEAP8[i9 >> 0] | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN14AnimationState22DidModifyAnimationClipEP13AnimationClipR4ListI8ListNodeIS_EE(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i7 = i10;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) != (i8 | 0)) {
  i4 = i5 + 4 | 0;
  if (!i6) do {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i2 + 96 >> 2] = 0;
   i4 = i2 + 56 | 0;
   HEAP16[i4 >> 1] = HEAP16[i4 >> 1] & -129;
   if ((HEAP16[gb + 1467088 + 6 >> 1] | 0) > -1) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467088 | 0, i5);
    i1 = gb + 1467088 | 0;
   } else i1 = 0;
   i4 = i2 + 64 | 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
  } while ((i3 | 0) != (i8 | 0)); else do {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   i11 = i2 + 96 | 0;
   __ZN13AnimationClip8GetRangeEv(i5, HEAP32[i11 >> 2] | 0);
   HEAP32[i2 + 88 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 92 >> 2] = HEAP32[i4 >> 2];
   i11 = HEAP32[i11 >> 2] | 0;
   i1 = i2 + 56 | 0;
   HEAP16[i1 >> 1] = (((HEAP32[i11 + 196 >> 2] | 0) == (HEAP32[i11 + 200 >> 2] | 0) & 1) << 7 & 65535 | HEAP16[i1 >> 1] & -129) ^ 128;
   if ((HEAP16[gb + 1467088 + 6 >> 1] | 0) > -1) {
    HEAP32[i7 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467088 | 0, i5);
    i1 = gb + 1467088 | 0;
   } else i1 = 0;
   i11 = i2 + 64 | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1;
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
  } while ((i3 | 0) != (i8 | 0));
 }
 if (i6 | 0) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) do {
  i11 = i1 + 4 | 0;
  i7 = i1;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
 } while ((i1 | 0) != (i8 | 0));
 HEAP32[i9 >> 2] = i8;
 HEAP32[i8 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function __ZN18GfxFramebufferGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i4 = i8 + 384 | 0;
 i7 = i4;
 i5 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i6 = i8 + 432 | 0;
 i7 = i6;
 i1 = i2;
 i5 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 i3 = i8 + 16 | 0;
 i7 = i8 + 20 | 0;
 i5 = i7 + 72 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 HEAP32[i3 >> 2] = i4;
 HEAP32[i8 + 48 >> 2] = i6;
 HEAP32[i8 + 52 >> 2] = 1;
 HEAP8[i8 + 72 >> 0] = 0;
 HEAP8[i8 + 80 >> 0] = 0;
 HEAP8[i8 + 88 >> 0] = 0;
 HEAP8[i8 + 89 >> 0] = 0;
 HEAP32[i8 + 60 >> 2] = -1;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 0;
 i2 = i9 + 68 | 0;
 i7 = i9;
 i5 = i7 + 96 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i5 | 0));
 if (!(HEAP32[i8 + 404 >> 2] & 64)) {
  HEAP32[i9 >> 2] = 1;
  i7 = HEAP32[i8 + 16 >> 2] | 0;
  HEAP32[i9 + 4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 36 >> 2] = HEAP32[i7 + 36 >> 2];
 } else HEAP32[i9 >> 2] = 0;
 i1 = i9 + 92 | 0;
 if (!(HEAP32[i8 + 452 >> 2] & 64)) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 72 >> 2] = HEAP32[i6 + 36 >> 2];
  HEAP32[i9 + 76 >> 2] = HEAP32[i6 + 44 >> 2];
 } else HEAP8[i1 >> 0] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 HEAP32[i9 + 84 >> 2] = 0;
 HEAP32[i9 + 88 >> 2] = -1;
 __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup(i10, i8, i3);
 i6 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i8, i9) | 0;
 i9 = i10;
 i7 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = i8 + 376 | 0;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i10 + 4 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN14EdgeCollider2D9SetPointsEPK8Vector2fj(i16, i1, i2) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 if (i2 >>> 0 < 2) {
  i16 = 0;
  return i16 | 0;
 }
 i14 = i16 + 160 | 0;
 i15 = i16 + 176 | 0;
 if ((HEAP32[i15 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i14 >> 2] | 0, i16 + 164 | 0);
  HEAP32[i14 >> 2] = 0;
 }
 HEAP32[i14 >> 2] = 0;
 i12 = i16 + 172 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 i13 = i16 + 164 | 0;
 i9 = 0;
 i10 = 0;
 i11 = 0;
 i7 = 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = i1 + 8 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = (i5 & 2139095040 | 0) != 2139095040 & (i4 & 2139095040 | 0) != 2139095040;
  i4 = i8 ? i4 : 0;
  i5 = i8 ? i5 : 0;
  i8 = i9 + 1 | 0;
  i3 = i10 & 2147483647;
  do if (i8 >>> 0 > i3 >>> 0) {
   i1 = i10 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i3 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
    HEAP32[i15 >> 2] = i1;
    i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i11, i1 << 3, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i14 >> 2] = i3;
    break;
   } else {
    i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i3 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
    HEAP32[i15 >> 2] = i1;
    HEAP32[i14 >> 2] = i3;
    break;
   } else i3 = i7;
  } else i3 = i7; while (0);
  HEAP32[i12 >> 2] = i8;
  HEAP32[i3 + (i9 << 3) >> 2] = i5;
  HEAP32[i3 + (i9 << 3) + 4 >> 2] = i4;
  if (!i2) break;
  i1 = i6;
  i9 = i8;
  i10 = HEAP32[i15 >> 2] | 0;
  i11 = i3;
  i7 = i3;
 }
 __ZN10Collider2D19WakeAllBodyContactsEv(i16);
 i1 = HEAP32[i16 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i15 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 112 >> 2] | 0, i16 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i16, i15);
  if (!i15) {
   i16 = 1;
   return i16 | 0;
  }
  mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 140 >> 2] | 0, i16 | 0, 0);
  i16 = 1;
  return i16 | 0;
 }
 __ZN10Collider2D7CleanupEb(i16, 0);
 i16 = 1;
 return i16 | 0;
}

function __ZN7mecanim9animation22MotionOutputBlendBeginEPNS0_12MotionOutputEbb(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i4 + 56 | 0;
 i2 = i4 + 4 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i4 + 60 >> 2] = 1065353216;
 HEAP32[i4 + 64 >> 2] = 1065353216;
 i1 = i4 + 68 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 1065353216;
 HEAP32[i4 + 100 >> 2] = 1065353216;
 HEAP32[i4 + 104 >> 2] = 1065353216;
 i1 = i4 + 108 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 1065353216;
 HEAP32[i4 + 140 >> 2] = 1065353216;
 HEAP32[i4 + 144 >> 2] = 1065353216;
 i1 = i4 + 148 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 176 >> 2] = 1065353216;
 HEAP32[i4 + 180 >> 2] = 1065353216;
 HEAP32[i4 + 184 >> 2] = 1065353216;
 i1 = i4 + 188 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 216 >> 2] = 1065353216;
 HEAP32[i4 + 220 >> 2] = 1065353216;
 HEAP32[i4 + 224 >> 2] = 1065353216;
 i1 = i4 + 228 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i4 + 256 >> 2] = 1065353216;
 HEAP32[i4 + 260 >> 2] = 1065353216;
 HEAP32[i4 + 264 >> 2] = 1065353216;
 i1 = i4 + 320 | 0;
 i2 = i4 + 268 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i4 + 324 >> 2] = 1065353216;
 HEAP32[i4 + 328 >> 2] = 1065353216;
 return;
}

function __Z18ConvertUTF8toUTF32RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayImLj4EE(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i4 = i11;
 i5 = i3 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i6 = i3 + 4 | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i1 & 255;
 i9 = i8 + 12 | 0;
 HEAP32[i9 >> 2] = i1;
 i10 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i10 >> 2] = i1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i8 >> 2] = i1;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i1 = i2;
  break;
 } else i1 = HEAP32[i8 >> 2] | 0; while (0);
 i2 = HEAP8[i5 >> 0] | 0;
 i12 = i2 << 24 >> 24 < 0;
 i5 = i12 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i12 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i4 >> 2] = i5;
 if ((__Z18ConvertUTF8toUTF32PPKhS0_PPmS2_15ConversionFlags(i4, i5 + i6 | 0, i7, 0, 0) | 0) == 3) {
  i3 = 0;
  i2 = 0;
 } else {
  i3 = 1;
  i2 = (HEAP32[i7 >> 2] | 0) - i1 >> 2;
 }
 HEAP32[i9 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 & 2147483647) >>> 0 >= i2 >>> 0) {
  STACKTOP = i11;
  return i3 | 0;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i10 >> 2] = i2;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i2 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i11;
  return i3 | 0;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i2;
  HEAP32[i8 >> 2] = i12;
  STACKTOP = i11;
  return i3 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 i1 = __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i2, i3, i4, i1) | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f9 < Math_fround(HEAPF32[i7 + 8 >> 2]))) {
  i10 = i1;
  STACKTOP = i8;
  return i10 | 0;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i10 = HEAP32[i3 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f9 < Math_fround(HEAPF32[i7 + 8 >> 2]))) {
  i10 = i1 + 1 | 0;
  STACKTOP = i8;
  return i10 | 0;
 }
 i10 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i10;
 i10 = HEAP32[i2 >> 2] | 0;
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 if (!(f9 < Math_fround(HEAPF32[i7 + 8 >> 2]))) {
  i10 = i1 + 2 | 0;
  STACKTOP = i8;
  return i10 | 0;
 }
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i10;
 i10 = i1 + 3 | 0;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN5physx2Gu21findUniqueConvexEdgesEjPNS0_10ConvexEdgeEjPKNS0_15HullPolygonDataEPKh(i1, i13, i3, i2, i14) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, f17 = f0;
 if (!i3) {
  i15 = 0;
  return i15 | 0;
 } else {
  i12 = i3;
  i3 = 0;
 }
 L3 : while (1) {
  i12 = i12 + -1 | 0;
  i11 = HEAPU16[i2 + 16 >> 1] | 0;
  i10 = HEAP8[i2 + 18 >> 0] | 0;
  i4 = i10 & 255;
  if (i10 << 24 >> 24) {
   i9 = i2 + 4 | 0;
   i10 = i2 + 8 | 0;
   i8 = i4;
   i4 = i4 + -1 | 0;
   i7 = 0;
   while (1) {
    i8 = i8 + -1 | 0;
    i4 = HEAP8[i14 + (i4 + i11) >> 0] | 0;
    i6 = HEAP8[i14 + (i7 + i11) >> 0] | 0;
    i16 = (i6 & 255) < (i4 & 255);
    i5 = i16 ? i6 : i4;
    i6 = i16 ? i4 : i6;
    L9 : do if (!i3) i15 = 10; else {
     i4 = 0;
     while (1) {
      if ((HEAP8[i13 + (i4 << 4) >> 0] | 0) == i5 << 24 >> 24) if ((HEAP8[i13 + (i4 << 4) + 1 >> 0] | 0) == i6 << 24 >> 24) break;
      i4 = i4 + 1 | 0;
      if (i4 >>> 0 >= i3 >>> 0) {
       i15 = 10;
       break L9;
      }
     }
     f17 = Math_fround(HEAPF32[i2 >> 2]);
     i16 = i13 + (i4 << 4) + 4 | 0;
     HEAPF32[i16 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
     f17 = Math_fround(HEAPF32[i9 >> 2]);
     i16 = i13 + (i4 << 4) + 8 | 0;
     HEAPF32[i16 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
     f17 = Math_fround(HEAPF32[i10 >> 2]);
     i16 = i13 + (i4 << 4) + 12 | 0;
     HEAPF32[i16 >> 2] = Math_fround(f17 + Math_fround(HEAPF32[i16 >> 2]));
    } while (0);
    if ((i15 | 0) == 10) {
     i15 = 0;
     if ((i3 | 0) == (i1 | 0)) {
      i15 = 13;
      break L3;
     }
     HEAP8[i13 + (i3 << 4) >> 0] = i5;
     HEAP8[i13 + (i3 << 4) + 1 >> 0] = i6;
     HEAP32[i13 + (i3 << 4) + 4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i13 + (i3 << 4) + 8 >> 2] = HEAP32[i9 >> 2];
     HEAP32[i13 + (i3 << 4) + 12 >> 2] = HEAP32[i10 >> 2];
     i3 = i3 + 1 | 0;
    }
    if (!i8) break; else {
     i4 = i7;
     i7 = i7 + 1 | 0;
    }
   }
  }
  i2 = i2 + 20 | 0;
  if (!i12) {
   i1 = i3;
   i15 = 13;
   break;
  }
 }
 if ((i15 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6;
 i7 = i5 + 4 | 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 20 | 0, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 431299 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034365 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0);
 i3 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431317 | 0, HEAP32[gb + 37260 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i6 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 STACKTOP = i6;
 return;
}

function __ZN22UnityProfilerPerThread20CreateOverheadSampleEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, i9 = 0, i10 = 0, d11 = 0.0, f12 = f0;
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i7, gb + 1163376 | 0, 0) | 0;
 i10 = HEAP32[(HEAP32[i7 + 36 >> 2] | 0) + ((HEAP32[i7 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
 i1 = i7 + 16 | 0;
 i9 = i10 & 16383;
 i10 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + (i10 >>> 14 << 2) >> 2] >> 2] | 0;
 d11 = +_emscripten_get_now() * 1.0e6;
 i6 = +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i7, gb + 1163376 | 0, ~~d11 >>> 0, i6) | 0;
 if (!(HEAP32[i7 + 4 >> 2] | 0)) return;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i6) return;
 if (HEAP8[i7 + 157 >> 0] | 0) return;
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(1.0e3));
 i2 = ~~+f8 >>> 0;
 i1 = +Math_abs(+f8) >= 1.0 ? (+f8 > 0.0 ? ~~+Math_min(+Math_floor(+f8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f8 - +(~~+f8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 if ((i6 | 0) > 0) {
  i3 = 1;
  i4 = 0;
  do {
   f12 = Math_fround(Math_fround(+(i2 >>> 0) + 4294967296.0 * +(i1 >>> 0)) - Math_fround(Math_fround(HEAPF32[(HEAP32[HEAP32[i5 + (i3 >>> 14 << 2) >> 2] >> 2] | 0) + ((i3 & 16383) * 24 | 0) + 8 >> 2]) * Math_fround(1.0e3)));
   i3 = __ZN22UnityProfilerPerThread22SkipSampleRecurseIndexEj(i7, i3) | 0;
   i4 = i4 + 1 | 0;
   i2 = ~~+f12 >>> 0;
   i1 = +Math_abs(+f12) >= 1.0 ? (+f12 > 0.0 ? ~~+Math_min(+Math_floor(+f12 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f12 - +(~~+f12 >>> 0)) / 4294967296.0) >>> 0) : 0;
  } while ((i4 | 0) < (i6 | 0));
 }
 if (!(Math_fround(+(i2 >>> 0) + 4294967296.0 * +(i1 >>> 0)) < f8)) return;
 i7 = ___udivdi3(i2 | 0, i1 | 0, 1e3, 0) | 0;
 f12 = Math_fround(+(i7 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 i10 = i10 + (i9 * 24 | 0) + 8 | 0;
 HEAPF32[i10 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i10 >> 2]));
 return;
}

function __ZN19SpriteMeshGenerator12path_segment12max_distanceENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i2, i1, i3, i20) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i20 = i20 | 0;
 var f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i14 = HEAP32[i1 >> 2] | 0;
 i19 = (HEAP32[i1 + 4 >> 2] | 0) - i14 >> 5;
 f15 = Math_fround(HEAPF32[i14 + (i3 << 5) >> 2]);
 f16 = Math_fround(HEAPF32[i14 + (i3 << 5) + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i14 + (i20 << 5) >> 2]);
 f18 = Math_fround(HEAPF32[i14 + (i20 << 5) + 4 >> 2]);
 i9 = i2 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 if ((i3 | 0) == (i20 | 0)) {
  i20 = -1;
  return i20 | 0;
 }
 f10 = Math_fround(f17 - f15);
 f11 = Math_fround(f18 - f16);
 f12 = Math_fround(Math_fround(f10 * f10) + Math_fround(f11 * f11));
 i13 = i19 + -1 | 0;
 i2 = -1;
 f8 = Math_fround(-1.0);
 f7 = f15;
 f5 = f16;
 i6 = 0;
 while (1) {
  f4 = Math_fround(Math_fround(f10 * Math_fround(f7 - f15)) + Math_fround(f11 * Math_fround(f5 - f16)));
  do if (!(f4 <= Math_fround(0.0))) if (!(f12 <= f4)) {
   f4 = Math_fround(f4 / f12);
   f7 = Math_fround(Math_fround(f15 + Math_fround(f10 * f4)) - f7);
   f4 = Math_fround(Math_fround(f16 + Math_fround(f11 * f4)) - f5);
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4))));
   break;
  } else {
   f7 = Math_fround(f17 - f7);
   f4 = Math_fround(f18 - f5);
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4))));
   break;
  } else {
   f7 = Math_fround(f15 - f7);
   f4 = Math_fround(f16 - f5);
   f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4))));
  } while (0);
  i1 = f4 < f8;
  i2 = i1 ? i2 : i3;
  f4 = i1 ? f8 : f4;
  i1 = i3 + 1 | 0;
  if ((i1 | 0) < (i19 | 0)) {
   if ((i3 | 0) <= -2) i1 = i13 - ((-2 - i3 | 0) % (i19 | 0) | 0) | 0;
  } else i1 = (i1 | 0) % (i19 | 0) | 0;
  i6 = i6 + 1 | 0;
  if ((i1 | 0) == (i20 | 0)) break;
  f7 = Math_fround(HEAPF32[i14 + (i1 << 5) >> 2]);
  i3 = i1;
  f8 = f4;
  f5 = Math_fround(HEAPF32[i14 + (i1 << 5) + 4 >> 2]);
 }
 HEAP32[i9 >> 2] = i6;
 i20 = i2;
 return i20 | 0;
}

function __ZN16HeightMeshBVNode8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 20 | 0;
 i8 = i12;
 i6 = i12 + 16 | 0;
 i9 = i8 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 if (!(i7 & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 8); else {
   i6 = i3;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = i7;
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
  STACKTOP = i12;
  return;
 }
 i5 = i2 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i2 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 >> 2] = i3;
 }
 i1 = i3 + 8 | 0;
 if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 8); else {
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i8, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!(i7 & 8388608)) {
  HEAP32[i10 >> 2] = i1;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i10) | 0;
 } else i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb(i1, i2, i3, i4, i9, i5, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i8 = i12;
 i13 = gb + 63520 | 0;
 i6 = HEAP32[i13 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i10 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i10) | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 48 >> 2] | 0, i10 | 0, 125);
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 188 >> 2] | 0, i10 | 0, i2 | 0, i3 | 0, i4 | 0, i11 & 1 | 0, 1, -1, 0) | 0;
 __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i10, i5);
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i1 | 0);
 HEAP32[i10 + 36 >> 2] = 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 100 >> 2] | 0, i10 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 104 >> 2] | 0, i10 | 0) | 0;
 __ZN9Texture2D18UnshareTextureDataEv(i10);
 i1 = HEAP32[i10 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i10 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 i5 = __Z25GetBytesFromTextureFormat13TextureFormat(i2) | 0;
 if ((i7 | 0) > 0 & (i8 | 0) > 0) {
  i6 = Math_imul(i5, i7) | 0;
  i4 = 0;
  while (1) {
   i2 = 0;
   i3 = i1;
   while (1) {
    mftCall_viiiiii(HEAP32[i9 >> 2] | 0, i10 | 0, i3 | 0, i2 | 0, i4 | 0, i7 | 0, i8 | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + i5 | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i8 | 0)) break; else i1 = i1 + i6 | 0;
  }
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i11) {
  mftCall_vi(HEAP32[i1 + 192 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 } else {
  mftCall_vi(HEAP32[i1 + 196 >> 2] | 0, i10 | 0);
  STACKTOP = i12;
  return i10 | 0;
 }
 return 0;
}

function __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 16 | 0;
 i8 = i15;
 i9 = i2 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i6 >> 2] = Math_fround(.0500000007);
 i10 = i6 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(.100000001);
 i11 = i6 + 8 | 0;
 HEAPF32[i11 >> 2] = Math_fround(.150000006);
 i12 = i6 + 12 | 0;
 HEAPF32[i12 >> 2] = Math_fround(.200000003);
 i13 = i8 + 4 | 0;
 i14 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = 0;
 f5 = Math_fround(0.0);
 f7 = Math_fround(0.0);
 do {
  __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i8, i3, i6);
  f18 = Math_fround(HEAPF32[i8 >> 2]);
  f19 = Math_fround(HEAPF32[i13 >> 2]);
  f22 = Math_fround(_fminf(f18, f19));
  f20 = Math_fround(HEAPF32[i14 >> 2]);
  f21 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(_fminf(f5, Math_fround(_fminf(f22, Math_fround(_fminf(f20, f21))))));
  f19 = Math_fround(_fmaxf(f18, f19));
  HEAPF32[i9 >> 2] = Math_fround(_fmaxf(f7, Math_fround(_fmaxf(f19, Math_fround(_fmaxf(f20, f21))))));
  i16 = i2;
  i17 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = i17;
  HEAP32[i9 >> 2] = i16;
  f21 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(.200000003));
  f20 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(.200000003));
  f19 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(.200000003));
  f18 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(.200000003));
  HEAPF32[i6 >> 2] = f21;
  HEAPF32[i10 >> 2] = f20;
  HEAPF32[i11 >> 2] = f19;
  HEAPF32[i12 >> 2] = f18;
  i1 = i1 + 4 | 0;
  f5 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i1 | 0) < 20);
 STACKTOP = i15;
 return;
}

function __ZN6Avatar8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = i6 + 32;
 i8 = i6 + 56 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i6 + 72 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i8 = i2;
  __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i7);
  i8 = i6 + 60 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, i1);
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 100, 4) | 0;
 i2 = i1 + 40 | 0;
 i3 = i1;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 1065353216;
 HEAP32[i1 + 72 >> 2] = 1065353216;
 HEAP32[i1 + 76 >> 2] = 1065353216;
 HEAP32[i1 + 80 >> 2] = 1065353216;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = i1;
 i8 = i1;
 __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i7);
 i8 = i6 + 60 | 0;
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i7 = i18 + 28 | 0;
 i17 = HEAP32[i7 >> 2] | 0;
 f19 = Math_fround(i1 >>> 0);
 i8 = ~~Math_fround(f19 * Math_fround(HEAPF32[i18 + 36 >> 2])) >>> 0;
 i13 = i1 << 2;
 i12 = (i8 << 2) + i13 | 0;
 i12 = (0 - i12 & 12) + i12 | 0;
 i9 = i18 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i10 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i12 + (i8 << 3) | 0, HEAP32[i18 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i11 = i10 + i13 | 0;
 i12 = i10 + i12 | 0;
 _memset(i10 | 0, -1, i13 | 0) | 0;
 i13 = i18 + 48 | 0;
 i6 = i18 + 16 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i14 = i1 + -1 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i16 = 0;
  do {
   i3 = HEAP32[i5 + (i16 << 3) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i15 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i10 + ((i2 & i14) << 2) | 0;
   HEAP32[i11 + (i16 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i16;
   HEAP32[i12 + (i16 << 3) >> 2] = i15;
   HEAP32[i12 + (i16 << 3) + 4 >> 2] = HEAP32[i5 + (i16 << 3) + 4 >> 2];
   i16 = i16 + 1 | 0;
  } while (i16 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 i16 = i18 + 12 | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, HEAP32[i16 >> 2] | 0);
 HEAP32[i16 >> 2] = i10;
 HEAP32[i18 + 24 >> 2] = i10;
 HEAP32[i18 + 32 >> 2] = i1;
 HEAP32[i18 + 20 >> 2] = i11;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i7 >> 2] = i8;
 i1 = i18 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i17;
 return;
}

function __ZN5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_(i8, i3, i4, i6, i5, i2, i1, i7) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 88 | 0;
 i12 = i9 + 80 | 0;
 i13 = i9 + 72 | 0;
 i14 = i9 + 64 | 0;
 i15 = i9 + 56 | 0;
 i16 = i9 + 48 | 0;
 i22 = i9 + 40 | 0;
 i21 = i9 + 32 | 0;
 i20 = i9 + 24 | 0;
 i19 = i9 + 16 | 0;
 i18 = i9 + 8 | 0;
 i17 = i9;
 i10 = __ZN5physx5cloth8allocateEj(96) | 0;
 i24 = i4;
 i4 = HEAP32[i24 + 4 >> 2] | 0;
 i23 = i22;
 HEAP32[i23 >> 2] = HEAP32[i24 >> 2];
 HEAP32[i23 + 4 >> 2] = i4;
 i23 = i6;
 i6 = HEAP32[i23 + 4 >> 2] | 0;
 i4 = i21;
 HEAP32[i4 >> 2] = HEAP32[i23 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = i5;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i20;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i2;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i19;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = i1;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i18;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i7;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i17;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = __ZN5physx5cloth15getNextFabricIdEv() | 0;
 HEAP32[i16 >> 2] = HEAP32[i22 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i22 + 4 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i21 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i21 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i20 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i18 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i18 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 __ZN5physx5cloth8SwFabricC2ERNS0_9SwFactoryEjNS0_5RangeIKjEES6_NS4_IKfEES6_S6_S8_j(i10, i8, i3, i16, i15, i14, i13, i12, i11, i7);
 STACKTOP = i9;
 return ((i10 | 0) == 0 ? 0 : i10 + 4 | 0) | 0;
}

function __ZN5Unity5ClothD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 168556 + 8;
 i1 = i3 + 228 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 240 >> 2] = 0;
 HEAP32[i3 + 244 >> 2] = 0;
 i1 = i3 + 308 | 0;
 if ((HEAP32[i3 + 324 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 312 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 288 | 0;
 if ((HEAP32[i3 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 292 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 268 | 0;
 if ((HEAP32[i3 + 284 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 272 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 248 | 0;
 if ((HEAP32[i3 + 264 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 252 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 208 | 0;
 if ((HEAP32[i3 + 224 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 212 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 188 | 0;
 if ((HEAP32[i3 + 204 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 192 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 168 | 0;
 if ((HEAP32[i3 + 184 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 172 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 148 | 0;
 if ((HEAP32[i3 + 164 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 152 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 128 | 0;
 if ((HEAP32[i3 + 144 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 37748 + 8;
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 132 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 37748 + 8;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN4crnd25static_huffman_data_modelaSERKS0_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i4 = i9;
 i5 = i9 + 28 | 0;
 i7 = i9 + 32 | 0;
 if ((i8 | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 __ZN4crnd6vectorIhE6assignERKS1_(i8 + 4 | 0, i1 + 4 | 0) | 0;
 i3 = i8 + 16 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  HEAP32[i8 >> 2] = 0;
  i1 = i8 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
    HEAP32[i4 >> 2] = gb + 401209;
    HEAP32[i4 + 4 >> 2] = 2513;
    HEAP32[i4 + 8 >> 2] = gb + 401349;
    _sprintf(i7, gb + 401176 | 0, i4) | 0;
    _puts(i7) | 0;
   }
   HEAP32[i1 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
  }
  HEAP8[i3 >> 0] = 0;
  i1 = i8 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   STACKTOP = i9;
   return i8 | 0;
  }
  __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i2);
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i8 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
  HEAP32[i3 >> 2] = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (i1 | 0) {
  __ZN4crnd13prefix_coding14decoder_tablesaSERKS1_(i1, i2) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = 180;
 i1 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, 0, 180, i5 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
 if ((i1 | 0) == 0 | (HEAP32[i5 >> 2] | 0) >>> 0 < 180) {
  HEAP32[i6 >> 2] = gb + 401209;
  HEAP32[i6 + 4 >> 2] = 2513;
  HEAP32[i6 + 8 >> 2] = gb + 401368;
  _sprintf(i7, gb + 401176 | 0, i6) | 0;
  _puts(i7) | 0;
  i1 = 0;
 } else {
  i7 = i1 + 164 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  __ZN4crnd13prefix_coding14decoder_tablesaSERKS1_(i1, i2) | 0;
 }
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN10GUIManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP32[i1 + 480 >> 2] = 0;
 HEAP32[i1 + 488 >> 2] = 0;
 HEAP32[i1 + 504 >> 2] = -1;
 HEAP32[i1 + 492 >> 2] = 1;
 HEAP32[i1 + 496 >> 2] = 0;
 HEAP32[i1 + 500 >> 2] = 0;
 HEAP32[i1 + 508 >> 2] = 0;
 HEAP32[i1 + 524 >> 2] = -1;
 HEAP32[i1 + 512 >> 2] = 1;
 HEAP32[i1 + 516 >> 2] = 0;
 HEAP32[i1 + 520 >> 2] = 0;
 HEAP32[i1 + 528 >> 2] = 0;
 HEAP32[i1 + 544 >> 2] = -1;
 HEAP32[i1 + 532 >> 2] = 1;
 HEAP32[i1 + 536 >> 2] = 0;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP32[i1 + 548 >> 2] = 0;
 HEAP32[i1 + 564 >> 2] = -1;
 HEAP32[i1 + 552 >> 2] = 1;
 HEAP32[i1 + 556 >> 2] = 0;
 HEAP32[i1 + 560 >> 2] = 0;
 HEAP32[i1 + 568 >> 2] = 0;
 HEAP32[i1 + 584 >> 2] = -1;
 HEAP32[i1 + 572 >> 2] = 1;
 HEAP32[i1 + 576 >> 2] = 0;
 HEAP32[i1 + 580 >> 2] = 0;
 HEAP32[i1 + 588 >> 2] = 0;
 HEAP32[i1 + 604 >> 2] = -1;
 HEAP32[i1 + 592 >> 2] = 1;
 HEAP32[i1 + 596 >> 2] = 0;
 HEAP32[i1 + 600 >> 2] = 0;
 HEAP32[i1 + 608 >> 2] = 0;
 HEAP32[i1 + 624 >> 2] = -1;
 HEAP32[i1 + 612 >> 2] = 1;
 HEAP32[i1 + 616 >> 2] = 0;
 HEAP32[i1 + 620 >> 2] = 0;
 HEAP32[i1 + 628 >> 2] = 0;
 HEAP32[i1 + 644 >> 2] = -1;
 HEAP32[i1 + 632 >> 2] = 1;
 HEAP32[i1 + 636 >> 2] = 0;
 HEAP32[i1 + 640 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 424 >> 2] = 0;
 HEAP32[i1 + 476 >> 2] = 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 32 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 16 >> 2] | 0;
   i3 = i11 + 20 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 << 3) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 48 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 16 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5Unity17ConfigurableJoint17SetTargetRotationERK11Quaternionf(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 32 | 0;
 i12 = i14 + 28 | 0;
 i13 = i14;
 i6 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i6 & 2139095040 | 0) != 2139095040 & (i4 & 2139095040 | 0) != 2139095040 & (i5 & 2139095040 | 0) != 2139095040 & (i2 & 2139095040 | 0) != 2139095040) {
  f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } else {
  f1 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(1.0);
 }
 HEAPF32[i10 + 308 >> 2] = f1;
 i9 = i10 + 312 | 0;
 HEAPF32[i9 >> 2] = f3;
 i6 = i10 + 316 | 0;
 HEAPF32[i6 >> 2] = f7;
 i5 = i10 + 320 | 0;
 HEAPF32[i5 >> 2] = f8;
 i2 = i10 + 32 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0) | 0) & 1) {
  STACKTOP = i14;
  return;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 176 >> 2] | 0, i13 | 0, i4 | 0);
 i4 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i10 + 308 >> 2];
 HEAP32[i13 + 4 >> 2] = i4;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i9;
 i10 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 172 >> 2] | 0, i10 | 0, i13 | 0);
 i13 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i13 >> 2] | 0) + 28 >> 2] | 0, i13 | 0, i11 | 0, i12 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i11 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i12 >> 2] | 0);
 STACKTOP = i14;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i4 + 16 | 0;
 HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i4 + 32 | 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i4 + 48 | 0;
 HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i4 + 68 | 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 HEAP32[i4 + 148 >> 2] = 0;
 HEAP32[i4 + 152 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = i4 + 148;
 HEAP32[i4 + 64 >> 2] = 1;
 HEAP32[i4 + 140 >> 2] = 8;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i4 + 116 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i4 + 120 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 156 | 0, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 431150 | 0, i4, 0);
 __ZN14SubstanceInput8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN14SubstanceInputD2Ev(i4);
 STACKTOP = i1;
 return;
}

function __ZN21ParticleSystemManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 16 | 0;
 i6 = i12;
 HEAP32[i1 >> 2] = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i10 = i6;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i1 + 20 >> 0] = 0;
 i8 = i1 + 24 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 28 | 0;
 HEAP32[i9 >> 2] = 1;
 i10 = i1 + 32 | 0;
 HEAP32[i10 >> 2] = 1812433254;
 i11 = i1 + 36 | 0;
 HEAP32[i11 >> 2] = 1900727103;
 i3 = HEAP32[i4 >> 2] | 0;
 do if ((i3 & 2147483616) >>> 0 < 32) if ((i3 | 0) > -1) {
  HEAP32[i4 >> 2] = 32;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 128, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(128, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = 32;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 33964 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i6, gb + 1048800 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 33196 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 33196 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 33196 + (i1 * 12 | 0) >> 2] = fb + 289;
 i7 = _time(0) | 0;
 HEAP32[i8 >> 2] = i7;
 i8 = (Math_imul(i7, 1812433253) | 0) + 1 | 0;
 HEAP32[i9 >> 2] = i8;
 i9 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i11 >> 2] = (Math_imul(i9, 1812433253) | 0) + 1;
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i11 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i11 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i11);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i4;
  }
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZNK20LightPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 20 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 8 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 24 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 28 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 32 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 20 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 64 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 24 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround((HEAP8[(HEAP32[i3 + 44 >> 2] | 0) + 85 >> 0] | 0) != 0 & 1);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 28 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 44 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 32 >> 2] | 0) == (i1 | 0)) {
  i3 = HEAP32[i3 + 44 >> 2] | 0;
  f4 = Math_fround(HEAPF32[((HEAP32[i3 + 40 >> 2] | 0) == 3 ? i3 + 204 | 0 : i3 + 48 | 0) >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 108 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 112 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 44 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 116 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 48 >> 2] | 0) == (i1 | 0)) {
  f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 120 >> 2]);
  return Math_fround(f4);
 }
 if ((HEAP32[i2 + 52 >> 2] | 0) != (i1 | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 60 >> 2]);
 return Math_fround(f4);
}

function __ZN15ReplacementPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceData(i10, i1, i11, i12, i13) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 40 | 0;
 i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i1) | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 110 >> 0] | 0)) i1 = 0; else i1 = HEAP8[(HEAP32[gb + 1166248 >> 2] | 0) + 149 >> 0] ^ 1;
 HEAP8[i10 + 104 >> 0] = i1;
 i2 = i10 + 12 | 0;
 i9 = i11 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i10 + 28 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 40 | 0, 8, i10 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 40 | 0, 8, i10 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i10 + 24 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
  }
  i1 = HEAP32[i9 >> 2] | 0;
 }
 if (!i1) return;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = i2;
 do {
  i5 = i8 + 8 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i12 >> 2] | 0;
  i6 = i7 + (i4 * 360 | 0) | 0;
  i7 = HEAP32[i7 + (i4 * 360 | 0) + 244 >> 2] | 0;
  if ((i7 | 0) > 0) {
   i2 = i8 + 18 | 0;
   i3 = i8 + 20 | 0;
   __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i10, i4, i6, HEAPU16[i2 >> 1] | 0, Math_fround(HEAPF32[i3 >> 2]), i13);
   if ((i7 | 0) != 1) {
    i1 = 1;
    do {
     __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData(i10, HEAP32[i5 >> 2] | 0, i6, HEAPU16[i2 >> 1] | 0, Math_fround(HEAPF32[i3 >> 2]), i13);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i7 | 0));
   }
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i8 = i8 + 32 | 0;
 } while ((i8 | 0) != (i2 + (i1 << 5) | 0));
 return;
}

function __ZN13BoneInfluence8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN12MeshCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737084 | 0, i6, i1 + 60 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737093 | 0, i6, i1 + 121 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734447 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 124 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 64 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i6, 0);
 i1 = i7 + 8 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z51AssetBundleCreateRequest_Get_Custom_PropAssetBundleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i4 = i9;
 i6 = i9 + 16 | 0;
 i7 = i9 + 12 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4); else i3 = i2;
 while (1) {
  if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0) | 0) break;
  __ZN14PreloadManager16UpdatePreloadingEv(__Z17GetPreloadManagerv() | 0);
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   i8 = 3;
   break;
  }
 }
 if ((i8 | 0) == 3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i4 = i1 + 84 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 14; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 14; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 16;
  }
 }
 if ((i8 | 0) == 14) i8 = 16;
 if ((i8 | 0) == 16) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i8 = i1;
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z15FMODMemoryAllocjjPKc(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (__Z46get_current_allocation_root_reference_internalv() | 0) {
  switch ((i3 & 65535) << 16 >> 16) {
  case 2:
  case 1:
   {
    i6 = gb + 63368 | 0;
    i3 = HEAP32[i6 + 4 >> 2] | 0;
    i4 = i1;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i4 + 4 >> 2] = i3;
    break;
   }
  case 4:
   {
    i3 = gb + 63376 | 0;
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    i6 = i1;
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = i4;
    break;
   }
  case 8:
   {
    i3 = gb + 63384 | 0;
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    i6 = i1;
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = i4;
    break;
   }
  default:
   {
    i3 = gb + 63360 | 0;
    i4 = HEAP32[i3 + 4 >> 2] | 0;
    i6 = i1;
    HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i6 + 4 >> 2] = i4;
   }
  }
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i1, 0, gb + 856220 | 0, 157) | 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1459924 >> 2] | 0, 0, 0) | 0;
 switch ((i3 & 65535) << 16 >> 16) {
 case 2:
 case 1:
  {
   i7 = gb + 63368 | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i6 = i1;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = i3;
   break;
  }
 case 4:
  {
   i3 = gb + 63376 | 0;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 case 8:
  {
   i3 = gb + 63384 | 0;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 default:
  {
   i3 = gb + 63360 | 0;
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
  }
 }
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i1, 0, gb + 856220 | 0, 154) | 0;
 if (!i4) {
  i7 = i1;
  STACKTOP = i5;
  return i7 | 0;
 }
 __Z19pop_allocation_rootv();
 i7 = i1;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl10getClassesEPN5physx8debugger16ClassDescriptionEjj(i6, i8, i2, i1) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 i1 = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
 i7 = i7 - i1 | 0;
 i7 = i7 >>> 0 > i2 >>> 0 ? i2 : i7;
 if (!i1) i1 = 0; else {
  i4 = HEAP32[i6 + 124 >> 2] | 0;
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   i1 = (((HEAP32[i4 + (i3 << 2) >> 2] | 0) != 0) << 31 >> 31) + i1 | 0;
   if (!i1) {
    i1 = i2;
    break;
   } else i3 = i2;
  }
 }
 i5 = HEAP32[i6 + 128 >> 2] | 0;
 if (!(i1 >>> 0 < i5 >>> 0 & (i7 | 0) != 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i4 = i6 + 124 | 0;
 i3 = i1;
 i1 = 0;
 do {
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if (i2) {
   i10 = i2 + 4 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i6 = i8 + (i1 * 72 | 0) + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i6 + 4 >> 2] = i9;
   HEAP32[i8 + (i1 * 72 | 0) + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i6 = i8 + (i1 * 72 | 0) + 28 | 0;
   i9 = i2 + 28 | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   i6 = i8 + (i1 * 72 | 0) + 48 | 0;
   i9 = i2 + 48 | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i8 + (i1 * 72 | 0) + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   i6 = i8 + (i1 * 72 | 0) + 68 | 0;
   i2 = i2 + 68 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   HEAP8[i6 >> 0] = i2;
   HEAP8[i6 + 1 >> 0] = i2 >> 8;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i5 >>> 0 & i1 >>> 0 < i7 >>> 0);
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i18, i1) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i7 = i18 + 28 | 0;
 i17 = HEAP32[i7 >> 2] | 0;
 f19 = Math_fround(i1 >>> 0);
 i8 = ~~Math_fround(f19 * Math_fround(HEAPF32[i18 + 36 >> 2])) >>> 0;
 i13 = i1 << 2;
 i12 = (i8 << 2) + i13 | 0;
 i12 = (0 - i12 & 12) + i12 | 0;
 i9 = i18 + 4 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i10 = mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i12 + (i8 << 3) | 0, HEAP32[i18 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i11 = i10 + i13 | 0;
 i12 = i10 + i12 | 0;
 _memset(i10 | 0, -1, i13 | 0) | 0;
 i13 = i18 + 48 | 0;
 i6 = i18 + 16 | 0;
 if (HEAP32[i13 >> 2] | 0) {
  i14 = i1 + -1 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i16 = 0;
  do {
   i3 = HEAP32[i5 + (i16 << 3) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i15 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i10 + ((i2 & i14) << 2) | 0;
   HEAP32[i11 + (i16 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i16;
   HEAP32[i12 + (i16 << 3) >> 2] = i15;
   HEAP32[i12 + (i16 << 3) + 4 >> 2] = HEAP32[i5 + (i16 << 3) + 4 >> 2];
   i16 = i16 + 1 | 0;
  } while (i16 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0);
 }
 i16 = i18 + 12 | 0;
 i15 = HEAP32[i9 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, HEAP32[i16 >> 2] | 0);
 HEAP32[i16 >> 2] = i10;
 HEAP32[i18 + 24 >> 2] = i10;
 HEAP32[i18 + 32 >> 2] = i1;
 HEAP32[i18 + 20 >> 2] = i11;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i7 >> 2] = i8;
 i1 = i18 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i17;
 return;
}

function __ZN18PlatformEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 88 | 0;
 i7 = i6 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 76 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 77 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 80 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 78 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 79 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN17AnimationCurveTplI11QuaternionfE6AssignEPK11KeyframeTplIS0_ES5_(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i8 + 152 | 0;
 i7 = i8 + 164 | 0;
 i2 = i1 - i6 | 0;
 i3 = (i2 | 0) / 52 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 168 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2, 4, i8 + 156 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i8 + 156 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 52 | 0) | 0;
 i5 = i8 + 152 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i7 = i8 + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 80 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  i8 = i8 + 76 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 i1 = i2;
 i4 = i2 + (i3 * 52 | 0) | 0;
 L11 : while (1) {
  while (1) {
   if (!(((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 8 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i1 + 12 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i1 + 16 >> 2] & 2139095040 | 0) != 2139095040)) break;
   if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
   i1 = i1 + 52 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 13;
    break L11;
   }
  }
  i4 = i1 + 52 | 0;
  _memmove(i1 | 0, i4 | 0, i2 + (i3 * 52 | 0) - i4 | 0) | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = i2 + (i3 * 52 | 0) | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 13;
   break;
  }
 }
 if ((i1 | 0) == 13) {
  i7 = i8 + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 80 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  i8 = i8 + 76 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
}

function __ZN13ScreenManager15SetBlitMaterialEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i1 = i7;
 i6 = i7 + 8 | 0;
 i2 = i4 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i9 = gb + 63520 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  i3 = __Z20CreateObjectFromCodeI19LowerResBlitTextureEPT_17AwakeFromLoadMode10MemLabelId(4, i5) | 0;
  HEAP32[i2 >> 2] = i3;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, 61);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 80 >> 2] | 0, i4 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i3 + 80 >> 2] = i2;
 HEAP32[i3 + 84 >> 2] = i1;
 HEAPF32[i3 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
 HEAPF32[i3 + 72 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
 i1 = i4 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i8 = i2;
  i9 = HEAP32[gb + 1166248 >> 2] | 0;
  i9 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i8, 0, i9, 0, 1) | 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 i8 = __Z15GetScriptMapperv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 410414 | 0, 15);
 i8 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i8 = __ZN8Material14CreateMaterialER6Shaderib(i8, 61, 0) | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[gb + 1158340 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i8, i5, i3);
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[gb + 1166248 >> 2] | 0;
 i9 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i8, 0, i9, 0, 1) | 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefIhEE(i11, i13) {
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 4 | 0;
 i10 = i14;
 i5 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i10 | 0, i8 | 0) | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 HEAP8[i10 >> 0] = i8 >>> 24;
 HEAP8[i10 + 3 >> 0] = i8;
 HEAP8[i10 + 1 >> 0] = i8 >>> 16;
 HEAP8[i10 + 2 >> 0] = (i8 & 65535) >>> 8;
 i8 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i11 + 20 >> 2] | 0;
 i9 = i5 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = i4;
 i12 = i2 - i1 | 0;
 i3 = i12 + i8 | 0;
 if (!i3) i1 = i8; else {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i1 | 0) >>> 0 > i3 >>> 0) i1 = i8; else {
   i1 = i3 << 1;
   if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i3 >>> 0) * Math_fround(1.20000005)) >>> 0;
   i3 = i5 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i4 | 0, i2 | 0, i12 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i4;
   i2 = i4 + i12 | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i7 >> 2] = i4 + i1;
   i1 = HEAP32[i10 >> 2] | 0;
  }
 }
 HEAP32[i9 >> 2] = i2 + i8;
 i3 = i4 + i12 | 0;
 if (!i1) {
  i10 = 0;
  i11 = i3;
  i12 = i10 + i12 | 0;
  i12 = i4 + i12 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i2 = 0;
 do {
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i4 + (i2 + i12) | 0);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 i11 = i3;
 i12 = i1 + i12 | 0;
 i12 = i4 + i12 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i14;
 return;
}

function __ZN12LightsModule5StartER23ParticleSystemParticlesjj(i6, i4, i5, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = i13 >>> 0 > i5 >>> 0;
 if (!(HEAP8[i6 + 12 >> 0] | 0)) {
  if (!i2) return;
  i7 = i4 + 608 | 0;
  i8 = i6 + 8 | 0;
  i6 = i6 + 572 | 0;
  do {
   do if (!i1) {
    i1 = (HEAP32[i7 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << (i5 & 31));
    i1 = 0;
   } else {
    i1 = i1 + -1 | 0;
    f3 = Math_fround(HEAPF32[i8 >> 2]);
    f3 = Math_fround(f3 + Math_fround(HEAPF32[i6 >> 2]));
    HEAPF32[i6 >> 2] = f3;
    i12 = !(f3 >= Math_fround(1.0));
    i2 = 1 << (i5 & 31);
    i4 = HEAP32[i7 >> 2] | 0;
    if (i12) {
     i12 = i4 + (i5 >>> 5 << 2) | 0;
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~i2;
     break;
    } else {
     i12 = i4 + (i5 >>> 5 << 2) | 0;
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i2;
     HEAPF32[i6 >> 2] = Math_fround(f3 + Math_fround(-1.0));
     break;
    }
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  return;
 } else {
  if (!i2) return;
  i8 = i6 + 556 | 0;
  i9 = i6 + 560 | 0;
  i10 = i6 + 564 | 0;
  i11 = i6 + 568 | 0;
  i7 = i4 + 608 | 0;
  f3 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  i4 = f3 != Math_fround(0.0);
  do {
   if (i4) {
    i1 = HEAP32[i8 >> 2] | 0;
    i1 = i1 << 11 ^ i1;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    i6 = HEAP32[i11 >> 2] | 0;
    HEAP32[i10 >> 2] = i6;
    i6 = i1 >>> 8 ^ i1 ^ i6 ^ i6 >>> 19;
    HEAP32[i11 >> 2] = i6;
    i6 = !(Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07)) <= f3);
    i1 = 1 << (i5 & 31);
    i2 = HEAP32[i7 >> 2] | 0;
    if (i6) i12 = 10; else {
     i6 = i2 + (i5 >>> 5 << 2) | 0;
     HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i1;
    }
   } else {
    i1 = 1 << (i5 & 31);
    i2 = HEAP32[i7 >> 2] | 0;
    i12 = 10;
   }
   if ((i12 | 0) == 10) {
    i12 = 0;
    i6 = i2 + (i5 >>> 5 << 2) | 0;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~i1;
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i13 | 0));
  return;
 }
}

function __Z16IntersectRayAABBRK3RayRK4AABBPfS5_(i5, i3, i11, i12) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f13 = f0, f14 = f0;
 f6 = Math_fround(HEAPF32[gb + 62496 >> 2]);
 f2 = Math_fround(-f6);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i5 >> 2]));
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i5 + 4 >> 2]));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i5 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 i3 = i5 + 12 | 0;
 f14 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 >> 2]));
 f1 = Math_fround(f14 * Math_fround(f13 + f4));
 f4 = Math_fround(f14 * Math_fround(f13 - f4));
 if (f1 < f4) {
  f2 = f1 > f2 ? f1 : f2;
  f1 = f4 < f6 ? f4 : f6;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  }
 } else {
  f2 = f4 > f2 ? f4 : f2;
  f1 = f1 < f6 ? f1 : f6;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  }
 }
 f4 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 4 >> 2]));
 f6 = Math_fround(f4 * Math_fround(f7 + f8));
 f4 = Math_fround(f4 * Math_fround(f7 - f8));
 if (f6 < f4) {
  f2 = f6 > f2 ? f6 : f2;
  f1 = f4 < f1 ? f4 : f1;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  } else f6 = f1;
 } else {
  f2 = f4 > f2 ? f4 : f2;
  f1 = f6 < f1 ? f6 : f1;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  } else f6 = f1;
 }
 f1 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(f1 * Math_fround(f10 + f9));
 f1 = Math_fround(f1 * Math_fround(f10 - f9));
 if (f4 < f1) {
  f2 = f4 > f2 ? f4 : f2;
  f1 = f1 < f6 ? f1 : f6;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  }
 } else {
  f2 = f1 > f2 ? f1 : f2;
  f1 = f4 < f6 ? f4 : f6;
  if (f2 > f1 | f1 < Math_fround(0.0)) {
   i12 = 0;
   return i12 | 0;
  }
 }
 HEAPF32[i11 >> 2] = f2;
 HEAPF32[i12 >> 2] = f1;
 i12 = 1;
 return i12 | 0;
}

function __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (((i3 - i1 | 0) / 40 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i4 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i4 | 0));
   i1 = (HEAP32[i10 >> 2] | 0) + 40 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 40 | 0) + i2 | 0;
 if (i5 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 40 | 0;
 i7 = i6 << 1;
 i5 = i6 >>> 0 < 53687091 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 107374182;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 40 | 0) | 0;
 i3 = i6 + (((i1 - i4 | 0) / 40 | 0) * 40 | 0) | 0;
 i7 = i3;
 i5 = i6 + (i5 * 40 | 0) | 0;
 i1 = i3;
 i6 = i7;
 do {
  i4 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i4 | 0));
  i1 = i6 + 40 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i4 = i2;
  i2 = i7;
  do {
   i11 = i4;
   i4 = i4 + -40 | 0;
   HEAP32[i3 + -40 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i11 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i11 + -32 >> 2];
   i7 = i3 + -28 | 0;
   i11 = i11 + -28 | 0;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
   HEAP32[i7 + 24 >> 2] = HEAP32[i11 + 24 >> 2];
   i3 = i2 + -40 | 0;
   i2 = i3;
  } while ((i4 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpCloth13setClothFlagsENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i4 = i11 + 8 | 0;
 i2 = i11;
 i5 = i8 + 24 | 0;
 i6 = i8 + 32 | 0;
 i7 = i8 + 20 | 0;
 i1 = (HEAP16[i3 >> 1] & 1) != 0;
 switch ((HEAP32[i5 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i10 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 3; else i10 = 4;
   break;
  }
 default:
  i10 = 3;
 }
 if ((i10 | 0) == 3) __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i6, 1, i1); else if ((i10 | 0) == 4) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 936, gb + 698357 | 0, i2);
 i1 = (HEAP16[i3 >> 1] & 2) != 0;
 switch ((HEAP32[i5 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i10 = 7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 8; else i10 = 7;
   break;
  }
 default:
  i10 = 8;
 }
 if ((i10 | 0) == 7) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 936, gb + 698357 | 0, i4); else if ((i10 | 0) == 8) __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i6, 2, i1);
 i1 = (HEAP16[i3 >> 1] & 4) != 0;
 switch ((HEAP32[i5 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i10 = 11;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i10 = 11;
   break;
  }
 default:
  i10 = 12;
 }
 if ((i10 | 0) == 11) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 936, gb + 698357 | 0, i9);
  __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i8) | 0;
  STACKTOP = i11;
  return;
 } else if ((i10 | 0) == 12) {
  __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i6, 4, i1);
  __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i8) | 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN13CameraLODData9AddAtBackEhf(i10, i2, f11) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 16 | 0;
 i4 = i10 + 28 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i10 + 32 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1, 1, i10 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i10 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i5 >> 0] = i2;
 i2 = i10 + 36 | 0;
 i3 = i10 + 48 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 52 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 if (i5 >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAPF32[i10 >> 2] = f11;
  return;
 }
 i1 = i7 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i8 >>> 0 >= i1 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAPF32[i10 >> 2] = f11;
  return;
 }
 if ((i7 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAPF32[i10 >> 2] = f11;
  return;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = i5;
  i10 = HEAP32[i2 >> 2] | 0;
  i10 = i10 + (i4 << 2) | 0;
  HEAPF32[i10 >> 2] = f11;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 28 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 12 >> 2] | 0;
   i3 = i11 + 16 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 << 3) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 44 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 24 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 36 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 20 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 40 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 12 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj431ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 220; else i1 = (HEAP32[i1 >> 2] | 0) + 220 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj431ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN14BlendShapeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i5 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 * 40 | 0) | 0;
 if (i4 | 0) do {
  __ZN16BlendShapeVertex8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i6 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 * 12 | 0) | 0;
 if (i4 | 0) do {
  __ZN10BlendShape8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i5, i6 + 40 | 0, 0);
 i4 = i6 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i6 + 52 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14;
 i12 = HEAP32[i7 + 8 >> 2] | 0;
 i13 = __Z21GetScriptingArraySizeP11Il2CppArray(i11) | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) != (i7 | 0)) do {
  i6 = i2 + 8 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 10; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i4 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i4 + (i5 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i4 = HEAP32[i8 >> 2] | 0;
     i15 = HEAP32[i2 + 28 >> 2] | 0;
     i5 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i4 | 0) == -1 ? i15 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i15 + (i4 << 3) | 0;
     i4 = HEAP32[i5 + 28 >> 2] | 0;
     i5 = HEAP32[i5 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i4 + (i5 << 3) | 0)) i10 = 10; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i10 = 12;
    }
   }
   if ((i10 | 0) == 10) i10 = 12;
   if ((i10 | 0) == 12) {
    i10 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
   }
  }
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i11, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i7 | 0));
 if ((i1 | 0) >= (i13 | 0)) {
  STACKTOP = i14;
  return i12 | 0;
 }
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i11, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i13 | 0));
 STACKTOP = i14;
 return i12 | 0;
}

function __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   __ZN14ConstantString12create_emptyEv(i1);
   i1 = (HEAP32[i11 >> 2] | 0) + 16 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 4) + i2 | 0;
 if (i5 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 3;
 i3 = i8 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 268435455;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 4) | 0;
 i7 = i5 + (i1 - i4 >> 4 << 4) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 4) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  __ZN14ConstantString12create_emptyEv(i1);
  i1 = i8 + 16 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i7 = i2 + -16 | 0;
   i6 = i1;
   i1 = i1 + -16 | 0;
   HEAP32[i7 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i7, i1);
   i7 = i2 + -12 | 0;
   i6 = i6 + -12 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   i2 = i3 + -16 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -16 | 0;
  __ZN14ConstantStringD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS0_14NamedAllocatorEPKcEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_S9_SC_NS0_20NonTrackingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i13 + 16 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i5 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i6 = HEAP32[gb + 1452348 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i8 + (i5 << 3) | 0, gb + 778463 | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 36 | 0;
 i3 = i13 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i2 + (i11 << 3) >> 2] | 0;
   i16 = i15 + ~(i15 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i6 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP32[i8 + (i11 << 3) >> 2] = i15;
   HEAP32[i8 + (i11 << 3) + 4 >> 2] = HEAP32[i2 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i16 = HEAP32[i13 >> 2] | 0;
 i15 = HEAP32[gb + 1452348 >> 2] | 0;
 i15 = mftCall_ii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, i15 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i16 | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i4 >> 2] = i5;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx2Cm10Collection5addIdERNS_6PxBaseEy(i8, i7, i9, i10) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i6 = i12 + 12 | 0;
 i5 = i12 + 8 | 0;
 i1 = HEAP32[i8 + 64 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = i7;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i8 + 56 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i8 + 48 >> 2] | 0;
   i3 = i8 + 52 | 0;
   while (1) {
    i2 = i4 + (i1 << 4) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i1 = i4 + (i1 << 4) + 8 | 0;
    i4 = i1;
    if (!((HEAP32[i4 >> 2] | 0) == 0 & (HEAP32[i4 + 4 >> 2] | 0) == 0)) __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i8 + 4 | 0, i1) | 0;
   }
  }
 } while (0);
 i1 = i11;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i8 + 4 | 0, i11, i6) | 0;
 i2 = i7;
 if (!(HEAP8[i6 >> 0] | 0)) {
  i6 = i1;
  HEAP32[i6 >> 2] = i9;
  HEAP32[i6 + 4 >> 2] = i10;
  HEAP32[i1 + 8 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = i7;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i8 + 44 | 0, i5, i11) | 0;
 if (!(HEAP8[i11 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  i11 = i1 + 8 | 0;
  i8 = i11;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i8 = i11;
  HEAP32[i8 >> 2] = i9;
  i11 = i11 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i12;
  return;
 } else {
  i11 = i1 + 8 | 0;
  i8 = i11;
  HEAP32[i8 >> 2] = i9;
  i11 = i11 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgExNS_8ios_base7seekdirE(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i5 = i8;
 i9 = i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i9 | 0, HEAP32[i9 + 16 >> 2] & -3 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i9 & 1) i6 = 7; else {
  __THREW__ = 0;
  invoke_viii(fb + 1038 | 0, i4 | 0, i7 | 0, 1);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i6 = 7; else do if (HEAP8[i4 >> 0] | 0) {
   i9 = HEAP32[i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   __THREW__ = 0;
   invoke_viiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i9 | 0, i1 | 0, i2 | 0, i3 | 0, 8);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   } else {
    i9 = i5 + 8 | 0;
    if (!((HEAP32[i9 >> 2] | 0) == -1 ? (HEAP32[i9 + 4 >> 2] | 0) == -1 : 0)) break;
    i9 = i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i9 | 0, HEAP32[i9 + 16 >> 2] | 4 | 0);
    i9 = __THREW__;
    __THREW__ = 0;
    if (!(i9 & 1)) break;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i6 = 12;
   break L1;
  } while (0);
 } while (0);
 if ((i6 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i6 = 12;
 }
 do if ((i6 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (!(i9 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgExNS_8ios_base7seekdirE(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i5 = i8;
 i9 = i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4508 | 0, i9 | 0, HEAP32[i9 + 16 >> 2] & -3 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i9 & 1) i6 = 7; else {
  __THREW__ = 0;
  invoke_viii(fb + 1037 | 0, i4 | 0, i7 | 0, 1);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i6 = 7; else do if (HEAP8[i4 >> 0] | 0) {
   i9 = HEAP32[i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   __THREW__ = 0;
   invoke_viiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i9 | 0, i1 | 0, i2 | 0, i3 | 0, 8);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) {
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   } else {
    i9 = i5 + 8 | 0;
    if (!((HEAP32[i9 >> 2] | 0) == -1 ? (HEAP32[i9 + 4 >> 2] | 0) == -1 : 0)) break;
    i9 = i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i9 | 0, HEAP32[i9 + 16 >> 2] | 4 | 0);
    i9 = __THREW__;
    __THREW__ = 0;
    if (!(i9 & 1)) break;
    i1 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
   }
   i6 = 12;
   break L1;
  } while (0);
 } while (0);
 if ((i6 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i6 = 12;
 }
 do if ((i6 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i7 + (HEAP32[(HEAP32[i7 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (!(i9 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i9 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i9);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN8Renderer34GetLightProbeInterpolationPositionEv(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i2 = i9;
 i4 = i5 + 280 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i8 = 9;
   }
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  __ZNK9Transform11GetPositionEv(i7, i1);
  STACKTOP = i9;
  return;
 } while (0);
 __ZN12BaseRenderer12GetWorldAABBER4AABB(i5 + 32 | 0, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i1 & 2139095040 | 0) != 2139095040 & (i2 & 2139095040 | 0) != 2139095040 & (i3 & 2139095040 | 0) != 2139095040) if (((HEAP32[i6 + 12 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i6 + 16 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i6 + 20 >> 2] & 2139095040 | 0) != 2139095040) {
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i3;
 } else i8 = 14; else i8 = 14;
 if ((i8 | 0) == 14) {
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 }
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 32 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 16 >> 2] | 0;
   i3 = i11 + 20 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 << 3) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 48 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 16 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx2Sn17readAllPropertiesINS_7PxShapeEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i2, i5, i4, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 284 | 0;
 i14 = i11 + 232 | 0;
 i6 = i11 + 32 | 0;
 i10 = i11 + 16 | 0;
 i9 = i11;
 i15 = i11 + 40 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i10 >> 2] = i6;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = i6;
 i6 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx20PxShapeGeneratedInfoC2Ev(i15);
 HEAP8[i13 >> 0] = 0;
 HEAP32[i14 >> 2] = i10;
 HEAP32[i14 + 4 >> 2] = i9;
 i16 = i14 + 8 | 0;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i16 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i16 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i14 + 20 >> 2] = i5;
 HEAP32[i14 + 24 >> 2] = i4;
 HEAP32[i14 + 28 >> 2] = i1;
 HEAP32[i14 + 32 >> 2] = i3;
 HEAP8[i14 + 36 >> 0] = 1;
 HEAP32[i14 + 40 >> 2] = i13;
 HEAP32[i14 + 44 >> 2] = 0;
 HEAP32[i14 + 48 >> 2] = 0;
 __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j(i15, i14, 0) | 0;
 i2 = (HEAP8[i13 >> 0] | 0) == 0;
 i5 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i16 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
  }
 }
 i16 = HEAP32[i8 >> 2] | 0;
 if (!((i16 | 0) > -1 & (i16 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i16 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 92 | 0, i5);
 i1 = i7 + 40 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 36 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN5Umbra5QueryaSERKS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i1 + 3 & -4;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = (i3 | 0) == 0 ? 0 : i3 + 3 & -4;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  i4 = i1 + 36 | 0;
  i5 = i1 + 120 + 15 & -16;
  i6 = i5;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = i6;
  i6 = i6 + (i3 + 102400 - i5) | 0;
  HEAP32[i1 + 44 >> 2] = i6;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 + 48 >> 2] = i5;
  HEAP32[i1 + 52 >> 2] = i6 - i5;
  i5 = i1 + 56 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i1 + 76 >> 2] = i4;
  HEAP32[i1 + 80 >> 2] = 1;
  HEAP32[i1 + 84 >> 2] = 1;
  HEAP32[i1 + 88 >> 2] = 1;
  HEAP32[i1 + 92 >> 2] = -1;
  HEAP32[i1 + 96 >> 2] = 0;
  HEAP32[i1 + 100 >> 2] = 0;
  HEAP32[i1 + 104 >> 2] = 0;
  __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i1, i2, 0);
  return i3 | 0;
 } else {
  i6 = (i3 | 0) == 0 ? 0 : i3 + 3 & -4;
  HEAP32[i6 + 24 >> 2] = 0;
  HEAP32[i6 + 28 >> 2] = 0;
  HEAP32[i6 + 32 >> 2] = 0;
  i5 = i6 + 36 | 0;
  i4 = i6 + 120 + 15 & -16;
  i1 = i4;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i6 + 40 >> 2] = i1;
  i1 = i1 + (i3 + 102400 - i4) | 0;
  HEAP32[i6 + 44 >> 2] = i1;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 + 48 >> 2] = i4;
  HEAP32[i6 + 52 >> 2] = i1 - i4;
  i4 = i6 + 56 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i6 + 76 >> 2] = i5;
  HEAP32[i6 + 80 >> 2] = 1;
  HEAP32[i6 + 84 >> 2] = 1;
  HEAP32[i6 + 88 >> 2] = 1;
  HEAP32[i6 + 92 >> 2] = -1;
  HEAP32[i6 + 96 >> 2] = 0;
  HEAP32[i6 + 100 >> 2] = 0;
  HEAP32[i6 + 104 >> 2] = 0;
  __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i6, 0, i2);
  return i3 | 0;
 }
 return 0;
}

function __ZN5Umbra13MatrixFactory16orthonormalBasisERKNS_7Vector3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, d10 = 0.0, f11 = f0, f12 = f0, f13 = f0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f6 * f6);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f7));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f2 * f2)))));
 f6 = Math_fround(f6 * f8);
 f7 = Math_fround(f7 * f8);
 f8 = Math_fround(f2 * f8);
 f2 = Math_fround(Math_abs(Math_fround(f6)));
 f3 = Math_fround(Math_abs(Math_fround(f7)));
 f4 = Math_fround(Math_abs(Math_fround(f8)));
 do if (!(f2 <= f3) | !(f2 <= f4)) if (!(f3 <= f2) | !(f3 <= f4)) {
  f3 = Math_fround(-f7);
  f4 = f6;
  f2 = Math_fround(0.0);
  break;
 } else {
  f3 = Math_fround(-f8);
  f4 = Math_fround(0.0);
  f2 = f6;
  break;
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(-f8);
  f2 = f7;
 } while (0);
 f5 = Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f2 * f2));
 if (f5 != Math_fround(0.0)) {
  d10 = 1.0 / +Math_sqrt(+(+f5));
  f3 = Math_fround(+f3 * d10);
  f4 = Math_fround(+f4 * d10);
  f2 = Math_fround(+f2 * d10);
 }
 f13 = Math_fround(Math_fround(f7 * f2) - Math_fround(f8 * f4));
 f11 = Math_fround(Math_fround(f8 * f3) - Math_fround(f6 * f2));
 f5 = Math_fround(Math_fround(f6 * f4) - Math_fround(f7 * f3));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(Math_fround(f13 * f13) + Math_fround(f11 * f11))))));
 f11 = Math_fround(f11 * f12);
 f5 = Math_fround(f5 * f12);
 HEAPF32[i9 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i9 + 16 >> 2] = f11;
 HEAPF32[i9 + 32 >> 2] = f5;
 HEAP32[i9 + 48 >> 2] = 0;
 HEAPF32[i9 + 4 >> 2] = f3;
 HEAPF32[i9 + 20 >> 2] = f4;
 HEAPF32[i9 + 36 >> 2] = f2;
 HEAP32[i9 + 52 >> 2] = 0;
 HEAPF32[i9 + 8 >> 2] = f6;
 HEAPF32[i9 + 24 >> 2] = f7;
 HEAPF32[i9 + 40 >> 2] = f8;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 1065353216;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i5) i4 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, (i5 << 6) + 131 | 0, (i1 ? gb + 721479 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i4 = 0; else {
   i4 = i1 + 131 & -128;
   HEAP32[i4 + -4 >> 2] = i4 - i1;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 6) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i7 = i1 + 36 | 0;
   i8 = i2 + 36 | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   i1 = i1 + 64 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 64 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN7ApiGLES10InvalidateERK14GfxContextGLES(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 + 460 >> 2] = HEAP32[i2 + 524 >> 2];
 HEAP8[i4 >> 0] = 15;
 HEAP8[i4 + 1 >> 0] = 1;
 HEAP8[i4 + 2 >> 0] = 0;
 HEAP8[i4 + 3 >> 0] = 1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP8[i4 + 8 >> 0] = 15;
 HEAP8[i4 + 9 >> 0] = 1;
 HEAP8[i4 + 10 >> 0] = 0;
 HEAP8[i4 + 11 >> 0] = 1;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP8[i4 + 16 >> 0] = 15;
 HEAP8[i4 + 17 >> 0] = 1;
 HEAP8[i4 + 18 >> 0] = 0;
 HEAP8[i4 + 19 >> 0] = 1;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP8[i4 + 24 >> 0] = 15;
 HEAP8[i4 + 25 >> 0] = 1;
 HEAP8[i4 + 26 >> 0] = 0;
 HEAP8[i4 + 27 >> 0] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 15;
 HEAP8[i4 + 33 >> 0] = 1;
 HEAP8[i4 + 34 >> 0] = 0;
 HEAP8[i4 + 35 >> 0] = 1;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 15;
 HEAP8[i4 + 41 >> 0] = 1;
 HEAP8[i4 + 42 >> 0] = 0;
 HEAP8[i4 + 43 >> 0] = 1;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP8[i4 + 48 >> 0] = 15;
 HEAP8[i4 + 49 >> 0] = 1;
 HEAP8[i4 + 50 >> 0] = 0;
 HEAP8[i4 + 51 >> 0] = 1;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP8[i4 + 56 >> 0] = 15;
 HEAP8[i4 + 57 >> 0] = 1;
 HEAP8[i4 + 58 >> 0] = 0;
 HEAP8[i4 + 59 >> 0] = 1;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i2 + 468 >> 2] = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i2, i4) | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP8[i4 + 1 >> 0] = -1;
 HEAP8[i4 + 2 >> 0] = -1;
 HEAP8[i4 + 3 >> 0] = 0;
 HEAP8[i4 + 4 >> 0] = 8;
 HEAP8[i4 + 5 >> 0] = 0;
 HEAP8[i4 + 6 >> 0] = 0;
 HEAP8[i4 + 7 >> 0] = 0;
 HEAP8[i4 + 8 >> 0] = 8;
 HEAP8[i4 + 9 >> 0] = 0;
 HEAP8[i4 + 10 >> 0] = 0;
 HEAP8[i4 + 11 >> 0] = 0;
 HEAP32[i2 + 464 >> 2] = __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i2, i4) | 0;
 HEAP32[i4 >> 2] = 2;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 472 >> 2] = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i2, i4) | 0;
 HEAP8[i2 + 569 >> 0] = 0;
 STACKTOP = i3;
 return;
}

function __ZN14RenderSettings5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAPF32[i1 + 28 >> 2] = Math_fround(.211999997);
 HEAPF32[i1 + 32 >> 2] = Math_fround(.226999998);
 HEAPF32[i1 + 36 >> 2] = Math_fround(.259000003);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(.114);
 HEAPF32[i1 + 48 >> 2] = Math_fround(.125);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.133000001);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(.0469999984);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.0430000015);
 HEAPF32[i1 + 68 >> 2] = Math_fround(.0350000001);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 300 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 308 >> 2] = Math_fround(3.0);
 HEAP8[i1 + 312 >> 0] = 0;
 HEAP32[i1 + 316 >> 2] = 3;
 HEAPF32[i1 + 320 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 324 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 328 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 332 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 336 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 340 >> 2] = Math_fround(300.0);
 HEAPF32[i1 + 344 >> 2] = Math_fround(.00999999977);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 453292 | 0, 8);
 HEAP32[i1 + 348 >> 2] = __ZNK22BuiltinResourceManager21GetResourceInstanceIDEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 32032 | 0, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 HEAP32[i1 + 352 >> 2] = 0;
 HEAPF32[i1 + 364 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 368 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 128;
 HEAP32[i1 + 376 >> 2] = 1;
 HEAPF32[i1 + 392 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 396 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 400 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 404 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN14PhysicsManager34ResetInterpolatedTransformPositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i20 + 28 | 0;
 i18 = i20 + 16 | 0;
 i19 = i20;
 if ((HEAP16[gb + 1452476 + 6 >> 1] | 0) > -1) {
  HEAP32[i18 >> 2] = 0;
  HEAP32[i16 >> 2] = HEAP32[i18 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452476 | 0, i16);
  i17 = gb + 1452476 | 0;
 } else i17 = 0;
 i2 = HEAP32[i1 + 200 >> 2] | 0;
 i14 = i1 + 196 | 0;
 i1 = i2;
 if ((i1 | 0) != (i14 | 0)) {
  i15 = i16 + 16 | 0;
  i4 = i16 + 20 | 0;
  i5 = i16 + 24 | 0;
  i6 = i18 + 4 | 0;
  i7 = i18 + 8 | 0;
  i8 = i16 + 4 | 0;
  i9 = i16 + 8 | 0;
  i10 = i16 + 12 | 0;
  i11 = i19 + 4 | 0;
  i12 = i19 + 8 | 0;
  i13 = i19 + 12 | 0;
  i3 = i1;
  do {
   i1 = HEAP32[i2 + 36 >> 2] | 0;
   i2 = i1 + 52 | 0;
   i21 = HEAP32[i2 >> 2] | 0;
   if (!(mftCall_ii(HEAP32[(HEAP32[i21 >> 2] | 0) + 256 >> 2] | 0, i21 | 0) | 0)) {
    i21 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i1 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    i22 = HEAP32[i5 >> 2] | 0;
    HEAP32[i18 >> 2] = HEAP32[i15 >> 2];
    HEAP32[i6 >> 2] = i1;
    HEAP32[i7 >> 2] = i22;
    i22 = HEAP32[i2 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i22 >> 2] | 0) + 84 >> 2] | 0, i16 | 0, i22 | 0);
    i22 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i2 = HEAP32[i10 >> 2] | 0;
    HEAP32[i19 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i11 >> 2] = i22;
    HEAP32[i12 >> 2] = i1;
    HEAP32[i13 >> 2] = i2;
    __ZN9Transform41SetPositionAndRotationWithoutNotificationERK8Vector3fRK11Quaternionf(i21, i18, i19);
   }
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
  } while ((i3 | 0) != (i14 | 0));
 }
 if (!i17) {
  STACKTOP = i20;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i17);
 STACKTOP = i20;
 return;
}

function __ZN14ConstantString6assignEPKc10MemLabelId(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) if (i1 >>> 0 < (gb + 388687 | 0) >>> 0 | i1 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i2 = i1 + -8 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if (!(HEAP32[i2 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i10, HEAP32[i1 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i10);
  }
 }
 HEAP32[i7 >> 2] = 0;
 i6 = HEAP32[gb + 1115292 >> 2] | 0;
 L6 : do if (!i8) i11 = 15; else {
  if (i8 >>> 0 < (gb + 388687 + 1052 | 0) >>> 0 & i8 >>> 0 >= (gb + 388687 | 0) >>> 0) {
   HEAP32[i7 >> 2] = i8;
   STACKTOP = i12;
   return;
  }
  i1 = HEAP8[i8 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i2 = 0; else {
   i2 = 0;
   i3 = i8;
   do {
    i2 = (i2 << 4) + (i1 << 24 >> 24) | 0;
    i5 = i2 & -268435456;
    i2 = (i5 >>> 24 | i5) ^ i2;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
  }
  i1 = (i2 >>> 0) % 20 | 0;
  i5 = HEAP32[i6 + (i1 * 20 | 0) + 12 >> 2] | 0;
  if (!i5) i11 = 15; else {
   i3 = HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i2 | 0)) {
     i4 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
     if (!(_strcmp(i4, i8) | 0)) break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) {
     i11 = 15;
     break L6;
    }
   }
   HEAP32[i7 >> 2] = i4;
   if (i4 | 0) {
    STACKTOP = i12;
    return;
   }
  }
 } while (0);
 if ((i11 | 0) == 15) HEAP32[i7 >> 2] = 0;
 i5 = HEAP32[i9 >> 2] | 0;
 __Z14CreateMemLabel18MemLabelIdentifierPv(i10, i5, i6);
 i9 = _strlen(i8) | 0;
 i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + 9 | 0, 16, i10, 0, gb + 389834 | 0, 73) | 0;
 i11 = i10 + 8 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i5;
 _memcpy(i11 | 0, i8 | 0, i9 | 0) | 0;
 HEAP8[i11 + i9 >> 0] = 0;
 HEAP32[i7 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN14AnimationState21RemoveMixingTransformER9Transform(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i7 = i14;
 i10 = i14 + 4 | 0;
 i11 = i9 + 144 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i9 + 148 | 0;
 i12 = HEAP32[i6 >> 2] | 0;
 if (!i12) i13 = 14; else {
  i3 = i6;
  i2 = i12;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) == (i6 | 0)) i13 = 14; else if ((i3 | 0) == (i6 | 0) ? 1 : (i5 | 0) < (HEAP32[i3 + 16 >> 2] | 0)) i13 = 14; else {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i11 >> 2] | 0) == (i3 | 0)) HEAP32[i11 >> 2] = i1;
   i11 = i9 + 152 | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i12, i3);
   __ZdlPv(i3);
  }
 }
 if ((i13 | 0) == 14) {
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __Z6FormatPKcz(i8, gb + 910511 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 897023 | 0, 719, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 i13 = i9 + 64 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1;
 if ((HEAP16[gb + 1467076 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467076 | 0, i8);
  __Z12profiler_endP19ProfilerInformation(gb + 1467076 | 0);
  STACKTOP = i14;
  return;
 } else {
  STACKTOP = i14;
  return;
 }
}

function __ZN9ShaderLab20SerializedSubProgram13BufferBinding8TransferI14SafeBinaryReadEEvRT_(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i5 = i4 + 16 | 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 471202 | 0, i6, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i9 + 16 | 0;
   i2 = HEAP32[i9 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i8 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i8 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i4 = i4 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, gb + 899057 | 0, i6, i7, 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i9 + 16 | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = i7 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i7 >>> 0) i8 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i8 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i8 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN7dtCrowd14resetAgentPathERK13dtCrowdHandle(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i2 + 16 >> 2] | 0;
 __ZN7dtCrowd19completeOffMeshLinkEib(i2, i8, 0);
 HEAP32[i9 + (i8 * 608 | 0) + 476 >> 2] = 0;
 i7 = i9 + (i8 * 608 | 0) + 602 | 0;
 HEAP8[i7 >> 0] = HEAP8[i7 >> 0] & -5;
 i3 = i9 + (i8 * 608 | 0) | 0;
 i6 = i9 + (i8 * 608 | 0) + 32 | 0;
 i4 = HEAP32[i9 + (i8 * 608 | 0) + 28 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i1 = i9 + (i8 * 608 | 0) + 480 | 0;
  i2 = HEAP32[(HEAP32[i9 + (i8 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  i10 = 4;
 } else {
  i5 = i4;
  i1 = i9 + (i8 * 608 | 0) + 480 | 0;
  i2 = HEAP32[(HEAP32[i9 + (i8 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  if ((HEAP32[i5 >> 2] | 0) == 0 & (HEAP32[i5 + 4 >> 2] | 0) == 0) i10 = 4; else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   i3 = HEAP32[i9 + (i8 * 608 | 0) + 484 >> 2] | 0;
   HEAP32[i9 + (i8 * 608 | 0) + 4 >> 2] = i3;
   i4 = HEAP32[i9 + (i8 * 608 | 0) + 488 >> 2] | 0;
   HEAP32[i9 + (i8 * 608 | 0) + 8 >> 2] = i4;
   HEAP32[i9 + (i8 * 608 | 0) + 12 >> 2] = i1;
   HEAP32[i9 + (i8 * 608 | 0) + 16 >> 2] = i3;
   HEAP32[i9 + (i8 * 608 | 0) + 20 >> 2] = i4;
   i5 = 1;
  }
 }
 if ((i10 | 0) == 4) {
  i5 = i4;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i9 + (i8 * 608 | 0) + 484 >> 2] | 0;
  i4 = HEAP32[i9 + (i8 * 608 | 0) + 488 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 1;
 HEAP8[i9 + (i8 * 608 | 0) + 44 >> 0] = i5;
 HEAP32[i9 + (i8 * 608 | 0) + 48 >> 2] = i2;
 HEAP8[i9 + (i8 * 608 | 0) + 601 >> 0] = 0;
 HEAPF32[i9 + (i8 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
 HEAPF32[i9 + (i8 * 608 | 0) + 504 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + (i8 * 608 | 0) + 508 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + (i8 * 608 | 0) + 512 >> 2] = Math_fround(0.0);
 HEAP8[i7 >> 0] = HEAP8[i7 >> 0] & -57;
 i10 = i9 + (i8 * 608 | 0) + 592 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 + (i8 * 608 | 0) + 564 >> 2] = i1;
 HEAP32[i9 + (i8 * 608 | 0) + 568 >> 2] = i3;
 HEAP32[i9 + (i8 * 608 | 0) + 572 >> 2] = i4;
 return;
}

function __ZN7b2World4DumpEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, d15 = 0.0, d16 = 0.0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 96 | 0;
 i12 = i14 + 88 | 0;
 i11 = i14 + 80 | 0;
 i10 = i14 + 72 | 0;
 i9 = i14 + 64 | 0;
 i8 = i14 + 56 | 0;
 i7 = i14 + 48 | 0;
 i6 = i14 + 40 | 0;
 i3 = i14 + 32 | 0;
 i2 = i14 + 24 | 0;
 i1 = i14;
 if (HEAP32[i4 + 102868 >> 2] & 2 | 0) {
  STACKTOP = i14;
  return;
 }
 d16 = +Math_fround(HEAPF32[i4 + 102972 >> 2]);
 d15 = +Math_fround(HEAPF32[i4 + 102976 >> 2]);
 HEAPF64[i1 >> 3] = d16;
 HEAPF64[i1 + 8 >> 3] = d15;
 __Z5b2LogPKcz(gb + 804872 | 0, i1);
 __Z5b2LogPKcz(gb + 804901 | 0, i14 + 16 | 0);
 HEAP32[i2 >> 2] = HEAP32[i4 + 102964 >> 2];
 __Z5b2LogPKcz(gb + 804926 | 0, i2);
 HEAP32[i3 >> 2] = HEAP32[i4 + 102968 >> 2];
 __Z5b2LogPKcz(gb + 804986 | 0, i3);
 i1 = HEAP32[i4 + 102956 >> 2] | 0;
 if (i1 | 0) {
  i2 = 0;
  while (1) {
   HEAP32[i1 + 8 >> 2] = i2;
   __ZN6b2Body4DumpEv(i1);
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (!i1) break; else i2 = i2 + 1 | 0;
  }
 }
 i5 = i4 + 102960 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = (i1 | 0) == 0;
 if (!i4) {
  i2 = i1;
  i3 = 0;
  while (1) {
   HEAP32[i2 + 56 >> 2] = i3;
   i2 = HEAP32[i2 + 12 >> 2] | 0;
   if (!i2) break; else i3 = i3 + 1 | 0;
  }
  if (!i4) {
   do {
    if ((HEAP32[i1 + 4 >> 2] | 0) != 6) {
     __Z5b2LogPKcz(gb + 803386 | 0, i6);
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
     __Z5b2LogPKcz(gb + 1046929 | 0, i7);
    }
    i1 = HEAP32[i1 + 12 >> 2] | 0;
   } while ((i1 | 0) != 0);
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) do {
    if ((HEAP32[i1 + 4 >> 2] | 0) == 6) {
     __Z5b2LogPKcz(gb + 803386 | 0, i12);
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
     __Z5b2LogPKcz(gb + 1046929 | 0, i13);
    }
    i1 = HEAP32[i1 + 12 >> 2] | 0;
   } while ((i1 | 0) != 0);
  }
 }
 __Z5b2LogPKcz(gb + 805049 | 0, i8);
 __Z5b2LogPKcz(gb + 805066 | 0, i9);
 __Z5b2LogPKcz(gb + 805083 | 0, i10);
 __Z5b2LogPKcz(gb + 805099 | 0, i11);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, f17 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i10 = i16 + 20 | 0;
 i15 = HEAP32[i10 >> 2] | 0;
 f17 = Math_fround(i1 >>> 0);
 i11 = ~~Math_fround(f17 * Math_fround(HEAPF32[i16 + 28 >> 2])) >>> 0;
 i6 = i1 << 2;
 i14 = (i11 << 2) + i6 | 0;
 i14 = (0 - i14 & 12) + i14 | 0;
 i12 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
 i12 = mftCall_iiiiii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i14 + (i11 << 3) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i13 = i12 + i6 | 0;
 i14 = i12 + i14 | 0;
 _memset(i12 | 0, -1, i6 | 0) | 0;
 i6 = i16 + 40 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i1 + -1 | 0;
  i5 = HEAP32[i16 + 8 >> 2] | 0;
  i9 = 0;
  do {
   i3 = HEAP32[i5 + (i9 << 3) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i8 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i12 + ((i2 & i7) << 2) | 0;
   HEAP32[i13 + (i9 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i9;
   HEAP32[i14 + (i9 << 3) >> 2] = i8;
   HEAP32[i14 + (i9 << 3) + 4 >> 2] = HEAP32[i5 + (i9 << 3) + 4 >> 2];
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i2 = i16 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i9 = HEAP32[HEAP32[i16 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i12;
 HEAP32[i16 + 16 >> 2] = i12;
 HEAP32[i16 + 24 >> 2] = i1;
 HEAP32[i16 + 12 >> 2] = i13;
 HEAP32[i16 + 8 >> 2] = i14;
 HEAP32[i10 >> 2] = i11;
 i1 = i16 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i15;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj477ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 160; else i1 = (HEAP32[i1 >> 2] | 0) + 160 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj477ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i5 = i8 + 164 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i8 + 152 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i5 * 52 | 0) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i6, i1 + 4 | 0, gb + 1034365 | 0, 0);
  __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i6, i1 + 20 | 0, gb + 1034371 | 0, 0);
  __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i6, i1 + 36 | 0, gb + 1034379 | 0, 0);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i8 + 172 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 176 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__29to_stringEf(i8, f3) {
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, d5 = 0.0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i10 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i6 = i10 + 11 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i9 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  ___resumeException(i9 | 0);
 }
 i2 = HEAP8[i6 >> 0] | 0;
 d5 = +f3;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i10 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i4 = i2 << 24 >> 24 < 0 ? HEAP32[i10 >> 2] | 0 : i10;
  HEAPF64[i7 >> 3] = d5;
  i4 = _snprintf(i4, i1 + 1 | 0, gb + 1084516 | 0, i7) | 0;
  if ((i4 | 0) > -1) if (i4 >>> 0 > i1 >>> 0) i1 = i4; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i1 | 0, 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i6 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i10 | 0, i4 | 0, 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i10 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i9;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 ___resumeException(i1 | 0);
}

function __ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo(i4, i5, i7, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i6 = 0, i8 = 0, i10 = 0;
 i2 = HEAP32[i4 + 92 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  i2 = 4;
  i3 = HEAP32[1] | 0;
 } else {
  i6 = i2 + 12 | 0;
  i3 = i2 + 4 | 0;
  i2 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
  i10 = i3 + i2 + (i5 << 2) | 0;
  i10 = (HEAP32[i6 >> 2] | 0) + i6 + (HEAP32[i10 + (HEAP32[i10 >> 2] | 0) >> 2] << 2) | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i6 = (i6 | 0) == 0 ? 0 : i10 + i6 | 0;
 }
 i4 = (HEAP32[i4 + 100 >> 2] | 0) + 4 | 0;
 i10 = i3 + i2 + (i5 << 2) | 0;
 i10 = (HEAP32[i4 >> 2] | 0) + i4 + (HEAP32[i10 + (HEAP32[i10 >> 2] | 0) >> 2] << 2) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i4 = (i4 | 0) == 0 ? 0 : i10 + i4 | 0;
 if ((HEAP32[i6 >> 2] | 0) >>> 0 <= i7 >>> 0) {
  i10 = 0;
  return i10 | 0;
 }
 if ((HEAP32[i4 + 8 >> 2] | 0) == (i7 | 0)) i5 = 0; else i5 = (HEAP32[i4 + 12 >> 2] | 0) == (i7 | 0) ? 1 : 2;
 i3 = i6 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 + (i7 << 2) | 0;
 i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 32 >> 2];
 switch (i5 & 3) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i4 + 32 >> 2]);
   i8 = 9;
   break;
  }
 case 2:
  {
   HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
   i2 = i4 + 48 | 0;
   break;
  }
 case 1:
  {
   HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 36 >> 2];
   i2 = i4 + 44 | 0;
   break;
  }
 default:
  {
   f1 = Math_fround(0.0);
   i8 = 9;
  }
 }
 if ((i8 | 0) == 9) {
  HEAPF32[i9 + 12 >> 2] = f1;
  i2 = i4 + 40 | 0;
 }
 HEAP32[i9 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAPU8[i3 + 62 >> 0];
 HEAP32[i9 + 20 >> 2] = HEAP32[i3 + 52 >> 2];
 switch (i5 & 3) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i4 + 52 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i4 + 60 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i4 + 56 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 HEAPF32[i9 + 24 >> 2] = f1;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx16PxsBroadPhaseMBPC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerERKNS_11PxSceneDescEPNS_14PxsAABBManagerE(i12, i2, i1, i10, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i12 >> 2] = gb + 104052 + 8;
 __ZN5physx17MBPUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i12 + 4 | 0, i2, i1);
 __ZN5physx21MBPPostUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i12 + 44 | 0, i2, i1);
 i6 = i12 + 96 | 0;
 i7 = i12 + 104 | 0;
 i8 = i12 + 108 | 0;
 i9 = i12 + 116 | 0;
 i2 = i12 + 88 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i5 | 0, i1 | 0, 5264, (i4 ? gb + 717103 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 3418) | 0;
 HEAP32[i4 >> 2] = gb + 104132 + 8;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP32[i4 + 16 >> 2] = -1;
 __ZN5physx2Gu9ContainerC2Ev(i4 + 20 | 0);
 __ZN5physx2Gu9ContainerC2Ev(i4 + 36 | 0);
 i1 = i4 + 96 | 0;
 i5 = i4 + 4208 | 0;
 i2 = i4 + 52 | 0;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 do {
  __ZN5physx2Gu9ContainerC2Ev(i1);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i5 | 0));
 __ZN5physx2Gu9ContainerC2Ev(i4 + 5236 | 0);
 HEAP32[i4 + 5252 >> 2] = 0;
 HEAP32[i4 + 5256 >> 2] = 0;
 HEAP32[i4 + 5260 >> 2] = i11;
 _memset(i5 | 0, -1, 1028) | 0;
 HEAP32[i12 + 84 >> 2] = i4;
 __ZN3MBP11preallocateEjj(i4, HEAP32[i10 + 72 >> 2] | 0, (HEAP32[i10 + 60 >> 2] | 0) + (HEAP32[i10 + 56 >> 2] | 0) | 0) | 0;
 if ((HEAP32[i7 >> 2] & 2147482624) >>> 0 < 1024) __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, 1024);
 if ((HEAP32[i9 >> 2] & 2147482624) >>> 0 >= 1024) return;
 __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i8, 1024);
 return;
}

function __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i5;
 i7 = i5 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i8 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i6 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 60 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i8 = i10;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 i1 = i1 + 20 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i9 = i2 + 4 | 0;
 i8 = i2 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i11) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_(i3, i10, i7);
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i11) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i3, i7, i10);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i1) >> 2] = HEAP32[i10 >> 2];
 i1 = i7 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE3putEw(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i6 | 0, i8 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i8;
  i3 = i8;
  i7 = 12;
 } else {
  L4 : do if (HEAP8[i6 >> 0] | 0) {
   i2 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = i2;
   do if (!i2) i7 = 8; else {
    i4 = i3 + 24 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
     __THREW__ = 0;
     i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i1 | 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) break;
    } else {
     HEAP32[i4 >> 2] = i5 + 4;
     HEAP32[i5 >> 2] = i1;
    }
    if ((i1 | 0) == -1) i7 = 8; else break L4;
   } while (0);
   if ((i7 | 0) == 8) {
    i5 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 1 | 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) break;
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i6);
   i2 = i8;
   i3 = i8;
   i7 = 12;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i6);
 } while (0);
 do if ((i7 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i1 = i10 + 16 | 0;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i13 = i11 + 24 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i5 = i10 + 20 | 0;
 i8 = i10 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i9 >> 2] = i6;
 i7 = i3 + 4 | 0;
 if (i7 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i12 >> 2] = i7;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i10 + 32 | 0;
 i7 = i10 + 36 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i9 >> 2] = i4;
 i5 = HEAP32[i12 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i10 + 44 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  STACKTOP = i14;
  return;
 }
}

function __ZN5physx7NpScene12fetchResultsEbPj(i7, i4, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i7 + 3696 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i1 = i7 + 3698 | 0;
  do if (HEAP8[i1 >> 0] | 0) {
   i2 = HEAP32[i7 + 3692 >> 2] | 0;
   if (i4) {
    if (__ZN5physx6shdfnd8SyncImpl4waitEj(i2, -1) | 0) break; else i1 = 0;
    return i1 | 0;
   } else {
    if (__ZN5physx6shdfnd8SyncImpl4waitEj(i2, 0) | 0) break; else i1 = 0;
    return i1 | 0;
   }
  } while (0);
  if (!(HEAP8[i5 >> 0] | 0)) {
   if (!(HEAP8[i1 >> 0] | 0)) if (!(HEAP8[i7 + 3697 >> 0] | 0)) {
    i7 = 0;
    return i7 | 0;
   }
  } else i3 = 9;
 } else i3 = 9;
 do if ((i3 | 0) == 9) {
  i1 = HEAP32[i7 + 3688 >> 2] | 0;
  if (i4) {
   if (__ZN5physx6shdfnd8SyncImpl4waitEj(i1, -1) | 0) break; else i1 = 0;
   return i1 | 0;
  } else {
   if (__ZN5physx6shdfnd8SyncImpl4waitEj(i1, 0) | 0) break; else i1 = 0;
   return i1 | 0;
  }
 } while (0);
 i4 = i7 + 16 | 0;
 i1 = i7 + 32 | 0;
 __ZN5physx2Sc5Scene27prepareOutOfBoundsCallbacksEv(i1);
 __ZN5physx3Scb5Scene20processPendingRemoveEv(i4);
 __ZN5physx2Sc5Scene13endSimulationEv(i1);
 __ZN5physx7NpScene20fireCallBacksPreSyncEv(i7);
 __ZN5physx2Sc5Scene20postCallbacksPreSyncEv(i1);
 HEAP8[i7 + 2448 >> 0] = 0;
 HEAP8[i7 + 2449 >> 0] = 0;
 __ZN5physx3Scb5Scene15syncEntireSceneEPj(i4, i6);
 __ZN5physx2Sq17SceneQueryManager17processSimUpdatesEv(i7 + 3392 | 0);
 __ZN5physx2Sc5Scene21fireCallBacksPostSyncEv(i1);
 __ZN5physx2Sc5Scene18postReportsCleanupEv(i1);
 if (HEAP16[((HEAP32[i7 + 3388 >> 2] & 4 | 0) == 0 ? i7 + 1224 | 0 : i7 + 3364 | 0) >> 1] & 2) __ZN5physx2Sc5Scene21buildActiveTransformsEv(i1);
 __ZN5physx2Cm12RenderBuffer6appendERKNS_14PxRenderBufferE(i7 + 3476 | 0, __ZN5physx2Sc5Scene15getRenderBufferEv(i1) | 0);
 if (HEAP8[i5 >> 0] | 0) if (HEAP8[i7 + 3856 >> 0] | 0) {
  i6 = HEAP32[i7 + 3720 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0);
 }
 HEAP8[i5 >> 0] = 0;
 HEAP8[i7 + 3697 >> 0] = 0;
 HEAP8[i7 + 3698 >> 0] = 0;
 __ZN5physx6shdfnd8SyncImpl5resetEv(HEAP32[i7 + 3688 >> 2] | 0);
 __ZN5physx6shdfnd8SyncImpl5resetEv(HEAP32[i7 + 3692 >> 2] | 0);
 i7 = 1;
 return i7 | 0;
}

function __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i12, i13, i15) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i19;
 i3 = HEAP32[i12 >> 2] | 0;
 i17 = i13 + 4 | 0;
 i4 = HEAP32[i17 >> 2] | 0;
 HEAP32[i3 + (i4 * 24 | 0) + 16 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + 1;
 i14 = HEAP32[i13 >> 2] | 0;
 i5 = HEAP32[i17 >> 2] | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = i1 + (i5 * 24 | 0) | 0;
 if ((i2 + 24 | 0) >>> 0 >= (i1 + ((HEAP32[i14 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) {
  STACKTOP = i19;
  return;
 }
 if ((i14 | 0) == 0 ? 1 : (HEAPU8[i2 + 26 >> 0] | 0) != ((HEAPU8[i1 + (i5 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  STACKTOP = i19;
  return;
 }
 i11 = i3 + (i4 * 24 | 0) + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i2 = i5 + 1 | 0;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i16 + 4 >> 2] = i2;
 i7 = i16 + 4 | 0;
 i8 = i14 + 12 | 0;
 i9 = i14;
 i10 = (i14 | 0) == 0;
 i6 = 0;
 L7 : do {
  __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii(i12, i16, i15);
  i1 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 * 24 | 0) + 12 >> 2] | 0;
  i6 = i6 | (i1 | 0) == -1;
  if (!i6) HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
  i1 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP8[i1 + (i2 * 24 | 0) + 2 >> 0] | 0;
  i4 = i1 + ((HEAP32[i8 >> 2] | 0) * 24 | 0) | 0;
  i5 = i1;
  i2 = i1 + (i2 * 24 | 0) | 0;
  do {
   i1 = i2;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i18 = 11;
    break L7;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
  } while ((i1 & 255) > (i3 & 255));
  if (i1 << 24 >> 24 != i3 << 24 >> 24) {
   i18 = 11;
   break;
  }
  i2 = (i2 - i5 | 0) / 24 | 0;
  HEAP32[i16 >> 2] = i9;
  HEAP32[i7 >> 2] = i2;
 } while (!i10);
 if ((i18 | 0) == 11) {
  HEAP32[i16 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 }
 if (!(i6 | (HEAP8[(HEAP32[HEAP32[i13 >> 2] >> 2] | 0) + ((HEAP32[i17 >> 2] | 0) * 24 | 0) + 3 >> 0] | 0) != 0)) {
  STACKTOP = i19;
  return;
 }
 HEAP32[i11 >> 2] = -1;
 STACKTOP = i19;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 780 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = i9 * 24 | 0;
  i2 = i10 + 768 | 0;
  if (i1 >>> 0 < 769 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i10, i1, gb + 838004 | 0, 543) | 0;
 }
 i5 = i10 + 776 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 * 24 | 0) | 0;
 i6 = i10 + 772 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP8[i2 + 20 >> 0] = HEAP8[i3 + 20 >> 0] | 0;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 24 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i1 + (i2 * 24 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP8[i1 + (i2 * 24 | 0) + 20 >> 0] = HEAP8[i7 + 20 >> 0] | 0;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i8 >> 2] = i9;
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = i10 + 1 | 0;
  HEAP32[i5 >> 2] = i9;
  i10 = i1 + (i10 * 24 | 0) | 0;
  return i10 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i10 | 0) == (i2 | 0)) {
  HEAP8[i10 + 768 >> 0] = 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i8 >> 2] = i9;
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = i10 + 1 | 0;
  HEAP32[i5 >> 2] = i9;
  i10 = i1 + (i10 * 24 | 0) | 0;
  return i10 | 0;
 } else {
  __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i10, i2);
  HEAP32[i6 >> 2] = i1;
  HEAP32[i8 >> 2] = i9;
  i10 = HEAP32[i5 >> 2] | 0;
  i9 = i10 + 1 | 0;
  HEAP32[i5 >> 2] = i9;
  i10 = i1 + (i10 * 24 | 0) | 0;
  return i10 | 0;
 }
 return 0;
}

function __ZN11NavMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 i3 = i7 + 52 | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE8TransferI15NavMeshTileDataEEvRT_PKc17TransferMetaFlags(i8, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 32 | 0, i8);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i8, i7 + 68 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i8, i7 + 88 | 0, 0);
 i3 = i7 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 108 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __Z22GetFolderSizeRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i2 = i8;
 if (!(__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0)) {
  i6 = 0;
  i7 = 0;
  setTempRet0(i6 | 0);
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, i6, 0, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (i5) {
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i7 | 0)) {
   i2 = 0;
   i1 = 0;
  } else {
   i2 = 0;
   i5 = 0;
   do {
    i3 = i1 + 16 | 0;
    if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0) {
     i3 = __Z22GetFolderSizeRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0;
     i4 = getTempRet0() | 0;
    } else {
     i3 = __Z13GetFileLengthRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0;
     i4 = getTempRet0() | 0;
    }
    i2 = _i64Add(i3 | 0, i4 | 0, i2 | 0, i5 | 0) | 0;
    i5 = getTempRet0() | 0;
    i3 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i3) while (1) {
     i3 = HEAP32[i1 + 8 >> 2] | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
      i1 = i3;
      break;
     } else i1 = i3;
    } else {
     i1 = i3;
     while (1) {
      i3 = HEAP32[i1 >> 2] | 0;
      if (!i3) break; else i1 = i3;
     }
    }
   } while ((i1 | 0) != (i7 | 0));
   i1 = i5;
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, HEAP32[i7 >> 2] | 0);
 i6 = i1;
 i7 = i2;
 setTempRet0(i6 | 0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN4Halo23VirtualRedirectTransferER14SafeBinaryRead(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 67408 >> 2] | 0, gb + 374123 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i7);
   i2 = i3 + 36 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i5, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i7);
   }
   i4 = i3 + 40 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 842535 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) {
     i1 = i7 + 16 | 0;
     i5 = HEAP32[i7 + 20 >> 2] | 0;
     i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
     HEAP32[i1 >> 2] = i2;
     if (i2 >>> 0 < i5 >>> 0) i6 = 14; else {
      i3 = i2 + 4 | 0;
      if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 14; else {
       HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
       HEAP32[i1 >> 2] = i3;
      }
     }
     if ((i6 | 0) == 14) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
     if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
    } else {
     i1 = HEAP32[i5 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i7);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN10AudioMixer24SetOutputAudioMixerGroupERK4PPtrI15AudioMixerGroupE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i10 + 8 | 0;
 i2 = i10 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i10;
  return;
 }
 i8 = i5 + 92 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 if (!i1) i1 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i2);
    i2 = HEAP32[i7 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i4 = 11;
   }
  }
  if ((i4 | 0) == 9) i4 = 11;
  if ((i4 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 if (__ZN10AudioMixer24CheckForCyclicReferencesEPS_P15AudioMixerGroup(i5, i1) | 0) {
  HEAP32[i9 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
  __Z6FormatPKcz(i7, gb + 873707 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 861578 | 0, 524, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  __ZN10AudioMixer11SetupGroupsEv(i5);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 40 | 0) + 1 | 0;
 if (i4 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 40 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 53687091 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 107374182;
 i5 = (i1 - i2 | 0) / 40 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 40 | 0) | 0;
 i7 = i6 + (i5 * 40 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 40 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 40 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i4 = i6 + (i5 * 40 | 0) + 12 | 0;
 i8 = i8 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 i4 = i7 + 40 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i7 = i3;
   i3 = i3 + -40 | 0;
   HEAP32[i1 + -40 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i7 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i7 + -32 >> 2];
   i8 = i1 + -28 | 0;
   i7 = i7 + -28 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
   HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
   i1 = i2 + -40 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK15CollisionEvents10SendEventsERN5Unity9ComponentE(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 4 | 0;
 i14 = i15;
 i9 = HEAP32[i1 + 28 >> 2] | 0;
 i10 = i12 + 12 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = i13 + 8 | 0;
 i6 = i13 + 4 | 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 4 | 0;
 i1 = 0;
 i5 = 0;
 do {
  i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i5 * 44 | 0) + 40 >> 2] | 0;
  do if ((i1 | 0) != (i2 | 0)) {
   HEAP32[i14 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (i2 | 0) {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i13, i2, i14);
     i3 = HEAP32[i13 >> 2] | 0;
     i16 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i16 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i16 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) != (i3 + (i4 << 3) | 0)) {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) break;
     i2 = HEAP32[i2 + 28 >> 2] | 0;
     if (!i2) break;
     i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i5 * 44 | 0) + 40 >> 2] | 0;
     HEAP32[i13 >> 2] = gb + 28900;
     HEAP32[i11 >> 2] = 0;
     HEAP32[i6 >> 2] = i2;
     __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i9, gb + 1105096 | 0, i13);
     HEAP32[i13 >> 2] = gb + 28900;
     HEAP32[i7 >> 2] = 0;
     HEAP32[i8 >> 2] = i9;
     __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1105096 | 0, i13);
     break;
    }
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sc8ClothSim19removeCollisionMeshEPKNS0_8ShapeSimE(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i1 = (HEAP32[i10 + 88 >> 2] | 0) + (HEAP32[i10 + 84 >> 2] | 0) + (HEAP32[i10 + 92 >> 2] | 0) + (HEAP32[i10 + 96 >> 2] | 0) + (HEAP32[i10 + 100 >> 2] | 0) | 0;
 i8 = i10 + 116 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i11 = i10 + 104 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 if (!i12) return; else i5 = 0;
 while (1) {
  i4 = i1 + i5 | 0;
  i2 = i7 + (i4 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i9 = i5;
   break;
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i12 >>> 0) {
   i6 = 11;
   break;
  }
 }
 if ((i6 | 0) == 11) return;
 i1 = i4 + 1 | 0;
 i3 = i10 + 120 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 < i5 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
  i1 = i4 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i3 >> 2] = i5 + -1;
 i1 = i9 + 1 | 0;
 i4 = i10 + 132 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i5 >>> 0) {
  i3 = HEAP32[i10 + 128 >> 2] | 0;
  i2 = i1;
  i1 = i3 + (i9 * 48 | 0) | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i3 + (i2 * 48 | 0) >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i3 + (i2 * 48 | 0) + 44 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 48 | 0;
  }
 }
 HEAP32[i4 >> 2] = i5 + -1;
 HEAP32[i11 >> 2] = i12 + -1;
 return;
}

function __ZN2UI13CanvasManager14RenderOverlaysEi(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i2 = i7 + 16 | 0;
 i3 = i7;
 i5 = __Z12GetGfxDevicev() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i12 = __Z16GetScreenManagerv() | 0;
 f10 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 80 >> 2] | 0, i12 | 0) | 0);
 f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i12 | 0) | 0);
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = f11;
 __Z14RectfToRectIntRK5RectTIfE(i2, i3);
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i4 | 0);
 f11 = Math_fround(HEAP32[i4 + 8 >> 2] | 0);
 f10 = Math_fround(HEAP32[i4 + 12 >> 2] | 0);
 f9 = Math_fround(Math_fround(Math_fround(1.0) / f11) + Math_fround(1.0));
 f8 = Math_fround(Math_fround(Math_fround(1.0) / f10) + Math_fround(1.0));
 HEAPF32[i5 + 628 >> 2] = f11;
 HEAPF32[i5 + 632 >> 2] = f10;
 HEAPF32[i5 + 636 >> 2] = f9;
 HEAPF32[i5 + 640 >> 2] = f8;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i2 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i2, gb + 1012537 | 0);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i5, i2, Math_fround(8.0), 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = i3;
  while (1) {
   i4 = HEAP32[i1 + 344 >> 2] | 0;
   if (!i4) break; else i1 = i4;
  }
  if ((HEAP8[i1 + 374 >> 0] | 0) == (i6 | 0)) if (!(__ZNK2UI6Canvas13GetRenderModeEv(i3) | 0)) __ZN2UI6Canvas14RenderOverlaysEv(i3);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 STACKTOP = i7;
 return;
}

function __ZN16DeveloperConsoleC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i2 = i7 + 16 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7;
 HEAP8[i1 >> 0] = 0;
 i9 = i1 + 4 | 0;
 HEAP32[i9 >> 2] = i9;
 HEAP32[i1 + 8 >> 2] = i9;
 HEAP32[i1 + 12 >> 2] = 0;
 i9 = i1 + 16 | 0;
 HEAP32[i9 >> 2] = i9;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i1 + 56 | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 i6 = i1 + 72 | 0;
 i8 = i6 + 44 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 i8 = gb + 63672 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP8[i1 + 84 >> 0] = 0;
 i9 = i1 + 88 | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP8[i1 + 104 >> 0] = 0;
 i9 = i1 + 108 | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i1 + 116 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i9 = i2;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i1 + 132 | 0, gb + 1017159 | 0, i5);
 i9 = gb + 63672 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i1 + 152 | 0, gb + 1017179 | 0, i5);
 i6 = gb + 63672 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i1 + 172 | 0, gb + 1017185 | 0, i5);
 STACKTOP = i7;
 return;
}

function __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 24 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 24 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 24 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 79;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (((i1 - i4 | 0) / 24 | 0) * 24 | 0) | 0;
 i5 = i5 + (i3 * 24 | 0) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i1 = i4 + 24 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 79;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn13XmlNodeWriter15writeContentTagEPKcS3_(i9, i4, i6) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i5 = (HEAP32[i9 + 4 >> 2] | 0) + 8 | 0;
 i8 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, 24) | 0;
 HEAP32[i8 >> 2] = gb + 1576256;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = gb + 1576256;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i4) i1 = gb + 1576256 | 0; else if (!(HEAP8[i4 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i4;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i8 >> 2] = i1;
 if (!i6) i1 = gb + 1576256 | 0; else if (!(HEAP8[i6 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i6;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i5, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i6 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i7 >> 2] = i1;
 i4 = i9 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i8 + 20 >> 2] = i1;
  i1 = i1 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = i8;
   break;
  }
  while (1) {
   i1 = i2 + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  HEAP32[i1 >> 2] = i8;
  HEAP32[i8 + 12 >> 2] = i2;
 } while (0);
 i1 = i9 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  HEAP32[i4 >> 2] = i8;
  i8 = i9 + 16 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  i8 = HEAP32[i9 >> 2] | 0;
  i8 = i8 + 12 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vi(i8 | 0, i9 | 0);
  return;
 }
 HEAP32[i1 >> 2] = i8;
 HEAP32[i4 >> 2] = i8;
 i8 = i9 + 16 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + 1 | 0;
 HEAP32[i8 >> 2] = i7;
 i8 = HEAP32[i9 >> 2] | 0;
 i8 = i8 + 12 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vi(i8 | 0, i9 | 0);
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL10initializeEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 4 | 0;
 i6 = i12;
 i8 = i10 + 32 | 0;
 i9 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i8 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0;
 i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i8 >> 2] | 0) | 0;
 i7 = i10 + 36 | 0;
 i3 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i7 >> 2] | 0) | 0;
 if (!i2) i1 = 0; else i1 = HEAPU8[i2 + 50 >> 0] | 0;
 if (!i3) i4 = 0; else i4 = HEAPU8[i3 + 50 >> 0] | 0;
 switch (i1 | 0) {
 case 1:
 case 4:
  {
   i2 = HEAP32[i2 + 188 >> 2] | 0;
   break;
  }
 default:
  i2 = -1;
 }
 switch (i4 | 0) {
 case 1:
 case 4:
  {
   i1 = HEAP32[i3 + 188 >> 2] | 0;
   break;
  }
 default:
  i1 = -1;
 }
 HEAP32[i5 >> 2] = i2;
 HEAP32[i6 >> 2] = i1;
 i1 = i10 + 60 | 0;
 __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_(i9, 0, i5, i6, i1);
 if (!(HEAP8[(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) if (!(HEAP8[(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) {
  i8 = i10 + 44 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 134217728;
  __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i9, i1);
 } else i11 = 11; else i11 = 11;
 if ((i11 | 0) == 11) {
  i11 = i10 + 44 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -134217729;
 }
 i11 = i10 + 8 | 0;
 i8 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, 0) | 0;
 i9 = i10 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i11, i8);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i9 >> 2] | 0, i11);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i10 + 16 >> 2] | 0, i11);
 i11 = (HEAP32[i10 + 48 >> 2] | 0) + 16 | 0;
 HEAP16[i11 >> 1] = (HEAP16[i11 >> 1] | 0) + 1 << 16 >> 16;
 STACKTOP = i12;
 return;
}

function __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i10 = HEAP16[i12 + 4 >> 1] | 0;
 i2 = i10 << 16 >> 16 == 1;
 if (i2) i11 = i12; else i11 = HEAP32[i12 >> 2] | 0;
 if (!i1) i3 = 19; else {
  i9 = i1 + 3392 | 0;
  if (i2) i7 = i12; else i7 = HEAP32[i12 >> 2] | 0;
  i8 = i10 & 65535;
  i1 = i12 + 8 | 0;
  if ((HEAP16[i12 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
  if (i10 << 16 >> 16) {
   i5 = i8 + -1 | 0;
   i6 = 0;
   do {
    if (i6 >>> 0 < i5 >>> 0) {
     i4 = HEAP32[i7 + (i6 + 1 << 2) >> 2] | 0;
     i3 = i4;
     i14 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
     i13 = getTempRet0() | 0;
     i3 = _i64Add(i3 | 0, 0, 207, 0) | 0;
     i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
     i2 = getTempRet0() | 0;
     i13 = _i64Subtract(1, 0, i14 | 0, i13 | 0) | 0;
     i2 = _i64Add(i13 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
     i3 = getTempRet0() | 0;
     while (1) {
      i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
      i3 = getTempRet0() | 0;
      if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
     }
    }
    i2 = i1 + (i6 << 2) | 0;
    if ((__ZNK5physx7NpShape8getFlagsEv(HEAP32[i7 + (i6 << 2) >> 2] | 0) | 0) & 2) __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i9, HEAP32[i2 >> 2] | 0);
    HEAP32[i2 >> 2] = 0;
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i8 | 0));
   i3 = 19;
  }
 }
 if ((i3 | 0) == 19) if (i10 << 16 >> 16) {
  i1 = i10 & 65535;
  i4 = 0;
  do {
   i2 = HEAP32[i11 + (i4 << 2) >> 2] | 0;
   if (__ZNK5physx7NpShape11isExclusiveEv(i2) | 0) __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE(i2, 0);
   i3 = i2 + 12 | 0;
   if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i14 = HEAP32[(HEAP32[gb + 1457204 >> 2] | 0) + 440 >> 2] | 0;
 __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE(i12, i14);
 __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE(i12 + 8 | 0, i14);
 return;
}

function __ZN2UI15DoSyncWorldRectERNS_13UIInstructionE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f9 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f12 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f13 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 i14 = i6 + 12 | 0;
 HEAPF32[i14 >> 2] = f9;
 i7 = i6 + 16 | 0;
 HEAPF32[i7 >> 2] = f12;
 i1 = i6 + 20 | 0;
 HEAPF32[i1 >> 2] = f13;
 __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_(i2 + 548 | 0, i2 + 484 | 0, i6);
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f11 = Math_fround(-f9);
 f10 = Math_fround(-f8);
 f5 = Math_fround(-f13);
 f4 = Math_fround(-f12);
 HEAPF32[i2 + 596 >> 2] = f13;
 HEAPF32[i2 + 600 >> 2] = f12;
 HEAPF32[i2 + 604 >> 2] = f11;
 HEAPF32[i2 + 608 >> 2] = f10;
 HEAPF32[i2 + 612 >> 2] = f9;
 HEAPF32[i2 + 616 >> 2] = f8;
 HEAPF32[i2 + 620 >> 2] = f5;
 HEAPF32[i2 + 624 >> 2] = f4;
 i7 = i2 + 572 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i6 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 if (!((i6 ? f5 : f4) <= Math_fround(.00100000005))) {
  i7 = 0;
  i14 = i2 + 669 | 0;
  HEAP8[i14 >> 0] = i7;
  i14 = i2 + 664 | 0;
  HEAP16[i14 >> 1] = 2;
  STACKTOP = i3;
  return;
 }
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 i7 = f13 < Math_fround(0.0);
 f12 = Math_fround(-f13);
 i7 = (i7 ? f12 : f13) <= Math_fround(.00100000005) & 1;
 i14 = i2 + 669 | 0;
 HEAP8[i14 >> 0] = i7;
 i14 = i2 + 664 | 0;
 HEAP16[i14 >> 1] = 2;
 STACKTOP = i3;
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE11PostRequestEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 4 | 0;
 i2 = HEAP32[i5 + 60 >> 2] | 0;
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 if (!i1) i3 = -1; else i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i2 + -32 | 0;
 __ZN12StatusHelper13SetStatusCodeEl(i4, i3) | 0;
 if (!(__ZNK12StatusHelper10IsRedirectEv(i4) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = i5 + 36 | 0;
 i1 = __ZN14RedirectHelper10OnRedirectEl(i4, i3) | 0;
 if ((i1 | 1 | 0) != 1) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1030909 | 0, 8);
 i2 = __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2 + -24 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i2) {
  i7 = 30;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i5 + 76 | 0;
 __ZN14RedirectHelper10RedirectToERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i6, i1, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!(__ZNK14RedirectHelper11RevertToGetEl(i4, i3) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 + 88 >> 2] = 0;
 if (HEAP32[i5 + 68 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 __Z6FormatPKcz(i6, gb + 1030918 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 1030979 | 0, 330, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZL19DrawSimpleWatermark13WatermarkEnumff(i2, f4) {
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i3 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 220 | 0;
 i8 = i12 + 24 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i3 = gb + 42988 + (i2 << 3) + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[gb + 42988 + (i2 << 3) >> 2] | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i1, _strlen(i1) | 0);
  HEAP32[i3 >> 2] = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 32032 | 0, i11) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i2 = __Z16GetScreenManagerv() | 0;
 f7 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i8, __Z12GetGfxDevicev() | 0);
 __Z28SetupPixelCorrectCoordinatesv();
 f5 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
 f6 = Math_fround(0 - (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) | 0);
 f7 = Math_fround(Math_fround(f7 - f5) + Math_fround(-1.0));
 if (f4 < Math_fround(0.0)) f4 = Math_fround(Math_fround(f4 + Math_fround(1.0)) + Math_fround(Math_fround(i2 | 0) + f6));
 f4 = Math_fround(f4 - f6);
 HEAPF32[i9 >> 2] = f7;
 HEAPF32[i9 + 8 >> 2] = f5;
 HEAPF32[i9 + 4 >> 2] = f4;
 HEAPF32[i9 + 12 >> 2] = f6;
 HEAP32[i10 >> 2] = -2139062144;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i9, i1, i11, 0, -1);
 i11 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 __ZN22DeviceMVPMatricesStateD2Ev(i8);
 STACKTOP = i12;
 return i11 | 0;
}

function __Z13PxcPoolMallocj(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = HEAP32[gb + 1457392 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 if (i2 >>> 0 < 9) {
  i2 = HEAP32[gb + 1457392 >> 2] | 0;
  i3 = i2 + 296 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i2 + 4 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i2 + 284 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i2 + 288 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 if (i2 >>> 0 < 17) {
  i2 = HEAP32[gb + 1457392 >> 2] | 0;
  i3 = i2 + 592 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i2 + 300 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i2 + 580 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i2 + 584 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 if (i2 >>> 0 >= 33) {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i2, gb + 768423 | 0, 105) | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 i2 = HEAP32[gb + 1457392 >> 2] | 0;
 i3 = i2 + 888 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i2 + 596 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i2 + 876 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i2 + 880 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = i1;
 i4 = HEAP32[i4 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 STACKTOP = i5;
 return i3 | 0;
}

function __ZNSt3__218__insertion_sort_3IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i8 = i9 + 16 | 0;
 i4 = i9 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = (i6 | 0) < (i2 | 0);
 do if ((i2 | 0) < (i5 | 0)) {
  if (i1) {
   HEAP32[i9 >> 2] = i6;
   HEAP32[i8 >> 2] = i5;
   i6 = i9 + 4 | 0;
   i2 = i9 + 20 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i7;
   i2 = i5;
   break;
  }
  HEAP32[i9 >> 2] = i2;
  HEAP32[i4 >> 2] = i5;
  i7 = i9 + 4 | 0;
  i1 = i9 + 12 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  if ((i6 | 0) < (i5 | 0)) {
   HEAP32[i4 >> 2] = i6;
   HEAP32[i8 >> 2] = i5;
   i7 = i9 + 20 | 0;
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i7 >> 2] = i2;
   i2 = i5;
  } else i2 = i6;
 } else if (i1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i1 = i9 + 12 | 0;
  i7 = i9 + 20 | 0;
  i11 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i7 >> 2] = i11;
  if ((i6 | 0) < (i5 | 0)) {
   HEAP32[i9 >> 2] = i6;
   HEAP32[i4 >> 2] = i5;
   i7 = i9 + 4 | 0;
   i11 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i1 >> 2] = i11;
  }
 } else i2 = i6; while (0);
 i1 = i9 + 24 | 0;
 if ((i1 | 0) == (i10 | 0)) return; else {
  i7 = i1;
  i1 = i8;
 }
 while (1) {
  if ((HEAP32[i7 >> 2] | 0) < (i2 | 0)) {
   i6 = i7;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = i7;
   while (1) {
    HEAP32[i3 >> 2] = i2;
    i4 = i1 + 4 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
    if ((i1 | 0) == (i9 | 0)) break;
    i3 = i1 + -8 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i5 | 0) >= (i2 | 0)) break; else {
     i11 = i1;
     i1 = i3;
     i3 = i11;
    }
   }
   HEAP32[i1 >> 2] = i5;
   HEAP32[i4 >> 2] = i6;
  }
  i1 = i7 + 8 | 0;
  if ((i1 | 0) == (i10 | 0)) break;
  i2 = HEAP32[i7 >> 2] | 0;
  i11 = i7;
  i7 = i1;
  i1 = i11;
 }
 return;
}

function __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i5 + 24 >> 2] & 2147483647;
 do if (i2 | 0) {
  i3 = i5 + 20 | 0;
  if ((HEAP32[i3 >> 2] | 0) >>> 0 > i2 >>> 1 >>> 0) {
   HEAP32[i3 >> 2] = 0;
   break;
  } else {
   HEAP32[i6 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, 0, i6);
   __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, HEAP32[i3 >> 2] | 0);
   break;
  }
 } while (0);
 i1 = i5 + 28 | 0;
 i2 = HEAP32[i5 + 36 >> 2] & 2147483647;
 do if (i2 | 0) {
  i3 = i5 + 32 | 0;
  if ((HEAP32[i3 >> 2] | 0) >>> 0 > i2 >>> 1 >>> 0) {
   HEAP32[i3 >> 2] = 0;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, 0, i6);
   __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, HEAP32[i3 >> 2] | 0);
   break;
  }
 } while (0);
 i1 = i5 + 40 | 0;
 i2 = HEAP32[i5 + 48 >> 2] & 2147483647;
 do if (i2 | 0) {
  i3 = i5 + 44 | 0;
  if ((HEAP32[i3 >> 2] | 0) >>> 0 > i2 >>> 1 >>> 0) {
   HEAP32[i3 >> 2] = 0;
   break;
  } else {
   HEAP32[i6 >> 2] = 0;
   __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, 0, i6);
   __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, HEAP32[i3 >> 2] | 0);
   break;
  }
 } while (0);
 i4 = i5 + 52 | 0;
 i1 = HEAP32[i5 + 60 >> 2] & 2147483647;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i3 = i5 + 56 | 0;
 if ((HEAP32[i3 >> 2] | 0) >>> 0 > i1 >>> 1 >>> 0) {
  HEAP32[i3 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  i1 = i6;
  i2 = i1 + 56 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i4, 0, i6);
  __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i4, HEAP32[i3 >> 2] | 0);
  STACKTOP = i7;
  return;
 }
}

function __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 52 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = i8 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = i4 + 76 | 0;
    i2 = i4 + 84 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i9 = i4 + 80 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 64 | 0;
    i2 = i4 + 72 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 68 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     HEAP32[i9 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 56 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     HEAP32[i9 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i10 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i10;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i8 + 28 | 0;
 i2 = i8 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i10 = i8 + 32 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i8 + 16 | 0;
 i2 = i8 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i10 = i8 + 20 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z25UpdateLODGroupBoundingBoxR8LODGroup(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i6 = i9;
 __Z36CalculateLODGroupBoundsCenterAndSizeR8Vector3fRfRK8LODGroup(i1, i6, i7);
 i8 = i7 + 32 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i8 = i7 + 68 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i7 + 44 >> 2] = HEAP32[i6 >> 2];
  STACKTOP = i9;
  return;
 }
 i5 = i7 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2) {
  i4 = i7 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i8 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i7);
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 + 44 >> 2] = HEAP32[i6 >> 2];
 if ((i1 | 0) == -1) {
  STACKTOP = i9;
  return;
 }
 i5 = i7 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2) {
  i4 = i7 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i8 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i7);
 STACKTOP = i9;
 return;
}

function __Z13raycast_planeRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i3, i10, i16, i15, f18, i4, i6, i17, i2, i5, i7) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i15 = i15 | 0;
 f18 = Math_fround(f18);
 i4 = i4 | 0;
 i6 = i6 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var f1 = f0, f8 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, d19 = 0.0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i2, i10);
 f11 = Math_fround(HEAPF32[i15 >> 2]);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(f11 * f12);
 f13 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f13 * f14));
 f8 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f8 * f9));
 if (f1 >= Math_fround(0.0)) {
  i17 = 0;
  STACKTOP = i3;
  return i17 | 0;
 }
 d19 = +f1;
 if (d19 > -1.0e-07 & d19 < 1.0e-07) {
  i17 = 0;
  STACKTOP = i3;
  return i17 | 0;
 }
 f21 = Math_fround(HEAPF32[i16 >> 2]);
 f23 = Math_fround(f12 * f21);
 f20 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f14 * f20));
 f22 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f23 = Math_fround(f23 + Math_fround(f9 * f22));
 f1 = Math_fround(Math_fround(-Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f23)) / f1);
 f20 = Math_fround(f20 + Math_fround(f13 * f1));
 f13 = Math_fround(f22 + Math_fround(f8 * f1));
 HEAPF32[i17 + 16 >> 2] = Math_fround(f21 + Math_fround(f11 * f1));
 HEAPF32[i17 + 20 >> 2] = f20;
 HEAPF32[i17 + 24 >> 2] = f13;
 if (f1 < Math_fround(0.0) | f1 > f18) {
  i17 = 0;
  STACKTOP = i3;
  return i17 | 0;
 }
 HEAPF32[i17 + 40 >> 2] = f1;
 HEAP32[i17 + 8 >> 2] = -1;
 HEAPF32[i17 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i17 + 48 >> 2] = Math_fround(0.0);
 HEAP16[i17 + 12 >> 1] = 7;
 HEAPF32[i17 + 28 >> 2] = f12;
 HEAPF32[i17 + 32 >> 2] = f14;
 HEAPF32[i17 + 36 >> 2] = f9;
 i17 = 1;
 STACKTOP = i3;
 return i17 | 0;
}

function __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, i12, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i2;
 i3 = i12;
 i6 = i9 - i3 | 0;
 i10 = i6 >> 3;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i11 = i4;
 if (i10 >>> 0 > i1 - i4 >> 3 >>> 0) {
  i3 = i4;
  if (i4) {
   i1 = i5 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i11 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i4 | 0) >>> 3) << 3);
   __ZdlPv(i3);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
  }
  if (i10 >>> 0 > 536870911) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } else i2 = 0;
  i11 = i1 - i2 | 0;
  i1 = i11 >> 2;
  i1 = i11 >> 3 >>> 0 < 268435455 ? (i1 >>> 0 < i10 >>> 0 ? i10 : i1) : 536870911;
  if (i1 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i2 = __Znwj(i1 << 3) | 0;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 << 3);
  if ((i6 | 0) <= 0) return;
  _memcpy(i2 | 0, i12 | 0, i6 | 0) | 0;
  HEAP32[i3 >> 2] = i2 + (i10 << 3);
  return;
 }
 i8 = i5 + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i5 = i7 - i4 >> 3;
 i6 = i10 >>> 0 > i5 >>> 0;
 i5 = i6 ? i12 + (i5 << 3) | 0 : i2;
 i4 = i7;
 if ((i5 | 0) == (i12 | 0)) i1 = i11; else {
  i3 = i5 + -8 - i3 | 0;
  i1 = i12;
  i2 = i11;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 8 | 0;
  }
  i1 = i11 + ((i3 >>> 3) + 1 << 3) | 0;
 }
 if (i6) {
  i1 = i9 - i5 | 0;
  if ((i1 | 0) <= 0) return;
  _memcpy(i7 | 0, i5 | 0, i1 | 0) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 3 << 3);
  return;
 } else {
  if ((i4 | 0) == (i1 | 0)) return;
  HEAP32[i8 >> 2] = i4 + (~((i4 + -8 - i1 | 0) >>> 3) << 3);
  return;
 }
}

function __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, i12, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i2;
 i3 = i12;
 i6 = i9 - i3 | 0;
 i10 = i6 >> 3;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i11 = i4;
 if (i10 >>> 0 > i1 - i4 >> 3 >>> 0) {
  i3 = i4;
  if (i4) {
   i1 = i5 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i11 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i4 | 0) >>> 3) << 3);
   __ZdlPv(i3);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
  }
  if (i10 >>> 0 > 536870911) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } else i2 = 0;
  i11 = i1 - i2 | 0;
  i1 = i11 >> 2;
  i1 = i11 >> 3 >>> 0 < 268435455 ? (i1 >>> 0 < i10 >>> 0 ? i10 : i1) : 536870911;
  if (i1 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i2 = __Znwj(i1 << 3) | 0;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i7 >> 2] = i2 + (i1 << 3);
  if ((i6 | 0) <= 0) return;
  _memcpy(i2 | 0, i12 | 0, i6 | 0) | 0;
  HEAP32[i3 >> 2] = i2 + (i10 << 3);
  return;
 }
 i8 = i5 + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i5 = i7 - i4 >> 3;
 i6 = i10 >>> 0 > i5 >>> 0;
 i5 = i6 ? i12 + (i5 << 3) | 0 : i2;
 i4 = i7;
 if ((i5 | 0) == (i12 | 0)) i1 = i11; else {
  i3 = i5 + -8 - i3 | 0;
  i1 = i12;
  i2 = i11;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 8 | 0;
  }
  i1 = i11 + ((i3 >>> 3) + 1 << 3) | 0;
 }
 if (i6) {
  i1 = i9 - i5 | 0;
  if ((i1 | 0) <= 0) return;
  _memcpy(i7 | 0, i5 | 0, i1 | 0) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i1 >> 3 << 3);
  return;
 } else {
  if ((i4 | 0) == (i1 | 0)) return;
  HEAP32[i8 >> 2] = i4 + (~((i4 + -8 - i1 | 0) >>> 3) << 3);
  return;
 }
}

function __ZN8Material21CopySettingsFromOtherERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = i8 + 100 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i2 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i2 = 3;
 if ((i2 | 0) == 3) __ZN8Material15BuildPropertiesEv(i8);
 i5 = i8 + 80 | 0;
 i1 = i9 + 80 | 0;
 do if ((i8 | 0) != (i9 | 0)) {
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i9 + 84 >> 2] | 0 : i7 & 255;
  i3 = i5 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i8 + 88 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i8 + 84 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i8 + 84 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i8 + 36 >> 2] = HEAP32[i9 + 36 >> 2];
 HEAP32[i8 + 96 >> 2] = HEAP32[i9 + 96 >> 2];
 i2 = HEAP32[i9 + 100 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i10 = i1 + 124 | 0;
 i9 = i2 + 124 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 HEAP8[i1 + 172 >> 0] = HEAP8[i2 + 172 >> 0] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i1 + 176 | 0, HEAP32[i2 + 176 >> 2] | 0, HEAP32[i2 + 180 >> 2] | 0);
 return;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i6, i7);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i6 + 40 | 0, i7);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i6 + 80 | 0, i7);
 i5 = i6 + 120 | 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 4 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 132 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + 136 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 137 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN5physx22PxVehicleWheelsDynData4copyERKS0_jj(i2, i1, i3, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i3 >>> 2;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i5 >>> 2;
 i6 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 3;
 i3 = i5 & 3;
 HEAP32[i6 + (i8 * 224 | 0) + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + (i4 << 2) >> 2];
 HEAP32[i6 + (i8 * 224 | 0) + 16 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 16 + (i4 << 2) >> 2];
 HEAP32[i6 + (i8 * 224 | 0) + 48 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 48 + (i4 << 2) >> 2];
 HEAP32[i6 + (i8 * 224 | 0) + 64 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 64 + (i4 << 2) >> 2];
 HEAP32[i6 + (i8 * 224 | 0) + 32 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 32 + (i4 << 2) >> 2];
 i1 = i7 + (i9 * 224 | 0) + 96 | 0;
 i2 = i6 + (i8 * 224 | 0) + 96 | 0;
 if (!(HEAP32[i7 + (i9 * 224 | 0) + 212 >> 2] | 0)) {
  HEAP32[i2 + (i3 << 4) >> 2] = HEAP32[i1 + (i4 << 4) >> 2];
  HEAP32[i2 + (i3 << 4) + 4 >> 2] = HEAP32[i1 + (i4 << 4) + 4 >> 2];
  HEAP32[i2 + (i3 << 4) + 8 >> 2] = HEAP32[i1 + (i4 << 4) + 8 >> 2];
  HEAP32[i2 + (i3 << 4) + 12 >> 2] = HEAP32[i1 + (i4 << 4) + 12 >> 2];
  HEAP32[i6 + (i8 * 224 | 0) + 160 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 160 + (i4 << 2) >> 2];
  HEAP16[i6 + (i8 * 224 | 0) + 192 + (i3 << 1) >> 1] = HEAP16[i7 + (i9 * 224 | 0) + 192 + (i4 << 1) >> 1] | 0;
  HEAP32[i6 + (i8 * 224 | 0) + 176 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 176 + (i4 << 2) >> 2];
  return;
 } else {
  HEAP32[i2 + (i3 * 12 | 0) >> 2] = HEAP32[i1 + (i4 * 12 | 0) >> 2];
  HEAP32[i2 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2];
  HEAP32[i2 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i4 * 12 | 0) + 8 >> 2];
  i5 = i6 + (i8 * 224 | 0) + 144 | 0;
  i2 = i7 + (i9 * 224 | 0) + 144 | 0;
  HEAP32[i5 + (i3 * 12 | 0) >> 2] = HEAP32[i2 + (i4 * 12 | 0) >> 2];
  HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2];
  HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2];
  HEAP32[i6 + (i8 * 224 | 0) + 192 + (i3 << 2) >> 2] = HEAP32[i7 + (i9 * 224 | 0) + 192 + (i4 << 2) >> 2];
  return;
 }
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairIttEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, HEAP32[gb + 37008 >> 2] | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 2 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 2);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, HEAP32[gb + 37224 >> 2] | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 16 | 0;
 i8 = i15;
 i9 = i2 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i6 >> 2] = Math_fround(.0500000007);
 i10 = i6 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(.100000001);
 i11 = i6 + 8 | 0;
 HEAPF32[i11 >> 2] = Math_fround(.150000006);
 i12 = i6 + 12 | 0;
 HEAPF32[i12 >> 2] = Math_fround(.200000003);
 i13 = i8 + 4 | 0;
 i14 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = 0;
 f5 = Math_fround(0.0);
 f7 = Math_fround(0.0);
 do {
  __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E(i8, i3, i6);
  f18 = Math_fround(HEAPF32[i8 >> 2]);
  f19 = Math_fround(HEAPF32[i13 >> 2]);
  f22 = Math_fround(_fminf(f18, f19));
  f20 = Math_fround(HEAPF32[i14 >> 2]);
  f21 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(_fminf(f5, Math_fround(_fminf(f22, Math_fround(_fminf(f20, f21))))));
  f19 = Math_fround(_fmaxf(f18, f19));
  HEAPF32[i9 >> 2] = Math_fround(_fmaxf(f7, Math_fround(_fmaxf(f19, Math_fround(_fmaxf(f20, f21))))));
  i16 = i2;
  i17 = HEAP32[i16 >> 2] | 0;
  i16 = HEAP32[i16 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = i17;
  HEAP32[i9 >> 2] = i16;
  f21 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(.200000003));
  f20 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(.200000003));
  f19 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + Math_fround(.200000003));
  f18 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + Math_fround(.200000003));
  HEAPF32[i6 >> 2] = f21;
  HEAPF32[i10 >> 2] = f20;
  HEAPF32[i11 >> 2] = f19;
  HEAPF32[i12 >> 2] = f18;
  i1 = i1 + 4 | 0;
  f5 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f7 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i1 | 0) < 20);
 STACKTOP = i15;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIifEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN11NavMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 i3 = i7 + 52 | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i8, i1, 0);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 32 | 0, i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i8, i7 + 68 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i8, i7 + 88 | 0, 0);
 i3 = i7 + 104 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i7 + 108 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i8);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __Z24InitializeEngineGraphicsb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (HEAP8[gb + 1548965 >> 0] | 0) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i2 >> 2] = gb + 584171;
 _printf_console(gb + 584140 | 0, i2);
 if (!(__Z19InitializeGfxDevicej(0) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __Z15CreateJobSystemv();
 __ZN18BackgroundJobQueue10InitializeEv(__Z21GetBackgroundJobQueuev() | 0) | 0;
 __ZN9ShaderLab13InitShaderLabEv();
 __Z27ShaderPassContextInitializev();
 __ZN11TypeManager23CallPostInitializeTypesEv(HEAP32[gb + 1110260 >> 2] | 0);
 __ZN14MessageHandler16ResolveCallbacksEv(__ZN14MessageHandler3GetEv() | 0);
 __ZN22BuiltinResourceManager22InitializeAllResourcesEv();
 __Z33InitializeMeshVertexFormatManagerv();
 __ZN6Shader18LoadDefaultShadersEv();
 if (__Z22GetGraphicsSettingsPtrv() | 0) __ZN16GraphicsSettings22WarmupPreloadedShadersEv(__Z19GetGraphicsSettingsv() | 0);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 24700 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) >> 2] = fb + 176;
 HEAP8[gb + 1548965 >> 0] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 10032 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 } else i1 = 0;
 do {
  i4 = i2 + 9264 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 9264 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 9264 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i1 = 1;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = i1 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = HEAP32[i2 + 20 >> 2] | 0;
  i9 = (i9 | 0) == 0 ? i2 + 4 | 0 : i9;
  i7 = i11;
  i2 = i1;
  L3 : while (1) {
   i1 = i2;
   while (1) {
    i8 = HEAP32[i1 + 36 >> 2] | 0;
    i2 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    L7 : do if (!i2) i12 = 6; else {
     i6 = i9;
     i3 = (i3 | 0) == 0 ? i1 + 20 | 0 : i3;
     while (1) {
      i4 = HEAP8[i3 >> 0] | 0;
      i5 = HEAP8[i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i12 = 6;
       break L7;
      } else {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
      }
     }
     i2 = (i4 & 255) - (i5 & 255) | 0;
    } while (0);
    if ((i12 | 0) == 6) {
     i12 = 0;
     i2 = i8 - i10 | 0;
    }
    if ((i2 | 0) >= 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = i1;
    break;
   } else i7 = i1;
  }
  if ((i7 | 0) != (i11 | 0)) {
   i2 = HEAP32[i7 + 16 >> 2] | 0;
   i6 = HEAP32[i7 + 36 >> 2] | 0;
   i1 = i10 >>> 0 > i6 >>> 0 ? i6 : i10;
   L20 : do if (!i1) i12 = 16; else {
    i5 = (i2 | 0) == 0 ? i7 + 20 | 0 : i2;
    i2 = i9;
    while (1) {
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = HEAP8[i5 >> 0] | 0;
     if (i3 << 24 >> 24 != i4 << 24 >> 24) break;
     i1 = i1 + -1 | 0;
     if (!i1) {
      i12 = 16;
      break L20;
     } else {
      i5 = i5 + 1 | 0;
      i2 = i2 + 1 | 0;
     }
    }
    i1 = (i3 & 255) - (i4 & 255) | 0;
   } while (0);
   if ((i12 | 0) == 16) i1 = i10 - i6 | 0;
   if ((i1 | 0) >= 0) {
    i12 = i7;
    return i12 | 0;
   }
  }
 }
 i12 = i11;
 return i12 | 0;
}

function __ZNK8TypeTree9BlobWriteER13dynamic_arrayIhLj1EEb(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = i7 + 12 | 0;
 i9 = i7 + 32 | 0;
 i6 = ((HEAP32[i10 >> 2] | 0) * 24 | 0) + 8 + (HEAP32[i9 >> 2] | 0) | 0;
 i5 = i1 + 12 | 0;
 i2 = i6 + (HEAP32[i5 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i1 >> 2] = i4;
  i1 = i4;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i1 >> 2] = i4;
  i1 = i4;
  break;
 } else i1 = HEAP32[i1 >> 2] | 0; while (0);
 i1 = i1 + (HEAP32[i5 >> 2] | 0) + (0 - i6) | 0;
 i2 = i1 + 4 | 0;
 i3 = i2 + 4 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
 _memcpy(i3 + (i6 * 24 | 0) | 0, HEAP32[i7 + 20 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
 if (!i8) return;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = _llvm_bswap_i32(HEAP32[i2 >> 2] | 0) | 0;
 if (!(HEAP32[i10 >> 2] | 0)) return; else i1 = 0;
 do {
  i9 = i3 + (i1 * 24 | 0) | 0;
  HEAP16[i9 >> 1] = _llvm_bswap_i16(HEAP16[i9 >> 1] | 0) | 0;
  i9 = i3 + (i1 * 24 | 0) + 4 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i3 + (i1 * 24 | 0) + 8 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i3 + (i1 * 24 | 0) + 12 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i3 + (i1 * 24 | 0) + 16 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i9 = i3 + (i1 * 24 | 0) + 20 | 0;
  HEAP32[i9 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 return;
}

function __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i8, i9, i10, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 24 | 0;
 i12 = i15 + 16 | 0;
 i13 = i15 + 8 | 0;
 i14 = i15;
 i5 = i8 + 48 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = i5;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if ((i4 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i5 = i10;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i3 = i1 + 20 | 0;
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 4 >> 2] = i4;
   i3 = i11;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i1 + 28 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = i4;
  }
 }
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 12; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 12;
 if ((i6 | 0) == 12) {
  __ZN8Material15BuildPropertiesEv(i8);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_(i2 + 12 | 0, i9, i12, i13);
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i8, i7);
 STACKTOP = i15;
 return;
}

function __ZN6Camera38PrepareCullingParametersRendererArraysERK23CameraCullingParametersR11CullResults(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1110544 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110544 | 0, i1);
  i2 = gb + 1110544 | 0;
 } else i2 = 0;
 HEAP32[i4 + 1136 >> 2] = __ZNK13RendererScene22GetStaticBoundingBoxesEv(__Z16GetRendererScenev() | 0) | 0;
 HEAP32[i4 + 1140 >> 2] = __ZNK13RendererScene19GetStaticSceneNodesEv(__Z16GetRendererScenev() | 0) | 0;
 HEAP32[i4 + 1144 >> 2] = __ZNK13RendererScene20GetStaticObjectCountEv(__Z16GetRendererScenev() | 0) | 0;
 HEAP32[i4 + 1148 >> 2] = __ZNK13RendererScene23GetDynamicBoundingBoxesEv(__Z16GetRendererScenev() | 0) | 0;
 HEAP32[i4 + 1152 >> 2] = __ZNK13RendererScene20GetDynamicSceneNodesEv(__Z16GetRendererScenev() | 0) | 0;
 HEAP32[i4 + 1156 >> 2] = __ZNK13RendererScene21GetDynamicObjectCountEv(__Z16GetRendererScenev() | 0) | 0;
 i1 = __Z16GetRendererScenev() | 0;
 HEAP32[i4 + 1160 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 + 1164 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 1168 >> 2] = HEAP32[i1 + 32 >> 2];
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1132 >> 2] | 0;
 HEAP32[i4 + 1172 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 + 1176 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 1180 >> 2] = HEAP32[i1 + 32 >> 2];
 i1 = __Z18GetITerrainManagerv() | 0;
 if (!i1) i1 = i4 + 1288 | 0; else {
  i6 = i4 + 1288 | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, i4 + 1268 | 0, i6 | 0);
  i1 = i6;
 }
 HEAP32[i4 + 1184 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 1188 >> 2] = HEAP32[i4 + 1268 >> 2];
 HEAP32[i4 + 1192 >> 2] = HEAP32[i4 + 1300 >> 2];
 __ZN11CullResults11InitDynamicEPK16RendererCullData(i4, i4 + 1136 | 0);
 __ZN6Camera21PrepareLODCullingDataER11CullResultsPKS_(i4, HEAP32[i3 >> 2] | 0);
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i5;
 return;
}

function __ZN5physx23performBoxPruningNewNewERKNS_2Gu4AxesEPKjjbPjPPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_(i1, i18, i17, i4, i16, i7, i12, i19, i13, i15, i14) {
 i1 = i1 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i4 = i4 | 0;
 i16 = i16 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i19 = i19 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i20 = 0, i21 = 0;
 if (!i17) return;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
 i2 = 0;
 do {
  HEAP32[i16 + (i2 << 2) >> 2] = HEAP32[i1 + (HEAP32[i18 + (i2 << 2) >> 2] << 3) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i17 | 0));
 if (i4) return;
 i11 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
 i10 = i7 + (i5 << 2) | 0;
 i6 = i7 + (i6 << 2) | 0;
 i1 = 0;
 i9 = 0;
 while (1) {
  i7 = HEAP32[i18 + (i9 << 2) >> 2] | 0;
  i8 = HEAP32[i11 + (i7 << 3) + 4 >> 2] | 0;
  i3 = i16 + (i9 << 2) | 0;
  i9 = i9 + 1 | 0;
  while (1) {
   if (i1 >>> 0 >= i17 >>> 0) break;
   i2 = i1 + 1 | 0;
   if ((HEAP32[i16 + (i1 << 2) >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) i1 = i2; else {
    i1 = i2;
    break;
   }
  }
  i2 = i1 >>> 0 < i17 >>> 0;
  if (!i2) {
   i1 = 17;
   break;
  }
  i3 = i12 + (i7 << 2) | 0;
  i5 = i1;
  do {
   if ((HEAP32[i16 + (i5 << 2) >> 2] | 0) >>> 0 > i8 >>> 0) break;
   i4 = HEAP32[i18 + (i5 << 2) >> 2] | 0;
   i5 = i5 + 1 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i12 + (i4 << 2) >> 2] | 0)) {
    i21 = HEAP32[i10 >> 2] | 0;
    i20 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[i20 + (i4 << 3) + 4 >> 2] | 0) >>> 0 >= (HEAP32[i20 + (i7 << 3) >> 2] | 0) >>> 0 & ((((HEAP32[i21 + (i7 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i21 + (i4 << 3) >> 2] | 0) >>> 0 ? 1 : (HEAP32[i21 + (i4 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i21 + (i7 << 3) >> 2] | 0) >>> 0) | (HEAP32[i20 + (i7 << 3) + 4 >> 2] | 0) >>> 0 < (HEAP32[i20 + (i4 << 3) >> 2] | 0) >>> 0) ^ 1)) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i7, i4, i19, i13, i15, i14) | 0;
   }
  } while (i5 >>> 0 < i17 >>> 0);
  if (!(i9 >>> 0 < i17 >>> 0 & i2)) {
   i1 = 17;
   break;
  }
 }
 if ((i1 | 0) == 17) return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx14NpRigidDynamic18setAngularVelocityERKNS_6PxVec3Eb(i11, i5, i9) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = f0, i7 = 0, i8 = 0, i10 = 0, f12 = f0;
 i2 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i11) | 0;
 i10 = i11 + 48 | 0;
 HEAP32[i11 + 264 >> 2] = HEAP32[i5 >> 2];
 i3 = i5 + 4 | 0;
 HEAP32[i11 + 268 >> 2] = HEAP32[i3 >> 2];
 i4 = i5 + 8 | 0;
 HEAP32[i11 + 272 >> 2] = HEAP32[i4 >> 2];
 i8 = i11 + 52 | 0;
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   i7 = 5;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 4; else i7 = 5;
   break;
  }
 default:
  i7 = 4;
 }
 if ((i7 | 0) == 4) {
  HEAP32[i11 + 160 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 164 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i11 + 168 >> 2] = HEAP32[i4 >> 2];
 } else if ((i7 | 0) == 5) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i10);
  i7 = i11 + 284 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2097152;
 }
 if (!i2) return;
 i7 = Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0);
 if (i7 & Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i4 >> 2]) != Math_fround(0.0); else i1 = 1;
 f12 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i11) | 0) + 2876 >> 2]);
 i2 = i11 + 276 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i11 + 280 | 0;
 i7 = f6 < f12 & i9;
 f6 = i7 ? f12 : f6;
 if (!(i7 | (i1 | i9) & (HEAP32[i3 >> 2] | 0) != 0)) return;
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   i7 = 14;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 13; else i7 = 14;
   break;
  }
 default:
  i7 = 13;
 }
 if ((i7 | 0) == 13) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i11 + 64 | 0, f6, 1);
  return;
 } else if ((i7 | 0) == 14) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i10);
  i11 = i11 + 284 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN4gles20TextureIDFromSurfaceEP17RenderSurfaceGLESj(i11, i6) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i2 = i12;
 i7 = i12 + 4 | 0;
 i8 = (i11 | 0) != 0;
 if (i8) i1 = HEAP32[i11 >> 2] | 0; else i1 = 0;
 if ((i6 | 0) != 0 & (i1 | 0) == 0) {
  i10 = __Z21GetUncheckedGfxDevicev() | 0;
  i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 420 >> 2] | 0, i10 | 0) | 0;
 } else i10 = i1;
 if (!i10) {
  STACKTOP = i12;
  return i10 | 0;
 }
 HEAP32[i2 >> 2] = i10;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i5, i1, i2);
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 13; else {
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i3;
  if (!i3) i9 = 13; else HEAP32[i4 >> 2] = i6;
 }
 if ((i9 | 0) == 13) {
  i4 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609299 | 0, 230) | 0;
  HEAP32[i4 >> 2] = i6;
  i9 = i4 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 2;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i5, i4);
 }
 if (i8) {
  i2 = HEAP32[i11 + 4 >> 2] | 0;
  i3 = HEAP32[i11 + 40 >> 2] | 0;
  i1 = HEAP32[i11 + 8 >> 2] | 0;
 } else {
  i2 = 1;
  i3 = 3;
  i1 = 1;
 }
 HEAP32[i4 + 20 >> 2] = i3;
 HEAP32[i4 + 24 >> 2] = i2;
 HEAP32[i4 + 28 >> 2] = i1;
 HEAP32[i4 + 32 >> 2] = 1;
 HEAP32[i4 + 36 >> 2] = 1;
 STACKTOP = i12;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 12 | 0, 4) | 0;
  i2 = i4 + (i1 * 12 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 10;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i5 * 12 | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN17GenericDynamicVBOD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 HEAP32[i6 >> 2] = gb + 57952 + 8;
 i5 = i6 + 36 | 0;
 i2 = i6 + 48 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i6 + 28 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[i3 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 236 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i3 = i6 + 56 | 0;
 i4 = i6 + 68 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i6 + 28 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[i2 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 236 >> 2] | 0, i7 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[gb + 1161272 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161272 >> 2] | 0, gb + 1161272 + 4 | 0);
  HEAP32[gb + 1161272 >> 2] = 0;
 }
 HEAP32[gb + 1161272 >> 2] = 0;
 HEAP32[gb + 1161272 + 12 >> 2] = 0;
 HEAP32[gb + 1161272 + 16 >> 2] = 0;
 if ((HEAP32[gb + 1161272 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161272 + 20 >> 2] | 0, gb + 1161272 + 24 | 0);
  HEAP32[gb + 1161272 + 20 >> 2] = 0;
 }
 HEAP32[gb + 1161272 + 20 >> 2] = 0;
 HEAP32[gb + 1161272 + 32 >> 2] = 0;
 HEAP32[gb + 1161272 + 36 >> 2] = 0;
 if ((HEAP32[gb + 1161312 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161312 >> 2] | 0, gb + 1161312 + 4 | 0);
  HEAP32[gb + 1161312 >> 2] = 0;
 }
 HEAP32[gb + 1161312 >> 2] = 0;
 HEAP32[gb + 1161312 + 12 >> 2] = 0;
 HEAP32[gb + 1161312 + 16 >> 2] = 0;
 if ((HEAP32[i6 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i6 + 60 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i6 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 40 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i6 >> 2] = gb + 57900 + 8;
 i1 = i6 + 4 | 0;
 if ((HEAP32[i6 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11Rigidbody2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i7, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 157332 + 8;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP8[i1 + 76 >> 0] = 0;
 HEAP8[i1 + 77 >> 0] = 0;
 i2 = HEAP32[gb + 1162356 >> 2] | 0;
 HEAP32[i1 + 80 >> 2] = i2;
 i3 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 HEAP32[i1 + 84 >> 2] = i3;
 HEAPF32[i1 + 88 >> 2] = Math_fround(1.0);
 i7 = i1 + 92 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = i1;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 i7 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i1 + 128 >> 2] = i7;
 i6 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i1 + 132 >> 2] = i6;
 i5 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i1 + 136 >> 2] = i5;
 HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 156 >> 2] = i7;
 HEAP32[i1 + 160 >> 2] = i6;
 HEAP32[i1 + 164 >> 2] = i5;
 HEAPF32[i1 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 184 >> 2] = i7;
 HEAP32[i1 + 188 >> 2] = i6;
 HEAP32[i1 + 192 >> 2] = i5;
 HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 212 >> 2] = i2;
 HEAP32[i1 + 216 >> 2] = i3;
 i3 = i1 + 220 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __Z50Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff(i1, i2, i8, i3, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i10 + 8 | 0;
 i14 = i10;
 i12 = i10 + 48 | 0;
 i11 = i10 + 40 | 0;
 i9 = i10 + 16 | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f19 = Math_fround(Math_fround(f18 + f15) * Math_fround(.5));
 HEAPF32[i12 >> 2] = Math_fround(Math_fround(f17 + f16) * Math_fround(.5));
 HEAPF32[i12 + 4 >> 2] = f19;
 f15 = Math_fround(Math_abs(Math_fround(f18 - f15)));
 HEAPF32[i11 >> 2] = Math_fround(Math_abs(Math_fround(f17 - f16)));
 HEAPF32[i11 + 4 >> 2] = f15;
 i1 = gb + 64016 | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i14;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i14);
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i3 = __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(__Z19GetPhysicsManager2Dv() | 0, i12, i11, Math_fround(0.0), i3, f6, f7, 0, i9) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0;
 i2 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i8, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i5);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return i2 | 0;
}

function __Z27ShaderPassContextInitializev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i5 = i7;
 i2 = __ZnwjRK10MemLabelIdiPKci(152, gb + 63280 | 0, 16, gb + 478638 | 0, 11) | 0;
 i3 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 i6 = i2;
 i8 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 33952 + 8;
 i4 = gb + 63280 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i5);
 i8 = i1;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i2 + 72 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = gb + 63280 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i2 + 88 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i5);
 i8 = i1;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i2 + 92 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = gb + 63280 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i2 + 120 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i5);
 i8 = i1;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i2 + 112 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 0;
 i5 = gb + 63280 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i2 + 136 | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP8[i2 + 144 >> 0] = 1;
 i8 = i2 + 44 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP8[i2 + 148 >> 0] = 1;
 HEAP32[gb + 1166248 >> 2] = i2;
 HEAP8[i2 + 149 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z18ClearByDrawingQuadjRK10ColorRGBAffjR17ShaderPassContext(i7, i8, f1, i2, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, f11 = f0, f12 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = __Z12GetGfxDevicev() | 0;
 i4 = __ZN6Shader20GetScreenClearShaderEv() | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 i5 = i4 + 32 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[i10 >> 2] | 0) + (HEAP32[i10 + 48 >> 2] << 2) >> 2] | 0) + 20 >> 2] | 0) != 8) {
  STACKTOP = i6;
  return;
 }
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i2, __Z12GetGfxDevicev() | 0);
 __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 i10 = i7 & 7;
 i9 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (HEAP32[i5 + 48 >> 2] << 2) >> 2] >> 2] | 0) + (i10 << 2) >> 2] | 0, 0, 0, i9, i4, i10, 0, 0) | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0, 0);
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 580 >> 2] | 0, i3 | 0, 2, i9 | 0);
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 mftCall_viffff(HEAP32[(HEAP32[i3 >> 2] | 0) + 568 >> 2] | 0, i3 | 0, +f12, +f11, +f1, +Math_fround(HEAPF32[i8 + 12 >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 0.0, 0.0, -100.0);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 0.0, 1.0, -100.0);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 1.0, 1.0, -100.0);
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 560 >> 2] | 0, i3 | 0, 1.0, 0.0, -100.0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 584 >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0, i10 | 0);
 __ZN22DeviceMVPMatricesStateD2Ev(i2);
 STACKTOP = i6;
 return;
}

function _UNITY_tt_face_load_loca(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i1 = i11 + 508 | 0;
 i2 = i11 + 668 | 0;
 i3 = mftCall_iiiii(HEAP32[i1 >> 2] | 0, i11 | 0, 1735162214, i12 | 0, i2 | 0) | 0;
 if ((i3 & 255 | 0) == 142) HEAP32[i2 >> 2] = 0; else if (i3 | 0) {
  i12 = i3;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (mftCall_iiiii(HEAP32[i1 >> 2] | 0, i11 | 0, 1819239265, i12 | 0, i10 | 0) | 0) {
  i12 = 144;
  STACKTOP = i13;
  return i12 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 do if (!(HEAP16[i11 + 210 >> 1] | 0)) if (i1 >>> 0 > 131071) {
  i12 = 8;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i4 = i1 >>> 1;
  i8 = i11 + 696 | 0;
  HEAP32[i8 >> 2] = i4;
  i2 = 1;
  break;
 } else if (i1 >>> 0 > 262143) {
  i12 = 8;
  STACKTOP = i13;
  return i12 | 0;
 } else {
  i4 = i1 >>> 2;
  i8 = i11 + 696 | 0;
  HEAP32[i8 >> 2] = i4;
  i2 = 2;
  break;
 } while (0);
 i9 = i11 + 16 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i3 = i7 + 1 | 0;
 do if (!(i4 >>> 0 > i7 >>> 0 | (i4 | 0) == (i3 | 0))) {
  i1 = i3 << i2;
  i3 = HEAP32[i11 + 156 >> 2] | 0;
  i5 = HEAP16[i11 + 152 >> 1] | 0;
  i6 = i3 + ((i5 & 65535) << 4) | 0;
  i7 = _UNITY_FT_Stream_Pos(i12) | 0;
  if (!(i5 << 16 >> 16)) i2 = 2147483647; else {
   i5 = i3 + 16 | 0;
   i5 = (((i6 >>> 0 > i5 >>> 0 ? i6 : i5) + ~i3 | 0) >>> 4) + 1 | 0;
   i2 = 2147483647;
   i4 = i3;
   do {
    i14 = (HEAP32[i4 + 8 >> 2] | 0) - i7 | 0;
    i2 = (i14 | 0) > 0 & (i14 | 0) < (i2 | 0) ? i14 : i2;
    i4 = i4 + 16 | 0;
   } while (i4 >>> 0 < i6 >>> 0);
   i3 = i3 + (i5 << 4) | 0;
  }
  if ((i3 | 0) == (i6 | 0)) i2 = (HEAP32[i12 + 4 >> 2] | 0) - i7 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   i1 = HEAP32[i8 >> 2] | 0;
   HEAP32[i9 >> 2] = (i1 | 0) == 0 ? 0 : i1 + -1 | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   break;
  } else {
   HEAP32[i8 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = _UNITY_FT_Stream_ExtractFrame(i12, i1, i11 + 700 | 0) | 0;
 STACKTOP = i13;
 return i14 | 0;
}

function __ZN8GUIState24GetNextKeyboardControlIDERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 i9 = i11;
 i10 = i12;
 L1 : do if ((i12 | 0) == (i11 | 0)) i8 = 0; else {
  i1 = i12;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = i1 + 4 | 0;
   if (HEAP8[i2 + 20 >> 0] | 0) {
    i8 = i2;
    break L1;
   }
   if ((i1 | 0) == (i11 | 0)) {
    i8 = 0;
    break;
   }
  }
 } while (0);
 i7 = (i8 | 0) != 0;
 if (i5) {
  L8 : do if (i7) {
   i1 = HEAP32[i8 + 16 >> 2] | 0;
   if ((i1 | 0) != -1) {
    i12 = i1;
    return i12 | 0;
   }
   i2 = i9 - i10 >> 2;
   i1 = 0;
   do {
    if (i1 >>> 0 >= i2 >>> 0) {
     i6 = -1;
     i5 = i2;
     break L8;
    }
    i6 = i1;
    i1 = i1 + 1 | 0;
   } while ((HEAP32[i12 + (i6 << 2) >> 2] | 0) != (i8 | 0));
   i6 = (i1 >>> 0) % (i2 >>> 0) | 0;
   i5 = i2;
  } else {
   i6 = 0;
   i5 = i9 - i10 >> 2;
  } while (0);
  i1 = i6;
  while (1) {
   i2 = HEAP32[(HEAP32[i12 + (i1 << 2) >> 2] | 0) + 4 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = 26;
    break;
   }
   i1 = ((i1 + 1 | 0) >>> 0) % (i5 >>> 0) | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i2 = 0;
    i1 = 26;
    break;
   }
  }
  if ((i1 | 0) == 26) return i2 | 0;
 }
 L26 : do if (i7) {
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i12 = i1;
   return i12 | 0;
  }
  i1 = i9 - i10 >> 2;
  if ((i11 | 0) == (i12 | 0)) i5 = 0; else {
   i2 = 0;
   while (1) {
    if ((HEAP32[i12 + (i2 << 2) >> 2] | 0) == (i8 | 0)) {
     i1 = i2;
     i5 = i2;
     break L26;
    }
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= i1 >>> 0) {
     i5 = 0;
     break;
    }
   }
  }
 } else {
  i1 = i9 - i10 >> 2;
  i5 = 0;
 } while (0);
 while (1) {
  if (!i1) i1 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 2;
  i1 = i1 + -1 | 0;
  i2 = HEAP32[(HEAP32[i12 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i1 = 26;
   break;
  }
  if ((i1 | 0) == (i5 | 0)) {
   i2 = 0;
   i1 = 26;
   break;
  }
 }
 if ((i1 | 0) == 26) return i2 | 0;
 return 0;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx14NpRigidDynamic17setLinearVelocityERKNS_6PxVec3Eb(i11, i5, i9) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f6 = f0, i7 = 0, i8 = 0, i10 = 0, f12 = f0;
 i2 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i11) | 0;
 i10 = i11 + 48 | 0;
 HEAP32[i11 + 252 >> 2] = HEAP32[i5 >> 2];
 i3 = i5 + 4 | 0;
 HEAP32[i11 + 256 >> 2] = HEAP32[i3 >> 2];
 i4 = i5 + 8 | 0;
 HEAP32[i11 + 260 >> 2] = HEAP32[i4 >> 2];
 i8 = i11 + 52 | 0;
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   i7 = 5;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 4; else i7 = 5;
   break;
  }
 default:
  i7 = 4;
 }
 if ((i7 | 0) == 4) {
  HEAP32[i11 + 144 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 148 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i11 + 152 >> 2] = HEAP32[i4 >> 2];
 } else if ((i7 | 0) == 5) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i10);
  i7 = i11 + 284 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1048576;
 }
 if (!i2) return;
 i7 = Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0);
 if (i7 & Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i4 >> 2]) != Math_fround(0.0); else i1 = 1;
 f12 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i11) | 0) + 2876 >> 2]);
 i2 = i11 + 276 | 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i11 + 280 | 0;
 i7 = f6 < f12 & i9;
 f6 = i7 ? f12 : f6;
 if (!(i7 | (i1 | i9) & (HEAP32[i3 >> 2] | 0) != 0)) return;
 switch ((HEAP32[i8 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   i7 = 14;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i10 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 13; else i7 = 14;
   break;
  }
 default:
  i7 = 13;
 }
 if ((i7 | 0) == 13) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i11 + 64 | 0, f6, 1);
  return;
 } else if ((i7 | 0) == 14) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i2 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i10);
  i11 = i11 + 284 | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 48 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5CacheD2Ev(i2);
  __ZdlPv(i2);
 }
 i2 = __Znwj(80) | 0;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i11 = i2 + 60 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = i11;
 i11 = i2 + 72 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = i11;
 i11 = i2 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 2147483647;
 HEAP8[i2 + 52 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 48 >> 2] = 1296e4;
 HEAP32[i1 >> 2] = i2;
 __Z20GetPlatformCachePathv(i7);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i7); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i7, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i11 = __Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i9) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 if (i11) __ZN5Cache18WriteCacheInfoFileEb(HEAP32[i1 >> 2] | 0, 1);
 i11 = HEAP32[i1 >> 2] | 0;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 i9 = i11 + 40 | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP8[i11 >> 0] = i6 & 1;
 __ZN5Cache14ReadCacheIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i11, i3, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_16StringTableEventEEEvT_(i13, i11) {
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 HEAP16[i12 >> 1] = 16369;
 i9 = i13 + 80 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i7 = i5 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4;
 i8 = i1 - i3 | 0;
 i2 = i8 + 2 | 0;
 i6 = i5 + 16 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i5 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
  }
  HEAP32[i7 >> 2] = i2;
  i1 = i2 + i8 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = -15;
 HEAP8[i1 + 1 >> 0] = 63;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 2;
 __ZN5physx7profile16StringTableEvent9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_17MemoryEventHeaderE(i11, i9, i12);
 i7 = i13 + 20 | 0;
 i3 = i13 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4;
 i5 = (HEAP32[i7 >> 2] | 0) - i1 | 0;
 if (i5 >>> 0 < (HEAP32[i13 + 44 >> 2] | 0) >>> 0) {
  STACKTOP = i14;
  return;
 }
 i6 = HEAP32[i13 + 36 >> 2] | 0;
 if (i6) {
  i1 = i13 + 32 | 0;
  i2 = 0;
  do {
   i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i4 | 0, i5 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcherD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 1 | 0;
 i7 = i9;
 HEAP32[i8 >> 2] = gb + 87280 + 8;
 i6 = i8 + 28 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i1 = i8 + 4 | 0;
  i2 = 0;
  do {
   __ZN5physx6shdfnd10ThreadImpl10signalQuitEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 28 | 0) + 4 >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 HEAP8[i8 + 32 >> 0] = 1;
 i4 = i8 + 20 | 0;
 __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i4 >> 2] | 0);
 i3 = i8 + 4 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i2 = 0;
  do {
   __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 * 28 | 0) + 4 >> 2] | 0) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i1 = 0;
   do {
    i2 = (HEAP32[i3 >> 2] | 0) + (i1 * 28 | 0) | 0;
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i8 + 24 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i1);
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (i1 | 0) {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc10NPhaseCore26createRbElementInteractionERNS0_8ShapeSimES3_(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i9 + 10 | 0;
 i2 = i9 + 8 | 0;
 __ZN5physx2Sc10NPhaseCore21filterRbCollisionPairERKNS0_8ShapeSimES4_PNS0_10FilterPairE(i8, i7, i5, i6, 0);
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 >>> 16 & 65535;
 if (i3 & 1 | 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 do if (!(i3 & 2)) {
  if (!(HEAP8[(HEAP32[i5 + 28 >> 2] | 0) + 64 >> 0] & 4)) if (!(HEAP8[(HEAP32[i6 + 28 >> 2] | 0) + 64 >> 0] & 4)) {
   HEAP16[i1 >> 1] = i4;
   i1 = __ZN5physx2Sc10NPhaseCore25createShapeInstancePairLLERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i7, i5, i6, i1) | 0;
   break;
  }
  HEAP16[i2 >> 1] = i4;
  i1 = __ZN5physx2Sc10NPhaseCore24createTriggerInteractionERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i7, i5, i6, i2) | 0;
 } else {
  i2 = i7 + 1916 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i7 + 1624 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i4 = i7 + 1904 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i7 = i7 + 1908 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = gb + 101220 + 8;
   HEAP16[i1 + 4 >> 1] = -1;
   HEAP16[i1 + 6 >> 1] = 1;
   i7 = i1 + 8 | 0;
   __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i7, HEAP32[i5 + 8 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, 3, 5);
   HEAP32[i1 + 32 >> 2] = i5;
   HEAP32[i1 + 36 >> 2] = i6;
   HEAP32[i1 >> 2] = gb + 101244 + 8;
   HEAP32[i7 >> 2] = gb + 101244 + 52;
  }
  __ZN5physx2Sc24ElementInteractionMarker10initializeEv(i1);
 } while (0);
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 if (!i2) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = i1 + 6 | 0;
 HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 0 | 4;
 HEAP8[i2 + 8 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 1, 2, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 1) | 0, 0, i5 - i3 << 1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 1) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
   i2 = HEAP16[i8 >> 1] | 0;
  } else {
   i2 = HEAP16[i2 >> 1] | 0;
   HEAP16[i8 >> 1] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP16[i1 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 1, 2, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 2, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 1) | 0, 0, i5 - i3 << 1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 1) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 2);
   i2 = HEAP16[i8 >> 1] | 0;
  } else {
   i2 = HEAP16[i2 >> 1] | 0;
   HEAP16[i8 >> 1] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP16[i1 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
 }
 i6 = i7 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i4;
  i2 = i4;
  i1 = i4;
  break;
 } else {
  i2 = i4;
  i1 = i4;
 } while (0);
 if (i5 >>> 0 > i3 >>> 0) {
  _memset(i2 + (i3 << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 88 | 0;
 i7 = i6 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 76 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 77 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 80 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 78 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 79 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 }
}

function __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj458ES3_RKNS_22PxJointLinearLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 260 | 0, i6 + 2 | 0);
 i1 = i7 + 276 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj459ENS_22PxRepXPropertyAccessorILj459ES4_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i3 = i1 + -1 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj460ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 292 | 0, i6 + 4 | 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj461ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 308 | 0, i6 + 5 | 0);
 STACKTOP = i8;
 return i6 + 7 | 0;
}

function __ZNK13b2CircleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi(i5, i12, i11, i1, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f8 = Math_fround(f6 * f3);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f9 * f10));
 f10 = Math_fround(Math_fround(f3 * f9) + Math_fround(f6 * f10));
 f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f8);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + f10);
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(f6 - f8);
 f9 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f10 = Math_fround(f9 - f10);
 f3 = Math_fround(Math_fround(f8 * f8) + Math_fround(f10 * f10));
 f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f4 = Math_fround(f3 - Math_fround(f4 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f6);
 f9 = Math_fround(Math_fround(HEAPF32[i11 + 12 >> 2]) - f9);
 f3 = Math_fround(Math_fround(f8 * f6) + Math_fround(f10 * f9));
 f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(f9 * f9));
 f4 = Math_fround(Math_fround(f3 * f3) - Math_fround(f4 * f7));
 if (f7 < Math_fround(1.1920929e-07) | f4 < Math_fround(0.0)) {
  i12 = 0;
  return i12 | 0;
 }
 f4 = Math_fround(f3 + Math_fround(Math_sqrt(Math_fround(f4))));
 f3 = Math_fround(-f4);
 if (!(f4 <= Math_fround(-0.0))) {
  i12 = 0;
  return i12 | 0;
 }
 if (!(Math_fround(f7 * Math_fround(HEAPF32[i11 + 16 >> 2])) >= f3)) {
  i12 = 0;
  return i12 | 0;
 }
 f3 = Math_fround(f3 / f7);
 HEAPF32[i12 + 8 >> 2] = f3;
 f6 = Math_fround(f8 + Math_fround(f6 * f3));
 f3 = Math_fround(f10 + Math_fround(f9 * f3));
 HEAPF32[i12 >> 2] = f6;
 i1 = i12 + 4 | 0;
 HEAPF32[i1 >> 2] = f3;
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f3 * f3))));
 if (f4 < Math_fround(1.1920929e-07)) {
  i12 = 1;
  return i12 | 0;
 }
 f10 = Math_fround(Math_fround(1.0) / f4);
 HEAPF32[i12 >> 2] = Math_fround(f6 * f10);
 HEAPF32[i1 >> 2] = Math_fround(f3 * f10);
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx3Scb11RigidObject19processShapeRemovesEv(i13) {
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i12 = i13 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!(i1 & 8)) {
  STACKTOP = i15;
  return;
 }
 i2 = i13 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i13 >> 2] | 0, i1 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i3;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 if ((i1 & -1073741824 | 0) == -2147483648) {
  i10 = i13;
  i1 = i3 + 76 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2) {
   i11 = i3 + 72 | 0;
   i9 = 0;
   do {
    i6 = HEAP32[i11 >> 2] | 0;
    i7 = HEAP32[i6 + (i9 << 3) >> 2] | 0;
    i8 = i7 + 4 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    if ((i4 & 251658240 | 0) == 16777216) {
     HEAP32[i8 >> 2] = i4 & 1073741823;
     HEAP32[i7 >> 2] = 0;
    }
    i4 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i12 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i10 | 0;
    i5 = HEAP32[i13 >> 2] | 0;
    if (!(HEAP16[i4 + 8 >> 1] & 8)) {
     __ZN5physx2Sc9RigidCore20removeShapeFromSceneERNS0_9ShapeCoreEb(i4, i7 + 16 | 0, (HEAP8[i6 + (i9 << 3) + 4 >> 0] | 0) != 0);
     if (HEAP32[i8 >> 2] & 268435456 | 0) {
      __ZN5physx3Scb5Shape9syncStateEv(i7);
      HEAP32[i14 >> 2] = i7;
      __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i5 + 2464 | 0, i14) | 0;
     }
     __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i7);
     i2 = HEAP32[i1 >> 2] | 0;
    }
    i9 = i9 + 1 | 0;
   } while (i9 >>> 0 < i2 >>> 0);
  }
 } else i1 = i3 + 76 | 0;
 i13 = i3 + 36 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP8[i14 + 4 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i13, 0, i14);
 __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i13, HEAP32[i1 >> 2] | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN15NavMeshObstacle7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 845662 | 0, 16) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 169040 + 8;
 i2 = i4 + 44 | 0;
 i6 = i4 + 80 | 0;
 i5 = i4 + 92 | 0;
 i1 = i4 + 120 | 0;
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 116 >> 2] = Math_fround(1.0);
 HEAP32[i1 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 HEAPF32[i4 + 132 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 136 >> 2] = 8;
 HEAP32[i4 + 140 >> 2] = 0;
 HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 148 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 1;
 HEAPF32[i4 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(.5);
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 76 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 72 >> 2] = Math_fround(.100000001);
 HEAP8[i4 + 69 >> 0] = 1;
 HEAP8[i4 + 68 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17GetResponseHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i3);
 i2 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i4, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if ((i2 | 0) != (i4 + 4 | 0)) {
  i6 = i2 + 28 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i3);
 i2 = i6 + 11 | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i1 = i8 << 24 >> 24 < 0;
 i3 = i6 + 4 | 0;
 if ((i1 ? HEAP32[i3 >> 2] | 0 : i8 & 255) | 0) {
  i1 = i1 ? HEAP32[i6 >> 2] | 0 : i6;
  do {
   i9 = HEAP8[i1 >> 0] | 0;
   i8 = i9 << 24 >> 24;
   HEAP8[i1 >> 0] = (i9 + -97 & 255) < 26 ? i8 + 224 | 0 : i8;
   i1 = i1 + 1 | 0;
   i8 = HEAP8[i2 >> 0] | 0;
   i9 = i8 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i9 ? HEAP32[i6 >> 2] | 0 : i6) + (i9 ? HEAP32[i3 >> 2] | 0 : i8 & 255) | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 i9 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i4, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i9 = (i9 | 0) == (i4 + 4 | 0) ? 0 : i9 + 28 | 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN9Animation12AddToManagerEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 256 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 260 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 if (!(__Z14IsWorldPlayingv() | 0)) {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  if (!i1) return;
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
  i2 = HEAP32[gb + 1465160 >> 2] | 0;
  if ((i4 | 0) == (i2 | 0)) return;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i3 + 260 | 0; else {
   i3 = i3 + 260 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 if (!(HEAP8[i3 + 42 >> 0] | 0)) if (HEAP32[i3 + 44 >> 2] | 0) return;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if ((HEAP32[i3 + 104 >> 2] | 0) == (HEAP32[i3 + 108 >> 2] | 0)) return;
 i2 = HEAP32[gb + 1465160 >> 2] | 0;
 if (!(HEAP8[i3 + 41 >> 0] | 0)) {
  if ((i4 | 0) == (i2 | 0)) return;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i3 + 260 | 0; else {
   i3 = i3 + 260 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  return;
 } else {
  i2 = i2 + 8 | 0;
  if ((i4 | 0) == (i2 | 0)) return;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i3 + 260 | 0; else {
   i3 = i3 + 260 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  return;
 }
}

function __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj(i15, i7, i14, i12, i13) {
 i15 = i15 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i16 = 0;
 i6 = HEAP32[i15 + 1220 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) {
    i16 = 6;
    break;
   }
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
  if (!i1) i1 = 0; else i16 = 6;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i16 = 6;
 } while (0);
 if ((i16 | 0) == 6) __ZN5physx2Sc7BodySimC2ERNS0_5SceneERNS0_8BodyCoreE(i1, i15, i7);
 i8 = i15 + 1420 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i1 + 64 | 0;
 if (!i12) return;
 i9 = i15 + 1212 | 0;
 i11 = 0;
 do {
  i10 = (HEAP32[i14 + (i11 << 2) >> 2] | 0) + i13 | 0;
  i7 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i5 = HEAP32[i7 + 12 >> 2] | 0;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i5 + (i4 * 12 | 0) + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if (!i2) {
   i2 = i5 + (i4 * 12 | 0) + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i7 >> 2] | 0)) {
    HEAP32[i2 >> 2] = i3 + 1;
    i2 = (HEAP32[i5 + (i4 * 12 | 0) >> 2] | 0) + (Math_imul(i3, i6) | 0) | 0;
    if (i2 | 0) {
     i16 = 14;
     break;
    }
   }
   i2 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i7) | 0;
   if (i2 | 0) i16 = 14;
  } else {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i16 = 14;
  } while (0);
  if ((i16 | 0) == 14) {
   i16 = 0;
   __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(i2, i1, i10, i8, 0);
  }
  i10 = i15 + 1424 + (HEAP32[i10 + 68 >> 2] << 2) | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) != (i12 | 0));
 return;
}

function __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i9 = i6 + 32 | 0;
  __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426256 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 898897 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 i6 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i6, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426246 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 92 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 76 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 80 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN12AudioManager27GroupGUIDHasDependentMixersERK9UnityGUID(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i10 = i14;
 i11 = i1 + 68 | 0;
 i12 = i8 + 12 | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i11 | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i7 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 L4 : while (1) {
  i5 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 92 >> 2] | 0;
  do if (i5 | 0) {
   HEAP32[i10 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i13 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
     i3 = HEAP32[i9 >> 2] | 0;
     i15 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i13 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i13 = 11;
    }
   }
   if ((i13 | 0) == 9) i13 = 11;
   if ((i13 | 0) == 11) {
    i13 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
    if (!i1) break;
   }
   if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i1 + 56 >> 2] | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i1 + 60 >> 2] | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i1 + 64 >> 2] | 0)) if ((HEAP32[i12 >> 2] | 0) == (HEAP32[i1 + 68 >> 2] | 0)) {
    i1 = 1;
    i13 = 17;
    break L4;
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i11 | 0)) {
   i1 = 0;
   i13 = 17;
   break;
  }
 }
 if ((i13 | 0) == 17) {
  STACKTOP = i14;
  return i1 | 0;
 }
 return 0;
}

function __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i10 = (HEAP32[i11 + 4 >> 2] | 0) - i2 | 0;
 i12 = (i10 | 0) / 36 | 0;
 if (!i10) return;
 i10 = i1 + 4 | 0;
 i1 = 0;
 while (1) {
  i6 = HEAP32[i2 + (i1 * 36 | 0) + 16 >> 2] | 0;
  do if ((i6 | 0) != -1) {
   i3 = HEAP32[i10 >> 2] | 0;
   if (i3 | 0) {
    i5 = i10;
    L8 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) {
       i4 = i5;
       break L8;
      } else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) break; else i5 = i4;
    }
    if ((i4 | 0) != (i10 | 0)) if ((i6 | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) {
     i8 = i2 + (i1 * 36 | 0) | 0;
     i3 = i4 + 20 | 0;
     if ((i8 | 0) != (i3 | 0)) {
      i7 = HEAP8[i3 + 11 >> 0] | 0;
      i5 = i7 << 24 >> 24 < 0;
      i9 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
      i7 = i5 ? HEAP32[i4 + 24 >> 2] | 0 : i7 & 255;
      i5 = i8 + 11 | 0;
      i3 = HEAP8[i5 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i6 = (HEAP32[i2 + (i1 * 36 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
      if (i7 >>> 0 > i6 >>> 0) {
       if (i4) i2 = HEAP32[i2 + (i1 * 36 | 0) + 4 >> 2] | 0; else i2 = i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i6, i7 - i6 | 0, i2, 0, i2, i7, i9);
       break;
      }
      if (i4) i3 = HEAP32[i8 >> 2] | 0; else i3 = i8;
      if (i7 | 0) _memmove(i3 | 0, i9 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i5 >> 0] | 0) < 0) {
       HEAP32[i2 + (i1 * 36 | 0) + 4 >> 2] = i7;
       break;
      } else {
       HEAP8[i5 >> 0] = i7;
       break;
      }
     }
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i12 | 0)) break;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 return;
}

function __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i10 = (HEAP32[i11 + 4 >> 2] | 0) - i2 | 0;
 i12 = (i10 | 0) / 36 | 0;
 if (!i10) return;
 i10 = i1 + 4 | 0;
 i1 = 0;
 while (1) {
  i6 = HEAP32[i2 + (i1 * 36 | 0) + 16 >> 2] | 0;
  do if ((i6 | 0) != -1) {
   i3 = HEAP32[i10 >> 2] | 0;
   if (i3 | 0) {
    i5 = i10;
    L8 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) {
       i4 = i5;
       break L8;
      } else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) break; else i5 = i4;
    }
    if ((i4 | 0) != (i10 | 0)) if ((i6 | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) {
     i8 = i2 + (i1 * 36 | 0) | 0;
     i3 = i4 + 20 | 0;
     if ((i8 | 0) != (i3 | 0)) {
      i7 = HEAP8[i3 + 11 >> 0] | 0;
      i5 = i7 << 24 >> 24 < 0;
      i9 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
      i7 = i5 ? HEAP32[i4 + 24 >> 2] | 0 : i7 & 255;
      i5 = i8 + 11 | 0;
      i3 = HEAP8[i5 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i6 = (HEAP32[i2 + (i1 * 36 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
      if (i7 >>> 0 > i6 >>> 0) {
       if (i4) i2 = HEAP32[i2 + (i1 * 36 | 0) + 4 >> 2] | 0; else i2 = i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i6, i7 - i6 | 0, i2, 0, i2, i7, i9);
       break;
      }
      if (i4) i3 = HEAP32[i8 >> 2] | 0; else i3 = i8;
      if (i7 | 0) _memmove(i3 | 0, i9 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i5 >> 0] | 0) < 0) {
       HEAP32[i2 + (i1 * 36 | 0) + 4 >> 2] = i7;
       break;
      } else {
       HEAP8[i5 >> 0] = i7;
       break;
      }
     }
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i12 | 0)) break;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 return;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i8 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i12 >> 2] | 0) - i3 | 0) / 52 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i1 = i2;
  i7 = i3;
 } else {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = 16;
  HEAP32[i11 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 52 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i5 + (((i2 - i3 | 0) / 52 | 0) * 52 | 0) | 0;
 i6 = i3;
 i4 = i5 + (i4 * 52 | 0) | 0;
 if ((i1 | 0) == (i7 | 0)) i2 = i6; else {
  i2 = i6;
  do {
   i14 = i1;
   i1 = i1 + -52 | 0;
   i16 = i1;
   i15 = HEAP32[i16 + 4 >> 2] | 0;
   i5 = i3 + -52 | 0;
   HEAP32[i5 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i5 + 4 >> 2] = i15;
   HEAP32[i3 + -44 >> 2] = HEAP32[i14 + -44 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i14 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i14 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i14 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i14 + -24 >> 2];
   i5 = i3 + -20 | 0;
   i14 = i14 + -20 | 0;
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   i3 = i2 + -52 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i12 >> 2] = i4;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i16 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = 16;
 HEAP32[i11 + 4 >> 2] = i16;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZN20PxsAtomIntegrateTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 f5 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 i10 = HEAP32[i1 + 24 >> 2] | 0;
 i11 = HEAP32[i1 + 64 >> 2] | 0;
 i12 = HEAP32[i1 + 28 >> 2] | 0;
 i13 = HEAP32[i1 + 68 >> 2] | 0;
 i6 = HEAP32[i1 + 44 >> 2] | 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 i8 = HEAP32[i1 + 36 >> 2] | 0;
 i9 = HEAP32[i1 + 56 >> 2] | 0;
 i4 = HEAP32[i1 + 60 >> 2] | 0;
 if (i13 >>> 0 > 1) {
  i2 = 1;
  i3 = 0;
  i1 = 0;
  do {
   i14 = i2 + -1 + i11 | 0;
   i15 = HEAP32[i10 + (i14 << 2) >> 2] | 0;
   i16 = HEAPU16[i15 + 30 >> 1] | 0;
   i17 = i16 & 255;
   i3 = i17 >>> 0 < i3 >>> 0 ? i3 : i17;
   i16 = i16 >>> 8;
   i1 = i16 >>> 0 < i1 >>> 0 ? i1 : i16;
   __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(i15, i6 + (i14 << 5) | 0, i6 + (i14 << 5) + 16 | 0, f5);
   __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i7 + (i14 << 5) | 0, i8 + (i2 + i11 << 6) | 0, i15, HEAP32[i12 + (i14 << 2) >> 2] | 0);
   HEAP32[i7 + (i14 << 5) + 28 >> 2] = 0;
   HEAP16[i7 + (i14 << 5) + 12 >> 1] = 0;
   HEAP16[i7 + (i14 << 5) + 14 >> 1] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  i2 = i3;
 } else {
  i2 = 0;
  i1 = 0;
 }
 i15 = i13 + -1 + i11 | 0;
 i14 = HEAP32[i10 + (i15 << 2) >> 2] | 0;
 i17 = HEAPU16[i14 + 30 >> 1] | 0;
 i16 = i17 & 255;
 i17 = i17 >>> 8;
 __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(i14, i6 + (i15 << 5) | 0, i6 + (i15 << 5) + 16 | 0, f5);
 __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i7 + (i15 << 5) | 0, i8 + (i13 + i11 << 6) | 0, i14, HEAP32[i12 + (i15 << 2) >> 2] | 0);
 HEAP32[i7 + (i15 << 5) + 28 >> 2] = 0;
 HEAP16[i7 + (i15 << 5) + 12 >> 1] = 0;
 HEAP16[i7 + (i15 << 5) + 14 >> 1] = 0;
 __ZN5physx6shdfnd9atomicMaxEPVii(i9, i16 >>> 0 < i2 >>> 0 ? i2 : i16) | 0;
 __ZN5physx6shdfnd9atomicMaxEPVii(i4, i17 >>> 0 < i1 >>> 0 ? i1 : i17) | 0;
 return;
}

function __ZN15CapsuleCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 12 | 0;
 i6 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f7 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + (i6 << 2) >> 2]));
 i4 = f5 < Math_fround(0.0);
 f7 = Math_fround(-f5);
 f5 = i4 ? f7 : f5;
 i4 = f5 < Math_fround(9.99999974e-06);
 f5 = i4 ? Math_fround(9.99999974e-06) : f5;
 f7 = Math_fround(HEAPF32[i3 + (((i6 + 1 | 0) % 3 | 0) << 2) >> 2]);
 f9 = Math_fround(HEAPF32[i3 + (((i6 + 2 | 0) % 3 | 0) << 2) >> 2]);
 i6 = f7 < Math_fround(0.0);
 f10 = Math_fround(-f7);
 f7 = i6 ? f10 : f7;
 i6 = f9 < Math_fround(0.0);
 f10 = Math_fround(-f9);
 f9 = i6 ? f10 : f9;
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * (f7 < f9 ? f9 : f7));
 f5 = Math_fround(f5 - Math_fround(f7 * Math_fround(2.0)));
 i6 = f5 < Math_fround(9.99999974e-06);
 f5 = i6 ? Math_fround(9.99999974e-06) : f5;
 i6 = f7 < Math_fround(9.99999974e-06);
 f7 = i6 ? Math_fround(9.99999974e-06) : f7;
 HEAP32[i3 >> 2] = 2;
 i6 = i3 + 4 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i4 = i3 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i1 = i1 + 36 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 44 >> 2] | 0, i8 | 0, i3 | 0) | 0;
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i4 >> 2] = Math_fround(f5 * Math_fround(.5));
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function _UNITY_FT_Render_Glyph_Internal(i8, i13, i14) {
 i8 = i8 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = i13 + 72 | 0;
 i10 = HEAP32[i15 >> 2] | 0;
 L1 : do if ((i10 | 0) < 1869968492) {
  switch (i10 | 0) {
  case 1651078259:
   {
    i2 = 0;
    break;
   }
  default:
   {
    i11 = 3;
    break L1;
   }
  }
  return i2 | 0;
 } else {
  switch (i10 | 0) {
  case 1869968492:
   break;
  default:
   {
    i11 = 3;
    break L1;
   }
  }
  i1 = i8 + 148 | 0;
  i3 = HEAP32[i8 + 156 >> 2] | 0;
  i12 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } while (0);
 do if ((i11 | 0) == 3) {
  if (!i8) {
   i2 = 7;
   i4 = 0;
  } else {
   i9 = i8 + 148 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!i2) {
    i3 = 0;
    i12 = i9;
    i1 = 0;
    break;
   }
   while (1) {
    i5 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i5 + 16 >> 2] | 0) == (i10 | 0)) {
     i11 = 6;
     break;
    }
    i6 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i6) {
     i4 = 0;
     i7 = 0;
     break;
    } else i2 = i6;
   }
   if ((i11 | 0) == 6) {
    i4 = i5;
    i7 = i2;
   }
   if (!i8) i2 = 7; else {
    i3 = i4;
    i12 = i9;
    i1 = i7;
    break;
   }
  }
  while (1) {
   if (!i4) {
    i11 = 18;
    break;
   }
   i2 = mftCall_iiiii(HEAP32[i4 + 60 >> 2] | 0, i4 | 0, i13 | 0, i14 | 0, 0) | 0;
   if ((i2 | 0) != 0 & (i2 & 255 | 0) == 19) i4 = 0; else {
    i11 = 18;
    break;
   }
  }
  if ((i11 | 0) == 18) return i2 | 0;
 } while (0);
 if (!i3) {
  i15 = 7;
  return i15 | 0;
 }
 while (1) {
  i2 = mftCall_iiiii(HEAP32[i3 + 60 >> 2] | 0, i3 | 0, i13 | 0, i14 | 0, 0) | 0;
  if (!((i2 | 0) != 0 & (i2 & 255 | 0) == 19)) {
   i11 = 18;
   break;
  }
  i4 = HEAP32[i15 >> 2] | 0;
  i1 = HEAP32[((i1 | 0) == 0 ? i12 : i1 + 4 | 0) >> 2] | 0;
  L28 : do if (!i1) {
   i3 = 0;
   i1 = 0;
  } else while (1) {
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i3 + 16 >> 2] | 0) == (i4 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i3 = 0;
    i1 = 0;
    break L28;
   }
  } while (0);
  if (!i3) {
   i11 = 18;
   break;
  }
 }
 if ((i11 | 0) == 18) return i2 | 0;
 return 0;
}

function __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_(i9, i10, i8, i7, i6, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = (i1 | 0) < (i4 | 0);
 do if ((i4 | 0) < (i3 | 0)) {
  if (i2) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i8 >> 2] = i3;
   i5 = 1;
   i1 = i3;
   break;
  }
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i3;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) < (i3 | 0)) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3;
   i5 = 2;
   i1 = i3;
  } else i5 = 1;
 } else if (i2) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) < (i2 | 0)) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
   i5 = 2;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i5 = 1;
   i1 = i4;
  }
 } else i5 = 0; while (0);
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) < (i1 | 0)) {
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i1 = i5 + 1 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) < (i2 | 0)) {
    HEAP32[i9 >> 2] = i1;
    HEAP32[i10 >> 2] = i2;
    i3 = i5 + 3 | 0;
   } else i3 = i5 + 2 | 0;
  } else i3 = i1;
 } else i3 = i5;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 1 | 0;
  return i10 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 2 | 0;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 3 | 0;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 i10 = i3 + 4 | 0;
 return i10 | 0;
}

function __ZNK9Texture2D9GetPixelsEiiiiiP11ColorRGBA32i(i11, i4, i5, i6, i7, i8, i9, i10) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i14 + 4 | 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i11) | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((i8 | 0) < 0) if (!i11) i1 = 0; else i2 = 6; else if ((HEAP32[i11 + 76 >> 2] | 0) > (i8 | 0)) {
  i1 = i11 + 52 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i10 | 0) >= 0) {
   if (!i2) i3 = 0; else i3 = HEAP32[i2 + 44 >> 2] | 0;
   if ((i3 | 0) > (i10 | 0)) {
    i10 = Math_imul(HEAP32[i2 + 40 >> 2] | 0, i10) | 0;
    i10 = (HEAP32[i2 + 8 >> 2] | 0) + i10 | 0;
    i10 = i10 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 32 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, i8) | 0) | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i13 + 28 >> 2] >> i8;
    i12 = HEAP32[i13 + 32 >> 2] >> i8;
    i13 = __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_(i10, (i11 | 0) < 1 ? 1 : i11, (i12 | 0) < 1 ? 1 : i12, HEAP32[i13 + 36 >> 2] | 0, i4, i5, i6, i7, i9) | 0;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
  if (!i2) i1 = -1; else i1 = (HEAP32[i2 + 44 >> 2] | 0) + -1 | 0;
  HEAP32[i12 >> 2] = i1;
  __Z6FormatPKcz(i13, gb + 416996 | 0, i12);
  if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 410682 | 0, 1266, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } else i2 = 6;
 if ((i2 | 0) == 6) i1 = HEAP32[i11 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 410682 | 0, 1260, 1, i1, 0, 0);
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5physx2Cm10FanoutTask7releaseEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i12 = i13 + 40 | 0;
 i9 = i13 + 44 | 0;
 i10 = i13 + 48 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i13 + 52 | 0;
 HEAP8[i12 >> 0] = 1;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i11 >> 2] = 10;
 i4 = i8 + 88 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i5 = i8 + 76 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i13, i6);
 if (i6 | 0) {
  i1 = i8 + 72 | 0;
  i7 = 0;
  do {
   i2 = (HEAP32[i1 >> 2] | 0) + (i7 << 2) | 0;
   i3 = HEAP32[i10 >> 2] | 0;
   if ((HEAP32[i11 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 >> 2] = i3 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i13, i2) | 0;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i6 | 0));
 }
 HEAP32[i5 >> 2] = 0;
 if (!(HEAP8[i8 + 84 >> 0] | 0)) __ZN5physx6shdfnd15atomicDecrementEPVi(i8 + 12 | 0) | 0; else mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 if (HEAP32[i10 >> 2] | 0) {
  i1 = 0;
  do {
   i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i11 = HEAP32[i11 >> 2] | 0;
 if (!((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0)) {
  STACKTOP = i14;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i13 | 0) == (i1 | 0)) {
  HEAP8[i12 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i14;
 return;
}

function __ZN5physx22PxcContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 264 | 0;
 i8 = i1 + 192 | 0;
 i11 = i1 + 96 | 0;
 i10 = i1;
 i13 = i1 + 120 | 0;
 i12 = i1 + 24 | 0;
 HEAP32[i9 >> 2] = 1065353216;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 1065353216;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 1065353216;
 HEAP32[i9 + 36 >> 2] = 1065353216;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 HEAP32[i9 + 52 >> 2] = 1065353216;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 HEAP32[i9 + 68 >> 2] = 1065353216;
 HEAP32[i8 >> 2] = 1065353216;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 1065353216;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1065353216;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1065353216;
 i4 = __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i4, i9, i11, i13) | 0;
 i5 = __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i5, i8, i10, i12) | 0;
 i7 = __ZL18PxcContactHullHullRKN5physx2Gu13PolygonalDataES3_RKNS_9PxBounds3ES6_RKNS_11PxTransformES9_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESF_bb(i13, i12, i11, i10, i6, i7, Math_fround(HEAPF32[i3 >> 2]), i2, i9, i8, i4, i5) | 0;
 STACKTOP = i1;
 return i7 | 0;
}

function __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram13BufferBindingEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i10 = (HEAP32[i11 + 4 >> 2] | 0) - i2 | 0;
 i12 = (i10 | 0) / 24 | 0;
 if (!i10) return;
 i10 = i1 + 4 | 0;
 i1 = 0;
 while (1) {
  i6 = HEAP32[i2 + (i1 * 24 | 0) + 16 >> 2] | 0;
  do if ((i6 | 0) != -1) {
   i3 = HEAP32[i10 >> 2] | 0;
   if (i3 | 0) {
    i5 = i10;
    L8 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >= (i6 | 0)) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) {
       i4 = i5;
       break L8;
      } else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) break; else i5 = i4;
    }
    if ((i4 | 0) != (i10 | 0)) if ((i6 | 0) >= (HEAP32[i4 + 16 >> 2] | 0)) {
     i8 = i2 + (i1 * 24 | 0) | 0;
     i3 = i4 + 20 | 0;
     if ((i8 | 0) != (i3 | 0)) {
      i7 = HEAP8[i3 + 11 >> 0] | 0;
      i5 = i7 << 24 >> 24 < 0;
      i9 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
      i7 = i5 ? HEAP32[i4 + 24 >> 2] | 0 : i7 & 255;
      i5 = i8 + 11 | 0;
      i3 = HEAP8[i5 >> 0] | 0;
      i4 = i3 << 24 >> 24 < 0;
      if (i4) i6 = (HEAP32[i2 + (i1 * 24 | 0) + 8 >> 2] & 2147483647) + -1 | 0; else i6 = 10;
      if (i7 >>> 0 > i6 >>> 0) {
       if (i4) i2 = HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] | 0; else i2 = i3 & 255;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i8, i6, i7 - i6 | 0, i2, 0, i2, i7, i9);
       break;
      }
      if (i4) i3 = HEAP32[i8 >> 2] | 0; else i3 = i8;
      if (i7 | 0) _memmove(i3 | 0, i9 | 0, i7 | 0) | 0;
      HEAP8[i3 + i7 >> 0] = 0;
      if ((HEAP8[i5 >> 0] | 0) < 0) {
       HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] = i7;
       break;
      } else {
       HEAP8[i5 >> 0] = i7;
       break;
      }
     }
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i12 | 0)) break;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 return;
}

function __ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_(i7, i9, i12, i13, i14, i2, i3, i4, i5, i8) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i6 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = (i10 | 0) == (i12 | 0);
 do if (i11) {
  i1 = (HEAP8[i8 + 24 >> 0] | 0) == i7 << 24 >> 24;
  if (!i1) if ((HEAP8[i8 + 25 >> 0] | 0) != i7 << 24 >> 24) {
   i6 = 5;
   break;
  }
  HEAP32[i13 >> 2] = i12 + 1;
  HEAP8[i12 >> 0] = i1 ? 43 : 45;
  HEAP32[i14 >> 2] = 0;
  i1 = 0;
 } else i6 = 5; while (0);
 L6 : do if ((i6 | 0) == 5) {
  i6 = HEAP8[i3 + 11 >> 0] | 0;
  if (i7 << 24 >> 24 == i2 << 24 >> 24 ? ((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0) != 0 : 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 - i4 | 0) >= 160) {
    i1 = 0;
    break;
   }
   i13 = HEAP32[i14 >> 2] | 0;
   HEAP32[i5 >> 2] = i1 + 4;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i14 >> 2] = 0;
   i1 = 0;
   break;
  }
  i3 = i8 + 26 | 0;
  i2 = 0;
  while (1) {
   i1 = i8 + i2 | 0;
   if ((i2 | 0) == 26) {
    i1 = i3;
    break;
   }
   if ((HEAP8[i1 >> 0] | 0) == i7 << 24 >> 24) break; else i2 = i2 + 1 | 0;
  }
  i1 = i1 - i8 | 0;
  if ((i1 | 0) > 23) i1 = -1; else {
   switch (i9 | 0) {
   case 10:
   case 8:
    {
     if ((i1 | 0) >= (i9 | 0)) {
      i1 = -1;
      break L6;
     }
     break;
    }
   case 16:
    {
     if ((i1 | 0) >= 22) {
      if (i11) {
       i1 = -1;
       break L6;
      }
      if ((i10 - i12 | 0) >= 3) {
       i1 = -1;
       break L6;
      }
      if ((HEAP8[i10 + -1 >> 0] | 0) != 48) {
       i1 = -1;
       break L6;
      }
      HEAP32[i14 >> 2] = 0;
      i1 = HEAP8[gb + 1077991 + i1 >> 0] | 0;
      HEAP32[i13 >> 2] = i10 + 1;
      HEAP8[i10 >> 0] = i1;
      i1 = 0;
      break L6;
     }
     break;
    }
   default:
    {}
   }
   i1 = HEAP8[gb + 1077991 + i1 >> 0] | 0;
   HEAP32[i13 >> 2] = i10 + 1;
   HEAP8[i10 >> 0] = i1;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 76 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 837834 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 76 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
   i9 = i2 + 68 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1 + 68 | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 76 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 76 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj430ES3_RKNS_18PxJointLinearLimitES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 120 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 196; else i1 = (HEAP32[i1 >> 2] | 0) + 196 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj430ES2_RKNS_18PxJointLinearLimitES6_EEKNS_31PxJointLinearLimitGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __Z23GUIDToStringWithHyphensRK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3;
 i14 = i3 + 92 | 0;
 i4 = i3 + 80 | 0;
 i5 = i3 + 68 | 0;
 i6 = i3 + 56 | 0;
 i7 = i3 + 44 | 0;
 i8 = i3 + 32 | 0;
 i9 = i3 + 20 | 0;
 __Z12GUIDToStringRK9UnityGUIDPc(i2, i14);
 HEAP8[i14 + 32 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i14, _strlen(i14) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i5, i4, 0, 8, i4);
 i14 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i6, i4, 8, 4, i4);
 i13 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i7, i4, 12, 4, i4);
 i12 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i4, 16, 4, i4);
 i11 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i4, 20, 12, i4);
 i2 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 HEAP32[i10 >> 2] = i14;
 HEAP32[i10 + 4 >> 2] = i13;
 HEAP32[i10 + 8 >> 2] = i12;
 HEAP32[i10 + 12 >> 2] = i11;
 HEAP32[i10 + 16 >> 2] = i2;
 __Z6FormatPKcz(i1, gb + 488698 | 0, i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi(i11, i4, i5, i6, i7, i8, i9, i10) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i14 + 4 | 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) {
  i13 = 1;
  STACKTOP = i14;
  return i13 | 0;
 }
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i11) | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((i8 | 0) < 0) if (!i11) i1 = 0; else i2 = 6; else if ((HEAP32[i11 + 76 >> 2] | 0) > (i8 | 0)) {
  i1 = i11 + 52 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i10 | 0) >= 0) {
   if (!i2) i3 = 0; else i3 = HEAP32[i2 + 44 >> 2] | 0;
   if ((i3 | 0) > (i10 | 0)) {
    i10 = Math_imul(HEAP32[i2 + 40 >> 2] | 0, i10) | 0;
    i10 = (HEAP32[i2 + 8 >> 2] | 0) + i10 | 0;
    i10 = i10 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 32 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, i8) | 0) | 0;
    i13 = HEAP32[i1 >> 2] | 0;
    i11 = HEAP32[i13 + 28 >> 2] >> i8;
    i12 = HEAP32[i13 + 32 >> 2] >> i8;
    i13 = __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i10, (i11 | 0) < 1 ? 1 : i11, (i12 | 0) < 1 ? 1 : i12, HEAP32[i13 + 36 >> 2] | 0, i4, i5, i6, i7, i9) | 0;
    STACKTOP = i14;
    return i13 | 0;
   }
  }
  if (!i2) i1 = -1; else i1 = (HEAP32[i2 + 44 >> 2] | 0) + -1 | 0;
  HEAP32[i12 >> 2] = i1;
  __Z6FormatPKcz(i13, gb + 416996 | 0, i12);
  if (!i11) i1 = 0; else i1 = HEAP32[i11 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i13 + 11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, 0, gb + 410682 | 0, 1238, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } else i2 = 6;
 if ((i2 | 0) == 6) i1 = HEAP32[i11 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 410682 | 0, 1232, 1, i1, 0, 0);
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5physx2Gu4BoxV6createERKNS0_8CapsuleVE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i10 = HEAP32[i1 + 128 >> 2] | 0;
 _memmove(i2 | 0, i1 | 0, 16) | 0;
 f5 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f9 = Math_fround(f5 - f9);
 f8 = Math_fround(f6 - f8);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 104 >> 2]));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f4 * f4)))));
 f9 = Math_fround(f9 * f6);
 f8 = Math_fround(f8 * f6);
 f6 = Math_fround(f4 * f6);
 HEAPF32[i2 + 96 >> 2] = f9;
 HEAPF32[i2 + 100 >> 2] = f8;
 HEAPF32[i2 + 104 >> 2] = f6;
 HEAPF32[i2 + 108 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 144 >> 2] = i10;
 HEAP32[i2 + 148 >> 2] = i10;
 HEAP32[i2 + 152 >> 2] = i10;
 HEAPF32[i2 + 156 >> 2] = Math_fround(0.0);
 f4 = Math_fround(-f8);
 f5 = Math_fround(-f6);
 f7 = Math_fround(-f9);
 f3 = Math_fround(Math_abs(Math_fround(f9)));
 i10 = f6 >= f3 & (f8 >= f3 & f9 >= f3);
 f3 = Math_fround(Math_abs(Math_fround(f8)));
 i1 = f6 >= f3 & (f8 >= f3 & f9 >= f3);
 f3 = i1 ? Math_fround(0.0) : f6;
 f5 = i1 ? f5 : Math_fround(0.0);
 f3 = i10 ? f4 : f3;
 f5 = i10 ? f9 : f5;
 f7 = i10 ? Math_fround(0.0) : i1 ? f8 : f7;
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(Math_fround(f3 * f3) + Math_fround(f5 * f5))))));
 f3 = Math_fround(f4 * f3);
 f5 = Math_fround(f4 * f5);
 f7 = Math_fround(f4 * f7);
 HEAPF32[i2 + 112 >> 2] = f3;
 HEAPF32[i2 + 116 >> 2] = f5;
 HEAPF32[i2 + 120 >> 2] = f7;
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 f4 = Math_fround(Math_fround(f6 * f3) - Math_fround(f9 * f7));
 f3 = Math_fround(Math_fround(f9 * f5) - Math_fround(f8 * f3));
 HEAPF32[i2 + 128 >> 2] = Math_fround(Math_fround(f8 * f7) - Math_fround(f6 * f5));
 HEAPF32[i2 + 132 >> 2] = f4;
 HEAPF32[i2 + 136 >> 2] = f3;
 HEAPF32[i2 + 140 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i7 + 284 >> 2] | 0) + (i4 * 12 | 0) + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 i1 = i7 + 344 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i7 + 364 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i15 = i7 + 332 | 0;
  i10 = i2 << 1;
  i16 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i8 + 1 | 0, i2 << 5, gb + 681489 | 0, 1659) | 0;
  i9 = i16 + (i10 << 2) | 0;
  i13 = i16 + (i2 << 2 << 2) | 0;
  i11 = i16 + (i2 * 6 << 2) | 0;
  _memcpy(i16 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i7 + 336 >> 2] << 2 | 0) | 0;
  i14 = i7 + 340 | 0;
  _memcpy(i9 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  i12 = i7 + 356 | 0;
  _memcpy(i13 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i7 + 360 >> 2] << 2 | 0) | 0;
  i2 = i7 + 348 | 0;
  _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 + 352 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, HEAP32[i15 >> 2] | 0);
  HEAP32[i15 >> 2] = i16;
  HEAP32[i14 >> 2] = i9;
  HEAP32[i12 >> 2] = i13;
  HEAP32[i2 >> 2] = i11;
  HEAP32[i3 >> 2] = i10;
  i2 = i9;
  i3 = HEAP32[i1 >> 2] | 0;
  i3 = i2 + (i3 << 2) | 0;
  HEAP32[i3 >> 2] = i4;
  i4 = HEAP32[i1 >> 2] | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i5 >> 2] = -1;
  i6 = i7 + 456 + (i6 << 2) | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 477 | 0;
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 } else {
  i15 = HEAP32[i7 + 340 >> 2] | 0;
  i16 = i2;
  i16 = i15 + (i16 << 2) | 0;
  HEAP32[i16 >> 2] = i4;
  i16 = HEAP32[i1 >> 2] | 0;
  i16 = i16 + 1 | 0;
  HEAP32[i1 >> 2] = i16;
  HEAP32[i5 >> 2] = -1;
  i16 = i7 + 456 + (i6 << 2) | 0;
  i15 = HEAP32[i16 >> 2] | 0;
  i15 = i15 + -1 | 0;
  HEAP32[i16 >> 2] = i15;
  i16 = i7 + 477 | 0;
  HEAP8[i16 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
}

function __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = i6 + 104;
 i4 = i6 + 128 | 0;
 i5 = i6 + 132 | 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4); else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i1, HEAP32[i5 >> 2] | 0);
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 24, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i4 >> 2] = i1;
 }
 __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i6 + 140 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i7, i6 + 80 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags(i7, i6 + 156 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 172 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i7, i6 + 192 | 0, 0);
 i1 = i6 + 152 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEEEvRT_17TransferMetaFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i2, 0);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, HEAP32[gb + 37008 >> 2] | 0, i6, i2, 0);
 i5 = i1 + 16 | 0;
 i3 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i7 = i2 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, HEAP32[gb + 37224 >> 2] | 0, gb + 367250 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 367266 | 0, gb + 455698 | 0, i7, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i7, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 367282 | 0, HEAP32[gb + 37228 >> 2] | 0, i2 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i4 + 8 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i6, i4 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_110Connection14createRendererEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 136 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3;
  STACKTOP = i5;
  return i4 | 0;
 }
 i3 = i4 + 16 | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i4 + 32 >> 2] | 0;
 i7 = HEAP32[i4 + 60 >> 2] | 0;
 i6 = HEAP32[i4 + 28 >> 2] | 0;
 i11 = i4 + 24 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 16 >> 2] | 0, i12 | 0) | 0;
 i12 = i4 + 64 | 0;
 i4 = i12;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, 1, 0) | 0;
 i8 = getTempRet0() | 0;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i8;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0);
 i8 = __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i10, i9, i7, i6, i4, i8) | 0;
 i4 = __ZN5physx8debugger8renderer15PvdUserRenderer6createERNS_19PxAllocatorCallbackEj(HEAP32[i3 >> 2] | 0, 8192) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, 16, gb + 776600 | 0, gb + 773844 | 0, 636) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 150428 + 8;
 HEAP32[i6 + 4 >> 2] = i3;
 i3 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = i8;
 i7 = i6 + 12 | 0;
 HEAP32[i7 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 84 >> 2] | 0, i8 | 0);
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 775887;
 HEAP32[i1 + 4 >> 2] = gb + 776554;
 mftCall_iiii(i9 | 0, i8 | 0, i1 | 0, i7 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0);
 HEAP32[i2 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw(i7, i9, i12, i13, i14, i2, i3, i4, i5, i8) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i6 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i13 >> 2] | 0;
 i11 = (i10 | 0) == (i12 | 0);
 do if (i11) {
  i1 = (HEAP32[i8 + 96 >> 2] | 0) == (i7 | 0);
  if (!i1) if ((HEAP32[i8 + 100 >> 2] | 0) != (i7 | 0)) {
   i6 = 5;
   break;
  }
  HEAP32[i13 >> 2] = i12 + 1;
  HEAP8[i12 >> 0] = i1 ? 43 : 45;
  HEAP32[i14 >> 2] = 0;
  i1 = 0;
 } else i6 = 5; while (0);
 L6 : do if ((i6 | 0) == 5) {
  i6 = HEAP8[i3 + 11 >> 0] | 0;
  if ((i7 | 0) == (i2 | 0) ? ((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0) != 0 : 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 - i4 | 0) >= 160) {
    i1 = 0;
    break;
   }
   i13 = HEAP32[i14 >> 2] | 0;
   HEAP32[i5 >> 2] = i1 + 4;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i14 >> 2] = 0;
   i1 = 0;
   break;
  }
  i3 = i8 + 104 | 0;
  i2 = 0;
  while (1) {
   i1 = i8 + (i2 << 2) | 0;
   if ((i2 | 0) == 26) {
    i1 = i3;
    break;
   }
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i1 = i1 - i8 | 0;
  i2 = i1 >> 2;
  if ((i1 | 0) > 92) i1 = -1; else {
   switch (i9 | 0) {
   case 10:
   case 8:
    {
     if ((i2 | 0) >= (i9 | 0)) {
      i1 = -1;
      break L6;
     }
     break;
    }
   case 16:
    {
     if ((i1 | 0) >= 88) {
      if (i11) {
       i1 = -1;
       break L6;
      }
      if ((i10 - i12 | 0) >= 3) {
       i1 = -1;
       break L6;
      }
      if ((HEAP8[i10 + -1 >> 0] | 0) != 48) {
       i1 = -1;
       break L6;
      }
      HEAP32[i14 >> 2] = 0;
      i1 = HEAP8[gb + 1077991 + i2 >> 0] | 0;
      HEAP32[i13 >> 2] = i10 + 1;
      HEAP8[i10 >> 0] = i1;
      i1 = 0;
      break L6;
     }
     break;
    }
   default:
    {}
   }
   i1 = HEAP8[gb + 1077991 + i2 >> 0] | 0;
   HEAP32[i13 >> 2] = i10 + 1;
   HEAP8[i10 >> 0] = i1;
   HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
   i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx2Sn18writeAllPropertiesINS_18PxVehicleDriveTankEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i4, i5, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 212 | 0;
 i14 = i7 + 184 | 0;
 i10 = i7 + 44 | 0;
 i9 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i13 = i6;
 i12 = i5;
 i11 = i4;
 i4 = i2;
 i5 = i3;
 __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i11;
 HEAP32[i15 + 12 >> 2] = i4;
 HEAP32[i15 + 16 >> 2] = i5;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i3 = __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i10, i15, 0) | 0;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i4;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i10, i14, i3) | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j(i10, i9, 0) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i15 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Gu10computeMTDERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos6FloatVERNS9_5Vec3VE(i1, i6, i2, i5, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 32 | 0;
 i7 = i8 + 16 | 0;
 i3 = i8;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i1, i6, i2, i9, i3, i7) | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = HEAP32[i2 + 32 >> 2] | 0;
 f20 = Math_fround(HEAPF32[i9 >> 2]);
 f15 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f16 = Math_fround(HEAPF32[i9 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f17 = Math_fround(Math_fround(f16 * f16) + Math_fround(-.5));
 f19 = Math_fround(Math_fround(Math_fround(f20 * f18) + Math_fround(f15 * f12)) + Math_fround(f13 * f14));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f19) + Math_fround(Math_fround(f17 * f12) + Math_fround(f16 * Math_fround(Math_fround(f13 * f18) - Math_fround(f20 * f14))))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * Math_fround(Math_fround(f20 * f12) - Math_fround(f15 * f18)))) + Math_fround(f13 * f19)) * Math_fround(2.0));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f20 * f19) + Math_fround(Math_fround(f18 * f17) + Math_fround(f16 * Math_fround(Math_fround(f15 * f14) - Math_fround(f13 * f12))))) * Math_fround(2.0));
 HEAPF32[i4 + 4 >> 2] = f11;
 HEAPF32[i4 + 8 >> 2] = f10;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i9 = 1;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i11 = i1 + i8 | 0;
 i12 = i1 + (i8 + 4) | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i9 = i7 >>> 24 & 15;
 i6 = (HEAP32[gb + 90260 + 24 + (i9 << 2) >> 2] | 0) + i11 | 0;
 i8 = i1 + (i8 + 8) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP16[((i7 & 1 | 0) == 0 ? i6 + 8 | 0 : i1) >> 1] | 0;
 if (i4) {
  i3 = (i2 & 65535 | i3) & 65535;
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 5; else i2 = i11;
    break;
   }
  default:
   i10 = 5;
  }
  if ((i10 | 0) == 5) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 } else {
  i3 = i2 & ((i3 ^ 65535) & 65535);
  switch (i7 >>> 30 | 0) {
  case 3:
   {
    i2 = i11;
    break;
   }
  case 2:
   {
    if (!(HEAP8[(HEAP32[i11 >> 2] | 0) + 2433 >> 0] | 0)) i10 = 12; else i2 = i11;
    break;
   }
  default:
   i10 = 12;
  }
  if ((i10 | 0) == 12) {
   HEAP16[i5 >> 1] = i3;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   STACKTOP = i13;
   return;
  }
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i9) | 0;
   HEAP32[i8 >> 2] = i1;
  }
  HEAP16[i1 >> 1] = i3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i11);
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 1;
  STACKTOP = i13;
  return;
 }
}

function __ZN23ArchiveStorageConverterC2EP32IArchiveStorageConverterListenerb(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10;
 i5 = i10 + 16 | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i9 >> 2] = i2;
 i1 = i9 + 4 | 0;
 i2 = i9 + 24 | 0;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 64 >> 2] = 0;
 i3 = i1;
 i4 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP16[i1 + 52 >> 1] = 0;
 i11 = gb + 63552 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i9 + 68 >> 2] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 HEAP32[i9 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i8);
 i4 = i7;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i9 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i9 + 88 >> 2] = 0;
 i9 = __ZnwjRK10MemLabelIdiPKci(104, gb + 63552 | 0, 16, gb + 490147 | 0, 28) | 0;
 i3 = gb + 63552 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN24RingBufferMemoryFileDataC2E10MemLabelId(i9, i7);
 HEAP32[i1 >> 2] = i9;
 __ZN24RingBufferMemoryFileData11SetGrowableEb(i9, 1);
 i9 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63552 | 0, 16, gb + 490147 | 0, 35) | 0;
 i4 = gb + 63552 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i5;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission(i9, i7, i8, 0);
 HEAP32[i2 >> 2] = i9;
 i1 = HEAP32[i1 >> 2] | 0;
 i9 = i1 + 4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (HEAP32[i9 >> 2] | 0) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = i1 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = HEAP32[i2 + 20 >> 2] | 0;
  i9 = (i9 | 0) == 0 ? i2 + 4 | 0 : i9;
  i7 = i11;
  i2 = i1;
  L3 : while (1) {
   i1 = i2;
   while (1) {
    i8 = HEAP32[i1 + 36 >> 2] | 0;
    i2 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    L7 : do if (!i2) i12 = 6; else {
     i6 = i9;
     i3 = (i3 | 0) == 0 ? i1 + 20 | 0 : i3;
     while (1) {
      i4 = HEAP8[i3 >> 0] | 0;
      i5 = HEAP8[i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i12 = 6;
       break L7;
      } else {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
      }
     }
     i2 = (i4 & 255) - (i5 & 255) | 0;
    } while (0);
    if ((i12 | 0) == 6) {
     i12 = 0;
     i2 = i8 - i10 | 0;
    }
    if ((i2 | 0) >= 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = i1;
    break;
   } else i7 = i1;
  }
  if ((i7 | 0) != (i11 | 0)) {
   i2 = HEAP32[i7 + 16 >> 2] | 0;
   i6 = HEAP32[i7 + 36 >> 2] | 0;
   i1 = i10 >>> 0 > i6 >>> 0 ? i6 : i10;
   L20 : do if (!i1) i12 = 16; else {
    i5 = (i2 | 0) == 0 ? i7 + 20 | 0 : i2;
    i2 = i9;
    while (1) {
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = HEAP8[i5 >> 0] | 0;
     if (i3 << 24 >> 24 != i4 << 24 >> 24) break;
     i1 = i1 + -1 | 0;
     if (!i1) {
      i12 = 16;
      break L20;
     } else {
      i5 = i5 + 1 | 0;
      i2 = i2 + 1 | 0;
     }
    }
    i1 = (i3 & 255) - (i4 & 255) | 0;
   } while (0);
   if ((i12 | 0) == 16) i1 = i10 - i6 | 0;
   if ((i1 | 0) >= 0) {
    i12 = i7;
    return i12 | 0;
   }
  }
 }
 i12 = i11;
 return i12 | 0;
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[i3 + 200 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i13 + (i1 * 12 | 0) >> 2]);
 f7 = Math_fround(HEAPF32[i13 + (i1 * 12 | 0) + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i13 + (i1 * 12 | 0) + 8 >> 2]);
 f12 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 96 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 112 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 128 >> 2])));
 f9 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 100 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 116 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 132 >> 2])));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i3 + 104 >> 2]));
 f7 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 120 >> 2])));
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 136 >> 2])));
 f7 = Math_fround(HEAPF32[i8 + 48 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 32 >> 2])));
 f5 = Math_fround(f12 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 20 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 36 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i8 + 8 >> 2]));
 f9 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 24 >> 2])));
 f5 = Math_fround(f11 + f5);
 f4 = Math_fround(f10 + Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 40 >> 2]))));
 HEAPF32[i2 >> 2] = Math_fround(f7 + f6);
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i5, i6, i8, i10, i2, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i5 + 8 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i7 = i5 + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 i9 = Math_imul(HEAP32[i6 + 4 >> 2] | 0, i8) | 0;
 i4 = i6 + 8 | 0;
 i3 = i6 + 12 | 0;
 i1 = i6 + 20 | 0;
 i9 = (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i10) | 0) + i9 | 0;
 i9 = (HEAP32[i6 >> 2] | 0) + i9 | 0;
 i4 = HEAP32[i4 >> 2] >> i10;
 i4 = (i4 | 0) < 1 ? 1 : i4;
 i3 = HEAP32[i3 >> 2] >> i10;
 i3 = (i3 | 0) < 1 ? 1 : i3;
 L7 : do if (i2) {
  i1 = HEAP32[i1 >> 2] | 0;
  do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
   i2 = i1 + -30 | 0;
   if (i2 >>> 0 < 15) if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break; else break L7; else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break; else break L7;
  } while (0);
  i6 = __Z21SourceMipLevelForBlitiiii(HEAP32[i13 >> 2] | 0, HEAP32[i7 >> 2] | 0, i4, i3) | 0;
  i10 = (HEAP32[i5 + 24 >> 2] | 0) + -1 | 0;
  i6 = (i10 | 0) < (i6 | 0) ? i10 : i6;
  i10 = i5 + 20 | 0;
  i11 = __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i13 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i10 >> 2] | 0, i6) | 0;
  i12 = HEAP32[i13 >> 2] >> i6;
  i13 = HEAP32[i7 >> 2] >> i6;
  __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib(HEAP32[i10 >> 2] | 0, (HEAP32[i5 >> 2] | 0) + ((Math_imul(HEAP32[i5 + 4 >> 2] | 0, i8) | 0) + i11) | 0, (i12 | 0) < 1 ? 1 : i12, (i13 | 0) < 1 ? 1 : i13, i9, i4, i3, 1);
  STACKTOP = i14;
  return;
 } while (0);
 __ZN11TextureData17GetImageReferenceEii(i12, i6, i8, i10);
 __ZN9TextureOpI11TextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i5, i12, i11 ? 2 : 0, 1, i8) | 0;
 STACKTOP = i14;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0;
 i13 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = 1 - i1 | 0;
 i16 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f15 = Math_fround(HEAPF32[i16 + (i1 << 4) >> 2]);
 f9 = Math_fround(HEAPF32[i16 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i1 << 4) + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i13 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 52 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 56 >> 2]);
 f10 = Math_fround(f15 * Math_fround(HEAPF32[i13 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 32 >> 2])));
 f12 = Math_fround(f15 * Math_fround(HEAPF32[i13 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 36 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i13 + 8 >> 2]));
 f9 = Math_fround(f15 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 24 >> 2])));
 f10 = Math_fround(f14 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f8 + Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 40 >> 2]))));
 i2 = 1 - i2 | 0;
 i6 = (HEAP32[i6 + 8 >> 2] | 0) + 96 | 0;
 f9 = Math_fround(HEAPF32[i6 + (i2 << 4) >> 2]);
 f8 = Math_fround(HEAPF32[i6 + (i2 << 4) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + (i2 << 4) + 8 >> 2]);
 i6 = HEAP32[i6 + (i2 << 4) + 12 >> 2] | 0;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAP32[i5 + 12 >> 2] = i6;
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i5 = i10 + 16 | 0;
 i3 = i10 + 8 | 0;
 i2 = i10;
 i6 = i10 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 1084495 | 0, i2) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i3 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 1084495 | 0, i3) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i5 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 1084495 | 0, i5) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1086395 | 0, 1) | 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 i9 = i6;
 i11 = i9 + 128 | 0;
 do {
  HEAP8[i9 >> 0] = 0;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i6, 128, gb + 1084495 | 0, i8) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  STACKTOP = i10;
  return i7 | 0;
 }
 i11 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 mftCall_iiii(i11 | 0, i7 | 0, i6 | 0, _strlen(i6) | 0) | 0;
 STACKTOP = i10;
 return i7 | 0;
}

function __ZN5physx3Scb4Body18putToSleepInternalEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 >>> 30;
 switch (i2 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2432 >> 0] | 0)) i4 = 3;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  HEAP32[i5 + 232 >> 2] = 1;
  i4 = i5 + 204 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = 0;
  __ZN5physx2Sc8BodyCore10putToSleepEv(i5 + 16 | 0);
  return;
 }
 HEAP32[i5 + 232 >> 2] = 1;
 HEAPF32[i5 + 228 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 204 >> 2] = 0;
 HEAP32[i5 + 208 >> 2] = 0;
 HEAP32[i5 + 212 >> 2] = 0;
 switch (i2 | 0) {
 case 3:
  {
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = 8;
   break;
  }
 case 2:
  {
   i2 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i2 + 2432 >> 0] | 0)) i4 = 7; else i4 = 8;
   break;
  }
 default:
  i4 = 7;
 }
 if ((i4 | 0) == 7) {
  HEAP32[i5 + 96 >> 2] = 0;
  HEAP32[i5 + 100 >> 2] = 0;
  HEAP32[i5 + 104 >> 2] = 0;
 } else if ((i4 | 0) == 8) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i2, i5);
  i1 = i5 + 236 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1048576;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i5 + 216 >> 2] = 0;
 HEAP32[i5 + 220 >> 2] = 0;
 HEAP32[i5 + 224 >> 2] = 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = 13;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i4 = 12; else i4 = 13;
   break;
  }
 default:
  i4 = 12;
 }
 if ((i4 | 0) == 12) {
  HEAP32[i5 + 112 >> 2] = 0;
  HEAP32[i5 + 116 >> 2] = 0;
  HEAP32[i5 + 120 >> 2] = 0;
  i2 = i5 + 236 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 } else if ((i4 | 0) == 13) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i5);
  i1 = i5 + 236 | 0;
  i2 = HEAP32[i1 >> 2] | 2097152;
  HEAP32[i1 >> 2] = i2;
 }
 HEAP32[i1 >> 2] = i2 & -253953;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i5);
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -29360129 | 12582912;
 return;
}

function __ZL18MouseButtonHandleriPK20EmscriptenMouseEventPv(i5, i9, i1) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = __Z15GetInputManagerv() | 0;
 switch (HEAP16[i9 + 40 >> 1] | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 1:
  {
   i1 = 2;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 3;
 }
 __ZN12InputManager11SetKeyStateEib(i2, i1 + 323 | 0, (i5 | 0) != 6);
 HEAP32[i7 + 44 >> 2] = 0;
 __ZN10InputEvent4InitEi(i7, 0);
 HEAP32[i7 + 20 >> 2] = i1;
 i1 = i9 + 60 | 0;
 f10 = Math_fround(HEAP32[i1 >> 2] | 0);
 i3 = i9 + 64 | 0;
 f4 = Math_fround(HEAP32[i3 >> 2] | 0);
 HEAPF32[i7 + 4 >> 2] = f10;
 HEAPF32[i7 + 8 >> 2] = f4;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 1;
 if ((i5 | 0) == 5) {
  f4 = Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
  HEAP32[i7 >> 2] = 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[gb + 1103812 >> 2] | 0) ? (i1 | 0) == (HEAP32[gb + 1103816 >> 2] | 0) : 0) if (Math_fround(f4 - Math_fround(HEAPF32[gb + 1103820 >> 2])) <= Math_fround(1.0)) HEAP32[i6 >> 2] = (HEAP32[gb + 1103824 >> 2] | 0) + 1;
  HEAP32[gb + 1103812 >> 2] = i2;
  HEAP32[gb + 1103816 >> 2] = i1;
  HEAP32[gb + 1103824 >> 2] = HEAP32[i6 >> 2];
  HEAPF32[gb + 1103820 >> 2] = f4;
 } else HEAP32[i7 >> 2] = 1;
 if (HEAP32[i9 + 24 >> 2] | 0) {
  i6 = i7 + 24 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
 }
 if (HEAP32[i9 + 28 >> 2] | 0) {
  i6 = i7 + 24 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
 }
 if (HEAP32[i9 + 32 >> 2] | 0) {
  i6 = i7 + 24 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
 }
 if (!(HEAP32[i9 + 36 >> 2] | 0)) {
  i9 = __Z18GetGUIEventManagerv() | 0;
  __ZN15GUIEventManager10QueueEventERK10InputEvent(i9, i7);
  __ZN10InputEventD2Ev(i7);
  STACKTOP = i8;
  return 0;
 }
 i9 = i7 + 24 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 8;
 i9 = __Z18GetGUIEventManagerv() | 0;
 __ZN15GUIEventManager10QueueEventERK10InputEvent(i9, i7);
 __ZN10InputEventD2Ev(i7);
 STACKTOP = i8;
 return 0;
}

function __ZN8GUILayer14RenderGUILayerE5RectTIfEjR17ShaderPassContext(i1, i7, i8, i9) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 32 | 0;
 i1 = i12 + 24 | 0;
 i11 = i12;
 i2 = i12 + 20 | 0;
 i3 = i12 + 16 | 0;
 __ZN11delayed_setI4PPtrI10GUIElementENSt3__23setIS2_NS3_4lessIS2_EE11memory_poolIS2_EEEE13apply_delayedEv(HEAP32[gb + 1114500 >> 2] | 0);
 i4 = HEAP32[gb + 1114500 >> 2] | 0;
 if (!(HEAP32[i4 + 8 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 >> 2] = i4 + 4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEC2INS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEET_NS_9enable_ifIXaasr21__is_forward_iteratorISG_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISG_E9referenceEEE5valueESG_E4typeE(i11, i1, i10);
 i4 = HEAP32[i11 >> 2] | 0;
 i6 = i11 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i10 >> 2] = fb + 548;
 __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i4, i3, i10);
 i3 = __Z12GetGfxDevicev() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i3 | 0, 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (1 << HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 48 >> 2] & i8 | 0) mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, i7 | 0, i9 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i5 | 0));
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i3 | 0, i4 | 0);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn5ConvX7convertERNS_13PxInputStreamEjRNS_14PxOutputStreamE(i10, i8, i7, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 24 | 0;
 i11 = i13 + 16 | 0;
 i3 = i13 + 8 | 0;
 i2 = i13;
 i1 = i13 + 31 | 0;
 i4 = i13 + 30 | 0;
 i5 = i13 + 29 | 0;
 i6 = i13 + 28 | 0;
 if (HEAP32[i10 + 4 >> 2] | 0) if (HEAP32[i10 + 8 >> 2] | 0) {
  __ZN5physx2Sn5ConvX16resetConvexFlagsEv(i10);
  __ZN5physx2Sn5ConvX13resetNbErrorsEv(i10);
  if (!(HEAP8[i10 + 340 >> 0] | 0)) {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  if (!i7) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 668184 | 0, 107, gb + 668369 | 0, i3);
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i7 + 128 | 0, gb + 668184 | 0, 112) | 0;
  i2 = i1 + 128 & -128;
  if ((mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i2 | 0, i7 | 0) | 0) != (i7 | 0)) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 668184 | 0, 118, gb + 668426 | 0, i11);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i10, 1, gb + 668489 | 0, i12);
  if (__ZN5physx2Sn5ConvX10initOutputERNS_14PxOutputStreamE(i10, i9) | 0) {
   i12 = __ZN5physx2Sn5ConvX7convertEPKvi(i10, i2, i7) | 0;
   __ZN5physx2Sn5ConvX11closeOutputEv(i10);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1);
   STACKTOP = i13;
   return i12 | 0;
  } else {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i1);
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 668184 | 0, 94, gb + 668284 | 0, i2);
 i12 = 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5Umbra15OcclusionBuffer7combineERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 i3 = i2 + 15 & -16;
 i4 = i3;
 i1 = HEAP8[i4 + 1412 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i2 = i5 + 1412 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  __ZN5Umbra18ImpOcclusionBuffer7combineERKS0_(i5, i4);
  return;
 }
 HEAP8[i2 >> 0] = i1;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i5 + 32 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i5 + 36 >> 2] = HEAP32[i4 + 36 >> 2];
 HEAP32[i5 + 40 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i4 + 44 >> 2];
 HEAP32[i5 + 48 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i4 + 52 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i4 + 56 >> 2];
 HEAP32[i5 + 60 >> 2] = HEAP32[i4 + 60 >> 2];
 HEAP32[i5 + 64 >> 2] = HEAP32[i4 + 64 >> 2];
 HEAP32[i5 + 68 >> 2] = HEAP32[i4 + 68 >> 2];
 HEAP32[i5 + 72 >> 2] = HEAP32[i4 + 72 >> 2];
 HEAP32[i5 + 76 >> 2] = HEAP32[i4 + 76 >> 2];
 HEAP32[i5 + 80 >> 2] = HEAP32[i4 + 80 >> 2];
 HEAP32[i5 + 84 >> 2] = HEAP32[i4 + 84 >> 2];
 HEAP32[i5 + 88 >> 2] = HEAP32[i4 + 88 >> 2];
 HEAP32[i5 + 92 >> 2] = HEAP32[i4 + 92 >> 2];
 HEAP32[i5 + 96 >> 2] = HEAP32[i4 + 96 >> 2];
 HEAP32[i5 + 100 >> 2] = HEAP32[i4 + 100 >> 2];
 HEAP32[i5 + 104 >> 2] = HEAP32[i4 + 104 >> 2];
 HEAP32[i5 + 108 >> 2] = HEAP32[i4 + 108 >> 2];
 HEAP32[i5 + 112 >> 2] = HEAP32[i4 + 112 >> 2];
 HEAP32[i5 + 116 >> 2] = HEAP32[i4 + 116 >> 2];
 HEAP32[i5 + 120 >> 2] = HEAP32[i4 + 120 >> 2];
 HEAP32[i5 + 124 >> 2] = HEAP32[i4 + 124 >> 2];
 _memcpy(i5 + 128 | 0, i4 + 128 | 0, 1276) | 0;
 i2 = i5 + 1408 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 + 1416 >> 2] = HEAP32[i4 + 1416 >> 2];
 i1 = i4 + 1408 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i5 = i5 + 1424 | 0;
 HEAP32[i2 >> 2] = i5;
 _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, 16384) | 0;
 return;
}

function __ZN14SpriteRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 340 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429505 | 0, gb + 450632 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 344 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i6, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429514 | 0, i6, i1 + 360 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 429522 | 0, i6, i1 + 361 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13RenderManagerD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i4 + 68 | 0;
 i3 = i4 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4 + 56 | 0, HEAP32[i4 + 60 >> 2] | 0);
 i3 = i4 + 40 | 0;
 i2 = i4 + 48 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  i6 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZdlPv(i6);
  } while ((i1 | 0) != (i3 | 0));
 }
 i3 = i4 + 28 | 0;
 i2 = i4 + 36 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 32 >> 2] | 0;
  i6 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZdlPv(i6);
  } while ((i1 | 0) != (i3 | 0));
 }
 i3 = i4 + 16 | 0;
 i2 = i4 + 24 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i6 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
  HEAP32[i2 >> 2] = 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZdlPv(i6);
  } while ((i1 | 0) != (i3 | 0));
 }
 i3 = i4 + 4 | 0;
 i2 = i4 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i6 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZdlPv(i6);
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, i16 = 0;
 i13 = HEAP32[i6 + 12 >> 2] | 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) >> 2]);
 f9 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i13 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 52 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 56 >> 2]);
 f10 = Math_fround(f15 * Math_fround(HEAPF32[i13 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 16 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 32 >> 2])));
 f12 = Math_fround(f15 * Math_fround(HEAPF32[i13 + 4 >> 2]));
 f12 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 20 >> 2])));
 f12 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 36 >> 2])));
 f15 = Math_fround(f15 * Math_fround(HEAPF32[i13 + 8 >> 2]));
 f9 = Math_fround(f15 + Math_fround(f9 * Math_fround(HEAPF32[i13 + 24 >> 2])));
 f10 = Math_fround(f14 + f10);
 f12 = Math_fround(f7 + f12);
 f11 = Math_fround(f8 + Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i13 + 40 >> 2]))));
 i2 = 1 - i2 | 0;
 i6 = (HEAP32[i6 + 8 >> 2] | 0) + 96 | 0;
 f9 = Math_fround(HEAPF32[i6 + (i2 << 4) >> 2]);
 f8 = Math_fround(HEAPF32[i6 + (i2 << 4) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + (i2 << 4) + 8 >> 2]);
 i6 = HEAP32[i6 + (i2 << 4) + 12 >> 2] | 0;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAP32[i5 + 12 >> 2] = i6;
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9Transform8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i7, i6 + 40 | 0, gb + 896768 | 0, 0);
 i1 = i6 + 56 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 72 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (HEAP32[i7 >> 2] & 16384 | 0) return;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i7, i6 + 80 | 0, 0);
 __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 100 | 0, i7);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj432ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 136 | 0;
 i4 = i8 + 24 | 0;
 i6 = i8;
 HEAP8[i6 >> 0] = 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i7, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 248; else i1 = (HEAP32[i1 >> 2] | 0) + 248 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i3 = i7 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj432ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_(i7, (i2 | 0) == 0 ? i5 : i2, i6, i4);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 + 36 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i7 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i7 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN20LocalFileSystemPosix6DeleteER13FileEntryDatab(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i9 = i11 + 1068 | 0;
 i10 = i11 + 8 | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i8 | 0) | 0)) {
  i10 = _unlink(i8) | 0;
  i10 = (i10 | 0) == 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (i1) if (!(mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 88 >> 2] | 0, i7 | 0, i8 | 0) | 0)) {
  HEAP32[i9 >> 2] = 0;
  i4 = i9 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i9 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  i6 = i9 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i12 = i2;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = i6;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0, i7 | 0, i8 | 0, i9 | 0, 0, i2 | 0, 0) | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i3 = i10 + 1040 | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   do {
    HEAP8[i10 >> 0] = 0;
    HEAP32[i3 >> 2] = 0;
    HEAP32[i3 + 4 >> 2] = 0;
    HEAP32[i3 + 8 >> 2] = 0;
    HEAP32[i3 + 12 >> 2] = 0;
    HEAP32[i3 + 16 >> 2] = 0;
    __ZN15FileSystemEntry3SetEPKc(i10, i2);
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) {
     mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i10 | 0, 1) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
    }
    i2 = i2 + 1088 | 0;
   } while ((i2 | 0) != ((HEAP32[i9 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 1088 | 0) | 0));
  }
  if ((HEAP32[i5 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i6);
   HEAP32[i9 >> 2] = 0;
  }
 }
 if (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 88 >> 2] | 0, i7 | 0, i8 | 0) | 0) {
  i12 = _unlink(i8) | 0;
  i12 = (i12 | 0) == 0;
  STACKTOP = i11;
  return i12 | 0;
 } else {
  i12 = _rmdir(i8) | 0;
  i12 = (i12 | 0) == 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 return 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 * 72 | 0, 4) | 0;
  i2 = i3 + (i2 * 72 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    HEAP32[i1 + 40 >> 2] = 1;
    i10 = i1 + 44 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i10 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
    i1 = i1 + 72 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i10 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i10 * 72 | 0) | 0;
 if (!i10) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4math8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i3);
 i6 = i3 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 88 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 48 | 0, i3);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 52 | 0, i3);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i4 + 84 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i4 + 98 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i4 + 99 >> 0] = i1;
 i1 = i4 + 96 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZNK6Camera21ViewportToCameraPointERK8Vector3f(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __Z20InvertMatrix4x4_FullPKfPf(__ZNK6Camera19GetProjectionMatrixEv(i2) | 0, i8) | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f9 - Math_fround(Math_fround(1.0) - f9));
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(Math_fround(1.0) - f7));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 920 >> 2]));
 f3 = Math_fround(f3 / Math_fround(HEAPF32[i2 + 924 >> 2]));
 f3 = Math_fround(f3 - Math_fround(Math_fround(1.0) - f3));
 f4 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 12 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 28 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 44 >> 2])));
 f4 = Math_fround(Math_fround(HEAPF32[i8 + 60 >> 2]) + f4);
 i2 = f4 < Math_fround(0.0);
 f11 = Math_fround(-f4);
 if (!((i2 ? f11 : f4) > Math_fround(1.00000001e-07))) {
  f11 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  HEAPF32[i6 >> 2] = f9;
  i8 = i6 + 4 | 0;
  HEAPF32[i8 >> 2] = f11;
  i8 = i6 + 8 | 0;
  HEAPF32[i8 >> 2] = f5;
  STACKTOP = i10;
  return;
 }
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 f11 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 20 >> 2])));
 f11 = Math_fround(f11 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 36 >> 2])));
 f11 = Math_fround(Math_fround(HEAPF32[i8 + 52 >> 2]) + f11);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i8 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f3 * Math_fround(HEAPF32[i8 + 32 >> 2])));
 f7 = Math_fround(Math_fround(1.0) / f4);
 f11 = Math_fround(f7 * f11);
 f9 = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i8 + 48 >> 2]) + f9));
 HEAPF32[i6 >> 2] = f9;
 i8 = i6 + 4 | 0;
 HEAPF32[i8 >> 2] = f11;
 i8 = i6 + 8 | 0;
 HEAPF32[i8 >> 2] = f5;
 STACKTOP = i10;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE8WriteIntEi(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 if ((i1 | 0) < 0) {
  HEAP8[i6 >> 0] = 45;
  i2 = i6 + 1 | 0;
  i1 = 0 - i1 | 0;
 } else i2 = i6;
 i11 = __ZN9rapidjson8internal6u32toaEjPc(i1, i2) | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i1 = i5 + 12 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + (i11 - i6) | 0;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i10;
  break;
 } while (0);
 if ((i6 | 0) == (i11 | 0)) {
  STACKTOP = i13;
  return 1;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = i2 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i7 = i5 + 1 | 0;
  i8 = i2 + 16 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i7;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i5 >> 0] = i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 STACKTOP = i13;
 return 1;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEEC2ERNS_19PxAllocatorCallbackEjPS2_(i12, i1, i2, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i12 >> 2] = gb + 147848 + 8;
 i8 = i12 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 i7 = i12 + 8 | 0;
 HEAP32[i7 >> 2] = i8;
 i5 = i12 + 12 | 0;
 HEAP32[i5 >> 2] = gb + 773653;
 i9 = i12 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i12 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i12 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 + 28 >> 2] = i8;
 HEAP32[i12 + 32 >> 2] = 0;
 HEAP32[i12 + 36 >> 2] = 0;
 HEAP32[i12 + 40 >> 2] = 0;
 HEAP32[i12 + 44 >> 2] = i2;
 HEAP32[i12 + 72 >> 2] = i3;
 HEAP8[i12 + 76 >> 0] = 0;
 HEAP32[i12 + 80 >> 2] = i7;
 i1 = i2 + 68 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3;
 i6 = (HEAP32[i10 >> 2] | 0) - i4 | 0;
 if (((HEAP32[i11 >> 2] | 0) - i4 | 0) >>> 0 <= i1 >>> 0) {
  i4 = i1 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i5 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) {
    i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
   }
  }
  HEAP32[i9 >> 2] = i2;
  HEAP32[i10 >> 2] = i2 + i6;
  HEAP32[i11 >> 2] = i2 + i4;
 }
 HEAP32[i12 >> 2] = gb + 147876 + 8;
 i11 = i12 + 84 | 0;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i12 + 88 >> 2] = gb + 773688;
 i10 = i12 + 92 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAPF32[i12 + 116 >> 2] = Math_fround(.75);
 HEAP32[i12 + 120 >> 2] = -1;
 HEAP32[i12 + 124 >> 2] = 0;
 HEAP32[i12 + 128 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, 64);
 return;
}

function __ZN5physx27PxClothFabricRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i10, i2, i13, i11, i12, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 60 | 0;
 i1 = i9 + 56 | 0;
 i7 = i9 + 8 | 0;
 i4 = i9 + 16 | 0;
 i6 = i9 + 4 | 0;
 i5 = i9;
 HEAP32[i7 >> 2] = 0;
 i2 = i4;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 if (mftCall_iiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 8 >> 2] | 0, i13 | 0, gb + 674663 | 0, i1 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) HEAP32[i4 >> 2] = _strtoul(i1, i8, 10) | 0;
 }
 __ZN5physx2Sn25readStridedBufferPropertyINS_18PxClothFabricPhaseEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i13, gb + 674675 | 0, i4 + 8 | 0, i7, i4 + 4 | 0, i11);
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i13, gb + 773316 | 0, i4 + 24 | 0, i7, i6, i11);
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i13, gb + 674682 | 0, i4 + 16 | 0, i7, i4 + 12 | 0, i11);
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i13, gb + 674687 | 0, i4 + 20 | 0, i7, i5, i11);
 i8 = i4 + 28 | 0;
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i13, gb + 674703 | 0, i4 + 32 | 0, i7, i8, i11);
 __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE(i13, gb + 674717 | 0, i4 + 36 | 0, i7, i8, i11);
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 80 >> 2] | 0, i12 | 0, i4 | 0) | 0;
 HEAP32[i10 >> 2] = gb + 764826;
 HEAP32[i10 + 4 >> 2] = i12;
 i13 = i10 + 8 | 0;
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx14PxsAABBManager15deleteAggregateEj(i15, i14) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i12 = i14 >>> 1;
 i11 = i15 + 180 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = HEAP32[i2 + (i12 * 1048 | 0) + 1040 >> 2] | 0;
 i13 = i15 + 292 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i3 | 0) != 1073741823) {
  i9 = i15 + 256 | 0;
  i10 = i15 + 248 | 0;
  i4 = i15 + 252 | 0;
  i5 = i15 + 260 | 0;
  i6 = i15 + 268 | 0;
  i7 = i15 + 280 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i8 + (i3 << 2) >> 2] | 0;
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 * 24 | 0) >> 2] = i1;
   HEAP8[(HEAP32[i4 >> 2] | 0) + i3 >> 0] = 0;
   i8 = HEAP32[i9 >> 2] | 0;
   HEAP32[i8 + (i3 << 2) >> 2] = 1073741823;
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] = 1073741823;
   i16 = ~(1 << (i3 & 31));
   i1 = i3 >>> 5;
   i17 = (HEAP32[i6 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & i16;
   i1 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i16;
   if ((i2 | 0) == 1073741823) {
    i1 = i3;
    break;
   } else {
    i1 = i3;
    i3 = i2;
   }
  }
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i13 >> 2] = i1;
 i17 = i15 + 204 | 0;
 HEAP32[(HEAP32[i15 + 200 >> 2] | 0) + (HEAP32[i17 >> 2] << 2) >> 2] = i12;
 HEAP32[i17 >> 2] = (HEAP32[i17 >> 2] | 0) + 1;
 i17 = i2 + (i12 * 1048 | 0) + 1036 | 0;
 i16 = i15 + 216 | 0;
 HEAP32[(HEAP32[i15 + 212 >> 2] | 0) + (HEAP32[i16 >> 2] << 2) >> 2] = HEAP32[i17 >> 2];
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
 HEAP32[i17 >> 2] = 1073741823;
 HEAP32[i2 + (i12 * 1048 | 0) + 1040 >> 2] = 1073741823;
 i17 = (HEAP32[i15 + 184 >> 2] | 0) + (i12 << 4) | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 i17 = (HEAP32[i15 + 188 >> 2] | 0) + (i12 << 4) | 0;
 HEAP32[i17 >> 2] = 0;
 HEAP32[i17 + 4 >> 2] = 0;
 HEAP32[i17 + 8 >> 2] = 0;
 HEAP32[i17 + 12 >> 2] = 0;
 i17 = (HEAP32[i15 + 232 >> 2] | 0) + (i14 >>> 6 << 2) | 0;
 HEAP32[i17 >> 2] = HEAP32[i17 >> 2] & ~(1 << (i12 & 31));
 return;
}

function __ZN18ProceduralMaterial7SetDataERK22ProceduralMaterialData(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i8 = i1 + 144 | 0;
 i9 = i1 + 176 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i10 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i6 = i1 + 180 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i4 = (i3 | 0) / 156 | 0;
 if (i3 | 0) {
  if (i4 >>> 0 > 27531841) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i2 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
  } else i5 = i1;
  i1 = __Znwj(i3) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i10 + 8 >> 2] = i1 + (i4 * 156 | 0);
  if ((i2 | 0) != (i5 | 0)) do {
   __ZN14SubstanceInputC2ERKS_(i1, i2);
   i2 = i2 + 156 | 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 156 | 0;
   HEAP32[i11 >> 2] = i1;
  } while ((i2 | 0) != (i5 | 0));
 }
 __ZN22ProceduralMaterialData12CopyFromDataERKS_(i8, i7);
 i7 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i2 = (i7 | 0) / 156 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = ((HEAP32[i11 >> 2] | 0) - i4 | 0) / 156 | 0;
 if (i7 | 0) {
  i1 = 0;
  do {
   if (i1 >>> 0 < i3 >>> 0) {
    i7 = (HEAP32[i9 >> 2] | 0) + (i1 * 156 | 0) + 68 | 0;
    i6 = i4 + (i1 * 156 | 0) + 68 | 0;
    HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 __ZN22ProceduralMaterialData12SyncMaterialEP18ProceduralMaterial(i8, 0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i9 = i2 + -156 | 0;
   HEAP32[i11 >> 2] = i9;
   __ZN14SubstanceInputD2Ev(i9);
   i2 = HEAP32[i11 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 36 | 0) + 1 | 0;
 if (i3 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 36 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 59652323 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 119304647;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 36 | 0) | 0;
 i2 = i4 + (((i2 - i1 | 0) / 36 | 0) * 36 | 0) | 0;
 i5 = i2;
 i8 = i4 + (i3 * 36 | 0) | 0;
 __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i2, i6);
 i6 = i2 + 36 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i7 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -36 | 0;
   __ZN13AvatarBuilder14NamedTransformC2ERKS0_(i2 + -36 | 0, i1);
   i2 = i3 + -36 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i7 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i9 >> 2] = i8;
 i4 = i7;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  i6 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -36 | 0;
   i3 = i2 + -20 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i2 + -8 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -24 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i13;
 return;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i6, i7);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i6 + 40 | 0, i7);
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i6 + 80 | 0, i7);
 i5 = i6 + 120 | 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i5 + 4 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 132 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 136 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 137 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN5Umbra15CameraTransformaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 i3 = i2;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i4 + 32 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i3 + 36 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i3 + 40 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i4 + 48 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i4 + 52 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i4 + 56 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i4 + 60 >> 2] = HEAP32[i3 + 60 >> 2];
 _memcpy(i4 + 64 | 0, i3 + 64 | 0, 276) | 0;
 HEAP32[i4 + 340 >> 2] = HEAP32[i3 + 340 >> 2];
 HEAP32[i4 + 344 >> 2] = HEAP32[i3 + 344 >> 2];
 HEAP32[i4 + 348 >> 2] = HEAP32[i3 + 348 >> 2];
 HEAP32[i4 + 352 >> 2] = HEAP32[i3 + 352 >> 2];
 HEAP32[i4 + 356 >> 2] = HEAP32[i3 + 356 >> 2];
 HEAP32[i4 + 360 >> 2] = HEAP32[i3 + 360 >> 2];
 HEAP32[i4 + 364 >> 2] = HEAP32[i3 + 364 >> 2];
 HEAP32[i4 + 368 >> 2] = HEAP32[i3 + 368 >> 2];
 HEAP32[i4 + 372 >> 2] = HEAP32[i3 + 372 >> 2];
 HEAP32[i4 + 376 >> 2] = HEAP32[i3 + 376 >> 2];
 HEAP32[i4 + 380 >> 2] = HEAP32[i3 + 380 >> 2];
 HEAP32[i4 + 384 >> 2] = HEAP32[i3 + 384 >> 2];
 HEAP32[i4 + 388 >> 2] = HEAP32[i3 + 388 >> 2];
 HEAP32[i4 + 392 >> 2] = HEAP32[i3 + 392 >> 2];
 HEAP32[i4 + 396 >> 2] = HEAP32[i3 + 396 >> 2];
 HEAP32[i4 + 400 >> 2] = HEAP32[i3 + 400 >> 2];
 i2 = i4 + 404 | 0;
 i3 = i3 + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP8[i2 + 32 >> 0] = HEAP8[i3 + 32 >> 0] | 0;
 return i1 | 0;
}

function __ZN17TransformInternal12InitLocalTRSE15TransformAccessRKN4math7_float3ERKNS1_7_float4ES4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0;
 i5 = i1;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i5 + 8 >> 2] | 0;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i10 + (i1 * 40 | 0) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + (i1 * 40 | 0) + 4 >> 2] = i9;
 HEAP32[i10 + (i1 * 40 | 0) + 8 >> 2] = i11;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i10 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + (i1 * 40 | 0) + 16 >> 2] = i11;
 HEAP32[i10 + (i1 * 40 | 0) + 20 >> 2] = i9;
 HEAP32[i10 + (i1 * 40 | 0) + 24 >> 2] = i2;
 i2 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i10 + (i1 * 40 | 0) + 28 >> 2] = i2;
 HEAP32[i10 + (i1 * 40 | 0) + 32 >> 2] = i9;
 HEAP32[i10 + (i1 * 40 | 0) + 36 >> 2] = i3;
 f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i3 = (HEAP32[tempDoublePtr >> 2] = i9 & -2147483648 ^ (i2 & -2147483648 | 1065353216) ^ i3 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
 i4 = ((Math_fround(Math_abs(Math_fround(f6 - f8))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f8 - f7))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f7 - f6))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i3) ^ 1;
 i4 = (i3 << 2 | 3) & ~(i4 << 1) & (i4 & ((Math_fround(Math_abs(Math_fround(f8 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f7 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f6 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
 HEAP32[(HEAP32[i5 + 64 >> 2] | 0) + (i1 << 2) >> 2] = i4;
 return;
}

function __ZN14DetailDatabase9BuildMeshEii8Vector3f16DetailRenderModef(i5, i6, i8, i9, i10, f11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i1 = i14 + 28 | 0;
 i2 = i14 + 24 | 0;
 i3 = i14 + 20 | 0;
 i12 = i14;
 i7 = i14 + 8 | 0;
 if ((HEAP16[gb + 1467644 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467644 | 0, i13);
  i4 = gb + 1467644 | 0;
 } else i4 = 0;
 i1 = (Math_imul(HEAP32[i5 + 36 >> 2] | 0, i8) | 0) + i6 | 0;
 __ZN14DetailDatabase29ComputeVertexAndTriangleCountER11DetailPatch16DetailRenderModefPiS3_(i5, (HEAP32[i5 + 4 >> 2] | 0) + (i1 * 52 | 0) | 0, i10, f11, i3, i2);
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == 0 | (i1 | 0) == 0) i1 = 0; else {
  i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 932993 | 0, 796) | 0;
  i17 = gb + 63520 | 0;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i15 = i12;
  HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i15 + 4 >> 2] = i16;
  HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i3, i13, 0);
  __Z19pop_allocation_rootv();
  i13 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, 4);
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 48 >> 2] | 0, i13 | 0, 61);
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  __ZN14DetailDatabase12GenerateMeshER4Meshii8Vector3f16DetailRenderModefii(i5, i13, i6, i8, i7, i10, f11, i1, i2);
  i1 = i13;
 }
 if (!i4) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i8 + 8 | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (!(HEAP32[i7 >> 2] & 1)) {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i9;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = i7 + 16 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i4 + 4 | 0;
  i5 = i7 + 24 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i8, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 8);
   STACKTOP = i10;
   return;
  }
 } else {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier(__Z20GetPersistentManagerv() | 0, i1, i8);
  i5 = i7 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i7 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i8, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i9, 8);
   STACKTOP = i10;
   return;
  }
 }
}

function __Z44SceneUtility_CUSTOM_GetBuildIndexByScenePathP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 72 | 0;
 i6 = i5 + 68 | 0;
 i4 = i5 + 16 | 0;
 i2 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i4 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNK11ICallStringcv8UnityStrEv(i2, i6);
 i1 = __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo(i2, -1, i4) | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 i2 = i1 ? HEAP32[i4 + 48 >> 2] | 0 : -1;
 i1 = i4 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 i1 = i4 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return i2 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 STACKTOP = i5;
 return i2 | 0;
}

function __ZN5physx3Scb11RigidStatic9syncStateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i6 = i7 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do if (i5 & 1 | 0) {
  i2 = i7 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i7 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  i2 = (HEAP16[i7 + 24 >> 1] & 8) != 0;
  i1 = (HEAP16[i1 >> 1] & 8) != 0;
  if (i1 | i2 ^ 1) {
   if (i2 | i1 ^ 1) break;
   __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb(HEAP32[i7 >> 2] | 0, i7, 0);
   break;
  }
  i1 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & -1073741824 | 0) == -2147483648) {
   i9 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
   i2 = i9 + -16 | 0;
   i3 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i7, i4) | 0;
   __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj(i1 + 16 | 0, (HEAP32[gb + 90260 + 24 + (((HEAP32[i6 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i7 | 0, HEAP32[i4 >> 2] | 0, i3, i9);
   if (i3 | 0) {
    i1 = 0;
    do {
     __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE((HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i2 | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
  }
 } while (0);
 __ZN5physx3Scb11RigidObject9syncStateEv(i7);
 i2 = i7 + 8 | 0;
 if (!(i5 & 64)) {
  HEAP32[i2 >> 2] = 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = i9 & -16777216;
  HEAP32[i6 >> 2] = i9;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i7 >> 2] | 0, (HEAP32[i6 >> 2] | 0) >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 if (!(HEAP32[i6 >> 2] & 64)) {
  HEAP32[i2 >> 2] = 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = i9 & -16777216;
  HEAP32[i6 >> 2] = i9;
  STACKTOP = i8;
  return;
 }
 __ZN5physx2Sc10StaticCore14setActor2WorldERKNS_11PxTransformE(i7 + 16 | 0, i1 + 96 | 0);
 HEAP32[i2 >> 2] = 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = i9 & -16777216;
 HEAP32[i6 >> 2] = i9;
 STACKTOP = i8;
 return;
}

function __ZN20LocalFileSystemPosix6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i6 = i8;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
 i4 = i5 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i10 = i2 << 24 >> 24 < 0;
 i1 = i10 ? HEAP32[i5 >> 2] | 0 : i5;
 i10 = i10 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
 i3 = i1 + i10 | 0;
 if (!i10) i1 = i2; else {
  do {
   if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP8[i4 >> 0] | 0;
 }
 i10 = i1 << 24 >> 24 < 0;
 i3 = i5 + 4 | 0;
 i2 = i10 ? HEAP32[i5 >> 2] | 0 : i5;
 i1 = i2 + (i10 ? HEAP32[i3 >> 2] | 0 : i1 & 255) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   break;
  }
  i1 = i1 + -1 | 0;
  if (!(_memchr(gb + 491589 | 0, HEAPU8[i1 >> 0] | 0, 2) | 0)) {
   i7 = 9;
   break;
  }
 }
 if ((i7 | 0) == 9) i1 = 1 - i2 + i1 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i5, i1, -1) | 0;
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i5, 47, -1) | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i8;
  return i10 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i6, i5, 0, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i7 = HEAP8[i9 + 11 >> 0] | 0;
 i10 = HEAP8[i4 >> 0] | 0;
 i10 = (i7 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i7 & 255) >>> 0 < (i10 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i10 & 255) >>> 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN9ShaderLab16SerializedTagMapaSERKS0_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i10 = i13 + 4 | 0;
 i11 = i13;
 if ((i9 | 0) == (i1 | 0)) {
  STACKTOP = i13;
  return i9 | 0;
 }
 i2 = i9 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i9, HEAP32[i2 >> 2] | 0);
 i12 = i9 + 8 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i4 | 0) == (i7 | 0)) {
  STACKTOP = i13;
  return i9 | 0;
 }
 i6 = i9 + 4 | 0;
 i3 = i4;
 i1 = i4;
 while (1) {
  i4 = i3 + 16 | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  i5 = __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_(i9, i8, i10, i4) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   i3 = __Znwj(24) | 0;
   i15 = i4;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i4 = i3 + 16 | 0;
   HEAP32[i4 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i4 + 4 >> 2] = i14;
   i4 = HEAP32[i10 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = i4;
   HEAP32[i5 >> 2] = i3;
   i4 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i9 >> 2] = i4;
    i3 = HEAP32[i5 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 >> 2] | 0, i3);
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  }
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
    i1 = i3;
    break;
   } else i1 = i3;
  } else {
   i1 = i3;
   while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
  }
  if ((i1 | 0) == (i7 | 0)) break; else i3 = i1;
 }
 STACKTOP = i13;
 return i9 | 0;
}

function __ZNK14SerializedFile13GetAllFileIDsER13dynamic_arrayIxLj8EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = i9 + 36 | 0;
 i1 = ((HEAP32[i11 >> 2] | 0) - (HEAP32[i9 + 32 >> 2] | 0) | 0) / 24 | 0;
 i12 = i10 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i12 >> 2] = i1;
  HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 12 >> 2] << 3 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i10 >> 2] = i8;
  break;
 } while (0);
 i1 = HEAP32[i9 + 32 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i11 >> 2] | 0)) return;
 i7 = i10 + 12 | 0;
 i8 = i10 + 4 | 0;
 do {
  i2 = __ZN6Object13ClassIDToRTTIEi(HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP32[i1 + 16 >> 2] | 0) * 56 | 0) >> 2] | 0) | 0;
  if (i2 | 0) if (HEAP32[i2 + 4 >> 2] | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i12 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i2 = i5 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i12 >> 2] = i2;
     HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 3, 8, i8, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 8, i8, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
     HEAP32[i12 >> 2] = i2;
     HEAP32[i10 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i7 >> 2] = i4;
   i4 = i1;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = (HEAP32[i10 >> 2] | 0) + (i3 << 3) | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (HEAP32[i11 >> 2] | 0));
 return;
}

function __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj(i3, i4, i5, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP8[i5 + (i1 * 148 | 0) + 28 >> 0] = HEAP8[i3 + 112 + i1 >> 0] | 0;
  HEAP32[i5 + (i1 * 148 | 0) + 32 >> 2] = HEAP32[i3 + 116 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 36 >> 2] = HEAP32[i3 + 132 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 40 >> 2] = HEAP32[i3 + 148 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 44 >> 2] = HEAP32[i3 + 164 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 48 >> 2] = HEAP32[i3 + 180 + (i1 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 52 >> 2] = HEAP32[i3 + 180 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 56 >> 2] = HEAP32[i3 + 180 + (i1 * 12 | 0) + 8 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 60 >> 2] = HEAP32[i3 + 228 + (i1 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 64 >> 2] = HEAP32[i3 + 228 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 68 >> 2] = HEAP32[i3 + 228 + (i1 * 12 | 0) + 8 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 72 >> 2] = HEAP32[i3 + 276 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 76 >> 2] = HEAP32[i3 + 292 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 80 >> 2] = HEAP32[i3 + 308 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 84 >> 2] = HEAP32[i3 + 324 + (i1 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 88 >> 2] = HEAP32[i3 + 324 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 92 >> 2] = HEAP32[i3 + 324 + (i1 * 12 | 0) + 8 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 96 >> 2] = HEAP32[i3 + 372 + (i1 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 100 >> 2] = HEAP32[i3 + 372 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 104 >> 2] = HEAP32[i3 + 372 + (i1 * 12 | 0) + 8 >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 108 >> 2] = HEAP32[i3 + 420 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 112 >> 2] = HEAP32[i3 + 436 + (i1 << 2) >> 2];
  HEAP32[i5 + (i1 * 148 | 0) + 116 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN26AnimatorControllerPlayable17GotoStateInternalEiifffb(i9, i1, i10, f3, f11, f12, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 f3 = Math_fround(f3);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 4 | 0;
 i7 = i14;
 i8 = i14 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 >> 2] = i10;
 if (!(__ZNK26AnimatorControllerPlayable17ValidateGoToStateERiS0_(i9, i2, i7) | 0)) {
  STACKTOP = i14;
  return;
 }
 i4 = f3 == Math_fround(-inf);
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = (HEAP32[i9 + 92 >> 2] | 0) + 4 | 0;
 i7 = i6;
 do if (i4) {
  i2 = (HEAP32[i6 >> 2] | 0) + i7 + (i5 << 2) | 0;
  i1 = i9 + 100 | 0;
  i4 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
  i2 = i4 + (HEAP32[i4 >> 2] | 0) + (HEAP32[i2 + (HEAP32[i2 >> 2] | 0) >> 2] << 2) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[((i4 | 0) == 0 ? 0 : i2 + i4 | 0) + 81 >> 0] | 0)) {
   i2 = i8;
   i4 = i2 + 36 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i4 | 0));
   __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i9, i5, 0, i8) | 0;
   if ((HEAP32[i8 + 8 >> 2] | 0) != (i10 | 0)) if ((HEAP32[i8 + 4 >> 2] | 0) != (i10 | 0)) if ((HEAP32[i8 >> 2] | 0) != (i10 | 0)) {
    f3 = Math_fround(0.0);
    break;
   }
   STACKTOP = i14;
   return;
  } else f3 = Math_fround(0.0);
 } else i1 = i9 + 100 | 0; while (0);
 i8 = (HEAP32[i6 >> 2] | 0) + i7 + (i5 << 2) | 0;
 i7 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i8 = i7 + (HEAP32[i7 >> 2] | 0) + (HEAP32[i8 + (HEAP32[i8 >> 2] | 0) >> 2] << 2) | 0;
 HEAP8[i8 + (HEAP32[i8 >> 2] | 0) + 83 >> 0] = 1;
 i9 = HEAP32[(HEAP32[i9 + 96 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 + (i5 * 24 | 0) >> 2] = i10;
 HEAP8[i9 + (i5 * 24 | 0) + 20 >> 0] = i13 & 1;
 HEAPF32[i9 + (i5 * 24 | 0) + 4 >> 2] = i13 ? Math_fround(0.0) : f3;
 HEAPF32[i9 + (i5 * 24 | 0) + 16 >> 2] = i13 ? f3 : Math_fround(0.0);
 HEAPF32[i9 + (i5 * 24 | 0) + 8 >> 2] = f11;
 HEAPF32[i9 + (i5 * 24 | 0) + 12 >> 2] = f12;
 STACKTOP = i14;
 return;
}

function __ZN17PersistentManager21UnloadNonDirtyStreamsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i9 = i1 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i10 = 0;
  i11 = 0;
  HEAP32[i12 >> 2] = i11;
  i11 = i12 + 4 | 0;
  HEAP32[i11 >> 2] = i10;
  _printf_console(gb + 467777 | 0, i12);
  STACKTOP = i13;
  return;
 }
 i10 = i1 + 4 | 0;
 i11 = i1 + 24 | 0;
 i8 = i1 + 40 | 0;
 i7 = 0;
 i1 = 0;
 i2 = 0;
 do {
  i4 = HEAP32[i10 >> 2] | 0;
  i6 = i4 + (i7 * 24 | 0) | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  do if (i5) {
   if (!(HEAP8[i5 + 45 >> 0] | 0)) if (!(HEAP8[i5 + 46 >> 0] | 0)) {
    i4 = i4 + (i7 * 24 | 0) + 16 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     HEAP32[i4 >> 2] = 0;
     i3 = 0;
    } else {
     if (HEAP32[i5 + 12 >> 2] | 0) {
      i2 = i2 + 1 | 0;
      break;
     }
     HEAP32[i4 >> 2] = 0;
     if ((HEAP32[i5 + 16 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
      HEAP32[i5 >> 2] = 0;
      i3 = i5;
     } else i3 = i5;
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63416 | 0);
    i3 = HEAP32[i6 >> 2] | 0;
    if (i3 | 0) {
     __ZN14SerializedFile7ReleaseEv(i3);
     HEAP32[i6 >> 2] = 0;
    }
    i4 = HEAP32[i11 >> 2] | 0;
    i3 = HEAP32[i4 + (i7 * 20 | 0) + 4 >> 2] | 0;
    i4 = i4 + (i7 * 20 | 0) + 8 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -8 - i3 | 0) >>> 3) << 3);
    i4 = HEAP32[i8 >> 2] | 0;
    i3 = HEAP32[i4 + (i7 * 20 | 0) + 4 >> 2] | 0;
    i4 = i4 + (i7 * 20 | 0) + 8 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -8 - i3 | 0) >>> 3) << 3);
    i1 = i1 + 1 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    break;
   }
   i2 = i2 + 1 | 0;
  } while (0);
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < i3 >>> 0);
 HEAP32[i12 >> 2] = i1;
 i11 = i12 + 4 | 0;
 HEAP32[i11 >> 2] = i2;
 _printf_console(gb + 467777 | 0, i12);
 STACKTOP = i13;
 return;
}

function _tt_cmap2_validate(i3, i12) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i5 = i12 + 8 | 0;
 if ((i3 + 4 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 i14 = (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0);
 i13 = i3 + i14 | 0;
 if (i14 >>> 0 < 518 ? 1 : i13 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 i14 = i12 + 12 | 0;
 i1 = 0;
 i11 = 0;
 i2 = i3 + 6 | 0;
 while (1) {
  i10 = HEAPU8[i2 + 1 >> 0] | 0;
  i4 = (HEAPU8[i2 >> 0] | 0) << 8 | i10;
  if (!((HEAP32[i14 >> 2] | 0) >>> 0 < 2 | (i10 & 7 | 0) == 0)) _UNITY_ft_validator_error(i12, 8);
  i10 = i4 >>> 3;
  i11 = i10 >>> 0 > i11 >>> 0 ? i10 : i11;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 256) break; else i2 = i2 + 2 | 0;
 }
 i1 = i3 + 518 | 0;
 i10 = i1 + ((i11 << 3) + 8) | 0;
 if (i10 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i12, 8);
 i9 = i12 + 20 | 0;
 i8 = 0;
 do {
  i3 = (HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0);
  i6 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
  i7 = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
  i2 = i1 + 8 | 0;
  i4 = i1 + 6 | 0;
  i5 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
  if (!i6) i1 = i2; else {
   if ((HEAP32[i14 >> 2] | 0) >>> 0 > 1) if (i3 >>> 0 > 255 | (i6 + i3 | 0) >>> 0 > 256) _UNITY_ft_validator_error(i12, 8);
   if (!i5) i1 = i2; else {
    i3 = i4 + i5 | 0;
    if (i3 >>> 0 < i10 >>> 0) i15 = 19; else if ((i3 + (i6 << 1) | 0) >>> 0 > i13 >>> 0) i15 = 19;
    if ((i15 | 0) == 19) {
     i15 = 0;
     _UNITY_ft_validator_error(i12, 9);
    }
    if (!(HEAP32[i14 >> 2] | 0)) i1 = i2; else {
     i3 = i1 + ((i6 << 1) + 8) | 0;
     while (1) {
      i1 = i2 + 2 | 0;
      i2 = (HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0);
      if (i2 | 0) if ((i2 + i7 & 65535) >>> 0 >= (HEAP32[i9 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i12, 16);
      if (i1 >>> 0 < i3 >>> 0) i2 = i1; else break;
     }
    }
   }
  }
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 <= i11 >>> 0);
 return 0;
}

function __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, i12, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i7 = i12;
 i6 = i8 - i7 | 0;
 i4 = (i6 | 0) / 12 | 0;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i9 = i10;
 if (i4 >>> 0 <= ((i1 - i10 | 0) / 12 | 0) >>> 0) {
  i6 = i5 + 4 | 0;
  i3 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 12 | 0;
  i5 = i4 >>> 0 > i3 >>> 0;
  i4 = i5 ? i12 + (i3 * 12 | 0) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  if (i1 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (((i1 | 0) / 12 | 0) * 12 | 0) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (((i1 >>> 0) / 12 | 0) * 12 | 0);
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -12 - i10 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i3);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if (i4 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = (i1 - i2 | 0) / 12 | 0;
 i1 = i10 << 1;
 i1 = i10 >>> 0 < 178956970 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 357913941;
 if (i1 >>> 0 > 357913941) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i2 = __Znwj(i1 * 12 | 0) | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i11 >> 2] = i2 + (i1 * 12 | 0);
 if ((i6 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i6 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (((i6 >>> 0) / 12 | 0) * 12 | 0);
 return;
}

function __ZN5physx8debugger11StringTable6createERNS_19PxAllocatorCallbackE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 168, gb + 774701 | 0, gb + 774188 | 0, 1336) | 0;
 HEAP32[i2 >> 2] = gb + 148508 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 i4 = i2 + 8 | 0;
 i3 = i1;
 HEAP32[i2 + 12 >> 2] = i3;
 HEAP32[i2 + 16 >> 2] = gb + 774717;
 HEAP32[i4 >> 2] = gb + 148548 + 8;
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(.75);
 HEAP32[i2 + 48 >> 2] = -1;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i4, 64);
 HEAP32[i2 + 60 >> 2] = 1;
 i1 = i2 + 64 | 0;
 HEAP32[i2 + 68 >> 2] = i3;
 HEAP32[i2 + 72 >> 2] = gb + 774743;
 HEAP32[i1 >> 2] = gb + 148564 + 8;
 i4 = i2 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 100 >> 2] = Math_fround(.75);
 HEAP32[i2 + 104 >> 2] = -1;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i2 + 116 | 0;
 HEAP32[i2 + 120 >> 2] = i3;
 HEAP32[i2 + 124 >> 2] = gb + 774773;
 HEAP32[i1 >> 2] = gb + 148580 + 8;
 i3 = i2 + 128 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i2 + 152 >> 2] = Math_fround(.75);
 HEAP32[i2 + 156 >> 2] = -1;
 HEAP32[i2 + 160 >> 2] = 0;
 HEAP32[i2 + 164 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i1, 64);
 return i2 | 0;
}

function __ZN5Unity17ConfigurableJoint17SetTargetPositionERK8Vector3f(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 32 | 0;
 i7 = i9 + 28 | 0;
 i8 = i9;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f12 < Math_fround(340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(340282326000000008404918.0e15);
 i1 = f11 < Math_fround(340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(340282326000000008404918.0e15);
 i1 = f10 < Math_fround(340282326000000008404918.0e15);
 f10 = i1 ? f10 : Math_fround(340282326000000008404918.0e15);
 i1 = f12 > Math_fround(-340282326000000008404918.0e15);
 f12 = i1 ? f12 : Math_fround(-340282326000000008404918.0e15);
 i1 = f11 > Math_fround(-340282326000000008404918.0e15);
 f11 = i1 ? f11 : Math_fround(-340282326000000008404918.0e15);
 i1 = f10 > Math_fround(-340282326000000008404918.0e15);
 f10 = i1 ? f10 : Math_fround(-340282326000000008404918.0e15);
 HEAPF32[i5 + 296 >> 2] = f12;
 i1 = i5 + 300 | 0;
 HEAPF32[i1 >> 2] = f11;
 i2 = i5 + 304 | 0;
 HEAPF32[i2 >> 2] = f10;
 i3 = i5 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0) | 0) & 1) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 176 >> 2] | 0, i8 | 0, i4 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 296 >> 2];
 HEAP32[i8 + 20 >> 2] = i1;
 HEAP32[i8 + 24 >> 2] = i4;
 i5 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 172 >> 2] | 0, i5 | 0, i8 | 0);
 i8 = HEAP32[i3 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, i6 | 0, i7 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN17InternalIndexPoolC2EjjPKj(i1, i3, i13, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 4 | 0;
 i12 = i14;
 HEAP32[i1 >> 2] = gb + 88176 + 8;
 i2 = i1 + 4 | 0;
 i10 = i1 + 8 | 0;
 i11 = i1 + 12 | 0;
 i9 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 if (i3 | 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i10, i3);
 HEAP32[i2 >> 2] = i13;
 if (!i13) {
  STACKTOP = i14;
  return;
 }
 i6 = (i13 + -1 | 0) >>> 5;
 if (i6 | 0) {
  i5 = 0;
  do {
   i1 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) {
    i4 = i5 << 5;
    i3 = ~i1;
    do {
     i1 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
     i1 = HEAP32[gb + 90668 + (i1 << 2) >> 2] | i4;
     HEAP32[i7 >> 2] = i1;
     i2 = HEAP32[i11 >> 2] | 0;
     if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
      HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i1;
      HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i10, i7) | 0;
     i3 = i3 + -1 & i3;
    } while ((i3 | 0) != 0);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
 i4 = i6 << 5;
 if ((i1 | 0) == -1) {
  STACKTOP = i14;
  return;
 }
 i3 = ~i1;
 while (1) {
  i1 = (Math_imul(i3 & 0 - i3, 125613361) | 0) >>> 27;
  i1 = HEAP32[gb + 90668 + (i1 << 2) >> 2] | i4;
  HEAP32[i12 >> 2] = i1;
  if (i1 >>> 0 >= i13 >>> 0) {
   i1 = 19;
   break;
  }
  i2 = HEAP32[i11 >> 2] | 0;
  if ((HEAP32[i9 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i10, i12) | 0;
  i3 = i3 + -1 & i3;
  if (!i3) {
   i1 = 19;
   break;
  }
 }
 if ((i1 | 0) == 19) {
  STACKTOP = i14;
  return;
 }
}

function __ZN13OcclusionArea8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 32 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZL29GeomOverlapCallback_SphereBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 16 | 0;
 i7 = i1;
 HEAP32[i6 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i6 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f8 = Math_fround(f12 + f12);
 f10 = Math_fround(f11 + f11);
 f15 = Math_fround(f18 + f18);
 f17 = Math_fround(f11 * f10);
 f16 = Math_fround(f18 * f15);
 f11 = Math_fround(f8 * f11);
 f19 = Math_fround(f8 * f18);
 f9 = Math_fround(f8 * f13);
 f18 = Math_fround(f10 * f18);
 f10 = Math_fround(f10 * f13);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(f11 + f13);
 f14 = Math_fround(f19 - f10);
 f13 = Math_fround(f11 - f13);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f8));
 f12 = Math_fround(f8 - f16);
 f11 = Math_fround(f18 + f9);
 f10 = Math_fround(f19 + f10);
 f9 = Math_fround(f18 - f9);
 f8 = Math_fround(f8 - f17);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f17) - f16);
 HEAPF32[i6 + 4 >> 2] = f15;
 HEAPF32[i6 + 8 >> 2] = f14;
 HEAPF32[i6 + 12 >> 2] = f13;
 HEAPF32[i6 + 16 >> 2] = f12;
 HEAPF32[i6 + 20 >> 2] = f11;
 HEAPF32[i6 + 24 >> 2] = f10;
 HEAPF32[i6 + 28 >> 2] = f9;
 HEAPF32[i6 + 32 >> 2] = f8;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i7 + 12 >> 2] = i5;
 i5 = __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i7, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 172 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 172 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z19InterpolateKeyframeI8Vector3fET_RK11KeyframeTplIS1_ES5_f(i9, i10, i11, f1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 f8 = Math_fround(f8 - f2);
 if (f8 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(f1 - f2) / f8);
  f5 = Math_fround(f8 * Math_fround(HEAPF32[i10 + 28 >> 2]));
  f7 = Math_fround(f8 * Math_fround(HEAPF32[i10 + 32 >> 2]));
  f2 = Math_fround(f8 * Math_fround(HEAPF32[i10 + 36 >> 2]));
  f4 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 16 >> 2]));
  f6 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 20 >> 2]));
  f1 = Math_fround(f8 * Math_fround(HEAPF32[i11 + 24 >> 2]));
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f13 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f15 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f14 = Math_fround(f3 * f3);
 f20 = Math_fround(f3 * f14);
 f16 = Math_fround(f20 * Math_fround(2.0));
 f19 = Math_fround(f14 * Math_fround(3.0));
 f12 = Math_fround(Math_fround(f16 - f19) + Math_fround(1.0));
 f3 = Math_fround(f3 + Math_fround(f20 - Math_fround(f14 * Math_fround(2.0))));
 f14 = Math_fround(f20 - f14);
 f16 = Math_fround(f19 - f16);
 f7 = Math_fround(Math_fround(f16 * f18) + Math_fround(Math_fround(f6 * f14) + Math_fround(Math_fround(f7 * f3) + Math_fround(f17 * f12))));
 f8 = Math_fround(Math_fround(f16 * Math_fround(HEAPF32[i11 + 12 >> 2])) + Math_fround(Math_fround(f1 * f14) + Math_fround(Math_fround(f2 * f3) + Math_fround(f8 * f12))));
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(f16 * f15) + Math_fround(Math_fround(f4 * f14) + Math_fround(Math_fround(f5 * f3) + Math_fround(f13 * f12))));
 HEAPF32[i9 + 4 >> 2] = f7;
 HEAPF32[i9 + 8 >> 2] = f8;
 return;
}

function __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
  i3 = 15;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i7 + 4 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) {
    i2 = HEAP32[i1 + 20 >> 2] | 0;
    if (i5 >>> 0 < i2 >>> 0) i3 = 6; else if (i2 >>> 0 < i5 >>> 0) i3 = 10; else {
     i3 = 13;
     break;
    }
   } else if (i4 >>> 0 < i2 >>> 0) i3 = 6; else if (i2 >>> 0 < i4 >>> 0) i3 = 10; else {
    i3 = 13;
    break;
   }
   if ((i3 | 0) == 6) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = 7;
     break;
    } else i1 = i2;
   } else if ((i3 | 0) == 10) {
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = 12;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 7) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i3 | 0) == 12) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i3 | 0) == 13) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i6;
   i3 = 15;
   break;
  }
 } while (0);
 if ((i3 | 0) == 15) if (i1) {
  i8 = i1;
  i8 = i8 + 24 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = __Znwj(36) | 0;
 i6 = i7;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP8[i3 + 24 >> 0] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i3;
 i8 = i8 + 24 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDriveNWEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i4, i5, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 196 | 0;
 i14 = i7 + 168 | 0;
 i10 = i7 + 44 | 0;
 i9 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i13 = i6;
 i12 = i5;
 i11 = i4;
 i4 = i2;
 i5 = i3;
 __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i11;
 HEAP32[i15 + 12 >> 2] = i4;
 HEAP32[i15 + 16 >> 2] = i5;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i3 = __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i10, i15, 0) | 0;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i4;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i10, i14, i3) | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx29PxVehicleDriveNWGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j(i10, i9, 0) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i15 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDrive4WEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i4, i5, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 196 | 0;
 i14 = i7 + 168 | 0;
 i10 = i7 + 44 | 0;
 i9 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i13 = i6;
 i12 = i5;
 i11 = i4;
 i4 = i2;
 i5 = i3;
 __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i11;
 HEAP32[i15 + 12 >> 2] = i4;
 HEAP32[i15 + 16 >> 2] = i5;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i3 = __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i10, i15, 0) | 0;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i4;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i10, i14, i3) | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx29PxVehicleDrive4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j(i10, i9, 0) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i15 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN12ImmediatePtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i8 + 8 | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (!(HEAP32[i7 >> 2] & 1)) {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i9;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = i7 + 16 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i4 + 4 | 0;
  i5 = i7 + 24 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i8, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 8);
   STACKTOP = i10;
   return;
  }
 } else {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier(__Z20GetPersistentManagerv() | 0, i1, i8);
  i5 = i7 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i7 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i8, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i9, 8);
   STACKTOP = i10;
   return;
  }
 }
}

function __ZN11MinMaxCurveC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAP16[i1 + 84 >> 1] = 0;
 HEAP8[i1 + 86 >> 0] = 0;
 i3 = i1 + 88 | 0;
 HEAPF32[i1 + 92 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i7 = i1 + 96 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAPF32[i1 + 120 >> 2] = Math_fround(inf);
 HEAP32[i1 + 116 >> 2] = 0;
 i7 = i1 + 124 | 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i7 = i6;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 148 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i1 + 168 >> 2] = 2;
 HEAP32[i1 + 164 >> 2] = 2;
 HEAP32[i1 + 172 >> 2] = 4;
 HEAPF32[i1 + 180 >> 2] = Math_fround(inf);
 HEAP32[i1 + 176 >> 2] = 0;
 i5 = i1 + 184 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i1 + 208 >> 2] = Math_fround(inf);
 HEAP32[i1 + 204 >> 2] = 0;
 i5 = i1 + 212 | 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 236 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 + 256 >> 2] = 2;
 HEAP32[i1 + 252 >> 2] = 2;
 HEAP32[i1 + 260 >> 2] = 4;
 __Z25SetPolynomialCurveToValueR17AnimationCurveTplIfER24OptimizedPolynomialCurvef(i3, i1, Math_fround(1.0));
 __Z25SetPolynomialCurveToValueR17AnimationCurveTplIfER24OptimizedPolynomialCurvef(i1 + 176 | 0, i1 + 40 | 0, Math_fround(0.0));
 STACKTOP = i2;
 return;
}

function __ZN10TagManager15ThreadedCleanupEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i7 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63528 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63528 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63528 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i8 + 20 | 0;
 i3 = i8 + 24 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8 + 4 | 0;
 i1 = 0;
 do {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i11 = gb + 63648 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 + 4 >> 2] = i10;
  HEAP8[i4 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i7 + 44 + (i1 << 5) | 0, i8);
  i6 = HEAP32[i8 >> 2] | 0;
  if (!((i6 | 0) == 0 | (HEAP32[i5 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i11 = i7 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, gb + 63528 | 0);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function _Horizontal_Sweep_Drop(i11, i12, i3, i4, i5, i6) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3 + -1 | 0;
 i1 = 0 - i7 | 0;
 i9 = i8 + i7 & i1;
 i10 = i1 & i4;
 if ((i9 | 0) > (i10 | 0)) {
  i2 = HEAP16[i5 + 12 >> 1] | 0;
  if ((i9 | 0) != (i10 + i7 | 0)) return;
  switch (i2 & 7) {
  case 0:
   {
    i2 = i10;
    break;
   }
  case 4:
   {
    i2 = (HEAP32[i11 + 8 >> 2] | 0) + ((i8 + i4 | 0) / 2 | 0) & i1;
    break;
   }
  case 5:
  case 1:
   {
    if ((HEAP32[i5 + 28 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i5 + 16 >> 2] | 0) < 1) {
     if (!(i2 & 16)) return;
     if ((i4 - i3 | 0) < (HEAP32[i11 + 8 >> 2] | 0)) return;
    }
    if ((HEAP32[i6 + 28 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i5 + 20 >> 2] | 0) == (i12 << 16 >> 16 | 0)) {
     if (!(i2 & 32)) return;
     if ((i4 - i3 | 0) < (HEAP32[i11 + 8 >> 2] | 0)) return;
    }
    if ((i2 & 7) == 1) i2 = i10; else i2 = (HEAP32[i11 + 8 >> 2] | 0) + ((i8 + i4 | 0) / 2 | 0) & i1;
    break;
   }
  default:
   return;
  }
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) < 0) i2 = i9; else i2 = i2 >> i1 >>> 0 < (HEAP32[i11 + 104 >> 2] | 0) >>> 0 ? i2 : i10;
  i5 = ((i2 | 0) == (i9 | 0) ? i10 : i9) >> i1;
  i3 = i12 << 16 >> 16;
  i6 = 128 >>> (i3 & 7);
  i7 = i11 + 104 | 0;
  i4 = HEAP32[i11 + 112 >> 2] | 0;
  i3 = (HEAP32[i11 + 60 >> 2] | 0) + (i3 >> 3) + (Math_imul(i5, 0 - i4 | 0) | 0) | 0;
  if ((i4 | 0) > 0) i3 = i3 + (Math_imul((HEAP32[i7 >> 2] | 0) + -1 | 0, i4) | 0) | 0;
  if ((i5 | 0) > -1) if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) if ((HEAPU8[i3 >> 0] | 0) & i6) return;
 } else {
  i2 = i9;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i2 >> i1;
 if ((i1 | 0) <= -1) return;
 i2 = HEAP32[i11 + 104 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) return;
 i10 = i12 << 16 >> 16;
 i9 = HEAP32[i11 + 112 >> 2] | 0;
 i12 = (HEAP32[i11 + 60 >> 2] | 0) + (i10 >> 3) + (Math_imul(i9, 0 - i1 | 0) | 0) | 0;
 i11 = i12 + (Math_imul(i9, i2 + -1 | 0) | 0) | 0;
 i12 = (i9 | 0) > 0 ? i11 : i12;
 HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 0 | 128 >>> (i10 & 7);
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE3putEc(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i6 | 0, i8 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i8;
  i3 = i8;
  i7 = 12;
 } else {
  do if (HEAP8[i6 >> 0] | 0) {
   i2 = HEAP32[i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i3 = i2;
   if (!i2) i7 = 8; else {
    i4 = i3 + 24 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (HEAP32[i3 + 28 >> 2] | 0)) {
     HEAP32[i4 >> 2] = i5 + 1;
     HEAP8[i5 >> 0] = i1;
     break;
    }
    __THREW__ = 0;
    i1 = invoke_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i1 & 255 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) if ((i1 | 0) == -1) i7 = 8; else break;
   }
   if ((i7 | 0) == 8) {
    i5 = i8 + (HEAP32[(HEAP32[i8 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 1 | 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) break;
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i6);
   i2 = i8;
   i3 = i8;
   i7 = 12;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i6);
 } while (0);
 do if ((i7 | 0) == 12) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx16PxsThreadContext5resetEjj(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5physx26PxcFrictionPatchStreamPair5resetEv(i8 + 360 | 0);
 HEAP32[i8 + 336 >> 2] = 0;
 HEAP32[i8 + 340 >> 2] = 0;
 HEAP32[i8 + 352 >> 2] = 0;
 HEAP32[i8 + 356 >> 2] = 0;
 __ZN5physx20PxcNpCacheStreamPair5resetEv(i8 + 372 | 0);
 i5 = i8 + 9136 | 0;
 i6 = i8 + 9140 | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 i1 = (i1 + 31 | 0) >>> 5;
 if (i1 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
  i2 = i8 + 9144 | 0;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i1 << 2, gb + 769739 | 0, 329) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if (i4 | 0) {
   _memcpy(i3 | 0, i4 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i5 >> 2] | 0);
  }
  i4 = HEAP32[i6 >> 2] | 0;
  _memset(i3 + ((i4 & 2147483647) << 2) | 0, 0, i1 - i4 << 2 | 0) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 9148 >> 2] = 0;
 HEAP32[i8 + 9152 >> 2] = 0;
 i5 = i8 + 9156 | 0;
 i6 = i8 + 9160 | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
 i1 = (i7 + 31 | 0) >>> 5;
 if (i1 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
  i2 = i8 + 9164 | 0;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i1 << 2, gb + 769739 | 0, 329) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if (i4 | 0) {
   _memcpy(i3 | 0, i4 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i5 >> 2] | 0);
  }
  i7 = HEAP32[i6 >> 2] | 0;
  _memset(i3 + ((i7 & 2147483647) << 2) | 0, 0, i1 - i7 << 2 | 0) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i8 + 9068 >> 2] = HEAP32[i8 + 8892 >> 2];
 HEAP32[i8 + 9076 >> 2] = HEAP32[i8 + 8916 >> 2];
 HEAP32[i8 + 9060 >> 2] = 0;
 HEAP32[i8 + 9028 >> 2] = 0;
 HEAP32[i8 + 9052 >> 2] = 0;
 HEAP32[i8 + 9056 >> 2] = 0;
 HEAP8[i8 + 9032 >> 0] = 0;
 HEAP32[i8 + 8796 >> 2] = 0;
 HEAP32[i8 + 8804 >> 2] = 0;
 HEAP32[i8 + 9036 >> 2] = 0;
 HEAP32[i8 + 8812 >> 2] = 0;
 HEAP32[i8 + 8932 >> 2] = 0;
 return;
}

function __ZN4Mesh21UnswizzleVertexColorsEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i2 + 44 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 & 16)) return;
 if (i3) {
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  i7 = i5 + 8 | 0;
  i3 = HEAP16[i5 + 18 >> 1] | 0;
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) {
   i6 = 0;
   i9 = 0;
  } else {
   i2 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i2) {
    i6 = 0;
    i9 = 1;
   } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
    i6 = 0;
    i9 = 1;
   } else {
    i3 = HEAP32[i5 + 16 >> 2] | 0;
    i6 = i2 + ((i3 >>> 8 & 255) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i9 = HEAPU8[i7 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
    i3 = i3 >>> 16 & 65535;
   }
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) i8 = 0; else {
   i2 = HEAP32[i5 + 100 >> 2] | 0;
   i4 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i4) i8 = 0; else if (!(HEAP8[i5 + 19 >> 0] | 0)) i8 = 0; else {
    i3 = HEAP32[i5 + 16 >> 2] | 0;
    i8 = i4 + ((Math_imul(HEAPU8[i7 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0, i2) | 0) + (HEAP32[i7 + 32 + ((i3 & 255) * 12 | 0) + 4 >> 2] | 0) + (i3 >>> 8 & 255)) | 0;
    i3 = i3 >>> 16 & 65535;
   }
  }
  if ((i3 & 65535) < 1024 | (i3 & 255) != 2) {
   i2 = 0;
   i5 = 0;
  } else {
   i2 = HEAP32[i5 + 92 >> 2] | 0;
   if (!i2) {
    i2 = 0;
    i5 = 1;
   } else if (!(HEAP8[i5 + 19 >> 0] | 0)) {
    i2 = 0;
    i5 = 1;
   } else {
    i4 = HEAP16[i5 + 16 >> 1] | 0;
    i2 = i2 + (((i4 & 65535) >>> 8 & 65535) + (HEAP32[i7 + 32 + ((i4 & 255) * 12 | 0) + 4 >> 2] | 0)) | 0;
    i5 = HEAPU8[i7 + 32 + ((HEAPU8[i5 + 16 >> 0] | 0) * 12 | 0) + 10 >> 0] | 0;
   }
  }
  if ((i6 | 0) != (i8 | 0)) {
   i3 = i6;
   i4 = i2;
   i1 = i2;
   while (1) {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] | i2 << 16 & 16711680 | i2 & -16777216;
    i1 = i3 + i9 | 0;
    i2 = i4 + i5 | 0;
    if ((i1 | 0) == (i8 | 0)) break; else {
     i3 = i1;
     i4 = i2;
     i1 = i2;
    }
   }
   i1 = HEAP8[i10 >> 0] | 0;
  }
 }
 HEAP8[i10 >> 0] = i1 & -17;
 return;
}

function __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i9, i8, 0);
 i3 = i8 + 20 | 0;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i4 = i9 + 8 | 0;
 __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = i1 + (i3 * 56 | 0) | 0;
 if (i3 | 0) do {
  __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 56 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i8 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i8 + 52 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i9, i8 + 80 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags(i9, i8 + 100 | 0, 0);
 __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i8);
 STACKTOP = i10;
 return;
}

function __ZN16HumanDescriptionD2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = i9 + 52 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i9 + 64 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i10);
 }
 i5 = i9 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i9 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i7 = i10 + 4 | 0;
   i8 = i10 + 4 | 0;
   do {
    i3 = i2 + -72 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -56 | 0;
    if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i4 >> 2] | 0;
     i12 = HEAP32[i2 + -44 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i7 >> 2] = i12;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i10);
    }
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i12 = HEAP32[i3 >> 2] | 0;
     i4 = HEAP32[i2 + -60 >> 2] | 0;
     HEAP32[i10 >> 2] = 66;
     HEAP32[i8 >> 2] = i4;
     __Z19free_alloc_internalPvRK10MemLabelId(i12, i10);
    }
    i2 = HEAP32[i6 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i10 + 4 | 0;
  i7 = i10 + 4 | 0;
  do {
   i3 = i2 + -76 | 0;
   HEAP32[i5 >> 2] = i3;
   i4 = i2 + -60 | 0;
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i4 >> 2] | 0;
    i8 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i6 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i10);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i12 = HEAP32[i3 >> 2] | 0;
    i8 = HEAP32[i2 + -64 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i7 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i12, i10);
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E5clearEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i7 + 60 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i7 + 64 | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   if ((i2 | 0) != 1) {
    i1 = 1;
    do {
     i3 = HEAP32[i6 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + (i1 * 24 | 0) + 12 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + (i1 * 24 | 0) | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
 }
 HEAP32[i4 >> 2] = 32;
 HEAP32[i7 + 76 >> 2] = 16;
 HEAP32[i7 + 72 >> 2] = 6;
 HEAP8[i7 + 80 >> 0] = 0;
 i2 = i7 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 >> 2] = 54;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(768, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i3 | 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 }
 HEAP32[i6 >> 2] = i1;
 i2 = i1 + ((HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i6 = i7 + 68 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i3 = i7 + 36 | 0;
 i4 = i7 + 48 | 0;
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 12 | 0, i4);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = i7 + 68 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __Z38Renderer_Get_Custom_PropSharedMaterialP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0)) {
  i6 = __Z19GetScriptingManagerv() | 0;
  i6 = __ZN9Scripting19ScriptingObjectNULLEP11Il2CppClass(HEAP32[(HEAP32[i6 + 168 >> 2] | 0) + (HEAP32[gb + 30792 + 24 >> 2] << 2) >> 2] | 0) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i5 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0) | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 13; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 13; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 15;
   }
  }
  if ((i6 | 0) == 13) i6 = 15;
  if ((i6 | 0) == 15) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9JSONWrite8TransferI10Matrix4x4fEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN10Matrix4x4f8TransferI9JSONWriteEEvRT_(i11, i10);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx41solveContactCoulomb_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i12, i11, i14, i15, i1, i13) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (i11 | 0) {
  i10 = 0;
  do {
   __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i12 + (i10 << 5) | 0, 0);
   i1 = HEAP32[i12 + (i10 << 5) + 16 >> 2] | 0;
   i7 = HEAP16[i1 + 2 >> 1] | 0;
   i9 = i1 + (i7 & 65535) | 0;
   i8 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
   if (i7 << 16 >> 16) {
    i4 = HEAP32[i12 + (i10 << 5) + 20 >> 2] | 0;
    while (1) {
     i2 = HEAP8[i1 + 1 >> 0] | 0;
     i7 = i2 & 255;
     if (!i4) {
      i1 = i1 + ((Math_imul(i7, i8) | 0) + 48) | 0;
      if (i1 >>> 0 < i9 >>> 0) {
       i4 = 0;
       continue;
      } else break;
     }
     i3 = i1 + 48 | 0;
     if (!(i2 << 24 >> 24)) {
      i1 = i3;
      i2 = i4;
     } else {
      i6 = i7 >>> 0 > 1 ? i7 : 1;
      i2 = i4 + (i6 << 2) | 0;
      i5 = 0;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 + 12 >> 2];
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i7 | 0)) break; else {
        i3 = i3 + i8 | 0;
        i4 = i4 + 4 | 0;
       }
      }
      i1 = i1 + ((Math_imul(i6, i8) | 0) + 48) | 0;
     }
     if (i1 >>> 0 < i9 >>> 0) i4 = i2; else break;
    }
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i11 | 0));
 }
 i5 = i14 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i14 + 12 >> 2] | 0) + -4 | 0) >>> 0) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i13, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i14 = i15 + (i4 + i2 << 4) | 0;
   i13 = i1 + (i2 << 4) | 0;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN12SocketStream7SendAllEPKvjl(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i6 = (i5 | 0) > 0;
 if (!i2) {
  i7 = 1;
  return i7 | 0;
 } else i3 = i2;
 L3 : while (1) {
  L5 : do if (i6) while (1) {
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   if (!(__ZN6Socket26WaitForAvailableSendBufferEl(i4, i5) | 0)) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, i3 | 0) | 0;
   if ((i2 | 0) >= 1) break L5;
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0)) {
    i7 = 16;
    break L5;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, 1, 0) | 0)) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
  } else while (1) {
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, i3 | 0) | 0;
   if ((i2 | 0) >= 1) break L5;
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0)) {
    i7 = 16;
    break L5;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, 1, 0) | 0)) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) {
    i1 = 0;
    i7 = 18;
    break L3;
   }
  } while (0);
  if ((i7 | 0) == 16) {
   i7 = 0;
   if ((i2 | 0) < 0) {
    i1 = 0;
    i7 = 18;
    break;
   } else i2 = 0;
  }
  i3 = i3 - i2 | 0;
  if (!i3) {
   i1 = 1;
   i7 = 18;
   break;
  } else i1 = i1 + i2 | 0;
 }
 if ((i7 | 0) == 18) return i1 | 0;
 return 0;
}

function __Z33ScriptingClassArrayToDynamicArrayI12LightmapData16LightmapDataMono13dynamic_arrayIS0_Lj4EEEvP11Il2CppArrayRT1_PFvRT0_RT_E(i5, i9, i7) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i8 = i11;
 i3 = i9 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i9 + 4 | 0);
  HEAP32[i9 >> 2] = 0;
 }
 HEAP32[i9 >> 2] = 0;
 i4 = i9 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i6 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i9 >> 2] = i2;
  break;
 } while (0);
 if (i6 >>> 0 > i1 >>> 0) _memset((HEAP32[i9 >> 2] | 0) + (i1 << 3) | 0, 0, i6 - i1 << 3 | 0) | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i2 = 0;
 while (1) {
  i1 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i5, i2) | 0;
  if (!i1) {
   i1 = 13;
   break;
  }
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = i8;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = i4;
  mftCall_vii(i7 | 0, i8 | 0, (HEAP32[i9 >> 2] | 0) + (i2 << 3) | 0);
  i1 = i2 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i2 = i1; else {
   i1 = 15;
   break;
  }
 }
 if ((i1 | 0) == 13) {
  __ZN13dynamic_arrayI12LightmapDataLj4EE5clearEv(i9);
  HEAP32[i10 >> 2] = i2;
  __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 937647 | 0, i10);
 } else if ((i1 | 0) == 15) {
  STACKTOP = i11;
  return;
 }
}

function __ZN7mecanim8skeleton19SkeletonMaskElement8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 904275 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 904286 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37316 >> 2] | 0, i2, i4);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 410605 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i1, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 410618 | 0, HEAP32[gb + 37324 >> 2] | 0, i6, 0);
 i2 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i2;
 i2 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085989 | 0, i2, i6, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085998 | 0, i2, i6 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1084342 | 0, i2, i6 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_(i9, i10, i8, i7, i6, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = (i1 | 0) < (i4 | 0);
 do if ((i4 | 0) < (i3 | 0)) {
  if (i2) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i8 >> 2] = i3;
   i5 = 1;
   i1 = i3;
   break;
  }
  HEAP32[i9 >> 2] = i4;
  HEAP32[i10 >> 2] = i3;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) < (i3 | 0)) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i8 >> 2] = i3;
   i5 = 2;
   i1 = i3;
  } else i5 = 1;
 } else if (i2) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) < (i2 | 0)) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i2;
   i5 = 2;
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i5 = 1;
   i1 = i4;
  }
 } else i5 = 0; while (0);
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) < (i1 | 0)) {
  HEAP32[i8 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i1 = i5 + 1 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) < (i2 | 0)) {
    HEAP32[i9 >> 2] = i1;
    HEAP32[i10 >> 2] = i2;
    i3 = i5 + 3 | 0;
   } else i3 = i5 + 2 | 0;
  } else i3 = i1;
 } else i3 = i5;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 1 | 0;
  return i10 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 2 | 0;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) >= (i2 | 0)) {
  i10 = i3 + 3 | 0;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = i2;
 i10 = i3 + 4 | 0;
 return i10 | 0;
}

function __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 - i1 | 0;
 i3 = ((i9 | 0) / 20 | 0) + 1 | 0;
 if ((i9 | 0) < -20) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 20 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 1073741823 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 2147483647;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 20 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i4 + (((i2 - i1 | 0) / 20 | 0) * 20 | 0) | 0;
 i5 = i2;
 i8 = i4 + (i3 * 20 | 0) | 0;
 __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2, i6);
 i7 = i2 + 20 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i5;
  i4 = i6;
  i1 = i6;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -20 | 0;
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2 + -20 | 0, i1);
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i9 >> 2] = i8;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i12);
 STACKTOP = i14;
 return;
}

function __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj(i14, i7, i13, i11, i12) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i15 = 0;
 i6 = HEAP32[i14 + 1216 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i4 + (i3 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + (i3 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i5) | 0) | 0;
   if (i1 | 0) {
    i15 = 6;
    break;
   }
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
  if (!i1) i1 = 0; else i15 = 6;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i15 = 6;
 } while (0);
 if ((i15 | 0) == 6) __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE(i1, i14, i7);
 i10 = i14 + 1416 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if (!i11) return;
 i8 = i14 + 1212 | 0;
 i10 = 0;
 do {
  i9 = (HEAP32[i13 + (i10 << 2) >> 2] | 0) + i12 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i5 = HEAP32[i7 + 12 >> 2] | 0;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i5 + (i4 * 12 | 0) + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if (!i2) {
   i2 = i5 + (i4 * 12 | 0) + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (HEAP32[i7 >> 2] | 0)) {
    HEAP32[i2 >> 2] = i3 + 1;
    i2 = (HEAP32[i5 + (i4 * 12 | 0) >> 2] | 0) + (Math_imul(i3, i6) | 0) | 0;
    if (i2 | 0) {
     i15 = 14;
     break;
    }
   }
   i2 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i7) | 0;
   if (i2 | 0) i15 = 14;
  } else {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i15 = 14;
  } while (0);
  if ((i15 | 0) == 14) {
   i15 = 0;
   __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(i2, i1, i9, 0, 0);
  }
  i9 = i14 + 1424 + (HEAP32[i9 + 68 >> 2] << 2) | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i11 | 0));
 return;
}

function __ZN14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i9 = i14 + 4 | 0;
 i10 = i14;
 if (!i7) {
  STACKTOP = i14;
  return;
 }
 i11 = i1 + 96 | 0;
 i12 = i1 + 100 | 0;
 i5 = i1 + 92 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[(HEAP32[i6 + (i4 * 12 | 0) + 4 >> 2] | 0) + 8 >> 2] | 0;
  do if (!i1) HEAP32[i10 >> 2] = 0; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = i1;
   if (i1 | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 12; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i2 = HEAP32[i8 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 12; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i13 = 14;
    }
    if ((i13 | 0) == 12) i13 = 14;
    if ((i13 | 0) == 14) {
     i13 = 0;
     if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i10 >> 2] | 0) | 0)) break;
    }
    i1 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i12 >> 2] | 0)) {
     __ZNSt3__26vectorI4PPtrIN5Unity5JointEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i5, i10);
     break;
    } else {
     HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
     HEAP32[i11 >> 2] = i1 + 4;
     break;
    }
   }
  } while (0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i7 | 0));
 STACKTOP = i14;
 return;
}

function __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i3, i6 + 4 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i3, i6 + 20 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZL26ClosestHeightPointTriangleRK8Vector3ffS1_S1_S1_Rf(i4, f5, i1, i2, i3, i8) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 80 | 0;
 i6 = i10 + 8 | 0;
 i7 = i10;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = i9 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i9 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = __ZL8ClipPolyPK8Vector3fiPS_RS0_f(i9, 3, i6, Math_fround(1.0), Math_fround(0.0), Math_fround(0.0), Math_fround(-Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f5))) | 0;
 if ((i1 | 0) < 3) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = __ZL8ClipPolyPK8Vector3fiPS_RS0_f(i6, i1, i9, Math_fround(-1.0), Math_fround(0.0), Math_fround(0.0), Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5)) | 0;
 if ((i1 | 0) < 3) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = i4 + 8 | 0;
 i1 = __ZL8ClipPolyPK8Vector3fiPS_RS0_f(i9, i1, i6, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(-Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f5))) | 0;
 if ((i1 | 0) < 3) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = __ZL8ClipPolyPK8Vector3fiPS_RS0_f(i6, i1, i9, Math_fround(0.0), Math_fround(0.0), Math_fround(-1.0), Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f5)) | 0;
 if ((i3 | 0) < 3) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i1 = 1;
 do {
  f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = i9 + (i1 * 12 | 0) + 4 | 0;
  i4 = f5 < Math_fround(HEAPF32[i6 >> 2]);
  i2 = HEAP32[(i4 ? i6 : i7) >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i8 >> 2] = i2;
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z36Cloth_Set_Custom_PropSphereCollidersP12Il2CppObjectP11Il2CppArray(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 840031 | 0, i9);
 if (!i8) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i3) {
  i7 = i8;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i6 = i3 + 168 | 0;
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 i4 = i3 + 180 | 0;
 HEAP32[i4 >> 2] = i7;
 i1 = i3 + 184 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i7 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i7 << 3, 4, i3 + 172 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 4, i3 + 172 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  break;
 } while (0);
 if (i7 | 0) {
  i4 = 0;
  do {
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, i4, 8) | 0;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i1 >> 2] | 0) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i2 + (i4 << 3) >> 2] = i1;
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i2 + (i4 << 3) + 4 >> 2] = i1;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i7 | 0));
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8); else {
  __ZN5Unity5Cloth14SetupCollidersEv(i1);
  STACKTOP = i9;
  return;
 }
}

function __Z34ParticleSystemRenderer_RenderTrailRK15RenderNodeQueueRK17BatchInstanceDataR21DynamicVBOChunkHandleR13dynamic_arrayIN10DynamicVBO10DrawParamsELj4EER9GfxDevice(i2, i1, i4, i11, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i11 = 0;
  return i11 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i1 + (i3 * 360 | 0) + 328 >> 2] | 0;
 if (!(HEAP32[i2 + 88 >> 2] | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i10 = i2 + 500 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 if ((HEAP32[i4 + 8 >> 2] | 0) == -1) {
  i9 = i2 + 484 | 0;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 }
 i1 = HEAP32[i1 + (i3 * 360 | 0) + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 188 >> 2] | 0, i5 | 0, i1 | 0);
 i2 = HEAP32[i2 + 504 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i11 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i11 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i11 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i11 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 + (i5 * 20 | 0) >> 2] = 24;
 HEAP32[i11 + (i5 * 20 | 0) + 4 >> 2] = i2;
 HEAP32[i11 + (i5 * 20 | 0) + 8 >> 2] = i3;
 HEAP32[i11 + (i5 * 20 | 0) + 12 >> 2] = 0;
 HEAP32[i11 + (i5 * 20 | 0) + 16 >> 2] = 0;
 i11 = HEAP32[i10 >> 2] | 0;
 return i11 | 0;
}

function __Z32PolygonCollider2D_CUSTOM_GetPathP12Il2CppObjecti(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i7 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = i1 + 160 | 0;
 if ((((HEAP32[i7 + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0) / 20 | 0 | 0) <= (i5 | 0)) {
  HEAP32[i2 >> 2] = i5;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 808363 | 0, i2);
 }
 if ((i5 | 0) < 0) {
  HEAP32[i3 >> 2] = i5;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 808387 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i4 = HEAP32[i1 + 160 >> 2] | 0;
 i2 = HEAP32[i4 + (i5 * 20 | 0) >> 2] | 0;
 i4 = HEAP32[i4 + (i5 * 20 | 0) + 12 >> 2] | 0;
 i5 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i4 = (i2 | 0) == 0 ? 0 : i4;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 8, i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 8) | 0;
 if ((i4 | 0) > 0) i3 = 0; else {
  STACKTOP = i6;
  return i5 | 0;
 }
 while (1) {
  i8 = i2;
  i10 = i8;
  i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
  i8 = i8 + 4 | 0;
  i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
  i7 = i1;
  i9 = i7;
  HEAP8[i9 >> 0] = i10;
  HEAP8[i9 + 1 >> 0] = i10 >> 8;
  HEAP8[i9 + 2 >> 0] = i10 >> 16;
  HEAP8[i9 + 3 >> 0] = i10 >> 24;
  i7 = i7 + 4 | 0;
  HEAP8[i7 >> 0] = i8;
  HEAP8[i7 + 1 >> 0] = i8 >> 8;
  HEAP8[i7 + 2 >> 0] = i8 >> 16;
  HEAP8[i7 + 3 >> 0] = i8 >> 24;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + 8 | 0;
   i2 = i2 + 8 | 0;
  }
 }
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 8 | 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = i6 + 16 | 0;
 HEAP32[i6 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = 0;
 i8 = i6 + 56 | 0;
 HEAP32[i8 >> 2] = 0;
 i3 = i6 + 44 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 899322 | 0, i6, 0);
 __ZN13AnimationClip9PPtrCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i6 + 40 | 0;
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i6 + 28 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i9;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 STACKTOP = i7;
 return;
}

function __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i3, i4, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i9 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63800 | 0, 16, gb + 1046596 | 0, 41) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i5 = i9 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i9 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 1;
 if (!(_gettimeofday(i1 | 0, 0) | 0)) {
  i11 = HEAP32[i1 >> 2] | 0;
  i11 = ___muldi3(i11 | 0, ((i11 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
  i2 = getTempRet0() | 0;
  i1 = (HEAP32[i1 + 4 >> 2] | 0) / 1e3 | 0;
  i1 = _i64Add(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, i11 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 i11 = i4 + 24 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i2;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER8UnityStrjPKc(i4, i9, i7, i6);
 HEAP32[i9 + 32 >> 2] = HEAP32[i4 + 20 >> 2];
 if ((HEAP32[i3 + 8 >> 2] | 0) == (i7 | 0)) {
  i11 = __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(i3, i9, i8) | 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!i7) {
  HEAP32[i5 >> 2] = 1;
  i11 = __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(i3, i9, i8) | 0;
  STACKTOP = i10;
  return i11 | 0;
 } else {
  HEAP32[i5 >> 2] = 2;
  i11 = __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(i3, i9, i8) | 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 return 0;
}

function __ZN16UnityAdsSettings9SetGameIdE15RuntimePlatformRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 switch (i1 | 0) {
 case 8:
  {
   i1 = i8 + 20 | 0;
   i6 = HEAP8[i2 + 11 >> 0] | 0;
   i4 = i6 << 24 >> 24 < 0;
   i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
   i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i8 + 28 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i6 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i8 + 24 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
    return;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i8 + 24 >> 2] = i6;
    return;
   } else {
    HEAP8[i4 >> 0] = i6;
    return;
   }
  }
 case 11:
  {
   i1 = i8 + 36 | 0;
   i6 = HEAP8[i2 + 11 >> 0] | 0;
   i4 = i6 << 24 >> 24 < 0;
   i7 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
   i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i8 + 44 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i6 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i8 + 40 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
    return;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
   HEAP8[i1 + i6 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i8 + 40 >> 2] = i6;
    return;
   } else {
    HEAP8[i4 >> 0] = i6;
    return;
   }
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1042972 | 0, 0, gb + 1042881 | 0, 210, 1, 0, 0, 0);
   return;
  }
 }
}

function __Z15AddLoopingFrameI8Vector3fEvR17AnimationCurveTplIT_Ef(i6, f7) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i9 = i6 + 132 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i6 + 120 >> 2] | 0;
 if ((HEAP32[i11 >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i11 + ((i10 + -1 | 0) * 40 | 0) >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i13;
  return;
 }
 i1 = i8 + 4 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i8 >> 2] = f7;
 i5 = i8 + 4 | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i5 = i8 + 16 | 0;
 i4 = i11 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i5 = i8 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAPF32[i6 + 4 >> 2] = Math_fround(inf);
 HEAP32[i6 >> 2] = 0;
 HEAPF32[i6 + 64 >> 2] = Math_fround(inf);
 HEAP32[i6 + 60 >> 2] = 0;
 i5 = i6 + 120 | 0;
 i4 = i11;
 i1 = (i10 * 40 | 0) / 40 | 0;
 L10 : while (1) {
  while (1) {
   if (!i1) break L10;
   i2 = (i1 | 0) / 2 | 0;
   i3 = i4 + (i2 * 40 | 0) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) < f7) break; else i1 = i2;
  }
  i4 = i3 + 40 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 if ((i4 | 0) == (i11 + (i10 * 40 | 0) | 0)) i12 = 11; else if (Math_fround(HEAPF32[i4 >> 2]) > f7) i12 = 11;
 if ((i12 | 0) == 11) __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_(i5, i4, 1, i8) | 0;
 __Z26RecalculateSplineSlopeLoopI8Vector3fEvR17AnimationCurveTplIT_Eif(i6, 0, Math_fround(0.0));
 __Z26RecalculateSplineSlopeLoopI8Vector3fEvR17AnimationCurveTplIT_Eif(i6, (HEAP32[i9 >> 2] | 0) + -1 | 0, Math_fround(0.0));
 STACKTOP = i13;
 return;
}

function __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i2, i11, i12, i1) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 HEAP8[i2 + 24 >> 0] = i11 & 1;
 i13 = i2 + 16 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i6 = (i1 + -1 & 0 - i6) + i6 | 0;
 i7 = i2 + 48 | 0;
 i8 = i2 + 44 | 0;
 i10 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i8 >> 2] | 0) | 0;
 i9 = i2 + 32 | 0;
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i10 = (HEAP32[i1 + (i10 << 4) + 4 >> 2] | 0) + (HEAP32[i1 + (i10 << 4) >> 2] | 0) | 0;
 i1 = i2 + 26 | 0;
 i14 = HEAP16[i1 >> 1] | 0;
 i2 = i11 ? i6 - i10 | 0 : 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = (i14 & 65535) < 256;
 i5 = _llvm_bswap_i32(i2 | 0) | 0;
 if (!((i14 & 255) << 24 >> 24)) {
  i5 = i4 ? i2 : i5;
  i14 = i3 + i10 | 0;
  HEAP8[i14 >> 0] = i5;
  HEAP8[i14 + 1 >> 0] = i5 >> 8;
  HEAP8[i14 + 2 >> 0] = i5 >> 16;
  HEAP8[i14 + 3 >> 0] = i5 >> 24;
 } else {
  i2 = i4 ? i2 : 0;
  i5 = i4 ? 0 : i5;
  i14 = i3 + i10 | 0;
  i10 = i14;
  HEAP8[i10 >> 0] = i2;
  HEAP8[i10 + 1 >> 0] = i2 >> 8;
  HEAP8[i10 + 2 >> 0] = i2 >> 16;
  HEAP8[i10 + 3 >> 0] = i2 >> 24;
  i14 = i14 + 4 | 0;
  HEAP8[i14 >> 0] = i5;
  HEAP8[i14 + 1 >> 0] = i5 >> 8;
  HEAP8[i14 + 2 >> 0] = i5 >> 16;
  HEAP8[i14 + 3 >> 0] = i5 >> 24;
 }
 do if (i12 | 0) if (i11) {
  i14 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i8 >> 2] | 0) | 0;
  i11 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i14 >>> 8 << 2) >> 2] | 0;
  i14 = i14 & 255;
  HEAP32[i12 >> 2] = (HEAP32[i11 + (i14 << 4) + 4 >> 2] | 0) + (HEAP32[i11 + (i14 << 4) >> 2] | 0);
  HEAP32[i12 + 4 >> 2] = i6;
  HEAP32[i12 + 8 >> 2] = HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2];
  break;
 } else {
  HEAP32[i12 >> 2] = 1048575;
  HEAP32[i12 + 4 >> 2] = 1048575;
  HEAP32[i12 + 8 >> 2] = 1048575;
  break;
 } while (0);
 i14 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i8 >> 2] | 0) | 0;
 i14 = (HEAP32[(HEAP32[i9 >> 2] | 0) + (i14 >>> 8 << 2) >> 2] | 0) + ((i14 & 255) << 4) + 4 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (HEAP8[i1 >> 0] | 0 ? 8 : 4);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 348 | 0;
 i1 = i11 + 344 | 0;
 i10 = i11 + 328 | 0;
 i9 = i11 + 312 | 0;
 i13 = i11 + 16 | 0;
 i15 = i11;
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx29PxSphericalJointGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i2 = __ZN5physx2Sn17readAllPropertiesINS_16PxSphericalJointENS_29PxSphericalJointGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i14, i10, i9, i8, i7, i5, i6, i13) | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i15 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 }
 i15 = HEAP32[i4 >> 2] | 0;
 if (!((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i15 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 356 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN25MultiBlocksMemoryFileData5WriteEyyPKv(i13, i14, i15, i9, i10, i11) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i16 = 0;
 i8 = _i64Add(i9 | 0, i10 | 0, i14 | 0, i15 | 0) | 0;
 i1 = getTempRet0() | 0;
 i12 = i13 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = ___udivdi3(i8 | 0, i1 | 0, i2 | 0, 0) | 0;
 i1 = _i64Add(i1 | 0, getTempRet0() | 0, 1, 0) | 0;
 getTempRet0() | 0;
 if (i1 >>> 0 > (HEAP32[i13 + 32 >> 2] | 0) >>> 0) {
  __ZN25MultiBlocksMemoryFileData17AdjustBlocksCountEj(i13, i1);
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i1 = ___udivdi3(i14 | 0, i15 | 0, i2 | 0, 0) | 0;
 getTempRet0() | 0;
 if ((i9 | 0) == 0 & (i10 | 0) == 0) {
  i12 = 0;
  i11 = 0;
  i13 = i13 + 40 | 0;
  i14 = _i64Add(i12 | 0, i11 | 0, i14 | 0, i15 | 0) | 0;
  getTempRet0() | 0;
  i15 = HEAP32[i13 >> 2] | 0;
  i10 = i15 >>> 0 < i14 >>> 0;
  i15 = i10 ? i14 : i15;
  HEAP32[i13 >> 2] = i15;
  setTempRet0(i11 | 0);
  return i12 | 0;
 }
 i6 = _i64Subtract(i14 | 0, i15 | 0, Math_imul(i1, i2) | 0, 0) | 0;
 getTempRet0() | 0;
 i7 = i13 + 20 | 0;
 i8 = i13 + 8 | 0;
 i5 = 0;
 i4 = i1;
 i1 = 0;
 i3 = 0;
 while (1) {
  i16 = i2 - i6 | 0;
  i3 = _i64Subtract(i9 | 0, i10 | 0, i1 | 0, i3 | 0) | 0;
  getTempRet0() | 0;
  i3 = i3 >>> 0 < i16 >>> 0 ? i3 : i16;
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  if (!i1) {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i8, 0, gb + 492156 | 0, 109) | 0;
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = i1;
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  }
  _memcpy(i1 + i6 | 0, i11 + i5 | 0, i3 | 0) | 0;
  i1 = i3 + i5 | 0;
  if (!(0 < i10 >>> 0 | 0 == (i10 | 0) & i1 >>> 0 < i9 >>> 0)) {
   i2 = 0;
   break;
  }
  i5 = i1;
  i6 = 0;
  i4 = i4 + 1 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = 0;
 }
 i16 = i13 + 40 | 0;
 i14 = _i64Add(i1 | 0, i2 | 0, i14 | 0, i15 | 0) | 0;
 getTempRet0() | 0;
 i15 = HEAP32[i16 >> 2] | 0;
 i13 = i15 >>> 0 < i14 >>> 0;
 i15 = i13 ? i14 : i15;
 HEAP32[i16 >> 2] = i15;
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i8, i4, i5, i2, i1) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i3 = i11;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i10 = i8 + 20 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i7 = i8 + 16 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = 0;
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = i1;
 } else {
  i7 = i8 + 16 | 0;
  __ZN8TypeTree8AddChildERK16TypeTreeIterator(i3, HEAP32[i7 >> 2] | 0, i10);
  i13 = i3;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
  i12 = i9;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = i3;
  i12 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  HEAP32[i12 + (i3 * 24 | 0) + 20 >> 2] = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i10) | 0) + 20 >> 2] | i1) & -32769;
  i3 = i12 + (i3 * 24 | 0) | 0;
 }
 __ZN8TypeTree16AssignTypeStringERK16TypeTreeIteratorPKc(HEAP32[i7 >> 2] | 0, i9, i5);
 __ZN8TypeTree16AssignNameStringERK16TypeTreeIteratorPKc(HEAP32[i7 >> 2] | 0, i9, i4);
 HEAP32[i3 + 12 >> 2] = 0;
 if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i9) | 0) + 20 >> 2] & 4096)) i6 = 6; else if (!(HEAP32[i8 >> 2] & 32)) i6 = 6; else i1 = -1;
 if ((i6 | 0) == 6) {
  i13 = i8 + 44 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  HEAP32[i13 >> 2] = i1 + 1;
 }
 HEAP32[i3 + 16 >> 2] = i1;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 do if ((i2 | 0) != 0 & (i1 | 0) != 0) {
  i1 = i2 - i1 | 0;
  if ((i1 | 0) > -1) if ((i1 | 0) < (HEAP32[i8 + 32 >> 2] | 0)) {
   __ZN8TypeTree16AssignByteOffsetERK16TypeTreeIteratorj(HEAP32[i7 >> 2] | 0, i9, i1);
   break;
  }
  i1 = i2 - (HEAP32[i8 + 36 >> 2] | 0) | 0;
  if ((i1 | 0) > -1) if ((i1 | 0) < (HEAP32[i8 + 40 >> 2] | 0)) __ZN8TypeTree16AssignByteOffsetERK16TypeTreeIteratorj(HEAP32[i7 >> 2] | 0, i9, i1 | -2147483648);
 } while (0);
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i13 = i10;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 STACKTOP = i11;
 return;
}

function __ZN24dtObstacleAvoidanceQuery10addCapsuleEPKfS1_S1_S1_(i8, i1, i2, i3, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i4 = 0, f5 = f0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 f13 = Math_fround(HEAPF32[i8 + 10424 >> 2]);
 f5 = Math_fround(f13 + Math_fround(HEAPF32[i8 + 10436 >> 2]));
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 i2 = __Z23CalculateClippedCapsulePfS_PKfS1_S1_ff(i10, i11, i1, i2, i3, f13, f5) | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i3 = i8 + 10452 | 0;
 i4 = i9 + 8 | 0;
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 i6 = i8 + 10432 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i3 >> 2] | 0;
  if ((i7 | 0) < 104) {
   i14 = i10 + (i1 << 1 << 2) | 0;
   HEAP32[i3 >> 2] = i7 + 1;
   HEAP32[i8 + (i7 * 24 | 0) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i8 + (i7 * 24 | 0) + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i8 + (i7 * 24 | 0) + 8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + (i7 * 24 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
   HEAPF32[i8 + (i7 * 24 | 0) + 16 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
   HEAPF32[i8 + (i7 * 24 | 0) + 20 >> 2] = Math_fround(1.0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((i2 | 0) <= 1) {
  STACKTOP = i12;
  return;
 }
 i1 = i8 + 10460 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) >= 104) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i8 + 4992 + (i2 * 52 | 0) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4992 + (i2 * 52 | 0) + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 4992 + (i2 * 52 | 0) + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 4992 + (i2 * 52 | 0) + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i8 + 4992 + (i2 * 52 | 0) + 16 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4992 + (i2 * 52 | 0) + 20 >> 2] = HEAP32[i9 + 8 >> 2];
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 HEAPF32[i8 + 4992 + (i2 * 52 | 0) + 44 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i8 + 10432 >> 2]));
 HEAPF32[i8 + 4992 + (i2 * 52 | 0) + 48 >> 2] = Math_fround(1.0);
 STACKTOP = i12;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i9, i10, i8, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(HEAPF32[i9 >> 2]);
 if (f4 < f7) i1 = 1; else if (f7 < f4) i1 = 0; else i1 = (HEAP32[i10 + 4 >> 2] | 0) >>> 0 < (HEAP32[i9 + 4 >> 2] | 0) >>> 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 if (f2 < f4) i3 = 1; else if (f4 < f2) i3 = 0; else i3 = (HEAP32[i8 + 4 >> 2] | 0) >>> 0 < (HEAP32[i10 + 4 >> 2] | 0) >>> 0;
 if (!i1) {
  if (!i3) {
   i10 = 0;
   return i10 | 0;
  }
  HEAPF32[i10 >> 2] = f2;
  HEAPF32[i8 >> 2] = f4;
  i6 = i10 + 4 | 0;
  i8 = i8 + 4 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i5;
  f2 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  if (f2 < f4) {
   i3 = i9 + 4 | 0;
   i1 = i3;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
  } else {
   if (f4 < f2) {
    i10 = 1;
    return i10 | 0;
   }
   i5 = HEAP32[i6 >> 2] | 0;
   i1 = i9 + 4 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i5 >>> 0 >= i3 >>> 0) {
    i10 = 1;
    return i10 | 0;
   }
  }
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i10 >> 2] = f4;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i3;
  i10 = 2;
  return i10 | 0;
 }
 if (i3) {
  HEAPF32[i9 >> 2] = f2;
  HEAPF32[i8 >> 2] = f7;
  i6 = i9 + 4 | 0;
  i10 = i8 + 4 | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i10 >> 2] = i9;
  i10 = 1;
  return i10 | 0;
 }
 HEAPF32[i9 >> 2] = f4;
 HEAPF32[i10 >> 2] = f7;
 i9 = i9 + 4 | 0;
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 if (f2 < f7) {
  i3 = i8 + 4 | 0;
  i1 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 } else {
  if (f7 < f2) {
   i10 = 1;
   return i10 | 0;
  }
  i1 = i8 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 >>> 0 >= i6 >>> 0) {
   i10 = 1;
   return i10 | 0;
  }
 }
 HEAPF32[i10 >> 2] = f2;
 HEAPF32[i8 >> 2] = f7;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i1 >> 2] = i6;
 i10 = 2;
 return i10 | 0;
}

function __ZN9Projector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 48 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 52 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 56 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 64 | 0, i6);
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN9JSONWrite8TransferI8GradientEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN8Gradient8TransferI9JSONWriteEEvRT_(i11, i10);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferI8GUIStyleEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN8GUIStyle8TransferI9JSONWriteEEvRT_(i11, i10);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i11 + 20 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = (i4 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = i1 & i4 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if (!(_strcmp(HEAP32[i5 + (i2 << 3) >> 2] | 0, i6) | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i8 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i5 = i11 + 36 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i4 << 1;
  if (i4 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i3 = i1;
   i1 = 5381;
   do {
    i1 = i1 * 33 ^ i3 << 24 >> 24;
    i2 = i2 + 1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
   } while (i3 << 24 >> 24 != 0);
  }
  i1 = i1 & i4 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5Unity5Cloth26ClothConstrainCoefficients8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 839419 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 839431 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i8 + 28 | 0;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 72 | 0, 4) | 0;
  i2 = i4 + (i1 * 72 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    HEAP32[i1 + 40 >> 2] = 1;
    i10 = i1 + 44 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i10 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i10 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i10 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i10 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
    i1 = i1 + 72 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i10 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i10 * 72 | 0) | 0;
 if (!i10) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4math8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN8GUIStyle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 296 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i2 = HEAP8[i8 >> 0] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 28 >> 2] = i2 << 24 >> 24;
 i1 = i6 + 32 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i2 = HEAP8[i8 >> 0] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP8[i2 >> 0] | 0;
  HEAP8[i8 >> 0] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 28 >> 2] = i2 << 24 >> 24;
 i1 = i6 + 32 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN8LODGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 32 | 0, gb + 425113 | 0, 0);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 48 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 52 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i6, i5 + 56 | 0, 0);
 i1 = i5 + 72 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18PxVehicleDriveTankC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP16[i3 + 4 >> 1] = 515;
 HEAP16[i3 + 6 >> 1] = 3;
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(.230800003);
 HEAPF32[i3 + 16 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(3.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(.333333343);
 HEAP32[i3 >> 2] = gb + 159216 + 8;
 __ZN5physx21PxVehicleDriveDynDataC2Ev(i3 + 128 | 0);
 HEAP32[i3 >> 2] = gb + 159336 + 8;
 HEAPF32[i3 + 304 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 308 >> 2] = Math_fround(500.0);
 HEAPF32[i3 + 312 >> 2] = Math_fround(600.0);
 HEAPF32[i3 + 316 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 320 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 324 >> 2] = Math_fround(.349999994);
 HEAPF32[i3 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 228 >> 2] = Math_fround(.800000011);
 HEAPF32[i3 + 232 >> 2] = Math_fround(.330000013);
 HEAPF32[i3 + 236 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 240 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 244 >> 2] = Math_fround(.800000011);
 HEAP32[i3 + 288 >> 2] = 3;
 HEAPF32[i3 + 328 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 332 >> 2] = Math_fround(.00166666671);
 HEAPF32[i3 + 464 >> 2] = Math_fround(4.0);
 HEAP32[i3 + 468 >> 2] = 7;
 HEAPF32[i3 + 472 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 336 >> 2] = Math_fround(-4.0);
 HEAPF32[i3 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 344 >> 2] = Math_fround(4.0);
 HEAPF32[i3 + 348 >> 2] = Math_fround(2.0);
 HEAPF32[i3 + 352 >> 2] = Math_fround(1.5);
 HEAPF32[i3 + 356 >> 2] = Math_fround(1.10000002);
 HEAPF32[i3 + 360 >> 2] = Math_fround(1.0);
 i1 = i3 + 364 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[i3 + 480 >> 2] = Math_fround(10.0);
 HEAP32[i3 + 484 >> 2] = 1;
 HEAP32[i3 + 488 >> 2] = 5;
 i1 = 0;
 do {
  HEAPF32[i3 + 496 + (i1 << 2) >> 2] = Math_fround(.649999976);
  HEAPF32[i3 + 624 + (i1 << 2) >> 2] = Math_fround(.5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAPF32[i3 + 500 >> 2] = Math_fround(.150000006);
 HEAPF32[i3 + 624 >> 2] = Math_fround(2.0);
 HEAP32[i3 + 752 >> 2] = 0;
 return;
}

function __ZN5Umbra18CellGraphTraversal9enterNodeERKNS_10PortalNodeE(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = (HEAP32[i14 + 344 >> 2] | 0) + (i12 >> 5 << 2) | 0;
 i12 = 1 << (i12 & 31);
 i13 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i12 | i13;
 if (i12 & i13 | 0) {
  i14 = 0;
  return i14 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = (HEAP32[i14 + 208 >> 2] | 0) + (Math_imul(HEAP32[i14 + 224 >> 2] | 0, i1) | 0) | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = HEAP32[i9 + 8 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 i12 = HEAP32[i14 + 384 >> 2] | 0;
 i13 = (i12 | 0) == 0;
 if (i13) {
  i7 = 0;
  i8 = 0;
 } else if (!(HEAP32[i12 + 8 >> 2] | 0)) {
  i7 = 0;
  i8 = 0;
 } else {
  i8 = (HEAP32[i14 + 244 >> 2] | 0) + (Math_imul(HEAP32[i14 + 260 >> 2] | 0, i1) | 0) | 0;
  i7 = HEAP32[i8 >> 2] << 4;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
 }
 i3 = HEAP32[i14 + 360 >> 2] | 0;
 i5 = HEAP32[i3 + 84 >> 2] | 0;
 i4 = i5 & 31;
 i5 = i5 >>> 5 & 31;
 i6 = i5 + i4 | 0;
 i1 = Math_imul(i6, i2) | 0;
 i2 = ((Math_imul(i6, HEAP32[i3 + 92 >> 2] | 0) | 0) + 31 >> 5 << 5) - i1 | 0;
 if (i2 | 0) {
  HEAP32[i14 + 308 >> 2] = i3 + (HEAP32[i3 + 88 >> 2] | 0);
  HEAP32[i14 + 312 >> 2] = i2;
  HEAP32[i14 + 316 >> 2] = i1;
 }
 HEAP8[i14 + 340 >> 0] = i6 >>> 0 > 31 & 1;
 HEAP32[i14 + 320 >> 2] = i4;
 HEAP32[i14 + 324 >> 2] = i5;
 HEAP32[i14 + 328 >> 2] = i9;
 HEAP32[i14 + 336 >> 2] = 0;
 i1 = i14 + 300 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i14 + 304 >> 0] = 0;
 if (!i13) if (HEAP32[i12 + 8 >> 2] | 0) {
  i13 = (HEAP32[i12 + 12 >> 2] | 0) + i7 | 0;
  HEAP32[i14 + 288 >> 2] = HEAP32[i14 + 364 >> 2];
  HEAP32[i14 + 292 >> 2] = i13;
  HEAP32[i14 + 296 >> 2] = 16;
  HEAP32[i1 >> 2] = i8;
 }
 i12 = HEAP32[i14 + 380 >> 2] | 0;
 i13 = (HEAP32[i12 + 60 >> 2] | 0) + (i10 << 4) | 0;
 i13 = (i13 | 0) == 0 ? 0 : i12 + i13 | 0;
 HEAP32[i14 + 284 >> 2] = (i13 | 0) == 0 ? 0 : i11;
 HEAP32[i14 + 280 >> 2] = i13;
 i14 = i14 + 404 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5Umbra15CameraTransformC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 i1 = i2;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i3 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i3 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i3 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i3 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i3 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 _memcpy(i3 + 64 | 0, i1 + 64 | 0, 276) | 0;
 HEAP32[i3 + 340 >> 2] = HEAP32[i1 + 340 >> 2];
 HEAP32[i3 + 344 >> 2] = HEAP32[i1 + 344 >> 2];
 HEAP32[i3 + 348 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i3 + 352 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i3 + 356 >> 2] = HEAP32[i1 + 356 >> 2];
 HEAP32[i3 + 360 >> 2] = HEAP32[i1 + 360 >> 2];
 HEAP32[i3 + 364 >> 2] = HEAP32[i1 + 364 >> 2];
 HEAP32[i3 + 368 >> 2] = HEAP32[i1 + 368 >> 2];
 HEAP32[i3 + 372 >> 2] = HEAP32[i1 + 372 >> 2];
 HEAP32[i3 + 376 >> 2] = HEAP32[i1 + 376 >> 2];
 HEAP32[i3 + 380 >> 2] = HEAP32[i1 + 380 >> 2];
 HEAP32[i3 + 384 >> 2] = HEAP32[i1 + 384 >> 2];
 HEAP32[i3 + 388 >> 2] = HEAP32[i1 + 388 >> 2];
 HEAP32[i3 + 392 >> 2] = HEAP32[i1 + 392 >> 2];
 HEAP32[i3 + 396 >> 2] = HEAP32[i1 + 396 >> 2];
 HEAP32[i3 + 400 >> 2] = HEAP32[i1 + 400 >> 2];
 i2 = i3 + 404 | 0;
 i1 = i1 + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i2 + 32 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
 return;
}

function __ZN15ResourceManager16FindDependenciesEiR13dynamic_arrayIiLj4EE(i10, i9, i11) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i7 = i11 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + (i8 << 2) | 0;
 L1 : do if (!i8) {
  i2 = i1;
  i4 = 4;
 } else {
  i2 = i1;
  do {
   if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
    i4 = 4;
    break L1;
   }
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } while (0);
 if ((i4 | 0) == 4) if ((i2 | 0) != (i3 | 0)) return;
 i6 = i8 + 1 | 0;
 i3 = i11 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i6 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i11 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i11 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i6;
 HEAP32[i1 + (i8 << 2) >> 2] = i9;
 i2 = HEAP32[i10 + 28 >> 2] | 0;
 i6 = HEAP32[i10 + 32 >> 2] | 0;
 i1 = i6 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 20 | 0;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 * 20 | 0) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i9 | 0);
   i4 = i4 + 20 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) return;
 if ((HEAP32[i1 >> 2] | 0) != (i9 | 0)) return;
 i4 = i1 + 4 | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return; else i2 = 0;
 do {
  __ZN15ResourceManager16FindDependenciesEiR13dynamic_arrayIiLj4EE(i10, HEAP32[i1 + (i2 << 2) >> 2] | 0, i11);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0);
 return;
}

function __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i9 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
  i4 = i3;
 }
 i1 = i7 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 i1 = i7 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i7 + 12 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  i2 = i4;
 }
 i5 = i7 + 20 | 0;
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i7 + 16 >> 2] = i3;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 i1 = i3 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i3 = i5;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2 + i3 | 0, i1 << 2);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Cm21visualizeAngularLimitERNS0_12RenderOutputEfRKNS_11PxTransformEffb(i9, f10, i2, f7, f3, i1) {
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 var f4 = f0, i5 = 0, f6 = f0, i8 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i11 + 48 | 0;
 i14 = i11 + 36 | 0;
 i13 = i11 + 24 | 0;
 i5 = i11 + 12 | 0;
 i8 = i11;
 i2 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i9, i2) | 0;
 __ZN5physx2Cm12RenderOutputlsEj(i2, i1 ? -65536 : -8355712) | 0;
 i2 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i9, 1) | 0;
 HEAPF32[i15 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i15 + 8 >> 2] = Math_fround(0.0);
 i2 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i2, i15) | 0;
 f6 = Math_fround(f10 * Math_fround(0.0));
 f4 = Math_fround(Math_fround(+Math_cos(+f7)) * f10);
 f12 = Math_fround(Math_fround(+Math_sin(+f7)) * f10);
 HEAPF32[i14 >> 2] = f6;
 HEAPF32[i14 + 4 >> 2] = f4;
 HEAPF32[i14 + 8 >> 2] = f12;
 i2 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i2, i14) | 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 8 >> 2] = Math_fround(0.0);
 i2 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i2, i13) | 0;
 f12 = Math_fround(Math_fround(+Math_cos(+f3)) * f10);
 f4 = Math_fround(Math_fround(+Math_sin(+f3)) * f10);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i5 + 4 >> 2] = f12;
 HEAPF32[i5 + 8 >> 2] = f4;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i2, i5) | 0;
 __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i9, 2) | 0;
 f4 = Math_fround(Math_fround(f3 - f7) / Math_fround(20.0));
 i2 = i8 + 4 | 0;
 i5 = i8 + 8 | 0;
 f3 = f7;
 i1 = 0;
 do {
  f7 = Math_fround(Math_fround(+Math_cos(+f3)) * f10);
  f12 = Math_fround(Math_fround(+Math_sin(+f3)) * f10);
  HEAPF32[i8 >> 2] = f6;
  HEAPF32[i2 >> 2] = f7;
  HEAPF32[i5 >> 2] = f12;
  __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i9, i8) | 0;
  i1 = i1 + 1 | 0;
  f3 = Math_fround(f4 + f3);
 } while ((i1 | 0) != 21);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 320 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_17MemoryEventHeaderE(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP8[i9 >> 0] | 0) != 0 | i1 >>> 0 < 4) {
  HEAP8[i9 >> 0] = 1;
  i7 = i12;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i8 = 1;
 } else {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i4 = i2 + 1 | 0;
  HEAP32[i12 >> 2] = i4;
  HEAP32[i10 >> 2] = i1 + -1;
  i4 = HEAP8[i4 >> 0] | 0;
  i5 = i2 + 2 | 0;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i10 >> 2] = i1 + -2;
  i5 = HEAP8[i5 >> 0] | 0;
  i6 = i2 + 3 | 0;
  HEAP32[i12 >> 2] = i6;
  HEAP32[i10 >> 2] = i1 + -3;
  i6 = HEAP8[i6 >> 0] | 0;
  i2 = i2 + 4 | 0;
  HEAP32[i12 >> 2] = i2;
  i1 = i1 + -4 | 0;
  HEAP32[i10 >> 2] = i1;
  i7 = i12;
  i8 = 0;
 }
 i6 = (i4 & 255) << 16 | (i3 & 255) << 24 | (i5 & 255) << 8 | i6 & 255;
 i6 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
 HEAP32[i11 >> 2] = i2;
 i2 = (HEAP32[i7 >> 2] | 0) + i6 | 0;
 HEAP32[i7 >> 2] = i2;
 i7 = i1 - i6 | 0;
 HEAP32[i10 >> 2] = i7;
 i1 = i11 + 4 | 0;
 if (i8 | i7 >>> 0 < 4) {
  HEAP8[i9 >> 0] = 1;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i7 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  i9 = i1 + 1 | 0;
  HEAP8[i9 >> 0] = HEAP8[i7 >> 0] | 0;
  i7 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  i11 = i1 + 2 | 0;
  HEAP8[i11 >> 0] = HEAP8[i7 >> 0] | 0;
  i7 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  i8 = i1 + 3 | 0;
  HEAP8[i8 >> 0] = HEAP8[i7 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  i12 = HEAP8[i1 >> 0] | 0;
  HEAP8[i1 >> 0] = HEAP8[i8 >> 0] | 0;
  HEAP8[i8 >> 0] = i12;
  i12 = HEAP8[i9 >> 0] | 0;
  HEAP8[i9 >> 0] = HEAP8[i11 >> 0] | 0;
  HEAP8[i11 >> 0] = i12;
  return;
 }
}

function __ZN5physx6shdfnd10FoundationD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i6 = i9 + 4 | 0;
 HEAP32[i8 >> 2] = gb + 110452 + 8;
 i7 = i8 + 96 | 0;
 i5 = i8 + 100 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) {
    i1 = i2;
    do {
     i2 = i1;
     i1 = HEAP32[i1 >> 2] | 0;
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
    } while ((i1 | 0) != 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE6resizeEjRKS3_(i7, 0, i4);
 __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE8recreateEj(i7, HEAP32[i5 >> 2] | 0);
 __ZN5physx6shdfnd12ErrorHandlerD2Ev(i8 + 116 | 0);
 i1 = i8 + 108 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i6 = (HEAP32[gb + 1452348 >> 2] | 0) + 8 | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 }
 i6 = HEAP32[i8 + 104 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i7 >> 2] | 0);
 i1 = i8 + 92 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i7 = (HEAP32[gb + 1452348 >> 2] | 0) + 8 | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 i1 = HEAP32[i8 + 52 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[gb + 1452348 >> 2] | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 i1 = i8 + 48 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i8 = (HEAP32[gb + 1452348 >> 2] | 0) + 8 | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 STACKTOP = i9;
 return;
}

function __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 87;
 HEAP32[i6 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(64, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
 i5 = i3 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i5;
  if (i5) i11 = 6;
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i5 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i5;
  i1 = i6;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i7 + 32 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i7 + 36 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i7 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 56 >> 2] = Math_fround(1.0);
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i11 = i10 + 9 | 0;
 HEAP8[i11 >> 0] = 1;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getWorldBoundsEf(i10, i1, f11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13;
 i9 = i13 + 8 | 0;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i12 = 3;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i12 = 4; else i12 = 3;
   break;
  }
 default:
  i12 = 4;
 }
 if ((i12 | 0) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 700634 | 0, 437, gb + 700721 | 0, i2);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 } else if ((i12 | 0) == 4) {
  __ZNK5physx2Sc18ParticleSystemCore14getWorldBoundsEv(i9, i1 + 32 | 0);
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 }
 f14 = Math_fround(Math_fround(f4 + f5) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f6 + f7) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f8 + f3) * Math_fround(.5));
 f4 = Math_fround(Math_fround(Math_fround(f5 - f4) * Math_fround(.5)) * f11);
 f16 = Math_fround(Math_fround(Math_fround(f7 - f6) * Math_fround(.5)) * f11);
 f11 = Math_fround(Math_fround(Math_fround(f3 - f8) * Math_fround(.5)) * f11);
 f5 = Math_fround(f17 - f16);
 f6 = Math_fround(f15 - f11);
 f7 = Math_fround(f14 + f4);
 f8 = Math_fround(f17 + f16);
 f11 = Math_fround(f15 + f11);
 HEAPF32[i10 >> 2] = Math_fround(f14 - f4);
 HEAPF32[i10 + 4 >> 2] = f5;
 HEAPF32[i10 + 8 >> 2] = f6;
 HEAPF32[i10 + 12 >> 2] = f7;
 HEAPF32[i10 + 16 >> 2] = f8;
 HEAPF32[i10 + 20 >> 2] = f11;
 STACKTOP = i13;
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i1, i2, f7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = HEAP32[i1 + 164 >> 2] | 0;
 i6 = HEAP32[i1 + 152 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 L1 : do if ((i4 | 0) == -1) {
  i5 = 0;
  i1 = i10;
 } else {
  f3 = Math_fround(HEAPF32[i6 + (i4 * 52 | 0) >> 2]);
  if (f3 < f7) {
   i1 = i4 + 1 | 0;
   if ((i1 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i1 * 52 | 0) >> 2]) > f7) {
    i2 = i1;
    i1 = i4;
   } else i5 = 6; else i5 = 6;
   do if ((i5 | 0) == 6) {
    i2 = i4 + 2 | 0;
    if ((i2 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i2 * 52 | 0) >> 2]) > f7) break;
    i1 = i4 + 3 | 0;
    if ((i1 | 0) >= (i10 | 0)) {
     i5 = 0;
     i1 = i10;
     break L1;
    }
    if (Math_fround(HEAPF32[i6 + (i1 * 52 | 0) >> 2]) > f7) {
     i2 = i1;
     i1 = i4 + 2 | 0;
    } else {
     i5 = 0;
     i1 = i10;
     break L1;
    }
   } while (0);
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i2 | 0) ? i10 : i2;
   return;
  } else {
   if ((i4 | 0) > -1) if (!(f3 <= f7)) {
    i1 = i4 + -1 | 0;
    if ((i4 | 0) <= 0) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 * 52 | 0) >> 2]) <= f7)) i5 = 21;
   } else i1 = i4; else i5 = 21;
   if ((i5 | 0) == 21) {
    i1 = i4 + -2 | 0;
    if ((i1 | 0) <= -1) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 * 52 | 0) >> 2]) <= f7)) {
     i5 = 0;
     i1 = i10;
     break;
    }
   }
   i6 = i1 + 1 | 0;
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i6 | 0) ? i10 : i6;
   return;
  }
 } while (0);
 L25 : while (1) {
  while (1) {
   if ((i1 | 0) <= 0) break L25;
   i2 = i1 >> 1;
   i4 = i2 + i5 | 0;
   if (Math_fround(HEAPF32[i6 + (i4 * 52 | 0) >> 2]) > f7) i1 = i2; else break;
  }
  i5 = i4 + 1 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 HEAP32[i8 >> 2] = i5 + -1;
 i10 = i10 + -1 | 0;
 HEAP32[i9 >> 2] = (i5 | 0) < (i10 | 0) ? i5 : i10;
 return;
}

function __ZN9Texture2D8SetPixelEiiiRK10ColorRGBAf(i10, i3, i5, i6, i7) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i11 + 4 | 0;
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i10) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = i10 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) >= 0) {
  if (!i2) i4 = 0; else i4 = HEAP32[i2 + 44 >> 2] | 0;
  if ((i4 | 0) > (i3 | 0)) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   HEAP32[i9 + 16 >> 2] = 0;
   L10 : do if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i10, i9, i3, 0) | 0) __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf(i9, i5, i6, HEAP32[i10 + 44 >> 2] | 0, i7); else {
    i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
    do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
     i2 = i1 + -30 | 0;
     if (i2 >>> 0 < 15) {
      if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
     } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break;
     __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 934273 | 0, 0, gb + 410682 | 0, 1157, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
     break L10;
    } while (0);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 410682 | 0, 1153, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
   } while (0);
   STACKTOP = i11;
   return;
  }
 }
 if (!i2) i1 = -1; else i1 = (HEAP32[i2 + 44 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i1;
 __Z6FormatPKcz(i9, gb + 416717 | 0, i8);
 if (!i10) i1 = 0; else i1 = HEAP32[i10 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 410682 | 0, 1140, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 356 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 356 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 332) | 0;
 __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 356 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN19MemoryProfilerStats21ChangePersistancyflagEibb(i5, i1, i6, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!(i6 ^ i2)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    STACKTOP = i7;
    return;
   }
   i2 = i5 + 100 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i6) {
    HEAP32[i2 >> 2] = i3 + -1;
    i6 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
    i4 = i5 + 104 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
    if ((i6 | 0) != 1) {
     STACKTOP = i7;
     return;
    }
    i6 = i5 + 108 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
    STACKTOP = i7;
    return;
   } else {
    HEAP32[i2 >> 2] = i3 + 1;
    i6 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0;
    i4 = i5 + 104 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
    if ((i6 | 0) != 1) {
     STACKTOP = i7;
     return;
    }
    i6 = i5 + 108 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    STACKTOP = i7;
    return;
   }
  }
 }
 STACKTOP = i7;
 return;
}

function __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 i11 = i12 + 80 | 0;
 i8 = i10 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i10 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i11 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i12 + 88 | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i10);
 i6 = i12 + 176 | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i10);
 i4 = i12 + 84 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 2 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i1 = HEAP16[i7 >> 1] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i7 >> 1] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP16[i4 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i10);
 f2 = Math_fround(HEAPF32[i11 >> 2]);
 i11 = HEAP16[i4 >> 1] | 0;
 i1 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12, i5, f2) | 0;
 if ((i11 & -2) << 16 >> 16 == 2) {
  if (!i1) {
   i11 = 0;
   i12 = i12 + 86 | 0;
   i11 = i11 & 1;
   HEAP8[i12 >> 0] = i11;
   STACKTOP = i13;
   return;
  }
  i11 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12 + 40 | 0, i6, f2) | 0;
  i12 = i12 + 86 | 0;
  i11 = i11 & 1;
  HEAP8[i12 >> 0] = i11;
  STACKTOP = i13;
  return;
 } else {
  if (!i1) {
   i11 = 0;
   i12 = i12 + 86 | 0;
   i11 = i11 & 1;
   HEAP8[i12 >> 0] = i11;
   STACKTOP = i13;
   return;
  }
  i11 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i12 + 40 | 0, i5, f2) | 0;
  i12 = i12 + 86 | 0;
  i11 = i11 & 1;
  HEAP8[i12 >> 0] = i11;
  STACKTOP = i13;
  return;
 }
}

function __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f3 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(-Math_fround(HEAPF32[i1 + 12 >> 2]));
 if ((i4 | 0) > 0) i1 = 0; else {
  i4 = 1;
  return i4 | 0;
 }
 while (1) {
  f21 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
  f17 = Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i2 + (i1 << 4) + 8 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + (i1 << 4) + 12 >> 2]);
  i8 = i1 | 1;
  f22 = Math_fround(HEAPF32[i2 + (i8 << 4) >> 2]);
  f18 = Math_fround(HEAPF32[i2 + (i8 << 4) + 4 >> 2]);
  f14 = Math_fround(HEAPF32[i2 + (i8 << 4) + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i2 + (i8 << 4) + 12 >> 2]);
  i8 = i1 | 2;
  f23 = Math_fround(HEAPF32[i2 + (i8 << 4) >> 2]);
  f19 = Math_fround(HEAPF32[i2 + (i8 << 4) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i2 + (i8 << 4) + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i2 + (i8 << 4) + 12 >> 2]);
  i8 = i1 | 3;
  f20 = Math_fround(HEAPF32[i2 + (i8 << 4) >> 2]);
  f16 = Math_fround(HEAPF32[i2 + (i8 << 4) + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i2 + (i8 << 4) + 8 >> 2]);
  i1 = i1 + 4 | 0;
  if ((Math_fround(Math_fround(f7 * f23) + Math_fround(Math_fround(f6 * f22) + Math_fround(Math_fround(f5 * f21) + f20))) < f3 ? 1 : Math_fround(Math_fround(f7 * f19) + Math_fround(Math_fround(f6 * f18) + Math_fround(Math_fround(f5 * f17) + f16))) < f3) | Math_fround(Math_fround(f7 * f15) + Math_fround(Math_fround(f6 * f14) + Math_fround(Math_fround(f5 * f13) + f12))) < f3 | Math_fround(Math_fround(f7 * f11) + Math_fround(Math_fround(f6 * f10) + Math_fround(Math_fround(f5 * f9) + Math_fround(HEAPF32[i2 + (i8 << 4) + 12 >> 2])))) < f3) {
   i1 = 0;
   i2 = 4;
   break;
  }
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5, i12, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i7 = i12;
 i6 = i8 - i7 | 0;
 i4 = (i6 | 0) / 20 | 0;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i9 = i10;
 if (i4 >>> 0 <= ((i1 - i10 | 0) / 20 | 0) >>> 0) {
  i6 = i5 + 4 | 0;
  i3 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 20 | 0;
  i5 = i4 >>> 0 > i3 >>> 0;
  i4 = i5 ? i12 + (i3 * 20 | 0) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  if (i1 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (((i1 | 0) / 20 | 0) * 20 | 0) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (((i1 >>> 0) / 20 | 0) * 20 | 0);
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -20 - i10 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i3);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if (i4 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = (i1 - i2 | 0) / 20 | 0;
 i1 = i10 << 1;
 i1 = i10 >>> 0 < 107374182 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 214748364;
 if (i1 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i2 = __Znwj(i1 * 20 | 0) | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i11 >> 2] = i2 + (i1 * 20 | 0);
 if ((i6 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i6 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (((i6 >>> 0) / 20 | 0) * 20 | 0);
 return;
}

function __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE(i2, i1, i16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i21 + 28 | 0;
 i20 = i21;
 i18 = HEAP32[i2 + 4 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i14 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i14 = (i3 | 0) < (i14 | 0) ? i3 : i14;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i15 = i20 + 4 | 0;
 HEAP32[i15 >> 2] = i3;
 HEAP32[i20 >> 2] = HEAP32[i2 + 16 >> 2];
 i17 = i20 + 12 | 0;
 HEAP32[i17 >> 2] = (i13 | 0) < (i18 | 0) ? i13 : i18;
 if (!i14) {
  STACKTOP = i21;
  return;
 }
 i18 = i16 + 4 | 0;
 i13 = i1 + 12 | 0;
 i6 = i2 + 12 | 0;
 i7 = i16 + 16 | 0;
 i8 = i16 + 12 | 0;
 i9 = i16 + 20 | 0;
 i10 = i19 + 4 | 0;
 i11 = i19 + 12 | 0;
 i12 = i16 + 8 | 0;
 i5 = 0;
 i1 = i3;
 do {
  if (!(HEAP8[i16 >> 0] | 0)) mftCall_vi(HEAP32[i18 >> 2] | 0, i20 | 0); else {
   i4 = HEAP32[i17 >> 2] | 0;
   if ((HEAP32[i7 >> 2] | 0) >>> 0 < i4 >>> 0) {
    i2 = HEAP32[i8 >> 2] | 0;
    if (!i2) i2 = i4; else {
     __ZdaPv(i2);
     i1 = HEAP32[i15 >> 2] | 0;
     i2 = HEAP32[i17 >> 2] | 0;
    }
    i22 = HEAP32[i9 >> 2] | 0;
    i3 = __Znaj(Math_imul(i22, i4 + 1 | 0) | 0) | 0;
    HEAP32[i8 >> 2] = i3;
    _memset(i3 + (Math_imul(i22, i4) | 0) | 0, 0, i22 | 0) | 0;
    HEAP32[i7 >> 2] = i4;
   } else {
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = i4;
   }
   HEAP32[i10 >> 2] = i1;
   HEAP32[i19 >> 2] = i3;
   HEAP32[i11 >> 2] = i2;
   mftCall_vi(HEAP32[i18 >> 2] | 0, i19 | 0);
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i19 >> 2] = HEAP32[i20 >> 2];
   HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
   mftCall_vi(HEAP32[i12 >> 2] | 0, i19 | 0);
  }
  i1 = (HEAP32[i15 >> 2] | 0) + (HEAP32[i13 >> 2] | 0) | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i20 >> 2] = (HEAP32[i20 >> 2] | 0) + (HEAP32[i6 >> 2] | 0);
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < i14 >>> 0);
 STACKTOP = i21;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (!i5) i3 = i2; else {
    i3 = i2;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i3 + i5 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP8[i2 + 16 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
  i1 = i6 + 36 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 36 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else i6 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (!i5) i3 = i2; else {
    i3 = i2;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i3 + i5 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP8[i2 + 16 >> 0] = HEAP8[i1 + 16 >> 0] | 0;
  i1 = i6 + 36 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 36 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else i6 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) - i2 >> 6 >>> 0 >= i3 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i3) {
  i4 = 0;
  i5 = i1;
  i6 = i2;
 } else {
  i4 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 6, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i4 + (i1 - i2 >> 6 << 6) | 0;
 i7 = i1;
 i4 = i4 + (i3 << 6) | 0;
 if ((i5 | 0) == (i6 | 0)) {
  i1 = i7;
  i6 = i5;
  i2 = i5;
 } else {
  i2 = i5;
  i3 = i7;
  do {
   i2 = i2 + -64 | 0;
   __ZN14AnimationEventC2ERKS_(i1 + -64 | 0, i2);
   i1 = i3 + -64 | 0;
   i3 = i1;
  } while ((i2 | 0) != (i6 | 0));
  i1 = i3;
  i6 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i4;
 i3 = i6;
 if ((i2 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  i5 = i12 + 4 | 0;
  do {
   i1 = i2 + -44 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
   i1 = i2 + -60 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
   i2 = i2 + -64 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i13;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getWorldBoundsEf(i10, i1, f11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 f11 = Math_fround(f11);
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13;
 i9 = i13 + 8 | 0;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i12 = 3;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i12 = 4; else i12 = 3;
   break;
  }
 default:
  i12 = 4;
 }
 if ((i12 | 0) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 700634 | 0, 437, gb + 700721 | 0, i2);
  f4 = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 } else if ((i12 | 0) == 4) {
  __ZNK5physx2Sc18ParticleSystemCore14getWorldBoundsEv(i9, i1 + 32 | 0);
  f4 = Math_fround(HEAPF32[i9 >> 2]);
  f5 = Math_fround(HEAPF32[i9 + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i9 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f8 = Math_fround(HEAPF32[i9 + 8 >> 2]);
  f3 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 }
 f14 = Math_fround(Math_fround(f4 + f5) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f6 + f7) * Math_fround(.5));
 f15 = Math_fround(Math_fround(f8 + f3) * Math_fround(.5));
 f4 = Math_fround(Math_fround(Math_fround(f5 - f4) * Math_fround(.5)) * f11);
 f16 = Math_fround(Math_fround(Math_fround(f7 - f6) * Math_fround(.5)) * f11);
 f11 = Math_fround(Math_fround(Math_fround(f3 - f8) * Math_fround(.5)) * f11);
 f5 = Math_fround(f17 - f16);
 f6 = Math_fround(f15 - f11);
 f7 = Math_fround(f14 + f4);
 f8 = Math_fround(f17 + f16);
 f11 = Math_fround(f15 + f11);
 HEAPF32[i10 >> 2] = Math_fround(f14 - f4);
 HEAPF32[i10 + 4 >> 2] = f5;
 HEAPF32[i10 + 8 >> 2] = f6;
 HEAPF32[i10 + 12 >> 2] = f7;
 HEAPF32[i10 + 16 >> 2] = f8;
 HEAPF32[i10 + 20 >> 2] = f11;
 STACKTOP = i13;
 return;
}

function __ZNK25BlendshapePropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i7, i1, i3, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!(__Z10BeginsWithPKcS0_(i2, HEAP32[gb + 57896 >> 2] | 0) | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i4 = __Z11StringToIntPKc(i2 + (_strlen(HEAP32[gb + 57896 >> 2] | 0) | 0) | 0) | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31632 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31632 + 28 >> 2] | 0) >>> 0) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i1 = __ZN19SkinnedMeshRenderer7GetMeshEv(i3) | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i2 = i1 + 112 | 0;
 i3 = i1 + 116 | 0;
 if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 4 | 0) <= (i4 | 0)) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[gb + 57892 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, _strlen(i1) | 0);
 if ((i4 | 0) < 0) i1 = gb + 1576256 | 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (((HEAP32[i3 >> 2] | 0) - i1 >> 4 | 0) > (i4 | 0)) i1 = HEAP32[i1 + (i4 << 4) >> 2] | 0; else i1 = gb + 1576256 | 0;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 i4 = _strlen(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i7, i2 ? HEAP32[i5 >> 2] | 0 : i5, i3, i3 + i4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i1, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZN9dtNavMesh23removeOffMeshConnectionEy(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!((i1 & 983040 | 0) == 65536 & 0 == 0)) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i10 = i1 & 65535;
 if (i10 >>> 0 > (HEAP32[i9 + 44 >> 2] | 0) >>> 0) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i1 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 i2 = getTempRet0() | 0;
 i8 = i9 + 48 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (HEAP32[i3 + (i10 * 104 | 0) + 92 >> 2] | 0)) {
  i11 = -2147483640;
  return i11 | 0;
 }
 i6 = _bitshift64Shl(i1 | 0, i2 | 0, 48) | 0;
 i5 = getTempRet0() | 0;
 i6 = i10 | i6 | 65536;
 i7 = i3 + (i10 * 104 | 0) + 88 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == -1) i5 = i3; else {
  i3 = i9 + 36 | 0;
  i4 = i9 + 28 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do {
   i12 = i1;
   i1 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
   i13 = i2 + (i12 << 4) | 0;
   __ZN9dtNavMesh17removeLinkBetweenEyy(i9, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, i6, i5);
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 + (i12 << 4) + 8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i12;
  } while ((i1 | 0) != -1);
  i5 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = -1;
 i4 = i9 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == -1 | (i1 | 0) == (i10 | 0)) {
  i1 = i5 + (i10 * 104 | 0) + 96 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i11 = 12;
 } else {
  i3 = i1;
  while (1) {
   i1 = HEAP32[i5 + (i3 * 104 | 0) + 96 >> 2] | 0;
   if ((i1 | 0) == -1 | (i1 | 0) == (i10 | 0)) break; else i3 = i1;
  }
  i1 = i5 + (i10 * 104 | 0) + 96 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) == -1) i11 = 12; else HEAP32[i5 + (i3 * 104 | 0) + 96 >> 2] = i2;
 }
 if ((i11 | 0) == 12) HEAP32[i4 >> 2] = i2;
 i13 = i5 + (i10 * 104 | 0) + 92 | 0;
 i12 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
 HEAP32[i13 >> 2] = (i12 | 0) == 0 ? 1 : i12;
 i13 = i9 + 40 | 0;
 HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i10;
 i13 = i9 + 56 | 0;
 i12 = (HEAP32[i13 >> 2] | 0) + 1 | 0;
 HEAP32[i13 >> 2] = (i12 | 0) == 0 ? 1 : i12;
 i13 = 1073741824;
 return i13 | 0;
}

function __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite17TransferBasicDataIyEEvRT_(i10, i11);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags(i10, i11, i13, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if (!((i1 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = i10 + 36 | 0;
 i12 = i10 + 48 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i6 + (i9 + -1 << 2) >> 2] | i1;
 i8 = i9 + 1 | 0;
 i2 = i10 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i8 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
   i1 = i6;
   break;
  } else i1 = i6;
 } else i1 = i6; while (0);
 HEAP32[i12 >> 2] = i8;
 HEAP32[i1 + (i9 << 2) >> 2] = i7;
 i1 = i10 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 HEAP32[i14 + 16 >> 2] = 3;
 HEAP32[i1 >> 2] = i14;
 __ZN9JSONWrite17TransferBasicDataIxEEvRT_(i10, i11);
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i10, i2, i13, i14);
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 HEAP32[i1 >> 2] = i2;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i14);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Sn18writeAllPropertiesINS_15PxParticleFluidEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE(i4, i5, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 484 | 0;
 i14 = i7 + 456 | 0;
 i10 = i7 + 48 | 0;
 i9 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i13 = i6;
 i12 = i5;
 i11 = i4;
 i4 = i2;
 i5 = i3;
 __ZN5physx28PxParticleFluidGeneratedInfoC2Ev(i10);
 HEAP32[i15 >> 2] = i13;
 HEAP32[i15 + 4 >> 2] = i12;
 HEAP32[i15 + 8 >> 2] = i11;
 HEAP32[i15 + 12 >> 2] = i4;
 HEAP32[i15 + 16 >> 2] = i5;
 HEAP32[i15 + 20 >> 2] = 0;
 HEAP32[i15 + 24 >> 2] = 0;
 i3 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i10, i15, 0) | 0;
 HEAP32[i14 >> 2] = i13;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i4;
 HEAP32[i14 + 16 >> 2] = i5;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i10, i14, i3) | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 HEAP32[i9 + 8 >> 2] = i11;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx28PxParticleFluidGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j(i10, i9, 0) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i15 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i7, i8, i5, i2, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 576 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 556 | 0;
 i1 = i11 + 552 | 0;
 i10 = i11 + 536 | 0;
 i9 = i11 + 520 | 0;
 i13 = i11 + 12 | 0;
 i15 = i11;
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i15 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i4 = i10 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = i1;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i12 = i9 + 12 | 0;
 HEAP32[i12 >> 2] = 0;
 __ZN5physx27PxRigidDynamicGeneratedInfoC2Ev(i13);
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 i2 = __ZN5physx2Sn17readAllPropertiesINS_14PxRigidDynamicENS_27PxRigidDynamicGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_(i14, i10, i9, i8, i7, i5, i6, i13) | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i15 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
  }
 }
 i15 = HEAP32[i4 >> 2] | 0;
 if (!((i15 | 0) > -1 & (i15 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 i15 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i1 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN9AudioClip28ScriptPCMSetPositionCallbackEP10FMOD_SOUNDijj(i3, i1, i10, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 256 | 0;
 i8 = i9 + 248 | 0;
 i4 = i9 + 252 | 0;
 i5 = i9;
 i6 = i9 + 240 | 0;
 __ZN4FMOD5Sound11getUserDataEPPv(i3, i4) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  i10 = 20;
  STACKTOP = i9;
  return i10 | 0;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
  i1 = gb + 874396 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 874396 + 88 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459916 >> 2] = i1;
  i2 = gb + 1098880 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459916 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = 0;
 i1 = __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE(i1) | 0;
 if (!i1) {
  i10 = 20;
  STACKTOP = i9;
  return i10 | 0;
 }
 i2 = i1 + 124 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i8 >> 2] = gb + 854794;
  __Z6FormatPKcz(i7, gb + 854751 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 854901 | 0, 268, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + 68 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i8, i7);
 __ZN18ScriptingArguments6AddIntEi(i5, i10);
 HEAP32[i5 + 216 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i7, 0) | 0;
 i10 = 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 16 | 0;
 i6 = i7 + 8 | 0;
 i3 = i7;
 i4 = i1 + 224 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) {
  i6 = i5;
  STACKTOP = i7;
  return i6 | 0;
 }
 __ZNK6Object14GetMemoryLabelEv(i3, i1);
 i5 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 410214 | 0, 360) | 0;
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = gb + 33952 + 8;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i6);
 i1 = i2;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i5 + 36 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i6);
 i1 = i2;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i5 + 56 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 HEAP32[i5 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i6);
 i1 = i2;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i5 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 96 >> 2] = 0;
 i2 = i3;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i5 + 100 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP8[i5 + 108 >> 0] = 1;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 i6 = i5;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx31collideWithCapsuleNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_S6_(i12, i5, i1, i13, i7) {
 i12 = i12 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i6 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0;
 i10 = i12 + 124 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 if (i11 & 2 | 0) return;
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(-f9);
 f8 = f4 > f8 ? f4 : f8;
 f9 = f8 < f9 ? f8 : f9;
 i6 = i12 + 144 | 0;
 f4 = Math_fround(f4 - f9);
 i16 = HEAP32[i5 + 4 >> 2] | 0;
 i15 = HEAP32[i5 + 8 >> 2] | 0;
 HEAPF32[i6 >> 2] = f4;
 i1 = i12 + 148 | 0;
 HEAP32[i1 >> 2] = i16;
 i5 = i12 + 152 | 0;
 HEAP32[i5 >> 2] = i15;
 f8 = Math_fround(f4 * f4);
 f2 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(f8 + Math_fround(f2 * f2));
 f3 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f3 * f3))));
 f14 = Math_fround(HEAPF32[i13 >> 2]);
 if (!(f8 < Math_fround(f14 + Math_fround(HEAPF32[i7 >> 2])))) return;
 if (f8 != Math_fround(0.0)) {
  f18 = Math_fround(Math_fround(1.0) / f8);
  f17 = Math_fround(f4 * f18);
  HEAPF32[i6 >> 2] = f17;
  f14 = Math_fround(f18 * f2);
  HEAPF32[i1 >> 2] = f14;
  f4 = Math_fround(f18 * f3);
  HEAPF32[i5 >> 2] = f4;
  f2 = f17;
  f3 = f14;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f19 = Math_fround(HEAPF32[i13 >> 2]);
 f18 = Math_fround(HEAPF32[i12 + 92 >> 2]);
 f19 = Math_fround(f19 + f18);
 f14 = Math_fround(Math_fround(f19 * f3) + Math_fround(0.0));
 f17 = Math_fround(Math_fround(f19 * f4) + Math_fround(0.0));
 HEAPF32[i12 + 160 >> 2] = Math_fround(f9 + Math_fround(f2 * f19));
 HEAPF32[i12 + 164 >> 2] = f14;
 HEAPF32[i12 + 168 >> 2] = f17;
 HEAP32[i10 >> 2] = i11 | 32;
 if (!(f8 < Math_fround(Math_fround(HEAPF32[i13 >> 2]) + f18))) return;
 HEAP32[i10 >> 2] = i11 | 48;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_(i1, i2, f7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = HEAP32[i1 + 132 >> 2] | 0;
 i6 = HEAP32[i1 + 120 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 L1 : do if ((i4 | 0) == -1) {
  i5 = 0;
  i1 = i10;
 } else {
  f3 = Math_fround(HEAPF32[i6 + (i4 * 40 | 0) >> 2]);
  if (f3 < f7) {
   i1 = i4 + 1 | 0;
   if ((i1 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]) > f7) {
    i2 = i1;
    i1 = i4;
   } else i5 = 6; else i5 = 6;
   do if ((i5 | 0) == 6) {
    i2 = i4 + 2 | 0;
    if ((i2 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i2 * 40 | 0) >> 2]) > f7) break;
    i1 = i4 + 3 | 0;
    if ((i1 | 0) >= (i10 | 0)) {
     i5 = 0;
     i1 = i10;
     break L1;
    }
    if (Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]) > f7) {
     i2 = i1;
     i1 = i4 + 2 | 0;
    } else {
     i5 = 0;
     i1 = i10;
     break L1;
    }
   } while (0);
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i2 | 0) ? i10 : i2;
   return;
  } else {
   if ((i4 | 0) > -1) if (!(f3 <= f7)) {
    i1 = i4 + -1 | 0;
    if ((i4 | 0) <= 0) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]) <= f7)) i5 = 21;
   } else i1 = i4; else i5 = 21;
   if ((i5 | 0) == 21) {
    i1 = i4 + -2 | 0;
    if ((i1 | 0) <= -1) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 * 40 | 0) >> 2]) <= f7)) {
     i5 = 0;
     i1 = i10;
     break;
    }
   }
   i6 = i1 + 1 | 0;
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i6 | 0) ? i10 : i6;
   return;
  }
 } while (0);
 L25 : while (1) {
  while (1) {
   if ((i1 | 0) <= 0) break L25;
   i2 = i1 >> 1;
   i4 = i2 + i5 | 0;
   if (Math_fround(HEAPF32[i6 + (i4 * 40 | 0) >> 2]) > f7) i1 = i2; else break;
  }
  i5 = i4 + 1 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 HEAP32[i8 >> 2] = i5 + -1;
 i10 = i10 + -1 | 0;
 HEAP32[i9 >> 2] = (i5 | 0) < (i10 | 0) ? i5 : i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 320 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 336 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 296) | 0;
 __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 320 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN13OcclusionArea8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 32 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 40 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 48 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 52 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 56 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE13stl_allocatorIS6_L18MemLabelIdentifier77ELi16EEE21__push_back_slow_pathIKS6_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i9 + 12 | 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 12 | 0) + 1 | 0;
 if ((i8 | 0) < -12) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i5 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i7 = i5 << 1;
 i3 = i5 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 if (!i3) i4 = 0; else {
  i4 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = 77;
  HEAP32[i11 + 4 >> 2] = i4;
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 }
 i2 = i4 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 i5 = i2;
 i7 = i4 + (i3 * 12 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 i6 = i2 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i1);
   i2 = i3 + -12 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = 77;
 HEAP32[i11 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i5, i12, i2) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i7 = i12;
 i6 = i8 - i7 | 0;
 i4 = (i6 | 0) / 24 | 0;
 i11 = i5 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i9 = i10;
 if (i4 >>> 0 <= ((i1 - i10 | 0) / 24 | 0) >>> 0) {
  i6 = i5 + 4 | 0;
  i3 = ((HEAP32[i6 >> 2] | 0) - i10 | 0) / 24 | 0;
  i5 = i4 >>> 0 > i3 >>> 0;
  i4 = i5 ? i12 + (i3 * 24 | 0) | 0 : i2;
  i3 = i4;
  i1 = i3 - i7 | 0;
  if (i1 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (((i1 | 0) / 24 | 0) * 24 | 0) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i6 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (((i1 >>> 0) / 24 | 0) * 24 | 0);
   return;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i6 >> 2] = i1 + (~(((i1 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -24 - i10 | 0) >>> 0) / 24 | 0) * 24 | 0);
  __ZdlPv(i3);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = 0;
 }
 if (i4 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i10 = (i1 - i2 | 0) / 24 | 0;
 i1 = i10 << 1;
 i1 = i10 >>> 0 < 89478485 ? (i1 >>> 0 < i4 >>> 0 ? i4 : i1) : 178956970;
 if (i1 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i2 = __Znwj(i1 * 24 | 0) | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i11 >> 2] = i2 + (i1 * 24 | 0);
 if ((i6 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i6 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (((i6 >>> 0) / 24 | 0) * 24 | 0);
 return;
}

function __ZNSt3__212strstreambuf7seekoffExNS_8ios_base7seekdirEj(i13, i12, i9, i10, i7, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i11 = 0;
 i2 = i1 >>> 3;
 i3 = i1 >>> 4;
 switch (i7 | 0) {
 case 2:
 case 0:
  {
   i1 = ((i2 | i3) & 1 | 0) != 0;
   break;
  }
 case 1:
  {
   i1 = ((i2 ^ i3) & 1 | 0) != 0;
   break;
  }
 default:
  i1 = 0;
 }
 i11 = (i2 & 1 | 0) != 0;
 if (i11) i1 = i1 & (HEAP32[i12 + 12 >> 2] | 0) != 0;
 i8 = (i3 & 1 | 0) != 0;
 if (i8) if (i1 & (HEAP32[i12 + 24 >> 2] | 0) != 0) i4 = 9; else {
  i2 = -1;
  i1 = -1;
 } else if (i1) i4 = 9; else {
  i2 = -1;
  i1 = -1;
 }
 if ((i4 | 0) == 9) {
  i5 = i12 + 28 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i6 = i1;
  if (!i1) i4 = HEAP32[i12 + 16 >> 2] | 0; else i4 = i1;
  switch (i7 | 0) {
  case 2:
   {
    i2 = i4 - (HEAP32[i12 + 8 >> 2] | 0) | 0;
    i1 = i2;
    i2 = ((i2 | 0) < 0) << 31 >> 31;
    break;
   }
  case 1:
   {
    i2 = (HEAP32[(i11 ? i12 + 12 | 0 : i12 + 24 | 0) >> 2] | 0) - (HEAP32[i12 + 8 >> 2] | 0) | 0;
    i1 = i2;
    i2 = ((i2 | 0) < 0) << 31 >> 31;
    break;
   }
  default:
   {
    i1 = 0;
    i2 = 0;
   }
  }
  i2 = _i64Add(i1 | 0, i2 | 0, i9 | 0, i10 | 0) | 0;
  i1 = getTempRet0() | 0;
  if ((i1 | 0) > -1 | (i1 | 0) == -1 & i2 >>> 0 > 4294967295) {
   i3 = HEAP32[i12 + 8 >> 2] | 0;
   i10 = i4 - i3 | 0;
   i9 = ((i10 | 0) < 0) << 31 >> 31;
   if ((i1 | 0) > (i9 | 0) | (i1 | 0) == (i9 | 0) & i2 >>> 0 > i10 >>> 0) {
    i2 = -1;
    i1 = -1;
   } else {
    i3 = i3 + i2 | 0;
    if (i11) {
     i11 = i12 + 16 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i12 + 12 >> 2] = i3;
     HEAP32[i11 >> 2] = i3 >>> 0 < i10 >>> 0 ? i10 : i3;
    }
    if (i8) {
     i11 = i12 + 20 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = i3 >>> 0 < i10 >>> 0 ? i3 : i10;
     HEAP32[i5 >> 2] = i6;
     HEAP32[i12 + 24 >> 2] = i3;
    }
   }
  } else {
   i2 = -1;
   i1 = -1;
  }
 }
 i12 = i13;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 i13 = i13 + 8 | 0;
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i1;
 return;
}

function __ZNK8Material9GetShaderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i2 = i7;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i8 = i1;
     STACKTOP = i7;
     return i8 | 0;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 469921 | 0, 27);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i6) | 0;
 HEAP32[gb + 1166240 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
 i8 = i1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx9NpFactory11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i10, i7, i6, i8, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16 | 0;
 i9 = i12 + 12 | 0;
 if (!(HEAP32[gb + 1457344 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 489, gb + 690476 | 0, i12);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP16[i1 >> 1] | 0;
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i5 = i2 + 4252 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i4 = i2 + 4248 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 3956 | 0);
  i3 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 i4 = i2 + 4236 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i2 + 4240 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else {
  HEAP16[i11 >> 1] = i1;
  __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i3, i7, i6, i8, i11);
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 if (!i3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 503, gb + 690513 | 0, i12 + 8 | 0);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i9 >> 2] = i3;
 i2 = i10 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i10 + 564 | 0, i9, i11) | 0;
 if (!(HEAP8[i11 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i11 = i3;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_14PxTaskTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 20 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 719092 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 20 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 20 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 20 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 20 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i5 >> 2] = i8;
  i9 = i4 + (i9 * 20 | 0) | 0;
  return i9 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i8;
 i9 = i4 + (i9 * 20 | 0) | 0;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i1 = i12;
 i10 = i13 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i13 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i10 >> 2] = i3;
  i1 = i8;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 3;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 3) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i8 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i7 = i1 + (i8 << 3) | 0;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i8 = i13 + 4 | 0;
 do {
  i6 = i1 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i11 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i10, i9, 4);
   i2 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = i2;
  if (!i2) HEAP32[i6 >> 2] = 0; else {
   i3 = i2 << 2;
   i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
   if ((i4 | 0) != (i4 + (i2 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
   i5 = i6;
   i3 = i4 | 0 ? i4 - i5 | 0 : 0;
   HEAP32[i6 >> 2] = i3;
   i2 = HEAP32[i9 >> 2] | 0;
   if (i2 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i13, i3 + i5 | 0, i2 << 2);
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i12;
 return;
}

function __Z20CalculateLightMatrixRK15SharedLightDataP10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 144 | 0;
 i4 = i9 + 80 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9;
 i7 = i1 + 280 | 0;
 i8 = i1 + 40 | 0;
 switch (HEAP32[i8 >> 2] | 0) {
 case 0:
  {
   __ZN10Matrix4x4f11SetIdentityEv(i5) | 0;
   HEAPF32[i5 + 44 >> 2] = Math_fround(Math_fround(2.0) / Math_fround(HEAPF32[i1 + 68 >> 2]));
   HEAPF32[i5 + 60 >> 2] = Math_fround(0.0);
   f11 = Math_fround(HEAPF32[i1 + 204 >> 2]);
   f10 = Math_fround(HEAPF32[i1 + 48 >> 2]);
   f10 = Math_fround(Math_fround(1.0) / ((HEAP32[i8 >> 2] | 0) == 3 ? f11 : f10));
   HEAPF32[i6 >> 2] = f10;
   HEAPF32[i6 + 4 >> 2] = f10;
   HEAPF32[i6 + 8 >> 2] = f10;
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i3, i6) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i5, i3, i4);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i4, i7, i2);
   STACKTOP = i9;
   return;
  }
 case 2:
  {
   f11 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 48 >> 2]));
   HEAPF32[i6 >> 2] = f11;
   HEAPF32[i6 + 4 >> 2] = f11;
   HEAPF32[i6 + 8 >> 2] = f11;
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i3, i6) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, i7, i2);
   STACKTOP = i9;
   return;
  }
 case 1:
  {
   if (!(HEAP8[i1 + 84 >> 0] | 0)) {
    STACKTOP = i9;
    return;
   }
   f11 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 64 >> 2]));
   HEAPF32[i6 >> 2] = f11;
   HEAPF32[i6 + 4 >> 2] = f11;
   HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i3, i6) | 0;
   HEAPF32[i6 >> 2] = Math_fround(.5);
   HEAPF32[i6 + 4 >> 2] = Math_fround(.5);
   HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
   __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i4, i6) | 0;
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i4, i3, i5);
   __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i5, i7, i2);
   STACKTOP = i9;
   return;
  }
 default:
  {
   STACKTOP = i9;
   return;
  }
 }
}

function __ZN8Material9GetShaderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i2 = i7;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i8 = i1;
     STACKTOP = i7;
     return i8 | 0;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 469921 | 0, 27);
 i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i6) | 0;
 HEAP32[gb + 1166240 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
 i8 = i1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN7mecanim9animation30ValueFromSkeletonPoseRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapEPKiRNS_10ValueArrayEii(i1, i5, i4, i2, i6, i7, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if ((i7 | 0) == -1 | (i7 | 0) == (i3 | 0)) return;
 i8 = i1 + 4 | 0;
 __ZN7mecanim9animation30ValueFromSkeletonPoseRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapEPKiRNS_10ValueArrayEii(i1, i5, i4, i2, i6, HEAP32[(HEAP32[i8 >> 2] | 0) + i8 + (i7 << 3) >> 2] | 0, i3);
 i2 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
 i1 = HEAP32[i4 + (i2 * 12 | 0) >> 2] | 0;
 if ((i1 | 0) != -1) {
  i10 = i5 + 4 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i8 = i6 + 4 | 0;
  i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
  i9 = HEAP32[i10 + (i7 * 40 | 0) + 4 >> 2] | 0;
  i3 = HEAP32[i10 + (i7 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i8 + (i1 * 12 | 0) >> 2] = HEAP32[i10 + (i7 * 40 | 0) >> 2];
  HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] = i9;
  HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] = i3;
 }
 i1 = HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i11 = i5 + 4 | 0;
  i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
  i10 = i6 + 12 | 0;
  i10 = (HEAP32[i10 >> 2] | 0) + i10 | 0;
  i3 = HEAP32[i11 + (i7 * 40 | 0) + 16 >> 2] | 0;
  i8 = HEAP32[i11 + (i7 * 40 | 0) + 20 >> 2] | 0;
  i9 = HEAP32[i11 + (i7 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i10 + (i1 << 4) >> 2] = HEAP32[i11 + (i7 * 40 | 0) + 12 >> 2];
  HEAP32[i10 + (i1 << 4) + 4 >> 2] = i3;
  HEAP32[i10 + (i1 << 4) + 8 >> 2] = i8;
  HEAP32[i10 + (i1 << 4) + 12 >> 2] = i9;
 }
 i1 = HEAP32[i4 + (i2 * 12 | 0) + 8 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i8 = i5 + 4 | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
 i11 = i6 + 20 | 0;
 i11 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
 i9 = HEAP32[i8 + (i7 * 40 | 0) + 32 >> 2] | 0;
 i10 = HEAP32[i8 + (i7 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i11 + (i1 * 12 | 0) >> 2] = HEAP32[i8 + (i7 * 40 | 0) + 28 >> 2];
 HEAP32[i11 + (i1 * 12 | 0) + 4 >> 2] = i9;
 HEAP32[i11 + (i1 * 12 | 0) + 8 >> 2] = i10;
 return;
}

function __ZN7mecanim9animation10ValueDelta8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898897 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 898905 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN7dtCrowd17requestMoveTargetEiyPKf(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i3 + 16 >> 2] | 0;
 i9 = i8 + (i4 * 608 | 0) + 600 | 0;
 switch (HEAP8[i9 >> 0] | 0) {
 case 1:
  {
   i9 = i8 + (i4 * 608 | 0) + 592 | 0;
   HEAP32[i9 >> 2] = i5;
   HEAP32[i9 + 4 >> 2] = i6;
   return;
  }
 case 2:
  {
   i2 = i8 + (i4 * 608 | 0) + 592 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i5 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i6 | 0) : 0) return;
   HEAP32[i3 + 32 >> 2] = 0;
   HEAP32[i3 + 92 >> 2] = 0;
   HEAP32[i3 + 256 >> 2] = 0;
   HEAP32[i3 + 452 >> 2] = 0;
   i2 = i3 + 460 | 0;
   i1 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 | 0) {
    i2 = HEAP32[i3 + 456 >> 2] | 0;
    _memmove(i2 | 0, i2 + 4 | 0, i1 << 2 | 0) | 0;
   }
   break;
  }
 default:
  {
   i1 = HEAP32[i8 + (i4 * 608 | 0) + 32 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i2 = 0;
   } else {
    i2 = (HEAP32[i8 + (i4 * 608 | 0) + 28 >> 2] | 0) + (i1 + -1 << 3) | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
   }
   if ((i1 | 0) == (i5 | 0) & (i2 | 0) == (i6 | 0)) {
    i1 = HEAP32[i8 + (i4 * 608 | 0) + 48 >> 2] | 0;
    if (i1 | 0) if ((i1 | 0) == (HEAP32[(HEAP32[i8 + (i4 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0)) {
     HEAP32[i8 + (i4 * 608 | 0) + 12 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i8 + (i4 * 608 | 0) + 16 >> 2] = HEAP32[i7 + 4 >> 2];
     HEAP32[i8 + (i4 * 608 | 0) + 20 >> 2] = HEAP32[i7 + 8 >> 2];
     HEAPF32[i8 + (i4 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
     return;
    }
   }
  }
 }
 i1 = i3 + 460 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[(HEAP32[i3 + 456 >> 2] | 0) + (i2 << 2) >> 2] = i4;
 i3 = i8 + (i4 * 608 | 0) + 592 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP8[i9 >> 0] = 1;
 i9 = i8 + (i4 * 608 | 0) + 602 | 0;
 HEAP8[i9 >> 0] = HEAP8[i9 >> 0] | 4;
 HEAP32[i8 + (i4 * 608 | 0) + 576 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + (i4 * 608 | 0) + 580 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + (i4 * 608 | 0) + 584 >> 2] = HEAP32[i7 + 8 >> 2];
 return;
}

function __ZN5physx33solveContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i12, i11, i14, i15, i1, i13) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (i11 | 0) {
  i10 = 0;
  do {
   __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i12 + (i10 << 5) | 0, 0);
   i1 = HEAP32[i12 + (i10 << 5) + 16 >> 2] | 0;
   i7 = HEAP16[i1 + 2 >> 1] | 0;
   i9 = i1 + (i7 & 65535) | 0;
   i8 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
   if (i7 << 16 >> 16) {
    i4 = HEAP32[i12 + (i10 << 5) + 20 >> 2] | 0;
    while (1) {
     i2 = HEAP8[i1 + 1 >> 0] | 0;
     i7 = i2 & 255;
     if (!i4) {
      i1 = i1 + ((Math_imul(i7, i8) | 0) + 48) | 0;
      if (i1 >>> 0 < i9 >>> 0) {
       i4 = 0;
       continue;
      } else break;
     }
     i3 = i1 + 48 | 0;
     if (!(i2 << 24 >> 24)) {
      i1 = i3;
      i2 = i4;
     } else {
      i6 = i7 >>> 0 > 1 ? i7 : 1;
      i2 = i4 + (i6 << 2) | 0;
      i5 = 0;
      while (1) {
       HEAP32[i4 >> 2] = HEAP32[i3 + 12 >> 2];
       i5 = i5 + 1 | 0;
       if ((i5 | 0) == (i7 | 0)) break; else {
        i3 = i3 + i8 | 0;
        i4 = i4 + 4 | 0;
       }
      }
      i1 = i1 + ((Math_imul(i6, i8) | 0) + 48) | 0;
     }
     if (i1 >>> 0 < i9 >>> 0) i4 = i2; else break;
    }
   }
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i11 | 0));
 }
 i5 = i14 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i14 + 12 >> 2] | 0) + -4 | 0) >>> 0) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i13, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i14 = i15 + (i4 + i2 << 4) | 0;
   i13 = i1 + (i2 << 4) | 0;
   HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
   HEAP32[i14 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN15LODGroupManagerC2E10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i4 = i10;
 i9 = i2 + 4 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = i11;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i9 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i2 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i2 + 8 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i13 = i5;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 HEAPF32[i2 + 32 >> 2] = Math_fround(.5);
 i3 = i4;
 HEAP32[i3 >> 2] = i11;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = (__ZN17UniqueIDGenerator15CreatePureIndexEv(gb + 1161220 | 0) | 0) + -1;
 HEAPF32[i2 + 24 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 28 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i3 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 * 96 | 0, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 96 | 0, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i13 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 96 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i9 >> 2] = i13;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i3;
 i1 = (HEAP32[i9 >> 2] | 0) + (i2 * 96 | 0) | 0;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN11LightProbes14LightProbeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i6 * 80 | 0) | 0;
 if (i6 | 0) do {
  __ZN11Tetrahedron8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags(i9, i7 + 20 | 0, gb + 378836 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i9, i7 + 40 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags(i9, i7 + 60 | 0, gb + 405193 | 0, 0);
 i6 = i7 + 88 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 + 84 >> 2] | 0;
 i2 = (i5 - i1 | 0) / 24 | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i8, 4);
  i1 = HEAP32[i7 + 84 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i12;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 4628 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 3860 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 534 | 0)) {
    i4 = i6 + 3860 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 3860 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 3860 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 3860 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 3860 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 3860 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 3860 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 5400 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 4632 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 535 | 0)) {
   i4 = i6 + 4632 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 4632 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i8 = 15;
   break;
  }
 }
 if ((i8 | 0) == 15) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (i8 >>> 0 <= i1 >>> 0) return;
 do {
  i8 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 4632 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 4632 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 4632 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 4632 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 4632 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZN27ComputeShaderBuiltinSampler8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469606 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469614 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy(i8, i3, i1, i7, i2, i6, i9) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i5 = i10;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 if (!(HEAP8[i8 + 2360 >> 0] | 0)) i4 = i7; else {
  do if (i1 >>> 0 < 0 | (i1 | 0) == 0 & i3 >>> 0 < 5) {
   i4 = _i64Subtract(5, 0, i3 | 0, i1 | 0) | 0;
   i5 = getTempRet0() | 0;
   i12 = i5 >>> 0 > i2 >>> 0 | (i5 | 0) == (i2 | 0) & i4 >>> 0 > i7 >>> 0;
   i4 = i12 ? i7 : i4;
   i5 = i12 ? i2 : i5;
   if ((i4 | 0) == 0 & (i5 | 0) == 0) i4 = i7; else {
    i12 = i8 + 2320 | 0;
    i12 = _i64Add(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i3 | 0, i1 | 0) | 0;
    if (__ZN12FileAccessor4ReadEyyPvPy(i8 + 1248 | 0, i12, getTempRet0() | 0, i4, i5, i6, i10) | 0) {
     i5 = i10;
     i12 = HEAP32[i5 >> 2] | 0;
     i5 = HEAP32[i5 + 4 >> 2] | 0;
     i4 = _i64Subtract(i7 | 0, i2 | 0, i12 | 0, i5 | 0) | 0;
     i2 = getTempRet0() | 0;
     i3 = _i64Add(i12 | 0, i5 | 0, i3 | 0, i1 | 0) | 0;
     i6 = i6 + i12 | 0;
     i1 = getTempRet0() | 0;
     break;
    }
    i12 = 0;
    STACKTOP = i11;
    return i12 | 0;
   }
  } else i4 = i7; while (0);
  i3 = _i64Add(i3 | 0, i1 | 0, 8, 0) | 0;
  i1 = getTempRet0() | 0;
 }
 i12 = i8 + 2320 | 0;
 i12 = _i64Add(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 if (__ZN12FileAccessor4ReadEyyPvPy(i8 + 1248 | 0, i12, getTempRet0() | 0, i4, i2, i6, i9) | 0) {
  i12 = i10;
  i10 = i9;
  i12 = _i64Add(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
  i10 = getTempRet0() | 0;
  i1 = i9;
  HEAP32[i1 >> 2] = i12;
  HEAP32[i1 + 4 >> 2] = i10;
  i1 = i8 + 2328 | 0;
  i9 = i1;
  i10 = _i64Add(HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, i12 | 0, i10 | 0) | 0;
  i12 = getTempRet0() | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i12;
  i1 = 1;
 } else i1 = 0;
 i12 = i1;
 STACKTOP = i11;
 return i12 | 0;
}

function __ZN18BuoyancyEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800986 | 0, i5, i1 + 92 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864119 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802772 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802447 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801001 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801013 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801029 | 0, i5, i1 + 116 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer8drawTextEN5physx6PxVec3ENS1_8debugger8PvdColorEPKcz(i4, i2, i1, i3, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 40 | 0;
 i9 = i6 + 24 | 0;
 i7 = i6;
 HEAP32[i9 >> 2] = i5;
 _vsnprintf(gb + 1551036 | 0, 1024, i3, i9) | 0;
 HEAP8[gb + 1551036 + 1024 >> 0] = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 i9 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 i1 = (_strlen(gb + 1551036 | 0) | 0) + 1 | 0;
 HEAP32[i7 >> 2] = gb + 1551036;
 HEAP32[i7 + 4 >> 2] = gb + 1551036 + i1;
 HEAP32[i7 + 8 >> 2] = i5;
 HEAP32[i7 + 12 >> 2] = i3;
 HEAP32[i7 + 16 >> 2] = i2;
 i2 = i7 + 20 | 0;
 HEAP32[i2 >> 2] = i9;
 i9 = i4 + 8 | 0;
 HEAP32[i8 >> 2] = gb + 150564 + 8;
 HEAP32[i8 + 4 >> 2] = i9;
 i3 = i4 + 24 | 0;
 i5 = i4 + 20 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i9, i1 + 1 | 0);
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i5 >> 2] | 0) + i1 >> 0] = 10;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0, i7 | 0);
 i1 = i7 + 8 | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i7 + 21 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i7 + 22 | 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i7 + 23 | 0);
 if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i6;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZN8Animator16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i6 = i9;
 i7 = i1 + 153 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i3 = (i2 & 1 | 0) != 0;
 i4 = (i2 & 2 | 0) == 0;
 if (i4 | i3 ^ 1) {
  if (i3) {
   __ZNK9Transform11GetPositionEv(i5, i8);
   if (HEAP8[i7 >> 0] | 0) {
    i6 = HEAP32[i1 + 136 >> 2] | 0;
    i10 = HEAP32[i5 + 4 >> 2] | 0;
    i3 = HEAP32[i5 + 8 >> 2] | 0;
    HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i6 + 4 >> 2] = i10;
    HEAP32[i6 + 8 >> 2] = i3;
   }
  }
  if (!i4) {
   __ZNK9Transform11GetRotationEv(i5, i8);
   if (HEAP8[i7 >> 0] | 0) {
    i10 = HEAP32[i1 + 136 >> 2] | 0;
    i3 = HEAP32[i5 + 4 >> 2] | 0;
    i4 = HEAP32[i5 + 8 >> 2] | 0;
    i6 = HEAP32[i5 + 12 >> 2] | 0;
    HEAP32[i10 + 12 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i10 + 16 >> 2] = i3;
    HEAP32[i10 + 20 >> 2] = i4;
    HEAP32[i10 + 24 >> 2] = i6;
   }
  }
 } else {
  __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(i8, i5, i6);
  if (HEAP8[i7 >> 0] | 0) {
   i10 = HEAP32[i1 + 136 >> 2] | 0;
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i3;
   HEAP32[i10 + 8 >> 2] = i11;
   i11 = HEAP32[i6 + 4 >> 2] | 0;
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   i4 = HEAP32[i6 + 12 >> 2] | 0;
   HEAP32[i10 + 12 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 16 >> 2] = i11;
   HEAP32[i10 + 20 >> 2] = i3;
   HEAP32[i10 + 24 >> 2] = i4;
  }
 }
 if (!(i2 & 8)) {
  STACKTOP = i9;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i5, i8);
 if (HEAP8[i7 >> 0] | 0) {
  i11 = HEAP32[i1 + 136 >> 2] | 0;
  i8 = HEAP32[i5 + 4 >> 2] | 0;
  i10 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i11 + 28 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + 32 >> 2] = i8;
  HEAP32[i11 + 36 >> 2] = i10;
 }
 STACKTOP = i9;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i5, i1, i6, i7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  {
   i3 = i5 + 48 | 0;
   i4 = HEAP32[i5 + 52 >> 2] | 0;
   switch (i4 >>> 30 | 0) {
   case 3:
    break;
   case 2:
    {
     if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2432 >> 0] | 0)) i2 = 4;
     break;
    }
   default:
    i2 = 4;
   }
   if ((i2 | 0) == 4) {
    __ZN5physx2Sc8BodyCore24clearSpatialAccelerationEbb(i5 + 64 | 0, i6, i7);
    return;
   }
   i2 = i5 + 56 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i4 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
    HEAP32[i2 >> 2] = i4;
    i2 = i4;
   } else i2 = i1;
   i3 = i5 + 284 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i6) {
    HEAP32[i2 + 220 >> 2] = 0;
    HEAP32[i2 + 224 >> 2] = 0;
    HEAP32[i2 + 228 >> 2] = 0;
    i1 = i1 & -16385;
   }
   if (i7) {
    HEAP32[i2 + 232 >> 2] = 0;
    HEAP32[i2 + 236 >> 2] = 0;
    HEAP32[i2 + 240 >> 2] = 0;
    i1 = i1 & -32769;
   }
   HEAP32[i3 >> 2] = i1;
   return;
  }
 case 2:
 case 1:
  {
   i3 = i5 + 48 | 0;
   i4 = HEAP32[i5 + 52 >> 2] | 0;
   switch (i4 >>> 30 | 0) {
   case 3:
    break;
   case 2:
    {
     if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2432 >> 0] | 0)) i2 = 14;
     break;
    }
   default:
    i2 = 14;
   }
   if ((i2 | 0) == 14) {
    __ZN5physx2Sc8BodyCore20clearSpatialVelocityEbb(i5 + 64 | 0, i6, i7);
    return;
   }
   i1 = i5 + 56 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
    HEAP32[i1 >> 2] = i2;
   }
   i3 = i5 + 284 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i6) {
    HEAP32[i2 + 244 >> 2] = 0;
    HEAP32[i2 + 248 >> 2] = 0;
    HEAP32[i2 + 252 >> 2] = 0;
    i1 = i1 & -65537;
   }
   if (i7) {
    HEAP32[i2 + 256 >> 2] = 0;
    HEAP32[i2 + 260 >> 2] = 0;
    HEAP32[i2 + 264 >> 2] = 0;
    i1 = i1 & -131073;
   }
   HEAP32[i3 >> 2] = i1;
   return;
  }
 default:
  return;
 }
}

function __ZNSt3__29to_stringEm(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i6 >> 2] = i5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084502 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__29to_stringEl(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i6 >> 2] = i5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084498 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__29to_stringEj(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i6 >> 2] = i5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084495 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__29to_stringEi(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAP32[i6 >> 2] = i5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084492 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i5 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i5;
  i1 = i5;
  i7 = 10;
 } else {
  L4 : do if (!(HEAP8[i1 >> 0] | 0)) i1 = -1; else {
   i1 = HEAP32[i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) i7 = 6;
   } else {
    HEAP32[i2 >> 2] = i3 + 4;
    i1 = HEAP32[i3 >> 2] | 0;
    i7 = 6;
   }
   do if ((i7 | 0) == 6) if ((i1 | 0) == -1) {
    i4 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i4 | 0, HEAP32[i4 + 16 >> 2] | 6 | 0);
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) break; else {
     i1 = -1;
     break L4;
    }
   } else {
    HEAP32[i4 >> 2] = 1;
    break L4;
   } while (0);
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i5;
   i1 = i5;
   i7 = 10;
   break L1;
  } while (0);
  i6 = i1;
 } while (0);
 do if ((i7 | 0) == 10) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   i6 = -1;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i8;
 return i6 | 0;
}

function __ZN5physx2Sc7BodySim37checkSleepReadinessBesidesWakeCounterEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 i1 = i2 + 156 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) i4 = 0; else if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, 0) | 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = 0;
 if (Math_fround(HEAPF32[i2 + 80 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 + 84 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 + 88 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 + 96 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 + 100 >> 2]) == Math_fround(0.0)) i2 = Math_fround(HEAPF32[i2 + 104 >> 2]) == Math_fround(0.0); else i2 = 0; else i2 = 0; else i2 = 0; else i2 = 0; else i2 = 0;
 i3 = HEAP8[i3 + 146 >> 0] | 0;
 i1 = (i3 & 2) == 0;
 do if (i1 | i2 ^ 1) i2 = i2 & i1; else if (!i4) i2 = 1; else {
  if (!(Math_fround(HEAPF32[i4 >> 2]) == Math_fround(0.0))) {
   i4 = 0;
   return i4 | 0;
  }
  if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) == Math_fround(0.0))) {
   i4 = 0;
   return i4 | 0;
  }
  if (!(Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(0.0))) {
   i4 = 0;
   return i4 | 0;
  }
  if (!(Math_fround(HEAPF32[i4 + 16 >> 2]) == Math_fround(0.0))) {
   i4 = 0;
   return i4 | 0;
  }
  if (Math_fround(HEAPF32[i4 + 20 >> 2]) == Math_fround(0.0)) {
   i2 = Math_fround(HEAPF32[i4 + 24 >> 2]) == Math_fround(0.0);
   break;
  } else {
   i4 = 0;
   return i4 | 0;
  }
 } while (0);
 i1 = (i3 & 4) == 0;
 if (i1 | i2 ^ 1) {
  i4 = i2 & i1;
  return i4 | 0;
 }
 if (!i4) {
  i4 = 1;
  return i4 | 0;
 }
 if (!(Math_fround(HEAPF32[i4 + 32 >> 2]) == Math_fround(0.0))) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(Math_fround(HEAPF32[i4 + 36 >> 2]) == Math_fround(0.0))) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(Math_fround(HEAPF32[i4 + 40 >> 2]) == Math_fround(0.0))) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(Math_fround(HEAPF32[i4 + 48 >> 2]) == Math_fround(0.0))) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(Math_fround(HEAPF32[i4 + 52 >> 2]) == Math_fround(0.0))) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = Math_fround(HEAPF32[i4 + 56 >> 2]) == Math_fround(0.0);
 return i4 | 0;
}

function __ZN5physx24PxsParticleSystemBatcher21scheduleCollisionPrepEPPNS_20PxvParticleSystemSimEPPNS_14PxLightCpuTaskEjRNS_10PxBaseTaskE(i16, i1, i15, i14, i18) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17;
 if (!i14) i2 = i16 + 196 | 0; else {
  i4 = i16 + 272 | 0;
  i2 = i16 + 196 | 0;
  i7 = i16 + 192 | 0;
  i8 = i16 + 232 | 0;
  i9 = i16 + 228 | 0;
  i10 = i16 + 224 | 0;
  i11 = i16 + 268 | 0;
  i12 = i16 + 204 | 0;
  i13 = 0;
  do {
   i3 = i15 + (i13 << 2) | 0;
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i5 + 16 >> 2] = 1;
   i6 = i5 + 12 | 0;
   HEAP32[i6 >> 2] = i18;
   mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
   HEAP32[i5 + 8 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
   i5 = HEAP32[i3 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
   __ZN5physx6shdfnd15atomicIncrementEPVi(i2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i1 >> 2] = i5;
   i6 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i6 << 2) >> 2] = i5;
    HEAP32[i9 >> 2] = i6 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i12, i1) | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
   HEAP8[i11 >> 0] = 1;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i14 | 0));
 }
 i1 = i16 + 184 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i18 >> 2] | 0) + 16 >> 2] | 0, i18 | 0);
  STACKTOP = i17;
  return i18 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) > 1) do __ZN5physx2Cm10FanoutTask15removeReferenceEv(i1); while ((HEAP32[i2 >> 2] | 0) > 1);
 i18 = i1;
 STACKTOP = i17;
 return i18 | 0;
}

function __ZN10MemoryPool13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[gb + 1170804 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) {
  i7 = 0;
  do {
   i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   if (i4 | 0) {
    i5 = i4 + 12 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i6 = i4 + 24 | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i2 = i1 + (i3 << 2) | 0;
    if (i3 | 0) {
     i3 = i4 + 44 | 0;
     do {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
    i2 = i4 + 28 | 0;
    if ((HEAP32[i2 >> 2] | 0) > -1) {
     i1 = i4 + 16 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1);
     HEAP32[i5 >> 2] = 0;
    } else i1 = i4 + 16 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i4 + 32 >> 2] = 0;
    __Z19free_alloc_internalPvRK10MemLabelId(0, i1);
    HEAP32[i5 >> 2] = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63696 | 0);
   HEAP32[(HEAP32[HEAP32[gb + 1170804 >> 2] >> 2] | 0) + (i7 << 2) >> 2] = 0;
   i7 = i7 + 1 | 0;
   i1 = HEAP32[gb + 1170804 >> 2] | 0;
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while (i7 >>> 0 < i2 - (HEAP32[i1 >> 2] | 0) >> 2 >>> 0);
 }
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
  HEAP32[gb + 1170804 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
  HEAP32[gb + 1170804 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 if ((i2 | 0) != (i4 | 0)) HEAP32[i3 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 72;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
 HEAP32[gb + 1170804 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z11CloneObjectR6ObjectR9Transformb(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 32 | 0;
 i5 = i12;
 i6 = i12 + 20 | 0;
 if ((HEAP16[gb + 1155156 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155156 | 0, i7);
  i8 = gb + 1155156 | 0;
 } else i8 = 0;
 i11 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i5 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i10 = i5 + 16 | 0;
 HEAP32[i10 >> 2] = i11;
 i11 = __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i2, i5) | 0;
 if (i11 | 0) {
  i14 = HEAP32[i11 >> 2] | 0;
  i13 = HEAP32[i14 + 40 >> 2] | 0;
  __Z6AppendPKcS0_(i6, mftCall_ii(HEAP32[i14 + 36 >> 2] | 0, i11 | 0) | 0, gb + 391391 | 0);
  mftCall_vii(i13 | 0, i11 | 0, ((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 if (i4) __Z47CopyWorldSpaceTransformDataWithoutNotificationsP6ObjectS0_(i1, i11);
 __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i5);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1105076 | 0, i7);
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i14 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i14;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 if (!i8) {
  STACKTOP = i12;
  return i11 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil14isBoundaryEdgeEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 i6 = (i3 >>> 0) / 3 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i4 = (i6 >>> 0) / (i2 >>> 0) | 0;
 i5 = (i6 >>> 0) % (i2 >>> 0) | 0;
 switch ((Math_imul(i6, -3) | 0) + i3 | 0) {
 case 0:
  {
   if (i5 >>> 0 < (i2 + -1 | 0) >>> 0) {
    if (!i4) i3 = 0; else {
     i3 = i6 - i2 | 0;
     HEAP32[i8 >> 2] = (i3 << 1 | 1) - ((HEAPU8[(HEAP32[i7 + 36 >> 2] | 0) + (i3 << 2) + 2 >> 0] | 0) >>> 7 & 255);
     i3 = 1;
    }
    if (i4 >>> 0 < ((HEAP32[i1 >> 2] | 0) + -1 | 0) >>> 0) {
     HEAP32[i8 + (i3 << 2) >> 2] = (HEAPU8[(HEAP32[i7 + 36 >> 2] | 0) + (i6 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i6 << 1;
     i3 = i3 + 1 | 0;
    }
   } else i3 = 0;
   break;
  }
 case 1:
  {
   if (i5 >>> 0 < (i2 + -1 | 0) >>> 0 ? i4 >>> 0 < ((HEAP32[i1 >> 2] | 0) + -1 | 0) >>> 0 : 0) {
    i3 = i6 << 1;
    HEAP32[i8 >> 2] = i3;
    HEAP32[i8 + 4 >> 2] = i3 | 1;
    i3 = 2;
   } else i3 = 0;
   break;
  }
 case 2:
  {
   if (i4 >>> 0 < ((HEAP32[i1 >> 2] | 0) + -1 | 0) >>> 0) {
    if (!i5) i3 = 0; else {
     HEAP32[i8 >> 2] = (i6 << 1) + -1;
     i3 = 1;
    }
    if (i5 >>> 0 < (i2 + -1 | 0) >>> 0) {
     HEAP32[i8 + (i3 << 2) >> 2] = i6 << 1;
     i3 = i3 + 1 | 0;
    }
   } else i3 = 0;
   break;
  }
 default:
  i3 = 0;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 >>> 1;
 i1 = HEAP32[i7 + 36 >> 2] | 0;
 i2 = (HEAPU8[((i6 & 1 | 0) == 0 ? i1 + (i2 << 2) + 2 | 0 : i1 + (i2 << 2) + 3 | 0) >> 0] | 0) & 127;
 if (i3 >>> 0 <= 1) {
  i8 = i2;
  i8 = i8 << 16 >> 16 != 127;
  STACKTOP = i9;
  return i8 | 0;
 }
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i8 = i7 >>> 1;
 i1 = (HEAPU8[((i7 & 1 | 0) == 0 ? i1 + (i8 << 2) + 2 | 0 : i1 + (i8 << 2) + 3 | 0) >> 0] | 0) & 127;
 if (i2 << 16 >> 16 == 127) {
  i8 = i1;
  i8 = i8 << 16 >> 16 != 127;
  STACKTOP = i9;
  return i8 | 0;
 } else {
  STACKTOP = i9;
  return i1 << 16 >> 16 == 127 | 0;
 }
 return 0;
}

function __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i4 + 100 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 124 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) if ((HEAP32[i2 + 128 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) if ((HEAP32[i2 + 132 >> 2] | 0) == (HEAP32[i1 + 8 >> 2] | 0)) if ((HEAP32[i2 + 136 >> 2] | 0) == (HEAP32[i1 + 12 >> 2] | 0)) if ((HEAP32[i2 + 140 >> 2] | 0) == (HEAP32[i1 + 16 >> 2] | 0)) if ((HEAP32[i2 + 144 >> 2] | 0) == (HEAP32[i1 + 20 >> 2] | 0)) if ((HEAP32[i2 + 148 >> 2] | 0) == (HEAP32[i1 + 24 >> 2] | 0)) if ((HEAP32[i2 + 152 >> 2] | 0) == (HEAP32[i1 + 28 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 i1 = (HEAP32[i6 >> 2] | 0) + 124 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i1, i5);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i5, i4 + 80 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i4 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i4;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i6 = i1 + 164 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 2;
 STACKTOP = i7;
 return;
}

function __ZN7Cubemap13RebuildMipMapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 i3 = i2 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (i5) {
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i4 + 36 >> 2] | 0;
 do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
  i6 = i1 + -30 | 0;
  if (i6 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i6 & 65535) & 1) != 0)) break;
  } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break;
  if (!i5) if ((HEAP32[i4 + 44 >> 2] | 0) == 6) {
   __ZN9Texture2D18UnshareTextureDataEv(i2);
   i6 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i6 + 28 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat(HEAP32[i6 + 8 >> 2] | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 + 8 >> 2] | 0) + (HEAP32[i6 + 40 >> 2] | 0) | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 + 8 >> 2] | 0) + (HEAP32[i6 + 40 >> 2] << 1) | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 + 8 >> 2] | 0) + ((HEAP32[i6 + 40 >> 2] | 0) * 3 | 0) | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 + 8 >> 2] | 0) + (HEAP32[i6 + 40 >> 2] << 2) | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   i6 = HEAP32[i3 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 + 8 >> 2] | 0) + ((HEAP32[i6 + 40 >> 2] | 0) * 5 | 0) | 0, i5, i5, 1, HEAP32[i6 + 36 >> 2] | 0);
   return;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397289 | 0, 0, gb + 397213 | 0, 222, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410623 | 0, 0, gb + 397213 | 0, 217, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE16dispatchAccessorILj435ENS0_26PxPvdRangePropertyAccessorILj435ES4_NS_6PxVec3EEEEEvjRKT0_bbb(i5, i4, i12, i1, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 48 | 0;
 i8 = i11 + 36 | 0;
 i9 = i11 + 24 | 0;
 i10 = i11 + 12 | 0;
 i6 = i11;
 HEAP32[i7 >> 2] = 0;
 if (!(HEAP8[i5 + 36 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i7 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == 0 | i4 ^ 1) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i7, i6, i8);
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = i12 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i9 | 0, i10 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i12 + 8 >> 0] | 0)) {
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  i10 = HEAP32[i9 + 8 >> 2] | 0;
  i12 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i7 + 8 >> 2] = i10;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i8 + 4 >> 2] = i5;
  HEAP32[i8 + 8 >> 2] = i1;
  mftCall_viii(i12 | 0, i3 | 0, i7 | 0, i8 | 0);
 } else {
  i6 = HEAP32[i10 >> 2] | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i10 = HEAP32[i10 + 8 >> 2] | 0;
  i12 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i7 + 8 >> 2] = i1;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i8 + 8 >> 2] = i10;
  mftCall_viii(i12 | 0, i3 | 0, i7 | 0, i8 | 0);
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx17ConvexMeshBuilder12loadFromDescERKNS_16PxConvexMeshDescENS_10PxPlatform4EnumE(i5, i2, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 L1 : do if (i1 >>> 0 >= 3) {
  if (i1 >>> 0 > 65535) if (HEAP16[i2 + 48 >> 1] & 2) break;
  if (HEAP32[i2 + 4 >> 2] | 0) if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 12) {
   do if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    if (!(HEAP32[i2 + 28 >> 2] | 0)) if (!(HEAP16[i2 + 48 >> 1] & 4)) break L1; else break;
    if ((HEAP32[i2 + 32 >> 2] | 0) >>> 0 < 4) break L1;
    if (!(HEAP32[i2 + 40 >> 2] | 0)) break L1;
    if ((HEAP32[i2 + 36 >> 2] | 0) >>> 0 < ((HEAP16[i2 + 48 >> 1] & 2 ^ 2) + 2 | 0) >>> 0) break L1;
    if ((HEAP32[i2 + 24 >> 2] | 0) >>> 0 < 20) break L1;
   } else {
    if ((HEAP32[i2 + 20 >> 2] | 0) >>> 0 < 2) break L1;
    if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 < (HEAP16[i2 + 48 >> 1] & 2 ? 6 : 12) >>> 0) break L1;
   } while (0);
   if (((HEAP16[i2 + 50 >> 1] | 0) + -4 & 65535) < 253) {
    if (!(__ZN5physx17ConvexMeshBuilder14loadConvexHullERKNS_16PxConvexMeshDescE(i5, i2) | 0)) {
     i5 = 0;
     STACKTOP = i6;
     return i5 | 0;
    }
    i2 = i5 + 54 | 0;
    __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E(i5 + 16 | 0, HEAPU8[i2 >> 0] | 0, HEAP32[i5 + 132 >> 2] | 0);
    i2 = HEAPU8[i2 >> 0] | 0;
    switch (i4 | 0) {
    case 4:
    case 2:
    case 1:
     {
      i1 = 128;
      break;
     }
    case 0:
     {
      i1 = 32;
      break;
     }
    case 3:
     {
      i1 = 32;
      break;
     }
    default:
     i1 = 0;
    }
    if (i2 >>> 0 > i1 >>> 0) __ZN5physx17ConvexMeshBuilder16computeGaussMapsEv(i5) | 0;
    __ZN5physx17ConvexMeshBuilder22computeInternalObjectsEv(i5);
    i5 = 1;
    STACKTOP = i6;
    return i5 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726597 | 0, 57, gb + 729608 | 0, i3);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24JointTranslationLimits2D8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 802983 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 803002 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i11 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i11 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 4 | 0, i11);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE6AssignEPK11KeyframeTplIS0_ES5_(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i8 + 120 | 0;
 i7 = i8 + 132 | 0;
 i2 = i1 - i6 | 0;
 i3 = (i2 | 0) / 40 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = i8 + 136 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2, 4, i8 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i8 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
 i5 = i8 + 120 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i7 = i8 + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 64 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  i8 = i8 + 60 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 i1 = i2;
 i4 = i2 + (i3 * 40 | 0) | 0;
 L11 : while (1) {
  while (1) {
   if (!(((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 8 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i1 + 12 >> 2] & 2139095040 | 0) != 2139095040)) break;
   if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
   i1 = i1 + 40 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 13;
    break L11;
   }
  }
  i4 = i1 + 40 | 0;
  _memmove(i1 | 0, i4 | 0, i2 + (i3 * 40 | 0) - i4 | 0) | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i3;
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = i2 + (i3 * 40 | 0) | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 13;
   break;
  }
 }
 if ((i1 | 0) == 13) {
  i7 = i8 + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  HEAP32[i8 >> 2] = 0;
  i7 = i8 + 64 | 0;
  HEAPF32[i7 >> 2] = Math_fround(inf);
  i8 = i8 + 60 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
}

function __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform(i8, i1, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i12 = i8 + 4 | 0;
 i13 = i1 + 12 | 0;
 i14 = i13;
 i15 = i1 + 4 | 0;
 i9 = i15;
 i6 = i1 + 20 | 0;
 i7 = i6;
 i2 = 0;
 i3 = 0;
 i5 = 0;
 i1 = 0;
 do {
  i17 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i17 + (i5 << 4) + 12 >> 2] | 0;
  switch (HEAP32[i17 + (i5 << 4) + 4 >> 2] | 0) {
  case 2:
  case 4:
   {
    if (!((i4 | 0) == 0 | (i4 | 0) == (i10 | 0))) {
     i17 = (HEAP32[i13 >> 2] | 0) + i14 + (i1 << 4) | 0;
     HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     HEAP32[i11 + 12 >> 2] = HEAP32[i17 + 12 >> 2];
     __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i4, i11);
    }
    i1 = i1 + 1 | 0;
    break;
   }
  case 1:
   {
    if (!((i4 | 0) == 0 | (i4 | 0) == (i10 | 0))) {
     i17 = (HEAP32[i15 >> 2] | 0) + i9 + (i2 * 12 | 0) | 0;
     HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i4, i11);
    }
    i2 = i2 + 1 | 0;
    break;
   }
  case 3:
   {
    if (!((i4 | 0) == 0 | (i4 | 0) == (i10 | 0))) {
     i17 = (HEAP32[i6 >> 2] | 0) + i7 + (i3 * 12 | 0) | 0;
     HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
     HEAP32[i11 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
     HEAP32[i11 + 8 >> 2] = HEAP32[i17 + 8 >> 2];
     __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i4, i11);
    }
    i3 = i3 + 1 | 0;
    break;
   }
  default:
   {}
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (HEAP32[i8 >> 2] | 0));
 STACKTOP = i16;
 return;
}

function __ZNSt3__29to_stringEe(i7, d5) {
 i7 = i7 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAPF64[i6 >> 3] = d5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084519 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__29to_stringEd(i7, d5) {
 i7 = i7 | 0;
 d5 = +d5;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i9 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i9 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 __THREW__ = 0;
 invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  ___resumeException(i8 | 0);
 }
 i2 = HEAP8[i4 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 while (1) {
  i3 = i2 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  HEAPF64[i6 >> 3] = d5;
  i3 = _snprintf(i3, i1 + 1 | 0, gb + 1084516 | 0, i6) | 0;
  if ((i3 | 0) > -1) if (i3 >>> 0 > i1 >>> 0) i1 = i3; else {
   i2 = 14;
   break;
  } else i1 = i1 << 1 | 1;
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i2 = 19;
   break;
  }
  i2 = HEAP8[i4 >> 0] | 0;
 }
 do if ((i2 | 0) == 14) {
  __THREW__ = 0;
  invoke_viii(fb + 1039 | 0, i9 | 0, i3 | 0, 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  };
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = 0;
  while (1) {
   if ((i1 | 0) == 3) break;
   HEAP32[i9 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 19) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 ___resumeException(i1 | 0);
}

function __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = i2;
 i8 = i12;
 i5 = i10 - i8 | 0;
 i7 = i5 >> 2;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i11 = i3;
 if (i7 >>> 0 > i1 - i3 >> 2 >>> 0) {
  if (i3) {
   i1 = i4 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i11 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i11);
   HEAP32[i6 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = 0;
  }
  if (i7 >>> 0 > 1073741823) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else i2 = 0;
  i11 = i1 - i2 | 0;
  i1 = i11 >> 1;
  i1 = i11 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i7 >>> 0 ? i7 : i1) : 1073741823;
  if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i2 = __Znwj(i1 << 2) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i6 >> 2] = i2 + (i1 << 2);
  if ((i5 | 0) <= 0) return;
  _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
  HEAP32[i3 >> 2] = i2 + (i7 << 2);
  return;
 }
 i9 = i4 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i1 - i3 >> 2;
 i6 = i7 >>> 0 > i5 >>> 0;
 i5 = i6 ? i12 + (i5 << 2) | 0 : i2;
 i4 = i1;
 i7 = i1;
 if ((i5 | 0) == (i12 | 0)) i1 = i11; else {
  i3 = i5 + -4 - i8 | 0;
  i1 = i12;
  i2 = i11;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i2 + 4 | 0;
  }
  i1 = i11 + ((i3 >>> 2) + 1 << 2) | 0;
 }
 if (i6) {
  i1 = i10 - i5 | 0;
  if ((i1 | 0) <= 0) return;
  _memcpy(i7 | 0, i5 | 0, i1 | 0) | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + (i1 >> 2 << 2);
  return;
 } else {
  if ((i4 | 0) == (i1 | 0)) return;
  HEAP32[i9 >> 2] = i4 + (~((i4 + -4 - i1 | 0) >>> 2) << 2);
  return;
 }
}

function __ZNK17BaseWebCamTexture9GetPixelsE13TextureFormatPvj(i1, i2, i3, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 20 | 0;
 i8 = i9;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895035 | 0, 0, gb + 895080 | 0, 102, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP8[i1 + 94 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895154 | 0, 0, gb + 895080 | 0, 108, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i4 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i4, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0) | 0;
 i5 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0, i2) | 0;
 if ((Math_imul(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i5) | 0) >>> 0 > i6 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895274 | 0, 0, gb + 895080 | 0, 151, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 } else {
  i11 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
  i10 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i7, i11, i10, i4, i6, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0);
  i6 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i8, i6, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i5, i2, i3);
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i8, i7, 0);
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 return 0;
}

function __ZN30RuntimeInitializeOnLoadManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 64596 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 STACKTOP = i4;
 return;
}

function __ZN15StaticBatchInfo8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37288 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 405154 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 2 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 2);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 2 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 405167 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z50NavMesh_CUSTOM_INTERNAL_CALL_CalculatePathInternalRK8Vector3fS1_iP12Il2CppObject(i4, i5, i2, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 128 >> 2] = i2;
 i2 = __Z25GetNavMeshProjectSettingsv() | 0;
 i1 = 0;
 do {
  HEAPF32[i6 + (i1 << 2) >> 2] = Math_fround(__ZNK22NavMeshProjectSettings11GetAreaCostEj(i2, i1));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i6 = (__ZN14NavMeshManager20CalculatePolygonPathEP11NavMeshPathRK8Vector3fS4_RK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i3, i4, i5, i6) | 0) > 0 & 1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i5, i1, i6, i7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  {
   i3 = i5 + 48 | 0;
   i4 = HEAP32[i5 + 52 >> 2] | 0;
   switch (i4 >>> 30 | 0) {
   case 3:
    break;
   case 2:
    {
     if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2432 >> 0] | 0)) i2 = 4;
     break;
    }
   default:
    i2 = 4;
   }
   if ((i2 | 0) == 4) {
    __ZN5physx2Sc8BodyCore24clearSpatialAccelerationEbb(i5 + 64 | 0, i6, i7);
    return;
   }
   i2 = i5 + 56 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i4 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
    HEAP32[i2 >> 2] = i4;
    i2 = i4;
   } else i2 = i1;
   i3 = i5 + 284 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i6) {
    HEAP32[i2 + 220 >> 2] = 0;
    HEAP32[i2 + 224 >> 2] = 0;
    HEAP32[i2 + 228 >> 2] = 0;
    i1 = i1 & -16385;
   }
   if (i7) {
    HEAP32[i2 + 232 >> 2] = 0;
    HEAP32[i2 + 236 >> 2] = 0;
    HEAP32[i2 + 240 >> 2] = 0;
    i1 = i1 & -32769;
   }
   HEAP32[i3 >> 2] = i1;
   return;
  }
 case 2:
 case 1:
  {
   i3 = i5 + 48 | 0;
   i4 = HEAP32[i5 + 52 >> 2] | 0;
   switch (i4 >>> 30 | 0) {
   case 3:
    break;
   case 2:
    {
     if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2432 >> 0] | 0)) i2 = 14;
     break;
    }
   default:
    i2 = 14;
   }
   if ((i2 | 0) == 14) {
    __ZN5physx2Sc8BodyCore20clearSpatialVelocityEbb(i5 + 64 | 0, i6, i7);
    return;
   }
   i1 = i5 + 56 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
    HEAP32[i1 >> 2] = i2;
   }
   i3 = i5 + 284 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i6) {
    HEAP32[i2 + 244 >> 2] = 0;
    HEAP32[i2 + 248 >> 2] = 0;
    HEAP32[i2 + 252 >> 2] = 0;
    i1 = i1 & -65537;
   }
   if (i7) {
    HEAP32[i2 + 256 >> 2] = 0;
    HEAP32[i2 + 260 >> 2] = 0;
    HEAP32[i2 + 264 >> 2] = 0;
    i1 = i1 & -131073;
   }
   HEAP32[i3 >> 2] = i1;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx16PxsFluidDynamics10mergeForceEPNS_10PxBaseTaskE(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i4 = HEAP32[i10 + 80 >> 2] | 0;
 i7 = HEAP32[i4 + 40 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 48 >> 2] | 0;
 i3 = HEAP32[i4 + 64 >> 2] | 0;
 i4 = HEAP32[i4 + 36 >> 2] | 0;
 if (!i7) {
  i1 = i10 + 88 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = i10 + 84 | 0;
  i6 = i10 + 60 | 0;
  i2 = i10 + 88 | 0;
  i9 = 0;
  do {
   i11 = HEAP32[i4 + (i9 << 2) >> 2] | 0;
   i12 = HEAP32[i5 >> 2] | 0;
   f13 = Math_fround(HEAPF32[i10 >> 2]);
   f14 = Math_fround(HEAPF32[i6 >> 2]);
   i1 = i12 + (i9 << 5) + 12 | 0;
   f13 = Math_fround(f14 * Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f13));
   HEAPF32[i1 >> 2] = f13;
   HEAP32[i8 + (i11 << 5) >> 2] = HEAP32[i12 + (i9 << 5) >> 2];
   HEAP32[i8 + (i11 << 5) + 4 >> 2] = HEAP32[i12 + (i9 << 5) + 4 >> 2];
   HEAP32[i8 + (i11 << 5) + 8 >> 2] = HEAP32[i12 + (i9 << 5) + 8 >> 2];
   HEAPF32[i8 + (i11 << 5) + 12 >> 2] = f13;
   HEAP32[i8 + (i11 << 5) + 16 >> 2] = HEAP32[i12 + (i9 << 5) + 16 >> 2];
   HEAP32[i8 + (i11 << 5) + 20 >> 2] = HEAP32[i12 + (i9 << 5) + 20 >> 2];
   HEAP32[i8 + (i11 << 5) + 24 >> 2] = HEAP32[i12 + (i9 << 5) + 24 >> 2];
   i1 = i8 + (i11 << 5) + 28 | 0;
   i12 = i12 + (i9 << 5) + 28 | 0;
   i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
   HEAP16[i1 >> 1] = i12;
   HEAP16[i1 + 2 >> 1] = i12 >>> 16;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 + (i11 * 12 | 0) >> 2] = HEAP32[i1 + (i9 * 12 | 0) >> 2];
   HEAP32[i3 + (i11 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 4 >> 2];
   HEAP32[i3 + (i11 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i9 * 12 | 0) + 8 >> 2];
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i7 | 0));
 }
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN17AudioChorusFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853419 | 0, i5, i1 + 44 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853428 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853438 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853448 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853458 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853466 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853473 | 0, i5, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15dtProximityGrid7addItemEiPKf(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 i14 = ~~Math_fround(Math_floor(Math_fround(f17 * f16)));
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i4 = ~~Math_fround(Math_floor(Math_fround(f17 * f15)));
 i13 = ~~Math_fround(Math_floor(Math_fround(f16 * Math_fround(HEAPF32[i1 + 8 >> 2]))));
 i9 = ~~Math_fround(Math_floor(Math_fround(f15 * Math_fround(HEAPF32[i1 + 12 >> 2]))));
 i12 = i3 + 28 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i11 | 0) < (i14 | 0) ? i11 : i14;
 i12 = i3 + 32 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i11 | 0) < (i4 | 0) ? i11 : i4;
 i12 = i3 + 36 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i11 | 0) > (i13 | 0) ? i11 : i13;
 i12 = i3 + 40 | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = (i11 | 0) > (i9 | 0) ? i11 : i9;
 if ((i4 | 0) > (i9 | 0)) return;
 i10 = i3 + 12 | 0;
 i11 = i3 + 24 | 0;
 i12 = i3 + 8 | 0;
 i7 = i2 & 65535;
 i8 = i3 + 20 | 0;
 if ((i14 | 0) > (i13 | 0)) return;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 L7 : while (1) {
  i3 = Math_imul(i4, 19349663) | 0;
  i5 = i4 & 65535;
  i2 = i14;
  while (1) {
   if ((i1 | 0) >= (i6 | 0)) {
    i1 = 8;
    break L7;
   }
   i18 = (HEAP32[i11 >> 2] | 0) + -1 & ((Math_imul(i2, 73856093) | 0) ^ i3);
   i19 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i10 >> 2] = i1;
   i20 = i19 & 65535;
   i21 = HEAP32[i12 >> 2] | 0;
   HEAP16[i21 + (i20 << 3) >> 1] = i7;
   i18 = (HEAP32[i8 >> 2] | 0) + (i18 << 1) | 0;
   HEAP16[i21 + (i20 << 3) + 2 >> 1] = HEAP16[i18 >> 1] | 0;
   HEAP16[i21 + (i20 << 3) + 4 >> 1] = i2;
   HEAP16[i21 + (i20 << 3) + 6 >> 1] = i5;
   HEAP16[i18 >> 1] = i19;
   if ((i2 | 0) >= (i13 | 0)) break; else i2 = i2 + 1 | 0;
  }
  if ((i4 | 0) < (i9 | 0)) i4 = i4 + 1 | 0; else {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZL18Texture2D_EncodeToP9Texture2DR13dynamic_arrayIhLj1EEii(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i10 + 16 | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
  i2 = i1 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
  } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP32[i7 + 16 >> 2] = 0;
  do if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i3, i7, 0, 0) | 0) {
   i1 = (i5 | 0) == 0;
   if (i1) {
    if (__Z23ConvertImageToPNGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EE(i7, i4) | 0) {
     i1 = 1;
     break;
    }
   } else if ((i5 | 0) == 1) if (__Z23ConvertImageToJPGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EEi(i7, i4, i6) | 0) {
    i1 = 1;
    break;
   }
   HEAP32[i9 >> 2] = i1 ? gb + 417401 | 0 : gb + 417405 | 0;
   __Z6FormatPKcz(i8, gb + 417409 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 410682 | 0, 1547, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 0;
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 934273 | 0, 0, gb + 410682 | 0, 1536, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
   i1 = 0;
  } while (0);
  i9 = i1;
  STACKTOP = i10;
  return i9 | 0;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 43072 >> 2] | 0, 0, gb + 410682 | 0, 1530, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function _getdelim(i11, i7, i10, i12) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 L1 : do if ((i11 | 0) != 0 & (i7 | 0) != 0) {
  if (!(HEAP32[i11 >> 2] | 0)) HEAP32[i7 >> 2] = 0;
  if ((HEAP32[i12 + 76 >> 2] | 0) > -1) i13 = ___lockfile(i12) | 0; else i13 = 0;
  i8 = i12 + 4 | 0;
  i9 = i12 + 8 | 0;
  i3 = 0;
  while (1) {
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = i4;
   i5 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
   i1 = _memchr(i4, i10, i5) | 0;
   i6 = (i1 | 0) != 0;
   i5 = i6 ? 1 - i2 + i1 | 0 : i5;
   i1 = i5 + i3 | 0;
   if (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) i2 = HEAP32[i11 >> 2] | 0; else {
    if (i5 >>> 0 >= (2147483647 - i3 | 0) >>> 0) {
     i14 = 25;
     break;
    }
    i4 = i1 + 2 | 0;
    i2 = i4 << (i4 >>> 0 < 1073741823 & 1);
    HEAP32[i7 >> 2] = i2;
    i2 = _realloc(HEAP32[i11 >> 2] | 0, i2) | 0;
    if (!i2) {
     HEAP32[i7 >> 2] = i4;
     i2 = _realloc(HEAP32[i11 >> 2] | 0, i4) | 0;
     if (!i2) {
      i14 = 25;
      break;
     }
    }
    HEAP32[i11 >> 2] = i2;
    i4 = HEAP32[i8 >> 2] | 0;
   }
   _memcpy(i2 + i3 | 0, i4 | 0, i5 | 0) | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + i5 | 0;
   HEAP32[i8 >> 2] = i2;
   if (i6) break;
   if (i2 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
    HEAP32[i8 >> 2] = i2 + 1;
    i2 = HEAPU8[i2 >> 0] | 0;
   } else {
    i2 = ___uflow(i12) | 0;
    if ((i2 | 0) == -1) {
     i14 = 18;
     break;
    }
   }
   i3 = i1 + 1 | 0;
   HEAP8[(HEAP32[i11 >> 2] | 0) + i1 >> 0] = i2;
   if ((i2 << 24 >> 24 | 0) == (i10 | 0)) {
    i1 = i3;
    break;
   }
  }
  if ((i14 | 0) == 25) {
   if (i13 | 0) ___unlockfile(i12);
   HEAP32[(___errno_location() | 0) >> 2] = 12;
   i1 = -1;
   break;
  }
  do if ((i14 | 0) == 18) {
   if (i1 | 0) if (HEAP32[i12 >> 2] & 16 | 0) break;
   if (!i13) {
    i1 = -1;
    break L1;
   }
   ___unlockfile(i12);
   i1 = -1;
   break L1;
  } while (0);
  HEAP8[(HEAP32[i11 >> 2] | 0) + i1 >> 0] = 0;
  if (i13) ___unlockfile(i12);
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 } while (0);
 return i1 | 0;
}

function __ZN19SpriteMeshGenerator4path18SetSizeUnOptimizedEii(i10, i9, i11) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f12 = f0, f13 = f0;
 HEAP32[i10 + 12 >> 2] = i9;
 HEAP32[i10 + 16 >> 2] = i11;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = (HEAP32[i10 + 4 >> 2] | 0) - i2 | 0;
 i6 = i1 >> 5;
 if ((i1 | 0) > 0) {
  f7 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(1.17549435e-38);
  f5 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
  do {
   f13 = Math_fround(HEAPF32[i2 + (i1 << 5) >> 2]);
   f12 = Math_fround(HEAPF32[i2 + (i1 << 5) + 4 >> 2]);
   f7 = f13 < f7 ? f13 : f7;
   f3 = f12 < f3 ? f12 : f3;
   f5 = f13 > f5 ? f13 : f5;
   f4 = f12 > f4 ? f12 : f4;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
  if (f7 < Math_fround(0.0)) i6 = 0; else i8 = 4;
 } else {
  f7 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(1.17549435e-38);
  f5 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i8 = 4;
 }
 if ((i8 | 0) == 4) {
  f13 = Math_fround(i9 | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f7 > f13 ? f13 : f7, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f3 < Math_fround(0.0)) i2 = 0; else {
  f13 = Math_fround(i11 | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3 > f13 ? f13 : f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f5 < Math_fround(0.0)) i1 = 0; else {
  f13 = Math_fround(i9 | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5 > f13 ? f13 : f5, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f4 < Math_fround(0.0)) {
  i9 = 0;
  i11 = i10 + 28 | 0;
  HEAP32[i11 >> 2] = i6;
  i11 = i10 + 32 | 0;
  HEAP32[i11 >> 2] = i2;
  i11 = i10 + 36 | 0;
  HEAP32[i11 >> 2] = i1;
  i11 = i10 + 40 | 0;
  HEAP32[i11 >> 2] = i9;
  return;
 }
 f13 = Math_fround(i11 | 0);
 i9 = (HEAPF32[tempDoublePtr >> 2] = f4 > f13 ? f13 : f4, HEAP32[tempDoublePtr >> 2] | 0);
 i11 = i10 + 28 | 0;
 HEAP32[i11 >> 2] = i6;
 i11 = i10 + 32 | 0;
 HEAP32[i11 >> 2] = i2;
 i11 = i10 + 36 | 0;
 HEAP32[i11 >> 2] = i1;
 i11 = i10 + 40 | 0;
 HEAP32[i11 >> 2] = i9;
 return;
}

function __ZL33GetNonSkeletonTransformsRecursiveRKN7mecanim8skeleton8SkeletonERK9TransformS6_R13dynamic_arrayIPS5_Lj4EE(i6, i7, i5, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 __Z22CalculateTransformPathRK9TransformPS0_(i4, i5, i7);
 i1 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i8 = _strlen(i1) | 0;
 i3 = i1 + i8 | 0;
 if ((i8 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 i8 = (__ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i6, i1) | 0) == -1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (!i8) {
  i3 = HEAP32[i5 + 92 >> 2] | 0;
  if ((i3 | 0) <= 0) {
   STACKTOP = i10;
   return;
  }
  i2 = i5 + 80 | 0;
  i1 = 0;
  do {
   __ZL33GetNonSkeletonTransformsRecursiveRKN7mecanim8skeleton8SkeletonERK9TransformS6_R13dynamic_arrayIPS5_Lj4EE(i6, i7, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i9);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  STACKTOP = i10;
  return;
 }
 i2 = i5;
 i3 = i9 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 STACKTOP = i10;
 return;
}

function __ZN9Projector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 48 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 52 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 56 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 64 | 0, i6);
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 }
}

function __ZN7mecanim8skeleton4Node8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906607 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906618 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEclERS4_17TransferMetaFlagsR9BlobWrite(i1, i5, i2, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i4 = i5 + 4 | 0;
 if (!(HEAP32[HEAP32[i4 >> 2] >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (HEAP32[i8 >> 2] | 0) + i8 | 0;
 i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i7) | 0;
 i2 = HEAP8[i7 + 26 >> 0] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP8[i1 + 21 >> 0] = i3 & 1;
 HEAP8[i1 + 22 >> 0] = i2;
 i2 = i1 + 20 | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i8, i1);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (0 - i1 & 3) + i1 | 0;
 HEAP32[i3 >> 2] = i1;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i2 >> 0] = 0;
 i8 = (0 - i1 & 3) + i1 | 0;
 i8 = i8 + 4 + (0 - i8 & 3) | 0;
 i8 = Math_imul((0 - i8 & 3) + i8 | 0, HEAP32[HEAP32[i4 >> 2] >> 2] | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i7, i8, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i8 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 i2 = i1 + (i8 * 48 | 0) | 0;
 if (i8 | 0) do {
  __ZN9BlobWrite8TransferIN7mecanim5human6HandleEEEvRT_PKc17TransferMetaFlags(i7, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i7 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i7 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - (HEAP32[i7 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i7 + 44 >> 2] | 0) + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i6;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i6;
 return;
}

function __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 827416 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 827423 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN20ComputeBufferCounter8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469681 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 744923 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi(i7, i4, i8, i1) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 L1 : do if ((i1 | 0) == 1) i1 = 0; else {
  i5 = i8 + 4 | 0;
  i6 = i8 + 8 | 0;
  i3 = i1;
  i1 = 0;
  do {
   i2 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, i4, i1) | 0;
   if ((i2 | 0) == -1) break L1;
   while (1) {
    if (i2 >>> 0 > i1 >>> 0) break;
    i1 = i2 + 1 | 0;
    i2 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, i4, i1) | 0;
    if ((i2 | 0) == -1) break L1;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i7, i1, i2 - i1 | 0, i7);
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i8, i9); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i9);
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i3 = i3 + -1 | 0;
   i1 = i2 + 1 | 0;
  } while ((i3 | 0) != 1);
 } while (0);
 i6 = HEAP8[i7 + 11 >> 0] | 0;
 if (i1 >>> 0 >= (i6 << 24 >> 24 < 0 ? HEAP32[i7 + 4 >> 2] | 0 : i6 & 255) >>> 0) {
  STACKTOP = i10;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i7, i1, -1, i7);
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i8 + 8 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i8, i9); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i9);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZN17BufferManagerGLES13InvalidateAllEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i8 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) i5 = 0; else {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = i2 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   if (i2 | 0) if (HEAP8[i2 + 20 >> 0] | 0) {
    __Z34register_external_gfx_deallocationPvPKci(-1073741824, gb + 602218 | 0, 116);
    if (HEAP32[i3 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i3);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
   HEAP32[i1 >> 2] = 0;
   i3 = i1 + 4 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) break; else i1 = i3;
  }
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) i5 = 0; else {
   HEAP32[i5 >> 2] = i3 + (~((i1 - i2 | 0) >>> 2) << 2);
   i5 = 0;
  }
 }
 do {
  i6 = i8 + 16 + (i5 * 12 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i8 + 16 + (i5 * 12 | 0) + 4 | 0;
  if ((i1 | 0) != (i7 | 0)) {
   i2 = i1;
   while (1) {
    i1 = i2 + 20 | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    i4 = i3 + 4 | 0;
    HEAP32[i4 >> 2] = 0;
    if (i3 | 0) if (HEAP8[i3 + 20 >> 0] | 0) {
     __Z34register_external_gfx_deallocationPvPKci(-1073741824, gb + 602218 | 0, 116);
     if (HEAP32[i4 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i4);
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63304 | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
   }
  }
  __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i6, HEAP32[i7 >> 2] | 0);
  HEAP32[i8 + 16 + (i5 * 12 | 0) + 8 >> 2] = 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i7 >> 2] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 11);
 return;
}

function __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 i5 = i1 + 24 | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo(i9, HEAP32[i5 >> 2] | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i4 = (i2 | 0) / 88 | 0;
 i3 = i5 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) {
  HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i4) | 0;
  HEAP32[i3 >> 2] = i4;
 }
 if (i2 | 0) {
  i1 = 0;
  do {
   i3 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i5 >> 2] | 0, i1) | 0;
   __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i6, (HEAP32[i9 >> 2] | 0) + (i1 * 88 | 0) | 0, i3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i7 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf(i3, i18, f19) {
 i3 = i3 | 0;
 i18 = i18 | 0;
 f19 = Math_fround(f19);
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i20 = 0;
 i20 = i18 + 8 | 0;
 f2 = Math_fround(HEAPF32[i20 >> 2]);
 if (f2 == f19) return;
 if (f2 > f19) {
  HEAPF32[i20 >> 2] = Math_fround(-inf);
  i17 = i18 + 12 | 0;
  HEAP32[i17 >> 2] = 0;
  i1 = 0;
 } else {
  i1 = i18 + 12 | 0;
  i17 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i16 = i3 + 4 | 0;
 i3 = HEAP32[i16 >> 2] | 0;
 i16 = (i3 | 0) == 0 ? 0 : i3 + i16 | 0;
 i3 = i16 + i1 | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) <= f19) do {
  i14 = HEAP32[i18 >> 2] | 0;
  i15 = HEAP32[i3 >> 2] | 0;
  i11 = i3 + 8 | 0;
  i12 = i3 + 4 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i9 = HEAP32[i11 >> 2] | 0;
  i5 = HEAP32[i3 + 12 >> 2] | 0;
  i7 = HEAP32[i3 + 24 >> 2] | 0;
  i6 = HEAP32[i3 + 20 >> 2] | 0;
  i4 = HEAP32[i3 + 16 >> 2] | 0;
  if ((i13 | 0) > 1) {
   i8 = 1;
   i10 = i7;
   i3 = i9;
   while (1) {
    HEAP32[i14 + (i3 * 20 | 0) >> 2] = i15;
    HEAP32[i14 + (i3 * 20 | 0) + 4 >> 2] = i5;
    HEAP32[i14 + (i3 * 20 | 0) + 8 >> 2] = i4;
    HEAP32[i14 + (i3 * 20 | 0) + 12 >> 2] = i6;
    HEAP32[i14 + (i3 * 20 | 0) + 16 >> 2] = i10;
    i7 = i8 + 1 | 0;
    i3 = HEAP32[i11 + (i8 * 20 | 0) >> 2] | 0;
    i5 = HEAP32[i11 + (i8 * 20 | 0) + 4 >> 2] | 0;
    i10 = HEAP32[i11 + (i8 * 20 | 0) + 16 >> 2] | 0;
    i6 = HEAP32[i11 + (i8 * 20 | 0) + 12 >> 2] | 0;
    i4 = HEAP32[i11 + (i8 * 20 | 0) + 8 >> 2] | 0;
    if ((i7 | 0) == (i13 | 0)) break; else i8 = i7;
   }
   i9 = i3;
   i7 = i10;
   i3 = HEAP32[i12 >> 2] | 0;
  } else i3 = i13;
  HEAP32[i14 + (i9 * 20 | 0) >> 2] = i15;
  HEAP32[i14 + (i9 * 20 | 0) + 4 >> 2] = i5;
  HEAP32[i14 + (i9 * 20 | 0) + 8 >> 2] = i4;
  HEAP32[i14 + (i9 * 20 | 0) + 12 >> 2] = i6;
  HEAP32[i14 + (i9 * 20 | 0) + 16 >> 2] = i7;
  i1 = i1 + 8 + (i3 * 20 | 0) | 0;
  i3 = i16 + i1 | 0;
 } while (Math_fround(HEAPF32[i3 >> 2]) <= f19);
 HEAPF32[i20 >> 2] = f19;
 HEAP32[i17 >> 2] = i1;
 return;
}

function __ZN20BufferedSocketStream4SendEPKvj(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!(HEAP8[i3 + 18 >> 0] | 0)) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = i3 + 20 | 0;
 i6 = i3 + 40 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 i1 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
 i2 = i3 + 48 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i9 = i10 + 24 | 0;
 i12 = HEAP32[i10 + 16 >> 2] | 0;
 i11 = i12 - (HEAP32[i9 >> 2] | 0) + (HEAP32[i10 + 20 >> 2] | 0) | 0;
 i9 = i12 + -1 & HEAP32[i9 >> 2];
 i12 = i12 - i9 | 0;
 i11 = i12 >>> 0 < i11 >>> 0 ? i12 : i11;
 i1 = i11 >>> 0 < i1 >>> 0 ? i11 : i1;
 _memcpy((HEAP32[i10 >> 2] | 0) + i9 | 0, i4 | 0, i1 | 0) | 0;
 i4 = (HEAP32[i2 >> 2] | 0) + 24 | 0;
 HEAP32[i4 >> 2] = i1 + (HEAP32[i4 >> 2] | 0);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
 i4 = HEAP32[i2 >> 2] | 0;
 if (((HEAP32[i4 + 16 >> 2] | 0) - (HEAP32[i4 + 24 >> 2] | 0) | 0) != (0 - (HEAP32[i4 + 20 >> 2] | 0) | 0)) {
  i12 = i1;
  STACKTOP = i8;
  return i12 | 0;
 }
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) {
  i12 = i1;
  STACKTOP = i8;
  return i12 | 0;
 }
 i10 = __Znwj(32) | 0;
 i5 = i3 + 28 | 0;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i12 = i3 + 36 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 i6 = 1 << 31 - (Math_clz32((i6 << 1) + -1 | 0) | 0);
 i11 = i10 + 16 | 0;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i10 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i7, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i10 + 4 >> 0] = 1;
 i6 = i7;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i10 + 8 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i10 + 28 >> 2] = 0;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] = i10;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + (HEAP32[i11 >> 2] | 0);
 i12 = i1;
 STACKTOP = i8;
 return i12 | 0;
}

function __ZN18JointAngleLimits2D8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 801470 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 801483 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN10Effector2D19RecalculateContactsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 8 | 0;
 i2 = i12;
 i11 = i12 + 16 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0)) {
  STACKTOP = i12;
  return;
 }
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i3 = i11 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i6 = i1;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 if (__ZNK10Effector2D18GetActiveCollidersER13dynamic_arrayIP10Collider2DLj4EE(i4, i11) | 0) {
  if (HEAP32[i3 >> 2] | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   do {
    __ZN10Collider2D19RecalculateContactsEv(HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
  }
  i8 = i4 + 36 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i7 = i4 + 48 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i6 = i2;
   do {
    i3 = HEAP32[i6 + 16 >> 2] | 0;
    i4 = i3 + 4 | 0;
    i5 = HEAPU16[i4 >> 1] | 0;
    if (!(HEAP32[i3 >> 2] | 0)) {
     HEAP16[i4 >> 1] = i5 & 65533;
     HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
     i2 = i3 + 64 | 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i2 + 4 >> 2] = 0;
     HEAP32[i2 + 8 >> 2] = 0;
     HEAP32[i2 + 12 >> 2] = 0;
     HEAP32[i2 + 16 >> 2] = 0;
     HEAP32[i2 + 20 >> 2] = 0;
     i2 = HEAP32[i8 >> 2] | 0;
     i1 = HEAP32[i7 >> 2] | 0;
    } else if (!(i5 & 2)) {
     HEAP16[i4 >> 1] = i5 | 2;
     HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
    }
    i6 = i6 + 40 | 0;
   } while ((i6 | 0) != (i2 + (i1 * 40 | 0) | 0));
  }
 }
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
  HEAP32[i11 >> 2] = 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd8internal7median3IjKNS_19SortBoundsPredicateEEEvPT_iiRT0_(i14, i1, i15, i11) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 i11 = i11 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = i14 + (((i15 + i1 | 0) / 2 | 0) << 2) | 0;
 i9 = i14 + (i1 << 2) | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i12 + (i7 << 5) + (i1 << 2) >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i12 + (i7 << 5) + 16 + (i1 << 2) >> 2]));
 i5 = HEAP32[i9 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i12 + (i5 << 5) + (i1 << 2) >> 2]);
 f4 = Math_fround(HEAPF32[i12 + (i5 << 5) + 16 + (i1 << 2) >> 2]);
 if (f8 < Math_fround(f2 + f4)) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i13 >> 2] = i5;
  i7 = HEAP32[i11 >> 2] | 0;
  i10 = HEAP32[i9 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i12 + (i10 << 5) + (i7 << 2) >> 2]);
  i3 = i7;
  f4 = Math_fround(HEAPF32[i12 + (i10 << 5) + 16 + (i7 << 2) >> 2]);
 } else {
  i3 = i1;
  i10 = i5;
  i5 = i7;
 }
 i7 = i14 + (i15 << 2) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i12 + (i1 << 5) + (i3 << 2) >> 2]);
 f8 = Math_fround(HEAPF32[i12 + (i1 << 5) + 16 + (i3 << 2) >> 2]);
 if (Math_fround(f6 + f8) < Math_fround(f2 + f4)) {
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i10;
  i3 = HEAP32[i11 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i12 + (i10 << 5) + (i3 << 2) >> 2]);
  f2 = Math_fround(HEAPF32[i12 + (i10 << 5) + 16 + (i3 << 2) >> 2]);
  i5 = HEAP32[i13 >> 2] | 0;
  i1 = i10;
 } else f2 = f8;
 f6 = Math_fround(f6 + f2);
 f8 = Math_fround(HEAPF32[i12 + (i5 << 5) + (i3 << 2) >> 2]);
 if (!(f6 < Math_fround(f8 + Math_fround(HEAPF32[i12 + (i5 << 5) + 16 + (i3 << 2) >> 2])))) {
  i12 = i5;
  i15 = i15 + -1 | 0;
  i15 = i14 + (i15 << 2) | 0;
  i14 = HEAP32[i15 >> 2] | 0;
  HEAP32[i13 >> 2] = i14;
  HEAP32[i15 >> 2] = i12;
  return;
 }
 HEAP32[i13 >> 2] = i1;
 HEAP32[i7 >> 2] = i5;
 i12 = HEAP32[i13 >> 2] | 0;
 i15 = i15 + -1 | 0;
 i15 = i14 + (i15 << 2) | 0;
 i14 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i15 >> 2] = i12;
 return;
}

function __ZL22SRGB_GammaToLinear_JobP17ImageSliceJobDataj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP32[i1 + (i2 * 12 | 0) >> 2] | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i8 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 if ((i4 | 0) >= (i8 | 0)) return;
 i7 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 do {
  i2 = 0;
  i3 = i7 + (Math_imul(i6, i4) | 0) | 0;
  while (1) {
   i1 = i3 + 4 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(.0404499993))) {
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
   } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
   HEAPF32[i1 >> 2] = f5;
   i1 = i3 + 8 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(.0404499993))) {
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
   } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
   HEAPF32[i1 >> 2] = f5;
   i1 = i3 + 12 | 0;
   f5 = Math_fround(HEAPF32[i1 >> 2]);
   do if (!(f5 <= Math_fround(.0404499993))) {
    if (f5 < Math_fround(1.0)) {
     f5 = Math_fround(+Math_pow(+Math_fround(Math_fround(f5 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
     break;
    }
    if (f5 == Math_fround(1.0)) f5 = Math_fround(1.0); else f5 = Math_fround(+Math_pow(+f5, 2.20000005));
   } else f5 = Math_fround(f5 / Math_fround(12.9200001)); while (0);
   HEAPF32[i1 >> 2] = f5;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i9 | 0)) break; else i3 = i3 + 16 | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i8 | 0));
 return;
}

function _UNITY_png_write_sBIT(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i9 = i10;
 do if (!(i6 & 2)) {
  i1 = HEAP8[i5 + 3 >> 0] | 0;
  if (!(i1 << 24 >> 24)) {
   STACKTOP = i10;
   return;
  }
  if ((i1 & 255) > (HEAPU8[i7 + 433 >> 0] | 0)) {
   STACKTOP = i10;
   return;
  } else {
   HEAP8[i9 >> 0] = i1;
   i1 = 1;
   break;
  }
 } else {
  if ((i6 | 0) == 3) i2 = 8; else i2 = HEAP8[i7 + 433 >> 0] | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  if ((i1 + -1 & 255) >= (i2 & 255)) {
   STACKTOP = i10;
   return;
  }
  i3 = HEAP8[i5 + 1 >> 0] | 0;
  if ((i3 + -1 & 255) >= (i2 & 255)) {
   STACKTOP = i10;
   return;
  }
  i4 = HEAP8[i5 + 2 >> 0] | 0;
  if ((i4 + -1 & 255) < (i2 & 255)) {
   HEAP8[i9 >> 0] = i1;
   HEAP8[i9 + 1 >> 0] = i3;
   HEAP8[i9 + 2 >> 0] = i4;
   i1 = 3;
   break;
  } else {
   STACKTOP = i10;
   return;
  }
 } while (0);
 do if (!(i6 & 4)) {
  if (!i7) {
   STACKTOP = i10;
   return;
  }
 } else {
  i2 = HEAP8[i5 + 4 >> 0] | 0;
  if (!(i2 << 24 >> 24)) {
   STACKTOP = i10;
   return;
  }
  if ((i2 & 255) > (HEAPU8[i7 + 433 >> 0] | 0)) {
   STACKTOP = i10;
   return;
  } else {
   HEAP8[i9 + i1 >> 0] = i2;
   i1 = i1 + 1 | 0;
   break;
  }
 } while (0);
 i6 = i7 + 656 | 0;
 HEAP32[i6 >> 2] = 34;
 HEAP8[i8 >> 0] = i1 >>> 24;
 HEAP8[i8 + 1 >> 0] = i1 >>> 16;
 HEAP8[i8 + 2 >> 0] = i1 >>> 8;
 HEAP8[i8 + 3 >> 0] = i1;
 i5 = i8 + 4 | 0;
 HEAP8[i5 >> 0] = 115;
 HEAP8[i8 + 5 >> 0] = 66;
 HEAP8[i8 + 6 >> 0] = 73;
 HEAP8[i8 + 7 >> 0] = 84;
 _UNITY_png_write_data(i7, i8, 8);
 HEAP32[i7 + 372 >> 2] = 1933723988;
 _UNITY_png_reset_crc(i7);
 _UNITY_png_calculate_crc(i7, i5, 4);
 HEAP32[i6 >> 2] = 66;
 _UNITY_png_write_data(i7, i9, i1);
 _UNITY_png_calculate_crc(i7, i9, i1);
 HEAP32[i6 >> 2] = 130;
 i9 = HEAP32[i7 + 408 >> 2] | 0;
 HEAP8[i8 >> 0] = i9 >>> 24;
 HEAP8[i8 + 1 >> 0] = i9 >>> 16;
 HEAP8[i8 + 2 >> 0] = i9 >>> 8;
 HEAP8[i8 + 3 >> 0] = i9;
 _UNITY_png_write_data(i7, i8, 4);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i9 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 108 | 0) >>> 0 >= i2 >>> 0) {
  do {
   __ZN9InputAxisC2Ev(i1);
   i1 = (HEAP32[i12 >> 2] | 0) + 108 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 108 | 0) + i2 | 0;
 if (i5 >>> 0 > 39768215) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 108 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 19884107 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 39768215;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i9 + 8;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 108 | 0) | 0;
 HEAP32[i10 >> 2] = i5;
 i4 = i5 + (((i1 - i4 | 0) / 108 | 0) * 108 | 0) | 0;
 i6 = i10 + 8 | 0;
 HEAP32[i6 >> 2] = i4;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = i4;
 i8 = i10 + 12 | 0;
 HEAP32[i8 >> 2] = i5 + (i3 * 108 | 0);
 i1 = i4;
 do {
  __ZN9InputAxisC2Ev(i1);
  i1 = i1 + 108 | 0;
  HEAP32[i6 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i1 = i4; else {
  i1 = i4;
  do {
   i1 = i1 + -108 | 0;
   i2 = i2 + -108 | 0;
   __ZN9InputAxisC2ERKS_(i1, i2);
   HEAP32[i7 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i12;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev(i10);
 STACKTOP = i13;
 return;
}

function __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i7, i10, i4) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!(HEAP8[i7 + 25 >> 0] | 0)) return;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 if ((i5 | 0) == 1048575) return;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (HEAP32[i1 + 12 >> 2] | 0) - i5 | 0;
 if (!i5) return;
 i8 = HEAP32[i1 >> 2] | 0;
 i2 = i8 + i5 | 0;
 i1 = 0;
 while (1) {
  if (!(_memcmp(i8 + i1 | 0, i2, i3) | 0)) break;
  i1 = i1 + i4 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 17;
   break;
  }
 }
 if ((i6 | 0) == 17) return;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i1 - i4 | 0;
 i7 = HEAP16[i7 + 26 >> 1] | 0;
 i1 = (i7 & 65535) < 256;
 i2 = _llvm_bswap_i32(i3 | 0) | 0;
 if (!((i7 & 255) << 24 >> 24)) {
  i7 = i1 ? i3 : i2;
  i8 = i8 + i4 | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP8[i8 + 1 >> 0] = i7 >> 8;
  HEAP8[i8 + 2 >> 0] = i7 >> 16;
  HEAP8[i8 + 3 >> 0] = i7 >> 24;
 } else {
  i5 = i1 ? i3 : 0;
  i7 = i1 ? 0 : i2;
  i8 = i8 + i4 | 0;
  i6 = i8;
  HEAP8[i6 >> 0] = i5;
  HEAP8[i6 + 1 >> 0] = i5 >> 8;
  HEAP8[i6 + 2 >> 0] = i5 >> 16;
  HEAP8[i6 + 3 >> 0] = i5 >> 24;
  i8 = i8 + 4 | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP8[i8 + 1 >> 0] = i7 >> 8;
  HEAP8[i8 + 2 >> 0] = i7 >> 16;
  HEAP8[i8 + 3 >> 0] = i7 >> 24;
 }
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 i2 = i6 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 16, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = i10;
  break;
 } while (0);
 if (i1 >>> 0 <= i5 >>> 0) return;
 i1 = i1 - i5 | 0;
 if (!i1) return;
 _memset((HEAP32[i6 >> 2] | 0) + i5 | 0, 0, i1 | 0) | 0;
 return;
}

function __Z8EvaluateRK14MinMaxGradientff(i1, i2, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 80 | 0;
 i7 = i12 + 64 | 0;
 i8 = i12 + 48 | 0;
 i9 = i12 + 32 | 0;
 i10 = i12 + 16 | 0;
 i11 = i12;
 i3 = (HEAP32[i2 + 68 >> 2] | 0) == 0;
 if (!(HEAP32[i2 + 140 >> 2] | 0)) if (i3) {
  HEAPF32[i6 + 12 >> 2] = f4;
  HEAPF32[i6 + 8 >> 2] = f4;
  HEAPF32[i6 + 4 >> 2] = f4;
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 + 12 >> 2] = f5;
  HEAPF32[i7 + 8 >> 2] = f5;
  HEAPF32[i7 + 4 >> 2] = f5;
  HEAPF32[i7 >> 2] = f5;
  __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i8, i2, i6, i7);
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  STACKTOP = i12;
  return;
 } else {
  HEAPF32[i6 + 12 >> 2] = f4;
  HEAPF32[i6 + 8 >> 2] = f4;
  HEAPF32[i6 + 4 >> 2] = f4;
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 + 12 >> 2] = f5;
  HEAPF32[i7 + 8 >> 2] = f5;
  HEAPF32[i7 + 4 >> 2] = f5;
  HEAPF32[i7 >> 2] = f5;
  __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i9, i2, i6, i7);
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  STACKTOP = i12;
  return;
 } else if (i3) {
  HEAPF32[i6 + 12 >> 2] = f4;
  HEAPF32[i6 + 8 >> 2] = f4;
  HEAPF32[i6 + 4 >> 2] = f4;
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 + 12 >> 2] = f5;
  HEAPF32[i7 + 8 >> 2] = f5;
  HEAPF32[i7 + 4 >> 2] = f5;
  HEAPF32[i7 >> 2] = f5;
  __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i10, i2, i6, i7);
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  STACKTOP = i12;
  return;
 } else {
  HEAPF32[i6 + 12 >> 2] = f4;
  HEAPF32[i6 + 8 >> 2] = f4;
  HEAPF32[i6 + 4 >> 2] = f4;
  HEAPF32[i6 >> 2] = f4;
  HEAPF32[i7 + 12 >> 2] = f5;
  HEAPF32[i7 + 8 >> 2] = f5;
  HEAPF32[i7 + 4 >> 2] = f5;
  HEAPF32[i7 >> 2] = f5;
  __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i11, i2, i6, i7);
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  STACKTOP = i12;
  return;
 }
}

function __Z29AnimationClip_CUSTOM_SetCurveP12Il2CppObjectP12Il2CppStringS0_S2_S0_(i4, i1, i2, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 36 | 0;
 i5 = i12 + 32 | 0;
 i7 = i12 + 28 | 0;
 i9 = i12 + 16 | 0;
 i10 = i12;
 i11 = i12 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZN11ICallStringC2EP12Il2CppString(i7, i3);
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i2);
 i2 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i2) | 0;
 i1 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i2) | 0;
 if (!i1) {
  i1 = 0;
  i3 = -1;
 } else {
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i3 | 0) == 114) {
   i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i2) | 0;
   if (!i1) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 915289 | 0, 0, gb + 915178 | 0, 132, 1, 0, 0, 0);
    STACKTOP = i12;
    return;
   } else i3 = 114;
  } else i1 = 0;
 }
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i9, i5);
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i11, i7);
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZN13AnimationClip8SetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfEbb(i2, i9, i3, i8, i11, i1, 1, 1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i12;
 return;
}

function __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i2 = i8 + 8 | 0;
 i1 = i8;
 i7 = i8 + 20 | 0;
 if (i4 & 2 | 0) {
  HEAP32[i1 >> 2] = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  __Z6FormatPKcz(i7, gb + 913702 | 0, i1);
  i1 = HEAP32[i3 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 899812 | 0, 750, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if (i4 & 4 | 0) {
  HEAP32[i2 >> 2] = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  __Z6FormatPKcz(i7, gb + 913738 | 0, i2);
  i1 = HEAP32[i3 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 899812 | 0, 754, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 if (i4 & 8 | 0) {
  i1 = HEAP32[i3 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 913769 | 0, 0, gb + 899812 | 0, 758, 512, i1, 0, 0);
 }
 if (!(i4 & 16)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 __Z6FormatPKcz(i7, gb + 913804 | 0, i6);
 i1 = HEAP32[i3 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 899812 | 0, 762, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i1 = i7;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i7 = i9 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 88, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = -1;
   HEAP32[i2 + 24 >> 2] = -1;
   HEAP32[i2 + 28 >> 2] = 1;
   i3 = i2 + 32 | 0;
   i4 = i3;
   i5 = i4 + 52 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAP16[i3 + 52 >> 1] = 0;
   HEAP8[i3 + 54 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE(i5, i6, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15 + 12 | 0;
 i13 = i15;
 i14 = i5 + 11 | 0;
 i2 = HEAP8[i14 >> 0] | 0;
 i7 = i2 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
 i8 = i6 + 12 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i9 = i11 + 4 | 0;
 i10 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 while (1) {
  if (!(_strncmp(i1, i2 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5, i7) | 0)) {
   i2 = i1 + i7 | 0;
   while (1) if ((HEAP8[i2 >> 0] | 0) == 47) i2 = i2 + 1 | 0; else break;
  } else i2 = i1;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i13, i2, _strlen(i2) | 0);
  i3 = __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESG_RKT_(i11, i12, i13) | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i2 = __Znwj(28) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + 16 | 0, i13);
   i4 = HEAP32[i12 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i4;
   HEAP32[i3 >> 2] = i2;
   i4 = HEAP32[HEAP32[i11 >> 2] >> 2] | 0;
   if (i4) {
    HEAP32[i11 >> 2] = i4;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 >> 2] | 0, i2);
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
  i1 = i1 + 1088 | 0;
  if ((i1 | 0) == ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i8 >> 2] | 0) * 1088 | 0) | 0)) break;
  i2 = HEAP8[i14 >> 0] | 0;
 }
 STACKTOP = i15;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE4findIS6_EENS_15__tree_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = i1 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i1 | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = HEAP32[i2 + 20 >> 2] | 0;
  i9 = (i9 | 0) == 0 ? i2 + 4 | 0 : i9;
  i7 = i11;
  i2 = i1;
  L3 : while (1) {
   i1 = i2;
   while (1) {
    i8 = HEAP32[i1 + 36 >> 2] | 0;
    i2 = i8 >>> 0 > i10 >>> 0 ? i10 : i8;
    i3 = HEAP32[i1 + 16 >> 2] | 0;
    L7 : do if (!i2) i12 = 6; else {
     i6 = i9;
     i3 = (i3 | 0) == 0 ? i1 + 20 | 0 : i3;
     while (1) {
      i4 = HEAP8[i3 >> 0] | 0;
      i5 = HEAP8[i6 >> 0] | 0;
      if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
      i2 = i2 + -1 | 0;
      if (!i2) {
       i12 = 6;
       break L7;
      } else {
       i6 = i6 + 1 | 0;
       i3 = i3 + 1 | 0;
      }
     }
     i2 = (i4 & 255) - (i5 & 255) | 0;
    } while (0);
    if ((i12 | 0) == 6) {
     i12 = 0;
     i2 = i8 - i10 | 0;
    }
    if ((i2 | 0) >= 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = i1;
    break;
   } else i7 = i1;
  }
  if ((i7 | 0) != (i11 | 0)) {
   i2 = HEAP32[i7 + 16 >> 2] | 0;
   i6 = HEAP32[i7 + 36 >> 2] | 0;
   i1 = i10 >>> 0 > i6 >>> 0 ? i6 : i10;
   L20 : do if (!i1) i12 = 16; else {
    i5 = (i2 | 0) == 0 ? i7 + 20 | 0 : i2;
    i2 = i9;
    while (1) {
     i3 = HEAP8[i2 >> 0] | 0;
     i4 = HEAP8[i5 >> 0] | 0;
     if (i3 << 24 >> 24 != i4 << 24 >> 24) break;
     i1 = i1 + -1 | 0;
     if (!i1) {
      i12 = 16;
      break L20;
     } else {
      i5 = i5 + 1 | 0;
      i2 = i2 + 1 | 0;
     }
    }
    i1 = (i3 & 255) - (i4 & 255) | 0;
   } while (0);
   if ((i12 | 0) == 16) i1 = i10 - i6 | 0;
   if ((i1 | 0) >= 0) {
    i12 = i7;
    return i12 | 0;
   }
  }
 }
 i12 = i11;
 return i12 | 0;
}

function __ZN8StateKey8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 902691 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i6 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 902701 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i9 = i2 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 4 | 0;
 i5 = i7 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = i6 - i4 >> 3;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj(i1, i3 - i2 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] | 0;
 } else if (i3 >>> 0 < i2 >>> 0) {
  i1 = i4 + (i3 << 3) | 0;
  if ((i6 | 0) == (i1 | 0)) i1 = i4; else {
   i6 = i6 + (~((i6 + -8 - i1 | 0) >>> 3) << 3) | 0;
   HEAP32[i5 >> 2] = i6;
   i1 = i4;
  }
 } else i1 = i4;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 2 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 2);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP32[i9 >> 2] = i3;
  }
  i2 = i1 + 2 | 0;
  i5 = i3 + 2 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 2);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
   HEAP32[i9 >> 2] = i5;
  }
  i2 = i1 + 4 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14dtNavMeshQuery9initPoolsEPK9dtNavMeshi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i1 >> 2] = i2;
 i2 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 24) | 0;
 HEAP32[i2 >> 2] = 0;
 i8 = i2 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = 64;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 32;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 2048) | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, HEAP32[i4 >> 2] << 1 | 0) | 0;
 i7 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 64) | 0;
 HEAP32[i8 >> 2] = i7;
 _memset(i7 | 0, -1, HEAP32[i6 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i5 >> 2] | 0, -1, HEAP32[i4 >> 2] << 1 | 0) | 0;
 HEAP32[i1 + 72 >> 2] = i2;
 if (!i2) {
  i8 = -2147483644;
  return i8 | 0;
 }
 if (!i3) {
  i8 = 1073741824;
  return i8 | 0;
 }
 i8 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 24) | 0;
 i4 = ((i3 | 0) / 4 | 0) + -1 | 0;
 i4 = i4 >>> 1 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = (i4 >>> 16 | i4) + 1 | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i3 << 5 | 0) | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
 i4 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i4 << 1 | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 _memset(i4 | 0, -1, HEAP32[i5 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i6 >> 2] | 0, -1, HEAP32[i7 >> 2] << 1 | 0) | 0;
 HEAP32[i1 + 76 >> 2] = i8;
 if (!i8) {
  i8 = -2147483644;
  return i8 | 0;
 }
 i8 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 12) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, (i3 << 2) + 4 | 0) | 0;
 HEAP32[i1 + 80 >> 2] = i8;
 i8 = (i8 | 0) == 0 ? -2147483644 : 1073741824;
 return i8 | 0;
}

function _unity_z_tr_stored_block(i6, i1, i2, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = i6 + 5820 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 5816 | 0;
 i3 = HEAPU16[i8 >> 1] | 0 | i4 << i5;
 HEAP16[i8 >> 1] = i3;
 if ((i5 | 0) > 13) {
  i10 = i6 + 20 | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i5 + 1;
  i9 = i6 + 8 | 0;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i5 >> 0] = i3;
  i3 = (HEAPU16[i8 >> 1] | 0) >>> 8 & 255;
  i5 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 >> 2] = i5 + 1;
  HEAP8[(HEAP32[i9 >> 2] | 0) + i5 >> 0] = i3;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = (i4 & 65535) >>> (16 - i5 | 0);
  HEAP16[i8 >> 1] = i3;
  i5 = i5 + -13 | 0;
 } else i5 = i5 + 3 | 0;
 i3 = i3 & 255;
 HEAP32[i7 >> 2] = i5;
 do if ((i5 | 0) > 8) {
  i4 = i6 + 20 | 0;
  i9 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i9 + 1;
  i10 = i6 + 8 | 0;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i9 >> 0] = i3;
  i9 = (HEAPU16[i8 >> 1] | 0) >>> 8 & 255;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 + 1;
  HEAP8[(HEAP32[i10 >> 2] | 0) + i3 >> 0] = i9;
  i3 = i10;
 } else {
  i4 = i6 + 20 | 0;
  if ((i5 | 0) > 0) {
   i9 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i9 + 1;
   i10 = i6 + 8 | 0;
   HEAP8[(HEAP32[i10 >> 2] | 0) + i9 >> 0] = i3;
   i3 = i10;
   break;
  } else {
   i3 = i6 + 8 | 0;
   break;
  }
 } while (0);
 HEAP16[i8 >> 1] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 5812 >> 2] = 8;
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i9 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i9 >> 0] = i2;
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i9 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i9 >> 0] = i2 >>> 8;
 i9 = i2 & 65535 ^ 65535;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i9;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i10 + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i9 >>> 8;
 if (!i2) return;
 while (1) {
  i2 = i2 + -1 | 0;
  i9 = HEAP8[i1 >> 0] | 0;
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i10 + 1;
  HEAP8[(HEAP32[i3 >> 2] | 0) + i10 >> 0] = i9;
  if (!i2) break; else i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 + 8 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = HEAP32[gb + 62512 >> 2];
  HEAP32[i2 + 48 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
  HEAP32[i2 + 52 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 68 >> 2] = 0;
  HEAP32[i2 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i6 = i4;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 60 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i2 + 76 >> 2] = 0;
  HEAP32[i2 + 88 >> 2] = 0;
  HEAP32[i2 + 92 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i2 + 80 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i2 + 96 >> 2] = 0;
  HEAP32[i2 + 108 >> 2] = 0;
  HEAP32[i2 + 112 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i6 = i4;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 100 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i2 + 116 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i2 + 120 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAPF32[i2 + 136 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 140 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 144 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 148 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
  i2 = (HEAP32[i3 >> 2] | 0) + 156 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZN7Terrain11RemoveTreesERK8Vector2ffi(i7, i8, f9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i2 = i12;
 i4 = i7 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i11, i1, i2);
   i2 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i12;
   return;
  }
 }
 if (!(__ZN12TreeDatabase11RemoveTreesERK8Vector2ffi(i1 + 84 | 0, i8, f9, i10) | 0)) {
  STACKTOP = i12;
  return;
 }
 i6 = i7 + 228 | 0;
 i2 = i7 + 240 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i3 = i8 + 4 | 0;
 i4 = i11 + 4 | 0;
 i5 = i11 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i13 = HEAP32[i3 >> 2] | 0;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 >> 2] = i13;
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  __ZN12TreeRenderer11RemoveTreesERK8Vector3ffi(i7, i11, f9, i10);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
 STACKTOP = i12;
 return;
}

function __ZN11Rigidbody2D18AddForceAtPositionERK8Vector2fS2_NS_9ForceModeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0;
 i9 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i9) return;
 if (HEAP32[i1 + 68 >> 2] | 0) return;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i1 = (HEAP32[i9 >> 2] | 0) == 2;
 if (!i4) {
  if (!i1) return;
  i2 = i9 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i9 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  i4 = i9 + 76 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i4 >> 2]));
  i4 = i9 + 80 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i4 >> 2]));
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i9 + 44 >> 2]));
  f8 = Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * Math_fround(f5 - Math_fround(HEAPF32[i9 + 48 >> 2]))));
  i9 = i9 + 84 | 0;
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f8);
  return;
 } else {
  if (!i1) return;
  i2 = i9 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i9 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  f10 = Math_fround(HEAPF32[i9 + 120 >> 2]);
  f11 = Math_fround(f8 * f10);
  f10 = Math_fround(f6 * f10);
  i4 = i9 + 64 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i4 >> 2]));
  i4 = i9 + 68 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i4 >> 2]));
  f10 = Math_fround(HEAPF32[i9 + 128 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i9 + 44 >> 2]));
  f8 = Math_fround(f10 * Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * Math_fround(f5 - Math_fround(HEAPF32[i9 + 48 >> 2])))));
  i9 = i9 + 72 | 0;
  HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f8);
  return;
 }
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, i1);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN8GUIStyle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
  i1 = i1 + 296 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 803306 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 803319 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function _tlsf_realloc_align(i14, i15, i5, i7) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = (i15 | 0) != 0;
 if (i1 & (i7 | 0) == 0) {
  _tlsf_free(i14, i15);
  i15 = 0;
  return i15 | 0;
 }
 if (!i1) {
  i15 = _tlsf_memalign(i14, i5, i7) | 0;
  return i15 | 0;
 }
 i13 = i15 + -8 | 0;
 i11 = i15 + -4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i15;
 i8 = (i1 + -4 & -4) + i12 | 0;
 i4 = i1 & -4;
 i9 = i8 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 3 & -4;
 i10 = (i7 + -1 | 0) >>> 0 < 1073741823 ? (i10 >>> 0 > 12 ? i10 : 12) : 0;
 i2 = i10 >>> 0 > i4 >>> 0;
 if (i2) {
  if (!((i3 & 1 | 0) == 0 ? 1 : i10 >>> 0 > (i4 + 4 + (i3 & -4) | 0) >>> 0)) i6 = 7;
 } else i6 = 7;
 if ((i6 | 0) == 7) if ((i5 + -1 + i12 & 0 - i5 | 0) == (i15 | 0)) {
  if (i2) {
   if (i3 & 1) {
    i1 = i3 & -4;
    if (i1 >>> 0 < 128) {
     i1 = i3 >>> 2;
     i4 = 0;
    } else {
     i4 = 31 - (Math_clz32(i1 | 0) | 0) | 0;
     i1 = i1 >>> (i4 + -5 | 0) ^ 32;
     i4 = i4 + -6 | 0;
    }
    i3 = HEAP32[i8 + 12 >> 2] | 0;
    i2 = HEAP32[i8 + 8 >> 2] | 0;
    HEAP32[i2 + 12 >> 2] = i3;
    HEAP32[i3 + 8 >> 2] = i2;
    i3 = i14 + 116 + (i4 << 7) + (i1 << 2) | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i8 | 0)) {
     HEAP32[i3 >> 2] = i2;
     if ((i2 | 0) == (i14 | 0)) {
      i7 = i14 + 20 + (i4 << 2) | 0;
      i8 = HEAP32[i7 >> 2] & ~(1 << i1);
      HEAP32[i7 >> 2] = i8;
      i1 = i14 + 16 | 0;
      if (!i8) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i4);
     }
    }
    i1 = ((HEAP32[i9 >> 2] | 0) + 4 & -4) + (HEAP32[i11 >> 2] | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[(i1 + -4 & -4) + i12 >> 2] = i13;
   }
   i12 = (i1 + -4 & -4) + i12 + 4 | 0;
   HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -3;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -2;
  }
  _block_trim_used(i14, i13, i10);
  return i15 | 0;
 }
 i1 = _tlsf_memalign(i14, i5, i7) | 0;
 if (!i1) {
  i15 = 0;
  return i15 | 0;
 }
 _memcpy(i1 | 0, i15 | 0, (i4 >>> 0 < i7 >>> 0 ? i4 : i7) | 0) | 0;
 _tlsf_free(i14, i15);
 i15 = i1;
 return i15 | 0;
}

function __ZN5physx2Sc10NPhaseCore13findActorPairEPNS0_8ShapeSimES3_(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[(HEAP32[i8 + 8 >> 2] | 0) + 28 >> 2] | 0) >>> 0 < (HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 28 >> 2] | 0) >>> 0) {
  i6 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i8) | 0;
  i7 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i9) | 0;
 } else {
  i6 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i9) | 0;
  i7 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i8) | 0;
 }
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 i5 = i1 + (i4 << 2) | 0;
 L5 : do if ((i4 | 0) > 0) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   if ((i3 | 0) == (i6 | 0)) if ((HEAP32[i1 + 8 >> 2] | 0) == (i7 | 0)) i4 = 10; else i4 = 8; else i4 = 8;
   if ((i4 | 0) == 8) {
    i4 = 0;
    if ((i3 | 0) == (i7 | 0)) if ((HEAP32[i1 + 8 >> 2] | 0) == (i6 | 0)) i4 = 10;
   }
   if ((i4 | 0) == 10) if (HEAP8[i1 + 21 >> 0] & 16) break;
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i5 >>> 0) break L5;
  }
  i1 = HEAP32[i1 + -8 + 48 >> 2] | 0;
  if (i1 | 0) {
   i10 = i1;
   return i10 | 0;
  }
 } while (0);
 i4 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i8) | 0;
 i2 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i9) | 0;
 i3 = i10 + 436 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i10 + 144 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i9 = i10 + 424 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i10 = i10 + 428 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 if (!i1) {
  i10 = 0;
  return i10 | 0;
 }
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = __ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0;
 HEAP16[i1 + 12 >> 1] = 0;
 HEAP16[i1 + 14 >> 1] = 0;
 HEAP16[i1 + 16 >> 1] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i10 = i4 + 46 | 0;
 HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + 1 << 16 >> 16;
 i10 = i2 + 46 | 0;
 HEAP16[i10 >> 1] = (HEAP16[i10 >> 1] | 0) + 1 << 16 >> 16;
 i10 = i1;
 return i10 | 0;
}

function __ZN20IntermediateRenderer27GetWritableSharedPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 i1 = i1 + 256 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 375269 | 0, 92) | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 33952 + 8;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i6 = i3;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i2 + 36 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i6 = i3;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i2 + 56 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i4);
 i4 = i3;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2 + 76 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 i6 = gb + 63536 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP8[i2 + 108 >> 0] = 1;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i2;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z30AudioMixer_CUSTOM_FindSnapshotP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i3 = i9 + 12 | 0;
 i7 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK11ICallString6ToUTF8Ev(i7, i3);
 i4 = __ZN10AudioMixer20FindSnapshotFromNameEPKc(i1, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 if (!i4) {
  i8 = 0;
  i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 12;
  }
 }
 if ((i8 | 0) == 10) i8 = 12;
 if ((i8 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i8 = i1;
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return i8 | 0;
}

function _wcsrtombs(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 L1 : do if (!i3) {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 0; else {
   i3 = i1;
   i1 = 0;
   do {
    if (i2 >>> 0 > 127) {
     i2 = _wcrtomb(i7, i2, 0) | 0;
     if ((i2 | 0) == -1) {
      i1 = -1;
      break L1;
     }
    } else i2 = 1;
    i1 = i2 + i1 | 0;
    i3 = i3 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != 0);
  }
 } else {
  L9 : do if (i1 >>> 0 > 3) {
   i2 = i1;
   i4 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 + -1 | 0) >>> 0 > 126) {
     if (!i5) break;
     i5 = _wcrtomb(i3, i5, 0) | 0;
     if ((i5 | 0) == -1) {
      i1 = -1;
      break L1;
     }
     i3 = i3 + i5 | 0;
     i2 = i2 - i5 | 0;
    } else {
     HEAP8[i3 >> 0] = i5;
     i3 = i3 + 1 | 0;
     i2 = i2 + -1 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
    HEAP32[i6 >> 2] = i4;
    if (i2 >>> 0 <= 3) break L9;
   }
   HEAP8[i3 >> 0] = 0;
   HEAP32[i6 >> 2] = 0;
   i1 = i1 - i2 | 0;
   break L1;
  } else i2 = i1; while (0);
  if (i2) {
   i4 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 + -1 | 0) >>> 0 > 126) {
     if (!i5) {
      i4 = 19;
      break;
     }
     i5 = _wcrtomb(i7, i5, 0) | 0;
     if ((i5 | 0) == -1) {
      i1 = -1;
      break L1;
     }
     if (i2 >>> 0 < i5 >>> 0) {
      i4 = 22;
      break;
     }
     _wcrtomb(i3, HEAP32[i4 >> 2] | 0, 0) | 0;
     i3 = i3 + i5 | 0;
     i2 = i2 - i5 | 0;
    } else {
     HEAP8[i3 >> 0] = i5;
     i3 = i3 + 1 | 0;
     i2 = i2 + -1 | 0;
     i4 = HEAP32[i6 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
    HEAP32[i6 >> 2] = i4;
    if (!i2) break L1;
   }
   if ((i4 | 0) == 19) {
    HEAP8[i3 >> 0] = 0;
    HEAP32[i6 >> 2] = 0;
    i1 = i1 - i2 | 0;
    break;
   } else if ((i4 | 0) == 22) {
    i1 = i1 - i2 | 0;
    break;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx2Gu25PersistentContactManifold14getWorldNormalERKNS_6shdfnd3aos12PsTransformVE(i7, i3, i8) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var f1 = f0, f2 = f0, f4 = f0, i5 = 0, i6 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i6 = HEAP32[i3 + 44 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i6 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 i3 = HEAP8[i3 + 32 >> 0] | 0;
 if ((i3 & 255) > 1) {
  i5 = i3 & 255;
  i3 = 1;
  do {
   f10 = Math_fround(HEAPF32[i6 + (i3 * 48 | 0) + 32 >> 2]);
   f9 = Math_fround(HEAPF32[i6 + (i3 * 48 | 0) + 36 >> 2]);
   f1 = Math_fround(f1 + f10);
   f2 = Math_fround(f2 + f9);
   f4 = Math_fround(f4 + Math_fround(HEAPF32[i6 + (i3 * 48 | 0) + 40 >> 2]));
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i5 >>> 0);
 }
 f13 = Math_fround(HEAPF32[i8 >> 2]);
 f12 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i8 + 12 >> 2]);
 f10 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f15 = Math_fround(Math_fround(Math_fround(f1 * f13) + Math_fround(f2 * f12)) + Math_fround(f4 * f16));
 f11 = Math_fround(Math_fround(Math_fround(f13 * f15) + Math_fround(Math_fround(f14 * Math_fround(Math_fround(f4 * f12) - Math_fround(f2 * f16))) + Math_fround(f1 * f10))) * Math_fround(2.0));
 f9 = Math_fround(Math_fround(Math_fround(f12 * f15) + Math_fround(Math_fround(f14 * Math_fround(Math_fround(f1 * f16) - Math_fround(f4 * f13))) + Math_fround(f2 * f10))) * Math_fround(2.0));
 f10 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(Math_fround(f14 * Math_fround(Math_fround(f2 * f13) - Math_fround(f1 * f12))) + Math_fround(f4 * f10))) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9))))));
 f9 = Math_fround(f4 * f9);
 f10 = Math_fround(f4 * f10);
 HEAPF32[i7 >> 2] = Math_fround(f4 * f11);
 HEAPF32[i7 + 4 >> 2] = f9;
 HEAPF32[i7 + 8 >> 2] = f10;
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE4findIS2_EENS3_11__wrap_iterIPS2_EERKT_(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0;
 i2 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 - i2 | 0;
 if (!i1) i1 = i2; else {
  i8 = HEAP32[i14 >> 2] | 0;
  i9 = i14 + 40 | 0;
  i10 = i14 + 44 | 0;
  i11 = i14 + 48 | 0;
  i7 = (i1 | 0) / 60 | 0;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i7 | 0) / 2 | 0;
   i6 = i3 + (i2 * 60 | 0) | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   do if ((i4 | 0) == (i8 | 0)) {
    i4 = HEAP32[i3 + (i2 * 60 | 0) + 40 >> 2] | 0;
    i5 = HEAP32[i9 >> 2] | 0;
    if ((i4 | 0) != (i5 | 0)) if ((i4 | 0) < (i5 | 0)) {
     i12 = 11;
     break;
    } else break;
    i4 = HEAP32[i3 + (i2 * 60 | 0) + 44 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
    if ((i4 | 0) == (i5 | 0)) {
     f15 = Math_fround(HEAPF32[i3 + (i2 * 60 | 0) + 48 >> 2]);
     if (f15 < Math_fround(HEAPF32[i11 >> 2])) {
      i12 = 11;
      break;
     } else break;
    } else if (i5 >>> 0 < i4 >>> 0) {
     i12 = 11;
     break;
    } else break;
   } else if (i4 >>> 0 < i8 >>> 0) i12 = 11; while (0);
   if ((i12 | 0) == 11) {
    i12 = 0;
    i3 = i6 + 60 | 0;
    i2 = i7 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i7 = i2;
  }
 }
 do if ((i1 | 0) != (i13 | 0)) {
  i2 = HEAP32[i14 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   if (i2 >>> 0 < i3 >>> 0) break;
   return i1 | 0;
  }
  i2 = HEAP32[i14 + 40 >> 2] | 0;
  i3 = HEAP32[i1 + 40 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   if ((i2 | 0) < (i3 | 0)) break;
   return i1 | 0;
  }
  i2 = HEAP32[i14 + 44 >> 2] | 0;
  i3 = HEAP32[i1 + 44 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   f15 = Math_fround(HEAPF32[i14 + 48 >> 2]);
   if (f15 < Math_fround(HEAPF32[i1 + 48 >> 2])) break;
   return i1 | 0;
  } else {
   if (i3 >>> 0 < i2 >>> 0) break;
   return i1 | 0;
  }
 } while (0);
 i14 = i13;
 return i14 | 0;
}

function __ZN10StateRange8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 902678 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 912455 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE4findIS1_EENS_15__tree_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i1 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 do if (i3 | 0) {
  i7 = HEAP32[i2 + 16 >> 2] | 0;
  i8 = HEAP32[i2 + 12 >> 2] | 0;
  i10 = HEAP8[i2 + 11 >> 0] | 0;
  i9 = i10 << 24 >> 24 < 0;
  i10 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
  i9 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i11;
  L3 : while (1) {
   i2 = i3;
   L5 : while (1) {
    i6 = i2 + 16 | 0;
    i3 = HEAP32[i2 + 32 >> 2] | 0;
    do if ((i3 | 0) == (i7 | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     if ((i3 | 0) != (i8 | 0)) if ((i3 | 0) < (i8 | 0)) break; else break L5;
     i5 = HEAP8[i6 + 11 >> 0] | 0;
     i4 = i5 << 24 >> 24 < 0;
     i5 = i4 ? HEAP32[i2 + 20 >> 2] | 0 : i5 & 255;
     i3 = i10 >>> 0 < i5 >>> 0 ? i10 : i5;
     if (i3 | 0) {
      i3 = _memcmp(i4 ? HEAP32[i6 >> 2] | 0 : i6, i9, i3) | 0;
      if (i3 | 0) if ((i3 | 0) < 0) break; else break L5;
     }
     if (i5 >>> 0 >= i10 >>> 0) break L5;
    } else if ((i3 | 0) >= (i7 | 0)) break L5; while (0);
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i11 | 0)) {
   i5 = i1 + 16 | 0;
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   if ((i7 | 0) != (i2 | 0)) {
    if ((i7 | 0) < (i2 | 0)) break;
    return i1 | 0;
   }
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if ((i8 | 0) != (i2 | 0)) {
    if ((i8 | 0) < (i2 | 0)) break;
    return i1 | 0;
   }
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i4 = i3 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255;
   i2 = i4 >>> 0 < i10 >>> 0 ? i4 : i10;
   if (i2 | 0) {
    i2 = _memcmp(i9, i3 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i10 >>> 0 >= i4 >>> 0) {
    i11 = i1;
    return i11 | 0;
   }
  }
 } while (0);
 return i11 | 0;
}

function __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1085989 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i7 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 6; else {
     HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i7 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i4 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1085998 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i6 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i6 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i6 >>> 0) i7 = 17; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i7 = 17; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i7 | 0) == 17) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i12, i11, i10, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 if (!i10) {
  i12 = 1;
  return i12 | 0;
 } else {
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i9 = 0;
 }
 do {
  f7 = Math_fround(HEAPF32[i8 + (i9 << 6) + 12 >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i9 << 6) >> 2]);
  f13 = Math_fround(HEAPF32[i8 + (i9 << 6) + 4 >> 2]);
  f14 = Math_fround(f7 * f14);
  f13 = Math_fround(f7 * f13);
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i8 + (i9 << 6) + 8 >> 2]));
  f4 = f4 < f14 ? f4 : f14;
  f5 = f5 < f13 ? f5 : f13;
  f6 = f6 < f7 ? f6 : f7;
  f1 = f1 > f14 ? f1 : f14;
  f2 = f2 > f13 ? f2 : f13;
  f3 = f3 > f7 ? f3 : f7;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i10 | 0));
 i17 = f4 == Math_fround(0.0);
 i15 = f5 == Math_fround(0.0);
 i9 = f6 == Math_fround(0.0);
 i16 = f1 == Math_fround(0.0);
 i8 = f2 == Math_fround(0.0);
 i10 = f3 == Math_fround(0.0);
 f7 = Math_fround(Math_fround((i17 ? f1 : f4) + (i16 ? f4 : f1)) * Math_fround(.5));
 f4 = Math_fround(Math_fround((i15 ? f2 : f5) + (i8 ? f5 : f2)) * Math_fround(.5));
 f1 = Math_fround(Math_fround((i9 ? f3 : f6) + (i10 ? f6 : f3)) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f4 * f4) + Math_fround(f7 * f7)));
 if (f2 < Math_fround(1.00000001e-10)) {
  i17 = 0;
  return i17 | 0;
 }
 f5 = Math_fround(Math_sqrt(Math_fround(f2)));
 if (f2 > Math_fround(0.0)) {
  f14 = Math_fround(Math_fround(1.0) / f5);
  f3 = Math_fround(f1 * f14);
  f2 = Math_fround(f4 * f14);
  f1 = Math_fround(f7 * f14);
 } else {
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f13 = Math_fround(-f2);
 f14 = Math_fround(-f3);
 HEAPF32[i12 >> 2] = Math_fround(-f1);
 HEAPF32[i12 + 4 >> 2] = f13;
 HEAPF32[i12 + 8 >> 2] = f14;
 HEAPF32[i11 >> 2] = f5;
 i17 = 1;
 return i17 | 0;
}

function _tgamma(d8) {
 d8 = +d8;
 var d1 = 0.0, i2 = 0, d3 = 0.0, i4 = 0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d9 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d8;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = i2 & 2147483647;
 i2 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, i2 | 0, 63) | 0;
 getTempRet0() | 0;
 do if (i4 >>> 0 > 2146435071) d1 = d8 + inf; else {
  if (i4 >>> 0 < 1016070144) {
   d1 = 1.0 / d8;
   break;
  }
  d1 = +Math_floor(+d8);
  if (d1 == d8) {
   if (i2 | 0) {
    d1 = nan;
    break;
   }
   if (d8 <= 23.0) {
    d1 = +HEAPF64[gb + 10232 + (~~d8 + -1 << 3) >> 3];
    break;
   }
  }
  i2 = (i2 | 0) != 0;
  if (i4 >>> 0 > 1080492031) if (i2) {
   i4 = d1 * .5 == +Math_floor(+(d8 * .5));
   d1 = i4 ? 0.0 : -0.0;
   break;
  } else {
   d1 = d8 * 8988465674311579538646525.0e283;
   break;
  }
  d7 = i2 ? -d8 : d8;
  d9 = d7 + 5.52468004077673;
  d1 = d7 > 5.52468004077673 ? d9 - d7 + -5.52468004077673 : d9 + -5.52468004077673 - d7;
  d3 = d7 + -.5;
  if (d7 < 8.0) {
   d6 = 0.0;
   d5 = 0.0;
   i2 = 12;
   while (1) {
    d5 = d7 * d5 + +HEAPF64[gb + 10416 + (i2 << 3) >> 3];
    d6 = d7 * d6 + +HEAPF64[gb + 10520 + (i2 << 3) >> 3];
    if ((i2 | 0) > 0) i2 = i2 + -1 | 0; else break;
   }
  } else {
   d6 = 0.0;
   d5 = 0.0;
   i2 = 0;
   do {
    d5 = d5 / d7 + +HEAPF64[gb + 10416 + (i2 << 3) >> 3];
    d6 = d6 / d7 + +HEAPF64[gb + 10520 + (i2 << 3) >> 3];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 13);
  }
  d6 = d5 / d6 * +Math_exp(+-d9);
  if (d8 < 0.0) {
   d5 = d7 * .5;
   d5 = (d5 - +Math_floor(+d5)) * 2.0;
   i4 = (~~(d5 * 4.0) + 1 | 0) / 2 | 0;
   d5 = (d5 - +(i4 | 0) * .5) * 3.141592653589793;
   switch (i4 | 0) {
   case 3:
    {
     d5 = -+___cos(d5, 0.0);
     break;
    }
   case 1:
    {
     d5 = +___cos(d5, 0.0);
     break;
    }
   case 2:
    {
     d5 = +___sin(-d5, 0.0, 0);
     break;
    }
   default:
    d5 = +___sin(d5, 0.0, 0);
   }
   d5 = -3.141592653589793 / (d6 * (d7 * d5));
   d3 = -d3;
   d1 = -d1;
  } else d5 = d6;
  d8 = +Math_pow(+d9, +(d3 * .5));
  d1 = d8 * (d8 * (d5 + d1 * 6.02468004077673 * d5 / d9));
 } while (0);
 return +d1;
}

function __ZN8JSONRead14GetDataVersionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i2 + 56 | 0;
 i11 = i2 + 44 | 0;
 i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) + -1 << 3) >> 2] | 0;
 if ((i1 | 0) != -1) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i4 = i2 + 64 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9 + 4 | 0;
 i7 = i2 + 164 | 0;
 i8 = i2 + 152 | 0;
 i3 = HEAP32[i2 + 76 >> 2] | 0;
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 L4 : while (1) {
  do if (i2 | 0) {
   i1 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i1 & 255 | 0) == 3) {
    HEAP32[i9 >> 2] = 0;
    HEAP32[i9 + 4 >> 2] = 0;
    HEAP32[i9 + 8 >> 2] = 0;
    HEAP32[i9 + 12 >> 2] = 0;
    HEAP32[i5 >> 2] = 1048581;
    HEAP32[i9 >> 2] = gb + 1034388;
    HEAP32[i6 >> 2] = 17;
    i1 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i2, i9) | 0;
    __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i9);
    if ((i1 | 0) == ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 48 | 0) | 0)) break; else {
     i1 = i1 + 24 | 0;
     i2 = 11;
     break L4;
    }
   }
   if ((i1 | 0) == 4) {
    i13 = (HEAP32[i8 >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) + -1 << 2) | 0;
    i1 = HEAP32[i13 >> 2] | 0;
    HEAP32[i13 >> 2] = i1 + 1;
    i1 = (HEAP32[i2 >> 2] | 0) + (i1 * 24 | 0) | 0;
    if (i1 | 0) {
     i2 = 11;
     break L4;
    }
   }
  } while (0);
  if ((i3 | 0) <= 0) {
   i2 = 10;
   break;
  }
  i3 = i3 + -1 | 0;
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if (!i2) {
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) {
  HEAP32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) + -1 << 3) >> 2] = 1;
  i13 = 1;
  STACKTOP = i12;
  return i13 | 0;
 } else if ((i2 | 0) == 11) {
  i13 = HEAP32[i1 >> 2] | 0;
  HEAP32[(HEAP32[i11 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) + -1 << 3) >> 2] = i13;
  STACKTOP = i12;
  return i13 | 0;
 }
 return 0;
}

function __ZN5physx2Sc27ConstraintProjectionManager10addToGroupERNS0_7BodySimEPS2_RNS0_13ConstraintSimE(i6, i4, i5, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i4 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i2 = i6 + 296 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i6 + 4 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i6 + 284 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = i6 + 288 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE(i1, i4);
  HEAP32[i3 >> 2] = i1;
  i4 = i1;
 } else {
  i1 = __ZN5physx2Sc19ConstraintGroupNode7getRootEv(i1) | 0;
  if (!(HEAP32[i1 + 20 >> 2] | 0)) i4 = i1; else {
   __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE(i1);
   i4 = i1;
  }
 }
 if (!i5) return;
 i3 = i5 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i2 = i6 + 296 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i6 + 4 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i6 + 284 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i6 = i6 + 288 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!i1) i1 = 0; else __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE(i1, i5);
  HEAP32[i3 >> 2] = i1;
 } else {
  i1 = __ZN5physx2Sc19ConstraintGroupNode7getRootEv(i1) | 0;
  if (HEAP32[i1 + 20 >> 2] | 0) __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE(i1);
 }
 if ((i4 | 0) == (i1 | 0)) return;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 12 >> 2] | 0) >>> 0 > i3 >>> 0) i2 = i4; else {
  HEAP32[i2 >> 2] = i3 + 1;
  i2 = i1;
  i1 = i4;
 }
 HEAP32[i1 + 4 >> 2] = i2;
 i6 = i2 + 8 | 0;
 HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx11NpAggregate8addActorERNS_7PxActorE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 28 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 122, gb + 682066 | 0, i4);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 128, gb + 682138 | 0, i4 + 8 | 0);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 134, gb + 682219 | 0, i4 + 16 | 0);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 140, gb + 682295 | 0, i4 + 24 | 0);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i2 + (HEAP32[gb + 1457020 + ((HEAPU16[i2 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, i3, i2);
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + 1;
 HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i5 << 2) >> 2] = i2;
 if ((((HEAP32[i3 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i5 = 1;
  STACKTOP = i4;
  return i5 | 0;
 }
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) {
  i5 = 1;
  STACKTOP = i4;
  return i5 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 if (!i1) {
  i5 = 1;
  STACKTOP = i4;
  return i5 | 0;
 }
 __ZN5physx11NpAggregate16addActorInternalERNS_7PxActorERNS_7NpSceneE(i3, i2, i1);
 i5 = 1;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf(i16, i2, f3) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i20 + 4 | 0;
 i19 = i20;
 HEAPF32[i19 >> 2] = f3;
 i9 = i16 + 2 | 0;
 i1 = HEAPU8[i9 >> 0] | 0;
 i6 = HEAPU8[i16 >> 0] | 0;
 i7 = HEAP8[i16 + 3 >> 0] | 0;
 i17 = i7 & 255;
 i8 = HEAP8[i16 + 1 >> 0] | 0;
 i10 = i8 & 255;
 i5 = i17 - i10 | 0;
 if (!(Math_imul(i5, i1 - i6 | 0) | 0)) {
  STACKTOP = i20;
  return;
 }
 i18 = i6 << 1;
 i15 = i1 << 1;
 HEAPF32[i4 >> 2] = f3;
 i14 = i2 + 8 | 0;
 i12 = Math_fround(HEAPF32[i14 >> 2]) >= f3;
 HEAP32[i14 >> 2] = HEAP32[(i12 ? i14 : i4) >> 2];
 i2 = (HEAP32[i2 + 4 >> 2] | 0) + (i10 << 10) | 0;
 i14 = i2 + (i5 << 10) | 0;
 i12 = i6 << 7;
 i13 = i15 - i18 + -1 | 0;
 if ((i7 & 255) <= (i8 & 255)) {
  STACKTOP = i20;
  return;
 }
 i11 = HEAP32[i16 + 4 >> 2] | 0;
 i9 = HEAPU8[i9 >> 0] | 0;
 if (i15 >>> 0 <= i18 >>> 0) {
  STACKTOP = i20;
  return;
 }
 i1 = i2 + i12 | 0;
 i4 = i13;
 do {
  i8 = i18;
  i7 = i4;
  while (1) {
   i5 = HEAP16[i16 >> 1] | 0;
   i6 = i5 & 255;
   i5 = HEAPU16[i11 + (i8 - (i6 << 1) + (Math_imul(i9 - i6 << 1, i10 - ((i5 & 65535) >>> 8 & 65535) | 0) | 0) << 1) >> 1] | 0;
   i6 = i1;
   i4 = 0;
   do {
    if (1 << i4 & i5 | 0) {
     i21 = i6 + (i4 << 2) | 0;
     f3 = Math_fround(HEAPF32[i21 >> 2]);
     i22 = f3 >= Math_fround(HEAPF32[i19 >> 2]);
     HEAP32[i21 >> 2] = HEAP32[(i22 ? i21 : i19) >> 2];
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != 16);
   if (!i7) {
    i2 = i2 + 1024 | 0;
    i4 = i2 >>> 0 < i14 >>> 0;
    i1 = i4 ? i2 + i12 | 0 : i1;
    i4 = i4 ? i13 : 0;
   } else {
    i1 = i1 + 64 | 0;
    i4 = i7 + -1 | 0;
   }
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i15 | 0)) break; else i7 = i4;
  }
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) != (i17 | 0));
 STACKTOP = i20;
 return;
}

function __ZN5Umbra12QueryContextD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i5 + 32 >> 2] & 1024 | 0) {
  i4 = i5 + 60 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) > -1) {
   mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, gb + 612648 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, gb + 612662 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, gb + 612680 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, gb + 612702 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, gb + 612718 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i2 | 0) > -1) {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, gb + 612732 | 0, i2 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i1 = HEAP32[i1 + 44 >> 2] | 0;
  if ((i1 | 0) > -1) {
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, gb + 612751 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i5 + 60 >> 2] | 0;
 if (i1 | 0) HEAP32[i5 + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i5 + 36 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 40 >> 2];
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if (!i1) return;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN14FileCacherReadC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjj(i6, i2, i3, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i6 >> 2] = gb + 67232 + 8;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = -1;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = -1;
 HEAP32[i6 + 44 >> 2] = 0;
 i7 = i6 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = 3;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP8[i6 + 84 >> 0] = 0;
 HEAP32[i6 + 80 >> 2] = 0;
 i7 = i6 + 88 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i6 + 112 >> 2] = 3;
 HEAP32[i6 + 116 >> 2] = 0;
 HEAP8[i6 + 124 >> 0] = 0;
 HEAP32[i6 + 120 >> 2] = 0;
 i7 = i6 + 128 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i6 + 152 >> 2] = 3;
 HEAP32[i6 + 156 >> 2] = 0;
 HEAP8[i6 + 164 >> 0] = 0;
 HEAP32[i6 + 160 >> 2] = 0;
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN15FileSystemEntryC2EPKc(i4, i1);
 i7 = __ZNK15FileSystemEntry4SizeEv(i4) | 0;
 getTempRet0() | 0;
 HEAP32[i6 + 8 >> 2] = i7;
 HEAP32[i6 + 24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 16, gb + 63552 | 0, 0, gb + 468446 | 0, 30) | 0;
 HEAP32[i6 + 28 >> 2] = -1;
 HEAP32[i6 + 36 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 16, gb + 63552 | 0, 0, gb + 468446 | 0, 30) | 0;
 HEAP32[i6 + 40 >> 2] = -1;
 __ZN13FileEntryDataD2Ev(i4);
 STACKTOP = i5;
 return;
}

function __Z10SetGlobalT15TransformAccessRKN4math7_float3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 24 | 0;
 i5 = i10 + 8 | 0;
 i3 = i10;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  i9 = i1;
  i1 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
 } else {
  i9 = i1;
  i1 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  i8 = i3;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E(i4, i5);
 }
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = i7 + (i9 * 40 | 0) | 0;
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i7 + (i9 * 40 | 0) + 4 | 0;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + (i9 * 40 | 0) + 8 | 0;
 i8 = f13 != f15 | f12 != f14 | f11 != Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i7 >> 2] = f11;
 if (!i8) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i9 << 2) >> 2] | 0;
 if (!i5) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 i7 = HEAP32[i1 + 56 >> 2] | 0;
 i8 = i1 + 36 | 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i2 = 0;
 i1 = i9;
 while (1) {
  i9 = HEAP32[i6 + (i1 << 2) >> 2] & i4;
  i16 = i7 + (i1 << 2) | 0;
  HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | i9;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i9;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i5 | 0)) {
   i1 = 1;
   break;
  } else i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 }
 STACKTOP = i10;
 return i1 | 0;
}

function ___fdopen(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 40 | 0;
 i8 = i12 + 24 | 0;
 i7 = i12 + 16 | 0;
 i4 = i12;
 i10 = i12 + 52 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 if (!(_memchr(gb + 1074696 | 0, i2 << 24 >> 24, 4) | 0)) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 } else {
  i1 = _malloc(1144) | 0;
  if (!i1) i1 = 0; else {
   i5 = i1;
   i6 = i5 + 112 | 0;
   do {
    HEAP32[i5 >> 2] = 0;
    i5 = i5 + 4 | 0;
   } while ((i5 | 0) < (i6 | 0));
   if (!(_strchr(i3, 43) | 0)) HEAP32[i1 >> 2] = i2 << 24 >> 24 == 114 ? 8 : 4;
   if (_strchr(i3, 101) | 0) {
    HEAP32[i4 >> 2] = i9;
    HEAP32[i4 + 4 >> 2] = 2;
    HEAP32[i4 + 8 >> 2] = 1;
    ___syscall221(221, i4 | 0) | 0;
    i2 = HEAP8[i3 >> 0] | 0;
   }
   if (i2 << 24 >> 24 == 97) {
    HEAP32[i7 >> 2] = i9;
    HEAP32[i7 + 4 >> 2] = 3;
    i2 = ___syscall221(221, i7 | 0) | 0;
    if (!(i2 & 1024)) {
     HEAP32[i8 >> 2] = i9;
     HEAP32[i8 + 4 >> 2] = 4;
     HEAP32[i8 + 8 >> 2] = i2 | 1024;
     ___syscall221(221, i8 | 0) | 0;
    }
    i3 = HEAP32[i1 >> 2] | 128;
    HEAP32[i1 >> 2] = i3;
   } else i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 + 60 >> 2] = i9;
   HEAP32[i1 + 44 >> 2] = i1 + 120;
   HEAP32[i1 + 48 >> 2] = 1024;
   i2 = i1 + 75 | 0;
   HEAP8[i2 >> 0] = -1;
   if (!(i3 & 8)) {
    HEAP32[i11 >> 2] = i9;
    HEAP32[i11 + 4 >> 2] = 21505;
    HEAP32[i11 + 8 >> 2] = i10;
    if (!(___syscall54(54, i11 | 0) | 0)) HEAP8[i2 >> 0] = 10;
   }
   HEAP32[i1 + 32 >> 2] = fb + 297;
   HEAP32[i1 + 36 >> 2] = fb + 295;
   HEAP32[i1 + 40 >> 2] = fb + 296;
   HEAP32[i1 + 12 >> 2] = fb + 1404;
   if (!(HEAP32[gb + 1469464 + 4 >> 2] | 0)) HEAP32[i1 + 76 >> 2] = -1;
   ___lock(gb + 1469464 + 28 | 0);
   i2 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
   HEAP32[i1 + 56 >> 2] = i2;
   if (i2 | 0) HEAP32[i2 + 52 >> 2] = i1;
   HEAP32[gb + 1469464 + 24 >> 2] = i1;
   ___unlock(gb + 1469464 + 28 | 0);
  }
 }
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 1104 >> 2]);
 f6 = Math_fround(f6 * f5);
 i4 = f6 < Math_fround(1.0);
 f6 = Math_fround(Math_fround(1.0) - f6);
 HEAPF32[i3 + 636 >> 2] = i4 ? f6 : Math_fround(0.0);
 HEAP32[i3 + 624 >> 2] = HEAP32[i3 + 1112 >> 2];
 HEAP32[i3 + 628 >> 2] = HEAP32[i3 + 1116 >> 2];
 HEAP32[i3 + 632 >> 2] = HEAP32[i3 + 1120 >> 2];
 HEAP32[i3 + 696 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i3 + 700 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i3 + 704 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i3 + 708 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAPF32[i3 + 688 >> 2] = f5;
 i4 = f5 > Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f5);
 HEAPF32[i3 + 692 >> 2] = i4 ? f5 : Math_fround(0.0);
 f5 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 i4 = f5 < Math_fround(0.0);
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = f5 > Math_fround(.949999988);
 HEAPF32[i3 + 640 >> 2] = i4 ? Math_fround(.949999988) : f5;
 f5 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 i4 = f5 < Math_fround(.00100000005);
 f5 = i4 ? Math_fround(.00100000005) : f5;
 i4 = f5 > Math_fround(1.0);
 HEAPF32[i3 + 644 >> 2] = i4 ? Math_fround(1.0) : f5;
 f5 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 HEAPF32[i3 + 648 >> 2] = Math_fround(f5 * f5);
 i4 = HEAP32[i1 + 84 >> 2] | 0;
 HEAP32[i3 + 716 >> 2] = (Math_imul(Math_imul(i4, 4999879) | 0, i4) | 0) & 65535;
 HEAP32[i3 + 712 >> 2] = HEAP32[i1 + 20 >> 2];
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i1 + 24 >> 2] = 2122317823;
 HEAP32[i1 + 28 >> 2] = 2122317823;
 HEAP32[i1 + 32 >> 2] = 2122317823;
 HEAP32[i1 + 36 >> 2] = -25165825;
 HEAP32[i1 + 40 >> 2] = -25165825;
 HEAP32[i1 + 44 >> 2] = -25165825;
 i1 = i3 + 624 | 0;
 __ZN5physx17PxsFluidCollision15updateCollisionEPKhRNS_10PxBaseTaskE(i1, HEAP32[i3 + 1304 >> 2] | 0, i2);
 __ZN5physx17PxsFluidCollision23updateOverflowParticlesEv(i1);
 return;
}

function __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 24 | 0;
 i1 = i8 + 8 | 0;
 i4 = i8;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 i7 = i1 + 11 | 0;
 i5 = (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i6, i5, i2);
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i2);
 }
 i1 = i6 + 4 | 0;
 i7 = i3 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Unity14CharacterJoint19SetTwistLimitSpringERK20SoftJointLimitSpring(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i7 + 108 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i3 ? Math_fround(340282326000000008404918.0e15) : f1;
 i3 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i5 = f1 < Math_fround(0.0);
 i2 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i2 ? Math_fround(340282326000000008404918.0e15) : f1;
 i5 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i6 >> 2] = i3;
 i2 = i7 + 112 | 0;
 HEAP32[i2 >> 2] = i5;
 i5 = i7 + 32 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 152 >> 2] | 0, i8 | 0, i3 | 0);
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 >> 2];
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + 124 >> 2]);
 f1 = Math_fround(Math_fround(Math_fround(f10 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 i7 = f10 > Math_fround(0.0);
 f1 = i7 ? f1 : Math_fround(-1.0);
 if (f1 == Math_fround(-1.0)) {
  f1 = Math_fround(HEAPF32[i8 + 20 >> 2]);
  f1 = Math_fround(Math_fround(f1 - Math_fround(HEAPF32[i8 + 24 >> 2])) * Math_fround(.49000001));
  i7 = f1 > Math_fround(.100000001);
  f1 = i7 ? Math_fround(.100000001) : f1;
 }
 i7 = f4 > Math_fround(0.0);
 i6 = f1 < Math_fround(.200000003);
 f10 = i6 ? Math_fround(.200000003) : f1;
 HEAPF32[i8 + 16 >> 2] = i7 ? Math_fround(9.99999974e-06) : f10;
 i7 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0, i7 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __Z21SetupMonoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK8Vector3f(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i2 >> 2]));
 i11 = i6 + 4 | 0;
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 i12 = i2 + 4 | 0;
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i12 >> 2]));
 i10 = i6 + 8 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAPF32[i1 >> 2] = f8;
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAP32[i1 + 8 >> 2] = i7;
 i7 = i3 + 4 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 20 >> 2] = i13;
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 >> 2];
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i12 >> 2]));
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i2 >> 2]));
 i13 = HEAP32[i10 >> 2] | 0;
 HEAPF32[i1 + 24 >> 2] = f9;
 HEAPF32[i1 + 28 >> 2] = f8;
 HEAP32[i1 + 32 >> 2] = i13;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 44 >> 2] = i7;
 HEAP32[i1 + 36 >> 2] = HEAP32[i5 >> 2];
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i12 >> 2]));
 i7 = HEAP32[i10 >> 2] | 0;
 HEAPF32[i1 + 48 >> 2] = f8;
 HEAPF32[i1 + 52 >> 2] = f9;
 HEAP32[i1 + 56 >> 2] = i7;
 i7 = i4 + 4 | 0;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 68 >> 2] = i13;
 HEAP32[i1 + 60 >> 2] = HEAP32[i5 >> 2];
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i12 >> 2]));
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i2 >> 2]));
 i6 = HEAP32[i10 >> 2] | 0;
 HEAPF32[i1 + 72 >> 2] = f9;
 HEAPF32[i1 + 76 >> 2] = f8;
 HEAP32[i1 + 80 >> 2] = i6;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + 88 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 92 >> 2] = i6;
 HEAP32[i1 + 84 >> 2] = HEAP32[i5 >> 2];
 return;
}

function _csqrt(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var d1 = 0.0, d3 = 0.0, d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 d3 = +HEAPF64[i2 >> 3];
 d4 = +HEAPF64[i2 + 8 >> 3];
 do if (d3 == 0.0 & d4 == 0.0) {
  HEAPF64[i10 >> 3] = 0.0;
  HEAPF64[i10 + 8 >> 3] = d4;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d4;
  if ((HEAP32[tempDoublePtr >> 2] | 0) == 0 ? (HEAP32[tempDoublePtr + 4 >> 2] & 2147483647 | 0) == 2146435072 : 0) {
   HEAPF64[i10 >> 3] = inf;
   HEAPF64[i10 + 8 >> 3] = d4;
   break;
  }
  HEAPF64[tempDoublePtr >> 3] = d3;
  i2 = HEAP32[tempDoublePtr >> 2] | 0;
  i7 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i6 = i7 & 2147483647;
  if (i6 >>> 0 > 2146435072 | (i6 | 0) == 2146435072 & i2 >>> 0 > 0) {
   d5 = d4 - d4;
   HEAPF64[i10 >> 3] = d3;
   HEAPF64[i10 + 8 >> 3] = d5 / d5;
   break;
  }
  if ((i2 | 0) == 0 & (i6 | 0) == 2146435072) {
   d1 = d4 - d4;
   if ((i7 | 0) < 0) {
    d1 = +Math_abs(+d1);
    d5 = +_copysign(d3, d4);
    HEAPF64[i10 >> 3] = d1;
    HEAPF64[i10 + 8 >> 3] = d5;
    break;
   } else {
    d5 = +_copysign(d1, d4);
    HEAPF64[i10 >> 3] = d3;
    HEAPF64[i10 + 8 >> 3] = d5;
    break;
   }
  }
  if (!(+Math_abs(+d3) >= 7446288774449766337959726.0e283)) if (!(+Math_abs(+d4) >= 7446288774449766337959726.0e283)) i2 = 0; else i8 = 13; else i8 = 13;
  if ((i8 | 0) == 13) {
   d3 = d3 * .25;
   d4 = d4 * .25;
   i2 = 1;
  }
  d1 = +_hypot(d3, d4);
  if (!(d3 >= 0.0)) {
   d1 = +Math_sqrt(+((d1 - d3) * .5));
   d3 = +Math_abs(+d4) / (d1 * 2.0);
   d1 = +_copysign(d1, d4);
  } else {
   d1 = +Math_sqrt(+((d3 + d1) * .5));
   d3 = d1;
   d1 = d4 / (d1 * 2.0);
  }
  if (i2) {
   d4 = d3 * 2.0 - d1 * 0.0;
   d5 = d3 * 0.0 + d1 * 2.0;
   if ((d4 != d4 | 0.0 != 0.0) & (d5 != d5 | 0.0 != 0.0)) {
    ___muldc3(i9 | 0, +d3, +d1, 2.0, 0.0);
    d3 = +HEAPF64[i9 >> 3];
    d1 = +HEAPF64[i9 + 8 >> 3];
   } else {
    d3 = d4;
    d1 = d5;
   }
  }
  HEAPF64[i10 >> 3] = d3;
  HEAPF64[i10 + 8 >> 3] = d1;
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator9GetBoundsEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, f6 = f0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 f1 = Math_fround(HEAPF32[i3 + 288 >> 2]);
 i4 = (HEAP8[i3 + 229 >> 0] | 0) == 0;
 if (i4) {
  HEAPF32[i5 + 4 >> 2] = f1;
  f2 = Math_fround(HEAPF32[i3 + 292 >> 2]);
 } else {
  f6 = Math_fround(HEAPF32[i3 + 248 >> 2]);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f6) + Math_fround(.5)))) / f6);
  HEAPF32[i5 + 4 >> 2] = f1;
  f6 = Math_fround(HEAPF32[i3 + 292 >> 2]);
  f2 = Math_fround(HEAPF32[i3 + 248 >> 2]);
  f2 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f6 * f2) + Math_fround(.5)))) / f2);
 }
 HEAPF32[i5 + 12 >> 2] = Math_fround(f2 - f1);
 switch (HEAP32[i3 + 216 >> 2] | 0) {
 case 0:
  {
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   f1 = Math_fround(HEAPF32[i3 + 316 >> 2]);
   if (!i4) {
    f6 = Math_fround(HEAPF32[i3 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f6) + Math_fround(.5)))) / f6);
   }
   HEAPF32[i5 + 8 >> 2] = f1;
   return;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i3 + 316 >> 2]);
   if (!i4) {
    f6 = Math_fround(HEAPF32[i3 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f6) + Math_fround(.5)))) / f6);
   }
   f6 = Math_fround(-f1);
   HEAPF32[i5 >> 2] = f6;
   i4 = f1 > Math_fround(-0.0);
   HEAPF32[i5 + 8 >> 2] = i4 ? f1 : f6;
   return;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i3 + 316 >> 2]);
   f2 = Math_fround(f1 * Math_fround(.5));
   if (i4) HEAPF32[i5 >> 2] = Math_fround(-f2); else {
    f6 = Math_fround(HEAPF32[i3 + 248 >> 2]);
    HEAPF32[i5 >> 2] = Math_fround(-Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f2 * f6) + Math_fround(.5)))) / f6));
    f6 = Math_fround(HEAPF32[i3 + 248 >> 2]);
    f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f6) + Math_fround(.5)))) / f6);
   }
   HEAPF32[i5 + 8 >> 2] = f1;
   return;
  }
 default:
  return;
 }
}

function __Z60AnimatorControllerPlayable_CUSTOM_GetParametersArrayInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 12 | 0;
 i8 = i9;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 16 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN26AnimatorControllerPlayable13GetParametersEv(i8, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0);
 i4 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 16 >> 2] | 0;
 i5 = i8 + 4 | 0;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, ((HEAP32[i5 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 36 | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   __Z33AnimatorControllerParameterToMonoRK27AnimatorControllerParameterR31MonoAnimatorControllerParameter(i1 + (i3 * 36 | 0) | 0, i6);
   i2 = _il2cpp_object_new(i4 | 0) | 0;
   i1 = i2 + 8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i7, i3, i2);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 36 | 0) >>> 0);
 }
 i4 = i1;
 if (i1 | 0) {
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i6 + 4 | 0;
   do {
    i1 = i2 + -36 | 0;
    HEAP32[i5 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i2 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i6 >> 2] = 66;
     HEAP32[i3 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i1;
   } while ((i2 | 0) != (i4 | 0));
   i1 = HEAP32[i8 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i8 = i7;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z48UnityAnalyticsHandler_CUSTOM_SendCustomEventNameP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 40 | 0;
 i3 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (__ZNK11ICallString6IsNullEv(i3) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038891 | 0, i10);
 if (!i1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i9, i3);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 8;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i6 = 10;
  }
 } else i6 = 8;
 if ((i6 | 0) == 8) {
  i2 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN14UnityAnalytics15SendCustomEventERK8UnityStr(i5, i8) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN2UIL18CompareCanvasDepthEPNS_6CanvasES1_(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 if (!(__ZNK2UI6Canvas13GetRenderModeEv(i3) | 0)) {
  i4 = i3;
  while (1) {
   i6 = HEAP32[i4 + 344 >> 2] | 0;
   if (!i6) break;
   if (!(HEAP8[i4 + 375 >> 0] | 0)) i4 = i6; else break;
  }
  i6 = HEAP16[i4 + 372 >> 1] | 0;
  i4 = i2;
  while (1) {
   i7 = HEAP32[i4 + 344 >> 2] | 0;
   if (!i7) break;
   if (!(HEAP8[i4 + 375 >> 0] | 0)) i4 = i7; else break;
  }
  if (i6 << 16 >> 16 != (HEAP16[i4 + 372 >> 1] | 0)) {
   while (1) {
    i4 = HEAP32[i3 + 344 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i3 + 375 >> 0] | 0)) i3 = i4; else break;
   }
   i4 = HEAP16[i3 + 372 >> 1] | 0;
   while (1) {
    i3 = HEAP32[i2 + 344 >> 2] | 0;
    if (!i3) break;
    if (!(HEAP8[i2 + 375 >> 0] | 0)) i2 = i3; else break;
   }
   i7 = i4 << 16 >> 16 < (HEAP16[i2 + 372 >> 1] | 0);
   return i7 | 0;
  }
 } else {
  i4 = HEAP16[i3 + 420 >> 1] | 0;
  i6 = HEAP16[i2 + 420 >> 1] | 0;
  if (i4 << 16 >> 16 == i6 << 16 >> 16) i4 = i3; else {
   i7 = i4 << 16 >> 16 < i6 << 16 >> 16;
   return i7 | 0;
  }
  while (1) {
   i6 = HEAP32[i4 + 344 >> 2] | 0;
   if (!i6) break;
   if (!(HEAP8[i4 + 375 >> 0] | 0)) i4 = i6; else break;
  }
  i6 = HEAP16[i4 + 372 >> 1] | 0;
  i4 = i2;
  while (1) {
   i7 = HEAP32[i4 + 344 >> 2] | 0;
   if (!i7) break;
   if (!(HEAP8[i4 + 375 >> 0] | 0)) i4 = i7; else break;
  }
  if (i6 << 16 >> 16 != (HEAP16[i4 + 372 >> 1] | 0)) {
   while (1) {
    i4 = HEAP32[i3 + 344 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i3 + 375 >> 0] | 0)) i3 = i4; else break;
   }
   i4 = HEAP16[i3 + 372 >> 1] | 0;
   while (1) {
    i3 = HEAP32[i2 + 344 >> 2] | 0;
    if (!i3) break;
    if (!(HEAP8[i2 + 375 >> 0] | 0)) i2 = i3; else break;
   }
   i7 = i4 << 16 >> 16 < (HEAP16[i2 + 372 >> 1] | 0);
   return i7 | 0;
  }
 }
 f5 = Math_fround(HEAPF32[i3 + 348 >> 2]);
 if (f5 == Math_fround(-1.0)) {
  i7 = 0;
  return i7 | 0;
 }
 f1 = Math_fround(HEAPF32[i2 + 348 >> 2]);
 if (f1 == Math_fround(-1.0)) {
  i7 = 1;
  return i7 | 0;
 }
 i7 = f5 < f1;
 return i7 | 0;
}

function __Z47Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleAllRK13Vector2fIcallfiff(i1, f3, i2, f4, f5) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i14 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i14;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i14);
 i14 = i6;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i7 = i10;
 HEAP32[i7 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i7 + 4 >> 2] = i13;
 i7 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN16Physics2DManager16OverlapCircleAllERK8Vector2ffiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i7, i6, f3, i2, f4, f5, 0, i11) | 0;
 i6 = __Z19GetScriptingManagerv() | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i6 + 168 >> 2] | 0) + (HEAP32[gb + 32588 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i8 >> 2] | 0) | 0;
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i11 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i11 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i7 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i6, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i6 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i6 | 0;
}

function __Z14raycast_sphereRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_(i9, i13, i11, i12, f2, i10, i7, i14, i1, i3, i8) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f2 = Math_fround(f2);
 i10 = i10 | 0;
 i7 = i7 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var f4 = f0, f5 = f0, f6 = f0;
 i1 = i13 + 16 | 0;
 i3 = i14 + 40 | 0;
 i7 = i14 + 16 | 0;
 if (!(__ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_(i11, i12, f2, i1, Math_fround(HEAPF32[i9 + 4 >> 2]), i3, i7) | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 HEAP32[i14 + 8 >> 2] = -1;
 HEAPF32[i14 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i14 + 48 >> 2] = Math_fround(0.0);
 do if (!(HEAP16[i10 >> 1] & 2)) {
  HEAP32[i14 + 28 >> 2] = 0;
  HEAP32[i14 + 32 >> 2] = 0;
  HEAP32[i14 + 36 >> 2] = 0;
  i1 = 5;
 } else {
  i8 = i14 + 28 | 0;
  if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) {
   f4 = Math_fround(-Math_fround(HEAPF32[i12 >> 2]));
   f5 = Math_fround(-Math_fround(HEAPF32[i12 + 4 >> 2]));
   f6 = Math_fround(-Math_fround(HEAPF32[i12 + 8 >> 2]));
   HEAPF32[i8 >> 2] = f4;
   HEAPF32[i14 + 32 >> 2] = f5;
   HEAPF32[i14 + 36 >> 2] = f6;
   i1 = 7;
   break;
  }
  f5 = Math_fround(HEAPF32[i7 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
  f6 = Math_fround(HEAPF32[i14 + 20 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i13 + 20 >> 2]));
  f2 = Math_fround(HEAPF32[i14 + 24 >> 2]);
  f2 = Math_fround(f2 - Math_fround(HEAPF32[i13 + 24 >> 2]));
  HEAPF32[i8 >> 2] = f5;
  i1 = i14 + 32 | 0;
  HEAPF32[i1 >> 2] = f6;
  i3 = i14 + 36 | 0;
  HEAPF32[i3 >> 2] = f2;
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f2 * f2))));
  if (f4 > Math_fround(0.0)) {
   f4 = Math_fround(Math_fround(1.0) / f4);
   HEAPF32[i8 >> 2] = Math_fround(f5 * f4);
   HEAPF32[i1 >> 2] = Math_fround(f6 * f4);
   HEAPF32[i3 >> 2] = Math_fround(f2 * f4);
   i1 = 7;
  } else i1 = 7;
 } while (0);
 HEAP16[i14 + 12 >> 1] = i1;
 i14 = 1;
 return i14 | 0;
}

function __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 + 4 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = HEAP32[gb + 62512 >> 2];
  HEAP32[i2 + 48 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
  HEAP32[i2 + 52 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 68 >> 2] = 0;
  HEAP32[i2 + 72 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i6 = i4;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 60 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i2 + 76 >> 2] = 0;
  HEAP32[i2 + 88 >> 2] = 0;
  HEAP32[i2 + 92 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i2 + 80 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i2 + 96 >> 2] = 0;
  HEAP32[i2 + 108 >> 2] = 0;
  HEAP32[i2 + 112 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i6 = i4;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i2 + 100 | 0;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  HEAP32[i2 + 116 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
  i8 = i4;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i2 + 120 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAPF32[i2 + 136 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 140 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 144 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 148 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
  i2 = (HEAP32[i3 >> 2] | 0) + 156 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZNK26AnimatorControllerPlayable24GetAnimatorClipInfoCountEib(i5, i2, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i6 = i7 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if ((i2 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0) | 0) i1 = HEAP32[HEAP32[i5 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i2 | 0)) {
   i1 = (HEAP32[i5 + 92 >> 2] | 0) + 4 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) + (i2 << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i6 = HEAP32[i1 >> 2] | 0;
   i2 = i3 ? (HEAP32[(HEAP32[(HEAP32[(HEAP32[i5 + 104 >> 2] | 0) + 4 >> 2] | 0) + (i6 << 2) >> 2] | 0) + 4 >> 2] | 0) >>> 1 & 1 : 1;
   i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i5 + 144 >> 2] | 0) + (i6 << 3) >> 2] | 0) + (HEAP32[i1 + 4 >> 2] << 2) >> 2] | 0) + 8 >> 2] | 0;
   if (i2 >>> 0 >= (HEAP32[i1 + 28 >> 2] | 0) >>> 0) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   i3 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if (!i3) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   i6 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
   i4 = i6 + -1 | 0;
   if ((i6 | 0) > 1) {
    i1 = 0;
    i2 = 0;
   } else {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   do {
    i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i4 | 0));
   STACKTOP = i7;
   return i1 | 0;
  }
 }
 HEAP32[i4 >> 2] = i2;
 __Z6FormatPKcz(i6, gb + 902210 | 0, i4);
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 * 76 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 * 76 | 0) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = gb + 148864 + 8;
   i8 = i2 + 4 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i1 + 4 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i10 = i2 + 16 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1 + 16 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i8 = i1 + 28 | 0;
   i9 = i2 + 28 | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   i8 = i2 + 44 | 0;
   i9 = HEAP32[i8 + 4 >> 2] | 0;
   i10 = i1 + 44 | 0;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i9;
   i10 = i2 + 52 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1 + 52 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
   i8 = i1 + 64 | 0;
   i9 = i2 + 64 | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   i1 = i1 + 76 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 76 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i10 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx2Gu23intersectRaySphereBasicERKNS_6PxVec3ES3_fS3_fRfPS1_(i16, i12, f15, i2, f8, i13, i14) {
 i16 = i16 | 0;
 i12 = i12 | 0;
 f15 = Math_fround(f15);
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 i13 = i13 | 0;
 i14 = i14 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0, i11 = 0, f17 = f0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i16 >> 2]);
 f17 = Math_fround(f17 - f5);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i11 = i16 + 4 | 0;
 f7 = Math_fround(HEAPF32[i11 >> 2]);
 f4 = Math_fround(f4 - f7);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i16 + 8 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f3 - f1);
 f6 = Math_fround(f17 * Math_fround(HEAPF32[i12 >> 2]));
 i9 = i12 + 4 | 0;
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2])));
 i10 = i12 + 8 | 0;
 f6 = Math_fround(f6 + Math_fround(f3 * Math_fround(HEAPF32[i10 >> 2])));
 f3 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f4 * f4)) + Math_fround(f3 * f3));
 f4 = Math_fround(f8 * f8);
 if (f3 <= f4) {
  if (i14 | 0) {
   HEAPF32[i14 >> 2] = f5;
   HEAPF32[i14 + 4 >> 2] = f7;
   HEAPF32[i14 + 8 >> 2] = f1;
  }
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  i16 = 1;
  return i16 | 0;
 }
 if (f6 <= Math_fround(0.0) | Math_fround(f6 - f15) > f8) {
  i16 = 0;
  return i16 | 0;
 }
 f1 = Math_fround(f4 - Math_fround(f3 - Math_fround(f6 * f6)));
 if (f1 < Math_fround(0.0)) {
  i16 = 0;
  return i16 | 0;
 }
 f1 = Math_fround(f6 - Math_fround(Math_sqrt(Math_fround(f1))));
 HEAPF32[i13 >> 2] = f1;
 if (f1 > f15) {
  i16 = 0;
  return i16 | 0;
 }
 if (!i14) {
  i16 = 1;
  return i16 | 0;
 }
 f8 = Math_fround(f1 * Math_fround(HEAPF32[i12 >> 2]));
 f15 = Math_fround(f1 * Math_fround(HEAPF32[i9 >> 2]));
 f17 = Math_fround(f1 * Math_fround(HEAPF32[i10 >> 2]));
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i16 >> 2]));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i11 >> 2]));
 f17 = Math_fround(f17 + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i14 >> 2] = f8;
 HEAPF32[i14 + 4 >> 2] = f15;
 HEAPF32[i14 + 8 >> 2] = f17;
 i16 = 1;
 return i16 | 0;
}

function __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE13set_empty_keyERSG_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 24 | 0;
 i7 = i10;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i7 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i8 >> 2] | 0;
   i9 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i7 + 11 >> 0] = i4;
   if (!i4) i1 = i7; else {
    i1 = i7;
    i9 = 8;
   }
  } else {
   i1 = i2;
   i9 = 6;
  }
  if ((i9 | 0) == 6) {
   i2 = i4 + 16 & -16;
   HEAP32[i6 >> 2] = 54;
   HEAP32[i6 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i7 + 4 >> 2] = i4;
   i9 = 8;
  }
  if ((i9 | 0) == 8) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 HEAP32[i7 + 16 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13set_empty_keyERKSC_(i5, i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i10;
  return;
 }
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 54;
 HEAP32[i6 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
 STACKTOP = i10;
 return;
}

function __ZN13TriggerModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 28 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 32 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 36 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 40 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 44 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 48 | 0, i1);
 i5 = i7 + 8 | 0;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i3 = HEAP32[i5 >> 2] | 0;
 switch (i3 | 0) {
 case 1:
  {
   i2 = 1;
   i1 = 1;
   i9 = 13;
   break;
  }
 case 8:
 case 3:
  {
   i1 = 3;
   i9 = 5;
   break;
  }
 case 5:
 case 14:
 case 4:
  {
   i1 = 4;
   i9 = 5;
   break;
  }
 case 23:
  {
   i2 = -1;
   i1 = 3;
   i9 = 14;
   break;
  }
 case 20:
 case 6:
  {
   i1 = 4;
   i9 = 5;
   break;
  }
 default:
  {
   i1 = -1;
   i9 = 5;
  }
 }
 L5 : do if ((i9 | 0) == 5) switch (i3 | 0) {
 case 1:
  {
   i2 = 1;
   i9 = 13;
   break L5;
  }
 case 23:
  {
   i2 = -1;
   i9 = 14;
   break L5;
  }
 case 3:
  {
   i2 = -1;
   i9 = 13;
   break L5;
  }
 case 8:
  {
   i2 = -1;
   i9 = 13;
   break L5;
  }
 case 4:
  {
   i2 = 3;
   i9 = 13;
   break L5;
  }
 case 14:
  {
   i2 = 3;
   i9 = 13;
   break L5;
  }
 case 5:
  {
   i2 = 0;
   i9 = 13;
   break L5;
  }
 case 6:
  {
   i2 = 0;
   i9 = 14;
   break L5;
  }
 case 20:
  {
   i2 = 3;
   i9 = 14;
   break L5;
  }
 default:
  {
   i2 = __Z11IsHDRFormat13TextureFormat(i3) | 0;
   i4 = 0;
   i3 = -1;
   i2 = i2 ? 6 : 5;
   break L5;
  }
 } while (0);
 if ((i9 | 0) == 13) {
  i9 = __Z11IsHDRFormat13TextureFormat(i3) | 0;
  i4 = 0;
  i3 = i2;
  i2 = i9 ? 6 : 5;
 } else if ((i9 | 0) == 14) {
  i9 = __Z11IsHDRFormat13TextureFormat(i3) | 0;
  i4 = 3;
  i3 = i2;
  i2 = i9 ? 6 : 5;
 }
 i13 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = HEAP32[i5 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i9 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = fb + 558;
 HEAP32[i8 + 4 >> 2] = fb + 2403;
 _stbir_resize(HEAP32[i5 + 16 >> 2] | 0, i12, i9, HEAP32[i5 + 12 >> 2] | 0, HEAP32[i6 + 16 >> 2] | 0, i13, i11, HEAP32[i6 + 12 >> 2] | 0, i4, i1, i3, 1, 1, 1, (i13 | 0) < (i12 | 0) ? i2 : 3, (i11 | 0) < (i9 | 0) ? i2 : 3, (i7 | 0) != 0 & 1, i8) | 0;
 STACKTOP = i10;
 return;
}

function __ZNK8Material12GetPassCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i6 = 11; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i2);
    i2 = HEAP32[i5 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) i6 = 11;
 } while (0);
 if ((i6 | 0) == 11) {
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 469921 | 0, 27);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i5) | 0;
   HEAP32[gb + 1166240 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i1 = HEAP32[gb + 1166240 >> 2] | 0;
   HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
  }
 }
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 STACKTOP = i7;
 return HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[i8 + 48 >> 2] << 2) >> 2] | 0) + 20 >> 2] | 0;
}

function __ZN25RuntimeAnimatorController22RegisterAnimationClipsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 24 | 0;
 i9 = i12 + 20 | 0;
 i10 = i12;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i10 | 0, i1 | 0);
 i6 = i1 + 56 | 0;
 __ZN8UserList5ClearEv(i6);
 i7 = i10 + 12 | 0;
 __ZN8UserList7ReserveEj(i6, HEAP32[i7 >> 2] | 0);
 if (HEAP32[i7 >> 2] | 0) {
  i5 = 0;
  do {
   i4 = (HEAP32[i10 >> 2] | 0) + (i5 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i11 = 12; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
      i2 = HEAP32[i8 >> 2] | 0;
      i13 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i13 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i13 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i11 = 12; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i11 = 14;
     }
    }
    if ((i11 | 0) == 12) i11 = 14;
    if ((i11 | 0) == 14) {
     i11 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    __ZN8UserList7AddUserERS_(i1 + 32 | 0, i6);
   } while (0);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i10 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i10 + 4 | 0);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN13RuntimeStaticI15ApplicationInfoE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(56, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = i4 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i3 = i4 + 32 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 48 >> 2] = 0;
  HEAP32[i4 + 52 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = i4 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i3 = i4 + 32 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i4 + 48 >> 2] = 0;
  HEAP32[i4 + 52 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_10StartEventEEEbRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i3 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 8 | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i4, i7, (HEAPU8[i6 >> 0] | 0) >>> 2 & 3);
 i2 = i4 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i2, HEAPU8[i6 >> 0] & 3);
 i5 = (HEAP8[(HEAP32[i5 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i5) return i5 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i8 = i2;
 i10 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i6 = i2;
 i9 = (HEAP8[i10 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i9 ? 0 : HEAP32[i6 >> 2] | 0) | 0, (i9 ? 0 : HEAP32[i6 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i9 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = i4;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP8[i4 + 13 >> 0] | 0;
 i4 = HEAP8[i4 + 12 >> 0] | 0;
 i1 = i2 + 8192 | 0;
 i7 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
 HEAP32[i7 >> 2] = HEAPU16[i10 + 2 >> 1] << 16 | 65281;
 i10 = i7 + 8 | 0;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP8[i7 + 20 >> 0] = i4;
 HEAP8[i7 + 21 >> 0] = i3;
 i7 = i7 + 24 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i7;
 if ((i7 | 0) != 256) return i5 | 0;
 i12 = HEAP32[i2 + 8196 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, 256);
 HEAP32[i1 >> 2] = 0;
 return i5 | 0;
}

function __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_10StartEventEEEbRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i3 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 8 | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i4, i7, (HEAPU8[i6 >> 0] | 0) >>> 2 & 3);
 i2 = i4 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i2, HEAPU8[i6 >> 0] & 3);
 i5 = (HEAP8[(HEAP32[i5 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i5) return i5 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i8 = i2;
 i10 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i6 = i2;
 i9 = (HEAP8[i10 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i9 ? 0 : HEAP32[i6 >> 2] | 0) | 0, (i9 ? 0 : HEAP32[i6 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i9 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = i4;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP8[i4 + 13 >> 0] | 0;
 i4 = HEAP8[i4 + 12 >> 0] | 0;
 i1 = i2 + 8192 | 0;
 i7 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
 HEAP32[i7 >> 2] = HEAPU16[i10 + 2 >> 1] << 16 | 65281;
 i10 = i7 + 8 | 0;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP8[i7 + 20 >> 0] = i4;
 HEAP8[i7 + 21 >> 0] = i3;
 i7 = i7 + 24 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i7;
 if ((i7 | 0) != 256) return i5 | 0;
 i12 = HEAP32[i2 + 8196 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, 256);
 HEAP32[i1 >> 2] = 0;
 return i5 | 0;
}

function __Z25BatchDeleteObjectInternalPKii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 1056 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 1040 | 0;
 i11 = i14 + 1032 | 0;
 i12 = i14;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 if ((HEAP16[gb + 1162496 + 6 >> 1] | 0) > -1) {
  HEAP32[i11 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162496 | 0, i9);
  i10 = gb + 1162496 | 0;
 } else i10 = 0;
 i13 = i12 + 4 | 0;
 while (1) {
  i8 = i1 >>> 0 > 256 ? 256 : i1;
  HEAP32[i12 >> 2] = i8;
  HEAP32[i13 >> 2] = 0;
  if (!i8) i3 = 0; else {
   i7 = 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   do {
    HEAP32[i11 >> 2] = HEAP32[i2 + (i7 << 2) >> 2];
    if (!i3) {
     i4 = 0;
     i3 = 0;
    } else {
     if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
      i5 = HEAP32[i3 + 28 >> 2] | 0;
      i6 = HEAP32[i3 + 32 >> 2] | 0;
      i4 = i5 + (i6 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i3, i11);
      i4 = HEAP32[i9 >> 2] | 0;
      i5 = HEAP32[i3 + 28 >> 2] | 0;
      i15 = HEAP32[gb + 1104264 >> 2] | 0;
      i4 = (i4 | 0) == -1 ? i5 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i5 + (i4 << 3) | 0;
      i5 = HEAP32[i15 + 28 >> 2] | 0;
      i6 = HEAP32[i15 + 32 >> 2] | 0;
      i3 = i15;
     }
     if ((i4 | 0) == (i5 + (i6 << 3) | 0)) i4 = 0; else i4 = HEAP32[i4 + 4 >> 2] | 0;
    }
    HEAP32[i12 + 8 + (i7 << 2) >> 2] = i4;
    i7 = i7 + 1 | 0;
   } while (i7 >>> 0 < i8 >>> 0);
   i3 = i8;
  }
  HEAP32[i13 >> 2] = i3;
  __Z17CommitBatchDeleteR11BatchDelete(i12);
  i1 = i1 - i8 | 0;
  if (!i1) break; else i2 = i2 + (i8 << 2) | 0;
 }
 if (!i10) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i14;
 return;
}

function __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_(i10, i11, i8, i7, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, f12 = f0;
 i5 = HEAP32[i11 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 f12 = Math_fround(HEAPF32[i9 + (i5 * 40 | 0) + 36 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + (i4 * 40 | 0) + 36 >> 2]);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2]) > f12;
 do if (f12 > f3) {
  if (i1) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i8 >> 2] = i4;
   i6 = 1;
   i2 = i4;
   break;
  }
  HEAP32[i10 >> 2] = i5;
  HEAP32[i11 >> 2] = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  if (Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2]) > f3) {
   HEAP32[i11 >> 2] = i2;
   HEAP32[i8 >> 2] = i4;
   i6 = 2;
   i2 = i4;
  } else i6 = 1;
 } else if (i1) {
  HEAP32[i11 >> 2] = i2;
  HEAP32[i8 >> 2] = i5;
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 36 >> 2]);
  if (f12 > Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2])) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i11 >> 2] = i2;
   i6 = 2;
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i6 = 1;
   i2 = i5;
  }
 } else i6 = 0; while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 36 >> 2]);
 if (!(f12 > Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2]))) {
  i11 = i6;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 36 >> 2]);
 if (!(f12 > Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2]))) {
  i11 = i6 + 1 | 0;
  return i11 | 0;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i9 + (i1 * 40 | 0) + 36 >> 2]);
 if (!(f12 > Math_fround(HEAPF32[i9 + (i2 * 40 | 0) + 36 >> 2]))) {
  i11 = i6 + 2 | 0;
  return i11 | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 i11 = i6 + 3 | 0;
 return i11 | 0;
}

function __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN18AwakeFromLoadQueue19InvokeAwakeFromLoadEPNS_4ItemEj17AwakeFromLoadMode(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14 + 8 | 0;
 i10 = i14;
 i11 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
 i12 = (i11 | 0) == 0;
 if (!i12) __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
 if (i7 | 0) {
  i5 = 0;
  do {
   i4 = i6 + (i5 * 12 | 0) + 4 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do if (i1 | 0) {
    HEAP32[i10 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 14; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i9, i1, i10);
      i2 = HEAP32[i9 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 14; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 16;
     }
    }
    if ((i13 | 0) == 14) i13 = 16;
    if ((i13 | 0) == 16) {
     i13 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
     if (!i1) break;
    }
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i8 | 0);
   } while (0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i7 | 0));
 }
 if (i12) {
  STACKTOP = i14;
  return;
 }
 __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i11);
 STACKTOP = i14;
 return;
}

function __ZL24processBrokenEdgeIslandsRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerEPjSD_SD_RS4_(i8, i16, i10, i14, i12, i13, i11, i9) {
 i8 = i8 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i15 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 4096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] & 2147483647;
 while (1) {
  i1 = i2 + -1 | 0;
  if (!i2) {
   i7 = 1;
   break;
  }
  i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  if (!i2) i2 = i1; else {
   i4 = 4;
   break;
  }
 }
 if ((i4 | 0) == 4) {
  i7 = i2 >>> 1 | i2;
  i7 = i7 >>> 2 | i7;
  i7 = i7 >>> 4 | i7;
  i7 = i7 >>> 8 | i7;
  i7 = (Math_imul(i7 >>> 16 | i7, 130329821) | 0) >>> 27;
  i7 = (((HEAP32[gb + 85120 + (i7 << 2) >> 2] | 0) + (i1 << 5) | 0) >>> 5) + 1 | 0;
 }
 i6 = i14 + 36 | 0;
 i1 = 0;
 i5 = 0;
 while (1) {
  i2 = HEAP32[i3 + (i5 << 2) >> 2] | 0;
  if (i2) {
   i4 = i5 << 5;
   do {
    i18 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
    i18 = HEAP32[gb + 90668 + (i18 << 2) >> 2] | 0;
    i3 = i18 | i4;
    do if (HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + (i3 >>> 5 << 2) >> 2] & 1 << (i18 & 31)) if (i1 >>> 0 < 1024) {
     HEAP32[i15 + (i1 << 2) >> 2] = i3;
     i1 = i1 + 1 | 0;
     break;
    } else {
     __ZL25processBrokenEdgeIslands2PKjjRN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerEPjS8_S8_RNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEE(i15, i1, i16, i10, i14, i12, i13, i11, i9);
     HEAP32[i15 >> 2] = i3;
     i1 = 1;
     break;
    } while (0);
    i2 = i2 + -1 & i2;
   } while ((i2 | 0) != 0);
  }
  i2 = i5 + 1 | 0;
  if ((i2 | 0) == (i7 | 0)) break;
  i3 = HEAP32[i8 >> 2] | 0;
  i5 = i2;
 }
 __ZL25processBrokenEdgeIslands2PKjjRN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerEPjS8_S8_RNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEE(i15, i1, i16, i10, i14, i12, i13, i11, i9);
 STACKTOP = i17;
 return;
}

function __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_9StopEventEEEbRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i3 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 8 | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i4, i7, (HEAPU8[i6 >> 0] | 0) >>> 2 & 3);
 i2 = i4 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i2, HEAPU8[i6 >> 0] & 3);
 i5 = (HEAP8[(HEAP32[i5 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i5) return i5 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i8 = i2;
 i10 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i6 = i2;
 i9 = (HEAP8[i10 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i9 ? 0 : HEAP32[i6 >> 2] | 0) | 0, (i9 ? 0 : HEAP32[i6 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i9 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = i4;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP8[i4 + 13 >> 0] | 0;
 i4 = HEAP8[i4 + 12 >> 0] | 0;
 i1 = i2 + 8192 | 0;
 i7 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
 HEAP32[i7 >> 2] = HEAPU16[i10 + 2 >> 1] << 16 | 65282;
 i10 = i7 + 8 | 0;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP8[i7 + 20 >> 0] = i4;
 HEAP8[i7 + 21 >> 0] = i3;
 i7 = i7 + 24 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i7;
 if ((i7 | 0) != 256) return i5 | 0;
 i12 = HEAP32[i2 + 8196 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, 256);
 HEAP32[i1 >> 2] = 0;
 return i5 | 0;
}

function __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_9StopEventEEEbRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i3 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i1 = i3 + 8 | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i4, i7, (HEAPU8[i6 >> 0] | 0) >>> 2 & 3);
 i2 = i4 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i7, gb + 660679 | 0, i2, HEAPU8[i6 >> 0] & 3);
 i5 = (HEAP8[(HEAP32[i5 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i5) return i5 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i8 = i2;
 i10 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i6 = i2;
 i9 = (HEAP8[i10 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i9 ? 0 : HEAP32[i6 >> 2] | 0) | 0, (i9 ? 0 : HEAP32[i6 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i9 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = i4;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = HEAP8[i4 + 13 >> 0] | 0;
 i4 = HEAP8[i4 + 12 >> 0] | 0;
 i1 = i2 + 8192 | 0;
 i7 = i2 + (HEAP32[i1 >> 2] << 5) | 0;
 HEAP32[i7 >> 2] = HEAPU16[i10 + 2 >> 1] << 16 | 65282;
 i10 = i7 + 8 | 0;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP8[i7 + 20 >> 0] = i4;
 HEAP8[i7 + 21 >> 0] = i3;
 i7 = i7 + 24 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i7;
 if ((i7 | 0) != 256) return i5 | 0;
 i12 = HEAP32[i2 + 8196 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0, i12 | 0, i2 | 0, 256);
 HEAP32[i1 >> 2] = 0;
 return i5 | 0;
}

function __ZN5physx7profile17EventDeserializerILb1EE9streamifyIyEEvPKcRT_(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i4 + 8 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 8) {
   HEAP8[i3 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i9 = i3 + 1 | 0;
   HEAP8[i9 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i7 = i3 + 2 | 0;
   HEAP8[i7 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i5 = i3 + 3 | 0;
   HEAP8[i5 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i1 = i3 + 4 | 0;
   HEAP8[i1 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i6 = i3 + 5 | 0;
   HEAP8[i6 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i8 = i3 + 6 | 0;
   HEAP8[i8 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i10 = i3 + 7 | 0;
   HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i4 = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = HEAP8[i10 >> 0] | 0;
   HEAP8[i10 >> 0] = i4;
   i4 = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
   HEAP8[i8 >> 0] = i4;
   i4 = HEAP8[i7 >> 0] | 0;
   HEAP8[i7 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i6 >> 0] = i4;
   i4 = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = i4;
   return;
  }
 }
 HEAP8[i1 >> 0] = 1;
 return;
}

function __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 33952 + 8;
 __ZN13dynamic_arrayIN9ShaderLab16FastPropertyNameELj4EEC2ERKS2_RK10MemLabelId(i6 + 32 | 0, i8 + 32 | 0, i7);
 __ZN13dynamic_arrayIjLj4EEC2ERKS0_RK10MemLabelId(i6 + 52 | 0, i8 + 52 | 0, i7);
 i10 = i6 + 84 | 0;
 HEAP32[i10 >> 2] = 0;
 i1 = i6 + 88 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i6 + 76 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i7);
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 i3 = i6 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = HEAP32[i8 + 72 >> 2] | 0;
 i4 = HEAP32[i8 + 84 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 i5 = HEAP32[i1 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i4 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i4, 4, i2, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i1;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i2, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  i1 = i5;
  break;
 } else i1 = 0; while (0);
 _memcpy(i1 | 0, i9 | 0, HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i6 + 92 >> 2] = HEAP32[i8 + 92 >> 2];
 HEAP32[i6 + 96 >> 2] = HEAP32[i8 + 96 >> 2];
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i6 + 100 | 0;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP8[i6 + 108 >> 0] = HEAP8[i8 + 108 >> 0] | 0;
 i10 = i6 + 8 | 0;
 i9 = i8 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
   HEAP8[i2 + 36 >> 0] = 0;
   HEAP8[i2 + 37 >> 0] = 0;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAP8[i2 + 44 >> 0] = 1;
   HEAP8[i2 + 45 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN17BufferManagerGLES5ClearEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i8 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i8 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) i5 = 0; else {
  while (1) {
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) {
    i2 = i3 + 4 | 0;
    if (HEAP8[i3 + 20 >> 0] | 0) __Z34register_external_gfx_deallocationPvPKci(HEAP32[i2 >> 2] | -1073741824, gb + 602218 | 0, 116);
    if (HEAP32[i2 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i2);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63304 | 0);
   HEAP32[i1 >> 2] = 0;
   i3 = i1 + 4 | 0;
   if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) break; else i1 = i3;
  }
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) i5 = 0; else {
   HEAP32[i5 >> 2] = i3 + (~((i1 - i2 | 0) >>> 2) << 2);
   i5 = 0;
  }
 }
 do {
  i6 = i8 + 16 + (i5 * 12 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i7 = i8 + 16 + (i5 * 12 | 0) + 4 | 0;
  if ((i1 | 0) != (i7 | 0)) {
   i2 = i1;
   while (1) {
    i3 = i2 + 20 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4 | 0) {
     i1 = i4 + 4 | 0;
     if (HEAP8[i4 + 20 >> 0] | 0) __Z34register_external_gfx_deallocationPvPKci(HEAP32[i1 >> 2] | -1073741824, gb + 602218 | 0, 116);
     if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63304 | 0);
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
   }
  }
  __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i6, HEAP32[i7 >> 2] | 0);
  HEAP32[i8 + 16 + (i5 * 12 | 0) + 8 >> 2] = 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i7 >> 2] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 11);
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E5clearEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 i3 = i12 + 96 | 0;
 i4 = i12 + 100 | 0;
 HEAP32[i4 >> 2] = 32;
 HEAP32[i12 + 112 >> 2] = 16;
 HEAP32[i12 + 108 >> 2] = 6;
 HEAP8[i12 + 116 >> 0] = 0;
 i5 = i12 + 120 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = 65;
 HEAP32[i1 + 4 >> 2] = i11;
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1280, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = 65;
  HEAP32[i1 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 }
 HEAP32[i3 >> 2] = i11;
 i2 = i11 + ((HEAP32[i4 >> 2] | 0) * 40 | 0) | 0;
 if ((i11 | 0) == (i2 | 0)) {
  i11 = i12 + 104 | 0;
  HEAP32[i11 >> 2] = 0;
  i12 = i12 + 4 | 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i3 = i12 + 56 | 0;
 i4 = i12 + 64 | 0;
 i5 = i12 + 68 | 0;
 i6 = i12 + 72 | 0;
 i7 = i12 + 76 | 0;
 i8 = i12 + 80 | 0;
 i9 = i12 + 84 | 0;
 i10 = i12 + 88 | 0;
 i1 = i11;
 do {
  i11 = i3;
  i14 = HEAP32[i11 + 4 >> 2] | 0;
  i15 = i1;
  HEAP32[i15 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i15 + 4 >> 2] = i14;
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i9 >> 2];
  i15 = i10;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i11 = i1 + 32 | 0;
  HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i11 + 4 >> 2] = i14;
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i15 = i12 + 104 | 0;
 HEAP32[i15 >> 2] = 0;
 i15 = i12 + 4 | 0;
 HEAP32[i15 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN10Effector2D15PreSolveContactEP9b2Contact(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i7 + 48 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i2 + 60 >> 2] | 0;
 i10 = i7 + 52 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i5 = HEAP32[i3 + 60 >> 2] | 0;
 if (HEAP8[i6 + 53 >> 0] | 0) {
  i4 = HEAP32[i6 + 156 >> 2] | 0;
  if (i4 | 0) {
   HEAP8[i8 + 36 >> 0] = 1;
   HEAP32[i8 + 32 >> 2] = i7;
   HEAP32[i8 + 4 >> 2] = i6;
   if (!(HEAP32[i6 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i6 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 20 >> 2] = i5;
   if (!(HEAP32[i5 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i5 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
   HEAP32[i8 + 16 >> 2] = i1;
   HEAP32[i8 + 8 >> 2] = i2;
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 56 >> 2];
   HEAP32[i8 + 24 >> 2] = i3;
   HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 60 >> 2];
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, i8 | 0);
  }
 }
 if (!(HEAP8[i5 + 53 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i5 + 156 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i8 + 36 >> 0] = 0;
 HEAP32[i8 + 32 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i5;
 if (!(HEAP32[i5 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i5 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = i6;
 if (!(HEAP32[i6 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i6 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i8 + 16 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 60 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 56 >> 2];
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i8 | 0);
 STACKTOP = i11;
 return;
}

function __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii(i12, i4, i5, i6, i7, i8, i9, i10, i11) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i14 = i15 + 4 | 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) {
  STACKTOP = i15;
  return;
 }
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i12) | 0)) {
  STACKTOP = i15;
  return;
 }
 if ((i10 | 0) < 0) if (!i12) i1 = 0; else i2 = 6; else if ((HEAP32[i12 + 76 >> 2] | 0) > (i10 | 0)) {
  i1 = i12 + 52 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i11 | 0) >= 0) {
   if (!i2) i3 = 0; else i3 = HEAP32[i2 + 44 >> 2] | 0;
   if ((i3 | 0) > (i11 | 0)) {
    i11 = Math_imul(HEAP32[i2 + 40 >> 2] | 0, i11) | 0;
    i11 = (HEAP32[i2 + 8 >> 2] | 0) + i11 | 0;
    i11 = i11 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 32 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, i10) | 0) | 0;
    i14 = HEAP32[i1 >> 2] | 0;
    i12 = HEAP32[i14 + 28 >> 2] >> i10;
    i13 = HEAP32[i14 + 32 >> 2] >> i10;
    __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf(i11, (i12 | 0) < 1 ? 1 : i12, (i13 | 0) < 1 ? 1 : i13, HEAP32[i14 + 36 >> 2] | 0, i4, i5, i6, i7, i8, i9) | 0;
    STACKTOP = i15;
    return;
   }
  }
  if (!i2) i1 = -1; else i1 = (HEAP32[i2 + 44 >> 2] | 0) + -1 | 0;
  HEAP32[i13 >> 2] = i1;
  __Z6FormatPKcz(i14, gb + 416798 | 0, i13);
  if (!i12) i1 = 0; else i1 = HEAP32[i12 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i14 + 11 >> 0] | 0) < 0 ? HEAP32[i14 >> 2] | 0 : i14, 0, gb + 410682 | 0, 1181, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  STACKTOP = i15;
  return;
 } else i2 = 6;
 if ((i2 | 0) == 6) i1 = HEAP32[i12 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 410682 | 0, 1175, 1, i1, 0, 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i6 = i12 + 20 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i7 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 28 >> 2])) >>> 0;
 i2 = i1 << 2;
 i10 = (i7 << 2) + i2 | 0;
 i10 = (0 - i10 & 12) + i10 | 0;
 i8 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i8 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i10 + (i7 << 3) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i9 = i8 + i2 | 0;
 i10 = i8 + i10 | 0;
 _memset(i8 | 0, -1, i2 | 0) | 0;
 i2 = i12 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  i4 = i1 + -1 | 0;
  i5 = 0;
  do {
   i14 = i3 + (i5 << 3) | 0;
   i15 = HEAP32[i14 >> 2] | 0;
   i15 = i15 + ~(i15 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i8 + (((i15 >>> 16 ^ i15) & i4) << 2) | 0;
   HEAP32[i9 + (i5 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   HEAP32[i10 + (i5 << 3) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i10 + (i5 << 3) + 4 >> 2] = HEAP32[i3 + (i5 << 3) + 4 >> 2];
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i15 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i8;
 HEAP32[i12 + 16 >> 2] = i8;
 HEAP32[i12 + 24 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i7;
 i1 = i12 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5Umbra9Matrix4x411flushToZeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2]))) <= 1.0e-15) HEAPF32[i2 >> 2] = Math_fround(0.0);
 i1 = i2 + 4 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 8 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 12 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 16 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 20 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 24 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 28 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 32 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 36 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 40 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 44 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 48 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 52 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 56 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 60 | 0;
 if (!(+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15)) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN4FMOD5Sound13setLoopPointsEjjjj(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 40 | 0;
 i9 = i14 + 32 | 0;
 i8 = i14 + 24 | 0;
 i12 = i14 + 16 | 0;
 i11 = i14 + 8 | 0;
 i7 = i14;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   switch (i4 | 0) {
   case 2:
    {
     HEAPF64[i2 + 328 >> 3] = +Math_fround(Math_fround(i3 >>> 0) / Math_fround(44100.0));
     i13 = 10;
     break;
    }
   case 1:
    {
     HEAPF64[i2 + 328 >> 3] = +(i3 >>> 0) * .001;
     i13 = 10;
     break;
    }
   default:
    {
     HEAP32[i11 >> 2] = gb + 854586;
     HEAP32[i11 + 4 >> 2] = 1476;
     _printf(gb + 854600 | 0, i11) | 0;
     HEAP32[i12 >> 2] = 37;
     HEAP32[i12 + 4 >> 2] = gb + 854586;
     _printf(gb + 853277 | 0, i12) | 0;
    }
   }
   L10 : do if ((i13 | 0) == 10) switch (i6 | 0) {
   case 2:
    {
     HEAPF64[i2 + 336 >> 3] = +Math_fround(Math_fround(i5 >>> 0) / Math_fround(44100.0));
     i13 = 0;
     STACKTOP = i14;
     return i13 | 0;
    }
   case 1:
    {
     HEAPF64[i2 + 336 >> 3] = +(i5 >>> 0) * .001;
     i13 = 0;
     STACKTOP = i14;
     return i13 | 0;
    }
   default:
    {
     HEAP32[i8 >> 2] = gb + 854586;
     HEAP32[i8 + 4 >> 2] = 1488;
     _printf(gb + 854600 | 0, i8) | 0;
     HEAP32[i9 >> 2] = 37;
     HEAP32[i9 + 4 >> 2] = gb + 854586;
     _printf(gb + 853277 | 0, i9) | 0;
     break L10;
    }
   } while (0);
   HEAP32[i10 >> 2] = 37;
   HEAP32[i10 + 4 >> 2] = gb + 854586;
   _printf(gb + 853343 | 0, i10) | 0;
   i13 = 37;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 854586;
 _printf(gb + 853184 | 0, i7) | 0;
 i13 = 36;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN15RelativeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 76 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function _fullsize_smooth_downsample(i3, i7, i17, i18) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i19 = 0;
 i8 = HEAP32[i7 + 28 >> 2] << 3;
 i6 = i17 + -4 | 0;
 i1 = HEAP32[i3 + 220 >> 2] | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 if ((i1 | 0) > -2 & (i8 - i4 | 0) > 0) {
  i5 = i4 + ~i8 | 0;
  i5 = (i8 | 2) - i4 + ((i5 | 0) > -2 ? i5 : -2) | 0;
  i2 = i1 + 1 | 0;
  i1 = 0;
  while (1) {
   i16 = (HEAP32[i6 + (i1 << 2) >> 2] | 0) + i4 | 0;
   _memset(i16 | 0, HEAP8[i16 + -1 >> 0] | 0, i5 | 0) | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i1 = i1 + 1 | 0;
  }
 }
 i16 = HEAP32[i3 + 180 >> 2] | 0;
 i15 = 65536 - (i16 << 9) | 0;
 i16 = i16 << 6;
 i13 = i7 + 12 | 0;
 if ((HEAP32[i13 >> 2] | 0) <= 0) return;
 i14 = i8 + -2 | 0;
 i9 = i8 + -1 | 0;
 i4 = 0;
 do {
  i10 = HEAP32[i18 + (i4 << 2) >> 2] | 0;
  i12 = HEAP32[i17 + (i4 << 2) >> 2] | 0;
  i5 = HEAP32[i17 + (i4 + -1 << 2) >> 2] | 0;
  i4 = i4 + 1 | 0;
  i8 = HEAP32[i17 + (i4 << 2) >> 2] | 0;
  i7 = i5 + 1 | 0;
  i6 = i8 + 1 | 0;
  i5 = (HEAPU8[i8 >> 0] | 0) + (HEAPU8[i5 >> 0] | 0) | 0;
  i8 = HEAPU8[i12 >> 0] | 0;
  i2 = i5 + i8 | 0;
  i1 = i12 + 1 | 0;
  i3 = (HEAPU8[i6 >> 0] | 0) + (HEAPU8[i7 >> 0] | 0) + (HEAPU8[i1 >> 0] | 0) | 0;
  HEAP8[i10 >> 0] = ((Math_imul(i8, i15) | 0) + 32768 + (Math_imul(i2 + i5 + i3 | 0, i16) | 0) | 0) >>> 16;
  i12 = i12 + i9 | 0;
  i5 = i14;
  i8 = i10;
  while (1) {
   i8 = i8 + 1 | 0;
   i19 = HEAPU8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i7 = i7 + 1 | 0;
   i6 = i6 + 1 | 0;
   i11 = (HEAPU8[i6 >> 0] | 0) + (HEAPU8[i7 >> 0] | 0) + (HEAPU8[i1 >> 0] | 0) | 0;
   HEAP8[i8 >> 0] = ((Math_imul(i19, i15) | 0) + 32768 + (Math_imul(i2 + i3 - i19 + i11 | 0, i16) | 0) | 0) >>> 16;
   i5 = i5 + -1 | 0;
   if (!i5) break; else {
    i2 = i3;
    i3 = i11;
   }
  }
  i19 = HEAPU8[i12 >> 0] | 0;
  HEAP8[i10 + i9 >> 0] = ((Math_imul(i19, i15) | 0) + 32768 + (Math_imul(i3 - i19 + (i11 << 1) | 0, i16) | 0) | 0) >>> 16;
 } while ((i4 | 0) < (HEAP32[i13 >> 2] | 0));
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4readEPwi(i6, i1, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i3 | 0, i6 | 0, 1);
 i2 = __THREW__;
 __THREW__ = 0;
 do if (i2 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i6;
  i3 = i6;
  i4 = 8;
 } else {
  i2 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i2 | 0, HEAP32[i2 + 16 >> 2] | 4 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) i4 = 7; else i4 = 12;
  } else {
   i3 = HEAP32[i2 + 24 >> 2] | 0;
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) i4 = 7; else {
    HEAP32[i5 >> 2] = i1;
    if ((i1 | 0) == (i4 | 0)) i4 = 12; else {
     i5 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 6 | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) i4 = 7; else i4 = 12;
    }
   }
  }
  if ((i4 | 0) == 7) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i2 = i6;
   i3 = i6;
   i4 = 8;
   break;
  } else if ((i4 | 0) == 12) break;
 } while (0);
 do if ((i4 | 0) == 8) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4readEPci(i6, i1, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i3 | 0, i6 | 0, 1);
 i2 = __THREW__;
 __THREW__ = 0;
 do if (i2 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i6;
  i3 = i6;
  i4 = 8;
 } else {
  i2 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i2 | 0, HEAP32[i2 + 16 >> 2] | 4 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) i4 = 7; else i4 = 12;
  } else {
   i3 = HEAP32[i2 + 24 >> 2] | 0;
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) i4 = 7; else {
    HEAP32[i5 >> 2] = i1;
    if ((i1 | 0) == (i4 | 0)) i4 = 12; else {
     i5 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 6 | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) i4 = 7; else i4 = 12;
    }
   }
  }
  if ((i4 | 0) == 7) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i2 = i6;
   i3 = i6;
   i4 = 8;
   break;
  } else if ((i4 | 0) == 12) break;
 } while (0);
 do if ((i4 | 0) == 8) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5Flare12FlareElement8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i3, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 12 | 0, i5);
 i1 = i6 + 28 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 29 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 30 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 31 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 4 | 0;
 i5 = i13;
 i7 = i6 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = (i8 - i1 | 0) / 40 | 0;
 HEAP32[i5 >> 2] = i2;
 i10 = i14 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i14 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i14);
  i3 = i1 + 24 | 0;
  i9 = i1 + 28 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = i5 - i2 >> 2;
  HEAP32[i12 >> 2] = i4;
  i6 = HEAP32[i10 >> 2] | 0;
  i7 = i6 + 4 | 0;
  if (i7 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i4;
   HEAP32[i10 >> 2] = i7;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
   i2 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
  }
  if ((i2 | 0) != (i5 | 0)) do {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i3 + 4 | 0;
   if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 >> 2] = i4;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i5 | 0));
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN13MonoBehaviour14StartCoroutineEPKcP12Il2CppObject(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 28 | 0;
 i9 = i10 + 24 | 0;
 i2 = i10 + 16 | 0;
 i6 = i10;
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  if (!(HEAP32[i3 + 20 >> 2] | 0)) {
   i11 = gb + 1164176 | 0;
   i1 = HEAP32[i11 >> 2] | 0;
   i11 = HEAP32[i11 + 4 >> 2] | 0;
   i2 = i6;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i2 + 4 >> 2] = i11;
  } else {
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i6, HEAP32[(HEAP32[i3 + 56 >> 2] | 0) + 4 >> 2] | 0, i4, 1);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (!i1) {
   HEAP32[i9 >> 2] = i4;
   __Z6FormatPKcz(i8, gb + 587270 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 587199 | 0, 907, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 0;
  } else {
   i9 = i6;
   i11 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = i7;
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = i11;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   i1 = __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i3, i8, i5) | 0;
  }
  i11 = i1;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i11;
 __Z6FormatPKcz(i8, gb + 587676 | 0, i2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 587199 | 0, 900, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i11 = 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 204 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 204 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 204 | 0) * 204 | 0) | 0;
 i7 = i1;
 i4 = i5 + (i4 * 204 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i6 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i3 = i3 + -204 | 0;
   __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i1 + -204 | 0, i3);
   i1 = i2 + -204 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i4;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -204 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + -192 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i13;
 return;
}

function __ZN6Sprite7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i4 = i8;
 i6 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i1, 16, gb + 1048932 | 0, 0, gb + 568578 | 0, 129) | 0;
 i3 = i1;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i6, i7, i2);
 HEAP32[i6 >> 2] = gb + 45276 + 8;
 i1 = i6 + 116 | 0;
 i4 = i6 + 32 | 0;
 i5 = i4 + 84 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 128 >> 2] = Math_fround(0.0);
 HEAP8[i6 + 132 >> 0] = 1;
 i1 = i6 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 412121 | 0, 329) | 0;
 i3 = i2 + 4 | 0;
 i4 = i3;
 i5 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i3 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 45376 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i3 = i7;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i4 = i7;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i2 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 HEAPF32[i6 + 140 >> 2] = Math_fround(100.0);
 HEAP32[i6 + 144 >> 2] = 0;
 HEAP8[i6 + 148 >> 0] = 0;
 i7 = i6 + 152 | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i6 + 156 >> 2] = i7;
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return i6 | 0;
}

function __ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178624 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 178624 + 28 >> 2] | 0) >>> 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 if (__Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i2) | 0) do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = (__Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i2) | 0) + 80 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 } while ((__Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i2) | 0) != 0);
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 12; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 12; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 14;
  }
 }
 if ((i5 | 0) == 12) i5 = 14;
 if ((i5 | 0) == 14) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z19SetupKeyNameMappingv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 12 | 0;
 i7 = i9;
 if (HEAP8[gb + 1546329 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 HEAP8[gb + 1546329 >> 0] = 1;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i4 = HEAP32[gb + 1161932 >> 2] | 0;
 i5 = i4 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 i5 = 0;
 do {
  i4 = HEAP32[gb + 1161932 >> 2] | 0;
  i3 = HEAP32[gb + 59864 + (i5 << 2) >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i3, _strlen(i3) | 0);
  i3 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i4, i6, i7) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i1 = __Znwj(32) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i7);
   HEAP32[i1 + 28 >> 2] = 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   if (!i2) i2 = i1; else {
    HEAP32[i4 >> 2] = i2;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i2);
   i4 = i4 + 8 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  }
  HEAP32[i1 + 28 >> 2] = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 570);
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE8__appendEj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   i9 = i1 + 16 | 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   HEAP32[i9 + 12 >> 2] = 0;
   i1 = (HEAP32[i10 >> 2] | 0) + 32 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i7 = i6 >> 4;
 i5 = i6 >> 5 >>> 0 < 67108863 ? (i7 >>> 0 < i5 >>> 0 ? i5 : i7) : 134217727;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 << 5) | 0;
 i3 = i6 + (i1 - i4 >> 5 << 5) | 0;
 i7 = i3;
 i4 = i6 + (i5 << 5) | 0;
 i6 = i7;
 i1 = i3;
 do {
  i5 = i1 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  i1 = i6 + 32 | 0;
  i6 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i2 = i7; else {
  i5 = i2;
  i2 = i7;
  do {
   i11 = i5;
   i5 = i5 + -32 | 0;
   HEAP32[i3 + -32 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i11 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i11 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i11 + -20 >> 2];
   i7 = i3 + -16 | 0;
   i11 = i11 + -16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
   i3 = i2 + -32 | 0;
   i2 = i3;
  } while ((i5 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i9 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN8Animator30GetEffectiveAnimatorControllerEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i6 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = i6 + 628 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) {
  i3 = i6 + 596 | 0;
  if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i3 >> 2] | 0)) {
   i8 = HEAP32[(HEAP32[i6 + 628 >> 2] | 0) + 20 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 92 >> 2] | 0, i8 | 0, i6 + 584 | 0);
  }
  if (HEAP32[i3 >> 2] | 0) {
   i8 = HEAP32[(HEAP32[HEAP32[i6 + 584 >> 2] >> 2] | 0) + 84 >> 2] | 0;
   i1 = (i8 | 0) == 0 ? i1 : i8;
  }
 }
 i1 = __ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController(i1) | 0;
 if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178256 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 178256 + 28 >> 2] | 0) >>> 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj663ES3_RKNS_19PxVehicleEngineDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _memset(i4 | 0, 0, 148) | 0;
 __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i4);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ES2_RKNS_19PxVehicleEngineDataES6_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_(i6, (i2 | 0) == 0 ? i7 + 172 | 0 : i2, i5, i4);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx13GuMeshFactoryC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 93264 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(.75);
 HEAP32[i2 + 36 >> 2] = -1;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i5, 64);
 i5 = i2 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i2 + 72 >> 2] = Math_fround(.75);
 HEAP32[i2 + 76 >> 2] = -1;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i5, 64);
 i5 = i2 + 88 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i2 + 112 >> 2] = Math_fround(.75);
 HEAP32[i2 + 116 >> 2] = -1;
 HEAP32[i2 + 120 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i5, 64);
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 return;
}

function __ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(f15 - f16);
 f18 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f14 = Math_fround(f18 - f19);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(f13 - f7);
 f3 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f14 * f14)) + Math_fround(f8 * f8));
 i2 = f3 == Math_fround(0.0);
 f9 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f9 - f16);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(f11 - f19);
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(f5 - f7);
 if (i2) {
  f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f12 * f12)) + Math_fround(f6 * f6))));
  return Math_fround(f19);
 }
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f17 * f10) + Math_fround(f14 * f12)) + Math_fround(f8 * f6)) / f3);
 if (f3 < Math_fround(0.0)) {
  f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f12 * f12)) + Math_fround(f6 * f6))));
  return Math_fround(f19);
 }
 if (f3 > Math_fround(1.0)) {
  f17 = Math_fround(f9 - f15);
  f18 = Math_fround(f11 - f18);
  f19 = Math_fround(f5 - f13);
  f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f18 * f18)) + Math_fround(f19 * f19))));
  return Math_fround(f19);
 } else {
  f18 = Math_fround(f9 - Math_fround(f16 + Math_fround(f17 * f3)));
  f19 = Math_fround(f11 - Math_fround(f19 + Math_fround(f14 * f3)));
  f17 = Math_fround(f5 - Math_fround(f7 + Math_fround(f8 * f3)));
  f19 = Math_fround(Math_sqrt(Math_fround(Math_fround(f17 * f17) + Math_fround(Math_fround(f18 * f18) + Math_fround(f19 * f19)))));
  return Math_fround(f19);
 }
 return f0;
}

function __ZN12_GLOBAL__N_115ParamNameLookup9AddArraysEPKNS_22BuiltinArrayParamIndexEj(i14, i15, i16) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + i16 | 0;
 i13 = i14 + 16 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i2 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i2 << 3, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i14 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
  HEAP32[i13 >> 2] = i2;
  HEAP32[i14 >> 2] = i11;
  break;
 } while (0);
 if (!i16) return;
 i4 = i14 + 4 | 0;
 i5 = i14 + 20 | 0;
 i1 = 0;
 do {
  i6 = HEAP32[i15 + (i1 * 12 | 0) >> 2] | 0;
  i7 = i15 + (i1 * 12 | 0) + 8 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 1 | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i11 = i2 & 2147483647;
  do if (i10 >>> 0 > i11 >>> 0) {
   i3 = i2 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i11 >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
    HEAP32[i13 >> 2] = i3;
    HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i3 << 3, 4, i4, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i4, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i12 >> 2] << 3 | 0) | 0;
    HEAP32[i13 >> 2] = i3;
    HEAP32[i14 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i12 >> 2] = i10;
  i11 = (HEAP32[i14 >> 2] | 0) + (i9 << 3) | 0;
  HEAP32[i11 >> 2] = i6;
  HEAP32[i11 + 4 >> 2] = i8;
  HEAP16[(HEAP32[i5 >> 2] | 0) + (HEAP32[i7 >> 2] << 1) >> 1] = HEAP16[i15 + (i1 * 12 | 0) + 4 >> 1] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i16 | 0));
 return;
}

function __ZN11JointLimits8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z38Camera_CUSTOM_INTERNAL_CALL_RaycastTryP12Il2CppObjectRK3Rayfi23QueryTriggerInteraction(i11, i2, f12, i1, i13) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 f12 = Math_fround(f12);
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 48 | 0;
 i9 = i14;
 i10 = __Z19GetRaycastInterfacev() | 0;
 if (f12 < Math_fround(1.1920929e-07) | (i10 | 0) == 0) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(Math_sqrt(Math_fround(f7 + Math_fround(f6 * f6))));
 if (f7 <= Math_fround(HEAPF32[gb + 62452 >> 2])) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 f4 = Math_fround(f4 / f7);
 f5 = Math_fround(f5 / f7);
 f7 = Math_fround(f6 / f7);
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i8 + 12 >> 2] = f4;
 HEAPF32[i8 + 16 >> 2] = f5;
 HEAPF32[i8 + 20 >> 2] = f7;
 i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0;
 if (!i11) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i1) {
  i2 = i11;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 880 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 if (mftCall_iiifiii(i3 | 0, i10 | 0, i8 | 0, +f12, i1 & -5 & HEAP32[i2 + 884 >> 2] | 0, i13 | 0, i9 | 0) | 0) {
  i1 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i9 | 0) | 0;
  if (i1 | 0) {
   i13 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
   STACKTOP = i14;
   return i13 | 0;
  }
 }
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z27GeomOverlapCallback_BoxMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i6 = HEAP32[i3 + 36 >> 2] | 0;
 HEAP32[i7 + 36 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f8 = Math_fround(f12 + f12);
 f10 = Math_fround(f11 + f11);
 f15 = Math_fround(f18 + f18);
 f17 = Math_fround(f11 * f10);
 f16 = Math_fround(f18 * f15);
 f11 = Math_fround(f8 * f11);
 f19 = Math_fround(f8 * f18);
 f9 = Math_fround(f8 * f13);
 f18 = Math_fround(f10 * f18);
 f10 = Math_fround(f10 * f13);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(f11 + f13);
 f14 = Math_fround(f19 - f10);
 f13 = Math_fround(f11 - f13);
 f8 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f8));
 f12 = Math_fround(f8 - f16);
 f11 = Math_fround(f18 + f9);
 f10 = Math_fround(f19 + f10);
 f9 = Math_fround(f18 - f9);
 f8 = Math_fround(f8 - f17);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f17) - f16);
 HEAPF32[i7 + 4 >> 2] = f15;
 HEAPF32[i7 + 8 >> 2] = f14;
 HEAPF32[i7 + 12 >> 2] = f13;
 HEAPF32[i7 + 16 >> 2] = f12;
 HEAPF32[i7 + 20 >> 2] = f11;
 HEAPF32[i7 + 24 >> 2] = f10;
 HEAPF32[i7 + 28 >> 2] = f9;
 HEAPF32[i7 + 32 >> 2] = f8;
 i5 = __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i7, i6 + 32 | 0, i5, i3 + 4 | 0, 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function _LzmaDecode(i5, i14, i9, i10, i2, i1, i12, i15, i17) {
 i5 = i5 | 0;
 i14 = i14 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i17 = i17 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0, i16 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18;
 i6 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i15 >> 2] = 0;
 if (i7 >>> 0 < 5) {
  i17 = 6;
  STACKTOP = i18;
  return i17 | 0;
 }
 i8 = i13 + 20 | 0;
 HEAP32[i8 >> 2] = 0;
 i16 = i13 + 16 | 0;
 HEAP32[i16 >> 2] = 0;
 if (i1 >>> 0 < 5) {
  i17 = 4;
  STACKTOP = i18;
  return i17 | 0;
 }
 i4 = (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0) | (HEAPU8[i2 + 3 >> 0] | 0) << 16 | (HEAPU8[i2 + 4 >> 0] | 0) << 24;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 & 255) > 224) {
  i17 = 4;
  STACKTOP = i18;
  return i17 | 0;
 }
 i2 = ((i1 & 255) % 9 | 0) & 255;
 i3 = ((((i1 & 255) / 9 | 0) & 255) % 5 | 0) & 255;
 i20 = (768 << i3 + i2) + 1846 | 0;
 i11 = i17 + 4 | 0;
 mftCall_vii(HEAP32[i11 >> 2] | 0, i17 | 0, 0);
 i19 = mftCall_iii(HEAP32[i17 >> 2] | 0, i17 | 0, i20 << 1 | 0) | 0;
 HEAP32[i16 >> 2] = i19;
 HEAP32[i13 + 84 >> 2] = i20;
 if (!i19) {
  i20 = 2;
  STACKTOP = i18;
  return i20 | 0;
 }
 HEAP32[i13 >> 2] = i2;
 HEAP32[i13 + 4 >> 2] = i3;
 HEAP32[i13 + 8 >> 2] = ((i1 & 255) / 45 | 0) & 255;
 HEAP32[i13 + 12 >> 2] = i4 >>> 0 < 4096 ? 4096 : i4;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i13 + 40 >> 2] = i6;
 i20 = i13 + 36 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i13 + 76 >> 2] = 1;
 HEAP32[i13 + 72 >> 2] = 0;
 HEAP32[i13 + 88 >> 2] = 0;
 HEAP32[i13 + 44 >> 2] = 0;
 HEAP32[i13 + 48 >> 2] = 0;
 HEAP32[i13 + 80 >> 2] = 1;
 HEAP32[i10 >> 2] = i7;
 i1 = _LzmaDec_DecodeToDic(i13, i6, i9, i10, i12, i15) | 0;
 HEAP32[i14 >> 2] = HEAP32[i20 >> 2];
 if (!i1) i1 = (HEAP32[i15 >> 2] | 0) == 3 ? 6 : 0;
 mftCall_vii(HEAP32[i11 >> 2] | 0, i17 | 0, HEAP32[i16 >> 2] | 0);
 HEAP32[i16 >> 2] = 0;
 i20 = i1;
 STACKTOP = i18;
 return i20 | 0;
}

function __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i1, i2, f7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = HEAP32[i1 + 68 >> 2] | 0;
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 L1 : do if ((i4 | 0) == -1) {
  i5 = 0;
  i1 = i10;
 } else {
  f3 = Math_fround(HEAPF32[i6 + (i4 << 4) >> 2]);
  if (f3 < f7) {
   i1 = i4 + 1 | 0;
   if ((i1 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]) > f7) {
    i2 = i1;
    i1 = i4;
   } else i5 = 6; else i5 = 6;
   do if ((i5 | 0) == 6) {
    i2 = i4 + 2 | 0;
    if ((i2 | 0) < (i10 | 0)) if (Math_fround(HEAPF32[i6 + (i2 << 4) >> 2]) > f7) break;
    i1 = i4 + 3 | 0;
    if ((i1 | 0) >= (i10 | 0)) {
     i5 = 0;
     i1 = i10;
     break L1;
    }
    if (Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]) > f7) {
     i2 = i1;
     i1 = i4 + 2 | 0;
    } else {
     i5 = 0;
     i1 = i10;
     break L1;
    }
   } while (0);
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i2 | 0) ? i10 : i2;
   return;
  } else {
   if ((i4 | 0) > -1) if (!(f3 <= f7)) {
    i1 = i4 + -1 | 0;
    if ((i4 | 0) <= 0) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]) <= f7)) i5 = 21;
   } else i1 = i4; else i5 = 21;
   if ((i5 | 0) == 21) {
    i1 = i4 + -2 | 0;
    if ((i1 | 0) <= -1) {
     i5 = 0;
     i1 = i10;
     break;
    }
    if (!(Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]) <= f7)) {
     i5 = 0;
     i1 = i10;
     break;
    }
   }
   i6 = i1 + 1 | 0;
   i10 = i10 + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = (i10 | 0) < (i6 | 0) ? i10 : i6;
   return;
  }
 } while (0);
 L25 : while (1) {
  while (1) {
   if ((i1 | 0) <= 0) break L25;
   i2 = i1 >> 1;
   i4 = i2 + i5 | 0;
   if (Math_fround(HEAPF32[i6 + (i4 << 4) >> 2]) > f7) i1 = i2; else break;
  }
  i5 = i4 + 1 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 HEAP32[i8 >> 2] = i5 + -1;
 i10 = i10 + -1 | 0;
 HEAP32[i9 >> 2] = (i5 | 0) < (i10 | 0) ? i5 : i10;
 return;
}

function __ZN8WindZone8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034151 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, i6, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 486995 | 0, i6, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 487006 | 0, i6, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 487023 | 0, i6, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 487044 | 0, i6, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13MonoBehaviour16CallUpdateMethodEi(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 248 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 i1 = HEAP32[i7 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 36 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 i6 = i7 + 20 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i4) {
  STACKTOP = i11;
  return;
 }
 i1 = i7 + 141 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  i3 = i7 + 60 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i2 + 96 >> 2] | 0;
  if (i1) {
   i2 = HEAPU8[i2 + 100 >> 0] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i7, i10, 0) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i1 = HEAP32[i2 + 88 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAPU8[i2 + 92 >> 0] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i9 + 4 >> 2] = i3;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i7, i10, 0) | 0;
  }
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i7 + 60 >> 2] | 0;
 i3 = HEAP32[i1 + (i5 << 3) >> 2] | 0;
 i1 = HEAP32[i1 + (i5 << 3) + 4 >> 2] | 0;
 if (i3 | 0) {
  i2 = HEAP32[i7 + 28 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
   i6 = HEAP32[i6 >> 2] | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i9 + 4 >> 2] = i1;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i8, i6, i10);
   HEAP32[i8 + 216 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i10 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i8, i10, 0) | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function ___stdio_write(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 16 | 0;
 i10 = i15;
 i7 = i15 + 32 | 0;
 i13 = i12 + 28 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 HEAP32[i7 >> 2] = i6;
 i14 = i12 + 20 | 0;
 i6 = (HEAP32[i14 >> 2] | 0) - i6 | 0;
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i7 + 8 >> 2] = i2;
 HEAP32[i7 + 12 >> 2] = i1;
 i8 = i12 + 60 | 0;
 i9 = i12 + 44 | 0;
 i5 = 2;
 i2 = i6 + i1 | 0;
 while (1) {
  if (!(HEAP32[gb + 1469464 >> 2] | 0)) {
   HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i11 + 4 >> 2] = i7;
   HEAP32[i11 + 8 >> 2] = i5;
   i4 = ___syscall_ret(___syscall146(146, i11 | 0) | 0) | 0;
  } else {
   _pthread_cleanup_push(fb + 3990 | 0, i12 | 0);
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = i7;
   HEAP32[i10 + 8 >> 2] = i5;
   i4 = ___syscall_ret(___syscall146(146, i10 | 0) | 0) | 0;
   _pthread_cleanup_pop(0);
  }
  if ((i2 | 0) == (i4 | 0)) {
   i2 = 6;
   break;
  }
  if ((i4 | 0) < 0) {
   i2 = 8;
   break;
  }
  i2 = i2 - i4 | 0;
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  if (i4 >>> 0 > i3 >>> 0) {
   i6 = HEAP32[i9 >> 2] | 0;
   HEAP32[i13 >> 2] = i6;
   HEAP32[i14 >> 2] = i6;
   i4 = i4 - i3 | 0;
   i5 = i5 + -1 | 0;
   i6 = i7 + 8 | 0;
   i3 = HEAP32[i7 + 12 >> 2] | 0;
  } else if ((i5 | 0) == 2) {
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i4;
   i5 = 2;
   i6 = i7;
  } else i6 = i7;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
  HEAP32[i6 + 4 >> 2] = i3 - i4;
  i7 = i6;
 }
 if ((i2 | 0) == 6) {
  i11 = HEAP32[i9 >> 2] | 0;
  HEAP32[i12 + 16 >> 2] = i11 + (HEAP32[i12 + 48 >> 2] | 0);
  i12 = i11;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i14 >> 2] = i12;
 } else if ((i2 | 0) == 8) {
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | 32;
  if ((i5 | 0) == 2) i1 = 0; else i1 = i1 - (HEAP32[i7 + 4 >> 2] | 0) | 0;
 }
 STACKTOP = i15;
 return i1 | 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_(i11, i5, i6) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = _strlen(i5) | 0;
 i8 = i6 + 11 | 0;
 i10 = HEAP8[i8 >> 0] | 0;
 i10 = i10 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i10 & 255;
 i3 = i10 + i7 | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i2 >> 2] | 0;
  i9 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i7;
  i1 = i11;
 } else i9 = 5;
 if ((i9 | 0) == 5) {
  i9 = i3 + 16 & -16;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = i11 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i10 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i10 - i3 + i1 | 0, i1, i1, 0, i10, i4);
  STACKTOP = i12;
  return;
 }
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 if (i2) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
 _memcpy(i2 + i1 | 0, i4 | 0, i10 | 0) | 0;
 i1 = i1 + i10 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN18AnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(212, i1, 16, gb + 1048932 | 0, 0, gb + 910197 | 0, 54) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 178116 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = i5;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i4 + 84 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP8[i4 + 100 >> 0] = 1;
 HEAP32[i4 + 104 >> 2] = gb + 176376 + 8;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = 4096;
 HEAP32[i4 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i6 = i4 + 144 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 + 148 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = i6;
 HEAP8[i4 + 152 >> 0] = 1;
 i6 = i4 + 160 | 0;
 HEAP32[i4 + 184 >> 2] = 0;
 HEAP32[i4 + 188 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 176 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 192 >> 2] = 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i4 + 208 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 196 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN19ControllerHitReport5onHitERKN5physx15PxControllerHitEP8Collider(i3, i5, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0) + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (!(__ZN10GameObject17WillHandleMessageERK17MessageIdentifier(i1, gb + 1105416 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = i4;
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorIN19ControllerHitReport29RecordedControllerColliderHitENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 4 | 0, i4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i2 + 32 >> 2] = HEAP32[i4 + 32 >> 2];
  HEAP32[i2 + 36 >> 2] = HEAP32[i4 + 36 >> 2];
  HEAP32[i2 + 40 >> 2] = 0;
  i4 = i2 + 44 | 0;
  HEAP32[i1 >> 2] = i4;
  i1 = i4;
 }
 f10 = Math_fround(+HEAPF64[i5 + 8 >> 3]);
 f9 = Math_fround(+HEAPF64[i5 + 16 >> 3]);
 f8 = Math_fround(+HEAPF64[i5 + 24 >> 3]);
 HEAPF32[i1 + -40 >> 2] = f10;
 HEAPF32[i1 + -36 >> 2] = f9;
 HEAPF32[i1 + -32 >> 2] = f8;
 i4 = i1 + -28 | 0;
 i3 = i5 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i4 = i1 + -16 | 0;
 i3 = i5 + 44 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + -4 >> 2] = HEAP32[i5 + 56 >> 2];
 HEAP32[i1 + -44 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZN16SpriteRenderData11SetVerticesEPK12SpriteVertexj(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = i1 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 i2 = i1 + 8 | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = i8;
 i4 = i1 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i8 >>> 0) {
  i8 = i8 * 20 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i8;
  i8 = i8 * 20 | 0;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i8, 4, i1 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i6;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i5 = i8 * 20 | 0;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 4, i1 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i2 >> 2] = i6;
  i8 = i5;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZL22Transfer_ManagedObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 40 | 0;
 i7 = i11;
 i8 = i11 + 28 | 0;
 i3 = i11 + 8 | 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 28 >> 2];
 i4 = HEAP32[i2 + 44 >> 2] | 0;
 i5 = (HEAP32[i1 + 16 >> 2] | 0) + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = i6 + (i4 << 6) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 8 >> 2] = i1;
 i1 = i4 << 6 >> 6;
 HEAP32[i3 + 16 >> 2] = i1;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i3;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = i9 + 36 | 0;
 HEAP8[i4 >> 0] = 0;
 if (!((i3 & 524288 | 0) == 0 | (HEAP32[i9 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 40 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if (!i6) {
   STACKTOP = i11;
   return;
  }
  if ((HEAP32[i6 + 16 >> 2] | 0) != 3) {
   STACKTOP = i11;
   return;
  }
 }
 i12 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i9, i6, i1) | 0;
 HEAP32[i5 >> 2] = i12;
 i1 = i9 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 36956 >> 2];
 if (i12 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i9, i3);
  i13 = i9 + 8 | 0;
  i3 = HEAP32[i13 + 4 >> 2] | 0;
  i12 = i7;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = i3;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN8JSONRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_10MemLabelId17TransferMetaFlags(i9, i8, i10, 0);
  HEAP8[i4 >> 0] = 1;
  i12 = i9 + 56 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 }
 HEAP32[i5 >> 2] = i6;
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i11;
 return;
}

function __ZN8Animator12SetFloatDampEifff(i9, i11, f4, f6, f7) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 f4 = Math_fround(f4);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i8 = i13 + 8 | 0;
 HEAPF32[i12 >> 2] = f4;
 i10 = i9 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i10) | 0)) {
  i12 = 64;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (f6 > Math_fround(0.0)) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i5 = i8 + 4 | 0;
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i2 = i9 + 596 | 0;
  if (__ZNK9HPlayable7IsValidEv(i10) | 0) if (!(HEAP32[i2 >> 2] | 0)) {
   i3 = HEAP32[(HEAP32[i9 + 628 >> 2] | 0) + 20 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i9 + 584 | 0);
  }
  i3 = i9 + 584 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   do {
    i14 = HEAP32[i1 >> 2] | 0;
    mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 136 >> 2] | 0, i14 | 0, i11 | 0, i5 | 0) | 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
   f4 = Math_fround(HEAPF32[i12 >> 2]);
  }
  HEAPF32[i8 >> 2] = f6;
  __ZN7mecanim8dynamics8ScalDamp8EvaluateEff(i8, f4, f7);
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 }
 if (!(__ZNK9HPlayable7IsValidEv(i10) | 0)) {
  i14 = 64;
  STACKTOP = i13;
  return i14 | 0;
 }
 i5 = i9 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i10) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i14 = HEAP32[(HEAP32[i9 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 92 >> 2] | 0, i14 | 0, i9 + 584 | 0);
 }
 i3 = i9 + 584 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i14 = 0;
  STACKTOP = i13;
  return i14 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i14 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 140 >> 2] | 0, i14 | 0, i11 | 0, i12 | 0) | 0 | i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_(i11, i5, i6) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i2 = i11 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = _strlen(i5) | 0;
 i8 = i6 + 11 | 0;
 i10 = HEAP8[i8 >> 0] | 0;
 i10 = i10 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i10 & 255;
 i3 = i10 + i7 | 0;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i2 >> 2] | 0;
  i9 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i7;
  i1 = i11;
 } else i9 = 5;
 if ((i9 | 0) == 5) {
  i9 = i3 + 16 & -16;
  HEAP32[i4 >> 2] = 1;
  HEAP32[i4 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = i11 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i10 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i10 - i3 + i1 | 0, i1, i1, 0, i10, i4);
  STACKTOP = i12;
  return;
 }
 if (!i10) {
  STACKTOP = i12;
  return;
 }
 if (i2) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
 _memcpy(i2 + i1 | 0, i4 | 0, i10 | 0) | 0;
 i1 = i1 + i10 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 172 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 172 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 172 | 0) * 172 | 0) | 0;
 i7 = i1;
 i4 = i5 + (i4 * 172 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i6 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i3 = i3 + -172 | 0;
   __ZN13AnimationClip12Vector3CurveC2ERKS0_(i1 + -172 | 0, i3);
   i1 = i2 + -172 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i4;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -172 | 0;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + -160 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i6) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i12);
 STACKTOP = i13;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = HEAP32[i1 + 12 >> 2] | 0;
 i7 = (i6 >>> 0) / 3 | 0;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i4 = (i7 >>> 0) / (i3 >>> 0) | 0;
 i5 = (i7 >>> 0) % (i3 >>> 0) | 0;
 switch ((Math_imul(i7, -3) | 0) + i6 | 0) {
 case 0:
  {
   if (i5 >>> 0 < (i3 + -1 | 0) >>> 0) {
    if (!i4) i1 = 0; else {
     i1 = i7 - i3 | 0;
     HEAP32[i9 >> 2] = (i1 << 1 | 1) - ((HEAPU8[(HEAP32[i8 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >>> 7 & 255);
     i1 = 1;
    }
    if (i4 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0) {
     HEAP32[i9 + (i1 << 2) >> 2] = (HEAPU8[(HEAP32[i8 + 36 >> 2] | 0) + (i7 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i7 << 1;
     i4 = i1 + 1 | 0;
    } else i4 = i1;
   } else i4 = 0;
   break;
  }
 case 1:
  {
   if (i5 >>> 0 < (i3 + -1 | 0) >>> 0 ? i4 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0 : 0) {
    i4 = i7 << 1;
    HEAP32[i9 >> 2] = i4;
    HEAP32[i9 + 4 >> 2] = i4 | 1;
    i4 = 2;
   } else i4 = 0;
   break;
  }
 case 2:
  {
   if (i4 >>> 0 < ((HEAP32[i2 >> 2] | 0) + -1 | 0) >>> 0) {
    if (!i5) i1 = 0; else {
     HEAP32[i9 >> 2] = (i7 << 1) + -1;
     i1 = 1;
    }
    if (i5 >>> 0 < (i3 + -1 | 0) >>> 0) {
     HEAP32[i9 + (i1 << 2) >> 2] = i7 << 1;
     i4 = i1 + 1 | 0;
    } else i4 = i1;
   } else i4 = 0;
   break;
  }
 default:
  i4 = 0;
 }
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = i3 >>> 1;
 i1 = HEAP32[i8 + 36 >> 2] | 0;
 i2 = (HEAP8[((i3 & 1 | 0) == 0 ? i1 + (i2 << 2) + 2 | 0 : i1 + (i2 << 2) + 3 | 0) >> 0] & 127) != 127;
 if (i4 >>> 0 <= 1) {
  i9 = i2 ? i3 : -1;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (i2) {
  i9 = i3;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i8 = i9 >>> 1;
  STACKTOP = i10;
  return ((HEAP8[((i9 & 1 | 0) == 0 ? i1 + (i8 << 2) + 2 | 0 : i1 + (i8 << 2) + 3 | 0) >> 0] & 127) == 127 ? -1 : i9) | 0;
 }
 return 0;
}

function __ZN5physx20PxJointGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 756565;
 HEAP32[i1 + 4 >> 2] = 409;
 HEAP32[i1 + 8 >> 2] = gb + 771563;
 HEAP32[i1 + 12 >> 2] = gb + 771570;
 HEAP32[i1 + 16 >> 2] = fb + 777;
 HEAP32[i1 + 20 >> 2] = fb + 778;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 410;
 HEAP32[i1 + 32 >> 2] = fb + 779;
 HEAP32[i1 + 36 >> 2] = fb + 780;
 HEAP32[i1 + 40 >> 2] = gb + 741441;
 HEAP32[i1 + 44 >> 2] = 411;
 HEAP32[i1 + 48 >> 2] = fb + 3550;
 HEAP32[i1 + 52 >> 2] = gb + 741459;
 HEAP32[i1 + 56 >> 2] = 412;
 HEAP32[i1 + 60 >> 2] = fb + 3551;
 HEAP32[i1 + 64 >> 2] = gb + 741482;
 HEAP32[i1 + 68 >> 2] = 413;
 HEAP32[i1 + 72 >> 2] = fb + 3552;
 HEAP32[i1 + 76 >> 2] = gb + 771577;
 HEAP32[i1 + 80 >> 2] = 414;
 HEAP32[i1 + 84 >> 2] = gb + 1048292;
 HEAP32[i1 + 88 >> 2] = gb + 741506;
 HEAP32[i1 + 92 >> 2] = fb + 17;
 HEAP32[i1 + 96 >> 2] = fb + 781;
 HEAP32[i1 + 100 >> 2] = gb + 741513;
 HEAP32[i1 + 104 >> 2] = 415;
 HEAP32[i1 + 108 >> 2] = fb + 2159;
 HEAP32[i1 + 112 >> 2] = fb + 3553;
 HEAP32[i1 + 116 >> 2] = gb + 741529;
 HEAP32[i1 + 120 >> 2] = 416;
 HEAP32[i1 + 124 >> 2] = fb + 423;
 HEAP32[i1 + 128 >> 2] = fb + 366;
 HEAP32[i1 + 132 >> 2] = gb + 741543;
 HEAP32[i1 + 136 >> 2] = 417;
 HEAP32[i1 + 140 >> 2] = fb + 424;
 HEAP32[i1 + 144 >> 2] = fb + 367;
 HEAP32[i1 + 148 >> 2] = gb + 741560;
 HEAP32[i1 + 152 >> 2] = 418;
 HEAP32[i1 + 156 >> 2] = fb + 425;
 HEAP32[i1 + 160 >> 2] = fb + 368;
 HEAP32[i1 + 164 >> 2] = gb + 741574;
 HEAP32[i1 + 168 >> 2] = 419;
 HEAP32[i1 + 172 >> 2] = fb + 426;
 HEAP32[i1 + 176 >> 2] = fb + 369;
 HEAP32[i1 + 180 >> 2] = gb + 741591;
 HEAP32[i1 + 184 >> 2] = 420;
 HEAP32[i1 + 188 >> 2] = fb + 2160;
 HEAP32[i1 + 192 >> 2] = gb + 741602;
 HEAP32[i1 + 196 >> 2] = 421;
 HEAP32[i1 + 200 >> 2] = fb + 2161;
 HEAP32[i1 + 204 >> 2] = fb + 3554;
 HEAP32[i1 + 208 >> 2] = gb + 741607;
 HEAP32[i1 + 212 >> 2] = 422;
 HEAP32[i1 + 216 >> 2] = fb + 2162;
 HEAP32[i1 + 220 >> 2] = gb + 741613;
 HEAP32[i1 + 224 >> 2] = 423;
 HEAP32[i1 + 228 >> 2] = fb + 2163;
 HEAP32[i1 + 232 >> 2] = fb + 3555;
 return;
}

function __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i10, i7, i3) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = HEAP8[i10 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 if (i9) {
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
 } else {
  i2 = i8 & 255;
  i5 = i10;
 }
 if (i2 >>> 0 <= i7 >>> 0) {
  i10 = i7;
  return i10 | 0;
 }
 i1 = i5 + i7 | 0;
 i6 = i5 + i2 | 0;
 i4 = i6;
 L8 : do if ((i2 | 0) == (i7 | 0) | (i4 - i1 | 0) < 1) i1 = i4; else while (1) {
  if ((HEAP8[i1 >> 0] | 0) == 47) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i6 | 0)) {
   i1 = i4;
   break L8;
  }
 } while (0);
 i2 = (i1 | 0) == (i6 | 0) ? -1 : i1 - i5 | 0;
 if ((i3 | 0) == 0 | (i2 | 0) == -1) {
  i10 = i7;
  return i10 | 0;
 }
 i7 = i8 & 255;
 if (i9) {
  i8 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i5 = i8 + i4 | 0;
  i6 = i5;
  i7 = i8;
  while (1) {
   i3 = i3 + -1 | 0;
   i1 = i2 + 1 | 0;
   if (i4 >>> 0 <= i1 >>> 0) {
    i2 = 19;
    break;
   }
   i2 = i8 + i1 | 0;
   L22 : do if ((i4 | 0) == (i1 | 0) | (i6 - i2 | 0) < 1) i2 = i6; else while (1) {
    if ((HEAP8[i2 >> 0] | 0) == 47) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i5 | 0)) {
     i2 = i6;
     break L22;
    }
   } while (0);
   i2 = (i2 | 0) == (i5 | 0) ? -1 : i2 - i7 | 0;
   if ((i3 | 0) == 0 | (i2 | 0) == -1) {
    i2 = 19;
    break;
   }
  }
  if ((i2 | 0) == 19) return i1 | 0;
 } else {
  i4 = i10 + i7 | 0;
  i5 = i4;
  i6 = i10;
  while (1) {
   i3 = i3 + -1 | 0;
   i1 = i2 + 1 | 0;
   if (i7 >>> 0 <= i1 >>> 0) {
    i2 = 19;
    break;
   }
   i2 = i10 + i1 | 0;
   L35 : do if ((i7 | 0) == (i1 | 0) | (i5 - i2 | 0) < 1) i2 = i5; else while (1) {
    if ((HEAP8[i2 >> 0] | 0) == 47) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) {
     i2 = i5;
     break L35;
    }
   } while (0);
   i2 = (i2 | 0) == (i4 | 0) ? -1 : i2 - i6 | 0;
   if ((i3 | 0) == 0 | (i2 | 0) == -1) {
    i2 = 19;
    break;
   }
  }
  if ((i2 | 0) == 19) return i1 | 0;
 }
 return 0;
}

function __Z38UnityAnalyticsHandler_CUSTOM_SetUserIdP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 40 | 0;
 i3 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (__ZNK11ICallString6IsNullEv(i3) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038841 | 0, i10);
 if (!i1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i9, i3);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 8;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i6 = 10;
  }
 } else i6 = 8;
 if ((i6 | 0) == 8) {
  i2 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i6 = 10;
 }
 if ((i6 | 0) == 10) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZN14UnityAnalytics9SetUserIdERK8UnityStr(i5, i8) | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z23InitPlayerLoopCallbacksv() {
 HEAP32[gb + 1115296 + 4 >> 2] = fb + 130;
 HEAP32[gb + 1115296 >> 2] = fb + 131;
 HEAP32[gb + 1115296 + 20 >> 2] = fb + 132;
 HEAP32[gb + 1115296 + 24 >> 2] = fb + 133;
 HEAP32[gb + 1115296 + 28 >> 2] = fb + 134;
 HEAP32[gb + 1115296 + 44 >> 2] = fb + 135;
 HEAP32[gb + 1115296 + 48 >> 2] = fb + 136;
 HEAP32[gb + 1115296 + 56 >> 2] = fb + 137;
 HEAP32[gb + 1115296 + 60 >> 2] = fb + 138;
 HEAP32[gb + 1115296 + 64 >> 2] = fb + 139;
 HEAP32[gb + 1115296 + 68 >> 2] = fb + 140;
 HEAP32[gb + 1115296 + 72 >> 2] = fb + 141;
 HEAP32[gb + 1115296 + 76 >> 2] = fb + 142;
 HEAP32[gb + 1115296 + 80 >> 2] = fb + 143;
 HEAP32[gb + 1115296 + 92 >> 2] = fb + 144;
 HEAP32[gb + 1115296 + 128 >> 2] = fb + 145;
 HEAP32[gb + 1115296 + 180 >> 2] = fb + 146;
 HEAP32[gb + 1115296 + 368 >> 2] = fb + 147;
 HEAP32[gb + 1115296 + 188 >> 2] = fb + 148;
 HEAP32[gb + 1115296 + 252 >> 2] = fb + 149;
 HEAP32[gb + 1115296 + 260 >> 2] = fb + 150;
 HEAP32[gb + 1115296 + 292 >> 2] = fb + 151;
 HEAP32[gb + 1115296 + 300 >> 2] = fb + 152;
 HEAP32[gb + 1115296 + 316 >> 2] = fb + 153;
 HEAP32[gb + 1115296 + 320 >> 2] = fb + 154;
 HEAP32[gb + 1115296 + 324 >> 2] = fb + 155;
 HEAP32[gb + 1115296 + 328 >> 2] = fb + 156;
 HEAP32[gb + 1115296 + 332 >> 2] = fb + 157;
 HEAP32[gb + 1115296 + 392 >> 2] = fb + 158;
 HEAP32[gb + 1115296 + 336 >> 2] = fb + 159;
 HEAP32[gb + 1115296 + 340 >> 2] = fb + 160;
 HEAP32[gb + 1115296 + 344 >> 2] = fb + 161;
 HEAP32[gb + 1115296 + 352 >> 2] = fb + 162;
 HEAP32[gb + 1115296 + 356 >> 2] = fb + 163;
 HEAP32[gb + 1115296 + 360 >> 2] = fb + 164;
 HEAP32[gb + 1115296 + 364 >> 2] = fb + 165;
 HEAP32[gb + 1115296 + 376 >> 2] = fb + 166;
 HEAP32[gb + 1115296 + 380 >> 2] = fb + 167;
 HEAP32[gb + 1115296 + 388 >> 2] = fb + 168;
 HEAP32[gb + 1115296 + 104 >> 2] = fb + 169;
 HEAP32[gb + 1115296 + 140 >> 2] = fb + 170;
 HEAP32[gb + 1115296 + 168 >> 2] = fb + 171;
 HEAP32[gb + 1115296 + 200 >> 2] = fb + 172;
 HEAP32[gb + 1115296 + 208 >> 2] = fb + 173;
 HEAP32[gb + 1115296 + 272 >> 2] = fb + 174;
 HEAP32[gb + 1115296 + 248 >> 2] = fb + 175;
 return;
}

function __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEC2INS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEET_NS_9enable_ifIXaasr21__is_forward_iteratorISG_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISG_E9referenceEEE5valueESG_E4typeE(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 16 | 0;
 i9 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i13 = i15;
 HEAP32[i11 >> 2] = 0;
 i14 = i11 + 4 | 0;
 HEAP32[i14 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 + 12 >> 2] = i7;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i1 = i7;
 i7 = i3;
 i8 = i5;
 if ((i3 | 0) == (i5 | 0)) {
  STACKTOP = i15;
  return;
 }
 i4 = 0;
 while (1) {
  i6 = i4 + 1 | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i5 | 0)) break; else {
   i4 = i6;
   i3 = i2;
  }
 }
 if ((i4 | 0) < -1) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 + 12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i1;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i14 >> 2] = i5;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i11 + 8 >> 2] = i5 + (i6 << 2);
 HEAP32[i12 >> 2] = i7;
 HEAP32[i13 >> 2] = i8;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE18__construct_at_endINS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESH_SH_j(i11, i9, i10, i6);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 5) + 1 | 0;
 if (i3 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i5 = i7 >> 4;
 i5 = i7 >> 5 >>> 0 < 67108863 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 134217727;
 i1 = i2 - i1 >> 5;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 << 5) | 0;
 i2 = i4 + (i1 << 5) | 0;
 i3 = i2;
 i7 = i4 + (i5 << 5) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + (i1 << 5) + 20 >> 2] = 0;
 i12 = i6 + 24 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = i4 + (i1 << 5) + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i11;
 HEAP8[i4 + (i1 << 5) + 4 >> 0] = 0;
 __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i6);
 i6 = i2 + 32 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i5 = i4;
  i1 = i4;
 } else {
  do {
   i12 = i2 + -32 | 0;
   HEAP32[i12 >> 2] = 0;
   HEAP32[i2 + -12 >> 2] = 0;
   i13 = i1 + -8 | 0;
   i1 = i1 + -32 | 0;
   i5 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i2 + -8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i5;
   HEAP8[i2 + -28 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i12, i1);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -32 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -28 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE(i5, i7, i6) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 20, 4) | 0;
 i3 = i8 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = i5;
 i3 = i8 + 4 | 0;
 i4 = (i5 | 0) == 0;
 if (i4) i1 = 0; else {
  i2 = i5 << 3;
  i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i5 << 3) | 0)) _memset(i1 | 0, -1, i2 | 0) | 0;
 }
 HEAP32[i3 >> 2] = i1 | 0 ? i1 - i3 | 0 : 0;
 i3 = i8 + 8 | 0;
 if (i4) i1 = 0; else {
  i2 = i5 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i5 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 HEAP32[i3 >> 2] = i1 | 0 ? i1 - i3 | 0 : 0;
 HEAP32[i8 + 12 >> 2] = i7;
 if (!i7) return i8 | 0;
 i4 = i8 + 16 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i7 * 76 | 0, 4) | 0;
 i2 = i3 + (i7 * 76 | 0) | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i1 = i3;
  do {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
   HEAPF32[i1 + 60 >> 2] = Math_fround(-1.0);
   HEAPF32[i1 + 64 >> 2] = Math_fround(-1.0);
   HEAP32[i1 + 68 >> 2] = 1065353216;
   HEAP32[i1 + 72 >> 2] = 3;
   i1 = i1 + 76 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 return i8 | 0;
}

function __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb(i1, i2, i3, i8, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 8 | 0;
 i12 = i11;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 71752 + 8;
 i6 = i2;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i1 + 8 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i2;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i1 + 28 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i1 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i1 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 + 4 >> 2] = i12;
 i5 = (i8 | 0) != 0;
 if ((i3 | 0) != 0 & i5) {
  if ((HEAP32[i9 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i10);
   HEAP32[i6 >> 2] = 0;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i9 >> 2] = i8 | -2147483648;
  HEAP32[i6 >> 2] = i3;
  if (!i4) {
   STACKTOP = i11;
   return;
  }
  HEAP32[i9 >> 2] = i8 & 2147483647;
  __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i3, i2, __Z18get_root_referencePvRK10MemLabelId(i1, i2) | 0);
  STACKTOP = i11;
  return;
 }
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 & 2147483647) >>> 0 >= i8 >>> 0) {
  STACKTOP = i11;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i8;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i8, 1, i10, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i11;
  return;
 } else {
  i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 1, i10, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i13 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i6 >> 2] = i13;
  STACKTOP = i11;
  return;
 }
}

function __Z20GUIStyle_CUSTOM_InitP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = __Znwj(296) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 32 >> 2] = Math_fround(1.0);
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 52 >> 2] = Math_fround(1.0);
 i1 = i4 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 i1 = i4 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 92 >> 2] = Math_fround(1.0);
 i1 = i4 + 96 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 112 >> 2] = Math_fround(1.0);
 i1 = i4 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 132 >> 2] = Math_fround(1.0);
 i1 = i4 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 152 >> 2] = Math_fround(1.0);
 i1 = i4 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i4 + 172 >> 2] = Math_fround(1.0);
 i1 = i4 + 176 | 0;
 i2 = i4 + 249 | 0;
 i5 = i1;
 i6 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i1 = i4 + 292 | 0;
 i5 = i4 + 252 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i1 >> 0] = 1;
 HEAP8[i4 + 293 >> 0] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 return;
}

function __ZNK5physx14NpSpatialIndex5sweepERKNS_9PxBounds3ERKNS_6PxVec3EfRNS_25PxSpatialLocationCallbackE(i1, i5, i10, f2, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 f2 = Math_fround(f2);
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 56 | 0;
 i8 = i12 + 48 | 0;
 i6 = i12 + 32 | 0;
 i11 = i12;
 i9 = i12 + 64 | 0;
 HEAPF32[i4 >> 2] = f2;
 i3 = i1 + 4 | 0;
 i1 = i1 + 8 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i13 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0);
 }
 HEAP8[i3 >> 0] = 0;
 HEAP32[i8 >> 2] = gb + 107584 + 8;
 HEAP32[i8 + 4 >> 2] = i7;
 f15 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f18 = Math_fround(HEAPF32[i5 >> 2]);
 f21 = Math_fround(f15 - f18);
 f14 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f20 = Math_fround(f14 - f17);
 f2 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f21 = Math_fround(f21 * Math_fround(.5));
 f20 = Math_fround(f20 * Math_fround(.5));
 f19 = Math_fround(Math_fround(f2 - f16) * Math_fround(.5));
 HEAP32[i6 >> 2] = 3;
 HEAPF32[i6 + 4 >> 2] = f21;
 HEAPF32[i6 + 8 >> 2] = f20;
 HEAPF32[i6 + 12 >> 2] = f19;
 f15 = Math_fround(Math_fround(f18 + f15) * Math_fround(.5));
 f14 = Math_fround(Math_fround(f17 + f14) * Math_fround(.5));
 f2 = Math_fround(Math_fround(f16 + f2) * Math_fround(.5));
 HEAPF32[i11 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i11 + 16 >> 2] = f15;
 HEAPF32[i11 + 20 >> 2] = f14;
 HEAPF32[i11 + 24 >> 2] = f2;
 __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i9, i6, i11, Math_fround(0.0));
 i13 = HEAP32[i1 >> 2] | 0;
 mftCall_iiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0, i9 | 0, i10 | 0, i4 | 0, i8 | 0) | 0;
 STACKTOP = i12;
 return;
}

function __ZN9Texture2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 416577 | 0, 102) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i4 + 32 | 0);
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAPF32[i4 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 76 >> 2] = 1;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 45572 + 8;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = -1;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 i2 = i4 + 116 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 120 | 0;
 i5 = i4 + 128 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = 0;
 HEAP32[i4 + 148 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP8[i4 + 108 >> 0] = 1;
 HEAP8[i4 + 111 >> 0] = 1;
 HEAP8[i4 + 112 >> 0] = 0;
 HEAP8[i4 + 109 >> 0] = 0;
 HEAP8[i4 + 110 >> 0] = 0;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5Unity11Adjacencies10UpdateLinkEjjjj(i1, i8, i9, i5, i6) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = HEAP32[i7 + (i8 * 24 | 0) >> 2] | 0;
 i2 = (i1 | 0) == (i5 | 0);
 if (i2) if ((HEAP32[i7 + (i8 * 24 | 0) + 4 >> 2] | 0) == (i6 | 0)) i3 = 0; else i4 = 3; else i4 = 3;
 do if ((i4 | 0) == 3) {
  i1 = (i1 | 0) == (i6 | 0);
  if (i1) if ((HEAP32[i7 + (i8 * 24 | 0) + 4 >> 2] | 0) == (i5 | 0)) {
   i3 = 0;
   break;
  }
  if (i2) if ((HEAP32[i7 + (i8 * 24 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
   i3 = 1;
   break;
  }
  if (i1) if ((HEAP32[i7 + (i8 * 24 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
   i3 = 1;
   break;
  }
  i1 = HEAP32[i7 + (i8 * 24 | 0) + 4 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) if ((HEAP32[i7 + (i8 * 24 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
   i3 = 2;
   break;
  }
  if ((i1 | 0) != (i6 | 0)) {
   i9 = 0;
   return i9 | 0;
  }
  if ((HEAP32[i7 + (i8 * 24 | 0) + 8 >> 2] | 0) == (i5 | 0)) i3 = 2; else {
   i9 = 0;
   return i9 | 0;
  }
 } while (0);
 i1 = HEAP32[i7 + (i9 * 24 | 0) >> 2] | 0;
 i2 = (i1 | 0) == (i5 | 0);
 if (i2) if ((HEAP32[i7 + (i9 * 24 | 0) + 4 >> 2] | 0) == (i6 | 0)) i1 = 0; else i4 = 15; else i4 = 15;
 do if ((i4 | 0) == 15) {
  i1 = (i1 | 0) == (i6 | 0);
  if (i1) if ((HEAP32[i7 + (i9 * 24 | 0) + 4 >> 2] | 0) == (i5 | 0)) {
   i1 = 0;
   break;
  }
  if (i2) if ((HEAP32[i7 + (i9 * 24 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
   i1 = 1;
   break;
  }
  if (i1) if ((HEAP32[i7 + (i9 * 24 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
   i1 = 1;
   break;
  }
  i1 = HEAP32[i7 + (i9 * 24 | 0) + 4 >> 2] | 0;
  if ((i1 | 0) == (i5 | 0)) if ((HEAP32[i7 + (i9 * 24 | 0) + 8 >> 2] | 0) == (i6 | 0)) {
   i1 = 2;
   break;
  }
  if ((i1 | 0) != (i6 | 0)) {
   i9 = 0;
   return i9 | 0;
  }
  if ((HEAP32[i7 + (i9 * 24 | 0) + 8 >> 2] | 0) == (i5 | 0)) i1 = 2; else {
   i9 = 0;
   return i9 | 0;
  }
 } while (0);
 HEAP32[i7 + (i8 * 24 | 0) + 12 + (i3 << 2) >> 2] = i1 << 30 | i9;
 HEAP32[i7 + (i9 * 24 | 0) + 12 + (i1 << 2) >> 2] = i3 << 30 | i8;
 i9 = 1;
 return i9 | 0;
}

function __ZN13SparseTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932215 | 0, i6, i1 + 80 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i6, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410444 | 0, i6, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 96 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 410455 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932818 | 0, i6, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431875 | 0, gb + 431893 | 0, i1, 0);
 __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK8Collider(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i4 + 136 >> 2] | 0;
 i10 = i4 + 140 | 0;
 i3 = i1;
 i2 = i1;
 if ((i3 | 0) != (i10 | 0)) if (HEAP8[i3 + 24 >> 0] | 0) while (1) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i10 | 0)) {
   i1 = i10;
   break;
  }
  if (!(HEAP8[i1 + 24 >> 0] | 0)) break; else i2 = i1;
 }
 i2 = i1;
 if ((i2 | 0) == (i10 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i9 + 4 | 0;
 i6 = i4 + 104 | 0;
 L21 : while (1) {
  i5 = i2 + 28 | 0;
  i2 = i2 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i5 >> 2] | 0;
   if (i4 | 0) if ((i3 | 0) == (i8 | 0) | (i4 | 0) == (i8 | 0)) {
    i3 = HEAP32[i3 + 36 >> 2] | 0;
    HEAP32[i9 >> 2] = HEAP32[i4 + 36 >> 2];
    HEAP32[i7 >> 2] = i3;
    i4 = __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_(i6, i9) | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    HEAP8[i4 >> 0] = 0;
    HEAP32[i4 + 4 >> 2] = i3;
    HEAP32[i4 + 8 >> 2] = i5;
   }
  }
  while (1) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i10 | 0)) {
    i1 = 24;
    break L21;
   }
   if (!(HEAP8[i2 + 24 >> 0] | 0)) break; else i1 = i2;
  }
  if ((i2 | 0) == (i10 | 0)) {
   i1 = 24;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == 24) {
  STACKTOP = i11;
  return;
 }
}

function __ZN13TriggerModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 28 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 32 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 36 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 40 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 44 | 0, i1);
 __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 48 | 0, i1);
 i5 = i7 + 8 | 0;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z40SkinnedMeshRenderer_Set_Custom_PropBonesP12Il2CppObjectP11Il2CppArray(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 i6 = i9 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i6 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 if (i3 | 0) {
  i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[i7 >> 2] | 0;
  do if ((i1 & 2147483647) >>> 0 < i4 >>> 0) if ((i1 | 0) > -1) {
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i4 << 2, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i6 >> 2] = i10;
   break;
  } while (0);
  if ((i4 | 0) > 0) {
   i1 = 0;
   do {
    i10 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(__ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i3, i1) | 0) | 0;
    HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i10;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
 }
 if (!i5) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i10 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE(i1, i6);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i8);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (!i5) i3 = i2; else {
    i3 = i2;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i3 + i5 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i1 = i6 + 32 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 32 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else i6 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE7reserveEj(i14, i3) {
 i14 = i14 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = i14 + 8 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i1 = i7;
 if ((((HEAP32[i15 >> 2] | 0) - i7 | 0) / 20 | 0) >>> 0 >= i3 >>> 0) return;
 i16 = i14 + 4 | 0;
 i2 = HEAP32[i16 >> 2] | 0;
 i5 = i2;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 20 | 0) | 0;
 i6 = i4 + (((i2 - i7 | 0) / 20 | 0) * 20 | 0) | 0;
 i13 = i6;
 i12 = i4 + (i3 * 20 | 0) | 0;
 if ((i5 | 0) == (i1 | 0)) i2 = i13; else {
  i2 = i13;
  do {
   i9 = i5;
   i5 = i5 + -20 | 0;
   i11 = i5;
   i7 = HEAP32[i11 + 4 >> 2] | 0;
   i4 = i6 + -20 | 0;
   HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i4 + 4 >> 2] = i7;
   i4 = i6 + -12 | 0;
   i7 = i9 + -12 | 0;
   HEAP32[i4 >> 2] = 0;
   i11 = i6 + -8 | 0;
   HEAP32[i11 >> 2] = 0;
   HEAP32[i6 + -4 >> 2] = 0;
   i9 = i9 + -8 | 0;
   i3 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
   i8 = (i3 | 0) / 24 | 0;
   if (i3 | 0) {
    if (i8 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
    i10 = __Znwj(i3) | 0;
    HEAP32[i11 >> 2] = i10;
    HEAP32[i4 >> 2] = i10;
    HEAP32[i6 + -4 >> 2] = i10 + (i8 * 24 | 0);
    i4 = HEAP32[i7 >> 2] | 0;
    i3 = (HEAP32[i9 >> 2] | 0) - i4 | 0;
    if ((i3 | 0) > 0) {
     _memcpy(i10 | 0, i4 | 0, i3 | 0) | 0;
     HEAP32[i11 >> 2] = i10 + (((i3 >>> 0) / 24 | 0) * 24 | 0);
    }
   }
   i6 = i2 + -20 | 0;
   i2 = i6;
  } while ((i5 | 0) != (i1 | 0));
  i7 = HEAP32[i14 >> 2] | 0;
  i1 = HEAP32[i16 >> 2] | 0;
 }
 HEAP32[i14 >> 2] = i2;
 HEAP32[i16 >> 2] = i13;
 HEAP32[i15 >> 2] = i12;
 i6 = i7;
 if ((i1 | 0) != (i6 | 0)) do {
  i2 = HEAP32[i1 + -12 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + -8 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i2);
  }
  i1 = i1 + -20 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if (!i7) return;
 __ZdlPv(i7);
 return;
}

function __ZN5physx2Sc8ShapeSim20createTransformCacheERNS_17PxsTransformCacheE(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 i8 = i10 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i9 = i9 + 28 | 0;
  i10 = i1;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i9 + (i10 << 2) | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 + 1 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i11;
  return;
 }
 i4 = i9 + 16 | 0;
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i6 = i5 & 2147483647;
 i1 = i9 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i2 + 1;
 } else {
  i3 = i2 + -1 | 0;
  i2 = HEAP32[(HEAP32[i9 + 4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
 }
 if ((i2 | 0) == (i6 | 0)) {
  i3 = i5 << 1;
  if (i6 >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i4, i3);
  i1 = i9 + 28 | 0;
  if ((HEAP32[i9 + 36 >> 2] & 2147483647) >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1, i3);
  HEAP32[i9 + 20 >> 2] = i3;
  HEAP32[i9 + 32 >> 2] = i3;
  _memset((HEAP32[i1 >> 2] | 0) + (i6 << 2) | 0, 0, i5 << 2 | 0) | 0;
 }
 i6 = i9 + 28 | 0;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] = 0;
 __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i7, i10);
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 HEAP32[i9 + (i2 * 28 | 0) >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i9 + (i2 * 28 | 0) + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i8 >> 2] = i2;
 i9 = i6;
 i10 = i2;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i9 + (i10 << 2) | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + 1 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 88 | 0;
 i9 = i10;
 i8 = i9 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP8[i9 + 4 >> 0] = 0;
 i6 = i9 + 52 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i9 + 56 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 i1 = i8;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i8 + 40 >> 0] = 0;
 HEAP32[i9 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i9 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 899392 | 0, i9, 0);
 __ZN24CompressedAnimationCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i9, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 i1 = i9 + 72 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i9 + 84 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (i1 | 0) {
  i2 = i9 + 28 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 i1 = i9 + 12 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
 __ZdlPv(i2);
 STACKTOP = i10;
 return;
}

function __ZN9Rigidbody11SetPositionERK8Vector3f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 56 | 0;
 i6 = i9 + 28 | 0;
 i7 = i9;
 i8 = i3 + 52 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i4 | 0);
 i4 = i7 + 16 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i1 = i7 + 20 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i7 + 24 | 0;
 HEAP32[i2 >> 2] = i10;
 if (!(HEAP8[i3 + 84 >> 0] | 0)) {
  i1 = HEAP32[i3 + 108 >> 2] | 0;
  if (!i1) {
   i10 = HEAP32[i8 >> 2] | 0;
   i8 = HEAP32[i10 >> 2] | 0;
   i8 = i8 + 88 | 0;
   i8 = HEAP32[i8 >> 2] | 0;
   mftCall_viii(i8 | 0, i10 | 0, i7 | 0, 1);
   STACKTOP = i9;
   return;
  }
  HEAP32[i1 + 40 >> 2] = 1;
  i10 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i8 = i8 + 88 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_viii(i8 | 0, i10 | 0, i7 | 0, 1);
  STACKTOP = i9;
  return;
 }
 if (HEAP8[i3 + 80 >> 0] | 0) {
  i10 = HEAP32[i8 >> 2] | 0;
  if (!(mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 228 >> 2] | 0, i10 | 0, i6 | 0) | 0)) {
   i12 = HEAP32[i8 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i12 | 0);
   i12 = HEAP32[i5 + 4 >> 2] | 0;
   i11 = HEAP32[i5 + 8 >> 2] | 0;
   i10 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = i12;
   HEAP32[i6 + 8 >> 2] = i11;
   HEAP32[i6 + 12 >> 2] = i10;
  }
  HEAP32[i6 + 16 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i2 >> 2];
  i12 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 224 >> 2] | 0, i12 | 0, i6 | 0);
 }
 i12 = i3 + 104 | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -2;
 i12 = HEAP32[i8 >> 2] | 0;
 i11 = HEAP32[i12 >> 2] | 0;
 i11 = i11 + 88 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_viii(i11 | 0, i12 | 0, i7 | 0, 1);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(i9, i3, i1, i7, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i4 = i10;
 HEAP32[i9 >> 2] = gb + 90952 + 8;
 HEAP32[i9 + 4 >> 2] = 0;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i9 + 12 | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = 1073741823;
 HEAP32[i11 + 4 >> 2] = 1073741823;
 __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE(i3, i9);
 HEAP32[i9 >> 2] = gb + 90968 + 8;
 HEAP32[i9 + 24 >> 2] = -1;
 HEAP32[i9 + 28 >> 2] = i1;
 i5 = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0;
 do if (HEAP8[i1 + 64 >> 0] & 5) {
  __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E(i8, 0, i1, i3, i2);
  i1 = (HEAP8[i3 + 50 >> 0] | 0) == 0 ? 0 : (HEAP32[i3 + 56 >> 2] | 0) + 2 | 0;
  if (!i7) {
   HEAP32[i4 >> 2] = 1073741823;
   HEAP32[i4 + 4 >> 2] = 1073741823;
   __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3EjRKNS_9AABBMgrIdERNS0_8ShapeSimE(i5, i8, i1, i4, i9);
   break;
  } else {
   i11 = i7 + 68 | 0;
   i2 = i11;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i7 = i4;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = i3;
   __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3EjRKNS_9AABBMgrIdERNS0_8ShapeSimE(i5, i8, i1, i4, i9);
   i7 = i6;
   i8 = HEAP32[i7 + 4 >> 2] & 1073741823;
   HEAP32[i11 >> 2] = HEAP32[i7 >> 2] & 1073741823;
   HEAP32[i11 + 4 >> 2] = i8;
   break;
  }
 } while (0);
 i1 = HEAP32[i5 + 1196 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i8 + 1;
  i11 = i9 + 20 | 0;
  HEAP32[i11 >> 2] = i8;
  STACKTOP = i10;
  return;
 } else {
  i11 = i3 + -1 | 0;
  i8 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i11;
  i11 = i9 + 20 | 0;
  HEAP32[i11 >> 2] = i8;
  STACKTOP = i10;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_(i9, i10, i11) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_(i1, i10, i11);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i11 = HEAP32[i10 + 28 >> 2] | 0;
  i12 = i11 + (HEAP32[i10 + 32 >> 2] << 3) | 0;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i9 + 4 >> 2] = i11 + (i2 << 3);
  HEAP32[i9 + 8 >> 2] = i12;
  HEAP8[i9 + 12 >> 0] = 0;
  STACKTOP = i13;
  return;
 }
 i7 = i1 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 do if (!(HEAP8[i10 + 8 >> 0] | 0)) i12 = 9; else {
  i3 = i10 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) i12 = 9; else {
   i5 = HEAP32[i10 + 12 >> 2] | 0;
   i2 = i10 + 28 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[i1 + (i8 << 3) >> 2] | 0;
   if ((i5 | 0) != (i6 | 0)) {
    if (!((i5 | 0) != 0 & (i6 | 0) != 0)) {
     i12 = 9;
     break;
    }
    if (_strcmp(i5, i6) | 0) {
     i12 = 9;
     break;
    }
   }
   HEAP32[i3 >> 2] = i4 + -1;
  }
 } while (0);
 if ((i12 | 0) == 9) {
  i1 = i10 + 36 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i10 + 28 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i6 = i11;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i12 = i1 + (i8 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = HEAP32[i2 >> 2] | 0;
 i11 = i12 + (HEAP32[i7 >> 2] << 3) | 0;
 i12 = i12 + (HEAP32[i10 + 32 >> 2] << 3) | 0;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i12;
 HEAP8[i9 + 12 >> 0] = 1;
 STACKTOP = i13;
 return;
}

function __ZN5physx7NpShapeD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i3 >> 2] = gb + 93856 + 8;
 HEAP32[i3 + 12 >> 2] = gb + 93856 + 184;
 i1 = i3 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i2 = 11;
   }
   break;
  }
 case 6:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i2 = 11;
   }
   break;
  }
 case 5:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + 8 | 0;
    i2 = 11;
   }
   break;
  }
 default:
  {}
 }
 if ((i2 | 0) == 11) if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i1 + 4 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i7 = i3 + 36 | 0;
 if (!(HEAP32[i7 >> 2] & 2)) i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i3 + 48 | 0) | 0; else i1 = HEAP16[(HEAP32[i3 + 40 >> 2] | 0) + 116 >> 1] | 0;
 i6 = i3 + 48 | 0;
 if (!(i1 << 16 >> 16)) {
  __ZN5physx2Sc9ShapeCoreD2Ev(i6);
  return;
 }
 i8 = i3 + 40 | 0;
 i5 = i3 + 32 | 0;
 i3 = i1 & 65535;
 i4 = 0;
 do {
  i2 = HEAP32[gb + 1457324 >> 2] | 0;
  if (!(HEAP32[i7 >> 2] & 2)) {
   i1 = HEAPU16[(__ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i6) | 0) + (i4 << 1) >> 1] | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((HEAP16[i1 + 116 >> 1] | 0) == 1) i1 = i1 + 112 | 0; else i1 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (HEAPU16[i1 + (i4 << 1) >> 1] << 2) | 0;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = i2 + 12 | 0;
  if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 __ZN5physx2Sc9ShapeCoreD2Ev(i6);
 return;
}

function __ZNK6Camera19GetProjectionMatrixEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i3 = i2 + 1077 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i6 = i2 + 100 | 0;
  return i6 | 0;
 }
 if (!(HEAP8[i2 + 1081 >> 0] | 0)) {
  i6 = i2 + 100 | 0;
  return i6 | 0;
 }
 i4 = i2 + 100 | 0;
 if (!(HEAP8[i2 + 1088 >> 0] | 0)) {
  if (HEAP8[i2 + 1087 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
   i7 = __Z12GetIVRDevicev() | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 116 >> 2] | 0, i7 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i2) | 0) {
    i8 = __Z14IsWorldPlayingv() | 0;
    i7 = HEAP32[i2 + 1108 >> 2] | 0;
    if ((i7 | 0) == 8 | i8 & (i7 | 0) == 1) {
     i8 = __Z12GetIVRDevicev() | 0;
     HEAPF32[i2 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 120 >> 2] | 0, i8 | 0));
    }
   }
  }
  f5 = Math_fround(HEAPF32[i2 + 292 >> 2]);
  if (!(HEAP8[i2 + 1086 >> 0] | 0)) i6 = 16; else if (!(__Z12GetIVRDevicev() | 0)) i6 = 16; else if (__ZNK6Camera16GetStereoEnabledEv(i2) | 0) {
   i7 = __Z14IsWorldPlayingv() | 0;
   i8 = HEAP32[i2 + 1108 >> 2] | 0;
   if ((i8 | 0) == 8 | i7 & (i8 | 0) == 1) {
    i8 = __Z12GetIVRDevicev() | 0;
    if (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i8 | 0) | 0) {
     i8 = __Z12GetIVRDevicev() | 0;
     f1 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i8 >> 2] | 0) + 128 >> 2] | 0, i8 | 0));
    } else i6 = 16;
   } else i6 = 16;
  } else i6 = 16;
  if ((i6 | 0) == 16) f1 = Math_fround(HEAPF32[i2 + 1060 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + 920 >> 2]);
  __ZN10Matrix4x4f14SetPerspectiveEffff(i4, f5, f1, f9, Math_fround(HEAPF32[i2 + 924 >> 2])) | 0;
 } else {
  f5 = Math_fround(HEAPF32[i2 + 916 >> 2]);
  f1 = Math_fround(-f5);
  f10 = Math_fround(HEAPF32[i2 + 1060 >> 2]);
  f11 = Math_fround(f10 * f1);
  f10 = Math_fround(f5 * f10);
  f9 = Math_fround(HEAPF32[i2 + 920 >> 2]);
  __ZN10Matrix4x4f8SetOrthoEffffff(i4, f11, f10, f1, f5, f9, Math_fround(HEAPF32[i2 + 924 >> 2])) | 0;
 }
 HEAP8[i3 >> 0] = 0;
 i8 = i2 + 100 | 0;
 return i8 | 0;
}

function __ZN7Terrain23GarbageCollectRenderersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
 i12 = i1 + 228 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i10 = i1 + 240 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return; else i9 = i2;
 L3 : while (1) {
  i8 = i9 + 16 | 0;
  i4 = i9 + 8 | 0;
  i5 = i9 + 4 | 0;
  i6 = i9 + 12 | 0;
  i3 = i9;
  i9 = i9 + 20 | 0;
  i7 = i9;
  while (1) {
   if ((i11 - (HEAP32[i8 >> 2] | 0) | 0) >>> 0 <= 100) if (HEAP32[i3 >> 2] | 0) break;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) __ZN12TreeRendererD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63616 | 0);
   HEAP32[i4 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) __ZN15TerrainRendererD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63616 | 0);
   HEAP32[i5 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    __ZN14DetailRenderer7CleanupEv(i1);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1 + 88 | 0, HEAP32[i1 + 92 >> 2] | 0);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1 + 76 | 0, HEAP32[i1 + 80 >> 2] | 0);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1 + 64 | 0, HEAP32[i1 + 68 >> 2] | 0);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63616 | 0);
   HEAP32[i6 >> 2] = 0;
   _memmove(i3 | 0, i9 | 0, (HEAP32[i12 >> 2] | 0) + ((HEAP32[i10 >> 2] | 0) * 20 | 0) - i7 | 0) | 0;
   i1 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   if ((i3 | 0) == (i2 + (i1 * 20 | 0) | 0)) {
    i1 = 13;
    break L3;
   }
  }
  if ((i9 | 0) == (i2 + (i1 * 20 | 0) | 0)) {
   i1 = 13;
   break;
  }
 }
 if ((i1 | 0) == 13) return;
}

function __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i8 + 8 | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (!(HEAP32[i7 >> 2] & 1)) {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  i6 = i9;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = i7 + 16 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i4 + 4 | 0;
  i5 = i7 + 24 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i8, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i9, 8);
   STACKTOP = i10;
   return;
  }
 } else {
  if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(i1, i8);
  i5 = i7 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i7 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i8, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i9;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i3;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i10;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i9, 8);
   STACKTOP = i10;
   return;
  }
 }
}

function __ZNK5physx12PxsRigidBody20getAdvancedTransformEf(i3, i5, f6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i1 = i7;
 i2 = HEAP32[i5 + 64 >> 2] | 0;
 if (Math_fround(HEAPF32[i2 + 124 >> 2]) == Math_fround(0.0)) {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
  f6 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f9 = Math_fround(0.0);
  i5 = i3 + 16 | 0;
  HEAPF32[i5 >> 2] = f9;
  i5 = i3 + 20 | 0;
  HEAPF32[i5 >> 2] = f8;
  i5 = i3 + 24 | 0;
  HEAPF32[i5 >> 2] = f6;
  STACKTOP = i7;
  return;
 } else {
  f9 = Math_fround(Math_fround(1.0) - f6);
  f13 = Math_fround(HEAPF32[i5 + 48 >> 2]);
  f15 = Math_fround(f9 * f13);
  f12 = Math_fround(HEAPF32[i5 + 52 >> 2]);
  f14 = Math_fround(f9 * f12);
  f11 = Math_fround(HEAPF32[i5 + 56 >> 2]);
  f9 = Math_fround(f9 * f11);
  f10 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f6);
  f8 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * f6);
  f10 = Math_fround(f15 + f10);
  f8 = Math_fround(f14 + f8);
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * f6));
  HEAP32[i1 >> 2] = HEAP32[i5 + 32 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 36 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 40 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 44 >> 2];
  HEAPF32[i1 + 16 >> 2] = f13;
  HEAPF32[i1 + 20 >> 2] = f12;
  HEAPF32[i1 + 24 >> 2] = f11;
  __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i4, f6, i1, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  f6 = f10;
  i5 = i3 + 16 | 0;
  HEAPF32[i5 >> 2] = f6;
  i5 = i3 + 20 | 0;
  HEAPF32[i5 >> 2] = f8;
  i5 = i3 + 24 | 0;
  HEAPF32[i5 >> 2] = f9;
  STACKTOP = i7;
  return;
 }
}

function __ZN6Avatar23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 905757 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 HEAP32[i2 + 4 >> 2] = i1 + 32;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905773 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i4 + 40 | 0;
 i5 = i4;
 i7 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i3 >> 2] = -1;
 i7 = i4 + 44 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 1065353216;
 HEAP32[i4 + 72 >> 2] = 1065353216;
 HEAP32[i4 + 76 >> 2] = 1065353216;
 HEAP32[i4 + 80 >> 2] = 1065353216;
 i7 = i4 + 84 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905764 | 0, gb + 910045 | 0, i4, 0);
 __ZN7mecanim9animation14AvatarConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905786 | 0, HEAP32[gb + 37052 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i2, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc15ArticulationSimC2ERNS0_16ArticulationCoreERNS0_5SceneERNS0_8BodyCoreE(i12, i10, i3, i11) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = i3;
 i6 = i12 + 8 | 0;
 HEAP32[i6 >> 2] = i10;
 i7 = i12 + 12 | 0;
 i8 = i12 + 24 | 0;
 i9 = i12 + 32 | 0;
 i1 = i12 + 88 | 0;
 i2 = i12 + 160 | 0;
 i4 = i7;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 i4 = i1;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i2 >> 0] = 1;
 i1 = HEAP32[(HEAP32[i3 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayINS_19PxsArticulationLinkENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i7, 16);
 if ((HEAP32[i12 + 44 >> 2] & 2147483632) >>> 0 < 16) __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i12 + 36 | 0, 16);
 if ((HEAP32[i9 >> 2] & 2147483632) >>> 0 < 16) __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i8, 16);
 i9 = __ZN5physx10PxsContext18createArticulationEv(i1) | 0;
 HEAP32[i12 >> 2] = i9;
 if (!i9) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 681221 | 0, 53, gb + 681315 | 0, i13);
  STACKTOP = i14;
  return;
 } else {
  __ZN5physx2Sc15ArticulationSim7addBodyERNS0_7BodySimEPS2_PNS0_20ArticulationJointSimE(i12, __ZNK5physx2Sc8BodyCore6getSimEv(i11) | 0, 0, 0);
  HEAP32[HEAP32[i6 >> 2] >> 2] = i12;
  HEAP32[i12 + 72 >> 2] = i10 + 4;
  HEAP32[i12 + 48 >> 2] = 0;
  i11 = i12 + 56 | 0;
  i13 = i12 + 76 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i11 + 8 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  STACKTOP = i14;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i1 = i7;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i7 = i9 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 88, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = -1;
   HEAP32[i2 + 24 >> 2] = -1;
   HEAP32[i2 + 28 >> 2] = 1;
   i3 = i2 + 32 | 0;
   i4 = i3;
   i5 = i4 + 52 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAP16[i3 + 52 >> 1] = 0;
   HEAP8[i3 + 54 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E5eraseERS4_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = i11 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 if ((HEAP32[i11 + 36 >> 2] | 0) == (i4 | 0)) {
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i11 + 32 >> 2] | 0;
  i9 = i10 + -1 | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  i1 = (Math_imul(i8, 1419247029) | 0) & i9;
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i7 = HEAP32[i11 + 20 >> 2] | 0;
  i6 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L4 : do if ((i7 | 0) == (i6 | 0)) i1 = -1; else {
   i3 = i11 + 12 | 0;
   if (!(HEAP8[i11 + 8 >> 0] | 0)) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i9;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i7 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   if (!i4) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i8 | 0) == (i3 | 0)) break L4;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i9;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i7 | 0) == (i3 | 0)) {
      i1 = -1;
      break L4;
     }
    }
   }
   i5 = HEAP32[i3 >> 2] | 0;
   i4 = 0;
   i3 = i6;
   while (1) {
    if ((i5 | 0) != (i3 | 0) & (i8 | 0) == (i3 | 0)) break L4;
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i9;
    i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
    if ((i7 | 0) == (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } while (0);
  i3 = (i1 | 0) == -1 ? i2 + (i10 << 3) | 0 : i2 + (i1 << 3) | 0;
  i1 = i10;
 }
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 i8 = i11 + 12 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i3;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 HEAP8[i11 + 48 >> 0] = 1;
 i12 = 1;
 return i12 | 0;
}

function __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 76 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 84 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 88 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 92 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 96 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i8, i3, i2, i7) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = HEAP32[i3 + 16 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i5 | 0)) {
  i4 = HEAP32[i3 + 32 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) {
    i1 = 0;
    i5 = 0;
    break L1;
   }
  }
  if ((i1 | 0) > -1) {
   __ZNK19ShaderPropertySheet14GetVectorArrayEi(i6, i3, i1);
   i1 = HEAP32[i6 >> 2] | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
  } else {
   i1 = 0;
   i5 = 0;
  }
 } else {
  i1 = 0;
  i5 = 0;
 } while (0);
 i3 = __Z23GetCoreScriptingClassesv() | 0;
 i2 = HEAP32[i3 + 120 >> 2] | 0;
 i3 = HEAP32[i3 + 460 >> 2] | 0;
 i4 = i8 + 8 | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i4 >> 2] | 0) | 0) >>> 0 < i5 >>> 0) {
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i7 ? i2 : i3, 16, i5) | 0;
  HEAP32[i4 >> 2] = i3;
 } else i3 = HEAP32[i4 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if ((i5 | 0) > 0) i2 = 0; else {
  i7 = i8 + 12 | 0;
  HEAP32[i7 >> 2] = i5;
  i8 = i8 + 16 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  STACKTOP = i9;
  return;
 }
 while (1) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i6 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, i2, 16) | 0;
  HEAP32[i7 >> 2] = i11;
  HEAP32[i7 + 4 >> 2] = i10;
  HEAP32[i7 + 8 >> 2] = i4;
  HEAP32[i7 + 12 >> 2] = i6;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 16 | 0;
 }
 i11 = i8 + 12 | 0;
 HEAP32[i11 >> 2] = i5;
 i11 = i8 + 16 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i9;
 return;
}

function __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i3 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 12 | 0, i5);
 i1 = i6 + 28 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 29 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 30 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 31 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 }
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i4, i6, i1, i9) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = i6 + 12 | 0;
 i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAPU16[i5 >> 1] | 0) | 0;
 if (!i2) {
  i9 = -1;
  return i9 | 0;
 }
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, i2) | 0;
 if (!i8) {
  i9 = -1;
  return i9 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 & 65535;
 i4 = i4 + 40 | 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 if (!i1) {
  i3 = __ZN11UnityEngine9AnimationL24GenerateComponentBindingEiP12Il2CppObjectP11Il2CppClassP6Object(i3, 0, 0, i8) | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i1 = i7 & 65535;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 } else i7 = i2;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i1 + (i2 << 4) | 0;
 i2 = i2 << 4 >> 4;
 if (!i2) i4 = i1; else {
  do {
   i10 = (i2 | 0) / 2 | 0;
   i6 = i1 + (i10 << 4) | 0;
   i4 = (HEAP32[i6 >> 2] | 0) >>> 0 < i3 >>> 0;
   i2 = i4 ? i2 + -1 - i10 | 0 : i10;
   i1 = i4 ? i6 + 16 | 0 : i1;
  } while ((i2 | 0) != 0);
  i4 = i1;
 }
 if ((i4 | 0) != (i5 | 0)) if ((HEAP32[i4 >> 2] | 0) >>> 0 <= i3 >>> 0) {
  i3 = i9 + 12 | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i9 >> 2] = i8 + (HEAP32[i4 + 4 >> 2] | 0);
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  i2 = i9 + 4 | 0;
  HEAP32[i2 >> 2] = i1;
  L17 : do if (i7 >>> 0 < 16777216) {
   switch (i1 | 0) {
   case 5:
    break;
   case 6:
    {
     i10 = 100001;
     return i10 | 0;
    }
   default:
    break L17;
   }
   i10 = 100002;
   return i10 | 0;
  } else if ((i1 | 0) == 9) {
   i10 = HEAP32[i4 + 12 >> 2] | 0;
   return i10 | 0;
  } while (0);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i10 = -1;
  return i10 | 0;
 }
 HEAP32[i9 + 4 >> 2] = 0;
 i10 = -1;
 return i10 | 0;
}

function __ZN5physx15PxsParticleData19addDeltaVelocitiesVERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef(i7, i8, i10, f11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, f12 = f0, f13 = f0, f14 = f0;
 i9 = HEAP32[i8 + 4 >> 2] & 2147483647;
 if (!i9) return;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  if (i3 | 0) {
   i1 = i2;
   i5 = i3;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i9 >>> 0) {
   i4 = 18;
   break;
  }
 }
 if ((i4 | 0) == 18) return;
 i3 = (Math_imul(i5 & 0 - i5, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
 i2 = i5 + -1 & i5;
 L10 : do if (!i2) do {
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i9 >>> 0) {
   i2 = 0;
   break L10;
  }
  i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
 } while ((i2 | 0) == 0); while (0);
 if ((i3 | 0) == -1) return;
 i6 = HEAP32[i7 + 48 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 L18 : while (1) {
  i4 = i1 << 5;
  while (1) {
   f14 = Math_fround(Math_fround(HEAPF32[i10 + (i3 * 12 | 0) >> 2]) * f11);
   f13 = Math_fround(Math_fround(HEAPF32[i10 + (i3 * 12 | 0) + 4 >> 2]) * f11);
   f12 = Math_fround(Math_fround(HEAPF32[i10 + (i3 * 12 | 0) + 8 >> 2]) * f11);
   i8 = i6 + (i3 << 5) + 16 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f14 + Math_fround(HEAPF32[i8 >> 2]));
   i8 = i6 + (i3 << 5) + 20 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i8 >> 2]));
   i8 = i6 + (i3 << 5) + 24 | 0;
   HEAPF32[i8 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i8 >> 2]));
   if (!i2) {
    i4 = 18;
    break L18;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
   i2 = i2 + -1 & i2;
   if (!i2) break;
   if ((i3 | 0) == -1) {
    i4 = 18;
    break L18;
   }
  }
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i9 >>> 0) {
    i2 = 0;
    break;
   }
   i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
  if ((i3 | 0) == -1) {
   i4 = 18;
   break;
  }
 }
 if ((i4 | 0) == 18) return;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN9ShaderLab19SerializedSubShaderEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 470681 | 0, i2, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 470701 | 0, HEAP32[gb + 37316 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i1, i2, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 470710 | 0, gb + 470717 | 0, i2 + 12 | 0, 0);
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 470740 | 0, HEAP32[gb + 37052 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i1, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i6, HEAP32[i4 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 470734 | 0, HEAP32[gb + 37040 >> 2] | 0, i2 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object(i12, i3, i4, i1, i2) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (i1 | 0) if ((HEAP32[i1 + (HEAP32[i2 + ((i3 >>> 2) * 12 | 0) >> 2] << 2) >> 2] | 0) == (HEAP32[i1 + (HEAP32[i2 + ((i4 >>> 2) * 12 | 0) >> 2] << 2) >> 2] | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 i10 = i3 >>> 0 > i4 >>> 0;
 i11 = i10 ? i4 : i3;
 i10 = i10 ? i3 : i4;
 i8 = i10 << 16 | i11 & 65535;
 i8 = i8 + ~(i8 << 15) | 0;
 i8 = (i8 >> 10 ^ i8) * 9 | 0;
 i8 = i8 >> 6 ^ i8;
 i8 = i8 + ~(i8 << 11) | 0;
 i8 = i8 >> 16 ^ i8;
 i9 = i12 + 4 | 0;
 i1 = HEAP32[i9 >> 2] & i8;
 i7 = i12 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 L5 : do if (i3 | 0) {
  i6 = HEAP32[i12 + 20 >> 2] | 0;
  i5 = HEAP32[i12 + 16 >> 2] | 0;
  i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   while (1) {
    i4 = i6 + (i2 * 12 | 0) | 0;
    if (!((HEAP32[i4 >> 2] | 0) != (i11 | 0) ? 1 : (HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0) != (i10 | 0))) break;
    i2 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L5;
   }
   if (i4 | 0) {
    HEAP8[i6 + (i2 * 12 | 0) + 9 >> 0] = 1;
    i12 = i4;
    return i12 | 0;
   }
  }
 } while (0);
 i4 = i12 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
  i2 = i2 + 1 | 0;
  i2 = i2 >>> 1 | i2;
  i2 = i2 >>> 2 | i2;
  i2 = i2 >>> 4 | i2;
  i2 = i2 >>> 8 | i2;
  i2 = i2 >>> 16 | i2;
  HEAP32[i12 >> 2] = i2 + 1;
  HEAP32[i9 >> 2] = i2;
  __ZN15MBP_PairManager12reallocPairsEv(i12);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] & i8;
 }
 i8 = HEAP32[i12 + 20 >> 2] | 0;
 i9 = i8 + (i2 * 12 | 0) | 0;
 HEAP32[i9 >> 2] = i11;
 HEAP32[i8 + (i2 * 12 | 0) + 4 >> 2] = i10;
 HEAP8[i8 + (i2 * 12 | 0) + 8 >> 0] = 1;
 HEAP8[i8 + (i2 * 12 | 0) + 9 >> 0] = 0;
 i11 = i3 + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 16 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i11 >> 2];
 i12 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i12 + 1;
 HEAP32[i11 >> 2] = i12;
 i12 = i9;
 return i12 | 0;
}

function __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv(i2, i12, i13) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i9 = i12 + 8 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
 HEAP32[i9 >> 2] = i1;
 i9 = i12 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i1 << 1 | 0) > (i10 | 0)) {
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (!i4) {
   i13 = 268435455;
   return i13 | 0;
  }
  i5 = HEAP32[i12 >> 2] | 0;
  i7 = i12 + 4 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i10 << 1;
  i2 = i2 + 12 | 0;
  i10 = mftCall_iiii(i4 | 0, HEAP32[i2 >> 2] | 0, i5 | 0, i10 << 3 | 4 | 0) | 0;
  HEAP32[i12 >> 2] = i10;
  if (!i10) {
   HEAP32[i12 >> 2] = i5;
   i13 = 268435455;
   return i13 | 0;
  }
  i10 = mftCall_iiii(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i9 >> 2] << 3) + 8 | 0) | 0;
  HEAP32[i7 >> 2] = i10;
  if (!i10) {
   HEAP32[i7 >> 2] = i8;
   i13 = 268435455;
   return i13 | 0;
  }
 }
 i2 = i12 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i10 = HEAP32[i12 + 4 >> 2] | 0;
 if (!i3) i3 = i1; else HEAP32[i2 >> 2] = HEAP32[i10 + (i3 << 3) + 4 >> 2];
 i8 = HEAP32[i12 >> 2] | 0;
 HEAP32[i8 + (i1 << 2) >> 2] = i3;
 i9 = i10 + (i3 << 3) + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 + (i3 << 3) >> 2] = i13;
 if (!(HEAP32[i12 + 20 >> 2] | 0)) {
  i13 = i3;
  return i13 | 0;
 }
 i2 = i1 >> 1;
 L19 : do if (i2) {
  f11 = Math_fround(HEAPF32[i13 + 24 >> 2]);
  i7 = i13 + 28 | 0;
  while (1) {
   i4 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
   i5 = HEAP32[i10 + (i4 << 3) >> 2] | 0;
   f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   if (f6 < f11) break L19;
   if (f6 == f11) {
    f6 = Math_fround(HEAPF32[i5 + 28 >> 2]);
    if (f6 <= Math_fround(HEAPF32[i7 >> 2])) break L19;
   }
   HEAP32[i8 + (i1 << 2) >> 2] = i4;
   HEAP32[i10 + (i4 << 3) + 4 >> 2] = i1;
   i1 = i2 >> 1;
   if (!i1) {
    i1 = i2;
    break;
   } else {
    i13 = i2;
    i2 = i1;
    i1 = i13;
   }
  }
 } while (0);
 HEAP32[i8 + (i1 << 2) >> 2] = i3;
 HEAP32[i9 >> 2] = i1;
 i13 = i3;
 return i13 | 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i11, i1, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i9 = _strlen(i10) | 0;
 i5 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = i7 + i9 | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i4 >> 2] | 0;
  i8 = 5;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i7;
  i1 = i11;
 } else {
  i1 = i3;
  i8 = 5;
 }
 if ((i8 | 0) == 5) {
  i8 = i2 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = i11 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i9 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i9 - i3 + i1 | 0, i1, i1, 0, i9, i10);
  STACKTOP = i12;
  return;
 }
 if (!i9) {
  STACKTOP = i12;
  return;
 }
 if (i2) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
 _memcpy(i2 + i1 | 0, i10 | 0, i9 | 0) | 0;
 i1 = i1 + i9 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i4 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5audio5mixer20GetGroupPathFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = HEAP32[i8 >> 2] | 0;
 L1 : do if (i7 | 0) {
  i3 = i8 + 8 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 4) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i3 + (i1 << 4) + 8 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + (i1 << 4) + 12 >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i7 >>> 0) break L1;
  }
  if ((i1 | 0) != -1) {
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   HEAP32[i10 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1576256 | 0, 0);
   i6 = i8 + 48 | 0;
   i7 = i6;
   i4 = i8 + 4 | 0;
   i5 = i4;
   i3 = i1;
   do {
    i1 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
    if ((i3 | 0) > 0) {
     i2 = 0;
     do {
      i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i3 | 0));
    }
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc(i10, 0, i1) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc(i10, 0, gb + 1087627 | 0) | 0;
    i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + i5 + (i3 << 4) >> 2] | 0;
   } while ((i3 | 0) != -1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i9, i10);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
   STACKTOP = i11;
   return;
  }
 } while (0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1576256 | 0, 0);
 STACKTOP = i11;
 return;
}

function __ZN15OcclusionPortal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 72 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN11UnityEngine9AnimationL19GetTypeTreeBindTypeERK16TypeTreeIterator(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i3) | 0) + 20 >> 2] & 8388608 | 0) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37012 >> 2] | 0;
 do if (!i2) i4 = 4; else if (!i1) {
  i1 = 0;
  i4 = 4;
 } else {
  i6 = HEAP32[gb + 36932 >> 2] | 0;
  i5 = HEAP32[gb + 36936 >> 2] | 0;
  if (i5 >>> 0 > i2 >>> 0 & ((i6 >>> 0 > i2 >>> 0 | (i6 >>> 0 > i1 >>> 0 | i5 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) i1 = 5; else break;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) i1 = 5; else break;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 4) if ((i1 | 0) == (i2 | 0)) {
  i6 = 5;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 36972 >> 2] | 0;
 do if (!i2) i4 = 10; else if (!i1) {
  i1 = 0;
  i4 = 10;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) {
   if ((i1 | 0) == (i2 | 0)) i1 = 6; else break;
   return i1 | 0;
  } else {
   if (!(_strcmp(i2, i1) | 0)) i1 = 6; else break;
   return i1 | 0;
  }
 } while (0);
 if ((i4 | 0) == 10) if ((i1 | 0) == (i2 | 0)) {
  i6 = 6;
  return i6 | 0;
 }
 i1 = __ZNK16TypeTreeIterator4TypeEv(i3) | 0;
 i2 = HEAP32[gb + 37300 >> 2] | 0;
 do if (!i2) i4 = 16; else if (!i1) {
  i1 = 0;
  i4 = 16;
 } else {
  i5 = HEAP32[gb + 36932 >> 2] | 0;
  i6 = HEAP32[gb + 36936 >> 2] | 0;
  if (i6 >>> 0 > i2 >>> 0 & ((i5 >>> 0 > i2 >>> 0 | (i5 >>> 0 > i1 >>> 0 | i6 >>> 0 <= i1 >>> 0)) ^ 1)) if ((i1 | 0) == (i2 | 0)) {
   i4 = 20;
   break;
  } else break; else if (!(_strcmp(i2, i1) | 0)) {
   i4 = 20;
   break;
  } else break;
 } while (0);
 if ((i4 | 0) == 16) if ((i1 | 0) == (i2 | 0)) i4 = 20;
 if ((i4 | 0) == 20) if (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i3) | 0) + 20 >> 2] & 256 | 0) {
  i6 = 6;
  return i6 | 0;
 }
 i6 = 0;
 return i6 | 0;
}

function __Z31WillAddComponentChangeTransformR10GameObjectiP11Il2CppClass(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 20 | 0;
 i12 = i13;
 i2 = gb + 64016 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i10 = i11 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 i3 = HEAP32[gb + 1163236 >> 2] | 0;
 if ((i4 | 0) < 4 | (i2 | 0) != 0 | (i3 | 0) == 0) {
  i5 = i4;
  i1 = i2;
 } else {
  i2 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
  i1 = gb + 64016 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[gb + 1163236 >> 2] | 0;
 }
 HEAP32[i11 + 4 >> 2] = i4;
 HEAP32[i11 + 8 >> 2] = i2;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 i4 = i12 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 if (!((i5 | 0) < 4 | (i1 | 0) != 0 | (i3 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i3) | 0;
 HEAP32[i12 + 4 >> 2] = i5;
 HEAP32[i12 + 8 >> 2] = i1;
 i9 = __ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE(i6, i7, i9, i11, i12, 0) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L7 : do if (i9 & (i2 | 0) != 0) {
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = 0;
  while (1) {
   switch (HEAP32[i3 + (i1 << 3) >> 2] | 0) {
   case 4:
   case 224:
    {
     i1 = 1;
     break L7;
    }
   default:
    {}
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    i1 = 0;
    break L7;
   }
  }
 } else i1 = 0; while (0);
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i12 + 4 | 0);
  HEAP32[i12 >> 2] = 0;
 }
 if ((HEAP32[i10 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i11 + 4 | 0);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 12 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 12 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 12 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 12 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 54;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (((i1 - i4 | 0) / 12 | 0) * 12 | 0) | 0;
 i5 = i5 + (i3 * 12 | 0) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i4 + 12 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 54;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim5human19HumanPoseBlendBeginERNS0_9HumanPoseE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 _memset(i1 + 596 | 0, 0, 208) | 0;
 i2 = i1 + 500 | 0;
 i4 = i1 + 68 | 0;
 i3 = i1 + 96 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 i4 = i1 + 364 | 0;
 i5 = i4 + 80 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 i4 = i2;
 i5 = i4 + 80 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i3 >> 2] = 1065353216;
 HEAP32[i1 + 100 >> 2] = 1065353216;
 HEAP32[i1 + 104 >> 2] = 1065353216;
 i4 = i1 + 132 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 1065353216;
 HEAP32[i1 + 164 >> 2] = 1065353216;
 HEAP32[i1 + 168 >> 2] = 1065353216;
 i4 = i1 + 196 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 1065353216;
 HEAP32[i1 + 228 >> 2] = 1065353216;
 HEAP32[i1 + 232 >> 2] = 1065353216;
 i4 = i1 + 260 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 1065353216;
 HEAP32[i1 + 292 >> 2] = 1065353216;
 HEAP32[i1 + 296 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 i4 = i1 + 804 | 0;
 i5 = i4 + 84 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 return;
}

function __ZN6Camera12AddToManagerEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN13RenderManager9AddCameraEP6Camera(__Z16GetRenderManagerv() | 0, i3);
 i5 = i3 + 1086 | 0;
 if (HEAP8[i5 >> 0] | 0) {
  __ZL19GetCameraTargetRectRK6Camerab(i4, i3, 1);
  f1 = Math_fround(HEAPF32[i3 + 864 >> 2]);
  f2 = Math_fround(HEAPF32[i3 + 868 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + 872 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 876 >> 2]);
  f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
  f1 = Math_fround(f1 * f13);
  f12 = Math_fround(f12 * f13);
  f2 = Math_fround(f2 * f10);
  f9 = Math_fround(f9 * f10);
  f11 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f1 = Math_fround(f1 + f11);
  f2 = Math_fround(f2 + f8);
  f12 = Math_fround(f12 + f1);
  f9 = Math_fround(f9 + f2);
  f13 = Math_fround(f13 + f11);
  f10 = Math_fround(f10 + f8);
  f1 = Math_fround((f12 > f13 ? f13 : f12) - (f1 < f11 ? f11 : f1));
  f2 = Math_fround((f9 > f10 ? f10 : f9) - (f2 < f8 ? f8 : f2));
  i7 = f2 < Math_fround(0.0);
  f2 = i7 ? Math_fround(0.0) : f2;
  if (f2 != Math_fround(0.0)) {
   i7 = f1 < Math_fround(0.0);
   f1 = Math_fround((i7 ? Math_fround(0.0) : f1) / f2);
  } else f1 = Math_fround(1.0);
  HEAPF32[i3 + 1060 >> 2] = f1;
  HEAP8[i3 + 1077 >> 0] = 1;
  HEAP8[i3 + 1079 >> 0] = 1;
  HEAP8[i3 + 1078 >> 0] = 1;
  HEAP8[i5 >> 0] = 1;
 }
 i7 = i3 + 904 | 0;
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAPF32[i3 + 892 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 896 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 900 >> 2] = Math_fround(0.0);
 __ZN6Camera34UpdatePreviousViewProjectionMatrixEv(i3);
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx2Sc5Scene13ccdBroadPhaseEPNS_10PxBaseTaskE(i11, i2) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[(HEAP32[i11 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i6 = __ZNK5physx10PxsContext17getCurrentCCDPassEv(i9) | 0;
 i1 = __ZNK5physx10PxsContext15getCCDMaxPassesEv(i9) | 0;
 if (i6 | 0) if (!(__ZNK5physx10PxsContext15getNumSweepHitsEv(i9) | 0)) return;
 i10 = i6 & 1;
 i8 = i10 ^ 1;
 i4 = i1 + -1 | 0;
 i7 = (i6 | 0) != (i4 | 0);
 if (i7) {
  i1 = HEAP32[i11 + 1928 >> 2] | 0;
  HEAP32[i1 + (i8 * 28 | 0) + 16 >> 2] = 1;
  i3 = i1 + (i8 * 28 | 0) + 12 | 0;
  HEAP32[i3 >> 2] = i2;
  if (i2 | 0) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
   HEAP32[i1 + (i8 * 28 | 0) + 8 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
  }
 }
 i3 = i11 + 1940 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if ((i6 | 0) != (i4 | 0)) i2 = (HEAP32[i11 + 1928 >> 2] | 0) + (i8 * 28 | 0) | 0;
 HEAP32[i5 + (i10 * 28 | 0) + 16 >> 2] = 1;
 i1 = i5 + (i10 * 28 | 0) + 12 | 0;
 HEAP32[i1 >> 2] = i2;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  HEAP32[i5 + (i10 * 28 | 0) + 8 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 i6 = i11 + 1916 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + (i10 * 28 | 0) | 0;
 HEAP32[i5 + (i10 * 28 | 0) + 16 >> 2] = 1;
 i4 = i5 + (i10 * 28 | 0) + 12 | 0;
 HEAP32[i4 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 HEAP32[i5 + (i10 * 28 | 0) + 8 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
 __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb(i9, (HEAP32[i6 >> 2] | 0) + (i10 * 28 | 0) | 0, 1);
 i9 = (HEAP32[i3 >> 2] | 0) + (i10 * 28 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0);
 i10 = (HEAP32[i6 >> 2] | 0) + (i10 * 28 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0);
 if (!i7) return;
 i11 = (HEAP32[i11 + 1928 >> 2] | 0) + (i8 * 28 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0);
 return;
}

function __ZN5physx24NpPtrTableStorageManager10deallocateEPPvj(i5, i3, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i4 = i5 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 do if (i2 >>> 0 < 17) {
  i2 = i5 + 8 | 0;
  if (i3 | 0) {
   i1 = i5 + 288 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i5 + 300 | 0;
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i3;
   i1 = i5 + 292 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i3 + 1;
   if ((i3 | 0) >= ((HEAP32[i5 + 284 >> 2] | 0) * 50 | 0)) {
    __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i2);
    HEAP32[i1 >> 2] = 0;
   }
  }
 } else {
  if (i2 >>> 0 < 65) {
   if (!i3) break;
   i1 = i5 + 584 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i5 + 596 | 0;
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i3;
   i1 = i5 + 588 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i3 + 1;
   if ((i3 | 0) < ((HEAP32[i5 + 580 >> 2] | 0) * 50 | 0)) break;
   __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i5 + 304 | 0);
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i2 >>> 0 >= 257) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
   break;
  }
  i2 = i5 + 600 | 0;
  if (i3 | 0) {
   i1 = i5 + 880 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i1 = i5 + 892 | 0;
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i1 >> 2] = i3;
   i1 = i5 + 884 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i3 + 1;
   if ((i3 | 0) >= ((HEAP32[i5 + 876 >> 2] | 0) * 50 | 0)) {
    __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i2);
    HEAP32[i1 >> 2] = 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra15PortalRayTracer4initERNS_10PortalNodeE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i5 + 4 | 0;
 i7 = __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i1, i2) | 0;
 if ((i7 | 0) == -1) {
  i7 = 5;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i3 = i4 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i1, i4, i7);
 i3 = HEAP32[i3 >> 2] | 0;
 if (i3 | 0) {
  i1 = __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i1, i3, i2) | 0;
  if ((i1 | 0) != -1) {
   i2 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i3, i1, i2) | 0;
   if ((i2 | 0) == -1 ? 1 : (i2 | 0) >= (HEAP32[i3 + 52 >> 2] & 65535 | 0)) {
    i7 = 5;
    STACKTOP = i8;
    return i7 | 0;
   }
   HEAP32[i4 >> 2] = -1;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 12 >> 2] = 0;
   i1 = i4 + 28 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i4 + 32 >> 2] = 0;
   __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(HEAP32[i5 >> 2] | 0, i4, i7);
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP32[i1 + 56 >> 2] | 0)) i1 = 3; else {
    HEAP32[i5 + 244 >> 2] = HEAP32[i1 + 48 >> 2];
    HEAP32[i6 >> 2] = i7;
    HEAP32[i6 + 4 >> 2] = i2;
    i1 = HEAP32[HEAP32[HEAP32[i5 >> 2] >> 2] >> 2] | 0;
    HEAP32[i6 + 8 >> 2] = (HEAP32[i1 + (HEAP32[i1 + 136 >> 2] | 0) + (i7 << 2) >> 2] | 0) + i2;
    i1 = HEAP32[(HEAP32[i5 + 88 >> 2] | 0) + 24 >> 2] | 0;
    if (!i1) i1 = 0; else {
     i1 = HEAP32[i1 + 1408 >> 2] | 0;
     i2 = i1 + 16384 | 0;
     if (i1 >>> 0 < 4294950912) {
      do {
       _memset(i1 | 0, 0, 1024) | 0;
       i1 = i1 + 1024 | 0;
      } while (i1 >>> 0 < i2 >>> 0);
      i1 = 0;
     } else i1 = 0;
    }
   }
   i7 = i1;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 i7 = 5;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i5 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i5;
  i1 = i5;
  i7 = 10;
 } else {
  L4 : do if (!(HEAP8[i1 >> 0] | 0)) i1 = -1; else {
   i1 = HEAP32[i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   do if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     if ((i1 | 0) != -1) break;
     i4 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i4 | 0, HEAP32[i4 + 16 >> 2] | 6 | 0);
     i4 = __THREW__;
     __THREW__ = 0;
     if (!(i4 & 1)) {
      i1 = -1;
      break L4;
     }
    }
    i2 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    i3 = i5;
    i1 = i5;
    i7 = 10;
    break L1;
   } else {
    HEAP32[i2 >> 2] = i3 + 1;
    i1 = HEAPU8[i3 >> 0] | 0;
   } while (0);
   HEAP32[i4 >> 2] = 1;
  } while (0);
  i6 = i1;
 } while (0);
 do if ((i7 | 0) == 10) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   i6 = -1;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i8;
 return i6 | 0;
}

function __ZN5physx14NpArticulation14wakeUpInternalEbb(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i11 = 0, f12 = f0;
 f12 = Math_fround(HEAPF32[(__ZN5physx3Scb5Scene10getPxSceneEv(HEAP32[i10 + 12 >> 2] | 0) | 0) + 2876 >> 2]);
 i11 = i10 + 12 | 0;
 i8 = i10 + 60 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = (i2 | i1) & (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0, i10 | 0) | 0);
 i6 = f9 < f12 & i1;
 f9 = i6 ? f12 : f9;
 if (!(i6 | i7)) return;
 i2 = i10 + 92 | 0;
 L4 : do if (HEAP32[i2 >> 2] | 0) {
  i3 = i10 + 88 | 0;
  i6 = 0;
  while (1) {
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i5 = i4 + 48 | 0;
   switch ((HEAP32[i4 + 52 >> 2] | 0) >>> 30 | 0) {
   case 3:
    {
     i1 = HEAP32[i5 >> 2] | 0;
     i7 = 8;
     break;
    }
   case 2:
    {
     i1 = HEAP32[i5 >> 2] | 0;
     if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 7; else i7 = 8;
     break;
    }
   default:
    i7 = 7;
   }
   if ((i7 | 0) == 7) {
    HEAP32[i4 + 280 >> 2] = 0;
    HEAPF32[i4 + 276 >> 2] = f9;
    __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i4 + 64 | 0, f9, 1);
   } else if ((i7 | 0) == 8) {
    HEAP32[i4 + 280 >> 2] = 0;
    HEAPF32[i4 + 276 >> 2] = f9;
    __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i5);
    i7 = i4 + 284 | 0;
    HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -29360129 | 20971520;
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) break L4;
  }
 } while (0);
 HEAPF32[i8 >> 2] = f9;
 HEAP8[i10 + 64 >> 0] = 0;
 i2 = i10 + 16 | 0;
 switch ((HEAP32[i2 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i11 >> 2] | 0;
   i7 = 14;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i11 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i7 = 13; else i7 = 14;
   break;
  }
 default:
  i7 = 13;
 }
 if ((i7 | 0) == 13) {
  __ZN5physx2Sc16ArticulationCore6wakeUpEf(i10 + 24 | 0, f9);
  return;
 } else if ((i7 | 0) == 14) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i11);
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -897 | 640;
  return;
 }
}

function __ZN20BufferedSocketStreamC2Eijjb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 __ZN12SocketStreamC2Eib(i1, i2, i5);
 HEAP32[i1 >> 2] = gb + 73616 + 8;
 HEAP8[i1 + 19 >> 0] = 0;
 i2 = gb + 63560 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 20 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = 1024;
 i5 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = i2;
 i5 = __Znwj(32) | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 1024;
 HEAP32[i5 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 16, i7, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i5 + 4 >> 0] = 1;
 i8 = i7;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i5 + 28 >> 2] = 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 40 >> 2] = 0;
 i3 = gb + 63560 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 1024;
 i4 = i1 + 60 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = __Znwj(32) | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 1024;
 HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 16, i7, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i4 + 4 >> 0] = 1;
 i2 = i7;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i4 + 28 >> 2] = 0;
 i5 = i1 + 76 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 + 80 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 72 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_(i11, i1, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i9 = _strlen(i10) | 0;
 i5 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = i7 + i9 | 0;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i4 >> 2] | 0;
  i8 = 5;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i11 + 11 >> 0] = i7;
  i1 = i11;
 } else {
  i1 = i3;
  i8 = 5;
 }
 if ((i8 | 0) == 5) {
  i8 = i2 + 16 & -16;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i11 + 4 >> 2] = i7;
 }
 if (i7 | 0) _memcpy(i1 | 0, i5 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 i4 = i11 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i11 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i9 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i11, i3, i9 - i3 + i1 | 0, i1, i1, 0, i9, i10);
  STACKTOP = i12;
  return;
 }
 if (!i9) {
  STACKTOP = i12;
  return;
 }
 if (i2) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
 _memcpy(i2 + i1 | 0, i10 | 0, i9 | 0) | 0;
 i1 = i1 + i9 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i4 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNK25MultiBlocksMemoryFileData5CloneEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i1 = i10;
 i9 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63552 | 0, 16, gb + 492156 | 0, 142) | 0;
 i2 = gb + 63552 | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = i5 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i9, i8, i7);
 HEAP32[i9 + 40 >> 2] = HEAP32[i5 + 40 >> 2];
 i7 = i9 + 20 | 0;
 i8 = i5 + 32 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i9 + 32 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i9 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  break;
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i5 + 20 | 0;
 i3 = i5 + 8 | 0;
 i2 = 0;
 do {
  if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0)) HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = 0; else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, 16, i3, 0, gb + 492156 | 0, 151) | 0;
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   _memcpy(HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 * 12 | 0) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 * 12 | 0) | 0;
 return i11 | 0;
}

function __ZN5physx2Gu27checkOverlapCapsule_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4;
 i9 = i7 + 36 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i2 + 24 >> 2];
 i8 = i7 + 48 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i1 + 12 >> 2];
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(f12 + f12);
 f10 = Math_fround(f11 + f11);
 f15 = Math_fround(f18 + f18);
 f17 = Math_fround(f11 * f10);
 f16 = Math_fround(f18 * f15);
 f11 = Math_fround(f6 * f11);
 f19 = Math_fround(f6 * f18);
 f5 = Math_fround(f6 * f13);
 f18 = Math_fround(f10 * f18);
 f10 = Math_fround(f10 * f13);
 f13 = Math_fround(f15 * f13);
 f15 = Math_fround(f11 + f13);
 f14 = Math_fround(f19 - f10);
 f13 = Math_fround(f11 - f13);
 f6 = Math_fround(Math_fround(1.0) - Math_fround(f12 * f6));
 f12 = Math_fround(f6 - f16);
 f11 = Math_fround(f18 + f5);
 f10 = Math_fround(f19 + f10);
 f5 = Math_fround(f18 - f5);
 f6 = Math_fround(f6 - f17);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f17) - f16);
 HEAPF32[i7 + 4 >> 2] = f15;
 HEAPF32[i7 + 8 >> 2] = f14;
 HEAPF32[i7 + 12 >> 2] = f13;
 HEAPF32[i7 + 16 >> 2] = f12;
 HEAPF32[i7 + 20 >> 2] = f11;
 HEAPF32[i7 + 24 >> 2] = f10;
 HEAPF32[i7 + 28 >> 2] = f5;
 HEAPF32[i7 + 32 >> 2] = f6;
 f6 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i3, i3 + 12 | 0, i9, i8, i7, 0, 0));
 f5 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 i3 = f6 <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Gu24computeSphere_CapsuleMTDERKNS0_6SphereERKNS0_7CapsuleERNS_10PxSweepHitE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 i10 = i3 + 12 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i1 + 24 >> 2]));
 Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i1, i1 + 12 | 0, i3, i8));
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f7 - f14);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f6 - f13);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(f14 + Math_fround(f5 * f7));
 f6 = Math_fround(f13 + Math_fround(f5 * f6));
 f12 = Math_fround(f12 + Math_fround(f5 * Math_fround(f11 - f12)));
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2]));
 i8 = i3 + 4 | 0;
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i8 >> 2]));
 i1 = i3 + 8 | 0;
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i1 >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f12 * f12))));
 f5 = Math_fround(Math_fround(1.0) / f11);
 f7 = Math_fround(f7 * f5);
 f6 = Math_fround(f6 * f5);
 f5 = Math_fround(f12 * f5);
 HEAPF32[i2 + 28 >> 2] = f7;
 HEAPF32[i2 + 32 >> 2] = f6;
 HEAPF32[i2 + 36 >> 2] = f5;
 HEAPF32[i2 + 40 >> 2] = Math_fround(f11 - f9);
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f9 * f7);
 f6 = Math_fround(f9 * f6);
 f5 = Math_fround(f9 * f5);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i8 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i2 + 16 >> 2] = f7;
 HEAPF32[i2 + 20 >> 2] = f6;
 HEAPF32[i2 + 24 >> 2] = f5;
 STACKTOP = i4;
 return 1;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher5StartERKNS0_18CloudServiceConfigE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i4 = i6;
 i5 = i1 + 8 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((HEAP32[i5 >> 2] | 0) == 1) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i1 + 12 >> 2] = i2;
 i2 = i1 + 96 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1047136 | 0, 6);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1047143 | 0, 3);
 mftCall_viii(i8 | 0, i7 | 0, i3 | 0, i4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i2 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1047147 | 0, 12);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1047160 | 0, 16);
 mftCall_viii(i7 | 0, i2 | 0, i3 | 0, i4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = (HEAP32[i1 + 128 >> 2] | 0) == 0;
 HEAP32[i5 >> 2] = 1;
 if (!i4) {
  i8 = 1;
  STACKTOP = i6;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, fb + 3959 | 0, i1 | 0) | 0;
 i8 = 1;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN10GUITexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 52 | 0, i1);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 56 | 0, i1);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 72 | 0, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z15PlayerInitStatev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 44 | 0;
 i4 = i5 + 24 | 0;
 i2 = i5;
 i3 = i5 + 12 | 0;
 i6 = (__Z14GetPlayerPausev() | 0) == 2;
 HEAP32[i3 >> 2] = gb + 29232;
 HEAP32[i3 + 4 >> 2] = i6 & 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1105716 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1105716 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1105716 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 1105716 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 1105716 + 16 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i4, i1);
 i3 = __Z16GetScreenManagerv() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0) | 0;
 if (__Z19GetBuildSettingsPtrv() | 0) {
  HEAP32[i2 >> 2] = gb + 29232;
  HEAP32[i2 + 4 >> 2] = i3 & 1;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[gb + 1105736 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1105736 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1105736 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[gb + 1105736 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[gb + 1105736 + 16 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i4, i1);
 }
 if (!(HEAP32[(__ZN16PlayerConnection3GetEv() | 0) + 216 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] | 0) == 1) {
  STACKTOP = i5;
  return;
 }
 if (__Z12GetIVRDevicev() | 0) {
  i6 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 168 >> 2] | 0, i6 | 0) | 0) {
   STACKTOP = i5;
   return;
  }
 }
 HEAP8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] = 1;
 __Z17GetPlayerSettingsv() | 0;
 __Z14SetPlayerPause11PlayerPauseb(0, 1);
 STACKTOP = i5;
 return;
}

function __ZN26EnlightenSystemInformation8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402714 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402728 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402741 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402752 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402765 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402778 | 0, gb + 455698 | 0, i3, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 40 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402794 | 0, gb + 455698 | 0, i1, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18GfxFramebufferGLES24UpdateDefaultFramebufferEP17RenderSurfaceBaseS1_N2gl6HandleILNS2_10ObjectTypeE9EEE(i7, i1, i2, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i3 = i7 + 384 | 0;
 i6 = i3;
 i4 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i6 = i6 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 i5 = i7 + 432 | 0;
 i6 = i5;
 i1 = i2;
 i4 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i6 = i6 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 i6 = i7 + 20 | 0;
 i4 = i6 + 72 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 HEAP32[i7 + 16 >> 2] = i3;
 HEAP32[i7 + 48 >> 2] = i5;
 HEAP32[i7 + 52 >> 2] = 1;
 HEAP8[i7 + 72 >> 0] = 0;
 HEAP8[i7 + 80 >> 0] = 0;
 HEAP8[i7 + 88 >> 0] = 0;
 HEAP8[i7 + 89 >> 0] = 0;
 HEAP32[i7 + 60 >> 2] = -1;
 HEAP32[i7 + 56 >> 2] = 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i2 = i9 + 68 | 0;
 i6 = i9;
 i4 = i6 + 96 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i4 | 0));
 if (!(HEAP32[i7 + 404 >> 2] & 64)) {
  HEAP32[i9 >> 2] = 1;
  i6 = HEAP32[i7 + 16 >> 2] | 0;
  HEAP32[i9 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 36 >> 2] = HEAP32[i6 + 36 >> 2];
 } else HEAP32[i9 >> 2] = 0;
 i1 = i9 + 92 | 0;
 if (!(HEAP32[i7 + 452 >> 2] & 64)) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 72 >> 2] = HEAP32[i5 + 36 >> 2];
  HEAP32[i9 + 76 >> 2] = HEAP32[i5 + 44 >> 2];
 } else HEAP8[i1 >> 0] = 0;
 HEAP32[i9 + 80 >> 2] = 0;
 HEAP32[i9 + 84 >> 2] = 0;
 HEAP32[i9 + 88 >> 2] = -1;
 i9 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i7, i9) | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i7 + 376 | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function __ZN14ShadowSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 380976 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374360 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374379 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374390 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374397 | 0, i5, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 374410 | 0, i5, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 150616 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 150616 + 96;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 150616 + 120;
 i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = i3 + 172 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0);
 i2 = HEAP32[i3 + 40 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
 HEAP32[i3 + 192 >> 2] = gb + 148172 + 8;
 i2 = i3 + 204 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i3 + 196 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i3 + 148 >> 2] = gb + 150800 + 8;
 i2 = HEAP32[i3 + 168 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i3 + 152 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i3 + 160 >> 2] | 0);
 }
 HEAP32[i3 + 96 >> 2] = gb + 150768 + 8;
 i1 = HEAP32[i3 + 108 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 + 100 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 }
 HEAP32[i3 + 44 >> 2] = gb + 150752 + 8;
 i1 = HEAP32[i3 + 56 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 + 48 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 }
 HEAP32[i3 + 24 >> 2] = gb + 148172 + 8;
 i1 = i3 + 36 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i11 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i3, HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i6) >> 2] | 0, i10);
 i6 = i10 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i5 = i10 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i1;
 i7 = i11 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i11 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i9, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i10 >> 2] | 0 : i10;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 i3 = i1 + i5 | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 STACKTOP = i12;
 return;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteUint64Ey(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i11 = __ZN9rapidjson8internal6u64toaEyPc(i1, i2, i6) | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 12 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + (i11 - i6) | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = i10;
  break;
 } while (0);
 if ((i6 | 0) == (i11 | 0)) {
  STACKTOP = i13;
  return 1;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = i2 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i7 = i5 + 1 | 0;
  i8 = i2 + 16 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i7;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i5 >> 0] = i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 STACKTOP = i13;
 return 1;
}

function __ZN23ShaderVariantCollection13WarmupShadersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 200 | 0;
 i6 = i7;
 i1 = i5 + 44 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 if (!(HEAP32[i5 + 40 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(HEAP8[i1 + 4192 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 496 >> 2] | 0, i1 | 0);
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0) {
   i3 = 1;
   i2 = 5;
  }
 } else {
  i3 = 0;
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  if ((HEAP16[gb + 1166372 + 6 >> 1] | 0) > -1) {
   HEAP32[i6 >> 2] = i5;
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1166372 | 0, i4);
   i2 = gb + 1166372 | 0;
  } else i2 = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = -1;
  HEAP32[i4 + 12 >> 2] = 0;
  i1 = __Z12GetGfxDevicev() | 0;
  if ((HEAP32[i1 + 4388 >> 2] | 0) != 4) {
   i1 = __ZN9GfxDevice13GetDynamicVBOEv(i1) | 0;
   if (mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 60, 3, 0, 1, i4 | 0) | 0) {
    _memset(HEAP32[i4 >> 2] | 0, 0, 180) | 0;
    mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i4 | 0, 3, 0);
    __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i6, __Z12GetGfxDevicev() | 0);
    __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
    __ZN23ShaderVariantCollection17WarmupShadersImplEPFvP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContextES9_SA_(i5, fb + 24 | 0, i1, i4);
    __ZN22DeviceMVPMatricesStateD2Ev(i6);
   }
  }
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  if (!(i3 << 24 >> 24)) {
   STACKTOP = i7;
   return;
  }
 }
 i6 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 500 >> 2] | 0, i6 | 0);
 STACKTOP = i7;
 return;
}

function __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_(i8, i1, i12, i13) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i9 = (i1 - i11 | 0) / 40 | 0;
 i7 = i8 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i10 = i2 - i9 | 0;
 i2 = i2 + i12 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i11;
 i1 = i11;
 do if (i5 >>> 0 < i2 >>> 0) {
  i11 = i4 << 1;
  i2 = i11 >>> 0 > i2 >>> 0 ? i11 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 40 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  }
 } while (0);
 i11 = i1 + (i9 * 40 | 0) | 0;
 _memmove(i11 + (i12 * 40 | 0) | 0, i11 | 0, i10 * 40 | 0) | 0;
 if (!i12) return i11 | 0;
 i2 = i13 + 4 | 0;
 i3 = i13 + 8 | 0;
 i4 = i13 + 12 | 0;
 i5 = i13 + 16 | 0;
 i6 = i13 + 20 | 0;
 i7 = i13 + 24 | 0;
 i8 = i13 + 28 | 0;
 i9 = i13 + 32 | 0;
 i10 = i13 + 36 | 0;
 i1 = 0;
 do {
  HEAP32[i11 + (i1 * 40 | 0) >> 2] = HEAP32[i13 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 24 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 28 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 32 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i11 + (i1 * 40 | 0) + 36 >> 2] = HEAP32[i10 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 return i11 | 0;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper17pushBracketedNameEPKcS2_S2_(i11, i8, i9, i10) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 4 | 0;
 i2 = i12;
 i3 = i11 + 12 | 0;
 i4 = i11 + 28 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 >> 2] = i5;
 i6 = i11 + 52 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i11 + 56 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
  HEAP32[(HEAP32[i11 + 48 >> 2] | 0) + (i7 << 2) >> 2] = i5;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj(i11 + 36 | 0, i2) | 0;
 if (i9 | 0) {
  i7 = _strlen(i9) | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i5 = (i6 | 0) == 0;
  HEAP8[i1 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i3, i6 + i7 + (i5 & 1) | 0, i1);
  _memcpy((HEAP32[i11 + 24 >> 2] | 0) + (i5 ? 0 : i6 + -1 | 0) | 0, i9 | 0, i7 | 0) | 0;
 }
 if (i8 | 0) {
  i9 = _strlen(i8) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i6 = (i7 | 0) == 0;
  HEAP8[i1 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i3, i7 + i9 + (i6 & 1) | 0, i1);
  _memcpy((HEAP32[i11 + 24 >> 2] | 0) + (i6 ? 0 : i7 + -1 | 0) | 0, i8 | 0, i9 | 0) | 0;
 }
 if (!i10) {
  i10 = i11 + 24 | 0;
  i11 = HEAP32[i4 >> 2] | 0;
  i11 = i11 + -1 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i10 + i11 | 0;
  HEAP8[i11 >> 0] = 0;
  STACKTOP = i12;
  return;
 } else {
  i9 = _strlen(i10) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i7 = (i8 | 0) == 0;
  HEAP8[i1 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i3, i8 + i9 + (i7 & 1) | 0, i1);
  i11 = i11 + 24 | 0;
  _memcpy((HEAP32[i11 >> 2] | 0) + (i7 ? 0 : i8 + -1 | 0) | 0, i10 | 0, i9 | 0) | 0;
  i10 = i11;
  i11 = HEAP32[i4 >> 2] | 0;
  i11 = i11 + -1 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i10 + i11 | 0;
  HEAP8[i11 >> 0] = 0;
  STACKTOP = i12;
  return;
 }
}

function __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i9, i3, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP32[i3 + 20 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i4 | 0)) {
  i5 = HEAP32[i3 + 32 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) {
    i3 = 0;
    i7 = 0;
    break L1;
   }
  }
  if ((i1 | 0) > -1) {
   __ZNK19ShaderPropertySheet14GetMatrixArrayEi(i8, i3, i1);
   i3 = HEAP32[i8 >> 2] | 0;
   i7 = HEAP32[i8 + 4 >> 2] | 0;
  } else {
   i3 = 0;
   i7 = 0;
  }
 } else {
  i3 = 0;
  i7 = 0;
 } while (0);
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 260 >> 2] | 0;
 i2 = i9 + 8 | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0) >>> 0 < i7 >>> 0) {
  i6 = __Z19scripting_array_newP11Il2CppClassjj(i1, 64, i7) | 0;
  HEAP32[i2 >> 2] = i6;
 } else i6 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 if ((i7 | 0) <= 0) {
  i8 = i9 + 12 | 0;
  HEAP32[i8 >> 2] = i7;
  i9 = i9 + 16 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i8 = i8 + 1 | 0;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i10;
  return;
 }
 i1 = 0;
 while (1) {
  i2 = i8;
  i4 = i3;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, i1, 64) | 0;
  i4 = i8;
  i5 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i2 = i2 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i2 | 0) < (i5 | 0));
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i7 | 0)) break; else i3 = i3 + 64 | 0;
 }
 i8 = i9 + 12 | 0;
 HEAP32[i8 >> 2] = i7;
 i9 = i9 + 16 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i8 = i8 + 1 | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function _UNITY_FT_MulDiv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = i1 >> 31 | 1;
 i4 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i1 = (i2 | 0) < 0;
 i7 = i1 ? 0 - i7 | 0 : i7;
 i1 = i1 ? 0 - i2 | 0 : i2;
 i5 = (i3 | 0) < 0;
 i6 = i5 ? 0 - i3 | 0 : i3;
 i7 = i5 ? 0 - i7 | 0 : i7;
 if (!i6) {
  i6 = 2147483647;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 if ((i1 + i4 | 0) >>> 0 <= (129894 - (i6 >>> 17) | 0) >>> 0) {
  i6 = (((i6 >>> 1) + (Math_imul(i1, i4) | 0) | 0) >>> 0) / (i6 >>> 0) | 0;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 i3 = i4 & 65535;
 i8 = i4 >>> 16;
 i10 = i1 & 65535;
 i9 = i1 >>> 16;
 i4 = Math_imul(i10, i8) | 0;
 i2 = (Math_imul(i9, i3) | 0) + i4 | 0;
 i5 = i2 << 16;
 i1 = i5 + (Math_imul(i10, i3) | 0) | 0;
 i3 = i1 + (i6 >>> 1) | 0;
 i1 = (i2 >>> 16) + (Math_imul(i9, i8) | 0) + ((i2 >>> 0 < i4 >>> 0 & 1) << 16) + (i1 >>> 0 < i5 >>> 0 & 1) + (i3 >>> 0 < i1 >>> 0 & 1) | 0;
 if (!i1) {
  i10 = (i3 >>> 0) / (i6 >>> 0) | 0;
  i8 = (i7 | 0) < 0;
  i9 = 0 - i10 | 0;
  i10 = i8 ? i9 : i10;
  return i10 | 0;
 }
 if (i1 >>> 0 >= i6 >>> 0) {
  i10 = 2147483647;
  i8 = (i7 | 0) < 0;
  i9 = 0 - i10 | 0;
  i10 = i8 ? i9 : i10;
  return i10 | 0;
 }
 i10 = i1 >>> 0 > 65535;
 i4 = i10 ? i1 >>> 16 : i1;
 i10 = i10 ? 16 : 0;
 i5 = (i4 & 65280 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 8;
 i10 = i5 ? i10 : i10 | 8;
 i5 = (i4 & 240 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 4;
 i10 = i5 ? i10 : i10 | 4;
 i5 = (i4 & 12 | 0) == 0;
 i4 = 31 - (i5 ? i10 : i10 | 2) - ((i5 ? i4 : i4 >>> 2) >>> 1 & 1) | 0;
 i5 = 32 - i4 | 0;
 i10 = i3 >>> i5 | i1 << i4;
 i2 = (i10 >>> 0) / (i6 >>> 0) | 0;
 i1 = i2;
 i2 = i10 - (Math_imul(i2, i6) | 0) | 0;
 i4 = i3 << i4;
 while (1) {
  i2 = i2 << 1 | i4 >>> 31;
  i3 = i2 >>> 0 < i6 >>> 0;
  i1 = (i3 & 1 | i1 << 1) ^ 1;
  i5 = i5 + -1 | 0;
  if (!i5) break; else {
   i2 = i2 - (i3 ? 0 : i6) | 0;
   i4 = i4 << 1;
  }
 }
 i9 = (i7 | 0) < 0;
 i10 = 0 - i1 | 0;
 i10 = i9 ? i10 : i1;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i3 = i3 + 8 | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  i2 = i4 - i5 | 0;
  if (i2) {
   _memset(i1 + i5 | 0, 0, i2 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + i7 | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i8 >> 0] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i3 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i3 = i3 + 8 | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 1, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  i2 = i4 - i5 | 0;
  if (i2) {
   _memset(i1 + i5 | 0, 0, i2 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + i7 | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
   i2 = HEAP8[i8 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i8 >> 0] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN14AnimationState11SetWrapModeEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 HEAP32[i3 + 68 >> 2] = i4;
 f1 = Math_fround(+HEAPF64[i3 + 16 >> 3]);
 f5 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 92 >> 2]);
 L1 : do if (!(f6 <= f1)) {
  if (f5 > f1) {
   switch (i4 | 0) {
   case 1:
   case 8:
    {
     f1 = f5;
     break L1;
    }
   case 2:
    {
     f7 = Math_fround(f1 - f5);
     f1 = Math_fround(f6 - f5);
     f1 = Math_fround(f5 + Math_fround(f7 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f7 / f1))))));
     break L1;
    }
   default:
    {}
   }
   if ((i4 | 0) == 4) {
    f7 = Math_fround(f1 - f5);
    f8 = Math_fround(f6 - f5);
    f1 = Math_fround(f8 * Math_fround(2.0));
    f1 = Math_fround(Math_fround(f7 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f7 / f1))))) - f8);
    i2 = f1 < Math_fround(0.0);
    f7 = Math_fround(-f1);
    f1 = Math_fround(f5 + Math_fround(f8 - (i2 ? f7 : f1)));
   }
  }
 } else {
  switch (i4 | 0) {
  case 1:
  case 8:
   {
    f1 = f6;
    break L1;
   }
  case 2:
   {
    f8 = Math_fround(f1 - f5);
    f1 = Math_fround(f6 - f5);
    f1 = Math_fround(f5 + Math_fround(f8 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f8 / f1))))));
    break L1;
   }
  default:
   {}
  }
  if ((i4 | 0) == 4) {
   f8 = Math_fround(f1 - f5);
   f7 = Math_fround(f6 - f5);
   f1 = Math_fround(f7 * Math_fround(2.0));
   f1 = Math_fround(Math_fround(f8 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f8 / f1))))) - f7);
   i2 = f1 < Math_fround(0.0);
   f8 = Math_fround(-f1);
   f1 = Math_fround(f5 + Math_fround(f7 - (i2 ? f8 : f1)));
  }
 } while (0);
 HEAPF32[i3 + 12 >> 2] = f1;
 i2 = Math_fround(HEAPF32[i3 + 36 >> 2]) >= Math_fround(0.0);
 if ((i4 | 1 | 0) != 1) {
  f8 = i2 ? Math_fround(inf) : Math_fround(-inf);
  i4 = i3 + 44 | 0;
  HEAPF32[i4 >> 2] = f8;
  return;
 }
 if (i2) {
  f8 = f6;
  i4 = i3 + 44 | 0;
  HEAPF32[i4 >> 2] = f8;
  return;
 }
 f8 = f5;
 i4 = i3 + 44 | 0;
 HEAPF32[i4 >> 2] = f8;
 return;
}

function __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE11lower_boundIS1_EENS2_11__wrap_iterIPS1_EERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - i3 | 0;
 if (!i1) {
  i17 = i3;
  return i17 | 0;
 }
 i9 = HEAP32[i2 + 32 >> 2] | 0;
 i10 = HEAP32[i2 + 28 >> 2] | 0;
 i11 = HEAP32[i2 + 24 >> 2] | 0;
 i12 = HEAP32[i2 + 20 >> 2] | 0;
 i13 = HEAP32[i2 + 16 >> 2] | 0;
 i14 = HEAP32[i2 + 12 >> 2] | 0;
 i15 = HEAP32[i2 + 8 >> 2] | 0;
 i16 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = (i1 | 0) / 36 | 0;
 i1 = i3;
 do {
  i6 = (i2 | 0) / 2 | 0;
  i7 = i3 + (i6 * 36 | 0) | 0;
  i4 = HEAP32[i3 + (i6 * 36 | 0) + 32 >> 2] | 0;
  do if ((i4 | 0) == (i9 | 0)) {
   i4 = HEAP32[i3 + (i6 * 36 | 0) + 28 >> 2] | 0;
   if ((i4 | 0) == (i10 | 0)) {
    i4 = HEAP32[i3 + (i6 * 36 | 0) + 24 >> 2] | 0;
    if ((i4 | 0) == (i11 | 0)) {
     i4 = HEAP32[i3 + (i6 * 36 | 0) + 20 >> 2] | 0;
     if ((i4 | 0) == (i12 | 0)) {
      i4 = HEAP32[i3 + (i6 * 36 | 0) + 16 >> 2] | 0;
      if ((i4 | 0) == (i13 | 0)) {
       i4 = HEAP32[i3 + (i6 * 36 | 0) + 12 >> 2] | 0;
       if ((i4 | 0) == (i14 | 0)) {
        i4 = HEAP32[i3 + (i6 * 36 | 0) + 8 >> 2] | 0;
        if ((i4 | 0) == (i15 | 0)) {
         i4 = HEAP32[i3 + (i6 * 36 | 0) + 4 >> 2] | 0;
         if ((i4 | 0) == (i16 | 0)) {
          i4 = HEAP32[i7 >> 2] | 0;
          if ((i4 | 0) == (i8 | 0)) {
           i2 = i6;
           break;
          } else i5 = i8;
         } else i5 = i16;
        } else i5 = i15;
       } else i5 = i14;
      } else i5 = i13;
     } else i5 = i12;
    } else i5 = i11;
   } else i5 = i10;
   if (i4 >>> 0 < i5 >>> 0) i17 = 15; else i2 = i6;
  } else if ((i4 | 0) < (i9 | 0)) i17 = 15; else i2 = i6; while (0);
  if ((i17 | 0) == 15) {
   i17 = 0;
   i3 = i7 + 36 | 0;
   i2 = i2 + -1 - i6 | 0;
   i1 = i3;
  }
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __Z24LoadImageIntoTextureImplI11JpegDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE(i5, i1, i2, i6, i7, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14 + 24 | 0;
 i8 = i14;
 i9 = i11 + 4 | 0;
 HEAP8[i9 >> 0] = 0;
 i3 = i11 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i11 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = gb + 43136 + 8;
 i12 = i11 + 32 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i11 + 36 | 0;
 HEAP32[i13 >> 2] = 0;
 if (!i1) {
  HEAP8[i9 >> 0] = 1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i15 = i11 + 24 | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i11 + 28 >> 2] = i2;
  HEAP32[i11 + 16 >> 2] = i15;
  HEAP32[i11 + 20 >> 2] = fb + 351;
  __ZN11JpegDecoder11InitDecoderEv(i11);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 if (__ZL26InitializeTextureImageLoadR9Texture2D13TextureFormatjjbR14ImageReferenceR13dynamic_arrayIhLj1EE(i5, i6 ? 12 : i7, i2, i1, i6, i8, i10) | 0) {
  mftCall_viiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, HEAP32[i8 + 16 >> 2] | 0, HEAP32[i8 + 12 >> 2] | 0, 1, HEAP32[i8 >> 2] | 0);
  if (!(HEAP8[i9 >> 0] | 0)) i2 = 1; else {
   i1 = i10 + 16 | 0;
   if ((HEAP32[i1 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i10 + 4 | 0);
    HEAP32[i10 >> 2] = 0;
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i2 = 0;
  }
 } else i2 = 0;
 HEAP32[i11 >> 2] = gb + 43136 + 8;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i1 | 0) {
  _jpeg_destroy_decompress(i1);
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return i2 | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i14;
 return i2 | 0;
}

function __ZNK9ShaderLab4Pass21ComputePassValuesHashERK16ShaderKeywordSetPK19ShaderPropertySheetRK17ShaderPassContextP6Shader(i7, i8, i10, i4, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i14 = i13;
 i12 = i13 + 16 | 0;
 i2 = i7;
 i11 = gb + 64016 | 0;
 i9 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i14;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i12 >> 2] = 0;
 i5 = i12 + 12 | 0;
 i9 = i12 + 16 | 0;
 i11 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i14);
 i14 = i6;
 i3 = HEAP32[i14 + 4 >> 2] | 0;
 i1 = i11;
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = 36;
 HEAP32[i9 >> 2] = 36;
 i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 36, 4, i11, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i12 >> 2] = i1;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 i1 = (HEAP32[i12 >> 2] | 0) + 4 | 0;
 i2 = i8;
 i3 = i1 + 32 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i4 + 36 | 0;
 i2 = 0;
 do {
  i1 = HEAP32[i7 + 32 + (i2 << 2) >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK9ShaderLab7Program21GetMatchingSubProgramEPK6ShaderPKNS_4PassERK16ShaderKeywordSetjPS7_R19ShaderSnippetResult(i1, 0, 0, i8, 0, 0, i6) | 0;
   if (i1 | 0) __ZNK20GpuProgramParameters13PrepareValuesEPK19ShaderPropertySheetS2_R13dynamic_arrayIhLj4EEjP12GfxPatchInfoPb(HEAP32[i1 >> 2] | 0, i10, i3, i12, 0, 0, 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 i1 = __Z12MurmurHash2APKvij(HEAP32[i12 >> 2] | 0, HEAP32[i5 >> 2] | 0, -1756908916) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNK13BuildSettings15GetHashOfScriptERK7Hash128(i14, i1, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = HEAP32[i1 + 96 >> 2] | 0;
 i13 = HEAP32[i1 + 100 >> 2] | 0;
 i1 = i13 - i2 >> 5;
 if (!i1) i1 = i2; else {
  i9 = i15;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i15 + 8 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = i1;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i7 | 0) / 2 | 0;
   i4 = i3 + (i2 << 5) | 0;
   i6 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i5 | 0) == (i8 | 0) & (i6 | 0) == (i9 | 0)) {
    i6 = i3 + (i2 << 5) + 8 | 0;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    if (i5 >>> 0 < i11 >>> 0 | ((i5 | 0) == (i11 | 0) ? (HEAP32[i6 >> 2] | 0) >>> 0 < i10 >>> 0 : 0)) i12 = 7;
   } else if (i6 >>> 0 < i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0) i12 = 7;
   if ((i12 | 0) == 7) {
    i12 = 0;
    i3 = i4 + 32 | 0;
    i2 = i7 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i7 = i2;
  }
 }
 do if ((i1 | 0) != (i13 | 0)) {
  i3 = i15;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
   i12 = i15 + 8 | 0;
   i10 = HEAP32[i12 + 4 >> 2] | 0;
   i15 = i1 + 8 | 0;
   i11 = HEAP32[i15 + 4 >> 2] | 0;
   if (i10 >>> 0 < i11 >>> 0 | ((i10 | 0) == (i11 | 0) ? (HEAP32[i12 >> 2] | 0) >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0 : 0) | (i1 | 0) == (i13 | 0)) break;
  } else if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0 | (i1 | 0) == (i13 | 0)) break;
  i15 = i1 + 16 | 0;
  HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
  HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
  HEAP32[i14 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
  return;
 } while (0);
 HEAP32[i14 >> 2] = 0;
 HEAP32[i14 + 4 >> 2] = 0;
 HEAP32[i14 + 8 >> 2] = 0;
 HEAP32[i14 + 12 >> 2] = 0;
 return;
}

function __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv(i9, i2, i13, i1, i14, i15, i16, i17, i18, i19, i10, i3, i11) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i20 = 0;
 i12 = i9 + 860 | 0;
 i1 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i12 >> 2] | 0, i1) | 0;
 i4 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i13) | 0;
 i5 = i9 + 1600 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i9 + 1604 + (i7 << 2) >> 2] | 0;
 i7 = HEAP32[i9 + 1732 + (i7 << 2) >> 2] | 0;
 i8 = i9 + 1992 | 0;
 if (!((HEAP8[i8 >> 0] | 0) != 0 & (i6 | 0) == (i2 | 0))) {
  i20 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i13) | 0;
  mftCall_vii(HEAP32[i9 + 812 >> 2] | 0, i20 | 0, i2 | 0);
  HEAP32[i9 + 1604 + (HEAP32[i5 >> 2] << 2) >> 2] = i2;
  HEAP32[i9 + 1732 + (HEAP32[i5 >> 2] << 2) >> 2] = i13;
 }
 do if (!(HEAP32[i1 + 12 >> 2] & 1)) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((i13 | 0) == 3) {
   mftCall_viiiiiiiiiii(HEAP32[i9 + 580 >> 2] | 0, i4 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i10 | 0, i2 | 0, i1 | 0, i11 | 0);
   break;
  } else {
   mftCall_viiiiiiiii(HEAP32[i9 + 576 >> 2] | 0, i4 | 0, i14 | 0, i15 | 0, i16 | 0, i18 | 0, i19 | 0, i2 | 0, i1 | 0, i11 | 0);
   break;
  }
 } else mftCall_viiiiiiiii(HEAP32[i9 + 596 >> 2] | 0, i4 | 0, i14 | 0, i15 | 0, i16 | 0, i18 | 0, i19 | 0, HEAP32[i1 >> 2] | 0, i3 | 0, i11 | 0); while (0);
 if (HEAP8[i8 >> 0] | 0) if ((HEAP32[i9 + 1604 + (HEAP32[i5 >> 2] << 2) >> 2] | 0) == (i6 | 0)) return;
 i20 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 >> 2] | 0, i7) | 0;
 mftCall_vii(HEAP32[i9 + 812 >> 2] | 0, i20 | 0, i6 | 0);
 HEAP32[i9 + 1604 + (HEAP32[i5 >> 2] << 2) >> 2] = i6;
 HEAP32[i9 + 1732 + (HEAP32[i5 >> 2] << 2) >> 2] = i7;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i6 = i12 + 20 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i7 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 28 >> 2])) >>> 0;
 i2 = i1 << 2;
 i10 = (i7 << 2) + i2 | 0;
 i10 = (0 - i10 & 12) + i10 | 0;
 i8 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i8 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i10 + (i7 << 3) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i9 = i8 + i2 | 0;
 i10 = i8 + i10 | 0;
 _memset(i8 | 0, -1, i2 | 0) | 0;
 i2 = i12 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  i4 = i1 + -1 | 0;
  i5 = 0;
  do {
   i14 = i3 + (i5 << 3) | 0;
   i15 = HEAP32[i14 >> 2] | 0;
   i15 = i15 + ~(i15 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i8 + (((i15 >>> 16 ^ i15) & i4) << 2) | 0;
   HEAP32[i9 + (i5 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   HEAP32[i10 + (i5 << 3) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i10 + (i5 << 3) + 4 >> 2] = HEAP32[i3 + (i5 << 3) + 4 >> 2];
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i15 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i8;
 HEAP32[i12 + 16 >> 2] = i8;
 HEAP32[i12 + 24 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i7;
 i1 = i12 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN22BlockMemoryCacheWriter12ResizeBlocksEj(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i6 + 20 | 0;
 i7 = i6 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 > i8 >>> 0) {
  i3 = i6 + 12 | 0;
  i2 = i8;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i5 = i6 + 36 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = i3 & 2147483647;
 do if (i2 >>> 0 < i8 >>> 0) {
  i4 = i3 << 1;
  if (i2 >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i3 << 3, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i3 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i3;
   i3 = i4;
   break;
  }
 } while (0);
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i5 >> 2] = i8;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i8 << 2, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 2, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i5 >> 2] = i8;
  HEAP32[i9 >> 2] = i4;
  break;
 } while (0);
 if (i2 >>> 0 < i8 >>> 0) _memset((HEAP32[i9 >> 2] | 0) + (i2 << 2) | 0, 0, i8 - i2 << 2 | 0) | 0;
 if (i1 >>> 0 >= i8 >>> 0) return;
 i2 = i6 + 12 | 0;
 do {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 16, i2, 0, gb + 391399 | 0, 67) | 0;
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i7;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i4 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i5 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 8 | 0, i4);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 2);
  i1 = HEAP16[i6 >> 1] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i6 >> 1] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP16[i5 + 12 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 1 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i4;
  HEAP32[i7 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 14 >> 0] = i1;
 i1 = i5 + 15 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z21TransferBlobSerializeIN7mecanim9animation18ControllerConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i5, i7, i6, i1, i9) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i1, HEAP32[gb + 37304 >> 2] | 0, i8, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i9 + 16 | 0;
   i3 = HEAP32[i9 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i9 + 36 >> 2] | 0, 0 - (HEAP32[i9 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i4 = 6; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
   if (HEAP32[i9 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i9 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i9);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i2, HEAP32[i6 >> 2] | 0);
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 24, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i5 >> 2] = i2;
 } else i2 = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i9, i7, gb + 910060 | 0, i8, 1) | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) > 0) __ZN7mecanim9animation18ControllerConstant8TransferI14SafeBinaryReadEEvRT_(i2, i9); else {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i9 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i9);
 STACKTOP = i10;
 return;
}

function _start_pass(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = HEAP32[i8 + 412 >> 2] | 0;
 i10 = i8 + 36 | 0;
 if ((HEAP32[i10 >> 2] | 0) <= 0) return;
 i11 = i8 + 68 | 0;
 i6 = HEAP32[i8 + 196 >> 2] | 0;
 i3 = 0;
 i1 = 0;
 i7 = 0;
 while (1) {
  i2 = HEAP32[i6 + 36 >> 2] | 0;
  L6 : do if ((i2 | 0) == 8) switch (HEAP32[i11 >> 2] | 0) {
  case 0:
   {
    i3 = (_jsimd_can_idct_islow() | 0) == 0;
    i1 = 0;
    i3 = i3 ? fb + 114 | 0 : fb + 115 | 0;
    break L6;
   }
  case 1:
   {
    i3 = (_jsimd_can_idct_ifast() | 0) == 0;
    i1 = 1;
    i3 = i3 ? fb + 116 | 0 : fb + 117 | 0;
    break L6;
   }
  default:
   {
    i5 = HEAP32[i8 >> 2] | 0;
    HEAP32[i5 + 20 >> 2] = 48;
    mftCall_vi(HEAP32[i5 >> 2] | 0, i8 | 0);
    break L6;
   }
  } else {
   i5 = HEAP32[i8 >> 2] | 0;
   HEAP32[i5 + 20 >> 2] = 7;
   HEAP32[i5 + 24 >> 2] = i2;
   mftCall_vi(HEAP32[i5 >> 2] | 0, i8 | 0);
  } while (0);
  HEAP32[i9 + 4 + (i7 << 2) >> 2] = i3;
  L14 : do if (HEAP8[i6 + 48 >> 0] | 0) {
   i2 = i9 + 44 + (i7 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) {
    i5 = HEAP32[i6 + 76 >> 2] | 0;
    if (i5 | 0) {
     HEAP32[i2 >> 2] = i1;
     switch (i1 | 0) {
     case 0:
      {
       i4 = HEAP32[i6 + 80 >> 2] | 0;
       i2 = 0;
       do {
        HEAP32[i4 + (i2 << 2) >> 2] = HEAPU16[i5 + (i2 << 1) >> 1];
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 64);
       break;
      }
     case 1:
      {
       i4 = HEAP32[i6 + 80 >> 2] | 0;
       i2 = 0;
       do {
        HEAP32[i4 + (i2 << 2) >> 2] = (Math_imul(HEAP16[gb + 216784 + (i2 << 1) >> 1] | 0, HEAPU16[i5 + (i2 << 1) >> 1] | 0) | 0) + 2048 >> 12;
        i2 = i2 + 1 | 0;
       } while ((i2 | 0) != 64);
       break;
      }
     default:
      {
       i5 = HEAP32[i8 >> 2] | 0;
       HEAP32[i5 + 20 >> 2] = 48;
       mftCall_vi(HEAP32[i5 >> 2] | 0, i8 | 0);
       break L14;
      }
     }
    }
   }
  } while (0);
  i7 = i7 + 1 | 0;
  if ((i7 | 0) >= (HEAP32[i10 >> 2] | 0)) break; else i6 = i6 + 84 | 0;
 }
 return;
}

function __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(Math_fround(1.0) - f5);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i9 = (i2 >>> 16) * 3 | 0;
  f10 = Math_fround(Math_fround((i2 & 65535) >>> 0) * Math_fround(.0000152587891));
  f12 = Math_fround(Math_fround(1.0) - f10);
  i16 = i9 + 3 | 0;
  f14 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i9 << 2) >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i16 << 2) >> 2])))));
  i16 = i9 + 1 | 0;
  f11 = Math_fround(HEAPF32[i7 + (i16 << 2) >> 2]);
  i15 = i9 + 4 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i16 << 2) >> 2]);
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 + 2 | 0;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i9 = i9 + 5 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i9 << 2) >> 2])))));
  i1 = i1 + -1 | 0;
  if (!i1) break; else {
   i3 = i3 + 12 | 0;
   i2 = i4 + i2 | 0;
  }
 }
 return;
}

function __ZN5physx31PxDefaultSimulationFilterShaderEjNS_12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj(i7, i9, i8, i10, i11, i1, i2) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 32 | 0;
 i4 = i6 + 24 | 0;
 i3 = i6 + 16 | 0;
 i5 = i6 + 8 | 0;
 i1 = i6;
 if ((i8 | i7) & 32 | 0) {
  HEAP16[i11 >> 1] = 1044;
  i11 = 0;
  STACKTOP = i6;
  return i11 | 0;
 }
 if (!(HEAP8[(HEAP32[i10 >> 2] | 0) + (gb + 1550009 + (HEAP32[i9 >> 2] << 5)) >> 0] | 0)) {
  i11 = 2;
  STACKTOP = i6;
  return i11 | 0;
 }
 i8 = HEAP32[i9 + 8 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP16[i2 >> 1] = i8;
 HEAP16[i2 + 2 >> 1] = i8 >>> 16;
 HEAP16[i2 + 4 >> 1] = i9;
 HEAP16[i2 + 6 >> 1] = i9 >>> 16;
 i9 = HEAP32[i10 + 8 >> 2] | 0;
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP16[i4 >> 1] = i9;
 HEAP16[i4 + 2 >> 1] = i9 >>> 16;
 HEAP16[i4 + 4 >> 1] = i10;
 HEAP16[i4 + 6 >> 1] = i10 >>> 16;
 i10 = i3;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 mftCall_viii(HEAP32[gb + 114428 + (HEAP32[gb + 1457424 >> 2] << 2) >> 2] | 0, i3 | 0, i2 | 0, gb + 1098832 | 0);
 i10 = i5;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 mftCall_viii(HEAP32[gb + 114428 + (HEAP32[gb + 1457428 >> 2] << 2) >> 2] | 0, i5 | 0, i4 | 0, gb + 1098832 + 8 | 0);
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 mftCall_viii(HEAP32[gb + 114428 + (HEAP32[gb + 1457432 >> 2] << 2) >> 2] | 0, i1 | 0, i3 | 0, i5 | 0);
 i10 = HEAP32[i1 >> 2] | 0;
 if ((i10 & 65535) << 16 >> 16 == 0 & i10 >>> 0 < 65536) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i1 >>> 0 > 65535 | (i1 & 65535) << 16 >> 16 != 0;
 } else i1 = 1;
 if ((i1 & 1 | 0) != (HEAPU8[gb + 1551035 >> 0] | 0)) {
  i11 = 2;
  STACKTOP = i6;
  return i11 | 0;
 }
 HEAP16[i11 >> 1] = 1025;
 i11 = 0;
 STACKTOP = i6;
 return i11 | 0;
}

function __ZN12TreeDatabase7AddTreeERK12TreeInstance(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 if ((i2 | 0) >= 0) if (i2 >>> 0 < (HEAP32[i4 + 8 >> 2] | 0) - (HEAP32[i4 + 4 >> 2] | 0) >> 3 >>> 0) {
  i2 = i4 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 + 24 >> 2] | 0)) {
   __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i4 + 16 | 0, i5);
   i1 = i5 + 8 | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   i3 = i5 + 8 | 0;
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
   i1 = i1 + 12 | 0;
   i8 = i5 + 12 | 0;
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 40;
   i1 = i3;
  }
  i8 = (HEAP32[i4 >> 2] | 0) + 248 | 0;
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  f9 = Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i8, f9, Math_fround(HEAPF32[i1 >> 2])));
  __ZNK9Heightmap7GetSizeEv(i6, i8);
  f9 = Math_fround(f9 / Math_fround(HEAPF32[i6 + 4 >> 2]));
  HEAPF32[(HEAP32[i2 >> 2] | 0) + -36 >> 2] = f9;
  __ZN12TreeDatabase13ValidateTreesEv(i4);
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(HEAP32[i4 >> 2] | 0, 2);
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = i2;
 __Z6FormatPKcz(i1, gb + 936842 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 933103 | 0, 355, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i8 = 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNK11NoiseModule22GeneratePreviewTextureEP9Texture2D(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 i5 = Math_imul(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0) | 0, i5) | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 i9 = gb + 63160 | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 << 4;
 do if (!i1) i1 = 0; else {
  i2 = (i1 | 4) + -1 | 0;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 613471 | 0, 743) | 0;
   i2 = gb + 64016 | 0;
   i10 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   i9 = i6;
   HEAP32[i9 >> 2] = i10;
   HEAP32[i9 + 4 >> 2] = i2;
   break;
  }
 } while (0);
 i1 = i1 + 3 & -4;
 switch (HEAP32[i3 + 820 >> 2] | 0) {
 case 0:
  {
   __ZNK11NoiseModule12PreviewNoiseILi1EEEvP9Texture2DP10ColorRGBAf(i3, i4, i1);
   break;
  }
 case 1:
  {
   __ZNK11NoiseModule12PreviewNoiseILi2EEEvP9Texture2DP10ColorRGBAf(i3, i4, i1);
   break;
  }
 case 2:
  {
   __ZNK11NoiseModule12PreviewNoiseILi3EEEvP9Texture2DP10ColorRGBAf(i3, i4, i1);
   break;
  }
 default:
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 613414 | 0, 0, gb + 613471 | 0, 757, 1, 0, 0, 0);
 }
 HEAP8[i4 + 111 >> 0] = 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii(i4, 0, 0, i10, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0) | 0, i5, i1, 0, 0);
 __ZN9Texture2D5ApplyEbb(i4, 0, 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, i16 = 0, i17 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i14 + 28 | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 f15 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f15 * Math_fround(HEAPF32[i14 + 36 >> 2])) >>> 0;
 i10 = i1 << 2;
 i9 = (i5 << 2) + i10 | 0;
 i9 = (0 - i9 & 12) + i9 | 0;
 i6 = i14 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i9 + (i5 << 3) | 0, HEAP32[i14 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i8 = i7 + i10 | 0;
 i9 = i7 + i9 | 0;
 _memset(i7 | 0, -1, i10 | 0) | 0;
 i10 = i14 + 48 | 0;
 i3 = i14 + 16 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i11 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 0;
  do {
   i16 = HEAP32[i2 + (i12 << 3) >> 2] | 0;
   i17 = i16 + ~(i16 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i7 + (((i17 >>> 16 ^ i17) & i11) << 2) | 0;
   HEAP32[i8 + (i12 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i12;
   HEAP32[i9 + (i12 << 3) >> 2] = i16;
   HEAP32[i9 + (i12 << 3) + 4 >> 2] = HEAP32[i2 + (i12 << 3) + 4 >> 2];
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i17 = i14 + 12 | 0;
 i16 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i7;
 HEAP32[i14 + 24 >> 2] = i7;
 HEAP32[i14 + 32 >> 2] = i1;
 HEAP32[i14 + 20 >> 2] = i8;
 HEAP32[i3 >> 2] = i9;
 HEAP32[i4 >> 2] = i5;
 i1 = i14 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i13;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i4, i1) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 24 | 0;
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = i11 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i9, 4);
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = i7 + 12 | 0;
 i3 = i7 + 11 | 0;
 i4 = i7 + 12 | 0;
 i5 = i9 + 4 | 0;
 do {
  HEAP32[i2 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i7, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i11);
  i12 = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  i15 = gb + 63648 | 0;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i13 = i8;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = i14;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i1, i12, i9);
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i15 = HEAP32[i7 >> 2] | 0;
   i14 = HEAP32[i4 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i5 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i9);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = -1;
   HEAP32[i2 + 8 >> 2] = -1;
   i3 = i2 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i2 + 32 >> 2] = -1;
   HEAPF32[i2 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
   HEAP8[i2 + 44 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN13DrawImmediateC2ER9GfxDevice(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i6 >> 2] = i1;
 i1 = i6 + 4 | 0;
 i2 = i6 + 8 | 0;
 i3 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = -1;
 i1 = i6 + 60 | 0;
 i4 = i6 + 32 | 0;
 i5 = i4 + 92 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
 i4 = i6 + 124 | 0;
 i5 = i4 + 88 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i6 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 160 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 212 >> 2] = 0;
 HEAP32[i6 + 216 >> 2] = 0;
 HEAP32[i2 >> 2] = 127;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP8[i7 + 3 >> 0] = 3;
 HEAP8[i7 + 5 >> 0] = 12;
 HEAP8[i7 + 6 >> 0] = 0;
 HEAP8[i7 + 7 >> 0] = 3;
 HEAP8[i7 + 9 >> 0] = 24;
 HEAP8[i7 + 10 >> 0] = 0;
 HEAP8[i7 + 11 >> 0] = 4;
 HEAP8[i7 + 13 >> 0] = 40;
 HEAP8[i7 + 14 >> 0] = 0;
 HEAP8[i7 + 15 >> 0] = 3;
 HEAP8[i7 + 17 >> 0] = 52;
 HEAP8[i7 + 18 >> 0] = 0;
 HEAP8[i7 + 19 >> 0] = 3;
 HEAP8[i7 + 21 >> 0] = 64;
 HEAP8[i7 + 22 >> 0] = 0;
 HEAP8[i7 + 23 >> 0] = 3;
 HEAP8[i7 + 25 >> 0] = 76;
 HEAP8[i7 + 26 >> 0] = 0;
 HEAP8[i7 + 27 >> 0] = 3;
 i6 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63304 | 0, 16, gb + 396312 | 0, 152) | 0;
 __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob(i6, 1, i7, 1);
 HEAP32[i3 >> 2] = i6;
 STACKTOP = i8;
 return;
}

function __ZN11DetailPatch8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10);
 i4 = i8 + 28 | 0;
 i7 = i8 + 32 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 - i1 | 0;
 HEAP32[i9 >> 2] = i5;
 i12 = i10 + 16 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i6 >> 2] = i5;
  HEAP32[i12 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i6 = i8 + 40 | 0;
 i7 = i8 + 44 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i3 - i1 | 0;
 HEAP32[i9 >> 2] = i2;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i13;
 return;
}

function __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, i1, i9) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0, f21 = f0, f22 = f0, f23 = f0, f24 = f0, i25 = 0, i26 = 0, f27 = f0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 i1 = 0;
 do {
  f24 = Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]);
  f27 = Math_fround(f24 * f15);
  i26 = i1 + 4 | 0;
  f23 = Math_fround(HEAPF32[i3 + (i26 << 2) >> 2]);
  f27 = Math_fround(f27 + Math_fround(f23 * f17));
  i25 = i1 + 8 | 0;
  f22 = Math_fround(HEAPF32[i3 + (i25 << 2) >> 2]);
  f27 = Math_fround(f27 + Math_fround(f22 * f18));
  i20 = i1 + 12 | 0;
  f21 = Math_fround(HEAPF32[i3 + (i20 << 2) >> 2]);
  HEAPF32[i9 + (i1 << 2) >> 2] = Math_fround(f27 + Math_fround(f21 * f19));
  HEAPF32[i9 + (i26 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f4) + Math_fround(f23 * f5)) + Math_fround(f22 * f6)) + Math_fround(f21 * f7));
  HEAPF32[i9 + (i25 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f8) + Math_fround(f23 * f10)) + Math_fround(f22 * f11)) + Math_fround(f21 * f12));
  HEAPF32[i9 + (i20 << 2) >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f24 * f13) + Math_fround(f23 * f14)) + Math_fround(f22 * f16)) + Math_fround(f21 * f2));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 return;
}

function __GLOBAL__sub_I_runtime_serialize_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165848 | 0, gb + 466288 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165860 | 0, gb + 466310 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165872 | 0, gb + 466349 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165884 | 0, gb + 466349 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165896 | 0, gb + 466380 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165908 | 0, gb + 466400 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165920 | 0, gb + 466418 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165932 | 0, gb + 466456 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165944 | 0, gb + 466475 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165956 | 0, gb + 466502 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165968 | 0, gb + 466519 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165980 | 0, gb + 466545 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1165992 | 0, gb + 466569 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166004 | 0, gb + 466599 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166016 | 0, gb + 466627 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166028 | 0, gb + 466706 | 0, 10, 0);
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i6, i8, i7, i1) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) i4 = 1; else if (i3 >>> 0 < i2 >>> 0) i4 = 0; else i4 = (HEAP32[i8 + 4 >> 2] | 0) >>> 0 < (HEAP32[i6 + 4 >> 2] | 0) >>> 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) i5 = 1; else if (i2 >>> 0 < i1 >>> 0) i5 = 0; else i5 = (HEAP32[i7 + 4 >> 2] | 0) >>> 0 < (HEAP32[i8 + 4 >> 2] | 0) >>> 0;
 if (!i4) {
  if (!i5) {
   i8 = 0;
   return i8 | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i4 = i8 + 4 | 0;
  i2 = i7 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i3;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) i1 = i6 + 4 | 0; else {
   if (i3 >>> 0 < i2 >>> 0) {
    i8 = 1;
    return i8 | 0;
   }
   i1 = i6 + 4 | 0;
   if ((HEAP32[i4 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
    i8 = 1;
    return i8 | 0;
   }
  }
  HEAP32[i6 >> 2] = i2;
  HEAP32[i8 >> 2] = i3;
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i8;
  i8 = 2;
  return i8 | 0;
 }
 if (i5) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
  i6 = i6 + 4 | 0;
  i8 = i7 + 4 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i7;
  i8 = 1;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i8 >> 2] = i3;
 i4 = i6 + 4 | 0;
 i3 = i8 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i5 >>> 0) i1 = i7 + 4 | 0; else {
  if (i5 >>> 0 < i4 >>> 0) {
   i8 = 1;
   return i8 | 0;
  }
  i1 = i7 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 >= i2 >>> 0) {
   i8 = 1;
   return i8 | 0;
  }
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i7 >> 2] = i5;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i8;
 i8 = 2;
 return i8 | 0;
}

function __ZN5physx20PxsParticleSystemSim24removeTwoWayRbReferencesERKNS_16PxsParticleShapeEPKNS_11PxsBodyCoreE(i2, i1, i22) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i23 = 0;
 i16 = HEAP32[i1 + 44 >> 2] | 0;
 i21 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 48 >> 2] | 0;
 i1 = HEAP32[i16 + 12 >> 2] | 0;
 i16 = (HEAP32[i16 + 8 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= i16 >>> 0) return;
 i17 = HEAP32[i2 + 36 >> 2] | 0;
 i18 = i2 + 44 | 0;
 i19 = i2 + 48 | 0;
 i20 = i2 + 52 | 0;
 i15 = i2 + 56 | 0;
 do {
  i4 = HEAP32[i17 + (i1 << 2) >> 2] | 0;
  do if (HEAP16[i21 + (i4 << 5) + 28 >> 1] & 1) {
   i5 = i21 + (i4 << 5) + 30 | 0;
   i2 = HEAP16[i5 >> 1] | 0;
   i3 = i2 & 65535;
   if (i3 & 3 | 0) {
    i6 = HEAP32[i18 >> 2] | 0;
    i7 = i6 + (i4 << 4) | 0;
    i8 = HEAP32[i19 >> 2] | 0;
    i9 = i8 + (i4 << 4) | 0;
    i10 = HEAP32[i20 >> 2] | 0;
    i11 = i10 + (i4 << 4) | 0;
    i12 = HEAP32[i15 >> 2] | 0;
    i13 = i12 + (i4 << 4) | 0;
    i23 = HEAP32[i12 + (i4 << 4) + 12 >> 2] | 0;
    i14 = i23;
    if ((i23 | 0) == (i22 | 0)) {
     i2 = i3 & 65525;
     HEAP16[i5 >> 1] = i2;
    }
    i3 = i10 + (i4 << 4) + 12 | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i22 | 0)) {
     i2 = i2 & 65535;
     if (!(i2 & 2)) {
      HEAP16[i5 >> 1] = i2 & 65530;
      break;
     } else {
      HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
      HEAP32[i6 + (i4 << 4) + 4 >> 2] = HEAP32[i8 + (i4 << 4) + 4 >> 2];
      HEAP32[i6 + (i4 << 4) + 8 >> 2] = HEAP32[i8 + (i4 << 4) + 8 >> 2];
      HEAP32[i6 + (i4 << 4) + 12 >> 2] = HEAP32[i8 + (i4 << 4) + 12 >> 2];
      HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
      HEAP32[i10 + (i4 << 4) + 4 >> 2] = HEAP32[i12 + (i4 << 4) + 4 >> 2];
      HEAP32[i10 + (i4 << 4) + 8 >> 2] = HEAP32[i12 + (i4 << 4) + 8 >> 2];
      HEAP32[i3 >> 2] = i14;
      HEAP16[i5 >> 1] = i2 & 65525;
      break;
     }
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i16 | 0));
 return;
}

function __ZN19SpriteMeshGenerator4path4bboxEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f10 = f0, f11 = f0, i12 = 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = (HEAP32[i9 + 4 >> 2] | 0) - i6 | 0;
 i2 = i1 >> 5;
 if ((i1 | 0) > 0) {
  f7 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(1.17549435e-38);
  f5 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i1 = 0;
  do {
   f11 = Math_fround(HEAPF32[i6 + (i1 << 5) >> 2]);
   f10 = Math_fround(HEAPF32[i6 + (i1 << 5) + 4 >> 2]);
   f7 = f11 < f7 ? f11 : f7;
   f3 = f10 < f3 ? f10 : f3;
   f5 = f11 > f5 ? f11 : f5;
   f4 = f10 > f4 ? f10 : f4;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  if (f7 < Math_fround(0.0)) i6 = 0; else i8 = 4;
 } else {
  f7 = Math_fround(3402823469999999843913219.0e14);
  f4 = Math_fround(1.17549435e-38);
  f5 = Math_fround(1.17549435e-38);
  f3 = Math_fround(3402823469999999843913219.0e14);
  i8 = 4;
 }
 if ((i8 | 0) == 4) {
  f11 = Math_fround(HEAP32[i9 + 12 >> 2] | 0);
  i6 = (HEAPF32[tempDoublePtr >> 2] = f7 > f11 ? f11 : f7, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f3 < Math_fround(0.0)) i2 = 0; else {
  f11 = Math_fround(HEAP32[i9 + 16 >> 2] | 0);
  i2 = (HEAPF32[tempDoublePtr >> 2] = f3 > f11 ? f11 : f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f5 < Math_fround(0.0)) i1 = 0; else {
  f11 = Math_fround(HEAP32[i9 + 12 >> 2] | 0);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f5 > f11 ? f11 : f5, HEAP32[tempDoublePtr >> 2] | 0);
 }
 if (f4 < Math_fround(0.0)) {
  i8 = 0;
  i12 = i9 + 28 | 0;
  HEAP32[i12 >> 2] = i6;
  i6 = i9 + 32 | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i9 + 36 | 0;
  HEAP32[i6 >> 2] = i1;
  i9 = i9 + 40 | 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 f11 = Math_fround(HEAP32[i9 + 16 >> 2] | 0);
 i8 = (HEAPF32[tempDoublePtr >> 2] = f4 > f11 ? f11 : f4, HEAP32[tempDoublePtr >> 2] | 0);
 i12 = i9 + 28 | 0;
 HEAP32[i12 >> 2] = i6;
 i12 = i9 + 32 | 0;
 HEAP32[i12 >> 2] = i2;
 i12 = i9 + 36 | 0;
 HEAP32[i12 >> 2] = i1;
 i12 = i9 + 40 | 0;
 HEAP32[i12 >> 2] = i8;
 return;
}

function __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 switch (i2 | 0) {
 case 8:
  {
   if (!i1) {
    STACKTOP = i4;
    return;
   }
   i2 = i3 + 392 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i2 = i3 + 404 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i1;
   i1 = i3 + 396 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i2 + 1;
   if ((i2 | 0) < ((HEAP32[i3 + 388 >> 2] | 0) * 50 | 0)) {
    STACKTOP = i4;
    return;
   }
   __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i3 + 112 | 0);
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i4;
   return;
  }
 case 16:
  {
   if (!i1) {
    STACKTOP = i4;
    return;
   }
   i2 = i3 + 688 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i2 = i3 + 700 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i1;
   i1 = i3 + 692 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i2 + 1;
   if ((i2 | 0) < ((HEAP32[i3 + 684 >> 2] | 0) * 50 | 0)) {
    STACKTOP = i4;
    return;
   }
   __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i3 + 408 | 0);
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i4;
   return;
  }
 case 32:
  {
   if (!i1) {
    STACKTOP = i4;
    return;
   }
   i2 = i3 + 984 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i2 = i3 + 996 | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i1;
   i1 = i3 + 988 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = i2 + 1;
   if ((i2 | 0) < ((HEAP32[i3 + 980 >> 2] | 0) * 50 | 0)) {
    STACKTOP = i4;
    return;
   }
   __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv(i3 + 704 | 0);
   HEAP32[i1 >> 2] = 0;
   STACKTOP = i4;
   return;
  }
 default:
  {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
   STACKTOP = i4;
   return;
  }
 }
}

function __ZN5physx14PxsAABBManager14sortAggregatesEPjjS1_jPNS_19AggregateSortedDataE(i3, i23, i2, i22, i1, i21) {
 i3 = i3 | 0;
 i23 = i23 | 0;
 i2 = i2 | 0;
 i22 = i22 | 0;
 i1 = i1 | 0;
 i21 = i21 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 2064 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i20 + 2049 | 0;
 i11 = i20 + 2048 | 0;
 i19 = i20 + 1024 | 0;
 i17 = i20 + 512 | 0;
 i18 = i20;
 i12 = HEAP32[i3 + 300 >> 2] | 0;
 i13 = i3 + 45696 | 0;
 if (!(HEAP32[i13 >> 2] | 0)) {
  STACKTOP = i20;
  return;
 }
 i14 = i3 + 45684 | 0;
 i15 = i3 + 180 | 0;
 i16 = i3 + 308 | 0;
 i6 = i3 + 316 | 0;
 i8 = 0;
 i9 = 0;
 while (1) {
  i7 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i8 << 2) >> 2] | 0;
  i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i7 * 1048 | 0) + 1032 >> 2] | 0;
  if ((i1 | 0) == 1073741823) {
   i3 = 0;
   i2 = 0;
  } else {
   i4 = HEAP32[i16 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = 0;
   i2 = 0;
   do {
    if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) != 1073741823) {
     HEAP32[i19 + (i2 << 3) >> 2] = HEAP32[i12 + (i1 * 24 | 0) >> 2];
     HEAP32[i19 + (i2 << 3) + 4 >> 2] = i3;
     i2 = i2 + 1 | 0;
    }
    HEAP32[i17 + (i3 << 2) >> 2] = i1;
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   } while ((i1 | 0) != 1073741823);
  }
  __ZN5physx6shdfnd4sortI10SortedDataNS0_4LessIS2_EENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j(i19, i2, i10, i11, 32);
  if (i2 | 0) {
   i1 = 0;
   do {
    HEAP32[i18 + (i1 << 2) >> 2] = HEAP32[i19 + (i1 << 3) + 4 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i5 = i23 + (i9 << 2) | 0;
  HEAP32[i21 + (i7 << 3) >> 2] = i5;
  i7 = i21 + (i7 << 3) + 4 | 0;
  HEAP32[i7 >> 2] = i22 + (i9 << 2);
  _memcpy(i5 | 0, i18 | 0, i2 << 2 | 0) | 0;
  _memcpy(HEAP32[i7 >> 2] | 0, i17 | 0, i3 << 2 | 0) | 0;
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 >= (HEAP32[i13 >> 2] | 0) >>> 0) break; else i9 = i3 + i9 | 0;
 }
 STACKTOP = i20;
 return;
}

function __ZN5physx22PxVehicleWheelsDynData14setToRestStateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) return;
 i3 = 0;
 do {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAPF32[i2 + (i3 * 224 | 0) >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 32 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 48 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 64 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 80 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i2 + (i3 * 224 | 0) + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 36 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 52 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 68 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 84 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i2 + (i3 * 224 | 0) + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 56 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 72 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 88 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i2 + (i3 * 224 | 0) + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 44 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 60 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 76 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + (i3 * 224 | 0) + 92 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i5 = i2 + (i3 * 224 | 0) + 96 | 0;
  i6 = i5 + 112 | 0;
  do {
   HEAP8[i5 >> 0] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP32[i2 + (i3 * 224 | 0) + 212 >> 2] = 0;
  HEAP8[i2 + (i3 * 224 | 0) + 216 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 return;
}

function __ZN16CircleCollider2D8TransferI14SafeBinaryReadEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i7, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i5 = i7 + 160 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i8, 1) | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = i7 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1034411 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if ((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i7 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0) {
  STACKTOP = i9;
  return;
 }
 i6 = gb + 1162356 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZN15CapsuleCollider9SetRadiusEf(i4, f2) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i6 = i9 + 12 | 0;
 i7 = i9;
 i8 = i4 + 60 | 0;
 if (Math_fround(HEAPF32[i8 >> 2]) != f2) HEAPF32[i8 >> 2] = f2;
 i1 = i4 + 36 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = 2;
 i10 = i7 + 4 | 0;
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i7 | 0) | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(f12 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f11 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 HEAPF32[i5 >> 2] = f12;
 HEAPF32[i5 + 4 >> 2] = f11;
 HEAPF32[i5 + 8 >> 2] = f2;
 i6 = HEAP32[i4 + 68 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i5 + (((i6 + 1 | 0) % 3 | 0) << 2) >> 2]);
 f11 = Math_fround(HEAPF32[i5 + (((i6 + 2 | 0) % 3 | 0) << 2) >> 2]);
 i6 = f2 < Math_fround(0.0);
 f12 = Math_fround(-f2);
 f2 = i6 ? f12 : f2;
 i6 = f11 < Math_fround(0.0);
 f12 = Math_fround(-f11);
 f11 = i6 ? f12 : f11;
 f2 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) * (f2 < f11 ? f11 : f2));
 i8 = f2 < Math_fround(9.99999974e-06);
 HEAPF32[i10 >> 2] = i8 ? Math_fround(9.99999974e-06) : f2;
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0, i7 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 }
 STACKTOP = i9;
 return;
}

function __Z34Animator_Get_Custom_PropParametersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 __ZN8Animator13GetParametersEv(i8, i2);
 i4 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 16 >> 2] | 0;
 i5 = i8 + 4 | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, ((HEAP32[i5 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 36 | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   __Z33AnimatorControllerParameterToMonoRK27AnimatorControllerParameterR31MonoAnimatorControllerParameter(i1 + (i3 * 36 | 0) | 0, i7);
   i2 = _il2cpp_object_new(i4 | 0) | 0;
   i1 = i2 + 8 | 0;
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i3, i2);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 36 | 0) >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i6 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i7 + 4 | 0;
  do {
   i1 = i2 + -36 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -24 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i6 | 0;
}

function __ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_(i4, i10, i11) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f12 = f0;
 i7 = HEAP32[i10 + 8 >> 2] | 0;
 i8 = HEAP32[HEAP32[i4 + 4 >> 2] >> 2] | 0;
 i9 = HEAP32[i11 + 8 >> 2] | 0;
 i1 = HEAP32[i8 + (i7 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i8 + (i9 * 360 | 0) + 184 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i11 = i1 >>> 0 < i2 >>> 0;
  return i11 | 0;
 }
 i1 = HEAP16[i10 + 12 >> 1] | 0;
 i2 = HEAP16[i11 + 12 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i11 = i1 << 16 >> 16 < i2 << 16 >> 16;
  return i11 | 0;
 }
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = (HEAP16[i8 + (i7 * 360 | 0) + 182 >> 1] | 0) != 0;
 i3 = (HEAP16[i8 + (i9 * 360 | 0) + 182 >> 1] | 0) != 0;
 i1 = i3 ^ 1;
 if (!(i2 ^ 1 | i1)) {
  if ((i5 | 0) != (i6 | 0)) {
   i11 = i5 >>> 0 < i6 >>> 0;
   return i11 | 0;
  }
  i1 = HEAP32[i8 + (i7 * 360 | 0) + 248 >> 2] | 0;
  i2 = HEAP32[i8 + (i9 * 360 | 0) + 248 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i11 = (HEAPU16[i8 + (i7 * 360 | 0) + 180 >> 1] | 0) < (HEAPU16[i8 + (i9 * 360 | 0) + 180 >> 1] | 0);
   return i11 | 0;
  } else {
   i11 = (i1 | 0) < (i2 | 0);
   return i11 | 0;
  }
 }
 if (i2 ^ i3) {
  i11 = i2 & i1;
  return i11 | 0;
 }
 if (HEAP8[i4 >> 0] | 0) {
  i1 = (HEAP32[i10 + 20 >> 2] | 0) >>> 24;
  i2 = (HEAP32[i11 + 20 >> 2] | 0) >>> 24;
  if ((i1 | 0) != (i2 | 0)) {
   i11 = i1 >>> 0 < i2 >>> 0;
   return i11 | 0;
  }
 }
 i2 = HEAP32[i8 + (i7 * 360 | 0) + 224 >> 2] | 0;
 i1 = HEAP32[i8 + (i9 * 360 | 0) + 224 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i11 = i2 >>> 0 < i1 >>> 0;
  return i11 | 0;
 }
 if ((i5 | 0) != (i6 | 0)) {
  i11 = (i5 | 0) < (i6 | 0);
  return i11 | 0;
 }
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 i2 = HEAP32[i11 + 28 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  f12 = Math_fround(HEAPF32[i10 + 20 >> 2]);
  i11 = f12 > Math_fround(HEAPF32[i11 + 20 >> 2]);
  return i11 | 0;
 } else {
  i11 = i1 >>> 0 > i2 >>> 0;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i6 = i12 + 20 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i7 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 28 >> 2])) >>> 0;
 i2 = i1 << 2;
 i10 = (i7 << 2) + i2 | 0;
 i10 = (0 - i10 & 12) + i10 | 0;
 i8 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 i8 = mftCall_iiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i10 + (i7 << 3) | 0, gb + 766896 | 0, gb + 778479 | 0, 341) | 0;
 i9 = i8 + i2 | 0;
 i10 = i8 + i10 | 0;
 _memset(i8 | 0, -1, i2 | 0) | 0;
 i2 = i12 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = HEAP32[i12 + 8 >> 2] | 0;
  i4 = i1 + -1 | 0;
  i5 = 0;
  do {
   i14 = HEAP16[i3 + (i5 << 3) >> 1] | 0;
   i15 = i14 & 65535;
   i15 = i15 + ~(i15 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i8 + (((i15 >>> 16 ^ i15) & i4) << 2) | 0;
   HEAP32[i9 + (i5 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i5;
   HEAP16[i10 + (i5 << 3) >> 1] = i14;
   HEAP32[i10 + (i5 << 3) + 4 >> 2] = HEAP32[i3 + (i5 << 3) + 4 >> 2];
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i12 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i15 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 12 >> 2] | 0, i15 | 0, i3 | 0);
 }
 HEAP32[i2 >> 2] = i8;
 HEAP32[i12 + 16 >> 2] = i8;
 HEAP32[i12 + 24 >> 2] = i1;
 HEAP32[i12 + 12 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i7;
 i1 = i12 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, i16 = 0, i17 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i14 + 28 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 f15 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f15 * Math_fround(HEAPF32[i14 + 36 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i4 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i5 = i14 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i8 + (i4 << 3) | 0, HEAP32[i14 + 8 >> 2] | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i14 + 48 | 0;
 i2 = i14 + 16 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = HEAP32[i2 >> 2] | 0;
  i11 = i1 + -1 | 0;
  i12 = 0;
  do {
   i16 = i10 + (i12 << 3) | 0;
   i17 = HEAP32[i16 >> 2] | 0;
   i17 = i17 + ~(i17 << 15) | 0;
   i17 = (i17 >>> 10 ^ i17) * 9 | 0;
   i17 = i17 >>> 6 ^ i17;
   i17 = i17 + ~(i17 << 11) | 0;
   i17 = i6 + (((i17 >>> 16 ^ i17) & i11) << 2) | 0;
   HEAP32[i7 + (i12 << 2) >> 2] = HEAP32[i17 >> 2];
   HEAP32[i17 >> 2] = i12;
   HEAP32[i8 + (i12 << 3) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i8 + (i12 << 3) + 4 >> 2] = HEAP32[i10 + (i12 << 3) + 4 >> 2];
   i12 = i12 + 1 | 0;
  } while (i12 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i17 = i14 + 12 | 0;
 i16 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i6;
 HEAP32[i14 + 24 >> 2] = i6;
 HEAP32[i14 + 32 >> 2] = i1;
 HEAP32[i14 + 20 >> 2] = i7;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i3 >> 2] = i4;
 i1 = i14 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i13;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAPF32[i2 + 32 >> 2] = Math_fround(.899999976);
   HEAP8[i2 + 36 >> 0] = 0;
   HEAP8[i2 + 37 >> 0] = 0;
   HEAP32[i2 + 40 >> 2] = 0;
   HEAP8[i2 + 44 >> 0] = 1;
   HEAP8[i2 + 45 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i1 = i11;
 i9 = i12 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i9 >> 2] = i3;
  i3 = i6;
 }
 i1 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = (i4 - i5 | 0) / 24 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj(i1, i3 - i2 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else if (i3 >>> 0 < i2 >>> 0) {
  i1 = i5 + (i3 * 24 | 0) | 0;
  if ((i4 | 0) == (i1 | 0)) i1 = i5; else {
   i4 = i4 + (~(((i4 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i4;
   i1 = i5;
  }
 } else i1 = i5;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = i1;
 do {
  HEAP32[i8 >> 2] = -1;
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  i7 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
  HEAP32[i3 >> 2] = i7;
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i7 | 0) == 0 & (i1 | 0) != -1) HEAP32[i3 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(i1) | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 8 | 0, i12);
  i3 = i3 + 24 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZN11AudioSource14SetSecPositionEf(i7, f6) {
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i7 + 436 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  i7 = i7 + 528 | 0;
  HEAP32[i7 >> 2] = i5;
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i5 = 0;
   i9 = i7 + 528 | 0;
   HEAP32[i9 >> 2] = i5;
   STACKTOP = i8;
   return;
  }
 }
 i3 = ~~Math_fround(Math_fround((__ZNK9AudioClip12GetFrequencyEv(i1) | 0) >>> 0) * f6) >>> 0;
 i1 = i7 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = i3;
  i9 = i7 + 528 | 0;
  HEAP32[i9 >> 2] = i5;
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i2 + 16 >> 2] | 0)) {
  i5 = i3;
  i9 = i7 + 528 | 0;
  HEAP32[i9 >> 2] = i5;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance14SetPositionPCMEj(i1, i3) | 0;
 i5 = i3;
 i9 = i7 + 528 | 0;
 HEAP32[i9 >> 2] = i5;
 STACKTOP = i8;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = i4;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, i1, i5 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i5, HEAP32[i11 >> 2] | 0, i1 << 4);
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__212ctype_bynameIcEC2EPKcj(i7, i3, i1) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 12 | 0;
 i6 = i2;
 __ZNSt3__25ctypeIcEC2EPKtbj(i7, 0, 0, i1);
 HEAP32[i7 >> 2] = gb + 212824 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, i3 | 0, 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i7 + 16 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i2;
   return;
  }
  i4 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = _strlen(i3) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i6 | 0, i3 | 0, i2 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1081576 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i4 | 0, i5 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (i3 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if (!i2) break;
  }
  ___cxa_free_exception(i4 | 0);
 } while (0);
 __ZNSt3__25ctypeIcED2Ev(i7);
 ___resumeException(i1 | 0);
}

function __ZN9Transform17RotateAroundLocalERK8Vector3ff(i4, i1, f5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var f2 = f0, f3 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f7 * f7);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f8 * f8));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f2 * f2));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  STACKTOP = i9;
  return;
 }
 f12 = Math_fround(Math_sqrt(Math_fround(f3)));
 f13 = Math_fround(f5 * Math_fround(.5));
 f3 = Math_fround(+Math_sin(+f13));
 f13 = Math_fround(+Math_cos(+f13));
 f11 = Math_fround(f3 * Math_fround(f7 / f12));
 f15 = Math_fround(f3 * Math_fround(f8 / f12));
 f2 = Math_fround(f3 * Math_fround(f2 / f12));
 i16 = i4 + 32 | 0;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 i16 = HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 16 >> 2]);
 f14 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + (i1 * 40 | 0) + 24 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f2 * f12) + Math_fround(Math_fround(f13 * f3) + Math_fround(f15 * f10))) - Math_fround(f11 * f14));
 f7 = Math_fround(Math_fround(Math_fround(f11 * f3) + Math_fround(Math_fround(f13 * f14) + Math_fround(f2 * f10))) - Math_fround(f15 * f12));
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(f13 * f10) - Math_fround(f11 * f12)) - Math_fround(f15 * f3)) - Math_fround(f2 * f14));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(Math_fround(f13 * f12) + Math_fround(f11 * f10))) - Math_fround(f2 * f3));
 HEAPF32[i6 + 4 >> 2] = f5;
 HEAPF32[i6 + 8 >> 2] = f7;
 HEAPF32[i6 + 12 >> 2] = f8;
 __ZN9Transform16SetLocalRotationERK11Quaternionf(i4, i6);
 STACKTOP = i9;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBufferaSERKS1_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = (i5 | 0) == (i6 | 0);
 if (i9) {
  HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  i8 = i6 + 44 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i5 + 44 | 0;
  HEAP32[i9 >> 2] = i8;
  return i5 | 0;
 }
 i8 = HEAP8[i6 + 11 >> 0] | 0;
 i3 = i8 << 24 >> 24 < 0;
 i7 = i3 ? HEAP32[i6 >> 2] | 0 : i6;
 i8 = i3 ? HEAP32[i6 + 4 >> 2] | 0 : i8 & 255;
 i3 = i5 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i8 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i8 - i4 | 0, i1, 0, i1, i8, i7);
 } else {
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i5 + 4 >> 2] = i8;
   break;
  } else {
   HEAP8[i3 >> 0] = i8;
   break;
  }
 } while (0);
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i5 + 20 | 0, HEAP32[i6 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0);
 if (i9) {
  i8 = i6 + 44 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = i5 + 44 | 0;
  HEAP32[i9 >> 2] = i8;
  return i5 | 0;
 }
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i5 + 32 | 0, HEAP32[i6 + 32 >> 2] | 0, HEAP32[i6 + 36 >> 2] | 0);
 i8 = i6 + 44 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i5 + 44 | 0;
 HEAP32[i9 >> 2] = i8;
 return i5 | 0;
}

function __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_(i3, i1, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i4;
 i1 = i3 + 48 | 0;
 i10 = i11 + 8 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773720 | 0, i10, (HEAPU16[i2 >> 1] | 0) >>> 10 & 3);
 i8 = i11 + 12 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773725 | 0, i8, (HEAPU16[i2 >> 1] | 0) >>> 6 & 3);
 i7 = i11 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773730 | 0, i7, (HEAPU16[i2 >> 1] | 0) >>> 8 & 3);
 i6 = i11 + 20 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773735 | 0, i6, (HEAPU16[i2 >> 1] | 0) >>> 12 & 3);
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773712 | 0, i11, (HEAPU16[i2 >> 1] | 0) >>> 4 & 3);
 i2 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i5 + 131072 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i9 = i5 + (i3 << 5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 + (i3 << 5) + 8 >> 2] = i8;
 HEAP32[i5 + (i3 << 5) + 12 >> 2] = i7;
 HEAP32[i5 + (i3 << 5) + 16 >> 2] = i6;
 HEAP32[i5 + (i3 << 5) + 20 >> 2] = i2;
 HEAP32[i5 + (i3 << 5) + 24 >> 2] = 1;
 i3 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i3;
 if ((i3 | 0) != 4096) {
  STACKTOP = i4;
  return;
 }
 i11 = HEAP32[i5 + 131076 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i5 | 0, 4096);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_(i3, i1, i2, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i4;
 i1 = i3 + 48 | 0;
 i10 = i11 + 8 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773720 | 0, i10, (HEAPU16[i2 >> 1] | 0) >>> 10 & 3);
 i8 = i11 + 12 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773725 | 0, i8, (HEAPU16[i2 >> 1] | 0) >>> 6 & 3);
 i7 = i11 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773730 | 0, i7, (HEAPU16[i2 >> 1] | 0) >>> 8 & 3);
 i6 = i11 + 20 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773735 | 0, i6, (HEAPU16[i2 >> 1] | 0) >>> 12 & 3);
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i1, gb + 773712 | 0, i11, (HEAPU16[i2 >> 1] | 0) >>> 4 & 3);
 i2 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i5 + 131072 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i9 = i5 + (i3 << 5) | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 + (i3 << 5) + 8 >> 2] = i8;
 HEAP32[i5 + (i3 << 5) + 12 >> 2] = i7;
 HEAP32[i5 + (i3 << 5) + 16 >> 2] = i6;
 HEAP32[i5 + (i3 << 5) + 20 >> 2] = i2;
 HEAP32[i5 + (i3 << 5) + 24 >> 2] = 1;
 i3 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i3;
 if ((i3 | 0) != 4096) {
  STACKTOP = i4;
  return;
 }
 i11 = HEAP32[i5 + 131076 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i5 | 0, 4096);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sq11PruningPool6resizeEj(i5, i11) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 11 | 0, i11 * 24 | 0, gb + 710390 | 0, 58) | 0;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 10 | 0, i11 << 3, gb + 710390 | 0, 59) | 0;
 i9 = i11 << 2;
 i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 9 | 0, i9, gb + 710390 | 0, 60) | 0;
 i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 8 | 0, i9, gb + 710390 | 0, 61) | 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0 | (i8 | 0) == 0 | (i9 | 0) == 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 7 | 0, i6);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 6 | 0, i7);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 5 | 0, i8);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 4 | 0, i9);
  STACKTOP = i12;
  return;
 }
 i10 = i5 + 12 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) _memcpy(i6 | 0, i1 | 0, (HEAP32[i5 + 4 >> 2] | 0) * 24 | 0) | 0;
 i4 = i5 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) _memcpy(i7 | 0, i1 | 0, HEAP32[i5 + 4 >> 2] << 3 | 0) | 0;
 i3 = i5 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _memcpy(i8 | 0, i1 | 0, HEAP32[i5 + 4 >> 2] << 2 | 0) | 0;
 i2 = i5 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = i5 + 8 | 0; else {
  i5 = i5 + 8 | 0;
  _memcpy(i9 | 0, i1 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  i1 = i5;
 }
 HEAP32[i1 >> 2] = i11;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 3 | 0, HEAP32[i10 >> 2] | 0);
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 2 | 0, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 1 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i3 >> 2] | 0);
 HEAP32[i10 >> 2] = i6;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i2 >> 2] = i9;
 HEAP32[i3 >> 2] = i8;
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i5, i1) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 32 | 0;
 i7 = i10 + 16 | 0;
 i8 = i10;
 i1 = i10 + 8 | 0;
 i2 = i11 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j(i5, i1);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = i7 + 12 | 0;
 i3 = i7 + 11 | 0;
 i4 = i7 + 12 | 0;
 i5 = i9 + 4 | 0;
 do {
  HEAP32[i2 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i11, i7, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
  i12 = (HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  i15 = gb + 63648 | 0;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i13 = i8;
  HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i13 + 4 >> 2] = i14;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i1, i12, i9);
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   i15 = HEAP32[i7 >> 2] | 0;
   i14 = HEAP32[i4 >> 2] | 0;
   HEAP32[i9 >> 2] = 1;
   HEAP32[i5 >> 2] = i14;
   __Z19free_alloc_internalPvRK10MemLabelId(i15, i9);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE25recurseAddLinkAndChildrenEPKNS_18PxArticulationLinkERNS_6shdfnd11InlineArrayIS6_Lj64ENS7_19ReflectionAllocatorIS6_EEEE(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i10 = i11 + 8 | 0;
 i6 = i11;
 HEAP32[i1 >> 2] = i7;
 i2 = i8 + 264 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i8 + 268 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i8 + 260 >> 2] | 0) + (i3 << 2) >> 2] = i7;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPKNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i8, i1) | 0;
 i5 = i10 + 32 | 0;
 i2 = i10 + 36 | 0;
 HEAP32[i10 + 40 >> 2] = 0;
 i3 = i10 + 44 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i3 >> 2] = 8;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 232 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i10, i4, i6);
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 236 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0, i4 | 0) | 0;
 if (i4 | 0) {
  i1 = 0;
  do {
   __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE25recurseAddLinkAndChildrenEPKNS_18PxArticulationLinkERNS_6shdfnd11InlineArrayIS6_Lj64ENS7_19ReflectionAllocatorIS6_EEEE(i9, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i8);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i9 = HEAP32[i3 >> 2] | 0;
 if (!((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i10 | 0) == (i1 | 0)) {
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i11;
 return;
}

function __ZN23ShaderVariantCollection11VariantInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 16 | 0;
 i11 = i13;
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZN8keywords18KeywordSetToStringERK16ShaderKeywordSetR8UnityStr(i6, i11);
 i12 = i11 + 11 | 0;
 i2 = HEAP8[i12 >> 0] | 0;
 i5 = i11 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 HEAP32[i10 >> 2] = i1;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i7 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i10, 4);
  i2 = HEAP8[i12 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i11 >> 2] | 0 : i11;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i2 & 255;
 i3 = i1 + i5 | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i10, 4);
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 if ((HEAP8[i12 >> 0] | 0) >= 0) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 66;
 HEAP32[i10 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i10);
 STACKTOP = i13;
 return;
}

function __ZL26CullDynamicSceneCombineJobP14CullingJobData(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 4 | 0;
 i3 = i13;
 if ((HEAP16[gb + 1112828 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112828 | 0, i2);
  i11 = gb + 1112828 | 0;
 } else i11 = 0;
 if (!(HEAP32[i12 + 16 >> 2] | 0)) if (!(HEAP8[HEAP32[i12 + 12 >> 2] >> 0] | 0)) i1 = 6; else {
  i10 = HEAP32[i12 + 8 >> 2] | 0;
  __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(HEAP32[i12 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i12 + 20 >> 2] | 0);
 } else i1 = 6;
 if ((i1 | 0) == 6) {
  i10 = i12 + 20 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i9 = HEAP32[i12 + 216 >> 2] | 0;
  if ((HEAP16[gb + 1162184 + 6 >> 1] | 0) > -1) {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162184 | 0, i2);
   i8 = gb + 1162184 | 0;
  } else i8 = 0;
  i1 = HEAP32[i12 + 28 >> 2] | 0;
  if ((i9 | 0) > 1) {
   i7 = HEAP32[i4 >> 2] | 0;
   i6 = 1;
   do {
    i2 = HEAP32[i12 + 24 + (i6 * 12 | 0) >> 2] | 0;
    i4 = HEAP32[i12 + 24 + (i6 * 12 | 0) + 4 >> 2] | 0;
    i5 = i4 + i2 | 0;
    if (i2 >>> 0 < i5 >>> 0) {
     i3 = i1;
     while (1) {
      HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
      i2 = i2 + 1 | 0;
      if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
     }
     i1 = i4 + i1 | 0;
    }
    i6 = i6 + 1 | 0;
   } while ((i6 | 0) != (i9 | 0));
  }
  if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
  HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] = i1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i12, gb + 64024 | 0);
 if (!i11) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i13;
 return;
}

function __Z46Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointAllRK13Vector2fIcalliff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i13 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i13;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i13);
 i13 = i5;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 i6 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i6, i5, i2, f3, f4, 0, i10) | 0;
 i5 = __Z19GetScriptingManagerv() | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i5 + 168 >> 2] | 0) + (HEAP32[gb + 32588 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i7 >> 2] | 0) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i10 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i6 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i5, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return i5 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return i5 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = i4;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i11, i1, i5 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i5, HEAP32[i11 >> 2] | 0, i1 << 4);
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _start_pass_main_29(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = HEAP32[i2 + 388 >> 2] | 0;
 if (i1 | 0) {
  i17 = HEAP32[i2 >> 2] | 0;
  HEAP32[i17 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i17 >> 2] | 0, i2 | 0);
  return;
 }
 i1 = i17 + 4 | 0;
 if (!(HEAP8[(HEAP32[i2 + 416 >> 2] | 0) + 8 >> 0] | 0)) HEAP32[i1 >> 2] = fb + 209; else {
  HEAP32[i1 >> 2] = fb + 208;
  i11 = HEAP32[i2 + 280 >> 2] | 0;
  i12 = HEAP32[i2 + 36 >> 2] | 0;
  if ((i12 | 0) > 0) {
   i13 = i17 + 56 | 0;
   i14 = i17 + 60 | 0;
   i15 = i11 + 2 | 0;
   i16 = i11 + -2 | 0;
   i7 = HEAP32[i2 + 196 >> 2] | 0;
   i8 = 0;
   while (1) {
    i9 = (Math_imul(HEAP32[i7 + 36 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0) | 0) / (i11 | 0) | 0;
    i10 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i5 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i8 << 2) >> 2] | 0;
    i6 = HEAP32[i17 + 8 + (i8 << 2) >> 2] | 0;
    i2 = Math_imul(i9, i15) | 0;
    if ((i2 | 0) > 0) {
     i1 = 0;
     do {
      i4 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
      HEAP32[i5 + (i1 << 2) >> 2] = i4;
      HEAP32[i10 + (i1 << 2) >> 2] = i4;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
    i2 = i9 << 1;
    if ((i9 | 0) > 0) {
     i3 = Math_imul(i9, i11) | 0;
     i4 = Math_imul(i9, i16) | 0;
     i1 = 0;
     do {
      i18 = i1 + i3 | 0;
      i19 = i1 + i4 | 0;
      HEAP32[i5 + (i19 << 2) >> 2] = HEAP32[i6 + (i18 << 2) >> 2];
      HEAP32[i5 + (i18 << 2) >> 2] = HEAP32[i6 + (i19 << 2) >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (i2 | 0));
     i1 = 0;
     do {
      HEAP32[i10 + (i1 - i9 << 2) >> 2] = HEAP32[i10 >> 2];
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i9 | 0));
    }
    i8 = i8 + 1 | 0;
    if ((i8 | 0) == (i12 | 0)) break; else i7 = i7 + 84 | 0;
   }
  }
  HEAP32[i17 + 64 >> 2] = 0;
  HEAP32[i17 + 68 >> 2] = 0;
  HEAP32[i17 + 76 >> 2] = 0;
 }
 HEAP8[i17 + 48 >> 0] = 0;
 HEAP32[i17 + 52 >> 2] = 0;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i1, i2, i5, i4, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 switch ((Math_imul(i5, -3) | 0) + i2 | 0) {
 case 0:
  {
   i1 = HEAP32[i6 + 20 >> 2] | 0;
   if ((i1 + -1 | 0) >>> 0 > i3 >>> 0) {
    if (!i4) i1 = 0; else {
     i1 = i5 - i1 | 0;
     HEAP32[i7 >> 2] = (i1 << 1 | 1) - ((HEAPU8[(HEAP32[i6 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) >>> 7 & 255);
     i1 = 1;
    }
    if (((HEAP32[i6 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i4 >>> 0) {
     HEAP32[i7 + (i1 << 2) >> 2] = (HEAPU8[(HEAP32[i6 + 36 >> 2] | 0) + (i5 << 2) + 2 >> 0] | 0) >>> 7 & 255 | i5 << 1;
     i4 = i1 + 1 | 0;
    } else i4 = i1;
   } else i4 = 0;
   break;
  }
 case 1:
  {
   if (((HEAP32[i6 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i4 >>> 0) if (((HEAP32[i6 + 20 >> 2] | 0) + -1 | 0) >>> 0 > i3 >>> 0) {
    i4 = i5 << 1;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i7 + 4 >> 2] = i4 | 1;
    i4 = 2;
   } else i4 = 0; else i4 = 0;
   break;
  }
 case 2:
  {
   if (((HEAP32[i6 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i4 >>> 0) {
    if (!i3) i1 = 0; else {
     HEAP32[i7 >> 2] = (i5 << 1) + -1;
     i1 = 1;
    }
    if (((HEAP32[i6 + 20 >> 2] | 0) + -1 | 0) >>> 0 > i3 >>> 0) {
     HEAP32[i7 + (i1 << 2) >> 2] = i5 << 1;
     i4 = i1 + 1 | 0;
    } else i4 = i1;
   } else i4 = 0;
   break;
  }
 default:
  i4 = 0;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = i3 >>> 1;
 i1 = HEAP32[i6 + 36 >> 2] | 0;
 i2 = (HEAP8[((i3 & 1 | 0) == 0 ? i1 + (i2 << 2) + 2 | 0 : i1 + (i2 << 2) + 3 | 0) >> 0] & 127) != 127;
 if (i4 >>> 0 <= 1) {
  i7 = i2 ? i3 : -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (i2) {
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i6 = i7 >>> 1;
  STACKTOP = i8;
  return ((HEAP8[((i7 & 1 | 0) == 0 ? i1 + (i6 << 2) + 2 | 0 : i1 + (i6 << 2) + 3 | 0) >> 0] & 127) == 127 ? -1 : i7) | 0;
 }
 return 0;
}

function __ZN5physx14SapPairManager10RemovePairEjjjj(i12, i1, i2, i3, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i3 = i8 + (i3 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i10 = i12 + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i11 | 0)) {
  i1 = HEAP32[i9 + (i11 << 2) >> 2] | 0;
  i13 = 6;
 } else {
  while (1) {
   i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) == (i11 | 0)) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = HEAP32[i9 + (i11 << 2) >> 2] | 0;
  if ((i2 | 0) == 1073741823) i13 = 6; else HEAP32[i9 + (i2 << 2) >> 2] = i1;
 }
 if ((i13 | 0) == 6) HEAP32[i3 >> 2] = i1;
 i6 = i12 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + -1 | 0;
 if ((i7 | 0) == (i11 | 0)) {
  i13 = i1;
  i13 = i13 + -1 | 0;
  HEAP32[i6 >> 2] = i13;
  return;
 }
 i4 = HEAP32[i12 + 20 >> 2] | 0;
 i5 = HEAP32[i4 + (i7 << 3) + 4 >> 2] << 16 | HEAP32[i4 + (i7 << 3) >> 2];
 i5 = i5 + ~(i5 << 15) | 0;
 i5 = (i5 >> 10 ^ i5) * 9 | 0;
 i5 = i5 >> 6 ^ i5;
 i5 = i5 + ~(i5 << 11) | 0;
 i5 = (i5 >> 16 ^ i5) & HEAP32[i12 + 36 >> 2];
 i3 = i8 + (i5 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  i1 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  i13 = 13;
 } else {
  while (1) {
   i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) == (i7 | 0)) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  if ((i2 | 0) == 1073741823) i13 = 13; else HEAP32[i9 + (i2 << 2) >> 2] = i1;
 }
 if ((i13 | 0) == 13) HEAP32[i3 >> 2] = i1;
 i8 = i4 + (i7 << 3) | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i13 = i4 + (i11 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i13 + 4 >> 2] = i9;
 i13 = HEAP32[i12 + 24 >> 2] | 0;
 HEAP8[i13 + i11 >> 0] = HEAP8[i13 + i7 >> 0] | 0;
 i13 = (HEAP32[i12 >> 2] | 0) + (i5 << 2) | 0;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i11;
 i13 = HEAP32[i6 >> 2] | 0;
 i13 = i13 + -1 | 0;
 HEAP32[i6 >> 2] = i13;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI24GenerateTypeTreeTransferEEvRS5_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, gb + 839349 | 0, i1, 0);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, gb + 839349 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNK32RendererMaterialAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 24 | 0;
 i9 = i11 + 8 | 0;
 i3 = i11;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i7 = __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i10) | 0;
 HEAP32[i3 >> 2] = i1 & 268435455;
 switch (i1 >>> 30 & 3) {
 case 2:
  {
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i7, i3, f4, 0);
   break;
  }
 case 1:
 case 0:
  {
   __ZN19ShaderPropertySheet16SetVectorIndexedERKN9ShaderLab16FastPropertyNameEifRK8Vector4fNS_8SetFlagsE(i7, i3, i1 >>> 28 & 3, f4, gb + 1162376 | 0, 0);
   break;
  }
 default:
  {}
 }
 __ZN19ShaderPropertySheet11ComputeHashEv(i7);
 if (!((i1 & 805306368 | 0) == 536870912 ? (HEAP32[gb + 1158336 >> 2] | 0) == (HEAP32[i3 >> 2] | 0) : 0)) {
  STACKTOP = i11;
  return;
 }
 if (((HEAP32[i10 + 260 >> 2] | 0) >>> 16 & 65535) >= 65534) {
  STACKTOP = i11;
  return;
 }
 i2 = __Z13GetIEnlightenv() | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 if ((i1 | 0) >= (i3 | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = HEAP32[i7 + 32 >> 2] | 0;
 i6 = HEAP32[gb + 1158336 >> 2] | 0;
 while (1) {
  if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i3 | 0)) {
   i12 = 12;
   break;
  }
 }
 if ((i12 | 0) == 12) {
  STACKTOP = i11;
  return;
 }
 if (!((i2 | 0) != 0 & (i1 | 0) > -1)) {
  STACKTOP = i11;
  return;
 }
 __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi(i8, i7, i1);
 i12 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 mftCall_iiii(i12 | 0, i2 | 0, i10 | 0, i9 | 0) | 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc8ClothSim21removeCollisionConvexEPKNS0_8ShapeSimE(i14, i7) {
 i14 = i14 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15;
 i13 = HEAP32[i14 + 52 >> 2] | 0;
 i2 = HEAP32[i14 + 92 >> 2] | 0;
 i1 = HEAP32[i14 + 96 >> 2] | 0;
 i3 = (HEAP32[i14 + 88 >> 2] | 0) + (HEAP32[i14 + 84 >> 2] | 0) + i2 + i1 | 0;
 i11 = i14 + 116 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i12 = i14 + 100 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i5 = 0;
 i6 = (i1 * 6 | 0) + i2 + (HEAP32[i13 + 80 >> 2] | 0) | 0;
 while (1) {
  i2 = i3 + i5 | 0;
  i16 = i4 + (i2 << 2) | 0;
  i1 = HEAP32[(HEAP32[(HEAP32[i16 >> 2] | 0) + 28 >> 2] | 0) + 100 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  if ((HEAP32[i16 >> 2] | 0) == (i7 | 0)) {
   i7 = i1;
   i3 = i2;
   break;
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
   i8 = 9;
   break;
  } else i6 = i1 + i6 | 0;
 }
 if ((i8 | 0) == 9) {
  STACKTOP = i15;
  return;
 }
 i1 = i3 + 1 | 0;
 i4 = i14 + 120 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i5 >>> 0) {
  i16 = HEAP32[i11 >> 2] | 0;
  i2 = i16 + (i3 << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i16 + (i1 << 2) >> 2];
  i1 = i3 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i4 >> 2] = i5 + -1;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i16 = HEAP32[i13 + 28 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i16 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 mftCall_viiii(i13 | 0, i16 | 0, i9 | 0, i6 | 0, i7 + i6 | 0);
 i16 = i14 + 112 | 0;
 HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) - i7;
 STACKTOP = i15;
 return;
}

function __ZN5physx11NpAggregate7releaseEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i6, 0, 1);
 i1 = i6 + 36 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = i6 + 40 | 0;
  i4 = i6 + 8 | 0;
  i5 = 0;
  do {
   i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i7 = (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0) == 4;
   i2 = HEAP32[i3 >> 2] | 0;
   if (i7) HEAP32[(HEAP32[(HEAP32[i2 + (i5 << 2) >> 2] | 0) + 288 >> 2] | 0) + 100 >> 2] = 0;
   i2 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
   i8 = HEAPU16[i2 + 4 >> 1] | 0;
   i7 = i2 + (HEAP32[gb + 1457020 + 68 + (i8 << 2) >> 2] | 0) | 0;
   __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i2 + (HEAP32[gb + 1457020 + (i8 << 2) >> 2] | 0) | 0, 0, i2);
   __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i4, i7, 1);
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 if ((((HEAP32[i6 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i8 = i6 + 8 | 0;
  __ZN5physx3Scb4Base7destroyEv(i8);
  return;
 }
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 if (!i1) {
  i8 = i6 + 8 | 0;
  __ZN5physx3Scb4Base7destroyEv(i8);
  return;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 if (!i1) {
  i8 = i6 + 8 | 0;
  __ZN5physx3Scb4Base7destroyEv(i8);
  return;
 }
 __ZN5physx3Scb5Scene15removeAggregateERNS0_9AggregateE(i1 + 16 | 0, i6 + 8 | 0);
 i5 = i1 + 3576 | 0;
 i3 = i1 + 3580 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L18 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L18;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  i8 = i6 + 8 | 0;
  __ZN5physx3Scb4Base7destroyEv(i8);
  return;
 }
 i7 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i7;
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i8 + (i7 << 2) >> 2];
 i8 = i6 + 8 | 0;
 __ZN5physx3Scb4Base7destroyEv(i8);
 return;
}

function __ZN15OcclusionPortal8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 72 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE(i4, i2, i6, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) i5 = 5; else {
     i7 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i7 + 1;
     HEAP32[i2 >> 2] = i3 + -1;
    }
   } else i5 = 5;
   if ((i5 | 0) == 5) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
   }
   HEAP32[i6 >> 2] = i1 & 255;
   return;
  }
 case 1:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i3 >>> 0 < 2) i5 = 10; else {
     i8 = HEAP32[i4 >> 2] | 0;
     i1 = HEAP8[i8 >> 0] | 0;
     i7 = i8 + 1 | 0;
     HEAP32[i4 >> 2] = i7;
     HEAP32[i2 >> 2] = i3 + -1;
     i7 = HEAP8[i7 >> 0] | 0;
     HEAP32[i4 >> 2] = i8 + 2;
     HEAP32[i2 >> 2] = i3 + -2;
     i1 = i1 & 255;
     i2 = (i7 & 255) << 8;
    }
   } else i5 = 10;
   if ((i5 | 0) == 10) {
    HEAP8[i1 >> 0] = 1;
    i1 = 0;
    i2 = 0;
   }
   HEAP32[i6 >> 2] = i1 | i2;
   return;
  }
 default:
  {
   i1 = i4 + 8 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    i2 = i4 + 4 | 0;
    if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 4) {
     HEAP8[i6 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
     i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     HEAP8[i6 + 1 >> 0] = HEAP8[i8 >> 0] | 0;
     i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     HEAP8[i6 + 2 >> 0] = HEAP8[i8 >> 0] | 0;
     i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
     HEAP32[i4 >> 2] = i8;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     HEAP8[i6 + 3 >> 0] = HEAP8[i8 >> 0] | 0;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
     return;
    }
   }
   HEAP8[i1 >> 0] = 1;
   return;
  }
 }
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx2Sc19ShapeInstancePairLL7destroyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv(i4);
 i3 = i4 + 32 | 0;
 __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, 0, i4 + 60 | 0);
 i2 = i4 + 8 | 0;
 i1 = i4 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i1 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i4 + 16 >> 2] | 0, i2);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i2);
 do if ((HEAP32[i4 + 52 >> 2] | 0) == -1) i1 = i4 + 44 | 0; else {
  i2 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0;
  i1 = i4 + 44 | 0;
  i2 = HEAP32[i2 + 1104 >> 2] | 0;
  if (!(HEAP32[i1 >> 2] & 8388608)) {
   __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i2, i4);
   break;
  } else {
   __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i2, i4);
   break;
  }
 } while (0);
 if (!(HEAP32[i1 >> 2] & 32768)) {
  i4 = i4 + 48 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i4 = i4 + 16 | 0;
  i3 = HEAP16[i4 >> 1] | 0;
  i3 = i3 + -1 << 16 >> 16;
  HEAP16[i4 >> 1] = i3;
  return;
 }
 i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i3 >> 2] | 0) | 0;
 i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i4 + 36 >> 2] | 0) | 0;
 if (i1 | 0) {
  i3 = i1 + 148 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
 }
 if (i2 | 0) {
  i3 = i2 + 148 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
 }
 i4 = i4 + 48 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 14 | 0;
 HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
 i4 = HEAP32[i4 >> 2] | 0;
 i4 = i4 + 16 | 0;
 i3 = HEAP16[i4 >> 1] | 0;
 i3 = i3 + -1 << 16 >> 16;
 HEAP16[i4 >> 1] = i3;
 return;
}

function __ZN16SpriteRenderData10SetIndicesEPKtj(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = i1 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 i2 = i1 + 28 | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = i8;
 i4 = i1 + 44 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i8 >>> 0) {
  i8 = i8 << 1;
  i6 = HEAP32[i2 >> 2] | 0;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i8;
  i8 = i8 << 1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i8, 2, i1 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i2 >> 2] = i6;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i5 = i8 << 1;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 2, i1 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i2 >> 2] = i6;
  i8 = i5;
  _memcpy(i6 | 0, i7 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13WheelCollider7SetMassEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i3 + 96 | 0;
 if (Math_fround(HEAPF32[i9 >> 2]) != f1) {
  i7 = f1 < Math_fround(9.99999974e-06);
  HEAP32[i9 >> 2] = i7 ? 925353388 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 i7 = i3 + 148 | 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 52 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 56 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i3 + 72 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 i2 = f1 < Math_fround(0.0);
 f11 = Math_fround(-f1);
 f1 = i2 ? f11 : f1;
 i2 = f1 < Math_fround(9.99999974e-06);
 f1 = i2 ? Math_fround(9.99999974e-06) : f1;
 i2 = i4 + 56 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + 8 | 0;
 i4 = i8;
 i5 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i3, HEAP32[i7 >> 2] | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 + 8 >> 2] = i9;
 HEAPF32[i8 + 12 >> 2] = Math_fround(f1 * Math_fround(f1 * Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5))));
 __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i3, HEAP32[i7 >> 2] | 0, i8);
 i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 284 >> 2] | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i6 = i7;
 if (!i3) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i4) | 0;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!i2) i2 = i1; else {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i2 = i1 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) | 0);
 }
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) {
  i6 = i2;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i6 = i2 | (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i1, i4) | 0);
 STACKTOP = i7;
 return i6 | 0;
}

function _common_180(i4, d10, i2, i11) {
 i4 = i4 | 0;
 d10 = +d10;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var d1 = 0.0, d3 = 0.0, d5 = 0.0, d6 = 0.0, i7 = 0, i8 = 0, d9 = 0.0;
 d1 = +Math_sin(+d10);
 i2 = (i2 | 0) != 0;
 d1 = i2 ? -d1 : d1;
 d5 = +Math_cos(+d10);
 d9 = d1 - d5;
 if (i4 >>> 0 < 2145386496) {
  d3 = -d1 - d5;
  d6 = +Math_cos(+(d10 * 2.0));
  if (d1 * d5 > 0.0) d1 = d6 / d3; else {
   d1 = d9;
   d3 = d6 / d9;
  }
  if (i4 >>> 0 < 1207959552) {
   d3 = i2 ? -d3 : d3;
   HEAPF64[tempDoublePtr >> 3] = d10;
   i7 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
   i8 = i7 >>> 0 > 1075838975;
   if (i8) {
    i2 = gb + 9752 | 0;
    i4 = gb + 9672 | 0;
   } else if (i7 >>> 0 > 1074933386) {
    i2 = gb + 9800 | 0;
    i4 = gb + 9712 | 0;
   } else {
    i4 = i7 >>> 0 > 1074191212;
    i2 = i4 ? gb + 9576 | 0 : gb + 9624 | 0;
    i4 = i4 ? gb + 9496 | 0 : gb + 9536 | 0;
   }
   d5 = 1.0 / (d10 * d10);
   d1 = d1 * ((+HEAPF64[i2 >> 3] + d5 * (+HEAPF64[i2 + 8 >> 3] + d5 * (+HEAPF64[i2 + 16 >> 3] + d5 * (+HEAPF64[i2 + 24 >> 3] + d5 * (+HEAPF64[i2 + 32 >> 3] + d5 * +HEAPF64[i2 + 40 >> 3]))))) / (d5 * (+HEAPF64[i4 >> 3] + d5 * (+HEAPF64[i4 + 8 >> 3] + d5 * (+HEAPF64[i4 + 16 >> 3] + d5 * (+HEAPF64[i4 + 24 >> 3] + d5 * +HEAPF64[i4 + 32 >> 3])))) + 1.0) + 1.0);
   if (i8) {
    i2 = gb + 10136 | 0;
    i4 = gb + 10040 | 0;
   } else if (i7 >>> 0 > 1074933386) {
    i2 = gb + 10184 | 0;
    i4 = gb + 10088 | 0;
   } else {
    i4 = i7 >>> 0 > 1074191212;
    i2 = i4 ? gb + 9944 | 0 : gb + 9992 | 0;
    i4 = i4 ? gb + 9848 | 0 : gb + 9896 | 0;
   }
   d1 = d1 - d3 * (((+HEAPF64[i2 >> 3] + d5 * (+HEAPF64[i2 + 8 >> 3] + d5 * (+HEAPF64[i2 + 16 >> 3] + d5 * (+HEAPF64[i2 + 24 >> 3] + d5 * (+HEAPF64[i2 + 32 >> 3] + d5 * +HEAPF64[i2 + 40 >> 3]))))) / (d5 * (+HEAPF64[i4 >> 3] + d5 * (+HEAPF64[i4 + 8 >> 3] + d5 * (+HEAPF64[i4 + 16 >> 3] + d5 * (+HEAPF64[i4 + 24 >> 3] + d5 * (+HEAPF64[i4 + 32 >> 3] + d5 * +HEAPF64[i4 + 40 >> 3]))))) + 1.0) + .375) / d10);
  }
 } else d1 = d9;
 return +(((i11 | 0) == 0 ? d1 : -d1) * .5641895835477563 / +Math_sqrt(+d10));
}

function __ZN5physx2Gu12StoreIndicesEjjPKjRNS_14PxOutputStreamEb(i3, i8, i7, i9, i5) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i2 = i10 + 4 | 0;
 if (i3 >>> 0 < 256) {
  if (!i8) {
   STACKTOP = i10;
   return;
  }
  i1 = 0;
  do {
   HEAP8[i2 >> 0] = HEAP32[i7 + (i1 << 2) >> 2];
   mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i2 | 0, 1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
  STACKTOP = i10;
  return;
 }
 i1 = (i8 | 0) == 0;
 if (i3 >>> 0 < 65536) {
  if (i1) {
   STACKTOP = i10;
   return;
  }
  i2 = i6 + 1 | 0;
  if (i5) {
   i1 = 0;
   do {
    i5 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
    i4 = i5 & 65535;
    HEAP16[i6 >> 1] = i4;
    HEAP8[i6 >> 0] = (i4 & 65535) >>> 8;
    HEAP8[i2 >> 0] = i5;
    mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i6 | 0, 2) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   STACKTOP = i10;
   return;
  } else {
   i1 = 0;
   do {
    HEAP16[i6 >> 1] = HEAP32[i7 + (i1 << 2) >> 2];
    mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i6 | 0, 2) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   STACKTOP = i10;
   return;
  }
 } else {
  if (i1) {
   STACKTOP = i10;
   return;
  }
  i2 = i6 + 3 | 0;
  i3 = i6 + 1 | 0;
  i4 = i6 + 2 | 0;
  if (i5) {
   i1 = 0;
   do {
    i5 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
    HEAP32[i6 >> 2] = i5;
    HEAP8[i6 >> 0] = i5 >>> 24;
    HEAP8[i2 >> 0] = i5;
    HEAP8[i3 >> 0] = i5 >>> 16;
    HEAP8[i4 >> 0] = i5 >>> 8;
    mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i6 | 0, 4) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   STACKTOP = i10;
   return;
  } else {
   i1 = 0;
   do {
    HEAP32[i6 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
    mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i6 | 0, 4) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
   STACKTOP = i10;
   return;
  }
 }
}

function __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 40 | 0;
 i6 = i10;
 i7 = i10 + 8 | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i8, i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i9 = i6 + 4 | 0;
 HEAP32[i9 >> 2] = -1;
 if (HEAP32[i4 + 4 >> 2] | 0) {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i5 = i2;
  do if (!i2) i1 = -1; else if (!(HEAP32[i8 + 24 >> 2] | 0)) {
   i1 = __Z22scripting_array_lengthP11Il2CppArray(i2) | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   break;
  } while (0);
  HEAP32[i6 >> 2] = i5;
  HEAP32[i6 + 4 >> 2] = i1;
 };
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = i6;
 mftCall_vii(HEAP32[i3 + 40 >> 2] | 0, i3 | 0, i7 | 0);
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i7) >> 2] = i6;
 if ((HEAP32[i8 + 24 >> 2] | 0) != 1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 >> 2];
 i9 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 + 28 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + ((HEAP8[i8 + 32 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i8 + 44 >> 2] | 0) | 0 : i9) >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 40 | 0;
 i6 = i10;
 i7 = i10 + 8 | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i8, i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i9 = i6 + 4 | 0;
 HEAP32[i9 >> 2] = -1;
 if (HEAP32[i4 + 4 >> 2] | 0) {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i5 = i2;
  do if (!i2) i1 = -1; else if (!(HEAP32[i8 + 24 >> 2] | 0)) {
   i1 = __Z22scripting_array_lengthP11Il2CppArray(i2) | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   break;
  } while (0);
  HEAP32[i6 >> 2] = i5;
  HEAP32[i6 + 4 >> 2] = i1;
 };
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = i6;
 mftCall_vii(HEAP32[i3 + 40 >> 2] | 0, i3 | 0, i7 | 0);
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i7) >> 2] = i6;
 if ((HEAP32[i8 + 24 >> 2] | 0) != 1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 >> 2];
 i9 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 + 28 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + ((HEAP8[i8 + 32 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i8 + 44 >> 2] | 0) | 0 : i9) >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __ZN7mecanim9animation9DenseClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i9 = i1 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i1 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 >> 2] = i3;
  i4 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i6, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i5 = i6 + 20 | 0;
 i6 = i6 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i7, 4);
 i1 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN21RotationBySpeedModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj(i8, i1, i2, i9, i10, i11, i12) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i1 = i7;
 if (!(HEAP8[i9 + 869 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP16[gb + 1451764 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451764 | 0, i6);
  i2 = gb + 1451764 | 0;
 } else i2 = 0;
 __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i6, i8 + 804 | 0);
 i1 = HEAP8[i8 + 800 >> 0] | 0 ? 0 : 2;
 do {
  i3 = i8 + 8 + (i1 * 264 | 0) | 0;
  i4 = HEAP16[i8 + 8 + (i1 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i4 << 16 >> 16)) __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i3, i9, HEAP32[i9 + 360 + (i1 * 20 | 0) >> 2] | 0, i10, i11, i12, i6); else {
   if (!(HEAP8[i8 + 8 + (i1 * 264 | 0) + 86 >> 0] | 0)) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i3, i9, HEAP32[i9 + 360 + (i1 * 20 | 0) >> 2] | 0, i10, i11, i12, i6);
    break;
   }
   i5 = HEAP32[i9 + 360 + (i1 * 20 | 0) >> 2] | 0;
   if ((i4 | 1) << 16 >> 16 == 3) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i3, i9, i5, i10, i11, i12, i6);
    break;
   } else {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f(i3, i9, i5, i10, i11, i12, i6);
    break;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return;
}

function __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE10insert_oneERKS1_(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 4 | 0;
 i8 = i10;
 i3 = __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE11lower_boundIS1_EENS2_11__wrap_iterIPS1_EERKT_(i6, i7) | 0;
 i9 = i3;
 L1 : do if ((i3 | 0) != (HEAP32[i6 + 4 >> 2] | 0)) {
  i1 = HEAP32[i7 + 32 >> 2] | 0;
  i2 = HEAP32[i3 + 32 >> 2] | 0;
  do if ((i1 | 0) == (i2 | 0)) {
   i1 = HEAP32[i7 + 28 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = HEAP32[i7 + 24 >> 2] | 0;
    i2 = HEAP32[i3 + 24 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i1 = HEAP32[i7 + 20 >> 2] | 0;
     i2 = HEAP32[i3 + 20 >> 2] | 0;
     if ((i1 | 0) == (i2 | 0)) {
      i1 = HEAP32[i7 + 16 >> 2] | 0;
      i2 = HEAP32[i3 + 16 >> 2] | 0;
      if ((i1 | 0) == (i2 | 0)) {
       i1 = HEAP32[i7 + 12 >> 2] | 0;
       i2 = HEAP32[i3 + 12 >> 2] | 0;
       if ((i1 | 0) == (i2 | 0)) {
        i1 = HEAP32[i7 + 8 >> 2] | 0;
        i2 = HEAP32[i3 + 8 >> 2] | 0;
        if ((i1 | 0) == (i2 | 0)) {
         i1 = HEAP32[i7 + 4 >> 2] | 0;
         i2 = HEAP32[i3 + 4 >> 2] | 0;
         if ((i1 | 0) == (i2 | 0)) {
          i1 = HEAP32[i7 >> 2] | 0;
          i2 = HEAP32[i3 >> 2] | 0;
          if ((i1 | 0) == (i2 | 0)) break;
         }
        }
       }
      }
     }
    }
   }
   if (i1 >>> 0 < i2 >>> 0) break L1;
  } else if ((i1 | 0) < (i2 | 0)) break L1; while (0);
  HEAP32[i5 >> 2] = i9;
  HEAP8[i5 + 4 >> 0] = 0;
  STACKTOP = i10;
  return;
 } while (0);
 HEAP32[i8 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 >> 2] = __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_(i6, i4, i7) | 0;
 HEAP8[i5 + 4 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __ZNK5physx2Gu5RTree4saveERNS_14PxOutputStreamE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN5physx10writeChunkEaaaaRNS_14PxOutputStreamE(82, 84, 82, 69, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[gb + 107348 >> 2] | 0, 1, i4);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i1, 4, 1, i4);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i1 + 16 | 0, 4, 1, i4);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i1 + 32 | 0, 4, 1, i4);
 __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i1 + 48 | 0, 4, 1, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 64 >> 2] | 0, 1, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 68 >> 2] | 0, 1, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 72 >> 2] | 0, 1, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 76 >> 2] | 0, 1, i4);
 i3 = i1 + 80 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i3 >> 2] | 0, 1, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[i1 + 88 >> 2] | 0, 1, i4);
 if (!(HEAP32[i3 >> 2] | 0)) return 1;
 i1 = i1 + 92 | 0;
 i2 = 0;
 do {
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 16 | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 32 | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 48 | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 64 | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 80 | 0, 4, 1, i4);
  __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE((HEAP32[i1 >> 2] | 0) + (i2 * 112 | 0) + 96 | 0, 4, 1, i4);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return 1;
}

function __ZNK24RingBufferMemoryFileData4ReadEyyPv(i1, i10, i11, i15, i16, i17) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i18 = 0, i19 = 0, i20 = 0;
 i18 = i1 + 40 | 0;
 i3 = i18;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (i3 >>> 0 > i11 >>> 0 | (i3 | 0) == (i11 | 0) & i2 >>> 0 > i10 >>> 0) {
  i17 = 0;
  i18 = 0;
  setTempRet0(i17 | 0);
  return i18 | 0;
 }
 L4 : do if ((i15 | 0) == 0 & (i16 | 0) == 0) i1 = 0; else {
  i12 = i1 + 20 | 0;
  i13 = i1 + 64 | 0;
  i14 = i1 + 52 | 0;
  i9 = i1 + 48 | 0;
  i1 = 0;
  i4 = 0;
  i5 = 0;
  while (1) {
   i7 = _i64Subtract(i15 | 0, i16 | 0, i4 | 0, i5 | 0) | 0;
   i8 = getTempRet0() | 0;
   i4 = _i64Add(i4 | 0, i5 | 0, i10 | 0, i11 | 0) | 0;
   i3 = _i64Subtract(i4 | 0, getTempRet0() | 0, i2 | 0, i3 | 0) | 0;
   i4 = getTempRet0() | 0;
   i5 = ___udivdi3(i3 | 0, i4 | 0, HEAP32[i12 >> 2] | 0, 0) | 0;
   getTempRet0() | 0;
   if (i5 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) i6 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i5 << 2) >> 2] | 0; else i6 = 0;
   i20 = _i64Add(i3 | 0, i4 | 0, i7 | 0, i8 | 0) | 0;
   i19 = getTempRet0() | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i20 = i19 >>> 0 > 0 | (i19 | 0) == 0 & i20 >>> 0 > i2 >>> 0;
   i2 = _i64Subtract(i2 | 0, 0, i3 | 0, i4 | 0) | 0;
   i19 = getTempRet0() | 0;
   i2 = i20 ? i2 : i7;
   if ((i6 | 0) == 0 | (i2 | 0) == 0 & ((i20 ? i19 : i8) | 0) == 0) break L4;
   i19 = HEAP32[i12 >> 2] | 0;
   i20 = _i64Subtract(i3 | 0, i4 | 0, Math_imul(i19, i5) | 0, 0) | 0;
   getTempRet0() | 0;
   i19 = i19 - i20 | 0;
   i2 = i2 >>> 0 < i19 >>> 0 ? i2 : i19;
   _memcpy(i17 + i1 | 0, i6 + i20 | 0, i2 | 0) | 0;
   i2 = i2 + i1 | 0;
   if (!(0 < i16 >>> 0 | 0 == (i16 | 0) & i2 >>> 0 < i15 >>> 0)) {
    i1 = i2;
    break L4;
   }
   i3 = i18;
   i1 = i2;
   i4 = i2;
   i5 = 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
  }
 } while (0);
 i19 = 0;
 i20 = i1;
 setTempRet0(i19 | 0);
 return i20 | 0;
}

function __ZN5physx2Sn18RepXCollectionImpl16createCollectionEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 4 | 0;
 i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 164, gb + 767044 | 0, gb + 766736 | 0, 654) | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = gb + 146368 + 8;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i6;
 i5 = i6 + 80 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[i3 + 8 >> 2] = i6 + 4;
 HEAP32[i3 + 12 >> 2] = i4;
 HEAP32[i3 + 16 >> 2] = i6;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i4 = i3 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 36 >> 2] = i4;
 i6 = i4;
 HEAP32[i3 + 40 >> 2] = i6;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 i5 = i3 + 56 | 0;
 HEAP32[i5 >> 2] = i6;
 i6 = i3 + 60 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAPF32[i3 + 84 >> 2] = Math_fround(.75);
 HEAP32[i3 + 88 >> 2] = -1;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i5, 64);
 HEAP32[i3 + 100 >> 2] = 32;
 HEAP32[i3 + 112 >> 2] = i4;
 i4 = i3 + 116 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = gb + 89528 + 8;
 HEAP32[i3 + 108 >> 2] = gb + 89528 + 32;
 i4 = i3 + 132 | 0;
 i5 = i2 + 132 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 144 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i3 + 148 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i3 + 152 >> 2] = HEAP32[i2 + 152 >> 2];
 HEAP32[i3 + 156 >> 2] = i1;
 HEAP32[i3 + 160 >> 2] = 0;
 return i3 | 0;
}

function __ZN24MeshIntermediateRenderer10InitializeERK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebi(i10, i11, i2, i12, i6, i7, i8, i9, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i13 = 0;
 i5 = i10 + 280 | 0;
 HEAP32[i5 >> 2] = i2;
 do if (i2) {
  i4 = i10 + 268 | 0;
  i3 = i2 + 240 | 0;
  if ((i4 | 0) != (i3 | 0)) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) i2 = i10 + 272 | 0; else {
    i13 = i10 + 272 | 0;
    HEAP32[i2 + 4 >> 2] = HEAP32[i13 >> 2];
    HEAP32[HEAP32[i13 >> 2] >> 2] = i2;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i13 >> 2] = 0;
    i2 = i13;
   }
   i13 = HEAP32[i3 >> 2] | 0;
   HEAP32[i4 >> 2] = i13;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i13 + 4 >> 2] = i4;
   HEAP32[HEAP32[i2 >> 2] >> 2] = i4;
  }
  if ((i1 | 0) >= 0) if ((__ZNK4Mesh15GetSubMeshCountEv(HEAP32[i5 >> 2] | 0) | 0) > (i1 | 0)) break;
  i1 = 0;
 } while (0);
 HEAP32[i10 + 284 >> 2] = i1;
 HEAP32[i10 + 252 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 260 >> 2] = i7 >>> 0 > 31 ? 0 : i7;
 i1 = i10 + 236 | 0;
 i2 = (i9 & 1) << 8 | i8 << 6 & 192 | (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773183;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i10 + 4 | 0;
 i2 = i11;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i10 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i11, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0;
 i13 = i10 + 156 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
 HEAP32[i13 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i12, i11, i10 + 132 | 0);
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 HEAP8[i10 + 240 >> 0] = 0;
 HEAP8[i10 + 241 >> 0] = 0;
 return;
}

function __ZN19RuntimeSceneManager17DontDestroyOnLoadER6Object(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
 if ((i2 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) i1 = HEAP32[i1 + 28 >> 2] | 0; else i1 = (i2 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0 ? i1 : 0;
 if (i1 | 0) if (!(HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0)) {
  i3 = i11 + 68 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i11 + 80 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 + 1 | 0;
  i8 = i11 + 84 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i2 = i9 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i11 + 72 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11 + 72 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i3 >> 2] = i11;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i7;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i6 << 2) >> 2] = i4;
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
  if (!i1) {
   i11 = 1;
   return i11 | 0;
  }
  i2 = i1 + 104 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i11 = i1 + 108 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i11 >> 2];
   HEAP32[HEAP32[i11 >> 2] >> 2] = i3;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i11 >> 2] = 0;
  }
  HEAP32[i1 + 116 >> 2] = 0;
  i11 = 1;
  return i11 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 463494 | 0, 0, gb + 462762 | 0, 447, 512, 0, 0, 0);
 i11 = 0;
 return i11 | 0;
}

function __ZN10GISettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i4 = i5 + 4 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i3 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 12 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 16 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 20 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 21 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = i4;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i11, i1, i5 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i5, HEAP32[i11 >> 2] | 0, i1 << 4);
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) i1 = HEAP32[i6 >> 2] | 0; else {
  i8 = i8 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i8 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i8 >> 2] | 0, i1, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 }
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i8 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z17GetWebErrorString8WebError(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 2:
  {
   i1 = gb + 1030869 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 1030840 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 1030819 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 1030805 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 1030784 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 1030752 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 1030717 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 1030703 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 1030676 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 1030655 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 1030635 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 1030621 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 1030605 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 1030569 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 1030535 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 1030519 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 1030495 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 1030466 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 1030428 | 0;
   break;
  }
 case 21:
  {
   i1 = gb + 1030404 | 0;
   break;
  }
 case 22:
  {
   i1 = gb + 1030381 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 1030331 | 0;
   break;
  }
 case 24:
  {
   i1 = gb + 1030288 | 0;
   break;
  }
 case 25:
  {
   i1 = gb + 1030263 | 0;
   break;
  }
 case 26:
  {
   i1 = gb + 1030233 | 0;
   break;
  }
 case 27:
  {
   i1 = gb + 1030220 | 0;
   break;
  }
 case 28:
  {
   i1 = gb + 1030200 | 0;
   break;
  }
 case 29:
  {
   i1 = gb + 1030174 | 0;
   break;
  }
 case 30:
  {
   i1 = gb + 1030118 | 0;
   break;
  }
 case 31:
  {
   i1 = gb + 1030083 | 0;
   break;
  }
 case 32:
  {
   i1 = gb + 1030043 | 0;
   break;
  }
 case 33:
  {
   i1 = gb + 1030002 | 0;
   break;
  }
 case 34:
  {
   i1 = gb + 1029961 | 0;
   break;
  }
 case 35:
  {
   i1 = gb + 1029933 | 0;
   break;
  }
 case 36:
  {
   i1 = gb + 1029913 | 0;
   break;
  }
 case 37:
  {
   i1 = gb + 1029897 | 0;
   break;
  }
 default:
  i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteUintEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i11 = __ZN9rapidjson8internal6u32toaEjPc(i1, i6) | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i5 = i4 + 12 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + (i11 - i6) | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i4 >> 2] = i10;
  break;
 } while (0);
 if ((i6 | 0) == (i11 | 0)) {
  STACKTOP = i13;
  return 1;
 }
 do {
  i2 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = i2 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i7 = i5 + 1 | 0;
  i8 = i2 + 16 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i7 >>> 0 > i10 >>> 0) {
   i1 = i9 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i8 >> 2] = i1;
    HEAP32[i2 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i7;
  HEAP8[(HEAP32[i2 >> 2] | 0) + i5 >> 0] = i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 STACKTOP = i13;
 return 1;
}

function __ZN7ApiGLES14TextureSamplerEj16TextureDimension17TextureFilterMode15TextureWrapModeifb18ShadowSamplingModeN2gl17TextureSrgbDecodeE(i6, i1, i2, i7, i4, i8, f9, i10, i11, i12) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i5 = 0;
 i5 = i6 + 860 | 0;
 i3 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i5 >> 2] | 0, i2) | 0;
 i1 = __ZNK13TranslateGLES4WrapE15TextureWrapMode(HEAP32[i5 >> 2] | 0, i4) | 0;
 i2 = i6 + 180 | 0;
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 10242, i1 | 0);
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 10243, i1 | 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0) mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 32882, i1 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(i4 | 0, i3 | 0, 10240, __ZNK13TranslateGLES9FilterMagE17TextureFilterMode(HEAP32[i5 >> 2] | 0, i7) | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(i4 | 0, i3 | 0, 10241, __ZNK13TranslateGLES9FilterMinE17TextureFilterModeb(HEAP32[i5 >> 2] | 0, i7, i10) | 0);
 if ((i8 | 0) > 0 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 152 >> 0] | 0) != 0) {
  i10 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 112 >> 2] | 0;
  mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 34046, ((i10 | 0) < (i8 | 0) ? i10 : i8) | 0);
 }
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 153 >> 0] | 0) mftCall_viif(HEAP32[i6 + 608 >> 2] | 0, i3 | 0, 34049, +f9);
 L10 : do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0) switch (i11 | 0) {
 case 1:
  {
   mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 34892, 0);
   break L10;
  }
 case 0:
  {
   mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 34892, 34894);
   mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 34893, 515);
   break L10;
  }
 default:
  break L10;
 } while (0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 652 >> 0] | 0)) return;
 i11 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(i11 | 0, i3 | 0, 35400, __ZNK13TranslateGLES20GetTextureSRGBDecodeEN2gl17TextureSrgbDecodeE(HEAP32[i5 >> 2] | 0, i12) | 0);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN11MonoManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i11);
 i6 = i10 + 28 | 0;
 i8 = i11 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i2;
 }
 i5 = i10 + 32 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 2;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj(i6, i4 - i3 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else if (i4 >>> 0 < i3 >>> 0) {
  i3 = i1 + (i4 << 2) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2) | 0;
   HEAP32[i5 >> 2] = i2;
  }
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i10 + 212 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i10 + 216 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i11, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i11);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i12;
 return;
}

function __ZL11TextHandleriPK23EmscriptenKeyboardEventPv(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 i1 = HEAP32[i6 + 152 >> 2] | 0;
 if (!i1) if ((HEAP32[i6 + 156 >> 2] | 0) == 13) i1 = 13; else {
  STACKTOP = i5;
  return 1;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i1 & 65535;
 HEAP16[i3 >> 1] = i1;
 if (__Z18ConvertUTF16toUTF8PKtiRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i3, 1, i4) | 0) {
  i8 = (__Z15GetInputManagerv() | 0) + 136 | 0;
  i2 = HEAP8[i4 + 11 >> 0] | 0;
  i7 = i2 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i8, i7 ? HEAP32[i4 >> 2] | 0 : i4, i7 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255) | 0;
 }
 HEAP32[i3 + 44 >> 2] = 0;
 __ZN10InputEvent4InitEi(i3, 0);
 HEAP32[i3 >> 2] = 4;
 i2 = (HEAP32[i6 + 68 >> 2] | 0) == 0;
 if (!i2) if (!(HEAP32[i6 + 76 >> 2] | 0)) {
  i8 = i3 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 }
 if (HEAP32[i6 + 72 >> 2] | 0) {
  i8 = i3 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1;
 }
 if (!((HEAP32[i6 + 76 >> 2] | 0) == 0 | i2 ^ 1)) {
  i8 = i3 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 }
 if (HEAP32[i6 + 80 >> 2] | 0) {
  i8 = i3 + 24 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 8;
 }
 i7 = __Z15GetInputManagerv() | 0;
 i8 = HEAP32[i7 + 116 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i7 + 120 >> 2]);
 i7 = __Z16GetScreenManagerv() | 0;
 f9 = Math_fround(Math_fround((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i7 | 0) | 0) + -1 | 0) - f9);
 HEAP32[i3 + 4 >> 2] = i8;
 HEAPF32[i3 + 8 >> 2] = f9;
 HEAP16[i3 + 36 >> 1] = i1;
 __Z16SanitizeKeyEventR10InputEvent(i3);
 __ZN15GUIEventManager10QueueEventERK10InputEvent(__Z18GetGUIEventManagerv() | 0, i3);
 __ZN10InputEventD2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i5;
 return 1;
}

function __ZNK26AnimatorControllerPlayable8HasStateEii(i3, i5, i7) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i6 = i8 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i3 | 0) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((i5 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i3 | 0) | 0) i1 = HEAP32[HEAP32[i3 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i5 | 0)) {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i4 = i1 + 12 | 0;
    i6 = i1 + 4 | 0;
    i6 = (HEAP32[i6 >> 2] | 0) + i6 + (i5 << 2) | 0;
    i6 = (HEAP32[i4 >> 2] | 0) + i4 + (HEAP32[i6 + (HEAP32[i6 >> 2] | 0) >> 2] << 2) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    i1 = (i1 | 0) == 0 ? 0 : i6 + i1 | 0;
   }
   i2 = i1 + 4 | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   if (!i4) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
   i1 = 0;
   while (1) {
    i3 = i2 + (i1 << 2) | 0;
    i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
    if ((HEAP32[i3 + 32 >> 2] | 0) == (i7 | 0)) {
     i1 = 1;
     i2 = 17;
     break;
    }
    if ((HEAP32[i3 + 28 >> 2] | 0) == (i7 | 0)) {
     i1 = 1;
     i2 = 17;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((HEAP32[i3 + 24 >> 2] | 0) == (i7 | 0)) {
     i1 = 1;
     i2 = 17;
     break;
    }
    if (i1 >>> 0 >= i4 >>> 0) {
     i1 = 0;
     i2 = 17;
     break;
    }
   }
   if ((i2 | 0) == 17) {
    STACKTOP = i8;
    return i1 | 0;
   }
  }
 }
 HEAP32[i4 >> 2] = i5;
 __Z6FormatPKcz(i6, gb + 902210 | 0, i4);
 i1 = HEAP32[i3 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i6, i3, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i6 >> 2] | 0)) {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i6 + 4 | 0;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
  }
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i3;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i6 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i6 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + (i6 * 24 | 0) | 0;
 if (i6 | 0) {
  i4 = i9 + 20 | 0;
  while (1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i4 >> 2] = gb + 1034406;
   __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(i9, i2, gb + 1034411 | 0, 0, 0);
   __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 12 | 0, gb + 1034420 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 24 | 0;
  }
 }
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 32 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 16 >> 2] | 0;
   i3 = i11 + 20 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 48 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 16 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx16PxsIslandManager17cleanupEdgeEventsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 4 | 0;
 i4 = i7 + 352 | 0;
 i5 = i7 + 360 | 0;
 if (!((HEAP32[i4 >> 2] | 0) != 0 & (HEAP32[i5 >> 2] | 0) != 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i7 + 628 >> 2] | 0;
 i2 = HEAP32[i7 + 292 >> 2] | 0;
 i3 = i2 << 2;
 if ((HEAP32[i7 + 624 >> 2] | 0) >>> 0 < i3 >>> 0) {
  i6 = 1;
  i10 = __ZN5physx19PxcScratchAllocator5allocEjb(HEAP32[i7 + 4 >> 2] | 0, i3, 1) | 0;
 } else {
  i6 = 0;
  i10 = i1;
 }
 if (!i10) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 719876 | 0, 1210, gb + 719966 | 0, i12);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 _memset(i10 | 0, 0, i3 | 0) | 0;
 __ZN5physx17EdgeChangeManager17cleanupEdgeEventsEPij(i7 + 332 | 0, i10, i2);
 if (!i6) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (i1 >>> 0 > i10 >>> 0) i11 = 8; else if ((i1 + (HEAP32[i9 + 20 >> 2] | 0) | 0) >>> 0 > i10 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
  i5 = i9 + 8 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i9 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i6;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i10 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i6 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i6 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i6 | 0));
  }
  HEAP32[i5 >> 2] = i6 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
 } else i11 = 8;
 if ((i11 | 0) == 8) __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i10);
 STACKTOP = i12;
 return;
}

function __ZN4crnd26crnd_create_segmented_fileEPKvjPvj(i2, i1, i8, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 if ((i2 | 0) == 0 | i1 >>> 0 < 74) {
  i8 = 0;
  return i8 | 0;
 }
 if (((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0) | 0) != 18552) {
  i8 = 0;
  return i8 | 0;
 }
 if (((HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0)) >>> 0 < 74) {
  i8 = 0;
  return i8 | 0;
 }
 if (((HEAPU8[i2 + 7 >> 0] | 0) << 16 | (HEAPU8[i2 + 6 >> 0] | 0) << 24 | (HEAPU8[i2 + 8 >> 0] | 0) << 8 | (HEAPU8[i2 + 9 >> 0] | 0)) >>> 0 > i1 >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 if (HEAP8[i2 + 20 >> 0] & 1) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = __ZN4crnd28crnd_get_segmented_file_sizeEPKvj(i2, i1) | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 _memcpy(i8 | 0, i2 | 0, i1 | 0) | 0;
 i5 = i8 + 20 | 0;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 0 | 1;
 i5 = i8 + 6 | 0;
 i4 = i1 >>> 24;
 i3 = i4 & 255;
 HEAP8[i5 >> 0] = i3;
 HEAP8[i8 + 7 >> 0] = i1 >>> 16;
 HEAP8[i8 + 8 >> 0] = i1 >>> 8;
 HEAP8[i8 + 9 >> 0] = i1;
 i6 = i8 + 10 | 0;
 i7 = (HEAPU8[i8 + 2 >> 0] | 0) << 8 | (HEAPU8[i8 + 3 >> 0] | 0);
 i1 = (i4 << 24 | i1 & 255 | i1 & 16711680 | i1 & 65280) - i7 | 0;
 if (!i1) i1 = 0; else {
  i2 = 65535;
  i4 = i8 + i7 | 0;
  while (1) {
   i10 = i2 & 65535;
   i9 = (HEAPU8[i4 >> 0] | 0) ^ i10 >>> 8;
   i9 = i9 >>> 4 ^ i9;
   i2 = (i9 | i10 << 8 & 65280) ^ i9 << 5 ^ i9 << 12 & 61440;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i4 = i4 + 1 | 0;
  }
  i1 = i2 & 65535 ^ 65535;
 }
 HEAP8[i6 >> 0] = i1 >>> 8;
 HEAP8[i8 + 11 >> 0] = i1;
 i6 = i8 + 4 | 0;
 i2 = i7 + -6 | 0;
 if (!i2) i1 = 0; else {
  i1 = 65535;
  while (1) {
   i4 = i5 + 1 | 0;
   i10 = i1 & 65535;
   i1 = i3 & 255 ^ i10 >>> 8;
   i1 = i1 >>> 4 ^ i1;
   i1 = (i1 | i10 << 8 & 65280) ^ i1 << 5 ^ i1 << 12 & 61440;
   i2 = i2 + -1 | 0;
   if (!i2) break;
   i5 = i4;
   i3 = HEAP8[i4 >> 0] | 0;
  }
  i1 = i1 & 65535 ^ 65535;
 }
 HEAP8[i6 >> 0] = i1 >>> 8;
 HEAP8[i8 + 5 >> 0] = i1;
 i10 = 1;
 return i10 | 0;
}

function __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i1 = i9;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
 i5 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i7, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i8 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i7 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 8 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i6 + 8 | 0;
 i4 = i5 + 8 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i5 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < 4) i7 = 4; else {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i5 >> 2] >> 0] | 0;
   i11 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i9 = i1 + 1 | 0;
   HEAP8[i9 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i8 = i1 + 2 | 0;
   HEAP8[i8 >> 0] = HEAP8[i11 >> 0] | 0;
   i11 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i11;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i10 = i1 + 3 | 0;
   HEAP8[i10 >> 0] = HEAP8[i11 >> 0] | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i2 = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
   HEAP8[i10 >> 0] = i2;
   i2 = HEAP8[i9 >> 0] | 0;
   HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
   HEAP8[i8 >> 0] = i2;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) HEAP8[i4 >> 0] = 1;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i5, gb + 660697 | 0, i6, i3);
 i1 = i6 + 12 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i5 + 4 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) i7 = 7; else {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i5 >> 2] >> 0] | 0;
   i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i1;
   i11 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i2 >> 2] = i11;
   if (!((HEAP8[i4 >> 0] | 0) != 0 | (i11 | 0) == 0)) {
    HEAP8[i6 + 13 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
    return;
   }
  }
 } else i7 = 7;
 if ((i7 | 0) == 7) HEAP8[i4 >> 0] = 1;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN20BufferedSocketStreamC2Eijj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN12SocketStreamC2Eib(i1, i2, 0);
 HEAP32[i1 >> 2] = gb + 73616 + 8;
 HEAP8[i1 + 19 >> 0] = 0;
 i7 = gb + 63560 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i1 + 20 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = 1024;
 i8 = i1 + 28 | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = __Znwj(32) | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i9;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 1024;
 HEAP32[i8 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 16, i6, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i8 + 4 >> 0] = 1;
 i2 = i6;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i8 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i8 + 28 >> 2] = 0;
 i7 = i1 + 44 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i1 + 48 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 40 >> 2] = 0;
 i7 = gb + 63560 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 1024;
 i3 = i1 + 60 | 0;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i3 + 4 >> 2] = i7;
 i3 = __Znwj(32) | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 1024;
 HEAP32[i3 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 16, i6, 0, gb + 584872 | 0, 112) | 0;
 HEAP8[i3 + 4 >> 0] = 1;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i3 + 28 >> 2] = 0;
 i4 = i1 + 76 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i1 + 80 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2];
 HEAP32[i1 + 72 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN13ComputeShader14SetBufferParamEjRKN9ShaderLab16FastPropertyNameE15ComputeBufferID(i7, i8, i6, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 i1 = i11 + 4 | 0;
 i2 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i7, 22, 0) | 0;
 if ((HEAP32[i7 + 48 >> 2] | 0) >>> 0 <= i8 >>> 0) {
  HEAP32[i3 >> 2] = i8;
  __Z6FormatPKcz(i1, gb + 476912 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 476838 | 0, 398, 1, HEAP32[i7 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 i4 = HEAP32[i2 + (i8 * 96 | 0) + 40 >> 2] | 0;
 i5 = (HEAP32[i2 + (i8 * 96 | 0) + 44 >> 2] | 0) - i4 | 0;
 i3 = (i5 | 0) / 20 | 0;
 L5 : do if (i5 | 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 * 20 | 0) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L5;
  }
  HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + (i8 * 976 | 0) + 516 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
 } while (0);
 i4 = HEAP32[i2 + (i8 * 96 | 0) + 52 >> 2] | 0;
 i5 = (HEAP32[i2 + (i8 * 96 | 0) + 56 >> 2] | 0) - i4 | 0;
 i3 = (i5 | 0) / 20 | 0;
 if (!i5) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 * 20 | 0) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 1;
   i10 = 13;
   break;
  }
 }
 if ((i10 | 0) == 13) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i10 = HEAP32[i7 + 44 >> 2] | 0;
 HEAP32[i10 + (i8 * 976 | 0) + 772 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
 i10 = i10 + (i8 * 976 | 0) + 580 + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & 2147483647;
 i10 = 1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN12ImageFilters7PrepareEbbi(i7, i1, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i7 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if (!((HEAP32[i7 + 12 >> 2] | 0) != (HEAP32[i7 + 16 >> 2] | 0) | i1)) return;
 if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 488 >> 2] | 0)) {
  if (HEAP8[gb + 1544217 >> 0] | 0) return;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 375721 | 0, 0, gb + 375577 | 0, 328, 1, 0, 0, 0);
  HEAP8[gb + 1544217 >> 0] = 1;
  return;
 }
 i3 = __Z22GetRenderBufferManagerv() | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i5) i1 = mftCall_ii(HEAP32[i2 + 708 >> 2] | 0, i1 | 0) | 0; else i1 = mftCall_ii(HEAP32[i2 + 704 >> 2] | 0, i1 | 0) | 0;
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i3, -1, -1, 2, i1, 0, 0, HEAP32[i3 + 24 >> 2] | 0, i6) | 0;
 if (i1 | 0) {
  __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, 1);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 375803 | 0);
 }
 HEAP32[i7 + 24 >> 2] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i4 >> 2] | 0) - i1 | 0;
 i3 = (i2 | 0) / 12 | 0;
 i4 = i1;
 if (!i2) i1 = i5; else {
  i1 = i5;
  i2 = 0;
  do {
   i1 = i1 & (HEAP8[i4 + (i2 * 12 | 0) + 8 >> 0] | 0) == 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 i4 = __Z22GetRenderBufferManagerv() | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i1) i1 = mftCall_ii(HEAP32[i3 + 708 >> 2] | 0, i2 | 0) | 0; else i1 = mftCall_ii(HEAP32[i3 + 704 >> 2] | 0, i2 | 0) | 0;
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i4, -1, -1, 0, i1, 0, 0, HEAP32[i4 + 24 >> 2] | 0, i6) | 0;
 if (i1 | 0) {
  __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, 1);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 375803 | 0);
 }
 HEAP32[i7 + 28 >> 2] = i1;
 return;
}

function __ZN10GameObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 5);
 __ZN10GameObject18TransferComponentsI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 368700 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 48 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 64 | 0, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 368708 | 0, HEAP32[gb + 37288 >> 2] | 0, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896826 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 54 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i9, i10, i7) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 i2 = _strlen(i7) | 0;
 i1 = i6 + i4 | 0;
 L1 : do if (!i2) {
  if (i4 | 0) {
   i1 = i1 + -1 | 0;
   i8 = 6;
  }
 } else while (1) {
  if ((i1 | 0) == (i6 | 0)) break L1;
  i1 = i1 + -1 | 0;
  if (!(_memchr(i7, HEAPU8[i1 >> 0] | 0, i2) | 0)) {
   i8 = 6;
   break;
  }
 } while (0);
 if ((i8 | 0) == 6) {
  i5 = i6;
  i1 = i1 - i5 | 0;
  if ((i1 | 0) != -1) {
   i2 = _strlen(i7) | 0;
   L10 : do if (i2 | 0) {
    i1 = i6 + (i4 >>> 0 > i1 >>> 0 ? i1 + 1 | 0 : i4) | 0;
    do {
     if ((i1 | 0) == (i6 | 0)) break L10;
     i1 = i1 + -1 | 0;
    } while (!(_memchr(i7, HEAPU8[i1 >> 0] | 0, i2) | 0));
    i1 = i1 - i5 | 0;
    if ((i1 | 0) != -1) {
     i3 = _strlen(i7) | 0;
     i2 = i4 >>> 0 > i1 >>> 0 ? i1 + 1 | 0 : i4;
     i1 = i6 + i2 | 0;
     L17 : do if (!i3) {
      if (i2 | 0) {
       i1 = i1 + -1 | 0;
       i8 = 19;
      }
     } else while (1) {
      if ((i1 | 0) == (i6 | 0)) break L17;
      i1 = i1 + -1 | 0;
      if (!(_memchr(i7, HEAPU8[i1 >> 0] | 0, i3) | 0)) {
       i8 = 19;
       break;
      }
     } while (0);
     if ((i8 | 0) == 19) {
      i1 = i1 - i5 | 0;
      if ((i1 | 0) != -1) {
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i10, 0, i1 + 1 | 0, i10);
       return;
      }
     };
     HEAP32[i9 >> 2] = 0;
     HEAP32[i9 + 4 >> 2] = 0;
     HEAP32[i9 + 8 >> 2] = 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, gb + 1087627 | 0, 1);
     return;
    }
   } while (0);
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   return;
  }
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 return;
}

function __ZN8Material10ComputeCRCEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = __Z8CRCBeginv() | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 + 32 >> 2];
 i1 = __Z7CRCFeedjPKhj(i1, i4, 4) | 0;
 i1 = __Z7CRCFeedjPKhj(i1, (HEAP32[i6 + 100 >> 2] | 0) + 124 | 0, 32) | 0;
 i3 = HEAP32[i6 + 44 >> 2] | 0;
 i5 = i6 + 48 | 0;
 i2 = i3;
 if ((i2 | 0) != (i5 | 0)) while (1) {
  i1 = __Z7CRCFeedjPKhj(__Z7CRCFeedjPKhj(__Z7CRCFeedjPKhj(i1, i2 + 16 | 0, 4) | 0, i2 + 20 | 0, 8) | 0, i2 + 28 | 0, 8) | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 + 36 >> 2];
  i1 = __Z7CRCFeedjPKhj(i1, i4, 4) | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
 }
 i3 = HEAP32[i6 + 56 >> 2] | 0;
 i4 = i6 + 60 | 0;
 i2 = i3;
 if ((i2 | 0) != (i4 | 0)) while (1) {
  i1 = __Z7CRCFeedjPKhj(i1, i2 + 16 | 0, 8) | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
 }
 i2 = HEAP32[i6 + 68 >> 2] | 0;
 i4 = i6 + 72 | 0;
 i3 = i2;
 if ((i3 | 0) == (i4 | 0)) {
  i6 = i1;
  i6 = __Z7CRCDonej(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 while (1) {
  i1 = __Z7CRCFeedjPKhj(i1, i3 + 16 | 0, 20) | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) break; else i2 = i3;
  } else {
   i2 = i3;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = i2;
     break;
    } else i2 = i3;
   }
  }
  if ((i3 | 0) == (i4 | 0)) break; else i2 = i3;
 }
 i6 = __Z7CRCDonej(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i18 = i19 + 256 | 0;
 i14 = i19 + 248 | 0;
 i15 = i19;
 i16 = i19 + 240 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i17 = (HEAP32[i10 + 4 >> 2] | 0) - i2 >> 2;
 if (!i17) {
  STACKTOP = i19;
  return;
 }
 i11 = i1 + 76 | 0;
 i12 = i1 + 60 | 0;
 i13 = i1 + 28 | 0;
 i9 = i1 + 44 | 0;
 i1 = 0;
 while (1) {
  i7 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  i8 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i8 + (i7 * 24 | 0) >> 2] | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i2 = (HEAP32[i13 >> 2] | 0) + (HEAP32[i5 + (i4 * 36 | 0) >> 2] << 4) | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  i3 = (HEAP32[i9 >> 2] | 0) + (HEAP32[i5 + (i4 * 36 | 0) + 4 >> 2] << 4) | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i6 = HEAP32[i3 >> 2] | 0; else i6 = i3;
  i3 = i5 + (i4 * 36 | 0) + 8 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) i3 = HEAP32[i3 >> 2] | 0;
  i3 = __Z29scripting_class_from_fullnamePKcS0_S0_(i2, i6, i3) | 0;
  if (i3 | 0) {
   i2 = i8 + (i7 * 24 | 0) + 4 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i14, i3, i2, -1);
   if (HEAP32[i14 >> 2] | 0) {
    i6 = i14;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i8 = i16;
    HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i8 + 4 >> 2] = i7;
    HEAP32[i18 >> 2] = HEAP32[i16 >> 2];
    HEAP32[i18 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
    __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i15, i18);
    HEAP32[i18 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i15, i18, 0) | 0;
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i17 | 0)) break;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 STACKTOP = i19;
 return;
}

function __ZN14TerrainManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP32[i8 >> 2] = gb + 184476 + 8;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 27788 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 27020 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 4155 | 0)) {
    i4 = i6 + 27020 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 27020 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 27020 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 27020 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 27020 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 27020 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 27020 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 27020 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if ((HEAP32[i8 + 36 >> 2] | 0) > -1) {
  i7 = i8 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 24 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 i4 = i8 + 4 | 0;
 i2 = i8 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i7 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[HEAP32[i7 >> 2] >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = i8 + 16 | 0;
 i3 = i9 + 4 | 0;
 do {
  i8 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = 52;
  HEAP32[i3 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i9);
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __Z28WWW_CUSTOM_INTERNAL_CALL_WWWP12Il2CppObjectP12Il2CppStringRK7Hash128j(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 16 | 0;
 i10 = i9 + 56 | 0;
 i6 = i9 + 44 | 0;
 i7 = i9 + 32 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i10, i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i10);
 if (_JS_FileSystem_HasIndexedDB() | 0) {
  i8 = __Znwj(104) | 0;
  i10 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  __ZN9WWWCachedC2EPKc7Hash128j(i8, i10, i1, i5);
  i10 = i2 + 8 | 0;
  HEAP32[i10 >> 2] = i8;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i9;
  return;
 } else {
  i4 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  i10 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i8 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i4, 0, 0, i7, 0, i1, i5) | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, HEAP32[i10 >> 2] | 0);
  i10 = i2 + 8 | 0;
  HEAP32[i10 >> 2] = i8;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i11, i8, i4, i3, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = i11 + 8 | 0;
 i12 = i5 + 3 | 0;
 i2 = HEAP8[i12 >> 0] | 0;
 i7 = i2 << 24 >> 24 < 0;
 if (i7) i10 = HEAP32[i11 + 4 >> 2] | 0; else i10 = i2 & 255;
 if (i10 >>> 0 < i8 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i11);
 i6 = i10 - i8 | 0;
 i2 = i6 >>> 0 < i4 >>> 0 ? i6 : i4;
 if (i7) i4 = (HEAP32[i5 >> 2] & 2147483647) + -1 | 0; else i4 = 1;
 if ((i2 - i10 + i4 | 0) >>> 0 < i1 >>> 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i11, i4, i10 + i1 - i2 - i4 | 0, i10, i8, i2, i1, i3); else {
  if (i7) i7 = HEAP32[i11 >> 2] | 0; else i7 = i11;
  do if ((i2 | 0) == (i1 | 0)) {
   i2 = i1;
   i4 = i8;
   i9 = 21;
  } else {
   i5 = i6 - i2 | 0;
   if (!i5) {
    i4 = i8;
    i9 = 21;
   } else {
    i4 = i7 + (i8 << 2) | 0;
    if (i2 >>> 0 > i1 >>> 0) {
     __ZNSt3__211char_traitsIwE4moveEPwPKwj(i4, i3, i1) | 0;
     __ZNSt3__211char_traitsIwE4moveEPwPKwj(i4 + (i1 << 2) | 0, i4 + (i2 << 2) | 0, i5) | 0;
     break;
    }
    do if (i4 >>> 0 < i3 >>> 0 & (i7 + (i10 << 2) | 0) >>> 0 > i3 >>> 0) if ((i4 + (i2 << 2) | 0) >>> 0 > i3 >>> 0) {
     __ZNSt3__211char_traitsIwE4moveEPwPKwj(i4, i3, i2) | 0;
     i4 = i2 + i8 | 0;
     i3 = i3 + (i1 << 2) | 0;
     i1 = i1 - i2 | 0;
     i2 = 0;
     break;
    } else {
     i4 = i8;
     i3 = i3 + (i1 - i2 << 2) | 0;
     break;
    } else i4 = i8; while (0);
    i9 = i7 + (i4 << 2) | 0;
    __ZNSt3__211char_traitsIwE4moveEPwPKwj(i9 + (i1 << 2) | 0, i9 + (i2 << 2) | 0, i5) | 0;
    i9 = 21;
   }
  } while (0);
  if ((i9 | 0) == 21) __ZNSt3__211char_traitsIwE4moveEPwPKwj(i7 + (i4 << 2) | 0, i3, i1) | 0;
  i1 = i1 - i2 + i10 | 0;
  if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i12 >> 0] = i1;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
 }
 return i11 | 0;
}

function __ZN9ShaderLab19SerializedSubShader8TransferI14SafeBinaryReadEEvRT_(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470701 | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i3 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470710 | 0, gb + 470717 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i3 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 470734 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 18; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim9animation19EvaluateClipAtIndexEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEj(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  f9 = Math_fround(HEAPF32[i5 >> 2]);
  __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf(i4, i1, f9);
  i6 = HEAP32[i1 >> 2] | 0;
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i6 + (i2 * 20 | 0) >> 2]));
  f8 = Math_fround(f9 * Math_fround(HEAPF32[i6 + (i2 * 20 | 0) + 4 >> 2]));
  f8 = Math_fround(f9 * Math_fround(f8 + Math_fround(HEAPF32[i6 + (i2 * 20 | 0) + 8 >> 2])));
  f8 = Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i6 + (i2 * 20 | 0) + 12 >> 2]) + f8));
  f8 = Math_fround(Math_fround(HEAPF32[i6 + (i2 * 20 | 0) + 16 >> 2]) + f8);
  STACKTOP = i7;
  return Math_fround(f8);
 }
 i1 = i2 - i3 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  f8 = Math_fround(HEAPF32[i5 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i4 + 24 >> 2]));
  f8 = Math_fround(_modff(Math_fround(f8 * Math_fround(HEAPF32[i4 + 20 >> 2])), i6));
  i5 = ~~Math_fround(HEAPF32[i6 >> 2]);
  i10 = i5 + 1 | 0;
  i5 = (i5 | 0) > 0 ? i5 : 0;
  i3 = (HEAP32[i4 + 12 >> 2] | 0) + -1 | 0;
  i10 = (i10 | 0) > 0 ? i10 : 0;
  i4 = i4 + 32 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i5 = Math_imul((i5 | 0) < (i3 | 0) ? i5 : i3, i6) | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i6 = i4 + ((Math_imul((i10 | 0) < (i3 | 0) ? i10 : i3, i6) | 0) << 2) | 0;
  f9 = Math_fround(HEAPF32[i4 + (i5 << 2) + (i1 << 2) >> 2]);
  f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]) - f9)));
  STACKTOP = i7;
  return Math_fround(f9);
 } else {
  i10 = i4 + 40 | 0;
  f9 = Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + i10 + (i1 - i3 << 2) >> 2]);
  STACKTOP = i7;
  return Math_fround(f9);
 }
 return f0;
}

function __ZN7dtCrowd19completeOffMeshLinkEib(i7, i8, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = HEAP32[i7 + 16 >> 2] | 0;
 i13 = HEAP32[i7 + 20 >> 2] | 0;
 i14 = i13 + (i8 * 56 | 0) + 40 | 0;
 i5 = i14;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i4 | 0) == 0 & (i5 | 0) == 0) return;
 i9 = i7 + 380 | 0;
 i6 = i7 + 384 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 if (i10 | 0) {
  i3 = i6;
  i2 = i10;
  L5 : while (1) {
   i1 = i2;
   while (1) {
    i2 = i1 + 16 | 0;
    i15 = HEAP32[i2 + 4 >> 2] | 0;
    if (!(i15 >>> 0 < i5 >>> 0 | ((i15 | 0) == (i5 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < i4 >>> 0 : 0))) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L5;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i6 | 0)) {
   i15 = i3 + 16 | 0;
   i6 = HEAP32[i15 + 4 >> 2] | 0;
   if (!(i5 >>> 0 < i6 >>> 0 | ((i5 | 0) == (i6 | 0) ? i4 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0 : 0))) {
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i1) {
     i2 = i3;
     while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
     }
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) HEAP32[i9 >> 2] = i1;
    i15 = i7 + 388 | 0;
    HEAP32[i15 >> 2] = (HEAP32[i15 >> 2] | 0) + -1;
    __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i10, i3);
    __ZdlPv(i3);
   }
  }
 }
 i15 = i14;
 HEAP32[i15 >> 2] = 0;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP8[i12 + (i8 * 608 | 0) + 601 >> 0] = 1;
 HEAPF32[i12 + (i8 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
 if (!i11) return;
 HEAP32[i12 + (i8 * 608 | 0) + 480 >> 2] = HEAP32[i13 + (i8 * 56 | 0) + 24 >> 2];
 HEAP32[i12 + (i8 * 608 | 0) + 484 >> 2] = HEAP32[i13 + (i8 * 56 | 0) + 28 >> 2];
 HEAP32[i12 + (i8 * 608 | 0) + 488 >> 2] = HEAP32[i13 + (i8 * 56 | 0) + 32 >> 2];
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 24 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4 + ~(i4 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 8 >> 2] | 0;
   i3 = i11 + 12 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 20 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 36 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 8 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function _jpeg_finish_compress(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 switch (i1 | 0) {
 case 102:
 case 101:
  {
   if ((HEAP32[i8 + 208 >> 2] | 0) >>> 0 < (HEAP32[i8 + 32 >> 2] | 0) >>> 0) {
    i7 = HEAP32[i8 >> 2] | 0;
    HEAP32[i7 + 20 >> 2] = 67;
    mftCall_vi(HEAP32[i7 >> 2] | 0, i8 | 0);
   }
   mftCall_vi(HEAP32[(HEAP32[i8 + 316 >> 2] | 0) + 8 >> 2] | 0, i8 | 0);
   break;
  }
 case 103:
  break;
 default:
  {
   i7 = HEAP32[i8 >> 2] | 0;
   HEAP32[i7 + 20 >> 2] = 20;
   HEAP32[i7 + 24 >> 2] = i1;
   mftCall_vi(HEAP32[i7 >> 2] | 0, i8 | 0);
  }
 }
 i4 = i8 + 316 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (HEAP8[i1 + 13 >> 0] | 0) {
  i7 = i8;
  i6 = i8 + 332 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = i6 + 12 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(i6 | 0, i8 | 0);
  i6 = i8 + 24 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = i6 + 16 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(i6 | 0, i8 | 0);
  _jpeg_abort(i7);
  return;
 }
 i5 = i8 + 224 | 0;
 i6 = i8 + 8 | 0;
 i7 = i8 + 328 | 0;
 do {
  mftCall_vi(HEAP32[i1 >> 2] | 0, i8 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i3 = 0;
   do {
    i2 = HEAP32[i6 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i2 + 4 >> 2] = i3;
     HEAP32[i2 + 8 >> 2] = i1;
     mftCall_vi(HEAP32[i2 >> 2] | 0, i8 | 0);
    }
    if (!((mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, 0) | 0) << 24 >> 24)) {
     i2 = HEAP32[i8 >> 2] | 0;
     HEAP32[i2 + 20 >> 2] = 24;
     mftCall_vi(HEAP32[i2 >> 2] | 0, i8 | 0);
    }
    i3 = i3 + 1 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i8 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 } while (!(HEAP8[i1 + 13 >> 0] | 0));
 i1 = i8;
 i7 = i8 + 332 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i7 = i7 + 12 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_vi(i7 | 0, i8 | 0);
 i7 = i8 + 24 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i7 = i7 + 16 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_vi(i7 | 0, i8 | 0);
 _jpeg_abort(i1);
 return;
}

function __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i6 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 4;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 12;
 HEAP32[i4 + 4 >> 2] = i3 + 8;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i8 = i1;
  i2 = i2 | 0 ? i2 - i8 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i8;
 }
 i8 = i2 + i1 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 4;
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i2 = i1;
  i3 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i8 = i4;
  i5 = i1 | 0 ? i1 - i8 | 0 : 0;
  HEAP32[i4 >> 2] = i5;
  i8 = i5 + i8 | 0;
  __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
  STACKTOP = i7;
  return;
 } else {
  i8 = i4;
  i5 = i1;
  i8 = i5 + i8 | 0;
  __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i6 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 4;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 12;
 HEAP32[i4 + 4 >> 2] = i3 + 8;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i8 = i1;
  i2 = i2 | 0 ? i2 - i8 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i8;
 }
 i8 = i2 + i1 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 + 4;
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i2 = i1;
  i3 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  i8 = i4;
  i5 = i1 | 0 ? i1 - i8 | 0 : 0;
  HEAP32[i4 >> 2] = i5;
  i8 = i5 + i8 | 0;
  __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  STACKTOP = i7;
  return;
 } else {
  i8 = i4;
  i5 = i1;
  i8 = i5 + i8 | 0;
  __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN23ForwardShaderRenderLoop21CleanupAfterRenderingEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (__ZNK6Camera16GetStereoEnabledEv(HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 8 >> 2] | 0) | 0) {
  i1 = i5 + 236 | 0;
  if (HEAP32[i1 >> 2] | 0) if (HEAP8[i5 + 336 >> 0] | 0) {
   i4 = __Z22GetRenderBufferManagerv() | 0;
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i4, HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i3 = HEAP32[i5 + 352 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i4 = i5 + 340 | 0;
   i2 = 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do {
    if (HEAP32[i1 + (i2 * 152 | 0) + 48 >> 2] | 0) if (HEAP8[i1 + (i2 * 152 | 0) + 148 >> 0] | 0) {
     i1 = __Z22GetRenderBufferManagerv() | 0;
     __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 152 | 0) + 48 >> 2] | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i2 * 152 | 0) + 48 >> 2] = 0;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i1 = HEAP32[i5 + 332 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
  }
 }
 i2 = HEAP32[i5 + 352 >> 2] | 0;
 if (!i2) {
  i4 = __Z12GetGfxDevicev() | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i3 = i3 + 296 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(i3 | 0, i4 | 0, i5 | 0);
  return;
 }
 i3 = i5 + 340 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 152 | 0) + 144 >> 2] | 0;
  if (i4 | 0) {
   i6 = i4 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   if (!(HEAP32[i6 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = __Z12GetGfxDevicev() | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i4 = i4 + 296 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(i4 | 0, i6 | 0, i5 | 0);
 return;
}

function __ZN19RuntimeSceneManager26IsLevelManagerOwnedBySceneEP11GameManager(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i11 = i14;
 i12 = i1 + 16 | 0;
 if (!(HEAP32[i12 >> 2] | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i8 = i1 + 4 | 0;
 i5 = 0;
 L4 : while (1) {
  i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i6 = 0;
  do {
   i4 = i7 + 84 + (i6 << 2) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else {
    HEAP32[i11 >> 2] = i1;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i13 = 11; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i2 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i2 + (i3 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i10, i1, i11);
      i2 = HEAP32[i10 >> 2] | 0;
      i15 = HEAP32[i1 + 28 >> 2] | 0;
      i3 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i2 | 0) == -1 ? i15 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i15 + (i2 << 3) | 0;
      i2 = HEAP32[i3 + 28 >> 2] | 0;
      i3 = HEAP32[i3 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i13 = 11; else {
      i1 = HEAP32[i1 + 4 >> 2] | 0;
      if (!i1) i13 = 13;
     }
    }
    if ((i13 | 0) == 11) i13 = 13;
    if ((i13 | 0) == 13) {
     i13 = 0;
     i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    }
   }
   i6 = i6 + 1 | 0;
   if ((i1 | 0) == (i9 | 0)) {
    i1 = 1;
    i13 = 17;
    break L4;
   }
  } while (i6 >>> 0 < 4);
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) {
   i1 = 0;
   i13 = 17;
   break;
  }
 }
 if ((i13 | 0) == 17) {
  STACKTOP = i14;
  return i1 | 0;
 }
 return 0;
}

function __ZN15ComputeShaderCB8TransferI14SafeBinaryReadEEvRT_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1037646 | 0, gb + 469407 | 0, i7, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i6, i8); else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i4 = i6 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469424 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i1 = i8 + 16 | 0;
   i3 = HEAP32[i8 + 20 >> 2] | 0;
   i2 = i3 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
    i3 = i2 + 4 | 0;
    if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
     HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
     HEAP32[i1 >> 2] = i3;
    }
   }
   if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i6 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 469433 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI18ComputeShaderParamNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i8, i2, 0); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN14AssetReferenceaSERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i4 = i10;
 if ((i9 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return i8 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return i8 | 0;
 }
 if (i2) {
  i6 = HEAP32[gb + 1162408 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  i5 = i6 + 4 | 0;
  if ((HEAP32[i6 + 36 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
   i2 = HEAP32[i6 + 28 >> 2] | 0;
   i3 = HEAP32[i6 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i3, i6, i4);
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i6 + 28 >> 2] | 0;
   i3 = HEAP32[i6 + 32 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
  }
  i11 = i1 + 4 | 0;
  i4 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
  HEAP32[i11 >> 2] = i4;
  do if (!i4) if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   if (!(HEAP8[i6 + 8 >> 0] | 0)) i7 = 11; else if (!(HEAP32[i5 >> 2] | 0)) i7 = 11; else {
    i11 = (HEAP32[i6 + 12 >> 2] | 0) == (HEAP32[i1 >> 2] | 0);
    i2 = i6 + 12 | 0;
    i3 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = i1;
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i4 + 4 >> 2] = i3;
    if (i11) break;
   }
   if ((i7 | 0) == 11) {
    i4 = i6 + 12 | 0;
    i7 = HEAP32[i4 + 4 >> 2] | 0;
    i11 = i1;
    HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i11 + 4 >> 2] = i7;
   }
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP8[i6 + 48 >> 0] = 1;
  } while (0);
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i10;
  return i8 | 0;
 }
 __ZN21AssetReferenceStorage12AddReferenceEi(HEAP32[gb + 1162408 >> 2] | 0, i1);
 STACKTOP = i10;
 return i8 | 0;
}

function __Z37CustomEventData_CUSTOM_InternalCreateP12Il2CppObjectP12Il2CppString(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 40 | 0;
 i4 = i11 + 32 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i5 = __ZnwjRK10MemLabelIdiPKci(88, gb + 63160 | 0, 16, gb + 1037990 | 0, 36) | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i4);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  i1 = i8 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i8; else {
   i2 = i8;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i12 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i1 = i8 + 11 | 0;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr(i5, i8);
 HEAP32[i6 + 8 >> 2] = i5;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i12, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i8 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i12 >> 2] | 0) - i3 | 0) / 48 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i1 = i2;
  i7 = i3;
 } else {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = 18;
  HEAP32[i11 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 48 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i5 + (((i2 - i3 | 0) / 48 | 0) * 48 | 0) | 0;
 i6 = i3;
 i4 = i5 + (i4 * 48 | 0) | 0;
 if ((i1 | 0) == (i7 | 0)) i2 = i6; else {
  i2 = i6;
  do {
   i14 = i1;
   i1 = i1 + -48 | 0;
   HEAP32[i3 + -48 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + -44 >> 2] = HEAP32[i14 + -44 >> 2];
   HEAP32[i3 + -40 >> 2] = HEAP32[i14 + -40 >> 2];
   HEAP32[i3 + -36 >> 2] = HEAP32[i14 + -36 >> 2];
   HEAP32[i3 + -32 >> 2] = HEAP32[i14 + -32 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i14 + -28 >> 2];
   i5 = i3 + -24 | 0;
   i14 = i14 + -24 | 0;
   HEAP32[i5 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i14 + 16 >> 2];
   HEAP32[i5 + 20 >> 2] = HEAP32[i14 + 20 >> 2];
   i3 = i2 + -48 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i12 >> 2] = i4;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i14 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = 18;
 HEAP32[i11 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE16__construct_nodeERKNS_4pairIKS8_SB_EE(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i5 >> 2] = 54;
 HEAP32[i5 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((HEAP8[i11 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i11 >> 2] | 0;
  i6 = HEAP32[i11 + 4 >> 2] | 0;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i12 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i7 + 27 >> 0] = i6;
   if (i6) i12 = 8;
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i3 = i6 + 16 & -16;
   HEAP32[i5 >> 2] = 54;
   HEAP32[i5 + 4 >> 2] = i2;
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
   HEAP32[i7 + 20 >> 2] = i6;
   i1 = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 }
 HEAP32[i7 + 32 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i12 = i10 + 9 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_(i9, i11, i8, i10, i6, i12, i13, i1, i4, i5, i7) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, f14 = f0, f15 = f0, f16 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = f3 <= Math_fround(0.0);
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 if (i1 | f2 == Math_fround(0.0)) {
  __ZN5physx31collideWithCapsuleNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_S6_(i9, i8, i6, i12, i7);
  return;
 }
 f2 = Math_fround(Math_fround(-Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(Math_sqrt(Math_fround(f3))))) / f2);
 if (f2 < Math_fround(0.0) | f2 > Math_fround(1.0)) {
  __ZN5physx31collideWithCapsuleNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_S6_(i9, i8, i6, i12, i7);
  return;
 }
 i1 = i9 + 44 | 0;
 if (!(f2 < Math_fround(HEAPF32[i1 >> 2]))) return;
 f16 = Math_fround(f2 * Math_fround(HEAPF32[i10 >> 2]));
 f15 = Math_fround(f2 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 f3 = Math_fround(f2 * Math_fround(HEAPF32[i10 + 8 >> 2]));
 f16 = Math_fround(f16 + Math_fround(HEAPF32[i11 >> 2]));
 i8 = i11 + 4 | 0;
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i8 >> 2]));
 i10 = i11 + 8 | 0;
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i10 >> 2]));
 i5 = i9 + 144 | 0;
 HEAPF32[i5 >> 2] = f16;
 i6 = i9 + 148 | 0;
 HEAPF32[i6 >> 2] = f15;
 i7 = i9 + 152 | 0;
 HEAPF32[i7 >> 2] = f3;
 f16 = Math_fround(f16 - Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i5 >> 2] = f16;
 f14 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i5 >> 2] = Math_fround(f16 * f14);
 HEAPF32[i6 >> 2] = Math_fround(f14 * f15);
 HEAPF32[i7 >> 2] = Math_fround(f14 * f3);
 HEAP32[i9 + 160 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 164 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 168 >> 2] = HEAP32[i10 >> 2];
 HEAPF32[i1 >> 2] = f2;
 i13 = i9 + 124 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 8;
 return;
}

function __ZN17AudioChorusFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_(i1, i11, i8) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 60 | 0;
 i12 = i15 + 56 | 0;
 i13 = i15 + 16 | 0;
 i9 = i15;
 i14 = i1 + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i7 - i3 | 0;
 if (!i1) i2 = i3; else {
  i6 = HEAP32[i8 >> 2] | 0;
  i5 = (i1 | 0) / 40 | 0;
  i2 = i3;
  i1 = i3;
  while (1) {
   i16 = (i5 | 0) / 2 | 0;
   i4 = i1 + (i16 * 40 | 0) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 40 | 0;
   i2 = i3 ? i4 : i2;
   i5 = i3 ? i5 + -1 - i16 | 0 : i16;
   if (!i5) break; else i1 = i3 ? i4 : i1;
  }
 }
 i3 = i2;
 if ((i2 | 0) == (i7 | 0)) i1 = HEAP32[i8 >> 2] | 0; else {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) >= (HEAP32[i2 >> 2] | 0)) {
   HEAP32[i11 >> 2] = i2 + 8;
   STACKTOP = i15;
   return;
  }
 }
 HEAP32[i12 >> 2] = i3;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i13 >> 2] = i1;
 i1 = i13 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i1 = i13 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i13 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i13 + 32 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 >> 2] = (__ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_(i14, i10, i13) | 0) + 8;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 STACKTOP = i15;
 return;
}

function __Z28Texture3D_CUSTOM_GetPixels32P12Il2CppObjecti(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i7 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i7 = __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i3 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i5;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) >> i5;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0) | 0) >> i5;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0, 4, Math_imul(Math_imul((i1 | 0) < 1 ? 1 : i1, (i3 | 0) < 1 ? 1 : i3) | 0, (i2 | 0) < 1 ? 1 : i2) | 0) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture3D11GetPixels32EP11ColorRGBA32i(i3, i2, i5);
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN9ShaderLab11ShaderStateD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 700 | 0;
 if ((HEAP32[i3 + 716 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 704 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 56 | 0;
 if ((HEAP32[i3 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN5physx5cloth8SwSolver11removeClothEPNS0_5ClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i7 = i9;
 i3 = i1 + 12 | 0;
 i5 = i2 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i2 + 36 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i10 * 40 | 0) | 0;
 if (!i10) {
  STACKTOP = i9;
  return;
 }
 while (1) {
  if ((HEAP32[i1 + 20 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i8 = 5;
   break;
  }
 }
 if ((i8 | 0) == 5) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx5cloth10deallocateEPv(HEAP32[i1 + 32 >> 2] | 0);
 i3 = HEAP32[i5 >> 2] | 0;
 i8 = (i1 - i3 | 0) / 40 | 0;
 i10 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i10;
 i1 = i3 + (i10 * 40 | 0) + 4 | 0;
 i12 = i1;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i1 = i1 + 4 | 0;
 i1 = HEAPU16[i1 >> 1] | HEAPU16[i1 + 2 >> 1] << 16;
 i2 = i3 + (i8 * 40 | 0) + 4 | 0;
 i11 = i2;
 HEAP16[i11 >> 1] = i12;
 HEAP16[i11 + 2 >> 1] = i12 >>> 16;
 i2 = i2 + 4 | 0;
 HEAP16[i2 >> 1] = i1;
 HEAP16[i2 + 2 >> 1] = i1 >>> 16;
 HEAP32[i3 + (i8 * 40 | 0) + 12 >> 2] = HEAP32[i3 + (i10 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + (i8 * 40 | 0) + 16 >> 2] = HEAP32[i3 + (i10 * 40 | 0) + 16 >> 2];
 i8 = i3 + (i8 * 40 | 0) + 20 | 0;
 i10 = i3 + (i10 * 40 | 0) + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
 i8 = (HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 40 | 0) | 0;
 mftCall_vi(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0);
 i8 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = fb + 903;
 __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j(i8, i10, i7, i6, 32);
 STACKTOP = i9;
 return;
}

function __Z30TransferField_LinearCollectionI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 40 | 0;
 i6 = i10;
 i7 = i10 + 8 | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i8, i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i9 = i6 + 4 | 0;
 HEAP32[i9 >> 2] = -1;
 if (HEAP32[i4 + 4 >> 2] | 0) {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
  i1 = HEAP32[i8 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i5 = i2;
  do if (!i2) i1 = -1; else if (!(HEAP32[i8 + 24 >> 2] | 0)) {
   i1 = __Z22scripting_array_lengthP11Il2CppArray(i2) | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   break;
  } while (0);
  HEAP32[i6 >> 2] = i5;
  HEAP32[i6 + 4 >> 2] = i1;
 };
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = i6;
 mftCall_vii(HEAP32[i3 + 40 >> 2] | 0, i3 | 0, i7 | 0);
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 >> 2] | 0) | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i1 + ((HEAP8[i8 + 4 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i8 + 16 >> 2] | 0) | 0 : i7) >> 2] = i6;
 if ((HEAP32[i8 + 24 >> 2] | 0) != 1) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i1 + 12 >> 2] = HEAP32[i9 >> 2];
 i9 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i8 + 28 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + ((HEAP8[i8 + 32 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i8 + 44 >> 2] | 0) | 0 : i9) >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __Z18ExtractAssetBundleR3WWW(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) == 2) {
  i5 = __ZN9WWWCached14GetAssetBundleEv(i1) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = __ZN14UnityWebStream24GetAssetBundleInstanceIdEv(i1) | 0;
 do if (i4 | 0) {
  HEAP32[i3 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 13;
   }
  }
  if ((i5 | 0) == 11) i5 = 13;
  if ((i5 | 0) == 13) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27368 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27368 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = i5 - i6 | 0;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = i6;
 i7 = i3;
 i11 = i5;
 if (i4 >>> 0 > (i1 - i3 | 0) >>> 0) {
  if (i3) {
   i1 = i10 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i7;
   __ZdlPv(i7);
   HEAP32[i8 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
  }
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
  } else i3 = 0;
  i9 = i1 - i3 | 0;
  i3 = i9 << 1;
  i3 = i9 >>> 0 < 1073741823 ? (i3 >>> 0 < i4 >>> 0 ? i4 : i3) : 2147483647;
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = __Znwj(i3) | 0;
  i4 = i10 + 4 | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = i1 + i3;
  if ((i2 | 0) == (i11 | 0)) return;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
  } while ((i2 | 0) != (i11 | 0));
  return;
 } else {
  i8 = i10 + 4 | 0;
  i1 = (HEAP32[i8 >> 2] | 0) - i3 | 0;
  i4 = i4 >>> 0 > i1 >>> 0;
  i1 = i4 ? i2 + i1 | 0 : i5;
  i3 = i1 - i6 | 0;
  if (i3 | 0) _memmove(i7 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i7 + i3 | 0;
  if (!i4) {
   if ((HEAP32[i8 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i8 >> 2] = i2;
   return;
  }
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) return;
  i2 = HEAP32[i8 >> 2] | 0;
  do {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
   HEAP32[i8 >> 2] = i2;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
}

function __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i10 = i1;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 4 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i9 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 20 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i8 >> 2] = 87;
  HEAP32[i8 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 20 | 0, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i5 = i5 + (i3 * 20 | 0) | 0;
 i1 = i6;
 i4 = i6;
 do {
  i3 = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = i4 + 20 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (((i2 | 0) / -20 | 0) * 20 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = 87;
 HEAP32[i8 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim12statemachine24CreateTransitionConstantEPPNS0_17ConditionConstantEjjfffbb28TransitionInterruptionSourcebbjjjRNS_6memory9AllocatorE(i23, i24, i9, f16, f17, f18, i19, i20, i21, i22, i3, i4, i5, i6, i1) {
 i23 = i23 | 0;
 i24 = i24 | 0;
 i9 = i9 | 0;
 f16 = Math_fround(f16);
 f17 = Math_fround(f17);
 f18 = Math_fround(f18);
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i25 = 0;
 i25 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
 i7 = i25 + 32 | 0;
 HEAP32[i25 >> 2] = 0;
 HEAP32[i25 + 4 >> 2] = 0;
 HEAP32[i25 + 8 >> 2] = 0;
 HEAP32[i25 + 12 >> 2] = 0;
 HEAP32[i25 + 16 >> 2] = 0;
 HEAP32[i25 + 20 >> 2] = 0;
 HEAP32[i25 + 24 >> 2] = 0;
 HEAP32[i25 + 28 >> 2] = 0;
 HEAPF32[i7 >> 2] = Math_fround(.899999976);
 i8 = i25 + 36 | 0;
 HEAP8[i8 >> 0] = 0;
 i10 = i25 + 37 | 0;
 HEAP8[i10 >> 0] = 0;
 i11 = i25 + 40 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i25 + 44 | 0;
 HEAP8[i12 >> 0] = 1;
 i13 = i25 + 45 | 0;
 HEAP8[i13 >> 0] = 0;
 i14 = i25 + 4 | 0;
 i15 = (i24 | 0) == 0;
 if (i15) i1 = 0; else {
  i2 = i24 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i24 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i2 = i14;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i25 >> 2] = i24;
 HEAPF32[i25 + 24 >> 2] = f16;
 HEAPF32[i25 + 28 >> 2] = f17;
 HEAPF32[i7 >> 2] = f18;
 HEAP8[i8 >> 0] = i19 & 1;
 HEAP8[i10 >> 0] = i20 & 1;
 HEAP32[i11 >> 2] = i21;
 HEAP8[i12 >> 0] = i22 & 1;
 HEAP8[i13 >> 0] = i3 & 1;
 HEAP32[i25 + 16 >> 2] = i5;
 HEAP32[i25 + 12 >> 2] = i4;
 HEAP32[i25 + 20 >> 2] = i6;
 HEAP32[i25 + 8 >> 2] = i9;
 if (i15) return i25 | 0;
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  i22 = i2 + (i1 << 2) | 0;
  i21 = HEAP32[i23 + (i1 << 2) >> 2] | 0;
  HEAP32[i22 >> 2] = i21 | 0 ? i21 - i22 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i24 | 0));
 return i25 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 32 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 471189 | 0, i2, 0);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 471202 | 0, i7, i6, 0);
 i6 = i4 + 16 | 0;
 i5 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 899057 | 0, i7, i2 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 471214 | 0, i7, i2 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 STACKTOP = i3;
 return;
}

function __ZN15AudioReverbZone7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i3 + 8 | 0;
 i13 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 874099 | 0, 12) | 0;
 i11 = i1;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i14, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 175168 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i4;
 HEAPF32[i4 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(15.0);
 HEAP32[i4 + 56 >> 2] = 1;
 HEAP32[i4 + 116 >> 2] = 0;
 i14 = HEAP32[gb + 171848 + 96 >> 2] | 0;
 i1 = HEAP32[gb + 171848 + 100 >> 2] | 0;
 i13 = HEAP32[gb + 171848 + 104 >> 2] | 0;
 i12 = HEAP32[gb + 171848 + 108 >> 2] | 0;
 i11 = HEAP32[gb + 171848 + 116 >> 2] | 0;
 i10 = HEAP32[gb + 171848 + 120 >> 2] | 0;
 i9 = HEAP32[gb + 171848 + 124 >> 2] | 0;
 i8 = HEAP32[gb + 171848 + 128 >> 2] | 0;
 i7 = HEAP32[gb + 171848 + 140 >> 2] | 0;
 i2 = HEAP32[gb + 171848 + 144 >> 2] | 0;
 i6 = HEAP32[gb + 171848 + 148 >> 2] | 0;
 i5 = HEAP32[gb + 171848 + 152 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = HEAP32[gb + 171848 + 92 >> 2];
 HEAP32[i4 + 64 >> 2] = i14;
 HEAP32[i4 + 72 >> 2] = i13;
 HEAP32[i4 + 76 >> 2] = i12;
 HEAP32[i4 + 80 >> 2] = i11;
 HEAP32[i4 + 84 >> 2] = i10;
 HEAP32[i4 + 88 >> 2] = i9;
 HEAP32[i4 + 92 >> 2] = i8;
 HEAP32[i4 + 96 >> 2] = i7;
 HEAPF32[i4 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 108 >> 2] = i6;
 HEAP32[i4 + 112 >> 2] = i5;
 HEAP32[i4 + 68 >> 2] = i1;
 HEAP32[i4 + 100 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z35SetMeshComponentFromArrayFromScriptR4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi(i5, i1, i3, i2, i4, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 switch (i1 | 0) {
 case 0:
  {
   if (!i4) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 12) | 0;
   __ZN4Mesh11SetVerticesEPK8Vector3fj(i5, i1, i6);
   return;
  }
 case 1:
  {
   if (!i4) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 12) | 0;
   __ZN4Mesh10SetNormalsEPK8Vector3fj(i5, i1, i6);
   return;
  }
 case 7:
  {
   if (!i4) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
   __ZN4Mesh11SetTangentsEPK8Vector4fj(i5, i1, i6);
   return;
  }
 case 6:
 case 5:
 case 4:
 case 3:
  switch (i2 | 0) {
  case 2:
   {
    i1 = i1 + -3 | 0;
    if (!i4) {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, 0, 2, 0);
     return;
    } else {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 8) | 0, 2, i6);
     return;
    }
   }
  case 3:
   {
    i1 = i1 + -3 | 0;
    if (!i4) {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, 0, 3, 0);
     return;
    } else {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 12) | 0, 3, i6);
     return;
    }
   }
  case 4:
   {
    i1 = i1 + -3 | 0;
    if (!i4) {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, 0, 4, 0);
     return;
    } else {
     __ZN4Mesh5SetUvEiPKfjj(i5, i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0, 4, i6);
     return;
    }
   }
  default:
   return;
  }
 case 2:
  {
   i1 = (i4 | 0) == 0;
   if (!i3) {
    if (i1) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
    __ZN4Mesh9SetColorsEPK10ColorRGBAfj(i5, i1, i6);
    return;
   } else {
    if (i1) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
    __ZN4Mesh9SetColorsEPK11ColorRGBA32j(i5, i1, i6);
    return;
   }
  }
 default:
  return;
 }
}

function __Z21GetCameraOrWindowRectPK6Camera(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14;
 if (!i1) {
  i13 = __Z16GetScreenManagerv() | 0;
  f10 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 80 >> 2] | 0, i13 | 0) | 0);
  f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 84 >> 2] | 0, i13 | 0) | 0);
  HEAPF32[i7 + 8 >> 2] = f10;
  HEAPF32[i7 + 12 >> 2] = f11;
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  STACKTOP = i14;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i2, i1, 1);
 i12 = i1 + 864 | 0;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2]));
 i12 = i7 + 8 | 0;
 f8 = Math_fround(f10 * Math_fround(HEAPF32[i12 >> 2]));
 HEAPF32[i12 >> 2] = f8;
 i1 = i7 + 4 | 0;
 f6 = Math_fround(f11 * Math_fround(HEAPF32[i1 >> 2]));
 i13 = i7 + 12 | 0;
 f9 = Math_fround(f11 * Math_fround(HEAPF32[i13 >> 2]));
 HEAPF32[i13 >> 2] = f9;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 + f4);
 HEAPF32[i7 >> 2] = f5;
 f6 = Math_fround(f6 + f3);
 HEAPF32[i1 >> 2] = f6;
 f8 = Math_fround(f8 + f5);
 f9 = Math_fround(f9 + f6);
 f10 = Math_fround(f10 + f4);
 f11 = Math_fround(f11 + f3);
 if (f5 < f4) HEAPF32[i7 >> 2] = f4; else f4 = f5;
 if (f6 < f3) HEAPF32[i1 >> 2] = f3; else f3 = f6;
 f10 = Math_fround((f8 > f10 ? f10 : f8) - f4);
 i7 = f10 < Math_fround(0.0);
 HEAPF32[i12 >> 2] = i7 ? Math_fround(0.0) : f10;
 f11 = Math_fround((f9 > f11 ? f11 : f9) - f3);
 i12 = f11 < Math_fround(0.0);
 HEAPF32[i13 >> 2] = i12 ? Math_fround(0.0) : f11;
 STACKTOP = i14;
 return;
}

function _UNITY_png_set_pCAL(i10, i11, i4, i5, i6, i7, i12, i8, i13) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0;
 if ((i10 | 0) == 0 | (i11 | 0) == 0 | (i4 | 0) == 0 | (i8 | 0) == 0) return;
 i9 = (i12 | 0) > 0;
 if (i9 & (i13 | 0) == 0) return;
 i3 = (_strlen(i4) | 0) + 1 | 0;
 if (i7 >>> 0 > 3) _UNITY_png_error(i10, gb + 352807 | 0);
 if (i12 >>> 0 > 255) _UNITY_png_error(i10, gb + 352834 | 0);
 L13 : do if (i12 | 0) {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i13 + (i1 << 2) >> 2] | 0;
   if (!i2) {
    i1 = 11;
    break;
   }
   i1 = i1 + 1 | 0;
   if (!(_UNITY_png_check_fp_string(i2, _strlen(i2) | 0) | 0)) {
    i1 = 11;
    break;
   }
   if ((i1 | 0) >= (i12 | 0)) break L13;
  }
  if ((i1 | 0) == 11) _UNITY_png_error(i10, gb + 352863 | 0);
 } while (0);
 i1 = _UNITY_png_malloc_warn(i10, i3) | 0;
 HEAP32[i11 + 196 >> 2] = i1;
 if (!i1) return;
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 HEAP32[i11 + 200 >> 2] = i5;
 HEAP32[i11 + 204 >> 2] = i6;
 HEAP8[i11 + 216 >> 0] = i7;
 HEAP8[i11 + 217 >> 0] = i12;
 i1 = (_strlen(i8) | 0) + 1 | 0;
 i2 = _UNITY_png_malloc_warn(i10, i1) | 0;
 HEAP32[i11 + 208 >> 2] = i2;
 if (!i2) return;
 _memcpy(i2 | 0, i8 | 0, i1 | 0) | 0;
 i1 = (i12 << 2) + 4 | 0;
 i2 = _UNITY_png_malloc_warn(i10, i1) | 0;
 i5 = i11 + 212 | 0;
 HEAP32[i5 >> 2] = i2;
 if (!i2) return;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 L31 : do if (i9) {
  i1 = 0;
  while (1) {
   i2 = i13 + (i1 << 2) | 0;
   i3 = (_strlen(HEAP32[i2 >> 2] | 0) | 0) + 1 | 0;
   i4 = _UNITY_png_malloc_warn(i10, i3) | 0;
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i4;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (!i4) break;
   _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i12 | 0)) break L31;
  }
  return;
 } while (0);
 i13 = i11 + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 1024;
 i13 = i11 + 220 | 0;
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | 128;
 return;
}

function __ZNSt3__214__split_bufferI14SubstanceInputRNS_9allocatorIS1_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 8 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i4 = i2 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 32 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 68 | 0;
  HEAP32[i2 + 84 >> 2] = 0;
  HEAP32[i2 + 104 >> 2] = 0;
  HEAP32[i2 + 108 >> 2] = 0;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 0;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 148 >> 2] = 0;
  HEAP32[i2 + 152 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = i2 + 148;
  HEAP32[i2 + 64 >> 2] = 1;
  HEAP32[i2 + 140 >> 2] = 8;
  HEAP32[i2 + 88 >> 2] = 0;
  HEAP32[i2 + 92 >> 2] = 0;
  HEAP32[i2 + 96 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAPF32[i2 + 116 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i2 + 120 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i2 = (HEAP32[i3 >> 2] | 0) + 156 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN9BoxPrunerD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 3 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 2 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 1 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 12984 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 | 0) == (i4 + 12464 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 12988 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 | 0) == (i4 + 176 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 12992 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 | 0) == (i4 + 6320 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 + 12976 >> 2] = 0;
 HEAP32[i4 + 12980 >> 2] = 0;
 __ZN5physx2Gu17RadixSortBufferedD2Ev(i4 + 132 | 0);
 i1 = i4 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i4 = i4 + 128 | 0;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i4 + 128 | 0;
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN9BlobWrite4PushEjPKvj(i13, i12, i10, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i14 = 0;
 i11 = i13 + 16 | 0;
 i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0;
 i9 = (i1 + -1 & 0 - i9) + i9 | 0;
 i6 = i13 + 36 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i13 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i14 = i3 - i2 | 0;
 i4 = i13 + 44 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i8 = i13 + 48 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((((i14 | 0) == 0 ? 0 : (i14 << 6) + -1 | 0) | 0) == (i1 + i5 | 0)) {
  __ZNSt3__25dequeIN9BlobWrite11TypeContextENS_9allocatorIS2_EEE19__add_back_capacityEv(i13 + 28 | 0);
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i1 + i5 | 0;
 if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (i1 >>> 8 << 2) >> 2] | 0) + ((i1 & 255) << 4) | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i10;
 HEAP32[i1 + 12 >> 2] = i12;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i6 = HEAP32[i11 >> 2] | 0;
 i1 = i9 + i12 | 0;
 i2 = i6 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 16, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i14 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = i14;
  break;
 } while (0);
 if (i1 >>> 0 <= i5 >>> 0) {
  i14 = i13 + 24 | 0;
  HEAP8[i14 >> 0] = 0;
  return;
 }
 i1 = i1 - i5 | 0;
 if (!i1) {
  i14 = i13 + 24 | 0;
  HEAP8[i14 >> 0] = 0;
  return;
 }
 _memset((HEAP32[i6 >> 2] | 0) + i5 | 0, 0, i1 | 0) | 0;
 i14 = i13 + 24 | 0;
 HEAP8[i14 >> 0] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_19PxsW2STransformTempENS0_16AlignedAllocatorILj16ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, (i5 * 56 | 0) + 19 | 0, (i1 ? gb + 769559 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i4 = 0; else {
   i4 = i1 + 19 & -16;
   HEAP32[i4 + -4 >> 2] = i4 - i1;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 56 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
   HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
   i1 = i1 + 56 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 56 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZL24GeomMTDCallback_PlaneBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i2, i1, i5, i3, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 16 | 0;
 i8 = i1;
 HEAP32[i7 + 36 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i3 + 12 >> 2];
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f12 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f9 = Math_fround(f13 + f13);
 f11 = Math_fround(f12 + f12);
 f16 = Math_fround(f19 + f19);
 f18 = Math_fround(f12 * f11);
 f17 = Math_fround(f19 * f16);
 f12 = Math_fround(f9 * f12);
 f20 = Math_fround(f9 * f19);
 f10 = Math_fround(f9 * f14);
 f19 = Math_fround(f11 * f19);
 f11 = Math_fround(f11 * f14);
 f14 = Math_fround(f16 * f14);
 f16 = Math_fround(f12 + f14);
 f15 = Math_fround(f20 - f11);
 f14 = Math_fround(f12 - f14);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f9));
 f13 = Math_fround(f9 - f17);
 f12 = Math_fround(f19 + f10);
 f11 = Math_fround(f20 + f11);
 f10 = Math_fround(f19 - f10);
 f9 = Math_fround(f9 - f18);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f18) - f17);
 HEAPF32[i7 + 4 >> 2] = f16;
 HEAPF32[i7 + 8 >> 2] = f15;
 HEAPF32[i7 + 12 >> 2] = f14;
 HEAPF32[i7 + 16 >> 2] = f13;
 HEAPF32[i7 + 20 >> 2] = f12;
 HEAPF32[i7 + 24 >> 2] = f11;
 HEAPF32[i7 + 28 >> 2] = f10;
 HEAPF32[i7 + 32 >> 2] = f9;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i8, i5);
 i6 = __ZN5physx2Gu19computeMTD_PlaneBoxERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_3BoxE(i4, i2, i8, i7) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __Z26Texture3D_CUSTOM_GetPixelsP12Il2CppObjecti(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i7 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i7 = __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i3 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i5;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) >> i5;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0) | 0) >> i5;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, Math_imul(Math_imul((i1 | 0) < 1 ? 1 : i1, (i3 | 0) < 1 ? 1 : i3) | 0, (i2 | 0) < 1 ? 1 : i2) | 0) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture3D9GetPixelsEP10ColorRGBAfi(i3, i2, i5);
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __Z12NHxRoughnessItEvP9Texture2DPT_iiii(i2, i6, i7, i4, i8, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var f1 = f0, f3 = f0, f9 = f0;
 f9 = Math_fround(+Math_pow(+Math_fround(Math_fround(i7 | 0) / Math_fround(Math_fround(i8 | 0) + Math_fround(-1.0))), .25));
 f3 = Math_fround(Math_fround(i4 | 0) / Math_fround(Math_fround(i5 | 0) + Math_fround(-.5)));
 f1 = Math_fround(Math_fround(10.0) / Math_fround(_log2f(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(.967999994)) + Math_fround(.0299999993)))));
 f1 = Math_fround(Math_fround(f1 * f1) * Math_fround(.25));
 f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, +f1)) * Math_fround(Math_fround(f1 + Math_fround(2.0)) / Math_fround(6.28318548))) / Math_fround(445.721954));
 i5 = f1 < Math_fround(0.0);
 f1 = i5 ? Math_fround(0.0) : f1;
 i5 = f1 > Math_fround(1.0);
 f1 = i5 ? Math_fround(1.0) : f1;
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 if ((i8 + -1 | 0) > (i7 | 0) | !(f3 <= Math_fround(.0500000007))) {
  f3 = f1;
  f3 = Math_fround(f3 * Math_fround(65535.0));
  f3 = Math_fround(f3 + Math_fround(.5));
  i8 = f3 >= Math_fround(0.0);
  f9 = Math_fround(f3 + Math_fround(-.99999994));
  f9 = i8 ? f3 : f9;
  i8 = ~~f9;
  i8 = i8 & 65535;
  HEAP16[i6 >> 1] = i8;
  return;
 }
 f3 = Math_fround(Math_fround(f3 / Math_fround(.0500000007)) * f1);
 f3 = Math_fround(f3 * Math_fround(65535.0));
 f3 = Math_fround(f3 + Math_fround(.5));
 i8 = f3 >= Math_fround(0.0);
 f9 = Math_fround(f3 + Math_fround(-.99999994));
 f9 = i8 ? f3 : f9;
 i8 = ~~f9;
 i8 = i8 & 65535;
 HEAP16[i6 >> 1] = i8;
 return;
}

function __ZNK6Avatar12GetLimitSignEi(i7, i1, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 L1 : do if ((i5 | 0) < 0) i1 = -1; else {
  do if ((i5 | 0) < 24) {
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i1 = -1;
    break L1;
   }
   i3 = i2 + i1 | 0;
   i4 = i3 + 40 | 0;
   if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) i3 = 8; else {
    i1 = HEAP32[i3 + 72 + (i5 << 2) >> 2] | 0;
    break L1;
   }
  } else {
   if ((i5 | 0) < 39) {
    i1 = i6 + 20 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i1 = -1;
     break L1;
    } else {
     i3 = 8;
     break;
    }
   }
   if ((i5 | 0) >= 54) {
    i1 = -1;
    break L1;
   }
   i1 = i6 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i1 = -1;
    break L1;
   }
  } while (0);
  if ((i3 | 0) == 8) {
   i3 = i1 + i2 | 0;
   i4 = i3 + 40 | 0;
   if (HEAP32[i4 + (HEAP32[i4 >> 2] | 0) >> 2] | 0) {
    i3 = i3 + 48 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (i4) {
     i1 = HEAP32[i4 + i3 + (i5 + -24 << 2) >> 2] | 0;
     break;
    }
   }
  }
  i1 = i1 + i2 | 0;
  i4 = i1 + 40 | 0;
  if (!(HEAP32[i4 + (HEAP32[i4 >> 2] | 0) >> 2] | 0)) i1 = -1; else {
   i1 = i1 + 52 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i1 = -1; else i1 = HEAP32[i2 + i1 + (i5 + -39 << 2) >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[gb + 62512 >> 2];
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 i4 = i7 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 if ((i1 | 0) == -1) return;
 i2 = i6 + 20 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 + 40 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i2 + 4 | 0;
 i1 = HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i2 = i2 + 16 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i5 = HEAP32[i2 + (i1 * 76 | 0) + 36 >> 2] | 0;
 i6 = HEAP32[i2 + (i1 * 76 | 0) + 40 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + (i1 * 76 | 0) + 32 >> 2];
 HEAP32[i3 >> 2] = i5;
 HEAP32[i4 >> 2] = i6;
 return;
}

function __ZN5physx15PxsParticleData13onOriginShiftERKNS_6PxVec3E(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, f13 = f0, i14 = 0;
 i2 = HEAP32[i11 + 16 >> 2] | 0;
 if (!i2) {
  i3 = i1 + 4 | 0;
  i2 = i1 + 8 | 0;
 } else {
  i10 = HEAP32[i11 + 56 >> 2] | 0;
  i7 = (i2 + -1 | 0) >>> 5;
  i8 = i11 + 48 | 0;
  i3 = i1 + 4 | 0;
  i2 = i1 + 8 | 0;
  i9 = 0;
  while (1) {
   i4 = HEAP32[i10 + (i9 << 2) >> 2] | 0;
   if (i4 | 0) {
    i5 = i9 << 5;
    i6 = HEAP32[i8 >> 2] | 0;
    do {
     i12 = (Math_imul(i4 & 0 - i4, 125613361) | 0) >>> 27;
     i12 = HEAP32[gb + 90668 + (i12 << 2) >> 2] | i5;
     f13 = Math_fround(HEAPF32[i1 >> 2]);
     i14 = i6 + (i12 << 5) | 0;
     HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
     f13 = Math_fround(HEAPF32[i3 >> 2]);
     i14 = i6 + (i12 << 5) + 4 | 0;
     HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
     f13 = Math_fround(HEAPF32[i2 >> 2]);
     i12 = i6 + (i12 << 5) + 8 | 0;
     HEAPF32[i12 >> 2] = Math_fround(Math_fround(HEAPF32[i12 >> 2]) - f13);
     i4 = i4 + -1 & i4;
    } while ((i4 | 0) != 0);
   }
   if ((i9 | 0) == (i7 | 0)) break; else i9 = i9 + 1 | 0;
  }
 }
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 i14 = i11 + 24 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i14 = i11 + 28 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 i14 = i11 + 32 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 i14 = i11 + 36 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i14 = i11 + 40 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 i14 = i11 + 44 | 0;
 HEAPF32[i14 >> 2] = Math_fround(Math_fround(HEAPF32[i14 >> 2]) - f13);
 return;
}

function __ZNK5Unity14CharacterJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 24 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11;
 i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i16 = HEAP32[i1 + 64 >> 2] | 0;
 HEAP32[i7 >> 2] = i16;
 i3 = i7 + 4 | 0;
 i15 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i3 >> 2] = i15;
 i4 = i7 + 8 | 0;
 i14 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i4 >> 2] = i14;
 f12 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f12 * f12);
 f13 = (HEAP32[tempDoublePtr >> 2] = i15, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f13 = Math_fround(f12 + Math_fround(f13 * f13));
 f12 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = Math_fround(f13 + Math_fround(f12 * f12));
 if (f12 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  HEAPF32[i7 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
 }
 HEAP32[i8 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 104 >> 2];
 __Z14OrthoNormalizeP8Vector3fS0_(i7, i8);
 __ZNK9Transform14TransformPointERK8Vector3f(i9, i10, i1 + 40 | 0);
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK9Transform18TransformDirectionERK8Vector3f(i9, i10, i7);
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 __ZNK9Transform18TransformDirectionERK8Vector3f(i9, i10, i8);
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej(i10, i11, i5, i3) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i12 = i13 + 8 | 0;
 i1 = i11 + 4216 + (i5 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 220 >> 2] | 0, i11 | 0) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i1 = i3 >>> 0 > 1 ? i3 : 1;
 if ((HEAP32[i2 + 24 >> 2] | 0) >>> 0 >= i1 << 3 >>> 0) {
  HEAP32[i10 >> 2] = i2;
  i12 = i10 + 4 | 0;
  HEAP32[i12 >> 2] = 8;
  STACKTOP = i13;
  return;
 }
 i7 = i1 + -1 | 0;
 i7 = i7 >>> 16 | i7;
 i7 = i7 >>> 8 | i7;
 i7 = i7 >>> 4 | i7;
 i7 = i7 >>> 2 | i7;
 i7 = (i7 >>> 1 | i7) + 1 | 0;
 i9 = i7 << 1;
 HEAP32[i12 + 12 >> 2] = i9;
 i8 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = i9;
 i9 = i12 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i7 << 3;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i12 >> 2] = i1;
 if ((i5 | 0) == 1) {
  i5 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0) == 0;
  i4 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 514 >> 0] | 0) == 0;
  i4 = i4 ? 255 : 16711680;
  i5 = i5 ? 16711680 : 255;
 } else {
  i4 = 0;
  i5 = -1;
 }
 if (i7 | 0) {
  i3 = 0;
  while (1) {
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i4;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else i1 = i1 + 8 | 0;
  }
 }
 mftCall_viiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 224 >> 2] | 0, i11 | 0, i2 | 0, 0, 1, i6 | 0, HEAP32[i12 >> 2] | 0, 0);
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i9);
  HEAP32[i12 >> 2] = 0;
 }
 HEAP32[i10 >> 2] = i2;
 i12 = i10 + 4 | 0;
 HEAP32[i12 >> 2] = 8;
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE6createERKS5_Rb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx27PxArticulationGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 82;
 HEAP32[i1 + 8 >> 2] = fb + 2133;
 HEAP32[i1 + 12 >> 2] = gb + 674232;
 HEAP32[i1 + 16 >> 2] = 83;
 HEAP32[i1 + 20 >> 2] = fb + 2134;
 HEAP32[i1 + 24 >> 2] = fb + 3521;
 HEAP32[i1 + 28 >> 2] = gb + 674256;
 HEAP32[i1 + 32 >> 2] = 84;
 HEAP32[i1 + 36 >> 2] = fb + 392;
 HEAP32[i1 + 40 >> 2] = fb + 334;
 HEAP32[i1 + 44 >> 2] = gb + 674276;
 HEAP32[i1 + 48 >> 2] = 85;
 HEAP32[i1 + 52 >> 2] = fb + 2135;
 HEAP32[i1 + 56 >> 2] = fb + 3522;
 HEAP32[i1 + 60 >> 2] = gb + 674300;
 HEAP32[i1 + 64 >> 2] = 86;
 HEAP32[i1 + 68 >> 2] = fb + 2136;
 HEAP32[i1 + 72 >> 2] = fb + 3523;
 HEAP32[i1 + 76 >> 2] = gb + 673733;
 HEAP32[i1 + 80 >> 2] = 87;
 HEAP32[i1 + 84 >> 2] = gb + 673755;
 HEAP32[i1 + 88 >> 2] = gb + 673772;
 HEAP32[i1 + 92 >> 2] = fb + 773;
 HEAP32[i1 + 96 >> 2] = fb + 774;
 HEAP32[i1 + 100 >> 2] = gb + 673687;
 HEAP32[i1 + 104 >> 2] = 88;
 HEAP32[i1 + 108 >> 2] = fb + 2137;
 HEAP32[i1 + 112 >> 2] = gb + 756508;
 HEAP32[i1 + 116 >> 2] = 89;
 HEAP32[i1 + 120 >> 2] = fb + 393;
 HEAP32[i1 + 124 >> 2] = fb + 335;
 HEAP32[i1 + 128 >> 2] = gb + 673698;
 HEAP32[i1 + 132 >> 2] = 90;
 HEAP32[i1 + 136 >> 2] = fb + 394;
 HEAP32[i1 + 140 >> 2] = fb + 336;
 HEAP32[i1 + 144 >> 2] = gb + 673721;
 HEAP32[i1 + 148 >> 2] = 91;
 HEAP32[i1 + 152 >> 2] = fb + 395;
 HEAP32[i1 + 156 >> 2] = fb + 337;
 HEAP32[i1 + 160 >> 2] = gb + 674324;
 HEAP32[i1 + 164 >> 2] = 92;
 HEAP32[i1 + 168 >> 2] = fb + 401;
 HEAP32[i1 + 172 >> 2] = fb + 2138;
 HEAP32[i1 + 176 >> 2] = gb + 741602;
 HEAP32[i1 + 180 >> 2] = 93;
 HEAP32[i1 + 184 >> 2] = fb + 2139;
 HEAP32[i1 + 188 >> 2] = fb + 3524;
 HEAP32[i1 + 192 >> 2] = gb + 673499;
 HEAP32[i1 + 196 >> 2] = 94;
 HEAP32[i1 + 200 >> 2] = fb + 2140;
 HEAP32[i1 + 204 >> 2] = gb + 831985;
 HEAP32[i1 + 208 >> 2] = 95;
 HEAP32[i1 + 212 >> 2] = fb + 2141;
 HEAP32[i1 + 216 >> 2] = gb + 741613;
 HEAP32[i1 + 220 >> 2] = 96;
 HEAP32[i1 + 224 >> 2] = fb + 2142;
 HEAP32[i1 + 228 >> 2] = fb + 3525;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = (i4 - i5 | 0) / 24 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj(i2, i1 - i3 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i3 >>> 0) {
  i1 = i5 + (i1 * 24 | 0) | 0;
  if ((i4 | 0) == (i1 | 0)) i1 = i5; else {
   i4 = i4 + (~(((i4 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i4;
   i1 = i5;
  }
 } else i1 = i5;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  i3 = _llvm_bswap_i32(i2 | 0) | 0;
  i7 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i3) | 0;
  HEAP32[i1 >> 2] = i7;
  if ((i2 | 0) != -1 & (i7 | 0) == 0) HEAP32[i1 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(i3) | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i12);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __Z28RecreateSkinnedMeshResourcesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i7 = i8 + 16 | 0;
 i3 = gb + 64016 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i7 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31632 | 0, i7, 0);
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  i1 = 0;
  do {
   __ZN19SkinnedMeshRenderer19UnloadFromGfxDeviceEv(HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i3);
  HEAP32[i7 >> 2] = 0;
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = 0;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = i5;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31632 | 0, i7, 0);
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN19SkinnedMeshRenderer17ReloadToGfxDeviceEv(HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i4);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN30EmissionModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 do switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 352 >> 2] = f4;
   HEAP8[i2 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 272 | 0, i2 + 360 | 0, f4, HEAP16[i2 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 616 >> 2] = f4;
   HEAP8[i2 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 536 | 0, i2 + 624 | 0, f4, HEAP16[i2 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 816 >> 2] = ~~f4;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 820 >> 2] = ~~f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 824 >> 2] = ~~f4;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 828 >> 2] = ~~f4;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 832 >> 2] = ~~f4;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 836 >> 2] = ~~f4;
   return;
  }
 case 8:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 840 >> 2] = ~~f4;
   return;
  }
 case 9:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 844 >> 2] = ~~f4;
   return;
  }
 case 10:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 800 >> 2] = f4;
   return;
  }
 case 11:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 804 >> 2] = f4;
   return;
  }
 case 12:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 808 >> 2] = f4;
   return;
  }
 case 13:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[i2 + 812 >> 2] = f4;
   return;
  }
 case 14:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP32[i2 + 848 >> 2] = ~~f4;
   return;
  }
 default:
  return;
 } while (0);
}

function __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 40 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 40 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 40 | 0) * 40 | 0) | 0;
 i7 = i1;
 i4 = i5 + (i4 * 40 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i5 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i5 = i3;
   i3 = i3 + -40 | 0;
   __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i1 + -40 | 0, i3);
   __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i1 + -20 | 0, i5 + -20 | 0);
   i1 = i2 + -40 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i4;
 i4 = i5;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = i2 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -36 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i4 | 0));
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
 STACKTOP = i13;
 return;
}

function __ZN14PhysicsManager5ResetEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAPF32[i7 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 36 >> 2] = Math_fround(-9.81000041);
 HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 52 >> 2] = Math_fround(2.0);
 i4 = i7 + 724 | 0;
 HEAP32[i1 >> 2] = -1;
 i6 = i7 + 728 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = i5 - i3 >> 2;
 if (i2 >>> 0 < 32) __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEjRKj(i4, 32 - i2 | 0, i1); else if ((i2 | 0) != 32) {
  i1 = i3 + 128 | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
 }
 HEAP32[i7 + 168 >> 2] = 6;
 HEAP32[i7 + 172 >> 2] = 1;
 i2 = i7 + 104 | 0;
 i1 = i7 + 108 | 0;
 __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i7 + 112 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 116 | 0;
 i2 = i7 + 132 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 120 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 128 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i2 = i7 + 136 | 0;
 i1 = i7 + 140 | 0;
 __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i7 + 144 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 148 | 0;
 i2 = i7 + 164 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 152 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 160 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __Z27FindSeparatedPathComponentsPKcjc(i12, i2, i1, i13) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i8 = i2 + i1 | 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i12 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 i10 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i6 = i12 + 8 | 0;
 i7 = i14 + 11 | 0;
 while (1) {
  if ((i2 | 0) == (i8 | 0)) {
   i15 = 18;
   break;
  } else i1 = i2;
  while (1) {
   if ((HEAP8[i1 >> 0] | 0) == i13 << 24 >> 24) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i8 | 0)) {
    i1 = i8;
    break;
   }
  }
  if ((i1 | 0) != (i2 | 0)) {
   HEAP32[i14 >> 2] = 0;
   HEAP32[i14 + 4 >> 2] = 0;
   HEAP32[i14 + 8 >> 2] = 0;
   i5 = i1 - i2 | 0;
   if (i5 >>> 0 > 4294967279) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i14);
    i15 = 10;
   } else if (i5 >>> 0 < 11) {
    HEAP8[i7 >> 0] = i5;
    i3 = i14;
   } else i15 = 10;
   if ((i15 | 0) == 10) {
    i15 = 0;
    i4 = i5 + 16 & -16;
    i3 = __Znwj(i4) | 0;
    HEAP32[i14 >> 2] = i3;
    HEAP32[i10 >> 2] = i4 | -2147483648;
    HEAP32[i11 >> 2] = i5;
   }
   i4 = i3;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i1 | 0)) break; else i4 = i4 + 1 | 0;
   }
   HEAP8[i3 + i5 >> 0] = 0;
   i2 = HEAP32[i9 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i12, i14); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i14);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i14);
  }
  if ((i1 | 0) == (i8 | 0)) {
   i15 = 18;
   break;
  } else i2 = i1 + 1 | 0;
 }
 if ((i15 | 0) == 18) {
  STACKTOP = i16;
  return;
 }
}

function __Z24setPxSceneDesc_ToDefaultPN5physx11PxSceneDescERKNS_17PxTolerancesScaleE(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 16 | 0;
 i3 = i10;
 i9 = i1;
 i11 = i9 + 68 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(f7 * Math_fround(.00999999977));
 f5 = Math_fround(f7 * Math_fround(.0250000004));
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(.200000003));
 f7 = Math_fround(f7 * Math_fround(.0399999991));
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i9 = i8 + 12 | 0;
 i11 = i9 + 68 | 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  i9 = i9 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAPF32[i8 + 80 >> 2] = f4;
 HEAP32[i8 + 84 >> 2] = 0;
 HEAPF32[i8 + 88 >> 2] = f5;
 HEAPF32[i8 + 92 >> 2] = f6;
 HEAPF32[i8 + 96 >> 2] = f7;
 HEAP16[i8 + 100 >> 1] = 0;
 HEAP32[i8 + 104 >> 2] = 0;
 HEAP32[i8 + 108 >> 2] = 0;
 HEAP32[i8 + 112 >> 2] = 0;
 HEAP32[i8 + 116 >> 2] = 1;
 HEAP32[i8 + 120 >> 2] = 1;
 HEAP32[i8 + 124 >> 2] = 100;
 HEAP32[i8 + 128 >> 2] = 0;
 HEAP32[i8 + 132 >> 2] = 32;
 HEAP32[i8 + 136 >> 2] = 0;
 HEAP32[i8 + 140 >> 2] = 65536;
 HEAP32[i8 + 144 >> 2] = 8192;
 HEAP32[i8 + 148 >> 2] = 1;
 HEAP32[i8 + 152 >> 2] = 0;
 HEAPF32[i8 + 156 >> 2] = Math_fround(.399999976);
 HEAP32[i8 + 160 >> 2] = -25165825;
 HEAP32[i8 + 164 >> 2] = -25165825;
 HEAP32[i8 + 168 >> 2] = -25165825;
 HEAP32[i8 + 172 >> 2] = 2122317823;
 HEAP32[i8 + 176 >> 2] = 2122317823;
 HEAP32[i8 + 180 >> 2] = 2122317823;
 i11 = i8 + 184 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN7dtCrowd11removeAgentER13dtCrowdHandle(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i8 + 16 >> 2] | 0;
 __ZN7dtCrowd19completeOffMeshLinkEib(i8, i10, 0);
 i3 = i5 + (i10 * 608 | 0) + 602 | 0;
 HEAP8[i3 >> 0] = HEAP8[i3 >> 0] & -2;
 i3 = i5 + (i10 * 608 | 0) + 28 | 0;
 __Z6dtFreePv(HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + (i10 * 608 | 0) + 32 >> 2] = 0;
 HEAP32[i5 + (i10 * 608 | 0) + 36 >> 2] = 0;
 i3 = i8 + 4 | 0;
 HEAP32[i5 + (i10 * 608 | 0) + 384 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i10;
 i5 = i5 + (i10 * 608 | 0) + 600 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i3 << 24 >> 24) {
  i6 = i8 + 460 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  L3 : do if ((i4 | 0) > 0) {
   i1 = HEAP32[i8 + 456 >> 2] | 0;
   i2 = 0;
   do {
    if ((HEAP32[i1 + (i2 << 2) >> 2] | 0) == (i10 | 0)) break L3;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
  } else i2 = 0; while (0);
  if (i3 << 24 >> 24 == 2) {
   HEAP32[i8 + 32 >> 2] = 0;
   HEAP32[i8 + 92 >> 2] = 0;
   HEAP32[i8 + 256 >> 2] = 0;
   HEAP32[i8 + 452 >> 2] = 0;
  }
  i1 = i4 + -1 | 0;
  HEAP32[i6 >> 2] = i1;
  if ((i1 | 0) != (i2 | 0)) {
   i7 = HEAP32[i8 + 456 >> 2] | 0;
   _memmove(i7 + (i2 << 2) | 0, i7 + (i2 + 1 << 2) | 0, i1 - i2 << 2 | 0) | 0;
  }
  HEAP8[i5 >> 0] = 0;
 }
 i7 = HEAP32[i8 + 428 >> 2] | 0;
 if ((i7 | 0) <= 0) {
  HEAP32[i9 >> 2] = -1;
  return;
 }
 i2 = HEAP32[i8 + 424 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = (i4 | 0) == 0;
  if (i5) i6 = -1; else i6 = HEAP32[i4 >> 2] | 0;
  if ((i6 | 0) == (i10 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i7 | 0)) {
   i11 = 20;
   break;
  }
 }
 if ((i11 | 0) == 20) {
  HEAP32[i9 >> 2] = -1;
  return;
 }
 if (!i5) {
  __Z6dtFreePv(HEAP32[i4 + 48 >> 2] | 0);
  __Z6dtFreePv(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i3 >> 2] | 0);
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i9 >> 2] = -1;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i6, i8, i2) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = i11 + 44 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
 }
 i5 = i9;
 i7 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i2 = i6 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i8 * 60 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 60 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 60 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i6 >> 2] = i1;
  break;
 } while (0);
 if (i5 >>> 0 >= i8 >>> 0) {
  STACKTOP = i11;
  return;
 }
 i6 = i1 + (i5 * 60 | 0) | 0;
 i2 = i8 - i5 | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 } else i1 = 0;
 do {
  i3 = i6 + (i1 * 60 | 0) | 0;
  HEAP32[i3 >> 2] = -1;
  i5 = i3 + 4 | 0;
  i4 = i9;
  i7 = i5 + 44 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   i5 = i5 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  HEAPF32[i3 + 48 >> 2] = Math_fround(1.0);
  HEAP32[i3 + 52 >> 2] = 0;
  HEAP8[i3 + 56 >> 0] = 0;
  i8 = i3 + 57 | 0;
  HEAP8[i8 >> 0] = HEAP8[i10 >> 0] | 0;
  HEAP8[i8 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
  HEAP8[i8 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags(i8, i7, 0);
 i3 = i7 + 20 | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i8 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i7 + 32 >> 2] | 0;
 i2 = i1 + (i3 * 12 | 0) | 0;
 if (i3 | 0) do {
  __ZN10BlendShape8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i7 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 + 44 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i7 = i7 + 52 | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i8, i7, 0);
  STACKTOP = i9;
  return;
 }
 do {
  __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = i7 + 52 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i8, i7, 0);
 STACKTOP = i9;
 return;
}

function __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i1, i8, i3, i4, f2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i10 = i9;
 i5 = HEAP32[i1 + 56 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i5 + (i3 << 4) >> 2]);
 HEAPF32[i8 + 4 >> 2] = Math_fround(f13 + f2);
 f15 = Math_fround(HEAPF32[i5 + (i4 << 4) >> 2]);
 HEAPF32[i8 + 8 >> 2] = Math_fround(f15 + f2);
 HEAP32[i8 >> 2] = i3;
 f13 = Math_fround(f15 - f13);
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i10 >> 2] = Math_fround(.0000999999974);
 i6 = f13 < Math_fround(.0000999999974);
 i10 = HEAP32[(i6 ? i10 : i7) >> 2] | 0;
 HEAP32[i7 >> 2] = i10;
 f13 = Math_fround(HEAPF32[i5 + (i4 << 4) + 4 >> 2]);
 i7 = i5 + (i3 << 4) + 4 | 0;
 f13 = Math_fround(f13 - Math_fround(HEAPF32[i7 >> 2]));
 f15 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f14 = Math_fround(Math_fround(1.0) / Math_fround(f15 * f15));
 i10 = i5 + (i3 << 4) + 12 | 0;
 f2 = Math_fround(HEAPF32[i10 >> 2]);
 i3 = i5 + (i4 << 4) + 8 | 0;
 f12 = Math_fround(f15 * f2);
 f11 = Math_fround(f15 * Math_fround(HEAPF32[i3 >> 2]));
 i4 = i8 + 12 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(f14 * Math_fround(Math_fround(Math_fround(f12 + f11) - f13) - f13)) / f15);
 i5 = i8 + 16 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f14 * Math_fround(Math_fround(Math_fround(Math_fround(f13 + Math_fround(f13 + f13)) - f12) - f12) - f11));
 i6 = i8 + 20 | 0;
 HEAPF32[i6 >> 2] = f2;
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 if (!(Math_fround(HEAPF32[i10 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i3 >> 2]) == Math_fround(inf))) {
  STACKTOP = i9;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN22DeviceMVPMatricesStateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 96 | 0;
 i3 = i2;
 i5 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0, i1 + 132 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0, i1 + 68 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 108 >> 2] | 0, i5 | 0, i1 + 4 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i5, i4);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i4, i3);
 i4 = i1 + 1364 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i4 = i3 + 16 | 0;
 i5 = i1 + 1380 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 32 | 0;
 i4 = i1 + 1396 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = i3 + 48 | 0;
 i5 = i1 + 1412 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 64 | 0;
 i4 = i1 + 1428 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i3 = i3 + 80 | 0;
 i1 = i1 + 1444 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN13MonoBehaviour18TransferEngineDataI24GenerateTypeTreeTransferEE4PPtrI10MonoScriptERT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i4 = i3 + 16 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 HEAP32[i4 >> 2] = HEAP32[i1 + 36 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 588832 | 0, gb + 899338 | 0, i4, 0);
 i8 = i7 + 8 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 40 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return HEAP32[i4 >> 2] | 0;
}

function __ZN13GfxDeviceGLES23UnregisterNativeTextureE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i9 = i10;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = i6;
 i3 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i1 = HEAP32[i3 + 32 >> 2] | 0;
  i5 = i2 + (i1 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i3, i9);
  i5 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i8 = HEAP32[gb + 1157724 >> 2] | 0;
  i5 = (i5 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i5 << 3) | 0;
  i2 = HEAP32[i8 + 28 >> 2] | 0;
  i1 = HEAP32[i8 + 32 >> 2] | 0;
  i3 = i8;
 }
 i4 = i2 + (i1 << 3) | 0;
 if ((i5 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 i8 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i9 >> 2] = i6;
 i5 = i3 + 4 | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) != (HEAP32[i5 >> 2] | 0)) {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i7, i3, i9);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i1 = HEAP32[i3 + 32 >> 2] | 0;
  i4 = (i4 | 0) == -1 ? i2 + (i1 << 3) | 0 : i2 + (i4 << 3) | 0;
 }
 if ((i4 | 0) != (i2 + (i1 << 3) | 0)) {
  i6 = i3 + 12 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i7;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  HEAP8[i3 + 48 >> 0] = 1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 63304 | 0);
 STACKTOP = i10;
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 16 >> 2] = HEAP32[i2 >> 2];
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo(i10, HEAP32[i3 + 24 >> 2] | 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 296 | 0;
 HEAP32[i9 >> 2] = i3;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i9, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN8GUIStyle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 296 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i9 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i8 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i7, i9);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i11;
 return;
}

function __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE(i15, i11, i1, i12, i13, i14, i16) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i9) return;
 i10 = i1 + 36 | 0;
 i5 = i1 + 12 | 0;
 i6 = i11 + i14 | 0;
 i8 = 0;
 do {
  i7 = HEAP32[i10 >> 2] | 0;
  i4 = i7 + (i8 << 5) | 0;
  i3 = i7 + (i8 << 5) + 24 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do if (!(i2 & 5)) {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i2 & 256) {
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) break;
    if (_strcmp(i2, gb + 753365 | 0) | 0) break;
    i1 = __ZN5physx2Sn5ConvX11getTypeNameEPKci(i15, i1, HEAP32[i6 >> 2] | 0) | 0;
    i2 = (_strcmp(i1, gb + 753407 | 0) | 0) == 0;
    if (!(i2 | (_strcmp(i1, gb + 753383 | 0) | 0) == 0)) break;
    i2 = HEAP32[i3 >> 2] | 0;
   }
   if (i2 & 16 | 0) {
    i3 = i12 + ((HEAP32[i13 >> 2] | 0) * 36 | 0) | 0;
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
    HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
    HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
    HEAP32[i12 + ((HEAP32[i13 >> 2] | 0) * 36 | 0) + 32 >> 2] = (HEAP32[i7 + (i8 << 5) + 8 >> 2] | 0) + i14;
    HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
    break;
   }
   if (!(i2 & 8)) {
    i1 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i15, i1, i16) | 0;
    if (i1 | 0) if (!(HEAP32[i1 + 4 >> 2] & 1 | HEAP32[i1 >> 2])) __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE(i15, i11, i1, i12, i13, (HEAP32[i7 + (i8 << 5) + 8 >> 2] | 0) + i14 | 0, i16);
   }
  } while (0);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i9 | 0));
 return;
}

function __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 28 | 0;
 i6 = i9;
 i7 = i8 + 488 | 0;
 __ZN22DeviceStencilStateGLESC2ERK15GfxStencilState(i6, i1);
 i2 = i8 + 492 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((_memcmp(i6, i2, 12) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((_memcmp(i2, i6, 12) | 0) >= 0) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  i8 = i8 + 16 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = __Znwj(44) | 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 492 >> 2] | 0, i1);
 i8 = i8 + 496 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 16 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8WindZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i1);
 i7 = i9 + 36 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i10 = i1 + 16 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i8 = i1 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 i1 = i9 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 }
}

function __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDeviceii9TextureIDiiiiiiii(i7, i8, i1, i2, i13, i3, i4, i5, i6, i14, i9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i12 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0, f19 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i15 + 56 | 0;
 i16 = i15 + 40 | 0;
 i12 = i15;
 f19 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
 f18 = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
 HEAPF32[i16 >> 2] = Math_fround(f19 * Math_fround(i3 | 0));
 HEAPF32[i16 + 4 >> 2] = Math_fround(f18 * Math_fround(i4 | 0));
 HEAPF32[i16 + 8 >> 2] = Math_fround(f19 * Math_fround(i5 | 0));
 HEAPF32[i16 + 12 >> 2] = Math_fround(f18 * Math_fround(i6 | 0));
 HEAP32[i12 >> 2] = i8;
 i6 = i12 + 4 | 0;
 HEAP8[i6 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 168 >> 2] | 0, i8 | 0) | 0) & 1;
 i1 = i12 + 8 | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 172 >> 2] | 0, i1 | 0, i8 | 0);
 i5 = i12 + 24 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 156 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0;
 HEAP32[i17 >> 2] = i14;
 HEAP32[i17 + 8 >> 2] = i10;
 HEAP32[i17 + 4 >> 2] = i9;
 HEAP32[i17 + 12 >> 2] = i11;
 mftCall_vii(i3 | 0, i4 | 0, i17 | 0);
 i14 = HEAP32[i12 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 164 >> 2] | 0, i14 | 0);
 __ZL19BlitFramebufferImplRN4gles23BlitFramebufferDrawQuadER9GfxDevice9TextureIDRK8Vector4f(i7, i8, HEAP32[i13 >> 2] | 0, i16);
 i14 = HEAP32[i12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 152 >> 2] | 0, i14 | 0, i5 | 0);
 if (!(HEAP8[i6 >> 0] | 0)) {
  STACKTOP = i15;
  return;
 }
 i17 = HEAP32[i12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 160 >> 2] | 0, i17 | 0, i1 | 0);
 STACKTOP = i15;
 return;
}

function __ZN22RenderingCommandBufferD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 HEAP32[i7 >> 2] = gb + 56592 + 8;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP8[i7 + 36 >> 0] = 0;
 i8 = i7 + 40 | 0;
 i5 = i7 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  i3 = i1;
  while (1) {
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (!i2) i1 = i3; else {
    i3 = i2 + 4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
    if (!(HEAP32[i3 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
     i1 = HEAP32[i8 >> 2] | 0;
    }
    HEAP32[i1 + (i4 << 2) >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= i1 >>> 0) break; else i3 = i1;
  }
 }
 i2 = i7 + 56 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7 + 44 | 0);
  HEAP32[i8 >> 2] = 0;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i7 + 164 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i7 + 176 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 i1 = i7 + 80 | 0;
 if ((HEAP32[i7 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 60 | 0;
 if ((HEAP32[i7 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  i8 = i7 + 8 | 0;
  __ZN14GrowableBufferD2Ev(i8);
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7 + 44 | 0);
 HEAP32[i8 >> 2] = 0;
 i8 = i7 + 8 | 0;
 __ZN14GrowableBufferD2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig10UnregisterERNS_7Connect13ConfigHandlerE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 16 | 0;
 i10 = i12;
 if (!(HEAP8[i8 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i11 = i10 + 11 | 0;
 HEAP8[i11 >> 0] = 9;
 i2 = i10;
 i3 = gb + 1042554 | 0;
 i4 = i2 + 9 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i10 + 9 >> 0] = 0;
 i6 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i1, i10) | 0;
 i7 = i6 + 768 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 1001 | 0)) {
    i4 = i6 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L4;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if ((HEAP8[i11 >> 0] | 0) < 0) {
  i11 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 }
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer17RestoreEventQueueERK8UnityStrS4_Pvy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 2176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 1096 | 0;
 i8 = i9 + 36 | 0;
 i12 = i9 + 12 | 0;
 i10 = i9 + 24 | 0;
 i11 = i9;
 __ZN12FileAccessorC2Ev(i7);
 i13 = HEAP8[i2 + 11 >> 0] | 0;
 i15 = i13 << 24 >> 24 < 0;
 i14 = i15 ? HEAP32[i2 >> 2] | 0 : i2;
 i13 = i15 ? HEAP32[i2 + 4 >> 2] | 0 : i13 & 255;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, i14, i13);
 i13 = HEAP8[i3 + 11 >> 0] | 0;
 i14 = i13 << 24 >> 24 < 0;
 i2 = i14 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i14 ? HEAP32[i3 + 4 >> 2] | 0 : i13 & 255;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i11, i2, i3);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i12, i10, i11);
 __ZN15FileSystemEntryC2EPKc(i8, (HEAP8[i12 + 11 >> 0] | 0) < 0 ? HEAP32[i12 >> 2] | 0 : i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i12);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i11);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i7, i8, 0, 1) | 0)) {
  i15 = 0;
  __ZN13FileEntryDataD2Ev(i8);
  __ZN12FileAccessorD2Ev(i7);
  STACKTOP = i9;
  return i15 | 0;
 }
 i15 = __ZN11UnityEngine15CloudWebService17SessionEventQueue15RestoreFromFileER12FileAccessorPvy(i1 + 68 | 0, i7, i4, i5, i6) | 0;
 __ZN12FileAccessor5CloseEv(i7) | 0;
 __ZN13FileEntryDataD2Ev(i8);
 __ZN12FileAccessorD2Ev(i7);
 STACKTOP = i9;
 return i15 | 0;
}

function __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalRotationiR11Quaternionf(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 32 | 0;
 i7 = i11 + 16 | 0;
 i8 = i11;
 if (!(__Z12GetIVRDevicev() | 0)) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i11;
  return;
 }
 i9 = __Z12GetIVRDevicev() | 0;
 i3 = __ZN8VRDevice33VRNodeToTrackedNodeNameDeprecatedEi(i1) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i10 = 5;
 } else if (i4 >>> 0 < 11) {
  i1 = i8 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i8; else {
   i2 = i8;
   i10 = 7;
  }
 } else i10 = 5;
 if ((i10 | 0) == 5) {
  i12 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i1 = i8 + 11 | 0;
  i10 = 7;
 }
 if ((i10 | 0) == 7) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZNK8VRDevice16GetLocalRotationERK8UnityStr(i7, i9, i8);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i8 >> 2] | 0;
  i10 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i6);
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i4 = i2 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 32 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i2 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i4 = i2 + 68 | 0;
  HEAP32[i2 + 84 >> 2] = 0;
  HEAP32[i2 + 104 >> 2] = 0;
  HEAP32[i2 + 108 >> 2] = 0;
  HEAP32[i2 + 112 >> 2] = 0;
  HEAP32[i2 + 128 >> 2] = 0;
  HEAP32[i2 + 132 >> 2] = 0;
  HEAP32[i2 + 136 >> 2] = 0;
  HEAP32[i2 + 148 >> 2] = 0;
  HEAP32[i2 + 152 >> 2] = 0;
  HEAP32[i2 + 144 >> 2] = i2 + 148;
  HEAP32[i2 + 64 >> 2] = 1;
  HEAP32[i2 + 140 >> 2] = 8;
  HEAP32[i2 + 88 >> 2] = 0;
  HEAP32[i2 + 92 >> 2] = 0;
  HEAP32[i2 + 96 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAPF32[i2 + 116 >> 2] = Math_fround(-3402823469999999843913219.0e14);
  HEAPF32[i2 + 120 >> 2] = Math_fround(3402823469999999843913219.0e14);
  i2 = (HEAP32[i3 >> 2] | 0) + 156 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN19SkinnedMeshRenderer13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 508 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = __Z12GetGfxDevicev() | 0;
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 300 >> 2] | 0, i3 | 0) | 0;
 }
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv(i4);
 i1 = i4 + 472 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 do if (!(HEAP8[i4 + 467 >> 0] | 0)) {
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN8Renderer16TransformChangedEi(i4, 75);
   return;
  }
 } else {
  i3 = i1 & (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0);
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(i3 ^ (i1 | 0) != 0)) {
   __ZN8Renderer16TransformChangedEi(i4, 75);
   return;
  }
  if (!i3) {
   if (i1 | 0) break;
   __ZN8Renderer16TransformChangedEi(i4, 75);
   return;
  }
  if ((i2 | 0) == (gb + 1161628 | 0)) {
   __ZN8Renderer16TransformChangedEi(i4, 75);
   return;
  }
  if (!i1) i1 = i4 + 528 | 0; else {
   i3 = i4 + 528 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[gb + 1161628 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = gb + 1161628;
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  __ZN8Renderer16TransformChangedEi(i4, 75);
  return;
 } while (0);
 i3 = i4 + 528 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN8Renderer16TransformChangedEi(i4, 75);
 return;
}

function __ZN15NavMeshObstacleC2ER10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 169040 + 8;
 i3 = i1 + 44 | 0;
 i6 = i1 + 80 | 0;
 i5 = i1 + 92 | 0;
 i2 = i1 + 120 | 0;
 HEAP32[i1 + 36 >> 2] = -1;
 HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(1.0);
 HEAP32[i2 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 HEAPF32[i1 + 132 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 136 >> 2] = 8;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 1;
 HEAPF32[i1 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.5);
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 72 >> 2] = Math_fround(.100000001);
 HEAP8[i1 + 69 >> 0] = 1;
 HEAP8[i1 + 68 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN13DrawImmediate6VertexEfff(i10, f2, f3, f4) {
 i10 = i10 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) return;
 i12 = i10 + 36 | 0;
 HEAPF32[i10 + 36 >> 2] = f2;
 HEAPF32[i10 + 40 >> 2] = f3;
 HEAPF32[i10 + 44 >> 2] = f4;
 HEAP32[i11 >> 2] = i1 + 88;
 i6 = i12;
 i7 = i1 + 88 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i1 | 0) < (i7 | 0));
 i9 = i10 + 216 | 0;
 i5 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
 HEAP32[i9 >> 2] = i5;
 if (i5 >>> 0 <= 766) return;
 i8 = i10 + 212 | 0;
 if ((i5 | 0) == 767 & (HEAP32[i8 >> 2] | 0) == 1) {
  i1 = i10 + 124 | 0;
  i6 = i12;
  i7 = i1 + 88 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   i1 = i1 + 4 | 0;
   i6 = i6 + 4 | 0;
  } while ((i1 | 0) < (i7 | 0));
 }
 if ((i5 | 0) != 768) return;
 __ZN13DrawImmediate11FlushBufferEv(i10);
 i1 = HEAP32[i10 >> 2] | 0;
 i6 = i1 + 4512 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  if (!(HEAP32[i6 >> 2] | 0)) HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 896 >> 2] | 0, i1 | 0) | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i10 + 20 | 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 HEAP32[i10 + 28 >> 2] = -1;
 HEAP32[i10 + 32 >> 2] = 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 88, 768, 0, HEAP32[i8 >> 2] | 0, i1 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i11 >> 2] = i1;
 } else i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i8 >> 2] | 0) != 1) return;
 HEAP32[i11 >> 2] = i1 + 88;
 i6 = i10 + 124 | 0;
 i7 = i1 + 88 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i1 | 0) < (i7 | 0));
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i11 >> 2] = i1 + 88;
 i6 = i12;
 i7 = i1 + 88 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i1 | 0) < (i7 | 0));
 HEAP32[i9 >> 2] = 2;
 return;
}

function __Z24RegisterModuleClasses_UIv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1107;
 HEAP32[i2 + 8 >> 2] = gb + 1011618;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 222;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 187020;
 HEAP32[i2 + 44 >> 2] = fb + 352;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 353;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 1106;
 HEAP32[i2 + 8 >> 2] = gb + 1011545;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 225;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 186852;
 HEAP32[i2 + 44 >> 2] = fb + 350;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 351;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 1105;
 HEAP32[i2 + 8 >> 2] = gb + 1012675;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 223;
 HEAP32[i2 + 20 >> 2] = 444;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67128;
 HEAP32[i2 + 44 >> 2] = fb + 348;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 349;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z12NHxRoughnessIhEvP9Texture2DPT_iiii(i2, i6, i7, i4, i8, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var f1 = f0, f3 = f0, f9 = f0;
 f9 = Math_fround(+Math_pow(+Math_fround(Math_fround(i7 | 0) / Math_fround(Math_fround(i8 | 0) + Math_fround(-1.0))), .25));
 f3 = Math_fround(Math_fround(i4 | 0) / Math_fround(Math_fround(i5 | 0) + Math_fround(-.5)));
 f1 = Math_fround(Math_fround(10.0) / Math_fround(_log2f(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(.967999994)) + Math_fround(.0299999993)))));
 f1 = Math_fround(Math_fround(f1 * f1) * Math_fround(.25));
 f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, +f1)) * Math_fround(Math_fround(f1 + Math_fround(2.0)) / Math_fround(6.28318548))) / Math_fround(445.721954));
 i5 = f1 < Math_fround(0.0);
 f1 = i5 ? Math_fround(0.0) : f1;
 i5 = f1 > Math_fround(1.0);
 f1 = i5 ? Math_fround(1.0) : f1;
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 if ((i8 + -1 | 0) > (i7 | 0) | !(f3 <= Math_fround(.0500000007))) {
  f3 = f1;
  f3 = Math_fround(f3 * Math_fround(255.0));
  f3 = Math_fround(f3 + Math_fround(.5));
  i8 = f3 >= Math_fround(0.0);
  f9 = Math_fround(f3 + Math_fround(-.99999994));
  f9 = i8 ? f3 : f9;
  i8 = ~~f9;
  i8 = i8 & 255;
  HEAP8[i6 >> 0] = i8;
  return;
 }
 f3 = Math_fround(Math_fround(f3 / Math_fround(.0500000007)) * f1);
 f3 = Math_fround(f3 * Math_fround(255.0));
 f3 = Math_fround(f3 + Math_fround(.5));
 i8 = f3 >= Math_fround(0.0);
 f9 = Math_fround(f3 + Math_fround(-.99999994));
 f9 = i8 ? f3 : f9;
 i8 = ~~f9;
 i8 = i8 & 255;
 HEAP8[i6 >> 0] = i8;
 return;
}

function __ZNK17AnimationCurveTplIfE20EvaluateWithoutCacheEfRf(i3, f1, i8) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i8 = i8 | 0;
 var i2 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 4 | 0;
 i5 = i10;
 if ((HEAP32[i3 + 68 >> 2] | 0) == 1) {
  HEAP32[i8 >> 2] = HEAP32[(HEAP32[i3 + 56 >> 2] | 0) + 4 >> 2];
  STACKTOP = i10;
  return;
 }
 f6 = Math_fround(__ZNK17AnimationCurveTplIfE8WrapTimeEf(i3, f1));
 __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_(i3, i3, f6, i2, i5);
 i2 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i3 + 56 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i7 + (i5 << 4) >> 2]);
 f1 = Math_fround(HEAPF32[i7 + (i2 << 4) >> 2]);
 f4 = Math_fround(f4 - f1);
 if (f4 != Math_fround(0.0)) {
  f6 = Math_fround(Math_fround(f6 - f1) / f4);
  i3 = i7 + (i2 << 4) + 12 | 0;
  f11 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
  f1 = Math_fround(f4 * Math_fround(HEAPF32[i7 + (i5 << 4) + 8 >> 2]));
  f4 = f11;
 } else {
  f6 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i3 = i7 + (i2 << 4) + 12 | 0;
 }
 i2 = i7 + (i2 << 4) + 4 | 0;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(f6 * f6);
 f15 = Math_fround(f6 * f14);
 f12 = Math_fround(f15 * Math_fround(2.0));
 f11 = Math_fround(f14 * Math_fround(3.0));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(HEAPF32[i7 + (i5 << 4) + 4 >> 2]) * Math_fround(f11 - f12)) + Math_fround(Math_fround(f1 * Math_fround(f15 - f14)) + Math_fround(Math_fround(f4 * Math_fround(f6 + Math_fround(f15 - Math_fround(f14 * Math_fround(2.0))))) + Math_fround(f13 * Math_fround(Math_fround(f12 - f11) + Math_fround(1.0))))));
 if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(inf)) i9 = 8; else if (Math_fround(HEAPF32[i7 + (i5 << 4) + 8 >> 2]) == Math_fround(inf)) i9 = 8;
 if ((i9 | 0) == 8) HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 STACKTOP = i10;
 return;
}

function __ZN8WindZone8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1);
 i6 = i8 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i7 = i1 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i5 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
  i1 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i5;
  i4 = i5;
 }
 HEAP32[i6 >> 2] = i1;
 i1 = i8 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i8 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __ZN8JSONRead8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlagsb(i13, i5, i2, i4, i1) {
 i13 = i13 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i13 + 36 | 0;
 HEAP8[i11 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i13 >> 2] & 2 | 0) == 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i13 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  if (!i9) {
   STACKTOP = i12;
   return;
  }
  if ((HEAP32[i9 + 16 >> 2] | 0) != 3) {
   STACKTOP = i12;
   return;
  }
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i13, i9, i2) | 0;
 HEAP32[i8 >> 2] = i3;
 i6 = i13 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 if (!i1) {
  i2 = gb + 1033805 | 0;
  i1 = i3;
 } else {
  i2 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i2;
 if (i1 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i13, i4);
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 + 20 >> 2] = i13;
  i4 = i5 + 4 | 0;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = i3;
  i4 = i3 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = i3 + 8 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i3 = i3 + 12 | 0;
   do {
    i14 = i1 + 64 | 0;
    HEAP32[i4 >> 2] = i14;
    HEAP32[i3 >> 2] = i2 - i14 >> 6;
    mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i10 | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP8[i11 >> 0] = 1;
  i14 = i13 + 56 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 }
 HEAP32[i8 >> 2] = i9;
 HEAP32[i6 >> 2] = i7;
 STACKTOP = i12;
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i3 = i5 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i7 + 4;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i8 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags(i5, i8, 0);
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i8 >> 2] = i7 + 12;
 HEAP32[i8 + 4 >> 2] = i7 + 8;
 HEAP32[i8 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i5, i8, 0);
 i2 = i7 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 48, 4) | 0;
  i3 = i1;
  i4 = i3 + 48 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i6 = i2;
  i1 = i1 | 0 ? i1 - i6 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i6;
 }
 __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + i2 | 0, i5);
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i5 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i7 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i7 + 24 | 0;
 i2 = i5 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 1);
  i8 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i7;
  HEAP32[i6 >> 2] = i2;
  i8 = i7;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx2Sn16writeStrideFlagsINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEPFRKS5_PS6_jEEEvRNS_9XmlWriterERNS_12MemoryBufferEjRNS_16PxStrideIteratorIKT_EET0_jPKcPKNS_11PxU32ToNameE(i16, i15, i12, i11, i1, i10, i13, i14) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i17 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 if (!i10) {
  STACKTOP = i9;
  return;
 }
 i5 = i11 + 4 | 0;
 i8 = 0;
 do {
  i4 = HEAP16[(HEAP32[i11 >> 2] | 0) + (Math_imul(HEAP32[i5 >> 2] | 0, i8) | 0) >> 1] | 0;
  i6 = i4 & 65535;
  if (i4 << 16 >> 16) {
   i1 = HEAP32[i14 >> 2] | 0;
   if (i1 | 0) {
    i3 = i14;
    i2 = 0;
    i4 = 0;
    do {
     do if (HEAP32[i14 + (i4 << 3) + 4 >> 2] & i6) {
      if (i2) {
       mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, gb + 1087697 | 0, 1) | 0;
       i1 = HEAP32[i3 >> 2] | 0;
       if (!i1) {
        i2 = 1;
        break;
       }
      }
      if (!(HEAP8[i1 >> 0] | 0)) i2 = 1; else {
       i2 = HEAP32[HEAP32[i15 >> 2] >> 2] | 0;
       mftCall_iiii(i2 | 0, i15 | 0, i1 | 0, _strlen(i1) | 0) | 0;
       i2 = 1;
      }
     } while (0);
     i4 = i4 + 1 | 0;
     i3 = i14 + (i4 << 3) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    } while ((i1 | 0) != 0);
   }
  }
  if (!i8) i17 = 14; else if (!((i8 >>> 0) % (i12 >>> 0) | 0)) mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, gb + 673156 | 0, 4) | 0; else i17 = 14;
  if ((i17 | 0) == 14) {
   i17 = 0;
   mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, gb + 1086395 | 0, 1) | 0;
  }
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i10 | 0));
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i15 >> 2] >> 2] | 0, i15 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i16 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i13 | 0, HEAP32[i15 + 20 >> 2] | 0);
 HEAP32[i15 + 16 >> 2] = 0;
 HEAP32[i15 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN17BillboardRenderer21UpdateCachedBillboardEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i6 + 344 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = i6 + 360 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 172 >> 2] | 0, i6 | 0);
 i3 = i6 + 348 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i6 + 352 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 40 | 0;
 if ((i3 | 0) == (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = i6 + 352 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
 STACKTOP = i7;
 return;
}

function __ZN15DirectorManager25RemoveControllerFromArrayERNSt3__26vectorI20ProcessFrameJobGroupNS0_9allocatorIS2_EEEEP18PlayableController(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((HEAP32[i9 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = 0;
 do {
  i6 = i1 + (i7 * 24 | 0) + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  L6 : do if (i2 | 0) {
   i5 = i1 + (i7 * 24 | 0) + 4 | 0;
   i4 = 0;
   i1 = i2;
   do {
    while (1) {
     i2 = HEAP32[i5 >> 2] | 0;
     i3 = i2 + (i4 * 24 | 0) | 0;
     if ((HEAP32[i3 >> 2] | 0) != (i12 | 0)) break;
     i1 = i2 + ((i1 + -1 | 0) * 24 | 0) | 0;
     HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
     HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
     HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
     HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
     HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
     HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
     HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
     HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
     HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
     HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
     HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
     HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
     HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
     HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
     HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
     HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
     i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
     HEAP32[i6 >> 2] = i1;
     if (i4 >>> 0 >= i1 >>> 0) break L6;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i1 >>> 0);
  } while (0);
  i7 = i7 + 1 | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 } while (i7 >>> 0 < (((HEAP32[i9 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_119PvdConnectionReader7executeEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 4 | 0;
 i8 = i1;
 i9 = i2 + 4 | 0;
 i5 = i2 + 12 | 0;
 if ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) != 1) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0);
 i6 = HEAP32[i2 + 16 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 if (!i6) {
  STACKTOP = i1;
  return;
 }
 i3 = i2 + 20 | 0;
 i4 = i2 + 8 | 0;
 do {
  if (!(HEAP8[i3 >> 0] | 0)) break;
  i1 = (mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i8 | 0, 4) | 0) == 0;
  if (!i1) break;
  if (!(HEAP32[i8 >> 2] | 0)) {
   HEAP32[i7 >> 2] = 0;
   i1 = (mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i7 | 0, 4) | 0) == 0;
   L13 : do if (i1) switch (HEAP32[i7 >> 2] | 0) {
   case 1:
    {
     i2 = HEAP32[i5 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == 1) break L13;
     HEAP32[i2 >> 2] = 1;
     __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0);
     break L13;
    }
   case 2:
    {
     if ((HEAP32[HEAP32[i5 >> 2] >> 2] | 0) != 1) break L13;
     __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0);
     HEAP32[HEAP32[i5 >> 2] >> 2] = 2;
     break L13;
    }
   default:
    {
     i2 = HEAP32[i5 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == 1) break L13;
     HEAP32[i2 >> 2] = 1;
     __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0);
     break L13;
    }
   } while (0);
  } else HEAP8[i3 >> 0] = 0;
 } while (i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == 1) {
  i8 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd10ThreadImpl4quitEv(i8);
 }
 HEAP32[i1 >> 2] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0);
 i9 = HEAP32[i9 >> 2] | 0;
 __ZN5physx6shdfnd10ThreadImpl4quitEv(i9);
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (!i5) i3 = i2; else {
    i3 = i2;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i3 + i5 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i1 = i6 + 28 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 28 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else i6 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZNK12ShaderErrors11ShaderErrorltERKS0_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i1 = HEAP8[i10 + 56 >> 0] | 0;
 i2 = HEAP8[i11 + 56 >> 0] | 0;
 if (i1 << 24 >> 24 != i2 << 24 >> 24) {
  i12 = (i1 & 255) < (i2 & 255);
  return i12 | 0;
 }
 i7 = i10 + 32 | 0;
 i8 = i11 + 32 | 0;
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) i1 = HEAP32[i10 + 36 >> 2] | 0; else i1 = i4 & 255;
 i9 = HEAP8[i8 + 11 >> 0] | 0;
 i6 = i9 << 24 >> 24 < 0;
 i9 = i6 ? HEAP32[i11 + 36 >> 2] | 0 : i9 & 255;
 if ((i1 | 0) == (i9 | 0)) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i5) {
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = i6 ? i1 : i8;
   i2 = HEAP32[i10 + 36 >> 2] | 0;
  } else {
   i3 = i7;
   i1 = i6 ? i1 : i8;
   i2 = i4 & 255;
  }
  if (!(_strncmp(i3, i1, i2) | 0)) {
   i1 = HEAP32[i10 + 52 >> 2] | 0;
   i2 = HEAP32[i11 + 52 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i12 = (i1 | 0) < (i2 | 0);
    return i12 | 0;
   }
   i1 = HEAP32[i10 + 48 >> 2] | 0;
   i2 = HEAP32[i11 + 48 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i12 = (i1 | 0) < (i2 | 0);
    return i12 | 0;
   }
   i4 = HEAP8[i10 + 11 >> 0] | 0;
   i2 = i4 << 24 >> 24 < 0;
   i4 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
   i5 = HEAP8[i11 + 11 >> 0] | 0;
   i3 = i5 << 24 >> 24 < 0;
   i5 = i3 ? HEAP32[i11 + 4 >> 2] | 0 : i5 & 255;
   i6 = i5 >>> 0 < i4 >>> 0;
   i1 = i6 ? i5 : i4;
   if (!i1) i12 = 21; else {
    i1 = _memcmp(i2 ? HEAP32[i10 >> 2] | 0 : i10, i3 ? HEAP32[i11 >> 2] | 0 : i11, i1) | 0;
    if (!i1) i12 = 21;
   }
   if ((i12 | 0) == 21) i1 = i4 >>> 0 < i5 >>> 0 ? -1 : i6 & 1;
   i12 = (i1 | 0) < 0;
   return i12 | 0;
  }
 }
 i2 = i5 ? HEAP32[i10 + 36 >> 2] | 0 : i4 & 255;
 i3 = i9 >>> 0 < i2 >>> 0;
 i1 = i3 ? i9 : i2;
 if (!i1) i12 = 13; else {
  i1 = _memcmp(i5 ? HEAP32[i7 >> 2] | 0 : i7, i6 ? HEAP32[i8 >> 2] | 0 : i8, i1) | 0;
  if (!i1) i12 = 13;
 }
 if ((i12 | 0) == 13) i1 = i2 >>> 0 < i9 >>> 0 ? -1 : i3 & 1;
 i12 = (i1 | 0) < 0;
 return i12 | 0;
}

function __ZNK11SoundHandle8Instance21GetMemoryInfoInternalEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i3 = i7;
 i5 = i7 + 36 | 0;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 if ((HEAP32[i2 + 44 >> 2] | 0) != 3) {
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = i6 + 128 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i1) {
  i1 = __ZN4FMOD5Sound13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(HEAP32[i2 + 40 >> 2] | 0, -1, 0, i6, 0) | 0;
  if (!i1) {
   i6 = HEAP32[i6 >> 2] | 0;
   i6 = i6 + 128 | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 343;
  HEAP32[i4 + 8 >> 2] = gb + 872757;
  HEAP32[i4 + 12 >> 2] = i3;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = i6 + 128 | 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  i1 = __ZN4FMOD5Sound13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, -1, 0, i6, 0) | 0;
  if (!i1) {
   i6 = HEAP32[i6 >> 2] | 0;
   i6 = i6 + 128 | 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i3 >> 2] = gb + 853741;
  HEAP32[i3 + 4 >> 2] = 341;
  HEAP32[i3 + 8 >> 2] = gb + 872703;
  HEAP32[i3 + 12 >> 2] = i4;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = i6 + 128 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN5Umbra13MatrixFactory13transformBaseERKNS_7Vector3ES3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0;
 i13 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = i13;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = i12;
 i10 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i10;
 f9 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f9 * f8);
 f11 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(f9 + Math_fround(f11 * f7));
 f9 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 HEAPF32[i1 + 12 >> 2] = Math_fround(-Math_fround(f11 + Math_fround(f9 * f6)));
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = i10;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i1 + 20 >> 2] = i4;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
 f9 = Math_fround(f9 + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
 HEAPF32[i1 + 28 >> 2] = Math_fround(-Math_fround(f9 + Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f6)));
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = i2;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = i4;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = i5;
 f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f8);
 f7 = Math_fround(f8 + Math_fround((HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
 HEAPF32[i1 + 44 >> 2] = Math_fround(-Math_fround(f7 + Math_fround((HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f6)));
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = -1;
   HEAP32[i2 + 8 >> 2] = -1;
   i3 = i2 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i2 + 32 >> 2] = -1;
   HEAPF32[i2 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
   HEAP8[i2 + 44 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 52 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 56 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 60 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z40Camera_CUSTOM_INTERNAL_CALL_RaycastTry2DP12Il2CppObjectRK3Rayfi(i11, i2, f12, i1) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 f12 = Math_fround(f12);
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 40 | 0;
 i9 = i13;
 i10 = __Z13GetIPhysics2Dv() | 0;
 if (f12 < Math_fround(1.1920929e-07) | (i10 | 0) == 0) {
  i11 = 0;
  STACKTOP = i13;
  return i11 | 0;
 }
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f5 * f5));
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(Math_sqrt(Math_fround(f7 + Math_fround(f6 * f6))));
 if (f7 <= Math_fround(HEAPF32[gb + 62452 >> 2])) {
  i11 = 0;
  STACKTOP = i13;
  return i11 | 0;
 }
 f4 = Math_fround(f4 / f7);
 f5 = Math_fround(f5 / f7);
 f7 = Math_fround(f6 / f7);
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i8 + 12 >> 2] = f4;
 HEAPF32[i8 + 16 >> 2] = f5;
 HEAPF32[i8 + 20 >> 2] = f7;
 i3 = HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0;
 if (!i11) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i1) {
  i2 = i11;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 880 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 if (mftCall_iiifii(i3 | 0, i10 | 0, i8 | 0, +f12, i1 & -5 & HEAP32[i2 + 884 >> 2] | 0, i9 | 0) | 0) {
  i1 = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i9 | 0) | 0;
  if (i1 | 0) {
   i11 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
   STACKTOP = i13;
   return i11 | 0;
  }
 }
 i11 = 0;
 STACKTOP = i13;
 return i11 | 0;
}

function __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 2;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 2 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 2;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i10 | 0) >>> 2) << 2);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 1;
 i1 = i10 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 1073741823;
 if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 2) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 2);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 2);
 return;
}

function __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEE25__construct_node_with_keyERSE_(i11, i1, i5) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i1 + 8 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = 5;
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 i10 = i8;
 i2 = i8 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i8 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i8 + 40 | 0;
 i6 = i5 + 24 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = i8 + 20 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i2 | 0) != (i5 | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  i13 = (i6 | 0) == 0;
  i6 = i13 ? i5 + 4 | 0 : i6;
  i7 = HEAP32[i5 + 20 >> 2] | 0;
  if (!((HEAP32[i5 + 4 >> 2] | 0) != 0 | i13)) {
   HEAP32[i2 >> 2] = i6;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i7 >>> 0 > 15) {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i2 >> 2] = i13;
   HEAP32[i1 >> 2] = i7;
   i1 = (i13 | 0) == 0 ? i1 : i13;
  }
  _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  HEAP32[i4 >> 2] = i7;
 } while (0);
 i1 = i8 + 88 | 0;
 i2 = i8 + 48 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i6 = gb + 63648 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i13 = i1;
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = i7;
 HEAP8[i8 + 68 >> 0] = 0;
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP8[i11 + 8 >> 0] = 1;
 HEAP8[i11 + 9 >> 0] = 1;
 HEAP16[i11 + 10 >> 1] = 0;
 STACKTOP = i12;
 return;
}

function __ZN7mecanim5human29HumanComputeMomentumOfInertiaEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i3 = i12 + 4 | 0;
 i4 = i12 + 8 | 0;
 f1 = Math_fround(0.0);
 i2 = 0;
 f6 = Math_fround(0.0);
 f7 = Math_fround(0.0);
 f8 = Math_fround(0.0);
 do {
  if ((HEAP32[i10 + 72 + (i2 << 2) >> 2] | 0) > -1) {
   f14 = Math_fround(HEAPF32[i10 + 168 + (i2 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i12, i10, i11, i2);
   f15 = Math_fround(HEAPF32[i12 >> 2]);
   f9 = Math_fround(HEAPF32[i3 >> 2]);
   f1 = Math_fround(f1 + f14);
   f6 = Math_fround(f6 + Math_fround(f14 * f15));
   f7 = Math_fround(f7 + Math_fround(f14 * Math_fround(HEAPF32[i4 >> 2])));
   f8 = Math_fround(f8 + Math_fround(f14 * f9));
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 24);
 f9 = Math_fround(f6 / f1);
 f8 = Math_fround(f8 / f1);
 f6 = Math_fround(f7 / f1);
 i4 = i12 + 4 | 0;
 i5 = i12 + 8 | 0;
 i3 = 0;
 f1 = Math_fround(0.0);
 do {
  i2 = HEAP32[i10 + 72 + (i3 << 2) >> 2] | 0;
  if ((i2 | 0) > -1) {
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i12, i10, i11, i2);
   f7 = Math_fround(HEAPF32[i12 >> 2]);
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f7 = Math_fround(f7 - f9);
   f14 = Math_fround(f14 - f8);
   f15 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f15 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f14 * f14)) + Math_fround(Math_fround(f15 * f15) + Math_fround(0.0)))));
   f1 = Math_fround(f1 + Math_fround(f15 * Math_fround(f15 * Math_fround(HEAPF32[i10 + 168 + (i3 << 2) >> 2]))));
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 24);
 STACKTOP = i13;
 return Math_fround(f1);
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN18AsyncUploadManager17DoScaledPaddedJobEP28FileTextureUploadInstruction(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i15 + 28 | 0;
 i12 = i15;
 i14 = i3 + 64 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i3 + 24 >> 2];
 i6 = i12 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 + 36 >> 2];
 i7 = i12 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 + 40 >> 2];
 i11 = i3 + 32 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 16 >> 2] = i1;
 HEAP32[i12 + 20 >> 2] = HEAP32[i3 + 60 >> 2];
 HEAP32[i12 + 24 >> 2] = i2 & 255;
 if ((i1 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i13 = i3 + 76 | 0;
 i8 = i3 + 104 | 0;
 i9 = i3 + 112 | 0;
 i10 = i3 + 116 | 0;
 i4 = i3 + 124 | 0;
 if ((i2 & 3932160 | 0) == 1572864) {
  i3 = 0;
  do {
   if (i2 & 255) {
    i1 = 0;
    do {
     __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i12, i13, i3, i1, 1, 0);
     i1 = i1 + 1 | 0;
     i2 = HEAP32[i14 >> 2] | 0;
    } while ((i1 | 0) < (i2 & 255 | 0));
    i1 = HEAP32[i11 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  STACKTOP = i15;
  return;
 } else i3 = 0;
 do {
  if (i2 & 255) {
   i1 = 0;
   do {
    if (!((HEAP32[i6 >> 2] | 0) == 0 | (HEAP32[i7 >> 2] | 0) == 0)) {
     __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1) | 0;
     __ZN11TextureData17GetImageReferenceEii(i5, i8, i3, i1);
     __ZN9TextureOpI11TextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i12, i5, 2, 1, i3) | 0;
    }
    __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb(i12, i13, i3, i1, 1, 0);
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i14 >> 2] | 0;
   } while ((i1 | 0) < (i2 & 255 | 0));
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 STACKTOP = i15;
 return;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream7executeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = i1 + 8 | 0;
 if (__ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv(HEAP32[i17 >> 2] | 0) | 0) {
  i16 = HEAP32[i17 >> 2] | 0;
  __ZN5physx6shdfnd10ThreadImpl4quitEv(i16);
 }
 i10 = i1 + 100 | 0;
 i11 = i1 + 96 | 0;
 i12 = i1 + 116 | 0;
 i13 = i1 + 88 | 0;
 i14 = i1 + 16 | 0;
 i15 = i1 + 72 | 0;
 i16 = i1 + 68 | 0;
 i6 = i1 + 92 | 0;
 i7 = i1 + 56 | 0;
 i8 = i1 + 60 | 0;
 i9 = i1 + 32 | 0;
 i5 = i1 + 36 | 0;
 while (1) {
  i4 = HEAP32[i10 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0)) {
   i1 = 13;
   break;
  }
  if (__ZN5physx6shdfnd8SyncImpl4waitEj(HEAP32[i11 >> 2] | 0, 100) | 0) {
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i12 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i13 >> 2] | 0);
   i3 = HEAP32[i15 >> 2] | 0;
   i1 = (HEAP32[i16 >> 2] | 0) - i3 + (HEAP32[i14 >> 2] | 0) | 0;
   if (!i1) {
    __ZN5physx6shdfnd8SyncImpl5resetEv(HEAP32[i11 >> 2] | 0);
    i2 = 0;
    i1 = 0;
   } else {
    i2 = HEAP32[i7 >> 2] | 0;
    i18 = i2 + (HEAP32[i8 >> 2] | 0) | 0;
    i4 = HEAP32[i9 >> 2] | 0;
    HEAP32[i16 >> 2] = i2;
    HEAP32[i15 >> 2] = i18;
    if ((i3 | 0) == (i18 | 0)) {
     HEAP32[i16 >> 2] = i4;
     HEAP32[i15 >> 2] = i4 + (HEAP32[i5 >> 2] | 0);
    } else i2 = i4;
   }
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i13 >> 2] | 0);
   __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i6 >> 2] | 0);
   if (i1 | 0) {
    i18 = HEAP32[i10 >> 2] | 0;
    mftCall_iiii(HEAP32[(HEAP32[i18 >> 2] | 0) + 8 >> 2] | 0, i18 | 0, i2 | 0, i1 | 0) | 0;
   }
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i12 >> 2] | 0);
  }
  if (__ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv(HEAP32[i17 >> 2] | 0) | 0) {
   i1 = 13;
   break;
  }
 }
 if ((i1 | 0) == 13) {
  i18 = HEAP32[i17 >> 2] | 0;
  __ZN5physx6shdfnd10ThreadImpl4quitEv(i18);
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN15CapsuleCollider6CreateEPK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 if (HEAP32[i1 + 36 >> 2] | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 HEAPF32[i3 >> 2] = f8;
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 i4 = HEAP32[i1 + 68 >> 2] | 0;
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i3 + (i4 << 2) >> 2]));
 i10 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i10 ? f7 : f6;
 i10 = f6 < Math_fround(9.99999974e-06);
 f6 = i10 ? Math_fround(9.99999974e-06) : f6;
 f7 = Math_fround(HEAPF32[i3 + (((i4 + 1 | 0) % 3 | 0) << 2) >> 2]);
 f8 = Math_fround(HEAPF32[i3 + (((i4 + 2 | 0) % 3 | 0) << 2) >> 2]);
 i4 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 f7 = i4 ? f9 : f7;
 i4 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i4 ? f9 : f8;
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * (f7 < f8 ? f8 : f7));
 f6 = Math_fround(f6 - Math_fround(f7 * Math_fround(2.0)));
 i4 = f6 < Math_fround(9.99999974e-06);
 f6 = i4 ? Math_fround(9.99999974e-06) : f6;
 i4 = f7 < Math_fround(9.99999974e-06);
 f7 = i4 ? Math_fround(9.99999974e-06) : f7;
 f6 = Math_fround(f6 * Math_fround(.5));
 HEAP32[i3 >> 2] = 2;
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f6;
 __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i1, i3, i2);
 STACKTOP = i5;
 return;
}

function __ZN10Matrix4x4f12SetTRInverseERK8Vector3fRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i4;
 f5 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[i3 + 4 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[i3 + 8 >> 2]));
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 HEAPF32[i9 >> 2] = f5;
 HEAPF32[i9 + 4 >> 2] = f6;
 HEAPF32[i9 + 8 >> 2] = f7;
 HEAP32[i9 + 12 >> 2] = i3;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i9, i1);
 f7 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f7);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) * f6));
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) * f5));
 i3 = i1 + 48 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f8);
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f7);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) * f6));
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) * f5));
 i3 = i1 + 52 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f8);
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f7);
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * f6));
 f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) * f5));
 i3 = i1 + 56 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f8);
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * f7);
 f6 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) * f6));
 f5 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * f5));
 i3 = i1 + 60 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f5);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx2Sq8AABBTree5buildEPNS0_15AABBTreeBuilderE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i7) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i7 + 8 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN5physx2Sq8AABBTree7releaseEv(i8);
 i6 = i7 + 24 | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i7 + 28 >> 2] = 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, HEAP32[i5 >> 2] << 2, gb + 706818 | 0, 451) | 0;
 HEAP32[i8 >> 2] = i2;
 if (!(HEAP32[i5 >> 2] | 0)) i1 = -1; else {
  i3 = 0;
  do {
   HEAP32[i2 + (i3 << 2) >> 2] = i3;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = (i1 << 1) + -1 | 0;
 }
 i4 = i1 * 24 | 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i10 | 0, i2 | 0, (i1 >>> 0 > 178956970 | i4 >>> 0 > 4294967287 ? -1 : i4 + 8 | 0) | 0, (i3 ? gb + 706891 | 0 : gb + 837976 | 0) | 0, gb + 706818 | 0, 457) | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 i4 = i3 + 8 | 0;
 i1 = i4 + (i1 * 24 | 0) | 0;
 i2 = i4;
 do {
  i10 = i2 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i2 = i2 + 24 | 0;
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i8 + 4 >> 2] = i4;
 HEAP32[i7 + 12 >> 2] = i4;
 i10 = i3 + 24 | 0;
 i1 = i10;
 i2 = HEAP32[i1 >> 2] & 2;
 i1 = HEAP32[i1 + 4 >> 2] & -256;
 i3 = _bitshift64Shl(HEAP32[i5 >> 2] | 0, 0, 2) | 0;
 i5 = i1 | (getTempRet0() | 0);
 HEAP32[gb + 1457356 >> 2] = 0;
 HEAP32[i10 >> 2] = i2 | i3 | 1;
 HEAP32[i10 + 4 >> 2] = i5;
 __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj(i4, i7, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 + 536 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 540 >> 2] = HEAP32[i7 + 16 >> 2];
 i10 = 1;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx15PxCollectionExt14releaseObjectsERNS_12PxCollectionE(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 4 | 0;
 i5 = i9;
 HEAP32[i8 >> 2] = 0;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0) {
  i4 = 0;
  do {
   i3 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, i4 | 0) | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i3;
   do if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0) | 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
     HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2] = i2;
     HEAP32[i1 >> 2] = i3 + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i5) | 0;
     break;
    }
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0) >>> 0);
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = 0;
   do {
    i5 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
    mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
  }
 }
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0) do {
  i5 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  mftCall_vii(i4 | 0, i7 | 0, mftCall_iii(HEAP32[i5 + 32 >> 2] | 0, i7 | 0, 0) | 0);
 } while ((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0) != 0);
 i7 = HEAP32[i6 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 STACKTOP = i9;
 return;
}

function __ZN14LineParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i2 = i8 + 16 | 0;
 i10 = i1 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i1 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
 __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 20 | 0, i1);
 __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 108 | 0, i1);
 i1 = i8 + 180 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 184 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i8 + 188 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i3;
  i6 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i6 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 i1 = i8 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i6 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 >> 2] = i3;
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i10 = HEAP32[i9 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
}

function __ZN12LineRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 i2 = HEAP32[i7 + 348 >> 2] | 0;
 i6 = i2 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i10 = i8 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i9 = i8 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i10 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i1 + (i5 * 12 | 0) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
   i5 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 __ZN14LineParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i7 + 344 >> 2] | 0, i8);
 i1 = i7 + 340 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  STACKTOP = i11;
  return;
 }
}

function __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, f11 = f0;
 i9 = HEAP32[i1 + 68 >> 2] | 0;
 if ((i9 | 0) < 2) return;
 do if (!i2) {
  i9 = HEAP32[i1 + 56 >> 2] | 0;
  f8 = Math_fround(HEAPF32[i9 + 16 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i9 >> 2]));
  f7 = Math_fround(HEAPF32[i9 + 20 >> 2]);
  f8 = Math_fround(Math_fround(f7 - Math_fround(HEAPF32[i9 + 4 >> 2])) / f8);
  HEAPF32[i9 + 8 >> 2] = f8;
  HEAPF32[i9 + 12 >> 2] = f8;
 } else {
  i4 = HEAP32[i1 + 56 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i4 + (i2 << 4) >> 2]);
  i10 = i2 + -1 | 0;
  f6 = Math_fround(f5 - Math_fround(HEAPF32[i4 + (i10 << 4) >> 2]));
  f7 = Math_fround(HEAPF32[i4 + (i2 << 4) + 4 >> 2]);
  f8 = Math_fround(f7 - Math_fround(HEAPF32[i4 + (i10 << 4) + 4 >> 2]));
  if ((i9 + -1 | 0) == (i2 | 0)) {
   f8 = Math_fround(f8 / f6);
   HEAPF32[i4 + (i2 << 4) + 8 >> 2] = f8;
   HEAPF32[i4 + (i2 << 4) + 12 >> 2] = f8;
   break;
  } else {
   i10 = i2 + 1 | 0;
   f5 = Math_fround(Math_fround(HEAPF32[i4 + (i10 << 4) >> 2]) - f5);
   f11 = Math_fround(Math_fround(HEAPF32[i4 + (i10 << 4) + 4 >> 2]) - f7);
   i10 = f6 < Math_fround(0.0);
   f7 = Math_fround(-f6);
   i10 = (i10 ? f7 : f6) > Math_fround(9.99999974e-06);
   f7 = Math_fround(f8 / f6);
   f7 = i10 ? f7 : Math_fround(0.0);
   i10 = f5 < Math_fround(0.0);
   f8 = Math_fround(-f5);
   i10 = (i10 ? f8 : f5) > Math_fround(9.99999974e-06);
   f8 = Math_fround(f11 / f5);
   f8 = Math_fround(Math_fround(Math_fround(Math_fround(f3 + Math_fround(1.0)) * Math_fround(.5)) * f7) + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(.5)) * (i10 ? f8 : Math_fround(0.0))));
   HEAPF32[i4 + (i2 << 4) + 8 >> 2] = f8;
   HEAPF32[i4 + (i2 << 4) + 12 >> 2] = f8;
   break;
  }
 } while (0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function _tlsf_realloc(i11, i12, i4) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = (i12 | 0) != 0;
 if (i1 & (i4 | 0) == 0) {
  _tlsf_free(i11, i12);
  i12 = 0;
  return i12 | 0;
 }
 if (!i1) {
  i12 = i4 + 3 & -4;
  i12 = (i4 + -1 | 0) >>> 0 < 1073741823 ? (i12 >>> 0 > 12 ? i12 : 12) : 0;
  i12 = _block_prepare_used(i11, _block_locate_free(i11, i12) | 0, i12) | 0;
  return i12 | 0;
 }
 i9 = i12 + -8 | 0;
 i8 = i12 + -4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i10 = i12;
 i5 = (i3 + -4 & -4) + i10 | 0;
 i3 = i3 & -4;
 i7 = i5 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i4 + 3 & -4;
 i6 = (i4 + -1 | 0) >>> 0 < 1073741823 ? (i6 >>> 0 > 12 ? i6 : 12) : 0;
 if (i6 >>> 0 > i3 >>> 0) {
  i2 = i1 & -4;
  if ((i1 & 1 | 0) == 0 | i6 >>> 0 > (i3 + 4 + i2 | 0) >>> 0) {
   i1 = _block_prepare_used(i11, _block_locate_free(i11, i6) | 0, i6) | 0;
   if (!i1) {
    i12 = 0;
    return i12 | 0;
   }
   _memcpy(i1 | 0, i12 | 0, (i3 >>> 0 < i4 >>> 0 ? i3 : i4) | 0) | 0;
   _tlsf_free(i11, i12);
   i12 = i1;
   return i12 | 0;
  }
  if (i2 >>> 0 < 128) {
   i1 = i1 >>> 2;
   i4 = 0;
  } else {
   i4 = 31 - (Math_clz32(i2 | 0) | 0) | 0;
   i1 = i2 >>> (i4 + -5 | 0) ^ 32;
   i4 = i4 + -6 | 0;
  }
  i3 = HEAP32[i5 + 12 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  HEAP32[i3 + 8 >> 2] = i2;
  i3 = i11 + 116 + (i4 << 7) + (i1 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) {
   HEAP32[i3 >> 2] = i2;
   if ((i2 | 0) == (i11 | 0)) {
    i3 = i11 + 20 + (i4 << 2) | 0;
    i5 = HEAP32[i3 >> 2] & ~(1 << i1);
    HEAP32[i3 >> 2] = i5;
    i1 = i11 + 16 | 0;
    if (!i5) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i4);
   }
  }
  i7 = ((HEAP32[i7 >> 2] | 0) + 4 & -4) + (HEAP32[i8 >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[(i7 + -4 & -4) + i10 >> 2] = i9;
  i10 = (i7 + -4 & -4) + i10 + 4 | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -3;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -2;
 }
 _block_trim_used(i11, i9, i6);
 return i12 | 0;
}

function __ZNK20TextRenderingPrivate8TextMesh7GetFontEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i2 = i7;
 i4 = i1 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i8 = i1;
     STACKTOP = i7;
     return i8 | 0;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i1 = HEAP32[gb + 1467892 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1017543 | 0, 9);
 i8 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i6) | 0;
 HEAP32[gb + 1467892 >> 2] = i8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i8 = HEAP32[gb + 1467892 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 24 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP16[i10 >> 1] | 0;
  i1 = i4 & 65535;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 8 >> 2] | 0;
   i3 = i11 + 12 | 0;
   while (1) {
    if ((HEAP16[i5 + (i2 << 3) >> 1] | 0) == i4 << 16 >> 16) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 20 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAPU16[i10 >> 1] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 36 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 8 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN19CharacterController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i5, i1 + 88 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, i5, i1 + 92 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734421 | 0, i5, i1 + 80 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734434 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734447 | 0, i5, i1 + 76 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 734459 | 0, i5, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 96 | 0, gb + 1034411 | 0, 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i12, i8, i1) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i9 = i12 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i9 >> 2] = i3;
  i3 = i7;
 }
 i1 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = (i4 - i5 | 0) / 40 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj(i1, i3 - i2 | 0);
  i4 = HEAP32[i7 >> 2] | 0;
 } else if (i3 >>> 0 < i2 >>> 0) {
  i6 = i5 + (i3 * 40 | 0) | 0;
  if ((i4 | 0) != (i6 | 0)) while (1) {
   i1 = i4 + -40 | 0;
   HEAP32[i7 >> 2] = i1;
   i3 = HEAP32[i4 + -16 >> 2] | 0;
   i5 = i3;
   if (i3) {
    i1 = i4 + -12 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i5 | 0) >>> 2) << 2);
    __ZdlPv(i3);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   if ((i1 | 0) == (i6 | 0)) {
    i4 = i6;
    break;
   } else i4 = i1;
  }
 }
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  __ZN19AssetBundleManifest15AssetBundleInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i12);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i6 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212516 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, i4 | 0, 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i7 = _strlen(i4) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i6 | 0, i4 | 0, i7 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1081852 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 4;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 4 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 4;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 4) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 4;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 4) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 4 << 4);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -16 - i2 | 0) >>> 4) << 4);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -16 - i10 | 0) >>> 4) << 4);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 3;
 i1 = i10 >> 4 >>> 0 < 134217727 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 268435455;
 if (i1 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 4) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 4);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 4);
 return;
}

function __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 24 | 0;
 i10 = i12;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i12;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 20 | 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i9 = i10 + 16 | 0;
 HEAP32[i9 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i11 >> 2] = 51;
  HEAP32[i11 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 20 | 0, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i10 >> 2] = i2;
 i1 = i2 + (i1 * 20 | 0) | 0;
 i8 = i10 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 i6 = i10 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i2 + (i4 * 20 | 0);
 __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i3, i10);
 i6 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i11 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i8 >> 2] = i2;
   i4 = HEAP32[i1 + -16 >> 2] | 0;
   i5 = i4;
   if (!i4) i1 = i2; else {
    i2 = i1 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i11 >> 2] = 51;
    HEAP32[i7 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i11);
    i1 = HEAP32[i8 >> 2] | 0;
   }
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  HEAP32[i11 >> 2] = 51;
  HEAP32[i11 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 }
 STACKTOP = i12;
 return;
}

function __ZNK7ApiGLES18GetExtensionStringEv(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i10 = i11;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i7, mftCall_ii(HEAP32[i1 + 844 >> 2] | 0, 7939) | 0) | 0;
  STACKTOP = i11;
  return;
 }
 HEAP32[i9 >> 2] = 0;
 mftCall_vii(HEAP32[i1 + 88 >> 2] | 0, 33309, i9 | 0);
 i8 = HEAP32[i9 >> 2] | 0;
 if ((i8 | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i2 = i1 + 840 | 0;
 i3 = i10 + 11 | 0;
 i4 = i10 + 4 | 0;
 i5 = i9 + 11 | 0;
 i6 = i9 + 4 | 0;
 i1 = 0;
 do {
  i13 = mftCall_iii(HEAP32[i2 >> 2] | 0, 7939, i1 | 0) | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i10, gb + 1086395 | 0, 1);
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  i14 = HEAP8[i3 >> 0] | 0;
  i15 = i14 << 24 >> 24 < 0;
  i14 = i15 ? HEAP32[i4 >> 2] | 0 : i14 & 255;
  i12 = _strlen(i13) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i9, i15 ? HEAP32[i10 >> 2] | 0 : i10, i14, i14 + i12 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i9, i13, i12) | 0;
  i12 = HEAP8[i5 >> 0] | 0;
  i13 = i12 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i7, i13 ? HEAP32[i9 >> 2] | 0 : i9, i13 ? HEAP32[i6 >> 2] | 0 : i12 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i11;
 return;
}

function __ZNK20TextRenderingPrivate7GUIText7GetFontEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i2 = i7;
 i4 = i1 + 88 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i8 = i1;
     STACKTOP = i7;
     return i8 | 0;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i1 = HEAP32[gb + 1467944 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1017543 | 0, 9);
 i8 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 64868 | 0, i6) | 0;
 HEAP32[gb + 1467944 >> 2] = i8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i8 = HEAP32[gb + 1467944 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS3_(i1, i15, i2) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i15 >>> 0) __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i15);
 i11 = HEAP32[i1 + 12 >> 2] | 0;
 i12 = i1 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + (i15 * 76 | 0) | 0;
 if ((i1 | 0) >= (i15 | 0)) {
  HEAP32[i12 >> 2] = i15;
  return;
 }
 i14 = i2 + 4 | 0;
 i3 = i2 + 12 | 0;
 i4 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 i6 = i2 + 28 | 0;
 i7 = i2 + 40 | 0;
 i8 = i2 + 44 | 0;
 i9 = i2 + 52 | 0;
 i10 = i2 + 60 | 0;
 i2 = i2 + 64 | 0;
 i1 = i11 + (i1 * 76 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = gb + 148864 + 8;
  i11 = i14;
  i16 = HEAP32[i11 + 4 >> 2] | 0;
  i17 = i1 + 4 | 0;
  HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
  i17 = i4;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i11 = i1 + 16 | 0;
  HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i11 + 4 >> 2] = i16;
  HEAP32[i1 + 24 >> 2] = HEAP32[i5 >> 2];
  i11 = i1 + 28 | 0;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i7 >> 2];
  i11 = i8;
  i16 = HEAP32[i11 + 4 >> 2] | 0;
  i17 = i1 + 44 | 0;
  HEAP32[i17 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i17 + 4 >> 2] = i16;
  i17 = i9;
  i16 = HEAP32[i17 + 4 >> 2] | 0;
  i11 = i1 + 52 | 0;
  HEAP32[i11 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i11 + 4 >> 2] = i16;
  HEAP32[i1 + 60 >> 2] = HEAP32[i10 >> 2];
  i11 = i1 + 64 | 0;
  HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i1 = i1 + 76 | 0;
 } while (i1 >>> 0 < i13 >>> 0);
 HEAP32[i12 >> 2] = i15;
 return;
}

function __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(i16, i15) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i18;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i16 >> 2] | 0);
 i5 = i15 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i17 = HEAP32[i16 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i17);
  STACKTOP = i18;
  return;
 }
 i8 = i16 + 168 | 0;
 i9 = i16 + 112 | 0;
 i10 = i16 + 120 | 0;
 i11 = i16 + 116 | 0;
 i12 = i16 + 152 | 0;
 i13 = i16 + 88 | 0;
 i6 = i16 + 96 | 0;
 i7 = i16 + 92 | 0;
 do {
  i2 = i1 + -1 | 0;
  i1 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i14 >> 2] = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i4 = i1;
  do if (i3 >>> 0 > i1 >>> 0) i17 = 8; else if ((i3 + (HEAP32[i2 + 20 >> 2] | 0) | 0) >>> 0 > i1 >>> 0) {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] = i4;
    HEAP32[i7 >> 2] = i1 + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i13, i14) | 0;
    break;
   }
  } else i17 = 8; while (0);
  if ((i17 | 0) == 8) {
   i17 = 0;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i4;
    HEAP32[i11 >> 2] = i1 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i14) | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i17 = HEAP32[i16 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i17);
 STACKTOP = i18;
 return;
}

function __ZN15MBP_PairManager12reallocPairsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 1 | 0;
 i11 = i12;
 i6 = i10 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i12 + 5 | 0, i1);
  HEAP32[i6 >> 2] = 0;
 }
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 4 | 0, HEAP32[i10 >> 2] << 2, gb + 717183 | 0, 1012) | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) i1 = 0; else {
  _memset(i1 | 0, -1, i2 << 2 | 0) | 0;
  i1 = (HEAP32[i10 >> 2] | 0) * 12 | 0;
 }
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 3 | 0, i1, gb + 717183 | 0, 1016) | 0;
 i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12 + 2 | 0, HEAP32[i10 >> 2] << 2, gb + 717183 | 0, 1017) | 0;
 i5 = i10 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  _memcpy(i7 | 0, HEAP32[i10 + 20 >> 2] | 0, i1 * 12 | 0) | 0;
  if (HEAP32[i5 >> 2] | 0) {
   i3 = HEAP32[i10 + 20 >> 2] | 0;
   i4 = i10 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = 0;
   do {
    i6 = HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] << 16 | HEAP32[i3 + (i2 * 12 | 0) >> 2] & 65535;
    i6 = i6 + ~(i6 << 15) | 0;
    i6 = (i6 >> 10 ^ i6) * 9 | 0;
    i6 = i6 >> 6 ^ i6;
    i6 = i6 + ~(i6 << 11) | 0;
    i6 = i1 + (((i6 >> 16 ^ i6) & HEAP32[i4 >> 2]) << 2) | 0;
    HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i6 >> 2];
    HEAP32[i6 >> 2] = i2;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
  }
 }
 i3 = i10 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i1);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i3 >> 2] = i8;
  STACKTOP = i12;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 STACKTOP = i12;
 return;
}

function __ZN14b2PolygonShape8SetAsBoxEffRK6b2Vec2f(i9, f1, f2, i3, f4) {
 i9 = i9 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, f14 = f0;
 i10 = i9 + 148 | 0;
 HEAP32[i10 >> 2] = 4;
 f8 = Math_fround(-f1);
 f11 = Math_fround(-f2);
 HEAPF32[i9 + 20 >> 2] = f8;
 HEAPF32[i9 + 24 >> 2] = f11;
 HEAPF32[i9 + 28 >> 2] = f1;
 HEAPF32[i9 + 32 >> 2] = f11;
 HEAPF32[i9 + 36 >> 2] = f1;
 HEAPF32[i9 + 40 >> 2] = f2;
 HEAPF32[i9 + 44 >> 2] = f8;
 HEAPF32[i9 + 48 >> 2] = f2;
 HEAPF32[i9 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 88 >> 2] = Math_fround(-1.0);
 HEAPF32[i9 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 108 >> 2] = Math_fround(-1.0);
 HEAPF32[i9 + 112 >> 2] = Math_fround(0.0);
 i13 = i3;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i5 + 4 >> 2] = i12;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(+Math_sin(+f4));
 f2 = Math_fround(+Math_cos(+f4));
 i5 = 0;
 f4 = f11;
 f1 = Math_fround(-1.0);
 while (1) {
  i3 = i9 + 20 + (i5 << 3) | 0;
  f14 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(f6 + Math_fround(Math_fround(f7 * f14) + Math_fround(f2 * f4)));
  HEAPF32[i3 >> 2] = Math_fround(f8 + Math_fround(Math_fround(f2 * f14) - Math_fround(f7 * f4)));
  HEAPF32[i9 + 20 + (i5 << 3) + 4 >> 2] = f11;
  i3 = i9 + 84 + (i5 << 3) | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  f11 = Math_fround(Math_fround(f7 * f4) + Math_fround(f2 * f1));
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f2 * f4) - Math_fround(f7 * f1));
  HEAPF32[i9 + 84 + (i5 << 3) + 4 >> 2] = f11;
  i3 = i5 + 1 | 0;
  if ((i3 | 0) >= (HEAP32[i10 >> 2] | 0)) break;
  f4 = Math_fround(HEAPF32[i9 + 20 + (i3 << 3) + 4 >> 2]);
  i5 = i3;
  f1 = Math_fround(HEAPF32[i9 + 84 + (i3 << 3) + 4 >> 2]);
 }
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN15MBP_PairManager10removePairEjjjj(i4, i1, i2, i3, i12) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = i4 + 12 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i3 = i8 + (i3 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i10 = i4 + 16 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i12 | 0)) {
  i1 = HEAP32[i9 + (i12 << 2) >> 2] | 0;
  i13 = 6;
 } else {
  while (1) {
   i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) == (i12 | 0)) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = HEAP32[i9 + (i12 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) i13 = 6; else HEAP32[i9 + (i2 << 2) >> 2] = i1;
 }
 if ((i13 | 0) == 6) HEAP32[i3 >> 2] = i1;
 i6 = i4 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + -1 | 0;
 if ((i7 | 0) == (i12 | 0)) {
  i13 = i1;
  i13 = i13 + -1 | 0;
  HEAP32[i6 >> 2] = i13;
  return;
 }
 i5 = HEAP32[i4 + 20 >> 2] | 0;
 i3 = HEAP32[i5 + (i7 * 12 | 0) + 4 >> 2] << 16 | HEAP32[i5 + (i7 * 12 | 0) >> 2] & 65535;
 i3 = i3 + ~(i3 << 15) | 0;
 i3 = (i3 >> 10 ^ i3) * 9 | 0;
 i3 = i3 >> 6 ^ i3;
 i3 = i3 + ~(i3 << 11) | 0;
 i4 = (i3 >> 16 ^ i3) & HEAP32[i4 + 4 >> 2];
 i3 = i8 + (i4 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) {
  i1 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  i13 = 13;
 } else {
  while (1) {
   i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
   if ((i2 | 0) == (i7 | 0)) {
    i2 = i1;
    break;
   } else i1 = i2;
  }
  i1 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) i13 = 13; else HEAP32[i9 + (i2 << 2) >> 2] = i1;
 }
 if ((i13 | 0) == 13) HEAP32[i3 >> 2] = i1;
 i13 = i5 + (i12 * 12 | 0) | 0;
 i9 = i5 + (i7 * 12 | 0) | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP16[i13 + 8 >> 1] = HEAP16[i9 + 8 >> 1] | 0;
 i13 = (HEAP32[i11 >> 2] | 0) + (i4 << 2) | 0;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i12 << 2) >> 2] = HEAP32[i13 >> 2];
 HEAP32[i13 >> 2] = i12;
 i13 = HEAP32[i6 >> 2] | 0;
 i13 = i13 + -1 | 0;
 HEAP32[i6 >> 2] = i13;
 return;
}

function __Z31Texture2D_CUSTOM_SetAllPixels32P12Il2CppObjectP11Il2CppArrayi(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i3 = i9;
 i1 = i9 + 24 | 0;
 i6 = i9 + 12 | 0;
 HEAP32[i1 >> 2] = i8;
 if (!i8) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i2) {
  i10 = i8;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 if ((i5 | 0) >= 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
  if ((__ZNK9Texture2D16CountDataMipmapsEv(i1) | 0) > (i5 | 0)) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
   i10 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
   __ZN9Texture2D11SetPixels32EiPK11ColorRGBA32i(i1, i5, i10, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0);
   STACKTOP = i9;
   return;
  }
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 HEAP32[i7 >> 2] = __ZNK9Texture2D16CountDataMipmapsEv(i1) | 0;
 __Z6FormatPKcz(i6, gb + 570440 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 570137 | 0, 398, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i9;
 return;
}

function __ZN7Terrain31UpdateTerrainRendererLightmapSTE12LightmapType(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i1 = HEAP32[i4 + 120 + (i8 << 4) >> 2] | 0;
 i3 = HEAP32[i4 + 120 + (i8 << 4) + 4 >> 2] | 0;
 i5 = HEAP32[i4 + 120 + (i8 << 4) + 8 >> 2] | 0;
 i2 = HEAP32[i4 + 120 + (i8 << 4) + 12 >> 2] | 0;
 if ((i8 | 0) == 1) {
  f11 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f13 = Math_fround(f11 * Math_fround(HEAPF32[i4 + 156 >> 2]));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f13 = Math_fround(f9 * Math_fround(HEAPF32[i4 + 160 >> 2]));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
  f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i4 + 164 >> 2])));
  i5 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
  f9 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i4 + 168 >> 2])));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = i3;
 i6 = i4 + 228 | 0;
 i4 = i4 + 240 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i6 >> 2] | 0;
 do {
  i14 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i14 + 76 + (i8 << 4) >> 2] = i1;
  HEAP32[i14 + 76 + (i8 << 4) + 4 >> 2] = i7;
  HEAP32[i14 + 76 + (i8 << 4) + 8 >> 2] = i5;
  HEAP32[i14 + 76 + (i8 << 4) + 12 >> 2] = i2;
  i14 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i14 + 32 + (i8 << 4) >> 2] = i1;
  HEAP32[i14 + 32 + (i8 << 4) + 4 >> 2] = i7;
  HEAP32[i14 + 32 + (i8 << 4) + 8 >> 2] = i5;
  HEAP32[i14 + 32 + (i8 << 4) + 12 >> 2] = i2;
  i3 = i3 + 20 | 0;
 } while ((i3 | 0) != ((HEAP32[i6 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 3) | 0, 0, i4 - i5 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i10, i3, i1) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = i10 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i3 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i3, i1, i6, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = i1 + (i4 * 12 | 0) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i10);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 8 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15TerrainRenderer11RenderStep3EP6Cameraib20ReflectionProbeUsageP9TransformRK13dynamic_arrayIP8MaterialLj4EES7_(i10, i1, i2, i3, i4, i5, i6, i7) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 32 | 0;
 i9 = i13 + 28 | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP8[i11 + 8 >> 0] = i3 & 1;
 HEAP32[i11 + 12 >> 2] = i4;
 HEAP32[i11 + 16 >> 2] = i5;
 HEAP32[i11 + 20 >> 2] = i6;
 HEAP32[i11 + 24 >> 2] = i7;
 i4 = (HEAP32[i10 + 20 >> 2] | 0) + -64 | 0;
 i5 = i10 + 72 | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i12 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
   i2 = HEAP32[i8 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i12 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i12 = i1;
    i12 = i12 + 248 | 0;
    __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i10, i4, i12, i11);
    STACKTOP = i13;
    return;
   }
  }
 }
 i12 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i12 = i12 + 248 | 0;
 __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE(i10, i4, i12, i11);
 STACKTOP = i13;
 return;
}

function __ZN14SpriteRenderer18UpdateCachedSpriteEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i6 + 340 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 i2 = i6 + 364 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP8[i6 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i6);
 i3 = i6 + 368 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i6 + 372 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 152 | 0;
 if ((i3 | 0) == (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = i6 + 372 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
 STACKTOP = i7;
 return;
}

function __Z30GetLightProbeProxyVolumeHandleRK28LightProbeProxyVolumeContextRK12BaseRenderer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 if (!(HEAP8[i1 + 20 >> 0] | 0)) {
  i4 = -1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i2 + 236 | 0;
 i1 = HEAPU16[i1 >> 1] | HEAPU8[i1 + 2 >> 0] << 16;
 if ((i1 & 196608 | 0) != 131072) {
  i4 = -1;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((i1 & 63) >>> 0 < 9) {
  i1 = HEAP32[i2 + -32 + 28 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30592 | 0) | 0;
   if (i1 | 0) {
    i4 = HEAP16[i1 + 152 >> 1] | 0;
    STACKTOP = i5;
    return i4 | 0;
   }
  }
 }
 i1 = HEAP32[i2 + 244 >> 2] | 0;
 if (!i1) {
  i4 = -1;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i4 = -1;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30592 | 0) | 0;
   if (!i1) {
    i4 = -1;
    STACKTOP = i5;
    return i4 | 0;
   }
   i4 = HEAP16[i1 + 152 >> 1] | 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 i4 = -1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK5Umbra9Matrix4x4eqERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 4 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 8 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 12 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 16 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 20 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 24 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 28 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 32 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 36 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 40 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 44 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 48 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 52 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 56 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 60 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1;
 return i2 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 272 | 0, i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 536 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 800 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 804 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 808 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN20TextRenderingPrivate15GetFontsManager13StaticDestroyEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = HEAP32[gb + 1467888 >> 2] | 0;
 if (i6 | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i4 = i6 + 4 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i7 + 4 | 0;
    do {
     i3 = i2 + -16 | 0;
     HEAP32[i4 >> 2] = i3;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i5 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
      i2 = HEAP32[i4 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i6 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63392 | 0);
 HEAP32[gb + 1467888 >> 2] = 0;
 i6 = HEAP32[gb + 1467880 >> 2] | 0;
 if (!i6) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63392 | 0);
  HEAP32[gb + 1467880 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63392 | 0);
  HEAP32[gb + 1467880 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i4 = i6 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i7 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i4 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i5 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
    i2 = HEAP32[i4 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 34;
 HEAP32[i7 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63392 | 0);
 HEAP32[gb + 1467880 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13SparseTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10);
 i1 = i9 + 80 | 0;
 i11 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i10 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i9 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i2 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i9 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i6 = i9 + 96 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i2;
  i5 = i2;
  i3 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i5 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 i1 = i9 + 60 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
  i11 = i9 + 32 | 0;
  __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i11 = i9 + 32 | 0;
  __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 }
}

function __Z11SkinGenericILi4ELb0ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i7 = HEAP32[i1 + 24 >> 2] | 0;
 i8 = HEAP32[i1 + 68 >> 2] | 0;
 i9 = HEAP32[i1 + 40 >> 2] | 0;
 i10 = HEAP32[i1 + 44 >> 2] | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 i3 = i7;
 while (1) {
  i15 = __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence(i5, 4, i8, i7, i7, i3) | 0;
  f14 = Math_fround(HEAPF32[i15 >> 2]);
  f17 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(f14 * f17);
  f13 = Math_fround(HEAPF32[i15 + 16 >> 2]);
  f16 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f13 = Math_fround(f14 + Math_fround(f13 * f16));
  f14 = Math_fround(HEAPF32[i15 + 32 >> 2]);
  f12 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  f14 = Math_fround(f13 + Math_fround(f14 * f12));
  f14 = Math_fround(Math_fround(HEAPF32[i15 + 48 >> 2]) + f14);
  f13 = Math_fround(f17 * Math_fround(HEAPF32[i15 + 4 >> 2]));
  f13 = Math_fround(f13 + Math_fround(f16 * Math_fround(HEAPF32[i15 + 20 >> 2])));
  f13 = Math_fround(f13 + Math_fround(f12 * Math_fround(HEAPF32[i15 + 36 >> 2])));
  f13 = Math_fround(Math_fround(HEAPF32[i15 + 52 >> 2]) + f13);
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i15 + 8 >> 2]));
  f16 = Math_fround(f17 + Math_fround(f16 * Math_fround(HEAPF32[i15 + 24 >> 2])));
  f12 = Math_fround(f16 + Math_fround(f12 * Math_fround(HEAPF32[i15 + 40 >> 2])));
  f12 = Math_fround(Math_fround(HEAPF32[i15 + 56 >> 2]) + f12);
  HEAPF32[i1 >> 2] = f14;
  HEAPF32[i1 + 4 >> 2] = f13;
  HEAPF32[i1 + 8 >> 2] = f12;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i6 | 0)) break; else {
   i4 = i4 + i9 | 0;
   i1 = i1 + i10 | 0;
   i3 = i3 + 32 | 0;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i1, i7, i2, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i4 = i9 + 8 | 0;
 i5 = i9;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i7) {
  i7 = i5;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  i8 = mftCall_iii(i3 | 0, i6 | 0, i8 | 0) | 0;
  i6 = (HEAP32[gb + 29188 >> 2] | 0) + -2 | 0;
  HEAP32[gb + 29188 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = i6;
  i6 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0) | 0) + 24 >> 2] | 0;
  i7 = i8 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & 2097151 | i6 << 21;
  __ZN6Object17InsertObjectInMapEPS_(i8);
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i2 = mftCall_iii(i3 | 0, i6 | 0, i8 | 0) | 0;
 if (!i2) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i2 + 4 >> 2] = i7;
 i7 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0) + 24 >> 2] | 0;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 2097151 | i7 << 21;
 switch (i8 | 0) {
 case 0:
  {
   __ZN6Object17InsertObjectInMapEPS_(i2);
   i8 = i2;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 2:
  {
   i8 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0) | 0) + 24 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 2097151 | i8 << 21;
   __ZN6Object17InsertObjectInMapEPS_(i2);
   i8 = i2;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i8 = i2;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13SparseTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 i1 = i8 + 80 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 84 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i1 = i8 + 76 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i6 = i8 + 96 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i5, 4);
  i2 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i5 = i1;
  i3 = i4;
 }
 HEAP32[i6 >> 2] = i2;
 i1 = i8 + 60 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i10 = i8 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i10 >> 2] = i2;
  i10 = i8 + 32 | 0;
  __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN12MeshCollider21IsScaleBakingRequiredEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i1 = __ZNK9Transform16GetTransformTypeEv(i4) | 0;
 __ZNK9Transform13GetWorldScaleEv(i2, i4);
 if (!(i1 & 2)) {
  i4 = 0;
  STACKTOP = i3;
  return i4 | 0;
 }
 if (Math_fround(HEAPF32[i2 >> 2]) < Math_fround(0.0)) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i4 = f5 < Math_fround(0.0);
 f6 = Math_fround(-f5);
 if (!((i4 ? f6 : f5) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 i4 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i4 ? f5 : f6) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i4 ? f5 : f6) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 if (Math_fround(HEAPF32[i2 + 16 >> 2]) < Math_fround(0.0)) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f6 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 i4 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i4 ? f5 : f6) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i4 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i4 ? f5 : f6) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 i4 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i4 ? f5 : f6) <= Math_fround(.00999999977))) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 if (Math_fround(HEAPF32[i2 + 32 >> 2]) < Math_fround(0.0)) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 i4 = 0;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN9Scripting32GetScriptingWrapperForInstanceIDEi(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (i2 | 0) {
  i7 = i2;
  STACKTOP = i6;
  return i7 | 0;
 }
 i2 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
 if ((i2 | 0) == (gb + 27592 | 0)) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 while (1) {
  i3 = __Z21GetManagerFromContexti(5) | 0;
  i3 = HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
  if (i3 | 0) break;
  i2 = HEAP32[i2 >> 2] | 0;
  if ((i2 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i5 = 15;
   break;
  }
 }
 if ((i5 | 0) == 15) {
  STACKTOP = i6;
  return i1 | 0;
 }
 i7 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i3, i1) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 __ZN18GfxFramebufferGLES22EnsureDefaultFBOInitedEv(i6);
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = HEAP32[i6 + 128 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i1 = 0;
  i3 = 0;
  do {
   i2 = HEAP32[i6 + 92 + (i3 << 2) >> 2] | 0;
   if (i2) {
    i9 = i2 + 29 | 0;
    i2 = (HEAP8[i9 >> 0] | 0) == 1;
    HEAP8[i7 + i3 >> 0] = i2 & 1;
    HEAP8[i9 >> 0] = 0;
    i1 = (i2 & 1) + i1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } else i1 = 0;
 i9 = HEAP32[i6 + 124 >> 2] | 0;
 i2 = i9 + 29 | 0;
 if (!i9) i2 = 0; else {
  i9 = (HEAP8[i2 >> 0] | 0) == 1;
  HEAP8[i2 >> 0] = 0;
  i2 = i9;
  i1 = (i9 & 1) + i1 | 0;
 }
 if ((i1 | 0) > 0) __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i6, i7, i2);
 i4 = i6 + 212 | 0;
 i1 = i4;
 i2 = i5;
 i3 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP16[i4 + 72 >> 1] = HEAP16[i5 + 72 >> 1] | 0;
 HEAP8[i6 + 328 >> 0] = 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 31 >> 0] | 0) HEAP32[i4 >> 2] = i6 + 384;
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 31 >> 0] | 0) HEAP32[i6 + 244 >> 2] = i6 + 432;
 HEAP8[i6 + 329 >> 0] = 1;
 HEAP32[i6 + 296 >> 2] = 0;
 HEAP32[i6 + 312 >> 2] = 0;
 HEAP32[i6 + 300 >> 2] = 0;
 HEAP32[i6 + 316 >> 2] = 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i6 + 304 >> 2] = i9;
 HEAP32[i6 + 320 >> 2] = i9;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i6 + 308 >> 2] = i5;
 HEAP32[i6 + 324 >> 2] = i5;
 __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup(i7, i6, i4);
 i5 = i7;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i9 = i6 + 288 | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i8, i9, i10, i5, i6) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 4 | 0;
 i11 = i13;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 i12 = i8 + 32 | 0;
 i2 = i1;
 if ((i2 | 0) == (i12 | 0)) {
  STACKTOP = i13;
  return;
 }
 if (!i5) {
  i4 = i1;
  i3 = i2;
  while (1) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i4;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   i2 = i3 + 16 | 0;
   if ((HEAP32[i3 + 48 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i3 + 40 >> 2] | 0) == (i10 | 0)) {
    HEAP32[i11 >> 2] = i4;
    HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
    __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i8, i2, i7);
   }
   i4 = i1;
   if ((i1 | 0) == (i12 | 0)) break; else i3 = i1;
  }
  STACKTOP = i13;
  return;
 } else i4 = i2;
 while (1) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   }
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  i3 = i4 + 16 | 0;
  if ((HEAP32[i4 + 48 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i4 + 40 >> 2] | 0) == (i10 | 0)) if (mftCall_iii(i5 | 0, HEAP32[i4 + 36 >> 2] | 0, i6 | 0) | 0) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
   __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i8, i3, i7);
  }
  i1 = i2;
  if ((i2 | 0) == (i12 | 0)) break; else i4 = i2;
 }
 STACKTOP = i13;
 return;
}

function __ZN13GfxDeviceGLES14SetRasterStateEPK17DeviceRasterState(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 f4 = Math_fround(HEAPF32[i7 + 4368 >> 2]);
 i6 = f4 != Math_fround(0.0);
 f3 = Math_fround(HEAPF32[i7 + 4372 >> 2]);
 if (i6 | f3 != Math_fround(0.0)) {
  i1 = (i1 | 0) == 0 ? HEAP32[i7 + 7088 >> 2] | 0 : i1;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i1 = i5 + 4 | 0;
  HEAP32[i1 >> 2] = ~~Math_fround(f4 + Math_fround(HEAP32[i1 >> 2] | 0));
  i1 = i5 + 8 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
  i1 = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i7 + 6616 | 0, i5) | 0;
 }
 i2 = HEAP32[i7 + 4384 >> 2] | 0;
 if ((i2 | 0) == -1) i2 = i7 + 7088 | 0; else {
  i6 = i7 + 7088 | 0;
  i1 = (i1 | 0) == 0 ? HEAP32[i6 >> 2] | 0 : i1;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i5 >> 2] = i2;
  i1 = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i7 + 6616 | 0, i5) | 0;
  i2 = i6;
 }
 i5 = i7 + 4620 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 if ((i6 | 0) == (i1 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) __ZN7ApiGLES11SetCullModeE8CullMode(i5, i2);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 f3 = Math_fround(i1 | 0);
 if (!(f4 != Math_fround(HEAPF32[i6 + 8 >> 2]))) if (!(f3 != Math_fround(HEAP32[i6 + 4 >> 2] | 0))) {
  STACKTOP = i8;
  return;
 }
 mftCall_vff(HEAP32[i7 + 4732 >> 2] | 0, +f4, +f3);
 if (f4 != Math_fround(0.0) | (i1 | 0) != 0) {
  __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i5, 9);
  STACKTOP = i8;
  return;
 } else {
  __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i5, 9);
  STACKTOP = i8;
  return;
 }
}

function __ZL30GeomMTDCallback_BoxHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(f13 + f13);
 f11 = Math_fround(f12 + f12);
 f16 = Math_fround(f19 + f19);
 f18 = Math_fround(f12 * f11);
 f17 = Math_fround(f19 * f16);
 f12 = Math_fround(f9 * f12);
 f20 = Math_fround(f9 * f19);
 f10 = Math_fround(f9 * f14);
 f19 = Math_fround(f11 * f19);
 f11 = Math_fround(f11 * f14);
 f14 = Math_fround(f16 * f14);
 f16 = Math_fround(f12 + f14);
 f15 = Math_fround(f20 - f11);
 f14 = Math_fround(f12 - f14);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f9));
 f13 = Math_fround(f9 - f17);
 f12 = Math_fround(f19 + f10);
 f11 = Math_fround(f20 + f11);
 f10 = Math_fround(f19 - f10);
 f9 = Math_fround(f9 - f18);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f18) - f17);
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 HEAPF32[i8 + 12 >> 2] = f14;
 HEAPF32[i8 + 16 >> 2] = f13;
 HEAPF32[i8 + 20 >> 2] = f12;
 HEAPF32[i8 + 24 >> 2] = f11;
 HEAPF32[i8 + 28 >> 2] = f10;
 HEAPF32[i8 + 32 >> 2] = f9;
 i6 = __ZN5physx2Gu25computeMTD_BoxHeightFieldERNS_6PxVec3ERfRKNS0_3BoxERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__214collate_bynameIwEC2EPKcj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i6 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212740 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, i4 | 0, 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i7 = _strlen(i4) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i6 | 0, i4 | 0, i7 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1082005 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNSt3__214collate_bynameIcEC2EPKcj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i6 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212708 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, i4 | 0, 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i7 = _strlen(i4) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i6 | 0, i4 | 0, i7 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1082083 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZN5physx31PxVehicleDriveNWGeneratedValuesC2EPKNS_16PxVehicleDriveNWE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 108 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 112 | 0;
 i4 = i1 + 128 | 0;
 i5 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP32[i2 + 208 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i5 = i1 + 288 | 0;
 _memcpy(i2 + 212 | 0, i1 + 224 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 276 >> 2] = HEAP32[i5 >> 2];
 i5 = i2 + 292 | 0;
 i4 = i1 + 304 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 324 | 0, i1 + 336 | 0, 416) | 0;
 i5 = i2 + 740 | 0;
 i4 = i1 + 752 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 return;
}

function __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE(i4, i5, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 32 | 0;
 i9 = i12 + 16 | 0;
 i10 = i12;
 __Z22CalculateTransformPathRK9TransformPS0_(i10, i4, __ZN9Transform7GetRootEv(i4) | 0);
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i1 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 + 12 >> 2] | 0;
  i11 = 4;
 } else if (i6 >>> 0 < 11) {
  i1 = i9 + 11 | 0;
  HEAP8[i1 >> 0] = i6;
  if (!i6) i2 = i9; else {
   i2 = i9;
   i11 = 6;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i13 = i6 + 16 & -16;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i9 + 8 >> 2] = i13 | -2147483648;
  HEAP32[i9 + 4 >> 2] = i6;
  i1 = i9 + 11 | 0;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i2 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i2 + i6 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZN13AvatarBuilder14GetAllChildrenER9TransformR8UnityStrRNSt3__26vectorINS_14NamedTransformENS4_9allocatorIS6_EEEERKNS5_IS2_NS7_IS2_EEEE(i4, i9, i5, i7);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i13, i8);
 STACKTOP = i12;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropImplERKN5physx8debugger14NamespacedNameEPKc(i12, i1, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i8;
 i10 = i9;
 i5 = HEAP32[i12 + 92 >> 2] | 0;
 if (!i5) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP8[i6 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i2 = 5381;
  i3 = i6;
  do {
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i1 = HEAP8[i10 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = 5381; else {
  i3 = 5381;
  i4 = i10;
  do {
   i3 = i3 * 33 ^ i1 << 24 >> 24;
   i4 = i4 + 1 | 0;
   i1 = HEAP8[i4 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i1 = i3;
 }
 i4 = i1 ^ i2;
 i1 = HEAP8[i11 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = 5381; else {
  i2 = 5381;
  i3 = i11;
  do {
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i1 = i2;
 }
 i1 = HEAP32[(HEAP32[i12 + 84 >> 2] | 0) + (((i4 ^ i1) & i5 + -1) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i13 = 0;
  return i13 | 0;
 }
 i7 = HEAP32[i12 + 76 >> 2] | 0;
 i6 = i8 | 0 ? i6 : gb + 1576256 | 0;
 i5 = i9 | 0 ? i10 : gb + 1576256 | 0;
 i4 = i11 | 0 ? i11 : gb + 1576256 | 0;
 i3 = i12 + 80 | 0;
 while (1) {
  i12 = HEAP32[i7 + (i1 << 4) >> 2] | 0;
  i2 = HEAP32[i7 + (i1 << 4) + 4 >> 2] | 0;
  if (!(_strcmp(i12 | 0 ? i12 : gb + 1576256 | 0, i6) | 0)) if (!(_strcmp(i2 | 0 ? i2 : gb + 1576256 | 0, i5) | 0)) {
   i12 = HEAP32[i7 + (i1 << 4) + 8 >> 2] | 0;
   if (!(_strcmp(i12 | 0 ? i12 : gb + 1576256 | 0, i4) | 0)) break;
  }
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i13 = 16;
   break;
  }
 }
 if ((i13 | 0) == 16) return i1 | 0;
 if (!(i7 + (i1 << 4) | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i13 = HEAP32[i7 + (i1 << 4) + 12 >> 2] | 0;
 return i13 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + (i4 * 12 | 0) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i16 = HEAP32[i2 >> 2] | 0;
   i15 = HEAP32[i16 + (i10 * 12 | 0) >> 2] | 0;
   i14 = i15 + ~(i15 << 15) | 0;
   i14 = (i14 >>> 10 ^ i14) * 9 | 0;
   i14 = i14 >>> 6 ^ i14;
   i14 = i14 + ~(i14 << 11) | 0;
   i14 = i5 + (((i14 >>> 16 ^ i14) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i14 >> 2];
   HEAP32[i14 >> 2] = i10;
   HEAP32[i7 + (i10 * 12 | 0) >> 2] = i15;
   i16 = i16 + (i10 * 12 | 0) + 4 | 0;
   i15 = HEAP32[i16 + 4 >> 2] | 0;
   i14 = i7 + (i10 * 12 | 0) + 4 | 0;
   HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
   HEAP32[i14 + 4 >> 2] = i15;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayINS0_4PairIPNS_6PxBaseEyEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 << 4;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 754826 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 4) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i13 = i2 + 8 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1 + 8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 i11 = i7 + 8 | 0;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i6 << 4) + 8 | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i13 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i12 = i13 + 1 | 0;
  HEAP32[i5 >> 2] = i12;
  i13 = i4 + (i13 << 4) | 0;
  return i13 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i13 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i12 = i13 + 1 | 0;
  HEAP32[i5 >> 2] = i12;
  i13 = i4 + (i13 << 4) | 0;
  return i13 | 0;
 }
 i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i12 = i13 + 1 | 0;
 HEAP32[i5 >> 2] = i12;
 i13 = i4 + (i13 << 4) | 0;
 return i13 | 0;
}

function __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 158 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN11JointSpring8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 116 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 157 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 __ZN10JointMotor8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 128 | 0, i5);
 i1 = i4 + 156 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 96 | 0;
  __ZN11JointLimits8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  i8 = i4 + 96 | 0;
  __ZN11JointLimits8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 4, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 4) | 0, 0, i4 - i5 << 4 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 932479 | 0, 0);
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 12 | 0, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalEiRK31LocalSerializedObjectIdentifierRi(i12, i3, i2, i13) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i1 = i14 + 16 | 0;
 if ((HEAP16[gb + 1165896 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165896 | 0, i10);
  i11 = gb + 1165896 | 0;
 } else i11 = 0;
 i9 = i2 + 8 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 L4 : do if ((i8 | 0) == 0 & (i9 | 0) == 0) HEAP32[i13 >> 2] = 0; else {
  do if (!i7) i1 = i3; else {
   i6 = HEAP32[i12 + 40 >> 2] | 0;
   i2 = HEAP32[i6 + (i3 * 20 | 0) + 4 >> 2] | 0;
   i6 = HEAP32[i6 + (i3 * 20 | 0) + 8 >> 2] | 0;
   i1 = i6 - i2 >> 3;
   if (!i1) i1 = i2; else {
    i5 = i1;
    i1 = i2;
    while (1) {
     i15 = (i5 | 0) / 2 | 0;
     i4 = i2 + (i15 << 3) | 0;
     i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
     i4 = i4 + 8 | 0;
     i1 = i3 ? i4 : i1;
     i5 = i3 ? i5 + -1 - i15 | 0 : i15;
     if (!i5) break; else i2 = i3 ? i4 : i2;
    }
   }
   if ((i1 | 0) != (i6 | 0)) if (!((i1 | 0) == (i6 | 0) ? 1 : (i7 | 0) < (HEAP32[i1 >> 2] | 0))) {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    break;
   }
   HEAP32[i13 >> 2] = 0;
   break L4;
  } while (0);
  HEAP32[i10 >> 2] = i1;
  i1 = i10 + 8 | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 4 >> 2] = i9;
  i1 = __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(HEAP32[i12 + 56 >> 2] | 0, i10) | 0;
  HEAP32[i13 >> 2] = i1;
  if (!((i1 | 0) == 0 | (HEAP8[i12 + 115 >> 0] | 0) == 0)) __Z38PreallocateObjectFromPersistentManagerib(i1, 1) | 0;
 } while (0);
 if (!i11) {
  STACKTOP = i14;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i11);
 STACKTOP = i14;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   i13 = i1;
   i6 = HEAP32[i13 + 4 >> 2] | 0;
   i7 = i2;
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 8);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 3) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   i13 = i1;
   i6 = HEAP32[i13 + 4 >> 2] | 0;
   i7 = i2;
   HEAP32[i7 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 8);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__212ctype_bynameIwEC2EPKcj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i6 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212876 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, i4 | 0, 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i7 = _strlen(i4) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i6 | 0, i4 | 0, i7 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1081704 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    i2 = 1;
   } else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 1; else {
     __THREW__ = 0;
     invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
     __THREW__ = 0;
     i2 = 0;
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNK16ParticleRenderer22AdjustBoundsForStretchERK15ParticleEmitterR10MinMaxAABB(i2, i1, i16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, f17 = f0, f18 = f0;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 i13 = (HEAP32[i1 + 60 >> 2] | 0) - i3 | 0;
 i15 = (i13 | 0) / 48 | 0;
 f14 = Math_fround(HEAPF32[i2 + 348 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 344 >> 2]);
 if (!i13) return;
 f9 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 i2 = i16 + 4 | 0;
 i10 = i16 + 8 | 0;
 i11 = i16 + 12 | 0;
 i12 = i16 + 16 | 0;
 i13 = i16 + 20 | 0;
 i1 = 0;
 while (1) {
  f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f4 = Math_fround(f5 * f5);
  f6 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f6 * f6));
  f7 = Math_fround(HEAPF32[i3 + 20 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f7 * f7));
  if (f4 > f9) {
   if (!(f4 == Math_fround(0.0))) f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f4))));
   f17 = Math_fround(f8 * f4);
   f17 = Math_fround(f14 + Math_fround(f17 * Math_fround(HEAPF32[i3 + 24 >> 2])));
   f18 = Math_fround(f5 * f17);
   f4 = Math_fround(f6 * f17);
   f6 = Math_fround(f17 * f7);
   f18 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f18);
   f4 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f4);
   f6 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f6);
   f7 = Math_fround(HEAPF32[i16 >> 2]);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   f17 = Math_fround(HEAPF32[i10 >> 2]);
   HEAPF32[i16 >> 2] = f18 < f7 ? f18 : f7;
   HEAPF32[i2 >> 2] = f4 < f5 ? f4 : f5;
   HEAPF32[i10 >> 2] = f6 < f17 ? f6 : f17;
   f17 = Math_fround(HEAPF32[i11 >> 2]);
   f5 = Math_fround(HEAPF32[i12 >> 2]);
   f7 = Math_fround(HEAPF32[i13 >> 2]);
   HEAPF32[i11 >> 2] = f17 < f18 ? f18 : f17;
   HEAPF32[i12 >> 2] = f5 < f4 ? f4 : f5;
   HEAPF32[i13 >> 2] = f7 < f6 ? f6 : f7;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i15 >>> 0) break; else i3 = i3 + 48 | 0;
 }
 return;
}

function __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i8 + 72 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6);
 i1 = i8 + 20 | 0;
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i3 = i8 + 24 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i1;
  i1 = i4;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i3, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, HEAP32[i3 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 36 | 0, i6);
 i1 = i8 + 64 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 }
}

function __Z50AssetBundle_CUSTOM_LoadAssetWithSubAssets_InternalP12Il2CppObjectP12Il2CppStringS0_(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i4 = i10;
 i8 = i10 + 48 | 0;
 i9 = i10 + 28 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i8, i1);
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i3 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (HEAP8[i1 + 184 >> 0] | 0) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 495978 | 0, i10 + 24 | 0);
 i11 = gb + 64016 | 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i2 = i9 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i4);
 i11 = i7;
 i4 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i8);
 __Z36LoadAssetWithSubAssetFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EE(i1, i7, i6, i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i1 = __Z36CreateScriptingArrayFromUnityObjectsI13dynamic_arrayIP6ObjectLj4EEEP11Il2CppArrayRKT_i(i9, 0) | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i3);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return i1 | 0;
}

function __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 24 | 0;
 i9 = i11;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = i2 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i12 = (HEAP32[i9 >> 2] | 0) + (i1 << 4) | 0;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i12 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i7 + 24 >> 2] | 0;
 if (i1 | 0) {
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i6, i1);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i6);
 }
 __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i5 >> 2] | 0, HEAP32[i7 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i12 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i11;
 return;
}

function __GLOBAL__sub_I_runtime_vehicles_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1458540 >> 2] = 0;
 i3 = gb + 63400 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1458540 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1458540 + 12 >> 2] = 16;
 i1 = gb + 1458540 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3754 | 0, fb + 3755 | 0, 0, gb + 1458540 | 0);
 HEAP32[gb + 1458620 >> 2] = 0;
 i3 = gb + 63400 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1458620 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1458620 + 12 >> 2] = 16;
 i1 = gb + 1458620 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3756 | 0, fb + 3757 | 0, 0, gb + 1458620 | 0);
 HEAP32[gb + 1458700 >> 2] = 0;
 i3 = gb + 63400 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1458700 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1458700 + 12 >> 2] = 16;
 i1 = gb + 1458700 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3758 | 0, fb + 3759 | 0, 0, gb + 1458700 | 0);
 HEAP32[gb + 1458780 >> 2] = 0;
 i3 = gb + 63400 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1458780 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1458780 + 12 >> 2] = 16;
 i1 = gb + 1458780 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3760 | 0, fb + 3761 | 0, 0, gb + 1458780 | 0);
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1458860 | 0, gb + 826752 | 0, 3, 0);
 return;
}

function __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i4 + 16 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 56 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 96 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 116 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 136 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 156 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i4 + 240 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z15TransformSpriteRPhRPtjPK10Matrix4x4fPK12SpriteVertexjPKtj11ColorRGBA32j(i1, i7, i2, i3, i4, i5, i8, i9, i6, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i11 + 64 | 0;
 i18 = i11 + 48 | 0;
 i17 = i11 + 40 | 0;
 i16 = i11 + 32 | 0;
 i15 = i11 + 24 | 0;
 i14 = i11 + 16 | 0;
 i13 = i11 + 8 | 0;
 i12 = i11;
 HEAPF32[i19 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i19 + 8 >> 2] = Math_fround(-1.0);
 HEAPF32[i18 >> 2] = Math_fround(1.0);
 HEAPF32[i18 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i18 + 12 >> 2] = Math_fround(-1.0);
 HEAP32[i17 >> 2] = i4;
 HEAP32[i17 + 4 >> 2] = 20;
 HEAP32[i16 >> 2] = i2 & 2 | 0 ? i19 : 0;
 HEAP32[i16 + 4 >> 2] = 0;
 HEAP32[i15 >> 2] = i6;
 HEAP32[i15 + 4 >> 2] = 0;
 HEAP32[i14 >> 2] = i4 + 12;
 HEAP32[i14 + 4 >> 2] = 20;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = i2 & 128 | 0 ? i18 : 0;
 HEAP32[i12 + 4 >> 2] = 0;
 __Z43TransformVerticesStridedSeparatePointersREFRPhRK10Matrix4x4fj14StrideIteratorI8Vector3fES6_S4_I11ColorRGBA32ES4_I8Vector2fESA_S4_I8Vector4fE(i1, i3, i5, i17, i16, i15, i14, i13, i12);
 if (!i10) {
  _memcpy(HEAP32[i7 >> 2] | 0, i8 | 0, i9 << 1 | 0) | 0;
  i19 = HEAP32[i7 >> 2] | 0;
  i19 = i19 + (i9 << 1) | 0;
  HEAP32[i7 >> 2] = i19;
  STACKTOP = i11;
  return;
 }
 if (!i9) {
  i19 = HEAP32[i7 >> 2] | 0;
  i19 = i19 + (i9 << 1) | 0;
  HEAP32[i7 >> 2] = i19;
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = 0;
 do {
  HEAP16[i2 + (i1 << 1) >> 1] = (HEAPU16[i8 + (i1 << 1) >> 1] | 0) + i10;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i9 | 0));
 i19 = HEAP32[i7 >> 2] | 0;
 i19 = i19 + (i9 << 1) | 0;
 HEAP32[i7 >> 2] = i19;
 STACKTOP = i11;
 return;
}

function __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj278ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7, i6);
 i1 = i7 + 16 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEE14handleAccessorILj279ENS_22PxRepXPropertyAccessorILj279ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i4 = i1 + -1 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 32 | 0, i6 + 2 | 0);
 STACKTOP = i8;
 return i6 + 3 | 0;
}

function __ZN7mecanim9animation19DestroyAnimationSetEPNS0_12AnimationSetERNS_6memory9AllocatorE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = i5 + 24 | 0;
  i1 = 0;
  do {
   __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i6);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i3 = i5 + 4 | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0;
 i4 = i5 + 8 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i2 = 0;
  do {
   mftCall_vii(i1 | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 28 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 32 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 8 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 12 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 24 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 16 >> 2] | 0);
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 40 | 0) + 20 >> 2] | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 mftCall_vii(i1 | 0, i6 | 0, HEAP32[i4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i5 + 16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i5 + 24 >> 2] | 0);
 __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i5 + 20 >> 2] | 0, i6);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, i5 | 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj93ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i1 = i7;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i7 = i9 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 64, 4) | 0;
   i3 = i2 + 52 | 0;
   i4 = i2;
   i5 = i4 + 52 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
   HEAP8[i2 + 60 >> 0] = 1;
   HEAP8[i2 + 61 >> 0] = 1;
   HEAP8[i2 + 62 >> 0] = 0;
   HEAP8[i2 + 63 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11LightProbes28GetPendingCoefficientsOffsetERK10vector_mapI7Hash12813ProbeSetIndexNSt3__24lessIS1_EENS3_9allocatorINS3_4pairIS1_S2_EEEEERKS1_(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i13 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i13 - i2 | 0;
 if (!i1) i1 = i2; else {
  i9 = i12;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i11 = i12 + 8 | 0;
  i10 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i7 = (i1 | 0) / 40 | 0;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i7 | 0) / 2 | 0;
   i4 = i3 + (i2 * 40 | 0) | 0;
   i6 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   if ((i5 | 0) == (i8 | 0) & (i6 | 0) == (i9 | 0)) {
    i6 = i3 + (i2 * 40 | 0) + 8 | 0;
    i5 = HEAP32[i6 + 4 >> 2] | 0;
    if (i5 >>> 0 < i11 >>> 0 | ((i5 | 0) == (i11 | 0) ? (HEAP32[i6 >> 2] | 0) >>> 0 < i10 >>> 0 : 0)) i14 = 7;
   } else if (i6 >>> 0 < i9 >>> 0 | (i6 | 0) == (i9 | 0) & i5 >>> 0 < i8 >>> 0) i14 = 7;
   if ((i14 | 0) == 7) {
    i14 = 0;
    i3 = i4 + 40 | 0;
    i2 = i7 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i7 = i2;
  }
 }
 do if ((i1 | 0) == (i13 | 0)) i14 = 12; else {
  i3 = i12;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i5 | 0)) {
   i11 = i12 + 8 | 0;
   i9 = HEAP32[i11 + 4 >> 2] | 0;
   i12 = i1 + 8 | 0;
   i10 = HEAP32[i12 + 4 >> 2] | 0;
   if (i9 >>> 0 < i10 >>> 0 | ((i9 | 0) == (i10 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0 : 0)) {
    i14 = 12;
    break;
   } else break;
  } else if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i14 = 12;
   break;
  } else break;
 } while (0);
 if ((i14 | 0) == 12) i1 = i13;
 if ((i13 | 0) == (i1 | 0)) {
  i14 = -1;
  return i14 | 0;
 }
 i14 = HEAP32[i1 + 32 >> 2] | 0;
 return i14 | 0;
}

function __ZN5physx22PxSphericalJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i8 | 0, i9 | 0, 84, (i1 ? gb + 741874 | 0 : gb + 837976 | 0) | 0, gb + 742e3 | 0, 45) | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i1 + 4 >> 1] = 256;
 HEAP16[i1 + 6 >> 1] = 3;
 i9 = i1 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i8 = i1 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 88796 + 8;
 HEAP32[i9 >> 2] = gb + 88796 + 200;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 120, gb + 742089 | 0, 78) | 0;
 HEAP32[i1 + 80 >> 2] = i10;
 __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i1, i10, i2, i4, i3, i5);
 HEAPF32[i10 + 112 >> 2] = Math_fround(1.0e10);
 HEAPF32[i10 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 76 >> 2] = Math_fround(.5);
 i5 = i10 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i10 + 88 >> 2] = Math_fround(.100000001);
 HEAPF32[i10 + 92 >> 2] = Math_fround(1.57079637);
 HEAPF32[i10 + 96 >> 2] = Math_fround(1.57079637);
 HEAP16[i10 + 116 >> 1] = 0;
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, i2 | 0, i3 | 0, i9 | 0, gb + 88776 | 0, 120) | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 | 0) {
  i10 = i1;
  STACKTOP = i7;
  return i10 | 0;
 }
 if (!i1) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i10 = 0;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN5physx21PxcArticulationHelper20initializeDriveCacheERNS_9PxcFsDataEtPKNS_19PxsArticulationLinkEfjPcj(i10, i2, i3, f1, i11, i12, i13) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i15 + 284 | 0;
 i14 = i15 + 16 | 0;
 i5 = i15 + 272 | 0;
 i6 = i15;
 i7 = i2 & 65535;
 i8 = i12 + (i7 * 272 | 0) | 0;
 i9 = i7 * 320 | 0;
 __ZN5physx21PxcArticulationHelper16prepareDataBlockERNS_9PxcFsDataEPKNS_19PxsArticulationLinkEtPNS_11PxTransformEPNS_12PxcFsInertiaEPNS_30PxcArticulationJointTransformsEj(i10, i3, i2, i12 + (i7 * 240 | 0) | 0, i12, i12 + (i7 * 144 | 0) | 0, 0);
 _memset(i10 + (HEAPU16[i10 + 26 >> 1] | 0) | 0, 0, (i7 * 160 | 0) + 144 | 0) | 0;
 __ZN5physx21PxcArticulationHelper13prepareFsDataERNS_9PxcFsDataEPKNS_19PxsArticulationLinkE(i10, i3);
 HEAPF32[i14 >> 2] = Math_fround(0.0);
 if ((i2 & 65535) > 1) {
  f1 = Math_fround(Math_fround(1.0) / f1);
  i2 = 1;
  do {
   HEAPF32[i14 + (i2 << 2) >> 2] = f1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
 }
 _memset(i8 | 0, 0, i7 * 48 | 0) | 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i13;
 HEAP32[i5 + 8 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE(i10, i12, i8, i14, i7, i11 & 65535, i4);
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i13;
 HEAP32[i6 + 8 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE(i10, i12, i14, i8, i4);
 STACKTOP = i15;
 return;
}

function __ZN16ReflectionProbesD2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 52 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i6 = i2;
  do {
   i4 = i6;
   i6 = i6 + 4 | 0;
   i5 = i6;
   while (1) {
    i3 = HEAP32[i4 >> 2] | 0;
    if (!i3) break;
    if (!(HEAP8[i3 + 16 >> 0] | 0)) break;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63536 | 0);
    _memmove(i4 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) - i5 | 0) | 0;
    i1 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
    HEAP32[i8 >> 2] = i1;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((i4 | 0) == (i2 + (i1 << 2) | 0)) break L1;
   }
  } while ((i6 | 0) != (i2 + (i1 << 2) | 0));
 } while (0);
 i2 = i9 + 104 | 0;
 i1 = i9 + 164 | 0;
 if ((HEAP32[i9 + 180 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 168 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 144 | 0;
 if ((HEAP32[i9 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 124 | 0;
 if ((HEAP32[i9 + 140 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 128 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i9 + 120 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i9 + 108 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZNSt3__212__deque_baseI18ReflectionProbeJobNS_9allocatorIS1_EEED2Ev(i9 + 80 | 0);
 i1 = i9 + 60 | 0;
 if ((HEAP32[i9 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 40 | 0;
 if ((HEAP32[i9 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i9 + 12 | 0;
 if ((HEAP32[i9 + 28 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 16 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15b2RevoluteJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, d12 = 0.0, d13 = 0.0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 120 | 0;
 i4 = i2 + 112 | 0;
 i5 = i2 + 104 | 0;
 i6 = i2 + 96 | 0;
 i7 = i2 + 88 | 0;
 i8 = i2 + 80 | 0;
 i9 = i2 + 72 | 0;
 i10 = i2 + 64 | 0;
 i11 = i2 + 48 | 0;
 i14 = i2 + 32 | 0;
 i15 = i2 + 24 | 0;
 i16 = i2 + 16 | 0;
 i18 = i2 + 8 | 0;
 i19 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i17 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800450 | 0, i2);
 HEAP32[i18 >> 2] = i19;
 __Z5b2LogPKcz(gb + 799360 | 0, i18);
 HEAP32[i16 >> 2] = i17;
 __Z5b2LogPKcz(gb + 799386 | 0, i16);
 HEAP32[i15 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i15);
 d12 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d13 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i14 >> 3] = d12;
 HEAPF64[i14 + 8 >> 3] = d13;
 __Z5b2LogPKcz(gb + 799447 | 0, i14);
 d13 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d12 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i11 >> 3] = d13;
 HEAPF64[i11 + 8 >> 3] = d12;
 __Z5b2LogPKcz(gb + 799489 | 0, i11);
 HEAPF64[i10 >> 3] = +Math_fround(HEAPF32[i1 + 116 >> 2]);
 __Z5b2LogPKcz(gb + 800071 | 0, i10);
 HEAP32[i9 >> 2] = HEAPU8[i1 + 112 >> 0];
 __Z5b2LogPKcz(gb + 800103 | 0, i9);
 HEAPF64[i8 >> 3] = +Math_fround(HEAPF32[i1 + 120 >> 2]);
 __Z5b2LogPKcz(gb + 800476 | 0, i8);
 HEAPF64[i7 >> 3] = +Math_fround(HEAPF32[i1 + 124 >> 2]);
 __Z5b2LogPKcz(gb + 800504 | 0, i7);
 HEAP32[i6 >> 2] = HEAPU8[i1 + 100 >> 0];
 __Z5b2LogPKcz(gb + 800201 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 108 >> 2]);
 __Z5b2LogPKcz(gb + 800231 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 104 >> 2]);
 __Z5b2LogPKcz(gb + 800532 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function _UNITY_tt_face_get_kerning(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i5 = HEAP32[i3 + 740 >> 2] | 0;
 i14 = HEAP32[i3 + 744 >> 2] | 0;
 i15 = i5 + i14 | 0;
 i4 = HEAP32[i3 + 748 >> 2] | 0;
 if ((i14 | 0) < 10 | (i4 | 0) == 0) {
  i15 = 0;
  return i15 | 0;
 }
 i14 = HEAP32[i3 + 752 >> 2] | 0;
 i13 = i1 << 16 | i2;
 i12 = i3 + 756 | 0;
 i10 = 1;
 i11 = i5 + 4 | 0;
 i1 = 0;
 i3 = i5 + 10 | 0;
 while (1) {
  i9 = HEAP8[i11 + 5 >> 0] | 0;
  i2 = i11 + (HEAPU8[i11 + 2 >> 0] << 8 | HEAPU8[i11 + 3 >> 0]) | 0;
  i5 = i11;
  i11 = i2 >>> 0 > i15 >>> 0 ? i15 : i2;
  i2 = i5 + 14 | 0;
  L6 : do if (!((i14 & i10 | 0) == 0 | i2 >>> 0 > i11 >>> 0)) {
   i3 = HEAPU8[i3 >> 0] << 8 | HEAPU8[i5 + 7 >> 0];
   i8 = i11 - i2 | 0;
   i3 = (i8 | 0) < (i3 * 6 | 0) ? (i8 | 0) / 6 | 0 : i3;
   if (!(HEAP8[i5 + 4 >> 0] | 0)) {
    i5 = (i3 | 0) == 0;
    if (!(HEAP32[i12 >> 2] & i10)) {
     if (i5) break;
     while (1) {
      if ((HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0] | 0) == (i13 | 0)) break;
      i3 = i3 + -1 | 0;
      if (!i3) break L6; else i2 = i2 + 6 | 0;
     }
     i2 = HEAPU8[i2 + 4 >> 0] << 8 | HEAPU8[i2 + 5 >> 0];
    } else {
     if (i5) break; else i5 = 0;
     while (1) {
      i6 = (i3 + i5 | 0) >>> 1;
      i7 = i2 + (i6 * 6 | 0) + 4 | 0;
      i8 = i7 + -4 | 0;
      i8 = HEAPU8[i8 + 1 >> 0] << 16 | HEAPU8[i8 >> 0] << 24 | HEAPU8[i8 + 2 >> 0] << 8 | HEAPU8[i8 + 3 >> 0];
      if ((i8 | 0) == (i13 | 0)) break;
      i8 = i8 >>> 0 < i13 >>> 0;
      i5 = i8 ? i6 + 1 | 0 : i5;
      i3 = i8 ? i3 : i6;
      if (i5 >>> 0 >= i3 >>> 0) break L6;
     }
     i2 = HEAPU8[i7 >> 0] << 8 | HEAPU8[i7 + 1 >> 0];
    }
    i1 = (i2 << 16 >> 16) + ((i9 & 8) == 0 ? i1 : 0) | 0;
   }
  } while (0);
  i4 = i4 + -1 | 0;
  i3 = i11 + 6 | 0;
  if (i3 >>> 0 > i15 >>> 0 | (i4 | 0) == 0) break; else i10 = i10 << 1;
 }
 return i1 | 0;
}

function _jpeg_start_decompress(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 L1 : do switch (i1 | 0) {
 case 202:
  {
   _jinit_master_decompress(i7);
   if (!(HEAP8[i7 + 64 >> 0] | 0)) {
    HEAP32[i8 >> 2] = 203;
    i2 = 6;
    break L1;
   }
   HEAP32[i8 >> 2] = 207;
   i8 = 1;
   return i8 | 0;
  }
 case 203:
  {
   i2 = 6;
   break;
  }
 case 204:
  {
   i1 = i7 + 384 | 0;
   break;
  }
 default:
  {
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i2 + 20 >> 2] = 20;
   HEAP32[i2 + 24 >> 2] = i1;
   mftCall_vi(HEAP32[i2 >> 2] | 0, i7 | 0);
   i2 = 16;
  }
 } while (0);
 if ((i2 | 0) == 6) {
  i6 = i7 + 400 | 0;
  L11 : do if (HEAP8[(HEAP32[i6 >> 2] | 0) + 16 >> 0] | 0) {
   i4 = i7 + 8 | 0;
   i5 = i7 + 284 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L13 : while (1) {
    if (i1 | 0) mftCall_vi(HEAP32[i1 >> 2] | 0, i7 | 0);
    i2 = mftCall_ii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i7 | 0) | 0;
    switch (i2 | 0) {
    case 2:
     break L11;
    case 0:
     {
      i1 = 0;
      break L13;
     }
    default:
     {}
    }
    i1 = HEAP32[i4 >> 2] | 0;
    if (!((i2 | 2 | 0) == 3 & (i1 | 0) != 0)) continue;
    i2 = i1 + 4 | 0;
    i9 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
    HEAP32[i2 >> 2] = i9;
    i2 = i1 + 8 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i9 | 0) < (i3 | 0)) continue;
    HEAP32[i2 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
   }
   return i1 | 0;
  } while (0);
  HEAP32[i7 + 132 >> 2] = HEAP32[i7 + 124 >> 2];
  i2 = 16;
 }
 if ((i2 | 0) == 16) {
  i1 = i7 + 384 | 0;
  if ((HEAP32[i8 >> 2] | 0) != 204) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i7 | 0);
   HEAP32[i7 + 120 >> 2] = 0;
   HEAP32[i8 >> 2] = 204;
  }
 }
 if (HEAP8[(HEAP32[i1 >> 2] | 0) + 8 >> 0] | 0) do {
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i9 >> 2] | 0, i7 | 0);
 } while ((HEAP8[(HEAP32[i1 >> 2] | 0) + 8 >> 0] | 0) != 0);
 HEAP32[i8 >> 2] = HEAP8[i7 + 65 >> 0] | 0 ? 206 : 205;
 i9 = 1;
 return i9 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13GfxDeviceGLESC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN9GfxDeviceC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 75860 + 8;
 HEAP32[i1 + 4616 >> 2] = 0;
 __ZN7ApiGLESC2Ev(i1 + 4620 | 0);
 __ZN19ConstantBuffersGLESC2Ev(i1 + 6624 | 0);
 HEAP32[i1 + 7096 >> 2] = 0;
 HEAP32[i1 + 7100 >> 2] = 0;
 HEAP32[i1 + 7092 >> 2] = i1 + 7096;
 HEAP32[i1 + 7108 >> 2] = 0;
 HEAP32[i1 + 7112 >> 2] = 0;
 HEAP32[i1 + 7104 >> 2] = i1 + 7108;
 HEAP32[i1 + 7120 >> 2] = 0;
 HEAP32[i1 + 7124 >> 2] = 0;
 HEAP32[i1 + 7116 >> 2] = i1 + 7120;
 HEAP32[i1 + 7132 >> 2] = 0;
 HEAP32[i1 + 7136 >> 2] = 0;
 HEAP32[i1 + 7128 >> 2] = i1 + 7132;
 i3 = i1 + 7148 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i3 = i1 + 7200 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i1 + 7384 | 0;
 HEAP32[i3 >> 2] = gb + 41128 + 8;
 HEAP32[i1 + 7392 >> 2] = 0;
 HEAP32[i1 + 7396 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 7400 >> 2] = 0;
 HEAP32[i1 + 7388 >> 2] = i1 + 7392;
 HEAP32[i1 + 7408 >> 2] = 0;
 HEAP32[i1 + 7412 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 7416 >> 2] = 0;
 HEAP32[i1 + 7404 >> 2] = i1 + 7408;
 HEAP32[i3 >> 2] = gb + 76976 + 8;
 HEAP32[i1 + 8456 >> 2] = 0;
 HEAP32[i1 + 8460 >> 2] = 0;
 HEAP32[i1 + 8452 >> 2] = i1 + 8456;
 HEAP32[i1 + 8468 >> 2] = 0;
 HEAP32[i1 + 8472 >> 2] = 0;
 HEAP32[i1 + 8464 >> 2] = i1 + 8468;
 HEAP32[i1 + 8476 >> 2] = 0;
 HEAP32[i1 + 8488 >> 2] = 0;
 HEAP32[i1 + 8492 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i1 + 8480 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN11MonoManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i8 >> 2] = gb + 66480 + 8;
 __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE(0);
 if (HEAP32[gb + 1165728 + 8 >> 2] | 0) {
  i1 = HEAP32[gb + 1165728 + 4 >> 2] | 0;
  i6 = (HEAP32[gb + 1165728 >> 2] | 0) + 4 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
  HEAP32[gb + 1165728 + 8 >> 2] = 0;
  if ((i1 | 0) != (gb + 1165728 | 0)) {
   i4 = i7 + 4 | 0;
   do {
    i2 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = i2 + 8 | 0;
    if ((HEAP32[i2 + 24 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    i6 = HEAP32[gb + 1165728 + 12 >> 2] | 0;
    HEAP32[i7 >> 2] = 49;
    HEAP32[i4 >> 2] = i6;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
   } while ((i1 | 0) != (gb + 1165728 | 0));
  }
 }
 i1 = HEAP32[i8 + 224 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 228 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i4 = i8 + 212 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN16ScriptingManagerD2Ev(i8);
  STACKTOP = i9;
  return;
 }
 i5 = i8 + 216 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i7 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 __ZN16ScriptingManagerD2Ev(i8);
 STACKTOP = i9;
 return;
}

function _UNITY_png_convert_to_rfc1123_buffer(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if (!i8) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((HEAPU16[i5 >> 1] | 0) > 9999) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = i5 + 2 | 0;
 i7 = HEAP16[i3 >> 1] | 0;
 i2 = (i7 & 65535) >>> 8;
 if (((i7 & 255) + -1 & 255) > 11) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (((i2 & 255) + -1 & 255) > 30) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i5 + 4 | 0;
 i1 = HEAP16[i4 >> 1] | 0;
 if ((i1 & 255) > 23) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (((i1 & 65535) >>> 8 & 255) > 59) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = i5 + 6 | 0;
 if ((HEAPU8[i6 >> 0] | 0) > 60) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i7 = i9 + 5 | 0;
 i1 = _UNITY_png_safecat(i8, 29, 0, _UNITY_png_format_number(i9, i7, 1, i2 & 65535) | 0) | 0;
 if (i1 >>> 0 < 28) {
  HEAP8[i8 + i1 >> 0] = 32;
  i1 = i1 + 1 | 0;
 }
 i1 = _UNITY_png_safecat(i8, 29, i1, gb + 350405 + ((HEAPU8[i3 >> 0] | 0) + -1 << 2) | 0) | 0;
 if (i1 >>> 0 < 28) {
  HEAP8[i8 + i1 >> 0] = 32;
  i1 = i1 + 1 | 0;
 }
 i1 = _UNITY_png_safecat(i8, 29, i1, _UNITY_png_format_number(i9, i7, 1, HEAPU16[i5 >> 1] | 0) | 0) | 0;
 if (i1 >>> 0 < 28) {
  HEAP8[i8 + i1 >> 0] = 32;
  i1 = i1 + 1 | 0;
 }
 i1 = _UNITY_png_safecat(i8, 29, i1, _UNITY_png_format_number(i9, i7, 2, HEAPU8[i4 >> 0] | 0) | 0) | 0;
 if (i1 >>> 0 < 28) {
  HEAP8[i8 + i1 >> 0] = 58;
  i1 = i1 + 1 | 0;
 }
 i1 = _UNITY_png_safecat(i8, 29, i1, _UNITY_png_format_number(i9, i7, 2, HEAPU8[i5 + 5 >> 0] | 0) | 0) | 0;
 if (i1 >>> 0 < 28) {
  HEAP8[i8 + i1 >> 0] = 58;
  i1 = i1 + 1 | 0;
 }
 _UNITY_png_safecat(i8, 29, _UNITY_png_safecat(i8, 29, i1, _UNITY_png_format_number(i9, i7, 2, HEAPU8[i6 >> 0] | 0) | 0) | 0, gb + 350453 | 0) | 0;
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN8VRDevice10PostRenderEPK6Camera(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i1 = i10;
 if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0) | 0)) {
  STACKTOP = i10;
  return;
 }
 if (i3 | 0) if (HEAP8[i3 + 1112 >> 0] | 0) {
  if ((HEAP16[gb + 1469320 + 6 >> 1] | 0) > -1) {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469320 | 0, i8);
   i1 = gb + 1469320 | 0;
  } else i1 = 0;
  i2 = HEAP32[i9 + 288 >> 2] | 0;
  if (i2 | 0) __ZN19VREyeTextureManager28BlitLeftToRightForMonoscopicEv(i2);
  mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 80 >> 2] | 0, i9 | 0, i3 | 0, 1);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if (!(HEAP8[i9 + 302 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i9 + 148 >> 2] | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 i1 = i8 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i8 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i8 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i4 = HEAP32[i9 + 304 >> 2] | 0;
 if (!i4) i7 = 15; else {
  i5 = HEAP32[i9 + 288 >> 2] | 0;
  if (!i5) i7 = 15; else __ZN19VREyeTextureManager12BlitToBufferE15UnityVRBlitModeRK5RectTIfEfP13RenderTexture(i5, 1, i8, Math_fround(HEAPF32[i9 + 312 >> 2]), i4);
 }
 if ((i7 | 0) == 15) {
  if (HEAP8[i9 + 171 >> 0] | 0) {
   i5 = HEAP32[i9 + 100 >> 2] | 0;
   i4 = HEAP32[i9 + 104 >> 2] | 0;
   i7 = HEAP32[i9 + 108 >> 2] | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 + 96 >> 2];
   HEAP32[i1 >> 2] = i4;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i3 >> 2] = i7;
  }
  i1 = HEAP32[i9 + 288 >> 2] | 0;
  if (i1 | 0) __ZN19VREyeTextureManager17BlitToFramebufferE15UnityVRBlitModeRK5RectTIfEf(i1, i6, i8, Math_fround(HEAPF32[i9 + 312 >> 2]));
 }
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx3Cct9SweepTest13onOriginShiftERKNS_6PxVec3E(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, d2 = 0.0, f3 = f0, f4 = f0, f5 = f0, d6 = 0.0, d7 = 0.0, i10 = 0, i11 = 0, i12 = 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 d2 = +f3;
 i10 = i8 + 48 | 0;
 HEAPF64[i10 >> 3] = +HEAPF64[i10 >> 3] - d2;
 i10 = i9 + 4 | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 d6 = +f5;
 i11 = i8 + 56 | 0;
 HEAPF64[i11 >> 3] = +HEAPF64[i11 >> 3] - d6;
 i11 = i9 + 8 | 0;
 f4 = Math_fround(HEAPF32[i11 >> 2]);
 d7 = +f4;
 i1 = i8 + 64 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d7;
 i1 = i8 + 72 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d2;
 i1 = i8 + 80 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d6;
 i1 = i8 + 88 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d7;
 if (!(HEAP32[i8 + 156 >> 2] | 0)) {
  if ((HEAP32[i8 + 152 >> 2] | 0) != -1) {
   i1 = i8 + 212 | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
   i1 = i8 + 216 | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
   i1 = i8 + 220 | 0;
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f4);
  }
 } else if ((HEAP16[(HEAP32[i8 + 160 >> 2] | 0) + 4 >> 1] | 0) != 6) {
  i1 = i8 + 188 | 0;
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
  i1 = i8 + 192 | 0;
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f5);
  i1 = i8 + 196 | 0;
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f4);
 }
 i1 = HEAP32[i8 + 32 >> 2] | 0;
 i12 = HEAP32[i8 + 36 >> 2] | 0;
 i8 = i1 + (i12 << 2) | 0;
 if (!i12) return;
 d7 = +Math_fround(HEAPF32[i9 >> 2]);
 d6 = +Math_fround(HEAPF32[i10 >> 2]);
 d2 = +Math_fround(HEAPF32[i11 >> 2]);
 do {
  i12 = i1 + 16 | 0;
  HEAPF64[i12 >> 3] = +HEAPF64[i12 >> 3] - d7;
  i12 = i1 + 24 | 0;
  HEAPF64[i12 >> 3] = +HEAPF64[i12 >> 3] - d6;
  i12 = i1 + 32 | 0;
  HEAPF64[i12 >> 3] = +HEAPF64[i12 >> 3] - d2;
  i1 = i1 + (HEAP32[gb + 83868 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS5_RT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i9 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i9 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i11 = i10 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i9 >> 2] | 0 : i9;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i2;
  i11 = i9 + 24 | 0;
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i11 = i9 + 24 | 0;
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i11, i10);
  STACKTOP = i12;
  return;
 }
}

function __ZN14LineParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = i7 + 16 | 0;
 i9 = i1 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i1 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 20 | 0, i1);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 108 | 0, i1);
 i1 = i7 + 180 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i7 + 184 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i3 = i7 + 188 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i5 = i1;
 }
 HEAP32[i3 >> 2] = i2;
 i1 = i7 + 192 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i9 = i7;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN11AudioSource16UpdateParametersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i6 = i7;
 i1 = HEAP32[i5 + 432 >> 2] | 0;
 i4 = i5 + 428 | 0;
 i2 = i1;
 if ((i2 | 0) != (i4 | 0)) do {
  i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (i1 | 0) if (HEAP32[i1 + 16 >> 2] | 0) {
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
   HEAP32[i3 >> 2] = i1;
   __ZN11AudioSource16UpdateParametersE12SoundChannel(i5, i3);
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
   }
   HEAP32[i3 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i4 | 0));
 i1 = HEAP32[i5 + 456 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = i1;
 __ZN11AudioSource16UpdateParametersE12SoundChannel(i5, i6);
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!(HEAP32[i8 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 16 >> 2] = HEAP32[i2 >> 2];
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo(i10, HEAP32[i3 + 24 >> 2] | 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 88 | 0;
 HEAP32[i9 >> 2] = i3;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i9, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 88 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i8 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 3;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 3 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 3;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 3) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 3;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 3) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 3 << 3);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i10 | 0) >>> 3) << 3);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 2;
 i1 = i10 >> 3 >>> 0 < 268435455 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 536870911;
 if (i1 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 3) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 3);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 3);
 return;
}

function __ZN9ShaderLab20SerializedProperties18AddTexturePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERKNS_25SerializedTexturePropertyE(i9, i1, i2, i3, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i10, i1, i2, 4, i3);
 i4 = i10 + 68 | 0;
 do if ((i4 | 0) != (i8 | 0)) {
  i6 = HEAP8[i8 + 11 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i8 >> 2] | 0 : i8;
  i6 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
  i7 = i4 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i10 + 76 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  if (i6 >>> 0 > i3 >>> 0) {
   i7 = i2 ? HEAP32[i10 + 72 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, i3, i6 - i3 | 0, i7, 0, i7, i6, i5);
   break;
  }
  i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i10 + 72 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i10 + 84 >> 2] = HEAP32[i8 + 16 >> 2];
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i9 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i10);
  __ZN9ShaderLab18SerializedPropertyD2Ev(i10);
  STACKTOP = i11;
  return;
 } else {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i10);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 88;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i10);
  STACKTOP = i11;
  return;
 }
}

function __ZN8Animator26ClearRelatedPropertyBlocksEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i6 = i12;
 i10 = i9 + 448 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 460 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i7 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  do if (i2 | 0) {
   HEAP32[i6 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i8 = 12; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i2, i6);
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 12; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i8 = 14;
    }
   }
   if ((i8 | 0) == 12) i8 = 14;
   if ((i8 | 0) == 14) {
    i8 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
    if (!i2) break;
   }
   __ZN8Renderer21ClearCustomPropertiesEv(i2);
  } while (0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i7 | 0));
 i1 = i9 + 464 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9 + 452 | 0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN18ComputeShaderParam8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047471 | 0, i6, i8, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744923 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469459 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469469 | 0, i6, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469478 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14AnimationState18AddMixingTransformER9Transformb(i9, i1, i6) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i10 = i11;
 i7 = i9 + 144 | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i9 + 148 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i5 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i5 | 0)) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i8 >> 2] = i1;
   i4 = i1;
   i3 = i8;
   break;
  }
 } while (0);
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = __Znwj(24) | 0;
  i2 = i1 + 16 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i6 & 1;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (i2) {
   HEAP32[i7 >> 2] = i2;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 148 >> 2] | 0, i1);
  i7 = i9 + 152 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i9 = i9 + 64 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 if ((HEAP16[gb + 1467064 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467064 | 0, i8);
  __Z12profiler_endP19ProfilerInformation(gb + 1467064 | 0);
  STACKTOP = i11;
  return;
 } else {
  STACKTOP = i11;
  return;
 }
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i5;
 i7 = i5 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i8 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i6 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 60 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i8 = i10;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, HEAP32[i2 + 20 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i9 = i2 + 4 | 0;
 i8 = i2 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i11) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i3, i7, i10);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i1) >> 2] = HEAP32[i10 >> 2];
 i1 = i7 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i5;
 i7 = i5 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i8 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i6 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 60 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i8 = i10;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = i4;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4 >> 2] = i9;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, HEAP32[i2 + 20 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i9 = i2 + 4 | 0;
 i8 = i2 + 12 | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i11 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i11) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject(i3, i7, i10);
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i8 >> 2] | 0) | 0 : i1) >> 2] = HEAP32[i10 >> 2];
 i1 = i7 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5Unity5Joint16SetConnectedBodyE4PPtrI9RigidbodyE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i3 = i10;
 i8 = i9 + 92 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = i9 + 28 | 0;
 do if ((HEAP32[i8 >> 2] | 0) != (i5 | 0)) {
  i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 67048 | 0) | 0;
  if (!i5) i1 = 0; else {
   HEAP32[i3 >> 2] = i5;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i7 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
     i2 = HEAP32[i2 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i7 = 10;
    }
   }
   if ((i7 | 0) == 8) i7 = 10;
   if ((i7 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
  }
  if ((i6 | 0) == (i1 | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 780729 | 0, 0, gb + 780771 | 0, 349, 1, 0, 0, 0);
   break;
  } else {
   HEAP32[i8 >> 2] = i5;
   break;
  }
 } while (0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 144 >> 2] | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function __ZN12ImageFilters14AddImageFilterERK11ImageFilter(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 8 | 0;
 i12 = i14 + 4 | 0;
 i13 = i14;
 __ZN12ImageFilters17RemoveImageFilterERK11ImageFilter(i1, i11);
 i9 = HEAP8[i11 + 9 >> 0] | 0 ? i1 : i1 + 12 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 L1 : do if (!i1) i1 = -1; else {
  i3 = HEAP32[i1 + 40 >> 2] | 0;
  if ((i3 | 0) > 0) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i4 | 0)) break L1;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i1 = -1;
     break;
    }
   }
  } else i1 = -1;
 } while (0);
 i8 = HEAP32[i9 >> 2] | 0;
 i7 = i8;
 i6 = ((HEAP32[i9 + 4 >> 2] | 0) - i8 | 0) / 12 | 0;
 while (1) {
  i5 = i6;
  i6 = i6 + -1 | 0;
  if ((i5 | 0) <= 0) {
   i1 = 15;
   break;
  }
  i4 = HEAP32[i7 + (i6 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  L11 : do if (!i2) i2 = -1; else {
   i5 = HEAP32[i2 + 40 >> 2] | 0;
   if ((i5 | 0) > 0) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i2 = 0;
    while (1) {
     if ((HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0) == (i4 | 0)) break L11;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) >= (i5 | 0)) {
      i2 = -1;
      break;
     }
    }
   } else i2 = -1;
  } while (0);
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = 14;
   break;
  }
 }
 if ((i1 | 0) == 14) {
  HEAP32[i12 >> 2] = i7 + (i6 * 12 | 0) + 12;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  __ZNSt3__26vectorI11ImageFilterNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_(i9, i10, i11) | 0;
  STACKTOP = i14;
  return;
 } else if ((i1 | 0) == 15) {
  HEAP32[i13 >> 2] = i8;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  __ZNSt3__26vectorI11ImageFilterNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_(i9, i10, i11) | 0;
  STACKTOP = i14;
  return;
 }
}

function __ZL25GeomMTDCallback_BoxConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(f13 + f13);
 f11 = Math_fround(f12 + f12);
 f16 = Math_fround(f19 + f19);
 f18 = Math_fround(f12 * f11);
 f17 = Math_fround(f19 * f16);
 f12 = Math_fround(f9 * f12);
 f20 = Math_fround(f9 * f19);
 f10 = Math_fround(f9 * f14);
 f19 = Math_fround(f11 * f19);
 f11 = Math_fround(f11 * f14);
 f14 = Math_fround(f16 * f14);
 f16 = Math_fround(f12 + f14);
 f15 = Math_fround(f20 - f11);
 f14 = Math_fround(f12 - f14);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f9));
 f13 = Math_fround(f9 - f17);
 f12 = Math_fround(f19 + f10);
 f11 = Math_fround(f20 + f11);
 f10 = Math_fround(f19 - f10);
 f9 = Math_fround(f9 - f18);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f18) - f17);
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 HEAPF32[i8 + 12 >> 2] = f14;
 HEAPF32[i8 + 16 >> 2] = f13;
 HEAPF32[i8 + 20 >> 2] = f12;
 HEAPF32[i8 + 24 >> 2] = f11;
 HEAPF32[i8 + 28 >> 2] = f10;
 HEAPF32[i8 + 32 >> 2] = f9;
 i6 = __ZN5physx2Gu20computeMTD_BoxConvexERNS_6PxVec3ERfRKNS0_3BoxERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z31ResolveDepthIntoTextureIfNeededR9GfxDeviceR10RenderLoop17DepthBufferFormatRP13RenderTextureP9TextureIDPb(i5, i6, i1, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 12 | 0;
 i2 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12;
 i4 = HEAP32[i5 + 4388 >> 2] | 0;
 if (!((i4 | 0) == 11 | (i4 | 0) == 17)) {
  STACKTOP = i12;
  return;
 }
 if ((HEAP16[gb + 1114796 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114796 | 0, i3);
  i4 = gb + 1114796 | 0;
 } else i4 = 0;
 i13 = HEAP32[gb + 1114796 >> 2] | 0;
 i14 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 648 >> 2] | 0, i14 | 0, i13 | 0);
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(__Z22GetRenderBufferManagerv() | 0, -1, -1, i1, 1, 4, 1, 0, 1) | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 387837 | 0);
 __ZN7Texture13SetFilterModeEi(i1, 0);
 __ZN13RenderTexture6CreateEv(i1) | 0;
 __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(i6, 5, i1);
 i14 = HEAP32[(HEAP32[i5 >> 2] | 0) + 332 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 mftCall_viii(i14 | 0, i5 | 0, i2 | 0, i3 | 0);
 __Z15gpu_time_samplev();
 HEAP32[i7 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP8[i9 >> 0] = 1;
 i14 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 652 >> 2] | 0, i14 | 0);
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i12;
 return;
}

function _UNITY_FT_Outline_Get_Orientation(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 if (!i11) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = HEAP16[i11 + 2 >> 1] | 0;
 if (i1 << 16 >> 16 < 1) {
  i13 = 0;
  return i13 | 0;
 }
 i10 = i11 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i9 = i4 + (i1 << 16 >> 16 << 3) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (i1 << 16 >> 16 == 1) {
  i13 = 2;
  return i13 | 0;
 }
 i8 = i2;
 i5 = i3;
 i6 = i4 + 8 | 0;
 i7 = i2;
 i2 = i3;
 i1 = i4;
 while (1) {
  i13 = HEAP32[i6 >> 2] | 0;
  i2 = (i13 | 0) < (i2 | 0) ? i13 : i2;
  i5 = (i13 | 0) > (i5 | 0) ? i13 : i5;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  i8 = (i1 | 0) < (i8 | 0) ? i1 : i8;
  i7 = (i1 | 0) > (i7 | 0) ? i1 : i7;
  i1 = i6 + 8 | 0;
  if (i1 >>> 0 >= i9 >>> 0) break; else {
   i13 = i6;
   i6 = i1;
   i1 = i13;
  }
 }
 if ((i2 | 0) == (i5 | 0) | (i7 | 0) == (i8 | 0)) {
  i13 = 2;
  return i13 | 0;
 }
 i13 = (_FT_MSB(((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | ((i2 | 0) < 0 ? 0 - i2 | 0 : i2)) | 0) + -14 | 0;
 i13 = (i13 | 0) > 0 ? i13 : 0;
 i12 = (_FT_MSB(i7 - i8 | 0) | 0) + -14 | 0;
 i12 = (i12 | 0) > 0 ? i12 : 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP16[i11 >> 1] | 0;
 if (i1 << 16 >> 16 > 0) {
  i8 = HEAP32[i11 + 12 >> 2] | 0;
  i6 = i1 << 16 >> 16;
  i1 = 0;
  i2 = 0;
  i5 = 0;
  while (1) {
   i7 = HEAP16[i8 + (i5 << 1) >> 1] | 0;
   if ((i2 | 0) <= (i7 | 0)) {
    i3 = HEAP32[i9 + (i7 << 3) >> 2] | 0;
    i4 = HEAP32[i9 + (i7 << 3) + 4 >> 2] | 0;
    while (1) {
     i11 = i3;
     i3 = HEAP32[i9 + (i2 << 3) >> 2] | 0;
     i10 = i4;
     i4 = HEAP32[i9 + (i2 << 3) + 4 >> 2] | 0;
     i1 = (Math_imul(i4 - i10 >> i12, i3 + i11 >> i13) | 0) + i1 | 0;
     if ((i2 | 0) >= (i7 | 0)) break; else i2 = i2 + 1 | 0;
    }
   }
   i5 = i5 + 1 | 0;
   if ((i5 | 0) >= (i6 | 0)) break; else i2 = i7 + 1 | 0;
  }
  if ((i1 | 0) > 0) {
   i13 = 1;
   return i13 | 0;
  }
 } else i1 = 0;
 i13 = i1 | 0 ? 0 : 2;
 return i13 | 0;
}

function __ZNK8VRModule23GetFirstSupportedDeviceEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i2, i7);
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i10 = i4 << 24 >> 24 < 0;
 i3 = i10 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i10 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i5 = 6;
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i11 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i10;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i8 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 220 >> 0] = i1;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 221 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 224 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 228 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 12, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 }
 i1 = i2 + i1 | 0;
 i6 = i1;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = i9 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 < i5 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i4 >> 2] | 0;
 }
 i4 = i6 + 8 | 0;
 i6 = i6 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i5 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i8, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 i5 = i9 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
   HEAP32[i2 >> 2] = 1;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags(i9, i2 + i3 | 0, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15HeightMeshQuery13AddHeightDataEiPKNSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEPK13dynamic_arrayI13HeightmapDataLj4EE(i8, i6, i9, i10) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i9 + 4 >> 2] | 0)) if (!(HEAP32[i10 + 12 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i8 + 4 | 0;
 i2 = i8 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 13;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i6 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 6;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i6 | 0)) {
     i2 = 12;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 10;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 6) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   i2 = 13;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i2 = 13;
   break;
  } else if ((i2 | 0) == 12) {
   HEAP32[i5 >> 2] = i1;
   if (!i1) {
    i4 = i1;
    i3 = i5;
    i2 = 13;
    break;
   } else break;
  }
 } while (0);
 if ((i2 | 0) == 13) {
  i1 = __Znwj(28) | 0;
  HEAP32[i1 + 16 >> 2] = i6;
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i3 >> 2] = i1;
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i7 >> 2] = i2;
   i2 = HEAP32[i3 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 8 >> 2] | 0, i2);
  i8 = i8 + 12 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 24 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE7reserveEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1 >>> 0 > 2147483631) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i11 = i8 + 11 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i9 = i4 & 255;
  i2 = 10;
 }
 i7 = i9 >>> 0 > i1 >>> 0 ? i9 : i1;
 i1 = i7 >>> 0 < 11;
 i7 = i1 ? 10 : (i7 + 16 & -16) + -1 | 0;
 if ((i7 | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 do if (i1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i4 << 24 >> 24 < 0) {
   i2 = 0;
   i3 = i8;
   i4 = 13;
  } else {
   i5 = 0;
   i6 = 1;
   i3 = i8;
   i2 = i4;
   i4 = 14;
  }
 } else {
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  if (i7 >>> 0 <= i2 >>> 0 & (i3 | 0) == 0) {
   STACKTOP = i12;
   return;
  }
  i2 = HEAP8[i11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i2 = 1;
   i1 = HEAP32[i8 >> 2] | 0;
   i4 = 13;
   break;
  } else {
   i5 = 1;
   i6 = 0;
   i1 = i8;
   i4 = 14;
   break;
  }
 } while (0);
 if ((i4 | 0) == 13) {
  i5 = i2;
  i6 = 1;
  i2 = HEAP32[i8 + 4 >> 2] | 0;
 } else if ((i4 | 0) == 14) i2 = i2 & 255;
 i2 = i2 + 1 | 0;
 if (i2 | 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 if (i6) {
  i6 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 if (i5) {
  HEAP32[i8 + 8 >> 2] = i7 + 1 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i11 >> 0] = i9;
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE7reserveEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1 >>> 0 > 2147483631) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i11 = i8 + 11 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i9 = i4 & 255;
  i2 = 10;
 }
 i7 = i9 >>> 0 > i1 >>> 0 ? i9 : i1;
 i1 = i7 >>> 0 < 11;
 i7 = i1 ? 10 : (i7 + 16 & -16) + -1 | 0;
 if ((i7 | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 do if (i1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i4 << 24 >> 24 < 0) {
   i2 = 0;
   i3 = i8;
   i4 = 13;
  } else {
   i5 = 0;
   i6 = 1;
   i3 = i8;
   i2 = i4;
   i4 = 14;
  }
 } else {
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 54;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  if (i7 >>> 0 <= i2 >>> 0 & (i3 | 0) == 0) {
   STACKTOP = i12;
   return;
  }
  i2 = HEAP8[i11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i2 = 1;
   i1 = HEAP32[i8 >> 2] | 0;
   i4 = 13;
   break;
  } else {
   i5 = 1;
   i6 = 0;
   i1 = i8;
   i4 = 14;
   break;
  }
 } while (0);
 if ((i4 | 0) == 13) {
  i5 = i2;
  i6 = 1;
  i2 = HEAP32[i8 + 4 >> 2] | 0;
 } else if ((i4 | 0) == 14) i2 = i2 & 255;
 i2 = i2 + 1 | 0;
 if (i2 | 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 if (i6) {
  i6 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 54;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 if (i5) {
  HEAP32[i8 + 8 >> 2] = i7 + 1 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i11 >> 0] = i9;
  STACKTOP = i12;
  return;
 }
}

function __ZN9ShaderLab9SubShader15FindNamedPassesERK8UnityStrR13dynamic_arrayIPNS_4PassELj4EE(i7, i8, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i13 = HEAP32[i7 + 12 >> 2] | 0;
 if (!i13) return;
 i14 = i8 + 11 | 0;
 i15 = i8 + 4 | 0;
 i16 = i12 + 12 | 0;
 i17 = i12 + 16 | 0;
 i9 = i12 + 4 | 0;
 i6 = 0;
 do {
  i10 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i11 = i10;
  i1 = i10 + 728 | 0;
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  if (i2) i3 = HEAP32[i10 + 732 >> 2] | 0; else i3 = i5 & 255;
  i18 = HEAP8[i14 >> 0] | 0;
  i4 = i18 << 24 >> 24 < 0;
  if ((i3 | 0) == ((i4 ? HEAP32[i15 >> 2] | 0 : i18 & 255) | 0)) {
   if (i2) {
    i3 = HEAP32[i1 >> 2] | 0;
    i2 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i1 = HEAP32[i10 + 732 >> 2] | 0;
   } else {
    i3 = i1;
    i2 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
    i1 = i5 & 255;
   }
   if (!(_strncmp(i3, i2, i1) | 0)) {
    i2 = HEAP32[i16 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i17 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i17 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i18 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i18 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i16 >> 2] << 2 | 0) | 0;
      HEAP32[i17 >> 2] = i1;
      HEAP32[i12 >> 2] = i18;
      break;
     }
    } while (0);
    HEAP32[i16 >> 2] = i3;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] = i11;
    i18 = i10 + 748 | 0;
    HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i13 | 0));
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb(i12, i11, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i7 = (i10 | 0) == 0;
 L1 : do if (i7) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6;
  i3 = i3 + ~(i3 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i8 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i8 >> 0] = 0;
 i2 = i12 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i12 + 16 >> 2] | 0)) {
  i1 = i7 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE15reserveInternalEj(i12, i1);
   i1 = HEAP32[i9 >> 2] | 0;
  } else i1 = i10;
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = i12 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11 + 1;
 i10 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i12 + 8 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i11 << 2) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN15PackedIntVector8PackIntsItEEvPT_i(i3, i10, i11) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = (i11 | 0) > 0;
 if (i7) {
  i1 = 0;
  i2 = 0;
  do {
   i9 = HEAPU16[i10 + (i1 << 1) >> 1] | 0;
   i2 = i2 >>> 0 < i9 >>> 0 ? i9 : i2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  HEAP32[i3 >> 2] = i11;
  if (!i2) i1 = 0; else {
   i8 = i2 >>> 0 > 65535;
   i1 = i8 ? i2 >>> 16 : i2;
   i8 = i8 ? 16 : 0;
   i9 = (i1 & 65280 | 0) == 0;
   i1 = i9 ? i1 : i1 >>> 8;
   i8 = i9 ? i8 : i8 | 8;
   i9 = (i1 & 240 | 0) == 0;
   i1 = ((i9 ? i8 : i8 | 4) | 1) + (HEAPU8[(i9 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) & 255;
  }
 } else {
  HEAP32[i3 >> 2] = i11;
  i1 = 0;
 }
 i8 = i3 + 4 | 0;
 HEAP8[i8 >> 0] = i1;
 i9 = i3 + 8 | 0;
 i4 = ((Math_imul(i1 & 255, i11) | 0) + 7 | 0) / 8 | 0;
 HEAP8[i6 >> 0] = 0;
 i3 = i3 + 12 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i5 - i2 | 0;
 if (i4 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh(i9, i4 - i1 | 0, i6); else if (i4 >>> 0 < i1 >>> 0) {
  i1 = i2 + i4 | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
 }
 if (!i7) {
  STACKTOP = i12;
  return;
 }
 i6 = 0;
 i2 = 0;
 i3 = 0;
 i1 = HEAP8[i8 >> 0] | 0;
 do {
  if (!(i1 << 24 >> 24)) i1 = 0; else {
   i5 = i10 + (i6 << 1) | 0;
   i4 = 0;
   do {
    i1 = (HEAP32[i9 >> 2] | 0) + i3 | 0;
    HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | (HEAPU16[i5 >> 1] | 0) >>> i4 << i2;
    i1 = HEAP8[i8 >> 0] | 0;
    i7 = i1 & 255;
    i13 = i7 - i4 | 0;
    i14 = 8 - i2 | 0;
    i13 = (i14 | 0) < (i13 | 0) ? i14 : i13;
    i2 = i13 + i2 | 0;
    i4 = i13 + i4 | 0;
    i13 = (i2 | 0) == 8;
    i3 = (i13 & 1) + i3 | 0;
    i2 = i13 ? 0 : i2;
   } while ((i4 | 0) < (i7 | 0));
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN12TreeRenderer16UpdateProbeIndexEii(i11, i2, i3) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = i11 + 296 | 0;
 i13 = i11 + 300 | 0;
 if ((HEAP32[i12 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i13 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i3;
 i10 = i11 + 268 | 0;
 L5 : do if (HEAP32[i10 >> 2] | 0) {
  i9 = i11 + 256 | 0;
  i1 = 0;
  while (1) {
   i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0;
   i14 = HEAP32[i8 + 272 >> 2] | 0;
   i4 = i14 + i2 | 0;
   i5 = i8 + 236 | 0;
   i6 = HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16;
   i7 = (i6 & 196608 | 0) == 0;
   i8 = i8 + 232 | 0;
   if ((i2 | 0) > -1 & (i14 | 0) < (i3 | 0)) {
    if (!i7) {
     i14 = i6 | 8192;
     HEAP16[i5 >> 1] = i14;
     HEAP8[i5 + 2 >> 0] = i14 >>> 16;
     HEAP32[i8 >> 2] = i4;
    }
   } else if (!i7) {
    i14 = i6 & 16769023;
    HEAP16[i5 >> 1] = i14;
    HEAP8[i5 + 2 >> 0] = i14 >>> 16;
    HEAP32[i8 >> 2] = -1;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) break L5;
   i2 = HEAP32[i12 >> 2] | 0;
   i3 = HEAP32[i13 >> 2] | 0;
  }
 } while (0);
 i8 = i11 + 412 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) return;
 i2 = i11 + 400 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0;
  i11 = HEAP32[i12 >> 2] | 0;
  i14 = HEAP32[i7 + 272 >> 2] | 0;
  i3 = i14 + i11 | 0;
  i4 = i7 + 236 | 0;
  i5 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
  i6 = (i5 & 196608 | 0) == 0;
  i7 = i7 + 232 | 0;
  if ((i11 | 0) > -1 ? (i14 | 0) < (HEAP32[i13 >> 2] | 0) : 0) {
   if (!i6) {
    i14 = i5 | 8192;
    HEAP16[i4 >> 1] = i14;
    HEAP8[i4 + 2 >> 0] = i14 >>> 16;
    HEAP32[i7 >> 2] = i3;
   }
  } else if (!i6) {
   i14 = i5 & 16769023;
   HEAP16[i4 >> 1] = i14;
   HEAP8[i4 + 2 >> 0] = i14 >>> 16;
   HEAP32[i7 >> 2] = -1;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN11LightProbes14LightProbeData8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378712 | 0, gb + 378733 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN26ProbeSetTetrahedralization8TransferI14SafeBinaryReadEEvRT_(i4, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 40 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378760 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 405193 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378772 | 0, HEAP32[gb + 37052 >> 2] | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS2_EE13stl_allocatorINS3_4pairIS2_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZL23GeomMTDCallback_BoxMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 + 36 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 56 >> 2] = HEAP32[i2 + 12 >> 2];
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f19 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(f13 + f13);
 f11 = Math_fround(f12 + f12);
 f16 = Math_fround(f19 + f19);
 f18 = Math_fround(f12 * f11);
 f17 = Math_fround(f19 * f16);
 f12 = Math_fround(f9 * f12);
 f20 = Math_fround(f9 * f19);
 f10 = Math_fround(f9 * f14);
 f19 = Math_fround(f11 * f19);
 f11 = Math_fround(f11 * f14);
 f14 = Math_fround(f16 * f14);
 f16 = Math_fround(f12 + f14);
 f15 = Math_fround(f20 - f11);
 f14 = Math_fround(f12 - f14);
 f9 = Math_fround(Math_fround(1.0) - Math_fround(f13 * f9));
 f13 = Math_fround(f9 - f17);
 f12 = Math_fround(f19 + f10);
 f11 = Math_fround(f20 + f11);
 f10 = Math_fround(f19 - f10);
 f9 = Math_fround(f9 - f18);
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f18) - f17);
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 HEAPF32[i8 + 12 >> 2] = f14;
 HEAPF32[i8 + 16 >> 2] = f13;
 HEAPF32[i8 + 20 >> 2] = f12;
 HEAPF32[i8 + 24 >> 2] = f11;
 HEAPF32[i8 + 28 >> 2] = f10;
 HEAPF32[i8 + 32 >> 2] = f9;
 i6 = __ZN5physx2Gu18computeMTD_BoxMeshERNS_6PxVec3ERfRKNS0_3BoxERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2UI13PrepareOutputERNS_7BatchesEjj(i4, i3, i6) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i4 + 100 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i4 + 96 >> 2] = __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(159, gb + 1546313 | 0, i1) | 0;
  HEAP32[i2 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(__ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i1) | 0, 159, 0) | 0;
 }
 i5 = __Z12GetGfxDevicev() | 0;
 i2 = i4 + 88 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i8 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 220 >> 2] | 0, i5 | 0) | 0;
  i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63248 | 0, 16, gb + 1012378 | 0, 14) | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 58920 + 8;
  HEAP32[i1 + 8 >> 2] = i8;
 }
 HEAP32[i2 >> 2] = i1;
 i2 = i3 * 60 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) mftCall_viiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, i1 | 0, 1, 0, i2 | 0, 0, 0);
 i2 = i4 + 92 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i8 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 216 >> 2] | 0, i5 | 0) | 0;
  i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63248 | 0, 16, gb + 1012378 | 0, 14) | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 58920 + 8;
  HEAP32[i1 + 8 >> 2] = i8;
 }
 HEAP32[i2 >> 2] = i1;
 i2 = i6 << 1;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 >>> 0 <= (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 mftCall_viiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, i1 | 0, 1, 0, i2 | 0, 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = i3 + 8 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i4 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
 }
 HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i6 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy(i4, i1, i6, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i5 = i1 + (i4 << 3) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15CollisionModule8TransferI17RemapPPtrTransferEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i5, i6);
 i3 = i6 + 16 | 0;
 i4 = i6 + 36 | 0;
 i7 = i6 + 40 | 0;
 i2 = i5 + 972 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i1 = i5 + 976 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i5 + 980 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i5 + 984 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i5 + 988 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i5 + 992 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i7 = i5 + 144 | 0;
  __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
  i7 = i5 + 408 | 0;
  __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
  i7 = i5 + 672 | 0;
  __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i7 = i5 + 144 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
 i7 = i5 + 408 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
 i7 = i5 + 672 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
 return;
}

function __Z37AnimationClip_CUSTOM_AddEventInternalP12Il2CppObjectS0_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 144 | 0;
 i3 = i8 + 64 | 0;
 i7 = i8;
 i4 = i3;
 i1 = i1 + 8 | 0;
 i2 = i4 + 80 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i4 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 11 >> 0] = 0;
 HEAP8[i4 >> 0] = 0;
 i4 = i7 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 11 >> 0] = 0;
 HEAP8[i4 >> 0] = 0;
 i4 = i7 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __Z22AnimationEventFromMonoRK18MonoAnimationEventR14AnimationEvent(i3, i7);
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 __ZN13AnimationClip15AddRuntimeEventER14AnimationEvent(i1, i7);
 i1 = i7 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i7 + 32 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 }
 i1 = i7 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return;
}

function _cf2_glyphpath_init(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0;
 _memset(i1 + 4 + 4 | 0, 0, 11776) | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 i3 = i1 + 11612 | 0;
 _cf2_arrstack_init(i3, HEAP32[i2 >> 2] | 0, i2 + 4 | 0, 8);
 i12 = i1 + 7744 | 0;
 i11 = i1 + 7748 | 0;
 _memset(i11 + 8 | 0, 0, 3856) | 0;
 i13 = i2 + 140 | 0;
 HEAP8[i1 + 7757 >> 0] = HEAP8[i13 >> 0] | 0;
 HEAP32[i1 + 7760 >> 2] = i4;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i1 + 7752 >> 2] = i3;
 i11 = i1 + 3880 | 0;
 _memset(i11 + 8 | 0, 0, 3856) | 0;
 HEAP8[i1 + 3889 >> 0] = HEAP8[i13 >> 0] | 0;
 HEAP32[i1 + 3892 >> 2] = i4;
 HEAP32[i1 + 3876 >> 2] = i2;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i1 + 3884 >> 2] = i3;
 i11 = i1 + 12 | 0;
 _memset(i11 + 8 | 0, 0, 3856) | 0;
 HEAP8[i1 + 21 >> 0] = HEAP8[i13 >> 0] | 0;
 HEAP32[i1 + 24 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i1 + 16 >> 2] = i3;
 HEAP32[i1 + 11644 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 11648 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 11652 >> 2] = HEAP32[i2 + 48 >> 2];
 i3 = i10;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i10 = i1 + 11656 | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i1 + 11668 >> 2] = i5;
 HEAP32[i1 + 11672 >> 2] = i6;
 HEAP32[i1 + 11676 >> 2] = i7;
 HEAP32[i1 + 11680 >> 2] = i8;
 HEAP32[i1 + 11684 >> 2] = i9;
 HEAP8[i1 + 11666 >> 0] = HEAP8[i2 + 141 >> 0] | 0;
 i9 = HEAP32[i2 + 184 >> 2] | 0;
 HEAP32[i1 + 11688 >> 2] = i9;
 i10 = HEAP32[i2 + 188 >> 2] | 0;
 HEAP32[i1 + 11692 >> 2] = i10;
 i9 = (i9 | 0) < 0 ? 0 - i9 | 0 : i9;
 i10 = (i10 | 0) < 0 ? 0 - i10 | 0 : i10;
 HEAP32[i1 + 11696 >> 2] = ((i9 | 0) > (i10 | 0) ? i9 : i10) << 1;
 HEAP32[i1 + 11700 >> 2] = 6554;
 HEAP8[i1 + 11667 >> 0] = 1;
 HEAP8[i1 + 11664 >> 0] = 0;
 HEAP8[i1 + 11665 >> 0] = 0;
 HEAP8[i1 + 11744 >> 0] = 0;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5Unity10HingeJoint8SetMotorERK10JointMotor(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i7 = i8;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f10 < Math_fround(-340282326000000008404918.0e15);
 i4 = f10 > Math_fround(340282326000000008404918.0e15);
 f10 = i4 ? Math_fround(340282326000000008404918.0e15) : f10;
 f10 = i3 ? Math_fround(-340282326000000008404918.0e15) : f10;
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i3 = f9 < Math_fround(0.0);
 i4 = f9 > Math_fround(340282326000000008404918.0e15);
 f9 = i4 ? Math_fround(340282326000000008404918.0e15) : f9;
 f9 = i3 ? Math_fround(0.0) : f9;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i2 + 128 | 0;
 HEAPF32[i3 >> 2] = f10;
 i4 = i2 + 132 | 0;
 HEAPF32[i4 >> 2] = f9;
 i5 = i2 + 136 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = i2 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP16[i1 + 4 >> 1] | 0) == 261) {
  STACKTOP = i8;
  return;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0, +Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(HEAPF32[i3 >> 2])) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 164 >> 2] | 0, i4 | 0, 4, (HEAP32[i5 >> 2] | 0) != 0 | 0);
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i6 | 0, i7 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i6 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i6 = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37316 >> 2] | 0, i2, i4);
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 471245 | 0, i6, 0);
 i2 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 471202 | 0, i2, i3, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 899057 | 0, i2, i6 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 3;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 3) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i5 = i1 + (i6 << 3) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i9 >> 2] = i2;
   i2 = i6;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15PackedIntVector8PackIntsIjEEvPT_i(i3, i10, i11) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = (i11 | 0) > 0;
 if (i7) {
  i1 = 0;
  i2 = 0;
  do {
   i9 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
   i2 = i2 >>> 0 < i9 >>> 0 ? i9 : i2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
  HEAP32[i3 >> 2] = i11;
  if (!i2) i1 = 0; else {
   i8 = i2 >>> 0 > 65535;
   i1 = i8 ? i2 >>> 16 : i2;
   i8 = i8 ? 16 : 0;
   i9 = (i1 & 65280 | 0) == 0;
   i1 = i9 ? i1 : i1 >>> 8;
   i8 = i9 ? i8 : i8 | 8;
   i9 = (i1 & 240 | 0) == 0;
   i1 = ((i9 ? i8 : i8 | 4) | 1) + (HEAPU8[(i9 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) & 255;
  }
 } else {
  HEAP32[i3 >> 2] = i11;
  i1 = 0;
 }
 i8 = i3 + 4 | 0;
 HEAP8[i8 >> 0] = i1;
 i9 = i3 + 8 | 0;
 i4 = ((Math_imul(i1 & 255, i11) | 0) + 7 | 0) / 8 | 0;
 HEAP8[i6 >> 0] = 0;
 i3 = i3 + 12 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = i5 - i2 | 0;
 if (i4 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh(i9, i4 - i1 | 0, i6); else if (i4 >>> 0 < i1 >>> 0) {
  i1 = i2 + i4 | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
 }
 if (!i7) {
  STACKTOP = i12;
  return;
 }
 i6 = 0;
 i2 = 0;
 i3 = 0;
 i1 = HEAP8[i8 >> 0] | 0;
 do {
  if (!(i1 << 24 >> 24)) i1 = 0; else {
   i5 = i10 + (i6 << 2) | 0;
   i4 = 0;
   do {
    i1 = (HEAP32[i9 >> 2] | 0) + i3 | 0;
    HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | (HEAP32[i5 >> 2] | 0) >>> i4 << i2;
    i1 = HEAP8[i8 >> 0] | 0;
    i7 = i1 & 255;
    i13 = i7 - i4 | 0;
    i14 = 8 - i2 | 0;
    i13 = (i14 | 0) < (i13 | 0) ? i14 : i13;
    i2 = i13 + i2 | 0;
    i4 = i13 + i4 | 0;
    i13 = (i2 | 0) == 8;
    i3 = (i13 & 1) + i3 | 0;
    i2 = i13 ? 0 : i2;
   } while ((i4 | 0) < (i7 | 0));
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 48 | 0;
 i8 = i4 + 40 | 0;
 i6 = i4;
 i12 = i4 + 16 | 0;
 i10 = i4 + 8 | 0;
 i9 = i4 + 32 | 0;
 i7 = i4 + 24 | 0;
 i11 = __ZN7ApiGLES13CreateTextureE16TextureDimensionN2gl9TexFormatEiiiii(i1, 2, __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(HEAP32[i1 + 860 >> 2] | 0, i3, 0) | 0, 1, 1, 16, 16, 1) | 0;
 HEAP32[i8 >> 2] = i11;
 __ZN7ApiGLES17CreateFramebufferEv(i6, i1);
 i14 = i6;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i3 = i12;
 HEAP32[i3 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i3 + 4 >> 2] = i13;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i1, 0, i5);
 mftCall_viiiii(HEAP32[i1 + 56 >> 2] | 0, HEAP32[i2 + 668 >> 2] | 0, 36064, 3553, i11 | 0, 0);
 i11 = i6;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 i3 = __ZN7ApiGLES16CheckFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEEb(i1, i5, 0) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = -1;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i1, 0, i5);
 __ZN7ApiGLES11BindTextureEj16TextureDimension(i1, 0, 2);
 __ZN7ApiGLES13DeleteTextureERj(i1, i8);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_(i1, i6, i5);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z30Sprite_Get_Custom_PropVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = (__ZNK6Sprite13GetRenderDataEb(i2, 0) | 0) + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0, 8, i3) | 0;
 if (!i3) {
  STACKTOP = i7;
  return i4 | 0;
 }
 i2 = i1 + 8 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i5 + (i1 * 20 | 0) >> 2] | 0;
  i5 = HEAP32[i5 + (i1 * 20 | 0) + 4 >> 2] | 0;
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 8) | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return i4 | 0;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i2 = HEAP32[i2 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i10 | 0)) {
  STACKTOP = i12;
  return;
 }
 i8 = i11 + 4 | 0;
 i7 = i2;
 i2 = HEAP32[i9 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i3 = i2 + 4 | 0;
  i5 = i1 + 4 | 0;
  i6 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i4 ? HEAP32[i1 + 8 >> 2] | 0 : i6 & 255;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 16 >> 2] = i4;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
   i4 = HEAP32[i2 + 16 >> 2] | 0;
   i13 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i3 + 11 >> 0] = i6;
   if (i6) i13 = 8;
  } else i13 = 6;
  if ((i13 | 0) == 6) {
   i14 = i6 + 16 & -16;
   HEAP32[i11 >> 2] = 66;
   HEAP32[i8 >> 2] = i4;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i2 + 12 >> 2] = i14 | -2147483648;
   HEAP32[i2 + 8 >> 2] = i6;
   i3 = i4;
   i13 = 8;
  }
  if ((i13 | 0) == 8) {
   i13 = 0;
   _memcpy(i3 | 0, i5 | 0, i6 | 0) | 0;
  }
  HEAP8[i3 + i6 >> 0] = 0;
  HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  i1 = i7 + 24 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 24 | 0;
  HEAP32[i9 >> 2] = i2;
  if ((i1 | 0) == (i10 | 0)) break; else i7 = i1;
 }
 STACKTOP = i12;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE7reserveEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if (i1 >>> 0 > 2147483631) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
 i11 = i8 + 11 | 0;
 i4 = HEAP8[i11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i9 = i4 & 255;
  i2 = 10;
 }
 i7 = i9 >>> 0 > i1 >>> 0 ? i9 : i1;
 i1 = i7 >>> 0 < 11;
 i7 = i1 ? 10 : (i7 + 16 & -16) + -1 | 0;
 if ((i7 | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 do if (i1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i4 << 24 >> 24 < 0) {
   i2 = 0;
   i3 = i8;
   i4 = 13;
  } else {
   i5 = 0;
   i6 = 1;
   i3 = i8;
   i2 = i4;
   i4 = 14;
  }
 } else {
  i3 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i3;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
  if (i7 >>> 0 <= i2 >>> 0 & (i3 | 0) == 0) {
   STACKTOP = i12;
   return;
  }
  i2 = HEAP8[i11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i2 = 1;
   i1 = HEAP32[i8 >> 2] | 0;
   i4 = 13;
   break;
  } else {
   i5 = 1;
   i6 = 0;
   i1 = i8;
   i4 = 14;
   break;
  }
 } while (0);
 if ((i4 | 0) == 13) {
  i5 = i2;
  i6 = 1;
  i2 = HEAP32[i8 + 4 >> 2] | 0;
 } else if ((i4 | 0) == 14) i2 = i2 & 255;
 i2 = i2 + 1 | 0;
 if (i2 | 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 if (i6) {
  i6 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 }
 if (i5) {
  HEAP32[i8 + 8 >> 2] = i7 + 1 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  HEAP8[i11 >> 0] = i9;
  STACKTOP = i12;
  return;
 }
}

function __ZNK16MemoryFileSystem4SizeERK13FileEntryData(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7;
 if ((HEAP16[gb + 1179020 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179020 | 0, i4);
  i6 = gb + 1179020 | 0;
 } else i6 = 0;
 i2 = HEAP32[i1 + 1052 >> 2] | 0;
 if (!i2) {
  HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i3, i1, i5);
  i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i3 + 4 | 0, i5) | 0;
  if ((i1 | 0) == (i3 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i3 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 12 >> 2] | 0;
   HEAP32[i4 >> 2] = 54;
   HEAP32[i4 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
  }
  if (!i1) {
   i1 = 0;
   i2 = 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i2 = 0;
   } else {
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
    i2 = getTempRet0() | 0;
   }
  }
 } else {
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
 }
 if (!i6) {
  setTempRet0(i2 | 0);
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 setTempRet0(i2 | 0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK13AnimationClip10FloatCurve16CopyWithoutCurveERS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 do if ((i9 | 0) != (i8 | 0)) {
  i4 = HEAP8[i8 + 11 >> 0] | 0;
  i5 = i4 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i8 >> 2] | 0 : i8;
  i4 = i5 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
  i5 = i9 + 11 | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i3 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
  do if (i4 >>> 0 > i3 >>> 0) {
   i7 = i2 ? HEAP32[i9 + 4 >> 2] | 0 : i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i3, i4 - i3 | 0, i7, 0, i7, i4, i6);
  } else {
   i1 = i2 ? HEAP32[i9 >> 2] | 0 : i9;
   if (i4 | 0) _memmove(i1 | 0, i6 | 0, i4 | 0) | 0;
   HEAP8[i1 + i4 >> 0] = 0;
   if ((HEAP8[i5 >> 0] | 0) < 0) {
    HEAP32[i9 + 4 >> 2] = i4;
    break;
   } else {
    HEAP8[i5 >> 0] = i4;
    break;
   }
  } while (0);
  i1 = i9 + 16 | 0;
  i5 = i8 + 16 | 0;
  i6 = HEAP8[i5 + 11 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i5 = i7 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i7 ? HEAP32[i8 + 20 >> 2] | 0 : i6 & 255;
  i7 = i1 + 11 | 0;
  i2 = HEAP8[i7 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i6 >>> 0 > i4 >>> 0) {
   i7 = i3 ? HEAP32[i9 + 20 >> 2] | 0 : i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i4, i6 - i4 | 0, i7, 0, i7, i6, i5);
   break;
  }
  i1 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i9 + 20 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 + 32 >> 2] = HEAP32[i8 + 32 >> 2];
 HEAP32[i9 + 36 >> 2] = HEAP32[i8 + 36 >> 2];
 HEAP32[i9 + 128 >> 2] = HEAP32[i8 + 128 >> 2];
 return;
}

function __ZN7ApiGLES19CreateSparseTextureEj16TextureDimensionN2gl9TexFormatEiiiiRiS3_S3_(i12, i1, i3, i4, i13, i14, i15, i2, i7, i9, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = i10 + 16 | 0;
 i6 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i12 + 860 >> 2] | 0, i3) | 0;
 i3 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i4) | 0;
 i2 = i12 + 848 | 0;
 mftCall_viiiii(HEAP32[i2 >> 2] | 0, i6 | 0, HEAP32[i3 >> 2] | 0, 37269, 1, i7 | 0);
 mftCall_viiiii(HEAP32[i2 >> 2] | 0, i6 | 0, HEAP32[i3 >> 2] | 0, 37270, 1, i9 | 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!((i14 | 0) % (i2 | 0) | 0)) if (!((i15 | 0) % (i1 | 0) | 0)) {
  mftCall_viii(HEAP32[i12 + 180 >> 2] | 0, i6 | 0, 37286, 1);
  mftCall_viiiii(HEAP32[i12 + 584 >> 2] | 0, i6 | 0, i13 | 0, HEAP32[i3 >> 2] | 0, i14 | 0, i15 | 0);
  mftCall_viii(HEAP32[i12 + 96 >> 2] | 0, i6 | 0, 37290, i11 | 0);
  i1 = HEAP32[i11 >> 2] | 0;
  if ((i1 | 0) >= (i13 | 0)) {
   i15 = 1;
   STACKTOP = i10;
   return i15 | 0;
  }
  i14 = i14 >> i1;
  i15 = i15 >> i1;
  mftCall_viiiiiiiii(HEAP32[i12 + 820 >> 2] | 0, i6 | 0, i1 | 0, 0, 0, 0, ((i14 | 0) > 1 ? i14 : 1) | 0, ((i15 | 0) > 1 ? i15 : 1) | 0, 1, 1);
  i15 = 1;
  STACKTOP = i10;
  return i15 | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i14;
 HEAP32[i8 + 12 >> 2] = i15;
 __Z6FormatPKcz(i5, gb + 600277 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 599732 | 0, 1300, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i15 = 0;
 STACKTOP = i10;
 return i15 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP16[i10 >> 1] | 0;
  i1 = i4 & 65535;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP16[i5 + (i2 << 3) >> 1] | 0) == i4 << 16 >> 16) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAPU16[i10 >> 1] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN15ParticleEmitter7SetEmitEb(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i8 + 205 | 0;
 if ((HEAPU8[i1 >> 0] | 0) == (i4 & 1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP8[i1 >> 0] = i4 & 1;
 i5 = i8 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  i2 = i8 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i6 = 12;
 } else {
  i3 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  i2 = i8 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i3 ^ (i1 | 0) != 0) {
   if (!i3) if (!i1) break; else {
    i6 = 12;
    break;
   }
   if ((i2 | 0) != (gb + 1469400 | 0)) {
    if (!i1) i1 = i8 + 212 | 0; else {
     i3 = i8 + 212 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
     i1 = i3;
    }
    i3 = HEAP32[gb + 1469400 >> 2] | 0;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i1 >> 2] = gb + 1469400;
    HEAP32[i3 + 4 >> 2] = i2;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   }
  }
 } while (0);
 if ((i6 | 0) == 12) {
  i6 = i8 + 212 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 }
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i1 = i8 + 32 | 0;
 if (!(HEAP8[i8 + 192 >> 0] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 } else {
  __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 }
 i8 = i8 + 44 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN12HeaderHelperC2ERKS_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 8 | 0;
 i10 = i14 + 4 | 0;
 i11 = i14;
 i12 = i9 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i13 = i9 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 i2 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i3 | 0) == (i7 | 0)) {
  STACKTOP = i14;
  return;
 }
 i6 = i2;
 i5 = i3;
 i1 = i3;
 while (1) {
  i3 = i5 + 16 | 0;
  HEAP32[i11 >> 2] = i6;
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  i4 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_(i9, i8, i10, i3) | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i2 = __Znwj(40) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + 16 | 0, i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + 28 | 0, i5 + 28 | 0);
   i3 = HEAP32[i10 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i3;
   HEAP32[i4 >> 2] = i2;
   i3 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i9 >> 2] = i3;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i12 >> 2] | 0, i2);
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
    i1 = i2;
    break;
   } else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
  }
  if ((i1 | 0) == (i7 | 0)) break; else i5 = i1;
 }
 STACKTOP = i14;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 1) | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 HEAP32[i6 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i5 >> 2] = i2;
 i7 = i13 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i13 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _UNITY_FT_Remove_Module(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i1) {
  i10 = 33;
  return i10 | 0;
 }
 if (!i10) {
  i10 = 34;
  return i10 | 0;
 }
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + 20 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) {
  i10 = 34;
  return i10 | 0;
 }
 i1 = i1 + 20 | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) break;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 34;
   i5 = 26;
   break;
  }
 }
 if ((i5 | 0) == 26) return i1 | 0;
 HEAP32[i2 >> 2] = i3 + -1;
 i2 = i4 + -4 | 0;
 if (i1 >>> 0 < i2 >>> 0) do {
  i9 = i1;
  i1 = i1 + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 } while (i1 >>> 0 < i2 >>> 0);
 HEAP32[i2 >> 2] = 0;
 i6 = i10 + 8 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 if (i8 | 0) {
  i1 = i8 + 160 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) HEAP32[i1 >> 2] = 0;
  if (HEAP32[i7 >> 2] & 2 | 0) {
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i8 + 148 | 0;
   i3 = _UNITY_FT_List_Find(i2, i10) | 0;
   if (i3 | 0) {
    i4 = HEAP32[i10 + 12 >> 2] | 0;
    if ((HEAP32[i4 + 36 >> 2] | 0) == 1869968492) {
     i5 = HEAP32[i10 + 52 >> 2] | 0;
     if (i5 | 0) mftCall_vi(HEAP32[(HEAP32[i4 + 56 >> 2] | 0) + 20 >> 2] | 0, i5 | 0);
    }
    _UNITY_FT_List_Remove(i2, i3);
    _UNITY_ft_mem_free(i1, i3);
    i1 = HEAP32[i8 + 148 >> 2] | 0;
    L31 : do if (!i1) i1 = 0; else {
     i2 = i1;
     while (1) {
      i1 = HEAP32[i2 + 8 >> 2] | 0;
      if ((HEAP32[i1 + 16 >> 2] | 0) == 1869968492) break L31;
      i2 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i2) {
       i1 = 0;
       break;
      }
     }
    } while (0);
    HEAP32[i8 + 156 >> 2] = i1;
   }
  }
 }
 if (HEAP32[HEAP32[i10 >> 2] >> 2] & 1 | 0) _UNITY_FT_List_Finalize(i10 + 16 | 0, fb + 960 | 0, HEAP32[i6 >> 2] | 0, i10);
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i10 | 0);
 _UNITY_ft_mem_free(i9, i10);
 i10 = 0;
 return i10 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i12 = i5 + 16 | 0;
  i4 = i3 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP8[i12 + 16 >> 0] = HEAP8[i4 + 16 >> 0] | 0;
  i3 = i3 + 36 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 36 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i12 = i5 + 16 | 0;
  i4 = i3 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP8[i12 + 16 >> 0] = HEAP8[i4 + 16 >> 0] | 0;
  i3 = i3 + 36 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 36 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10ReallocateEPvji(i10, i1, i7, i4) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 if (!i1) {
  i12 = mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i7 | 0, i4 | 0) | 0;
  return i12 | 0;
 }
 i3 = i1 + -8 | 0;
 if (!(HEAP32[i3 >> 2] & 1)) i2 = 0; else i2 = HEAP32[i1 + -12 >> 2] | 0;
 i5 = (HEAP32[i3 >> 2] | 0) >>> 1;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i5;
 i9 = i10 + 28 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -23;
 i11 = i10 + 12 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 i12 = i10 + 20 | 0;
 HEAP32[i12 >> 2] = -23 - i5 + (HEAP32[i12 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv(i10, i1) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i5 >>> 1;
 if (!(i5 & 1)) i5 = 0; else i5 = HEAP32[i1 + -12 >> 2] | 0;
 i2 = __ZN17LowLevelAllocator7ReallocEPvjj(i3 + (0 - i2) | 0, i7 + 7 + i4 | 0, i6 + 31 | 0) | 0;
 if (!i2) {
  i12 = 0;
  return i12 | 0;
 }
 i1 = -8 - i2 & i4 + -1;
 if ((i1 | 0) != (i5 | 0)) {
  i4 = i2 + 8 | 0;
  _memmove(i4 + i1 | 0, i4 + i5 | 0, (i6 >>> 0 > i7 >>> 0 ? i7 : i6) | 0) | 0;
 }
 i3 = i2 + i1 | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -2;
  i1 = 0;
  i2 = i3;
 } else {
  _memset(i2 | 0, -86, i1 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
  HEAP32[i3 + -4 >> 2] = i1;
  i1 = 1;
  i2 = i3;
 }
 HEAP32[i2 >> 2] = i1 | i7 << 1;
 i2 = i3 + 8 | 0;
 i3 = (HEAP32[i2 + -8 >> 2] | 0) >>> 1;
 i4 = (HEAP32[i8 >> 2] | 0) + i3 | 0;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 23;
 i1 = i10 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) HEAP32[i1 >> 2] = i4;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 HEAP32[i12 >> 2] = i3 + 23 + (HEAP32[i12 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv(i10, i2) | 0;
 i12 = i2;
 return i12 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 3) | 0, 0, i4 - i5 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i3 = i8 + 11 | 0;
 i1 = i8 + 12 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i5);
 }
 i2 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i10 = i8 + 16 | 0;
  i9 = i9 + 16 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i1 >> 2] | 0;
  i10 = 9;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i3 >> 0] = i6;
  if (!i6) i1 = i8; else {
   i1 = i8;
   i10 = 11;
  }
 } else {
  i1 = i2;
  i10 = 9;
 }
 if ((i10 | 0) == 9) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i6;
  i10 = 11;
 }
 if ((i10 | 0) == 11) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 i10 = i8 + 16 | 0;
 i9 = i9 + 16 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i7;
 return;
}

function __ZN14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i7, i3, i4) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i1 = i8 + 4 | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0) | 0) > 1) {
  i7 = HEAP32[i7 + 28 >> 2] | 0;
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
  __Z6FormatPKcz(i1, gb + 429284 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 429409 | 0, 505, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(HEAP32[i7 + 364 >> 2] | 0)) {
  i7 = -1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i6 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i3, i4) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 24 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i4 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 24;
 HEAP32[i5 + (i6 * 360 | 0) + 328 >> 2] = i4;
 HEAP32[i4 >> 2] = __ZN14SpriteRenderer11GetGeometryEv(i7) | 0;
 i1 = HEAP16[i7 + 360 >> 1] | 0;
 HEAP8[i4 + 4 >> 0] = i1;
 HEAP8[i4 + 5 >> 0] = (i1 & 65535) >>> 8;
 i4 = i4 + 8 | 0;
 i1 = HEAP32[i7 + 348 >> 2] | 0;
 i2 = HEAP32[i7 + 352 >> 2] | 0;
 i3 = HEAP32[i7 + 356 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 + 344 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 HEAP32[i5 + (i6 * 360 | 0) + 332 >> 2] = fb + 222;
 HEAP32[i5 + (i6 * 360 | 0) + 344 >> 2] = fb + 2416;
 HEAP32[i5 + (i6 * 360 | 0) + 340 >> 2] = fb + 528;
 i7 = i6;
 STACKTOP = i8;
 return i7 | 0;
}

function _common(i4, d10, i2) {
 i4 = i4 | 0;
 d10 = +d10;
 i2 = i2 | 0;
 var d1 = 0.0, d3 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0;
 d8 = +Math_sin(+d10);
 d1 = +Math_cos(+d10);
 i2 = (i2 | 0) != 0;
 d1 = i2 ? -d1 : d1;
 d9 = d8 + d1;
 if (i4 >>> 0 < 2145386496) {
  d3 = d8 - d1;
  d5 = -+Math_cos(+(d10 * 2.0));
  if (d8 * d1 < 0.0) d1 = d5 / d3; else {
   d1 = d9;
   d3 = d5 / d9;
  }
  if (i4 >>> 0 < 1207959552) {
   d3 = i2 ? -d3 : d3;
   HEAPF64[tempDoublePtr >> 3] = d10;
   i6 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
   i7 = i6 >>> 0 > 1075838975;
   if (i7) {
    i2 = gb + 9016 | 0;
    i4 = gb + 8936 | 0;
   } else if (i6 >>> 0 > 1074933386) {
    i2 = gb + 9064 | 0;
    i4 = gb + 8976 | 0;
   } else {
    i4 = i6 >>> 0 > 1074191212;
    i2 = i4 ? gb + 8840 | 0 : gb + 8888 | 0;
    i4 = i4 ? gb + 8760 | 0 : gb + 8800 | 0;
   }
   d5 = 1.0 / (d10 * d10);
   d1 = d1 * ((+HEAPF64[i2 >> 3] + d5 * (+HEAPF64[i2 + 8 >> 3] + d5 * (+HEAPF64[i2 + 16 >> 3] + d5 * (+HEAPF64[i2 + 24 >> 3] + d5 * (+HEAPF64[i2 + 32 >> 3] + d5 * +HEAPF64[i2 + 40 >> 3]))))) / (d5 * (+HEAPF64[i4 >> 3] + d5 * (+HEAPF64[i4 + 8 >> 3] + d5 * (+HEAPF64[i4 + 16 >> 3] + d5 * (+HEAPF64[i4 + 24 >> 3] + d5 * +HEAPF64[i4 + 32 >> 3])))) + 1.0) + 1.0);
   if (i7) {
    i2 = gb + 9400 | 0;
    i4 = gb + 9304 | 0;
   } else if (i6 >>> 0 > 1074933386) {
    i2 = gb + 9448 | 0;
    i4 = gb + 9352 | 0;
   } else {
    i4 = i6 >>> 0 > 1074191212;
    i2 = i4 ? gb + 9208 | 0 : gb + 9256 | 0;
    i4 = i4 ? gb + 9112 | 0 : gb + 9160 | 0;
   }
   d1 = d1 - d3 * (((+HEAPF64[i2 >> 3] + d5 * (+HEAPF64[i2 + 8 >> 3] + d5 * (+HEAPF64[i2 + 16 >> 3] + d5 * (+HEAPF64[i2 + 24 >> 3] + d5 * (+HEAPF64[i2 + 32 >> 3] + d5 * +HEAPF64[i2 + 40 >> 3]))))) / (d5 * (+HEAPF64[i4 >> 3] + d5 * (+HEAPF64[i4 + 8 >> 3] + d5 * (+HEAPF64[i4 + 16 >> 3] + d5 * (+HEAPF64[i4 + 24 >> 3] + d5 * (+HEAPF64[i4 + 32 >> 3] + d5 * +HEAPF64[i4 + 40 >> 3]))))) + 1.0) + -.125) / d10);
  }
 } else d1 = d9;
 return +(d1 * .5641895835477563 / +Math_sqrt(+d10));
}

function __ZNK19CollisionListener2D10IsTouchingEPK10Collider2DS2_(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 if ((i1 | 0) == (i2 | 0)) {
  i16 = 0;
  return i16 | 0;
 }
 i3 = i1;
 i4 = i2;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) > (HEAP32[i2 + 4 >> 2] | 0);
 i6 = HEAP32[i5 + 8 >> 2] | 0;
 if ((HEAP32[i5 + 184 >> 2] | 0) == (i6 | 0)) {
  i2 = HEAP32[i5 + 176 >> 2] | 0;
  i1 = HEAP32[i5 + 180 >> 2] | 0;
  i3 = i2 + (i1 * 80 | 0) | 0;
 } else {
  i13 = i1 ? i3 : i4;
  i12 = i1 ? i4 : i3;
  i15 = HEAP32[i5 + 180 >> 2] | 0;
  i8 = i15 + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i1 + 2127912214 + (i1 << 12) | 0;
  i1 = HEAP32[i13 + 4 >> 2] ^ -949894596 ^ i1 ^ i1 >>> 19;
  i1 = i1 + 374761393 + (i1 << 5) | 0;
  i2 = HEAP32[i5 + 176 >> 2] | 0;
  i9 = HEAP32[i5 + 96 >> 2] | 0;
  i10 = i5 + 100 | 0;
  i11 = i5 + 12 | 0;
  i14 = i5 + 16 | 0;
  i7 = i5 + 20 | 0;
  i5 = 0;
  i1 = i1 + -744332180 ^ i1 << 9;
  i3 = i6;
  while (1) {
   i1 = i1 & i8;
   i4 = HEAP32[i2 + (i1 * 80 | 0) >> 2] | 0;
   if ((i9 | 0) == (i4 | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i2 + (i1 * 80 | 0) + 4 >> 2] | 0)) {
    i1 = -1;
    break;
   }
   if (!(HEAP8[i11 >> 0] | 0)) i16 = 11; else if (!i3) {
    i3 = 0;
    i16 = 11;
   } else if ((HEAP32[i14 >> 2] | 0) == (i4 | 0)) {
    if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i2 + (i1 * 80 | 0) + 4 >> 2] | 0)) i16 = 11;
   } else i16 = 11;
   if ((i16 | 0) == 11) {
    i16 = 0;
    if ((i12 | 0) == (i4 | 0)) if ((i13 | 0) == (HEAP32[i2 + (i1 * 80 | 0) + 4 >> 2] | 0)) break;
   }
   i6 = i5 + 1 | 0;
   i5 = i6;
   i1 = i6 + i1 | 0;
  }
  i3 = (i1 | 0) == -1 ? i2 + (i15 * 80 | 0) | 0 : i2 + (i1 * 80 | 0) | 0;
  i1 = i15;
 }
 if ((i3 | 0) == (i2 + (i1 * 80 | 0) | 0)) {
  i16 = 0;
  return i16 | 0;
 }
 if (!(HEAP8[i3 + 79 >> 0] | 0)) {
  i16 = 0;
  return i16 | 0;
 }
 i16 = HEAP32[i3 + 72 >> 2] | 0;
 i16 = (i16 | 0) == 1 | (i16 | 0) == 4;
 return i16 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 44 | 0;
 L1 : do if ((HEAP32[i6 >> 2] | 0) == (i7 | 0)) {
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  if (i4 | 0) {
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
    if (!((i2 | 0) == (i7 | 0) ? 1 : (HEAP32[i2 + 80 >> 2] | 0) != 2)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i4 >>> 0) break L1;
   }
   HEAP32[i6 >> 2] = i2;
   __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(i2);
   i5 = __ZN15GlobalCallbacks3GetEv() | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i5 + 37052 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = 0;
    do {
     i4 = i5 + 36284 + (i1 * 12 | 0) | 0;
     if (!(HEAP8[i5 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i4 >> 2] | 0, i7 | 0, i2 | 0); else mftCall_viii(HEAP32[i4 >> 2] | 0, HEAP32[i5 + 36284 + (i1 * 12 | 0) + 4 >> 2] | 0, i7 | 0, i2 | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
  }
 } while (0);
 i2 = i7 + 104 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i7 + 100 | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  __Z22DestroyObjectHighLevelP6Objectb(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0, 0);
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 i4 = i2 + 2312 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  __ZN10UnityScene23UnloadLevelGameManagersEv(i7);
  i7 = i7 + 80 | 0;
  HEAP32[i7 >> 2] = 0;
  return;
 } else i1 = 0;
 do {
  i5 = i2 + 1544 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 1544 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0); else mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 + 1544 + (i1 * 12 | 0) + 4 >> 2] | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 __ZN10UnityScene23UnloadLevelGameManagersEv(i7);
 i7 = i7 + 80 | 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __Z40CollectObjectHierarchyWithHideFlagFilterR10GameObjectiRNSt3__26vectorIP6ObjectNS1_9allocatorIS4_EEEE(i7, i11, i12) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i13 = i11 & 127;
 if ((HEAP32[i7 + 8 >> 2] | 0) >>> 13 & i13 | 0) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i10 >> 2] = i7;
 i8 = i12 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i12 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i10); else {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 4;
 }
 i5 = i7 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 28 | 0;
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = i2;
   i3 = i2;
   do if (i2) if (!((HEAP32[i2 + 8 >> 2] | 0) >>> 13 & i13)) {
    i2 = HEAP32[i8 >> 2] | 0;
    if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) {
     __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i10);
     i1 = HEAP32[i5 >> 2] | 0;
     break;
    } else {
     HEAP32[i2 >> 2] = i3;
     HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 4;
     break;
    }
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i4 = (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i7, gb + 28940 | 0) | 0) + 80 | 0;
 i5 = i4 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if (i2) if (!((HEAP32[i2 + 8 >> 2] | 0) >>> 13 & i13)) {
   __Z40CollectObjectHierarchyWithHideFlagFilterR10GameObjectiRNSt3__26vectorIP6ObjectNS1_9allocatorIS4_EEEE(HEAP32[i2 + 28 >> 2] | 0, i11, i12);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 STACKTOP = i14;
 return;
}

function __Z29SkipMipLevelsForTextureUploadi13TextureFormatiPPKhPiS3_S3_(i1, i5, i4, i6, i7, i9, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0;
 L1 : do if ((i1 | 0) > 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  while (1) {
   if ((i3 >> i2 | 0) >= 8) if ((HEAP32[i9 >> 2] >> i2 | 0) >= 8) {
    i1 = i2;
    break L1;
   }
   i1 = i2 + -1 | 0;
   if ((i2 | 0) > 1) i2 = i1; else break;
  }
 } while (0);
 i4 = i4 + -1 | 0;
 i1 = (i4 | 0) < (i1 | 0) ? i4 : i1;
 HEAP32[i8 >> 2] = i1;
 if ((i1 | 0) > 0) {
  i1 = 0;
  i3 = HEAP32[i9 >> 2] | 0;
  do {
   i2 = __Z18CalculateImageSizeii13TextureFormat(HEAP32[i7 >> 2] | 0, i3, i5) | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
   i2 = (HEAP32[i7 >> 2] | 0) / 2 | 0;
   HEAP32[i7 >> 2] = (i2 | 0) < 1 ? 1 : i2;
   i2 = (HEAP32[i9 >> 2] | 0) / 2 | 0;
   i3 = (i2 | 0) < 1 ? 1 : i2;
   HEAP32[i9 >> 2] = i3;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i1 | 0) < (i2 | 0));
 } else i2 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 L14 : do if ((i2 | 0) < (i4 | 0)) do {
  if ((i1 | 0) > (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0)) i1 = HEAP32[i7 >> 2] | 0; else {
   i3 = HEAP32[i9 >> 2] | 0;
   i3 = (i3 | 0) > (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i3) break L14;
  }
  i3 = __Z18CalculateImageSizeii13TextureFormat(i1, HEAP32[i9 >> 2] | 0, i5) | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i3;
  i3 = (HEAP32[i7 >> 2] | 0) / 2 | 0;
  HEAP32[i7 >> 2] = (i3 | 0) < 1 ? 1 : i3;
  i3 = (HEAP32[i9 >> 2] | 0) / 2 | 0;
  HEAP32[i9 >> 2] = (i3 | 0) < 1 ? 1 : i3;
  i3 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i3;
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i3 | 0) < (i4 | 0)); while (0);
 if ((i1 | 0) > (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP32[i9 >> 2] | 0;
 i9 = (i9 | 0) <= (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0);
 return i9 | 0;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i1;
 i8 = i9 + 36 | 0;
 i7 = i10 >>> 25;
 i6 = i10 >>> 18 & 127;
 i5 = i10 >>> 13 & 31;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + (i7 << 2) >> 2] | 0;
 i3 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
 i4 = HEAP32[i3 + (i5 << 2) >> 2] | 0;
 i11 = i4 + ((i10 >>> 9 & 15) << 2) | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & ~(1 << (i10 >>> 4 & 31));
 i11 = i4 + 64 | 0;
 i10 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
 HEAP32[i11 >> 2] = i10;
 if (!i10) {
  i1 = i9 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -68;
  __ZN13MemoryManager12LowLevelFreeEPvj(i4, 68);
  HEAP32[(HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0) + (i6 << 2) >> 2] | 0) + (i5 << 2) >> 2] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i1 + (i7 << 2) >> 2] | 0;
  i3 = HEAP32[i2 + (i6 << 2) >> 2] | 0;
 }
 i10 = i3 + 128 | 0;
 i11 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 HEAP32[i10 >> 2] = i11;
 if (!i11) {
  i1 = i9 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -132;
  __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i2 + (i6 << 2) >> 2] | 0, 132);
  HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0) + (i6 << 2) >> 2] = 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i2;
  i2 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
 }
 i10 = i2 + 512 | 0;
 i11 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 HEAP32[i10 >> 2] = i11;
 if (!i11) {
  i11 = i9 + 28 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -516;
  __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i1 + (i7 << 2) >> 2] | 0, 516);
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] = 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i10 = i1 + 512 | 0;
 i11 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
 HEAP32[i10 >> 2] = i11;
 if (i11 | 0) return 1;
 i11 = i9 + 28 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -516;
 __ZN13MemoryManager12LowLevelFreeEPvj(i1, 516);
 HEAP32[i8 >> 2] = 0;
 return 1;
}

function __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i3;
 }
 i1 = i6 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i2;
  i3 = i4;
 }
 i4 = i6 + 16 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i4, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, HEAP32[i4 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN9Heightmap15PrecomputeErrorEiiiib(i15, i16, i17, i1, i2, i18) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i18 = i18 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i19 = 0;
 i19 = i15 + 80 | 0;
 i3 = HEAP32[i19 >> 2] | 0;
 if ((i3 | 0) < 0) return;
 i14 = i1 + i16 | 0;
 i12 = i2 + i17 | 0;
 i13 = i15 + 24 | 0;
 i11 = 0;
 i1 = i3;
 while (1) {
  i10 = i1 - i11 | 0;
  i7 = 1 << i10;
  if ((i10 | 0) != 31) {
   i8 = 17 << i11;
   i9 = (i11 | 0) > 0;
   i5 = 0;
   do {
    i6 = i5 << 4 << i11;
    i10 = (i6 + i8 | 0) < (i17 | 0);
    if ((i6 | 0) <= (i12 | 0)) {
     i6 = 0;
     do {
      i3 = i6 << 4 << i11;
      if (!(i10 | ((i3 | 0) > (i14 | 0) | (i3 + i8 | 0) < (i16 | 0)))) {
       if (i18) {
        i1 = 1 << HEAP32[i19 >> 2];
        if (i9) {
         i2 = 0;
         i3 = 0;
         do {
          i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
          i1 = i1 >> 1;
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i11 | 0));
        } else i2 = 0;
        i3 = i2 + i6 + (Math_imul(i1, i5) | 0) | 0;
        HEAPF32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = Math_fround(inf);
       } else {
        f4 = Math_fround(__ZNK9Heightmap25ComputeMaximumHeightErrorEiii(i15, i6, i5, i11));
        i1 = 1 << HEAP32[i19 >> 2];
        if (i9) {
         i2 = 0;
         i3 = 0;
         do {
          i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
          i1 = i1 >> 1;
          i3 = i3 + 1 | 0;
         } while ((i3 | 0) != (i11 | 0));
        } else i2 = 0;
        i3 = i2 + i6 + (Math_imul(i1, i5) | 0) | 0;
        HEAPF32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] = f4;
       }
       __ZN9Heightmap23RecalculateMinMaxHeightEiii(i15, i6, i5, i11);
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) < (i7 | 0));
    }
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < (i7 | 0));
  }
  i1 = HEAP32[i19 >> 2] | 0;
  if ((i1 | 0) <= (i11 | 0)) break; else i11 = i11 + 1 | 0;
 }
 return;
}

function __ZN8Animator23ClearContainedRenderersEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i6 = i12;
 i10 = i9 + 428 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 440 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i7 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i6 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i8 = 12; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i2, i6);
     i3 = HEAP32[i5 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i8 = 12; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i8 = 14;
    }
   }
   if ((i8 | 0) == 12) i8 = 14;
   if ((i8 | 0) == 14) {
    i8 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i1 >> 2] | 0) | 0;
   }
  }
  __ZN6Object11RemoveEventEPFvPvS0_iES0_(i2, fb + 915 | 0, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i7 | 0));
 i1 = i9 + 444 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9 + 432 | 0);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN6b2Body9SetActiveEb(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i3 = i8 + 4 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!((i1 & 32) != 0 ^ i2)) return;
 i1 = i1 & 65535;
 if (i2) {
  HEAP16[i3 >> 1] = i1 | 32;
  i7 = (HEAP32[i8 + 88 >> 2] | 0) + 102872 | 0;
  i1 = HEAP32[i8 + 100 >> 2] | 0;
  if (!i1) return;
  i6 = i8 + 12 | 0;
  do {
   i3 = i1 + 32 | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
   i4 = i1 + 48 | 0;
   HEAP32[i4 >> 2] = i8;
   if ((i8 | 0) > 0) {
    i5 = i1 + 44 | 0;
    i2 = 0;
    do {
     i8 = HEAP32[i5 >> 2] | 0;
     i9 = i8 + (i2 * 28 | 0) | 0;
     i10 = HEAP32[i3 >> 2] | 0;
     mftCall_viiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i9 | 0, i6 | 0, i2 | 0, 1);
     HEAP32[i8 + (i2 * 28 | 0) + 24 >> 2] = __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv(i7, i9, i9) | 0;
     HEAP32[i8 + (i2 * 28 | 0) + 16 >> 2] = i1;
     HEAP32[i8 + (i2 * 28 | 0) + 20 >> 2] = i2;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
   }
   i1 = HEAP32[i1 + 24 >> 2] | 0;
  } while ((i1 | 0) != 0);
  return;
 }
 HEAP16[i3 >> 1] = i1 & 65503;
 i6 = i8 + 88 | 0;
 i5 = (HEAP32[i6 >> 2] | 0) + 102872 | 0;
 i1 = HEAP32[i8 + 100 >> 2] | 0;
 if (i1 | 0) do {
  i3 = i1 + 48 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i4 = i1 + 44 | 0;
   i2 = 0;
   do {
    i10 = (HEAP32[i4 >> 2] | 0) + (i2 * 28 | 0) + 24 | 0;
    __ZN12b2BroadPhase12DestroyProxyEi(i5, HEAP32[i10 >> 2] | 0);
    HEAP32[i10 >> 2] = -1;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
  }
  HEAP32[i3 >> 2] = 0;
  i1 = HEAP32[i1 + 24 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i2 = i8 + 112 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i10 = i1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  __ZN16b2ContactManager7DestroyEP9b2Contact((HEAP32[i6 >> 2] | 0) + 102872 | 0, HEAP32[i10 + 4 >> 2] | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN5physx20PxsParticleSystemSim15collisionUpdateEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 + 44 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 1104 >> 2]);
 f6 = Math_fround(f6 * f5);
 i4 = f6 < Math_fround(1.0);
 f6 = Math_fround(Math_fround(1.0) - f6);
 HEAPF32[i2 + 636 >> 2] = i4 ? f6 : Math_fround(0.0);
 HEAP32[i2 + 624 >> 2] = HEAP32[i2 + 1112 >> 2];
 HEAP32[i2 + 628 >> 2] = HEAP32[i2 + 1116 >> 2];
 HEAP32[i2 + 632 >> 2] = HEAP32[i2 + 1120 >> 2];
 HEAP32[i2 + 696 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP32[i2 + 700 >> 2] = HEAP32[i3 + 68 >> 2];
 HEAP32[i2 + 704 >> 2] = HEAP32[i3 + 72 >> 2];
 HEAP32[i2 + 708 >> 2] = HEAP32[i3 + 76 >> 2];
 HEAPF32[i2 + 688 >> 2] = f5;
 i4 = f5 > Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f5);
 HEAPF32[i2 + 692 >> 2] = i4 ? f5 : Math_fround(0.0);
 f5 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 i4 = f5 < Math_fround(0.0);
 f5 = i4 ? Math_fround(0.0) : f5;
 i4 = f5 > Math_fround(.949999988);
 HEAPF32[i2 + 640 >> 2] = i4 ? Math_fround(.949999988) : f5;
 f5 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 i4 = f5 < Math_fround(.00100000005);
 f5 = i4 ? Math_fround(.00100000005) : f5;
 i4 = f5 > Math_fround(1.0);
 HEAPF32[i2 + 644 >> 2] = i4 ? Math_fround(1.0) : f5;
 f5 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 HEAPF32[i2 + 648 >> 2] = Math_fround(f5 * f5);
 i4 = HEAP32[i3 + 84 >> 2] | 0;
 HEAP32[i2 + 716 >> 2] = (Math_imul(Math_imul(i4, 4999879) | 0, i4) | 0) & 65535;
 HEAP32[i2 + 712 >> 2] = HEAP32[i3 + 20 >> 2];
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = 2122317823;
 HEAP32[i3 + 28 >> 2] = 2122317823;
 HEAP32[i3 + 32 >> 2] = 2122317823;
 HEAP32[i3 + 36 >> 2] = -25165825;
 HEAP32[i3 + 40 >> 2] = -25165825;
 HEAP32[i3 + 44 >> 2] = -25165825;
 i3 = i2 + 624 | 0;
 __ZN5physx17PxsFluidCollision15updateCollisionEPKhRNS_10PxBaseTaskE(i3, HEAP32[i2 + 1304 >> 2] | 0, i1);
 __ZN5physx17PxsFluidCollision23updateOverflowParticlesEv(i3);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i2 = HEAP32[i6 + 16 >> 2] | 0;
   if (!i2) i5 = i6; else {
    i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
    mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
    i5 = i6;
   }
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5Umbra15OcclusionBufferaSERKS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (i4 | 0) == 0 ? 0 : i4 + 15 & -16;
 i1 = i1 + 15 & -16;
 i2 = i1;
 HEAP8[i3 + 1412 >> 0] = HEAP8[i2 + 1412 >> 0] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i3 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i3 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i3 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i3 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i3 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAP32[i3 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i3 + 68 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i3 + 72 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i3 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAP32[i3 + 80 >> 2] = HEAP32[i2 + 80 >> 2];
 HEAP32[i3 + 84 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i3 + 88 >> 2] = HEAP32[i2 + 88 >> 2];
 HEAP32[i3 + 92 >> 2] = HEAP32[i2 + 92 >> 2];
 HEAP32[i3 + 96 >> 2] = HEAP32[i2 + 96 >> 2];
 HEAP32[i3 + 100 >> 2] = HEAP32[i2 + 100 >> 2];
 HEAP32[i3 + 104 >> 2] = HEAP32[i2 + 104 >> 2];
 HEAP32[i3 + 108 >> 2] = HEAP32[i2 + 108 >> 2];
 HEAP32[i3 + 112 >> 2] = HEAP32[i2 + 112 >> 2];
 HEAP32[i3 + 116 >> 2] = HEAP32[i2 + 116 >> 2];
 HEAP32[i3 + 120 >> 2] = HEAP32[i2 + 120 >> 2];
 HEAP32[i3 + 124 >> 2] = HEAP32[i2 + 124 >> 2];
 _memcpy(i3 + 128 | 0, i2 + 128 | 0, 1276) | 0;
 i1 = i3 + 1408 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 1416 >> 2] = HEAP32[i2 + 1416 >> 2];
 i2 = i2 + 1408 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return i4 | 0;
 i3 = i3 + 1424 | 0;
 HEAP32[i1 >> 2] = i3;
 _memcpy(i3 | 0, HEAP32[i2 >> 2] | 0, 16384) | 0;
 return i4 | 0;
}

function __ZN12QuadTreeNode14PrepareBuffersER15TerrainRenderer(i11, i12) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = i11 + 60 | 0;
 i10 = i11 + 4 | 0;
 if (!(HEAP8[i13 >> 0] & 2)) {
  i1 = HEAP32[i10 >> 2] | 0;
  if (!i1) i2 = 5; else {
   i9 = HEAP32[i1 + 8 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0) | 0) i2 = 5; else i1 = HEAP8[i13 >> 0] | 0;
  }
 } else i2 = 5;
 if ((i2 | 0) == 5) {
  i1 = HEAP32[i10 >> 2] | 0;
  if (i1 | 0) {
   i3 = i12 + 116 | 0;
   i4 = i12 + 128 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i5 + 1 | 0;
   i7 = i12 + 132 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i9 = i8 & 2147483647;
   do if (i6 >>> 0 > i9 >>> 0) {
    i2 = i8 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
     HEAP32[i7 >> 2] = i2;
     HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i12 + 120 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12 + 120 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
     HEAP32[i7 >> 2] = i2;
     HEAP32[i3 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i4 >> 2] = i6;
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
  }
  __ZN15TerrainRenderer20GetPatchVertexStreamEiiiPP15SharedGfxBuffer(i12, HEAP32[i11 + 24 >> 2] | 0, HEAP32[i11 + 28 >> 2] | 0, HEAP32[i11 + 32 >> 2] | 0, i10);
  i1 = HEAP8[i13 >> 0] & -3;
  HEAP8[i13 >> 0] = i1;
 }
 if (!(i1 & 4)) {
  i1 = HEAP32[i11 >> 2] | 0;
  if (i1 | 0) {
   i10 = HEAP32[i1 + 8 >> 2] | 0;
   if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0)) return;
  }
 }
 HEAP32[i11 >> 2] = __ZN15TerrainRenderer19GetPatchIndexBufferEi(i12, HEAP32[i11 + 8 >> 2] | 0) | 0;
 HEAP8[i13 >> 0] = HEAP8[i13 >> 0] & -5;
 return;
}

function __ZL9SetUvRectP6SpriteR5RectTIfE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i3 = i11;
 i4 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0;
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 9;
   }
  }
  if ((i9 | 0) == 7) i9 = 9;
  if ((i9 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 f13 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
 f14 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0);
 f6 = Math_fround(f6 / f14);
 f7 = Math_fround(f7 / f13);
 f8 = Math_fround(f8 / f14);
 HEAPF32[i10 >> 2] = Math_fround(f5 / f13);
 HEAPF32[i10 + 8 >> 2] = f7;
 HEAPF32[i10 + 4 >> 2] = f6;
 HEAPF32[i10 + 12 >> 2] = f8;
 STACKTOP = i11;
 return;
}

function __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i2 + 24 | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo(i9, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i4 = (i1 | 0) != 0;
 if (i4) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i5, i1);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_(i1, i5);
  i1 = i1 + 296 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (i4) __ZN17RemapPPtrTransfer11PopMetaFlagEv(i5);
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i3 >> 2] | 0, HEAP32[i6 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i6 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function _tt_cmap12_char_map_binary(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = HEAP32[i12 + 16 >> 2] | 0;
 i10 = HEAPU8[i3 + 13 >> 0] << 16 | HEAPU8[i3 + 12 >> 0] << 24 | HEAPU8[i3 + 14 >> 0] << 8 | HEAPU8[i3 + 15 >> 0];
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i10) {
  i13 = 0;
  return i13 | 0;
 }
 i8 = i1 << 24 >> 24 != 0;
 do if (i8) if ((i2 | 0) == -1) {
  i13 = 0;
  return i13 | 0;
 } else {
  i11 = i2 + 1 | 0;
  break;
 } else i11 = i2; while (0);
 i6 = i3 + 16 | 0;
 i1 = 0;
 i5 = i10;
 L10 : while (1) {
  while (1) {
   i2 = (i1 + i5 | 0) >>> 1;
   i4 = i6 + (i2 * 12 | 0) + 4 | 0;
   i3 = i4 + -4 | 0;
   i3 = HEAPU8[i3 + 1 >> 0] << 16 | HEAPU8[i3 >> 0] << 24 | HEAPU8[i3 + 2 >> 0] << 8 | HEAPU8[i3 + 3 >> 0];
   i4 = i4 + 4 | 0;
   i7 = i4 + -4 | 0;
   i7 = HEAPU8[i7 + 1 >> 0] << 16 | HEAPU8[i7 >> 0] << 24 | HEAPU8[i7 + 2 >> 0] << 8 | HEAPU8[i7 + 3 >> 0];
   if (i11 >>> 0 < i3 >>> 0) break;
   if (i11 >>> 0 <= i7 >>> 0) {
    i9 = 11;
    break L10;
   }
   i1 = i2 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i1 = 0;
    break L10;
   }
  }
  if (i1 >>> 0 < i2 >>> 0) i5 = i2; else {
   i1 = 0;
   break;
  }
 }
 if ((i9 | 0) == 11) {
  i9 = HEAPU8[i4 + 1 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i4 + 2 >> 0] << 8 | HEAPU8[i4 + 3 >> 0];
  i1 = i11 - i3 | 0;
  i1 = i9 >>> 0 > ~i1 >>> 0 ? 0 : i9 + i1 | 0;
 }
 if (!i8) {
  i13 = i1;
  return i13 | 0;
 }
 i5 = HEAP32[i12 >> 2] | 0;
 if (i11 >>> 0 > i7 >>> 0) {
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i10 | 0)) {
   i13 = 0;
   return i13 | 0;
  }
 }
 i3 = i12 + 24 | 0;
 HEAP8[i3 >> 0] = 1;
 i4 = i12 + 28 | 0;
 HEAP32[i4 >> 2] = i11;
 HEAP32[i12 + 36 >> 2] = i2;
 if ((i1 | 0) == 0 ? 1 : i1 >>> 0 >= (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
  _tt_cmap12_next(i12);
  if (!(HEAP8[i3 >> 0] | 0)) i1 = 0; else i1 = HEAP32[i12 + 32 >> 2] | 0;
 } else HEAP32[i12 + 32 >> 2] = i1;
 HEAP32[i13 >> 2] = HEAP32[i4 >> 2];
 i13 = i1;
 return i13 | 0;
}

function __ZN14CachingManager14MoveTempFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i1 = i9;
 i7 = i9 + 1092 | 0;
 i8 = i9 + 32 | 0;
 i4 = i9 + 20 | 0;
 i5 = i3 + 11 | 0;
 __ZN15FileSystemEntryC2EPKc(i7, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 if (__ZNK15FileSystemEntry6ExistsEv(i7) | 0) {
  i6 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  HEAP32[i1 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  HEAP32[i1 + 4 >> 2] = i6;
  __Z6FormatPKcz(i8, gb + 444181 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 444242 | 0, 243, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i8 = 0;
  __ZN13FileEntryDataD2Ev(i7);
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i2 + 11 | 0;
 __ZN15FileSystemEntryC2EPKc(i8, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if (__ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags(i8, i7, 0) | 0) {
  __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i3, 1, 0) | 0;
  i1 = 1;
 } else {
  i3 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  i5 = HEAP32[i8 + 1056 >> 2] | 0;
  HEAP32[i6 >> 2] = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[i6 + 8 >> 2] = i5;
  __Z6FormatPKcz(i4, gb + 444314 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 444242 | 0, 250, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = 0;
 }
 __ZN13FileEntryDataD2Ev(i8);
 i8 = i1;
 __ZN13FileEntryDataD2Ev(i7);
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN13AvatarBuilder36ReadFromLocalTransformToSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNSt3__26vectorINS_14NamedTransformENS7_9allocatorIS9_EEEE(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, i27 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i17 + 32 | 0;
 i15 = i17 + 16 | 0;
 i16 = i17;
 i10 = i1 + 4 | 0;
 i11 = i10;
 i12 = i13 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i12 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i17;
  return;
 }
 i3 = i14 + 4 | 0;
 i5 = i14 + 8 | 0;
 i7 = i15 + 4 | 0;
 i8 = i15 + 8 | 0;
 i9 = i15 + 12 | 0;
 i4 = i16 + 4 | 0;
 i6 = i16 + 8 | 0;
 i2 = 0;
 do {
  i27 = HEAP32[i1 + (i2 * 36 | 0) + 32 >> 2] | 0;
  i18 = (HEAP32[i10 >> 2] | 0) + i11 | 0;
  __ZNK9Transform16GetLocalPositionEv(i14, i27);
  __ZNK9Transform16GetLocalRotationEv(i15, i27);
  __ZNK9Transform13GetLocalScaleEv(i16, i27);
  i27 = HEAP32[i3 >> 2] | 0;
  i26 = HEAP32[i5 >> 2] | 0;
  i25 = HEAP32[i15 >> 2] | 0;
  i24 = HEAP32[i7 >> 2] | 0;
  i23 = HEAP32[i8 >> 2] | 0;
  i22 = HEAP32[i9 >> 2] | 0;
  i21 = HEAP32[i16 >> 2] | 0;
  i20 = HEAP32[i4 >> 2] | 0;
  i19 = HEAP32[i6 >> 2] | 0;
  HEAP32[i18 + (i2 * 40 | 0) >> 2] = HEAP32[i14 >> 2];
  HEAP32[i18 + (i2 * 40 | 0) + 4 >> 2] = i27;
  HEAP32[i18 + (i2 * 40 | 0) + 8 >> 2] = i26;
  HEAP32[i18 + (i2 * 40 | 0) + 12 >> 2] = i25;
  HEAP32[i18 + (i2 * 40 | 0) + 16 >> 2] = i24;
  HEAP32[i18 + (i2 * 40 | 0) + 20 >> 2] = i23;
  HEAP32[i18 + (i2 * 40 | 0) + 24 >> 2] = i22;
  HEAP32[i18 + (i2 * 40 | 0) + 28 >> 2] = i21;
  HEAP32[i18 + (i2 * 40 | 0) + 32 >> 2] = i20;
  HEAP32[i18 + (i2 * 40 | 0) + 36 >> 2] = i19;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i12 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0);
 STACKTOP = i17;
 return;
}

function __Z18ConvertUTF32toUTF8RK13dynamic_arrayImLj4EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i4 = i1 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i8, HEAP32[i4 >> 2] << 2, 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
 i7 = i1;
 i5 = i2 + (i4 << 2) | 0;
 i6 = i1 + (i4 << 2) | 0;
 if ((i4 | 0) <= 0) {
  i9 = i1;
  i9 = i9 - i7 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i8, i9, 0);
  return 1;
 }
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  if (i3 >>> 0 < 128) i4 = 1; else if (i3 >>> 0 < 2048) i4 = 2; else if (i3 >>> 0 < 65536) i4 = 3; else {
   i10 = i3 >>> 0 < 2097152;
   i4 = i10 ? 4 : 2;
   i3 = i10 ? i3 : 65533;
  }
  i1 = i1 + i4 | 0;
  if (i1 >>> 0 > i6 >>> 0) break;
  switch (i4 & 7) {
  case 4:
   {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i9 = 9;
    break;
   }
  case 3:
   {
    i9 = 9;
    break;
   }
  case 2:
   {
    i9 = 10;
    break;
   }
  case 1:
   {
    i9 = 11;
    break;
   }
  default:
   {}
  }
  if ((i9 | 0) == 9) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i9 = 10;
  }
  if ((i9 | 0) == 10) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i9 = 11;
  }
  if ((i9 | 0) == 11) {
   i9 = 0;
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = HEAPU8[gb + 584572 + i4 >> 0] | i3;
  }
  i1 = i1 + i4 | 0;
  if (i2 >>> 0 >= i5 >>> 0) {
   i9 = 14;
   break;
  }
 }
 if ((i9 | 0) == 14) {
  i10 = i1;
  i10 = i10 - i7 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i8, i10, 0);
  return 1;
 }
 i10 = i1 + (0 - i4) | 0;
 i10 = i10 - i7 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i8, i10, 0);
 return 1;
}

function __ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = i1 + 4 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if (i8 >>> 0 > 1073741823) {
  i12 = 0;
  return i12 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = i7 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + (i10 << 2) | 0;
 L4 : do if (!i10) {
  i2 = i1;
  i4 = 5;
 } else {
  i2 = i1;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) {
    i4 = 5;
    break L4;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i4 = 6;
    break;
   }
  }
 } while (0);
 if ((i4 | 0) == 5) if ((i2 | 0) == (i3 | 0)) i4 = 6;
 if ((i4 | 0) == 6) {
  i6 = i10 + 1 | 0;
  i3 = i7 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i6 >>> 0 > i5 >>> 0) {
   i2 = i4 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i3 >> 2] = i2;
    i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    HEAP32[i7 >> 2] = i1;
    break;
   } else {
    i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i7 >> 2] = i1;
    break;
   }
  } while (0);
  HEAP32[i9 >> 2] = i6;
  HEAP32[i1 + (i10 << 2) >> 2] = i8;
 }
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 i4 = HEAP32[i11 + 12 >> 2] | 0;
 if ((i1 | 0) >= (i4 | 0)) {
  i12 = 1;
  return i12 | 0;
 }
 i3 = HEAP32[i11 + 32 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
   i4 = 16;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 1;
   i4 = 17;
   break;
  }
 }
 if ((i4 | 0) == 16) return (i1 | 0) < 0 | 0; else if ((i4 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZN12LightsModule5CacheER19ParticleSystemState(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
 }
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 i9 = i3 + 4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 HEAP32[i6 + 452 >> 2] = i3;
 i6 = i7 + 592 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i3 | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i7 + 584 | 0;
 i5 = i7 + 576 | 0;
 i1 = i7 + 580 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i5 | 0)) {
  i9 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 + 4 >> 2] = i2;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 >> 2] = i9;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i5 >> 2] = i5;
 }
 HEAP32[i6 >> 2] = i3;
 STACKTOP = i8;
 return;
}

function __ZN11LightProbes8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 i2 = i4 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 899468 | 0, gb + 378416 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11LightProbes14LightProbeData8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 148 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378431 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 168 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378451 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI19LightProbeOcclusionLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 3;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 3) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i5 = i1 + (i6 << 3) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i9 >> 2] = i2;
   i2 = i6;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15CollisionModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i5 = i1 + 224 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = f7 < Math_fround(0.0);
 i3 = f7 > Math_fround(1.0);
 f7 = i3 ? Math_fround(1.0) : f7;
 f7 = i6 ? Math_fround(0.0) : f7;
 HEAPF32[i5 >> 2] = f7;
 HEAP8[i1 + 230 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 144 | 0, i1 + 232 | 0, f7, HEAP16[i1 + 228 >> 1] | 0) | 0) & 1;
 i5 = i1 + 488 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = f7 < Math_fround(0.0);
 i3 = f7 > Math_fround(2.0);
 f7 = i3 ? Math_fround(2.0) : f7;
 f7 = i6 ? Math_fround(0.0) : f7;
 HEAPF32[i5 >> 2] = f7;
 HEAP8[i1 + 494 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 408 | 0, i1 + 496 | 0, f7, HEAP16[i1 + 492 >> 1] | 0) | 0) & 1;
 i5 = i1 + 752 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = f7 < Math_fround(0.0);
 i3 = f7 > Math_fround(1.0);
 f7 = i3 ? Math_fround(1.0) : f7;
 f7 = i6 ? Math_fround(0.0) : f7;
 HEAPF32[i5 >> 2] = f7;
 HEAP8[i1 + 758 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 672 | 0, i1 + 760 | 0, f7, HEAP16[i1 + 756 >> 1] | 0) | 0) & 1;
 i5 = i1 + 940 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i6 = Math_fround(HEAPF32[i5 >> 2]) < Math_fround(0.0);
 i6 = HEAP32[(i6 ? i4 : i5) >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i3 = i1 + 936 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = f7 < Math_fround(HEAPF32[i3 >> 2]);
 HEAP32[i3 >> 2] = HEAP32[(i6 ? i5 : i3) >> 2];
 i3 = i1 + 944 | 0;
 HEAPF32[i4 >> 2] = Math_fround(.00999999977);
 i5 = Math_fround(HEAPF32[i3 >> 2]) < Math_fround(.00999999977);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i4 : i3) >> 2];
 i1 = i1 + 952 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i3 | 0) < 0 ? 0 : i3;
 STACKTOP = i2;
 return;
}

function __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 3;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 3 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 3;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 3) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 3;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 3) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 3 << 3);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -8 - i10 | 0) >>> 3) << 3);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 2;
 i1 = i10 >> 3 >>> 0 < 268435455 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 536870911;
 if (i1 >>> 0 > 536870911) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 3) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 3);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 3);
 return;
}

function __ZNK6Avatar13GetAxisLengthEi(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i2 + 56 >> 2] | 0;
 if ((i7 | 0) < 0) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 do if ((i7 | 0) < 24) {
  i2 = i8 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   f1 = Math_fround(0.0);
   return Math_fround(f1);
  }
  i4 = i3 + i2 | 0;
  i5 = i4 + 40 | 0;
  if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) i6 = 8; else i2 = i4 + 72 + (i7 << 2) | 0;
 } else {
  if ((i7 | 0) < 39) {
   i2 = i8 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) f1 = Math_fround(0.0); else {
    i6 = 8;
    break;
   }
   return Math_fround(f1);
  }
  if ((i7 | 0) >= 54) {
   f1 = Math_fround(0.0);
   return Math_fround(f1);
  }
  i2 = i8 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   f1 = Math_fround(0.0);
   return Math_fround(f1);
  } else i6 = 13;
 } while (0);
 if ((i6 | 0) == 8) {
  i4 = i2 + i3 | 0;
  i5 = i4 + 40 | 0;
  if (!(HEAP32[i5 + (HEAP32[i5 >> 2] | 0) >> 2] | 0)) i6 = 13; else {
   i4 = i4 + 48 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (!i5) i6 = 13; else i2 = i5 + i4 + (i7 + -24 << 2) | 0;
  }
 }
 do if ((i6 | 0) == 13) {
  i2 = i2 + i3 | 0;
  i6 = i2 + 40 | 0;
  if (!(HEAP32[i6 + (HEAP32[i6 >> 2] | 0) >> 2] | 0)) {
   f1 = Math_fround(0.0);
   return Math_fround(f1);
  }
  i2 = i2 + 52 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   f1 = Math_fround(0.0);
   return Math_fround(f1);
  } else {
   i2 = i4 + i2 + (i7 + -39 << 2) | 0;
   break;
  }
 } while (0);
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i3 = i3 + (i8 + 20) + 40 | 0;
 i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
 i8 = i3 + 4 | 0;
 i2 = HEAP32[i8 + (HEAP32[i8 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i8 = i3 + 16 | 0;
 f1 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + i8 + (i2 * 76 | 0) + 68 >> 2]);
 return Math_fround(f1);
}

function __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 4;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i1, i7, 0);
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 12;
 HEAP32[i7 + 4 >> 2] = i5 + 8;
 HEAP32[i7 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags(i1, i7, 0);
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i5 + 20;
 HEAP32[i7 + 4 >> 2] = i5 + 16;
 HEAP32[i7 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags(i1, i7, 0);
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i6 >> 2] = i4;
 }
 HEAP32[i5 + 24 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i5 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i6 >> 2] = i2;
  i7 = i5;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP16[i10 >> 1] | 0;
  i1 = i4 & 65535;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP16[i5 + (i2 << 3) >> 1] | 0) == i4 << 16 >> 16) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAPU16[i10 >> 1] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx17PxStringTableImplD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i10 >> 2] = gb + 120016 + 8;
 i9 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 L1 : do if (!(HEAP32[i9 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i10 + 32 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L1;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i5 = i10 + 16 | 0;
 i6 = i10 + 4 | 0;
 i8 = i10 + 20 | 0;
 i4 = i10 + 32 | 0;
 L8 : while (1) {
  do {
   if ((i1 | 0) == -1) break L8;
   i3 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 3) >> 2] | 0);
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L8;
   }
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L8;
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i10 + 48 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   _memset(HEAP32[i7 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i4 = i2 + -1 | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   if (i4) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i8 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i4 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i9 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i10 + 40 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 if (!i1) return;
 i10 = HEAP32[HEAP32[i10 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 return;
}

function __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playableb(i9, i6, i2, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i5 = i10;
 if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 180 >> 2] | 0, i9 | 0) | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i9 + 8 >> 2] | 0;
 if (!(HEAP32[i4 + 28 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + 4 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP16[gb + 1466772 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466772 | 0, i1);
  i4 = gb + 1466772 | 0;
 } else i4 = 0;
 i1 = HEAP32[i9 + 84 >> 2] | 0;
 if (i1 | 0) {
  i5 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 0) | 0;
  if ((i5 | 0) != (HEAP32[i9 + 92 >> 2] | 0)) __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i9);
 }
 i1 = HEAP32[i9 + 100 >> 2] | 0;
 if (i7) i8 = 11; else if (!(HEAP8[i1 + 24 >> 0] | 0)) i8 = 11;
 L19 : do if ((i8 | 0) == 11) {
  f3 = Math_fround(+HEAPF64[i6 + 8 >> 3] - +HEAPF64[i6 + 32 >> 3]);
  i1 = i1 + 20 | 0;
  if (!((HEAP32[i1 >> 2] | 0) != 0 | f3 == Math_fround(0.0))) HEAP32[i1 >> 2] = 1;
  __ZN26AnimatorControllerPlayable11UpdateGraphEf(i9, f3);
  while (1) {
   if (!i2) break L19;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 48 >> 2] | 0) >>> 0 > 1) break L19;
   i1 = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) i2 = i1; else break L19;
  }
  if (!(HEAP32[i2 + 16 >> 2] | 0)) {
   if (HEAP8[i9 + 74 >> 0] | 0) HEAP8[i2 + 74 >> 0] = 1;
   if (HEAP8[i9 + 73 >> 0] | 0) HEAP8[i2 + 73 >> 0] = 1;
  }
 } while (0);
 if (!i4) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i10;
 return;
}

function __ZN15ConstantForce2D8TransferI14SafeBinaryReadEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i4, i7);
 i2 = i4 + 48 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 801108 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i4 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 801116 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i4 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 801132 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 18; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 18; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 18) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26locale5__impC2ERKS1_PNS0_5facetEl(i3, i1, i8, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 HEAP32[i3 + 4 >> 2] = -1;
 HEAP32[i3 >> 2] = gb + 212688 + 8;
 i9 = i3 + 8 | 0;
 i5 = i1 + 8 | 0;
 i6 = i1 + 12 | 0;
 i7 = ((HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 2) + 1 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i9 | 0, (i7 >>> 0 > 28 ? i7 : 28) | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i7 = i3 + 144 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i7 | 0, gb + 1086428 | 0, 1);
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __ZNSt3__214__shared_count12__add_sharedEv(i8);
   if ((i3 | 0) == (i1 | 0)) i2 = 5; else {
    __THREW__ = 0;
    invoke_viii(fb + 1050 | 0, i9 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0);
    i10 = __THREW__;
    __THREW__ = 0;
    if (!(i10 & 1)) i2 = 5;
   }
   if ((i2 | 0) == 5) {
    i1 = 0;
    while (1) {
     if (i1 >>> 0 >= (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 2 >>> 0) break;
     i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     if (i2 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i2);
     i1 = i1 + 1 | 0;
    }
    __THREW__ = 0;
    invoke_viii(fb + 1058 | 0, i3 | 0, i8 | 0, i4 | 0);
    i10 = __THREW__;
    __THREW__ = 0;
    if (!(i10 & 1)) {
     if (i8 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i8) | 0;
     return;
    }
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (i8 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i8) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  }
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i9);
 }
 ___resumeException(i1 | 0);
}

function __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 if (!i2) {
  i9 = -1;
  return i9 | 0;
 }
 i8 = HEAP32[i3 + 24 >> 2] & 31;
 i1 = Math_imul(i8, i1) | 0;
 i10 = i3 + i2 + (i1 >> 5 << 2) | 0;
 i11 = i10 + 4 | 0;
 i2 = i1 & 31;
 i1 = (1 << i8) + -1 | 0;
 i2 = ((HEAPU8[i11 >> 0] | HEAPU8[i11 + 1 >> 0] << 8 | HEAPU8[i11 + 2 >> 0] << 16 | HEAPU8[i11 + 3 >> 0] << 24) << 32 - i2 & -1 << (i2 ^ 31) | (HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24) >>> i2) & i1;
 if (!(i2 & 1 << i8 + -1)) {
  if ((i2 | 0) >= 0) {
   i11 = i2;
   return i11 | 0;
  }
 } else if ((i2 | 0) == (i1 | 0)) {
  i11 = -1;
  return i11 | 0;
 } else i2 = i2 & i1 >>> 1 | -2147483648;
 if ((i2 | 0) == -1) {
  i11 = -1;
  return i11 | 0;
 }
 i8 = i3 + (HEAP32[i3 + 64 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[i3 + 72 >> 2] | 0) | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i1 = i2 & 2147483647;
 while (1) {
  i1 = i8 + (i1 << 3) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i11 = i2 & 1073741823;
  f14 = Math_fround(HEAPF32[i3 + (i11 << 4) >> 2]);
  f13 = Math_fround(HEAPF32[i3 + (i11 << 4) + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i3 + (i11 << 4) + 8 >> 2]);
  if (Math_fround(Math_fround(HEAPF32[i3 + (i11 << 4) + 12 >> 2]) + Math_fround(Math_fround(Math_fround(f14 * f6) + Math_fround(f13 * f7)) + Math_fround(f12 * f5))) < Math_fround(0.0)) {
   i1 = i1 & 65535;
   if (!(i2 & 1073741824)) continue; else {
    i9 = 9;
    break;
   }
  } else {
   i1 = _bitshift64Lshr(i2 | 0, i1 | 0, 48) | 0;
   getTempRet0() | 0;
   if ((i2 | 0) < 0) break; else continue;
  }
 }
 if ((i9 | 0) == 9) return ((i1 | 0) == 65535 ? -1 : i1) | 0;
 i11 = (i1 | 0) == 65535 ? -1 : i1;
 return i11 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE5eraseERKS4_(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i14 + 20 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if (!i2) {
  i14 = 0;
  return i14 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = i7;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i12 = i14 + 12 | 0;
 i2 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i14 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i14 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i4 = i2;
 while (1) {
  i3 = i8 + (i1 << 2) | 0;
  i2 = i4;
  i4 = i6 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) {
   i4 = i3;
   break;
  }
  if ((i1 | 0) == -1) {
   i1 = 0;
   i11 = 11;
   break;
  }
 }
 if ((i11 | 0) == 11) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i14 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i11 = i14 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 2) >> 2];
  i4 = HEAP32[i9 >> 2] | 0;
  HEAP32[i4 + (i5 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (HEAP32[i12 >> 2] | 0) + (((i1 >>> 16 ^ i1) & (HEAP32[i13 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i14 = i14 + 28 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx3Ext20DefaultCpuDispatcher10submitTaskERNS_10PxBaseTaskE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i1 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i2 = i6 + 28 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  if (!(HEAP8[i6 + 33 >> 0] | 0)) {
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
   i1 = i5;
  } else {
   i7 = i5 + 8 | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 104 >> 2] | 0, i6 | 0, i5 | 0, i1 | 0);
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
   i7 = HEAP32[i7 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i5 | 0, i1 | 0);
   i1 = i5;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i5 | 0);
  return;
 }
 i3 = i6 + 4 | 0;
 i4 = 0;
 do {
  if (__ZN5physx3Ext15CpuWorkerThread24tryAcceptJobToLocalQueueERNS_10PxBaseTaskEj((HEAP32[i3 >> 2] | 0) + (i4 * 28 | 0) | 0, i5, i1) | 0) {
   i7 = 9;
   break;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 if ((i7 | 0) == 9) {
  __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i6 + 20 >> 2] | 0);
  return;
 }
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i6 + 12 >> 2] | 0) | 0;
 if (!i1) {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, 27, (i1 ? gb + 661229 | 0 : gb + 837976 | 0) | 0, gb + 661359 | 0, 109) | 0;
  if (!i1) return;
  i4 = i1 + 11 & -8;
  HEAP32[i4 + -4 >> 2] = i4 - i1;
  i1 = i4;
  if (!i4) i7 = 15; else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP8[i1 + 8 >> 0] = 0;
  }
 } else {
  HEAP32[i1 + 4 >> 2] = i5;
  i7 = 15;
 }
 if ((i7 | 0) == 15) if (!i1) return;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i6 + 16 >> 2] | 0, i1);
 __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i6 + 20 >> 2] | 0);
 return;
}

function __ZN16BaseVideoTexture10YUYVToRGBAEPti(i1, i2, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i3, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 if ((i7 | 0) <= 0) return;
 i8 = 0 - i3 | 0;
 if ((i9 | 0) <= 1) return;
 i6 = 0;
 i4 = i4 + (Math_imul(i7 + -1 | 0, i3) | 0) | 0;
 while (1) {
  i1 = i4;
  i3 = i2;
  i5 = 0;
  while (1) {
   i15 = HEAP32[gb + 1464132 + ((HEAPU8[i3 >> 0] | 0) << 2) >> 2] | 0;
   i12 = HEAPU8[i3 + 1 >> 0] | 0;
   i11 = HEAP32[gb + 1464132 + ((HEAPU8[i3 + 2 >> 0] | 0) << 2) >> 2] | 0;
   i13 = HEAPU8[i3 + 3 >> 0] | 0;
   i14 = HEAP32[gb + 1460036 + (i13 << 2) >> 2] | 0;
   i13 = (HEAP32[gb + 1462084 + (i12 << 2) >> 2] | 0) + (HEAP32[gb + 1461060 + (i13 << 2) >> 2] | 0) | 0;
   i12 = HEAP32[gb + 1463108 + (i12 << 2) >> 2] | 0;
   HEAP8[i1 >> 0] = -1;
   HEAP8[i1 + 1 >> 0] = HEAP8[i14 + i15 + (gb + 1552713 + 384) >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i15 - i13 + (gb + 1552713 + 384) >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i12 + i15 + (gb + 1552713 + 384) >> 0] | 0;
   HEAP8[i1 + 4 >> 0] = -1;
   HEAP8[i1 + 5 >> 0] = HEAP8[i14 + i11 + (gb + 1552713 + 384) >> 0] | 0;
   HEAP8[i1 + 6 >> 0] = HEAP8[i11 - i13 + (gb + 1552713 + 384) >> 0] | 0;
   HEAP8[i1 + 7 >> 0] = HEAP8[i12 + i11 + (gb + 1552713 + 384) >> 0] | 0;
   i5 = i5 + 2 | 0;
   if ((i5 | 1 | 0) >= (i9 | 0)) break; else {
    i1 = i1 + 8 | 0;
    i3 = i3 + 4 | 0;
   }
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == (i7 | 0)) break; else {
   i2 = i2 + (i10 << 1) | 0;
   i4 = i4 + i8 | 0;
  }
 }
 return;
}

function __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 i7 = i4 + 92 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i6 + 16 | 0;
   i3 = HEAP32[i6 + 20 >> 2] | 0;
   i1 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i3 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i7, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 76 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 946522 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 800705 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 3) | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13MonoBehaviour31AddBehaviourCallbacksToManagersEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i7 + 56 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i7 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z19GetBehaviourManagerv() | 0, i7 + 72 | 0, i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (HEAP32[i1 + 16 >> 2] | 0) {
  __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z24GetFixedBehaviourManagerv() | 0, i7 + 84 | 0, i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (HEAP32[i1 + 8 >> 2] | 0) {
  __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z23GetLateBehaviourManagerv() | 0, i7 + 96 | 0, i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (HEAP32[i1 + 56 >> 2] | 0) {
  i2 = i7 + 120 | 0;
  i3 = (__Z16GetRenderManagerv() | 0) + 68 | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = i7 + 124 | 0; else {
    i9 = i7 + 124 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
    HEAP32[HEAP32[i9 >> 2] >> 2] = i1;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i9 >> 2] = 0;
    i1 = i9;
   }
   i9 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i9 + 4 >> 2] = i2;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  }
 }
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 if (!(__Z9GetIIMGUIv() | 0)) {
  _printf_console(gb + 587839 | 0, i5);
  STACKTOP = i8;
  return;
 }
 i2 = __Z9GetIIMGUIv() | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i7 + 136 >> 2] = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 i9 = __Z9GetIIMGUIv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i7 + 108 | 0);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim4hand8HandPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i6, i1);
 HEAP32[i2 >> 2] = 20;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = 20;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
 i4 = i6 + 120 | 0;
 i1 = i6 + 40 | 0;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 120 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 124 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 128 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 132 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  STACKTOP = i8;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 24 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4 + ~(i4 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 8 >> 2] | 0;
   i3 = i11 + 12 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 20 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 16 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 36 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 8 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx14PxRigidBodyExt18addForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i1, i2, i4, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 28 | 0;
 i11 = i6;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i11 | 0, i1 | 0);
 f14 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(2.0));
 f16 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(2.0));
 f19 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(2.0));
 f17 = Math_fround(HEAPF32[i11 + 12 >> 2]);
 f18 = Math_fround(Math_fround(f17 * f17) + Math_fround(-.5));
 f15 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(f14 * f15);
 f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f16 * f13));
 f12 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f19 * f12));
 f10 = Math_fround(Math_fround(f15 * f8) + Math_fround(Math_fround(f14 * f18) + Math_fround(f17 * Math_fround(Math_fround(f19 * f13) - Math_fround(f16 * f12)))));
 f9 = Math_fround(Math_fround(f13 * f8) + Math_fround(Math_fround(f16 * f18) + Math_fround(f17 * Math_fround(Math_fround(f14 * f12) - Math_fround(f19 * f15)))));
 f8 = Math_fround(Math_fround(Math_fround(f19 * f18) + Math_fround(f17 * Math_fround(Math_fround(f16 * f15) - Math_fround(f14 * f13)))) + Math_fround(f12 * f8));
 f10 = Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) + f10);
 f9 = Math_fround(Math_fround(HEAPF32[i11 + 20 >> 2]) + f9);
 f8 = Math_fround(Math_fround(HEAPF32[i11 + 24 >> 2]) + f8);
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i7 + 4 >> 2] = f9;
 HEAPF32[i7 + 8 >> 2] = f8;
 __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb(i1, i2, i7, i3, i5);
 STACKTOP = i6;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i3 = i8 + 11 | 0;
 i1 = i8 + 12 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  i6 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i5);
 }
 i2 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 if ((HEAP8[i9 + 11 >> 0] | 0) >= 0) {
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i10 = i8 + 16 | 0;
  i9 = i9 + 16 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i1 >> 2] | 0;
  i10 = 9;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i3 >> 0] = i6;
  if (!i6) i1 = i8; else {
   i1 = i8;
   i10 = 11;
  }
 } else {
  i1 = i2;
  i10 = 9;
 }
 if ((i10 | 0) == 9) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i6;
  i10 = 11;
 }
 if ((i10 | 0) == 11) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 i10 = i8 + 16 | 0;
 i9 = i9 + 16 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i7;
 return;
}

function __Z56AssetBundleManifest_CUSTOM_GetAllAssetBundlesWithVariantP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN19AssetBundleManifest29GetAllAssetBundlesWithVariantERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i2, i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i8 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i6 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i8 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i5 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i6 = i4 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 + 12 >> 2] = i4;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
   i4 = HEAP32[i3 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i3 + 11 >> 0] = i6;
   if (!i6) i4 = i3; else {
    i4 = i3;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i6 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i4;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i3 + 4 >> 2] = i6;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i4 | 0, i5 | 0, i6 | 0) | 0;
  }
  HEAP8[i4 + i6 >> 0] = 0;
  i6 = i1 + 16 | 0;
  i13 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = i3 + 16 | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i13;
  i1 = i2 + 24 | 0;
  i3 = (HEAP32[i8 >> 2] | 0) + 24 | 0;
  HEAP32[i8 >> 2] = i3;
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZN21AnimationClipOverride8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905707 | 0, gb + 905722 | 0, i1, 0);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905742 | 0, gb + 905722 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 715737 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 212 | 0;
 i5 = i2 + 160 | 0;
 i6 = i2 + 80 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 24, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 i11 = i1 + 20 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 0;
 i4 = i5 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i4);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 8 | 0, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 0);
 i5 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 12 | 0, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN14ConstantStringD2Ev(i4);
 STACKTOP = i1;
 return;
}

function __ZN21UnityWebStream_Static11WriteStringERNSt3__26vectorIhNS0_9allocatorIhEEEERKNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 20 | 0;
 i2 = i11 + 16 | 0;
 i3 = i11 + 12 | 0;
 i6 = i11 + 8 | 0;
 i7 = i11 + 4 | 0;
 i8 = i11;
 i10 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i12 = i5 << 24 >> 24 < 0;
 i13 = i12 ? HEAP32[i1 >> 2] | 0 : i1;
 HEAP32[i7 >> 2] = i13;
 HEAP32[i8 >> 2] = i13 + (i12 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255);
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__26vectorIcNS_9allocatorIcEEE6insertINS_11__wrap_iterIPKcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsISA_E9referenceEEE5valueENS5_IPcEEE4typeES8_SA_SA_(i9, i3, i2, i4) | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i4 = i9 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1;
 if ((i1 | 0) != (i2 | 0)) {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i3 - i1 + 1 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i8 = i4;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 } else i8 = i4;
 i7 = i1;
 i2 = i2 - i1 | 0;
 i6 = i2 << 1;
 i6 = i2 >>> 0 < 1073741823 ? (i6 >>> 0 < i5 >>> 0 ? i5 : i6) : 2147483647;
 i2 = i3 - i1 | 0;
 if (!i6) i4 = 0; else i4 = __Znwj(i6) | 0;
 i3 = i4 + i2 | 0;
 HEAP8[i3 >> 0] = 0;
 i5 = i3 + (0 - i2) | 0;
 if ((i2 | 0) > 0) _memcpy(i5 | 0, i7 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i10 >> 2] = i3 + 1;
 HEAP32[i8 >> 2] = i4 + i6;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i11;
 return;
}

function __ZN12GraphicsCaps11ClearMemoryEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 if (i6 << 24 >> 24 < 0) {
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i7 = i3 + 16 | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP8[i7 + 11 >> 0] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (i6 << 24 >> 24 < 0) {
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i6 = i3 + 32 | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 if (i7 << 24 >> 24 < 0) {
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i6 = i3 + 48 | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 if (i7 << 24 >> 24 < 0) {
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i6 = i3 + 64 | 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP8[i6 + 11 >> 0] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 if (i7 << 24 >> 24 >= 0) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 STACKTOP = i5;
 return;
}

function __ZNSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE25__construct_node_with_keyERSD_(i10, i1, i4) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 54;
 HEAP32[i6 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i7 + 27 >> 0] = i4;
   if (i4) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i3 = i4 + 16 & -16;
   HEAP32[i6 >> 2] = 54;
   HEAP32[i6 + 4 >> 2] = i2;
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
   HEAP32[i7 + 20 >> 2] = i4;
   i1 = i6;
   i11 = 8;
  }
  if ((i11 | 0) == 8) _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
  HEAP8[i1 + i4 >> 0] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 }
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i11 = i10 + 9 | 0;
 HEAP8[i11 >> 0] = 1;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i10, i6, i11, i2, i3, i8) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i1 = HEAP32[i10 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i13 = i6;
  i4 = i2 - i13 >> 2;
  i7 = i3 + 12 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i4 = (i5 | 0) > (i4 | 0) ? i5 - i4 | 0 : 0;
  i5 = i11;
  i13 = i5 - i13 | 0;
  i3 = i13 >> 2;
  if ((i13 | 0) > 0) if ((mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i6 | 0, i3 | 0) | 0) != (i3 | 0)) {
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
   break;
  }
  do if ((i4 | 0) > 0) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i9 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i9, i4, i8);
   __THREW__ = 0;
   i3 = invoke_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, ((HEAP8[i9 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0, i4 | 0) | 0;
   i13 = __THREW__;
   __THREW__ = 0;
   if (i13 & 1) {
    i13 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
    ___resumeException(i13 | 0);
   }
   if ((i3 | 0) == (i4 | 0)) {
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
    break;
   } else {
    HEAP32[i10 >> 2] = 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i9);
    i1 = 0;
    break L1;
   }
  } while (0);
  i13 = i2 - i5 | 0;
  i2 = i13 >> 2;
  if ((i13 | 0) > 0) if ((mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i11 | 0, i2 | 0) | 0) != (i2 | 0)) {
   HEAP32[i10 >> 2] = 0;
   i1 = 0;
   break;
  }
  HEAP32[i7 >> 2] = 0;
 } while (0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE6createERKjRb(i12, i11, i7) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = (i10 | 0) == 0;
 L1 : do if (i8) i1 = 0; else {
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = i6 + ~(i6 << 15) | 0;
  i3 = (i3 >>> 10 ^ i3) * 9 | 0;
  i3 = i3 >>> 6 ^ i3;
  i3 = i3 + ~(i3 << 11) | 0;
  i3 = (i3 >>> 16 ^ i3) & i10 + -1;
  i1 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i3; else {
   i4 = HEAP32[i12 + 4 >> 2] | 0;
   i5 = i12 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
    i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = i3;
     break L1;
    }
   }
   HEAP8[i7 >> 0] = 1;
   i12 = i1;
   return i12 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i3 = i12 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i1 = i8 ? 16 : i10 << 1;
  if (i10 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj(i12, i1);
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } else {
   i2 = -1;
   i1 = i10;
  }
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + ~(i11 << 15) | 0;
  i11 = (i11 >>> 10 ^ i11) * 9 | 0;
  i11 = i11 >>> 6 ^ i11;
  i11 = i11 + ~(i11 << 11) | 0;
  i1 = (i11 >>> 16 ^ i11) & i1 + -1;
 }
 i10 = (HEAP32[i12 + 8 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 i11 = (HEAP32[i12 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i2;
 i11 = i12 + 36 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i11 = i12 + 32 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i12 = (HEAP32[i12 + 4 >> 2] | 0) + (i2 << 2) | 0;
 return i12 | 0;
}

function __ZN14MessageHandler7CleanupEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i9 + 8 | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 + 20 >> 2] = 0;
  HEAP32[i9 + 24 >> 2] = 0;
 }
 i8 = HEAP32[i9 + 28 >> 2] | 0;
 i7 = i9 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) do {
  i2 = i1 + -32 | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = HEAP32[i1 + -20 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i5 = i1 + -16 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i3);
  }
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i1 = i1 + -28 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i3);
  }
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i8 | 0));
 HEAP32[i9 + 44 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 i1 = HEAP32[i9 + 52 >> 2] | 0;
 i2 = i9 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i7 = i9 + 64 | 0;
  i8 = i9 + 68 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, i6);
  i9 = i9 + 72 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i7 >> 2] = i8;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
 i7 = i9 + 64 | 0;
 i8 = i9 + 68 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i7, i6);
 i9 = i9 + 72 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 3 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i10 = i1 + 4 | 0;
   HEAP32[i10 >> 2] = 0;
   __ZN14ConstantString12create_emptyEv(i10);
   i1 = (HEAP32[i11 >> 2] | 0) + 8 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 3) + i2 | 0;
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 2;
 i3 = i8 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 536870911;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 3) | 0;
 i7 = i5 + (i1 - i4 >> 3 << 3) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 3) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN14ConstantString12create_emptyEv(i5);
  i1 = i8 + 8 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i7 = i1;
   i1 = i1 + -8 | 0;
   HEAP32[i2 + -8 >> 2] = HEAP32[i1 >> 2];
   i6 = i2 + -4 | 0;
   HEAP32[i6 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i6, i7 + -4 | 0);
   i2 = i3 + -8 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN14ConstantStringD2Ev(i1 + -4 | 0);
  i1 = i1 + -8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 715545 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 3;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 3) | 0)) _memset(i2 | 0, -1, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i5 = i1 + (i6 << 3) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i9 >> 2] = i2;
   i2 = i6;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZN13BuildSettings34ConvertScenePathToDisplayScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i6 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 if ((i1 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255) >>> 0 >= 7) {
  i1 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
  i7 = HEAP8[i1 >> 0] | 0;
  i6 = i7 << 24 >> 24;
  if ((((i7 + -65 & 255) < 26 ? i6 + 32 | 0 : i6) & 255) << 24 >> 24 == 97) {
   i6 = HEAP8[i1 + 1 >> 0] | 0;
   i7 = i6 << 24 >> 24;
   if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 115) {
    i6 = HEAP8[i1 + 2 >> 0] | 0;
    i7 = i6 << 24 >> 24;
    if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 115) {
     i6 = HEAP8[i1 + 3 >> 0] | 0;
     i7 = i6 << 24 >> 24;
     if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 101) {
      i6 = HEAP8[i1 + 4 >> 0] | 0;
      i7 = i6 << 24 >> 24;
      if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 116) {
       i6 = HEAP8[i1 + 5 >> 0] | 0;
       i7 = i6 << 24 >> 24;
       if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 115) {
        i6 = HEAP8[i1 + 6 >> 0] | 0;
        i7 = i6 << 24 >> 24;
        if ((((i6 + -65 & 255) < 26 ? i7 + 32 | 0 : i7) & 255) << 24 >> 24 == 47) {
         __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i5);
         __Z28DeleteFirstPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i2);
         __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
         STACKTOP = i3;
         return;
        }
       }
      }
     }
    }
   }
  }
 }
 __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5);
 STACKTOP = i3;
 return;
}

function __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i6 = i11 + 16 | 0;
 i10 = i9 + 8 | 0;
 i7 = i10;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 if (!(i7 & 1)) {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 8); else {
   i6 = i3;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 + 4 >> 2] = i7;
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i8 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(HEAP32[i9 >> 2] | 0, 0) | 0;
  STACKTOP = i11;
  return;
 } else {
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i10, 8); else {
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i10 + 4 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i9, i6);
  HEAP32[i8 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(HEAP32[i6 >> 2] | 0, (i7 & 8388608 | 0) != 0) | 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN10AudioMixer20TransitionToSnapshotERK4PPtrI18AudioMixerSnapshotEf(i4, i5, f6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i4) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 350, 1, 0, 0, 0);
  STACKTOP = i8;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i9 = __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot(i4, i1) | 0;
 __ZN5audio5mixer20TransitionToSnapshotERNS0_16AudioMixerMemoryEif(HEAP32[i4 + 76 >> 2] | 0, i9, f6);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __Z33AssetBundle_CUSTOM_LoadFromMemoryP11Il2CppArrayj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 i6 = __ZnwjRK10MemLabelIdiPKci(192, gb + 64016 | 0, 16, gb + 495876 | 0, 147) | 0;
 __ZN39AssetBundleLoadFromMemoryAsyncOperationC2Ev(i6);
 HEAP32[i6 + 88 >> 2] = i2;
 __ZN39AssetBundleLoadFromMemoryAsyncOperation20ExecuteSynchronouslyEPKhj(i6, i1, i5);
 i5 = i6 + 84 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 10;
   }
  }
  if ((i7 | 0) == 8) i7 = 10;
  if ((i7 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 }
 if (i6 | 0) mftCall_vi(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 64016 | 0);
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z27CalculateOrientedBoxCornersPfPKfS1_S1_S1_S1_(i2, i3, i10, i11, i12, i13) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, i21 = 0, f22 = f0, i23 = 0, f24 = f0, f25 = f0;
 i14 = i3 + 4 | 0;
 i15 = i11 + 4 | 0;
 i16 = i3 + 8 | 0;
 i17 = i11 + 8 | 0;
 i4 = i10 + 4 | 0;
 i5 = i12 + 4 | 0;
 i6 = i12 + 8 | 0;
 i7 = i10 + 8 | 0;
 i8 = i13 + 4 | 0;
 i9 = i13 + 8 | 0;
 i1 = 0;
 do {
  i23 = i2 + (i1 * 3 << 2) | 0;
  f24 = Math_fround(HEAPF32[i10 >> 2]);
  f25 = Math_fround(-f24);
  f25 = i1 & 1 | 0 ? f24 : f25;
  f24 = Math_fround(HEAPF32[i3 >> 2]);
  f24 = Math_fround(f24 + Math_fround(f25 * Math_fround(HEAPF32[i11 >> 2])));
  HEAPF32[i23 >> 2] = f24;
  f22 = Math_fround(HEAPF32[i14 >> 2]);
  f22 = Math_fround(f22 + Math_fround(f25 * Math_fround(HEAPF32[i15 >> 2])));
  i21 = i23 + 4 | 0;
  HEAPF32[i21 >> 2] = f22;
  f19 = Math_fround(HEAPF32[i16 >> 2]);
  f25 = Math_fround(f19 + Math_fround(f25 * Math_fround(HEAPF32[i17 >> 2])));
  i18 = i23 + 8 | 0;
  HEAPF32[i18 >> 2] = f25;
  f19 = Math_fround(HEAPF32[i4 >> 2]);
  f20 = Math_fround(-f19);
  f20 = i1 & 2 | 0 ? f19 : f20;
  f24 = Math_fround(f24 + Math_fround(f20 * Math_fround(HEAPF32[i12 >> 2])));
  HEAPF32[i23 >> 2] = f24;
  f22 = Math_fround(f22 + Math_fround(f20 * Math_fround(HEAPF32[i5 >> 2])));
  HEAPF32[i21 >> 2] = f22;
  f20 = Math_fround(f25 + Math_fround(f20 * Math_fround(HEAPF32[i6 >> 2])));
  HEAPF32[i18 >> 2] = f20;
  f25 = Math_fround(HEAPF32[i7 >> 2]);
  f19 = Math_fround(-f25);
  f19 = i1 & 4 | 0 ? f25 : f19;
  HEAPF32[i23 >> 2] = Math_fround(f24 + Math_fround(f19 * Math_fround(HEAPF32[i13 >> 2])));
  HEAPF32[i21 >> 2] = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i8 >> 2])));
  HEAPF32[i18 >> 2] = Math_fround(f20 + Math_fround(f19 * Math_fround(HEAPF32[i9 >> 2])));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 return;
}

function __Z15HiearchyMatchesP9TransformPKN7mecanim8skeleton8SkeletonEiRKNS1_5crc32E(i1, i12, i15, i16) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0;
 i21 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i21;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i3 >>> 0 <= i15 >>> 0) {
  i20 = 0;
  STACKTOP = i21;
  return i20 | 0;
 }
 i18 = i12 + 4 | 0;
 i19 = i18;
 i20 = i12 + 8 | 0;
 i13 = i20;
 i14 = i1 + 92 | 0;
 i11 = i1 + 80 | 0;
 i10 = i15;
 i2 = 0;
 i1 = 0;
 do {
  if ((HEAP32[(HEAP32[i18 >> 2] | 0) + i19 + (i10 << 3) >> 2] | 0) == (i15 | 0)) {
   HEAP32[i17 >> 2] = -1;
   i7 = HEAP32[(HEAP32[i20 >> 2] | 0) + i13 + (i10 << 2) >> 2] | 0;
   i8 = HEAP32[i14 >> 2] | 0;
   L8 : do if ((i8 | 0) > 0) {
    i6 = 0;
    while (1) {
     i9 = (i6 + i2 | 0) % (i8 | 0) | 0;
     i4 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2] | 0;
     i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
     i3 = HEAP32[i16 >> 2] | 0;
     if ((i3 | 0) == -1) i3 = -1; else i3 = HEAP32[gb + 1111240 + ((i3 & 255 ^ 47) << 2) >> 2] ^ i3 >>> 8;
     i22 = _strlen(i4) | 0;
     i5 = i4 + i22 | 0;
     if ((i22 | 0) > 0) do {
      i3 = HEAP32[gb + 1111240 + (((HEAPU8[i4 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i5 | 0));
     i6 = i6 + 1 | 0;
     if ((i7 | 0) == (~i3 | 0)) break;
     if ((i6 | 0) >= (i8 | 0)) break L8;
    }
    HEAP32[i17 >> 2] = i3;
    i3 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2] | 0;
    if (i3) {
     i1 = i1 + 1 + (__Z15HiearchyMatchesP9TransformPKN7mecanim8skeleton8SkeletonEiRKNS1_5crc32E(i3, i12, i10, i17) | 0) | 0;
     i2 = i2 + 1 | 0;
    }
   } while (0);
   i3 = HEAP32[i12 >> 2] | 0;
  }
  i10 = i10 + 1 | 0;
 } while (i10 >>> 0 < i3 >>> 0);
 STACKTOP = i21;
 return i1 | 0;
}

function __ZN7mecanim9animation28GetWeightFreeformDirectionalERKNS0_19Blend2dDataConstantEP8Vector2fiiS4_(i2, i6, i4, i8, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, f3 = f0, i7 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0;
 i13 = (Math_imul(HEAP32[i2 >> 2] | 0, i8) | 0) + i4 | 0;
 i7 = i2 + 20 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i1 = HEAP32[i7 + (i13 << 3) >> 2] | 0;
 f9 = Math_fround(HEAPF32[i7 + (i13 << 3) + 4 >> 2]);
 i7 = HEAP32[i6 + (i4 << 3) >> 2] | 0;
 f10 = Math_fround(HEAPF32[i6 + (i4 << 3) + 4 >> 2]);
 i14 = i2 + 28 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + i14 + (i13 << 2) >> 2]));
 i2 = i2 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 f12 = Math_fround(HEAPF32[i2 + (i4 << 3) >> 2]);
 f3 = Math_fround(HEAPF32[gb + 1162356 >> 2]);
 if (f12 == f3) {
  f12 = Math_fround(HEAPF32[i2 + (i4 << 3) + 4 >> 2]);
  if (f12 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
   i2 = i7;
   i1 = HEAP32[i6 + (i8 << 3) >> 2] | 0;
  } else i11 = 4;
 } else i11 = 4;
 do if ((i11 | 0) == 4) {
  if (Math_fround(HEAPF32[i2 + (i8 << 3) >> 2]) == f3) {
   f12 = Math_fround(HEAPF32[i2 + (i8 << 3) + 4 >> 2]);
   if (f12 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) {
    i2 = i7;
    i1 = i7;
    break;
   }
  }
  if (!((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) == Math_fround(0.0))) {
   if (!(Math_fround(HEAPF32[i5 >> 2]) == f3)) {
    i2 = i7;
    break;
   }
   f12 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   if (!(f12 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]))) {
    i2 = i7;
    break;
   }
  }
  i2 = i1;
 } while (0);
 f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 return Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_fround(f9 * f10) + Math_fround(f12 * (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) / Math_fround(Math_fround(f9 * f9) + Math_fround(f12 * f12))));
}

function __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 i4 = i1 + 68 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 1065353216;
 HEAP32[i1 + 96 >> 2] = 1065353216;
 HEAP32[i1 + 100 >> 2] = 1065353216;
 HEAP32[i1 + 104 >> 2] = 1065353216;
 i4 = i1 + 132 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 1065353216;
 HEAP32[i1 + 160 >> 2] = 1065353216;
 HEAP32[i1 + 164 >> 2] = 1065353216;
 HEAP32[i1 + 168 >> 2] = 1065353216;
 i4 = i1 + 196 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 1065353216;
 HEAP32[i1 + 224 >> 2] = 1065353216;
 HEAP32[i1 + 228 >> 2] = 1065353216;
 HEAP32[i1 + 232 >> 2] = 1065353216;
 i4 = i1 + 260 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 1065353216;
 HEAP32[i1 + 288 >> 2] = 1065353216;
 HEAP32[i1 + 292 >> 2] = 1065353216;
 HEAP32[i1 + 296 >> 2] = 1065353216;
 i4 = i1 + 596 | 0;
 i3 = i1 + 500 | 0;
 i1 = i1 + 364 | 0;
 i2 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = i3;
 i2 = i1 + 80 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 _memset(i4 | 0, 0, 292) | 0;
 return;
}

function __ZN6Camera17MultiCustomRenderER11CullResultsPKPFvRS_R10RenderLoopRK15RenderNodeQueueEPKPS6_jb(i9, i10, i11, i8, i12, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i3 = i13;
 if (!i2) {
  if ((HEAP16[gb + 1110496 + 6 >> 1] | 0) > -1) {
   HEAP32[i3 >> 2] = i9;
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110496 | 0, i1);
   i1 = gb + 1110496 | 0;
  } else i1 = 0;
  i7 = HEAP32[gb + 1110496 >> 2] | 0;
  i6 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 648 >> 2] | 0, i6 | 0, i7 | 0);
  i7 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 652 >> 2] | 0, i7 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 if (!i12) {
  STACKTOP = i13;
  return;
 }
 i4 = i9 + 1124 | 0;
 i5 = i10 + 1204 | 0;
 i6 = i9 + 1128 | 0;
 i7 = i10 + 1372 | 0;
 if (!i8) {
  i1 = 0;
  do {
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i2) __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb(i3, HEAP32[i5 >> 2] | 0, i10, HEAP32[i6 >> 2] | 0, 0); else mftCall_viii(i2 | 0, i9 | 0, i3 | 0, (HEAP32[i7 >> 2] | 0) + 8 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 } else {
  i1 = 0;
  do {
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i2) __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb(i3, HEAP32[i5 >> 2] | 0, i10, HEAP32[i6 >> 2] | 0, 0); else {
    i14 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
    mftCall_viii(i2 | 0, i9 | 0, i3 | 0, ((i14 | 0) == 0 ? (HEAP32[i7 >> 2] | 0) + 8 | 0 : i14) | 0);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 715355 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 715933 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZNSt3__26locale6globalERKS0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 12 | 0;
 i3 = i6;
 i4 = __ZNSt3__26locale8__globalEv() | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 __ZNSt3__214__shared_count12__add_sharedEv(i7);
 __ZNSt3__26localeaSERKS0_(i4, i1) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4529 | 0, i2 | 0, (HEAP32[i4 >> 2] | 0) + 144 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  do if (((i1 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i1 & 255) | 0) == 1) {
   __THREW__ = 0;
   i1 = invoke_iiiiii(fb + 192 | 0, i2 | 0, 0, -1, gb + 1086428 | 0, 1) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i8 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i8);
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
    if (!i1) break; else {
     i5 = 7;
     break;
    }
   }
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i5 = 7;
  } while (0);
  do if ((i5 | 0) == 7) {
   __THREW__ = 0;
   invoke_vii(fb + 4529 | 0, i3 | 0, (HEAP32[i4 >> 2] | 0) + 144 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    break L1;
   }
   __THREW__ = 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    break L1;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    break;
   }
  } while (0);
  STACKTOP = i6;
  return i7 | 0;
 } while (0);
 __ZNSt3__214__shared_count16__release_sharedEv(i7) | 0;
 ___resumeException(i1 | 0);
 return 0;
}

function __ZNSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE25__construct_node_with_keyERS6_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(48, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
 i5 = i3 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i5;
  if (i5) i11 = 6;
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i5 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i5;
  i1 = i6;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 i11 = i7 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i7 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 HEAP8[i10 + 9 >> 0] = 1;
 HEAP16[i10 + 10 >> 1] = 0;
 STACKTOP = i12;
 return;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i11 = i6 + 112 | 0;
 i12 = i6 + 100 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6 + 8 | 0;
 i2 = i6 + 4 | 0;
 HEAP8[i11 >> 0] = HEAP8[gb + 1078238 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 1078238 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 1078238 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = HEAP8[gb + 1078238 + 3 >> 0] | 0;
 HEAP8[i11 + 4 >> 0] = HEAP8[gb + 1078238 + 4 >> 0] | 0;
 HEAP8[i11 + 5 >> 0] = HEAP8[gb + 1078238 + 5 >> 0] | 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i11 + 1 | 0, gb + 1085971 | 0, 0, HEAP32[i8 + 4 >> 2] | 0);
 i13 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i1 >> 2] = i10;
 i10 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 12, i13, i11, i1) | 0) | 0;
 i11 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i10, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 43 | 0, i12 | 0, i11 | 0, i10 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i13 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  i12 = HEAP32[i4 >> 2] | 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i13 = __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i3, i12, i13, i8, i9) | 0;
  STACKTOP = i6;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i11 = i6 + 122 | 0;
 i12 = i6 + 108 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6 + 8 | 0;
 i2 = i6 + 4 | 0;
 HEAP8[i11 >> 0] = HEAP8[gb + 1078238 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 1078238 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 1078238 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = HEAP8[gb + 1078238 + 3 >> 0] | 0;
 HEAP8[i11 + 4 >> 0] = HEAP8[gb + 1078238 + 4 >> 0] | 0;
 HEAP8[i11 + 5 >> 0] = HEAP8[gb + 1078238 + 5 >> 0] | 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i11 + 1 | 0, gb + 1085971 | 0, 1, HEAP32[i8 + 4 >> 2] | 0);
 i13 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i1 >> 2] = i10;
 i10 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 13, i13, i11, i1) | 0) | 0;
 i11 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i10, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 43 | 0, i12 | 0, i11 | 0, i10 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i13 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  i12 = HEAP32[i4 >> 2] | 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i13 = __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i3, i12, i13, i8, i9) | 0;
  STACKTOP = i6;
  return i13 | 0;
 }
 return 0;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 212 | 0;
 i5 = i2 + 160 | 0;
 i6 = i2 + 80 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 24, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 i11 = i1 + 20 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_PKc17TransferMetaFlags(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, i2, HEAP32[gb + 37316 >> 2] | 0, i1, i3);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 i1 = i5 + 24 | 0;
 i7 = gb + 63648 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i5 + 4 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 32 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 36 | 0, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i6 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i5 + 4 >> 2] | 0)) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i6;
 return;
}

function __ZN16LightmapSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i6);
 __ZN21EnlightenSceneMapping8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 100 | 0, i6);
 __ZN4PPtrI11LightProbesE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 32 | 0, i6);
 i5 = i9 + 48 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i8 = i6 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = HEAP32[i9 + 36 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 << 3) | 0;
 if (i5 | 0) do {
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i6);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i9 + 28 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 __ZN10GISettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9 + 76 | 0, i6);
 i1 = i9 + 236 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 HEAP8[i9 + 96 >> 0] = 1;
 HEAP8[i9 + 97 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 212 | 0;
 i5 = i2 + 160 | 0;
 i6 = i2 + 80 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 24, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 i11 = i1 + 20 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN17ProceduralTexture13AwakeFromLoadE17AwakeFromLoadMode(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 HEAP32[i6 + 152 >> 2] = HEAP32[i6 + 4 >> 2];
 do if (!(i1 & 2)) {
  i4 = i6 + 80 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i5 = 8; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
     i2 = HEAP32[i2 >> 2] | 0;
     i8 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else if (HEAP32[i1 + 4 >> 2] | 0) break;
   }
   __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
 } while (0);
 if (!(HEAP32[i6 + 128 >> 2] | 0)) {
  i1 = HEAP32[i6 + 208 >> 2] | 0;
  i5 = 16;
 } else {
  i1 = HEAP32[i6 + 208 >> 2] | 0;
  if ((HEAP32[i6 + 108 >> 2] | 0) == (HEAP32[i6 + 104 >> 2] | 0)) i5 = 16; else if ((i1 | 0) < 2) __ZN17ProceduralTexture18UploadBakedTextureEv(i6);
 }
 if ((i5 | 0) == 16) if (!i1) __ZN17ProceduralTexture20UploadWaitingTextureEv(i6);
 HEAP32[i6 + 172 >> 2] = 4;
 i1 = i6 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != 3) {
  i5 = i2;
  i8 = i6 + 216 | 0;
  HEAP32[i8 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = 4;
 i5 = 4;
 i8 = i6 + 216 | 0;
 HEAP32[i8 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZN14NavMeshManager21InitializeCrowdSystemEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i4 + 100 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(472, gb + 63704 | 0, 16, gb + 842172 | 0, 1305) | 0;
  __ZN7dtCrowdC2Ev(i1);
  HEAP32[i3 >> 2] = i1;
  if (!i1) {
   i4 = 0;
   STACKTOP = i6;
   return i4 | 0;
  }
  if (__ZN7dtCrowd4initEi(i1, 4) | 0) {
   i8 = __ZNK7dtCrowd26getObstacleAvoidanceParamsEi(HEAP32[i3 >> 2] | 0, 0) | 0;
   HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
   i8 = i2 + 16 | 0;
   HEAP8[i8 >> 0] = 5;
   i7 = i2 + 17 | 0;
   HEAP8[i7 >> 0] = 2;
   i1 = i2 + 18 | 0;
   HEAP8[i1 >> 0] = 1;
   __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams(HEAP32[i3 >> 2] | 0, 1, i2);
   HEAP8[i8 >> 0] = 5;
   HEAP8[i7 >> 0] = 2;
   HEAP8[i1 >> 0] = 2;
   __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams(HEAP32[i3 >> 2] | 0, 2, i2);
   HEAP8[i8 >> 0] = 7;
   HEAP8[i7 >> 0] = 2;
   HEAP8[i1 >> 0] = 3;
   __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams(HEAP32[i3 >> 2] | 0, 3, i2);
   HEAP8[i8 >> 0] = 7;
   HEAP8[i7 >> 0] = 3;
   HEAP8[i1 >> 0] = 3;
   __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams(HEAP32[i3 >> 2] | 0, 4, i2);
   i1 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i8 = 0;
   STACKTOP = i6;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i1 + 444 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i1 + 448 >> 2] = HEAP32[i4 + 36 >> 2];
 i8 = __ZN7dtCrowd10setNavMeshEPK9dtNavMeshPK15HeightMeshQueryfi(i1, HEAP32[i4 + 108 >> 2] | 0, HEAP32[i4 + 116 >> 2] | 0, f5, 4096) | 0;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj(i8, i1, i2, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 if (!i7) return;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) return;
 i5 = i8 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L9 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L9;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i6) return;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(i8 + 6616 | 0, HEAP32[i7 >> 2] | 0, 0, 0);
 i4 = i8 + 7380 | 0;
 HEAP32[i4 >> 2] = 14380;
 i5 = i8 + 7376 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 & 14380;
  if (i1 | 0) mftCall_vi(HEAP32[i8 + 4860 >> 2] | 0, i1 | 0);
  i2 = i8 + 5480 | 0;
  i3 = i8 + 7368 | 0;
  i1 = 0;
  do {
   i7 = HEAP32[i4 >> 2] & HEAP32[i5 >> 2];
   if (i7 & (__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0) | 0) {
    i11 = i3;
    i10 = HEAP32[i11 + 4 >> 2] | 0;
    i7 = i8 + 7264 + (i1 << 3) | 0;
    HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i7 + 4 >> 2] = i10;
    i7 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0);
    HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & i7;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 13);
  i7 = i3;
  i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, 1, 0) | 0;
  i10 = getTempRet0() | 0;
  i11 = i3;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 4 >> 2] = i10;
  HEAP32[i4 >> 2] = 15407;
 }
 __ZN7ApiGLES16DispatchIndirectEjj(i8 + 4620 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i9);
 return;
}

function __ZN12LightmapData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402465 | 0, gb + 1034905 | 0, i1, 0);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i8 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37248 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402476 | 0, gb + 1034905 | 0, i7, 0);
 i1 = i9 + 8 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i8, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, i6, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN11SoundHandle8Instance7DisposeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 if (i4 | 0) {
  i1 = HEAP32[i4 + 120 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  }
  HEAP32[i5 >> 2] = i1;
 }
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 i3 = i4 + 28 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i7 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN20SoundChannelInstance4StopEv(HEAP32[i7 + 8 >> 2] | 0);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i1 = i4 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 16 >> 2] = 0;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 108 | 0;
 i3 = i4 + 104 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 + 108 >> 2] = HEAP32[i1 >> 2];
 HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
 i3 = i4 + 116 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  __ZN11SoundHandleD2Ev(i5);
  STACKTOP = i6;
  return;
 }
 i2 = i1 + 24 | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i4 + 4 | 0; else {
   i7 = i4 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
   i1 = i7;
  }
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 }
 HEAP8[i3 >> 0] = 1;
 __ZN11SoundHandleD2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i11 = i6 + 52 | 0;
 i12 = i6 + 40 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6 + 8 | 0;
 i2 = i6 + 4 | 0;
 HEAP8[i11 >> 0] = HEAP8[gb + 1078238 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 1078238 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 1078238 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = HEAP8[gb + 1078238 + 3 >> 0] | 0;
 HEAP8[i11 + 4 >> 0] = HEAP8[gb + 1078238 + 4 >> 0] | 0;
 HEAP8[i11 + 5 >> 0] = HEAP8[gb + 1078238 + 5 >> 0] | 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i11 + 1 | 0, gb + 1085971 | 0, 0, HEAP32[i8 + 4 >> 2] | 0);
 i13 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i1 >> 2] = i10;
 i10 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 12, i13, i11, i1) | 0) | 0;
 i11 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i10, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 41 | 0, i12 | 0, i11 | 0, i10 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i13 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  i12 = HEAP32[i4 >> 2] | 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i13 = __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i3, i12, i13, i8, i9) | 0;
  STACKTOP = i6;
  return i13 | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i11 = i6 + 52 | 0;
 i12 = i6 + 39 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6 + 8 | 0;
 i2 = i6 + 4 | 0;
 HEAP8[i11 >> 0] = HEAP8[gb + 1078238 >> 0] | 0;
 HEAP8[i11 + 1 >> 0] = HEAP8[gb + 1078238 + 1 >> 0] | 0;
 HEAP8[i11 + 2 >> 0] = HEAP8[gb + 1078238 + 2 >> 0] | 0;
 HEAP8[i11 + 3 >> 0] = HEAP8[gb + 1078238 + 3 >> 0] | 0;
 HEAP8[i11 + 4 >> 0] = HEAP8[gb + 1078238 + 4 >> 0] | 0;
 HEAP8[i11 + 5 >> 0] = HEAP8[gb + 1078238 + 5 >> 0] | 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i11 + 1 | 0, gb + 1085971 | 0, 1, HEAP32[i8 + 4 >> 2] | 0);
 i13 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i1 >> 2] = i10;
 i10 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 13, i13, i11, i1) | 0) | 0;
 i11 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i10, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 41 | 0, i12 | 0, i11 | 0, i10 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) {
  i13 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i13 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  i12 = HEAP32[i4 >> 2] | 0;
  i13 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i13 = __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i3, i12, i13, i8, i9) | 0;
  STACKTOP = i6;
  return i13 | 0;
 }
 return 0;
}

function __ZN9Animation9IsPlayingERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 __ZN9Animation20BuildAnimationStatesEv(i1);
 i14 = HEAP32[i1 + 104 >> 2] | 0;
 i9 = HEAP32[i1 + 108 >> 2] | 0;
 i12 = i9;
 i13 = i14;
 L1 : do if ((i14 | 0) != (i9 | 0)) {
  i6 = HEAP8[i11 + 11 >> 0] | 0;
  i7 = i6 << 24 >> 24 < 0;
  i6 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
  i7 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
  i5 = i14;
  while (1) {
   i8 = HEAP32[i5 >> 2] | 0;
   i2 = i8 + 112 | 0;
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   i1 = i4 << 24 >> 24 < 0;
   if (i1) i3 = HEAP32[i8 + 116 >> 2] | 0; else i3 = i4 & 255;
   if ((i3 | 0) == (i6 | 0)) {
    if (i1) {
     i2 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i8 + 116 >> 2] | 0;
    } else i1 = i4 & 255;
    if (!(_strncmp(i2, i7, i1) | 0)) break;
   }
   i5 = i5 + 4 | 0;
   if ((i5 | 0) == (i9 | 0)) break L1;
  }
  if (i8 | 0) if (HEAP16[i8 + 56 >> 1] & 2) {
   i14 = 1;
   return i14 | 0;
  }
 } while (0);
 if ((i9 | 0) == (i14 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = HEAP8[i11 + 11 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i10 = i9 ? HEAP32[i11 + 4 >> 2] | 0 : i10 & 255;
 i9 = i9 ? HEAP32[i11 >> 2] | 0 : i11;
 i7 = i12 - i13 >> 2;
 i6 = 0;
 while (1) {
  i4 = HEAP32[i14 + (i6 << 2) >> 2] | 0;
  i8 = HEAP16[i4 + 56 >> 1] | 0;
  if (i8 & 256) {
   i2 = i4 + 128 | 0;
   i5 = HEAP8[i2 + 11 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   if (i1) i3 = HEAP32[i4 + 132 >> 2] | 0; else i3 = i5 & 255;
   if ((i3 | 0) == (i10 | 0)) {
    if (i1) {
     i2 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i4 + 132 >> 2] | 0;
    } else i1 = i5 & 255;
    if (!((_strncmp(i2, i9, i1) | 0) != 0 | (i8 & 2) == 0)) {
     i1 = 1;
     i2 = 26;
     break;
    }
   }
  }
  i6 = i6 + 1 | 0;
  if (i6 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i2 = 26;
   break;
  }
 }
 if ((i2 | 0) == 26) return i1 | 0;
 return 0;
}

function __ZN5physx2Sc8BodyCoreC2ENS_11PxActorType4EnumERKNS_11PxTransformE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, i6 = 0;
 __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE(i2, i3);
 i6 = HEAP32[gb + 1457332 >> 2] | 0;
 HEAP32[i2 + 152 >> 2] = HEAP32[gb + 92912 >> 2];
 HEAP32[i2 + 128 >> 2] = 1065353216;
 HEAP32[i2 + 132 >> 2] = 1065353216;
 HEAP32[i2 + 136 >> 2] = 1065353216;
 HEAPF32[i2 + 140 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 24 >> 2];
 f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(f5 * Math_fround(f5 * Math_fround(.0000499999987)));
 HEAPF32[i2 + 148 >> 2] = Math_fround(f5 * Math_fround(f5 * Math_fround(.0000249999994)));
 HEAP32[i2 + 156 >> 2] = 0;
 HEAPF32[i2 + 92 >> 2] = Math_fround(-1000000029999999928682502.0e8);
 HEAP8[i2 + 44 >> 0] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAPF32[i2 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 116 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP16[i2 + 46 >> 1] = 260;
 HEAPF32[i2 + 108 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 1065353216;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAPF32[i2 + 76 >> 2] = Math_fround(.150000006);
 HEAP8[i2 + 45 >> 0] = 0;
 i3 = (i3 | 0) == 1;
 f5 = i3 ? Math_fround(.0500000007) : Math_fround(0.0);
 f4 = i3 ? Math_fround(49.0) : Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 124 >> 2] = f5;
 HEAPF32[i2 + 112 >> 2] = f4;
 return;
}

function __ZN13RuntimeStaticI20HardwareInfoReporterE10InitializeEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i5 = i9;
 i7 = i9 + 12 | 0;
 i1 = i8 + 16 | 0;
 i2 = i8 + 4 | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = __ZnwjRK10MemLabelIdiPKci(4, i2, i3, gb + 1041912 | 0, 65) | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = __ZN15GlobalCallbacks3GetEv() | 0;
  i4 = i3 + 10804 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 >>> 0 > 63) {
   __Z6FormatPKcz(i7, gb + 1048800 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i4 >> 2] = i1 + 1;
  HEAP32[i3 + 10036 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i3 + 10036 + (i1 * 12 | 0) + 8 >> 0] = 0;
  HEAP32[i3 + 10036 + (i1 * 12 | 0) >> 2] = fb + 403;
  HEAP32[i8 >> 2] = i2;
  STACKTOP = i9;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, i2, i3, i1, i8 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i3 = i2 + 10804 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 >>> 0 > 63) {
   __Z6FormatPKcz(i7, gb + 1048800 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP32[i2 + 10036 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[i2 + 10036 + (i1 * 12 | 0) + 8 >> 0] = 0;
  HEAP32[i2 + 10036 + (i1 * 12 | 0) >> 2] = fb + 403;
  __Z19pop_allocation_rootv();
  HEAP32[i8 >> 2] = i4;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEjRKS1_(i12, i11, i9) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = i12 + 8 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 i14 = i12 + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i5 = i3;
 if (((i2 - i3 | 0) / 12 | 0) >>> 0 >= i11 >>> 0) {
  i2 = i9 + 4 | 0;
  i3 = i9 + 8 | 0;
  i1 = i11;
  i4 = i5;
  while (1) {
   HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i3 >> 2];
   i1 = i1 + -1 | 0;
   if (!i1) break; else i4 = i4 + 12 | 0;
  }
  HEAP32[i14 >> 2] = i5 + (i11 * 12 | 0);
  return;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 i4 = ((i3 - i1 | 0) / 12 | 0) + i11 | 0;
 if (i4 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i3 = HEAP32[i14 >> 2] | 0;
  i10 = HEAP32[i12 >> 2] | 0;
  i2 = HEAP32[i13 >> 2] | 0;
  i1 = i3;
 } else {
  i10 = i1;
  i1 = i3;
  i3 = i5;
 }
 i8 = i10;
 i7 = (i2 - i10 | 0) / 12 | 0;
 i2 = i7 << 1;
 i2 = i7 >>> 0 < 178956970 ? (i2 >>> 0 < i4 >>> 0 ? i4 : i2) : 357913941;
 if (!i2) i4 = 0; else i4 = __Znwj(i2 * 12 | 0) | 0;
 i1 = i4 + (((i1 - i10 | 0) / 12 | 0) * 12 | 0) | 0;
 i4 = i4 + (i2 * 12 | 0) | 0;
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 i2 = i11;
 i7 = i1;
 while (1) {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 >> 2];
  i2 = i2 + -1 | 0;
  if (!i2) break; else i7 = i7 + 12 | 0;
 }
 i5 = i4;
 i4 = i1 + (i11 * 12 | 0) | 0;
 if ((i3 | 0) != (i8 | 0)) while (1) {
  i2 = i1 + -12 | 0;
  i11 = i3;
  i3 = i3 + -12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + -8 >> 2] = HEAP32[i11 + -8 >> 2];
  HEAP32[i1 + -4 >> 2] = HEAP32[i11 + -4 >> 2];
  if ((i3 | 0) == (i8 | 0)) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 HEAP32[i12 >> 2] = i1;
 HEAP32[i14 >> 2] = i4;
 HEAP32[i13 >> 2] = i5;
 if (!i10) return;
 __ZdlPv(i10);
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4peekEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i4 + 4 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i4 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i4;
  i1 = i4;
  i6 = 10;
 } else {
  do if (!(HEAP8[i1 >> 0] | 0)) i1 = -1; else {
   i1 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) i6 = 6;
   } else {
    i1 = HEAP32[i2 >> 2] | 0;
    i6 = 6;
   }
   if ((i6 | 0) == 6) {
    if ((i1 | 0) != -1) break;
    i3 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 2 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i1 = -1;
     break;
    }
   }
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i4;
   i1 = i4;
   i6 = 10;
   break L1;
  } while (0);
  i5 = i1;
 } while (0);
 do if ((i6 | 0) == 10) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   ___cxa_end_catch();
   i5 = -1;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i6);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 << 4;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 656630 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 4) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 << 4) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 << 4) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 << 4) | 0;
 return i10 | 0;
}

function __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb(i14, i1, i13, i11, i15) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 8 | 0;
 i12 = i16 + 4 | 0;
 i9 = i16;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i10, i1);
 i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i10) | 0;
 HEAP32[i12 >> 2] = i1;
 if (!i1) i3 = i13 + 264 | 0; else {
  i4 = i13 + 268 | 0;
  i3 = i13 + 264 | 0;
  i5 = i13 + 260 | 0;
  i6 = i11 + 268 | 0;
  i7 = i11 + 264 | 0;
  i8 = i11 + 260 | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    HEAP32[i3 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_2Sc8ShapeSimENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i13, i12) | 0;
   i1 = HEAP32[i1 + 28 >> 2] | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    HEAP32[i7 >> 2] = i2 + 1;
   } else __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE15growAndPushBackERKS5_(i11, i9) | 0;
   i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i10) | 0;
   HEAP32[i12 >> 2] = i1;
  } while ((i1 | 0) != 0);
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i16;
  return;
 }
 i1 = i13 + 260 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc5Scene11removeShapeERNS0_8ShapeSimEb(i14, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, i15);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx14SapPairManager7AddPairEjjh(i15, i1, i2, i14) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = i15 + 28 | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 if ((i10 | 0) == 1073741823) {
  i15 = 0;
  return i15 | 0;
 }
 i11 = i1 >>> 0 > i2 >>> 0;
 i13 = i11 ? i2 : i1;
 i11 = i11 ? i1 : i2;
 i8 = i11 << 16 | i13;
 i8 = i8 + ~(i8 << 15) | 0;
 i8 = (i8 >> 10 ^ i8) * 9 | 0;
 i8 = i8 >> 6 ^ i8;
 i8 = i8 + ~(i8 << 11) | 0;
 i8 = i8 >> 16 ^ i8;
 i9 = i15 + 36 | 0;
 i1 = HEAP32[i9 >> 2] & i8;
 i6 = i15 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 L4 : do if (i7 | 0) {
  i2 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != 1073741823) {
   i4 = HEAP32[i15 + 20 >> 2] | 0;
   i5 = i15 + 4 | 0;
   i3 = i2;
   while (1) {
    i2 = i4 + (i3 << 3) | 0;
    if (!((HEAP32[i2 >> 2] | 0) != (i13 | 0) ? 1 : (HEAP32[i4 + (i3 << 3) + 4 >> 2] | 0) != (i11 | 0))) break;
    i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    if ((i3 | 0) == 1073741823) break L4;
   }
   if (i2 | 0) {
    i15 = i2;
    return i15 | 0;
   }
  }
 } while (0);
 if (i10 >>> 0 < i7 >>> 0) i2 = i10; else {
  i1 = i10 + 1 | 0;
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = i1 >>> 16 | i1;
  i2 = i1 + 1 | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  __ZN5physx14SapPairManager12reallocPairsEb(i15, i2 >>> 0 > (HEAP32[i15 + 12 >> 2] | 0) >>> 0);
  i2 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] & i8;
 }
 i9 = HEAP32[i15 + 20 >> 2] | 0;
 i10 = i9 + (i2 << 3) | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i9 + (i2 << 3) + 4 >> 2] = i11;
 HEAP8[(HEAP32[i15 + 24 >> 2] | 0) + i2 >> 0] = i14;
 i14 = (HEAP32[i15 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i15 + 4 >> 2] | 0) + (HEAP32[i12 >> 2] << 2) >> 2] = HEAP32[i14 >> 2];
 i15 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i15 + 1;
 HEAP32[i14 >> 2] = i15;
 i15 = i10;
 return i15 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 3) | 0, 0, i4 - i5 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN12LineRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = (HEAP32[i3 + 348 >> 2] | 0) + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 405193 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN4math14float3_storageELj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = HEAP32[i3 + 344 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 421169 | 0, gb + 421182 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14LineParameters8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i3 + 340 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 405205 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 2) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 1) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 1;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i5 >> 2] = i2;
 i7 = i13 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i13 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i6 << 1) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 2) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 1) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 1;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i5 >> 2] = i2;
 i7 = i13 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i13 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i6 << 1) | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 2 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 2);
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i12, i4, i1) {
 i12 = i12 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i1 = i11;
 i9 = i12 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i9 >> 2] = i3;
  i1 = i7;
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i5 = i12 + 8 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i4 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i4, i1, i8, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i7 = i1 + (i6 * 12 | 0) | 0;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i12);
  i5 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
   i6 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
   i6 = i3;
  }
  HEAP32[i5 >> 2] = i2;
  i2 = i1 + 8 | 0;
  i3 = i6 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i11;
 return;
}

function __ZN14TerrainManager20CollectTreeRenderersEPK6CameraR13dynamic_arrayI9SceneNodeLj4EERS3_I4AABBLj4EE(i12, i7, i11, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i12 + 8 >> 2] | 0;
 i9 = i12 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) != (i9 | 0)) {
  i10 = i7 + 880 | 0;
  do {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   L5 : do if (HEAP32[i1 + 204 >> 2] & 2 | 0) if (HEAP8[i1 + 90 >> 0] | 0) if (+Math_fround(HEAPF32[i1 + 64 >> 2]) > .001) if (1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i10 >> 2] | 0) {
    i5 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
    i6 = HEAP32[i1 + 240 >> 2] | 0;
    if (i6 | 0) {
     i4 = HEAP32[i1 + 228 >> 2] | 0;
     i1 = 0;
     while (1) {
      i3 = i4 + (i1 * 20 | 0) | 0;
      if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) break;
      i1 = i1 + 1 | 0;
      if (i1 >>> 0 >= i6 >>> 0) break L5;
     }
     HEAP32[i4 + (i1 * 20 | 0) + 16 >> 2] = i5;
     if (i3 | 0) __ZN12TreeRenderer20CollectTreeRenderersER13dynamic_arrayI9SceneNodeLj4EERS0_I4AABBLj4EE(HEAP32[i4 + (i1 * 20 | 0) + 8 >> 2] | 0, i11, i8);
    }
   } while (0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i9 | 0));
 }
 i5 = i12 + 20 | 0;
 i3 = i12 + 32 | 0;
 i4 = i12 + 36 | 0;
 i1 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 1, i12 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i12 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i12 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i12;
  break;
 } while (0);
 if (!i1) return;
 _memset(HEAP32[i5 >> 2] | 0, 0, i1 | 0) | 0;
 return;
}

function __ZN12b2WheelJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0, d11 = 0.0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 120 | 0;
 i4 = i2 + 112 | 0;
 i5 = i2 + 104 | 0;
 i6 = i2 + 96 | 0;
 i7 = i2 + 88 | 0;
 i8 = i2 + 80 | 0;
 i9 = i2 + 64 | 0;
 i12 = i2 + 48 | 0;
 i13 = i2 + 32 | 0;
 i14 = i2 + 24 | 0;
 i15 = i2 + 16 | 0;
 i17 = i2 + 8 | 0;
 i18 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i16 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800635 | 0, i2);
 HEAP32[i17 >> 2] = i18;
 __Z5b2LogPKcz(gb + 799360 | 0, i17);
 HEAP32[i15 >> 2] = i16;
 __Z5b2LogPKcz(gb + 799386 | 0, i15);
 HEAP32[i14 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i14);
 d11 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d10 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i13 >> 3] = d11;
 HEAPF64[i13 + 8 >> 3] = d10;
 __Z5b2LogPKcz(gb + 799447 | 0, i13);
 d10 = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 d11 = +Math_fround(HEAPF32[i1 + 88 >> 2]);
 HEAPF64[i12 >> 3] = d10;
 HEAPF64[i12 + 8 >> 3] = d11;
 __Z5b2LogPKcz(gb + 799489 | 0, i12);
 d11 = +Math_fround(HEAPF32[i1 + 92 >> 2]);
 d10 = +Math_fround(HEAPF32[i1 + 96 >> 2]);
 HEAPF64[i9 >> 3] = d11;
 HEAPF64[i9 + 8 >> 3] = d10;
 __Z5b2LogPKcz(gb + 800031 | 0, i9);
 HEAP32[i8 >> 2] = HEAPU8[i1 + 128 >> 0];
 __Z5b2LogPKcz(gb + 800201 | 0, i8);
 HEAPF64[i7 >> 3] = +Math_fround(HEAPF32[i1 + 124 >> 2]);
 __Z5b2LogPKcz(gb + 800231 | 0, i7);
 HEAPF64[i6 >> 3] = +Math_fround(HEAPF32[i1 + 120 >> 2]);
 __Z5b2LogPKcz(gb + 800532 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 __Z5b2LogPKcz(gb + 799555 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 __Z5b2LogPKcz(gb + 799584 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function _UNITY_tt_size_reset(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = i8 + 72 | 0;
 i9 = i8 + 108 | 0;
 HEAP8[i9 >> 0] = 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i8 + 44 | 0;
 i2 = i8 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = i2 & 65535;
 i1 = i2 >>> 16;
 i6 = i1 & 65535;
 if (!(i5 << 16 >> 16)) {
  i9 = 151;
  return i9 | 0;
 }
 if (!(i6 << 16 >> 16)) {
  i9 = 151;
  return i9 | 0;
 }
 if (!(HEAP16[i3 + 176 >> 1] & 8)) i3 = i6; else {
  i5 = i3 + 68 | 0;
  i1 = i8 + 48 | 0;
  HEAP32[i1 >> 2] = _UNITY_FT_DivFix(i2 << 6 & 4194240, HEAPU16[i5 >> 1] | 0) | 0;
  i5 = _UNITY_FT_DivFix(HEAPU16[i8 + 46 >> 1] << 6, HEAPU16[i5 >> 1] | 0) | 0;
  i2 = i8 + 52 | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i8 + 56 >> 2] = (_UNITY_FT_MulFix(HEAP16[i3 + 70 >> 1] | 0, i5) | 0) + 32 & -64;
  HEAP32[i8 + 60 >> 2] = (_UNITY_FT_MulFix(HEAP16[i3 + 72 >> 1] | 0, HEAP32[i2 >> 2] | 0) | 0) + 32 & -64;
  HEAP32[i8 + 64 >> 2] = (_UNITY_FT_MulFix(HEAP16[i3 + 74 >> 1] | 0, HEAP32[i2 >> 2] | 0) | 0) + 32 & -64;
  HEAP32[i8 + 68 >> 2] = (_UNITY_FT_MulFix(HEAP16[i3 + 76 >> 1] | 0, HEAP32[i1 >> 2] | 0) | 0) + 32 & -64;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i2 >>> 16;
  i5 = i2 & 65535;
  i3 = i1 & 65535;
 }
 if ((i5 & 65535) < (i3 & 65535)) {
  HEAP32[i8 + 88 >> 2] = HEAP32[i8 + 52 >> 2];
  HEAP16[i8 + 80 >> 1] = i3;
  HEAP32[i7 >> 2] = _UNITY_FT_DivFix(i2 & 65535, i3 & 65535) | 0;
  i1 = 65536;
 } else {
  HEAP32[i8 + 88 >> 2] = HEAP32[i8 + 48 >> 2];
  HEAP16[i8 + 80 >> 1] = i5;
  HEAP32[i7 >> 2] = 65536;
  i1 = _UNITY_FT_DivFix(i1, i2 & 65535) | 0;
 }
 HEAP32[i8 + 76 >> 2] = i1;
 HEAP32[i8 + 300 >> 2] = -1;
 HEAP8[i9 >> 0] = 1;
 i9 = 0;
 return i9 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i17, i1) {
 i17 = i17 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f18 = f0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i7 = i17 + 16 | 0;
 i16 = HEAP32[i7 >> 2] | 0;
 f18 = Math_fround(i1 >>> 0);
 i8 = ~~Math_fround(f18 * Math_fround(HEAPF32[i17 + 24 >> 2])) >>> 0;
 i12 = i1 << 2;
 i11 = (i8 << 2) + i12 | 0;
 i11 = (0 - i11 & 12) + i11 | 0;
 i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i17, i11 + (i8 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i10 = i9 + i12 | 0;
 i11 = i9 + i11 | 0;
 _memset(i9 | 0, -1, i12 | 0) | 0;
 i12 = i17 + 36 | 0;
 i6 = i17 + 4 | 0;
 if (HEAP32[i12 >> 2] | 0) {
  i13 = i1 + -1 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i15 = 0;
  do {
   i3 = HEAP32[i5 + (i15 << 3) >> 2] | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   i14 = i3;
   if (!(i2 << 24 >> 24)) i2 = 5381; else {
    i4 = i2;
    i2 = 5381;
    do {
     i2 = i2 * 33 ^ i4 << 24 >> 24;
     i3 = i3 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
    } while (i4 << 24 >> 24 != 0);
   }
   i4 = i9 + ((i2 & i13) << 2) | 0;
   HEAP32[i10 + (i15 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i15;
   HEAP32[i11 + (i15 << 3) >> 2] = i14;
   HEAP32[i11 + (i15 << 3) + 4 >> 2] = HEAP32[i5 + (i15 << 3) + 4 >> 2];
   i15 = i15 + 1 | 0;
  } while (i15 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i17, HEAP32[i17 >> 2] | 0);
 HEAP32[i17 >> 2] = i9;
 HEAP32[i17 + 12 >> 2] = i9;
 HEAP32[i17 + 20 >> 2] = i1;
 HEAP32[i17 + 8 >> 2] = i10;
 HEAP32[i6 >> 2] = i11;
 HEAP32[i7 >> 2] = i8;
 i1 = i17 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i16;
 return;
}

function __ZN5physx2Sc7BodySim19deactivateKinematicEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = i7 + 144 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(i2 & 512)) {
  HEAP16[i1 >> 1] = i2 & 65019 | 512;
  i7 = 0;
  return i7 | 0;
 }
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 HEAP16[i1 >> 1] = i2 & 65023;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 i4 = i7 + 36 | 0;
 i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i4 >> 2] | 0) | 0;
 i6 = i7 + 188 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i8 = i2 + (i1 * 12 | 0) + 8 | 0;
 i3 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i3 & 247;
 do if (i3 & 8) {
  i8 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~(1 << (i1 & 31));
  i1 = HEAP32[i6 >> 2] | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i3 & i1)) {
    HEAP32[i2 >> 2] = i3 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i3 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i5 + 477 >> 0] = 1;
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i4 >> 2] | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 i5 = i2 + (i1 * 12 | 0) + 8 | 0;
 i8 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = i8 & 231 | 16;
 do if (i8 & 8) {
  i8 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~(1 << (i1 & 31));
  i1 = HEAP32[i6 >> 2] | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i3 & i1)) {
    HEAP32[i2 >> 2] = i3 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i3 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i4 + 477 >> 0] = 1;
 __ZN5physx2Sc5Actor9setActiveEbj(i7, 0, 0);
 i8 = 1;
 return i8 | 0;
}

function __ZN4mathL11quatToEulerERKNS_7_float4ENS_13RotationOrderE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0;
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f8 * f11);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f2 * Math_fround(2.0));
 f3 = Math_fround(Math_fround(f8 * f7) * Math_fround(2.0));
 f4 = Math_fround(Math_fround(f10 * f11) * Math_fround(2.0));
 f5 = Math_fround(Math_fround(f7 * f10) * Math_fround(2.0));
 f6 = Math_fround(f5 - f2);
 if (Math_fround(f6 * f6) < Math_fround(.999995946)) {
  f13 = Math_fround(f8 * f8);
  f5 = Math_fround(f7 * f7);
  f2 = Math_fround(f11 * f11);
  f14 = Math_fround(f10 * f10);
  f10 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f8 * f10) * Math_fround(2.0)) + Math_fround(Math_fround(f11 * f7) * Math_fround(2.0))), +Math_fround(Math_fround(Math_fround(f5 + f13) - f2) - f14)));
  f11 = Math_fround(+Math_asin(+f6));
  f8 = Math_fround(+Math_atan2(+Math_fround(f3 + f4), +Math_fround(Math_fround(Math_fround(f14 + f13) - f2) - f5)));
  i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  f11 = Math_fround(-f11);
  HEAPF32[i9 >> 2] = f10;
  i12 = i9 + 4 | 0;
  HEAPF32[i12 >> 2] = f11;
  i9 = i9 + 8 | 0;
  HEAP32[i9 >> 2] = i1;
  return;
 } else {
  f14 = Math_fround(+Math_asin(+Math_fround(_fminf(Math_fround(_fmaxf(f6, Math_fround(-1.0))), Math_fround(1.0)))));
  f13 = Math_fround(+Math_atan2(+Math_fround(Math_fround(Math_fround(f2 * f4) + Math_fround(f3 * f5)) * Math_fround(2.0)), +Math_fround(Math_fround(Math_fround(f3 * f3) - Math_fround(f4 * f4)) + Math_fround(Math_fround(f2 * f2) - Math_fround(f5 * f5)))));
  i1 = 0;
  f14 = Math_fround(-f14);
  HEAPF32[i9 >> 2] = f13;
  i12 = i9 + 4 | 0;
  HEAPF32[i12 >> 2] = f14;
  i12 = i9 + 8 | 0;
  HEAP32[i12 >> 2] = i1;
  return;
 }
}

function __ZN16PlayerConnection10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 40 | 0;
 i1 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10 + 8 | 0;
 i4 = i10;
 i3 = HEAP32[gb + 1163120 >> 2] | 0;
 if (!i3) {
  i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  HEAP32[i4 >> 2] = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
  HEAP32[i4 + 4 >> 2] = i6 & 1;
  _printf_console(gb + 460552 | 0, i4);
  i2 = __Znwj(408) | 0;
  __ZN16PlayerConnectionC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEtb(i2, i5, -10539, i6);
  HEAP32[gb + 1163120 >> 2] = i2;
  if (HEAP8[i2 + 141 >> 0] | 0) if (!(HEAP32[i2 + 144 >> 2] | 0)) {
   i1 = i2 + 152 | 0;
   if ((HEAP8[i2 + 163 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i8 = HEAPU16[i2 + 164 >> 1] | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i9 + 4 >> 2] = i8;
   _printf_console(gb + 460603 | 0, i9);
  }
  if (!i3) {
   STACKTOP = i10;
   return;
  }
  __Z19pop_allocation_rootv();
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i3 + 141 >> 0] | 0)) {
  _printf_console(gb + 460809 | 0, i2);
  STACKTOP = i10;
  return;
 }
 switch (HEAP32[i3 + 144 >> 2] | 0) {
 case 0:
  {
   i1 = i3 + 152 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i9 = HEAPU16[i3 + 164 >> 1] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i9;
   _printf_console(gb + 460633 | 0, i8);
   STACKTOP = i10;
   return;
  }
 case 1:
  {
   i1 = i3 + 224 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = 54999;
   _printf_console(gb + 460694 | 0, i7);
   STACKTOP = i10;
   return;
  }
 default:
  {
   _printf_console(gb + 460756 | 0, i1);
   STACKTOP = i10;
   return;
  }
 }
}

function __Z51ParticleSystemRenderer_Get_Custom_PropTrailMaterialP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) <= 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i5 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 1) | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 13; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 13; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 15;
   }
  }
  if ((i6 | 0) == 13) i6 = 15;
  if ((i6 | 0) == 15) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i4 = i6;
 i5 = i2 + 11 | 0;
 if (!(__Z10BeginsWithPKcS0_((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 366730 | 0) | 0)) if (!(__Z10BeginsWithPKcS0_((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 366748 | 0) | 0)) if (__Z10BeginsWithPKcS0_((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 366752 | 0) | 0) {
  __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i2);
  __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i5 = HEAP8[i4 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i5 = i3 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i3 ? HEAP32[i4 >> 2] | 0 : i4, i5, i5 + 1 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, gb + 1087627 | 0, 1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  STACKTOP = i6;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i5 = HEAP8[i5 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i5, i5 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, gb + 1087627 | 0, 1) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx31PxVehicleDrive4WGeneratedValuesC2EPKNS_16PxVehicleDrive4WE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 108 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 112 | 0;
 i4 = i1 + 128 | 0;
 i5 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP32[i2 + 208 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 288 | 0;
 _memcpy(i2 + 212 | 0, i1 + 224 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 276 >> 2] = HEAP32[i3 >> 2];
 i3 = i2 + 292 | 0;
 i4 = i1 + 304 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 324 | 0, i1 + 336 | 0, 416) | 0;
 i3 = i2 + 740 | 0;
 i4 = i1 + 752 | 0;
 i5 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 return;
}

function __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE(i10, i1, i2, f3, i4, f5, f6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11;
 HEAP32[i10 >> 2] = gb + 156124 + 8;
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAPF32[i10 + 20 >> 2] = f3;
 HEAP32[i10 + 24 >> 2] = i4;
 HEAPF32[i10 + 28 >> 2] = f5;
 HEAPF32[i10 + 32 >> 2] = f6;
 HEAP32[i10 + 36 >> 2] = 0;
 __ZN9b2FixtureC2Ev(i10 + 40 | 0);
 HEAP32[i10 + 152 >> 2] = 0;
 HEAP32[i10 + 156 >> 2] = 0;
 HEAPF32[i10 + 160 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 180 >> 2] = 0;
 HEAP32[i10 + 184 >> 2] = 0;
 HEAPF32[i10 + 188 >> 2] = Math_fround(0.0);
 __ZN16b2BlockAllocatorC2Ev(i10 + 268 | 0);
 HEAP32[i10 + 336 >> 2] = i9;
 HEAP32[i10 + 340 >> 2] = 0;
 HEAP32[i10 + 352 >> 2] = 0;
 HEAP32[i10 + 356 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i12, gb + 63664 | 0);
 i2 = i12;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i10 + 344 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i10 + 360 >> 2] = i7;
 HEAP8[i10 + 368 >> 0] = i8 & 1;
 HEAP8[i10 + 369 >> 0] = 0;
 if ((i7 | 0) == 0 | i8 ^ 1) {
  HEAP32[i10 + 364 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 if (HEAP32[i7 + 72 >> 2] | 0) {
  HEAP32[i10 + 364 >> 2] = HEAP32[(HEAP32[HEAP32[i7 + 60 >> 2] >> 2] | 0) + 28 >> 2];
  STACKTOP = i11;
  return;
 }
 i1 = __ZNK10Collider2D20GetAttachedRigidbodyEb(i7, 0) | 0;
 if (!i1) {
  HEAP32[i10 + 364 >> 2] = HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 8 >> 2];
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i10 + 364 >> 2] = HEAP32[i1 + 92 >> 2];
  STACKTOP = i11;
  return;
 }
}

function __Z7ToLowerINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEET_RKS8_(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i3 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i2 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
   i1 = HEAP32[i3 >> 2] | 0;
   i6 = 6;
  } else if (i2 >>> 0 < 11) {
   HEAP8[i7 + 11 >> 0] = i2;
   if (!i2) i1 = i7; else {
    i1 = i7;
    i6 = 8;
   }
  } else i6 = 6;
  if ((i6 | 0) == 6) {
   i3 = i2 + 16 & -16;
   HEAP32[i4 >> 2] = 54;
   HEAP32[i4 + 4 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i7 + 4 >> 2] = i2;
   i6 = 8;
  }
  if ((i6 | 0) == 8) _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 } else {
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 i4 = i7 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i6 = 12;
 } else {
  i2 = i7;
  i6 = 14;
 }
 while (1) {
  if ((i6 | 0) == 12) {
   if (i1 << 24 >> 24 >= 0) {
    i6 = 14;
    continue;
   }
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i7 + 4 >> 2] | 0;
  } else if ((i6 | 0) == 14) {
   i3 = i7;
   i1 = i1 & 255;
  }
  if ((i2 | 0) == (i3 + i1 | 0)) break;
  i6 = HEAP8[i2 >> 0] | 0;
  i1 = i6 << 24 >> 24;
  HEAP8[i2 >> 0] = (i6 + -65 & 255) < 26 ? i1 + 32 | 0 : i1;
  i1 = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i6 = 12;
 }
 STACKTOP = i8;
 return;
}

function __Z22MonoGUIContentToNativeP12Il2CppObjectR10GUIContent(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 40 | 0;
 i2 = i7 + 16 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017992 | 0, 0, gb + 1018033 | 0, 32, 512, 0, 0, 0);
  i1 = gb + 63672 | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = i3;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN11UTF16StringC2EPKc10MemLabelId(i2, gb + 1576256 | 0, i5);
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  __ZN11UTF16StringD2Ev(i2);
  i3 = i6 + 20 | 0;
  i9 = gb + 63672 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN11UTF16StringC2EPKc10MemLabelId(i2, gb + 1576256 | 0, i5);
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  __ZN11UTF16StringD2Ev(i2);
  HEAP32[i6 + 40 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i8 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN11UTF16String12BorrowStringEP12Il2CppString(i6, HEAP32[i1 + 8 >> 2] | 0);
 __ZN11UTF16String12BorrowStringEP12Il2CppString(i6 + 20 | 0, i8);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i6 + 40 >> 2] = i1;
 STACKTOP = i7;
 return;
}

function _block_trim_used(i11, i1, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i2 >> 2] & -4;
 if (i4 >>> 0 < (i3 + 16 | 0) >>> 0) return;
 i10 = i3 + -4 + (i1 + 8) | 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & 3 | -4 - i3 + i4;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 3 | i3;
 i9 = i10 + 8 | 0;
 i7 = i9;
 i1 = ((HEAP32[i8 >> 2] | 0) + -4 & -4) + i7 | 0;
 HEAP32[i1 >> 2] = i10;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 2;
 i1 = HEAP32[i8 >> 2] & -4 | 1;
 HEAP32[i8 >> 2] = i1;
 i5 = (i1 + -4 & -4) + i7 | 0;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 & 1) {
  i1 = i2 & -4;
  if (i1 >>> 0 < 128) {
   i1 = i2 >>> 2;
   i4 = 0;
  } else {
   i4 = 31 - (Math_clz32(i1 | 0) | 0) | 0;
   i1 = i1 >>> (i4 + -5 | 0) ^ 32;
   i4 = i4 + -6 | 0;
  }
  i3 = HEAP32[i5 + 12 >> 2] | 0;
  i2 = HEAP32[i5 + 8 >> 2] | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  HEAP32[i3 + 8 >> 2] = i2;
  i3 = i11 + 116 + (i4 << 7) + (i1 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) {
   HEAP32[i3 >> 2] = i2;
   if ((i2 | 0) == (i11 | 0)) {
    i3 = i11 + 20 + (i4 << 2) | 0;
    i5 = HEAP32[i3 >> 2] & ~(1 << i1);
    HEAP32[i3 >> 2] = i5;
    i1 = i11 + 16 | 0;
    if (!i5) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i4);
   }
  }
  i1 = ((HEAP32[i6 >> 2] | 0) + 4 & -4) + (HEAP32[i8 >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[(i1 + -4 & -4) + i7 >> 2] = i10;
 }
 i2 = i1 & -4;
 if (i2 >>> 0 < 128) {
  i1 = i1 >>> 2;
  i2 = 0;
 } else {
  i8 = 31 - (Math_clz32(i2 | 0) | 0) | 0;
  i1 = i2 >>> (i8 + -5 | 0) ^ 32;
  i2 = i8 + -6 | 0;
 }
 i8 = i11 + 116 + (i2 << 7) + (i1 << 2) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 + 12 >> 2] = i11;
 HEAP32[i7 + 12 >> 2] = i10;
 HEAP32[i8 >> 2] = i10;
 i10 = i11 + 16 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1 << i2;
 i11 = i11 + 20 + (i2 << 2) | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] | 1 << i1;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 i16 = HEAP32[i5 + 4 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f19 = Math_fround(-f12);
 f18 = Math_fround(-f13);
 f17 = Math_fround(-f14);
 f6 = Math_fround(HEAPF32[i16 + 96 >> 2]);
 f7 = Math_fround(HEAPF32[i16 + 100 >> 2]);
 f8 = Math_fround(HEAPF32[i16 + 104 >> 2]);
 f20 = Math_fround(Math_fround(Math_fround(f6 * f19) + Math_fround(f7 * f18)) + Math_fround(f8 * f17));
 f9 = Math_fround(HEAPF32[i16 + 112 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 116 >> 2]);
 f10 = Math_fround(HEAPF32[i16 + 120 >> 2]);
 i16 = f20 > Math_fround(Math_fround(Math_fround(f9 * f19) + Math_fround(f11 * f18)) + Math_fround(f10 * f17));
 f9 = i16 ? f6 : f9;
 f11 = i16 ? f7 : f11;
 f10 = i16 ? f8 : f10;
 i16 = HEAP32[i5 + 8 >> 2] | 0;
 i15 = f12 > Math_fround(0.0);
 i1 = f13 > Math_fround(0.0);
 i5 = f14 > Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i16 + 144 >> 2]);
 f13 = Math_fround(HEAPF32[i16 + 148 >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 152 >> 2]);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f6 = Math_fround(-f12);
 f8 = i15 ? f14 : f8;
 f7 = i1 ? f13 : f7;
 f6 = i5 ? f12 : f6;
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f11;
 HEAPF32[i3 + 8 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = Math_fround(0.0);
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i2 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Gu24computeMTD_SphereCapsuleERNS_6PxVec3ERfRKNS0_6SphereERKNS0_7CapsuleE(i10, i9, i7, i1) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 f8 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i1 + 24 >> 2]));
 if (Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i1, i1 + 12 | 0, i7, i2)) > Math_fround(f8 * f8)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 - f14);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f6 - f13);
 f12 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(f14 + Math_fround(f4 * f5));
 f6 = Math_fround(f13 + Math_fround(f4 * f6));
 f3 = Math_fround(f3 + Math_fround(f4 * Math_fround(f12 - f3)));
 f5 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f5);
 f6 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) - f6);
 f3 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) - f3);
 f12 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f3 * f3));
 f4 = Math_fround(Math_sqrt(Math_fround(f12)));
 if (f12 < Math_fround(9.99999997e-07)) {
  HEAP32[i10 >> 2] = 1065353216;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
 } else {
  f12 = Math_fround(Math_fround(1.0) / f4);
  f13 = Math_fround(f6 * f12);
  f14 = Math_fround(f3 * f12);
  HEAPF32[i10 >> 2] = Math_fround(f5 * f12);
  HEAPF32[i10 + 4 >> 2] = f13;
  HEAPF32[i10 + 8 >> 2] = f14;
 }
 f14 = Math_fround(f8 - f4);
 i10 = f14 > Math_fround(0.0);
 HEAPF32[i9 >> 2] = i10 ? f14 : Math_fround(0.0);
 i10 = 1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i1 = i7;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i7 = i9 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 64, 4) | 0;
   i3 = i2 + 52 | 0;
   i4 = i2;
   i5 = i4 + 52 | 0;
   do {
    HEAP32[i4 >> 2] = 0;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) < (i5 | 0));
   HEAPF32[i3 >> 2] = Math_fround(1.0);
   HEAPF32[i2 + 56 >> 2] = Math_fround(0.0);
   HEAP8[i2 + 60 >> 0] = 1;
   HEAP8[i2 + 61 >> 0] = 1;
   HEAP8[i2 + 62 >> 0] = 0;
   HEAP8[i2 + 63 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf(i4, i5, i1, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, f3 = f0, i6 = 0, f7 = f0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 48 | 0;
 i8 = i13 + 24 | 0;
 i11 = i13;
 i6 = HEAP8[i5 + 28 >> 0] | 0;
 i12 = i6 & 255;
 i6 = i6 << 24 >> 24 == 0;
 if (!i6) {
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  i1 = 0;
  do {
   i14 = i10 + (i1 * 3 << 2) | 0;
   i15 = i2 + ((HEAPU16[i5 + (i1 << 1) >> 1] | 0) * 3 << 2) | 0;
   HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i14 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
   HEAP32[i14 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 }
 if (__Z24dtDistancePtPolyEdgesSqrPKfS0_iPfS1_(i4, i10, i12, i8, i11) | 0) {
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i13;
  return;
 }
 if (i6) i1 = -1; else {
  f3 = Math_fround(3402823469999999843913219.0e14);
  i1 = -1;
  i2 = 0;
  while (1) {
   f7 = Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
   i4 = f7 < f3;
   i1 = i4 ? i2 : i1;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i12 | 0)) break; else f3 = i4 ? f7 : f3;
  }
 }
 i15 = i1 + 1 | 0;
 i14 = i10 + (i1 * 3 << 2) | 0;
 i15 = i10 + (((i15 | 0) == (i12 | 0) ? 0 : i15 * 3 | 0) << 2) | 0;
 f3 = Math_fround(HEAPF32[i11 + (i1 << 2) >> 2]);
 f7 = Math_fround(HEAPF32[i14 >> 2]);
 HEAPF32[i9 >> 2] = Math_fround(f7 + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i15 >> 2]) - f7)));
 f7 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 HEAPF32[i9 + 4 >> 2] = Math_fround(f7 + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i15 + 4 >> 2]) - f7)));
 f7 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 HEAPF32[i9 + 8 >> 2] = Math_fround(f7 + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i15 + 8 >> 2]) - f7)));
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 2;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 2 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 2;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i10 | 0) >>> 2) << 2);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 1;
 i1 = i10 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 1073741823;
 if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 2) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 2);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 2);
 return;
}

function __ZNSt3__26vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 2;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 2 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 2;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 2) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 2) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 2 << 2);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i10 | 0) >>> 2) << 2);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if (i11 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i10 = i1 - i2 | 0;
 i1 = i10 >> 1;
 i1 = i10 >> 2 >>> 0 < 536870911 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 1073741823;
 if (i1 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 2) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 2);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 2);
 return;
}

function __ZN5physx3Cct26CharacterControllerManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 86304 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = HEAP32[i3 + 124 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 116 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = i3 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i2 = HEAP32[i3 + 72 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 64 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 60 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 52 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 48 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 40 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 36 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene25deallocateConstraintBlockEPvj(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (i3 >>> 0 < 129) {
  if (!i2) {
   STACKTOP = i5;
   return;
  }
  i1 = i4 + 496 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i4 + 508 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i1 = i4 + 500 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  if ((i3 | 0) < ((HEAP32[i4 + 492 >> 2] | 0) * 50 | 0)) {
   STACKTOP = i5;
   return;
  }
  __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i4 + 216 | 0);
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
 if (i3 >>> 0 < 257) {
  if (!i2) {
   STACKTOP = i5;
   return;
  }
  i1 = i4 + 792 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i4 + 804 | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i2;
  i1 = i4 + 796 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  if ((i3 | 0) < ((HEAP32[i4 + 788 >> 2] | 0) * 50 | 0)) {
   STACKTOP = i5;
   return;
  }
  __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i4 + 512 | 0);
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
 if (i3 >>> 0 >= 385) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i5;
  return;
 }
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 i1 = i4 + 1088 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i4 + 1100 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i4 + 1092 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 1;
 if ((i3 | 0) < ((HEAP32[i4 + 1084 >> 2] | 0) * 50 | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i4 + 808 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i12 = i11 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i13 = i11 + 24 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 >> 2] = i2;
  i7 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i7 = HEAP32[i12 >> 2] | 0;
  i3 = HEAP32[i13 >> 2] | 0;
 }
 i6 = i10 + 4 | 0;
 i1 = i6 + 11 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i8 = i10 + 8 | 0;
 i4 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i4;
 i5 = i7 + 4 | 0;
 if (i5 >>> 0 < i3 >>> 0) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i12 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i2 = HEAP8[i1 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i6 >> 2] | 0 : i6;
 i9 = i9 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (i9 | 0) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
}

function __ZN17AnimationCurveTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 52 | 0;
 i4 = i6;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 152 | 0, 1);
 i5 = i4;
 i7 = i5 + 52 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034351 | 0, i4, 0);
 __ZN11KeyframeTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034211 | 0, i4, i1 + 172 | 0, 1);
 i5 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034225 | 0, i4, i1 + 176 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034240 | 0, i4, i1 + 180 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i6;
 return;
}

function __ZN14UnityAnalytics23RegisterGlobalCallbacksEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 HEAP8[i5 + 16 >> 0] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 5400 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) + 4 >> 2] = i5;
 HEAP8[i2 + 4632 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 4632 + (i1 * 12 | 0) >> 2] = fb + 329;
 i1 = HEAP32[gb + 1163400 + 768 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i6 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[gb + 1163400 + 768 >> 2] | 0;
 }
 HEAP32[gb + 1163400 + 768 >> 2] = i1 + 1;
 HEAP32[gb + 1163400 + (i1 * 12 | 0) + 4 >> 2] = i5;
 HEAP8[gb + 1163400 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[gb + 1163400 + (i1 * 12 | 0) >> 2] = fb + 1e3;
 i1 = i5 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2;
  i5 = i5 + 24 | 0;
  __ZN11UnityEngine9Analytics15AnalyticsConfig8RegisterERNS_7Connect13ConfigHandlerE(i5, i4);
  STACKTOP = i6;
  return;
 }
 i4 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 544 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 __ZN11UnityEngine7Connect13ConfigHandler6RetainEv(i4);
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i5 + 24 | 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfig8RegisterERNS_7Connect13ConfigHandlerE(i5, i4);
 STACKTOP = i6;
 return;
}

function __ZN12VertexWelderILi2048EE4PushERK8Vector3f(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f13 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(10.0));
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 f15 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) / f13);
 i2 = f15 >= Math_fround(0.0);
 f14 = Math_fround(f15 + Math_fround(-.99999994));
 f17 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) / f13);
 i3 = f17 >= Math_fround(0.0);
 f16 = Math_fround(f17 + Math_fround(-.99999994));
 f13 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f13);
 i10 = f13 >= Math_fround(0.0);
 f12 = Math_fround(f13 + Math_fround(-.99999994));
 i10 = (Math_imul(~~(i3 ? f17 : f16), -669632447) | 0) + (Math_imul(~~(i2 ? f15 : f14), -1918454973) | 0) + (Math_imul(~~(i10 ? f13 : f12), -887442657) | 0) & 2047;
 __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i11, i1);
 i2 = i9 + 8 | 0;
 i3 = i9 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 24 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + (i4 << 2) >> 2] = -1;
 i11 = (HEAP32[i11 + 12 >> 2] | 0) + -1 | 0;
 i10 = i9 + 28 + (i10 << 2) | 0;
 HEAP32[i8 + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 return i11 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 32 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4 + ~(i4 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 16 >> 2] | 0;
   i3 = i11 + 20 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 48 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 28 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 20 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 16 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 << 4;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 683054 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 4) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 << 4) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 << 4) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 << 4) | 0;
 return i10 | 0;
}

function __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i3 + 224 | 0;
 i10 = i3 + 196 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i13 = i2;
 i12 = i7;
 i11 = i5;
 i5 = i6;
 i6 = i4;
 __ZN5physx26PxRigidStaticGeneratedInfoC2Ev(i9);
 HEAP32[i14 >> 2] = i13;
 HEAP32[i14 + 4 >> 2] = i12;
 HEAP32[i14 + 8 >> 2] = i11;
 HEAP32[i14 + 12 >> 2] = i5;
 HEAP32[i14 + 16 >> 2] = i6;
 HEAP32[i14 + 20 >> 2] = 0;
 HEAP32[i14 + 24 >> 2] = 0;
 i7 = __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEEEEjT_j(i9, i14, 0) | 0;
 HEAP32[i10 >> 2] = i13;
 HEAP32[i10 + 4 >> 2] = i12;
 HEAP32[i10 + 8 >> 2] = i11;
 HEAP32[i10 + 12 >> 2] = i5;
 HEAP32[i10 + 16 >> 2] = i6;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i10 + 24 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i10, i9 + 120 | 0, i7);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclERKNS_27PxRigidActorShapeCollectionEj(i10, i9 + 136 | 0, i7 + 1 | 0);
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i14 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __Z38MaterialPropertyBlock_CUSTOM_InitBlockP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 517579 | 0, 3291) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 33952 + 8;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i5);
 i6 = i4;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i3 + 36 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i5);
 i6 = i4;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i3 + 56 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = gb + 63536 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAP32[i3 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i5);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i3 + 76 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 i6 = gb + 63536 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i3 + 108 >> 0] = 1;
 i4 = i3 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS7_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 << 4;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 683156 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 4) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 << 4) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 << 4) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 << 4) | 0;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i7 + 40 | 0;
 i6 = i7 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i4 + 164 >> 2] | 0;
    if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 56 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i11;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 40 | 0;
    i2 = i4 + 48 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i11 = i4 + 44 | 0;
     i10 = HEAP32[i11 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i11 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i11;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = __Znaj(i8 >>> 0 > 1073741823 ? -1 : i8 << 2) | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i6 >> 2] = i8;
 if ((i8 | 0) > 0) {
  HEAP32[i1 >> 2] = 0;
  if ((i8 | 0) != 1) {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  }
 }
 i11 = i7 + 28 | 0;
 HEAP32[i7 + 32 >> 2] = i11;
 HEAP32[i7 + 36 >> 2] = i11;
 i11 = i7 + 16 | 0;
 HEAP32[i7 + 20 >> 2] = i11;
 HEAP32[i7 + 24 >> 2] = i11;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (((i3 - i1 | 0) / 12 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 12 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 12 | 0) + i2 | 0;
 if (i5 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (i3 - i4 | 0) / 12 | 0;
 i3 = i8 << 1;
 i3 = i8 >>> 0 < 178956970 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 357913941;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 12 | 0) | 0;
 i7 = i5 + (((i1 - i4 | 0) / 12 | 0) * 12 | 0) | 0;
 i6 = i7;
 i3 = i5 + (i3 * 12 | 0) | 0;
 i1 = i7;
 i8 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i8 + 12 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i1 = i1 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i1);
   i2 = i3 + -12 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEjRKS3_(i10, i2, i9) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 8 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i1, i9);
   i1 = (HEAP32[i12 >> 2] | 0) + 20 | 0;
   HEAP32[i12 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if (i5 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i7 = (i3 - i4 | 0) / 20 | 0;
 i8 = i7 << 1;
 i5 = i7 >>> 0 < 107374182 ? (i8 >>> 0 < i5 >>> 0 ? i5 : i8) : 214748364;
 if (!i5) i6 = 0; else i6 = __Znwj(i5 * 20 | 0) | 0;
 i7 = i6 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i3 = i7;
 i4 = i6 + (i5 * 20 | 0) | 0;
 i8 = i3;
 i1 = i7;
 do {
  __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i1, i9);
  i1 = i8 + 20 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i2 = i3;
  i5 = i6;
  i1 = i6;
 } else {
  i2 = i7;
  do {
   i1 = i1 + -20 | 0;
   __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i2 + -20 | 0, i1);
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i6 | 0));
  i2 = i3;
  i5 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i11 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN9ShaderLab11shaderprops9GetMatrixEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i7, i5, i8, i1, i9) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) == -1) {
  HEAP32[i9 >> 2] = -1;
  HEAP32[i9 + 4 >> 2] = 3;
  HEAP32[i7 >> 2] = gb + 1162292;
  HEAP16[i7 + 4 >> 1] = 1;
  return;
 }
 if (i6 >>> 0 > 1073741823) {
  i6 = i6 & 1073741823;
  i8 = i9;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = 2;
  i8 = (__Z12GetGfxDevicev() | 0) + 1764 + (i6 << 6) | 0;
  i9 = __Z30GetBuiltinMatrixParamArraySize24BuiltinShaderMatrixParam(i6) | 0;
  HEAP32[i7 >> 2] = i8;
  HEAP16[i7 + 4 >> 1] = i9;
  return;
 }
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 L9 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L9;
  }
  if ((i1 | 0) > -1) {
   i8 = HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i7 >> 2] = (HEAP32[i5 + 72 >> 2] | 0) + (i8 & 1048575);
   HEAP16[i7 + 4 >> 1] = i8 >>> 20 & 1023;
   return;
  }
 } while (0);
 i2 = HEAP32[i8 + 16 >> 2] | 0;
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 L18 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i8 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L18;
  }
  if ((i1 | 0) > -1) {
   i6 = HEAP32[(HEAP32[i8 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 1;
   HEAP32[i7 >> 2] = (HEAP32[i8 + 72 >> 2] | 0) + (i6 & 1048575);
   HEAP16[i7 + 4 >> 1] = i6 >>> 20 & 1023;
   return;
  }
 } while (0);
 HEAP32[i9 >> 2] = -1;
 HEAP32[i9 + 4 >> 2] = 4;
 HEAP32[i7 >> 2] = gb + 1162292;
 HEAP16[i7 + 4 >> 1] = 1;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i1 = i7 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 739170 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 212 | 0;
 i5 = i2 + 160 | 0;
 i6 = i2 + 80 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 24, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 i11 = i1 + 20 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 HEAP8[i11 + 3 >> 0] = 0;
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i6);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i12;
 HEAP32[i5 + 4 >> 2] = i10;
 i10 = i5 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i5 + 20 >> 2] = i9;
 HEAP32[i5 + 24 >> 2] = i1;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP32[i5 + 32 >> 2] = i7;
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i5 + 40 >> 2] = i4;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 0;
 __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j(i6, i5, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN17PersistentManager17GetSerializedTypeEi(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i4 = 5; else {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if ((i3 | 0) > (i5 | 0)) i4 = 5; else if ((HEAP32[i2 + 32 >> 2] | 0) < (i5 | 0)) i4 = 5; else {
   i5 = (i5 - i3 | 0) / 2 | 0;
   i6 = i5;
   i5 = ((i5 | 0) < 0) << 31 >> 31;
  }
 }
 if ((i4 | 0) == 5) {
  i4 = i2 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i7 = 0;
   return i7 | 0;
  } else i2 = i4;
  L9 : while (1) {
   i3 = i1;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i1) break L9; else i3 = i1;
   }
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    break;
   } else i2 = i3;
  }
  if ((i2 | 0) == (i4 | 0)) {
   i7 = 0;
   return i7 | 0;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > (i5 | 0)) {
   i7 = 0;
   return i7 | 0;
  }
  i1 = HEAP32[i2 + 24 >> 2] | 0;
  i2 = i2 + 32 | 0;
  if ((i1 | 0) == -1) {
   i7 = 0;
   return i7 | 0;
  } else {
   i6 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i2 + 4 >> 2] | 0;
  }
 }
 i3 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i7, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 if (!(__ZNK14SerializedFile11IsAvailableEx(i1, i6, i5) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 L30 : do if (i2 | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i2 + 12 >> 2] | 0;
  i2 = i1 + (i7 << 3) | 0;
  L32 : do if (i7) while (1) {
   i7 = i1;
   if ((HEAP32[i7 >> 2] | 0) == (i6 | 0) ? (HEAP32[i7 + 4 >> 2] | 0) == (i5 | 0) : 0) break L32;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i2 | 0)) break L30;
  } while (0);
  if ((i1 | 0) != (i2 | 0)) {
   i7 = 0;
   return i7 | 0;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = __ZNK14SerializedFile7GetTypeEx(i1, i6, i5) | 0;
 return i7 | 0;
}

function _start_pass_fdctmgr(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = HEAP32[i6 + 344 >> 2] | 0;
 i9 = i6 + 60 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) return;
 i10 = i6 + 184 | 0;
 i11 = i6 + 4 | 0;
 i7 = i8 + 16 | 0;
 i4 = HEAP32[i6 + 68 >> 2] | 0;
 i5 = 0;
 while (1) {
  i3 = HEAP32[i4 + 16 >> 2] | 0;
  i1 = i6 + 72 + (i3 << 2) | 0;
  if (i3 >>> 0 > 3) i12 = 5; else {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i12 = 5;
  }
  if ((i12 | 0) == 5) {
   i12 = 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 + 20 >> 2] = 52;
   HEAP32[i2 + 24 >> 2] = i3;
   mftCall_vi(HEAP32[i2 >> 2] | 0, i6 | 0);
   i2 = HEAP32[i1 >> 2] | 0;
  }
  switch (HEAP32[i10 >> 2] | 0) {
  case 0:
   {
    i1 = i8 + 20 + (i3 << 2) | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i3 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i6 | 0, 1, 1024) | 0;
     HEAP32[i1 >> 2] = i3;
    }
    i1 = 0;
    do {
     if (!(_compute_reciprocal(HEAPU16[i2 + (i1 << 1) >> 1] << 3 & 65535, i3 + (i1 << 2) | 0) | 0)) if ((HEAP32[i7 >> 2] | 0) == (fb + 488 | 0)) HEAP32[i7 >> 2] = fb + 489;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 64);
    break;
   }
  case 1:
   {
    i1 = i8 + 20 + (i3 << 2) | 0;
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) {
     i3 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i6 | 0, 1, 1024) | 0;
     HEAP32[i1 >> 2] = i3;
    }
    i1 = 0;
    do {
     if (!(_compute_reciprocal(((Math_imul(HEAP16[gb + 216784 + (i1 << 1) >> 1] | 0, HEAPU16[i2 + (i1 << 1) >> 1] | 0) | 0) + 1024 | 0) >>> 11 & 65535, i3 + (i1 << 2) | 0) | 0)) if ((HEAP32[i7 >> 2] | 0) == (fb + 488 | 0)) HEAP32[i7 >> 2] = fb + 489;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != 64);
    break;
   }
  default:
   {
    i3 = HEAP32[i6 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 48;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i6 | 0);
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (HEAP32[i9 >> 2] | 0)) break; else i4 = i4 + 84 | 0;
 }
 return;
}

function __ZN5physx7NpScene20fireCallBacksPreSyncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i13 = i15 + 8 | 0;
 i10 = i1 + 32 | 0;
 i1 = __ZN5physx2Sc5Scene24fireOutOfBoundsCallbacksEv(i10) | 0;
 i11 = __ZN5physx2Sc5Scene24getOutOfBoundsAggregatesEv(i10) | 0;
 i12 = i11 + 4 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 if (i8) {
  i9 = 0;
  do {
   i7 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i9 << 2) >> 2] | 0;
   if ((HEAP32[i7 + 12 >> 2] | 0) >>> 0 <= 3221225471) {
    i2 = i13;
    i3 = i2 + 128 | 0;
    do {
     HEAP8[i2 >> 0] = 0;
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) < (i3 | 0));
    i4 = HEAP32[i7 + 36 >> 2] | 0;
    if (i4) {
     i5 = i7 + 40 | 0;
     i6 = 0;
     do {
      i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 << 2) >> 2] | 0;
      i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0;
      i3 = i13 + (i2 & 255) | 0;
      if (!(HEAP8[i3 >> 0] | 0)) {
       HEAP8[i3 >> 0] = 1;
       i2 = __ZNK5physx2Sc5Scene21getBroadPhaseCallbackEh(i10, i2) | 0;
       if (!i2) i1 = 1; else mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i7 | 0);
      }
      i6 = i6 + 1 | 0;
     } while ((i6 | 0) != (i4 | 0));
    }
   }
   i9 = i9 + 1 | 0;
  } while ((i9 | 0) != (i8 | 0));
 }
 HEAP32[i13 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i11, 0, i13);
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i11, HEAP32[i12 >> 2] | 0);
 if (!i1) {
  __ZN5physx2Sc5Scene20fireCallBacksPreSyncEv(i10);
  STACKTOP = i15;
  return;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 2233, gb + 707517 | 0, i14);
 __ZN5physx2Sc5Scene20fireCallBacksPreSyncEv(i10);
 STACKTOP = i15;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 4) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 4) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 4) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i11, i10, i7) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i11 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = (i9 | 0) == 0;
 L1 : do if (i6) i1 = 0; else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = i4;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = (i1 >>> 16 ^ i1) & i9 + -1;
  i2 = HEAP32[(HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i11 + 4 >> 2] | 0;
   i3 = i11 + 8 | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
     i1 = i2;
     break;
    }
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   HEAP8[i7 >> 0] = 1;
   i11 = i5 + (i1 << 3) | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP8[i7 >> 0] = 0;
 i2 = i11 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i11 + 16 >> 2] | 0)) {
  i1 = i6 ? 16 : i9 << 1;
  if (i9 >>> 0 < i1 >>> 0) {
   __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i11, i1);
   i1 = HEAP32[i8 >> 2] | 0;
  } else i1 = i9;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + ~(i10 << 15) | 0;
  i10 = (i10 >>> 10 ^ i10) * 9 | 0;
  i10 = i10 >>> 6 ^ i10;
  i10 = i10 + ~(i10 << 11) | 0;
  i1 = (i10 >>> 16 ^ i10) & i1 + -1;
 }
 i9 = i11 + 28 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 + 1;
 i9 = (HEAP32[i11 + 12 >> 2] | 0) + (i1 << 2) | 0;
 HEAP32[(HEAP32[i11 + 8 >> 2] | 0) + (i10 << 2) >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i10;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = (HEAP32[i11 + 4 >> 2] | 0) + (i10 << 3) | 0;
 return i11 | 0;
}

function __ZN14dtPathCorridor28optimizePathVisibilitySimpleEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i6, i1, i2, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i10 = i14 + 288 | 0;
 i4 = i14;
 HEAP32[i10 >> 2] = 0;
 i5 = i6 + 28 | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii(i2, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, i6, i1, i3, i4, i13, i10, 32) | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 if ((i10 | 0) <= 1) {
  STACKTOP = i14;
  return;
 }
 if (!(Math_fround(HEAPF32[i4 >> 2]) > Math_fround(.990000009))) {
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i5 >> 2] | 0;
 i12 = i6 + 32 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP32[i6 + 36 >> 2] | 0;
 i4 = -1;
 i6 = i1;
 i3 = -1;
 do {
  if ((i6 | 0) <= 0) break;
  i6 = i6 + -1 | 0;
  i8 = i11 + (i6 << 3) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i10;
  i5 = 0;
  do {
   i15 = i2;
   i2 = i2 + -1 | 0;
   i16 = i13 + (i2 << 3) | 0;
   i16 = (i7 | 0) == (HEAP32[i16 >> 2] | 0) ? (i8 | 0) == (HEAP32[i16 + 4 >> 2] | 0) : 0;
   i3 = i16 ? i2 : i3;
   i5 = i5 | i16;
   i4 = i16 ? i6 : i4;
  } while ((i15 | 0) > 1);
 } while (!i5);
 if (!((i3 | 0) < 1 | (i4 | 0) == -1)) {
  i2 = i1 - i4 | 0;
  i2 = (i2 | 0) < 0 ? 0 : i2;
  i2 = (i2 + i3 | 0) > (i9 | 0) ? i9 - i3 | 0 : i2;
  if (i2 | 0) _memmove(i11 + (i3 << 3) | 0, i11 + (i4 << 3) | 0, i2 << 3 | 0) | 0;
  if ((i3 | 0) > 0) {
   i1 = 0;
   do {
    i10 = i13 + (i1 << 3) | 0;
    i15 = HEAP32[i10 + 4 >> 2] | 0;
    i16 = i11 + (i1 << 3) | 0;
    HEAP32[i16 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i16 + 4 >> 2] = i15;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  i1 = i2 + i3 | 0;
 }
 HEAP32[i12 >> 2] = i1;
 STACKTOP = i14;
 return;
}

function __ZN13RenderTexture15DestroySurfacesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 128 >> 2] | 0;
 if (!i1) if (!(HEAP32[i7 + 136 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = i7 + 128 | 0;
 __ZN16RenderTextureMap6RemoveEPK17RenderSurfaceBase(i1);
 i5 = i7 + 136 | 0;
 __ZN16RenderTextureMap6RemoveEPK17RenderSurfaceBase(HEAP32[i5 >> 2] | 0);
 i3 = __Z12GetGfxDevicev() | 0;
 i4 = i7 + 140 | 0;
 i11 = 0 - (HEAP32[i4 >> 2] | 0) | 0;
 i1 = i3 + 3808 | 0;
 i10 = i1;
 i11 = _i64Add(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, i11 | 0, ((i11 | 0) < 0) << 31 >> 31 | 0) | 0;
 i10 = getTempRet0() | 0;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i10;
 HEAP32[i4 >> 2] = 0;
 i4 = __Z16GetRenderManagerv() | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i4, i6, i7);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 324 >> 2] | 0, i3 | 0, i2 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i7 + 132 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i4, i6, i7);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 324 >> 2] | 0, i3 | 0, i1 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i4, i6, i7);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 324 >> 2] | 0, i3 | 0, i5 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 STACKTOP = i9;
 return;
}

function __ZN12VertexWelderILi64EE4PushERK8Vector3f(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f13 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) * Math_fround(10.0));
 i11 = HEAP32[i9 + 4 >> 2] | 0;
 f15 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) / f13);
 i2 = f15 >= Math_fround(0.0);
 f14 = Math_fround(f15 + Math_fround(-.99999994));
 f17 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) / f13);
 i3 = f17 >= Math_fround(0.0);
 f16 = Math_fround(f17 + Math_fround(-.99999994));
 f13 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f13);
 i10 = f13 >= Math_fround(0.0);
 f12 = Math_fround(f13 + Math_fround(-.99999994));
 i10 = (Math_imul(~~(i3 ? f17 : f16), -669632447) | 0) + (Math_imul(~~(i2 ? f15 : f14), -1918454973) | 0) + (Math_imul(~~(i10 ? f13 : f12), -887442657) | 0) & 63;
 __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i11, i1);
 i2 = i9 + 8 | 0;
 i3 = i9 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 24 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 + (i4 << 2) >> 2] = -1;
 i11 = (HEAP32[i11 + 12 >> 2] | 0) + -1 | 0;
 i10 = i9 + 28 + (i10 << 2) | 0;
 HEAP32[i8 + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i11;
 return i11 | 0;
}

function __ZNSt3__23mapIN20TextRenderingPrivate7FontRefENS1_6OSFontENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEixERS8_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
  i5 = 11;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if (__ZNK20TextRenderingPrivate7FontRefltERKS0_(i7, i2) | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 4;
     break;
    } else i1 = i2;
   } else {
    if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i2, i7) | 0)) {
     i5 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i5 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 4) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i5 | 0) == 8) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i3;
   break;
  } else if ((i5 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i6;
   i5 = 11;
   break;
  }
 } while (0);
 if ((i5 | 0) == 11) if (i1) {
  i8 = i1;
  i8 = i8 + 32 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = __Znwj(48) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 16 | 0, i7);
 HEAP32[i3 + 28 >> 2] = HEAP32[i7 + 12 >> 2];
 i1 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i3;
 i8 = i8 + 32 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx14NpArticulation6wakeUpEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i11 + 16 | 0;
 if ((((HEAP32[i10 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i11 + 12 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 } else i1 = 0;
 i8 = i11 + 92 | 0;
 L5 : do if (HEAP32[i8 >> 2] | 0) {
  i7 = i11 + 88 | 0;
  i2 = i1 + 2876 | 0;
  i6 = 0;
  while (1) {
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   i5 = i4 + 48 | 0;
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   switch ((HEAP32[i4 + 52 >> 2] | 0) >>> 30 | 0) {
   case 3:
    {
     i1 = HEAP32[i5 >> 2] | 0;
     i9 = 10;
     break;
    }
   case 2:
    {
     i1 = HEAP32[i5 >> 2] | 0;
     if (!(HEAP8[i1 + 2432 >> 0] | 0)) i9 = 9; else i9 = 10;
     break;
    }
   default:
    i9 = 9;
   }
   if ((i9 | 0) == 9) {
    HEAP32[i4 + 280 >> 2] = 0;
    HEAPF32[i4 + 276 >> 2] = f3;
    __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i4 + 64 | 0, f3, 1);
   } else if ((i9 | 0) == 10) {
    HEAP32[i4 + 280 >> 2] = 0;
    HEAPF32[i4 + 276 >> 2] = f3;
    __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i5);
    i9 = i4 + 284 | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & -29360129 | 20971520;
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) break L5;
  }
 } while (0);
 i1 = i11 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 2860 >> 2]);
 HEAPF32[i11 + 60 >> 2] = f3;
 HEAP8[i11 + 64 >> 0] = 0;
 switch ((HEAP32[i10 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i9 = 15;
   break;
  }
 case 2:
  {
   if (!(HEAP8[i2 + 2432 >> 0] | 0)) i9 = 14; else i9 = 15;
   break;
  }
 default:
  i9 = 14;
 }
 if ((i9 | 0) == 14) {
  __ZN5physx2Sc16ArticulationCore6wakeUpEf(i11 + 24 | 0, f3);
  return;
 } else if ((i9 | 0) == 15) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i2, i1);
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -897 | 640;
  return;
 }
}

function __ZN9ShaderLab11shaderprops9GetVectorEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i7, i5, i8, i1, i9) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) == -1) {
  HEAP32[i9 >> 2] = -1;
  HEAP32[i9 + 4 >> 2] = 3;
  HEAP32[i7 >> 2] = gb + 1162376;
  HEAP16[i7 + 4 >> 1] = 1;
  return;
 }
 if (i6 >>> 0 > 1073741823) {
  i6 = i6 & 1073741823;
  i8 = i9;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = 2;
  i8 = (__Z12GetGfxDevicev() | 0) + 4 + (i6 << 4) | 0;
  i9 = __Z30GetBuiltinVectorParamArraySize24BuiltinShaderVectorParam(i6) | 0;
  HEAP32[i7 >> 2] = i8;
  HEAP16[i7 + 4 >> 1] = i9;
  return;
 }
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 i3 = HEAP32[i5 + 16 >> 2] | 0;
 L9 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L9;
  }
  if ((i1 | 0) > -1) {
   i8 = HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i7 >> 2] = (HEAP32[i5 + 72 >> 2] | 0) + (i8 & 1048575);
   HEAP16[i7 + 4 >> 1] = i8 >>> 20 & 1023;
   return;
  }
 } while (0);
 i2 = HEAP32[i8 + 12 >> 2] | 0;
 i3 = HEAP32[i8 + 16 >> 2] | 0;
 L18 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i8 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L18;
  }
  if ((i1 | 0) > -1) {
   i6 = HEAP32[(HEAP32[i8 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 1;
   HEAP32[i7 >> 2] = (HEAP32[i8 + 72 >> 2] | 0) + (i6 & 1048575);
   HEAP16[i7 + 4 >> 1] = i6 >>> 20 & 1023;
   return;
  }
 } while (0);
 HEAP32[i9 >> 2] = -1;
 HEAP32[i9 + 4 >> 2] = 4;
 HEAP32[i7 >> 2] = gb + 1162376;
 HEAP16[i7 + 4 >> 1] = 1;
 return;
}

function __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii(i16, i14, f10, i11, i12) {
 i16 = i16 | 0;
 i14 = i14 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19;
 i18 = i19 + 8 | 0;
 __ZN9Animation20BuildAnimationStatesEv(i16);
 i2 = HEAP32[i16 + 104 >> 2] | 0;
 i13 = HEAP32[i16 + 108 >> 2] | 0;
 i15 = HEAP8[i14 + 11 >> 0] | 0;
 L1 : do if ((i2 | 0) == (i13 | 0)) {
  i2 = i14;
  i1 = HEAP32[i14 >> 2] | 0;
 } else {
  i9 = i15 << 24 >> 24 < 0;
  i8 = i9 ? HEAP32[i14 + 4 >> 2] | 0 : i15 & 255;
  i1 = HEAP32[i14 >> 2] | 0;
  i9 = i9 ? i1 : i14;
  while (1) {
   i7 = HEAP32[i2 >> 2] | 0;
   i4 = i7 + 112 | 0;
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   if (i3) i5 = HEAP32[i7 + 116 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i8 | 0)) {
    if (i3) {
     i4 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i7 + 116 >> 2] | 0;
    } else i3 = i6 & 255;
    if (!(_strncmp(i4, i9, i3) | 0)) break;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i13 | 0)) {
    i2 = i14;
    break L1;
   }
  }
  if (!i7) i2 = i14; else {
   i18 = __ZN9Animation14QueueCrossFadeER14AnimationStatefii(i16, i7, f10, i11, i12) | 0;
   STACKTOP = i19;
   return i18 | 0;
  }
 } while (0);
 i14 = HEAP32[gb + 176236 >> 2] | 0;
 i15 = i15 << 24 >> 24 < 0 ? i1 : i2;
 HEAP32[i17 >> 2] = i15;
 HEAP32[i17 + 4 >> 2] = i15;
 __Z6FormatPKcz(i18, i14, i17);
 if (!i16) i1 = 0; else i1 = HEAP32[i16 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i18 + 11 >> 0] | 0) < 0 ? HEAP32[i18 >> 2] | 0 : i18, 0, gb + 896407 | 0, 433, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i18);
 i18 = 0;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i1 = i5 + 384 | 0;
 i2 = i5 + 388 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i7 = i5 + 372 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i8;
  i8 = i5 + 376 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i2 >> 2] = i7;
  i7 = i5 + 380 | 0;
  i3 = i5 + 392 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i6);
 }
 i1 = i5 + 300 | 0;
 i2 = i5 + 304 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i8 = i5 + 288 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i7;
  i7 = i5 + 292 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i2 >> 2] = i8;
  i3 = i5 + 296 | 0;
  i8 = i5 + 308 | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i8 >> 2] = i7;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i4);
 }
 i1 = i5 + 336 | 0;
 i2 = i5 + 340 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i8 = i5 + 540 | 0;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i8 = i5 + 324 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i7;
 i7 = i5 + 328 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i2 >> 2] = i8;
 i3 = i5 + 332 | 0;
 i8 = i5 + 344 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i7;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, 0, i4);
 i8 = i5 + 540 | 0;
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx15PxsParticleData13setPositionsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE(i1, i14, i2, i4) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i14) return;
 i12 = HEAP32[i1 + 48 >> 2] | 0;
 i13 = i1 + 24 | 0;
 i7 = i1 + 28 | 0;
 i8 = i1 + 32 | 0;
 i9 = i1 + 36 | 0;
 i10 = i1 + 40 | 0;
 i5 = i1 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = 0;
 while (1) {
  i4 = HEAP32[i3 >> 2] | 0;
  i22 = i12 + (i4 << 5) | 0;
  i23 = i1;
  i25 = HEAP32[i1 >> 2] | 0;
  HEAP32[i22 >> 2] = i25;
  i24 = HEAP32[i23 + 4 >> 2] | 0;
  i21 = i12 + (i4 << 5) + 4 | 0;
  HEAP32[i21 >> 2] = i24;
  i23 = HEAP32[i23 + 8 >> 2] | 0;
  i4 = i12 + (i4 << 5) + 8 | 0;
  HEAP32[i4 >> 2] = i23;
  f15 = Math_fround(HEAPF32[i13 >> 2]);
  f16 = (HEAP32[tempDoublePtr >> 2] = i25, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f17 = Math_fround(HEAPF32[i7 >> 2]);
  f18 = (HEAP32[tempDoublePtr >> 2] = i24, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f19 = Math_fround(HEAPF32[i8 >> 2]);
  f20 = (HEAP32[tempDoublePtr >> 2] = i23, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i13 >> 2] = f15 < f16 ? f15 : f16;
  HEAPF32[i7 >> 2] = f17 < f18 ? f17 : f18;
  HEAPF32[i8 >> 2] = f19 < f20 ? f19 : f20;
  f20 = Math_fround(HEAPF32[i9 >> 2]);
  f19 = Math_fround(HEAPF32[i22 >> 2]);
  f18 = Math_fround(HEAPF32[i10 >> 2]);
  f17 = Math_fround(HEAPF32[i21 >> 2]);
  f16 = Math_fround(HEAPF32[i5 >> 2]);
  f15 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i9 >> 2] = f20 > f19 ? f20 : f19;
  HEAPF32[i10 >> 2] = f18 > f17 ? f18 : f17;
  HEAPF32[i5 >> 2] = f16 > f15 ? f16 : f15;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i14 | 0)) break; else {
   i3 = i3 + i6 | 0;
   i1 = i1 + i11 | 0;
  }
 }
 return;
}

function __ZN4FMOD7SystemI7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE(i6, i1, i3, i2, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, d8 = 0.0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   i1 = __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7GetFreeEi(i6 + 76 | 0, -1) | 0;
   if (!i1) {
    HEAP32[i4 >> 2] = 10;
    HEAP32[i4 + 4 >> 2] = gb + 865085;
    _printf(gb + 859330 | 0, i4) | 0;
    i7 = 10;
    STACKTOP = i5;
    return i7 | 0;
   } else {
    HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i1 + 64 >> 2] = 0;
    HEAP32[i1 + 68 >> 2] = 0;
    i3 = i1 + 128 | 0;
    HEAP32[i3 >> 2] = 44100;
    HEAP32[i3 + 4 >> 2] = 0;
    d8 = +__Z19GetTimeSinceStartupv() * 44100.0;
    i3 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
    i4 = i1 + 104 | 0;
    HEAP32[i4 >> 2] = ~~d8 >>> 0;
    HEAP32[i4 + 4 >> 2] = i3;
    i4 = i1 + 52 | 0;
    i3 = i1 + 60 | 0;
    i2 = i1 + 56 | 0;
    i7 = HEAP32[i2 >> 2] | 0;
    HEAP32[i7 + 8 >> 2] = HEAP32[i3 >> 2];
    HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i7;
    HEAP32[i2 >> 2] = i4;
    i7 = i6 + 68 | 0;
    HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i3 >> 2] = i6 + 64;
    HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] = i4;
    HEAP32[i7 >> 2] = i4;
    i7 = i6 + 36 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i7 = 0;
    STACKTOP = i5;
    return i7 | 0;
   }
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 865085;
 _printf(gb + 853184 | 0, i2) | 0;
 i7 = 36;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i10, i6, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i1 >> 2] = i3;
  i1 = i7;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  i2 = i2 + i3 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 >> 2] = i2 + 4;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i3;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i10, i8, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi(i1, i10, i19, i20, i21) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i22 = 0, i23 = 0, i24 = 0, i25 = 0, i26 = 0, f27 = f0, f28 = f0, i29 = 0;
 i26 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i22 = i26;
 if ((i21 | 0) <= 0) {
  STACKTOP = i26;
  return;
 }
 i23 = i1 + 8 | 0;
 i24 = i1 + 4 | 0;
 i25 = i1 + 28 | 0;
 i11 = i22 + 4 | 0;
 i12 = i1 + 32 | 0;
 i13 = i22 + 8 | 0;
 i14 = i1 + 36 | 0;
 i15 = i1 + 24 | 0;
 i16 = i1 + 40 | 0;
 i17 = i1 + 44 | 0;
 i18 = i1 + 48 | 0;
 i7 = i1 + 16 | 0;
 i6 = 0;
 do {
  i9 = i19 + (i6 << 3) | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = HEAP32[i20 + (i6 << 2) >> 2] | 0;
  if (HEAP32[(HEAP32[i23 >> 2] | 0) + 128 >> 2] & HEAP32[i1 + 24 >> 2] | 0) {
   i29 = HEAP32[i24 >> 2] | 0;
   __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf(i25, i1, i10, i22);
   __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i29, i8, i9, i22, i11) | 0;
   f2 = Math_fround(HEAPF32[i22 >> 2]);
   f28 = Math_fround(f2 - Math_fround(HEAPF32[i25 >> 2]));
   f3 = Math_fround(HEAPF32[i11 >> 2]);
   f27 = Math_fround(f3 - Math_fround(HEAPF32[i12 >> 2]));
   f4 = Math_fround(HEAPF32[i13 >> 2]);
   f5 = Math_fround(f4 - Math_fround(HEAPF32[i14 >> 2]));
   f5 = Math_fround(Math_fround(Math_fround(f28 * f28) + Math_fround(f27 * f27)) + Math_fround(f5 * f5));
   if (f5 < Math_fround(HEAPF32[i15 >> 2])) {
    HEAPF32[i16 >> 2] = f2;
    HEAPF32[i17 >> 2] = f3;
    HEAPF32[i18 >> 2] = f4;
    HEAPF32[i15 >> 2] = f5;
    i29 = i7;
    HEAP32[i29 >> 2] = i8;
    HEAP32[i29 + 4 >> 2] = i9;
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i21 | 0));
 STACKTOP = i26;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i11, i12, i9, i7, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i10 = 0;
 i10 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_(i11, i12, i9, i1) | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 if (f5 < f6) {
  i2 = i9 + 4 | 0;
  i3 = i7 + 4 | 0;
  i1 = i3;
  i8 = i2;
  i3 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i12 = i10;
   return i12 | 0;
  }
  i1 = i7 + 4 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i9 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i2 >>> 0) {
   i8 = i3;
   i3 = i4;
  } else {
   i12 = i10;
   return i12 | 0;
  }
 }
 HEAPF32[i9 >> 2] = f5;
 HEAPF32[i7 >> 2] = f6;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i1 >> 2] = i2;
 i2 = i10 + 1 | 0;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 if (f5 < f6) {
  i1 = i12 + 4 | 0;
  i7 = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i12 = i2;
   return i12 | 0;
  }
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = i12 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i1 >>> 0) {
   i7 = i3;
   i2 = i4;
  } else {
   i12 = i2;
   return i12 | 0;
  }
 }
 HEAPF32[i12 >> 2] = f5;
 HEAPF32[i9 >> 2] = f6;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i1;
 i2 = i10 + 2 | 0;
 f5 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 if (f5 < f6) {
  i1 = i11 + 4 | 0;
  i3 = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  if (f6 < f5) {
   i12 = i2;
   return i12 | 0;
  }
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i11 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < i1 >>> 0) i2 = i4; else {
   i12 = i2;
   return i12 | 0;
  }
 }
 HEAPF32[i11 >> 2] = f5;
 HEAPF32[i12 >> 2] = f6;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i7 >> 2] = i1;
 i12 = i10 + 3 | 0;
 return i12 | 0;
}

function __ZN9ShaderLab9IntShader10LinkShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEb(i12, i1, i7, i8) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i9 = i12 + 132 | 0;
 i10 = i12 + 136 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) != (i2 | 0)) {
  i6 = i1 + 24 | 0;
  i5 = i6 + 11 | 0;
  i4 = 0;
  i1 = i2;
  do {
   i2 = i1 + (i4 * 24 | 0) + 12 | 0;
   if (!(__Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb(i2, i7, i8) | 0)) {
    if ((HEAP8[i5 >> 0] | 0) < 0) i3 = HEAP32[i6 >> 2] | 0; else i3 = i6;
    i1 = i1 + (i4 * 24 | 0) | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
    HEAP32[i11 >> 2] = i3;
    HEAP32[i11 + 4 >> 2] = i1;
    HEAP32[i11 + 8 >> 2] = i2;
    _printf_console(gb + 481457 | 0, i11);
   }
   i4 = i4 + 1 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } while (i4 >>> 0 < (((HEAP32[i10 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0);
 }
 __ZN9ShaderLab9IntShader27DeleteUnsupportedSubShadersEv(i12);
 i2 = HEAP32[i12 >> 2] | 0;
 i6 = i12 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i13;
  return;
 }
 i7 = i12 + 92 | 0;
 i5 = i12 + 72 | 0;
 do {
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 20 | 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    __ZN9ShaderLab11ShaderState29FindPropsAffectingStateBlocksERK19ShaderPropertySheetR13dynamic_arrayIiLj4EE((HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 4 | 0, HEAP32[i7 >> 2] | 0, i5);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i13;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE17mergeAccelerationEPj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & HEAP32[i1 + 96 >> 2];
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 100 >> 2];
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 104 >> 2];
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 108 >> 2];
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 112 >> 2];
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 116 >> 2];
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 120 >> 2];
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 124 >> 2];
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 128 >> 2];
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 132 >> 2];
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 136 >> 2];
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 140 >> 2];
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 144 >> 2];
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 148 >> 2];
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 152 >> 2];
 i2 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 156 >> 2];
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 160 >> 2];
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 164 >> 2];
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 168 >> 2];
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 172 >> 2];
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 176 >> 2];
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 180 >> 2];
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 184 >> 2];
 i2 = i1 + 92 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & HEAP32[i1 + 188 >> 2];
 return;
}

function __ZN3MBPD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 2 | 0;
 i4 = i7 + 1 | 0;
 i5 = i7;
 HEAP32[i6 >> 2] = gb + 104132 + 8;
 __ZN3MBP5resetEv(i6);
 i1 = i6 + 5252 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 5256 >> 2] = 0;
 __ZN5physx2Gu9ContainerD2Ev(i6 + 5236 | 0);
 i2 = i6 + 96 | 0;
 i1 = i6 + 4208 | 0;
 do {
  i1 = i1 + -16 | 0;
  __ZN5physx2Gu9ContainerD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 92 >> 2] = 0;
 i1 = i6 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 84 >> 2] = 0;
 i1 = i6 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = i6 + 52 | 0;
  HEAP32[i5 >> 2] = 0;
  i5 = i6 + 56 | 0;
  HEAP32[i5 >> 2] = 0;
  i5 = i6 + 60 | 0;
  HEAP32[i5 >> 2] = 0;
  i5 = i6 + 36 | 0;
  __ZN5physx2Gu9ContainerD2Ev(i5);
  i6 = i6 + 20 | 0;
  __ZN5physx2Gu9ContainerD2Ev(i6);
  STACKTOP = i7;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i2);
 HEAP32[i1 >> 2] = 0;
 i5 = i6 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i6 + 56 | 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i6 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i6 + 36 | 0;
 __ZN5physx2Gu9ContainerD2Ev(i5);
 i6 = i6 + 20 | 0;
 __ZN5physx2Gu9ContainerD2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i8 = i9 + 184 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) i4 = 8; else {
  i1 = i8;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i7 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i8 | 0)) i4 = 8; else if ((HEAP32[i1 + 16 >> 2] | 0) > (i7 | 0)) i4 = 8;
 }
 if ((i4 | 0) == 8) i1 = i8;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 if ((__ZNK15MonoScriptCache8RefCountEv(i4) | 0) > 1) {
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 180 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 if (i6 | 0) {
  i3 = i8;
  i2 = i6;
  L17 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i7 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L17;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i8 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) <= (i7 | 0)) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) HEAP32[i5 >> 2] = i1;
   i8 = i9 + 192 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i3);
   i9 = HEAP32[i9 + 188 >> 2] | 0;
   HEAP32[i10 >> 2] = 76;
   HEAP32[i10 + 4 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i10);
  }
 }
 __ZNK15MonoScriptCache7ReleaseEv(i4);
 STACKTOP = i11;
 return;
}

function __Z45AssetBundleManifest_CUSTOM_GetAllAssetBundlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN19AssetBundleManifest18GetAllAssetBundlesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i2, i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i8 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i6 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i8 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i5 | 0;
}

function __ZNK8Material8FindPassERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i2 = i10 + 8 | 0;
 i3 = __ZNK8Material9GetShaderEv(i1) | 0;
 if (!i3) {
  i8 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i4 + 4 >> 2] = i9;
  __Z6FormatPKcz(i2, gb + 477709 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 469775 | 0, 696, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i9 = -1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] | 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i3 | 0) <= 0) {
  i9 = -1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = i9 + 11 | 0;
 i1 = 0;
 L8 : while (1) {
  i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i8 = i11 + 728 | 0;
  i5 = (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
  i6 = _strlen(i5) | 0;
  i7 = HEAP8[i8 + 11 >> 0] | 0;
  if ((i6 | 0) == ((i7 << 24 >> 24 < 0 ? HEAP32[i11 + 732 >> 2] | 0 : i7 & 255) | 0)) {
   switch (i6 | 0) {
   case -1:
    {
     i2 = 7;
     break L8;
    }
   case 0:
    {
     i2 = 10;
     break L8;
    }
   default:
    {}
   }
   if (!(_memcmp(i7 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i8, i5, i6) | 0)) {
    i2 = 10;
    break;
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i3 | 0)) {
   i1 = -1;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 7) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8); else if ((i2 | 0) == 10) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx24PxsParticleSystemBatcher23scheduleShapeGenerationEPPNS_20PxvParticleSystemSimEPNS_28PxvParticleShapesUpdateInputEjRNS_10PxBaseTaskE(i17, i15, i14, i12, i16) {
 i17 = i17 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i18;
 if (!i12) i1 = i17 + 12 | 0; else {
  i5 = i17 + 88 | 0;
  i1 = i17 + 12 | 0;
  i6 = i17 + 8 | 0;
  i7 = i17 + 48 | 0;
  i8 = i17 + 44 | 0;
  i9 = i17 + 40 | 0;
  i10 = i17 + 84 | 0;
  i11 = i17 + 20 | 0;
  i13 = 0;
  do {
   i3 = __ZN5physx20PxsParticleSystemSim26schedulePacketShapesUpdateERKNS_28PxvParticleShapesUpdateInputERNS_10PxBaseTaskE(HEAP32[i15 + (i13 << 2) >> 2] | 0, i14 + (i13 << 3) | 0, i16) | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
   __ZN5physx6shdfnd15atomicIncrementEPVi(i1) | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 >> 2] = i3;
   i4 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i8 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11, i2) | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
   HEAP8[i10 >> 0] = 1;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i12 | 0));
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i16 | 0);
  i17 = i16;
  STACKTOP = i18;
  return i17 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) > 1) do __ZN5physx2Cm10FanoutTask15removeReferenceEv(i17); while ((HEAP32[i1 >> 2] | 0) > 1);
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 5, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 5, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 5 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 5) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 5) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i3 = HEAP32[i11 + 4 >> 2] | 0;
 if ((HEAP32[i11 + 36 >> 2] | 0) == (i3 | 0)) {
  i12 = (HEAP32[i11 + 28 >> 2] | 0) + (HEAP32[i11 + 32 >> 2] << 3) | 0;
  HEAP32[i10 >> 2] = i11;
  HEAP32[i10 + 4 >> 2] = i12;
  HEAP32[i10 + 8 >> 2] = i12;
  return;
 }
 i12 = HEAP32[i11 + 32 >> 2] | 0;
 i8 = i12 + -1 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = (Math_imul((Math_imul((Math_imul((Math_imul(i6 >>> 24 ^ -2128831035, 16777619) | 0) ^ i6 >>> 16 & 255, 16777619) | 0) ^ i6 >>> 8 & 255, 16777619) | 0) ^ i6 & 255, 16777619) | 0) & i8;
 i9 = HEAP32[i11 + 28 >> 2] | 0;
 i7 = HEAP32[i11 + 20 >> 2] | 0;
 i5 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
 L5 : do if ((i7 | 0) == (i5 | 0)) i1 = -1; else {
  i2 = i11 + 12 | 0;
  if (!(HEAP8[i11 + 8 >> 0] | 0)) {
   i3 = 0;
   i2 = i5;
   while (1) {
    if ((i6 | 0) == (i2 | 0)) break L5;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i8;
    i2 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
    if ((i7 | 0) == (i2 | 0)) {
     i1 = -1;
     break L5;
    }
   }
  }
  if (!i3) {
   i3 = 0;
   i2 = i5;
   while (1) {
    if ((i6 | 0) == (i2 | 0)) break L5;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i8;
    i2 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
    if ((i7 | 0) == (i2 | 0)) {
     i1 = -1;
     break L5;
    }
   }
  }
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = 0;
  i2 = i5;
  while (1) {
   if ((i4 | 0) != (i2 | 0) & (i6 | 0) == (i2 | 0)) break L5;
   i3 = i3 + 1 | 0;
   i1 = i3 + i1 & i8;
   i2 = HEAP32[i9 + (i1 << 3) >> 2] | 0;
   if ((i7 | 0) == (i2 | 0)) {
    i1 = -1;
    break;
   }
  }
 } while (0);
 i12 = i9 + (i12 << 3) | 0;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = (i1 | 0) == -1 ? i12 : i9 + (i1 << 3) | 0;
 HEAP32[i10 + 8 >> 2] = i12;
 return;
}

function __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalPositioniR8Vector3f(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 32 | 0;
 i7 = i11 + 16 | 0;
 i8 = i11;
 if (!(__Z12GetIVRDevicev() | 0)) {
  HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i11;
  return;
 }
 i9 = __Z12GetIVRDevicev() | 0;
 i3 = __ZN8VRDevice33VRNodeToTrackedNodeNameDeprecatedEi(i1) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i10 = 5;
 } else if (i4 >>> 0 < 11) {
  i1 = i8 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i8; else {
   i2 = i8;
   i10 = 7;
  }
 } else i10 = 5;
 if ((i10 | 0) == 5) {
  i12 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i1 = i8 + 11 | 0;
  i10 = 7;
 }
 if ((i10 | 0) == 7) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZNK8VRDevice16GetLocalPositionERK8UnityStr(i7, i9, i8);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i12 = HEAP32[i8 >> 2] | 0;
  i10 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i6);
 }
 STACKTOP = i11;
 return;
}

function _log10f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (i2 | 0) < 0;
 do if (i2 >>> 0 < 8388608 | i3) {
  if (!(i2 & 2147483647)) {
   f1 = Math_fround(Math_fround(-1.0) / Math_fround(f1 * f1));
   break;
  }
  if (i3) {
   f1 = Math_fround(Math_fround(f1 - f1) / Math_fround(0.0));
   break;
  } else {
   f1 = Math_fround(f1 * Math_fround(33554432.0));
   i3 = -152;
   i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = 9;
   break;
  }
 } else if (i2 >>> 0 <= 2139095039) if ((i2 | 0) == 1065353216) f1 = Math_fround(0.0); else {
  i3 = -127;
  i4 = 9;
 } while (0);
 if ((i4 | 0) == 9) {
  i4 = i2 + 4913933 | 0;
  f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 & 8388607) + 1060439283, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
  f7 = Math_fround(f8 / Math_fround(f8 + Math_fround(2.0)));
  f6 = Math_fround(f7 * f7);
  f1 = Math_fround(f6 * f6);
  f1 = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f1 * Math_fround(.284987867)) + Math_fround(.666666627))) + Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.242790788)) + Math_fround(.400009722))));
  f6 = Math_fround(f8 * Math_fround(f8 * Math_fround(.5)));
  f5 = Math_fround(f8 - f6);
  f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -4096, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(Math_fround(Math_fround(f8 - f5) - f6) + Math_fround(f7 * Math_fround(f6 + f1)));
  f6 = Math_fround(i3 + (i4 >>> 23) | 0);
  f1 = Math_fround(Math_fround(f6 * Math_fround(.301029205)) + Math_fround(Math_fround(f5 * Math_fround(.434326172)) + Math_fround(Math_fround(f1 * Math_fround(.434326172)) + Math_fround(Math_fround(f6 * Math_fround(7.90341517e-07)) - Math_fround(Math_fround(f5 + f1) * Math_fround(.0000316899714))))));
 }
 return Math_fround(f1);
}

function __ZN8UserList7AddUserERS_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i9 + 4 | 0;
 i5 = i9 + 16 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i12 = i10 + 4 | 0;
 i13 = i10 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i7 = i11 + 1 | 0;
 i8 = i9 + 20 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i7 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 3, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i3;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + (i11 << 3) >> 2] = i10;
 HEAP32[i2 + (i11 << 3) + 4 >> 2] = i6;
 i2 = HEAP32[i13 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = i10 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 3, 4, i10 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i10 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i12 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = i3;
 i13 = HEAP32[i12 >> 2] | 0;
 HEAP32[i13 + (i2 << 3) >> 2] = i9;
 HEAP32[i13 + (i2 << 3) + 4 >> 2] = i11;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 64 | 0;
 i5 = i6;
 i1 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 i1 = i5 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 i1 = i5 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 898218 | 0, i5, 0);
 __ZN14AnimationEvent8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 32 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN14AnimationStateD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP32[i8 + 96 >> 2] = 0;
 i3 = i8 + 144 | 0;
 i4 = i8 + 148 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3, HEAP32[i4 >> 2] | 0);
 HEAP32[i8 + 152 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 i6 = i8 + 112 | 0;
 i7 = i6 + 11 | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i6 >> 2] >> 0] = 0;
  HEAP32[i8 + 116 >> 2] = 0;
 } else {
  HEAP8[i6 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
 }
 i1 = i8 + 4 | 0;
 if (HEAP16[i8 + 56 >> 1] & 16) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i10 = i8 + 104 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3, HEAP32[i4 >> 2] | 0);
 i1 = i8 + 128 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i8 + 140 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 }
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i10 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i8 + 124 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i1 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 if (i1 | 0) HEAP32[i1 + 8 >> 2] = 0;
 __Z23scripting_gchandle_freej(HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZL45FrustumAndOcculusionCullLocalLightsCombineJobP21LocalLightCullJobData(i15) {
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i16 + 4 | 0;
 i2 = i16;
 if ((HEAP16[gb + 1111088 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1111088 | 0, i1);
  i12 = gb + 1111088 | 0;
 } else i12 = 0;
 i13 = HEAP32[i15 + 24 >> 2] | 0;
 i14 = HEAP32[i15 + 28 >> 2] | 0;
 i11 = HEAP32[i15 + 32 >> 2] | 0;
 i10 = i15 + 300 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = 0;
  i9 = 0;
  i1 = 0;
  do {
   i8 = i15 + 44 + (i9 * 12 | 0) | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i15 + 44 + (i9 * 12 | 0) + 4 >> 2] | 0;
   i6 = i5 + i3 | 0;
   if (i3 >>> 0 < i6 >>> 0) {
    i7 = HEAP32[i13 >> 2] | 0;
    i4 = i2;
    while (1) {
     HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i7 + (i3 << 2) >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i6 | 0)) break; else i4 = i4 + 1 | 0;
    }
    i2 = i2 + i5 | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   i5 = HEAP32[i15 + 236 + (i9 << 2) >> 2] | 0;
   i6 = i5 + i3 | 0;
   if (i3 >>> 0 < i6 >>> 0) {
    i7 = HEAP32[i14 >> 2] | 0;
    i4 = i1;
    while (1) {
     HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i7 + (i3 << 2) >> 2];
     HEAP32[i11 + (i4 << 2) >> 2] = HEAP32[i11 + (i3 << 2) >> 2];
     i3 = i3 + 1 | 0;
     if ((i3 | 0) == (i6 | 0)) break; else i4 = i4 + 1 | 0;
    }
    i1 = i1 + i5 | 0;
   }
   i9 = i9 + 1 | 0;
  } while (i9 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, gb + 64024 | 0);
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i12);
 STACKTOP = i16;
 return;
}

function __ZN5physx13BigConvexData5VLoadERNS_13PxInputStreamE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 6 | 0;
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(86, 65, 76, 69, i10, i2, i8) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = i1 + 8 | 0;
 HEAP32[i9 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i2 >> 0] | 0) != 0, i8) | 0;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i2 >> 0] | 0) != 0, i8) | 0;
 i7 = i1 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 5 | 0, HEAP32[i7 >> 2] | 0);
 i3 = (HEAP32[i9 >> 2] << 2) + 12 & -16;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10 + 4 | 0, i3 + (HEAP32[i5 >> 2] | 0) | 0, gb + 724398 | 0, 80) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = i6;
 i4 = i1 + 20 | 0;
 HEAP32[i4 >> 2] = i6 + i3;
 i1 = (__ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i2 >> 0] | 0) != 0, i8) | 0) & 65535;
 __ZN5physx2Gu11ReadIndicesEtjPtRNS_13PxInputStreamEb(i1, HEAP32[i9 >> 2] | 0, i6, i8, (HEAP8[i2 >> 0] | 0) != 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = 0;
  do {
   i11 = i1 - i3 + -1 | 0;
   HEAP16[i2 + (i11 << 2) >> 1] = HEAP16[i6 + (i11 << 1) >> 1] | 0;
   i3 = i3 + 1 | 0;
  } while (i1 >>> 0 > i3 >>> 0);
 }
 mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP16[i4 + 2 >> 1] = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i2 = 0;
  i3 = 1;
 } else {
  i11 = 1;
  STACKTOP = i10;
  return i11 | 0;
 }
 do {
  i2 = (HEAPU16[i4 + (i3 + -1 << 2) >> 1] | 0) + (i2 & 65535) | 0;
  HEAP16[i4 + (i3 << 2) + 2 >> 1] = i2;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 i1 = 1;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN16Physics2DManager12ColliderCastEPK10Collider2DRK8Vector2ffibP12RaycastHit2Di(i1, i4, i5, f8, i6, i7, i2, i9) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f8 = Math_fround(f8);
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 8 | 0;
 i3 = i14;
 i12 = i14 + 16 | 0;
 if ((HEAP16[gb + 1457728 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457728 | 0, i1);
  i13 = gb + 1457728 | 0;
 } else i13 = 0;
 if (!(HEAP32[i4 + 72 >> 2] | 0)) i1 = 0; else {
  i15 = gb + 64016 | 0;
  i11 = HEAP32[i15 + 4 >> 2] | 0;
  i10 = i3;
  HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  i10 = i12 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i12 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i3);
  i15 = i1;
  i3 = HEAP32[i15 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = __ZN16Physics2DManager15ColliderCastAllEPK10Collider2DRK8Vector2ffibP13dynamic_arrayI12RaycastHit2DLj4EE(0, i4, i5, f8, i6, i7, i12) | 0;
  i1 = (i1 | 0) > (i9 | 0) ? i9 : i1;
  if ((i1 | 0) > 0) {
   i7 = HEAP32[i12 >> 2] | 0;
   i3 = 0;
   do {
    i4 = i2;
    i2 = i2 + 36 | 0;
    i5 = i7 + (i3 * 36 | 0) | 0;
    i6 = i4 + 36 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + 4 | 0;
     i5 = i5 + 4 | 0;
    } while ((i4 | 0) < (i6 | 0));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
  }
  if ((HEAP32[i10 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
   HEAP32[i12 >> 2] = 0;
  }
 }
 if (!i13) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx2Sc7BodySimD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 >> 2] = gb + 90988 + 8;
 i4 = HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i5) | 0) + 1204 >> 2] | 0;
 if (HEAP8[i5 + 51 >> 0] & 1) {
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i4 + 4 >> 2] | 0) + -1 << 2) >> 2] | 0;
  i2 = i3;
  i7 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
  i6 = getTempRet0() | 0;
  i2 = _i64Add(i2 | 0, 0, 51, 0) | 0;
  i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
  i1 = getTempRet0() | 0;
  i6 = _i64Subtract(1, 0, i7 | 0, i6 | 0) | 0;
  i1 = _i64Add(i6 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
  i2 = getTempRet0() | 0;
  while (1) {
   i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
  }
 }
 i2 = i5 + 52 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i5) | 0) + 1232 >> 2] | 0;
 __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i7, i1, (HEAP8[(HEAP32[i2 >> 2] | 0) + 44 >> 0] & 1) != 0);
 i1 = i5 + 144 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 8;
 __ZN5physx2Sc5Scene10removeBodyERNS0_7BodySimE(__ZNK5physx2Sc8ActorSim8getSceneEv(i5) | 0, i5);
 i1 = HEAP32[i5 + 152 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE(i1, i5);
 i1 = i5 + 188 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE(i4, i5);
  i7 = HEAP32[i2 >> 2] | 0;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  __ZN5physx2Sc8RigidSimD2Ev(i5);
  return;
 }
 __ZN5physx16PxsIslandManager10removeNodeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(i4) | 0, i1);
 __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE(i4, i5);
 i7 = HEAP32[i2 >> 2] | 0;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN5physx2Sc8RigidSimD2Ev(i5);
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIPKN5Unity4TypeE7Hash128EEE8TransferI14SafeBinaryReadEEvRS7_RT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i1 = i8;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37008 >> 2] | 0, gb + 589182 | 0, i1, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   HEAP32[i6 >> 2] = -1;
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     i1 = HEAP32[i1 >> 2] | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
    i1 = HEAP32[i6 >> 2] | 0;
   }
   if (HEAP32[i7 >> 2] & 512) {
    i1 = _llvm_bswap_i32(i1 | 0) | 0;
    HEAP32[i6 >> 2] = i1;
   }
   i4 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
   HEAP32[i5 >> 2] = i4;
   i1 = HEAP32[i6 >> 2] | 0;
   if ((i4 | 0) == 0 & (i1 | 0) != -1) HEAP32[i5 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(i1) | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37224 >> 2] | 0, gb + 455698 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN14PreloadManager33PrepareProcessingPreloadOperationEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i10 + 12 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > 1) {
  i2 = 0;
  i4 = 1;
  while (1) {
   i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if ((mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0) | 0) > (i1 | 0)) {
    i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
    i3 = i4;
   } else i3 = i2;
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i4 >>> 0 >= i2 >>> 0) {
    i1 = i3;
    break;
   } else i2 = i3;
  }
 } else i1 = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i6 = i4 + (i1 << 2) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i3 = i6 + 4 | 0;
 _memmove(i6 | 0, i3 | 0, i4 + (i2 << 2) - i3 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 i2 = i10 + 20 | 0;
 i3 = i10 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 36 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i9;
 i10 = i9;
 return i10 | 0;
}

function __ZN12b2WheelJointC2EPK15b2WheelJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152684 + 8;
 i4 = i2 + 20 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 76 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 i5 = i2 + 28 | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1 + 84 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = i2 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1 + 92 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAPF32[i1 + 100 >> 2] = Math_fround(-(HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAP32[i1 + 104 >> 2] = i3;
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP8[i1 + 128 >> 0] = HEAP8[i2 + 44 >> 0] | 0;
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAPF32[i1 + 216 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(0.0);
 i2 = i1 + 172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 707127 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE12iterateClothEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 40 | 0;
 i4 = i6;
 i1 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 140 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i5 + 724 >> 2]);
 f7 = Math_fround(f7 * f7);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 if (!i1) {
  HEAP32[i3 >> 2] = HEAP32[i5 + 572 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 576 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 580 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 584 >> 2];
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_16ConstantIteratorIS2_EEEEvRT_RKS2_(i5, i3, i5 + 588 | 0);
 } else {
  i3 = HEAP32[gb + 1097472 + 12 >> 2] & i2;
  i8 = HEAP32[gb + 1097472 + 8 >> 2] & i2;
  i9 = HEAP32[gb + 1097472 + 4 >> 2] & i2;
  HEAP32[i4 >> 2] = HEAP32[gb + 1097472 >> 2] & i2;
  HEAP32[i4 + 4 >> 2] = i9;
  HEAP32[i4 + 8 >> 2] = i8;
  HEAP32[i4 + 12 >> 2] = i3;
  HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 572 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 576 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 580 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i5 + 584 >> 2];
  HEAP32[i4 + 32 >> 2] = i1;
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_17ScaleBiasIteratorIS2_PKS2_EEEEvRT_RS6_(i5, i4, i5 + 588 | 0);
 }
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainMotionEv(i5);
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainTetherEv(i5);
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fE11solveFabricEv(i5);
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fE19constrainSeparationEv(i5);
 __ZN5physx5cloth11SwCollisionI8Scalar4fEclERKNS0_14IterationStateIS2_EE(i5 + 12 | 0, i5 + 524 | 0);
 __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEclEv(i5 + 460 | 0);
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16updateSleepStateEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN11Rigidbody2D16AddRelativeForceERK8Vector2fNS_9ForceModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i6) return;
 if (HEAP32[i1 + 68 >> 2] | 0) return;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f4 = Math_fround(f7 * f8);
 f5 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f9 * f5));
 f5 = Math_fround(Math_fround(f9 * f8) + Math_fround(f7 * f5));
 i1 = (HEAP32[i6 >> 2] | 0) == 2;
 if (!i3) {
  if (!i1) return;
  i2 = i6 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  i3 = i6 + 76 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i3 >> 2]));
  i6 = i6 + 80 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2]));
  return;
 } else {
  if (!i1) return;
  i2 = i6 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  f7 = Math_fround(HEAPF32[i6 + 120 >> 2]);
  f8 = Math_fround(f4 * f7);
  f7 = Math_fround(f5 * f7);
  i3 = i6 + 64 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i3 >> 2]));
  i3 = i6 + 68 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
  f7 = Math_fround(HEAPF32[i6 + 128 >> 2]);
  f8 = Math_fround(HEAPF32[i6 + 44 >> 2]);
  f8 = Math_fround(f8 - f8);
  f9 = Math_fround(HEAPF32[i6 + 48 >> 2]);
  f9 = Math_fround(f7 * Math_fround(Math_fround(f5 * f8) - Math_fround(f4 * Math_fround(f9 - f9))));
  i6 = i6 + 72 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f9);
  return;
 }
}

function __ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i4, i6, i7, i8) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 i3 = HEAP32[i4 + 40 >> 2] | 0;
 i5 = i1 + (i3 << 3) | 0;
 L1 : do if (i3 | 0) {
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i3 + 24 >> 2] | 0;
  i3 = HEAP32[i3 + 28 >> 2] | 0;
  while (1) {
   if (((HEAP32[i1 >> 2] | 0) - i2 | 0) >>> 0 < i3 >>> 0) break;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i5 | 0)) break L1;
  }
  HEAP32[HEAP32[i8 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
  i8 = 1;
  return i8 | 0;
 } while (0);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
 i5 = HEAP32[i1 + 92 >> 2] | 0;
 L9 : do if ((i5 | 0) > 0) {
  i4 = i1 + 80 | 0;
  if (i6) {
   i1 = 0;
   while (1) {
    i2 = __ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i7, i8) | 0;
    if (i2) {
     i2 = i2 & 1;
     i1 = 1;
     break L9;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i5 | 0)) {
     i2 = 2;
     i1 = 0;
     break L9;
    }
   }
  } else {
   i1 = 0;
   i3 = 0;
  }
  while (1) {
   i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
   if (!(HEAP8[i2 + 54 >> 0] | 0)) i2 = 4; else {
    i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i7, i8) | 0);
    i2 = i1 & 1;
   }
   switch (i2 & 7) {
   case 4:
   case 0:
    break;
   default:
    break L9;
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i5 | 0)) {
    i2 = 2;
    break L9;
   }
  }
 } else {
  i2 = 2;
  i1 = 0;
 } while (0);
 i8 = i1 | (i2 | 0) != 2;
 return i8 | 0;
}

function __ZL21CullDynamicObjectsJobP14CullingJobDataj(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 4 | 0;
 i1 = i11;
 if ((HEAP16[gb + 1112816 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112816 | 0, i10);
  i9 = gb + 1112816 | 0;
 } else i9 = 0;
 i4 = i8 + 12 | 0;
 if (!(HEAP32[i8 + 16 >> 2] | 0)) {
  if (!(HEAP8[HEAP32[i4 >> 2] >> 0] | 0)) i3 = 5;
 } else i3 = 5;
 if ((i3 | 0) == 5) {
  i12 = HEAP32[i8 + 24 + (i2 * 12 | 0) >> 2] | 0;
  i5 = i8 + 24 + (i2 * 12 | 0) + 4 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i10 >> 2] = (HEAP32[HEAP32[i8 + 20 >> 2] >> 2] | 0) + (i12 << 2);
  i6 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 + 8 >> 2] = i2;
  i1 = i8 + 8 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i7 = i3 + 4 | 0;
  __Z34ProcessIndexListIsNodeVisibleStep1RK22SceneCullingParametersPK9SceneNodejjR9IndexList(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, i12, i2 + i12 | 0, i10);
  if (!(HEAP8[HEAP32[i4 >> 2] >> 0] | 0)) __Z23CullObjectsWithoutUmbraRK17CullingParametersPK4AABBR9IndexList(HEAP32[i8 >> 2] | 0, HEAP32[i3 >> 2] | 0, i10); else __Z23CullDynamicObjectsUmbraPK4AABBPKN5Umbra15OcclusionBufferER9IndexList(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i10);
  __Z34ProcessIndexListIsNodeVisibleStep2RK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, i10);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i1 + 852 >> 2] | 0;
  if (i2 | 0) mftCall_viiii(i2 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, i10 | 0, HEAP32[i1 + 856 >> 2] | 0);
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 }
 if (!i9) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i9);
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab27ComputeStateBlockValuesHashERK13dynamic_arrayIiLj4EEPK19ShaderPropertySheetS6_(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i16 + 40 | 0;
 i11 = i16 + 32 | 0;
 i12 = i16 + 24 | 0;
 i13 = i16 + 16 | 0;
 i14 = i16;
 i15 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i15) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 HEAP32[i14 >> 2] = 0;
 i8 = i14 + 4 | 0;
 i3 = gb + 63160 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = i4;
 i10 = i15 << 2;
 do if (!i10) i1 = 0; else {
  i2 = i10 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 4, gb + 64016 | 0, 0, gb + 480983 | 0, 254) | 0;
   i3 = gb + 64016 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i14 >> 2] = i1;
   i4 = i8;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = i3;
   break;
  }
 } while (0);
 i3 = i1 + 3 & -4;
 i4 = i11 + 4 | 0;
 i1 = 0;
 i2 = i3;
 while (1) {
  i17 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i11 >> 2] = -1;
  HEAP32[i4 >> 2] = 4;
  HEAP32[i12 >> 2] = i17;
  HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i13, i7, i9, i5, i11);
  HEAP32[i2 >> 2] = HEAP32[HEAP32[i13 >> 2] >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i15 | 0)) break; else i2 = i2 + 4 | 0;
 }
 i15 = HEAP32[i14 >> 2] | 0;
 i17 = __Z12MurmurHash2APKvij(i3, i10, -1756908916) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i15, i8);
 STACKTOP = i16;
 return i17 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i10 = i11 + 20 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  return i11 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i8 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = i8 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i11 = 0;
  return i11 | 0;
 }
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = HEAP32[i11 + 8 >> 2] | 0;
 while (1) {
  i3 = i2;
  i2 = i4 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i7 + (i5 << 4) >> 2] | 0) == (i6 | 0)) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i9 = 11;
   break;
  }
 }
 if ((i9 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i11 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  i9 = HEAP32[i7 + (i1 << 4) >> 2] | 0;
  HEAP32[i7 + (i5 << 4) >> 2] = i9;
  i12 = i7 + (i1 << 4) + 8 | 0;
  i6 = HEAP32[i12 + 4 >> 2] | 0;
  i7 = i7 + (i5 << 4) + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = i9 + ~(i9 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i8 + (((i1 >>> 16 ^ i1) & (HEAP32[i10 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i12 = i11 + 28 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sq10AABBPruner12NewTreeFixupENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 710575 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f7 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i2 >> 2]));
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f10 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f12 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 f10 = Math_fround(f8 + f10);
 f12 = Math_fround(f9 + f12);
 f11 = Math_fround(f7 + Math_fround(f11 * Math_fround(HEAPF32[i2 + 20 >> 2])));
 f7 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f9 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f8 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 28 >> 2]));
 f8 = Math_fround(f12 + f8);
 f7 = Math_fround(f11 + Math_fround(f7 * Math_fround(HEAPF32[i2 + 32 >> 2])));
 HEAPF32[i1 >> 2] = Math_fround(f10 + f9);
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 i4 = HEAPU8[i3 + 38 >> 0] | 0;
 HEAP32[i1 + 12 >> 2] = i4;
 i2 = HEAPU8[i3 + 39 >> 0] | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 i6 = HEAPU16[i3 + 36 >> 1] | 0;
 HEAP32[i1 + 20 >> 2] = i6;
 i5 = HEAP32[i3 + 40 >> 2] | 0;
 HEAP32[i1 + 24 >> 2] = i5;
 i2 = i2 * 20 | 0;
 HEAP32[i1 + 28 >> 2] = i5 + i2;
 HEAP32[i1 + 32 >> 2] = i5 + ((i4 * 15 | 0) + i2 + (i6 << 1));
 HEAP32[i1 + 36 >> 2] = i5 + ((i4 * 12 | 0) + i2);
 i2 = i1 + 40 | 0;
 i4 = i3 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i3 = HEAP32[i3 + 44 >> 2] | 0;
 HEAP32[i1 + 56 >> 2] = i3;
 HEAP32[i1 + 64 >> 2] = (i3 | 0) == 0 ? fb + 179 | 0 : fb + 180 | 0;
 HEAP32[i1 + 68 >> 2] = fb + 395;
 HEAP32[i1 + 60 >> 2] = fb + 3453;
 return;
}

function __ZN19RuntimeSceneManager15GetLoadedScenesER13dynamic_arrayIP10UnitySceneLj4EE(i3, i11) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = i3 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + 16 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i2 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i11 >> 2] = i10;
  }
  i1 = HEAP32[i12 >> 2] | 0;
 }
 if (!i1) return;
 i8 = i3 + 4 | 0;
 i9 = i11 + 12 | 0;
 i10 = i11 + 4 | 0;
 i7 = 0;
 do {
  i6 = (HEAP32[i8 >> 2] | 0) + (i7 << 2) | 0;
  if (HEAP32[(HEAP32[i6 >> 2] | 0) + 80 >> 2] | 0) {
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i13 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i13 >> 2] = i1;
     HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i11 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i9 >> 2] = i3;
   HEAP32[(HEAP32[i11 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i6 >> 2];
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < i1 >>> 0);
 return;
}

function __ZN18AssetBundleManager14AddPreloadDataEiR13dynamic_arrayINS_11PreloadDataELj8EEb(i1, i3, i10, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = __Z20GetPersistentManagerv() | 0;
 i2 = (__ZN17PersistentManager17GetSerializedTypeEi(i1, i3) | 0) == (gb + 27480 | 0);
 if (!(i2 | i4 ^ 1)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = i8 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = i2 << 31 >> 31;
 __ZN17PersistentManager38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier(i1, i3, i8 + 8 | 0) | 0;
 i2 = i10 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 5, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 5 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i10 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i10 = (HEAP32[i10 >> 2] | 0) + (i3 << 5) | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 STACKTOP = i9;
 return;
}

function __Z35AssetBundle_CUSTOM_GetAllScenePathsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i2, i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i8 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i6 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i8 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i5 | 0;
}

function __Z35AssetBundle_CUSTOM_GetAllAssetNamesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __Z31GetAllAssetNamesFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE(i2, i7);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, (HEAP32[i8 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i5 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i6 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i8 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i6);
    i2 = HEAP32[i8 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i5 | 0;
}

function __Z24ConvertBufferToJPGBufferPKhjjjiPvPFvS1_PhjE(i6, i2, i9, i10, i4, i12, i13) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i5 = i15 + 376 | 0;
 i3 = i15 + 368 | 0;
 i7 = i15 + 360 | 0;
 HEAP32[i14 >> 2] = _jpeg_std_error(i15 + 380 | 0) | 0;
 _jpeg_CreateCompress(i14, 62, 360);
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(65535, 16, gb + 63192 | 0, 0, gb + 404842 | 0, 149) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = i12;
 HEAP32[i3 >> 2] = i13;
 i8 = i14 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i14 + 4 >> 2] >> 2] | 0, i14 | 0, 0, 48) | 0;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i1 + 24 >> 2] = 65535;
 HEAP32[i1 + 20 >> 2] = i11;
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = fb + 509;
 HEAP32[i1 + 8 >> 2] = fb + 3377;
 HEAP32[i1 + 12 >> 2] = fb + 1575;
 HEAP32[i1 + 16 >> 2] = fb + 3378;
 HEAP32[i14 + 28 >> 2] = i2;
 HEAP32[i14 + 32 >> 2] = i9;
 HEAP32[i14 + 36 >> 2] = 3;
 HEAP32[i14 + 40 >> 2] = 2;
 _jpeg_set_defaults(i14);
 _jpeg_set_quality(i14, i4, 0);
 _jpeg_start_compress(i14, 1);
 if (i9 | 0) {
  i2 = i9 + -1 | 0;
  i1 = 0;
  do {
   HEAP32[i7 >> 2] = i6 + (Math_imul(i2 - i1 | 0, i10) | 0);
   _jpeg_write_scanlines(i14, i7, 1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 _jpeg_finish_compress(i14);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  _jpeg_destroy_compress(i14);
  __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 63192 | 0);
  STACKTOP = i15;
  return 1;
 }
 mftCall_viii(i13 | 0, i12 | 0, HEAP32[i1 + 20 >> 2] | 0, i2 | 0);
 _jpeg_destroy_compress(i14);
 __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 63192 | 0);
 STACKTOP = i15;
 return 1;
}

function __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = __ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i4, i2, i1) | 0;
 i6 = __ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i4, i3, i2) | 0;
 if (!i7) {
  if (!i6) {
   i7 = 0;
   return i7 | 0;
  }
  i6 = i2;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i3;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i2;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  i7 = i3;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i7 + 4 >> 2] = i6;
  if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i4, i2, i1) | 0)) {
   i9 = 1;
   return i9 | 0;
  }
  i8 = i1;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i5 = i2;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i6;
  i9 = i2;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = 2;
  return i9 | 0;
 }
 i7 = i1;
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 if (i6) {
  i6 = i3;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = i3;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i9 + 4 >> 2] = i7;
  i9 = 1;
  return i9 | 0;
 }
 i6 = i2;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i2;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i7;
 if (!(__ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_(i4, i3, i2) | 0)) {
  i9 = 1;
  return i9 | 0;
 }
 i8 = i2;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i3;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 i9 = i3;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = 2;
 return i9 | 0;
}

function __ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(i2, i4, i6, i9, i12, i10, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i13 + 7 | 0;
 i3 = i13 + 6 | 0;
 i5 = i13 + 5 | 0;
 i7 = i13 + 4 | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i3 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i7 | 0, 1) | 0;
 if (!((HEAP8[i1 >> 0] | 0) == 73 & (HEAP8[i3 >> 0] | 0) == 67 & (HEAP8[i5 >> 0] | 0) == 69)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP8[i10 >> 0] = HEAP8[i7 >> 0] & 1 ^ 1;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i3 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i7 | 0, 1) | 0;
 if ((HEAP8[i1 >> 0] | 0) != (i2 & 255 | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((HEAP8[i3 >> 0] | 0) != (i4 & 255 | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((HEAP8[i5 >> 0] | 0) != (i6 & 255 | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 if ((HEAP8[i7 >> 0] | 0) != (i9 & 255 | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i10 = (HEAP8[i10 >> 0] | 0) == 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i8 | 0, 4) | 0;
 if (!i10) {
  i11 = HEAP32[i8 >> 2] | 0;
  HEAP8[i8 >> 0] = i11 >>> 24;
  HEAP8[i8 + 3 >> 0] = i11;
  HEAP8[i8 + 1 >> 0] = i11 >>> 16;
  HEAP8[i8 + 2 >> 0] = (i11 & 65535) >>> 8;
 }
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __Z26ApplyBlendShapesToVerticesR12SkinMeshInfoRKN4math5_int4EPNS1_8floatNx3ES6_(i6, i7, i12, i15) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0;
 i16 = HEAP32[i6 + 80 >> 2] | 0;
 i17 = i6 + 76 | 0;
 if ((HEAP32[i17 >> 2] | 0) <= 0) return;
 i18 = i6 + 72 | 0;
 i8 = i16 + 40 | 0;
 i9 = i16 + 20 | 0;
 i10 = i16 + 52 | 0;
 i5 = 0;
 do {
  f11 = Math_fround(HEAPF32[(HEAP32[i18 >> 2] | 0) + (i5 << 2) >> 2]);
  do if (f11 > Math_fround(.0000999999974)) {
   i1 = HEAP32[i8 >> 2] | 0;
   i14 = HEAP32[i1 + (i5 << 4) + 8 >> 2] | 0;
   i13 = (HEAP32[i9 >> 2] | 0) + (i14 * 12 | 0) | 0;
   i14 = (HEAP32[i10 >> 2] | 0) + (i14 << 2) | 0;
   f2 = Math_fround(HEAPF32[i14 >> 2]);
   if (!(f11 < f2)) {
    i1 = HEAP32[i1 + (i5 << 4) + 12 >> 2] | 0;
    if ((i1 | 0) != 1) {
     i3 = i1 + -1 | 0;
     i1 = 0;
     while (1) {
      i4 = i1 + 1 | 0;
      f2 = Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]);
      if (i1 >>> 0 < i3 >>> 0 & f2 < f11) i1 = i4; else break;
     }
     f19 = Math_fround(HEAPF32[i14 + (i1 << 2) >> 2]);
     f11 = Math_fround(Math_fround(f11 - f19) / Math_fround(f2 - f19));
     __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_(i13 + (i1 * 12 | 0) | 0, i16, Math_fround(Math_fround(1.0) - f11), i6, i7, i12, i15);
     __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_(i13 + (i4 * 12 | 0) | 0, i16, f11, i6, i7, i12, i15);
     break;
    }
   }
   __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_(i13, i16, Math_fround(f11 / f2), i6, i7, i12, i15);
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i17 >> 2] | 0));
 return;
}

function __ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, f8 = f0, f9 = f0;
 switch (HEAP32[i5 >> 2] | 0) {
 case 7:
 case 6:
 case 4:
 case 3:
 case 2:
 case 1:
  break;
 default:
  {
   i7 = 0;
   return i7 | 0;
  }
 }
 i7 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i1, HEAP32[i5 + 4 >> 2] | 0) | 0;
 if ((i7 | 0) <= -1) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = i1 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i3 = HEAP32[i2 + (i7 * 12 | 0) + 4 >> 2] | 0;
 switch (i3 | 0) {
 case 9:
 case 4:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 + -1 | 0) >>> 0 < 2) {
    i6 = i6 + 44 | 0;
    i7 = (i1 | 0) != 1 ^ (HEAP8[(HEAP32[i6 >> 2] | 0) + i6 + (HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0) != 0;
    return i7 | 0;
   } else i4 = 6;
   break;
  }
 case 3:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if ((i1 & -2 | 0) == 6) {
    i6 = i6 + 36 | 0;
    f9 = Math_fround(HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0);
    f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
    i7 = (i1 | 0) == 6 ? f9 == f8 : f9 != f8;
    return i7 | 0;
   }
   break;
  }
 default:
  i4 = 6;
 }
 if ((i4 | 0) == 6) i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 + -3 | 0) >>> 0 >= 2) {
  i7 = 0;
  return i7 | 0;
 }
 switch (i3 | 0) {
 case 1:
  {
   i6 = i6 + 28 | 0;
   f8 = Math_fround(HEAPF32[(HEAP32[i6 >> 2] | 0) + i6 + (HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] << 2) >> 2]);
   f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   i7 = (i1 | 0) == 3 ? f8 > f9 : f8 < f9;
   return i7 | 0;
  }
 case 3:
  {
   i6 = i6 + 36 | 0;
   f8 = Math_fround(HEAP32[(HEAP32[i6 >> 2] | 0) + i6 + (HEAP32[i2 + (i7 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0);
   f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   i7 = (i1 | 0) == 3 ? f8 > f9 : f8 < f9;
   return i7 | 0;
  }
 default:
  {
   i7 = 0;
   return i7 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Sc5Scene24fireOutOfBoundsCallbacksEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i14 = HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 i13 = i14 + 51600 | 0;
 i14 = i14 + 51604 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i2 + 1196 >> 2] | 0;
 if (!i10) {
  i11 = 0;
  HEAP32[i12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i13, 0, i12);
  i14 = HEAP32[i14 >> 2] | 0;
  __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i13, i14);
  STACKTOP = i15;
  return i11 | 0;
 }
 i8 = i2 + 1264 | 0;
 i9 = i1 + 20 | 0;
 i7 = i1 + 16 | 0;
 i5 = i2 + 1152 | 0;
 i6 = 0;
 i1 = 0;
 do {
  i4 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  i3 = i2 >>> 5;
  if (i3 >>> 0 < (HEAP32[i9 >> 2] & 2147483647) >>> 0) {
   if (!(HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i2 & 31))) i11 = 5;
  } else i11 = 5;
  if ((i11 | 0) == 5) {
   i11 = 0;
   i2 = __ZN5physx2Sc8RigidSim10getPxActorEv(HEAP32[i4 + 8 >> 2] | 0) | 0;
   i3 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 255;
   i3 = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 20 >> 2] | 0;
   if (!i3) i1 = 1; else {
    i4 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i4 + 28 >> 2] | 0) | 0;
    mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i4 | 0, i2 | 0);
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i10 | 0));
 HEAP32[i12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i13, 0, i12);
 i14 = HEAP32[i14 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i13, i14);
 STACKTOP = i15;
 return i1 | 0;
}

function __ZN28EnlightenRendererInformation8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 425237 | 0, HEAP32[gb + 37176 >> 2] | 0, i1, 0);
 i7 = i6 + 8 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402843 | 0, HEAP32[gb + 37328 >> 2] | 0, i7, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402869 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 402878 | 0, gb + 455698 | 0, i1, 0);
 __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 * 20 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 20 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 * 20 | 0) | 0, 0, (i4 - i5 | 0) * 20 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 * 20 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 410618 | 0, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}
function __ZN13WheelCollider21SetSuspensionDistanceEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i3 = i7 + 88 | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) != f1) HEAPF32[i3 >> 2] = f1;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 136 >> 2] | 0, i7 | 0) | 0;
 i9 = i7 + 148 | 0;
 if ((HEAP32[i9 >> 2] | 0) == -1) {
  STACKTOP = i11;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 136 >> 2] | 0, i7 | 0) | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i2 + 52 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 if (!(HEAP32[i2 + 56 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 i5 = f1 < Math_fround(0.0);
 f8 = Math_fround(-f1);
 f1 = i5 ? f8 : f1;
 i5 = f1 < Math_fround(9.99999974e-06);
 f1 = i5 ? Math_fround(9.99999974e-06) : f1;
 f8 = Math_fround(HEAPF32[i7 + 84 >> 2]);
 i5 = i4 + 56 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + 8 | 0;
 __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv(i7);
 i2 = i10;
 i3 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i6, HEAP32[i9 >> 2] | 0) | 0;
 i4 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAPF32[i10 + 8 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f8) * f1);
 HEAPF32[i10 + 12 >> 2] = Math_fround(f8 * f1);
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i6, HEAP32[i9 >> 2] | 0, i10);
 i10 = HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 284 >> 2] | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZNK5physx2Gu11HeightField10getNormal_Efffff(i10, i11, f1, f2, f8, f12, f9) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f8 = Math_fround(f8);
 f12 = Math_fround(f12);
 f9 = Math_fround(f9);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 4 | 0;
 i7 = i13;
 i4 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i11, f1, f2, i6, i7) | 0;
 f1 = Math_fround(HEAPF32[i6 >> 2]);
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 i7 = HEAP32[i11 + 36 >> 2] | 0;
 do if ((HEAP8[i7 + (i4 << 2) + 2 >> 0] | 0) < 0) {
  i5 = HEAP16[i7 + (i4 << 2) >> 1] | 0;
  i3 = (HEAP32[i11 + 20 >> 2] | 0) + i4 | 0;
  i6 = HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0;
  if (!(f2 >= f1)) {
   i3 = HEAP16[i7 + (i3 << 2) >> 1] | 0;
   i4 = i3 - i6 | 0;
   i3 = i5 - i3 | 0;
   break;
  } else {
   i3 = HEAP16[i7 + (i4 + 1 << 2) >> 1] | 0;
   i4 = i5 - i3 | 0;
   i3 = i3 - i6 | 0;
   break;
  }
 } else {
  i5 = HEAP16[i7 + (i4 + 1 << 2) >> 1] | 0;
  i3 = (HEAP32[i11 + 20 >> 2] | 0) + i4 | 0;
  i6 = HEAP16[i7 + (i3 << 2) >> 1] | 0;
  if (!(Math_fround(f1 + f2) <= Math_fround(1.0))) {
   i3 = HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0;
   i4 = i6 - i3 | 0;
   i3 = i5 - i3 | 0;
   break;
  } else {
   i3 = HEAP16[i7 + (i4 << 2) >> 1] | 0;
   i4 = i3 - i5 | 0;
   i3 = i3 - i6 | 0;
   break;
  }
 } while (0);
 f2 = Math_fround(Math_fround(i3 | 0) * f8);
 f1 = Math_fround(Math_fround(i4 | 0) * f9);
 if (Math_fround(HEAPF32[i11 + 40 >> 2]) <= Math_fround(0.0)) {
  f9 = f1;
  f8 = f2;
  HEAPF32[i10 >> 2] = f8;
  i11 = i10 + 4 | 0;
  HEAPF32[i11 >> 2] = f12;
  i11 = i10 + 8 | 0;
  HEAPF32[i11 >> 2] = f9;
  STACKTOP = i13;
  return;
 }
 f9 = Math_fround(-f1);
 f8 = Math_fround(-f2);
 f12 = Math_fround(-f12);
 HEAPF32[i10 >> 2] = f8;
 i11 = i10 + 4 | 0;
 HEAPF32[i11 >> 2] = f12;
 i11 = i10 + 8 | 0;
 HEAPF32[i11 >> 2] = f9;
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0, i17 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i13 + 16 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i5 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i8 + (i5 << 4) | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 36 | 0;
 i3 = i13 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 0;
  do {
   i17 = HEAP32[i2 + (i11 << 4) >> 2] | 0;
   i16 = i17 + ~(i17 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i6 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP32[i8 + (i11 << 4) >> 2] = i17;
   i17 = i2 + (i11 << 4) + 8 | 0;
   i16 = HEAP32[i17 + 4 >> 2] | 0;
   i15 = i8 + (i11 << 4) + 8 | 0;
   HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
   HEAP32[i15 + 4 >> 2] = i16;
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i4 >> 2] = i5;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 720203 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i1 = i7 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 738802 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = i4;
  HEAP32[i9 >> 2] = i7;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 24 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, i2, gb + 469135 | 0, 0, i5);
 i3 = i4 + 16 | 0;
 i2 = i4 + 24 | 0;
 HEAP8[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 3 >> 0] = 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 945671 | 0, HEAP32[gb + 37040 >> 2] | 0, i9, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i9 + 32 | 0, i5);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 HEAP8[i4 + 53 >> 0] = 1;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 i1 = i4 + 48 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 3 & -4;
 i1 = i4 + 20 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZNK16TypeTreeIterator8ChildrenEv(i6, i1);
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i8, i1);
 __ZNK16TypeTreeIterator4LastEv(i7, i8);
 i8 = (HEAP32[i6 >> 2] | 0) + ((HEAP32[i7 + 4 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 16384;
 i8 = (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 32768;
 STACKTOP = i9;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 HEAPF32[i10 + 4 >> 2] = Math_fround(inf);
 HEAP32[i10 >> 2] = 0;
 HEAPF32[i10 + 80 >> 2] = Math_fround(inf);
 HEAP32[i10 + 76 >> 2] = 0;
 i13 = i10 + 152 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i11 = i10 + 164 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i7 = i1;
 i5 = i1;
 i2 = (i9 * 52 | 0) / 52 | 0;
 L1 : while (1) {
  while (1) {
   if (!i2) break L1;
   i3 = (i2 | 0) / 2 | 0;
   i4 = i5 + (i3 * 52 | 0) | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) < f6) break; else i2 = i3;
  }
  i5 = i4 + 52 | 0;
  i2 = i2 + -1 - i3 | 0;
 }
 if ((i5 | 0) != (i1 + (i9 * 52 | 0) | 0)) if (!(f6 < Math_fround(HEAPF32[i5 >> 2]))) {
  i13 = -1;
  return i13 | 0;
 }
 i7 = (i5 - i7 | 0) / 52 | 0;
 i8 = i9 - i7 | 0;
 i2 = i9 + 1 | 0;
 HEAP32[i11 >> 2] = i2;
 i3 = i10 + 168 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i2 >>> 0) {
  i9 = i4 << 1;
  i2 = i9 >>> 0 > i2 >>> 0 ? i9 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 52 | 0, 4, i10 + 156 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i13 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 52 | 0, 4, i10 + 156 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i13 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 52 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i13 >> 2] = i1;
   break;
  }
 } while (0);
 i4 = i1 + (i7 * 52 | 0) | 0;
 _memmove(i4 + 52 | 0, i4 | 0, i8 * 52 | 0) | 0;
 i3 = i4;
 i1 = i12;
 i2 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i13 = (i4 - (HEAP32[i13 >> 2] | 0) | 0) / 52 | 0;
 return i13 | 0;
}

function __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i1 = i10;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i9, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 i6 = i1 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i1 = i8 + 4 | 0;
 i6 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i9 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i3 = i8 + 8 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  i1 = i5;
 }
 __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i8 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14ParticleSystem24StartParticlesProceduralERS_R23ParticleSystemParticlesfffjjf(i7, i1, f2, f15, f11, i16, i8, f3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f15 = Math_fround(f15);
 f11 = Math_fround(f11);
 i16 = i16 | 0;
 i8 = i8 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = HEAP32[i7 + 40 >> 2] | 0;
 i12 = i14 + 468 | 0;
 i13 = i14 + 480 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 if (!i6) {
  i1 = 0;
  i6 = 0;
 } else {
  i5 = HEAP32[i12 >> 2] | 0;
  i4 = 0;
  i1 = 0;
  do {
   i1 = (HEAP32[i5 + (i4 * 24 | 0) + 16 >> 2] | 0) + i1 | 0;
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i6 >>> 0);
 }
 i10 = HEAP32[i14 + 492 >> 2] | 0;
 i9 = i1 + i8 | 0;
 i8 = HEAP32[(HEAP32[i7 + 44 >> 2] | 0) + 2548 >> 2] | 0;
 i9 = (i8 >>> 0 < i9 >>> 0 ? i8 : i9) - i1 | 0;
 if (!i9) return;
 f2 = Math_fround(Math_fround(HEAPF32[i14 + 488 >> 2]) * f11);
 i4 = i6 + 1 | 0;
 i5 = i14 + 484 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i4 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 * 24 | 0, 4, i14 + 472 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i14 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i14 + 472 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i14 | 0, HEAP32[i12 >> 2] | 0, (HEAP32[i13 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = i14;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = i4;
 i14 = HEAP32[i12 >> 2] | 0;
 HEAPF32[i14 + (i6 * 24 | 0) >> 2] = f15;
 HEAPF32[i14 + (i6 * 24 | 0) + 4 >> 2] = Math_fround(0.0);
 HEAP32[i14 + (i6 * 24 | 0) + 8 >> 2] = i10;
 HEAPF32[i14 + (i6 * 24 | 0) + 12 >> 2] = f2;
 HEAP32[i14 + (i6 * 24 | 0) + 16 >> 2] = i9;
 HEAP32[i14 + (i6 * 24 | 0) + 20 >> 2] = i16;
 return;
}

function __ZN13EmscriptenWWW10OnResponseEPviS0_jPc(i6, i1, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (i2 | 0) {
  HEAP32[i6 + 92 >> 2] = i2;
  HEAP32[i6 + 88 >> 2] = i3;
  __ZN3WWW18FeedUnityWebStreamEb(i6, 1);
 }
 if (!i4) {
  if ((i1 | 0) > 399) {
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   i2 = i6 + 80 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i5, _JS_WebRequest_GetStatusLine(HEAP32[i2 >> 2] | 0, 0, 0) | 0, 0);
   i4 = HEAP8[i5 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   _JS_WebRequest_GetStatusLine(HEAP32[i2 >> 2] | 0, (i3 ? HEAP32[i5 >> 2] | 0 : i5) | 0, (i3 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, i5 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
 } else {
  i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i4, _strlen(i4) | 0);
  mftCall_vii(i3 | 0, i6 | 0, i5 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 HEAP8[i6 + 96 >> 0] = 1;
 i1 = i6 + 64 | 0;
 i2 = i6 + 80 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i1, _JS_WebRequest_GetResponseHeaders(HEAP32[i2 >> 2] | 0, 0, 0) | 0, 0);
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP8[i6 + 75 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i6 + 68 >> 2] | 0;
  _JS_WebRequest_GetResponseHeaders(i2 | 0, i5 | 0, i6 | 0) | 0;
  STACKTOP = i7;
  return;
 } else {
  i5 = i1;
  i6 = i3 & 255;
  _JS_WebRequest_GetResponseHeaders(i2 | 0, i5 | 0, i6 | 0) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = (i1 - i2 >> 5) + 1 | 0;
 if (i4 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = (HEAP32[i11 >> 2] | 0) - i2 | 0;
 i5 = i9 >> 4;
 i4 = i9 >> 5 >>> 0 < 67108863 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 134217727;
 i5 = i1 - i2 >> 5;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 5) | 0;
 i7 = i6 + (i5 << 5) | 0;
 i2 = i7;
 i9 = i6 + (i4 << 5) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 << 5) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 << 5) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + (i5 << 5) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i6 + (i5 << 5) + 16 | 0;
 i8 = i8 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i7 + 32 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i7 = i3;
   i3 = i3 + -32 | 0;
   HEAP32[i1 + -32 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i7 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i7 + -24 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i7 + -20 >> 2];
   i8 = i1 + -16 | 0;
   i7 = i7 + -16 | 0;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i1 = i2 + -32 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__23mapIN19CloudServiceHandler11ServiceTypeEPS1_NS_4lessIS2_EE13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier85ELi16EEEixERS8_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i3 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i2 = 10;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  }
 } while (0);
 if ((i2 | 0) == 12) if (i1) {
  i8 = i1;
  i8 = i8 + 20 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 85;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN26AnimatorOverrideController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 16 | 0;
 __ZN25RuntimeAnimatorController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i7 = i1 + 80 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905632 | 0, gb + 905645 | 0, i7, 0);
 i8 = i5 + 8 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 1);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i8, 1);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 905677 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905685 | 0, i4, 0);
 __ZN21AnimationClipOverride8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14SerializedFileD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i7 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN18ResourceImageGroup7CleanupEv(i7 + 132 | 0);
 __ZN20dynamic_block_vectorI14FileIdentifierE5clearEv(i7 + 92 | 0);
 i1 = i7 + 108 | 0;
 if ((HEAP32[i7 + 124 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 112 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 72 | 0;
 if ((HEAP32[i7 + 88 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 76 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i7 + 32 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i7 + 36 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
  __ZdlPv(i1);
 }
 if ((HEAP32[i7 + 16 >> 2] | 0) <= -1) return;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i7 + 12 >> 2] | 0;
 if (i3) {
  i2 = 0;
  do {
   i4 = i1 + (i2 * 56 | 0) + 44 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    i6 = i5 + 40 | 0;
    if ((HEAP32[i5 + 56 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + 44 | 0);
     HEAP32[i6 >> 2] = 0;
    }
    if ((HEAP32[i5 + 36 >> 2] | 0) > -1) {
     i6 = i5 + 20 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + 24 | 0);
     HEAP32[i6 >> 2] = 0;
    }
    if ((HEAP32[i5 + 16 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
     HEAP32[i5 >> 2] = 0;
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63720 | 0);
   HEAP32[i4 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 4 | 0);
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di(i1, i4, i5, f8, i6, i7, i2, i9) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f8 = Math_fround(f8);
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 8 | 0;
 i3 = i14;
 i12 = i14 + 16 | 0;
 if ((HEAP16[gb + 1457824 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457824 | 0, i1);
  i13 = gb + 1457824 | 0;
 } else i13 = 0;
 if (!i9) i1 = 0; else {
  i15 = gb + 64016 | 0;
  i11 = HEAP32[i15 + 4 >> 2] | 0;
  i10 = i3;
  HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  i10 = i12 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  i11 = i12 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i3);
  i15 = i1;
  i3 = HEAP32[i15 + 4 >> 2] | 0;
  i1 = i11;
  HEAP32[i1 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = __ZN16Physics2DManager21GetRayIntersectionAllERK8Vector3fS2_fiPK10Collider2DP13dynamic_arrayI12RaycastHit2DLj4EE(0, i4, i5, f8, i6, i7, i12) | 0;
  i1 = (i1 | 0) > (i9 | 0) ? i9 : i1;
  if ((i1 | 0) > 0) {
   i7 = HEAP32[i12 >> 2] | 0;
   i3 = 0;
   do {
    i4 = i2;
    i2 = i2 + 36 | 0;
    i5 = i7 + (i3 * 36 | 0) | 0;
    i6 = i4 + 36 | 0;
    do {
     HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
     i4 = i4 + 4 | 0;
     i5 = i5 + 4 | 0;
    } while ((i4 | 0) < (i6 | 0));
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i1 | 0));
  }
  if ((HEAP32[i10 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i12 >> 2] | 0, i11);
   HEAP32[i12 >> 2] = 0;
  }
 }
 if (!i13) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return i1 | 0;
}

function _tre_fill_pmatch(i13, i14, i1, i2, i8, i10) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 if ((i1 & 8 | 0) == 0 & (i10 | 0) > -1) {
  i11 = HEAP32[i2 + 16 >> 2] | 0;
  i7 = i2 + 28 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i9 = (i13 | 0) != 0;
  if (i9 & (i1 | 0) != 0) {
   i6 = i2 + 48 | 0;
   i5 = 0;
   do {
    i1 = HEAP32[i11 + (i5 * 12 | 0) >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) i4 = i10; else i4 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
    i3 = i14 + (i5 << 3) | 0;
    HEAP32[i3 >> 2] = i4;
    i1 = HEAP32[i11 + (i5 * 12 | 0) + 4 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) i2 = i10; else i2 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
    i1 = i14 + (i5 << 3) + 4 | 0;
    HEAP32[i1 >> 2] = i2;
    if ((i4 | 0) == -1 | (i2 | 0) == -1) {
     HEAP32[i1 >> 2] = -1;
     HEAP32[i3 >> 2] = -1;
    }
    i5 = i5 + 1 | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   } while (i5 >>> 0 < i13 >>> 0 & i5 >>> 0 < i1 >>> 0);
   i8 = i1;
  } else i8 = i1;
  if (i9 & (i8 | 0) != 0) {
   i1 = 0;
   do {
    i5 = i14 + (i1 << 3) + 4 | 0;
    i6 = HEAP32[i11 + (i1 * 12 | 0) + 8 >> 2] | 0;
    if (i6 | 0) {
     i2 = HEAP32[i6 >> 2] | 0;
     if ((i2 | 0) > -1) {
      i7 = i14 + (i1 << 3) | 0;
      i4 = 0;
      i3 = HEAP32[i7 >> 2] | 0;
      do {
       if ((i3 | 0) < (HEAP32[i14 + (i2 << 3) >> 2] | 0)) i12 = 19; else if ((HEAP32[i5 >> 2] | 0) > (HEAP32[i14 + (i2 << 3) + 4 >> 2] | 0)) i12 = 19;
       if ((i12 | 0) == 19) {
        i12 = 0;
        HEAP32[i5 >> 2] = -1;
        HEAP32[i7 >> 2] = -1;
        i3 = -1;
       }
       i4 = i4 + 1 | 0;
       i2 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
      } while ((i2 | 0) > -1);
     }
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i13 >>> 0 & i1 >>> 0 < i8 >>> 0);
  } else i1 = 0;
 } else i1 = 0;
 if (i1 >>> 0 < i13 >>> 0) _memset(i14 + (i1 << 3) | 0, -1, i13 - i1 << 3 | 0) | 0;
 return;
}

function __ZNSt3__23mapIPKc21ScriptingMethodIl2Cpp14CStringCompare13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier1ELi16EEEixERS7_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i3 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((_strcmp(i4, i2) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((_strcmp(i2, i4) | 0) >= 0) {
     i2 = 10;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  }
 } while (0);
 if ((i2 | 0) == 12) if (i1) {
  i8 = i1;
  i8 = i8 + 20 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i6, i12, i3, i4, i1) {
 i6 = i6 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i6 + 36 | 0;
 HEAP8[i11 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i9 = i6 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (i3 | 0) {
  if (!i10) return;
  if ((HEAP32[i10 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i10, i3) | 0;
 HEAP32[i9 >> 2] = i3;
 i7 = i6 + 20 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 37300 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i4);
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  if (!(i4 & 256)) i5 = 9; else {
   i3 = i6 + 56 | 0;
   if (!(HEAP32[(HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) + -1 << 3) + 4 >> 2] & 256)) i5 = 9; else i1 = (i4 | 0) == 258 & 1;
  }
  if ((i5 | 0) == 9) {
   do if (!(i4 & 2048)) {
    if (!(i4 & 512)) {
     if (!(i4 & 1048576)) {
      i1 = 0;
      break;
     }
     if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
     i1 = __Z11StringToIntPKc(i1) | 0;
     break;
    }
    do if (!(i4 & 16384)) {
     if (i4 & 1024 | 0) {
      d2 = +(HEAP32[i1 >> 2] | 0);
      break;
     }
     i3 = i1;
     i1 = HEAP32[i3 >> 2] | 0;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if (!(i4 & 4096)) {
      d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
      break;
     } else {
      d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
      break;
     }
    } else d2 = +HEAPF64[i1 >> 3]; while (0);
    i1 = ~~d2 >>> 0;
   } else i1 = HEAP32[i1 >> 2] | 0; while (0);
   i3 = i6 + 56 | 0;
   i1 = i1 & 255;
  }
  HEAP8[i12 >> 0] = i1;
  HEAP8[i11 >> 0] = 1;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 }
 HEAP32[i9 >> 2] = i10;
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZL22Transfer_ManagedObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 20 | 0;
 i7 = i10;
 i8 = HEAP32[i5 + 20 >> 2] | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = -1;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = (HEAP32[i4 + 32 >> 2] | 0) == 17;
 i2 = i3;
 do if (!i3) {
  i2 = i4 + 12 | 0;
  if (i1) i1 = 0; else i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP8[i7 >> 0] = 1;
  HEAP32[i7 + 4 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = -1;
 } else {
  if (!i1) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i7, HEAP32[i4 >> 2] | 0, i5, 1);
   break;
  }
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i3 = HEAP32[i4 + 12 >> 2] | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = i2;
  } else {
   HEAP8[i7 >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = i2;
  }
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = i1;
 } while (0);
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i9 = HEAP32[i4 + 44 >> 2] | 0;
 i2 = (HEAP32[i5 + 16 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + (i9 << 6) | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i5;
 i9 = i9 << 6 >> 6;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i9;
 HEAP32[i6 >> 2] = i7;
 __ZN8JSONRead8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlagsb(i8, i6, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0, 0);
 STACKTOP = i10;
 return;
}

function __ZNSt3__211__call_onceERVmPvPFvS2_E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 _pthread_mutex_lock(gb + 1476912 | 0) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) != 1) break;
  _pthread_cond_wait(gb + 1476940 | 0, gb + 1476912 | 0) | 0;
 }
 do if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 1;
  __THREW__ = 0;
  invoke_ii(fb + 2796 | 0, gb + 1476912 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   __THREW__ = 0;
   invoke_vi(i3 | 0, i2 | 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (!(i4 & 1)) {
    __THREW__ = 0;
    invoke_ii(fb + 2811 | 0, gb + 1476912 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (!(i4 & 1)) {
     HEAP32[i1 >> 2] = -1;
     __THREW__ = 0;
     invoke_ii(fb + 2796 | 0, gb + 1476912 | 0) | 0;
     i4 = __THREW__;
     __THREW__ = 0;
     if (!(i4 & 1)) {
      __THREW__ = 0;
      invoke_ii(fb + 2799 | 0, gb + 1476940 | 0) | 0;
      i4 = __THREW__;
      __THREW__ = 0;
      if (!(i4 & 1)) break;
     }
    }
   }
  }
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___cxa_begin_catch(i4 | 0) | 0;
  __THREW__ = 0;
  invoke_ii(fb + 2811 | 0, gb + 1476912 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   HEAP32[i1 >> 2] = 0;
   __THREW__ = 0;
   invoke_ii(fb + 2796 | 0, gb + 1476912 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (!(i4 & 1)) {
    __THREW__ = 0;
    invoke_ii(fb + 2799 | 0, gb + 1476940 | 0) | 0;
    i4 = __THREW__;
    __THREW__ = 0;
    if (!(i4 & 1)) {
     __THREW__ = 0;
     invoke_v(fb + 460 | 0);
     __THREW__ = 0;
    }
   }
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  } else ___resumeException(i1 | 0);
 } else _pthread_mutex_unlock(gb + 1476912 | 0) | 0; while (0);
 return;
}

function __ZNK25SingleBlockMemoryFileData5CloneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i11 = i10;
 i8 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 492486 | 0, 103) | 0;
 i9 = gb + 63552 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = 1;
 HEAP32[i8 >> 2] = gb + 71752 + 8;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i9;
 i3 = i11;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i9;
 i3 = i8 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i9 = i8 + 28 | 0;
 HEAP32[i9 >> 2] = 0;
 i4 = i8 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i8 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i11);
 i11 = i7;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i7, i1 + 16 | 0);
 if ((i7 | 0) != (i3 | 0)) {
  i6 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = i1;
  i2 = HEAP32[i4 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1, 1, i5, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i3 >> 2] = i1;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i5, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i3 >> 2] = i11;
   i1 = i11;
   break;
  } else i1 = HEAP32[i3 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, HEAP32[i9 >> 2] | 0) | 0;
 }
 if ((HEAP32[i7 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i8 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i7 + 4 | 0);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return i8 | 0;
}

function __ZN6SpriteC2E10MemLabelId18ObjectCreationMode(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i4 = i8;
 i3 = i1;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i6, i7, i2);
 HEAP32[i6 >> 2] = gb + 45276 + 8;
 i1 = i6 + 116 | 0;
 i4 = i6 + 32 | 0;
 i5 = i4 + 84 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 128 >> 2] = Math_fround(0.0);
 HEAP8[i6 + 132 >> 0] = 1;
 i1 = i6 + 136 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 412121 | 0, 329) | 0;
 i3 = i2 + 4 | 0;
 i4 = i3;
 i5 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i3 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 45376 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i3 = i7;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i4 = i7;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i2 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 HEAPF32[i6 + 140 >> 2] = Math_fround(100.0);
 HEAP32[i6 + 144 >> 2] = 0;
 HEAP8[i6 + 148 >> 0] = 0;
 i7 = i6 + 152 | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i6 + 156 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap13postUpdatePPUEPNS_10PxBaseTaskE(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i10 + 192 | 0;
 i7 = i10 + 180 | 0;
 i8 = i10 + 184 | 0;
 i9 = i10 + 188 | 0;
 i3 = HEAP32[i10 + 288 >> 2] | 0;
 i4 = HEAP32[i10 + 284 >> 2] | 0;
 if (i3 | 0) {
  i5 = 0;
  do {
   i1 = HEAP32[i4 + (i5 << 3) >> 2] | 0;
   i2 = HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0;
   if (i1 >>> 0 > i2 >>> 0) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i1, i2, i6, i7, i8, i9) | 0; else __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_(i1, i2, i6, i7, i8, i9);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i10 + 328 >> 2] | 0;
 i2 = HEAP32[i10 + 324 >> 2] | 0;
 if (i1 | 0) {
  i5 = 0;
  do {
   i3 = HEAP32[i2 + (i5 << 3) >> 2] | 0;
   i4 = HEAP32[i2 + (i5 << 3) + 4 >> 2] | 0;
   if (i3 >>> 0 > i4 >>> 0) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i3, i4, i6, i7, i8, i9) | 0; else __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_(i3, i4, i6, i7, i8, i9);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i10 + 368 >> 2] | 0;
 i2 = HEAP32[i10 + 364 >> 2] | 0;
 if (i1 | 0) {
  i5 = 0;
  do {
   i3 = HEAP32[i2 + (i5 << 3) >> 2] | 0;
   i4 = HEAP32[i2 + (i5 << 3) + 4 >> 2] | 0;
   if (i3 >>> 0 > i4 >>> 0) __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i3, i4, i6, i7, i8, i9) | 0; else __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_(i3, i4, i6, i7, i8, i9);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i1 | 0));
 }
 __ZN5physx23PxsBroadPhaseContextSap11batchCreateEv(i10);
 __ZN5physx31ComputeCreatedDeletedPairsListsEPKjS1_jRPNS_17PxcBroadPhasePairERjS5_S4_S5_S5_RNS_14SapPairManagerE(HEAP32[i10 + 104 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, i10 + 232 | 0, i10 + 236 | 0, i10 + 240 | 0, i10 + 244 | 0, i10 + 248 | 0, i10 + 252 | 0, i6);
 HEAP32[i10 + 172 >> 2] = HEAP32[i10 + 168 >> 2];
 return;
}

function __ZN27DeviceViewProjMatricesStateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 96 | 0;
 i3 = i2;
 i5 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0, i1 + 68 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0, i1 + 4 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i5, i4);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i4, i3);
 i4 = i1 + 1364 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i4 = i3 + 16 | 0;
 i5 = i1 + 1380 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 32 | 0;
 i4 = i1 + 1396 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = i3 + 48 | 0;
 i5 = i1 + 1412 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 64 | 0;
 i4 = i1 + 1428 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i3 = i3 + 80 | 0;
 i1 = i1 + 1444 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN12_GLOBAL__N_115StringTableImpl7getStrsEPPKcjj(i6, i11, i2, i1) {
 i6 = i6 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0) | 0;
 i5 = i5 >>> 0 < i1 >>> 0 ? i5 : i1;
 i10 = (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0) | 0) - i5 | 0;
 i10 = i10 >>> 0 < i2 >>> 0 ? i10 : i2;
 i9 = i6 + 32 | 0;
 L1 : do if (!(HEAP32[i6 + 36 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i6 + 40 >> 2] | 0;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    if ((i3 | 0) == (i2 | 0)) {
     i1 = -1;
     break L1;
    }
    i1 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i3; else {
     i2 = i3;
     break;
    }
   }
  } else i2 = 0;
 } while (0);
 i8 = i6 + 28 | 0;
 i7 = i6 + 40 | 0;
 i3 = 0;
 L8 : while (1) {
  do {
   if (i3 >>> 0 >= i5 >>> 0) break L8;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) {
    i1 = -1;
    i2 = i4;
    continue L8;
   }
   i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) != -1) continue L8;
  }
 }
 i5 = i6 + 24 | 0;
 i3 = i2;
 i2 = 0;
 L18 : while (1) {
  do {
   if ((i1 | 0) == -1 | i2 >>> 0 >= i10 >>> 0) break L18;
   HEAP32[i11 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 3) + 4 >> 2];
   i2 = i2 + 1 | 0;
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i3;
  while (1) {
   i3 = i1 + 1 | 0;
   if ((i3 | 0) == (i4 | 0)) {
    i1 = -1;
    i3 = i4;
    continue L18;
   }
   i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i1 = i3; else continue L18;
  }
 }
 return i10 | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer20RestoreSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 2176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 1096 | 0;
 i2 = i3 + 36 | 0;
 i9 = i3 + 12 | 0;
 i7 = i3 + 24 | 0;
 i8 = i3;
 __ZN12FileAccessorC2Ev(i1);
 i10 = HEAP8[i4 + 11 >> 0] | 0;
 i12 = i10 << 24 >> 24 < 0;
 i11 = i12 ? HEAP32[i4 >> 2] | 0 : i4;
 i10 = i12 ? HEAP32[i4 + 4 >> 2] | 0 : i10 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i11, i10);
 i10 = HEAP8[i5 + 11 >> 0] | 0;
 i11 = i10 << 24 >> 24 < 0;
 i4 = i11 ? HEAP32[i5 >> 2] | 0 : i5;
 i5 = i11 ? HEAP32[i5 + 4 >> 2] | 0 : i10 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, i5);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i9, i7, i8);
 __ZN15FileSystemEntryC2EPKc(i2, (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i1, i2, 0, 1) | 0)) {
  i12 = 0;
  __ZN13FileEntryDataD2Ev(i2);
  __ZN12FileAccessorD2Ev(i1);
  STACKTOP = i3;
  return i12 | 0;
 }
 i12 = __ZN11UnityEngine15CloudWebService13SessionHeader15RestoreFromFileER12FileAccessor(i6, i1) | 0;
 __ZN12FileAccessor5CloseEv(i1) | 0;
 __ZN13FileEntryDataD2Ev(i2);
 __ZN12FileAccessorD2Ev(i1);
 STACKTOP = i3;
 return i12 | 0;
}

function __Z22AddCurveToStreamedClipIfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i17;
 i12 = i10 + 68 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  STACKTOP = i17;
  return;
 }
 i13 = i11 + 4 | 0;
 i14 = i11 + 8 | 0;
 i15 = i10 + 56 | 0;
 i6 = i11 + 20 | 0;
 i7 = i11 + 16 | 0;
 i8 = i11 + 12 | 0;
 i9 = i11 + 24 | 0;
 i3 = -1;
 do {
  HEAPF32[i13 >> 2] = Math_fround(inf);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  HEAP32[i14 + 4 >> 2] = 0;
  HEAP32[i14 + 8 >> 2] = 0;
  HEAP32[i14 + 12 >> 2] = 0;
  HEAP32[i14 + 16 >> 2] = 0;
  do if ((i3 | 0) == (i1 + -1 | 0)) {
   i16 = HEAP32[i15 >> 2] | 0;
   HEAP32[i13 >> 2] = HEAP32[i16 + (i3 << 4) >> 2];
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i7 >> 2] = Math_fround(0.0);
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   HEAP32[i9 >> 2] = HEAP32[i16 + (i3 << 4) + 4 >> 2];
   i16 = 10;
  } else {
   if ((i3 | 0) != -1) {
    __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif(i10, i11, i3, i3 + 1 | 0, Math_fround(0.0));
    i16 = 10;
    break;
   }
   i2 = HEAP32[i15 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i2 >> 2]) == Math_fround(-3402823469999999843913219.0e14))) {
    HEAPF32[i13 >> 2] = Math_fround(-3402823469999999843913219.0e14);
    HEAPF32[i6 >> 2] = Math_fround(0.0);
    HEAPF32[i7 >> 2] = Math_fround(0.0);
    HEAPF32[i8 >> 2] = Math_fround(0.0);
    HEAP32[i9 >> 2] = HEAP32[i2 + 4 >> 2];
    i16 = 10;
   }
  } while (0);
  if ((i16 | 0) == 10) {
   i16 = 0;
   __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i11, i5, i4);
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 STACKTOP = i17;
 return;
}

function __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE15growAndPushBackERKS6_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 * 12 | 0;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 739340 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 * 12 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 HEAP32[i4 + (i6 * 12 | 0) >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 12 | 0) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 12 | 0) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 * 12 | 0) | 0;
 return i10 | 0;
}

function __ZL22Transfer_ManagedObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 20 | 0;
 i7 = i10;
 i8 = HEAP32[i5 + 20 >> 2] | 0;
 i9 = i6 + 4 | 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = -1;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = (HEAP32[i4 + 32 >> 2] | 0) == 17;
 i2 = i3;
 do if (!i3) {
  i2 = i4 + 12 | 0;
  if (i1) i1 = 0; else i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP8[i7 >> 0] = 1;
  HEAP32[i7 + 4 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = -1;
 } else {
  if (!i1) {
   __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i7, HEAP32[i4 >> 2] | 0, i5, 1);
   break;
  }
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i3 = HEAP32[i4 + 12 >> 2] | 0;
  if (!(HEAP8[i5 >> 0] | 0)) {
   i1 = i1 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0;
   HEAP8[i7 >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = i2;
  } else {
   HEAP8[i7 >> 0] = 0;
   HEAP32[i7 + 4 >> 2] = i2;
  }
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = i1;
 } while (0);
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i9 = HEAP32[i4 + 44 >> 2] | 0;
 i2 = (HEAP32[i5 + 16 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + (i9 << 6) | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i5;
 i9 = i9 << 6 >> 6;
 HEAP32[i7 + 16 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i9;
 HEAP32[i6 >> 2] = i7;
 __ZN9JSONWrite8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags(i8, i6, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __Z19ApplyBlendShapeTmplILb1ELb1EEvPK16BlendShapeVertexjjfiiiPh(i2, i3, i1, f4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i9 = i8 + (Math_imul(HEAP32[i2 + (i1 * 40 | 0) + 36 >> 2] | 0, i7) | 0) | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) >> 2]) * f4);
  f12 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 4 >> 2]) * f4);
  f10 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 8 >> 2]) * f4);
  HEAPF32[i9 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i9 >> 2]));
  i11 = i9 + 4 | 0;
  HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i11 >> 2]));
  i11 = i9 + 8 | 0;
  HEAPF32[i11 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i11 >> 2]));
  i11 = i9 + i5 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 12 >> 2]) * f4);
  f12 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 16 >> 2]) * f4);
  f13 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 20 >> 2]) * f4);
  HEAPF32[i11 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i11 >> 2]));
  i14 = i11 + 4 | 0;
  HEAPF32[i14 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i14 >> 2]));
  i11 = i11 + 8 | 0;
  HEAPF32[i11 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i11 >> 2]));
  i9 = i9 + i6 | 0;
  f13 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 24 >> 2]) * f4);
  f12 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 28 >> 2]) * f4);
  f10 = Math_fround(Math_fround(HEAPF32[i2 + (i1 * 40 | 0) + 32 >> 2]) * f4);
  HEAPF32[i9 >> 2] = Math_fround(f13 + Math_fround(HEAPF32[i9 >> 2]));
  i11 = i9 + 4 | 0;
  HEAPF32[i11 >> 2] = Math_fround(f12 + Math_fround(HEAPF32[i11 >> 2]));
  i9 = i9 + 8 | 0;
  HEAPF32[i9 >> 2] = Math_fround(f10 + Math_fround(HEAPF32[i9 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function _getmntent_r(i7, i1, i14, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i18 + 8 | 0;
 i17 = i18;
 i3 = i18 + 48 | 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 _fgets(i14, i2, i7) | 0;
 L1 : do if (!(_feof(i7) | 0)) {
  i16 = i3 + 4 | 0;
  i8 = i3 + 8 | 0;
  i9 = i3 + 12 | 0;
  i10 = i3 + 16 | 0;
  i11 = i3 + 20 | 0;
  i12 = i3 + 24 | 0;
  i13 = i3 + 28 | 0;
  while (1) {
   if (_ferror(i7) | 0) {
    i1 = 0;
    break L1;
   }
   if (!(_strchr(i14, 10) | 0)) {
    i2 = 5;
    break;
   }
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i16;
   HEAP32[i6 + 8 >> 2] = i8;
   HEAP32[i6 + 12 >> 2] = i9;
   HEAP32[i6 + 16 >> 2] = i10;
   HEAP32[i6 + 20 >> 2] = i11;
   HEAP32[i6 + 24 >> 2] = i12;
   HEAP32[i6 + 28 >> 2] = i13;
   HEAP32[i6 + 32 >> 2] = i4;
   HEAP32[i6 + 36 >> 2] = i5;
   if ((_sscanf(i14, gb + 1073846 | 0, i6) | 0) >= 2) {
    i15 = i14 + (HEAP32[i3 >> 2] | 0) | 0;
    if ((HEAP8[i15 >> 0] | 0) != 35) {
     i2 = 9;
     break;
    }
   }
   _fgets(i14, i2, i7) | 0;
   if (_feof(i7) | 0) {
    i1 = 0;
    break L1;
   }
  }
  if ((i2 | 0) == 5) {
   _fscanf(i7, gb + 1073834 | 0, i17) | 0;
   HEAP32[(___errno_location() | 0) >> 2] = 34;
   i1 = 0;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP8[i14 + (HEAP32[i16 >> 2] | 0) >> 0] = 0;
   HEAP8[i14 + (HEAP32[i9 >> 2] | 0) >> 0] = 0;
   HEAP8[i14 + (HEAP32[i11 >> 2] | 0) >> 0] = 0;
   HEAP8[i14 + (HEAP32[i13 >> 2] | 0) >> 0] = 0;
   HEAP32[i1 >> 2] = i15;
   HEAP32[i1 + 4 >> 2] = i14 + (HEAP32[i8 >> 2] | 0);
   HEAP32[i1 + 8 >> 2] = i14 + (HEAP32[i10 >> 2] | 0);
   HEAP32[i1 + 12 >> 2] = i14 + (HEAP32[i12 >> 2] | 0);
   break;
  }
 } else i1 = 0; while (0);
 STACKTOP = i18;
 return i1 | 0;
}

function __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i6, gb + 1085944 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i5, i6 + 12 | 0, gb + 1084124 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i6 + 28 | 0, gb + 1085935 | 0, 0);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN6Avatar8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i6 + 32;
 i8 = i6 + 56 | 0;
 i5 = i6 + 72 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i1, i5, 4);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  __ZN7mecanim9animation14AvatarConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 60 | 0;
  __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i1, HEAP32[i5 >> 2] | 0);
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 100, 4) | 0;
 i2 = i1 + 40 | 0;
 i3 = i1;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 1065353216;
 HEAP32[i1 + 72 >> 2] = 1065353216;
 HEAP32[i1 + 76 >> 2] = 1065353216;
 HEAP32[i1 + 80 >> 2] = 1065353216;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = i1;
 i8 = i1;
 __ZN7mecanim9animation14AvatarConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
 i8 = i6 + 60 | 0;
 __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 739046 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx19CVariableMemoryPool8allocateEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i7 = i9;
 i5 = i1 + 135 & -128;
 HEAP32[i6 >> 2] = i5;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = i5 + ~(i5 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i8 + 28 >> 2] | 0;
   i3 = i8 + 32 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i5 = i4 + (i1 << 3) + 4 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i7 = HEAP32[i1 >> 2] | 0;
    HEAP32[i5 >> 2] = i7;
    if (!i7) __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE5eraseERS4_(i8 + 20 | 0, i6) | 0;
    i8 = i1 + 8 | 0;
    STACKTOP = i9;
    return i8 | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i8 + 64 >> 2] | 0;
 if (i5 >>> 0 < i1 >>> 0) HEAP32[i6 >> 2] = i1; else i1 = i5;
 i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, gb + 673189 | 0, gb + 673221 | 0, 177) | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i8 + 16 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i8 + 8 >> 2] | 0) + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = i4 + 1;
 } else __ZN5physx6shdfnd5ArrayIPhNS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i8 + 4 | 0, i7) | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i8 = i2 + 8 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN14SerializedFileC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 8 | 0;
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i7 = i6;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = -2;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i8 = i6;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i1 + 76 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 i4 = gb + 63416 | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i1 + 92 >> 2] = 1024;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i8 = i6;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i1 + 112 | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = i1 + 132 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP8[i1 + 45 >> 0] = 0;
 HEAP8[i1 + 47 >> 0] = 0;
 HEAP8[i1 + 46 >> 0] = 0;
 HEAP32[i3 >> 2] = -2;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP32[i1 + 68 >> 2] = 50;
 HEAP32[i1 + 128 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZL32GeomOverlapCallback_PlaneCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i10, i8, i3, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(f6 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f15 = Math_fround(f12 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f6 * f16) + Math_fround(Math_fround(f12 * f15) + Math_fround(-1.0)));
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(f6 * f15);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f16 * f14));
 f14 = Math_fround(Math_fround(f16 * f6) - Math_fround(f15 * f14));
 f15 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f12 = Math_fround(f15 * f12);
 f13 = Math_fround(f15 * f13);
 f14 = Math_fround(f15 * f14);
 f15 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f6 = Math_fround(f15 + f12);
 f16 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f7 = Math_fround(f16 + f13);
 f11 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f17 = Math_fround(f14 + f11);
 f9 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i2, i10);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 * f4);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f6 + Math_fround(f7 * f5));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f17 = Math_fround(f7 + Math_fround(f17 * f6));
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 if (Math_fround(f7 + f17) <= f9) {
  i10 = 1;
  STACKTOP = i1;
  return i10 | 0;
 }
 i10 = Math_fround(f7 + Math_fround(Math_fround(Math_fround(Math_fround(f15 - f12) * f4) + Math_fround(Math_fround(f16 - f13) * f5)) + Math_fround(Math_fround(f11 - f14) * f6))) <= f9;
 STACKTOP = i1;
 return i10 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i6 = i11 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i3);
 i3 = i5;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 1) | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 HEAP32[i6 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i5 >> 2] = i2;
 i7 = i13 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i13 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN7mecanim12AndValueMaskEPNS_14ValueArrayMaskEPKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i3 | 0) {
  i6 = i8 + 4 | 0;
  i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
  i7 = i9 + 4 | 0;
  i2 = i7;
  i1 = 0;
  do {
   i4 = i6 + i1 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) i5 = 0; else i5 = (HEAP8[(HEAP32[i7 >> 2] | 0) + i2 + i1 >> 0] | 0) != 0;
   HEAP8[i4 >> 0] = i5 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 12 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 12 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = 0; else i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i8 + 16 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 20 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 20 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = 0; else i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i8 + 24 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 28 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 28 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = 0; else i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i7 = HEAP32[i8 + 32 >> 2] | 0;
 if (!i7) return;
 i6 = i8 + 36 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i3 = i9 + 36 | 0;
 i4 = i3;
 i1 = 0;
 do {
  i5 = i6 + i1 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) i2 = 0; else i2 = (HEAP8[(HEAP32[i3 >> 2] | 0) + i4 + i1 >> 0] | 0) != 0;
  HEAP8[i5 >> 0] = i2 & 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 688777 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 717273 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_17PxTaskDepTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 718970 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags(i10, i6, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 4 | 0;
 i1 = i9;
 i2 = i10 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i1 = i7;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  i2 = i2 + i3 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 >> 2] = i2 + 4;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i3;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i10, i8, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf(i4, i12, f3, f6, f7, i5, i1, f8) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 f3 = Math_fround(f3);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i5 = i5 | 0;
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 var i2 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i15 = HEAP32[i4 + 36 >> 2] | 0;
 i13 = HEAP32[i4 + 40 >> 2] | 0;
 i9 = i12 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i14 = i10 + i1 | 0;
 i16 = HEAP32[(HEAP32[i4 + 44 >> 2] | 0) + 2548 >> 2] | 0;
 i14 = i16 >>> 0 < i14 >>> 0 ? i16 : i14;
 i16 = i14 - i10 | 0;
 i1 = i16 >>> 0 < i1 >>> 0 ? i16 : i1;
 HEAP32[i2 >> 2] = i1;
 i1 = i1 + (i10 + 3 | 3) & -4;
 __ZN23ParticleSystemParticles13array_reserveEj(i12, i1 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i12, i1);
 i10 = i14 >>> 0 < i10 >>> 0 ? i14 : i10;
 i1 = i10 + 3 & -4;
 i14 = HEAP32[i15 + 280 >> 2] | 0;
 __ZN14ParticleSystem12StartModulesERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK27ParticleSystemEmissionStatebRK8Vector3fRK10Matrix4x4fR23ParticleSystemParticlesjffjfjRjb(i4, i15, i13, i13 + 488 | 0, (i14 | 0) == 1, i13 + 292 | 0, (i14 | 0) == 0 ? gb + 1162292 | 0 : i13 + 116 | 0, i12, i1, f7, f6, i5, f8, 0, i2, 1);
 i5 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i10 | 0)) {
  i4 = i1 - i10 | 0;
  i16 = i5 + i1 | 0;
  i4 = i16 - (i4 >>> 0 > i5 >>> 0 ? i5 : i4) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i16 = i2 >>> 0 < i16 >>> 0 ? i2 : i16;
  i2 = i16 - i4 | 0;
  if (!(i16 >>> 0 <= i4 >>> 0 | (i2 | 0) == 0)) {
   i1 = 0;
   do {
    __ZN23ParticleSystemParticles14element_assignEjj(i12, i1 + i10 | 0, i1 + i4 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i12, i5 + i10 | 0);
 STACKTOP = i11;
 return;
}

function __Z50AnimatorOverrideController_CUSTOM_Internal_GetClipP12Il2CppObjectS0_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 i4 = i9 + 4 | 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i4 = __ZNK26AnimatorOverrideController7GetClipE4PPtrI13AnimationClipEb(i5, i6, i3 << 24 >> 24 != 0) | 0;
 if (!i4) {
  i8 = 0;
  i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i8 = 12;
  }
 }
 if ((i8 | 0) == 10) i8 = 12;
 if ((i8 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i8 = i1;
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z24LoadImageIntoTextureImplI10PngDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE(i5, i1, i2, i6, i7, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 24 | 0;
 i8 = i14;
 i9 = i13 + 4 | 0;
 HEAP8[i9 >> 0] = 0;
 i3 = i13 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i13 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i13 >> 2] = gb + 43108 + 8;
 i11 = i13 + 32 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i13 + 36 | 0;
 HEAP32[i12 >> 2] = 0;
 if (!i1) {
  HEAP8[i9 >> 0] = 1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i15 = i13 + 24 | 0;
  HEAP32[i15 >> 2] = i1;
  HEAP32[i13 + 28 >> 2] = i2;
  HEAP32[i13 + 16 >> 2] = i15;
  HEAP32[i13 + 20 >> 2] = fb + 351;
  __ZN10PngDecoder11InitDecoderEv(i13);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 if (__ZL26InitializeTextureImageLoadR9Texture2D13TextureFormatjjbR14ImageReferenceR13dynamic_arrayIhLj1EE(i5, i6 ? 12 : i7, i2, i1, i6, i8, i10) | 0) {
  mftCall_viiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 16 >> 2] | 0, i13 | 0, HEAP32[i8 + 16 >> 2] | 0, HEAP32[i8 + 12 >> 2] | 0, 1, HEAP32[i8 >> 2] | 0);
  if (!(HEAP8[i9 >> 0] | 0)) i1 = 1; else {
   i1 = i10 + 16 | 0;
   if ((HEAP32[i1 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i10 + 4 | 0);
    HEAP32[i10 >> 2] = 0;
   }
   HEAP32[i10 >> 2] = 0;
   HEAP32[i10 + 12 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = 0;
  }
 } else i1 = 0;
 HEAP32[i13 >> 2] = gb + 43108 + 8;
 if (!(HEAP32[i11 >> 2] | 0)) {
  STACKTOP = i14;
  return i1 | 0;
 }
 _UNITY_png_destroy_read_struct(i11, i12, 0);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZNK5physx14NpSceneQueries5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf(i13, i8, i12, i14, f5, i10, i9, i7, i6, i4, f1) {
 i13 = i13 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 f5 = Math_fround(f5);
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 24 | 0;
 i3 = i15 + 48 | 0;
 i2 = HEAP16[i9 >> 1] | 0;
 if ((i2 & 768) == 768) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 688250 | 0, 87, gb + 704183 | 0, i15);
  i2 = HEAP16[i9 >> 1] & -257;
  HEAP16[i9 >> 1] = i2;
 }
 if ((i2 & 528) == 528) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 688250 | 0, 93, gb + 704250 | 0, i15 + 8 | 0);
  i2 = HEAP16[i9 >> 1] & -17;
  HEAP16[i9 >> 1] = i2;
 }
 if (f1 > Math_fround(0.0) & (i2 & 256) != 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 688250 | 0, 101, gb + 704362 | 0, i15 + 16 | 0);
  f1 = Math_fround(0.0);
 }
 HEAP32[i11 >> 2] = 0;
 HEAPF32[i11 + 8 >> 2] = f5;
 HEAP32[i11 + 4 >> 2] = i14;
 HEAP32[i11 + 12 >> 2] = i8;
 HEAP32[i11 + 16 >> 2] = i12;
 HEAPF32[i11 + 20 >> 2] = f1;
 HEAP16[i3 >> 1] = HEAP16[i9 >> 1] | 0;
 i14 = __ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i13, i11, i10, i3, i4, i7, i6, 0) | 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5Umbra8sha1HashEPKhj(i11, i1, i8) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i14 = i15 + 24 | 0;
 HEAP32[i13 >> 2] = HEAP32[gb + 80108 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[gb + 80108 + 4 >> 2];
 HEAP32[i13 + 8 >> 2] = HEAP32[gb + 80108 + 8 >> 2];
 HEAP32[i13 + 12 >> 2] = HEAP32[gb + 80108 + 12 >> 2];
 HEAP32[i13 + 16 >> 2] = HEAP32[gb + 80108 + 16 >> 2];
 i9 = (i8 + 72 | 0) >>> 6;
 i10 = i8 & 255;
 i7 = i8 & 63;
 i12 = (i7 + 9 | 0) >>> 0 > 64 ? 2 : 1;
 i6 = i12 << 6;
 i5 = i6 + (-9 - i7) | 0;
 if (!i7) i3 = i14; else {
  i2 = i7;
  i3 = i14;
  i4 = i1 + (i8 & -64) | 0;
  while (1) {
   i2 = i2 + -1 | 0;
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   if (!i2) break; else {
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   }
  }
  i3 = i14 + i7 | 0;
 }
 HEAP8[i3 >> 0] = -128;
 i2 = i3 + 1 | 0;
 if (!i5) i4 = i3; else {
  _memset(i2 | 0, 0, i5 | 0) | 0;
  i4 = i3 + i5 | 0;
  i2 = i3 + (-8 - i7 + i6) | 0;
 }
 HEAP8[i2 >> 0] = 0;
 HEAP8[i4 + 2 >> 0] = 0;
 HEAP8[i4 + 3 >> 0] = 0;
 HEAP8[i4 + 4 >> 0] = i8 >>> 29;
 HEAP8[i4 + 5 >> 0] = i8 >>> 21;
 HEAP8[i4 + 6 >> 0] = i8 >>> 13;
 HEAP8[i4 + 7 >> 0] = i8 >>> 5;
 HEAP8[i4 + 8 >> 0] = i10 << 3;
 i3 = i9 - i12 | 0;
 if (!i3) i1 = 0; else {
  i2 = 0;
  while (1) {
   __ZN5UmbraL12processBlockEPKjPj(i1, i13);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = 0;
    break;
   } else i1 = i1 + 64 | 0;
  }
 }
 do {
  __ZN5UmbraL12processBlockEPKjPj(i14 + (i1 << 6) | 0, i13);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i12 >>> 0);
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i11 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
 STACKTOP = i15;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i3 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i7, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i7, HEAP32[i4 + 24 >> 2] | 0, HEAP32[i3 + 28 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i12 = i5 + 16 | 0;
  i4 = i3 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  i3 = i3 + 32 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 32 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZN8Animator23RemoveContainedRendererEPv(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i10 = i1 + 440 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i6 = i1 + 428 | 0;
 i1 = 0;
 while (1) {
  i5 = (HEAP32[i6 >> 2] | 0) + (i1 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i2) i2 = 0; else {
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i11 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i13 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 9; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i11 = 11;
    }
   }
   if ((i11 | 0) == 9) i11 = 11;
   if ((i11 | 0) == 11) {
    i11 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  if ((i2 | 0) == (i7 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
   i11 = 16;
   break;
  }
 }
 if ((i11 | 0) == 16) {
  STACKTOP = i12;
  return;
 }
 i13 = HEAP32[i6 >> 2] | 0;
 HEAP32[i13 + (i1 << 2) >> 2] = HEAP32[i13 + ((HEAP32[i10 >> 2] | 0) + -1 << 2) >> 2];
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 STACKTOP = i12;
 return;
}

function __ZN7mecanim11OrValueMaskEPNS_14ValueArrayMaskEPKS0_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i3 | 0) {
  i6 = i8 + 4 | 0;
  i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
  i7 = i9 + 4 | 0;
  i2 = i7;
  i1 = 0;
  do {
   i4 = i6 + i1 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) i5 = (HEAP8[(HEAP32[i7 >> 2] | 0) + i2 + i1 >> 0] | 0) != 0; else i5 = 1;
   HEAP8[i4 >> 0] = i5 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 12 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 12 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0; else i7 = 1;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i8 + 16 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 20 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 20 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0; else i7 = 1;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i8 + 24 >> 2] | 0;
 if (i2 | 0) {
  i3 = i8 + 28 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = i9 + 28 | 0;
  i5 = i4;
  i1 = 0;
  do {
   i6 = i3 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) i7 = (HEAP8[(HEAP32[i4 >> 2] | 0) + i5 + i1 >> 0] | 0) != 0; else i7 = 1;
   HEAP8[i6 >> 0] = i7 & 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i7 = HEAP32[i8 + 32 >> 2] | 0;
 if (!i7) return;
 i6 = i8 + 36 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i3 = i9 + 36 | 0;
 i4 = i3;
 i1 = 0;
 do {
  i5 = i6 + i1 | 0;
  if (!(HEAP8[i5 >> 0] | 0)) i2 = (HEAP8[(HEAP32[i3 >> 2] | 0) + i4 + i1 >> 0] | 0) != 0; else i2 = 1;
  HEAP8[i5 >> 0] = i2 & 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 return;
}

function __ZN5physx3Scb4Body18setKinematicTargetERKNS_11PxTransformE(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0;
 i1 = HEAP32[i8 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i1 + 2860 >> 2]);
 i6 = i8 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i3 = 3;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  __ZN5physx2Sc8BodyCore18setKinematicTargetEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEERKNS_11PxTransformEf(i8 + 16 | 0, HEAP32[i1 + 1248 >> 2] | 0, i5, f7);
  HEAP32[i8 + 232 >> 2] = 0;
  HEAPF32[i8 + 228 >> 2] = f7;
  return;
 }
 i3 = i8 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(i1, i4 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i2 + 192 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 196 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 200 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 204 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 208 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i2 + 212 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i2 + 216 >> 2] = HEAP32[i5 + 24 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i8);
 i2 = i8 + 236 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8192;
 switch ((HEAP32[i6 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i8 >> 2] | 0;
   i3 = 10;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i8 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i3 = 9; else i3 = 10;
   break;
  }
 default:
  i3 = 9;
 }
 if ((i3 | 0) == 9) {
  HEAP32[i8 + 232 >> 2] = 0;
  HEAPF32[i8 + 228 >> 2] = f7;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i8 + 16 | 0, f7, 1);
  return;
 } else if ((i3 | 0) == 10) {
  HEAP32[i8 + 232 >> 2] = 0;
  HEAPF32[i8 + 228 >> 2] = f7;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i8);
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend2dDataConstantEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = i6 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 40, 4) | 0;
  i4 = i1;
  i5 = i4 + 40 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i5 | 0));
  i5 = i2;
  i1 = i1 | 0 ? i1 - i5 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i5;
 } else i3 = i6 + 4 | 0;
 i4 = i1 + i2 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 4;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i7 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 12;
 HEAP32[i7 + 4 >> 2] = i4 + 8;
 HEAP32[i7 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 20;
 HEAP32[i7 + 4 >> 2] = i4 + 16;
 HEAP32[i7 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 28;
 HEAP32[i7 + 4 >> 2] = i4 + 24;
 HEAP32[i7 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i7, 0);
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i4 + 36;
 HEAP32[i7 + 4 >> 2] = i4 + 32;
 HEAP32[i7 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i6, i7, 0);
 STACKTOP = i8;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 5, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 5, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 5 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 5) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 5) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14ParticleSystem21SendCollisionMessagesERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i4 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 i5 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i3 + 904 >> 2] | 0;
 if (HEAP8[i2 + 4 >> 0] | 0) if (HEAP8[i2 + 968 >> 0] | 0) __ZNK15CollisionEvents10SendEventsERN5Unity9ComponentE(i5 + 620 | 0, i3);
 if (HEAP8[(HEAP32[i3 + 912 >> 2] | 0) + 4 >> 0] | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1105116 | 0, i1);
  i2 = HEAP32[i5 + 12 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i5 + 520 >> 2] | 0;
   i1 = 0;
   do {
    i13 = i3 + (i1 << 2) | 0;
    f14 = Math_fround(HEAPF32[i13 >> 2]);
    i11 = i13 + 4 | 0;
    f12 = Math_fround(HEAPF32[i11 >> 2]);
    i9 = i13 + 8 | 0;
    f10 = Math_fround(HEAPF32[i9 >> 2]);
    i7 = i13 + 12 | 0;
    f8 = Math_fround(HEAPF32[i7 >> 2]);
    i15 = f14 < Math_fround(100.000008);
    f14 = i15 ? f14 : Math_fround(100.000008);
    i15 = f12 < Math_fround(100.000008);
    f12 = i15 ? f12 : Math_fround(100.000008);
    i15 = f10 < Math_fround(100.000008);
    f10 = i15 ? f10 : Math_fround(100.000008);
    i15 = f8 < Math_fround(100.000008);
    f8 = i15 ? f8 : Math_fround(100.000008);
    HEAPF32[i13 >> 2] = f14;
    HEAPF32[i11 >> 2] = f12;
    HEAPF32[i9 >> 2] = f10;
    HEAPF32[i7 >> 2] = f8;
    i1 = i1 + 4 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
 }
 HEAP32[i5 + 652 >> 2] = 0;
 HEAP32[i5 + 672 >> 2] = 0;
 HEAP32[i5 + 692 >> 2] = 0;
 HEAP32[i5 + 712 >> 2] = 0;
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i4) | 0;
 STACKTOP = i6;
 return;
}

function __ZN11LightProbes8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i9);
 __ZN11LightProbes14LightProbeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 32 | 0, i9);
 i4 = i5 + 160 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i7 = i9 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = HEAP32[i5 + 148 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 * 108 | 0) | 0;
 if (i4 | 0) do {
  __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i5 + 180 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = HEAP32[i5 + 168 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i8 << 3) | 0;
 if (i8 | 0) do {
  __ZN19LightProbeOcclusion8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __ZL21BuildEmptyCubeTexturePKci11ColorRGBA3217TextureColorSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i5 = i4;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i3 = __Z20CreateObjectFromCodeI7CubemapEPT_17AwakeFromLoadMode10MemLabelId(4, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, 61);
 mftCall_iiiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, 1, 1, 4, 0, 6, -1, 0) | 0;
 __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, i1 | 0);
 __ZN9Texture2D18UnshareTextureDataEv(i3);
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i5 = i8 & 255;
 i6 = i8 >>> 8 & 255;
 i7 = i8 >>> 16 & 255;
 i8 = i8 >>> 24 & 255;
 HEAP8[i1 >> 0] = i5;
 HEAP8[i1 + 1 >> 0] = i6;
 HEAP8[i1 + 2 >> 0] = i7;
 HEAP8[i1 + 3 >> 0] = i8;
 HEAP8[i1 + 4 >> 0] = i5;
 HEAP8[i1 + 5 >> 0] = i6;
 HEAP8[i1 + 6 >> 0] = i7;
 HEAP8[i1 + 7 >> 0] = i8;
 HEAP8[i1 + 8 >> 0] = i5;
 HEAP8[i1 + 9 >> 0] = i6;
 HEAP8[i1 + 10 >> 0] = i7;
 HEAP8[i1 + 11 >> 0] = i8;
 HEAP8[i1 + 12 >> 0] = i5;
 HEAP8[i1 + 13 >> 0] = i6;
 HEAP8[i1 + 14 >> 0] = i7;
 HEAP8[i1 + 15 >> 0] = i8;
 HEAP8[i1 + 16 >> 0] = i5;
 HEAP8[i1 + 17 >> 0] = i6;
 HEAP8[i1 + 18 >> 0] = i7;
 HEAP8[i1 + 19 >> 0] = i8;
 HEAP8[i1 + 20 >> 0] = i5;
 HEAP8[i1 + 21 >> 0] = i6;
 HEAP8[i1 + 22 >> 0] = i7;
 HEAP8[i1 + 23 >> 0] = i8;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 196 >> 2] | 0, i3 | 0);
 HEAP32[i3 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z33CreateMonoScriptFromScriptingTypeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(144, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 457443 | 0, 305) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 HEAP32[i3 >> 2] = gb + 65032 + 8;
 i4 = i3 + 72 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i4 = i3 + 92 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 108 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i4 = i3 + 124 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 + 88 >> 2] = 0;
 HEAP8[i3 + 140 >> 0] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN10MonoScript27InitializeAndRegisterScriptEP11Il2CppClass(i3, i1);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return i3 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN8Animator9GetStagesER13dynamic_arrayI9StageDescLj4EE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = (HEAP32[i1 + 96 >> 2] | 0) == 1;
 i1 = i7 ? 0 : 3;
 i7 = i7 ? 1 : 4;
 i8 = i10 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i9 = i10 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i4 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i2 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i4;
 i2 = HEAP32[i10 >> 2] | 0;
 HEAP32[i2 + (i3 << 3) >> 2] = fb + 3797;
 HEAP32[i2 + (i3 << 3) + 4 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i3 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i10 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i3;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 + (i2 << 3) >> 2] = fb + 3798;
 HEAP32[i10 + (i2 << 3) + 4 >> 2] = i7;
 return;
}

function __ZN5physx11NpAggregate29removeArticulationAndReinsertERNS_14PxArticulationEb(i1, i10, i9) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i7 = i1 + 36 | 0;
 do if (!(HEAP32[i7 >> 2] | 0)) HEAP32[i10 + 100 >> 2] = 0; else {
  i8 = i1 + 40 | 0;
  i5 = i1 + 8 | 0;
  i1 = 0;
  i6 = 0;
  L4 : while (1) {
   while (1) {
    i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) != 4) {
     i2 = i1;
     break;
    }
    i2 = HEAP32[i8 >> 2] | 0;
    i3 = i2 + (i6 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i4 + 288 >> 2] | 0) != (i10 | 0)) {
     i2 = i1;
     break;
    }
    i1 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
    i2 = HEAPU16[i4 + 4 >> 1] | 0;
    i3 = i4 + (HEAP32[gb + 1457020 + 68 + (i2 << 2) >> 2] | 0) | 0;
    __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i4 + (HEAP32[gb + 1457020 + (i2 << 2) >> 2] | 0) | 0, 0, i4);
    __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i5, i3, i9);
    if (i6 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) i1 = 1; else {
     i1 = 8;
     break L4;
    }
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) {
    i1 = 10;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == 8) {
   HEAP32[i10 + 100 >> 2] = 0;
   i11 = 1;
   STACKTOP = i12;
   return i11 | 0;
  } else if ((i1 | 0) == 10) {
   HEAP32[i10 + 100 >> 2] = 0;
   if (i2) i1 = 1; else break;
   STACKTOP = i12;
   return i1 | 0;
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 265, gb + 675580 | 0, i11);
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN21WorldParticleCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048629 | 0, i5, i1 + 36 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048644 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048666 | 0, gb + 1048681 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 4194305);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048697 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048720 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14UnityWebStream24GetAssetBundleInstanceIdEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 i8 = i1 + 44 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i8 = i2;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (HEAP8[i1 + 20 >> 0] | 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = i1 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN33AssetBundleLoadFromAsyncOperation20IntegrateImmediatelyEv(i1);
 i5 = (HEAP32[i6 >> 2] | 0) + 84 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 12;
   }
  }
  if ((i7 | 0) == 10) i7 = 12;
  if ((i7 | 0) == 12) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   if (!i1) break;
  }
  HEAP32[i8 >> 2] = HEAP32[i1 + 4 >> 2];
 } while (0);
 i7 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0);
 HEAP32[i6 >> 2] = 0;
 i8 = HEAP32[i8 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 64) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 28 | 0) + 1 | 0;
 if (i3 >>> 0 > 153391689) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 28 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 76695844 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 153391689;
 i1 = (i2 - i1 | 0) / 28 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 28 | 0) | 0;
 i2 = i4 + (i1 * 28 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 28 | 0) | 0;
 i12 = i6;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i11;
 __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i4 + (i1 * 28 | 0) + 8 | 0, i6 + 8 | 0);
 i6 = i2 + 28 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i3;
  i4 = i5;
  i1 = i5;
 } else {
  do {
   i12 = i1;
   i1 = i1 + -28 | 0;
   i13 = i1;
   i4 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i2 + -28 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i4;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + -20 | 0, i12 + -20 | 0);
   i2 = i3 + -28 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i2 = i3;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -28 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) return;
 __ZdlPv(i4);
 return;
}

function __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor13constructLeftERS3_(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i12 = i2 + 1 | 0;
 i13 = i5;
 i9 = i5 + 16 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i10 | 0) > (i12 | 0)) {
  HEAP32[i11 >> 2] = i13;
  i13 = i11 + 4 | 0;
  HEAP32[i13 >> 2] = i1;
  i13 = i11 + 8 | 0;
  HEAP32[i13 >> 2] = i12;
  return;
 }
 i8 = i2 + 2 | 0;
 i4 = i5 + 12 | 0;
 if ((HEAP32[i4 >> 2] | 0) > (i12 | 0)) i2 = HEAP32[i5 + 8 >> 2] | 0; else {
  i3 = i8 << 1;
  i3 = (i3 | 0) > 16 ? i3 : 16;
  i7 = i5 + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, (i3 << 3) + 16 | 0, 0) | 0;
  if (!i2) {
   i13 = 0;
   HEAP32[i11 >> 2] = i13;
   i13 = i11 + 4 | 0;
   HEAP32[i13 >> 2] = i1;
   i13 = i11 + 8 | 0;
   HEAP32[i13 >> 2] = i12;
   return;
  }
  HEAP32[i2 >> 2] = i3;
  i2 = i2 + 16 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i5 + 8 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  do if (i3 | 0) {
   i4 = HEAP32[i9 >> 2] | 0;
   if (i4) {
    i5 = (i4 | 0) <= (i8 | 0) ? i4 : i8;
    if ((i5 | 0) > 0) {
     i4 = 0;
     do {
      i16 = i3 + (i4 << 3) | 0;
      i15 = HEAP32[i16 + 4 >> 2] | 0;
      i14 = i2 + (i4 << 3) | 0;
      HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
      HEAP32[i14 + 4 >> 2] = i15;
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i5 | 0));
     i3 = HEAP32[i6 >> 2] | 0;
     if (!i3) break;
    }
   }
   i16 = HEAP32[i7 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i16 >> 2] | 0) + 12 >> 2] | 0, i16 | 0, i3 + -16 | 0);
  } while (0);
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i9 >> 2] = i8;
 _memset(i2 + (i10 << 3) | 0, 0, i8 - i10 << 2 | 0) | 0;
 i16 = i13;
 HEAP32[i11 >> 2] = i16;
 i16 = i11 + 4 | 0;
 HEAP32[i16 >> 2] = i1;
 i16 = i11 + 8 | 0;
 HEAP32[i16 >> 2] = i12;
 return;
}

function __ZN12_GLOBAL__N_110Connection22initializeProfileTypesERN5physx8debugger4comm31PvdCommStreamInternalDataStreamE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 133 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 i5 = i5 + 4 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 776499;
 mftCall_iii(i1 | 0, i5 | 0, i2 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 776499;
 HEAP32[i3 >> 2] = gb + 776474;
 HEAP32[i3 + 4 >> 2] = gb + 827872;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 mftCall_iiiiiiii(i1 | 0, i5 | 0, i2 | 0, gb + 1046975 | 0, gb + 776513 | 0, i3 | 0, 2, i4 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 775898;
 mftCall_iii(i1 | 0, i5 | 0, i2 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 775898;
 HEAP32[i3 >> 2] = gb + 776474;
 HEAP32[i3 + 4 >> 2] = gb + 827872;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 mftCall_iiiiiiii(i1 | 0, i5 | 0, i2 | 0, gb + 1046975 | 0, gb + 776534 | 0, i3 | 0, 2, i4 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 776554;
 mftCall_iii(i1 | 0, i5 | 0, i2 | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 775887;
 HEAP32[i2 + 4 >> 2] = gb + 776554;
 HEAP32[i3 >> 2] = gb + 776474;
 HEAP32[i3 + 4 >> 2] = gb + 827872;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 mftCall_iiiiiiii(i1 | 0, i5 | 0, i2 | 0, gb + 1046975 | 0, gb + 776570 | 0, i3 | 0, 2, i4 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZNK7b2Mat337Solve33ERK6b2Vec3(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f9 = Math_fround(f6 * f16);
 f10 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f10 * f15));
 f14 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f18 = Math_fround(f10 * f14);
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f18 = Math_fround(f18 - Math_fround(f16 * f7));
 f17 = Math_fround(Math_fround(f15 * f7) - Math_fround(f6 * f14));
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(f9 * f12);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f11 * f18));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f17 * f4));
 i2 = f13 != Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f13);
 f13 = i2 ? f5 : f13;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f9 * f5);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(f9 + Math_fround(f18 * f8));
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f13 * Math_fround(f18 + Math_fround(f17 * f9)));
 HEAPF32[i1 + 4 >> 2] = Math_fround(f13 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f16) - Math_fround(f9 * f15)) * f12) + Math_fround(f11 * Math_fround(Math_fround(f9 * f14) - Math_fround(f16 * f5)))) + Math_fround(Math_fround(Math_fround(f15 * f5) - Math_fround(f8 * f14)) * f4)));
 HEAPF32[i1 + 8 >> 2] = Math_fround(f13 * Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f6 * f9) - Math_fround(f10 * f8)) * f12) + Math_fround(f11 * Math_fround(Math_fround(f10 * f5) - Math_fround(f9 * f7)))) + Math_fround(Math_fround(Math_fround(f8 * f7) - Math_fround(f6 * f5)) * f4)));
 return;
}

function __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 76 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 45572 + 8;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = -1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 i3 = i1 + 116 | 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i1 + 120 | 0;
 i5 = i1 + 128 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP8[i1 + 108 >> 0] = 1;
 HEAP8[i1 + 111 >> 0] = 1;
 HEAP8[i1 + 112 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 HEAP8[i1 + 110 >> 0] = 0;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN7dtCrowd19updateAgentPositionERK13dtCrowdHandlePKf(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i2 + 16 >> 2] | 0;
 i11 = i10 + (i9 * 608 | 0) + 480 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 i7 = i10 + (i9 * 608 | 0) + 484 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 + 4 >> 2];
 i8 = i10 + (i9 * 608 | 0) + 488 | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAPF32[i10 + (i9 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
 if (HEAP8[i10 + (i9 * 608 | 0) + 601 >> 0] | 0) return;
 i4 = i10 + (i9 * 608 | 0) | 0;
 __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i4, i3, HEAP32[i2 + 464 >> 2] | 0, (HEAP32[i2 + 24 >> 2] | 0) + (i9 * 132 | 0) | 0);
 i6 = i10 + (i9 * 608 | 0) + 32 | 0;
 i1 = HEAP32[i10 + (i9 * 608 | 0) + 28 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i10 + (i9 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  i12 = 5;
 } else {
  i5 = i1;
  i2 = HEAP32[(HEAP32[i10 + (i9 * 608 | 0) + 24 >> 2] | 0) + 56 >> 2] | 0;
  if ((HEAP32[i5 >> 2] | 0) == 0 & (HEAP32[i5 + 4 >> 2] | 0) == 0) i12 = 5; else {
   i3 = HEAP32[i10 + (i9 * 608 | 0) + 4 >> 2] | 0;
   i13 = HEAP32[i10 + (i9 * 608 | 0) + 8 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i10 + (i9 * 608 | 0) + 12 >> 2] = i1;
   HEAP32[i10 + (i9 * 608 | 0) + 16 >> 2] = i3;
   HEAP32[i10 + (i9 * 608 | 0) + 20 >> 2] = i13;
   i5 = 1;
   i4 = i13;
  }
 }
 if ((i12 | 0) == 5) {
  i5 = i1;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i10 + (i9 * 608 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i10 + (i9 * 608 | 0) + 8 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 1;
 HEAP8[i10 + (i9 * 608 | 0) + 44 >> 0] = i5;
 HEAP32[i10 + (i9 * 608 | 0) + 48 >> 2] = i2;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 + (i9 * 608 | 0) + 476 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 704559 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN15TerrainRenderer9ReloadAllEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i4 = i7 + 20 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i3 = i1 + 16 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 2) {
   __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i7, i1);
   i2 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i5, i1, i6);
   i2 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i6 = i1;
    i6 = i6 + 248 | 0;
    i6 = i6 + 80 | 0;
    i6 = HEAP32[i6 >> 2] | 0;
    i8 = i7 + 28 | 0;
    HEAP32[i8 >> 2] = i6;
    __ZN15TerrainRenderer12RebuildNodesEv(i7);
    STACKTOP = i9;
    return;
   }
  }
 }
 i6 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i6 = i6 + 248 | 0;
 i6 = i6 + 80 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 28 | 0;
 HEAP32[i8 >> 2] = i6;
 __ZN15TerrainRenderer12RebuildNodesEv(i7);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37176 >> 2] | 0, i6, 0);
 i1 = i7 + 8 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13b2PulleyJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 120 | 0;
 i4 = i2 + 112 | 0;
 i5 = i2 + 104 | 0;
 i6 = i2 + 96 | 0;
 i7 = i2 + 80 | 0;
 i10 = i2 + 64 | 0;
 i11 = i2 + 48 | 0;
 i12 = i2 + 32 | 0;
 i13 = i2 + 24 | 0;
 i14 = i2 + 16 | 0;
 i16 = i2 + 8 | 0;
 i17 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i15 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800290 | 0, i2);
 HEAP32[i16 >> 2] = i17;
 __Z5b2LogPKcz(gb + 799360 | 0, i16);
 HEAP32[i14 >> 2] = i15;
 __Z5b2LogPKcz(gb + 799386 | 0, i14);
 HEAP32[i13 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i13);
 d8 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i12 >> 3] = d8;
 HEAPF64[i12 + 8 >> 3] = d9;
 __Z5b2LogPKcz(gb + 800314 | 0, i12);
 d9 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d8 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i11 >> 3] = d9;
 HEAPF64[i11 + 8 >> 3] = d8;
 __Z5b2LogPKcz(gb + 800357 | 0, i11);
 d8 = +Math_fround(HEAPF32[i1 + 92 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 96 >> 2]);
 HEAPF64[i10 >> 3] = d8;
 HEAPF64[i10 + 8 >> 3] = d9;
 __Z5b2LogPKcz(gb + 799447 | 0, i10);
 d9 = +Math_fround(HEAPF32[i1 + 100 >> 2]);
 d8 = +Math_fround(HEAPF32[i1 + 104 >> 2]);
 HEAPF64[i7 >> 3] = d9;
 HEAPF64[i7 + 8 >> 3] = d8;
 __Z5b2LogPKcz(gb + 799489 | 0, i7);
 HEAPF64[i6 >> 3] = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 __Z5b2LogPKcz(gb + 800400 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 88 >> 2]);
 __Z5b2LogPKcz(gb + 800425 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 112 >> 2]);
 __Z5b2LogPKcz(gb + 799812 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i4 = i8 + 8 | 0;
 i3 = i8;
 i6 = i8 + 32 | 0;
 if (i2 | 0) if (HEAP32[i2 >> 2] | 0) {
  if (i5 | 0) if (HEAP32[i5 >> 2] | 0) {
   i1 = i1 + 860 | 0;
   i4 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i1 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0) | 0;
   i1 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i1 >> 2] | 0, HEAP32[i5 + 20 >> 2] | 0) | 0;
   i2 = HEAP32[i4 + 20 >> 2] | 0;
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i7 = 1;
    STACKTOP = i8;
    return i7 | 0;
   }
   i5 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i7 + 8 >> 2] = i5;
   HEAP32[i7 + 12 >> 2] = i3;
   __Z6FormatPKcz(i6, gb + 604016 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 603515 | 0, 1128, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
  __Z6FormatPKcz(i6, gb + 603896 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 603515 | 0, 1118, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __Z6FormatPKcz(i6, gb + 603781 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 603515 | 0, 1113, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z21PostprocessStacktracePKcRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 500 | 0;
 i10 = i11 + 496 | 0;
 i8 = i11 + 248 | 0;
 i2 = i11 + 488 | 0;
 i3 = i11;
 i4 = i11 + 240 | 0;
 if (!(HEAP8[gb + 1546606 >> 0] | 0)) {
  HEAP8[gb + 1546606 >> 0] = 1;
  i5 = __Z23GetCoreScriptingClassesv() | 0;
  i6 = HEAP32[i5 + 436 >> 2] | 0;
  if (i6 | 0) {
   i5 = HEAP32[i5 + 440 >> 2] | 0;
   HEAP32[i2 >> 2] = i6;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i8, i9);
   __ZN18ScriptingArguments9AddStringEPKc(i8, gb + 463682 | 0);
   HEAP32[i9 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i8, i9, 0) | 0;
  }
 }
 if (!(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 420 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 i2 = (__Z23GetCoreScriptingClassesv() | 0) + 420 | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i9);
 __ZN18ScriptingArguments9AddStringEPKc(i3, i1);
 __ZN18ScriptingArguments10AddBooleanEb(i3, 1);
 i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i8, 0) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  __Z24scripting_cpp_string_forP12Il2CppString(i9, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i9) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i11;
  return;
 } else {
  _printf_console(gb + 463704 | 0, i10);
  STACKTOP = i11;
  return;
 }
}

function _jpeg_set_linear_quality(i5, i6, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0;
 i4 = i5 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != 100) {
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 20;
  HEAP32[i2 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i5 | 0);
 }
 i1 = i5 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = _jpeg_alloc_quant_table(i5) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i3 = i3 << 24 >> 24 == 0;
 if (i3) {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[gb + 15752 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) > 32767 ? 32767 : i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
 } else {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[gb + 15752 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) < 255 ? i7 : 255;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
 }
 HEAP8[i2 + 128 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != 100) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 20;
  HEAP32[i7 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i1 = i5 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = _jpeg_alloc_quant_table(i5) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 if (i3) {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[gb + 16008 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) > 32767 ? 32767 : i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  i7 = i2 + 128 | 0;
  HEAP8[i7 >> 0] = 0;
  return;
 } else {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[gb + 16008 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) < 255 ? i7 : 255;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  i7 = i2 + 128 | 0;
  HEAP8[i7 >> 0] = 0;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 3;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 671669 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i10 = i6;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i7 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 i12 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i10 = i7;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 28 | 0, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 843883 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 843899 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i3 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 4 | 0;
 i5 = i13;
 i8 = i7 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = (i9 - i1 | 0) / 20 | 0;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  i5 = i1 + 12 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i12 >> 2] = i2;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i11 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i12, 4);
  i2 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i7 = i2 + (i8 << 3) | 0;
  if (i8 | 0) do {
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = i3 + 4 | 0;
   i5 = HEAP32[i10 >> 2] | 0;
   if (i4 >>> 0 < i5 >>> 0) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i11 >> 2] = i4;
   } else {
    __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = HEAP32[i10 >> 2] | 0;
   }
   i3 = i2 + 4 | 0;
   i6 = i4 + 4 | 0;
   if (i6 >>> 0 < i5 >>> 0) {
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i11 >> 2] = i6;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i3, 4);
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i7 | 0));
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i13;
 return;
}

function __Z38NavMesh_CUSTOM_GetNavMeshLayerFromNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 40 | 0;
 i4 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i5 = __Z25GetNavMeshProjectSettingsv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i4);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZNK22NavMeshProjectSettings15GetAreaFromNameERK8UnityStr(i5, i8) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i13 = HEAP32[i5 + 4 >> 2] | 0;
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(-f17);
 f16 = Math_fround(-f16);
 f15 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 f14 = Math_fround(HEAPF32[i13 + 96 >> 2]);
 f8 = Math_fround(HEAPF32[i13 + 100 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 104 >> 2]);
 f18 = Math_fround(Math_fround(Math_fround(f14 * f17) + Math_fround(f8 * f16)) + Math_fround(f9 * f15));
 f10 = Math_fround(HEAPF32[i13 + 112 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 116 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 120 >> 2]);
 i13 = f18 > Math_fround(Math_fround(Math_fround(f10 * f17) + Math_fround(f12 * f16)) + Math_fround(f7 * f15));
 f10 = i13 ? f14 : f10;
 f12 = i13 ? f8 : f12;
 f7 = i13 ? f9 : f7;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZNK5physx2Gu11HeightField17getHeightInternalEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 4 | 0;
 i7 = i8;
 i4 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i3, f1, f2, i9, i7) | 0;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 i7 = HEAP32[i3 + 36 >> 2] | 0;
 if ((HEAP8[i7 + (i4 << 2) + 2 >> 0] | 0) < 0) {
  f2 = Math_fround(HEAP16[i7 + (i4 << 2) >> 1] | 0);
  i3 = (HEAP32[i3 + 20 >> 2] | 0) + i4 | 0;
  f1 = Math_fround(HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0);
  if (f6 > f5) {
   f10 = Math_fround(HEAP16[i7 + (i4 + 1 << 2) >> 1] | 0);
   f6 = Math_fround(Math_fround(f5 * Math_fround(f1 - f10)) + Math_fround(f2 + Math_fround(f6 * Math_fround(f10 - f2))));
   STACKTOP = i8;
   return Math_fround(f6);
  } else {
   f10 = Math_fround(HEAP16[i7 + (i3 << 2) >> 1] | 0);
   f10 = Math_fround(Math_fround(f6 * Math_fround(f1 - f10)) + Math_fround(f2 + Math_fround(f5 * Math_fround(f10 - f2))));
   STACKTOP = i8;
   return Math_fround(f10);
  }
 } else {
  i3 = (HEAP32[i3 + 20 >> 2] | 0) + i4 | 0;
  f1 = Math_fround(HEAP16[i7 + (i3 << 2) >> 1] | 0);
  f2 = Math_fround(HEAP16[i7 + (i4 + 1 << 2) >> 1] | 0);
  if (Math_fround(f5 + f6) < Math_fround(1.0)) {
   f10 = Math_fround(HEAP16[i7 + (i4 << 2) >> 1] | 0);
   f10 = Math_fround(Math_fround(f5 * Math_fround(f1 - f10)) + Math_fround(f10 + Math_fround(f6 * Math_fround(f2 - f10))));
   STACKTOP = i8;
   return Math_fround(f10);
  } else {
   f10 = Math_fround(HEAP16[i7 + (i3 + 1 << 2) >> 1] | 0);
   f10 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f5) * Math_fround(f2 - f10)) + Math_fround(f10 + Math_fround(Math_fround(Math_fround(1.0) - f6) * Math_fround(f1 - f10))));
   STACKTOP = i8;
   return Math_fround(f10);
  }
 }
 return f0;
}

function __ZNK5physx14NpSpatialIndex7overlapERKNS_9PxBounds3ERNS_24PxSpatialOverlapCallbackE(i1, i3, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 48 | 0;
 i4 = i9 + 32 | 0;
 i8 = i9;
 i7 = i9 + 56 | 0;
 i2 = i1 + 4 | 0;
 i1 = i1 + 8 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0);
 }
 HEAP8[i2 >> 0] = 0;
 HEAP32[i6 >> 2] = gb + 107604 + 8;
 HEAP32[i6 + 4 >> 2] = i5;
 f13 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 f19 = Math_fround(f13 - f16);
 f12 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(f12 - f15);
 f11 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f19 = Math_fround(f19 * Math_fround(.5));
 f18 = Math_fround(f18 * Math_fround(.5));
 f17 = Math_fround(Math_fround(f11 - f14) * Math_fround(.5));
 HEAP32[i4 >> 2] = 3;
 HEAPF32[i4 + 4 >> 2] = f19;
 HEAPF32[i4 + 8 >> 2] = f18;
 HEAPF32[i4 + 12 >> 2] = f17;
 f13 = Math_fround(Math_fround(f16 + f13) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f15 + f12) * Math_fround(.5));
 f11 = Math_fround(Math_fround(f14 + f11) * Math_fround(.5));
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 16 >> 2] = f13;
 HEAPF32[i8 + 20 >> 2] = f12;
 HEAPF32[i8 + 24 >> 2] = f11;
 __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf(i7, i4, i8, Math_fround(0.0));
 i10 = HEAP32[i1 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0, i7 | 0, i6 | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN6Avatar8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = i6 + 32;
 i8 = i6 + 56 | 0;
 i5 = i6 + 72 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4); else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 60 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i1, HEAP32[i5 >> 2] | 0);
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 100, 4) | 0;
 i2 = i1 + 40 | 0;
 i3 = i1;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 1065353216;
 HEAP32[i1 + 72 >> 2] = 1065353216;
 HEAP32[i1 + 76 >> 2] = 1065353216;
 HEAP32[i1 + 80 >> 2] = 1065353216;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i8 >> 2] = i1;
 i8 = i1;
 __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
 i8 = i6 + 60 | 0;
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 return;
}

function __ZN18AnimatorControllerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 178116 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 84 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP8[i1 + 100 >> 0] = 1;
 HEAP32[i1 + 104 >> 2] = gb + 176376 + 8;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 4096;
 HEAP32[i1 + 108 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = i1 + 144;
 HEAP8[i1 + 152 >> 0] = 1;
 i6 = i1 + 160 | 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 176 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 196 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __Z27GetComponentsInChildrenImplILb1EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE(i8, i14, i15) {
 i8 = i8 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = HEAP32[i8 + 40 >> 2] | 0;
 if ((i9 | 0) > 0) {
  i10 = i8 + 28 | 0;
  i11 = i15 + 12 | 0;
  i12 = i15 + 16 | 0;
  i13 = i15 + 4 | 0;
  i7 = 0;
  do {
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[gb + 1106156 + 4 + (HEAP32[i2 + (i7 << 3) >> 2] << 2) >> 2] | 0;
   if (!i1) i1 = -1; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i1 | 0) == (i14 | 0)) {
    i2 = HEAP32[i2 + (i7 << 3) + 4 >> 2] | 0;
    i3 = HEAP32[i11 >> 2] | 0;
    i4 = i3 + 1 | 0;
    i5 = HEAP32[i12 >> 2] | 0;
    i6 = i5 & 2147483647;
    do if (i4 >>> 0 > i6 >>> 0) {
     i1 = i5 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
      HEAP32[i12 >> 2] = i1;
      HEAP32[i15 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i15 >> 2] | 0, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i6 | 0, HEAP32[i15 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i1;
      HEAP32[i15 >> 2] = i6;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i4;
    HEAP32[(HEAP32[i15 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i9 | 0));
 }
 i1 = __ZNK10GameObject23QueryComponentTransformEv(i8) | 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i1 + 80 | 0;
 i1 = 0;
 do {
  __Z27GetComponentsInChildrenImplILb1EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, i14, i15);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 11;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if (__ZNK21GLESRenderTargetSetupltERKS_(i7, i2) | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if (!(__ZNK21GLESRenderTargetSetupltERKS_(i2, i7) | 0)) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i6 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i6 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   i2 = 11;
   break;
  }
 } while (0);
 if ((i2 | 0) == 11) if (!i1) i6 = i4; else {
  i8 = i1;
  i8 = i8 + 112 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = __Znwj(120) | 0;
 i4 = i5 + 16 | 0;
 i1 = i7;
 i2 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP32[i5 + 112 >> 2] = 0;
 HEAP32[i5 + 116 >> 2] = -1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAP32[i3 >> 2] = i5;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i5; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i5;
 i8 = i8 + 112 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i20, i19) {
 i1 = i1 | 0;
 i20 = i20 | 0;
 i19 = i19 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i21 = 0, i22 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i20 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i20);
 i16 = HEAP32[i1 >> 2] | 0;
 i17 = i1 + 4 | 0;
 i1 = HEAP32[i17 >> 2] | 0;
 i18 = i16 + (i20 * 76 | 0) | 0;
 if ((i1 | 0) >= (i20 | 0)) {
  HEAP32[i17 >> 2] = i20;
  return;
 }
 i2 = i19 + 16 | 0;
 i3 = i19 + 20 | 0;
 i4 = i19 + 24 | 0;
 i5 = i19 + 28 | 0;
 i6 = i19 + 32 | 0;
 i7 = i19 + 36 | 0;
 i8 = i19 + 40 | 0;
 i9 = i19 + 44 | 0;
 i10 = i19 + 48 | 0;
 i11 = i19 + 52 | 0;
 i12 = i19 + 56 | 0;
 i13 = i19 + 60 | 0;
 i14 = i19 + 64 | 0;
 i15 = i19 + 68 | 0;
 i1 = i16 + (i1 * 76 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i19 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i19 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i19 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 56 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 60 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 64 >> 2] = HEAP32[i14 >> 2];
  i22 = i15;
  i21 = HEAP32[i22 + 4 >> 2] | 0;
  i16 = i1 + 68 | 0;
  HEAP32[i16 >> 2] = HEAP32[i22 >> 2];
  HEAP32[i16 + 4 >> 2] = i21;
  i1 = i1 + 76 | 0;
 } while (i1 >>> 0 < i18 >>> 0);
 HEAP32[i17 >> 2] = i20;
 return;
}

function __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_(i2, i1, i4, i3, i6, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f18 = Math_fround(Math_fround(1.0) / f18);
 f11 = Math_fround(Math_fround(1.0) / f11);
 f7 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f16 = Math_fround(f18 * Math_fround(f16 - f10));
 f15 = Math_fround(f11 * Math_fround(f15 - f12));
 f9 = Math_fround(f7 * Math_fround(f9 - f13));
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f18 * Math_fround(f17 - f10));
 f12 = Math_fround(f11 * Math_fround(f8 - f12));
 f13 = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f13));
 i2 = f16 > f10;
 i14 = f15 > f12;
 i1 = f9 > f13;
 f7 = f16 < f10 ? f16 : f10;
 f8 = f15 < f12 ? f15 : f12;
 f11 = f9 < f13 ? f9 : f13;
 f10 = i2 ? f16 : f10;
 f12 = i14 ? f15 : f12;
 f13 = i1 ? f9 : f13;
 i3 = f7 == f7 & Math_fround(0.0) == Math_fround(0.0) & f7 >= f8 & f7 >= f11;
 i4 = f8 == f8 & Math_fround(0.0) == Math_fround(0.0) & f8 >= f7 & f8 >= f11;
 f11 = i3 ? f7 : i4 ? f8 : f11;
 f8 = i14 ? Math_fround(4.0) : Math_fround(1.0);
 f7 = i1 ? Math_fround(5.0) : Math_fround(2.0);
 f9 = i2 ? Math_fround(3.0) : Math_fround(0.0);
 f12 = f12 > f13 ? f13 : f12;
 f10 = f10 > f12 ? f12 : f10;
 i2 = f10 >= Math_fround(1.1920929e-07) & f10 >= f11;
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i5 >> 2] = f10;
 return (i2 ? ~~(i3 ? f9 : i4 ? f8 : f7) : -1) | 0;
}

function __ZN5Unity14CharacterJoint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(184, i1, 16, gb + 1048932 | 0, 0, gb + 779595 | 0, 22) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i3 = i4 + 40 | 0;
 i2 = i4 + 52 | 0;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 111592 + 8;
 i1 = i4 + 96 | 0;
 i2 = i4 + 108 | 0;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = HEAP32[gb + 62536 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
 HEAP8[i4 + 172 >> 0] = 0;
 HEAPF32[i4 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 180 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD8ChannelI12setFrequencyEf(i11, f5) {
 i11 = i11 | 0;
 f5 = Math_fround(f5);
 var d1 = 0.0, f2 = f0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i6 = i11 + 140 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 if (!(f2 != f5)) return 0;
 i7 = i11 + 152 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i4 = i11 + 161 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  d1 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i10 = +Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0;
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  i9 = ~~d1 >>> 0;
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  i4 = (HEAP8[i4 >> 0] | 0) == 0;
 } else {
  i10 = i11 + 120 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  f3 = f8;
  i4 = 0;
 }
 i12 = i11 + 104 | 0;
 i13 = i12;
 i13 = _i64Subtract(i9 | 0, i10 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0) | 0;
 f3 = Math_fround(Math_fround(+(i13 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0)) * Math_fround(Math_fround(f2 * f3) / Math_fround(44100.0)));
 i13 = +Math_abs(+f3) >= 1.0 ? (+f3 > 0.0 ? ~~+Math_min(+Math_floor(+f3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f3 - +(~~+f3 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAPF32[i6 >> 2] = f5;
 HEAPF32[i7 >> 2] = f8;
 f2 = Math_fround(f8 * f5);
 f8 = Math_fround(Math_fround(+(i9 >>> 0) + 4294967296.0 * +(i10 >>> 0)) - Math_fround(Math_fround(Math_fround(44100.0) / f2) * Math_fround(+(~~+f3 >>> 0 >>> 0) + 4294967296.0 * +(i13 >>> 0))));
 i9 = +Math_abs(+f8) >= 1.0 ? (+f8 > 0.0 ? ~~+Math_min(+Math_floor(+f8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f8 - +(~~+f8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i10 = i12;
 HEAP32[i10 >> 2] = ~~+f8 >>> 0;
 HEAP32[i10 + 4 >> 2] = i9;
 if (i4) d1 = +Math_fround(f2 / Math_fround(44100.0)); else d1 = 1.0e-07;
 _JS_Sound_SetPitch(HEAP32[i11 + 164 >> 2] | 0, +d1);
 return 0;
}

function __ZN4FMOD8ChannelI11getPositionEPjj(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, f10 = f0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 if (!(HEAP8[i1 + 161 >> 0] | 0)) {
  d9 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i2 = ~~d9 >>> 0;
  i3 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
 } else {
  i3 = i1 + 120 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
 }
 i11 = i1 + 104 | 0;
 i2 = _i64Subtract(i2 | 0, i3 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0) | 0;
 f10 = Math_fround(+(i2 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 f10 = Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i1 + 140 >> 2]) / Math_fround(44100.0)));
 i2 = +Math_abs(+f10) >= 1.0 ? (+f10 > 0.0 ? ~~+Math_min(+Math_floor(+f10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f10 - +(~~+f10 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i1 = i1 + 128 | 0;
 i1 = ___uremdi3(~~+f10 >>> 0 | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 i2 = getTempRet0() | 0;
 switch (i5 | 0) {
 case 2:
  {
   if (!i4) {
    i11 = 0;
    STACKTOP = i8;
    return i11 | 0;
   }
   HEAP32[i4 >> 2] = i1;
   i11 = 0;
   STACKTOP = i8;
   return i11 | 0;
  }
 case 1:
  {
   if (!i4) {
    i11 = 0;
    STACKTOP = i8;
    return i11 | 0;
   }
   HEAP32[i4 >> 2] = ~~((+(i1 >>> 0) + 4294967296.0 * +(i2 >>> 0)) * 1.0e3 / 44100.0) >>> 0;
   i11 = 0;
   STACKTOP = i8;
   return i11 | 0;
  }
 default:
  {
   HEAP32[i6 >> 2] = gb + 868575;
   HEAP32[i6 + 4 >> 2] = 584;
   _printf(gb + 854600 | 0, i6) | 0;
   HEAP32[i7 >> 2] = 37;
   HEAP32[i7 + 4 >> 2] = gb + 868575;
   _printf(gb + 853277 | 0, i7) | 0;
   i11 = 37;
   STACKTOP = i8;
   return i11 | 0;
  }
 }
 return 0;
}

function __ZL26DrawParticlesFromNodeQueueRK15RenderNodeQueuejRK14ChannelAssignsi(i2, i9, i12, i1) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i5 = HEAP32[i2 >> 2] | 0;
 if ((HEAP16[gb + 1469408 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1469408 | 0, HEAP32[i5 + (i9 * 360 | 0) + 352 >> 2] | 0);
  i6 = gb + 1469408 | 0;
 } else i6 = 0;
 i1 = HEAP32[i5 + (i9 * 360 | 0) + 328 >> 2] | 0;
 i2 = HEAP32[i1 + 192 >> 2] | 0;
 if ((HEAP32[i1 + 196 >> 2] | 0) > 0) i4 = HEAP32[i1 + 200 >> 2] | 0; else i4 = 0;
 i7 = __Z12GetGfxDevicev() | 0;
 i8 = __ZN9GfxDevice13GetDynamicVBOEv(i7) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = -1;
 HEAP32[i10 + 12 >> 2] = 0;
 i3 = i1 + 188 | 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, 36, HEAP32[i3 >> 2] << 2 | 0, 0, 2, i10 | 0) | 0) {
  __ZL31ParticleRenderer_FillVertexDataPvRK27LegacyParticleRenderingDataPK8ParticlePK5RectTIfE(HEAP32[i10 >> 2] | 0, i1, i2, i4);
  mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i10 | 0, HEAP32[i3 >> 2] << 2 | 0, 0);
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 104 >> 2] | 0, i7 | 0, gb + 1162292 | 0, 0);
  i1 = HEAP32[i5 + (i9 * 360 | 0) + 188 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 188 >> 2] | 0, i7 | 0, i1 | 0);
  i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0;
  i9 = HEAP32[gb + 1469420 + 4 >> 2] | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
  mftCall_viiiiiii(i5 | 0, i8 | 0, i10 | 0, i12 | 0, i7 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i9, HEAP32[i12 >> 2] | 0, 0) | 0, 0, 0);
  __Z15gpu_time_samplev();
 }
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i11;
 return;
}

function __ZNSt3__23mapIjP25SubstanceRawTextureSharedNS_4lessIjEE13stl_allocatorINS_4pairIKjS2_EEL18MemLabelIdentifier77ELi16EEEixERS7_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i3 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i2 = 10;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  }
 } while (0);
 if ((i2 | 0) == 12) if (i1) {
  i8 = i1;
  i8 = i8 + 20 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 77;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx12storeIndicesEjjPKjRNS_14PxOutputStreamEb(i1, i4, i2, i8, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = i9 + 4 | 0;
 if (i1 >>> 0 < 256) {
  if (!i4) {
   STACKTOP = i9;
   return;
  }
  i1 = 0;
  do {
   HEAP8[i3 >> 0] = HEAP32[i2 + (i1 << 2) >> 2];
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i3 | 0, 1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i9;
  return;
 }
 if (i1 >>> 0 >= 65536) {
  i1 = i4 + -1 | 0;
  if (i4 | 0) {
   i3 = i7 + 3 | 0;
   i4 = i7 + 1 | 0;
   i5 = i7 + 2 | 0;
   if (i6) while (1) {
    i6 = HEAP32[i2 >> 2] | 0;
    HEAP32[i7 >> 2] = i6;
    HEAP8[i7 >> 0] = i6 >>> 24;
    HEAP8[i3 >> 0] = i6;
    HEAP8[i4 >> 0] = i6 >>> 16;
    HEAP8[i5 >> 0] = i6 >>> 8;
    mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 4) | 0;
    if (!i1) break; else {
     i2 = i2 + 4 | 0;
     i1 = i1 + -1 | 0;
    }
   } else while (1) {
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 4) | 0;
    if (!i1) break; else {
     i2 = i2 + 4 | 0;
     i1 = i1 + -1 | 0;
    }
   }
  }
  STACKTOP = i9;
  return;
 }
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i3 = i7 + 1 | 0;
 if (i6) {
  i1 = 0;
  do {
   i6 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i5 = i6 & 65535;
   HEAP16[i7 >> 1] = i5;
   HEAP8[i7 >> 0] = (i5 & 65535) >>> 8;
   HEAP8[i3 >> 0] = i6;
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 2) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i9;
  return;
 } else {
  i1 = 0;
  do {
   HEAP16[i7 >> 1] = HEAP32[i2 + (i1 << 2) >> 2];
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 2) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  STACKTOP = i9;
  return;
 }
}

function __ZN20dynamic_block_vectorI14FileIdentifierE6resizeEj(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i13 = i10 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (i1 >>> 0 < i11 >>> 0) do {
  i1 = __ZN20dynamic_block_vectorI14FileIdentifierE22push_back_no_constructEv(i10) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i1 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i1 = HEAP32[i13 >> 2] | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 if (i1 >>> 0 <= i11 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i8 = i10 + 16 | 0;
 i9 = i12 + 4 | 0;
 i6 = i10 + 28 | 0;
 i7 = i10 + 8 | 0;
 do {
  i4 = i1 + -1 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = (i4 >>> 0) % (i3 >>> 0) | 0;
  i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + (((i4 >>> 0) / (i3 >>> 0) | 0) << 2) >> 2] | 0;
  i5 = i4 + (i2 * 36 | 0) | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i4 + (i2 * 36 | 0) + 12 >> 2] | 0;
   HEAP32[i12 >> 2] = 66;
   HEAP32[i9 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
   i1 = HEAP32[i13 >> 2] | 0;
   i3 = HEAP32[i10 >> 2] | 0;
  }
  i1 = i1 + -1 | 0;
  HEAP32[i13 >> 2] = i1;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((((i1 >>> 0) / (i3 >>> 0) | 0) + 1 | 0) >>> 0 < i2 >>> 0) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0, i7);
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   i1 = HEAP32[i13 >> 2] | 0;
  }
 } while (i1 >>> 0 > i11 >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN20TextRenderingPrivate22ScriptingTextGenerator9InitVertsEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = (i1 << 2) + 4 | 0;
 i7 = HEAP32[gb + 1162364 >> 2] | 0;
 i8 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 i9 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 i10 = HEAP32[gb + 1162356 >> 2] | 0;
 i11 = HEAP32[gb + 1162356 + 4 >> 2] | 0;
 i3 = i4 + 12 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i6 * 60 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 60 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 60 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i4 >> 2] = i2;
  break;
 } while (0);
 if (i6 >>> 0 <= i5 >>> 0) return;
 i3 = (HEAP32[i4 >> 2] | 0) + (i5 * 60 | 0) | 0;
 i2 = i6 - i5 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 * 60 | 0) >> 2] = i7;
  HEAP32[i3 + (i1 * 60 | 0) + 4 >> 2] = i8;
  HEAP32[i3 + (i1 * 60 | 0) + 8 >> 2] = i9;
  HEAP32[i3 + (i1 * 60 | 0) + 12 >> 2] = 0;
  HEAP32[i3 + (i1 * 60 | 0) + 16 >> 2] = 0;
  HEAP32[i3 + (i1 * 60 | 0) + 20 >> 2] = -1082130432;
  HEAP32[i3 + (i1 * 60 | 0) + 24 >> 2] = -1;
  HEAP32[i3 + (i1 * 60 | 0) + 28 >> 2] = i10;
  HEAP32[i3 + (i1 * 60 | 0) + 32 >> 2] = i11;
  HEAP32[i3 + (i1 * 60 | 0) + 36 >> 2] = i10;
  HEAP32[i3 + (i1 * 60 | 0) + 40 >> 2] = i11;
  HEAP32[i3 + (i1 * 60 | 0) + 44 >> 2] = 1065353216;
  HEAP32[i3 + (i1 * 60 | 0) + 48 >> 2] = 0;
  HEAP32[i3 + (i1 * 60 | 0) + 52 >> 2] = 0;
  HEAP32[i3 + (i1 * 60 | 0) + 56 >> 2] = -1082130432;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13MemoryManager16ThreadInitializeEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i6 = i9;
 i1 = i4 + 1549 | 0;
 i2 = i4 + 1551 | 0;
 do if (!(HEAP8[i1 >> 0] | 0)) {
  if (!(HEAP8[i2 >> 0] | 0)) __ZN13MemoryManager27InitializeDefaultAllocatorsEv(i4);
  i3 = HEAP32[gb + 73344 >> 2] | 0;
  i10 = i3 + 544 | 0;
  HEAP32[gb + 73344 >> 2] = i10;
  if (i10 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN12TLSAllocatorI14StackAllocatorEC2EPKc(i3, gb + 582491 | 0);
   HEAP32[i4 + 1552 >> 2] = i3;
   HEAP32[i4 + 3848 >> 2] = i3;
   i11 = i4 + 1544 | 0;
   i10 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i10 + 1;
   HEAP32[i4 + 1568 + (i10 << 2) >> 2] = i3;
   HEAP8[i1 >> 0] = 1;
   HEAP8[i4 + 1550 >> 0] = 1;
   __ZN14MemoryProfiler16StaticInitializeEv();
   break;
  }
 } while (0);
 if (HEAP8[i2 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 i3 = gb + 64024 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i11 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i11;
  if (i11 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i7 = i1;
   break;
  }
 } else i7 = i1; while (0);
 i11 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i7, 56, 16, gb + 63216 | 0, 0, gb + 581974 | 0, 832) | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i3;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14StackAllocatorC2Ej10MemLabelIdPKc(i11, i5, i8, gb + 582491 | 0);
 i10 = HEAP32[i4 + 1552 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 68 >> 2] | 0, i10 | 0, i11 | 0);
 STACKTOP = i9;
 return;
}

function __ZL20HullProjectionCB_BoxRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_(i1, i2, i6, i5, i4, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f16 = Math_fround(HEAPF32[i6 >> 2]);
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(f16 * f18);
 f13 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(f16 + Math_fround(f13 * f17));
 f16 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f16 = Math_fround(f13 + Math_fround(f16 * f8));
 f13 = Math_fround(f18 * Math_fround(HEAPF32[i6 + 12 >> 2]));
 f13 = Math_fround(f13 + Math_fround(f17 * Math_fround(HEAPF32[i6 + 16 >> 2])));
 f13 = Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i6 + 20 >> 2])));
 f10 = Math_fround(f18 * Math_fround(HEAPF32[i6 + 24 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f17 * Math_fround(HEAPF32[i6 + 28 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i6 + 32 >> 2])));
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f14 = Math_fround(-f15);
 i1 = f16 >= Math_fround(0.0);
 f11 = Math_fround(-f12);
 i2 = f13 >= Math_fround(0.0);
 f7 = Math_fround(-f9);
 i5 = f10 >= Math_fround(0.0);
 f18 = Math_fround(f18 * Math_fround(HEAPF32[i6 + 36 >> 2]));
 f17 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i6 + 40 >> 2])));
 f8 = Math_fround(f17 + Math_fround(f8 * Math_fround(HEAPF32[i6 + 44 >> 2])));
 f7 = Math_fround(Math_fround(Math_fround(f16 * (i1 ? f15 : f14)) + Math_fround(f13 * (i2 ? f12 : f11))) + Math_fround(f10 * (i5 ? f9 : f7)));
 HEAPF32[i3 >> 2] = Math_fround(f7 + f8);
 HEAPF32[i4 >> 2] = Math_fround(f8 - f7);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z24BuildHumanAvatarInternalP10GameObjectRK16HumanDescription(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 32 | 0;
 i8 = i5 + 8 | 0;
 i4 = i5 + 16 | 0;
 i7 = i5;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(100, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 929895 | 0, 17) | 0;
 i11 = gb + 63520 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN6AvatarC2E10MemLabelId18ObjectCreationMode(i3, i6, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 i8 = i7;
 HEAP32[i8 >> 2] = 3;
 HEAP32[i8 + 4 >> 2] = 256;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN13AvatarBuilder11BuildAvatarER6AvatarRK10GameObjectRK16HumanDescriptionNS_7OptionsE(i4, i3, i1, i2, i6);
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255) | 0)) {
  i11 = HEAP32[i3 >> 2] | 0;
  i11 = i11 + 12 | 0;
  i11 = HEAP32[i11 >> 2] | 0;
  mftCall_vii(i11 | 0, i3 | 0, 4);
  i11 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i11 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i1 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 929895 | 0, 26, 1, 0, 0, 0);
 i11 = HEAP32[i3 >> 2] | 0;
 i11 = i11 + 12 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 mftCall_vii(i11 | 0, i3 | 0, 4);
 i11 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i5;
 return i11 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim21scheduleCollisionPrepERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 20 | 0;
 i12 = i11 + 16 | 0;
 i9 = i11 + 4 | 0;
 i4 = i11;
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i7 = i10 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i10, i1, i12);
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i8 = i9 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE6resizeEjRKS3_(i9, i12, i4);
 i2 = HEAP32[i2 >> 2] | 0;
 if (i2 | 0) {
  i4 = 0;
  do {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = (HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 372;
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 56 >> 2];
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 i1 = __ZN5physx24PxsParticleSystemBatcher21scheduleCollisionPrepEPPNS_20PxvParticleSystemSimEPPNS_14PxLightCpuTaskEjRNS_10PxBaseTaskE((HEAP32[i6 + 1e3 >> 2] | 0) + 324 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3) | 0;
 i12 = HEAP32[i8 >> 2] | 0;
 if ((i12 | 0) > -1 & (i12 & 2147483647 | 0) != 0) __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 i12 = HEAP32[i7 >> 2] | 0;
 if (!((i12 | 0) > -1 & (i12 & 2147483647 | 0) != 0)) {
  STACKTOP = i11;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i10, HEAP32[i10 >> 2] | 0);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN20QuadTreeNodeRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i1 + 264 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  i9 = -1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = i1 + 268 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i9 = -1;
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN12QuadTreeNode14PrepareBuffersER15TerrainRenderer(i1, i2);
 i8 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i3, i4) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + (i8 * 360 | 0) + 332 >> 2] = fb + 312;
 HEAP32[i5 + (i8 * 360 | 0) + 344 >> 2] = fb + 4154;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 20 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i4 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 20;
 HEAP32[i5 + (i8 * 360 | 0) + 328 >> 2] = i4;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 236 >> 2];
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = i3 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 + 8 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 24 >> 2] | 0) >>> 1;
 i3 = i2 + 232 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __Z26GetMeshVertexFormatManagerv() | 0;
  __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo(i9, i2 + 200 | 0);
  i1 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i1, i9) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i4 >> 2] = i1;
 i9 = i8;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN17BufferManagerGLES13ReleaseBufferEP14DataBufferGLES(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 HEAP32[i4 >> 2] = i3;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i8 = i3;
 if (i1 >>> 0 <= (HEAP32[i2 >> 2] | 0) >>> 0) if ((HEAP32[i2 + 160 >> 2] | 0) >>> 0 < i1 >>> 0) {
  i1 = i9 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i9 + 12 >> 2] | 0)) {
   __ZNSt3__26vectorIP14DataBufferGLESNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9 + 4 | 0, i4);
   STACKTOP = i10;
   return;
  } else {
   HEAP32[i2 >> 2] = i8;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
   STACKTOP = i10;
   return;
  }
 }
 i7 = HEAP32[i3 + 12 >> 2] | 0;
 i6 = i9 + 16 + (i7 * 12 | 0) | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i2 = i9 + 16 + (i7 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i4 = i2;
  i3 = i2;
 } else {
  while (1) if ((i5 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = 6;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 9;
    break;
   } else i1 = i2;
  }
  if ((i2 | 0) == 6) {
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   i4 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 16 + (i7 * 12 | 0) + 4 >> 2] | 0, i1);
 i9 = i9 + 16 + (i7 * 12 | 0) + 8 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 STACKTOP = i10;
 return;
}

function __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i10 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 i11 = i1 + 100 | 0;
 i12 = i9 + 4 | 0;
 i3 = ((HEAP32[i12 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 88 | 0;
 i7 = i1 + 104 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = (i4 - i2 | 0) / 204 | 0;
 if (i3 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i11, i3 - i1 | 0); else if (i3 >>> 0 < i1 >>> 0) {
  i5 = i2 + (i3 * 204 | 0) | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i6 = i8 + 4 | 0;
   i2 = i4;
   do {
    i1 = i2 + -204 | 0;
    HEAP32[i7 >> 2] = i1;
    i3 = i2 + -36 | 0;
    if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
     HEAP32[i3 >> 2] = 0;
    }
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i4 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i2 + -192 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
    }
    i2 = HEAP32[i7 >> 2] | 0;
   } while ((i2 | 0) != (i5 | 0));
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i12 >> 2] | 0) != (i1 | 0)) {
  i2 = 0;
  do {
   __ZN24CompressedAnimationCurve19DecompressQuatCurveERN13AnimationClip15QuaternionCurveE(i1 + (i2 * 88 | 0) | 0, (HEAP32[i11 >> 2] | 0) + (i2 * 204 | 0) | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  } while (i2 >>> 0 < (((HEAP32[i12 >> 2] | 0) - i1 | 0) / 88 | 0) >>> 0);
 }
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i13;
 return;
}

function __Z49UnityConnectSettings_Set_Custom_PropTestConfigUrlP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 32 | 0;
 i4 = i10 + 12 | 0;
 i7 = i10 + 16 | 0;
 i8 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i5 = __Z23GetUnityConnectSettingsv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i4);
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
 i4 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i9 = 4;
 } else if (i4 >>> 0 < 11) {
  i1 = i7 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i7; else {
   i2 = i7;
   i9 = 6;
  }
 } else i9 = 4;
 if ((i9 | 0) == 4) {
  i11 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i1 = i7 + 11 | 0;
  i9 = 6;
 }
 if ((i9 | 0) == 6) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN20UnityConnectSettings16SetTestConfigUrlE8UnityStr(i5, i7);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i4 = HEAP32[i1 + 192 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i1 + 96 >> 2]));
 f10 = Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[i1 + 112 >> 2])));
 f10 = Math_fround(f10 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 128 >> 2])));
 f9 = Math_fround(f12 * Math_fround(HEAPF32[i1 + 100 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f11 * Math_fround(HEAPF32[i1 + 116 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 132 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i1 + 104 >> 2]));
 f11 = Math_fround(f12 + Math_fround(f11 * Math_fround(HEAPF32[i1 + 120 >> 2])));
 f8 = Math_fround(f11 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 136 >> 2])));
 HEAPF32[i3 >> 2] = f10;
 HEAPF32[i3 + 4 >> 2] = f9;
 HEAPF32[i3 + 8 >> 2] = f8;
 i1 = HEAPU8[i4 + 38 >> 0] | 0;
 HEAP32[i3 + 12 >> 2] = i1;
 i5 = HEAPU8[i4 + 39 >> 0] | 0;
 HEAP32[i3 + 16 >> 2] = i5;
 i7 = HEAPU16[i4 + 36 >> 1] | 0;
 HEAP32[i3 + 20 >> 2] = i7;
 i6 = HEAP32[i4 + 40 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = i6;
 i5 = i5 * 20 | 0;
 HEAP32[i3 + 28 >> 2] = i6 + i5;
 HEAP32[i3 + 32 >> 2] = i6 + (i5 + (i1 * 15 | 0) + (i7 << 1));
 HEAP32[i3 + 36 >> 2] = i6 + (i5 + (i1 * 12 | 0));
 HEAP32[i3 + 56 >> 2] = HEAP32[i4 + 44 >> 2];
 i1 = i3 + 40 | 0;
 i4 = i4 + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 60 >> 2] = fb + 3454;
 if (i2) return;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx21PxDistanceJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i9 | 0, i11 | 0, 84, (i1 ? gb + 737704 | 0 : gb + 837976 | 0) | 0, gb + 737828 | 0, 40) | 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i1 + 4 >> 1] = 260;
 HEAP16[i1 + 6 >> 1] = 3;
 i9 = i1 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i8 = i1 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87668 + 8;
 HEAP32[i9 >> 2] = gb + 87668 + 228;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 96, gb + 737916 | 0, 76) | 0;
 HEAP32[i1 + 80 >> 2] = i10;
 __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i1, i10, i2, i4, i3, i5);
 HEAPF32[i10 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 80 >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.0250000004));
 HEAP16[i10 + 92 >> 1] = 2;
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, i2 | 0, i3 | 0, i9 | 0, gb + 87648 | 0, 96) | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 | 0) {
  i11 = i1;
  STACKTOP = i7;
  return i11 | 0;
 }
 if (!i1) {
  i11 = 0;
  STACKTOP = i7;
  return i11 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i11 = 0;
 STACKTOP = i7;
 return i11 | 0;
}

function __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN14BlendShapeData8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 500490 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags(i6, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 426370 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10BlendShapeLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 426377 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 426386 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 24) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 24 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK14SerializedFile22GetAllFileIDsUncheckedEP13dynamic_arrayIxLj8EE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i1 + 36 | 0;
 i2 = ((HEAP32[i10 >> 2] | 0) - (HEAP32[i1 + 32 >> 2] | 0) | 0) / 24 | 0;
 i11 = i9 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i11 >> 2] = i2;
  HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 3, 8, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 8, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 12 >> 2] << 3 | 0) | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i9 >> 2] = i8;
  break;
 } while (0);
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) return;
 i7 = i9 + 12 | 0;
 i8 = i9 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 do {
  i4 = i3;
  i3 = i3 + 1 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i3 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 3, 8, i8, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 8, i8, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i7 >> 2] = i3;
  i2 = i1;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = (HEAP32[i9 >> 2] | 0) + (i4 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (HEAP32[i10 >> 2] | 0));
 return;
}

function __ZN5Unity10HingeJoint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6;
 i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i1, 16, gb + 1048932 | 0, 0, gb + 780659 | 0, 23) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i5, i3, i2);
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 112584 + 8;
 i3 = i5 + 40 | 0;
 i1 = i5 + 52 | 0;
 i2 = i5 + 64 | 0;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP8[i5 + 76 >> 0] = 1;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i5 + 36 >> 0] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i5 + 88 >> 0] = 0;
 HEAP8[i5 + 89 >> 0] = 1;
 HEAPF32[i5 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i5 + 84 >> 2] = Math_fround(inf);
 HEAP32[i5 >> 2] = gb + 112384 + 8;
 HEAPF32[i5 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 108 >> 2] = Math_fround(.200000003);
 i2 = i5 + 156 | 0;
 i1 = i5 + 152 | 0;
 i3 = i5 + 112 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN19ConstantBuffersGLES8UpdateCBEiiPKv(i11, i1, i6, i7) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 12 | 0;
 i10 = i13;
 i5 = i6 << 16 | i1;
 HEAP32[i12 >> 2] = i5;
 i8 = i11 + 12 | 0;
 i9 = i11 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = (HEAP32[i9 >> 2] | 0) - i3 | 0;
 i2 = (i4 | 0) / 12 | 0;
 L1 : do if ((i4 | 0) > 0) {
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L1;
  }
  if (!i7) {
   STACKTOP = i13;
   return;
  }
  _memcpy(HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i3 + (i1 * 12 | 0) + 10 >> 0] = 1;
  STACKTOP = i13;
  return;
 } while (0);
 i1 = __Znaj((i6 | 0) > -1 ? i6 : -1) | 0;
 HEAP32[i10 >> 2] = i1;
 i2 = i10 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP16[i10 + 8 >> 1] = -1;
 HEAP8[i10 + 10 >> 0] = 1;
 if (!i7) _memset(i1 | 0, 0, i6 | 0) | 0; else _memcpy(i1 | 0, i7 | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, i6, 8, 0) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i11 + 20 >> 2] | 0)) __ZNSt3__26vectorIN19ConstantBuffersGLES11ConstBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i10); else {
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
 }
 i1 = i11 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i11 + 8 >> 2] | 0)) __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i11, i12); else {
  HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 >> 2] = i2 + 4;
 }
 STACKTOP = i13;
 return;
}

function __ZN17SurfaceEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 92 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 100 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 104 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 106 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function __Z48UnityConnectSettings_Set_Custom_PropTestEventUrlP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 32 | 0;
 i4 = i10 + 12 | 0;
 i7 = i10 + 16 | 0;
 i8 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i5 = __Z23GetUnityConnectSettingsv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i4);
 i4 = HEAP8[i8 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
 i4 = i1 ? HEAP32[i8 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i9 = 4;
 } else if (i4 >>> 0 < 11) {
  i1 = i7 + 11 | 0;
  HEAP8[i1 >> 0] = i4;
  if (!i4) i2 = i7; else {
   i2 = i7;
   i9 = 6;
  }
 } else i9 = 4;
 if ((i9 | 0) == 4) {
  i11 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i11, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i11 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i1 = i7 + 11 | 0;
  i9 = 6;
 }
 if ((i9 | 0) == 6) _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i2 + i4 >> 0] = 0;
 __ZN20UnityConnectSettings15SetTestEventUrlE8UnityStr(i5, i7);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return;
 }
 i11 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorItNS_9allocatorItEEE6assignIPtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i4, i12, i2) {
 i4 = i4 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i2;
 i6 = i12;
 i5 = i8 - i6 | 0;
 i11 = i5 >> 1;
 i7 = i4 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i9 = i10;
 if (i11 >>> 0 <= i1 - i10 >> 1 >>> 0) {
  i7 = i4 + 4 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) - i10 >> 1;
  i5 = i11 >>> 0 > i4 >>> 0;
  i4 = i5 ? i12 + (i4 << 1) | 0 : i2;
  i3 = i4;
  i1 = i3 - i6 | 0;
  i2 = i1 >> 1;
  if (i2 | 0) _memmove(i10 | 0, i12 | 0, i1 | 0) | 0;
  i2 = i9 + (i2 << 1) | 0;
  if (i5) {
   i1 = i8 - i3 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i7 >> 2] | 0, i4 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i1 >> 1 << 1);
   return;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) return;
   HEAP32[i7 >> 2] = i1 + (~((i1 + -2 - i2 | 0) >>> 1) << 1);
   return;
  }
 }
 i3 = i10;
 if (i10) {
  i1 = i4 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i9 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i10 | 0) >>> 1) << 1);
  __ZdlPv(i3);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i1 = i1 - i2 | 0;
 i1 = i1 >> 1 >>> 0 < 1073741823 ? (i1 >>> 0 < i11 >>> 0 ? i11 : i1) : 2147483647;
 if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1 << 1) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 + (i1 << 1);
 if ((i5 | 0) <= 0) return;
 _memcpy(i2 | 0, i12 | 0, i5 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + (i11 << 1);
 return;
}

function __ZN14ShadowSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i4 = i5;
 __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 i6 = f10 < Math_fround(0.0);
 f7 = Math_fround(-f10);
 f10 = i6 ? f7 : f10;
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i6 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i9 = f11 < Math_fround(0.0);
 f12 = Math_fround(-f11);
 f11 = i9 ? f12 : f11;
 HEAPF32[i3 >> 2] = Math_fround(9.99999974e-06);
 f10 = Math_fround((f10 < f11 ? f11 : f10) * Math_fround(HEAPF32[i2 + 36 >> 2]));
 HEAPF32[i4 >> 2] = f10;
 i9 = f10 > Math_fround(9.99999974e-06);
 HEAP32[i1 >> 2] = HEAP32[(i9 ? i4 : i3) >> 2];
 HEAPF32[i3 >> 2] = Math_fround(9.99999974e-06);
 f7 = Math_fround((i6 ? f8 : f7) * Math_fround(HEAPF32[i2 + 40 >> 2]));
 HEAPF32[i4 >> 2] = f7;
 i6 = f7 > Math_fround(9.99999974e-06);
 HEAP32[i1 + 4 >> 2] = HEAP32[(i6 ? i4 : i3) >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP8[i1 + 24 >> 0] = 99 - (HEAP32[i2 + 100 >> 2] | 0);
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 HEAP8[i1 + 26 >> 0] = i3;
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 96 >> 2];
 i4 = i1 + 25 | 0;
 i3 = (i3 | 0) != 0;
 i1 = i3 & 1;
 HEAP8[i4 >> 0] = i1;
 i2 = HEAP32[i2 + 104 >> 2] | 0;
 if ((i2 & 255) << 24 >> 24) {
  i1 = (i3 & 1 | 2) & 255;
  HEAP8[i4 >> 0] = i1;
 }
 if (i2 & 65280) {
  i1 = (i1 & 255 | 4) & 255;
  HEAP8[i4 >> 0] = i1;
 }
 if (!(i2 & 16711680)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i4 >> 0] = i1 & 255 | 8;
 STACKTOP = i5;
 return;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = i8 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i4 + 164 >> 2] | 0;
    if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i9 = i4 + 56 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 40 | 0;
    i2 = i4 + 48 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 44 | 0;
     i9 = HEAP32[i10 >> 2] | 0;
     HEAP32[i9 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i10 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i10;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i8 + 28 | 0;
 i2 = i8 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i10 = i8 + 32 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i8 + 16 | 0;
 i2 = i8 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i10 = i8 + 20 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNK5physx2Sq10AABBPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE(i7, i6, i8, i4, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 12 | 0;
 i1 = i9;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if (i2 | 0) {
  f13 = Math_fround(HEAPF32[i6 + 132 >> 2]);
  f14 = Math_fround(HEAPF32[i6 + 120 >> 2]);
  f19 = Math_fround(f13 - f14);
  f12 = Math_fround(HEAPF32[i6 + 136 >> 2]);
  f16 = Math_fround(HEAPF32[i6 + 124 >> 2]);
  f18 = Math_fround(f12 - f16);
  f11 = Math_fround(HEAPF32[i6 + 140 >> 2]);
  f15 = Math_fround(HEAPF32[i6 + 128 >> 2]);
  f18 = Math_fround(f18 * Math_fround(.5));
  f17 = Math_fround(Math_fround(f11 - f15) * Math_fround(.5));
  HEAPF32[i3 >> 2] = Math_fround(f19 * Math_fround(.5));
  HEAPF32[i3 + 4 >> 2] = f18;
  HEAPF32[i3 + 8 >> 2] = f17;
  i10 = HEAP32[i7 + 7776 >> 2] | 0;
  f12 = Math_fround(Math_fround(f16 + f12) * Math_fround(.5));
  f11 = Math_fround(Math_fround(f15 + f11) * Math_fround(.5));
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(f14 + f13) * Math_fround(.5));
  HEAPF32[i1 + 4 >> 2] = f12;
  HEAPF32[i1 + 8 >> 2] = f11;
  if (!(__ZN15AABBTreeRaycastILb1EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE(i9 + 24 | 0, i10, i2, i1, i8, i4, i3, i5) | 0)) {
   i10 = 0;
   STACKTOP = i9;
   return i10 | 0;
  }
 }
 if (!(HEAP8[i7 + 7808 >> 0] | 0)) {
  i10 = 1;
  STACKTOP = i9;
  return i10 | 0;
 }
 if (!(HEAP32[i7 + 92 >> 2] | 0)) if (!(HEAP32[i7 + 136 >> 2] | 0)) {
  i10 = 1;
  STACKTOP = i9;
  return i10 | 0;
 }
 i10 = __ZNK5physx2Sq16BucketPrunerCore5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE(i7 + 144 | 0, i6, i8, i4, i5) | 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNK5physx2Gu11HeightField12isConvexEdgeEjjjj(i7, i2, i6, i3, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 if (((HEAP32[i7 + 16 >> 2] | 0) + -2 | 0) >>> 0 < i3 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = HEAP32[i7 + 20 >> 2] | 0;
 if ((i5 + -2 | 0) >>> 0 < i1 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 L7 : do switch ((Math_imul(i6, -3) | 0) + i2 | 0) {
 case 0:
  if (!i3) {
   i7 = 0;
   return i7 | 0;
  } else {
   i3 = i6 - i5 | 0;
   i4 = HEAP32[i7 + 36 >> 2] | 0;
   i1 = (HEAPU8[i4 + (i3 << 2) + 2 >> 0] | 0) >>> 7 & 255 ^ 1;
   i2 = (HEAPU8[i4 + (i6 << 2) + 2 >> 0] | 0) >>> 7 & 255;
   i2 = (HEAP16[i4 + (i1 + i6 << 2) >> 1] | 0) - (HEAP16[i4 + (i1 + i3 << 2) >> 1] | 0) + (HEAP16[i4 + (i2 + i6 << 2) >> 1] | 0) - (HEAP16[i4 + (i5 + i6 + i2 << 2) >> 1] | 0) | 0;
   break L7;
  }
 case 1:
  {
   i8 = HEAP32[i7 + 36 >> 2] | 0;
   i3 = HEAP16[i8 + (i6 << 2) >> 1] | 0;
   i4 = HEAP16[i8 + (i6 + 1 << 2) >> 1] | 0;
   i2 = i5 + i6 | 0;
   i1 = HEAP16[i8 + (i2 << 2) >> 1] | 0;
   i2 = HEAP16[i8 + (i2 + 1 << 2) >> 1] | 0;
   if ((HEAP8[i8 + (i6 << 2) + 2 >> 0] | 0) < 0) {
    i2 = i3 - i4 - i1 + i2 | 0;
    break L7;
   } else {
    i2 = i4 - i3 + i1 - i2 | 0;
    break L7;
   }
  }
 case 2:
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  } else {
   i4 = i6 + -1 | 0;
   i8 = HEAP32[i7 + 36 >> 2] | 0;
   i3 = (HEAP8[i8 + (i4 << 2) + 2 >> 0] | 0) < 0 ? 0 : i5;
   i2 = ((HEAP8[i8 + (i6 << 2) + 2 >> 0] | 0) < 0 ? i5 : 0) + i6 | 0;
   i2 = (HEAP16[i8 + (i3 + i6 << 2) >> 1] | 0) - (HEAP16[i8 + (i3 + i4 << 2) >> 1] | 0) + (HEAP16[i8 + (i2 << 2) >> 1] | 0) - (HEAP16[i8 + (i2 + 1 << 2) >> 1] | 0) | 0;
   break L7;
  }
 default:
  i2 = 0;
 } while (0);
 i1 = ~~Math_fround(HEAPF32[i7 + 44 >> 2]);
 if (!(Math_fround(HEAPF32[i7 + 40 >> 2]) <= Math_fround(0.0))) {
  i8 = (i2 | 0) < (0 - i1 | 0);
  return i8 | 0;
 } else {
  i8 = (i2 | 0) > (i1 | 0);
  return i8 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i13, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i13 >>> 0) __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i13);
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + (i13 * 56 | 0) | 0;
 if ((i1 | 0) >= (i13 | 0)) {
  HEAP32[i10 >> 2] = i13;
  return;
 }
 i2 = i12 + 24 | 0;
 i3 = i12 + 28 | 0;
 i4 = i12 + 32 | 0;
 i5 = i12 + 36 | 0;
 i6 = i12 + 40 | 0;
 i7 = i12 + 44 | 0;
 i8 = i12 + 48 | 0;
 i1 = i9 + (i1 * 56 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i12 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i12 + 20 >> 2];
  i1 = i1 + 56 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 HEAP32[i10 >> 2] = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferentialNWDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __Z30NavMesh_CUSTOM_GetAreaFromNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 40 | 0;
 i4 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i5 = __Z25GetNavMeshProjectSettingsv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i4);
 i4 = HEAP8[i9 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i9 >> 2] | 0 : i9;
 i4 = i1 ? HEAP32[i9 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __ZNK22NavMeshProjectSettings15GetAreaFromNameERK8UnityStr(i5, i8) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i10, i8) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 72 | 0;
 i9 = i11;
 __ZN8GradientC2Ev(i9);
 i4 = HEAP32[i10 + 20 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[i3 + 4 >> 2] | 0, gb + 1033990 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_(i9, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!(HEAP8[i4 + 128 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i3 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i10 + 4 | 0;
 i7 = i10 + 12 | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i10 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i7 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i8 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
 i4 = i4 + 32 | 0;
 i2 = i9 + 32 | 0;
 i3 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i10 >> 0] | 0) == 0 ? i9 + -8 + (HEAP32[i7 >> 2] | 0) | 0 : i9) >> 2] = i1;
 STACKTOP = i11;
 return;
}

function _next_marker(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i7 + 24 >> 2] | 0;
 i9 = i8 + 4 | 0;
 i6 = i8 + 12 | 0;
 i10 = i7 + 404 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L1 : while (1) {
  if (!i1) {
   if (!((mftCall_ii(HEAP32[i6 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
    i1 = 0;
    i3 = 19;
    break;
   }
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
  } else i3 = i2;
  i1 = i1 + -1 | 0;
  i2 = i3 + 1 | 0;
  if ((HEAP8[i3 >> 0] | 0) != -1) do {
   i5 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i1;
   if (!i1) {
    if (!((mftCall_ii(HEAP32[i6 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     i3 = 19;
     break L1;
    }
    i1 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   } else i3 = i2;
   i1 = i1 + -1 | 0;
   i2 = i3 + 1 | 0;
  } while ((HEAP8[i3 >> 0] | 0) != -1);
  do {
   if (!i1) {
    if (!((mftCall_ii(HEAP32[i6 >> 2] | 0, i7 | 0) | 0) << 24 >> 24)) {
     i1 = 0;
     i3 = 19;
     break L1;
    }
    i1 = HEAP32[i9 >> 2] | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   } else i3 = i2;
   i1 = i1 + -1 | 0;
   i2 = i3 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while (i4 << 24 >> 24 == -1);
  i3 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  if (i4 << 24 >> 24) {
   i3 = 16;
   break;
  }
  HEAP32[i3 >> 2] = i5 + 2;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 if ((i3 | 0) == 16) {
  i3 = i4 & 255;
  if (i5 | 0) {
   i6 = HEAP32[i7 >> 2] | 0;
   HEAP32[i6 + 20 >> 2] = 116;
   HEAP32[i6 + 24 >> 2] = i5;
   HEAP32[i6 + 28 >> 2] = i3;
   mftCall_vii(HEAP32[i6 + 4 >> 2] | 0, i7 | 0, -1);
   HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] = 0;
  }
  HEAP32[i7 + 380 >> 2] = i3;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i10 = 1;
  return i10 | 0;
 } else if ((i3 | 0) == 19) return i1 | 0;
 return 0;
}

function __ZN6b2Rope7SolveC2Ev(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, f21 = f0, f22 = f0;
 i19 = HEAP32[i1 >> 2] | 0;
 i16 = i19 + -1 | 0;
 if ((i19 | 0) <= 1) return;
 i17 = i1 + 4 | 0;
 i18 = i1 + 16 | 0;
 i19 = i1 + 40 | 0;
 i14 = i1 + 20 | 0;
 i1 = 0;
 do {
  i20 = HEAP32[i17 >> 2] | 0;
  i15 = i20 + (i1 << 3) | 0;
  f10 = Math_fround(HEAPF32[i15 >> 2]);
  i9 = i20 + (i1 << 3) + 4 | 0;
  f11 = Math_fround(HEAPF32[i9 >> 2]);
  i8 = i1;
  i1 = i1 + 1 | 0;
  f12 = Math_fround(HEAPF32[i20 + (i1 << 3) >> 2]);
  f13 = Math_fround(HEAPF32[i20 + (i1 << 3) + 4 >> 2]);
  f3 = Math_fround(f12 - f10);
  f4 = Math_fround(f13 - f11);
  f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4))));
  if (f2 < Math_fround(1.1920929e-07)) f2 = Math_fround(0.0); else {
   f7 = Math_fround(Math_fround(1.0) / f2);
   f3 = Math_fround(f3 * f7);
   f4 = Math_fround(f4 * f7);
  }
  i20 = HEAP32[i18 >> 2] | 0;
  f5 = Math_fround(HEAPF32[i20 + (i8 << 2) >> 2]);
  f6 = Math_fround(HEAPF32[i20 + (i1 << 2) >> 2]);
  f7 = Math_fround(f5 + f6);
  if (!(f7 == Math_fround(0.0))) {
   f22 = Math_fround(f5 / f7);
   f21 = Math_fround(f6 / f7);
   f5 = Math_fround(HEAPF32[i19 >> 2]);
   f7 = Math_fround(f22 * f5);
   f6 = Math_fround(Math_fround(HEAPF32[(HEAP32[i14 >> 2] | 0) + (i8 << 2) >> 2]) - f2);
   f7 = Math_fround(f7 * f6);
   f11 = Math_fround(f11 - Math_fround(f4 * f7));
   f6 = Math_fround(Math_fround(f21 * f5) * f6);
   f12 = Math_fround(f12 + Math_fround(f3 * f6));
   f13 = Math_fround(f13 + Math_fround(f4 * f6));
   HEAPF32[i15 >> 2] = Math_fround(f10 - Math_fround(f3 * f7));
   HEAPF32[i9 >> 2] = f11;
   i20 = HEAP32[i17 >> 2] | 0;
   HEAPF32[i20 + (i1 << 3) >> 2] = f12;
   HEAPF32[i20 + (i1 << 3) + 4 >> 2] = f13;
  }
 } while ((i1 | 0) != (i16 | 0));
 return;
}

function __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i8, i1, i9, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i11 >> 2] = 0;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i4 - i2 | 0;
 i6 = i5 >> 5;
 if (i6 | 0) {
  if (i6 >>> 0 > 134217727) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
  }
  i7 = __Znwj(i5) | 0;
  HEAP32[i12 >> 2] = i7;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 8 >> 2] = i7 + (i6 << 5);
  if ((i2 | 0) != (i4 | 0)) {
   i5 = ((i4 + -32 - i2 | 0) >>> 5) + 1 | 0;
   i1 = i7;
   i3 = i7;
   while (1) {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
    i6 = i1 + 16 | 0;
    i1 = i2 + 16 | 0;
    HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    i2 = i2 + 32 | 0;
    i3 = i3 + 32 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i3;
   }
   HEAP32[i12 >> 2] = i7 + (i5 << 5);
  }
 }
 HEAP32[i8 + 8 >> 2] = __ZN19SpriteMeshGenerator12path_segment12max_distanceENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii(i8, i11, i9, i10) | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i12 >> 2] = i2 + (~((i2 + -32 - i1 | 0) >>> 5) << 5);
 __ZdlPv(i1);
 STACKTOP = i13;
 return;
}

function __ZN13RenderTexture13ApplySettingsEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i4 = i12 + 4 | 0;
 i10 = i12;
 i11 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 148 >> 2] | 0, i6 | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 112 >> 2] | 0, i6 | 0) | 0;
 i2 = i6 + 96 | 0;
 if (__Z15IsDepthRTFormat19RenderTextureFormat(HEAP32[i2 >> 2] | 0) | 0) i1 = 4; else if (!(HEAP8[i6 + 156 >> 0] | 0)) {
  if (HEAP8[i6 + 119 >> 0] | 0) i1 = 4;
 } else i1 = 4;
 if ((i1 | 0) == 4) HEAP32[i6 + 36 >> 2] = 0;
 i7 = i6 + 32 | 0;
 __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE19RenderTextureFormat(i7, HEAP32[i2 >> 2] | 0);
 HEAP32[i4 >> 2] = HEAP32[i6 + 48 >> 2];
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i2 = HEAP32[i6 + 60 >> 2] | 0; else i2 = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 120 >> 2] | 0, i6 | 0) | 0;
 i5 = i6 + 80 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!(i3 + -1 & i3)) {
  i3 = HEAP32[i6 + 84 >> 2] | 0;
  i3 = (i3 + -1 & i3 | 0) != 0;
 } else i3 = 1;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i8, i11, i9, i2, i1, i3);
 if (!(HEAP8[i6 + 156 >> 0] | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = HEAP32[i6 + 124 >> 2];
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i3 = HEAP32[i6 + 60 >> 2] | 0; else i3 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 120 >> 2] | 0, i6 | 0) | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 if (!(i5 + -1 & i5)) {
  i1 = HEAP32[i6 + 84 >> 2] | 0;
  i1 = (i1 + -1 & i1 | 0) != 0;
 } else i1 = 1;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i8, i11, i9, i3, i2, i1);
 STACKTOP = i12;
 return;
}

function __Z32PolygonCollider2D_CUSTOM_SetPathP12Il2CppObjectiP11Il2CppArray(i9, i8, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 8 | 0;
 i3 = i11;
 i10 = i11 + 12 | 0;
 if ((i8 | 0) < 0) {
  HEAP32[i1 >> 2] = i8;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 808387 | 0, i1);
 }
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 HEAP32[i10 >> 2] = 0;
 i4 = i10 + 12 | 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i12 = i3;
 i3 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i1 = i5 + (i1 << 3) - i5 | 0;
 i2 = i1 >> 3;
 HEAP32[i4 >> 2] = i2;
 if (!i2) {
  i2 = 0;
  i1 = 0;
 } else {
  HEAP32[i7 >> 2] = i2;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i2;
  i1 = HEAP32[i4 >> 2] << 3;
 }
 _memcpy(i2 | 0, i5 | 0, i1 | 0) | 0;
 if (!i9) {
  i12 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) {
  i12 = i9;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 __ZN9Polygon2D7SetPathEiRK13dynamic_arrayI8Vector2fLj4EE(i1 + 160 | 0, i8, i10);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i9) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 __ZN17PolygonCollider2D11RefreshPolyEv(i1);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim13ValueConstantEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 12 | 0;
 i7 = i5;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, i2, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 HEAP32[i8 >> 2] = 0;
 i7 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = 10;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 899043 | 0, i8, 0);
 i6 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 910040 | 0, i6, i8, 0);
 i2 = i4 + 16 | 0;
 i3 = i4 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 913271 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 899057 | 0, i6, i1, 0);
 HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i8 + (i2 * 40 | 0) + 4 >> 2] | 0;
 i9 = HEAP32[i8 + (i2 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i5 + (i4 * 40 | 0) >> 2] = HEAP32[i8 + (i2 * 40 | 0) >> 2];
 HEAP32[i5 + (i4 * 40 | 0) + 4 >> 2] = i6;
 HEAP32[i5 + (i4 * 40 | 0) + 8 >> 2] = i9;
 i9 = HEAP32[i8 + (i2 * 40 | 0) + 16 >> 2] | 0;
 i6 = HEAP32[i8 + (i2 * 40 | 0) + 20 >> 2] | 0;
 i7 = HEAP32[i8 + (i2 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i5 + (i4 * 40 | 0) + 12 >> 2] = HEAP32[i8 + (i2 * 40 | 0) + 12 >> 2];
 HEAP32[i5 + (i4 * 40 | 0) + 16 >> 2] = i9;
 HEAP32[i5 + (i4 * 40 | 0) + 20 >> 2] = i6;
 HEAP32[i5 + (i4 * 40 | 0) + 24 >> 2] = i7;
 i7 = HEAP32[i8 + (i2 * 40 | 0) + 32 >> 2] | 0;
 i6 = HEAP32[i8 + (i2 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i5 + (i4 * 40 | 0) + 28 >> 2] = HEAP32[i8 + (i2 * 40 | 0) + 28 >> 2];
 HEAP32[i5 + (i4 * 40 | 0) + 32 >> 2] = i7;
 HEAP32[i5 + (i4 * 40 | 0) + 36 >> 2] = i6;
 HEAP32[(HEAP32[i3 + 64 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (i2 << 2) >> 2];
 HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 2) >> 2];
 HEAP32[(HEAP32[i3 + 24 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + (i2 << 2) >> 2];
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = 1 << (i4 & 31);
 if (!(HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31))) {
  i9 = i5 + (i4 >>> 5 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~i6;
  i9 = i3 + 28 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 0;
  return;
 } else {
  i9 = i5 + (i4 >>> 5 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i6;
  i9 = i3 + 28 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i9 = i9 + i4 | 0;
  HEAP8[i9 >> 0] = 0;
  return;
 }
}

function __Z27QuadTreeNodeRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi(i2, i5, i9, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 32 | 0;
 i7 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP16[gb + 1467172 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1467172 | 0, HEAP32[i1 + (i5 * 360 | 0) + 352 >> 2] | 0);
  i2 = gb + 1467172 | 0;
 } else i2 = 0;
 i3 = HEAP32[i1 + (i5 * 360 | 0) + 328 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[i1 + (i5 * 360 | 0) + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 188 >> 2] | 0, i4 | 0, i1 | 0);
 i13 = HEAP32[i3 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i13 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 8 >> 2];
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 1;
 i5 = i6 + 40 | 0;
 HEAP32[i5 >> 2] = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i13, i12, 0) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 289;
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 16 >> 2];
 __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj(i4, i6, i7, HEAP32[i9 >> 2] | 0, i11);
 mftCall_viiiiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 244 >> 2] | 0, i4 | 0, HEAP32[i6 >> 2] | 0, i10 | 0, HEAP32[i1 >> 2] | 0, i7 | 0, 1, HEAP32[i5 >> 2] | 0, i9 | 0);
 __Z15gpu_time_samplev();
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return;
}

function __ZNK8Animator20IsAnyRendererVisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 i2 = HEAP32[i1 + 428 >> 2] | 0;
 i4 = HEAP32[i1 + 440 >> 2] | 0;
 i5 = i2 + (i4 << 2) | 0;
 if (!i4) {
  i8 = 4;
  i8 = (i8 | 0) != 4;
  STACKTOP = i9;
  return i8 | 0;
 }
 L4 : while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i8 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i3 = HEAP32[i6 >> 2] | 0;
     i10 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i8 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i8 = 11;
    }
   }
   if ((i8 | 0) == 9) i8 = 11;
   if ((i8 | 0) == 11) {
    i8 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
   }
  }
  if ((HEAP32[i1 + 284 >> 2] | 0) == -1) i1 = 6; else i1 = (__ZNK8Renderer16IsVisibleInSceneEv(i1) | 0) & 1;
  switch (i1 & 7) {
  case 6:
  case 0:
   break;
  default:
   {
    i8 = 17;
    break L4;
   }
  }
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (i5 | 0)) {
   i1 = 4;
   i8 = 17;
   break;
  }
 }
 if ((i8 | 0) == 17) {
  i10 = (i1 | 0) != 4;
  STACKTOP = i9;
  return i10 | 0;
 }
 return 0;
}

function __ZN18CrashReportManager15ThreadedCleanupEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = HEAP32[i2 + 18524 >> 2] | 0;
 if (!i3) {
  __ZN18CrashReportManager12CloseServiceEv(i10);
  return;
 } else i1 = 0;
 while (1) {
  if ((HEAP32[i2 + 17756 + (i1 * 12 | 0) >> 2] | 0) == (fb + 167 | 0)) {
   if (!(HEAP8[i2 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0)) break;
   if (!(HEAP32[i2 + 17756 + (i1 * 12 | 0) + 4 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i9 = 13;
   break;
  }
 }
 if ((i9 | 0) == 13) {
  __ZN18CrashReportManager12CloseServiceEv(i10);
  return;
 }
 i5 = __ZN15GlobalCallbacks3GetEv() | 0;
 i6 = i5 + 18524 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  __ZN18CrashReportManager12CloseServiceEv(i10);
  return;
 } else i1 = 0;
 while (1) {
  i3 = i5 + 17756 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 167 | 0)) {
   i8 = i5 + 17756 + (i1 * 12 | 0) + 8 | 0;
   i7 = i5 + 17756 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i8 >> 0] | 0)) break;
   if (!(HEAP32[i7 >> 2] | 0)) break;
  }
  i4 = i1 + 1 | 0;
  if (i4 >>> 0 < i2 >>> 0) i1 = i4; else {
   i9 = 13;
   break;
  }
 }
 if ((i9 | 0) == 13) {
  __ZN18CrashReportManager12CloseServiceEv(i10);
  return;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP8[i8 >> 0] = 0;
 i9 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i9;
 if (i9 >>> 0 <= i1 >>> 0) {
  __ZN18CrashReportManager12CloseServiceEv(i10);
  return;
 }
 do {
  i9 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i5 + 17756 + (i9 * 12 | 0) >> 2] = HEAP32[i5 + 17756 + (i1 * 12 | 0) >> 2];
  HEAP32[i5 + 17756 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i5 + 17756 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i5 + 17756 + (i9 * 12 | 0) + 8 >> 0] = HEAP8[i5 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 __ZN18CrashReportManager12CloseServiceEv(i10);
 return;
}

function __ZN17SurfaceEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903494 | 0, i5, i1 + 92 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803088 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803105 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803118 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803136 | 0, i5, i1 + 105 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803150 | 0, i5, i1 + 106 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i9 = i7 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i7 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 32 >> 2] = i3;
 HEAP8[i7 + 40 >> 0] = i2 & 1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i6 = i7 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i5;
 if (i5 - i1 >> 2 >>> 0 < 4) {
  i4 = (HEAP32[i10 >> 2] | 0) - i1 >> 2;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i3;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i4 = i2 + (i4 << 2) | 0;
  i2 = i2 + 16 | 0;
  i3 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
  i5 = i4 + (0 - (i3 >> 2) << 2) | 0;
  if ((i3 | 0) > 0) {
   _memcpy(i5 | 0, i1 | 0, i3 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i5;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i6 >> 2] = i2;
  if (i1) {
   i2 = HEAP32[i7 + 32 >> 2] | 0;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i8 + 4 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 }
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZNSt3__26vectorI17TransferMetaFlags13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i8);
  i10 = i7 + 36 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = i1 + 4;
  i10 = i7 + 36 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
}

function _UNITY_ft_create_default_module_classes(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 4 | 0;
 i3 = i7;
 i4 = HEAP32[i1 + 188 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = _UNITY_ft_mem_alloc(i5, 32, i2) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 i6 = _UNITY_FT_Create_Class_tt_driver_class(i1, i3) | 0;
 HEAP32[i2 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i6 = _UNITY_FT_Create_Class_cff_driver_class(i1, i3) | 0;
  HEAP32[i2 >> 2] = i6;
  if (!i6) {
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 >> 2];
   i6 = _UNITY_FT_Create_Class_psnames_module_class(i1, i3) | 0;
   HEAP32[i2 >> 2] = i6;
   if (!i6) {
    HEAP32[i5 + 8 >> 2] = HEAP32[i3 >> 2];
    i6 = _UNITY_FT_Create_Class_pshinter_module_class(i1, i3) | 0;
    HEAP32[i2 >> 2] = i6;
    if (!i6) {
     HEAP32[i5 + 12 >> 2] = HEAP32[i3 >> 2];
     i6 = _UNITY_FT_Create_Class_ft_raster1_renderer_class(i1, i3) | 0;
     HEAP32[i2 >> 2] = i6;
     if (!i6) {
      HEAP32[i5 + 16 >> 2] = HEAP32[i3 >> 2];
      i6 = _UNITY_FT_Create_Class_sfnt_module_class(i1, i3) | 0;
      HEAP32[i2 >> 2] = i6;
      if (!i6) {
       HEAP32[i5 + 20 >> 2] = HEAP32[i3 >> 2];
       i6 = _UNITY_FT_Create_Class_ft_smooth_renderer_class(i1, i3) | 0;
       HEAP32[i2 >> 2] = i6;
       if (!i6) {
        HEAP32[i5 + 24 >> 2] = HEAP32[i3 >> 2];
        HEAP32[i4 >> 2] = i5;
        i6 = 0;
        STACKTOP = i7;
        return i6 | 0;
       }
      }
     }
    }
   }
  }
 }
 _UNITY_ft_destroy_default_module_classes(i1);
 i6 = HEAP32[i2 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9HumanBoneC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i6 + 11 >> 0] = 0;
 HEAP8[i6 >> 0] = 0;
 i1 = i6 + 16 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i9 = i5 << 24 >> 24 < 0;
 i4 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
 i5 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 28 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i6 + 28 >> 2] | 0;
  i7 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (i5) i7 = 6;
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i10 = i5 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i6 + 24 >> 2] = i10 | -2147483648;
  HEAP32[i6 + 20 >> 2] = i5;
  i1 = i9;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 i7 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i6 + 32 >> 2] = i7;
 i9 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i6 + 36 >> 2] = i9;
 i10 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = i7;
 HEAP32[i6 + 48 >> 2] = i9;
 HEAP32[i6 + 52 >> 2] = i10;
 HEAP32[i6 + 56 >> 2] = i7;
 HEAP32[i6 + 60 >> 2] = i9;
 HEAP32[i6 + 64 >> 2] = i10;
 HEAPF32[i6 + 68 >> 2] = Math_fround(0.0);
 HEAP8[i6 + 72 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc15ArticulationSim10sleepCheckEffb(i5, f8, f9, i1) {
 i5 = i5 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f6 = f0, f7 = f0, i10 = 0, i11 = 0, f12 = f0;
 if (!(HEAP32[i5 + 28 >> 2] | 0)) return;
 i11 = i5 + 24 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 if (!(HEAP8[(HEAP32[i4 >> 2] | 0) + 51 >> 0] & 1)) return;
 i10 = i5 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 i5 = i5 + 16 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf(i1, Math_fround(0.0)); else {
  i1 = 0;
  f3 = Math_fround(0.0);
  f2 = Math_fround(3402823469999999843913219.0e14);
  while (1) {
   f12 = Math_fround(__ZN5physx2Sc7BodySim17updateWakeCounterEffffb(HEAP32[i4 + (i1 << 2) >> 2] | 0, f8, f6, f7, f9, 0));
   f3 = f3 > f12 ? f3 : f12;
   f2 = f2 < f12 ? f2 : f12;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) break;
   i4 = HEAP32[i11 >> 2] | 0;
  }
  __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf(HEAP32[i10 >> 2] | 0, f3);
  if (f3 != Math_fround(0.0)) {
   if (!(f2 == Math_fround(0.0))) return;
   if (!(HEAP32[i5 >> 2] | 0)) return; else i1 = 0;
   do {
    i10 = HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 52 >> 2] | 0;
    f12 = Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i10));
    i4 = f12 < Math_fround(9.99999997e-07);
    HEAPF32[i10 + 152 >> 2] = i4 ? Math_fround(9.99999997e-07) : f12;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
   return;
  }
 }
 if (!(HEAP32[i5 >> 2] | 0)) return; else i1 = 0;
 do {
  __ZN5physx2Sc7BodySim22notifyReadyForSleepingEv(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  __ZN5physx2Sc7BodySim16resetSleepFilterEv(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 3) | 0, 0, i5 - i4 << 3 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 4 | 0, i9);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZL29GeomMTDCallback_SphereCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i9 = i7;
 f18 = Math_fround(HEAPF32[i6 >> 2]);
 f15 = Math_fround(f18 * Math_fround(2.0));
 f12 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f13 = Math_fround(f12 * Math_fround(2.0));
 f12 = Math_fround(Math_fround(f18 * f15) + Math_fround(Math_fround(f12 * f13) + Math_fround(-1.0)));
 f18 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f11 = Math_fround(f18 * f13);
 f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f15 * f10));
 f10 = Math_fround(Math_fround(f15 * f18) - Math_fround(f13 * f10));
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f13 * f12);
 f11 = Math_fround(f13 * f11);
 f10 = Math_fround(f13 * f10);
 f13 = Math_fround(HEAPF32[i6 + 16 >> 2]);
 f18 = Math_fround(f13 + f12);
 f15 = Math_fround(HEAPF32[i6 + 20 >> 2]);
 f17 = Math_fround(f15 + f11);
 f14 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 f16 = Math_fround(f10 + f14);
 HEAPF32[i8 >> 2] = f18;
 HEAPF32[i8 + 4 >> 2] = f17;
 HEAPF32[i8 + 8 >> 2] = f16;
 f11 = Math_fround(f15 - f11);
 f10 = Math_fround(f14 - f10);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f13 - f12);
 HEAPF32[i8 + 16 >> 2] = f11;
 HEAPF32[i8 + 20 >> 2] = f10;
 HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 4 >> 2];
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 12 >> 2] = i6;
 i6 = __ZN5physx2Gu24computeMTD_SphereCapsuleERNS_6PxVec3ERfRKNS0_6SphereERKNS0_7CapsuleE(i4, i1, i9, i8) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__23mapIiP15MonoScriptCacheNS_4lessIiEE13stl_allocatorINS_4pairIKiS2_EEL18MemLabelIdentifier76ELi16EEEixERS7_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i3 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i2 = 10;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  }
 } while (0);
 if ((i2 | 0) == 12) if (i1) {
  i8 = i1;
  i8 = i8 + 20 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 76;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN20SpeedTreeWindManager8TickWindER18SpeedTreeWindTimesRP18SpeedTreeLocalWindRK4AABBRK18SpeedTreeWindAsset(i6, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, f7 = f0;
 i4 = __ZN20SpeedTreeWindManager7GetWindERK4AABBRP18SpeedTreeLocalWindRK18SpeedTreeWindAsset(i6, i4, i3, i5) | 0;
 if (!i4) {
  i3 = i2 + 44 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  return i4 | 0;
 }
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(HEAPF32[i6 + 52 >> 2]);
 if (!(f7 != f1)) return i4 | 0;
 HEAPF32[i2 >> 2] = f1;
 i6 = i2 + 4 | 0;
 f7 = Math_fround(HEAPF32[i4 + 1548 >> 2]);
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1552 >> 2]);
 i6 = i2 + 8 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1556 >> 2]);
 i6 = i2 + 12 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1560 >> 2]);
 i6 = i2 + 16 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1564 >> 2]);
 i6 = i2 + 20 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1568 >> 2]);
 i6 = i2 + 24 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1572 >> 2]);
 i6 = i2 + 28 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1576 >> 2]);
 i6 = i2 + 32 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1580 >> 2]);
 i6 = i2 + 36 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 1584 >> 2]);
 i6 = i2 + 40 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i6 >> 2]));
 return i4 | 0;
}

function __ZN16MemoryFileSystem5CloseER13FileEntryData(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 if ((HEAP16[gb + 1179032 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179032 | 0, i5);
  i7 = gb + 1179032 | 0;
 } else i7 = 0;
 i2 = i1 + 1052 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i1 + 1056 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i4, i1, i6);
  i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i4 + 4 | 0, i6) | 0;
  if ((i1 | 0) == (i4 + 8 | 0)) i2 = 0; else i2 = HEAP32[i1 + 32 >> 2] | 0;
  if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
   i4 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = 54;
   HEAP32[i5 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
  }
  do if (i2 | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) break;
   HEAP32[i2 + 12 >> 2] = 8;
  } while (0);
 }
 if (!i7) {
  STACKTOP = i8;
  return 1;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i8;
 return 1;
}

function __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 40 | 0, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 40 | 0, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 * 40 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i6 = i3 + (i1 * 40 | 0) | 0;
  i7 = i3 + (i1 * 40 | 0) + 20 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function _UNITY_png_handle_sBIT(i10, i11, i3) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i1 = HEAP32[i10 + 204 >> 2] | 0;
 if (!(i1 & 1)) _UNITY_png_chunk_error(i10, gb + 352205 | 0);
 if (i1 & 6 | 0) {
  _UNITY_png_crc_finish(i10, i3) | 0;
  _UNITY_png_chunk_benign_error(i10, gb + 352423 | 0);
  STACKTOP = i12;
  return;
 }
 if (i11 | 0) if (HEAP32[i11 + 8 >> 2] & 2 | 0) {
  _UNITY_png_crc_finish(i10, i3) | 0;
  _UNITY_png_chunk_benign_error(i10, gb + 352436 | 0);
  STACKTOP = i12;
  return;
 }
 i7 = i10 + 431 | 0;
 if ((HEAP8[i7 >> 0] | 0) == 3) {
  i2 = 8;
  i1 = 3;
 } else {
  i2 = HEAP8[i10 + 432 >> 0] | 0;
  i1 = HEAPU8[i10 + 435 >> 0] | 0;
 }
 if (i3 >>> 0 > 4 | (i1 | 0) != (i3 | 0)) {
  _UNITY_png_chunk_benign_error(i10, gb + 352446 | 0);
  _UNITY_png_crc_finish(i10, i3) | 0;
  STACKTOP = i12;
  return;
 }
 i6 = i4 + 3 | 0;
 i8 = i4 + 2 | 0;
 i9 = i4 + 1 | 0;
 _memset(i4 | 0, i2 | 0, 4) | 0;
 _UNITY_png_read_data(i10, i4, i3);
 _UNITY_png_calculate_crc(i10, i4, i3);
 if (_UNITY_png_crc_finish(i10, 0) | 0) {
  STACKTOP = i12;
  return;
 }
 L23 : do if (i3 | 0) {
  i1 = 0;
  while (1) {
   if (((HEAP8[i4 + i1 >> 0] | 0) + -1 & 255) >= (i2 & 255)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L23;
  }
  _UNITY_png_chunk_benign_error(i10, gb + 352446 | 0);
  STACKTOP = i12;
  return;
 } while (0);
 i4 = HEAP8[i4 >> 0] | 0;
 i5 = i10 + 512 | 0;
 if (!(HEAP8[i7 >> 0] & 2)) {
  HEAP8[i10 + 515 >> 0] = i4;
  i3 = HEAP8[i9 >> 0] | 0;
  i2 = i4;
  i1 = i4;
 } else {
  i3 = HEAP8[i6 >> 0] | 0;
  i2 = HEAP8[i8 >> 0] | 0;
  i1 = HEAP8[i9 >> 0] | 0;
 }
 HEAP8[i5 >> 0] = i4;
 HEAP8[i10 + 513 >> 0] = i1;
 HEAP8[i10 + 514 >> 0] = i2;
 HEAP8[i10 + 516 >> 0] = i3;
 _UNITY_png_set_sBIT(i10, i11, i5);
 STACKTOP = i12;
 return;
}

function _UNITY_png_colorspace_set_sRGB(i4, i6, i5) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, i7 = 0;
 i7 = i6 + 74 | 0;
 i1 = HEAP16[i7 >> 1] | 0;
 i2 = i1 & 65535;
 if (i2 & 32768 | 0) {
  i7 = 0;
  return i7 | 0;
 }
 if (i5 >>> 0 > 3) {
  _UNITY_png_icc_profile_error(i4, i6, gb + 470258 | 0, i5, gb + 351091 | 0);
  i7 = 0;
  return i7 | 0;
 }
 if (i2 & 4) {
  i1 = HEAP32[i6 + 72 >> 2] | 0;
  if ((i1 & 65535 | 0) == (i5 | 0)) i1 = i1 >>> 16 & 65535; else {
   _UNITY_png_icc_profile_error(i4, i6, gb + 470258 | 0, i5, gb + 351121 | 0);
   i7 = 0;
   return i7 | 0;
  }
 }
 i2 = i1 & 65535;
 if (i2 & 32 | 0) {
  _UNITY_png_benign_error(i4, gb + 351152 | 0);
  i7 = 0;
  return i7 | 0;
 }
 if (i2 & 2) if (!(_UNITY_png_colorspace_endpoints_match(gb + 14376 | 0, i6 + 4 | 0, 100) | 0)) {
  _UNITY_png_chunk_report(i4, gb + 351187 | 0, 2);
  i1 = HEAP16[i7 >> 1] | 0;
 }
 do if (i1 & 1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) {
   d3 = +Math_floor(+(+(i2 | 0) * 1.0e5 / 45455.0 + .5));
   if (d3 <= 2147483647.0 & d3 >= -2147483648.0) if ((~~d3 + -95e3 | 0) >>> 0 <= 1e4) break;
  }
  _UNITY_png_chunk_report(i4, gb + 350925 | 0, 2);
  i1 = HEAP16[i7 >> 1] | 0;
 } while (0);
 HEAP16[i6 + 72 >> 1] = i5;
 i1 = i1 & 65535;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 14376 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 14376 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 14376 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[gb + 14376 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[gb + 14376 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[gb + 14376 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[gb + 14376 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[gb + 14376 + 28 >> 2];
 i2 = i6 + 36 | 0;
 i4 = gb + 14408 | 0;
 i5 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i2 = i2 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP32[i6 >> 2] = 45455;
 HEAP16[i7 >> 1] = i1 | 231;
 i7 = 1;
 return i7 | 0;
}

function _UNITY_FT_MulDiv_No_Round(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i1 >> 31 | 1;
 i4 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i1 = (i2 | 0) < 0;
 i7 = i1 ? 0 - i7 | 0 : i7;
 i1 = i1 ? 0 - i2 | 0 : i2;
 i5 = (i3 | 0) < 0;
 i6 = i5 ? 0 - i3 | 0 : i3;
 i7 = i5 ? 0 - i7 | 0 : i7;
 if (!i6) {
  i6 = 2147483647;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 if ((i1 + i4 | 0) >>> 0 < 131072) {
  i6 = ((Math_imul(i1, i4) | 0) >>> 0) / (i6 >>> 0) | 0;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 i3 = i4 & 65535;
 i2 = i4 >>> 16;
 i9 = i1 & 65535;
 i8 = i1 >>> 16;
 i5 = Math_imul(i9, i2) | 0;
 i4 = (Math_imul(i8, i3) | 0) + i5 | 0;
 i1 = i4 << 16;
 i3 = i1 + (Math_imul(i9, i3) | 0) | 0;
 i1 = (i4 >>> 16) + (Math_imul(i8, i2) | 0) + ((i4 >>> 0 < i5 >>> 0 & 1) << 16) + (i3 >>> 0 < i1 >>> 0 & 1) | 0;
 if (!i1) {
  i9 = (i3 >>> 0) / (i6 >>> 0) | 0;
  i7 = (i7 | 0) < 0;
  i8 = 0 - i9 | 0;
  i9 = i7 ? i8 : i9;
  return i9 | 0;
 }
 if (i1 >>> 0 >= i6 >>> 0) {
  i9 = 2147483647;
  i7 = (i7 | 0) < 0;
  i8 = 0 - i9 | 0;
  i9 = i7 ? i8 : i9;
  return i9 | 0;
 }
 i9 = i1 >>> 0 > 65535;
 i4 = i9 ? i1 >>> 16 : i1;
 i9 = i9 ? 16 : 0;
 i5 = (i4 & 65280 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 8;
 i9 = i5 ? i9 : i9 | 8;
 i5 = (i4 & 240 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 4;
 i9 = i5 ? i9 : i9 | 4;
 i5 = (i4 & 12 | 0) == 0;
 i4 = 31 - (i5 ? i9 : i9 | 2) - ((i5 ? i4 : i4 >>> 2) >>> 1 & 1) | 0;
 i5 = 32 - i4 | 0;
 i9 = i3 >>> i5 | i1 << i4;
 i2 = (i9 >>> 0) / (i6 >>> 0) | 0;
 i1 = i2;
 i2 = i9 - (Math_imul(i2, i6) | 0) | 0;
 i4 = i3 << i4;
 while (1) {
  i2 = i2 << 1 | i4 >>> 31;
  i3 = i2 >>> 0 < i6 >>> 0;
  i1 = (i3 & 1 | i1 << 1) ^ 1;
  i5 = i5 + -1 | 0;
  if (!i5) break; else {
   i2 = i2 - (i3 ? 0 : i6) | 0;
   i4 = i4 << 1;
  }
 }
 i8 = (i7 | 0) < 0;
 i9 = 0 - i1 | 0;
 i9 = i8 ? i9 : i1;
 return i9 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 i1 = 1 - i1 | 0;
 i15 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f10 = Math_fround(HEAPF32[i15 + (i1 << 4) >> 2]);
 f12 = Math_fround(HEAPF32[i15 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + (i1 << 4) + 8 >> 2]);
 i1 = HEAP32[i15 + (i1 << 4) + 12 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i15 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Gu37generateCapsuleBoxFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb(i5, i11, i8, i4, i7, i10, i6, i9, i2) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2) if (!(__ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE(i5, i11, i8, i6, i12 + 16 | 0, i9) | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 f15 = Math_fround(HEAPF32[i9 >> 2]);
 f14 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f14 = Math_fround(-f14);
 f13 = Math_fround(-Math_fround(HEAPF32[i9 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(-f15);
 HEAPF32[i1 + 4 >> 2] = f14;
 HEAPF32[i1 + 8 >> 2] = f13;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 i1 = __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE(i11, i8, i1) | 0;
 i1 = (HEAP32[i11 + 24 >> 2] | 0) + (i1 * 20 | 0) | 0;
 __ZN5physx2Gu31generatedCapsuleBoxFaceContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE(i5, i11, i1, i8, i4, i7, i10, i6, i9);
 if (((HEAP32[i10 >> 2] | 0) - i3 | 0) >>> 0 >= 2) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 __ZN5physx2Gu27generatedContactsEEContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE(i5, i11, i1, i8, i4, i7, i10, i6, i9);
 i11 = 1;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN16StreamedResource8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i8) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i10 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i10 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i11 = i8 + 16 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i8 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i10 >> 2] | 0 : i10;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i7 = i1;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i2;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 8);
  i4 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i10 + 24 | 0;
 i2 = i4 + 8 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i8 = i1;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i4;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
  HEAP32[i11 >> 2] = i2;
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 8);
  STACKTOP = i12;
  return;
 }
}

function __ZL20CopyNodesIntoJobGapsP29RenderNodeQueuePrepareContext(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 200 | 0;
 i2 = i13 + 192 | 0;
 i3 = i13;
 _memcpy(i3 | 0, i12 + 1312 | 0, 192) | 0;
 i11 = HEAP32[i12 + 20 >> 2] | 0;
 if (i11 | 0) {
  i1 = 0;
  do {
   HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = (HEAP32[i12 + 24 + (i1 * 80 | 0) + 4 >> 2] | 0) - (HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i11 | 0));
 }
 i9 = HEAP32[HEAP32[i12 >> 2] >> 2] | 0;
 if ((HEAP16[gb + 1162184 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162184 | 0, i10);
  i8 = gb + 1162184 | 0;
 } else i8 = 0;
 _memcpy(i10 | 0, i3 | 0, 192) | 0;
 i5 = i11 + -1 | 0;
 if (i5 | 0) {
  i3 = 0;
  do {
   i4 = i3;
   i3 = i3 + 1 | 0;
   i6 = HEAP32[i10 + (i3 * 12 | 0) >> 2] | 0;
   i7 = i10 + (i4 * 12 | 0) + 4 | 0;
   i1 = (HEAP32[i7 >> 2] | 0) + (HEAP32[i10 + (i4 * 12 | 0) >> 2] | 0) | 0;
   L11 : do if (i1 >>> 0 < i6 >>> 0) do {
    i2 = __ZN18BlockRangeInternal16PopLastNodeIndexEP10BlockRangeji(i10, i11, i4) | 0;
    if ((i2 | 0) == -1) break L11;
    _memcpy(i9 + (i1 * 360 | 0) | 0, i9 + (i2 * 360 | 0) | 0, 360) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i6 >>> 0); while (0);
  } while ((i3 | 0) != (i5 | 0));
 }
 i1 = __ZN18BlockRangeInternal25GetSizeFromLastBlockRangeEP10BlockRangej(i10, i11) | 0;
 if (!i8) {
  i12 = HEAP32[i12 >> 2] | 0;
  i12 = i12 + 32804 | 0;
  HEAP32[i12 >> 2] = i1;
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = i12 + 32804 | 0;
 HEAP32[i12 >> 2] = i1;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __Z53Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfP11Il2CppArrayiff(i1, i2, i3, f4, i10, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i10 = i10 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i12 + 8 | 0;
 i13 = i12;
 i11 = i12 + 16 | 0;
 i17 = gb + 64016 | 0;
 i9 = HEAP32[i17 + 4 >> 2] | 0;
 i8 = i13;
 HEAP32[i8 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 i8 = i11 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i17 = i14;
 i16 = HEAP32[i17 + 4 >> 2] | 0;
 i15 = i9;
 HEAP32[i15 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i15 + 4 >> 2] = i16;
 i15 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = __ZN16Physics2DManager17OverlapCapsuleAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DP13dynamic_arrayIPS5_Lj4EE(i15, i14, i13, i3, f4, i5, f6, f7, 0, i11) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i10) | 0;
 i2 = i5 >>> 0 < i2 >>> 0 ? i5 : i2;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i10, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i9);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return i2 | 0;
}

function __Z24dtDistancePtPolyEdgesSqrPKfS0_iPfS1_(i13, i14, i15, i16, i17) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i18 = 0, i19 = 0;
 if ((i15 | 0) <= 0) {
  i18 = 0;
  return i18 | 0;
 }
 i18 = i13 + 8 | 0;
 i11 = i15 + -1 | 0;
 i1 = 0;
 i12 = 0;
 while (1) {
  i5 = i14 + (i12 * 3 << 2) | 0;
  i3 = i14 + (i11 * 3 << 2) | 0;
  f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f9 = Math_fround(HEAPF32[i18 >> 2]);
  f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  if (f7 > f9 ^ f10 > f9) {
   f6 = Math_fround(HEAPF32[i13 >> 2]);
   f4 = Math_fround(HEAPF32[i3 >> 2]);
   f2 = Math_fround(HEAPF32[i5 >> 2]);
   if (f6 < Math_fround(f2 + Math_fround(Math_fround(Math_fround(f9 - f7) * Math_fround(f4 - f2)) / Math_fround(f10 - f7)))) i1 = i1 ^ 1;
  } else {
   f2 = Math_fround(HEAPF32[i5 >> 2]);
   f4 = Math_fround(HEAPF32[i3 >> 2]);
   f6 = Math_fround(HEAPF32[i13 >> 2]);
  }
  i3 = i17 + (i11 << 2) | 0;
  f8 = Math_fround(f2 - f4);
  f7 = Math_fround(f7 - f10);
  f6 = Math_fround(f6 - f4);
  f2 = Math_fround(f9 - f10);
  f4 = Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7));
  if (f4 == Math_fround(0.0)) {
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   f2 = Math_fround(Math_fround(f6 * f6) + Math_fround(f2 * f2));
  } else {
   f9 = Math_fround(Math_fround(Math_fround(f8 * f6) + Math_fround(f7 * f2)) / f4);
   i5 = f9 < Math_fround(0.0);
   i19 = f9 > Math_fround(1.0);
   f9 = i19 ? Math_fround(1.0) : f9;
   f9 = i5 ? Math_fround(0.0) : f9;
   f10 = Math_fround(Math_fround(f8 * f9) - f6);
   f2 = Math_fround(Math_fround(f7 * f9) - f2);
   HEAPF32[i3 >> 2] = f9;
   f2 = Math_fround(Math_fround(f10 * f10) + Math_fround(f2 * f2));
  }
  HEAPF32[i16 + (i11 << 2) >> 2] = f2;
  i3 = i12 + 1 | 0;
  if ((i3 | 0) == (i15 | 0)) break; else {
   i11 = i12;
   i12 = i3;
  }
 }
 return i1 | 0;
}

function __Z10DestripifyPKtiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i12, i11, i9) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0;
 i10 = i9 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = i4 - i1 | 0;
 i13 = i11 + -2 | 0;
 i8 = 0;
 i2 = 0;
 L1 : while (1) {
  while (1) {
   if ((i2 | 0) >= (i13 | 0)) break L1;
   i3 = HEAP16[i12 + (i2 << 1) >> 1] | 0;
   i5 = i2 + 1 | 0;
   i6 = HEAP16[i12 + (i5 << 1) >> 1] | 0;
   if (i3 << 16 >> 16 == i6 << 16 >> 16) i2 = i5; else break;
  }
  i2 = HEAP16[i12 + (i2 + 2 << 1) >> 1] | 0;
  i8 = ((i3 << 16 >> 16 == i2 << 16 >> 16 ? 1 : i6 << 16 >> 16 == i2 << 16 >> 16) & 1 ^ 1) + i8 | 0;
  i2 = i5;
 }
 i5 = i7 >> 2;
 i2 = i8 * 3 | 0;
 i3 = i2 + i5 | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i2);
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i3 >>> 0 < i5 >>> 0) {
  i2 = i1 + (i3 << 2) | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i10 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 }
 i7 = i1 + (i5 << 2) | 0;
 if ((i11 | 0) <= 2) return;
 i6 = 0;
 i1 = 0;
 i2 = HEAP16[i12 >> 1] | 0;
 L17 : while (1) {
  i4 = i2;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = HEAP16[i12 + (i3 << 1) >> 1] | 0;
   if (i4 << 16 >> 16 != i2 << 16 >> 16) {
    i5 = HEAP16[i12 + (i1 + 2 << 1) >> 1] | 0;
    if (!(i4 << 16 >> 16 == i5 << 16 >> 16 ? 1 : i2 << 16 >> 16 == i5 << 16 >> 16)) break;
   }
   if ((i3 | 0) < (i13 | 0)) {
    i1 = i3;
    i4 = i2;
   } else {
    i1 = 18;
    break L17;
   }
  }
  i11 = (i1 & 1 | 0) == 0;
  HEAP32[i7 + (i6 << 2) >> 2] = (i11 ? i4 : i2) & 65535;
  HEAP32[i7 + (i6 + 1 << 2) >> 2] = (i11 ? i2 : i4) & 65535;
  HEAP32[i7 + (i6 + 2 << 2) >> 2] = i5 & 65535;
  if ((i3 | 0) < (i13 | 0)) {
   i6 = i6 + 3 | 0;
   i1 = i3;
  } else {
   i1 = 18;
   break;
  }
 }
 if ((i1 | 0) == 18) return;
}

function __ZNSt3__218__insertion_sort_3IR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14 + 12 | 0;
 i13 = i14;
 i2 = i10 + 8 | 0;
 __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_(i10, i10 + 4 | 0, i2, i1) | 0;
 i1 = i10 + 12 | 0;
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i14;
  return;
 }
 i9 = i12 + 8 | 0;
 i6 = i13 + 8 | 0;
 i7 = i12 + 8 | 0;
 i8 = i13 + 8 | 0;
 i5 = i1;
 i1 = i2;
 while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  __ZNK9Transform11GetPositionEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f15 = Math_fround(HEAPF32[i9 >> 2]);
  __ZNK9Transform11GetPositionEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  if (f15 < Math_fround(HEAPF32[i6 >> 2])) {
   i3 = HEAP32[i5 >> 2] | 0;
   i4 = i3 + 28 | 0;
   i2 = i5;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    if ((i1 | 0) == (i10 | 0)) break;
    i2 = i1 + -4 | 0;
    i16 = HEAP32[i2 >> 2] | 0;
    __ZNK9Transform11GetPositionEv(i12, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 >> 2] | 0, gb + 28940 | 0) | 0);
    f15 = Math_fround(HEAPF32[i7 >> 2]);
    __ZNK9Transform11GetPositionEv(i13, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i16 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
    if (f15 < Math_fround(HEAPF32[i8 >> 2])) {
     i16 = i1;
     i1 = i2;
     i2 = i16;
    } else break;
   }
   HEAP32[i1 >> 2] = i3;
  }
  i1 = i5 + 4 | 0;
  if ((i1 | 0) == (i11 | 0)) break; else {
   i16 = i5;
   i5 = i1;
   i1 = i16;
  }
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx17PxStringTableImpl11allocateStrEPKc(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i9 = i10 + 4 | 0;
 i6 = (i1 | 0) == 0 ? gb + 1576256 | 0 : i1;
 i4 = HEAP32[i8 + 32 >> 2] | 0;
 L1 : do if (i4 | 0) {
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i8 + 24 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i8 + 16 >> 2] | 0;
   i4 = i8 + 20 | 0;
   while (1) {
    i3 = i5 + (i1 << 3) | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!(_strcmp(i2, i6) | 0)) break;
    i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i3 | 0) {
    i9 = i5 + (i1 << 3) + 4 | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i9 = i2;
    STACKTOP = i10;
    return i9 | 0;
   }
  }
 } while (0);
 i1 = (_strlen(i6) | 0) + 1 | 0;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, gb + 745343 | 0, gb + 745255 | 0, 57) | 0;
 do if (!((i1 | 0) == 0 | (i3 | 0) == 0)) {
  i2 = _strlen(i6) | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   _memcpy(i3 | 0, i6 | 0, i2 | 0) | 0;
   HEAP8[i3 + i2 >> 0] = 0;
   break;
  } else {
   HEAP8[i3 >> 0] = 0;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i3;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb(i8 + 8 | 0, i7, i9) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = 1;
 }
 i9 = i3;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN16MemoryFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, _strlen(i1) | 0);
 __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i3, i1, i5);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i3 + 4 | 0, i5) | 0;
 if ((i1 | 0) == (i3 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i5 + 11 >> 0] | 0) >= 0) {
  i5 = (i1 | 0) != 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 54;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 i5 = (i1 | 0) != 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z19CreateNullGfxDevicev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 __ZN12GraphicsCaps8InitNullEv(__Z15GetGraphicsCapsv() | 0);
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4912, gb + 63304 | 0, 32, gb + 612287 | 0, gb + 1576256 | 0, gb + 612090 | 0, 80) | 0;
 __ZN9GfxDeviceC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 77628 + 8;
 __ZN9GfxDevice15InvalidateStateEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 620 >> 2] | 0, i1 | 0);
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4616 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4680 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4744 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4808 | 0) | 0;
 i2 = i1 + 4908 | 0;
 i3 = i1 + 4872 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 + 4388 >> 2] = 4;
 HEAPF32[i1 + 4372 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4368 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 4392 >> 2] = -1;
 HEAP32[gb + 1451360 >> 2] = 0;
 HEAP32[gb + 1451360 + 4 >> 2] = 0;
 HEAP32[gb + 1451360 + 8 >> 2] = 0;
 HEAP32[gb + 1451360 + 12 >> 2] = 0;
 HEAP32[gb + 1451360 + 16 >> 2] = 0;
 HEAP32[gb + 1451360 + 20 >> 2] = 0;
 HEAP32[gb + 1451360 + 24 >> 2] = 0;
 HEAP32[gb + 1451360 + 28 >> 2] = 0;
 HEAP32[gb + 1451360 + 16 >> 2] = 1;
 HEAP32[gb + 1451360 + 24 >> 2] = 2;
 HEAP8[gb + 1451360 + 30 >> 0] = 1;
 HEAP8[gb + 1451360 + 31 >> 0] = 1;
 HEAP32[i1 + 4400 >> 2] = gb + 1451360;
 HEAP32[gb + 1451392 >> 2] = 0;
 HEAP32[gb + 1451392 + 4 >> 2] = 0;
 HEAP32[gb + 1451392 + 8 >> 2] = 0;
 HEAP32[gb + 1451392 + 12 >> 2] = 0;
 HEAP32[gb + 1451392 + 16 >> 2] = 0;
 HEAP32[gb + 1451392 + 20 >> 2] = 0;
 HEAP32[gb + 1451392 + 24 >> 2] = 0;
 HEAP32[gb + 1451392 + 28 >> 2] = 0;
 HEAP32[gb + 1451392 + 16 >> 2] = 1;
 HEAP32[gb + 1451392 + 24 >> 2] = 2;
 HEAP8[gb + 1451392 + 30 >> 0] = 0;
 HEAP8[gb + 1451392 + 31 >> 0] = 1;
 HEAP32[i1 + 4404 >> 2] = gb + 1451392;
 __Z19pop_allocation_rootv();
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorINS2_12basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES7_ISA_LS8_1ELi16EEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i8 - i1 >> 4;
 HEAP32[i4 >> 2] = i5;
 i9 = i13 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i13 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i7 = i1 + 4 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = i4;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i4 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  i4 = i2 + i7 | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __GLOBAL__sub_I_runtime_ai_internal_crowd_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459272 | 0, gb + 843279 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459284 | 0, gb + 843302 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459296 | 0, gb + 843320 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459308 | 0, gb + 843343 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459320 | 0, gb + 843367 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459332 | 0, gb + 843381 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459344 | 0, gb + 843400 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459356 | 0, gb + 843420 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459368 | 0, gb + 843435 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459380 | 0, gb + 843451 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459392 | 0, gb + 843467 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459404 | 0, gb + 843483 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459416 | 0, gb + 843498 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459428 | 0, gb + 843523 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459440 | 0, gb + 843549 | 0, 5, 0);
 return;
}

function _UNITY_png_set_gamma(i9, d1, d2) {
 i9 = i9 | 0;
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 d1 = +Math_floor(+((d1 > 0.0 & d1 < 128.0 ? d1 * 1.0e5 : d1) + .5));
 if (d1 > 2147483647.0 | d1 < -2147483647.0) _UNITY_png_fixed_error(i9, gb + 354019 | 0);
 i4 = ~~d1;
 d1 = +Math_floor(+((d2 > 0.0 & d2 < 128.0 ? d2 * 1.0e5 : d2) + .5));
 if (d1 > 2147483647.0 | d1 < -2147483647.0) _UNITY_png_fixed_error(i9, gb + 354019 | 0);
 i6 = ~~d1;
 if (!i9) return;
 i7 = i9 + 208 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (i5 & 64 | 0) {
  _UNITY_png_app_error(i9, gb + 353836 | 0);
  return;
 }
 i3 = i5 | 16384;
 HEAP32[i7 >> 2] = i3;
 L14 : do if ((i4 | 0) < -2) if ((i4 | 0) < -5e4) switch (i4 | 0) {
 case -1e5:
  {
   i10 = 9;
   break L14;
  }
 default:
  break L14;
 } else switch (i4 | 0) {
 case -5e4:
  {
   i10 = 10;
   break L14;
  }
 default:
  break L14;
 } else switch (i4 | 0) {
 case -1:
  {
   i10 = 9;
   break;
  }
 case -2:
  {
   i10 = 10;
   break;
  }
 default:
  {}
 } while (0);
 if ((i10 | 0) == 9) {
  i3 = i5 | 20480;
  HEAP32[i7 >> 2] = i3;
  i4 = 22e4;
 } else if ((i10 | 0) == 10) i4 = 151724;
 L24 : do if ((i6 | 0) < -2) if ((i6 | 0) < -5e4) switch (i6 | 0) {
 case -1e5:
  {
   i10 = 12;
   break L24;
  }
 default:
  {
   i10 = 13;
   break L24;
  }
 } else switch (i6 | 0) {
 case -5e4:
  {
   i8 = 65909;
   break L24;
  }
 default:
  {
   i10 = 13;
   break L24;
  }
 } else switch (i6 | 0) {
 case -1:
  {
   i10 = 12;
   break;
  }
 case -2:
  {
   i8 = 65909;
   break;
  }
 default:
  i10 = 13;
 } while (0);
 if ((i10 | 0) == 12) {
  HEAP32[i7 >> 2] = i3 | 4096;
  i8 = 45455;
 } else if ((i10 | 0) == 13) if ((i6 | 0) < 1) _UNITY_png_error(i9, gb + 354031 | 0); else i8 = i6;
 if ((i4 | 0) < 1) _UNITY_png_error(i9, gb + 354067 | 0);
 HEAP32[i9 + 680 >> 2] = i8;
 i10 = i9 + 754 | 0;
 HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 0 | 1;
 HEAP32[i9 + 484 >> 2] = i4;
 return;
}

function __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i3 = i2 + 4 | 0;
 i4 = i2 + 8 | 0;
 i9 = i6 + 40 | 0;
 i10 = i9;
 i1 = 1;
 do {
  i5 = HEAP32[i6 + 72 + (i1 << 2) >> 2] | 0;
  if ((i5 | 0) != -1) {
   i12 = HEAP32[i7 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) >> 2] << 2) >> 2] | 0;
   i13 = HEAP32[i7 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) + 4 >> 2] << 2) >> 2] & 0 - (15106022 >>> i1 & 1);
   HEAP32[i2 >> 2] = HEAP32[i7 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2] & 0 - (124830 >>> i1 & 1);
   HEAP32[i3 >> 2] = i13;
   HEAP32[i4 >> 2] = i12;
   i12 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei((i12 | 0) == 0 ? 0 : i12 + i10 | 0, i8, i2, i5);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i1 = HEAP16[i6 + 392 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i13 = i6 + 48 | 0;
  i12 = HEAP32[i13 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  __ZN7mecanim4hand17Hand2SkeletonPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS0_8HandPoseEPNS4_13SkeletonPoseTIN4math4trsXEEE((i12 | 0) == 0 ? 0 : i12 + i13 | 0, (i1 | 0) == 0 ? 0 : i1 + i10 | 0, i7 + 324 | 0, i8);
  i1 = HEAP8[i6 + 393 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i11;
  return;
 }
 i12 = i6 + 52 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 i13 = HEAP32[i9 >> 2] | 0;
 __ZN7mecanim4hand17Hand2SkeletonPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS0_8HandPoseEPNS4_13SkeletonPoseTIN4math4trsXEEE((i6 | 0) == 0 ? 0 : i6 + i12 | 0, (i13 | 0) == 0 ? 0 : i13 + i10 | 0, i7 + 460 | 0, i8);
 STACKTOP = i11;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_110DataStream19bufferPropertyValueEN5physx8debugger24ClassDescriptionSizeInfoENS2_7DataRefIKhEE(i15, i4, i1, i16) {
 i15 = i15 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i14 = i16 + 4 | 0;
 i5 = HEAP32[i16 >> 2] | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i3 = i5;
 i12 = ((i2 - i3 | 0) >>> 0) / (i11 >>> 0) | 0;
 i13 = i1 + 16 | 0;
 i10 = i1 + 12 | 0;
 if ((HEAP32[i13 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
  i16 = i3;
  i14 = i2;
  HEAP32[i15 >> 2] = i16;
  i16 = i15 + 4 | 0;
  HEAP32[i16 >> 2] = i14;
  return;
 }
 i8 = i4 + 356 | 0;
 i9 = i4 + 368 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = i4 + 372 | 0;
 HEAP32[i7 >> 2] = i1;
 if (!i12) i2 = i1; else {
  i1 = 0;
  while (1) {
   i6 = Math_imul(i1, i11) | 0;
   __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(i8, i5 + i6 | 0, i11);
   i3 = HEAP32[i13 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i4 = 0;
    do {
     if ((HEAP32[i2 + (i4 << 3) >> 2] | 0) != 1) {
      i3 = i5 + ((HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0) + i6) | 0;
      i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
      i3 = i3 | 0 ? i3 : gb + 1576256 | 0;
      __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j(i8, i3, (_strlen(i3) | 0) + 1 | 0);
      i3 = HEAP32[i13 >> 2] | 0;
      i2 = HEAP32[i10 >> 2] | 0;
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i3 - i2 >> 3 >>> 0);
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i12 >>> 0) break;
   i5 = HEAP32[i16 >> 2] | 0;
  }
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i13 = i2;
 i12 = i1;
 HEAP32[i16 >> 2] = i12;
 HEAP32[i14 >> 2] = i13;
 i16 = i12;
 i14 = i13;
 HEAP32[i15 >> 2] = i16;
 i16 = i15 + 4 | 0;
 HEAP32[i16 >> 2] = i14;
 return;
}

function _start_pass_huff(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i7 + 348 >> 2] | 0;
 i1 = i1 << 24 >> 24 != 0;
 HEAP32[i8 + 4 >> 2] = i1 ? fb + 502 | 0 : fb + 503 | 0;
 HEAP32[i8 + 8 >> 2] = i1 ? fb + 3266 | 0 : fb + 3267 | 0;
 i6 = i7 + 228 | 0;
 L1 : do if ((HEAP32[i6 >> 2] | 0) > 0) {
  i5 = i7 + 4 | 0;
  if (i1) i4 = 0; else {
   i1 = 0;
   while (1) {
    i5 = HEAP32[i7 + 232 + (i1 << 2) >> 2] | 0;
    i4 = HEAP32[i5 + 20 >> 2] | 0;
    i5 = HEAP32[i5 + 24 >> 2] | 0;
    _jpeg_make_c_derived_tbl(i7, 1, i4, i8 + 44 + (i4 << 2) | 0);
    _jpeg_make_c_derived_tbl(i7, 0, i5, i8 + 60 + (i5 << 2) | 0);
    HEAP32[i8 + 20 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (HEAP32[i6 >> 2] | 0)) break L1;
   }
  }
  do {
   i3 = HEAP32[i7 + 232 + (i4 << 2) >> 2] | 0;
   i1 = HEAP32[i3 + 20 >> 2] | 0;
   i3 = HEAP32[i3 + 24 >> 2] | 0;
   if (i1 >>> 0 > 3) {
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 50;
    HEAP32[i2 + 24 >> 2] = i1;
    mftCall_vi(HEAP32[i2 >> 2] | 0, i7 | 0);
   }
   if (i3 >>> 0 > 3) {
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i2 + 20 >> 2] = 50;
    HEAP32[i2 + 24 >> 2] = i3;
    mftCall_vi(HEAP32[i2 >> 2] | 0, i7 | 0);
   }
   i2 = i8 + 76 + (i1 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i7 | 0, 1, 1028) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   _memset(i1 | 0, 0, 1028) | 0;
   i2 = i8 + 92 + (i3 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i7 | 0, 1, 1028) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   _memset(i1 | 0, 0, 1028) | 0;
   HEAP32[i8 + 20 + (i4 << 2) >> 2] = 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
 } while (0);
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 36 >> 2] = HEAP32[i7 + 188 >> 2];
 HEAP32[i8 + 40 >> 2] = 0;
 return;
}

function _cff_get_advances(i3, i11, i12, i9, i13) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i14 + 2 | 0;
 i5 = i14;
 i10 = HEAP32[i3 + 84 >> 2] | 0;
 do if (HEAP32[i3 + 8 >> 2] & 8 | 0) {
  if (!(i9 & 16)) {
   if (!(HEAP16[i3 + 216 + 34 >> 1] | 0)) break;
   if (i12 | 0) {
    i2 = i3 + 532 | 0;
    i1 = 0;
    do {
     mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, 0, i1 + i11 | 0, i4 | 0, i5 | 0);
     HEAP32[i13 + (i1 << 2) >> 2] = HEAPU16[i5 >> 1];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i12 | 0));
   }
  } else {
   if (!(HEAP8[i3 + 292 >> 0] | 0)) break;
   if (i12 | 0) {
    i2 = i3 + 532 | 0;
    i1 = 0;
    do {
     mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, 1, i1 + i11 | 0, i4 | 0, i5 | 0);
     HEAP32[i13 + (i1 << 2) >> 2] = HEAPU16[i5 >> 1];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i12 | 0));
   }
  }
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 i7 = i3 + 88 | 0;
 if (!i12) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i6 = (i9 & 16 | 0) == 0 ? i10 + 56 | 0 : i10 + 60 | 0;
 i8 = i10 + 4 | 0;
 if (!i10) {
  i13 = 37;
  STACKTOP = i14;
  return i13 | 0;
 } else i5 = 0;
 while (1) {
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i5 + i11 | 0;
  i1 = ((i3 | 0) == 0 ? 259 : 256) | i9;
  i2 = (i1 & 1 | 0) == 0 ? i3 : 0;
  if (i2 | 0) if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) {
   i1 = 35;
   i2 = 20;
   break;
  }
  i1 = _cff_slot_load(i10, i2, i4, i1) | 0;
  if (i1 | 0) {
   i2 = 20;
   break;
  }
  HEAP32[i13 + (i5 << 2) >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i12 >>> 0) {
   i1 = 0;
   i2 = 20;
   break;
  }
 }
 if ((i2 | 0) == 20) {
  STACKTOP = i14;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE13computeBoundsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15 + 200 | 0;
 i19 = i15 + 184 | 0;
 i12 = i15 + 168 | 0;
 i18 = i15 + 164 | 0;
 i17 = i15 + 160 | 0;
 i14 = i15 + 144 | 0;
 i10 = i15 + 128 | 0;
 i5 = i15 + 112 | 0;
 i6 = i15 + 96 | 0;
 i7 = i15 + 80 | 0;
 i8 = i15 + 64 | 0;
 i9 = i15 + 32 | 0;
 i13 = i15;
 i4 = i1 + 432 | 0;
 i16 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i16 + 8 >> 2] | 0;
 i1 = HEAP32[i16 + 4 >> 2] | 0;
 i16 = HEAP32[i16 >> 2] | 0;
 i3 = i1 + (i16 << 4) | 0;
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i19, gb + 1097664 | 0);
 __ZngRK8Scalar4f(i11, i19);
 HEAPF32[i18 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i17 >> 2] = __Z6simd4fRKf(i18) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i12, i17);
 __ZngRK8Scalar4f(i14, i12);
 if ((i16 | 0) > 0) while (1) {
  __ZN8Scalar4fC2ERKS_(i10, i1);
  __Z3minRK8Scalar4fS1_(i5, i12, i10);
  __ZN8Scalar4faSERKS_(i12, i5) | 0;
  __Z3maxRK8Scalar4fS1_(i6, i14, i10);
  __ZN8Scalar4faSERKS_(i14, i6) | 0;
  __ZgtRK8Scalar4fS1_(i8, i10, i11);
  __Z6selectRK8Scalar4fS1_S1_(i7, i8, i2, i10);
  __ZN8Scalar4faSERKS_(i1, i7) | 0;
  i1 = i1 + 16 | 0;
  if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
 }
 __ZN8Scalar4faSERKS_(i9, i12) | 0;
 __ZN8Scalar4faSERKS_(i9 + 16 | 0, i14) | 0;
 __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf(i13, (HEAP32[i4 >> 2] | 0) + 12 | 0);
 __ZN12_GLOBAL__N_111storeBoundsI8Scalar4fEEvPfRKN5physx5cloth11BoundingBoxIT_EE((HEAP32[i4 >> 2] | 0) + 12 | 0, i9);
 __ZN12_GLOBAL__N_111storeBoundsI8Scalar4fEEvPfRKN5physx5cloth11BoundingBoxIT_EE((HEAP32[i4 >> 2] | 0) + 36 | 0, i13);
 STACKTOP = i15;
 return;
}

function __ZN5physx2Cm10Collection3addERNS_6PxBaseEy(i8, i7, i10, i11) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 16 | 0;
 i3 = i12 + 8 | 0;
 i9 = i12;
 i4 = i12 + 24 | 0;
 i6 = i12 + 20 | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0, i7 | 0) | 0;
 i2 = getTempRet0() | 0;
 if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
  if ((i1 | 0) == (i10 | 0) & (i2 | 0) == (i11 | 0)) {
   STACKTOP = i12;
   return;
  }
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 732479 | 0, 26, gb + 732554 | 0, i3);
  STACKTOP = i12;
  return;
 }
 do if ((i10 | 0) == 0 & (i11 | 0) == 0) i2 = i7; else {
  i1 = i9;
  HEAP32[i1 >> 2] = i10;
  HEAP32[i1 + 4 >> 2] = i11;
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i8 + 4 | 0, i9, i4) | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i2 = i7;
   i5 = i1;
   HEAP32[i5 >> 2] = i10;
   HEAP32[i5 + 4 >> 2] = i11;
   HEAP32[i1 + 8 >> 2] = i2;
   break;
  }
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 732479 | 0, 36, gb + 732654 | 0, i5);
  STACKTOP = i12;
  return;
 } while (0);
 HEAP32[i6 >> 2] = i7;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb(i8 + 44 | 0, i6, i9) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 8 | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
 } else i1 = i1 + 8 | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i9 + 4 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = i1 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i16 | 0)) return;
 i10 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i10 + 52 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i12 = i10 + 28 | 0;
 i13 = i10 + 16 | 0;
 i14 = i10 + 12 | 0;
 i4 = i10 + 20 | 0;
 i5 = i10 + 24 | 0;
 i6 = i10 + 40 | 0;
 i7 = i10 + 36 | 0;
 i8 = i10 + 44 | 0;
 i9 = i10 + 48 | 0;
 i10 = i10 + 8 | 0;
 i1 = i2;
 while (1) {
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) if (!(_strcmp(HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) if (!(_strcmp(HEAP32[i8 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0)) {
   if ((HEAP32[i9 >> 2] | 0) != (HEAP32[i1 + 12 >> 2] | 0)) i17 = 8;
  } else i17 = 8; else i17 = 8; else i17 = 8; else i17 = 8;
  if ((i17 | 0) == 8) {
   i17 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i17 = 16;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i2 | 0)) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
    i17 = 16;
    break;
   }
   if (_strcmp(HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
    i17 = 16;
    break;
   }
   if (_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 12 >> 2] | 0)) {
    i17 = 16;
    break;
   }
  }
  i1 = i1 + 24 | 0;
  HEAP32[i15 >> 2] = i1;
  if ((i1 | 0) == (i16 | 0)) {
   i17 = 16;
   break;
  }
 }
 if ((i17 | 0) == 16) return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i9 + 36 | 0, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 469301 | 0, i8, 0);
 __ZN20ComputeShaderVariant8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i6 = i8 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 24 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -20 | 0;
    HEAP32[i7 >> 2] = i3;
    i4 = HEAP32[i2 + -12 >> 2] | 0;
    i5 = i4;
    if (!i4) i2 = i3; else {
     i2 = i2 + -8 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i5 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i4);
     i2 = HEAP32[i7 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i8 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i3 = i8 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i8 = i2 + -96 | 0;
   HEAP32[i3 >> 2] = i8;
   __ZN19ComputeShaderKernelD2Ev(i8);
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return;
}

function __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE9erase_oneIS1_EEjRKT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE11lower_boundIS1_EENS2_11__wrap_iterIPS1_EERKT_(i1, i4) | 0;
 i7 = i1 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i2;
 if ((i6 | 0) == (i2 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 do if ((i3 | 0) == (i1 | 0)) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i6 + 28 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = HEAP32[i4 + 24 >> 2] | 0;
   i3 = HEAP32[i6 + 24 >> 2] | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i1 = HEAP32[i4 + 20 >> 2] | 0;
    i3 = HEAP32[i6 + 20 >> 2] | 0;
    if ((i1 | 0) == (i3 | 0)) {
     i1 = HEAP32[i4 + 16 >> 2] | 0;
     i3 = HEAP32[i6 + 16 >> 2] | 0;
     if ((i1 | 0) == (i3 | 0)) {
      i1 = HEAP32[i4 + 12 >> 2] | 0;
      i3 = HEAP32[i6 + 12 >> 2] | 0;
      if ((i1 | 0) == (i3 | 0)) {
       i1 = HEAP32[i4 + 8 >> 2] | 0;
       i3 = HEAP32[i6 + 8 >> 2] | 0;
       if ((i1 | 0) == (i3 | 0)) {
        i1 = HEAP32[i4 + 4 >> 2] | 0;
        i3 = HEAP32[i6 + 4 >> 2] | 0;
        if ((i1 | 0) == (i3 | 0)) {
         i1 = HEAP32[i4 >> 2] | 0;
         i3 = HEAP32[i6 >> 2] | 0;
         if ((i1 | 0) == (i3 | 0)) break;
        }
       }
      }
     }
    }
   }
  }
  if (i1 >>> 0 < i3 >>> 0) {
   i7 = 0;
   return i7 | 0;
  }
 } else if ((i3 | 0) < (i1 | 0)) {
  i7 = 0;
  return i7 | 0;
 } while (0);
 i1 = i6 + 36 | 0;
 i3 = i5 - i1 | 0;
 if (i3) {
  _memmove(i6 | 0, i1 | 0, i3 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + (((i3 | 0) / 36 | 0) * 36 | 0) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i7 = 1;
  return i7 | 0;
 }
 HEAP32[i7 >> 2] = i2 + (~(((i2 + -36 - i1 | 0) >>> 0) / 36 | 0) * 36 | 0);
 i7 = 1;
 return i7 | 0;
}

function __ZN12WheelJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 i2 = i4 + 96 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 803220 | 0, gb + 803233 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI17JointSuspension2DE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i3 = i4 + 116 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 803251 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i1 = i6 + 16 | 0;
   i8 = HEAP32[i6 + 20 >> 2] | 0;
   i2 = i8 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i1 >> 2] = i2;
   if (i2 >>> 0 >= i8 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 108 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 803262 | 0, gb + 803270 | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZL17WriteToBufferFuncPvPhj(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i6 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 & 2147483647;
 i10 = i6 + 12 | 0;
 i1 = (HEAP32[i10 >> 2] | 0) + i8 | 0;
 do if (i3 >>> 0 < i1 >>> 0) {
  i5 = (i3 >>> 1) + i3 | 0;
  i1 = i1 >>> 0 < i5 >>> 0 ? i5 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   break;
  } else i1 = i2;
 } else i1 = i2; while (0);
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i2 = i4 + i8 | 0;
 HEAP32[i10 >> 2] = i2;
 i5 = i1 & 2147483647;
 if (i5 >>> 0 >= i2 >>> 0) {
  i10 = i3;
  i10 = i10 + i4 | 0;
  _memcpy(i10 | 0, i7 | 0, i8 | 0) | 0;
  return;
 }
 i11 = i1 << 1;
 i2 = i11 >>> 0 > i2 >>> 0 ? i11 : i2;
 if (i5 >>> 0 >= i2 >>> 0) {
  i11 = i3;
  i11 = i11 + i4 | 0;
  _memcpy(i11 | 0, i7 | 0, i8 | 0) | 0;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i11 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i2, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i11;
  i11 = i11 + i4 | 0;
  _memcpy(i11 | 0, i7 | 0, i8 | 0) | 0;
  return;
 } else {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i11 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i10 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i6 >> 2] = i11;
  i11 = i11 + i4 | 0;
  _memcpy(i11 | 0, i7 | 0, i8 | 0) | 0;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i3 = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i1 = i2 + 4 | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP8[i4 + 11 >> 0] | 0;
  i13 = i5 << 24 >> 24 < 0;
  i4 = i13 ? HEAP32[i4 >> 2] | 0 : i4;
  i5 = i13 ? HEAP32[i3 + 8 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 16 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i12 = 8;
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i14 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i14, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i13;
   HEAP32[i2 + 12 >> 2] = i14 | -2147483648;
   HEAP32[i2 + 8 >> 2] = i5;
   i1 = i13;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  i1 = i6 + 20 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 20 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else {
   i6 = i1;
   i3 = i1;
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1 + 96 | 0;
 i10 = i1;
 i11 = i1 + 24 | 0;
 HEAP32[i8 >> 2] = 1065353216;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 1065353216;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1065353216;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1065353216;
 i4 = __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE(i4, i8, i10, i11) | 0;
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i10 >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) - f9);
 i3 = i10 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f9);
 i3 = i10 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f9);
 i3 = i10 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i10 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i3 >> 2]));
 i3 = i10 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i3 >> 2]));
 i7 = __ZL23contactHullHeightfield2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEb(i11, i10, i5, i6, i7, f9, i2, i8, i4) | 0;
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN5physx2Gu21contactBoxHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i3, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i1 + 320 | 0;
 i18 = i1 + 96 | 0;
 i10 = i1;
 i8 = i1 + 24 | 0;
 i17 = i4 + 4 | 0;
 __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E(i18, i17);
 __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i18, i11);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f9 + Math_fround(HEAPF32[i17 >> 2]));
 f13 = Math_fround(f9 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 f12 = Math_fround(f9 + Math_fround(HEAPF32[i4 + 12 >> 2]));
 f16 = Math_fround(-f13);
 f15 = Math_fround(-f12);
 HEAPF32[i10 >> 2] = Math_fround(-f14);
 HEAPF32[i10 + 4 >> 2] = f16;
 HEAPF32[i10 + 8 >> 2] = f15;
 HEAPF32[i10 + 12 >> 2] = f14;
 HEAPF32[i10 + 16 >> 2] = f13;
 HEAPF32[i10 + 20 >> 2] = f12;
 HEAP32[i8 >> 2] = 1065353216;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 1065353216;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i8 + 32 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 HEAP32[i8 + 40 >> 2] = 0;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i8 + 52 >> 2] = 1065353216;
 HEAP32[i8 + 56 >> 2] = 0;
 HEAP32[i8 + 60 >> 2] = 0;
 HEAP32[i8 + 64 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 1065353216;
 i7 = __ZL23contactHullHeightfield2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEb(i11, i10, i5, i6, i7, f9, i2, i8, 1) | 0;
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet(i5, i1, i2, i3, i4, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 16 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13 + 4 | 0;
 i6 = i13;
 HEAP32[i6 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i6, i1);
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 i1 = i5 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i5 + 44 >> 2] | 0)) __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5 + 36 | 0, i8); else {
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
 }
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 if ((i6 | 0) != -1 & i6 >>> 0 > 1073741823) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i11 >> 2] = i6;
 i2 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i7 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i12 = 10; else if ((HEAP32[i1 >> 2] | 0) > (i6 | 0)) i12 = 10;
 if ((i12 | 0) == 10) {
  HEAP32[i10 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i9, i8, i11) | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 92 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 96 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 100 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 104 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 105 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 106 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 32 | 0;
 i4 = i1 + 20 | 0;
 i5 = i1 + 8 | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903598 | 0, i7, 0);
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i7 + 4;
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i5 + 8 >> 2] = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903616 | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i4, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = -1;
 HEAP32[i3 + 8 >> 2] = -1;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = -1;
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 40 >> 2] = Math_fround(0.0);
 HEAP8[i3 + 44 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903628 | 0, i3, 0);
 __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i1;
 return;
}

function __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function _start_pass_huff_decoder(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i5 + 408 >> 2] | 0;
 if (!(HEAP32[i5 + 364 >> 2] | 0)) if ((HEAP32[i5 + 368 >> 2] | 0) == 63) if (!(HEAP32[i5 + 372 >> 2] | 0)) {
  if (HEAP32[i5 + 376 >> 2] | 0) i1 = 5;
 } else i1 = 5; else i1 = 5; else i1 = 5;
 if ((i1 | 0) == 5) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 122;
  mftCall_vii(HEAP32[i4 + 4 >> 2] | 0, i5 | 0, -1);
 }
 i2 = i5 + 292 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i5 + 296 + (i1 << 2) >> 2] | 0;
   i3 = HEAP32[i4 + 20 >> 2] | 0;
   i4 = HEAP32[i4 + 24 >> 2] | 0;
   _jpeg_make_d_derived_tbl(i5, 1, i3, i6 + 40 + (i3 << 2) | 0);
   _jpeg_make_d_derived_tbl(i5, 0, i4, i6 + 56 + (i4 << 2) | 0);
   HEAP32[i6 + 20 + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i4 = i5 + 320 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) i3 = 0; else {
  i4 = i6 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  i4 = i6 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  i4 = i6 + 8 | 0;
  HEAP8[i4 >> 0] = 0;
  i5 = i5 + 252 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = i6 + 36 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 do {
  i1 = HEAP32[i5 + 296 + (HEAP32[i5 + 324 + (i3 << 2) >> 2] << 2) >> 2] | 0;
  HEAP32[i6 + 72 + (i3 << 2) >> 2] = HEAP32[i6 + 40 + (HEAP32[i1 + 20 >> 2] << 2) >> 2];
  HEAP32[i6 + 112 + (i3 << 2) >> 2] = HEAP32[i6 + 56 + (HEAP32[i1 + 24 >> 2] << 2) >> 2];
  i2 = i6 + 152 + i3 | 0;
  if (!(HEAP8[i1 + 48 >> 0] | 0)) {
   HEAP8[i2 >> 0] = 0;
   i1 = 0;
  } else {
   HEAP8[i2 >> 0] = 1;
   i1 = (HEAP32[i1 + 36 >> 2] | 0) > 1 & 1;
  }
  HEAP8[i6 + 162 + i3 >> 0] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i4 >> 2] | 0));
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i6 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i6 + 8 | 0;
 HEAP8[i4 >> 0] = 0;
 i5 = i5 + 252 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i6 + 36 | 0;
 HEAP32[i6 >> 2] = i5;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 i15 = HEAP32[i6 + 4 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i15 + 96 + (i1 << 4) >> 2]);
 f12 = Math_fround(HEAPF32[i15 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + 96 + (i1 << 4) + 8 >> 2]);
 i1 = HEAP32[i15 + 96 + (i1 << 4) + 12 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i15 = HEAP32[i6 + 200 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) >> 2]);
 f13 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + (i2 * 12 | 0) + 8 >> 2]);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 96 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 112 >> 2])));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 128 >> 2])));
 f8 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 100 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 116 >> 2])));
 f8 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 132 >> 2])));
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i6 + 104 >> 2]));
 f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i6 + 120 >> 2])));
 f7 = Math_fround(f13 + Math_fround(f7 * Math_fround(HEAPF32[i6 + 136 >> 2])));
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN8UserList7AddUserER12UserListNode(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i8 = i10 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) i1 = i10 + 8 | 0; else {
  i6 = i10 + 4 | 0;
  i1 = i10 + 8 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i7 = i3 + 16 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = i2 + -1 | 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i3 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i12 = i3 + (i4 << 3) | 0;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i3 = i3 + (i5 << 3) | 0;
   HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i3 + 4 >> 2] = i11;
   i2 = HEAP32[i2 >> 2] | 0;
   i3 = i2 + (i4 << 3) | 0;
   i2 = HEAP32[i2 + (i4 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) i2 = (HEAP32[i3 >> 2] | 0) + 4 | 0; else i2 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0) + (i2 << 3) | 0;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i2 + -1;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = -1;
 }
 HEAP32[i8 >> 2] = i9;
 i6 = i9 + 4 | 0;
 i7 = i9 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 >> 2] = i8;
 i2 = i8 + 1 | 0;
 i3 = i9 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 3, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i2;
 i12 = HEAP32[i6 >> 2] | 0;
 HEAP32[i12 + (i8 << 3) >> 2] = i10;
 HEAP32[i12 + (i8 << 3) + 4 >> 2] = -1;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i4 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  STACKTOP = i8;
  return;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L24 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L24;
   i9 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i9 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 f10 = Math_fround(+_strtod(i6, i4));
 mftCall_vif(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i7 + 24 >> 2] | 0, +f10);
 STACKTOP = i8;
 return;
}

function __ZN10MeshFilter19GetInstantiatedMeshEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i2 = i8;
 i7 = i5 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i4 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i4 = 9;
   }
  }
  if ((i4 | 0) == 7) i4 = 9;
  if ((i4 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i7 >> 2] | 0) | 0;
 }
 i2 = __ZN4Mesh19GetInstantiatedMeshEPS_R6Object(i1, i5) | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i8;
  return i2 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i1 + 376 >> 2] = HEAP32[i7 >> 2];
  __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1106136 | 0, i6);
 STACKTOP = i8;
 return i2 | 0;
}

function __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i5 + 48 >> 2] | 0;
 if (i2 & 16 | 0) {
  i2 = i5 + 44 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i5 + 24 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) HEAP32[i2 >> 2] = i4; else i4 = i3;
  i2 = HEAP32[i5 + 20 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i5 = i4 - i2 | 0;
  if (i5 >>> 0 > 4294967279) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i6 = 8;
  } else if (i5 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i5; else i6 = 8;
  if ((i6 | 0) == 8) {
   i3 = i5 + 16 & -16;
   i6 = __Znwj(i3) | 0;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i6;
  }
  if ((i2 | 0) != (i4 | 0)) {
   i3 = i1;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
   }
   i1 = i1 + i5 | 0;
  }
  HEAP8[i1 >> 0] = 0;
  return;
 }
 if (!(i2 & 8)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i5 = i4 - i2 | 0;
 if (i5 >>> 0 > 4294967279) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i6 = 18;
 } else if (i5 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i5; else i6 = 18;
 if ((i6 | 0) == 18) {
  i3 = i5 + 16 & -16;
  i6 = __Znwj(i3) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i6;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i1;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
  i1 = i1 + i5 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN7mecanim6memory16ChainedAllocator8AllocateEjj(i6, i9, i7) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i3 = i6 + 8 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i1 >>> 0 < i9 >>> 0 ? i9 : i1;
  i2 = (i7 >>> 0 > 16 ? i7 : 16) + -1 | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i5;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i2 & -12) + 12 + i1 + (i2 & 0 - i1) | 0, 16, i8, 0, gb + 913345 | 0, 534) | 0;
  if (i2 | 0) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 + 12 >> 2] = i2;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = i1;
   i5 = i2 + 12 | 0;
   i5 = (i7 + -1 & 0 - i5) + i5 | 0;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i6 + 16 >> 2] = i5;
  }
 }
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i7 + -1 | 0;
 i3 = i6 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do if (((i5 & 0 - i1) + i1 + i9 | 0) >>> 0 > ((HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] | 0) | 0) >>> 0) {
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i2 >>> 0 < i9 >>> 0 ? i9 : i2;
  i1 = (i7 >>> 0 > 16 ? i7 : 16) + -1 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = 25;
  HEAP32[i8 + 4 >> 2] = i7;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i1 & -12) + 12 + i2 + (i1 & 0 - i2) | 0, 16, i8, 0, gb + 913345 | 0, 619) | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  } else {
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i2;
   i8 = i1 + 12 | 0;
   i8 = (i5 & 0 - i8) + i8 | 0;
   i7 = i8;
   HEAP32[i1 + 4 >> 2] = i7;
   HEAP32[i4 >> 2] = i7;
   i1 = i8;
   break;
  }
 } while (0);
 i8 = (i5 & 0 - i1) + i1 | 0;
 HEAP32[i4 >> 2] = i8 + i9;
 i9 = i8;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE5eraseERS4_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 24 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6 + ~(i6 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i9 = HEAP32[i12 + 16 >> 2] | 0;
 i2 = i9 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i12 = 0;
  return i12 | 0;
 }
 i8 = HEAP32[i12 + 8 >> 2] | 0;
 i5 = HEAP32[i12 + 12 >> 2] | 0;
 while (1) {
  i4 = i8 + (i1 << 3) | 0;
  i3 = i2;
  i2 = i5 + (i1 << 2) | 0;
  i7 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i10 = 11;
   break;
  }
 }
 if ((i10 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i12 + 40 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i10 = i12 + 36 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if ((i7 | 0) != (i1 | 0)) {
  HEAP32[i4 >> 2] = HEAP32[i8 + (i1 << 3) >> 2];
  HEAP32[i8 + (i7 << 3) + 4 >> 2] = HEAP32[i8 + (i1 << 3) + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
  i1 = HEAP32[i4 >> 2] | 0;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i9 + (((i1 >>> 16 ^ i1) & (HEAP32[i11 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i5 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i7;
 }
 i12 = i12 + 32 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj646ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj645ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj644ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = i12 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i1 >> 2] = i3;
  i3 = i9;
 }
 i9 = i13 + 11 | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i8 = i13 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 & 255;
 i2 = i4 ? i5 : i6;
 do if (i3 >>> 0 > i2 >>> 0) {
  i7 = i3 - i2 | 0;
  if (i7 | 0) {
   if (i4) {
    i2 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0;
    i3 = i5;
   } else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i7 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i13, i2, i7 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i9 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   _memset(i2 + i3 | 0, 1, i7 | 0) | 0;
   i1 = i3 + i7 | 0;
   if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } else if (i4) {
  HEAP8[(HEAP32[i13 >> 2] | 0) + i3 >> 0] = 0;
  HEAP32[i8 >> 2] = i3;
  break;
 } else {
  HEAP8[i13 + i3 >> 0] = 0;
  HEAP8[i9 >> 0] = i3;
  break;
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i1);
 STACKTOP = i11;
 return;
}

function __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i6, i2, i7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 __ZL18InitializeIfNeededv();
 if (!(__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1103788 >> 2] | 0, i2) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[gb + 1103788 >> 2] | 0;
 i4 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i5, i3, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(48) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i2);
  HEAP32[i1 + 28 >> 2] = 255;
  i2 = i1 + 36 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
  i5 = i5 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) == 128) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i1 + 36 | 0);
  STACKTOP = i8;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv(i1, i11, i12, i13, i2) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i10 + 176 | 0;
 i7 = i10 + 156 | 0;
 i8 = i10 + 4 | 0;
 i9 = i10 + 152 | 0;
 HEAP8[i1 >> 0] = HEAP8[gb + 1078232 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1078232 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[gb + 1078232 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1078232 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[gb + 1078232 + 4 >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = HEAP8[gb + 1078232 + 5 >> 0] | 0;
 i3 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i6 >> 2] = i2;
 i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i7, 20, i3, i1, i6) | 0;
 i2 = i7 + i1 | 0;
 i3 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i7, i2, i12) | 0;
 i4 = __ZNKSt3__28ios_base6getlocEv(i12) | 0;
 HEAP32[i6 >> 2] = i4;
 __THREW__ = 0;
 i5 = invoke_iii(fb + 1145 | 0, i6 | 0, gb + 1474588 | 0) | 0;
 i14 = __THREW__;
 __THREW__ = 0;
 if (i14 & 1) {
  i14 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i4) | 0;
  ___resumeException(i14 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i4) | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0, i7 | 0, i2 | 0, i8 | 0) | 0;
  i14 = i8 + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  i14 = __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i8, (i3 | 0) == (i2 | 0) ? i14 : i8 + (i3 - i7 << 2) | 0, i14, i12, i13) | 0;
  STACKTOP = i10;
  return i14 | 0;
 }
 return 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj655ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj654ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj653ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5Umbra20RuntimeStructBuilder13reserveOutputEPNS_9AllocatorEj(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (i2 >>> 0 < 64) {
  i12 = 0;
  return i12 | 0;
 }
 i12 = i2 + -64 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + -44 | 0, 0) | 0;
 if (!i1) {
  i12 = 0;
  return i12 | 0;
 }
 i9 = i1 + 4 + 15 & -16;
 i10 = i9;
 HEAP32[i9 + -4 >> 2] = i9 - i1;
 if (!i9) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = i11 + 152 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i3 = i11 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) > (i8 | 0)) i1 = HEAP32[i11 + 144 >> 2] | 0; else {
  i2 = i9 << 1;
  i2 = (i2 | 0) > 16 ? i2 : 16;
  i6 = i11 + 140 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 * 12 | 0) + 16 | 0, 0) | 0;
  if (!i1) {
   i12 = 0;
   return i12 | 0;
  }
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = i2;
  i5 = i11 + 144 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (i2 | 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   if (i3) {
    i4 = (i3 | 0) <= (i9 | 0) ? i3 : i9;
    if ((i4 | 0) > 0) {
     i3 = 0;
     do {
      i13 = i1 + (i3 * 12 | 0) | 0;
      i14 = i2 + (i3 * 12 | 0) | 0;
      HEAP32[i13 >> 2] = HEAP32[i14 >> 2];
      HEAP32[i13 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
      HEAP32[i13 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i4 | 0));
     i2 = HEAP32[i5 >> 2] | 0;
     if (!i2) break;
    }
   }
   i14 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, i2 + -16 | 0);
  } while (0);
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i7 >> 2] = i9;
 HEAP32[i1 + (i8 * 12 | 0) >> 2] = i10;
 HEAP32[i1 + (i8 * 12 | 0) + 4 >> 2] = i10;
 HEAP32[i1 + (i8 * 12 | 0) + 8 >> 2] = i12;
 HEAP8[i11 + 137 >> 0] = 1;
 i14 = 1;
 return i14 | 0;
}

function __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034203 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 56 | 0, 1);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034351 | 0, i6, 0);
 __ZN11KeyframeTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034211 | 0, i6, i1 + 76 | 0, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034225 | 0, i6, i1 + 80 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034240 | 0, i6, i1 + 84 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13OcclusionArea8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i2 = i4 + 32 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 842535 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1034411 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i3 = i4 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 378987 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i5 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i5 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i12 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i12;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i12);
 i12 = i1;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i2 + 4 >> 2] = i11;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (!i2) i1 = 0; else {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i3, i9, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i4 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) i1 = HEAP32[i4 >> 2] | 0; else {
  i12 = i6 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i12 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i12 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 }
 i12 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i12 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 20 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = HEAP16[i1 >> 1] | 0;
 i1 = i6 & 65535;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 i2 = i9 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i12 = 0;
  return i12 | 0;
 }
 i8 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 8 >> 2] | 0;
 while (1) {
  i4 = i8 + (i1 << 3) | 0;
  i3 = i2;
  i2 = i5 + (i1 << 2) | 0;
  i7 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP16[i4 >> 1] | 0) == i6 << 16 >> 16) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i10 = 11;
   break;
  }
 }
 if ((i10 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i12 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if ((i7 | 0) != (i1 | 0)) {
  i10 = HEAP16[i8 + (i1 << 3) >> 1] | 0;
  HEAP16[i4 >> 1] = i10;
  HEAP32[i8 + (i7 << 3) + 4 >> 2] = HEAP32[i8 + (i1 << 3) + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
  i1 = i10 & 65535;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i9 + (((i1 >>> 16 ^ i1) & (HEAP32[i11 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i5 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i7;
 }
 i12 = i12 + 28 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx2Sn8MetaDataD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 1 | 0;
 i2 = i9;
 i7 = i8 + 20 | 0;
 i3 = HEAP32[i8 + 24 >> 2] | 0;
 if (i3 | 0) {
  i5 = 0;
  do {
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   if (i4 | 0) {
    i1 = HEAP32[i4 + 44 >> 2] | 0;
    if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
     i1 = HEAP32[i4 + 36 >> 2] | 0;
     if (i1 | 0) {
      i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
     }
    }
    i10 = HEAP32[i4 + 32 >> 2] | 0;
    if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
     i1 = HEAP32[i4 + 24 >> 2] | 0;
     if (i1 | 0) {
      i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
      mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
     }
    }
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i4);
   }
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i8 + 16 >> 2] | 0);
 i1 = i8 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
 HEAP32[i1 >> 2] = 0;
 i10 = HEAP32[i8 + 72 >> 2] | 0;
 if ((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i8 + 64 >> 2] | 0;
  if (i1 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 i10 = HEAP32[i8 + 28 >> 2] | 0;
 if (!((i10 | 0) > -1 & (i10 & 2147483647 | 0) != 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 12, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 2;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = i1 + 4 | 0;
 i2 = HEAP32[i15 >> 2] | 0;
 i16 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == (i16 | 0)) return;
 i10 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i10 + 52 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i12 = i10 + 28 | 0;
 i13 = i10 + 16 | 0;
 i14 = i10 + 12 | 0;
 i4 = i10 + 20 | 0;
 i5 = i10 + 24 | 0;
 i6 = i10 + 40 | 0;
 i7 = i10 + 36 | 0;
 i8 = i10 + 44 | 0;
 i9 = i10 + 48 | 0;
 i10 = i10 + 8 | 0;
 i1 = i2;
 while (1) {
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i3 | 0) == (i2 | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) if (!(_strcmp(HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) if (!(_strcmp(HEAP32[i8 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0)) {
   if ((HEAP32[i9 >> 2] | 0) != (HEAP32[i1 + 12 >> 2] | 0)) i17 = 8;
  } else i17 = 8; else i17 = 8; else i17 = 8; else i17 = 8;
  if ((i17 | 0) == 8) {
   i17 = 0;
   if (!(HEAP8[i10 >> 0] | 0)) {
    i17 = 16;
    break;
   }
   if (!(HEAP32[i11 >> 2] | 0)) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i12 >> 2] | 0) != (i2 | 0)) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i13 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
    i17 = 16;
    break;
   }
   if (_strcmp(HEAP32[i14 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
    i17 = 16;
    break;
   }
   if (_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0) {
    i17 = 16;
    break;
   }
   if ((HEAP32[i5 >> 2] | 0) != (HEAP32[i1 + 12 >> 2] | 0)) {
    i17 = 16;
    break;
   }
  }
  i1 = i1 + 24 | 0;
  HEAP32[i15 >> 2] = i1;
  if ((i1 | 0) == (i16 | 0)) {
   i17 = 16;
   break;
  }
 }
 if ((i17 | 0) == 16) return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z28Texture2D_CUSTOM_EncodeToJPGP12Il2CppObjecti(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i6 = i8;
 i2 = i8 + 32 | 0;
 i7 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i9 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i3 + 111 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = (i5 | 0) < 0 ? 0 : i5;
 HEAP32[i7 >> 2] = 0;
 i1 = i7 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i10 = i6;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 if (__ZN9Texture2D11EncodeToJPGER13dynamic_arrayIhLj1EEi(i2, i7, (i9 | 0) > 100 ? 100 : i9) | 0) {
  i9 = HEAP32[i7 >> 2] | 0;
  i10 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
  i10 = (i9 | 0) == 0 ? 0 : i10;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 1, i10) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0, i9 | 0, i10 | 0) | 0;
 } else i1 = 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i4);
  HEAP32[i7 >> 2] = 0;
 }
 i10 = i1;
 STACKTOP = i8;
 return i10 | 0;
}

function __Z20buildActiveTransformPN5physx2Sc5ActorEPPNS0_6ClientEj(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i1 = i13 + 36 | 0;
 i3 = i2 + 52 | 0;
 if (HEAP8[(HEAP32[i3 >> 2] | 0) + 45 >> 0] | 0) {
  STACKTOP = i13;
  return;
 }
 i6 = __ZN5physx2Sc8RigidSim10getPxActorEv(i2) | 0;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i6 | 0);
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 + 8 >> 2] = i6;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = i7;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i12 + 16 >> 2] = i8;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i12 + 20 >> 2] = i9;
 i10 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i12 + 24 >> 2] = i10;
 i11 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i12 + 28 >> 2] = i11;
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i12 + 32 >> 2] = i4;
 i1 = HEAP32[i5 + (HEAPU8[(HEAP32[i3 >> 2] | 0) + 13 >> 0] << 2) >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i14 = i12;
  i1 = HEAP32[i14 + 4 >> 2] | 0;
  i12 = i5 + (i3 * 36 | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i12 + 4 >> 2] = i1;
  HEAP32[i5 + (i3 * 36 | 0) + 8 >> 2] = i6;
  HEAP32[i5 + (i3 * 36 | 0) + 12 >> 2] = i7;
  HEAP32[i5 + (i3 * 36 | 0) + 16 >> 2] = i8;
  HEAP32[i5 + (i3 * 36 | 0) + 20 >> 2] = i9;
  HEAP32[i5 + (i3 * 36 | 0) + 24 >> 2] = i10;
  HEAP32[i5 + (i3 * 36 | 0) + 28 >> 2] = i11;
  HEAP32[i5 + (i3 * 36 | 0) + 32 >> 2] = i4;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_17PxActiveTransformENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i1, i12) | 0;
 STACKTOP = i13;
 return;
}

function _malloc_stats() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 16 | 0;
 i11 = i13 + 8 | 0;
 i10 = i13;
 i1 = i13 + 20 | 0;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i9 = i1 & -16 ^ 1431655768;
  HEAP32[i1 >> 2] = i9;
  HEAP32[gb + 1470876 >> 2] = i9;
 }
 i9 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
 if (!i9) {
  i7 = 0;
  i6 = 0;
  i8 = 0;
  i9 = HEAP32[gb + 191628 >> 2] | 0;
  HEAP32[i10 >> 2] = i6;
  _fprintf(i9, gb + 1076036 | 0, i10) | 0;
  HEAP32[i11 >> 2] = i7;
  _fprintf(i9, gb + 1076062 | 0, i11) | 0;
  HEAP32[i12 >> 2] = i8;
  _fprintf(i9, gb + 1076088 | 0, i12) | 0;
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[gb + 1470404 + 436 >> 2] | 0;
 i3 = HEAP32[gb + 1470404 + 432 >> 2] | 0;
 i8 = gb + 1470404 + 448 | 0;
 i1 = i3 + -40 - (HEAP32[gb + 1470404 + 12 >> 2] | 0) | 0;
 do {
  i6 = HEAP32[i8 >> 2] | 0;
  i5 = i6 + 8 | 0;
  i7 = i6 + (HEAP32[i8 + 4 >> 2] | 0) | 0;
  i5 = i6 + ((i5 & 7 | 0) == 0 ? 0 : 0 - i5 & 7) | 0;
  do {
   if (i5 >>> 0 >= i7 >>> 0 | (i5 | 0) == (i9 | 0)) break;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i4 | 0) == 7) break;
   i14 = i4 & -8;
   i1 = i1 - ((i4 & 3 | 0) == 1 ? i14 : 0) | 0;
   i5 = i5 + i14 | 0;
  } while (i5 >>> 0 >= i6 >>> 0);
  i8 = HEAP32[i8 + 8 >> 2] | 0;
 } while ((i8 | 0) != 0);
 i14 = HEAP32[gb + 191628 >> 2] | 0;
 HEAP32[i10 >> 2] = i2;
 _fprintf(i14, gb + 1076036 | 0, i10) | 0;
 HEAP32[i11 >> 2] = i3;
 _fprintf(i14, gb + 1076062 | 0, i11) | 0;
 HEAP32[i12 >> 2] = i1;
 _fprintf(i14, gb + 1076088 | 0, i12) | 0;
 STACKTOP = i13;
 return;
}

function __ZNK5Umbra4Tome16getClusterBoundsEiRNS_7Vector3ES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0, i18 = 0, i19 = 0;
 i19 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
 i18 = HEAP32[i19 + (i2 * 20 | 0) + 8 >> 2] | 0;
 i17 = HEAP32[i19 + (i2 * 20 | 0) + 12 >> 2] | 0;
 i2 = HEAP32[i19 + (i2 * 20 | 0) + 16 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f16 = Math_fround(i18 >>> 16 | 0);
 f12 = Math_fround(i18 & 65535 | 0);
 f8 = Math_fround(i17 >>> 16 | 0);
 f13 = Math_fround(HEAPF32[gb + 1451432 >> 2]);
 f16 = Math_fround(f16 * f13);
 f9 = Math_fround(HEAPF32[gb + 1451432 + 4 >> 2]);
 f12 = Math_fround(f12 * f9);
 f5 = Math_fround(HEAPF32[gb + 1451432 + 8 >> 2]);
 f8 = Math_fround(f8 * f5);
 f13 = Math_fround(Math_fround(i17 & 65535 | 0) * f13);
 f9 = Math_fround(Math_fround(i2 >>> 16 | 0) * f9);
 f5 = Math_fround(Math_fround(i2 & 65535 | 0) * f5);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(f15 * f16) + Math_fround(f14 * Math_fround(Math_fround(1.0) - f16)));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(f15 * f13) + Math_fround(f14 * Math_fround(Math_fround(1.0) - f13)));
 HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f11 * f12) + Math_fround(f10 * Math_fround(Math_fround(1.0) - f12)));
 HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround(f11 * f9) + Math_fround(f10 * Math_fround(Math_fround(1.0) - f9)));
 HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f7 * f8) + Math_fround(f6 * Math_fround(Math_fround(1.0) - f8)));
 HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(f7 * f5) + Math_fround(f6 * Math_fround(Math_fround(1.0) - f5)));
 return;
}

function __ZN29SerializeTraitsForStringTypesI8UnityStrE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i4 = i8 + 8 | 0;
 i5 = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, 0, 1);
 i6 = i2 + 16 | 0;
 i7 = i2 + 24 | 0;
 HEAP8[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 3 >> 0] = 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 945671 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i2 + 48 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 3 & -4;
 i1 = i2 + 20 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 __ZNK16TypeTreeIterator8ChildrenEv(i3, i1);
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i6 >> 2] | 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i5, i1);
 __ZNK16TypeTreeIterator4LastEv(i4, i5);
 i5 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[i4 + 4 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 16384;
 i7 = (HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i7 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 32768;
 STACKTOP = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN11AssetBundle9AssetInfoEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 365524 | 0, i2, i4);
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 365604 | 0, i7, i2, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 365617 | 0, i7, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i6 = i2 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 365629 | 0, HEAP32[gb + 37176 >> 2] | 0, i6, 0);
 i2 = i8 + 8 | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, i7, i6, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i2, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __Z19GenerateSortIndicesP16ParticleSortDataRK5PlaneRK23ParticleSystemParticles22ParticleSystemSortMode(i9, i8, i2, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0, f14 = f0;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   if (!i10) return;
   i6 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i2 + 20 >> 2] | 0;
   i2 = HEAP32[i2 + 40 >> 2] | 0;
   i3 = i8 + 4 | 0;
   i4 = i8 + 8 | 0;
   i5 = i8 + 12 | 0;
   i1 = 0;
   do {
    f14 = Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]);
    f13 = Math_fround(HEAPF32[i7 + (i1 << 2) >> 2]);
    f11 = Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
    f14 = Math_fround(f14 * Math_fround(HEAPF32[i8 >> 2]));
    f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i3 >> 2])));
    f11 = Math_fround(f13 + Math_fround(f11 * Math_fround(HEAPF32[i4 >> 2])));
    f11 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f11);
    i12 = f11 < Math_fround(-1.1920929e-07);
    f11 = i12 ? f11 : Math_fround(-1.1920929e-07);
    HEAP32[i9 + (i1 << 3) >> 2] = i1;
    HEAPF32[i9 + (i1 << 3) + 4 >> 2] = f11;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
 case 3:
  {
   if (!i10) return;
   i2 = HEAP32[i2 + 520 >> 2] | 0;
   i1 = 0;
   do {
    i12 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
    HEAP32[i9 + (i1 << 3) >> 2] = i1;
    HEAP32[i9 + (i1 << 3) + 4 >> 2] = i12;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
 case 2:
  {
   if (!i10) return;
   i2 = HEAP32[i2 + 520 >> 2] | 0;
   i1 = 0;
   do {
    f14 = Math_fround(Math_fround(100.0) - Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]));
    i12 = f14 < Math_fround(0.0);
    f14 = i12 ? Math_fround(0.0) : f14;
    HEAP32[i9 + (i1 << 3) >> 2] = i1;
    HEAPF32[i9 + (i1 << 3) + 4 >> 2] = f14;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i10 | 0));
   return;
  }
 default:
  return;
 }
}

function __Z14pqNewPriorityQP9TESSallociPFiPvS1_E(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i2 + 12 | 0;
 i7 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, 28) | 0;
 if (!i7) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, 28) | 0;
 do if (!i4) i1 = i2 + 8 | 0; else {
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = i3;
  i1 = i3 + 1 | 0;
  i8 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, i1 << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i8;
  if (!i8) {
   i1 = i2 + 8 | 0;
   mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, i4 | 0);
   break;
  }
  i1 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, i1 << 3 | 0) | 0;
  HEAP32[i4 + 4 >> 2] = i1;
  if (!i1) {
   i1 = i2 + 8 | 0;
   mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0);
   mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, i4 | 0);
   break;
  }
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = i5;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = 1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i7 >> 2] = i4;
  i8 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0, i3 << 2 | 0) | 0;
  HEAP32[i7 + 4 >> 2] = i8;
  if (!i8) {
   i5 = HEAP32[i7 >> 2] | 0;
   i8 = i2 + 8 | 0;
   mftCall_vii(HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0);
   mftCall_vii(HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0);
   mftCall_vii(HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, i5 | 0);
   mftCall_vii(HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7 | 0);
   i8 = 0;
   return i8 | 0;
  } else {
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 16 >> 2] = i3;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = i5;
   i8 = i7;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = 0;
 mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7 | 0);
 i8 = 0;
 return i8 | 0;
}

function __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj509ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 32 | 0, i6);
 i1 = i1 + 48 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEE14handleAccessorILj510ENS_22PxRepXPropertyAccessorILj510ES4_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESC_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 2 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 2 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 2 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 2 | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_(i7, i8, i5, i6) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, f9 = f0, f10 = f0;
 i2 = (HEAP16[i6 + 12 >> 1] | HEAP16[i5 + 12 >> 1]) & 65535;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i2 & 1 | 0) {
  HEAP32[i3 >> 2] = i2 | 2;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  return;
 }
 i3 = (HEAPU8[i5 + 14 >> 0] | 0) >>> 4;
 i2 = (HEAPU8[i6 + 14 >> 0] | 0) >>> 4;
 switch ((i3 >>> 0 < i2 >>> 0 ? i2 : i3) | 0) {
 case 0:
  {
   f4 = Math_fround(Math_fround(Math_fround(HEAPF32[i5 >> 2]) + Math_fround(HEAPF32[i6 >> 2])) * Math_fround(.5));
   f1 = Math_fround(Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) + Math_fround(HEAPF32[i6 + 4 >> 2])) * Math_fround(.5));
   break;
  }
 case 1:
  {
   f10 = Math_fround(HEAPF32[i5 >> 2]);
   f4 = Math_fround(HEAPF32[i6 >> 2]);
   f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f4 = f10 < f4 ? f10 : f4;
   f1 = f9 < f1 ? f9 : f1;
   break;
  }
 case 2:
  {
   f4 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(HEAPF32[i6 >> 2]));
   f1 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) * Math_fround(HEAPF32[i6 + 4 >> 2]));
   break;
  }
 case 3:
  {
   f9 = Math_fround(HEAPF32[i5 >> 2]);
   f4 = Math_fround(HEAPF32[i6 >> 2]);
   f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
   f1 = Math_fround(HEAPF32[i6 + 4 >> 2]);
   f4 = f9 > f4 ? f9 : f4;
   f1 = f10 > f1 ? f10 : f1;
   break;
  }
 default:
  {
   f4 = Math_fround(0.0);
   f1 = Math_fround(0.0);
  }
 }
 f10 = Math_fround(f4 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 f9 = Math_fround(f1 * Math_fround(HEAPF32[i8 >> 2]));
 i8 = f10 > Math_fround(0.0);
 f10 = i8 ? f10 : Math_fround(0.0);
 i8 = Math_fround(f9 - f10) >= Math_fround(0.0);
 HEAPF32[i7 + 4 >> 2] = f10;
 HEAPF32[i7 >> 2] = i8 ? f9 : f10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN20SphericalHarmonicsL211AddWeightedERK20SphericalHarmonicsL1f(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 72 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 40 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 24 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 76 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 44 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 28 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 80 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 12 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 48 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 20 >> 2]) * Math_fround(2.0));
 HEAPF32[i4 + 84 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) * Math_fround(2.0));
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = i4 + 52 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = i4 + 88 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = 0;
 do {
  f7 = Math_fround(Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]) * f3);
  i6 = i2 + (i1 << 2) | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 27);
 STACKTOP = i5;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i14, i5, i1) {
 i14 = i14 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 4 | 0;
 i1 = i13;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i12 = i14 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i14 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
 i9 = i5 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i13;
  return;
 }
 i2 = i1;
 while (1) {
  __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + 16 | 0, i14);
  i4 = i2 + 20 | 0;
  i8 = i2 + 24 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i5 = (i3 - i1 | 0) / 36 | 0;
  HEAP32[i11 >> 2] = i5;
  i6 = HEAP32[i12 >> 2] | 0;
  i7 = i6 + 4 | 0;
  if (i7 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i5;
   HEAP32[i12 >> 2] = i7;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i11, 4);
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
  }
  if ((i1 | 0) != (i3 | 0)) do {
   __ZN23ShaderVariantCollection11VariantInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i14);
   i1 = i1 + 36 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i9 | 0)) break; else i2 = i1;
 }
 STACKTOP = i13;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 4 | 0;
 i6 = i9;
 i7 = i8 + 476 | 0;
 i2 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8;
 HEAP16[i6 >> 1] = i2;
 HEAP16[i6 + 2 >> 1] = __ZNK13TranslateGLES4FuncE15CompareFunction(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, ((i2 & 65535) >>> 8 & 65535) << 24 >> 24) | 0;
 i2 = i8 + 480 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((_memcmp(i6, i2, 4) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((_memcmp(i2, i6, 4) | 0) >= 0) {
     i2 = 9;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  i8 = i8 + 16 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = __Znwj(20) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 480 >> 2] | 0, i1);
 i8 = i8 + 484 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 16 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN4FMOD8ChannelI9setVolumeEf(i6, f2) {
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f7 = f0, d8 = 0.0;
 HEAPF32[i6 + 136 >> 2] = f2;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i1 + 368 >> 2] | 0;
 if (i3) {
  f7 = Math_fround(HEAPF32[i6 + 76 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 + 320 >> 2]));
  f4 = Math_fround(HEAPF32[i6 + 80 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 324 >> 2]));
  f5 = Math_fround(HEAPF32[i6 + 84 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 328 >> 2]));
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f4 * f4)) + Math_fround(f5 * f5))));
  f5 = Math_fround(Math_fround(+mftCall_fif(i3 | 0, HEAP32[i6 + 20 >> 2] | 0, +f5)) + Math_fround(-1.0));
  f2 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i6 + 144 >> 2])) + Math_fround(1.0)) * f2);
 }
 i1 = HEAP32[i6 + 68 >> 2] | 0;
 if (!i1) {
  f7 = f2;
  i3 = i6 + 160 | 0;
  i3 = HEAP8[i3 >> 0] | 0;
  i3 = i3 << 24 >> 24 == 0;
  i6 = i6 + 164 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  d8 = +f7;
  d8 = i3 ? d8 : 0.0;
  _JS_Sound_SetVolume(i6 | 0, +d8);
  return 0;
 }
 while (1) {
  f4 = Math_fround(HEAPF32[i1 + 44 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
  i3 = i1;
  i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
  if (!i1) break;
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (!i1) break;
  if (HEAP8[i1 + 16 >> 0] | 0) break;
  if ((HEAP32[i1 + 12 >> 2] | 0) != (i3 & 65535 | 0)) break;
  f2 = Math_fround(f2 * Math_fround(f4 * f5));
 }
 f7 = Math_fround(f2 * Math_fround(f4 * f5));
 i3 = i6 + 160 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 i3 = i3 << 24 >> 24 == 0;
 i6 = i6 + 164 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 d8 = +f7;
 d8 = i3 ? d8 : 0.0;
 _JS_Sound_SetVolume(i6 | 0, +d8);
 return 0;
}

function __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 4 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i5 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i6, i5 + 16 | 0, gb + 899468 | 0, 0);
 i1 = i5 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 20 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = HEAP16[i1 >> 1] | 0;
 i1 = i6 & 65535;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 i2 = i9 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i12 = 0;
  return i12 | 0;
 }
 i8 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i12 + 8 >> 2] | 0;
 while (1) {
  i4 = i8 + (i1 << 3) | 0;
  i3 = i2;
  i2 = i5 + (i1 << 2) | 0;
  i7 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP16[i4 >> 1] | 0) == i6 << 16 >> 16) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i10 = 11;
   break;
  }
 }
 if ((i10 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i12 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i10 = i12 + 32 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 if ((i7 | 0) != (i1 | 0)) {
  i10 = HEAP16[i8 + (i1 << 3) >> 1] | 0;
  HEAP16[i4 >> 1] = i10;
  HEAP32[i8 + (i7 << 3) + 4 >> 2] = HEAP32[i8 + (i1 << 3) + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
  i1 = i10 & 65535;
  i1 = i1 + ~(i1 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i9 + (((i1 >>> 16 ^ i1) & (HEAP32[i11 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i5 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i7;
 }
 i12 = i12 + 28 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i4 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  STACKTOP = i8;
  return;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L24 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L24;
   i9 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i9 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 f10 = Math_fround(+_strtod(i6, i4));
 mftCall_vif(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i7 + 24 >> 2] | 0, +f10);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 12, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 2;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj77ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj75ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   i4 = (_strcasecmp(i1, gb + 1087447 | 0) | 0) == 0;
   mftCall_vii(i5 | 0, HEAP32[i6 + 24 >> 2] | 0, i4 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738066 | 0, gb + 738082 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 946522 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 734913 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 800705 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, gb + 479385 | 0, i1, 0);
 i7 = i6 + 8 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 4 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i3 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i7 = i11 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i3);
 i3 = i6;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i10);
 i2 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i2 | -2147483648;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 12, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 2;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx14PxsAABBManager15setVolumeBoundsEjRKNS_9PxBounds3E(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i4 = i1 + 12 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i7 = ((i7 | 0) < 0 ? ~i7 : i7 | -2147483648) + -16 & -16;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = ((i5 | 0) < 0 ? ~i5 : i5 | -2147483648) + -16 & -16;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = ((i1 | 0) < 0 ? ~i1 : i1 | -2147483648) + -16 & -16;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = ((i2 | 0) < 0 ? ~i2 : i2 | -2147483648) + 16 & -16 | 1;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = ((i3 | 0) < 0 ? ~i3 : i3 | -2147483648) + 16 & -16 | 1;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = ((i4 | 0) < 0 ? ~i4 : i4 | -2147483648) + 16 & -16 | 1;
 i6 = i8 >>> 1;
 if (i8 & 1 | 0) {
  i8 = HEAP32[i9 + 300 >> 2] | 0;
  HEAP32[i8 + (i6 * 24 | 0) >> 2] = i7;
  HEAP32[i8 + (i6 * 24 | 0) + 4 >> 2] = i5;
  HEAP32[i8 + (i6 * 24 | 0) + 8 >> 2] = i1;
  HEAP32[i8 + (i6 * 24 | 0) + 12 >> 2] = i2;
  HEAP32[i8 + (i6 * 24 | 0) + 16 >> 2] = i3;
  HEAP32[i8 + (i6 * 24 | 0) + 20 >> 2] = i4;
  i3 = HEAP32[(HEAP32[i9 + 260 >> 2] | 0) + ((HEAP32[(HEAP32[i9 + 312 >> 2] | 0) + (i6 << 2) >> 2] | 0) >>> 1 << 2) >> 2] | 0;
  i1 = (HEAP32[i9 + 356 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = 1 << (i3 & 31);
  if (i2 & i3 | 0) return;
  HEAP32[i1 >> 2] = i2 | i3;
  return;
 }
 i10 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i10 + (i6 * 24 | 0) >> 2] = i7;
 HEAP32[i10 + (i6 * 24 | 0) + 4 >> 2] = i5;
 HEAP32[i10 + (i6 * 24 | 0) + 8 >> 2] = i1;
 HEAP32[i10 + (i6 * 24 | 0) + 12 >> 2] = i2;
 HEAP32[i10 + (i6 * 24 | 0) + 16 >> 2] = i3;
 HEAP32[i10 + (i6 * 24 | 0) + 20 >> 2] = i4;
 i1 = i8 >>> 6;
 i3 = 1 << (i6 & 31);
 if (HEAP32[(HEAP32[i9 + 96 >> 2] | 0) + (i1 << 2) >> 2] & i3 | 0) return;
 i1 = (HEAP32[i9 + 68 >> 2] | 0) + (i1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 & i3 | 0) return;
 HEAP32[i1 >> 2] = i2 | i3;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = -1;
  HEAP32[i6 + 4 >> 2] = -1;
  HEAP32[i6 + 8 >> 2] = -1;
  HEAP32[i6 + 12 >> 2] = -1;
  HEAP32[i6 + 16 >> 2] = -1;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 << 5 | 0, 4) | 0;
  i2 = i3 + (i2 << 5) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = 0;
    i1 = i1 + 32 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i7 << 5) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z41OffMeshLink_Set_Custom_PropStartTransformP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!i2) i5 = 0; else i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 i6 = i8 + 48 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 12; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 14;
   }
  }
  if ((i7 | 0) == 12) i7 = 14;
  if ((i7 | 0) == 14) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 if (!i5) i1 = 0; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP8[i8 + 97 >> 0] = HEAP8[i8 + 96 >> 0] | 0;
 STACKTOP = i9;
 return;
}

function _fmodf(f8, f1) {
 f8 = Math_fround(f8);
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i5 >>> 23 & 255;
 i6 = i7 >>> 23 & 255;
 i9 = i5 & -2147483648;
 i4 = i7 << 1;
 L1 : do if (!i4) i10 = 3; else if ((i7 & 2147483647) >>> 0 > 2139095040 | (i2 | 0) == 255) i10 = 3; else {
  i3 = i5 << 1;
  if (i3 >>> 0 <= i4 >>> 0) {
   f1 = Math_fround(f8 * Math_fround(0.0));
   return Math_fround((i3 | 0) == (i4 | 0) ? f1 : f8);
  }
  if (!i2) {
   i2 = i5 << 9;
   if ((i2 | 0) > -1) {
    i3 = i2;
    i2 = 0;
    do {
     i2 = i2 + -1 | 0;
     i3 = i3 << 1;
    } while ((i3 | 0) > -1);
   } else i2 = 0;
   i3 = i5 << 1 - i2;
  } else i3 = i5 & 8388607 | 8388608;
  if (!i6) {
   i5 = i7 << 9;
   if ((i5 | 0) > -1) {
    i4 = 0;
    do {
     i4 = i4 + -1 | 0;
     i5 = i5 << 1;
    } while ((i5 | 0) > -1);
   } else i4 = 0;
   i6 = i4;
   i7 = i7 << 1 - i4;
  } else i7 = i7 & 8388607 | 8388608;
  i4 = i3 - i7 | 0;
  i5 = (i4 | 0) > -1;
  L23 : do if ((i2 | 0) > (i6 | 0)) {
   while (1) {
    if (i5) if (!i4) break; else i3 = i4;
    i3 = i3 << 1;
    i2 = i2 + -1 | 0;
    i4 = i3 - i7 | 0;
    i5 = (i4 | 0) > -1;
    if ((i2 | 0) <= (i6 | 0)) break L23;
   }
   f1 = Math_fround(f8 * Math_fround(0.0));
   break L1;
  } while (0);
  if (i5) if (!i4) {
   f1 = Math_fround(f8 * Math_fround(0.0));
   break;
  } else i3 = i4;
  if (i3 >>> 0 < 8388608) do {
   i3 = i3 << 1;
   i2 = i2 + -1 | 0;
  } while (i3 >>> 0 < 8388608);
  if ((i2 | 0) > 0) i2 = i3 + -8388608 | i2 << 23; else i2 = i3 >>> (1 - i2 | 0);
  f1 = (HEAP32[tempDoublePtr >> 2] = i2 | i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while (0);
 if ((i10 | 0) == 3) {
  f1 = Math_fround(f8 * f1);
  f1 = Math_fround(f1 / f1);
 }
 return Math_fround(f1);
}

function __ZN7SubMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i8 + 32 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
 }
 i5 = i8 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i2;
 i1 = i8 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 }
 i1 = i8 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i10 = i8 + 8 | 0;
  __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i2;
  i10 = i8 + 8 | 0;
  __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx13NpClothFabric17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 96 | 0;
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i6 >> 2] = HEAP32[gb + 123940 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 123940 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 123940 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[gb + 123940 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[gb + 123940 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[gb + 123940 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[gb + 123940 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[gb + 123940 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i6 | 0, 32) | 0;
 HEAP32[i5 >> 2] = gb + 754779;
 HEAP32[i5 + 4 >> 2] = gb + 827530;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 36;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 1;
 HEAP32[i5 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 754779;
 HEAP32[i4 + 4 >> 2] = gb + 752142;
 HEAP32[i4 + 8 >> 2] = 8;
 HEAP32[i4 + 12 >> 2] = 36;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123972 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123972 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123972 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123972 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123972 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123972 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123972 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123972 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4FMOD8ChannelI33UpdateStartPositionForPitchChangeEff(i4, f2, f3) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, f13 = f0;
 i1 = i4 + 161 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  d8 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i6 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i5 = ~~d8 >>> 0;
  i7 = (HEAP8[i1 >> 0] | 0) == 0;
 } else {
  i6 = i4 + 120 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 4 >> 2] | 0;
  i7 = 0;
 }
 i1 = i4 + 104 | 0;
 i12 = i1;
 i12 = _i64Subtract(i5 | 0, i6 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0) | 0;
 f13 = Math_fround(+(i12 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 i12 = i4 + 140 | 0;
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 i11 = i4 + 152 | 0;
 f10 = Math_fround(f13 * Math_fround(Math_fround(f10 * Math_fround(HEAPF32[i11 >> 2])) / Math_fround(44100.0)));
 i9 = +Math_abs(+f10) >= 1.0 ? (+f10 > 0.0 ? ~~+Math_min(+Math_floor(+f10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f10 - +(~~+f10 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAPF32[i12 >> 2] = f2;
 HEAPF32[i11 >> 2] = f3;
 f2 = Math_fround(f2 * f3);
 f3 = Math_fround(Math_fround(+(i5 >>> 0) + 4294967296.0 * +(i6 >>> 0)) - Math_fround(Math_fround(Math_fround(44100.0) / f2) * Math_fround(+(~~+f10 >>> 0 >>> 0) + 4294967296.0 * +(i9 >>> 0))));
 i6 = +Math_abs(+f3) >= 1.0 ? (+f3 > 0.0 ? ~~+Math_min(+Math_floor(+f3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f3 - +(~~+f3 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAP32[i1 >> 2] = ~~+f3 >>> 0;
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = HEAP32[i4 + 164 >> 2] | 0;
 if (!i7) {
  d8 = 1.0e-07;
  _JS_Sound_SetPitch(i1 | 0, +d8);
  return;
 }
 d8 = +Math_fround(f2 / Math_fround(44100.0));
 _JS_Sound_SetPitch(i1 | 0, +d8);
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = __Z34scripting_class_get_declaring_typeP11Il2CppClass(i5) | 0;
 if (!i1) i6 = i7 + 11 | 0; else {
  __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i1, i7);
  i4 = i7 + 11 | 0;
  i1 = HEAP8[i4 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) {
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0;
  } else {
   i3 = i1 & 255;
   i1 = 10;
  }
  if ((i3 | 0) == (i1 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i7, i1, 1, i1, i1, 0, 0);
   if ((HEAP8[i4 >> 0] | 0) > -1) i2 = 9; else i2 = 10;
  } else if (i2) i2 = 10; else i2 = 9;
  if ((i2 | 0) == 9) {
   HEAP8[i4 >> 0] = i3 + 1;
   i1 = i7;
  } else if ((i2 | 0) == 10) {
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i7 + 4 >> 2] = i3 + 1;
  }
  i6 = i1 + i3 | 0;
  HEAP8[i6 >> 0] = 47;
  HEAP8[i6 + 1 >> 0] = 0;
  i6 = i4;
 }
 i4 = __Z24scripting_class_get_nameP11Il2CppClass(i5) | 0;
 i5 = _strlen(i4) | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i5 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i5 - i3 + i1 | 0, i1, i1, 0, i5, i4);
  return;
 }
 if (!i5) return;
 i2 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 _memcpy(i2 + i1 | 0, i4 | 0, i5 | 0) | 0;
 i1 = i1 + i5 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i6 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 return;
}

function __ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i3 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i4 = i2;
  i3 = i2;
  i2 = 12;
 } else {
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i4 >>> 0 < i2 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 5;
     break;
    } else i1 = i2;
   } else {
    if (i2 >>> 0 >= i4 >>> 0) {
     i2 = 10;
     break;
    }
    i5 = i1 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (!i2) {
     i2 = 9;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 5) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  } else if ((i2 | 0) == 10) {
   HEAP32[i3 >> 2] = i1;
   i4 = i1;
   i2 = 12;
   break;
  }
 } while (0);
 if ((i2 | 0) == 12) if (i1) {
  i8 = i1;
  i8 = i8 + 20 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = 77;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5IMGUI25RestoreGUIStatePropertiesER8GUIStateR10InputEventRNS_23GUIStatePropertiesCacheE(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i9 = i6 + 96 | 0;
 i2 = i6 + 108 | 0;
 i3 = i2;
 i4 = i8;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 if (__Z20InvertMatrix4x4_FullPKfPf(i8, i1) | 0) {
  i3 = i2;
  i4 = i8;
  i5 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i3 = i6 + 172 | 0;
  i4 = i1;
  i5 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i1 = HEAP32[i6 + 100 >> 2] | 0;
  if ((HEAP32[i9 >> 2] | 0) != (i1 | 0)) __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i9, i7, i1 + -56 | 0);
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017878 | 0, 0, gb + 1017283 | 0, 258, 1, 0, 0, 0);
 i5 = HEAP32[i8 + 68 >> 2] | 0;
 i7 = HEAP32[i8 + 72 >> 2] | 0;
 i9 = HEAP32[i8 + 76 >> 2] | 0;
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 64 >> 2];
 HEAP32[i6 + 16 >> 2] = i5;
 HEAP32[i6 + 20 >> 2] = i7;
 HEAP32[i6 + 24 >> 2] = i9;
 i9 = HEAP32[i8 + 84 >> 2] | 0;
 i7 = HEAP32[i8 + 88 >> 2] | 0;
 i5 = HEAP32[i8 + 92 >> 2] | 0;
 HEAP32[i6 + 44 >> 2] = HEAP32[i8 + 80 >> 2];
 HEAP32[i6 + 48 >> 2] = i9;
 HEAP32[i6 + 52 >> 2] = i7;
 HEAP32[i6 + 56 >> 2] = i5;
 i5 = HEAP32[i8 + 100 >> 2] | 0;
 i7 = HEAP32[i8 + 104 >> 2] | 0;
 i9 = HEAP32[i8 + 108 >> 2] | 0;
 HEAP32[i6 + 28 >> 2] = HEAP32[i8 + 96 >> 2];
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP32[i6 + 36 >> 2] = i7;
 HEAP32[i6 + 40 >> 2] = i9;
 HEAP32[i6 + 60 >> 2] = HEAPU8[i8 + 112 >> 0];
 STACKTOP = i10;
 return;
}

function __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i10, i12) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 HEAPF32[i10 + 4 >> 2] = Math_fround(inf);
 HEAP32[i10 >> 2] = 0;
 HEAPF32[i10 + 32 >> 2] = Math_fround(inf);
 HEAP32[i10 + 28 >> 2] = 0;
 i13 = i10 + 56 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i11 = i10 + 68 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 i7 = i1;
 i5 = i1;
 i2 = i9 << 4 >> 4;
 L1 : while (1) {
  while (1) {
   if (!i2) break L1;
   i3 = (i2 | 0) / 2 | 0;
   i4 = i5 + (i3 << 4) | 0;
   if (Math_fround(HEAPF32[i4 >> 2]) < f6) break; else i2 = i3;
  }
  i5 = i4 + 16 | 0;
  i2 = i2 + -1 - i3 | 0;
 }
 if ((i5 | 0) != (i1 + (i9 << 4) | 0)) if (!(f6 < Math_fround(HEAPF32[i5 >> 2]))) {
  i13 = -1;
  return i13 | 0;
 }
 i7 = i5 - i7 >> 4;
 i8 = i9 - i7 | 0;
 i2 = i9 + 1 | 0;
 HEAP32[i11 >> 2] = i2;
 i3 = i10 + 72 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i2 >>> 0) {
  i9 = i4 << 1;
  i2 = i9 >>> 0 > i2 >>> 0 ? i9 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 4, 4, i10 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i13 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i10 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i11 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i13 >> 2] = i1;
   break;
  }
 } while (0);
 i11 = i1 + (i7 << 4) | 0;
 _memmove(i11 + 16 | 0, i11 | 0, i8 << 4 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i12 + 12 >> 2];
 i13 = i11 - (HEAP32[i13 >> 2] | 0) >> 4;
 return i13 | 0;
}

function __ZN11UnityEngine15PlatformWrapper14GetLicenseTypeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i4 = __Z16GetBuildSettingsv() | 0;
 i1 = i4 + 108 | 0;
 if (!(HEAP8[i4 + 109 >> 0] | 0)) i2 = (HEAP8[i1 >> 0] | 0) == 0; else {
  i1 = HEAP16[i1 >> 1] | 0;
  if ((i1 & 255) << 24 >> 24) {
   i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP32[i3 + 12 >> 2] = i4;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i2 + 4 >> 2] = i4;
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 8 >> 2] = -2147483632;
   HEAP32[i3 + 4 >> 2] = 12;
   i1 = i4;
   i2 = gb + 1040522 | 0;
   i3 = i1 + 12 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   HEAP8[i4 + 12 >> 0] = 0;
   STACKTOP = i5;
   return;
  }
  if ((i1 & 65535) < 256) i2 = 1; else {
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
   HEAP8[i3 + 11 >> 0] = 8;
   i4 = i3;
   HEAP32[i4 >> 2] = 1635148897;
   HEAP32[i4 + 4 >> 2] = 1684366190;
   HEAP8[i3 + 8 >> 0] = 0;
   STACKTOP = i5;
   return;
  }
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i3 + 11 | 0;
 if (i2) {
  HEAP8[i1 >> 0] = 8;
  i4 = i3;
  HEAP32[i4 >> 2] = 1936876912;
  HEAP32[i4 + 4 >> 2] = 1818324591;
  HEAP8[i3 + 8 >> 0] = 0;
  STACKTOP = i5;
  return;
 } else {
  HEAP8[i1 >> 0] = 3;
  HEAP8[i3 >> 0] = HEAP8[gb + 1040535 >> 0] | 0;
  HEAP8[i3 + 1 >> 0] = HEAP8[gb + 1040535 + 1 >> 0] | 0;
  HEAP8[i3 + 2 >> 0] = HEAP8[gb + 1040535 + 2 >> 0] | 0;
  HEAP8[i3 + 3 >> 0] = 0;
  STACKTOP = i5;
  return;
 }
}

function __Z39OffMeshLink_Set_Custom_PropEndTransformP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!i2) i5 = 0; else i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 i6 = i8 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i7 = 12; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 12; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i7 = 14;
   }
  }
  if ((i7 | 0) == 12) i7 = 14;
  if ((i7 | 0) == 14) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i6 >> 2] | 0) | 0;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 if (!i5) i1 = 0; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP8[i8 + 97 >> 0] = HEAP8[i8 + 96 >> 0] | 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = (_strtoul(i1, i5, 10) | 0) & 255;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN23UnityPurchasingSettings8TransferI14SafeBinaryReadEEvRT_(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i4 = i3 + 8 | 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047713 | 0, i5, i6, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i7 + 16 | 0;
   i9 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i9 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i4, 1);
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i3 = i3 + 9 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041676 | 0, i5, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i9 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i9 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i9 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i3, i6, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i3 = i3 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i1 + (i2 << 2) | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function _tt_cmap13_char_map_binary(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i3 = HEAP32[i11 + 16 >> 2] | 0;
 i9 = HEAPU8[i3 + 13 >> 0] << 16 | HEAPU8[i3 + 12 >> 0] << 24 | HEAPU8[i3 + 14 >> 0] << 8 | HEAPU8[i3 + 15 >> 0];
 i2 = HEAP32[i12 >> 2] | 0;
 if (!i9) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = i1 << 24 >> 24 != 0;
 do if (i7) if ((i2 | 0) == -1) {
  i12 = 0;
  return i12 | 0;
 } else {
  i10 = i2 + 1 | 0;
  break;
 } else i10 = i2; while (0);
 i5 = i3 + 16 | 0;
 i1 = 0;
 i4 = i9;
 L10 : while (1) {
  while (1) {
   i2 = (i1 + i4 | 0) >>> 1;
   i3 = i5 + (i2 * 12 | 0) + 4 | 0;
   i13 = i3 + -4 | 0;
   i3 = i3 + 4 | 0;
   i6 = i3 + -4 | 0;
   i6 = HEAPU8[i6 + 1 >> 0] << 16 | HEAPU8[i6 >> 0] << 24 | HEAPU8[i6 + 2 >> 0] << 8 | HEAPU8[i6 + 3 >> 0];
   if (i10 >>> 0 < (HEAPU8[i13 + 1 >> 0] << 16 | HEAPU8[i13 >> 0] << 24 | HEAPU8[i13 + 2 >> 0] << 8 | HEAPU8[i13 + 3 >> 0]) >>> 0) break;
   if (i10 >>> 0 <= i6 >>> 0) {
    i8 = 11;
    break L10;
   }
   i1 = i2 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i1 = 0;
    break L10;
   }
  }
  if (i1 >>> 0 < i2 >>> 0) i4 = i2; else {
   i1 = 0;
   break;
  }
 }
 if ((i8 | 0) == 11) i1 = HEAPU8[i3 + 1 >> 0] << 16 | HEAPU8[i3 >> 0] << 24 | HEAPU8[i3 + 2 >> 0] << 8 | HEAPU8[i3 + 3 >> 0];
 if (!i7) {
  i13 = i1;
  return i13 | 0;
 }
 i5 = HEAP32[i11 >> 2] | 0;
 if (i10 >>> 0 > i6 >>> 0) {
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i9 | 0)) {
   i13 = 0;
   return i13 | 0;
  }
 }
 i3 = i11 + 24 | 0;
 HEAP8[i3 >> 0] = 1;
 i4 = i11 + 28 | 0;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i11 + 36 >> 2] = i2;
 if ((i1 | 0) == 0 ? 1 : i1 >>> 0 >= (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
  _tt_cmap13_next(i11);
  if (!(HEAP8[i3 >> 0] | 0)) i1 = 0; else i1 = HEAP32[i11 + 32 >> 2] | 0;
 } else HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 i13 = i1;
 return i13 | 0;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 24 | 0;
 i8 = i10;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 24 | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i7 = i8 + 16 | 0;
 HEAP32[i7 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 24 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i5 = i2 + (i1 * 24 | 0) | 0;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = i2 + (i4 * 24 | 0);
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i3, i8);
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i9 + 4 | 0;
  do {
   i2 = i1 + -24 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -20 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i8 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i10;
 return;
}

function __ZN9LensFlare8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i1);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 40 | 0, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 72 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 36 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) i5 = i6; else {
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == 0 | i3 ^ 1) i5 = i6; else if (!(HEAP8[i1 >> 0] | 0)) i5 = i6; else {
   HEAP32[i5 >> 2] = i1;
   i5 = _strtoul(i1, i5, 10) | 0;
   mftCall_vii(i4 | 0, HEAP32[i6 + 24 >> 2] | 0, i5 | 0);
   i5 = i6;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i7 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP8[i7 >> 0] = 1;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN14NavMeshManager14DistanceToEdgeEP10NavMeshHitRK8Vector3fRK13dtQueryFilter(i1, i9, i2, i5) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i6 = i10 + 12 | 0;
 i8 = i10 + 8 | 0;
 i7 = i1 + 112 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i4 | 0) {
  __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i4, i2, i1 + 20 | 0, i5, i3, i6) | 0;
  i2 = i3;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (!((i1 | 0) == 0 & (i2 | 0) == 0)) {
   HEAP32[i8 >> 2] = 0;
   i3 = i9 + 24 | 0;
   i4 = i9 + 12 | 0;
   i7 = __ZNK14dtNavMeshQuery18findDistanceToWallEyPKfPK13dtQueryFilterPfS5_S5_Pj(HEAP32[i7 >> 2] | 0, i1, i2, i6, i5, i3, i9, i4, i8) | 0;
   i1 = i9 + 28 | 0;
   HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
   if ((i7 | 0) < 0) {
    HEAP32[i9 >> 2] = HEAP32[gb + 62500 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
    HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
    HEAPF32[i3 >> 2] = Math_fround(inf);
    HEAP32[i1 >> 2] = 0;
    i1 = 0;
    i2 = 0;
   } else {
    i1 = 1;
    i2 = 1;
   }
   HEAP32[i9 + 32 >> 2] = i2;
   i9 = i1;
   STACKTOP = i10;
   return i9 | 0;
  }
 };
 HEAP32[i9 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 i8 = i9 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i9 + 24 >> 2] = Math_fround(inf);
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = 0;
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z32WebCamTexture_CUSTOM_GetPixels32P12Il2CppObjectP11Il2CppArray(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = i8 + 12 | 0;
 if (!i7) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i2) {
  i4 = i7;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
 if (!i1) i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0, 4, Math_imul(i2, i4) | 0) | 0; else {
  i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
  if ((i3 | 0) != (Math_imul(i2, i4) | 0)) {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i4;
   HEAP32[i6 + 8 >> 2] = i2;
   __Z6FormatPKcz(i5, gb + 895200 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 894914 | 0, 282, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 __ZNK17BaseWebCamTexture9GetPixelsE13TextureFormatPvj(i2, 4, i7, (__Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0) << 2) | 0;
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 89478485 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 178956970;
 i1 = (i2 - i1 | 0) / 24 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 24 | 0) | 0;
 i2 = i4 + (i1 * 24 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 24 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4 + (i1 * 24 | 0) + 12 | 0, i6 + 12 | 0);
 i5 = i2 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i6 = i1;
   i1 = i1 + -24 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -24 | 0, i1);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i6 + -12 | 0);
   i2 = i3 + -24 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
  i1 = i1 + -24 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i9, i10, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = (i3 - i8 | 0) / 12 | 0;
 if ((i10 | 0) < 2) {
  STACKTOP = i7;
  return;
 }
 i5 = (i10 + -2 | 0) / 2 | 0;
 if ((i5 | 0) < (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 << 1 | 1;
 i2 = i8 + (i1 * 12 | 0) | 0;
 i4 = i1 + 1 | 0;
 if ((i4 | 0) < (i10 | 0)) {
  i12 = i2 + 12 | 0;
  i11 = __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i9, i2, i12) | 0;
  i2 = i11 ? i12 : i2;
  i1 = i11 ? i4 : i1;
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i9, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 while (1) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  if ((i5 | 0) < (i1 | 0)) break;
  i1 = i1 << 1 | 1;
  i3 = i8 + (i1 * 12 | 0) | 0;
  i4 = i1 + 1 | 0;
  if ((i4 | 0) < (i10 | 0)) {
   i11 = i3 + 12 | 0;
   i12 = __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i9, i3, i11) | 0;
   i3 = i12 ? i11 : i3;
   i1 = i12 ? i4 : i1;
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_(i9, i3, i6) | 0) break; else {
   i12 = i2;
   i2 = i3;
   i3 = i12;
  }
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i7;
 return;
}

function __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_(i8, i1, i9, i10, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = (i3 - i8 | 0) / 12 | 0;
 if ((i10 | 0) < 2) {
  STACKTOP = i7;
  return;
 }
 i5 = (i10 + -2 | 0) / 2 | 0;
 if ((i5 | 0) < (i1 | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 << 1 | 1;
 i2 = i8 + (i1 * 12 | 0) | 0;
 i4 = i1 + 1 | 0;
 if ((i4 | 0) < (i10 | 0)) {
  i12 = i2 + 12 | 0;
  i11 = __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i9, i2, i12) | 0;
  i2 = i11 ? i12 : i2;
  i1 = i11 ? i4 : i1;
 }
 if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i9, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 while (1) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  if ((i5 | 0) < (i1 | 0)) break;
  i1 = i1 << 1 | 1;
  i3 = i8 + (i1 * 12 | 0) | 0;
  i4 = i1 + 1 | 0;
  if ((i4 | 0) < (i10 | 0)) {
   i11 = i3 + 12 | 0;
   i12 = __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i9, i3, i11) | 0;
   i3 = i12 ? i11 : i3;
   i1 = i12 ? i4 : i1;
  }
  if (__ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_(i9, i3, i6) | 0) break; else {
   i12 = i2;
   i2 = i3;
   i3 = i12;
  }
 }
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i5 = 0; else {
  i1 = i6 * 20 | 0;
  if (!i1) i5 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i5 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 660493 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = i7 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + (i2 * 20 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
   __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE(i1 + 8 | 0, i2 + 8 | 0);
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 20 | 0;
  }
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = i1 + (i4 * 20 | 0) | 0;
  if ((i4 | 0) > 0) do {
   i4 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if (i2 | 0) {
     i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 | 0);
    }
   }
   i1 = i1 + 20 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i1 = i7 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 | 0);
 HEAP32[i7 >> 2] = i5;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIS4_S8_EE(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i5 >> 2] = 5;
 HEAP32[i5 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(804, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
 i6 = i2 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 _memcpy(i7 + 32 | 0, i11 + 16 | 0, 772) | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i12 = i10 + 9 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5writeEPKwi(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 __THREW__ = 0;
 invoke_vii(fb + 4509 | 0, i3 | 0, i5 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i5;
  i3 = i5;
  i4 = 8;
 } else {
  do if ((i2 | 0) != 0 & (HEAP8[i3 >> 0] | 0) != 0) {
   i7 = HEAP32[i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 48 >> 2] | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    if ((i1 | 0) == (i2 | 0)) break;
    i7 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 1 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break;
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i3);
   i2 = i5;
   i3 = i5;
   i4 = 8;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i3);
 } while (0);
 do if ((i4 | 0) == 8) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5writeEPKci(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 __THREW__ = 0;
 invoke_vii(fb + 4507 | 0, i3 | 0, i5 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i2 = i5;
  i3 = i5;
  i4 = 8;
 } else {
  do if ((i2 | 0) != 0 & (HEAP8[i3 >> 0] | 0) != 0) {
   i7 = HEAP32[i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 48 >> 2] | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) {
    if ((i1 | 0) == (i2 | 0)) break;
    i7 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i7 | 0, HEAP32[i7 + 16 >> 2] | 1 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (!(i7 & 1)) break;
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i3);
   i2 = i5;
   i3 = i5;
   i4 = 8;
   break L1;
  } while (0);
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i3);
 } while (0);
 do if ((i4 | 0) == 8) {
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i2 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4peekEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 HEAP32[i5 + 4 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i2 | 0, i5 | 0, 1);
 i4 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i4 & 1) {
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i4 = i5;
  i2 = i5;
  i6 = 10;
 } else do if (!(HEAP8[i2 >> 0] | 0)) i1 = -1; else {
  i2 = HEAP32[i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  if ((i3 | 0) != (HEAP32[i2 + 16 >> 2] | 0)) {
   i1 = HEAPU8[i3 >> 0] | 0;
   break;
  }
  __THREW__ = 0;
  i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   if ((i2 | 0) != -1) {
    i1 = i2;
    break;
   }
   i4 = i5 + (HEAP32[(HEAP32[i5 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i4 | 0, HEAP32[i4 + 16 >> 2] | 2 | 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (!(i4 & 1)) {
    i1 = -1;
    break;
   }
  }
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i4 = i5;
  i2 = i5;
  i6 = 10;
  break L1;
 } while (0); while (0);
 do if ((i6 | 0) == 10) {
  ___cxa_begin_catch(i3 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i4 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   ___cxa_end_catch();
   i1 = -1;
   break;
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i6);
  } else ___resumeException(i2 | 0);
 } while (0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__211__libcpp_db17__insert_iteratorEPv(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i7 = i11 + 4 | 0;
 i10 = i1 + 20 | 0;
 i8 = i1 + 16 | 0;
 i5 = i1 + 12 | 0;
 i1 = (HEAP32[i8 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 if (((HEAP32[i10 >> 2] | 0) + 1 | 0) >>> 0 > i1 >> 2 >>> 0) {
  i3 = __ZNSt3__212__next_primeEj((i1 >> 1) + 1 | 0) | 0;
  i4 = _calloc(i3, 4) | 0;
  if (!i4) {
   i11 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i11);
   ___cxa_throw(i11 | 0, gb + 13048 | 0, fb + 3215 | 0);
  }
  i1 = HEAP32[i5 >> 2] | 0;
  while (1) {
   if ((i1 | 0) == (HEAP32[i8 >> 2] | 0)) break;
   i2 = HEAP32[i1 >> 2] | 0;
   while (1) {
    if (!i2) break;
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    i13 = ((__ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i7, i6, 4) | 0) >>> 0) % (i3 >>> 0) | 0;
    i14 = i2 + 4 | 0;
    i12 = HEAP32[i14 >> 2] | 0;
    i13 = i4 + (i13 << 2) | 0;
    HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i13 >> 2] = i2;
    i2 = i12;
   }
   i1 = i1 + 4 | 0;
  }
  _free(HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = i4;
  HEAP32[i8 >> 2] = i4 + (i3 << 2);
 }
 HEAP32[i6 >> 2] = i9;
 i1 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i7, i6, 4) | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i14 = i14 + (((i1 >>> 0) % ((HEAP32[i8 >> 2] | 0) - i14 >> 2 >>> 0) | 0) << 2) | 0;
 i1 = HEAP32[i14 >> 2] | 0;
 i2 = _malloc(12) | 0;
 HEAP32[i14 >> 2] = i2;
 if (!i2) {
  i14 = ___cxa_allocate_exception(4) | 0;
  __ZNSt9bad_allocC2Ev(i14);
  ___cxa_throw(i14 | 0, gb + 13048 | 0, fb + 3215 | 0);
 } else {
  HEAP32[i2 >> 2] = i9;
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i11;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE5eraseERS6_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i11 + 20 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  return i11 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i8 = HEAP32[i11 + 12 >> 2] | 0;
 i2 = i8 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i11 = 0;
  return i11 | 0;
 }
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = HEAP32[i11 + 8 >> 2] | 0;
 while (1) {
  i3 = i2;
  i2 = i4 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i7 + (i5 << 3) >> 2] | 0) == (i6 | 0)) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i9 = 11;
   break;
  }
 }
 if ((i9 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i11 + 36 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i9 = i11 + 32 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  i9 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
  HEAP32[i7 + (i5 << 3) >> 2] = i9;
  HEAP32[i7 + (i5 << 3) + 4 >> 2] = HEAP32[i7 + (i1 << 3) + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = i9 + ~(i9 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i8 + (((i1 >>> 16 ^ i1) & (HEAP32[i10 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i11 = i11 + 28 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 i11 = 1;
 return i11 | 0;
}

function __ZNK9Rigidbody20GetWorldCenterOfMassEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i16 = i3 + 28 | 0;
 i2 = i2 + 52 | 0;
 i17 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i17 >> 2] | 0) + 84 >> 2] | 0, i7 | 0, i17 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i16 | 0, i2 | 0);
 f10 = Math_fround(Math_fround(HEAPF32[i16 + 16 >> 2]) * Math_fround(2.0));
 f12 = Math_fround(Math_fround(HEAPF32[i16 + 20 >> 2]) * Math_fround(2.0));
 f15 = Math_fround(Math_fround(HEAPF32[i16 + 24 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f14 = Math_fround(Math_fround(f13 * f13) + Math_fround(-.5));
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(f10 * f11);
 f9 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f12 * f9));
 f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f15 * f8));
 f6 = Math_fround(Math_fround(f11 * f4) + Math_fround(Math_fround(f10 * f14) + Math_fround(f13 * Math_fround(Math_fround(f15 * f9) - Math_fround(f12 * f8)))));
 f5 = Math_fround(Math_fround(f9 * f4) + Math_fround(Math_fround(f12 * f14) + Math_fround(f13 * Math_fround(Math_fround(f10 * f8) - Math_fround(f15 * f11)))));
 f4 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * Math_fround(Math_fround(f12 * f11) - Math_fround(f10 * f9)))) + Math_fround(f8 * f4));
 f6 = Math_fround(Math_fround(HEAPF32[i7 + 16 >> 2]) + f6);
 f5 = Math_fround(Math_fround(HEAPF32[i7 + 20 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i7 + 24 >> 2]) + f4);
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii(i9, i14, i4, i2, i5, i23, i24, i25, i6, i26, i3, i1, i7, i15, i16, i17, i8, i18, i19, i20, i21, i22) {
 i9 = i9 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i6 = i6 | 0;
 i26 = i26 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i8 = i8 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 687 >> 0] | 0)) return;
 i12 = (i3 | 0) == 3;
 i11 = i9 + 860 | 0;
 i13 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i11 >> 2] | 0, i4) | 0;
 i11 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i11 >> 2] | 0, i3) | 0;
 i10 = (i4 | 0) == 3 ? i6 : i5;
 i7 = i12 ? i8 : i7;
 if ((i18 | 0) <= 0) return;
 i6 = i9 + 416 | 0;
 if ((i19 | 0) > 0) {
  i5 = 0;
  i1 = i22;
 } else return;
 do {
  i3 = i5 + i10 | 0;
  i4 = i5 + i7 | 0;
  if (i12) {
   i2 = 0;
   do {
    i8 = i20 >> i2;
    i9 = i21 >> i2;
    i1 = i22 >> i2;
    i1 = (i1 | 0) < 1 ? 1 : i1;
    mftCall_viiiiiiiiiiiiiii(HEAP32[i6 >> 2] | 0, i14 | 0, i13 | 0, i2 + i23 | 0, i24 | 0, i25 | 0, i3 | 0, i26 | 0, i11 | 0, i2 + i15 | 0, i16 | 0, i17 | 0, i4 | 0, ((i8 | 0) < 1 ? 1 : i8) | 0, ((i9 | 0) < 1 ? 1 : i9) | 0, i1 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i19 | 0));
  } else {
   i2 = 0;
   do {
    i8 = i20 >> i2;
    i9 = i21 >> i2;
    mftCall_viiiiiiiiiiiiiii(HEAP32[i6 >> 2] | 0, i14 | 0, i13 | 0, i2 + i23 | 0, i24 | 0, i25 | 0, i3 | 0, i26 | 0, i11 | 0, i2 + i15 | 0, i16 | 0, i17 | 0, i4 | 0, ((i8 | 0) < 1 ? 1 : i8) | 0, ((i9 | 0) < 1 ? 1 : i9) | 0, i1 | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i19 | 0));
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i18 | 0));
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj467ENS_22PxRepXPropertyAccessorILj467ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 280 | 0;
 i7 = i10 + 168 | 0;
 i4 = i10 + 140 | 0;
 i8 = i10 + 112 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx36PxJointAngularLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 56; else i1 = (HEAP32[i1 >> 2] | 0) + 56 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 176; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i6 = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37316 >> 2] | 0, i2, i4);
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i7 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i7 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i7;
 return;
}

function __ZN15AudioReverbZoneC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i4 + 8 | 0;
 i13 = i4;
 i11 = i2;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i13;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i12;
 HEAP32[i14 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i14, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 175168 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP32[i1 + 116 >> 2] = 0;
 i14 = HEAP32[gb + 171848 + 96 >> 2] | 0;
 i2 = HEAP32[gb + 171848 + 100 >> 2] | 0;
 i13 = HEAP32[gb + 171848 + 104 >> 2] | 0;
 i12 = HEAP32[gb + 171848 + 108 >> 2] | 0;
 i11 = HEAP32[gb + 171848 + 116 >> 2] | 0;
 i10 = HEAP32[gb + 171848 + 120 >> 2] | 0;
 i9 = HEAP32[gb + 171848 + 124 >> 2] | 0;
 i8 = HEAP32[gb + 171848 + 128 >> 2] | 0;
 i7 = HEAP32[gb + 171848 + 140 >> 2] | 0;
 i3 = HEAP32[gb + 171848 + 144 >> 2] | 0;
 i6 = HEAP32[gb + 171848 + 148 >> 2] | 0;
 i5 = HEAP32[gb + 171848 + 152 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[gb + 171848 + 92 >> 2];
 HEAP32[i1 + 64 >> 2] = i14;
 HEAP32[i1 + 72 >> 2] = i13;
 HEAP32[i1 + 76 >> 2] = i12;
 HEAP32[i1 + 80 >> 2] = i11;
 HEAP32[i1 + 84 >> 2] = i10;
 HEAP32[i1 + 88 >> 2] = i9;
 HEAP32[i1 + 92 >> 2] = i8;
 HEAP32[i1 + 96 >> 2] = i7;
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 108 >> 2] = i6;
 HEAP32[i1 + 112 >> 2] = i5;
 HEAP32[i1 + 68 >> 2] = i2;
 HEAP32[i1 + 100 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL34setContactReportPostSolverVelocityERNS0_20ContactStreamManagerE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i1 + 32 >> 2] | 0) | 0) + 1104 >> 2] | 0) + 44 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(HEAP8[i1 + 50 >> 0] | 0)) {
  HEAP32[i3 + (i4 + 12) >> 2] = 0;
  HEAP32[i3 + (i4 + 16) >> 2] = 0;
  HEAP32[i3 + (i4 + 20) >> 2] = 0;
  HEAP32[i3 + (i4 + 36) >> 2] = 0;
  HEAP32[i3 + (i4 + 40) >> 2] = 0;
  HEAP32[i3 + (i4 + 44) >> 2] = 0;
 } else {
  i1 = HEAP32[i1 + 52 >> 2] | 0;
  HEAP32[i3 + (i4 + 12) >> 2] = HEAP32[i1 + 80 >> 2];
  HEAP32[i3 + (i4 + 16) >> 2] = HEAP32[i1 + 84 >> 2];
  HEAP32[i3 + (i4 + 20) >> 2] = HEAP32[i1 + 88 >> 2];
  HEAP32[i3 + (i4 + 36) >> 2] = HEAP32[i1 + 96 >> 2];
  HEAP32[i3 + (i4 + 40) >> 2] = HEAP32[i1 + 100 >> 2];
  HEAP32[i3 + (i4 + 44) >> 2] = HEAP32[i1 + 104 >> 2];
 }
 if (!(HEAP8[i2 + 50 >> 0] | 0)) {
  HEAP32[i3 + (i4 + 24) >> 2] = 0;
  HEAP32[i3 + (i4 + 28) >> 2] = 0;
  HEAP32[i3 + (i4 + 32) >> 2] = 0;
  HEAP32[i3 + (i4 + 48) >> 2] = 0;
  HEAP32[i3 + (i4 + 52) >> 2] = 0;
  HEAP32[i3 + (i4 + 56) >> 2] = 0;
  i5 = i5 + 10 | 0;
  i4 = HEAP16[i5 >> 1] | 0;
  i4 = i4 & 65535;
  i4 = i4 & 65527;
  i4 = i4 & 65535;
  HEAP16[i5 >> 1] = i4;
  return;
 } else {
  i2 = HEAP32[i2 + 52 >> 2] | 0;
  HEAP32[i3 + (i4 + 24) >> 2] = HEAP32[i2 + 80 >> 2];
  HEAP32[i3 + (i4 + 28) >> 2] = HEAP32[i2 + 84 >> 2];
  HEAP32[i3 + (i4 + 32) >> 2] = HEAP32[i2 + 88 >> 2];
  HEAP32[i3 + (i4 + 48) >> 2] = HEAP32[i2 + 96 >> 2];
  HEAP32[i3 + (i4 + 52) >> 2] = HEAP32[i2 + 100 >> 2];
  HEAP32[i3 + (i4 + 56) >> 2] = HEAP32[i2 + 104 >> 2];
  i5 = i5 + 10 | 0;
  i4 = HEAP16[i5 >> 1] | 0;
  i4 = i4 & 65535;
  i4 = i4 & 65527;
  i4 = i4 & 65535;
  HEAP16[i5 >> 1] = i4;
  return;
 }
}

function __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 12 | 0;
 i6 = i9;
 i7 = i8 + 512 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i2 = i8 + 516 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((_memcmp(i6, i2, 12) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((_memcmp(i2, i6, 12) | 0) >= 0) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  i8 = i8 + 16 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = __Znwj(28) | 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 516 >> 2] | 0, i1);
 i8 = i8 + 520 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 16 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig32RestoreNetworkRetryTimeoutConfigER13dynamic_arrayIiLj4EE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i10 = i11;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i1 = i1 >>> 0 > 20 ? 20 : i1;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 if (i1 | 0) {
  i3 = i10 + 8 | 0;
  i2 = 0;
  do {
   i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i4;
   do if (i4 | 0) {
    i5 = HEAP32[i8 >> 2] | 0;
    if ((i5 | 0) == (HEAP32[i3 >> 2] | 0)) {
     __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKiEEvRT_(i10, i9);
     break;
    } else {
     HEAP32[i5 >> 2] = i4;
     HEAP32[i8 >> 2] = i5 + 4;
     break;
    }
   } while (0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) i1 = i3; else {
   i1 = i7 + 4 | 0;
   if ((i1 | 0) == (i10 | 0)) i1 = i2; else {
    __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i1, i2, i3);
    i1 = HEAP32[i10 >> 2] | 0;
   }
  }
  i2 = i1;
  if (i1 | 0) {
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   i10 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i9 >> 2] = 85;
   HEAP32[i9 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseE(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i9 = i6 + 40 | 0;
 i10 = i9;
 i3 = i2 + 8 | 0;
 i4 = i2 + 4 | 0;
 i1 = 1;
 do {
  i5 = HEAP32[i6 + 72 + (i1 << 2) >> 2] | 0;
  if ((i5 | 0) != -1) {
   i12 = HEAP32[i9 >> 2] | 0;
   __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i2, (i12 | 0) == 0 ? 0 : i12 + i10 | 0, i7, i5);
   if (124830 >>> i1 & 1 | 0) HEAP32[i8 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i2 >> 2];
   if (15106022 >>> i1 & 1 | 0) HEAP32[i8 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) + 4 >> 2] << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 596 + (HEAP32[gb + 177812 + (i1 * 12 | 0) >> 2] << 2) >> 2] = HEAP32[i3 >> 2];
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i1 = HEAP16[i6 + 392 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i12 = i6 + 48 | 0;
  i5 = HEAP32[i12 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  __ZN7mecanim4hand17Skeleton2HandPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS4_13SkeletonPoseTIN4math4trsXEEEPNS0_8HandPoseEf((i5 | 0) == 0 ? 0 : i5 + i12 | 0, (i1 | 0) == 0 ? 0 : i1 + i10 | 0, i7, i8 + 324 | 0, Math_fround(0.0));
  i1 = HEAP8[i6 + 393 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i11;
  return;
 }
 i6 = i6 + 52 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 __ZN7mecanim4hand17Skeleton2HandPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS4_13SkeletonPoseTIN4math4trsXEEEPNS0_8HandPoseEf((i5 | 0) == 0 ? 0 : i5 + i6 | 0, (i12 | 0) == 0 ? 0 : i12 + i10 | 0, i7, i8 + 460 | 0, Math_fround(0.0));
 STACKTOP = i11;
 return;
}

function __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_17MemoryEventHeaderE(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP8[i9 >> 0] | 0) != 0 | i1 >>> 0 < 4) {
  HEAP8[i9 >> 0] = 1;
  i7 = i12;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i8 = 1;
 } else {
  i2 = HEAP32[i12 >> 2] | 0;
  i6 = HEAP8[i2 >> 0] | 0;
  i5 = i2 + 1 | 0;
  HEAP32[i12 >> 2] = i5;
  HEAP32[i10 >> 2] = i1 + -1;
  i5 = HEAP8[i5 >> 0] | 0;
  i4 = i2 + 2 | 0;
  HEAP32[i12 >> 2] = i4;
  HEAP32[i10 >> 2] = i1 + -2;
  i4 = HEAP8[i4 >> 0] | 0;
  i3 = i2 + 3 | 0;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i1 + -3;
  i3 = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 4 | 0;
  HEAP32[i12 >> 2] = i2;
  i1 = i1 + -4 | 0;
  HEAP32[i10 >> 2] = i1;
  i7 = i12;
  i8 = 0;
 }
 i6 = (i4 & 255) << 16 | (i3 & 255) << 24 | (i5 & 255) << 8 | i6 & 255;
 i6 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
 HEAP32[i11 >> 2] = i2;
 i2 = (HEAP32[i7 >> 2] | 0) + i6 | 0;
 HEAP32[i7 >> 2] = i2;
 i7 = i1 - i6 | 0;
 HEAP32[i10 >> 2] = i7;
 i1 = i11 + 4 | 0;
 if (i8 | i7 >>> 0 < 4) {
  HEAP8[i9 >> 0] = 1;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  HEAP8[i1 + 1 >> 0] = HEAP8[i11 >> 0] | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  HEAP8[i1 + 2 >> 0] = HEAP8[i11 >> 0] | 0;
  i11 = (HEAP32[i12 >> 2] | 0) + 1 | 0;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  HEAP8[i1 + 3 >> 0] = HEAP8[i11 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf(i8, i1, i11, i12) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f13 = f0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f6 - f13);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f7 - f9);
 f2 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f2 - f10);
 i1 = i1 + 12 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(-f4);
 if (f6 < f5) {
  f3 = Math_fround(f6 + f4);
  f3 = Math_fround(Math_fround(f3 * f3) + Math_fround(0.0));
  f4 = f5;
 } else if (f6 > f4) {
  f3 = Math_fround(f6 - f4);
  f3 = Math_fround(Math_fround(f3 * f3) + Math_fround(0.0));
 } else {
  f3 = Math_fround(0.0);
  f4 = f6;
 }
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(-f5);
 if (f7 < f6) {
  f7 = Math_fround(f7 + f5);
  f3 = Math_fround(f3 + Math_fround(f7 * f7));
  f7 = f6;
 } else if (f7 > f5) {
  f7 = Math_fround(f7 - f5);
  f3 = Math_fround(f3 + Math_fround(f7 * f7));
  f7 = f5;
 }
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(-f5);
 if (f2 < f6) {
  f2 = Math_fround(f2 + f5);
  f3 = Math_fround(f3 + Math_fround(f2 * f2));
  f2 = f6;
 } else if (f2 > f5) {
  f2 = Math_fround(f2 - f5);
  f3 = Math_fround(f3 + Math_fround(f2 * f2));
  f2 = f5;
 }
 if (f3 == Math_fround(0.0)) {
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  f13 = Math_fround(0.0);
  HEAPF32[i12 >> 2] = f13;
  return;
 } else {
  f9 = Math_fround(f7 + f9);
  f10 = Math_fround(f2 + f10);
  HEAPF32[i11 >> 2] = Math_fround(f4 + f13);
  HEAPF32[i11 + 4 >> 2] = f9;
  HEAPF32[i11 + 8 >> 2] = f10;
  f13 = f3;
  HEAPF32[i12 >> 2] = f13;
  return;
 }
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i7 = i1 + 8 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = (i6 | 0) == 0 ? 0 : i6 + i7 | 0;
 i6 = i2 + 8 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = (i5 | 0) == 0 ? 0 : i5 + i6 | 0;
 i5 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i5 = (i2 | 0) == 0 ? 0 : i2 + i5 | 0;
 i2 = i4 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = (i4 | 0) == 0 ? 0 : i4 + i2 | 0;
 if ((i8 | 0) == 0 | (i9 | 0) == 0) return; else i3 = 0;
 do {
  i4 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
  i1 = 0;
  do {
   if ((i4 | 0) == (HEAP32[i6 + (i1 << 2) >> 2] | 0)) {
    i10 = 5;
    break;
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i9 >>> 0);
  if ((i10 | 0) == 5) {
   i10 = 0;
   i4 = HEAP32[i5 + (i3 * 40 | 0) + 4 >> 2] | 0;
   i12 = HEAP32[i5 + (i3 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i2 + (i1 * 40 | 0) >> 2] = HEAP32[i5 + (i3 * 40 | 0) >> 2];
   HEAP32[i2 + (i1 * 40 | 0) + 4 >> 2] = i4;
   HEAP32[i2 + (i1 * 40 | 0) + 8 >> 2] = i12;
   i12 = HEAP32[i5 + (i3 * 40 | 0) + 16 >> 2] | 0;
   i4 = HEAP32[i5 + (i3 * 40 | 0) + 20 >> 2] | 0;
   i11 = HEAP32[i5 + (i3 * 40 | 0) + 24 >> 2] | 0;
   HEAP32[i2 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i5 + (i3 * 40 | 0) + 12 >> 2];
   HEAP32[i2 + (i1 * 40 | 0) + 16 >> 2] = i12;
   HEAP32[i2 + (i1 * 40 | 0) + 20 >> 2] = i4;
   HEAP32[i2 + (i1 * 40 | 0) + 24 >> 2] = i11;
   i11 = HEAP32[i5 + (i3 * 40 | 0) + 32 >> 2] | 0;
   i4 = HEAP32[i5 + (i3 * 40 | 0) + 36 >> 2] | 0;
   HEAP32[i2 + (i1 * 40 | 0) + 28 >> 2] = HEAP32[i5 + (i3 * 40 | 0) + 28 >> 2];
   HEAP32[i2 + (i1 * 40 | 0) + 32 >> 2] = i11;
   HEAP32[i2 + (i1 * 40 | 0) + 36 >> 2] = i4;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i8 | 0));
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 56; else i1 = (HEAP32[i1 >> 2] | 0) + 56 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 176; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __Z38AudioMixerSnapshot_CUSTOM_TransitionToP12Il2CppObjectf(i6, f7) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i2 = i9;
 if (!i6) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i4 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 10; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i2);
    i2 = HEAP32[i8 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 10; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 12;
   }
  }
  if ((i5 | 0) == 10) i5 = 12;
  if ((i5 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6); else {
  HEAP32[i8 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN10AudioMixer20TransitionToSnapshotERK4PPtrI18AudioMixerSnapshotEf(i1, i8, f7);
  STACKTOP = i9;
  return;
 }
}

function __Z25CopySerializedIfDifferentRK6ObjectRS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i10 + 8 | 0;
 i13 = i10;
 i6 = i10 + 36 | 0;
 i8 = i10 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i13;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i11 = i14;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = gb + 64016 | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i13;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = i7;
 HEAP32[i8 >> 2] = 0;
 i11 = i8 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i7 = i8 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i14, i13);
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i9;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags(i2, i6, 16384);
 __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags(i3, i8, 16384);
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i11 >> 2] | 0)) i1 = (_memcmp(HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] | 0, i1) | 0) == 0; else i1 = 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i9);
  HEAP32[i8 >> 2] = 0;
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
  HEAP32[i6 >> 2] = 0;
 }
 if (i1) {
  STACKTOP = i10;
  return;
 }
 __Z14CopySerializedRK6ObjectRS_(i2, i3);
 STACKTOP = i10;
 return;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv(i1, i11, i12, i13, i2) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i10 + 68 | 0;
 i7 = i10 + 48 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 4 | 0;
 HEAP8[i1 >> 0] = HEAP8[gb + 1078232 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[gb + 1078232 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[gb + 1078232 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[gb + 1078232 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[gb + 1078232 + 4 >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = HEAP8[gb + 1078232 + 5 >> 0] | 0;
 i3 = __ZNSt3__26__clocEv() | 0;
 HEAP32[i6 >> 2] = i2;
 i1 = __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i7, 20, i3, i1, i6) | 0;
 i2 = i7 + i1 | 0;
 i3 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i7, i2, i12) | 0;
 i4 = __ZNKSt3__28ios_base6getlocEv(i12) | 0;
 HEAP32[i6 >> 2] = i4;
 __THREW__ = 0;
 i5 = invoke_iii(fb + 1145 | 0, i6 | 0, gb + 1474556 | 0) | 0;
 i14 = __THREW__;
 __THREW__ = 0;
 if (i14 & 1) {
  i14 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i4) | 0;
  ___resumeException(i14 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i4) | 0;
  mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, i7 | 0, i2 | 0, i8 | 0) | 0;
  i14 = i8 + i1 | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  i14 = __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i6, i8, (i3 | 0) == (i2 | 0) ? i14 : i8 + (i3 - i7) | 0, i14, i12, i13) | 0;
  STACKTOP = i10;
  return i14 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj678ENS_22PxRepXPropertyAccessorILj678ES4_NS_23PxVehicleDriveSimData4WES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 800 | 0;
 i7 = i10 + 704 | 0;
 i4 = i10 + 672 | 0;
 i8 = i10 + 96 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 212; else i1 = (HEAP32[i1 >> 2] | 0) + 212 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx36PxVehicleDriveSimData4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 116 | 0;
 i6 = i2 + 64 | 0;
 i5 = i2 + 32 | 0;
 i8 = i3 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 12, gb + 673142 | 0, gb + 833180 | 0, 158) | 0;
 HEAP32[i1 >> 2] = 2;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i2);
 __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i5);
 i11 = i3 + 8 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i3 + 32 >> 2] | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i10;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i1;
 HEAP32[i6 + 28 >> 2] = i8;
 HEAP32[i6 + 32 >> 2] = i7;
 HEAP8[i6 + 36 >> 0] = 1;
 HEAP32[i6 + 40 >> 2] = i4;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5, 0);
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i5 + 16 | 0, 1);
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP8[HEAP32[i3 + 40 >> 2] >> 0] = 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN13RenderTexture13AwakeFromLoadE17AwakeFromLoadMode(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0;
 i5 = i7 + 80 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i6 | 0) > 1 ? i6 : 1;
 i6 = i7 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = (i2 | 0) > 1 ? i2 : 1;
 i2 = i7 + 92 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) > 1 ? i4 : 1;
 i2 = i7 + 88 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) < 1 ? 1 : (i4 | 0) > 8 ? 8 : i4;
 i2 = i7 + 96 | 0;
 if (__Z15IsDepthRTFormat19RenderTextureFormat(HEAP32[i2 >> 2] | 0) | 0) HEAP8[i7 + 116 >> 0] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i7 + 104 >> 2] | 0) == 4) HEAP32[i6 >> 2] = i1;
 if (!(i1 + -1 & i1)) {
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4 + -1 & i4 | 0) i3 = 7;
 } else i3 = 7;
 if ((i3 | 0) == 7) {
  i1 = i7 + 44 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 1;
 }
 if (__Z15IsDepthRTFormat19RenderTextureFormat(HEAP32[i2 >> 2] | 0) | 0) HEAP32[i7 + 44 >> 2] = 1;
 i2 = i7 + 144 | 0;
 if ((i2 | 0) != (gb + 1158220 | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = i7 + 148 | 0; else {
   i4 = i7 + 148 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
   HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = i4;
  }
  i4 = HEAP32[gb + 1158220 >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = gb + 1158220;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
 }
 i3 = (HEAP8[i7 + 116 >> 0] | 0) == 0;
 i4 = i7 + 76 | 0;
 HEAP32[i4 >> 2] = 1;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 f8 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
 HEAPF32[i7 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
 HEAPF32[i7 + 72 >> 2] = f8;
 if (i3) i1 = 1; else i1 = __Z22CalculateMipMapCount3Diii(i2, i1, 1) | 0;
 HEAP32[i4 >> 2] = i1;
 return;
}

function __Z29RegisterModuleClasses_Terrainv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 995;
 HEAP32[i2 + 8 >> 2] = gb + 932069;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 156;
 HEAP32[i2 + 20 >> 2] = 368;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 66968;
 HEAP32[i2 + 44 >> 2] = fb + 316;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 317;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 994;
 HEAP32[i2 + 8 >> 2] = gb + 937588;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 218;
 HEAP32[i2 + 20 >> 2] = 248;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 35740;
 HEAP32[i2 + 44 >> 2] = fb + 314;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 315;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 996;
 HEAP32[i2 + 8 >> 2] = gb + 935475;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 193;
 HEAP32[i2 + 20 >> 2] = 88;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 184796;
 HEAP32[i2 + 44 >> 2] = fb + 319;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 320;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i12 >> 2] = gb + 114136 + 8;
 i8 = i12 + 36 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i9 = i12 + 32 | 0;
  i10 = i12 + 72 | 0;
  i11 = i12 + 76 | 0;
  do {
   i5 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
   i6 = HEAP32[i10 >> 2] | 0;
   i7 = (i6 | 0) == 0;
   if (i7) i4 = 6; else {
    __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 + 4 >> 2] | 0);
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) {
     HEAP8[i11 >> 0] = 0;
     i4 = 12;
    } else i4 = 6;
   }
   if ((i4 | 0) == 6) {
    i4 = 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = 0;
    do {
     if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i5 | 0)) {
      i1 = i3;
      i4 = 8;
      break;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i1 >>> 0);
    if ((i4 | 0) == 8) {
     i4 = 0;
     mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
     i5 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
     HEAP32[i8 >> 2] = i5;
     i3 = HEAP32[i9 >> 2] | 0;
     HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i3 + (i5 << 2) >> 2];
     i1 = i5;
    }
    HEAP8[i11 >> 0] = (i1 | 0) != 0 & 1;
    if (!i7) i4 = 12;
   }
   if ((i4 | 0) == 12) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 + 4 >> 2] | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i11 = HEAP32[i12 + 40 >> 2] | 0;
 if ((i11 | 0) > -1 & (i11 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i12 + 32 >> 2] | 0;
  if (i1 | 0) {
   i11 = HEAP32[HEAP32[i12 + 28 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i12 + 16 >> 2] | 0;
 if (!i1) return;
 i12 = HEAP32[HEAP32[i12 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, i1 | 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj458ENS_22PxRepXPropertyAccessorILj458ES4_RKNS_22PxJointLinearLimitPairES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 280 | 0;
 i7 = i10 + 168 | 0;
 i4 = i10 + 140 | 0;
 i8 = i10 + 112 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLinearLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 28; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 5, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 5, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 5) | 0, 0, i4 - i5 << 5 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 5) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN10GameObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 if (!(HEAP32[i9 >> 2] & 16384)) {
  i5 = i10 + 40 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  i7 = i9 + 16 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i4 + 4 | 0;
  i6 = i9 + 24 | 0;
  if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i7 >> 2] = i1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i10 + 28 >> 2] | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i2 = i1 + (i8 << 3) | 0;
  if (i8 | 0) do {
   __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i9);
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i8 = i7;
  i5 = i7;
 } else {
  i5 = i9 + 16 | 0;
  i8 = i5;
  i6 = i9 + 24 | 0;
 }
 i1 = i10 + 48 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 4);
 __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i10 + 64 | 0, i9);
 i1 = i10 + 52 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 2);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i10 + 54 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  STACKTOP = i11;
  return;
 }
}

function __ZNK5physx2Gu11HeightField22isCollisionVertexPrecaEjjjt(i10, i8, i6, i7, i3) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0, i5 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 if (HEAP16[i10 + 48 >> 1] & 1) {
  if ((i6 | 0) == 0 | (i7 | 0) == 0) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  if (((HEAP32[i10 + 16 >> 2] | 0) + -1 | 0) >>> 0 <= i6 >>> 0) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
  if (((HEAP32[i10 + 20 >> 2] | 0) + -1 | 0) >>> 0 <= i7 >>> 0) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 if (__ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb(i10, i8, i6, i7, i3, i4) | 0) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(HEAP8[i4 >> 0] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i4 = HEAP32[i10 + 36 >> 2] | 0;
 i5 = HEAP16[i4 + (i8 << 2) >> 1] << 1;
 if (!i6) {
  i6 = 0;
  i3 = 0;
 } else if (((HEAP32[i10 + 16 >> 2] | 0) + -1 | 0) >>> 0 > i6 >>> 0) {
  i6 = HEAP32[i10 + 20 >> 2] | 0;
  i6 = i5 - (HEAP16[i4 + (i6 + i8 << 2) >> 1] | 0) - (HEAP16[i4 + (i8 - i6 << 2) >> 1] | 0) | 0;
  i3 = 1;
 } else {
  i6 = 0;
  i3 = 0;
 }
 if (!i7) i9 = 13; else if (((HEAP32[i10 + 20 >> 2] | 0) + -1 | 0) >>> 0 > i7 >>> 0) i3 = i5 - (HEAP16[i4 + (i8 + 1 << 2) >> 1] | 0) - (HEAP16[i4 + (i8 + -1 << 2) >> 1] | 0) | 0; else i9 = 13;
 if ((i9 | 0) == 13) if (i3) i3 = 0; else {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((i3 ^ i6 | 0) > -1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 f2 = Math_fround(i3 + i6 | 0);
 i9 = !(Math_fround(HEAPF32[i10 + 40 >> 2]) <= Math_fround(0.0));
 f1 = Math_fround(HEAPF32[i10 + 44 >> 2]);
 if (i9) {
  i10 = f2 < Math_fround(-f1);
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i10 = f2 > f1;
  STACKTOP = i11;
  return i10 | 0;
 }
 return 0;
}

function __ZN11DynamicMesh7ReserveEii(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4 * 26 | 0, 2, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 26 | 0, 2, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i5 + 12 >> 2] | 0) * 26 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i5 >> 2] = i3;
  break;
 } while (0);
 i1 = i5 + 40 | 0;
 i2 = i5 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i4 << 2, 4, i5 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i5 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 52 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  break;
 } while (0);
 i1 = i5 + 20 | 0;
 i2 = i5 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i6 >>> 0) return;
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 * 12 | 0, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 12 | 0, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i5 + 32 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function _log1pf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if (i2 >>> 0 < 1054086096 | (i2 | 0) < 0) if (i2 >>> 0 > 3212836863) {
  if (f1 == Math_fround(-1.0)) {
   f1 = Math_fround(-inf);
   break;
  }
  f1 = Math_fround(Math_fround(f1 - f1) / Math_fround(0.0));
  break;
 } else {
  if (i2 << 1 >>> 0 < 1728053248) break;
  if (i2 >>> 0 < 3197498906) {
   f5 = Math_fround(0.0);
   f3 = Math_fround(0.0);
   i4 = 11;
   break;
  } else {
   i4 = 8;
   break;
  }
 } else if (i2 >>> 0 <= 2139095039) i4 = 8; while (0);
 if ((i4 | 0) == 8) {
  f3 = Math_fround(f1 + Math_fround(1.0));
  i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) + 4913933 | 0;
  i2 = (i4 >>> 23) + -127 | 0;
  if ((i2 | 0) < 25) {
   f6 = Math_fround(Math_fround(1.0) - Math_fround(f3 - f1));
   f5 = Math_fround(f1 - Math_fround(f3 + Math_fround(-1.0)));
   f3 = Math_fround(((i2 | 0) > 1 ? f6 : f5) / f3);
  } else f3 = Math_fround(0.0);
  f5 = Math_fround(i2 | 0);
  f1 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 & 8388607) + 1060439283, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
  i4 = 11;
 }
 if ((i4 | 0) == 11) {
  f9 = Math_fround(f1 / Math_fround(f1 + Math_fround(2.0)));
  f8 = Math_fround(f9 * f9);
  f7 = Math_fround(f8 * f8);
  f6 = Math_fround(f1 * Math_fround(f1 * Math_fround(.5)));
  f1 = Math_fround(Math_fround(f5 * Math_fround(.693138123)) + Math_fround(f1 + Math_fround(Math_fround(Math_fround(f3 + Math_fround(f5 * Math_fround(9.05800061e-06))) + Math_fround(f9 * Math_fround(f6 + Math_fround(Math_fround(f8 * Math_fround(Math_fround(f7 * Math_fround(.284987867)) + Math_fround(.666666627))) + Math_fround(f7 * Math_fround(Math_fround(f7 * Math_fround(.242790788)) + Math_fround(.400009722))))))) - f6)));
 }
 return Math_fround(f1);
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i8 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i10 + 4 | 0;
 i6 = i2;
 i2 = HEAP32[i8 >> 2] | 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i4 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 + 12 >> 2] = i3;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   i12 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i2 + 11 >> 0] = i5;
   if (!i5) i3 = i2; else {
    i3 = i2;
    i12 = 8;
   }
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i5 + 16 & -16;
   HEAP32[i10 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i2 + 4 >> 2] = i5;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i3 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i3 + i5 >> 0] = 0;
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  i1 = i6 + 20 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 20 | 0;
  HEAP32[i8 >> 2] = i2;
  if ((i1 | 0) == (i9 | 0)) break; else i6 = i1;
 }
 STACKTOP = i11;
 return;
}

function __ZNKSt3__214collate_bynameIwE12do_transformEPKwS3_(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i8, i1, i2);
 i5 = i8 + 8 + 3 | 0;
 i4 = i3 + 8 | 0;
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 212 | 0, 0, ((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0, 0, HEAP32[i4 >> 2] | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i9 = 7; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1048 | 0, i6 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i9 = 7; else {
   i1 = HEAP8[i6 + 8 + 3 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) {
    i2 = HEAP32[i6 + 4 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   } else {
    i2 = i1 & 255;
    i3 = i6;
    i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   }
   __THREW__ = 0;
   invoke_iiiii(fb + 212 | 0, i3 | 0, i1 | 0, i2 + 1 | 0, HEAP32[i4 >> 2] | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
    break;
   } else {
    __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
    STACKTOP = i7;
    return;
   }
  }
 } while (0);
 if ((i9 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
 ___resumeException(i1 | 0);
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj431ENS_22PxRepXPropertyAccessorILj431ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 280 | 0;
 i7 = i10 + 168 | 0;
 i4 = i10 + 140 | 0;
 i8 = i10 + 112 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 220; else i1 = (HEAP32[i1 >> 2] | 0) + 220 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx36PxJointAngularLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN17BlendShapeChannel8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863350 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426420 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426431 | 0, i6, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManager19CreatePvdConnectionEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if (HEAP32[gb + 1457416 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 i4 = HEAP32[gb + 1457408 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(__Z20IsHumanControllingUsv() | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[gb + 1452356 >> 2] | 0;
 i6 = __Z25BeginsWithCaseInsensitivePKcS0_((i6 | 0) == 0 ? gb + 1452356 + 4 | 0 : i6, gb + 781521 | 0) | 0;
 i3 = HEAP32[gb + 1457408 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0;
 i4 = HEAP32[gb + 1452356 >> 2] | 0;
 i4 = (i4 | 0) == 0 ? gb + 1452356 + 4 | 0 : i4;
 if (i6) {
  HEAP32[i1 >> 2] = 7;
  i1 = __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE(i3, i4 + 5 | 0, i1) | 0;
 } else {
  HEAP32[i2 >> 2] = 7;
  i1 = __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcijNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE(i3, i4, 5425, 10, i2) | 0;
 }
 HEAP32[gb + 1457416 >> 2] = i1;
 i6 = HEAP32[gb + 1457408 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, 1, 1);
 i6 = HEAP32[gb + 1457408 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, 2, 1);
 i6 = HEAP32[gb + 1457408 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, 4, 1);
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Vector_Polarize(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 if (!((i1 | 0) != 0 & (i9 | 0) != 0 & (i10 | 0) != 0)) return;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!(i3 | i2)) return;
 i1 = _FT_MSB(((i3 | 0) < 0 ? 0 - i3 | 0 : i3) | ((i2 | 0) < 0 ? 0 - i2 | 0 : i2)) | 0;
 if ((i1 | 0) < 30) {
  i7 = 29 - i1 | 0;
  i8 = i7;
  i2 = i2 << i7;
  i3 = i3 << i7;
 } else {
  i7 = i1 + -29 | 0;
  i8 = 29 - i1 | 0;
  i2 = i2 >> i7;
  i3 = i3 >> i7;
 }
 i1 = 0 - i2 | 0;
 if ((i3 | 0) > (i2 | 0)) if ((i3 | 0) > (i1 | 0)) {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = i1;
  i1 = i3;
  i2 = 5898240;
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = 0 - i3 | 0;
  i2 = (i3 | 0) > 0 ? 11796480 : -11796480;
 } else {
  i11 = (i3 | 0) < (i1 | 0);
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = i11 ? i2 : i3;
  i1 = i11 ? 0 - i3 | 0 : i2;
  i2 = i11 ? -5898240 : 0;
 }
 while (1) {
  i3 = i4 + i5 >> i6;
  if ((i4 | 0) > 0) {
   i4 = i4 - (i1 + i5 >> i6) | 0;
   i3 = i3 + i1 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i4 = (i1 + i5 >> i6) + i4 | 0;
   i3 = i1 - i3 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
   i1 = i3;
  }
 }
 if ((i2 | 0) > -1) i1 = i2 + 8 & -16; else i1 = 0 - (8 - i2 & -16) | 0;
 i7 = (i3 | 0) < 0;
 i3 = i7 ? 0 - i3 | 0 : i3;
 i11 = i3 & 65535;
 i3 = i3 >>> 16;
 i5 = i3 * 23318 | 0;
 i4 = (i11 * 56281 | 0) + i5 | 0;
 i6 = i4 << 16;
 i11 = i6 + (i11 * 23318 | 0) | 0;
 i11 = (i4 >>> 16) + (i3 * 56281 | 0) + ((i4 >>> 0 < i5 >>> 0 & 1) << 16) + (i11 >>> 0 < i6 >>> 0 & 1) + (i11 >>> 0 > 3221225471 & 1) | 0;
 i11 = i7 ? 0 - i11 | 0 : i11;
 HEAP32[i9 >> 2] = (i8 | 0) > -1 ? i11 >> i8 : i11 << 0 - i8;
 HEAP32[i10 >> 2] = i1;
 return;
}

function __ZNK9Heightmap15CalculateBoundsEiii(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = 1 << HEAP32[i5 + 80 >> 2];
 if ((i8 | 0) > 0) {
  i2 = 0;
  i3 = 0;
  do {
   i2 = (Math_imul(i1, i1) | 0) + i2 | 0;
   i1 = i1 >> 1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i8 | 0));
 } else i2 = 0;
 i3 = i2 + i6 + (Math_imul(i1, i7) | 0) << 1;
 i2 = HEAP32[i5 + 44 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i2 + (i3 << 2) >> 2]);
 f18 = Math_fround(HEAPF32[i2 + ((i3 | 1) << 2) >> 2]);
 f13 = Math_fround(i6 << i8 << 4 | 0);
 f14 = Math_fround(HEAPF32[i5 + 88 >> 2]);
 f13 = Math_fround(f13 * f14);
 f12 = Math_fround(i7 << i8 << 4 | 0);
 f15 = Math_fround(HEAPF32[i5 + 96 >> 2]);
 f12 = Math_fround(f12 * f15);
 f16 = Math_fround(HEAPF32[i5 + 92 >> 2]);
 f11 = Math_fround(f11 * f16);
 f14 = Math_fround(Math_fround(i6 + 1 << i8 << 4 | 0) * f14);
 f15 = Math_fround(Math_fround(i7 + 1 << i8 << 4 | 0) * f15);
 f16 = Math_fround(f18 * f16);
 f18 = Math_fround(Math_fround(f11 + f16) * Math_fround(.5));
 f17 = Math_fround(Math_fround(f12 + f15) * Math_fround(.5));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(f13 + f14) * Math_fround(.5));
 HEAPF32[i4 + 4 >> 2] = f18;
 HEAPF32[i4 + 8 >> 2] = f17;
 f11 = Math_fround(Math_fround(f16 - f11) * Math_fround(.5));
 f12 = Math_fround(Math_fround(f15 - f12) * Math_fround(.5));
 HEAPF32[i4 + 12 >> 2] = Math_fround(Math_fround(f14 - f13) * Math_fround(.5));
 i8 = i4 + 16 | 0;
 HEAPF32[i8 >> 2] = f11;
 HEAPF32[i4 + 20 >> 2] = f12;
 HEAPF32[i9 >> 2] = Math_fround(.0000999999974);
 i7 = f11 < Math_fround(.0000999999974);
 HEAP32[i8 >> 2] = HEAP32[(i7 ? i9 : i8) >> 2];
 STACKTOP = i10;
 return;
}

function __ZN5physx16PxVehicleDrive4W17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 __ZN5physx14PxVehicleDrive17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx15PxVehicleWheels17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx21PxVehicleDriveSimData17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 __ZN5physx23PxVehicleDriveSimData4W17getBinaryMetaDataERNS_14PxOutputStreamE(i1);
 HEAP32[i5 >> 2] = HEAP32[gb + 165744 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 165744 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 165744 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 165744 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 165744 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 165744 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 165744 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 165744 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 835156;
 HEAP32[i4 + 4 >> 2] = gb + 828300;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 800;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 165776 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 165776 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 165776 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 165776 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 165776 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 165776 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 165776 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 165776 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN14RotationModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj(i7, i1, i2, i8, i9, i10, i11) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if (!(HEAP8[i8 + 869 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1452116 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452116 | 0, i1);
  i2 = gb + 1452116 | 0;
 } else i2 = 0;
 i1 = HEAP8[i7 + 800 >> 0] | 0 ? 0 : 2;
 do {
  i3 = i7 + 8 + (i1 * 264 | 0) | 0;
  i4 = HEAP16[i7 + 8 + (i1 * 264 | 0) + 84 >> 1] | 0;
  do if (!(i4 << 16 >> 16)) __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i3, i8, HEAP32[i8 + 360 + (i1 * 20 | 0) >> 2] | 0, i9, i10, i11); else {
   if (!(HEAP8[i7 + 8 + (i1 * 264 | 0) + 86 >> 0] | 0)) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i3, i8, HEAP32[i8 + 360 + (i1 * 20 | 0) >> 2] | 0, i9, i10, i11);
    break;
   }
   i5 = HEAP32[i8 + 360 + (i1 * 20 | 0) >> 2] | 0;
   if ((i4 | 1) << 16 >> 16 == 3) {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i3, i8, i5, i9, i10, i11);
    break;
   } else {
    __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj(i3, i8, i5, i9, i10, i11);
    break;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZL40UnityAudioEffect_InternalReleaseCallbackP14FMOD_DSP_STATE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 HEAP32[i11 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(i2, i11) | 0;
 if (i1 | 0) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i11 = 36;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = HEAP32[i1 + 112 >> 2] | 0;
 __ZN4FMOD3DSP11setUserDataEPv(i2, 0) | 0;
 i1 = HEAP32[i3 + 164 >> 2] | 0;
 if (!i1) i10 = 0; else {
  i10 = (mftCall_ii(i1 | 0, HEAP32[i11 >> 2] | 0) | 0) == 0;
  i10 = i10 ? 0 : 80;
 }
 if (0 == 0 ? (HEAP32[i3 + 120 >> 2] & 2 | 0) == 0 : 0) i7 = HEAP32[i11 >> 2] | 0; else {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, gb + 63328 | 0);
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i7 + 40 >> 2] = 0;
 }
 if (i7 | 0) {
  i8 = i7 + 112 | 0;
  i9 = HEAP32[i8 >> 2] | 0;
  if (i9 | 0) {
   i5 = i9 + 200 | 0;
   i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   HEAP32[i5 >> 2] = i6;
   if (!i6) {
    i5 = i9 + 60 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    i6 = i9 + 64 | 0;
    i1 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) > 0) {
     i4 = 0;
     do {
      i3 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
      if (i3) {
       __ZdaPv(i3);
       i2 = HEAP32[i5 >> 2] | 0;
       i1 = HEAP32[i6 >> 2] | 0;
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) < (i2 | 0));
    }
    if (i1 | 0) __ZdaPv(i1);
    i1 = HEAP32[i9 + 180 >> 2] | 0;
    if (i1 | 0) __ZdaPv(i1);
    __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 63328 | 0);
   }
  }
  HEAP32[i8 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63328 | 0);
 HEAP32[i11 >> 2] = 0;
 i11 = i10;
 STACKTOP = i12;
 return i11 | 0;
}

function _UNITY_FT_Request_Size(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (!i8) {
  i9 = 35;
  return i9 | 0;
 }
 if (!i2) {
  i9 = 6;
  return i9 | 0;
 }
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i4 | 0) < 0) {
  i9 = 6;
  return i9 | 0;
 }
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i5 | 0) < 0) {
  i9 = 6;
  return i9 | 0;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 > 4) {
  i9 = 6;
  return i9 | 0;
 }
 i7 = HEAP32[(HEAP32[i8 + 96 >> 2] | 0) + 12 >> 2] | 0;
 i1 = HEAP32[i7 + 88 >> 2] | 0;
 if (i1 | 0) {
  i9 = mftCall_iii(i1 | 0, HEAP32[i8 + 88 >> 2] | 0, i2 | 0) | 0;
  return i9 | 0;
 }
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 if ((i1 & 3 | 0) != 2) {
  _UNITY_FT_Request_Metrics(i8, i2);
  i9 = 0;
  return i9 | 0;
 }
 if (!(i1 & 2)) {
  i9 = 35;
  return i9 | 0;
 }
 if (i3 | 0) {
  i9 = 7;
  return i9 | 0;
 }
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = ((Math_imul(i6, i4) | 0) + 36 | 0) / 72 | 0;
 i3 = (i6 | 0) == 0 ? i4 : i3;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 i6 = ((Math_imul(i2, i5) | 0) + 36 | 0) / 72 | 0;
 i6 = (i2 | 0) == 0 ? i5 : i6;
 i2 = (i4 | 0) == 0;
 i4 = (i5 | 0) == 0 ? i3 : i6;
 i3 = (i2 ? i4 : i3) + 32 | 0;
 i4 = (i2 ? i6 : i4) + 32 | 0;
 i5 = HEAP32[i8 + 28 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i9 = 23;
  return i9 | 0;
 }
 i6 = HEAP32[i8 + 32 >> 2] | 0;
 i2 = 0;
 while (1) {
  if (((HEAP32[i6 + (i2 << 4) + 12 >> 2] | 0) + 32 ^ i4) >>> 0 <= 63) if (((HEAP32[i6 + (i2 << 4) + 8 >> 2] | 0) + 32 ^ i3) >>> 0 <= 63) break;
  i1 = i2 + 1 | 0;
  if ((i1 | 0) < (i5 | 0)) i2 = i1; else {
   i1 = 23;
   i9 = 21;
   break;
  }
 }
 if ((i9 | 0) == 21) return i1 | 0;
 if (!((i2 | 0) > -1 & (i5 | 0) > (i2 | 0))) {
  i9 = 6;
  return i9 | 0;
 }
 i1 = HEAP32[i7 + 92 >> 2] | 0;
 if (!i1) {
  _UNITY_FT_Select_Metrics(i8, i2);
  i9 = 0;
  return i9 | 0;
 } else {
  i9 = mftCall_iii(i1 | 0, HEAP32[i8 + 88 >> 2] | 0, i2 | 0) | 0;
  return i9 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI15CarveDataArraysNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 5) + 1 | 0;
 if (i3 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i5 = i7 >> 4;
 i5 = i7 >> 5 >>> 0 < 67108863 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 134217727;
 i1 = i2 - i1 >> 5;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 << 5) | 0;
 i2 = i4 + (i1 << 5) | 0;
 i3 = i2;
 i7 = i4 + (i5 << 5) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_(i4 + (i1 << 5) + 12 | 0, i6 + 12 | 0);
 i6 = i2 + 32 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i3;
  i4 = i5;
  i1 = i5;
 } else {
  do {
   i11 = i2 + -32 | 0;
   i4 = i1;
   i1 = i1 + -32 | 0;
   HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_(i2 + -20 | 0, i4 + -20 | 0);
   i2 = i3 + -32 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i2 = i3;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -32 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) return;
 __ZdlPv(i4);
 return;
}

function __ZN20UnityConnectSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(236, i1, 16, gb + 1048932 | 0, 0, gb + 1042564 | 0, 38) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 189132 + 8;
 __ZN22CrashReportingSettingsC2Ev(i4 + 28 | 0);
 __ZN23UnityPurchasingSettingsC2Ev(i4 + 56 | 0);
 __ZN22UnityAnalyticsSettingsC2Ev(i4 + 68 | 0);
 __ZN16UnityAdsSettingsC2Ev(i4 + 112 | 0);
 HEAP32[i4 + 164 >> 2] = 0;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 HEAP32[i4 + 176 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 180 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 192 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 200 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 212 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 216 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN20UnityConnectSettings10InitializeEv(i4);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i8 + 24 | 0;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = -1;
  HEAP32[i6 + 4 >> 2] = -1;
  HEAP32[i6 + 8 >> 2] = -1;
  HEAP32[i6 + 12 >> 2] = -1;
  HEAP32[i6 + 16 >> 2] = -1;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 5 | 0, 4) | 0;
  i2 = i4 + (i1 << 5) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
    HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 28 >> 2] = 0;
    i1 = i1 + 32 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i7 << 5) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i12 = i5 + 16 | 0;
  i4 = i3 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i3 = i3 + 28 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 28 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 24 | 0;
 i8 = i10;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 36 | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i7 = i8 + 16 | 0;
 HEAP32[i7 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 36 | 0, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i5 = i2 + (i1 * 36 | 0) | 0;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = i2 + (i4 * 36 | 0);
 __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE(i3, i8);
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i9 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -28 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -16 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i8 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  HEAP32[i9 >> 2] = 12;
  HEAP32[i9 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 }
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE14__erase_uniqueIS2_EEjRKT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = i8 + 4 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 if (!i9) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i6;
 i2 = i9;
 L4 : while (1) {
  i1 = i2;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) >= (i7 | 0)) {
    if ((i2 | 0) > (i7 | 0)) break;
    i2 = i1 + 24 | 0;
    i10 = HEAP32[i2 + 4 >> 2] | 0;
    if (!((i10 | 0) < (i4 | 0) | ((i10 | 0) == (i4 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0 : 0))) break;
   }
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L4;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i6 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i7 | 0) < (i1 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if ((i7 | 0) > (i1 | 0)) {
  if ((i3 | 0) == (i6 | 0)) {
   i10 = 0;
   return i10 | 0;
  }
 } else {
  i10 = i3 + 24 | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  if ((i4 | 0) < (i7 | 0) | ((i4 | 0) == (i7 | 0) ? i5 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0 : 0) | (i3 | 0) == (i6 | 0)) {
   i10 = 0;
   return i10 | 0;
  }
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) HEAP32[i8 >> 2] = i1;
 i10 = i8 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i9, i3);
 __ZdlPv(i3);
 i10 = 1;
 return i10 | 0;
}

function __ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb(i5, i3, i2, i1, i9, i10) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 96 | 0;
 i8 = i11;
 i6 = i11 + 32 | 0;
 i7 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(i5, i3, i2, i1, i4) | 0;
 i1 = (i7 | 0) == 0;
 if (i1) {
  HEAP8[i10 >> 0] = 0;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i2 = i6;
  i3 = 0;
 }
 while (1) {
  HEAP32[i8 + (i3 << 2) >> 2] = __ZN5physx22getEdgeTriangleIndicesERKNS_2Gu11HeightFieldERKNS_8EdgeDataEPj(i5, i4 + (i3 << 4) | 0, i2) | 0;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i7 | 0)) break; else i2 = i2 + 8 | 0;
 }
 HEAP8[i10 >> 0] = 0;
 if (i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = HEAP32[i5 + 36 >> 2] | 0;
 i3 = i6;
 i4 = 0;
 while (1) {
  i6 = HEAP32[i3 >> 2] | 0;
  i1 = i6 >>> 1;
  i1 = (HEAPU8[((i6 & 1 | 0) == 0 ? i5 + (i1 << 2) + 2 | 0 : i5 + (i1 << 2) + 3 | 0) >> 0] | 0) & 127;
  if ((HEAP32[i8 + (i4 << 2) >> 2] | 0) >>> 0 > 1) {
   i6 = HEAP32[i3 + 4 >> 2] | 0;
   i2 = i6 >>> 1;
   i2 = (HEAPU8[((i6 & 1 | 0) == 0 ? i5 + (i2 << 2) + 2 | 0 : i5 + (i2 << 2) + 3 | 0) >> 0] | 0) & 127;
   i1 = i1 << 16 >> 16 == i9 << 16 >> 16;
   if (!i1) {
    HEAP8[i10 >> 0] = 1;
    if (i2 << 16 >> 16 == i9 << 16 >> 16) {
     i1 = 1;
     i2 = 13;
     break;
    }
   }
   if (i2 << 16 >> 16 != i9 << 16 >> 16) {
    HEAP8[i10 >> 0] = 1;
    if (i1) {
     i1 = 1;
     i2 = 13;
     break;
    }
   }
  } else if (i1 << 16 >> 16 != i9 << 16 >> 16) {
   i1 = 1;
   i2 = 13;
   break;
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i2 = 13;
   break;
  } else i3 = i3 + 8 | 0;
 }
 if ((i2 | 0) == 13) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE5eraseERS6_(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i11 + 32 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  return i11 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i6;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i8 = HEAP32[i11 + 24 >> 2] | 0;
 i2 = i8 + (((i1 >>> 16 ^ i1) & i2 + -1) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i11 = 0;
  return i11 | 0;
 }
 i7 = HEAP32[i11 + 16 >> 2] | 0;
 i4 = HEAP32[i11 + 20 >> 2] | 0;
 while (1) {
  i3 = i2;
  i2 = i4 + (i1 << 2) | 0;
  i5 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i7 + (i5 << 3) >> 2] | 0) == (i6 | 0)) break;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i9 = 11;
   break;
  }
 }
 if ((i9 | 0) == 11) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i11 + 48 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 if ((i5 | 0) != (i1 | 0)) {
  i9 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
  HEAP32[i7 + (i5 << 3) >> 2] = i9;
  HEAP32[i7 + (i5 << 3) + 4 >> 2] = HEAP32[i7 + (i1 << 3) + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = i9 + ~(i9 << 15) | 0;
  i1 = (i1 >>> 10 ^ i1) * 9 | 0;
  i1 = i1 >>> 6 ^ i1;
  i1 = i1 + ~(i1 << 11) | 0;
  i1 = i8 + (((i1 >>> 16 ^ i1) & (HEAP32[i10 >> 2] | 0) + -1) << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   i1 = i4 + (i2 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  HEAP32[i1 >> 2] = i5;
 }
 i11 = i11 + 40 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 i11 = 1;
 return i11 | 0;
}

function __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_(i4, i1, i2, i3, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f18 = Math_fround(HEAPF32[i2 >> 2]);
 f17 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f18 = Math_fround(f18 - f15);
 f17 = Math_fround(f17 - f7);
 f12 = Math_fround(f12 - f10);
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(f16 - f15);
 f14 = Math_fround(f14 - f7);
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f10);
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f15 = Math_fround(f11 - f15);
 f7 = Math_fround(f9 - f7);
 f10 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) - f10);
 f9 = Math_fround(Math_fround(Math_fround(f18 * f18) + Math_fround(f17 * f17)) + Math_fround(f12 * f12));
 f11 = Math_fround(Math_fround(Math_fround(f18 * f16) + Math_fround(f17 * f14)) + Math_fround(f12 * f8));
 f13 = Math_fround(Math_fround(Math_fround(f16 * f16) + Math_fround(f14 * f14)) + Math_fround(f8 * f8));
 f12 = Math_fround(Math_fround(Math_fround(f18 * f15) + Math_fround(f17 * f7)) + Math_fround(f12 * f10));
 f10 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f7)) + Math_fround(f8 * f10));
 f8 = Math_fround(f9 * f10);
 f7 = Math_fround(f11 * f12);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f9 * f13) - Math_fround(f11 * f11)));
 HEAPF32[i5 >> 2] = Math_fround(f9 * Math_fround(Math_fround(f13 * f12) - Math_fround(f11 * f10)));
 HEAPF32[i6 >> 2] = Math_fround(f9 * Math_fround(f8 - f7));
 return;
}

function __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i1 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i3 >>> 0 > 1 ? 1 : i3;
 i4 = i5 + (i3 << 2) | 0;
 if (i3 | 0) {
  i3 = i5;
  do {
   i1 = HEAP32[i8 >> 2] | 0;
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
    __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
    i1 = HEAP32[i7 >> 2] | 0;
   } else {
    i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i8 >> 2] = i2;
   }
   HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i3 >>> 0 > 1 ? 1 : i3;
 i4 = i5 + 4 + (i3 << 2) | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i3 = i5 + 4 | 0;
 do {
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i1 = HEAP32[i7 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i8 >> 2] = i2;
  }
  HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15OcclusionPortal8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i4, i6);
 i3 = i4 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 379439 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0) | 0;
 if (i1 | 0) {
  do if ((i1 | 0) > 0) {
   i2 = i6 + 16 | 0;
   i8 = HEAP32[i6 + 20 >> 2] | 0;
   i1 = i8 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   if (i1 >>> 0 >= i8 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
    break;
   }
   __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
  } else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  } while (0);
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 44 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1034411 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 842535 | 0, i3, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_(i15, i16, i1) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i17 = 0;
 i2 = HEAP32[i16 + 4 >> 2] | 0;
 if ((HEAP32[i16 + 180 >> 2] | 0) == (i2 | 0)) {
  i17 = (HEAP32[i16 + 172 >> 2] | 0) + ((HEAP32[i16 + 176 >> 2] | 0) * 80 | 0) | 0;
  HEAP32[i15 >> 2] = i16;
  HEAP32[i15 + 4 >> 2] = i17;
  HEAP32[i15 + 8 >> 2] = i17;
  return;
 }
 i17 = HEAP32[i16 + 176 >> 2] | 0;
 i11 = i17 + -1 | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i13 + 2127912214 + (i13 << 12) | 0;
 i1 = i1 ^ -949894596 ^ HEAP32[i5 + 4 >> 2] ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i13 = HEAP32[i16 + 172 >> 2] | 0;
 i6 = HEAP32[i16 + 92 >> 2] | 0;
 i7 = i16 + 96 | 0;
 i8 = i16 + 8 | 0;
 i9 = i16 + 12 | 0;
 i10 = i16 + 16 | 0;
 i4 = 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 while (1) {
  i1 = i1 & i11;
  i3 = HEAP32[i13 + (i1 * 80 | 0) >> 2] | 0;
  if ((i6 | 0) == (i3 | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i13 + (i1 * 80 | 0) + 4 >> 2] | 0)) {
   i1 = -1;
   break;
  }
  if (!(HEAP8[i8 >> 0] | 0)) i14 = 10; else if (!i2) {
   i2 = 0;
   i14 = 10;
  } else if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) {
   if ((HEAP32[i10 >> 2] | 0) != (HEAP32[i13 + (i1 * 80 | 0) + 4 >> 2] | 0)) i14 = 10;
  } else i14 = 10;
  if ((i14 | 0) == 10) {
   i14 = 0;
   if ((i12 | 0) == (i3 | 0)) if ((i5 | 0) == (HEAP32[i13 + (i1 * 80 | 0) + 4 >> 2] | 0)) break;
  }
  i3 = i4 + 1 | 0;
  i4 = i3;
  i1 = i3 + i1 | 0;
 }
 i17 = i13 + (i17 * 80 | 0) | 0;
 HEAP32[i15 >> 2] = i16;
 HEAP32[i15 + 4 >> 2] = (i1 | 0) == -1 ? i17 : i13 + (i1 * 80 | 0) | 0;
 HEAP32[i15 + 8 >> 2] = i17;
 return;
}

function __ZN12_GLOBAL__N_115ParamNameLookup15AddBuiltinNamesEPPKcjb(i6, i4, i7, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = i7;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i7 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i7 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 if (i7 | 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 3) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   HEAP32[i2 + (i1 << 3) + 4 >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 if (!i5) return;
 i1 = i6 + 20 | 0;
 i2 = i6 + 32 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i6 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i7 << 1, 2, i6 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 1, 2, i6 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = i6;
  break;
 } while (0);
 if (i5 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i1 >> 2] | 0) + (i5 << 1) | 0;
 i2 = i7 - i5 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP16[i3 + (i1 << 1) >> 1] = 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function _UNITY_tt_glyphzone_new(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i6 >> 2] = i3;
 i1 = i4 & 65535;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = _UNITY_ft_mem_realloc(i3, 8, 0, i1, 0, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 + 16 >> 2] = _UNITY_ft_mem_realloc(i3, 8, 0, i1, 0, i7) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) {
   HEAP32[i6 + 20 >> 2] = _UNITY_ft_mem_realloc(i3, 8, 0, i1, 0, i7) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (!i2) {
    HEAP32[i6 + 24 >> 2] = _UNITY_ft_mem_realloc(i3, 1, 0, i1, 0, i7) | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if (!i2) {
     HEAP32[i6 + 28 >> 2] = _UNITY_ft_mem_realloc(i3, 2, 0, i5 << 16 >> 16, 0, i7) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
     if (!i2) {
      HEAP16[i6 + 4 >> 1] = i4;
      HEAP16[i6 + 6 >> 1] = i5;
      i8 = 0;
      STACKTOP = i9;
      return i8 | 0;
     }
    }
   }
  }
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i8 = i2;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i6 + 28 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i6 + 24 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i6 + 16 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 _UNITY_ft_mem_free(i1, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 i8 = i6 + 20 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i8 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function _UNITY_FT_Select_Charmap(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 if (!i8) {
  i9 = 35;
  return i9 | 0;
 }
 L4 : do if ((i4 | 0) < 1970170211) {
  switch (i4 | 0) {
  case 0:
   {
    i7 = 6;
    break;
   }
  default:
   break L4;
  }
  return i7 | 0;
 } else {
  switch (i4 | 0) {
  case 1970170211:
   break;
  default:
   break L4;
  }
  i5 = HEAP32[i8 + 40 >> 2] | 0;
  if (!i5) {
   i9 = 38;
   return i9 | 0;
  }
  i1 = i5 + (HEAP32[i8 + 36 >> 2] << 2) | 0;
  i2 = i1 + -4 | 0;
  L12 : do if (i2 >>> 0 >= i5 >>> 0) {
   L13 : while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    L15 : do if ((HEAP32[i3 + 4 >> 2] | 0) == 1970170211) {
     i10 = HEAP32[i3 + 8 >> 2] | 0;
     i4 = i10 >>> 16 & 65535;
     switch ((i10 & 65535) << 16 >> 16) {
     case 3:
      if (i4 << 16 >> 16 == 10) break L13; else break L15;
     case 0:
      if (i4 << 16 >> 16 == 4) break L13; else break L15;
     default:
      break L15;
     }
    } while (0);
    i2 = i2 + -4 | 0;
    if (i2 >>> 0 < i5 >>> 0) break L12;
   }
   HEAP32[i8 + 92 >> 2] = i3;
   i10 = 0;
   return i10 | 0;
  } while (0);
  do {
   i1 = i1 + -4 | 0;
   if (i1 >>> 0 < i5 >>> 0) {
    i7 = 38;
    i9 = 19;
    break;
   }
   i6 = HEAP32[i1 >> 2] | 0;
  } while ((HEAP32[i6 + 4 >> 2] | 0) != 1970170211);
  if ((i9 | 0) == 19) return i7 | 0;
  HEAP32[i8 + 92 >> 2] = i6;
  i10 = 0;
  return i10 | 0;
 } while (0);
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 if (!i1) {
  i10 = 38;
  return i10 | 0;
 }
 i10 = HEAP32[i8 + 36 >> 2] | 0;
 i3 = i1 + (i10 << 2) | 0;
 if ((i10 | 0) <= 0) {
  i10 = 6;
  return i10 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = i1 + 4 | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) break;
  if (i1 >>> 0 >= i3 >>> 0) {
   i7 = 6;
   i9 = 19;
   break;
  }
 }
 if ((i9 | 0) == 19) return i7 | 0;
 HEAP32[i8 + 92 >> 2] = i2;
 i10 = 0;
 return i10 | 0;
}

function __ZN9Animation9CrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfi(i15, i13, f10, i11) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i17 = i18 + 8 | 0;
 __ZN9Animation20BuildAnimationStatesEv(i15);
 i2 = HEAP32[i15 + 104 >> 2] | 0;
 i12 = HEAP32[i15 + 108 >> 2] | 0;
 i14 = HEAP8[i13 + 11 >> 0] | 0;
 L1 : do if ((i2 | 0) == (i12 | 0)) {
  i2 = i13;
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i9 = i14 << 24 >> 24 < 0;
  i8 = i9 ? HEAP32[i13 + 4 >> 2] | 0 : i14 & 255;
  i1 = HEAP32[i13 >> 2] | 0;
  i9 = i9 ? i1 : i13;
  while (1) {
   i7 = HEAP32[i2 >> 2] | 0;
   i4 = i7 + 112 | 0;
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   if (i3) i5 = HEAP32[i7 + 116 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i8 | 0)) {
    if (i3) {
     i4 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i7 + 116 >> 2] | 0;
    } else i3 = i6 & 255;
    if (!(_strncmp(i4, i9, i3) | 0)) break;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i12 | 0)) {
    i2 = i13;
    break L1;
   }
  }
  if (!i7) i2 = i13; else {
   __ZN9Animation9CrossFadeER14AnimationStatefib(i15, i7, f10, i11, 1);
   STACKTOP = i18;
   return;
  }
 } while (0);
 i13 = HEAP32[gb + 176236 >> 2] | 0;
 i14 = i14 << 24 >> 24 < 0 ? i1 : i2;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i16 + 4 >> 2] = i14;
 __Z6FormatPKcz(i17, i13, i16);
 if (!i15) i1 = 0; else i1 = HEAP32[i15 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 896407 | 0, 424, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i18;
 return;
}

function __ZN8Animator19FireAnimationEventsEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 i10 = i9 + 100 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i3 & 8 | 0) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = i3 | 8;
 if (HEAP8[i9 + 425 >> 0] | 0) if (__ZNK9HPlayable7IsValidEv(i9 + 628 | 0) | 0) {
  if ((HEAP16[gb + 1466944 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = i9;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466944 | 0, i1);
   i4 = gb + 1466944 | 0;
  } else i4 = 0;
  i5 = i9 + 564 | 0;
  i6 = i9 + 576 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   i7 = i9 + 153 | 0;
   i8 = i9 + 168 | 0;
   i3 = i2;
   do {
    if (HEAP8[i7 >> 0] | 0) if (HEAP32[i8 >> 2] | 0) {
     f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
     f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
     __ZN13AnimationClip19FireAnimationEventsEffRN5Unity9ComponentEP17AnimatorStateInfoP16AnimatorClipInfob(HEAP32[i3 >> 2] | 0, f13, f12, i9, i3 + 12 | 0, i3 + 48 | 0, (HEAP32[tempDoublePtr >> 2] = HEAP32[i3 + 56 >> 2] & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0));
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i3 = i3 + 60 | 0;
   } while ((i3 | 0) != (i2 + (i1 * 60 | 0) | 0));
  }
  if (i4 | 0) __Z12profiler_endP19ProfilerInformation(i4);
 }
 i1 = i9 + 564 | 0;
 i2 = i9 + 580 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 568 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 576 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -9;
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i13 + 16 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i5 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i8 + (i5 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 36 | 0;
 i3 = i13 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i2 + (i11 << 3) >> 2] | 0;
   i16 = i15 + ~(i15 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i6 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP32[i8 + (i11 << 3) >> 2] = i15;
   HEAP32[i8 + (i11 << 3) + 4 >> 2] = HEAP32[i2 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i4 >> 2] = i5;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx22PxSimulationStatisticsC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 88 + (i1 * 28 | 0) >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 8 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 8 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 8 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 8 >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 12 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 12 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 12 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 12 >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 16 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 16 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 16 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 16 >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 20 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 20 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 20 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 20 >> 2] = 0;
  HEAP32[i2 + 88 + (i1 * 28 | 0) + 24 >> 2] = 0;
  HEAP32[i2 + 480 + (i1 * 28 | 0) + 24 >> 2] = 0;
  HEAP32[i2 + 284 + (i1 * 28 | 0) + 24 >> 2] = 0;
  HEAP32[i2 + 676 + (i1 * 28 | 0) + 24 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 7);
 i3 = i2 + 872 | 0;
 i1 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i1 | 0));
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 return;
}

function __ZN16RenderTextureMap6RemoveEPK17RenderSurfaceBase(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[gb + 1158228 >> 2] | 0;
 i12 = i11 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 L1 : do if ((HEAP32[i11 + 36 >> 2] | 0) == (i4 | 0)) {
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i1 = HEAP32[i11 + 32 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i11 + 32 >> 2] | 0;
  i8 = i10 + -1 | 0;
  i1 = i8 & (Math_imul(i7, 1419247029) | 0);
  i2 = HEAP32[i11 + 28 >> 2] | 0;
  i9 = HEAP32[i11 + 20 >> 2] | 0;
  i6 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L4 : do if ((i9 | 0) != (i6 | 0)) {
   i3 = i11 + 12 | 0;
   L6 : do if (!(HEAP8[i11 + 8 >> 0] | 0)) {
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i3 | 0) == (i7 | 0)) break L6;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L4;
    }
   } else {
    if (!i4) {
     i4 = 0;
     i3 = i6;
     while (1) {
      if ((i3 | 0) == (i7 | 0)) break L6;
      i4 = i4 + 1 | 0;
      i1 = i4 + i1 & i8;
      i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
      if ((i9 | 0) == (i3 | 0)) break L4;
     }
    }
    i5 = HEAP32[i3 >> 2] | 0;
    i4 = 0;
    i3 = i6;
    while (1) {
     if ((i5 | 0) != (i3 | 0) & (i3 | 0) == (i7 | 0)) break L6;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L4;
    }
   } while (0);
   if ((i1 | 0) != -1) {
    i3 = i2 + (i1 << 3) | 0;
    i1 = i10;
    break L1;
   }
  } while (0);
  i3 = i2 + (i10 << 3) | 0;
  i1 = i10;
 } while (0);
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) return;
 i8 = i11 + 12 | 0;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i3;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 HEAP8[i11 + 48 >> 0] = 1;
 return;
}

function __ZN14DataBufferGLES16RecreateWithDataEiPKv(i7, i8, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = i7 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 i6 = HEAP32[gb + 1451080 >> 2] | 0;
 switch (HEAP32[i7 + 12 >> 2] | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
   } else i1 = 1;
   break;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 0 : 2;
   } else i1 = 0;
   break;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   break;
  }
 default:
  i1 = -559030611;
 }
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 if (i5) i2 = __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj(i6, i1, i8, i2, i3) | 0; else i2 = __ZN7ApiGLES14RecreateBufferEjN2gl12BufferTargetElPKvj(i6, i4, i1, i8, i2, i3) | 0;
 HEAP32[i9 >> 2] = i2;
 i1 = i7 + 20 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i6 = i2;
  i5 = i7 + 8 | 0;
  HEAP32[i5 >> 2] = i8;
  i5 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i9 = i7 + 24 | 0;
  HEAP32[i9 >> 2] = i5;
  HEAP8[i1 >> 0] = 1;
  i6 = i6 | -1073741824;
  i9 = i7;
  __Z32register_external_gfx_allocationPvjjPKci(i6, i8, i9, gb + 602218 | 0, 235);
  return;
 }
 __Z34register_external_gfx_deallocationPvPKci(i2 | -1073741824, gb + 602218 | 0, 228);
 i6 = HEAP32[i9 >> 2] | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i8;
 i5 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i9 = i7 + 24 | 0;
 HEAP32[i9 >> 2] = i5;
 HEAP8[i1 >> 0] = 1;
 i6 = i6 | -1073741824;
 i9 = i7;
 __Z32register_external_gfx_allocationPvjjPKci(i6, i8, i9, gb + 602218 | 0, 235);
 return;
}

function __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i1 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) return;
 i8 = 0;
 L7 : while (1) {
  while (1) {
   i1 = i1 + -1 | 0;
   i3 = HEAP32[i2 + 36 >> 2] | 0;
   if (HEAP8[i3 + (i8 << 3) >> 0] | 0) break;
   i4 = HEAP32[i3 + (i8 << 3) + 4 >> 2] | 0;
   __ZN5physx12NpConstraint12actorDeletedEPNS_12PxRigidActorE(i4, i10);
   i2 = __ZNK5physx12NpConstraint10getNpSceneEv(i4) | 0;
   if (i2 | 0) {
    __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i2 + 16 | 0, i4 + 16 | 0);
    i7 = i2 + 3540 | 0;
    i5 = i2 + 3544 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    L14 : do if (!i6) i2 = 0; else {
     i3 = HEAP32[i7 >> 2] | 0;
     i2 = 0;
     do {
      if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) == (i4 | 0)) break L14;
      i2 = i2 + 1 | 0;
     } while (i2 >>> 0 < i6 >>> 0);
    } while (0);
    if ((i2 | 0) != (i6 | 0)) {
     i6 = i6 + -1 | 0;
     HEAP32[i5 >> 2] = i6;
     i7 = HEAP32[i7 >> 2] | 0;
     HEAP32[i7 + (i2 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
    }
   }
   i7 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i7 + 36 >> 2] | 0;
   i7 = i7 + 40 | 0;
   i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i6;
   i6 = i2 + (i6 << 3) | 0;
   i7 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i2 + (i8 << 3) | 0;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = i7;
   i2 = HEAP32[i9 >> 2] | 0;
   if (!(HEAP32[i2 + 40 >> 2] | 0)) {
    if ((HEAP32[i2 + 44 >> 2] | 0) > -1) __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(HEAP32[gb + 1457204 >> 2] | 0, i2);
    HEAP32[i9 >> 2] = 0;
    i2 = 0;
   }
   if (!i1) {
    i1 = 19;
    break L7;
   }
  }
  if (!i1) {
   i1 = 19;
   break;
  } else i8 = i8 + 1 | 0;
 }
 if ((i1 | 0) == 19) return;
}

function __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i10, i11, i2, i1, i7, i8) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i9 = i10 + 32 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i3 + 96 >> 2] | 0;
 i6 = ~i5 & i2 | i1;
 i4 = i5 & ~i2;
 if (!(i6 | i4 | 0 ? 1 : (HEAP32[i3 + 100 >> 2] | 0) != (i11 | 0))) {
  STACKTOP = i13;
  return;
 }
 if ((HEAP32[i3 + 4 >> 2] | 0) == 1) i1 = i3; else {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i9 >> 2] | 0);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i9 >> 2] = i1;
 }
 i1 = i1 + 8 | 0;
 if (i5 & 4 & i6 | 0) if ((HEAP8[i7 + 4 >> 0] | 0) != 2) __ZN4Mesh21UnswizzleVertexColorsEb(i10, 1);
 i2 = __Z20push_allocation_rootPvP13BaseAllocatorb(i10, 0, 0) | 0;
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i1, i11, i6, i4, i8, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 if (HEAP32[i1 + 176 >> 2] | 0) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
  HEAP32[i12 + 12 >> 2] = 0;
  HEAP32[i12 + 16 >> 2] = 0;
  HEAP32[i12 + 20 >> 2] = 0;
  HEAP32[i12 + 24 >> 2] = 0;
  HEAP32[i12 + 28 >> 2] = 0;
  __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i1 + 164 | 0, i11, i12, 1);
 }
 i12 = i10 + 44 | 0;
 HEAP8[i12 >> 0] = HEAP8[i12 >> 0] | 1;
 if (!i2) {
  STACKTOP = i13;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i13;
 return;
}

function __ZN14NavMeshManager8LoadDataEPK11NavMeshData(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, f5 = f0, f6 = f0;
 i2 = i3 + 108 | 0;
 do if (!(HEAP32[i2 >> 2] | 0)) {
  __ZN14NavMeshManager24InitializeNavMeshSystemsEPK11NavMeshData(i3, i1);
  if (!(HEAP32[i2 >> 2] | 0)) {
   i4 = 0;
   return i4 | 0;
  }
 } else {
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 32 >> 2]));
  i4 = f5 < Math_fround(0.0);
  f6 = Math_fround(-f5);
  if ((i4 ? f6 : f5) <= Math_fround(9.99999974e-06)) {
   f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
   f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 36 >> 2]));
   i4 = f6 < Math_fround(0.0);
   f5 = Math_fround(-f6);
   if ((i4 ? f5 : f6) <= Math_fround(9.99999974e-06)) {
    f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
    f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 40 >> 2]));
    i4 = f6 < Math_fround(0.0);
    f5 = Math_fround(-f6);
    if ((i4 ? f5 : f6) <= Math_fround(9.99999974e-06)) {
     f6 = Math_fround(HEAPF32[i3 + 12 >> 2]);
     f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 44 >> 2]));
     i4 = f6 < Math_fround(0.0);
     f5 = Math_fround(-f6);
     if ((i4 ? f5 : f6) <= Math_fround(9.99999974e-06)) break;
    }
   }
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 846053 | 0, 0, gb + 842172 | 0, 197, 1, 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 } while (0);
 i1 = __ZN14NavMeshManager16LoadDataInternalEPK11NavMeshData(i3, i1) | 0;
 if (!i1) {
  if (HEAP32[i3 + 132 >> 2] | 0) {
   i4 = 0;
   return i4 | 0;
  }
  __ZN14NavMeshManager7CleanupEv(i3);
  i4 = 0;
  return i4 | 0;
 }
 i4 = i3 + 52 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = i1;
  return i4 | 0;
 }
 i3 = i3 + 40 | 0;
 i2 = 0;
 do {
  __ZN12NavMeshAgent14OnNavMeshAddedEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return i1 | 0;
}

function __ZN13GfxDeviceGLES17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv(i13, i1, i14, i2, i15) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i16 + 8 | 0;
 i11 = i16;
 i9 = i16 + 16 | 0;
 i10 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i5 = HEAP32[i14 + 16 >> 2] | 0;
 i3 = HEAP32[i14 + 20 >> 2] | 0;
 i8 = Math_imul(i3, i5) | 0;
 i7 = i14 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i8 = Math_imul(i8, i1) | 0;
 i6 = i2 >>> 2;
 i4 = HEAP32[i14 + 4 >> 2] | 0;
 do if (!i4) i2 = gb + 76812 + (i3 + -1 << 4) + (i5 + -1 << 2) | 0; else {
  i2 = i5 + -1 | 0;
  if ((i4 | 0) == 1) {
   i2 = gb + 76876 + (i2 << 2) | 0;
   break;
  } else {
   i2 = gb + 76892 + (i2 << 2) | 0;
   break;
  }
 } while (0);
 i2 = HEAP32[i2 >> 2] | 0;
 if (i6 >>> 0 > i8 >>> 0) {
  HEAP32[i11 >> 2] = i6;
  HEAP32[i11 + 4 >> 2] = i8;
  __Z6FormatPKcz(i9, gb + 603394 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 603515 | 0, 2481, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i1 = HEAP32[i7 >> 2] | 0;
 } else if (i6 >>> 0 < i8 >>> 0) {
  HEAP32[i12 >> 2] = i6;
  HEAP32[i12 + 4 >> 2] = i8;
  __Z6FormatPKcz(i9, gb + 603600 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 603515 | 0, 2485, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i16;
  return;
 }
 mftCall_viiiiii(i2 | 0, i13 + 4620 | 0, i10 | 0, HEAP32[i14 + 8 >> 2] | 0, i1 | 0, 0, i15 | 0);
 STACKTOP = i16;
 return;
}

function __Z40GameObject_CUSTOM_FindGameObjectsWithTagP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i4 = i9;
 i5 = i9 + 36 | 0;
 i8 = i9 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i4);
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 __Z22FindGameObjectsWithTagI13dynamic_arrayIP10GameObjectLj4EEEvjRT_(__Z18ExtractTagThrowingR11ICallString(i5) | 0, i8);
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(1) | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE(i1) | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, HEAP32[i3 >> 2] | 0) | 0;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i8 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 if ((i1 | 0) < (i5 | 0)) do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return i4 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return i4 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i4, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z11scalePlanesPN5physx7PxPlaneEPKNS_2Gu14ConvexHullDataERKNS_7PxMat33E(i2, i3, i18) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i18 = i18 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, f19 = f0;
 i1 = HEAP8[i3 + 39 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i14 = i18 + 4 | 0;
 i15 = i18 + 8 | 0;
 i16 = i18 + 12 | 0;
 i17 = i18 + 16 | 0;
 i10 = i18 + 20 | 0;
 i11 = i18 + 24 | 0;
 i12 = i18 + 28 | 0;
 i13 = i18 + 32 | 0;
 i9 = i1 & 255;
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 while (1) {
  f19 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f4 = Math_fround(f19 * Math_fround(HEAPF32[i18 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f8 * Math_fround(HEAPF32[i14 >> 2])));
  f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i15 >> 2])));
  f6 = Math_fround(f19 * Math_fround(HEAPF32[i16 >> 2]));
  f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i17 >> 2])));
  f6 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i10 >> 2])));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2]));
  f8 = Math_fround(f19 + Math_fround(f8 * Math_fround(HEAPF32[i12 >> 2])));
  f5 = Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f5 * f5))));
  if (f8 > Math_fround(0.0)) {
   f19 = Math_fround(Math_fround(1.0) / f8);
   f5 = Math_fround(f5 * f19);
   f6 = Math_fround(f6 * f19);
   f4 = Math_fround(f4 * f19);
  }
  f19 = Math_fround(f7 / f8);
  HEAPF32[i2 >> 2] = f4;
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f19;
  i9 = i9 + -1 | 0;
  if (!i9) break; else {
   i2 = i2 + 16 | 0;
   i1 = i1 + 20 | 0;
  }
 }
 return;
}

function __ZNKSt3__214collate_bynameIcE12do_transformEPKcS3_(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i8, i1, i2);
 i5 = i8 + 11 | 0;
 i4 = i3 + 8 | 0;
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 211 | 0, 0, ((HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0, 0, HEAP32[i4 >> 2] | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) i9 = 7; else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1046 | 0, i6 | 0, i1 | 0, 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i9 = 7; else {
   i1 = HEAP8[i6 + 11 >> 0] | 0;
   if (i1 << 24 >> 24 < 0) {
    i2 = HEAP32[i6 + 4 >> 2] | 0;
    i3 = HEAP32[i6 >> 2] | 0;
    i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   } else {
    i2 = i1 & 255;
    i3 = i6;
    i1 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
   }
   __THREW__ = 0;
   invoke_iiiii(fb + 211 | 0, i3 | 0, i1 | 0, i2 + 1 | 0, HEAP32[i4 >> 2] | 0) | 0;
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    break;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    STACKTOP = i7;
    return;
   }
  }
 } while (0);
 if ((i9 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 * 12 | 0;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 832684 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 * 12 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 * 12 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 12 | 0) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 * 12 | 0) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 * 12 | 0) | 0;
 return i10 | 0;
}

function __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i5, gb + 898897 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i5 + 12 | 0, gb + 843739 | 0, 0);
 i8 = i1 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i5 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 2 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i3 = HEAP16[i7 >> 1] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP16[i3 >> 1] | 0;
  HEAP16[i7 >> 1] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP16[i5 + 28 >> 1] = _llvm_bswap_i16(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 30 >> 0] = i1;
 i1 = i5 + 31 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i6;
  HEAP32[i8 >> 2] = i3;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z42TerrainData_Set_Custom_PropSplatPrototypesP12Il2CppObjectP11Il2CppArray(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = i12 + 16 | 0;
 i9 = i12 + 4 | 0;
 if (!i1) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i10 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i6 = i2 + 32 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 L7 : do if (i7 | 0) {
  i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0;
  if (i5 | 0) {
   __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj(i9, i5);
   if ((i5 | 0) > 0) {
    i1 = 0;
    while (1) {
     i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i7, i1) | 0;
     if (!i2) break;
     i4 = i8;
     i2 = i2 + 8 | 0;
     i3 = i4 + 44 | 0;
     do {
      HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
      i4 = i4 + 4 | 0;
      i2 = i2 + 4 | 0;
     } while ((i4 | 0) < (i3 | 0));
     __Z19SplatPrototypeToCppRK18MonoSplatPrototypeR14SplatPrototype(i8, (HEAP32[i9 >> 2] | 0) + (i1 * 44 | 0) | 0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i5 | 0)) break L7;
    }
    HEAP32[i11 >> 2] = i1;
    __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 937647 | 0, i11);
   }
  }
 } while (0);
 __ZN13SplatDatabase18SetSplatPrototypesERKNSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEE(i6, i9);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i10 >> 2] = i2 + (~(((i2 + -44 - i1 | 0) >>> 0) / 44 | 0) * 44 | 0);
 __ZdlPv(i1);
 STACKTOP = i12;
 return;
}

function __Z17DeformSkinnedMeshR12SkinMeshInfo(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i2 = i9;
 if ((HEAP16[gb + 1161568 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161568 | 0, i1);
  i7 = gb + 1161568 | 0;
 } else i7 = 0;
 i1 = i8 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i6 = i8 + 36 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 L7 : do if (i5 | 0) {
  i1 = HEAP32[i8 + 76 >> 2] | 0;
  i2 = HEAP32[i8 + 28 >> 2] | 0;
  i3 = (i2 | 0) != 0;
  if (!(i2 | i1)) {
   i2 = i8 + 32 | 0;
   i3 = i8 + 40 | 0;
   i4 = i8 + 60 | 0;
   _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, Math_imul(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) | 0;
   i1 = HEAP32[i8 + 68 >> 2] | 0;
   if (!i1) break;
   __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fjPS2_ji(i1, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 + 44 >> 2] | 0, HEAP32[i4 >> 2] | 0);
   break;
  }
  do if (!i1) if (i3) {
   i1 = 0;
   i4 = 14;
  } else break L7; else {
   i2 = Math_imul(HEAP32[i8 + 60 >> 2] | 0, HEAP32[i8 + 40 >> 2] | 0) | 0;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 428921 | 0, 121) | 0;
   __Z16ApplyBlendShapesR12SkinMeshInfoPh(i8, i1);
   if (i3) {
    HEAP32[i8 + 32 >> 2] = i1;
    i4 = 14;
    break;
   } else {
    _memcpy(HEAP32[i6 >> 2] | 0, i1 | 0, i2 | 0) | 0;
    break;
   }
  } while (0);
  if ((i4 | 0) == 14) __Z15SkinMeshMathLibR12SkinMeshInfo(i8);
  if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 } while (0);
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i9;
 return;
}

function __ZNK12NavMeshAgent8CopyPathEP11NavMeshPath(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i1 + 68 | 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  HEAP32[i10 + 20 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 2;
  return;
 }
 i2 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i7) | 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 __ZN11NavMeshPath15ReservePolygonsEi(i10, i3);
 i4 = i3 << 3;
 _memcpy(HEAP32[i10 + 8 >> 2] | 0, HEAP32[i2 + 28 >> 2] | 0, i4 | 0) | 0;
 i5 = i10 + 8 | 0;
 i6 = i10 + 20 | 0;
 HEAP32[i6 >> 2] = i3;
 i8 = i10 + 24 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 do if ((i9 & 2147483647) >>> 0 < i3 >>> 0) if ((i9 | 0) > -1) {
  HEAP32[i8 >> 2] = i3;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4, 8, i10 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 8, i10 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i5 >> 2] = i9;
  break;
 } while (0);
 i9 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i10 + 40 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i10 + 44 >> 2] = i9;
 HEAP32[i10 + 48 >> 2] = i8;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i10 + 28 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 32 >> 2] = i8;
 HEAP32[i10 + 36 >> 2] = i9;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) i1 = 2; else if (!(HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i7) | 0) + 44 >> 0] & 1)) i1 = 2; else i1 = (HEAPU8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i7) | 0) + 44 >> 0] | 0) >>> 1 & 1;
 HEAP32[i10 + 4 >> 2] = i1;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i8 + 16 | 0;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i5 = i8 + 28 | 0;
 HEAP8[i6 >> 0] = HEAP32[i5 >> 2];
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 1);
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP8[i4 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i3 << 24 >> 24;
 i1 = i8 + 32 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i8 + 16 | 0;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i1 = i8 + 20 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 >> 2] = i3;
 }
 i1 = i8 + 24 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i10 >> 2] = i4;
 }
 i5 = i8 + 28 | 0;
 HEAP8[i6 >> 0] = HEAP32[i5 >> 2];
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i6, 1);
  i3 = HEAP8[i6 >> 0] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP8[i4 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i10 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 >> 2] = i3 << 24 >> 24;
 i1 = i8 + 32 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i10, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN9Animation5BlendERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEff(i15, i13, f10, f11) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18;
 i17 = i18 + 8 | 0;
 __ZN9Animation20BuildAnimationStatesEv(i15);
 i2 = HEAP32[i15 + 104 >> 2] | 0;
 i12 = HEAP32[i15 + 108 >> 2] | 0;
 i14 = HEAP8[i13 + 11 >> 0] | 0;
 L1 : do if ((i2 | 0) == (i12 | 0)) {
  i2 = i13;
  i1 = HEAP32[i13 >> 2] | 0;
 } else {
  i9 = i14 << 24 >> 24 < 0;
  i8 = i9 ? HEAP32[i13 + 4 >> 2] | 0 : i14 & 255;
  i1 = HEAP32[i13 >> 2] | 0;
  i9 = i9 ? i1 : i13;
  while (1) {
   i7 = HEAP32[i2 >> 2] | 0;
   i4 = i7 + 112 | 0;
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   if (i3) i5 = HEAP32[i7 + 116 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i8 | 0)) {
    if (i3) {
     i4 = HEAP32[i4 >> 2] | 0;
     i3 = HEAP32[i7 + 116 >> 2] | 0;
    } else i3 = i6 & 255;
    if (!(_strncmp(i4, i9, i3) | 0)) break;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i12 | 0)) {
    i2 = i13;
    break L1;
   }
  }
  if (!i7) i2 = i13; else {
   __ZN9Animation5BlendER14AnimationStateff(i15, i7, f10, f11);
   STACKTOP = i18;
   return;
  }
 } while (0);
 i13 = HEAP32[gb + 176236 >> 2] | 0;
 i14 = i14 << 24 >> 24 < 0 ? i1 : i2;
 HEAP32[i16 >> 2] = i14;
 HEAP32[i16 + 4 >> 2] = i14;
 __Z6FormatPKcz(i17, i13, i16);
 if (!i15) i1 = 0; else i1 = HEAP32[i15 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i17 + 11 >> 0] | 0) < 0 ? HEAP32[i17 >> 2] | 0 : i17, 0, gb + 896407 | 0, 416, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i17);
 STACKTOP = i18;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18GfxFramebufferGLES20ActiveContextChangedEPP17RenderSurfaceBaseS2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i9 = i3 + 376 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN18GfxFramebufferGLES23SetupDefaultFramebufferEPP17RenderSurfaceBaseS2_N2gl6HandleILNS3_10ObjectTypeE9EEE(i3, i1, i2, i5);
 HEAP8[i3 + 329 >> 0] = 1;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i5, HEAP32[i3 + 336 >> 2] | 0, 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i3 + 168 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i3 + 176 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 i1 = (HEAP8[i3 + 328 >> 0] | 0) == 0;
 if (HEAP8[i3 + 208 >> 0] | 0) {
  if (!i1) {
   __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv(i3);
   STACKTOP = i4;
   return;
  }
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i3, i3 + 16 | 0);
  __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv(i3);
  STACKTOP = i4;
  return;
 }
 if (i1) {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i3, 0);
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i3, i3 + 16 | 0);
  __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv(i3);
  STACKTOP = i4;
  return;
 } else {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i3, 1);
  __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv(i3);
  STACKTOP = i4;
  return;
 }
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801045 | 0, i1, 0);
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i8 = i1 + 160 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, HEAP32[gb + 37320 >> 2] | 0, i8, 0);
 i7 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 20 >> 2] = i7;
 i7 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i7, i8, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i7, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 168 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801063 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i5 >> 2] = 51;
 HEAP32[i5 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
 i6 = i2 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i7 + 32 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i12 = i10 + 9 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN22UnityProfilerPerThread11SetIsActiveEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d5 = 0.0, i6 = 0, i7 = 0;
 if (i1) {
  d5 = +_emscripten_get_now() * 1.0e6;
  i2 = +Math_abs(d5) >= 1.0 ? (d5 > 0.0 ? ~~+Math_min(+Math_floor(d5 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d5 - +(~~d5 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i3 = i4 + 224 | 0;
  HEAP32[i3 >> 2] = ~~d5 >>> 0;
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i4 + 232 >> 2] = 0;
  i3 = i4;
  i4 = (HEAP32[i4 + 48 >> 2] | 0) != 0 & 1;
  HEAP8[i3 >> 0] = i4;
  return;
 }
 if (HEAP8[i4 >> 0] | 0) {
  i2 = i4 + 248 | 0;
  i1 = i2;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!((i3 | 0) == 0 & (i1 | 0) == 0)) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i4, gb + 1163364 | 0, 0) | 0;
   i2 = HEAP32[(HEAP32[i4 + 36 >> 2] | 0) + ((HEAP32[i4 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
   i6 = HEAP32[HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + (i2 >>> 14 << 2) >> 2] >> 2] | 0;
   d5 = +_emscripten_get_now() * 1.0e6;
   i7 = +Math_abs(d5) >= 1.0 ? (d5 > 0.0 ? ~~+Math_min(+Math_floor(d5 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d5 - +(~~d5 >>> 0)) / 4294967296.0) >>> 0) : 0;
   __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i4, gb + 1163364 | 0, ~~d5 >>> 0, i7) | 0;
   i3 = ___udivdi3(i3 | 0, i1 | 0, 1e3, 0) | 0;
   HEAPF32[i6 + ((i2 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i3 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
  }
 }
 d5 = +_emscripten_get_now() * 1.0e6;
 i6 = +Math_abs(d5) >= 1.0 ? (d5 > 0.0 ? ~~+Math_min(+Math_floor(d5 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d5 - +(~~d5 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i7 = i4 + 224 | 0;
 HEAP32[i7 >> 2] = ~~d5 >>> 0;
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i4 + 232 >> 2] = 0;
 i7 = i4;
 i6 = 0;
 HEAP8[i7 >> 0] = i6;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i5, i1, i2, i8, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i11 = i5 + 16 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i5 + 24 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 >> 2] = i3;
  i4 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i8, 4);
  i4 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i2 = i8 + 4 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i3 = HEAP32[i11 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = i8 + 8 | 0;
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i8 + 12 | 0;
 i4 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i9 >> 2] = i4;
 i5 = i3 + 4 | 0;
 if (i5 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i11 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i9 = i2 << 24 >> 24 < 0;
 i1 = i9 ? HEAP32[i7 >> 2] | 0 : i7;
 i9 = i9 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i9 | 0;
 if (!i9) {
  __ZN12CachedWriter11Align4WriteEv(i11);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN12CachedWriter11Align4WriteEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i7 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i4 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i4 >>> 0 > i5 >>> 0) {
  _memset(i2 + (i5 << 2) | 0, 0, i4 - i5 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17Physics2DSettings13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (HEAP32[gb + 1458412 >> 2] | 0) + 4 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i6 = i4 + 32 | 0;
 i2 = i4 + 36 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 + 102972 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 102976 >> 2] = i8;
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 if (f5 == Math_fround(HEAPF32[gb + 1162356 >> 2])) {
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f5 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2]))) i3 = 3;
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 102956 >> 2] | 0;
  if (i1 | 0) do {
   if ((HEAP32[i1 >> 2] | 0) == 2) if (Math_fround(HEAPF32[i1 + 140 >> 2]) != Math_fround(0.0)) {
    i2 = i1 + 4 | 0;
    i3 = HEAPU16[i2 >> 1] | 0;
    if (!(i3 & 2)) {
     HEAP16[i2 >> 1] = i3 | 2;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    }
   }
   i1 = HEAP32[i1 + 96 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 HEAP32[gb + 151644 >> 2] = HEAP32[i4 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i4 + 52 >> 2];
 f5 = Math_fround(Math_fround(HEAPF32[i4 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i4 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f5;
 f5 = Math_fround(f5 * f5);
 HEAPF32[gb + 151892 >> 2] = f5;
 f5 = Math_fround(Math_fround(HEAPF32[i4 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f5;
 f5 = Math_fround(f5 * f5);
 HEAPF32[gb + 151900 >> 2] = f5;
 HEAP32[gb + 151904 >> 2] = HEAP32[i4 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i4 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i4 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i4 + 84 >> 2];
 f5 = Math_fround(Math_fround(HEAPF32[i4 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f5;
 return;
}

function __ZN17InternalIndexPool15allocateIndicesEjRKN5physx16PxStrideIteratorIjEE(i2, i6, i13) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i2 + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i11 = i2 + 12 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 i15 = (i5 & 2147483647) + (i4 - i3) | 0;
 i15 = i15 >>> 0 > i6 >>> 0 ? i6 : i15;
 if (i15 >>> 0 < i6 >>> 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 666952 | 0, 260, gb + 667274 | 0, i16);
  i7 = HEAP32[i11 >> 2] | 0;
 } else i7 = i4;
 i12 = i15 >>> 0 < i7 >>> 0 ? i15 : i7;
 i1 = i15 - i12 | 0;
 if (!i12) i2 = 0; else {
  i8 = HEAP32[i2 + 8 >> 2] | 0;
  i9 = HEAP32[i13 >> 2] | 0;
  i10 = i13 + 4 | 0;
  i4 = i3 + -1 - i4 - (i5 & 2147483647) | 0;
  i2 = ~i7;
  i2 = i4 >>> 0 > i2 >>> 0 ? i4 : i2;
  i4 = ~i6;
  i4 = i2 >>> 0 > i4 >>> 0 ? i2 : i4;
  i7 = i7 + -1 | 0;
  i2 = HEAP32[i8 + (i7 << 2) >> 2] | 0;
  HEAP32[i11 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i2 = i12 + -1 | 0;
  if (i2 | 0) {
   i3 = 0;
   do {
    i3 = i3 + 1 | 0;
    i6 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
    i7 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
    HEAP32[i11 >> 2] = i6;
    HEAP32[i9 + (Math_imul(HEAP32[i10 >> 2] | 0, i3) | 0) >> 2] = i7;
    i2 = i2 + -1 | 0;
   } while ((i2 | 0) != 0);
  }
  i2 = ~i4;
 }
 if ((i15 | 0) == (i12 | 0)) {
  STACKTOP = i16;
  return i15 | 0;
 }
 i4 = HEAP32[i13 >> 2] | 0;
 i3 = i13 + 4 | 0;
 while (1) {
  i13 = HEAP32[i14 >> 2] | 0;
  HEAP32[i14 >> 2] = i13 + 1;
  HEAP32[i4 + (Math_imul(HEAP32[i3 >> 2] | 0, i2) | 0) >> 2] = i13;
  i1 = i1 + -1 | 0;
  if (!i1) break; else i2 = i2 + 1 | 0;
 }
 STACKTOP = i16;
 return i15 | 0;
}

function __Z31Sprite_Get_Custom_PropTrianglesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = (__ZNK6Sprite13GetRenderDataEb(i2, 0) | 0) + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 64 >> 2] | 0, 2, i3) | 0;
 if (!i3) {
  STACKTOP = i7;
  return i4 | 0;
 }
 i2 = i1 + 28 | 0;
 i1 = 0;
 do {
  i6 = HEAP16[(HEAP32[i2 >> 2] | 0) + (i1 << 1) >> 1] | 0;
  HEAP16[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 2) | 0) >> 1] = i6;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return i4 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclERKNS_27PxRigidActorShapeCollectionEj(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i5 >> 2] = gb + 673520;
 HEAP8[i5 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i5;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_18PxArticulationLinkEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i7, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 28; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i12, i11, i14) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i15 = 0;
 HEAP32[i12 >> 2] = 0;
 i15 = i12 + 20 | 0;
 HEAP32[i15 >> 2] = 0;
 i8 = i12 + 24 | 0;
 i13 = gb + 64016 | 0;
 i1 = HEAP32[i13 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = i12 + 4 | 0;
 HEAP8[i9 >> 0] = 0;
 i1 = _strlen(i11) | 0;
 i13 = i14 + 20 | 0;
 i2 = (HEAP32[i13 >> 2] | 0) + i1 | 0;
 if (i2 >>> 0 < 15) i6 = 0; else {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i12, i2);
  i6 = HEAP32[i12 >> 2] | 0;
 }
 i5 = (i6 | 0) == 0;
 i2 = i5 ? i9 : i6;
 if (i2 >>> 0 > i11 >>> 0) i10 = 7; else {
  i3 = HEAP32[i15 >> 2] | 0;
  if ((i2 + i3 | 0) >>> 0 > i11 >>> 0) {
   i1 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
   if ((i2 | 0) != (i11 | 0)) _memmove(i2 | 0, i11 | 0, i1 | 0) | 0;
  } else i10 = 7;
 }
 if ((i10 | 0) == 7) {
  i7 = i12 + 4 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = (i3 | 0) == 0;
  if (i4) if (i5) {
   i3 = 15;
   i10 = 10;
  } else i10 = 13; else {
   i3 = i5 ? 15 : i3;
   i10 = 10;
  }
  if ((i10 | 0) == 10) if (i3 >>> 0 < i1 >>> 0) if (i5 | i4) i10 = 13; else {
   __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
   i10 = 13;
  }
  if ((i10 | 0) == 13) {
   if (i1 >>> 0 > 15) {
    i3 = i1;
    i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + 1 | 0, 16, i8, 0, gb + 1047486 | 0, 251) | 0;
   } else {
    i3 = 0;
    i2 = 0;
   }
   HEAP32[i12 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
   i2 = (i2 | 0) == 0 ? i9 : i2;
  }
  _memcpy(i2 | 0, i11 | 0, i1 | 0) | 0;
  HEAP8[i2 + i1 >> 0] = 0;
 }
 HEAP32[i15 >> 2] = i1;
 i15 = HEAP32[i14 >> 2] | 0;
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i12, i1, 0, (i15 | 0) == 0 ? i14 + 4 | 0 : i15, HEAP32[i13 >> 2] | 0);
 return;
}

function __ZN14DetailDatabase13AddLayerIndexEiR11DetailPatch(i11, i5, i10) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i12 = i10 + 28 | 0;
 i13 = i10 + 32 | 0;
 i7 = HEAP32[i13 >> 2] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3;
 i6 = i7;
 L1 : do if ((i7 | 0) == (i3 | 0)) i3 = i7; else {
  i2 = i7 - i3 | 0;
  i1 = 0;
  while (1) {
   if ((HEAPU8[i4 + i1 >> 0] | 0 | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  return i1 | 0;
 } while (0);
 i9 = i5 & 255;
 i2 = i10 + 36 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = i8;
 if ((i6 | 0) == (i8 | 0)) {
  i4 = i7 - i3 + 1 | 0;
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
   i3 = HEAP32[i12 >> 2] | 0;
   i8 = i2;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i13 >> 2] | 0;
  } else {
   i8 = i2;
   i2 = i7;
  }
  i7 = i3;
  i5 = i1 - i3 | 0;
  i6 = i5 << 1;
  i6 = i5 >>> 0 < 1073741823 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 2147483647;
  i2 = i2 - i3 | 0;
  if (!i6) i5 = 0; else i5 = __Znwj(i6) | 0;
  i4 = i5 + i2 | 0;
  HEAP8[i4 >> 0] = i9;
  i1 = i4 + (0 - i2) | 0;
  if ((i2 | 0) > 0) _memcpy(i1 | 0, i7 | 0, i2 | 0) | 0;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i13 >> 2] = i4 + 1;
  HEAP32[i8 >> 2] = i5 + i6;
  if (i3 | 0) __ZdlPv(i7);
 } else {
  HEAP8[i6 >> 0] = i9;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
 }
 i6 = i10 + 40 | 0;
 i7 = i10 + 44 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i5 - i3 | 0;
 i1 = HEAP32[i11 + 40 >> 2] | 0;
 i1 = Math_imul(i1, i1) | 0;
 i2 = i1 + i4 | 0;
 if (i4 >>> 0 < i2 >>> 0) __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj(i6, i1); else if (i4 >>> 0 > i2 >>> 0) {
  i1 = i3 + i2 | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i1;
 }
 i13 = (HEAP32[i13 >> 2] | 0) + -1 - (HEAP32[i12 >> 2] | 0) | 0;
 return i13 | 0;
}

function __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i4 + 12 | 0, i5);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 28 | 0, gb + 1085935 | 0, 0);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP32[i4 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i5, i4 + 48 | 0, gb + 899300 | 0, 0);
 i1 = i4 + 60 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 23; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN20SoundChannelInstance15set3DAttributesEPK11FMOD_VECTORS2_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 16 | 0;
 if (i3 | 0) {
  i8 = (HEAP32[i2 + 164 >> 2] | 0) == 0;
  i1 = i2 + 4 | 0;
  i9 = i2 + 148 | 0;
  i10 = HEAP16[i9 >> 1] | 0;
  HEAP16[i9 >> 1] = (((i10 & 65535) >>> 15 & 65535 | i8 & 1) & 65535) << 15 & 65535 | i10 & 32767;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i1 = i2 + 146 | 0;
  HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -2 | i8 & 1;
 }
 i1 = HEAP32[i2 + 164 >> 2] | 0;
 if (i4 | 0) {
  i9 = (i1 | 0) == 0;
  i10 = i2 + 148 | 0;
  i8 = HEAP16[i10 >> 1] | 0;
  HEAP16[i10 >> 1] = (((i8 & 65535) >>> 15 & 65535 | i9 & 1) & 65535) << 15 & 65535 | i8 & 32767;
  i10 = i2 + 16 | 0;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  i10 = i2 + 146 | 0;
  HEAP16[i10 >> 1] = (i9 & 1) << 1 & 65535 | HEAP16[i10 >> 1] & -3;
 }
 if (!i1) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i1 = __ZN4FMOD7Channel15set3DAttributesEPK11FMOD_VECTORS3_(i1, i3, i4) | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 i10 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i6 >> 2] = gb + 853918;
 HEAP32[i6 + 4 >> 2] = 170;
 HEAP32[i6 + 8 >> 2] = gb + 866377;
 HEAP32[i6 + 12 >> 2] = i10;
 __Z6FormatPKcz(i5, gb + 883334 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i10 = i1;
 STACKTOP = i7;
 return i10 | 0;
}

function __Z26InitializeEngineNoGraphicsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __Z16SelectDataFolderv(i2);
 __ZN16PlayerConnection10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i2, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __Z30InstallPlayerConnectionLoggingb(1);
 __Z29InitializeMemoryProfilerStatsv();
 __ZN13UnityProfiler20InitializeMainThreadEv();
 __ZN18ProfilerConnection10InitializeEv();
 __ZN16PlayerConnection4PollEv(__ZN16PlayerConnection3GetEv() | 0);
 __Z18RegisterAllClassesv();
 __ZN11TypeManager18InitializeAllTypesEv(HEAP32[gb + 1110260 >> 2] | 0);
 __ZN21ExecutionOrderManager15InitializeClassEv();
 __ZN23ManagedAttributeManager15InitializeClassEv();
 __Z26InitializeAsyncReadManagerv();
 i2 = __ZN14MessageHandler3GetEv() | 0;
 __ZN14MessageHandler10InitializeEP11TypeManagerPKN5Unity4TypeE(i2, HEAP32[gb + 1110260 >> 2] | 0, gb + 28304 | 0);
 __Z31ManagerContextInitializeClassesv();
 __ZN19RenderBufferManager23InitRenderBufferManagerEv();
 i2 = __ZN13ModuleManager3GetEv() | 0;
 __ZN13ModuleManager4LoadEv(i2);
 i3 = i2 + 768 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __Z17InitScreenManagerv();
  i4 = HEAP32[gb + 1110260 >> 2] | 0;
  __ZN11TypeManager19CallInitializeTypesEv(i4);
  __Z23InitPlayerLoopCallbacksv();
  STACKTOP = i5;
  return 1;
 } else i1 = 0;
 do {
  i4 = i2 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 __Z17InitScreenManagerv();
 i4 = HEAP32[gb + 1110260 >> 2] | 0;
 __ZN11TypeManager19CallInitializeTypesEv(i4);
 __Z23InitPlayerLoopCallbacksv();
 STACKTOP = i5;
 return 1;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl9findClassERKN5physx8debugger14NamespacedNameE(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i2, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = gb + 148960 + 8;
 if (!i1) {
  HEAP32[i4 + 4 >> 2] = gb + 1576256;
  HEAP32[i4 + 8 >> 2] = gb + 1576256;
  i2 = i4 + 12 | 0;
  i1 = i4 + 28 | 0;
  HEAP32[i2 >> 2] = -1;
  HEAP32[i2 + 4 >> 2] = -1;
  HEAP32[i2 + 8 >> 2] = -1;
  HEAP32[i2 + 12 >> 2] = -1;
  i2 = i1;
  i3 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP16[i1 + 40 >> 1] = 0;
  i3 = 0;
  i4 = i4 + 72 | 0;
  HEAP8[i4 >> 0] = i3;
  return;
 } else {
  i2 = i1 + 4 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  i3 = i4 + 28 | 0;
  i6 = i1 + 28 | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i4 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i3 + 4 >> 2] = i2;
  i3 = i4 + 48 | 0;
  i2 = i1 + 48 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i4 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i4 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
  i3 = i4 + 68 | 0;
  i2 = i1 + 68 | 0;
  i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
  HEAP8[i3 >> 0] = i2;
  HEAP8[i3 + 1 >> 0] = i2 >> 8;
  i3 = 1;
  i4 = i4 + 72 | 0;
  HEAP8[i4 >> 0] = i3;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclERKNS_32PxArticulationLinkCollectionPropEj(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i5 >> 2] = gb + 674324;
 HEAP8[i5 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i5;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE23handleArticulationLinksERKNS_32PxArticulationLinkCollectionPropE(i7, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i8;
 return;
}

function __ZN19MemoryProfilerStatsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 124 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN12CachedReader22FetchResourceImageDataE19ActiveResourceImagejj(i7, i2, i8, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 24 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6;
 i1 = HEAP32[i7 + 36 + (i2 << 2) >> 2] | 0;
 if (!i1) {
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i5 | 0, i7 | 0);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i7 = i5 + 11 | 0;
  i8 = HEAP8[i7 >> 0] | 0;
  i8 = i8 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i8 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, gb + 468947 | 0, 20, i8 + 20 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i8) | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i8 = HEAP8[i4 + 11 >> 0] | 0;
  i7 = i8 << 24 >> 24 < 0;
  i8 = i7 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i3, i7 ? HEAP32[i4 >> 2] | 0 : i4, i8, i8 + 21 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i3, gb + 468968 | 0, 21) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 468719 | 0, 86, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 } else {
  i8 = (HEAP32[i1 >> 2] | 0) + i8 | 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 return 0;
}

function _tlsf_memalign(i10, i5, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i1 + 3 & -4;
 i7 = (i1 + -1 | 0) >>> 0 < 1073741823 ? (i7 >>> 0 > 12 ? i7 : 12) : 0;
 i9 = i5 + 15 + i7 | 0;
 i2 = 0 - i5 | 0;
 i8 = i9 + i5 & i2;
 i8 = _block_locate_free(i10, i5 >>> 0 < 5 ? i7 : i9 >>> 0 < 1073741823 ? (i8 >>> 0 > 12 ? i8 : 12) : 0) | 0;
 if (!i8) {
  i9 = 0;
  i10 = _block_prepare_used(i10, i9, i7) | 0;
  return i10 | 0;
 }
 i9 = i8 + 8 | 0;
 i6 = i9;
 i3 = i5 + -1 | 0;
 i4 = i6 + i3 & i2;
 i1 = i4 - i6 | 0;
 if ((i1 + -1 | 0) >>> 0 < 15) {
  i1 = 16 - i1 | 0;
  i1 = (i4 + i3 + (i1 >>> 0 > i5 >>> 0 ? i1 : i5) & i2) - i6 | 0;
 }
 if (!i1) {
  i9 = i8;
  i10 = _block_prepare_used(i10, i9, i7) | 0;
  return i10 | 0;
 }
 i2 = i8 + 4 | 0;
 i3 = HEAP32[i2 >> 2] & -4;
 if (i3 >>> 0 < (i1 + 16 | 0) >>> 0) {
  i9 = i8;
  i10 = _block_prepare_used(i10, i9, i7) | 0;
  return i10 | 0;
 }
 i4 = i6 + -8 + i1 | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 3 | i3 - i1;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 3 | i1 + -4;
 i1 = ((HEAP32[i5 >> 2] | 0) + -4 & -4) + (i4 + 8) | 0;
 HEAP32[i1 >> 2] = i4;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 2;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 3;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[(i2 + -4 & -4) + i6 >> 2] = i8;
 i1 = i2 & -4;
 if (i1 >>> 0 < 128) {
  i1 = i2 >>> 2;
  i2 = 0;
 } else {
  i2 = 31 - (Math_clz32(i1 | 0) | 0) | 0;
  i1 = i1 >>> (i2 + -5 | 0) ^ 32;
  i2 = i2 + -6 | 0;
 }
 i6 = i10 + 116 + (i2 << 7) + (i1 << 2) | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = i10;
 HEAP32[i5 + 12 >> 2] = i8;
 HEAP32[i6 >> 2] = i8;
 i9 = i10 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1 << i2;
 i9 = i10 + 20 + (i2 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1 << i1;
 i9 = i4;
 i10 = _block_prepare_used(i10, i9, i7) | 0;
 return i10 | 0;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 97) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 108) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 115) {
    i2 = i2 + 5 | 0;
    HEAP32[i5 >> 2] = i2;
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = i10 + 28 | 0;
     i9 = i10 + 40 | 0;
     i1 = HEAP32[i9 >> 2] | 0;
     i7 = i10 + 44 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     i3 = i6;
     i8 = i1;
     if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
      i4 = i10 + 36 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      i6 = i5;
      if (!i5) {
       if (!(HEAP32[i2 >> 2] | 0)) {
        i3 = __Znwj(1) | 0;
        HEAP32[i2 >> 2] = i3;
        HEAP32[i10 + 32 >> 2] = i3;
       }
       i1 = HEAP32[i10 + 48 >> 2] | 0;
      } else {
       i1 = i3 - i6 | 0;
       i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
      }
      i6 = i8 - i6 | 0;
      i10 = i6 + 24 | 0;
      i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
      i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
      HEAP32[i4 >> 2] = i8;
      i1 = i8 + i6 | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i7 >> 2] = i8 + i10;
     }
     HEAP32[i9 >> 2] = i1 + 24;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i1 + 12 >> 2] = 0;
     HEAP32[i1 + 16 >> 2] = 257;
     return;
    } else i1 = i2;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZN5physx2Gu25computeMTD_BoxHeightFieldERNS_6PxVec3ERfRKNS0_3BoxERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i6, i4, i1, i2, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 4208 | 0;
 i15 = i7 + 4192 | 0;
 i12 = i7 + 4240 | 0;
 i13 = i7 + 4120 | 0;
 i11 = i7 + 4136 | 0;
 i8 = i7 + 4116 | 0;
 i3 = i7;
 i9 = i7 + 4112 | 0;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i15, i1);
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i12 >> 2] = -1;
 i15 = HEAP32[i1 + 48 >> 2] | 0;
 i14 = HEAP32[i1 + 52 >> 2] | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i13 >> 2] = 3;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i13 + 8 >> 2] = i14;
 HEAP32[i13 + 12 >> 2] = i1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu21contactBoxHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i5, i9, i8, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i6, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i15 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN16RenderTextureMap10InitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63536 | 0, 16, gb + 410024 | 0, 18) | 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP8[i5 + 8 >> 0] = 0;
 i2 = i5 + 9 | 0;
 HEAP8[i2 >> 0] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i3 = i5 + 32 | 0;
 HEAP32[i3 >> 2] = 32;
 HEAP32[i5 + 36 >> 2] = 0;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 52 >> 2] = i7;
 i6 = HEAP32[i3 >> 2] | 0;
 f9 = Math_fround(i6 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i5 + 40 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 HEAP32[gb + 1158228 >> 2] = i5;
 HEAP8[i2 >> 0] = 1;
 i2 = i5 + 20 | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 65;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 28 >> 2] = i1;
 i3 = i1 + (HEAP32[i3 >> 2] << 3) | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i8 = HEAP32[gb + 1158228 >> 2] | 0;
 __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E14squash_deletedEv(i8);
 HEAP8[i8 + 8 >> 0] = 1;
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = -2;
 HEAP32[i8 + 4 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN14AvatarPlayback4InitEi(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 4 | 0;
 i8 = i9 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = i5;
 if ((i3 | 0) == (i5 | 0)) {
  i2 = i3;
  i4 = i1;
  i1 = i3;
 } else {
  i5 = i9 + 36 | 0;
  i4 = 0;
  while (1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + (i4 * 12 | 0) >> 2] | 0, i5);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 * 12 | 0) + 4 >> 2] | 0, i5);
   i4 = i4 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i3 = i1;
   if (i4 >>> 0 >= ((i2 - i1 | 0) / 12 | 0) >>> 0) {
    i4 = i3;
    break;
   } else i1 = i3;
  }
 }
 i3 = i2;
 if ((i3 | 0) != (i4 | 0)) {
  i2 = i3 + (~(((i3 + -12 - i4 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
  HEAP32[i8 >> 2] = i2;
 }
 if ((i6 | 0) <= 0) {
  HEAP32[i9 + 16 >> 2] = 0;
  i8 = i9 + 28 | 0;
  HEAP32[i8 >> 2] = -1;
  i8 = i9 + 20 | 0;
  HEAP32[i8 >> 2] = -1;
  i9 = i9 + 24 | 0;
  HEAP32[i9 >> 2] = -1;
  return;
 }
 if ((i6 | 0) > 1e4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911085 | 0, 0, gb + 901345 | 0, 30, 512, 0, 0, 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i6 >>> 0 > 1e4 ? 1e4 : i6;
 i4 = (i2 - i1 | 0) / 12 | 0;
 i5 = i1;
 i6 = i2;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE8__appendEj(i7, i3 - i4 | 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } else if (i3 >>> 0 < i4 >>> 0) {
  i3 = i5 + (i3 * 12 | 0) | 0;
  if ((i6 | 0) != (i3 | 0)) {
   i2 = i6 + (~(((i6 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
   HEAP32[i8 >> 2] = i2;
  }
 }
 HEAP32[i9 + 16 >> 2] = (i2 - i1 | 0) / 12 | 0;
 i8 = i9 + 28 | 0;
 HEAP32[i8 >> 2] = -1;
 i8 = i9 + 20 | 0;
 HEAP32[i8 >> 2] = -1;
 i9 = i9 + 24 | 0;
 HEAP32[i9 >> 2] = -1;
 return;
}

function __ZN13RuntimeStaticI18UnityConnectClientE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(792, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = gb + 189004 + 8;
  i2 = i4 + 680 | 0;
  HEAP32[i2 >> 2] = gb + 189004 + 68;
  i3 = i4 + 688 | 0;
  __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE(i4, i3);
  HEAP32[i4 >> 2] = gb + 189004 + 8;
  HEAP32[i2 >> 2] = gb + 189004 + 68;
  __ZN11UnityEngine7Connect16PersistentValuesC2Ev(i3);
  i3 = i4 + 772 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 776 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 780 >> 2] = 0;
  HEAP32[i4 + 768 >> 2] = i3;
  HEAP8[i4 + 785 >> 0] = 0;
  HEAP8[i4 + 788 >> 0] = 0;
  HEAP8[i4 + 789 >> 0] = 0;
  HEAP32[i4 + 12 >> 2] = gb + 1042554;
  __ZN18UnityConnectClient23RegisterGlobalCallbacksEv(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(792, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = gb + 189004 + 8;
  i2 = i4 + 680 | 0;
  HEAP32[i2 >> 2] = gb + 189004 + 68;
  i3 = i4 + 688 | 0;
  __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE(i4, i3);
  HEAP32[i4 >> 2] = gb + 189004 + 8;
  HEAP32[i2 >> 2] = gb + 189004 + 68;
  __ZN11UnityEngine7Connect16PersistentValuesC2Ev(i3);
  i3 = i4 + 772 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 776 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 780 >> 2] = 0;
  HEAP32[i4 + 768 >> 2] = i3;
  HEAP8[i4 + 785 >> 0] = 0;
  HEAP8[i4 + 788 >> 0] = 0;
  HEAP8[i4 + 789 >> 0] = 0;
  HEAP32[i4 + 12 >> 2] = gb + 1042554;
  __ZN18UnityConnectClient23RegisterGlobalCallbacksEv(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __Z28ParticleEmitter_CUSTOM_Emit3P12Il2CppObjectR33MonoInternalEmitParticleArguments(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f7 = Math_fround(HEAPF32[i2 + 28 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + 32 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 + 1 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 40 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 + 2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 44 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 + 3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  __ZN15ParticleEmitter4EmitERK8Vector3fS2_ffRK11ColorRGBA32ff(i4, i2, i2 + 12 | 0, f8, f7, i3, f6, Math_fround(HEAPF32[i2 + 52 >> 2]));
  STACKTOP = i5;
  return;
 }
}

function __ZN7SubMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i1 = i8 + 32 | 0;
 i10 = i9 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i5 = i8 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i1 = i8 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  i10 = i8 + 8 | 0;
  __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i10 = i8 + 8 | 0;
  __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i9);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 1 | 0;
 i8 = i11;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = i9 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i2 = i9 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i5 = i9 + 36 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i6 + 1;
 } else {
  i5 = i3 + -1 | 0;
  i6 = HEAP32[(HEAP32[i9 + 40 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
 }
 i3 = i9 + 56 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 do if (i6 >>> 0 < i5 >>> 0) {
  i2 = HEAP32[i9 + 52 >> 2] | 0;
  i7 = 11;
 } else {
  if (i5 >>> 0 >= 65535) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = 0;
   break;
  }
  HEAP32[i3 >> 2] = i5 << 1;
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i5 << 3, gb + 688901 | 0, 167) | 0;
  _memset(i2 | 0, 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  i3 = i9 + 52 | 0;
  if (i5 | 0) {
   i4 = 0;
   do {
    HEAP32[i2 + (i4 << 2) >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2];
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = i2;
  i7 = 11;
 } while (0);
 if ((i7 | 0) == 11) {
  HEAP32[i2 + (i6 << 2) >> 2] = i1;
  HEAP32[i1 + 52 >> 2] = i6;
  i4 = i9 + 8 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i2 = i9 + 4 | 0;
   i3 = 0;
   do {
    __ZN5physx7NpScene11addMaterialERNS_10NpMaterialE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i1) | 0;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_10StartEventEEEbRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i3 = i6 + 4 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i5, i9, (HEAPU8[i8 >> 0] | 0) >>> 2 & 3);
 i2 = i5 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i9, gb + 660679 | 0, i2, HEAPU8[i8 >> 0] & 3);
 i3 = (HEAP8[(HEAP32[i3 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i3) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i8 = i2;
 i13 = HEAP32[i4 >> 2] | 0;
 i12 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
 i9 = i12;
 i11 = (HEAP8[i13 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i11 ? 0 : HEAP32[i9 >> 2] | 0) | 0, (i11 ? 0 : HEAP32[i9 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = HEAP32[i6 + 12 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i5;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP8[i5 + 13 >> 0] | 0;
 i6 = HEAP8[i5 + 12 >> 0] | 0;
 i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP16[i1 >> 1] = HEAP16[i13 + 2 >> 1] | 0;
 HEAP8[i1 + 2 >> 0] = 1;
 mftCall_viiiiiiiii(i5 | 0, i12 | 0, i1 | 0, i11 | 0, i10 | 0, i2 | 0, i4 | 0, i6 | 0, i8 | 0, i9 | 0);
 STACKTOP = i7;
 return i3 | 0;
}

function __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_10StartEventEEEbRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i3 = i6 + 4 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i5, i9, (HEAPU8[i8 >> 0] | 0) >>> 2 & 3);
 i2 = i5 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i9, gb + 660679 | 0, i2, HEAPU8[i8 >> 0] & 3);
 i3 = (HEAP8[(HEAP32[i3 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i3) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i8 = i2;
 i13 = HEAP32[i4 >> 2] | 0;
 i12 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
 i9 = i12;
 i11 = (HEAP8[i13 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i11 ? 0 : HEAP32[i9 >> 2] | 0) | 0, (i11 ? 0 : HEAP32[i9 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = HEAP32[i6 + 12 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i5;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP8[i5 + 13 >> 0] | 0;
 i6 = HEAP8[i5 + 12 >> 0] | 0;
 i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP16[i1 >> 1] = HEAP16[i13 + 2 >> 1] | 0;
 HEAP8[i1 + 2 >> 0] = 1;
 mftCall_viiiiiiiii(i5 | 0, i12 | 0, i1 | 0, i11 | 0, i10 | 0, i2 | 0, i4 | 0, i6 | 0, i8 | 0, i9 | 0);
 STACKTOP = i7;
 return i3 | 0;
}

function __ZN5physx34solveContact_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i4, i3, i7, i8, i1, i6) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = i7 + 16 | 0;
 if (i3 >>> 0 > 1) {
  i1 = 1;
  do {
   i5 = i1 + -1 | 0;
   i10 = i4 + (i5 << 5) | 0;
   i11 = HEAP32[i2 >> 2] | 0;
   i9 = i11 + ((HEAPU16[i4 + (i5 << 5) + 10 >> 1] | 0) << 6) | 0;
   i5 = i11 + ((HEAPU16[i4 + (i5 << 5) + 14 >> 1] | 0) << 6) | 0;
   __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i10, i7);
   __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i10, i7, i9, i5);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = i3 + -1 | 0;
 i11 = i4 + (i5 << 5) | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i1 = i10 + ((HEAPU16[i4 + (i5 << 5) + 10 >> 1] | 0) << 6) | 0;
 i5 = i10 + ((HEAPU16[i4 + (i5 << 5) + 14 >> 1] | 0) << 6) | 0;
 __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i11, i7);
 __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i11, i7, i1, i5);
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i7 + 12 >> 2] | 0) + -4 | 0) >>> 0) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i6, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i11 = i8 + (i4 + i2 << 4) | 0;
   i10 = i1 + (i2 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E9erase_oneIS7_EEjRKT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i1 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 - i3 | 0;
 if (!i2) i2 = i3; else {
  i6 = i7 + 11 | 0;
  i5 = (i2 | 0) / 24 | 0;
  i2 = i3;
  i1 = i3;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i1 + (i9 * 24 | 0) | 0;
   i3 = (__Z7StrICmpPKcS0_((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0) < 0;
   i4 = i4 + 24 | 0;
   i2 = i3 ? i4 : i2;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i1 = i3 ? i4 : i1;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 if ((i2 | 0) == (i1 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if ((__Z7StrICmpPKcS0_((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0) < 0) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = i2 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  do {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i1) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 12 | 0, i1 + 12 | 0) | 0;
   i1 = i1 + 24 | 0;
   i2 = i2 + 24 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i9 = 1;
   return i9 | 0;
  }
 }
 do {
  i9 = i1 + -24 | 0;
  HEAP32[i8 >> 2] = i9;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = 1;
 return i1 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 1048681 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i4, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 4194305);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z21GetLoadedObjectReasonP6Object(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i10 = (HEAP32[i9 + 20 >> 2] | 0) == 0;
 i6 = i9 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = (i1 & 1048576 | 0) != 0;
 L1 : do if (i8) {
  i2 = __Z20GetPersistentManagerv() | 0;
  __ZN17PersistentManager11GetPathNameEi(i5, i2, HEAP32[i9 + 4 >> 2] | 0);
  i2 = i5 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i4 = i5 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (((i3 << 24 >> 24 < 0 ? i1 : i3 & 255) | 0) == 30) {
   if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i5, 0, -1, gb + 466958 | 0, 30) | 0) {
    i3 = HEAP8[i2 >> 0] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i7 = 5;
   }
  } else i7 = 5;
  do if ((i7 | 0) == 5) {
   if (((i3 << 24 >> 24 < 0 ? i1 : i3 & 255) | 0) == 31) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i5, 0, -1, gb + 588322 | 0, 31) | 0)) break;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i1 = HEAP32[i6 >> 2] | 0;
   break L1;
  } while (0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 } while (0);
 if (i1 & 262144 | 0) {
  i10 = 2;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (i8) {
  i10 = i10 ? 8 : 9;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = i1 >>> 21;
 if ((i1 | 0) == (HEAP32[gb + 28900 + 24 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((i1 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
  i1 = (HEAP32[i9 + 28 >> 2] | 0) == 0;
  if (!i1) {
   i10 = i1 & 1;
   STACKTOP = i11;
   return i10 | 0;
  }
 }
 i10 = i10 ? 5 : 6;
 STACKTOP = i11;
 return i10 | 0;
}

function _ft_var_apply_tuple(i8, i2, i9, i10, i11) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0;
 i12 = i8 + 4 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!i3) {
  i12 = 65536;
  return i12 | 0;
 }
 if (!(i2 & 16384)) {
  i6 = 0;
  i2 = 65536;
  while (1) {
   i5 = HEAP32[i9 + (i6 << 2) >> 2] | 0;
   if (i5) {
    i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i6 << 2) >> 2] | 0;
    if (!i3) {
     i2 = 0;
     i3 = 19;
     break;
    }
    if ((i5 | 0) > 0 & (i3 | 0) < 0) {
     i2 = 0;
     i3 = 19;
     break;
    }
    i4 = (i3 | 0) > 0;
    if ((i5 | 0) < 0 & i4) {
     i2 = 0;
     i3 = 19;
     break;
    }
    i2 = _UNITY_FT_MulFix(i2, i4 ? i3 : 0 - i3 | 0) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
   if (i6 >>> 0 >= i3 >>> 0) {
    i3 = 19;
    break;
   }
  }
  if ((i3 | 0) == 19) return i2 | 0;
 } else {
  i7 = 0;
  i1 = 65536;
 }
 L18 : while (1) {
  i2 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  do if (i2) {
   i3 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i7 << 2) >> 2] | 0;
   if (!i3) {
    i2 = 0;
    i3 = 19;
    break L18;
   }
   if ((i2 | 0) > 0 & (i3 | 0) < 0) {
    i2 = 0;
    i3 = 19;
    break L18;
   }
   if ((i2 | 0) < 0 & (i3 | 0) > 0) {
    i2 = 0;
    i3 = 19;
    break L18;
   }
   i4 = HEAP32[i10 + (i7 << 2) >> 2] | 0;
   if ((i3 | 0) < (i4 | 0)) {
    i2 = 0;
    i3 = 19;
    break L18;
   }
   i5 = HEAP32[i11 + (i7 << 2) >> 2] | 0;
   if ((i5 | 0) < (i3 | 0)) {
    i2 = 0;
    i3 = 19;
    break L18;
   }
   if ((i3 | 0) < (i2 | 0)) {
    i1 = _UNITY_FT_MulDiv(i1, i3 - i4 | 0, i2 - i4 | 0) | 0;
    break;
   } else {
    i1 = _UNITY_FT_MulDiv(i1, i5 - i3 | 0, i5 - i2 | 0) | 0;
    break;
   }
  } while (0);
  i7 = i7 + 1 | 0;
  if (i7 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) {
   i2 = i1;
   i3 = 19;
   break;
  }
 }
 if ((i3 | 0) == 19) return i2 | 0;
 return 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl8getClassEN5physx8debugger18NonNegativeIntegerE(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) if ((HEAP32[i2 + 128 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i4 >> 2] = gb + 148960 + 8;
   i2 = i1 + 4 | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   i3 = i4 + 28 | 0;
   i6 = i1 + 28 | 0;
   HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i4 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
   i3 = i4 + 4 | 0;
   HEAP32[i3 >> 2] = i5;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = i4 + 48 | 0;
   i2 = i1 + 48 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i4 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
   HEAP32[i4 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
   i3 = i4 + 68 | 0;
   i2 = i1 + 68 | 0;
   i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
   HEAP8[i3 >> 0] = i2;
   HEAP8[i3 + 1 >> 0] = i2 >> 8;
   HEAP8[i4 + 72 >> 0] = 1;
   return;
  }
 }
 HEAP32[i4 >> 2] = gb + 148960 + 8;
 HEAP32[i4 + 4 >> 2] = gb + 1576256;
 HEAP32[i4 + 8 >> 2] = gb + 1576256;
 i2 = i4 + 12 | 0;
 i1 = i4 + 28 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 i2 = i1;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP16[i1 + 40 >> 1] = 0;
 HEAP8[i4 + 72 >> 0] = 0;
 return;
}

function __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_9StopEventEEEbRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i3 = i6 + 4 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i5, i9, (HEAPU8[i8 >> 0] | 0) >>> 2 & 3);
 i2 = i5 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i9, gb + 660679 | 0, i2, HEAPU8[i8 >> 0] & 3);
 i3 = (HEAP8[(HEAP32[i3 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i3) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i8 = i2;
 i13 = HEAP32[i4 >> 2] | 0;
 i12 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
 i9 = i12;
 i11 = (HEAP8[i13 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i11 ? 0 : HEAP32[i9 >> 2] | 0) | 0, (i11 ? 0 : HEAP32[i9 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = HEAP32[i6 + 12 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i5;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP8[i5 + 13 >> 0] | 0;
 i6 = HEAP8[i5 + 12 >> 0] | 0;
 i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0;
 HEAP16[i1 >> 1] = HEAP16[i13 + 2 >> 1] | 0;
 HEAP8[i1 + 2 >> 0] = 1;
 mftCall_viiiiiiiii(i5 | 0, i12 | 0, i1 | 0, i11 | 0, i10 | 0, i2 | 0, i4 | 0, i6 | 0, i8 | 0, i9 | 0);
 STACKTOP = i7;
 return i3 | 0;
}

function __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_9StopEventEEEbRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i3 = i6 + 4 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i8 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i5, i9, (HEAPU8[i8 >> 0] | 0) >>> 2 & 3);
 i2 = i5 + 16 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i9, gb + 660679 | 0, i2, HEAPU8[i8 >> 0] & 3);
 i3 = (HEAP8[(HEAP32[i3 >> 2] | 0) + 8 >> 0] | 0) == 0;
 if (!i3) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i8 = i2;
 i13 = HEAP32[i4 >> 2] | 0;
 i12 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
 i9 = i12;
 i11 = (HEAP8[i13 + 1 >> 0] & 3) == 3;
 i8 = _i64Add((i11 ? 0 : HEAP32[i9 >> 2] | 0) | 0, (i11 ? 0 : HEAP32[i9 + 4 >> 2] | 0) | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i12 + 4 >> 2] = i9;
 i12 = HEAP32[i6 + 12 >> 2] | 0;
 i11 = HEAP32[i5 + 8 >> 2] | 0;
 i2 = i5;
 i10 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP8[i5 + 13 >> 0] | 0;
 i6 = HEAP8[i5 + 12 >> 0] | 0;
 i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0;
 HEAP16[i1 >> 1] = HEAP16[i13 + 2 >> 1] | 0;
 HEAP8[i1 + 2 >> 0] = 1;
 mftCall_viiiiiiiii(i5 | 0, i12 | 0, i1 | 0, i11 | 0, i10 | 0, i2 | 0, i4 | 0, i6 | 0, i8 | 0, i9 | 0);
 STACKTOP = i7;
 return i3 | 0;
}

function __ZN14GraphicsHelper28PrepareShaderParameterBufferER13dynamic_arrayIhLj4EERA6_P10GpuProgramRA6_PK20GpuProgramParametersRA6_PKhRK11SubProgramsPK19ShaderPropertySheetSL_(i2, i3, i7, i8, i9, i10, i11) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 i13 = i2 + 12 | 0;
 i1 = 0;
 do {
  i4 = i3 + (i1 << 2) | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i7 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i8 + (i1 << 2) >> 2] = 0;
  i6 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  if (i6 | 0) {
   i15 = HEAP32[i6 >> 2] | 0;
   HEAP32[i12 + (i1 << 2) >> 2] = HEAP32[i13 >> 2];
   __ZNK20GpuProgramParameters13PrepareValuesEPK19ShaderPropertySheetS2_R13dynamic_arrayIhLj4EEjP12GfxPatchInfoPb(i15, i10, i11, i2, 0, 0, 0);
   HEAP32[i4 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 >> 2] = i15;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 6);
 if (HEAP32[i3 >> 2] | 0) HEAP32[i8 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 >> 2] | 0);
 if (HEAP32[i3 + 4 >> 2] | 0) HEAP32[i8 + 4 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 + 4 >> 2] | 0);
 if (HEAP32[i3 + 8 >> 2] | 0) HEAP32[i8 + 8 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 + 8 >> 2] | 0);
 if (HEAP32[i3 + 12 >> 2] | 0) HEAP32[i8 + 12 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 + 12 >> 2] | 0);
 if (HEAP32[i3 + 16 >> 2] | 0) HEAP32[i8 + 16 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 + 16 >> 2] | 0);
 if (!(HEAP32[i3 + 20 >> 2] | 0)) {
  STACKTOP = i14;
  return;
 }
 HEAP32[i8 + 20 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i12 + 20 >> 2] | 0);
 STACKTOP = i14;
 return;
}

function __ZN12AudioManager16GetConfigurationEv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i4 = i9;
 i7 = i9 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i2 = i6 + 88 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 + 160 >> 2];
 i1 = __ZN4FMOD6System16getDSPBufferSizeEPjPi(i1, i5 + 4 | 0, 0) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i4 >> 2] = gb + 856220;
  HEAP32[i4 + 4 >> 2] = 1859;
  HEAP32[i4 + 8 >> 2] = gb + 873481;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i7, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i1 = __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i2 >> 2] | 0, i3, 0, 0, 0, 0, 0) | 0;
 if (i1 | 0) {
  i4 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i8 >> 2] = gb + 856220;
  HEAP32[i8 + 4 >> 2] = 1860;
  HEAP32[i8 + 8 >> 2] = gb + 873556;
  HEAP32[i8 + 12 >> 2] = i4;
  __Z6FormatPKcz(i7, gb + 883334 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 HEAP32[i5 >> 2] = HEAP32[i6 + 156 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 172 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 168 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i1 + 4 | 0;
 i6 = i1 + 8 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i1 + 144 | 0;
  i8 = i1 + 424 | 0;
  i9 = i1 + 436 | 0;
  i10 = i1 + 428 | 0;
  i2 = i1 + 420 | 0;
  i3 = 0;
  do {
   i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   i14 = i1 + 16 | 0;
   i13 = HEAP16[i14 >> 1] | 0;
   HEAP16[i14 >> 1] = i13 + -1 << 16 >> 16;
   if ((i13 & 65535) > 1) {
    i14 = i1 + 12 | 0;
    HEAP16[i14 >> 1] = (HEAPU16[i14 >> 1] | 0) & 65534;
   } else if (i1 | 0) {
    if (HEAP32[i1 + 20 >> 2] | 0) __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv(i1);
    i14 = (HEAP32[i1 >> 2] | 0) + 46 | 0;
    HEAP16[i14 >> 1] = (HEAP16[i14 >> 1] | 0) + -1 << 16 >> 16;
    i14 = (HEAP32[i1 + 4 >> 2] | 0) + 46 | 0;
    HEAP16[i14 >> 1] = (HEAP16[i14 >> 1] | 0) + -1 << 16 >> 16;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i1;
    i14 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i14 + 1;
    if ((i14 | 0) >= ((HEAP32[i2 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i7);
     HEAP32[i10 >> 2] = 0;
    }
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 if (i11) {
  HEAP32[i4 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i5, 0, i4);
  __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5, HEAP32[i6 >> 2] | 0);
  STACKTOP = i12;
  return;
 } else {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
}

function __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI16SplashScreenLogoEEvRT_17TransferMetaFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i4 + 16 | 0, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 450610 | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 450627 | 0, gb + 450632 | 0, i2, 0);
 i6 = i5 + 8 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i2, 1);
 i5 = i1 + 16 | 0;
 i3 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1040045 | 0, HEAP32[gb + 37012 >> 2] | 0, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN14CompressedMeshC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 i9 = i1 + 44 | 0;
 i8 = i1 + 72 | 0;
 i7 = i1 + 92 | 0;
 i6 = i1 + 120 | 0;
 i5 = i1 + 140 | 0;
 i4 = i1 + 168 | 0;
 i3 = i1 + 188 | 0;
 i2 = i1 + 208 | 0;
 i1 = i1 + 228 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP8[i10 + 24 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP8[i9 + 24 >> 0] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP8[i8 + 16 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP8[i7 + 24 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP8[i6 + 16 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP8[i5 + 24 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP8[i4 + 16 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN10AudioMixer20FindSnapshotFromNameEPKc(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12;
 i10 = i1 + 60 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i1 + 48 | 0;
 i1 = 0;
 while (1) {
  i5 = (HEAP32[i6 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i11 = 8; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
    i3 = HEAP32[i8 >> 2] | 0;
    i13 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 8; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) i11 = 10;
   }
  }
  if ((i11 | 0) == 8) i11 = 10;
  if ((i11 | 0) == 10) {
   i11 = 0;
   i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  }
  if (!(_strcmp(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0, i7) | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
   i1 = 0;
   i11 = 14;
   break;
  }
 }
 if ((i11 | 0) == 14) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim9animation18MotionNeighborListEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 28 | 0;
 i7 = i5 + 16 | 0;
 i9 = i5;
 i8 = i4 + 4 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i10;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, i2, i3, i9, 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 904006 | 0, i7, 0);
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = i7 + 4;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i2;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 904025 | 0, i3, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 44 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i5 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx13NpRigidStatic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i11, i10, i4) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 56 | 0;
 i8 = i12 + 24 | 0;
 i9 = i12;
 __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE(i11 + 20 | 0, i10, i4, i11);
 i3 = HEAP32[i11 + 52 >> 2] | 0;
 if (!(HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i11 + 48) + 8 | 0 : HEAP32[i11 + 56 >> 2] | 0) >> 1] & 1)) {
  STACKTOP = i12;
  return;
 }
 i3 = i4 + 3388 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(i2 & 64)) i6 = 5; else if (!(HEAP8[i4 + 3028 >> 0] | 0)) i6 = 5; else f5 = Math_fround(HEAPF32[i4 + 2880 >> 2]);
 if ((i6 | 0) == 5) {
  f5 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i4 + 32 | 0, 0));
  i2 = HEAP32[i3 >> 2] | 0;
 }
 if (!(i2 & 64)) i6 = 9; else if (!(HEAP8[i4 + 3039 >> 0] | 0)) i6 = 9; else f1 = Math_fround(HEAPF32[i4 + 2924 >> 2]);
 if ((i6 | 0) == 9) f1 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i4 + 32 | 0, 11));
 f1 = Math_fround(f5 * f1);
 if (!(f1 != Math_fround(0.0))) {
  STACKTOP = i12;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i8 | 0, i11 | 0);
 __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i7, i8);
 i11 = __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i10, i7) | 0;
 HEAPF32[i9 >> 2] = f1;
 HEAPF32[i9 + 4 >> 2] = f1;
 HEAPF32[i9 + 8 >> 2] = f1;
 HEAP32[i9 + 12 >> 2] = -65536;
 HEAP32[i9 + 16 >> 2] = -16711936;
 HEAP32[i9 + 20 >> 2] = -16776961;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i11, i9) | 0;
 STACKTOP = i12;
 return;
}

function __ZN5audio5mixer13GroupConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863520 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863540 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863552 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863563 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863568 | 0, i5, i1 + 13 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863573 | 0, i5, i1 + 14 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN15TerrainCollider22FetchPoseFromTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 28 | 0;
 i13 = i14;
 __ZNK9Transform11GetPositionEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0) | 0;
 i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i11 = i10 + 4 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 8 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = i8;
 HEAP32[i13 + 24 >> 2] = i3;
 mftCall_viii(i9 | 0, i2 | 0, i13 | 0, 1);
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 i9 = HEAP32[i1 + 92 >> 2] | 0;
 i3 = i2 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i14;
  return;
 }
 i4 = i13 + 4 | 0;
 i5 = i13 + 8 | 0;
 i6 = i13 + 12 | 0;
 i7 = i13 + 16 | 0;
 i8 = i13 + 20 | 0;
 i9 = i13 + 24 | 0;
 i1 = i2;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i15 = HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0;
   i18 = HEAP32[i10 >> 2] | 0;
   i17 = HEAP32[i11 >> 2] | 0;
   i16 = HEAP32[i12 >> 2] | 0;
   HEAPF32[i13 >> 2] = Math_fround(0.0);
   HEAPF32[i4 >> 2] = Math_fround(0.0);
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   HEAPF32[i6 >> 2] = Math_fround(1.0);
   HEAP32[i7 >> 2] = i18;
   HEAP32[i8 >> 2] = i17;
   HEAP32[i9 >> 2] = i16;
   mftCall_viii(i15 | 0, i2 | 0, i13 | 0, 1);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i14;
 return;
}

function __ZN12HingeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 112 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 113 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 104 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZNK9Texture2D17CheckHasPixelDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i6 = i8 + 16 | 0;
 i5 = i8;
 i2 = i8 + 28 | 0;
 i3 = i1 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) if (!(HEAP8[i1 + 111 >> 0] | 0)) {
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 570291 | 0, i6);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i2, 256, HEAP32[i1 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 416692 | 0, i7);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i2, 256, HEAP32[i1 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  if (HEAP32[i4 + 28 >> 2] | 0) if (HEAP32[i4 + 32 >> 2] | 0) {
   i7 = 1;
   STACKTOP = i8;
   return i7 | 0;
  }
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i7 + 28 >> 2] | 0;
  i7 = HEAP32[i7 + 32 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i5 + 8 >> 2] = i7;
  __Z6FormatPKcz(i2, gb + 416646 | 0, i5);
  __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi(i2, 256, HEAP32[i1 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 24 | 0;
 i11 = i4 + 12 | 0;
 i6 = i4;
 HEAPF32[i7 >> 2] = Math_fround(9.99999974e-06);
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 f9 = Math_fround(f9 * Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i11 >> 2] = f9;
 HEAPF32[i11 + 4 >> 2] = f5;
 HEAPF32[i11 + 8 >> 2] = f8;
 f8 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 i3 = HEAP32[i2 + 68 >> 2] | 0;
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]));
 i12 = f8 < Math_fround(0.0);
 f5 = Math_fround(-f8);
 f8 = i12 ? f5 : f8;
 i12 = f8 < Math_fround(9.99999974e-06);
 f8 = i12 ? Math_fround(9.99999974e-06) : f8;
 f5 = Math_fround(HEAPF32[i11 + (((i3 + 1 | 0) % 3 | 0) << 2) >> 2]);
 f9 = Math_fround(HEAPF32[i11 + (((i3 + 2 | 0) % 3 | 0) << 2) >> 2]);
 i3 = f5 < Math_fround(0.0);
 f10 = Math_fround(-f5);
 f5 = i3 ? f10 : f5;
 i3 = f9 < Math_fround(0.0);
 f10 = Math_fround(-f9);
 f9 = i3 ? f10 : f9;
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 60 >> 2]) * (f5 < f9 ? f9 : f5));
 f8 = Math_fround(f8 - Math_fround(f5 * Math_fround(2.0)));
 HEAPF32[i6 >> 2] = f8;
 i3 = f8 < Math_fround(9.99999974e-06);
 i3 = HEAP32[(i3 ? i7 : i6) >> 2] | 0;
 i2 = f5 < Math_fround(9.99999974e-06);
 HEAPF32[i1 >> 2] = i2 ? Math_fround(9.99999974e-06) : f5;
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE(i13, i12, i2, i1, i3, i15, i14, i11, i10) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, i23 = 0;
 if (i3) {
  HEAP32[i13 >> 2] = i15;
  HEAP32[i12 >> 2] = i14;
  return;
 }
 HEAP32[i12 >> 2] = i1;
 HEAP32[i13 >> 2] = i2;
 if (!i11) return;
 i1 = i10 + 4 | 0;
 i2 = i10 + 8 | 0;
 i3 = i10 + 12 | 0;
 i4 = i10 + 16 | 0;
 i5 = i10 + 20 | 0;
 i6 = i10 + 24 | 0;
 i7 = i10 + 28 | 0;
 i8 = i10 + 32 | 0;
 i9 = 0;
 do {
  HEAP8[(HEAP32[i12 >> 2] | 0) + i9 >> 0] = i9;
  i16 = HEAP32[i13 >> 2] | 0;
  i23 = HEAPU8[i14 + i9 >> 0] | 0;
  f17 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) >> 2]);
  f18 = Math_fround(f17 * Math_fround(HEAPF32[i10 >> 2]));
  f19 = Math_fround(f17 * Math_fround(HEAPF32[i1 >> 2]));
  f17 = Math_fround(f17 * Math_fround(HEAPF32[i2 >> 2]));
  f21 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 4 >> 2]);
  f20 = Math_fround(f21 * Math_fround(HEAPF32[i3 >> 2]));
  f22 = Math_fround(f21 * Math_fround(HEAPF32[i4 >> 2]));
  f20 = Math_fround(f18 + f20);
  f22 = Math_fround(f19 + f22);
  f21 = Math_fround(f17 + Math_fround(f21 * Math_fround(HEAPF32[i5 >> 2])));
  f17 = Math_fround(HEAPF32[i15 + (i23 * 12 | 0) + 8 >> 2]);
  f19 = Math_fround(f17 * Math_fround(HEAPF32[i6 >> 2]));
  f18 = Math_fround(f17 * Math_fround(HEAPF32[i7 >> 2]));
  f18 = Math_fround(f22 + f18);
  f17 = Math_fround(f21 + Math_fround(f17 * Math_fround(HEAPF32[i8 >> 2])));
  HEAPF32[i16 + (i9 * 12 | 0) >> 2] = Math_fround(f20 + f19);
  HEAPF32[i16 + (i9 * 12 | 0) + 4 >> 2] = f18;
  HEAPF32[i16 + (i9 * 12 | 0) + 8 >> 2] = f17;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i11 | 0));
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclERKNS_27PxRigidActorShapeCollectionEj(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i5 >> 2] = gb + 673520;
 HEAP8[i5 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i5;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_14PxRigidDynamicEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i7, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i8;
 return;
}

function __ZN17TriggerStayStates20executeDeferredEraseEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = i10 + 12 | 0;
 i12 = i10 + 24 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  HEAP32[i12 >> 2] = 0;
  return;
 }
 i2 = HEAP32[i11 >> 2] | 0;
 i13 = i10 + 4 | 0;
 i14 = i10 + 8 | 0;
 i9 = i2;
 do {
  i8 = HEAP32[i13 >> 2] | 0;
  do if (i8) {
   i6 = HEAP32[i9 >> 2] | 0;
   i7 = HEAP32[i9 + 4 >> 2] | 0;
   i5 = i13;
   i4 = i8;
   L8 : while (1) {
    i3 = i4;
    while (1) {
     i4 = HEAP32[i3 + 16 >> 2] | 0;
     if ((i4 | 0) == (i6 | 0)) {
      if ((HEAP32[i3 + 20 >> 2] | 0) >>> 0 >= i7 >>> 0) break;
     } else if (i4 >>> 0 >= i6 >>> 0) break;
     i3 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i3) {
      i3 = i5;
      break L8;
     }
    }
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i4) break; else i5 = i3;
   }
   if ((i3 | 0) != (i13 | 0)) {
    i4 = HEAP32[i3 + 16 >> 2] | 0;
    if ((i6 | 0) == (i4 | 0)) {
     if ((i3 | 0) == (i13 | 0) ? 1 : i7 >>> 0 < (HEAP32[i3 + 20 >> 2] | 0) >>> 0) break;
    } else if (i6 >>> 0 < i4 >>> 0 | (i3 | 0) == (i13 | 0)) break;
    if (HEAP8[i3 + 24 >> 0] | 0) {
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      }
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
     HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
     __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i3);
     __ZdlPv(i3);
     i2 = HEAP32[i11 >> 2] | 0;
     i1 = HEAP32[i12 >> 2] | 0;
    }
   }
  } while (0);
  i9 = i9 + 8 | 0;
 } while ((i9 | 0) != (i2 + (i1 << 3) | 0));
 HEAP32[i12 >> 2] = 0;
 return;
}

function __ZN12CullingGroup22SetBoundingSphereCountEj(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i6 + 20 >> 2] | 0) >>> 0 < i7 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 385284 | 0, 0, gb + 385204 | 0, 150, 512, 0, 0, 0);
  return;
 }
 i4 = i6 + 28 | 0;
 i1 = i6 + 40 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7;
 i2 = i6 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i7 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i7, 1, i6 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 1, i6 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  HEAP32[i4 >> 2] = i3;
  break;
 } while (0);
 if (i5 >>> 0 < i7 >>> 0) {
  i1 = i7 - i5 | 0;
  if (i1 | 0) _memset((HEAP32[i4 >> 2] | 0) + i5 | 0, 0, i1 | 0) | 0;
 }
 i4 = i6 + 48 | 0;
 i1 = i6 + 60 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7;
 i2 = i6 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i7 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i7, 1, i6 + 52 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7, 1, i6 + 52 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  HEAP32[i4 >> 2] = i3;
  break;
 } while (0);
 if (i5 >>> 0 < i7 >>> 0) {
  i1 = i7 - i5 | 0;
  if (i1 | 0) _memset((HEAP32[i4 >> 2] | 0) + i5 | 0, 0, i1 | 0) | 0;
 }
 HEAP32[i6 + 24 >> 2] = i7;
 return;
}

function __ZN11TerrainDataD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i6 >> 2] = gb + 184376 + 8;
 i2 = HEAP32[i6 + 352 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i6 + 356 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  i5 = HEAP32[i6 + 364 >> 2] | 0;
  HEAP32[i1 >> 2] = 62;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 }
 __ZN9HeightmapD2Ev(i6 + 248 | 0);
 __ZN14DetailDatabaseD2Ev(i6 + 128 | 0);
 __ZNSt3__213__vector_baseIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEED2Ev(i6 + 112 | 0);
 i1 = HEAP32[i6 + 100 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 104 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 + 88 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 92 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 48 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = gb + 32336 + 8;
  i5 = i6 + 28 | 0;
  __ZN14ConstantStringD2Ev(i5);
  HEAP32[i6 >> 2] = gb + 26392 + 8;
  STACKTOP = i7;
  return;
 }
 i2 = i6 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -44 - i1 | 0) >>> 0) / 44 | 0) * 44 | 0);
 __ZdlPv(i1);
 HEAP32[i6 >> 2] = gb + 32336 + 8;
 i5 = i6 + 28 | 0;
 __ZN14ConstantStringD2Ev(i5);
 HEAP32[i6 >> 2] = gb + 26392 + 8;
 STACKTOP = i7;
 return;
}

function __Z37Cloth_Set_Custom_PropCapsuleCollidersP12Il2CppObjectP11Il2CppArray(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i6) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 84e4 | 0, i8);
 if (!i7) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) {
  i5 = i7;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i4 = i1 + 148 | 0;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = i5;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i4 >> 2] = i2;
  break;
 } while (0);
 if (i5 | 0) {
  i2 = 0;
  do {
   i1 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i6, i2) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i3 + (i2 << 2) >> 2] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7); else {
  __ZN5Unity5Cloth14SetupCollidersEv(i1);
  STACKTOP = i8;
  return;
 }
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 97) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 108) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 115) {
    i2 = i2 + 5 | 0;
    HEAP32[i5 >> 2] = i2;
    if ((HEAP8[i1 >> 0] | 0) == 101) {
     i2 = i10 + 28 | 0;
     i9 = i10 + 40 | 0;
     i1 = HEAP32[i9 >> 2] | 0;
     i7 = i10 + 44 | 0;
     i6 = HEAP32[i7 >> 2] | 0;
     i3 = i6;
     i8 = i1;
     if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
      i4 = i10 + 36 | 0;
      i5 = HEAP32[i4 >> 2] | 0;
      i6 = i5;
      if (!i5) {
       if (!(HEAP32[i2 >> 2] | 0)) {
        i3 = __Znwj(1) | 0;
        HEAP32[i2 >> 2] = i3;
        HEAP32[i10 + 32 >> 2] = i3;
       }
       i1 = HEAP32[i10 + 48 >> 2] | 0;
      } else {
       i1 = i3 - i6 | 0;
       i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
      }
      i6 = i8 - i6 | 0;
      i10 = i6 + 24 | 0;
      i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
      i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
      HEAP32[i4 >> 2] = i8;
      i1 = i8 + i6 | 0;
      HEAP32[i9 >> 2] = i1;
      HEAP32[i7 >> 2] = i8 + i10;
     }
     HEAP32[i9 >> 2] = i1 + 24;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     HEAP32[i1 + 8 >> 2] = 0;
     HEAP32[i1 + 12 >> 2] = 0;
     HEAP32[i1 + 16 >> 2] = 257;
     return;
    } else i1 = i2;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 4 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZN25SingleBlockMemoryFileData5WriteEyyPKv(i8, i9, i4, i1, i2, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i8 + 16 | 0;
 i12 = i8 + 32 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i13 = (i7 | 0) > -1;
 if (i13) i6 = i2; else {
  i6 = _i64Add(i1 | 0, i2 | 0, i9 | 0, i4 | 0) | 0;
  i5 = getTempRet0() | 0;
  i3 = i7 & 2147483647;
  if (i5 >>> 0 > 0 | (i5 | 0) == 0 & i6 >>> 0 > i3 >>> 0) {
   i1 = _i64Subtract(i3 | 0, 0, i9 | 0, i4 | 0) | 0;
   i2 = getTempRet0() | 0;
   if (0 > i4 >>> 0 | 0 == (i4 | 0) & i3 >>> 0 > i9 >>> 0) i6 = i2; else {
    i12 = 0;
    i13 = 0;
    setTempRet0(i12 | 0);
    return i13 | 0;
   }
  } else i6 = i2;
 }
 if ((i1 | 0) == 0 & (i6 | 0) == 0) {
  i12 = 0;
  i13 = 0;
  setTempRet0(i12 | 0);
  return i13 | 0;
 }
 i3 = _i64Add(i1 | 0, i6 | 0, i9 | 0, i4 | 0) | 0;
 getTempRet0() | 0;
 i4 = i8 + 28 | 0;
 do if ((HEAP32[i4 >> 2] | 0) >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i3;
  i5 = i7 & 2147483647;
  if (i5 >>> 0 < i3 >>> 0) {
   i2 = i7 << 1;
   i2 = i2 >>> 0 > i3 >>> 0 ? i2 : i3;
   if (i5 >>> 0 < i2 >>> 0) if (i13) {
    HEAP32[i12 >> 2] = i2;
    HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2, 1, i8 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i8 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i13 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i12 >> 2] = i2;
    HEAP32[i11 >> 2] = i13;
    break;
   }
  }
 } while (0);
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < i3 >>> 0) {
  i12 = 0;
  i13 = 0;
  setTempRet0(i12 | 0);
  return i13 | 0;
 }
 _memcpy((HEAP32[i11 >> 2] | 0) + i9 | 0, i10 | 0, i1 | 0) | 0;
 i12 = i6;
 i13 = i1;
 setTempRet0(i12 | 0);
 return i13 | 0;
}

function __ZN24dtObstacleAvoidanceQuery18addBoundarySegmentEPKfS1_(i5, i6, i13) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i13 = i13 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, i18 = 0;
 i14 = i5 + 10456 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 if ((i15 | 0) > 103) return;
 f12 = Math_fround(HEAPF32[i5 + 10420 >> 2]);
 f16 = Math_fround(HEAPF32[i5 + 10428 >> 2]);
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f11 = Math_fround(f9 - f7);
 f1 = Math_fround(f10 - f8);
 f12 = Math_fround(f12 - f7);
 f3 = Math_fround(f16 - f8);
 f4 = Math_fround(Math_fround(f11 * f11) + Math_fround(f1 * f1));
 if (f4 == Math_fround(0.0)) f1 = Math_fround(Math_fround(f12 * f12) + Math_fround(f3 * f3)); else {
  f17 = Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f3 * f1)) / f4);
  i2 = f17 > Math_fround(1.0);
  i18 = f17 < Math_fround(0.0);
  f17 = i18 ? Math_fround(0.0) : f17;
  f17 = i2 ? Math_fround(1.0) : f17;
  f4 = Math_fround(Math_fround(f11 * f17) - f12);
  f1 = Math_fround(Math_fround(f1 * f17) - f3);
  f1 = Math_fround(Math_fround(f4 * f4) + Math_fround(f1 * f1));
 }
 i2 = f1 < Math_fround(.00250000018);
 if (!i2) {
  f17 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  if (Math_fround(Math_fround(f12 * Math_fround(Math_fround(HEAPF32[i13 + 4 >> 2]) - f17)) - Math_fround(Math_fround(f16 - f17) * f11)) < Math_fround(0.0)) return;
 }
 HEAP32[i14 >> 2] = i15 + 1;
 HEAPF32[i5 + 2496 + (i15 * 24 | 0) >> 2] = f7;
 HEAPF32[i5 + 2496 + (i15 * 24 | 0) + 4 >> 2] = f8;
 HEAPF32[i5 + 2496 + (i15 * 24 | 0) + 8 >> 2] = f9;
 HEAPF32[i5 + 2496 + (i15 * 24 | 0) + 12 >> 2] = f10;
 HEAPF32[i5 + 2496 + (i15 * 24 | 0) + 16 >> 2] = Math_fround(.5);
 HEAP8[i5 + 2496 + (i15 * 24 | 0) + 20 >> 0] = i2 & 1;
 return;
}

function __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i2 = i10;
 i6 = i10 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i5, i1, i2);
  i2 = HEAP32[i5 >> 2] | 0;
  i11 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 7; else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) i9 = 7;
 }
 if ((i9 | 0) == 7) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 17) | 0;
  HEAP32[i1 >> 2] = 0;
  i11 = i1 + 8 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 2;
  HEAP32[i1 + 20 >> 2] = 3;
  HEAP32[i1 + 24 >> 2] = 1;
  HEAP32[i1 + 28 >> 2] = 1;
  HEAP32[i1 + 32 >> 2] = 1;
  HEAP32[i1 + 36 >> 2] = 1;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i5, i1);
 }
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i10;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = __ZN7ApiGLES10GenTextureE16TextureDimension(i7, i8) | 0;
 HEAP32[i1 + 16 >> 2] = i8;
 STACKTOP = i10;
 return i1 | 0;
}

function _jinit_d_coef_controller(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = i5 + 4 | 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i5 | 0, 1, 116) | 0;
 HEAP32[i5 + 392 >> 2] = i7;
 HEAP32[i7 >> 2] = fb + 3279;
 HEAP32[i7 + 8 >> 2] = fb + 3280;
 if (!(i1 << 24 >> 24)) {
  i4 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, 1, 1280) | 0;
  HEAP32[i7 + 32 >> 2] = i4;
  HEAP32[i7 + 36 >> 2] = i4 + 128;
  HEAP32[i7 + 40 >> 2] = i4 + 256;
  HEAP32[i7 + 44 >> 2] = i4 + 384;
  HEAP32[i7 + 48 >> 2] = i4 + 512;
  HEAP32[i7 + 52 >> 2] = i4 + 640;
  HEAP32[i7 + 56 >> 2] = i4 + 768;
  HEAP32[i7 + 60 >> 2] = i4 + 896;
  HEAP32[i7 + 64 >> 2] = i4 + 1024;
  HEAP32[i7 + 68 >> 2] = i4 + 1152;
  HEAP32[i7 + 4 >> 2] = fb + 1560;
  HEAP32[i7 + 12 >> 2] = fb + 507;
  HEAP32[i7 + 16 >> 2] = 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = mftCall_iiii(i6 | 0, i5 | 0, 1, 128) | 0;
  i7 = i7 + 72 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i4 = i5 + 36 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i1 = i7 + 76 | 0;
  i2 = 0;
  i3 = HEAP32[i5 + 196 >> 2] | 0;
  while (1) {
   i9 = i3 + 12 | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i11 = HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0;
   i10 = _jround_up(HEAP32[i3 + 28 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
   HEAP32[i1 + (i2 << 2) >> 2] = mftCall_iiiiiii(i11 | 0, i5 | 0, 1, 1, i10 | 0, _jround_up(HEAP32[i3 + 32 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0, i8 | 0) | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (HEAP32[i4 >> 2] | 0)) break; else i3 = i3 + 84 | 0;
  }
 } else i1 = i7 + 76 | 0;
 HEAP32[i7 + 4 >> 2] = fb + 1559;
 HEAP32[i7 + 12 >> 2] = fb + 506;
 HEAP32[i7 + 16 >> 2] = i1;
 i10 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = mftCall_iiii(i10 | 0, i5 | 0, 1, 128) | 0;
 i11 = i7 + 72 | 0;
 HEAP32[i11 >> 2] = i10;
 return;
}

function __ZN7ApiGLES11CheckShaderERjb(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i7 + 28 | 0;
 i4 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i8 + 492 | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0, 35713, i3 | 0);
 if ((HEAP32[i3 >> 2] | 0) == 1) {
  i9 = 1;
  STACKTOP = i7;
  return i9 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0, 35716, i4 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __Z6FormatPKcz(i5, gb + 599687 | 0, i7 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 599732 | 0, 686, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 } else {
  HEAP32[i5 >> 2] = 0;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
  i2 = __Znwj(i1) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 8 >> 2] = i2 + i1;
  do {
   HEAP8[i2 >> 0] = 0;
   i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
   HEAP32[i3 >> 2] = i2;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
  mftCall_viiii(HEAP32[i8 + 496 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0, HEAP32[i5 >> 2] | 0);
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  _printf_console(gb + 1076431 | 0, i6);
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i1;
   __ZdlPv(i1);
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 switch (i1 | 0) {
 case -1:
 case 0:
  break;
 default:
  {
   mftCall_vi(HEAP32[i8 + 488 >> 2] | 0, i1 | 0);
   HEAP32[i9 >> 2] = -1;
  }
 }
 i9 = 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN5physx3Ext20ProfileZoneInterfaceC2ERNS_13PxProfileZoneEPNS0_23DefaultBufferedProfilerE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 24 | 0;
 i5 = i11 + 16 | 0;
 i7 = i11 + 8 | 0;
 i8 = i11;
 HEAP32[i3 >> 2] = gb + 87192 + 8;
 i9 = i3 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 i6 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(.75);
 HEAP32[i3 + 36 >> 2] = -1;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i6, 64);
 HEAP32[i3 + 48 >> 2] = i2;
 HEAP8[i3 + 52 >> 0] = 1;
 i1 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
 mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i5 | 0, i1 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i5 = i7 + 4 | 0;
 do {
  i1 = i1 + -1 | 0;
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i7 | 0, i2 | 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  i2 = HEAPU16[i2 + (i1 << 3) + 4 >> 1] | 0;
  i3 = i8;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i6, i8, i10) | 0;
  if (!(HEAP8[i10 >> 0] | 0)) {
   i12 = i3;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i12 + 4 >> 2] = 0;
   i2 = i3 + 8 | 0;
   HEAP32[i2 >> 2] = 0;
  } else i2 = i3 + 8 | 0;
  HEAP32[i2 >> 2] = i4;
 } while ((i1 | 0) != 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx26PxRigidBodyGeneratedValuesC2EPKNS_11PxRigidBodyE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i2 + 24 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i2 + 52 | 0, i1 | 0);
 HEAPF32[i2 + 80 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 84 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i2 + 88 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i2 + 100 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i2 + 112 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i2 + 124 | 0, i1 | 0);
 HEAP8[i2 + 136 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 137 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 140 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 212 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 144 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 220 >> 2] | 0, i1 | 0));
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclERKNS_27PxRigidActorShapeCollectionEj(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i5 >> 2] = gb + 673520;
 HEAP8[i5 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i5;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_13PxRigidStaticEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE(i7, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i8;
 return;
}

function __ZN5physx18NpArticulationLink15releaseInternalEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i6, HEAP32[i6 + 8 >> 2] | 0, 1);
 i3 = i6 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i3, i6);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i6 + 20 | 0, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i6) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i3, i6);
 i3 = HEAP32[i6 + 288 >> 2] | 0;
 i4 = i3 + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i5) i1 = 0; else {
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i2;
  i5 = HEAP32[i3 + 88 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
 }
 i3 = HEAP32[i6 + 296 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 324 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  L12 : do if (!i5) i1 = 0; else {
   i2 = HEAP32[i3 + 320 >> 2] | 0;
   i1 = 0;
   do {
    if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L12;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
  } while (0);
  if ((i1 | 0) != (i5 | 0)) {
   i2 = i5 + -1 | 0;
   HEAP32[i4 >> 2] = i2;
   i5 = HEAP32[i3 + 320 >> 2] | 0;
   HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
  }
 }
 i1 = HEAP32[i6 + 292 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i6) | 0;
 if (!i1) {
  i6 = i6 + 48 | 0;
  __ZN5physx3Scb4Base7destroyEv(i6);
  return;
 }
 __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i1 + 16 | 0, i6 + 48 | 0, 1, 0);
 i6 = i6 + 48 | 0;
 __ZN5physx3Scb4Base7destroyEv(i6);
 return;
}

function __ZN12AspectRatios8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 16 | 0;
 i7 = i4 + 24 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 1 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 2 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 3 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 4 >> 0] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i3 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP32[i6 >> 2] = i2;
  HEAP8[i3 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
 i2 = i4 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i3);
 __Z19DestroySingleObjectP6Object(HEAP32[i3 + 20 >> 2] | 0);
 if (HEAP8[gb + 1099720 >> 0] | 0) {
  i6 = HEAP32[gb + 1467252 >> 2] | 0;
  __ZN10MemoryPool10DeallocateEPv(i6, i3);
  STACKTOP = i7;
  return i1 | 0;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
 i10 = gb + 63696 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 1018240 | 0, 40, 32768, i6, 16);
 HEAP32[gb + 1467252 >> 2] = i2;
 __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i2);
 if (i4) __Z19pop_allocation_rootv();
 i10 = gb + 1099720 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = HEAP32[gb + 1467252 >> 2] | 0;
 __ZN10MemoryPool10DeallocateEPv(i10, i3);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE16__construct_nodeERKNS_4pairIKS2_bEE(i10, i1, i11) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i5 >> 2] = 87;
 HEAP32[i5 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i11 >> 2] | 0 : i11;
 i6 = i2 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP8[i7 + 32 >> 0] = HEAP8[i11 + 16 >> 0] | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i12 = i10 + 9 | 0;
 HEAP8[i12 >> 0] = 0;
 HEAP8[i12 + 1 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = 0;
 STACKTOP = i13;
 return;
}

function __ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i4 = i2;
  i5 = 11;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if (__ZNK20TextRenderingPrivate7FontRefltERKS0_(i7, i2) | 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i5 = 4;
     break;
    } else i1 = i2;
   } else {
    if (!(__ZNK20TextRenderingPrivate7FontRefltERKS0_(i2, i7) | 0)) {
     i5 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i5 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i5 | 0) == 4) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i5 | 0) == 8) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i3;
   break;
  } else if ((i5 | 0) == 9) {
   HEAP32[i6 >> 2] = i1;
   i4 = i1;
   i2 = i6;
   i5 = 11;
   break;
  }
 } while (0);
 if ((i5 | 0) == 11) if (i1) {
  i8 = i1;
  i8 = i8 + 32 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = __Znwj(36) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3 + 16 | 0, i7);
 HEAP32[i3 + 28 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i3;
 i8 = i8 + 32 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_(i2, i1, i5, i4, i3, i7, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f16 = Math_fround(HEAPF32[i2 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f16 = Math_fround(f16 - f11);
 f15 = Math_fround(f15 - f13);
 f10 = Math_fround(f10 - f14);
 f18 = Math_fround(HEAPF32[i3 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f16 = Math_fround(f16 * f18);
 f15 = Math_fround(f15 * f12);
 f10 = Math_fround(f10 * f8);
 f17 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(f18 * Math_fround(f17 - f11));
 f13 = Math_fround(f12 * Math_fround(f9 - f13));
 f14 = Math_fround(f8 * Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f14));
 i3 = f16 > f11;
 i1 = f15 > f13;
 i2 = f10 > f14;
 f8 = f16 < f11 ? f16 : f11;
 f9 = f15 < f13 ? f15 : f13;
 f12 = f10 < f14 ? f10 : f14;
 f11 = i3 ? f16 : f11;
 f13 = i1 ? f15 : f13;
 f14 = i2 ? f10 : f14;
 i4 = f8 == f8 & Math_fround(0.0) == Math_fround(0.0) & f8 >= f9 & f8 >= f12;
 i5 = f9 == f9 & Math_fround(0.0) == Math_fround(0.0) & f9 >= f8 & f9 >= f12;
 f12 = i4 ? f8 : i5 ? f9 : f12;
 f9 = i1 ? Math_fround(4.0) : Math_fround(1.0);
 f8 = i2 ? Math_fround(5.0) : Math_fround(2.0);
 f10 = i3 ? Math_fround(3.0) : Math_fround(0.0);
 f13 = f13 > f14 ? f14 : f13;
 f11 = f11 > f13 ? f13 : f11;
 i3 = f11 >= Math_fround(1.1920929e-07) & f11 >= f12;
 HEAPF32[i7 >> 2] = f12;
 HEAPF32[i6 >> 2] = f11;
 return (i3 ? ~~(i4 ? f10 : i5 ? f9 : f8) : -1) | 0;
}

function __ZN2UI6Canvas19SetSortingLayerNameERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i4 = __Z13GetTagManagerv() | 0;
 HEAP32[i6 >> 2] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i6 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i10 = HEAP8[i2 + 11 >> 0] | 0;
 i11 = i10 << 24 >> 24 < 0;
 i3 = i11 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i11 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
 if (i2 >>> 0 > 15) {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i6 >> 2] = i11;
  HEAP32[i6 + 4 >> 2] = i2;
  i1 = (i11 | 0) == 0 ? i1 : i11;
 }
 _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i6) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i6 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 if (!(__ZNK2UI6Canvas13GetRenderModeEv(i8) | 0)) {
  STACKTOP = i9;
  return;
 }
 if (HEAP32[i8 + 344 >> 2] | 0) if (!(HEAP8[i8 + 375 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = __ZN10TagManager27IsSortingLayerUniqueIDValidEi(__Z13GetTagManagerv() | 0, i1) | 0;
 i1 = i2 ? i1 : 0;
 i2 = i8 + 368 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i11 = __Z13GetTagManagerv() | 0;
 HEAP16[i8 + 420 >> 1] = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i11, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i6 = i7;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37316 >> 2] | 0, i2, i4);
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i7 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i7 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i7;
 return;
}

function __ZN20SphericalHarmonicsL111AddWeightedERKS_f(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0;
 f5 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f3);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f3);
 i4 = i1 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f3);
 i4 = i1 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * f3);
 i4 = i1 + 12 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f3);
 i4 = i1 + 16 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * f3);
 i4 = i1 + 20 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * f3);
 i4 = i1 + 24 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * f3);
 i4 = i1 + 28 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 32 >> 2]) * f3);
 i4 = i1 + 32 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * f3);
 i4 = i1 + 36 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * f3);
 i4 = i1 + 40 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + f5);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * f3);
 i2 = i1 + 44 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f3);
 return;
}

function __ZN20ArchiveStorageHeader15WriteBlocksInfoER12FileAccessorRKNS_10BlocksInfoE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 i2 = __ZN12FileAccessor5WriteEyPKvPy(i4, 16, 0, i1, i5) | 0;
 i3 = i5;
 if (!(i2 & ((HEAP32[i3 >> 2] | 0) == 16 & (HEAP32[i3 + 4 >> 2] | 0) == 0))) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = i1 + 16 | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(((HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 12 | 0 | 0) | 0;
 i8 = __ZN12FileAccessor5WriteEyPKvPy(i4, 4, 0, i5, i6) | 0;
 i1 = i6;
 if (!(i8 & ((HEAP32[i1 >> 2] | 0) == 4 & (HEAP32[i1 + 4 >> 2] | 0) == 0))) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 while (1) {
  HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i4, 4, 0, i5, i6) | 0;
  i8 = i6;
  if (!(i2 & ((HEAP32[i8 >> 2] | 0) == 4 & (HEAP32[i8 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 9;
   break;
  }
  HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i1 + 4 >> 2] | 0) | 0;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i4, 4, 0, i5, i6) | 0;
  i8 = i6;
  if (!(i2 & ((HEAP32[i8 >> 2] | 0) == 4 & (HEAP32[i8 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 9;
   break;
  }
  HEAP16[i5 >> 1] = _llvm_bswap_i16(HEAP16[i1 + 8 >> 1] | 0) | 0;
  i2 = __ZN12FileAccessor5WriteEyPKvPy(i4, 2, 0, i5, i6) | 0;
  i8 = i6;
  i1 = i1 + 12 | 0;
  if (!(i2 & ((HEAP32[i8 >> 2] | 0) == 2 & (HEAP32[i8 + 4 >> 2] | 0) == 0))) {
   i1 = 0;
   i2 = 9;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 24 | 0;
 i12 = i14;
 i13 = i10 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if ((((HEAP32[i13 >> 2] | 0) - i5 | 0) / 132 | 0) >>> 0 >= i7 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i1 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i1;
 if (!i7) {
  i6 = 0;
  i3 = i4;
  i8 = i5;
  i2 = i4;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = 25;
  HEAP32[i2 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 132 | 0, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
  i8 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i6;
 i1 = i6 + (((i4 - i5 | 0) / 132 | 0) * 132 | 0) | 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i9 = i12 + 12 | 0;
 HEAP32[i9 >> 2] = i6 + (i7 * 132 | 0);
 if ((i3 | 0) != (i8 | 0)) {
  i2 = i3;
  do {
   i2 = i2 + -132 | 0;
   __ZN13AnimationClip10FloatCurveC2ERKS0_(i1 + -132 | 0, i2);
   i1 = (HEAP32[i5 >> 2] | 0) + -132 | 0;
   HEAP32[i5 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN7mecanim8skeleton8Skeleton8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i7 = i8;
 i3 = i6 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 906508 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 910040 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 16;
 HEAP32[i7 + 4 >> 2] = i2 + 12;
 HEAP32[i7 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 906515 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i6, i7, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 63; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i8 - i1 >> 4;
 HEAP32[i4 >> 2] = i5;
 i9 = i13 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i13 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i7 = i1 + 4 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = i4;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i4 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  i4 = i2 + i7 | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i12;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i8 - i1 >> 4;
 HEAP32[i4 >> 2] = i5;
 i9 = i13 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i13 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i7 = i1 + 4 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = i4;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i4 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  i4 = i2 + i7 | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i12;
 return;
}

function __Z11SkinGenericILi1ELb0ELb0EEvR12SkinMeshInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0;
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 i6 = HEAP32[i1 + 40 >> 2] | 0;
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = HEAP32[i1 + 60 >> 2] | 0;
 if ((i8 | 0) <= 0) return;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 while (1) {
  i12 = HEAP32[i1 >> 2] | 0;
  f11 = Math_fround(HEAPF32[i5 + (i12 << 6) >> 2]);
  f14 = Math_fround(HEAPF32[i2 >> 2]);
  f11 = Math_fround(f11 * f14);
  f10 = Math_fround(HEAPF32[i5 + (i12 << 6) + 16 >> 2]);
  f13 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f10 = Math_fround(f11 + Math_fround(f10 * f13));
  f11 = Math_fround(HEAPF32[i5 + (i12 << 6) + 32 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f11 = Math_fround(f10 + Math_fround(f11 * f9));
  f11 = Math_fround(Math_fround(HEAPF32[i5 + (i12 << 6) + 48 >> 2]) + f11);
  f10 = Math_fround(f14 * Math_fround(HEAPF32[i5 + (i12 << 6) + 4 >> 2]));
  f10 = Math_fround(f10 + Math_fround(f13 * Math_fround(HEAPF32[i5 + (i12 << 6) + 20 >> 2])));
  f10 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i5 + (i12 << 6) + 36 >> 2])));
  f10 = Math_fround(Math_fround(HEAPF32[i5 + (i12 << 6) + 52 >> 2]) + f10);
  f14 = Math_fround(f14 * Math_fround(HEAPF32[i5 + (i12 << 6) + 8 >> 2]));
  f13 = Math_fround(f14 + Math_fround(f13 * Math_fround(HEAPF32[i5 + (i12 << 6) + 24 >> 2])));
  f9 = Math_fround(f13 + Math_fround(f9 * Math_fround(HEAPF32[i5 + (i12 << 6) + 40 >> 2])));
  f9 = Math_fround(Math_fround(HEAPF32[i5 + (i12 << 6) + 56 >> 2]) + f9);
  HEAPF32[i3 >> 2] = f11;
  HEAPF32[i3 + 4 >> 2] = f10;
  HEAPF32[i3 + 8 >> 2] = f9;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i8 | 0)) break; else {
   i2 = i2 + i6 | 0;
   i3 = i3 + i7 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 L1 : do if (HEAP32[i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0) {
  __THREW__ = 0;
  invoke_vii(fb + 4509 | 0, i1 | 0, i3 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  L3 : do if (i2 & 1) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else {
   do if (HEAP8[i1 >> 0] | 0) {
    i2 = HEAP32[i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) {
     if ((i2 | 0) != -1) break;
     i5 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 1 | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     if (!(i5 & 1)) break;
    }
    i5 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1);
    i1 = i5;
    break L3;
   } while (0);
   __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1);
   break L1;
  } while (0);
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 L1 : do if (HEAP32[i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0) {
  __THREW__ = 0;
  invoke_vii(fb + 4507 | 0, i1 | 0, i3 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  L3 : do if (i2 & 1) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  } else {
   do if (HEAP8[i1 >> 0] | 0) {
    i2 = HEAP32[i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) {
     if ((i2 | 0) != -1) break;
     i5 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4508 | 0, i5 | 0, HEAP32[i5 + 16 >> 2] | 1 | 0);
     i5 = __THREW__;
     __THREW__ = 0;
     if (!(i5 & 1)) break;
    }
    i5 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1);
    i1 = i5;
    break L3;
   } while (0);
   __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1);
   break L1;
  } while (0);
  ___cxa_begin_catch(i1 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i15 = HEAP16[i9 + (i11 << 3) >> 1] | 0;
   i16 = i15 & 65535;
   i16 = i16 + ~(i16 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i5 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP16[i7 + (i11 << 3) >> 1] = i15;
   HEAP32[i7 + (i11 << 3) + 4 >> 2] = HEAP32[i9 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __Z14ValidateFormatR13dynamic_arrayIN20TextRenderingPrivate16TextFormatChangeELj4EE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 4 | 0;
 i7 = i12;
 HEAP32[i10 >> 2] = 0;
 i11 = i10 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 i8 = i6 + 12 | 0;
 do if (!(HEAP32[i8 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
  i4 = 13;
 } else {
  i4 = HEAP32[i6 >> 2] | 0;
  i9 = i10 + 8 | 0;
  i5 = i4;
  L3 : while (1) {
   i3 = HEAP32[i5 + 40 >> 2] | 0;
   HEAP32[i7 >> 2] = i3;
   do if (!(i3 & 32768)) {
    i1 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
     __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i10, i7);
     i1 = HEAP32[i6 >> 2] | 0;
     break;
    } else {
     HEAP32[i1 >> 2] = i3;
     HEAP32[i11 >> 2] = i1 + 4;
     i1 = i4;
     break;
    }
   } else {
    i1 = HEAP32[i10 >> 2] | 0;
    i2 = HEAP32[i11 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) {
     i4 = 11;
     break L3;
    }
    i13 = i3 & -32769;
    HEAP32[i7 >> 2] = i13;
    i3 = i2 + -4 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i13 | 0)) {
     i4 = 11;
     break L3;
    }
    HEAP32[i11 >> 2] = i3;
    i1 = i4;
   } while (0);
   i5 = i5 + 44 | 0;
   if ((i5 | 0) == (i1 + ((HEAP32[i8 >> 2] | 0) * 44 | 0) | 0)) {
    i4 = 12;
    break;
   } else i4 = i1;
  }
  if ((i4 | 0) == 11) {
   i3 = 0;
   break;
  } else if ((i4 | 0) == 12) {
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = 13;
   break;
  }
 } while (0);
 if ((i4 | 0) == 13) i3 = (i1 | 0) == (i2 | 0);
 if (!i1) {
  STACKTOP = i12;
  return i3 | 0;
 }
 if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i12;
 return i3 | 0;
}

function __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = 12;
 } else {
  i4 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i4 | 0) < (i2 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i3 = 5;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i4 | 0)) {
     i3 = 10;
     break;
    }
    i2 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) {
     i3 = 9;
     break;
    } else i1 = i3;
   }
  }
  if ((i3 | 0) == 5) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i2 = i1;
   break;
  } else if ((i3 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i3 | 0) == 10) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i2 = i5;
   i3 = 12;
   break;
  }
 } while (0);
 if ((i3 | 0) == 12) if (i1) {
  i7 = i1;
  i7 = i7 + 20 | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i3 = __Znwj(40) | 0;
 HEAP32[i3 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 20 >> 2] = 1065353216;
 HEAP32[i3 + 24 >> 2] = 1065353216;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = i3;
 i7 = i7 + 20 | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i7 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i7 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 + 20;
 HEAP32[i8 + 4 >> 2] = i6 + 16;
 HEAP32[i8 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i7, i8, 0);
 STACKTOP = i9;
 return;
}

function __ZN2UI17PrepareBatchesJobEPNS_21PrepareBatchesJobDataE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 24 | 0;
 i1 = i5;
 i4 = i5 + 8 | 0;
 if ((HEAP16[gb + 1468120 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468120 | 0, i2);
  i1 = gb + 1468120 | 0;
 } else i1 = 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i6 + 8 | 0;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((HEAP32[i7 >> 2] | 0) * 108 | 0, 16, gb + 64024 | 0, 0, gb + 1012316 | 0, 186) | 0;
 HEAP32[i6 + 20 >> 2] = i8;
 i10 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = i6 + 16 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i14 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(Math_fround((i14 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f12 = Math_fround(Math_fround(i14 >>> 16 & 255) / Math_fround(255.0));
 f11 = Math_fround(Math_fround(i14 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(i14 & 255) / Math_fround(255.0));
 HEAPF32[i4 + 4 >> 2] = f13;
 HEAPF32[i4 + 8 >> 2] = f12;
 HEAPF32[i4 + 12 >> 2] = f11;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 __ZN2UI14PrepareBatchesERNS_7BatchesEPKNS_23RenderableUIInstructionEPNS_28TransformGeometryInstructionEi10ColorRGBAf(i10, i9, i8, i7, i2);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, gb + 64024 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN24UVModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = gb + 618793 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618793 + 29 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7); else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
 }
 i1 = gb + 618823 | 0;
 i2 = -1;
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618823 + 26 | 0));
 HEAP32[i7 >> 2] = ~i2;
 HEAP32[i7 + 4 >> 2] = i5;
 HEAP32[i7 + 8 >> 2] = 100002;
 HEAP32[i7 + 12 >> 2] = 1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i6 + 4 | 0, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  STACKTOP = i8;
  return;
 }
}

function __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 120 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 i6 = HEAP32[i3 + 20 >> 2] | 0;
 i9 = HEAP32[i3 + 32 >> 2] | 0;
 i8 = HEAP32[i3 + 60 >> 2] | 0;
 i5 = HEAP32[i3 + 28 >> 2] | 0;
 i10 = i3 + 24 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0) | 0;
 i11 = i3 + 64 | 0;
 i3 = i11;
 i3 = _i64Add(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, 1, 0) | 0;
 i7 = getTempRet0() | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i7;
 i10 = HEAP32[i10 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 20 >> 2] | 0, i10 | 0);
 i7 = __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i6, i9, i8, i5, i3, i7) | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, 12, gb + 775869 | 0, gb + 773844 | 0, 756) | 0;
 HEAP32[i3 >> 2] = gb + 149240 + 8;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferERNS_19PxAllocatorCallbackEj(i6, 4096) | 0;
 i6 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i2 >> 2] = i3;
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 775887;
 HEAP32[i1 + 4 >> 2] = gb + 775898;
 mftCall_iiii(i8 | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0);
 i2 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Gu18computeMTD_BoxMeshERNS_6PxVec3ERfRKNS0_3BoxERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i6, i4, i1, i2, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 4208 | 0;
 i15 = i7 + 4192 | 0;
 i12 = i7 + 4240 | 0;
 i13 = i7 + 4120 | 0;
 i11 = i7 + 4136 | 0;
 i8 = i7 + 4116 | 0;
 i3 = i7;
 i9 = i7 + 4112 | 0;
 __ZN5physx6PxQuatC2ERKNS_7PxMat33E(i15, i1);
 HEAP32[i10 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i15 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i15 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i15 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i12 >> 2] = -1;
 i15 = HEAP32[i1 + 48 >> 2] | 0;
 i14 = HEAP32[i1 + 52 >> 2] | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i13 >> 2] = 3;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i13 + 8 >> 2] = i14;
 HEAP32[i13 + 12 >> 2] = i1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu14contactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i5, i9, i8, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i6, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i15 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN5physx24PxsParticleSystemBatcher20scheduleCollisionCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE(i15, i14, i12, i16) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17;
 if (!i12) i2 = i15 + 288 | 0; else {
  i5 = i15 + 364 | 0;
  i2 = i15 + 288 | 0;
  i6 = i15 + 284 | 0;
  i7 = i15 + 324 | 0;
  i8 = i15 + 320 | 0;
  i9 = i15 + 316 | 0;
  i10 = i15 + 360 | 0;
  i11 = i15 + 296 | 0;
  i13 = 0;
  do {
   i3 = __ZN5physx20PxsParticleSystemSim23scheduleCollisionUpdateERNS_10PxBaseTaskE(HEAP32[i14 + (i13 << 2) >> 2] | 0, i16) | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
   __ZN5physx6shdfnd15atomicIncrementEPVi(i2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 >> 2] = i3;
   i4 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i8 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11, i1) | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
   HEAP8[i10 >> 0] = 1;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i12 | 0));
 }
 i1 = i15 + 276 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i16 | 0);
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) > 1) do __ZN5physx2Cm10FanoutTask15removeReferenceEv(i1); while ((HEAP32[i2 >> 2] | 0) > 1);
 i16 = i1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN16ReflectionProbes40UpdateRealtimeReflectionProbesTimeslicedEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i2 = i8 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAPU8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 82 >> 0] | 0;
 do if ((i3 | 0) == -1) HEAP32[i2 >> 2] = i1; else if ((i3 | 0) == (i1 | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i1 = __Z18GetQualitySettingsv() | 0;
  i1 = HEAPU8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 82 >> 0] | 0;
  HEAP32[i2 >> 2] = i1;
  break;
 } while (0);
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = i8 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i8 + 72 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i5 = i3 + 8 | 0;
  i6 = i3 + 12 | 0;
  i7 = i6;
  i1 = 0;
  do {
   i1 = i1 | (HEAP32[i5 >> 2] | 0) == 2;
   __ZN18ReflectionProbeJob3RunEv(i3) | 0;
   _memmove(i3 | 0, i6 | 0, (HEAP32[i2 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 12 | 0) - i7 | 0) | 0;
   i9 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
   HEAP32[i4 >> 2] = i9;
  } while ((i3 | 0) != ((HEAP32[i2 >> 2] | 0) + (i9 * 12 | 0) | 0));
 }
 i3 = i8 + 100 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i9 = i1;
  return i9 | 0;
 }
 i4 = i8 + 84 | 0;
 i2 = i8 + 96 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i4 >> 2] | 0) + (((i9 >>> 0) / 341 | 0) << 2) >> 2] | 0;
 i9 = (i9 >>> 0) % 341 | 0;
 i1 = i1 | (HEAP32[i8 + (i9 * 12 | 0) + 8 >> 2] | 0) == 2;
 __ZN18ReflectionProbeJob3RunEv(i8 + (i9 * 12 | 0) | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i9 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
 HEAP32[i2 >> 2] = i9;
 if (i9 >>> 0 <= 681) {
  i9 = i1;
  return i9 | 0;
 }
 __ZdlPv(HEAP32[HEAP32[i4 >> 2] >> 2] | 0);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -341;
 i9 = i1;
 return i9 | 0;
}

function __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = i8 + 16 | 0;
 i2 = (HEAP8[(__Z15GetAudioManagerv() | 0) + 225 >> 0] | 0) != 0;
 if (i1) if (i2) i3 = 4; else i4 = 1; else if (i2) i3 = 4; else {
  STACKTOP = i8;
  return;
 }
 if ((i3 | 0) == 4) i4 = (__ZNK11AudioSource21AreAllChannelsVirtualEv(i7) | 0) ^ 1;
 i1 = HEAP32[i7 + 540 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD3DSP9setActiveEb(i1, i4) | 0;
  if (i1 | 0) {
   i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i6 >> 2] = gb + 855390;
   HEAP32[i6 + 4 >> 2] = 1800;
   HEAP32[i6 + 8 >> 2] = gb + 856127;
   HEAP32[i6 + 12 >> 2] = i3;
   __Z6FormatPKcz(i5, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
 }
 i2 = HEAP32[i7 + 28 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 i6 = ((HEAP8[i7 + 424 >> 0] ^ 1) & 255 & (i4 & 1) | 0) != 0;
 i7 = i2 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = i2 + 28 | 0;
 i4 = 0;
 do {
  i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
  if (!((i3 | 0) == 0 ? 1 : (((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0)) {
   i2 = i3 + 40 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN11AudioFilter4InitEv(i3);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   __ZN4FMOD3DSP9setActiveEb(i1, i6) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 STACKTOP = i8;
 return;
}

function __ZN8VRDevice27OnAudioConfigurationChangedEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = i7 + 4 | 0;
 i6 = __Z9GetIAudiov() | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 92 >> 2] | 0, i6 | 0) | 0) {
  STACKTOP = i7;
  return;
 }
 i4 = i5 + 4 | 0;
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 276 >> 2] | 0;
 do if (i2 | 0) {
  i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 80 >> 2] | 0;
  if (!(mftCall_iii(i8 | 0, i6 | 0, mftCall_i(i2 | 0) | 0) | 0)) {
   __Z6FormatPKcz(i1, gb + 1044409 | 0, i3);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1044184 | 0, 303, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   break;
  }
  i2 = mftCall_i(HEAP32[(HEAP32[i4 >> 2] | 0) + 276 >> 2] | 0) | 0;
  i1 = i5 + 331 | 0;
  if (!i2) {
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   break;
  } else {
   i3 = i1 + 16 | 0;
   do {
    HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i1 + 1 | 0;
    i2 = i2 + 1 | 0;
   } while ((i1 | 0) < (i3 | 0));
   break;
  }
 } while (0);
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 280 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = mftCall_i(i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 84 >> 2] | 0, i6 | 0, i2 | 0);
 i1 = i5 + 347 | 0;
 if (!i2) {
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i7;
  return;
 } else {
  i3 = i1 + 16 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i7;
  return;
 }
}

function __ZN6Camera24PrepareCullingParametersERK23CameraCullingParameters13RenderingPathR11CullResults(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = i5 + 12 | 0;
 if (!(HEAP32[i8 >> 2] & 2)) {
  i4 = i7 + 336 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  i4 = 0;
  i2 = 0;
  i1 = i7 + 16 | 0;
 } else {
  i1 = HEAP32[(__Z16GetRendererScenev() | 0) + 144 >> 2] | 0;
  i4 = i7 + 336 | 0;
  i3 = i7 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  if (!i1) {
   i4 = 0;
   i2 = 0;
   i1 = i3;
  } else {
   i2 = __Z9GetIUmbrav() | 0;
   i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i3 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = i2;
   i2 = __Z9GetIUmbrav() | 0;
   i4 = i1;
   i2 = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i1 | 0, HEAP32[i3 >> 2] | 0, gb + 64024 | 0) | 0;
   i1 = i3;
  }
 }
 HEAP32[i7 + 80 >> 2] = i2;
 __ZNK6Camera26CalculateCullingParametersER17CullingParameters(HEAP32[i5 >> 2] | 0, i7 + 384 | 0);
 HEAP32[i7 + 1216 >> 2] = i1;
 HEAP32[i7 + 1228 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i7 + 1232 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i7 + 1220 >> 2] = i4;
 HEAP32[i7 + 1224 >> 2] = HEAP32[(__Z16GetRendererScenev() | 0) + 140 >> 2];
 HEAP32[i7 + 1212 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 1108 >> 2];
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP8[i7 + 1201 >> 0] = i8 >>> 2 & 1;
 HEAP8[i7 + 1202 >> 0] = i8 >>> 3 & 1;
 HEAP8[i7 + 1200 >> 0] = 1;
 HEAP32[i7 + 1204 >> 2] = i6;
 HEAP8[i7 + 76 >> 0] = (i4 | 0) != 0 & 1;
 return;
}

function __ZN5physx2Sc5Scene17stepSetupSimulateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f11 = f0, i12 = 0, i13 = 0;
 f11 = Math_fround(HEAPF32[i10 + 64 >> 2]);
 i6 = i10 + 72 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i6 >> 2]));
 i6 = i10 + 1204 | 0;
 __ZN5physx2Sc27ConstraintProjectionManager21processPendingUpdatesERNS_19PxcScratchAllocatorE(HEAP32[i10 + 96 >> 2] | 0, (HEAP32[(HEAP32[i6 >> 2] | 0) + 1e3 >> 2] | 0) + 20 | 0);
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i5 << 2) | 0;
 if (!i5) {
  i9 = i10 + 1104 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv(i9);
  i10 = i10 + 1188 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 & -7;
  HEAP32[i10 >> 2] = i9;
  return;
 }
 i8 = i10 + 68 | 0;
 i9 = 0;
 i1 = i6 + 64 | 0;
 do {
  if (i1 >>> 0 < i7 >>> 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   i13 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i12 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 1023, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i12 = _i64Subtract(1, 0, i13 | 0, i12 | 0) | 0;
   i2 = _i64Add(i12 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(HEAP32[i6 + (i9 << 2) >> 2] | 0, Math_fround(HEAPF32[i8 >> 2]));
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i5 | 0));
 i13 = i10 + 1104 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv(i13);
 i13 = i10 + 1188 | 0;
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = i12 & -7;
 HEAP32[i13 >> 2] = i12;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold12drawTriangleERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_S9_j(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i6 + 40 | 0;
 i13 = i6 + 24 | 0;
 i9 = i6 + 12 | 0;
 i7 = i6;
 i16 = HEAP32[i3 >> 2] | 0;
 i15 = HEAP32[i3 + 4 >> 2] | 0;
 i14 = HEAP32[i3 + 8 >> 2] | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = HEAP32[i4 + 8 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAPF32[i17 >> 2] = Math_fround(1.0);
 i5 = i17 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i17 + 20 >> 2] = Math_fround(1.0);
 i5 = i17 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i17 + 40 >> 2] = Math_fround(1.0);
 i5 = i17 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAPF32[i17 + 60 >> 2] = Math_fround(1.0);
 i5 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i17) | 0, 3) | 0;
 HEAP32[i13 >> 2] = i16;
 HEAP32[i13 + 4 >> 2] = i15;
 HEAP32[i13 + 8 >> 2] = i14;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i13) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i10;
 i5 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i9) | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i4;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i5, i7) | 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 32, 4) | 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorI12WebCamDeviceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 20 | 0) + 1 | 0;
 if (i3 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 20 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 107374182 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 214748364;
 i1 = (i2 - i1 | 0) / 20 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 20 | 0) | 0;
 i2 = i4 + (i1 * 20 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 20 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 i11 = i6 + 12 | 0;
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i4 + (i1 * 20 | 0) + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i2 + 20 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i12 = i1;
   i1 = i1 + -20 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -20 | 0, i1);
   i12 = i12 + -8 | 0;
   i6 = HEAP32[i12 + 4 >> 2] | 0;
   i11 = i2 + -8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i11 + 4 >> 2] = i6;
   i2 = i3 + -20 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -20 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = __Znwj(36) | 0;
 i8 = i1 + 4 | 0;
 i9 = i7;
 HEAP32[i7 + 16 >> 2] = HEAP32[i2 >> 2];
 i1 = i7 + 20 | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i3 ? HEAP32[i2 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 32 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i7 + 31 >> 0] = i4;
  if (!i4) {
   i11 = i1;
   i11 = i11 + i4 | 0;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i10 >> 2] = i9;
   i11 = i10 + 4 | 0;
   i10 = i11;
   HEAP32[i10 >> 2] = i8;
   i11 = i11 + 4 | 0;
   HEAP32[i11 >> 2] = 1;
   STACKTOP = i12;
   return;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 + 28 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 24 >> 2] = i4;
  i1 = i11;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i11 = i1;
 i11 = i11 + i4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i10 >> 2] = i9;
 i11 = i10 + 4 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = i8;
 i11 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = 1;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE5eraseENS_21__tree_const_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
 i2 = i4 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i3);
 if (HEAP8[gb + 1098104 >> 0] | 0) {
  i6 = HEAP32[gb + 1158356 >> 2] | 0;
  __ZN10MemoryPool10DeallocateEPv(i6, i3);
  STACKTOP = i7;
  return i1 | 0;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
 i10 = gb + 63696 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 1018240 | 0, 56, 32768, i6, 16);
 HEAP32[gb + 1158356 >> 2] = i2;
 __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i2);
 if (i4) __Z19pop_allocation_rootv();
 i10 = gb + 1098104 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = HEAP32[gb + 1158356 >> 2] | 0;
 __ZN10MemoryPool10DeallocateEPv(i10, i3);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i13 + 16 | 0;
 i12 = HEAP32[i3 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i7 = (i4 << 2) + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i7 + (i4 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i13 + 36 | 0;
 i2 = i13 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i10 = i1 + -1 | 0;
  i11 = 0;
  do {
   i15 = HEAP16[i9 + (i11 << 3) >> 1] | 0;
   i16 = i15 & 65535;
   i16 = i16 + ~(i16 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i5 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i6 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP16[i7 + (i11 << 3) >> 1] = i15;
   HEAP32[i7 + (i11 << 3) + 4 >> 2] = HEAP32[i9 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i5;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx2Sc5Scene16stepSetupCollideEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f11 = f0, i12 = 0, i13 = 0;
 f11 = Math_fround(HEAPF32[i10 + 64 >> 2]);
 i6 = i10 + 72 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i6 >> 2]));
 i6 = i10 + 1204 | 0;
 __ZN5physx2Sc27ConstraintProjectionManager21processPendingUpdatesERNS_19PxcScratchAllocatorE(HEAP32[i10 + 96 >> 2] | 0, (HEAP32[(HEAP32[i6 >> 2] | 0) + 1e3 >> 2] | 0) + 20 | 0);
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i5 << 2) | 0;
 if (!i5) {
  i9 = i10 + 1104 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv(i9);
  i10 = i10 + 1188 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 & -7;
  HEAP32[i10 >> 2] = i9;
  return;
 }
 i8 = i10 + 68 | 0;
 i9 = 0;
 i1 = i6 + 64 | 0;
 do {
  if (i1 >>> 0 < i7 >>> 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   i13 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i12 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 1023, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i12 = _i64Subtract(1, 0, i13 | 0, i12 | 0) | 0;
   i2 = _i64Add(i12 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(HEAP32[i6 + (i9 << 2) >> 2] | 0, Math_fround(HEAPF32[i8 >> 2]));
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i5 | 0));
 i13 = i10 + 1104 | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv(i13);
 i13 = i10 + 1188 | 0;
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = i12 & -7;
 HEAP32[i13 >> 2] = i12;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i12 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = (i4 - i5 | 0) / 24 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj(i2, i1 - i3 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i3 >>> 0) {
  i1 = i5 + (i1 * 24 | 0) | 0;
  if ((i4 | 0) == (i1 | 0)) i1 = i5; else {
   i4 = i4 + (~(((i4 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i4;
   i1 = i5;
  }
 } else i1 = i5;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i11;
  return;
 }
 i3 = i1;
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i12);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  HEAP32[i3 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = i3 + 24 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i11;
 return;
}

function __ZL37UnityAudioEffect_InternalReadCallbackP14FMOD_DSP_STATEPfS1_jii(i1, i6, i7, i10, i11, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 HEAP32[i9 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i1 >> 2] | 0, i9) | 0;
 if (i1 | 0) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i11 = 36;
  STACKTOP = i12;
  return i11 | 0;
 }
 i5 = HEAP32[i1 + 112 >> 2] | 0;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = i1 + 32 | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + 8 >> 2] & 3 | i13 & -4;
 i3 = i4;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i14 = i1 + 8 | 0;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i4 + 16 >> 2];
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 if ((i4 | 0) == 0 | (i13 & 8 | 0) == 0) i3 = 0; else {
  i14 = i1 + 16 | 0;
  i14 = _i64Subtract(i2 | 0, i3 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i14 + 4 >> 2] | 0) | 0;
  if ((i14 | 0) == (i10 | 0) & (getTempRet0() | 0) == 0) i3 = 1; else {
   _memset(i4 | 0, 0, Math_imul(i10 << 2, i11) | 0) | 0;
   i3 = 0;
  }
 }
 i1 = HEAP32[i5 + 172 >> 2] | 0;
 if (!i1) i2 = 0; else {
  i2 = (mftCall_iiiiiii(i1 | 0, HEAP32[i9 >> 2] | 0, i6 | 0, i7 | 0, i10 | 0, i11 | 0, i8 | 0) | 0) == 0;
  i2 = i2 ? 0 : 80;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i9 = i1 + 8 | 0;
 i13 = HEAP32[i9 + 4 >> 2] | 0;
 i14 = i1 + 16 | 0;
 HEAP32[i14 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i14 + 4 >> 2] = i13;
 if (!i3) {
  i14 = i2;
  STACKTOP = i12;
  return i14 | 0;
 }
 _memset(HEAP32[i1 + 24 >> 2] | 0, 0, Math_imul(i10 << 2, i11) | 0) | 0;
 i14 = i2;
 STACKTOP = i12;
 return i14 | 0;
}

function __ZN6prcore17GetIntegerBlitterE13TextureFormatS0_N14ImageReference8BlitModeE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   if ((i1 | 0) == -1) i2 = 0; else if ((i1 | 0) == 1001) i2 = 13; else if ((i1 | 0) == 1) i2 = 26; else if ((i1 | 0) == 7) i2 = 39; else if ((i1 | 0) == 3) i2 = 52; else if ((i1 | 0) == 2) i2 = 78; else if ((i1 | 0) == 5) i2 = 91; else if ((i1 | 0) == 8) i2 = 104; else if ((i1 | 0) == 1e3) i2 = 117; else if ((i1 | 0) == 13) i2 = 130; else if ((i1 | 0) == 14) i2 = 143; else if ((i1 | 0) == 4) i2 = 156; else {
    i3 = 0;
    return i3 | 0;
   }
   if ((i3 | 0) == -1) i1 = 0; else if ((i3 | 0) == 1001) i1 = 1; else if ((i3 | 0) == 1) i1 = 2; else if ((i3 | 0) == 7) i1 = 3; else if ((i3 | 0) == 3) i1 = 4; else if ((i3 | 0) == 2) i1 = 6; else if ((i3 | 0) == 5) i1 = 7; else if ((i3 | 0) == 8) i1 = 8; else if ((i3 | 0) == 1e3) i1 = 9; else if ((i3 | 0) == 13) i1 = 10; else if ((i3 | 0) == 14) i1 = 11; else if ((i3 | 0) == 4) i1 = 12; else {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[gb + 56896 + (i1 + i2 << 2) >> 2] | 0;
   return i3 | 0;
  }
 case 1:
  {
   i3 = (HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(i1) | 0) + 4 >> 2] | 0) + -1 | 0;
   i3 = HEAP32[gb + 57636 + (i3 << 2) >> 2] | 0;
   return i3 | 0;
  }
 case 2:
  {
   if ((i1 | 0) == -1) i1 = 0; else if ((i1 | 0) == 1001) i1 = 1; else if ((i1 | 0) == 1) i1 = 2; else if ((i1 | 0) == 7) i1 = 3; else if ((i1 | 0) == 3) i1 = 4; else if ((i1 | 0) == 2) i1 = 6; else if ((i1 | 0) == 5) i1 = 7; else if ((i1 | 0) == 8) i1 = 8; else if ((i1 | 0) == 1e3) i1 = 9; else if ((i1 | 0) == 13) i1 = 10; else if ((i1 | 0) == 14) i1 = 11; else if ((i1 | 0) == 4) i1 = 12; else {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[gb + 57652 + (i1 << 2) >> 2] | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx24PxsParticleSystemBatcher19scheduleDynamicsCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE(i15, i14, i12, i16) {
 i15 = i15 | 0;
 i14 = i14 | 0;
 i12 = i12 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17;
 if (!i12) i2 = i15 + 104 | 0; else {
  i5 = i15 + 180 | 0;
  i2 = i15 + 104 | 0;
  i6 = i15 + 100 | 0;
  i7 = i15 + 140 | 0;
  i8 = i15 + 136 | 0;
  i9 = i15 + 132 | 0;
  i10 = i15 + 176 | 0;
  i11 = i15 + 112 | 0;
  i13 = 0;
  do {
   i3 = __ZN5physx20PxsParticleSystemSim22scheduleDynamicsUpdateERNS_10PxBaseTaskE(HEAP32[i14 + (i13 << 2) >> 2] | 0, i16) | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
   __ZN5physx6shdfnd15atomicIncrementEPVi(i2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 >> 2] = i3;
   i4 = HEAP32[i8 >> 2] | 0;
   if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i3;
    HEAP32[i8 >> 2] = i4 + 1;
   } else __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i11, i1) | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
   HEAP8[i10 >> 0] = 1;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   i13 = i13 + 1 | 0;
  } while ((i13 | 0) != (i12 | 0));
 }
 i1 = i15 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i16 >> 2] | 0) + 16 >> 2] | 0, i16 | 0);
  STACKTOP = i17;
  return i16 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) > 1) do __ZN5physx2Cm10FanoutTask15removeReferenceEv(i1); while ((HEAP32[i2 >> 2] | 0) > 1);
 i16 = i1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_110DataStream28sendPropertyMessageFromGroupEPKvN5physx8debugger7DataRefIKhEE(i14, i13, i12) {
 i14 = i14 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15;
 i3 = HEAP32[i14 + 344 >> 2] | 0;
 i11 = i12 + 4 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i9;
 if ((i1 - i2 | 0) != (i3 | 0)) {
  i14 = 2;
  STACKTOP = i15;
  return i14 | 0;
 }
 i7 = i14 + 352 | 0;
 i8 = i14 + 348 | 0;
 if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i8 >> 2] | 0)) {
  i4 = i14 + 356 | 0;
  i5 = i14 + 368 | 0;
  i6 = i14 + 372 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(i4, i9, i3);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((HEAP32[i7 >> 2] | 0) != (i1 | 0)) {
   i2 = 0;
   do {
    i3 = i9 + (HEAP32[i1 + (i2 << 2) >> 2] | 0) | 0;
    i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
    i3 = i3 | 0 ? i3 : gb + 1576256 | 0;
    __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j(i4, i3, (_strlen(i3) | 0) + 1 | 0);
    i2 = i2 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) - i1 >> 2 >>> 0);
  }
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i10 >> 2] = gb + 150120 + 8;
 i12 = i10 + 8 | 0;
 HEAP32[i12 >> 2] = i13;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = i2;
 HEAP32[i10 + 20 >> 2] = i1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i14, i10, 13);
 i14 = (HEAPU8[i14 + 392 >> 0] | 0) ^ 1;
 STACKTOP = i15;
 return i14 | 0;
}

function __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEER17ShaderPassContext(i3, i4, i1, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i9 = i10;
 i7 = i10 + 16 | 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i7 >> 2] = i1;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 HEAP32[i8 >> 2] = i1;
 i8 = __ZnwjRK10MemLabelIdiPKci(108, gb + 64024 | 0, 16, gb + 388526 | 0, 339) | 0;
 i11 = gb + 64024 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = 1;
 HEAP32[i8 >> 2] = gb + 36880 + 8;
 i2 = i8 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i12;
 HEAP32[i1 + 4 >> 2] = i11;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i9);
 i1 = i6;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i8 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i8 + 32 >> 2] = 0;
 HEAP32[i8 + 36 >> 2] = 0;
 HEAP8[i8 + 104 >> 0] = 1;
 i9 = i4 + 4 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = i4;
 __ZN15ReplacementPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceData(i8, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, i3, i4 + 8 | 0, i7);
 __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext(i8, i5);
 STACKTOP = i10;
 return;
}

function __Z12NHxRoughnessIA4_tEvP9Texture2DPT_iiii(i2, i8, i6, i4, i7, i5) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var f1 = f0, f3 = f0, f9 = f0;
 f9 = Math_fround(+Math_pow(+Math_fround(Math_fround(i6 | 0) / Math_fround(Math_fround(i7 | 0) + Math_fround(-1.0))), .25));
 f3 = Math_fround(Math_fround(i4 | 0) / Math_fround(Math_fround(i5 | 0) + Math_fround(-.5)));
 f1 = Math_fround(Math_fround(10.0) / Math_fround(_log2f(Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(.967999994)) + Math_fround(.0299999993)))));
 f1 = Math_fround(Math_fround(f1 * f1) * Math_fround(.25));
 f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f9, +f1)) * Math_fround(Math_fround(f1 + Math_fround(2.0)) / Math_fround(6.28318548))) / Math_fround(445.721954));
 i5 = f1 < Math_fround(0.0);
 f1 = i5 ? Math_fround(0.0) : f1;
 i5 = f1 > Math_fround(1.0);
 f1 = i5 ? Math_fround(1.0) : f1;
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 if (!((i7 + -1 | 0) > (i6 | 0) | !(f3 <= Math_fround(.0500000007)))) f1 = Math_fround(Math_fround(f3 / Math_fround(.0500000007)) * f1);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = i6 >>> 23 & 255;
 i7 = (i6 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i7 << 1) >> 1] | 0) | (i6 & 8388607) >>> (HEAPU8[gb + 1546331 + i7 >> 0] | 0)) & 65535;
 HEAP16[i8 >> 1] = i7;
 HEAP16[i8 + 2 >> 1] = i7;
 HEAP16[i8 + 4 >> 1] = i7;
 HEAP16[i8 + 6 >> 1] = i7;
 return;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i12, i1, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i9 = i11 + 4 | 0;
  i10 = i11 + 8 | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
   f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2])));
   f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f16 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f14 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]);
    f15 = Math_fround(HEAPF32[i11 >> 2]);
    f13 = Math_fround(HEAPF32[i9 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f4 * Math_fround(HEAPF32[i10 >> 2])));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i11) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 i10 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i11 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 + (i2 * 12 | 0) >> 2];
 HEAP32[i12 + 4 >> 2] = i10;
 HEAP32[i12 + 8 >> 2] = i11;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 4 | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 << 3 | 0, 4) | 0;
  i1 = i1 | 0 ? i1 - i3 | 0 : 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i4 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 i5 = i1 + (i4 << 3) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i8 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i6, i1) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) {
  i2 = i4 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = i6 + 16 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i1 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   i1 = i4;
  }
  HEAP32[i6 >> 2] = i1;
  i3 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i3 + i1 | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 do {
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = i1 + 1 | 0;
  if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
   i1 = HEAP8[i7 >> 0] | 0;
  } else {
   i1 = HEAP8[i1 >> 0] | 0;
   HEAP8[i7 >> 0] = i1;
   HEAP32[i8 >> 2] = i2;
  }
  HEAP8[i3 >> 0] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i6 = i1;
  i2 = i2 | 0 ? i2 - i6 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i6;
 }
 i6 = i2 + i1 | 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i7, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = -1;
   HEAP32[i2 + 8 >> 2] = -1;
   i3 = i2 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i2 + 32 >> 2] = -1;
   HEAPF32[i2 + 36 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
   HEAP8[i2 + 44 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801380 | 0, i1, 0);
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802559 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 160 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 8 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37320 >> 2] | 0, i5, 0);
 i6 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 20 >> 2] = i6;
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i6, i5 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function _UNITY_png_colorspace_set_chromaticities(i3, i4, i6, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 switch (_UNITY_png_colorspace_check_xy(i1, i6) | 0) {
 case 0:
  {
   i7 = i4 + 74 | 0;
   i8 = HEAPU16[i7 >> 1] | 0;
   if (i8 & 32768 | 0) {
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   }
   i2 = i4 + 4 | 0;
   do if (!((i5 | 0) > 1 | (i8 & 2 | 0) == 0)) if (!(_UNITY_png_colorspace_endpoints_match(i6, i2, 100) | 0)) {
    HEAP16[i7 >> 1] = i8 | 32768;
    _UNITY_png_benign_error(i3, gb + 350982 | 0);
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   } else {
    if (!i5) i1 = 1; else break;
    STACKTOP = i9;
    return i1 | 0;
   } while (0);
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
   HEAP32[i2 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
   i3 = i4 + 36 | 0;
   i2 = i3 + 36 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
   i6 = (_UNITY_png_colorspace_endpoints_match(i6, gb + 14376 | 0, 1e3) | 0) == 0;
   HEAP16[i7 >> 1] = i6 ? i8 & 65469 | 2 : i8 | 66;
   i8 = 2;
   STACKTOP = i9;
   return i8 | 0;
  }
 case 1:
  {
   i8 = i4 + 74 | 0;
   HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 0 | 32768;
   _UNITY_png_benign_error(i3, gb + 351010 | 0);
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 default:
  {
   i9 = i4 + 74 | 0;
   HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 32768;
   _UNITY_png_error(i3, gb + 351033 | 0);
  }
 }
 return 0;
}

function _alloc_small(i7, i3, i1) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = i1 + 7 & -8;
 i6 = i10 + 19 | 0;
 if (i6 >>> 0 > 1e9) {
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 54;
  HEAP32[i8 + 24 >> 2] = 1;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i7 | 0);
 }
 if (i3 >>> 0 > 1) {
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 14;
  HEAP32[i8 + 24 >> 2] = i3;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i7 | 0);
 }
 i8 = i9 + 52 + (i3 << 2) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 L7 : do if (!i1) {
  i1 = 0;
  i4 = 8;
 } else while (1) {
  if ((HEAP32[i1 + 8 >> 2] | 0) >>> 0 >= i10 >>> 0) break L7;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i4 = 8;
   break;
  } else i1 = i2;
 } while (0);
 do if ((i4 | 0) == 8) {
  i5 = (i1 | 0) == 0;
  i3 = HEAP32[(i5 ? gb + 15736 | 0 : gb + 15744 | 0) + (i3 << 2) >> 2] | 0;
  i2 = 999999981 - i10 | 0;
  i3 = i3 >>> 0 > i2 >>> 0 ? i2 : i3;
  i2 = i3 + i6 | 0;
  i4 = _jpeg_get_small(i7, i2) | 0;
  if (!i4) {
   i2 = i3;
   while (1) {
    i3 = i2 >>> 1;
    if (i2 >>> 0 < 100) {
     i4 = HEAP32[i7 >> 2] | 0;
     HEAP32[i4 + 20 >> 2] = 54;
     HEAP32[i4 + 24 >> 2] = 2;
     mftCall_vi(HEAP32[i4 >> 2] | 0, i7 | 0);
    }
    i2 = i3 + i6 | 0;
    i4 = _jpeg_get_small(i7, i2) | 0;
    if (!i4) i2 = i3; else break;
   }
  }
  i9 = i9 + 76 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i2;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = i3 + i10;
  if (i5) {
   HEAP32[i8 >> 2] = i4;
   i1 = i4;
   break;
  } else {
   HEAP32[i1 >> 2] = i4;
   i1 = i4;
   break;
  }
 } while (0);
 i7 = i1 + 12 | 0;
 i8 = i7 & 7;
 i6 = i1 + 4 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i9 + i10;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i10;
 return ((i8 | 0) == 0 ? i7 : i7 + (8 - i8) | 0) + i9 | 0;
}

function __ZN5physx16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE8pushBackEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i7 + 4 | 0;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 if ((i3 | 0) != 128) {
  i5 = i2;
  i6 = i1;
  i7 = i3;
  i4 = i5 + (i6 << 3) + 4 | 0;
  i3 = i7 + 1 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i5 + (i6 << 3) | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + (i7 * 96 | 0) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 do if ((i1 + 1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = mftCall_iiiiii(i2 | 0, i3 | 0, 12288, (i1 ? gb + 714989 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 235) | 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i7 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i2 = i4;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i7, i4) | 0;
   break;
  }
 } while (0);
 i4 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 HEAP32[i6 >> 2] = i4;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i4 << 3) + 4 >> 2] = 0;
 i6 = i4;
 i7 = 0;
 i4 = i5 + (i6 << 3) + 4 | 0;
 i3 = i7 + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 i6 = i5 + (i6 << 3) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i7 * 96 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE8pushBackEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i7 + 4 | 0;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 if ((i3 | 0) != 128) {
  i5 = i2;
  i6 = i1;
  i7 = i3;
  i4 = i5 + (i6 << 3) + 4 | 0;
  i3 = i7 + 1 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i5 + (i6 << 3) | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + (i7 * 108 | 0) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 do if ((i1 + 1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = mftCall_iiiiii(i2 | 0, i3 | 0, 13824, (i1 ? gb + 715173 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 235) | 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i7 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i2 = i4;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i7, i4) | 0;
   break;
  }
 } while (0);
 i4 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 HEAP32[i6 >> 2] = i4;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i4 << 3) + 4 >> 2] = 0;
 i6 = i4;
 i7 = 0;
 i4 = i5 + (i6 << 3) + 4 | 0;
 i3 = i7 + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 i6 = i5 + (i6 << 3) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i7 * 108 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 40, 4) | 0;
   i3 = i2 + 8 | 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP8[i2 + 36 >> 0] = 1;
   HEAP8[i2 + 37 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclERKNS_24PxShapeMaterialsPropertyEj(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = i2 + -1 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0)) {
   i2 = HEAP32[i7 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i4 + (i3 << 3) >> 2] | 0);
   i2 = HEAP32[i7 >> 2] | 0;
   HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP32[i2 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = 1;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  } else i3 = i1;
 }
 HEAP32[i5 >> 2] = gb + 672885;
 HEAP8[i5 + 4 >> 0] = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = i5;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i5 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx2Sn20handleShapeMaterialsINS0_21RepXVisitorWriterBaseINS_7PxShapeEEEEEvRT_RKNS_24PxShapeMaterialsPropertyE(i7, i6);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 0] | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 do {
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
  i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i5 + 12 >> 2] = i1;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i5 + 11 >> 0] = i4;
   if (!i4) i1 = i5; else {
    i1 = i5;
    i11 = 8;
   }
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i4 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i1;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i5 + 4 >> 2] = i4;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i2 = i3 + 16 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i12 = i5 + 16 | 0;
  HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i12 + 4 >> 2] = i4;
  i3 = i3 + 24 | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + 24 | 0;
  HEAP32[i6 >> 2] = i5;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 112 | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 113 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 104 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5;
 i7 = i5 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i11 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i11 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i6 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 60 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i11 = i9;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 i8 = HEAP32[i2 + 20 >> 2] | 0;
 i10 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i10 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i10) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_(i3, i9, i7);
 __ZN9JSONWrite8TransferI17AnimationCurveTplIfEEEvRT_PKc17TransferMetaFlags(i8, i7, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 i1 = i7 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z17FreeStaticQueriesv() {
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 >> 2] | 0);
 HEAP32[gb + 1459460 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 4 >> 2] | 0);
 HEAP32[gb + 1459460 + 4 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 8 >> 2] | 0);
 HEAP32[gb + 1459460 + 8 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 12 >> 2] | 0);
 HEAP32[gb + 1459460 + 12 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 16 >> 2] | 0);
 HEAP32[gb + 1459460 + 16 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 20 >> 2] | 0);
 HEAP32[gb + 1459460 + 20 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 24 >> 2] | 0);
 HEAP32[gb + 1459460 + 24 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 28 >> 2] | 0);
 HEAP32[gb + 1459460 + 28 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 32 >> 2] | 0);
 HEAP32[gb + 1459460 + 32 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 36 >> 2] | 0);
 HEAP32[gb + 1459460 + 36 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 40 >> 2] | 0);
 HEAP32[gb + 1459460 + 40 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 44 >> 2] | 0);
 HEAP32[gb + 1459460 + 44 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 48 >> 2] | 0);
 HEAP32[gb + 1459460 + 48 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 52 >> 2] | 0);
 HEAP32[gb + 1459460 + 52 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 56 >> 2] | 0);
 HEAP32[gb + 1459460 + 56 >> 2] = 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[gb + 1459460 + 60 >> 2] | 0);
 HEAP32[gb + 1459460 + 60 >> 2] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj477ENS_22PxRepXPropertyAccessorILj477ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 280 | 0;
 i7 = i10 + 168 | 0;
 i4 = i10 + 140 | 0;
 i8 = i10 + 112 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 160; else i1 = (HEAP32[i1 >> 2] | 0) + 160 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx29PxJointLimitConeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f11 = f0;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 f7 = Math_fround(HEAP16[i1 + (i9 << 2) >> 1] | 0);
 f4 = Math_fround(HEAP16[i1 + (i9 + 1 << 2) >> 1] | 0);
 i3 = (HEAP32[i10 + 48 >> 2] | 0) + i9 | 0;
 f5 = Math_fround(HEAP16[i1 + (i3 << 2) >> 1] | 0);
 f6 = Math_fround(HEAP16[i1 + (i3 + 1 << 2) >> 1] | 0);
 f11 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 if (f11 < f6 & (f11 < f5 & (f11 < f7 & f11 < f4))) {
  i10 = 1;
  return i10 | 0;
 }
 f11 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 if (f11 > f6 & (f11 > f5 & (f11 > f7 & f11 > f4))) {
  i10 = 1;
  return i10 | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 2 >> 0] & 127) != 127) {
  i2 = i9 << 1;
  i3 = i10 + 156 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  do if ((i1 | 0) == 16) {
   i1 = HEAP32[i10 + 12 >> 2] | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, i10 + 92 | 0) | 0) {
    HEAP32[i3 >> 2] = 0;
    i1 = 0;
    break;
   } else {
    i10 = 0;
    return i10 | 0;
   }
  } while (0);
  HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 3 >> 0] & 127) == 127) {
  i10 = 1;
  return i10 | 0;
 }
 i2 = i9 << 1 | 1;
 i3 = i10 + 156 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == 16) {
  i9 = HEAP32[i10 + 12 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, 16, i10 + 92 | 0) | 0) {
   HEAP32[i3 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i10 = 0;
   return i10 | 0;
  }
 } while (0);
 HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE8pushBackEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i7 + 4 | 0;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 if ((i3 | 0) != 128) {
  i5 = i2;
  i6 = i1;
  i7 = i3;
  i4 = i5 + (i6 << 3) + 4 | 0;
  i3 = i7 + 1 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i5 + (i6 << 3) | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + (i7 * 20 | 0) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 do if ((i1 + 1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = mftCall_iiiiii(i2 | 0, i3 | 0, 2560, (i1 ? gb + 714537 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 235) | 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i7 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i2 = i4;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i7, i4) | 0;
   break;
  }
 } while (0);
 i4 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 HEAP32[i6 >> 2] = i4;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i4 << 3) + 4 >> 2] = 0;
 i6 = i4;
 i7 = 0;
 i4 = i5 + (i6 << 3) + 4 | 0;
 i3 = i7 + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 i6 = i5 + (i6 << 3) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i7 * 20 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator9InsertTabEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i4 + 312 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + 1;
 if (!i6) HEAP32[i4 + 276 >> 2] = HEAP32[i4 + 260 >> 2];
 i2 = i4 + 320 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = i4 + 236 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 f8 = Math_fround(f3 / Math_fround(i7 | 0));
 i6 = f8 >= Math_fround(0.0);
 f1 = Math_fround(f8 + Math_fround(-.99999994));
 i6 = ~~(i6 ? f8 : f1) + 1 | 0;
 f1 = Math_fround(Math_imul(i6, i7) | 0);
 if (HEAP8[i4 + 229 >> 0] | 0) {
  f8 = Math_fround(HEAPF32[i4 + 248 >> 2]);
  f1 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f1 * f8) + Math_fround(.5)))) / f8);
 }
 f8 = Math_fround(f1 - f3);
 HEAPF32[(HEAP32[i4 + 376 >> 2] | 0) + (HEAP32[i4 + 260 >> 2] << 2) >> 2] = f8;
 HEAPF32[i2 >> 2] = f1;
 HEAPF32[i4 + 300 >> 2] = f1;
 i7 = i4 + 436 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i11 = i9 + 60 | 0;
 i10 = i9 + 120 | 0;
 i12 = i9 + 180 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 _memmove(i10 | 0, i2 | 0, 12) | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 240;
 HEAPF32[i4 + 304 >> 2] = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i4 + 220 >> 2]);
 if (!(f1 > Math_fround(0.0))) {
  i12 = 1;
  return i12 | 0;
 }
 if (!(Math_fround(Math_imul(HEAP32[i5 >> 2] | 0, i6) | 0) > f1)) {
  i12 = 1;
  return i12 | 0;
 }
 i12 = __ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv(i4) | 0;
 return i12 | 0;
}

function __ZL16PresizeOutputJobP25ScheduleSceneNodesJobData(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1110716 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110716 | 0, i1);
  i3 = gb + 1110716 | 0;
 } else i3 = 0;
 i4 = i6 + 2732 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i5 = i6 + 2736 | 0;
  i1 = 0;
  i2 = 0;
  do {
   HEAP32[i6 + 2700 + (i1 << 2) >> 2] = i2;
   i2 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 16 + (i1 * 12 | 0) + 4 >> 2] | 0) + i2 | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 HEAP8[i6 + 2720 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 28560 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2721 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 29332 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2722 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 30104 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2723 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 30876 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2724 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 31648 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2725 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 32420 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2726 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 33192 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2727 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 33964 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2728 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 34736 >> 2] | 0) != 0 & 1;
 HEAP8[i6 + 2729 >> 0] = (HEAP32[(__ZN15GlobalCallbacks3GetEv() | 0) + 35508 >> 2] | 0) != 0 & 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i7;
 return;
}

function _UNITY_FT_Vector_NormLen(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = (i3 | 0) < 0;
 i5 = i11 ? 0 - i3 | 0 : i3;
 i3 = i3 >> 31;
 i12 = (i2 | 0) < 0;
 i4 = i12 ? 0 - i2 | 0 : i2;
 i1 = (i4 | 0) == 0;
 if (!i5) {
  if (i1) {
   i12 = 0;
   return i12 | 0;
  }
  HEAP32[i10 >> 2] = i2 >> 31 << 16 | 65536;
  i12 = i4;
  return i12 | 0;
 }
 if (i1) {
  HEAP32[i9 >> 2] = i3 << 16 | 65536;
  i12 = i5;
  return i12 | 0;
 }
 i1 = i5 >>> 0 > i4 >>> 0 ? (i4 >>> 1) + i5 | 0 : i4 + (i5 >>> 1) | 0;
 i6 = i1 >>> 0 > 65535;
 i7 = i6 ? i1 >>> 16 : i1;
 i6 = i6 ? 16 : 0;
 i8 = (i7 & 65280 | 0) == 0;
 i7 = i8 ? i7 : i7 >>> 8;
 i6 = i8 ? i6 : i6 | 8;
 i8 = (i7 & 240 | 0) == 0;
 i7 = i8 ? i7 : i7 >>> 4;
 i6 = i8 ? i6 : i6 | 4;
 i8 = (i7 & 12 | 0) == 0;
 i7 = 31 - (i8 ? i6 : i6 | 2) - ((i8 ? i7 : i7 >>> 2) >>> 1 & 1) | 0;
 i7 = i7 - (i1 >>> 0 >= -1431655766 >>> i7 >>> 0 ? 16 : 15) | 0;
 i8 = (i7 | 0) > 0;
 if (i8) {
  i5 = i5 << i7;
  i6 = i4 << i7;
  i1 = i5 >>> 0 > i6 >>> 0 ? (i6 >>> 1) + i5 | 0 : (i5 >>> 1) + i6 | 0;
 } else {
  i3 = 0 - i7 | 0;
  i1 = i1 >>> i3;
  i6 = i4 >>> i3;
  i5 = i5 >>> i3;
 }
 i1 = 65536 - i1 | 0;
 while (1) {
  i2 = ((Math_imul(i1, i5) | 0) >> 16) + i5 | 0;
  i3 = ((Math_imul(i1, i6) | 0) >> 16) + i6 | 0;
  i4 = Math_imul(((Math_imul(i2, i2) | 0) + (Math_imul(i3, i3) | 0) | 0) / -512 | 0, i1 + 65536 >> 8) | 0;
  if ((i4 | 0) > 65535) i1 = ((i4 | 0) / 65536 | 0) + i1 | 0; else break;
 }
 HEAP32[i9 >> 2] = i11 ? 0 - i2 | 0 : i2;
 HEAP32[i10 >> 2] = i12 ? 0 - i3 | 0 : i3;
 i1 = (((Math_imul(i2, i5) | 0) + (Math_imul(i3, i6) | 0) | 0) / 65536 | 0) + 65536 | 0;
 if (i8) {
  i12 = (i1 + (1 << i7 + -1) | 0) >>> i7;
  return i12 | 0;
 } else {
  i12 = i1 << 0 - i7;
  return i12 | 0;
 }
 return 0;
}

function _ft_var_readpackedpoints(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i2 = HEAP32[i8 + 28 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i7 = _UNITY_FT_Stream_GetChar(i8) | 0;
 i1 = i7 & 255;
 if (!(i7 << 24 >> 24)) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(i1 & 128)) i7 = i1; else i7 = (_UNITY_FT_Stream_GetChar(i8) | 0) & 255 | i1 << 8 & 32512;
 i1 = _UNITY_ft_mem_realloc(i2, 2, 0, i7, 0, i4) | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = i7;
 if (!i7) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 } else i2 = 0;
 while (1) {
  i5 = _UNITY_FT_Stream_GetChar(i8) | 0;
  i6 = i5 & 255;
  if (!(i6 & 128)) {
   i4 = (_UNITY_FT_Stream_GetChar(i8) | 0) & 255;
   i3 = i2 + 1 | 0;
   HEAP16[i1 + (i2 << 1) >> 1] = i4;
   i2 = i6 + i3 | 0;
   if (i5 << 24 >> 24 == 0 | i2 >>> 0 > i7 >>> 0) {
    i2 = 12;
    break;
   } else i5 = 0;
   while (1) {
    i4 = ((_UNITY_FT_Stream_GetChar(i8) | 0) & 255) + (i4 & 65535) & 65535;
    HEAP16[i1 + (i3 << 1) >> 1] = i4;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
   }
  } else {
   i6 = i6 & 127;
   i4 = _UNITY_FT_Stream_GetUShort(i8) | 0;
   i3 = i2 + 1 | 0;
   HEAP16[i1 + (i2 << 1) >> 1] = i4;
   i2 = i6 + i3 | 0;
   if ((i6 | 0) == 0 | i2 >>> 0 > i7 >>> 0) {
    i2 = 12;
    break;
   } else i5 = 0;
   while (1) {
    i4 = ((_UNITY_FT_Stream_GetUShort(i8) | 0) & 65535) + (i4 & 65535) & 65535;
    HEAP16[i1 + (i3 << 1) >> 1] = i4;
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
   }
  }
  if (i2 >>> 0 >= i7 >>> 0) {
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) {
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function _ft_get_adobe_glyph_index(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 if (!((i1 | 0) != 0 & i1 >>> 0 < i12 >>> 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i9 = i1 + 1 | 0;
 i6 = HEAP8[i1 >> 0] | 0;
 i3 = 52;
 i4 = 0;
 while (1) {
  i7 = i3 + i4 >> 1;
  i2 = (i7 << 1) + (gb + 950903 + 2) | 0;
  i2 = (HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0]) + (gb + 950903) | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  i5 = i1 & 127;
  if ((i5 | 0) == (i6 | 0)) break;
  i5 = (i5 | 0) < (i6 | 0);
  i4 = i5 ? i7 + 1 | 0 : i4;
  i3 = i5 ? i3 : i7;
  if ((i4 | 0) >= (i3 | 0)) {
   i8 = 0;
   i10 = 16;
   break;
  }
 }
 if ((i10 | 0) == 16) return i8 | 0;
 L10 : do if (i9 >>> 0 < i12 >>> 0) {
  L11 : while (1) {
   i7 = HEAP8[i9 >> 0] | 0;
   i9 = i9 + 1 | 0;
   i3 = i2 + 1 | 0;
   i5 = HEAP8[i3 >> 0] | 0;
   i6 = i5 & 255;
   i4 = i6 & 127;
   L13 : do if (i1 << 24 >> 24 < 0) if ((i7 | 0) == (i4 | 0)) {
    i2 = i3;
    i1 = i5;
   } else {
    i8 = 0;
    i10 = 16;
    break L11;
   } else {
    if (!i4) {
     i8 = 0;
     i10 = 16;
     break L11;
    }
    i3 = i2 + (i6 >>> 6 | 1) + 1 | 0;
    while (1) {
     i2 = (HEAPU8[i3 >> 0] << 8 | HEAPU8[i3 + 1 >> 0]) + (gb + 950903) | 0;
     i1 = HEAP8[i2 >> 0] | 0;
     if ((i7 | 0) == (i1 & 127 | 0)) break L13;
     if ((i4 | 0) > 1) {
      i4 = i4 + -1 | 0;
      i3 = i3 + 2 | 0;
     } else {
      i8 = 0;
      i10 = 16;
      break L11;
     }
    }
   } while (0);
   if (i9 >>> 0 >= i12 >>> 0) {
    i11 = i2;
    i13 = i1;
    break L10;
   }
  }
  if ((i10 | 0) == 16) return i8 | 0;
 } else {
  i11 = i2;
  i13 = i1;
 } while (0);
 if (i13 << 24 >> 24 <= -1) {
  i13 = 0;
  return i13 | 0;
 }
 if ((HEAP8[i11 + 1 >> 0] | 0) >= 0) {
  i13 = 0;
  return i13 | 0;
 }
 i13 = HEAPU8[i11 + 2 >> 0] << 8 | HEAPU8[i11 + 3 >> 0];
 return i13 | 0;
}

function _fchmodat(i4, i5, i9, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 80 | 0;
 i11 = i13 + 64 | 0;
 i8 = i13 + 48 | 0;
 i6 = i13 + 32 | 0;
 i3 = i13 + 16 | 0;
 i2 = i13;
 i7 = i13 + 84 | 0;
 i10 = i13 + 160 | 0;
 switch (i1 | 0) {
 case 0:
  {
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i5;
   HEAP32[i2 + 8 >> 2] = i9;
   HEAP32[i2 + 12 >> 2] = 0;
   i1 = ___syscall_ret(___syscall306(306, i2 | 0) | 0) | 0;
   break;
  }
 case 256:
  {
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i5;
   HEAP32[i3 + 8 >> 2] = i7;
   HEAP32[i3 + 12 >> 2] = 256;
   i1 = ___syscall300(300, i3 | 0) | 0;
   do if (!i1) {
    i3 = i7 + 12 | 0;
    if ((HEAP32[i3 >> 2] & 61440 | 0) == 40960) {
     i1 = ___syscall_ret(-95) | 0;
     break;
    }
    HEAP32[i6 >> 2] = i4;
    HEAP32[i6 + 4 >> 2] = i5;
    HEAP32[i6 + 8 >> 2] = 2752768;
    i2 = ___syscall295(295, i6 | 0) | 0;
    if ((i2 | 0) < 0) if ((i2 | 0) == -40) {
     i1 = ___syscall_ret(-95) | 0;
     break;
    } else {
     i1 = ___syscall_ret(i2) | 0;
     break;
    }
    ___procfdname(i10, i2);
    HEAP32[i8 >> 2] = -100;
    HEAP32[i8 + 4 >> 2] = i10;
    HEAP32[i8 + 8 >> 2] = i7;
    HEAP32[i8 + 12 >> 2] = 0;
    i1 = ___syscall300(300, i8 | 0) | 0;
    if (!i1) if ((HEAP32[i3 >> 2] & 61440 | 0) == 40960) i1 = -95; else {
     HEAP32[i11 >> 2] = -100;
     HEAP32[i11 + 4 >> 2] = i10;
     HEAP32[i11 + 8 >> 2] = i9;
     i1 = ___syscall306(306, i11 | 0) | 0;
    }
    HEAP32[i12 >> 2] = i2;
    ___syscall6(6, i12 | 0) | 0;
    i1 = ___syscall_ret(i1) | 0;
   } else i1 = ___syscall_ret(i1) | 0; while (0);
   break;
  }
 default:
  i1 = ___syscall_ret(-22) | 0;
 }
 STACKTOP = i13;
 return i1 | 0;
}

function __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 4 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 25;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 25;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) - i1 >> 4 >>> 0 >= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i1 >> 4;
 HEAP32[i7 + 12 >> 2] = 0;
 i6 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i7 >> 2] = i2;
 i10 = i2 + (i1 << 4) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i10;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 << 4);
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS7_RS8_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 1;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i8);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  HEAP32[i8 >> 2] = 1;
  HEAP32[i8 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i5) i4 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i3 | 0, i4 | 0, (i5 << 5) + 131 | 0, (i1 ? gb + 721601 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i4 = 0; else {
   i4 = i1 + 131 & -128;
   HEAP32[i4 + -4 >> 2] = i4 - i1;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i7 = i1 + 12 | 0;
   i8 = i2 + 12 | 0;
   i8 = HEAPU16[i8 >> 1] | HEAPU16[i8 + 2 >> 1] << 16;
   HEAP16[i7 >> 1] = i8;
   HEAP16[i7 + 2 >> 1] = i8 >>> 16;
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN5physx3Cct9SweepTestC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i3 + 120 | 0;
 i5 = i3 + 164 | 0;
 i6 = i3 + 224 | 0;
 i1 = i3 + 240 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i3;
 i7 = i6 + 44 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i1 = i3 + 244 | 0;
 i2 = i3 + 283 | 0;
 i6 = i1;
 i7 = i6 + 36 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP16[i1 + 36 >> 1] = 0;
 HEAP8[i1 + 38 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 HEAP8[i3 + 284 >> 0] = 0;
 HEAP32[i3 + 296 >> 2] = -1;
 i1 = i3 + 300 | 0;
 HEAP16[i1 >> 1] = 0;
 HEAP16[i1 + 2 >> 1] = 0;
 HEAP16[i1 + 4 >> 1] = 0;
 HEAP16[i1 + 6 >> 1] = 0;
 HEAP16[i1 + 8 >> 1] = 0;
 HEAP16[i1 + 10 >> 1] = 0;
 HEAPF64[i3 + 48 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i3 + 56 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i3 + 64 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i3 + 72 >> 3] = -1797693134862315708145274.0e284;
 HEAPF64[i3 + 80 >> 3] = -1797693134862315708145274.0e284;
 HEAPF64[i3 + 88 >> 3] = -1797693134862315708145274.0e284;
 i1 = i3 + 96 | 0;
 HEAP32[i3 + 156 >> 2] = 0;
 HEAP32[i3 + 160 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 + 152 >> 2] = -1;
 i1 = i3 + 288 | 0;
 i6 = i5;
 i7 = i6 + 60 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.5);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 return;
}

function __ZN5physx2Sc7BodySim18postSetWakeCounterEfb(i3, f2, i1) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (f2 > Math_fround(0.0) | i1) {
  i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i3 + 36 >> 2] | 0) | 0;
  i1 = i3 + 188 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i5 + 16 >> 2] | 0;
  i7 = i4 + (i3 * 12 | 0) + 8 | 0;
  i6 = HEAP8[i7 >> 0] | 0;
  HEAP8[i7 >> 0] = i6 & 255 | 8;
  do if (!(i6 & 8)) {
   i7 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i3 >>> 5 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i3 & 31);
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
    i3 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    i1 = 1 << (i1 & 31);
    if (!(i4 & i1)) {
     HEAP32[i3 >> 2] = i4 | i1;
     break;
    } else {
     HEAP32[i3 >> 2] = i4 & ~i1;
     break;
    }
   }
  } while (0);
  HEAP8[i5 + 477 >> 0] = 1;
  return;
 }
 if (!(__ZN5physx2Sc7BodySim37checkSleepReadinessBesidesWakeCounterEv(i3) | 0)) return;
 i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i3 + 36 >> 2] | 0) | 0;
 i1 = i3 + 188 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i6 = i4 + (i3 * 12 | 0) + 8 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i7 & 247;
 do if (i7 & 8) {
  i7 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i3 >>> 5 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << (i3 & 31));
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i3 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i4 & i1)) {
    HEAP32[i3 >> 2] = i4 | i1;
    break;
   } else {
    HEAP32[i3 >> 2] = i4 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i5 + 477 >> 0] = 1;
 return;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f11 = f0;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 f7 = Math_fround(HEAP16[i1 + (i9 << 2) >> 1] | 0);
 f4 = Math_fround(HEAP16[i1 + (i9 + 1 << 2) >> 1] | 0);
 i3 = (HEAP32[i10 + 48 >> 2] | 0) + i9 | 0;
 f5 = Math_fround(HEAP16[i1 + (i3 << 2) >> 1] | 0);
 f6 = Math_fround(HEAP16[i1 + (i3 + 1 << 2) >> 1] | 0);
 f11 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 if (f11 < f6 & (f11 < f5 & (f11 < f7 & f11 < f4))) {
  i10 = 1;
  return i10 | 0;
 }
 f11 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 if (f11 > f6 & (f11 > f5 & (f11 > f7 & f11 > f4))) {
  i10 = 1;
  return i10 | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 2 >> 0] & 127) != 127) {
  i2 = i9 << 1;
  i3 = i10 + 156 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  do if ((i1 | 0) == 16) {
   i1 = HEAP32[i10 + 12 >> 2] | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, i10 + 92 | 0) | 0) {
    HEAP32[i3 >> 2] = 0;
    i1 = 0;
    break;
   } else {
    i10 = 0;
    return i10 | 0;
   }
  } while (0);
  HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 3 >> 0] & 127) == 127) {
  i10 = 1;
  return i10 | 0;
 }
 i2 = i9 << 1 | 1;
 i3 = i10 + 156 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == 16) {
  i9 = HEAP32[i10 + 12 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, 16, i10 + 92 | 0) | 0) {
   HEAP32[i3 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i10 = 0;
   return i10 | 0;
  }
 } while (0);
 HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 62; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN14EdgeCollider2D15TransformPointsERK10Matrix4x4fP6b2Vec2(i2, i8, i3) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i16 = HEAP32[i2 + 172 >> 2] | 0;
 if (!i16) {
  i19 = 0;
  return i19 | 0;
 }
 i17 = i2 + 40 | 0;
 i18 = i2 + 44 | 0;
 i9 = i8 + 16 | 0;
 i10 = i8 + 32 | 0;
 i11 = i8 + 48 | 0;
 i12 = i8 + 4 | 0;
 i13 = i8 + 20 | 0;
 i14 = i8 + 36 | 0;
 i15 = i8 + 52 | 0;
 i7 = 0;
 i1 = 0;
 i6 = HEAP32[i2 + 160 >> 2] | 0;
 i2 = i3;
 while (1) {
  f20 = Math_fround(HEAPF32[i6 >> 2]);
  f20 = Math_fround(f20 + Math_fround(HEAPF32[i17 >> 2]));
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i18 >> 2]));
  f4 = Math_fround(f20 * Math_fround(HEAPF32[i8 >> 2]));
  f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2])));
  f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * Math_fround(0.0)));
  f4 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f4);
  f20 = Math_fround(f20 * Math_fround(HEAPF32[i12 >> 2]));
  f5 = Math_fround(f20 + Math_fround(f5 * Math_fround(HEAPF32[i13 >> 2])));
  f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i14 >> 2]) * Math_fround(0.0)));
  f5 = Math_fround(Math_fround(HEAPF32[i15 >> 2]) + f5);
  if ((i1 | 0) > 0) {
   f21 = Math_fround(Math_fround(HEAPF32[i2 + -8 >> 2]) - f4);
   f20 = Math_fround(Math_fround(HEAPF32[i2 + -4 >> 2]) - f5);
   if (!(Math_fround(Math_fround(f21 * f21) + Math_fround(f20 * f20)) <= Math_fround(.000050249997))) i19 = 6;
  } else i19 = 6;
  if ((i19 | 0) == 6) {
   i19 = 0;
   HEAPF32[i2 >> 2] = f4;
   HEAPF32[i2 + 4 >> 2] = f5;
   i1 = i1 + 1 | 0;
   i2 = i2 + 8 | 0;
  }
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == (i16 | 0)) break; else i6 = i6 + 8 | 0;
 }
 return i1 | 0;
}

function __ZN13MonoBehaviour9CallAwakeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 256 | 0;
 i5 = i9 + 248 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP8[i4 + 140 >> 0] = 1;
 i2 = i4 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 if (i3) {
  i11 = HEAP32[i1 + 36 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i10 = i7;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i1, i8);
  HEAP8[i6 + 233 >> 0] = 1;
  HEAP32[i6 + 216 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i6);
  __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i6, i5) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i10 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 i11 = i7;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i1, i8);
 HEAP8[i6 + 233 >> 0] = 1;
 HEAP32[i6 + 216 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i6);
 __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i6, i5) | 0;
 if ((i1 | 0) == 0 | (HEAP32[i5 >> 2] | 0) == 0) {
  STACKTOP = i9;
  return;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  STACKTOP = i9;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 116 >> 2] | 0, i4 | 0, 0);
 STACKTOP = i9;
 return;
}

function __Z20IntersectionAABBAABBRK10MinMaxAABBS1_PS_(i1, i2, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, f15 = f0, f16 = f0;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 i13 = i2 + 12 | 0;
 if (f12 > Math_fround(HEAPF32[i13 >> 2])) {
  i14 = 0;
  return i14 | 0;
 }
 i14 = i1 + 12 | 0;
 f16 = Math_fround(HEAPF32[i14 >> 2]);
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 if (f16 < f15) {
  i14 = 0;
  return i14 | 0;
 }
 i3 = i1 + 4 | 0;
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i2 + 16 | 0;
 if (f16 > Math_fround(HEAPF32[i4 >> 2])) {
  i14 = 0;
  return i14 | 0;
 }
 i5 = i1 + 16 | 0;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i2 + 4 | 0;
 if (f16 < Math_fround(HEAPF32[i6 >> 2])) {
  i14 = 0;
  return i14 | 0;
 }
 i8 = i1 + 8 | 0;
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = i2 + 20 | 0;
 if (f16 > Math_fround(HEAPF32[i9 >> 2])) {
  i14 = 0;
  return i14 | 0;
 }
 i10 = i1 + 20 | 0;
 f16 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i2 + 8 | 0;
 if (f16 < Math_fround(HEAPF32[i11 >> 2])) {
  i14 = 0;
  return i14 | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[(f12 < f15 ? i2 : i1) >> 2];
 f16 = Math_fround(HEAPF32[i13 >> 2]);
 i2 = f16 < Math_fround(HEAPF32[i14 >> 2]);
 HEAP32[i7 + 12 >> 2] = HEAP32[(i2 ? i13 : i14) >> 2];
 f16 = Math_fround(HEAPF32[i3 >> 2]);
 i14 = f16 < Math_fround(HEAPF32[i6 >> 2]);
 HEAP32[i7 + 4 >> 2] = HEAP32[(i14 ? i6 : i3) >> 2];
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 i14 = f16 < Math_fround(HEAPF32[i5 >> 2]);
 HEAP32[i7 + 16 >> 2] = HEAP32[(i14 ? i4 : i5) >> 2];
 f16 = Math_fround(HEAPF32[i8 >> 2]);
 i14 = f16 < Math_fround(HEAPF32[i11 >> 2]);
 HEAP32[i7 + 8 >> 2] = HEAP32[(i14 ? i11 : i8) >> 2];
 f16 = Math_fround(HEAPF32[i9 >> 2]);
 i14 = f16 < Math_fround(HEAPF32[i10 >> 2]);
 HEAP32[i7 + 20 >> 2] = HEAP32[(i14 ? i9 : i10) >> 2];
 i14 = 1;
 return i14 | 0;
}

function __ZN5physx16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE8pushBackEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i7 + 4 | 0;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 if ((i3 | 0) != 128) {
  i5 = i2;
  i6 = i1;
  i7 = i3;
  i4 = i5 + (i6 << 3) + 4 | 0;
  i3 = i7 + 1 | 0;
  HEAP32[i4 >> 2] = i3;
  i6 = i5 + (i6 << 3) | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + (i7 << 3) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 do if ((i1 + 1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = mftCall_iiiiii(i2 | 0, i3 | 0, 1024, (i1 ? gb + 714801 | 0 : gb + 837976 | 0) | 0, gb + 714719 | 0, 235) | 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i7 + 8 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
   i2 = i4;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i7, i4) | 0;
   break;
  }
 } while (0);
 i4 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 HEAP32[i6 >> 2] = i4;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 + (i4 << 3) + 4 >> 2] = 0;
 i6 = i4;
 i7 = 0;
 i4 = i5 + (i6 << 3) + 4 | 0;
 i3 = i7 + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 i6 = i5 + (i6 << 3) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i7 << 3) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN4FMOD5Sound9getLengthEPjj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 16 | 0;
 i4 = i10 + 8 | 0;
 i3 = i10;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   L6 : do if (!i5) {
    HEAP32[i4 >> 2] = 37;
    HEAP32[i4 + 4 >> 2] = gb + 868952;
    _printf(gb + 853277 | 0, i4) | 0;
   } else {
    i1 = _JS_Sound_GetLength(HEAP32[i2 + 320 >> 2] | 0) | 0;
    switch (i6 | 0) {
    case 2:
     {
      HEAP32[i5 >> 2] = i1;
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
    case 1:
     {
      HEAP32[i5 >> 2] = ~~(+(i1 >>> 0) * 1.0e3 / 44100.0) >>> 0;
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
    case 4:
     {
      HEAP32[i5 >> 2] = i1 << 2;
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
    case 8:
     {
      HEAP32[i5 >> 2] = i1 << 2;
      i9 = 0;
      STACKTOP = i10;
      return i9 | 0;
     }
    default:
     {
      HEAP32[i9 >> 2] = gb + 868952;
      HEAP32[i9 + 4 >> 2] = 1275;
      _printf(gb + 854600 | 0, i9) | 0;
      HEAP32[i7 >> 2] = 37;
      HEAP32[i7 + 4 >> 2] = gb + 868952;
      _printf(gb + 853277 | 0, i7) | 0;
      break L6;
     }
    }
   } while (0);
   HEAP32[i8 >> 2] = 37;
   HEAP32[i8 + 4 >> 2] = gb + 868952;
   _printf(gb + 853343 | 0, i8) | 0;
   i9 = 37;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868952;
 _printf(gb + 853184 | 0, i3) | 0;
 i9 = 36;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN14HeightMeshData8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 843803 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 843814 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 898103 | 0, gb + 1034406 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 843824 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 24 | 0;
 i12 = i14;
 i13 = i10 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if ((((HEAP32[i13 >> 2] | 0) - i5 | 0) / 60 | 0) >>> 0 >= i7 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i1 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i1;
 if (!i7) {
  i6 = 0;
  i3 = i4;
  i8 = i5;
  i2 = i4;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = 25;
  HEAP32[i2 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 60 | 0, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
  i8 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i6;
 i1 = i6 + (((i4 - i5 | 0) / 60 | 0) * 60 | 0) | 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i9 = i12 + 12 | 0;
 HEAP32[i9 >> 2] = i6 + (i7 * 60 | 0);
 if ((i3 | 0) != (i8 | 0)) {
  i2 = i3;
  do {
   i2 = i2 + -60 | 0;
   __ZN13AnimationClip9PPtrCurveC2ERKS0_(i1 + -60 | 0, i2);
   i1 = (HEAP32[i5 >> 2] | 0) + -60 | 0;
   HEAP32[i5 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__214__split_bufferIN13AnimationClip9PPtrCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i5 + 16 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i7 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i6 >> 0] = i1;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = i1;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP8[i6 >> 0];
 i1 = i5 + 32 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = i5 + 16 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i7 + 24 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i5 + 24 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
  i2 = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i4 = i5 + 28 | 0;
 i1 = HEAP32[i4 >> 2] & 255;
 HEAP8[i6 >> 0] = i1;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = i1;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP8[i6 >> 0];
 i1 = i5 + 32 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Gu26checkOverlapSphere_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 + 36 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 40 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + 12 >> 2];
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(f10 + f10);
 f8 = Math_fround(f9 + f9);
 f13 = Math_fround(f16 + f16);
 f15 = Math_fround(f9 * f8);
 f14 = Math_fround(f16 * f13);
 f9 = Math_fround(f6 * f9);
 f17 = Math_fround(f6 * f16);
 f7 = Math_fround(f6 * f11);
 f16 = Math_fround(f8 * f16);
 f8 = Math_fround(f8 * f11);
 f11 = Math_fround(f13 * f11);
 f13 = Math_fround(f9 + f11);
 f12 = Math_fround(f17 - f8);
 f11 = Math_fround(f9 - f11);
 f6 = Math_fround(Math_fround(1.0) - Math_fround(f10 * f6));
 f10 = Math_fround(f6 - f14);
 f9 = Math_fround(f16 + f7);
 f8 = Math_fround(f17 + f8);
 f7 = Math_fround(f16 - f7);
 f6 = Math_fround(f6 - f15);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f15) - f14);
 HEAPF32[i5 + 4 >> 2] = f13;
 HEAPF32[i5 + 8 >> 2] = f12;
 HEAPF32[i5 + 12 >> 2] = f11;
 HEAPF32[i5 + 16 >> 2] = f10;
 HEAPF32[i5 + 20 >> 2] = f9;
 HEAPF32[i5 + 24 >> 2] = f8;
 HEAPF32[i5 + 28 >> 2] = f7;
 HEAPF32[i5 + 32 >> 2] = f6;
 i3 = __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i3, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z10WriteArrayIN12ProfilerData17AllocatedGCMemoryEEvR13dynamic_arrayIiLj4EERKS2_IT_Xsr11AlignOfTypeIS5_EE5alignEE(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4 + (i2 << 1 & 1073741822) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 _memcpy(i1 + (i4 << 2) | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
 return;
}

function __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEC2ERKS5_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i8 = i4 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i2 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i7 = i5 + 4 | 0;
 i6 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 if ((i6 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = 16;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i1 + (((i6 | 0) / 52 | 0) * 52 | 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i5 = i2;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i1;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  i7 = i1 + 32 | 0;
  i6 = i2 + 32 | 0;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  i2 = i2 + 52 | 0;
  i1 = (HEAP32[i8 >> 2] | 0) + 52 | 0;
  HEAP32[i8 >> 2] = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i9;
 return;
}

function __ZN9ShaderLab26SerializedShaderDependencyaSERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i9 | 0) == (i8 | 0)) return i9 | 0;
 i5 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i6 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i5 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i5 & 255;
 i3 = i9 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 do if (i5 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i5 - i4 | 0, i1, 0, i1, i5, i6);
 } else {
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i5 | 0) _memmove(i1 | 0, i6 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 i1 = i9 + 16 | 0;
 i7 = i8 + 16 | 0;
 i6 = HEAP8[i7 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i4 ? HEAP32[i8 + 20 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i9 + 24 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i9 + 20 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
  return i9 | 0;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i9 + 20 >> 2] = i6;
  return i9 | 0;
 } else {
  HEAP8[i4 >> 0] = i6;
  return i9 | 0;
 }
 return 0;
}

function __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f11 = f0;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 f7 = Math_fround(HEAP16[i1 + (i9 << 2) >> 1] | 0);
 f4 = Math_fround(HEAP16[i1 + (i9 + 1 << 2) >> 1] | 0);
 i3 = (HEAP32[i10 + 48 >> 2] | 0) + i9 | 0;
 f5 = Math_fround(HEAP16[i1 + (i3 << 2) >> 1] | 0);
 f6 = Math_fround(HEAP16[i1 + (i3 + 1 << 2) >> 1] | 0);
 f11 = Math_fround(HEAPF32[i10 + 28 >> 2]);
 if (f11 < f6 & (f11 < f5 & (f11 < f7 & f11 < f4))) {
  i10 = 1;
  return i10 | 0;
 }
 f11 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 if (f11 > f6 & (f11 > f5 & (f11 > f7 & f11 > f4))) {
  i10 = 1;
  return i10 | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 2 >> 0] & 127) != 127) {
  i2 = i9 << 1;
  i3 = i10 + 156 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  do if ((i1 | 0) == 16) {
   i1 = HEAP32[i10 + 12 >> 2] | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 16, i10 + 92 | 0) | 0) {
    HEAP32[i3 >> 2] = 0;
    i1 = 0;
    break;
   } else {
    i10 = 0;
    return i10 | 0;
   }
  } while (0);
  HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0;
 }
 if ((HEAP8[i1 + (i9 << 2) + 3 >> 0] & 127) == 127) {
  i10 = 1;
  return i10 | 0;
 }
 i2 = i9 << 1 | 1;
 i3 = i10 + 156 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == 16) {
  i9 = HEAP32[i10 + 12 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, 16, i10 + 92 | 0) | 0) {
   HEAP32[i3 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i10 = 0;
   return i10 | 0;
  }
 } while (0);
 HEAP32[i10 + 92 + (i1 << 2) >> 2] = i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx26solveContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i4, i3, i7, i8, i1, i6) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = i7 + 16 | 0;
 if (i3 >>> 0 > 1) {
  i1 = 1;
  do {
   i5 = i1 + -1 | 0;
   i10 = i4 + (i5 << 5) | 0;
   i11 = HEAP32[i2 >> 2] | 0;
   i9 = i11 + ((HEAPU16[i4 + (i5 << 5) + 10 >> 1] | 0) << 6) | 0;
   i5 = i11 + ((HEAPU16[i4 + (i5 << 5) + 14 >> 1] | 0) << 6) | 0;
   __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i10, i7);
   __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i10, i7, i9, i5);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = i3 + -1 | 0;
 i11 = i4 + (i5 << 5) | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i1 = i10 + ((HEAPU16[i4 + (i5 << 5) + 10 >> 1] | 0) << 6) | 0;
 i5 = i10 + ((HEAPU16[i4 + (i5 << 5) + 14 >> 1] | 0) << 6) | 0;
 __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i11, i7);
 __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i11, i7, i1, i5);
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i7 + 12 >> 2] | 0) + -4 | 0) >>> 0) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i6, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i11 = i8 + (i4 + i2 << 4) | 0;
   i10 = i1 + (i2 << 4) | 0;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 24 | 0;
 i12 = i14;
 i13 = i10 + 8 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if ((((HEAP32[i13 >> 2] | 0) - i5 | 0) / 88 | 0) >>> 0 >= i7 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i1 = i10 + 12 | 0;
 i11 = i10 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = i1;
 if (!i7) {
  i6 = 0;
  i3 = i4;
  i8 = i5;
  i2 = i4;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = 25;
  HEAP32[i2 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 88 | 0, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2;
  i8 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i6;
 i1 = i6 + (((i4 - i5 | 0) / 88 | 0) * 88 | 0) | 0;
 i4 = i12 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i12 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i9 = i12 + 12 | 0;
 HEAP32[i9 >> 2] = i6 + (i7 * 88 | 0);
 if ((i3 | 0) != (i8 | 0)) {
  i2 = i3;
  do {
   i2 = i2 + -88 | 0;
   __ZN24CompressedAnimationCurveC2ERKS_(i1 + -88 | 0, i2);
   i1 = (HEAP32[i5 >> 2] | 0) + -88 | 0;
   HEAP32[i5 >> 2] = i1;
  } while ((i2 | 0) != (i8 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i11 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__214__split_bufferI24CompressedAnimationCurveR13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i12);
 STACKTOP = i14;
 return;
}

function __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 _memcpy(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, ((i7 | 0) == 0 ? 0 : i7 + i8 | 0) | 0, (i5 >>> 0 < i6 >>> 0 ? i5 : i6) * 12 | 0) | 0;
 i6 = i1 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i8 = i2 + 12 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 _memcpy(((i7 | 0) == 0 ? 0 : i7 + i8 | 0) | 0, ((i5 | 0) == 0 ? 0 : i5 + i6 | 0) | 0, (i3 >>> 0 < i4 >>> 0 ? i3 : i4) << 4 | 0) | 0;
 i4 = i1 + 20 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i6 = i2 + 20 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 _memcpy(((i5 | 0) == 0 ? 0 : i5 + i6 | 0) | 0, ((i3 | 0) == 0 ? 0 : i3 + i4 | 0) | 0, (i8 >>> 0 < i7 >>> 0 ? i8 : i7) * 12 | 0) | 0;
 i7 = i1 + 28 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 28 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 + 24 >> 2] | 0;
 i5 = HEAP32[i2 + 24 >> 2] | 0;
 _memcpy(((i3 | 0) == 0 ? 0 : i3 + i4 | 0) | 0, ((i8 | 0) == 0 ? 0 : i8 + i7 | 0) | 0, (i6 >>> 0 < i5 >>> 0 ? i6 : i5) << 2 | 0) | 0;
 i5 = i1 + 36 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i2 + 36 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 _memcpy(((i8 | 0) == 0 ? 0 : i8 + i7 | 0) | 0, ((i6 | 0) == 0 ? 0 : i6 + i5 | 0) | 0, (i4 >>> 0 < i3 >>> 0 ? i4 : i3) << 2 | 0) | 0;
 i3 = i1 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i2 + 44 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 _memcpy(((i6 | 0) == 0 ? 0 : i6 + i5 | 0) | 0, ((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, (i1 >>> 0 < i2 >>> 0 ? i1 : i2) | 0) | 0;
 return;
}

function __ZN13GfxDeviceGLES15SetImageTextureE9TextureIDi(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i2, i1, i3);
  i2 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i2 = 0; else i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2 + 8 | 0;
 i7 = i1;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4 + 7296 | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 if (i9 >>> 0 < i8 >>> 0 | ((i9 | 0) == (i8 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0 : 0)) {
  i8 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i4 + 5480 >> 2] | 0, 4) | 0;
  i9 = i4 + 7376 | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i8;
 }
 i7 = i4 + 7368 | 0;
 i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, 1, 0) | 0;
 i8 = getTempRet0() | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i8;
 mftCall_viiiiiii(HEAP32[i4 + 4864 >> 2] | 0, i5 | 0, HEAP32[i2 >> 2] | 0, 0, 1, 0, 35001, HEAP32[i2 + 40 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __Z18BuildScriptClassIdRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 12 | 0;
 i3 = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 HEAP32[i5 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 __Z6FormatPKcz(i6, gb + 456776 | 0, i5);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i4 = i2 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i10, i7, i4, i3, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 11 | 0;
 i2 = HEAP8[i11 >> 0] | 0;
 i6 = i2 << 24 >> 24 < 0;
 if (i6) i9 = HEAP32[i10 + 4 >> 2] | 0; else i9 = i2 & 255;
 if (i9 >>> 0 < i7 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i10);
 i5 = i9 - i7 | 0;
 i2 = i5 >>> 0 < i4 >>> 0 ? i5 : i4;
 if (i6) i4 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if ((i2 - i9 + i4 | 0) >>> 0 < i1 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i10, i4, i9 + i1 - i2 - i4 | 0, i9, i7, i2, i1, i3); else {
  if (i6) i6 = HEAP32[i10 >> 2] | 0; else i6 = i10;
  do if ((i2 | 0) == (i1 | 0)) {
   i2 = i1;
   i4 = i7;
   i8 = 25;
  } else {
   i5 = i5 - i2 | 0;
   if (!i5) {
    i4 = i7;
    i8 = 25;
   } else {
    i4 = i6 + i7 | 0;
    if (i2 >>> 0 > i1 >>> 0) {
     if (i1 | 0) _memmove(i4 | 0, i3 | 0, i1 | 0) | 0;
     _memmove(i4 + i1 | 0, i4 + i2 | 0, i5 | 0) | 0;
     break;
    }
    do if (i4 >>> 0 < i3 >>> 0 & (i6 + i9 | 0) >>> 0 > i3 >>> 0) {
     if ((i4 + i2 | 0) >>> 0 <= i3 >>> 0) {
      i4 = i7;
      i3 = i3 + (i1 - i2) | 0;
      break;
     }
     if (i2 | 0) _memmove(i4 | 0, i3 | 0, i2 | 0) | 0;
     i4 = i2 + i7 | 0;
     i3 = i3 + i1 | 0;
     i1 = i1 - i2 | 0;
     i2 = 0;
    } else i4 = i7; while (0);
    i8 = i6 + i4 | 0;
    _memmove(i8 + i1 | 0, i8 + i2 | 0, i5 | 0) | 0;
    i8 = 25;
   }
  } while (0);
  if ((i8 | 0) == 25) if (!i1) i1 = 0; else _memmove(i6 + i4 | 0, i3 | 0, i1 | 0) | 0;
  i1 = i1 - i2 + i9 | 0;
  if ((HEAP8[i11 >> 0] | 0) < 0) HEAP32[i10 + 4 >> 2] = i1; else HEAP8[i11 >> 0] = i1;
  HEAP8[i6 + i1 >> 0] = 0;
 }
 return i10 | 0;
}

function __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i7, i5, i8, i1, i9) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) == -1) {
  HEAP32[i9 >> 2] = -1;
  HEAP32[i9 + 4 >> 2] = 3;
  HEAP32[i7 >> 2] = gb + 1170596;
  HEAP16[i7 + 4 >> 1] = 1;
  return;
 }
 if (i6 >>> 0 > 1073741823) {
  i8 = i6 & 1073741823;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i9 + 4 >> 2] = 2;
  HEAP32[i7 >> 2] = (__Z12GetGfxDevicev() | 0) + 4 + (i8 << 4);
  HEAP16[i7 + 4 >> 1] = 1;
  return;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 L9 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L9;
  }
  if ((i1 | 0) > -1) {
   i8 = HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 0;
   HEAP32[i7 >> 2] = (HEAP32[i5 + 72 >> 2] | 0) + (i8 & 1048575);
   HEAP16[i7 + 4 >> 1] = i8 >>> 20 & 1023;
   return;
  }
 } while (0);
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 L18 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i8 + 32 >> 2] | 0;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) break L18;
  }
  if ((i1 | 0) > -1) {
   i6 = HEAP32[(HEAP32[i8 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   HEAP32[i9 >> 2] = i1 - i2;
   HEAP32[i9 + 4 >> 2] = 1;
   HEAP32[i7 >> 2] = (HEAP32[i8 + 72 >> 2] | 0) + (i6 & 1048575);
   HEAP16[i7 + 4 >> 1] = i6 >>> 20 & 1023;
   return;
  }
 } while (0);
 HEAP32[i9 >> 2] = -1;
 HEAP32[i9 + 4 >> 2] = 4;
 HEAP32[i7 >> 2] = gb + 1170596;
 HEAP16[i7 + 4 >> 1] = 1;
 return;
}

function __ZN8Playable18SetInputConnectionEPS_i(i1, i10, i3) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((i3 | 0) > -1) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAP32[i1 + 28 >> 2] | 0) <= (i3 | 0)) {
   i10 = 0;
   return i10 | 0;
  }
 } else {
  i2 = i1 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == -1) {
   i3 = HEAP32[i1 + 28 >> 2] | 0;
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 >= (i4 & 2147483647) >>> 0) {
    __Z18GetDirectorManagerv() | 0;
    i4 = __ZN15DirectorManager14ConnectionPool12SwitchBucketEP14ConnectionList(gb + 1188456 | 0, HEAP32[i2 >> 2] | 0) | 0;
    HEAP32[i2 >> 2] = i4;
    i1 = i4;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   i5 = i1 + 16 | 0;
   i6 = i1 + 28 | 0;
   i7 = i3 + 1 | 0;
   i8 = i1 + 32 | 0;
   i9 = i4 & 2147483647;
   do if (i7 >>> 0 > i9 >>> 0) {
    i2 = i4 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i9 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i8 >> 2] = i2;
     HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2 << 3, 4, i1 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i1 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i9 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
     HEAP32[i8 >> 2] = i2;
     HEAP32[i5 >> 2] = i9;
     break;
    }
   } while (0);
   HEAP32[i6 >> 2] = i7;
   i9 = HEAP32[i5 >> 2] | 0;
   HEAP32[i9 + (i3 << 3) + 4 >> 2] = i10;
   HEAPF32[i9 + (i3 << 3) >> 2] = Math_fround(1.0);
   i10 = 1;
   return i10 | 0;
  }
 }
 i1 = (HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 2) {
  i10 = 0;
  return i10 | 0;
 }
 HEAP32[i1 >> 2] = i10;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx2Gu25PersistentContactManifold20replaceManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE(i2, i10, i11, i9, i1) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f6 * f6);
 i1 = HEAP8[i2 + 32 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = i2 + 44 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i11 >> 2]);
 f5 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 i2 = i1 & 255;
 i1 = 0;
 while (1) {
  f15 = Math_fround(HEAPF32[i8 + (i1 * 48 | 0) + 16 >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i1 * 48 | 0) + 20 >> 2]);
  f15 = Math_fround(f15 - f4);
  f14 = Math_fround(f14 - f5);
  f13 = Math_fround(Math_fround(HEAPF32[i8 + (i1 * 48 | 0) + 24 >> 2]) - f3);
  if (f6 > Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f14 * f14)) + Math_fround(f13 * f13))) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i12 = 6;
   break;
  }
 }
 if ((i12 | 0) == 6) return i1 | 0;
 i12 = i8 + (i1 * 48 | 0) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i12 = (HEAP32[i7 >> 2] | 0) + (i1 * 48 | 0) + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 i12 = (HEAP32[i7 >> 2] | 0) + (i1 * 48 | 0) + 32 | 0;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i12 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 i12 = 1;
 return i12 | 0;
}

function __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 16 | 0, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN13MonoBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, i1, 16, gb + 1048932 | 0, 0, gb + 587337 | 0, 60) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 65372 + 8;
 i1 = i4 + 36 | 0;
 i2 = i4 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 64 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i4 + 68 >> 2] = i2;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = i4;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i4;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = i4;
 i2 = i4 + 108 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = i4;
 HEAP32[i4 + 136 >> 2] = 1;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP8[i4 + 143 >> 0] = 0;
 HEAP8[i4 + 141 >> 0] = 0;
 HEAP8[i4 + 140 >> 0] = 0;
 HEAP8[i4 + 142 >> 0] = 1;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = i4;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES21ProcessPendingMipGensEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i6 = i11;
 i9 = i8 + 8476 | 0;
 i10 = i8 + 8488 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i7 = i8 + 4620 | 0;
  i4 = 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] >> 2];
   i1 = HEAP32[gb + 1157724 >> 2] | 0;
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i5, i1, i6);
    i2 = HEAP32[i5 >> 2] | 0;
    i12 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1157724 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __ZN7ApiGLES14GenerateMipmapEj16TextureDimension(i7, HEAP32[i1 >> 2] | 0, HEAP32[(HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 24 >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i1 = i8 + 8492 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8 + 8480 | 0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i2, i5, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i8 = i2 + 20 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i5 + 4 | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i6 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i4 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) {
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, i1);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i6 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i4 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i8 + -8 + (HEAP32[i6 >> 2] | 0) | 0 : i8) >> 2] = i1;
 STACKTOP = i10;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i7 >> 2] = i2 + -72;
   i2 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function __ZN5physx8debugger8renderer19RenderSerializerMapINS1_11PvdTriangleEE9serializeERNS1_16RenderSerializerERS3_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 13 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 14 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 15 | 0);
 i3 = i1 + 16 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 29 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 30 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 31 | 0);
 i3 = i1 + 32 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 44 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 45 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 46 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 + 47 | 0);
 return;
}

function __ZN5audio5mixer12UpdateBypassERNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15 + 16 | 0;
 i13 = i15;
 i9 = i15 + 32 | 0;
 i10 = i2 + 12 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i11 = i2 + 16 | 0;
 i12 = i11;
 i8 = i1 + 16 | 0;
 i7 = i2 + 4 | 0;
 i6 = i7;
 i5 = 0;
 do {
  i1 = (HEAP32[i11 >> 2] | 0) + i12 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = Math_fround(HEAPF32[i4 + (i5 << 5) + 12 >> 2]) == Math_fround(0.0);
  if (i2) i3 = 1; else if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + i6 + (HEAP32[i1 + (i5 << 5) + 4 >> 2] << 4) + 14 >> 0] | 0)) i3 = (HEAP8[i1 + (i5 << 5) + 20 >> 0] | 0) != 0; else i3 = 1;
  i1 = HEAP32[i1 + (i5 << 5) >> 2] | 0;
  i16 = (i1 | 0) > -1;
  i3 = i3 & (i16 | i2 ^ 1 ? i16 : (i1 | 0) == -3);
  i2 = i4 + (i5 << 5) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZN4FMOD3DSP9getBypassEPb(i1, i9) | 0;
   if (i1 | 0) {
    i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
    HEAP32[i13 >> 2] = gb + 859765;
    HEAP32[i13 + 4 >> 2] = 1116;
    HEAP32[i13 + 8 >> 2] = i16;
    HEAP32[i13 + 12 >> 2] = i1;
    _printf_console(gb + 859725 | 0, i13);
   }
   if ((i3 & 1 | 0) != (HEAPU8[i9 >> 0] | 0)) {
    i1 = __ZN4FMOD3DSP9setBypassEb(HEAP32[i2 >> 2] | 0, i3) | 0;
    if (i1 | 0) {
     i16 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
     HEAP32[i14 >> 2] = gb + 859765;
     HEAP32[i14 + 4 >> 2] = 1118;
     HEAP32[i14 + 8 >> 2] = i16;
     HEAP32[i14 + 12 >> 2] = i1;
     _printf_console(gb + 859725 | 0, i14);
    }
   }
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 STACKTOP = i15;
 return;
}

function __ZN5Cache14ReadCacheIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 48 | 0;
 i2 = i6 + 36 | 0;
 i3 = i6 + 24 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6;
 i9 = i7 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i8) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1576256 | 0, 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i9, i5);
 __Z20GetPlatformCachePathv(i1);
 i8 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i8 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i8 & 255) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1); else {
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, i1, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i8 = _time(0) | 0;
 HEAP32[i1 >> 2] = i8;
 i9 = i7 + 16 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i7 + 48 >> 2] | 0) + i8;
 __ZN5Cache17ReadCacheInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlS9_(0, i4, i9, i1) | 0;
 __ZN5Cache22ReadCacheIndexThreadedEPv(i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return 1;
}

function __ZN28LightProbeProxyVolumeManager15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i2 = i5;
 i1 = __ZnwjRK10MemLabelIdiPKci(44, gb + 63160 | 0, 16, gb + 380088 | 0, 369) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63536 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN28LightProbeProxyVolumeContextC2E10MemLabelId(i1 + 20 | 0, i4);
 HEAP32[gb + 1110944 >> 2] = i1;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 38596 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i7 = i3;
  i6 = i7 + 1 | 0;
  HEAP32[i2 >> 2] = i6;
  i6 = i1 + 37828 + (i7 * 12 | 0) + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i1 + 37828 + (i7 * 12 | 0) + 8 | 0;
  HEAP8[i6 >> 0] = 0;
  i7 = i1 + 37828 + (i7 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = fb + 18;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = i7 + 1 | 0;
 HEAP32[i2 >> 2] = i6;
 i6 = i1 + 37828 + (i7 * 12 | 0) + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i1 + 37828 + (i7 * 12 | 0) + 8 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i1 + 37828 + (i7 * 12 | 0) | 0;
 HEAP32[i7 >> 2] = fb + 18;
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if (!i1) {
  i2 = i7 + 260 | 0;
  i3 = i7 + 272 | 0;
  i1 = 0;
  do {
   if ((i1 | 0) == 13) {
    i5 = HEAP32[i2 >> 2] | 0;
    i6 = i5 + ((HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
    HEAP32[i9 >> 2] = fb + 600;
    __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i5, i6, i9);
   }
   __ZN18AwakeFromLoadQueue19InvokeAwakeFromLoadEPNS_4ItemEj17AwakeFromLoadMode(HEAP32[i7 + (i1 * 20 | 0) >> 2] | 0, HEAP32[i7 + (i1 * 20 | 0) + 12 >> 2] | 0, i8);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 14);
  STACKTOP = i10;
  return;
 }
 __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj(HEAP32[i7 + 20 >> 2] | 0, HEAP32[i7 + 32 >> 2] | 0);
 __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj(HEAP32[i7 + 40 >> 2] | 0, HEAP32[i7 + 52 >> 2] | 0);
 i4 = i7 + 260 | 0;
 i5 = i7 + 272 | 0;
 i3 = 0;
 do {
  if ((i3 | 0) == 13) {
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = i2 + ((HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i9 >> 2] = fb + 600;
   __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i2, i1, i9);
   i1 = HEAP32[i7 + (i3 * 20 | 0) >> 2] | 0;
   i2 = HEAP32[i7 + (i3 * 20 | 0) + 12 >> 2] | 0;
   i6 = 7;
  } else {
   i1 = HEAP32[i7 + (i3 * 20 | 0) >> 2] | 0;
   i2 = HEAP32[i7 + (i3 * 20 | 0) + 12 >> 2] | 0;
   if ((i3 + -1 | 0) >>> 0 > 1) i6 = 7;
  }
  if ((i6 | 0) == 7) {
   i6 = 0;
   __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj(i1, i2);
  }
  __ZN18AwakeFromLoadQueue19InvokeAwakeFromLoadEPNS_4ItemEj17AwakeFromLoadMode(i1, i2, i8);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 14);
 STACKTOP = i10;
 return;
}

function __ZN12TextureIdMap10InitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63536 | 0, 16, gb + 396863 | 0, 7) | 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP8[i5 + 8 >> 0] = 0;
 i2 = i5 + 9 | 0;
 HEAP8[i2 >> 0] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i3 = i5 + 32 | 0;
 HEAP32[i3 >> 2] = 32;
 HEAP32[i5 + 36 >> 2] = 0;
 i7 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 52 >> 2] = i7;
 i6 = HEAP32[i3 >> 2] | 0;
 f9 = Math_fround(i6 >>> 0);
 HEAP32[i5 + 44 >> 2] = ~~Math_fround(f9 * Math_fround(.5)) >>> 0;
 HEAP32[i5 + 40 >> 2] = ~~Math_fround(f9 * Math_fround(.200000003)) >>> 0;
 HEAP8[i5 + 48 >> 0] = 0;
 HEAP32[gb + 1157724 >> 2] = i5;
 HEAP8[i2 >> 0] = 1;
 i2 = i5 + 20 | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 65;
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 28 >> 2] = i1;
 i3 = i1 + (HEAP32[i3 >> 2] << 3) | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i6 = i2;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i8 = HEAP32[gb + 1157724 >> 2] | 0;
 __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv(i8);
 HEAP8[i8 + 8 >> 0] = 1;
 i8 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = -2;
 HEAP32[i8 + 4 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12ImageFilters17RemoveImageFilterERK11ImageFilter(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = i8 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) != (i2 | 0)) {
  i6 = i9 + 4 | 0;
  while (1) {
   i4 = i2;
   if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i3 + 4 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) {
    i3 = HEAP32[i8 >> 2] | 0;
    i3 = i3 + (((i1 - i3 | 0) / 12 | 0) * 12 | 0) | 0;
    i1 = i3 + 12 | 0;
    i4 = i4 - i1 | 0;
    if (i4) {
     _memmove(i3 | 0, i1 | 0, i4 | 0) | 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    i1 = i3 + (((i4 | 0) / 12 | 0) * 12 | 0) | 0;
    if ((i2 | 0) != (i1 | 0)) {
     i2 = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
     HEAP32[i5 >> 2] = i2;
    }
   } else i10 = 11; else i10 = 11;
   if ((i10 | 0) == 11) {
    i10 = 0;
    i3 = i3 + 12 | 0;
   }
   if ((i3 | 0) == (i2 | 0)) break; else i1 = i3;
  }
 }
 i7 = i8 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3;
 if ((i2 | 0) == (i1 | 0)) return;
 i6 = i9 + 4 | 0;
 while (1) {
  i4 = i1;
  if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i9 >> 2] | 0)) if ((HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = i2 + (((i3 - i2 | 0) / 12 | 0) * 12 | 0) | 0;
   i3 = i2 + 12 | 0;
   i4 = i4 - i3 | 0;
   if (!i4) i3 = i1; else {
    _memmove(i2 | 0, i3 | 0, i4 | 0) | 0;
    i3 = HEAP32[i5 >> 2] | 0;
   }
   i1 = i2 + (((i4 | 0) / 12 | 0) * 12 | 0) | 0;
   if ((i3 | 0) == (i1 | 0)) i1 = i3; else {
    i1 = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
   }
  } else i10 = 20; else i10 = 20;
  if ((i10 | 0) == 20) {
   i10 = 0;
   i2 = i2 + 12 | 0;
  }
  if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
 }
 return;
}

function __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 296 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 296 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 296 | 0) * 296 | 0) | 0;
 i7 = i1;
 i4 = i5 + (i4 * 296 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i5 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i3 = i3 + -296 | 0;
   __ZN8GUIStyleC2ERKS_(i1 + -296 | 0, i3);
   i1 = i2 + -296 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i5 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i4;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -296 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i4 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i12);
   }
  } while ((i1 | 0) != (i3 | 0));
 }
 if (!i5) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i12);
 STACKTOP = i13;
 return;
}

function __ZN7Cubemap23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i4 = i3 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 397454 | 0, i1, 0);
 __ZN9Texture2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 397462 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 152 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034905 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj432ENS_22PxRepXPropertyAccessorILj432ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 280 | 0;
 i7 = i10 + 168 | 0;
 i4 = i10 + 140 | 0;
 i8 = i10 + 112 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 248; else i1 = (HEAP32[i1 >> 2] | 0) + 248 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i8;
 i8 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i7);
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i8;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i7, i3, 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZNK5physx29PxJointLimitConeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j(i7, i4, 0) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc8BodyCore18addSpatialVelocityEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i2, i4, i7, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i5 = 0, f8 = f0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim24notifyAddSpatialVelocityEv(i1);
 i5 = i2 + 156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i2 = i4 + 292 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i3 = i4 + 280 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i4 + 284 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = 8;
 } else if (HEAP8[i1 + 31 >> 0] | 0) i3 = 8;
 if ((i3 | 0) == 8) {
  i2 = i1;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i5 >> 2] = i1;
 }
 i5 = i1 + 12 | 0;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 4;
 if (i7 | 0) {
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  i5 = i1 + 32 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  f8 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  i5 = i1 + 36 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i7 = i1 + 40 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 }
 if (!i6) return;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i1 + 48 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i7 = i1 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i7 = i1 + 56 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer31HandleDeleteArchivedFolderErrorERK8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 1080 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if (!(__ZNK15FileSystemEntry12FolderExistsEv(i4) | 0)) {
  __ZN13FileEntryDataD2Ev(i4);
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 + 120 >> 0] = (__ZN15FileSystemEntry8IsLockedEv(i4) | 0) & 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i5 + 11 | 0;
 HEAP8[i7 >> 0] = 1;
 HEAP8[i5 >> 0] = 101;
 HEAP8[i5 + 1 >> 0] = 0;
 HEAP8[i1 + 121 >> 0] = (__ZN11UnityEngine15CloudWebService16SessionContainer18DeleteArchivedFileERK8UnityStrS4_Rb(0, i2, i5, i1 + 122 | 0) | 0) & 1;
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i8 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i5 + 11 | 0;
 HEAP8[i8 >> 0] = 1;
 HEAP8[i5 >> 0] = 115;
 HEAP8[i5 + 1 >> 0] = 0;
 HEAP8[i1 + 123 >> 0] = (__ZN11UnityEngine15CloudWebService16SessionContainer18DeleteArchivedFileERK8UnityStrS4_Rb(0, i2, i5, i1 + 124 | 0) | 0) & 1;
 if ((HEAP8[i8 >> 0] | 0) < 0) {
  i8 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i3);
 }
 __ZN13FileEntryDataD2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 272 | 0;
 i5 = i4 + 256 | 0;
 i11 = i4 + 240 | 0;
 i21 = i4 + 224 | 0;
 i14 = i4 + 208 | 0;
 i20 = i4 + 192 | 0;
 i10 = i4 + 176 | 0;
 i18 = i4 + 160 | 0;
 i19 = i4 + 144 | 0;
 i17 = i4 + 128 | 0;
 i8 = i4 + 112 | 0;
 i13 = i4 + 96 | 0;
 i15 = i4 + 80 | 0;
 i12 = i4 + 64 | 0;
 i9 = i4 + 32 | 0;
 i6 = i4;
 i16 = i3 + 384 | 0;
 __Z5splatILj0EE8Scalar4fRKS0_(i14, i16);
 __ZmlRK8Scalar4fS1_(i21, i2, i14);
 i14 = i3 + 400 | 0;
 __Z5splatILj0EE8Scalar4fRKS0_(i20, i14);
 __ZplRK8Scalar4fS1_(i11, i21, i20);
 __Z5splatILj1EE8Scalar4fRKS0_(i19, i16);
 __ZmlRK8Scalar4fS1_(i18, i2 + 16 | 0, i19);
 __Z5splatILj1EE8Scalar4fRKS0_(i17, i14);
 __ZplRK8Scalar4fS1_(i10, i18, i17);
 __Z5splatILj2EE8Scalar4fRKS0_(i15, i16);
 __ZmlRK8Scalar4fS1_(i13, i2 + 32 | 0, i15);
 __Z5splatILj2EE8Scalar4fRKS0_(i12, i14);
 __ZplRK8Scalar4fS1_(i8, i13, i12);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i1, i11, i3, i3 + 192 | 0);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i9, i10, i3 + 32 | 0, i3 + 224 | 0);
 __ZanRK8Scalar4fS1_(i7, i1, i9);
 __ZN8Scalar4faSERKS_(i1, i7) | 0;
 i2 = i1 + 16 | 0;
 __ZanRK8Scalar4fS1_(i5, i2, i9 + 16 | 0);
 __ZN8Scalar4faSERKS_(i2, i5) | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i6, i8, i3 + 64 | 0, i3 + 256 | 0);
 __ZanRK8Scalar4fS1_(i7, i1, i6);
 __ZN8Scalar4faSERKS_(i1, i7) | 0;
 __ZanRK8Scalar4fS1_(i5, i2, i6 + 16 | 0);
 __ZN8Scalar4faSERKS_(i2, i5) | 0;
 STACKTOP = i4;
 return;
}

function __ZNK16Physics2DManager18GetIgnoreCollisionEP10Collider2DS1_(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i3 = i1;
 i4 = i2;
 if ((i1 | 0) == (i2 | 0) | ((i1 | 0) == 0 | (i2 | 0) == 0)) {
  i16 = 0;
  return i16 | 0;
 }
 i1 = (HEAP32[i1 + 4 >> 2] | 0) > (HEAP32[i2 + 4 >> 2] | 0);
 i6 = HEAP32[i5 + 8 >> 2] | 0;
 if ((HEAP32[i5 + 48 >> 2] | 0) == (i6 | 0)) {
  i2 = HEAP32[i5 + 40 >> 2] | 0;
  i1 = HEAP32[i5 + 44 >> 2] | 0;
  i3 = i2 + (i1 * 12 | 0) | 0;
 } else {
  i13 = i1 ? i3 : i4;
  i12 = i1 ? i4 : i3;
  i15 = HEAP32[i5 + 44 >> 2] | 0;
  i8 = i15 + -1 | 0;
  i1 = HEAP32[i12 + 4 >> 2] | 0;
  i1 = i1 + 2127912214 + (i1 << 12) | 0;
  i1 = HEAP32[i13 + 4 >> 2] ^ -949894596 ^ i1 ^ i1 >>> 19;
  i1 = i1 + 374761393 + (i1 << 5) | 0;
  i2 = HEAP32[i5 + 40 >> 2] | 0;
  i9 = HEAP32[i5 + 28 >> 2] | 0;
  i10 = i5 + 32 | 0;
  i11 = i5 + 12 | 0;
  i14 = i5 + 16 | 0;
  i7 = i5 + 20 | 0;
  i5 = 0;
  i1 = i1 + -744332180 ^ i1 << 9;
  i3 = i6;
  while (1) {
   i1 = i1 & i8;
   i4 = HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0;
   if ((i9 | 0) == (i4 | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) {
    i1 = -1;
    break;
   }
   if (!(HEAP8[i11 >> 0] | 0)) i16 = 11; else if (!i3) {
    i3 = 0;
    i16 = 11;
   } else if ((HEAP32[i14 >> 2] | 0) == (i4 | 0)) {
    if ((HEAP32[i7 >> 2] | 0) != (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) i16 = 11;
   } else i16 = 11;
   if ((i16 | 0) == 11) {
    i16 = 0;
    if ((i12 | 0) == (i4 | 0)) if ((i13 | 0) == (HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0)) break;
   }
   i6 = i5 + 1 | 0;
   i5 = i6;
   i1 = i6 + i1 | 0;
  }
  i3 = (i1 | 0) == -1 ? i2 + (i15 * 12 | 0) | 0 : i2 + (i1 * 12 | 0) | 0;
  i1 = i15;
 }
 i16 = (i3 | 0) != (i2 + (i1 * 12 | 0) | 0);
 return i16 | 0;
}

function __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i11 = i12;
 i4 = i8 + 72 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = i4;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i3 = HEAP32[i10 + 4 >> 2] | 0;
   i4 = HEAP32[i10 + 8 >> 2] | 0;
   i5 = HEAP32[i10 + 12 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 24 >> 2] = i3;
   HEAP32[i1 + 28 >> 2] = i4;
   HEAP32[i1 + 32 >> 2] = i5;
  }
 }
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 12; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 12;
 if ((i6 | 0) == 12) {
  __ZN8Material15BuildPropertiesEv(i8);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i2 + 12 | 0, i9, i10, 0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i8, i7);
 STACKTOP = i12;
 return;
}

function __ZN32ParticleSystemGeometryJobModules7ReleaseE10MemLabelId(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 HEAP32[i3 >> 2] = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZNK10Effector2D18GetActiveCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i13 = i12 + 12 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i11 = HEAP32[i1 + 40 >> 2] | 0;
 if ((i11 | 0) <= 0) {
  i13 = i14;
  i14 = i13 - i14 | 0;
  return i14 | 0;
 }
 i10 = i1 + 28 | 0;
 i8 = i12 + 16 | 0;
 i9 = i12 + 4 | 0;
 i7 = 0;
 do {
  i1 = HEAP32[i10 >> 2] | 0;
  if (((HEAP32[(HEAP32[gb + 1106156 + 4 + (HEAP32[i1 + (i7 << 3) >> 2] << 2) >> 2] | 0) + 24 >> 2] | 0) - (HEAP32[gb + 32588 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32588 + 28 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i1 + (i7 << 3) + 4 >> 2] | 0;
   i6 = i1;
   if (HEAP8[i1 + 53 >> 0] | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) if (HEAP32[i1 + 72 >> 2] | 0) {
    i2 = HEAP32[i13 >> 2] | 0;
    i3 = i2 + 1 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    i5 = i4 & 2147483647;
    do if (i3 >>> 0 > i5 >>> 0) {
     i1 = i4 << 1;
     i1 = (i1 | 0) == 0 ? 1 : i1;
     if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
      HEAP32[i8 >> 2] = i1;
      HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i5 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
      HEAP32[i8 >> 2] = i1;
      HEAP32[i12 >> 2] = i5;
      break;
     }
    } while (0);
    HEAP32[i13 >> 2] = i3;
    HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   }
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i11 | 0));
 i13 = HEAP32[i13 >> 2] | 0;
 i14 = i13 - i14 | 0;
 return i14 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc8BodyRankENS0_15InlineAllocatorILj768ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 780 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = i9 * 12 | 0;
  i2 = i10 + 768 | 0;
  if (i1 >>> 0 < 769 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i1 = mftCall_iiiiii(i4 | 0, i5 | 0, i1 | 0, (i6 ? gb + 703100 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 776 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 * 12 | 0) | 0;
 i6 = i10 + 772 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 12 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i1 + (i2 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 do if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) == (i2 | 0)) {
   HEAP8[i10 + 768 >> 0] = 0;
   break;
  }
  if (i2 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i2 | 0);
  }
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = i9;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + 1;
 return i1 + (i10 * 12 | 0) | 0;
}

function __ZN5physx33PxVehicleDriveTankGeneratedValuesC2EPKNS_18PxVehicleDriveTankE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 108 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 112 | 0;
 i4 = i1 + 128 | 0;
 i5 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP32[i2 + 208 >> 2] = HEAP32[i1 + 752 >> 2];
 HEAP32[i2 + 212 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i5 = i1 + 288 | 0;
 _memcpy(i2 + 216 | 0, i1 + 224 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 280 >> 2] = HEAP32[i5 >> 2];
 i5 = i2 + 296 | 0;
 i4 = i1 + 304 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 328 | 0, i1 + 336 | 0, 416) | 0;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 5, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 5, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 5) | 0, 0, i5 - i4 << 5 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 5) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = HEAP32[i1 + 28 >> 2] | 0;
 i8 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = i9 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i7 | 0) == (i4 | 0)) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = (i1 | 0) == 0;
  if (i4) {
   i2 = i7;
   while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     i5 = i7;
     break;
    } else i2 = i3;
   }
  } else {
   i2 = i1;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
   i5 = i7;
  }
  HEAP32[i6 >> 2] = i2;
  i3 = i9 + 28 | 0;
  if (i4) {
   i2 = i5;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) HEAP32[i3 >> 2] = i1;
  i6 = i9 + 36 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 32 >> 2] | 0, i5);
  __ZdlPv(i7);
 } else {
  i3 = i9 + 28 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i4;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) HEAP32[i3 >> 2] = i1;
  i7 = i9 + 36 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 32 >> 2] | 0, i4);
  __ZdlPv(i4);
 }
 if (!i10) return;
 mftCall_ii(i10 | 0, i8 | 0) | 0;
 return;
}

function __ZN10AudioMixer18SetCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i4) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 395, 1, 0, 0, 0);
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 11;
  }
 }
 if ((i6 | 0) == 9) i6 = 11;
 if ((i6 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i8 = __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot(i4, i1) | 0;
 __ZN5audio5mixer20TransitionToSnapshotERNS0_16AudioMixerMemoryEif(HEAP32[i4 + 76 >> 2] | 0, i8, Math_fround(0.0));
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i5 | 0);
 STACKTOP = i7;
 return;
}

function __Z50CanvasRenderer_CUSTOM_SplitIndiciesStreamsInternalP12Il2CppObjectS0_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i9 = i10 + 8 | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = i9 + 12 | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = i3;
 i7 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i1 = i4;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i9 >> 2] = i2;
 if (i3 | 0) {
  i1 = 0;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i5 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) > 0) {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = 0;
  while (1) {
   i11 = HEAP32[i1 >> 2] | 0;
   HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 4) | 0) >> 2] = i11;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
  }
 }
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 >> 2];
 i11 = i8 + 16 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i7);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function _mallinfo(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i10 = i1 & -16 ^ 1431655768;
  HEAP32[i1 >> 2] = i10;
  HEAP32[gb + 1470876 >> 2] = i10;
 }
 i10 = HEAP32[gb + 1470404 + 24 >> 2] | 0;
 if (!i10) {
  i7 = 0;
  i6 = 0;
  i5 = 0;
  i2 = 0;
  i3 = 0;
  i4 = 0;
  i1 = 0;
 } else {
  i6 = HEAP32[gb + 1470404 + 12 >> 2] | 0;
  i1 = i6 + 40 | 0;
  i9 = gb + 1470404 + 448 | 0;
  i2 = i1;
  i5 = 1;
  do {
   i7 = HEAP32[i9 >> 2] | 0;
   i4 = i7 + 8 | 0;
   i8 = i7 + (HEAP32[i9 + 4 >> 2] | 0) | 0;
   i4 = i7 + ((i4 & 7 | 0) == 0 ? 0 : 0 - i4 & 7) | 0;
   do {
    if (i4 >>> 0 >= i8 >>> 0 | (i4 | 0) == (i10 | 0)) break;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i3 | 0) == 7) break;
    i13 = i3 & -8;
    i2 = i13 + i2 | 0;
    i3 = (i3 & 3 | 0) == 1;
    i5 = (i3 & 1) + i5 | 0;
    i1 = (i3 ? i13 : 0) + i1 | 0;
    i4 = i4 + i13 | 0;
   } while (i4 >>> 0 >= i7 >>> 0);
   i9 = HEAP32[i9 + 8 >> 2] | 0;
  } while ((i9 | 0) != 0);
  i4 = HEAP32[gb + 1470404 + 432 >> 2] | 0;
  i7 = i2;
  i2 = i4 - i2 | 0;
  i3 = HEAP32[gb + 1470404 + 436 >> 2] | 0;
  i4 = i4 - i1 | 0;
 }
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i5;
 i13 = i11 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i2;
 HEAP32[i11 + 20 >> 2] = i3;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = i4;
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 36 >> 2] = i6;
 STACKTOP = i12;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb(i11, i8, i7, i6) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 8 | 0;
 i5 = i12 + 12 | 0;
 i9 = i12;
 i10 = i11 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 HEAP16[i2 >> 1] = i7;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i11 + 212 | 0, i2, i5) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  HEAP16[i1 >> 1] = i7;
  HEAP32[i1 + 4 >> 2] = i8;
 }
 i4 = i11 + 160 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb(i11 + 168 | 0, i2, i5) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 4 >> 2] = i3;
 }
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = (i6 & 1) << 16 | i7 & 65535;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i11 + 164 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i8 = i9;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i11 = (HEAP32[i11 + 156 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = i9;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i11 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_18PxProfileEventNameENS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i11 + 152 | 0, i9) | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 }
}

function __Z43NavMesh_CUSTOM_INTERNAL_CALL_SamplePositionRK8Vector3fP10NavMeshHitfi(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 128 >> 2] = i4;
 i4 = (__ZN14NavMeshManager14SamplePositionEP10NavMeshHitRK8Vector3fRK13dtQueryFilterf(__Z17GetNavMeshManagerv() | 0, i2, i1, i6, f3) | 0) & 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z35Font_CUSTOM_GetOSInstalledFontNamesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN20TextRenderingPrivate8FontImpl14GetOSFontNamesERNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE(i7);
 i8 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8, 4, (HEAP32[i5 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) i1 = i2; else {
  i1 = 0;
  while (1) {
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i8, i1, __Z20scripting_string_newPKcj(i3 ? HEAP32[i2 >> 2] | 0 : i2, i3 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) | 0);
   i2 = i2 + 16 | 0;
   if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) break; else i1 = i1 + 1 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 34;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i9;
 return i8 | 0;
}

function __Z10WriteArrayI20AudioProfilerDSPInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4 + ((i2 * 44 | 0) >>> 2) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 _memcpy(i1 + (i4 << 2) | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 44 | 0) | 0;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471202 | 0, i7, i1 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899057 | 0, i7, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471313 | 0, i7, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 28 | 0;
 HEAP8[i8 >> 0] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 37252 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP8[i8 >> 0];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471291 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471202 | 0, i7, i1 + 16 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899057 | 0, i7, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471313 | 0, i7, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 28 | 0;
 HEAP8[i8 >> 0] = HEAP32[i7 >> 2];
 i6 = HEAP32[gb + 37252 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP8[i8 >> 0];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471325 | 0, i6, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEER8UnityStr(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i11 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i9 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 i4 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i3 - i2 | 0;
 i6 = (i5 | 0) / 12 | 0;
 if (!i5) {
  i2 = 0;
  i1 = 0;
 } else {
  if (i6 >>> 0 > 357913941) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i4 >> 2] | 0;
  }
  i1 = __Znwj(i5) | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 8 >> 2] = i1 + (i6 * 12 | 0);
  if ((i2 | 0) == (i3 | 0)) i2 = i1; else {
   do {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
    i2 = i2 + 12 | 0;
    i1 = (HEAP32[i10 >> 2] | 0) + 12 | 0;
    HEAP32[i10 >> 2] = i1;
   } while ((i2 | 0) != (i3 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
 }
 __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(i2, i1, i8);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i9, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i8 = i2 + -12 | 0;
   HEAP32[i10 >> 2] = i8;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i2 = HEAP32[i10 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = i10 + 44 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = i9 << 3;
  i2 = i10 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i1 = mftCall_iiiiii(i4 | 0, i5 | 0, i1 | 0, (i6 ? gb + 707647 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 << 3) | 0;
 i6 = i10 + 36 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i13 = i3;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i11 = i7;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i1 + (i2 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 do if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) == (i2 | 0)) {
   HEAP8[i10 + 32 >> 0] = 0;
   break;
  }
  if (i2 | 0) {
   i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i2 | 0);
  }
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = i9;
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i13 + 1;
 return i1 + (i13 << 3) | 0;
}

function __Z37TextGenerator_CUSTOM_GetLinesInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 24 | 0;
 i8 = i9;
 if (!i7) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1008413 | 0, i9 + 16 | 0);
 i3 = HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 20 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i1 >> 2] | 0) | 0;
 i6 = i5 + 52 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i3, 12, i2) | 0;
  HEAP32[i1 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
 }
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i8 = i7 + 12 | 0;
  HEAP32[i8 >> 2] = i6;
  i8 = i7 + 16 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i5 + 40 >> 2] | 0;
 i2 = 0;
 while (1) {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 12) | 0;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 12 | 0;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 12 | 0;
 HEAP32[i8 >> 2] = i6;
 i8 = i7 + 16 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + 1 | 0;
 HEAP32[i8 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_(i6, i7, i5, i4, i1, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_(i6, i7, i5, i4, i8) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i11 = Math_imul(HEAP32[i10 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i2 << 3) >> 2] | 0) | 0;
 if ((i11 | 0) <= (Math_imul(HEAP32[i10 + (i3 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i3 << 3) >> 2] | 0) | 0)) {
  i11 = i9;
  return i11 | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i10 = Math_imul(HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i1 << 3) >> 2] | 0) | 0;
 if ((i10 | 0) <= (Math_imul(HEAP32[i11 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i2 << 3) >> 2] | 0) | 0)) {
  i11 = i9 + 1 | 0;
  return i11 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i2;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i10 = Math_imul(HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i1 << 3) >> 2] | 0) | 0;
 if ((i10 | 0) <= (Math_imul(HEAP32[i11 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i2 << 3) >> 2] | 0) | 0)) {
  i11 = i9 + 2 | 0;
  return i11 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i11 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i10 = Math_imul(HEAP32[i11 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i1 << 3) >> 2] | 0) | 0;
 if ((i10 | 0) <= (Math_imul(HEAP32[i11 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i11 + (i2 << 3) >> 2] | 0) | 0)) {
  i11 = i9 + 3 | 0;
  return i11 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i11 = i9 + 4 | 0;
 return i11 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = __Znwj(36) | 0;
 i8 = i1 + 4 | 0;
 i9 = i7;
 HEAP32[i7 + 16 >> 2] = HEAP32[i2 >> 2];
 i1 = i7 + 20 | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i3 ? HEAP32[i2 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 32 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i7 + 31 >> 0] = i4;
  if (!i4) {
   i11 = i1;
   i11 = i11 + i4 | 0;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i10 >> 2] = i9;
   i11 = i10 + 4 | 0;
   i10 = i11;
   HEAP32[i10 >> 2] = i8;
   i11 = i11 + 4 | 0;
   HEAP32[i11 >> 2] = 1;
   STACKTOP = i12;
   return;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 + 28 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 24 >> 2] = i4;
  i1 = i11;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i11 = i1;
 i11 = i11 + i4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i10 >> 2] = i9;
 i11 = i10 + 4 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = i8;
 i11 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = 1;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKiS2_EE(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i7 = __Znwj(36) | 0;
 i8 = i1 + 4 | 0;
 i9 = i7;
 HEAP32[i7 + 16 >> 2] = HEAP32[i2 >> 2];
 i1 = i7 + 20 | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i3 ? HEAP32[i2 + 8 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 32 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i7 + 31 >> 0] = i4;
  if (!i4) {
   i11 = i1;
   i11 = i11 + i4 | 0;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i10 >> 2] = i9;
   i11 = i10 + 4 | 0;
   i10 = i11;
   HEAP32[i10 >> 2] = i8;
   i11 = i11 + 4 | 0;
   HEAP32[i11 >> 2] = 1;
   STACKTOP = i12;
   return;
  }
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 + 28 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 24 >> 2] = i4;
  i1 = i11;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i11 = i1;
 i11 = i11 + i4 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i10 >> 2] = i9;
 i11 = i10 + 4 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = i8;
 i11 = i11 + 4 | 0;
 HEAP32[i11 >> 2] = 1;
 STACKTOP = i12;
 return;
}

function __ZN24EllipsoidParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi(i3, i4, i11, i12, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, i21 = 0, i22 = 0, i23 = 0;
 f13 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 i14 = i4 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((((HEAP32[i14 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0 <= i2 >>> 0) return;
 i5 = i3 + 72 | 0;
 i6 = i3 + 76 | 0;
 i7 = i3 + 80 | 0;
 i8 = i3 + 84 | 0;
 i9 = i3 + 88 | 0;
 i10 = i3 + 92 | 0;
 do {
  __ZN24EllipsoidParticleEmitter13SetupParticleER8ParticleRK8Vector3fRK10Matrix3x3ff(i3, i1 + (i2 * 48 | 0) | 0, i11, i12, f13);
  i21 = HEAP32[i4 >> 2] | 0;
  f15 = Math_fround(HEAPF32[i5 >> 2]);
  i23 = i21 + (i2 * 48 | 0) | 0;
  f16 = Math_fround(HEAPF32[i23 >> 2]);
  f17 = Math_fround(HEAPF32[i6 >> 2]);
  i22 = i21 + (i2 * 48 | 0) + 4 | 0;
  f18 = Math_fround(HEAPF32[i22 >> 2]);
  f19 = Math_fround(HEAPF32[i7 >> 2]);
  i21 = i21 + (i2 * 48 | 0) + 8 | 0;
  f20 = Math_fround(HEAPF32[i21 >> 2]);
  HEAPF32[i5 >> 2] = f16 < f15 ? f16 : f15;
  HEAPF32[i6 >> 2] = f18 < f17 ? f18 : f17;
  HEAPF32[i7 >> 2] = f20 < f19 ? f20 : f19;
  f19 = Math_fround(HEAPF32[i8 >> 2]);
  f20 = Math_fround(HEAPF32[i23 >> 2]);
  f17 = Math_fround(HEAPF32[i9 >> 2]);
  f18 = Math_fround(HEAPF32[i22 >> 2]);
  f15 = Math_fround(HEAPF32[i10 >> 2]);
  f16 = Math_fround(HEAPF32[i21 >> 2]);
  HEAPF32[i8 >> 2] = f19 < f20 ? f20 : f19;
  HEAPF32[i9 >> 2] = f17 < f18 ? f18 : f17;
  HEAPF32[i10 >> 2] = f15 < f16 ? f16 : f15;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i14 >> 2] | 0) - i1 | 0) / 48 | 0) >>> 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function _log2f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (i2 | 0) < 0;
 do if (i2 >>> 0 < 8388608 | i3) {
  if (!(i2 & 2147483647)) {
   f1 = Math_fround(Math_fround(-1.0) / Math_fround(f1 * f1));
   break;
  }
  if (i3) {
   f1 = Math_fround(Math_fround(f1 - f1) / Math_fround(0.0));
   break;
  } else {
   f1 = Math_fround(f1 * Math_fround(33554432.0));
   i3 = -152;
   i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = 9;
   break;
  }
 } else if (i2 >>> 0 <= 2139095039) if ((i2 | 0) == 1065353216) f1 = Math_fround(0.0); else {
  i3 = -127;
  i4 = 9;
 } while (0);
 if ((i4 | 0) == 9) {
  i4 = i2 + 4913933 | 0;
  f8 = Math_fround((HEAP32[tempDoublePtr >> 2] = (i4 & 8388607) + 1060439283, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
  f7 = Math_fround(f8 / Math_fround(f8 + Math_fround(2.0)));
  f6 = Math_fround(f7 * f7);
  f1 = Math_fround(f6 * f6);
  f1 = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f1 * Math_fround(.284987867)) + Math_fround(.666666627))) + Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.242790788)) + Math_fround(.400009722))));
  f6 = Math_fround(f8 * Math_fround(f8 * Math_fround(.5)));
  f5 = Math_fround(f8 - f6);
  f5 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -4096, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f1 = Math_fround(Math_fround(Math_fround(f8 - f5) - f6) + Math_fround(f7 * Math_fround(f6 + f1)));
  f1 = Math_fround(Math_fround(i3 + (i4 >>> 23) | 0) + Math_fround(Math_fround(f5 * Math_fround(1.44287109)) + Math_fround(Math_fround(f1 * Math_fround(1.44287109)) - Math_fround(Math_fround(f5 + f1) * Math_fround(.000176052854)))));
 }
 return Math_fround(f1);
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE12__find_equalIS8_EERPNS_16__tree_node_baseIPvEESO_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN5audio5mixer13GroupConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i4 = i5 + 4 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 12 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 13 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 14 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN5Umbra9RasterOps13rasterizeQuadERNS_17BlockRasterBufferERKNS_8Vector4iERKS1_(i21, i1, i22) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 i22 = i22 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i23 = 0;
 i18 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i20 = HEAP32[i1 + 12 >> 2] | 0;
 i15 = i18 >> 2;
 i16 = i2 >> 2;
 i17 = i20 + 3 >> 2;
 i18 = HEAP32[gb + 78976 + ((i18 & 3) << 2) >> 2] | 0;
 i19 = HEAP32[gb + 78992 + ((i3 & 3) << 2) >> 2] | 0;
 i20 = HEAP32[gb + 79008 + ((i20 & 3) << 2) >> 2] | 0;
 if ((i16 | 0) >= (i17 | 0)) {
  i22 = 0;
  return i22 | 0;
 }
 i13 = HEAP32[gb + 79024 + ((i2 & 3) << 2) >> 2] & 65535;
 i14 = i17 + -1 | 0;
 i12 = (i3 + 3 >> 2) - i15 | 0;
 if (!i12) {
  i22 = 0;
  return i22 | 0;
 }
 i10 = HEAP32[i22 + 4 >> 2] | 0;
 i11 = HEAP32[i21 + 4 >> 2] | 0;
 i5 = 0;
 i3 = i16;
 i2 = HEAP8[i22 + 2 >> 0] | 0;
 i1 = HEAP8[i21 + 2 >> 0] | 0;
 do {
  i6 = HEAP32[i22 >> 2] | 0;
  i7 = i6 & 255;
  i7 = i10 + (i15 - (i7 << 1) + (Math_imul((i2 & 255) - i7 << 1, i3 - (i6 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i4 = HEAP32[i21 >> 2] | 0;
  i8 = i4 & 255;
  i8 = i11 + (i15 - (i8 << 1) + (Math_imul((i1 & 255) - i8 << 1, i3 - (i4 >>> 8 & 255) | 0) | 0) << 1) | 0;
  i9 = ((i3 | 0) == (i16 | 0) ? i13 : 65535) & ((i3 | 0) == (i14 | 0) ? i20 : -1);
  i2 = i6 >>> 16 & 255;
  i1 = i4 >>> 16 & 255;
  i4 = i12;
  i6 = i9 & i18;
  while (1) {
   i23 = HEAPU16[i8 >> 1] | 0;
   i6 = (1 - i4 >> 31 | i19) & i6 & (HEAPU16[i7 >> 1] | 0) | i23;
   i4 = i4 + -1 | 0;
   i5 = i6 ^ i23 | i5;
   HEAP16[i8 >> 1] = i6;
   if (!i4) break; else {
    i7 = i7 + 2 | 0;
    i6 = i9;
    i8 = i8 + 2 | 0;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i17 | 0));
 i23 = (i5 | 0) != 0;
 return i23 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 i1 = i5 + 8 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 i10 = i1 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 i10 = i1 + 36 | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 i6 = i1 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i1 + 60 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i10 = i7;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i1 + 80 >> 2] = 2;
 HEAP32[i1 + 76 >> 2] = 2;
 HEAP32[i1 + 84 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 1034188 | 0, i1, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i1 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z10WriteArrayI22AudioProfilerGroupInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4 + (i2 << 4 & 1073741808) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 _memcpy(i1 + (i4 << 2) | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 6 | 0) | 0;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_(i9, i10, i7, i6, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0;
 i8 = __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_(i9, i10, i7, i6, i1) | 0;
 i1 = i5;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0 | (i1 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) {
  i11 = i6;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i8 + 1 | 0;
  i3 = i6;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i7;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i1 = i7;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i6;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i8 + 2 | 0;
   i3 = i7;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i10;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i1 = i10;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 4 >> 2] = i3;
    i2 = i7;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = i10;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = i9;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
     i11 = i9;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i11 + 4 >> 2] = i2;
     i1 = i10;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i8 + 4 | 0;
    } else i1 = i8 + 3 | 0;
   }
  }
 } else i1 = i8;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_(i9, i10, i7, i6, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0;
 i8 = __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i9, i10, i7, i6, i1) | 0;
 i1 = i5;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) < (i3 | 0) | (i1 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) {
  i11 = i6;
  HEAP32[i11 >> 2] = i4;
  HEAP32[i11 + 4 >> 2] = i1;
  i1 = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i8 + 1 | 0;
  i3 = i6;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i7;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i3 | 0) < (i5 | 0) | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i1 = i7;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i6;
   HEAP32[i1 >> 2] = i4;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i8 + 2 | 0;
   i3 = i7;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   i5 = i10;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   if ((i3 | 0) < (i5 | 0) | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
    i1 = i10;
    HEAP32[i1 >> 2] = i2;
    HEAP32[i1 + 4 >> 2] = i3;
    i2 = i7;
    HEAP32[i2 >> 2] = i4;
    HEAP32[i2 + 4 >> 2] = i5;
    i2 = i10;
    i1 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = i9;
    i3 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i4 + 4 >> 2] | 0;
    if ((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
     i11 = i9;
     HEAP32[i11 >> 2] = i1;
     HEAP32[i11 + 4 >> 2] = i2;
     i1 = i10;
     HEAP32[i1 >> 2] = i3;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = i8 + 4 | 0;
    } else i1 = i8 + 3 | 0;
   }
  }
 } else i1 = i8;
 return i1 | 0;
}

function __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 24 | 0) + 1 | 0;
 if ((i8 | 0) < -24) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i6 = i7 << 1;
 i6 = i7 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 2;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 24 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 24;
 HEAP32[i8 >> 2] = i7 + (i6 * 24 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 2;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNK9ShaderLab21ShaderRasterStateDesc16ToGfxRasterStateEPK19ShaderPropertySheetS3_R14GfxRasterState(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 24 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 >> 2]); else {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i5, i6, i3, i8);
  f1 = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]);
 }
 i2 = ~~f1;
 HEAP32[i7 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 2 ? 2 : i2;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 + 8 >> 2]); else {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i5, i6, i3, i8);
  f1 = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]);
 }
 HEAP32[i7 + 4 >> 2] = ~~f1;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f1 = Math_fround(HEAPF32[i4 + 16 >> 2]);
  i10 = i7 + 8 | 0;
  HEAPF32[i10 >> 2] = f1;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i5, i6, i3, i8);
  f1 = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]);
  i10 = i7 + 8 | 0;
  HEAPF32[i10 >> 2] = f1;
  STACKTOP = i11;
  return;
 }
}

function __ZN9ShaderLab27SerializedShaderVectorValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i4, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 4 | 0, i5);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 12 | 0, i5);
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 20 | 0, i5);
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  i7 = i4 + 28 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  i7 = i4 + 32 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i7 = i4 + 28 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  i7 = i4 + 32 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 }
}

function __ZN5physx15PxSetGroupsMaskERNS_7PxActorERKNS_12PxGroupsMaskE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 48 | 0;
 i7 = i9 + 32 | 0;
 i2 = i9 + 16 | 0;
 i3 = i9;
 i5 = (HEAPU16[i1 + 2 >> 1] | 0) << 16 | (HEAPU16[i1 >> 1] | 0);
 i4 = (HEAPU16[i1 + 6 >> 1] | 0) << 16 | (HEAPU16[i1 + 4 >> 1] | 0);
 switch (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0) {
 case 4:
 case 0:
 case 1:
  {
   if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 104 >> 2] | 0, i6 | 0) | 0)) {
    STACKTOP = i9;
    return;
   }
   i1 = i7 + 8 | 0;
   i2 = i7 + 12 | 0;
   i3 = 0;
   do {
    mftCall_iiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 108 >> 2] | 0, i6 | 0, i8 | 0, 1, i3 | 0) | 0;
    i10 = HEAP32[i8 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i10 | 0);
    HEAP32[i1 >> 2] = i5;
    HEAP32[i2 >> 2] = i4;
    i10 = HEAP32[i8 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 76 >> 2] | 0, i10 | 0, i7 | 0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 104 >> 2] | 0, i6 | 0) | 0) >>> 0);
   STACKTOP = i9;
   return;
  }
 case 2:
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i2 | 0, i6 | 0);
   HEAP32[i2 + 8 >> 2] = i5;
   HEAP32[i2 + 12 >> 2] = i4;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 176 >> 2] | 0, i6 | 0, i2 | 0);
   STACKTOP = i9;
   return;
  }
 case 5:
  {
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 432 >> 2] | 0, i3 | 0, i6 | 0);
   HEAP32[i3 + 8 >> 2] = i5;
   HEAP32[i3 + 12 >> 2] = i4;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 428 >> 2] | 0, i6 | 0, i3 | 0);
   STACKTOP = i9;
   return;
  }
 default:
  {
   STACKTOP = i9;
   return;
  }
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z11FormatBytesx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i6 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i4 = i8;
 if ((i3 | 0) < 0) {
  HEAP32[i1 >> 2] = 0;
  i5 = gb + 63648 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i1 + 24 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i7 = i1 + 4 | 0;
  HEAP8[i7 >> 0] = HEAP8[gb + 585672 >> 0] | 0;
  HEAP8[i7 + 1 >> 0] = HEAP8[gb + 585672 + 1 >> 0] | 0;
  HEAP8[i7 + 2 >> 0] = HEAP8[gb + 585672 + 2 >> 0] | 0;
  HEAP8[i7 + 3 >> 0] = HEAP8[gb + 585672 + 3 >> 0] | 0;
  HEAP8[i7 + 4 >> 0] = HEAP8[gb + 585672 + 4 >> 0] | 0;
  HEAP8[i7 + 5 >> 0] = HEAP8[gb + 585672 + 5 >> 0] | 0;
  HEAP8[i7 + 6 >> 0] = HEAP8[gb + 585672 + 6 >> 0] | 0;
  HEAP8[i1 + 11 >> 0] = 0;
  HEAP32[i1 + 20 >> 2] = 7;
  STACKTOP = i8;
  return;
 }
 if ((i3 | 0) < 0 | (i3 | 0) == 0 & i2 >>> 0 < 512) {
  i7 = i4;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i7 + 4 >> 2] = i3;
  __Z12FormatStringPKcz(i1, gb + 585680 | 0, i4);
  STACKTOP = i8;
  return;
 }
 if ((i3 | 0) < 0 | (i3 | 0) == 0 & i2 >>> 0 < 524288) {
  HEAPF64[i5 >> 3] = (+(i2 >>> 0) + 4294967296.0 * +(i3 | 0)) * .0009765625;
  __Z12FormatStringPKcz(i1, gb + 585687 | 0, i5);
  STACKTOP = i8;
  return;
 }
 if ((i3 | 0) < 0 | (i3 | 0) == 0 & i2 >>> 0 < 536870912) {
  i7 = _bitshift64Lshr(i2 | 0, i3 | 0, 10) | 0;
  HEAPF64[i6 >> 3] = (+(i7 >>> 0) + 4294967296.0 * +(getTempRet0() | 0)) * .0009765625;
  __Z12FormatStringPKcz(i1, gb + 585697 | 0, i6);
  STACKTOP = i8;
  return;
 } else {
  i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
  HEAPF64[i7 >> 3] = (+(i6 >>> 0) + 4294967296.0 * +(getTempRet0() | 0)) * .0009765625;
  __Z12FormatStringPKcz(i1, gb + 585707 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESF_SF_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i9 + 4 | 0;
 i5 = i2;
 i2 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i12 = i4 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
  i4 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i13 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i12;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i2 = i5 + 12 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
  HEAP32[i7 >> 2] = i1;
  if ((i2 | 0) == (i8 | 0)) break; else i5 = i2;
 }
 STACKTOP = i10;
 return;
}

function __ZNK6Camera34CalculateNearPlaneWorldSpaceLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 24 | 0;
 i6 = i2 + 12 | 0;
 i8 = i2;
 __ZL19GetCameraTargetRectRK6Camerab(i7, i1, 1);
 f3 = Math_fround(HEAPF32[i1 + 864 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 868 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 872 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f3 = Math_fround(f3 * f11);
 f4 = Math_fround(f4 * f11);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 12 >> 2]));
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f3 = Math_fround(f3 + f13);
 f5 = Math_fround(f5 + f12);
 f4 = Math_fround(f4 + f3);
 f11 = Math_fround(f11 + f13);
 f3 = f3 < f13 ? f13 : f3;
 f5 = f5 < f12 ? f12 : f5;
 f4 = Math_fround((f4 > f11 ? f11 : f4) - f3);
 i9 = f4 < Math_fround(0.0);
 f4 = i9 ? Math_fround(0.0) : f4;
 i9 = i1 + 920 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i6 >> 2] = f3;
 HEAPF32[i6 + 4 >> 2] = f5;
 HEAP32[i6 + 8 >> 2] = i10;
 __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i7, i1, i6);
 f4 = Math_fround(f3 + f4);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i8 >> 2] = f4;
 HEAPF32[i8 + 4 >> 2] = f5;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i6, i1, i8);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2]));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i6 + 8 >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f3 * f3))));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN7mecanim12statemachine18StateMachineMemory8TransferI8BlobSizeEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 20 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i1 = i3 + 16 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i4 = (0 - i4 & 3) + i4 | 0;
  HEAP32[i1 >> 2] = i4 + 4 + (0 - i4 & 3);
 } else HEAP8[i2 >> 0] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i4 = i3 + 16 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i3 = i3 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i3 & 3) | 0;
  i1 = (i1 & 65535) < 256 ? i3 : i3 + 4 | 0;
  HEAP8[i2 >> 0] = 0;
  i2 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i4 >> 2] = i2;
  i1 = i4;
 } else {
  HEAP8[i2 >> 0] = 0;
  i2 = i3 + 16 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i4 = (0 - i2 & 3) + i2 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 i4 = i4 + 4 + (0 - i4 & 3) | 0;
 i4 = (0 - i4 & 3) + i4 | 0;
 HEAP32[i1 >> 2] = i4 + 4 + (0 - i4 & 3) + 7;
 return;
}

function __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 HEAP32[i10 >> 2] = i1;
 i12 = i10 + 12 | 0;
 i13 = i10 + 24 | 0;
 if (HEAP32[i13 >> 2] << 14 >>> 0 > i1 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i8 = i10 + 4 | 0;
 i9 = i10 + 28 | 0;
 i2 = i10 + 16 | 0;
 do {
  i3 = __ZnwjRK10MemLabelIdiPKci(20, i8, 16, gb + 461790 | 0, 61) | 0;
  HEAP32[i3 + 12 >> 2] = 16384;
  HEAP32[i3 + 16 >> 2] = 16384;
  i4 = i3 + 4 | 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i8);
  i7 = i11;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[i3 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(393216, 8, i4, 0, gb + 1047584 | 0, 446) | 0;
  i4 = HEAP32[i13 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i9 >> 2] = i1;
    HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i2, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i12 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i13 >> 2] = i5;
  HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 2) >> 2] = i3;
 } while ((HEAP32[i10 >> 2] | 0) >>> 0 >= i5 << 14 >>> 0);
 STACKTOP = i14;
 return;
}

function __ZN14DataBufferGLESC2ER17BufferManagerGLESiNS_11BufferUsageEb(i5, i1, i9, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 HEAP32[i5 >> 2] = i1;
 i7 = i5 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i9;
 i8 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = i5 + 16 | 0;
 switch (i2 | 0) {
 case 7:
 case 4:
 case 0:
  {
   i1 = 35044;
   break;
  }
 case 10:
 case 9:
 case 8:
 case 5:
 case 1:
  {
   i1 = 35048;
   break;
  }
 case 2:
 case 6:
  {
   i1 = 35040;
   break;
  }
 case 3:
  {
   i1 = 35046;
   break;
  }
 default:
  {
   HEAP32[i4 >> 2] = i2;
   _printf_console(gb + 602178 | 0, i4);
   i1 = 35048;
  }
 }
 HEAP32[i3 >> 2] = i1;
 HEAP8[i5 + 20 >> 0] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 __ZN14DataBufferGLES16RecreateWithDataEiPKv(i5, i9, 0);
 i3 = HEAP32[gb + 1451080 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 switch (HEAP32[i8 >> 2] | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
   } else i1 = 1;
   break;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 0 : 2;
   } else i1 = 0;
   break;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   break;
  }
 default:
  i1 = -559030611;
 }
 __ZN7ApiGLES18ClearBufferSubDataEjN2gl12BufferTargetEll(i3, i2, i1, 0, i9);
 STACKTOP = i10;
 return;
}

function __Z16CreateGpuProgram20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i1 = i7 + 4 | 0;
 switch (i3 | 0) {
 case 2:
 case 3:
 case 4:
 case 5:
 case 6:
 case 7:
 case 8:
  {
   i1 = (HEAP32[(__Z16GetRealGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
   if (i1 >>> 0 >= 10) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   if (!(521 >>> (i1 & 1023) & 1)) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 628 >> 2] | 0;
   if ((i2 | 0) > 0) i1 = 0; else {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   while (1) {
    if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 588 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i1 = 0;
     i6 = 9;
     break;
    }
   }
   if ((i6 | 0) == 9) {
    STACKTOP = i7;
    return i1 | 0;
   }
   i6 = __Znwj(100) | 0;
   __ZN18GlslGpuProgramGLESC2E20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i6, i3, i4, i5);
   STACKTOP = i7;
   return i6 | 0;
  }
 case 9:
 case 10:
 case 11:
 case 12:
 case 13:
 case 14:
 case 15:
 case 16:
 case 17:
 case 18:
 case 19:
 case 20:
 case 21:
 case 22:
 case 23:
 case 24:
 case 25:
 case 1:
  {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 default:
  {
   __Z6FormatPKcz(i1, gb + 396657 | 0, i2);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 396790 | 0, 878, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i8, i1, i2, i10, i11, i12, i3) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 if ((2147483630 - i8 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) i9 = HEAP32[i7 >> 2] | 0; else i9 = i7;
 if (i8 >>> 0 < 1073741799) {
  i5 = i1 + i8 | 0;
  i6 = i8 << 1;
  i5 = i5 >>> 0 < i6 >>> 0 ? i6 : i5;
  i5 = i5 >>> 0 < 11 ? 11 : i5 + 16 & -16;
 } else i5 = 2147483631;
 i4 = i7 + 12 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 66;
 HEAP32[i13 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 if (i10 | 0) _memcpy(i6 | 0, i9 | 0, i10 | 0) | 0;
 if (i12 | 0) _memcpy(i6 + i10 | 0, i3 | 0, i12 | 0) | 0;
 i1 = i2 - i11 | 0;
 i2 = i1 - i10 | 0;
 if (i2 | 0) _memcpy(i6 + i10 + i12 | 0, i9 + i10 + i11 | 0, i2 | 0) | 0;
 if ((i8 | 0) == 10) {
  HEAP32[i7 >> 2] = i6;
  i11 = i5 | -2147483648;
  i13 = i7 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i1 + i12 | 0;
  i12 = i7 + 4 | 0;
  HEAP32[i12 >> 2] = i13;
  i13 = i6 + i13 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 66;
 HEAP32[i13 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 HEAP32[i7 >> 2] = i6;
 i11 = i5 | -2147483648;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i1 + i12 | 0;
 i12 = i7 + 4 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i6 + i13 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i14;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i8, i1, i2, i10, i11, i12, i3) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 if ((2147483630 - i8 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) i9 = HEAP32[i7 >> 2] | 0; else i9 = i7;
 if (i8 >>> 0 < 1073741799) {
  i5 = i1 + i8 | 0;
  i6 = i8 << 1;
  i5 = i5 >>> 0 < i6 >>> 0 ? i6 : i5;
  i5 = i5 >>> 0 < 11 ? 11 : i5 + 16 & -16;
 } else i5 = 2147483631;
 i4 = i7 + 12 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 58;
 HEAP32[i13 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 if (i10 | 0) _memcpy(i6 | 0, i9 | 0, i10 | 0) | 0;
 if (i12 | 0) _memcpy(i6 + i10 | 0, i3 | 0, i12 | 0) | 0;
 i1 = i2 - i11 | 0;
 i2 = i1 - i10 | 0;
 if (i2 | 0) _memcpy(i6 + i10 + i12 | 0, i9 + i10 + i11 | 0, i2 | 0) | 0;
 if ((i8 | 0) == 10) {
  HEAP32[i7 >> 2] = i6;
  i11 = i5 | -2147483648;
  i13 = i7 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i1 + i12 | 0;
  i12 = i7 + 4 | 0;
  HEAP32[i12 >> 2] = i13;
  i13 = i6 + i13 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 58;
 HEAP32[i13 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 HEAP32[i7 >> 2] = i6;
 i11 = i5 | -2147483648;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i1 + i12 | 0;
 i12 = i7 + 4 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i6 + i13 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i14;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i8, i1, i2, i10, i11, i12, i3) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 if ((2147483630 - i8 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) i9 = HEAP32[i7 >> 2] | 0; else i9 = i7;
 if (i8 >>> 0 < 1073741799) {
  i5 = i1 + i8 | 0;
  i6 = i8 << 1;
  i5 = i5 >>> 0 < i6 >>> 0 ? i6 : i5;
  i5 = i5 >>> 0 < 11 ? 11 : i5 + 16 & -16;
 } else i5 = 2147483631;
 i4 = i7 + 12 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 54;
 HEAP32[i13 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 if (i10 | 0) _memcpy(i6 | 0, i9 | 0, i10 | 0) | 0;
 if (i12 | 0) _memcpy(i6 + i10 | 0, i3 | 0, i12 | 0) | 0;
 i1 = i2 - i11 | 0;
 i2 = i1 - i10 | 0;
 if (i2 | 0) _memcpy(i6 + i10 + i12 | 0, i9 + i10 + i11 | 0, i2 | 0) | 0;
 if ((i8 | 0) == 10) {
  HEAP32[i7 >> 2] = i6;
  i11 = i5 | -2147483648;
  i13 = i7 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i1 + i12 | 0;
  i12 = i7 + 4 | 0;
  HEAP32[i12 >> 2] = i13;
  i13 = i6 + i13 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 54;
 HEAP32[i13 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 HEAP32[i7 >> 2] = i6;
 i11 = i5 | -2147483648;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i1 + i12 | 0;
 i12 = i7 + 4 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i6 + i13 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i14;
 return;
}

function __ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2 + 24 | 0;
 i6 = i2 + 12 | 0;
 i8 = i2;
 __ZL19GetCameraTargetRectRK6Camerab(i7, i1, 1);
 f3 = Math_fround(HEAPF32[i1 + 864 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 868 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 872 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f3 = Math_fround(f3 * f11);
 f4 = Math_fround(f4 * f11);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i7 + 12 >> 2]));
 f13 = Math_fround(HEAPF32[i7 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f3 = Math_fround(f3 + f13);
 f5 = Math_fround(f5 + f12);
 f4 = Math_fround(f4 + f3);
 f11 = Math_fround(f11 + f13);
 f3 = f3 < f13 ? f13 : f3;
 f5 = f5 < f12 ? f12 : f5;
 f4 = Math_fround((f4 > f11 ? f11 : f4) - f3);
 i9 = f4 < Math_fround(0.0);
 f4 = i9 ? Math_fround(0.0) : f4;
 i9 = i1 + 924 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i6 >> 2] = f3;
 HEAPF32[i6 + 4 >> 2] = f5;
 HEAP32[i6 + 8 >> 2] = i10;
 __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i7, i1, i6);
 f4 = Math_fround(f3 + f4);
 i9 = HEAP32[i9 >> 2] | 0;
 HEAPF32[i8 >> 2] = f4;
 HEAPF32[i8 + 4 >> 2] = f5;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i6, i1, i8);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2]));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i6 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i6 + 8 >> 2]));
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f3 * f3))));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 208 | 0;
 i7 = i10 + 136 | 0;
 i4 = i10 + 104 | 0;
 i8 = i10 + 72 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i7);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 1, i7 + 12 | 0, i3);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 2, i7 + 36 | 0, i3);
 STACKTOP = i10;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 372; else i1 = (HEAP32[i1 >> 2] | 0) + 372 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 434; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4crnd12crn_unpacker12unpack_levelEPKvjPPvjjj(i7, i8, i9, i10, i11, i2, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i7 + 88 >> 2] | 0;
 i4 = (HEAPU8[i6 + 12 >> 0] << 8 | HEAPU8[i6 + 13 >> 0]) >>> i1;
 i5 = (HEAPU8[i6 + 14 >> 0] << 8 | HEAPU8[i6 + 15 >> 0]) >>> i1;
 i4 = ((i4 >>> 0 > 1 ? i4 : 1) + 3 | 0) >>> 2;
 i5 = ((i5 >>> 0 > 1 ? i5 : 1) + 3 | 0) >>> 2;
 i6 = i6 + 18 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i1 = Math_imul(i4, i1 << 24 >> 24 == 0 | i1 << 24 >> 24 == 9 ? 8 : 16) | 0;
 if (i2) if ((i2 & 3 | 0) == 0 & i1 >>> 0 <= i2 >>> 0) i1 = i2; else {
  i11 = 0;
  return i11 | 0;
 }
 if ((Math_imul(i1, i5) | 0) >>> 0 > i11 >>> 0) {
  i11 = 0;
  return i11 | 0;
 }
 i2 = (i4 + 1 | 0) >>> 1;
 i3 = (i5 + 1 | 0) >>> 1;
 if (!i9) {
  i11 = 0;
  return i11 | 0;
 }
 HEAP32[i7 + 92 >> 2] = i8;
 HEAP32[i7 + 96 >> 2] = i8;
 HEAP32[i7 + 104 >> 2] = i9;
 HEAP32[i7 + 100 >> 2] = i8 + i9;
 HEAP32[i7 + 108 >> 2] = 0;
 HEAP32[i7 + 112 >> 2] = 0;
 switch (HEAP8[i6 >> 0] | 0) {
 case 0:
  {
   if (!(__ZN4crnd12crn_unpacker11unpack_dxt1EPPhjjjjjj(i7, i10, i11, i1, i4, i5, i2, i3) | 0)) {
    i11 = 0;
    return i11 | 0;
   }
   break;
  }
 case 4:
 case 6:
 case 5:
 case 3:
 case 2:
  {
   if (!(__ZN4crnd12crn_unpacker11unpack_dxt5EPPhjjjjjj(i7, i10, i11, i1, i4, i5, i2, i3) | 0)) {
    i11 = 0;
    return i11 | 0;
   }
   break;
  }
 case 9:
  {
   if (!(__ZN4crnd12crn_unpacker12unpack_dxt5aEPPhjjjjjj(i7, i10, i11, i1, i4, i5, i2, i3) | 0)) {
    i11 = 0;
    return i11 | 0;
   }
   break;
  }
 case 8:
 case 7:
  {
   if (!(__ZN4crnd12crn_unpacker10unpack_dxnEPPhjjjjjj(i7, i10, i11, i1, i4, i5, i2, i3) | 0)) {
    i11 = 0;
    return i11 | 0;
   }
   break;
  }
 default:
  {
   i11 = 0;
   return i11 | 0;
  }
 }
 i11 = 1;
 return i11 | 0;
}

function __ZN15ApplicationInfo19GetBundleIdentifierEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i7 = i8;
 i3 = __Z17GetPlayerSettingsv() | 0;
 i1 = i3 + 556 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 560 >> 2] | 0;
 } else {
  i2 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, i1);
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) {
   i9 = i6;
   i9 = i9 + i3 | 0;
   HEAP8[i9 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   STACKTOP = i8;
   return;
  } else i1 = i6;
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i9 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 i9 = i1;
 i9 = i9 + i3 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN13RenderManager15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = __Znwj(76) | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i2 + 20 >> 2] = i4;
 HEAP32[i2 + 24 >> 2] = 0;
 i4 = i2 + 28 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i2 + 32 >> 2] = i4;
 HEAP32[i2 + 36 >> 2] = 0;
 i4 = i2 + 40 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i2 + 44 >> 2] = i4;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP8[i2 + 52 >> 0] = 0;
 i4 = i2 + 60 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = i4;
 i4 = i2 + 68 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i2 + 72 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1112268 >> 2] = i2;
 __Z21InitializeHaloManagerv();
 i2 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 if (i2 >>> 0 <= 63) {
  i4 = i2;
  i2 = i4 + 1 | 0;
  HEAP32[gb + 1156840 + 768 >> 2] = i2;
  i2 = gb + 1156840 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  i2 = gb + 1156840 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i2 >> 0] = 0;
  i4 = gb + 1156840 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 29;
  STACKTOP = i3;
  return;
 }
 __Z6FormatPKcz(i1, gb + 1048800 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i4 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 i2 = i4 + 1 | 0;
 HEAP32[gb + 1156840 + 768 >> 2] = i2;
 i2 = gb + 1156840 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i2 = gb + 1156840 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 0;
 i4 = gb + 1156840 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 29;
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i8 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i12 >> 2] | 0) - i3 >> 5 >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i9 = i8 + 12 | 0;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i1 = i2;
  i7 = i3;
 } else {
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = 73;
  HEAP32[i11 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 5, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i1 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i5 + (i2 - i3 >> 5 << 5) | 0;
 i6 = i3;
 i4 = i5 + (i4 << 5) | 0;
 if ((i1 | 0) == (i7 | 0)) i2 = i6; else {
  i2 = i6;
  do {
   i15 = i1;
   i1 = i1 + -32 | 0;
   HEAP32[i3 + -32 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + -28 >> 2] = HEAP32[i15 + -28 >> 2];
   HEAP32[i3 + -24 >> 2] = HEAP32[i15 + -24 >> 2];
   HEAP32[i3 + -20 >> 2] = HEAP32[i15 + -20 >> 2];
   HEAP32[i3 + -16 >> 2] = HEAP32[i15 + -16 >> 2];
   HEAP32[i3 + -12 >> 2] = HEAP32[i15 + -12 >> 2];
   i15 = i15 + -8 | 0;
   i14 = HEAP32[i15 + 4 >> 2] | 0;
   i5 = i3 + -8 | 0;
   HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
   HEAP32[i5 + 4 >> 2] = i14;
   i3 = i2 + -32 | 0;
   i2 = i3;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i12 >> 2] = i4;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i15 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = 73;
 HEAP32[i11 + 4 >> 2] = i15;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i13;
 return;
}

function __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE17handleBufferFlushEPKhj(i7, i11, i12) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!((i11 | 0) != 0 & (i12 | 0) != 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
 i8 = i7 + 8 | 0;
 i10 = i7 + 20 | 0;
 i9 = i7 + 16 | 0;
 i2 = i7 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (((HEAP32[i10 >> 2] | 0) + i12 - (HEAP32[i9 >> 2] | 0) | 0) >>> 0 >= i1 >>> 0) {
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (i1 >>> 0 <= i12 >>> 0) {
  i3 = HEAP32[i7 + 36 >> 2] | 0;
  if (!i3) return;
  i1 = i7 + 32 | 0;
  i2 = 0;
  do {
   i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i11 | 0, i12 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3;
 i5 = i1 - i4 | 0;
 i2 = i5 + i12 | 0;
 i6 = i7 + 24 | 0;
 if (((HEAP32[i6 >> 2] | 0) - i4 | 0) >>> 0 <= i2 >>> 0) {
  i4 = i2 << 1;
  if (!i4) {
   i2 = 0;
   i1 = i3;
  } else {
   i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, HEAP32[i7 + 12 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i5 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 | 0) {
    i8 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
   }
  }
  HEAP32[i9 >> 2] = i2;
  i1 = i2 + i5 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i6 >> 2] = i2 + i4;
 }
 _memcpy(i1 | 0, i11 | 0, i12 | 0) | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i12;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i13 + 16 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i5 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i8 + (i5 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 36 | 0;
 i3 = i13 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i2 + (i11 << 3) >> 2] | 0;
   i16 = i15 + ~(i15 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i6 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP32[i8 + (i11 << 3) >> 2] = i15;
   HEAP32[i8 + (i11 << 3) + 4 >> 2] = HEAP32[i2 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i4 >> 2] = i5;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx34PxArticulationJointGeneratedValuesC2EPKNS_19PxArticulationJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i2 + 28 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i2 + 56 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i2 + 72 | 0, i1 | 0);
 HEAP32[i2 + 84 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 88 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 92 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 96 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 100 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 112 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 116 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 120 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
 HEAP8[i2 + 124 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAP8[i2 + 136 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAPF32[i2 + 140 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 144 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0, i2 + 104 | 0, i2 + 108 | 0);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i2 + 128 | 0, i2 + 132 | 0);
 return;
}

function __ZN5physx2Cm8PtrTable15replaceWithLastEjRNS0_22PtrTableStorageManagerE(i7, i4, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i7 + 4 | 0;
 i1 = HEAP16[i5 >> 1] | 0;
 switch (i1 << 16 >> 16) {
 case 1:
  {
   HEAP32[i7 >> 2] = 0;
   HEAP16[i5 >> 1] = 0;
   HEAP8[i7 + 7 >> 0] = 0;
   return;
  }
 case 2:
  {
   i3 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i3 + (1 - i4 << 2) >> 2] | 0;
   i2 = i7 + 6 | 0;
   if (HEAP8[i2 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, i3 | 0, 8);
   HEAP32[i7 >> 2] = i1;
   HEAP16[i5 >> 1] = 1;
   HEAP8[i7 + 7 >> 0] = 1;
   HEAP8[i2 >> 0] = 1;
   return;
  }
 default:
  {
   i2 = i1 + -1 << 16 >> 16;
   HEAP16[i5 >> 1] = i2;
   i2 = i2 & 65535;
   i3 = HEAP32[i7 >> 2] | 0;
   HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
   i3 = i7 + 6 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i1 = i2 + -1 | 0;
    i1 = i1 >>> 1 | i1;
    i1 = i1 >>> 2 | i1;
    i1 = i1 >>> 4 | i1;
    i1 = i1 >>> 8 | i1;
    i1 = mftCall_iii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, ((i1 >>> 16 | i1) << 2) + 4 | 0) | 0;
    _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAPU16[i5 >> 1] << 2 | 0) | 0;
    if (HEAP8[i3 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0, 0);
    HEAP32[i7 >> 2] = i1;
    HEAP8[i3 >> 0] = 1;
    return;
   }
   if (i2 + 65535 & i2 | 0) return;
   if (mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i2 << 1 | 0, i2 | 0) | 0) return;
   i1 = mftCall_iii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 << 2 | 0) | 0;
   _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAPU16[i5 >> 1] << 2 | 0) | 0;
   if (HEAP8[i3 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0, i2 << 3 | 0);
   HEAP32[i7 >> 2] = i1;
   HEAP8[i3 >> 0] = 1;
   return;
  }
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i8 - i1 >> 4;
 HEAP32[i4 >> 2] = i5;
 i9 = i13 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i13 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 11 | 0;
  i3 = HEAP8[i2 >> 0] | 0;
  i7 = i1 + 4 | 0;
  i4 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  HEAP32[i11 >> 2] = i4;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i9 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
   i3 = HEAP8[i2 >> 0] | 0;
  }
  i4 = i3 << 24 >> 24 < 0;
  i2 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i4 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
  i4 = i2 + i7 | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i12;
 return;
}

function __ZN10VertexData13SwapEndianessEv(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = i14 + 84 | 0;
 i16 = i14 + 92 | 0;
 i13 = 0;
 do {
  i1 = HEAP8[i14 + 32 + (i13 * 12 | 0) + 10 >> 0] | 0;
  if (i1 << 24 >> 24) {
   i12 = i1 & 255;
   i1 = (HEAP32[i15 >> 2] | 0) + (HEAP32[i14 + 32 + (i13 * 12 | 0) + 4 >> 2] | 0) | 0;
   i9 = Math_imul(HEAP32[i16 >> 2] | 0, i12) | 0;
   i10 = i1 + i9 | 0;
   i11 = HEAP32[i14 + 32 + (i13 * 12 | 0) >> 2] | 0;
   if (i9 | 0) do {
    i2 = 0;
    i8 = 0;
    i9 = 1;
    while (1) {
     if (i9 & i11) {
      i4 = HEAP8[i14 + (i8 << 2) + 3 >> 0] | 0;
      i6 = i4 & 255;
      i3 = HEAP8[i14 + (i8 << 2) + 2 >> 0] | 0;
      i5 = HEAP8[(i3 & 255) + (gb + 430676) >> 0] | 0;
      i7 = i5 & 255;
      L11 : do if ((i3 & 255) < 2) {
       i3 = i1 + i2 | 0;
       switch (i5 << 24 >> 24) {
       case 2:
        {
         if (!(i4 << 24 >> 24)) break L11;
         i4 = 0;
         while (1) {
          HEAP16[i3 >> 1] = _llvm_bswap_i16(HEAP16[i3 >> 1] | 0) | 0;
          i4 = i4 + 1 | 0;
          if ((i4 | 0) == (i6 | 0)) break; else i3 = i3 + 2 | 0;
         }
         break;
        }
       case 4:
        {
         if (!(i4 << 24 >> 24)) break L11;
         i4 = 0;
         while (1) {
          HEAP32[i3 >> 2] = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
          i4 = i4 + 1 | 0;
          if ((i4 | 0) == (i6 | 0)) break; else i3 = i3 + 4 | 0;
         }
         break;
        }
       default:
        break L11;
       }
      } while (0);
      i2 = (Math_imul(i7, i6) | 0) + i2 | 0;
     }
     i8 = i8 + 1 | 0;
     if ((i8 | 0) == 8) break; else i9 = i9 << 1;
    }
    i1 = i1 + i12 | 0;
   } while ((i1 | 0) != (i10 | 0));
  }
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 4);
 return;
}

function _ps_hints_t1reset(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i8 + 4 | 0;
 if (HEAP32[i11 >> 2] | 0) {
  STACKTOP = i12;
  return;
 }
 i9 = HEAP32[i8 >> 2] | 0;
 L4 : do if ((HEAP32[i8 + 12 >> 2] | 0) == 1) {
  i5 = i8 + 28 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + (i1 << 4) + -16 + 12 >> 2] = i7;
  i6 = i1 + 1 | 0;
  i4 = i8 + 32 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if (i6 >>> 0 > i2 >>> 0) {
   HEAP32[i10 >> 2] = 0;
   i3 = i1 + 8 & -8;
   i1 = i8 + 36 | 0;
   i2 = _UNITY_ft_mem_realloc(i9, 16, i2, i3, HEAP32[i1 >> 2] | 0, i10) | 0;
   HEAP32[i1 >> 2] = i2;
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) {
    HEAP32[i4 >> 2] = i3;
    i1 = i2;
    break;
   } else break L4;
  } else i1 = HEAP32[i8 + 36 >> 2] | 0; while (0);
  i1 = i1 + (i6 << 4) + -16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i5 >> 2] = i6;
  i6 = i8 + 64 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i8 + 72 >> 2] | 0) + (i1 << 4) + -16 + 12 >> 2] = i7;
  i5 = i1 + 1 | 0;
  i4 = i8 + 68 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if (i5 >>> 0 > i2 >>> 0) {
   HEAP32[i10 >> 2] = 0;
   i3 = i1 + 8 & -8;
   i1 = i8 + 72 | 0;
   i2 = _UNITY_ft_mem_realloc(i9, 16, i2, i3, HEAP32[i1 >> 2] | 0, i10) | 0;
   HEAP32[i1 >> 2] = i2;
   i1 = HEAP32[i10 >> 2] | 0;
   if (!i1) {
    HEAP32[i4 >> 2] = i3;
    i1 = i2;
    break;
   } else break L4;
  } else i1 = HEAP32[i8 + 72 >> 2] | 0; while (0);
  i11 = i1 + (i5 << 4) + -16 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 12 >> 2] = 0;
  HEAP32[i6 >> 2] = i5;
  STACKTOP = i12;
  return;
 } else i1 = 6; while (0);
 HEAP32[i11 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i6 + 32 | 0;
 i14 = i6 + 16 | 0;
 i11 = i6;
 i15 = HEAP32[i5 + 4 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(-f12);
 f10 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i14 >> 2] = Math_fround(-f7);
 HEAPF32[i14 + 4 >> 2] = f12;
 HEAPF32[i14 + 8 >> 2] = f10;
 HEAPF32[i14 + 12 >> 2] = Math_fround(0.0);
 __ZNK5physx2Gu18ConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVE(i13, i15, i14, HEAP32[i5 + 12 >> 2] | 0);
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i11, HEAP32[i5 + 8 >> 2] | 0, i1);
 HEAP32[i3 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 f10 = Math_fround(HEAPF32[i13 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i11 + 8 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 STACKTOP = i6;
 return;
}

function __ZN8Animator11ClearObjectEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (HEAP32[i4 + 100 >> 2] & 16 | 0) return;
 __ZN6Object11InvokeEventEi(i4, 3);
 i1 = i4 + 188 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 __ZN8Animator13AvatarDataSet5ResetEv(i4 + 124 | 0);
 i2 = i4 + 604 | 0;
 i1 = i4 + 620 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 608 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 616 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 168 | 0;
 __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i4 + 176 | 0);
 HEAP32[i4 + 172 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 624 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
  __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(HEAP32[i1 >> 2] | 0, 0);
 }
 i1 = i4 + 628 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) {
  i3 = HEAP32[(HEAP32[i4 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0);
 }
 i2 = i4 + 584 | 0;
 i3 = i4 + 600 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 588 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 596 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i4 + 426 >> 0] = 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) {
  i3 = HEAP32[(HEAP32[i4 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0);
 }
 if (!(HEAP8[i4 + 33 >> 0] | 0)) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 168 >> 2] | 0, i4 | 0);
 __ZN8UserList5ClearEv(i4 + 480 | 0);
 __ZN12UserListNode5ClearEv(i4 + 468 | 0);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f14 = f0, i15 = 0, i16 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i4 = i13 + 16 | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 f14 = Math_fround(i1 >>> 0);
 i5 = ~~Math_fround(f14 * Math_fround(HEAPF32[i13 + 24 >> 2])) >>> 0;
 i9 = i1 << 2;
 i8 = (i5 << 2) + i9 | 0;
 i8 = (0 - i8 & 12) + i8 | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, i8 + (i5 << 3) | 0, gb + 778479 | 0, 341) | 0;
 i7 = i6 + i9 | 0;
 i8 = i6 + i8 | 0;
 _memset(i6 | 0, -1, i9 | 0) | 0;
 i9 = i13 + 36 | 0;
 i3 = i13 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i10 = i1 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 0;
  do {
   i15 = HEAP32[i2 + (i11 << 3) >> 2] | 0;
   i16 = i15 + ~(i15 << 15) | 0;
   i16 = (i16 >>> 10 ^ i16) * 9 | 0;
   i16 = i16 >>> 6 ^ i16;
   i16 = i16 + ~(i16 << 11) | 0;
   i16 = i6 + (((i16 >>> 16 ^ i16) & i10) << 2) | 0;
   HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i16 >> 2];
   HEAP32[i16 >> 2] = i11;
   HEAP32[i8 + (i11 << 3) >> 2] = i15;
   HEAP32[i8 + (i11 << 3) + 4 >> 2] = HEAP32[i2 + (i11 << 3) + 4 >> 2];
   i11 = i11 + 1 | 0;
  } while (i11 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, HEAP32[i13 >> 2] | 0);
 HEAP32[i13 >> 2] = i6;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 20 >> 2] = i1;
 HEAP32[i13 + 8 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 HEAP32[i4 >> 2] = i5;
 i1 = i13 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 208 | 0;
 i7 = i10 + 136 | 0;
 i4 = i10 + 104 | 0;
 i8 = i10 + 72 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i7);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 1, i7 + 12 | 0, i3);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 2, i7 + 36 | 0, i3);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 208 | 0;
 i7 = i10 + 136 | 0;
 i4 = i10 + 104 | 0;
 i8 = i10 + 72 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i7);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 1, i7 + 12 | 0, i3);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 2, i7 + 36 | 0, i3);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 208 | 0;
 i7 = i10 + 136 | 0;
 i4 = i10 + 104 | 0;
 i8 = i10 + 72 | 0;
 i5 = i10;
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (!i1) i1 = 76; else i1 = (HEAP32[i1 >> 2] | 0) + 76 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i5;
 i2 = i1 + 72 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i5);
 mftCall_vii(HEAP32[i6 + 16 >> 2] | 0, i8 | 0, HEAP32[i9 + 8 >> 2] | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i9 = HEAP32[i9 + 16 >> 2] | 0;
 __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i7);
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 1, i7 + 12 | 0, i3);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i4, 2, i7 + 36 | 0, i3);
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 12 | 0;
 i10 = i12;
 i6 = (i8 | 0) != 0;
 if (i6) i1 = HEAP16[i8 + 60 >> 1] | 0; else i1 = 1;
 i7 = (i9 | 0) != 0;
 if (i7) i5 = HEAP16[i9 + 60 >> 1] | 0; else i5 = 1;
 if ((i1 | 0) != (i5 | 0)) {
  i11 = (i1 | 0) < (i5 | 0);
  STACKTOP = i12;
  return i11 | 0;
 }
 if (i6) __ZNK15ReflectionProbe16GetGlobalExtentsEv(i11, i8); else {
  HEAP32[i11 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 if (i7) {
  __ZNK15ReflectionProbe16GetGlobalExtentsEv(i10, i9);
  f3 = Math_fround(HEAPF32[i10 >> 2]);
  f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
  f2 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 } else {
  i7 = HEAP32[gb + 1162364 >> 2] | 0;
  HEAP32[i10 >> 2] = i7;
  i8 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
  HEAP32[i10 + 4 >> 2] = i8;
  i9 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
  HEAP32[i10 + 8 >> 2] = i9;
  f3 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f2 = (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f13 * f13);
 f14 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f14 = Math_fround(f13 + Math_fround(f14 * f14));
 f13 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 i11 = Math_fround(f14 + Math_fround(f13 * f13)) > Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f2 * f2));
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN14DetailRenderer7CleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i4 + 64 >> 2] | 0;
 i3 = i4 + 68 | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   HEAP8[i2 + 26 >> 0] = 0;
   i1 = i2 + 20 | 0;
   __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 __Z19DestroySingleObjectP6Object(HEAP32[i4 + 4 >> 2] | 0);
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 i3 = i4 + 80 | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   HEAP8[i2 + 26 >> 0] = 0;
   i1 = i2 + 20 | 0;
   __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 __Z19DestroySingleObjectP6Object(HEAP32[i4 + 8 >> 2] | 0);
 i2 = HEAP32[i4 + 88 >> 2] | 0;
 i3 = i4 + 92 | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 while (1) {
  HEAP8[i2 + 26 >> 0] = 0;
  i1 = i2 + 20 | 0;
  __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN12MeshCollider13AwakeFromLoadE17AwakeFromLoadMode(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i3 = i6 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i5 = i6 + 60 | 0;
  i8 = HEAPU8[i5 >> 0] | 0;
  do if ((i8 | 0) != ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) == 4 | 0)) {
   i1 = HEAP8[i5 >> 0] | 0;
   if (!(i1 << 24 >> 24 != 0 | (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 132 >> 2] | 0, i6 | 0) | 0) ^ 1)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737019 | 0, 0, gb + 736492 | 0, 475, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
    break;
   }
   HEAP8[i5 >> 0] = i1;
   i1 = HEAP32[i6 + 28 >> 2] | 0;
   if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i6 | 0, 0);
  } while (0);
  if (HEAP32[i3 >> 2] | 0) {
   if ((HEAP32[i6 + 68 >> 2] | 0) == (HEAP32[i6 + 64 >> 2] | 0)) {
    if (HEAP8[i6 + 120 >> 0] | 0) i4 = 11;
   } else i4 = 11;
   if ((i4 | 0) == 11) {
    i1 = HEAP32[i6 + 28 >> 2] | 0;
    if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i6 | 0, 0);
   }
   i8 = i6 + 124 | 0;
   f2 = Math_fround(HEAPF32[i8 >> 2]);
   i4 = f2 < Math_fround(1.00000005e-20);
   i3 = f2 > Math_fround(340282326000000008404918.0e15);
   f2 = i3 ? Math_fround(340282326000000008404918.0e15) : f2;
   f2 = i4 ? Math_fround(1.00000005e-20) : f2;
   HEAPF32[i8 >> 2] = f2;
   if (HEAP8[i5 >> 0] | 0) if (HEAP8[i6 + 121 >> 0] | 0) if (f2 != Math_fround(HEAPF32[i6 + 128 >> 2])) {
    i1 = HEAP32[i6 + 28 >> 2] | 0;
    if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i6 | 0, 0);
   }
  }
 }
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i6, i7);
 return;
}

function __ZN12AdsIdHandlerD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i6 + 64 | 0;
 i1 = i6 + 72 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = HEAP32[i6 + 68 >> 2] | 0;
  i3 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  if ((i4 | 0) != (i5 | 0)) {
   i2 = i6 + 76 | 0;
   i3 = i7 + 4 | 0;
   i1 = i4;
   do {
    i4 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i2 >> 2] | 0;
    HEAP32[i7 >> 2] = 5;
    HEAP32[i3 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 i5 = i6 + 48 | 0;
 i1 = i6 + 56 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i6 + 52 >> 2] | 0;
  i9 = (HEAP32[i5 >> 2] | 0) + 4 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[HEAP32[i9 >> 2] >> 2] = i4;
  HEAP32[i1 >> 2] = 0;
  if ((i2 | 0) != (i5 | 0)) {
   i3 = i6 + 60 | 0;
   i4 = i7 + 4 | 0;
   i1 = i2;
   do {
    i9 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[i7 >> 2] = 5;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i7);
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 i1 = i6 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i6 + 32 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i7);
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i9 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i7);
 STACKTOP = i8;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i8, i1, i2, i10, i11, i12, i3) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 if ((2147483630 - i8 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) i9 = HEAP32[i7 >> 2] | 0; else i9 = i7;
 if (i8 >>> 0 < 1073741799) {
  i5 = i1 + i8 | 0;
  i6 = i8 << 1;
  i5 = i5 >>> 0 < i6 >>> 0 ? i6 : i5;
  i5 = i5 >>> 0 < 11 ? 11 : i5 + 16 & -16;
 } else i5 = 2147483631;
 i4 = i7 + 12 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i13, 0, gb + 1049224 | 0, 75) | 0;
 if (i10 | 0) _memcpy(i6 | 0, i9 | 0, i10 | 0) | 0;
 if (i12 | 0) _memcpy(i6 + i10 | 0, i3 | 0, i12 | 0) | 0;
 i1 = i2 - i11 | 0;
 i2 = i1 - i10 | 0;
 if (i2 | 0) _memcpy(i6 + i10 + i12 | 0, i9 + i10 + i11 | 0, i2 | 0) | 0;
 if ((i8 | 0) == 10) {
  HEAP32[i7 >> 2] = i6;
  i11 = i5 | -2147483648;
  i13 = i7 + 8 | 0;
  HEAP32[i13 >> 2] = i11;
  i13 = i1 + i12 | 0;
  i12 = i7 + 4 | 0;
  HEAP32[i12 >> 2] = i13;
  i13 = i6 + i13 | 0;
  HEAP8[i13 >> 0] = 0;
  STACKTOP = i14;
  return;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 HEAP32[i13 >> 2] = 1;
 HEAP32[i13 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i9, i13);
 HEAP32[i7 >> 2] = i6;
 i11 = i5 | -2147483648;
 i13 = i7 + 8 | 0;
 HEAP32[i13 >> 2] = i11;
 i13 = i1 + i12 | 0;
 i12 = i7 + 4 | 0;
 HEAP32[i12 >> 2] = i13;
 i13 = i6 + i13 | 0;
 HEAP8[i13 >> 0] = 0;
 STACKTOP = i14;
 return;
}

function __ZN5physx2Cm17FreeListAllocator10allocChunkEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i1 = __ZN5physx2Cm17FreeListAllocator11findBestFitEjRj(i8, i7, i4) | 0;
 if (!i1) {
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 16384, 0, gb + 732730 | 0, 140) | 0;
  if (!i2) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
  i3 = i8 + 4240 | 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i1 = i2 + 12 | 0;
  HEAP32[i1 >> 2] = 1610613759;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i4 >> 2] = 1023;
  i4 = 1023;
 } else i4 = HEAP32[i4 >> 2] | 0;
 if (i4 >>> 0 > i7 >>> 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i2 = i7 << 4;
  i6 = i1 + i2 | 0;
  i3 = i7 << 10;
  HEAP32[i6 >> 2] = i5 & 536870912 | i3 | (i5 & 1023) - i7;
  i2 = i2 | 4;
  i5 = i1 + i2 | 0;
  HEAP32[i1 + (i2 + 4) >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & 536870912)) {
   i2 = i1 + (i2 << 4 & 16368) | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i3;
   i2 = HEAP32[i1 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = i2 & 1074789376 | i7;
  i3 = i4 - i7 | 0;
  i4 = i8 + 148 + (i3 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) HEAP32[i2 + 8 >> 2] = i6;
  HEAP32[i4 >> 2] = i6;
  i7 = i3 >>> 5;
  i6 = i8 + 16 + (i7 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i3 & 31);
  i8 = i8 + 144 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << i7;
 }
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | -2147483648;
 i8 = i1 + 4 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx19PxsFluidSpatialHash31reorderParticleIndicesToPacketsEPjjRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPt(i8, i12, i1, i9, i11) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i7 = HEAP32[i10 >> 2] & 2147483647;
 if (!i7) return;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
  if (i3 | 0) {
   i2 = i1;
   i5 = i3;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i4 = 18;
   break;
  }
 }
 if ((i4 | 0) == 18) return;
 i3 = (Math_imul(i5 & 0 - i5, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i2 << 5;
 i1 = i5 + -1 & i5;
 L10 : do if (!i1) {
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if (i2 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L10;
   }
   i1 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
   if (!i1) i1 = i2; else break;
  }
 } while (0);
 if ((i3 | 0) == -1) return;
 i6 = HEAP32[i8 >> 2] | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 L18 : while (1) {
  i4 = i2 << 5;
  while (1) {
   i8 = HEAPU16[i11 + (i3 << 1) >> 1] | 0;
   i9 = i6 + (i8 << 4) + 8 | 0;
   HEAP32[i12 + ((HEAP32[i9 >> 2] | 0) + (HEAP32[i6 + (i8 << 4) + 12 >> 2] | 0) << 2) >> 2] = i3;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   if (!i1) {
    i4 = 18;
    break L18;
   }
   i3 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
   i1 = i1 + -1 & i1;
   if (!i1) break;
   if ((i3 | 0) == -1) {
    i4 = 18;
    break L18;
   }
  }
  i4 = HEAP32[i10 >> 2] & 2147483647;
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
   if (!i1) i1 = i2; else break;
  }
  if ((i3 | 0) == -1) {
   i4 = 18;
   break;
  }
 }
 if ((i4 | 0) == 18) return;
}

function __ZN5physx17PxsFluidCollision26processShapeListWithFilterEjj(i15, i2, i13) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16;
 i7 = i15 + 100 + (i2 * 44 | 0) | 0;
 i4 = HEAP32[i15 + 100 + (i2 * 44 | 0) + 12 >> 2] | 0;
 i3 = i4;
 i9 = i15 + 100 + (i2 * 44 | 0) + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  STACKTOP = i16;
  return;
 }
 i10 = i14 + 4 | 0;
 i11 = i14 + 8 | 0;
 i12 = i15 + 100 + (i2 * 44 | 0) + 4 | 0;
 i8 = i15 + 96 | 0;
 i6 = i15 + 100 + (i2 * 44 | 0) + 20 | 0;
 do {
  HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = i2;
  i5 = i3 + 8 | 0;
  HEAP32[i11 >> 2] = i5;
  i3 = i3 + (i2 << 4 | 8) | 0;
  i4 = i3;
  if (i2 >>> 0 >= i13 >>> 0) {
   HEAP32[i12 >> 2] = 0;
   if (i2 | 0) {
    i1 = 0;
    do {
     __ZN5physx17PxsFluidCollision19addTempW2STransformERNS0_8TaskDataERKNS_31PxsParticleStreamContactManagerE(i15, i7, i5 + (i1 << 4) | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
   }
   i5 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i5 + 8 >> 2] | 0;
   __ZN5physx17PxsFluidCollision25updateFluidShapeCollisionEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_9PxBounds3EPKjPKfPKNS_19PxsW2STransformTempERKNS_22PxsParticleStreamShapeE(i15, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i5 + 20 >> 2] | 0, HEAP32[i5 + 64 >> 2] | 0, HEAP32[i5 + 68 >> 2] | 0, i5 + 44 | 0, HEAP32[i5 + 60 >> 2] | 0, i6, HEAP32[i5 + 36 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, HEAP32[i7 >> 2] | 0, i14);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 } while ((i3 | 0) != (i1 | 0));
 STACKTOP = i16;
 return;
}

function __ZN20LocalFileSystemPosix10ToAbsoluteEPKc(i4, i3, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 12 | 0;
 i2 = i6;
 if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i5 | 0) | 0) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, _strlen(i5) | 0);
  STACKTOP = i6;
  return;
 }
 if ((HEAP8[i5 >> 0] | 0) != 126) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i3 = _strlen(gb + 1546878 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1546878 | 0, i3);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i5, _strlen(i5) | 0);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i4, i1, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i6;
  return;
 }
 i2 = i3 + 4 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 8 >> 2] | 0; else i1 = i1 & 255;
 do if (!i1) {
  i1 = _getenv(gb + 491503 | 0) | 0;
  if (!i1) {
   i1 = HEAP32[(_getpwuid(_getuid() | 0) | 0) + 20 >> 2] | 0;
   if (!i1) break;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i1) | 0;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i4, i5 + 1 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 8 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 16 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 17 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP32[i6 + 12 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 20 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 36 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform(i4, i5, i7, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i8 = i10 + 4 | 0;
 i9 = i10;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i1 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i1, i2, 0) | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 i2 = i5 + 4 | 0;
 L5 : do switch (HEAP32[i2 >> 2] | 0) {
 case 1:
  {
   i1 = HEAP32[i1 + 28 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   i2 = 1;
   i3 = i1;
   i6 = 10;
   break;
  }
 case 4:
  {
   HEAP32[i3 >> 2] = i1;
   i2 = 4;
   i3 = i1;
   i6 = 10;
   break;
  }
 case 21:
  {
   i1 = __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(HEAP32[i1 + 28 >> 2] | 0, 25, HEAP32[i5 + 12 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (!i1) {
    i9 = 0;
    STACKTOP = i10;
    return i9 | 0;
   } else {
    i2 = HEAP32[i2 >> 2] | 0;
    i3 = i1;
    i6 = 10;
    break L5;
   }
  }
 default:
  if (__Z21BindGenericFloatCurveRK7CurveIDRP6ObjectP10GameObjectP9TransformRPvRiRN11UnityEngine9Animation10BoundCurveE(i5, i3, 0, i1, i8, i9, i7) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   break L5;
  } else {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 } while (0);
 if ((i6 | 0) == 10) if (!(__ZN15AnimationBinder18CalculateTargetPtrEiP6ObjectPKcPPvPi(i4, i2, i3, HEAP32[i5 + 8 >> 2] | 0, i8, i9) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 12 >> 2] = i1;
 HEAP32[i7 + 16 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = 1;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z36GetBlendShapeFrameVerticesFromScriptRK4MeshiiP11Il2CppArrayS3_S3_(i10, i11, i12, i7, i8, i9) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 8 | 0;
 i2 = i14;
 if ((i11 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i2);
 i13 = i10 + 112 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (((HEAP32[i10 + 116 >> 2] | 0) - i1 >> 4 | 0) <= (i11 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i2);
 if ((i12 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404154 | 0, i3);
 if ((HEAP32[i1 + (i11 << 4) + 12 >> 2] | 0) <= (i12 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404154 | 0, i3);
 i6 = HEAP32[(HEAP32[i10 + 32 >> 2] | 0) + 100 >> 2] | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0;
 i4 = (i8 | 0) != 0;
 if (i4) i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0; else i2 = i6;
 i5 = (i9 | 0) != 0;
 if (i5) i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i9) | 0; else i3 = i6;
 if (!((i1 | 0) == (i6 | 0) & (i2 | 0) == (i6 | 0) & (i3 | 0) == (i6 | 0))) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404192 | 0, i14 + 16 | 0);
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 12) | 0;
 if (i4) i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 12) | 0; else i2 = 0;
 if (i5) i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i9, 0, 12) | 0; else i1 = 0;
 __Z21GetBlendShapeVerticesP8Vector3fS0_S0_RK13dynamic_arrayI16BlendShapeVertexLj4EERK10BlendShapei(i3, i2, i1, i10 + 72 | 0, (HEAP32[i10 + 92 >> 2] | 0) + (((HEAP32[(HEAP32[i13 >> 2] | 0) + (i11 << 4) + 8 >> 2] | 0) + i12 | 0) * 12 | 0) | 0, i6);
 STACKTOP = i14;
 return;
}

function __Z21WWW_CUSTOM_GetTextureP12Il2CppObjecth(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 32 | 0;
 i8 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i4 = i9 + 8 | 0;
 i2 = i9;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i4);
 i5 = i1 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i4);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 580408 | 0, 249, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i11 = gb + 63520 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(4, i3) | 0;
 do if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
  i2 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8); else {
   __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb(i3, i2, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0, 0, i7 << 24 >> 24 != 0) | 0;
   break;
  }
 } else __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb(i3, 0, 0, 0, i7 << 24 >> 24 != 0) | 0; while (0);
 i11 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI8BlobSizeEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = i4 + 20 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  i2 = i4 + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (0 - i1 & 3) + i1;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i3, i4);
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(HEAP8[i6 >> 0] | 0)) i5 = 5; else {
   HEAP8[i6 >> 0] = 0;
   i5 = 7;
  }
 } else {
  HEAP8[i6 >> 0] = 0;
  i1 = i4 + 16 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = 5;
 }
 if ((i5 | 0) == 5) {
  HEAP32[i2 >> 2] = (0 - i1 & 3) + i1;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i3 + 40 | 0, i4);
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(HEAP8[i6 >> 0] | 0)) i5 = 7; else HEAP8[i6 >> 0] = 0;
 }
 if ((i5 | 0) == 7) {
  HEAP32[i2 >> 2] = (0 - i1 & 3) + i1;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i3 + 80 | 0, i4);
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (HEAP8[i6 >> 0] | 0) {
   HEAP8[i6 >> 0] = 0;
   i6 = i2;
   i5 = i1;
   i4 = 0 - i5 | 0;
   i4 = i4 & 3;
   i5 = i4 + i5 | 0;
   i4 = i5 + 4 | 0;
   i5 = 0 - i5 | 0;
   i5 = i5 & 3;
   i5 = i4 + i5 | 0;
   i5 = i5 + 2 | 0;
   HEAP32[i6 >> 2] = i5;
   return;
  }
 }
 i5 = (0 - i1 & 3) + i1 | 0;
 i5 = (0 - i5 & 3) + i5 | 0;
 i5 = i5 + 4 + (0 - i5 & 3) | 0;
 i5 = (0 - i5 & 3) + i5 | 0;
 i5 = i5 + 4 + (0 - i5 & 3) | 0;
 i5 = (0 - i5 & 3) + i5 | 0;
 i5 = i5 + 4 + (0 - i5 & 3) | 0;
 i5 = (0 - i5 & 3) + i5 | 0;
 HEAP32[i2 >> 2] = i5;
 i6 = i2;
 i4 = 0 - i5 | 0;
 i4 = i4 & 3;
 i5 = i4 + i5 | 0;
 i4 = i5 + 4 | 0;
 i5 = 0 - i5 | 0;
 i5 = i5 & 3;
 i5 = i4 + i5 | 0;
 i5 = i5 + 2 | 0;
 HEAP32[i6 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8IntervalENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = i10 + 44 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = i9 << 3;
  i2 = i10 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i1 = mftCall_iiiiii(i4 | 0, i5 | 0, i1 | 0, (i6 ? gb + 731600 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 << 3) | 0;
 i6 = i10 + 36 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i13 = i3;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i2;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i11 = i7;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i1 + (i2 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 do if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) == (i2 | 0)) {
   HEAP8[i10 + 32 >> 0] = 0;
   break;
  }
  if (i2 | 0) {
   i13 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i2 | 0);
  }
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = i9;
 i13 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i13 + 1;
 return i1 + (i13 << 3) | 0;
}

function __ZN5physx3Ext18ProfileZoneHandler11flushEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i11 = i1 + 8 | 0;
 i9 = i1 + 4 | 0;
 i10 = i12 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 do {
  i2 = i2 + -1 | 0;
  i8 = i1 + (i2 << 2) | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  HEAP8[i3 + 52 >> 0] = 0;
  HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] = i3;
  i8 = (HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0) + 12 | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0);
  i8 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  if (!i3) i1 = i8 + 28 | 0; else {
   i6 = i8 + 4 | 0;
   i1 = i8 + 28 | 0;
   i7 = i8 + 24 | 0;
   do {
    i3 = i3 + -1 | 0;
    i5 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i8, i5, i6);
    i4 = HEAP32[i1 >> 2] | 0;
    if (i4 | 0) do {
     i4 = i4 + -1 | 0;
     __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i8, i5, (HEAP32[i7 >> 2] | 0) + (i4 * 20 | 0) | 0);
    } while ((i4 | 0) != 0);
    __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE(i8, i5);
   } while ((i3 | 0) != 0);
  }
  HEAP32[i8 + 16 >> 2] = 0;
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[i8 + 24 >> 2] | 0;
   do {
    i1 = i1 + -1 | 0;
    HEAP32[i3 + (i1 * 20 | 0) + 12 >> 2] = 0;
   } while ((i1 | 0) != 0);
  }
  HEAP32[i8 + 44 >> 2] = 0;
  HEAP32[i8 + 36 >> 2] = 0;
  i1 = HEAP32[i11 >> 2] | 0;
  HEAP8[(HEAP32[i1 + (i2 << 2) >> 2] | 0) + 52 >> 0] = 1;
 } while ((i2 | 0) != 0);
 return;
}

function __ZN5physx2Sc9ShapeCore17resolveReferencesERNS_24PxDeserializationContextE(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i5 = i6 + 68 | 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case 4:
  {
   i3 = i6 + 100 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = i2;
   if (!i2) i2 = 4; else {
    i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i1 | 0) | 0;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   HEAP32[i5 >> 2] = i2;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 + 104 >> 2] = i1 + 16;
   return;
  }
 case 6:
  {
   i2 = i6 + 72 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i2 = 6; else {
    i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i1 | 0) | 0;
    HEAP32[i2 >> 2] = i1;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 + 92 >> 2] = i1 + 16;
   return;
  }
 case 5:
  {
   i2 = i6 + 104 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i1 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i1 | 0) | 0;
    HEAP32[i2 >> 2] = i1;
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i7 = i6 + 101 | 0;
   i8 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
   i3 = i7 + 4 | 0;
   i3 = (HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8) & 65535 | (HEAPU8[i3 + 2 >> 0] | 0) << 16;
   i4 = HEAP32[i1 + 176 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP8[i7 >> 0] = i8;
   HEAP8[i7 + 1 >> 0] = i8 >> 8;
   HEAP8[i7 + 2 >> 0] = i8 >> 16;
   HEAP8[i7 + 3 >> 0] = i8 >> 24;
   i5 = i7 + 4 | 0;
   i2 = i3 & 65535;
   HEAP8[i5 >> 0] = i2;
   HEAP8[i5 + 1 >> 0] = i2 >> 8;
   i3 = _bitshift64Lshr(i3 | 0, 0, 16) | 0;
   getTempRet0() | 0;
   HEAP8[i5 + 2 >> 0] = i3;
   HEAP32[i6 + 108 >> 2] = i1 + 16;
   HEAP32[i6 + 112 >> 2] = i4;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj161ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 272; else i1 = (HEAP32[i1 >> 2] | 0) + 272 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 161; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj161ES2_RKNS_12PxFilterDataES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i2 = i9 + 8 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i6 = i7 + 12 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i2 = i3;
  i1 = i3;
  break;
 } else {
  i2 = i3;
  i1 = i3;
 } while (0);
 if (i5 >>> 0 > i4 >>> 0) {
  _memset(i2 + (i4 << 2) | 0, 0, i5 - i4 << 2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine15PlatformWrapper17GetCloudProjectIdEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 i4 = __Z17GetPlayerSettingsv() | 0;
 i2 = i4 + 44 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 if (i5 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 + 48 >> 2] | 0;
 } else {
  i3 = i2;
  i2 = i5 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i3, i2);
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i2 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i8 = 7;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   STACKTOP = i9;
   return;
  }
 } else i8 = 7;
 if ((i8 | 0) == 7) {
  i5 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine15PlatformWrapper16GetVRDeviceModelEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 32 | 0;
 i7 = i8;
 i2 = __Z12GetIVRDevicev() | 0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i7 | 0, i2 | 0);
  i4 = HEAP32[i7 >> 2] | 0;
  i4 = (i4 | 0) == 0 ? i7 + 4 | 0 : i4;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i6 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i6 = 8;
  } else i6 = 6;
  if ((i6 | 0) == 6) {
   i9 = i5 + 16 & -16;
   HEAP32[i3 >> 2] = 66;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i3;
   i6 = 8;
  }
  if ((i6 | 0) == 8) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
  if (!(HEAP32[i7 + 4 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 24 | 0);
  STACKTOP = i8;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN11TimeManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 200 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 196 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 204 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Sc8BodyCore22addSpatialAccelerationEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i2, i4, i7, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i5 = 0, f8 = f0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim28notifyAddSpatialAccelerationEv(i1);
 i5 = i2 + 156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i2 = i4 + 292 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i3 = i4 + 280 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i4 + 284 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = 8;
 } else if (HEAP8[i1 + 31 >> 0] | 0) i3 = 8;
 if ((i3 | 0) == 8) {
  i2 = i1;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  HEAP32[i5 >> 2] = i1;
 }
 i5 = i1 + 12 | 0;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 2;
 if (i7 | 0) {
  f8 = Math_fround(HEAPF32[i7 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i1 >> 2]));
  f8 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  i5 = i1 + 4 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i7 = i1 + 8 | 0;
  HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 }
 if (!i6) return;
 f8 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i1 + 16 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 f8 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i7 = i1 + 20 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 f8 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i7 = i1 + 24 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i7 >> 2]));
 return;
}

function __ZN5physx16PxsIslandManager10removeNodeERNS_20PxsIslandManagerHookIjLj4294967295EEE(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = (HEAP32[i10 + 16 >> 2] | 0) + (i5 * 12 | 0) + 8 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 i8 = (i7 & 1) != 0;
 HEAP8[i6 >> 0] = i7 & 255 | 32;
 i4 = i10 + 320 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i10 + 324 | 0;
 if ((i2 | 0) == (HEAP32[i1 >> 2] | 0)) {
  i13 = i10 + 308 | 0;
  i12 = i2 << 1;
  i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, i2 << 4, gb + 681489 | 0, 1482) | 0;
  i3 = i14 + (i12 << 2) | 0;
  _memcpy(i14 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 + 312 >> 2] << 2 | 0) | 0;
  i2 = i10 + 316 | 0;
  _memcpy(i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i13 >> 2] | 0);
  HEAP32[i13 >> 2] = i14;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = i12;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i10 + 316 >> 2] | 0;
  i1 = i2;
 }
 HEAP32[i3 + (i1 << 2) >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 if (!(i7 & 2)) {
  i14 = i10 + 444 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + ((i8 ^ 1) << 31 >> 31);
  i14 = i10 + 452 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + (i8 << 31 >> 31);
  HEAP32[i9 >> 2] = -1;
  i14 = i10 + 477 | 0;
  HEAP8[i14 >> 0] = 1;
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i6 >> 0] & 4)) {
  HEAP32[i9 >> 2] = -1;
  i14 = i10 + 477 | 0;
  HEAP8[i14 >> 0] = 1;
  STACKTOP = i11;
  return;
 }
 i14 = i10 + 448 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -1;
 HEAP32[i9 >> 2] = -1;
 i14 = i10 + 477 | 0;
 HEAP8[i14 >> 0] = 1;
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine15PlatformWrapper15GetVRDeviceNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 32 | 0;
 i7 = i8;
 i2 = __Z12GetIVRDevicev() | 0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0, i7 | 0, i2 | 0);
  i4 = HEAP32[i7 >> 2] | 0;
  i4 = (i4 | 0) == 0 ? i7 + 4 | 0 : i4;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  i5 = _strlen(i4) | 0;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i6 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i6 = 8;
  } else i6 = 6;
  if ((i6 | 0) == 6) {
   i9 = i5 + 16 & -16;
   HEAP32[i3 >> 2] = 66;
   HEAP32[i3 + 4 >> 2] = i2;
   i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i3;
   i6 = 8;
  }
  if ((i6 | 0) == 8) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
  if (!(HEAP32[i7 + 4 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 24 | 0);
  STACKTOP = i8;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 904242 | 0, i2, i4);
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 4 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 904255 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 904275 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 904286 | 0, HEAP32[gb + 37012 >> 2] | 0, i2, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__217__assoc_sub_state28set_exception_at_thread_exitESt13exception_ptr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 i6 = i2 + 12 | 0;
 __ZNSt3__25mutex4lockEv(i6);
 if (!(HEAP32[i2 + 88 >> 2] & 1)) {
  HEAP32[i3 >> 2] = 0;
  i7 = (HEAP32[i2 + 8 >> 2] | 0) == 0;
  __ZNSt13exception_ptrD2Ev(i3);
  if (i7) {
   __ZNSt13exception_ptraSERKS_(i2 + 8 | 0, i1) | 0;
   __THREW__ = 0;
   i1 = invoke_i(fb + 313 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) i2 = 5; else {
    __THREW__ = 0;
    i1 = invoke_ii(fb + 2801 | 0, HEAP32[i1 >> 2] | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 5; else {
     __THREW__ = 0;
     invoke_vii(fb + 4501 | 0, i1 | 0, i2 | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) i2 = 5; else {
      __ZNSt3__25mutex6unlockEv(i6);
      STACKTOP = i5;
      return;
     }
    }
   }
  } else i2 = 3;
 } else i2 = 3;
 do if ((i2 | 0) == 3) {
  i1 = ___cxa_allocate_exception(16) | 0;
  __ZNSt3__215future_categoryEv() | 0;
  HEAP32[i4 >> 2] = 2;
  HEAP32[i4 + 4 >> 2] = gb + 1473484;
  __THREW__ = 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  invoke_vii(fb + 4499 | 0, i1 | 0, i3 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i7;
   break;
  } else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
   __THREW__ = 0;
   i2 = 5;
   break;
  }
 } while (0);
 if ((i2 | 0) == 5) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__25mutex6unlockEv(i6);
 ___resumeException(i1 | 0);
}

function __ZN5Umbra9intersectERKNS_7Vector4ERKNS_4AABBE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i18 = HEAP32[i1 >> 2] | 0;
 i17 = HEAP32[i1 + 4 >> 2] | 0;
 i16 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = i2 + 12 | 0;
 i15 = (i18 | 0) > -1;
 i13 = HEAP32[i2 >> 2] | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i11 = (i17 | 0) > -1;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = (i16 | 0) > -1;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 f12 = (HEAP32[tempDoublePtr >> 2] = i18, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15 ? i13 : i14, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f12);
 f7 = (HEAP32[tempDoublePtr >> 2] = i17, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f4 + Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i9 : i10, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
 f3 = (HEAP32[tempDoublePtr >> 2] = i16, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(f4 + Math_fround((HEAP32[tempDoublePtr >> 2] = i6 ? i2 : i5, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3));
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f8 + f4);
 f12 = Math_fround((HEAP32[tempDoublePtr >> 2] = i15 ? i14 : i13, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f12);
 f7 = Math_fround(f12 + Math_fround((HEAP32[tempDoublePtr >> 2] = i11 ? i10 : i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f7));
 f3 = Math_fround(f8 + Math_fround(f7 + Math_fround((HEAP32[tempDoublePtr >> 2] = i6 ? i5 : i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * f3)));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 return (i2 ^ (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) | 0) < 0 | 0;
}

function __ZN21BillboardBatchManager19TransformBillboardsEPvS0_RK19SharedBillboardDataPKNS_17BillboardInstanceEjjj(i15, i2, i1, i11, i14, i10, i3) {
 i15 = i15 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i16 = 0, i17 = 0;
 i17 = HEAP32[i1 + 48 >> 2] | 0;
 i16 = HEAP32[i1 + 60 >> 2] | 0;
 i9 = HEAP32[i1 + 68 >> 2] | 0;
 i8 = (HEAP32[i1 + 80 >> 2] | 0) >>> 1;
 if (!(i14 >>> 0 >= i10 >>> 0 | (i8 | 0) == 0)) {
  i4 = i14;
  while (1) {
   i7 = i3 << 16 | i3;
   i1 = 0;
   i5 = i9;
   i6 = i2;
   while (1) {
    HEAP32[i6 >> 2] = (HEAP32[i5 >> 2] | 0) + i7;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i8 | 0)) break; else {
     i5 = i5 + 4 | 0;
     i6 = i6 + 4 | 0;
    }
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i10 | 0)) break; else {
    i2 = i2 + (i8 << 2) | 0;
    i3 = i3 + i16 | 0;
   }
  }
 }
 i13 = i11 + (i10 << 5) | 0;
 if ((i14 | 0) >= (i10 | 0) | (i16 | 0) == 0) return;
 i12 = i16 * 9 | 0;
 i11 = i11 + (i14 << 5) | 0;
 i1 = i15;
 while (1) {
  i4 = i11 + 4 | 0;
  i5 = i11 + 8 | 0;
  i6 = i11 + 12 | 0;
  i7 = i11 + 16 | 0;
  i8 = i11 + 20 | 0;
  i9 = i11 + 24 | 0;
  i10 = i11 + 28 | 0;
  i2 = 0;
  i3 = i1;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i17 + (i2 << 3) >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i17 + (i2 << 3) + 4 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i3 + 32 >> 2] = HEAP32[i10 >> 2];
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i16 | 0)) break; else i3 = i3 + 36 | 0;
  }
  i11 = i11 + 32 | 0;
  if (i11 >>> 0 >= i13 >>> 0) break; else i1 = i1 + (i12 << 2) | 0;
 }
 return;
}

function __ZN13GfxDeviceGLES21RegisterNativeTextureE9TextureIDi16TextureDimension(i1, i2, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i3 = i7;
 i6 = i7 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i5, i1, i3);
  i2 = HEAP32[i5 >> 2] | 0;
  i10 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (i1 | 0) {
   i10 = i1;
   HEAP32[i10 >> 2] = i8;
   i10 = i10 + 16 | 0;
   HEAP32[i10 >> 2] = i9;
   STACKTOP = i7;
   return;
  }
 }
 i10 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 17) | 0;
 HEAP32[i10 >> 2] = 0;
 i3 = i10 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 2;
 HEAP32[i10 + 20 >> 2] = 3;
 HEAP32[i10 + 24 >> 2] = 1;
 HEAP32[i10 + 28 >> 2] = 1;
 HEAP32[i10 + 32 >> 2] = 1;
 HEAP32[i10 + 36 >> 2] = 1;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i5, i10);
 HEAP32[i10 >> 2] = i8;
 i10 = i10 + 16 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i7;
 return;
}

function __ZN5physx9PxTaskMgr10resolveRowEjb(i13, i2, i1) {
 i13 = i13 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = i13 + 76 | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i3 = HEAP32[i5 + (i2 * 20 | 0) + 12 >> 2] | 0;
 i2 = HEAP32[i5 + (i2 * 20 | 0) >> 2] | 0;
 if (!i2) i10 = 0; else i10 = HEAP32[i2 + 16 >> 2] | 0;
 if ((i3 | 0) == -1) {
  i12 = i1;
  i13 = i13 + 56 | 0;
  __ZN5physx6shdfnd15atomicDecrementEPVi(i13) | 0;
  return i12 | 0;
 }
 i11 = i13 + 64 | 0;
 if (!i10) {
  i2 = i3;
  while (1) {
   i4 = HEAP32[i11 >> 2] | 0;
   i3 = i4 + (i2 << 3) | 0;
   if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i5 + ((HEAP32[i3 >> 2] | 0) * 20 | 0) + 4 | 0) | 0)) i1 = i1 | (__ZN5physx9PxTaskMgr12dispatchTaskEjb(i13, HEAP32[i3 >> 2] | 0, i1) | 0);
   i2 = HEAP32[i4 + (i2 << 3) + 4 >> 2] | 0;
   if ((i2 | 0) == -1) break;
   i5 = HEAP32[i12 >> 2] | 0;
  }
  i13 = i13 + 56 | 0;
  __ZN5physx6shdfnd15atomicDecrementEPVi(i13) | 0;
  return i1 | 0;
 } else {
  i2 = i3;
  i6 = 0;
 }
 while (1) {
  i9 = HEAP32[i11 >> 2] | 0;
  i7 = i9 + (i2 << 3) | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 + (i8 * 20 | 0) >> 2] | 0;
  do if (i3) if ((HEAP32[i5 + (i8 * 20 | 0) + 8 >> 2] | 0) == 1) {
   i4 = i3 + 16 | 0;
   if (HEAP32[i4 >> 2] | 0) {
    HEAP8[i3 + 20 >> 0] = 1;
    break;
   }
   if (i6) {
    HEAP8[i3 + 20 >> 0] = 1;
    i6 = 1;
    break;
   } else {
    HEAP32[i4 >> 2] = i10;
    i6 = 1;
    break;
   }
  } while (0);
  if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i5 + (i8 * 20 | 0) + 4 | 0) | 0)) i1 = i1 | (__ZN5physx9PxTaskMgr12dispatchTaskEjb(i13, HEAP32[i7 >> 2] | 0, i1) | 0);
  i2 = HEAP32[i9 + (i2 << 3) + 4 >> 2] | 0;
  if ((i2 | 0) == -1) break;
  i5 = HEAP32[i12 >> 2] | 0;
 }
 i13 = i13 + 56 | 0;
 __ZN5physx6shdfnd15atomicDecrementEPVi(i13) | 0;
 return i1 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 116; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i4 >> 0] = 1;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (!i1) i1 = 141; else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i1 = i3;
 }
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_(i5, i1, i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 if (!(_JS_WebCam_IsSupported() | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = _JS_WebCamVideo_GetNumDevices() | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i3 = i7 + 11 | 0;
 i4 = i10 + 8 | 0;
 i1 = 0;
 do {
  i5 = (_JS_WebCamVideo_GetDeviceName(i1 | 0, 0) | 0) + 1 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i7, i5, 0);
  _JS_WebCamVideo_GetDeviceName(i1 | 0, ((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0) | 0;
  HEAP32[i6 >> 2] = __Z20scripting_string_newPKc((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
  __ZN13WebCamTexture16EnsureUniqueNameER16MonoWebCamDeviceRKNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier56ELi16EEEE(i6, i10);
  i5 = HEAP32[i8 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i6); else {
   i12 = i6;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i5 + 4 >> 2] = i11;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 8;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN2UI14CanvasRenderer17SetMaterialNoSyncEP8MaterialiR13dynamic_arrayI4PPtrIS1_ELj4EE(i1, i9, i10, i7) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i4 = i8;
 if ((HEAP32[i7 + 12 >> 2] | 0) >>> 0 <= i10 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1012841 | 0, 0, gb + 1011708 | 0, 227, 1, 0, 0, 0);
  i10 = 0;
  STACKTOP = i8;
  return i10 | 0;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i3 + (i10 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i4);
    i2 = HEAP32[i2 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 11;
   }
  }
  if ((i6 | 0) == 9) i6 = 11;
  if ((i6 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if (!i9) i2 = 0; else i2 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i3 + (i10 << 2) >> 2] = i2;
 i10 = (i1 | 0) != (i9 | 0);
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_(i5, i8, i6, i7, i4) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if ((i7 | 0) >= 0) {
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  if ((i1 | 0) >= (i7 | 0)) {
   i3 = 1 << i1 - i7;
   if ((i8 | 0) < 0) {
    if ((i8 | 0) == -1) {
     i1 = i5 + 12 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     if (i2 | 0) {
      HEAP32[i4 >> 2] = i2;
      i8 = __ZN15TerrainRenderer7GetNodeEiii(HEAP32[i1 >> 2] | 0, i3 + -1 | 0, i6, i7) | 0;
      return i8 | 0;
     }
    }
   } else if ((i3 | 0) > (i6 | 0) & ((i6 | 0) > -1 & (i3 | 0) > (i8 | 0))) {
    HEAP32[i4 >> 2] = i5;
    i1 = 1 << i1;
    if ((i7 | 0) > 0) {
     i2 = i1;
     i1 = 0;
     i3 = 0;
     do {
      i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
      i2 = i2 >> 1;
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
    } else {
     i2 = i1;
     i1 = 0;
    }
    i8 = i1 + i8 + (Math_imul(i2, i6) | 0) | 0;
    i8 = (HEAP32[i5 + 16 >> 2] | 0) + (i8 << 6) | 0;
    return i8 | 0;
   }
   if ((i3 | 0) == (i8 | 0)) {
    i1 = i5 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i4 >> 2] = i2;
     i8 = __ZN15TerrainRenderer7GetNodeEiii(HEAP32[i1 >> 2] | 0, 0, i6, i7) | 0;
     return i8 | 0;
    }
   }
   if ((i3 | 0) == (i6 | 0)) {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) {
     HEAP32[i4 >> 2] = i1;
     i8 = __ZN15TerrainRenderer7GetNodeEiii(HEAP32[i5 >> 2] | 0, i8, 0, i7) | 0;
     return i8 | 0;
    }
   }
   if ((i6 | 0) == -1) {
    i1 = i5 + 8 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i4 >> 2] = i2;
     i8 = __ZN15TerrainRenderer7GetNodeEiii(HEAP32[i1 >> 2] | 0, i8, i3 + -1 | 0, i7) | 0;
     return i8 | 0;
    }
   }
   HEAP32[i4 >> 2] = 0;
   i8 = 0;
   return i8 | 0;
  }
 }
 HEAP32[i4 >> 2] = 0;
 i8 = 0;
 return i8 | 0;
}

function __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 48 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 56 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN15ApplicationInfo10GetVersionEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i7 = i8;
 i3 = __Z17GetPlayerSettingsv() | 0;
 i1 = i3 + 572 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 576 >> 2] | 0;
 } else {
  i2 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, i1);
 i3 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
 i3 = i1 ? HEAP32[i7 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i9 = 7;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i6 + 11 >> 0] = i3;
  if (!i3) {
   i9 = i6;
   i9 = i9 + i3 | 0;
   HEAP8[i9 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   STACKTOP = i8;
   return;
  } else i1 = i6;
 } else i9 = 7;
 if ((i9 | 0) == 7) {
  i9 = i3 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i3;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 i9 = i1;
 i9 = i9 + i3 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 108 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 100 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN4math4Axes8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906532 | 0, gb + 906539 | 0, i1, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906546 | 0, gb + 906539 | 0, i4, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 906554 | 0, 0);
 i4 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906567 | 0, gb + 906575 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 906590 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 906596 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906581 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 68 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 913271 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = i12 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i10, 4);
  i3 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i1 >> 2] = i3;
  i3 = i9;
 }
 i9 = i13 + 11 | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i8 = i13 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 & 255;
 i2 = i4 ? i5 : i6;
 do if (i3 >>> 0 > i2 >>> 0) {
  i7 = i3 - i2 | 0;
  if (i7 | 0) {
   if (i4) {
    i2 = (HEAP32[i13 + 8 >> 2] & 2147483647) + -1 | 0;
    i3 = i5;
   } else {
    i2 = 10;
    i3 = i6;
   }
   if ((i2 - i3 | 0) >>> 0 < i7 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i13, i2, i7 - i2 + i3 | 0, i3, i3, 0, 0);
    i1 = HEAP8[i9 >> 0] | 0;
   }
   i2 = i1 << 24 >> 24 < 0 ? HEAP32[i13 >> 2] | 0 : i13;
   _memset(i2 + i3 | 0, 1, i7 | 0) | 0;
   i1 = i3 + i7 | 0;
   if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
   HEAP8[i2 + i1 >> 0] = 0;
  }
 } else if (i4) {
  HEAP8[(HEAP32[i13 >> 2] | 0) + i3 >> 0] = 0;
  HEAP32[i8 >> 2] = i3;
  break;
 } else {
  HEAP8[i13 + i3 >> 0] = 0;
  HEAP8[i9 >> 0] = i3;
  break;
 } while (0);
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i12, (HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, i1);
 STACKTOP = i11;
 return;
}

function __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 4 | 0, i7);
 i4 = i6 + 56 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags(i7, (HEAP32[i4 >> 2] | 0) + 8 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i7, (HEAP32[i4 >> 2] | 0) + 28 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 8 | 0, gb + 410551 | 0, 0);
 i4 = i6 + 24 | 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 28 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 36 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i7, i8, gb + 410593 | 0, 0);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 36 | 0;
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i7, i8, gb + 410593 | 0, 0);
  return;
 }
}

function __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE13set_empty_keyERSE_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i7 = i8 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 i9 = i8 + 24 | 0;
 i5 = i2 + 24 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i8 | 0) != (i2 | 0)) {
  i5 = HEAP32[i2 >> 2] | 0;
  i11 = (i5 | 0) == 0;
  i5 = i11 ? i2 + 4 | 0 : i5;
  i6 = HEAP32[i2 + 20 >> 2] | 0;
  i3 = i8 + 4 | 0;
  if (!((HEAP32[i2 + 4 >> 2] | 0) != 0 | i11)) {
   HEAP32[i8 >> 2] = i5;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i3 >> 2] = 0;
   break;
  }
  if (i6 >>> 0 > 15) {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 + 1 | 0, 16, i9, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i8 >> 2] = i11;
   HEAP32[i3 >> 2] = i6;
   i1 = (i11 | 0) == 0 ? i1 : i11;
  }
  _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  HEAP32[i7 >> 2] = i6;
 } while (0);
 HEAP32[i8 + 32 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13set_empty_keyERKSA_(i4, i8);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i8 + 4 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __iup_worker_interpolate(i11, i4, i18, i1, i2) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 if (i4 >>> 0 > i18 >>> 0) return;
 i17 = HEAP32[i11 + 12 >> 2] | 0;
 if (!(i17 >>> 0 > i1 >>> 0 & i17 >>> 0 > i2 >>> 0)) return;
 i12 = i11 + 8 | 0;
 i16 = HEAP32[i12 >> 2] | 0;
 i10 = HEAP32[i16 + (i1 << 3) >> 2] | 0;
 i16 = HEAP32[i16 + (i2 << 3) >> 2] | 0;
 i15 = (i10 | 0) > (i16 | 0);
 i3 = i15 ? i10 : i16;
 i10 = i15 ? i16 : i10;
 i16 = i15 ? i1 : i2;
 i15 = i15 ? i2 : i1;
 i6 = HEAP32[i11 >> 2] | 0;
 i13 = HEAP32[i6 + (i15 << 3) >> 2] | 0;
 i14 = HEAP32[i6 + (i16 << 3) >> 2] | 0;
 i9 = i11 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i15 = HEAP32[i5 + (i15 << 3) >> 2] | 0;
 i1 = HEAP32[i5 + (i16 << 3) >> 2] | 0;
 i16 = i15 - i13 | 0;
 i17 = i1 - i14 | 0;
 if ((i3 | 0) == (i10 | 0) | (i1 | 0) == (i15 | 0)) {
  i2 = i4;
  do {
   i1 = HEAP32[i6 + (i2 << 3) >> 2] | 0;
   if ((i1 | 0) > (i13 | 0)) i1 = (i1 | 0) < (i14 | 0) ? i15 : i1 + i17 | 0; else i1 = i1 + i16 | 0;
   HEAP32[i5 + (i2 << 3) >> 2] = i1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 <= i18 >>> 0);
  return;
 }
 i8 = i3 - i10 | 0;
 i7 = i1 - i15 | 0;
 i1 = 0;
 i2 = 0;
 i3 = i6;
 while (1) {
  i3 = HEAP32[i3 + (i4 << 3) >> 2] | 0;
  do if ((i3 | 0) > (i13 | 0)) {
   if ((i3 | 0) >= (i14 | 0)) {
    i3 = i3 + i17 | 0;
    break;
   }
   if (!(i1 << 24 >> 24)) {
    i1 = 1;
    i2 = _UNITY_FT_DivFix(i7, i8) | 0;
   }
   i3 = (_UNITY_FT_MulFix((HEAP32[(HEAP32[i12 >> 2] | 0) + (i4 << 3) >> 2] | 0) - i10 | 0, i2) | 0) + i15 | 0;
   i5 = HEAP32[i9 >> 2] | 0;
  } else i3 = i3 + i16 | 0; while (0);
  HEAP32[i5 + (i4 << 3) >> 2] = i3;
  i3 = i4 + 1 | 0;
  if (i3 >>> 0 > i18 >>> 0) break;
  i4 = i3;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 return;
}

function __ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i1 = HEAP16[i6 + 8 >> 1] | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 if (i1 << 16 >> 16 == -1) {
  i6 = HEAP32[i6 >> 2] | 0;
  f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f2);
  f3 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * f3));
  f7 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  f7 = Math_fround(f3 + Math_fround(f7 * Math_fround(HEAPF32[i5 + 8 >> 2])));
  f3 = Math_fround(HEAPF32[i6 + 16 >> 2]);
  f3 = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
  f2 = Math_fround(HEAPF32[i6 + 20 >> 2]);
  f2 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i4 + 4 >> 2])));
  f3 = Math_fround(HEAPF32[i6 + 24 >> 2]);
  f3 = Math_fround(f7 + Math_fround(f2 + Math_fround(f3 * Math_fround(HEAPF32[i4 + 8 >> 2]))));
  return Math_fround(f3);
 } else {
  i1 = i1 & 65535;
  i6 = (HEAP32[i6 >> 2] | 0) + 128 | 0;
  f15 = Math_fround(HEAPF32[i6 + (i1 << 5) >> 2]);
  f14 = Math_fround(HEAPF32[i6 + (i1 << 5) + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i6 + (i1 << 5) + 8 >> 2]);
  f11 = Math_fround(HEAPF32[i6 + (i1 << 5) + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i6 + (i1 << 5) + 20 >> 2]);
  f7 = Math_fround(HEAPF32[i6 + (i1 << 5) + 24 >> 2]);
  f12 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f10 = Math_fround(HEAPF32[i4 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(f15 * f2) + Math_fround(f14 * f3)) + Math_fround(f13 * f12)) + Math_fround(Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f8)) + Math_fround(f7 * Math_fround(HEAPF32[i4 + 8 >> 2]))));
  return Math_fround(f7);
 }
 return f0;
}

function __ZNK21EnlightenSceneMapping19GetTerrainChunkUVSTER8Vector4fiRK7Hash128(i1, i13, i15, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, f20 = f0, f21 = f0;
 i16 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i16) {
  i18 = 0;
  return i18 | 0;
 }
 i17 = HEAP32[i1 + 100 >> 2] | 0;
 i14 = HEAP32[i1 + 20 >> 2] | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i12 = i2;
 i11 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i5 = i2 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = 0;
 L4 : while (1) {
  i6 = HEAP32[i17 + (i3 * 12 | 0) >> 2] | 0;
  if ((HEAP32[i10 + ((HEAP32[i14 + (i6 * 56 | 0) >> 2] | 0) * 40 | 0) >> 2] | 0) == (i15 | 0)) {
   i7 = HEAP32[i17 + (i3 * 12 | 0) + 4 >> 2] | 0;
   i8 = HEAP32[i17 + (i3 * 12 | 0) + 8 >> 2] | 0;
   i9 = Math_imul(i8, i7) | 0;
   if ((i9 | 0) > 0) {
    i1 = 0;
    do {
     i2 = i6 + i1 | 0;
     i19 = i14 + (i2 * 56 | 0) + 24 | 0;
     if ((HEAP32[i19 >> 2] | 0) == (i11 | 0) ? (HEAP32[i19 + 4 >> 2] | 0) == (i12 | 0) : 0) {
      i19 = i14 + (i2 * 56 | 0) + 32 | 0;
      if ((HEAP32[i19 >> 2] | 0) == (i4 | 0) ? (HEAP32[i19 + 4 >> 2] | 0) == (i5 | 0) : 0) break L4;
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i9 | 0));
   }
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i16 >>> 0) {
   i1 = 0;
   i18 = 10;
   break;
  }
 }
 if ((i18 | 0) == 10) return i1 | 0;
 f21 = Math_fround(Math_fround(1.0) / Math_fround(i7 | 0));
 HEAPF32[i13 >> 2] = f21;
 f20 = Math_fround(Math_fround(1.0) / Math_fround(i8 | 0));
 HEAPF32[i13 + 4 >> 2] = f20;
 HEAPF32[i13 + 8 >> 2] = Math_fround(f21 * Math_fround((i1 | 0) % (i7 | 0) | 0 | 0));
 HEAPF32[i13 + 12 >> 2] = Math_fround(f20 * Math_fround((i1 | 0) / (i7 | 0) | 0 | 0));
 i19 = 1;
 return i19 | 0;
}

function __ZN8Animator8GetFloatEiRfb(i5, i4, i6, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 if (i3) {
  if (!(HEAP8[i5 + 153 >> 0] | 0)) i1 = 4; else if (!(HEAP32[i5 + 168 >> 2] | 0)) i1 = 4;
  if ((i1 | 0) == 4) __ZN8Animator12CreateObjectEv(i5);
  if (HEAP32[i5 + 108 >> 2] | 0) {
   i1 = HEAP32[i5 + 624 >> 2] | 0;
   if (i1 | 0) {
    i1 = HEAP32[i1 + 96 >> 2] | 0;
    if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i5 + 420 >> 2];
   }
  }
 }
 i2 = i5 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i6 = 64;
  return i6 | 0;
 }
 if (i3) {
  if (!(HEAP32[i5 + 240 >> 2] | 0)) {
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   i6 = 8;
   return i6 | 0;
  }
  i2 = (HEAP32[i5 + 260 >> 2] | 0) + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = i2;
  i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i1 | 0) == 0 ? 0 : i3 + i1 | 0, i4) | 0;
  if ((i1 | 0) == -1) {
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   i6 = 4;
   return i6 | 0;
  } else {
   i4 = (HEAP32[i5 + 264 >> 2] | 0) + 16 | 0;
   i5 = (HEAP32[i2 >> 2] | 0) + i3 + 4 | 0;
   i4 = i4 + (HEAP32[i4 >> 2] | 0) + 28 | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 + (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 + (HEAP32[i5 >> 2] | 0) + (i1 * 12 | 0) + 8 >> 2] << 2) >> 2];
   i6 = 1;
   return i6 | 0;
  }
 }
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i6 = 64;
  return i6 | 0;
 }
 i1 = i5 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i1 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i5 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i5 + 584 | 0);
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i6 = 64;
  return i6 | 0;
 }
 i5 = HEAP32[HEAP32[i5 + 584 >> 2] >> 2] | 0;
 i6 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0, i4 | 0, i6 | 0) | 0;
 return i6 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 32, 4) | 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 + 24 >> 2] = 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i1 >> 2];
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i8, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i11 = (HEAP32[i8 >> 2] | 0) + (i1 << 4) | 0;
    i2 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i11 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
    HEAP32[i11 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __ZN9JSONWrite8TransferINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i5, i8, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i11 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i10;
 return;
}

function __ZNK5physx2Sc15ClothFabricCore18getParticleIndicesEPjj(i15, i16, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i9 = HEAP32[i15 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0;
 if (i9 >>> 0 > i14 >>> 0) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = i16;
 HEAP32[i11 + 4 >> 2] = i16 + (i9 << 2);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiiiiiii(i18 | 0, i14 | 0, i15 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i16 = i9;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i4, i5, i3, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i7 = i8 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((i5 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0) i1 = HEAP32[HEAP32[i4 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i5 | 0)) {
   i1 = (HEAP32[i4 + 100 >> 2] | 0) + 4 | 0;
   i7 = (HEAP32[i4 + 92 >> 2] | 0) + 4 | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 + (i5 << 2) | 0;
   i7 = (HEAP32[i1 >> 2] | 0) + i1 + (HEAP32[i7 + (HEAP32[i7 >> 2] | 0) >> 2] << 2) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i1 = (i1 | 0) == 0 ? 0 : i7 + i1 | 0;
   switch (i3 | 0) {
   case 0:
    {
     i1 = HEAP32[i1 + 8 >> 2] | 0;
     break;
    }
   case 2:
    {
     i1 = HEAP32[i1 + 16 >> 2] | 0;
     break;
    }
   case 1:
    {
     if (!(HEAP8[i1 + 81 >> 0] | 0)) i1 = -1; else i1 = HEAP32[i1 + 12 >> 2] | 0;
     break;
    }
   default:
    i1 = -1;
   }
   i7 = __ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo(i4, i5, i1, i6) | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i2 >> 2] = i5;
 __Z6FormatPKcz(i7, gb + 902210 | 0, i2);
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx9NpFactory20createParticleSystemEjb(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i7 = i10 + 12 | 0;
 if (!(HEAP32[gb + 1457352 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 280, gb + 700157 | 0, i10);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[gb + 1457204 >> 2] | 0;
 i6 = i1 + 3640 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i2 = i1 + 3636 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i1 + 3344 | 0);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i2 = i1 + 3624 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i1 + 3628 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx16NpParticleSystemC2Ejb(i3, i4, i5);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 if (!i3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 288, gb + 700258 | 0, i10 + 8 | 0);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i2 = i8 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i8 + 564 | 0, i7, i9) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i9 = i3;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb(i9, i2, i3) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 4 | 0;
 if ((i2 | 0) == 16) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 700312 | 0, 619, gb + 700404 | 0, i10);
  STACKTOP = i10;
  return;
 }
 i7 = i9 + 20 | 0;
 i8 = i9 + 24 | 0;
 if (!(HEAP32[i8 >> 2] & 32768)) i1 = __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i9 + 32 | 0) | 0; else i1 = HEAP16[(HEAP32[i9 + 28 >> 2] | 0) + 76 >> 1] | 0;
 if (i3) i6 = (i1 & 65535 | i2) & 65535; else i6 = i1 & ((i2 ^ 65535) & 65535);
 i1 = i9 + 32 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i3 = i7;
   i2 = 13;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 12; else {
    i3 = i7;
    i2 = 13;
   }
   break;
  }
 default:
  i2 = 12;
 }
 if ((i2 | 0) == 12) {
  HEAP16[i4 >> 1] = i6;
  __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE(i1, i4);
 } else if ((i2 | 0) == 13) {
  i2 = i9 + 28 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP16[i1 + 76 >> 1] = i6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i7);
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 32768;
 }
 if (!(__ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i9) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i4 = i5 + 4 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i3 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 12 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 13 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 14 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 * 48 | 0, 4) | 0;
  i2 = i3 + (i2 * 48 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 1065353216;
    HEAP32[i1 + 28 >> 2] = 1065353216;
    HEAP32[i1 + 32 >> 2] = 1065353216;
    HEAP32[i1 + 36 >> 2] = 1065353216;
    i9 = i1 + 40 | 0;
    HEAP32[i9 >> 2] = -1;
    HEAP32[i9 + 4 >> 2] = -1;
    i1 = i1 + 48 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i9 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i9 * 48 | 0) | 0;
 if (!i9) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN7mecanim5human6Handle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN15QualitySettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 28 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 40 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i9 = HEAP32[i7 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i8 >> 2] = i3;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN12WheelJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
 i1 = i7 + 96 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 104 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i7 + 108 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN14StackAllocator8AllocateEji(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 4 | 0;
 i8 = i12;
 i5 = i1 & 7 | 0 ? 8 : i1;
 i9 = i5 + -1 | 0;
 i4 = 0 - i5 | 0;
 i5 = i5 + 7 & i4;
 i7 = i11 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i11 + 32 >> 2] | 0;
  i1 = i2;
 } else {
  i1 = i1 + ((HEAP32[i1 + -4 >> 2] | 0) >>> 1) | 0;
  i2 = HEAP32[i11 + 32 >> 2] | 0;
 }
 i1 = i1 + i9 & i4;
 i3 = i1;
 i1 = i1 - i2 | 0;
 i2 = HEAP32[i11 + 36 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) if ((i2 - i1 | 0) >>> 0 >= (i9 + i10 + i5 & i4) >>> 0) {
  i3 = i3 + i5 | 0;
  i2 = i3 + -8 | 0;
  HEAP32[i2 + 4 >> 2] = i10 << 1;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i7 >> 2] = i3;
  i2 = i11 + 16 | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + i10 | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i11 + 28 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 8;
  i2 = i11 + 24 | 0;
  if (i1 >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) HEAP32[i2 >> 2] = i1;
  i11 = i11 + 12 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  i11 = i3;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((HEAP16[gb + 1103840 + 6 >> 1] | 0) > -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1103840 | 0, i6);
  i2 = gb + 1103840 | 0;
 } else i2 = 0;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i11 + 44 | 0) | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i10 | 0, (i9 | 15) + 1 | 0) | 0;
 if (!i2) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 i11 = i1;
 STACKTOP = i12;
 return i11 | 0;
}

function __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i2, i3, i1, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i6 = i2 + 60 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i3 + 12 | 0;
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i7 >> 2]);
 f8 = Math_fround(f12 * f11);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f14 * f9));
 f8 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f8);
 f9 = Math_fround(Math_fround(f11 * f14) + Math_fround(f12 * f9));
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i1 + 4 >> 2]));
 i1 = i4 + 12 | 0;
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f12 * f14);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f11 = Math_fround(f11 - Math_fround(f13 * f10));
 f11 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f11);
 f10 = Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * f10));
 f8 = Math_fround(f11 - f8);
 f9 = Math_fround(Math_fround(f10 + Math_fround(HEAPF32[i5 + 4 >> 2])) - f9);
 f9 = Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9));
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 if (f9 > Math_fround(f8 * f8)) return;
 HEAP32[i2 + 56 >> 2] = 0;
 i4 = i7;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i2 + 48 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i6 >> 2] = 1;
 i5 = i1;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function _UNITY_FT_Stroker_GetCounts(i10, i12, i13) {
 i10 = i10 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 if (!i10) {
  i5 = 6;
  i2 = 0;
  i1 = 0;
 } else {
  i1 = HEAP32[i10 + 64 >> 2] | 0;
  L3 : do if (!i1) {
   i2 = 0;
   i1 = 0;
   i11 = 9;
  } else {
   i7 = HEAP32[i10 + 76 >> 2] | 0;
   i5 = i1;
   i2 = 0;
   i1 = 0;
   i3 = 0;
   while (1) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = (i3 | 0) == 0;
    if (!(i6 & 4)) {
     if (i4) {
      i1 = 0;
      i2 = 0;
      break L3;
     }
    } else if (i4) i3 = 1; else {
     i1 = 0;
     i2 = 0;
     break L3;
    }
    i9 = i6 & 8;
    i2 = ((i9 & 255) >>> 3 & 255) + i2 | 0;
    i3 = i9 << 24 >> 24 == 0 ? i3 : 0;
    i5 = i5 + -1 | 0;
    i1 = i1 + 1 | 0;
    if (!i5) break; else i7 = i7 + 1 | 0;
   }
   if (!i3) i11 = 9; else {
    i1 = 0;
    i2 = 0;
   }
  } while (0);
  if ((i11 | 0) == 9) HEAP8[i10 + 92 >> 0] = 1;
  i3 = HEAP32[i10 + 96 >> 2] | 0;
  L15 : do if (!i3) {
   i4 = 0;
   i3 = 0;
   i11 = 17;
  } else {
   i9 = HEAP32[i10 + 108 >> 2] | 0;
   i7 = i3;
   i4 = 0;
   i3 = 0;
   i5 = 0;
   while (1) {
    i8 = HEAP8[i9 >> 0] | 0;
    i6 = (i5 | 0) == 0;
    if (!(i8 & 4)) {
     if (i6) {
      i3 = 0;
      i4 = 0;
      break L15;
     }
    } else if (i6) i5 = 1; else {
     i3 = 0;
     i4 = 0;
     break L15;
    }
    i8 = i8 & 8;
    i4 = ((i8 & 255) >>> 3 & 255) + i4 | 0;
    i5 = i8 << 24 >> 24 == 0 ? i5 : 0;
    i7 = i7 + -1 | 0;
    i3 = i3 + 1 | 0;
    if (!i7) break; else i9 = i9 + 1 | 0;
   }
   if (!i5) i11 = 17; else {
    i3 = 0;
    i4 = 0;
   }
  } while (0);
  if ((i11 | 0) == 17) HEAP8[i10 + 124 >> 0] = 1;
  i5 = 0;
  i2 = i4 + i2 | 0;
  i1 = i3 + i1 | 0;
 }
 if (i12 | 0) HEAP32[i12 >> 2] = i1;
 if (!i13) return i5 | 0;
 HEAP32[i13 >> 2] = i2;
 return i5 | 0;
}

function __ZNK5physx2Sc15ClothFabricCore16getTetherLengthsEPfj(i15, i16, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i9 = HEAP32[i15 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0) | 0;
 if (i9 >>> 0 > i14 >>> 0) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = i16;
 HEAP32[i13 + 4 >> 2] = i16 + (i9 << 2);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiiiiiii(i18 | 0, i14 | 0, i15 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i16 = i9;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZNK5physx2Sc15ClothFabricCore16getTetherAnchorsEPjj(i15, i16, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i9 = HEAP32[i15 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0) | 0;
 if (i9 >>> 0 > i14 >>> 0) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = i16;
 HEAP32[i12 + 4 >> 2] = i16 + (i9 << 2);
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiiiiiii(i18 | 0, i14 | 0, i15 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i16 = i9;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb(i9, i2, i3) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 4 | 0;
 if ((i2 | 0) == 16) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 700312 | 0, 619, gb + 700404 | 0, i10);
  STACKTOP = i10;
  return;
 }
 i7 = i9 + 20 | 0;
 i8 = i9 + 24 | 0;
 if (!(HEAP32[i8 >> 2] & 32768)) i1 = __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i9 + 32 | 0) | 0; else i1 = HEAP16[(HEAP32[i9 + 28 >> 2] | 0) + 76 >> 1] | 0;
 if (i3) i6 = (i1 & 65535 | i2) & 65535; else i6 = i1 & ((i2 ^ 65535) & 65535);
 i1 = i9 + 32 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i3 = i7;
   i2 = 13;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 12; else {
    i3 = i7;
    i2 = 13;
   }
   break;
  }
 default:
  i2 = 12;
 }
 if ((i2 | 0) == 12) {
  HEAP16[i4 >> 1] = i6;
  __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE(i1, i4);
 } else if ((i2 | 0) == 13) {
  i2 = i9 + 28 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP16[i1 + 76 >> 1] = i6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i7);
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 32768;
 }
 if (!(__ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i9) | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN4math4Axes8TransferI8BlobSizeEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i2 + 20 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = i2 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  HEAP32[i1 >> 2] = i2;
 } else {
  HEAP8[i1 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 HEAP32[i1 >> 2] = i2 + 4 + (0 - i2 & 3);
 return;
}

function __ZN14NavMeshManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i4 = i6;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i3 = i6;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i4 = i6;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = i1 + 128;
 i3 = i1 + 100 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(2.0);
 HEAP32[i1 + 36 >> 2] = 100;
 __Z16dtAllocSetCustomPFPviEPFvS_ES1_S3_PFS_S_iE(fb + 2440 | 0, fb + 3768 | 0, fb + 2441 | 0, fb + 3769 | 0, fb + 910 | 0);
 i3 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63704 | 0, 16, gb + 842172 | 0, 157) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 + 136 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z36NavMesh_CUSTOM_INTERNAL_CALL_RaycastRK8Vector3fS1_P10NavMeshHiti(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 128 >> 2] = i4;
 i4 = (__ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i3, i1, i2, i6) | 0) & 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 24 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 i7 = i9 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i9, i1);
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i9, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i7 >> 2] = i2 + -72;
   i2 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i10;
 return;
}

function _ctanhf(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f6 = f0, f7 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = i4 & 2147483647;
 do if (i1 >>> 0 > 2139095039) {
  if (i4 & 8388607 | 0) {
   i4 = f2 == Math_fround(0.0);
   f6 = Math_fround(f3 * f2);
   HEAPF32[i5 >> 2] = f3;
   HEAPF32[i5 + 4 >> 2] = i4 ? f2 : f6;
   break;
  }
  if (((HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647 | 0) != 2139095040) f2 = Math_fround(Math_fround(+Math_sin(+f2)) * Math_fround(+Math_cos(+f2)));
  f6 = Math_fround(_copysignf(Math_fround(0.0), f2));
  HEAP32[i5 >> 2] = i4 + -1073741824;
  HEAPF32[i5 + 4 >> 2] = f6;
 } else {
  if (((HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 >= 2139095040) {
   f6 = Math_fround(f2 - f2);
   HEAPF32[i5 >> 2] = f6;
   HEAPF32[i5 + 4 >> 2] = f6;
   break;
  }
  if (i1 >>> 0 > 1093664767) {
   f6 = Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_abs(Math_fround(f3))))));
   f6 = Math_fround(f6 * Math_fround(f6 * Math_fround(Math_fround(Math_fround(+Math_sin(+f2)) * Math_fround(4.0)) * Math_fround(+Math_cos(+f2)))));
   HEAPF32[i5 >> 2] = Math_fround(_copysignf(Math_fround(1.0), f3));
   HEAPF32[i5 + 4 >> 2] = f6;
   break;
  } else {
   f6 = Math_fround(+Math_tan(+f2));
   f7 = Math_fround(Math_fround(f6 * f6) + Math_fround(1.0));
   f2 = Math_fround(_sinhf(f3));
   f3 = Math_fround(Math_fround(f2 * Math_fround(f2 * f7)) + Math_fround(1.0));
   f6 = Math_fround(f6 / f3);
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(f2 * Math_fround(f7 * Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * f2) + Math_fround(1.0)))))) / f3);
   HEAPF32[i5 + 4 >> 2] = f6;
   break;
  }
 } while (0);
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i9 + 4 | 0;
 i5 = i2;
 i2 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i12 = i4 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
  i4 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i13 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i12;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i2 = i5 + 16 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
  HEAP32[i7 >> 2] = i1;
  if ((i2 | 0) == (i8 | 0)) break; else i5 = i2;
 }
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i9 + 4 | 0;
 i5 = i2;
 i2 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i12 = i4 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
  i4 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i13 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i12;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i2 = i5 + 16 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
  HEAP32[i7 >> 2] = i1;
  if ((i2 | 0) == (i8 | 0)) break; else i5 = i2;
 }
 STACKTOP = i10;
 return;
}

function __ZN9Animation22ReleaseOwnedAnimationsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i7 = i11;
 i8 = i1 + 300 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = i1 + 304 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i5 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i3 = HEAP32[i6 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 11;
    }
   }
   if ((i9 | 0) == 9) i9 = 11;
   if ((i9 | 0) == 11) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
   }
  }
  __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i5 | 0));
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 STACKTOP = i11;
 return;
}

function __ZN8VRDevice14SetRenderScaleEf(i8, f4) {
 i8 = i8 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0, f11 = f0, d12 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 20 | 0;
 i5 = i9;
 i7 = i9 + 16 | 0;
 i3 = i8 + 308 | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f4);
 i2 = f10 < Math_fround(0.0);
 f11 = Math_fround(-f10);
 if ((i2 ? f11 : f10) <= Math_fround(9.99999997e-07)) {
  STACKTOP = i9;
  return;
 }
 i2 = i8 + 288 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye(i1, 0) | 0;
  if (i1 | 0) if ((__ZNK19VREyeTextureManager43EstimateEyeTextureMemorySizeWithRenderScaleEP13RenderTexturef(HEAP32[i2 >> 2] | 0, i1, f4) | 0) < 1) {
   d12 = +Math_fround(HEAPF32[i3 >> 2]);
   HEAPF64[i5 >> 3] = +f4;
   HEAPF64[i5 + 8 >> 3] = d12;
   __Z6FormatPKcz(i6, gb + 1045002 | 0, i5);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 1044184 | 0, 1229, 512, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   STACKTOP = i9;
   return;
  }
 }
 HEAPF32[i3 >> 2] = f4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i6);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i8 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 11, i3 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 HEAP8[i8 + 303 >> 0] = 1;
 STACKTOP = i9;
 return;
}

function __ZN5physx9NpFactory19createParticleFluidEjb(i8, i4, i5) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i7 = i10 + 12 | 0;
 if (!(HEAP32[gb + 1457348 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 259, gb + 698830 | 0, i10);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[gb + 1457204 >> 2] | 0;
 i6 = i1 + 3940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i2 = i1 + 3936 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i1 + 3644 | 0);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i2 = i1 + 3924 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i1 + 3928 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx15NpParticleFluidC2Ejb(i3, i4, i5);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 if (!i3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 267, gb + 698930 | 0, i10 + 8 | 0);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i2 = i8 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i8 + 564 | 0, i7, i9) | 0;
 if (!(HEAP8[i9 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i9 = i3;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx7NpShapeC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKttb(i7, i2, i1, i4, i3, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8;
 HEAP16[i7 + 4 >> 1] = 7;
 HEAP16[i7 + 6 >> 1] = 3;
 HEAP32[i7 >> 2] = gb + 93696 + 8;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i7 + 12 | 0;
 HEAP32[i11 >> 2] = gb + 93676 + 8;
 HEAP32[i7 + 16 >> 2] = 1;
 HEAP32[i7 >> 2] = gb + 93856 + 8;
 HEAP32[i11 >> 2] = gb + 93856 + 184;
 HEAP32[i7 + 20 >> 2] = 0;
 i11 = HEAP8[i1 >> 0] | 0;
 HEAP32[i7 + 32 >> 2] = 0;
 i5 = i7 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = i7 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i10 >> 0] = i11;
 __ZN5physx2Sc9ShapeCoreC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKtt(i7 + 48 | 0, i2, i10, i4, i3);
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 & -251658241 | (i6 ? 16777216 : 33554432);
 HEAP32[i7 + 192 >> 2] = 0;
 HEAP8[i7 + 196 >> 0] = i6 & 1;
 HEAP32[i9 >> 2] = 0;
 i1 = i7 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (i2 & 1) i1 = (HEAP32[i5 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i1) {
    STACKTOP = i8;
    return;
   } else i1 = i1 + 8 | 0;
   break;
  }
 case 6:
  {
   if (i2 & 1) i1 = (HEAP32[i5 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    STACKTOP = i8;
    return;
   } else i1 = i1 + 8 | 0;
   break;
  }
 case 5:
  {
   if (i2 & 1) i1 = (HEAP32[i5 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (!i1) {
    STACKTOP = i8;
    return;
   } else i1 = i1 + 8 | 0;
   break;
  }
 default:
  {
   STACKTOP = i8;
   return;
  }
 }
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 4 | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN3MBP15removeBoxPrunerEj(i12, i10) {
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 12 | 0;
 i2 = i12 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 <= i10 >>> 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 717183 | 0, 2745, gb + 717609 | 0, i13);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i6 = i12 + 28 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + (i10 * 40 | 0) + 28 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (!i9) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 717183 | 0, 2755, gb + 717609 | 0, i13 + 8 | 0);
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP32[i7 + (i10 * 40 | 0) + 4 >> 2] = 2134900735;
 HEAP32[i7 + (i10 * 40 | 0) + 8 >> 2] = 2134900735;
 HEAP32[i7 + (i10 * 40 | 0) + 12 >> 2] = 2134900735;
 HEAP32[i7 + (i10 * 40 | 0) + 16 >> 2] = 12582912;
 HEAP32[i7 + (i10 * 40 | 0) + 20 >> 2] = 12582912;
 HEAP32[i7 + (i10 * 40 | 0) + 24 >> 2] = 12582912;
 i3 = HEAP32[i9 + 68 >> 2] | 0;
 i4 = HEAP32[i9 + 76 >> 2] | 0;
 if (i3 | 0) {
  i11 = 0;
  do {
   i5 = HEAP32[i4 + (i11 << 3) + 4 >> 2] | 0;
   if ((i5 | 0) != -1) __ZN3MBP12updateObjectEjP9BoxPruner(i12, i5, i9) | 0;
   i11 = i11 + 1 | 0;
  } while ((i11 | 0) != (i3 | 0));
 }
 __ZN9BoxPrunerD2Ev(i9);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i9);
 HEAP32[i8 >> 2] = 0;
 i12 = i12 + 16 | 0;
 HEAP32[i7 + (i10 * 40 | 0) + 36 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i12 >> 2] = i10;
 __ZL17setupOverlapFlagsjP13BoxPrunerData(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 40, 4) | 0;
   i3 = i2 + 8 | 0;
   HEAP32[i2 + 28 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP8[i2 + 36 >> 0] = 1;
   HEAP8[i2 + 37 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN14SpriteRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 12 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 i11 = i12 + 4 | 0;
 if ((HEAP16[gb + 1161680 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161680 | 0, i6);
  i7 = gb + 1161680 | 0;
 } else i7 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + (i8 * 20 | 0) >> 2] | 0;
 i2 = i4;
 if (i4 | 0) {
  i1 = HEAP32[i3 + (i8 * 20 | 0) + 4 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   i3 = i5 + (i8 * 5640 | 0) + 5636 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = 0;
    i2 = HEAP32[i5 + (i8 * 5640 | 0) + 5632 >> 2] | 0;
    while (1) {
     i14 = HEAP32[i5 + (i8 * 5640 | 0) + (i1 << 2) >> 2] | 0;
     i4 = HEAP32[i14 + 20 >> 2] | 0;
     i13 = HEAP32[i14 + 40 >> 2] | 0;
     i15 = HEAP32[i14 + 8 >> 2] | 0;
     i14 = HEAP32[i14 + 28 >> 2] | 0;
     i16 = HEAP32[i5 + (i8 * 5640 | 0) + 1280 + (i1 << 2) >> 2] | 0;
     __Z14GetDeviceColorRK10ColorRGBAf(i11, i5 + (i8 * 5640 | 0) + 256 + (i1 << 4) | 0);
     HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
     __Z15TransformSpriteRPhRPtjPK10Matrix4x4fPK12SpriteVertexjPKtj11ColorRGBA32j(i9, i10, i16, i5 + (i8 * 5640 | 0) + 1536 + (i1 << 6) | 0, i15, i4, i14, i13, i6, i2);
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) break; else i2 = i4 + i2 | 0;
    }
   }
  }
 }
 if (!i7) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i12;
 return;
}

function __ZN14Physics2DState13RecreateWorldEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[i1 + 102964 >> 2] | 0) > 1) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[i1 + 102968 >> 2] | 0) > 0) {
  STACKTOP = i6;
  return;
 }
 i2 = i3 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 104 >> 2] | 0) > 0) {
  STACKTOP = i6;
  return;
 }
 if (HEAP32[i1 + 108 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 __ZN7b2World11DestroyBodyEP6b2Body(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  __ZN7b2WorldD2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[i5 >> 2] = 0;
 i8 = (__Z21GetManagerFromContexti(16) | 0) + 32 | 0;
 i1 = __Znwj(103032) | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 __ZN7b2WorldC2ERK6b2Vec2(i1, i4);
 HEAP32[i5 >> 2] = i1;
 __ZN7b2World18SetContactListenerEP17b2ContactListener(i1, i3 + 12 | 0);
 __ZN7b2World16SetContactFilterEP15b2ContactFilter(HEAP32[i5 >> 2] | 0, i3 + 236 | 0);
 HEAP32[i4 + 44 >> 2] = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP8[i4 + 38 >> 0] = 0;
 HEAP8[i4 + 39 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 1;
 HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 37 >> 0] = 0;
 HEAP32[i2 >> 2] = __ZN7b2World10CreateBodyEPK9b2BodyDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i4) | 0;
 STACKTOP = i6;
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i12, i1, i11) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 if (!(HEAP32[i3 + 196 >> 2] | 0)) {
  i8 = i3 + 200 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i9 = i11 + 4 | 0;
  i10 = i11 + 8 | 0;
  i7 = i3 + 204 | 0;
  if ((HEAPU8[i7 >> 0] | 0) > 1) {
   f6 = Math_fround(HEAPF32[i1 >> 2]);
   f6 = Math_fround(f6 * Math_fround(HEAPF32[i11 >> 2]));
   f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i9 >> 2])));
   f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i10 >> 2])));
   i3 = 1;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i8 >> 2] | 0;
    f16 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) >> 2]);
    f14 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 4 >> 2]);
    f4 = Math_fround(HEAPF32[i1 + (i3 * 12 | 0) + 8 >> 2]);
    f15 = Math_fround(HEAPF32[i11 >> 2]);
    f13 = Math_fround(HEAPF32[i9 >> 2]);
    f4 = Math_fround(Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * f13)) + Math_fround(f4 * Math_fround(HEAPF32[i10 >> 2])));
    i5 = f4 > f6;
    i2 = i5 ? i3 : i2;
    i3 = i3 + 1 | 0;
    if (i3 >>> 0 < (HEAPU8[i7 >> 0] | 0) >>> 0) f6 = i5 ? f4 : f6; else break;
   }
  } else i2 = 0;
 } else {
  i2 = __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE(i3, i11) | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
 }
 i10 = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i11 = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 + (i2 * 12 | 0) >> 2];
 HEAP32[i12 + 4 >> 2] = i10;
 HEAP32[i12 + 8 >> 2] = i11;
 HEAPF32[i12 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEb(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if (!(__ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(86, 65, 76, 69, 2, i7, i8) | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i1 + 4 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i7, i8);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i7, i8);
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i2 = i1 >>> 0 > 2147483647 ? -1 : i1 << 1;
 if (!i2) {
  i2 = i3;
  i4 = 0;
 } else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i4 = mftCall_iiiiii(i3 | 0, i1 | 0, i2 | 0, (i4 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 729209 | 0, 282) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
 }
 if (!i1) i1 = 0; else {
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = 0;
  do {
   HEAP16[i4 + (i3 << 1) >> 1] = HEAP16[i2 + (i3 << 2) >> 1] | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i3 = __ZN5physx15computeMaxIndexEPKtj(i4, i1) | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i3 & 65535, i7, i8);
 __ZN5physx2Gu12StoreIndicesEtjPKtRNS_14PxOutputStreamEb(i3, HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i4, i8, i7);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i4);
 i7 = HEAP32[i5 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, HEAP32[i7 + 20 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0) | 0;
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7mecanim12statemachine26SelectorTransitionConstant8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 903074 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 8;
 HEAP32[i8 + 4 >> 2] = i5 + 4;
 HEAP32[i8 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 903088 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i7, i8, 0); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i9;
 return;
}

function __ZN13MonoBehaviour13StopCoroutineEPKc(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i2 = i10 + 8 | 0;
 i7 = i10;
 i3 = __Z21GetDelayedCallManagerv() | 0;
 if (!i4) i1 = 0; else i1 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i3, i8, fb + 592 | 0, fb + 695 | 0, i6);
 i1 = HEAP32[i4 + 68 >> 2] | 0;
 i4 = i4 + 64 | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 } else i5 = i1;
 while (1) {
  i3 = i5;
  i1 = i3 + 16 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i12 = i1;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i1 = i7;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i11;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   if (!(_strcmp(i6, __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i8) | 0) | 0)) break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) {
   i9 = 13;
   break;
  } else i5 = i1;
 }
 if ((i9 | 0) == 13) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i12 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i12 >> 2];
  HEAP32[HEAP32[i12 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i12 >> 2] = 0;
 }
 HEAP32[i3 + 40 >> 2] = 0;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i3 + 64 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
 STACKTOP = i10;
 return;
}

function __ZN12GUIClipState4ClipERK8Vector2f(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, i7 = 0, f8 = f0, f9 = f0;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  return;
 }
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f1 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 88 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 104 >> 2])));
 f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i5 + 120 >> 2]) * Math_fround(0.0)));
 f1 = Math_fround(Math_fround(HEAPF32[i5 + 136 >> 2]) + f1);
 i3 = f1 < Math_fround(0.0);
 f8 = Math_fround(-f1);
 if ((i3 ? f8 : f1) > Math_fround(1.00000001e-07)) {
  f9 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 80 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 96 >> 2])));
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i5 + 112 >> 2]) * Math_fround(0.0)));
  f9 = Math_fround(Math_fround(HEAPF32[i5 + 128 >> 2]) + f9);
  f8 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 76 >> 2]));
  f8 = Math_fround(f8 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 92 >> 2])));
  f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i5 + 108 >> 2]) * Math_fround(0.0)));
  f1 = Math_fround(Math_fround(1.0) / f1);
  f2 = Math_fround(f1 * f9);
  f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i5 + 124 >> 2]) + f8));
 } else {
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f4 = Math_fround(f1 - Math_fround(HEAPF32[i7 + -24 >> 2]));
 f9 = Math_fround(f2 - Math_fround(HEAPF32[i7 + -20 >> 2]));
 f8 = Math_fround(HEAPF32[i7 + -56 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i7 + -52 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(f4 - f8);
 HEAPF32[i6 + 4 >> 2] = f9;
 return;
}

function __Z19CalcBoxWorldExtentsPfPKfS1_S1_S1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, i11 = 0;
 i10 = i2 + 4 | 0;
 i8 = i2 + 8 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 i11 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * (i11 ? f7 : f6));
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i11 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 f7 = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * (i11 ? f9 : f7)));
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 i11 = f9 < Math_fround(0.0);
 f6 = Math_fround(-f9);
 HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * (i11 ? f6 : f9)));
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i11 = f9 < Math_fround(0.0);
 f6 = Math_fround(-f9);
 f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * (i11 ? f6 : f9));
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 i11 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * (i11 ? f7 : f6)));
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 i11 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * (i11 ? f9 : f7)));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 f7 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * (i3 ? f9 : f7));
 f9 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i4 = f9 < Math_fround(0.0);
 f6 = Math_fround(-f9);
 f9 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i10 >> 2]) * (i4 ? f6 : f9)));
 f6 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 i5 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i8 >> 2]) * (i5 ? f7 : f6)));
 return;
}

function __ZNK5physx2Sc15ClothFabricCore13getRestvaluesEPfj(i15, i16, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i9 = HEAP32[i15 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0) | 0;
 if (i9 >>> 0 > i14 >>> 0) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = i16;
 HEAP32[i10 + 4 >> 2] = i16 + (i9 << 2);
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiiiiiii(i18 | 0, i14 | 0, i15 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i16 = i9;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx2Gu11ReadIndicesEjjPjRNS_13PxInputStreamEb(i1, i7, i6, i4, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 if (i1 >>> 0 < 256) {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i2 | 0, i7 | 0) | 0;
  if (!i7) {
   STACKTOP = i8;
   return;
  } else i1 = 0;
  do {
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU8[i2 + i1 >> 0];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
 if (i1 >>> 0 >= 65536) {
  mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i6 | 0, i7 << 2 | 0) | 0;
  if ((i7 | 0) == 0 | i3 ^ 1) {
   STACKTOP = i8;
   return;
  } else i1 = 0;
  do {
   i5 = i6 + (i1 << 2) | 0;
   i4 = HEAP8[i5 >> 0] | 0;
   i3 = i5 + 3 | 0;
   HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = i4;
   i3 = i5 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   i5 = i5 + 2 | 0;
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i4;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
 i1 = i7 << 1;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i5 | 0, i1 | 0) | 0;
 i2 = (i7 | 0) == 0;
 if (!(i2 | i3 ^ 1)) {
  i1 = 0;
  do {
   i9 = i5 + (i1 << 1) | 0;
   i3 = HEAP8[i9 >> 0] | 0;
   i4 = i9 + 1 | 0;
   HEAP8[i9 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP8[i4 >> 0] = i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 if (i2) {
  STACKTOP = i8;
  return;
 } else i1 = 0;
 do {
  HEAP32[i6 + (i1 << 2) >> 2] = HEAPU16[i5 + (i1 << 1) >> 1];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i8;
 return;
}

function __ZN5Unity5Cloth13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 __ZN5Unity5Cloth18ApplyConfigurationEv(i4);
 i3 = i4 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) i2 = 7; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) if (!(HEAP32[i4 + 228 >> 2] | 0)) {
  __ZN5Unity5Cloth6CreateEv(i4);
  i1 = i4;
  break;
 } else {
  HEAP8[i4 + 357 >> 0] = 1;
  i1 = i4;
  break;
 } else i2 = 7; else i2 = 7; while (0);
 if ((i2 | 0) == 7) {
  i1 = i4 + 228 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31632 | 0) | 0;
   if (i1 | 0) HEAP32[i1 + 504 >> 2] = 0;
  }
  HEAP32[i4 + 240 >> 2] = 0;
  HEAP32[i4 + 244 >> 2] = 0;
  i1 = i4;
 }
 i2 = i4 + 352 | 0;
 HEAP32[i2 >> 2] = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i2 = i4 + 228 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 if (i3 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 476 >> 2] | 0, i1 | 0) | 0)) {
  HEAP8[i4 + 356 >> 0] = 1;
  i5 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 472 >> 2] | 0, i5 | 0);
  return;
 }
 i1 = i4 + 356 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 468 >> 2] | 0, i5 | 0);
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP8[i2 + 12 >> 0] = 0;
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim12statemachine21SelectorStateConstantEEEvRT_PKc17TransferMetaFlags(i8, i2 + i3 | 0, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __Z28Texture2D_CUSTOM_EncodeToPNGP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 i2 = i7 + 32 | 0;
 i6 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 111 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i5;
 if (__ZN9Texture2D11EncodeToPNGER13dynamic_arrayIhLj1EE(i1, i6) | 0) {
  i8 = HEAP32[i6 >> 2] | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
  i9 = (i8 | 0) == 0 ? 0 : i9;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 1, i9) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0, i8 | 0, i9 | 0) | 0;
 } else i1 = 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4);
  HEAP32[i6 >> 2] = 0;
 }
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_9allocatorIS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 24 | 0) + 1 | 0;
 if (i4 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 24 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 89478485 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 178956970;
 i5 = (i1 - i2 | 0) / 24 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 24 | 0) | 0;
 i7 = i6 + (i5 * 24 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 24 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 24 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 i4 = i7 + 24 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i8 = i3;
   i3 = i3 + -24 | 0;
   HEAP32[i1 + -24 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -20 >> 2] = HEAP32[i8 + -20 >> 2];
   HEAP32[i1 + -16 >> 2] = HEAP32[i8 + -16 >> 2];
   HEAP32[i1 + -12 >> 2] = HEAP32[i8 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i8 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i8 + -4 >> 2];
   i1 = i2 + -24 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 40 | 0;
 i5 = i6;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 32 | 0, i3);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = i5 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i5, 0);
 __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI24GenerateTypeTreeTransferEEvRS3_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN9JSONWrite17TransferBasicDataIxEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + ((HEAP32[i1 + 48 >> 2] | 0) + -1 << 2) >> 2] & 16777216 | 0) {
  __Z16BytesToHexStringPKvjPc(i2, 8, i4);
  HEAP8[i4 + 16 >> 0] = 0;
  i2 = HEAP32[i1 + 56 >> 2] | 0;
  i1 = i4;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  i3 = i1 - i4 | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2);
  i1 = i2 + 16 | 0;
  if (i3 >>> 0 < 12) {
   HEAP32[i1 >> 2] = 7340037;
   HEAP8[i2 + 11 >> 0] = 11 - i3;
   i1 = i2;
  } else {
   HEAP32[i1 >> 2] = 3145733;
   HEAP32[i2 + 4 >> 2] = i3;
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
  HEAP8[i1 + i3 >> 0] = 0;
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 i3 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i1);
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 4614;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 if ((i3 | 0) > -1 | (i3 | 0) == -1 & i2 >>> 0 > 4294967295) {
  i1 = i3 >>> 0 > 0 | (i3 | 0) == 0 & i2 >>> 0 > 4294967295 ? 12806 : 14854;
  HEAP32[i4 >> 2] = i1;
  if (i3 >>> 0 > 0 | (i3 | 0) == 0 & i2 >>> 0 > 2147483647) {
   STACKTOP = i5;
   return;
  }
  HEAP32[i4 >> 2] = i1 | 1024;
  STACKTOP = i5;
  return;
 } else {
  if (!((i3 | 0) > -1 | (i3 | 0) == -1 & i2 >>> 0 > 2147483647)) {
   STACKTOP = i5;
   return;
  }
  HEAP32[i4 >> 2] = 5638;
  STACKTOP = i5;
  return;
 }
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags(i11, i3, i1, i2) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, HEAP32[i10 + 4 >> 2] | 0);
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i1 + (i8 * 24 | 0) | 0;
 if (i8 | 0) {
  i8 = i11 + 20 | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  while (1) {
   HEAP32[i9 >> 2] = i1;
   i2 = HEAP32[i6 + 4 >> 2] | 0;
   if (!i2) i2 = gb + 1034517 | 0; else {
    i4 = HEAP32[i6 + 8 >> 2] | 0;
    HEAP8[i2 >> 0] = 80;
    HEAP8[i2 + 1 >> 0] = 80;
    HEAP8[i2 + 2 >> 0] = 116;
    HEAP8[i2 + 3 >> 0] = 114;
    HEAP8[i2 + 4 >> 0] = 60;
    i3 = i2 + 6 | 0;
    HEAP8[i2 + 5 >> 0] = 36;
    i4 = __Z24scripting_class_get_nameP11Il2CppClass(i4) | 0;
    i5 = HEAP8[i4 >> 0] | 0;
    if (i5 << 24 >> 24) do {
     HEAP8[i3 >> 0] = i5;
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
     i5 = HEAP8[i4 >> 0] | 0;
    } while (i5 << 24 >> 24 != 0);
    HEAP8[i3 >> 0] = 62;
    HEAP8[i3 + 1 >> 0] = 0;
   }
   HEAP32[i8 >> 2] = i2;
   __ZN4PPtrI6ObjectE8TransferI8JSONReadEEvRT_(i6, i11);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i7 | 0)) break; else i6 = i6 + 12 | 0;
  }
 }
 HEAP32[i9 >> 2] = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i8 + 4 | 0;
 i3 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = (__ZNK5physx2Sc9ClothCore13getClothFlagsEv(i6) | 0) & 1;
 do if (!i1) {
  i2 = i3;
  i1 = 0;
 } else {
  if (HEAP32[i7 + 168 + (i1 << 2) >> 2] | 0) {
   i2 = HEAP32[i7 + 184 + (i1 << 2) >> 2] | 0;
   i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i3 | 0) | 0;
   if (i2 | 0) {
    __ZN5physx2Sc9ClothCore11switchClothEPNS_5cloth5ClothE(i6, i2);
    break;
   }
  }
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 680241 | 0, 3814, gb + 682753 | 0, i4);
  __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i6, 1, 0);
  i2 = i3;
  i1 = 0;
 } while (0);
 i1 = HEAP32[i7 + 168 + (i1 << 2) >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0);
 i1 = i7 + 156 | 0;
 HEAP32[i5 >> 2] = i6;
 i2 = i7 + 160 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 164 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sc9ClothCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i5) | 0;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 __ZN5physx2Sc8ClothSimC2ERNS0_5SceneERNS0_9ClothCoreE(mftCall_iiiiii(i3 | 0, i4 | 0, 140, (i5 ? gb + 682816 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 3824) | 0, i7, i6);
 STACKTOP = i8;
 return 1;
}

function __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv(i7, i13) {
 i7 = i7 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = i7 + 132 | 0;
 i12 = HEAP32[i7 + 136 >> 2] & 2147483647;
 if (!i12) {
  i13 = 0;
  return i13 | 0;
 }
 i6 = HEAP32[i11 >> 2] | 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  if (i3 | 0) {
   i1 = i2;
   i5 = i3;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i12 >>> 0) {
   i8 = 0;
   i4 = 20;
   break;
  }
 }
 if ((i4 | 0) == 20) return i8 | 0;
 i3 = (Math_imul(i5 & 0 - i5, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
 i2 = i5 + -1 & i5;
 L10 : do if (!i2) do {
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i12 >>> 0) {
   i2 = 0;
   break L10;
  }
  i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
 } while ((i2 | 0) == 0); while (0);
 if ((i3 | 0) == -1) {
  i13 = 0;
  return i13 | 0;
 }
 i6 = HEAP32[i7 + 108 >> 2] | 0;
 L18 : while (1) {
  i5 = i1 << 5;
  while (1) {
   i4 = i3 & 31;
   i3 = HEAP32[i6 + (i3 >>> 5 << 2) >> 2] | 0;
   if ((HEAP32[i3 + (i4 * 12 | 0) + 4 >> 2] | 0) == (i13 | 0)) {
    i9 = i4;
    i10 = i3;
    i4 = 19;
    break L18;
   }
   if (!i2) {
    i8 = 0;
    i4 = 20;
    break L18;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i5;
   i2 = i2 + -1 & i2;
   if (!i2) break;
   if ((i3 | 0) == -1) {
    i8 = 0;
    i4 = 20;
    break L18;
   }
  }
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i12 >>> 0) {
    i2 = 0;
    break;
   }
   i2 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
  if ((i3 | 0) == -1) {
   i8 = 0;
   i4 = 20;
   break;
  }
 }
 if ((i4 | 0) == 19) {
  i13 = i10 + (i9 * 12 | 0) | 0;
  return i13 | 0;
 } else if ((i4 | 0) == 20) return i8 | 0;
 return 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i3 = i8 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i1 + (i2 * 24 | 0) | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i8, i1, gb + 1034411 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i8, i1 + 12 | 0, gb + 1034420 | 0, 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return;
}

function __ZN14ParticleSystem14BeginUpdateAllEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 f6 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (f6 == Math_fround(0.0) | (__Z14IsWorldPlayingv() | 0) ^ 1) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP16[gb + 1452152 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452152 | 0, i1);
  i5 = gb + 1452152 | 0;
 } else i5 = 0;
 i1 = HEAP32[gb + 1451700 >> 2] | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i3 = 0;
  do {
   i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if (!i2) i4 = 8; else if (__ZNK10GameObject8IsActiveEv(i2) | 0) __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i1, HEAP32[i1 + 36 >> 2] | 0, HEAP32[i1 + 40 >> 2] | 0, f6, 0); else i4 = 8;
   if ((i4 | 0) == 8) {
    i4 = 0;
    __ZN14ParticleSystem17RemoveFromManagerEv(i1);
   }
   i3 = i3 + 1 | 0;
   i1 = HEAP32[gb + 1451700 >> 2] | 0;
  } while (i3 >>> 0 < (HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 }
 HEAP8[i1 + 20 >> 0] = 1;
 __ZN14ParticleSystem16AssignRayBudgetsEv();
 i1 = HEAP32[gb + 1451700 >> 2] | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i2 = 0;
  do {
   i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i4, HEAP32[i4 + 32 >> 2] | 0, f6, 0, 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[gb + 1451700 >> 2] | 0;
  } while (i2 >>> 0 < (HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 }
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i7;
 return;
}

function __Z16ApplyBlendShapesR12SkinMeshInfoPh(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, i15 = 0, i16 = 0, f17 = f0;
 _memcpy(i7 | 0, HEAP32[i6 + 32 >> 2] | 0, Math_imul(HEAP32[i6 + 60 >> 2] | 0, HEAP32[i6 + 40 >> 2] | 0) | 0) | 0;
 i8 = HEAP32[i6 + 80 >> 2] | 0;
 i9 = i6 + 76 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) return;
 i10 = i6 + 72 | 0;
 i11 = i8 + 40 | 0;
 i12 = i8 + 20 | 0;
 i13 = i8 + 52 | 0;
 i5 = 0;
 do {
  f14 = Math_fround(HEAPF32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2]);
  do if (f14 > Math_fround(.0000999999974)) {
   i1 = HEAP32[i11 >> 2] | 0;
   i16 = HEAP32[i1 + (i5 << 4) + 8 >> 2] | 0;
   i15 = (HEAP32[i12 >> 2] | 0) + (i16 * 12 | 0) | 0;
   i16 = (HEAP32[i13 >> 2] | 0) + (i16 << 2) | 0;
   f2 = Math_fround(HEAPF32[i16 >> 2]);
   if (!(f14 < f2)) {
    i1 = HEAP32[i1 + (i5 << 4) + 12 >> 2] | 0;
    if ((i1 | 0) != 1) {
     i3 = i1 + -1 | 0;
     i1 = 0;
     while (1) {
      i4 = i1 + 1 | 0;
      f2 = Math_fround(HEAPF32[i16 + (i4 << 2) >> 2]);
      if (i1 >>> 0 < i3 >>> 0 & f2 < f14) i1 = i4; else break;
     }
     f17 = Math_fround(HEAPF32[i16 + (i1 << 2) >> 2]);
     f14 = Math_fround(Math_fround(f14 - f17) / Math_fround(f2 - f17));
     __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh(i15 + (i1 * 12 | 0) | 0, i8, Math_fround(Math_fround(1.0) - f14), i6, i7);
     __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh(i15 + (i4 * 12 | 0) | 0, i8, f14, i6, i7);
     break;
    }
   }
   __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh(i15, i8, Math_fround(f14 / f2), i6, i7);
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i9 >> 2] | 0));
 return;
}

function _cexp(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, d10 = 0.0, i11 = 0, d12 = 0.0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 32 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11;
 d10 = +HEAPF64[i1 >> 3];
 d4 = +HEAPF64[i1 + 8 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d4;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 do if (!(i5 | HEAP32[tempDoublePtr >> 2])) {
  HEAPF64[i7 >> 3] = +Math_exp(+d10);
  HEAPF64[i7 + 8 >> 3] = d4;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d10;
  i1 = HEAP32[tempDoublePtr >> 2] | 0;
  i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i3 = i2 & 2147483647;
  if (!(i3 | i1)) {
   d10 = +Math_sin(+d4);
   HEAPF64[i7 >> 3] = +Math_cos(+d4);
   HEAPF64[i7 + 8 >> 3] = d10;
   break;
  }
  if (i5 >>> 0 <= 2146435071) if ((i2 + -1082535490 | 0) >>> 0 < 1084067) {
   HEAPF64[i9 >> 3] = d10;
   HEAPF64[i9 + 8 >> 3] = d4;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   ___ldexp_cexp(i8, i6, 0);
   d10 = +HEAPF64[i8 + 8 >> 3];
   HEAPF64[i7 >> 3] = +HEAPF64[i8 >> 3];
   HEAPF64[i7 + 8 >> 3] = d10;
   break;
  } else {
   d12 = +Math_exp(+d10);
   d10 = d12 * +Math_sin(+d4);
   HEAPF64[i7 >> 3] = d12 * +Math_cos(+d4);
   HEAPF64[i7 + 8 >> 3] = d10;
   break;
  }
  if (!((i1 | 0) == 0 & (i3 | 0) == 2146435072)) {
   d12 = d4 - d4;
   HEAPF64[i7 >> 3] = d12;
   HEAPF64[i7 + 8 >> 3] = d12;
   break;
  }
  if ((i2 | 0) < 0) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   break;
  } else {
   HEAPF64[i7 >> 3] = d10;
   HEAPF64[i7 + 8 >> 3] = d4 - d4;
   break;
  }
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZN7mecanim9animation8GetClipXERKNS0_18ClipMuscleConstantEPKfi(i12, i7, i10, i8) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i9 = 0, i11 = 0, f13 = f0, f14 = f0, f15 = f0;
 i1 = HEAP32[i7 + 1088 + (i8 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i11 = 0; else i11 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1088 + (i8 + 1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i9 = 0; else i9 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1088 + (i8 + 2 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 0; else i6 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1088 + (i8 + 3 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1088 + (i8 + 4 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f4 = Math_fround(0.0); else f4 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1088 + (i8 + 5 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1088 + (i8 + 6 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) f2 = Math_fround(1.0); else f2 = Math_fround(HEAPF32[i10 + (i1 << 2) >> 2]);
 f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))))));
 f14 = Math_fround(f5 * f15);
 f13 = Math_fround(f4 * f15);
 f4 = Math_fround(f3 * f15);
 f5 = Math_fround(f2 * f15);
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAPF32[i12 + 12 >> 2] = f14;
 HEAPF32[i12 + 16 >> 2] = f13;
 HEAPF32[i12 + 20 >> 2] = f4;
 HEAPF32[i12 + 24 >> 2] = f5;
 HEAP32[i12 + 28 >> 2] = 1065353216;
 HEAP32[i12 + 32 >> 2] = 1065353216;
 HEAP32[i12 + 36 >> 2] = 1065353216;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN4FMOD8ChannelI11EndCallbackEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 i3 = i2;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 + 16 >> 0] | 0)) i1 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0; else i1 = 0;
 }
 if ((i1 | 0) != (i4 | 0)) return;
 i1 = i4 + 40 | 0;
 i2 = i4 + 48 | 0;
 i5 = i4 + 44 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 i2 = i4 + 52 | 0;
 i1 = i4 + 60 | 0;
 i5 = i4 + 56 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i6;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i2 = i4 + 64 | 0;
 if (HEAP32[i2 >> 2] | 0) HEAP32[i2 >> 2] = 0;
 i2 = HEAP32[i4 + 168 >> 2] | 0;
 if (i2) {
  mftCall_iiiii(i2 | 0, i3 | 0, 0, 0, 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i3 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + (HEAP32[i4 + 8 >> 2] << 2) >> 2] | 0;
 i5 = i3 + 12 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP8[i3 + 16 >> 0] = 1;
 i5 = i3 + 24 | 0;
 i4 = i3 + 32 | 0;
 i3 = i3 + 28 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = i5;
 i6 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 >> 2] = i1 + 92;
 HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] = i5;
 HEAP32[i6 >> 2] = i5;
 i6 = i1 + 88 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 i6 = i1 + 84 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZN26ProbeSetTetrahedralizationaSERKS_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i8 | 0) == (i9 | 0)) return i9 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i9 + 12 | 0;
 i1 = (HEAP32[i8 + 12 >> 2] | 0) * 80 | 0;
 i2 = (i1 | 0) / 80 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 80 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  break;
 } else i1 = HEAP32[i9 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) * 80 | 0) | 0;
 i5 = i9 + 20 | 0;
 i6 = HEAP32[i8 + 20 >> 2] | 0;
 i7 = i9 + 32 | 0;
 i1 = (HEAP32[i8 + 32 >> 2] | 0) * 12 | 0;
 i2 = (i1 | 0) / 12 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 return i9 | 0;
}

function __ZN13TranslateGLES4InitERK12GraphicsCaps16GfxDeviceLevelGL(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 _memcpy(i1 + 1924 | 0, gb + 74236 | 0, 248) | 0;
 i4 = i1 + 2264 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 74484 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 74484 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 74484 + 8 >> 2];
 i4 = i1 + 2172 | 0;
 i5 = gb + 74496 | 0;
 i6 = i4 + 92 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 __ZN13TranslateGLES10InitFormatERK12GraphicsCaps(i1, i2);
 i5 = HEAP8[i2 + 481 >> 0] | 0 ? 32879 : -1091584273;
 i4 = HEAP16[i2 + 482 >> 1] | 0;
 HEAP32[i1 + 8 >> 2] = 3553;
 HEAP32[i1 + 12 >> 2] = i5;
 HEAP32[i1 + 16 >> 2] = 34067;
 HEAP32[i1 + 20 >> 2] = (i4 & 255) << 24 >> 24 ? 35866 : -1091584273;
 HEAP32[i1 + 24 >> 2] = (i4 & 65535) > 255 ? 36873 : -1091584273;
 HEAP32[i1 + 2276 >> 2] = 5126;
 HEAP32[i1 + 2280 >> 2] = (i3 | 0) == 1 ? 36193 : 5131;
 HEAP32[i1 + 2284 >> 2] = 5121;
 HEAP32[i1 + 2288 >> 2] = 5120;
 HEAP32[i1 + 2292 >> 2] = 5125;
 i4 = i1 + 2296 | 0;
 i5 = gb + 74588 | 0;
 i6 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i5 = (HEAP8[i2 + 662 >> 0] | 0) != 0;
 HEAP32[i1 + 2336 >> 2] = i5 ? 33504 : 37201;
 HEAP32[i1 + 2340 >> 2] = i5 ? 33505 : 35656;
 HEAP32[i1 + 2344 >> 2] = i5 ? 33506 : 35648;
 HEAP32[i1 + 2348 >> 2] = i5 ? 32884 : 37204;
 HEAP32[i1 + 2352 >> 2] = i5 ? 33507 : 37203;
 HEAP32[i1 + 2356 >> 2] = 36386;
 HEAP32[i1 + 2360 >> 2] = 33510;
 HEAP32[i1 + 2364 >> 2] = 5890;
 HEAP32[i1 + 2368 >> 2] = 36161;
 HEAP32[i1 + 2372 >> 2] = 36160;
 i5 = (HEAP8[i2 + 666 >> 0] | 0) != 0;
 i6 = i1;
 HEAP32[i6 >> 2] = i5 ? 36009 : 36160;
 HEAP32[i6 + 4 >> 2] = i5 ? 36008 : 36160;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveTypeR9GfxBuffer15ComputeBufferIDj(i5, i6, i1, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i2 = i9;
 i8 = i9 + 4 | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401092 | 0, 0, gb + 400980 | 0, 235, 1, 0, 0, 0);
   STACKTOP = i9;
   return;
  }
  if ((HEAP16[gb + 1157796 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157796 | 0, i4);
   i1 = gb + 1157796 | 0;
  } else i1 = 0;
  i2 = __Z12GetGfxDevicev() | 0;
  i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + 848 >> 2] | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  mftCall_viiiii(i10 | 0, i2 | 0, i5 | 0, i6 | 0, i4 | 0, i7 | 0);
  if (HEAP8[i2 + 3896 >> 0] | 0) {
   i10 = i2 + 3644 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i10 = i2 + 3648 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i10 = i2 + 3656 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i10 = i2 + 3652 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i10 = i2 + 3640 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  }
  __Z15gpu_time_samplev();
  if (!i1) {
   STACKTOP = i9;
   return;
  }
  __Z12profiler_endP19ProfilerInformation(i1);
  STACKTOP = i9;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401050 | 0, 0, gb + 400980 | 0, 230, 1, 0, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10StartEventEEEvRNS0_11EventHeaderERT_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i6 = i10 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i1, i6);
 i7 = i1 + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i2, i6, (HEAPU8[i7 >> 0] | 0) >>> 2 & 3);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i6, gb + 660679 | 0, i2 + 16 | 0, (HEAPU8[i7 >> 0] | 0) & 3);
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 < (HEAP32[i10 + 44 >> 2] | 0) >>> 0) return;
 i8 = HEAP32[i10 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (i9) i3 = i1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2;
 i4 = i3 - i1 | 0;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (i5) {
  i1 = i10 + 32 | 0;
  i3 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i2 | 0, i4 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i9) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 return;
}

function __ZN5physx43solveContactCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i3, i1, i6, i8, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i5 = i7;
 __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAPU16[i3 + 10 >> 1] | 0) << 6);
 HEAP32[i1 + 4 >> 2] = i2 + ((HEAPU16[i3 + 42 >> 1] | 0) << 6);
 HEAP32[i1 + 8 >> 2] = i2 + ((HEAPU16[i3 + 74 >> 1] | 0) << 6);
 HEAP32[i1 + 12 >> 2] = i2 + ((HEAPU16[i3 + 106 >> 1] | 0) << 6);
 HEAP32[i5 >> 2] = i2 + ((HEAPU16[i3 + 14 >> 1] | 0) << 6);
 HEAP32[i5 + 4 >> 2] = i2 + ((HEAPU16[i3 + 46 >> 1] | 0) << 6);
 HEAP32[i5 + 8 >> 2] = i2 + ((HEAPU16[i3 + 78 >> 1] | 0) << 6);
 HEAP32[i5 + 12 >> 2] = i2 + ((HEAPU16[i3 + 110 >> 1] | 0) << 6);
 __ZN5physx24writeBackContactCoulomb4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i3, i6, i1, i5);
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i6 + 12 >> 2] | 0) + -4 | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i4, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i6 = i8 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN12GUIClipState6UnclipERK8Vector2f(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, i7 = 0, f8 = f0, f9 = f0;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  return;
 }
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f1 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 24 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 40 >> 2])));
 f1 = Math_fround(f1 + Math_fround(Math_fround(HEAPF32[i5 + 56 >> 2]) * Math_fround(0.0)));
 f1 = Math_fround(Math_fround(HEAPF32[i5 + 72 >> 2]) + f1);
 i3 = f1 < Math_fround(0.0);
 f8 = Math_fround(-f1);
 if ((i3 ? f8 : f1) > Math_fround(1.00000001e-07)) {
  f9 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 16 >> 2]));
  f9 = Math_fround(f9 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 32 >> 2])));
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i5 + 48 >> 2]) * Math_fround(0.0)));
  f9 = Math_fround(Math_fround(HEAPF32[i5 + 64 >> 2]) + f9);
  f8 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 12 >> 2]));
  f8 = Math_fround(f8 + Math_fround(f2 * Math_fround(HEAPF32[i5 + 28 >> 2])));
  f8 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i5 + 44 >> 2]) * Math_fround(0.0)));
  f1 = Math_fround(Math_fround(1.0) / f1);
  f2 = Math_fround(f1 * f9);
  f1 = Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i5 + 60 >> 2]) + f8));
 } else {
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f4 = Math_fround(f1 + Math_fround(HEAPF32[i7 + -24 >> 2]));
 f9 = Math_fround(f2 + Math_fround(HEAPF32[i7 + -20 >> 2]));
 f8 = Math_fround(HEAPF32[i7 + -56 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i7 + -52 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(f4 + f8);
 HEAPF32[i6 + 4 >> 2] = f9;
 return;
}

function __ZN5physx16computeDirectionERjS0_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i8 = 0;
 HEAP32[i7 >> 2] = -1;
 f5 = Math_fround(HEAPF32[gb + 158836 >> 2]);
 i8 = f5 == Math_fround(1.0);
 f6 = Math_fround(HEAPF32[gb + 158836 + 4 >> 2]);
 if (i8) {
  i8 = f6 == Math_fround(0.0);
  f1 = Math_fround(HEAPF32[gb + 158836 + 8 >> 2]);
  if (i8 & f1 == Math_fround(0.0)) i8 = 5; else i8 = 4;
 } else {
  f1 = Math_fround(HEAPF32[gb + 158836 + 8 >> 2]);
  i8 = 4;
 }
 do if ((i8 | 0) == 4) {
  i3 = f6 == Math_fround(0.0);
  i4 = f1 == Math_fround(0.0);
  if (f5 == Math_fround(-1.0) & i3 & i4) i8 = 5; else {
   i2 = f5 == Math_fround(0.0);
   if (i2) {
    if (!(f6 == Math_fround(1.0) & i4)) if (!(i2 & f6 == Math_fround(-1.0) & i4)) {
     if (!(i3 & f1 == Math_fround(1.0))) if (!(i2 & i3 & f1 == Math_fround(-1.0))) break;
     HEAP32[i7 >> 2] = 2;
     break;
    }
    HEAP32[i7 >> 2] = 1;
   }
  }
 } while (0);
 if ((i8 | 0) == 5) HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = -1;
 f5 = Math_fround(HEAPF32[gb + 158848 >> 2]);
 i7 = f5 == Math_fround(1.0);
 f6 = Math_fround(HEAPF32[gb + 158848 + 4 >> 2]);
 if (i7) {
  i7 = f6 == Math_fround(0.0);
  f1 = Math_fround(HEAPF32[gb + 158848 + 8 >> 2]);
  if (!(i7 & f1 == Math_fround(0.0))) i8 = 16;
 } else {
  f1 = Math_fround(HEAPF32[gb + 158848 + 8 >> 2]);
  i8 = 16;
 }
 if ((i8 | 0) == 16) {
  i3 = f6 == Math_fround(0.0);
  i4 = f1 == Math_fround(0.0);
  if (!(f5 == Math_fround(-1.0) & i3 & i4)) {
   i2 = f5 == Math_fround(0.0);
   if (!i2) return;
   if (!(f6 == Math_fround(1.0) & i4)) if (!(i2 & f6 == Math_fround(-1.0) & i4)) {
    if (!(i3 & f1 == Math_fround(1.0))) if (!(i2 & i3 & f1 == Math_fround(-1.0))) return;
    HEAP32[i9 >> 2] = 2;
    return;
   }
   HEAP32[i9 >> 2] = 1;
   return;
  }
 }
 HEAP32[i9 >> 2] = 0;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator13getParentCellEiii(i2, i4, i7, i8) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i1 = HEAP32[i2 + 76 >> 2] | 0;
 if ((i1 | 0) > (i4 | 0)) {
  i3 = HEAP32[i2 + 68 >> 2] | 0;
  i1 = i3 + (i4 << 5) + 4 | 0;
 } else {
  i1 = (HEAP32[i2 + 164 >> 2] | 0) + ((i4 - i1 | 0) * 40 | 0) + 24 | 0;
  i3 = HEAP32[i2 + 68 >> 2] | 0;
 }
 i5 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 460 >> 2] | 0) + (HEAP32[i1 >> 2] << 5) >> 2] << 2) >> 2] | 0;
 i1 = (HEAP32[i5 + 44 >> 2] | 0) >>> 5;
 i10 = HEAP32[i5 + 48 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? 0 : i5 + i10 | 0;
 i2 = HEAP32[i5 + 60 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i6 + 8 >> 2] = i10 + (((i1 << 1) + 31 | 0) >>> 5 << 2);
 HEAP32[i6 + 12 >> 2] = i5;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 20 >> 2] = 4;
 HEAP32[i6 + 24 >> 2] = i1;
 i1 = HEAP32[i3 + (i4 << 5) + 8 >> 2] | 0;
 i1 = i1 - (__ZNK5Umbra6KDTree4rankEi(i6, i1) | 0) | 0;
 i2 = HEAP32[i5 + 164 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i5 + i2 | 0;
 i6 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
 if (!i6) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 i10 = HEAP32[i2 + (i1 << 4) + 4 >> 2] | 0;
 i10 = (i10 | 0) == 0 ? 0 : i5 + i10 | 0;
 i1 = Math_imul((Math_imul(HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0, i7) | 0) + i8 | 0, i6) | 0;
 i4 = i1 >> 5;
 i1 = i1 & 31;
 i2 = (HEAP32[i10 + (i4 << 2) >> 2] | 0) >>> i1;
 i3 = 32 - i1 | 0;
 i4 = HEAP32[i10 + (i4 + 1 << 2) >> 2] << i3;
 if ((i6 | 0) == 32) {
  i10 = -1 << i3 & 0 - i1 >> 31 & i4 | i2;
  STACKTOP = i9;
  return i10 | 0;
 } else {
  i10 = (i4 & -1 << (i1 ^ 31) | i2) & (1 << i6) + -1;
  STACKTOP = i9;
  return i10 | 0;
 }
 return 0;
}

function __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i8 + 20 >> 2] | 0;
 i10 = i6 + 20 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 do if ((i7 | 0) < 24) {
  i5 = i6 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  i2 = i1 >>> 0 < i3 >>> 0;
  if ((i7 | 0) >= 16) {
   if (i2) {
    HEAP32[i5 >> 2] = i1 + 1;
    i1 = HEAPU8[i1 >> 0] | 0;
   } else i1 = 0;
   i4 = i7 + 8 | 0;
   HEAP32[i10 >> 2] = i4;
   i5 = i6 + 16 | 0;
   i6 = HEAP32[i5 >> 2] | i1 << 24 - i7;
   HEAP32[i5 >> 2] = i6;
   break;
  }
  if (i2) {
   i4 = (HEAPU8[i1 >> 0] | 0) << 8;
   i1 = i1 + 1 | 0;
  } else i4 = 0;
  if (i1 >>> 0 < i3 >>> 0) {
   i2 = HEAPU8[i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } else i2 = 0;
  HEAP32[i5 >> 2] = i1;
  i3 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = i3;
  i5 = i6 + 16 | 0;
  i6 = HEAP32[i5 >> 2] | (i2 | i4) << 16 - i7;
  HEAP32[i5 >> 2] = i6;
  i4 = i3;
 } else {
  i6 = i6 + 16 | 0;
  i5 = i6;
  i6 = HEAP32[i6 >> 2] | 0;
  i4 = i7;
 } while (0);
 i1 = (i6 >>> 16) + 1 | 0;
 do if (i1 >>> 0 > (HEAP32[i9 + 16 >> 2] | 0) >>> 0) {
  i2 = HEAP32[i9 + 20 >> 2] | 0;
  while (1) {
   i3 = i2 + -1 | 0;
   if (i1 >>> 0 > (HEAP32[i9 + 28 + (i3 << 2) >> 2] | 0) >>> 0) i2 = i2 + 1 | 0; else break;
  }
  i1 = (i6 >>> (32 - i2 | 0)) + (HEAP32[i9 + 96 + (i3 << 2) >> 2] | 0) | 0;
  if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   i1 = HEAPU16[(HEAP32[i9 + 176 >> 2] | 0) + (i1 << 1) >> 1] | 0;
   break;
  } else {
   i10 = 0;
   return i10 | 0;
  }
 } else {
  i1 = HEAP32[(HEAP32[i9 + 168 >> 2] | 0) + (i6 >>> (32 - (HEAP32[i9 + 8 >> 2] | 0) | 0) << 2) >> 2] | 0;
  i2 = i1 >>> 16;
  i1 = i1 & 65535;
 } while (0);
 HEAP32[i5 >> 2] = i6 << i2;
 HEAP32[i10 >> 2] = i4 - i2;
 i10 = i1;
 return i10 | 0;
}

function __ZN18ProceduralMaterial20HasNonVoidImageInputEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 i6 = i1 + 180 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 while (1) {
  if ((HEAP32[i2 + 64 >> 2] | 0) == 8) {
   i5 = i2 + 84 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   if (i3) {
    HEAP32[i8 >> 2] = i3;
    i1 = HEAP32[gb + 1104264 >> 2] | 0;
    if (!i1) i9 = 10; else {
     if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
      i3 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[i1 + 32 >> 2] | 0;
      i1 = i3 + (i4 << 3) | 0;
     } else {
      __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
      i3 = HEAP32[i7 >> 2] | 0;
      i11 = HEAP32[i1 + 28 >> 2] | 0;
      i4 = HEAP32[gb + 1104264 >> 2] | 0;
      i1 = (i3 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
      i3 = HEAP32[i4 + 28 >> 2] | 0;
      i4 = HEAP32[i4 + 32 >> 2] | 0;
     }
     if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 10; else if (HEAP32[i1 + 4 >> 2] | 0) {
      i1 = 1;
      i9 = 15;
      break;
     }
    }
    if ((i9 | 0) == 10) i9 = 0;
    if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) {
     i1 = 1;
     i9 = 15;
     break;
    }
    i1 = HEAP32[i6 >> 2] | 0;
   }
  }
  i2 = i2 + 156 | 0;
  if ((i2 | 0) == (i1 | 0)) {
   i1 = 0;
   i9 = 15;
   break;
  }
 }
 if ((i9 | 0) == 15) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN11UnityEngine7Connect13ConnectConfig8RegisterERNS0_13ConfigHandlerE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 24 | 0;
 i6 = i8 + 8 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  STACKTOP = i8;
  return;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = i6 + 11 | 0;
 HEAP8[i7 >> 0] = 7;
 HEAP8[i6 >> 0] = HEAP8[gb + 1040810 >> 0] | 0;
 HEAP8[i6 + 1 >> 0] = HEAP8[gb + 1040810 + 1 >> 0] | 0;
 HEAP8[i6 + 2 >> 0] = HEAP8[gb + 1040810 + 2 >> 0] | 0;
 HEAP8[i6 + 3 >> 0] = HEAP8[gb + 1040810 + 3 >> 0] | 0;
 HEAP8[i6 + 4 >> 0] = HEAP8[gb + 1040810 + 4 >> 0] | 0;
 HEAP8[i6 + 5 >> 0] = HEAP8[gb + 1040810 + 5 >> 0] | 0;
 HEAP8[i6 + 6 >> 0] = HEAP8[gb + 1040810 + 6 >> 0] | 0;
 HEAP8[i6 + 7 >> 0] = 0;
 i2 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i1, i6) | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i5, gb + 1048800 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = i4;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 1002;
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  i7 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i5);
 }
 HEAP8[i4 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function __Z33Texture2DArray_CUSTOM_GetPixels32P12Il2CppObjectii(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(HEAP8[i2 + 109 >> 0] | 0)) {
  i4 = __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i7;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0) >> i7;
 i1 = Math_imul((i2 | 0) < 1 ? 1 : i2, (i1 | 0) < 1 ? 1 : i1) | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0, 4, i1) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZNK14Texture2DArray11GetPixels32EiP11ColorRGBA32ii(i4, i1, i3, i6, i7) | 0;
  STACKTOP = i8;
  return i2 | 0;
 }
 return 0;
}

function __Z22updateIslandsToProcessRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjRKNS_11NodeManagerERS4_(i1, i10, i3, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] & 2147483647;
 while (1) {
  i1 = i2 + -1 | 0;
  if (!i2) {
   i8 = 1;
   break;
  }
  i2 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
  if (!i2) i2 = i1; else {
   i4 = 4;
   break;
  }
 }
 if ((i4 | 0) == 4) {
  i8 = i2 >>> 1 | i2;
  i8 = i8 >>> 2 | i8;
  i8 = i8 >>> 4 | i8;
  i8 = i8 >>> 8 | i8;
  i8 = (Math_imul(i8 >>> 16 | i8, 130329821) | 0) >>> 27;
  i8 = (((HEAP32[gb + 85120 + (i8 << 2) >> 2] | 0) + (i1 << 5) | 0) >>> 5) + 1 | 0;
 }
 i5 = i3 + 4 | 0;
 i7 = 0;
 do {
  i1 = HEAP32[i9 + (i7 << 2) >> 2] | 0;
  if (i1 | 0) {
   i6 = i7 << 5;
   do {
    i2 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i2 = HEAP32[gb + 90668 + (i2 << 2) >> 2] | i6;
    i4 = HEAP32[i5 >> 2] | 0;
    i3 = HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2] | 0;
    do if (!(HEAP8[i4 + (i2 * 12 | 0) + 8 >> 0] & 1)) {
     i4 = (HEAP32[i11 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
     HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1 << (i3 & 31);
    } else {
     if ((i3 | 0) != -1) {
      i4 = (HEAP32[i11 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
      HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1 << (i3 & 31);
      break;
     }
     i2 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
     if ((i2 | 0) != -1) do {
      i12 = HEAP32[i4 + (i2 * 12 | 0) + 4 >> 2] | 0;
      i3 = (HEAP32[i11 >> 2] | 0) + (i12 >>> 5 << 2) | 0;
      HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i12 & 31);
      i2 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
     } while ((i2 | 0) != -1);
    } while (0);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i8 | 0));
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__218__insertion_sort_3IR11EventSorterP14AnimationEventEEvT0_S5_T_(i12, i13, i1) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, i18 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i16 + 64 | 0;
 i15 = i16;
 i2 = i12 + 128 | 0;
 __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_(i12, i12 + 64 | 0, i2, i1) | 0;
 i1 = i12 + 192 | 0;
 if ((i1 | 0) == (i13 | 0)) {
  STACKTOP = i16;
  return;
 }
 i11 = i15 + 20 | 0;
 i4 = i11 + 11 | 0;
 i5 = i15 + 32 | 0;
 i6 = i14 + 4 | 0;
 i7 = i15 + 4 | 0;
 i8 = i7 + 11 | 0;
 i9 = i15 + 16 | 0;
 i10 = i14 + 4 | 0;
 i3 = i1;
 i1 = i2;
 while (1) {
  f17 = Math_fround(HEAPF32[i3 >> 2]);
  if (f17 < Math_fround(HEAPF32[i1 >> 2])) {
   __ZN14AnimationEventC2ERKS_(i15, i3);
   i2 = i3;
   while (1) {
    __ZN14AnimationEventaSERKS_(i2, i1) | 0;
    if ((i1 | 0) == (i12 | 0)) {
     i1 = i12;
     break;
    }
    i2 = i1 + -64 | 0;
    f17 = Math_fround(HEAPF32[i15 >> 2]);
    if (f17 < Math_fround(HEAPF32[i2 >> 2])) {
     i18 = i1;
     i1 = i2;
     i2 = i18;
    } else break;
   }
   __ZN14AnimationEventaSERKS_(i1, i15) | 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    i18 = HEAP32[i11 >> 2] | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i18, i14);
   }
   if ((HEAP8[i8 >> 0] | 0) < 0) {
    i18 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    HEAP32[i14 >> 2] = 66;
    HEAP32[i10 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i18, i14);
   }
  }
  i1 = i3 + 64 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else {
   i18 = i3;
   i3 = i1;
   i1 = i18;
  }
 }
 STACKTOP = i16;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_9StopEventEEEvRNS0_11EventHeaderERT_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i6 = i10 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i1, i6);
 i7 = i1 + 1 | 0;
 __ZN5physx7profile23EventContextInformation9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i2, i6, (HEAPU8[i7 >> 0] | 0) >>> 2 & 3);
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE(i6, gb + 660679 | 0, i2 + 16 | 0, (HEAPU8[i7 >> 0] | 0) & 3);
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 < (HEAP32[i10 + 44 >> 2] | 0) >>> 0) return;
 i8 = HEAP32[i10 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (i9) i3 = i1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2;
 i4 = i3 - i1 | 0;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (i5) {
  i1 = i10 + 32 | 0;
  i3 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i2 | 0, i4 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i9) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc15ContactIterator4Pair14getNextContactEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (i7 >>> 0 >= (HEAP32[i8 + 4 >> 2] | 0) >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 i5 = i8 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i8 + 48 | 0;
 do if (i1 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
  i3 = i8 + 36 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 - (HEAP32[i8 + 20 >> 2] | 0) | 0) >>> 0 < (HEAP32[i8 + 44 >> 2] | 0) >>> 0) {
   HEAP32[i8 + 32 >> 2] = i1;
   i9 = HEAPU16[i1 >> 1] | 0;
   HEAP32[i4 >> 2] = i9;
   i6 = HEAP32[i8 + 56 >> 2] | 0;
   HEAP32[i3 >> 2] = i1 + ((Math_imul(HEAP32[i8 + 60 >> 2] | 0, i9) | 0) + i6);
   HEAP32[i8 + 24 >> 2] = i1 + i6;
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  } else {
   i9 = 0;
   return i9 | 0;
  }
 } while (0);
 HEAP32[i5 >> 2] = i1 + 1;
 i6 = i8 + 24 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i8 + 40 >> 2] = i1;
 HEAP32[i6 >> 2] = i1 + (HEAP32[i8 + 60 >> 2] | 0);
 i6 = i8 + 80 | 0;
 i3 = i1;
 i5 = i1;
 if (!(HEAP32[i8 + 68 >> 2] | 0)) i4 = (HEAP32[i8 + 32 >> 2] | 0) + 4 | 0; else i4 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 84 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 88 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 92 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 96 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 100 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 112 >> 2] = HEAP32[i3 + 12 >> 2];
 i1 = HEAP32[i8 + 76 >> 2] | 0;
 if (!i1) f2 = Math_fround(0.0); else f2 = Math_fround(HEAPF32[i1 + (i7 << 2) >> 2]);
 HEAPF32[i8 + 116 >> 2] = f2;
 if (!(HEAP32[i8 + 64 >> 2] | 0)) {
  HEAP32[i8 + 120 >> 2] = -1;
  i1 = -1;
 } else {
  HEAP32[i8 + 120 >> 2] = HEAP32[i5 + 16 >> 2];
  i1 = HEAP32[i5 + 20 >> 2] | 0;
 }
 HEAP32[i8 + 124 >> 2] = i1;
 HEAP32[i8 >> 2] = i7 + 1;
 i9 = i6;
 return i9 | 0;
}

function __Z45EnsureQuaternionContinuityAndRecalculateSlopeR17AnimationCurveTplI11QuaternionfE(i14) {
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i15 = HEAP32[i14 + 164 >> 2] | 0;
 if (!i15) return;
 i13 = i14 + 152 | 0;
 i2 = HEAP32[i13 >> 2] | 0;
 if ((HEAP32[i2 >> 2] & 2139095040 | 0) == 2139095040) return;
 i1 = i15 + -1 | 0;
 if ((HEAP32[i2 + (i1 * 52 | 0) >> 2] & 2139095040 | 0) == 2139095040) return;
 i12 = (i15 | 0) > 0;
 if (!i12) return;
 f7 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) + 8 >> 2]);
 i11 = 0;
 f10 = Math_fround(HEAPF32[i2 + (i1 * 52 | 0) + 4 >> 2]);
 while (1) {
  f4 = Math_fround(HEAPF32[i2 + (i11 * 52 | 0) + 4 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + (i11 * 52 | 0) + 8 >> 2]);
  f5 = Math_fround(HEAPF32[i2 + (i11 * 52 | 0) + 12 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + (i11 * 52 | 0) + 16 >> 2]);
  if (Math_fround(Math_fround(Math_fround(Math_fround(f10 * f4) + Math_fround(f3 * f9)) + Math_fround(f8 * f5)) + Math_fround(f7 * f6)) < Math_fround(0.0)) {
   f4 = Math_fround(-f4);
   f5 = Math_fround(-f5);
   f6 = Math_fround(-f6);
   f3 = Math_fround(-f9);
  } else f3 = f9;
  HEAPF32[i2 + (i11 * 52 | 0) + 4 >> 2] = f4;
  HEAPF32[i2 + (i11 * 52 | 0) + 8 >> 2] = f3;
  HEAPF32[i2 + (i11 * 52 | 0) + 12 >> 2] = f5;
  HEAPF32[i2 + (i11 * 52 | 0) + 16 >> 2] = f6;
  i1 = i11 + 1 | 0;
  if ((i1 | 0) == (i15 | 0)) break;
  i11 = i1;
  f10 = f4;
  f8 = f5;
  f7 = f6;
  i2 = HEAP32[i13 >> 2] | 0;
 }
 if (i12) i1 = 0; else return;
 do {
  __Z23RecalculateSplineSlopeTI11QuaternionfEvR17AnimationCurveTplIT_Eif(i14, i1, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i15 | 0));
 return;
}

function __ZNK5physx2Sc15ClothFabricCore7getSetsEPjj(i15, i16, i14) {
 i15 = i15 | 0;
 i16 = i16 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17 + 88 | 0;
 i5 = i17 + 80 | 0;
 i4 = i17 + 72 | 0;
 i3 = i17 + 64 | 0;
 i2 = i17 + 56 | 0;
 i1 = i17 + 48 | 0;
 i7 = i17 + 40 | 0;
 i8 = i17 + 32 | 0;
 i10 = i17 + 24 | 0;
 i11 = i17 + 16 | 0;
 i12 = i17 + 8 | 0;
 i13 = i17;
 i9 = HEAP32[i15 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0, i9 | 0) | 0;
 if (i9 >>> 0 > i14 >>> 0) {
  i16 = 0;
  STACKTOP = i17;
  return i16 | 0;
 }
 i14 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 i18 = HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0;
 i15 = HEAP32[i15 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = i16;
 HEAP32[i8 + 4 >> 2] = i16 + (i9 << 2);
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 mftCall_viiiiiiii(i18 | 0, i14 | 0, i15 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i16 = i9;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZN5physx7Cooking15cookHeightFieldERKNS_17PxHeightFieldDescERNS_14PxOutputStreamE(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f5 = f0, i6 = 0, i7 = 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 < 2) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) >>> 0 < 2) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAP32[i2 + 8 >> 2] | 0) != 1) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 < 4) {
  i4 = 0;
  return i4 | 0;
 }
 if (Math_fround(HEAPF32[i2 + 24 >> 2]) < Math_fround(0.0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP16[i2 + 28 >> 1] | 0;
 if ((i1 & 1) << 16 >> 16 != i1 << 16 >> 16) {
  i4 = 0;
  return i4 | 0;
 }
 f5 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 if (!(!(f5 > Math_fround(8507058669999999534545717.0e13)) & !(f5 < Math_fround(-8507058669999999534545717.0e13)))) {
  i4 = 0;
  return i4 | 0;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i7 | 0, i6 | 0, 116, (i1 ? gb + 726403 | 0 : gb + 837976 | 0) | 0, gb + 726521 | 0, 344) | 0;
 __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE(i1, 0);
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 if (__ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb(i1, i2, 0) | 0) {
  i7 = __ZN5physx15saveHeightFieldERKNS_2Gu11HeightFieldERNS_14PxOutputStreamEb(i1, i3, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0) | 0;
  __ZN5physx2Gu11HeightField13releaseMemoryEb(i1, 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  return i7 | 0;
 } else {
  __ZN5physx2Gu11HeightField13releaseMemoryEb(i1, 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i7 = 0;
  return i7 | 0;
 }
 return 0;
}

function __ZN16BaseVideoTexture13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 i4 = HEAP32[gb + 1459952 + 4 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i4 | 0)) i2 = 4; else while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
   i2 = 4;
   break L1;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
 } while (0);
 if ((i2 | 0) == 4) if ((i1 | 0) == (i4 | 0)) i2 = 5;
 if ((i2 | 0) == 5) {
  HEAP32[i3 >> 2] = i5;
  if ((i4 | 0) == (HEAP32[gb + 1459952 + 8 >> 2] | 0)) __ZNSt3__26vectorIP16BaseVideoTexture13stl_allocatorIS2_L18MemLabelIdentifier19ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(gb + 1459952 | 0, i3); else {
   HEAP32[i4 >> 2] = i5;
   HEAP32[gb + 1459952 + 4 >> 2] = (HEAP32[gb + 1459952 + 4 >> 2] | 0) + 4;
  }
 }
 if (!(HEAP8[gb + 1552712 >> 0] | 0)) {
  i1 = 0;
  do {
   i5 = i1 + -128 | 0;
   HEAP32[gb + 1460036 + (i1 << 2) >> 2] = (i5 * 409 | 0) + 128 >> 8;
   HEAP32[gb + 1461060 + (i1 << 2) >> 2] = (i5 * 208 | 0) + 128 >> 8;
   HEAP32[gb + 1462084 + (i1 << 2) >> 2] = (i5 * 100 | 0) + 128 >> 8;
   HEAP32[gb + 1463108 + (i1 << 2) >> 2] = (i5 * 516 | 0) + 128 >> 8;
   HEAP32[gb + 1464132 + (i1 << 2) >> 2] = (i1 * 298 | 0) + -4768 >> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  _memset(gb + 1552713 | 0, 0, 384) | 0;
  i1 = 0;
  do {
   HEAP8[gb + 1552713 + 384 + i1 >> 0] = i1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 256);
  _memset(gb + 1552713 + 640 | 0, -1, 384) | 0;
  HEAP8[gb + 1552712 >> 0] = 1;
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN14RenderSettings16ApplyHaloTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 352 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i1 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) i5 = 11; else i1 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
   }
  }
  if ((i5 | 0) == 8) i5 = 11;
  if ((i5 | 0) == 11) {
   i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   i1 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
   if (!i2) break;
  }
  i5 = i1;
  i7 = i2;
  __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i5, gb + 1112312 | 0, i7);
  STACKTOP = i6;
  return;
 } while (0);
 i5 = i1;
 i7 = __ZN10builtintex14GetHaloTextureEv() | 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i5, gb + 1112312 | 0, i7);
 STACKTOP = i6;
 return;
}

function __Z18GetCubeMapTexelPtrPfP13CImageSurface(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i7 = HEAP32[i6 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f8)));
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(Math_abs(Math_fround(f9)));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(Math_abs(Math_fround(f5)));
 do if (!(f3 >= f4) | !(f3 >= f1)) if (!(f4 >= f3) | !(f4 >= f1)) {
  i2 = !(f5 >= Math_fround(0.0));
  i2 = i2 ? 5 : 4;
  break;
 } else {
  i2 = !(f9 >= Math_fround(0.0));
  f1 = f4;
  i2 = i2 ? 3 : 2;
  break;
 } else {
  f1 = f3;
  i2 = !(f8 >= Math_fround(0.0)) & 1;
 } while (0);
 f4 = Math_fround(Math_fround(1.0) / f1);
 f3 = Math_fround(f8 * f4);
 f8 = Math_fround(f9 * f4);
 f9 = Math_fround(f5 * f4);
 f4 = Math_fround(Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) >> 2]) * f3);
 f4 = Math_fround(f4 + Math_fround(f8 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 4 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f9 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 8 >> 2])));
 f5 = Math_fround(f3 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 12 >> 2]));
 f8 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 16 >> 2])));
 f5 = Math_fround(Math_fround(i7 + -1 | 0) * Math_fround(.5));
 i7 = ~~Math_fround(Math_floor(Math_fround(f5 * Math_fround(f4 + Math_fround(1.0)))));
 i10 = ~~Math_fround(Math_floor(Math_fround(f5 * Math_fround(Math_fround(f8 + Math_fround(f9 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 20 >> 2]))) + Math_fround(1.0)))));
 i7 = (Math_imul(HEAP32[i6 + (i2 << 4) >> 2] | 0, i10) | 0) + i7 | 0;
 return (HEAP32[i6 + (i2 << 4) + 12 >> 2] | 0) + ((Math_imul(i7, HEAP32[i6 + (i2 << 4) + 8 >> 2] | 0) | 0) << 2) | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIKjS6_EE(i10, i1, i5) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i8 = i1 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 5;
 HEAP32[i9 + 4 >> 2] = i1;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(52, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i1;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i1 + 44 | 0;
 i13 = i5 + 28 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 i1 = i1 + 24 | 0;
 HEAP8[i1 >> 0] = 0;
 do if ((i7 | 0) != (i5 | 0)) {
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i13 = (i6 | 0) == 0;
  i6 = i13 ? i5 + 8 | 0 : i6;
  i7 = HEAP32[i5 + 24 >> 2] | 0;
  if (!((HEAP32[i5 + 8 >> 2] | 0) != 0 | i13)) {
   HEAP32[i2 >> 2] = i6;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i1 >> 2] = 0;
   break;
  }
  if (i7 >>> 0 > 15) {
   i13 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + 1 | 0, 16, i3, 0, gb + 1047486 | 0, 251) | 0;
   HEAP32[i2 >> 2] = i13;
   HEAP32[i1 >> 2] = i7;
   i1 = (i13 | 0) == 0 ? i1 : i13;
  }
  _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  HEAP32[i4 >> 2] = i7;
 } while (0);
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i13 = i10 + 9 | 0;
 HEAP8[i13 >> 0] = 0;
 HEAP8[i13 + 1 >> 0] = 0;
 HEAP8[i13 + 2 >> 0] = 0;
 STACKTOP = i11;
 return;
}

function __ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i5 = i9 + 8 | 0;
 i6 = i3 + 72 | 0;
 i7 = i3 + 76 | 0;
 i1 = Math_imul(HEAP32[i6 >> 2] << 2, HEAP32[i7 >> 2] | 0) | 0;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 1, gb + 933176 | 0, 857) | 0;
 if (!i8) {
  i8 = i2;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 4 >> 2] = 0;
  __Z6FormatPKcz(i5, gb + 933246 | 0, i2);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 933176 | 0, 860, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = 4;
 HEAP32[i4 + 16 >> 2] = i8;
 HEAPF32[i4 + 20 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 + 84 >> 2]));
 HEAPF32[i4 + 24 >> 2] = Math_fround(4.0);
 if ((i1 | 0) <= 0) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = i3 + 4 | 0;
 i3 = 0;
 do {
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    i10 = (Math_imul(i2, i3) | 0) + i1 | 0;
    i5 = i8 + (i10 << 2) | 0;
    i10 = HEAPU16[(HEAP32[i4 >> 2] | 0) + (i10 << 1) >> 1] | 8388608;
    HEAP16[i5 >> 1] = i10;
    HEAP16[i5 + 2 >> 1] = i10 >>> 16;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i7 >> 2] | 0;
   } while ((i1 | 0) < (i2 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 i1 = 1;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK6Camera28ExtractCameraRenderingParamsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 64 | 0;
 i4 = i8;
 i5 = i2 + 36 | 0;
 i6 = i2 + 1076 | 0;
 if (HEAP8[i6 >> 0] | 0) if (HEAP8[i2 + 1080 >> 0] | 0) {
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i5, i3) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i5, i3) | 0;
  HEAP8[i6 >> 0] = 0;
 }
 i7 = i1;
 i9 = i5;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 i7 = i1 + 64 | 0;
 i9 = __ZNK6Camera19GetProjectionMatrixEv(i2) | 0;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 if (HEAP8[i6 >> 0] | 0) if (HEAP8[i2 + 1080 >> 0] | 0) {
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i5, i3) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i5, i3) | 0;
  HEAP8[i6 >> 0] = 0;
 }
 __Z20InvertMatrix4x4_FullPKfPf(i5, i4) | 0;
 i9 = HEAP32[i4 + 52 >> 2] | 0;
 i10 = HEAP32[i4 + 56 >> 2] | 0;
 HEAP32[i1 + 128 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAP32[i1 + 132 >> 2] = i9;
 HEAP32[i1 + 136 >> 2] = i10;
 STACKTOP = i8;
 return;
}

function __ZN8Material8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 32 | 0;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i9 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
 i6 = i1 + 40 | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i5;
 i2 = HEAP32[i4 + 44 >> 2] | 0;
 i4 = i4 + 48 | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i9 = 0;
  __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i7, i9);
  STACKTOP = i10;
  return;
 }
 while (1) {
  i1 = i2 + 36 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
  if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i3;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 i9 = HEAP32[i5 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i7, i9);
 STACKTOP = i10;
 return;
}

function __ZN8Material31SetTextureScaleAndOffsetIndexedEN9ShaderLab16FastPropertyNameEif(i8, i9, i10, f11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 4 | 0;
 i12 = i13;
 i4 = i8 + 48 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if (i2 | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = i4;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) if ((i10 | 0) < 2) {
   HEAPF32[i1 + 20 + (i10 << 2) >> 2] = f11;
   break;
  } else {
   HEAPF32[i1 + 28 + (i10 + -2 << 2) >> 2] = f11;
   break;
  }
 } while (0);
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 14; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 14;
 if ((i6 | 0) == 14) {
  __ZN8Material15BuildPropertiesEv(i8);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet31SetTextureScaleAndOffsetIndexedERKN9ShaderLab16FastPropertyNameEif(i2 + 12 | 0, i9, i10, f11);
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i8, i7);
 STACKTOP = i13;
 return;
}

function __ZN7mecanim5human9HumanGoal8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906345 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i5, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899280 | 0, i5, i1 + 40 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899290 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 899300 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899308 | 0, i5, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i8 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f4 = Math_fround(HEAPF32[i7 >> 2]);
  f5 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  do if (f4 == Math_fround(0.0)) i2 = 0; else {
   i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i3 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i3) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i3 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i8 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i8 + 2 >> 1] = i2;
  do if (f6 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i3 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i8 + 4 >> 1] = i2;
  HEAP16[i8 + 6 >> 1] = 15360;
  if (!i1) break; else {
   i8 = i8 + 8 | 0;
   i7 = i7 + 12 | 0;
  }
 }
 return;
}

function __ZN5Umbra11NodeLocator8findNodeERKNS_6KDTreeERKNS_4AABBERKNS_7Vector3ERNS1_4NodeE(i2, i3, i4, i1, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i2 + 8 >> 2] = i8;
 i8 = i2 + 12 | 0;
 i1 = i2 + 40 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 if (!(HEAP32[i3 >> 2] | 0)) {
  i9 = i2 + 1644 | 0;
  HEAP8[i9 >> 0] = 1;
  i9 = __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE(i2, i5, i6) | 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 i13 = HEAP32[i4 + 4 >> 2] | 0;
 i12 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = HEAP32[i4 + 12 >> 2] | 0;
 i10 = HEAP32[i4 + 16 >> 2] | 0;
 i8 = HEAP32[i4 + 20 >> 2] | 0;
 i9 = HEAP32[HEAP32[i3 + 4 >> 2] >> 2] & 3;
 HEAP32[i2 + 44 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 48 >> 2] = i13;
 HEAP32[i2 + 52 >> 2] = i12;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = i11;
 HEAP32[i2 + 64 >> 2] = i10;
 HEAP32[i2 + 68 >> 2] = i8;
 HEAP8[i2 + 72 >> 0] = 0;
 HEAP8[i2 + 73 >> 0] = i9;
 HEAP8[i2 + 74 >> 0] = 63;
 HEAP8[i2 + 75 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 i9 = i2 + 1644 | 0;
 HEAP8[i9 >> 0] = 1;
 i9 = __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE(i2, i5, i6) | 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN16ParticleAnimator7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 1049133 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 190788 + 8;
 i6 = i4 + 32 | 0;
 i1 = i4 + 56 | 0;
 i5 = i4 + 44 | 0;
 i2 = i4 + 68 | 0;
 HEAP32[i4 + 88 >> 2] = 184549375;
 HEAP32[i4 + 92 >> 2] = -1258291201;
 HEAP32[i4 + 96 >> 2] = -1;
 HEAP32[i4 + 100 >> 2] = -1258291201;
 HEAP32[i4 + 104 >> 2] = 184549375;
 HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 112 >> 0] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i4 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 80 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP8[i4 + 113 >> 0] = 0;
 HEAPF32[i4 + 116 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = i5 + 4 | 0;
 i7 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 i3 = i5 + 12 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 16 | 0;
 i14 = HEAP32[i4 >> 2] | 0;
 i7 = (Math_imul(mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 24 >> 2] | 0, i14 | 0) | 0, i9) | 0) + i7 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0, i9 | 0) | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i10 = i5 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i15 = i14 >>> 0 < i2 >>> 0 ? i2 : i14 >>> 0 > i1 >>> 0 ? i1 : i14;
 i13 = i14 + i8 | 0;
 i11 = i15;
 _memcpy(i15 | 0, i6 + (i11 - i14) | 0, (i13 >>> 0 < i2 >>> 0 ? i2 : i13 >>> 0 > i1 >>> 0 ? i1 : i13) - i11 | 0) | 0;
 i11 = i7 + i8 | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 24 >> 2] | 0, i13 | 0) | 0;
 i1 = (i11 >>> 0) / (i13 >>> 0) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i15 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i15 >> 2] | 0) + 20 >> 2] | 0, i15 | 0, i2 | 0);
  HEAP32[i3 >> 2] = i1;
  i15 = HEAP32[i4 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i15 >> 2] | 0) + 16 >> 2] | 0, i15 | 0, i1 | 0, i12 | 0, i10 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i14 = i11 - (Math_imul(i1, i13) | 0) | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i5 >> 2] = i12 + i14;
 i14 = i7 - (Math_imul(i1, i9) | 0) | 0;
 i11 = i12 + i14 | 0;
 i13 = HEAP32[i10 >> 2] | 0;
 i10 = (i14 | 0) < 0 ? i12 : i11 >>> 0 > i13 >>> 0 ? i13 : i11;
 i14 = i11 + i8 | 0;
 i15 = i10;
 _memcpy(i10 | 0, i6 + (i15 - i11) | 0, (i14 >>> 0 < i12 >>> 0 ? i12 : i14 >>> 0 > i13 >>> 0 ? i13 : i14) - i15 | 0) | 0;
 return;
}

function __Z52ParticleSystem_SubEmittersModule_CUSTOM_GetCollisionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei(HEAP32[i3 + 916 >> 2] | 0, 1, i2) | 0;
 if (!i6) {
  i7 = 0;
  i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z17WriteConditionalyR13dynamic_arrayIiLj4EEP19ProfilerInformation(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i3 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i3 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 i1 = i6 >>> 0 > i9 >>> 0;
 if (!i2) {
  do if (i1) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = 0;
  return;
 } else {
  do if (i1) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i3 >> 2] = i9;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = 1;
  __ZN17ProfilerFrameData28SerializeProfilerInformationERK19ProfilerInformationR13dynamic_arrayIiLj4EE(i2, i3);
  return;
 }
}

function __Z13IsNodeVisibleRK9SceneNodeRK4AABBRK22SceneCullingParameters(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(1 << i5 & HEAP32[i7 + 192 >> 2])) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (HEAP8[i1 + 20 >> 0] & 4) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i3 = HEAP16[i1 + 14 >> 1] | 0;
 if (i3 << 16 >> 16) if (!((HEAPU8[(HEAP32[(HEAP32[i7 + 812 >> 2] | 0) + ((HEAPU16[i1 + 12 >> 1] | 0) * 12 | 0) >> 2] | 0) + (i3 & 65535) >> 0] | 0) & HEAP32[i1 + 16 >> 2])) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 switch (HEAP32[i7 + 324 >> 2] | 0) {
 case 1:
  {
   HEAP32[i4 >> 2] = HEAP32[i7 + 108 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 112 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 116 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 196 + (i5 << 2) >> 2];
   i1 = (__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i6, i4, 1) | 0) ^ 1;
   break;
  }
 case 2:
  {
   f2 = Math_fround(HEAPF32[i7 + 196 + (i5 << 2) >> 2]);
   if (f2 == Math_fround(0.0)) i1 = 0; else {
    f11 = Math_fround(HEAPF32[i6 >> 2]);
    f11 = Math_fround(f11 - Math_fround(HEAPF32[i7 + 608 >> 2]));
    f10 = Math_fround(HEAPF32[i6 + 4 >> 2]);
    f10 = Math_fround(f10 - Math_fround(HEAPF32[i7 + 612 >> 2]));
    f9 = Math_fround(HEAPF32[i6 + 8 >> 2]);
    f9 = Math_fround(f9 - Math_fround(HEAPF32[i7 + 616 >> 2]));
    i1 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f9 * f9)) > Math_fround(f2 * f2);
   }
   break;
  }
 default:
  i1 = 0;
 }
 i7 = i1 ^ 1;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z10WriteArrayIjEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4 + (i2 & 1073741823) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 _memcpy(i1 + (i4 << 2) | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
 return;
}

function _UNITY_png_do_bgr(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP16[i2 + 8 >> 1] | 0;
 i4 = i3 & 255;
 if (!(i4 & 2)) return;
 i5 = HEAP32[i2 >> 2] | 0;
 switch (((i3 & 65535) >>> 8 & 255) << 24 >> 24) {
 case 8:
  switch (i4 << 24 >> 24) {
  case 2:
   {
    if (!i5) return; else i2 = 0;
    while (1) {
     i3 = HEAP8[i1 >> 0] | 0;
     i4 = i1 + 2 | 0;
     HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
     HEAP8[i4 >> 0] = i3;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 3 | 0;
    }
    return;
   }
  case 6:
   {
    if (!i5) return; else i2 = 0;
    while (1) {
     i3 = HEAP8[i1 >> 0] | 0;
     i4 = i1 + 2 | 0;
     HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
     HEAP8[i4 >> 0] = i3;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 4 | 0;
    }
    return;
   }
  default:
   return;
  }
 case 16:
  switch (i4 << 24 >> 24) {
  case 2:
   {
    if (!i5) return; else i2 = 0;
    while (1) {
     i3 = HEAP8[i1 >> 0] | 0;
     i6 = i1 + 4 | 0;
     HEAP8[i1 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP8[i6 >> 0] = i3;
     i6 = i1 + 1 | 0;
     i3 = HEAP8[i6 >> 0] | 0;
     i4 = i1 + 5 | 0;
     HEAP8[i6 >> 0] = HEAP8[i4 >> 0] | 0;
     HEAP8[i4 >> 0] = i3;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 6 | 0;
    }
    return;
   }
  case 6:
   {
    if (!i5) return; else i2 = 0;
    while (1) {
     i4 = HEAP8[i1 >> 0] | 0;
     i3 = i1 + 4 | 0;
     HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
     HEAP8[i3 >> 0] = i4;
     i3 = i1 + 1 | 0;
     i4 = HEAP8[i3 >> 0] | 0;
     i6 = i1 + 5 | 0;
     HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP8[i6 >> 0] = i4;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 8 | 0;
    }
    return;
   }
  default:
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i3 + 56 | 0;
 i9 = i3 + 28 | 0;
 i4 = i3;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f6 * f6);
 i10 = i1 + 4 | 0;
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 f12 = Math_fround(f5 + Math_fround(f12 * f12));
 i7 = i1 + 8 | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f5 * f5)))) * Math_fround(.150000006));
 i8 = i2 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAPF32[i11 + 12 >> 2] = Math_fround(f6 + Math_fround(0.0));
 HEAPF32[i11 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i11 + 24 >> 2] = f5;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i2, i11) | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 16 >> 2];
 f6 = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + Math_fround(0.0));
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i9 + 16 >> 2] = f6;
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 24 >> 2] = f5;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i2, i9) | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 20 >> 2];
 f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + Math_fround(0.0));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAPF32[i4 + 20 >> 2] = f6;
 HEAPF32[i4 + 24 >> 2] = f5;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE(i2, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue15RestoreFromFileER12FileAccessorPvy(i5, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i13 + 8 | 0;
 if ((i7 | 0) == 0 | (i8 | 0) == 0 & (i9 | 0) == 0) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv(i5);
 i2 = __ZNK12FileAccessor4SizeEv(i6) | 0;
 i1 = getTempRet0() | 0;
 if ((i2 | 0) == 0 & (i1 | 0) == 0) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP32[i11 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 while (1) {
  i4 = i10;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = i1 >>> 0 > i9 >>> 0 | (i1 | 0) == (i9 | 0) & i2 >>> 0 > i8 >>> 0;
  __ZN12FileAccessor4ReadEyPvPy(i6, i4 ? i8 : i2, i4 ? i9 : i1, i7, i10) | 0;
  i4 = i10;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i3 | 0) == 0 & (i4 | 0) == 0) {
   i12 = 6;
   break;
  }
  __ZN11UnityEngine15CloudWebService17SessionEventQueue16ExtractEventDataEPKcyR8UnityStr(i5, i7, i3, i4, i11);
  i4 = i10;
  i2 = _i64Subtract(i2 | 0, i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i1 | 0) == 0) {
   i1 = 1;
   break;
  }
 }
 if ((i12 | 0) == 6) i1 = 0;
 if ((HEAP8[i11 + 11 >> 0] | 0) < 0) {
  i12 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = 66;
  HEAP32[i10 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i12, i10);
 }
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi(i5, i1, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!i4) {
  HEAP32[i5 >> 2] = 0;
  i2 = gb + 63648 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + 24 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = i5 + 4 | 0;
  HEAP8[i4 >> 0] = HEAP8[gb + 1012705 >> 0] | 0;
  HEAP8[i4 + 1 >> 0] = HEAP8[gb + 1012705 + 1 >> 0] | 0;
  HEAP8[i4 + 2 >> 0] = HEAP8[gb + 1012705 + 2 >> 0] | 0;
  HEAP8[i4 + 3 >> 0] = HEAP8[gb + 1012705 + 3 >> 0] | 0;
  HEAP8[i4 + 4 >> 0] = HEAP8[gb + 1012705 + 4 >> 0] | 0;
  HEAP8[i4 + 5 >> 0] = HEAP8[gb + 1012705 + 5 >> 0] | 0;
  HEAP8[i4 + 6 >> 0] = HEAP8[gb + 1012705 + 6 >> 0] | 0;
  HEAP8[i5 + 11 >> 0] = 0;
  HEAP32[i5 + 20 >> 2] = 7;
  return;
 }
 i2 = HEAP32[i1 + 1072 >> 2] | 0;
 i1 = HEAP32[i1 + 1068 >> 2] | 0;
 i3 = i1;
 L5 : do if ((i2 | 0) != (i1 | 0)) {
  i2 = (i2 - i1 | 0) / 40 | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L5;
  }
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  i6 = i3 + (i1 * 40 | 0) + 24 | 0;
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i5 + 24 | 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP8[i5 + 4 >> 0] = 0;
  __ZN4core20StringStorageDefaultIcE6assignERKS1_(i5, i3 + (i1 * 40 | 0) | 0);
  return;
 } while (0);
 HEAP32[i5 >> 2] = 0;
 i1 = i5 + 20 | 0;
 i4 = gb + 63648 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i5 + 4 | 0;
 i3 = gb + 373229 | 0;
 i4 = i2 + 15 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i5 + 19 >> 0] = 0;
 HEAP32[i1 >> 2] = 15;
 return;
}

function __Z44NavMesh_CUSTOM_INTERNAL_CALL_FindClosestEdgeRK8Vector3fP10NavMeshHiti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i5 + 128 >> 2] = i3;
 i3 = (__ZN14NavMeshManager14DistanceToEdgeEP10NavMeshHitRK8Vector3fRK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i2, i1, i5) | 0) & 1;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z31Texture2DArray_CUSTOM_GetPixelsP12Il2CppObjectii(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(HEAP8[i2 + 109 >> 0] | 0)) {
  i4 = __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i7;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0) >> i7;
 i1 = Math_imul((i2 | 0) < 1 ? 1 : i2, (i1 | 0) < 1 ? 1 : i1) | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, i1) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZNK14Texture2DArray9GetPixelsEiP10ColorRGBAfii(i4, i1, i3, i6, i7) | 0;
  STACKTOP = i8;
  return i2 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEEC2INS_11__wrap_iterIPS1_EEEET_SA_RKS4_PNS_9enable_ifIXaasr21__is_forward_iteratorISA_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeE(i7, i3, i4, i2, i1) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i5 = i7 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = i4 - i1 | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 73;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i2 + (((i3 | 0) / 84 | 0) * 84 | 0);
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i2, i1);
  __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i2 + 20 | 0, i1 + 20 | 0);
  __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i2 + 40 | 0, i1 + 40 | 0);
  HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
  HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
  HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
  HEAP32[i2 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
  HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
  i1 = i1 + 84 | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 84 | 0;
  HEAP32[i8 >> 2] = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i6, i1, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i9 + 20 | 0;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 do if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i8 | 0) | 0) {
  i1 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
   i1 = _strtoull(i1, i7, 10) | 0;
   i2 = getTempRet0() | 0;
   if ((i1 | 0) == 0 & (i2 | 0) == 0) {
    i3 = 0;
    break;
   }
   i3 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
   if (i3 | 0) break;
   i10 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = gb + 833471;
   i8 = i5 + 8 | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i10, 4, gb + 833180 | 0, 92, gb + 833286 | 0, i5);
   STACKTOP = i9;
   return;
  }
  i3 = 0;
 } else i3 = 0; while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = i10 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i10 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i4 = i5 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4); else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i5 + 8 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 28 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
   HEAP32[i2 >> 2] = 1;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN18StreamedBinaryReadILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags(i8, i2 + i3 | 0, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 24 | 0, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 24 | 0, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 * 24 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 * 24 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i1 = i7 + 96 | 0;
 i8 = i5 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i5 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 100 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 104 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 116 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i7 + 108 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z36AudioMixer_CUSTOM_FindMatchingGroupsP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9;
 i4 = i9 + 40 | 0;
 i8 = i9 + 20 | 0;
 i5 = i9 + 8 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, gb + 63664 | 0);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 if (!i3) {
  i11 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i11 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 }
 __ZNK11ICallString6ToUTF8Ev(i5, i4);
 __ZN10AudioMixer25FindGroupsWithPartialPathEPKcR13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EE(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[gb + 174800 + 16 >> 2] | 0) | 0;
 i11 = __Z19GetScriptingManagerv() | 0;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i11 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i2 >> 2] | 0) | 0;
 __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEiP11Il2CppArrayRKT_i(i1, i8, 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __Z23GetGlobalBoolPreferencePKcb(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 36 | 0;
 i2 = i7 + 24 | 0;
 i4 = i7 + 12 | 0;
 i6 = i7;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i1, _strlen(i1) | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i6, i2, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i3 = i6 + 11 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) == 3) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, gb + 488713 | 0, 3) | 0)) {
  i5 = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return i5 | 0;
 } else {
  i2 = HEAP8[i3 >> 0] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  break;
 } while (0);
 if (((i2 << 24 >> 24 < 0 ? i1 : i2 & 255) | 0) != 2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return i5 | 0;
 }
 i5 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, gb + 488717 | 0, 2) | 0) != 0 & i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return i5 | 0;
}

function _UNITY_tt_face_load_hdmx(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 4 | 0;
 i11 = i12;
 i4 = HEAP32[i2 + 28 >> 2] | 0;
 i8 = mftCall_iiiii(HEAP32[i9 + 508 >> 2] | 0, i9 | 0, 1751412088, i2 | 0, i11 | 0) | 0;
 HEAP32[i10 >> 2] = i8;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i8 | 0) != 0 | i1 >>> 0 < 8) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i3 = i9 + 704 | 0;
 i8 = _UNITY_FT_Stream_ExtractFrame(i2, i1, i3) | 0;
 HEAP32[i10 >> 2] = i8;
 do if (!i8) {
  i1 = HEAP32[i3 >> 2] | 0;
  i5 = i1 + (HEAP32[i11 >> 2] | 0) | 0;
  i6 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
  i8 = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
  i8 = i8 >>> 0 > 4294901759 ? i8 & 65535 : i8;
  if ((i6 >>> 0 > 255 ? 1 : ((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | 0) != 0) | (i8 + -4 | 0) >>> 0 > 65533) HEAP32[i10 >> 2] = 3; else {
   i7 = i9 + 720 | 0;
   HEAP32[i7 >> 2] = _UNITY_ft_mem_realloc(i4, 1, 0, i6, 0, i10) | 0;
   if (!(HEAP32[i10 >> 2] | 0)) {
    L10 : do if (!i6) i1 = 0; else {
     i3 = i1 + 8 | 0;
     i1 = 0;
     do {
      i2 = i3;
      i3 = i3 + i8 | 0;
      if (i3 >>> 0 > i5 >>> 0) break L10;
      HEAP8[(HEAP32[i7 >> 2] | 0) + i1 >> 0] = HEAP8[i2 >> 0] | 0;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i6 >>> 0);
    } while (0);
    HEAP32[i9 + 712 >> 2] = i1;
    HEAP32[i9 + 708 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i9 + 716 >> 2] = i8;
    break;
   }
  }
  _UNITY_FT_Stream_ReleaseFrame(i2, i3);
  HEAP32[i9 + 708 >> 2] = 0;
 } while (0);
 i11 = HEAP32[i10 >> 2] | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK6Camera16GetStereoEnabledEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 if (!(__Z12GetIVRDevicev() | 0)) i6 = 0; else {
  i6 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0) i6 = (HEAP32[i4 + 824 >> 2] | 0) != 0; else i6 = 0;
 }
 do if ((HEAP32[i4 + 1108 >> 2] | 0) != 8) {
  i5 = i4 + 744 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i7 = 11; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
     i2 = HEAP32[i2 >> 2] | 0;
     i9 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 11; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 13;
   }
   if ((i7 | 0) == 11) i7 = 13;
   if ((i7 | 0) == 13) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   if (!(HEAP8[i4 + 1117 >> 0] | 0)) {
    i9 = 0;
    STACKTOP = i8;
    return i9 | 0;
   }
  }
 } while (0);
 i9 = __Z16GetScreenManagerv() | 0;
 i9 = i6 | (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 100 >> 2] | 0, i9 | 0) | 0);
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471784 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471789 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471794 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 471800 | 0, gb + 471434 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN15TerrainRenderer19GetPatchIndexBufferEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i3 = i8 + 16 | 0;
 i7 = i8;
 i5 = i1 + 136 + (i2 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0) | 0)) {
   i7 = HEAP32[i5 >> 2] | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 i2 = __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj(i2, i3) | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z10DestripifyPKtiRNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEEE(i2, HEAP32[i3 >> 2] | 0, i7);
 if (!(HEAP32[i5 >> 2] | 0)) {
  i2 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 216 >> 2] | 0, i2 | 0) | 0;
  i3 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63248 | 0, 16, gb + 1012378 | 0, 14) | 0;
  HEAP32[i3 + 4 >> 2] = 1;
  HEAP32[i3 >> 2] = gb + 58920 + 8;
  HEAP32[i3 + 8 >> 2] = i2;
  HEAP32[i5 >> 2] = i3;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, 0, 0, (HEAP32[i4 >> 2] | 0) - i1 | 0, i1 | 0, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~((i3 + -2 - i2 | 0) >>> 1) << 1);
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i7 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 L1 : do if ((i2 | 0) != (i1 | 0)) {
  i11 = i13 + 11 | 0;
  L3 : while (1) {
   i8 = HEAP32[i2 >> 2] | 0;
   i9 = i8 + 20 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 | 0) > 0) {
    i1 = 0;
    do {
     i7 = (HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 760 | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     if (i5) {
      i4 = i7;
      L10 : while (1) {
       i6 = i5;
       while (1) {
        if ((HEAP32[i6 + 16 >> 2] | 0) >= 0) break;
        i5 = HEAP32[i6 + 4 >> 2] | 0;
        if (!i5) break L10; else i6 = i5;
       }
       i5 = HEAP32[i6 >> 2] | 0;
       if (!i5) {
        i4 = i6;
        break;
       } else i4 = i6;
      }
      if ((i4 | 0) != (i7 | 0)) if ((HEAP32[i4 + 16 >> 2] | 0) < 1) {
       __ZN9shadertag16GetShaderTagNameEi(i13, HEAP32[i4 + 20 >> 2] | 0);
       i7 = (__Z7StrICmpPKcS0_((HEAP8[i11 >> 0] | 0) < 0 ? HEAP32[i13 >> 2] | 0 : i13, HEAP32[gb + 68848 + 32 >> 2] | 0) | 0) == 0;
       __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i13);
       if (i7) break L3;
       i3 = HEAP32[i9 >> 2] | 0;
      }
     }
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i3 | 0));
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i1 | 0)) break L1;
  }
  HEAP32[i12 >> 2] = i1;
  i13 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  STACKTOP = i14;
  return i13 | 0;
 } while (0);
 HEAP32[i12 >> 2] = 0;
 i13 = 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z18ConvertUTF8toUTF16PKhiR13dynamic_arrayItLj2EE(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i4 = i9;
 i7 = i6 + 12 | 0;
 HEAP32[i7 >> 2] = i3;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i8 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i3 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i2;
 if ((__Z18ConvertUTF8toUTF16PPKhS0_PPtS2_15ConversionFlags(i4, i2 + i3 | 0, i5, 0, 1) | 0) == 3) {
  i3 = 0;
  i2 = 0;
 } else {
  i3 = 1;
  i2 = (HEAP32[i5 >> 2] | 0) - i1 >> 1;
 }
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 & 2147483647) >>> 0 >= i2 >>> 0) {
  STACKTOP = i9;
  return i3 | 0;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i9;
  return i3 | 0;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  STACKTOP = i9;
  return i3 | 0;
 }
 return 0;
}

function _UNITY_LZ4_compress_limitedOutput_continue(i5, i9, i6, i12, i7) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0;
 i10 = i5 + 16392 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i13 = i5 + 16400 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i8 = i2 + i1 | 0;
 if (HEAP32[i5 + 16388 >> 2] | 0) {
  i13 = 0;
  return i13 | 0;
 }
 i11 = i5 + 16384 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i3 >>> 0 > 2147483648 ? 1 : i3 >>> 0 > ((i1 | 0) != 0 & i8 >>> 0 < i9 >>> 0 ? i8 : i9) >>> 0) {
  i2 = i3 + -65536 | 0;
  i1 = 0;
  do {
   i4 = i5 + (i1 << 2) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i3 >>> 0 < i2 >>> 0 ? 0 : i3 - i2 | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4096);
  HEAP32[i11 >> 2] = 65536;
  i1 = HEAP32[i13 >> 2] | 0;
  if (i1 >>> 0 > 65536) {
   HEAP32[i13 >> 2] = 65536;
   i1 = 65536;
  }
  i2 = i8 + (0 - i1) | 0;
  HEAP32[i10 >> 2] = i2;
  i3 = 65536;
 }
 i4 = i9 + i12 | 0;
 if (i4 >>> 0 < i8 >>> 0 & i4 >>> 0 > i2 >>> 0) {
  i1 = i8 - i4 | 0;
  i1 = i1 >>> 0 > 65536 ? 65536 : i1;
  i1 = i1 >>> 0 < 4 ? 0 : i1;
  HEAP32[i13 >> 2] = i1;
  HEAP32[i10 >> 2] = i8 + (0 - i1);
 }
 i1 = i1 >>> 0 < 65536 & i1 >>> 0 < i3 >>> 0;
 if ((i8 | 0) == (i9 | 0)) {
  if (i1) i1 = _LZ4_compress_generic(i5, i9, i6, i12, i7, 1, 1, 1, 1) | 0; else i1 = _LZ4_compress_generic(i5, i9, i6, i12, i7, 1, 1, 1, 0) | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i12;
  i13 = i1;
  return i13 | 0;
 } else {
  if (i1) i1 = _LZ4_compress_generic(i5, i9, i6, i12, i7, 1, 1, 2, 1) | 0; else i1 = _LZ4_compress_generic(i5, i9, i6, i12, i7, 1, 1, 2, 0) | 0;
  HEAP32[i10 >> 2] = i9;
  HEAP32[i13 >> 2] = i12;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i12;
  i13 = i1;
  return i13 | 0;
 }
 return 0;
}

function __ZNSt3__218condition_variable15__do_timed_waitERNS_11unique_lockINS_5mutexEEENS_6chrono10time_pointINS5_12system_clockENS5_8durationIxNS_5ratioILx1ELx1000000000EEEEEEE(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 if (!(HEAP8[i6 + 4 >> 0] | 0)) {
  __THREW__ = 0;
  invoke_vii(fb + 4496 | 0, 1, gb + 1076327 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  }
 }
 i2 = i1;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i2 | 0) > 15e8 | (i2 | 0) == 15e8 & i1 >>> 0 > 59713) i8 = 7; else {
  i3 = ___divdi3(i1 | 0, i2 | 0, 1e9, 0) | 0;
  i4 = getTempRet0() | 0;
  if ((i2 | 0) < 499999999 | (i2 | 0) == 499999999 & i1 >>> 0 < 3294967296) {
   HEAP32[i7 >> 2] = i3;
   i4 = ___muldi3(i3 | 0, i4 | 0, -1e9, -1) | 0;
   i4 = _i64Add(i4 | 0, getTempRet0() | 0, i1 | 0, i2 | 0) | 0;
   getTempRet0() | 0;
   HEAP32[i7 + 4 >> 2] = i4;
  } else i8 = 7;
 }
 if ((i8 | 0) == 7) {
  HEAP32[i7 >> 2] = 2147483647;
  HEAP32[i7 + 4 >> 2] = 999999999;
 }
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 501 | 0, i5 | 0, HEAP32[i6 >> 2] | 0, i7 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 L11 : do if (i8 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
 } else {
  switch (i1 | 0) {
  case 0:
  case 110:
   break;
  default:
   {
    __THREW__ = 0;
    invoke_vii(fb + 4496 | 0, i1 | 0, gb + 1076376 | 0);
    i8 = __THREW__;
    __THREW__ = 0;
    if (i8 & 1) {
     i1 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     break L11;
    }
   }
  }
  STACKTOP = i9;
  return;
 } while (0);
 ___clang_call_terminate(i1);
}

function __ZNK13WheelCollider12GetGroundHitER8WheelHit(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i2 = i1 + 148 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 i2 = i1 + (i3 * 148 | 0) + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + (i3 * 148 | 0) + 52 >> 2] | 0;
 i6 = HEAP32[i1 + (i3 * 148 | 0) + 56 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 48 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i5 + 8 >> 2] = i6;
 i6 = HEAP32[i1 + (i3 * 148 | 0) + 64 >> 2] | 0;
 i4 = HEAP32[i1 + (i3 * 148 | 0) + 68 >> 2] | 0;
 HEAP32[i5 + 12 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 60 >> 2];
 HEAP32[i5 + 16 >> 2] = i6;
 HEAP32[i5 + 20 >> 2] = i4;
 i4 = HEAP32[i1 + (i3 * 148 | 0) + 88 >> 2] | 0;
 i6 = HEAP32[i1 + (i3 * 148 | 0) + 92 >> 2] | 0;
 HEAP32[i5 + 24 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 84 >> 2];
 HEAP32[i5 + 28 >> 2] = i4;
 HEAP32[i5 + 32 >> 2] = i6;
 i6 = HEAP32[i1 + (i3 * 148 | 0) + 100 >> 2] | 0;
 i4 = HEAP32[i1 + (i3 * 148 | 0) + 104 >> 2] | 0;
 HEAP32[i5 + 36 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 96 >> 2];
 HEAP32[i5 + 40 >> 2] = i6;
 HEAP32[i5 + 44 >> 2] = i4;
 HEAP32[i5 + 48 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 80 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 108 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + (i3 * 148 | 0) + 112 >> 2];
 HEAP32[i5 + 60 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
 i5 = 1;
 return i5 | 0;
}

function __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 36972 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 256)) {
   if (i4 & 1048576 | 0) {
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    HEAP8[i11 >> 0] = (__Z7StrICmpPKcS0_(i1, gb + 1087447 | 0) | 0) == 0 & 1;
    break;
   }
   if (!(i4 & 512)) {
    HEAP8[i11 >> 0] = 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 1024 | 0) {
     d2 = +(HEAP32[i1 >> 2] | 0);
     break;
    }
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   HEAP8[i11 >> 0] = d2 != 0.0 & 1;
  } else HEAP8[i11 >> 0] = (i4 | 0) == 258 & 1; while (0);
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN2UI23InitializeCanvasManagerEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(24, gb + 63536 | 0, 16, gb + 1012454 | 0, gb + 1576256 | 0, gb + 1012468 | 0, 421) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i3;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1467948 >> 2] = i2;
 HEAP32[gb + 1115296 + 408 >> 2] = fb + 340;
 HEAP32[gb + 1115296 + 404 >> 2] = fb + 341;
 HEAP32[gb + 1115296 + 412 >> 2] = fb + 3872;
 HEAP32[gb + 1115296 + 88 >> 2] = fb + 342;
 HEAP32[gb + 1115296 + 256 >> 2] = fb + 343;
 HEAP32[gb + 1115296 + 396 >> 2] = fb + 344;
 HEAP32[gb + 1115296 + 400 >> 2] = fb + 345;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 27016 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 <= 63) {
  i1 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 26248 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 26248 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i2 + 26248 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 3873;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i1, gb + 1048800 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 + 1 | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i2 + 26248 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 26248 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i2 + 26248 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 3873;
 STACKTOP = i5;
 return;
}

function __ZN12SoundManager9GetHandleERK16StreamedResourceijjP10SampleClipb(i4, i5, i6, i7, i8, i9, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 L1 : do if (!i1) {
  i1 = HEAP32[i4 + 20 >> 2] | 0;
  i3 = i4 + 16 | 0;
  i2 = i1;
  if ((i2 | 0) != (i3 | 0)) {
   while (1) {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (__ZN16StreamedResourceeqERKS_(i1 + 64 | 0, i5) | 0) if ((HEAP32[i1 + 24 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i1 + 48 >> 2] | 0) == (i7 | 0)) if (HEAP32[i1 + 56 >> 2] & 1 | 0) break;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    i2 = i1;
    if ((i2 | 0) == (i3 | 0)) break L1;
   }
   HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
   HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
   i1 = HEAP32[i1 + 120 >> 2] | 0;
   i2 = i1;
   if (!i1) {
    i10 = i2;
    STACKTOP = i11;
    return i10 | 0;
   }
   i10 = i1 + 4 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
   i10 = i2;
   STACKTOP = i11;
   return i10 | 0;
  }
 } while (0);
 i1 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 i3 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 if (!(__Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i10, i1, i7, i9, i2, i3, 0) | 0)) i1 = __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i4, HEAP32[i10 >> 2] | 0, i5, i8, i6, 1) | 0; else {
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  i1 = 0;
 }
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN11BoxCollider8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i2, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i1 = __ZN14SafeBinaryRead16IsCurrentVersionEv(i6) | 0;
 i3 = i2 + 72 | 0;
 i4 = HEAP32[gb + 37324 >> 2] | 0;
 if (i1) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 842535 | 0, i4, i5, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i6); else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
 } else {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 842460 | 0, i4, i5, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i6); else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
  i3 = i2 + 76 | 0;
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
  i3 = i2 + 80 | 0;
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(2.0));
 }
 i2 = i2 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1034411 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetDeathP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei(HEAP32[i3 + 916 >> 2] | 0, 2, i2) | 0;
 if (!i6) {
  i7 = 0;
  i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetBirthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei(HEAP32[i3 + 916 >> 2] | 0, 0, i2) | 0;
 if (!i6) {
  i7 = 0;
  i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z13TransferFieldI19StreamedBinaryWriteILb0EELb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5;
 i7 = i5 + 8 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 i11 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 i11 = i7 + 36 | 0;
 HEAP32[i7 + 68 >> 2] = 0;
 i6 = i7 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 60 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i11 = i9;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i7 + 80 >> 2] = 2;
 HEAP32[i7 + 76 >> 2] = 2;
 HEAP32[i7 + 84 >> 2] = 4;
 i8 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2];
 __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_(i3, i9, i7);
 __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8);
 i1 = i7 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i2, i3, i4, i1, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 i1 = __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent(i3, i4, i1) | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  STACKTOP = i8;
  return;
 } else {
  i11 = __ZN13TextRendering17GetITextRenderingEv() | 0;
  i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 4 >> 2] | 0;
  f13 = Math_fround(HEAPF32[i4 >> 2]);
  f14 = Math_fround(f13 + Math_fround(HEAP32[i3 + 208 >> 2] | 0));
  f10 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  f9 = Math_fround(f10 + Math_fround(HEAP32[i3 + 216 >> 2] | 0));
  f13 = Math_fround(f13 + Math_fround(HEAPF32[i4 + 8 >> 2]));
  f13 = Math_fround(f13 - Math_fround(HEAP32[i3 + 212 >> 2] | 0));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i4 + 12 >> 2]));
  f13 = Math_fround(f13 - f14);
  f10 = Math_fround(Math_fround(f10 - Math_fround(HEAP32[i3 + 220 >> 2] | 0)) - f9);
  HEAPF32[i7 >> 2] = f14;
  HEAPF32[i7 + 8 >> 2] = f13;
  HEAPF32[i7 + 4 >> 2] = f9;
  HEAPF32[i7 + 12 >> 2] = f10;
  mftCall_viiiii(i12 | 0, i6 | 0, i11 | 0, i1 | 0, i7 | 0, i5 | 0);
  f10 = Math_fround(HEAPF32[i3 + 260 >> 2]);
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i3 + 268 >> 2]));
  f9 = Math_fround(HEAPF32[i3 + 264 >> 2]);
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i3 + 272 >> 2]));
  f10 = Math_fround(f10 + Math_fround(HEAPF32[i6 >> 2]));
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i6 + 4 >> 2]));
  HEAPF32[i2 >> 2] = f10;
  HEAPF32[i2 + 4 >> 2] = f9;
  STACKTOP = i8;
  return;
 }
}

function __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEEEEjT_j(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i1 = i7 + 96 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i5, HEAP32[i1 >> 2] | 0);
 __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEE14handleAccessorILj681ENS_22PxRepXPropertyAccessorILj681ES4_KNS_30PxVehicleDriveTankControlModel4EnumESA_EEEEvRKT0_(i5, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) HEAP8[i5 + 36 >> 0] = 1; else {
  i4 = i1 + -1 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
   i1 = HEAP32[i5 + 20 >> 2] | 0;
   mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  }
  HEAP32[i2 + 8 >> 2] = i1 + -1;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i5 + 36 | 0;
  HEAP8[i3 >> 0] = 1;
  if (i2 | 0) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) + 5 >> 0] | 0)) HEAP8[i3 >> 0] = 0;
 }
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj683ES3_NS_21PxVehicleDriveSimDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i7 + 124 | 0, i6 + 2 | 0);
 STACKTOP = i8;
 return i6 + 3 | 0;
}

function __ZN5IMGUI8GUILabelER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i9 = i11;
 i2 = HEAP32[i6 + 280 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) != 7) {
  STACKTOP = i11;
  return;
 }
 __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb(i1, i6, i7, i8, 0, 0, 0, 0);
 if (!(HEAP32[i8 + 24 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f3 <= f5)) {
  STACKTOP = i11;
  return;
 }
 if (!(Math_fround(f3 + Math_fround(HEAPF32[i7 + 8 >> 2])) > f5)) {
  STACKTOP = i11;
  return;
 }
 f3 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 if (!(f3 <= f4)) {
  STACKTOP = i11;
  return;
 }
 if (!(Math_fround(f3 + Math_fround(HEAPF32[i7 + 12 >> 2])) > f4)) {
  STACKTOP = i11;
  return;
 }
 f12 = Math_fround(HEAPF32[i6 + 252 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 256 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 260 >> 2]);
 if (!(Math_fround(f3 + Math_fround(HEAPF32[i6 + 264 >> 2])) > f4 & ((!(Math_fround(f12 + f13) > f5) | !(f12 <= f5) | !(f3 <= f4)) ^ 1))) {
  STACKTOP = i11;
  return;
 }
 i1 = i6 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 i7 = __Znwj(20) | 0;
 i14 = gb + 63672 | 0;
 i2 = HEAP32[i14 + 4 >> 2] | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i7, i8 + 20 | 0, i10);
 HEAP32[i1 >> 2] = i7;
 STACKTOP = i11;
 return;
}

function __ZN18AnimatorController10ClearAssetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 i1 = i4 + 140 | 0;
 i2 = i4 + 144 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i4 + 148 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = i4 + 112 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = 0;
 i1 = i4 + 80 | 0;
 i2 = i4 + 96 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i4 + 192 | 0;
 i2 = i4 + 208 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 196 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i4 + 160 >> 2] | 0;
 i2 = i4 + 164 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i1 | 0) >>> 4) << 4);
 i1 = i4 + 172 | 0;
 i2 = i4 + 188 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i3 = i4 + 184 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i4 = i4 + 152 | 0;
  HEAP8[i4 >> 0] = 1;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 176 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i4 + 184 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i4 + 152 | 0;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN15CapsuleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i2 = i7 + 60 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN9Transform48RemoveDeregisteredChangeSystemsFromAllTransformsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i5 = i11 + 8 | 0;
 i6 = HEAP32[gb + 1158396 >> 2] | 0;
 i6 = HEAP32[i6 + 24 >> 2] | HEAP32[i6 + 20 >> 2] | HEAP32[i6 + 28 >> 2] | HEAP32[i6 + 32 >> 2] | HEAP32[i6 + 36 >> 2] | HEAP32[i6 + 40 >> 2];
 HEAP32[i5 >> 2] = 0;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = i1;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 28940 | 0, i5, 0);
 i10 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i4 = i10;
  do {
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i3 + 32 >> 2] | 0;
   i3 = HEAP32[i3 + 36 >> 2] | 0;
   if (i2) {
    i1 = HEAP32[gb + 1158396 >> 2] | 0;
    HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 20 >> 2];
    HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 24 >> 2];
    HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 28 >> 2];
    HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 40 >> 2];
    i1 = (HEAP32[i2 + 56 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i6;
    i1 = (HEAP32[i2 + 60 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i6;
    i1 = i2 + 36 | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i6;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) != (i10 + (i1 << 2) | 0));
 }
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i9);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5Umbra20RuntimeStructBuilder4initEPNS_9AllocatorEj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = i2;
 i6 = i7 + 140 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i2) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i6 >> 2] = gb + 1451688;
  i2 = gb + 1451688 | 0;
 }
 i5 = i7 + 148 | 0;
 if ((HEAP32[i5 >> 2] | 0) < 16) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 208, 0) | 0;
  if (i3 | 0) {
   HEAP32[i3 >> 2] = 16;
   HEAP32[i5 >> 2] = 16;
   i1 = i7 + 144 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i4 = HEAP32[i6 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i3 + 16;
   i4 = 10;
  }
 } else i4 = 10;
 if ((i4 | 0) == 10) HEAP32[i7 + 152 >> 2] = 16;
 if ((HEAP32[i5 >> 2] | 0) < 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 16, 0) | 0;
  if (!i3) {
   i6 = i7 + 8 | 0;
   HEAP32[i6 >> 2] = 0;
   i6 = i7 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   i6 = i7 + 132 | 0;
   HEAP32[i6 >> 2] = 0;
   i6 = i7 + 136 | 0;
   HEAP8[i6 >> 0] = 0;
   i7 = i7 + 137 | 0;
   HEAP8[i7 >> 0] = 0;
   return 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = i7 + 144 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = i3 + 16;
 }
 HEAP32[i7 + 152 >> 2] = 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i7 + 132 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i7 + 136 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i7 + 137 | 0;
 HEAP8[i7 >> 0] = 0;
 return 0;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i12, i6, i1) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i8 - i1 >> 4;
 HEAP32[i4 >> 2] = i5;
 i10 = i12 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i12 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1, i12);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
   i3 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i9 >> 2] | 0;
  }
  i2 = i1 + 12 | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i11;
 return;
}

function __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i5 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i2 = i5 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i5 + 12 | 0, gb + 1084124 | 0, 0);
 i5 = i5 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7GetFreeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i1 | 0) == (i3 + 16 | 0)) i2 = 5; else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i4 = i3 + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   }
  }
  do if ((i2 | 0) == 5) {
   i1 = i3 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
    i4 = __Znwj(36) | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP8[i4 + 16 >> 0] = 1;
    HEAP32[i4 + 20 >> 2] = 0;
    i5 = i4 + 24 | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i4 + 28 >> 2] = i5;
    HEAP32[i4 + 32 >> 2] = i5;
    HEAP32[i4 + 8 >> 2] = i2;
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    i1 = i4;
    break;
   } else {
    i5 = 0;
    return i5 | 0;
   }
  } while (0);
  i4 = i3 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = i1 + 24 | 0;
  i2 = i1 + 32 | 0;
  i6 = i1 + 28 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
  i5 = i3 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 >> 2] = i3 + 28;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] = i4;
  HEAP32[i5 >> 2] = i4;
 } else {
  i1 = HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = i4 << 16 & 268369920 | i5 << 28 | i6 & 65535;
 i6 = i1;
 return i6 | 0;
}

function _UNITY_png_write_start_row(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = Math_imul(HEAPU8[i4 + 433 >> 0] | 0, HEAPU8[i4 + 436 >> 0] | 0) | 0;
 i5 = i4 + 344 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > 7) i1 = Math_imul(i2 >>> 3, i1) | 0; else i1 = ((Math_imul(i2, i1) | 0) + 7 | 0) >>> 3;
 i3 = i1 + 1 | 0;
 HEAP8[i4 + 439 >> 0] = HEAP8[i4 + 434 >> 0] | 0;
 HEAP8[i4 + 438 >> 0] = i2;
 i2 = _UNITY_png_malloc(i4, i3) | 0;
 HEAP32[i4 + 380 >> 2] = i2;
 HEAP8[i2 >> 0] = 0;
 i2 = i4 + 430 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (i1 & 16) {
  i1 = _UNITY_png_malloc(i4, (HEAP32[i4 + 360 >> 2] | 0) + 1 | 0) | 0;
  HEAP32[i4 + 384 >> 2] = i1;
  HEAP8[i1 >> 0] = 1;
  i1 = HEAP8[i2 >> 0] | 0;
 }
 if ((i1 & 255) <= 31) {
  i2 = i4 + 348 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i4 + 352 | 0;
  HEAP32[i3 >> 2] = i2;
  i3 = HEAP32[i5 >> 2] | 0;
  i5 = i4 + 356 | 0;
  HEAP32[i5 >> 2] = i3;
  return;
 }
 HEAP32[i4 + 376 >> 2] = _UNITY_png_calloc(i4, i3) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (i1 & 32) {
  i1 = _UNITY_png_malloc(i4, (HEAP32[i4 + 360 >> 2] | 0) + 1 | 0) | 0;
  HEAP32[i4 + 388 >> 2] = i1;
  HEAP8[i1 >> 0] = 2;
  i1 = HEAP8[i2 >> 0] | 0;
 }
 if (i1 & 64) {
  i1 = _UNITY_png_malloc(i4, (HEAP32[i4 + 360 >> 2] | 0) + 1 | 0) | 0;
  HEAP32[i4 + 392 >> 2] = i1;
  HEAP8[i1 >> 0] = 3;
  i1 = HEAP8[i2 >> 0] | 0;
 }
 if (i1 << 24 >> 24 >= 0) {
  i2 = i4 + 348 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i4 + 352 | 0;
  HEAP32[i3 >> 2] = i2;
  i3 = HEAP32[i5 >> 2] | 0;
  i5 = i4 + 356 | 0;
  HEAP32[i5 >> 2] = i3;
  return;
 }
 i2 = _UNITY_png_malloc(i4, (HEAP32[i4 + 360 >> 2] | 0) + 1 | 0) | 0;
 HEAP32[i4 + 396 >> 2] = i2;
 HEAP8[i2 >> 0] = 4;
 i2 = i4 + 348 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 352 | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = i4 + 356 | 0;
 HEAP32[i5 >> 2] = i3;
 return;
}

function __ZN5physx36solveContactPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i3, i1, i6, i8, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i5 = i7;
 __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i6);
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAPU16[i3 + 10 >> 1] | 0) << 6);
 HEAP32[i1 + 4 >> 2] = i2 + ((HEAPU16[i3 + 42 >> 1] | 0) << 6);
 HEAP32[i1 + 8 >> 2] = i2 + ((HEAPU16[i3 + 74 >> 1] | 0) << 6);
 HEAP32[i1 + 12 >> 2] = i2 + ((HEAPU16[i3 + 106 >> 1] | 0) << 6);
 HEAP32[i5 >> 2] = i2 + ((HEAPU16[i3 + 14 >> 1] | 0) << 6);
 HEAP32[i5 + 4 >> 2] = i2 + ((HEAPU16[i3 + 46 >> 1] | 0) << 6);
 HEAP32[i5 + 8 >> 2] = i2 + ((HEAPU16[i3 + 78 >> 1] | 0) << 6);
 HEAP32[i5 + 12 >> 2] = i2 + ((HEAPU16[i3 + 110 >> 1] | 0) << 6);
 __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i3, i6, i1, i5);
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i6 + 12 >> 2] | 0) + -4 | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i4, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i6 = i8 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sq10AABBPruner13updateObjectsEPKjPKNS_9PxBounds3Ej(i9, i12, i13, i11) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i14 = 0;
 HEAP8[i9 + 7809 >> 0] = 1;
 i4 = (i11 | 0) == 0;
 if (!i4) {
  i1 = HEAP32[i9 + 7780 >> 2] | 0;
  i2 = HEAP32[i9 + 7772 >> 2] | 0;
  i3 = 0;
  do {
   i10 = HEAP32[i1 + (HEAP32[i12 + (i3 << 2) >> 2] << 2) >> 2] | 0;
   HEAP32[i2 + (i10 * 24 | 0) >> 2] = HEAP32[i13 + (i3 * 24 | 0) >> 2];
   HEAP32[i2 + (i10 * 24 | 0) + 4 >> 2] = HEAP32[i13 + (i3 * 24 | 0) + 4 >> 2];
   HEAP32[i2 + (i10 * 24 | 0) + 8 >> 2] = HEAP32[i13 + (i3 * 24 | 0) + 8 >> 2];
   HEAP32[i2 + (i10 * 24 | 0) + 12 >> 2] = HEAP32[i13 + (i3 * 24 | 0) + 12 >> 2];
   HEAP32[i2 + (i10 * 24 | 0) + 16 >> 2] = HEAP32[i13 + (i3 * 24 | 0) + 16 >> 2];
   HEAP32[i2 + (i10 * 24 | 0) + 20 >> 2] = HEAP32[i13 + (i3 * 24 | 0) + 20 >> 2];
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i11 | 0));
 }
 if (!(HEAP8[i9 + 7808 >> 0] | 0)) return;
 i10 = i9 + 4 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) return;
 HEAP8[i9 + 7810 >> 0] = 1;
 if (i4) return;
 i5 = i9 + 7780 | 0;
 i6 = i9 + 7800 | 0;
 i7 = i9 + 7796 | 0;
 i8 = i9 + 144 | 0;
 i1 = i9 + 7776 | 0;
 i4 = 0;
 do {
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (HEAP32[i12 + (i4 << 2) >> 2] << 2) >> 2] | 0;
  if ((HEAP32[i6 >> 2] | 0) >>> 0 > i2 >>> 0) {
   i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i3 | 0) == -1) i14 = 11; else __ZN5physx2Sq8AABBTree12markForRefitEj(HEAP32[i10 >> 2] | 0, i3);
  } else i14 = 11;
  if ((i14 | 0) == 11) {
   i14 = 0;
   __ZN5physx2Sq16BucketPrunerCore12updateObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE(i8, i13 + (i4 * 24 | 0) | 0, (HEAP32[i1 >> 2] | 0) + (i2 << 3) | 0) | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i11 | 0));
 return;
}

function __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 64 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 72 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  STACKTOP = i10;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i9 >> 2] = i2;
  i9 = i5;
  i9 = _llvm_bswap_i32(i9 | 0) | 0;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 72 | 0;
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i9, gb + 1034411 | 0, 0);
  STACKTOP = i10;
  return;
 }
}

function __ZN10Matrix4x4f9TranslateERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 i6 = i2 + 4 | 0;
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 i4 = i2 + 8 | 0;
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2])));
 i7 = i1 + 48 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f3);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2])));
 i7 = i1 + 52 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f3);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2])));
 i7 = i1 + 56 | 0;
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f3);
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2])));
 i2 = i1 + 60 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f3);
 return i1 | 0;
}

function __Z47ParticleSystem_TriggerModule_CUSTOM_GetColliderP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[(HEAP32[i3 + 912 >> 2] | 0) + 28 + (((i2 | 0) < 0 ? 0 : (i2 | 0) > 5 ? 5 : i2) << 2) >> 2] | 0;
 if (!i6) {
  i7 = 0;
  i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z46ParticleSystem_CollisionModule_CUSTOM_GetPlaneP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[(HEAP32[i3 + 904 >> 2] | 0) + 972 + (((i2 | 0) < 0 ? 0 : (i2 | 0) > 5 ? 5 : i2) << 2) >> 2] | 0;
 if (!i6) {
  i7 = 0;
  i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 12;
  }
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i6) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z38Material_Get_Custom_PropShaderKeywordsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZNK8Material21GetShaderKeywordNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i2, i5);
 i4 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, ((HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 12 | 0) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i9 = i1 + (i3 * 12 | 0) | 0;
   i2 = HEAP8[i9 + 11 >> 0] | 0;
   i8 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i4, i3, __Z20scripting_string_newPKcj(i8 ? HEAP32[i9 >> 2] | 0 : i9, i8 ? HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 12 | 0) >>> 0);
 }
 i3 = i1;
 if (!i1) {
  STACKTOP = i7;
  return i4 | 0;
 }
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i9 = i2 + -12 | 0;
   HEAP32[i6 >> 2] = i9;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i7;
 return i4 | 0;
}

function __GLOBAL__sub_I_runtime_gfxdevice_lump_cpp() {
 var i1 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157684 | 0, gb + 392196 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157696 | 0, gb + 392213 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157708 | 0, gb + 392231 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157668 | 0, gb + 392256 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157656 | 0, gb + 392277 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157644 | 0, gb + 392297 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157632 | 0, gb + 392320 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157612 | 0, gb + 392338 | 0, 10, 0);
 i1 = 0;
 do {
  HEAP32[gb + 1155296 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1155296 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1155296 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1155296 + 768 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1156068 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1156068 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1156068 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1156068 + 768 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1156840 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1156840 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1156840 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1156840 + 768 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorIN11TypeManager18TypeCallbackStructE13stl_allocatorIS2_L18MemLabelIdentifier6ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (((i1 - i3 | 0) / 12 | 0) >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 * 12 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 * 12 | 0);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = ((i3 - i2 | 0) / 12 | 0) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = (i1 - i2 | 0) / 12 | 0;
 i5 = i6 << 1;
 i5 = i6 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 6;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (((i3 - i2 | 0) / 12 | 0) * 12 | 0) | 0;
 _memset(i3 | 0, 0, i8 * 12 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 * 12 | 0);
 HEAP32[i11 >> 2] = i6 + (i5 * 12 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN8LODGroup13AwakeFromLoadE17AwakeFromLoadMode(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) i5 = 0; else i5 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 i7 = i8 + 68 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i6 = i8 + 88 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2) {
   i4 = i8 + 76 | 0;
   i3 = 0;
   i1 = i2;
   do {
    i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
    i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
    if ((i2 | 0) != -1) {
     i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = 0;
  if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
  HEAP32[i7 >> 2] = -1;
 }
 if (!i5) return;
 __ZN8LODGroup6CreateEv(i8);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i5 = i8 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2) {
  i4 = i8 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i7 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i8);
 return;
}

function __ZN5physx37solveContactCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i3, i1, i6, i8, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i5 = i7;
 __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAPU16[i3 + 10 >> 1] | 0) << 6);
 HEAP32[i1 + 4 >> 2] = i2 + ((HEAPU16[i3 + 42 >> 1] | 0) << 6);
 HEAP32[i1 + 8 >> 2] = i2 + ((HEAPU16[i3 + 74 >> 1] | 0) << 6);
 HEAP32[i1 + 12 >> 2] = i2 + ((HEAPU16[i3 + 106 >> 1] | 0) << 6);
 HEAP32[i5 >> 2] = i2 + ((HEAPU16[i3 + 14 >> 1] | 0) << 6);
 HEAP32[i5 + 4 >> 2] = i2 + ((HEAPU16[i3 + 46 >> 1] | 0) << 6);
 HEAP32[i5 + 8 >> 2] = i2 + ((HEAPU16[i3 + 78 >> 1] | 0) << 6);
 HEAP32[i5 + 12 >> 2] = i2 + ((HEAPU16[i3 + 110 >> 1] | 0) << 6);
 __ZN5physx24writeBackContactCoulomb4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i3, i6, i1, i5);
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i6 + 12 >> 2] | 0) + -4 | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i4, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i6 = i8 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN14ParticleSystem10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN14ParticleSystem25AddParticleSystemRendererEv(i1);
 i2 = i1 + 36 | 0;
 __ZN27ParticleSystemReadOnlyState5ResetEv(HEAP32[i2 >> 2] | 0);
 i4 = HEAP32[gb + 1451700 >> 2] | 0;
 i6 = i4 + 24 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 << 11 ^ i5;
 i3 = i4 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 i6 = i4 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i4 = i4 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i3;
 i3 = i5 >>> 8 ^ i5 ^ i3 ^ i3 >>> 19;
 HEAP32[i4 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 272 >> 2] = i3;
 __ZN13InitialModule5ResetEv(HEAP32[i1 + 44 >> 2] | 0);
 __ZN11ShapeModule5ResetEv(i1 + 48 | 0);
 __ZN14EmissionModule5ResetEv(i1 + 264 | 0);
 __ZN10SizeModule5ResetEv(HEAP32[i1 + 852 >> 2] | 0);
 __ZN14RotationModule5ResetEv(HEAP32[i1 + 856 >> 2] | 0);
 __ZN11ColorModule5ResetEv(HEAP32[i1 + 860 >> 2] | 0);
 __ZN8UVModule5ResetEv(HEAP32[i1 + 864 >> 2] | 0);
 __ZN14VelocityModule5ResetEv(HEAP32[i1 + 868 >> 2] | 0);
 __ZN21InheritVelocityModule5ResetEv(HEAP32[i1 + 872 >> 2] | 0);
 __ZN11ForceModule5ResetEv(HEAP32[i1 + 876 >> 2] | 0);
 __ZN20ExternalForcesModule5ResetEv(HEAP32[i1 + 880 >> 2] | 0);
 __ZN19ClampVelocityModule5ResetEv(HEAP32[i1 + 884 >> 2] | 0);
 __ZN11NoiseModule5ResetEv(HEAP32[i1 + 888 >> 2] | 0);
 __ZN17SizeBySpeedModule5ResetEv(HEAP32[i1 + 892 >> 2] | 0);
 __ZN21RotationBySpeedModule5ResetEv(HEAP32[i1 + 896 >> 2] | 0);
 __ZN18ColorBySpeedModule5ResetEv(HEAP32[i1 + 900 >> 2] | 0);
 __ZN15CollisionModule5ResetEv(HEAP32[i1 + 904 >> 2] | 0);
 __ZN13TriggerModule5ResetEv(HEAP32[i1 + 912 >> 2] | 0);
 __ZN9SubModule5ResetEv(HEAP32[i1 + 916 >> 2] | 0);
 __ZN12LightsModule5ResetEv(HEAP32[i1 + 920 >> 2] | 0);
 __ZN11TrailModule5ResetEv(HEAP32[i1 + 908 >> 2] | 0);
 return;
}

function __ZN13b2DynamicTree9MoveProxyEiRK6b2AABBRK6b2Vec2(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i7 = i3 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i2 + (i4 * 36 | 0) >> 2]);
 if (!(f8 <= Math_fround(HEAPF32[i5 >> 2]))) i1 = i5 + 4 | 0; else {
  f8 = Math_fround(HEAPF32[i2 + (i4 * 36 | 0) + 4 >> 2]);
  i1 = i5 + 4 | 0;
  if (f8 <= Math_fround(HEAPF32[i1 >> 2])) {
   f8 = Math_fround(HEAPF32[i5 + 8 >> 2]);
   if (f8 <= Math_fround(HEAPF32[i2 + (i4 * 36 | 0) + 8 >> 2])) {
    f8 = Math_fround(HEAPF32[i5 + 12 >> 2]);
    if (f8 <= Math_fround(HEAPF32[i2 + (i4 * 36 | 0) + 12 >> 2])) {
     i7 = 0;
     return i7 | 0;
    }
   }
  }
 }
 __ZN13b2DynamicTree10RemoveLeafEi(i3, i4);
 f14 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f14 = Math_fround(f14 + Math_fround(-.100000001));
 f12 = Math_fround(f12 + Math_fround(-.100000001));
 f11 = Math_fround(f11 + Math_fround(.100000001));
 f9 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + Math_fround(.100000001));
 f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(2.0));
 f8 = Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * Math_fround(2.0));
 i5 = f10 < Math_fround(0.0);
 f15 = Math_fround(f14 + f10);
 f10 = Math_fround(f11 + f10);
 i6 = f8 < Math_fround(0.0);
 f13 = Math_fround(f12 + f8);
 f8 = Math_fround(f9 + f8);
 i7 = HEAP32[i7 >> 2] | 0;
 HEAPF32[i7 + (i4 * 36 | 0) >> 2] = i5 ? f15 : f14;
 HEAPF32[i7 + (i4 * 36 | 0) + 4 >> 2] = i6 ? f13 : f12;
 HEAPF32[i7 + (i4 * 36 | 0) + 8 >> 2] = i5 ? f11 : f10;
 HEAPF32[i7 + (i4 * 36 | 0) + 12 >> 2] = i6 ? f9 : f8;
 __ZN13b2DynamicTree10InsertLeafEi(i3, i4);
 i7 = 1;
 return i7 | 0;
}

function __Z49Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK13Vector2fIcallS1_fP11Il2CppArrayiff(i1, i2, f3, i9, i4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11 + 8 | 0;
 i12 = i11;
 i10 = i11 + 16 | 0;
 i16 = gb + 64016 | 0;
 i8 = HEAP32[i16 + 4 >> 2] | 0;
 i7 = i12;
 HEAP32[i7 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 i7 = i10 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i13, i12);
 i16 = i13;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i8;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 i14 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i14, i13, i12, f3, i4, f5, f6, 0, i10) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i9) | 0;
 i2 = i4 >>> 0 < i2 >>> 0 ? i4 : i2;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i9, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i8);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return i2 | 0;
}

function _Vertical_Sweep_Drop(i12, i1, i4, i5, i6, i7) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = HEAP32[i12 + 4 >> 2] | 0;
 i9 = i4 + -1 | 0;
 i2 = 0 - i8 | 0;
 i10 = i9 + i8 & i2;
 i11 = i2 & i5;
 if ((i10 | 0) > (i11 | 0)) {
  i3 = HEAP16[i6 + 12 >> 1] | 0;
  if ((i10 | 0) != (i11 + i8 | 0)) return;
  switch (i3 & 7) {
  case 0:
   {
    i2 = i11;
    break;
   }
  case 4:
   {
    i2 = (HEAP32[i12 + 8 >> 2] | 0) + ((i9 + i5 | 0) / 2 | 0) & i2;
    break;
   }
  case 5:
  case 1:
   {
    if ((HEAP32[i6 + 28 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i6 + 16 >> 2] | 0) < 1) {
     if (!(i3 & 16)) return;
     if ((i5 - i4 | 0) < (HEAP32[i12 + 8 >> 2] | 0)) return;
    }
    if ((HEAP32[i7 + 28 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i6 + 20 >> 2] | 0) == (i1 << 16 >> 16 | 0)) {
     if (!(i3 & 32)) return;
     if ((i5 - i4 | 0) < (HEAP32[i12 + 8 >> 2] | 0)) return;
    }
    if ((i3 & 7) == 1) i2 = i11; else i2 = (HEAP32[i12 + 8 >> 2] | 0) + ((i9 + i5 | 0) / 2 | 0) & i2;
    break;
   }
  default:
   return;
  }
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i2 | 0) < 0) i2 = i10; else i2 = (i2 >> i1 | 0) < (HEAPU16[i12 + 56 >> 1] | 0 | 0) ? i2 : i11;
  i3 = ((i2 | 0) == (i10 | 0) ? i11 : i10) >> i1;
  i4 = i3 & 7;
  if ((i3 | 0) > -1) if ((i3 | 0) < (HEAPU16[i12 + 56 >> 1] | 0 | 0)) if ((HEAPU8[(HEAP32[i12 + 60 >> 2] | 0) + ((HEAP32[i12 + 148 >> 2] | 0) + (i3 << 13 >> 16)) >> 0] | 0) & 128 >>> i4) return;
 } else {
  i2 = i10;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i1 = i2 >> i1;
 if ((i1 | 0) <= -1) return;
 if ((i1 | 0) >= (HEAPU16[i12 + 56 >> 1] | 0 | 0)) return;
 i12 = (HEAP32[i12 + 60 >> 2] | 0) + ((HEAP32[i12 + 148 >> 2] | 0) + (i1 << 13 >> 16)) | 0;
 HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 0 | 128 >>> (i1 & 7);
 return;
}

function __ZNSt3__217__assoc_sub_state24set_value_at_thread_exitEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 i6 = i2 + 12 | 0;
 __ZNSt3__25mutex4lockEv(i6);
 i1 = i2 + 88 | 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  HEAP32[i3 >> 2] = 0;
  i7 = (HEAP32[i2 + 8 >> 2] | 0) == 0;
  __ZNSt13exception_ptrD2Ev(i3);
  if (i7) {
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
   __THREW__ = 0;
   i1 = invoke_i(fb + 313 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) i2 = 5; else {
    __THREW__ = 0;
    i1 = invoke_ii(fb + 2801 | 0, HEAP32[i1 >> 2] | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) i2 = 5; else {
     __THREW__ = 0;
     invoke_vii(fb + 4501 | 0, i1 | 0, i2 | 0);
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) i2 = 5; else {
      __ZNSt3__25mutex6unlockEv(i6);
      STACKTOP = i5;
      return;
     }
    }
   }
  } else i2 = 3;
 } else i2 = 3;
 do if ((i2 | 0) == 3) {
  i1 = ___cxa_allocate_exception(16) | 0;
  __ZNSt3__215future_categoryEv() | 0;
  HEAP32[i4 >> 2] = 2;
  HEAP32[i4 + 4 >> 2] = gb + 1473484;
  __THREW__ = 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  invoke_vii(fb + 4499 | 0, i1 | 0, i3 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i7;
   break;
  } else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
   __THREW__ = 0;
   i2 = 5;
   break;
  }
 } while (0);
 if ((i2 | 0) == 5) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__25mutex6unlockEv(i6);
 ___resumeException(i1 | 0);
}

function __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i5 = i7 + 48 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i1) {
  i1 = __ZN2UI13RectTransform16UpdatePosAndRectEb(i5, 0) | 0;
  if (!((i1 & 1 | 0) == 0 | i6 ^ 1)) __ZN9Transform20SendTransformChangedEi(i5, 129);
  if (!(i1 & 2)) {
   STACKTOP = i8;
   return;
  }
 } else {
  i2 = i5 + 120 | 0;
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  if (!(f9 != Math_fround(HEAPF32[i1 >> 2]))) {
   f9 = Math_fround(HEAPF32[i5 + 124 >> 2]);
   if (!(f9 != Math_fround(HEAPF32[i1 + 4 >> 2]))) {
    f9 = Math_fround(HEAPF32[i5 + 128 >> 2]);
    if (!(f9 != Math_fround(HEAPF32[i1 + 8 >> 2]))) {
     f9 = Math_fround(HEAPF32[i5 + 132 >> 2]);
     if (!(f9 != Math_fround(HEAPF32[i1 + 12 >> 2]))) {
      STACKTOP = i8;
      return;
     }
    }
   }
  };
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 i2 = HEAP32[i5 + 92 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i3 = i5 + 80 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (!((i4 | 0) == 0 ? 1 : (((HEAP32[i4 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0)) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i4, i6, 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1106036 | 0, i7);
 STACKTOP = i8;
 return;
}

function __ZN19TouchPhaseEmulation18FreeExpiredTouchesEjx(i1, i9, i10, i11) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = i1 + 4 | 0;
 i5 = i1 + 8 | 0;
 i1 = 0;
 do {
  i6 = HEAP32[i12 >> 2] | 0;
  i7 = i6 + (i1 * 96 | 0) | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if ((i8 | 0) != -1) {
   i2 = i6 + (i1 * 96 | 0) + 84 | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i9 >>> 0) {
    i3 = i6 + (i1 * 96 | 0) + 72 | 0;
    i13 = i3;
    i13 = _i64Subtract(i10 | 0, i11 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0) | 0;
    i14 = getTempRet0() | 0;
    i4 = i6 + (i1 * 96 | 0) + 36 | 0;
    if (((i14 | 0) > 0 | (i14 | 0) == 0 & i13 >>> 0 > 15e4) & ((HEAP32[i4 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
     HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~(1 << i8);
     HEAP32[i7 >> 2] = -1;
     HEAP32[i4 >> 2] = 4;
     HEAP32[i6 + (i1 * 96 | 0) + 92 >> 2] = 0;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i6 + (i1 * 96 | 0) + 88 >> 2] = 0;
     i14 = i6 + (i1 * 96 | 0) + 4 | 0;
     i13 = i3;
     HEAP32[i13 >> 2] = 0;
     HEAP32[i13 + 4 >> 2] = 0;
     HEAP32[i14 >> 2] = 0;
     HEAP32[i14 + 4 >> 2] = 0;
     HEAP32[i14 + 8 >> 2] = 0;
     HEAP32[i14 + 12 >> 2] = 0;
     HEAP32[i14 + 16 >> 2] = 0;
     HEAP32[i14 + 20 >> 2] = 0;
     HEAP32[i14 + 24 >> 2] = 0;
     HEAP32[i14 + 28 >> 2] = 0;
     HEAP32[i6 + (i1 * 96 | 0) + 80 >> 2] = -1;
     HEAPF32[i6 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
     HEAPF32[i6 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
     HEAP32[i6 + (i1 * 96 | 0) + 40 >> 2] = 0;
     i14 = i6 + (i1 * 96 | 0) + 52 | 0;
     HEAP32[i14 >> 2] = 0;
     HEAP32[i14 + 4 >> 2] = 0;
     HEAP32[i14 + 8 >> 2] = 0;
     HEAP32[i14 + 12 >> 2] = 0;
    }
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 return;
}

function __ZN11BoxCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i2 = i7 + 72 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __Z38CanvasBatchIntermediateRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi(i2, i3, i12, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 12 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 * 360 | 0) + 328 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = i1 + 16 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = i1 + 4 | 0;
 i3 = i1 + 12 | 0;
 i1 = 0;
 do {
  if ((HEAP16[gb + 1110388 + 6 >> 1] | 0) > -1) {
   HEAP32[i9 >> 2] = 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110388 | 0, i8);
   i2 = gb + 1110388 | 0;
  } else i2 = 0;
  i4 = HEAP32[gb + 1110388 >> 2] | 0;
  i13 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 648 >> 2] | 0, i13 | 0, i4 | 0);
  i4 = i5 + (i1 * 36 | 0) + 32 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i13 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 184 >> 2] | 0, i13 | 0, HEAP32[i4 >> 2] | 0);
  }
  i13 = __Z12GetGfxDevicev() | 0;
  mftCall_viiiiiiii(HEAP32[(HEAP32[i13 >> 2] | 0) + 244 >> 2] | 0, i13 | 0, HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, 1, i5 + (i1 * 36 | 0) | 0, 1, HEAP32[i3 >> 2] | 0, i12 | 0);
  __Z15gpu_time_samplev();
  i13 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i13 >> 2] | 0) + 652 >> 2] | 0, i13 | 0);
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 STACKTOP = i11;
 return;
}

function __Z27InitializeRenderLoopContextP6CameraRK19SharedRendererSceneP10RenderLoop(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i7 = i4;
 i5 = __ZnwjRK10MemLabelIdiPKci(1904, gb + 64024 | 0, 16, gb + 388437 | 0, 329) | 0;
 i9 = gb + 64024 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = gb + 36864 + 8;
 HEAP32[i5 + 956 >> 2] = 0;
 HEAP32[i5 + 960 >> 2] = -1;
 HEAPF32[i5 + 1596 >> 2] = Math_fround(0.0);
 i12 = i5 + 1796 | 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i5 + 1828 >> 2] = 0;
 HEAP32[i5 + 1832 >> 2] = 0;
 i12 = i7;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAP32[i5 + 1840 >> 2] = 0;
 HEAP32[i5 + 1852 >> 2] = 0;
 HEAP32[i5 + 1856 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i12 = i8;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i6 = i5 + 1844 | 0;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 4 >> 2] = i11;
 i6 = i7;
 HEAP32[i6 >> 2] = i10;
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i5 + 1860 >> 2] = 0;
 HEAP32[i5 + 1872 >> 2] = 0;
 HEAP32[i5 + 1876 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5 + 1864 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i5 + 1880 >> 2] = 0;
 HEAP32[i5 + 1884 >> 2] = -1;
 HEAP32[i3 >> 2] = i5;
 i6 = i2 + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i5 + 1888 >> 2] = i3;
 HEAP32[i5 + 1828 >> 2] = i2;
 HEAP32[i5 + 1832 >> 2] = i2 + 8;
 HEAP32[i5 + 1836 >> 2] = i2 + 32820;
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i8, i4, i10) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i2 = i4;
 i11 = i10 - i2 >> 2;
 i1 = i8 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i5 = i7;
 L1 : do if (i11 >>> 0 > (HEAP32[i1 >> 2] | 0) - i7 >> 2 >>> 0) {
  __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE10deallocateEv(i8);
  if (i11 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8); else {
   i7 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
   i9 = i7 >> 1;
   __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj(i8, i7 >> 2 >>> 0 < 536870911 ? (i9 >>> 0 < i11 >>> 0 ? i11 : i9) : 1073741823);
   __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i8, i4, i10, i11);
   break;
  }
 } else {
  i9 = i8 + 4 | 0;
  i3 = (HEAP32[i9 >> 2] | 0) - i7 >> 2;
  i6 = i11 >>> 0 > i3 >>> 0;
  i3 = i6 ? i4 + (i3 << 2) | 0 : i10;
  i1 = i3 - i2 | 0;
  i2 = i1 >> 2;
  if (i2 | 0) _memmove(i7 | 0, i4 | 0, i1 | 0) | 0;
  i2 = i5 + (i2 << 2) | 0;
  if (i6) {
   __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i8, i3, i10, i11 - ((HEAP32[i9 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) >> 2) | 0);
   break;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) break L1;
   i11 = i1 + -4 | 0;
   HEAP32[i9 >> 2] = i11;
   i1 = i11;
  }
 } while (0);
 return;
}

function __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE8__appendEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   __ZN14ConstantString12create_emptyEv(i1);
   i1 = (HEAP32[i11 >> 2] | 0) + 4 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = i3 - i4 | 0;
 i3 = i8 >> 1;
 i3 = i8 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i7 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i6 = i7;
 i3 = i5 + (i3 << 2) | 0;
 i8 = i6;
 i1 = i7;
 do {
  HEAP32[i1 >> 2] = 0;
  __ZN14ConstantString12create_emptyEv(i1);
  i1 = i8 + 4 | 0;
  i8 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i5 = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i6;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i6;
  i2 = i7;
  do {
   i7 = i2 + -4 | 0;
   i1 = i1 + -4 | 0;
   HEAP32[i7 >> 2] = 0;
   __ZN14ConstantString6assignERKS_(i7, i1);
   i2 = i3 + -4 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -4 | 0;
  __ZN14ConstantStringD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNK28RectTransformPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i1 = i5;
 i2 = i2 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) {
  STACKTOP = i5;
  return;
 }
 __ZN9Transform18GetTransformAccessEv(i1, i3);
 i11 = i1;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0;
 i1 = HEAP32[i11 + (i10 * 40 | 0) + 4 >> 2] | 0;
 i7 = HEAP32[i11 + (i10 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i11 + (i10 * 40 | 0) >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = i7;
 i12 = HEAP32[i11 + (i10 * 40 | 0) + 16 >> 2] | 0;
 i8 = HEAP32[i11 + (i10 * 40 | 0) + 20 >> 2] | 0;
 i9 = HEAP32[i11 + (i10 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = HEAP32[i11 + (i10 * 40 | 0) + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = i12;
 HEAP32[i4 + 20 >> 2] = i8;
 HEAP32[i4 + 24 >> 2] = i9;
 i9 = HEAP32[i11 + (i10 * 40 | 0) + 32 >> 2] | 0;
 i8 = HEAP32[i11 + (i10 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i4 + 28 >> 2] = HEAP32[i11 + (i10 * 40 | 0) + 28 >> 2];
 HEAP32[i4 + 32 >> 2] = i9;
 HEAP32[i4 + 36 >> 2] = i8;
 if ((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) != f6) {
  HEAPF32[i1 >> 2] = f6;
  __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i3, i4);
  i12 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i12 >> 2] | 0) + 12 >> 2] | 0, i12 | 0, 16);
 }
 STACKTOP = i5;
 return;
}

function __ZN20GpuProgramParameters11AddUAVParamEPKciiP16PropertyNamesSet(i4, i1, i2, i3, i9) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 12 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13 + 4 | 0;
 i5 = i13;
 HEAP32[i5 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, i1);
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 i1 = i4 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 56 >> 2] | 0)) __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4 + 48 | 0, i8); else {
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
 }
 if (!i9) {
  STACKTOP = i13;
  return;
 }
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) != -1 & i6 >>> 0 > 1073741823) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i11 >> 2] = i6;
 i2 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i7 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i6 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) == (i7 | 0)) i12 = 10; else if ((HEAP32[i1 >> 2] | 0) > (i6 | 0)) i12 = 10;
 if ((i12 | 0) == 10) {
  HEAP32[i10 >> 2] = i2;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i9, i8, i11) | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN18AudioLowPassFilter8TransferI14SafeBinaryReadEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i7, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 3);
 i5 = i7 + 132 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 855888 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i7 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 855908 | 0, gb + 1034188 | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i8, 2) | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP8[i7 + 136 >> 0] = 1;
 STACKTOP = i9;
 return;
}

function __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf(i1, f6) {
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i7 = i10 + 8 | 0;
 i8 = i10 + 4 | 0;
 i9 = i10;
 i4 = i1 + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) >>> 0 < 10) {
  __ZN11UnityEngine9Animation23SetBoundCurveFloatValueERKNS0_10BoundCurveEf(i1, f6) | 0;
  STACKTOP = i10;
  return 1;
 }
 if (HEAP32[i1 + 8 >> 2] | 0) {
  __ZN11UnityEngine9Animation23SetBoundCurveFloatValueERKNS0_10BoundCurveEf(i1, f6) | 0;
  STACKTOP = i10;
  return 1;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i2 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = __ZN8Renderer32GetAndAssignInstantiatedMaterialEib(i1, i2, 1) | 0;
 if (!i3) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 i1 = i4 >>> 28;
 i2 = i4 >>> 4 & 16777215;
 switch (i4 & 15) {
 case 10:
  {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i3, i5, f6);
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 12:
  {
   HEAP32[i8 >> 2] = i2;
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   __ZN8Material31SetTextureScaleAndOffsetIndexedEN9ShaderLab16FastPropertyNameEif(i3, i5, i1, f6);
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 11:
  {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
   __ZN8Material15SetColorIndexedEN9ShaderLab16FastPropertyNameEif(i3, i5, i1, f6);
   i9 = 1;
   STACKTOP = i10;
   return i9 | 0;
  }
 default:
  {
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN14PlayerSettings18InitDefaultCursorsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 16 | 0;
 i3 = i8 + 8 | 0;
 i6 = i8;
 i4 = i5 + 268 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  i4 = i5 + 272 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i4;
  i4 = i6 + 4 | 0;
  i5 = i5 + 276 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f(i7, i6);
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 9;
  }
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i9 = i1;
 i7 = i5 + 272 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i7;
 i7 = i6 + 4 | 0;
 i5 = i5 + 276 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f(i9, i6);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSD_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN5Unity14CharacterJointC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i3 = i4 + 40 | 0;
 i2 = i4 + 52 | 0;
 i1 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 111592 + 8;
 i1 = i4 + 96 | 0;
 i2 = i4 + 108 | 0;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = HEAP32[gb + 62536 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62536 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62536 + 8 >> 2];
 HEAP8[i4 + 172 >> 0] = 0;
 HEAPF32[i4 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 180 >> 2] = Math_fround(0.0);
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i8 + 4 | 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
   HEAP32[i2 >> 2] = 1;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
   i3 = i1;
   i2 = i2 | 0 ? i2 - i3 | 0 : 0;
   HEAP32[i1 >> 2] = i2;
  } else i3 = i1;
  __ZN7mecanim12statemachine17ConditionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2 + i3 | 0, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i7;
 return;
}

function __ZN18ComputeShaderParam8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i1);
 i7 = i9 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i10 = i1 + 16 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i8 = i1 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i6, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 i1 = i9 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 12 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i4 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i9 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i2;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i11;
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) == -1) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if ((i1 | 0) == (i3 + 16 | 0)) i2 = 5; else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i2 = 5; else {
    i4 = i3 + 8 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   }
  }
  do if ((i2 | 0) == 5) {
   i1 = i3 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
    i4 = __Znwj(36) | 0;
    HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i4 + 4 >> 2] = 0;
    HEAP32[i4 + 12 >> 2] = 0;
    HEAP8[i4 + 16 >> 0] = 1;
    HEAP32[i4 + 20 >> 2] = 0;
    i5 = i4 + 24 | 0;
    HEAP32[i5 >> 2] = i4;
    HEAP32[i4 + 28 >> 2] = i5;
    HEAP32[i4 + 32 >> 2] = i5;
    HEAP32[i4 + 8 >> 2] = i2;
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) >> 2] = i4;
    i1 = i4;
    break;
   } else {
    i5 = 0;
    return i5 | 0;
   }
  } while (0);
  i4 = i3 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i4 = i1 + 24 | 0;
  i2 = i1 + 32 | 0;
  i6 = i1 + 28 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
  i5 = i3 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 >> 2] = i3 + 28;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] = i4;
  HEAP32[i5 >> 2] = i4;
 } else {
  i1 = HEAP32[(HEAP32[i3 + 40 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = i4 << 16 & 268369920 | i5 << 28 | i6 & 65535;
 i6 = i1;
 return i6 | 0;
}

function __Z10WriteArrayIcEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE(i7, i10) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6 + 1 | 0;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i2 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 + (i6 << 2) >> 2] = i5;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i8 >> 2] | 0;
 i2 = i4 + (i2 >>> 2) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i9 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 _memcpy(i1 + (i4 << 2) | 0, HEAP32[i10 >> 2] | 0, HEAP32[i11 >> 2] | 0) | 0;
 return;
}

function _getservbyname_r(i4, i5, i6, i2, i3, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[gb + 207736 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 207736 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 207736 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 207736 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[gb + 207736 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[gb + 207736 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[gb + 207736 + 24 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[gb + 207736 + 28 >> 2];
 L1 : do if (!i5) if (!(_getservbyname_r(i4, gb + 1074137 | 0, i6, i2, i3, i7) | 0)) i1 = 0; else i1 = _getservbyname_r(i4, gb + 1074141 | 0, i6, i2, i3, i7) | 0; else {
  i1 = i2 & 3;
  i1 = i1 | 0 ? i1 : 4;
  if ((12 - i1 | 0) >>> 0 > i3 >>> 0) i1 = 34; else {
   i1 = i2 + (4 - i1) | 0;
   if (!(_strcmp(i5, gb + 1074137 | 0) | 0)) HEAP32[i9 + 12 >> 2] = 6; else {
    if (_strcmp(i5, gb + 1074141 | 0) | 0) {
     i1 = 22;
     break;
    }
    HEAP32[i9 + 12 >> 2] = 17;
   }
   switch (_getaddrinfo(0, i4 | 0, i9 | 0, i8 | 0) | 0) {
   case -11:
   case -10:
    {
     i1 = 12;
     break L1;
    }
   case 0:
    {
     HEAP32[i6 >> 2] = i4;
     i9 = i6 + 4 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i1 >> 2] = i4;
     HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] = 0;
     i1 = HEAP32[i8 >> 2] | 0;
     HEAP32[i6 + 8 >> 2] = HEAPU16[(HEAP32[i1 + 20 >> 2] | 0) + 2 >> 1];
     HEAP32[i6 + 12 >> 2] = i5;
     _freeaddrinfo(i1);
     HEAP32[i7 >> 2] = i6;
     i1 = 0;
     break L1;
    }
   default:
    {
     i1 = 2;
     break L1;
    }
   }
  }
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4trsXEEEclERS3_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i8 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
 i6 = HEAP8[i5 + 26 >> 0] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP8[i1 + 21 >> 0] = i8 & 1;
 HEAP8[i1 + 22 >> 0] = i6;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i7, i1);
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = Math_imul(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, (0 - i6 & 3) + i6 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i5, i6, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 * 40 | 0) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i5, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 48 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - (HEAP32[i5 + 32 >> 2] | 0) | 0;
 if ((1 - i7 - (HEAP32[i5 + 44 >> 2] | 0) + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i4;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i4;
 return;
}

function __Z31GeomOverlapCallback_CapsuleMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i6 = HEAP32[i3 + 36 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(f16 * Math_fround(2.0));
 f10 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f11 = Math_fround(f10 * Math_fround(2.0));
 f10 = Math_fround(Math_fround(f16 * f13) + Math_fround(Math_fround(f10 * f11) + Math_fround(-1.0)));
 f16 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f9 = Math_fround(f16 * f11);
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f13 * f8));
 f8 = Math_fround(Math_fround(f13 * f16) - Math_fround(f11 * f8));
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f11 * f10);
 f9 = Math_fround(f11 * f9);
 f8 = Math_fround(f11 * f8);
 f11 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f16 = Math_fround(f11 + f10);
 f13 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f15 = Math_fround(f13 + f9);
 f12 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f14 = Math_fround(f8 + f12);
 HEAPF32[i7 >> 2] = f16;
 HEAPF32[i7 + 4 >> 2] = f15;
 HEAPF32[i7 + 8 >> 2] = f14;
 f9 = Math_fround(f13 - f9);
 f8 = Math_fround(f12 - f8);
 HEAPF32[i7 + 12 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i7 + 16 >> 2] = f9;
 HEAPF32[i7 + 20 >> 2] = f8;
 HEAP32[i7 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i7, i6 + 32 | 0, i5, i3 + 4 | 0, 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __Z15CullSpotShadowsR9IndexListPK9SceneNodePK4AABBR15SpotCullContext(i6, i7, i11, i12) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i17 + 128 | 0;
 i13 = i17 + 64 | 0;
 i14 = i17;
 if ((HEAP16[gb + 1114416 + 6 >> 1] | 0) > -1) {
  HEAP32[i13 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114416 | 0, i5);
  i15 = gb + 1114416 | 0;
 } else i15 = 0;
 i16 = i6 + 4 | 0;
 if ((HEAP32[i16 >> 2] | 0) > 0) {
  i8 = i12 + 140 | 0;
  i9 = i12 + 12 | 0;
  i10 = i12 + 76 | 0;
  i4 = 0;
  i1 = 0;
  do {
   i18 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = i11 + (i18 * 24 | 0) | 0;
   i2 = i7 + (i18 * 24 | 0) | 0;
   if (__ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB(i12, HEAP32[i2 >> 2] | 0, HEAP32[i7 + (i18 * 24 | 0) + 4 >> 2] | 0, i3) | 0) if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i3, i8) | 0) {
    i18 = HEAP32[i2 >> 2] | 0;
    __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i9, i18 + 4 | 0, i13);
    __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i13, i14);
    __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i14, i5);
    if (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i18 + 156 | 0, i5) | 0) {
     i18 = HEAP32[i6 >> 2] | 0;
     HEAP32[i18 + (i1 << 2) >> 2] = HEAP32[i18 + (i4 << 2) >> 2];
     i1 = i1 + 1 | 0;
    }
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (HEAP32[i16 >> 2] | 0));
 } else i1 = 0;
 HEAP32[i16 >> 2] = i1;
 if (!i15) {
  STACKTOP = i17;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i15);
 STACKTOP = i17;
 return;
}

function __Z15AddLoopingFrameI11QuaternionfEvR17AnimationCurveTplIT_Ef(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = i1 + 164 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[i1 + 152 >> 2] | 0;
 if ((HEAP32[i6 >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i6 + ((i5 + -1 | 0) * 52 | 0) >> 2] & 2139095040 | 0) == 2139095040) {
  STACKTOP = i7;
  return;
 }
 i9 = i3 + 4 | 0;
 i8 = i3 + 20 | 0;
 i5 = i3 + 36 | 0;
 HEAPF32[i3 >> 2] = f2;
 i10 = i6 + 4 | 0;
 i11 = i9 + 16 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i11 + 24 >> 2] = 0;
 HEAP32[i11 + 28 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i6 = i6 + 36 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E(i1, i3) | 0;
 __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif(i1, 0, Math_fround(0.0));
 __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif(i1, (HEAP32[i4 >> 2] | 0) + -1 | 0, Math_fround(0.0));
 STACKTOP = i7;
 return;
}

function __ZN8Collider17MainThreadCleanupEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i11 + 44 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i14 = i11 + 48 | 0;
 if ((i1 | 0) == (HEAP32[i14 >> 2] | 0)) {
  STACKTOP = i15;
  return;
 }
 i10 = i1;
 while (1) {
  i1 = HEAP32[i10 >> 2] | 0;
  if ((i1 | 0) != (i11 | 0)) {
   i2 = HEAP32[i1 + 36 >> 2] | 0;
   if (i2 | 0) {
    i8 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i8 + 76 >> 2] | 0;
    mftCall_vii(HEAP32[i8 + 80 >> 2] | 0, i12 | 0, i2 | 0);
    mftCall_vii(i9 | 0, i2 | 0, i12 | 0);
   }
   i3 = HEAP32[i1 + 44 >> 2] | 0;
   i9 = i1 + 48 | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i1 = i8 - i3 >> 2;
   i2 = i8;
   if (i1) {
    i4 = i3;
    i5 = i3;
    while (1) {
     i16 = (i1 | 0) / 2 | 0;
     i7 = i5 + (i16 << 2) | 0;
     i6 = (HEAP32[i7 >> 2] | 0) >>> 0 < i11 >>> 0;
     i7 = i7 + 4 | 0;
     i3 = i6 ? i7 : i4;
     i1 = i6 ? i1 + -1 - i16 | 0 : i16;
     if (!i1) break; else {
      i4 = i3;
      i5 = i6 ? i7 : i5;
     }
    }
   }
   if ((i3 | 0) != (i2 | 0)) if ((HEAP32[i3 >> 2] | 0) >>> 0 <= i11 >>> 0) {
    i4 = i3 + 4 | 0;
    i1 = i8 - i4 | 0;
    i5 = i1 >> 2;
    if (i5) {
     _memmove(i3 | 0, i4 | 0, i1 | 0) | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    }
    i1 = i3 + (i5 << 2) | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   }
  }
  i2 = i10 + 4 | 0;
  if ((i2 | 0) == (HEAP32[i14 >> 2] | 0)) break; else i10 = i2;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i15;
  return;
 }
 HEAP32[i14 >> 2] = i2 + (~((i10 - i1 | 0) >>> 2) << 2);
 STACKTOP = i15;
 return;
}

function __ZN5physx7NpScene8simulateEfPNS_10PxBaseTaskEPvjb(i9, f3, i8, i5, i6, i7) {
 i9 = i9 | 0;
 f3 = Math_fround(f3);
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 __ZN5physx7NpScene9visualizeEv(i9);
 HEAP8[i9 + 3696 >> 0] = 1;
 HEAP8[i9 + 3697 >> 0] = 1;
 HEAP8[i9 + 3698 >> 0] = 1;
 HEAPF32[i9 + 3700 >> 2] = f3;
 HEAP8[i9 + 3888 >> 0] = 1;
 i1 = i9 + 3544 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i9 + 3540 | 0;
  i4 = 0;
  do {
   __ZN5physx12NpConstraint15updateConstantsEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i2 = i9 + 16 | 0;
 __ZN5physx3Scb5Scene22updateLowLevelMaterialEPPNS_10NpMaterialE(i2, HEAP32[(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0) | 0) + 52 >> 2] | 0);
 __ZN5physx3Scb5Scene26preSimulateUpdateAppThreadEf(i2, f3);
 HEAP8[i9 + 2448 >> 0] = 1;
 HEAP8[i9 + 2449 >> 0] = 1;
 __ZN5physx2Sc5Scene15setScratchBlockEPvj(i9 + 32 | 0, i5, i6);
 i2 = i9 + 3720 | 0;
 if (i7) {
  i6 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0);
  i6 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0);
 }
 HEAP8[i9 + 3856 >> 0] = i7 & 1;
 i1 = i9 + 3724 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + 3740 >> 2] = 1;
 HEAP32[i9 + 3736 >> 2] = i8;
 HEAP32[i9 + 3732 >> 2] = i7;
 if (i8 | 0) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
 i8 = i9 + 3772 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + 3788 >> 2] = 1;
 HEAP32[i9 + 3784 >> 2] = i1;
 HEAP32[i9 + 3780 >> 2] = i7;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 return;
}

function __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i2 = i9;
 if ((HEAP16[gb + 1165872 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165872 | 0, i6);
  i4 = gb + 1165872 | 0;
 } else i4 = 0;
 HEAP32[i2 >> 2] = i6;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i8 = 8; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i10 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i10 + 28 >> 2] | 0;
   i3 = HEAP32[i10 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    i2 = 0;
    i8 = 11;
   } else if (HEAP32[i1 + 8 >> 2] & 1048576 | 0) {
    i2 = 1;
    i8 = 11;
   }
  }
 }
 if ((i8 | 0) == 8) {
  i1 = 0;
  i2 = 0;
  i8 = 11;
 }
 if ((i8 | 0) == 11) {
  if ((i7 | 0) == 1) __ZN17PersistentManager23DestroyFromFileInternalEi(i5, i6);
  __ZN8Remapper6RemoveEi(HEAP32[i5 + 56 >> 2] | 0, i6);
  if (i2) __ZN6Object15SetIsPersistentEb(i1, 0);
 }
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i9;
 return;
}

function __Z41TerrainData_Set_Custom_PropTreePrototypesP12Il2CppObjectP11Il2CppArray(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i6 = i10;
 i7 = i10 + 12 | 0;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i4 = i2 + 84 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 L7 : do if (i5 | 0) {
  i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
  if (i3 | 0) {
   __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj(i7, i3);
   if ((i3 | 0) > 0) {
    i1 = 0;
    while (1) {
     i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i5, i1) | 0;
     if (!i2) break;
     i12 = i2 + 8 | 0;
     i11 = HEAP32[i12 + 4 >> 2] | 0;
     i2 = i6;
     HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
     HEAP32[i2 + 4 >> 2] = i11;
     __Z18TreePrototypeToCppRK17MonoTreePrototypeR13TreePrototype(i6, (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0);
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i3 | 0)) break L7;
    }
    HEAP32[i9 >> 2] = i1;
    __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 937647 | 0, i9);
   }
  }
 } while (0);
 __ZN12TreeDatabase17SetTreePrototypesERKNSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEE(i4, i7);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3);
 __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Scb4Body8setFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i9 + 236 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!(i3 & 4096)) i1 = i9 + 60 | 0; else i1 = (HEAP32[i9 + 8 >> 2] | 0) + 268 | 0;
 i5 = (HEAP8[i1 >> 0] & 1) != 0;
 i1 = (HEAP8[i8 >> 0] & 1) != 0;
 i2 = i1 & (i5 ^ 1);
 i1 = i5 & (i1 ^ 1);
 i5 = i9 + 4 | 0;
 switch ((HEAP32[i5 >> 2] | 0) >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 6;
   break;
  }
 default:
  i4 = 6;
 }
 if ((i4 | 0) == 6) {
  if (i2) {
   HEAP32[i9 + 232 >> 2] = 1;
   i7 = i9 + 204 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i7 + 8 >> 2] = 0;
   HEAP32[i7 + 12 >> 2] = 0;
   HEAP32[i7 + 16 >> 2] = 0;
   HEAP32[i7 + 20 >> 2] = 0;
   HEAP32[i7 + 24 >> 2] = 0;
  }
  i1 = HEAP32[i9 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 1248 >> 2] | 0;
  HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
  __ZN5physx2Sc8BodyCore8setFlagsEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i9 + 16 | 0, i1, i6);
  STACKTOP = i10;
  return;
 }
 if (i2) __ZN5physx3Scb4Body18putToSleepInternalEv(i9); else if (i1) HEAP32[i7 >> 2] = i3 & -8193;
 i2 = i9 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i9 >> 2] | 0, (HEAP32[i5 >> 2] | 0) >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 268 >> 0] = HEAP8[i8 >> 0] | 0;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i9 >> 2] | 0, i9);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4096;
 STACKTOP = i10;
 return;
}

function __ZN22UnityWebRequestManager21CreateUnityWebRequestEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 if (!(HEAP8[gb + 1573588 >> 0] | 0)) {
  __Z6FormatPKcz(i1, gb + 1027428 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1027486 | 0, 105, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKci(124, gb + 63808 | 0, 16, gb + 1027486 | 0, 119) | 0;
  i1 = i4 + 4 | 0;
  i5 = i1;
  i6 = i5 + 116 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP16[i1 + 116 >> 1] = 0;
  HEAP32[i4 >> 2] = gb + 188012 + 8;
  HEAP32[i1 >> 2] = 1;
  __ZN19TransportJavaScriptC2Ev(i4 + 8 | 0);
  i1 = i4 + 36 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 40 >> 2] = 0;
  i2 = i4 + 48 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 52 >> 2] = 0;
  HEAP32[i4 + 44 >> 2] = i2;
  i2 = i4 + 108 | 0;
  i3 = i4 + 120 | 0;
  i5 = i4 + 56 | 0;
  i6 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  HEAP8[i3 >> 0] = 1;
  HEAP8[i4 + 121 >> 0] = 1;
  HEAP32[i2 >> 2] = 1;
  __ZN14RedirectHelper16SetRedirectLimitEj(i1, 32) | 0;
  HEAP32[i4 >> 2] = gb + 187980 + 8;
  i6 = __Znwj(12) | 0;
  HEAP32[i6 + 8 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = gb + 1468908;
  i5 = HEAP32[gb + 1468908 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i5 + 4 >> 2] = i6;
  HEAP32[gb + 1468908 >> 2] = i6;
  HEAP32[gb + 1468908 + 8 >> 2] = (HEAP32[gb + 1468908 + 8 >> 2] | 0) + 1;
  i6 = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN11TypeManager7Builder3AddEP4RTTI(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = (i1 | 0) == 0;
 if (i9) i2 = -1; else {
  i2 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i2 | 0) == -2147483648) i2 = __ZN11TypeManager7Builder3AddEP4RTTI(i8, i1) | 0;
 }
 i7 = i8 + 12 | 0;
 i11 = HEAP32[i7 >> 2] | 0;
 i3 = i11 + 1 | 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 * 12 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i3;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i4 + (i11 * 12 | 0) >> 2] = i10;
 HEAP32[i4 + (i11 * 12 | 0) + 4 >> 2] = -1;
 HEAP32[i10 + 24 >> 2] = i11;
 if (i9) {
  HEAP32[i4 + (i11 * 12 | 0) + 8 >> 2] = -1;
  return i11 | 0;
 }
 i2 = i4 + (i2 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 L16 : do if ((i1 | 0) == -1) i1 = -1; else {
  i3 = HEAP32[i10 + 8 >> 2] | 0;
  while (1) {
   if ((_strcmp(HEAP32[(HEAP32[i4 + (i1 * 12 | 0) >> 2] | 0) + 8 >> 2] | 0, i3) | 0) >= 0) break L16;
   i2 = i4 + (i1 * 12 | 0) + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == -1) {
    i1 = -1;
    break;
   }
  }
 } while (0);
 HEAP32[i4 + (i11 * 12 | 0) + 8 >> 2] = i1;
 HEAP32[i2 >> 2] = i11;
 return i11 | 0;
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 68 | 0) + 1 | 0;
 if (i3 >>> 0 > 63161283) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 68 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 31580641 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 63161283;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i10 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 68 | 0) | 0;
 HEAP32[i11 >> 2] = i4;
 i1 = i4 + (((i2 - i1 | 0) / 68 | 0) * 68 | 0) | 0;
 i6 = i11 + 8 | 0;
 i7 = i11 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i4 + (i3 * 68 | 0);
 __ZN19SpriteMeshGenerator4pathC2ERKS0_(i1, i5);
 HEAP32[i6 >> 2] = i1 + 68;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i1 = i1 + -68 | 0;
   i2 = i2 + -68 | 0;
   __ZN19SpriteMeshGenerator4pathC2ERKS0_(i1, i2);
   HEAP32[i7 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i12;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 __ZNSt3__214__split_bufferIN19SpriteMeshGenerator4pathERNS_9allocatorIS2_EEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESN_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN7dtCrowd13ReserveAgentsEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i6 >> 2] | 0) >= (i7 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = i6 + 16 | 0;
 i1 = __Z9dtReallocPvi(HEAP32[i5 >> 2] | 0, i7 * 608 | 0) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i2 = i6 + 456 | 0;
 i3 = i7 << 2;
 i1 = __Z9dtReallocPvi(HEAP32[i2 >> 2] | 0, i3) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = i6 + 24 | 0;
 i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i7 * 132 | 0) | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 i4 = i6 + 20 | 0;
 i1 = __Z9dtReallocPvi(HEAP32[i4 >> 2] | 0, i7 * 56 | 0) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i2 = i6 + 392 | 0;
 i1 = __Z9dtReallocPvi(HEAP32[i2 >> 2] | 0, i3) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) < (i7 | 0)) {
  i2 = HEAP32[i5 >> 2] | 0;
  do {
   _memset(i2 + (i1 * 608 | 0) | 0, 0, 608) | 0;
   HEAPF32[i2 + (i1 * 608 | 0) + 52 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i2 + (i1 * 608 | 0) + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
   HEAPF32[i2 + (i1 * 608 | 0) + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
   i3 = (HEAP32[i5 >> 2] | 0) + (i1 * 608 | 0) + 602 | 0;
   HEAP8[i3 >> 0] = HEAP8[i3 >> 0] & -2;
   i3 = (HEAP32[i4 >> 2] | 0) + (i1 * 56 | 0) + 40 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i3 = i1;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i2 + (i3 * 608 | 0) + 384 >> 2] = i1;
  } while ((i1 | 0) != (i7 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = i7;
 __ZN7dtCrowd19ResizeProximityGridEv(i6);
 i7 = 1;
 return i7 | 0;
}

function __ZN5physx15PxSerialization27createSerializationRegistryERNS_9PxPhysicsE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i4 | 0, i3 | 0, 100, (i2 ? gb + 755183 | 0 : gb + 837976 | 0) | 0, gb + 667371 | 0, 264) | 0;
 HEAP32[i2 >> 2] = gb + 89032 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(.75);
 HEAP32[i2 + 36 >> 2] = -1;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i2 + 48 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 72 >> 2] = Math_fround(.75);
 HEAP32[i2 + 76 >> 2] = -1;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i2 + 88 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 _PxRegisterPhysicsSerializers(i2);
 __ZN5physx3Ext29RegisterExtensionsSerializersERNS_23PxSerializationRegistryE(i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3719 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3720 | 0);
 return i2 | 0;
}

function __ZN5Unity10HingeJointC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i5 = i6;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i1 = i4 + 40 | 0;
 i3 = i4 + 52 | 0;
 i5 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 112384 + 8;
 HEAPF32[i4 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 108 >> 2] = Math_fround(.200000003);
 i5 = i4 + 156 | 0;
 i3 = i4 + 152 | 0;
 i1 = i4 + 112 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i5 >> 2] = 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 STACKTOP = i6;
 return;
}

function __ZN16SpriteRenderData16GenerateFullMeshERK5RectTIfERK8Vector2fffjPS1_bPNSt3__26vectorI13dynamic_arrayIS4_Lj4EENS8_9allocatorISB_EEEE(i7, i8, i9, f10, f11, i12, i13, i14, i15) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i17;
 i16 = i17 + 8 | 0;
 i5 = i7 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i4 = i6;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i1 + 12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i1 + 32 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i16 >> 2];
 __Z21GenerateSpriteOutline4PPtrI9Texture2DEfRK5RectTIfERK8Vector2ffhbjibPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENS9_9allocatorISC_EEEEPSB_I12SpriteVertexLj4EEPSB_ItLj2EEPS3_P8Vector4f(i6, f10, i8, i9, f11, 0, 1, i12, 1, i14, i15, i1 + 8 | 0, i1 + 28 | 0, i13, i7 + 36 | 0);
 STACKTOP = i17;
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 1;
 i6 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 8 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i5 = i4 + 12 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903113 | 0, i4, 0);
 i8 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903131 | 0, i8, i4, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903147 | 0, i8, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903157 | 0, i6, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903174 | 0, i6, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i1;
 return;
}

function __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i2 = i6;
 __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
 __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 72 | 0, i5);
 i4 = HEAP32[i1 + 144 >> 2] | 0;
 f7 = Math_fround(Math_fround((i4 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f8 = Math_fround(Math_fround(i4 >>> 16 & 255) / Math_fround(255.0));
 f9 = Math_fround(Math_fround(i4 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(i4 & 255) / Math_fround(255.0));
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f8;
 HEAPF32[i3 + 12 >> 2] = f9;
 i4 = HEAP32[i1 + 148 >> 2] | 0;
 f9 = Math_fround(Math_fround((i4 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f8 = Math_fround(Math_fround(i4 >>> 16 & 255) / Math_fround(255.0));
 f7 = Math_fround(Math_fround(i4 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(i4 & 255) / Math_fround(255.0));
 HEAPF32[i2 + 4 >> 2] = f9;
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f7;
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i5);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2, i5);
 i1 = i1 + 152 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  STACKTOP = i6;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN13MonoBehaviour20InvokeOnRenderObjectEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 248 | 0;
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i4 + 20 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i4 + 141 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  i1 = i4 + 60 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  if (i2) {
   i3 = HEAPU8[i3 + 100 >> 0] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 + 4 >> 2] = i3;
   HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i4, i8, 0) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
  }
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  if (i2) {
   i3 = HEAPU8[i3 + 92 >> 0] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i3;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i4, i8, 0) | 0;
  }
 } else i1 = i4 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i4 + 28 >> 2] | 0;
  if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
   i7 = HEAP32[i7 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i7, i8);
   HEAP32[i5 + 216 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i8 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i8, 0) | 0;
  }
 }
 STACKTOP = i9;
 return;
}

function __ZN13ComputeShader18DestroyRuntimeDataEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = __Z12GetGfxDevicev() | 0;
 i9 = i10 + 48 | 0;
 if ((HEAP32[i9 >> 2] | 0) > 0) {
  i6 = i10 + 44 | 0;
  i1 = 0;
  i2 = HEAP32[i6 >> 2] | 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 788 >> 2] | 0, i7 | 0, i2 + (i1 * 976 | 0) | 0);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i2 + (i1 * 976 | 0) + 964 >> 2] | 0;
   i4 = i2 + (i1 * 976 | 0) + 968 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i9 >> 2] | 0));
 } else i6 = i10 + 44 | 0;
 i8 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i10, 22, 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 800 >> 2] | 0, i7 | 0, ((HEAP32[i8 + 24 >> 2] | 0) - (HEAP32[i8 + 20 >> 2] | 0) | 0) / 20 | 0 | 0, i10 + 192 | 0);
 i7 = HEAP32[i6 >> 2] | 0;
 if (i7 | 0) {
  i8 = i7 + -4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i1 = i7 + (i1 * 976 | 0) | 0;
   do {
    i2 = HEAP32[i1 + -12 >> 2] | 0;
    i3 = i2;
    if (i2 | 0) {
     i4 = i1 + -8 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i2);
    }
    i1 = i1 + -976 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  __ZdaPv(i8);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i1 = i10 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i9 = i10 + 56 | 0;
  HEAP32[i9 >> 2] = 0;
  i10 = i10 + 60 | 0;
  HEAP32[i10 >> 2] = 0;
  return;
 }
 __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i9 = i10 + 56 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i10 + 60 | 0;
 HEAP32[i10 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream5flushEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i2 = i9 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i5 = i9 + 88 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i9 + 16 | 0;
 i7 = i9 + 72 | 0;
 i8 = i9 + 68 | 0;
 i4 = (HEAP32[i6 >> 2] | 0) == ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 L1 : do if (!i4) {
  i1 = i9 + 100 | 0;
  i3 = i9 + 96 | 0;
  i4 = i9 + 92 | 0;
  while (1) {
   i10 = HEAP32[i1 >> 2] | 0;
   i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0) | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
   if (!i10) break;
   __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i3 >> 2] | 0);
   __ZN5physx6shdfnd8SyncImpl4waitEj(HEAP32[i4 >> 2] | 0, 1) | 0;
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
   i10 = (HEAP32[i6 >> 2] | 0) == ((HEAP32[i7 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0);
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   if (i10) break L1;
  }
  i10 = HEAP32[i1 >> 2] | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 + 12 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = mftCall_ii(i9 | 0, i10 | 0) | 0;
  i10 = i10 & 1;
  i10 = i10 ^ 1;
  return i10 | 0;
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i10 = i9 + 100 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + 12 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = mftCall_ii(i9 | 0, i10 | 0) | 0;
 i10 = i10 & 1;
 i10 = i10 ^ 1;
 return i10 | 0;
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i3 - i1 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 - i4 + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 14;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (i1 - i4) | 0;
 i5 = i5 + i3 | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i4 + 1 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (0 - i2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 14;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx9NpFactory18createArticulationEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i5 = i8 + 12 | 0;
 if (!(HEAP32[gb + 1457340 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 605, gb + 686266 | 0, i8);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 2740 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 2736 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 2444 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i4 = i2 + 2724 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i2 + 2728 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 534, gb + 689334 | 0, i8 + 8 | 0);
  i1 = 0;
 } else {
  __ZN5physx14NpArticulationC2Ev(i1);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  HEAP32[i5 >> 2] = i1;
  i3 = i6 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i2 = __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i6 + 484 | 0, i5, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i2 >> 2] = i1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 }
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN10GameObject18TransferComponentsI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 16 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) {
  STACKTOP = i5;
  return;
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 368714 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 28 | 0, 65);
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 368726 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 368740 | 0, gb + 619781 | 0, i4 + 4 | 0, 0);
 i1 = i3 + 8 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 1);
 i3 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i1, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i5;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = i2 - i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z12KillParticleRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRj(i2, i3, i10, i11, i12) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i16;
 i14 = i3 + 428 | 0;
 if (!(HEAP32[i14 >> 2] | 0)) {
  i15 = HEAP32[i12 >> 2] | 0;
  i15 = i15 + -1 | 0;
  __ZN23ParticleSystemParticles14element_assignEjj(i10, i11, i15);
  i15 = HEAP32[i12 >> 2] | 0;
  i15 = i15 + -1 | 0;
  HEAP32[i12 >> 2] = i15;
  STACKTOP = i16;
  return;
 }
 i15 = i3 + 496 | 0;
 i4 = i13 + 4 | 0;
 i5 = i13 + 8 | 0;
 i6 = i13 + 12 | 0;
 i7 = i13 + 16 | 0;
 i8 = i13 + 20 | 0;
 i9 = i3 + 424 | 0;
 i1 = 0;
 do {
  i17 = HEAP32[i15 >> 2] | 0;
  HEAPF32[i13 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAP32[i5 >> 2] = i17;
  i17 = (Math_imul(i17, 1812433253) | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i17;
  i17 = (Math_imul(i17, 1812433253) | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i17;
  HEAP32[i8 >> 2] = (Math_imul(i17, 1812433253) | 0) + 1;
  __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff(i13, (HEAP32[i9 >> 2] | 0) + (i1 * 600 | 0) | 0, i2, i3, i10, 2, i1, i11, Math_fround(.0000999999974), Math_fround(.0000999999974), Math_fround(1.0));
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 i17 = HEAP32[i12 >> 2] | 0;
 i17 = i17 + -1 | 0;
 __ZN23ParticleSystemParticles14element_assignEjj(i10, i11, i17);
 i17 = HEAP32[i12 >> 2] | 0;
 i17 = i17 + -1 | 0;
 HEAP32[i12 >> 2] = i17;
 STACKTOP = i16;
 return;
}

function __ZNSt3__212strstreambuf8overflowEi(i11, i15) {
 i11 = i11 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 do if ((i15 | 0) == -1) i1 = 0; else {
  i16 = i11 + 24 | 0;
  i1 = HEAP32[i16 >> 2] | 0;
  i13 = i11 + 28 | 0;
  if ((i1 | 0) == (HEAP32[i13 >> 2] | 0)) {
   i14 = i11 + 32 | 0;
   if ((HEAP32[i14 >> 2] & 12 | 0) != 4) {
    i1 = -1;
    break;
   }
   if (!i1) i1 = HEAP32[i11 + 16 >> 2] | 0;
   i12 = i11 + 8 | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   i4 = i1 - i2 | 0;
   i1 = HEAP32[i11 + 36 >> 2] | 0;
   i3 = i4 << 1;
   i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
   i1 = (i1 | 0) == 0 ? 4096 : i1;
   i3 = HEAP32[i11 + 40 >> 2] | 0;
   if (!i3) i1 = __Znaj(i1) | 0; else {
    i1 = mftCall_ii(i3 | 0, i1 | 0) | 0;
    if (!i1) {
     i1 = -1;
     break;
    }
    i2 = HEAP32[i12 >> 2] | 0;
   }
   _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
   i3 = i11 + 12 | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i7 = i4;
   i5 = (HEAP32[i3 >> 2] | 0) - i7 | 0;
   i6 = i11 + 16 | 0;
   i7 = (HEAP32[i6 >> 2] | 0) - i7 | 0;
   i8 = i11 + 20 | 0;
   i10 = HEAP32[i8 >> 2] | 0;
   i9 = (HEAP32[i16 >> 2] | 0) - i10 | 0;
   i10 = (HEAP32[i13 >> 2] | 0) - i10 | 0;
   do if (HEAP32[i14 >> 2] & 1 | 0) {
    i2 = HEAP32[i11 + 44 >> 2] | 0;
    if (!i2) {
     __ZdaPv(i4);
     break;
    } else {
     mftCall_vi(i2 | 0, i4 | 0);
     break;
    }
   } while (0);
   i11 = i1 + i7 | 0;
   HEAP32[i12 >> 2] = i1;
   HEAP32[i3 >> 2] = i1 + i5;
   HEAP32[i6 >> 2] = i11;
   HEAP32[i8 >> 2] = i11;
   HEAP32[i13 >> 2] = i11 + i10;
   i1 = i11 + i9 | 0;
   HEAP32[i16 >> 2] = i1;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] | 1;
  }
  HEAP8[i1 >> 0] = i15;
  HEAP32[i16 >> 2] = (HEAP32[i16 >> 2] | 0) + 1;
  i1 = i15 & 255;
 } while (0);
 return i1 | 0;
}

function __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i3 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i5 + 4;
 HEAP32[i8 + 4 >> 2] = i5;
 HEAP32[i8 + 8 >> 2] = i3;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i9, i8, 0);
 i3 = i5 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i4;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i8, 4);
 i1 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i4 = i5 + 16 | 0;
 i5 = i5 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i8, 4);
 i1 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i8 * 76 | 0) | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN4math4Axes8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 76 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn9MetaClass21checkAndCompleteClassERKNS0_8MetaDataERiS5_(i7, i3, i6, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i9;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i3, 1, gb + 671424 | 0, i4);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 671086;
 HEAP32[i5 + 4 >> 2] = gb + 671477;
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i5 + 16 >> 2] = i1;
 HEAP32[i5 + 24 >> 2] = 512;
 i1 = i7 + 36 | 0;
 i2 = i7 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 44 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i9 = (HEAP32[i1 >> 2] | 0) + (i3 << 5) | 0;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i9 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i9 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i5) | 0;
 HEAP32[i6 >> 2] = -1;
 STACKTOP = i8;
 return;
}

function __Z22CleanupVehiclesManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1458872 >> 2] | 0, gb + 63400 | 0);
 HEAP32[gb + 1458872 >> 2] = 0;
 i2 = HEAP32[gb + 1458876 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
 HEAP32[gb + 1458876 >> 2] = 0;
 __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs7releaseEv(HEAP32[gb + 1458880 >> 2] | 0);
 HEAP32[gb + 1458880 >> 2] = 0;
 i2 = HEAP32[gb + 1458540 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6;
 if ((i4 | 0) == (i6 | 0)) {
  i3 = i1;
  i1 = i4;
  i2 = i5;
 } else {
  i6 = 0;
  while (1) {
   i1 = HEAP32[i1 + (i6 << 2) >> 2] | 0;
   if (i1) {
    __ZN5physx16PxVehicleNoDrive4freeEv(i1);
    i2 = HEAP32[gb + 1458540 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
   i5 = i2 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i3 = i4;
   if (i6 >>> 0 >= i1 - i4 >> 2 >>> 0) {
    i2 = i5;
    break;
   } else i1 = i3;
  }
 }
 if ((i1 | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i1 + (~((i1 + -4 - i4 | 0) >>> 2) << 2);
 i2 = HEAP32[gb + 1458620 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i2 = HEAP32[gb + 1458700 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i1 = HEAP32[gb + 1458780 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[gb + 1458868 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[gb + 1458868 >> 2] = 0;
 return;
}

function _cff_size_request(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (HEAP32[i1 + 8 >> 2] & 2) {
  if (mftCall_iiii(HEAP32[(HEAP32[i1 + 532 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0) | 0) {
   HEAP32[i4 + 44 >> 2] = -1;
   i1 = HEAP32[i4 >> 2] | 0;
   break;
  }
  _cff_size_select(i4, HEAP32[i2 >> 2] | 0) | 0;
  STACKTOP = i10;
  return 0;
 } while (0);
 _UNITY_FT_Request_Metrics(i1, i3);
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 656 >> 2] | 0) + 2952 >> 2] | 0;
 i2 = _UNITY_FT_Get_Module(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1006904 | 0) | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  STACKTOP = i10;
  return 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return 0;
 }
 i1 = mftCall_ii(i1 | 0, i2 | 0) | 0;
 if (!i1) {
  STACKTOP = i10;
  return 0;
 }
 i7 = HEAP32[(HEAP32[i4 >> 2] | 0) + 656 >> 2] | 0;
 i8 = HEAP32[i4 + 40 >> 2] | 0;
 i9 = HEAP32[i7 + 1392 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i6 = i4 + 16 | 0;
 i4 = i4 + 20 | 0;
 mftCall_viiiii(HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0, 0);
 i1 = HEAP32[i7 + 1896 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return 0;
 }
 do {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[(HEAP32[i7 + 1900 + (i1 << 2) >> 2] | 0) + 68 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) i3 = HEAP32[i4 >> 2] | 0; else {
   i2 = _UNITY_FT_MulDiv(i2, i9, i3) | 0;
   i3 = _UNITY_FT_MulDiv(HEAP32[i4 >> 2] | 0, i9, i3) | 0;
  }
  mftCall_viiiii(HEAP32[i5 >> 2] | 0, HEAP32[i8 + 4 + (i1 << 2) >> 2] | 0, i2 | 0, i3 | 0, 0, 0);
 } while ((i1 | 0) != 0);
 STACKTOP = i10;
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESL_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK5physx22PxcHeightFieldAabbTest5beginEv(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i9 = 0, i11 = 0, i12 = 0, f13 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if (HEAP8[i10 + 4 >> 0] | 0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = i10;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i10 + 8 >> 2] | 0;
 i5 = HEAP32[i10 + 16 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i9 + 16 >> 2] = i10;
 HEAP32[i9 + 8 >> 2] = 0;
 i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = (Math_imul(i4, i12) | 0) + i5 | 0;
 HEAP32[i9 + 12 >> 2] = i5;
 do if (((Math_imul(i4, HEAP32[i10 + 12 >> 2] | 0) | 0) + (HEAP32[i10 + 20 >> 2] | 0) | 0) != (i5 | 0)) {
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  if ((HEAP8[i1 + ((i5 & 2147483647) << 2) + 2 >> 0] & 127) != 127) {
   f6 = Math_fround(HEAP16[i1 + (i5 << 2) >> 1] | 0);
   f7 = Math_fround(HEAP16[i1 + (i5 + 1 << 2) >> 1] | 0);
   i12 = i4 + i5 | 0;
   f3 = Math_fround(HEAP16[i1 + (i12 << 2) >> 1] | 0);
   f2 = Math_fround(HEAP16[i1 + (i12 + 1 << 2) >> 1] | 0);
   f13 = Math_fround(HEAPF32[i10 + 28 >> 2]);
   if (!(f13 < f2 & (f13 < f3 & (f13 < f6 & f13 < f7)))) {
    f13 = Math_fround(HEAPF32[i10 + 24 >> 2]);
    if (!(f13 > f2) | f13 > f3 & (f13 > f6 & f13 > f7) ^ 1) break;
   }
  }
  __ZN5physx22PxcHeightFieldAabbTest8IteratorppEv(i9) | 0;
 } while (0);
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 STACKTOP = i11;
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9getHandleEPKc(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i7 = i10 + 16 | 0;
 i6 = i10;
 i1 = (i1 | 0) == 0 ? gb + 1576256 | 0 : i1;
 i5 = HEAP32[i8 + 112 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(i2 << 24 >> 24)) i2 = 5381; else {
   i3 = 5381;
   i4 = i1;
   do {
    i3 = i3 * 33 ^ i2 << 24 >> 24;
    i4 = i4 + 1 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
   i2 = i3;
  }
  i2 = HEAP32[(HEAP32[i8 + 104 >> 2] | 0) + ((i2 & i5 + -1) << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   i5 = HEAP32[i8 + 96 >> 2] | 0;
   i4 = i8 + 100 | 0;
   while (1) {
    i3 = i5 + (i2 << 3) | 0;
    if (!(_strcmp(HEAP32[i3 >> 2] | 0, i1) | 0)) break;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   if (i3 | 0) {
    i9 = HEAP32[i5 + (i2 << 3) + 4 >> 2] | 0;
    STACKTOP = i10;
    return i9 | 0;
   }
  }
 } while (0);
 i2 = (HEAP32[i8 + 128 >> 2] | 0) + 1 | 0;
 HEAP32[i9 >> 2] = i1;
 i3 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb(i8 + 84 | 0, i9, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_16StringTableEventEEEvT_(i8, i9);
 i9 = i2;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx30solveContactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i3, i1, i6, i8, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i5 = i7;
 __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i6);
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAPU16[i3 + 10 >> 1] | 0) << 6);
 HEAP32[i1 + 4 >> 2] = i2 + ((HEAPU16[i3 + 42 >> 1] | 0) << 6);
 HEAP32[i1 + 8 >> 2] = i2 + ((HEAPU16[i3 + 74 >> 1] | 0) << 6);
 HEAP32[i1 + 12 >> 2] = i2 + ((HEAPU16[i3 + 106 >> 1] | 0) << 6);
 HEAP32[i5 >> 2] = i2 + ((HEAPU16[i3 + 14 >> 1] | 0) << 6);
 HEAP32[i5 + 4 >> 2] = i2 + ((HEAPU16[i3 + 46 >> 1] | 0) << 6);
 HEAP32[i5 + 8 >> 2] = i2 + ((HEAPU16[i3 + 78 >> 1] | 0) << 6);
 HEAP32[i5 + 12 >> 2] = i2 + ((HEAPU16[i3 + 110 >> 1] | 0) << 6);
 __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i3, i6, i1, i5);
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i6 + 12 >> 2] | 0) + -4 | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i4, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i6 = i8 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN23ShaderVariantCollection11VariantInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 479430 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i5 + 24 | 0, 0);
 i7 = i2 + 16 | 0;
 i6 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 479439 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0);
 HEAP32[(HEAP32[HEAP32[i7 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 STACKTOP = i5;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier1ELi16EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i7 + 8 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i3 - i1 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  STACKTOP = i12;
  return;
 }
 i8 = i7 + 12 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 - i4 + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else {
  i5 = HEAP32[i8 >> 2] | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
 }
 i6 = i5 + (i1 - i4) | 0;
 i5 = i5 + i3 | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i4 + 1 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) - i1 | 0;
 i3 = i6 + (0 - i2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i9 + 4 | 0;
 i5 = i2;
 i2 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i12 = i4 << 24 >> 24 < 0;
  i3 = i12 ? HEAP32[i2 >> 2] | 0 : i2;
  i4 = i12 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i4 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i4 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i4;
   if (i4) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i13 = i4 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i6 >> 2] = i2;
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i12;
   HEAP32[i1 + 8 >> 2] = i13 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i12;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  HEAP8[i1 + i4 >> 0] = 0;
  i2 = i5 + 16 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 16 | 0;
  HEAP32[i7 >> 2] = i1;
  if ((i2 | 0) == (i8 | 0)) break; else i5 = i2;
 }
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN5Unity5Joint22JointTransferPreNoAxisI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738066 | 0, gb + 738082 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 946522 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800674 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 800705 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN26EnlightenSystemInformation8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 24 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 40 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 24 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  i8 = i6 + 40 | 0;
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i3 = i5 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i5 + 8 | 0;
 i3 = i1 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i5 + 12 | 0, gb + 1084124 | 0, 0);
 i5 = i5 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i5 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i2 = i7 + 60 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 76 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN11AssetBundle7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(188, i1, 16, gb + 1048932 | 0, 0, gb + 367658 | 0, 45) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 27268 + 8;
 HEAP32[i4 + 32 >> 2] = 1;
 i2 = i4 + 36 | 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i4 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i4 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = i1;
 i1 = i4 + 84 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = i1;
 __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev(i4 + 92 | 0);
 i1 = i4 + 148 | 0;
 i2 = i4 + 168 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 __ZN14ConstantString12create_emptyEv(i2);
 i2 = i4 + 172 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, 61);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z16pqHeapExtractMinP13PriorityQHeap(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i11 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i13 + (i3 << 3) | 0;
 i14 = HEAP32[i4 >> 2] | 0;
 i5 = i2 + 8 | 0;
 i15 = HEAP32[i5 >> 2] | 0;
 if ((i15 | 0) <= 0) return i14 | 0;
 i12 = HEAP32[i11 + (i15 << 2) >> 2] | 0;
 HEAP32[i1 >> 2] = i12;
 i10 = i13 + (i12 << 3) + 4 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i4 >> 2] = 0;
 i9 = i2 + 16 | 0;
 HEAP32[i13 + (i3 << 3) + 4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i3;
 i9 = i15 + -1 | 0;
 HEAP32[i5 >> 2] = i9;
 if ((i15 | 0) == 1) return i14 | 0;
 i8 = i13 + (i12 << 3) | 0;
 i5 = 1;
 while (1) {
  i1 = i5 << 1;
  do if ((i1 | 0) < (i9 | 0)) {
   i2 = i1 | 1;
   i3 = HEAP32[i13 + (HEAP32[i11 + (i2 << 2) >> 2] << 3) >> 2] | 0;
   f6 = Math_fround(HEAPF32[i3 + 24 >> 2]);
   i4 = HEAP32[i13 + (HEAP32[i11 + (i1 << 2) >> 2] << 3) >> 2] | 0;
   f7 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   if (!(f6 < f7)) {
    if (!(f6 == f7)) break;
    f7 = Math_fround(HEAPF32[i3 + 28 >> 2]);
    if (!(f7 <= Math_fround(HEAPF32[i4 + 28 >> 2]))) break;
   }
   i1 = i2;
  } while (0);
  i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) >= (i15 | 0)) break;
  i3 = HEAP32[i8 >> 2] | 0;
  f6 = Math_fround(HEAPF32[i3 + 24 >> 2]);
  i4 = HEAP32[i13 + (i2 << 3) >> 2] | 0;
  f7 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  if (f6 < f7) break;
  if (f6 == f7) {
   f7 = Math_fround(HEAPF32[i3 + 28 >> 2]);
   if (f7 <= Math_fround(HEAPF32[i4 + 28 >> 2])) break;
  }
  HEAP32[i11 + (i5 << 2) >> 2] = i2;
  HEAP32[i13 + (i2 << 3) + 4 >> 2] = i5;
  i5 = i1;
 }
 HEAP32[i11 + (i5 << 2) >> 2] = i12;
 HEAP32[i10 >> 2] = i5;
 return i14 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4syncEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i1 | 0, i4 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i4;
  i1 = i4;
  i5 = 6;
 } else {
  do if (HEAP8[i1 >> 0] | 0) {
   i1 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   if (!i1) {
    i6 = -1;
    break L1;
   }
   __THREW__ = 0;
   i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (!(i3 & 1)) {
    if ((i1 | 0) != -1) break;
    i3 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i6 = -1;
     break L1;
    }
   }
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i4;
   i1 = i4;
   i5 = 6;
   break L1;
  } while (0);
  i6 = 0;
 } while (0);
 do if ((i5 | 0) == 6) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   i6 = 0;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4syncEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i1 | 0, i4 | 0, 1);
 i3 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i3 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i4;
  i1 = i4;
  i5 = 6;
 } else {
  do if (HEAP8[i1 >> 0] | 0) {
   i1 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
   if (!i1) {
    i6 = -1;
    break L1;
   }
   __THREW__ = 0;
   i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (!(i3 & 1)) {
    if ((i1 | 0) != -1) break;
    i3 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
    __THREW__ = 0;
    invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) {
     i6 = -1;
     break L1;
    }
   }
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i4;
   i1 = i4;
   i5 = 6;
   break L1;
  } while (0);
  i6 = 0;
 } while (0);
 do if ((i5 | 0) == 6) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   ___cxa_end_catch();
   i6 = 0;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN8UVModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 544 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i5 | 0) < 0 ? 0 : (i5 | 0) > 1 ? 1 : i5;
 i3 = i1 + 536 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i5 | 0) > 1 ? i5 : 1;
 i3 = i1 + 540 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i5 = (i5 | 0) > 1 ? i5 : 1;
 HEAP32[i3 >> 2] = i5;
 i3 = i1 + 552 | 0;
 i4 = ~~Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(((i4 | 0) > 1 ? i4 : 1) | 0);
 i3 = i1 + 548 | 0;
 i5 = i5 + -1 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 0 ? 0 : (i4 | 0) > (i5 | 0) ? i5 : i4;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(.999899983);
 f2 = i5 ? Math_fround(.999899983) : f2;
 f2 = i4 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i3 = i1 + 352 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(.999899983);
 f2 = i5 ? Math_fround(.999899983) : f2;
 f2 = i4 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i3 = i1 + 564 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 568 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN22UnityProfilerPerThread24AddMiscSamplesAfterFrameEyb(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, f12 = f0;
 if (!(HEAP32[i4 + 4 >> 2] | 0)) return;
 i8 = i4 + 16 | 0;
 if (!(HEAP32[(HEAP32[HEAP32[HEAP32[i8 >> 2] >> 2] >> 2] | 0) + 12 >> 2] | 0)) return;
 if (HEAP8[i4 + 157 >> 0] | 0) return;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (i1 | 0) __ZN13UnityProfiler18StartProfilingModeE12ProfilerMode(i1, 2);
 i1 = i4 + 248 | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!((i2 | 0) == 0 & (i3 | 0) == 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i4, gb + 1163364 | 0, 0) | 0;
  i1 = HEAP32[(HEAP32[i4 + 36 >> 2] | 0) + ((HEAP32[i4 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
  i9 = HEAP32[HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 >>> 14 << 2) >> 2] >> 2] | 0;
  d11 = +_emscripten_get_now() * 1.0e6;
  i10 = +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0;
  __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i4, gb + 1163364 | 0, ~~d11 >>> 0, i10) | 0;
  i3 = ___udivdi3(i2 | 0, i3 | 0, 1e3, 0) | 0;
  HEAPF32[i9 + ((i1 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i3 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 }
 f12 = Math_fround(Math_fround(+(i5 >>> 0) + 4294967296.0 * +(i6 >>> 0)) / Math_fround(1.0e3));
 HEAPF32[(HEAP32[HEAP32[HEAP32[i8 >> 2] >> 2] >> 2] | 0) + 8 >> 2] = f12;
 if (i7) __ZN22UnityProfilerPerThread20CreateOverheadSampleEv(i4);
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) return;
 __ZN13UnityProfiler16EndProfilingModeE12ProfilerMode(i1, 2);
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, i7, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  i8 = i1;
  i9 = HEAP32[i8 + 4 >> 2] | 0;
  i10 = i4 + 4 | 0;
  HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i10 + 4 >> 2] = i9;
 }
 i8 = HEAP32[gb + 1162364 >> 2] | 0;
 i9 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 i10 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 i1 = i4 + 12 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i7 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i7 * 40 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i1;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 40 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i2 >> 2] = i7;
  HEAP32[i4 >> 2] = i5;
  i1 = i5;
  break;
 } else i1 = i5; while (0);
 if (i6 >>> 0 >= i7 >>> 0) return;
 i3 = i1 + (i6 * 40 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 * 40 | 0) >> 2] = i8;
  HEAP32[i3 + (i1 * 40 | 0) + 4 >> 2] = i9;
  HEAP32[i3 + (i1 * 40 | 0) + 8 >> 2] = i10;
  HEAP32[i3 + (i1 * 40 | 0) + 12 >> 2] = i8;
  HEAP32[i3 + (i1 * 40 | 0) + 16 >> 2] = i9;
  HEAP32[i3 + (i1 * 40 | 0) + 20 >> 2] = i10;
  HEAP32[i3 + (i1 * 40 | 0) + 24 >> 2] = i8;
  HEAP32[i3 + (i1 * 40 | 0) + 28 >> 2] = i9;
  HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] = i10;
  HEAP32[i3 + (i1 * 40 | 0) + 36 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z51ParticleSystem_CUSTOM_GetCustomParticleDataInternalP12Il2CppObjectS0_i(i6, i4, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 if (!i6) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0)) {
  i5 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622636 | 0, i8);
 if (i7 >>> 0 > 1) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 4 >> 2] = 1;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622655 | 0, i1);
 }
 i5 = i4 + 8 | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i5 >> 2] | 0) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 i1 = __ZNK14ParticleSystem16GetParticleCountEv(i1) | 0;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 if (i2 >>> 0 < i1 >>> 0) {
  i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 460 >> 2] | 0;
  HEAP32[i5 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i2, 16, HEAP32[i3 >> 2] | 0) | 0;
 }
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6); else {
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i5 >> 2] | 0, 0, 16) | 0;
  __ZNK14ParticleSystem21GetCustomParticleDataEPN4math14float4_storageEii(i1, i6, i7, HEAP32[i3 >> 2] | 0);
  STACKTOP = i8;
  return HEAP32[i3 >> 2] | 0;
 }
 return 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5tellgEv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6;
 i7 = i1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 __THREW__ = 0;
 invoke_viii(fb + 1038 | 0, i2 | 0, i4 | 0, 1);
 i7 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i7 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i4;
  i1 = i4;
  i5 = 8;
 } else do if (HEAP8[i2 >> 0] | 0) {
  i7 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
  __THREW__ = 0;
  invoke_viiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i7 | 0, 0, 0, 1, 8);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i4;
   i1 = i4;
   i5 = 8;
   break L1;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   break;
  }
 } while (0); while (0);
 do if ((i5 | 0) == 8) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5tellgEv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6;
 i7 = i1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 __THREW__ = 0;
 invoke_viii(fb + 1037 | 0, i2 | 0, i4 | 0, 1);
 i7 = __THREW__;
 __THREW__ = 0;
 L1 : do if (i7 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  i3 = i4;
  i1 = i4;
  i5 = 8;
 } else do if (HEAP8[i2 >> 0] | 0) {
  i7 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
  __THREW__ = 0;
  invoke_viiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i7 | 0, 0, 0, 1, 8);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   i3 = i4;
   i1 = i4;
   i5 = 8;
   break L1;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   break;
  }
 } while (0); while (0);
 do if ((i5 | 0) == 8) {
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_vi(fb + 3998 | 0, i3 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   ___cxa_end_catch();
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else ___resumeException(i1 | 0);
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6StringEPKcjb(i2, i12, i13, i10) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = i2 + 28 | 0;
 i11 = i2 + 40 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i9 = i2 + 44 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i3 = i6;
 i8 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
  i4 = i2 + 36 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i7 >> 2] | 0)) {
    i3 = __Znwj(1) | 0;
    HEAP32[i7 >> 2] = i3;
    HEAP32[i2 + 32 >> 2] = i3;
   }
   i1 = HEAP32[i2 + 48 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i6 = i8 - i6 | 0;
  i8 = i6 + 24 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i7;
  i1 = i7 + i6 | 0;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i9 >> 2] = i7 + i8;
 }
 HEAP32[i11 >> 2] = i1 + 24;
 if (!i10) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 1048581;
  HEAP32[i1 >> 2] = i12;
  HEAP32[i1 + 4 >> 2] = i13;
  return 1;
 }
 i2 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 if (i13 >>> 0 < 12) {
  HEAP32[i2 >> 2] = 7340037;
  HEAP8[i1 + 11 >> 0] = 11 - i13;
 } else {
  HEAP32[i2 >> 2] = 3145733;
  HEAP32[i1 + 4 >> 2] = i13;
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i1 >> 2] = i11;
  i1 = i11;
 }
 _memcpy(i1 | 0, i12 | 0, i13 | 0) | 0;
 HEAP8[i1 + i13 >> 0] = 0;
 return 1;
}

function __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i13, f14, i1, i2) {
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f15 = f0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f7 * f8);
 f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f11 * f12));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f9 * f10));
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f6 * f3));
 i1 = f5 < Math_fround(0.0);
 f4 = Math_fround(-f5);
 f5 = i1 ? f4 : f5;
 f4 = Math_fround(Math_fround(1.0) - Math_fround(f5 * f5));
 if (!(f4 >= Math_fround(1.00000002e-16))) {
  HEAPF32[i13 >> 2] = f7;
  HEAPF32[i13 + 4 >> 2] = f11;
  HEAPF32[i13 + 8 >> 2] = f9;
  HEAPF32[i13 + 12 >> 2] = f6;
  return;
 } else {
  f15 = Math_fround(Math_sqrt(Math_fround(f4)));
  f5 = Math_fround(+Math_atan2(+f15, +f5));
  f15 = Math_fround(Math_fround(1.0) / f15);
  f4 = Math_fround(f15 * Math_fround(+Math_sin(+Math_fround(Math_fround(Math_fround(1.0) - f14) * f5))));
  f5 = Math_fround((i1 ? Math_fround(-1.0) : Math_fround(1.0)) * Math_fround(f15 * Math_fround(+Math_sin(+Math_fround(f5 * f14)))));
  f11 = Math_fround(Math_fround(f11 * f4) + Math_fround(f12 * f5));
  f12 = Math_fround(Math_fround(f9 * f4) + Math_fround(f10 * f5));
  f14 = Math_fround(Math_fround(f6 * f4) + Math_fround(f3 * f5));
  HEAPF32[i13 >> 2] = Math_fround(Math_fround(f7 * f4) + Math_fround(f8 * f5));
  HEAPF32[i13 + 4 >> 2] = f11;
  HEAPF32[i13 + 8 >> 2] = f12;
  HEAPF32[i13 + 12 >> 2] = f14;
  return;
 }
}

function __ZN5Umbra8QueryExt20queryClusterForPointERKNS_7Vector3ERi(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i8 >> 2] = i5;
 i2 = HEAP32[i5 + 76 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = i2;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i10 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i10 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i1;
 HEAP32[i8 + 12 >> 2] = i1 + i4;
 i2 = i8 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i8 + 20 >> 2] = i4;
 i10 = i8 + 24 | 0;
 i3 = i8 + 28 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i8 + 40 >> 2] = -1;
 i10 = HEAP32[i5 + 84 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i10;
 HEAP32[i8 + 48 >> 2] = i10;
 HEAP32[i8 + 52 >> 2] = 0;
 HEAP32[i8 + 56 >> 2] = 0;
 if ((i4 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i8 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP32[i5 >> 2] | 0)) {
  i10 = 6;
  __ZN5Umbra12QueryContextD2Ev(i8);
  STACKTOP = i9;
  return i10 | 0;
 }
 i1 = __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i8, i6) | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != -1 & (HEAP32[i2 + 96 >> 2] | 0) != 0) i1 = (HEAP32[i2 + 108 >> 2] | 0) + i1 | 0;
 HEAP32[i7 >> 2] = i1;
 i10 = HEAP32[i3 >> 2] | 0;
 i10 = (i1 | 0) == -1 & (i10 | 0) == 0 ? 5 : i10;
 __ZN5Umbra12QueryContextD2Ev(i8);
 STACKTOP = i9;
 return i10 | 0;
}

function __Z60ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentColorP12Il2CppObjectR22ParticleSystemParticleR16ColorRGBA32Icall(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = HEAP32[i3 + 96 >> 2];
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 do if (HEAP8[(HEAP32[i1 + 860 >> 2] | 0) + 4 >> 0] | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
   __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(HEAP32[i1 + 860 >> 2] | 0, i3, i5);
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!(HEAP8[(HEAP32[i1 + 900 >> 2] | 0) + 4 >> 0] | 0)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP8[i4 >> 0] = i7;
  HEAP8[i4 + 1 >> 0] = i7 >> 8;
  HEAP8[i4 + 2 >> 0] = i7 >> 16;
  HEAP8[i4 + 3 >> 0] = i7 >> 24;
  STACKTOP = i6;
  return;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(HEAP32[i1 + 900 >> 2] | 0, i3, i5);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP8[i4 >> 0] = i7;
 HEAP8[i4 + 1 >> 0] = i7 >> 8;
 HEAP8[i4 + 2 >> 0] = i7 >> 16;
 HEAP8[i4 + 3 >> 0] = i7 >> 24;
 STACKTOP = i6;
 return;
}

function __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i5 = i7 + 48 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS0_4PairINS_14PxConcreteType4EnumEjEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = i9 << 3;
  if (!i1) i4 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i4 ? gb + 672120 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 3) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 HEAP32[i4 + (i6 << 3) >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 << 3) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 3) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 3) | 0;
  return i10 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 << 3) | 0;
 return i10 | 0;
}

function __Z49Sprite_Get_Custom_PropAssociatedAlphaSplitTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = (__ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0) + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK14RenderSettings23GetFFAmbientDeviceColorEv(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f7 = f0;
 f3 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 do if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  do if (!(f3 <= Math_fround(.0404499993))) {
   if (f3 < Math_fround(1.0)) {
    f3 = Math_fround(+Math_pow(+Math_fround(Math_fround(f3 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f3 == Math_fround(1.0)) f3 = Math_fround(1.0); else f3 = Math_fround(+Math_pow(+f3, 2.20000005));
  } else f3 = Math_fround(f3 / Math_fround(12.9200001)); while (0);
  do if (!(f4 <= Math_fround(.0404499993))) {
   if (f4 < Math_fround(1.0)) {
    f4 = Math_fround(+Math_pow(+Math_fround(Math_fround(f4 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
    break;
   }
   if (f4 == Math_fround(1.0)) f4 = Math_fround(1.0); else f4 = Math_fround(+Math_pow(+f4, 2.20000005));
  } else f4 = Math_fround(f4 / Math_fround(12.9200001)); while (0);
  if (f1 <= Math_fround(.0404499993)) {
   f1 = Math_fround(f1 / Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } while (0);
 f7 = Math_fround(f4 * Math_fround(.5));
 f4 = Math_fround(f1 * Math_fround(.5));
 f5 = Math_fround(f5 * Math_fround(.5));
 HEAPF32[i6 >> 2] = Math_fround(f3 * Math_fround(.5));
 HEAPF32[i6 + 4 >> 2] = f7;
 HEAPF32[i6 + 8 >> 2] = f4;
 HEAPF32[i6 + 12 >> 2] = f5;
 return;
}

function __ZN5physx2Gu30checkOverlapSphere_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(f14 * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f9 = Math_fround(f8 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f14 * f11) + Math_fround(Math_fround(f8 * f9) + Math_fround(-1.0)));
 f14 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(f14 * f9);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f11 * f5));
 f5 = Math_fround(Math_fround(f11 * f14) - Math_fround(f9 * f5));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f9 * f8);
 f7 = Math_fround(f9 * f7);
 f5 = Math_fround(f9 * f5);
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f14 = Math_fround(f9 + f8);
 f11 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f13 = Math_fround(f11 + f7);
 f10 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f12 = Math_fround(f5 + f10);
 HEAPF32[i6 >> 2] = f14;
 HEAPF32[i6 + 4 >> 2] = f13;
 HEAPF32[i6 + 8 >> 2] = f12;
 f7 = Math_fround(f11 - f7);
 f5 = Math_fround(f10 - f5);
 HEAPF32[i6 + 12 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i6 + 16 >> 2] = f7;
 HEAPF32[i6 + 20 >> 2] = f5;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i6 + 24 >> 2] = i2;
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f5 + (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i3 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i6, i6 + 12 | 0, i3, 0)) <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx14PxRigidBodyExt18addLocalForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i1, i2, i4, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, i19 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 28 | 0;
 i19 = i6;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i19 | 0, i1 | 0);
 f16 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(2.0));
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(2.0));
 f13 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(2.0));
 f14 = Math_fround(HEAPF32[i19 + 12 >> 2]);
 f15 = Math_fround(Math_fround(f14 * f14) + Math_fround(-.5));
 f18 = Math_fround(HEAPF32[i19 >> 2]);
 f17 = Math_fround(f16 * f18);
 f12 = Math_fround(HEAPF32[i19 + 4 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f11 * f12));
 f10 = Math_fround(HEAPF32[i19 + 8 >> 2]);
 f17 = Math_fround(f17 + Math_fround(f13 * f10));
 f9 = Math_fround(Math_fround(f12 * f17) + Math_fround(Math_fround(f11 * f15) + Math_fround(f14 * Math_fround(Math_fround(f16 * f10) - Math_fround(f13 * f18)))));
 f8 = Math_fround(Math_fround(Math_fround(f13 * f15) + Math_fround(f14 * Math_fround(Math_fround(f11 * f18) - Math_fround(f16 * f12)))) + Math_fround(f10 * f17));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f18 * f17) + Math_fround(Math_fround(f16 * f15) + Math_fround(f14 * Math_fround(Math_fround(f13 * f12) - Math_fround(f11 * f10)))));
 HEAPF32[i7 + 4 >> 2] = f9;
 HEAPF32[i7 + 8 >> 2] = f8;
 __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb(i1, i7, i4, i3, i5);
 STACKTOP = i6;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i5 = i7 + 152 | 0;
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i5, i1, i4 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i4, HEAP32[i5 >> 2] | 0, i1 * 52 | 0);
 i1 = i7 + 172 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 176 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i7);
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i7);
  STACKTOP = i9;
  return;
 }
}

function __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i12 = i11 + 16 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i13 = i11 + 24 | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i12 >> 2] = i2;
  i7 = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i10, 4);
  i2 = HEAP32[i12 >> 2] | 0;
  i7 = HEAP32[i13 >> 2] | 0;
 }
 i4 = i10 + 8 | 0;
 i8 = i10 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 - i1 | 0;
 HEAP32[i9 >> 2] = i5;
 i6 = i2 + 4 | 0;
 if (i6 >>> 0 < i7 >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i12 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = HEAP32[i12 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  STACKTOP = i14;
  return;
 }
}

function __ZN11BoxCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i2 = i7 + 72 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 76 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 80 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 64 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 68 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = i2 - i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = i2 - i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i12, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZNK15ReflectionProbe24CalculateHDRDecodeValuesEv(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i3 = i9;
 i5 = __ZNK15ReflectionProbe10GetTextureEv(i7) | 0;
 do if (i5 | 0) {
  HEAP32[i3 >> 2] = i5;
  i4 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i4) i6 = 7; else {
   if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) {
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
    i1 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i4, i3);
    i1 = HEAP32[i1 >> 2] | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i10 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i3 + (HEAP32[i4 + 32 >> 2] << 3) | 0 : i3 + (i1 << 3) | 0;
    i3 = HEAP32[i10 + 28 >> 2] | 0;
    i4 = HEAP32[i10 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i6 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 9;
   }
  }
  if ((i6 | 0) == 7) i6 = 9;
  if ((i6 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
   if (!i1) break;
  }
  f2 = Math_fround(HEAPF32[i7 + 132 >> 2]);
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
  __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i8, i3, i1, __Z19GetActiveColorSpacev() | 0, f2);
  STACKTOP = i9;
  return;
 } while (0);
 __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i8, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE(i2, i4, i6, i9, i12, i10, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13;
 i1 = i13 + 7 | 0;
 i3 = i13 + 6 | 0;
 i5 = i13 + 5 | 0;
 i7 = i13 + 4 | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i3 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i7 | 0, 1) | 0;
 if (!((HEAP8[i1 >> 0] | 0) == 78 & (HEAP8[i3 >> 0] | 0) == 88 & (HEAP8[i5 >> 0] | 0) == 83)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP8[i10 >> 0] = HEAP8[i7 >> 0] & 1 ^ 1;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i3 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i7 | 0, 1) | 0;
 if (!(((HEAP8[i1 >> 0] | 0) == i2 << 24 >> 24 ? (HEAP8[i3 >> 0] | 0) == i4 << 24 >> 24 : 0) & (HEAP8[i5 >> 0] | 0) == i6 << 24 >> 24 & (HEAP8[i7 >> 0] | 0) == i9 << 24 >> 24)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i10 = (HEAP8[i10 >> 0] | 0) == 0;
 mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i8 | 0, 4) | 0;
 if (!i10) {
  i11 = HEAP32[i8 >> 2] | 0;
  HEAP8[i8 >> 0] = i11 >>> 24;
  HEAP8[i8 + 3 >> 0] = i11;
  HEAP8[i8 + 1 >> 0] = i11 >>> 16;
  HEAP8[i8 + 2 >> 0] = (i11 & 65535) >>> 8;
 }
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math8ColliderEEEclERS3_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i8 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
 i6 = HEAP8[i5 + 26 >> 0] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP8[i1 + 21 >> 0] = i8 & 1;
 HEAP8[i1 + 22 >> 0] = i6;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN4math8Collider8TransferI8BlobSizeEEvRT_(i7, i1);
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = Math_imul(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, (0 - i6 & 3) + i6 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i5, i6, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 * 72 | 0) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIN4math8ColliderEEEvRT_PKc17TransferMetaFlags(i5, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 72 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 48 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - (HEAP32[i5 + 32 >> 2] | 0) | 0;
 if ((1 - i7 - (HEAP32[i5 + 44 >> 2] | 0) + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i4;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i4;
 return;
}

function __ZN15ParticleEmitter4EmitEjf(i7, i3, f8) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 36 | 0;
 i10 = i11;
 if (!i3) {
  STACKTOP = i11;
  return;
 }
 i2 = i7 + 207 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i1 = i7 + 32 | 0;
  if (!(HEAP8[i7 + 192 >> 0] | 0)) {
   HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  } else {
   __ZNK9Transform11GetPositionEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  }
  i6 = i7 + 44 | 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP8[i2 >> 0] = 0;
 }
 i4 = i7 + 56 | 0;
 i5 = i7 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 48 | 0;
 i3 = i6 + i3 | 0;
 i3 = i3 >>> 0 > 16250 ? 16250 : i3;
 if ((i3 | 0) == (i6 | 0)) {
  STACKTOP = i11;
  return;
 }
 if (i3 >>> 0 > i6 >>> 0) __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj(i4, i3 - i6 | 0); else if (i3 >>> 0 < i6 >>> 0) {
  i1 = i1 + (i3 * 48 | 0) | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~(((i2 + -48 - i1 | 0) >>> 0) / 48 | 0) * 48 | 0);
 }
 __ZN15ParticleEmitter11CalcOffsetsEP8Vector3fP10Matrix3x3ff(i7, i9, i10, f8);
 mftCall_viiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0, i4 | 0, i9 | 0, i10 | 0, i6 | 0);
 STACKTOP = i11;
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i8, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i8, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i10;
 return;
}

function __Z14DecompressDXT3iiiPKjPj(i6, i7, i12, i13, i14) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 HEAP8[i15 + 3 >> 0] = 0;
 HEAP8[i15 + 2 >> 0] = -1;
 HEAP8[i15 + 1 >> 0] = -1;
 HEAP8[i15 >> 0] = -1;
 i16 = HEAP32[i15 >> 2] | 0;
 if ((i7 | 0) <= 0) {
  STACKTOP = i17;
  return;
 }
 i8 = i6 << 2;
 i9 = i12 << 2;
 i10 = i12 + -4 | 0;
 if ((i6 | 0) > 0) i5 = 0; else {
  STACKTOP = i17;
  return;
 }
 do {
  i11 = Math_imul(i9, i5) | 0;
  i3 = 0;
  i4 = i13 + ((Math_imul(i8, i5) | 0) << 2) | 0;
  while (1) {
   i1 = i4 + 8 | 0;
   __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i1, i15);
   i2 = i14 + (i3 << 2 << 2) + (i11 << 2) | 0;
   __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i2, i1, i12, i15);
   i1 = 0;
   while (1) {
    i19 = HEAP16[i4 + (i1 << 1) >> 1] | 0;
    i18 = i19 & 65535;
    HEAP32[i2 >> 2] = (i18 & 15 | i18 << 4) << 24 | HEAP32[i2 >> 2] & i16;
    i18 = i2 + 4 | 0;
    i20 = (i19 & 65535) >>> 4 & 65535;
    HEAP32[i18 >> 2] = (i20 & 15 | i20 << 4) << 24 | HEAP32[i18 >> 2] & i16;
    i18 = i2 + 8 | 0;
    i20 = (i19 & 65535) >>> 8 & 65535;
    HEAP32[i18 >> 2] = HEAP32[i18 >> 2] & i16 | (i20 & 15 | i20 << 4) << 24;
    i18 = i2 + 12 | 0;
    i19 = (i19 & 65535) >>> 12 & 65535;
    HEAP32[i18 >> 2] = HEAP32[i18 >> 2] & i16 | (i19 << 4 | i19) << 24;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == 4) break; else i2 = i2 + 16 + (i10 << 2) | 0;
   }
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) break; else i4 = i4 + 16 | 0;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 STACKTOP = i17;
 return;
}

function __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i6, i4);
 i7 = i4 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i7 >> 2] = i3;
  i1 = i2;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i4, i6 + 40 | 0, i1 << 2);
 i1 = i6 + 120 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 124 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 128 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 132 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Flare8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 44 | 0, i6);
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i5 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 32 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 36 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN19AssetBundleManifest8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i8, i7 + 48 | 0, 0);
 i9 = i7 + 64 | 0;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i4 = i7 + 68 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i2 = i5 - i3 >> 2;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i9, i1 - i2 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i2 >>> 0) {
  i2 = i3 + (i1 << 2) | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2);
 }
 if (!i1) {
  i9 = i7 + 32 | 0;
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i8, i9, 0);
  STACKTOP = i10;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i9 >> 2] | 0, i1 << 2);
 i9 = i7 + 32 | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i8, i9, 0);
 STACKTOP = i10;
 return;
}

function __ZN12SoundManager19CreateSoundInternalEPKcjP22FMOD_CREATESOUNDEXINFOR11SoundHandlejP10SampleClip(i5, i1, i2, i3, i7, i8, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 40 | 0;
 i10 = i12 + 36 | 0;
 i11 = i12 + 32 | 0;
 i6 = i12;
 HEAP32[i10 >> 2] = 0;
 i1 = __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i10, i1, i2, i4, 0, 0, i3) | 0;
 if (i1 | 0) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
  HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
  __ZN11SoundHandleaSERKS_(i7, i9);
  __ZN11SoundHandleD2Ev(i9);
  STACKTOP = i12;
  return i1 | 0;
 }
 i10 = HEAP32[i10 >> 2] | 0;
 i4 = i10 + 36 | 0;
 HEAP32[i10 + 40 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i11 >> 2] = __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i5, i10, i6, i8, -1, 3) | 0;
 __ZN11SoundHandleaSERKS_(i7, i11);
 __ZN11SoundHandleD2Ev(i11);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i11 = HEAP32[i6 >> 2] | 0;
  i10 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i9 >> 2] = 66;
  HEAP32[i9 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 }
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 899432 | 0, i2, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i2, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i2 + 8 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 i6 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, i6, i5 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 426246 | 0, i6, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN18GfxFramebufferGLES19RegisterExternalFBOERK20GfxRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEE(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i8 + 68 | 0;
 i1 = i6 + 36 | 0;
 i2 = i8;
 i3 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) == 1) if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] & 64)) {
  HEAP32[i8 >> 2] = 1;
  i2 = i8;
  i4 = 6;
  break;
 } else {
  HEAP32[i8 >> 2] = 0;
  break;
 } else {
  HEAP32[i8 >> 2] = i1;
  if (i1 | 0) {
   i2 = i8;
   i4 = 6;
  }
 } while (0);
 if ((i4 | 0) == 6) {
  i1 = 0;
  do {
   i4 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
   HEAP32[i8 + 4 + (i1 << 2) >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 + 36 + (i1 << 2) >> 2] = HEAP32[i4 + 36 >> 2];
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 do if (!i1) HEAP8[i8 + 92 >> 0] = 0; else {
  i2 = i8 + 92 | 0;
  if (!(HEAP32[i1 + 20 >> 2] & 64)) {
   HEAP8[i2 >> 0] = 1;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 + 72 >> 2] = HEAP32[i1 + 36 >> 2];
   HEAP32[i8 + 76 >> 2] = HEAP32[i1 + 44 >> 2];
   break;
  } else {
   HEAP8[i2 >> 0] = 0;
   break;
  }
 } while (0);
 HEAP32[i8 + 80 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i8 + 84 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i8 + 88 >> 2] = HEAP32[i6 + 44 >> 2];
 i9 = __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_(i5, i8) | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 STACKTOP = i10;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 if (i1 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i9);
 i11 = i9 + 11 | 0;
 i7 = HEAP8[i11 >> 0] | 0;
 i3 = i7 << 24 >> 24 < 0;
 if (i3) {
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i10 = i7 & 255;
  i2 = 10;
 }
 i8 = i10 >>> 0 > i1 >>> 0 ? i10 : i1;
 i1 = i8 >>> 0 < 11;
 i8 = i1 ? 10 : (i8 + 16 & -16) + -1 | 0;
 L8 : do if ((i8 | 0) != (i2 | 0)) {
  do if (i1) {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i3) {
    i2 = i1;
    i3 = 0;
    i1 = i9;
    i6 = 16;
   } else {
    i2 = i1;
    i3 = 0;
    i4 = 1;
    i1 = i9;
    i6 = 17;
   }
  } else {
   i1 = i8 + 1 | 0;
   if (i8 >>> 0 > i2 >>> 0) i1 = __Znwj(i1) | 0; else {
    __THREW__ = 0;
    i1 = invoke_ii(fb + 1570 | 0, i1 | 0) | 0;
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i11 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___cxa_begin_catch(i11 | 0) | 0;
     ___cxa_end_catch();
     break L8;
    }
   }
   if (i3) {
    i2 = HEAP32[i9 >> 2] | 0;
    i3 = 1;
    i6 = 16;
    break;
   } else {
    i2 = i9;
    i3 = 1;
    i4 = 0;
    i6 = 17;
    break;
   }
  } while (0);
  if ((i6 | 0) == 16) {
   i5 = i3;
   i4 = 1;
   i3 = HEAP32[i9 + 4 >> 2] | 0;
  } else if ((i6 | 0) == 17) {
   i5 = i3;
   i3 = i7 & 255;
  }
  i3 = i3 + 1 | 0;
  if (i3 | 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  if (i4) __ZdlPv(i2);
  if (i5) {
   HEAP32[i9 + 8 >> 2] = i8 + 1 | -2147483648;
   HEAP32[i9 + 4 >> 2] = i10;
   HEAP32[i9 >> 2] = i1;
   break;
  } else {
   HEAP8[i11 >> 0] = i10;
   break;
  }
 } while (0);
 return;
}

function __ZN8Renderer17UpdateSceneHandleEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 28 | 0;
 i4 = i7 + 24 | 0;
 i1 = i7;
 i6 = i2 + 284 | 0;
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i8 = __Z16GetRendererScenev() | 0;
 __ZN12BaseRenderer12GetWorldAABBER4AABB(i2 + 32 | 0, i1);
 i5 = HEAP32[i6 >> 2] | 0;
 i9 = (HEAP32[i8 + 80 >> 2] | 0) + (i5 * 24 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i1 = i8 + 60 | 0;
 i5 = (HEAP32[i1 >> 2] | 0) + (i5 * 24 | 0) + 20 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -3;
 i5 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2 | (HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 60 >> 2] | 0) >>> 4 & 1;
 i5 = HEAP32[i6 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i5 * 24 | 0) + 4 >> 2] = i8;
 if ((HEAP32[i6 >> 2] | 0) != -1) {
  i5 = __Z16GetRendererScenev() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i2 + 312 >> 2] | 0;
  if (!i1) {
   i2 = 0;
   i1 = 0;
  } else {
   __ZN8LODGroup23GetLODGroupIndexAndMaskEP8RendererPjS2_(i1, i2, i3, i4);
   i2 = HEAP32[i3 >> 2] & 65535;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i9 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i5 + 60 >> 2] | 0;
  HEAP16[i8 + (i9 * 24 | 0) + 12 >> 1] = 0;
  HEAP16[i8 + (i9 * 24 | 0) + 14 >> 1] = i2;
  HEAP32[i8 + (i9 * 24 | 0) + 16 >> 2] = i1;
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f7 = f0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   i1 = HEAP32[i6 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 4;
   break;
  }
 default:
  {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = 4;
  }
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore22addSpatialAccelerationEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i6 + 16 | 0, HEAP32[i1 + 1248 >> 2] | 0, i4, i5);
  return;
 }
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i6 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i3 = i2 + 232 | 0;
 if (!i4) i1 = 0; else {
  i1 = i2 + 220 | 0;
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  i1 = i2 + 224 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  i1 = i2 + 228 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  i1 = 16384;
 }
 if (i5) {
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
  f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  i4 = i2 + 236 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i4 >> 2]));
  f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  i5 = i2 + 240 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i5 >> 2]));
  i1 = i1 | 32768;
 }
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i6 >> 2] | 0, i6);
 i6 = i6 + 236 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i1;
 return;
}

function _format_message(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i8 = i10;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i3 | 0) > 0) if ((i3 | 0) > (HEAP32[i5 + 116 >> 2] | 0)) i4 = 4; else {
  i1 = (HEAP32[i5 + 112 >> 2] | 0) + (i3 << 2) | 0;
  i4 = 8;
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i1 = HEAP32[i5 + 120 >> 2] | 0;
  if (!i1) i4 = 9; else {
   i2 = HEAP32[i5 + 124 >> 2] | 0;
   if ((i3 | 0) < (i2 | 0)) i4 = 9; else if ((i3 | 0) > (HEAP32[i5 + 128 >> 2] | 0)) i4 = 9; else {
    i1 = i1 + (i3 - i2 << 2) | 0;
    i4 = 8;
   }
  }
 }
 if ((i4 | 0) == 8) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i4 = 9;
 }
 if ((i4 | 0) == 9) {
  HEAP32[i5 + 24 >> 2] = i3;
  i1 = HEAP32[HEAP32[i5 + 112 >> 2] >> 2] | 0;
 }
 i2 = i1;
 L14 : while (1) {
  i3 = i2 + 1 | 0;
  switch (HEAP8[i2 >> 0] | 0) {
  case 0:
   break L14;
  case 37:
   {
    i4 = 12;
    break L14;
   }
  default:
   i2 = i3;
  }
 }
 if ((i4 | 0) == 12) if ((HEAP8[i3 >> 0] | 0) == 115) {
  HEAP32[i8 >> 2] = i5 + 24;
  _snprintf(i6, i7, i1, i8) | 0;
  STACKTOP = i10;
  return;
 }
 i13 = HEAP32[i5 + 28 >> 2] | 0;
 i12 = HEAP32[i5 + 32 >> 2] | 0;
 i11 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = HEAP32[i5 + 40 >> 2] | 0;
 i3 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 i8 = HEAP32[i5 + 52 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i9 + 4 >> 2] = i13;
 HEAP32[i9 + 8 >> 2] = i12;
 HEAP32[i9 + 12 >> 2] = i11;
 HEAP32[i9 + 16 >> 2] = i2;
 HEAP32[i9 + 20 >> 2] = i3;
 HEAP32[i9 + 24 >> 2] = i4;
 HEAP32[i9 + 28 >> 2] = i8;
 _snprintf(i6, i7, i1, i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN7mecanim12statemachine21SelectorStateConstant8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1 + 4;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902998 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 0);
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i5, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903024 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 8 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903037 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i3, i5, i1, i8, i2) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP16[i9 >> 1] = 20111;
 HEAP16[i9 + 2 >> 1] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 i7 = i3 + 140 | 0;
 i6 = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = 0;
 if (!i5) {
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  i3 = i3 + 92 | 0;
  if ((i2 | 0) == (i3 | 0)) {
   HEAP8[i7 >> 0] = i6;
   STACKTOP = i10;
   return;
  }
  while (1) {
   __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv(HEAP32[i2 + 20 >> 2] | 0, i9, i8);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
  HEAP8[i7 >> 0] = i6;
  STACKTOP = i10;
  return;
 }
 i4 = i3 + 92 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  HEAP8[i7 >> 0] = i6;
  STACKTOP = i10;
  return;
 } else i1 = i4;
 L19 : while (1) {
  i3 = i2;
  while (1) {
   if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) break L19; else i3 = i2;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i1 = i3;
   break;
  } else i1 = i3;
 }
 if ((i1 | 0) == (i4 | 0)) {
  HEAP8[i7 >> 0] = i6;
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) > (i5 | 0)) {
  HEAP8[i7 >> 0] = i6;
  STACKTOP = i10;
  return;
 }
 __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv(HEAP32[i1 + 20 >> 2] | 0, i9, i8);
 HEAP8[i7 >> 0] = i6;
 STACKTOP = i10;
 return;
}

function __Z19TransferField_ArrayI9JSONWrite27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (i4 | 0) {
  __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i8, i4);
  i1 = 0;
  do {
   i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
   if (i2 | 0) {
    i11 = HEAP32[i8 >> 2] | 0;
    HEAP32[i11 + (i1 * 12 | 0) >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __ZN9JSONWrite8TransferINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i5, i8, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i11 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i10;
 return;
}

function ___dn_expand(i11, i12, i2, i13, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0;
 L1 : do if ((i2 | 0) == (i12 | 0) | (i1 | 0) < 1) i1 = -1; else {
  i14 = i12;
  i15 = i14 - i11 | 0;
  if ((i15 | 0) > 0) {
   i9 = i13 + ((i1 | 0) > 254 ? 254 : i1) | 0;
   i10 = i2;
   i8 = 0;
   i7 = -1;
   i1 = i13;
   i4 = i2;
   while (1) {
    i2 = HEAP8[i4 >> 0] | 0;
    i3 = i2 & 255;
    if (!(i3 & 192)) {
     if (!(i2 << 24 >> 24)) break;
     if ((i1 | 0) == (i13 | 0)) i1 = i13; else {
      HEAP8[i1 >> 0] = 46;
      i1 = i1 + 1 | 0;
      i2 = HEAP8[i4 >> 0] | 0;
     }
     i3 = i4 + 1 | 0;
     i6 = i2 & 255;
     if ((i6 | 0) >= (i14 - i3 | 0)) {
      i1 = -1;
      break L1;
     }
     if ((i6 | 0) >= (i9 - i1 | 0)) {
      i1 = -1;
      break L1;
     }
     if (!(i2 << 24 >> 24)) i2 = i7; else {
      i5 = i3 + i6 | 0;
      i4 = i6;
      i2 = i3;
      i3 = i1;
      while (1) {
       i4 = i4 + -1 | 0;
       HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
       if (!i4) break; else {
        i2 = i2 + 1 | 0;
        i3 = i3 + 1 | 0;
       }
      }
      i3 = i5;
      i2 = i7;
      i1 = i1 + i6 | 0;
     }
    } else {
     i2 = i4 + 1 | 0;
     if ((i2 | 0) == (i12 | 0)) {
      i1 = -1;
      break L1;
     }
     i2 = HEAPU8[i2 >> 0] | 0 | i3 << 8 & 16128;
     if ((i2 | 0) >= (i15 | 0)) {
      i1 = -1;
      break L1;
     }
     i3 = i11 + i2 | 0;
     i2 = (i7 | 0) < 0 ? i4 + 2 - i10 | 0 : i7;
    }
    i8 = i8 + 2 | 0;
    if ((i8 | 0) >= (i15 | 0)) {
     i1 = -1;
     break L1;
    } else {
     i7 = i2;
     i4 = i3;
    }
   }
   HEAP8[i1 >> 0] = 0;
   i1 = (i7 | 0) < 0 ? i4 + 1 - i10 | 0 : i7;
  } else i1 = -1;
 } while (0);
 return i1 | 0;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty(i1, i9, i7, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 24 | 0;
 i6 = i1 + -124 | 0;
 HEAP16[i2 >> 1] = i9;
 i3 = i6 + 280 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i6 + 212 | 0, i2, i10) | 0;
  if (!(HEAP8[i10 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i9;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i1 | 0, i7 | 0, i8 | 0, 0);
 }
 if (!(HEAP8[i6 + 276 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i3 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i4 = getTempRet0() | 0;
 i5 = HEAP32[i6 + 72 >> 2] | 0;
 if (!i5) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i10;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = i8;
 HEAP32[i10 + 8 >> 2] = i2;
 HEAP8[i10 + 12 >> 0] = 2;
 HEAP8[i10 + 13 >> 0] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i4;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_(i6, i9, i10);
 if (!i1) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIssEEPsEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 1 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -2 | 0;
   i2 = HEAP16[i1 >> 1] | 0;
   i3 = HEAP16[i8 >> 1] | 0;
   if (i2 << 16 >> 16 < i3 << 16 >> 16) {
    HEAP16[i8 >> 1] = i2;
    HEAP16[i1 >> 1] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i8, i8 + 2 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_(i8, i8 + 2 | 0, i8 + 4 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_(i8, i8 + 2 | 0, i8 + 4 | 0, i8 + 6 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 4 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i8, i8 + 2 | 0, i2, i1) | 0;
   i6 = i8 + 6 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP16[i6 >> 1] | 0;
    i4 = HEAP16[i2 >> 1] | 0;
    if (i5 << 16 >> 16 < i4 << 16 >> 16) {
     i3 = i6;
     while (1) {
      HEAP16[i3 >> 1] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -2 | 0;
      i4 = HEAP16[i3 >> 1] | 0;
      if (i5 << 16 >> 16 >= i4 << 16 >> 16) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP16[i2 >> 1] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 2 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 2 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNK5Umbra9Matrix4x43detEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f16 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f18 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f8 = Math_fround(Math_fround(f2 * f18) - Math_fround(f17 * f9));
 f10 = Math_fround(Math_fround(f12 * f18) - Math_fround(f14 * f9));
 f5 = Math_fround(Math_fround(f12 * f17) - Math_fround(f14 * f2));
 f16 = Math_fround(f16 * Math_fround(Math_fround(f11 * f5) + Math_fround(Math_fround(f3 * f8) - Math_fround(f7 * f10))));
 f15 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 f9 = Math_fround(Math_fround(f18 * f13) - Math_fround(f9 * f6));
 f2 = Math_fround(Math_fround(f17 * f13) - Math_fround(f2 * f6));
 f8 = Math_fround(f16 - Math_fround(f15 * Math_fround(Math_fround(f11 * f2) + Math_fround(Math_fround(f8 * f4) - Math_fround(f7 * f9)))));
 f6 = Math_fround(Math_fround(f14 * f13) - Math_fround(f12 * f6));
 f8 = Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(Math_fround(f11 * f6) + Math_fround(Math_fround(f10 * f4) - Math_fround(f3 * f9)))) + f8);
 return Math_fround(f8 - Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(Math_fround(f7 * f6) + Math_fround(Math_fround(f5 * f4) - Math_fround(f3 * f2)))));
}

function __Z14PxToRaycastHitRKN5physx10PxSweepHitER10RaycastHit(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = i2 + 4 | 0;
 HEAP32[i3 + 40 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 i6 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = i3 + 12 | 0;
 i7 = i2 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i1 | 0) | 0) {
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i1 + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
 } else i1 = -1;
 HEAP32[i3 + 24 >> 2] = i1;
 i7 = HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i3 + 28 >> 2] = i7;
 HEAPF32[i3 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 if (!((HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2])) <= Math_fround(0.0))) {
  STACKTOP = i4;
  return;
 };
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff(i1, i8, f6, f7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f9 = f0;
 f5 = Math_fround(HEAPF32[(HEAP32[i1 + 16 >> 2] | 0) + 8 >> 2]);
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 if ((HEAP8[i4 + (i8 << 2) + 2 >> 0] | 0) < 0) {
  f3 = Math_fround(HEAP16[i4 + (i8 << 2) >> 1] | 0);
  i1 = (HEAP32[i1 + 20 >> 2] | 0) + i8 | 0;
  f2 = Math_fround(HEAP16[i4 + (i1 + 1 << 2) >> 1] | 0);
  if (f7 > f6) {
   f9 = Math_fround(HEAP16[i4 + (i8 + 1 << 2) >> 1] | 0);
   f7 = Math_fround(Math_fround(Math_fround(f2 - f9) * f6) + Math_fround(f3 + Math_fround(Math_fround(f9 - f3) * f7)));
   f7 = Math_fround(f5 * f7);
   return Math_fround(f7);
  } else {
   f9 = Math_fround(HEAP16[i4 + (i1 << 2) >> 1] | 0);
   f9 = Math_fround(Math_fround(Math_fround(f2 - f9) * f7) + Math_fround(f3 + Math_fround(Math_fround(f9 - f3) * f6)));
   f9 = Math_fround(f5 * f9);
   return Math_fround(f9);
  }
 } else {
  i1 = (HEAP32[i1 + 20 >> 2] | 0) + i8 | 0;
  f2 = Math_fround(HEAP16[i4 + (i1 << 2) >> 1] | 0);
  f3 = Math_fround(HEAP16[i4 + (i8 + 1 << 2) >> 1] | 0);
  if (Math_fround(f6 + f7) < Math_fround(1.0)) {
   f9 = Math_fround(HEAP16[i4 + (i8 << 2) >> 1] | 0);
   f9 = Math_fround(Math_fround(Math_fround(f2 - f9) * f6) + Math_fround(f9 + Math_fround(Math_fround(f3 - f9) * f7)));
   f9 = Math_fround(f5 * f9);
   return Math_fround(f9);
  } else {
   f9 = Math_fround(HEAP16[i4 + (i1 + 1 << 2) >> 1] | 0);
   f9 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f6) * Math_fround(f3 - f9)) + Math_fround(f9 + Math_fround(Math_fround(Math_fround(1.0) - f7) * Math_fround(f2 - f9))));
   f9 = Math_fround(f5 * f9);
   return Math_fround(f9);
  }
 }
 return f0;
}

function __ZN22UnityProfilerPerThread23InjectUnaccountedSampleEP19ProfilerInformationS1_(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i8 + 8 | 0;
 i9 = i2 + 224 | 0;
 i3 = i9;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d11 = +_emscripten_get_now() * 1.0e6;
 i10 = +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0;
 HEAP32[i9 >> 2] = ~~d11 >>> 0;
 HEAP32[i9 + 4 >> 2] = i10;
 if (!i1) i1 = gb + 461870 | 0; else i1 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i10;
 __Z12FormatStringPKcz(i7, gb + 461885 | 0, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE(i2, (i1 | 0) == 0 ? i7 + 4 | 0 : i1, 11, 1) | 0;
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i2, i1, 0) | 0;
 i10 = (HEAP32[i2 + 36 >> 2] | 0) + ((HEAP32[i2 + 48 >> 2] | 0) + -1 << 4) + 8 | 0;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i3;
 d11 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i2, i1, ~~d11 >>> 0, +Math_abs(d11) >= 1.0 ? (d11 > 0.0 ? ~~+Math_min(+Math_floor(d11 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d11 - +(~~d11 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 24 | 0);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i3, i1) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i10, i1 + 8 | 0, 0);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN13GfxDeviceGLES28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi(i2, i10, i11, i12, i1, i13, i14, i15, i16) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i10) return;
 i9 = i2 + 8468 | 0;
 i8 = i2 + 4620 | 0;
 i7 = 0;
 do {
  i6 = i16 + (i7 << 2) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) >= 0) {
   i5 = HEAP32[i11 + (i7 << 2) >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if (i3 | 0) {
    i2 = i9;
    L8 : while (1) {
     i4 = i3;
     while (1) {
      if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
      i3 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i3) break L8; else i4 = i3;
     }
     i3 = HEAP32[i4 >> 2] | 0;
     if (!i3) {
      i2 = i4;
      break;
     } else i2 = i4;
    }
    if ((i2 | 0) != (i9 | 0)) if (i5 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
     i3 = i2 + 20 | 0;
     i2 = HEAP32[i3 >> 2] | 0;
     if (1 << i7 & i12) {
      if (__Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i2) | 0) {
       __ZN14DataBufferGLES7ReleaseEv(i2);
       i1 = __Z20GetBufferManagerGLESv() | 0;
       i2 = i14 + (i7 << 2) | 0;
       i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i1, HEAP32[i2 >> 2] | 0, 8, 0) | 0;
       HEAP32[i3 >> 2] = i1;
      } else {
       i1 = i2;
       i2 = i14 + (i7 << 2) | 0;
      }
      __ZN14DataBufferGLES6UploadEiiPKv(i1, 0, HEAP32[i2 >> 2] | 0, i13 + (HEAP32[i15 + (i7 << 2) >> 2] | 0) | 0);
      i2 = i1;
      i1 = HEAP32[i6 >> 2] | 0;
     }
     __ZN7ApiGLES17BindUniformBufferEjj(i8, i1, HEAP32[i2 + 4 >> 2] | 0);
    }
   }
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i10 | 0));
 return;
}

function __ZN5physx7profile15ZoneManagerImpl14addProfileZoneERNS_13PxProfileZoneE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i5 = i4 + 44 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 do if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0) if ((mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0) == (i4 | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 } else {
  i3 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i6 | 0);
  break;
 } while (0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i6 | 0, HEAP32[i4 + 40 >> 2] | 0);
 HEAP32[i1 >> 2] = i6;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 20 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + (i3 << 2) >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_13PxProfileZoneENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4 + 8 | 0, i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i4 | 0);
 i3 = i4 + 32 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
 i1 = i4 + 28 | 0;
 i2 = 0;
 do {
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i6 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 536 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 800 | 0, i4);
 i7 = i4 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i2 + 1 | 0;
 i5 = i4 + 24 | 0;
 if (i1 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i2 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i2;
  HEAP32[i7 >> 2] = i1;
  i1 = i2;
 }
 HEAP8[i3 + 1065 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 1064 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = i3 + 1068 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i7 = i5;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (((i1 - i3 | 0) / 12 | 0) >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 * 12 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 * 12 | 0);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = ((i3 - i2 | 0) / 12 | 0) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = (i1 - i2 | 0) / 12 | 0;
 i5 = i6 << 1;
 i5 = i6 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (((i3 - i2 | 0) / 12 | 0) * 12 | 0) | 0;
 _memset(i3 | 0, 0, i8 * 12 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 * 12 | 0);
 HEAP32[i11 >> 2] = i6 + (i5 * 12 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE25__construct_node_with_keyERS6_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = 85;
 HEAP32[i6 + 4 >> 2] = i7;
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(36, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
 i9 = i7;
 i1 = i7 + 16 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i2 >> 2] | 0 : i2;
 i5 = i3 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i7 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i11 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i7 + 27 >> 0] = i5;
  if (i5) i11 = 6;
 } else i11 = 4;
 if ((i11 | 0) == 4) {
  i3 = i5 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i7 + 20 >> 2] = i5;
  i1 = i6;
  i11 = 6;
 }
 if ((i11 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i8;
 HEAP8[i10 + 8 >> 0] = 1;
 i11 = i10 + 9 | 0;
 HEAP8[i11 >> 0] = 1;
 HEAP8[i11 + 1 >> 0] = 0;
 HEAP8[i11 + 2 >> 0] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE15growAndPushBackERKS4_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = i9 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = (i6 & 2147483647 | 0) == 0 ? 1 : i6 << 1;
 if (!i6) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 << 3, gb + 838004 | 0, 543) | 0;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i11 = i2;
   i13 = i11;
   i13 = HEAPU16[i13 >> 1] | HEAPU16[i13 + 2 >> 1] << 16;
   i11 = i11 + 4 | 0;
   i11 = HEAPU16[i11 >> 1] | HEAPU16[i11 + 2 >> 1] << 16;
   i10 = i1;
   i12 = i10;
   HEAP16[i12 >> 1] = i13;
   HEAP16[i12 + 2 >> 1] = i13 >>> 16;
   i10 = i10 + 4 | 0;
   HEAP16[i10 >> 1] = i11;
   HEAP16[i10 + 2 >> 1] = i11 >>> 16;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i12 = i8;
 i10 = i12;
 i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
 i12 = i12 + 4 | 0;
 i12 = HEAPU16[i12 >> 1] | HEAPU16[i12 + 2 >> 1] << 16;
 i13 = i4 + (i1 << 3) | 0;
 i11 = i13;
 HEAP16[i11 >> 1] = i10;
 HEAP16[i11 + 2 >> 1] = i10 >>> 16;
 i13 = i13 + 4 | 0;
 HEAP16[i13 >> 1] = i12;
 HEAP16[i13 + 2 >> 1] = i12 >>> 16;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  i13 = HEAP32[i7 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i7 >> 2] = i12;
  i13 = i4 + (i13 << 3) | 0;
  return i13 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 >> 2] = i6;
 i13 = HEAP32[i7 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i7 >> 2] = i12;
 i13 = i4 + (i13 << 3) | 0;
 return i13 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP16[i6 + 8 >> 1] = 0;
  HEAP8[i6 + 10 >> 0] = 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 << 4 | 0, 4) | 0;
  i2 = i3 + (i2 << 4) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = -1;
    i10 = i1 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP16[i10 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
    HEAP8[i10 + 10 >> 0] = HEAP8[i6 + 10 >> 0] | 0;
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i10 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (!i10) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11AssetBundleD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i6 >> 2] = gb + 27268 + 8;
 i3 = i6 + 172 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i6 + 176 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -4 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZN14ConstantStringD2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZN14ConstantStringD2Ev(i6 + 168 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6 + 152 | 0);
 i1 = HEAP32[i6 + 120 >> 2] | 0;
 if (i1 | 0) {
  i8 = HEAP32[i6 + 144 >> 2] | 0;
  HEAP32[i5 >> 2] = 65;
  HEAP32[i5 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i6 + 80 | 0, HEAP32[i6 + 84 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i6 + 68 | 0, HEAP32[i6 + 72 >> 2] | 0);
 i1 = i6 + 48 | 0;
 if ((HEAP32[i6 + 64 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = gb + 32336 + 8;
  i8 = i6 + 28 | 0;
  __ZN14ConstantStringD2Ev(i8);
  HEAP32[i6 >> 2] = gb + 26392 + 8;
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 52 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 32336 + 8;
 i8 = i6 + 28 | 0;
 __ZN14ConstantStringD2Ev(i8);
 HEAP32[i6 >> 2] = gb + 26392 + 8;
 STACKTOP = i7;
 return;
}

function __Z42TextGenerator_CUSTOM_GetCharactersInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 if (!i7) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1008413 | 0, i8);
 i3 = HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 16 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i1 >> 2] | 0) | 0;
 i6 = i5 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i3, 12, i2) | 0;
  HEAP32[i1 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
 }
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 i2 = 0;
 while (1) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = HEAP32[i1 + 8 >> 2] | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 12) | 0;
  HEAP32[i5 >> 2] = i11;
  HEAP32[i5 + 4 >> 2] = i10;
  HEAP32[i5 + 8 >> 2] = i9;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 12 | 0;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = i7 + 12 | 0;
 HEAP32[i11 >> 2] = i10;
 i11 = i7 + 16 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = i10;
 STACKTOP = i8;
 return;
}

function __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i2, i3, i4) | 0;
 if ((_strcmp(HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) >= 0) return i6 | 0;
 i7 = i4;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i5;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i5 + 4 >> 2] = i7;
 if ((_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) >= 0) {
  i11 = i6 + 1 | 0;
  return i11 | 0;
 }
 i10 = i3;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i4;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i3;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 i11 = i4;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 if ((_strcmp(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
  i11 = i6 + 2 | 0;
  return i11 | 0;
 }
 i10 = i2;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i3;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i2;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 i11 = i3;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 if ((_strcmp(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) >= 0) {
  i11 = i6 + 3 | 0;
  return i11 | 0;
 }
 i10 = i1;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i2;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i1;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 4 >> 2] = i8;
 i11 = i2;
 HEAP32[i11 >> 2] = i9;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = i6 + 4 | 0;
 return i11 | 0;
}

function __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 20 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 20 | 0) * 20 | 0) | 0;
 i7 = i1;
 i5 = i5 + (i4 * 20 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i4 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i3 = i3 + -20 | 0;
   __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i1 + -20 | 0, i3);
   i1 = i2 + -20 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i5;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i12);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataP7TextureRK10Matrix4x4fR17ShaderPassContext(i2, i3, i1, i4, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 48 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 if (!i1) {
  HEAP32[i9 >> 2] = 0;
  __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i2, i3, i9, i4, i7);
  STACKTOP = i10;
  return;
 }
 HEAP32[i9 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i9 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i9 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 i5 = HEAP32[i1 + 72 >> 2] | 0;
 i13 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 f12 = Math_fround(i13 | 0);
 f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0);
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAPF32[i9 + 20 >> 2] = f12;
 HEAPF32[i9 + 24 >> 2] = f11;
 i5 = i9 + 28 | 0;
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i1 + 60 >> 2] | 0; else i1 = 0;
 __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i8, i6, i1);
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext(i2, i3, i9, i4, i7);
 STACKTOP = i10;
 return;
}

function __ZN9Transform47ClearTransformHierarchyAndApplyToSerializedDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i4) return;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 i3 = HEAP32[i4 + 68 >> 2] | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  i10 = i5 + 32 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i10 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
  i6 = i5 + 56 | 0;
  i7 = HEAP32[i10 + (i9 * 40 | 0) + 4 >> 2] | 0;
  i11 = HEAP32[i10 + (i9 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i10 + (i9 * 40 | 0) >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[i6 + 8 >> 2] = i11;
  i6 = i5 + 40 | 0;
  i11 = HEAP32[i10 + (i9 * 40 | 0) + 16 >> 2] | 0;
  i7 = HEAP32[i10 + (i9 * 40 | 0) + 20 >> 2] | 0;
  i8 = HEAP32[i10 + (i9 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i10 + (i9 * 40 | 0) + 12 >> 2];
  HEAP32[i6 + 4 >> 2] = i11;
  HEAP32[i6 + 8 >> 2] = i7;
  HEAP32[i6 + 12 >> 2] = i8;
  i6 = i5 + 68 | 0;
  i8 = HEAP32[i10 + (i9 * 40 | 0) + 32 >> 2] | 0;
  i7 = HEAP32[i10 + (i9 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[i10 + (i9 * 40 | 0) + 28 >> 2];
  HEAP32[i6 + 4 >> 2] = i8;
  HEAP32[i6 + 8 >> 2] = i7;
  HEAP32[i5 + 32 >> 2] = 0;
  i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) != -1);
 i1 = HEAP32[gb + 1158396 >> 2] | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != -1) {
  i9 = i1 + 12 | 0;
  i8 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = i11 + (i8 << 2) | 0;
  HEAP32[(HEAP32[i10 >> 2] | 0) + 32 >> 2] = i3;
  i11 = i11 + (HEAP32[i2 >> 2] << 2) | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i2 >> 2] = -1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63160 | 0);
 return;
}

function __ZN9Rigidbody19SetDetectCollisionsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i1 + 101 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i3 >> 0] | 0 | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i2 & 1;
 HEAP8[i1 + 100 >> 0] = i4;
 HEAP8[i3 >> 0] = i4;
 i4 = i1 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 i2 = gb + 63160 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i5 << 2;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i1 | 3;
  if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 1514) | 0;
   i3 = gb + 64016 | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i6;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1;
   break;
  }
 } while (0);
 i2 = i2 + 3 & -4;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 108 >> 2] | 0, i9 | 0, i2 | 0, i5 | 0, 0) | 0;
 if ((i5 | 0) > 0) {
  i1 = 0;
  do {
   i9 = HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 156 >> 2] | 0, i9 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 8 | 0;
 i8 = i10 + 4 | 0;
 i2 = i10;
 i4 = i9 + 12 | 0;
 i5 = i9 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((HEAP8[i7 + 51 >> 0] & 14) == 4) {
  HEAP32[i7 + 40 >> 2] = i6;
  HEAP32[i1 >> 2] = i7;
  if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] = i7;
   HEAP32[i5 >> 2] = i6 + 1;
   STACKTOP = i10;
   return;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i1) | 0;
   STACKTOP = i10;
   return;
  }
 }
 i3 = HEAP32[i4 >> 2] | 0;
 do if ((i6 | 0) == (i3 | 0)) {
  HEAP32[i7 + 40 >> 2] = i6;
  HEAP32[i2 >> 2] = i7;
  if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] = i7;
   HEAP32[i5 >> 2] = i6 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i2) | 0;
   break;
  }
 } else {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 + 40 >> 2] = i3;
  HEAP32[i2 + (HEAP32[i4 >> 2] << 2) >> 2] = i7;
  HEAP32[i1 + 40 >> 2] = i6;
  if ((HEAP32[i9 + 8 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] = i1;
   HEAP32[i5 >> 2] = i6 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i8) | 0;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 STACKTOP = i10;
 return;
}

function __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 24 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 40 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 24 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  i8 = i6 + 40 | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i10, i3, f1, i8) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 L1 : do if (!(i8 & 2)) {
  i2 = HEAP32[i10 + 8 >> 2] | 0;
  i4 = HEAP32[i10 + 12 >> 2] | 0;
  if ((i2 | 0) < (i4 | 0)) {
   i5 = HEAP32[i10 + 32 >> 2] | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   while (1) {
    if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i6 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i4 | 0)) {
     i9 = 7;
     break L1;
    }
   }
   if ((i2 | 0) < 0) i9 = 7; else {
    i3 = (HEAP32[i10 + 52 >> 2] | 0) + (i2 << 2) | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = i2 & 1048575;
    if (i8 & 1) {
     i2 = i2 | 1073741824;
     HEAP32[i3 >> 2] = i2;
    }
   }
  } else i9 = 7;
 } else i9 = 7; while (0);
 if ((i9 | 0) == 7) {
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i7, i10, i3, 0, 4, 0, i8 << 30 & 1073741824);
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i10 + 52 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) >> 2] | 0;
 }
 do if (i2 & 1073741824) if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  if (f1 <= Math_fround(.0404499993)) {
   f1 = Math_fround(f1 / Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } while (0);
 HEAPF32[(HEAP32[i10 + 72 >> 2] | 0) + i4 >> 2] = f1;
 STACKTOP = i11;
 return;
}

function __ZN15SerializeTraitsIN7mecanim12statemachine16LeafInfoConstantEE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i3 = i8;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + 4;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 903574 | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i7, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 903584 | 0, HEAP32[gb + 37304 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN11TerrainData23SetLightmapIndexOnUsersEi(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i2 = HEAP32[i1 + 352 >> 2] | 0;
 i5 = i1 + 356 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 10; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i3 = HEAP32[i7 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i9 = 10; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 12;
    }
   }
   if ((i9 | 0) == 10) i9 = 12;
   if ((i9 | 0) == 12) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i2 >> 2] | 0) | 0;
    if (!i1) break;
   }
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 35740 | 0) | 0;
   if (i1 | 0) __ZN7Terrain16SetLightmapIndexEi12LightmapType(i1, i6, 0);
  } while (0);
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 STACKTOP = i10;
 return;
}

function __ZN11AudioSource16UpdatePauseStateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = __Z15GetAudioManagerv() | 0;
 i4 = __ZN12AudioManager17ShouldSourcePauseEb(i4, (HEAP8[i5 + 427 >> 0] | 0) != 0) | 0;
 i3 = i4 | (HEAP8[i5 + 532 >> 0] | 0) != 0;
 i1 = i5 + 520 | 0;
 i2 = i1;
 i2 = (HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0;
 if (i4) {
  if (i2) {
   i6 = __ZNK12AudioManager14GetRealDSPTimeEv(__Z15GetAudioManagerv() | 0) | 0;
   i2 = getTempRet0() | 0;
   i4 = i1;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i4 + 4 >> 2] = i2;
  }
 } else if (!i2) {
  i6 = HEAP16[i5 + 498 >> 1] | 0;
  if ((i6 & 65535) > 255 | (i6 & 255) << 24 >> 24 != 0) {
   i2 = __ZNK12AudioManager14GetRealDSPTimeEv(__Z15GetAudioManagerv() | 0) | 0;
   i4 = getTempRet0() | 0;
   i6 = i1;
   i6 = _i64Subtract(i2 | 0, i4 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0) | 0;
   __ZN11AudioSource32CorrectScheduledTimeAfterUnpauseEy(i5, i6, getTempRet0() | 0);
  }
  i6 = i1;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
 }
 i1 = i5 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP8[i1 + 236 >> 0] = i3 & 1;
  __ZN20SoundChannelInstance16UpdatePauseStateEv(i1);
 }
 i2 = HEAP32[i5 + 432 >> 2] | 0;
 i4 = i5 + 428 | 0;
 i1 = i2;
 if ((i1 | 0) == (i4 | 0)) {
  __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i5, 0);
  return;
 }
 i3 = i3 & 1;
 do {
  i6 = HEAP32[(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0) + 16 >> 2] | 0;
  HEAP8[i6 + 236 >> 0] = i3;
  __ZN20SoundChannelInstance16UpdatePauseStateEv(i6);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i5, 0);
 return;
}

function __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE(i10, i8, i4, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 88 | 0;
 i11 = i12 + 24 | 0;
 i6 = i12 + 12 | 0;
 i5 = i12;
 i1 = HEAP32[i10 + 36 >> 2] | 0;
 i2 = i10 + 4 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(1.0)) if (Math_fround(HEAPF32[i10 + 8 >> 2]) == Math_fround(1.0)) i3 = Math_fround(HEAPF32[i10 + 12 >> 2]) == Math_fround(1.0); else i3 = 0; else i3 = 0;
 HEAP32[i7 >> 2] = 1065353216;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 1065353216;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = 1065353216;
 HEAP32[i7 + 36 >> 2] = 1065353216;
 HEAP32[i7 + 40 >> 2] = 0;
 HEAP32[i7 + 44 >> 2] = 0;
 HEAP32[i7 + 48 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 1065353216;
 HEAP32[i7 + 56 >> 2] = 0;
 HEAP32[i7 + 60 >> 2] = 0;
 HEAP32[i7 + 64 >> 2] = 0;
 HEAP32[i7 + 68 >> 2] = 1065353216;
 if (!i3) __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE(i7, i2, i10 + 16 | 0);
 __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE(i11, i4, i8, i2);
 HEAP32[i6 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i6 + 4 >> 2] = i1 + 48;
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i5 + 4 >> 2] = 2;
 HEAP32[i5 >> 2] = gb + 84764 + 8;
 HEAP32[i5 + 8 >> 2] = i9;
 __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb(i11, 1, i6, i5, 1);
 STACKTOP = i12;
 return;
}

function __Z33Canvas_Get_Custom_PropWorldCameraP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i5 = i7;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i4) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 12; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i5);
   i2 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 12; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 14;
  }
 }
 if ((i6 | 0) == 12) i6 = 14;
 if ((i6 | 0) == 14) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 HEAP32[i4 >> 2] = gb + 67512 + 8;
 i1 = i4 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 i5 = i4 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i5;
 i5 = i4 + 60 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = i5;
 i5 = i4 + 72 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = i5;
 i5 = i4 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i4 + 96 >> 2] = 5;
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK9Heightmap21GetInterpolatedHeightEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0;
 i12 = (HEAP32[i3 + 72 >> 2] | 0) + -1 | 0;
 f8 = Math_fround(Math_fround(i12 | 0) * f1);
 i11 = HEAP32[i3 + 76 >> 2] | 0;
 i10 = i11 + -1 | 0;
 f7 = Math_fround(Math_fround(i10 | 0) * f2);
 i5 = ~~f8;
 i6 = ~~f7;
 f2 = Math_fround(f8 - Math_fround(i5 | 0));
 f7 = Math_fround(f7 - Math_fround(i6 | 0));
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 92 >> 2]) / Math_fround(32766.0));
 i4 = (i6 | 0) < 0 ? 0 : (i10 | 0) < (i6 | 0) ? i10 : i6;
 i9 = Math_imul((i5 | 0) < 0 ? 0 : (i12 | 0) < (i5 | 0) ? i12 : i5, i11) | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f1 = Math_fround(f8 * Math_fround(HEAP16[i3 + (i4 + i9 << 1) >> 1] | 0));
 if (f2 > f7) {
  i9 = i5 + 1 | 0;
  i12 = Math_imul((i5 | 0) < -1 ? 0 : (i12 | 0) < (i9 | 0) ? i12 : i9, i11) | 0;
  f13 = Math_fround(f8 * Math_fround(HEAP16[i3 + (i12 + i4 << 1) >> 1] | 0));
  i11 = i6 + 1 | 0;
  f8 = Math_fround(Math_fround(f1 + Math_fround(f2 * Math_fround(f13 - f1))) + Math_fround(f7 * Math_fround(Math_fround(f8 * Math_fround(HEAP16[i3 + (((i6 | 0) < -1 ? 0 : (i10 | 0) < (i11 | 0) ? i10 : i11) + i12 << 1) >> 1] | 0)) - f13)));
  return Math_fround(f8);
 } else {
  i4 = i6 + 1 | 0;
  i6 = (i6 | 0) < -1 ? 0 : (i10 | 0) < (i4 | 0) ? i10 : i4;
  f13 = Math_fround(f8 * Math_fround(HEAP16[i3 + (i6 + i9 << 1) >> 1] | 0));
  i10 = i5 + 1 | 0;
  f13 = Math_fround(Math_fround(f7 * Math_fround(f13 - f1)) + Math_fround(f1 + Math_fround(f2 * Math_fround(Math_fround(f8 * Math_fround(HEAP16[i3 + (i6 + (Math_imul((i5 | 0) < -1 ? 0 : (i12 | 0) < (i10 | 0) ? i12 : i10, i11) | 0) << 1) >> 1] | 0)) - f13))));
  return Math_fround(f13);
 }
 return f0;
}

function __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = i2 + 4 | 0;
 i7 = HEAP32[i10 >> 2] | 0;
 i9 = i2 + 8 | 0;
 if (!(i7 & 16777215)) {
  HEAP32[i9 >> 2] = 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 & -16777216;
  HEAP32[i10 >> 2] = i9;
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i7 >>> 24 & 15) | 0;
  HEAP32[i9 >> 2] = i1;
 }
 if (i7 & 1 | 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i8 + 2528 >> 2] | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  if (i6 | 0) {
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   i3 = 0;
   do {
    i11 = HEAP32[i5 + (i3 + i4 << 2) >> 2] | 0;
    HEAP32[(HEAP32[gb + 90260 + 24 + (((HEAP32[i11 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i11 >> 2] = i2;
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i6 >>> 0);
  }
 }
 if (!(i7 & 2)) {
  HEAP32[i9 >> 2] = 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i11 = i11 & -16777216;
  HEAP32[i10 >> 2] = i11;
  return;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = HEAP32[i8 + 2528 >> 2] | 0;
 i4 = i1 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i9 >> 2] = 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i11 = i11 & -16777216;
  HEAP32[i10 >> 2] = i11;
  return;
 } else i3 = 0;
 do {
  i2 = HEAP32[i5 + (i3 + i6 << 2) >> 2] | 0;
  i11 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = (HEAP32[gb + 90260 + 24 + ((i11 >>> 24 & 15) << 2) >> 2] | 0) + i2 | 0;
  HEAP32[i2 >> 2] = -1;
  if (((i11 >>> 30) + -1 | 0) >>> 0 < 2) {
   __ZN5physx2Sc9ActorCore14reinsertShapesEv(i2);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 HEAP32[i9 >> 2] = 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = i11 & -16777216;
 HEAP32[i10 >> 2] = i11;
 return;
}

function __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f7 = f0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   i1 = HEAP32[i6 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 4;
   break;
  }
 default:
  {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = 4;
  }
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore18addSpatialVelocityEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_(i6 + 16 | 0, HEAP32[i1 + 1248 >> 2] | 0, i4, i5);
  return;
 }
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i6 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 i3 = i2 + 256 | 0;
 if (!i4) i1 = 0; else {
  i1 = i2 + 244 | 0;
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  f7 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  i1 = i2 + 248 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  i1 = i2 + 252 | 0;
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  i1 = 65536;
 }
 if (i5) {
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
  f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  i4 = i2 + 260 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i4 >> 2]));
  f7 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  i5 = i2 + 264 | 0;
  HEAPF32[i5 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i5 >> 2]));
  i1 = i1 | 131072;
 }
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i6 >> 2] | 0, i6);
 i6 = i6 + 236 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i1;
 return;
}

function __ZN18UnityPropertySheet8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i4 = HEAP32[gb + 37052 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469881 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags(i6, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469891 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_fEEEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 24 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469900 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEventD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 188936 + 8;
 i1 = i3 + 476 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 488 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 }
 i2 = i3 + 392 | 0;
 i1 = i3 + 440 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i3 + 452 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i1 = i3 + 424 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 436 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 i1 = i3 + 408 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 420 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i3 + 404 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoD2Ev(i3 + 32 | 0);
 HEAP32[i3 >> 2] = gb + 190148 + 8;
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i3);
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 __ZdlPv(i3);
 STACKTOP = i5;
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty(i1, i9, i7, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = i11 + 24 | 0;
 i6 = i1 + -124 | 0;
 HEAP16[i2 >> 1] = i9;
 i3 = i6 + 280 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i6 + 212 | 0, i2, i10) | 0;
  if (!(HEAP8[i10 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i9;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_viiiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i1 | 0, i7 | 0, i8 | 0, 0);
 }
 if (!(HEAP8[i6 + 276 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i3 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i4 = getTempRet0() | 0;
 i5 = HEAP32[i6 + 72 >> 2] | 0;
 if (!i5) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i10;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = i8;
 HEAP32[i10 + 8 >> 2] = i2;
 HEAP8[i10 + 12 >> 0] = 2;
 HEAP8[i10 + 13 >> 0] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i4;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_(i6, i9, i10);
 if (!i1) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN7mecanim9animation29MotionOutputGetDeltaTransformEPKNS0_12MotionOutputE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(f14 * f7);
 f8 = Math_fround(f14 * f8);
 f9 = Math_fround(f14 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f13 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f13 = Math_fround(f14 * f13);
 f12 = Math_fround(f14 * f12);
 f14 = Math_fround(f14 * Math_fround(HEAPF32[i1 + 24 >> 2]));
 f10 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)) + Math_fround(Math_fround(f14 * f14) + Math_fround(0.0)))));
 f2 = Math_fround(f10 * Math_fround(.5));
 f11 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 f13 = Math_fround(Math_fround(f13 * f11) / f10);
 f12 = Math_fround(Math_fround(f12 * f11) / f10);
 f11 = Math_fround(Math_fround(f14 * f11) / f10);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f13, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f12, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f11, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f10 == Math_fround(0.0);
 i15 = i5 ? 1065353216 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAPF32[i6 >> 2] = f7;
 HEAPF32[i6 + 4 >> 2] = f8;
 HEAPF32[i6 + 8 >> 2] = f9;
 HEAP32[i6 + 12 >> 2] = i5 ? 0 : i1;
 HEAP32[i6 + 16 >> 2] = i5 ? 0 : i3;
 HEAP32[i6 + 20 >> 2] = i5 ? 0 : i4;
 HEAP32[i6 + 24 >> 2] = i15;
 HEAP32[i6 + 28 >> 2] = 1065353216;
 HEAP32[i6 + 32 >> 2] = 1065353216;
 HEAP32[i6 + 36 >> 2] = 1065353216;
 return;
}

function __ZN7mecanim12statemachine17ConditionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx7Cooking17createHeightFieldERKNS_17PxHeightFieldDescERNS_26PxPhysicsInsertionCallbackE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) >>> 0 < 2) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) >>> 0 < 2) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i2 + 8 >> 2] | 0) != 1) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 < 4) {
  i3 = 0;
  return i3 | 0;
 }
 if (Math_fround(HEAPF32[i2 + 24 >> 2]) < Math_fround(0.0)) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP16[i2 + 28 >> 1] | 0;
 if ((i1 & 1) << 16 >> 16 != i1 << 16 >> 16) {
  i3 = 0;
  return i3 | 0;
 }
 f4 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 if (!(!(f4 > Math_fround(8507058669999999534545717.0e13)) & !(f4 < Math_fround(-8507058669999999534545717.0e13)))) {
  i3 = 0;
  return i3 | 0;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i5 | 0, 116, (i1 ? gb + 726403 | 0 : gb + 837976 | 0) | 0, gb + 726521 | 0, 385) | 0;
 __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE(i1, 0);
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(__ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb(i1, i2, 1) | 0)) {
  __ZN5physx2Gu11HeightField13releaseMemoryEb(i1, 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 0;
  return i6 | 0;
 }
 if (mftCall_iii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0) | 0) {
  i6 = i1;
  return i6 | 0;
 } else {
  __ZN5physx2Gu11HeightField13releaseMemoryEb(i1, 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN4PPtrI23ShaderVariantCollectionE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 i6 = i5 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37316 >> 2] | 0, i2, i4);
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 425225 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 425237 | 0, gb + 425246 | 0, i6, 0);
 i2 = i7 + 8 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i2, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN21AnimationClipPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant(i11, i7) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i9 = i11 + 164 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  if (HEAP32[i11 + 92 >> 2] | 0) i8 = 4;
 } else {
  i10 = __ZN13AnimationClip15GetRuntimeAssetEv(i1) | 0;
  if ((i10 | 0) != (HEAP32[i11 + 84 >> 2] | 0)) i8 = 4;
 }
 if ((i8 | 0) == 4) mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 100 >> 2] | 0, i11 | 0);
 i10 = i11 + 72 | 0;
 if (HEAP8[i10 >> 0] | 0) {
  HEAP8[i10 >> 0] = 1;
  return;
 }
 i5 = i7 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP8[i10 >> 0] = 1;
  return;
 }
 i6 = i7 + 16 | 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i3 + (i2 * 40 | 0) >> 2] | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  if (!((i4 | 0) != (i12 | 0) | (i12 | 0) == 0)) {
   if (__ZN13AnimationClip15GetRuntimeAssetEv(i4) | 0) break;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i1 >>> 0) {
   i8 = 18;
   break;
  }
 }
 if ((i8 | 0) == 18) {
  HEAP8[i10 >> 0] = 1;
  return;
 }
 HEAP32[i11 + 88 >> 2] = i3 + (i2 * 40 | 0) + 8;
 if (!(HEAP8[i7 + 32 >> 0] | 0)) i2 = __ZN7mecanim9animation17GetClipCurveCountERKNS0_18ClipMuscleConstantE(__ZN13AnimationClip15GetRuntimeAssetEv(HEAP32[i9 >> 2] | 0) | 0) | 0; else i2 = HEAP32[i3 + (i2 * 40 | 0) + 4 >> 2] | 0;
 i1 = __ZN13AnimationClip15GetRuntimeAssetEv(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i11 + 84 >> 2] = i1;
 if (!i1) i1 = 0; else {
  i1 = i1 + 1060 | 0;
  i12 = HEAP32[i1 >> 2] | 0;
  i1 = __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipEiRNS_6memory9AllocatorE((i12 | 0) == 0 ? 0 : i12 + i1 | 0, i2, i11 + 60 | 0) | 0;
 }
 HEAP32[i11 + 92 >> 2] = i1;
 HEAP8[i10 >> 0] = 1;
 return;
}

function __Z26Profiler_CUSTOM_GetSamplerP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 48 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if (__ZNK11ICallString6IsNullEv(i2) | 0) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1037646 | 0);
 i5 = HEAP32[gb + 1451e3 >> 2] | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i2);
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i7 + 24 | 0;
 i10 = gb + 63648 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i3 = HEAP8[i8 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i10 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i7 + 4 >> 2] = i3;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i4 >> 2] = i3;
 i1 = __ZNK9profiling14SamplerManager10GetSamplerERKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE(HEAP32[i5 + 76 >> 2] | 0, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i7 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 if (!i1) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 i10 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 276 >> 2] | 0) | 0;
 HEAP32[i10 + 8 >> 2] = i1;
 STACKTOP = i9;
 return i10 | 0;
}

function __Z18tessMeshDeleteMeshP9TESSallocP8TESSmesh(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i4 = HEAP32[i7 + 132 >> 2] | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (i1 | 0) do {
  i8 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i8 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0);
 i4 = HEAP32[i7 + 136 >> 2] | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (i1 | 0) do {
  i8 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i8 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0);
 i4 = HEAP32[i7 + 140 >> 2] | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i8 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(i8 | 0, i5 | 0, i4 | 0);
  i5 = i6 + 8 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i8 = i6 + 12 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i5 | 0, i8 | 0, i7 | 0);
  return;
 }
 do {
  i8 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i8 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(i8 | 0, i5 | 0, i4 | 0);
 i5 = i6 + 8 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i8 = i6 + 12 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(i5 | 0, i8 | 0, i7 | 0);
 return;
}

function __GLOBAL__sub_I_runtime_shaders_shaderimpl_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546611 | 0, fb + 3440 | 0, fb + 3441 | 0, 0, 0);
 HEAP32[gb + 1166408 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1166408 | 0, gb + 479790 | 0);
 HEAP32[gb + 1166496 >> 2] = 0;
 HEAP32[gb + 1166496 + 4 >> 2] = 0;
 HEAP32[gb + 1166496 + 16 >> 2] = 0;
 HEAP32[gb + 1166496 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = gb + 1166496 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166520 | 0, gb + 479803 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166532 | 0, gb + 479827 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166544 | 0, gb + 479852 | 0, 0, 0);
 HEAP32[gb + 1166556 >> 2] = 0;
 HEAP32[gb + 1166416 >> 2] = 0;
 i4 = gb + 63280 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = gb + 1166416 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[gb + 1166416 + 12 >> 2] = 16;
 i1 = gb + 1166416 + 16 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3442 | 0, fb + 3443 | 0, 0, gb + 1166416 | 0);
 HEAP32[gb + 1166412 >> 2] = 2147483647;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546612 | 0, fb + 3444 | 0, fb + 3445 | 0, 0, 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_(i5, i1, i2, i4, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i7;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) i9 = 8; else {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, gb + 1077991 | 0, gb + 1077991 + 32 | 0, i2 | 0) | 0;
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) i9 = 8; else {
   __THREW__ = 0;
   i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474596 | 0) | 0;
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) i9 = 8; else {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (!(i10 & 1)) {
     HEAP32[i4 >> 2] = i1;
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (!(i10 & 1)) {
      HEAP32[i6 >> 2] = i1;
      __THREW__ = 0;
      invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i2 | 0);
      i10 = __THREW__;
      __THREW__ = 0;
      if (!(i10 & 1)) {
       __ZNSt3__214__shared_count16__release_sharedEv(i7) | 0;
       STACKTOP = i8;
       return;
      }
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
  }
 }
 if ((i9 | 0) == 8) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i7) | 0;
 ___resumeException(i1 | 0);
}

function __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN9TextAsset8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 588832 | 0, i9, i1 + 48 | 0, 67108865);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 465937 | 0, i9, i1 + 32 | 0, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN9ShaderLab22SerializedBindChannels8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i1 = i11;
 i5 = i6 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i7 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i7 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = i1 + (i4 << 3) | 0;
 if (i4 | 0) do {
  i2 = HEAP32[i1 >> 2] & 255;
  HEAP8[i8 >> 0] = i2;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = i2;
   i4 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
   i4 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i1 >> 2] = HEAP8[i8 >> 0];
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] & 255;
  HEAP8[i8 >> 0] = i3;
  if ((i4 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i4 >> 0] = i3;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
  HEAP32[i2 >> 2] = HEAP8[i8 >> 0];
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
  STACKTOP = i11;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i11;
  return;
 }
}

function __ZN9Animation21RebuildBoundStateMaskEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 104 | 0;
 i9 = i10 + 108 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i2 = 0;
  i7 = 0;
 } else {
  i7 = 0;
  i6 = 0;
  i2 = 0;
  while (1) {
   i5 = HEAP32[i3 + (i6 << 2) >> 2] | 0;
   if (!(HEAP32[i5 + 96 >> 2] | 0)) i4 = i3; else if (!(HEAP16[i5 + 56 >> 1] & 2)) i4 = i3; else if (Math_fround(HEAPF32[i5 + 8 >> 2]) > Math_fround(.0000999999974)) {
    i4 = i10 + 120 + (i7 << 2) | 0;
    if (!(HEAP32[i5 + 72 >> 2] | 0)) {
     i2 = i2 | (HEAP32[i4 >> 2] | 0) != (i5 | 0);
     HEAP32[i4 >> 2] = i5;
     i7 = i7 + 1 | 0;
     i1 = HEAP32[i9 >> 2] | 0;
     i4 = HEAP32[i8 >> 2] | 0;
    } else i4 = i3;
   } else i4 = i3;
   i6 = i6 + 1 | 0;
   i3 = i1 - i4 >> 2;
   if (!((i7 | 0) < 32 & i6 >>> 0 < i3 >>> 0)) break; else i3 = i4;
  }
  if ((i6 | 0) != (i3 | 0)) {
   i10 = 0;
   return i10 | 0;
  }
 }
 i1 = i10 + 248 | 0;
 if (!(i2 | (i7 | 0) != (HEAP32[i1 >> 2] | 0))) {
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i1 >> 2] = i7;
 i5 = HEAP32[i10 + 96 >> 2] | 0;
 if (!i5) {
  i10 = 1;
  return i10 | 0;
 }
 i6 = HEAP32[i10 + 84 >> 2] | 0;
 if ((i7 | 0) > 0) i3 = 0; else {
  i1 = 0;
  do {
   HEAP32[i6 + (i1 * 24 | 0) + 20 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
  i1 = 1;
  return i1 | 0;
 }
 do {
  i4 = i6 + (i3 * 24 | 0) + 20 | 0;
  HEAP32[i4 >> 2] = 0;
  i2 = 0;
  i1 = 0;
  do {
   if (HEAP32[(HEAP32[(HEAP32[i10 + 120 + (i2 << 2) >> 2] | 0) + 4 >> 2] | 0) + (i3 << 2) >> 2] | 0) {
    i1 = i1 | 1 << i2;
    HEAP32[i4 >> 2] = i1;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i7 | 0));
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i5 >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4AxesEEEclERS3_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i8 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
 i6 = HEAP8[i5 + 26 >> 0] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP8[i1 + 21 >> 0] = i8 & 1;
 HEAP8[i1 + 22 >> 0] = i6;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN4math4Axes8TransferI8BlobSizeEEvRT_(i7, i1);
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = Math_imul(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, (0 - i6 & 3) + i6 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i5, i6, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 * 76 | 0) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIN4math4AxesEEEvRT_PKc17TransferMetaFlags(i5, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 76 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i5 + 48 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - (HEAP32[i5 + 32 >> 2] | 0) | 0;
 if ((1 - i7 - (HEAP32[i5 + 44 >> 2] | 0) + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i4;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i4;
 return;
}

function __ZN14TerrainManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 HEAP32[i1 >> 2] = gb + 184476 + 8;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = i7;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = i4;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 27788 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i7 = i3;
  i6 = i7 + 1 | 0;
  HEAP32[i2 >> 2] = i6;
  i6 = i1 + 27020 + (i7 * 12 | 0) + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i1 + 27020 + (i7 * 12 | 0) + 8 | 0;
  HEAP8[i6 >> 0] = 0;
  i7 = i1 + 27020 + (i7 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = fb + 4155;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 24 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = i7 + 1 | 0;
 HEAP32[i2 >> 2] = i6;
 i6 = i1 + 27020 + (i7 * 12 | 0) + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i1 + 27020 + (i7 * 12 | 0) + 8 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i1 + 27020 + (i7 * 12 | 0) | 0;
 HEAP32[i7 >> 2] = fb + 4155;
 STACKTOP = i5;
 return;
}

function __Z16NotifyPlayerQuitb(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 32 | 0;
 i4 = i5 + 12 | 0;
 i3 = i5;
 if (!(__Z24GetManagerPtrFromContexti(0) | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i6 = __Z15GetInputManagerv() | 0;
 HEAP8[i6 + 189 >> 0] = 1;
 HEAP8[i6 + 188 >> 0] = 1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1105756 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1105756 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1105756 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 1105756 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 1105756 + 16 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i4, i1);
 if (!i2) if (!(HEAP8[(__Z15GetInputManagerv() | 0) + 189 >> 0] | 0)) if (!(HEAP8[(__Z15GetInputManagerv() | 0) + 188 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i1 = __Z9GetIAudiov() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i6 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, 1);
 i6 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 76 >> 2] | 0, i6 | 0, 0);
 i6 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i6 | 0, 0);
 __ZN13ScreenManager18SetAllowCursorLockEb(__Z16GetScreenManagerv() | 0, 0);
 __Z18StopPreloadManagerv();
 __ZN19RuntimeSceneManager37ClearAndUnloadWaitingForLoadingScenesEv(__Z15GetSceneManagerv() | 0);
 i6 = 1;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj118ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i5 = i7 + 16 | 0;
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyINS_12PxFilterDataEEEbRT_(i6, i5) | 0) {
  i4 = HEAP32[i6 + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  mftCall_vii(i3 | 0, i4 | 0, i2 | 0);
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj117ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i4, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i5 = i7 + 16 | 0;
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyINS_12PxFilterDataEEEbRT_(i6, i5) | 0) {
  i4 = HEAP32[i6 + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  mftCall_vii(i3 | 0, i4 | 0, i2 | 0);
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN16TimerQueriesGLES18PollNextTimerQueryEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9;
 i6 = i1 + 556 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i1 + 552 | 0;
 if ((i7 | 0) == (i8 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i1 + 520 | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 if (!i2) {
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 800 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0, 34919, i3 | 0);
  if ((HEAP32[i3 >> 2] | 0) == 0 & (HEAP32[i3 + 4 >> 2] | 0) == 0) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 720 >> 0] | 0)) i1 = HEAP8[i7 + 8 >> 0] | 0; else {
  i1 = (__ZNK7ApiGLES3GetEj(HEAP32[gb + 1451080 >> 2] | 0, 36795) | 0) != 0 & 1;
  HEAP8[i7 + 8 >> 0] = i1;
 }
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 if (!(i1 << 24 >> 24)) {
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 800 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0, 34918, i4 | 0);
  i2 = i4;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 i3 = i5;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i7 + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 i7 = i5;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i8 | 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = i2 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN12TreeDatabase9PrototypeC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 120 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 STACKTOP = i2;
 return;
}

function __Z11CloneObjectR6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 32 | 0;
 i2 = i10;
 i3 = i10 + 20 | 0;
 if ((HEAP16[gb + 1155156 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155156 | 0, i6);
  i7 = gb + 1155156 | 0;
 } else i7 = 0;
 i5 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = i2 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i8 = i2 + 16 | 0;
 HEAP32[i8 >> 2] = i5;
 i5 = __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, 0, i2) | 0;
 if (i5 | 0) {
  i11 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i11 + 40 >> 2] | 0;
  __Z6AppendPKcS0_(i3, mftCall_ii(HEAP32[i11 + 36 >> 2] | 0, i5 | 0) | 0, gb + 391391 | 0);
  mftCall_vii(i1 | 0, i5 | 0, ((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i2);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i11 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 if (!i7) {
  STACKTOP = i10;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i10;
 return i5 | 0;
}

function __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_(i5, i1, i2, i4, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i7;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 if (i10 & 1) i9 = 8; else {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, gb + 1077991 | 0, gb + 1077991 + 32 | 0, i2 | 0) | 0;
  i10 = __THREW__;
  __THREW__ = 0;
  if (i10 & 1) i9 = 8; else {
   __THREW__ = 0;
   i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474572 | 0) | 0;
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) i9 = 8; else {
    __THREW__ = 0;
    i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
    i10 = __THREW__;
    __THREW__ = 0;
    if (!(i10 & 1)) {
     HEAP8[i4 >> 0] = i1;
     __THREW__ = 0;
     i1 = invoke_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
     i10 = __THREW__;
     __THREW__ = 0;
     if (!(i10 & 1)) {
      HEAP8[i6 >> 0] = i1;
      __THREW__ = 0;
      invoke_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i2 | 0);
      i10 = __THREW__;
      __THREW__ = 0;
      if (!(i10 & 1)) {
       __ZNSt3__214__shared_count16__release_sharedEv(i7) | 0;
       STACKTOP = i8;
       return;
      }
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
  }
 }
 if ((i9 | 0) == 8) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i7) | 0;
 ___resumeException(i1 | 0);
}

function __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE(i5, i9, i10, i7, i6, i2, i8) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i1 = i7 + 18 | 0;
 i3 = HEAP8[i1 >> 0] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 << 24 >> 24 != (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0) | 0) << 24 >> 24) {
  i3 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, HEAP8[i1 >> 0] | 0) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if (!((i3 & 8 & (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 76 >> 2] | 0, i4 | 0) | 0)) << 24 >> 24)) {
   i11 = 0;
   STACKTOP = i12;
   return i11 | 0;
  }
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 i4 = HEAP32[i7 + 12 >> 2] | 0;
 if (i2 | i1 | i3 | i4 | 0) {
  i13 = HEAP32[i5 + 4 >> 2] | 0;
  if (!(HEAP32[i13 + 52 >> 2] & i2 | HEAP32[i13 + 48 >> 2] & i1 | HEAP32[i13 + 56 >> 2] & i3 | HEAP32[i13 + 60 >> 2] & i4)) {
   i13 = 0;
   STACKTOP = i12;
   return i13 | 0;
  }
 }
 if (!i6) {
  i13 = i5;
  STACKTOP = i12;
  return i13 | 0;
 }
 if (!(HEAP16[i10 >> 1] & 4)) {
  i13 = i5;
  STACKTOP = i12;
  return i13 | 0;
 }
 HEAP16[i11 >> 1] = HEAP16[i8 >> 1] | 0;
 HEAP32[i9 >> 2] = mftCall_iiiiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i7 | 0, HEAP32[i5 + 4 >> 2] | 0, HEAP32[i5 >> 2] | 0, i11 | 0) | 0;
 HEAP16[i8 >> 1] = (HEAPU16[i11 >> 1] | 0) & 432 | HEAP16[i8 >> 1] & -433;
 i13 = i5;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI20OcclusionCullingDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN30RuntimeInitializeOnLoadManager15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 4628 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 3860 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 3860 + (i1 * 12 | 0) >> 2] = fb + 534;
 i1 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i1 + 5400 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 63) {
  i4 = i3;
  i3 = i4 + 1 | 0;
  HEAP32[i2 >> 2] = i3;
  i3 = i1 + 4632 + (i4 * 12 | 0) + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 4632 + (i4 * 12 | 0) + 8 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = i1 + 4632 + (i4 * 12 | 0) | 0;
  HEAP32[i4 >> 2] = fb + 535;
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i4 + 1 | 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i1 + 4632 + (i4 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 4632 + (i4 * 12 | 0) + 8 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 4632 + (i4 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = fb + 535;
 STACKTOP = i5;
 return;
}

function __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN13RenderTexture10GrabPixelsEiiii(i3, i12, i13, i1, i2) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 12 | 0;
 i9 = i17 + 8 | 0;
 i15 = i17 + 4 | 0;
 i16 = i17;
 if (!(HEAP32[i3 + 128 >> 2] | 0)) if (!(HEAP32[i3 + 136 >> 2] | 0)) {
  HEAP32[i10 >> 2] = 0;
  __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i3, i10, i10) | 0;
 }
 i11 = HEAP32[((HEAP32[i3 + 88 >> 2] | 0) > 1 ? i3 + 132 | 0 : i3 + 128 | 0) >> 2] | 0;
 if (!i11) {
  STACKTOP = i17;
  return;
 }
 i14 = (i12 | 0) < 0;
 i7 = (i14 ? i12 : 0) + i1 | 0;
 i8 = (i13 | 0) < 0;
 i4 = (i8 ? i13 : 0) + i2 | 0;
 i5 = HEAP32[i3 + 80 >> 2] | 0;
 i6 = HEAP32[i3 + 84 >> 2] | 0;
 i2 = HEAP32[i3 + 136 >> 2] | 0;
 if ((HEAP16[gb + 1158316 + 6 >> 1] | 0) > -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158316 | 0, i10);
  i1 = gb + 1158316 | 0;
 } else i1 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i18 = HEAP32[(HEAP32[i3 >> 2] | 0) + 604 >> 2] | 0;
 HEAP32[i15 >> 2] = i11;
 HEAP32[i16 >> 2] = i2;
 HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
 mftCall_viiiiiii(i18 | 0, i3 | 0, i9 | 0, i10 | 0, (i14 ? 0 : i12) | 0, (i8 ? 0 : i13) | 0, ((i7 | 0) > (i5 | 0) ? i5 : i7) | 0, ((i4 | 0) > (i6 | 0) ? i6 : i4) | 0);
 __Z15gpu_time_samplev();
 if (HEAP8[i3 + 3896 >> 0] | 0) {
  i18 = i3 + 3620 | 0;
  HEAP32[i18 >> 2] = (HEAP32[i18 >> 2] | 0) + 1;
 }
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i17;
 return;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy(i1, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i13 = i6;
 i12 = i6 + 200 | 0;
 i4 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = 37;
 HEAP32[i14 + 4 >> 2] = 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, gb + 1087509 | 0, 0, HEAP32[i8 + 4 >> 2] | 0);
 i14 = __ZNSt3__26__clocEv() | 0;
 i15 = i1;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = i11;
 i11 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 23, i14, i13, i1) | 0) | 0;
 i10 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i11, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 43 | 0, i12 | 0, i10 | 0, i11 | 0, i4 | 0, i5 | 0, i2 | 0, i1 | 0);
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i15 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i15 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  i14 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i15 = __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i4, i14, i15, i8, i9) | 0;
  STACKTOP = i6;
  return i15 | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx(i1, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i13 = i6;
 i12 = i6 + 200 | 0;
 i4 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = 37;
 HEAP32[i14 + 4 >> 2] = 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, gb + 1087509 | 0, 1, HEAP32[i8 + 4 >> 2] | 0);
 i14 = __ZNSt3__26__clocEv() | 0;
 i15 = i1;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = i11;
 i11 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 23, i14, i13, i1) | 0) | 0;
 i10 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i11, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 43 | 0, i12 | 0, i10 | 0, i11 | 0, i4 | 0, i5 | 0, i2 | 0, i1 | 0);
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i15 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i15 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  i14 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i15 = __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i4, i14, i15, i8, i9) | 0;
  STACKTOP = i6;
  return i15 | 0;
 }
 return 0;
}

function __ZN5Unity12PhysicsQuery18OverlapBoxInternalERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_12PxOverlapHitEEE(i1, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 68 | 0;
 i3 = i5 + 48 | 0;
 i4 = i5 + 32 | 0;
 i1 = i5;
 HEAP32[i2 >> 2] = gb + 114012 + 8;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i9;
 switch (i10 | 0) {
 case 0:
  {
   HEAP8[i2 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i2 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i2 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 + 16 >> 1] = 7;
 HEAP8[i3 + 18 >> 0] = 0;
 i10 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = 3;
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i4 + 8 >> 2] = i9;
 HEAP32[i4 + 12 >> 2] = i7;
 i7 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = HEAP32[i6 + 8 >> 2] | 0;
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 i12 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i13;
 HEAP32[i1 + 8 >> 2] = i12;
 HEAP32[i1 + 12 >> 2] = i6;
 HEAP32[i1 + 16 >> 2] = i7;
 HEAP32[i1 + 20 >> 2] = i9;
 HEAP32[i1 + 24 >> 2] = i10;
 i10 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_iiiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 356 >> 2] | 0, i10 | 0, i4 | 0, i1 | 0, i11 | 0, i3 | 0, i2 | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5Umbra15OcclusionBuffer5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1280 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 i2 = i4 + 1080 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i4 + 1248 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i4 | 0, 0, 1068) | 0;
 i2 = i4 + 1188 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 1412 >> 0] = 0;
 HEAP32[i1 >> 2] = 1065353216;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 HEAP32[i1 + 64 >> 2] = 1065353216;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 1065353216;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 1065353216;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 1065353216;
 _memcpy(i1 + 128 | 0, i4 | 0, 1276) | 0;
 HEAP32[i1 + 1408 >> 2] = 0;
 HEAP32[i1 + 1416 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN4PPtrI19SkinnedMeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i10, i3, i1) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i10);
  i4 = i1 + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i4, _llvm_bswap_i32(i2 | 0) | 0);
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i2, i10);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 272 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 536 | 0, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 + 800 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 804 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 808 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN16CrashReportEventD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i2 + 96 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 108 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 76 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeItemsEj(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i8 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = (HEAP32[i11 >> 2] | 0) - i2 >> 2;
 i4 = i4 >>> 0 < i1 >>> 0 ? i4 : i1;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i5 = i10 + 4 | 0;
 i6 = i10 + 4 | 0;
 i7 = i8 + 16 | 0;
 i3 = 0;
 i1 = i2;
 while (1) {
  if (HEAP32[(HEAP32[i1 + (i3 << 2) >> 2] | 0) + 32 >> 2] & 1 | 0) HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
  i9 = i2 + 44 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   i1 = i2 + 16 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i2 + 28 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
   }
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i2 + 12 >> 2] | 0;
    HEAP32[i10 >> 2] = 66;
    HEAP32[i6 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i10);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63800 | 0);
   i9 = HEAP32[i8 >> 2] | 0;
  } else i9 = i1;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i4 >>> 0) break; else i1 = i9;
 }
 i1 = i9 + (i4 << 2) | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 - i1 | 0;
 i4 = i3 >> 2;
 if (i4) {
  _memmove(i9 | 0, i1 | 0, i3 | 0) | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i1 = i9 + (i4 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 STACKTOP = i12;
 return;
}

function __Z67AnimatorOverrideController_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZNK26AnimatorOverrideController21GetAnimatorControllerEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sc10ClothShape21updateBoundsInAABBMgrEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = i8 + 20 | 0;
 i1 = ((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(HEAP32[i4 >> 2] | 0) | 0) & 4) == 0;
 i2 = i8 + 24 | 0;
 i3 = (HEAP8[i2 >> 0] | 0) != 0;
 if (i1) {
  if (!i3) {
   STACKTOP = i10;
   return;
  }
  __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i8 + 8 >> 2] | 0) | 0, i8);
  HEAP8[i2 >> 0] = 0;
  STACKTOP = i10;
  return;
 }
 i1 = i8 + 8 | 0;
 if (!i3) {
  __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_10ClothShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 >> 2] | 0) | 0, i8);
  HEAP8[i2 >> 0] = 1;
 }
 i2 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 __ZNK5physx2Sc9ClothCore14getWorldBoundsEv(i9, HEAP32[i4 >> 2] | 0);
 f5 = Math_fround(__ZNK5physx2Sc9ClothCore16getContactOffsetEv(HEAP32[i4 >> 2] | 0));
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 i1 = i9 + 12 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f6 > f7)) {
  HEAPF32[i9 >> 2] = Math_fround(f6 - f5);
  i4 = i9 + 4 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f5);
  i4 = i9 + 8 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f5);
  HEAPF32[i1 >> 2] = Math_fround(f5 + f7);
  i4 = i9 + 16 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
  i4 = i9 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
 }
 __ZN5physx14PxsAABBManager15setVolumeBoundsEjRKNS_9PxBounds3E(i2, HEAP32[i8 + 12 >> 2] & 1073741823, i9);
 STACKTOP = i10;
 return;
}

function __ZN5Unity10HingeJoint9SetLimitsERK11JointLimits(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0;
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i8 = f6 < Math_fround(-340282326000000008404918.0e15);
 i9 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i9 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i8 ? Math_fround(-340282326000000008404918.0e15) : f6;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i8 = f7 < Math_fround(-340282326000000008404918.0e15);
 i9 = f7 > Math_fround(340282326000000008404918.0e15);
 f7 = i9 ? Math_fround(340282326000000008404918.0e15) : f7;
 f7 = i8 ? Math_fround(-340282326000000008404918.0e15) : f7;
 i8 = f6 < f7;
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i9 = f5 < Math_fround(0.0);
 i10 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i10 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i9 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i9 = f4 < Math_fround(0.0);
 i10 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i10 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i9 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i9 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i9 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 96 >> 2] = i8 ? f6 : f7;
 HEAPF32[i2 + 100 >> 2] = i8 ? f7 : f6;
 HEAPF32[i2 + 104 >> 2] = f5;
 HEAPF32[i2 + 108 >> 2] = f4;
 HEAPF32[i2 + 112 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity10HingeJoint16WriteJointLimitsEv(i2);
 __ZN5Unity10HingeJoint14WriteUseLimitsEv(i2);
 return;
}

function __ZN4PPtrI18SpeedTreeWindAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI18ProceduralMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI18AudioMixerSnapshotE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI18AnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN12InputManager9GetButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i1 = i2 + 11 | 0;
 i12 = __Z7FNVHashPKc((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i11 = HEAP32[i3 + 32 >> 2] | 0;
 if ((i4 | 0) == (i11 | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 i10 = HEAP8[i1 >> 0] | 0;
 i8 = i10 << 24 >> 24 < 0;
 i10 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i9 = i3 + 68 | 0;
 i7 = i3 + 48 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i4 + 20 >> 2] | 0) == (i12 | 0)) {
   i3 = i4 + 4 | 0;
   i6 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   if (i2) i5 = HEAP32[i4 + 8 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i10 | 0)) {
    if (i2) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i4 + 8 >> 2] | 0;
    } else i2 = i6 & 255;
    if (!(_strncmp(i3, i8, i2) | 0)) {
     i15 = HEAP32[i4 + 56 >> 2] | 0;
     i16 = i15 >>> 5;
     i3 = HEAP32[i9 >> 2] | 0;
     i2 = HEAP32[i7 >> 2] | 0;
     i17 = HEAP32[i4 + 60 >> 2] | 0;
     i18 = i17 >>> 5;
     i13 = HEAP32[i4 + 64 >> 2] | 0;
     i14 = i13 >>> 5;
     i6 = HEAP32[i4 + 68 >> 2] | 0;
     i5 = i6 >>> 5;
     i1 = i1 | ((HEAP32[i2 + (i18 << 2) >> 2] | HEAP32[i3 + (i18 << 2) >> 2]) & 1 << (i17 & 31) | (HEAP32[i2 + (i16 << 2) >> 2] | HEAP32[i3 + (i16 << 2) >> 2]) & 1 << (i15 & 31) | (HEAP32[i2 + (i14 << 2) >> 2] | HEAP32[i3 + (i14 << 2) >> 2]) & 1 << (i13 & 31) | (HEAP32[i2 + (i5 << 2) >> 2] | HEAP32[i3 + (i5 << 2) >> 2]) & 1 << (i6 & 31) | 0) != 0;
    }
   }
  }
  i4 = i4 + 108 | 0;
 } while ((i4 | 0) != (i11 | 0));
 return i1 | 0;
}

function __ZN10dtNodePool7getNodeEy(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = _bitshift64Shl(i5 | 0, i6 | 0, 18) | 0;
 i7 = _i64Add(i7 | 0, getTempRet0() | 0, ~i5 | 0, ~i6 | 0) | 0;
 i1 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i7 | 0, i1 | 0, 31) | 0;
 i1 = ___muldi3(i8 ^ i7 | 0, (getTempRet0() | 0) ^ i1 | 0, 21, 0) | 0;
 i7 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i1 | 0, i7 | 0, 11) | 0;
 i7 = ___muldi3(i8 ^ i1 | 0, (getTempRet0() | 0) ^ i7 | 0, 65, 0) | 0;
 i1 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i7 | 0, i1 | 0, 22) | 0;
 (getTempRet0() | 0) ^ i1;
 i7 = (HEAP32[i4 + 16 >> 2] | 0) + -1 & (i8 ^ i7);
 i8 = i4 + 4 | 0;
 i1 = HEAP16[(HEAP32[i8 >> 2] | 0) + (i7 << 1) >> 1] | 0;
 L1 : do if (i1 << 16 >> 16 != -1) {
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = i4 + 8 | 0;
  i1 = i1 & 65535;
  while (1) {
   i9 = i2 + (i1 << 5) + 24 | 0;
   if ((HEAP32[i9 >> 2] | 0) == (i5 | 0) ? (HEAP32[i9 + 4 >> 2] | 0) == (i6 | 0) : 0) break;
   i1 = HEAP16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0;
   if (i1 << 16 >> 16 == -1) break L1; else i1 = i1 & 65535;
  }
  i9 = i2 + (i1 << 5) | 0;
  return i9 | 0;
 } while (0);
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) >= (HEAP32[i4 + 12 >> 2] | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 HEAP32[i1 >> 2] = i2 + 1;
 i9 = i2 & 65535;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i3 + (i9 << 5) + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + (i9 << 5) + 16 >> 2] = Math_fround(0.0);
 i1 = i3 + (i9 << 5) + 24 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i3 + (i9 << 5) + 20 >> 2] = 0;
 i8 = (HEAP32[i8 >> 2] | 0) + (i7 << 1) | 0;
 HEAP16[(HEAP32[i4 + 8 >> 2] | 0) + (i9 << 1) >> 1] = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = i2;
 i9 = i3 + (i9 << 5) | 0;
 return i9 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIttEEPtEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 1 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -2 | 0;
   i2 = HEAP16[i1 >> 1] | 0;
   i3 = HEAP16[i8 >> 1] | 0;
   if ((i2 & 65535) < (i3 & 65535)) {
    HEAP16[i8 >> 1] = i2;
    HEAP16[i1 >> 1] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i8, i8 + 2 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_(i8, i8 + 2 | 0, i8 + 4 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_(i8, i8 + 2 | 0, i8 + 4 | 0, i8 + 6 | 0, i7 + -2 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 4 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i8, i8 + 2 | 0, i2, i1) | 0;
   i6 = i8 + 6 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP16[i6 >> 1] | 0;
    i4 = HEAP16[i2 >> 1] | 0;
    if ((i5 & 65535) < (i4 & 65535)) {
     i3 = i6;
     while (1) {
      HEAP16[i3 >> 1] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -2 | 0;
      i4 = HEAP16[i3 >> 1] | 0;
      if ((i5 & 65535) >= (i4 & 65535)) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP16[i2 >> 1] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 2 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 2 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy(i1, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i13 = i6;
 i12 = i6 + 71 | 0;
 i4 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = 37;
 HEAP32[i14 + 4 >> 2] = 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, gb + 1087509 | 0, 0, HEAP32[i8 + 4 >> 2] | 0);
 i14 = __ZNSt3__26__clocEv() | 0;
 i15 = i1;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = i11;
 i11 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 23, i14, i13, i1) | 0) | 0;
 i10 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i11, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 41 | 0, i12 | 0, i10 | 0, i11 | 0, i4 | 0, i5 | 0, i2 | 0, i1 | 0);
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i15 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i15 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  i14 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i15 = __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i4, i14, i15, i8, i9) | 0;
  STACKTOP = i6;
  return i15 | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx(i1, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i13 = i6;
 i12 = i6 + 71 | 0;
 i4 = i6 + 28 | 0;
 i5 = i6 + 24 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 i14 = i13;
 HEAP32[i14 >> 2] = 37;
 HEAP32[i14 + 4 >> 2] = 0;
 __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i13 + 1 | 0, gb + 1087509 | 0, 1, HEAP32[i8 + 4 >> 2] | 0);
 i14 = __ZNSt3__26__clocEv() | 0;
 i15 = i1;
 HEAP32[i15 >> 2] = i10;
 HEAP32[i15 + 4 >> 2] = i11;
 i11 = i12 + (__ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i12, 23, i14, i13, i1) | 0) | 0;
 i10 = __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i12, i11, i8) | 0;
 HEAP32[i1 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
 __THREW__ = 0;
 invoke_viiiiiii(fb + 41 | 0, i12 | 0, i10 | 0, i11 | 0, i4 | 0, i5 | 0, i2 | 0, i1 | 0);
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i15 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  ___resumeException(i15 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  i14 = HEAP32[i5 >> 2] | 0;
  i15 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i15 = __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i1, i4, i14, i15, i8, i9) | 0;
  STACKTOP = i6;
  return i15 | 0;
 }
 return 0;
}

function __ZN4PPtrI17ProceduralTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN2UI13RectTransform15GetWorldCornersERA4_8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
 f9 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f7 = Math_fround(f9 + f7);
 f8 = Math_fround(f6 + Math_fround(HEAPF32[i1 + 132 >> 2]));
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f6;
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = f9;
 HEAPF32[i2 + 16 >> 2] = f8;
 HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 24 >> 2] = f7;
 HEAPF32[i2 + 28 >> 2] = f8;
 HEAPF32[i2 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 36 >> 2] = f7;
 HEAPF32[i2 + 40 >> 2] = f6;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 __ZNK9Transform14TransformPointERK8Vector3f(i3, i1, i2);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i5 = i2 + 12 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i3, i1, i5);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i5 = i2 + 24 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i3, i1, i5);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i2 + 36 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i3, i1, i2);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl12SetFontNamesERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 if ((HEAP32[i9 + 32 >> 2] | 0) != -2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1008055 | 0, 0, gb + 944940 | 0, 428, 1, 0, 0, 0);
  return;
 }
 i14 = i9 + 100 | 0;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i8 = HEAP32[i14 >> 2] | 0;
 i11 = i2;
 i12 = i8;
 i13 = i1;
 L5 : do if ((i3 | 0) == ((HEAP32[i9 + 104 >> 2] | 0) - i8 | 0)) {
  if ((i1 | 0) == (i2 | 0)) return;
  i8 = i3 >> 4;
  i7 = 0;
  do {
   i2 = i11 + (i7 << 4) | 0;
   i4 = i12 + (i7 << 4) | 0;
   i6 = HEAP8[i2 + 11 >> 0] | 0;
   i3 = i6 << 24 >> 24 < 0;
   if (i3) i1 = HEAP32[i11 + (i7 << 4) + 4 >> 2] | 0; else i1 = i6 & 255;
   i15 = HEAP8[i4 + 11 >> 0] | 0;
   i5 = i15 << 24 >> 24 < 0;
   if ((i1 | 0) != ((i5 ? HEAP32[i12 + (i7 << 4) + 4 >> 2] | 0 : i15 & 255) | 0)) break L5;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i3) {
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = i5 ? i1 : i4;
    i1 = HEAP32[i11 + (i7 << 4) + 4 >> 2] | 0;
   } else {
    i3 = i2;
    i2 = i5 ? i1 : i4;
    i1 = i6 & 255;
   }
   i7 = i7 + 1 | 0;
   if (_strncmp(i3, i2, i1) | 0) break L5;
  } while (i7 >>> 0 < i8 >>> 0);
  return;
 } while (0);
 if ((i14 | 0) != (i10 | 0)) __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i14, i11, i13);
 __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(i9) | 0;
 return;
}

function __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAP32[i2 + 4 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP8[i4 >> 0] = 0;
 i3 = i2 + 9 | 0;
 HEAP8[i3 >> 0] = 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i5 = i2 + 32 | 0;
 HEAP32[i5 >> 2] = 32;
 HEAP32[i2 + 36 >> 2] = 0;
 i8 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 52 >> 2] = i8;
 i7 = HEAP32[i5 >> 2] | 0;
 f10 = Math_fround(i7 >>> 0);
 HEAP32[i2 + 44 >> 2] = ~~Math_fround(f10 * Math_fround(.5)) >>> 0;
 HEAP32[i2 + 40 >> 2] = ~~Math_fround(f10 * Math_fround(.200000003)) >>> 0;
 HEAP8[i2 + 48 >> 0] = 0;
 HEAP8[i3 >> 0] = 1;
 i3 = i2 + 20 | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 65;
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 28 >> 2] = i1;
 i5 = i1 + (HEAP32[i5 >> 2] << 3) | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i7 = i3;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv(i2);
 HEAP8[i4 >> 0] = 1;
 i9 = i2 + 12 | 0;
 HEAP32[i9 >> 2] = -1;
 HEAP32[i9 + 4 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i7, i3, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i5 | 0)) {
  i4 = HEAP32[i3 + 32 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) {
    i1 = 0;
    i4 = 0;
    break L1;
   }
  }
  if ((i1 | 0) > -1) {
   __ZNK19ShaderPropertySheet13GetFloatArrayEi(i6, i3, i1);
   i1 = HEAP32[i6 >> 2] | 0;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
  } else {
   i1 = 0;
   i4 = 0;
  }
 } else {
  i1 = 0;
  i4 = 0;
 } while (0);
 i2 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
 i3 = i7 + 8 | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i3 >> 2] | 0) | 0) >>> 0 < i4 >>> 0) {
  i6 = __Z19scripting_array_newP11Il2CppClassjj(i2, 4, i4) | 0;
  HEAP32[i3 >> 2] = i6;
  i3 = i6;
 } else i3 = HEAP32[i3 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if ((i4 | 0) > 0) i2 = 0; else {
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i4;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
 while (1) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, i2, 4) | 0) >> 2] = i6;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
 }
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = i4;
 i7 = i7 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 + 1 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i8;
 return;
}

function __Z20RegisterBuiltinTypesv() {
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 1e5, gb + 29192 | 0, gb + 1087830 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100001, gb + 29232 | 0, gb + 1087825 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100002, gb + 29272 | 0, gb + 1087895 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100011, gb + 29312 | 0, gb + 1087820 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100010, gb + 29352 | 0, gb + 802568 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100005, gb + 29392 | 0, gb + 369702 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100009, gb + 29432 | 0, gb + 369711 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100008, gb + 29472 | 0, gb + 369736 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100004, gb + 29512 | 0, gb + 779307 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100007, gb + 29552 | 0, gb + 801622 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100003, gb + 29592 | 0, gb + 369762 | 0, gb + 1576256 | 0);
 __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, 100006, gb + 29632 | 0, gb + 369773 | 0, gb + 1576256 | 0);
 return;
}

function __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 56 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 52 >> 2] | 0;
 i8 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 * 20 | 0) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 * 20 | 0) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 * 20 | 0) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE(i8, i3, i7, i1) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, f6 = f0, i9 = 0, i10 = 0, i11 = 0, f12 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = i8 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN7mecanim9animation10SampleClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEfPf(i8, i7, Math_fround(HEAPF32[i3 >> 2]), i2);
  i2 = i2 + (HEAP32[i1 >> 2] << 2) | 0;
 }
 i1 = i8 + 16 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i8 + 24 >> 2]));
  f6 = Math_fround(_modff(Math_fround(f6 * Math_fround(HEAPF32[i8 + 20 >> 2])), i4));
  i4 = ~~Math_fround(HEAPF32[i4 >> 2]);
  i10 = i4 + 1 | 0;
  i4 = (i4 | 0) > 0 ? i4 : 0;
  i5 = (HEAP32[i8 + 12 >> 2] | 0) + -1 | 0;
  i10 = (i10 | 0) > 0 ? i10 : 0;
  i11 = i8 + 32 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = Math_imul((i4 | 0) < (i5 | 0) ? i4 : i5, i3) | 0;
  i1 = (HEAP32[i11 >> 2] | 0) + i11 | 0;
  i4 = i1 + (i4 << 2) | 0;
  i5 = i1 + ((Math_imul((i10 | 0) < (i5 | 0) ? i10 : i5, i3) | 0) << 2) | 0;
  if (i3 | 0) {
   i1 = 0;
   do {
    f12 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
    HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(f12 + Math_fround(f6 * Math_fround(Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]) - f12)));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  i2 = i2 + (i3 << 2) | 0;
 }
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i11 = i8 + 40 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 _memcpy(i2 | 0, ((i10 | 0) == 0 ? 0 : i10 + i11 | 0) | 0, i1 << 2 | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN7Terrain5FlushEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 228 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 240 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  do {
   i2 = i1 + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) __ZN12TreeRendererD2Ev(i3);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63616 | 0);
   HEAP32[i2 >> 2] = 0;
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) __ZN15TerrainRendererD2Ev(i3);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63616 | 0);
   HEAP32[i2 >> 2] = 0;
   i2 = i1 + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    __ZN14DetailRenderer7CleanupEv(i3);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i3 + 88 | 0, HEAP32[i3 + 92 >> 2] | 0);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i3 + 76 | 0, HEAP32[i3 + 80 >> 2] | 0);
    __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i3 + 64 | 0, HEAP32[i3 + 68 >> 2] | 0);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63616 | 0);
   HEAP32[i2 >> 2] = 0;
   i1 = i1 + 20 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i2 + ((HEAP32[i6 >> 2] | 0) * 20 | 0) | 0));
  i1 = i2;
 }
 i2 = i4 + 244 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4 + 232 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI16SubstanceArchiveE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN14AnimationState7SetTimeEf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0, f4 = f0, f6 = f0;
 HEAPF64[i5 + 16 >> 3] = +f1;
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 + 88 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + 92 >> 2]);
 L1 : do if (!(f4 <= f1)) {
  if (f3 > f1) {
   switch (i2 | 0) {
   case 1:
   case 8:
    {
     f1 = f3;
     break L1;
    }
   case 2:
    {
     f6 = Math_fround(f1 - f3);
     f1 = Math_fround(f4 - f3);
     f1 = Math_fround(f3 + Math_fround(f6 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f6 / f1))))));
     break L1;
    }
   default:
    {}
   }
   if ((i2 | 0) == 4) {
    f6 = Math_fround(f1 - f3);
    f4 = Math_fround(f4 - f3);
    f1 = Math_fround(f4 * Math_fround(2.0));
    f1 = Math_fround(Math_fround(f6 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f6 / f1))))) - f4);
    i2 = f1 < Math_fround(0.0);
    f6 = Math_fround(-f1);
    f1 = Math_fround(f3 + Math_fround(f4 - (i2 ? f6 : f1)));
   }
  }
 } else {
  switch (i2 | 0) {
  case 1:
  case 8:
   {
    f1 = f4;
    break L1;
   }
  case 2:
   {
    f6 = Math_fround(f1 - f3);
    f1 = Math_fround(f4 - f3);
    f1 = Math_fround(f3 + Math_fround(f6 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f6 / f1))))));
    break L1;
   }
  default:
   {}
  }
  if ((i2 | 0) == 4) {
   f6 = Math_fround(f1 - f3);
   f4 = Math_fround(f4 - f3);
   f1 = Math_fround(f4 * Math_fround(2.0));
   f1 = Math_fround(Math_fround(f6 - Math_fround(f1 * Math_fround(Math_floor(Math_fround(f6 / f1))))) - f4);
   i2 = f1 < Math_fround(0.0);
   f6 = Math_fround(-f1);
   f1 = Math_fround(f3 + Math_fround(f4 - (i2 ? f6 : f1)));
  }
 } while (0);
 HEAPF32[i5 + 12 >> 2] = f1;
 i5 = i5 + 56 | 0;
 HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -1537 | 512;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIccEEPcEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i1 >> 0] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i8 + 3 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 2 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i2, i1) | 0;
   i6 = i8 + 3 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP8[i6 >> 0] | 0;
    i4 = HEAP8[i2 >> 0] | 0;
    if (i5 << 24 >> 24 < i4 << 24 >> 24) {
     i3 = i6;
     while (1) {
      HEAP8[i3 >> 0] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -1 | 0;
      i4 = HEAP8[i3 >> 0] | 0;
      if (i5 << 24 >> 24 >= i4 << 24 >> 24) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP8[i2 >> 0] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 1 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 1 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIaaEEPaEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i1 >> 0] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i8 + 3 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 2 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i2, i1) | 0;
   i6 = i8 + 3 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP8[i6 >> 0] | 0;
    i4 = HEAP8[i2 >> 0] | 0;
    if (i5 << 24 >> 24 < i4 << 24 >> 24) {
     i3 = i6;
     while (1) {
      HEAP8[i3 >> 0] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -1 | 0;
      i4 = HEAP8[i3 >> 0] | 0;
      if (i5 << 24 >> 24 >= i4 << 24 >> 24) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP8[i2 >> 0] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 1 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 1 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj(i14, i2, i13, i1) {
 i14 = i14 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i15 + 4 | 0;
 i10 = i15;
 i11 = i14 + 396 | 0;
 i6 = HEAP32[i14 + 400 >> 2] | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 i7 = (HEAP32[i2 + 4 >> 2] | 0) - i12 >> 2;
 i9 = i13 - i1 + i6 + i7 | 0;
 if ((HEAP32[i14 + 404 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj(i11, i9);
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i11, i9 >>> 0 > i6 >>> 0 ? i9 : i6, i3);
 if ((i9 | 0) == (i6 | 0)) {
  i14 = i14 + 540 | 0;
  HEAP32[i14 >> 2] = 0;
  STACKTOP = i15;
  return;
 }
 i8 = HEAP32[i11 >> 2] | 0;
 i2 = i9 - i6 + i1 | 0;
 i5 = i2 >>> 0 > i1 >>> 0;
 i3 = i6 >>> 0 > i1 >>> 0;
 if (i5) if (i3) {
  i2 = i6;
  i3 = i9;
  do {
   i2 = i2 + -1 | 0;
   i3 = i3 + -1 | 0;
   HEAP32[i8 + (i3 << 2) >> 2] = HEAP32[i8 + (i2 << 2) >> 2];
  } while (i2 >>> 0 > i1 >>> 0);
  i4 = 9;
 } else i4 = 10; else if (i3) {
  i3 = i1;
  while (1) {
   HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i8 + (i3 << 2) >> 2];
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) {
    i4 = 9;
    break;
   } else i2 = i2 + 1 | 0;
  }
 }
 if ((i4 | 0) == 9) if (i5) i4 = 10;
 if ((i4 | 0) == 10) {
  i2 = i7 + i13 | 0;
  do {
   HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i12 + (i1 - i13 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i11, i9, i10);
 i14 = i14 + 540 | 0;
 HEAP32[i14 >> 2] = 0;
 STACKTOP = i15;
 return;
}

function __ZN5physx14SapPairManager10RemovePairEjj(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = i1 >>> 0 > i2 >>> 0;
 i7 = i5 ? i2 : i1;
 i5 = i5 ? i1 : i2;
 i6 = i5 << 16 | i7;
 i6 = i6 + ~(i6 << 15) | 0;
 i6 = (i6 >> 10 ^ i6) * 9 | 0;
 i6 = i6 >> 6 ^ i6;
 i6 = i6 + ~(i6 << 11) | 0;
 i9 = i11 + 36 | 0;
 i6 = HEAP32[i9 >> 2] & (i6 >> 16 ^ i6);
 i10 = i11 + 8 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i1 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2] | 0;
 if ((i1 | 0) == 1073741823) {
  i11 = 0;
  return i11 | 0;
 }
 i3 = HEAP32[i11 + 20 >> 2] | 0;
 i4 = i11 + 4 | 0;
 while (1) {
  i2 = i3 + (i1 << 3) | 0;
  if (!((HEAP32[i2 >> 2] | 0) != (i7 | 0) ? 1 : (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) != (i5 | 0))) break;
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == 1073741823) {
   i1 = 0;
   i8 = 13;
   break;
  }
 }
 if ((i8 | 0) == 13) return i1 | 0;
 if (!i2) {
  i11 = 0;
  return i11 | 0;
 }
 __ZN5physx14SapPairManager10RemovePairEjjjj(i11, 0, 0, i6, i1);
 i1 = HEAP32[i11 + 28 >> 2] | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = (i1 >>> 16 | i1) + 1 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i4 = HEAP32[i11 + 16 >> 2] | 0;
 i3 = i1 >>> 0 < i4 >>> 0;
 if (i3 & (i2 | 0) == (i4 | 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i1 = i3 ? i4 : i1;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i9 >> 2] = i1 + -1;
 if (i1 >>> 0 > i4 >>> 0) i1 = 1; else if (i1 >>> 0 > (HEAP32[i11 + 12 >> 2] | 0) >>> 2 >>> 0) i1 = i1 >>> 0 <= (HEAP32[i11 + 32 >> 2] | 0) >>> 2 >>> 0; else i1 = 1;
 __ZN5physx14SapPairManager12reallocPairsEb(i11, i1);
 i11 = 1;
 return i11 | 0;
}

function __ZN5physx14NpShapeManager17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 123684 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 123684 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 123684 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 123684 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 123684 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 123684 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 123684 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 123684 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 123716 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 123716 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 123716 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 123716 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 123716 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 123716 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 123716 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 123716 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 123748 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 123748 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 123748 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 123748 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 123748 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 123748 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 123748 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 123748 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4PPtrI15OcclusionPortalE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI15CapsuleColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN12TreeDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i5 = i8 + 16 | 0;
 i7 = i8 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 40 | 0;
 HEAP32[i9 >> 2] = i6;
 i12 = i10 + 16 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN12TreeInstance8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i5 - i1 >> 3;
 HEAP32[i9 >> 2] = i2;
 i3 = HEAP32[i12 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i12 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i13;
  return;
 }
 do {
  __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i12 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i13;
 return;
}

function __Z27GUIText_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 12 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i8) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i9, i3);
 i1 = i8 + 36 | 0;
 i7 = HEAP8[i9 + 11 >> 0] | 0;
 i4 = i7 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i9 >> 2] | 0 : i9;
 i7 = i4 ? HEAP32[i9 + 4 >> 2] | 0 : i7 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 44 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i7 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 40 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i7 - i5 | 0, i2, 0, i2, i7, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i8 + 40 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i4 >> 0] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
}

function _UNITY_LZ4_compress_continue(i5, i8, i6, i11) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i9 = i5 + 16392 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i12 = i5 + 16400 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i7 = i2 + i1 | 0;
 if (HEAP32[i5 + 16388 >> 2] | 0) {
  i12 = 0;
  return i12 | 0;
 }
 i10 = i5 + 16384 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 > 2147483648 ? 1 : i3 >>> 0 > ((i1 | 0) != 0 & i7 >>> 0 < i8 >>> 0 ? i7 : i8) >>> 0) {
  i2 = i3 + -65536 | 0;
  i1 = 0;
  do {
   i4 = i5 + (i1 << 2) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = i3 >>> 0 < i2 >>> 0 ? 0 : i3 - i2 | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4096);
  HEAP32[i10 >> 2] = 65536;
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 >>> 0 > 65536) {
   HEAP32[i12 >> 2] = 65536;
   i1 = 65536;
  }
  i2 = i7 + (0 - i1) | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = 65536;
 }
 i4 = i8 + i11 | 0;
 if (i4 >>> 0 < i7 >>> 0 & i4 >>> 0 > i2 >>> 0) {
  i1 = i7 - i4 | 0;
  i1 = i1 >>> 0 > 65536 ? 65536 : i1;
  i1 = i1 >>> 0 < 4 ? 0 : i1;
  HEAP32[i12 >> 2] = i1;
  HEAP32[i9 >> 2] = i7 + (0 - i1);
 }
 i1 = i1 >>> 0 < 65536 & i1 >>> 0 < i3 >>> 0;
 if ((i7 | 0) == (i8 | 0)) {
  if (i1) i1 = _LZ4_compress_generic(i5, i8, i6, i11, 0, 0, 1, 1, 1) | 0; else i1 = _LZ4_compress_generic(i5, i8, i6, i11, 0, 0, 1, 1, 0) | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i11;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i11;
  i12 = i1;
  return i12 | 0;
 } else {
  if (i1) i1 = _LZ4_compress_generic(i5, i8, i6, i11, 0, 0, 1, 2, 1) | 0; else i1 = _LZ4_compress_generic(i5, i8, i6, i11, 0, 0, 1, 2, 0) | 0;
  HEAP32[i9 >> 2] = i8;
  HEAP32[i12 >> 2] = i11;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i11;
  i12 = i1;
  return i12 | 0;
 }
 return 0;
}

function _cf2_glyphpath_lineTo(i6, i7, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i14 + 12 | 0;
 i4 = i14 + 8 | 0;
 i12 = i14;
 i13 = i6 + 11676 | 0;
 if (!((_cf2_hintmask_isNew(HEAP32[i13 >> 2] | 0) | 0) << 24 >> 24)) i11 = 0; else i11 = (HEAP8[i6 + 11665 >> 0] | 0) == 0 & 1;
 i8 = i6 + 11720 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i6 + 11724 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i7 | 0)) if (!(i11 << 24 >> 24 != 0 | (i2 | 0) != (i10 | 0))) {
  STACKTOP = i14;
  return;
 }
 _cf2_glyphpath_computeOffset(i6, i1, i2, i7, i10, i3, i4);
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i12 >> 2] = i3;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i5 + (HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i12 + 4 >> 2] = i1;
 i4 = i2 + i7 | 0;
 i5 = i5 + i10 | 0;
 i2 = i6 + 11667 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  _cf2_glyphpath_pushMove(i6, i3, i1);
  HEAP8[i2 >> 0] = 0;
  HEAP8[i6 + 11664 >> 0] = 1;
  i3 = i6 + 11712 | 0;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
 }
 i1 = i6 + 11744 | 0;
 if (HEAP8[i1 >> 0] | 0) _cf2_glyphpath_pushPrevElem(i6, i6 + 8 | 0, i12, i4, i5, 0);
 HEAP8[i1 >> 0] = 1;
 HEAP32[i6 + 11748 >> 2] = 2;
 i2 = i12;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = i6 + 11752 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = i3;
 i12 = i6 + 11760 | 0;
 HEAP32[i12 >> 2] = i4;
 HEAP32[i12 + 4 >> 2] = i5;
 if (i11 << 24 >> 24) _cf2_hintmap_build(i6 + 8 | 0, HEAP32[i6 + 11668 >> 2] | 0, HEAP32[i6 + 11672 >> 2] | 0, HEAP32[i13 >> 2] | 0, HEAP32[i6 + 11680 >> 2] | 0, 0);
 HEAP32[i8 >> 2] = i7;
 HEAP32[i9 >> 2] = i10;
 STACKTOP = i14;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN9Rigidbody12MovePositionERK8Vector3f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 28 | 0;
 i5 = i8;
 if (!(HEAP8[i3 + 84 >> 0] | 0)) {
  i7 = HEAP32[i3 + 52 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i10 + 88 >> 2] | 0;
  i9 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[i10 + 84 >> 2] | 0, i5 | 0, i7 | 0);
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = i9;
  HEAP32[i4 + 20 >> 2] = i2;
  HEAP32[i4 + 24 >> 2] = i3;
  mftCall_viii(i6 | 0, i7 | 0, i4 | 0, 1);
  STACKTOP = i8;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (HEAP8[i3 + 80 >> 0] | 0) {
  i2 = i3 + 52 | 0;
  i10 = HEAP32[i2 >> 2] | 0;
  if (!(mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 228 >> 2] | 0, i10 | 0, i5 | 0) | 0)) {
   i11 = HEAP32[i2 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i11 | 0);
   i11 = HEAP32[i4 + 4 >> 2] | 0;
   i9 = HEAP32[i4 + 8 >> 2] | 0;
   i10 = HEAP32[i4 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = i11;
   HEAP32[i5 + 8 >> 2] = i9;
   HEAP32[i5 + 12 >> 2] = i10;
  }
  HEAP32[i5 + 16 >> 2] = i6;
  HEAP32[i5 + 20 >> 2] = i7;
  HEAP32[i5 + 24 >> 2] = i1;
  i11 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 224 >> 2] | 0, i11 | 0, i5 | 0);
 }
 i11 = i3 + 104 | 0;
 HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & -2;
 STACKTOP = i8;
 return;
}

function __ZN4PPtrI14SphereColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI14PhysicMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI14ParticleSystemE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI14BillboardAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN18PlayableControllerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 88 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i3 = i1 + 120 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP8[i1 + 148 >> 0] = 1;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 2;
 HEAP8[i1 + 164 >> 0] = 0;
 HEAP8[i1 + 165 >> 0] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN15AudioReverbZone13SetFMODValuesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 80 | 0;
 i5 = i7;
 i6 = i4 + 116 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f8 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 __ZN4FMOD6Reverb15set3DAttributesEPK11FMOD_VECTORff(HEAP32[i6 >> 2] | 0, i1, f8, Math_fround(HEAPF32[i4 + 52 >> 2])) | 0;
 i1 = HEAP32[i4 + 56 >> 2] | 0;
 if ((i1 | 0) < 27) {
  i3 = i5;
  i1 = gb + 171848 + (i1 * 80 | 0) | 0;
  i2 = i3 + 80 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
 } else {
  i3 = i5;
  i1 = gb + 174008 | 0;
  i2 = i3 + 80 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 60 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 64 >> 2];
  HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 72 >> 2];
  HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 76 >> 2];
  HEAP32[i5 + 36 >> 2] = HEAP32[i4 + 80 >> 2];
  HEAP32[i5 + 40 >> 2] = HEAP32[i4 + 84 >> 2];
  HEAP32[i5 + 44 >> 2] = HEAP32[i4 + 88 >> 2];
  HEAP32[i5 + 48 >> 2] = HEAP32[i4 + 92 >> 2];
  HEAP32[i5 + 60 >> 2] = HEAP32[i4 + 96 >> 2];
  HEAP32[i5 + 68 >> 2] = HEAP32[i4 + 108 >> 2];
  HEAP32[i5 + 72 >> 2] = HEAP32[i4 + 112 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 68 >> 2];
  HEAP32[i5 + 64 >> 2] = HEAP32[i4 + 100 >> 2];
 }
 __ZN4FMOD6Reverb13setPropertiesEPK22FMOD_REVERB_PROPERTIES(HEAP32[i6 >> 2] | 0, i5) | 0;
 STACKTOP = i7;
 return;
}

function __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 i4 = i8 + 12 | 0;
 if (!i2) {
  __ZN13MonoBehaviour22DoScriptRebuildWarningEv(i1);
  STACKTOP = i8;
  return;
 }
 i5 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i2) | 0;
 do if (i5 | 0) {
  if (__ZNK10MonoScript13GetScriptTypeEv(i5) | 0) if ((__ZNK10MonoScript13GetScriptTypeEv(i5) | 0) != 1) if ((__ZNK10MonoScript13GetScriptTypeEv(i5) | 0) != 2) {
   HEAP32[i6 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i2) | 0;
   __Z6FormatPKcz(i4, gb + 588063 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 587199 | 0, 1617, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  }
  if (!(__ZN10MonoScript8GetClassEv(i5) | 0)) {
   HEAP32[i7 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i2) | 0;
   __Z6FormatPKcz(i4, gb + 588159 | 0, i7);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 587199 | 0, 1623, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  }
  HEAP32[i4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i1, i4, i3);
  STACKTOP = i8;
  return;
 } while (0);
 __ZN13MonoBehaviour35RebuildMonoInstanceFromScriptChangeEP11Il2CppClassP12Il2CppObject(i1, i2, i3);
 STACKTOP = i8;
 return;
}

function __Z21SourceMipLevelForBlitiiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i1 + -1 | 0;
 i7 = i7 >>> 16 | i7;
 i7 = i7 >>> 8 | i7;
 i7 = i7 >>> 4 | i7;
 i7 = i7 >>> 2 | i7;
 i7 = (i7 >>> 1 | i7) + 1 | 0;
 i8 = i7 >>> 0 > 65535;
 i7 = i8 ? i7 >>> 16 : i7;
 i8 = i8 ? 16 : 0;
 i5 = (i7 & 65280 | 0) == 0;
 i7 = i5 ? i7 : i7 >>> 8;
 i8 = i5 ? i8 : i8 | 8;
 i5 = (i7 & 240 | 0) == 0;
 i3 = i3 + -1 | 0;
 i3 = i3 >>> 16 | i3;
 i3 = i3 >>> 8 | i3;
 i3 = i3 >>> 4 | i3;
 i3 = i3 >>> 2 | i3;
 i3 = (i3 >>> 1 | i3) + 1 | 0;
 i6 = i3 >>> 0 > 65535;
 i3 = i6 ? i3 >>> 16 : i3;
 i6 = i6 ? 16 : 0;
 i1 = (i3 & 65280 | 0) == 0;
 i3 = i1 ? i3 : i3 >>> 8;
 i6 = i1 ? i6 : i6 | 8;
 i1 = (i3 & 240 | 0) == 0;
 i3 = (i5 ? i8 : i8 | 4) - (i1 ? i6 : i6 | 4) + (HEAP8[(i5 ? i7 : i7 >>> 4) + (gb + 936717) >> 0] | 0) - (HEAP8[(i1 ? i3 : i3 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
 i1 = i2 + -1 | 0;
 i1 = i1 >>> 16 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = (i1 >>> 1 | i1) + 1 | 0;
 i7 = i1 >>> 0 > 65535;
 i1 = i7 ? i1 >>> 16 : i1;
 i7 = i7 ? 16 : 0;
 i5 = (i1 & 65280 | 0) == 0;
 i1 = i5 ? i1 : i1 >>> 8;
 i7 = i5 ? i7 : i7 | 8;
 i5 = (i1 & 240 | 0) == 0;
 i4 = i4 + -1 | 0;
 i4 = i4 >>> 16 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = (i4 >>> 1 | i4) + 1 | 0;
 i6 = i4 >>> 0 > 65535;
 i4 = i6 ? i4 >>> 16 : i4;
 i6 = i6 ? 16 : 0;
 i2 = (i4 & 65280 | 0) == 0;
 i4 = i2 ? i4 : i4 >>> 8;
 i6 = i2 ? i6 : i6 | 8;
 i2 = (i4 & 240 | 0) == 0;
 i4 = (i5 ? i7 : i7 | 4) - (i2 ? i6 : i6 | 4) + (HEAP8[(i5 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) - (HEAP8[(i2 ? i4 : i4 >>> 4) + (gb + 936717) >> 0] | 0) | 0;
 i4 = (i3 | 0) < (i4 | 0) ? i4 : i3;
 return ((i4 | 0) > 0 ? i4 : 0) | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN8TypeTreeC2ERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 1;
 i8 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i2);
 i10 = i6;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i1 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i9 = i6;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i1 + 24 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 + (i2 * 24 | 0) + 2 >> 0] = 0;
 HEAP32[i1 + (i2 * 24 | 0) + 8 >> 2] = 0;
 HEAP32[i1 + (i2 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i1 + (i2 * 24 | 0) + 16 >> 2] = -1;
 HEAP8[i1 + (i2 * 24 | 0) + 3 >> 0] = 0;
 HEAP16[i1 + (i2 * 24 | 0) >> 1] = 1;
 HEAP32[i1 + (i2 * 24 | 0) + 20 >> 2] = 0;
 HEAP32[i1 + (i2 * 24 | 0) + 12 >> 2] = -1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i13, i12, i1) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i9 = i13 + 4 | 0;
 i10 = i13 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 i11 = i13 + 20 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i2 = i4 + i5 | 0;
 i6 = i1 + -1 | 0;
 i7 = ~i6;
 i1 = _i64Subtract(i6 + i2 & i7 | 0, 0, i2 | 0, 0) | 0;
 getTempRet0() | 0;
 i2 = HEAP32[i13 + 24 >> 2] | 0;
 if ((i5 + i12 + i1 | 0) >>> 0 <= i2 >>> 0) {
  i10 = i5;
  i8 = i4;
  i9 = i1;
  i13 = i10 + i9 | 0;
  i13 = i8 + i13 | 0;
  i12 = i9 + i12 | 0;
  i12 = i12 + i10 | 0;
  HEAP32[i11 >> 2] = i12;
  STACKTOP = i14;
  return i13 | 0;
 }
 i5 = i3 + 1 | 0;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i11 >> 2] = 0;
 i3 = i13 + 8 | 0;
 do if (i5 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14 + 4 | 0, i2, gb + 675773 | 0, 70) | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i13 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = i2 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i8) | 0;
   break;
  }
 } while (0);
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + (HEAP32[i10 >> 2] << 2) >> 2] | 0;
 i9 = i8;
 i9 = _i64Subtract(i6 + i9 & i7 | 0, 0, i9 | 0, 0) | 0;
 getTempRet0() | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i13 = i10 + i9 | 0;
 i13 = i8 + i13 | 0;
 i12 = i9 + i12 | 0;
 i12 = i12 + i10 | 0;
 HEAP32[i11 >> 2] = i12;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN4PPtrI13RenderTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI13MonoBehaviourE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN28LightProbeProxyVolumeManager12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 38596 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 37828 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 18 | 0)) {
    i4 = i6 + 37828 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 37828 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 37828 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 37828 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 37828 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 37828 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 37828 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = HEAP32[gb + 1110944 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  HEAP32[gb + 1110944 >> 2] = 0;
  return;
 }
 i2 = i1 + 20 | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) <= -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  HEAP32[gb + 1110944 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[gb + 1110944 >> 2] = 0;
 return;
}

function __ZN24GenerateTypeTreeTransfer12TransferBaseI15TerrainColliderEEvRT_17TransferMetaFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, HEAP32[gb + 67408 >> 2] | 0, gb + 1016757 | 0, i2, i3);
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 i5 = i2 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1016773 | 0, gb + 1016787 | 0, i5, 0);
 i6 = i7 + 8 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i1 + 16 | 0;
 i3 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1016805 | 0, HEAP32[gb + 36972 >> 2] | 0, i2 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN15FileSystemEntry3SetEPKc(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i4 = i5 + 1040 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 if ((i7 | 0) != (i5 | 0)) {
  i3 = i7 + 1040 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i7 | 0);
  _strncpy(i7, i5, 1040) | 0;
  HEAP8[i7 + 1039 >> 0] = 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 + 1044 >> 2] = HEAP32[i5 + 1044 >> 2];
  HEAP32[i7 + 1048 >> 2] = 0;
  HEAP32[i7 + 1052 >> 2] = 0;
  HEAP32[i7 + 1056 >> 2] = 0;
  i1 = i2;
  if (i2) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i7 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i5 | 0);
 }
 _strncpy(i7, i6, 1040) | 0;
 HEAP8[i7 + 1039 >> 0] = 0;
 __Z24ConvertSeparatorsToUnityPc(i7);
 i3 = HEAP32[gb + 1179016 >> 2] | 0;
 i4 = i3 + 16 | 0;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 while (1) {
  if (!i2) break;
  i2 = i2 + -1 | 0;
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i6 | 0) | 0) {
   i8 = 12;
   break;
  }
 }
 if ((i8 | 0) == 12) {
  i8 = HEAP32[i1 >> 2] | 0;
  i8 = i8 + 60 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i8 | 0, i1 | 0, i7 | 0);
  STACKTOP = i9;
  return;
 }
 i8 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i6 = i6 + 60 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(i6 | 0, i8 | 0, i7 | 0);
 STACKTOP = i9;
 return;
}

function __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 32 | 0;
 i7 = i11 + 28 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11;
 i3 = i11 + 24 | 0;
 i12 = i11 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 i1 = __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObjectPP15Il2CppException(i6, i10, i2, i3) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0;
 if ((i1 | 0) != 0 & i3) {
  i12 = i9;
  HEAP32[i12 >> 2] = i4;
  HEAP32[i12 + 4 >> 2] = i5;
  i12 = (__Z14GetMonoManagerv() | 0) + 44 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  if (__Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses(i10, i12) | 0) {
   HEAP32[i7 >> 2] = 0;
   i12 = i8;
   HEAP32[i12 >> 2] = i4;
   HEAP32[i12 + 4 >> 2] = i5;
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i6, i1, i10, i7) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } else i1 = 0;
  i12 = i1;
  STACKTOP = i11;
  return i12 | 0;
 } else {
  if (i3) {
   i12 = 0;
   STACKTOP = i11;
   return i12 | 0;
  }
  __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i2, HEAP32[i6 + 4 >> 2] | 0, 0);
  i12 = 0;
  STACKTOP = i11;
  return i12 | 0;
 }
 return 0;
}

function __ZL19makeDetailEdgeSlabsPfPKfii(i4, i5, i6, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i7 = 0, f8 = f0;
 i3 = i6 + -1 | 0;
 i2 = i5 + (i3 * 3 << 2) | 0;
 switch (i1 | 4 | 0) {
 case 4:
  {
   i1 = (i6 | 0) > 0;
   if (Math_fround(HEAPF32[i5 + 8 >> 2]) < Math_fround(HEAPF32[i2 + 8 >> 2])) {
    if (i1) i1 = 0; else return;
    do {
     i2 = i1 * 3 | 0;
     i3 = i1 << 1;
     HEAP32[i4 + (i3 << 2) >> 2] = HEAP32[i5 + (i2 + 2 << 2) >> 2];
     HEAP32[i4 + ((i3 | 1) << 2) >> 2] = HEAP32[i5 + (i2 + 1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
    return;
   } else {
    if (i1) i1 = 0; else return;
    do {
     i7 = (i3 - i1 | 0) * 3 | 0;
     i2 = i1 << 1;
     HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i5 + (i7 + 2 << 2) >> 2];
     HEAP32[i4 + ((i2 | 1) << 2) >> 2] = HEAP32[i5 + (i7 + 1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
    return;
   }
  }
 case 6:
  {
   f8 = Math_fround(HEAPF32[i5 >> 2]);
   i1 = (i6 | 0) > 0;
   if (f8 < Math_fround(HEAPF32[i2 >> 2])) {
    if (i1) i1 = 0; else return;
    do {
     i3 = i1 * 3 | 0;
     i7 = i1 << 1;
     HEAP32[i4 + (i7 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
     HEAP32[i4 + ((i7 | 1) << 2) >> 2] = HEAP32[i5 + (i3 + 1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
    return;
   } else {
    if (i1) i1 = 0; else return;
    do {
     i2 = (i3 - i1 | 0) * 3 | 0;
     i7 = i1 << 1;
     HEAP32[i4 + (i7 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
     HEAP32[i4 + ((i7 | 1) << 2) >> 2] = HEAP32[i5 + (i2 + 1 << 2) >> 2];
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i6 | 0));
    return;
   }
  }
 default:
  {
   if ((i6 | 0) <= 0) return;
   _memset(i4 | 0, 0, i6 << 3 | 0) | 0;
   return;
  }
 }
}

function __Z48TerrainData_CUSTOM_INTERNAL_CALL_SetTreeInstanceP12Il2CppObjectiRK12TreeInstance(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i3 = i8;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i2 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i1 + 100 | 0;
 if ((i6 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 944884 | 0, i3);
 i9 = HEAP32[i2 >> 2] | 0;
 i1 = i9;
 if ((((HEAP32[i2 + 4 >> 2] | 0) - i9 | 0) / 40 | 0) >>> 0 <= i6 >>> 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 944884 | 0, i3);
 if ((HEAP32[i7 + 32 >> 2] | 0) != (HEAP32[i1 + (i6 * 40 | 0) + 32 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937666 | 0, i8 + 8 | 0);
 f10 = Math_fround(HEAPF32[i7 >> 2]);
 if (f10 != Math_fround(HEAPF32[i1 + (i6 * 40 | 0) >> 2])) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937700 | 0, i4);
 f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 if (f10 != Math_fround(HEAPF32[i1 + (i6 * 40 | 0) + 4 >> 2])) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937700 | 0, i4);
 f10 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 if (f10 != Math_fround(HEAPF32[i1 + (i6 * 40 | 0) + 8 >> 2])) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937700 | 0, i4);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN12TreeDatabase7SetTreeEiRK12TreeInstance(i1 + 84 | 0, i6, i7);
  STACKTOP = i8;
  return;
 }
}

function __Z18ExtractTagThrowingR11ICallString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i8 = i11 + 48 | 0;
 i9 = i11 + 16 | 0;
 if (__ZNK11ICallString6IsNullEv(i1) | 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 514703 | 0, i11);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i1);
 i4 = __Z13GetTagManagerv() | 0;
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i9 + 24 | 0;
 i3 = gb + 63648 | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i6 = i8 + 11 | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i12 = i3 << 24 >> 24 < 0;
 i2 = i12 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i12 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 > 15) {
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i9 >> 2] = i12;
  HEAP32[i9 + 4 >> 2] = i3;
  i1 = (i12 | 0) == 0 ? i1 : i12;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i5 >> 2] = i3;
 i1 = __ZN10TagManager11StringToTagERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i9) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i9 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 if ((i1 | 0) == -1) {
  HEAP32[i10 >> 2] = (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 514827 | 0, i10);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i12, i3, i1) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + -1 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = i9 + 2127912214 + (i9 << 12) | 0;
 i1 = i1 ^ -949894596 ^ i1 >>> 19;
 i1 = i1 + 374761393 + (i1 << 5) | 0;
 i1 = i1 + -744332180 ^ i1 << 9;
 i1 = i1 + -42973499 + (i1 << 3) | 0;
 i1 = (i1 ^ -1252372727 ^ i1 >>> 16) & i10;
 i7 = HEAP32[i3 + 28 >> 2] | 0;
 i8 = HEAP32[i3 + 20 >> 2] | 0;
 i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
 L1 : do if ((i8 | 0) == (i2 | 0)) i11 = 6; else {
  i6 = i3 + 12 | 0;
  L3 : do if (!(HEAP8[i3 + 8 >> 0] | 0)) {
   i3 = 0;
   while (1) {
    if ((i9 | 0) == (i2 | 0)) break L3;
    i3 = i3 + 1 | 0;
    i1 = i3 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
    if ((i8 | 0) == (i2 | 0)) {
     i11 = 6;
     break L1;
    }
   }
  } else {
   i5 = (HEAP32[i3 + 4 >> 2] | 0) == 0;
   i3 = -1;
   i4 = 0;
   do {
    if (i5) i11 = 13; else if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) i3 = (i3 | 0) == -1 ? i1 : i3; else i11 = 13;
    if ((i11 | 0) == 13) {
     i11 = 0;
     if ((i9 | 0) == (i2 | 0)) break L3;
    }
    i4 = i4 + 1 | 0;
    i1 = i4 + i1 & i10;
    i2 = HEAP32[i7 + (i1 << 3) >> 2] | 0;
   } while ((i8 | 0) != (i2 | 0));
   HEAP32[i12 >> 2] = -1;
   i2 = i12 + 4 | 0;
   if ((i3 | 0) == -1) break L1;
   HEAP32[i2 >> 2] = i3;
   return;
  } while (0);
  HEAP32[i12 >> 2] = i1;
  HEAP32[i12 + 4 >> 2] = -1;
  return;
 } while (0);
 if ((i11 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i2 = i12 + 4 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN7mecanim24CreateValueArrayConstantEPjjRNS_6memory9AllocatorE(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
 i4 = i11 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i11 >> 2] = i10;
 i5 = (i10 | 0) == 0;
 if (i5) {
  HEAP32[i4 >> 2] = 0;
  return i11 | 0;
 }
 i3 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i10 * 12 | 0, 4) | 0;
 i2 = i3 + (i10 * 12 | 0) | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i1 = i4;
  i2 = i3 | 0 ? i3 - i1 | 0 : 0;
  HEAP32[i4 >> 2] = i2;
 } else {
  i1 = i3;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 10;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i4;
  i2 = i3 | 0 ? i3 - i1 | 0 : 0;
  HEAP32[i4 >> 2] = i2;
  if (i5) return i11 | 0;
 }
 i8 = i2 + i1 | 0;
 i1 = 0;
 i2 = 0;
 i3 = 0;
 i4 = 0;
 i5 = 0;
 i6 = 0;
 i7 = 0;
 do {
  i12 = i9 + (i7 << 2) | 0;
  HEAP32[i8 + (i7 * 12 | 0) + 4 >> 2] = HEAP32[i12 >> 2];
  switch (HEAP32[i12 >> 2] | 0) {
  case 6:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i6;
    i6 = i6 + 1 | 0;
    break;
   }
  case 7:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i5;
    i5 = i5 + 1 | 0;
    break;
   }
  case 8:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i4;
    i4 = i4 + 1 | 0;
    break;
   }
  case 1:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i3;
    i3 = i3 + 1 | 0;
    break;
   }
  case 3:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i2;
    i2 = i2 + 1 | 0;
    break;
   }
  case 4:
  case 9:
   {
    HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = i1;
    i1 = i1 + 1 | 0;
    break;
   }
  default:
   {}
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (i10 | 0));
 return i11 | 0;
}

function __ZN4PPtrI12MeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN19RenderEventsContext19RemoveCommandBufferEiP22RenderingCommandBuffer(i1, i2, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i12 = i11 + (i2 * 20 | 0) | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i11 = i11 + (i2 * 20 | 0) + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i5 = i4 + (i1 << 2) | 0;
 if (!i1) return;
 i10 = i14 + 4 | 0;
 if (!i14) {
  i7 = i4;
  i2 = i4;
  L5 : while (1) {
   i4 = i7;
   i7 = i7 + 4 | 0;
   i6 = i7;
   while (1) {
    if (HEAP32[i4 >> 2] | 0) break;
    _memmove(i4 | 0, i7 | 0, i5 - i6 | 0) | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
    i2 = HEAP32[i12 >> 2] | 0;
    i1 = HEAP32[i11 >> 2] | 0;
    i5 = i2 + (i1 << 2) | 0;
    if ((i4 | 0) == (i5 | 0)) {
     i1 = 9;
     break L5;
    }
   }
   i5 = i2 + (i1 << 2) | 0;
   if ((i7 | 0) == (i5 | 0)) {
    i1 = 9;
    break;
   }
  }
  if ((i1 | 0) == 9) return;
 } else {
  i13 = i4;
  i9 = i1;
  i8 = i4;
  i3 = i5;
 }
 L14 : while (1) {
  i4 = i13;
  i13 = i13 + 4 | 0;
  i5 = i13;
  i1 = i8;
  i2 = i9;
  while (1) {
   if ((HEAP32[i4 >> 2] | 0) != (i14 | 0)) break;
   _memmove(i4 | 0, i13 | 0, i3 - i5 | 0) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   if (!(HEAP32[i10 >> 2] | 0)) mftCall_vi(HEAP32[(HEAP32[i14 >> 2] | 0) + 4 >> 2] | 0, i14 | 0);
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i1 + (i2 << 2) | 0;
   if ((i4 | 0) == (i3 | 0)) {
    i1 = 9;
    break L14;
   }
  }
  i3 = i1 + (i2 << 2) | 0;
  if ((i13 | 0) == (i3 | 0)) {
   i1 = 9;
   break;
  } else {
   i9 = i2;
   i8 = i1;
  }
 }
 if ((i1 | 0) == 9) return;
}

function __ZN16TimerQueriesGLES17BeginTimerQueriesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 564 | 0;
 if (HEAP8[i5 >> 0] | 0) return;
 i6 = i4 + 540 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 + 528 + (i2 << 2) >> 2] | 0;
 if (!i1) {
  i3 = __Znwj(32) | 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = gb + 77312 + 8;
  HEAP8[i3 + 12 >> 0] = 0;
  i1 = HEAP32[gb + 1098256 + 512 >> 2] | 0;
  if (!i1) {
   mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 792 >> 2] | 0, 128, gb + 1098256 | 0);
   HEAP32[gb + 1098256 + 512 >> 2] = 128;
   i1 = 128;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i1 = i1 + -1 | 0;
  HEAP32[gb + 1098256 + 512 >> 2] = i1;
  HEAP32[i3 + 16 >> 2] = HEAP32[gb + 1098256 + (i1 << 2) >> 2];
  HEAP32[i4 + 528 + (i2 << 2) >> 2] = i3;
  i2 = HEAP32[i4 + 528 + (HEAP32[i6 >> 2] << 2) >> 2] | 0;
 } else i2 = i1;
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 1) | 0;
 getTempRet0() | 0;
 mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 784 >> 2] | 0, 35007, HEAP32[i2 + 16 >> 2] | 0);
 HEAP32[gb + 1098256 + 560 >> 2] = (HEAP32[gb + 1098256 + 560 >> 2] | 0) + 1;
 i3 = i2 + 4 | 0;
 if ((i3 | 0) != (gb + 1098256 + 544 | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i2 + 8 | 0; else {
   i4 = i2 + 8 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
   HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = i4;
  }
  i4 = HEAP32[gb + 1098256 + 544 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = gb + 1098256 + 544;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 }
 i4 = i2 + 24 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i6 >> 2] = ((HEAP32[i6 >> 2] | 0) + 1 | 0) % 3 | 0;
 HEAP8[i5 >> 0] = 1;
 return;
}

function __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i7 + 1550 | 0;
 i3 = i7 + 1552 | 0;
 if (!i8) return; else i6 = i1;
 while (1) {
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = (i4 | 0) < 4;
  if (!(HEAP8[i2 >> 0] | 0)) {
   i1 = 3;
   break;
  }
  if (!i5) {
   i1 = 10;
   break;
  }
  if ((i4 | 0) != 1) {
   i1 = 9;
   break;
  }
  if (__ZN12TLSAllocatorI14StackAllocatorE13TryDeallocateEPv(HEAP32[i3 >> 2] | 0, i8) | 0) {
   i1 = 21;
   break;
  } else i6 = gb + 64032 | 0;
 }
 if ((i1 | 0) == 3) {
  if (i5) {
   i6 = i7 + 1564 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  }
  __ZN13MemoryManager10DeallocateEPv(i7, i8);
  return;
 } else if ((i1 | 0) == 9) {
  i7 = HEAP32[i7 + 3824 + (i4 * 24 | 0) >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, i8 | 0);
  return;
 } else if ((i1 | 0) == 10) {
  if ((i4 + -57 | 0) >>> 0 < 2) i2 = 0; else if (!(__Z31profiler_get_memory_record_modev() | 0)) i2 = 0; else {
   __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1188384 | 0, 0);
   i2 = gb + 1188384 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) < 128) i1 = HEAP32[i7 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
   i1 = HEAP32[i7 + 1764 + (i1 + -128 << 2) >> 2] | 0;
   i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
  }
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i8 | 0) | 0) {
   __ZN13MemoryManager20RegisterDeallocationEPvRK10MemLabelIdPKc(i7, i8, i6, gb + 582331 | 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i8 | 0);
  } else __ZN13MemoryManager10DeallocateEPv(i7, i8);
  if (!i2) return;
  __Z12profiler_endP19ProfilerInformation(i2);
  return;
 } else if ((i1 | 0) == 21) return;
}

function __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1120 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = i7 + 1096 | 0;
 i3 = i7 + 36 | 0;
 i4 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 i8 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i2, i8, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = i2 + 11 | 0;
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if (__ZNK15FileSystemEntry6ExistsEv(i3) | 0) {
  i8 = __ZNK15FileSystemEntry5IsDirEv(i3) | 0;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i7;
  return i8 | 0;
 }
 if (__ZN15FileSystemEntry11CreateAsDirEv(i3) | 0) {
  i8 = 1;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i7;
  return i8 | 0;
 }
 i9 = (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 __ZNK10FileSystem16LastErrorMessageEv(i4, __Z13GetFileSystemv() | 0);
 i1 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 __ZNK10FileSystem16CurrentDirectoryEv(i5, __Z13GetFileSystemv() | 0);
 i8 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 HEAP32[i6 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i8;
 _printf_console(gb + 488540 | 0, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i8 = 0;
 __ZN13FileEntryDataD2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i7;
 return i8 | 0;
}

function _write_frame_header(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 68 | 0;
 i5 = i10 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i1 = 0;
  i2 = 0;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i1 = (_emit_dqt(i10, HEAP32[i3 + 16 >> 2] | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) >= (i4 | 0)) {
    i7 = i1;
    break;
   } else i3 = i3 + 84 | 0;
  }
 } else {
  i7 = 0;
  i4 = i1;
 }
 i6 = i10 + 177 | 0;
 i5 = i10 + 212 | 0;
 i1 = (HEAP8[i5 >> 0] | 0) == 0;
 L6 : do if (!(HEAP8[i6 >> 0] | 0)) {
  L8 : do if (i1) {
   do if ((HEAP32[i10 + 56 >> 2] | 0) == 8) {
    if ((i4 | 0) > 0) {
     i1 = 1;
     i3 = 0;
     i2 = HEAP32[i8 >> 2] | 0;
     while (1) {
      if ((HEAP32[i2 + 20 >> 2] | 0) > 1) i9 = 12; else if ((HEAP32[i2 + 24 >> 2] | 0) > 1) i9 = 12;
      if ((i9 | 0) == 12) {
       i9 = 0;
       i1 = 0;
      }
      i3 = i3 + 1 | 0;
      if ((i3 | 0) >= (i4 | 0)) break; else i2 = i2 + 84 | 0;
     }
    } else i1 = 1;
    if ((i7 | 0) == 0 | i1 << 24 >> 24 == 0) {
     if (!(i1 << 24 >> 24)) break;
     _emit_sof(i10, 192);
     return;
    } else {
     i1 = HEAP32[i10 >> 2] | 0;
     HEAP32[i1 + 20 >> 2] = 75;
     mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i10 | 0, 0);
     i1 = (HEAP8[i5 >> 0] | 0) != 0;
     if (!(HEAP8[i6 >> 0] | 0)) if (i1) break L8; else break; else if (i1) {
      i9 = 17;
      break L6;
     } else {
      i9 = 18;
      break L6;
     }
    }
   } while (0);
   _emit_sof(i10, 193);
   return;
  } while (0);
  _emit_sof(i10, 194);
  return;
 } else if (i1) i9 = 18; else i9 = 17; while (0);
 if ((i9 | 0) == 17) {
  _emit_sof(i10, 202);
  return;
 } else if ((i9 | 0) == 18) {
  _emit_sof(i10, 201);
  return;
 }
}

function __ZN4PPtrI11TerrainDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI11Rigidbody2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI11NavMeshDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI11LightProbesE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN20TextRenderingPrivate17TextMeshGenerator14GarbageCollectEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i10 = i12;
 i11 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
 i2 = HEAP32[gb + 1467756 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i11 - (HEAP32[i3 + 108 >> 2] | 0) | 0) > 5) {
   if ((HEAP16[gb + 1467908 + 6 >> 1] | 0) > -1) {
    HEAP32[i10 >> 2] = 0;
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467908 | 0, i9);
    i8 = gb + 1467908 | 0;
   } else i8 = 0;
   if (i3 | 0) {
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) __Z19DestroySingleObjectP6Object(i2);
    i2 = i3 + 88 | 0;
    if ((HEAP32[i3 + 104 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 92 | 0);
     HEAP32[i2 >> 2] = 0;
    }
    __ZN11UTF16StringD2Ev(i3 + 68 | 0);
    __ZdlPv(i3);
   }
   i7 = HEAP32[gb + 1467756 >> 2] | 0;
   i5 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
   i2 = i5 + 4 | 0;
   i7 = i7 + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = i3 - i2 | 0;
   i6 = i4 >> 2;
   if (i6) {
    _memmove(i5 | 0, i2 | 0, i4 | 0) | 0;
    i3 = HEAP32[i7 >> 2] | 0;
   }
   i2 = i5 + (i6 << 2) | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i7 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
   if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
  }
  if (!i1) break;
  i2 = HEAP32[gb + 1467756 >> 2] | 0;
 }
 STACKTOP = i12;
 return;
}

function __ZN13UnityProfiler11SetIsActiveEb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 if (i4) {
  i2 = (HEAP32[i3 + 72 >> 2] | 0) + 248 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) return;
 i5 = i3 + 4 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + (i4 ? 1 : -1) | 0;
 HEAP32[i5 >> 2] = i1;
 if (!((i1 | 0) == 1 | i4 ^ 1)) return;
 if (i4) i1 = i3 + 2 | 0; else {
  if (i1 | 0) return;
  i1 = i3 + 2 | 0;
  if (i2 & 16711680) {
   d9 = +_emscripten_get_now() * 1.0e6;
   i7 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i5 = i3 + 48 | 0;
   i6 = i5;
   i6 = _i64Subtract(~~d9 >>> 0 | 0, i7 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0) | 0;
   i6 = __Z17TimeToNanosecondsy(i6, getTempRet0() | 0) | 0;
   i7 = getTempRet0() | 0;
   i2 = i3 + 40 | 0;
   i8 = i2;
   i7 = _i64Add(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i6 | 0, i7 | 0) | 0;
   i6 = getTempRet0() | 0;
   HEAP32[i2 >> 2] = i7;
   HEAP32[i2 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
  }
 }
 HEAP8[i1 >> 0] = i4 & 1;
 __ZN22UnityProfilerPerThread11SetIsActiveEb(HEAP32[i3 + 72 >> 2] | 0, i4);
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 656 >> 2] | 0, i8 | 0, 2, i4 & 1 | 0);
 if (!i4) return;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 d9 = +_emscripten_get_now() * 1.0e6;
 i7 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i8 = i3 + 48 | 0;
 HEAP32[i8 >> 2] = ~~d9 >>> 0;
 HEAP32[i8 + 4 >> 2] = i7;
 return;
}

function __Z35UnregisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = HEAP32[gb + 1163040 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1163040 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1163040 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 1163040 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i7 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i7;
   HEAP32[gb + 1163040 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, gb + 1163040 + 4 | 0, i1, gb + 1163040 + 16 | 0, gb + 1163040 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i7 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i7;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1163040 >> 2] = i1;
   break;
  }
 } while (0);
 i5 = i1 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 if (!i7) return; else {
  i4 = i5;
  i3 = i7;
 }
 L9 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i6 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L9;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i4 = i2;
   break;
  } else i4 = i2;
 }
 if ((i4 | 0) == (i5 | 0)) return;
 if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 > i6 >>> 0) return;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) {
  i3 = i4;
  while (1) {
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
  }
 } else while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) break; else i2 = i3;
 }
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) HEAP32[i1 >> 2] = i2;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i7, i4);
 __ZdlPv(i4);
 return;
}

function __ZNK21EnlightenSceneMapping22GetTerrainInstanceHashEi(i10, i9, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i9 + 112 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i6 = HEAP32[i9 + 100 >> 2] | 0;
  i7 = HEAP32[i9 + 20 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = 0;
  while (1) {
   i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
   i4 = HEAP32[i7 + (i3 * 56 | 0) >> 2] | 0;
   if ((HEAP32[i2 + (i4 * 40 | 0) >> 2] | 0) == (i8 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  if ((i3 | 0) < 0) i1 = 0; else i1 = (HEAP32[i9 + 32 >> 2] | 0) >>> 0 > i3 >>> 0 ? i2 + (i4 * 40 | 0) | 0 : 0;
  i9 = i1 + 24 | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  return;
 } while (0);
 i2 = HEAP32[i9 + 124 >> 2] | 0;
 i6 = HEAP32[i9 + 128 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i7 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i7 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i8 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i7 | 0 : i7;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i8 | 0)) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 + (i2 * 40 | 0) | 0) {
   i9 = i1 + (i2 * 40 | 0) + 24 | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   return;
  }
 };
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 return;
}

function __ZN5physx3Scb5Shape18setMaterialsHelperEPKPNS_10PxMaterialEt(i8, i7, i5) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i1 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i4 = i5 & 65535;
 if (i5 << 16 >> 16 == 1) {
  HEAP16[i1 >> 1] = HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2];
  __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt(i8 + 16 | 0, i1, 1);
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i4 << 1;
 i10 = i1 >>> 0 > 1024;
 i3 = i6 + 4 | 0;
 HEAP8[i3 >> 0] = i10 & 1;
 if (i10) {
  i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i9 + 18 | 0, i1, gb + 689994 | 0, 32) | 0;
  HEAP32[i6 >> 2] = i1;
  if (!i1) {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 16, gb + 689994 | 0, 41, gb + 690074 | 0, i2);
   if (!(HEAP8[i3 >> 0] | 0)) {
    i10 = 0;
    STACKTOP = i9;
    return i10 | 0;
   }
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
   i10 = 0;
   STACKTOP = i9;
   return i10 | 0;
  }
 } else {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * (i4 << 1) | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  HEAP32[i6 >> 2] = i1;
 }
 if (i5 << 16 >> 16) {
  i2 = 0;
  do {
   HEAP16[i1 + (i2 << 1) >> 1] = HEAP32[(HEAP32[i7 + (i2 << 2) >> 2] | 0) + 52 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt(i8 + 16 | 0, i1, i5);
 if (!(HEAP8[i3 >> 0] | 0)) {
  i10 = 1;
  STACKTOP = i9;
  return i10 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 i10 = 1;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 2048 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 __ZN5physx11PxcLtbSolveERKNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPNS_14PxcSIMDSpatialE(i2, i1, i4);
 i1 = i2 + 8 | 0;
 if (!(HEAP16[i1 >> 1] | 0)) {
  STACKTOP = i5;
  return;
 } else i2 = 0;
 do {
  i6 = i3 + (i2 << 5) | 0;
  f11 = Math_fround(HEAPF32[i6 >> 2]);
  i8 = i3 + (i2 << 5) + 4 | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  i10 = i3 + (i2 << 5) + 8 | 0;
  f12 = Math_fround(HEAPF32[i10 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + (i2 << 5) >> 2]);
  f13 = Math_fround(HEAPF32[i4 + (i2 << 5) + 4 >> 2]);
  f13 = Math_fround(f9 - f13);
  f12 = Math_fround(f12 - Math_fround(HEAPF32[i4 + (i2 << 5) + 8 >> 2]));
  HEAPF32[i6 >> 2] = Math_fround(f11 - f7);
  HEAPF32[i8 >> 2] = f13;
  HEAPF32[i10 >> 2] = f12;
  HEAPF32[i3 + (i2 << 5) + 12 >> 2] = Math_fround(0.0);
  i10 = i3 + (i2 << 5) + 16 | 0;
  f12 = Math_fround(HEAPF32[i10 >> 2]);
  i8 = i3 + (i2 << 5) + 20 | 0;
  f13 = Math_fround(HEAPF32[i8 >> 2]);
  i6 = i3 + (i2 << 5) + 24 | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + (i2 << 5) + 16 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + (i2 << 5) + 20 >> 2]);
  f9 = Math_fround(f13 - f9);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i4 + (i2 << 5) + 24 >> 2]));
  HEAPF32[i10 >> 2] = Math_fround(f12 - f11);
  HEAPF32[i8 >> 2] = f9;
  HEAPF32[i6 >> 2] = f7;
  HEAPF32[i3 + (i2 << 5) + 28 >> 2] = Math_fround(0.0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAPU16[i1 >> 1] | 0) >>> 0);
 STACKTOP = i5;
 return;
}

function __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN9Scripting38RuntimeCreateAndInitObjectLogExceptionEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 48 | 0;
 i7 = i8 + 8 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = 0;
 i1 = __Z51scripting_object_new_and_invoke_default_constructorP11Il2CppClassPP15Il2CppException(i1, i2) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = i6;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __Z30scripting_stack_trace_info_forP15Il2CppExceptionR14StackTraceInfo(i2, i6);
 i2 = i7 + 20 | 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i5 = i6 + 12 | 0;
 HEAP32[i7 + 4 >> 2] = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i6 + 24 | 0;
 HEAP32[i7 + 8 >> 2] = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 36 >> 2];
 HEAP32[i7 + 16 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i7 + 24 >> 2] = 131332;
 HEAP32[i7 + 28 >> 2] = 0;
 __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN9Rigidbody25SetCollisionDetectionModeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i1 + 96 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i1 + 92 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 i5 = i1 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 i2 = gb + 63160 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i4 << 2;
 do if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i1 | 3;
  if (i3 >>> 0 < 2e3) {
   i2 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i3 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   i1 = 0;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 732812 | 0, 1489) | 0;
   i3 = gb + 64016 | 0;
   i9 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   i2 = i6;
   HEAP32[i2 >> 2] = i9;
   HEAP32[i2 + 4 >> 2] = i3;
   i2 = i1;
   break;
  }
 } while (0);
 i2 = i2 + 3 & -4;
 i9 = HEAP32[i5 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 108 >> 2] | 0, i9 | 0, i2 | 0, i4 | 0, 0) | 0;
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   i9 = HEAP32[(HEAP32[i2 + (i1 << 2) >> 2] | 0) + 8 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 156 >> 2] | 0, i9 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZN4crnd28crnd_get_segmented_file_sizeEPKvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i1 | 0) == 0 | i2 >>> 0 < 74) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | 0) != 18552) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
 if (i3 >>> 0 < 74) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAPU8[i1 + 7 >> 0] | 0) << 16 | (HEAPU8[i1 + 6 >> 0] | 0) << 24 | (HEAPU8[i1 + 8 >> 0] | 0) << 8 | (HEAPU8[i1 + 9 >> 0] | 0)) >>> 0 > i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = ((HEAPU8[i1 + 37 >> 0] | 0) << 8 | (HEAPU8[i1 + 36 >> 0] | 0) << 16 | (HEAPU8[i1 + 38 >> 0] | 0)) + ((HEAPU8[i1 + 34 >> 0] | 0) << 8 | (HEAPU8[i1 + 33 >> 0] | 0) << 16 | (HEAPU8[i1 + 35 >> 0] | 0)) | 0;
 i3 = i3 >>> 0 > i2 >>> 0 ? i3 : i2;
 i2 = ((HEAPU8[i1 + 45 >> 0] | 0) << 8 | (HEAPU8[i1 + 44 >> 0] | 0) << 16 | (HEAPU8[i1 + 46 >> 0] | 0)) + ((HEAPU8[i1 + 42 >> 0] | 0) << 8 | (HEAPU8[i1 + 41 >> 0] | 0) << 16 | (HEAPU8[i1 + 43 >> 0] | 0)) | 0;
 i2 = i3 >>> 0 > i2 >>> 0 ? i3 : i2;
 i3 = ((HEAPU8[i1 + 53 >> 0] | 0) << 8 | (HEAPU8[i1 + 52 >> 0] | 0) << 16 | (HEAPU8[i1 + 54 >> 0] | 0)) + ((HEAPU8[i1 + 50 >> 0] | 0) << 8 | (HEAPU8[i1 + 49 >> 0] | 0) << 16 | (HEAPU8[i1 + 51 >> 0] | 0)) | 0;
 i3 = i2 >>> 0 > i3 >>> 0 ? i2 : i3;
 i2 = ((HEAPU8[i1 + 61 >> 0] | 0) << 8 | (HEAPU8[i1 + 60 >> 0] | 0) << 16 | (HEAPU8[i1 + 62 >> 0] | 0)) + ((HEAPU8[i1 + 58 >> 0] | 0) << 8 | (HEAPU8[i1 + 57 >> 0] | 0) << 16 | (HEAPU8[i1 + 59 >> 0] | 0)) | 0;
 i2 = i3 >>> 0 > i2 >>> 0 ? i3 : i2;
 i3 = ((HEAPU8[i1 + 65 >> 0] | 0) << 8 | (HEAPU8[i1 + 66 >> 0] | 0)) + ((HEAPU8[i1 + 68 >> 0] | 0) << 8 | (HEAPU8[i1 + 67 >> 0] | 0) << 16 | (HEAPU8[i1 + 69 >> 0] | 0)) | 0;
 i3 = i2 >>> 0 > i3 >>> 0 ? i2 : i3;
 return i3 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = 0; else {
  i4 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP16[i6 + 8 >> 1] = 0;
  HEAP8[i6 + 10 >> 0] = 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 4 | 0, 4) | 0;
  i2 = i4 + (i1 << 4) | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i1 = i4;
   do {
    HEAP32[i1 >> 2] = -1;
    i10 = i1 + 4 | 0;
    HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP16[i10 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
    HEAP8[i10 + 10 >> 0] = HEAP8[i6 + 10 >> 0] | 0;
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i3 >> 2] = i4 | 0 ? i4 - i3 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i10 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i10 << 4) | 0;
 if (!i10) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = i6 + 20 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i7 = i6 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i6 + 172 >> 2] | 0;
  if (!i1) {
   i4 = i6 + 176 | 0;
   HEAP32[i4 >> 2] = fb + 186;
   HEAP32[i4 + 4 >> 2] = 0;
   i4 = i6 + 184 | 0;
   HEAP32[i4 >> 2] = fb + 3676;
   HEAP32[i4 + 4 >> 2] = 0;
   i4 = 6;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, 0);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    i2 = 0;
    i5 = 1;
   } else {
    i2 = i1;
    i4 = 6;
   }
  }
  if ((i4 | 0) == 6) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i5 = 0; else {
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
    i5 = 0;
   }
  }
  HEAP32[i3 >> 2] = 0;
  i1 = HEAP32[i6 + 208 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 4 | 0);
  __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackERNS_15PxErrorCallbackE((__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 116 | 0, i2 + 12 | 0);
  i4 = i6 + 164 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = i6 + 160 | 0;
   i3 = 0;
   do {
    i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, i2 | 0);
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  if (!i5) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i1 >> 2];
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i8, i1);
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i8, HEAP32[i6 + 24 >> 2] | 0, HEAP32[i5 + 28 >> 2] | 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i10;
 return;
}

function _UNITY_tt_face_get_ps_name(i5, i2, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i6 = 35;
  return i6 | 0;
 }
 if ((HEAPU16[i5 + 264 >> 1] | 0) >>> 0 <= i2 >>> 0) {
  i6 = 16;
  return i6 | 0;
 }
 i1 = HEAP32[i5 + 536 >> 2] | 0;
 if (!i1) {
  i6 = 7;
  return i6 | 0;
 }
 i3 = i5 + 612 | 0;
 i4 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[i4 >> 2] | 0, 0) | 0;
 i1 = HEAP32[i5 + 468 >> 2] | 0;
 if ((i1 | 0) < 131072) {
  switch (i1 | 0) {
  case 65536:
   break;
  default:
   {
    i6 = 0;
    return i6 | 0;
   }
  }
  if (i2 >>> 0 >= 258) {
   i6 = 0;
   return i6 | 0;
  }
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[i4 >> 2] | 0, i2 | 0) | 0;
  i6 = 0;
  return i6 | 0;
 }
 if ((i1 | 0) >= 163840) {
  switch (i1 | 0) {
  case 163840:
   break;
  default:
   {
    i6 = 0;
    return i6 | 0;
   }
  }
  if (!(HEAP8[i3 >> 0] | 0)) if (_load_post_names(i5) | 0) {
   i6 = 0;
   return i6 | 0;
  }
  if ((HEAPU16[i5 + 616 >> 1] | 0) >>> 0 <= i2 >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[i4 >> 2] | 0, (HEAP8[(HEAP32[i5 + 620 >> 2] | 0) + i2 >> 0] | 0) + i2 | 0) | 0;
  i6 = 0;
  return i6 | 0;
 }
 switch (i1 | 0) {
 case 131072:
  break;
 default:
  {
   i6 = 0;
   return i6 | 0;
  }
 }
 if (!(HEAP8[i3 >> 0] | 0)) if (_load_post_names(i5) | 0) {
  i6 = 0;
  return i6 | 0;
 }
 if ((HEAPU16[i5 + 616 >> 1] | 0) >>> 0 <= i2 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = HEAP16[(HEAP32[i5 + 620 >> 2] | 0) + (i2 << 1) >> 1] | 0;
 i1 = i3 & 65535;
 if ((i3 & 65535) < 258) {
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[i4 >> 2] | 0, i1 | 0) | 0;
  i6 = 0;
  return i6 | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[(HEAP32[i5 + 624 >> 2] | 0) + (i1 + -258 << 2) >> 2];
  i6 = 0;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) - i1 >> 4 >>> 0 >= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i1 >> 4;
 HEAP32[i7 + 12 >> 2] = 0;
 i6 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = 34;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i7 >> 2] = i2;
 i10 = i2 + (i1 << 4) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i10;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 << 4);
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i8);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  HEAP32[i8 >> 2] = 34;
  HEAP32[i8 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) - i1 >> 4 >>> 0 >= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i2 = i3 + 12 | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i1 >> 4;
 HEAP32[i7 + 12 >> 2] = 0;
 i6 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i4) i2 = 0; else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = 12;
  HEAP32[i8 + 4 >> 2] = i2;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 4, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
 }
 HEAP32[i7 >> 2] = i2;
 i10 = i2 + (i1 << 4) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i10;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 << 4);
 __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i8 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i8);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  HEAP32[i8 >> 2] = 12;
  HEAP32[i8 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 STACKTOP = i9;
 return;
}

function __ZN9Animation14SampleInternalEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 if ((HEAP16[gb + 1465212 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465212 | 0, i3);
  i8 = gb + 1465212 | 0;
 } else i8 = 0;
 __ZN9Animation19ValidateBoundCurvesEv(i7);
 i2 = i7 + 252 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  if (i1 & 1) {
   __ZN9Animation25RebuildStateForEverythingEv(i7);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (i1 & 2 | 0) {
   __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(HEAP32[i7 + 104 >> 2] | 0, HEAP32[i7 + 108 >> 2] | 0, i3);
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -3;
   HEAP32[i7 + 248 >> 2] = 0;
  }
 }
 if (HEAP32[i7 + 96 >> 2] | 0) {
  if (__ZN9Animation21RebuildBoundStateMaskEv(i7) | 0) {
   if (HEAP32[i7 + 248 >> 2] | 0) __ZN9Animation14BlendOptimizedEv(i7);
  } else __ZN9Animation12BlendGenericEv(i7);
  __ZN9Animation13BlendAdditiveEv(i7);
  i4 = HEAP8[i7 + 41 >> 0] | 0 ? 32 : 0;
  i5 = i7 + 48 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = (HEAP32[i7 + 52 >> 2] | 0) - i1 | 0;
  i6 = i2 >> 2;
  if ((i2 | 0) > 0) {
   i3 = i7 + 64 | 0;
   __ZN9Transform20SendTransformChangedEi(HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | i4);
   if ((i2 | 0) > 4) {
    i1 = 1;
    do {
     __ZN9Transform20SendTransformChangedEi(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0, HEAP32[i3 >> 2] | i4);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i6 | 0));
   }
  }
 }
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i9;
 return;
}

function __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i2 = i8;
 i7 = i8 + 4 | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401092 | 0, 0, gb + 400980 | 0, 213, 1, 0, 0, 0);
   STACKTOP = i8;
   return;
  }
  if ((HEAP16[gb + 1157796 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157796 | 0, i4);
   i1 = gb + 1157796 | 0;
  } else i1 = 0;
  i2 = __Z12GetGfxDevicev() | 0;
  i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 840 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  mftCall_viiii(i9 | 0, i2 | 0, i5 | 0, i4 | 0, i6 | 0);
  if (HEAP8[i2 + 3896 >> 0] | 0) {
   i9 = i2 + 3644 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = i2 + 3648 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = i2 + 3656 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = i2 + 3652 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   i9 = i2 + 3640 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  }
  __Z15gpu_time_samplev();
  if (!i1) {
   STACKTOP = i8;
   return;
  }
  __Z12profiler_endP19ProfilerInformation(i1);
  STACKTOP = i8;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 401050 | 0, 0, gb + 400980 | 0, 208, 1, 0, 0, 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Ext21InertiaTensorComputer11setCylinderEiff(i6, i5, f2, f1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0;
 f3 = Math_fround(Math_fround(Math_fround(f2 * Math_fround(3.14159274)) * f2) * Math_fround(f1 * Math_fround(2.0)));
 f4 = Math_fround(Math_fround(Math_fround(f2 * f2) * f3) * Math_fround(.5));
 f1 = Math_fround(Math_fround(f3 * Math_fround(Math_fround(Math_fround(f2 * Math_fround(3.0)) * f2) + Math_fround(Math_fround(f1 * Math_fround(4.0)) * f1))) / Math_fround(12.0));
 switch (i5 | 0) {
 case 0:
  {
   HEAPF32[i6 + 48 >> 2] = f3;
   HEAPF32[i6 >> 2] = f4;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f1;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f1;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 case 1:
  {
   HEAPF32[i6 + 48 >> 2] = f3;
   HEAPF32[i6 >> 2] = f1;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f4;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f1;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 default:
  {
   HEAPF32[i6 + 48 >> 2] = f3;
   HEAPF32[i6 >> 2] = f1;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
   HEAPF32[i6 + 16 >> 2] = f1;
   HEAP32[i6 + 20 >> 2] = 0;
   HEAP32[i6 + 24 >> 2] = 0;
   HEAP32[i6 + 28 >> 2] = 0;
   HEAPF32[i6 + 32 >> 2] = f4;
   HEAP32[i6 + 36 >> 2] = 0;
   HEAP32[i6 + 40 >> 2] = 0;
   HEAP32[i6 + 44 >> 2] = 0;
   return;
  }
 }
}

function __ZN5physx28solveParallelCouloumFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj(i15, i29, i34, i9, i7, i31, i8, i5, i4, i12, i13, i17, i18, i25, i26, i27, i23, i24, i22, i32, i33, i21, i20, i11, i19, i6, i1, i28, i14, i16, i3, i2, i30, i10) {
 i15 = i15 | 0;
 i29 = i29 | 0;
 i34 = i34 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i31 = i31 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i11 = i11 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i30 = i30 | 0;
 i10 = i10 | 0;
 __ZN5physx18PxsDynamicsContext20solveParallelCoulombEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEES12_PPNS_12PxsRigidBodyEj(i15, i29, i34, i9, i7, i31, i8, i5, i4, i12, i13, i17, i18, i25, i26, i27, i23, i24, i22, i32, i33, i21, i20, i11, i19, 0, i1, i28, i14, i16, i3, i2, i30, i10);
 return;
}

function __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI9AudioClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN2UI14CanvasRenderer13SyncTransformENS0_8SyncFlagEb(i7, i6, i9) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 64 | 0;
 i10 = i11;
 if ((HEAP16[gb + 1468048 + 6 >> 1] | 0) > -1) {
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468048 | 0, i1);
  i8 = gb + 1468048 | 0;
 } else i8 = 0;
 __ZNK9Transform21GetLocalToWorldMatrixEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i2 = i7 + 204 | 0;
 __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_(HEAP32[i2 >> 2] | 0, i1, i10);
 if (i6 & 1 | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i7 + 208 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i9) {
   i5 = i1 + 112 | 0;
   HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 2;
  }
  i1 = i3 + (i2 * 672 | 0) + 484 | 0;
  i4 = i10;
  i5 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   i1 = i1 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i1 | 0) < (i5 | 0));
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (i6 & 2 | 0) {
  i1 = HEAP32[i7 + 220 >> 2] | 0;
  i2 = HEAP32[i7 + 224 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i9) {
   i9 = i1 + 112 | 0;
   HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 2;
  }
  i1 = i3 + (i2 * 672 | 0) + 484 | 0;
  i4 = i10;
  i5 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   i1 = i1 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i1 | 0) < (i5 | 0));
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!i8) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i11;
 return;
}

function __ZN22ProceduralMaterialData20RemoveTextureRawDataEj(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i6 + 76 | 0;
 i5 = i6 + 80 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 } else {
  i3 = i5;
  i2 = i1;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i3 | 0) == (i5 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
  }
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) HEAP32[i8 >> 2] = i1;
 i8 = i6 + 88 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 80 >> 2] | 0, i3);
 i8 = HEAP32[i6 + 84 >> 2] | 0;
 HEAP32[i7 >> 2] = 77;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN20dynamic_block_vectorI14FileIdentifierE22push_back_no_constructEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = (i1 >>> 0) / (i2 >>> 0) | 0;
 i11 = (i1 >>> 0) % (i2 >>> 0) | 0;
 i12 = i8 + 16 | 0;
 i13 = i8 + 28 | 0;
 if ((i10 | 0) != (HEAP32[i13 >> 2] | 0)) {
  i13 = i12;
  i12 = i1;
  i12 = i12 + 1 | 0;
  HEAP32[i9 >> 2] = i12;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + (i10 << 2) | 0;
  i13 = HEAP32[i13 >> 2] | 0;
  i13 = i13 + (i11 * 36 | 0) | 0;
  return i13 | 0;
 }
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 36 | 0, 16, i8 + 8 | 0, 0, gb + 588751 | 0, 94) | 0;
 i3 = HEAP32[i13 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i12 >> 2] | 0, i1 << 2, 4, i8 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i12 >> 2] | 0, HEAP32[i13 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i12 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i13 >> 2] = i4;
 HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] = i2;
 i13 = i12;
 i12 = HEAP32[i9 >> 2] | 0;
 i12 = i12 + 1 | 0;
 HEAP32[i9 >> 2] = i12;
 i13 = HEAP32[i13 >> 2] | 0;
 i13 = i13 + (i10 << 2) | 0;
 i13 = HEAP32[i13 >> 2] | 0;
 i13 = i13 + (i11 * 36 | 0) | 0;
 return i13 | 0;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E11set_deletedER30dense_hashtable_const_iteratorIS9_S7_SB_SJ_SE_SH_E(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 L1 : do if (!(HEAP8[i9 + 8 >> 0] | 0)) i1 = 1; else if (!(HEAP32[i9 + 4 >> 2] | 0)) i1 = 1; else {
  i3 = i9 + 12 | 0;
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i5 = i2 << 24 >> 24 < 0;
  i2 = i2 & 255;
  i6 = i5 ? HEAP32[i9 + 16 >> 2] | 0 : i2;
  i8 = HEAP8[i1 + 11 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  if ((i6 | 0) == ((i4 ? HEAP32[i1 + 4 >> 2] | 0 : i8 & 255) | 0)) {
   i7 = HEAP32[i3 >> 2] | 0;
   i8 = i5 ? i7 : i3;
   i1 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
   i4 = (i6 | 0) == 0;
   if (i5) {
    if (i4) {
     i1 = 0;
     break;
    }
    i1 = (_memcmp(i8, i1, i6) | 0) != 0;
    break;
   }
   if (i4) i1 = 0; else if ((i7 & 255) << 24 >> 24 == (HEAP8[i1 >> 0] | 0)) while (1) {
    i2 = i2 + -1 | 0;
    i3 = i3 + 1 | 0;
    if (!i2) {
     i1 = 0;
     break L1;
    }
    i1 = i1 + 1 | 0;
    if ((HEAP8[i3 >> 0] | 0) != (HEAP8[i1 >> 0] | 0)) {
     i1 = 1;
     break;
    }
   } else i1 = 1;
  } else i1 = 1;
 } while (0);
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = i8 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i9 + 12 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i10, i9 + 24 | 0);
 return i1 | 0;
}

function __ZN14SphereCollider9SetRadiusEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i7 = i4 + 60 | 0;
 if (Math_fround(HEAPF32[i7 >> 2]) != f1) HEAPF32[i7 >> 2] = f1;
 i2 = i4 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 i9 = i6 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, i6 | 0) | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f10 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 i5 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 f1 = i5 ? f12 : f1;
 i5 = f11 < Math_fround(0.0);
 f12 = Math_fround(-f11);
 f11 = i5 ? f12 : f11;
 i5 = f10 < Math_fround(0.0);
 f12 = Math_fround(-f10);
 f10 = i5 ? f12 : f10;
 f1 = f1 < f11 ? f11 : f1;
 f1 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * (f1 < f10 ? f10 : f1));
 i7 = f1 < Math_fround(0.0);
 f10 = Math_fround(-f1);
 f1 = i7 ? f10 : f1;
 i7 = f1 < Math_fround(9.99999974e-06);
 HEAPF32[i9 >> 2] = i7 ? Math_fround(9.99999974e-06) : f1;
 i7 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i6 | 0);
 __ZN8Collider32RigidbodyMassDistributionChangedEv(i4);
 STACKTOP = i8;
 return;
}

function __Z8WrapTimefRKNSt3__24pairIffEEi(f3, i1, i4) {
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i4 = i4 | 0;
 var f2 = f0, f5 = f0, f6 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f2 <= f3) switch (i4 | 0) {
 case 2:
  {
   f6 = Math_fround(f3 - f5);
   f3 = Math_fround(f2 - f5);
   f5 = Math_fround(f5 + Math_fround(f6 - Math_fround(f3 * Math_fround(Math_floor(Math_fround(f6 / f3))))));
   return Math_fround(f5);
  }
 case 1:
 case 8:
  {
   f6 = f2;
   return Math_fround(f6);
  }
 default:
  {
   if ((i4 | 0) != 4) {
    f6 = f3;
    return Math_fround(f6);
   }
   f3 = Math_fround(f3 - f5);
   f2 = Math_fround(f2 - f5);
   f6 = Math_fround(f2 * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f3 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f3 / f6))))) - f2);
   i4 = f6 < Math_fround(0.0);
   f3 = Math_fround(-f6);
   f6 = Math_fround(f5 + Math_fround(f2 - (i4 ? f3 : f6)));
   return Math_fround(f6);
  }
 }
 if (!(f5 > f3)) {
  f6 = f3;
  return Math_fround(f6);
 }
 switch (i4 | 0) {
 case 2:
  {
   f3 = Math_fround(f3 - f5);
   f6 = Math_fround(f2 - f5);
   f6 = Math_fround(f5 + Math_fround(f3 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f3 / f6))))));
   return Math_fround(f6);
  }
 case 1:
 case 8:
  {
   f6 = f5;
   return Math_fround(f6);
  }
 default:
  {
   if ((i4 | 0) != 4) {
    f6 = f3;
    return Math_fround(f6);
   }
   f3 = Math_fround(f3 - f5);
   f2 = Math_fround(f2 - f5);
   f6 = Math_fround(f2 * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f3 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f3 / f6))))) - f2);
   i4 = f6 < Math_fround(0.0);
   f3 = Math_fround(-f6);
   f6 = Math_fround(f5 + Math_fround(f2 - (i4 ? f3 : f6)));
   return Math_fround(f6);
  }
 }
 return f0;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 24) | 0;
 i2 = i1 + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = (i2 - i1 | 0) / 24 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) do {
  __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fjPS2_ji(i4, i1, i13, i2, i14, i15) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i16 = 0, i17 = 0, i18 = 0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0;
 if ((i15 | 0) <= 0) return;
 i16 = i4 + 16 | 0;
 i17 = i4 + 32 | 0;
 i18 = i4 + 48 | 0;
 i5 = i4 + 4 | 0;
 i6 = i4 + 20 | 0;
 i7 = i4 + 36 | 0;
 i8 = i4 + 52 | 0;
 i9 = i4 + 8 | 0;
 i10 = i4 + 24 | 0;
 i11 = i4 + 40 | 0;
 i12 = i4 + 56 | 0;
 i3 = 0;
 while (1) {
  f21 = Math_fround(HEAPF32[i4 >> 2]);
  f23 = Math_fround(HEAPF32[i1 >> 2]);
  f21 = Math_fround(f21 * f23);
  f20 = Math_fround(HEAPF32[i16 >> 2]);
  f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f20 = Math_fround(f21 + Math_fround(f20 * f22));
  f21 = Math_fround(HEAPF32[i17 >> 2]);
  f19 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f21 = Math_fround(f20 + Math_fround(f21 * f19));
  f21 = Math_fround(Math_fround(HEAPF32[i18 >> 2]) + f21);
  f20 = Math_fround(f23 * Math_fround(HEAPF32[i5 >> 2]));
  f20 = Math_fround(f20 + Math_fround(f22 * Math_fround(HEAPF32[i6 >> 2])));
  f20 = Math_fround(f20 + Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2])));
  f20 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f20);
  f23 = Math_fround(f23 * Math_fround(HEAPF32[i9 >> 2]));
  f22 = Math_fround(f23 + Math_fround(f22 * Math_fround(HEAPF32[i10 >> 2])));
  f19 = Math_fround(f22 + Math_fround(f19 * Math_fround(HEAPF32[i11 >> 2])));
  f19 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f19);
  HEAPF32[i2 >> 2] = f21;
  HEAPF32[i2 + 4 >> 2] = f20;
  HEAPF32[i2 + 8 >> 2] = f19;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i15 | 0)) break; else {
   i1 = i1 + i13 | 0;
   i2 = i2 + i14 | 0;
  }
 }
 return;
}

function __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((((HEAP32[i10 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i8 + 12 | 0;
 i9 = i8 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  i3 = i1;
  i6 = i2;
 } else {
  i5 = HEAP32[i11 >> 2] | 0;
  HEAP32[i12 >> 2] = 73;
  HEAP32[i12 + 4 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 * 20 | 0, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + (((i1 - i2 | 0) / 20 | 0) * 20 | 0) | 0;
 i7 = i1;
 i5 = i5 + (i4 * 20 | 0) | 0;
 if ((i3 | 0) == (i6 | 0)) {
  i2 = i7;
  i4 = i3;
  i1 = i3;
 } else {
  i2 = i7;
  do {
   i3 = i3 + -20 | 0;
   __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + -20 | 0, i3);
   i1 = i2 + -20 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i6 | 0));
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i10 >> 2] = i5;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1;
  i1 = i1 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i12 >> 2] = 73;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i12);
 STACKTOP = i13;
 return;
}

function __ZNK7VRInput16GetEyeSeparationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0;
 i11 = HEAP32[i1 + 40 >> 2] | 0;
 f10 = Math_fround(-Math_fround(HEAPF32[i11 + 12 >> 2]));
 f7 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f2 = Math_fround(f7 * Math_fround(-2.0));
 f4 = Math_fround(f9 * Math_fround(-2.0));
 f6 = Math_fround(f2 * f10);
 f10 = Math_fround(f4 * f10);
 f5 = Math_fround(f2 * f8);
 f8 = Math_fround(f8 * f4);
 f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(-Math_fround(f7 * f2)) - Math_fround(f9 * f4)));
 f4 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * f4);
 f8 = Math_fround(f6 - f8);
 f4 = Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i11 + 4 >> 2])) + f4);
 f5 = Math_fround(f10 + f5);
 f4 = Math_fround(Math_fround(f5 * Math_fround(HEAPF32[i11 + 8 >> 2])) + f4);
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 f5 = Math_fround(-Math_fround(HEAPF32[i1 + 12 >> 2]));
 f10 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f9 = Math_fround(f10 * Math_fround(-2.0));
 f2 = Math_fround(f8 * Math_fround(-2.0));
 f7 = Math_fround(f9 * f5);
 f5 = Math_fround(f2 * f5);
 f3 = Math_fround(f9 * f6);
 f6 = Math_fround(f6 * f2);
 f2 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(-Math_fround(f10 * f9)) - Math_fround(f8 * f2)));
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 f6 = Math_fround(f7 - f6);
 f2 = Math_fround(Math_fround(f6 * Math_fround(HEAPF32[i1 + 4 >> 2])) + f2);
 f3 = Math_fround(f5 + f3);
 return Math_fround(Math_abs(Math_fround(f4 - Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i1 + 8 >> 2])) + f2))));
}

function __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = i6 + 8 | 0;
 i4 = i5 + 8 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i5 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 < 4) i7 = 4; else {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i5 >> 2] >> 0] | 0;
   i8 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i1 + 1 >> 0] = HEAP8[i8 >> 0] | 0;
   i8 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i1 + 2 >> 0] = HEAP8[i8 >> 0] | 0;
   i8 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i1 + 3 >> 0] = HEAP8[i8 >> 0] | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) HEAP8[i4 >> 0] = 1;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i5, gb + 660697 | 0, i6, i3);
 i1 = i6 + 12 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i5 + 4 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) i7 = 7; else {
   HEAP8[i1 >> 0] = HEAP8[HEAP32[i5 >> 2] >> 0] | 0;
   i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
   HEAP32[i5 >> 2] = i1;
   i8 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
   HEAP32[i2 >> 2] = i8;
   if (!((HEAP8[i4 >> 0] | 0) != 0 | (i8 | 0) == 0)) {
    HEAP8[i6 + 13 >> 0] = HEAP8[i1 >> 0] | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
    return;
   }
  }
 } else i7 = 7;
 if ((i7 | 0) == 7) HEAP8[i4 >> 0] = 1;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN5physx7NpActor17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 122724 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 122724 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 122724 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 122724 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 122724 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 122724 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 122724 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 122724 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 122756 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 122756 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 122756 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 122756 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 122756 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 122756 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 122756 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 122756 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122788 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122788 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122788 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122788 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122788 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122788 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122788 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122788 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i4 = 0; else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, (i9 << 4) + 19 | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i4 = 0; else {
   i4 = i1 + 19 & -16;
   HEAP32[i4 + -4 >> 2] = i4 - i1;
  }
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i6 << 4) | 0;
 if ((i6 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + (i6 << 4) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + (i6 << 4) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + (i6 << 4) + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i7 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i8 >> 2] = i9;
  i10 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i10 = i4 + (i7 << 4) | 0;
  return i10 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i8 >> 2] = i9;
 i10 = i7 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i10 = i4 + (i7 << 4) | 0;
 return i10 | 0;
}

function __ZN4PPtrI8RendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i10, i9, i2) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 32 | 0;
 i7 = i11 + 24 | 0;
 i3 = i11 + 16 | 0;
 i4 = i11 + 8 | 0;
 i5 = i11;
 HEAP32[i9 >> 2] = 0;
 i6 = HEAP32[i10 + 208 >> 2] | 0;
 if (!i6) i1 = HEAP32[i10 + 212 >> 2] | 0; else i1 = i6;
 i12 = i10 + 200 | 0;
 i15 = i12;
 i16 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i3;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i16;
 i13 = HEAP32[i10 + 220 >> 2] | 0;
 i16 = i10 + 224 | 0;
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i14 = i4;
 HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i14 + 4 >> 2] = i15;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i7 = __Z19mono_profiler_begin21ScriptingMethodIl2CppP11Il2CppClassS_P12Il2CppObject(i7, i13, i8, i6) | 0;
 i3 = i12;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i2 = __Z23scripting_method_invoke21ScriptingMethodIl2CppP12Il2CppObjectR18ScriptingArgumentsPP15Il2CppExceptionb(i8, i1, i10, i9, i2) | 0;
 __Z17mono_profiler_endi(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i16 = i2;
  STACKTOP = i11;
  return i16 | 0;
 }
 if (!(HEAP8[i10 + 233 >> 0] | 0)) {
  i16 = 0;
  STACKTOP = i11;
  return i16 | 0;
 }
 __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i1, HEAP32[i10 + 216 >> 2] | 0, 0);
 i16 = 0;
 STACKTOP = i11;
 return i16 | 0;
}

function __Z29Sprite_Get_Custom_PropTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK21GLESRenderTargetSetupltERKS_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) {
  i6 = i4 >>> 0 < i1 >>> 0;
  return i6 | 0;
 }
 L5 : do if (i4 | 0) {
  i3 = 0;
  while (1) {
   i1 = HEAP32[i5 + 4 + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[i6 + 4 + (i3 << 2) >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i3 = 6;
    break;
   }
   i1 = HEAP32[i5 + 36 + (i3 << 2) >> 2] | 0;
   i2 = HEAP32[i6 + 36 + (i3 << 2) >> 2] | 0;
   i3 = i3 + 1 | 0;
   if ((i1 | 0) != (i2 | 0)) {
    i3 = 8;
    break;
   }
   if (i3 >>> 0 >= i4 >>> 0) break L5;
  }
  if ((i3 | 0) == 6) {
   i6 = i1 >>> 0 < i2 >>> 0;
   return i6 | 0;
  } else if ((i3 | 0) == 8) {
   i6 = i1 >>> 0 < i2 >>> 0;
   return i6 | 0;
  }
 } while (0);
 i1 = HEAP8[i5 + 92 >> 0] | 0;
 i2 = HEAP8[i6 + 92 >> 0] | 0;
 if (i1 << 24 >> 24 != i2 << 24 >> 24) {
  i6 = (i1 & 255) < (i2 & 255);
  return i6 | 0;
 }
 if (i1 << 24 >> 24) {
  i1 = HEAP32[i5 + 72 >> 2] | 0;
  i2 = HEAP32[i6 + 72 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i6 = i1 >>> 0 < i2 >>> 0;
   return i6 | 0;
  }
  i1 = HEAP32[i5 + 68 >> 2] | 0;
  i2 = HEAP32[i6 + 68 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i6 = i1 >>> 0 < i2 >>> 0;
   return i6 | 0;
  }
  i1 = HEAP32[i5 + 76 >> 2] | 0;
  i2 = HEAP32[i6 + 76 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) {
   i6 = i1 >>> 0 < i2 >>> 0;
   return i6 | 0;
  }
 }
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 i2 = HEAP32[i6 + 80 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i6 = i1 >>> 0 < i2 >>> 0;
  return i6 | 0;
 }
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 i2 = HEAP32[i6 + 84 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return (HEAP32[i5 + 88 >> 2] | 0) < (HEAP32[i6 + 88 >> 2] | 0) | 0;
 i6 = (i1 | 0) < (i2 | 0);
 return i6 | 0;
}

function __ZN9SubModule14SubEmitterData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619747 | 0, gb + 619620 | 0, i1, 0);
 i7 = i8 + 8 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, i6, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i7 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047471 | 0, i6, i8, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1008162 | 0, i6, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN11AudioSourceD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 175316 + 8;
 i1 = i3 + 464 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 468 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 432 >> 2] = 0;
 HEAP32[i3 + 428 >> 2] = 0;
 i1 = i3 + 356 | 0;
 if ((HEAP32[i3 + 372 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 360 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 268 | 0;
 if ((HEAP32[i3 + 284 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 272 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 180 | 0;
 if ((HEAP32[i3 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 92 | 0;
 if ((HEAP32[i3 + 108 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 175500 + 8;
  HEAP32[i3 >> 2] = gb + 37748 + 8;
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 96 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 175500 + 8;
 HEAP32[i3 >> 2] = gb + 37748 + 8;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10GameObject22RemoveComponentAtIndexEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i9 = i2 + 28 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 i6 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i8 = i2 + 40 | 0;
 _memmove(i3 | 0, i5 | 0, i4 + (HEAP32[i8 >> 2] << 3) - i5 | 0) | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 29020;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = i6;
 __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1105276 | 0, i7);
 i7 = i2 + 60 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 if (HEAP32[i2 + 56 >> 2] & 16 | 0) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 } else {
  i5 = i3;
  i2 = 0;
  i4 = i3;
 }
 do {
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  if (i3) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0) | 0;
   i2 = HEAP32[i7 >> 2] | i2;
   HEAP32[i7 >> 2] = i2;
   i4 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i5 = i5 + 8 | 0;
 } while ((i5 | 0) != (i4 + (i1 << 3) | 0));
 if ((i6 | 0) == (i2 | 0) | (i1 | 0) == 0) {
  STACKTOP = i10;
  return;
 } else {
  i5 = i4;
  i3 = i4;
 }
 while (1) {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  if (!i2) i2 = i3; else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, HEAP32[i7 >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i5 = i5 + 8 | 0;
  if ((i5 | 0) == (i2 + (i1 << 3) | 0)) break; else i3 = i2;
 }
 STACKTOP = i10;
 return;
}

function __ZN4PPtrI6SpriteE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI6CameraE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI6AvatarE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i4;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j(i5, i1);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  if (i4 >>> 0 > i5 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i4;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i5 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 24 | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > i5 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i4;
  }
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 3;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 3) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESI_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN4PPtrI5FlareE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = i7 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i9 - i1 >> 3;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 2 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 2);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 2 | 0;
  i5 = i3 + 2 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP16[i3 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP32[i11 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 2);
   i5 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i12;
 return;
}

function __ZN13SliderJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, i7 = 0;
 __ZN15AnchoredJoint2D16CheckConsistencyEv(i2);
 i1 = i2 + 100 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f6 < Math_fround(-1.0e6);
 i5 = f6 > Math_fround(1.0e6);
 f6 = i5 ? Math_fround(1.0e6) : f6;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(-1.0e6) : f6;
 i1 = i2 + 104 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i5 = f6 > Math_fround(1.0e6);
 f6 = i5 ? Math_fround(1.0e6) : f6;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f6;
 i1 = i2 + 108 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f6 < Math_fround(-1.0e6);
 i5 = f6 > Math_fround(1.0e6);
 f6 = i5 ? Math_fround(1.0e6) : f6;
 f6 = i4 ? Math_fround(-1.0e6) : f6;
 HEAPF32[i1 >> 2] = f6;
 i1 = i2 + 112 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 f3 = i4 ? Math_fround(-1.0e6) : f3;
 HEAPF32[i1 >> 2] = f3 < f6 ? f6 : f3;
 i1 = i2 + 96 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i7 = gb + 1162356 | 0;
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i2 + 84 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0) return;
 i4 = gb + 1162356 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i5, gb + 1037665 | 0, 0);
 HEAP32[i5 >> 2] = gb + 188456 + 8;
 i6 = i5 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = i5 + 52;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 76 >> 2] = 0;
 HEAP32[i5 + 64 >> 2] = i5 + 68;
 HEAP32[i5 + 80 >> 2] = 0;
 HEAP32[i5 + 84 >> 2] = 0;
 if ((i6 | 0) == (i1 | 0)) return;
 i7 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i7 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i7 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i7 & 255;
 i3 = i6 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 40 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i7 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 36 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i7 - i4 | 0, i1, 0, i1, i7, i8);
  return;
 }
 if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
 if (i7 | 0) _memmove(i1 | 0, i8 | 0, i7 | 0) | 0;
 HEAP8[i1 + i7 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 36 >> 2] = i7;
  return;
 } else {
  HEAP8[i3 >> 0] = i7;
  return;
 }
}

function __Z57ParticleSystem_MainModule_CUSTOM_GetCustomSimulationSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i5 = __ZNK14ParticleSystem24GetCustomSimulationSpaceEv(i2) | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 13;
   }
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i6 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  i6 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i7 = i3;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 8);
   STACKTOP = i8;
   return;
  }
 } else {
  __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(HEAP32[i5 >> 2] | 0, i6);
  i5 = i2 + 16 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = i1 + 4 | 0;
  i4 = i2 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i6, 4);
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 < i2 >>> 0) {
   i4 = i7;
   i6 = HEAP32[i4 + 4 >> 2] | 0;
   i7 = i3;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   HEAP32[i5 >> 2] = i1;
   STACKTOP = i8;
   return;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i7, 8);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i5 = i9 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i8 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i8 + 24 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 20 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i9, i8 + 28 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i9, i8 + 48 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i9, i8 + 68 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN16ReflectionProbes19CleanupRendererPoolEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i1 + 40 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i9 = i1 + 52 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) return;
 if (i2) {
  i10 = i4;
  i3 = i1;
  i8 = i4;
 } else {
  i7 = i4;
  i2 = i4;
  L5 : while (1) {
   i5 = i7;
   i7 = i7 + 4 | 0;
   i6 = i7;
   while (1) {
    i4 = HEAP32[i5 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i4 + 16 >> 0] | 0)) break;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63536 | 0);
    _memmove(i5 | 0, i7 | 0, (HEAP32[i11 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) - i6 | 0) | 0;
    i1 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
    HEAP32[i9 >> 2] = i1;
    i2 = HEAP32[i11 >> 2] | 0;
    if ((i5 | 0) == (i2 + (i1 << 2) | 0)) {
     i1 = 15;
     break L5;
    }
   }
   if ((i7 | 0) == (i2 + (i1 << 2) | 0)) {
    i1 = 15;
    break;
   }
  }
  if ((i1 | 0) == 15) return;
 }
 L15 : while (1) {
  i4 = i10;
  i10 = i10 + 4 | 0;
  i5 = i10;
  i1 = i8;
  while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP8[i2 + 16 >> 0] | 0)) break;
   if (HEAP8[i2 + 28 >> 0] | 0) {
    __Z19DestroySingleObjectP6Object(HEAP32[i2 + 20 >> 2] | 0);
    __Z19DestroySingleObjectP6Object(HEAP32[i2 + 24 >> 2] | 0);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63536 | 0);
   _memmove(i4 | 0, i10 | 0, (HEAP32[i11 >> 2] | 0) + (HEAP32[i9 >> 2] << 2) - i5 | 0) | 0;
   i2 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
   HEAP32[i9 >> 2] = i2;
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i4 | 0) == (i1 + (i2 << 2) | 0)) {
    i1 = 15;
    break L15;
   } else i3 = i2;
  }
  if ((i10 | 0) == (i1 + (i3 << 2) | 0)) {
   i1 = 15;
   break;
  } else i8 = i1;
 }
 if ((i1 | 0) == 15) return;
}

function __ZN15RelativeJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i5, i1);
 if (!(i1 & 16)) {
  STACKTOP = i6;
  return;
 }
 i3 = i5 + 76 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i1 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.0e6);
 f2 = i7 ? Math_fround(1.0e6) : f2;
 f2 = i1 ? Math_fround(0.0) : f2;
 HEAPF32[i3 >> 2] = f2;
 i3 = i5 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  __ZN12b2MotorJoint11SetMaxForceEf(i1, f2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i7 = i5 + 80 | 0;
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = f2 < Math_fround(0.0);
 i9 = f2 > Math_fround(1.0e6);
 f2 = i9 ? Math_fround(1.0e6) : f2;
 f2 = i8 ? Math_fround(0.0) : f2;
 HEAPF32[i7 >> 2] = f2;
 if (!i1) i1 = 0; else {
  __ZN12b2MotorJoint12SetMaxTorqueEf(i1, f2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = i5 + 84 | 0;
 f2 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.0);
 f2 = i7 ? Math_fround(1.0) : f2;
 f2 = i8 ? Math_fround(0.0) : f2;
 HEAPF32[i9 >> 2] = f2;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __ZN12b2MotorJoint19SetCorrectionFactorEf(i1, f2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i9 = HEAP32[i5 + 92 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 + 88 >> 2];
 HEAP32[i4 + 4 >> 2] = i9;
 __ZN12b2MotorJoint15SetLinearOffsetERK6b2Vec2(i1, i4);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __ZN12b2MotorJoint16SetAngularOffsetEf(i1, Math_fround(Math_fround(HEAPF32[i5 + 96 >> 2]) * Math_fround(.0174532924)));
 STACKTOP = i6;
 return;
}

function __ZNK6Camera27GetImplicitProjectionMatrixEfR10Matrix4x4f(i2, f3, i4) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var f1 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0;
 if (HEAP8[i2 + 1088 >> 0] | 0) {
  f5 = Math_fround(HEAPF32[i2 + 916 >> 2]);
  f1 = Math_fround(-f5);
  f7 = Math_fround(HEAPF32[i2 + 1060 >> 2]);
  f8 = Math_fround(f7 * f1);
  f7 = Math_fround(f5 * f7);
  __ZN10Matrix4x4f8SetOrthoEffffff(i4, f8, f7, f1, f5, f3, Math_fround(HEAPF32[i2 + 924 >> 2])) | 0;
  return;
 }
 if (HEAP8[i2 + 1087 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
  i9 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 116 >> 2] | 0, i9 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i2) | 0) {
   i10 = __Z14IsWorldPlayingv() | 0;
   i9 = HEAP32[i2 + 1108 >> 2] | 0;
   if ((i9 | 0) == 8 | i10 & (i9 | 0) == 1) {
    i10 = __Z12GetIVRDevicev() | 0;
    HEAPF32[i2 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i10 >> 2] | 0) + 120 >> 2] | 0, i10 | 0));
   }
  }
 }
 f5 = Math_fround(HEAPF32[i2 + 292 >> 2]);
 if (!(HEAP8[i2 + 1086 >> 0] | 0)) i6 = 14; else if (!(__Z12GetIVRDevicev() | 0)) i6 = 14; else if (__ZNK6Camera16GetStereoEnabledEv(i2) | 0) {
  i9 = __Z14IsWorldPlayingv() | 0;
  i10 = HEAP32[i2 + 1108 >> 2] | 0;
  if ((i10 | 0) == 8 | i9 & (i10 | 0) == 1) {
   i10 = __Z12GetIVRDevicev() | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 124 >> 2] | 0, i10 | 0) | 0) {
    i10 = __Z12GetIVRDevicev() | 0;
    f1 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i10 >> 2] | 0) + 128 >> 2] | 0, i10 | 0));
   } else i6 = 14;
  } else i6 = 14;
 } else i6 = 14;
 if ((i6 | 0) == 14) f1 = Math_fround(HEAPF32[i2 + 1060 >> 2]);
 __ZN10Matrix4x4f14SetPerspectiveEffff(i4, f5, f1, f3, Math_fround(HEAPF32[i2 + 924 >> 2])) | 0;
 return;
}

function __ZNK6Camera24GetScreenViewportRectIntEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZL19GetCameraTargetRectRK6Camerab(i6, i2, 1);
 f8 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f10 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f8 = Math_fround(f8 * f10);
 f7 = Math_fround(f7 * f10);
 f5 = Math_fround(f5 * f9);
 f4 = Math_fround(f4 * f9);
 f12 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f8 = Math_fround(f8 + f12);
 f5 = Math_fround(f5 + f11);
 f7 = Math_fround(f7 + f8);
 f4 = Math_fround(f4 + f5);
 f10 = Math_fround(f10 + f12);
 f9 = Math_fround(f9 + f11);
 f8 = f8 < f12 ? f12 : f8;
 f5 = f5 < f11 ? f11 : f5;
 f7 = Math_fround((f7 > f10 ? f10 : f7) - f8);
 i6 = f7 < Math_fround(0.0);
 f7 = i6 ? Math_fround(0.0) : f7;
 f4 = Math_fround((f4 > f9 ? f9 : f4) - f5);
 i6 = f4 < Math_fround(0.0);
 f4 = i6 ? Math_fround(0.0) : f4;
 f9 = Math_fround(f8 + Math_fround(.5));
 i6 = f9 >= Math_fround(0.0);
 f10 = Math_fround(f9 + Math_fround(-.99999994));
 i6 = ~~(i6 ? f9 : f10);
 HEAP32[i1 >> 2] = i6;
 f10 = Math_fround(f5 + Math_fround(.5));
 i2 = f10 >= Math_fround(0.0);
 f9 = Math_fround(f10 + Math_fround(-.99999994));
 i2 = ~~(i2 ? f10 : f9);
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = (~~Math_fround(Math_fround(f8 + f7) + Math_fround(.5)) >>> 0) - i6;
 HEAP32[i1 + 12 >> 2] = (~~Math_fround(Math_fround(f5 + f4) + Math_fround(.5)) >>> 0) - i2;
 STACKTOP = i3;
 return;
}

function __ZN8JSONRead4InitE24TransferInstructionFlagsRK10MemLabelId(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 i9 = i2;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP8[i3 + 36 >> 0] = 0;
 __ZN23TextDOMTransferReadBaseI8JSONReadE10InitArraysEv(i3);
 i5 = i3 + 152 | 0;
 i6 = i3 + 156 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i3 + 164 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i2 = i3 + 168 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 if (i9 >>> 0 <= i4 >>> 0) {
  HEAP32[i7 >> 2] = i9;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + (i8 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 i1 = i3 << 1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i4 >>> 0 >= i1 >>> 0) {
  HEAP32[i7 >> 2] = i9;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + (i8 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 2, 4, i6, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i9;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + (i8 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i7 >> 2] = i9;
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + (i8 << 2) | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
}

function __ZN20UnityConnectSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 189132 + 8;
 __ZN22CrashReportingSettingsC2Ev(i1 + 28 | 0);
 __ZN23UnityPurchasingSettingsC2Ev(i1 + 56 | 0);
 __ZN22UnityAnalyticsSettingsC2Ev(i1 + 68 | 0);
 __ZN16UnityAdsSettingsC2Ev(i1 + 112 | 0);
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 180 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 200 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 216 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN20UnityConnectSettings10InitializeEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator15InsertLineBreakEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i2 = i1 + 436 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i4 = i8 + 60 | 0;
 i3 = i8 + 120 | 0;
 i9 = i8 + 180 | 0;
 i5 = i1 + 320 | 0;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 _memmove(i3 | 0, i5 | 0, 12) | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 240;
 i2 = i1 + 260 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 HEAPF32[(HEAP32[i1 + 376 >> 2] | 0) + (i8 << 2) >> 2] = Math_fround(0.0);
 i3 = i1 + 272 | 0;
 __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii(i1, HEAP32[i3 >> 2] | 0, i8 + -1 | 0, i8);
 i8 = i1 + 316 | 0;
 i4 = i1 + 300 | 0;
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 i9 = f10 < Math_fround(HEAPF32[i4 >> 2]);
 HEAP32[i8 >> 2] = HEAP32[(i9 ? i4 : i8) >> 2];
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 if (!(__ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf(i1, HEAP32[i3 >> 2] | 0, (HEAP32[i2 >> 2] | 0) + 1 | 0, i7) | 0)) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 312 >> 2] = 0;
 i9 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
 HEAP32[i1 + 276 >> 2] = i9;
 HEAP32[i1 + 268 >> 2] = i9;
 HEAP32[i3 >> 2] = i9;
 i9 = 1;
 STACKTOP = i6;
 return i9 | 0;
}

function __Z39PolygonCollider2D_Get_Custom_PropPointsP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i3) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i1 + 160 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i5 + 4 >> 2] | 0) == (i1 | 0)) i2 = 0; else i2 = HEAP32[i1 >> 2] | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 i5 = i1 + 160 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i5 + 4 >> 2] | 0) == (i1 | 0)) i1 = 0; else i1 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i4 = (i2 | 0) == 0 ? 0 : i1;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 8, i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 8) | 0;
 if ((i4 | 0) > 0) i3 = 0; else return i5 | 0;
 while (1) {
  i7 = i2;
  i9 = i7;
  i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
  i7 = i7 + 4 | 0;
  i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
  i6 = i1;
  i8 = i6;
  HEAP8[i8 >> 0] = i9;
  HEAP8[i8 + 1 >> 0] = i9 >> 8;
  HEAP8[i8 + 2 >> 0] = i9 >> 16;
  HEAP8[i8 + 3 >> 0] = i9 >> 24;
  i6 = i6 + 4 | 0;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + 8 | 0;
   i2 = i2 + 8 | 0;
  }
 }
 return i5 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 344 | 0;
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx29PxSphericalJointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx29PxSphericalJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 384 | 0;
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx29PxPrismaticJointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN13GfxDeviceGLES15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace(i7, i2, i3, i10, i1, i11, i12, i13, i14, i15, i8, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i16 = 0, i17 = 0, i18 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i16 = i6;
 i5 = i7 + 4620 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i16 >> 2] = i4;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 i1 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i5, i3, i1) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i4;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i2 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i16 = i1 + 8 | 0;
 i17 = HEAP32[i16 + 4 >> 2] | 0;
 i2 = i7 + 7320 | 0;
 i18 = HEAP32[i2 + 4 >> 2] | 0;
 if (i18 >>> 0 < i17 >>> 0 | ((i18 | 0) == (i17 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < (HEAP32[i16 >> 2] | 0) >>> 0 : 0)) {
  i17 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i7 + 5480 >> 2] | 0, 7) | 0;
  i18 = i7 + 7376 | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | i17;
 }
 i18 = __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i5, i1, i13, i10, 0, i11, i12, 1, i14, i15, i9, i8) | 0;
 __Z34register_external_gfx_deallocationPvPKci(i3, gb + 603515 | 0, 1005);
 __Z32register_external_gfx_allocationPvjjPKci(i3, i18, i4, gb + 603515 | 0, 1006);
 STACKTOP = i6;
 return;
}

function __ZN11GPUProfiler13GPUTimeSampleEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!(HEAP8[gb + 1546603 >> 0] | 0)) return;
 i12 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!(HEAP32[i12 + 280 >> 2] | 0)) return;
 i1 = HEAP32[gb + 1163260 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 660 >> 2] | 0, i1 | 0) | 0;
 } else {
  i11 = i3 + -1 | 0;
  i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i11;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i3 = HEAP32[(HEAP32[i12 + 36 >> 2] | 0) + ((HEAP32[i12 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
 i4 = HEAP32[gb + 1163232 >> 2] | 0;
 i5 = i12 + 56 | 0;
 i6 = i12 + 68 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i12 + 72 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i10 & 2147483647;
 do if (i8 >>> 0 > i11 >>> 0) {
  i2 = i10 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i11 >>> 0 < i2 >>> 0) if ((i10 | 0) > -1) {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2 << 4, 4, i12 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i12 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i5 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 i12 = HEAP32[i5 >> 2] | 0;
 HEAP32[i12 + (i7 << 4) >> 2] = i3;
 HEAP32[i12 + (i7 << 4) + 4 >> 2] = -1;
 HEAP32[i12 + (i7 << 4) + 8 >> 2] = i1;
 HEAP32[i12 + (i7 << 4) + 12 >> 2] = i4;
 return;
}

function __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
 i2 = i4 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i3);
 if (HEAP8[gb + 1098032 >> 0] | 0) {
  i6 = HEAP32[gb + 1114548 >> 2] | 0;
  __ZN10MemoryPool10DeallocateEPv(i6, i3);
  STACKTOP = i7;
  return i1 | 0;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
 i10 = gb + 63696 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 1018240 | 0, 20, 32768, i6, 16);
 HEAP32[gb + 1114548 >> 2] = i2;
 __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i2);
 if (i4) __Z19pop_allocation_rootv();
 i10 = gb + 1098032 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = HEAP32[gb + 1114548 >> 2] | 0;
 __ZN10MemoryPool10DeallocateEPv(i10, i3);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent11ColorRGBA32(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 i1 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i1 | 0) > -1) i1 = HEAP32[gb + 1468320 + (i1 << 2) >> 2] | 0; else i1 = 0;
 i1 = HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0;
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f16 = Math_fround(f15 + Math_fround(HEAP32[i2 + 208 >> 2] | 0));
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f14 = Math_fround(f10 + Math_fround(HEAP32[i2 + 216 >> 2] | 0));
 f15 = Math_fround(f15 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f15 = Math_fround(f15 - Math_fround(HEAP32[i2 + 212 >> 2] | 0));
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 f15 = Math_fround(f15 - f16);
 f10 = Math_fround(Math_fround(f10 - Math_fround(HEAP32[i2 + 220 >> 2] | 0)) - f14);
 HEAPF32[i6 >> 2] = f16;
 HEAPF32[i6 + 8 >> 2] = f15;
 HEAPF32[i6 + 4 >> 2] = f14;
 HEAPF32[i6 + 12 >> 2] = f10;
 i13 = __ZNK8GUIStyle14GetCurrentFontEv(i2) | 0;
 i12 = HEAP32[i2 + 244 >> 2] | 0;
 i11 = HEAP16[i2 + 248 >> 1] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 f10 = Math_fround(HEAPF32[i1 + 344 >> 2]);
 i1 = HEAP32[i2 + 284 >> 2] | 0;
 i3 = HEAP32[i2 + 288 >> 2] | 0;
 i5 = HEAP32[i2 + 256 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 i8 = __ZN5IMGUI12GetGeneratorERK5RectTIfERK10GUIContentPN13TextRendering4FontE10TextAnchorbb11ColorRGBA32fii13ImagePosition(i6, i4, i13, i12, (i11 & 255) << 24 >> 24 != 0, (i11 & 65535) > 255, i8, f10, i1, i3, i5) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37012 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 512)) {
   if (!(i4 & 1048576)) {
    HEAPF32[i11 >> 2] = Math_fround(0.0);
    break;
   }
   if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
   HEAPF32[i11 >> 2] = Math_fround(__Z19SimpleStringToFloatPKcPi(i1, 0));
  } else {
   do if (!(i4 & 16384)) {
    if (i4 & 1024 | 0) {
     d2 = +(HEAP32[i1 >> 2] | 0);
     break;
    }
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   HEAPF32[i11 >> 2] = Math_fround(d2);
  } while (0);
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i8, i2, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, i10 = 0, i11 = 0;
 i3 = i1 >>> 0 > 8 ? 8 : i1;
 if (!i3) {
  i1 = i8 + 65 | 0;
  HEAP8[i1 >> 0] = i3;
 } else {
  i1 = 0;
  do {
   f9 = Math_fround(HEAPF32[i2 + (i1 << 3) >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP8[i8 + (i1 << 2) + 3 >> 0] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
   f9 = Math_fround(HEAPF32[i2 + (i1 << 3) + 4 >> 2]);
   i7 = f9 < Math_fround(0.0);
   f9 = i7 ? Math_fround(0.0) : f9;
   i7 = f9 > Math_fround(1.0);
   HEAP16[i8 + 48 + (i1 << 1) >> 1] = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f9) * Math_fround(65535.0)) + Math_fround(.5)) >>> 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
  i2 = i3 & 255;
  i1 = i8 + 65 | 0;
  HEAP8[i1 >> 0] = i2;
  i7 = i3 & 255;
  if (i7 >>> 0 > 1) {
   i2 = 0;
   i6 = 1;
   while (1) {
    i3 = i8 + 48 + (i2 << 1) | 0;
    i4 = HEAP16[i3 >> 1] | 0;
    i5 = i8 + 48 + (i6 << 1) | 0;
    if ((i4 & 65535) > (HEAPU16[i5 >> 1] | 0)) {
     i11 = i8 + (i2 << 2) + 3 | 0;
     i10 = HEAP8[i11 >> 0] | 0;
     i6 = i8 + (i6 << 2) + 3 | 0;
     HEAP8[i11 >> 0] = HEAP8[i6 >> 0] | 0;
     HEAP16[i3 >> 1] = HEAP16[i5 >> 1] | 0;
     HEAP8[i6 >> 0] = i10;
     HEAP16[i5 >> 1] = i4;
     i2 = (i2 | 0) > 0 ? i2 + -2 | 0 : i2;
    }
    i6 = i2 + 2 | 0;
    if ((i6 | 0) >= (i7 | 0)) break; else i2 = i2 + 1 | 0;
   }
   i2 = HEAP8[i1 >> 0] | 0;
  }
  if ((i2 & 255) >= 2) return;
 }
 HEAP8[i1 >> 0] = 2;
 HEAP8[i8 + 7 >> 0] = HEAP8[i8 + 3 >> 0] | 0;
 HEAP16[i8 + 48 >> 1] = 0;
 HEAP16[i8 + 50 >> 1] = -1;
 return;
}

function __ZN5physx2Sc15ContactIterator4PairC2ERPKvjRPKfjRNS0_8ShapeSimESA_(i10, i1, i3, i7, i2, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = i2;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 16 >> 2] = Math_fround(0.0);
 HEAP32[i10 + 44 >> 2] = i3;
 HEAP32[i10 + 48 >> 2] = 0;
 HEAP32[i10 + 52 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = i1;
 if (!i3) {
  i2 = 0;
  i3 = 0;
  i4 = 0;
  i5 = 0;
  i6 = 1;
  i1 = 0;
 } else {
  i6 = HEAP16[i1 + 2 >> 1] | 0;
  i5 = i6 & 65535;
  i11 = i5 & 2;
  i12 = (i11 | 0) != 0;
  i5 = i5 & 1;
  i2 = (i5 | 0) != 0;
  i3 = i12;
  i4 = i12 ? 4 : 32;
  i5 = i12 ? 72 : i5 << 3 | 16;
  i6 = (i6 & 4) != 0;
  i1 = i1 + (i11 << 3 | 4) | 0;
 }
 HEAP32[i10 + 68 >> 2] = i3 & 1;
 HEAP32[i10 + 64 >> 2] = i2 & 1;
 HEAP32[i10 + 72 >> 2] = i6 & 1;
 HEAP32[i10 + 56 >> 2] = i4;
 HEAP32[i10 + 60 >> 2] = i5;
 HEAP32[i10 + 32 >> 2] = i1;
 HEAP32[i10 + 36 >> 2] = i1;
 HEAP32[i10 + 24 >> 2] = i1;
 HEAP32[i10 + 76 >> 2] = HEAP32[i7 >> 2];
 i12 = i10 + 80 | 0;
 HEAPF32[i10 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 116 >> 2] = Math_fround(0.0);
 HEAP32[i12 >> 2] = 0;
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i12 + 8 >> 2] = 0;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAP32[i12 + 20 >> 2] = 0;
 HEAP32[i10 + 132 >> 2] = i8;
 HEAP32[i10 + 136 >> 2] = i9;
 HEAP32[i10 + 104 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i8 + 28 >> 2] | 0) | 0;
 HEAP32[i10 + 108 >> 2] = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(HEAP32[i9 + 28 >> 2] | 0) | 0;
 HEAP8[i10 + 128 >> 0] = (HEAP32[i7 >> 2] | 0) != 0 & 1;
 return;
}

function __ZN4math4Axes8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i8, gb + 906532 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i8 + 16 | 0, gb + 906546 | 0, 0);
 i5 = i8 + 32 | 0;
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 __ZN4math5Limit8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 44 | 0, i6);
 i1 = i8 + 68 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI24GenerateTypeTreeTransferEEvRS3_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, i9, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, i9, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN13MonoBehaviour35RebuildMonoInstanceFromScriptChangeEP11Il2CppClassP12Il2CppObject(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i3 = i10;
 i9 = i6 + 33 | 0;
 if (HEAP8[i9 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0);
 i4 = i6 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 11;
   }
  }
  if ((i5 | 0) == 9) i5 = 11;
  if ((i5 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript(i6, i7, i8, i1);
 if (!(HEAP8[i9 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 132 >> 2] | 0, i6 | 0);
 STACKTOP = i10;
 return;
}

function __Z53Renderer_Get_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 32 + 244 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _write_marker_header(i5, i2, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 if (i3 >>> 0 > 65533) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 11;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i4 = i5 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 HEAP8[i7 >> 0] = -1;
 i7 = i1 + 4 | 0;
 i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 if (!i6) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i2;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i2 = i3 + 2 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i2 >>> 8;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (!i7) if (!((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24)) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 HEAP8[i6 >> 0] = i2;
 i6 = i1 + 4 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i7;
 if (i7 | 0) return;
 if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i5 | 0) | 0) << 24 >> 24) return;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 + 20 >> 2] = 24;
 mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i11 = __Znwj(44) | 0;
 i7 = i1 + 4 | 0;
 i8 = i11;
 i1 = i11 + 16 | 0;
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i11 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i11 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i11 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 i12 = i11 + 32 | 0;
 i11 = i10 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i12 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 >> 2] = i8;
 i12 = i9 + 4 | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = 1;
 STACKTOP = i13;
 return;
}

function __ZNK5Umbra15CameraTransform3getERNS_9Matrix4x4ENS0_10DepthRangeENS_12MatrixFormatE(i1, i5, i2, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 if (HEAP8[i1 + 436 >> 0] | 0) __ZN5Umbra18ImpCameraTransform6updateEv(i1);
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 8 >> 2];
 i4 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i5 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i5 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i5 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i5 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i5 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i5 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 if (i6 | 0) return;
 i1 = HEAP32[i2 >> 2] | 0;
 i6 = i5 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i6 = HEAP32[i4 >> 2] | 0;
 i3 = i5 + 48 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i6;
 i3 = i5 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i5 + 28 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i3 = i5 + 52 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i5 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i6 = i5 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 return;
}

function __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjPjS1_bRNS_6memory9AllocatorE(i7, i1, i8, i9, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0;
 i10 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 48, 4) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = -1;
 HEAP32[i10 + 8 >> 2] = -1;
 i5 = i10 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i10 + 32 >> 2] = -1;
 HEAPF32[i10 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 40 >> 2] = Math_fround(0.0);
 HEAP8[i10 + 44 >> 0] = 0;
 HEAP32[i10 + 12 >> 2] = i7;
 i5 = (i7 | 0) != 0;
 if (i5) {
  i2 = i10 + 16 | 0;
  i3 = i7 << 2;
  i4 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i7 << 2) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  i11 = i2;
  i4 = i4 | 0 ? i4 - i11 | 0 : 0;
  HEAP32[i2 >> 2] = i4;
  _memcpy(i4 + i11 | 0, i1 | 0, i3 | 0) | 0;
 }
 HEAP32[i10 >> 2] = 4;
 i3 = i10 + 28 | 0;
 i11 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 12, 4) | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP8[i11 + 8 >> 0] = 0;
 i4 = i3;
 i11 = i11 | 0 ? i11 - i4 | 0 : 0;
 HEAP32[i3 >> 2] = i11;
 i4 = i11 + i4 | 0;
 HEAP32[i4 >> 2] = i7;
 if (!i5) {
  i11 = i4 + 8 | 0;
  i9 = i9 & 1;
  HEAP8[i11 >> 0] = i9;
  return i10 | 0;
 }
 i2 = i4 + 4 | 0;
 i3 = i7 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i3 | 0, 4) | 0;
 if ((i1 | 0) != (i1 + (i7 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 i11 = i2;
 i7 = i1 | 0 ? i1 - i11 | 0 : 0;
 HEAP32[i2 >> 2] = i7;
 _memcpy(i7 + i11 | 0, i8 | 0, i3 | 0) | 0;
 i11 = i4 + 8 | 0;
 i9 = i9 & 1;
 HEAP8[i11 >> 0] = i9;
 return i10 | 0;
}

function __ZN5Umbra9RasterOps20testRectAnyReferenceERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf(i2, i1, i4, f16) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 f16 = Math_fround(f16);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 << 3 & 2040;
 i15 = i3 >>> 6 & 1020;
 i12 = i3 >>> 13 & 2040;
 i13 = i3 >>> 24 << 2;
 i14 = HEAP32[i1 >> 2] | 0;
 i14 = (i5 | 0) >= (i14 | 0) ? i5 : i14;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = (i15 | 0) >= (i5 | 0) ? i15 : i5;
 i15 = HEAP32[i1 + 8 >> 2] | 0;
 i15 = (i12 | 0) <= (i15 | 0) ? i12 : i15;
 i12 = HEAP32[i1 + 12 >> 2] | 0;
 i12 = (i13 | 0) <= (i12 | 0) ? i13 : i12;
 if (!((i5 | 0) < (i12 | 0) & (i14 | 0) < (i15 | 0))) {
  i15 = 0;
  return i15 | 0;
 }
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i3 & 255;
 i11 = (HEAPU8[i2 + 2 >> 0] | 0) - i9 << 1;
 i8 = i3 >>> 8 & 255;
 i9 = i9 << 1;
 i10 = (i4 | 0) == 0;
 i7 = i4 + 4 | 0;
 L4 : while (1) {
  i4 = i5 << 2 & 12;
  i6 = Math_imul(i11, (i5 >> 2) - i8 | 0) | 0;
  i2 = i5 >>> 2 << 8;
  if (i10) {
   i1 = i14;
   do {
    if ((HEAPU16[i13 + ((i1 >> 2) - i9 + i6 << 1) >> 1] | 0) & 1 << (i1 & 3 | i4) | 0) {
     i1 = 1;
     i2 = 10;
     break L4;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i15 | 0));
  } else {
   i1 = i14;
   do {
    i3 = i1 & 3 | i4;
    if ((HEAPU16[i13 + ((i1 >> 2) - i9 + i6 << 1) >> 1] | 0) & 1 << i3 | 0) if (Math_fround(HEAPF32[(HEAP32[i7 >> 2] | 0) + (((i1 >>> 2 << 4) + i2 | i3) << 2) >> 2]) >= f16) {
     i1 = 1;
     i2 = 10;
     break L4;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i15 | 0));
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (i12 | 0)) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZN16GraphicsSettings22WarmupPreloadedShadersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11;
 i9 = i1 + 108 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i6 = (HEAP32[i1 + 112 >> 2] | 0) - i2 >> 2;
 if (!i6) {
  STACKTOP = i11;
  return;
 }
 i1 = 0;
 while (1) {
  i5 = i2 + (i1 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (i2 | 0) {
   HEAP32[i8 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 10; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i8);
     i3 = HEAP32[i7 >> 2] | 0;
     i12 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 10; else {
     i2 = HEAP32[i2 + 4 >> 2] | 0;
     if (!i2) i10 = 12;
    }
   }
   if ((i10 | 0) == 10) i10 = 12;
   if ((i10 | 0) == 12) {
    i10 = 0;
    i2 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
    if (!i2) break;
   }
   __ZN23ShaderVariantCollection13WarmupShadersEv(i2);
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i6 | 0)) break;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 STACKTOP = i11;
 return;
}

function __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i3 = i5 + 16 | 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN12TreeInstance8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, i1);
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = i4;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN11DynamicMesh10DetailHullaSERKS0_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i8 | 0) == (i9 | 0)) return i9 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i9 + 12 | 0;
 i1 = HEAP32[i8 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i9 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  break;
 } else i1 = HEAP32[i9 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
 i5 = i9 + 20 | 0;
 i6 = HEAP32[i8 + 20 >> 2] | 0;
 i7 = i9 + 32 | 0;
 i1 = HEAP32[i8 + 32 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i7 >> 2] = i2;
 i3 = i9 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i9 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 return i9 | 0;
}

function _jpeg_write_coefficients(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 100) i1 = i2; else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 20;
  HEAP32[i5 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i2 | 0);
  i1 = i2;
 }
 _jpeg_suppress_tables(i2, 0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i2 + 24 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 HEAP32[i2 + 36 >> 2] = 1;
 _jinit_c_master_control(i2, 1);
 do if (!(HEAP8[i2 + 177 >> 0] | 0)) if (!(HEAP8[i2 + 212 >> 0] | 0)) {
  _jinit_huff_encoder(i2);
  break;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
  break;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 1;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
 } while (0);
 i5 = i2 + 4 | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i1 | 0, 1, 68) | 0;
 HEAP32[i2 + 328 >> 2] = i6;
 HEAP32[i6 >> 2] = fb + 2365;
 HEAP32[i6 + 4 >> 2] = fb + 504;
 HEAP32[i6 + 24 >> 2] = i3;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 1, 1280) | 0;
 _jzero_far(i3, 1280);
 HEAP32[i6 + 28 >> 2] = i3;
 HEAP32[i6 + 32 >> 2] = i3 + 128;
 HEAP32[i6 + 36 >> 2] = i3 + 256;
 HEAP32[i6 + 40 >> 2] = i3 + 384;
 HEAP32[i6 + 44 >> 2] = i3 + 512;
 HEAP32[i6 + 48 >> 2] = i3 + 640;
 HEAP32[i6 + 52 >> 2] = i3 + 768;
 HEAP32[i6 + 56 >> 2] = i3 + 896;
 HEAP32[i6 + 60 >> 2] = i3 + 1024;
 HEAP32[i6 + 64 >> 2] = i3 + 1152;
 _jinit_marker_writer(i2);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[HEAP32[i2 + 332 >> 2] >> 2] | 0, i2 | 0);
 HEAP32[i2 + 208 >> 2] = 0;
 HEAP32[i4 >> 2] = 103;
 return;
}

function _erfc2(i3, d1) {
 i3 = i3 | 0;
 d1 = +d1;
 var d2 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 d4 = +Math_abs(+d1);
 if (i3 >>> 0 < 1072955392) {
  d1 = d4 + -1.0;
  d1 = .15493708848953247 - (d1 * (d1 * (d1 * (d1 * (d1 * (.035478304325618236 - d1 * .002166375594868791) + -.11089469428239668) + .31834661990116175) + -.3722078760357013) + .41485611868374833) + -2.3621185607526594e-03) / (d1 * (d1 * (d1 * (d1 * (d1 * (d1 * .011984499846799107 + .01363708391202905) + .12617121980876164) + .07182865441419627) + .540397917702171) + .10642088040084423) + 1.0);
 } else {
  d5 = 1.0 / (d4 * d4);
  if (i3 >>> 0 < 1074191213) {
   d1 = d5 * (d5 * (d5 * (d5 * (d5 * (d5 * (-81.2874355063066 - d5 * 9.814329344169145) + -184.60509290671104) + -162.39666946257347) + -62.375332450326006) + -10.558626225323291) + -.6938585727071818) + -.009864944034847148;
   d2 = d5 * (d5 * (d5 * (d5 * (d5 * (d5 * (6.570249770319282 - d5 * .0604244152148581) + 108.63500554177944) + 429.00814002756783) + 645.3872717332679) + 434.56587747522923) + 137.65775414351904) + 19.651271667439257;
  } else {
   d1 = d5 * (d5 * (d5 * (d5 * (d5 * (-1025.0951316110772 - d5 * 483.5191916086514) + -637.5664433683896) + -160.63638485582192) + -17.757954917754752) + -.799283237680523) + -.0098649429247001;
   d2 = d5 * (d5 * (d5 * (d5 * (d5 * (474.52854120695537 - d5 * 22.44095244658582) + 2553.0504064331644) + 3199.8582195085955) + 1536.729586084437) + 325.7925129965739) + 30.33806074348246;
  }
  HEAPF64[tempDoublePtr >> 3] = d4;
  i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i3;
  d6 = +HEAPF64[tempDoublePtr >> 3];
  d1 = +Math_exp(+(-.5625 - d6 * d6)) * +Math_exp(+((d6 - d4) * (d4 + d6) + d1 / (d5 * d2 + 1.0))) / d4;
 }
 return +d1;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i10, i4, i1) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i1 = i9;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i7 >> 2] = i3;
  i1 = i5;
 }
 __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i4, i1);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i10);
  i4 = i1 + 4 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j(i4, i2);
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) do {
   __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i2, i10);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN11UmbraModule23CullDynamicObjectsUmbraEPK4AABBPKN5Umbra15OcclusionBufferER9IndexList(i1, i11, i12, i13) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i15 + 12 | 0;
 i8 = i15;
 i14 = i13 + 4 | 0;
 i9 = HEAP32[i14 >> 2] | 0;
 if ((i9 | 0) <= 0) {
  i13 = 0;
  HEAP32[i14 >> 2] = i13;
  STACKTOP = i15;
  return;
 }
 i10 = i7 + 4 | 0;
 i4 = i7 + 8 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  f24 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) + 12 >> 2]);
  f21 = Math_fround(f24 - f18);
  f23 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) + 4 >> 2]);
  f17 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) + 16 >> 2]);
  f20 = Math_fround(f23 - f17);
  f22 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) + 8 >> 2]);
  f16 = Math_fround(HEAPF32[i11 + (i2 * 24 | 0) + 20 >> 2]);
  f19 = Math_fround(f22 - f16);
  f18 = Math_fround(f24 + f18);
  f17 = Math_fround(f23 + f17);
  f16 = Math_fround(f22 + f16);
  HEAPF32[i7 >> 2] = f21;
  HEAPF32[i10 >> 2] = f20;
  HEAPF32[i4 >> 2] = f19;
  HEAPF32[i8 >> 2] = f18;
  HEAPF32[i5 >> 2] = f17;
  HEAPF32[i6 >> 2] = f16;
  if (__ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf(i12, i7, i8, 0, 0) | 0) {
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i9 | 0));
 HEAP32[i14 >> 2] = i1;
 STACKTOP = i15;
 return;
}

function __ZN11KeyframeTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 64) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 6) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = i2 - i1 >> 6;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 6) | 0;
 if (i7 | 0) do {
  __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i12, i2, i1) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i4 = i11;
 i10 = i11 + 16 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i10 >> 2] = 0;
 i7 = i10 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i10 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i1 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i9);
 i2 = i2 - i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i2 | -2147483648;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i3 = i12 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i12 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i6, 4);
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (i7 | 0) do {
  __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((HEAP32[i8 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __Z13CleanupEnginev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (__Z11IsGfxDevicev() | 0) {
  i4 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 532 >> 2] | 0, i4 | 0);
 }
 __Z17CleanupAllObjectsv();
 __ZN23ManagedAttributeManager12CleanupClassEv();
 __ZN21ExecutionOrderManager12CleanupClassEv();
 __ZN14MessageHandler7CleanupEv(__ZN14MessageHandler3GetEv() | 0);
 __ZN11TypeManager15CleanupAllTypesEv(HEAP32[gb + 1110260 >> 2] | 0);
 i3 = __ZN13ModuleManager3GetEv() | 0;
 __ZN13ModuleManager4LoadEv(i3);
 i4 = i3 + 2312 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = i3 + 1544 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i3 + 1544 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i2 >> 2] | 0); else mftCall_vi(HEAP32[i2 >> 2] | 0, HEAP32[i3 + 1544 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 __ZN15SkyboxGenerator26ReleaseSkyboxVertexBuffersEv();
 __ZN19RenderBufferManager26CleanupRenderBufferManagerEv();
 __ZN13UnityProfiler10CleanupGfxEv();
 if (!(HEAP8[gb + 1548965 >> 0] | 0)) {
  i4 = __Z21GetBackgroundJobQueuev() | 0;
  __ZN18BackgroundJobQueue8ShutdownEv(i4);
  __Z20ReleaseScreenManagerv();
  __Z30InstallPlayerConnectionLoggingb(0);
  __ZN13UnityProfiler7CleanupEv();
  __Z26CleanupMemoryProfilerStatsv();
  return;
 }
 __Z14CleanupShadersv();
 __ZN22BuiltinResourceManager19DestroyAllResourcesEv(__Z25GetBuiltinResourceManagerv() | 0);
 __Z24ShaderPassContextCleanupv();
 __Z16DestroyGfxDevicev();
 HEAP8[gb + 1548965 >> 0] = 0;
 i4 = __Z21GetBackgroundJobQueuev() | 0;
 __ZN18BackgroundJobQueue8ShutdownEv(i4);
 __Z20ReleaseScreenManagerv();
 __Z30InstallPlayerConnectionLoggingb(0);
 __ZN13UnityProfiler7CleanupEv();
 __Z26CleanupMemoryProfilerStatsv();
 return;
}

function __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 switch (i1 | 0) {
 case 8:
  {
   i2 = i3 + 404 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i3 + 112 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i3 + 392 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i3 = i3 + 396 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   i3 = i1;
   STACKTOP = i4;
   return i3 | 0;
  }
 case 16:
  {
   i2 = i3 + 700 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i3 + 408 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i3 + 688 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i3 = i3 + 692 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   i3 = i1;
   STACKTOP = i4;
   return i3 | 0;
  }
 case 32:
  {
   i2 = i3 + 996 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i3 + 704 | 0);
    i1 = HEAP32[i2 >> 2] | 0;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i3 + 984 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i3 = i3 + 988 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
   i3 = i1;
   STACKTOP = i4;
   return i3 | 0;
  }
 default:
  {
   i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i1 << 2, gb + 679598 | 0, 316) | 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i3, i7, i4, i12) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f11 - f8);
 f5 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f5 - f9);
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f1 = Math_fround(f1 - f10);
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
 f9 = Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) - f9);
 f10 = Math_fround(Math_fround(HEAPF32[i7 + 8 >> 2]) - f10);
 f2 = Math_fround(Math_fround(Math_fround(f11 * f8) + Math_fround(f5 * f9)) + Math_fround(f1 * f10));
 do if (!(f2 <= Math_fround(0.0))) {
  f6 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f9 * f9)) + Math_fround(f10 * f10));
  if (!(f2 >= f6)) {
   f2 = Math_fround(f2 / f6);
   f6 = Math_fround(f11 - Math_fround(f8 * f2));
   f5 = Math_fround(f5 - Math_fround(f9 * f2));
   f1 = Math_fround(f1 - Math_fround(f10 * f2));
   break;
  } else {
   f6 = Math_fround(f11 - f8);
   f5 = Math_fround(f5 - f9);
   f1 = Math_fround(f1 - f10);
   f2 = Math_fround(1.0);
   break;
  }
 } else {
  f6 = f11;
  f2 = Math_fround(0.0);
 } while (0);
 if (!i12) {
  f11 = Math_fround(f6 * f6);
  f10 = Math_fround(f5 * f5);
  f11 = Math_fround(f10 + f11);
  f10 = Math_fround(f1 * f1);
  f11 = Math_fround(f10 + f11);
  return Math_fround(f11);
 }
 HEAPF32[i12 >> 2] = f2;
 f11 = Math_fround(f6 * f6);
 f10 = Math_fround(f5 * f5);
 f11 = Math_fround(f10 + f11);
 f10 = Math_fround(f1 * f1);
 f11 = Math_fround(f10 + f11);
 return Math_fround(f11);
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = i7 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = (i9 - i1 | 0) / 28 | 0;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 24 | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 3;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 3) | 0)) _memset(i4 | 0, 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN13GfxDeviceGLES20GetComputeBufferDataE15ComputeBufferIDPvj(i6, i1, i7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) return;
 i5 = i2 + 16 | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i6 + 7328 | 0;
 i4 = i1;
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 if (i9 >>> 0 < i3 >>> 0 | ((i9 | 0) == (i3 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0 : 0)) {
  i9 = HEAP32[i6 + 4860 >> 2] | 0;
  i5 = i6 + 5480 | 0;
  mftCall_vi(i9 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i5 >> 2] | 0, 8) | 0);
  i9 = i6 + 7368 | 0;
  i4 = i9;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i11 = _i64Add(i3 | 0, i4 | 0, 1, 0) | 0;
  i10 = getTempRet0() | 0;
  HEAP32[i9 >> 2] = i11;
  HEAP32[i9 + 4 >> 2] = i10;
  i9 = i1;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = i4;
  i5 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i5 >> 2] | 0, 8) | 0);
  i9 = i6 + 7376 | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & i5;
 }
 i1 = __ZN14DataBufferGLES3MapEiij(HEAP32[i2 >> 2] | 0, 0, i8, 1) | 0;
 if (!i1) return;
 _memcpy(i7 | 0, i1 | 0, i8 | 0) | 0;
 __ZN14DataBufferGLES5UnmapEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i1 + 8 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) return;
 i10 = i1 + 12 | 0;
 i8 = i2 + 28 | 0;
 i9 = i8;
 i7 = 0;
 i1 = 0;
 do {
  i6 = HEAP32[i10 >> 2] | 0;
  i2 = i6 + (i7 << 4) | 0;
  i3 = HEAP32[i6 + (i7 << 4) + 4 >> 2] | 0;
  L6 : do if (i3) {
   f4 = Math_fround(HEAPF32[(HEAP32[i8 >> 2] | 0) + i9 + (i7 << 2) >> 2]);
   switch (i3 | 0) {
   case 5:
    {
     i3 = HEAP32[i2 >> 2] | 0;
     i5 = Math_fround(HEAPF32[i3 >> 2]) != f4;
     HEAPF32[i3 >> 2] = f4;
     if (!i5) break L6;
     break;
    }
   case 6:
    {
     i3 = HEAP32[i2 >> 2] | 0;
     i2 = f4 > Math_fround(.00100000005) | f4 < Math_fround(-.00100000005);
     i5 = (HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0);
     HEAP8[i3 >> 0] = i2 & 1;
     if (i5) break L6;
     break;
    }
   case 7:
    {
     __ZN10GameObject13SetSelfActiveEb(HEAP32[i6 + (i7 << 4) + 12 >> 2] | 0, f4 > Math_fround(.00100000005) | f4 < Math_fround(-.00100000005));
     break L6;
    }
   default:
    {
     i6 = HEAP32[i6 + (i7 << 4) + 8 >> 2] | 0;
     mftCall_viif(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, i2 | 0, +f4);
     break L6;
    }
   }
   i5 = i1;
   i2 = i6 + (i7 << 4) + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i5 | 0) != (i3 | 0)) if (!i1) i1 = i3; else {
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, 16);
    i1 = HEAP32[i2 >> 2] | 0;
   }
  } while (0);
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != (HEAP32[i11 >> 2] | 0));
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 return;
}

function __Z28RenderSceneShaderReplacementRK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEER17ShaderPassContext(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i8 = i9;
 i6 = i9 + 16 | 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 HEAP32[i7 >> 2] = i1;
 i7 = __ZnwjRK10MemLabelIdiPKci(108, gb + 64024 | 0, 16, gb + 388526 | 0, 351) | 0;
 i10 = gb + 64024 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i7 + 4 >> 2] = 1;
 HEAP32[i7 >> 2] = gb + 36880 + 8;
 i2 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i11;
 HEAP32[i1 + 4 >> 2] = i10;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i8);
 i1 = i5;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i7 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i5;
 HEAP32[i7 + 32 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAP8[i7 + 104 >> 0] = 1;
 i8 = i3 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = i3;
 __ZN15ReplacementPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceData(i7, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, i3 + 8 | 0, i6);
 __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext(i7, i4);
 STACKTOP = i9;
 return;
}

function __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = mftCall_iii(HEAP32[i4 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 i7 = mftCall_iii(HEAP32[i4 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 if (!i6) {
  if (!i7) {
   i7 = 0;
   return i7 | 0;
  }
  i5 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i9 = i3;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i2;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  i7 = i3;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i7 + 4 >> 2] = i6;
  if (!(mftCall_iii(HEAP32[i4 >> 2] | 0, i2 | 0, i1 | 0) | 0)) {
   i9 = 1;
   return i9 | 0;
  }
  i7 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i2;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 4 >> 2] = i6;
  i9 = i2;
  HEAP32[i9 >> 2] = i7;
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = 2;
  return i9 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if (i7) {
  i7 = i3;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  i9 = i3;
  HEAP32[i9 >> 2] = i5;
  HEAP32[i9 + 4 >> 2] = i6;
  i9 = 1;
  return i9 | 0;
 }
 i7 = i2;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i2;
 HEAP32[i9 >> 2] = i5;
 HEAP32[i9 + 4 >> 2] = i6;
 if (!(mftCall_iii(HEAP32[i4 >> 2] | 0, i3 | 0, i2 | 0) | 0)) {
  i9 = 1;
  return i9 | 0;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i3;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i9 = i2;
 HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 4 >> 2] = i6;
 i9 = i3;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = 2;
 return i9 | 0;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlENS_4lessIS6_EENS4_INS_4pairIKS6_S8_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSC_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8beginTagEPKc(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 HEAP32[i4 >> 2] = i10;
 i9 = i8 + 28 | 0;
 i7 = i10;
 if (HEAP8[i9 >> 0] | 0) {
  i6 = i8 + 8 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086447 | 0, 1) | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1074320 | 0, 1) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 i5 = i8 + 12 | 0;
 i6 = i8 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = (HEAP32[i8 + 32 >> 2] | 0) + i1 | 0;
 if (i3) {
  i1 = i8 + 8 | 0;
  i2 = 0;
  do {
   i12 = HEAP32[i1 >> 2] | 0;
   mftCall_iiii(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0, gb + 1074318 | 0, 1) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if ((HEAP32[i8 + 24 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i8 + 16 >> 2] | 0) + (i1 << 2) >> 2] = i7;
  HEAP32[i6 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPKcNS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i4) | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086445 | 0, 1) | 0;
 if (!i10) {
  HEAP8[i9 >> 0] = 1;
  STACKTOP = i11;
  return;
 }
 if (!(HEAP8[i10 >> 0] | 0)) {
  HEAP8[i9 >> 0] = 1;
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 mftCall_iiii(i12 | 0, i1 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 HEAP8[i9 >> 0] = 1;
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sc5Scene21processLostTouchPairsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 1244 | 0;
 i9 = i1 + 1252 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) {
  i8 = i1 + 1256 | 0;
  HEAP32[i10 >> 2] = 0;
  i10 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i10 << 2;
  _memset(i9 | 0, 0, i10 | 0) | 0;
  return;
 }
 i8 = i1 + 1240 | 0;
 i1 = i1 + 1256 | 0;
 i7 = 0;
 do {
  i6 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 + (i7 << 4) + 8 >> 2] | 0;
  i3 = i2 >>> 5;
  i4 = HEAP32[i1 >> 2] & 2147483647;
  if (i3 >>> 0 < i4 >>> 0) i5 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i2 & 31); else i5 = 0;
  i2 = HEAP32[i6 + (i7 << 4) + 12 >> 2] | 0;
  i3 = i2 >>> 5;
  if (i3 >>> 0 < i4 >>> 0) i3 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] & 1 << (i2 & 31); else i3 = 0;
  i2 = (i3 | 0) == 0;
  do if (!(i3 | i5)) {
   i3 = HEAP32[i6 + (i7 << 4) >> 2] | 0;
   i2 = (HEAP8[(HEAP32[i6 + (i7 << 4) + 4 >> 2] | 0) + 51 >> 0] & 1) == 0;
   if (!(HEAP8[i3 + 51 >> 0] & 1)) {
    if (i2) break;
   } else if (!i2) break;
   __ZN5physx2Sc7BodySim14internalWakeUpEf(i3, Math_fround(.399999976));
   __ZN5physx2Sc7BodySim14internalWakeUpEf(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 4) + 4 >> 2] | 0, Math_fround(.399999976));
  } else {
   if (!i5) __ZN5physx2Sc7BodySim14internalWakeUpEf(HEAP32[i6 + (i7 << 4) >> 2] | 0, Math_fround(.399999976));
   if (i2) __ZN5physx2Sc7BodySim14internalWakeUpEf(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 4) + 4 >> 2] | 0, Math_fround(.399999976));
  } while (0);
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 HEAP32[i10 >> 2] = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 << 2;
 _memset(i9 | 0, 0, i10 | 0) | 0;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 432 | 0;
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx28PxRevoluteJointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 432 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 400 | 0;
 i10 = i3 + 44 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx28PxDistanceJointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN4MeshD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 HEAP32[i6 >> 2] = gb + 58004 + 8;
 i1 = i6 + 204 | 0;
 __ZN17CollisionMeshData7CleanupEv(i1);
 i5 = i6 + 232 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN17CollisionMeshDataD2Ev(i1);
 i1 = i6 + 164 | 0;
 if ((HEAP32[i6 + 180 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 168 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 144 | 0;
 if ((HEAP32[i6 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 148 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i6 + 72 | 0;
 i1 = i6 + 124 | 0;
 if ((HEAP32[i6 + 140 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 128 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i6 + 112 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i6 + 116 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i7 = i2 + -16 | 0;
    HEAP32[i4 >> 2] = i7;
    __ZN14ConstantStringD2Ev(i7);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i6 + 92 | 0;
 if ((HEAP32[i6 + 108 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 96 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i6 + 88 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = gb + 32336 + 8;
  i7 = i6 + 28 | 0;
  __ZN14ConstantStringD2Ev(i7);
  HEAP32[i6 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 76 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 32336 + 8;
 i7 = i6 + 28 | 0;
 __ZN14ConstantStringD2Ev(i7);
 HEAP32[i6 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN4FMOD7Channel9setPausedEb(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var d1 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i6 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i6 | 0) if (!(HEAP8[i6 + 16 >> 0] | 0)) if ((HEAP32[i6 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i2 = i6 + 161 | 0;
   if ((HEAPU8[i2 >> 0] | 0) == (i7 & 1 | 0)) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   HEAP8[i2 >> 0] = i7 & 1;
   d1 = +__Z19GetTimeSinceStartupv() * 44100.0;
   i3 = ~~d1 >>> 0;
   i4 = +Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i5 = i6 + 120 | 0;
   if (i7) {
    i7 = i5;
    HEAP32[i7 >> 2] = i3;
    HEAP32[i7 + 4 >> 2] = i4;
   } else {
    i3 = _i64Subtract(i3 | 0, i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0) | 0;
    i5 = getTempRet0() | 0;
    i7 = i6 + 104 | 0;
    i4 = i7;
    i4 = _i64Add(i3 | 0, i5 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
    i5 = getTempRet0() | 0;
    HEAP32[i7 >> 2] = i4;
    HEAP32[i7 + 4 >> 2] = i5;
   }
   if (!(HEAP8[i2 >> 0] | 0)) {
    f9 = Math_fround(HEAPF32[i6 + 140 >> 2]);
    d1 = +Math_fround(Math_fround(f9 * Math_fround(HEAPF32[i6 + 152 >> 2])) / Math_fround(44100.0));
   } else d1 = 1.0e-07;
   _JS_Sound_SetPitch(HEAP32[i6 + 164 >> 2] | 0, +d1);
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 857796;
 _printf(gb + 853184 | 0, i4) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN25ThreadsafeLinearAllocator10DeallocateEPv(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 4 | 0;
 i1 = i5 + -8 | 0;
 i4 = i1;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if (!(0 == 0 & (i4 & 268435455 | 0) == 218558477)) {
  __Z6FormatPKcz(i2, gb + 365210 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365015 | 0, 223, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i7;
  return;
 }
 i2 = i1;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4 & -268435456 | 231591373;
 i2 = _bitshift64Lshr(i3 | 0, i4 | 0, 60) | 0;
 getTempRet0() | 0;
 i2 = i6 + 64 + (i2 << 2) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 & 256 | 0) == 0 & 0 == 0)) {
  i4 = _bitshift64Lshr(i2 | 0, HEAP32[i1 + 4 >> 2] | 0, 9) | 0;
  getTempRet0() | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i5 + (0 - (i4 & 8388607)) | 0, gb + 64032 | 0);
  i6 = i6 + 44 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  STACKTOP = i7;
  return;
 }
 i2 = i2 & 255;
 i3 = i6 + 32 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + (i2 * 12 | 0) + 8 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 STACKTOP = i7;
 return;
}

function __ZN14PhysicsManager15BoxCastNonAllocERK8Vector3fS2_S2_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction(i4, i5, i6, i7, i8, i9, i10, f11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 8 | 0;
 i1 = i14;
 if (!i9) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((HEAP16[gb + 1452800 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452800 | 0, i2);
  i3 = gb + 1452800 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 736 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i2 + 52 >> 0] = 0;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = 128;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151376 + 8;
 HEAP32[i2 + 68 >> 2] = i8;
 HEAP32[i2 + 72 >> 2] = i9;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE(0, i5, i6, i7, i10, f11, i12, i13, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 24 | 0;
 i7 = i3;
 i2 = i3 + 32 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 1034406 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i7, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i7 + 12 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 i8 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i10 + 16 >> 2] = HEAP32[i2 >> 2];
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo(i10, HEAP32[i3 + 24 >> 2] | 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 72 | 0;
 HEAP32[i9 >> 2] = i3;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i9, 4);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i7);
   i1 = i1 + 72 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i8 >> 2] = i2 + -72;
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i10 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 1;
 HEAP32[i9 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i11;
 return;
}

function __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fPS2_i(i2, i3, i10, i11) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 if ((i11 | 0) <= 0) return;
 i12 = i2 + 16 | 0;
 i13 = i2 + 32 | 0;
 i14 = i2 + 48 | 0;
 i15 = i2 + 4 | 0;
 i16 = i2 + 20 | 0;
 i4 = i2 + 36 | 0;
 i5 = i2 + 52 | 0;
 i6 = i2 + 8 | 0;
 i7 = i2 + 24 | 0;
 i8 = i2 + 40 | 0;
 i9 = i2 + 56 | 0;
 i1 = 0;
 do {
  f19 = Math_fround(HEAPF32[i2 >> 2]);
  f21 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
  f19 = Math_fround(f19 * f21);
  f18 = Math_fround(HEAPF32[i12 >> 2]);
  f20 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
  f18 = Math_fround(f19 + Math_fround(f18 * f20));
  f19 = Math_fround(HEAPF32[i13 >> 2]);
  f17 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
  f19 = Math_fround(f18 + Math_fround(f19 * f17));
  f19 = Math_fround(Math_fround(HEAPF32[i14 >> 2]) + f19);
  f18 = Math_fround(f21 * Math_fround(HEAPF32[i15 >> 2]));
  f18 = Math_fround(f18 + Math_fround(f20 * Math_fround(HEAPF32[i16 >> 2])));
  f18 = Math_fround(f18 + Math_fround(f17 * Math_fround(HEAPF32[i4 >> 2])));
  f18 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f18);
  f21 = Math_fround(f21 * Math_fround(HEAPF32[i6 >> 2]));
  f20 = Math_fround(f21 + Math_fround(f20 * Math_fround(HEAPF32[i7 >> 2])));
  f17 = Math_fround(f20 + Math_fround(f17 * Math_fround(HEAPF32[i8 >> 2])));
  f17 = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f17);
  HEAPF32[i10 + (i1 * 12 | 0) >> 2] = f19;
  HEAPF32[i10 + (i1 * 12 | 0) + 4 >> 2] = f18;
  HEAPF32[i10 + (i1 * 12 | 0) + 8 >> 2] = f17;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 return;
}

function ___vsyslog(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 352 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i5 = i13 + 336 | 0;
 i3 = i13 + 72 | 0;
 i4 = i13 + 28 | 0;
 i11 = i13 + 80 | 0;
 i12 = i13 + 24 | 0;
 if (!(i1 >>> 0 > 1023 ? 1 : (HEAP32[gb + 207708 >> 2] & 1 << (i1 & 7) | 0) == 0)) {
  _pthread_setcancelstate(1, i12 | 0) | 0;
  ___lock(gb + 1469724 | 0);
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[gb + 207712 >> 2] | 0) < 0) {
   ___openlog();
   if ((HEAP32[gb + 207712 >> 2] | 0) >= 0) i2 = 4;
  } else i2 = 4;
  if ((i2 | 0) == 4) {
   i2 = ((i1 & 1016 | 0) == 0 ? HEAP32[gb + 207716 >> 2] | 0 : 0) | i1;
   HEAP32[i3 >> 2] = _time(0) | 0;
   _gmtime_r(i3 | 0, i4 | 0) | 0;
   _strftime(i5 | 0, 16, gb + 1073926 | 0, i4 | 0) | 0;
   if (!(HEAP32[gb + 1469732 >> 2] & 1)) i1 = 0; else i1 = _getpid() | 0;
   i3 = (i1 | 0) == 0 & 1;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i6 + 8 >> 2] = gb + 1576076;
   HEAP32[i6 + 12 >> 2] = gb + 1073935 + i3;
   HEAP32[i6 + 16 >> 2] = i1;
   HEAP32[i6 + 20 >> 2] = gb + 1086372 + i3;
   i3 = _snprintf(i11, 256, gb + 1073937 | 0, i6) | 0;
   HEAP32[i7 >> 2] = i8;
   i2 = 256 - i3 | 0;
   i1 = _vsnprintf(i11 + i3 | 0, i2, i9, i10) | 0;
   if ((i1 | 0) > -1) {
    i1 = i1 >>> 0 < i2 >>> 0 ? i1 + i3 | 0 : 255;
    if ((HEAP8[i11 + (i1 + -1) >> 0] | 0) != 10) {
     HEAP8[i11 + i1 >> 0] = 10;
     i1 = i1 + 1 | 0;
    }
    _send(HEAP32[gb + 207712 >> 2] | 0, i11, i1, 0) | 0;
   }
  }
  ___unlock(gb + 1469724 | 0);
  _pthread_setcancelstate(HEAP32[i12 >> 2] | 0, 0) | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i2, i3, i11, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i2 + 4 | 0;
 if ((i3 | 0) == (i11 | 0)) {
  STACKTOP = i10;
  return;
 }
 i8 = i9 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  i1 = i4 + 4 | 0;
  i5 = i3 + 4 | 0;
  i6 = HEAP8[i5 + 11 >> 0] | 0;
  i2 = i6 << 24 >> 24 < 0;
  i5 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i2 ? HEAP32[i3 + 8 >> 2] | 0 : i6 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 16 >> 2] = i2;
  if (i6 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i4 + 16 >> 2] | 0;
   i12 = 6;
  } else if (i6 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i6;
   if (i6) i12 = 8;
  } else i12 = 6;
  if ((i12 | 0) == 6) {
   i13 = i6 + 16 & -16;
   HEAP32[i9 >> 2] = 66;
   HEAP32[i8 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 16, i9, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i4 + 12 >> 2] = i13 | -2147483648;
   HEAP32[i4 + 8 >> 2] = i6;
   i1 = i2;
   i12 = 8;
  }
  if ((i12 | 0) == 8) {
   i12 = 0;
   _memcpy(i1 | 0, i5 | 0, i6 | 0) | 0;
  }
  HEAP8[i1 + i6 >> 0] = 0;
  i3 = i3 + 20 | 0;
  i4 = (HEAP32[i7 >> 2] | 0) + 20 | 0;
  HEAP32[i7 >> 2] = i4;
 } while ((i3 | 0) != (i11 | 0));
 STACKTOP = i10;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIwwEEPwEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i1 >> 2] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i6;
     while (1) {
      HEAP32[i3 >> 2] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i5 | 0) >= (i4 | 0)) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP32[i2 >> 2] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessImmEEPmEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i1 >> 2] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if (i5 >>> 0 < i4 >>> 0) {
     i3 = i6;
     while (1) {
      HEAP32[i3 >> 2] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i5 >>> 0 >= i4 >>> 0) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP32[i2 >> 2] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIllEEPlEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i1 >> 2] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i6;
     while (1) {
      HEAP32[i3 >> 2] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i5 | 0) >= (i4 | 0)) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP32[i2 >> 2] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIjjEEPjEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i1 >> 2] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if (i5 >>> 0 < i4 >>> 0) {
     i3 = i6;
     while (1) {
      HEAP32[i3 >> 2] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if (i5 >>> 0 >= i4 >>> 0) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP32[i2 >> 2] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIiiEEPiEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i1 >> 2] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP32[i6 >> 2] | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) < (i4 | 0)) {
     i3 = i6;
     while (1) {
      HEAP32[i3 >> 2] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -4 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i5 | 0) >= (i4 | 0)) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP32[i2 >> 2] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZN7Terrain16SetDefaultValuesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 52 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 64 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 68 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 76 >> 2] = 50;
 HEAPF32[i1 + 80 >> 2] = Math_fround(80.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 88 >> 0] = 1;
 HEAP8[i1 + 89 >> 0] = 1;
 HEAP8[i1 + 90 >> 0] = 1;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = -8421505;
 HEAPF32[i1 + 104 >> 2] = Math_fround(.078125);
 i2 = i1 + 152 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 188 >> 0] = 1;
 i2 = i1 + 192 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 200 >> 0] = 1;
 HEAP32[i1 + 204 >> 2] = 7;
 i1 = i1 + 208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i10 + 20 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i8 * 20 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + (i1 * 20 | 0) | 0;
 i7 = i10 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 20 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i3 = i4 + (i1 * 20 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i8;
  i10 = HEAP32[i6 >> 2] | 0;
  i9 = i10 + 1 | 0;
  HEAP32[i6 >> 2] = i9;
  i10 = i4 + (i10 * 20 | 0) | 0;
  return i10 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i4;
 HEAP32[i5 >> 2] = i8;
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = i10 + 1 | 0;
 HEAP32[i6 >> 2] = i9;
 i10 = i4 + (i10 * 20 | 0) | 0;
 return i10 | 0;
}

function __ZN5physx3Scb14ParticleSystem16releaseParticlesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i1 = i7;
 i4 = HEAP32[i6 + 152 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (!i5) {
  i2 = i4 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i4 + 73 | 0; else {
   i9 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i8 = i4 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 699672;
   HEAP32[i1 + 4 >> 2] = i8;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i9, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i8;
  }
  _strncpy(i1, gb + 699672 | 0, 128) | 0;
  HEAP8[i4 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 switch ((HEAP32[i6 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 9; else i1 = 8;
   break;
  }
 default:
  i1 = 9;
 }
 if ((i1 | 0) == 8) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 126, gb + 699279 | 0, i3); else if ((i1 | 0) == 9) {
  __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEv(i6 + 12 | 0);
  i1 = i6 + 164 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   i9 = HEAP32[i6 + 156 >> 2] | 0;
   _memset(HEAP32[i9 >> 2] | 0, 0, HEAP32[i9 + 4 >> 2] << 2 | 0) | 0;
   HEAP8[i1 >> 0] = 0;
  }
  i1 = i6 + 176 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   i9 = HEAP32[i6 + 168 >> 2] | 0;
   _memset(HEAP32[i9 >> 2] | 0, 0, HEAP32[i9 + 4 >> 2] << 2 | 0) | 0;
   HEAP8[i1 >> 0] = 0;
  }
 }
 if (i5) {
  STACKTOP = i7;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 188936 + 8;
 i1 = i3 + 476 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 488 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 }
 i2 = i3 + 392 | 0;
 i1 = i3 + 440 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i3 + 452 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i1 = i3 + 424 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 436 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 i1 = i3 + 408 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 420 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i3 + 404 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoD2Ev(i3 + 32 | 0);
 HEAP32[i3 >> 2] = gb + 190148 + 8;
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 STACKTOP = i5;
 return;
}

function __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z16lineIntersectionRKN4math7_float2ES2_(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i13 = 0;
 f8 = Math_fround(HEAPF32[i12 >> 2]);
 f9 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f8 - f10);
 f5 = Math_fround(f9 - f2);
 f5 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5)) + Math_fround(0.0)) * Math_fround(50.0))))));
 f4 = Math_fround(f8 + f10);
 f3 = Math_fround(f9 + f2);
 f3 = Math_fround(_fminf(f5, Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(0.0)) * Math_fround(50.0))))))));
 f4 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(f8 / Math_fround(-f9)), Math_fround(-1.0e5))), Math_fround(1.0e5)));
 f5 = Math_fround(f9 - Math_fround(f8 * f4));
 f6 = Math_fround(_fminf(Math_fround(_fmaxf(Math_fround(Math_fround(-f10) / f2), Math_fround(-1.0e5))), Math_fround(1.0e5)));
 f7 = Math_fround(f4 - f6);
 if (Math_fround(Math_abs(Math_fround(f7))) < Math_fround(9.99999974e-06)) {
  i13 = i12;
  i1 = HEAP32[i13 + 4 >> 2] | 0;
  i12 = i11;
  HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i12 + 4 >> 2] = i1;
  return;
 } else {
  f7 = Math_fround(Math_fround(Math_fround(f2 - Math_fround(f10 * f6)) - f5) / f7);
  f10 = Math_fround(f9 + Math_fround(f3 * Math_fround(Math_fround(f5 + Math_fround(f4 * f7)) - f9)));
  HEAPF32[i11 >> 2] = Math_fround(f8 + Math_fround(f3 * Math_fround(f7 - f8)));
  HEAPF32[i11 + 4 >> 2] = f10;
  return;
 }
}

function _Compute_Funcs(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP16[i5 + 298 >> 1] | 0;
 i3 = i6 << 16 >> 16;
 i6 = i6 << 16 >> 16 == 16384;
 do if (i6) {
  i1 = HEAP16[i5 + 294 >> 1] | 0;
  i4 = i1 << 16 >> 16;
  HEAP32[i5 + 564 >> 2] = i4;
 } else {
  i1 = HEAP16[i5 + 300 >> 1] | 0;
  i2 = HEAP16[i5 + 296 >> 1] | 0;
  if (i1 << 16 >> 16 == 16384) {
   i4 = i2 << 16 >> 16;
   HEAP32[i5 + 564 >> 2] = i4;
   i1 = HEAP16[i5 + 294 >> 1] | 0;
   break;
  } else {
   i7 = HEAP16[i5 + 294 >> 1] | 0;
   i4 = (Math_imul(i2 << 16 >> 16, i1 << 16 >> 16) | 0) + (Math_imul(i7 << 16 >> 16, i3) | 0) >> 14;
   HEAP32[i5 + 564 >> 2] = i4;
   i1 = i7;
   break;
  }
 } while (0);
 do if (i1 << 16 >> 16 == 16384) HEAP32[i5 + 572 >> 2] = fb + 465; else {
  i1 = i5 + 572 | 0;
  if ((HEAP16[i5 + 296 >> 1] | 0) == 16384) {
   HEAP32[i1 >> 2] = fb + 466;
   break;
  } else {
   HEAP32[i1 >> 2] = fb + 467;
   break;
  }
 } while (0);
 do if ((HEAP16[i5 + 290 >> 1] | 0) == 16384) HEAP32[i5 + 576 >> 2] = fb + 465; else {
  i1 = i5 + 576 | 0;
  if ((HEAP16[i5 + 292 >> 1] | 0) == 16384) {
   HEAP32[i1 >> 2] = fb + 466;
   break;
  } else {
   HEAP32[i1 >> 2] = fb + 468;
   break;
  }
 } while (0);
 i1 = i5 + 584 | 0;
 HEAP32[i1 >> 2] = fb + 316;
 i2 = i5 + 588 | 0;
 HEAP32[i2 >> 2] = fb + 317;
 i3 = i5 + 564 | 0;
 do if ((i4 | 0) == 16384) {
  if (i6) {
   HEAP32[i1 >> 2] = fb + 318;
   HEAP32[i2 >> 2] = fb + 319;
   break;
  }
  if ((HEAP16[i5 + 300 >> 1] | 0) == 16384) {
   HEAP32[i1 >> 2] = fb + 320;
   HEAP32[i2 >> 2] = fb + 321;
  }
 } while (0);
 if ((((i4 | 0) < 0 ? 0 - i4 | 0 : i4) | 0) >= 1024) {
  i7 = i5 + 256 | 0;
  HEAP32[i7 >> 2] = 0;
  return;
 }
 HEAP32[i3 >> 2] = 16384;
 i7 = i5 + 256 | 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5Unity12PhysicsQuery15BoxCastNonAllocERK8Vector3fS3_S3_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction(i4, i5, i6, i7, i8, i9, i10, f11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 8 | 0;
 i1 = i14;
 if (!i9) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((HEAP16[gb + 1452800 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452800 | 0, i2);
  i3 = gb + 1452800 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i2 + 52 >> 0] = 0;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = 128;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151376 + 8;
 HEAP32[i2 + 68 >> 2] = i8;
 HEAP32[i2 + 72 >> 2] = i9;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE(0, i5, i6, i7, i10, f11, i12, i13, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZL33GeomOverlapCallback_SphereCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f12 = Math_fround(f15 * Math_fround(2.0));
 f9 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f10 = Math_fround(f9 * Math_fround(2.0));
 f9 = Math_fround(Math_fround(f15 * f12) + Math_fround(Math_fround(f9 * f10) + Math_fround(-1.0)));
 f15 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f8 = Math_fround(f15 * f10);
 f6 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f12 * f6));
 f6 = Math_fround(Math_fround(f12 * f15) - Math_fround(f10 * f6));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(f10 * f9);
 f8 = Math_fround(f10 * f8);
 f6 = Math_fround(f10 * f6);
 f10 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f15 = Math_fround(f10 + f9);
 f12 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f14 = Math_fround(f12 + f8);
 f11 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f13 = Math_fround(f6 + f11);
 HEAPF32[i7 >> 2] = f15;
 HEAPF32[i7 + 4 >> 2] = f14;
 HEAPF32[i7 + 8 >> 2] = f13;
 f8 = Math_fround(f12 - f8);
 f6 = Math_fround(f11 - f6);
 HEAPF32[i7 + 12 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i7 + 16 >> 2] = f8;
 HEAPF32[i7 + 20 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 i5 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i7, i7 + 12 | 0, i4 + 16 | 0, 0)) <= Math_fround(f6 * f6);
 STACKTOP = i1;
 return i5 | 0;
}

function __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 24 | 0;
 i6 = i11 + 12 | 0;
 i7 = i11;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 i8 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if ((i8 | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i9 = i5 + 11 | 0;
 i10 = i5 + 4 | 0;
 i1 = 0;
 do {
  __Z24scripting_cpp_string_forP12Il2CppString(i5, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i3, i1) | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 479510 | 0, 2);
  __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i5, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i12 = HEAP8[i9 >> 0] | 0;
  i4 = i12 << 24 >> 24 < 0;
  if ((i4 ? HEAP32[i10 >> 2] | 0 : i12 & 255) | 0) {
   i4 = __ZN8keywords6CreateEPKc(i4 ? HEAP32[i5 >> 2] | 0 : i5) | 0;
   i12 = i2 + (i4 >>> 5 << 2) | 0;
   HEAP32[i12 >> 2] = 1 << (i4 & 31) | HEAP32[i12 >> 2];
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i11;
 return;
}

function __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN9HeightmapC2EP11TerrainData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i1 >> 2] = i2;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i2 = i5;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i2 = i5;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i1 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 68 >> 2] = i2;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 100 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc7BodySim19postSwitchToDynamicEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 i1 = i4 + 188 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) __ZN5physx16PxsIslandManager12setKinematicERKNS_20PxsIslandManagerHookIjLj4294967295EEEb(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(i3) | 0, i1, 0);
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 156 | 0;
 if (HEAP32[i2 >> 2] | 0) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 48 >> 2] = 0;
   HEAP32[i1 + 52 >> 2] = 0;
   HEAP32[i1 + 56 >> 2] = 0;
   HEAP32[i1 + 32 >> 2] = 0;
   HEAP32[i1 + 36 >> 2] = 0;
   HEAP32[i1 + 40 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
  }
 }
 HEAP8[i4 + 146 >> 0] = 1;
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 if (!i1) {
  __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh(i4, 5, 0, 4);
  i3 = i4 + 144 | 0;
  i2 = HEAP16[i3 >> 1] | 0;
  i2 = i2 & 65535;
  i2 = i2 & 65019;
  i2 = i2 & 65535;
  HEAP16[i3 >> 1] = i2;
  __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE(i4, 4);
  return;
 }
 __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(i1, HEAP32[(HEAP32[i3 + 1008 >> 2] | 0) + 96 >> 2] | 0);
 __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh(i4, 5, 0, 4);
 i3 = i4 + 144 | 0;
 i2 = HEAP16[i3 >> 1] | 0;
 i2 = i2 & 65535;
 i2 = i2 & 65019;
 i2 = i2 & 65535;
 HEAP16[i3 >> 1] = i2;
 __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE(i4, 4);
 return;
}

function __ZN19AssetBundleManifest8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i6);
 i2 = i3 + 48 | 0;
 i4 = HEAP32[gb + 37052 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 367192 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 367209 | 0, HEAP32[gb + 37228 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS2_9allocatorIiEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 367233 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN13ConstantForce8TransferI14SafeBinaryReadEEvRT_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i6);
 i2 = i3 + 36 | 0;
 i4 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 801108 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 48 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 801116 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 801132 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i3 + 72 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 735705 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z24PlayerInitEngineGraphicsb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i2 = i7 + 8 | 0;
 i6 = i7 + 32 | 0;
 i5 = i7 + 20 | 0;
 if (!(__Z24InitializeEngineGraphicsb(i1) | 0)) {
  _printf_console(gb + 583528 | 0, i7);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 __ZNK12GraphicsCaps17CheckGPUSupportedEv(i6, __Z15GetGraphicsCapsv() | 0);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 if (!((i1 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255) | 0)) {
  __Z24PlayerLoadGlobalManagersPKcS0_j(i5, HEAP32[gb + 73492 >> 2] | 0, HEAP32[gb + 73496 >> 2] | 0, -1);
  i4 = HEAP8[i5 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  if (!((i1 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0)) {
   __ZN9ShaderLab28UpdateGlobalShaderPropertiesEf(Math_fround(-1.0));
   i2 = __ZN15GlobalCallbacks3GetEv() | 0;
   i3 = i2 + 10804 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) i1 = 1; else {
    i1 = 0;
    do {
     i4 = i2 + 10036 + (i1 * 12 | 0) | 0;
     if (!(HEAP8[i2 + 10036 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 10036 + (i1 * 12 | 0) + 4 >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
    i1 = 1;
   }
  } else {
   HEAP32[i3 >> 2] = i1 ? HEAP32[i5 >> 2] | 0 : i5;
   _printf_console(gb + 583636 | 0, i3);
   i1 = 0;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 } else {
  HEAP32[i2 >> 2] = i1 ? HEAP32[i6 >> 2] | 0 : i6;
  _printf_console(gb + 583587 | 0, i2);
  i1 = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN9BlobWrite8TransferIN7mecanim12statemachine18StateMachineMemoryEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim12statemachine18StateMachineMemory8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim12statemachine18StateMachineMemory8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx20InternalTriangleMesh15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 __ZN5physx2Gu13RTreeMidphase15exportExtraDataERNS_22PxSerializationContextE(i3 + 16 | 0, i2);
 i1 = i3 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0);
 }
 i1 = i3 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = HEAP8[i3 + 156 >> 0] & 2 ^ 2;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, Math_imul((i4 * 3 | 0) + 6 | 0, HEAP32[i3 + 4 >> 2] | 0) | 0);
 }
 i1 = i3 + 152 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
 }
 i1 = i3 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 4 >> 2] << 1 | 0);
 }
 i1 = i3 + 164 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 4 >> 2] << 2 | 0);
 }
 i1 = i3 + 168 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i3 + 4 >> 2] | 0) * 12 | 0);
 return;
}

function __ZN5physx13NpVolumeCache4fillERKNS_10PxGeometryERKNS_11PxTransformE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 + 44 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 48 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 52 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 56 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 60 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 64 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 68 >> 2] = HEAP32[i1 + 24 >> 2];
 i1 = i3 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 switch (HEAP32[i2 >> 2] | 0) {
 case 3:
  {
   HEAP32[i1 >> 2] = 3;
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 12 >> 2];
   break;
  }
 case 0:
  {
   i6 = i2;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   i2 = i1;
   HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i2 + 4 >> 2] = i5;
   break;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   break;
  }
 default:
  {
   HEAP32[i1 >> 2] = -1;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 704671 | 0, 135, gb + 704933 | 0, i4);
   HEAP8[i3 + 117 >> 0] = 1;
   HEAP8[i3 + 116 >> 0] = 1;
   i6 = 2;
   STACKTOP = i4;
   return i6 | 0;
  }
 }
 HEAP8[i3 + 117 >> 0] = 1;
 HEAP8[i3 + 116 >> 0] = 1;
 i6 = __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i3, 0, 0, 0) | 0;
 i5 = __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i3, 1, 0, 0) | 0;
 i6 = (i6 | 0) < (i5 | 0) ? i5 : i6;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN31CollisionModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 904 >> 2] | 0;
   HEAPF32[i3 + 224 >> 2] = f4;
   HEAP8[i3 + 230 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 144 | 0, i3 + 232 | 0, f4, HEAP16[i3 + 228 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 904 >> 2] | 0;
   HEAPF32[i3 + 488 >> 2] = f4;
   HEAP8[i3 + 494 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 408 | 0, i3 + 496 | 0, f4, HEAP16[i3 + 492 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 904 >> 2] | 0;
   HEAPF32[i3 + 752 >> 2] = f4;
   HEAP8[i3 + 758 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 672 | 0, i3 + 760 | 0, f4, HEAP16[i3 + 756 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 936 >> 2] = f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 940 >> 2] = f4;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 948 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 949 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 944 >> 2] = f4;
   return;
  }
 default:
  return;
 }
}

function __ZN13MonoBehaviour33AddImageEffectCallbacksToManagersEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i2 = i8 + 8 | 0;
 i4 = i8;
 i5 = i6 + 60 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i1 + 104 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 29832 | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 216 >> 2] | 0)) i2 = 0; else {
  i10 = (HEAP32[i5 >> 2] | 0) + 104 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = i2;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i1 + 4 >> 2] = i9;
  i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 216 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i2 = (__Z30scripting_method_has_attribute21ScriptingMethodIl2CppP11Il2CppClass(i7, i1) | 0) & 1;
 }
 if (!(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 220 >> 2] | 0)) i1 = 0; else {
  i9 = (HEAP32[i5 >> 2] | 0) + 104 | 0;
  i10 = HEAP32[i9 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = i10;
  i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 220 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  i1 = (__Z30scripting_method_has_attribute21ScriptingMethodIl2CppP11Il2CppClass(i7, i1) | 0) & 1;
 }
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 + 4 >> 2] = fb + 696;
 HEAP8[i7 + 8 >> 0] = i1;
 HEAP8[i7 + 9 >> 0] = i2;
 __ZN6Camera14AddImageFilterERK11ImageFilter(i3, i7);
 STACKTOP = i8;
 return;
}

function __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 64 | 0;
 i8 = i10 + 52 | 0;
 i9 = i10 + 8 | 0;
 i4 = i10;
 i5 = i2 + 16 | 0;
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 i7 = i2 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 >> 2] = gb + 65660 + 8;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = -1;
 HEAP32[i9 + 32 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = -2;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = -2;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i1 = __ZN19StreamedBinaryWriteILb0EE4InitE24TransferInstructionFlags20BuildTargetSelection(i9, i3, i1) | 0;
 __ZN12CachedWriter9InitWriteER15CacheWriterBase(i1, i8);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 64 >> 2] | 0, i6 | 0, i9 | 0);
 if (__ZN12CachedWriter15CompleteWritingEv(i1) | 0) {
  i9 = __ZNK12CachedWriter11GetPositionEv(i1) | 0;
  if ((i9 | 0) == (HEAP32[i7 >> 2] | 0)) {
   HEAP32[i8 >> 2] = gb + 65660 + 8;
   STACKTOP = i10;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467849 | 0, 0, gb + 467886 | 0, 76, 1, 0, 0, 0);
 HEAP32[i8 >> 2] = gb + 65660 + 8;
 STACKTOP = i10;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIhhEEPhEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if ((i2 & 255) < (i3 & 255)) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i1 >> 0] = i3;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_(i8, i8 + 1 | 0, i8 + 2 | 0, i8 + 3 | 0, i7 + -1 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 2 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i8, i8 + 1 | 0, i2, i1) | 0;
   i6 = i8 + 3 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    i5 = HEAP8[i6 >> 0] | 0;
    i4 = HEAP8[i2 >> 0] | 0;
    if ((i5 & 255) < (i4 & 255)) {
     i3 = i6;
     while (1) {
      HEAP8[i3 >> 0] = i4;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i3 = i2 + -1 | 0;
      i4 = HEAP8[i3 >> 0] | 0;
      if ((i5 & 255) >= (i4 & 255)) break; else {
       i9 = i2;
       i2 = i3;
       i3 = i9;
      }
     }
     HEAP8[i2 >> 0] = i5;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 1 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 1 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i5 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 4;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
 }
 HEAP32[i4 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4 + 12 | 0, i5);
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 40;
 HEAP32[i6 + 4 >> 2] = i4 + 36;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i5, i6, 0);
 i1 = i4 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i7 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i4 = i1;
  i2 = i2 | 0 ? i2 - i4 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i4;
 }
 i4 = i2 + i1 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i4 + 4;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i7;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i5, i6, 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim7releaseEb(i13, i12) {
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = i13 + 360 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i6 = i13 + 356 | 0;
  i7 = i13 + 60 | 0;
  i8 = i13 + 340 | 0;
  i9 = i13 + 352 | 0;
  i10 = i13 + 344 | 0;
  i11 = i13 + 336 | 0;
  i2 = i5;
  i3 = 0;
  while (1) {
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
   if (i1 | 0) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
    HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i1;
    i2 = HEAP32[i10 >> 2] | 0;
    HEAP32[i10 >> 2] = i2 + 1;
    if ((i2 | 0) >= ((HEAP32[i11 >> 2] | 0) * 50 | 0)) {
     __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i7);
     HEAP32[i10 >> 2] = 0;
    }
   }
   i1 = i3 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) break L1;
   i2 = HEAP32[i4 >> 2] | 0;
   i3 = i1;
  }
 } while (0);
 i1 = i13 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i12 = HEAP32[i13 >> 2] | 0;
  i12 = i12 + 4 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_vi(i12 | 0, i13 | 0);
  return;
 }
 i2 = HEAP32[(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i13) | 0) + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i2 = __ZN5physx10PxsContext20removeParticleSystemEPNS_20PxvParticleSystemSimEb(i2, HEAP32[i1 >> 2] | 0, i12 ^ 1) | 0;
 i1 = i13 + 52 | 0;
 if (!i12) __ZN5physx2Sc18ParticleSystemCore20returnStandaloneDataEPNS_15PxsParticleDataE(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = 0;
 i12 = HEAP32[i13 >> 2] | 0;
 i12 = i12 + 4 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_vi(i12 | 0, i13 | 0);
 return;
}

function __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z19b2ClipSegmentToLineP12b2ClipVertexPKS_RK6b2Vec2fi(i7, i8, i1, f2, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i9 = i9 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, f10 = f0, f11 = f0, i12 = 0, f13 = f0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f11 * Math_fround(HEAPF32[i8 >> 2]));
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i3 = i8 + 4 | 0;
 f4 = Math_fround(Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2]))) - f2);
 i5 = i8 + 12 | 0;
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i5 >> 2]));
 i6 = i8 + 16 | 0;
 f2 = Math_fround(Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i6 >> 2]))) - f2);
 if (!(f4 <= Math_fround(0.0))) i1 = 0; else {
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i1 = 1;
 }
 if (f2 <= Math_fround(0.0)) {
  i12 = i7 + (i1 * 12 | 0) | 0;
  HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i1 = i1 + 1 | 0;
 }
 if (!(Math_fround(f4 * f2) < Math_fround(0.0))) {
  i12 = i1;
  return i12 | 0;
 }
 f4 = Math_fround(f4 / Math_fround(f4 - f2));
 f10 = Math_fround(HEAPF32[i5 >> 2]);
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f10 - f2);
 f13 = Math_fround(HEAPF32[i6 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f11 + Math_fround(f4 * Math_fround(f13 - f11)));
 HEAPF32[i7 + (i1 * 12 | 0) >> 2] = Math_fround(f2 + Math_fround(f4 * f10));
 HEAPF32[i7 + (i1 * 12 | 0) + 4 >> 2] = f11;
 i12 = i7 + (i1 * 12 | 0) + 8 | 0;
 HEAP8[i12 >> 0] = i9;
 HEAP8[i12 + 1 >> 0] = HEAP8[i8 + 8 + 1 >> 0] | 0;
 HEAP8[i12 + 2 >> 0] = 0;
 HEAP8[i12 + 3 >> 0] = 1;
 i12 = i1 + 1 | 0;
 return i12 | 0;
}

function _sfnt_done_face(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i2) return;
 i3 = HEAP32[i2 + 100 >> 2] | 0;
 i4 = i2 + 532 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = (i5 | 0) != 0;
 if (i6) {
  i1 = HEAP32[i5 + 80 >> 2] | 0;
  if (i1 | 0) mftCall_vi(i1 | 0, i2 | 0);
  i1 = HEAP32[i5 + 100 >> 2] | 0;
  if (i1 | 0) mftCall_vi(i1 | 0, i2 | 0);
 }
 _UNITY_tt_face_done_kern(i2);
 i1 = i2 + 144 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 140 >> 2] = 0;
 i1 = i2 + 156 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP16[i2 + 152 >> 1] = 0;
 i1 = i2 + 104 | 0;
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i1 >> 2] | 0, i2 + 500 | 0);
 HEAP32[i2 + 504 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 _UNITY_FT_Stream_ReleaseFrame(i1, i2 + 680 | 0);
 _UNITY_FT_Stream_ReleaseFrame(i1, i2 + 688 | 0);
 HEAP32[i2 + 684 >> 2] = 0;
 HEAP32[i2 + 692 >> 2] = 0;
 i1 = i2 + 292 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i7 = i2 + 332 | 0;
  _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
  i7 = i2 + 336 | 0;
  _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 i7 = i2 + 544 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP16[i2 + 542 >> 1] = 0;
 if (i6) mftCall_vi(HEAP32[i5 + 52 >> 2] | 0, i2 | 0);
 i7 = i2 + 20 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i7 = i2 + 24 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i7 = i2 + 32 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 i7 = i2 + 664 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function _cexpf(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 16 | 0;
 i7 = i10 + 8 | 0;
 i8 = i10;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 do if (!i4) {
  HEAPF32[i6 >> 2] = Math_fround(+Math_exp(+f9));
  HEAPF32[i6 + 4 >> 2] = f3;
 } else {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = i1 & 2147483647;
  if (!i2) {
   f9 = Math_fround(+Math_sin(+f3));
   HEAPF32[i6 >> 2] = Math_fround(+Math_cos(+f3));
   HEAPF32[i6 + 4 >> 2] = f9;
   break;
  }
  if (i4 >>> 0 <= 2139095039) if ((i1 + -1118925336 | 0) >>> 0 < 9342557) {
   HEAPF32[i8 >> 2] = f9;
   HEAPF32[i8 + 4 >> 2] = f3;
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   ___ldexp_cexpf(i7, i5, 0);
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = i8;
   break;
  } else {
   f11 = Math_fround(+Math_exp(+f9));
   f9 = Math_fround(f11 * Math_fround(+Math_sin(+f3)));
   HEAPF32[i6 >> 2] = Math_fround(f11 * Math_fround(+Math_cos(+f3)));
   HEAPF32[i6 + 4 >> 2] = f9;
   break;
  }
  if ((i2 | 0) != 2139095040) {
   f11 = Math_fround(f3 - f3);
   HEAPF32[i6 >> 2] = f11;
   HEAPF32[i6 + 4 >> 2] = f11;
   break;
  }
  if ((i1 | 0) < 0) {
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
   break;
  } else {
   f11 = Math_fround(f3 - f3);
   HEAPF32[i6 >> 2] = f9;
   HEAPF32[i6 + 4 >> 2] = f11;
   break;
  }
 } while (0);
 STACKTOP = i10;
 return;
}

function __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 i2 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i2) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i2;
   i1 = 1;
   break;
  }
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2 | 0) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0)) {
  i7 = i1;
  return i7 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
  i7 = i1 + 1 | 0;
  return i7 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
  i7 = i1 + 2 | 0;
  return i7 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i7 = i1 + 3 | 0;
 return i7 | 0;
}

function __ZN5physx9PxTaskMgr15startSimulationEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i9 + 8 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 if (!(HEAP32[i9 + 56 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 i7 = i9 + 80 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i4 = i9 + 92 | 0; else {
  i2 = i9 + 76 | 0;
  i3 = i9 + 88 | 0;
  i5 = i9 + 96 | 0;
  i4 = i9 + 92 | 0;
  i6 = 0;
  do {
   i1 = HEAP32[i2 >> 2] | 0;
   do if ((HEAP32[i1 + (i6 * 20 | 0) + 8 >> 2] | 0) != 3) if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i1 + (i6 * 20 | 0) + 4 | 0) | 0)) {
    i1 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
     HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = i6;
     HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i3, i8) | 0;
     break;
    }
   } while (0);
   i6 = i6 + 1 | 0;
   HEAP32[i8 >> 2] = i6;
  } while (i6 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 i1 = i9 + 88 | 0;
 i2 = 0;
 i3 = 0;
 do {
  i2 = i2 | (__ZN5physx9PxTaskMgr12dispatchTaskEjb(i9, HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0, i2) | 0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == 0 | i2 ^ 1) {
  STACKTOP = i11;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(i1, i8, f2, i9, i10, i11) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 44 | 0;
 i4 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 i1 = i7 + 64 | 0;
 i12 = f2 == Math_fround(inf);
 f2 = i12 ? Math_fround(3402823469999999843913219.0e14) : f2;
 HEAP32[i3 >> 2] = gb + 114012 + 8;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = i9;
 switch (i10 | 0) {
 case 0:
  {
   HEAP8[i3 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i3 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i3 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP16[i4 + 16 >> 1] = 15;
 HEAP8[i4 + 18 >> 0] = 0;
 i9 = (HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 798 >> 0] | 0) != 0;
 i12 = HEAP32[gb + 1457404 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i12 >> 2] | 0) + 348 >> 2] | 0;
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 i14 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i13;
 HEAP32[i5 + 8 >> 2] = i14;
 i14 = HEAP32[i8 + 16 >> 2] | 0;
 i13 = HEAP32[i8 + 20 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + 4 >> 2] = i14;
 HEAP32[i6 + 8 >> 2] = i13;
 HEAP16[i1 >> 1] = i9 ? 143 : 15;
 mftCall_iiiifiiiii(i10 | 0, i12 | 0, i5 | 0, i6 | 0, +f2, i11 | 0, i1 | 0, i4 | 0, i3 | 0, 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i4;
  i1 = i5;
 }
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i2 >> 2] = 0; else {
  i4 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = i1 << 3;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  if ((i4 | 0) != (i4 + (i1 << 3) | 0)) _memset(i4 | 0, -1, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4 | 0 ? i4 - i2 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i6 = i1 + (i5 << 3) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 do if ((i1 | 0) != (i2 | 0)) {
  i3 = __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_(i1, i2, i4) | 0;
  if ((i3 | 0) != (i1 | 0)) {
   i6 = __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_(i3, i2, i4) | 0;
   if ((i6 | 0) == (i3 | 0)) i1 = i3; else {
    i5 = i4 + 4 | 0;
    i2 = HEAP32[i5 >> 2] | 0;
    if (((i2 - (HEAP32[i4 >> 2] | 0) | 0) / 24 | 0) >>> 0 >= 2) {
     __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i7, i2 + -24 | 0);
     i1 = HEAP32[i5 >> 2] | 0;
     i2 = i1 + -24 | 0;
     i3 = i1;
     while (1) {
      if ((i3 | 0) == (i2 | 0)) break;
      i4 = i3 + -24 | 0;
      HEAP32[i5 >> 2] = i4;
      __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i4);
      i3 = HEAP32[i5 >> 2] | 0;
     }
     i5 = HEAP8[i7 + 11 >> 0] | 0;
     i4 = i5 << 24 >> 24 < 0;
     __THREW__ = 0;
     invoke_iiii(fb + 519 | 0, i1 + -48 | 0, (i4 ? HEAP32[i7 >> 2] | 0 : i7) | 0, (i4 ? HEAP32[i7 + 4 >> 2] | 0 : i5 & 255) | 0) | 0;
     i5 = __THREW__;
     __THREW__ = 0;
     if (i5 & 1) {
      i8 = ___cxa_find_matching_catch_2() | 0;
      getTempRet0() | 0;
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      ___resumeException(i8 | 0);
     } else {
      __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i7);
      i1 = i6;
      break;
     }
    }
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb(i4, i5, i1, i6, i7, i8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, f17 = f0, i18 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f17 = Math_fround(HEAPF32[i4 + 276 >> 2]);
 i18 = f17 != Math_fround(0.0);
 f14 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 280 >> 2]);
 i16 = f15 != Math_fround(0.0);
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(Math_floor(Math_fround(Math_fround(f2 + (i18 ? f17 : f14)) + Math_fround(.5))));
 f13 = Math_fround(Math_floor(Math_fround(Math_fround((i16 ? f15 : f13) + f3) + Math_fround(.5))));
 f2 = Math_fround(Math_floor(Math_fround(f2 + Math_fround(.5))));
 HEAPF32[i11 >> 2] = f2;
 f3 = Math_fround(Math_floor(Math_fround(f3 + Math_fround(.5))));
 HEAPF32[i11 + 4 >> 2] = f3;
 HEAPF32[i11 + 8 >> 2] = Math_fround(f14 - f2);
 HEAPF32[i11 + 12 >> 2] = Math_fround(f13 - f3);
 f2 = Math_fround(HEAPF32[i5 + 256 >> 2]);
 if (f13 < f2) {
  STACKTOP = i12;
  return;
 }
 if (f3 > Math_fround(f2 + Math_fround(HEAPF32[i5 + 264 >> 2]))) {
  STACKTOP = i12;
  return;
 }
 i18 = __ZNK8GUIStyle16GetGUIStyleStateER8GUIStatebbbb(i4, i5, (HEAP8[(HEAP32[i5 + 276 >> 2] | 0) + 8 >> 0] | 0) != 0 & i7, i8, i9, i10) | 0;
 __ZNK8GUIStyle14DrawBackgroundER8GUIStateRK5RectTIfEPK13GUIStyleState(i4, i5, i11, i18);
 __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState(i4, i5, i11, i6, i18);
 STACKTOP = i12;
 return;
}

function __ZN7Terrain10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 52 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 64 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 68 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 76 >> 2] = 50;
 HEAPF32[i1 + 80 >> 2] = Math_fround(80.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 88 >> 0] = 1;
 HEAP8[i1 + 89 >> 0] = 1;
 HEAP8[i1 + 90 >> 0] = 1;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = -8421505;
 HEAPF32[i1 + 104 >> 2] = Math_fround(.078125);
 i2 = i1 + 152 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 188 >> 0] = 1;
 i2 = i1 + 192 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 200 >> 0] = 1;
 HEAP32[i1 + 204 >> 2] = 7;
 i1 = i1 + 208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i4 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 >> 2] = i3;
  i1 = i6;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i1, i4 + 8 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 i6 = i1 + (i5 * 12 | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
   i5 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN17InternalIndexPool11freeIndicesEjRKN5physx16PxStrideIteratorIKjEE(i9, i13, i12) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 8 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i10 = i9 + 8 | 0;
 i11 = i9 + 12 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if ((i1 - i3 | 0) >>> 0 < i13 >>> 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 666952 | 0, 291, gb + 667038 | 0, i14);
  STACKTOP = i14;
  return;
 }
 i4 = (i13 | 0) == 0;
 if (i4) {
  STACKTOP = i14;
  return;
 }
 i5 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i12 + 4 >> 2] | 0;
 i6 = 0;
 do {
  if ((HEAP32[i5 + (Math_imul(i2, i6) | 0) >> 2] | 0) >>> 0 >= i1 >>> 0) {
   i8 = 9;
   break;
  }
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < i13 >>> 0);
 if ((i8 | 0) == 9) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 666952 | 0, 302, gb + 667162 | 0, i7);
  STACKTOP = i14;
  return;
 }
 if (i4) {
  STACKTOP = i14;
  return;
 }
 i5 = i12 + 4 | 0;
 i4 = i9 + 16 | 0;
 i1 = 0;
 while (1) {
  i2 = (HEAP32[i12 >> 2] | 0) + (Math_imul(HEAP32[i5 >> 2] | 0, i1) | 0) | 0;
  if ((HEAP32[i4 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i10, i2) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i13 | 0)) break;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 STACKTOP = i14;
 return;
}

function __ZL34GeomMTDCallback_CapsuleHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f17 * Math_fround(2.0));
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(f11 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f11 * f12) + Math_fround(-1.0)));
 f17 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f17 * f12);
 f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f14 * f9));
 f9 = Math_fround(Math_fround(f14 * f17) - Math_fround(f12 * f9));
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(f12 * f11);
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f12 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(f12 + f11);
 f14 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(f14 + f10);
 f13 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f15 = Math_fround(f9 + f13);
 HEAPF32[i8 >> 2] = f17;
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 f10 = Math_fround(f14 - f10);
 f9 = Math_fround(f13 - f9);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f12 - f11);
 HEAPF32[i8 + 16 >> 2] = f10;
 HEAPF32[i8 + 20 >> 2] = f9;
 HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 i6 = __ZN5physx2Gu29computeMTD_CapsuleHeightFieldERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z45SceneManager_CUSTOM_INTERNAL_CALL_CreateSceneP12Il2CppStringRi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i5 = i8 + 48 | 0;
 i6 = i8 + 44 | 0;
 i7 = i8 + 16 | 0;
 i2 = i8 + 32 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 if (__ZNK11ICallString6IsNullEv(i6) | 0) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 561822 | 0);
 if (!(__ZNK11ICallString6LengthEv(i6) | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561858 | 0, i8);
 i1 = __Z15GetSceneManagerv() | 0;
 __ZNK11ICallStringcv8UnityStrEv(i7, i6);
 i1 = __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr(i1, i7) | 0;
 if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i7 >> 2] | 0;
  i10 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i10;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 if (i1 | 0) {
  __ZNK11ICallString6ToUTF8Ev(i2, i6);
  HEAP32[i3 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561895 | 0, i3);
 }
 i1 = __ZN19RuntimeSceneManager11CreateSceneEv(__Z15GetSceneManagerv() | 0) | 0;
 __ZNK11ICallStringcv8UnityStrEv(i7, i6);
 __ZN10UnityScene7SetNameERK8UnityStr(i1, i7);
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  i10 = i1 + 8 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i4 >> 2] = i10;
  STACKTOP = i8;
  return;
 }
 i10 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 i10 = i1 + 8 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i4 >> 2] = i10;
 STACKTOP = i8;
 return;
}

function __ZNK5physx2Sc9ClothCore14getWorldBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 32 | 0;
 i5 = i3;
 i6 = i2 + 28 | 0;
 i16 = HEAP32[i6 >> 2] | 0;
 i16 = mftCall_ii(HEAP32[(HEAP32[i16 >> 2] | 0) + 352 >> 2] | 0, i16 | 0) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 356 >> 2] | 0, i2 | 0) | 0;
 f15 = Math_fround(HEAPF32[i16 >> 2]);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(f15 - f9);
 f14 = Math_fround(HEAPF32[i16 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(f14 - f8);
 f13 = Math_fround(HEAPF32[i16 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f13 - f7);
 f9 = Math_fround(f15 + f9);
 f8 = Math_fround(f14 + f8);
 f7 = Math_fround(f13 + f7);
 HEAPF32[i4 >> 2] = f12;
 HEAPF32[i4 + 4 >> 2] = f11;
 HEAPF32[i4 + 8 >> 2] = f10;
 HEAPF32[i4 + 12 >> 2] = f9;
 HEAPF32[i4 + 16 >> 2] = f8;
 HEAPF32[i4 + 20 >> 2] = f7;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 64 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i1, i5, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 40 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 745065 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 40 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP16[i1 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
   HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | 0;
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i9 = i2 + 32 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1 + 32 | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 40 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 40 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN12AudioManager13AwakeFromLoadE17AwakeFromLoadMode(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, f10 = f0;
 if (HEAP8[i8 + 224 >> 0] | 0) return;
 i7 = i8 + 88 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  __ZN12AudioManager8InitFMODEv(i8) | 0;
  HEAP8[i8 + 40 >> 0] = 0;
  if (!(HEAP32[i7 >> 2] | 0)) return;
 }
 if ((HEAP32[i8 + 160 >> 2] | 0) == (HEAP32[i8 + 124 >> 2] | 0)) if ((HEAP32[i8 + 164 >> 2] | 0) == (HEAP32[i8 + 128 >> 2] | 0)) if ((HEAP32[i8 + 156 >> 2] | 0) == (HEAP32[i8 + 120 >> 2] | 0)) if ((HEAP32[i8 + 168 >> 2] | 0) == (HEAP32[i8 + 132 >> 2] | 0)) if ((HEAP32[i8 + 172 >> 2] | 0) == (HEAP32[i8 + 136 >> 2] | 0)) {
  i6 = i8 + 176 | 0;
  i4 = i8 + 225 | 0;
  i1 = HEAP8[i4 >> 0] | 0;
  if ((HEAP8[i6 >> 0] | 0) != i1 << 24 >> 24) {
   i2 = HEAP32[i8 + 48 >> 2] | 0;
   i5 = i8 + 44 | 0;
   i3 = i2;
   if ((i3 | 0) != (i5 | 0)) {
    i1 = i3;
    do {
     i3 = i2;
     i2 = HEAP32[i1 + 4 >> 2] | 0;
     __ZN11AudioSource31UpdateEffectVirtualizationStateEb(HEAP32[i3 + 8 >> 2] | 0, 1);
     i1 = i2;
    } while ((i1 | 0) != (i5 | 0));
    i1 = HEAP8[i4 >> 0] | 0;
   }
   HEAP8[i6 >> 0] = i1;
  }
 } else i9 = 9; else i9 = 9; else i9 = 9; else i9 = 9; else i9 = 9;
 if ((i9 | 0) == 9) {
  __ZN12AudioManager29ShutdownReinitializeAndReloadEv(i8);
  if (!(HEAP32[i7 >> 2] | 0)) return;
 }
 f10 = Math_fround(HEAPF32[i8 + 28 >> 2]);
 i9 = i8 + 32 | 0;
 HEAPF32[i9 >> 2] = f10;
 __ZN4FMOD12ChannelGroup9setVolumeEf(HEAP32[i8 + 100 >> 2] | 0, f10) | 0;
 __ZN4FMOD12ChannelGroup9setVolumeEf(HEAP32[i8 + 108 >> 2] | 0, Math_fround(HEAPF32[i9 >> 2])) | 0;
 __ZN4FMOD6System13set3DSettingsEfff(HEAP32[i7 >> 2] | 0, Math_fround(0.0), Math_fround(1.0), Math_fround(HEAPF32[i8 + 36 >> 2])) | 0;
 return;
}

function __Z49ParticleSystem_LightsModule_CUSTOM_GetLightPrefabP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i5 = HEAP32[(HEAP32[i2 + 920 >> 2] | 0) + 16 >> 2] | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 13;
   }
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z18FilterCubeSurfacesP13CImageSurfaceS0_fibfiiifR17PrecomputeContextR15ProgressContext(i14, i15, f2, i18, i19, f20, i1, i21, i3, f4, i16, i17) {
 i14 = i14 | 0;
 i15 = i15 | 0;
 f2 = Math_fround(f2);
 i18 = i18 | 0;
 i19 = i19 | 0;
 f20 = Math_fround(f20);
 i1 = i1 | 0;
 i21 = i21 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i16 = i16 | 0;
 i17 = i17 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, f22 = f0, f23 = f0;
 i13 = HEAP32[i15 + 4 >> 2] | 0;
 f11 = Math_fround(Math_fround(+Math_atan2(1.0, +Math_fround(HEAP32[i14 + 4 >> 2] | 0))) * Math_fround(57.2957763));
 f2 = Math_fround(f2 * Math_fround(.5));
 f2 = f2 < f11 ? f11 : f2;
 i6 = f2 > Math_fround(90.0);
 f2 = i6 ? Math_fround(90.0) : f2;
 i6 = ~~Math_fround(Math_ceil(Math_fround(f2 / Math_fround(f11 * f4))));
 i6 = (i3 | 0) > 0 & (i6 | 0) > (i3 | 0) ? i3 : (i6 | 0) < 1 ? 1 : i6;
 f2 = Math_fround(+Math_cos(+Math_fround(f2 * Math_fround(.0174532924))));
 f4 = Math_fround(i13 | 0);
 i7 = i17 + 8 | 0;
 i8 = i17 + 12 | 0;
 i9 = i17 + 4 | 0;
 if ((i13 | 0) > 0) i1 = 0; else return;
 do {
  i10 = i15 + (i1 << 4) | 0;
  f11 = Math_fround(i1 | 0);
  i3 = 0;
  do {
   i5 = i3;
   i3 = i3 + 1 | 0;
   __Z10FilterRowsP13CImageSurfaceRS_iiiiifbfiiR17PrecomputeContext(i14, i10, i1, i5, i3, i6, i18, f2, i19, f20, 0, i21, i16);
   i12 = HEAP32[i17 >> 2] | 0;
   if (i12 | 0) {
    f23 = Math_fround(Math_fround(f11 + Math_fround(Math_fround(i5 | 0) / f4)) / Math_fround(6.0));
    f22 = Math_fround(HEAPF32[i7 >> 2]);
    f22 = Math_fround(f22 + Math_fround(f23 * Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f22)));
    mftCall_vfi(i12 | 0, +f22, HEAP32[i9 >> 2] | 0);
   }
  } while ((i3 | 0) != (i13 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 6);
 return;
}

function __ZN9Animation14SetCullingTypeENS_11CullingTypeE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = (i1 | 1 | 0) == 3 ? 1 : i1;
 i5 = i7 + 44 | 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case 1:
  {
   i6 = i7 + 72 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i7 + 68 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    do {
     __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i7);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i2 | 0));
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   }
   break;
  }
 case 0:
  {
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 136 >> 2] | 0, i7 | 0);
   break;
  }
 default:
  {}
 }
 HEAP32[i5 >> 2] = i4;
 switch (i4 | 0) {
 case 1:
  {
   if ((HEAP32[i7 + 104 >> 2] | 0) == (HEAP32[i7 + 108 >> 2] | 0)) return;
   i4 = i7 + 72 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i3 = i7 + 68 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != (i2 | 0)) {
    do {
     __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i7);
     i1 = i1 + 4 | 0;
    } while ((i1 | 0) != (i2 | 0));
    i1 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
   }
   __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   __ZN9Animation25CheckRendererVisibleStateEv(i7);
   return;
  }
 case 0:
  {
   if (HEAP32[i7 + 256 >> 2] | 0) return;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i1, i7, i8, i12) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 8 | 0;
 i10 = i13;
 i9 = i13 + 16 | 0;
 i4 = HEAP32[i1 + 336 >> 2] | 0;
 if (!i4) {
  STACKTOP = i13;
  return;
 }
 i5 = i1 + 332 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = i1 + 328 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + i6 | 0;
 if ((i3 | 0) > 9) {
  STACKTOP = i13;
  return;
 }
 switch (i7 | 0) {
 case 4:
 case 8:
 case 32:
  {
   HEAP32[i1 >> 2] = i2 + 1;
   break;
  }
 case 2:
  {
   HEAP32[i5 >> 2] = i6 + 1;
   break;
  }
 default:
  {
   if (!((i3 | 0) == 0 & (i4 | 0) == 2)) {
    STACKTOP = i13;
    return;
   }
   HEAP32[i9 >> 2] = i12;
   __ZN5physx6shdfnd10Foundation9errorImplENS_11PxErrorCode4EnumEPKciS5_Pi(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, i7, gb + 669993 | 0, 57, i8, i9);
   STACKTOP = i13;
   return;
  }
 }
 HEAP32[i9 >> 2] = i12;
 __ZN5physx6shdfnd10Foundation9errorImplENS_11PxErrorCode4EnumEPKciS5_Pi(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, i7, gb + 669993 | 0, 57, i8, i9);
 switch (i3 | 0) {
 case 0:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 1, gb + 669993 | 0, 65, gb + 670099 | 0, i10);
   STACKTOP = i13;
   return;
  }
 case 9:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 1, gb + 669993 | 0, 69, gb + 670157 | 0, i11);
   STACKTOP = i13;
   return;
  }
 default:
  {
   STACKTOP = i13;
   return;
  }
 }
}

function __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP32[i4 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i7 >> 2] = i1;
  i1 = i3;
 }
 HEAP8[i4 + 40 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 41 >> 0] = i1;
 i1 = i4 + 42 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i8 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i8;
  HEAP32[i7 >> 2] = i3;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN17GeneralConnection13MulticastInfo5ParseEPKcPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i9 + 296 | 0;
 i5 = i9 + 40 | 0;
 i6 = i9 + 36 | 0;
 i7 = i1 + 24 | 0;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i8 + 8 >> 2] = i1 + 28;
 HEAP32[i8 + 12 >> 2] = i1 + 32;
 HEAP32[i8 + 16 >> 2] = i1 + 36;
 HEAP32[i8 + 20 >> 2] = i6;
 HEAP32[i8 + 24 >> 2] = i5;
 HEAP32[i8 + 28 >> 2] = i9 + 32;
 if ((_sscanf(i2, gb + 459520 | 0, i8) | 0) != 8) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  HEAP16[i1 + 52 >> 1] = 0;
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!i3) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, _strlen(i4) | 0);
 } else __Z10InAddrToIPP11sockaddr_in(i8, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 12 | 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i5, _strlen(i5) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 40 | 0, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP8[i1 + 52 >> 0] = (HEAP32[i6 >> 2] | 0) == (HEAP32[gb + 65596 >> 2] | 0) & 1;
 __ZN17GeneralConnection13MulticastInfo16SetLocalhostFlagEv(i1);
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z35MonoBehaviour_CUSTOM_StartCoroutineP12Il2CppObjectP12Il2CppStringS0_(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = i7 + 8 | 0;
 i2 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 __ZN9Scripting11RaiseIfNullEPv((__ZNK11ICallString6IsNullEv(i2) | 0) & 1 ^ 1);
 if (!i5) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549110 | 0, i3);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549110 | 0, i3);
 __ZNK11ICallString6ToUTF8Ev(i4, i2);
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i8 = i1 << 24 >> 24 < 0;
 i1 = (i8 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255) + 1 | 0;
 i2 = _malloc(i1) | 0;
 _strncpy(i2, i8 ? HEAP32[i4 >> 2] | 0 : i4, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  i8 = __ZN13MonoBehaviour21StartCoroutineManagedEPKcP12Il2CppObject(i1, i2, i6) | 0;
  _free(i2);
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN5physx11readIndicesEjjPjRNS_13PxInputStreamEb(i1, i7, i6, i5, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i2 = i8 + 2 | 0;
 if (i1 >>> 0 < 256) {
  if (!i7) {
   STACKTOP = i8;
   return;
  }
  i1 = 0;
  do {
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, 1) | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU8[i2 >> 0];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
 if (i1 >>> 0 >= 65536) {
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i6 | 0, i7 << 2 | 0) | 0;
  if ((i7 | 0) == 0 | i3 ^ 1) {
   STACKTOP = i8;
   return;
  } else i1 = 0;
  do {
   i5 = i6 + (i1 << 2) | 0;
   i4 = HEAP8[i5 >> 0] | 0;
   i3 = i5 + 3 | 0;
   HEAP8[i5 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = i4;
   i3 = i5 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
   i5 = i5 + 2 | 0;
   HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i4;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i2 = i4 + 1 | 0;
 if (i3) {
  i1 = 0;
  do {
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i4 | 0, 2) | 0;
   i3 = HEAP16[i4 >> 1] | 0;
   HEAP8[i4 >> 0] = (i3 & 65535) >>> 8;
   HEAP8[i2 >> 0] = i3;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU16[i4 >> 1];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 } else {
  i1 = 0;
  do {
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i4 | 0, 2) | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU16[i4 >> 1];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
}

function __ZN4math4Axes8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i8, gb + 906532 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i6, i8 + 16 | 0, gb + 906546 | 0, 0);
 i5 = i8 + 32 | 0;
 i9 = i6 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i6 + 24 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i5 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i1 = i5 + 8 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 __ZN4math5Limit8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 44 | 0, i6);
 i1 = i8 + 68 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i8 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  return;
 }
}

function __ZN4Mesh13GetVertexDataEPvjji(i3, i4, i7, i8, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i2 = i12;
 i10 = i12 + 16 | 0;
 if (i9 >>> 0 > 3) {
  if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427212 | 0, 0, gb + 425656 | 0, 767, 1, i1, 0, 0);
  STACKTOP = i12;
  return;
 }
 i5 = HEAP32[i3 + 32 >> 2] | 0;
 i6 = i5 + 8 | 0;
 i1 = HEAPU8[i6 + 32 + (i9 * 12 | 0) + 10 >> 0] | 0;
 if ((i1 | 0) != (i7 | 0)) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i2 + 4 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 427250 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 774, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i5 + 100 >> 2] | 0;
 if ((i1 | 0) == (i8 | 0)) {
  _memcpy(i4 | 0, (HEAP32[i5 + 92 >> 2] | 0) + (HEAP32[i6 + 32 + (i9 * 12 | 0) + 4 >> 2] | 0) | 0, Math_imul(i8, i7) | 0) | 0;
  __ZN4Mesh16SetChannelsDirtyEjb(i3, HEAP32[i6 + 32 + (i9 * 12 | 0) >> 2] | 0, 0);
  STACKTOP = i12;
  return;
 } else {
  HEAP32[i11 >> 2] = i8;
  HEAP32[i11 + 4 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 427324 | 0, i11);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 425656 | 0, 781, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  STACKTOP = i12;
  return;
 }
}

function __ZN20GpuProgramParametersD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 112 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i7 + 116 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = i7 + 92 | 0;
 if ((HEAP32[i7 + 108 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 96 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i7 + 80 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 84 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -52 | 0;
    HEAP32[i6 >> 2] = i3;
    i4 = i2 + -48 | 0;
    if ((HEAP32[i2 + -32 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -44 | 0);
     HEAP32[i4 >> 2] = 0;
     i2 = HEAP32[i6 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i7 + 60 | 0;
 if ((HEAP32[i7 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i7 + 52 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i7 + 36 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i7 + 40 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i2 | 0) >>> 4) << 4);
  __ZdlPv(i1);
 }
 i1 = i7 + 16 | 0;
 if ((HEAP32[i7 + 32 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 20 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i10, i3, i1) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i10 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = i1 + (i4 * 24 | 0) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i10);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i3;
  }
  HEAP32[i1 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14b2CapsuleShape12SetByEndCapsEfRK6b2Vec2S2_S2_(i7, f2, i4, i1, i8) {
 i7 = i7 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var f3 = f0, f5 = f0, f6 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, f16 = f0, f17 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAPF32[i7 + 8 >> 2] = f2;
 i13 = i4;
 i14 = HEAP32[i13 + 4 >> 2] | 0;
 i15 = i7 + 12 | 0;
 HEAP32[i15 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i15 + 4 >> 2] = i14;
 i15 = i1;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i7 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f5 - f6);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(f3 - f2);
 if (Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) < Math_fround(6.24999984e-06)) {
  HEAP32[i7 + 176 >> 2] = 0;
  i15 = 1;
  STACKTOP = i10;
  return i15 | 0;
 }
 f11 = Math_fround(HEAPF32[i8 >> 2]);
 f17 = Math_fround(f6 - f11);
 f12 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f16 = Math_fround(f2 - f12);
 HEAPF32[i9 >> 2] = f17;
 HEAPF32[i9 + 4 >> 2] = f16;
 f2 = Math_fround(f2 + f12);
 HEAPF32[i9 + 8 >> 2] = Math_fround(f6 + f11);
 HEAPF32[i9 + 12 >> 2] = f2;
 f6 = Math_fround(f3 + f12);
 HEAPF32[i9 + 16 >> 2] = Math_fround(f5 + f11);
 HEAPF32[i9 + 20 >> 2] = f6;
 f12 = Math_fround(f3 - f12);
 HEAPF32[i9 + 24 >> 2] = Math_fround(f5 - f11);
 HEAPF32[i9 + 28 >> 2] = f12;
 if (__ZN14b2PolygonShape8ValidateEPK6b2Vec2i(i9, 4) | 0) {
  __ZN14b2PolygonShape3SetEPK6b2Vec2i(i7 + 28 | 0, i9, 4);
  i1 = 1;
 } else i1 = 0;
 i15 = i1;
 STACKTOP = i10;
 return i15 | 0;
}

function __ZN14PhysicsManager19CapsuleCastNonAllocERK8Vector3fS2_fS2_P10RaycastHitifi23QueryTriggerInteraction(i4, i5, i6, f7, i8, i9, i10, f11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 8 | 0;
 i1 = i14;
 if (!i10) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((HEAP16[gb + 1452788 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452788 | 0, i2);
  i3 = gb + 1452788 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 736 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i2 + 52 >> 0] = 0;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = 128;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151376 + 8;
 HEAP32[i2 + 68 >> 2] = i9;
 HEAP32[i2 + 72 >> 2] = i10;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE(0, i5, i6, f7, i8, f11, i12, i13, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5physx2Sc13ConstraintSim14postFlagChangeENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEES5_(i6, i3, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP16[i1 >> 1] | 0;
 HEAP32[i6 + 84 >> 2] = i2 & 65535;
 i2 = (i2 & 6) == 0;
 i1 = (HEAP16[i3 >> 1] & 6) != 0;
 if (!(i1 | i2)) {
  i4 = HEAP32[i6 + 108 >> 2] | 0;
  i2 = HEAP32[i6 + 112 >> 2] | 0;
  i3 = (i4 | 0) != 0;
  if (i3) {
   if (HEAP32[i4 + 60 >> 2] | 0) i5 = 4;
  } else i5 = 4;
  do if ((i5 | 0) == 4) {
   if (i2 | 0) if (!(HEAP32[i2 + 60 >> 2] | 0)) break;
   i1 = HEAP32[(HEAP32[i6 + 96 >> 2] | 0) + 96 >> 2] | 0;
   if (i3) {
    __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(HEAP32[i4 + 60 >> 2] | 0, i1);
    return;
   } else {
    __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(HEAP32[i2 + 60 >> 2] | 0, i1);
    return;
   }
  } while (0);
  __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE(HEAP32[(HEAP32[i6 + 96 >> 2] | 0) + 96 >> 2] | 0, i6);
  return;
 }
 if (!(i1 & i2)) return;
 if (HEAP8[i6 + 116 >> 0] & 1) {
  __ZN5physx2Sc27ConstraintProjectionManager29removeFromPendingGroupUpdatesERNS0_13ConstraintSimE(HEAP32[(HEAP32[i6 + 96 >> 2] | 0) + 96 >> 2] | 0, i6);
  return;
 }
 i1 = HEAP32[i6 + 108 >> 2] | 0;
 if (!i1) i5 = 14; else {
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  if (!i1) i5 = 14;
 }
 if ((i5 | 0) == 14) {
  i1 = HEAP32[i6 + 112 >> 2] | 0;
  if (!i1) return;
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  if (!i1) return;
 }
 __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(HEAP32[(HEAP32[i6 + 96 >> 2] | 0) + 96 >> 2] | 0, i1, 0);
 return;
}

function __ZN5physx22getEdgeTriangleIndicesERKNS_2Gu11HeightFieldERKNS_8EdgeDataEPj(i6, i1, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 16 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 switch ((HEAP32[i1 >> 2] | 0) + (Math_imul(i7, -3) | 0) | 0) {
 case 0:
  {
   if (i3 >>> 0 >= (i2 + -1 | 0) >>> 0) {
    i8 = 0;
    return i8 | 0;
   }
   do if (!i5) i2 = 0; else {
    i3 = i7 - i2 | 0;
    i1 = i3 << 1;
    if ((HEAP8[(HEAP32[i6 + 36 >> 2] | 0) + (i3 << 2) + 2 >> 0] | 0) < 0) {
     HEAP32[i8 >> 2] = i1;
     i2 = 1;
     break;
    } else {
     HEAP32[i8 >> 2] = i1 | 1;
     i2 = 1;
     break;
    }
   } while (0);
   if (i5 >>> 0 >= (i4 + -1 | 0) >>> 0) {
    i8 = i2;
    return i8 | 0;
   }
   i1 = i7 << 1;
   if ((HEAP8[(HEAP32[i6 + 36 >> 2] | 0) + (i7 << 2) + 2 >> 0] | 0) < 0) {
    HEAP32[i8 + (i2 << 2) >> 2] = i1 | 1;
    i8 = i2 + 1 | 0;
    return i8 | 0;
   } else {
    HEAP32[i8 + (i2 << 2) >> 2] = i1;
    i8 = i2 + 1 | 0;
    return i8 | 0;
   }
  }
 case 1:
  {
   if (!(i5 >>> 0 < (i4 + -1 | 0) >>> 0 & i3 >>> 0 < (i2 + -1 | 0) >>> 0)) {
    i8 = 0;
    return i8 | 0;
   }
   i7 = i7 << 1;
   HEAP32[i8 >> 2] = i7;
   HEAP32[i8 + 4 >> 2] = i7 | 1;
   i8 = 2;
   return i8 | 0;
  }
 case 2:
  {
   if (i5 >>> 0 >= (i4 + -1 | 0) >>> 0) {
    i8 = 0;
    return i8 | 0;
   }
   if (!i3) i1 = 0; else {
    HEAP32[i8 >> 2] = (i7 << 1) + -1;
    i1 = 1;
   }
   if (i3 >>> 0 >= (i2 + -1 | 0) >>> 0) {
    i8 = i1;
    return i8 | 0;
   }
   HEAP32[i8 + (i1 << 2) >> 2] = i7 << 1;
   i8 = i1 + 1 | 0;
   return i8 | 0;
  }
 default:
  {
   i8 = 0;
   return i8 | 0;
  }
 }
 return 0;
}

function __ZN5UmbramlERKNS_9Matrix4x3ES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i4;
 HEAP32[i16 >> 2] = HEAP32[i2 >> 2];
 i15 = i16 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 + 4 >> 2];
 i14 = i16 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 + 8 >> 2];
 i13 = i16 + 12 | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 + 12 >> 2];
 i12 = i16 + 16 | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 + 16 >> 2];
 i11 = i16 + 20 | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 + 20 >> 2];
 i10 = i16 + 24 | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 + 24 >> 2];
 i9 = i16 + 28 | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 + 28 >> 2];
 i8 = i16 + 32 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 + 32 >> 2];
 i7 = i16 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 36 >> 2];
 i6 = i16 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 40 >> 2];
 i5 = i16 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 + 44 >> 2];
 __ZN5Umbra9Matrix4x3mLERKS0_(i16, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i5 >> 2];
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i6 >> 2] = Math_fround(1.0);
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 20 >> 2] = Math_fround(1.0);
 i7 = i6 + 24 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 40 >> 2] = Math_fround(1.0);
 i7 = i6 + 44 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 _memset(i6 + 64 | 0, 0, 276) | 0;
 HEAPF32[i6 + 340 >> 2] = Math_fround(1.0);
 i7 = i6 + 344 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 360 >> 2] = Math_fround(1.0);
 i7 = i6 + 364 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 380 >> 2] = Math_fround(1.0);
 i7 = i6 + 384 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAPF32[i6 + 400 >> 2] = Math_fround(1.0);
 i7 = i6 + 404 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP8[i7 + 32 >> 0] = 0;
 HEAP32[i6 + 432 >> 2] = i5;
 __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE(i1, i2, i3, i4, i5);
 return;
}

function __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i11 = i8 + 52 | 0;
 HEAP32[i11 >> 2] = 0;
 i7 = i8 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i4 = i8 + 32 | 0;
  i5 = i8 + 56 | 0;
  i6 = i8 + 4 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   if ((i2 | 0) != -1) {
    __ZNK13b2DynamicTree5QueryI12b2BroadPhaseEEvPT_RK6b2AABB(i8, i8, (HEAP32[i6 >> 2] | 0) + (i2 * 36 | 0) | 0);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  i1 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0;
 HEAP32[i7 >> 2] = 0;
 i7 = i8 + 44 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 >> 2] = fb + 859;
 __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_(i6, i6 + (i1 << 3) | 0, i9);
 if ((HEAP32[i11 >> 2] | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i5 = i8 + 4 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = i4 + (i1 << 3) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i4 = i4 + (i1 << 3) + 4 | 0;
  __ZN16b2ContactManager7AddPairEPvS0_(i10, HEAP32[i6 + ((HEAP32[i3 >> 2] | 0) * 36 | 0) + 16 >> 2] | 0, HEAP32[i6 + ((HEAP32[i4 >> 2] | 0) * 36 | 0) + 16 >> 2] | 0);
  i6 = HEAP32[i11 >> 2] | 0;
  i1 = i1 + 1 | 0;
  do {
   if ((i1 | 0) >= (i6 | 0)) break;
   i2 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i2 + (i1 << 3) >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) break;
   i9 = (HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (HEAP32[i4 >> 2] | 0);
   i1 = (i9 & 1) + i1 | 0;
  } while (i9);
 } while ((i1 | 0) < (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZL29GeomMTDCallback_CapsuleConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f17 * Math_fround(2.0));
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(f11 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f11 * f12) + Math_fround(-1.0)));
 f17 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f17 * f12);
 f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f14 * f9));
 f9 = Math_fround(Math_fround(f14 * f17) - Math_fround(f12 * f9));
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(f12 * f11);
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f12 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(f12 + f11);
 f14 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(f14 + f10);
 f13 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f15 = Math_fround(f9 + f13);
 HEAPF32[i8 >> 2] = f17;
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 f10 = Math_fround(f14 - f10);
 f9 = Math_fround(f13 - f9);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f12 - f11);
 HEAPF32[i8 + 16 >> 2] = f10;
 HEAPF32[i8 + 20 >> 2] = f9;
 HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 i6 = __ZN5physx2Gu24computeMTD_CapsuleConvexERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES9_(i4, i1, i8, i5, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK17AnimationCurveTplI11QuaternionfE8WrapTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i5 = HEAP32[i1 + 152 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + (((HEAP32[i1 + 164 >> 2] | 0) + -1 | 0) * 52 | 0) >> 2]);
 if (f3 > f2) switch (HEAP32[i1 + 172 >> 2] | 0) {
 case 0:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f4 = Math_fround(f6 * Math_fround(2.0));
   f4 = Math_fround(Math_fround(f2 - Math_fround(f4 * Math_fround(Math_floor(Math_fround(f2 / f4))))) - f6);
   i5 = f4 < Math_fround(0.0);
   f2 = Math_fround(-f4);
   f4 = Math_fround(f3 + Math_fround(f6 - (i5 ? f2 : f4)));
   return Math_fround(f4);
  }
 case 2:
  {
   f6 = f3;
   return Math_fround(f6);
  }
 default:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f6 = Math_fround(f3 + Math_fround(f2 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f2 / f6))))));
   return Math_fround(f6);
  }
 }
 if (!(f4 < f2)) {
  f6 = f2;
  return Math_fround(f6);
 }
 switch (HEAP32[i1 + 176 >> 2] | 0) {
 case 0:
  {
   f7 = Math_fround(f2 - f3);
   f2 = Math_fround(f4 - f3);
   f6 = Math_fround(f2 * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f7 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f7 / f6))))) - f2);
   i5 = f6 < Math_fround(0.0);
   f4 = Math_fround(-f6);
   f6 = Math_fround(f3 + Math_fround(f2 - (i5 ? f4 : f6)));
   return Math_fround(f6);
  }
 case 2:
  {
   f7 = f4;
   return Math_fround(f7);
  }
 default:
  {
   f6 = Math_fround(f2 - f3);
   f7 = Math_fround(f4 - f3);
   f7 = Math_fround(f3 + Math_fround(f6 - Math_fround(f7 * Math_fround(Math_floor(Math_fround(f6 / f7))))));
   return Math_fround(f7);
  }
 }
 return f0;
}

function __ZN5Unity12PhysicsQuery19CapsuleCastNonAllocERK8Vector3fS3_fS3_P10RaycastHitifi23QueryTriggerInteraction(i4, i5, i6, f7, i8, i9, i10, f11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 8 | 0;
 i1 = i14;
 if (!i10) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 if ((HEAP16[gb + 1452788 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452788 | 0, i2);
  i3 = gb + 1452788 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i2 + 52 >> 0] = 0;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = 128;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151376 + 8;
 HEAP32[i2 + 68 >> 2] = i9;
 HEAP32[i2 + 72 >> 2] = i10;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE(0, i5, i6, f7, i8, f11, i12, i13, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i13 = i1;
  STACKTOP = i14;
  return i13 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN2UI11BreaksBatchERKNS_23RenderableUIInstructionES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 if ((i1 | 0) == (i2 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP8[i2 + 247 >> 0] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if (HEAP8[i2 + 246 >> 0] | 0) {
  i3 = 1;
  return i3 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 i3 = HEAP8[i1 + 245 >> 0] | 0;
 if (i3 << 24 >> 24 != (HEAP8[i2 + 245 >> 0] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if ((HEAP8[i1 + 244 >> 0] | 0) != (HEAP8[i2 + 244 >> 0] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if (i3 << 24 >> 24) {
  f4 = Math_fround(HEAPF32[i1 + 228 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 228 >> 2]));
  i3 = f4 < Math_fround(0.0);
  f5 = Math_fround(-f4);
  if (!((i3 ? f5 : f4) <= Math_fround(9.99999997e-07))) {
   i3 = 1;
   return i3 | 0;
  }
  f5 = Math_fround(HEAPF32[i1 + 232 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 232 >> 2]));
  i3 = f5 < Math_fround(0.0);
  f4 = Math_fround(-f5);
  if (!((i3 ? f4 : f5) <= Math_fround(9.99999997e-07))) {
   i3 = 1;
   return i3 | 0;
  }
  f5 = Math_fround(HEAPF32[i1 + 236 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 236 >> 2]));
  i3 = f5 < Math_fround(0.0);
  f4 = Math_fround(-f5);
  if (!((i3 ? f4 : f5) <= Math_fround(9.99999997e-07))) {
   i3 = 1;
   return i3 | 0;
  }
  f5 = Math_fround(HEAPF32[i1 + 240 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 240 >> 2]));
  i3 = f5 < Math_fround(0.0);
  f4 = Math_fround(-f5);
  if (!((i3 ? f4 : f5) <= Math_fround(9.99999997e-07))) {
   i3 = 1;
   return i3 | 0;
  }
 }
 i3 = 0;
 return i3 | 0;
}

function __ZN19LightProbeOcclusion8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 12 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i1;
 i9 = HEAP32[gb + 37256 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378493 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = i1 + 4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378511 | 0, i9, i8, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN12ScriptMapper8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
 if (!(HEAP32[i7 >> 2] & 33554432)) i1 = 4; else {
  i2 = i8 + 28 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   i3 = i7 + 16 | 0;
   i5 = i3;
   i4 = i7 + 24 | 0;
  } else i1 = 4;
 }
 if ((i1 | 0) == 4) {
  i1 = HEAP32[i8 + 40 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  i6 = i7 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = i7 + 24 | 0;
  if (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i6 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i5, 4);
  i3 = i8 + 36 | 0;
  i1 = HEAP32[i8 + 32 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   while (1) {
    __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI4PPtrI6ShaderE8UnityStrEEEEvRT_PKc17TransferMetaFlags(i7, i2 + 16 | 0, gb + 1041891 | 0, 0);
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
   }
  }
  i5 = i6;
  i3 = i6;
  i2 = i8 + 28 | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  STACKTOP = i9;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i2, 1);
  STACKTOP = i9;
  return;
 }
}

function __ZL21CarveJobMultithreadedP12CarveJobInfoj(i2, i11) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 4 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1459092 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459092 | 0, i10);
  i5 = gb + 1459092 | 0;
 } else i5 = 0;
 i7 = __Z17GetNavMeshManagerv() | 0;
 f8 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i14 = HEAP32[i7 + (i11 << 5) >> 2] | 0;
 i13 = HEAP32[i7 + (i11 << 5) + 4 >> 2] | 0;
 i4 = HEAP32[i7 + (i11 << 5) + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i3 + (i11 * 12 | 0) + 8 | 0;
 HEAP32[i1 >> 2] = 2;
 i2 = i3 + (i11 * 12 | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i3 + (i11 * 12 | 0) + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = __ZNK14NavMeshManager19GetSourceTileDataAtEiii(__Z17GetNavMeshManagerv() | 0, i14, i13, i4) | 0;
 if (i4 | 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i14 = i7 + (i11 << 5) + 12 | 0;
  i15 = HEAP32[i14 >> 2] | 0;
  i13 = i7 + (i11 << 5) + 24 | 0;
  i11 = i15 + ((HEAP32[i13 >> 2] | 0) * 88 | 0) | 0;
  HEAP32[i10 >> 2] = fb + 911;
  __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_(i15, i11, i10);
  HEAP32[i1 >> 2] = __Z16CarveNavMeshTilePPhPiPKhijPK16NavMeshCarveDatafff(i2, i3, i4, 0, HEAP32[i13 >> 2] | 0, HEAP32[i14 >> 2] | 0, f8, f9, f6) | 0;
 }
 if (!i5) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i12;
 return;
}

function __Z42BillboardRenderer_Get_Custom_PropBillboardP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 344 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = i10 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 108 | 0) + 1 | 0;
 if (i3 >>> 0 > 39768215) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i7 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 108 | 0;
 i8 = i7 << 1;
 i3 = i7 >>> 0 < 19884107 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 39768215;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = i10 + 8;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 108 | 0) | 0;
 HEAP32[i11 >> 2] = i4;
 i1 = i4 + (((i2 - i1 | 0) / 108 | 0) * 108 | 0) | 0;
 i6 = i11 + 8 | 0;
 i7 = i11 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = i4 + (i3 * 108 | 0);
 __ZN9InputAxisC2ERKS_(i1, i5);
 HEAP32[i6 >> 2] = i1 + 108;
 i3 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i1 = i1 + -108 | 0;
   i2 = i2 + -108 | 0;
   __ZN9InputAxisC2ERKS_(i1, i2);
   HEAP32[i7 >> 2] = i1;
  } while ((i2 | 0) != (i3 | 0));
  i3 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i12;
 HEAP32[i11 >> 2] = HEAP32[i7 >> 2];
 __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev(i11);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN7dtCrowd6updateEfP21dtCrowdAgentDebugInfoi(i13, f14, i1, i2) {
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 __ZN7dtCrowd20UpdateActiveAgentIDsEv(i13);
 i9 = i13 + 400 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i8 = i13 + 408 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i2 = i13 + 416 | 0;
 if ((i5 | 0) > 0) {
  i7 = HEAP32[i2 >> 2] | 0;
  i3 = i13 + 396 | 0;
  i2 = i7;
  i6 = 0;
  i4 = 0;
  i1 = i5;
  do {
   if (HEAP32[i7 + (i6 * 92 | 0) + 84 >> 2] | 0) {
    HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] = i6;
    i4 = i4 + 1 | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) < (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 } else {
  i4 = 0;
  i3 = i13 + 396 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i13 + 404 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i13 + 468 >> 2];
 HEAP32[i10 + 4 >> 2] = i13 + 264;
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 368 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 24 >> 2];
 i8 = HEAP32[i13 + 16 >> 2] | 0;
 HEAP32[i10 + 16 >> 2] = i8;
 HEAP32[i10 + 20 >> 2] = i2;
 i9 = HEAP32[i13 + 392 >> 2] | 0;
 HEAP32[i10 + 24 >> 2] = i9;
 HEAP32[i10 + 28 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 32 >> 2] = i1;
 HEAP32[i10 + 36 >> 2] = i4;
 HEAP32[i10 + 40 >> 2] = HEAP32[i13 + 444 >> 2];
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 4 >> 2] = HEAP32[i13 + 20 >> 2];
 HEAP32[i11 + 8 >> 2] = i9;
 HEAP32[i11 + 12 >> 2] = i1;
 __Z24CrowdUpdateMultiThreadedRK17ReadonlyCrowdInfoR15UpdateCrowdInfoP7dtCrowdf(i10, i11, i13, f14);
 STACKTOP = i12;
 return;
}

function __ZN7Terrain5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 52 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 64 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 68 >> 2] = Math_fround(50.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(5.0);
 HEAP32[i1 + 76 >> 2] = 50;
 HEAPF32[i1 + 80 >> 2] = Math_fround(80.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 88 >> 0] = 1;
 HEAP8[i1 + 89 >> 0] = 1;
 HEAP8[i1 + 90 >> 0] = 1;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = -8421505;
 HEAPF32[i1 + 104 >> 2] = Math_fround(.078125);
 i2 = i1 + 152 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 188 >> 0] = 1;
 i2 = i1 + 192 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 200 >> 0] = 1;
 HEAP32[i1 + 204 >> 2] = 7;
 i1 = i1 + 208 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx3Scb4Body17switchBodyToNoSimEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 + 232 >> 2] = 1;
  i3 = i4 + 204 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  __ZN5physx2Sc8BodyCore10putToSleepEv(i4 + 16 | 0);
  return;
 }
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb(i1, i4, 1);
 if (!(HEAP8[(HEAP32[i4 >> 2] | 0) + 2433 >> 0] | 0)) {
  HEAP32[i4 + 232 >> 2] = 1;
  i1 = i4 + 204 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  i1 = i4 + 16 | 0;
  __ZN5physx2Sc8BodyCore10putToSleepEv(i1);
 } else {
  __ZN5physx3Scb4Body18putToSleepInternalEv(i4);
  i1 = i4 + 16 | 0;
 }
 if ((HEAP32[i4 + 4 >> 2] & -1073741824 | 0) != 1073741824) return;
 i2 = i4 + 172 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i5 = __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 1) | 0;
 i3 = (HEAP32[i2 >> 2] | 0) == 0;
 if (i5) {
  if (i3) return;
  __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i4 >> 2] | 0) + 1248 >> 2] | 0, 1);
  return;
 }
 if (i3) return;
 if (!(__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0)) return;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i1, HEAP32[(HEAP32[i4 >> 2] | 0) + 1248 >> 2] | 0, 0);
 return;
}

function __ZN18DelayedCallManager14HasDelayedCallE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i1, i4, i6, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = i1 + 32 | 0;
 if ((i3 | 0) == (i5 | 0)) {
  i8 = 2;
  i8 = (i8 | 0) != 2;
  return i8 | 0;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i7) {
  L5 : while (1) {
   if ((HEAP32[i3 + 48 >> 2] | 0) == (i4 | 0)) i1 = (HEAP32[i3 + 40 >> 2] | 0) == (i6 | 0) ? 1 : 4; else i1 = 4;
   switch (i1 & 7) {
   case 4:
   case 0:
    break;
   default:
    {
     i3 = 20;
     break L5;
    }
   }
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break; else i3 = i1;
   } else while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
   if ((i1 | 0) == (i5 | 0)) {
    i1 = 2;
    i3 = 20;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) == 20) {
   i8 = (i1 | 0) != 2;
   return i8 | 0;
  }
 } else i2 = i3;
 L21 : while (1) {
  if ((HEAP32[i2 + 48 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i2 + 40 >> 2] | 0) == (i6 | 0)) i1 = (mftCall_iii(i7 | 0, HEAP32[i2 + 36 >> 2] | 0, i8 | 0) | 0) & 1; else i1 = 4; else i1 = 4;
  switch (i1 & 7) {
  case 4:
  case 0:
   break;
  default:
   {
    i3 = 20;
    break L21;
   }
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) {
   i1 = 2;
   i3 = 20;
   break;
  } else i2 = i1;
 }
 if ((i3 | 0) == 20) {
  i8 = (i1 | 0) != 2;
  return i8 | 0;
 }
 return 0;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 24 | 0;
 i4 = i1 + 12 | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903047 | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903074 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 8;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903088 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 0);
 HEAP32[i3 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 905830 | 0, i3, 0);
 __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 i2 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i2) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i2;
   i1 = 1;
   break;
  }
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2 | 0) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0)) {
  i7 = i1;
  return i7 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
  i7 = i1 + 1 | 0;
  return i7 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
  i7 = i1 + 2 | 0;
  return i7 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i7 = i1 + 3 | 0;
 return i7 | 0;
}

function __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 i2 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i2) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i2;
   i1 = 1;
   break;
  }
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2 | 0) | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i5 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  if (mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0)) {
  i7 = i1;
  return i7 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) {
  i7 = i1 + 1 | 0;
  return i7 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 if (!(mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
  i7 = i1 + 2 | 0;
  return i7 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i7 = i1 + 3 | 0;
 return i7 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = (_strcmp(i6, HEAP32[i1 >> 2] | 0) | 0) < 0;
 i6 = (_strcmp(HEAP32[i3 >> 2] | 0, i6) | 0) < 0;
 if (!i5) {
  if (!i6) {
   i6 = 0;
   return i6 | 0;
  }
  i5 = i2;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i3;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = i2;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  i6 = i3;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i5;
  if ((_strcmp(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) >= 0) {
   i8 = 1;
   return i8 | 0;
  }
  i7 = i1;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = i2;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = i5;
  i8 = i2;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i8 + 4 >> 2] = i7;
  i8 = 2;
  return i8 | 0;
 }
 i5 = i1;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 if (i6) {
  i6 = i3;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = i7;
  i8 = i3;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i8 + 4 >> 2] = i5;
  i8 = 1;
  return i8 | 0;
 }
 i6 = i2;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i2;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i8 + 4 >> 2] = i5;
 if ((_strcmp(HEAP32[i3 >> 2] | 0, i4) | 0) >= 0) {
  i8 = 1;
  return i8 | 0;
 }
 i6 = i3;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = i3;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i8 + 4 >> 2] = i5;
 i8 = 2;
 return i8 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE15reserveInternalEj(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f13 = f0, i14 = 0, i15 = 0;
 if (!i1) i2 = 3; else if (i1 + -1 & i1) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 i3 = i12 + 16 | 0;
 i11 = HEAP32[i3 >> 2] | 0;
 f13 = Math_fround(i1 >>> 0);
 i4 = ~~Math_fround(f13 * Math_fround(HEAPF32[i12 + 24 >> 2])) >>> 0;
 i8 = i1 << 2;
 i5 = i4 << 2;
 i7 = i5 + i8 | 0;
 i7 = (0 - i7 & 12) + i7 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i12, i7 + i5 | 0, gb + 778479 | 0, 341) | 0;
 i6 = i5 + i8 | 0;
 i7 = i5 + i7 | 0;
 _memset(i5 | 0, -1, i8 | 0) | 0;
 i8 = i12 + 36 | 0;
 i2 = i12 + 4 | 0;
 if (HEAP32[i8 >> 2] | 0) {
  i9 = i1 + -1 | 0;
  i10 = 0;
  do {
   i14 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i10 << 2) >> 2] | 0;
   i15 = i14 + ~(i14 << 15) | 0;
   i15 = (i15 >>> 10 ^ i15) * 9 | 0;
   i15 = i15 >>> 6 ^ i15;
   i15 = i15 + ~(i15 << 11) | 0;
   i15 = i5 + (((i15 >>> 16 ^ i15) & i9) << 2) | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = HEAP32[i15 >> 2];
   HEAP32[i15 >> 2] = i10;
   HEAP32[i7 + (i10 << 2) >> 2] = i14;
   i10 = i10 + 1 | 0;
  } while (i10 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i12, HEAP32[i12 >> 2] | 0);
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 12 >> 2] = i5;
 HEAP32[i12 + 20 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 i1 = i12 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) return;
 HEAP32[i1 >> 2] = i11;
 return;
}

function __ZN5physx2Gu27checkOverlapOBB_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f14 * Math_fround(2.0));
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f9 = Math_fround(f8 * Math_fround(2.0));
 f8 = Math_fround(Math_fround(f14 * f11) + Math_fround(Math_fround(f8 * f9) + Math_fround(-1.0)));
 f14 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f14 * f9);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f11 * f6));
 f6 = Math_fround(Math_fround(f11 * f14) - Math_fround(f9 * f6));
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(f9 * f8);
 f5 = Math_fround(f9 * f5);
 f6 = Math_fround(f9 * f6);
 f9 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f14 = Math_fround(f9 + f8);
 f11 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f13 = Math_fround(f11 + f5);
 f10 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f12 = Math_fround(f6 + f10);
 HEAPF32[i7 >> 2] = f14;
 HEAPF32[i7 + 4 >> 2] = f13;
 HEAPF32[i7 + 8 >> 2] = f12;
 f5 = Math_fround(f11 - f5);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i7 + 12 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i7 + 16 >> 2] = f5;
 HEAPF32[i7 + 20 >> 2] = f6;
 i3 = i7 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 4 >> 2];
 f6 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i7, i7 + 12 | 0, i1 + 36 | 0, i1 + 48 | 0, i1, 0, 0));
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f6 <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags(i1, i6 + 152 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 172 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 176 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 180 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i8 = i5;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN14PhysicsManager10BoxCastAllERK8Vector3fS2_S2_RK11Quaternionffi23QueryTriggerInteraction(i7, i8, i9, i10, i11, f12, i13, i14) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1452716 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452716 | 0, i6);
  i1 = gb + 1452716 | 0;
 } else i1 = 0;
 i2 = i7 + 784 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i7 + 788 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 + 736 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i6 + 52 >> 0] = 0;
 HEAP32[i6 + 56 >> 2] = i7;
 HEAP32[i6 + 60 >> 2] = 128;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151352 + 8;
 HEAP32[i6 + 68 >> 2] = i2;
 __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE(0, i8, i9, i10, i11, f12, i13, i14, i6);
 if (!i1) {
  STACKTOP = i15;
  return i2 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i15;
 return i2 | 0;
}

function __ZN11OffMeshLink8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i4);
 i1 = i5 + 88 | 0;
 i6 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 48 | 0, i4);
 __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 52 | 0, i4);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 i1 = i5 + 98 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 99 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 96 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  return;
 }
}

function __Z41OffMeshLink_Get_Custom_PropStartTransformP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z35Renderer_Get_Custom_PropProbeAnchorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 32 + 248 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 52;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 52;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 328 | 0;
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx25PxFixedJointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx25PxFixedJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i1) i1 = gb + 1034517 | 0; else {
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  HEAP8[i1 >> 0] = 80;
  HEAP8[i1 + 1 >> 0] = 80;
  HEAP8[i1 + 2 >> 0] = 116;
  HEAP8[i1 + 3 >> 0] = 114;
  HEAP8[i1 + 4 >> 0] = 60;
  i2 = i1 + 6 | 0;
  HEAP8[i1 + 5 >> 0] = 36;
  i3 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  if (i4 << 24 >> 24) do {
   HEAP8[i2 >> 0] = i4;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while (i4 << 24 >> 24 != 0);
  HEAP8[i2 >> 0] = 62;
  HEAP8[i2 + 1 >> 0] = 0;
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, i7, i1, i6, i8);
 i7 = i9 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 1);
 i8 = i5 + 16 | 0;
 i9 = i5 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 1);
 HEAP32[(HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine9Animation18CreateAvatarTQSMapEPKN7mecanim9animation14AvatarConstantERKNS0_20AnimationSetBindingsERNS1_6memory9AllocatorE(i4, i6, i1) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i4;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + i5 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 * 12 | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 * 12 | 0) | 0)) {
   i12 = i2 + -12 | 0;
   _memset(i1 | 0, -1, i12 - ((i12 >>> 0) % 12 | 0) + 12 | 0) | 0;
  }
 }
 i11 = HEAP32[i4 >> 2] | 0;
 i11 = (i11 | 0) == 0 ? 0 : i11 + i5 | 0;
 i12 = HEAP32[i6 + 20 >> 2] | 0;
 if (!((i1 | 0) != 0 & (i12 | 0) > 0)) return i1 | 0;
 i8 = i6 + 24 | 0;
 i3 = -1;
 i4 = -1;
 i7 = 0;
 i2 = -1;
 while (1) {
  i6 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i6 + (i7 << 3) + 4 >> 2] | 0;
  i10 = (i9 | 0) == 3;
  L10 : do if (i10) {
   i5 = i3;
   i4 = i4 + 1 | 0;
  } else switch (i9 | 0) {
  case 2:
  case 4:
   {
    i2 = i2 + 1 | 0;
    i5 = i3;
    break L10;
   }
  case 1:
   {
    i5 = i3 + 1 | 0;
    break L10;
   }
  default:
   {
    i5 = i3;
    break L10;
   }
  } while (0);
  i3 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i11, HEAP32[i6 + (i7 << 3) >> 2] | 0) | 0;
  L17 : do if ((i3 | 0) != -1) {
   if (i10) {
    HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] = i4;
    break;
   }
   switch (i9 | 0) {
   case 2:
   case 4:
    {
     HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] = i2;
     break L17;
    }
   case 1:
    {
     HEAP32[i1 + (i3 * 12 | 0) >> 2] = i5;
     break L17;
    }
   default:
    break L17;
   }
  } while (0);
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == (i12 | 0)) break; else i3 = i5;
 }
 return i1 | 0;
}

function __ZN11AudioSource25UnbindFromChannelInstanceERK7WeakPtrI20SoundChannelInstanceE(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i5 | 0)) {
  if (i2 | 0) {
   HEAP32[i2 + 16 >> 2] = 0;
   i7 = i2 + 4 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   if (!(HEAP32[i7 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
   }
   HEAP32[i1 >> 2] = 0;
  }
  HEAP8[i3 + 498 >> 0] = 0;
  HEAP8[i3 + 499 >> 0] = 0;
  __ZN12AudioManager16UnScheduleSourceEP11AudioSource(__Z15GetAudioManagerv() | 0, i3);
  return;
 }
 i2 = HEAP32[i3 + 432 >> 2] | 0;
 i6 = i3 + 428 | 0;
 i1 = i2;
 if ((i1 | 0) == (i6 | 0)) return;
 while (1) {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i2 = i1 + 12 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) {
    i8 = i1 + 4 | 0;
    HEAP32[i3 + 4 >> 2] = HEAP32[i8 >> 2];
    HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i8 >> 2] = 0;
   }
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + -1;
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + -1;
   if (i5 | 0) {
    i8 = i5 + 4 | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
    if (!(HEAP32[i8 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i5, i5 + 8 | 0);
    }
    HEAP32[i2 >> 2] = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63328 | 0);
  }
  i1 = i4;
  if ((i1 | 0) == (i6 | 0)) break;
  i2 = i4;
  i5 = HEAP32[i7 >> 2] | 0;
 }
 return;
}

function __Z27SetClippingPlaneShaderPropsR9GfxDevice(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 96 | 0;
 i3 = i2;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i5, i4);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i4, i3);
 i4 = i1 + 1364 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i4 = i3 + 16 | 0;
 i5 = i1 + 1380 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 32 | 0;
 i4 = i1 + 1396 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i4 = i3 + 48 | 0;
 i5 = i1 + 1412 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i5 = i3 + 64 | 0;
 i4 = i1 + 1428 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i3 = i3 + 80 | 0;
 i1 = i1 + 1444 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE8WrapTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i5 = HEAP32[i1 + 120 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + (((HEAP32[i1 + 132 >> 2] | 0) + -1 | 0) * 40 | 0) >> 2]);
 if (f3 > f2) switch (HEAP32[i1 + 140 >> 2] | 0) {
 case 0:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f4 = Math_fround(f6 * Math_fround(2.0));
   f4 = Math_fround(Math_fround(f2 - Math_fround(f4 * Math_fround(Math_floor(Math_fround(f2 / f4))))) - f6);
   i5 = f4 < Math_fround(0.0);
   f2 = Math_fround(-f4);
   f4 = Math_fround(f3 + Math_fround(f6 - (i5 ? f2 : f4)));
   return Math_fround(f4);
  }
 case 2:
  {
   f6 = f3;
   return Math_fround(f6);
  }
 default:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f6 = Math_fround(f3 + Math_fround(f2 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f2 / f6))))));
   return Math_fround(f6);
  }
 }
 if (!(f4 < f2)) {
  f6 = f2;
  return Math_fround(f6);
 }
 switch (HEAP32[i1 + 144 >> 2] | 0) {
 case 0:
  {
   f7 = Math_fround(f2 - f3);
   f2 = Math_fround(f4 - f3);
   f6 = Math_fround(f2 * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f7 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f7 / f6))))) - f2);
   i5 = f6 < Math_fround(0.0);
   f4 = Math_fround(-f6);
   f6 = Math_fround(f3 + Math_fround(f2 - (i5 ? f4 : f6)));
   return Math_fround(f6);
  }
 case 2:
  {
   f7 = f4;
   return Math_fround(f7);
  }
 default:
  {
   f6 = Math_fround(f2 - f3);
   f7 = Math_fround(f4 - f3);
   f7 = Math_fround(f3 + Math_fround(f6 - Math_fround(f7 * Math_fround(Math_floor(Math_fround(f6 / f7))))));
   return Math_fround(f7);
  }
 }
 return f0;
}

function __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i5 = i7 + 56 | 0;
 i8 = i4 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i5, i1, i4 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i4, HEAP32[i5 >> 2] | 0, i1 << 4);
 i1 = i7 + 76 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i7);
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i7);
  STACKTOP = i9;
  return;
 }
}

function __ZN14SphereCollider9GetBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(HEAP32[i2 + 36 >> 2] | 0)) {
  __ZN8Collider9GetBoundsEv(i1, i2);
  STACKTOP = i4;
  return;
 } else {
  i6 = i2 + 28 | 0;
  __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0);
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 62512 >> 2]));
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f9 = Math_fround(f9 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
  f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f8 = Math_fround(f8 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
  i7 = f5 < Math_fround(0.0);
  f10 = Math_fround(-f5);
  f5 = i7 ? f10 : f5;
  i7 = f9 < Math_fround(0.0);
  f10 = Math_fround(-f9);
  f9 = i7 ? f10 : f9;
  i7 = f8 < Math_fround(0.0);
  f10 = Math_fround(-f8);
  f8 = i7 ? f10 : f8;
  f5 = f5 < f9 ? f9 : f5;
  f5 = Math_fround(Math_fround(HEAPF32[i2 + 60 >> 2]) * (f5 < f8 ? f8 : f5));
  i7 = f5 < Math_fround(0.0);
  f8 = Math_fround(-f5);
  f5 = i7 ? f8 : f5;
  i7 = f5 < Math_fround(9.99999974e-06);
  f5 = i7 ? Math_fround(9.99999974e-06) : f5;
  __ZNK9Transform14TransformPointERK8Vector3f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAPF32[i1 + 12 >> 2] = f5;
  HEAPF32[i1 + 16 >> 2] = f5;
  HEAPF32[i1 + 20 >> 2] = f5;
  STACKTOP = i4;
  return;
 }
}

function __ZN14RedirectHelper15PerformRedirectEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 264 | 0;
 i2 = i5 + 8 | 0;
 i6 = i5;
 i3 = i5 + 248 | 0;
 i9 = (__Z34GetUnityWebRequestScriptingClassesv() | 0) + 32 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i2, i4);
 i6 = HEAP32[i1 >> 2] | 0;
 __ZN18ScriptingArguments9AddStringEPKc(i2, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN18ScriptingArguments9AddStringEPKc(i2, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 HEAP32[i4 >> 2] = 0;
 i2 = __ZN19ScriptingInvocation6InvokeIP12Il2CppStringEET_PP15Il2CppExceptionb(i2, i4, 0) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) {
  i9 = i1 + 8 | 0;
  __Z24scripting_cpp_string_forP12Il2CppString(i3, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return;
 } else {
  __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i4, 0, gb + 1027300 | 0);
  i9 = i1 + 8 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i9, gb + 1576256 | 0) | 0;
  __Z24scripting_cpp_string_forP12Il2CppString(i3, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i9, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return;
 }
}

function __Z39OffMeshLink_Get_Custom_PropEndTransformP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z16VectToTexelCoordPfiPiS0_S0_(i2, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f10 = f0, f11 = f0, i12 = 0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f10)));
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(Math_abs(Math_fround(f11)));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(Math_abs(Math_fround(f5)));
 do if (!(f3 >= f4) | !(f3 >= f1)) if (!(f4 >= f3) | !(f4 >= f1)) {
  i2 = !(f5 >= Math_fround(0.0));
  i2 = i2 ? 5 : 4;
  break;
 } else {
  i2 = !(f11 >= Math_fround(0.0));
  f1 = f4;
  i2 = i2 ? 3 : 2;
  break;
 } else {
  f1 = f3;
  i2 = !(f10 >= Math_fround(0.0)) & 1;
 } while (0);
 f4 = Math_fround(Math_fround(1.0) / f1);
 f3 = Math_fround(f10 * f4);
 f10 = Math_fround(f4 * f11);
 f11 = Math_fround(f4 * f5);
 f4 = Math_fround(f3 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) >> 2]));
 f4 = Math_fround(f4 + Math_fround(f10 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 4 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f11 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 8 >> 2])));
 f5 = Math_fround(f3 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 12 >> 2]));
 f10 = Math_fround(f5 + Math_fround(f10 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 16 >> 2])));
 f5 = Math_fround(Math_fround(i6 + -1 | 0) * Math_fround(.5));
 i12 = ~~Math_fround(Math_floor(Math_fround(f5 * Math_fround(f4 + Math_fround(1.0)))));
 i6 = ~~Math_fround(Math_floor(Math_fround(f5 * Math_fround(Math_fround(f10 + Math_fround(f11 * Math_fround(HEAPF32[gb + 41340 + (i2 * 36 | 0) + 20 >> 2]))) + Math_fround(1.0)))));
 HEAP32[i7 >> 2] = i2;
 HEAP32[i8 >> 2] = i12;
 HEAP32[i9 >> 2] = i6;
 return;
}

function __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i5 + 56 | 0;
 i15 = i5 + 40 | 0;
 i17 = i5 + 8 | 0;
 i10 = i5 + 28 | 0;
 i13 = i5;
 i16 = i5 + 16 | 0;
 i2 = i2 + 32 | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i18 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i18;
 HEAP32[i16 + 8 >> 2] = i3;
 i4 = i17;
 HEAP32[i4 >> 2] = i14;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i17 + 4 >> 2];
 __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E(i15, i12, i16);
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f11 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f9 = Math_fround(f7 - f9);
 f11 = Math_fround(f8 - f11);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i15 + 8 >> 2]));
 i4 = i13;
 HEAP32[i4 >> 2] = i14;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 __Z23CalculateGlobalPosition23TransformAccessReadOnly(i10, i12);
 f8 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f7 = Math_fround(f11 + f7);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i10 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f9 + f8);
 HEAPF32[i1 + 4 >> 2] = f7;
 HEAPF32[i1 + 8 >> 2] = f6;
 STACKTOP = i5;
 return;
}

function __ZN5physx9NpPhysics31registerDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj(i2, i4, i9, i8) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = i2 + 64 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i5 = i4;
  i5 = i5 + ~(i5 << 15) | 0;
  i5 = (i5 >>> 10 ^ i5) * 9 | 0;
  i5 = i5 >>> 6 ^ i5;
  i5 = i5 + ~(i5 << 11) | 0;
  i1 = HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i2 + 72 >> 2] | 0;
   i3 = i2 + 76 | 0;
   while (1) {
    i2 = i5 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i4 = HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0;
    i1 = (HEAP32[i4 + 36 >> 2] | 0) + i8 | 0;
    if ((HEAP32[i4 + 20 >> 2] | 0) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj(i4, i1);
    if (i8 | 0) {
     i3 = 0;
     do {
      i1 = i9 + (i3 << 2) | 0;
      i2 = __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE6createERKS5_Rb(i4, i1, i7) | 0;
      if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i8 | 0));
    }
   }
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN5audio5mixer21SetResultingMuteStateERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEib(i1, i2, i8, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP8[(HEAP32[i2 + 64 >> 2] | 0) + i8 >> 0] = i3 & 1;
 i10 = i1 + 12 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (!i4) {
  STACKTOP = i11;
  return;
 }
 i6 = i1 + 16 | 0;
 i7 = i6;
 i5 = i2 + 16 | 0;
 if (i3) {
  i3 = 0;
  i1 = i4;
  do {
   i2 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
   if ((HEAP32[i2 + (i3 << 5) + 4 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i2 + (i3 << 5) >> 2] | 0) > -1) {
    HEAP32[i9 >> 2] = 0;
    i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 5) >> 2] | 0;
    if (i1 | 0) {
     i4 = (__ZN4FMOD3DSP11getUserDataEPPv(i1, i9) | 0) == 0;
     i1 = HEAP32[i9 >> 2] | 0;
     if (i4 & (i1 | 0) != 0) {
      i4 = i1 + 32 | 0;
      HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
     }
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  STACKTOP = i11;
  return;
 } else {
  i3 = 0;
  i1 = i4;
  do {
   i2 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
   if ((HEAP32[i2 + (i3 << 5) + 4 >> 2] | 0) == (i8 | 0)) if ((HEAP32[i2 + (i3 << 5) >> 2] | 0) > -1) {
    HEAP32[i9 >> 2] = 0;
    i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 5) >> 2] | 0;
    if (i1 | 0) {
     i4 = (__ZN4FMOD3DSP11getUserDataEPPv(i1, i9) | 0) == 0;
     i1 = HEAP32[i9 >> 2] | 0;
     if (i4 & (i1 | 0) != 0) {
      i4 = i1 + 32 | 0;
      HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -5;
     }
    }
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN5Umbra9KDRankLUT9constructEPKj(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if (!i2) return;
 i12 = (i2 << 1) + 31 >> 5;
 i1 = HEAP32[i10 >> 2] | 0;
 i1 = i1 & 1431655765 & i1 >>> 1;
 i1 = (i1 >>> 2 & 286331153) + (i1 & 286331153) | 0;
 i1 = (i1 >>> 4) + i1 & 117901063;
 i1 = (i1 >>> 8) + i1 | 0;
 i8 = i2 >>> 16;
 i7 = i2 >>> 8;
 _memset(HEAP32[i9 >> 2] | 0, 0, 3 - i7 + (i2 >>> 4) + (((1 - i8 + i7 | 0) >>> 1) + i8 << 2) & -4 | 0) | 0;
 if (i12 >>> 0 <= 1) return;
 i7 = 16 - ((i1 >>> 16) + i1 & 31) | 0;
 i1 = 0;
 i2 = 0;
 i3 = 0;
 i4 = 0;
 i5 = 0;
 i8 = 1;
 while (1) {
  do if (!(i8 & 4095)) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] = i7;
   i6 = i7;
   i2 = i7;
   i5 = i5 + 1 | 0;
  } else if (!(i8 & 15)) {
   i13 = i7 - i2 | 0;
   i1 = i4 << 4 & 16;
   i6 = (HEAP32[i9 >> 2] | 0) + (((HEAP32[i11 >> 2] | 0) >>> 16) + (i4 >> 1) << 2) | 0;
   HEAP32[i6 >> 2] = (i13 >>> 8 & 255) << (i1 | 8) | (i13 & 255) << i1 | HEAP32[i6 >> 2];
   i6 = i7;
   i4 = i4 + 1 | 0;
   break;
  } else {
   i6 = HEAP32[i11 >> 2] | 0;
   i13 = i6 >>> 16;
   i6 = (HEAP32[i9 >> 2] | 0) + (i13 + (i3 >> 2) + ((1 - i13 + (i6 >>> 8) | 0) >>> 1) << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | (i7 - i1 & 255) << (i3 << 3 & 24);
   i6 = i1;
   i3 = i3 + 1 | 0;
   break;
  } while (0);
  i1 = HEAP32[i10 + (i8 << 2) >> 2] | 0;
  i1 = i1 & 1431655765 & i1 >>> 1;
  i1 = (i1 >>> 2 & 286331153) + (i1 & 286331153) | 0;
  i1 = (i1 >>> 4) + i1 & 117901063;
  i1 = (i1 >>> 8) + i1 | 0;
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == (i12 | 0)) break; else {
   i7 = i7 + 16 - ((i1 >>> 16) + i1 & 31) | 0;
   i1 = i6;
  }
 }
 return;
}

function __ZN19b2PrismaticJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i13 = i4 + 4 | 0;
 f7 = Math_fround(HEAPF32[i13 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 i12 = i2 + 24 | 0;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f8 = Math_fround(f10 * f6);
 i11 = i2 + 20 | 0;
 f9 = Math_fround(HEAPF32[i11 >> 2]);
 f10 = Math_fround(Math_fround(f6 * f7) - Math_fround(f10 * f9));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 + Math_fround(f7 * f9));
 HEAPF32[i1 + 24 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 f9 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f7 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f10 * f7);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f10 = Math_fround(Math_fround(f7 * f9) - Math_fround(f10 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f8 + Math_fround(f9 * f6));
 HEAPF32[i1 + 32 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f10 * f6);
 f8 = Math_fround(HEAPF32[i11 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(Math_fround(f10 * f7) - Math_fround(f6 * f8));
 HEAPF32[i1 + 36 >> 2] = Math_fround(f9 + Math_fround(f8 * f7));
 HEAPF32[i1 + 40 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 HEAPF32[i1 + 44 >> 2] = Math_fround(f6 - Math_fround(HEAPF32[i2 + 56 >> 2]));
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation23BlendDirectDataConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 12 | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i5 = i6 + 8 | 0;
 HEAP8[i5 >> 0] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 903774 | 0, i6, 0);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i6 + 4;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903840 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i1 + 28 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 24 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 903865 | 0, HEAP32[gb + 36972 >> 2] | 0, i5, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 34;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 34;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 114) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 117) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 101) {
    i2 = i10 + 28 | 0;
    i9 = i10 + 40 | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i7 = i10 + 44 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i10 + 36 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i10 + 32 >> 2] = i3;
      }
      i1 = HEAP32[i10 + 48 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i6 = i8 - i6 | 0;
     i10 = i6 + 24 | 0;
     i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i8;
     i1 = i8 + i6 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i8 + i10;
    }
    HEAP32[i9 >> 2] = i1 + 24;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 258;
    return;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZN7mecanim5human21HumanComputeRootXformEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i6 = i11 + 4 | 0;
 i7 = i11 + 8 | 0;
 f1 = Math_fround(0.0);
 i5 = 0;
 f2 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 do {
  if ((HEAP32[i9 + 72 + (i5 << 2) >> 2] | 0) > -1) {
   f14 = Math_fround(HEAPF32[i9 + 168 + (i5 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i11, i9, i10, i5);
   f15 = Math_fround(HEAPF32[i11 >> 2]);
   f13 = Math_fround(HEAPF32[i6 >> 2]);
   f1 = Math_fround(f1 + f14);
   f2 = Math_fround(f2 + Math_fround(f14 * f15));
   f3 = Math_fround(f3 + Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2])));
   f4 = Math_fround(f4 + Math_fround(f14 * f13));
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 24);
 f13 = Math_fround(f2 / f1);
 f14 = Math_fround(f4 / f1);
 f15 = Math_fround(f3 / f1);
 __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i11, i9, i10);
 HEAPF32[i8 >> 2] = f13;
 HEAPF32[i8 + 4 >> 2] = f14;
 HEAPF32[i8 + 8 >> 2] = f15;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = HEAP32[i11 + 8 >> 2] | 0;
 i10 = HEAP32[i11 + 12 >> 2] | 0;
 HEAP32[i8 + 12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 16 >> 2] = i7;
 HEAP32[i8 + 20 >> 2] = i9;
 HEAP32[i8 + 24 >> 2] = i10;
 HEAP32[i8 + 28 >> 2] = 1065353216;
 HEAP32[i8 + 32 >> 2] = 1065353216;
 HEAP32[i8 + 36 >> 2] = 1065353216;
 STACKTOP = i12;
 return;
}

function __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i7 = i5 + 864 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = i5 + 1086 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i3, i5, 1);
 f1 = Math_fround(HEAPF32[i5 + 864 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + 868 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 872 >> 2]);
 f9 = Math_fround(HEAPF32[i5 + 876 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f1 = Math_fround(f1 * f13);
 f12 = Math_fround(f12 * f13);
 f4 = Math_fround(f4 * f10);
 f9 = Math_fround(f9 * f10);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f1 = Math_fround(f1 + f11);
 f4 = Math_fround(f4 + f8);
 f12 = Math_fround(f12 + f1);
 f9 = Math_fround(f9 + f4);
 f13 = Math_fround(f13 + f11);
 f10 = Math_fround(f10 + f8);
 f1 = Math_fround((f12 > f13 ? f13 : f12) - (f1 < f11 ? f11 : f1));
 f4 = Math_fround((f9 > f10 ? f10 : f9) - (f4 < f8 ? f8 : f4));
 i7 = f4 < Math_fround(0.0);
 f4 = i7 ? Math_fround(0.0) : f4;
 if (f4 != Math_fround(0.0)) {
  i7 = f1 < Math_fround(0.0);
  f1 = Math_fround((i7 ? Math_fround(0.0) : f1) / f4);
 } else f1 = Math_fround(1.0);
 HEAPF32[i5 + 1060 >> 2] = f1;
 HEAP8[i5 + 1077 >> 0] = 1;
 HEAP8[i5 + 1079 >> 0] = 1;
 HEAP8[i5 + 1078 >> 0] = 1;
 HEAP8[i2 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN5Unity12PhysicsQuery10BoxCastAllERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteraction(i7, i8, i9, i10, i11, f12, i13, i14) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1452716 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452716 | 0, i6);
  i1 = gb + 1452716 | 0;
 } else i1 = 0;
 i2 = i7 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i7 + 52 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i6 + 52 >> 0] = 0;
 HEAP32[i6 + 56 >> 2] = i7;
 HEAP32[i6 + 60 >> 2] = 128;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151352 + 8;
 HEAP32[i6 + 68 >> 2] = i2;
 __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE(0, i8, i9, i10, i11, f12, i13, i14, i6);
 if (!i1) {
  STACKTOP = i15;
  return i2 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i15;
 return i2 | 0;
}

function __Z16b2RaycastSegmentP15b2RayCastOutputRK14b2RayCastInputRK6b2Vec2S6_(i15, i11, i5, i6) {
 i15 = i15 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f13 = f0, f14 = f0;
 f7 = Math_fround(HEAPF32[i11 >> 2]);
 f10 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f13 = Math_fround(Math_fround(HEAPF32[i11 + 8 >> 2]) - f7);
 f12 = Math_fround(Math_fround(HEAPF32[i11 + 12 >> 2]) - f10);
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f14 - f4);
 f2 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f2 = Math_fround(f2 - f3);
 f1 = Math_fround(-f14);
 f8 = Math_fround(Math_fround(f12 * f1) + Math_fround(f13 * f2));
 f9 = Math_fround(-f8);
 if (!(f8 < Math_fround(-.000011920929))) {
  i15 = 0;
  return i15 | 0;
 }
 f7 = Math_fround(f7 - f4);
 f3 = Math_fround(f10 - f3);
 f4 = Math_fround(Math_fround(f7 * f2) + Math_fround(f3 * f1));
 if (!(f4 >= Math_fround(0.0))) {
  i15 = 0;
  return i15 | 0;
 }
 if (!(f4 <= Math_fround(Math_fround(HEAPF32[i11 + 16 >> 2]) * f9))) {
  i15 = 0;
  return i15 | 0;
 }
 f13 = Math_fround(Math_fround(f12 * f7) - Math_fround(f13 * f3));
 if (!(Math_fround(f8 * Math_fround(.000011920929)) <= f13) | !(f13 <= Math_fround(f8 * Math_fround(-1.00001192)))) {
  i15 = 0;
  return i15 | 0;
 }
 f4 = Math_fround(f4 / f9);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f14 * f14) + Math_fround(f2 * f2))));
 if (!(f3 < Math_fround(1.1920929e-07))) {
  f14 = Math_fround(Math_fround(1.0) / f3);
  f2 = Math_fround(f2 * f14);
  f1 = Math_fround(f14 * f1);
 }
 HEAPF32[i15 >> 2] = f2;
 HEAPF32[i15 + 4 >> 2] = f1;
 HEAPF32[i15 + 8 >> 2] = f4;
 i15 = 1;
 return i15 | 0;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES6_NS_4lessIS6_EENS4_INS_4pairIKS6_S6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN9Texture2D18LoadRawTextureDataEPKvj(i2, i7, i4) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i2 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i3 | 1 | 0) == 29) {
  __ZN9Texture2D19InitTextureInternalEii13TextureFormatiNS_10EInitFlagsEii(i2, HEAP32[i2 + 84 >> 2] | 0, HEAP32[i2 + 88 >> 2] | 0, i3, i4, 0, 1, HEAP32[i1 + 48 >> 2] | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  if ((HEAP32[i1 + 40 >> 2] | 0) >>> 0 > i4 >>> 0) {
   i7 = 0;
   return i7 | 0;
  }
  if ((HEAP32[i1 + 4 >> 2] | 0) == 1) {
   i2 = i1;
   i6 = 9;
  } else {
   i3 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   HEAP32[i3 + 4 >> 2] = 1;
   HEAP32[i3 >> 2] = gb + 41960 + 8;
   __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i3 + 8 | 0, i4 + 8 | 0);
   i1 = i3 + 28 | 0;
   i4 = i4 + 28 | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   if (!(HEAP32[i4 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
   }
   HEAP32[i5 >> 2] = i3;
   if (!i3) i2 = 0; else {
    i2 = i3;
    i1 = i3;
    i6 = 9;
   }
  }
  if ((i6 | 0) == 9) {
   i3 = i2;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
  }
  if (!i3) i1 = 0; else i1 = HEAP32[i3 + 40 >> 2] | 0;
 }
 _memcpy(i2 | 0, i7 | 0, i1 | 0) | 0;
 i7 = 1;
 return i7 | 0;
}

function __ZN9Texture2D13ApplySettingsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i3 = i10 + 4 | 0;
 i8 = i10;
 i9 = i7 + 32 | 0;
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i7 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE13TextureFormat(i9, i1);
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 148 >> 2] | 0, i7 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 + 48 >> 2];
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i2 = HEAP32[i7 + 60 >> 2] | 0; else i2 = 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0) | 0;
 i5 = i7 + 108 | 0;
 i11 = (HEAP8[i5 >> 0] | 0) == 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i9, i6, i4, i1, i2, i12, i11);
 if (!(HEAP8[i7 + 110 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 96 >> 2] | 0, i7 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i2 = HEAP32[i7 + 60 >> 2] | 0; else i2 = 0;
 i11 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0) | 0;
 i12 = (HEAP8[i5 >> 0] | 0) == 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i9, i6, i4, i1, i2, i11, i12);
 STACKTOP = i10;
 return;
}

function __ZN9Heightmap7SetSizeERK8Vector3f(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 88 >> 2] = Math_fround(f6 / Math_fround((HEAP32[i4 + 72 >> 2] | 0) + -1 | 0));
 HEAP32[i4 + 92 >> 2] = HEAP32[i1 + 4 >> 2];
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 HEAPF32[i4 + 96 >> 2] = Math_fround(f6 / Math_fround((HEAP32[i4 + 76 >> 2] | 0) + -1 | 0));
 i2 = i4 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  i1 = i3 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 1;
  HEAPF32[i3 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
  HEAP16[i3 + 28 >> 1] = 0;
  if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i4, i3) | 0) {
   i7 = __Z11GetIPhysicsv() | 0;
   HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 64 >> 2] | 0, i7 | 0, i3 | 0) | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
  }
 }
 i1 = HEAP32[i4 + 68 >> 2] | 0;
 i3 = i4 + 64 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  i7 = HEAP32[i4 >> 2] | 0;
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i7, 1);
  STACKTOP = i5;
  return;
 }
 do {
  i7 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, 0);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i7 = HEAP32[i4 >> 2] | 0;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i7, 1);
 STACKTOP = i5;
 return;
}

function __ZN8Animator36GetRootBlendTreeConstantAndWorkspaceEiiRPKN7mecanim9animation21BlendTreeNodeConstantERPNS1_18BlendTreeWorkspaceE(i1, i3, i8, i9, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) return;
 i1 = i1 + 624 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK26AnimatorControllerPlayable18ValidateLayerIndexEi(i2, i3) | 0)) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i4 + 92 >> 2] | 0;
 i6 = i7 + 4 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) + (i3 << 2) | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = ((i4 | 0) == 0 ? 0 : i7) + 12 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 + (i1 << 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i7 + i2 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 if (!i7) return;
 i5 = HEAP32[(HEAP32[HEAP32[i4 + 104 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i3 = i2 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i2 = 0;
 do {
  i4 = i3 + (i2 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = i4 + i1 | 0;
  i1 = (i1 | 0) == 0 ? 0 : i4;
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i8 | 0)) i11 = 9; else if ((HEAP32[i1 + 28 >> 2] | 0) == (i8 | 0)) i11 = 9; else if ((HEAP32[i1 + 24 >> 2] | 0) == (i8 | 0)) i11 = 9;
  if ((i11 | 0) == 9) {
   i11 = 0;
   i1 = i4 + 20 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) + (i6 << 2) | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
   i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
   i4 = HEAP32[i1 >> 2] | 0;
   HEAP32[i9 >> 2] = (i4 | 0) == 0 ? 0 : i1 + i4 | 0;
   HEAP32[i10 >> 2] = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0) + (i6 << 2) >> 2];
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i7 >>> 0);
 return;
}

function __ZN25RuntimeAnimatorController23DestroyCustomControllerEPN7mecanim9animation18ControllerConstantERNS0_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) return;
 i4 = i1 + 12 | 0;
 i3 = i4;
 i5 = (HEAP32[i4 >> 2] | 0) + i3 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 + 4 | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) + 20 | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 __ZN7mecanim9animation24DestroyBlendTreeConstantEPNS0_17BlendTreeConstantERNS_6memory9AllocatorE((i6 | 0) == 0 ? 0 : i5 + i6 | 0, i2);
 i6 = (HEAP32[i4 >> 2] | 0) + i3 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 + 4 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim12statemachine20DestroyStateConstantEPNS0_13StateConstantERNS_6memory9AllocatorE((i5 | 0) == 0 ? 0 : i6 + i5 | 0, i2);
 i3 = (HEAP32[i4 >> 2] | 0) + i3 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim12statemachine27DestroyStateMachineConstantEPNS0_20StateMachineConstantERNS_6memory9AllocatorE((i4 | 0) == 0 ? 0 : i4 + i3 | 0, i2);
 i3 = i1 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim9animation20DestroyLayerConstantEPNS0_13LayerConstantERNS_6memory9AllocatorE((i4 | 0) == 0 ? 0 : i4 + i3 | 0, i2);
 i3 = i1 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE((i4 | 0) == 0 ? 0 : i4 + i3 | 0, i2);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE((i4 | 0) == 0 ? 0 : i4 + i3 | 0, i2);
 __ZN7mecanim9animation25DestroyControllerConstantEPNS0_18ControllerConstantERNS_6memory9AllocatorE(i1, i2);
 return;
}

function __Z7ToLowerI8UnityStrET_RKS1_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i3 = i5 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i5 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i7 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) {
   i1 = i7;
   i5 = i2;
  } else {
   i1 = i7;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i5 = i4 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i2 = i7 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) {
  _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
  i5 = i2;
 }
 HEAP8[i1 + i4 >> 0] = 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 i4 = i7 + 4 | 0;
 while (1) {
  if (i2 << 24 >> 24 < 0) {
   i3 = HEAP32[i7 >> 2] | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } else {
   i3 = i7;
   i2 = i2 & 255;
  }
  if ((i1 | 0) == (i3 + i2 | 0)) break;
  i6 = HEAP8[i1 >> 0] | 0;
  i2 = i6 << 24 >> 24;
  HEAP8[i1 >> 0] = (i6 + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
 }
 STACKTOP = i8;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 117) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 108) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 108) {
    i2 = i10 + 28 | 0;
    i9 = i10 + 40 | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i7 = i10 + 44 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i10 + 36 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i10 + 32 >> 2] = i3;
      }
      i1 = HEAP32[i10 + 48 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i6 = i8 - i6 | 0;
     i10 = i6 + 24 | 0;
     i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i8;
     i1 = i8 + i6 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i8 + i10;
    }
    HEAP32[i9 >> 2] = i1 + 24;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    return;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 8 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZL27GeomMTDCallback_CapsuleMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(f17 * Math_fround(2.0));
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f12 = Math_fround(f11 * Math_fround(2.0));
 f11 = Math_fround(Math_fround(f17 * f14) + Math_fround(Math_fround(f11 * f12) + Math_fround(-1.0)));
 f17 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f10 = Math_fround(f17 * f12);
 f9 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f10 = Math_fround(f10 + Math_fround(f14 * f9));
 f9 = Math_fround(Math_fround(f14 * f17) - Math_fround(f12 * f9));
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f11 = Math_fround(f12 * f11);
 f10 = Math_fround(f12 * f10);
 f9 = Math_fround(f12 * f9);
 f12 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f17 = Math_fround(f12 + f11);
 f14 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f16 = Math_fround(f14 + f10);
 f13 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f15 = Math_fround(f9 + f13);
 HEAPF32[i8 >> 2] = f17;
 HEAPF32[i8 + 4 >> 2] = f16;
 HEAPF32[i8 + 8 >> 2] = f15;
 f10 = Math_fround(f14 - f10);
 f9 = Math_fround(f13 - f9);
 HEAPF32[i8 + 12 >> 2] = Math_fround(f12 - f11);
 HEAPF32[i8 + 16 >> 2] = f10;
 HEAPF32[i8 + 20 >> 2] = f9;
 HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 i6 = __ZN5physx2Gu22computeMTD_CapsuleMeshERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _UNITY_png_set_sPLT(i8, i1, i4, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 if ((i4 | 0) == 0 | ((i8 | 0) == 0 | (i1 | 0) == 0 | (i2 | 0) < 1)) return;
 i3 = i1 + 224 | 0;
 i9 = i1 + 228 | 0;
 i5 = _UNITY_png_realloc_array(i8, HEAP32[i3 >> 2] | 0, HEAP32[i9 >> 2] | 0, i2, 16) | 0;
 if (!i5) {
  _UNITY_png_chunk_report(i8, gb + 352481 | 0, 1);
  return;
 }
 _UNITY_png_free(i8, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = i5;
 i7 = i1 + 220 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 32;
 i7 = i1 + 8 | 0;
 i1 = i5 + (HEAP32[i9 >> 2] << 4) | 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (!i3) i10 = 7; else {
   i6 = i4 + 8 | 0;
   if (!(HEAP32[i6 >> 2] | 0)) i10 = 7; else {
    HEAP8[i1 + 4 >> 0] = HEAP8[i4 + 4 >> 0] | 0;
    i3 = (_strlen(i3) | 0) + 1 | 0;
    i5 = _UNITY_png_malloc_base(i8, i3) | 0;
    HEAP32[i1 >> 2] = i5;
    if (!i5) break;
    _memcpy(i5 | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0;
    i3 = i4 + 12 | 0;
    i5 = _UNITY_png_malloc_array(i8, HEAP32[i3 >> 2] | 0, 10) | 0;
    HEAP32[i1 + 8 >> 2] = i5;
    if (!i5) {
     i10 = 10;
     break;
    }
    HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
    _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 10 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8192;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    i1 = i1 + 16 | 0;
   }
  }
  if ((i10 | 0) == 7) {
   i10 = 0;
   _UNITY_png_app_error(i8, gb + 352502 | 0);
  }
  i2 = i2 + -1 | 0;
  if (!i2) {
   i10 = 15;
   break;
  } else i4 = i4 + 16 | 0;
 }
 if ((i10 | 0) == 10) _UNITY_png_free(i8, HEAP32[i1 >> 2] | 0); else if ((i10 | 0) == 15) return;
 if ((i2 | 0) <= 0) return;
 _UNITY_png_chunk_report(i8, gb + 352529 | 0, 1);
 return;
}

function __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 77;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 77;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2INS_11__wrap_iterIPS1_EEEET_S9_RKS3_PNS_9enable_ifIXaasr21__is_forward_iteratorIS9_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeE(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i5 >> 2] = 0;
 i11 = i5 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i1 = i10 - i3 | 0;
 i2 = (i1 | 0) / 20 | 0;
 if (!i1) return;
 if (i2 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
 i1 = __Znwj(i1) | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i1 + (i2 * 20 | 0);
 if ((i3 | 0) == (i10 | 0)) return;
 do {
  i9 = i3;
  i5 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i4 + 4 >> 2] = i5;
  i4 = i1 + 8 | 0;
  i5 = i3 + 8 | 0;
  HEAP32[i4 >> 2] = 0;
  i9 = i1 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  i7 = i3 + 12 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
  i6 = (i2 | 0) / 24 | 0;
  if (i2 | 0) {
   if (i6 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
   i8 = __Znwj(i2) | 0;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i1 + 16 >> 2] = i8 + (i6 * 24 | 0);
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i8 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i9 >> 2] = i8 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
   }
  }
  i3 = i3 + 20 | 0;
  i1 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
  HEAP32[i11 >> 2] = i1;
 } while ((i3 | 0) != (i10 | 0));
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 if (!(HEAP8[gb + 1098104 >> 0] | 0)) {
  i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i6 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i9 = gb + 63696 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i6, 1, gb + 1018240 | 0, 56, 32768, i4, 16);
  HEAP32[gb + 1158356 >> 2] = i6;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i6);
  if (i1) __Z19pop_allocation_rootv();
  i9 = gb + 1098104 | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = 0;
 }
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1158356 >> 2] | 0, i2);
 STACKTOP = i5;
 return;
}

function __ZN8JSONRead8TransferIdEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 36996 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 512)) {
   if (!(i4 & 1048576)) {
    HEAPF64[i11 >> 3] = 0.0;
    break;
   }
   if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
   HEAPF64[i11 >> 3] = +Math_fround(__Z19SimpleStringToFloatPKcPi(i1, 0));
  } else {
   do if (!(i4 & 16384)) {
    if (i4 & 1024 | 0) {
     d2 = +(HEAP32[i1 >> 2] | 0);
     break;
    }
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   HEAPF64[i11 >> 3] = d2;
  } while (0);
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5Unity11SpringJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity5Joint22JointTransferPreNoAxisI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738014 | 0, i5, i1 + 104 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738023 | 0, i5, i1 + 108 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864216 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 864230 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738032 | 0, i5, i1 + 112 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI17SortingLayerEntryEEvRT_17TransferMetaFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 370906 | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i4 + 4 | 0, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i4 + 8 | 0, 0);
 i5 = i1 + 16 | 0;
 i3 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 370924 | 0, HEAP32[gb + 37304 >> 2] | 0, i2 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN16b2BlockAllocator8AllocateEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 if ((i1 | 0) > 640) {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
  return i8 | 0;
 }
 i6 = HEAPU8[gb + 1552061 + i1 >> 0] | 0;
 i8 = i3 + 12 + (i6 << 2) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  i8 = i1;
  return i8 | 0;
 }
 i7 = i3 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i3 + 8 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  i5 = HEAP32[i3 >> 2] | 0;
  i1 = i1 + 128 | 0;
  HEAP32[i2 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
  HEAP32[i3 >> 2] = i1;
  _memcpy(i1 | 0, i5 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  _memset((HEAP32[i3 >> 2] | 0) + (HEAP32[i7 >> 2] << 3) | 0, 0, 1024) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63408 | 0);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16384, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
 i5 = i2 + (i1 << 3) + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 i3 = HEAP32[gb + 151768 + (i6 << 2) >> 2] | 0;
 HEAP32[i2 + (i1 << 3) >> 2] = i3;
 i6 = 16384 / (i3 | 0) | 0;
 i2 = i6 + -1 | 0;
 if ((i6 | 0) > 1) {
  i1 = 0;
  do {
   i6 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i4 + (Math_imul(i6, i3) | 0) >> 2] = i4 + (Math_imul(i1, i3) | 0);
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i4 + (Math_imul(i2, i3) | 0) >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i8 = HEAP32[i5 >> 2] | 0;
 return i8 | 0;
}

function __Z56ParticleSystem_ShapeModule_CUSTOM_GetSkinnedMeshRendererP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i5 = HEAP32[i2 + 48 + 52 >> 2] | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 13;
   }
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _UNITY_tt_face_get_metrics(i2, i1, i4, i7, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[i2 + 104 >> 2] | 0;
 i1 = i1 << 24 >> 24 == 0;
 i3 = HEAP32[(i1 ? i2 + 760 | 0 : i2 + 764 | 0) >> 2] | 0;
 i5 = (HEAP32[(i1 ? i2 + 684 | 0 : i2 + 692 | 0) >> 2] | 0) + i3 | 0;
 i2 = HEAP16[(i1 ? i2 + 216 | 0 : i2 + 296 | 0) + 34 >> 1] | 0;
 i1 = i2 & 65535;
 do if (i2 << 16 >> 16) {
  if (i1 >>> 0 > i4 >>> 0) {
   i1 = i3 + (i4 << 2) | 0;
   if ((i1 + 4 | 0) >>> 0 > i5 >>> 0) break;
   i5 = _UNITY_FT_Stream_Seek(i9, i1) | 0;
   HEAP32[i8 >> 2] = i5;
   if (i5 | 0) break;
   HEAP16[i6 >> 1] = _UNITY_FT_Stream_ReadUShort(i9, i8) | 0;
   if (HEAP32[i8 >> 2] | 0) break;
   HEAP16[i7 >> 1] = _UNITY_FT_Stream_ReadUShort(i9, i8) | 0;
   if (HEAP32[i8 >> 2] | 0) break;
   STACKTOP = i10;
   return;
  }
  i11 = i1 << 2;
  i2 = i3 + -4 + i11 | 0;
  if ((i11 + i3 | 0) >>> 0 <= i5 >>> 0) {
   i11 = _UNITY_FT_Stream_Seek(i9, i2) | 0;
   HEAP32[i8 >> 2] = i11;
   if (!i11) {
    HEAP16[i6 >> 1] = _UNITY_FT_Stream_ReadUShort(i9, i8) | 0;
    if (!(HEAP32[i8 >> 2] | 0)) {
     i1 = (i4 - i1 << 1) + 4 + i2 | 0;
     if ((i1 + 2 | 0) >>> 0 > i5 >>> 0) {
      HEAP16[i7 >> 1] = 0;
      STACKTOP = i10;
      return;
     }
     i11 = _UNITY_FT_Stream_Seek(i9, i1) | 0;
     HEAP32[i8 >> 2] = i11;
     if (i11 | 0) {
      STACKTOP = i10;
      return;
     }
     HEAP16[i7 >> 1] = _UNITY_FT_Stream_ReadUShort(i9, i8) | 0;
     STACKTOP = i10;
     return;
    }
   }
  }
 } while (0);
 HEAP16[i7 >> 1] = 0;
 HEAP16[i6 >> 1] = 0;
 STACKTOP = i10;
 return;
}

function _gzclose(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i4) {
  i12 = -2;
  return i12 | 0;
 }
 do if ((HEAP8[i4 + 92 >> 0] | 0) == 119) {
  HEAP32[i4 + 4 >> 2] = 0;
  i8 = i4 + 16 | 0;
  i9 = i4 + 104 | 0;
  i10 = i4 + 56 | 0;
  i11 = i4 + 72 | 0;
  i5 = i4 + 64 | 0;
  i6 = i4 + 12 | 0;
  i3 = 0;
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i2 = 16384 - i1 | 0;
   i7 = (i2 | 0) == 0;
   if (!i7) {
    if ((_fwrite(HEAP32[i11 >> 2] | 0, 1, i2, HEAP32[i5 >> 2] | 0) | 0) != (i2 | 0)) {
     i12 = 6;
     break;
    }
    HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
    HEAP32[i8 >> 2] = 16384;
    i1 = 16384;
   }
   if (i3) {
    i12 = 12;
    break;
   }
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i1;
   i2 = _unity_z_deflate(i4, 4) | 0;
   HEAP32[i10 >> 2] = i2;
   i1 = HEAP32[i8 >> 2] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i1;
   if (i7 & (i2 | 0) == -5) {
    HEAP32[i10 >> 2] = 0;
    i3 = (i1 | 0) != 0;
    continue;
   } else if (i2 >>> 0 < 2) {
    i3 = (i2 | 0) == 1 | (i1 | 0) != 0;
    continue;
   } else break;
  }
  if ((i12 | 0) == 6) HEAP32[i10 >> 2] = -1; else if ((i12 | 0) == 12) if ((HEAP32[i10 >> 2] | 0) >>> 0 < 2) {
   i12 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i4 + 76 >> 2] | 0;
   _fputc(i11 & 255, i12) | 0;
   _fputc(i11 >>> 8 & 255, i12) | 0;
   _fputc(i11 >>> 16 & 255, i12) | 0;
   _fputc(i11 >>> 24, i12) | 0;
   i12 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i4 + 100 >> 2] | 0;
   _fputc(i11 & 255, i12) | 0;
   _fputc(i11 >>> 8 & 255, i12) | 0;
   _fputc(i11 >>> 16 & 255, i12) | 0;
   _fputc(i11 >>> 24, i12) | 0;
   break;
  }
  i12 = _destroy(i4) | 0;
  return i12 | 0;
 } while (0);
 i12 = _destroy(i4) | 0;
 return i12 | 0;
}

function __ZN9BlobWrite8TransferIN7mecanim9animation16ControllerMemoryEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim9animation16ControllerMemory8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim9animation16ControllerMemory8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i5) {
  if ((HEAP32[i1 + 92 >> 2] | 0) == (HEAP32[gb + 1170756 + ((i2 & 1) << 2) >> 2] | 0)) return;
  _memset(i7 | 0, 0, (i2 ? 52 : 244) | 0) | 0;
  __ZN19ShaderPropertySheet11ComputeHashEv(i1);
  return;
 }
 i3 = i7 + 4 | 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i4 = i5 + 1628 | 0;
 if (i2) {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
  i6 = i7 + 36 | 0;
  i5 = i5 + 1724 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAPF32[i7 + 20 >> 2] = Math_fround(0.0);
 } else {
  _memcpy(i3 | 0, i4 | 0, 240) | 0;
  HEAP32[i7 + 20 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 36 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i7 + 44 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i7 + 132 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i7 + 148 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i7 + 172 >> 2] = HEAP32[i6 + 24 >> 2];
  HEAP32[i7 + 180 >> 2] = HEAP32[i6 + 28 >> 2];
  HEAP32[i7 + 196 >> 2] = HEAP32[i6 + 32 >> 2];
  HEAP32[i7 + 220 >> 2] = HEAP32[i6 + 36 >> 2];
  HEAP32[i7 + 228 >> 2] = HEAP32[i6 + 40 >> 2];
 }
 __ZN19ShaderPropertySheet11ComputeHashEv(i1);
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i9 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i4 = i1 + (i3 << 5) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i9);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 24 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i11, i7, i1) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i8 = i11 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i3;
  i3 = i6;
 }
 i1 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = (i5 - i4 | 0) / 24 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj(i1, i3 - i2 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
 } else if (i3 >>> 0 < i2 >>> 0) {
  i1 = i4 + (i3 * 24 | 0) | 0;
  if ((i5 | 0) == (i1 | 0)) i1 = i4; else {
   i5 = i5 + (~(((i5 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i5;
   i1 = i4;
  }
 } else i1 = i4;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i11);
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i4;
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18AudioLowPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(140, i1, 16, gb + 1048932 | 0, 0, gb + 873364 | 0, 10) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 171508 + 8;
 HEAPF32[i4 + 48 >> 2] = Math_fround(inf);
 HEAP32[i4 + 44 >> 2] = 0;
 i5 = i4 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i4 + 76 >> 2] = Math_fround(inf);
 HEAP32[i4 + 72 >> 2] = 0;
 i5 = i4 + 80 | 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 104 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i4 + 124 >> 2] = 2;
 HEAP32[i4 + 120 >> 2] = 2;
 HEAP32[i4 + 128 >> 2] = 4;
 HEAPF32[i4 + 132 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 136 >> 0] = 0;
 HEAP32[i2 >> 2] = 3;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 184 | 0;
 i6 = i9;
 i7 = i8 + 500 | 0;
 __ZN20DeviceBlendStateGLESC2ERK13GfxBlendState(i6, i1);
 i2 = i8 + 504 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = i1 + 16 | 0;
   if ((_memcmp(i6, i2, 68) | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((_memcmp(i2, i6, 68) | 0) >= 0) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  i8 = i8 + 16 | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = __Znwj(200) | 0;
 _memcpy(i2 + 16 | 0, i6 | 0, 184) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (!i1) i1 = i2; else {
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 504 >> 2] | 0, i1);
 i8 = i8 + 508 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i2;
 i8 = i8 + 16 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14dense_hash_mapIPKcPK4RTTIN11TypeManager23ConstCharPtrHashFunctorENS5_19ConstCharPtrEqualToE13stl_allocatorINSt3__24pairIKS1_S4_EEL18MemLabelIdentifier6ELi16EEE5beginEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i2 + 28 >> 2] | 0;
 i7 = HEAP32[i2 + 32 >> 2] | 0;
 i9 = i3 + (i7 << 3) | 0;
 HEAP32[i1 >> 2] = i2;
 i10 = i1 + 4 | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i9;
 if (!i7) return;
 i5 = i2 + 4 | 0;
 i6 = i2 + 8 | 0;
 i7 = i2 + 12 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i4) {
  while (1) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) {
    if (!(HEAP8[i6 >> 0] | 0)) {
     i1 = 19;
     break;
    }
    if (!(HEAP32[i5 >> 2] | 0)) {
     i1 = 19;
     break;
    }
    i2 = HEAP32[i7 >> 2] | 0;
    if ((i2 | 0) != (i1 | 0)) {
     if (!i2) {
      i1 = 19;
      break;
     }
     if (_strcmp(i2, i1) | 0) {
      i1 = 19;
      break;
     }
    }
   }
   i3 = i3 + 8 | 0;
   HEAP32[i10 >> 2] = i3;
   if ((i3 | 0) == (i9 | 0)) {
    i1 = 19;
    break;
   }
  }
  if ((i1 | 0) == 19) return;
 } else i8 = i3;
 L20 : while (1) {
  i1 = HEAP32[i8 >> 2] | 0;
  do if ((i4 | 0) != (i1 | 0)) {
   i2 = (i1 | 0) != 0;
   if (i2) if (!(_strcmp(i4, i1) | 0)) break;
   if (!(HEAP8[i6 >> 0] | 0)) {
    i1 = 19;
    break L20;
   }
   if (!(HEAP32[i5 >> 2] | 0)) {
    i1 = 19;
    break L20;
   }
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) {
    if (!(i2 & (i3 | 0) != 0)) {
     i1 = 19;
     break L20;
    }
    if (_strcmp(i3, i1) | 0) {
     i1 = 19;
     break L20;
    }
   }
  } while (0);
  i8 = i8 + 8 | 0;
  HEAP32[i10 >> 2] = i8;
  if ((i8 | 0) == (i9 | 0)) {
   i1 = 19;
   break;
  }
 }
 if ((i1 | 0) == 19) return;
}

function __Z31AudioSource_Get_Custom_PropClipP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 436 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 12 | 0) + 1 | 0;
 if ((i8 | 0) < -12) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i6 = i7 << 1;
 i6 = i7 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 54;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 12 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 12;
 HEAP32[i8 >> 2] = i7 + (i6 * 12 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 54;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 114) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 117) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 101) {
    i2 = i10 + 28 | 0;
    i9 = i10 + 40 | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i7 = i10 + 44 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i10 + 36 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i10 + 32 >> 2] = i3;
      }
      i1 = HEAP32[i10 + 48 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i6 = i8 - i6 | 0;
     i10 = i6 + 24 | 0;
     i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i8;
     i1 = i8 + i6 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i8 + i10;
    }
    HEAP32[i9 >> 2] = i1 + 24;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 258;
    return;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 4 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZN6Camera11ResetAspectEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZL19GetCameraTargetRectRK6Camerab(i5, i1, 1);
 f2 = Math_fround(HEAPF32[i1 + 864 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 868 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 872 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 876 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f2 = Math_fround(f2 * f11);
 f10 = Math_fround(f10 * f11);
 f3 = Math_fround(f3 * f8);
 f7 = Math_fround(f7 * f8);
 f9 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f2 = Math_fround(f2 + f9);
 f3 = Math_fround(f3 + f6);
 f10 = Math_fround(f10 + f2);
 f7 = Math_fround(f7 + f3);
 f11 = Math_fround(f11 + f9);
 f8 = Math_fround(f8 + f6);
 f2 = Math_fround((f10 > f11 ? f11 : f10) - (f2 < f9 ? f9 : f2));
 f3 = Math_fround((f7 > f8 ? f8 : f7) - (f3 < f6 ? f6 : f3));
 i5 = f3 < Math_fround(0.0);
 f3 = i5 ? Math_fround(0.0) : f3;
 if (!(f3 != Math_fround(0.0))) {
  f11 = Math_fround(1.0);
  i5 = i1 + 1060 | 0;
  HEAPF32[i5 >> 2] = f11;
  i5 = i1 + 1077 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i1 + 1079 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i1 + 1078 | 0;
  HEAP8[i5 >> 0] = 1;
  i5 = i1 + 1086 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
 i5 = f2 < Math_fround(0.0);
 f11 = Math_fround((i5 ? Math_fround(0.0) : f2) / f3);
 i5 = i1 + 1060 | 0;
 HEAPF32[i5 >> 2] = f11;
 i5 = i1 + 1077 | 0;
 HEAP8[i5 >> 0] = 1;
 i5 = i1 + 1079 | 0;
 HEAP8[i5 >> 0] = 1;
 i5 = i1 + 1078 | 0;
 HEAP8[i5 >> 0] = 1;
 i5 = i1 + 1086 | 0;
 HEAP8[i5 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 * 24 | 0;
  i2 = i7 + 192 | 0;
  if (i1 >>> 0 < 193 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 709460 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 200 >> 2] | 0;
 i4 = i1 + (i3 * 24 | 0) | 0;
 i5 = i7 + 196 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 24 | 0;
  }
 }
 i2 = i7 + 204 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 192 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 48 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 656402 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 48 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
   i1 = i1 + 48 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 48 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE(i8, i1, i2, i3, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = -1;
 HEAP32[i8 + 16 >> 2] = -1;
 HEAP32[i8 + 20 >> 2] = -1;
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 + 24 >> 2] = i1;
 i2 = i7 + 8 | 0;
 if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) {
  i6 = i7;
  i7 = i1;
  i5 = i7 + 1 | 0;
  HEAP32[i4 >> 2] = i5;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + (i7 << 2) | 0;
  HEAP32[i7 >> 2] = i8;
  i7 = i8 + 28 | 0;
  HEAP32[i7 >> 2] = -1;
  i8 = i8 + 32 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  STACKTOP = i9;
  return;
 }
 i1 = (i1 | 0) == 0 ? 16 : i1 << 1;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9 + 1 | 0, i1 << 2, gb + 730303 | 0, 136) | 0;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > 0) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  if ((i1 | 0) > 1) {
   i2 = 1;
   do {
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
   i6 = 7;
  } else i6 = 7;
 } else if (i3) i6 = 7;
 if ((i6 | 0) == 7) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i6 = i7;
 i7 = i1;
 i5 = i7 + 1 | 0;
 HEAP32[i4 >> 2] = i5;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i7 << 2) | 0;
 HEAP32[i7 >> 2] = i8;
 i7 = i8 + 28 | 0;
 HEAP32[i7 >> 2] = -1;
 i8 = i8 + 32 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 STACKTOP = i9;
 return;
}

function __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 16 | 0;
 i8 = i1 + 164 | 0;
 i9 = i1 + 148 | 0;
 i12 = HEAP16[i9 >> 1] | 0;
 HEAP16[i9 >> 1] = (((i12 & 65535) >>> 15 & 65535 | (HEAP32[i8 >> 2] | 0) == 0) & 65535) << 15 & 65535 | i12 & 32767;
 HEAP32[i1 + 80 + (i2 << 2) >> 2] = i3;
 i12 = (HEAP32[i8 >> 2] | 0) == 0;
 i10 = HEAP16[i9 >> 1] | 0;
 i14 = i10 & 15;
 i13 = 1 << i2;
 i11 = ~i13;
 HEAP16[i9 >> 1] = (i12 ? i14 | i13 : i14 & i11) & 15 | i10 & 32752 | ((i12 & 1 | (i10 & 65535) >>> 15 & 65535) & 65535) << 15 & 65535;
 HEAP32[i1 + 96 + (i2 << 2) >> 2] = i4;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = (i1 | 0) == 0;
 i10 = HEAP16[i9 >> 1] | 0;
 i12 = (i10 & 65535) >>> 4 & 15;
 HEAP16[i9 >> 1] = ((i8 ? i12 | i13 : i12 & i11) & 65535) << 4 & 240 | i10 & -241;
 if (i8) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 i1 = __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj(i1, i2, i3, i4) | 0;
 if (!i1) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 i14 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i6 >> 2] = gb + 853918;
 HEAP32[i6 + 4 >> 2] = 268;
 HEAP32[i6 + 8 >> 2] = gb + 865248;
 HEAP32[i6 + 12 >> 2] = i14;
 __Z6FormatPKcz(i5, gb + 883334 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i14 = i1;
 STACKTOP = i7;
 return i14 | 0;
}

function __ZN16Physics2DManager17OverlapCapsuleAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DP13dynamic_arrayIPS5_Lj4EE(i1, i2, i3, i4, f5, i6, f7, f8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i12 = i14 + 4 | 0;
 if ((HEAP16[gb + 1457812 + 6 >> 1] | 0) > -1) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457812 | 0, i11);
  i13 = gb + 1457812 | 0;
 } else i13 = 0;
 __ZN21OverlapCapsuleQuery2DC2ERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DR13dynamic_arrayIPS5_Lj4EE(i12, i2, i3, i4, Math_fround(f5 * Math_fround(.0174532924)), i6, f7, f8, i9, i10);
 i1 = i12 + 240 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i12, i12 + 208 | 0);
 i12 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i12 >> 2] | 0;
 __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_(i10, i10 + (HEAP32[i12 + 12 >> 2] << 2) | 0, i11);
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 if (!i13) {
  STACKTOP = i14;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i13);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(i7, i8, i2, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 4 | 0;
 i3 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, i2, gb + 1048681 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) {
  __ZN14SafeBinaryRead10SetVersionEi(i7, 2);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i4, 0) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) {
    i1 = i7 + 16 | 0;
    i4 = HEAP32[i7 + 20 >> 2] | 0;
    i2 = i4 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
    HEAP32[i1 >> 2] = i2;
    if (i2 >>> 0 < i4 >>> 0) i5 = 8; else {
     i3 = i2 + 4 | 0;
     if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i5 = 8; else {
      HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
      HEAP32[i1 >> 2] = i3;
     }
    }
    if ((i5 | 0) == 8) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
    if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i8 >> 2] = _llvm_bswap_i32(HEAP32[i8 >> 2] | 0) | 0;
   } else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
  if (__ZN14SafeBinaryRead12IsOldVersionEi(i7, 1) | 0) {
   i1 = HEAP32[i8 >> 2] | 0;
   if (i1 & 32 | 0) HEAP32[i8 >> 2] = i1 | -65536;
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i8 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i6;
 return;
}

function __Z44Physics_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK8Vector3fS1_P11Il2CppArrayfi23QueryTriggerInteraction(i2, i3, i6, f7, i8, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, f5 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f5 * f5);
 i11 = i3 + 4 | 0;
 f13 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f5 + Math_fround(f13 * f13));
 i4 = i3 + 8 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(f13 + Math_fround(f5 * f5))));
 if (!(f5 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 44) | 0;
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 f15 = Math_fround(f15 / f5);
 f14 = Math_fround(f14 / f5);
 f13 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) / f5);
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i10 + 12 >> 2] = f15;
 HEAPF32[i10 + 16 >> 2] = f14;
 HEAPF32[i10 + 20 >> 2] = f13;
 i3 = __Z17GetPhysicsManagerv() | 0;
 i3 = __ZN14PhysicsManager15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction(i3, i10, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0, f7, i8, i9) | 0;
 if (i3 | 0) {
  i2 = 0;
  while (1) {
   __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i1);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 44 | 0;
  }
 }
 i11 = i3;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 25;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5physx28solveParallelDefaultFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj(i15, i29, i34, i9, i7, i31, i8, i5, i4, i12, i13, i17, i18, i25, i26, i27, i23, i24, i22, i32, i33, i21, i20, i11, i19, i6, i1, i28, i14, i16, i3, i2, i30, i10) {
 i15 = i15 | 0;
 i29 = i29 | 0;
 i34 = i34 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i31 = i31 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i22 = i22 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i11 = i11 | 0;
 i19 = i19 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i28 = i28 | 0;
 i14 = i14 | 0;
 i16 = i16 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i30 = i30 | 0;
 i10 = i10 | 0;
 __ZN5physx18PxsDynamicsContext13solveParallelEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEEPPNS_12PxsRigidBodyEj(i15, i29, i34, i9, i7, i31, i8, i5, i4, i12, i13, i25, i26, i23, i24, i22, i32, i33, i21, i20, i11, i19, 0, i1, i28, i14, i16, i3, i30, i10);
 return;
}

function __ZN38StateMachineBehaviourVectorDescription8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902597 | 0, HEAP32[gb + 37052 >> 2] | 0, i1, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i4, 0);
 __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902627 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN21AnimationClipPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i3 = i9 + 164 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i10 + 12 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 1 | 0;
  i7 = i10 + 16 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i2 = i8 & 2147483647;
  do if (i6 >>> 0 > i2 >>> 0) {
   i1 = i8 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i2 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
    HEAP32[i7 >> 2] = i1;
    HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
    HEAP32[i7 >> 2] = i1;
    HEAP32[i10 >> 2] = i8;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i6;
  HEAP32[(HEAP32[i10 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[i3 >> 2];
 }
 i5 = i9 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) return;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i9;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i11 = 14;
    break;
   } else i3 = 0;
  }
  if ((i11 | 0) == 14) {
   i11 = 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i10 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i1 + 28 >> 2] | 0) >>> 0);
 return;
}

function __ZN14PhysicsManager14CapsuleCastAllERK8Vector3fS2_fS2_fi23QueryTriggerInteraction(i7, i8, i9, f10, i11, f12, i13, i14) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1452680 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452680 | 0, i6);
  i1 = gb + 1452680 | 0;
 } else i1 = 0;
 i2 = i7 + 784 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i7 + 788 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 + 736 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i6 + 52 >> 0] = 0;
 HEAP32[i6 + 56 >> 2] = i7;
 HEAP32[i6 + 60 >> 2] = 128;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151352 + 8;
 HEAP32[i6 + 68 >> 2] = i2;
 __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE(0, i8, i9, f10, i11, f12, i13, i14, i6);
 if (!i1) {
  STACKTOP = i15;
  return i2 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i15;
 return i2 | 0;
}

function __ZN13RenderManager24OnRenderTextureDestroyedEP13RenderTexture(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = i1 + 16 | 0;
 i1 = i2;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i5 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i5 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i3 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i3 + (i4 << 3) | 0)) i10 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 11;
    }
   }
   if ((i10 | 0) == 9) i10 = 11;
   if ((i10 | 0) == 11) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
   }
  }
  __ZN6Camera24OnRenderTextureDestroyedEP13RenderTexture(i1, i7);
  i1 = i2;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZN13GfxDeviceGLES20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace(i5, i1, i8, i9, i10, i11, i12, i13, i14, i15, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i16 + 4 | 0;
 i3 = i16;
 i7 = i5 + 4620 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i2 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i7, 5, i2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i3 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i3 = i2 + 8 | 0;
 i18 = HEAP32[i3 + 4 >> 2] | 0;
 i17 = i5 + 7320 | 0;
 i19 = HEAP32[i17 + 4 >> 2] | 0;
 if (i19 >>> 0 < i18 >>> 0 | ((i19 | 0) == (i18 | 0) ? (HEAP32[i17 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0)) {
  i18 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i5 + 5480 >> 2] | 0, 7) | 0;
  i19 = i5 + 7376 | 0;
  HEAP32[i19 >> 2] = HEAP32[i19 >> 2] | i18;
 }
 i19 = __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i7, i2, i13, i8, i9, i10, i11, i12, i14, i15, i6, 0) | 0;
 __Z34register_external_gfx_deallocationPvPKci(i4, gb + 603515 | 0, 1049);
 __Z32register_external_gfx_allocationPvjjPKci(i4, i19, i1, gb + 603515 | 0, 1050);
 STACKTOP = i16;
 return;
}

function __ZN10BlendShape8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 4 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 8 >> 0] = i1;
 i1 = i5 + 9 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i10;
  return;
 }
}

function __Z30LensFlare_Get_Custom_PropFlareP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = i2 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if ((i3 | 0) <= 0) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i3 + -1 | 0;
 i1 = 0;
 do {
  i9 = i1 | 1;
  i8 = i1 | 2;
  i7 = i1 | 3;
  i10 = i2 + (i1 << 4) | 0;
  i9 = i2 + (((i5 | 0) < (i9 | 0) ? i5 : i9) << 4) | 0;
  i8 = i2 + (((i5 | 0) < (i8 | 0) ? i5 : i8) << 4) | 0;
  i7 = i2 + (((i5 | 0) < (i7 | 0) ? i5 : i7) << 4) | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  i11 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i4 + (i1 << 4) >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + (i1 << 4) + 4 >> 2] = i12;
  HEAP32[i4 + (i1 << 4) + 8 >> 2] = i11;
  HEAP32[i4 + (i1 << 4) + 12 >> 2] = i6;
  i6 = i1 | 1;
  i11 = HEAP32[i9 + 4 >> 2] | 0;
  i12 = HEAP32[i8 + 4 >> 2] | 0;
  i13 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i4 + (i6 << 4) >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i4 + (i6 << 4) + 4 >> 2] = i11;
  HEAP32[i4 + (i6 << 4) + 8 >> 2] = i12;
  HEAP32[i4 + (i6 << 4) + 12 >> 2] = i13;
  i6 = i1 | 2;
  i13 = HEAP32[i9 + 8 >> 2] | 0;
  i12 = HEAP32[i8 + 8 >> 2] | 0;
  i11 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i4 + (i6 << 4) >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i4 + (i6 << 4) + 4 >> 2] = i13;
  HEAP32[i4 + (i6 << 4) + 8 >> 2] = i12;
  HEAP32[i4 + (i6 << 4) + 12 >> 2] = i11;
  i6 = i1 | 3;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i4 + (i6 << 4) >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i4 + (i6 << 4) + 4 >> 2] = i9;
  HEAP32[i4 + (i6 << 4) + 8 >> 2] = i8;
  HEAP32[i4 + (i6 << 4) + 12 >> 2] = i7;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i13 = i3 + 3 & -4;
 return i13 | 0;
}

function _Ins_DELTAP(i16, i1) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0, i19 = 0;
 i17 = mftCall_ii(HEAP32[i16 + 592 >> 2] | 0, i16 | 0) | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i6 = i16 + 28 | 0;
 if (!i12) {
  i17 = HEAP32[i6 >> 2] | 0;
  i18 = i16 + 32 | 0;
  HEAP32[i18 >> 2] = i17;
  return;
 }
 i13 = i16 + 24 | 0;
 i14 = i16 + 36 | 0;
 i15 = i16 + 44 | 0;
 i7 = i16 + 368 | 0;
 i8 = i16 + 332 | 0;
 i9 = i16 + 584 | 0;
 i10 = i16 + 561 | 0;
 i11 = i16 + 12 | 0;
 i5 = 1;
 while (1) {
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) < 2) break;
  i4 = i1 + -2 | 0;
  HEAP32[i6 >> 2] = i4;
  i19 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i19 + (i1 + -1 << 2) >> 2] | 0;
  i3 = i2 & 65535;
  i4 = HEAP32[i19 + (i4 << 2) >> 2] | 0;
  if ((i2 & 65535) >>> 0 < (HEAPU16[i15 >> 1] | 0) >>> 0) {
   i1 = i4 >>> 4 & 15;
   switch (HEAP8[i7 >> 0] | 0) {
   case 114:
    {
     i1 = i1 | 32;
     break;
    }
   case 113:
    {
     i1 = i1 | 16;
     break;
    }
   default:
    {}
   }
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i17 | 0) == ((i2 & 65535) + i1 | 0)) {
    i4 = i4 & 15;
    i19 = i4 + -8 | 0;
    mftCall_viiii(HEAP32[i9 >> 2] | 0, i16 | 0, i14 | 0, i3 | 0, ((i19 | 0) > -1 ? i4 + -7 | 0 : i19) << 6 - (i2 >>> 16) | 0);
   }
  } else if (HEAP8[i10 >> 0] | 0) HEAP32[i11 >> 2] = 134;
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 > i12 >>> 0) {
   i18 = 16;
   break;
  }
 }
 if ((i18 | 0) == 16) {
  i18 = HEAP32[i6 >> 2] | 0;
  i19 = i16 + 32 | 0;
  HEAP32[i19 >> 2] = i18;
  return;
 }
 if (HEAP8[i10 >> 0] | 0) HEAP32[i11 >> 2] = 129;
 HEAP32[i6 >> 2] = 0;
 i18 = HEAP32[i6 >> 2] | 0;
 i19 = i16 + 32 | 0;
 HEAP32[i19 >> 2] = i18;
 return;
}

function __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl7IntRectE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 4) + 1 | 0;
 if ((i8 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 3;
 i6 = i7 >> 4 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 34;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 16;
 HEAP32[i8 >> 2] = i7 + (i6 << 4);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 34;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i4, i5, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = i2 + 2 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i2 + 1 >> 0] | 0) == 117) {
  i3 = i2 + 3 | 0;
  HEAP32[i5 >> 2] = i3;
  if ((HEAP8[i1 >> 0] | 0) == 108) {
   i1 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i3 >> 0] | 0) == 108) {
    i2 = i10 + 28 | 0;
    i9 = i10 + 40 | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    i7 = i10 + 44 | 0;
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = i6;
    i8 = i1;
    if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
     i4 = i10 + 36 | 0;
     i5 = HEAP32[i4 >> 2] | 0;
     i6 = i5;
     if (!i5) {
      if (!(HEAP32[i2 >> 2] | 0)) {
       i3 = __Znwj(1) | 0;
       HEAP32[i2 >> 2] = i3;
       HEAP32[i10 + 32 >> 2] = i3;
      }
      i1 = HEAP32[i10 + 48 >> 2] | 0;
     } else {
      i1 = i3 - i6 | 0;
      i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
     }
     i6 = i8 - i6 | 0;
     i10 = i6 + 24 | 0;
     i10 = i1 >>> 0 < i10 >>> 0 ? i10 : i1;
     i8 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i10, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
     HEAP32[i4 >> 2] = i8;
     i1 = i8 + i6 | 0;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i7 >> 2] = i8 + i10;
    }
    HEAP32[i9 >> 2] = i1 + 24;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
    HEAP32[i1 + 12 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    return;
   }
  } else i1 = i3;
 }
 i10 = i1 + -1 - (HEAP32[i5 + 4 >> 2] | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 3;
 HEAP32[i4 + 28 >> 2] = i10;
 return;
}

function __ZN5physx5cloth8SwSolver22CpuClothSimulationTask11runInternalEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i6 = i10 + 1056 | 0;
 i3 = i10 + 320 | 0;
 i8 = i10 + 256 | 0;
 i4 = i9 + 20 | 0;
 i1 = __ZN5physx5cloth14SwSolverKernelI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(HEAP32[i4 >> 2] | 0) | 0;
 i5 = i9 + 28 | 0;
 if ((HEAP32[i5 >> 2] | 0) >>> 0 < i1 >>> 0) {
  i11 = i9 + 32 | 0;
  __ZN5physx5cloth10deallocateEPv(HEAP32[i11 >> 2] | 0);
  HEAP32[i11 >> 2] = __ZN5physx5cloth8allocateEj(i1) | 0;
  HEAP32[i5 >> 2] = i1;
 }
 i1 = i9 + 24 | 0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + 24 >> 2]);
 if (f2 == Math_fround(0.0)) {
  STACKTOP = i10;
  return;
 }
 __ZN5physx5cloth21IterationStateFactoryC2INS0_7SwClothEEERT_f(i8, HEAP32[i4 >> 2] | 0, f2);
 HEAP32[i9 + 36 >> 2] = HEAP32[i8 + 4 >> 2];
 i11 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 72 >> 2] | 0;
 i9 = HEAP32[i9 + 32 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN5physx5cloth11SwClothDataC2ERNS0_7SwClothERKNS0_8SwFabricE(i7, i11, HEAP32[i11 + 4 >> 2] | 0);
 HEAP32[i6 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i6 + 8 >> 2] = i9;
 HEAP32[i6 + 12 >> 2] = 0;
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fEC2ERKNS0_7SwClothERNS0_11SwClothDataER14StackAllocatorILj16EERNS0_21IterationStateFactoryEPNS_13PxProfileZoneE(i3, i11, i7, i6, i8, i4);
 __ZN5physx5cloth14SwSolverKernelI8Scalar4fEclEv(i3);
 __ZN5physx5cloth11SwCollisionI8Scalar4fED2Ev(i3 + 12 | 0);
 __ZNK5physx5cloth11SwClothData9reconcileERNS0_7SwClothE(i7, i11);
 STACKTOP = i10;
 return;
}

function __ZN11UnityEngine15CloudWebService18CloudServiceConfigD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = HEAP32[i5 + 100 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 104 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 112 >> 2] | 0;
  HEAP32[i6 >> 2] = 85;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = i5 + 84 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 96 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 68 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 80 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 52 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 64 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 48 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 STACKTOP = i7;
 return;
}

function __Z30TransferField_LinearCollectionI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 40 | 0;
 i7 = i11;
 i8 = i11 + 8 | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i5, i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = -1;
 do if (!(HEAP32[i4 + 4 >> 2] | 0)) i10 = 8; else {
  i2 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i5 >> 2] | 0) | 0;
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i2 = HEAP32[i1 + ((HEAP8[i5 + 4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i5 + 16 >> 2] | 0) | 0 : i2) >> 2] | 0;
  i6 = i2;
  if (!i2) {
   HEAP32[i7 >> 2] = i6;
   HEAP32[i7 + 4 >> 2] = -1;
   i10 = 8;
   break;
  }
  if (!(HEAP32[i5 + 24 >> 2] | 0)) i1 = __Z22scripting_array_lengthP11Il2CppArray(i2) | 0; else i1 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i7 + 4 >> 2] = i1;
  if ((i1 | 0) == -1) i10 = 8;
 } while (0);
 if ((i10 | 0) == 8) {
  i10 = HEAP32[i5 + 20 >> 2] | 0;
  HEAP32[i7 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i10, __Z34scripting_class_array_element_sizeP11Il2CppClass(i10) | 0, 0) | 0;
  HEAP32[i9 >> 2] = 0;
 };
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = i7;
 mftCall_vii(HEAP32[i3 + 40 >> 2] | 0, i3 | 0, i8 | 0);
 STACKTOP = i11;
 return;
}

function __ZN2UI20CleanupCanvasManagerEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[gb + 1467948 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1 + 12 | 0, HEAP32[i1 + 16 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i2);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63536 | 0);
 HEAP32[gb + 1467948 >> 2] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 27016 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 26248 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 3873 | 0)) {
   i4 = i6 + 26248 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 26248 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i8 = 13;
   break;
  }
 }
 if ((i8 | 0) == 13) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (i8 >>> 0 <= i1 >>> 0) return;
 do {
  i8 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 26248 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + 26248 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 26248 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 26248 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 26248 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 26248 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 * 40 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 40 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 * 40 | 0) | 0, 0, (i6 - i5 | 0) * 40 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 * 40 | 0);
 STACKTOP = i8;
 return;
}

function __ZN15SerializeTraitsIN9SubModule14SubEmitterDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 619747 | 0, gb + 619620 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ParticleSystemSubTypeEvRT_RT0_PKc17TransferMetaFlags(i6, i2 + 4 | 0, gb + 1047471 | 0, 0);
 i4 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1008162 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii(i5, i1, i2, i3, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i4 = i9;
 i7 = i9 + 16 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP32[i5 + 96 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418117 | 0, 0, gb + 411289 | 0, 253, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i5 | 0) | 0;
 if (!((i3 | 0) > -1 & (i1 | 0) > (i3 | 0))) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i3;
  __Z6FormatPKcz(i7, gb + 418144 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 411289 | 0, 259, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0) | 0;
 if ((i6 | 0) > -1 & (i1 | 0) > (i6 | 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i6;
 __Z6FormatPKcz(i7, gb + 418213 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 411289 | 0, 265, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z30RemoteSettings_CUSTOM_GetFloatP12Il2CppStringf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 48 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i6 = (__Z21GetUnityConnectClientv() | 0) + 768 | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i3);
 i3 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 HEAP32[i8 >> 2] = 0;
 i4 = i8 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i5 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i5 = _strlen(i3) | 0;
 if (i5 >>> 0 > 15) {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i8 + 4 >> 2] = i5;
  i1 = (i11 | 0) == 0 ? i1 : i11;
 }
 _memcpy(i1 | 0, i3 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 HEAP32[i4 >> 2] = i5;
 f2 = Math_fround(__ZN11UnityEngine7Connect14RemoteSettings8GetFloatERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEf(i6, i8, f2));
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return Math_fround(f2);
 }
 if (!(HEAP32[i8 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return Math_fround(f2);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return Math_fround(f2);
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  HEAP32[i5 >> 2] = i6;
  i4 = i4 + 4 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i6 = 9;
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i6 = 0;
  HEAP32[i5 >> 2] = i6;
  i6 = i4 + 4 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i8 = i5 + 4 | 0;
  HEAP32[i8 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i6 = i4 + 4 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i5 + 4 | 0;
 HEAP32[i8 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 76;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 76;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim9animation14AvatarConstantEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim9animation14AvatarConstant8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim9animation14AvatarConstant8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN5physx5cloth8SwFabricD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 >> 2] = gb + 167120 + 8;
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = gb + 167120 + 60;
 i2 = HEAP32[i6 + 12 >> 2] | 0;
 i3 = i2 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 i4 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i2 + (i4 << 2) >> 2];
 i1 = i6 + 68 | 0;
 i4 = HEAP32[i6 + 76 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i6 + 56 | 0;
 i4 = HEAP32[i6 + 64 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i6 + 44 | 0;
 i4 = HEAP32[i6 + 52 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 }
 i1 = i6 + 32 | 0;
 i4 = HEAP32[i6 + 40 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 i1 = i6 + 20 | 0;
 i4 = HEAP32[i6 + 28 >> 2] | 0;
 if (!((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0)) {
  HEAP32[i5 >> 2] = gb + 167224 + 8;
  HEAP32[i6 >> 2] = gb + 167276 + 8;
  __ZN5physx5cloth10deallocateEPv(i6);
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = gb + 167224 + 8;
 HEAP32[i6 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i6);
 return;
}

function __ZN4crnd12crn_unpacker11init_tablesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 92 | 0;
 i3 = i4 + 88 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i4 + 4 >> 2] | 0) + ((HEAPU8[i2 + 68 >> 0] | 0) << 8 | (HEAPU8[i2 + 67 >> 0] | 0) << 16 | (HEAPU8[i2 + 69 >> 0] | 0)) | 0;
 i2 = (HEAPU8[i2 + 65 >> 0] | 0) << 8 | (HEAPU8[i2 + 66 >> 0] | 0);
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 + 96 >> 2] = i1;
 HEAP32[i4 + 104 >> 2] = i2;
 HEAP32[i4 + 100 >> 2] = i1 + i2;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 if (!(__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i5, i4 + 116 | 0) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!((HEAPU8[i1 + 39 >> 0] | 0) << 8 | (HEAPU8[i1 + 40 >> 0] | 0))) {
  if (!((HEAPU8[i1 + 55 >> 0] | 0) << 8 | (HEAPU8[i1 + 56 >> 0] | 0))) {
   i5 = 0;
   return i5 | 0;
  }
 } else {
  if (!(__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i5, i4 + 140 | 0) | 0)) {
   i5 = 0;
   return i5 | 0;
  }
  if (__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i5, i4 + 188 | 0) | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i5 = 0;
   return i5 | 0;
  }
 } while (0);
 if ((HEAPU8[i1 + 55 >> 0] | 0) << 8 | (HEAPU8[i1 + 56 >> 0] | 0) | 0) {
  if (!(__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i5, i4 + 164 | 0) | 0)) {
   i5 = 0;
   return i5 | 0;
  }
  if (!(__ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE(i5, i4 + 212 | 0) | 0)) {
   i5 = 0;
   return i5 | 0;
  }
 }
 i5 = 1;
 return i5 | 0;
}

function __Z49ParticleSystem_ShapeModule_CUSTOM_GetMeshRendererP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i5 = HEAP32[i2 + 48 + 48 >> 2] | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 13;
   }
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z42Animator_CUSTOM_GetCurrentAnimatorClipInfoP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i7 = i8 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 if (!i1) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i10 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(i3, i2, 1, i7) | 0;
 i2 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 8, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i10 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i10, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, i1, 8) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return i2 | 0;
}

function __Z38ReflectionProbe_Get_Custom_PropTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZNK15ReflectionProbe10GetTextureEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z38MeshCollider_Get_Custom_PropSharedMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZNK12MeshCollider13GetSharedMeshEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN6Socket7ConnectEPK8sockaddrjlbb(i1, i2, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 24 | 0;
 i8 = i11;
 if (!i1) i3 = 0; else i3 = __Z7CRCDonej(__Z7CRCFeedjPKhj(__Z7CRCFeedjPKhj(__Z8CRCBeginv() | 0, i1 + 4 | 0, 4) | 0, i1 + 2 | 0, 2) | 0) | 0;
 i4 = _socket(2, 1, 6) | 0;
 __ZN6Socket10CheckErrorEiPKcii(i4, i6 ? 0 : gb + 458505 | 0, 0, i3) | 0;
 HEAP32[i8 >> 2] = 2048;
 if (!((_fcntl(i4, 4, i8) | 0) != -1 | i6)) {
  __Z6FormatPKcz(i8, gb + 458529 | 0, i11 + 16 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 458557 | 0, 147, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 i1 = _connect(i4, i1, i2) | 0;
 i2 = i7 ? (i6 ? 0 : gb + 458625 | 0) : 0;
 i1 = __ZN6Socket10CheckErrorEiPKcii(i1, i2, 115, i3) | 0;
 if ((i5 | 0) != -1 & (i1 ^ 1)) {
  if (!(i1 | (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket19PollAsyncConnectionEil(i4, i5) | 0, i2, 115, i3) | 0))) i10 = 11;
 } else if (!i1) i10 = 11;
 if ((i10 | 0) == 11) {
  __Z36RemoveErrorWithIdentifierFromConsolei(i3);
  i10 = i4;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (!(i6 | i7 ^ 1)) {
  __Z6FormatPKcz(i8, gb + 458625 | 0, i9);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 458557 | 0, 165, 1, 0, i3, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 }
 _close(i4) | 0;
 i10 = -1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5Unity12PhysicsQuery14CapsuleCastAllERK8Vector3fS3_fS3_fi23QueryTriggerInteraction(i7, i8, i9, f10, i11, f12, i13, i14) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i15 + 8 | 0;
 i1 = i15;
 if ((HEAP16[gb + 1452680 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452680 | 0, i6);
  i1 = gb + 1452680 | 0;
 } else i1 = 0;
 i2 = i7 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i7 + 52 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP8[i6 + 52 >> 0] = 0;
 HEAP32[i6 + 56 >> 2] = i7;
 HEAP32[i6 + 60 >> 2] = 128;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151352 + 8;
 HEAP32[i6 + 68 >> 2] = i2;
 __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE(0, i8, i9, f10, i11, f12, i13, i14, i6);
 if (!i1) {
  STACKTOP = i15;
  return i2 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i15;
 return i2 | 0;
}

function __ZN19SkinnedMeshRenderer14UpdateRendererEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 28 | 0;
 do if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
   if (!(HEAP8[i4 + 464 >> 0] | 0)) if (!(HEAP32[i4 + 380 >> 2] | 0)) break;
   __ZN8Renderer18UpdateManagerStateEb(i4, 1);
   __ZN8Renderer16TransformChangedEi(i4, 11);
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 do if (!(HEAP8[i4 + 467 >> 0] | 0)) {
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN8Renderer14UpdateRendererEv(i4);
   return;
  }
 } else {
  i3 = i1 & (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0);
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(i3 ^ (i1 | 0) != 0)) {
   __ZN8Renderer14UpdateRendererEv(i4);
   return;
  }
  if (!i3) {
   if (i1 | 0) break;
   __ZN8Renderer14UpdateRendererEv(i4);
   return;
  }
  if ((i2 | 0) == (gb + 1161628 | 0)) {
   __ZN8Renderer14UpdateRendererEv(i4);
   return;
  }
  if (!i1) i1 = i4 + 528 | 0; else {
   i3 = i4 + 528 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[gb + 1161628 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = gb + 1161628;
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  __ZN8Renderer14UpdateRendererEv(i4);
  return;
 } while (0);
 i3 = i4 + 528 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN8Renderer14UpdateRendererEv(i4);
 return;
}

function __ZN13GfxDeviceGLES13SetBlendStateEPK16DeviceBlendState(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if (!(HEAP32[(HEAP32[(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i8 + 4616 >> 2] | 0) | 0) + 212 >> 2] | 0) + 20 >> 2] & 64)) {
  if (!(HEAP8[i1 >> 0] | 0)) i1 = HEAP32[i8 + 7144 >> 2] | 0;
 } else {
  i5 = i8 + 6616 | 0;
  i1 = (i1 | 0) == 0 ? HEAP32[i8 + 7084 >> 2] | 0 : i1;
  i2 = i6;
  i3 = i1;
  i4 = i2 + 68 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  if (!(HEAP8[i6 >> 0] | 0)) i2 = 0; else {
   HEAP8[i6 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 8 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 16 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 24 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 32 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 40 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 48 | 0;
  if (HEAP8[i3 >> 0] | 0) {
   HEAP8[i3 >> 0] = 0;
   i2 = 1;
  }
  i3 = i6 + 56 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   if (i2) i7 = 5;
  } else {
   HEAP8[i3 >> 0] = 0;
   i7 = 5;
  }
  if ((i7 | 0) == 5) i1 = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i5, i6) | 0;
 }
 __ZN12_GLOBAL__N_113SetBlendStateER7ApiGLESR15DeviceStateGLESPK20DeviceBlendStateGLESi(i8 + 4620 | 0, i8 + 6616 | 0, i1, mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 356 >> 2] | 0, i8 | 0) | 0);
 STACKTOP = i9;
 return;
}

function __ZN11Rigidbody2D8AddForceERK8Vector2fNS_9ForceModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i6) return;
 if (HEAP32[i1 + 68 >> 2] | 0) return;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i1 = (HEAP32[i6 >> 2] | 0) == 2;
 if (!i3) {
  if (!i1) return;
  i2 = i6 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  i3 = i6 + 76 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i3 >> 2]));
  i6 = i6 + 80 | 0;
  HEAPF32[i6 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i6 >> 2]));
  return;
 } else {
  if (!i1) return;
  i2 = i6 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  f9 = Math_fround(HEAPF32[i6 + 120 >> 2]);
  f8 = Math_fround(f5 * f9);
  f9 = Math_fround(f4 * f9);
  i3 = i6 + 64 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i3 >> 2]));
  i3 = i6 + 68 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f9 + Math_fround(HEAPF32[i3 >> 2]));
  f9 = Math_fround(HEAPF32[i6 + 128 >> 2]);
  f8 = Math_fround(HEAPF32[i6 + 44 >> 2]);
  f8 = Math_fround(f8 - f8);
  f7 = Math_fround(HEAPF32[i6 + 48 >> 2]);
  f5 = Math_fround(f9 * Math_fround(Math_fround(f4 * f8) - Math_fround(f5 * Math_fround(f7 - f7))));
  i6 = i6 + 72 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f5);
  return;
 }
}

function __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i4);
 i1 = i5 + 88 | 0;
 i6 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 48 | 0, i4);
 __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 52 | 0, i4);
 i1 = i5 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i1 = i5 + 98 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 99 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i5 + 96 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 }
}

function __ZL17Transfer_GUIStyleI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 256 | 0;
 i5 = i9 + 248 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i8 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i8);
 if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 128 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = 0;
 do {
  i4 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i2 >> 2] | 0, i1) | 0) >> 2] | 0;
  if (i4 | 0) {
   i10 = __Z9GetIIMGUIv() | 0;
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i5, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0, gb + 1034525 | 0, 1);
   if (HEAP32[i5 >> 2] | 0) {
    i12 = i5;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i7;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i4, i8);
    HEAP32[i8 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i8, 0) | 0;
   }
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __Z41Rigidbody2D_Get_Custom_PropSharedMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN11Rigidbody2D11GetMaterialEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _strverscmp(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP8[i2 >> 0] | 0;
 i3 = HEAP8[i1 >> 0] | 0;
 L1 : do if (i5 << 24 >> 24 == i3 << 24 >> 24) {
  i4 = 1;
  i6 = i2;
  i3 = i5;
  i2 = i5 << 24 >> 24;
  while (1) {
   switch (i3 << 24 >> 24) {
   case 0:
    {
     i1 = 0;
     break L1;
    }
   case 48:
    {
     i2 = (i4 | 0) == 1 ? 0 : i4;
     break;
    }
   default:
    if ((i2 + -48 | 0) >>> 0 < 10) i2 = (i4 | 0) == 1 ? 2 : i4; else i2 = 1;
   }
   i6 = i6 + 1 | 0;
   i1 = i1 + 1 | 0;
   i5 = HEAP8[i6 >> 0] | 0;
   i3 = HEAP8[i1 >> 0] | 0;
   if (i5 << 24 >> 24 != i3 << 24 >> 24) break; else {
    i4 = i2;
    i3 = i5;
    i2 = i5 << 24 >> 24;
   }
  }
  if ((i2 | 0) == 1) {
   i2 = i6;
   i4 = i5;
   i9 = 9;
  } else {
   i8 = i1;
   i7 = i6;
   i4 = i5;
   i9 = 10;
  }
 } else {
  i4 = i5;
  i9 = 9;
 } while (0);
 if ((i9 | 0) == 9) {
  i8 = i1;
  i7 = i2;
  i2 = (i4 << 24 >> 24 == 48 | i3 << 24 >> 24 == 48) & 1 ^ 1;
  i9 = 10;
 }
 do if ((i9 | 0) == 10) {
  i5 = i4 << 24 >> 24;
  i6 = i3 << 24 >> 24;
  if ((i5 + -48 | 0) >>> 0 < 10) if ((i2 | 0) != 0 & (i6 + -48 | 0) >>> 0 < 10) {
   if (((i4 << 24 >> 24) + -48 | 0) >>> 0 < 10) {
    i1 = 1;
    while (1) if (((HEAP8[i7 + i1 >> 0] | 0) + -48 | 0) >>> 0 < 10) i1 = i1 + 1 | 0; else {
     i2 = i1;
     break;
    }
   } else i2 = 0;
   if (((i3 << 24 >> 24) + -48 | 0) >>> 0 < 10) {
    i1 = 1;
    while (1) if (((HEAP8[i8 + i1 >> 0] | 0) + -48 | 0) >>> 0 < 10) i1 = i1 + 1 | 0; else break;
   } else i1 = 0;
   if ((i2 | 0) == (i1 | 0)) {
    i1 = i5 - i6 | 0;
    break;
   } else {
    i1 = i2 >>> 0 > i1 >>> 0 ? 1 : -1;
    break;
   }
  }
  i1 = i5 - i6 | 0;
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i1, i6 + 120 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 140 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 144 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 148 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  i8 = i5;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESG_RKT_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIffEEPfEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 2 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -4 | 0;
   f3 = Math_fround(HEAPF32[i1 >> 2]);
   f4 = Math_fround(HEAPF32[i8 >> 2]);
   if (f3 < f4) {
    HEAPF32[i8 >> 2] = f3;
    HEAPF32[i1 >> 2] = f4;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_(i8, i8 + 4 | 0, i8 + 8 | 0, i8 + 12 | 0, i7 + -4 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 8 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i8, i8 + 4 | 0, i2, i1) | 0;
   i6 = i8 + 12 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    f3 = Math_fround(HEAPF32[i6 >> 2]);
    if (f3 < Math_fround(HEAPF32[i2 >> 2])) {
     i5 = i6;
     while (1) {
      HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
      if ((i2 | 0) == (i8 | 0)) break;
      i5 = i2 + -4 | 0;
      if (f3 < Math_fround(HEAPF32[i5 >> 2])) {
       i9 = i2;
       i2 = i5;
       i5 = i9;
      } else break;
     }
     HEAPF32[i2 >> 2] = f3;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 4 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 4 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 65372 + 8;
 i2 = i1 + 36 | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 68 >> 2] = i3;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = i1;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = i1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = i1;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = i1;
 HEAP32[i1 + 136 >> 2] = 1;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 143 >> 0] = 0;
 HEAP8[i1 + 141 >> 0] = 0;
 HEAP8[i1 + 140 >> 0] = 0;
 HEAP8[i1 + 142 >> 0] = 1;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __Z40Collider2D_Get_Custom_PropSharedMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN10Collider2D11GetMaterialEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z39Animator_CUSTOM_GetNextAnimatorClipInfoP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i7 = i8 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 if (!i1) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i10 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(i3, i2, 0, i7) | 0;
 i2 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 8, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i10 = (HEAP32[i7 >> 2] | 0) + (i1 << 3) | 0;
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i10, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, i1, 8) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return i2 | 0;
}

function __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local13_computeDepthERKS1_PNS0_9MetaClassEiRi(i13, i1, i2, i12) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 if ((HEAP32[i12 >> 2] | 0) < (i2 | 0)) HEAP32[i12 >> 2] = i2;
 i11 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i11) {
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i8 = i1 + 24 | 0;
 i9 = i13 + 24 | 0;
 i10 = i13 + 20 | 0;
 i6 = i2 + 1 | 0;
 i7 = 0;
 L7 : while (1) {
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 5) + 4 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if (!i3) {
   i2 = 12;
   break;
  }
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
   i5 = i5 + 1 | 0;
   if (!(_strcmp(HEAP32[i2 + 12 >> 2] | 0, i1) | 0)) break;
   if (i5 >>> 0 >= i3 >>> 0) {
    i2 = 12;
    break L7;
   }
  }
  while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if (!i2) {
   i2 = 12;
   break;
  }
  i7 = i7 + 1 | 0;
  if (!(__ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local13_computeDepthERKS1_PNS0_9MetaClassEiRi(i13, i2, i6, i12) | 0)) {
   i1 = 0;
   i2 = 14;
   break;
  }
  if (i7 >>> 0 >= i11 >>> 0) {
   i1 = 1;
   i2 = 14;
   break;
  }
 }
 if ((i2 | 0) == 12) {
  i13 = HEAP32[i13 >> 2] | 0;
  HEAP32[i14 >> 2] = i1;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i13, 32, gb + 671562 | 0, i14);
  i14 = 0;
  STACKTOP = i15;
  return i14 | 0;
 } else if ((i2 | 0) == 14) {
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__210__time_putC2EPKc(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i6 = i2;
 i5 = _newlocale(2147483647, i3, 0) | 0;
 HEAP32[i1 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i2;
  return;
 }
 i5 = ___cxa_allocate_exception(8) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = _strlen(i3) | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1040 | 0, i6 | 0, i3 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i7 = 13;
 } else {
  __THREW__ = 0;
  i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1081765 | 0) | 0;
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i2 = 1;
  } else {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i5 | 0, i4 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i5 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  if (i2) i7 = 13;
 }
 if ((i7 | 0) == 13) ___cxa_free_exception(i5 | 0);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210__time_getC2EPKc(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i6 = i2;
 i5 = _newlocale(2147483647, i3, 0) | 0;
 HEAP32[i1 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i2;
  return;
 }
 i5 = ___cxa_allocate_exception(8) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = _strlen(i3) | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1040 | 0, i6 | 0, i3 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i7 = 13;
 } else {
  __THREW__ = 0;
  i2 = invoke_iiii(fb + 511 | 0, i6 | 0, 0, gb + 1081634 | 0) | 0;
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   i2 = 1;
  } else {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = 0;
   while (1) {
    if ((i1 | 0) == 3) break;
    HEAP32[i2 + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i5 | 0, i4 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i5 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  if (i2) i7 = 13;
 }
 if ((i7 | 0) == 13) ___cxa_free_exception(i5 | 0);
 ___resumeException(i1 | 0);
}

function __ZNK5physx2Gu11HeightField25getTriangleNormalInternalEj(i11, i9, i1) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, f12 = f0;
 i4 = i1 >>> 1;
 i7 = HEAP32[i9 + 36 >> 2] | 0;
 i10 = (HEAP8[i7 + (i4 << 2) + 2 >> 0] | 0) < 0;
 i8 = (i1 & 1 | 0) == 0;
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 do if (i10) if (i8) {
  i5 = i3 + i4 | 0;
  i6 = i4;
  i1 = i4 + 1 + i3 | 0;
  break;
 } else {
  i6 = i4 + 1 | 0;
  i5 = i6;
  i6 = i3 + i6 | 0;
  i1 = i4;
  break;
 } else {
  i1 = i4 + 1 | 0;
  if (i8) {
   i5 = i4;
   i6 = i1;
   i1 = i3 + i4 | 0;
   break;
  } else {
   i5 = i3 + i1 | 0;
   i6 = i3 + i4 | 0;
   break;
  }
 } while (0);
 i4 = HEAP16[i7 + (i5 << 2) >> 1] | 0;
 i3 = HEAP16[i7 + (i6 << 2) >> 1] | 0;
 i1 = HEAP16[i7 + (i1 << 2) >> 1] | 0;
 i9 = Math_fround(HEAPF32[i9 + 40 >> 2]) >= Math_fround(0.0);
 f2 = i9 ? Math_fround(-1.0) : Math_fround(1.0);
 if (i10) if (i8) {
  f12 = Math_fround(f2 * Math_fround(i4 - i1 | 0));
  HEAPF32[i11 >> 2] = Math_fround(Math_fround(i3 - i4 | 0) * f2);
  HEAPF32[i11 + 4 >> 2] = f2;
  HEAPF32[i11 + 8 >> 2] = f12;
  return;
 } else {
  f12 = Math_fround(f2 * Math_fround(i1 - i4 | 0));
  HEAPF32[i11 >> 2] = Math_fround(Math_fround(i4 - i3 | 0) * f2);
  HEAPF32[i11 + 4 >> 2] = f2;
  HEAPF32[i11 + 8 >> 2] = f12;
  return;
 } else if (i8) {
  f12 = Math_fround(Math_fround(i4 - i3 | 0) * f2);
  HEAPF32[i11 >> 2] = Math_fround(f2 * Math_fround(i4 - i1 | 0));
  HEAPF32[i11 + 4 >> 2] = f2;
  HEAPF32[i11 + 8 >> 2] = f12;
  return;
 } else {
  f12 = Math_fround(Math_fround(i3 - i4 | 0) * f2);
  HEAPF32[i11 >> 2] = Math_fround(f2 * Math_fround(i1 - i4 | 0));
  HEAPF32[i11 + 4 >> 2] = f2;
  HEAPF32[i11 + 8 >> 2] = f12;
  return;
 }
}

function __ZN9ShaderLab26SerializedShaderDependency8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 i6 = i3 + 4 | 0;
 i9 = HEAP32[gb + 37260 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470673 | 0, i9, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 i7 = HEAP32[gb + 36976 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 470678 | 0, i9, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i8, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, i7, i6, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj(i9, i7, i5, i6, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i1 = i11 + 24 | 0;
 HEAP16[i1 >> 1] = i7;
 i2 = i9 + 280 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i9 + 212 | 0, i1, i8) | 0;
  if (!(HEAP8[i8 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i7;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i1 | 0, i5 | 0, i6 | 0, i10 | 0);
 }
 if (!(HEAP8[i9 + 276 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i3 = getTempRet0() | 0;
 i4 = HEAP32[i9 + 72 >> 2] | 0;
 if (!i4) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i8;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP8[i8 + 13 >> 0] = 0;
 i10 = i8 + 16 | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i3;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_(i9, i7, i8);
 if (!i1) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN4FMOD6System23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_(i2, i1, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i3 = i1 + 320 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i3 = i1 + 332 | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  i6 = i1 + 344 | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i6 = i1 + 356 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  d12 = +Math_fround(HEAPF32[i5 >> 2]);
  d13 = +Math_fround(HEAPF32[i5 + 4 >> 2]);
  _JS_Sound_SetListenerPosition(+d12, +d13, +(+Math_fround(HEAPF32[i5 + 8 >> 2])));
  d13 = +Math_fround(HEAPF32[i7 >> 2]);
  d12 = +Math_fround(HEAPF32[i7 + 4 >> 2]);
  d11 = +Math_fround(HEAPF32[i7 + 8 >> 2]);
  d10 = +Math_fround(HEAPF32[i8 >> 2]);
  d9 = +Math_fround(HEAPF32[i8 + 4 >> 2]);
  _JS_Sound_SetListenerOrientation(+d13, +d12, +d11, +d10, +d9, +(+Math_fround(HEAPF32[i8 + 8 >> 2])));
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 855670;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i4;
 return i8 | 0;
}

function __ZN2UI14CanvasRenderer12SyncClipRectENS0_8SyncFlagEb(i6, i4, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1468072 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468072 | 0, i1);
  i5 = gb + 1468072 | 0;
 } else i5 = 0;
 if (i4 & 1 | 0) {
  i1 = HEAP32[i6 + 204 >> 2] | 0;
  i2 = HEAP32[i6 + 208 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i7) {
   i1 = i1 + 112 | 0;
   HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 2;
  }
  i9 = i6 + 168 | 0;
  HEAP8[i3 + (i2 * 672 | 0) + 667 >> 0] = HEAP8[i6 + 165 >> 0] | 0;
  i1 = i3 + (i2 * 672 | 0) + 648 | 0;
  HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (i4 & 2 | 0) {
  i1 = HEAP32[i6 + 220 >> 2] | 0;
  i2 = HEAP32[i6 + 224 >> 2] | 0;
  i3 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i7) {
   i9 = i1 + 112 | 0;
   HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 2;
  }
  i7 = i6 + 168 | 0;
  HEAP8[i3 + (i2 * 672 | 0) + 667 >> 0] = HEAP8[i6 + 165 >> 0] | 0;
  i9 = i3 + (i2 * 672 | 0) + 648 | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP16[i3 + (i2 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i8;
 return;
}

function __Z32GUITexture_Set_Custom_PropBorderP12Il2CppObjectS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i6 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 HEAP32[i2 + 36 >> 2] = i1;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 8 | 0);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 HEAP32[i2 + 40 >> 2] = i1;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 16 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 HEAP32[i2 + 44 >> 2] = i1;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 24 | 0);
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP32[i2 + 48 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function _tt_cmap2_char_next(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
 if (i2 >>> 0 >= 65536) {
  i10 = 0;
  i12 = 0;
  HEAP32[i11 >> 2] = i10;
  return i12 | 0;
 }
 i10 = i1 + 6 | 0;
 i9 = i1 + 518 | 0;
 L4 : while (1) {
  i1 = i2 >>> 8;
  if (!i1) {
   i8 = i10 + (i2 << 1 & 510) | 0;
   if (!((HEAPU8[i8 >> 0] | 0) << 8 | (HEAPU8[i8 + 1 >> 0] | 0))) {
    i1 = i9;
    i12 = 6;
   }
  } else {
   i1 = i10 + (i1 << 1) | 0;
   i1 = (HEAPU8[i1 + 1 >> 0] | 0) & 248 | (HEAPU8[i1 >> 0] | 0) << 8;
   if (i1) {
    i1 = i9 + i1 | 0;
    i12 = 6;
   }
  }
  if ((i12 | 0) == 6) {
   i12 = 0;
   i4 = (HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0);
   i7 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
   i6 = i1 + 6 | 0;
   i8 = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
   i5 = (HEAPU8[i6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
   i1 = i2 & 255;
   if (i5) {
    i13 = i1 >>> 0 < i4 >>> 0;
    i3 = i13 ? 0 : i1 - i4 | 0;
    i2 = (i13 ? i4 : i1) + (i2 & -256) | 0;
    if (i3 >>> 0 < i7 >>> 0) {
     i4 = i6 + (i5 + (i3 << 1)) | 0;
     do {
      i1 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
      i4 = i4 + 2 | 0;
      if (i1 | 0) {
       i1 = i1 + i8 & 65535;
       if (i1 | 0) {
        i12 = 13;
        break L4;
       }
      }
      i3 = i3 + 1 | 0;
      i2 = i2 + 1 | 0;
     } while (i3 >>> 0 < i7 >>> 0);
    }
   }
  }
  i2 = i2 + 256 & -256;
  if (i2 >>> 0 >= 65536) {
   i2 = 0;
   i1 = 0;
   i12 = 13;
   break;
  }
 }
 if ((i12 | 0) == 13) {
  HEAP32[i11 >> 2] = i2;
  return i1 | 0;
 }
 return 0;
}

function _fmemopen(i3, i7, i1) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = (_strchr(i1, 43) | 0) == 0;
 do if (!i7) i9 = 3; else {
  i5 = HEAP8[i1 >> 0] | 0;
  i6 = i5 << 24 >> 24;
  if (!(_memchr(gb + 1074696 | 0, i6, 4) | 0)) i9 = 3; else {
   if ((i3 | 0) == 0 & i7 >>> 0 > 4294966151) {
    HEAP32[(___errno_location() | 0) >> 2] = 12;
    i1 = 0;
    break;
   }
   i2 = (i3 | 0) != 0;
   i1 = _calloc(i2 ? 1164 : i7 + 1164 | 0, 1) | 0;
   if (!i1) i1 = 0; else {
    i4 = i1 + 112 | 0;
    HEAP32[i1 + 84 >> 2] = i4;
    HEAP32[i1 + 60 >> 2] = -1;
    HEAP8[i1 + 75 >> 0] = -1;
    HEAP32[i1 + 44 >> 2] = i1 + 140;
    HEAP32[i1 + 48 >> 2] = 1024;
    i2 = i2 ? i3 : i1 + 1164 | 0;
    HEAP32[i1 + 124 >> 2] = i2;
    HEAP32[i1 + 120 >> 2] = i7;
    HEAP32[i1 + 128 >> 2] = i6;
    if (i8) HEAP32[i1 >> 2] = i5 << 24 >> 24 == 114 ? 8 : 4;
    switch (i5 << 24 >> 24) {
    case 114:
     {
      HEAP32[i1 + 116 >> 2] = i7;
      break;
     }
    case 97:
     {
      i8 = _strnlen(i2, i7) | 0;
      HEAP32[i4 >> 2] = i8;
      HEAP32[i1 + 116 >> 2] = i8;
      break;
     }
    default:
     {}
    }
    HEAP32[i1 + 32 >> 2] = fb + 490;
    HEAP32[i1 + 36 >> 2] = fb + 491;
    HEAP32[i1 + 40 >> 2] = fb + 492;
    HEAP32[i1 + 12 >> 2] = fb + 2792;
    if (!(HEAP32[gb + 1469464 + 4 >> 2] | 0)) HEAP32[i1 + 76 >> 2] = -1;
    ___lock(gb + 1469464 + 28 | 0);
    i2 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
    HEAP32[i1 + 56 >> 2] = i2;
    if (i2 | 0) HEAP32[i2 + 52 >> 2] = i1;
    HEAP32[gb + 1469464 + 24 >> 2] = i1;
    ___unlock(gb + 1469464 + 28 | 0);
   }
  }
 } while (0);
 if ((i9 | 0) == 3) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_(i9, i10, i7, i5, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_(i9, i10, i7, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  i1 = i5 + 4 | 0;
  i6 = i7 + 4 | 0;
 } else {
  if (i4 >>> 0 < i3 >>> 0) {
   i10 = i8;
   return i10 | 0;
  }
  i1 = i5 + 4 | 0;
  i2 = i7 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i6 = i2; else {
   i10 = i8;
   return i10 | 0;
  }
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i5 >> 2] = i4;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 i1 = i8 + 1 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) i5 = i10 + 4 | 0; else {
  if (i4 >>> 0 < i3 >>> 0) {
   i10 = i1;
   return i10 | 0;
  }
  i2 = i10 + 4 | 0;
  if ((HEAP32[i6 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) i5 = i2; else {
   i10 = i1;
   return i10 | 0;
  }
 }
 HEAP32[i10 >> 2] = i3;
 HEAP32[i7 >> 2] = i4;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 i2 = i8 + 2 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) i1 = i9 + 4 | 0; else {
  if (i4 >>> 0 < i3 >>> 0) {
   i10 = i2;
   return i10 | 0;
  }
  i1 = i9 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
   i10 = i2;
   return i10 | 0;
  }
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i4;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i10;
 i10 = i8 + 3 | 0;
 return i10 | 0;
}

function __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 52;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 52;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 51;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 51;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNKSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_(i1, i10, i2) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = i3;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 9;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 9;
  if ((i7 | 0) == 7) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i7 = 8;
    break;
   } else i1 = i2;
  } else if ((i7 | 0) == 9) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 11; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 11; else if ((i2 | 0) >= 0) {
     i7 = 16;
     break;
    }
   }
   if ((i7 | 0) == 11) if (!i6) {
    i7 = 16;
    break;
   }
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i7 = 15;
    break;
   } else i1 = i2;
  }
 }
 if ((i7 | 0) == 8) {
  HEAP32[i10 >> 2] = i1;
  i10 = i1;
  return i10 | 0;
 } else if ((i7 | 0) == 15) {
  HEAP32[i10 >> 2] = i1;
  i10 = i3;
  return i10 | 0;
 } else if ((i7 | 0) == 16) {
  HEAP32[i10 >> 2] = i1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, f10 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i6, i1 + 164 | 0);
 f10 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 24 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i2 + 28 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i2 + 32 >> 2]));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f7 * f7))));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i6 >> 2]));
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i6 + 4 >> 2]));
 i6 = f7 < Math_fround(0.0);
 i8 = f7 > Math_fround(1.0);
 f7 = i8 ? Math_fround(1.0) : f7;
 f7 = i6 ? Math_fround(0.0) : f7;
 i6 = (HEAP32[i2 + 100 >> 2] | 0) + 1089181156 | 0;
 i2 = (Math_imul(i6, 1790253981) | 0) + 1900727103 | 0;
 i6 = i6 << 11 ^ i6;
 __Z8EvaluateRK14MinMaxGradientff(i5, i1 + 8 | 0, f7, Math_fround(Math_fround(((i2 ^ i6 ^ i6 >>> 8) & 8388607 ^ i2 >>> 19) >>> 0) * Math_fround(1.19209304e-07)));
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = i2 >>> 8;
 HEAP32[i3 >> 2] = (Math_imul((i1 >>> 8 & 255) + 1 | 0, i5 & 255) | 0) & 65280 | (Math_imul((i1 >>> 24) + 1 | 0, i5 & 16711680) | 0) & -16777216 | (Math_imul((i1 & 255) + 1 | 0, i2 & 255) | 0) >>> 8 & 255 | (Math_imul((i1 >>> 16 & 255) + 1 | 0, i2 & 16711680) | 0) >>> 8 & 16711680;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj4ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i7, i6, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = i10 + 4 | 0;
 i9 = i7 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0) i1 = 6;
   break;
  }
 default:
  {}
 }
 if ((i1 | 0) == 6) {
  i2 = i7 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i7 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i7 >> 2] | 0, i7);
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
  STACKTOP = i10;
  return;
 }
 i2 = HEAP8[i6 + 64 >> 0] | 0;
 __ZN5physx2Sc9ShapeCore14setShape2ActorERKNS_11PxTransformE(i6, i8);
 i1 = HEAP32[i7 + -32 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i9 >> 2] & -1073741824 | 0) == 1073741824) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = 4;
 HEAP8[i4 >> 0] = i2;
 __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i6, i3, i4);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Scb14ParticleSystem18submitForceUpdatesEf(i6, f3) {
 i6 = i6 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i4 = HEAP32[i6 + 152 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (!i5) {
  i2 = i4 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i4 + 73 | 0; else {
   i9 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i8 = i4 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 707802;
   HEAP32[i1 + 4 >> 2] = i8;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i9, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i8;
  }
  _strncpy(i1, gb + 707802 | 0, 128) | 0;
  HEAP8[i4 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 i2 = i6 + 164 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i1 = i6 + 156 | 0;
  __ZN5physx2Sc18ParticleSystemCore18addDeltaVelocitiesERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef(i6 + 12 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 + 160 >> 2] | 0, f3);
  if (HEAP8[i2 >> 0] | 0) {
   i9 = HEAP32[i1 >> 2] | 0;
   _memset(HEAP32[i9 >> 2] | 0, 0, HEAP32[i9 + 4 >> 2] << 2 | 0) | 0;
   HEAP8[i2 >> 0] = 0;
  }
 }
 i1 = i6 + 176 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i2 = i6 + 168 | 0;
  __ZN5physx2Sc18ParticleSystemCore18addDeltaVelocitiesERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef(i6 + 12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 + 172 >> 2] | 0, Math_fround(1.0));
  if (HEAP8[i1 >> 0] | 0) {
   i9 = HEAP32[i2 >> 2] | 0;
   _memset(HEAP32[i9 >> 2] | 0, 0, HEAP32[i9 + 4 >> 2] << 2 | 0) | 0;
   HEAP8[i1 >> 0] = 0;
  }
 }
 if (i5) {
  STACKTOP = i7;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i3 + 480 | 0;
 i10 = i3 + 44 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i12 = i2;
 i11 = i7;
 i7 = i4;
 __ZN5physx22PxD6JointGeneratedInfoC2Ev(i10);
 HEAP32[i13 >> 2] = i12;
 HEAP32[i13 + 4 >> 2] = i11;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i6;
 HEAP32[i13 + 16 >> 2] = i7;
 HEAP32[i13 + 20 >> 2] = 0;
 HEAP32[i13 + 24 >> 2] = 0;
 __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j(i10, i13, 0) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i13 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx12processGearsEfRKNS_18PxVehicleGearsDataERNS_21PxVehicleDriveDynDataE(f9, i8, i6) {
 f9 = Math_fround(f9);
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, i7 = 0;
 i7 = i6 + 65 | 0;
 do if (HEAP8[i7 >> 0] | 0) {
  i1 = i6 + 68 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (((HEAP32[i8 + 132 >> 2] | 0) + -1 | 0) != (i2 | 0)) {
   i3 = i6 + 72 | 0;
   if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
    if (!i2) {
     HEAPF32[i6 + 80 >> 2] = Math_fround(0.0);
     HEAP32[i3 >> 2] = 2;
     HEAP32[i1 >> 2] = 1;
     break;
    }
    HEAPF32[i6 + 80 >> 2] = Math_fround(0.0);
    if ((i2 | 0) == 1) {
     HEAP32[i3 >> 2] = 2;
     HEAP32[i1 >> 2] = 1;
     break;
    } else {
     HEAP32[i3 >> 2] = i2 + 1;
     HEAP32[i1 >> 2] = 1;
     break;
    }
   }
  }
 } while (0);
 i5 = i6 + 66 | 0;
 i3 = i6 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (HEAP8[i5 >> 0] | 0) if (!i1) i1 = 0; else {
  i2 = i6 + 72 | 0;
  if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
   if ((i1 | 0) == 2) {
    HEAPF32[i6 + 80 >> 2] = Math_fround(0.0);
    HEAP32[i2 >> 2] = 0;
    HEAP32[i3 >> 2] = 1;
    i1 = 1;
    break;
   }
   HEAPF32[i6 + 80 >> 2] = Math_fround(0.0);
   if ((i1 | 0) == 1) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i3 >> 2] = 1;
    i1 = 1;
    break;
   } else {
    HEAP32[i2 >> 2] = i1 + -1;
    HEAP32[i3 >> 2] = 1;
    i1 = 1;
    break;
   }
  }
 } while (0);
 i2 = HEAP32[i6 + 72 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 i1 = i6 + 80 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 if (f4 > Math_fround(HEAPF32[i8 + 136 >> 2])) {
  HEAP32[i3 >> 2] = i2;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAP8[i5 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
  return;
 } else {
  HEAPF32[i1 >> 2] = Math_fround(f4 + f9);
  return;
 }
}

function __ZN5Umbra9intersectERKNS_4AABBERKNS_6SphereE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f1 - Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 20 >> 2]));
 f8 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f4 = Math_fround(-f8);
 do if (f5 < Math_fround(0.0)) if (f5 < f4) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(Math_fround(f5 * f5) + Math_fround(0.0));
  break;
 } else if (f1 > Math_fround(0.0)) if (f1 > f8) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(Math_fround(f1 * f1) + Math_fround(0.0));
  break;
 } else f1 = Math_fround(0.0); while (0);
 do if (f9 < Math_fround(0.0)) if (f9 < f4) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(f1 + Math_fround(f9 * f9));
  break;
 } else if (f6 > Math_fround(0.0)) if (f6 > f8) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(f1 + Math_fround(f6 * f6));
  break;
 } while (0);
 do if (f10 < Math_fround(0.0)) if (f10 < f4) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(f1 + Math_fround(f10 * f10));
  break;
 } else if (f7 > Math_fround(0.0)) if (f7 > f8) {
  i3 = 0;
  return i3 | 0;
 } else {
  f1 = Math_fround(f1 + Math_fround(f7 * f7));
  break;
 } while (0);
 if (f1 <= Math_fround(f8 * f8)) {
  i3 = 1;
  return i3 | 0;
 }
 i3 = 0;
 return i3 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i13, i6, i1) {
 i13 = i13 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i4 = i12;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = (i8 - i1 | 0) / 20 | 0;
 HEAP32[i4 >> 2] = i5;
 i9 = i13 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i13 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i5 = i1 + 12 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i11 >> 2] = i2;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
  i2 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i5 >> 2] | 0;
  i4 = i2 + i7 | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i9 >> 2] | 0;
   if ((i3 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 1);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i13);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i12;
 return;
}

function __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i11 + 80 | 0;
 i9 = i5 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i10 = i5 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4); else {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i3;
 }
 i6 = i11 + 88 | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i5);
 i7 = i11 + 176 | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
 i4 = i11 + 84 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 2 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i4, 2); else {
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i9 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 i10 = HEAP16[i4 >> 1] | 0;
 i1 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i11, i6, f2) | 0;
 if ((i10 & -2) << 16 >> 16 == 2) {
  if (!i1) {
   i10 = 0;
   i11 = i11 + 86 | 0;
   i10 = i10 & 1;
   HEAP8[i11 >> 0] = i10;
   return;
  }
  i10 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i11 + 40 | 0, i7, f2) | 0;
  i11 = i11 + 86 | 0;
  i10 = i10 & 1;
  HEAP8[i11 >> 0] = i10;
  return;
 } else {
  if (!i1) {
   i10 = 0;
   i11 = i11 + 86 | 0;
   i10 = i10 & 1;
   HEAP8[i11 >> 0] = i10;
   return;
  }
  i10 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i11 + 40 | 0, i6, f2) | 0;
  i11 = i11 + 86 | 0;
  i10 = i10 & 1;
  HEAP8[i11 >> 0] = i10;
  return;
 }
}

function __Z36MeshFilter_Get_Custom_PropSharedMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN10MeshFilter13GetSharedMeshEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __GLOBAL__sub_I_runtime_camera_culling_lump_cpp() {
 var i1 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114356 | 0, gb + 384791 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114368 | 0, gb + 384813 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114380 | 0, gb + 384834 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114392 | 0, gb + 384858 | 0, 0, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544227 | 0, fb + 3340 | 0, fb + 3341 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114404 | 0, gb + 384881 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114416 | 0, gb + 384918 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114428 | 0, gb + 384954 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114440 | 0, gb + 384982 | 0, 0, 0);
 i1 = gb + 1098024 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1114452 >> 2] = 0;
 HEAP32[gb + 1114452 + 4 >> 2] = 0;
 HEAP32[gb + 1114452 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114464 | 0, gb + 385006 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114476 | 0, gb + 385026 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114488 | 0, gb + 385053 | 0, 0, 0);
 return;
}

function _tlsf_check_heap(i16) {
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i1 = i16 + 3184 | 0;
 L1 : do if (!i1) i1 = 0; else {
  i4 = 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   if (i3 >>> 0 < 4) {
    i1 = i2;
    break L1;
   }
   i2 = i2 + (((i4 | 0) != (i3 >>> 1 & 1 | 0)) << 31 >> 31) | 0;
   i1 = (i3 + -4 & -4) + (i1 + 8) | 0;
   if (!i1) {
    i1 = i2;
    break;
   } else i4 = i3 & 1;
  }
 } while (0);
 i13 = HEAP32[i16 + 16 >> 2] | 0;
 i14 = i16 + 20 | 0;
 i15 = i16 + 116 | 0;
 i12 = 0;
 do {
  i9 = HEAP32[i14 + (i12 << 2) >> 2] | 0;
  i10 = (i13 & 1 << i12 | 0) == 0;
  i11 = ((i9 | 0) == 0) << 31 >> 31;
  i8 = 0;
  do {
   i2 = HEAP32[i15 + (i12 << 7) + (i8 << 2) >> 2] | 0;
   i7 = (i9 & 1 << i8 | 0) != 0;
   i1 = ((i10 & i7) << 31 >> 31) + i1 | 0;
   if (i7) {
    i7 = (i2 | 0) == (i16 | 0);
    i1 = (i7 << 31 >> 31) + i11 + i1 | 0;
    if (!i7) do {
     i6 = HEAP32[i2 + 4 >> 2] | 0;
     i7 = i2 + 8 | 0;
     i4 = HEAP32[(i6 + -4 & -4) + i7 + 4 >> 2] | 0;
     i5 = i6 & -4;
     if (i5 >>> 0 < 128) {
      i2 = i6 >>> 2;
      i3 = 0;
     } else {
      i3 = 31 - (Math_clz32(i5 | 0) | 0) | 0;
      i2 = i5 >>> (i3 + -5 | 0) ^ 32;
      i3 = i3 + -6 | 0;
     }
     i1 = i1 + -2 + (i6 & 1) + (i6 << 30 >> 31) + ((i5 >>> 0 < 12) << 31 >> 31) + (i4 << 31 >> 31) + (i4 >>> 1 & 1) + (((i3 | 0) != (i12 | 0) | (i2 | 0) != (i8 | 0)) << 31 >> 31) | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    } while ((i2 | 0) != (i16 | 0));
   } else i1 = i1 + (((i2 | 0) != (i16 | 0)) << 31 >> 31) | 0;
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != 32);
  i12 = i12 + 1 | 0;
 } while ((i12 | 0) != 24);
 return i1 | 0;
}

function __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 3 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 3 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 3);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 3) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 2;
 i5 = i6 >> 3 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 34;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 3 << 3) | 0;
 _memset(i3 | 0, 0, i8 << 3 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 3);
 HEAP32[i11 >> 2] = i6 + (i5 << 3);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 34;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIeeEEPeEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 3 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -8 | 0;
   d3 = +HEAPF64[i1 >> 3];
   d4 = +HEAPF64[i8 >> 3];
   if (d3 < d4) {
    HEAPF64[i8 >> 3] = d3;
    HEAPF64[i1 >> 3] = d4;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i8, i8 + 8 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i8 + 24 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i8, i8 + 8 | 0, i2, i1) | 0;
   i6 = i8 + 24 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    d4 = +HEAPF64[i6 >> 3];
    d3 = +HEAPF64[i2 >> 3];
    if (d4 < d3) {
     i5 = i6;
     while (1) {
      HEAPF64[i5 >> 3] = d3;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i5 = i2 + -8 | 0;
      d3 = +HEAPF64[i5 >> 3];
      if (!(d4 < d3)) break; else {
       i9 = i2;
       i2 = i5;
       i5 = i9;
      }
     }
     HEAPF64[i2 >> 3] = d4;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 8 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 8 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIddEEPdEEbT0_S5_T_(i8, i7, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, d4 = 0.0, i5 = 0, i6 = 0, i9 = 0;
 switch (i7 - i8 >> 3 | 0) {
 case 1:
 case 0:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = i7 + -8 | 0;
   d3 = +HEAPF64[i1 >> 3];
   d4 = +HEAPF64[i8 >> 3];
   if (d3 < d4) {
    HEAPF64[i8 >> 3] = d3;
    HEAPF64[i1 >> 3] = d4;
    i1 = 1;
   } else i1 = 1;
   break;
  }
 case 3:
  {
   __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i8, i8 + 8 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 4:
  {
   __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 case 5:
  {
   __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_(i8, i8 + 8 | 0, i8 + 16 | 0, i8 + 24 | 0, i7 + -8 | 0, i1) | 0;
   i1 = 1;
   break;
  }
 default:
  {
   i2 = i8 + 16 | 0;
   __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i8, i8 + 8 | 0, i2, i1) | 0;
   i6 = i8 + 24 | 0;
   i1 = 0;
   while (1) {
    if ((i6 | 0) == (i7 | 0)) {
     i2 = 1;
     i1 = 0;
     break;
    }
    d4 = +HEAPF64[i6 >> 3];
    d3 = +HEAPF64[i2 >> 3];
    if (d4 < d3) {
     i5 = i6;
     while (1) {
      HEAPF64[i5 >> 3] = d3;
      if ((i2 | 0) == (i8 | 0)) {
       i2 = i8;
       break;
      }
      i5 = i2 + -8 | 0;
      d3 = +HEAPF64[i5 >> 3];
      if (!(d4 < d3)) break; else {
       i9 = i2;
       i2 = i5;
       i5 = i9;
      }
     }
     HEAPF64[i2 >> 3] = d4;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) == 8) {
      i2 = 0;
      i1 = (i6 + 8 | 0) == (i7 | 0);
      break;
     }
    }
    i2 = i6;
    i6 = i6 + 8 | 0;
   }
   i1 = i1 | i2;
  }
 }
 return i1 | 0;
}

function __ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!(Math_fround(HEAPF32[i3 >> 2]) <= Math_fround(HEAPF32[i1 + 12 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(Math_fround(HEAPF32[i3 + 4 >> 2]) <= Math_fround(HEAPF32[i1 + 16 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(Math_fround(HEAPF32[i3 + 8 >> 2]) <= Math_fround(HEAPF32[i1 + 20 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(Math_fround(HEAPF32[i3 + 12 >> 2]) >= Math_fround(HEAPF32[i1 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(Math_fround(HEAPF32[i3 + 16 >> 2]) >= Math_fround(HEAPF32[i1 + 4 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = Math_fround(HEAPF32[i3 + 20 >> 2]) >= Math_fround(HEAPF32[i1 + 8 >> 2]);
   return i3 | 0;
  }
 case 1:
  {
   i3 = __ZN5Umbra9intersectERKNS_4AABBERKNS_4QuadE(i3, HEAP32[i1 >> 2] | 0) | 0;
   return i3 | 0;
  }
 case 2:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   f2 = Math_fround(HEAPF32[i1 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i3 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(f2 <= Math_fround(HEAPF32[i3 + 12 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i3 + 4 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   if (!(f2 <= Math_fround(HEAPF32[i3 + 16 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (!(f2 >= Math_fround(HEAPF32[i3 + 8 >> 2]))) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = f2 <= Math_fround(HEAPF32[i3 + 20 >> 2]);
   return i3 | 0;
  }
 default:
  {
   i3 = 1;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery(i4, i5, i8, i6, i10, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 HEAP32[i9 >> 2] = 0;
 i7 = __ZNK14dtNavMeshQuery16findStraightPathEPKfS1_PKyiPfPhPyPii(i2, i4, i4 + 12 | 0, HEAP32[i4 + 28 >> 2] | 0, HEAP32[i4 + 32 >> 2] | 0, i5, i8, i6, i9, i1) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  HEAP32[i10 >> 2] = 0;
  i11 = 1073741824;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((i2 | 0) > 0) {
  i3 = i4 + 8 | 0;
  i1 = 0;
  do {
   if (HEAP8[i8 + i1 >> 0] & 4) break;
   i15 = i5 + (i1 * 3 << 2) | 0;
   f14 = Math_fround(HEAPF32[i4 >> 2]);
   f14 = Math_fround(f14 - Math_fround(HEAPF32[i15 >> 2]));
   f13 = Math_fround(HEAPF32[i3 >> 2]);
   f13 = Math_fround(f13 - Math_fround(HEAPF32[i15 + 8 >> 2]));
   if (Math_fround(Math_fround(f14 * f14) + Math_fround(f13 * f13)) > Math_fround(.0000999999974)) break;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i2 = i2 - i1 | 0;
  HEAP32[i9 >> 2] = i2;
  if ((i1 | 0) != 0 & (i2 | 0) != 0) {
   _memmove(i8 | 0, i8 + i1 | 0, i2 | 0) | 0;
   _memmove(i6 | 0, i6 + (i1 << 3) | 0, i2 << 3 | 0) | 0;
   _memmove(i5 | 0, i5 + (i1 * 3 << 2) | 0, i2 * 12 | 0) | 0;
  }
 }
 i1 = 0;
 while (1) {
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = i2;
   break;
  }
  i15 = i1;
  i1 = i1 + 1 | 0;
  if (HEAP8[i8 + i15 >> 0] & 4) {
   i11 = 13;
   break;
  }
 }
 if ((i11 | 0) == 13) HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = i1;
 i15 = i7 & 64 | 1073741824;
 STACKTOP = i12;
 return i15 | 0;
}

function __ZN9BlobWrite8TransferIN7mecanim9animation12AvatarMemoryEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim9animation12AvatarMemory8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim9animation12AvatarMemory8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 613;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN26AnimatorOverrideController7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i9 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 908155 | 0, 25) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 178476 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i4 + 88 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i4 + 104 >> 2] = 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 108 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 112 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 120 >> 2] = i4;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = -1;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 144 >> 2] = 0;
 HEAP32[i4 + 148 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 136 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN17AnimationCurveTplIfE8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 8 | 0;
 i5 = i11;
 HEAP32[i2 + 16 >> 2] = 2;
 i6 = i1 + 56 | 0;
 i7 = i2 + 36 | 0;
 HEAP8[i7 >> 0] = 0;
 i8 = i2 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (i9 | 0) if ((HEAP32[i9 + 16 >> 2] | 0) == 3) {
  i12 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i2, i9, gb + 1034203 | 0) | 0;
  HEAP32[i8 >> 2] = i12;
  i3 = i2 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[gb + 37316 >> 2];
  if (i12 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i2, 1);
   i14 = i2 + 8 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i12 = i5;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags(i2, i6, i10, 0);
   HEAP8[i7 >> 0] = 1;
   i12 = i2 + 56 | 0;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
  }
  HEAP32[i8 >> 2] = i9;
  HEAP32[i3 >> 2] = i4;
 }
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 76 | 0, gb + 1034211 | 0, 1, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 80 | 0, gb + 1034225 | 0, 1, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 84 | 0, gb + 1034240 | 0, 1, 0);
 __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i1);
 STACKTOP = i11;
 return;
}

function __ZN16LightmapSettings15AppendLightmapsEiRK13dynamic_arrayI12LightmapDataLj4EE(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i1 = i11 + 8 | 0;
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 i8 = i3 + 36 | 0;
 i9 = i3 + 48 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if ((i7 | 0) < 1) {
  STACKTOP = i11;
  return;
 }
 i5 = i10 + i7 | 0;
 if (i5 >>> 0 > 65533) {
  HEAP32[i2 >> 2] = i7;
  HEAP32[i2 + 4 >> 2] = 65533;
  __Z6FormatPKcz(i1, gb + 403163 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 403085 | 0, 259, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i11;
  return;
 }
 HEAP32[i9 >> 2] = i5;
 i1 = i3 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i5 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i5 << 3, 4, i3 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 3, 4, i3 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 >> 2] = i2;
  break;
 } while (0);
 _memmove((HEAP32[i8 >> 2] | 0) + (i10 << 3) | 0, HEAP32[i6 >> 2] | 0, i7 << 3 | 0) | 0;
 __Z16AppendSceneRangeiiiR13dynamic_arrayI10SceneRangeLj4EE(i4, i10, i7, i3 + 56 | 0);
 __ZN16LightmapSettings7RebuildEv(i3);
 STACKTOP = i11;
 return;
}

function __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 24 | 0;
 i4 = i13 + 20 | 0;
 i8 = i13 + 12 | 0;
 i9 = i13 + 16 | 0;
 i10 = i13 + 8 | 0;
 i11 = i13;
 i12 = i13 + 4 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 __ZL27GetDestRenderTargetSurfacesP13RenderTextureR12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i1, i10, i11) | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 128 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 1) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 160 >> 0] | 0) {
   __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0;
   i1 = HEAP32[i10 >> 2] | 0;
   i2 = i1;
   if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > 1) {
    i3 = __Z12GetGfxDevicev() | 0;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 416 >> 2] | 0;
    HEAP32[i4 >> 2] = i2;
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    mftCall_viiii(i1 | 0, i3 | 0, i5 | 0, 4, 0);
    i1 = HEAP32[i11 >> 2] | 0;
    if (i1 | 0) {
     i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 416 >> 2] | 0;
     HEAP32[i8 >> 2] = i1;
     HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
     mftCall_viiii(i4 | 0, i3 | 0, i5 | 0, 4, 0);
    }
   }
  }
 }
 HEAP32[i12 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i10, i5, i9, 0, i7, 0, i6) | 0;
 STACKTOP = i13;
 return;
}

function __ZN11PlayerPrefs8GetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf(i2, f6) {
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 __ZL18InitializeIfNeededv();
 if (!(__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1103788 >> 2] | 0, i2) | 0)) {
  STACKTOP = i7;
  return Math_fround(f6);
 }
 i5 = HEAP32[gb + 1103788 >> 2] | 0;
 i4 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i5, i3, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(48) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i2);
  HEAP32[i1 + 28 >> 2] = 255;
  i2 = i1 + 36 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
  i5 = i5 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) != 253) {
  STACKTOP = i7;
  return Math_fround(f6);
 }
 f6 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 STACKTOP = i7;
 return Math_fround(f6);
}

function __Z28Font_Get_Custom_PropMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZNK13TextRendering4Font11GetMaterialEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 40 | 0;
 i8 = i7 + 24 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i5, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 1033949 | 0, i8, 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i8 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_(i4, i10, i3) {
 i4 = i4 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i3;
 i6 = i10;
 i9 = i8 - i6 | 0;
 i5 = i4 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = i2;
 if (i9 >>> 0 <= (i1 - i2 | 0) >>> 0) {
  i5 = i4 + 4 | 0;
  i2 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  i4 = i9 >>> 0 > i2 >>> 0;
  i3 = i4 ? i10 + i2 | 0 : i3;
  i2 = i3;
  i1 = i2 - i6 | 0;
  if (i1 | 0) _memmove(i7 | 0, i10 | 0, i1 | 0) | 0;
  i1 = i7 + i1 | 0;
  if (i4) {
   i1 = i8 - i2 | 0;
   if ((i1 | 0) <= 0) return;
   _memcpy(HEAP32[i5 >> 2] | 0, i3 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
   return;
  } else {
   if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) return;
   HEAP32[i5 >> 2] = i1;
   return;
  }
 }
 if (i2) {
  i1 = i4 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i7 | 0)) HEAP32[i1 >> 2] = i7;
  __ZdlPv(i7);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 if ((i9 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else i2 = 0;
 i8 = i1 - i2 | 0;
 i1 = i8 << 1;
 i1 = i8 >>> 0 < 1073741823 ? (i1 >>> 0 < i9 >>> 0 ? i9 : i1) : 2147483647;
 if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
 i2 = __Znwj(i1) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i5 >> 2] = i2 + i1;
 if ((i9 | 0) <= 0) return;
 _memcpy(i2 | 0, i10 | 0, i9 | 0) | 0;
 HEAP32[i3 >> 2] = i2 + i9;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE7reserveEj(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i11 = i9 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = i6;
 if ((HEAP32[i11 >> 2] | 0) - i6 >> 5 >>> 0 >= i4 >>> 0) {
  STACKTOP = i13;
  return;
 }
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 << 5) | 0;
 i2 = i5 + (i2 - i6 >> 5 << 5) | 0;
 i8 = i2;
 i5 = i5 + (i4 << 5) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i8;
  i7 = i6;
 } else {
  i4 = i8;
  do {
   i3 = i3 + -32 | 0;
   __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_(i2 + -32 | 0, i3);
   i2 = i4 + -32 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i7 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i11 >> 2] = i5;
 i4 = i7;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i12 + 4 | 0;
  i6 = i12 + 4 | 0;
  do {
   i2 = i1;
   i1 = i1 + -32 | 0;
   i3 = i2 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i5 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i1 >> 2] | 0;
    i10 = HEAP32[i2 + -20 >> 2] | 0;
    HEAP32[i12 >> 2] = 66;
    HEAP32[i6 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i12);
   }
  } while ((i1 | 0) != (i4 | 0));
 }
 if (!i7) {
  STACKTOP = i13;
  return;
 }
 __ZdlPv(i7);
 STACKTOP = i13;
 return;
}

function __ZNK12PhysXRaycast17BroadPhaseCullingER13dynamic_arrayIN5physx12PxOverlapHitELj4EERS0_I4AABBLj4EERK10MinMaxAABBibi23QueryTriggerInteraction(i1, i7, i8, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f18 = Math_fround(f12 + f13);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f17 = Math_fround(f11 + f15);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f17 = Math_fround(f17 * Math_fround(.5));
 f16 = Math_fround(Math_fround(f10 + f14) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(f18 * Math_fround(.5));
 HEAPF32[i1 + 4 >> 2] = f17;
 HEAPF32[i1 + 8 >> 2] = f16;
 f11 = Math_fround(Math_fround(f15 - f11) * Math_fround(.5));
 f10 = Math_fround(Math_fround(f14 - f10) * Math_fround(.5));
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f13 - f12) * Math_fround(.5));
 HEAPF32[i1 + 16 >> 2] = f11;
 HEAPF32[i1 + 20 >> 2] = f10;
 i1 = __ZNK12PhysXRaycast9GetShapesERK4AABBiPN5physx12PxOverlapHitEjb23QueryTriggerInteraction(0, i1, i5, HEAP32[i7 >> 2] | 0, i3, i4, i6) | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = 0;
 do {
  __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE((HEAP32[i8 >> 2] | 0) + (i2 * 24 | 0) | 0, (HEAP32[i7 >> 2] | 0) + (i2 << 4) | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN9Transform40InstantiateTransformSubhierarchyInternalER18TransformHierarchyPPS_Pij(i9, i10, i11, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i9 + 24 >> 2] | 0;
 i13 = HEAP32[i9 + 68 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i14 = i9 + 12 | 0;
 do {
  i7 = HEAP32[i12 + (i1 << 2) >> 2] | 0;
  HEAP32[i7 + 32 >> 2] = i9;
  HEAP32[i7 + 36 >> 2] = i1;
  i2 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) i2 = 0; else i2 = HEAP32[i12 + (i2 << 2) >> 2] | 0;
  HEAP32[i7 + 100 >> 2] = i2;
  i2 = HEAP32[i10 + (i1 << 2) >> 2] | 0;
  i8 = HEAP32[i2 + 92 >> 2] | 0;
  i6 = i7 + 80 | 0;
  i3 = i7 + 92 | 0;
  HEAP32[i3 >> 2] = i8;
  i4 = i7 + 96 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i8;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i8 << 2, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 2, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i8;
   HEAP32[i6 >> 2] = i7;
   break;
  } while (0);
  if (i8 | 0) {
   i4 = HEAP32[i2 + 80 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i3 + (i2 << 2) >> 2] = HEAP32[i12 + (HEAP32[i11 + (HEAP32[(HEAP32[i4 + (i2 << 2) >> 2] | 0) + 36 >> 2] << 2) >> 2] << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i8 | 0));
  }
  i1 = HEAP32[i13 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 40 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 36 | 0, i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Sc10NPhaseCore25createShapeInstancePairLLERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i8, i2, i3, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i1 = i2;
 i4 = i3;
 i10 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i2) | 0;
 i10 = (HEAP8[i10 + 50 >> 0] | 0) == 0 ? 0 : (HEAP32[i10 + 56 >> 2] | 0) + 2 | 0;
 i3 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i3) | 0;
 if (i10 >>> 0 < ((HEAP8[i3 + 50 >> 0] | 0) == 0 ? 0 : (HEAP32[i3 + 56 >> 2] | 0) + 2 | 0) >>> 0) i5 = 3; else if (!(HEAP8[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i2) | 0) + 50 >> 0] | 0)) i5 = 3; else {
  i2 = i1;
  i1 = i4;
 }
 if ((i5 | 0) == 3) i2 = i4;
 i3 = i1;
 i4 = __ZN5physx2Sc10NPhaseCore13findActorPairEPNS0_8ShapeSimES3_(i8, i2, i3) | 0;
 i5 = i8 + 1028 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i8 + 736 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 i10 = i8 + 1016 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i8 + 1020 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 if (!i1) i1 = 0; else {
  HEAP16[i6 >> 1] = HEAP16[i7 >> 1] | 0;
  __ZN5physx2Sc19ShapeInstancePairLLC2ERNS0_8ShapeSimES3_RNS0_9ActorPairENS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i1, i2, i3, i4, i6);
 }
 __ZN5physx2Sc19ShapeInstancePairLL10initializeEv(i1);
 HEAP32[i1 + 52 >> 2] = -1;
 if (HEAP32[i1 + 44 >> 2] & 134217728 | 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 __ZN5physx2Sc19ShapeInstancePairLL11updateStateEb(i1, 1);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN5physx28integrateWheelRotationAnglesEffffPKfS1_S1_PKbRKNS_21PxVehicleDriveSimDataERKNS_23PxVehicleWheels4SimDataERNS_21PxVehicleDriveDynDataERNS_23PxVehicleWheels4DynDataE(f12, f2, f1, f8, i11, i7, i9, i10, i4, i14, i3, i13) {
 f12 = Math_fround(f12);
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 f8 = Math_fround(f8);
 i11 = i11 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var f5 = f0, f6 = f0, f15 = f0, i16 = 0, i17 = 0;
 f6 = Math_fround(f2 * f1);
 i3 = 0;
 do {
  f1 = Math_fround(HEAPF32[i13 + (i3 << 2) >> 2]);
  f5 = Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]);
  if (f5 > Math_fround(-Math_fround(HEAPF32[i14 + (i3 * 48 | 0) + 12 >> 2]))) if (!(HEAP8[i10 + i3 >> 0] | 0)) if (Math_fround(Math_fround(f6 * Math_fround(HEAPF32[i7 + (i3 << 2) >> 2])) * f8) == Math_fround(0.0)) {
   f2 = Math_fround(HEAPF32[i9 + (i3 << 2) >> 2]);
   f5 = Math_fround(Math_abs(Math_fround(f2)));
   if (f5 < Math_fround(HEAPF32[gb + 1458420 >> 2])) {
    f15 = Math_fround(HEAPF32[i14 + 192 + (i3 * 48 | 0) + 36 >> 2]);
    f5 = Math_fround(f5 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
    f1 = Math_fround(Math_fround(f1 * f5) + Math_fround(Math_fround(f2 * f15) * Math_fround(Math_fround(1.0) - f5)));
   }
  }
  i4 = i13 + 32 + (i3 << 2) | 0;
  f15 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(f1 * f12));
  f2 = Math_fround(f15 + Math_fround(-31.4159279));
  f5 = Math_fround(f15 + Math_fround(31.4159279));
  i16 = Math_fround(Math_fround(-31.4159279) - f15) >= Math_fround(0.0);
  i17 = f2 >= Math_fround(0.0);
  HEAPF32[i4 >> 2] = i17 ? f2 : i16 ? f5 : f15;
  HEAPF32[i13 + 16 + (i3 << 2) >> 2] = f1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 4);
 return;
}

function __ZN11NavMeshDataD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i6 >> 2] = gb + 169404 + 8;
 i1 = HEAP32[i6 + 104 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 108 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -32 - i2 | 0) >>> 5) << 5);
  i5 = HEAP32[i6 + 116 >> 2] | 0;
  HEAP32[i7 >> 2] = 73;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i6 + 88 | 0);
 i1 = i6 + 68 | 0;
 if ((HEAP32[i6 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i4 = i6 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = gb + 32336 + 8;
  i7 = i6 + 28 | 0;
  __ZN14ConstantStringD2Ev(i7);
  HEAP32[i6 >> 2] = gb + 26392 + 8;
  STACKTOP = i8;
  return;
 }
 i5 = i6 + 56 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -20 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i3 >> 2] = 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i5 = HEAP32[i6 + 64 >> 2] | 0;
 HEAP32[i7 >> 2] = 73;
 HEAP32[i7 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 HEAP32[i6 >> 2] = gb + 32336 + 8;
 i7 = i6 + 28 | 0;
 __ZN14ConstantStringD2Ev(i7);
 HEAP32[i6 >> 2] = gb + 26392 + 8;
 STACKTOP = i8;
 return;
}

function __ZN11DynamicMesh21RemoveDegenerateEdgesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i8 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) return;
 i10 = i8 + 52 | 0;
 i11 = i8 + 40 | 0;
 i2 = 0;
 do {
  i7 = HEAP32[i8 >> 2] | 0;
  i6 = i7 + (i2 * 26 | 0) + 24 | 0;
  i3 = HEAP8[i6 >> 0] | 0;
  if (!(i3 << 24 >> 24)) i12 = 12; else {
   i5 = 0;
   i4 = i3 & 255;
   do {
    i13 = i5 + 1 | 0;
    i4 = (i13 | 0) < (i4 | 0) ? i13 : 0;
    if ((HEAP16[i7 + (i2 * 26 | 0) + 12 + (i5 << 1) >> 1] | 0) == (HEAP16[i7 + (i2 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0)) {
     if ((i4 | 0) < ((i3 & 255) + -1 | 0)) do {
      i3 = i4;
      i4 = i4 + 1 | 0;
      HEAP16[i7 + (i2 * 26 | 0) + 12 + (i3 << 1) >> 1] = HEAP16[i7 + (i2 * 26 | 0) + 12 + (i4 << 1) >> 1] | 0;
      i3 = HEAP8[i6 >> 0] | 0;
     } while ((i4 | 0) < ((i3 & 255) + -1 | 0));
     i3 = i3 + -1 << 24 >> 24;
     HEAP8[i6 >> 0] = i3;
     i4 = i5 + -1 | 0;
    } else i4 = i5;
    i5 = i4 + 1 | 0;
    i4 = i3 & 255;
   } while ((i5 | 0) < (i4 | 0));
   if ((i3 & 255) < 3) i12 = 12;
  }
  if ((i12 | 0) == 12) {
   i12 = 0;
   i5 = i7 + (i2 * 26 | 0) | 0;
   i3 = i7 + (((HEAP32[i9 >> 2] | 0) + -1 | 0) * 26 | 0) | 0;
   i4 = i5 + 26 | 0;
   do {
    HEAP16[i5 >> 1] = HEAP16[i3 >> 1] | 0;
    i5 = i5 + 2 | 0;
    i3 = i3 + 2 | 0;
   } while ((i5 | 0) < (i4 | 0));
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   i13 = HEAP32[i11 >> 2] | 0;
   HEAP32[i13 + (i2 << 2) >> 2] = HEAP32[i13 + ((HEAP32[i10 >> 2] | 0) + -1 << 2) >> 2];
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   i1 = i1 + -1 | 0;
   i2 = i2 + -1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 return;
}

function __Z27Light_Get_Custom_PropCookieP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 92 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z21SupportsMotionVectorsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, 5) | 0;
 if (!(HEAP32[i4 + 4 >> 2] | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 10;
  }
 }
 if ((i5 | 0) == 8) i5 = 10;
 if ((i5 | 0) == 10) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 if (!(__ZNK6Shader11IsSupportedEv(i1) | 0)) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 246 >> 0] | 0) != 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNSt3__26vectorI20ProcessFrameJobGroupNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i5 = i7 << 1;
 i5 = i7 >>> 0 < 89478485 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 178956970;
 i1 = (i2 - i1 | 0) / 24 | 0;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 * 24 | 0) | 0;
 i2 = i4 + (i1 * 24 | 0) | 0;
 i3 = i2;
 i7 = i4 + (i5 * 24 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_(i4 + (i1 * 24 | 0) + 4 | 0, i6 + 4 | 0);
 i6 = i2 + 24 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  i2 = i3;
  i4 = i5;
  i1 = i5;
 } else {
  do {
   i4 = i1;
   i1 = i1 + -24 | 0;
   HEAP32[i2 + -24 >> 2] = HEAP32[i1 >> 2];
   __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_(i2 + -20 | 0, i4 + -20 | 0);
   i2 = i3 + -24 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i5 | 0));
  i2 = i3;
  i4 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i3 = i4;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -24 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i4) return;
 __ZdlPv(i4);
 return;
}

function __ZN12CachedReader8InitReadER15CacheReaderBasejj(i9, i1, i10, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i8 = i9 + 12 | 0;
 HEAP32[i8 >> 2] = i1;
 i12 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i6 = i9 + 20 | 0;
 HEAP32[i6 >> 2] = i12;
 i12 = (i10 >>> 0) / (i12 >>> 0) | 0;
 i5 = i9 + 16 | 0;
 HEAP32[i5 >> 2] = i12;
 i1 = i9 + 28 | 0;
 HEAP32[i1 >> 2] = i2 + i10;
 HEAP32[i9 + 24 >> 2] = i10;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i12 | 0, i7 | 0, i3 | 0);
 i2 = (HEAP32[i1 >> 2] | 0) - (Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0) | 0;
 i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[(i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 ? i4 : i3) >> 2];
 __ZN12CachedReader16OutOfBoundsErrorEjj(i9, i10, 0);
 if (HEAP8[i9 + 32 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = (i10 >>> 0) / (i1 >>> 0) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i4 | 0)) {
  i2 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i4 | 0);
  i2 = (i10 >>> 0) / ((HEAP32[i6 >> 2] | 0) >>> 0) | 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i7 | 0, i3 | 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i12 = i10 - (Math_imul(i2, i1) | 0) | 0;
 HEAP32[i9 >> 2] = (HEAP32[i7 >> 2] | 0) + i12;
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine15PlatformWrapper19GetScreenResolutionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = i6 + 32 | 0;
 i3 = i6 + 20 | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i7 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i7 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 i7 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i7 | 0);
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z6FormatPKcz(i2, gb + 1040581 | 0, i4);
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i3 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i5 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 i5 = i1 + 11 | 0;
 if (i4 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, 10, i4 + -10 | 0, 0, 0, 0, i4, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i6;
  return;
 }
 if (i4 | 0) _memmove(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) {
  HEAP32[i1 + 4 >> 2] = i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i6;
  return;
 } else {
  HEAP8[i5 >> 0] = i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i6;
  return;
 }
}

function __Z49ReflectionProbe_Get_Custom_PropCustomBakedTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 128 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z41ParticleSystem_ShapeModule_CUSTOM_GetMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i5 = HEAP32[i2 + 48 + 44 >> 2] | 0;
 if (!i5) i1 = 0; else {
  HEAP32[i4 >> 2] = i5;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
    i2 = HEAP32[i3 >> 2] | 0;
    i4 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i6 = 13;
   }
  }
  if ((i6 | 0) == 11) i6 = 13;
  if ((i6 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 }
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z38Collider_Get_Custom_PropSharedMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN8Collider11GetMaterialEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i7 = i8;
 i5 = i2;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = gb + 28204 + 8;
 i2 = i9 + 8 | 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = i4 & 2047 | -2097152;
 i3 = __Z16GetMemoryManagerv() | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i1 = i10 & 2047;
 if (!(i10 & 2048)) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = 0;
  i1 = i9;
 } else {
  __Z14CreateMemLabel18MemLabelIdentifierPv(i6, i1, i9);
  i1 = i9;
 }
 i10 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i3, i6) | 0;
 i10 = (mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 80 >> 2] | 0, i10 | 0, i1 | 0) | 0) != 0 & 1;
 HEAP32[i2 >> 2] = i10 << 11 | HEAP32[i2 >> 2] & -2049;
 HEAP32[i9 + 24 >> 2] = -1;
 HEAP32[i9 >> 2] = gb + 28800 + 8;
 i10 = i7;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i10 + 4 >> 2] = i5;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP32[i9 + 40 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i9 + 32 | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i9 + 64 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i10);
 HEAP32[i9 + 68 >> 2] = 0;
 HEAP32[i9 + 72 >> 2] = 0;
 HEAP32[i9 + 76 >> 2] = i9;
 HEAP32[i9 + 60 >> 2] = 0;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP16[i9 + 52 >> 1] = 0;
 HEAP8[i9 + 54 >> 0] = 0;
 HEAP8[i9 + 55 >> 0] = -1;
 STACKTOP = i8;
 return;
}

function __ZL39UnityAudioEffect_InternalCreateCallbackP14FMOD_DSP_STATE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i5 >> 2] | 0, i4) | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 36;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 112 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i9 = i1 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 + 8 >> 2] & 3 | HEAP32[i9 >> 2] & -4;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i3 + 16 >> 2];
 if (0 == 0 ? (HEAP32[i2 + 120 >> 2] & 2 | 0) == 0 : 0) i3 = i1; else {
  i9 = __ZnwjRK10MemLabelIdiPKci(148, gb + 63328 | 0, 16, gb + 860370 | 0, 44) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i1 + 40 | 0;
  HEAP32[i3 >> 2] = i9;
  _memset(i9 | 0, 0, 148) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  HEAPF32[i3 + 124 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 104 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 84 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 64 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 60 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 40 >> 2] = Math_fround(1.0);
  HEAPF32[i3 + 20 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  i3 = i1;
 }
 i2 = HEAP32[i2 + 160 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i2 = (mftCall_ii(i2 | 0, i3 | 0) | 0) == 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = i2 ? 0 : 80;
 }
 HEAP32[i5 + 4 >> 2] = i1;
 i9 = i2;
 STACKTOP = i6;
 return i9 | 0;
}

function __Z48Renderer_Get_Custom_PropStaticBatchRootTransformP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 308 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z48AudioSource_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 440 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __GLOBAL__sub_I_Player_cpp() {
 var i1 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450816 | 0, gb + 583132 | 0, 8, 0);
 i1 = gb + 1098176 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1450828 >> 2] = 0;
 HEAP32[gb + 1450828 + 4 >> 2] = 0;
 HEAP32[gb + 1450828 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450840 | 0, gb + 583153 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450852 | 0, gb + 583168 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450864 | 0, gb + 583192 | 0, 1, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450876 | 0, gb + 583209 | 0, 13, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450888 | 0, gb + 583226 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450900 | 0, gb + 583250 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450912 | 0, gb + 583275 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450924 | 0, gb + 583302 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450936 | 0, gb + 583321 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450948 | 0, gb + 583338 | 0, 1, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450960 | 0, gb + 583361 | 0, 0, 0);
 return;
}

function _prepare_for_output_pass(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i4 + 384 >> 2] | 0;
 i3 = i2 + 8 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = i4 + 74 | 0;
  do if (HEAP8[i1 >> 0] | 0) if (!(HEAP32[i4 + 116 >> 2] | 0)) {
   if (HEAP8[i4 + 80 >> 0] | 0) if (HEAP8[i4 + 90 >> 0] | 0) {
    HEAP32[i4 + 424 >> 2] = HEAP32[i2 + 24 >> 2];
    HEAP8[i3 >> 0] = 1;
    break;
   }
   if (!(HEAP8[i4 + 88 >> 0] | 0)) {
    i5 = HEAP32[i4 >> 2] | 0;
    HEAP32[i5 + 20 >> 2] = 46;
    mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
    break;
   } else {
    HEAP32[i4 + 424 >> 2] = HEAP32[i2 + 20 >> 2];
    break;
   }
  } while (0);
  mftCall_vi(HEAP32[HEAP32[i4 + 412 >> 2] >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[(HEAP32[i4 + 392 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
  if (!(HEAP8[i4 + 65 >> 0] | 0)) {
   if (!(HEAP8[i2 + 16 >> 0] | 0)) mftCall_vi(HEAP32[HEAP32[i4 + 420 >> 2] >> 2] | 0, i4 | 0);
   mftCall_vi(HEAP32[HEAP32[i4 + 416 >> 2] >> 2] | 0, i4 | 0);
   if (HEAP8[i1 >> 0] | 0) mftCall_vii(HEAP32[HEAP32[i4 + 424 >> 2] >> 2] | 0, i4 | 0, HEAP8[i3 >> 0] | 0);
   mftCall_vii(HEAP32[HEAP32[i4 + 396 >> 2] >> 2] | 0, i4 | 0, (HEAP8[i3 >> 0] | 0 ? 3 : 0) | 0);
   mftCall_vii(HEAP32[HEAP32[i4 + 388 >> 2] >> 2] | 0, i4 | 0, 0);
  }
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 i2 = (HEAP8[i3 >> 0] | 0 ? 2 : 1) + i2 | 0;
 i1 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = i2;
 if (!(HEAP8[i4 + 64 >> 0] | 0)) return;
 if (HEAP8[(HEAP32[i4 + 400 >> 2] | 0) + 17 >> 0] | 0) return;
 HEAP32[i1 >> 2] = i2 + (HEAP8[i4 + 90 >> 0] | 0 ? 2 : 1);
 return;
}

function __ZNK17AnimationCurveTplIfE8WrapTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i5 = HEAP32[i1 + 56 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + ((HEAP32[i1 + 68 >> 2] | 0) + -1 << 4) >> 2]);
 if (f3 > f2) switch (HEAP32[i1 + 76 >> 2] | 0) {
 case 0:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f4 = Math_fround(f6 * Math_fround(2.0));
   f4 = Math_fround(Math_fround(f2 - Math_fround(f4 * Math_fround(Math_floor(Math_fround(f2 / f4))))) - f6);
   i5 = f4 < Math_fround(0.0);
   f2 = Math_fround(-f4);
   f4 = Math_fround(f3 + Math_fround(f6 - (i5 ? f2 : f4)));
   return Math_fround(f4);
  }
 case 2:
  {
   f6 = f3;
   return Math_fround(f6);
  }
 default:
  {
   f2 = Math_fround(f2 - f3);
   f6 = Math_fround(f4 - f3);
   f6 = Math_fround(f3 + Math_fround(f2 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f2 / f6))))));
   return Math_fround(f6);
  }
 }
 if (!(f4 < f2)) {
  f6 = f2;
  return Math_fround(f6);
 }
 switch (HEAP32[i1 + 80 >> 2] | 0) {
 case 0:
  {
   f7 = Math_fround(f2 - f3);
   f2 = Math_fround(f4 - f3);
   f6 = Math_fround(f2 * Math_fround(2.0));
   f6 = Math_fround(Math_fround(f7 - Math_fround(f6 * Math_fround(Math_floor(Math_fround(f7 / f6))))) - f2);
   i5 = f6 < Math_fround(0.0);
   f4 = Math_fround(-f6);
   f6 = Math_fround(f3 + Math_fround(f2 - (i5 ? f4 : f6)));
   return Math_fround(f6);
  }
 case 2:
  {
   f7 = f4;
   return Math_fround(f7);
  }
 default:
  {
   f6 = Math_fround(f2 - f3);
   f7 = Math_fround(f4 - f3);
   f7 = Math_fround(f3 + Math_fround(f6 - Math_fround(f7 * Math_fround(Math_floor(Math_fround(f6 / f7))))));
   return Math_fround(f7);
  }
 }
 return f0;
}

function __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(i2, i3, i4, i10, i5, i1, i7, i11) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 switch (HEAP32[i2 + 744 >> 2] | 0) {
 case 0:
  {
   i11 = __ZNK9ShaderLab11ShaderState16ApplyShaderStateEjPK19ShaderPropertySheetRK17ShaderPassContextP6ShaderPNS_4PassEP11SubPrograms(i2 + 4 | 0, i3, i4, i10, i5, i2, i11) | 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 case 2:
  {
   i6 = 3;
   break;
  }
 default:
  {}
 }
 do if ((i6 | 0) == 3) {
  i1 = i2 + 768 | 0;
  if (i7 | 0) {
   __ZN9ShaderLab10GrabPasses13ApplyGrabPassERKNS_16FastPropertyNameER17ShaderPassContextRKS0_(i1, i10, i7);
   break;
  }
  i2 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
  if (i2 | 0) {
   i7 = HEAP32[i1 >> 2] | 0;
   i3 = (i7 | 0) != -1 ? i1 : gb + 1166408 | 0;
   HEAP8[i8 >> 0] = 0;
   i1 = __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb(i2, i3, (i7 | 0) == -1, 1, i8) | 0;
   if (i1 | 0) __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i1, i3, i10);
  }
 } while (0);
 if (!i11) {
  i11 = 0;
  STACKTOP = i9;
  return i11 | 0;
 };
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i11 + 8 >> 2] = 0;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 i11 = 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj(i9, i7, i5, i6, i10) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i1 = i11 + 24 | 0;
 HEAP16[i1 >> 1] = i7;
 i2 = i9 + 280 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i9 + 212 | 0, i1, i8) | 0;
  if (!(HEAP8[i8 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i7;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_viiiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, i5 | 0, i6 | 0, i10 | 0);
 }
 if (!(HEAP8[i9 + 276 >> 0] | 0)) {
  STACKTOP = i11;
  return;
 }
 i2 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i3 = getTempRet0() | 0;
 i4 = HEAP32[i9 + 72 >> 2] | 0;
 if (!i4) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i8;
 HEAP32[i12 >> 2] = i5;
 HEAP32[i12 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i10;
 HEAP8[i8 + 12 >> 0] = 0;
 HEAP8[i8 + 13 >> 0] = 0;
 i10 = i8 + 16 | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i3;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_(i9, i7, i8);
 if (!i1) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN5Unity12PhysicsQuery15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction(i4, i5, i6, i7, f8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i1 = i11;
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((HEAP16[gb + 1452776 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452776 | 0, i2);
  i3 = gb + 1452776 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 68 >> 0] = 0;
 HEAP32[i2 + 72 >> 2] = i1;
 HEAP32[i2 + 76 >> 2] = 128;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151328 + 8;
 HEAP32[i2 + 84 >> 2] = i6;
 HEAP32[i2 + 88 >> 2] = i7;
 i1 = i2 + 92 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(0, i5, f8, i9, i10, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, gb + 469407 | 0, i1, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469646 | 0, gb + 469407 | 0, i5, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469614 | 0, i5, i1 + 8 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1039692 | 0, gb + 469660 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 469681 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744923 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16DeveloperConsole16AppendNewEntriesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = i1 + 24 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = i1 + 4 | 0;
 i4 = i1 + 20 | 0;
 i6 = i1 + 12 | 0;
 i7 = i1 + 8 | 0;
 do {
  i8 = HEAP32[i4 >> 2] | 0;
  i5 = __Znwj(40) | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i10 = i5 + 20 | 0;
  i12 = gb + 63672 | 0;
  i13 = HEAP32[i12 >> 2] | 0;
  i12 = HEAP32[i12 + 4 >> 2] | 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  i9 = i5 + 28 | 0;
  HEAP8[i9 >> 0] = 0;
  i11 = i5 + 32 | 0;
  HEAP32[i11 >> 2] = i13;
  HEAP32[i11 + 4 >> 2] = i12;
  __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i10, HEAP32[i8 + 20 >> 2] | 0, HEAP32[i8 + 24 >> 2] | 0);
  i8 = i8 + 28 | 0;
  HEAP8[i9 >> 0] = HEAP8[i8 >> 0] | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP32[i5 + 4 >> 2] = i3;
  i8 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i8;
  HEAP32[i8 + 4 >> 2] = i5;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  i5 = HEAP32[i4 >> 2] | 0;
  i8 = i5 + 4 | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  HEAP32[i9 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i9;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  __ZN11UTF16StringD2Ev(i5 + 20 | 0);
  __ZdlPv(i5);
  i5 = HEAP32[i6 >> 2] | 0;
  if (i5 >>> 0 > 10) {
   i13 = HEAP32[i7 >> 2] | 0;
   i12 = i13 + 4 | 0;
   i11 = HEAP32[i13 >> 2] | 0;
   HEAP32[i11 + 4 >> 2] = HEAP32[i12 >> 2];
   HEAP32[HEAP32[i12 >> 2] >> 2] = i11;
   HEAP32[i6 >> 2] = i5 + -1;
   __ZN11UTF16StringD2Ev(i13 + 20 | 0);
   __ZdlPv(i13);
  }
  HEAP8[i1 >> 0] = 0;
 } while ((HEAP32[i2 >> 2] | 0) != 0);
 return;
}

function __ZN13GfxDeviceGLES22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace(i5, i1, i7, i8, i9, i10, i11, i12, i13, i14) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i15 + 4 | 0;
 i3 = i15;
 i6 = i5 + 4620 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 i2 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i6, 6, i2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i3 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i3 = i2 + 8 | 0;
 i17 = HEAP32[i3 + 4 >> 2] | 0;
 i16 = i5 + 7320 | 0;
 i18 = HEAP32[i16 + 4 >> 2] | 0;
 if (i18 >>> 0 < i17 >>> 0 | ((i18 | 0) == (i17 | 0) ? (HEAP32[i16 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0)) {
  i17 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i5 + 5480 >> 2] | 0, 7) | 0;
  i18 = i5 + 7376 | 0;
  HEAP32[i18 >> 2] = HEAP32[i18 >> 2] | i17;
 }
 i18 = __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i6, i2, i11, i7, i8, i9, i9, i10 * 6 | 0, i12, i13, i14, 0) | 0;
 __Z34register_external_gfx_deallocationPvPKci(i4, gb + 603515 | 0, 1061);
 __Z32register_external_gfx_allocationPvjjPKci(i4, i18, i1, gb + 603515 | 0, 1062);
 STACKTOP = i15;
 return;
}

function __ZN10Matrix3x3f15InvertTransposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i2;
 HEAP32[i19 >> 2] = HEAP32[i1 >> 2];
 i10 = i1 + 4 | 0;
 i13 = i19 + 4 | 0;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 i6 = i1 + 8 | 0;
 i9 = i19 + 8 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAPF32[i19 + 12 >> 2] = Math_fround(0.0);
 i12 = i1 + 12 | 0;
 i11 = i19 + 16 | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 i17 = i1 + 16 | 0;
 i18 = i19 + 20 | 0;
 HEAP32[i18 >> 2] = HEAP32[i17 >> 2];
 i4 = i1 + 20 | 0;
 i16 = i19 + 24 | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i19 + 28 >> 2] = Math_fround(0.0);
 i8 = i1 + 24 | 0;
 i7 = i19 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i3 = i1 + 28 | 0;
 i5 = i19 + 36 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i14 = i1 + 32 | 0;
 i15 = i19 + 40 | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 i20 = i19 + 44 | 0;
 HEAP32[i20 >> 2] = 0;
 HEAP32[i20 + 4 >> 2] = 0;
 HEAP32[i20 + 8 >> 2] = 0;
 HEAP32[i20 + 12 >> 2] = 0;
 HEAPF32[i19 + 60 >> 2] = Math_fround(1.0);
 __Z20InvertMatrix4x4_FullPKfPf(i19, i19) | 0;
 HEAP32[i1 >> 2] = HEAP32[i19 >> 2];
 i13 = HEAP32[i13 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 HEAP32[i17 >> 2] = HEAP32[i18 >> 2];
 i1 = HEAP32[i16 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 >> 2] = i13;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i2;
 return;
}

function __Z15SkinMeshMathLibR12SkinMeshInfo(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1161580 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161580 | 0, i1);
  i1 = gb + 1161580 | 0;
 } else i1 = 0;
 i3 = HEAP16[i4 + 56 >> 1] | 0;
 L4 : do if (!((i3 & 255) << 24 >> 24)) switch (HEAP32[i4 + 20 >> 2] | 0) {
 case 1:
  {
   __Z18SkinGenericMathLibILi1ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 case 2:
  {
   __Z18SkinGenericMathLibILi2ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 case 4:
  {
   __Z18SkinGenericMathLibILi4ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 default:
  break L4;
 } else {
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i3 & 65535) < 256) switch (i2 | 0) {
  case 1:
   {
    __Z18SkinGenericMathLibILi1ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 2:
   {
    __Z18SkinGenericMathLibILi2ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 4:
   {
    __Z18SkinGenericMathLibILi4ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  default:
   break L4;
  } else switch (i2 | 0) {
  case 1:
   {
    __Z18SkinGenericMathLibILi1ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 2:
   {
    __Z18SkinGenericMathLibILi2ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 4:
   {
    __Z18SkinGenericMathLibILi4ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  default:
   break L4;
  }
 } while (0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function _tt_get_metrics(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 6 | 0;
 i9 = i12 + 4 | 0;
 i8 = i12 + 2 | 0;
 i10 = i12;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = HEAP32[i11 + 24 >> 2] | 0;
 HEAP16[i7 >> 1] = 0;
 HEAP16[i9 >> 1] = 0;
 HEAP16[i8 >> 1] = 0;
 HEAP16[i10 >> 1] = 0;
 i6 = _UNITY_FT_Stream_Pos(i5) | 0;
 i2 = i4 + 532 | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, 0, i1 | 0, i7 | 0, i8 | 0);
 i3 = HEAP32[i11 + 48 >> 2] | 0;
 do if (!(HEAP8[i4 + 292 >> 0] | 0)) if ((HEAP16[i4 + 364 >> 1] | 0) == -1) {
  i4 = i4 + 220 | 0;
  HEAP16[i9 >> 1] = (HEAPU16[i4 >> 1] | 0) - i3;
  i4 = HEAP32[i4 >> 2] | 0;
  i4 = (i4 << 16 >> 16) - (i4 >> 16) | 0;
  HEAP16[i10 >> 1] = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
  break;
 } else {
  i2 = HEAP16[i4 + 434 >> 1] | 0;
  HEAP16[i9 >> 1] = (i2 & 65535) - i3;
  i4 = (i2 << 16 >> 16) - (HEAP16[i4 + 436 >> 1] | 0) | 0;
  HEAP16[i10 >> 1] = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
  break;
 } else mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i4 | 0, 1, i1 | 0, i9 | 0, i10 | 0); while (0);
 i1 = _UNITY_FT_Stream_Seek(i5, i6) | 0;
 if (i1 | 0) {
  i11 = i1;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i11 + 52 >> 2] = HEAP16[i7 >> 1];
 i2 = HEAPU16[i8 >> 1] | 0;
 HEAP32[i11 + 56 >> 2] = i2;
 HEAP32[i11 + 176 >> 2] = HEAP16[i9 >> 1];
 HEAP32[i11 + 180 >> 2] = HEAPU16[i10 >> 1];
 i1 = i11 + 64 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 HEAP32[i11 + 60 >> 2] = i2;
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx2Gu11HeightField27getTriangleAdjacencyIndicesEjjjjRjS2_S2_(i5, i7, i1, i2, i3, i6, i4, i8) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i3 = i7 >>> 1;
 i2 = (HEAP8[(HEAP32[i5 + 36 >> 2] | 0) + (i3 << 2) + 2 >> 0] | 0) < 0;
 i1 = (i7 & 1 | 0) == 0;
 HEAP32[i6 >> 2] = -1;
 if (i2) if (i1) {
  HEAP32[i4 >> 2] = i7 + 1;
  HEAP32[i8 >> 2] = -1;
  i2 = i5 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i3 >>> 0) % (i1 >>> 0) | 0) {
   HEAP32[i6 >> 2] = i7 + -1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (((i3 >>> 0) / (i1 >>> 0) | 0 | 0) == ((HEAP32[i5 + 16 >> 2] | 0) + -2 | 0)) return;
  HEAP32[i8 >> 2] = i1 + i3 << 1 | 1;
  return;
 } else {
  HEAP32[i4 >> 2] = i7 + -1;
  HEAP32[i8 >> 2] = -1;
  i2 = i5 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (((i3 >>> 0) % (i1 >>> 0) | 0) >>> 0 < (i1 + -2 | 0) >>> 0) {
   HEAP32[i6 >> 2] = i7 + 1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (i3 >>> 0 < (i1 + -1 | 0) >>> 0) return;
  HEAP32[i8 >> 2] = i3 - i1 << 1;
  return;
 } else if (i1) {
  HEAP32[i4 >> 2] = i7 + 1;
  HEAP32[i8 >> 2] = -1;
  i2 = i5 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 >= (i1 + -1 | 0) >>> 0) {
   HEAP32[i6 >> 2] = i3 - i1 << 1 | 1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (!((i3 >>> 0) % (i1 >>> 0) | 0)) return;
  HEAP32[i8 >> 2] = i7 + -1;
  return;
 } else {
  HEAP32[i4 >> 2] = i7 + -1;
  HEAP32[i8 >> 2] = -1;
  i2 = i5 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (((i3 >>> 0) / (i1 >>> 0) | 0 | 0) != ((HEAP32[i5 + 16 >> 2] | 0) + -2 | 0)) {
   HEAP32[i6 >> 2] = i1 + i3 << 1;
   i1 = HEAP32[i2 >> 2] | 0;
  }
  if (((i3 >>> 0) % (i1 >>> 0) | 0) >>> 0 >= (i1 + -2 | 0) >>> 0) return;
  HEAP32[i8 >> 2] = i7 + 1;
  return;
 }
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEclERS6_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 44 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 3;
  i2 = i9 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 678299 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 40 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 3) | 0;
 i7 = i9 + 36 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   i3 = i3 + 8 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 8 | 0;
  }
 }
 i5 = i1 + (i2 << 3) | 0;
 HEAP8[i5 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 32 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 3) | 0;
}

function __ZN13RenderManager29InvokeOnRenderObjectCallbacksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i2 = i1 + 68 | 0;
 i3 = i1 + 72 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i5 + 4 | 0;
 i7 = i5 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 i8 = i5 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 >> 2] = i11;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i2;
 if ((i11 | 0) == (i2 | 0)) HEAP32[i5 >> 2] = i5;
 HEAP32[i3 >> 2] = i2;
 if ((i4 | 0) == (i2 | 0)) HEAP32[i6 >> 2] = i5;
 HEAP32[i1 + 72 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i5;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 L10 : do if ((i1 | 0) == (i5 | 0)) i9 = 12; else {
  i2 = i5;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   if (i2 | 0) {
    i11 = i1 + 4 | 0;
    HEAP32[i2 + 4 >> 2] = HEAP32[i11 >> 2];
    HEAP32[HEAP32[i11 >> 2] >> 2] = i2;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
   }
   i2 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    if (!i1) break L10;
   } else {
    i11 = i1 + 4 | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    HEAP32[i1 >> 2] = i4;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i4 + 4 >> 2] = i1;
    HEAP32[HEAP32[i11 >> 2] >> 2] = i1;
   }
   __ZN13MonoBehaviour20InvokeOnRenderObjectEv(HEAP32[i1 + 8 >> 2] | 0);
   i2 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) == (i5 | 0)) {
    i9 = 12;
    break L10;
   }
   i1 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  }
 } while (0);
 if ((i9 | 0) == 12) HEAP32[i8 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z47BillboardAsset_CUSTOM_GetImageTexCoordsInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 460 >> 2] | 0;
 i2 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 + 40 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 16, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i2 = 0;
 while (1) {
  i11 = HEAP32[i1 >> 2] | 0;
  i10 = HEAP32[i1 + 4 >> 2] | 0;
  i9 = HEAP32[i1 + 8 >> 2] | 0;
  i8 = HEAP32[i1 + 12 >> 2] | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 16) | 0;
  HEAP32[i5 >> 2] = i11;
  HEAP32[i5 + 4 >> 2] = i10;
  HEAP32[i5 + 8 >> 2] = i9;
  HEAP32[i5 + 12 >> 2] = i8;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 16 | 0;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = i7 + 12 | 0;
 HEAP32[i11 >> 2] = i10;
 i11 = i7 + 16 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = i10;
 return;
}

function __Z47AudioMixer_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN7mecanim9animation21ValueFromSkeletonPoseERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapERNS_10ValueArrayE(i1, i2, i8, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 if (!i7) return;
 i4 = i2 + 4 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i5 = i3 + 20 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i6 = i3 + 12 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i3 = i3 + 4 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i2 = 0;
 do {
  i1 = HEAP32[i8 + (i2 * 12 | 0) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i10 = HEAP32[i4 + (i2 * 40 | 0) + 4 >> 2] | 0;
   i9 = HEAP32[i4 + (i2 * 40 | 0) + 8 >> 2] | 0;
   HEAP32[i3 + (i1 * 12 | 0) >> 2] = HEAP32[i4 + (i2 * 40 | 0) >> 2];
   HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = i10;
   HEAP32[i3 + (i1 * 12 | 0) + 8 >> 2] = i9;
  }
  i1 = HEAP32[i8 + (i2 * 12 | 0) + 4 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i11 = HEAP32[i4 + (i2 * 40 | 0) + 16 >> 2] | 0;
   i9 = HEAP32[i4 + (i2 * 40 | 0) + 20 >> 2] | 0;
   i10 = HEAP32[i4 + (i2 * 40 | 0) + 24 >> 2] | 0;
   HEAP32[i6 + (i1 << 4) >> 2] = HEAP32[i4 + (i2 * 40 | 0) + 12 >> 2];
   HEAP32[i6 + (i1 << 4) + 4 >> 2] = i11;
   HEAP32[i6 + (i1 << 4) + 8 >> 2] = i9;
   HEAP32[i6 + (i1 << 4) + 12 >> 2] = i10;
  }
  i1 = HEAP32[i8 + (i2 * 12 | 0) + 8 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i10 = HEAP32[i4 + (i2 * 40 | 0) + 32 >> 2] | 0;
   i11 = HEAP32[i4 + (i2 * 40 | 0) + 36 >> 2] | 0;
   HEAP32[i5 + (i1 * 12 | 0) >> 2] = HEAP32[i4 + (i2 * 40 | 0) + 28 >> 2];
   HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = i10;
   HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = i11;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i7 >>> 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 100; else i1 = (HEAP32[i1 >> 2] | 0) + 100 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_15PxMetaDataPlaneEE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __Z17InstantiateObjectR6ObjectR9TransformRK8Vector3fRK11Quaternionf(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 20 | 0;
 i6 = i11;
 if ((HEAP16[gb + 1155156 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155156 | 0, i7);
  i8 = gb + 1155156 | 0;
 } else i8 = 0;
 i5 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i12 = i6 + 4 | 0;
 HEAP32[i12 >> 2] = 0;
 i9 = i6 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i10 = i6 + 16 | 0;
 HEAP32[i10 >> 2] = i5;
 i5 = __Z17InstantiateObjectR6ObjectP9TransformRK8Vector3fRK11QuaternionfR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINSA_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i4, i2, i3, i6) | 0;
 __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i6);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1105076 | 0, i7);
 i1 = HEAP32[i12 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i12 = HEAP32[i10 >> 2] | 0;
  HEAP32[i7 >> 2] = 1;
  HEAP32[i7 + 4 >> 2] = i12;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 }
 if (!i8) {
  STACKTOP = i11;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i11;
 return i5 | 0;
}

function _hypot(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = i6 & 2147483647;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 i7 = i6 >>> 0 < i5 >>> 0 | (i6 | 0) == (i5 | 0) & i10 >>> 0 < i4 >>> 0;
 i9 = i7 ? i4 : i10;
 i8 = i7 ? i5 : i6;
 i4 = i7 ? i10 : i4;
 i5 = i7 ? i6 : i5;
 i6 = _bitshift64Lshr(i9 | 0, i8 | 0, 52) | 0;
 getTempRet0() | 0;
 i7 = _bitshift64Lshr(i4 | 0, i5 | 0, 52) | 0;
 getTempRet0() | 0;
 HEAP32[tempDoublePtr >> 2] = i9;
 HEAP32[tempDoublePtr + 4 >> 2] = i8;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 HEAP32[tempDoublePtr >> 2] = i4;
 HEAP32[tempDoublePtr + 4 >> 2] = i5;
 d2 = +HEAPF64[tempDoublePtr >> 3];
 do if ((i7 | 0) == 2047) d1 = d2; else if (!((i4 | 0) == 0 & (i5 | 0) == 0 | (i6 | 0) == 2047)) {
  if ((i6 - i7 | 0) > 64) {
   d1 = d1 + d2;
   break;
  }
  if (i6 >>> 0 > 1533) {
   d3 = 5260135901548373507240989.0e186;
   d1 = d1 * 1.90109156629516e-211;
   d2 = d2 * 1.90109156629516e-211;
  } else if (i7 >>> 0 < 573) {
   d3 = 1.90109156629516e-211;
   d1 = d1 * 5260135901548373507240989.0e186;
   d2 = d2 * 5260135901548373507240989.0e186;
  } else d3 = 1.0;
  d12 = d1 * 134217729.0;
  d12 = d12 + (d1 - d12);
  d11 = d1 - d12;
  d1 = d1 * d1;
  d14 = d2 * 134217729.0;
  d14 = d14 + (d2 - d14);
  d13 = d2 - d14;
  d2 = d2 * d2;
  d1 = d3 * +Math_sqrt(+(d1 + (d2 + (d13 * d13 + (d14 * d14 - d2 + d14 * 2.0 * d13) + (d11 * d11 + (d12 * d12 - d1 + d12 * 2.0 * d11))))));
 } while (0);
 return +d1;
}

function __ZN9Transform41SetPositionAndRotationWithoutNotificationERK8Vector3fRK11Quaternionf(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i5 = i9 + 32 | 0;
 i6 = i9 + 16 | 0;
 i7 = i9;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i14 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[i3 + 8 >> 2] | 0;
 i12 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i4 + 4 >> 2] | 0;
 i10 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i14;
 HEAP32[i5 + 8 >> 2] = i13;
 HEAP32[i6 >> 2] = i12;
 HEAP32[i6 + 4 >> 2] = i11;
 HEAP32[i6 + 8 >> 2] = i10;
 HEAP32[i6 + 12 >> 2] = i4;
 if (i1 >>> 0 < 1 | (i1 | 0) == 1 & i2 >>> 0 < 0) {
  i14 = i7;
  i13 = i14;
  HEAP32[i13 >> 2] = i2;
  i14 = i14 + 4 | 0;
  HEAP32[i14 >> 2] = i1;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i8, i5, i6) | 0;
  STACKTOP = i9;
  return;
 }
 i13 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i14 = i8;
 HEAP32[i14 >> 2] = i2;
 HEAP32[i14 + 4 >> 2] = i13;
 __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E(i8, i5, i6);
 i14 = i7;
 i13 = i14;
 HEAP32[i13 >> 2] = i2;
 i14 = i14 + 4 | 0;
 HEAP32[i14 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i8, i5, i6) | 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 100; else i1 = (HEAP32[i1 >> 2] | 0) + 100 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_15PxMetaDataPlaneEE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc16InteractionSceneC2ERNS0_5SceneE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 380 >> 2] = 0;
 HEAP8[i2 + 372 >> 0] = 1;
 HEAP32[i2 + 376 >> 2] = i2 + 116;
 HEAP32[i2 + 384 >> 2] = 64;
 HEAP32[i2 + 388 >> 2] = 32;
 HEAP32[i2 + 392 >> 2] = 0;
 HEAP32[i2 + 396 >> 2] = 0;
 HEAP32[i2 + 400 >> 2] = 1024;
 HEAP32[i2 + 404 >> 2] = 0;
 HEAP32[i2 + 676 >> 2] = 0;
 HEAP8[i2 + 668 >> 0] = 1;
 HEAP32[i2 + 672 >> 2] = i2 + 412;
 HEAP32[i2 + 680 >> 2] = 64;
 HEAP32[i2 + 684 >> 2] = 32;
 HEAP32[i2 + 688 >> 2] = 0;
 HEAP32[i2 + 692 >> 2] = 0;
 HEAP32[i2 + 696 >> 2] = 2048;
 HEAP32[i2 + 700 >> 2] = 0;
 HEAP32[i2 + 972 >> 2] = 0;
 HEAP8[i2 + 964 >> 0] = 1;
 HEAP32[i2 + 968 >> 2] = i2 + 708;
 HEAP32[i2 + 976 >> 2] = 64;
 HEAP32[i2 + 980 >> 2] = 32;
 HEAP32[i2 + 984 >> 2] = 0;
 HEAP32[i2 + 988 >> 2] = 0;
 HEAP32[i2 + 992 >> 2] = 4096;
 HEAP32[i2 + 996 >> 2] = 0;
 HEAP32[i2 + 1e3 >> 2] = 0;
 HEAP32[i2 + 1004 >> 2] = 0;
 HEAP32[i2 + 1008 >> 2] = i1;
 i2 = i2 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZN5Unity11SpringJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint22JointTransferPreNoAxisI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 104 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __ZN20SpeedTreeWindManager32FillGlobalWindOnlyPropertiesFromER19ShaderPropertySheetRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN19ShaderPropertySheet5ClearEb(i1, 1);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i1, 4);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i1, gb + 1170752 | 0, Math_fround(0.0), 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170688 | 0, i4, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170692 | 0, i4, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, gb + 1170712 | 0, i4, 0);
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i4 = HEAP32[i2 + 72 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 i2 = i1 + 36 | 0;
 i4 = i4 + 100 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManager15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction(i4, i5, i6, i7, f8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11 + 8 | 0;
 i1 = i11;
 if (!i7) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((HEAP16[gb + 1452776 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452776 | 0, i2);
  i3 = gb + 1452776 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 748 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP16[i2 + 16 >> 1] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i2 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 68 >> 0] = 0;
 HEAP32[i2 + 72 >> 2] = i1;
 HEAP32[i2 + 76 >> 2] = 128;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151328 + 8;
 HEAP32[i2 + 84 >> 2] = i6;
 HEAP32[i2 + 88 >> 2] = i7;
 i1 = i2 + 92 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(0, i5, f8, i9, i10, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i10 = i1;
  STACKTOP = i11;
  return i10 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __Z22AssignCookieToMaterialRK15SharedLightDataP8Material(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i2 = i9;
 i8 = i9 + 4 | 0;
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 do if (!i4) i5 = 11; else {
  HEAP32[i2 >> 2] = i4;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i10 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i10 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i10 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) i5 = 11;
 } while (0);
 if ((i5 | 0) == 11) {
  i1 = HEAP32[gb + 1115124 >> 2] | 0;
  if (!i1) {
   i1 = __ZNK14RenderSettings20GetDefaultSpotCookieEv(__Z17GetRenderSettingsv() | 0) | 0;
   HEAP32[gb + 1115124 >> 2] = i1;
  }
 }
 HEAP32[i8 >> 2] = HEAP32[gb + 1114808 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i7, i6, i1);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertINS_11__wrap_iterIPcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISB_EE5valueES9_E4typeENS7_IPKcEESB_SB_(i8, i2, i9, i10) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = i8 + 11 | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 if (i4) {
  i3 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0;
  i6 = HEAP32[i8 + 4 >> 2] | 0;
  i7 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0;
 } else {
  i3 = 10;
  i6 = i1 & 255;
  i7 = (HEAP32[i2 >> 2] | 0) - i8 | 0;
 }
 i5 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 if (i5 | 0) {
  if ((i3 - i6 | 0) >>> 0 < i5 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i8, i3, i6 - i3 + i5 | 0, i6, i7, 0, i5);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   if (i4) i2 = HEAP32[i8 >> 2] | 0; else i2 = i8;
   i1 = i6 - i7 | 0;
   if (i1) {
    i4 = i2 + i7 | 0;
    _memmove(i4 + i5 | 0, i4 | 0, i1 | 0) | 0;
   }
  }
  i1 = i5 + i6 | 0;
  if ((HEAP8[i11 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i11 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (HEAP32[i10 >> 2] | 0)) {
   i2 = i2 + i7 | 0;
   while (1) {
    HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
    i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
    HEAP32[i9 >> 2] = i1;
    if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) break; else i2 = i2 + 1 | 0;
   }
  }
 }
 if ((HEAP8[i11 >> 0] | 0) < 0) {
  i11 = HEAP32[i8 >> 2] | 0;
  i11 = i11 + i7 | 0;
  return i11 | 0;
 } else {
  i11 = i8;
  i11 = i11 + i7 | 0;
  return i11 | 0;
 }
 return 0;
}

function __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i3, i5, i7, i2, i4) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i6 = 0, i8 = 0;
 do if ((i3 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  if ((HEAP32[i5 + 4 >> 2] | 0) == (i7 | 0)) {
   i1 = i5 + 28 | 0;
   if ((HEAP32[i1 >> 2] | 0) != 1) HEAP32[i1 >> 2] = i2;
  }
 } else {
  if ((i3 | 0) != (HEAP32[i5 >> 2] | 0)) {
   i8 = HEAP32[i3 + 8 >> 2] | 0;
   mftCall_viiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0, i5 | 0, i7 | 0, i2 | 0, i4 | 0);
   break;
  }
  if ((HEAP32[i5 + 16 >> 2] | 0) != (i7 | 0)) {
   i6 = i5 + 20 | 0;
   if ((HEAP32[i6 >> 2] | 0) != (i7 | 0)) {
    HEAP32[i5 + 32 >> 2] = i2;
    i8 = i5 + 44 | 0;
    if ((HEAP32[i8 >> 2] | 0) == 4) break;
    i1 = i5 + 52 | 0;
    HEAP8[i1 >> 0] = 0;
    i2 = i5 + 53 | 0;
    HEAP8[i2 >> 0] = 0;
    i3 = HEAP32[i3 + 8 >> 2] | 0;
    mftCall_viiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i5 | 0, i7 | 0, i7 | 0, 1, i4 | 0);
    if (!(HEAP8[i2 >> 0] | 0)) {
     i1 = 0;
     i2 = 13;
    } else if (!(HEAP8[i1 >> 0] | 0)) {
     i1 = 1;
     i2 = 13;
    } else i2 = 17;
    do if ((i2 | 0) == 13) {
     HEAP32[i6 >> 2] = i7;
     i7 = i5 + 40 | 0;
     HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
     if ((HEAP32[i5 + 36 >> 2] | 0) == 1) if ((HEAP32[i5 + 24 >> 2] | 0) == 2) {
      HEAP8[i5 + 54 >> 0] = 1;
      if (i1) {
       i2 = 17;
       break;
      } else {
       i1 = 4;
       break;
      }
     }
     if (i1) i2 = 17; else i1 = 4;
    } while (0);
    if ((i2 | 0) == 17) i1 = 3;
    HEAP32[i8 >> 2] = i1;
    break;
   }
  }
  if ((i2 | 0) == 1) HEAP32[i5 + 32 >> 2] = 1;
 } while (0);
 return;
}

function __ZN9ShaderLab11ShaderState25RemoveUnsupportedProgramsEPK6Shader(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!(__ZNK9ShaderLab11ShaderState34ShouldRemoveAnyUnsupportedProgramsEv(i2) | 0)) return;
 i3 = i2 + 700 | 0;
 i4 = i2 + 52 | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 do if (i1 | 0) {
  __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
  if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) break;
  HEAP8[i4 >> 0] = 1;
 } while (0);
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 do if (i1 | 0) {
  __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
  if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) break;
  HEAP8[i4 >> 0] = 1;
 } while (0);
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
  if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) break;
  HEAP8[i4 >> 0] = 1;
 } while (0);
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 do if (i1 | 0) {
  __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
  if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) break;
  HEAP8[i4 >> 0] = 1;
 } while (0);
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 do if (i1 | 0) {
  __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
  if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) break;
  HEAP8[i4 >> 0] = 1;
 } while (0);
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (!i1) return;
 __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i3);
 if (HEAP8[i1 + 204 >> 0] | 0) if (HEAP32[i1 + 20 >> 2] | 0) return;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN5physx7NpShape12setLocalPoseERKNS_11PxTransformE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f9 * f9);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f5 * f5)))));
 f7 = Math_fround(f7 * f8);
 f6 = Math_fround(f6 * f8);
 f5 = Math_fround(f5 * f8);
 HEAPF32[i2 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i2 + 4 >> 2] = f7;
 HEAPF32[i2 + 8 >> 2] = f6;
 HEAPF32[i2 + 12 >> 2] = f5;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj4ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i3 + 32 | 0, i3 + 48 | 0, i2);
 if (!(HEAP8[((HEAP32[i3 + 36 >> 2] & 64 | 0) == 0 ? i3 + 112 | 0 : (HEAP32[i3 + 40 >> 2] | 0) + 52 | 0) >> 0] & 2)) {
  STACKTOP = i4;
  return;
 }
 i2 = i3 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE(i1 + 3392 | 0, __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(__ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i2 >> 2] | 0) | 0, i3) | 0);
 STACKTOP = i4;
 return;
}

function __ZN2UI17DestroyCanvasDataER8JobFenceRNS_10CanvasDataE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i7 = i9 + 64 | 0;
 i8 = i9 + 76 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = -1;
    HEAP32[i2 + 8 >> 2] = -1;
    HEAP32[i2 + 12 >> 2] = -1;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 i5 = i9 + 84 | 0;
 i6 = i9 + 96 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i2 = (HEAP32[i5 >> 2] | 0) + (i4 * 672 | 0) + 476 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    i1 = i3 + 4 | 0;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
    if (!(HEAP32[i1 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
    }
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i1 = i9 + 80 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i9 + 68 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i9 + 100 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i9 + 88 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12NavMeshAgent4MoveERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 24 | 0;
 i7 = i9 + 12 | 0;
 i8 = i9;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845040 | 0, 0, gb + 841797 | 0, 747, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 i10 = i1 + 68 | 0;
 i5 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i10) | 0;
 i3 = i5 + 480 | 0;
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = i5 + 484 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i5 + 488 | 0;
 f11 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i2 + 4 >> 2]));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i7 >> 2] = f13;
 HEAPF32[i7 + 4 >> 2] = f12;
 HEAPF32[i7 + 8 >> 2] = f11;
 __ZN7dtCrowd9moveAgentERK13dtCrowdHandlePKf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i10, i7);
 if (HEAP8[i1 + 107 >> 0] & 1) {
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i5 >> 2];
  i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  f13 = Math_fround(-Math_fround(HEAPF32[i1 + 44 >> 2]));
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = f13;
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i10, i8, i6);
 }
 STACKTOP = i9;
 return;
}

function __ZL41FileEntryInfoListToFolderContentsAbsoluteRK13dynamic_arrayI13FileEntryInfoLj8EERNSt3__23setINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS4_4lessISB_EENS9_ISB_EEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 12 | 0;
 i8 = i12;
 i9 = i5 + 12 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i10 = i6 + 4 | 0;
 i11 = i6 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i4, _strlen(i4) | 0);
  i2 = __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESG_RKT_(i6, i7, i8) | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i1 = __Znwj(28) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i8);
   i3 = HEAP32[i7 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = i3;
   HEAP32[i2 >> 2] = i1;
   i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   if (i3) {
    HEAP32[i6 >> 2] = i3;
    i1 = HEAP32[i2 >> 2] | 0;
   }
   __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i10 >> 2] | 0, i1);
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i4 = i4 + 1088 | 0;
 } while ((i4 | 0) != ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) * 1088 | 0) | 0));
 STACKTOP = i12;
 return;
}

function __Z44AudioMixerSnapshot_Get_Custom_PropAudioMixerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z43ReflectionProbe_Get_Custom_PropBakedTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 124 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z23ConvertImageToPNGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = __Z21HasAlphaTextureFormat13TextureFormat(HEAP32[i1 >> 2] | 0) | 0;
 i4 = i4 ? 4 : 3;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) {
  __ZN5Image8SetImageEii13TextureFormatb(i6, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, i4, 1);
  if (!(HEAP32[i6 + 16 >> 2] | 0)) i1 = i6; else if (!(HEAP32[i1 + 16 >> 2] | 0)) i1 = i6; else {
   __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i1, i6, 0);
   i1 = i6;
  }
 }
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147479552) >>> 0 < 4096) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 4096;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, 4096, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 1, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 12 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = 4096;
  HEAP32[i5 >> 2] = i3;
  break;
 } while (0);
 __Z24ConvertBufferToPNGBufferPKhjjj13TextureFormatPvPFvS2_PhjE(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, i4, i5, fb + 507 | 0) | 0;
 i5 = (HEAP32[i5 + 12 >> 2] | 0) != 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 + 16 >> 2] | 0, gb + 63184 | 0);
 STACKTOP = i7;
 return i5 | 0;
}

function __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 96 | 0;
 i8 = i7 + 24 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i6, HEAP32[i1 + 24 >> 2] | 0);
 __ZN8GradientC2Ev(i8);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i3, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1041891 | 0, gb + 1033990 | 0, i8, 0);
 __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i8, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i4 >> 2] = i2 + -72;
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i8 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i7;
 return;
}

function __Z10DestripifyPKtiRNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEEE(i12, i1, i9) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i8 = i4 - i7 | 0;
 i11 = i1 + -2 | 0;
 i1 = i7;
 i7 = 0;
 i2 = 0;
 L1 : while (1) {
  while (1) {
   if ((i2 | 0) >= (i11 | 0)) break L1;
   i3 = HEAP16[i12 + (i2 << 1) >> 1] | 0;
   i5 = i2 + 1 | 0;
   i6 = HEAP16[i12 + (i5 << 1) >> 1] | 0;
   if (i3 << 16 >> 16 == i6 << 16 >> 16) i2 = i5; else break;
  }
  i2 = HEAP16[i12 + (i2 + 2 << 1) >> 1] | 0;
  i7 = ((i3 << 16 >> 16 == i2 << 16 >> 16 ? 1 : i6 << 16 >> 16 == i2 << 16 >> 16) & 1 ^ 1) + i7 | 0;
  i2 = i5;
 }
 i5 = i8 >> 1;
 i2 = i7 * 3 | 0;
 i3 = i2 + i5 | 0;
 if (i3 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEE8__appendEj(i9, i2);
  i1 = HEAP32[i9 >> 2] | 0;
 } else if (i3 >>> 0 < i5 >>> 0) {
  i2 = i1 + (i3 << 1) | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i10 >> 2] = i4 + (~((i4 + -2 - i2 | 0) >>> 1) << 1);
 }
 i7 = i1 + (i5 << 1) | 0;
 i6 = 0;
 i1 = 0;
 L14 : while (1) {
  while (1) {
   if ((i1 | 0) >= (i11 | 0)) break L14;
   i2 = HEAP16[i12 + (i1 << 1) >> 1] | 0;
   i3 = i1 + 1 | 0;
   i4 = HEAP16[i12 + (i3 << 1) >> 1] | 0;
   i5 = HEAP16[i12 + (i1 + 2 << 1) >> 1] | 0;
   if (i4 << 16 >> 16 == i5 << 16 >> 16 | (i2 << 16 >> 16 == i4 << 16 >> 16 ? 1 : i2 << 16 >> 16 == i5 << 16 >> 16)) i1 = i3; else break;
  }
  i1 = (i1 & 1 | 0) == 0;
  HEAP16[i7 + (i6 << 1) >> 1] = i1 ? i2 : i4;
  HEAP16[i7 + (i6 + 1 << 1) >> 1] = i1 ? i4 : i2;
  HEAP16[i7 + (i6 + 2 << 1) >> 1] = i5;
  i6 = i6 + 3 | 0;
  i1 = i3;
 }
 return;
}

function __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37040 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 1024)) {
   if (!(i4 & 512)) {
    if (!(i4 & 1048576)) {
     HEAP32[i11 >> 2] = 0;
     break;
    }
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i11 >> 2] = __Z11StringToIntPKc(i1) | 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   HEAP32[i11 >> 2] = ~~d2 >>> 0;
  } else HEAP32[i11 >> 2] = HEAP32[i1 >> 2]; while (0);
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx2Cm8PtrTable3addEPvRNS0_22PtrTableStorageManagerE(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = i7 + 4 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 i1 = i4 & 65535;
 L1 : do switch (i4 << 16 >> 16) {
 case 0:
  {
   HEAP32[i7 >> 2] = i5;
   HEAP16[i3 >> 1] = 1;
   HEAP8[i7 + 7 >> 0] = 1;
   return;
  }
 case 1:
  {
   i4 = HEAP32[i7 >> 2] | 0;
   i6 = mftCall_iii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 8) | 0;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i6 >> 2] = i4;
   HEAP8[i7 + 7 >> 0] = 0;
   HEAP8[i7 + 6 >> 0] = 1;
   break;
  }
 default:
  {
   i4 = i7 + 6 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) {
    i1 = i1 >>> 1 | i1;
    i1 = i1 >>> 2 | i1;
    i1 = i1 >>> 4 | i1;
    i1 = i1 >>> 8 | i1;
    i1 = mftCall_iii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, ((i1 >>> 16 | i1) << 2) + 4 | 0) | 0;
    _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAPU16[i3 >> 1] << 2 | 0) | 0;
    if (HEAP8[i4 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0, 0);
    HEAP32[i7 >> 2] = i1;
    HEAP8[i4 >> 0] = 1;
    break L1;
   }
   if (!(i1 + 65535 & i1)) if (!(mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i1 | 0, i1 << 1 | 0) | 0)) {
    i2 = mftCall_iii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i1 << 3 | 0) | 0;
    _memcpy(i2 | 0, HEAP32[i7 >> 2] | 0, HEAPU16[i3 >> 1] << 2 | 0) | 0;
    if (HEAP8[i4 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i7 >> 2] | 0, i1 << 2 | 0);
    HEAP32[i7 >> 2] = i2;
    HEAP8[i4 >> 0] = 1;
   }
  }
 } while (0);
 i6 = HEAP16[i3 >> 1] | 0;
 HEAP16[i3 >> 1] = i6 + 1 << 16 >> 16;
 HEAP32[(HEAP32[i7 >> 2] | 0) + ((i6 & 65535) << 2) >> 2] = i5;
 return;
}

function __ZN17PersistentManager12SetPathRemapERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 i8 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i1 + 60 | 0;
 if (!((i8 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i8 & 255) | 0)) {
  __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E9erase_oneIS7_EEjRKT_(i1, i2) | 0;
  STACKTOP = i7;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i5);
  i8 = i4 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i6);
  __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E10insert_oneERKS8_(i7 + 24 | 0, i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return;
 }
}

function __Z42ParticleSystemRenderer_Get_Custom_PropMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 552 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z20LoadAndLookupSymbolsPKcz(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i5 = i10 + 48 | 0;
 i6 = i10 + 32 | 0;
 i7 = i10 + 16 | 0;
 i8 = i10 + 4 | 0;
 HEAP32[i6 >> 2] = i1;
 i3 = i5 + 11 | 0;
 while (1) {
  i2 = (HEAP32[i6 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2 + 4;
  if (!i1) {
   i1 = 1;
   i2 = 6;
   break;
  }
  i11 = (HEAP32[i6 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i2 = HEAP32[i11 >> 2] | 0;
  HEAP32[i6 >> 2] = i11 + 4;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, _strlen(i4) | 0);
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i1, _strlen(i1) | 0);
  if (__Z18LoadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7) | 0) {
   __Z6FormatPKcz(i5, gb + 455597 | 0, i9);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 455527 | 0, 203, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
  HEAP32[i2 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  if (!(HEAP32[i2 >> 2] | 0)) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i3 + -1 | 0) >>> 0 > 1) {
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i2, 32, gb + 670216 | 0, i5);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = (i3 | 0) == 1 ? i2 + 4 | 0 : i2 + 8 | 0;
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i8 | 0, i7 | 0, 76, (i6 ? gb + 670292 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 818) | 0;
 HEAP32[i6 >> 2] = i2;
 i7 = i6 + 4 | 0;
 i2 = i6 + 40 | 0;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i4 >> 2] = i6;
 i3 = __ZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeE(i6, i1, i3) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i3) {
  i8 = i1;
  STACKTOP = i5;
  return i8 | 0;
 }
 if (!i1) {
  i8 = 0;
  STACKTOP = i5;
  return i8 | 0;
 }
 __ZN5physx2Sn8MetaDataD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 4 | 0, i1);
 HEAP32[i4 >> 2] = 0;
 i8 = 0;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZL17Transfer_GUIStyleI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 256 | 0;
 i5 = i9 + 248 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i8 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i8);
 if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = 0;
 do {
  i4 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i2 >> 2] | 0, i1) | 0) >> 2] | 0;
  if (i4 | 0) {
   i10 = __Z9GetIIMGUIv() | 0;
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i5, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0, gb + 1034525 | 0, 1);
   if (HEAP32[i5 >> 2] | 0) {
    i12 = i5;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i7;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i4, i8);
    HEAP32[i8 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i8, 0) | 0;
   }
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i5 = i10 + 32 | 0;
 i6 = i10 + 16 | 0;
 i7 = i10;
 i3 = i1 + 32 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = HEAP32[i2 + 4 >> 2] | 0;
 i14 = HEAP32[i2 + 8 >> 2] | 0;
 i13 = HEAP32[i4 >> 2] | 0;
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i15;
 HEAP32[i5 + 8 >> 2] = i14;
 HEAP32[i6 >> 2] = i13;
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i6 + 8 >> 2] = i11;
 HEAP32[i6 + 12 >> 2] = i4;
 if (!(i3 >>> 0 < 1 | (i3 | 0) == 1 & i8 >>> 0 < 0)) {
  i14 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i15 = i9;
  HEAP32[i15 >> 2] = i8;
  HEAP32[i15 + 4 >> 2] = i14;
  __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E(i9, i5, i6);
 }
 i15 = i7;
 HEAP32[i15 >> 2] = i8;
 HEAP32[i15 + 4 >> 2] = i3;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 if (!(__Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E(i9, i5, i6) | 0)) {
  STACKTOP = i10;
  return;
 }
 i15 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i15 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 3);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i15 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN9AudioClip7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(136, i1, 16, gb + 1048932 | 0, 0, gb + 870427 | 0, 180) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 170392 + 8;
 i2 = i4 + 32 | 0;
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 __ZN11SoundHandleC2Ev(i4 + 56 | 0);
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP8[i4 + 64 >> 0] = 1;
 HEAP8[i4 + 65 >> 0] = 0;
 HEAP8[i4 + 66 >> 0] = 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = i4;
 HEAP32[i4 + 120 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 170536 + 8;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[gb + 1459900 >> 2] = (HEAP32[gb + 1459900 >> 2] | 0) + 1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN8Material15SetColorIndexedEN9ShaderLab16FastPropertyNameEif(i8, i9, i10, f11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 4 | 0;
 i12 = i13;
 i4 = i8 + 72 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = i4;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) HEAPF32[i1 + 20 + (i10 << 2) >> 2] = f11;
 }
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 12; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 12;
 if ((i6 | 0) == 12) {
  __ZN8Material15BuildPropertiesEv(i8);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet16SetVectorIndexedERKN9ShaderLab16FastPropertyNameEifRK8Vector4fNS_8SetFlagsE(i2 + 12 | 0, i9, i10, f11, gb + 1162376 | 0, 0);
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i8, i7);
 STACKTOP = i13;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 374101 | 0, i2, i4);
 i6 = i2 + 4 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1034151 | 0, i7, i8, 0);
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 469700 | 0, gb + 479385 | 0, i2, 0);
 i6 = i8 + 8 | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048093 | 0, i7, i2, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i3 = i8 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i1 + (i2 * 12 | 0) | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i8, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return;
}

function __ZN16MessageForwarder15AddBaseMessagesERKS_(i8, i11) {
 i8 = i8 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i9 = i8 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) >> 2;
 i10 = i11 + 4 | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) >> 2;
 i7 = i1 >>> 0 < i3 >>> 0;
 i3 = i7 ? i3 : i1;
 HEAP32[i5 >> 2] = 0;
 if (i7) __ZNSt3__26vectorIPFvPviR11MessageDataENS_9allocatorIS5_EEE8__appendEjRKS5_(i8, i3 - i1 | 0, i5);
 i7 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i8 + 16 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (i3 >>> 0 > i1 >>> 0) __ZNSt3__26vectorIPKN5Unity4TypeENS_9allocatorIS4_EEE8__appendEjRKS4_(i7, i3 - i1 | 0, i5); else if (i3 >>> 0 < i1 >>> 0) {
  i1 = i2 + (i3 << 2) | 0;
  if ((i6 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i6 + (~((i6 + -4 - i1 | 0) >>> 2) << 2);
 }
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i11 + 12 | 0;
  i5 = 0;
  do {
   i3 = i1 + (i5 << 2) | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    i4 = HEAP32[i11 >> 2] | 0;
    if (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) - i4 >> 2 >>> 0) {
     HEAP32[i3 >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
     HEAP32[(HEAP32[i7 >> 2] | 0) + (i5 << 2) >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2];
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 - i1 >> 2 >>> 0);
 }
 i1 = i8 + 24 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[i11 + 24 >> 2];
 STACKTOP = i12;
 return;
}

function __ZN16AnimationManager6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 d8 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 i4 = (HEAP8[(__Z14GetTimeManagerv() | 0) + 193 >> 0] | 0) != 0;
 i1 = i4 ? i1 + 8 | 0 : i1;
 i4 = i7 + 4 | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i10;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i1 >> 2] = i1;
 if ((i10 | 0) == (i1 | 0)) HEAP32[i7 >> 2] = i7;
 HEAP32[i2 >> 2] = i1;
 if ((i3 | 0) == (i1 | 0)) HEAP32[i4 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAP32[i1 >> 2] = i1;
 HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] = i7;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = i7;
 L7 : do if ((i1 | 0) != (i7 | 0)) {
  i2 = i7;
  while (1) {
   HEAP32[i6 >> 2] = i1;
   if (i2 | 0) {
    i10 = i1 + 4 | 0;
    HEAP32[i2 + 4 >> 2] = HEAP32[i10 >> 2];
    HEAP32[HEAP32[i10 >> 2] >> 2] = i2;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
   }
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i1 | 0) == (i2 | 0)) {
    if (!i1) break;
   } else {
    i10 = i1 + 4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i10 >> 2] = i2;
    HEAP32[i3 + 4 >> 2] = i1;
    HEAP32[HEAP32[i10 >> 2] >> 2] = i1;
   }
   __ZN9Animation15UpdateAnimationEd(HEAP32[i1 + 8 >> 2] | 0, d8);
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) == (i7 | 0)) break L7;
   i1 = i2;
   i2 = HEAP32[i2 >> 2] | 0;
  }
  STACKTOP = i9;
  return;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z41AudioMixerGroup_Get_Custom_PropAudioMixerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z40SpriteRenderer_CUSTOM_GetSprite_INTERNALP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 340 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i7 = i3;
 i2 = i3 + 24 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37212 >> 2] | 0, i7, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 906486 | 0, i2, i4);
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2 + 4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 906345 | 0, HEAP32[gb + 37316 >> 2] | 0, i7, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 56 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 905989 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 1085944 | 0, 0);
 i4 = i6 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1084124 | 0, gb + 906539 | 0, i4, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i4, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __Z39Terrain_Get_Custom_PropMaterialTemplateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 108 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i5 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 i9 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i3 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 + 512 | 0) >>> 0 > (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i3, 32768);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i3 = (HEAP32[i3 >> 2] | 0) + i1 | 0;
 HEAP32[i2 >> 2] = i1 + 512;
 HEAP32[i7 + (i9 * 360 | 0) + 328 >> 2] = i3;
 HEAP32[i7 + (i9 * 360 | 0) + 256 >> 2] = HEAP32[i8 + 364 >> 2];
 _memcpy(i3 + 64 | 0, i8 + 592 | 0, 444) | 0;
 i4 = i8 + 340 | 0;
 HEAP32[i3 + 508 >> 2] = HEAPU16[i4 >> 1];
 __ZNK6Camera22GetCameraToWorldMatrixEv(i6, i5);
 i1 = i6;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i6 = (HEAP16[i4 >> 1] | 0) == 4;
 HEAP32[i7 + (i9 * 360 | 0) + 332 >> 2] = i6 ? fb + 287 | 0 : fb + 288 | 0;
 i1 = i7 + (i9 * 360 | 0) + 340 | 0;
 if (i6) {
  HEAP32[i1 >> 2] = fb + 747;
  i6 = 1;
  i8 = i7 + (i9 * 360 | 0) + 348 | 0;
  HEAP32[i8 >> 2] = i6;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  HEAP32[i1 >> 2] = fb + 748;
  i6 = HEAP32[i8 + 392 >> 2] << 16 | 1;
  i8 = i7 + (i9 * 360 | 0) + 348 | 0;
  HEAP32[i8 >> 2] = i6;
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function __ZN15ResourceManager8TransferI14SafeBinaryReadEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i4);
 i2 = i3 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 450717 | 0, HEAP32[gb + 37052 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i3 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 450729 | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 1) | 0;
 if (!i1) {
  i2 = i3 + 28 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 32 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i2, i4, i5);
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 i2 = i3 + 28 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 32 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(i2, i4, i5);
 STACKTOP = i6;
 return;
}

function __Z34TextMesh_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = f7 < Math_fround(0.0);
  f7 = i2 ? Math_fround(0.0) : f7;
  i2 = f7 > Math_fround(1.0);
  HEAP8[i4 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i2 = f7 < Math_fround(0.0);
  f7 = i2 ? Math_fround(0.0) : f7;
  i2 = f7 > Math_fround(1.0);
  HEAP8[i4 + 1 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i2 = f7 < Math_fround(0.0);
  f7 = i2 ? Math_fround(0.0) : f7;
  i2 = f7 > Math_fround(1.0);
  HEAP8[i4 + 2 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  i3 = f7 < Math_fround(0.0);
  f7 = i3 ? Math_fround(0.0) : f7;
  i3 = f7 > Math_fround(1.0);
  HEAP8[i4 + 3 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN20TextRenderingPrivate8TextMesh8SetColorE11ColorRGBA32(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z28dtClosestHeightPointTrianglePKfS0_S0_S0_Rf(i1, i2, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f3 = f0, f4 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f3 - f13);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f4 - f10);
 f14 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f13);
 f12 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f10);
 f13 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f13);
 f10 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) - f10);
 f11 = Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4));
 f9 = Math_fround(Math_fround(f3 * f14) + Math_fround(f4 * f12));
 f4 = Math_fround(Math_fround(f3 * f13) + Math_fround(f4 * f10));
 f3 = Math_fround(Math_fround(f14 * f14) + Math_fround(f12 * f12));
 f10 = Math_fround(Math_fround(f14 * f13) + Math_fround(f12 * f10));
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f11 * f3) - Math_fround(f9 * f9)));
 f3 = Math_fround(f12 * Math_fround(Math_fround(f3 * f4) - Math_fround(f9 * f10)));
 f4 = Math_fround(f12 * Math_fround(Math_fround(f11 * f10) - Math_fround(f9 * f4)));
 if (!(f4 >= Math_fround(-.0000999999974)) | !(f3 >= Math_fround(-.0000999999974)) | !(Math_fround(f3 + f4) <= Math_fround(1.00010002))) {
  i7 = 0;
  return i7 | 0;
 }
 f14 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f8);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f4 * f14) + Math_fround(f8 + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f8))));
 i7 = 1;
 return i7 | 0;
}

function __Z18BuildScriptClassIdP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 48 | 0;
 i4 = i7 + 32 | 0;
 i5 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __Z26GetScriptClassIdComponentsP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES9_S9_(i2, i6, i5, i4);
 __Z18BuildScriptClassIdRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_(i1, i6, i5, i4);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 12;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 12;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI20ShadowCasterPartData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 4) + 1 | 0;
 if ((i8 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 3;
 i6 = i7 >> 4 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 2;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 16;
 HEAP32[i8 >> 2] = i7 + (i6 << 4);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 2;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i11, i8, i2, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 if (!i1) {
  __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i8, 0, i2);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i8, HEAP32[i10 + 4 >> 2] | 0, i2);
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) {
  i4 = HEAP32[gb + 37208 >> 2] | 0;
  i5 = i11 + 20 | 0;
  i6 = i11 + 56 | 0;
  i7 = i11 + 44 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i8 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 3) + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2, gb + 1085989 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 4 | 0, gb + 1085998 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 8 | 0, gb + 1084342 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 12 | 0, gb + 1085899 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i9 >> 2] = i10;
 return;
}

function __ZN5physx3Ext20SharedQueueEntryPoolINS_6shdfnd19ReflectionAllocatorINS0_16SharedQueueEntryEEEEC2EjRKS5_(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9SListImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i6 | 0, i1 | 0, (i2 ? gb + 741043 | 0 : gb + 837976 | 0) | 0, gb + 741165 | 0, 86) | 0;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN5physx6shdfnd9SListImplC2Ev(i1);
 if (!i4) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i7 | 0, i4 << 4 | 11 | 0, (i1 ? gb + 661229 | 0 : gb + 837976 | 0) | 0, gb + 661359 | 0, 69) | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i2 = i1 + 11 & -8;
 HEAP32[i2 + -4 >> 2] = i2 - i1;
 i1 = i2;
 HEAP32[i5 >> 2] = i1;
 if (!i2) return;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 1;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i3 >> 2] | 0, i2);
 if ((i4 | 0) == 1) return; else i1 = 1;
 do {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + (i1 << 4) >> 2] = 0;
  HEAP32[i7 + (i1 << 4) + 4 >> 2] = 0;
  HEAP8[i7 + (i1 << 4) + 8 >> 0] = 1;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i3 >> 2] | 0, i7 + (i1 << 4) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN14SplatPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 4 | 0, i6);
 i1 = i5 + 8 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i6, i5 + 24 | 0, gb + 932925 | 0, 0);
 i1 = i5 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z38BillboardAsset_Get_Custom_PropMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _init_block(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = 0;
 do {
  HEAP16[i2 + 148 + (i1 << 2) >> 1] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 286);
 HEAP16[i2 + 2440 >> 1] = 0;
 HEAP16[i2 + 2444 >> 1] = 0;
 HEAP16[i2 + 2448 >> 1] = 0;
 HEAP16[i2 + 2452 >> 1] = 0;
 HEAP16[i2 + 2456 >> 1] = 0;
 HEAP16[i2 + 2460 >> 1] = 0;
 HEAP16[i2 + 2464 >> 1] = 0;
 HEAP16[i2 + 2468 >> 1] = 0;
 HEAP16[i2 + 2472 >> 1] = 0;
 HEAP16[i2 + 2476 >> 1] = 0;
 HEAP16[i2 + 2480 >> 1] = 0;
 HEAP16[i2 + 2484 >> 1] = 0;
 HEAP16[i2 + 2488 >> 1] = 0;
 HEAP16[i2 + 2492 >> 1] = 0;
 HEAP16[i2 + 2496 >> 1] = 0;
 HEAP16[i2 + 2500 >> 1] = 0;
 HEAP16[i2 + 2504 >> 1] = 0;
 HEAP16[i2 + 2508 >> 1] = 0;
 HEAP16[i2 + 2512 >> 1] = 0;
 HEAP16[i2 + 2516 >> 1] = 0;
 HEAP16[i2 + 2520 >> 1] = 0;
 HEAP16[i2 + 2524 >> 1] = 0;
 HEAP16[i2 + 2528 >> 1] = 0;
 HEAP16[i2 + 2532 >> 1] = 0;
 HEAP16[i2 + 2536 >> 1] = 0;
 HEAP16[i2 + 2540 >> 1] = 0;
 HEAP16[i2 + 2544 >> 1] = 0;
 HEAP16[i2 + 2548 >> 1] = 0;
 HEAP16[i2 + 2552 >> 1] = 0;
 HEAP16[i2 + 2556 >> 1] = 0;
 HEAP16[i2 + 2684 >> 1] = 0;
 HEAP16[i2 + 2688 >> 1] = 0;
 HEAP16[i2 + 2692 >> 1] = 0;
 HEAP16[i2 + 2696 >> 1] = 0;
 HEAP16[i2 + 2700 >> 1] = 0;
 HEAP16[i2 + 2704 >> 1] = 0;
 HEAP16[i2 + 2708 >> 1] = 0;
 HEAP16[i2 + 2712 >> 1] = 0;
 HEAP16[i2 + 2716 >> 1] = 0;
 HEAP16[i2 + 2720 >> 1] = 0;
 HEAP16[i2 + 2724 >> 1] = 0;
 HEAP16[i2 + 2728 >> 1] = 0;
 HEAP16[i2 + 2732 >> 1] = 0;
 HEAP16[i2 + 2736 >> 1] = 0;
 HEAP16[i2 + 2740 >> 1] = 0;
 HEAP16[i2 + 2744 >> 1] = 0;
 HEAP16[i2 + 2748 >> 1] = 0;
 HEAP16[i2 + 2752 >> 1] = 0;
 HEAP16[i2 + 2756 >> 1] = 0;
 HEAP16[i2 + 1172 >> 1] = 1;
 HEAP32[i2 + 5804 >> 2] = 0;
 HEAP32[i2 + 5800 >> 2] = 0;
 HEAP32[i2 + 5808 >> 2] = 0;
 HEAP32[i2 + 5792 >> 2] = 0;
 return;
}

function __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE(i8, i9, i4, i6) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i8 + 8 | 0;
 i11 = i8 + 20 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 L1 : do if (!i7) i7 = 0; else {
  i1 = HEAP32[i10 >> 2] | 0;
  i5 = i1 + (i4 * 12 | 0) | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   i1 = 0;
   while (1) {
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i7 >>> 0) break L1;
   }
  }
  i3 = (HEAP32[i1 + (i4 * 12 | 0) + 4 >> 2] | 0) == (i9 | 0);
  i2 = 0;
  i1 = 0;
  while (1) {
   if (i3) if ((i1 | 0) == (i4 | 0)) break; else i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break L1;
  }
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  return;
 } while (0);
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i7 + 1 | 0;
 i4 = i8 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 * 12 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i10 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i3;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 + (i7 * 12 | 0) >> 2] = i2;
 HEAP32[i11 + (i7 * 12 | 0) + 4 >> 2] = i9;
 HEAP32[i11 + (i7 * 12 | 0) + 8 >> 2] = 0;
 return;
}

function __ZN8keywords10InitializeEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63280 | 0, 16, gb + 469960 | 0, 21) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1166252 >> 2] = i1;
 i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478131 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478136 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478148 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478167 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478173 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478186 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478200 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478215 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478228 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478241 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478263 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478286 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478298 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478319 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478340 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478359 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478370 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478378 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478387 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478397 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478412 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478429 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478442 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478462 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478481 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478495 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478520 | 0) | 0;
 __ZN8keywords6CreateEPKc(gb + 478540 | 0) | 0;
 if (!i1) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13GfxDeviceNullC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN9GfxDeviceC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 77628 + 8;
 __ZN9GfxDevice15InvalidateStateEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 620 >> 2] | 0, i1 | 0);
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4616 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4680 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4744 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 4808 | 0) | 0;
 i2 = i1 + 4908 | 0;
 i3 = i1 + 4872 | 0;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 + 4388 >> 2] = 4;
 HEAPF32[i1 + 4372 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4368 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 4392 >> 2] = -1;
 HEAP32[gb + 1451360 >> 2] = 0;
 HEAP32[gb + 1451360 + 4 >> 2] = 0;
 HEAP32[gb + 1451360 + 8 >> 2] = 0;
 HEAP32[gb + 1451360 + 12 >> 2] = 0;
 HEAP32[gb + 1451360 + 16 >> 2] = 0;
 HEAP32[gb + 1451360 + 20 >> 2] = 0;
 HEAP32[gb + 1451360 + 24 >> 2] = 0;
 HEAP32[gb + 1451360 + 28 >> 2] = 0;
 HEAP32[gb + 1451360 + 16 >> 2] = 1;
 HEAP32[gb + 1451360 + 24 >> 2] = 2;
 HEAP8[gb + 1451360 + 30 >> 0] = 1;
 HEAP8[gb + 1451360 + 31 >> 0] = 1;
 HEAP32[i1 + 4400 >> 2] = gb + 1451360;
 HEAP32[gb + 1451392 >> 2] = 0;
 HEAP32[gb + 1451392 + 4 >> 2] = 0;
 HEAP32[gb + 1451392 + 8 >> 2] = 0;
 HEAP32[gb + 1451392 + 12 >> 2] = 0;
 HEAP32[gb + 1451392 + 16 >> 2] = 0;
 HEAP32[gb + 1451392 + 20 >> 2] = 0;
 HEAP32[gb + 1451392 + 24 >> 2] = 0;
 HEAP32[gb + 1451392 + 28 >> 2] = 0;
 HEAP32[gb + 1451392 + 16 >> 2] = 1;
 HEAP32[gb + 1451392 + 24 >> 2] = 2;
 HEAP8[gb + 1451392 + 30 >> 0] = 0;
 HEAP8[gb + 1451392 + 31 >> 0] = 1;
 HEAP32[i1 + 4404 >> 2] = gb + 1451392;
 return;
}

function _UNITY_png_ascii_from_fixed(i4, i5, i3, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (i3 >>> 0 <= 12) _UNITY_png_error(i4, gb + 351925 | 0);
 i3 = 0 - i6 | 0;
 if ((i6 | 0) < 0) {
  HEAP8[i5 >> 0] = 45;
  if (i3 >>> 0 < 2147483649) {
   i2 = i5 + 1 | 0;
   i1 = i3;
  } else _UNITY_png_error(i4, gb + 351925 | 0);
 } else {
  i2 = i5;
  i1 = i6;
 }
 if (i1 | 0) {
  i5 = 16;
  i4 = 0;
  while (1) {
   i6 = i1;
   i1 = (i1 >>> 0) / 10 | 0;
   i9 = (Math_imul(i1, -10) | 0) + i6 | 0;
   i3 = i4 + 1 | 0;
   HEAP8[i7 + i4 >> 0] = i9 + 48;
   i5 = (i5 | 0) == 16 & (i9 | 0) != 0 ? i3 : i5;
   if (i6 >>> 0 < 10) break; else i4 = i3;
  }
  if (i3 | 0) {
   if (i3 >>> 0 > 5) {
    i4 = i4 + -4 | 0;
    i1 = i2;
    while (1) {
     i3 = i3 + -1 | 0;
     HEAP8[i1 >> 0] = HEAP8[i7 + i3 >> 0] | 0;
     if (i3 >>> 0 <= 5) break; else i1 = i1 + 1 | 0;
    }
    i2 = i2 + i4 | 0;
    i3 = 5;
   }
   if (i5 >>> 0 >= 6) {
    i9 = i2;
    HEAP8[i9 >> 0] = 0;
    STACKTOP = i8;
    return;
   }
   HEAP8[i2 >> 0] = 46;
   i1 = i2 + 1 | 0;
   if (i3 >>> 0 < 5) {
    _memset(i1 | 0, 48, 5 - i3 | 0) | 0;
    i1 = i2 + (6 - i3) | 0;
   }
   if (i3 >>> 0 < i5 >>> 0) {
    i9 = i1;
    HEAP8[i9 >> 0] = 0;
    STACKTOP = i8;
    return;
   } else i2 = i1;
   while (1) {
    i3 = i3 + -1 | 0;
    i1 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = HEAP8[i7 + i3 >> 0] | 0;
    if (i3 >>> 0 < i5 >>> 0) break; else i2 = i1;
   }
   HEAP8[i1 >> 0] = 0;
   STACKTOP = i8;
   return;
  }
 }
 HEAP8[i2 >> 0] = 48;
 i9 = i2 + 1 | 0;
 HEAP8[i9 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorI15QueuedAnimation13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 4) + 1 | 0;
 if ((i8 | 0) < -16) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 3;
 i6 = i7 >> 4 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 4, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 16;
 HEAP32[i8 >> 2] = i7 + (i6 << 4);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 25;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN15LODGroupManager14RemoveLODGroupEi(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i10 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i2 + ((i1 + -1 | 0) * 96 | 0) + 88 >> 2] | 0;
 HEAP32[i3 + 68 >> 2] = i11;
 i7 = i3 + 88 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i4) {
  i5 = i3 + 76 | 0;
  i6 = i11 & 65535;
  i3 = 0;
  i1 = i4;
  do {
   i2 = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0;
    HEAP16[i1 + (i2 * 24 | 0) + 12 >> 1] = 0;
    HEAP16[i1 + (i2 * 24 | 0) + 14 >> 1] = i6;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i3 = i2 + (i11 * 96 | 0) | 0;
 i1 = i2 + ((i1 + -1 | 0) * 96 | 0) | 0;
 i2 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 i3 = i10 + 48 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i10 + 36 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i8 = i7 + 28 | 0;
  i10 = HEAP32[i7 + 16 >> 2] | 0;
  HEAP8[i10 + i11 >> 0] = HEAP8[i10 + ((HEAP32[i8 >> 2] | 0) + -1) >> 0] | 0;
  i10 = i7 + 48 | 0;
  i9 = (HEAP32[i10 >> 2] | 0) + -1 | 0;
  i7 = HEAP32[i7 + 36 >> 2] | 0;
  HEAP32[i7 + (i11 << 2) >> 2] = HEAP32[i7 + (i9 << 2) >> 2];
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  HEAP32[i10 >> 2] = i9;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZL20AccumulateContinuousRK11MinMaxCurveffff(i4, f2, f3, f5, f6) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 f3 = Math_fround(f3 / f2);
 HEAPF32[i8 + 12 >> 2] = f3;
 HEAPF32[i8 + 8 >> 2] = f3;
 HEAPF32[i8 + 4 >> 2] = f3;
 HEAPF32[i8 >> 2] = f3;
 HEAPF32[i9 + 12 >> 2] = f6;
 HEAPF32[i9 + 8 >> 2] = f6;
 HEAPF32[i9 + 4 >> 2] = f6;
 HEAPF32[i9 >> 2] = f6;
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 L1 : do switch ((i1 & 65535) << 16 >> 16) {
 case 0:
  {
   i9 = HEAP32[i4 + 80 >> 2] | 0;
   HEAP32[i7 + 12 >> 2] = i9;
   HEAP32[i7 + 8 >> 2] = i9;
   HEAP32[i7 + 4 >> 2] = i9;
   HEAP32[i7 >> 2] = i9;
   break;
  }
 case 3:
  {
   f3 = Math_fround(HEAPF32[(HEAP32[i4 + 232 >> 2] | 0) + 4 >> 2]);
   f2 = Math_fround(HEAPF32[i4 + 80 >> 2]);
   f3 = Math_fround(f3 * f2);
   f6 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(f2 * Math_fround(HEAPF32[(HEAP32[i4 + 144 >> 2] | 0) + 4 >> 2])) - f3) * f6));
   HEAPF32[i7 >> 2] = f6;
   HEAPF32[i7 + 4 >> 2] = f6;
   HEAPF32[i7 + 8 >> 2] = f6;
   HEAPF32[i7 + 12 >> 2] = f6;
   break;
  }
 default:
  if (!(i1 & 16711680)) {
   __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_(i7, i4, i8, i9);
   break L1;
  } else {
   __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_(i7, i4, i8, i9);
   break L1;
  }
 } while (0);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 i9 = f6 > Math_fround(0.0);
 f6 = Math_fround((i9 ? f6 : Math_fround(0.0)) * f5);
 STACKTOP = i10;
 return Math_fround(f6);
}

function __Z36Joint2D_Get_Custom_PropConnectedBodyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function ___towcase(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = (i9 << 1) + -1 | 0;
 i7 = i9 + -1 | 0;
 L1 : do if (!((i1 + -43008 | 0) >>> 0 < 22272 | ((i1 + -11776 | 0) >>> 0 < 30784 | ((i1 + -1536 | 0) >>> 0 < 2560 | (_iswalpha(i1) | 0) == 0)))) {
  i2 = (i9 | 0) != 0;
  if (i2 & (i1 + -4256 | 0) >>> 0 < 46) {
   if ((i1 | 0) > 4293) switch (i1 | 0) {
   case 4295:
   case 4301:
    break;
   default:
    break L1;
   }
   i1 = i1 + 7264 | 0;
   break;
  }
  if ((i1 + -11520 | 0) >>> 0 < 38 & (i2 ^ 1)) {
   if ((i1 | 0) > 11557) switch (i1 | 0) {
   case 11559:
   case 11565:
    break;
   default:
    break L1;
   }
   i1 = i1 + -7264 | 0;
   break;
  } else i2 = 0;
  do {
   i4 = HEAP8[gb + 229346 + (i2 << 2) + 2 >> 0] | 0;
   i5 = i4 << 24 >> 24;
   i3 = i1 - (HEAPU16[gb + 229346 + (i2 << 2) >> 1] | 0) | 0;
   if ((i3 - (i5 & i7) | 0) >>> 0 < (HEAPU8[gb + 229346 + (i2 << 2) + 3 >> 0] | 0) >>> 0) {
    i8 = 13;
    break;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 61);
  if ((i8 | 0) == 13) if (i4 << 24 >> 24 == 1) {
   i1 = i9 + i1 - (i3 & 1) | 0;
   break;
  } else {
   i1 = (Math_imul(i5, i6) | 0) + i1 | 0;
   break;
  }
  i4 = 1 - i9 | 0;
  i2 = HEAP16[gb + 228854 + (i4 << 1) >> 1] | 0;
  L23 : do if (i2 << 16 >> 16) {
   i3 = 0;
   while (1) {
    if ((i2 & 65535 | 0) == (i1 | 0)) break;
    i3 = i3 + 1 | 0;
    i2 = HEAP16[gb + 228854 + (i3 << 2) + (i4 << 1) >> 1] | 0;
    if (!(i2 << 16 >> 16)) break L23;
   }
   i1 = HEAPU16[gb + 228854 + (i3 << 2) + (i9 << 1) >> 1] | 0;
   break L1;
  } while (0);
  return ((i1 + -66600 + (i9 * 40 | 0) | 0) >>> 0 < 40 ? i1 + -40 + (i9 * 80 | 0) | 0 : i1) | 0;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 2);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 2) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i6 = i1 - i2 | 0;
 i5 = i6 >> 1;
 i5 = i6 >> 2 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 2 << 2) | 0;
 _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 2);
 HEAP32[i11 >> 2] = i6 + (i5 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_25GenericInsituStringStreamIS2_EEEEjRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + 1 | 0;
 HEAP32[i7 >> 2] = i3;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24;
 do if ((i1 + -48 & 255) < 10) {
  i2 = i2 + -48 | 0;
  i4 = 8;
 } else {
  if ((i1 + -65 & 255) < 6) {
   i2 = i2 + -55 | 0;
   i4 = 8;
   break;
  }
  if ((i1 + -97 & 255) < 6) {
   i2 = i2 + -87 | 0;
   i4 = 8;
  } else i1 = i3;
 } while (0);
 L8 : do if ((i4 | 0) == 8) {
  i1 = i5 + 2 | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = HEAP8[i3 >> 0] | 0;
  i2 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  do if ((i3 + -48 & 255) < 10) i2 = i2 + -48 | 0; else {
   if ((i3 + -65 & 255) < 6) {
    i2 = i2 + -55 | 0;
    break;
   }
   if ((i3 + -97 & 255) >= 6) break L8;
   i2 = i2 + -87 | 0;
  } while (0);
  i4 = i5 + 3 | 0;
  HEAP32[i7 >> 2] = i4;
  i3 = HEAP8[i1 >> 0] | 0;
  i1 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  do if ((i3 + -48 & 255) < 10) i2 = i1 + -48 | 0; else {
   if ((i3 + -65 & 255) < 6) {
    i2 = i1 + -55 | 0;
    break;
   }
   if ((i3 + -97 & 255) >= 6) {
    i1 = i4;
    break L8;
   }
   i2 = i1 + -87 | 0;
  } while (0);
  i1 = i5 + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = HEAP8[i4 >> 0] | 0;
  i2 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  if ((i3 + -48 & 255) < 10) {
   i7 = i2 + -48 | 0;
   return i7 | 0;
  }
  if ((i3 + -65 & 255) < 6) {
   i7 = i2 + -55 | 0;
   return i7 | 0;
  }
  if ((i3 + -97 & 255) < 6) {
   i7 = i2 + -87 | 0;
   return i7 | 0;
  }
 } while (0);
 i7 = i1 + -1 - (HEAP32[i7 + 8 >> 2] | 0) | 0;
 HEAP32[i6 + 24 >> 2] = 8;
 HEAP32[i6 + 28 >> 2] = i7;
 i7 = 0;
 return i7 | 0;
}

function __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i8, i4, i1, i2) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = (HEAP8[i8 + 24 >> 0] | 0) != 0;
 if (i6) __ZN9BlobWrite4PushEjPKvj(i8, 4, i4, 4);
 i7 = i8 + 48 | 0;
 i3 = i8 + 44 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i5 = i8 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 >>> 8 << 2) >> 2] | 0;
 i1 = i1 & 255;
 i2 = i9 + (i1 << 4) + 4 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i1 << 4) >> 2] | 0)) & 3);
 i2 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i2 = (HEAP32[HEAP32[i8 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + (i2 << 4) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 << 4) >> 2] | 0)) | 0;
 i1 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i2 >> 0] = i1;
 HEAP8[i2 + 1 >> 0] = i1 >> 8;
 HEAP8[i2 + 2 >> 0] = i1 >> 16;
 HEAP8[i2 + 3 >> 0] = i1 >> 24;
 if (HEAP8[i8 + 27 >> 0] | 0) HEAP32[i2 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i7 >> 2] | 0) + -1 + i4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i10 = (HEAP32[i3 + (i10 >>> 8 << 2) >> 2] | 0) + ((i10 & 255) << 4) + 4 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 if (!i6) return;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i9 + -1;
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - i3 | 0;
 if ((1 - i9 - i4 + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i8, i4, i1, i2) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = (HEAP8[i8 + 24 >> 0] | 0) != 0;
 if (i6) __ZN9BlobWrite4PushEjPKvj(i8, 4, i4, 4);
 i7 = i8 + 48 | 0;
 i3 = i8 + 44 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i5 = i8 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 >>> 8 << 2) >> 2] | 0;
 i1 = i1 & 255;
 i2 = i9 + (i1 << 4) + 4 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i1 << 4) >> 2] | 0)) & 3);
 i2 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i2 = (HEAP32[HEAP32[i8 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + (i2 << 4) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 << 4) >> 2] | 0)) | 0;
 i1 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i2 >> 0] = i1;
 HEAP8[i2 + 1 >> 0] = i1 >> 8;
 HEAP8[i2 + 2 >> 0] = i1 >> 16;
 HEAP8[i2 + 3 >> 0] = i1 >> 24;
 if (HEAP8[i8 + 27 >> 0] | 0) HEAP32[i2 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i7 >> 2] | 0) + -1 + i4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i10 = (HEAP32[i3 + (i10 >>> 8 << 2) >> 2] | 0) + ((i10 & 255) << 4) + 4 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 if (!i6) return;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i9 + -1;
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - i3 | 0;
 if ((1 - i9 - i4 + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i8, i4, i1, i2) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = (HEAP8[i8 + 24 >> 0] | 0) != 0;
 if (i6) __ZN9BlobWrite4PushEjPKvj(i8, 4, i4, 4);
 i7 = i8 + 48 | 0;
 i3 = i8 + 44 | 0;
 i1 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i5 = i8 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 >>> 8 << 2) >> 2] | 0;
 i1 = i1 & 255;
 i2 = i9 + (i1 << 4) + 4 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i1 << 4) >> 2] | 0)) & 3);
 i2 = (HEAP32[i7 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i2 = (HEAP32[HEAP32[i8 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + (i2 << 4) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 << 4) >> 2] | 0)) | 0;
 i1 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i2 >> 0] = i1;
 HEAP8[i2 + 1 >> 0] = i1 >> 8;
 HEAP8[i2 + 2 >> 0] = i1 >> 16;
 HEAP8[i2 + 3 >> 0] = i1 >> 24;
 if (HEAP8[i8 + 27 >> 0] | 0) HEAP32[i2 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i10 = (HEAP32[i7 >> 2] | 0) + -1 + i4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i10 = (HEAP32[i3 + (i10 >>> 8 << 2) >> 2] | 0) + ((i10 & 255) << 4) + 4 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
 if (!i6) return;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i9 + -1;
 i1 = i8 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - i3 | 0;
 if ((1 - i9 - i4 + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37304 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 2048)) {
   if (!(i4 & 512)) {
    if (!(i4 & 1048576)) {
     HEAP32[i11 >> 2] = 0;
     break;
    }
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i11 >> 2] = __Z11StringToIntPKc(i1) | 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 1024 | 0) {
     d2 = +(HEAP32[i1 >> 2] | 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   HEAP32[i11 >> 2] = ~~d2 >>> 0;
  } else HEAP32[i11 >> 2] = HEAP32[i1 >> 2]; while (0);
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_10MemLabelId17TransferMetaFlags(i11, i8, i2, i1) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i11 + 40 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 + 16 >> 2] | 0;
 if (!i1) {
  __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i8, 0, i2);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i8, HEAP32[i10 + 4 >> 2] | 0, i2);
 i7 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1 + (i7 * 24 | 0) | 0;
 if (i7 | 0) {
  i4 = HEAP32[gb + 36980 >> 2] | 0;
  i5 = i11 + 20 | 0;
  i6 = i11 + 56 | 0;
  i7 = i11 + 44 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i8 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 3) + 4 | 0;
   HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2, gb + 1084155 | 0, 1, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 4 | 0, gb + 1086064 | 0, 1, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 8 | 0, gb + 1085890 | 0, 1, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i11, i2 + 12 | 0, gb + 1085926 | 0, 1, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i9 >> 2] = i10;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i10 + 12 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i5 = 0; else {
  i5 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i9 * 24 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + (i1 * 24 | 0) | 0;
 i8 = i10 + 4 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i5 + (i1 * 24 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i10 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 >> 2] = i9;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + 1;
 return i5 + (i10 * 24 | 0) | 0;
}

function __ZN5physx3Ext20ProfileZoneInterface17handleBufferFlushEPKhj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = i5 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i5 + 52 >> 0] | 0)) {
  __ZN5physx21PxProfileEventHandler16parseEventBufferEPKhjRS0_b(i3, i4, i1 + 8 | 0, 0);
  return;
 }
 i10 = i1 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + 44 >> 2] = i5;
 __ZN5physx21PxProfileEventHandler16parseEventBufferEPKhjRS0_b(i3, i4, i9 + 8 | 0, 0);
 i9 = HEAP32[i2 >> 2] | 0;
 i5 = i9 + 8 | 0;
 i2 = HEAP32[i9 + 92 >> 2] | 0;
 if (!i2) i1 = i9 + 36 | 0; else {
  i6 = i9 + 88 | 0;
  i7 = i9 + 12 | 0;
  i1 = i9 + 36 | 0;
  i8 = i9 + 32 | 0;
  do {
   i2 = i2 + -1 | 0;
   i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i5, i4, i7);
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) do {
    i3 = i3 + -1 | 0;
    __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i5, i4, (HEAP32[i8 >> 2] | 0) + (i3 * 20 | 0) | 0);
   } while ((i3 | 0) != 0);
   __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE(i5, i4);
  } while ((i2 | 0) != 0);
 }
 HEAP32[i9 + 24 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i9 + 32 >> 2] | 0;
  do {
   i1 = i1 + -1 | 0;
   HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
  } while ((i1 | 0) != 0);
 }
 HEAP32[i9 + 52 >> 2] = 0;
 HEAP32[i9 + 44 >> 2] = 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 return;
}

function __ZN5physx2Sq17SceneQueryManager11preallocateEjj(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i8 + 28 | 0;
 i5 = i8 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 << 5 >>> 0 < i7 >>> 0) {
  i6 = (i7 + 31 | 0) >>> 5;
  if (i6 >>> 0 > (i1 & 2147483647) >>> 0) {
   i3 = i8 + 36 | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i6 << 2, gb + 769739 | 0, 329) | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i4 >> 2] | 0);
   }
   i3 = HEAP32[i5 >> 2] | 0;
   _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i6 - i3 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i6;
  }
 }
 i4 = i8 + 40 | 0;
 i5 = i8 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 << 5 >>> 0 < i9 >>> 0) {
  i6 = (i9 + 31 | 0) >>> 5;
  if (i6 >>> 0 > (i1 & 2147483647) >>> 0) {
   i1 = i8 + 48 | 0;
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i6 << 2, gb + 769739 | 0, 329) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    _memcpy(i2 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i4 >> 2] | 0);
   }
   i3 = HEAP32[i5 >> 2] | 0;
   _memset(i2 + ((i3 & 2147483647) << 2) | 0, 0, i6 - i3 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i5 >> 2] = i6;
  }
 }
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i7 | 0);
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i9 | 0);
 return;
}

function __ZN5physx2Sc5Scene5solveEfPNS_10PxBaseTaskE(i12, f1, i11) {
 i12 = i12 | 0;
 f1 = Math_fround(f1);
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 if (!(f1 != Math_fround(0.0))) return;
 HEAPF32[i12 + 64 >> 2] = f1;
 i6 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 i8 = i12 + 68 | 0;
 HEAPF32[i8 >> 2] = i6 ? f1 : Math_fround(0.0);
 i6 = HEAP32[i12 + 1204 >> 2] | 0;
 i9 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i6 + (i9 << 2) | 0;
 if (i9 | 0) {
  i10 = 0;
  i2 = i6 + 64 | 0;
  do {
   if (i2 >>> 0 < i7 >>> 0) {
    i5 = HEAP32[i2 >> 2] | 0;
    i4 = i5;
    i14 = _bitshift64Lshr(i4 | 0, 0, 6) | 0;
    i13 = getTempRet0() | 0;
    i4 = _i64Add(i4 | 0, 0, 1023, 0) | 0;
    i4 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, 6) | 0;
    i3 = getTempRet0() | 0;
    i13 = _i64Subtract(1, 0, i14 | 0, i13 | 0) | 0;
    i3 = _i64Add(i13 | 0, getTempRet0() | 0, i4 | 0, i3 | 0) | 0;
    i4 = getTempRet0() | 0;
    while (1) {
     i3 = _i64Add(i3 | 0, i4 | 0, -1, -1) | 0;
     i4 = getTempRet0() | 0;
     if ((i3 | 0) == 0 & (i4 | 0) == 0) break; else i5 = i5 + 64 | 0;
    }
    i2 = i2 + 4 | 0;
   }
   __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(HEAP32[i6 + (i10 << 2) >> 2] | 0, Math_fround(HEAPF32[i8 >> 2]));
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i9 | 0));
 }
 i2 = i12 + 2304 | 0;
 HEAP32[i12 + 2320 >> 2] = 1;
 i3 = i12 + 2316 | 0;
 HEAP32[i3 >> 2] = i11;
 if (i11 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0);
  HEAP32[i12 + 2312 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP16[((HEAP32[i8 + 4 >> 2] | 0) == (i9 | 0) ? i8 + 16 | 0 : i8 + 18 | 0) >> 1] | 0;
 i6 = i7 & 65535;
 if (i7 << 16 >> 16 == -1) return;
 i2 = i9 + 44 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 do if ((i7 & 65535) < (i1 & 65535)) {
  i5 = i1 + -1 << 16 >> 16;
  HEAP16[i2 >> 1] = i5;
  i2 = i5 & 65535;
  i3 = i9 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i4 + (i2 << 2) >> 2];
  i4 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 + (i6 << 2) >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i9 | 0)) HEAP16[i1 + 16 >> 1] = i7; else HEAP16[i1 + 18 >> 1] = i7;
  i6 = i9 + 28 | 0;
  i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i4 + (i7 << 2) >> 2];
  if (i2 >>> 0 < i7 >>> 0) {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) == (i9 | 0)) {
    HEAP16[i1 + 16 >> 1] = i5;
    break;
   } else {
    HEAP16[i1 + 18 >> 1] = i5;
    break;
   }
  }
 } else {
  i1 = i9 + 28 | 0;
  i5 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
  HEAP32[i1 >> 2] = i5;
  i1 = i9 + 20 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
  if (i6 >>> 0 < i5 >>> 0) {
   i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if ((HEAP32[i1 + 4 >> 2] | 0) == (i9 | 0)) {
    HEAP16[i1 + 16 >> 1] = i7;
    break;
   } else {
    HEAP16[i1 + 18 >> 1] = i7;
    break;
   }
  }
 } while (0);
 if ((HEAPU8[i8 + 20 >> 0] | 0) >= 2) return;
 i9 = i9 + 48 | 0;
 HEAP16[i9 >> 1] = (HEAP16[i9 >> 1] | 0) + -1 << 16 >> 16;
 return;
}

function __ZN5physx18PxFixedJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i8 | 0, i9 | 0, 84, (i1 ? gb + 735722 | 0 : gb + 837976 | 0) | 0, gb + 735840 | 0, 44) | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0) | 0;
 HEAP16[i1 + 4 >> 1] = 259;
 HEAP16[i1 + 6 >> 1] = 3;
 i9 = i1 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i8 = i1 + 76 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87952 + 8;
 HEAP32[i9 >> 2] = gb + 87952 + 188;
 i10 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 80, gb + 735925 | 0, 76) | 0;
 HEAP32[i1 + 80 >> 2] = i10;
 HEAPF32[i10 + 72 >> 2] = Math_fround(1.0e10);
 HEAPF32[i10 + 76 >> 2] = Math_fround(3.14159274);
 __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_(i1, i10, i2, i4, i3, i5);
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, i2 | 0, i3 | 0, i9 | 0, gb + 87932 | 0, 80) | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 | 0) {
  i10 = i1;
  STACKTOP = i7;
  return i10 | 0;
 }
 if (!i1) {
  i10 = 0;
  STACKTOP = i7;
  return i10 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i10 = 0;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN10VertexDataC2ERKS_j(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i2 = i9 + 16 | 0;
 i3 = i6 + 100 | 0;
 i4 = i6;
 i5 = i4 + 100 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP8[i3 >> 0] = 1;
 i3 = HEAP32[i7 + 92 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 44 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 56 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 + 68 >> 2];
 HEAP16[i2 >> 1] = HEAP16[i7 + 2 >> 1] | 0;
 HEAP16[i2 + 2 >> 1] = HEAP16[i7 + 6 >> 1] | 0;
 HEAP16[i2 + 4 >> 1] = HEAP16[i7 + 10 >> 1] | 0;
 HEAP16[i2 + 6 >> 1] = HEAP16[i7 + 14 >> 1] | 0;
 HEAP16[i2 + 8 >> 1] = HEAP16[i7 + 18 >> 1] | 0;
 HEAP16[i2 + 10 >> 1] = HEAP16[i7 + 22 >> 1] | 0;
 HEAP16[i2 + 12 >> 1] = HEAP16[i7 + 26 >> 1] | 0;
 HEAP16[i2 + 14 >> 1] = HEAP16[i7 + 30 >> 1] | 0;
 __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i6, i3, i8, 0, i1, i2);
 i1 = i6 + 96 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (i3 | 0) _memset(i3 | 0, 0, i2 | 0) | 0;
 HEAP32[i6 + 84 >> 2] = i3;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i7 + 84 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i7 + 96 >> 2] | 0)) {
  _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph(HEAP32[i6 + 92 >> 2] | 0, i8, i7 + 32 | 0, i7, i2, i6 + 32 | 0, i6, i3);
  STACKTOP = i9;
  return;
 }
}

function __Z48Renderer_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i5 = i6 + 8 | 0;
 if (!i4) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i7 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (HEAP16[i1 + 218 >> 1] | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i5, gb + 517380 | 0, i2);
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 517579 | 0, 1965, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i7;
 HEAP32[i5 + 12 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZN8Renderer13SetLightmapSTERK8Vector4f12LightmapType(i1, i5, 0);
  STACKTOP = i6;
  return;
 }
}

function __Z29RemoteSettings_CUSTOM_GetBoolP12Il2CppStringh(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 48 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i5 = (__Z21GetUnityConnectClientv() | 0) + 768 | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i2);
 i2 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i4 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 15) {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i8 + 4 >> 2] = i4;
  i1 = (i11 | 0) == 0 ? i1 : i11;
 }
 _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i3 >> 2] = i4;
 i1 = (__ZN11UnityEngine7Connect14RemoteSettings7GetBoolERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb(i5, i8, i6 << 24 >> 24 != 0) | 0) & 1;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 if (!(HEAP32[i8 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __Z13CopyAnimationR13AnimationClipS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i2 + 100 | 0, HEAP32[i1 + 100 >> 2] | 0, HEAP32[i1 + 104 >> 2] | 0);
 __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i2 + 116 | 0, HEAP32[i1 + 116 >> 2] | 0, HEAP32[i1 + 120 >> 2] | 0);
 __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i2 + 132 | 0, HEAP32[i1 + 132 >> 2] | 0, HEAP32[i1 + 136 >> 2] | 0);
 __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i2 + 148 | 0, HEAP32[i1 + 148 >> 2] | 0, HEAP32[i1 + 152 >> 2] | 0);
 __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_(i2 + 164 | 0, HEAP32[i1 + 164 >> 2] | 0, HEAP32[i1 + 168 >> 2] | 0);
 return;
}

function _LzmaDec_Allocate(i11, i2, i1, i9) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 if (i1 >>> 0 < 5) {
  i11 = 4;
  return i11 | 0;
 }
 i8 = (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0) | (HEAPU8[i2 + 3 >> 0] | 0) << 16 | (HEAPU8[i2 + 4 >> 0] | 0) << 24;
 i8 = i8 >>> 0 < 4096 ? 4096 : i8;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 & 255) > 224) {
  i11 = 4;
  return i11 | 0;
 }
 i6 = ((i1 & 255) % 9 | 0) & 255;
 i7 = ((i1 & 255) / 45 | 0) & 255;
 i5 = ((((i1 & 255) / 9 | 0) & 255) % 5 | 0) & 255;
 i2 = (768 << i5 + i6) + 1846 | 0;
 i4 = i11 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = i11 + 84 | 0;
 if (!i3) i10 = 5; else if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) i10 = 5;
 if ((i10 | 0) == 5) {
  mftCall_vii(HEAP32[i9 + 4 >> 2] | 0, i9 | 0, i3 | 0);
  HEAP32[i4 >> 2] = 0;
  i3 = mftCall_iii(HEAP32[i9 >> 2] | 0, i9 | 0, i2 << 1 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  if (!i3) {
   i11 = 2;
   return i11 | 0;
  }
 }
 i2 = i11 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i10 = 8; else {
  i1 = i11 + 40 | 0;
  if ((i8 | 0) != (HEAP32[i1 >> 2] | 0)) i10 = 8;
 }
 do if ((i10 | 0) == 8) {
  i1 = i9 + 4 | 0;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i9 | 0, i3 | 0);
  HEAP32[i2 >> 2] = 0;
  i10 = mftCall_iii(HEAP32[i9 >> 2] | 0, i9 | 0, i8 | 0) | 0;
  HEAP32[i2 >> 2] = i10;
  if (i10 | 0) {
   i1 = i11 + 40 | 0;
   break;
  }
  mftCall_vii(HEAP32[i1 >> 2] | 0, i9 | 0, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  i11 = 2;
  return i11 | 0;
 } while (0);
 HEAP32[i1 >> 2] = i8;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i11 + 8 >> 2] = i7;
 HEAP32[i11 + 12 >> 2] = i8;
 i11 = 0;
 return i11 | 0;
}

function __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i9, i6, i10, i1, i2, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i11 = HEAP32[i9 >> 2] | 0;
 if (!i11) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i4 = i6;
 i3 = i1 - i4 | 0;
 i5 = i2 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i2 = (i2 | 0) > (i3 | 0) ? i2 - i3 | 0 : 0;
 i3 = i10;
 i4 = i3 - i4 | 0;
 if ((i4 | 0) > 0) if ((mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, i6 | 0, i4 | 0) | 0) != (i4 | 0)) {
  HEAP32[i9 >> 2] = 0;
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 do if ((i2 | 0) > 0) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i8, i2, i7);
  if ((mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, ((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0, i2 | 0) | 0) == (i2 | 0)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   break;
  }
  HEAP32[i9 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 } while (0);
 i1 = i1 - i3 | 0;
 if ((i1 | 0) > 0) if ((mftCall_iiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 48 >> 2] | 0, i11 | 0, i10 | 0, i1 | 0) | 0) != (i1 | 0)) {
  HEAP32[i9 >> 2] = 0;
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i11, i12, i13, i14) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 i1 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i12) return;
 i4 = i1 + 96 | 0;
 i5 = i1 + 112 | 0;
 i6 = i1 + 128 | 0;
 i7 = i1 + 100 | 0;
 i8 = i1 + 116 | 0;
 i9 = i1 + 132 | 0;
 i10 = i1 + 104 | 0;
 i3 = i1 + 120 | 0;
 i1 = i1 + 136 | 0;
 i2 = 0;
 do {
  i20 = HEAPU8[i11 + i2 >> 0] | 0;
  f19 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) + 8 >> 2]);
  f17 = Math_fround(f19 * Math_fround(HEAPF32[i4 >> 2]));
  f17 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i5 >> 2])));
  f17 = Math_fround(f17 + Math_fround(f15 * Math_fround(HEAPF32[i6 >> 2])));
  f16 = Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f18 * Math_fround(HEAPF32[i8 >> 2])));
  f16 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i9 >> 2])));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i10 >> 2]));
  f18 = Math_fround(f19 + Math_fround(f18 * Math_fround(HEAPF32[i3 >> 2])));
  f15 = Math_fround(f18 + Math_fround(f15 * Math_fround(HEAPF32[i1 >> 2])));
  HEAPF32[i14 + (i2 << 4) >> 2] = f17;
  HEAPF32[i14 + (i2 << 4) + 4 >> 2] = f16;
  HEAPF32[i14 + (i2 << 4) + 8 >> 2] = f15;
  HEAPF32[i14 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i12 | 0));
 return;
}

function __ZN10MemoryPool14AllocNewBubbleEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!(HEAP8[i11 + 36 >> 0] | 0)) return;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 + 4 >> 2] | 0, HEAP32[i11 + 40 >> 2] | 0, i11 + 44 | 0, 0, gb + 488467 | 0, 100) | 0;
 i3 = i1;
 i4 = i11 + 12 | 0;
 i5 = i11 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i11 + 28 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i7 >>> 0 > i10 >>> 0) {
  i2 = i9 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i2;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 2, 4, i11 + 16 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i11 + 16 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i4 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i3;
 i6 = i11 + 32 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i11 + 8 >> 2] | 0;
 if ((i2 | 0) > 1) {
  i5 = HEAP32[i11 >> 2] | 0;
  i4 = i2 + -1 | 0;
  i2 = i1;
  i3 = 0;
  while (1) {
   i1 = i2 + i5 | 0;
   HEAP32[i2 >> 2] = i1;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i4 | 0)) break; else i2 = i1;
  }
 }
 HEAP32[i1 >> 2] = i7;
 if (HEAP32[i6 >> 2] | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 488727 | 0, 0, gb + 488467 | 0, 123, 1, 0, 0, 0);
 return;
}

function __Z34Terrain_Get_Custom_PropTerrainDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z34Joint_Get_Custom_PropConnectedBodyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z34Application_CUSTOM_GetValueForARGVP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 24 | 0;
 i6 = i7 + 12 | 0;
 i3 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i2);
 i5 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (i5) {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i2);
  __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i5 = i6 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i2;
  if ((HEAP32[i5 >> 2] | 0) == (i2 | 0)) {
   i3 = 1;
   i4 = 0;
  } else {
   i4 = HEAP8[i2 + 11 >> 0] | 0;
   i3 = i4 << 24 >> 24 < 0;
   i4 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i1 >> 2] | 0 : i2, i3 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255) | 0;
   i3 = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i8 = i2 + -12 | 0;
     HEAP32[i5 >> 2] = i8;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
     i2 = HEAP32[i5 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i6 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  if (!i3) {
   i8 = i4;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i8 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function _UNITY_png_destroy_gamma_table(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 488 | 0;
 _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 492 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i5 = 8 - (HEAP32[i4 + 480 >> 2] | 0) | 0;
  i2 = 1 << i5;
  if ((i5 | 0) != 31) {
   _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
   if ((i2 | 0) > 1) {
    i1 = 1;
    do {
     _UNITY_png_free(i4, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i2 | 0));
   }
   i1 = HEAP32[i3 >> 2] | 0;
  }
  _UNITY_png_free(i4, i1);
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i4 + 496 | 0;
 _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 500 | 0;
 _UNITY_png_free(i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 504 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i5 = 8 - (HEAP32[i4 + 480 >> 2] | 0) | 0;
  i2 = 1 << i5;
  if ((i5 | 0) != 31) {
   _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
   if ((i2 | 0) > 1) {
    i1 = 1;
    do {
     _UNITY_png_free(i4, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i2 | 0));
   }
   i1 = HEAP32[i3 >> 2] | 0;
  }
  _UNITY_png_free(i4, i1);
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i4 + 508 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 i5 = 8 - (HEAP32[i4 + 480 >> 2] | 0) | 0;
 i2 = 1 << i5;
 if ((i5 | 0) != 31) {
  _UNITY_png_free(i4, HEAP32[i1 >> 2] | 0);
  if ((i2 | 0) > 1) {
   i1 = 1;
   do {
    _UNITY_png_free(i4, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
  }
  i1 = HEAP32[i3 >> 2] | 0;
 }
 _UNITY_png_free(i4, i1);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNK13sorted_vectorIN22BuiltinResourceManager8ResourceENSt3__24lessIS1_EENS2_9allocatorIS1_EEE4findIS1_EENS2_11__wrap_iterIPKS1_EERKT_(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i11 - i3 | 0;
 i1 = (i9 | 0) / 24 | 0;
 L1 : do if (!i9) i1 = i3; else {
  i9 = HEAP32[i10 >> 2] | 0;
  i6 = HEAP32[i10 + 4 >> 2] | 0;
  i7 = i6 + 16 | 0;
  if (!i6) {
   i5 = i1;
   i1 = i3;
   i2 = i3;
   while (1) {
    i8 = (i5 | 0) / 2 | 0;
    i4 = i2 + (i8 * 24 | 0) | 0;
    i3 = (_strcmp(HEAP32[i4 >> 2] | 0, i9) | 0) < 0;
    i4 = i4 + 24 | 0;
    i1 = i3 ? i4 : i1;
    i5 = i3 ? i5 + -1 - i8 | 0 : i8;
    if (!i5) break L1; else i2 = i3 ? i4 : i2;
   }
  } else {
   i2 = i1;
   i1 = i3;
  }
  do {
   i5 = (i2 | 0) / 2 | 0;
   i6 = i3 + (i5 * 24 | 0) | 0;
   i4 = _strcmp(HEAP32[i6 >> 2] | 0, i9) | 0;
   if (!i4) {
    i4 = HEAP32[i3 + (i5 * 24 | 0) + 4 >> 2] | 0;
    if (!i4) i8 = 9; else if ((HEAP32[i4 + 16 >> 2] | 0) < (HEAP32[i7 >> 2] | 0)) i8 = 9; else i2 = i5;
   } else if ((i4 | 0) < 0) i8 = 9; else i2 = i5;
   if ((i8 | 0) == 9) {
    i8 = 0;
    i3 = i6 + 24 | 0;
    i2 = i2 + -1 - i5 | 0;
    i1 = i3;
   }
  } while ((i2 | 0) != 0);
 } while (0);
 do if ((i1 | 0) != (i11 | 0)) {
  i2 = _strcmp(HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  if (i2 | 0) {
   if ((i2 | 0) < 0) break;
   return i1 | 0;
  }
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i3) {
   i11 = i1;
   return i11 | 0;
  }
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) >= (HEAP32[i3 + 16 >> 2] | 0)) {
   i11 = i1;
   return i11 | 0;
  }
 } while (0);
 return i11 | 0;
}

function __ZN5physx7NpShape8requiresERNS_23PxProcessPxBaseCallbackE(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i3 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = i1 + 32 | 0;
   i2 = 11;
   break;
  }
 case 6:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = i1 + 4 | 0;
   i2 = 11;
   break;
  }
 case 5:
  {
   if (HEAP32[i3 + 36 >> 2] & 1) i1 = (HEAP32[i3 + 40 >> 2] | 0) + 56 | 0;
   i1 = i1 + 36 | 0;
   i2 = 11;
   break;
  }
 default:
  {}
 }
 if ((i2 | 0) == 11) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i1 | 0);
 }
 i6 = i3 + 36 | 0;
 if (!(HEAP32[i6 >> 2] & 2)) i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i3 + 48 | 0) | 0; else i1 = HEAP16[(HEAP32[i3 + 40 >> 2] | 0) + 116 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i7 = i3 + 48 | 0;
 i8 = i3 + 40 | 0;
 i5 = i3 + 32 | 0;
 i3 = i1 & 65535;
 i4 = 0;
 do {
  i2 = HEAP32[gb + 1457324 >> 2] | 0;
  if (!(HEAP32[i6 >> 2] & 2)) {
   i1 = HEAPU16[(__ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i7) | 0) + (i4 << 1) >> 1] | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) | 0;
  } else {
   i1 = HEAP32[i8 >> 2] | 0;
   if ((HEAP16[i1 + 116 >> 1] | 0) == 1) i1 = i1 + 112 | 0; else i1 = (HEAP32[(HEAP32[i5 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] << 1) | 0;
   i1 = (HEAP32[i2 + 52 >> 2] | 0) + (HEAPU16[i1 + (i4 << 1) >> 1] << 2) | 0;
  }
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, HEAP32[i1 >> 2] | 0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __ZN16PlayerConnection21ConstructWhoamiStringEv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i4 = i9;
 i7 = i9 + 64 | 0;
 i2 = i9 + 52 | 0;
 i3 = i9 + 40 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = i6 + 168 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN10systeminfo24GetRuntimePlatformStringEv(i3);
 HEAP32[i4 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 HEAP32[i4 + 4 >> 2] = i1;
 __Z6FormatPKcz(i2, gb + 460276 | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (!(HEAP8[gb + 1546600 >> 0] | 0)) i2 = (HEAP8[i6 + 148 >> 0] | 0) != 0; else i2 = 1;
 i1 = i6 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i12 = HEAPU16[i6 + 164 >> 1] | 0;
 i11 = HEAP32[i6 + 136 >> 2] | 0;
 i10 = HEAP32[i6 + 212 >> 2] | 0;
 i3 = HEAP32[gb + 65596 >> 2] | 0;
 i4 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = HEAP32[i6 + 216 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i8 + 8 >> 2] = i2 & 1 | 2;
 HEAP32[i8 + 12 >> 2] = i11;
 HEAP32[i8 + 16 >> 2] = i10;
 HEAP32[i8 + 20 >> 2] = i3;
 HEAP32[i8 + 24 >> 2] = i4;
 HEAP32[i8 + 28 >> 2] = i6;
 __Z6FormatPKcz(i5, gb + 459520 | 0, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __Z33Projector_Get_Custom_PropMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 64 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN6Camera18ApplyRenderTextureEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 44 | 0;
 i4 = i9 + 40 | 0;
 i5 = i9 + 8 | 0;
 i8 = i9;
 i1 = i6 + 1144 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) HEAP32[i4 >> 2] = 0; else HEAP32[i4 >> 2] = HEAP32[i2 + 128 >> 2];
 i3 = i6 + 748 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 if (!(HEAP32[i5 >> 2] | 0)) {
  i3 = __Z12GetGfxDevicev() | 0;
  HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 368 >> 2] | 0, i3 | 0) | 0;
 }
 i2 = HEAP32[i6 + 784 >> 2] | 0;
 if (!i2) {
  i2 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 372 >> 2] | 0, i2 | 0) | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i10 = (i3 | 0) != 0;
 i4 = i10 ? i4 : i5;
 if (i10) {
  i2 = HEAP32[i3 + 136 >> 2] | 0;
  i3 = 1;
 } else {
  i10 = i6 + 788 | 0;
  i3 = HEAP32[i6 + 780 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  i1 = i10;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(i3, i4, i7, i1, 0, -1, 0, 1) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 i10 = (HEAP8[i1 + 31 >> 0] | 0) != 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 614;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i3) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9, i3);
 __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9 + 100 | 0, i3);
 __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9 + 32 | 0, i3);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i3, i9 + 36 | 0, 0);
 i8 = i9 + 28 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 12 | 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 __ZN10GISettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i9 + 76 | 0, i3);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP32[i9 + 236 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = (HEAP32[i8 >> 2] | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 HEAP8[i9 + 96 >> 0] = 1;
 HEAP8[i9 + 97 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN13b2PulleyJointC2EPK16b2PulleyJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152476 + 8;
 i6 = i2 + 20 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i1 + 68 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i2 + 28 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 76 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i2 + 36 | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i1 + 92 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i2 + 44 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 100 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = HEAP32[i2 + 52 >> 2] | 0;
 HEAP32[i1 + 84 >> 2] = i6;
 i3 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i1 + 88 >> 2] = i3;
 f4 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 HEAPF32[i1 + 112 >> 2] = f4;
 f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i1 + 108 >> 2] = Math_fround(f5 + Math_fround(f4 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 return;
}

function __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 switch (HEAP16[i2 + 152 >> 1] | 0) {
 case 0:
  {
   i5 = HEAP32[i2 + 148 >> 2] | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i1 + 12 >> 2] = i5;
   STACKTOP = i6;
   return;
  }
 case 1:
  {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i3);
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
   f8 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
   i4 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
   HEAP32[i5 >> 2] = ~~f9;
   HEAP32[i5 + 4 >> 2] = ~~f8;
   HEAP32[i5 + 8 >> 2] = ~~f7;
   HEAP32[i5 + 12 >> 2] = i4;
   __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i1, i2 + 144 | 0, i2 + 148 | 0, i5);
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4);
   STACKTOP = i6;
   return;
  }
 default:
  if (!(HEAP32[i2 + 68 >> 2] | 0)) {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  } else {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  }
 }
}

function __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 switch (HEAP16[i2 + 152 >> 1] | 0) {
 case 0:
  {
   i5 = HEAP32[i2 + 148 >> 2] | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i1 + 12 >> 2] = i5;
   STACKTOP = i6;
   return;
  }
 case 1:
  {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i3);
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
   f8 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
   i4 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
   HEAP32[i5 >> 2] = ~~f9;
   HEAP32[i5 + 4 >> 2] = ~~f8;
   HEAP32[i5 + 8 >> 2] = ~~f7;
   HEAP32[i5 + 12 >> 2] = i4;
   __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i1, i2 + 144 | 0, i2 + 148 | 0, i5);
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4);
   STACKTOP = i6;
   return;
  }
 default:
  if (!(HEAP32[i2 + 68 >> 2] | 0)) {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  } else {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  }
 }
}

function __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 switch (HEAP16[i2 + 152 >> 1] | 0) {
 case 0:
  {
   i5 = HEAP32[i2 + 148 >> 2] | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i1 + 12 >> 2] = i5;
   STACKTOP = i6;
   return;
  }
 case 1:
  {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i3);
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
   f8 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
   i4 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
   HEAP32[i5 >> 2] = ~~f9;
   HEAP32[i5 + 4 >> 2] = ~~f8;
   HEAP32[i5 + 8 >> 2] = ~~f7;
   HEAP32[i5 + 12 >> 2] = i4;
   __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i1, i2 + 144 | 0, i2 + 148 | 0, i5);
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4);
   STACKTOP = i6;
   return;
  }
 default:
  if (!(HEAP32[i2 + 68 >> 2] | 0)) {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  } else {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  }
 }
}

function __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 switch (HEAP16[i2 + 152 >> 1] | 0) {
 case 0:
  {
   i5 = HEAP32[i2 + 148 >> 2] | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i5;
   HEAP32[i1 + 12 >> 2] = i5;
   STACKTOP = i6;
   return;
  }
 case 1:
  {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i3);
   STACKTOP = i6;
   return;
  }
 case 2:
  {
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(255.0));
   f8 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(255.0));
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * Math_fround(255.0));
   i4 = ~~Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) * Math_fround(255.0));
   HEAP32[i5 >> 2] = ~~f9;
   HEAP32[i5 + 4 >> 2] = ~~f8;
   HEAP32[i5 + 8 >> 2] = ~~f7;
   HEAP32[i5 + 12 >> 2] = i4;
   __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i1, i2 + 144 | 0, i2 + 148 | 0, i5);
   STACKTOP = i6;
   return;
  }
 case 3:
  {
   __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_(i1, i2, i3, i4);
   STACKTOP = i6;
   return;
  }
 default:
  if (!(HEAP32[i2 + 68 >> 2] | 0)) {
   __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  } else {
   __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i1, i2, i4);
   STACKTOP = i6;
   return;
  }
 }
}

function __Z34FindRequiredComponentsForComponenti(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __Z25InitComponentRequirementsv();
 i8 = HEAP32[gb + 1162544 >> 2] | 0;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i5 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i7 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i4 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i7 | 0)) {
     i4 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i4 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i4 | 0) == 4) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i2 = i1;
   break;
  } else if ((i4 | 0) == 8) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i2 = i3;
   break;
  } else if ((i4 | 0) == 10) {
   HEAP32[i6 >> 2] = i1;
   if (!i1) {
    i5 = i1;
    i2 = i6;
    break;
   }
   i8 = i1 + 20 | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 } while (0);
 i3 = __Znwj(32) | 0;
 HEAP32[i3 + 16 >> 2] = i7;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i3;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z24Tree_Get_Custom_PropDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN4Tree11GetTreeDataEv(i2) | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5Unity12PhysicsQuery10RaycastAllERK3Rayfi23QueryTriggerInteraction(i7, i8, f9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1452608 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452608 | 0, i6);
  i1 = gb + 1452608 | 0;
 } else i1 = 0;
 i4 = i7 + 48 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i7 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i5 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -44 - i5 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i6 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i6 + 68 >> 0] = 0;
 HEAP32[i6 + 72 >> 2] = i7;
 HEAP32[i6 + 76 >> 2] = 128;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 113988 + 8;
 HEAP32[i6 + 84 >> 2] = i4;
 __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(0, i8, f9, i10, i11, i6);
 if (!i1) {
  STACKTOP = i12;
  return i4 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i12;
 return i4 | 0;
}

function __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 104 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 108 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 96 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i8 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine15CloudWebService13SessionHeader15RestoreFromFileER12FileAccessor(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = __ZNK12FileAccessor4SizeEv(i8) | 0;
 i11 = getTempRet0() | 0;
 if ((i10 | 0) == 0 & (i11 | 0) == 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i7 = i1 + 11 | 0;
 i5 = HEAP8[i7 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i5 & 255;
 do if (i10 >>> 0 > i2 >>> 0) {
  i6 = i10 - i2 | 0;
  if (i6 | 0) {
   if (i3) {
    i2 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0;
    i4 = HEAP32[i1 + 4 >> 2] | 0;
   } else {
    i2 = 10;
    i4 = i5 & 255;
   }
   if ((i2 - i4 | 0) >>> 0 < i6 >>> 0) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i1, i2, i6 - i2 + i4 | 0, i4, i4, 0, 0);
    i2 = HEAP8[i7 >> 0] | 0;
   } else i2 = i5;
   if (i2 << 24 >> 24 < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
   _memset(i3 + i4 | 0, 0, i6 | 0) | 0;
   i2 = i4 + i6 | 0;
   if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i1 + 4 >> 2] = i2; else HEAP8[i7 >> 0] = i2;
   HEAP8[i3 + i2 >> 0] = 0;
  }
 } else if (i3) {
  HEAP8[(HEAP32[i1 >> 2] | 0) + i10 >> 0] = 0;
  HEAP32[i1 + 4 >> 2] = i10;
  break;
 } else {
  HEAP8[i1 + i10 >> 0] = 0;
  HEAP8[i7 >> 0] = i10;
  break;
 } while (0);
 i6 = i9;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i11 = __ZN12FileAccessor4ReadEyPvPy(i8, i10, i11, i1, i9) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK8Material11GetPassNameEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 i5 = i7 + 20 | 0;
 i1 = __ZNK8Material9GetShaderEv(i3) | 0;
 if (!i1) {
  i6 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i6;
  __Z6FormatPKcz(i5, gb + 477586 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 469775 | 0, 677, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i6 = gb + 1576256 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (HEAP32[i1 + 48 >> 2] << 2) >> 2] | 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i4 | 0) > -1 & (i2 | 0) > (i4 | 0))) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[i6 + 8 >> 2] = i2;
  __Z6FormatPKcz(i5, gb + 477645 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 469775 | 0, 684, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i6 = gb + 1576256 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = (HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 728 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali(i6, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i17;
 i15 = HEAP32[i2 + 8 >> 2] | 0;
 i16 = HEAP32[i2 >> 2] | 0;
 i14 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = HEAP32[i3 + 8 >> 2] | 0;
 i13 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i4) i10 = 0; else i10 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i5 & 65535;
 i2 = i1 + 2 | 0;
 i3 = i2 + 20 | 0;
 do {
  HEAP16[i2 >> 1] = 0;
  i2 = i2 + 2 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i7 = i6 + 8 | 0;
 i8 = i6 + 24 | 0;
 i5 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i4 = i5 + 4 | 0;
 i2 = i6 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i5, i4);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 i4 = i6 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + i5 >> 2] = 7;
 i5 = i5 + 7 & -4;
 i6 = i5 + 52 | 0;
 if (i6 >>> 0 > i3 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i7, i5, i6);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i6;
 i2 = i2 + i5 | 0;
 HEAP32[i2 >> 2] = i15;
 HEAP32[i2 + 4 >> 2] = i16;
 HEAP32[i2 + 8 >> 2] = i14;
 HEAP32[i2 + 12 >> 2] = i12;
 HEAP32[i2 + 16 >> 2] = i13;
 HEAP32[i2 + 20 >> 2] = i11;
 HEAP32[i2 + 24 >> 2] = i10;
 HEAP16[i2 + 28 >> 1] = i9;
 i2 = i2 + 30 | 0;
 i3 = i2 + 22 | 0;
 do {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  i2 = i2 + 2 | 0;
  i1 = i1 + 2 | 0;
 } while ((i2 | 0) < (i3 | 0));
 STACKTOP = i17;
 return;
}

function __ZN14PhysicsManager10RaycastAllERK3Rayfi23QueryTriggerInteraction(i7, i8, f9, i10, i11) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1452608 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452608 | 0, i6);
  i1 = gb + 1452608 | 0;
 } else i1 = 0;
 i4 = i7 + 784 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i7 + 788 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i5 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -44 - i5 | 0) >>> 0) / 44 | 0) * 44 | 0);
 i7 = HEAP32[i7 + 748 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP16[i6 + 16 >> 1] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i6 + 44 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i6 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 52 >> 2] = Math_fround(0.0);
 HEAP8[i6 + 68 >> 0] = 0;
 HEAP32[i6 + 72 >> 2] = i7;
 HEAP32[i6 + 76 >> 2] = 128;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 113988 + 8;
 HEAP32[i6 + 84 >> 2] = i4;
 __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE(0, i8, f9, i10, i11, i6);
 if (!i1) {
  STACKTOP = i12;
  return i4 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i12;
 return i4 | 0;
}

function __Z29Animation_Get_Custom_PropClipP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 280 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK18ProceduralMaterial19GetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if ((HEAP32[i1 + 88 >> 2] | 0) != 5) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = i1 + 84 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 11;
  }
 }
 if ((i6 | 0) == 9) i6 = 11;
 if ((i6 | 0) == 11) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_19GenericStringStreamIS2_EEEEjRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + 1 | 0;
 HEAP32[i7 >> 2] = i3;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24;
 do if ((i1 + -48 & 255) < 10) {
  i2 = i2 + -48 | 0;
  i4 = 8;
 } else {
  if ((i1 + -65 & 255) < 6) {
   i2 = i2 + -55 | 0;
   i4 = 8;
   break;
  }
  if ((i1 + -97 & 255) < 6) {
   i2 = i2 + -87 | 0;
   i4 = 8;
  } else i1 = i3;
 } while (0);
 L8 : do if ((i4 | 0) == 8) {
  i1 = i5 + 2 | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = HEAP8[i3 >> 0] | 0;
  i2 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  do if ((i3 + -48 & 255) < 10) i2 = i2 + -48 | 0; else {
   if ((i3 + -65 & 255) < 6) {
    i2 = i2 + -55 | 0;
    break;
   }
   if ((i3 + -97 & 255) >= 6) break L8;
   i2 = i2 + -87 | 0;
  } while (0);
  i4 = i5 + 3 | 0;
  HEAP32[i7 >> 2] = i4;
  i3 = HEAP8[i1 >> 0] | 0;
  i1 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  do if ((i3 + -48 & 255) < 10) i2 = i1 + -48 | 0; else {
   if ((i3 + -65 & 255) < 6) {
    i2 = i1 + -55 | 0;
    break;
   }
   if ((i3 + -97 & 255) >= 6) {
    i1 = i4;
    break L8;
   }
   i2 = i1 + -87 | 0;
  } while (0);
  i1 = i5 + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = HEAP8[i4 >> 0] | 0;
  i2 = (i3 << 24 >> 24) + (i2 << 4) | 0;
  if ((i3 + -48 & 255) < 10) {
   i7 = i2 + -48 | 0;
   return i7 | 0;
  }
  if ((i3 + -65 & 255) < 6) {
   i7 = i2 + -55 | 0;
   return i7 | 0;
  }
  if ((i3 + -97 & 255) < 6) {
   i7 = i2 + -87 | 0;
   return i7 | 0;
  }
 } while (0);
 i7 = i1 + -1 - (HEAP32[i7 + 4 >> 2] | 0) | 0;
 HEAP32[i6 + 24 >> 2] = 8;
 HEAP32[i6 + 28 >> 2] = i7;
 i7 = 0;
 return i7 | 0;
}

function __ZN9Animation14QueueCrossFadeER14AnimationStatefii(i7, i4, f3, i1, i2) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i8 = i9 + 8 | 0;
 i5 = __ZN9Animation14CloneAnimationEP14AnimationState(i7, i4) | 0;
 if (!i5) {
  i2 = HEAP32[gb + 176232 >> 2] | 0;
  i1 = i4 + 112 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  __Z6FormatPKcz(i8, i2, i6);
  if (!i7) i1 = 0; else i1 = HEAP32[i7 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 896407 | 0, 527, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = i5 + 56 | 0;
 HEAP16[i6 >> 1] = HEAP16[i6 >> 1] | 8;
 if (i1 | 0) {
  __ZN9Animation9CrossFadeER14AnimationStatefib(i7, i5, f3, i2, 1);
  i8 = i5;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAPF32[i8 + 8 >> 2] = f3;
 HEAP32[i8 + 12 >> 2] = i5;
 i1 = i7 + 320 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 + 324 >> 2] | 0)) __ZNSt3__26vectorI15QueuedAnimation13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i7 + 316 | 0, i8); else {
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
 }
 i8 = i5;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP16[i1 + 66 >> 1] = HEAP16[i8 >> 1] | 0;
 switch (i5 | 0) {
 case 5:
  {
   i5 = i1 + 116 | 0;
   i4 = i1 + 132 | 0;
   i2 = i1 + 120 | 0;
   i3 = i7 & 65535;
   if ((HEAPU16[i2 >> 1] | 0) < (i7 & 65535)) {
    i1 = HEAP32[i5 >> 2] | 0;
    if (!((i1 | 0) == 0 | (HEAP8[i4 >> 0] | 0) == 0)) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1);
     HEAP16[i2 >> 1] = 0;
    }
    i3 = i3 << 1;
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i3, gb + 687358 | 0, 90) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP16[i2 >> 1] = i7;
    HEAP8[i4 >> 0] = 1;
    i2 = i3;
   } else {
    i2 = i3 << 1;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   _memcpy(i1 | 0, i8 | 0, i2 | 0) | 0;
   STACKTOP = i9;
   return;
  }
 case 6:
  {
   i5 = i1 + 96 | 0;
   i4 = i1 + 132 | 0;
   i1 = i1 + 100 | 0;
   i2 = i7 & 65535;
   if ((HEAPU16[i1 >> 1] | 0) < (i7 & 65535)) {
    i3 = HEAP32[i5 >> 2] | 0;
    if (!((i3 | 0) == 0 | (HEAP8[i4 >> 0] | 0) == 0)) {
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i3);
     HEAP16[i1 >> 1] = 0;
    }
    i2 = i2 << 1;
    i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i2, gb + 687358 | 0, 90) | 0;
    HEAP32[i5 >> 2] = i6;
    HEAP16[i1 >> 1] = i7;
    HEAP8[i4 >> 0] = 1;
    i1 = i6;
   } else {
    i2 = i2 << 1;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   _memcpy(i1 | 0, i8 | 0, i2 | 0) | 0;
   STACKTOP = i9;
   return;
  }
 default:
  {
   STACKTOP = i9;
   return;
  }
 }
}

function __ZN5physx2Sc5Scene11removeShapeERNS0_8ShapeSimEb(i1, i9, i2) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 1424 + (HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + 68 >> 2] << 2) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 __ZN5physx2Sc8ShapeSim20removeFromBroadPhaseEb(i9, i2);
 i7 = HEAP32[i1 + 1212 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0);
 i8 = i7 + 24 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) i1 = i7 + 16 | 0; else {
  i1 = i7 + 16 | 0;
  __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j(HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 >> 2] | 0, i10 + 1 | 0, i10, 32);
 }
 i5 = Math_imul(HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 if ((i1 | 0) < 0) {
  STACKTOP = i10;
  return;
 }
 i6 = HEAP32[i7 + 12 >> 2] | 0;
 i2 = 0;
 i4 = i1;
 L8 : while (1) {
  while (1) {
   i1 = i2 + i4 >> 1;
   i3 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
   if (i3 >>> 0 <= i9 >>> 0 & (i3 + i5 | 0) >>> 0 > i9 >>> 0) {
    i2 = 8;
    break L8;
   }
   if (i3 >>> 0 >= i9 >>> 0) break;
   if ((i1 | 0) < (i4 | 0)) i2 = i1 + 1 | 0; else {
    i2 = 14;
    break L8;
   }
  }
  i1 = i1 + -1 | 0;
  if ((i2 | 0) > (i1 | 0)) {
   i2 = 14;
   break;
  } else i4 = i1;
 }
 if ((i2 | 0) == 8) {
  i6 = i6 + (i1 * 12 | 0) + 4 | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i9;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i7 + 8 >> 2] = i1;
  HEAP8[i8 >> 0] = 0;
  STACKTOP = i10;
  return;
 } else if ((i2 | 0) == 14) {
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx16PxsFluidDynamics23updateSubpacketPairHaloEPNS_6PxVec3EPNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjRbjS4_jS6_S7_RKS1_NS_16PxsSphUpdateTypeEPtRNS_27PxsFluidDynamicsTempBuffersE(i16, i2, i13, i6, i9, i11, i4, i5, i14, i7, i10, i12, i8, i17, i3, i15) {
 i16 = i16 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i14 = i14 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 var i1 = 0;
 if (i6 >>> 0 < 201 & i7 >>> 0 < 201) {
  i12 = HEAP32[i15 + 36 >> 2] | 0;
  __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj(i2, 0, i13, i14, i12, i6, i12, i7, 0, (i17 | 0) == 0, i16, HEAP32[i15 + 28 >> 2] | 0, HEAP32[i15 + 32 >> 2] | 0);
  return;
 }
 i1 = i16 + 12 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i13, i6, i9, i11, i3, i5, Math_fround(HEAPF32[i1 >> 2]), i8);
  HEAP8[i4 >> 0] = 1;
 }
 i4 = i7 + 1 | 0;
 i4 = i4 >>> 1 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = (i4 >>> 16 | i4) + 1 | 0;
 __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E(i14, i7, i10, i12, i3, i4, Math_fround(HEAPF32[i1 >> 2]), i8);
 __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb(i17, i2, 0, i13, i14, i9, i10, i11, i12, i5, i4, 0, i16, i15, i6 >>> 0 < i7 >>> 0);
 return;
}

function __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E10insert_oneERKS8_(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 4 | 0;
 i11 = i13;
 i12 = i1 + 4 | 0;
 i4 = HEAP32[i12 >> 2] | 0;
 i7 = i1 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i2 - i4 | 0;
 if (!i1) i3 = i4; else {
  i6 = i10 + 11 | 0;
  i5 = (i1 | 0) / 24 | 0;
  i3 = i4;
  i1 = i4;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i1 + (i14 * 24 | 0) | 0;
   i2 = (__Z7StrICmpPKcS0_((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10) | 0) < 0;
   i4 = i4 + 24 | 0;
   i3 = i2 ? i4 : i3;
   i5 = i2 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i1 = i2 ? i4 : i1;
  }
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i3;
 if ((i3 | 0) != (i2 | 0)) if ((__Z7StrICmpPKcS0_((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0) >= 0) {
  HEAP32[i9 >> 2] = i1;
  HEAP8[i9 + 4 >> 0] = 0;
  STACKTOP = i13;
  return;
 }
 HEAP32[i11 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 >> 2] = __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EE13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS8_EERSE_(i12, i8, i10) | 0;
 HEAP8[i9 + 4 >> 0] = 1;
 STACKTOP = i13;
 return;
}

function __ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB(i3, i1, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f2 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i8 = i1 + 236 | 0;
 if (!((HEAPU16[i8 >> 1] | HEAPU8[i8 + 2 >> 0] << 16) & 192)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (HEAP8[i3 + 4 >> 0] | 0) if ((HEAP32[i1 + 228 >> 2] & 65535) << 16 >> 16 != -1) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (!(HEAP32[i3 + 8 >> 2] & 1 << i4)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i1 + 812 + (i4 << 2) >> 2]);
 do if (f2 != Math_fround(0.0)) if (!(HEAP8[i1 + 940 >> 0] | 0)) {
  HEAP32[i6 >> 2] = HEAP32[i1 + 740 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 744 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 748 >> 2];
  HEAPF32[i6 + 12 >> 2] = Math_fround(f2 + Math_fround(HEAPF32[i1 + 560 >> 2]));
  if (__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i5, i6, 1) | 0) break; else i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 } else {
  f11 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i1 + 516 >> 2]));
  f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i1 + 520 >> 2]));
  f9 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i1 + 524 >> 2]));
  if (!(Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) + Math_fround(f9 * f9)) > Math_fround(f2 * f2))) break; else i1 = 0;
  STACKTOP = i7;
  return i1 | 0;
 } while (0);
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 5 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 32 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 5) + i2 | 0;
 if (i5 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 4;
 i3 = i6 >> 5 >>> 0 < 67108863 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 134217727;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 5) | 0;
 i6 = i5 + (i1 - i4 >> 5 << 5) | 0;
 i5 = i5 + (i3 << 5) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  i1 = i4 + 32 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 5) << 5) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN7dtCrowd9OccupyRefEy(i9, i6, i7) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i8 = i9 + 380 | 0;
 i2 = i9 + 384 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (i3 >>> 0 > i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 > i6 >>> 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if (!(i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i6 >>> 0)) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i10;
  return;
 }
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i8 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 384 >> 2] | 0, i1);
 i9 = i9 + 388 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 615;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx25contactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i3, i1, i6, i8, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 16 | 0;
 i5 = i7;
 i2 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAPU16[i3 + 10 >> 1] | 0) << 6);
 HEAP32[i1 + 4 >> 2] = i2 + ((HEAPU16[i3 + 42 >> 1] | 0) << 6);
 HEAP32[i1 + 8 >> 2] = i2 + ((HEAPU16[i3 + 74 >> 1] | 0) << 6);
 HEAP32[i1 + 12 >> 2] = i2 + ((HEAPU16[i3 + 106 >> 1] | 0) << 6);
 HEAP32[i5 >> 2] = i2 + ((HEAPU16[i3 + 14 >> 1] | 0) << 6);
 HEAP32[i5 + 4 >> 2] = i2 + ((HEAPU16[i3 + 46 >> 1] | 0) << 6);
 HEAP32[i5 + 8 >> 2] = i2 + ((HEAPU16[i3 + 78 >> 1] | 0) << 6);
 HEAP32[i5 + 12 >> 2] = i2 + ((HEAPU16[i3 + 110 >> 1] | 0) << 6);
 __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i3, i6, i1, i5);
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i6 + 12 >> 2] | 0) + -4 | 0) >>> 0) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i4, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i6 = i8 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN20SoundChannelInstance19set3DMinMaxDistanceEff(i2, f3, f4) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 20 | 0;
 i1 = i8 + 16 | 0;
 HEAPF32[i1 >> 2] = f3;
 i5 = HEAP32[i2 + 164 >> 2] | 0;
 i9 = (i5 | 0) == 0;
 i13 = i2 + 148 | 0;
 i14 = HEAP16[i13 >> 1] | 0;
 HEAPF32[i2 + 56 >> 2] = f3;
 i10 = i2 + 146 | 0;
 i12 = i9 & 1;
 i11 = HEAP16[i10 >> 1] | 0;
 HEAP16[i13 >> 1] = (((i14 & 65535) >>> 15 & 65535 | i9 & 1) & 65535) << 15 & 65535 | i14 & 32767;
 HEAPF32[i2 + 60 >> 2] = f4;
 HEAP16[i10 >> 1] = i12 << 8 & 65535 | (i12 << 7 & 65535 | i11 & -385);
 if (i9) {
  i14 = 0;
  STACKTOP = i8;
  return i14 | 0;
 }
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i14 = f3 > Math_fround(0.0);
 i14 = HEAP32[(i14 ? i1 : i6) >> 2] | 0;
 HEAP32[i1 >> 2] = i14;
 f3 = (HEAP32[tempDoublePtr >> 2] = i14, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = __ZN4FMOD7Channel19set3DMinMaxDistanceEff(i5, f3, f3 < f4 ? f4 : f3) | 0;
 if (!i1) {
  i14 = 0;
  STACKTOP = i8;
  return i14 | 0;
 }
 i14 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i7 >> 2] = gb + 853918;
 HEAP32[i7 + 4 >> 2] = 220;
 HEAP32[i7 + 8 >> 2] = gb + 866452;
 HEAP32[i7 + 12 >> 2] = i14;
 __Z6FormatPKcz(i6, gb + 883334 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i14 = i1;
 STACKTOP = i8;
 return i14 | 0;
}

function __ZN11TypeManagerD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[HEAP32[i6 + 44 >> 2] >> 2] = 0;
 i1 = HEAP32[i6 + 264 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i6 + 288 >> 2] | 0;
  HEAP32[i5 >> 2] = 6;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = HEAP32[i6 + 204 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i6 + 228 >> 2] | 0;
  HEAP32[i5 >> 2] = 6;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = HEAP32[i6 + 148 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i6 + 172 >> 2] | 0;
  HEAP32[i5 >> 2] = 6;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = HEAP32[i6 + 92 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i6 + 116 >> 2] | 0;
  HEAP32[i5 >> 2] = 6;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 52 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  i4 = HEAP32[i6 + 60 >> 2] | 0;
  HEAP32[i5 >> 2] = 6;
  HEAP32[i5 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i1 = i6 + 24 | 0;
 if ((HEAP32[i6 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 28 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 4 | 0;
 if ((HEAP32[i6 + 20 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN11PlayerPrefs9DeleteKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZL18InitializeIfNeededv();
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(HEAP32[gb + 1103788 >> 2] | 0, i2) | 0;
 i4 = HEAP32[gb + 1103788 >> 2] | 0;
 if ((i3 | 0) == (i4 + 4 | 0)) {
  __ZN11PlayerPrefs4SyncEv();
  return;
 }
 HEAP8[gb + 1544208 >> 0] = 1;
 if (((HEAP32[i3 + 28 >> 2] | 0) + -253 | 0) >>> 0 < 2) i1 = 5; else {
  i1 = HEAP8[i3 + 36 + 11 >> 0] | 0;
  i1 = i1 << 24 >> 24 < 0 ? HEAP32[i3 + 40 >> 2] | 0 : i1 & 255;
  i1 = (i1 >>> 0 < 128 ? 1 : 5) + i1 | 0;
 }
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[gb + 1103828 >> 2] = (HEAP32[gb + 1103828 >> 2] | 0) - (i2 + i1) + (i2 >>> 0 < 128 ? -1 : -5);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) HEAP32[i4 >> 2] = i1;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i4 + 4 >> 2] | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
 __ZdlPv(i3);
 __ZN11PlayerPrefs4SyncEv();
 return;
}

function __ZNK6Shader17GetOutputFilenameEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 12 >> 2] = i1;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
  i1 = HEAP32[i6 + 12 >> 2] | 0;
  i5 = 6;
 } else if (i4 >>> 0 < 11) {
  i3 = i6 + 11 | 0;
  HEAP8[i3 >> 0] = i4;
  if (!i4) i1 = i6; else {
   i1 = i6;
   i5 = 8;
  }
 } else i5 = 6;
 if ((i5 | 0) == 6) {
  i8 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i6 + 4 >> 2] = i4;
  i3 = i6 + 11 | 0;
  i5 = 8;
 }
 if ((i5 | 0) == 8) _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i5 = i6 + 4 | 0;
 i4 = 0;
 while (1) {
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i1 & 255;
  if (i4 >>> 0 >= i1 >>> 0) break;
  if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  if (!(__Z21IsValidFileNameSymbolc(HEAP8[i1 + i4 >> 0] | 0) | 0)) {
   if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
   HEAP8[i1 + i4 >> 0] = 45;
  }
  i4 = i4 + 1 | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i8 = i9;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i7 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = i5;
  i2 = i1;
  L5 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) {
     i1 = i3;
     break L5;
    }
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i3 = i1;
  }
  if ((i1 | 0) != (i5 | 0)) if (!((i1 | 0) == (i5 | 0) ? 1 : (i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0))) {
   i3 = i1;
   HEAP32[i6 >> 2] = HEAP32[i7 + 32 >> 2];
   i4 = i6 + 4 | 0;
   i1 = i1 + 16 | 0;
   i2 = i4 + 40 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    i4 = i4 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i4 | 0) < (i2 | 0));
   __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE9push_backERKS9_(i7, i6);
   HEAP32[i8 >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
   __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE5eraseENS_21__tree_const_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEE(i7 + 12 | 0, i6) | 0;
   STACKTOP = i9;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409142 | 0, 0, gb + 407408 | 0, 258, 1, i4, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN17PackedFloatVector12UnpackFloatsEPfiiii(i5, i1, i14, i17, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i17 = i17 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var d3 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0;
 i15 = HEAP8[i5 + 12 >> 0] | 0;
 i16 = i15 & 255;
 i6 = Math_imul(i16, i2) | 0;
 d3 = +Math_fround(HEAPF32[i5 + 4 >> 2]);
 if (i15 << 24 >> 24) d3 = d3 / +((1 << i16) + -1 | 0);
 if ((i4 | 0) == -1) i2 = ((HEAP32[i5 >> 2] | 0) >>> 0) / (i14 >>> 0) | 0; else i2 = i4;
 i13 = i1 + (Math_imul(i2, i17) | 0) | 0;
 if ((i13 | 0) == (i1 | 0)) return;
 i12 = i5 + 8 | 0;
 i11 = i5 + 16 | 0;
 if ((i14 | 0) > 0) {
  i5 = (i6 | 0) / 8 | 0;
  i4 = (i6 | 0) % 8 | 0;
  i2 = i15;
 } else {
  do i1 = i1 + i17 | 0; while ((i1 | 0) != (i13 | 0));
  return;
 }
 while (1) {
  i10 = 0;
  i6 = i5;
  do {
   i5 = i2 & 255;
   if (!(i2 << 24 >> 24)) {
    i7 = 0;
    i2 = 0;
   } else {
    i9 = HEAP32[i11 >> 2] | 0;
    i8 = 0;
    i7 = 0;
    i2 = i6;
    while (1) {
     i6 = (HEAPU8[i9 + i2 >> 0] | 0) >>> i4 << i8 | i7;
     i7 = i5 - i8 | 0;
     i5 = 8 - i4 | 0;
     i7 = (i5 | 0) < (i7 | 0) ? i5 : i7;
     i4 = i7 + i4 | 0;
     i8 = i7 + i8 | 0;
     i7 = (i4 | 0) == 8;
     i4 = i7 ? 0 : i4;
     i2 = (i7 & 1) + i2 | 0;
     if ((i16 | 0) <= (i8 | 0)) {
      i7 = i6;
      i6 = i2;
      i5 = i16;
      i2 = i15;
      break;
     } else {
      i7 = i6;
      i5 = i16;
     }
    }
   }
   HEAPF32[i1 + (i10 << 2) >> 2] = Math_fround(d3 * +(((1 << i5) + -1 & i7) >>> 0) + +Math_fround(HEAPF32[i12 >> 2]));
   i10 = i10 + 1 | 0;
  } while ((i10 | 0) != (i14 | 0));
  i1 = i1 + i17 | 0;
  if ((i1 | 0) == (i13 | 0)) break; else i5 = i6;
 }
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = i7 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = (i9 - i1 | 0) / 12 | 0;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
   i5 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i12;
 return;
}

function __ZN17SurfaceEffector2D14SetUseFrictionEb(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, f5 = f0, f6 = f0, i7 = 0;
 HEAP8[i2 + 105 >> 0] = i4 & 1;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 if (!i3) return;
 i2 = (HEAP8[i2 + 106 >> 0] | 0) == 0;
 i3 = i1 + (i3 * 40 | 0) | 0;
 if (i4) if (i2) {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   f5 = Math_fround(HEAPF32[(HEAP32[i4 + 48 >> 2] | 0) + 36 >> 2]);
   HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f5 * Math_fround(HEAPF32[(HEAP32[i4 + 52 >> 2] | 0) + 36 >> 2]))));
   HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i3 | 0));
  return;
 } else {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i7 = HEAP32[i4 + 48 >> 2] | 0;
   f6 = Math_fround(HEAPF32[i7 + 36 >> 2]);
   i2 = HEAP32[i4 + 52 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f6 * Math_fround(HEAPF32[i2 + 36 >> 2]))));
   f6 = Math_fround(HEAPF32[i7 + 40 >> 2]);
   f5 = Math_fround(HEAPF32[i2 + 40 >> 2]);
   HEAPF32[i4 + 148 >> 2] = f6 > f5 ? f6 : f5;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i3 | 0));
  return;
 } else if (i2) {
  do {
   i7 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i7 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i3 | 0));
  return;
 } else {
  do {
   i7 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
   f5 = Math_fround(HEAPF32[(HEAP32[i7 + 48 >> 2] | 0) + 40 >> 2]);
   f6 = Math_fround(HEAPF32[(HEAP32[i7 + 52 >> 2] | 0) + 40 >> 2]);
   HEAPF32[i7 + 148 >> 2] = f5 > f6 ? f5 : f6;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i3 | 0));
  return;
 }
}

function __ZN16GraphicsSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 377894 | 0, 219) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 33272 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 1;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 1;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 1;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 1;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 1;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 1;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 1;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 1;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 124 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace(i5, i2, i7, i1, i8, i9, i10, i11, i12, i13, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i14 = 0, i15 = 0, i16 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i14 = i4;
 i3 = i5 + 4620 | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
 i1 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i3, 2, i1) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i2 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i14 = i1 + 8 | 0;
 i15 = HEAP32[i14 + 4 >> 2] | 0;
 i2 = i5 + 7320 | 0;
 i16 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(i16 >>> 0 < i15 >>> 0 | ((i16 | 0) == (i15 | 0) ? (HEAP32[i2 >> 2] | 0) >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0 : 0))) {
  i16 = HEAP32[i1 >> 2] | 0;
  __ZN4gles22UploadTexture2DSubDataEP7ApiGLESj13TextureFormatPKviiiii17TextureColorSpace(i3, i16, i13, i7, i8, i9, i10, i11, i12, i6);
  STACKTOP = i4;
  return;
 }
 i15 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i5 + 5480 >> 2] | 0, 7) | 0;
 i16 = i5 + 7376 | 0;
 HEAP32[i16 >> 2] = HEAP32[i16 >> 2] | i15;
 i16 = HEAP32[i1 >> 2] | 0;
 __ZN4gles22UploadTexture2DSubDataEP7ApiGLESj13TextureFormatPKviiiii17TextureColorSpace(i3, i16, i13, i7, i8, i9, i10, i11, i12, i6);
 STACKTOP = i4;
 return;
}

function __Z41SortingLayer_CUSTOM_GetLayerValueFromNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 48 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i4 = __Z13GetTagManagerv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i5);
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 24 | 0;
 i10 = gb + 63648 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i3 = HEAP8[i8 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i10 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i7 + 4 >> 2] = i3;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i5 >> 2] = i3;
 i1 = __ZN10TagManager28GetSortingLayerValueFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK15FileSystemEntry6ParentEPS_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 1060 | 0;
 i5 = i7;
 i2 = i1 + 1040 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
 i3 = HEAP32[i2 >> 2] | 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0) {
  i3 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
  i2 = i5 + 1040 | 0;
  HEAP8[i5 >> 0] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  __ZN15FileSystemEntry3SetEPKc(i5, i3);
  if ((i5 | 0) != (i4 | 0)) {
   i3 = i4 + 1040 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i4 | 0);
   _strncpy(i4, i5, 1040) | 0;
   HEAP8[i4 + 1039 >> 0] = 0;
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i4 + 1044 >> 2] = HEAP32[i5 + 1044 >> 2];
   HEAP32[i4 + 1048 >> 2] = 0;
   HEAP32[i4 + 1052 >> 2] = 0;
   HEAP32[i4 + 1056 >> 2] = 0;
   if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i4 | 0);
  }
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i5 | 0);
  i1 = 1;
 } else i1 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13MemoryManager18RegisterAllocationEPvjRK10MemLabelIdPKcS5_i(i5, i6, i7, i4, i8, i9, i10) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!(HEAP32[gb + 1163236 >> 2] | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) < 128) i1 = HEAP32[i5 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
  i1 = HEAP32[i5 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L8 : do if ((i1 | 0) < 128) {
  i2 = i5 + 3824 + (i1 * 24 | 0) + 8 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
  i1 = i5 + 3824 + (i1 * 24 | 0) + 20 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i5 + 3824 + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 16 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 >= i7 >>> 0) break L8;
  } while ((HEAP32[i1 >> 2] | 0) != (i2 | 0));
  HEAP32[i1 >> 2] = i3;
 } while (0);
 __ZN14MemoryProfiler18RegisterAllocationEPvRK10MemLabelIdPKcij(HEAP32[gb + 1163236 >> 2] | 0, i6, i4, i9, i10, i3);
 if (!(HEAP8[i5 + 1548 >> 0] | 0)) return;
 if ((HEAP32[i5 + 3816 >> 2] | 0) >>> 0 > i7 >>> 0) return;
 i2 = i5 + 768 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return; else i1 = 0;
 do {
  i3 = i5 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i5 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiiii(HEAP32[i3 >> 2] | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0); else mftCall_viiiiii(HEAP32[i3 >> 2] | 0, HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return;
}

function __ZN12NavMeshAgent16AddToCrowdSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 140 | 0;
 i3 = i7 + 128 | 0;
 i6 = i7;
 if (!(__Z14IsWorldPlayingv() | 0)) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 + 33 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 841740 | 0, 0, gb + 841797 | 0, 498, 512, 0, 0, 0);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f8 = Math_fround(-Math_fround(HEAPF32[i1 + 44 >> 2]));
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform14TransformPointERK8Vector3f(i3, i5, i2);
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i2);
 i5 = i1 + 68 | 0;
 if (__ZN7dtCrowd8addAgentER13dtCrowdHandlePKfPK18dtCrowdAgentParams(i4, i5, i3, i2) | 0) {
  HEAPF32[i1 + 56 >> 2] = Math_fround(inf);
  i2 = __Z25GetNavMeshProjectSettingsv() | 0;
  i1 = 0;
  do {
   HEAPF32[i6 + (i1 << 2) >> 2] = Math_fround(__ZNK22NavMeshProjectSettings11GetAreaCostEj(i2, i1));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 32);
  __ZN7dtCrowd21initializeAgentFilterERK13dtCrowdHandlePKfi(i4, i5, i6, 32);
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 841885 | 0, 0, gb + 841797 | 0, 511, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN9GfxDevice20BeginDynamicBatchingERK14ChannelAssignsjjP17VertexDeclarationjj16GfxPrimitiveType(i11, i1, i2, i10, i5, i12, i3, i13) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, d14 = 0.0;
 d14 = +_emscripten_get_now() * 1.0e6;
 i6 = +Math_abs(d14) >= 1.0 ? (d14 > 0.0 ? ~~+Math_min(+Math_floor(d14 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d14 - +(~~d14 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i9 = i11 + 4544 | 0;
 HEAP32[i9 >> 2] = ~~d14 >>> 0;
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i11 + 4552 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4556 >> 2] = i2;
 HEAP32[i11 + 4560 >> 2] = i12;
 i9 = (i13 | 0) == 2;
 i1 = i9 ? (i3 >>> 2) * 6 | 0 : i3;
 i6 = i11 + 4564 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i11 + 4568 >> 2] = 0;
 HEAP32[i11 + 4572 >> 2] = 0;
 HEAP32[i11 + 4576 >> 2] = 0;
 HEAP32[i11 + 4580 >> 2] = i13;
 i8 = i11 + 4588 | 0;
 HEAP32[i11 + 4588 >> 2] = 0;
 i7 = i11 + 4592 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i11 + 4596 >> 2] = -1;
 HEAP32[i11 + 4600 >> 2] = 0;
 i4 = i11 + 4584 | 0;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i11 + 4612 >> 2] = i5;
 i2 = i11 + 4512 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 896 >> 2] | 0, i11 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 } else i2 = i10;
 HEAP8[i11 + 4536 >> 0] = (mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, i12 | 0, i1 | 0, (i9 ? 0 : i13) | 0, i8 | 0) | 0) & 1;
 HEAP32[i11 + 4604 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 4608 >> 2] = HEAP32[i7 >> 2];
 return;
}

function __ZN8VRDevice12ProcessFocusEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 168 >> 2] | 0, i5 | 0) | 0)) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i5 + 284 >> 2] | 0)) {
  i1 = HEAP32[i5 + 232 >> 2] | 0;
  if (!i1) i4 = 0; else i4 = mftCall_i(i1 | 0) | 0;
 } else i4 = 0;
 if (__Z32GetPlayerSettingsRunInBackgroundv() | 0) if (!(HEAP8[i5 + 172 >> 0] | 0)) {
  i1 = i5 + 300 | 0;
  i2 = (HEAP8[i1 >> 0] | 0) != 0;
  if (i4) {
   if (!i2) {
    STACKTOP = i6;
    return;
   }
   i4 = __Z12GetGfxDevicev() | 0;
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   mftCall_viiifi(i2 | 0, i4 | 0, 7, i3 | 0, 1.0, 0);
   HEAP8[i1 >> 0] = 0;
   __ZN8VRDevice18ReleaseEyeTexturesEv(i5);
   STACKTOP = i6;
   return;
  } else {
   if (i2) {
    STACKTOP = i6;
    return;
   }
   __ZN8VRDevice17CreateEyeTexturesEv(i5) | 0;
   HEAP8[i1 >> 0] = 1;
   STACKTOP = i6;
   return;
  }
 }
 i2 = i5 + 328 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!(i1 << 24 >> 24 != 0 | i4 ^ 1)) {
  HEAP8[i2 >> 0] = 1;
  __Z14SetPlayerPause11PlayerPauseb(1, 1);
  i1 = HEAP8[i2 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  STACKTOP = i6;
  return;
 }
 if (i4) {
  i1 = HEAP32[i5 + 240 >> 2] | 0;
  if (!i1) {
   STACKTOP = i6;
   return;
  }
  mftCall_v(i1 | 0);
  STACKTOP = i6;
  return;
 } else {
  __Z14SetPlayerPause11PlayerPauseb(0, 1);
  if (!(HEAP8[i2 >> 0] | 0)) {
   STACKTOP = i6;
   return;
  }
  HEAP8[i2 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN8DateTime25FromISO8601DateTimeStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i12, i1) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i4 = i13 + 44 | 0;
 i2 = i13 + 40 | 0;
 i3 = i13 + 36 | 0;
 i5 = i13 + 32 | 0;
 i6 = i13 + 28 | 0;
 i7 = i13 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = i2;
 HEAP32[i11 + 8 >> 2] = i3;
 HEAP32[i11 + 12 >> 2] = i5;
 HEAP32[i11 + 16 >> 2] = i6;
 HEAP32[i11 + 20 >> 2] = i7;
 _sscanf(i1, gb + 585545 | 0, i11) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 1;
  i1 = 1;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 1;
  i2 = 1;
 }
 i10 = i12;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = i10 * 365 | 0;
 i7 = (i10 | 0) / 400 | 0;
 i4 = (i10 | 0) / -100 | 0;
 i8 = (i10 | 0) / 4 | 0;
 i3 = i1 + -1 | 0;
 if (!(i10 & 3)) if (!((i10 | 0) % 100 | 0)) i1 = ((i10 | 0) % 400 | 0 | 0) == 0; else i1 = 1; else i1 = 0;
 i11 = (i9 * 60 | 0) + (i11 * 3600 | 0) + i5 + ((i7 + -719528 + i6 + i4 + i8 + i2 + (HEAP32[gb + 73680 + ((i1 & 1) * 48 | 0) + (i3 << 2) >> 2] | 0) | 0) * 86400 | 0) | 0;
 HEAP32[i12 >> 2] = ((i11 | 0) < 0) << 31 >> 31 & 65535;
 HEAP32[i12 + 4 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZN5Umbra10QueryState7mapTomeERNS_10MappedTomeEi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i4 | 0) != -1 & (i1 | 0) != 0) {
  i1 = (HEAP32[i1 + 32 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + (i4 << 5)) | 0;
  if (i1 | 0) {
   i9 = HEAP32[i1 >> 2] | 0;
   i8 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i8 + (HEAP32[i8 + 180 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i5 = i8 + (HEAP32[i8 + 184 >> 2] | 0) | 0;
   i6 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
   i5 = (HEAP32[i5 + (i4 + 1 << 2) >> 2] | 0) - i6 | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i3 + 8 >> 2] = i9;
   HEAP32[i3 + 12 >> 2] = i8;
   HEAP32[i3 + 16 >> 2] = i7;
   HEAP32[i3 + 20 >> 2] = i6;
   HEAP32[i3 + 24 >> 2] = i5;
   i4 = i2 + 92 | 0;
   HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   return;
  }
 }
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i9;
 HEAP32[i3 + 12 >> 2] = i9;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i9 = i2 + 92 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 return;
}

function __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5 + 4 | 0, i6);
 i1 = i5 + 8 | 0;
 i7 = i6 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i6 + 24 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 16 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 20 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i6, i5 + 24 | 0, gb + 932925 | 0, 0);
 i1 = i5 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 }
}

function __ZNK8GUIStyle20GetCursorStringIndexERK5RectTIfER10GUIContentRK8Vector2f(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 i1 = __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent(i2, i3, i1) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = __ZN13TextRendering17GetITextRenderingEv() | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(f12 + Math_fround(HEAP32[i2 + 208 >> 2] | 0));
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f11 + Math_fround(HEAP32[i2 + 216 >> 2] | 0));
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f12 = Math_fround(f12 - Math_fround(HEAP32[i2 + 212 >> 2] | 0));
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 f12 = Math_fround(f12 - f13);
 f11 = Math_fround(Math_fround(f11 - Math_fround(HEAP32[i2 + 220 >> 2] | 0)) - f10);
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i5 + 8 >> 2] = f12;
 HEAPF32[i5 + 4 >> 2] = f10;
 HEAPF32[i5 + 12 >> 2] = f11;
 f11 = Math_fround(HEAPF32[i2 + 260 >> 2]);
 f11 = Math_fround(f11 + Math_fround(HEAPF32[i2 + 268 >> 2]));
 f10 = Math_fround(HEAPF32[i2 + 264 >> 2]);
 f10 = Math_fround(f10 + Math_fround(HEAPF32[i2 + 272 >> 2]));
 f11 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f11);
 f10 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - f10);
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i6 + 4 >> 2] = f10;
 i6 = mftCall_iiiii(i9 | 0, i8 | 0, i1 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sc10NPhaseCore32addToPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i7, i11) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 4 | 0;
 i6 = i12;
 HEAP32[i2 >> 2] = i11;
 i9 = i11 + 44 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 2097152;
 i9 = i7 + 16 | 0;
 i4 = i7 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i10 = i7 + 28 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i11;
 if ((i5 | 0) == (i1 | 0)) {
  HEAP32[i11 + 52 >> 2] = i5;
  if ((HEAP32[i7 + 24 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] = i8;
   HEAP32[i4 >> 2] = i5 + 1;
   i11 = i5;
   i11 = i11 + 1 | 0;
   HEAP32[i10 >> 2] = i11;
   STACKTOP = i12;
   return;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i2) | 0;
   i11 = HEAP32[i10 >> 2] | 0;
   i11 = i11 + 1 | 0;
   HEAP32[i10 >> 2] = i11;
   STACKTOP = i12;
   return;
  }
 } else {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i3 + 52 >> 2] = i5;
  if ((HEAP32[i7 + 24 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
   HEAP32[i2 + (i5 << 2) >> 2] = i3;
   HEAP32[i4 >> 2] = i5 + 1;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i11 + 52 >> 2] = i1;
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i8;
  i11 = i1;
  i11 = i11 + 1 | 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i14, i6, i1) {
 i14 = i14 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13 + 4 | 0;
 i4 = i13;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = (i8 - i1 | 0) / 20 | 0;
 HEAP32[i4 >> 2] = i5;
 i10 = i14 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i11 = i14 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i13;
  return;
 }
 i9 = i1;
 do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i14);
  i3 = i9 + 4 | 0;
  i7 = i9 + 8 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i2 - i1 >> 2;
  HEAP32[i12 >> 2] = i4;
  i5 = HEAP32[i10 >> 2] | 0;
  i6 = i5 + 4 | 0;
  if (i6 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i4;
   HEAP32[i10 >> 2] = i6;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i12, 4);
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 | 0)) do {
   __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i14);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i9 = i9 + 20 | 0;
 } while ((i9 | 0) != (i8 | 0));
 STACKTOP = i13;
 return;
}

function __ZN17SurfaceEffector2D28UpdateFrictionBounceContactsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 i2 = HEAP32[i3 + 48 >> 2] | 0;
 if (!i2) return;
 i4 = (HEAP8[i3 + 106 >> 0] | 0) == 0;
 i2 = i1 + (i2 * 40 | 0) | 0;
 if (!(HEAP8[i3 + 105 >> 0] | 0)) if (i4) {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   f6 = Math_fround(HEAPF32[(HEAP32[i4 + 48 >> 2] | 0) + 40 >> 2]);
   f5 = Math_fround(HEAPF32[(HEAP32[i4 + 52 >> 2] | 0) + 40 >> 2]);
   HEAPF32[i4 + 148 >> 2] = f6 > f5 ? f6 : f5;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else if (i4) {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   f6 = Math_fround(HEAPF32[(HEAP32[i4 + 48 >> 2] | 0) + 36 >> 2]);
   HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f6 * Math_fround(HEAPF32[(HEAP32[i4 + 52 >> 2] | 0) + 36 >> 2]))));
   HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i7 = HEAP32[i4 + 48 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i7 + 36 >> 2]);
   i3 = HEAP32[i4 + 52 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f5 * Math_fround(HEAPF32[i3 + 36 >> 2]))));
   f5 = Math_fround(HEAPF32[i7 + 40 >> 2]);
   f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   HEAPF32[i4 + 148 >> 2] = f5 > f6 ? f5 : f6;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37008 >> 2] | 0, gb + 902658 | 0, i1, 0);
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902691 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902701 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 37224 >> 2] | 0, gb + 902667 | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 902678 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 912455 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i5 + 340 >> 2] | 0;
 if (!i6) {
  i8 = -1;
  return i8 | 0;
 }
 __ZN4Mesh18CreateMeshIfNeededEv(i6);
 i8 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 + (i8 * 360 | 0) + 248 >> 2] = HEAP32[i6 + 228 >> 2];
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 28 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i4 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 28;
 HEAP32[i7 + (i8 * 360 | 0) + 328 >> 2] = i4;
 i1 = HEAP32[i5 + 344 >> 2] | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 32 >> 2] | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = i5;
 i6 = HEAP32[i6 + 36 >> 2] | 0;
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[i4 + 8 >> 2] = i6;
 if (!i1) {
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = 0;
 } else {
  i6 = HEAP32[i1 + 32 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  HEAP32[i4 + 4 >> 2] = i6;
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i4 + 16 >> 2] = i2;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i7 + (i8 * 360 | 0) + 340 >> 2] = fb + 492;
 HEAP32[i7 + (i8 * 360 | 0) + 332 >> 2] = fb + 211;
 HEAP32[i7 + (i8 * 360 | 0) + 344 >> 2] = fb + 2371;
 return i8 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcherC2ERNS0_11IRestClientE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = gb + 189892 + 8;
 HEAP32[i4 >> 2] = gb + 189892 + 36;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i1 + 12 | 0;
 i5 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i5 = i1 + 32 | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 1;
 i3 = i1 + 96 | 0;
 i5 = i1 + 56 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 + 100 >> 2] = gb + 190168 + 8;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 0;
 HEAP32[i1 + 108 >> 2] = i4;
 i6 = i1 + 112 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1 + 136 | 0);
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 276 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = i1 + 268;
 return;
}

function __Z25FindConflictingComponentsi(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __Z25InitComponentRequirementsv();
 i8 = HEAP32[gb + 1162548 >> 2] | 0;
 i2 = i8 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i6 >> 2] = i2;
  i5 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i7 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i4 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i7 | 0)) {
     i4 = 10;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i4 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i4 | 0) == 4) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i2 = i1;
   break;
  } else if ((i4 | 0) == 8) {
   HEAP32[i6 >> 2] = i1;
   i5 = i1;
   i2 = i3;
   break;
  } else if ((i4 | 0) == 10) {
   HEAP32[i6 >> 2] = i1;
   if (!i1) {
    i5 = i1;
    i2 = i6;
    break;
   }
   i8 = i1 + 20 | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 } while (0);
 i3 = __Znwj(32) | 0;
 HEAP32[i3 + 16 >> 2] = i7;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 if (!i1) i1 = i3; else {
  HEAP32[i8 >> 2] = i1;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 4 >> 2] | 0, i1);
 i8 = i8 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i3;
 i8 = i8 + 20 | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN9ShaderLab10GrabPassesD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 12 | 0;
 if ((i1 | 0) != (i7 | 0)) {
  i2 = i1;
  while (1) {
   i3 = i2 + 20 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) {
    HEAP32[i4 >> 2] = gb + 33952 + 8;
    if ((HEAP32[i4 + 88 >> 2] | 0) > -1) {
     i1 = i4 + 72 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 76 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i4 + 52 | 0;
    if ((HEAP32[i4 + 68 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 56 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i4 + 32 | 0;
    if ((HEAP32[i4 + 48 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 36 | 0);
     HEAP32[i1 >> 2] = 0;
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, HEAP32[i7 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i7 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i6, 0);
 return;
}

function __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_(i1, i2, i3, i8, i12, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 1 | 0;
 i6 = i13;
 i1 = __ZN5physx14SapPairManager7AddPairEjjh(i3, i1, i2, 8) | 0;
 if (!i1) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i10 = i3 + 20 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i1;
 i7 = i3 + 24 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + (i11 - i2 >> 3) | 0;
 if (HEAP8[i3 >> 0] & 8) {
  HEAP8[i3 >> 0] = 0;
  i4 = (HEAP32[i7 >> 2] | 0) + (i11 - (HEAP32[i10 >> 2] | 0) >> 3) | 0;
  HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 1;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
   i1 = (i1 | 0) == 0 ? 64 : i1 << 1;
   i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i1 << 2, gb + 716962 | 0, 200) | 0;
   _memcpy(i3 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i8 >> 2] | 0);
   HEAP32[i8 >> 2] = i3;
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[i12 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  } else {
   i3 = HEAP32[i8 >> 2] | 0;
   i2 = i4;
  }
  HEAP32[i3 + (i1 << 2) >> 2] = (i11 - i4 | 0) >>> 3;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  i2 = (HEAP32[i7 >> 2] | 0) + (i11 - i2 >> 3) | 0;
  HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | 4;
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i12 = i1 + (i11 - i2 >> 3) | 0;
 HEAP8[i12 >> 0] = (HEAPU8[i12 >> 0] | 0) & 253;
 i12 = 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 24 | 0;
 i6 = i9;
 i8 = i7 + 80 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i2 = i7 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i7 + 52 | 0;
  i5 = 0;
  do {
   i12 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i11 = i12 & 1;
   i10 = i12 >>> 2;
   i12 = (HEAP32[i7 + 28 + (i11 * 12 | 0) >> 2] | 0) + (i12 >>> 7 << 2) | 0;
   HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~(1 << (i10 & 31));
   HEAP32[i1 >> 2] = i10;
   i10 = i7 + 12 + (i11 << 2) | 0;
   i12 = HEAP32[i10 >> 2] | 0;
   i12 = mftCall_iii(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0, i1 | 0) | 0;
   __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i6, HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0);
   i11 = i7 + 20 + (i11 << 2) | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
   i10 = HEAP32[i10 >> 2] | 0;
   mftCall_viiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i1 | 0, i6 | 0, 1);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i3 | 0));
 }
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  i12 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i9;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i12 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i8 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP8[i2 + 12 >> 0] = 0;
  i7 = i1;
  i2 = i2 | 0 ? i2 - i7 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i7;
 } else i3 = i8 + 4 | 0;
 i7 = i2 + i1 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 4;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i8, i4, 0);
 i1 = i7 + 8 | 0;
 i6 = i8 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i8 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i7 + 12 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 }
}

function __ZN13GfxDeviceGLES17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace(i7, i2, i8, i1, i9, i10, i11, i12, i13, i14) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 i5 = i7 + 4620 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i2 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i5, 4, i3) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i3 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i3 = i2 + 8 | 0;
 i16 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i7 + 7320 | 0;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 if (i17 >>> 0 < i16 >>> 0 | ((i17 | 0) == (i16 | 0) ? (HEAP32[i15 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0)) {
  i16 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i7 + 5480 >> 2] | 0, 7) | 0;
  i17 = i7 + 7376 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i16;
 }
 i17 = __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i5, i2, i11, i8, i9, i10, i10, 1, i12, i13, i14, 0) | 0;
 __Z34register_external_gfx_deallocationPvPKci(i4, gb + 603515 | 0, 1025);
 __Z32register_external_gfx_allocationPvjjPKci(i4, i17, i1, gb + 603515 | 0, 1026);
 STACKTOP = i6;
 return;
}

function __ZL60CombineDirectionalShadowCasterCullignIndexListsAndDestroyJobP20ShadowCullingJobData(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1112984 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112984 | 0, i1);
  i10 = gb + 1112984 | 0;
 } else i10 = 0;
 i12 = i11 + 24 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP32[i11 + 220 >> 2] | 0;
 if ((HEAP16[gb + 1162184 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162184 | 0, i1);
  i8 = gb + 1162184 | 0;
 } else i8 = 0;
 i1 = HEAP32[i11 + 32 >> 2] | 0;
 if ((i9 | 0) > 1) {
  i7 = HEAP32[i3 >> 2] | 0;
  i6 = 1;
  do {
   i2 = HEAP32[i11 + 28 + (i6 * 12 | 0) >> 2] | 0;
   i4 = HEAP32[i11 + 28 + (i6 * 12 | 0) + 4 >> 2] | 0;
   i5 = i4 + i2 | 0;
   if (i2 >>> 0 < i5 >>> 0) {
    i3 = i1;
    while (1) {
     HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
    }
    i1 = i4 + i1 | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i9 | 0));
 }
 if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
 HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 64024 | 0);
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i13;
 return;
}

function __Z13TransferFieldI24GenerateTypeTreeTransferLb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5;
 i1 = i5 + 8 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 i8 = i1 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 i8 = i1 + 36 | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 i6 = i1 + 72 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i1 + 60 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i1 + 80 >> 2] = 2;
 HEAP32[i1 + 76 >> 2] = 2;
 HEAP32[i1 + 84 >> 2] = 4;
 i3 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i2 + 4 >> 2] | 0, gb + 1034188 | 0, i1, HEAP32[i2 + 24 >> 2] | 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 i1 = i1 + 56 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEiPKN5Unity4TypeE(i6, i4, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 i2 = i8;
 do if (i4 | 0) {
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i5 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i9 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
    i2 = HEAP32[i9 + 28 >> 2] | 0;
    i3 = HEAP32[i9 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) break;
  }
  if (!((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
   i9 = __ZNK13MonoBehaviour17GetExecutionOrderEv(i1) | 0;
   STACKTOP = i8;
   return i9 | 0;
  }
 } while (0);
 i9 = HEAP32[(HEAP32[i6 >> 2] | 0) + (HEAP32[i7 + 24 >> 2] << 3) + 4 >> 2] | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN7mecanim9animation10GetMotionXERKNS0_18ClipMuscleConstantEPKf(i11, i7, i9) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i8 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i7 + 1088 >> 2] | 0;
 if ((i1 | 0) == -1) i10 = 0; else i10 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1092 >> 2] | 0;
 if ((i1 | 0) == -1) i8 = 0; else i8 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1096 >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 0; else i6 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1100 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1104 >> 2] | 0;
 if ((i1 | 0) == -1) f4 = Math_fround(0.0); else f4 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1108 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1112 >> 2] | 0;
 if ((i1 | 0) == -1) f2 = Math_fround(1.0); else f2 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))))));
 f13 = Math_fround(f5 * f14);
 f12 = Math_fround(f4 * f14);
 f4 = Math_fround(f3 * f14);
 f5 = Math_fround(f2 * f14);
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 4 >> 2] = i8;
 HEAP32[i11 + 8 >> 2] = i6;
 HEAPF32[i11 + 12 >> 2] = f13;
 HEAPF32[i11 + 16 >> 2] = f12;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i11 + 24 >> 2] = f5;
 HEAP32[i11 + 28 >> 2] = 1065353216;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 return;
}

function __ZN14SphereCollider8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i5, i8);
 __ZN14SafeBinaryRead10SetVersionEi(i8, 2);
 i6 = i5 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1034411 | 0, HEAP32[gb + 37324 >> 2] | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer20visualizeLinearLimitERKN5physx11PxTransformES4_fb(i4, i2, i3, f5, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 64 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 32 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 36 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 40 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i8 + 44 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i8 + 48 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i8 + 52 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAPF32[i8 + 56 >> 2] = f5;
 HEAP8[i8 + 60 >> 0] = i1 & 1;
 i9 = i4 + 8 | 0;
 HEAP32[i7 >> 2] = gb + 150564 + 8;
 HEAP32[i7 + 4 >> 2] = i9;
 i2 = i4 + 24 | 0;
 i3 = i4 + 20 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i9, i1 + 1 | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i1 >> 0] = 6;
 __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE(i8, i7);
 if (((HEAP32[i2 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i4 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i6;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZL54CombineLocalShadowCasterCullignIndexListsAndDestroyJobP25LocalShadowCullingJobData(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1112996 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112996 | 0, i1);
  i10 = gb + 1112996 | 0;
 } else i10 = 0;
 i12 = i11 + 32 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 i9 = HEAP32[i11 + 228 >> 2] | 0;
 if ((HEAP16[gb + 1162184 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162184 | 0, i1);
  i8 = gb + 1162184 | 0;
 } else i8 = 0;
 i1 = HEAP32[i11 + 40 >> 2] | 0;
 if ((i9 | 0) > 1) {
  i7 = HEAP32[i3 >> 2] | 0;
  i6 = 1;
  do {
   i2 = HEAP32[i11 + 36 + (i6 * 12 | 0) >> 2] | 0;
   i4 = HEAP32[i11 + 36 + (i6 * 12 | 0) + 4 >> 2] | 0;
   i5 = i4 + i2 | 0;
   if (i2 >>> 0 < i5 >>> 0) {
    i3 = i1;
    while (1) {
     HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
    }
    i1 = i4 + i1 | 0;
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i9 | 0));
 }
 if (i8 | 0) __Z12profiler_endP19ProfilerInformation(i8);
 HEAP32[(HEAP32[i12 >> 2] | 0) + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, gb + 64024 | 0);
 if (!i10) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i7 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i7 + 4 | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (i1 - i3 >> 1 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 1 | 0) | 0;
  HEAP32[i12 >> 2] = i3 + (i8 << 1);
  STACKTOP = i13;
  return;
 }
 i9 = i7 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i2 >> 1) + i8 | 0;
 if ((i4 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 }
 i5 = i1 - i2 | 0;
 i5 = i5 >> 1 >>> 0 < 1073741823 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 2147483647;
 if (!i5) i6 = 0; else {
  i6 = HEAP32[i9 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i6;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i3 = i6 + (i3 - i2 >> 1 << 1) | 0;
 _memset(i3 | 0, 0, i8 << 1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i4 = i3 + (0 - (i2 >> 1) << 1) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i4;
 HEAP32[i12 >> 2] = i3 + (i8 << 1);
 HEAP32[i11 >> 2] = i6 + (i5 << 1);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN18GfxFramebufferGLES7PrepareEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i8 = i10 + 8 | 0;
 i9 = i5 + 329 | 0;
 if (!(HEAP8[i9 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i5, 1);
 __ZN13GfxDeviceGLES21ProcessPendingMipGensEv(__Z16GetRealGfxDevicev() | 0);
 i4 = (HEAP32[i5 + 124 >> 2] | 0) + 28 | 0;
 i7 = (HEAP8[i4 >> 0] | 0) == 2;
 HEAP8[i4 >> 0] = 0;
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i5 + 128 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[i5 + 92 + (i3 << 2) >> 2] | 0;
   i11 = i2 + 28 | 0;
   HEAP8[i6 + i3 >> 0] = (HEAP8[i11 >> 0] | 0) == 2 & 1;
   HEAP8[i11 >> 0] = 0;
   if ((HEAP32[i2 + 20 >> 2] & 130 | 0) == 130) {
    __ZN13GfxDeviceGLES16AddPendingMipGenEP17RenderSurfaceBase(__Z16GetRealGfxDevicev() | 0, i2);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = HEAP32[gb + 1451148 >> 2] | 0;
 if (HEAP8[i1 + 109 >> 0] | 0) {
  __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i5, i6, i7);
  i1 = HEAP32[gb + 1451148 >> 2] | 0;
 }
 if (HEAP8[i1 + 110 >> 0] | 0) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi(HEAP32[i5 + 336 >> 2] | 0, (HEAP8[i6 >> 0] | 0) != 0, i7, i7, i8, Math_fround(1.0), 0);
 }
 HEAP8[i9 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN18DelayedCallManager15RemoveNoCleanupERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i7 | 0) != (i4 | 0)) {
  i3 = i8 + 28 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i2 = i4;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) HEAP32[i3 >> 2] = i1;
  i7 = i8 + 36 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 32 >> 2] | 0, i4);
  __ZdlPv(i4);
  return;
 }
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = (i1 | 0) == 0;
 if (i4) {
  i2 = i7;
  while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
    i2 = i3;
    i5 = i7;
    break;
   } else i2 = i3;
  }
 } else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  i5 = i7;
 }
 HEAP32[i6 >> 2] = i2;
 i3 = i8 + 28 | 0;
 if (i4) {
  i2 = i5;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i3 >> 2] | 0) == (i7 | 0)) HEAP32[i3 >> 2] = i1;
 i6 = i8 + 36 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 32 >> 2] | 0, i5);
 __ZdlPv(i7);
 return;
}

function _UNITY_png_write_PLTE(i7, i3, i8) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i10 = i11;
 i1 = HEAP8[i7 + 431 >> 0] | 0;
 if (i8 >>> 0 > 256 ? 1 : (HEAP32[i7 + 596 >> 2] & 1 | i8 | 0) == 0) if (i1 << 24 >> 24 == 3) _UNITY_png_error(i7, gb + 355832 | 0); else {
  STACKTOP = i11;
  return;
 }
 if (!(i1 & 2)) {
  STACKTOP = i11;
  return;
 }
 HEAP16[i7 + 416 >> 1] = i8;
 i6 = i8 * 3 | 0;
 i4 = i7 + 656 | 0;
 HEAP32[i4 >> 2] = 34;
 HEAP8[i9 >> 0] = i6 >>> 24;
 HEAP8[i9 + 1 >> 0] = i6 >>> 16;
 HEAP8[i9 + 2 >> 0] = i6 >>> 8;
 HEAP8[i9 + 3 >> 0] = i6;
 i6 = i9 + 4 | 0;
 HEAP8[i6 >> 0] = 80;
 HEAP8[i9 + 5 >> 0] = 76;
 HEAP8[i9 + 6 >> 0] = 84;
 HEAP8[i9 + 7 >> 0] = 69;
 _UNITY_png_write_data(i7, i9, 8);
 HEAP32[i7 + 372 >> 2] = 1347179589;
 _UNITY_png_reset_crc(i7);
 _UNITY_png_calculate_crc(i7, i6, 4);
 HEAP32[i4 >> 2] = 66;
 if (i8 | 0) {
  i5 = i10 + 1 | 0;
  i6 = i10 + 2 | 0;
  i2 = 0;
  i1 = i3;
  while (1) {
   HEAP8[i10 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP8[i5 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
   HEAP8[i6 >> 0] = HEAP8[i1 + 2 >> 0] | 0;
   _UNITY_png_write_data(i7, i10, 3);
   _UNITY_png_calculate_crc(i7, i10, 3);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i8 | 0)) break; else i1 = i1 + 3 | 0;
  }
 }
 HEAP32[i4 >> 2] = 130;
 i10 = HEAP32[i7 + 408 >> 2] | 0;
 HEAP8[i9 >> 0] = i10 >>> 24;
 HEAP8[i9 + 1 >> 0] = i10 >>> 16;
 HEAP8[i9 + 2 >> 0] = i10 >>> 8;
 HEAP8[i9 + 3 >> 0] = i10;
 _UNITY_png_write_data(i7, i9, 4);
 i10 = i7 + 204 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
 STACKTOP = i11;
 return;
}

function __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, f8 = f0, f9 = f0, f10 = f0;
 i1 = HEAP32[i7 + 100 >> 2] | 0;
 if (!i1) {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) {
  if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
  f5 = Math_fround(HEAPF32[i1 + 120 >> 2]);
  f3 = Math_fround(HEAPF32[i1 + 124 >> 2]);
  f4 = Math_fround(HEAPF32[i1 + 128 >> 2]);
  f2 = Math_fround(HEAPF32[i1 + 132 >> 2]);
 } else {
  f5 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 }
 f9 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i7 + 136 >> 2])));
 f8 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i7 + 140 >> 2])));
 f10 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i7 + 144 >> 2])));
 f4 = Math_fround(f3 + Math_fround(f2 * Math_fround(HEAPF32[i7 + 148 >> 2])));
 f2 = Math_fround(f9 + Math_fround(HEAPF32[i7 + 152 >> 2]));
 f3 = Math_fround(HEAPF32[i7 + 160 >> 2]);
 HEAPF32[i6 >> 2] = Math_fround(f2 - Math_fround(f3 * Math_fround(HEAPF32[i7 + 168 >> 2])));
 f2 = Math_fround(f8 + Math_fround(HEAPF32[i7 + 156 >> 2]));
 f5 = Math_fround(HEAPF32[i7 + 164 >> 2]);
 HEAPF32[i6 + 4 >> 2] = Math_fround(f2 - Math_fround(f5 * Math_fround(HEAPF32[i7 + 172 >> 2])));
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(f10 - f9) + f3);
 HEAPF32[i6 + 12 >> 2] = Math_fround(Math_fround(f4 - f8) + f5);
 return;
}

function __ZN5physx20PxShapeGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 672835;
 HEAP32[i1 + 4 >> 2] = 114;
 HEAP32[i1 + 8 >> 2] = fb + 2093;
 HEAP32[i1 + 12 >> 2] = gb + 673012;
 HEAP32[i1 + 16 >> 2] = 115;
 HEAP32[i1 + 20 >> 2] = fb + 3459;
 HEAP32[i1 + 24 >> 2] = gb + 756572;
 HEAP32[i1 + 28 >> 2] = 116;
 HEAP32[i1 + 32 >> 2] = fb + 3460;
 HEAP32[i1 + 36 >> 2] = fb + 3461;
 HEAP32[i1 + 40 >> 2] = gb + 672848;
 HEAP32[i1 + 44 >> 2] = 117;
 HEAP32[i1 + 48 >> 2] = fb + 3462;
 HEAP32[i1 + 52 >> 2] = fb + 3463;
 HEAP32[i1 + 56 >> 2] = gb + 672869;
 HEAP32[i1 + 60 >> 2] = 118;
 HEAP32[i1 + 64 >> 2] = fb + 3464;
 HEAP32[i1 + 68 >> 2] = fb + 3465;
 HEAP32[i1 + 72 >> 2] = gb + 672885;
 HEAP32[i1 + 76 >> 2] = 119;
 HEAP32[i1 + 80 >> 2] = fb + 397;
 HEAP32[i1 + 84 >> 2] = fb + 2094;
 HEAP32[i1 + 88 >> 2] = gb + 672895;
 HEAP32[i1 + 92 >> 2] = 120;
 HEAP32[i1 + 96 >> 2] = fb + 363;
 HEAP32[i1 + 100 >> 2] = fb + 306;
 HEAP32[i1 + 104 >> 2] = gb + 672909;
 HEAP32[i1 + 108 >> 2] = 121;
 HEAP32[i1 + 112 >> 2] = fb + 364;
 HEAP32[i1 + 116 >> 2] = fb + 307;
 HEAP32[i1 + 120 >> 2] = gb + 743223;
 HEAP32[i1 + 124 >> 2] = 122;
 HEAP32[i1 + 128 >> 2] = fb + 2095;
 HEAP32[i1 + 132 >> 2] = fb + 3466;
 HEAP32[i1 + 136 >> 2] = gb + 672920;
 HEAP32[i1 + 140 >> 2] = 123;
 HEAP32[i1 + 144 >> 2] = fb + 2096;
 HEAP32[i1 + 148 >> 2] = gb + 741602;
 HEAP32[i1 + 152 >> 2] = 124;
 HEAP32[i1 + 156 >> 2] = fb + 2097;
 HEAP32[i1 + 160 >> 2] = fb + 3467;
 HEAP32[i1 + 164 >> 2] = gb + 831985;
 HEAP32[i1 + 168 >> 2] = 125;
 HEAP32[i1 + 172 >> 2] = fb + 2098;
 HEAP32[i1 + 176 >> 2] = gb + 741613;
 HEAP32[i1 + 180 >> 2] = 126;
 HEAP32[i1 + 184 >> 2] = fb + 2099;
 HEAP32[i1 + 188 >> 2] = fb + 3468;
 return;
}

function __ZN5physx12InlineBitmapILj4096EED2Ev(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 1 | 0;
 i9 = i11 + 516 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == (i11 | 0)) {
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 520 | 0;
  HEAP32[i12 >> 2] = -2147483648;
  STACKTOP = i13;
  return;
 }
 i10 = HEAP32[i11 + 512 >> 2] | 0;
 if (!i10) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 520 | 0;
  HEAP32[i12 >> 2] = -2147483648;
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 + 16 >> 2] | 0;
 if (i2 >>> 0 > i5 >>> 0) i12 = 5; else if ((i2 + (HEAP32[i10 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
  i6 = i10 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 } else i12 = 5;
 if ((i12 | 0) == 5) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i5);
 HEAP32[i9 >> 2] = 0;
 i12 = i11 + 520 | 0;
 HEAP32[i12 >> 2] = -2147483648;
 STACKTOP = i13;
 return;
}

function __ZN14NavMeshManager13RestoreTileAtEiii(i9, i12, i10, i11) {
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i9 + 124 >> 2] | 0;
 i7 = i9 + 128 | 0;
 if ((i1 | 0) == (i7 | 0)) return;
 i2 = i1;
 L4 : while (1) {
  if ((HEAP32[i2 + 16 >> 2] | 0) == (i12 | 0)) {
   i3 = HEAP32[i2 + 20 >> 2] | 0;
   i1 = HEAP32[i3 + 56 >> 2] | 0;
   i3 = HEAP32[i3 + 52 >> 2] | 0;
   i5 = i3;
   if ((i1 | 0) != (i3 | 0)) {
    i4 = (i1 - i3 | 0) / 20 | 0;
    i1 = 0;
    do {
     i3 = i5 + (i1 * 20 | 0) | 0;
     i6 = HEAP32[i3 >> 2] | 0;
     if ((HEAP32[i6 + 8 >> 2] | 0) == (i10 | 0)) if ((HEAP32[i6 + 12 >> 2] | 0) == (i11 | 0)) break L4;
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < i4 >>> 0);
   }
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) {
   i8 = 20;
   break;
  } else i2 = i1;
 }
 if ((i8 | 0) == 20) return;
 if (!i3) return;
 i4 = HEAP32[i5 + (i1 * 20 | 0) + 12 >> 2] | 0;
 if (!i4) return;
 i3 = i9 + 108 | 0;
 i1 = __ZNK9dtNavMesh12getTileRefAtEiii(HEAP32[i3 >> 2] | 0, i12, i10, i11) | 0;
 i2 = getTempRet0() | 0;
 do if (!((i1 | 0) == 0 & (i2 | 0) == 0)) if ((HEAP32[(__ZNK9dtNavMesh12getTileByRefEy(HEAP32[i3 >> 2] | 0, i1, i2) | 0) + 40 >> 2] | 0) == (i6 | 0)) return; else {
  __ZN9dtNavMesh10removeTileEyPPKhPi(HEAP32[i3 >> 2] | 0, i1, i2, 0, 0) | 0;
  break;
 } while (0);
 __ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy(HEAP32[i3 >> 2] | 0, i6, i4, 0, i12, 0) | 0;
 return;
}

function _cff_size_init(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 196 | 0;
 i9 = i11;
 HEAP32[i8 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 656 >> 2] | 0) + 2952 >> 2] | 0;
 i2 = _UNITY_FT_Get_Module(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1006904 | 0) | 0;
 do if ((i1 | 0) != 0 & (i2 | 0) != 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i4 = mftCall_ii(i1 | 0, i2 | 0) | 0;
   if (i4 | 0) {
    i6 = HEAP32[i7 >> 2] | 0;
    i5 = HEAP32[i6 + 656 >> 2] | 0;
    i6 = _UNITY_ft_mem_alloc(HEAP32[i6 + 100 >> 2] | 0, 1028, i8) | 0;
    i1 = HEAP32[i8 >> 2] | 0;
    if (!i1) {
     _cff_make_private_dict(i5 + 1324 | 0, i9);
     i1 = mftCall_iiii(HEAP32[i4 >> 2] | 0, HEAP32[(HEAP32[i7 >> 2] | 0) + 100 >> 2] | 0, i9 | 0, i6 | 0) | 0;
     HEAP32[i8 >> 2] = i1;
     if (!i1) {
      i2 = i6 + 4 | 0;
      i1 = HEAP32[i5 + 1896 >> 2] | 0;
      do {
       if (!i1) {
        i10 = 9;
        break;
       }
       i1 = i1 + -1 | 0;
       _cff_make_private_dict(HEAP32[i5 + 1900 + (i1 << 2) >> 2] | 0, i9);
       i3 = mftCall_iiii(HEAP32[i4 >> 2] | 0, HEAP32[(HEAP32[i7 >> 2] | 0) + 100 >> 2] | 0, i9 | 0, i2 + (i1 << 2) | 0) | 0;
       HEAP32[i8 >> 2] = i3;
      } while (!(i3 | 0));
      if ((i10 | 0) == 9) {
       HEAP32[i7 + 40 >> 2] = i6;
       break;
      }
      i10 = i3;
      STACKTOP = i11;
      return i10 | 0;
     }
    }
    i10 = i1;
    STACKTOP = i11;
    return i10 | 0;
   }
  }
 } while (0);
 HEAP32[i7 + 44 >> 2] = -1;
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = i6 + 16 | 0;
 i9 = i7 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 28 | 0;
 i2 = HEAP32[i1 >> 2] & 255;
 HEAP8[i8 >> 0] = i2;
 if ((i4 + 1 | 0) >>> 0 < i3 >>> 0) {
  HEAP8[i4 >> 0] = i2;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i9 = HEAP8[i8 >> 0] | 0;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN9ShaderLab10GrabPasses13ApplyGrabPassERKNS_16FastPropertyNameER17ShaderPassContextRKS0_(i1, i9, i2) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 12 | 0;
 i7 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12;
 i6 = (HEAP32[i1 >> 2] | 0) != -1 ? i1 : gb + 1166408 | 0;
 i5 = i2 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = i5;
 i3 = i2;
 L4 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L4;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i12;
  return;
 }
 if ((i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i2 = i1 + 132 | 0;
 if ((HEAP8[i2 >> 0] & 3) != 2) {
  HEAP32[i10 >> 2] = HEAP32[i1 + 112 >> 2];
  HEAP32[i11 >> 2] = 0;
  i13 = HEAP32[i1 + 116 >> 2] | 0;
  i3 = HEAP32[i1 + 120 >> 2] | 0;
  i4 = HEAP32[i1 + 124 >> 2] | 0;
  i5 = HEAP32[i1 + 128 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
  __ZN13RenderTexture10GrabPixelsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii(i7, i8, i13, i3, i4, i5);
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 2;
 }
 __ZN19ShaderPropertySheet38CopyTextureWithAuxiliaryPropertiesFromERKN9ShaderLab16FastPropertyNameERKS_(i9 + 36 | 0, i6, i1);
 STACKTOP = i12;
 return;
}

function __ZN7mecanim9animation8GetRootXERKNS0_18ClipMuscleConstantEPKf(i11, i7, i9) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i8 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i7 + 1116 >> 2] | 0;
 if ((i1 | 0) == -1) i10 = 0; else i10 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1120 >> 2] | 0;
 if ((i1 | 0) == -1) i8 = 0; else i8 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1124 >> 2] | 0;
 if ((i1 | 0) == -1) i6 = 0; else i6 = HEAP32[i9 + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i7 + 1128 >> 2] | 0;
 if ((i1 | 0) == -1) f5 = Math_fround(0.0); else f5 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1132 >> 2] | 0;
 if ((i1 | 0) == -1) f4 = Math_fround(0.0); else f4 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1136 >> 2] | 0;
 if ((i1 | 0) == -1) f3 = Math_fround(0.0); else f3 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 i1 = HEAP32[i7 + 1140 >> 2] | 0;
 if ((i1 | 0) == -1) f2 = Math_fround(1.0); else f2 = Math_fround(HEAPF32[i9 + (i1 << 2) >> 2]);
 f14 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))))));
 f13 = Math_fround(f5 * f14);
 f12 = Math_fround(f4 * f14);
 f4 = Math_fround(f3 * f14);
 f5 = Math_fround(f2 * f14);
 HEAP32[i11 >> 2] = i10;
 HEAP32[i11 + 4 >> 2] = i8;
 HEAP32[i11 + 8 >> 2] = i6;
 HEAPF32[i11 + 12 >> 2] = f13;
 HEAPF32[i11 + 16 >> 2] = f12;
 HEAPF32[i11 + 20 >> 2] = f4;
 HEAPF32[i11 + 24 >> 2] = f5;
 HEAP32[i11 + 28 >> 2] = 1065353216;
 HEAP32[i11 + 32 >> 2] = 1065353216;
 HEAP32[i11 + 36 >> 2] = 1065353216;
 return;
}

function __ZN16ParticleAnimatorC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 190788 + 8;
 i6 = i1 + 32 | 0;
 i2 = i1 + 56 | 0;
 i5 = i1 + 44 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i1 + 88 >> 2] = 184549375;
 HEAP32[i1 + 92 >> 2] = -1258291201;
 HEAP32[i1 + 96 >> 2] = -1;
 HEAP32[i1 + 100 >> 2] = -1258291201;
 HEAP32[i1 + 104 >> 2] = 184549375;
 HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i1 + 112 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP8[i1 + 113 >> 0] = 0;
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZN14MemoryProfiler20UnregisterMemoryToIDEjj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = HEAP32[i1 + 160 >> 2] | 0;
 i4 = i7 + 4 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 if (i8 | 0) {
  i3 = i4;
  i2 = i8;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i4 | 0)) if (!((i3 | 0) == (i4 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) >>> 0 > i5 >>> 0)) {
   i5 = i3 + 20 | 0;
   i6 = (HEAP32[i5 >> 2] | 0) - i6 | 0;
   HEAP32[i5 >> 2] = i6;
   if (i6 | 0) {
    STACKTOP = i10;
    return;
   }
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
   i6 = i7 + 12 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i3);
   i8 = HEAP32[i7 + 8 >> 2] | 0;
   HEAP32[i9 >> 2] = 58;
   HEAP32[i9 + 4 >> 2] = i8;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
   STACKTOP = i10;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 461997 | 0, 0, gb + 461921 | 0, 478, 1, 0, 0, 0);
 STACKTOP = i10;
 return;
}

function __Z52Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleNonAllocRK13Vector2fIcallfP11Il2CppArrayiff(i1, f3, i7, i2, f4, f5) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i7 = i7 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10 + 8 | 0;
 i14 = i10;
 i9 = i10 + 16 | 0;
 i13 = gb + 64016 | 0;
 i8 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i14;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 i6 = i9 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i14);
 i14 = i11;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i8;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 i12 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i1 = __ZN16Physics2DManager16OverlapCircleAllERK8Vector2ffiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i12, i11, f3, i2, f4, f5, 0, i9) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0;
 i2 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i7, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return i2 | 0;
}

function __Z23_SimulationFilterShaderjN5physx12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj(i10, i6, i11, i9, i12, i1, i2) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i2 = i8 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = __Z21GetManagerFromContexti(9) | 0;
 i7 = i4 | i3;
 if (!(i7 & 224)) i4 = (HEAP32[(HEAP32[i1 + 724 >> 2] | 0) + ((i3 & 255) << 2) >> 2] & 1 << (i4 & 255) | 0) == 0; else {
  HEAP32[i5 >> 2] = 31;
  __Z6FormatPKcz(i2, gb + 662636 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 662472 | 0, 1440, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i4 = 0;
 }
 i1 = __ZN8Collider14WordsToPointerEjj(HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0) | 0;
 i2 = __ZN8Collider14WordsToPointerEjj(HEAP32[i9 + 4 >> 2] | 0, HEAP32[i9 + 12 >> 2] | 0) | 0;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) i3 = __ZNK8Collider21ShouldIgnoreCollisionEPS_(i1, i2) | 0; else i3 = 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 if (i2 & 16 | 0) {
  i12 = 2;
  STACKTOP = i8;
  return i12 | 0;
 }
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 if (i4 | i3 | (i1 & 16 | 0) != 0) {
  i12 = 2;
  STACKTOP = i8;
  return i12 | 0;
 }
 i9 = i7 >>> 8;
 HEAP16[i12 >> 1] = i9;
 HEAP16[i12 >> 1] = (((i1 >>> 2 & i2 | i1 & i2 >>> 2) & 16371 | 0) == 0 ? 0 : 2049) | (i9 | (((i11 | i10) & 32 | 0) == 0 ? 1025 : 1044)) & 65535;
 i12 = 0;
 STACKTOP = i8;
 return i12 | 0;
}

function _log10(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = (i3 | 0) < 0;
 do if (i4 | i3 >>> 0 < 1048576) {
  if ((i2 | 0) == 0 & (i3 & 2147483647 | 0) == 0) {
   d1 = -1.0 / (d1 * d1);
   break;
  }
  if (i4) {
   d1 = (d1 - d1) / 0.0;
   break;
  } else {
   HEAPF64[tempDoublePtr >> 3] = d1 * 18014398509481984.0;
   i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
   i4 = -1077;
   i2 = HEAP32[tempDoublePtr >> 2] | 0;
   i5 = 9;
   break;
  }
 } else if (i3 >>> 0 <= 2146435071) if ((i2 | 0) == 0 & 0 == 0 & (i3 | 0) == 1072693248) d1 = 0.0; else {
  i4 = -1023;
  i5 = 9;
 } while (0);
 if ((i5 | 0) == 9) {
  i5 = i3 + 614242 | 0;
  HEAP32[tempDoublePtr >> 2] = i2;
  HEAP32[tempDoublePtr + 4 >> 2] = (i5 & 1048575) + 1072079006;
  d8 = +HEAPF64[tempDoublePtr >> 3] + -1.0;
  d7 = d8 * (d8 * .5);
  d9 = d8 / (d8 + 2.0);
  d10 = d9 * d9;
  d1 = d10 * d10;
  HEAPF64[tempDoublePtr >> 3] = d8 - d7;
  i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i3;
  d6 = +HEAPF64[tempDoublePtr >> 3];
  d1 = d8 - d6 - d7 + d9 * (d7 + (d1 * (d1 * (d1 * .15313837699209373 + .22222198432149784) + .3999999999940942) + d10 * (d1 * (d1 * (d1 * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735)));
  d10 = d6 * .4342944818781689;
  d7 = +(i4 + (i5 >>> 20) | 0);
  d9 = d7 * .30102999566361177;
  d8 = d9 + d10;
  d1 = d8 + (d10 + (d9 - d8) + (d1 * .4342944818781689 + (d7 * 3.694239077158931e-13 + (d6 + d1) * 2.5082946711645275e-11)));
 }
 return +d1;
}

function __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 8 | 0;
 i12 = i15 + 4 | 0;
 i10 = i15;
 HEAP32[i12 >> 2] = i9;
 i13 = i11 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i7 = i1;
 i14 = i9;
 L1 : do if ((i2 | 0) != (i7 | 0)) {
  while (1) {
   i6 = i2;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) == (i9 | 0)) break;
   if ((i1 | 0) == (i7 | 0)) {
    i4 = i9;
    while (1) {
     i5 = HEAP32[i4 + 344 >> 2] | 0;
     if (!i5) break;
     if (!(HEAP8[i4 + 375 >> 0] | 0)) i4 = i5; else break;
    }
    i5 = HEAP16[i4 + 372 >> 1] | 0;
    while (1) {
     i4 = HEAP32[i3 + 344 >> 2] | 0;
     if (!i4) break;
     if (!(HEAP8[i3 + 375 >> 0] | 0)) i3 = i4; else break;
    }
    i1 = i5 << 16 >> 16 < (HEAP16[i3 + 372 >> 1] | 0) ? i6 : i1;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i7 | 0)) break L1;
  }
  STACKTOP = i15;
  return;
 } while (0);
 if (!(__ZNK2UI6Canvas13GetRenderModeEv(i9) | 0)) {
  HEAP32[i10 >> 2] = i1;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i11, i8, i12) | 0;
  STACKTOP = i15;
  return;
 }
 i1 = HEAP32[i13 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i11 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i11, i12);
  STACKTOP = i15;
  return;
 } else {
  HEAP32[i1 >> 2] = i14;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 4;
  STACKTOP = i15;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do {
  i5 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i4 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
  i5 = i2 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i5 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i2;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  i3 = i3 + 16 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS3_EEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i11 + 12 | 0;
 i14 = i11 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = i2 - i1 | 0;
 i3 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i10 = i11 + 8 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 if (!i7) {
  i5 = i11;
  i9 = 0;
  i6 = i1;
  i3 = i2;
 } else {
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 25;
  HEAP32[i12 + 4 >> 2] = i9;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i5 = i11;
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 i4 = i9 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i1 = i3 - i6 | 0;
 i2 = i4 + (0 - (i1 >> 2) << 2) | 0;
 if ((i1 | 0) > 0) {
  _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i6;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i14 >> 2] = i4 + 4;
 HEAP32[i10 >> 2] = i9 + (i7 << 2);
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 25;
 HEAP32[i12 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 STACKTOP = i15;
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim5human5HumanEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim5human5Human8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim5human5Human8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim10ValueArrayEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i2) {
  i3 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i4 = HEAP8[i5 + 26 >> 0] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP8[i1 + 20 >> 0] = 0;
  HEAP8[i1 + 21 >> 0] = i3 & 1;
  HEAP8[i1 + 22 >> 0] = i4;
  i4 = i1 + 16 | 0;
  HEAP32[i4 >> 2] = 0;
  __ZN7mecanim10ValueArray8TransferI8BlobSizeEEvRT_(i6, i1);
  i4 = HEAP32[i4 >> 2] | 0;
  __ZN9BlobWrite4PushEjPKvj(i5, (0 - i4 & 3) + i4 | 0, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i3 = i5 + 44 | 0;
 i9 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 >>> 8 << 2) >> 2] | 0;
 i9 = i9 & 255;
 i8 = i10 + (i9 << 4) + 4 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i9 << 4) >> 2] | 0)) & 3);
 __ZN7mecanim10ValueArray8TransferI9BlobWriteEEvRT_(i6, i5);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i10 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i4 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i3 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i7;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i7;
 return;
}

function __ZN8JSONRead8TransferIsEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37240 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 1024)) {
   if (!(i4 & 512)) {
    if (!(i4 & 1048576)) {
     i1 = 0;
     break;
    }
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    i1 = __Z11StringToIntPKc(i1) | 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   i1 = ~~d2 >>> 0;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP16[i11 >> 1] = i1;
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx9PxTaskMgr10startAfterERNS_6PxTaskEj(i3, i1, i10) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i6 = i3 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i7 = i3 + 76 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i3 + 64 | 0;
 i4 = i1 + 12 | 0;
 i1 = i3 + 68 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = -1;
 if ((HEAP32[i3 + 72 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
  i12 = i2;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = (HEAP32[i9 >> 2] | 0) + (i5 << 3) | 0;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_17PxTaskDepTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i2) | 0;
 i1 = i8 + (i10 * 20 | 0) + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i8 + (i10 * 20 | 0) + 12 >> 2] = i5;
  i12 = HEAP32[i4 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i12 = i10 + (i12 * 20 | 0) + 4 | 0;
  __ZN5physx6shdfnd15atomicIncrementEPVi(i12) | 0;
  i12 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 3) + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = i5;
  i12 = HEAP32[i4 >> 2] | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i12 = i10 + (i12 * 20 | 0) + 4 | 0;
  __ZN5physx6shdfnd15atomicIncrementEPVi(i12) | 0;
  i12 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i11;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 2) | 0, 0, i6 - i5 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN15ReflectionProbe19ClearRenderTexturesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 i3 = i8;
 i7 = i6 + 164 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 168 >> 2] = 0;
 HEAP8[i6 + 176 >> 0] = 0;
 if ((HEAP32[i6 + 156 >> 2] | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i7 = HEAP32[gb + 1112272 >> 2] | 0;
 i4 = __ZNK15ReflectionProbe10GetTextureEv(i6) | 0;
 if (!i4) i1 = 0; else {
  HEAP32[i3 >> 2] = i4;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i5 = 8; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i9 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i9 + (i3 << 3) | 0;
    i2 = i9;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i2, i3);
    i1 = HEAP32[i1 >> 2] | 0;
    i9 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i9 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i9 + (i1 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 10;
   }
  }
  if ((i5 | 0) == 8) i5 = 10;
  if ((i5 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 }
 __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture(i7, i6, i1);
 STACKTOP = i8;
 return;
}

function __Z28SortingLayer_CUSTOM_NameToIDP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 48 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i4 = __Z13GetTagManagerv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i5);
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 24 | 0;
 i10 = gb + 63648 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i3 = HEAP8[i8 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i10 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i7 + 4 >> 2] = i3;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i5 >> 2] = i3;
 i1 = __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __Z24AudioClip_CUSTOM_GetDataP12Il2CppObjectP11Il2CppArrayi(i6, i3, i4) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i7 = i8 + 4 | 0;
 if (!i6) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i2 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZNK9AudioClip15GetChannelCountEv(i1) | 0;
 if ((i2 | 0) >= 1) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
  i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  i7 = (__ZNK9AudioClip7GetDataEPfjj(i1, i7, (__Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0) / (i2 | 0) | 0, i4) | 0) & 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 __Z6FormatPKcz(i7, gb + 883609 | 0, i5);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 875076 | 0, 369, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN8JSONRead8TransferIaEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37252 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 1024)) {
   if (!(i4 & 512)) {
    if (!(i4 & 1048576)) {
     i1 = 0;
     break;
    }
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    i1 = __Z11StringToIntPKc(i1) | 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 2048 | 0) {
     d2 = +((HEAP32[i1 >> 2] | 0) >>> 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   i1 = ~~d2 >>> 0;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP8[i11 >> 0] = i1;
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx13IslandManager6resizeEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 >>> 5;
 i6 = i9 << 4;
 i7 = ((i9 << 2) + 15 & -16) + i6 | 0;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, i7 + ((i8 << 2) + 15 & 1073741808) | 0, gb + 681489 | 0, 1142) | 0;
 i6 = i4 + i6 | 0;
 i7 = i4 + i7 | 0;
 i3 = i10 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i2 = i10 + 8 | 0;
  i5 = i10 + 12 | 0;
  i1 = i3;
 } else {
  i5 = i10 + 12 | 0;
  _memcpy(i4 | 0, i1 | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
  i2 = i10 + 8 | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  _memcpy(i7 | 0, HEAP32[i10 + 40 >> 2] | 0, HEAP32[i10 + 44 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i3 >> 2] | 0);
  i1 = i3;
 }
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 >> 2] = i6;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i10 + 16 | 0;
 i3 = i9 + -1 | 0;
 HEAP32[i6 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 if (i3 >>> 0 > i1 >>> 0) {
  i4 = i1;
  do {
   i12 = i4;
   i4 = i4 + 1 | 0;
   HEAP32[i6 + (i12 << 2) >> 2] = i4;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAP32[i2 >> 2] = i1;
 i12 = i10 + 20 | 0;
 HEAP32[i12 >> 2] = (((i9 | 0) == 0) << 31 >> 31) + i9 - i1 + (HEAP32[i12 >> 2] | 0);
 i12 = i10 + 44 | 0;
 i6 = HEAP32[i12 >> 2] | 0;
 _memset(i7 + (i6 << 2) | 0, 0, i8 - i6 << 2 | 0) | 0;
 i6 = HEAP32[i10 + 36 >> 2] | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i8 | -2147483648;
 HEAP32[i10 + 40 >> 2] = i7;
 HEAP32[i12 >> 2] = i8;
 HEAP32[i5 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __Z19TreePrototypeToMonoRK13TreePrototypeR17MonoTreePrototype(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  HEAP32[i5 >> 2] = i6;
  i4 = i4 + 4 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 HEAP32[i5 >> 2] = i6;
 i6 = i4 + 4 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i5 + 4 | 0;
 HEAP32[i8 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZNK6Camera17GetSkyboxMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 31672 | 0) | 0;
 if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) if (__ZNK6Skybox11GetMaterialEv(i1) | 0) {
  i5 = __ZNK6Skybox11GetMaterialEv(i1) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = (__Z17GetRenderSettingsv() | 0) + 360 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 11; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 11; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 13;
  }
 }
 if ((i5 | 0) == 11) i5 = 13;
 if ((i5 | 0) == 13) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb(i5, i4, i2) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i5 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 & 32768 | 0) return;
 HEAP32[i3 >> 2] = i1 & -98305 | 32768;
 if (i2) {
  i1 = (HEAP32[i5 + 48 >> 2] | 0) + 14 | 0;
  HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
  i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 32 >> 2] | 0) | 0;
  i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 36 >> 2] | 0) | 0;
  if (i1 | 0) {
   i1 = i1 + 148 | 0;
   HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
  }
  if (i2 | 0) {
   i2 = i2 + 148 | 0;
   HEAP16[i2 >> 1] = (HEAP16[i2 >> 1] | 0) + 1 << 16 >> 16;
  }
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(i1 & 262144)) {
  __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, i5 + 60 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (!(i1 & 476)) return;
 if (i1 & 4 | 0) __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i5, 4, (HEAP16[(HEAP32[i5 + 48 >> 2] | 0) + 14 >> 1] | 0) == 1 ? 4 : 0, 0, i4);
 if (i1 & 8 | 0) {
  __ZN5physx2Sc10NPhaseCore39addToPersistentContactEventPairsDelayedEPNS0_19ShapeInstancePairLLE(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0) + 1104 >> 2] | 0, i5);
  return;
 }
 if (!(i1 & 448)) return;
 __ZN5physx2Sc10NPhaseCore36addToForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i5 + 32 >> 2] | 0) | 0) + 1104 >> 2] | 0, i5);
 return;
}

function __ZN5physx16PxsBroadPhaseMBP11freeBuffersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 i2 = i1 + 88 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 __ZN5physx2Gu9Container5EmptyEv(i1 + 5236 | 0) | 0;
 i1 = i5 + 96 | 0;
 i2 = i5 + 100 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 > 1024) {
  HEAP32[i4 >> 2] = 1073741823;
  HEAP32[i4 + 4 >> 2] = 1073741823;
  __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, 0, i4);
  __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, HEAP32[i2 >> 2] | 0);
  if ((HEAP32[i5 + 104 >> 2] & 2147482624) >>> 0 < 1024) __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, 1024);
 } else HEAP32[i2 >> 2] = 0;
 i1 = i5 + 108 | 0;
 i2 = i5 + 112 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 <= 1024) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 >> 2] = 1073741823;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, 0, i4);
 __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, HEAP32[i2 >> 2] | 0);
 if ((HEAP32[i5 + 116 >> 2] & 2147482624) >>> 0 >= 1024) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, 1024);
 STACKTOP = i6;
 return;
}

function __ZN16DeprecatedColors8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10;
 i1 = i8;
 i2 = gb + 421273 | 0;
 i3 = i1 + 11 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i8 + 8 | 0;
 i4 = HEAP32[gb + 36980 >> 2] | 0;
 i2 = 0;
 do {
  HEAP8[i3 >> 0] = i2 + 48;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i8, i4, i7, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i9, i6); else {
    i1 = HEAP32[i7 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
  i1 = HEAP32[i9 >> 2] | 0;
  f13 = Math_fround(Math_fround((i1 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f12 = Math_fround(Math_fround(i1 >>> 16 & 255) / Math_fround(255.0));
  f11 = Math_fround(Math_fround(i1 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i5 + (i2 * 20 | 0) >> 2] = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
  HEAPF32[i5 + (i2 * 20 | 0) + 4 >> 2] = f13;
  HEAPF32[i5 + (i2 * 20 | 0) + 8 >> 2] = f12;
  HEAPF32[i5 + (i2 * 20 | 0) + 12 >> 2] = f11;
  i1 = i5 + (i2 * 20 | 0) + 16 | 0;
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(i2 | 0) * Math_fround(.25));
  HEAPF32[i5 + 100 + (i2 << 3) >> 2] = f11;
  HEAP32[i5 + 100 + (i2 << 3) + 4 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 5);
 STACKTOP = i10;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfertEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37288 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfersEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37240 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37252 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z18StripAllWhitespaceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = i6 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i9 = i1 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i1 & 255;
 if ((i9 | 0) > 0) {
  i4 = 0;
  i2 = 0;
  i3 = 0;
  while (1) {
   i1 = (HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i6) + i3 >> 0] | 0) + -9 << 24 >> 24;
   if ((i1 & 255) < 24 & (8388639 >>> (i1 & 255) & 1 | 0) != 0) {
    if (!i2) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i9);
    if ((i3 | 0) != (i4 | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i7, i6, i4, i3 - i4 | 0) | 0;
    i3 = i3 + 1 | 0;
    i1 = i3;
    i2 = 1;
   } else {
    i1 = i4;
    i3 = i3 + 1 | 0;
   }
   if ((i3 | 0) == (i9 | 0)) break;
   i4 = i1;
   i1 = HEAP8[i8 >> 0] | 0;
  }
  if (i2) {
   if ((i1 | 0) < (i9 | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i7, ((HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) + i1 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i7);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   STACKTOP = i10;
   return;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN8Material43AddDefaultShaderPropertiesToSavedPropertiesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[i6 + 100 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 164 >> 0] & 1) {
  STACKTOP = i7;
  return;
 }
 i4 = i6 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 11;
  }
 }
 if ((i5 | 0) == 9) i5 = 11;
 if ((i5 | 0) == 11) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i7;
   return;
  }
 }
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 __ZN18UnityPropertySheet20AddNewShaderlabPropsERK19ShaderPropertySheet(i6 + 44 | 0, HEAP32[i1 + 92 >> 2] | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i12, i9) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i12 + 8 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i1 = i11 * 56 | 0;
  if (!i1) i7 = 0; else {
   i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i6 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i7 = mftCall_iiiiii(i6 | 0, i8 | 0, i1 | 0, (i7 ? gb + 657015 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i8 = i12 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i7 + (i1 * 56 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i12 >> 2] | 0;
  while (1) {
   i3 = i1;
   i4 = i2;
   i5 = i3 + 56 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   i1 = i1 + 56 | 0;
   if (i1 >>> 0 >= i6 >>> 0) break; else i2 = i2 + 56 | 0;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i3 = i7 + (i1 * 56 | 0) | 0;
 i4 = i9;
 i5 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 if ((HEAP32[i10 >> 2] | 0) > -1) {
  i1 = HEAP32[i12 >> 2] | 0;
  if (i1 | 0) {
   i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
  }
 }
 HEAP32[i12 >> 2] = i7;
 HEAP32[i10 >> 2] = i11;
 i12 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i12 + 1;
 return i7 + (i12 * 56 | 0) | 0;
}

function __Z31GUIText_Get_Custom_PropMaterialP12Il2CppObject(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i3 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN20TextRenderingPrivate7GUIText11GetMaterialEv(i1) | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1008286 | 0, 8);
  i3 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 30792 | 0, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i2 = i3;
 } else i2 = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i3 = __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb(i2, i1, 0) | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN20TextRenderingPrivate7GUIText11SetMaterialEP8Material(i1, i3);
 i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _csqrtf(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f6 = f0, d7 = 0.0, d8 = 0.0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 do if (f6 == Math_fround(0.0) & f4 == Math_fround(0.0)) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i5 + 4 >> 2] = f4;
 } else {
  if (((HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647 | 0) == 2139095040) {
   HEAPF32[i5 >> 2] = Math_fround(inf);
   HEAPF32[i5 + 4 >> 2] = f4;
   break;
  }
  i3 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
  i1 = i3 & 2147483647;
  if (i1 >>> 0 > 2139095040) {
   f4 = Math_fround(f4 - f4);
   f4 = Math_fround(f4 / f4);
   HEAPF32[i5 >> 2] = f6;
   HEAPF32[i5 + 4 >> 2] = f4;
   break;
  }
  if ((i1 | 0) == 2139095040) {
   f2 = Math_fround(f4 - f4);
   if ((i3 | 0) < 0) {
    f2 = Math_fround(Math_abs(Math_fround(f2)));
    f6 = Math_fround(_copysignf(f6, f4));
    HEAPF32[i5 >> 2] = f2;
    HEAPF32[i5 + 4 >> 2] = f6;
    break;
   } else {
    f4 = Math_fround(_copysignf(f2, f4));
    HEAPF32[i5 >> 2] = f6;
    HEAPF32[i5 + 4 >> 2] = f4;
    break;
   }
  } else if (!(f6 >= Math_fround(0.0))) {
   d7 = +Math_fround(-f6);
   d7 = +Math_sqrt(+((d7 + +_hypot(+f6, +f4)) * .5));
   f2 = Math_fround(+Math_fround(Math_abs(Math_fround(f4))) / (d7 * 2.0));
   f6 = Math_fround(_copysignf(Math_fround(d7), f4));
   HEAPF32[i5 >> 2] = f2;
   HEAPF32[i5 + 4 >> 2] = f6;
   break;
  } else {
   d7 = +f6;
   d8 = +f4;
   d7 = +Math_sqrt(+((d7 + +_hypot(d7, d8)) * .5));
   f6 = Math_fround(d8 / (d7 * 2.0));
   HEAPF32[i5 >> 2] = Math_fround(d7);
   HEAPF32[i5 + 4 >> 2] = f6;
   break;
  }
 } while (0);
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNK14ParticleSystem21GetCustomParticleDataEPN4math14float4_storageEii(i1, i10, i6, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i8 = i11 + 31 & -32;
 i9 = i8 << 4;
 i4 = i1 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i5 + 828 + (i6 * 20 | 0) | 0;
 i2 = i5 + 828 + (i6 * 20 | 0) + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i9, 4, i5 + 828 + (i6 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 4, i5 + 828 + (i6 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 828 + (i6 * 20 | 0) + 12 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i9;
  break;
 } while (0);
 i8 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy(i8 + 828 + (i6 * 20 | 0) | 0, i9 >>> 0 > i11 >>> 0 ? i9 : i11, i7, 1);
 if ((i11 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i2 = (HEAP32[i4 >> 2] | 0) + 828 + (i6 * 20 | 0) | 0;
 i3 = i11 << 4;
 i1 = 0;
 do {
  _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i7, i8, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i5 = i9;
 i6 = i5 + 108 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i2 = i7 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i8 * 108 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 108 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 108 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 if (i5 >>> 0 >= i8 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i1 + (i5 * 108 | 0) | 0;
 i2 = i8 - i5 | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i5 = i4 + (i1 * 108 | 0) | 0;
  i3 = i9;
  i6 = i5 + 108 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   i5 = i5 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14ParticleSystem21SetCustomParticleDataEPKN4math14float4_storageEii(i1, i10, i6, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i8 = i11 + 31 & -32;
 i9 = i8 << 4;
 i4 = i1 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i5 + 828 + (i6 * 20 | 0) | 0;
 i2 = i5 + 828 + (i6 * 20 | 0) + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i9, 4, i5 + 828 + (i6 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 4, i5 + 828 + (i6 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 828 + (i6 * 20 | 0) + 12 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = i9;
  break;
 } while (0);
 i8 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy(i8 + 828 + (i6 * 20 | 0) | 0, i9 >>> 0 > i11 >>> 0 ? i9 : i11, i7, 1);
 if ((i11 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i2 = (HEAP32[i4 >> 2] | 0) + 828 + (i6 * 20 | 0) | 0;
 i3 = i11 << 4;
 i1 = 0;
 do {
  _memcpy(HEAP32[i2 >> 2] | 0, i10 | 0, i3 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var d1 = 0.0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i4 = i9 + 8 | 0;
 i2 = i9;
 i5 = i9 + 24 | 0;
 d1 = +Math_fround(HEAPF32[i3 >> 2]);
 i8 = i5;
 i10 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAPF64[i2 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i2) | 0;
 if (HEAP8[i5 >> 0] | 0) {
  i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i10 | 0, i6 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
 d1 = +Math_fround(HEAPF32[i3 + 4 >> 2]);
 i8 = i5;
 i10 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAPF64[i4 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i4) | 0;
 if (HEAP8[i5 >> 0] | 0) {
  i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i10 | 0, i6 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
 d1 = +Math_fround(HEAPF32[i3 + 8 >> 2]);
 i8 = i5;
 i10 = i8 + 128 | 0;
 do {
  HEAP8[i8 >> 0] = 0;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) < (i10 | 0));
 HEAPF64[i7 >> 3] = d1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i7) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i9;
  return i6 | 0;
 }
 i10 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 mftCall_iiii(i10 | 0, i6 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 STACKTOP = i9;
 return i6 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 << 4 | 0, 4) | 0;
  i2 = i3 + (i2 << 4) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
    i1 = i1 + 16 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i7 << 4) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorI17TransferMetaFlags13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i11 + 12 | 0;
 i14 = i11 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = i2 - i1 | 0;
 i3 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i10 = i11 + 8 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 if (!i7) {
  i5 = i11;
  i9 = 0;
  i6 = i1;
  i3 = i2;
 } else {
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i9;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i5 = i11;
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 i4 = i9 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i1 = i3 - i6 | 0;
 i2 = i4 + (0 - (i1 >> 2) << 2) | 0;
 if ((i1 | 0) > 0) {
  _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i6;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i14 >> 2] = i4 + 4;
 HEAP32[i10 >> 2] = i9 + (i7 << 2);
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 STACKTOP = i15;
 return;
}

function __ZN9Scripting28CreateEngineScriptableObjectEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i2 = i5 + 24 | 0;
 i3 = i5;
 if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z26scripting_object_get_classP12Il2CppObject(i1) | 0;
 i7 = __Z29scripting_class_get_namespaceP11Il2CppClass(i6) | 0;
 i9 = __Z24scripting_class_get_nameP11Il2CppClass(i6) | 0;
 i8 = HEAP8[i7 >> 0] | 0 ? gb + 1087625 | 0 : gb + 1576256 | 0;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i9;
 HEAP32[i4 + 12 >> 2] = i9;
 __Z6FormatPKcz(i2, gb + 465667 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 465174 | 0, 648, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 465174 | 0, 650) | 0;
 i9 = gb + 63520 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
 __Z19pop_allocation_rootv();
 i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
 __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i4, i6, i1);
 __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb(i4, 1);
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i1 = i10 + 12 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i10 >> 2] = i2;
  break;
 } while (0);
 if (i5 >>> 0 > i6 >>> 0) {
  i1 = i5 - i6 | 0;
  if (i1 | 0) _memset(i2 + i6 | 0, 0, i1 | 0) | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i5 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
 }
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i2) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i10 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i1 = i10 + 12 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i5 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i10 >> 2] = i2;
  break;
 } while (0);
 if (i5 >>> 0 > i6 >>> 0) {
  i1 = i5 - i6 | 0;
  if (i1 | 0) _memset(i2 + i6 | 0, 0, i1 | 0) | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1);
 STACKTOP = i8;
 return;
}

function __ZN18ProceduralMaterial24IsProceduralInputVisibleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i2 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i8 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i8 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i8; else {
   i1 = i8;
   i6 = 6;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i8 + 4 >> 2] = i4;
  i2 = i8 + 11 | 0;
  i6 = 6;
 }
 if ((i6 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __Z24IsProceduralInputVisiblePK18ProceduralMaterialRK8UnityStr(i5, i8) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 66;
 HEAP32[i7 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN17SurfaceEffector2D12SetUseBounceEb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f5 = f0, f6 = f0, i7 = 0;
 HEAP8[i3 + 106 >> 0] = i4 & 1;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 i2 = HEAP32[i3 + 48 >> 2] | 0;
 if (!i2) return;
 i2 = i1 + (i2 * 40 | 0) | 0;
 if (!(HEAP8[i3 + 105 >> 0] | 0)) if (i4) {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   f6 = Math_fround(HEAPF32[(HEAP32[i4 + 48 >> 2] | 0) + 40 >> 2]);
   f5 = Math_fround(HEAPF32[(HEAP32[i4 + 52 >> 2] | 0) + 40 >> 2]);
   HEAPF32[i4 + 148 >> 2] = f6 > f5 ? f6 : f5;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   HEAPF32[i4 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else if (i4) {
  do {
   i4 = HEAP32[i1 + 32 >> 2] | 0;
   i7 = HEAP32[i4 + 48 >> 2] | 0;
   f5 = Math_fround(HEAPF32[i7 + 36 >> 2]);
   i3 = HEAP32[i4 + 52 >> 2] | 0;
   HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f5 * Math_fround(HEAPF32[i3 + 36 >> 2]))));
   f5 = Math_fround(HEAPF32[i7 + 40 >> 2]);
   f6 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   HEAPF32[i4 + 148 >> 2] = f5 > f6 ? f5 : f6;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 } else {
  do {
   i7 = HEAP32[i1 + 32 >> 2] | 0;
   f6 = Math_fround(HEAPF32[(HEAP32[i7 + 48 >> 2] | 0) + 36 >> 2]);
   HEAPF32[i7 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f6 * Math_fround(HEAPF32[(HEAP32[i7 + 52 >> 2] | 0) + 36 >> 2]))));
   HEAPF32[i7 + 148 >> 2] = Math_fround(0.0);
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
}

function __ZN16DeveloperConsole7DrawBoxEffR8GUIStateff(i10, f11, f12, i13, f14, f15) {
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0, i17 = 0, f18 = f0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i17;
 i7 = HEAP32[i10 + 120 >> 2] | 0;
 i2 = HEAP32[i10 + 8 >> 2] | 0;
 i5 = i10 + 4 | 0;
 i3 = i2;
 i8 = i10 + 76 | 0;
 i9 = i10 + 84 | 0;
 if ((i3 | 0) == (i5 | 0)) f1 = Math_fround(0.0); else {
  i6 = i10 + 80 | 0;
  f1 = Math_fround(0.0);
  do {
   __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i8, HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0);
   HEAP8[i9 >> 0] = 0;
   i4 = HEAP32[i2 + 8 >> 2] | 0;
   if ((i4 | 0) > 0) HEAP32[i6 >> 2] = i4;
   f18 = Math_fround(__ZNK8GUIStyle10CalcHeightER10GUIContentf(i7, i8, f15));
   HEAPF32[i2 + 16 >> 2] = f18;
   f1 = Math_fround(f1 + f18);
   i2 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i2;
  } while ((i3 | 0) != (i5 | 0));
 }
 i7 = HEAP32[i10 + 128 >> 2] | 0;
 __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i8, HEAP32[i10 + 132 >> 2] | 0, HEAP32[i10 + 136 >> 2] | 0);
 HEAP8[i9 >> 0] = 0;
 f18 = Math_fround(f1 + Math_fround(__ZNK8GUIStyle10CalcHeightER10GUIContentf(i7, i8, f15)));
 f14 = Math_fround(Math_fround(f14 - f18) - f12);
 f15 = Math_fround(f15 - f11);
 HEAPF32[i16 >> 2] = f11;
 HEAPF32[i16 + 8 >> 2] = f15;
 HEAPF32[i16 + 4 >> 2] = f14;
 HEAPF32[i16 + 12 >> 2] = f18;
 __ZN5IMGUI8GUILabelER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle(i13, i16, i8, i7);
 STACKTOP = i17;
 return Math_fround(f1);
}

function __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i6, i8, i2) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i6 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
 }
 i4 = i6 + 12 | 0;
 i5 = i9;
 i7 = i5 + 56 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i8 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i8 * 56 | 0, 8, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 56 | 0, 8, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 56 | 0) | 0;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i6 >> 2] = i1;
  break;
 } while (0);
 if (i5 >>> 0 >= i8 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i1 + (i5 * 56 | 0) | 0;
 i2 = i8 - i5 | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i5 = i4 + (i1 * 56 | 0) | 0;
  i3 = i9;
  i7 = i5 + 56 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   i5 = i5 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i5 | 0) < (i7 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN12_GLOBAL__N_110Connection16sendErrorMessageEjPKcS2_j(i12, i1, i4, i2, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 32 | 0;
 i11 = i13 + 24 | 0;
 i10 = i13;
 i8 = i13 + 4 | 0;
 HEAP32[i8 >> 2] = gb + 150348 + 8;
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i4;
 i7 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = i2;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i9 >> 2] = gb + 149652 + 8;
 i5 = i9 + 4 | 0;
 HEAP32[i5 >> 2] = i10;
 HEAP32[i10 >> 2] = 5;
 i1 = i4 | 0 ? i4 : gb + 1576256 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = 9;
  i2 = i10;
  i3 = 0;
  i4 = gb + 149652 + 8 | 0;
 } else {
  i3 = (_strlen(i1) | 0) + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = i1;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
 mftCall_vii(HEAP32[i4 + 28 >> 2] | 0, i9 | 0, i7 | 0);
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i9 | 0, i6 | 0);
 i12 = i12 + 28 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i10 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, HEAP32[i10 >> 2] | 0, 1, 0, 0) | 0;
 HEAP32[i11 >> 2] = gb + 149708 + 8;
 HEAP32[i11 + 4 >> 2] = i10;
 HEAP8[i9 >> 0] = 27;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i9 | 0, 1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i11 | 0);
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i12 >> 2] | 0) + 28 >> 2] | 0, i12 | 0);
 STACKTOP = i13;
 return;
}

function __Z33Font_Get_Custom_PropCharacterInfoP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) >> 2] | 0, 52, i5) | 0;
 i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 52) | 0;
 if ((i5 | 0) <= 0) return i3 | 0;
 i2 = i1 + 40 | 0;
 i1 = 0;
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + (i1 * 52 | 0) >> 2] = HEAP32[i6 + (i1 * 60 | 0) >> 2];
  i7 = i4 + (i1 * 52 | 0) + 4 | 0;
  i8 = i6 + (i1 * 60 | 0) + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i7 = i4 + (i1 * 52 | 0) + 20 | 0;
  i8 = i6 + (i1 * 60 | 0) + 20 | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i4 + (i1 * 52 | 0) + 36 >> 2] = HEAP32[i6 + (i1 * 60 | 0) + 36 >> 2];
  HEAP32[i4 + (i1 * 52 | 0) + 40 >> 2] = HEAP32[i6 + (i1 * 60 | 0) + 40 >> 2];
  HEAP32[i4 + (i1 * 52 | 0) + 44 >> 2] = HEAP32[i6 + (i1 * 60 | 0) + 44 >> 2];
  HEAP8[i4 + (i1 * 52 | 0) + 48 >> 0] = HEAP8[i6 + (i1 * 60 | 0) + 56 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return i3 | 0;
}

function __Z28RemoteSettings_CUSTOM_GetIntP12Il2CppStringi(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 48 | 0;
 i8 = i10 + 16 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i5 = (__Z21GetUnityConnectClientv() | 0) + 768 | 0;
 __ZNK11ICallString6ToUTF8Ev(i9, i2);
 i2 = (HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i7 = i8 + 24 | 0;
 i11 = gb + 63648 | 0;
 i4 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i8 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 15) {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[i8 + 4 >> 2] = i4;
  i1 = (i11 | 0) == 0 ? i1 : i11;
 }
 _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i3 >> 2] = i4;
 i1 = __ZN11UnityEngine7Connect14RemoteSettings6GetIntERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEi(i5, i8, i6) | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 if (!(HEAP32[i8 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return i1 | 0;
}

function __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i7, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Scb5Scene3addINS0_10ConstraintELb1EEEvRT_RNS0_13ObjectTrackerE(i7, i8, i4) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i6 = i9;
 HEAP32[i8 >> 2] = i7;
 i2 = i8 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i7 + 2433 >> 0] | 0)) {
  HEAP32[i2 >> 2] = i3 & 268435455 | -2147483648;
  __ZN5physx34NpConstraintGetRigidObjectsFromScbERKNS_3Scb10ConstraintERPNS0_11RigidObjectES6_(i8, i5, i6);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i2 = 0; else i2 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0;
  __ZN5physx2Sc5Scene13addConstraintERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_(i7 + 16 | 0, i8 + 12 | 0, i2, i1);
  STACKTOP = i9;
  return;
 }
 i1 = i3 & 1073741823;
 if (i3 >>> 0 > 3221225471) {
  HEAP32[i2 >> 2] = i1 | -2147483648;
  if (i3 & 268435456 | 0) {
   STACKTOP = i9;
   return;
  }
  HEAP32[i5 >> 2] = i8;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i4, i5) | 0;
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i2 >> 2] = i1 | 1073741824;
  HEAP32[i6 >> 2] = i8;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i6, i5) | 0;
  if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Gu8EdgeList4LoadERNS_13PxInputStreamE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 8 | 0;
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(69, 68, 71, 69, i4, i1, i2) | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i5 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i1 >> 0] | 0) != 0, i2) | 0;
 HEAP32[i3 >> 2] = i5;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 7 | 0, i5 << 3, gb + 728039 | 0, 52) | 0;
 HEAP32[i3 + 4 >> 2] = i5;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i5 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 i5 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i1 >> 0] | 0) != 0, i2) | 0;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = i5;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 6 | 0, i5 * 12 | 0, gb + 728039 | 0, 57) | 0;
 HEAP32[i3 + 12 >> 2] = i5;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i5 | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 5 | 0, HEAP32[i3 >> 2] << 3, gb + 728039 | 0, 61) | 0;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = i1;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAPU16[i5 + (i1 << 3) + 2 >> 1] | 0) + (HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0) << 2;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 4 | 0, i1, gb + 728039 | 0, 66) | 0;
 HEAP32[i3 + 20 >> 2] = i5;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i5 | 0, i1 | 0) | 0;
 i3 = 1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN10GameObject17WillHandleMessageERK17MessageIdentifier(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i13 = HEAP32[i1 + 8 >> 2] | 0;
 i14 = i2 + 28 | 0;
 i12 = i2 + 40 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i15 = 0;
  STACKTOP = i16;
  return i15 | 0;
 }
 i2 = HEAP32[i14 >> 2] | 0;
 i10 = i15 + 4 | 0;
 i11 = i15 + 8 | 0;
 i9 = i2;
 while (1) {
  i3 = HEAP32[i9 >> 2] | 0;
  i8 = (Math_imul(HEAP32[gb + 1104584 + 44 >> 2] | 0, i13) | 0) + i3 | 0;
  if (1 << (i8 & 31) & HEAP32[(HEAP32[gb + 1104584 + 16 >> 2] | 0) + (i8 >>> 5 << 2) >> 2]) {
   i4 = HEAP32[i9 + 4 >> 2] | 0;
   i5 = HEAP32[gb + 1104584 + 28 >> 2] | 0;
   i6 = HEAP32[gb + 1104584 + 52 >> 2] | 0;
   i7 = HEAP32[i6 + (i13 * 20 | 0) + 8 >> 2] | 0;
   i8 = HEAP32[i5 + (i3 << 5) >> 2] | 0;
   if ((i7 | 0) < ((HEAP32[i5 + (i3 << 5) + 4 >> 2] | 0) - i8 >> 2 | 0)) if (HEAP32[i8 + (i7 << 2) >> 2] | 0) {
    i1 = 1;
    i2 = 11;
    break;
   }
   if (HEAP32[i5 + (i3 << 5) + 24 >> 2] | 0) if (HEAP32[i6 + (i13 * 20 | 0) + 16 >> 2] & 1) {
    HEAP32[i15 >> 2] = 0;
    HEAP32[i10 >> 2] = 0;
    HEAP32[i11 >> 2] = 0;
    if (mftCall_iiii(HEAP32[i5 + (i3 << 5) + 28 >> 2] | 0, i4 | 0, i7 | 0, i15 | 0) | 0) {
     i1 = 1;
     i2 = 11;
     break;
    }
    i2 = HEAP32[i14 >> 2] | 0;
    i1 = HEAP32[i12 >> 2] | 0;
   }
  }
  i9 = i9 + 8 | 0;
  if ((i9 | 0) == (i2 + (i1 << 3) | 0)) {
   i1 = 0;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) {
  STACKTOP = i16;
  return i1 | 0;
 }
 return 0;
}

function __ZL8MainLoopv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i6 = i7;
 i1 = HEAP32[gb + 1103836 >> 2] | 0;
 if (i1 | 0) _JS_Eval_ClearTimeout(i1 | 0);
 __Z19scripting_gc_enablev();
 __Z29scripting_gc_collect_a_littlev() | 0;
 __Z20scripting_gc_disablev();
 __ZN18ScreenManagerWebGL6UpdateEv(__Z16GetScreenManagerv() | 0);
 if (__Z25GetShouldShowSplashScreenv() | 0) if (!(__Z26IsSplashScreenFadeCompletev() | 0)) {
  __Z16DrawSplashScreenb(1);
  STACKTOP = i7;
  return;
 }
 __Z11UpdateInputv();
 if ((__Z14GetPlayerPausev() | 0) == 2) {
  i2 = __ZN15GlobalCallbacks3GetEv() | 0;
  i3 = i2 + 20068 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = 0;
   do {
    i4 = i2 + 19300 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i2 + 19300 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 19300 + (i1 * 12 | 0) + 4 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
 } else {
  if ((__Z14GetPlayerPausev() | 0) == 1) __Z14SetPlayerPause11PlayerPauseb(2, 1);
  __Z14SetIsBatchmodeb(0);
  __Z25SetNeedToPerformRenderingb(1);
  __Z10PlayerLoopv();
 }
 i1 = _JS_Eval_SetTimeout(fb + 3295 | 0, 0, 1e3) | 0;
 HEAP32[gb + 1103836 >> 2] = i1;
 i1 = __Z18GetTargetFrameRatev() | 0;
 if ((i1 | 0) < 1) {
  i1 = 1;
  i2 = 1;
 } else {
  i1 = 1e3 / (i1 >>> 0) | 0;
  i2 = 0;
 }
 _emscripten_get_main_loop_timing(i5 | 0, i6 | 0);
 if (!((i2 | 0) == (HEAP32[i5 >> 2] | 0) ? (i1 | 0) == (HEAP32[i6 >> 2] | 0) : 0)) _emscripten_set_main_loop_timing(i2 | 0, i1 | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN9AudioClip10InitWSoundEPN11SoundHandle8InstanceE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 __ZN9AudioClip16EnableLegacyModeEv(i3);
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (!i1) i2 = 4; else if (!(HEAP8[i1 + 224 >> 0] | 0)) i2 = 4;
 if ((i2 | 0) == 4) {
  __ZN11SoundHandle7ReleaseEv(i3 + 56 | 0);
  i1 = HEAP8[i3 + 72 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 76 >> 2] | 0; else i1 = i1 & 255;
  if (i1 | 0) if (__Z24GetManagerPtrFromContexti(3) | 0) __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i3);
 }
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  __ZN9AudioClip16EnableLegacyModeEv(i3);
  if (__ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0) {
   i2 = i3 + 124 | 0;
   i1 = (HEAP32[i2 >> 2] | 0) + 60 | 0;
   i7 = __Z24GetAudioScriptingClassesv() | 0;
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   HEAP8[i1 + 4 >> 0] = HEAP8[i7 + 4 >> 0] | 0;
   i2 = (HEAP32[i2 >> 2] | 0) + 68 | 0;
   i1 = (__Z24GetAudioScriptingClassesv() | 0) + 8 | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
  }
 }
 HEAP32[i5 >> 2] = __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip(__Z15GetSoundManagerv() | 0, i4, 0, i3) | 0;
 __ZN11SoundHandleaSERKS_(i3 + 56 | 0, i5);
 __ZN11SoundHandleD2Ev(i5);
 HEAP32[(HEAP32[i3 + 124 >> 2] | 0) + 48 >> 2] = 0;
 i7 = 1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN8LODGroup18OnTransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 12 | 0;
 i4 = i7;
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 if ((i5 | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[gb + 1161200 >> 2] | 0;
 if (!(i2 & 8)) {
  __ZNK9Transform14TransformPointERK8Vector3f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i1 + 32 | 0);
  i6 = (HEAP32[i6 + 4 >> 2] | 0) + (i5 * 96 | 0) | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i7;
  return;
 } else {
  i2 = i1 + 28 | 0;
  __ZNK9Transform14TransformPointERK8Vector3f(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0, i1 + 32 | 0);
  __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0);
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = f8 < Math_fround(0.0);
  f9 = Math_fround(-f8);
  f8 = i2 ? f9 : f8;
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  i2 = f9 < Math_fround(0.0);
  f10 = Math_fround(-f9);
  f9 = i2 ? f10 : f9;
  f8 = f8 < f9 ? f9 : f8;
  f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  i3 = f9 < Math_fround(0.0);
  f10 = Math_fround(-f9);
  f9 = i3 ? f10 : f9;
  __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i6, i5, i1, i4, Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * (f8 < f9 ? f9 : f8)));
  STACKTOP = i7;
  return;
 }
}

function __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(i10, i11, i3, i4, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i4 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i3 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i3 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i3) | 0;
 HEAP32[i7 >> 2] = i3;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37288 >> 2];
 if (i3 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  do if (!(i4 & 2048)) {
   if (!(i4 & 512)) {
    if (!(i4 & 1048576)) {
     i1 = 0;
     break;
    }
    if (!(i4 & 4194304)) i1 = HEAP32[i1 >> 2] | 0;
    i1 = __Z11StringToIntPKc(i1) | 0;
    break;
   }
   do if (!(i4 & 16384)) {
    if (i4 & 1024 | 0) {
     d2 = +(HEAP32[i1 >> 2] | 0);
     break;
    }
    i3 = i1;
    i1 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i4 & 4096)) {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 >>> 0);
     break;
    } else {
     d2 = +(i1 >>> 0) + 4294967296.0 * +(i3 | 0);
     break;
    }
   } else d2 = +HEAPF64[i1 >> 3]; while (0);
   i1 = ~~d2 >>> 0;
  } else i1 = HEAP32[i1 >> 2] | 0; while (0);
  HEAP16[i11 >> 1] = i1;
  HEAP8[i9 >> 0] = 1;
  i11 = i10 + 56 | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i9) i1 = 0; else {
  i1 = i9 * 48 | 0;
  i2 = i10 + 240 | 0;
  if (i1 >>> 0 < 241 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i8 = _PxGetFoundation() | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
   i1 = mftCall_iiiiii(i6 | 0, i7 | 0, i1 | 0, (i8 ? gb + 833046 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = HEAP32[i10 + 248 >> 2] | 0;
 i4 = i1 + (i7 * 48 | 0) | 0;
 i8 = i10 + 244 | 0;
 if ((i7 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i5 = i2;
   i6 = i3;
   i7 = i5 + 48 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   i2 = i2 + 48 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 48 | 0;
  }
 }
 i2 = i10 + 252 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i10 | 0) == (i3 | 0)) {
  HEAP8[i10 + 240 >> 0] = 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 if (!i3) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i3 | 0);
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i9;
 return;
}

function __ZN5physx34PxsSolverConstraintPostProcessTask11runInternalEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i3 = i6 + 68 | 0;
 i4 = (HEAP32[i6 + 72 >> 2] | 0) + (HEAP32[i3 >> 2] | 0) | 0;
 i5 = i6 + 20 | 0;
 i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i2 + 224 >> 2] | 0) | 0;
 if (!i1) {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i8 | 0, i7 | 0, 9203, (i1 ? gb + 721955 | 0 : gb + 837976 | 0) | 0, gb + 722075 | 0, 65) | 0;
  if (!i1) i1 = 0; else {
   i8 = i1 + 19 & -16;
   HEAP32[i8 + -4 >> 2] = i8 - i1;
   i1 = i8;
  }
  __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE(i1, i2);
 }
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 0;
 HEAP32[i1 + 340 >> 2] = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 >= i4 >>> 0) {
  i8 = HEAP32[i5 >> 2] | 0;
  i8 = i8 + 96 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = i8 + 224 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i8, i1);
  return;
 }
 i3 = i6 + 24 | 0;
 do {
  __ZN5physx34PxsSolverConstraintPostProcessTask13mergeContactsERNS_25PxsCompoundContactManagerERNS_16PxsThreadContextE(i6, (HEAP32[(HEAP32[i3 >> 2] | 0) + 8964 >> 2] | 0) + (i2 << 5) | 0, i1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = i8 + 96 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i8 = i8 + 224 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i8, i1);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 3) | 0, 0, i6 - i5 << 3 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 3);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 3) | 0, 0, i6 - i5 << 3 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 3);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 1) | 0, 0, i6 - i5 << 1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 1);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 1) | 0, 0, i6 - i5 << 1 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 1);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 2) | 0, 0, i6 - i5 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 2) | 0, 0, i6 - i5 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 2) | 0, 0, i6 - i5 << 2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i6 = HEAP32[i7 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i3 = i9 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i10 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = i10 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i10 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i10 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 > i5 >>> 0) _memset(i1 + (i5 << 3) | 0, 0, i6 - i5 << 3 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, HEAP32[i10 >> 2] | 0, i1 << 3);
 STACKTOP = i8;
 return;
}

function __ZN14SharedMeshDataC2ERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 HEAP32[i8 + 4 >> 2] = 1;
 HEAP32[i8 >> 2] = gb + 58104 + 8;
 __ZN10VertexDataC2ERKS_j(i8 + 8 | 0, i9 + 8 | 0, HEAP32[i9 + 96 >> 2] | 0);
 i5 = i8 + 112 | 0;
 i6 = i9 + 112 | 0;
 i1 = HEAP32[i9 + 124 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 i10 = i8 + 116 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i8 + 120 >> 2] = 0;
 i2 = i8 + 124 | 0;
 HEAP32[i2 >> 2] = i1;
 i7 = i9 + 116 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 if (i4 | 0) {
  if ((i4 | 0) < 0) {
   __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i5);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = 14;
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 + 120 >> 2] = i3 + i4;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i1;
  }
 }
 __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEC2ERKS5_(i8 + 128 | 0, i9 + 128 | 0);
 __ZN13dynamic_arrayI10Matrix4x4fLj16EEC2ERKS1_(i8 + 144 | 0, i9 + 144 | 0);
 __ZN13dynamic_arrayI13BoneInfluenceLj16EEC2ERKS1_(i8 + 164 | 0, i9 + 164 | 0);
 __ZN13dynamic_arrayI14BoneInfluence2Lj16EEC2ERKS1_(i8 + 184 | 0, i9 + 184 | 0);
 __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i8 + 204 | 0, i9 + 204 | 0);
 STACKTOP = i11;
 return;
}

function __ZN12AudioManager39HandlePendingAudioConfigurationCallbackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 256 | 0;
 i7 = i11 + 248 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11;
 i2 = i1 + 226 | 0;
 i3 = HEAP16[i2 >> 1] | 0;
 if (!((i3 & 255) << 24 >> 24)) {
  STACKTOP = i11;
  return;
 }
 HEAP8[i2 >> 0] = 0;
 HEAP8[i1 + 227 >> 0] = 0;
 i6 = i1 + 232 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i5 + 1;
 if ((i5 | 0) > 1) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 856430 | 0, 0, gb + 856220 | 0, 765, 1, 0, 0, 0); else {
  i2 = (i3 & 65535) > 255;
  i3 = __ZN15GlobalCallbacks3GetEv() | 0;
  i4 = i3 + 17752 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = 0;
   do {
    i5 = i3 + 16984 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i3 + 16984 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i5 >> 2] | 0); else mftCall_vi(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 16984 + (i1 * 12 | 0) + 4 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  HEAP32[i7 >> 2] = 0;
  i3 = (__Z24GetAudioScriptingClassesv() | 0) + 16 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i9;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i8, i10);
  __ZN18ScriptingArguments10AddBooleanEb(i8, i2);
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i8, i7, 0) | 0;
 }
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 STACKTOP = i11;
 return;
}

function __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 + 176 >> 2] | 0;
 i12 = HEAP32[i1 + 180 >> 2] | 0;
 i8 = (i5 | 0) == (i12 | 0);
 if (i8) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i6 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
 i7 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i5;
 do {
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  if (i1) i2 = HEAP32[i4 + 4 >> 2] | 0; else i2 = i3 & 255;
  if ((i2 | 0) == (i6 | 0)) {
   if (i1) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = HEAP32[i4 + 4 >> 2] | 0;
   } else {
    i2 = i4;
    i1 = i3 & 255;
   }
   if (!(_strncmp(i2, i7, i1) | 0)) {
    i9 = i4;
    i10 = 23;
    break;
   }
  }
  i4 = i4 + 156 | 0;
 } while ((i4 | 0) != (i12 | 0));
 if ((i10 | 0) == 23) return i9 | 0;
 if (i8) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = HEAP8[i11 + 11 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
 i6 = i6 ? HEAP32[i11 >> 2] | 0 : i11;
 while (1) {
  i2 = i5 + 16 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  if (i1) i3 = HEAP32[i5 + 20 >> 2] | 0; else i3 = i4 & 255;
  if ((i3 | 0) == (i7 | 0)) {
   if (i1) {
    i2 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i5 + 20 >> 2] | 0;
   } else i1 = i4 & 255;
   if (!(_strncmp(i2, i6, i1) | 0)) {
    i9 = i5;
    i10 = 23;
    break;
   }
  }
  i5 = i5 + 156 | 0;
  if ((i5 | 0) == (i12 | 0)) {
   i9 = 0;
   i10 = 23;
   break;
  }
 }
 if ((i10 | 0) == 23) return i9 | 0;
 return 0;
}

function __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i12, i14, i13) {
 i12 = i12 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 i7 = i12 + 98 | 0;
 i10 = i14 + 4480 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = (i1 | 0) == 0;
 i4 = (i9 ? 1 : 2) | HEAPU16[i7 >> 1] & 65516;
 i2 = i12 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i9 & (i3 | 0) == 0) {
  HEAP16[i7 >> 1] = i4;
  i14 = 1;
  STACKTOP = i15;
  return i14 | 0;
 }
 i8 = HEAP16[i12 + 22 >> 1] | 0;
 i9 = i12 + 20 | 0;
 HEAP16[i9 >> 1] = i1;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = (i5 | 0) == 0;
 HEAP16[i7 >> 1] = (i8 & 130) == 0 | i6 ? i4 & 65515 : i4 | 4;
 HEAP32[i2 >> 2] = i6 ? 0 : i3;
 i2 = i5 << 2;
 i1 = i8 & 65535;
 do if (!(i1 & 1)) if (!(HEAP8[i14 + 8758 >> 0] | 0)) if (!(i1 & 256)) i1 = 1; else {
  if (i1 & 32 | 0) if ((HEAP32[(HEAP32[i12 + 64 >> 2] | 0) + 92 >> 2] | 0) != 2139095039) {
   i1 = 0;
   break;
  }
  if (!(i8 & 64)) i1 = 1; else i1 = (HEAP32[(HEAP32[i12 + 68 >> 2] | 0) + 92 >> 2] | 0) == 2139095039;
 } else i1 = 0; else i1 = 0; while (0);
 i14 = __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b(i14 + 384 | 0, i5, i14, i9, i12 + 28 | 0, i12 + 32 | 0, i11, i1 | i6 ? 0 : i2, i7, HEAP32[i12 + 80 >> 2] | 0, (i8 & 128) != 0, 0, i13, 0, 0, 0, (HEAP8[i14 + 8759 >> 0] | 0) != 0) | 0;
 i14 = (i14 | 0) != 0 | (HEAP32[i10 >> 2] | 0) == 0;
 STACKTOP = i15;
 return i14 | 0;
}

function __ZN5audio5mixer14SetWeightedMixERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEPiPfif(i3, i9, i10, i11, i12, f13) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 var f1 = f0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i14 = 0, i15 = 0, f16 = f0;
 i5 = i9 + 52 | 0;
 i14 = i9 + 20 | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
 i4 = (i12 | 0) > 0;
 if (i4) {
  f1 = Math_fround(0.0);
  i2 = 0;
  do {
   f1 = Math_fround(f1 + Math_fround(_fmaxf(Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]), Math_fround(0.0))));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
  i7 = f1 > Math_fround(0.0);
  f8 = Math_fround(Math_fround(1.0) / f1);
  f8 = i7 ? f8 : Math_fround(0.0);
  if (i4) {
   i6 = i3 + 36 | 0;
   i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
   i7 = HEAP32[i14 >> 2] | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if (i7 | 0) {
    i2 = 0;
    do {
     i5 = i6 + ((HEAP32[i10 + (i2 << 2) >> 2] | 0) * 28 | 0) + 8 | 0;
     i5 = i5 + (HEAP32[i5 >> 2] | 0) | 0;
     f1 = Math_fround(f8 * Math_fround(_fmaxf(Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]), Math_fround(0.0))));
     i3 = 0;
     do {
      f16 = Math_fround(f1 * Math_fround(HEAPF32[i5 + (i3 << 2) >> 2]));
      i15 = i4 + (i3 << 2) | 0;
      HEAPF32[i15 >> 2] = Math_fround(f16 + Math_fround(HEAPF32[i15 >> 2]));
      i3 = i3 + 1 | 0;
     } while ((i3 | 0) != (i7 | 0));
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i12 | 0));
   }
  }
 }
 _memcpy(HEAP32[i9 + 24 >> 2] | 0, HEAP32[i9 + 28 >> 2] | 0, HEAP32[i14 >> 2] << 2 | 0) | 0;
 HEAPF32[i9 + 44 >> 2] = Math_fround(0.0);
 HEAP8[i9 + 56 >> 0] = 1;
 HEAPF32[i9 + 48 >> 2] = f13;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944884 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 4 | 0;
 i6 = HEAP32[gb + 37212 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944890 | 0, i6, i5, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944893 | 0, i6, i5, 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946895 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 944898 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN15LODGroupManager11AddLODGroupER8LODGroupRK8Vector3ff(i9, i2, i4, f5) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i9 + 4 | 0;
 i11 = i9 + 16 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i6 = i12 + 1 | 0;
 i7 = i9 + 20 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = i8 & 2147483647;
 do if (i6 >>> 0 > i3 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 * 96 | 0, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 96 | 0, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i11 >> 2] | 0) * 96 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i10 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i6;
 __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i9, i12, i2, i4, f5);
 i3 = i9 + 48 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i11 = HEAP32[i11 >> 2] | 0;
  i11 = i11 + -1 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i11 = i10 + (i11 * 96 | 0) + 92 | 0;
  HEAP32[i11 >> 2] = 0;
  return i12 | 0;
 }
 i2 = i9 + 36 | 0;
 i1 = 0;
 do {
  __ZN13CameraLODData9AddAtBackEhf(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, 0, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i11 = HEAP32[i11 >> 2] | 0;
 i11 = i11 + -1 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i11 = i10 + (i11 * 96 | 0) + 92 | 0;
 HEAP32[i11 >> 2] = 0;
 return i12 | 0;
}

function __ZN10Collider2D7CleanupEb(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1457932 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457932 | 0, i1);
  i5 = gb + 1457932 | 0;
 } else i5 = 0;
 i6 = i7 + 72 | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = __Z19GetPhysicsManager2Dv() | 0;
  __ZN16Physics2DManager21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE(i2, i7, i3 ? 5 : 0);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i7 + 60 | 0;
  i1 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
  i3 = HEAP32[i1 + 28 >> 2] | 0;
  if ((i2 | 0) > 0) {
   __ZN6b2Body14DestroyFixtureEP9b2Fixtureb(i3, i1, 0);
   if ((i2 | 0) != 1) {
    i1 = 1;
    do {
     __ZN6b2Body14DestroyFixtureEP9b2Fixtureb(i3, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0, 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  __ZN6b2Body13ResetMassDataEv(i3);
  i1 = i7 + 76 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i7 + 64 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  if (!(__Z14IsWorldPlayingv() | 0)) __ZN16b2ContactManager20FlushPendingContactsEv((__Z17GetPhysicsWorld2Dv() | 0) + 102872 | 0);
 }
 HEAP32[i7 + 56 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i7 + 80 | 0) | 0;
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i8;
 return;
}

function __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i3 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i7, 0); else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i7, HEAP32[i4 + 24 >> 2] | 0, HEAP32[i3 + 28 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i5 >> 2] = i2 + -72;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __GLOBAL__sub_I_runtime_ai_internal_obstacles_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459044 | 0, gb + 842783 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459056 | 0, gb + 842809 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459068 | 0, gb + 842831 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459080 | 0, gb + 842850 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459092 | 0, gb + 842866 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459104 | 0, gb + 842883 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459116 | 0, gb + 842904 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459128 | 0, gb + 842924 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459140 | 0, gb + 842948 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459152 | 0, gb + 842968 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459164 | 0, gb + 842998 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459176 | 0, gb + 843028 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459188 | 0, gb + 843056 | 0, 5, 0);
 return;
}

function __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (((i3 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i8 = i1 + 4 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   HEAP32[i8 + 16 >> 2] = 0;
   HEAP32[i1 >> 2] = -1;
   i1 = (HEAP32[i9 >> 2] | 0) + 24 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 24 | 0) + i2 | 0;
 if (i5 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 24 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 89478485 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 178956970;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 24 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 24 | 0) * 24 | 0) | 0;
 i5 = i5 + (i3 * 24 | 0) | 0;
 i4 = i6;
 i1 = i6;
 do {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i1 >> 2] = -1;
  i1 = i4 + 24 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (((i3 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 20 | 0;
 i1 = i12;
 i5 = i11 + 268 | 0;
 __ZN5physx5cloth11PhaseConfigC2Et(i6, -1);
 __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE6resizeEjRKS3_(i5, 0, i6);
 i6 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 if (i6 >>> 0 >= i7 >>> 0) {
  i11 = i11 + 540 | 0;
  HEAP32[i11 >> 2] = 0;
  STACKTOP = i12;
  return;
 }
 i8 = i11 + 276 | 0;
 i9 = i11 + 272 | 0;
 i2 = i6 + 20 | 0;
 i2 = ((((i7 >>> 0 > i2 >>> 0 ? i7 : i2) + ~i6 | 0) >>> 0) / 20 | 0) + 1 | 0;
 i3 = i6;
 do {
  do if (Math_fround(HEAPF32[i3 + 4 >> 2]) > Math_fround(0.0)) {
   __ZN5physx5cloth9transformERKNS0_11PhaseConfigE(i1, i3);
   i4 = HEAP32[i9 >> 2] | 0;
   if ((HEAP32[i8 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    i4 = (HEAP32[i5 >> 2] | 0) + (i4 * 20 | 0) | 0;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE15growAndPushBackERKS3_(i5, i1) | 0;
    break;
   }
  } while (0);
  i3 = i3 + 20 | 0;
 } while (i3 >>> 0 < i7 >>> 0);
 HEAP32[i10 >> 2] = i6 + (i2 * 20 | 0);
 i11 = i11 + 540 | 0;
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx30collideWithSphereNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_(i11, i4, i12, i7) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i5 = 0, i6 = 0, f8 = f0, i9 = 0, i10 = 0, f13 = f0, f14 = f0, f15 = f0;
 i9 = i11 + 124 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 if (i10 & 2 | 0) return;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f2 * f2);
 f3 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f3 * f3));
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f1 * f1))));
 i4 = i11 + 144 | 0;
 HEAPF32[i4 >> 2] = f2;
 i5 = i11 + 148 | 0;
 HEAPF32[i5 >> 2] = f3;
 i6 = i11 + 152 | 0;
 HEAPF32[i6 >> 2] = f1;
 f13 = Math_fround(HEAPF32[i12 >> 2]);
 if (!(f8 < Math_fround(f13 + Math_fround(HEAPF32[i7 >> 2])))) return;
 if (f8 != Math_fround(0.0)) {
  f14 = Math_fround(Math_fround(1.0) / f8);
  f13 = Math_fround(f14 * f2);
  HEAPF32[i4 >> 2] = f13;
  f2 = Math_fround(f14 * f3);
  HEAPF32[i5 >> 2] = f2;
  f3 = Math_fround(f14 * f1);
  HEAPF32[i6 >> 2] = f3;
  f1 = f13;
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f3 = Math_fround(0.0);
 }
 f15 = Math_fround(HEAPF32[i12 >> 2]);
 f14 = Math_fround(HEAPF32[i11 + 92 >> 2]);
 f15 = Math_fround(f15 + f14);
 f2 = Math_fround(f15 * f2);
 f13 = Math_fround(f15 * f3);
 HEAPF32[i11 + 160 >> 2] = Math_fround(f1 * f15);
 HEAPF32[i11 + 164 >> 2] = f2;
 HEAPF32[i11 + 168 >> 2] = f13;
 HEAP32[i9 >> 2] = i10 | 32;
 if (!(f8 < Math_fround(Math_fround(HEAPF32[i12 >> 2]) + f14))) return;
 HEAP32[i9 >> 2] = i10 | 48;
 return;
}

function __ZN5physx2Sc5Scene11onBodySleepEPNS0_7BodySimE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i6 = i10;
 i9 = i3 + 144 | 0;
 i1 = HEAP16[i9 >> 1] | 0;
 i2 = i1 & 65535;
 if (!(HEAP32[(HEAP32[HEAP32[i8 + 1152 >> 2] >> 2] | 0) + 16 >> 2] | 0)) {
  do if (!(i2 & 16)) {
   i5 = i8 + 1124 | 0;
   i2 = HEAP32[i3 + 52 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i8 + 1128 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((HEAP32[i8 + 1132 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i2;
    HEAP32[i3 >> 2] = i4 + 1;
    break;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i6) | 0;
    i1 = HEAP16[i9 >> 1] | 0;
    break;
   }
  } while (0);
  HEAP16[i9 >> 1] = i1 & 65535 | 16;
  STACKTOP = i10;
  return;
 }
 if (i2 & 128) {
  i1 = i2 & 65407;
  HEAP16[i9 >> 1] = i1;
  HEAP8[i8 + 1148 >> 0] = 0;
 }
 i6 = i1 & 65535;
 i1 = (i6 | 64) & 65535;
 HEAP16[i9 >> 1] = i1;
 if (i6 & 16 | 0) {
  STACKTOP = i10;
  return;
 }
 i5 = i8 + 1124 | 0;
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i8 + 1128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i8 + 1132 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = i4 + 1;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i7) | 0;
  i1 = HEAP16[i9 >> 1] | 0;
 }
 HEAP16[i9 >> 1] = i1 & 65535 | 16;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu28computeMTD_SphereHeightFieldERNS_6PxVec3ERfRKNS0_6SphereERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i5, i3, i6, i1, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i7 + 4216 | 0;
 i13 = i7 + 4208 | 0;
 i11 = i7 + 4152 | 0;
 i8 = i7 + 4144 | 0;
 i2 = i7;
 i10 = i7 + 4116 | 0;
 i9 = i7 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 i14 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = i14;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i2 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i2 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu24contactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i4, i9, i8, i2) | 0)) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i5, i3, HEAP32[i1 >> 2] | 0, i2) | 0)) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 i14 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i14 | 0;
}

function __ZN19SharedBillboardDataC2ERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 56576 + 8;
 i8 = i2;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i8 = i5;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i1 + 32 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i8 = i5;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i1 + 52 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i5 = HEAP32[i1 + 176 >> 2] | 0;
 i12 = HEAP32[i1 + 180 >> 2] | 0;
 i8 = (i5 | 0) == (i12 | 0);
 if (i8) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = HEAP8[i11 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i6 = i7 ? HEAP32[i11 + 4 >> 2] | 0 : i6 & 255;
 i7 = i7 ? HEAP32[i11 >> 2] | 0 : i11;
 i4 = i5;
 do {
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  if (i1) i2 = HEAP32[i4 + 4 >> 2] | 0; else i2 = i3 & 255;
  if ((i2 | 0) == (i6 | 0)) {
   if (i1) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = HEAP32[i4 + 4 >> 2] | 0;
   } else {
    i2 = i4;
    i1 = i3 & 255;
   }
   if (!(_strncmp(i2, i7, i1) | 0)) {
    i9 = i4;
    i10 = 23;
    break;
   }
  }
  i4 = i4 + 156 | 0;
 } while ((i4 | 0) != (i12 | 0));
 if ((i10 | 0) == 23) return i9 | 0;
 if (i8) {
  i12 = 0;
  return i12 | 0;
 }
 i7 = HEAP8[i11 + 11 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i11 + 4 >> 2] | 0 : i7 & 255;
 i6 = i6 ? HEAP32[i11 >> 2] | 0 : i11;
 while (1) {
  i2 = i5 + 16 | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i4 << 24 >> 24 < 0;
  if (i1) i3 = HEAP32[i5 + 20 >> 2] | 0; else i3 = i4 & 255;
  if ((i3 | 0) == (i7 | 0)) {
   if (i1) {
    i2 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i5 + 20 >> 2] | 0;
   } else i1 = i4 & 255;
   if (!(_strncmp(i2, i6, i1) | 0)) {
    i9 = i5;
    i10 = 23;
    break;
   }
  }
  i5 = i5 + 156 | 0;
  if ((i5 | 0) == (i12 | 0)) {
   i9 = 0;
   i10 = 23;
   break;
  }
 }
 if ((i10 | 0) == 23) return i9 | 0;
 return 0;
}

function __Z27UnloadUnusedAssetsImmediateb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i5 + 8 | 0;
 i1 = __Z33CreateUnloadUnusedAssetsOperationb(i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1163176 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(56) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i4 = i2;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i1 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i7 = i2;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = i1 + 24 | 0;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i4 + 4 >> 2] = i6;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP8[i1 + 44 >> 0] = 0;
  HEAP32[i1 + 52 >> 2] = -1;
  HEAP32[i1 + 48 >> 2] = -1;
  HEAP32[gb + 1163176 >> 2] = i1;
 }
 if ((HEAP16[gb + 1163216 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163216 | 0, i2);
  i2 = gb + 1163216 | 0;
 } else i2 = 0;
 i3 = i1 + 32 | 0;
 i4 = i1 + 12 | 0;
 while (1) {
  if (!(HEAP32[i4 >> 2] | 0)) if (!(HEAP32[i3 >> 2] | 0)) break;
  __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi(i1, 2, 2147483647) | 0;
 }
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNK22MotionVectorRenderLoop18RenderObjectSorterclERK18RPDataMotionVectorS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i2 + 16 >> 2] | 0;
 i6 = HEAP32[i7 + 12 >> 2] | 0;
 i9 = HEAP32[i3 + 16 >> 2] | 0;
 i3 = HEAP32[i6 + (i10 << 5) + 8 >> 2] | 0;
 i7 = HEAP32[HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 1832 >> 2] >> 2] | 0;
 i8 = HEAP32[i6 + (i9 << 5) + 8 >> 2] | 0;
 i1 = HEAP32[i7 + (i3 * 360 | 0) + 184 >> 2] | 0;
 i2 = HEAP32[i7 + (i8 * 360 | 0) + 184 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  i10 = i1 >>> 0 < i2 >>> 0;
  return i10 | 0;
 }
 i1 = HEAP16[i6 + (i10 << 5) + 12 >> 1] | 0;
 i2 = HEAP16[i6 + (i9 << 5) + 12 >> 1] | 0;
 if (i1 << 16 >> 16 != i2 << 16 >> 16) {
  i10 = i1 << 16 >> 16 < i2 << 16 >> 16;
  return i10 | 0;
 }
 f4 = Math_fround(HEAPF32[i6 + (i10 << 5) + 20 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
 f5 = Math_fround(HEAPF32[i6 + (i9 << 5) + 20 >> 2]);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) >>> 24;
 if ((i1 | 0) != (i2 | 0)) {
  i10 = i1 >>> 0 < i2 >>> 0;
  return i10 | 0;
 }
 i2 = HEAP32[i6 + (i10 << 5) + 28 >> 2] | 0;
 i1 = HEAP32[i6 + (i9 << 5) + 28 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i10 = i2 >>> 0 > i1 >>> 0;
  return i10 | 0;
 }
 if (f4 != f5) {
  i10 = f4 > f5;
  return i10 | 0;
 }
 i2 = HEAP16[i7 + (i3 * 360 | 0) + 270 >> 1] | 0;
 i1 = HEAP16[i7 + (i8 * 360 | 0) + 270 >> 1] | 0;
 if (i2 << 16 >> 16 == i1 << 16 >> 16) {
  i10 = (i10 | 0) < (i9 | 0);
  return i10 | 0;
 } else {
  i10 = (i2 & 65535) > (i1 & 65535);
  return i10 | 0;
 }
 return 0;
}

function __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function _if_nameindex() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16 | 0;
 i10 = i12 + 8 | 0;
 i9 = i12;
 i6 = i12 + 24 | 0;
 i7 = _socket(1, 524290, 0) | 0;
 if ((i7 | 0) > -1) {
  i8 = i6 + 4 | 0;
  i5 = 0;
  while (1) {
   i1 = _malloc(i5 * 40 | 0) | 0;
   do if (!i1) {
    i1 = 0;
    i4 = 14;
   } else {
    HEAP32[i8 >> 2] = i1 + (i5 << 3);
    i3 = i5 << 5;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i9 >> 2] = i6;
    if ((_ioctl(i7, 35090, i9) | 0) < 0) {
     _free(i1);
     i1 = 0;
     i4 = 14;
     break;
    }
    i2 = HEAP32[i6 >> 2] | 0;
    if ((i2 | 0) == (i3 | 0)) {
     _free(i1);
     break;
    }
    i2 = i2 >>> 5;
    if (!i2) {
     i3 = 0;
     i2 = 0;
    } else {
     i3 = 0;
     i4 = 0;
     do {
      HEAP32[i10 >> 2] = (HEAP32[i8 >> 2] | 0) + (i4 << 5);
      if ((_ioctl(i7, 35123, i10) | 0) < 0) i3 = i3 + 1 | 0; else {
       i14 = HEAP32[i8 >> 2] | 0;
       i13 = i4 - i3 | 0;
       HEAP32[i1 + (i13 << 3) >> 2] = HEAP32[i14 + (i4 << 5) + 16 >> 2];
       HEAP32[i1 + (i13 << 3) + 4 >> 2] = i14 + (i4 << 5);
      }
      i4 = i4 + 1 | 0;
     } while ((i4 | 0) != (i2 | 0));
    }
    i4 = i2 - i3 | 0;
    HEAP32[i1 + (i4 << 3) + 4 >> 2] = 0;
    HEAP32[i1 + (i4 << 3) >> 2] = 0;
    i4 = 14;
   } while (0);
   if ((i4 | 0) == 14) {
    i4 = 0;
    if ((i1 | 0) != (-1 | 0)) break;
   }
   i5 = i5 + 1 | 0;
  }
  HEAP32[i11 >> 2] = i7;
  ___syscall6(6, i11 | 0) | 0;
 } else i1 = 0;
 HEAP32[(___errno_location() | 0) >> 2] = 105;
 STACKTOP = i12;
 return i1 | 0;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i11, i12, i13, i14) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, i20 = 0;
 i1 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i12) return;
 i4 = i1 + 96 | 0;
 i5 = i1 + 112 | 0;
 i6 = i1 + 128 | 0;
 i7 = i1 + 100 | 0;
 i8 = i1 + 116 | 0;
 i9 = i1 + 132 | 0;
 i10 = i1 + 104 | 0;
 i3 = i1 + 120 | 0;
 i1 = i1 + 136 | 0;
 i2 = 0;
 do {
  i20 = HEAPU8[i11 + i2 >> 0] | 0;
  f19 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) >> 2]);
  f18 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) + 4 >> 2]);
  f15 = Math_fround(HEAPF32[i13 + (i20 * 12 | 0) + 8 >> 2]);
  f17 = Math_fround(f19 * Math_fround(HEAPF32[i4 >> 2]));
  f17 = Math_fround(f17 + Math_fround(f18 * Math_fround(HEAPF32[i5 >> 2])));
  f17 = Math_fround(f17 + Math_fround(f15 * Math_fround(HEAPF32[i6 >> 2])));
  f16 = Math_fround(f19 * Math_fround(HEAPF32[i7 >> 2]));
  f16 = Math_fround(f16 + Math_fround(f18 * Math_fround(HEAPF32[i8 >> 2])));
  f16 = Math_fround(f16 + Math_fround(f15 * Math_fround(HEAPF32[i9 >> 2])));
  f19 = Math_fround(f19 * Math_fround(HEAPF32[i10 >> 2]));
  f18 = Math_fround(f19 + Math_fround(f18 * Math_fround(HEAPF32[i3 >> 2])));
  f15 = Math_fround(f18 + Math_fround(f15 * Math_fround(HEAPF32[i1 >> 2])));
  HEAPF32[i14 + (i2 << 4) >> 2] = f17;
  HEAPF32[i14 + (i2 << 4) + 4 >> 2] = f16;
  HEAPF32[i14 + (i2 << 4) + 8 >> 2] = f15;
  HEAPF32[i14 + (i2 << 4) + 12 >> 2] = Math_fround(0.0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i12 | 0));
 return;
}

function __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 i8 = i5 + 8 | 0;
 i10 = i3;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i4);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 i4 = i1 + 32 | 0;
 __ZN12BaseRendererC2E12RendererType(i4, i2);
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i4 >> 2] = gb + 43728 + 180;
 HEAP32[i1 + 284 >> 2] = -1;
 __ZNK6Object14GetMemoryLabelEv(i8, i1);
 i4 = i8;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i2 = i6;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i1 + 292 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = i1 + 308 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 324 >> 2] = i1;
 HEAP8[i1 + 328 >> 0] = 1;
 HEAP8[i1 + 329 >> 0] = 1;
 i4 = i1 + 268 | 0;
 i3 = i1 + 332 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = (HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16528383 | 82944;
 HEAP16[i4 >> 1] = i3;
 HEAP8[i4 + 2 >> 0] = i3 >>> 16;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc10NPhaseCore24createTriggerInteractionERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i5, i1, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i3 = (HEAP8[(HEAP32[i2 + 28 >> 2] | 0) + 64 >> 0] & 4) == 0;
 i4 = i3 ? i2 : i1;
 i3 = i3 ? i1 : i2;
 i2 = i5 + 1324 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i5 + 1032 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i5 + 1312 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = i5 + 1316 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (!i1) {
  i5 = 0;
  __ZN5physx2Sc18TriggerInteraction10initializeEv(i5);
  i4 = HEAP16[i6 >> 1] | 0;
  i6 = i5 + 56 | 0;
  i3 = HEAP16[i6 >> 1] | 0;
  i3 = i3 & 65535;
  i4 = i4 & 65535;
  i4 = i4 & 20;
  i3 = i3 & 65504;
  i4 = i3 | i4;
  i4 = i4 & 65535;
  HEAP16[i6 >> 1] = i4;
  return i5 | 0;
 }
 HEAP32[i1 >> 2] = gb + 101220 + 8;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 1;
 i5 = i1 + 8 | 0;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i5, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, 2, 5);
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = i4;
 HEAP32[i1 >> 2] = gb + 101320 + 8;
 HEAP32[i5 >> 2] = gb + 101320 + 52;
 HEAP16[i1 + 56 >> 1] = 32;
 HEAP8[i1 + 58 >> 0] = 0;
 i5 = i1;
 __ZN5physx2Sc18TriggerInteraction10initializeEv(i5);
 i4 = HEAP16[i6 >> 1] | 0;
 i6 = i5 + 56 | 0;
 i3 = HEAP16[i6 >> 1] | 0;
 i3 = i3 & 65535;
 i4 = i4 & 65535;
 i4 = i4 & 20;
 i3 = i3 & 65504;
 i4 = i3 | i4;
 i4 = i4 & 65535;
 HEAP16[i6 >> 1] = i4;
 return i5 | 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 469391 | 0, i2, i4);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1037646 | 0, gb + 469407 | 0, i2, 0);
 __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 469424 | 0, HEAP32[gb + 37040 >> 2] | 0, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 469433 | 0, HEAP32[gb + 37316 >> 2] | 0, i2 + 8 | 0, 0);
 HEAP32[i6 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1041891 | 0, gb + 469440 | 0, i6, 0);
 __ZN18ComputeShaderParam8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 __ZL18InitializeIfNeededv();
 if (!(__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1103788 >> 2] | 0, i2) | 0)) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = HEAP32[gb + 1103788 >> 2] | 0;
 i4 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_(i5, i3, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(48) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 16 | 0, i2);
  HEAP32[i1 + 28 >> 2] = 255;
  i2 = i1 + 36 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i2;
  HEAP32[i4 >> 2] = i1;
  i2 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  if (!i2) i2 = i1; else {
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 4 >> 2] | 0, i2);
  i5 = i5 + 8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) != 254) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN10UnityScene19HasLevelGameManagerEP11GameManager(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i5 = 0;
 while (1) {
  i4 = i6 + 84 + (i5 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i9 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i10 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i1, i9);
     i2 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i12 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i12 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i10 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i10 = 11;
    }
   }
   if ((i10 | 0) == 9) i10 = 11;
   if ((i10 | 0) == 11) {
    i10 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i1 | 0) == (i7 | 0)) {
   i1 = 1;
   i10 = 14;
   break;
  }
  if (i5 >>> 0 >= 4) {
   i1 = 0;
   i10 = 14;
   break;
  }
 }
 if ((i10 | 0) == 14) {
  STACKTOP = i11;
  return i1 | 0;
 }
 return 0;
}

function __Z39Graphics_CUSTOM_Internal_DrawMeshMatrixR36MonoInternal_DrawMeshMatrixArgumentsP12Il2CppObjectS2_S2_S2_(i7, i8, i5, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i6 = i9;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 HEAP32[i6 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i5) | 0;
 i11 = HEAP32[i7 >> 2] | 0;
 i10 = HEAP32[i7 + 72 >> 2] | 0;
 i3 = (HEAP32[i7 + 76 >> 2] | 0) != 0;
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i2 = __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i7 + 8 | 0, i1, i4, i11, i10, i3, i5, i2) | 0;
 i1 = i7 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i11 = i2 + 236 | 0;
  i10 = HEAPU16[i11 >> 1] | HEAPU8[i11 + 2 >> 0] << 16 | 49152;
  HEAP16[i11 >> 1] = i10;
  HEAP8[i11 + 2 >> 0] = i10 >>> 16;
  HEAP32[i2 + 248 >> 2] = HEAP32[i1 >> 2];
 }
 if (HEAP8[i7 + 84 >> 0] | 0) {
  i11 = i2 + 236 | 0;
  i10 = (HEAPU16[i11 >> 1] | HEAPU8[i11 + 2 >> 0] << 16) & 16580607 | 65536;
  HEAP16[i11 >> 1] = i10;
  HEAP8[i11 + 2 >> 0] = i10 >>> 16;
 }
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN19ShaderPropertySheet11ComputeHashEv(i1);
 __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i2, i1);
 STACKTOP = i9;
 return;
}

function __ZNK21ImposterRenderTexture18GetBillboardParamsERfS0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i6 = i7;
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0));
 i2 = f8 <= Math_fround(90.0);
 f1 = Math_fround(f8 + Math_fround(-360.0));
 f1 = i2 ? f8 : f1;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(+Math_cos(+Math_fround(Math_fround(Math_fround(f1 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)))));
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 HEAPF32[i5 >> 2] = f1;
 if (f1 < Math_fround(40.0)) {
  f8 = Math_fround(0.0);
  HEAPF32[i5 >> 2] = f8;
  HEAPF32[i6 >> 2] = Math_fround(.100000001);
  i3 = f8 > Math_fround(.100000001);
  i6 = i3 ? i5 : i6;
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
 f8 = Math_fround(Math_fround(f1 + Math_fround(-40.0)) / Math_fround(50.0));
 i3 = f8 < Math_fround(0.0);
 i2 = f8 > Math_fround(1.0);
 f8 = i2 ? Math_fround(1.0) : f8;
 f8 = i3 ? Math_fround(0.0) : f8;
 f8 = Math_fround(Math_fround(f8 * Math_fround(f8 * Math_fround(3.0))) + Math_fround(f8 * Math_fround(f8 * Math_fround(f8 * Math_fround(-2.0)))));
 f8 = Math_fround(f8 + Math_fround(Math_fround(Math_fround(1.0) - f8) * Math_fround(0.0)));
 HEAPF32[i5 >> 2] = f8;
 HEAPF32[i6 >> 2] = Math_fround(.100000001);
 i3 = f8 > Math_fround(.100000001);
 i6 = i3 ? i5 : i6;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i4 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (HEAP8[HEAP32[i2 >> 2] >> 0] | 0) {
 case 110:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 116:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 102:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 34:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i1, i2, i3, 0);
   return;
  }
 case 123:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 91:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 default:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 }
}

function __ZN7ApiGLES13DeleteTextureERj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 switch (HEAP32[i5 >> 2] | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 i10 = i4 + 1600 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i4 + 1992 | 0;
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0) > 0) {
  i6 = i4 + 808 | 0;
  i7 = i4 + 860 | 0;
  i8 = i4 + 812 | 0;
  i3 = 0;
  do {
   i2 = i4 + 1604 + (i3 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   do if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
    i9 = HEAP32[i4 + 1732 + (i3 << 2) >> 2] | 0;
    if (!(HEAP8[i12 >> 0] | 0)) i13 = 11; else if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) i13 = 13; else i13 = 11;
    if ((i13 | 0) == 11) {
     i13 = 0;
     mftCall_vi(HEAP32[i6 >> 2] | 0, i3 + 33984 | 0);
     HEAP32[i10 >> 2] = i3;
     if (HEAP8[i12 >> 0] | 0) {
      i1 = HEAP32[i2 >> 2] | 0;
      i13 = 13;
     }
    }
    if ((i13 | 0) == 13) {
     i13 = 0;
     if (!i1) break;
    }
    i2 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i7 >> 2] | 0, i9) | 0;
    mftCall_vii(HEAP32[i8 >> 2] | 0, i2 | 0, 0);
    HEAP32[i4 + 1604 + (HEAP32[i10 >> 2] << 2) >> 2] = 0;
    HEAP32[i4 + 1732 + (HEAP32[i10 >> 2] << 2) >> 2] = i9;
   } while (0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0));
 }
 if (!(HEAP8[i12 >> 0] | 0)) i13 = 6; else if ((HEAP32[i10 >> 2] | 0) != (i11 | 0)) i13 = 6;
 if ((i13 | 0) == 6) {
  mftCall_vi(HEAP32[i4 + 808 >> 2] | 0, i11 + 33984 | 0);
  HEAP32[i10 >> 2] = i11;
 }
 mftCall_vii(HEAP32[i4 + 816 >> 2] | 0, 1, i5 | 0);
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i9) i1 = 0; else {
  i1 = i9 * 48 | 0;
  i2 = i10 + 240 | 0;
  if (i1 >>> 0 < 241 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i8 = _PxGetFoundation() | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
   i1 = mftCall_iiiiii(i6 | 0, i7 | 0, i1 | 0, (i8 ? gb + 832922 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = HEAP32[i10 + 248 >> 2] | 0;
 i4 = i1 + (i7 * 48 | 0) | 0;
 i8 = i10 + 244 | 0;
 if ((i7 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i5 = i2;
   i6 = i3;
   i7 = i5 + 48 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   i2 = i2 + 48 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 48 | 0;
  }
 }
 i2 = i10 + 252 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i10 | 0) == (i3 | 0)) {
  HEAP8[i10 + 240 >> 0] = 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 if (!i3) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i3 | 0);
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i9;
 return;
}

function __ZN5physx2Sc5Scene23allocateConstraintBlockEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (i2 >>> 0 < 129) {
  i2 = i3 + 508 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 216 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i3 + 496 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i3 = i3 + 500 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (i2 >>> 0 < 257) {
  i2 = i3 + 804 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 512 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i3 + 792 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i3 = i3 + 796 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (i2 >>> 0 >= 385) {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i2, gb + 680241 | 0, 829) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = i3 + 1100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i3 + 808 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i3 + 1088 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i3 = i3 + 1092 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = i1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx12InlineBufferIjLj4096EE4freeEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 1 | 0;
 i9 = i11 + 16388 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == (i11 | 0)) {
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 16392 | 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i10 = HEAP32[i11 + 16384 >> 2] | 0;
 if (!i10) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 16392 | 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 + 16 >> 2] | 0;
 if (i2 >>> 0 > i5 >>> 0) i12 = 5; else if ((i2 + (HEAP32[i10 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
  i6 = i10 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 } else i12 = 5;
 if ((i12 | 0) == 5) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i5);
 HEAP32[i9 >> 2] = 0;
 i12 = i11 + 16392 | 0;
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN38StateMachineBehaviourVectorDescription8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i6 = i8 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i2 - i1 >> 4;
 HEAP32[i9 >> 2] = i5;
 i11 = i7 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i7 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags(i7, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i11 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i9, 4);
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i4 = i1 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i12;
 return;
}

function __ZN14MemoryProfiler22GetRootAllocationInfosER13dynamic_arrayINS_18RootAllocationInfoELj4EE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i6 + 12 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 168 | 0;
 i3 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0) + i7 | 0;
 HEAP32[i5 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i3 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  break;
 } while (0);
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = i4 + 4 | 0;
 if ((i2 | 0) == (i4 | 0)) return;
 i3 = HEAP32[i6 >> 2] | 0;
 while (1) {
  i1 = i2 + 16 | 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + (i7 * 12 | 0) + 8 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + (i7 * 12 | 0) >> 2] = HEAP32[i6 + 8 >> 2];
  i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + (i7 * 12 | 0) + 4 >> 2] = i1;
  i7 = i7 + 1 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZZNK9dtNavMesh15findNearestPolyEPKfS1_PfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi(i1, i9, i16, i17, i18) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i19 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0, f24 = f0, f25 = f0, i26 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i23;
 if ((i18 | 0) <= 0) {
  STACKTOP = i23;
  return;
 }
 i20 = i1 + 20 | 0;
 i21 = i19 + 4 | 0;
 i22 = i1 + 24 | 0;
 i10 = i19 + 8 | 0;
 i11 = i1 + 28 | 0;
 i12 = i1 + 16 | 0;
 i13 = i1 + 32 | 0;
 i14 = i1 + 36 | 0;
 i15 = i1 + 40 | 0;
 i2 = i1 + 8 | 0;
 i1 = 0;
 do {
  i4 = i16 + (i1 << 3) | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  __ZNK9dtNavMesh24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyPKfPf(0, i9, HEAP32[i17 + (i1 << 2) >> 2] | 0, i20, i19);
  f5 = Math_fround(HEAPF32[i19 >> 2]);
  f25 = Math_fround(f5 - Math_fround(HEAPF32[i20 >> 2]));
  f6 = Math_fround(HEAPF32[i21 >> 2]);
  f24 = Math_fround(f6 - Math_fround(HEAPF32[i22 >> 2]));
  f7 = Math_fround(HEAPF32[i10 >> 2]);
  f8 = Math_fround(f7 - Math_fround(HEAPF32[i11 >> 2]));
  f8 = Math_fround(Math_fround(Math_fround(f25 * f25) + Math_fround(f24 * f24)) + Math_fround(f8 * f8));
  if (f8 < Math_fround(HEAPF32[i12 >> 2])) {
   HEAPF32[i13 >> 2] = f5;
   HEAPF32[i14 >> 2] = f6;
   HEAPF32[i15 >> 2] = f7;
   HEAPF32[i12 >> 2] = f8;
   i26 = i2;
   HEAP32[i26 >> 2] = i3;
   HEAP32[i26 + 4 >> 2] = i4;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i18 | 0));
 STACKTOP = i23;
 return;
}

function __ZN8Material26ResetAllCachedMaterialDataEP6Shader(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 8 | 0;
 i6 = i12;
 i11 = i12 + 16 | 0;
 i10 = gb + 64016 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i11 >> 2] = 0;
 i8 = i11 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i11 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i10;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 30792 | 0, i11, 0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i6 = 0;
  do {
   i5 = HEAP32[(HEAP32[(HEAP32[i11 >> 2] | 0) + (i6 << 2) >> 2] | 0) + 100 >> 2] | 0;
   i2 = i5 + 8 | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) HEAP32[i2 >> 2] = HEAP32[gb + 1166240 >> 2];
   i4 = i5 + 220 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3) {
    i2 = i5 + 208 | 0;
    i1 = 0;
    do {
     __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i2 >> 2] | 0) + (i1 * 244 | 0) | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i8 >> 2] | 0;
   }
   HEAP32[i5 + 200 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i1 >>> 0);
 }
 if ((HEAP32[i9 >> 2] | 0) <= -1) {
  STACKTOP = i12;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i10);
 HEAP32[i11 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI8BlobSizeEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 20 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i3 = i2 + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1 + 4 + (0 - i1 & 3);
 } else HEAP8[i4 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i3 = i2 + 16 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i2 & 3) | 0;
  i1 = (i1 & 65535) < 256 ? i2 : i2 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  HEAP8[i4 >> 0] = 0;
  i1 = i2 + 16 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i1 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i1 = (i2 & 65535) < 256 ? i1 : i1 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else HEAP8[i4 >> 0] = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i4 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i4 = (i2 & 65535) < 256 ? i4 : i4 + 4 | 0;
  i4 = (0 - i4 & 3) + i4 | 0;
  HEAP32[i3 >> 2] = i4;
  i2 = 0 - i4 | 0;
  i2 = i2 & 3;
  i4 = i2 + i4 | 0;
  i2 = i4 + 4 | 0;
  i4 = 0 - i4 | 0;
  i4 = i4 & 3;
  i4 = i2 + i4 | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i4;
  return;
 } else {
  HEAP8[i4 >> 0] = 0;
  i4 = i1;
  i2 = 0 - i4 | 0;
  i2 = i2 & 3;
  i4 = i2 + i4 | 0;
  i2 = i4 + 4 | 0;
  i4 = 0 - i4 | 0;
  i4 = i4 & 3;
  i4 = i2 + i4 | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i3 >> 2] = i4;
  return;
 }
}

function __ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 2 | 0;
 i4 = i10 + 1 | 0;
 i5 = i10;
 i2 = i8 + 16 | 0;
 i6 = i8 + 12 | 0;
 i11 = (HEAP32[i2 >> 2] | 0) != 0;
 i7 = i8 + 13 | 0;
 i1 = (HEAP8[i7 >> 0] | 0) != 0 | i11;
 if ((HEAP8[i6 >> 0] | 0) != 0 | i11) if (!(__ZN5physx2Gu15EdgeListBuilder18CreateFacesToEdgesEjPKjPKt(i9, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (i1) if (!(__ZN5physx2Gu15EdgeListBuilder18CreateEdgesToFacesEjPKjPKt(i9, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (!(__ZN5physx2Gu15EdgeListBuilder18ComputeActiveEdgesEjPKjPKtPKNS_6PxVec3Ef(i9, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, HEAP32[i8 + 8 >> 2] | 0, i1, Math_fround(HEAPF32[i8 + 20 >> 2])) | 0)) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!(HEAP8[i6 >> 0] | 0)) {
  i11 = i9 + 12 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i11 >> 2] | 0);
  HEAP32[i11 >> 2] = 0;
 }
 if (HEAP8[i7 >> 0] | 0) {
  i11 = 1;
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = i9 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i11 >> 2] | 0);
 HEAP32[i11 >> 2] = 0;
 i11 = i9 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i11 >> 2] | 0);
 HEAP32[i11 >> 2] = 0;
 i11 = 1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN26AnimatorControllerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i2 = 0;
  do {
   i3 = i2;
   i1 = i6;
   while (1) {
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
    i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
    if (!i1) break;
    if (!(HEAP32[i1 + 16 >> 2] | 0)) {
     i5 = 7;
     break;
    } else i3 = 0;
   }
   if ((i5 | 0) == 7) {
    i5 = 0;
    mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i7 | 0, i8 | 0, i9 | 0);
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0) | 0)) return;
 i1 = HEAP32[i6 + 100 >> 2] | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i5 = i1 + 4 | 0;
  i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
  if (HEAP8[(HEAP32[i5 >> 2] | 0) + i5 + 85 >> 0] | 0) HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] = -1;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 i4 = (HEAP32[i6 + 92 >> 2] | 0) + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i7 = i1 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i6 + 84 >> 2] | 0;
 __ZN7mecanim14ValueArrayCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi(i2, i3, (i5 | 0) == 0 ? 0 : i4 + i5 | 0, (i8 | 0) == 0 ? 0 : i7 + i8 | 0, HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 96 >> 2] | 0, i9 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0);
 return;
}

function __ZN10GameObject6SetTagEj(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i5 + 52 | 0;
 HEAP16[i3 >> 1] = i1;
 i4 = i5 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i2 = i5 + 72 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 do if (__ZNK10GameObject8IsActiveEv(i5) | 0) {
  i2 = HEAP32[gb + 1104660 >> 2] | 0;
  if (!(HEAP16[i3 >> 1] | 0)) {
   i2 = i2 + 8 | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = i5 + 72 | 0; else {
    i3 = i5 + 72 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = i3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i3 + 4 >> 2] = i4;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
   break;
  } else {
   if ((i4 | 0) == (i2 | 0)) break;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = i5 + 72 | 0; else {
    i3 = i5 + 72 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
    HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
    HEAP32[i4 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = i3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i3 + 4 >> 2] = i4;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1105216 | 0, i6);
 STACKTOP = i7;
 return;
}

function __GLOBAL__sub_I_runtime_assetbundles_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104136 | 0, gb + 367456 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104044 | 0, gb + 367483 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104148 | 0, gb + 367536 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104160 | 0, gb + 367554 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1104172 | 0, gb + 367576 | 0, 10, 2);
 HEAP32[gb + 1104056 >> 2] = 0;
 i1 = gb + 63216 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = gb + 1104056 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[gb + 1104056 + 12 >> 2] = 16;
 _strncpy(gb + 1104056 + 16 | 0, gb + 365485 | 0, 32) | 0;
 _strncpy(gb + 1104056 + 48 | 0, gb + 367628 | 0, 32) | 0;
 HEAP8[gb + 1104056 + 47 >> 0] = 0;
 HEAP8[gb + 1104056 + 79 >> 0] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3302 | 0, fb + 3303 | 0, 1, gb + 1104056 | 0);
 HEAP32[gb + 1104184 >> 2] = 0;
 i3 = gb + 63456 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1104184 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1104184 + 12 >> 2] = 16;
 i1 = gb + 1104184 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(0, fb + 3304 | 0, 0, gb + 1104184 | 0);
 return;
}

function __ZN5Umbra15OcclusionBufferC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 i2 = i1 + 108 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 i2 = i1 + 1208 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 1376 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 _memset(i1 + 128 | 0, 0, 1068) | 0;
 i2 = i1 + 1316 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 + 1408 >> 2] = 0;
 HEAP8[i1 + 1412 >> 0] = 0;
 HEAPF32[i1 + 1416 >> 2] = Math_fround(0.0);
 return;
}

function __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = HEAP32[gb + 1158228 >> 2] | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 L1 : do if ((HEAP32[i4 + 36 >> 2] | 0) == (i6 | 0)) {
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i1 = HEAP32[i4 + 32 >> 2] | 0;
  i3 = i2 + (i1 << 3) | 0;
 } else {
  i10 = HEAP32[i4 + 32 >> 2] | 0;
  i8 = i10 + -1 | 0;
  i1 = i8 & (Math_imul(i7, 1419247029) | 0);
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i9 = HEAP32[i4 + 20 >> 2] | 0;
  i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
  L4 : do if ((i9 | 0) != (i3 | 0)) {
   i5 = i4 + 12 | 0;
   L6 : do if (!(HEAP8[i4 + 8 >> 0] | 0)) {
    i4 = 0;
    while (1) {
     if ((i3 | 0) == (i7 | 0)) break L6;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L4;
    }
   } else {
    if (!i6) {
     i4 = 0;
     while (1) {
      if ((i3 | 0) == (i7 | 0)) break L6;
      i4 = i4 + 1 | 0;
      i1 = i4 + i1 & i8;
      i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
      if ((i9 | 0) == (i3 | 0)) break L4;
     }
    }
    i5 = HEAP32[i5 >> 2] | 0;
    i4 = 0;
    while (1) {
     if ((i5 | 0) != (i3 | 0) & (i3 | 0) == (i7 | 0)) break L6;
     i4 = i4 + 1 | 0;
     i1 = i4 + i1 & i8;
     i3 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
     if ((i9 | 0) == (i3 | 0)) break L4;
    }
   } while (0);
   if ((i1 | 0) != -1) {
    i3 = i2 + (i1 << 3) | 0;
    i1 = i10;
    break L1;
   }
  } while (0);
  i3 = i2 + (i10 << 3) | 0;
  i1 = i10;
 } while (0);
 if ((i3 | 0) == (i2 + (i1 << 3) | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 return i10 | 0;
}

function __ZN13ComputeShader15SetTextureParamEjRKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension(i8, i9, i7, i10, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0;
 i1 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i8, 22, 0) | 0;
 if ((HEAP32[i8 + 48 >> 2] | 0) >>> 0 <= i9 >>> 0) {
  i12 = 0;
  return i12 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i2 + (i9 * 96 | 0) + 16 >> 2] | 0;
 i6 = (HEAP32[i2 + (i9 * 96 | 0) + 20 >> 2] | 0) - i4 | 0;
 i3 = (i6 | 0) / 20 | 0;
 if (i6 | 0) {
  i5 = i8 + 44 | 0;
  i6 = HEAP32[i10 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i4 + (i1 * 20 | 0) >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
    i13 = HEAP32[i5 >> 2] | 0;
    HEAP32[i13 + (i9 * 976 | 0) + 132 + (i1 << 2) >> 2] = i6;
    HEAP32[i13 + (i9 * 976 | 0) + 196 + (i1 << 2) >> 2] = i11;
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 i4 = HEAP32[i2 + (i9 * 96 | 0) + 52 >> 2] | 0;
 i13 = (HEAP32[i2 + (i9 * 96 | 0) + 56 >> 2] | 0) - i4 | 0;
 i3 = (i13 | 0) / 20 | 0;
 if (!i13) {
  i13 = 1;
  return i13 | 0;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 * 20 | 0) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 1;
   i12 = 12;
   break;
  }
 }
 if ((i12 | 0) == 12) return i1 | 0;
 i13 = HEAP32[i8 + 44 >> 2] | 0;
 HEAP32[i13 + (i9 * 976 | 0) + 836 + (i1 << 2) >> 2] = HEAP32[i10 >> 2];
 i12 = i13 + (i9 * 976 | 0) + 580 + (i1 << 2) | 0;
 HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | -2147483648;
 HEAP32[i13 + (i9 * 976 | 0) + 900 + (i1 << 2) >> 2] = i11;
 i13 = 1;
 return i13 | 0;
}

function __ZN13AnimationClip14CompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i8 = i12 + 4 | 0;
 i9 = i4 + 100 | 0;
 __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj(i5, ((HEAP32[i4 + 104 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0) / 204 | 0);
 i10 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i10 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 i6 = i8 + 11 | 0;
 i7 = i4 + 4 | 0;
 i1 = 0;
 i3 = 0;
 do {
  __ZN24CompressedAnimationCurve17CompressQuatCurveERN13AnimationClip15QuaternionCurveE(i2 + (i3 * 88 | 0) | 0, (HEAP32[i9 >> 2] | 0) + (i3 * 204 | 0) | 0);
  i2 = HEAP32[i9 >> 2] | 0;
  if (!(i1 | (HEAP32[i2 + (i3 * 204 | 0) + 180 >> 2] | 0) < 1)) if (Math_fround(HEAPF32[HEAP32[i2 + (i3 * 204 | 0) + 168 >> 2] >> 2]) < Math_fround(-9.99999974e-06)) {
   HEAP32[i11 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
   __Z6FormatPKcz(i8, gb + 899491 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 899654 | 0, 2282, 4, HEAP32[i7 >> 2] | 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i1 = 1;
  } else i1 = 0;
  i3 = i3 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } while (i3 >>> 0 < (((HEAP32[i10 >> 2] | 0) - i2 | 0) / 88 | 0) >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCacheD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 40 | 0;
 i2 = i7 + 52 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0, gb + 63320 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i5 = i7 + 56 | 0;
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i7 + 44 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i7 + 60 | 0;
 i4 = i7 + 72 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, gb + 63320 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i2 = i7 + 76 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  i1 = i7 + 64 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1);
  HEAP32[i3 >> 2] = 0;
 } else i1 = i7 + 64 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i1);
 HEAP32[i3 >> 2] = 0;
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i7 + 44 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i7 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i7 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i7 + 4 | 0);
 HEAP32[i7 >> 2] = 0;
 return;
}

function _cff_ps_get_font_info(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i2 + 656 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 if (!i4) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = i4 + 2960 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  i1 = _UNITY_ft_mem_alloc(HEAP32[i2 + 100 >> 2] | 0, 32, i3) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = _cff_index_get_sid_string(i4, HEAP32[i4 + 1324 >> 2] | 0) | 0;
   HEAP32[i1 + 4 >> 2] = _cff_index_get_sid_string(i4, HEAP32[i4 + 1328 >> 2] | 0) | 0;
   HEAP32[i1 + 8 >> 2] = _cff_index_get_sid_string(i4, HEAP32[i4 + 1336 >> 2] | 0) | 0;
   HEAP32[i1 + 12 >> 2] = _cff_index_get_sid_string(i4, HEAP32[i4 + 1340 >> 2] | 0) | 0;
   HEAP32[i1 + 16 >> 2] = _cff_index_get_sid_string(i4, HEAP32[i4 + 1344 >> 2] | 0) | 0;
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 1352 >> 2];
   HEAP8[i1 + 24 >> 0] = HEAP8[i4 + 1348 >> 0] | 0;
   HEAP16[i1 + 26 >> 1] = HEAP32[i4 + 1356 >> 2];
   HEAP16[i1 + 28 >> 1] = HEAP32[i4 + 1360 >> 2];
   HEAP32[i5 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | 0;
   break;
  } else {
   i6 = i2;
   STACKTOP = i7;
   return i6 | 0;
  }
 } else i2 = 0; while (0);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 i6 = i2;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN7mecanim9animation28MotionOutputSetDeltaRotationEPNS0_12MotionOutputERKN4math7_float4E(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(f2 * f2);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(f3 * f3);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(f9 * f9);
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f12 + f11) + Math_fround(f5 + Math_fround(f10 * f10))))));
 f2 = Math_fround(f2 * f10);
 f3 = Math_fround(f3 * f10);
 f10 = Math_fround(f9 * f10);
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f3 * f3)) + Math_fround(Math_fround(f10 * f10) + Math_fround(0.0)))));
 f5 = Math_fround(Math_fround(+Math_asin(+f9)) * Math_fround(2.0));
 f2 = Math_fround(Math_fround(f2 * f5) / f9);
 f3 = Math_fround(Math_fround(f3 * f5) / f9);
 f5 = Math_fround(Math_fround(f10 * f5) / f9);
 i6 = f9 != Math_fround(0.0);
 f2 = i6 ? f2 : Math_fround(0.0);
 f3 = i6 ? f3 : Math_fround(0.0);
 f2 = Math_fround(f2 / f8);
 f3 = Math_fround(f3 / f8);
 f5 = Math_fround((i6 ? f5 : Math_fround(0.0)) / f8);
 i6 = f8 != Math_fround(0.0);
 i4 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i6 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i7 + 16 >> 2] = i4;
 HEAP32[i7 + 20 >> 2] = i1;
 HEAP32[i7 + 24 >> 2] = i6;
 return;
}

function __ZN5physx7profile15ZoneManagerImpl17removeProfileZoneERNS_13PxProfileZoneE(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i1 + 44 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0) | 0)) {
  i9 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0) | 0) != (i1 | 0)) {
  i8 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i9 | 0);
  i9 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, 0);
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i9 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
  return;
 }
 i7 = i1 + 12 | 0;
 i8 = i1 + 32 | 0;
 i4 = i1 + 28 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i1 + (i3 << 2) >> 2] | 0) == (i9 | 0)) {
   if (HEAP32[i8 >> 2] | 0) {
    i1 = 0;
    do {
     i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i9 | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i2 = i2 + -1 | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i2 >>> 0);
 i9 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
 return;
}

function __ZN5physx2Sc8ClothSim18removeCollisionBoxEPKNS0_8ShapeSimE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 8 | 0;
 i11 = i17;
 i15 = HEAP32[i8 + 52 >> 2] | 0;
 i16 = HEAP32[i8 + 92 >> 2] | 0;
 i1 = (HEAP32[i8 + 88 >> 2] | 0) + (HEAP32[i8 + 84 >> 2] | 0) + i16 | 0;
 i12 = i8 + 116 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i13 = i8 + 96 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 if (!i14) {
  STACKTOP = i17;
  return;
 } else i5 = 0;
 while (1) {
  i4 = i1 + i5 | 0;
  i2 = i9 + (i4 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i7 = i5;
   break;
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i14 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) {
  STACKTOP = i17;
  return;
 }
 i1 = i4 + 1 | 0;
 i3 = i8 + 120 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 < i5 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i9 + (i1 << 2) >> 2];
  i1 = i4 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i3 >> 2] = i5 + -1;
 HEAP32[i13 >> 2] = i14 + -1;
 i16 = (HEAP32[i15 + 80 >> 2] | 0) + (i7 * 6 | 0) + i16 | 0;
 i15 = HEAP32[i15 + 28 >> 2] | 0;
 i14 = HEAP32[(HEAP32[i15 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 mftCall_viiii(i14 | 0, i15 | 0, i10 | 0, i16 | 0, i16 + 6 | 0);
 STACKTOP = i17;
 return;
}

function __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[i3 + 280 >> 2] | 0;
 do if (i2 | 0) {
  if (!i1) {
   i1 = i3 + 4 | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
   if ((HEAP32[i1 >> 2] | 0) != 3) break;
  }
  i1 = __ZN19CloudServiceHandler10QueueEventEPN11UnityEngine15CloudWebService14CloudEventInfoE(i2, i4) | 0;
  i3 = i4 + 44 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (HEAP32[i3 >> 2] | 0) {
   i5 = i1;
   STACKTOP = i6;
   return i5 | 0;
  }
  i2 = i4 + 16 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i4 + 28 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
  }
  if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i4 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63800 | 0);
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 } while (0);
 HEAP32[i5 >> 2] = i4;
 i1 = i3 + 668 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 672 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i3 + 664 | 0, i5); else {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
 }
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN16ParticleAnimator14UpdateAnimatorERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i4, i1, i5, f3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, f6 = f0, f7 = f0, f8 = f0;
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = i4 + 108 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 1) HEAP32[i2 >> 2] = 2;
  if (HEAP8[i4 + 113 >> 0] | 0) return;
  HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  f8 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
  f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
  f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
  HEAPF32[i5 + 12 >> 2] = f8;
  HEAPF32[i5 + 16 >> 2] = f7;
  HEAPF32[i5 + 20 >> 2] = f6;
  __ZNK16ParticleAnimator15UpdateParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof(i4, i1, i5, f3);
  f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + 84 >> 2]);
  f3 = Math_fround(f7 + Math_fround(1.0));
  i4 = f7 < Math_fround(0.0);
  f3 = Math_fround(f6 * Math_fround(+Math_pow(+f3, +Math_fround(HEAPF32[i5 + 32 >> 2]))));
  HEAPF32[i5 + 28 >> 2] = i4 ? f6 : f3;
  return;
 }
 HEAPF32[i4 + 116 >> 2] = Math_fround(0.0);
 i1 = i4 + 108 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  if (!(HEAP8[i5 + 37 >> 0] | 0)) return;
  if (HEAP8[i5 + 38 >> 0] | 0) return;
 }
 __Z20DestroyObjectDelayedP6Objectf(HEAP32[i4 + 28 >> 2] | 0, Math_fround(-100.0));
 return;
}

function __ZN13GfxDeviceGLES15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij(i7, i2, i8, i1, i9, i10, i11, i12, i13, i14) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i15 = 0, i16 = 0, i17 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 i5 = i7 + 4620 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i2 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i5, 3, i3) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0) if ((i3 | 0) != 0 & (HEAP8[gb + 1548977 >> 0] | 0) == 0) {
  __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(HEAP32[gb + 1451080 >> 2] | 0, 1);
  HEAP8[gb + 1548977 >> 0] = 1;
 }
 i3 = i2 + 8 | 0;
 i16 = HEAP32[i3 + 4 >> 2] | 0;
 i15 = i7 + 7320 | 0;
 i17 = HEAP32[i15 + 4 >> 2] | 0;
 if (i17 >>> 0 < i16 >>> 0 | ((i17 | 0) == (i16 | 0) ? (HEAP32[i15 >> 2] | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 : 0)) {
  i16 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i7 + 5480 >> 2] | 0, 7) | 0;
  i17 = i7 + 7376 | 0;
  HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i16;
 }
 i17 = __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode(i5, i2, i12, i8, 0, i9, i10, i11, i13, i14, 0, 0) | 0;
 __Z34register_external_gfx_deallocationPvPKci(i4, gb + 603515 | 0, 1037);
 __Z32register_external_gfx_allocationPvjjPKci(i4, i17, i1, gb + 603515 | 0, 1038);
 STACKTOP = i6;
 return;
}

function _mbsnrtowcs(i2, i10, i6, i1, i9) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i13 + 8 | 0;
 i11 = i13;
 i7 = HEAP32[i10 >> 2] | 0;
 HEAP32[i11 >> 2] = i7;
 i12 = (i2 | 0) != 0;
 i4 = i12 ? i1 : 256;
 i2 = i12 ? i2 : i8;
 i3 = i7;
 L1 : do if ((i4 | 0) != 0 & (i7 | 0) != 0) {
  i1 = 0;
  i7 = i6;
  while (1) {
   i5 = i7 >>> 2;
   i6 = i5 >>> 0 >= i4 >>> 0;
   if (!(i7 >>> 0 > 131 | i6)) {
    i6 = i7;
    break L1;
   }
   i3 = i6 ? i4 : i5;
   i6 = i7 - i3 | 0;
   i3 = _mbsrtowcs(i2, i11, i3, i9) | 0;
   if ((i3 | 0) == -1) break;
   i7 = (i2 | 0) == (i8 | 0);
   i4 = i4 - (i7 ? 0 : i3) | 0;
   i2 = i7 ? i2 : i2 + (i3 << 2) | 0;
   i1 = i3 + i1 | 0;
   i3 = HEAP32[i11 >> 2] | 0;
   if ((i4 | 0) != 0 & (i3 | 0) != 0) i7 = i6; else break L1;
  }
  i1 = -1;
  i4 = 0;
  i3 = HEAP32[i11 >> 2] | 0;
 } else i1 = 0; while (0);
 L8 : do if (i3) if ((i4 | 0) != 0 & (i6 | 0) != 0) {
  i5 = i2;
  while (1) {
   i2 = _mbrtowc(i5, i3, i6, i9) | 0;
   if ((i2 + 2 | 0) >>> 0 < 3) break;
   i3 = (HEAP32[i11 >> 2] | 0) + i2 | 0;
   HEAP32[i11 >> 2] = i3;
   i6 = i6 - i2 | 0;
   i4 = i4 + -1 | 0;
   i1 = i1 + 1 | 0;
   if (!((i4 | 0) != 0 & (i6 | 0) != 0)) break L8; else i5 = i5 + 4 | 0;
  }
  switch (i2 | 0) {
  case -1:
   {
    i1 = -1;
    break L8;
   }
  case 0:
   {
    HEAP32[i11 >> 2] = 0;
    break L8;
   }
  default:
   {
    HEAP32[i9 >> 2] = 0;
    break L8;
   }
  }
 } while (0);
 if (i12) HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 STACKTOP = i13;
 return i1 | 0;
}

function _cff_driver_class_pic_init(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i2 = _UNITY_ft_mem_alloc(HEAP32[i6 >> 2] | 0, 144, i7) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 _memset(i2 | 0, 0, 144) | 0;
 i5 = i6 + 196 | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = _UNITY_FT_Create_Class_cff_services(i6, i2) | 0;
 HEAP32[i7 >> 2] = i1;
 if (!i1) {
  i1 = _UNITY_FT_Create_Class_cff_field_handlers(i6, i2 + 4 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
  if (!i1) {
   _UNITY_FT_Init_Class_cff_service_ps_info(i6, i2 + 8 | 0);
   _UNITY_FT_Init_Class_cff_service_glyph_dict(i6, i2 + 28 | 0);
   _UNITY_FT_Init_Class_cff_service_ps_name(i6, i2 + 36 | 0);
   _UNITY_FT_Init_Class_cff_service_get_cmap_info(i6, i2 + 40 | 0);
   _UNITY_FT_Init_Class_cff_service_cid_info(i6, i2 + 44 | 0);
   _UNITY_FT_Init_Class_cff_cmap_encoding_class_rec(i6, i2 + 64 | 0);
   _UNITY_FT_Init_Class_cff_cmap_unicode_class_rec(i6, i2 + 104 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
  }
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_cff_services(i6, i1);
 HEAP32[i4 >> 2] = 0;
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _UNITY_FT_Destroy_Class_cff_field_handlers(i6, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i3, i4);
 HEAP32[i5 >> 2] = 0;
 i7 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn12PointerRemap12InternalDataENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 4;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 669265 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 << 4) | 0;
}

function __ZN5physx3Ext15CpuWorkerThread7executeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 + 24 >> 2] = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i5 = i1 + 4 | 0;
 if (__ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv(HEAP32[i5 >> 2] | 0) | 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd10ThreadImpl4quitEv(i7);
 }
 i6 = i1 + 16 | 0;
 i7 = i1 + 20 | 0;
 i4 = i1 + 12 | 0;
 do {
  __ZN5physx3Ext20DefaultCpuDispatcher15resetWakeSignalEv(HEAP32[i6 >> 2] | 0);
  i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i7 >> 2] | 0) | 0;
  if (!i1) i3 = 10; else {
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (!(HEAP8[i1 + 8 >> 0] | 0)) {
    i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
    if (i1 | 0) {
     i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
    }
   } else {
    HEAP32[i2 >> 2] = 0;
    __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i4 >> 2] | 0, i1);
   }
   if (!i3) i3 = 10; else {
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = i3;
    i3 = 11;
   }
  }
  if ((i3 | 0) == 10) {
   i3 = 0;
   i2 = __ZN5physx3Ext20DefaultCpuDispatcher13fetchNextTaskEv(HEAP32[i6 >> 2] | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (!i2) __ZN5physx6shdfnd8SyncImpl4waitEj(HEAP32[i1 + 20 >> 2] | 0, -1) | 0; else i3 = 11;
  }
  if ((i3 | 0) == 11) {
   __ZN5physx3Ext20DefaultCpuDispatcher7runTaskERNS_10PxBaseTaskE(i1, i2);
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
  }
 } while (!(__ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv(HEAP32[i5 >> 2] | 0) | 0));
 i7 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd10ThreadImpl4quitEv(i7);
}

function __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN15DirectorManager25RemoveControllerFromArrayER13dynamic_arrayI11DirectorJobLj8EEP18PlayableController(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = i7 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i4 = 0;
 L4 : while (1) {
  while (1) {
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = i2 + (i4 * 24 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i8 | 0)) break;
   i1 = i2 + ((i1 + -1 | 0) * 24 | 0) | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i5 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
   HEAP32[i6 >> 2] = i1;
   if (i4 >>> 0 >= i1 >>> 0) {
    i1 = 7;
    break L4;
   }
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i1 >>> 0) {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  STACKTOP = i9;
  return;
 }
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper8pushNameEPKcS2_(i10, i9, i8) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 4 | 0;
 i1 = i11;
 i6 = i10 + 12 | 0;
 i7 = i10 + 28 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i10 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i10 + 56 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i10 + 48 >> 2] | 0) + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj(i10 + 36 | 0, i1) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) if (i8 | 0) {
  i4 = _strlen(i8) | 0;
  HEAP8[i5 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i6, i1 + i4 | 0, i5);
  _memcpy((HEAP32[i10 + 24 >> 2] | 0) + (i1 + -1) | 0, i8 | 0, i4 | 0) | 0;
 }
 if (!i9) {
  i9 = i10 + 24 | 0;
  i10 = HEAP32[i7 >> 2] | 0;
  i10 = i10 + -1 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i9 + i10 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 } else {
  i8 = _strlen(i9) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = (i4 | 0) == 0;
  HEAP8[i5 >> 0] = 0;
  __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i6, i4 + i8 + (i3 & 1) | 0, i5);
  i10 = i10 + 24 | 0;
  _memcpy((HEAP32[i10 >> 2] | 0) + (i3 ? 0 : i4 + -1 | 0) | 0, i9 | 0, i8 | 0) | 0;
  i9 = i10;
  i10 = HEAP32[i7 >> 2] | 0;
  i10 = i10 + -1 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i9 + i10 | 0;
  HEAP8[i10 >> 0] = 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN10MonoScript7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(144, i1, 16, gb + 1048932 | 0, 0, gb + 457515 | 0, 20) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 65032 + 8;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i4 + 92 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 108 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 124 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP8[i4 + 140 >> 0] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx12InlineBufferIjLj1024EE4freeEv(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 1 | 0;
 i9 = i11 + 4100 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 if ((i5 | 0) == 0 | (i5 | 0) == (i11 | 0)) {
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 4104 | 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i10 = HEAP32[i11 + 4096 >> 2] | 0;
 if (!i10) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13, i5);
  HEAP32[i9 >> 2] = 0;
  i12 = i11 + 4104 | 0;
  HEAP32[i12 >> 2] = 0;
  STACKTOP = i13;
  return;
 }
 i2 = HEAP32[i10 + 16 >> 2] | 0;
 if (i2 >>> 0 > i5 >>> 0) i12 = 5; else if ((i2 + (HEAP32[i10 + 20 >> 2] | 0) | 0) >>> 0 > i5 >>> 0) {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
  i6 = i10 + 8 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
  while (1) {
   i3 = i1 + -1 | 0;
   i2 = i4 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) >>> 0 < i5 >>> 0) i1 = i3; else break;
  }
  if (i1 >>> 0 < i7 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i7 >>> 0) do {
    i2 = i2 + 4 | 0;
    HEAP32[i2 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
  HEAP32[i6 >> 2] = i7 + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 } else i12 = 5;
 if ((i12 | 0) == 5) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i5);
 HEAP32[i9 >> 2] = 0;
 i12 = i11 + 4104 | 0;
 HEAP32[i12 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN15CollisionModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 83544 + 8;
 i1 = i2 + 904 | 0;
 if ((HEAP32[i2 + 920 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 908 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 816 | 0;
 if ((HEAP32[i2 + 832 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 820 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 640 | 0;
 if ((HEAP32[i2 + 656 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 644 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 552 | 0;
 if ((HEAP32[i2 + 568 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 556 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 376 | 0;
 if ((HEAP32[i2 + 392 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 380 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 288 | 0;
 if ((HEAP32[i2 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 292 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E5clearEv(i2 + 8 | 0);
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i2 + 128 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z49UnityConnectSettings_Get_Custom_PropTestConfigUrlv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 i1 = __Z23GetUnityConnectSettingsv() | 0;
 i3 = i1 + 216 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i1 + 220 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i7 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i7; else {
   i1 = i7;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i2 = i7 + 11 | 0;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __Z20scripting_string_newPKc((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return i1 | 0;
}

function __Z28LayerMask_CUSTOM_NameToLayerP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 48 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i4 = __Z13GetTagManagerv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i5);
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 24 | 0;
 i10 = gb + 63648 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i3 = HEAP8[i8 + 11 >> 0] | 0;
 i10 = i3 << 24 >> 24 < 0;
 i2 = i10 ? HEAP32[i8 >> 2] | 0 : i8;
 i3 = i10 ? HEAP32[i8 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i7 + 4 >> 2] = i3;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i5 >> 2] = i3;
 i1 = __ZN10TagManager13StringToLayerERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255) | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i4 = __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i3;
  return i4 | 0;
 }
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0) {
  i4 = 1;
  STACKTOP = i3;
  return i4 | 0;
 }
 __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i1);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) if (__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0) i1 = 0; else i1 = __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0; else {
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  if (!((i4 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) | 0)) i1 = 1; else if (__Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) i1 = __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0; else i1 = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i4 = i1;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i9, i10, i8, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i10;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i9;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i2 >>> 0 < i5 >>> 0 | (i2 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0;
 do if (i5 >>> 0 < i7 >>> 0 | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) {
  if (i3) {
   i10 = i9;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 4 >> 2] = i2;
   i1 = i8;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i7;
   i1 = 1;
   break;
  }
  i2 = i9;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = i10;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 4 >> 2] = i7;
  i2 = i8;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i6 >>> 0) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 4 >> 2] = i2;
   i1 = i8;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i7;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  i3 = i10;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i2;
  i2 = i8;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = i10;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i9;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i9 + 4 >> 2] = i2;
   i1 = i10;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i9, i10, i8, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i10;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i9;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = (i2 | 0) < (i5 | 0) | (i2 | 0) == (i5 | 0) & i1 >>> 0 < i4 >>> 0;
 do if ((i5 | 0) < (i7 | 0) | (i5 | 0) == (i7 | 0) & i4 >>> 0 < i6 >>> 0) {
  if (i3) {
   i10 = i9;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 4 >> 2] = i2;
   i1 = i8;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i7;
   i1 = 1;
   break;
  }
  i2 = i9;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = i10;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 4 >> 2] = i7;
  i2 = i8;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if ((i2 | 0) < (i7 | 0) | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i6 >>> 0) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i10 + 4 >> 2] = i2;
   i1 = i8;
   HEAP32[i1 >> 2] = i6;
   HEAP32[i1 + 4 >> 2] = i7;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  i3 = i10;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i2;
  i2 = i8;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = i10;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i9;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  if ((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i9 + 4 >> 2] = i2;
   i1 = i10;
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 12 | 0;
 i9 = i11;
 i10 = i11 + 8 | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i9, i6);
 if (!(HEAP8[i9 >> 0] | 0)) {
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
  STACKTOP = i11;
  return i6 | 0;
 }
 i8 = (HEAP32[i6 >> 2] | 0) + -12 | 0;
 HEAP32[i10 >> 2] = HEAP32[i6 + (HEAP32[i8 >> 2] | 0) + 24 >> 2];
 i8 = i6 + (HEAP32[i8 >> 2] | 0) | 0;
 i3 = i7 + i1 | 0;
 i4 = (HEAP32[i8 + 4 >> 2] & 176 | 0) == 32 ? i3 : i7;
 i2 = i8 + 76 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i5 >> 2] = __ZNKSt3__28ios_base6getlocEv(i8) | 0;
  i1 = __ZNKSt3__26locale9use_facetERNS0_2idE(i5, gb + 1474556 | 0) | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
  __ZNSt3__26localeD2Ev(i5);
  i1 = i1 << 24 >> 24;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 if (__ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_(i5, i7, i4, i3, i8, i1 & 255) | 0) {
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
  STACKTOP = i11;
  return i6 | 0;
 }
 i10 = i6 + (HEAP32[(HEAP32[i6 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base5clearEj(i10, HEAP32[i10 + 16 >> 2] | 5);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i9);
 STACKTOP = i11;
 return i6 | 0;
}

function __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451007 | 0, i6, i1, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451020 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 4 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 451033 | 0, i6, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __Z48UnityConnectSettings_Get_Custom_PropTestEventUrlv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 i1 = __Z23GetUnityConnectSettingsv() | 0;
 i3 = i1 + 200 | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i3 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i2 ? HEAP32[i1 + 204 >> 2] | 0 : i4 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  i5 = 4;
 } else if (i4 >>> 0 < 11) {
  i2 = i7 + 11 | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i4) i1 = i7; else {
   i1 = i7;
   i5 = 6;
  }
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  i2 = i4 + 16 & -16;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i6, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 8 >> 2] = i2 | -2147483648;
  HEAP32[i7 + 4 >> 2] = i4;
  i2 = i7 + 11 | 0;
  i5 = 6;
 }
 if ((i5 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i1 = __Z20scripting_string_newPKc((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return i1 | 0;
}

function __Z27SetupModuleScriptingClassesPFvvES0_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i1 = HEAP32[gb + 1164184 + 768 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[gb + 1164184 + 768 >> 2] | 0;
 }
 HEAP32[gb + 1164184 + 768 >> 2] = i1 + 1;
 i2 = gb + 1164184 + (i1 * 12 | 0) | 0;
 HEAP32[gb + 1164184 + (i1 * 12 | 0) + 4 >> 2] = 0;
 i1 = gb + 1164184 + (i1 * 12 | 0) + 8 | 0;
 if (!i3) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i2 >> 2] = i3;
 }
 i1 = HEAP32[gb + 1164956 + 768 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i6 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[gb + 1164956 + 768 >> 2] | 0;
 }
 HEAP32[gb + 1164956 + 768 >> 2] = i1 + 1;
 i2 = gb + 1164956 + (i1 * 12 | 0) | 0;
 HEAP32[gb + 1164956 + (i1 * 12 | 0) + 4 >> 2] = 0;
 i1 = gb + 1164956 + (i1 * 12 | 0) + 8 | 0;
 if (!i5) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i2 >> 2] = i5;
  STACKTOP = i6;
  return;
 }
}

function __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_(i9, i3, i8) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f10 = f0;
 i7 = HEAP32[i3 + 92 >> 2] | 0;
 i1 = (i7 | 0) == 0;
 if (i1) {
  HEAP32[i8 + 92 >> 2] = 0;
  return;
 } else i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 HEAP32[i8 + 92 >> 2] = i7;
 if (i1) return; else {
  i6 = 0;
  i1 = -1;
 }
 do {
  i3 = i8 + (HEAP32[i9 + (i6 << 2) >> 2] << 2) | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i5 = i8 + (i6 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  if ((i1 | 0) == -1) if (f4 != Math_fround(0.0)) i1 = i6; else i1 = -1; else {
   i2 = i6 + -1 | 0;
   if (i1 >>> 0 <= i2 >>> 0) {
    i3 = i1;
    do {
     f10 = Math_fround(HEAPF32[i9 + 92 + (i6 * 92 | 0) + (i3 << 2) >> 2]);
     f4 = Math_fround(f4 - Math_fround(f10 * Math_fround(HEAPF32[i8 + (i3 << 2) >> 2])));
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 <= i2 >>> 0);
   }
  }
  HEAPF32[i5 >> 2] = f4;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 i2 = i7 + -1 | 0;
 if ((i2 | 0) > -1) i5 = i2; else return;
 while (1) {
  i3 = i8 + (i5 << 2) | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i1 = i5 + 1 | 0;
  if (i1 >>> 0 <= i2 >>> 0) do {
   f10 = Math_fround(HEAPF32[i9 + 92 + (i5 * 92 | 0) + (i1 << 2) >> 2]);
   f4 = Math_fround(f4 - Math_fround(f10 * Math_fround(HEAPF32[i8 + (i1 << 2) >> 2])));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 <= i2 >>> 0);
  HEAPF32[i3 >> 2] = Math_fround(f4 / Math_fround(HEAPF32[i9 + 92 + (i5 * 92 | 0) + (i5 << 2) >> 2]));
  if ((i5 | 0) > 0) i5 = i5 + -1 | 0; else break;
 }
 return;
}

function __ZN5physx2Sq17AABBTreeUpdateMap7initMapEjRKNS0_8AABBTreeE(i8, i4, i7) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 if (!i4) {
  HEAP32[i1 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i8, 0, i1);
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i8, HEAP32[i8 + 4 >> 2] | 0);
  STACKTOP = i9;
  return;
 }
 i2 = i8 + 8 | 0;
 i6 = HEAP32[i2 >> 2] & 2147483647;
 i3 = (i4 >>> 2) + i4 | 0;
 if ((i3 >>> 0 < i6 >>> 1 >>> 0 & (i6 - i3 | 0) >>> 0 > 1024 ? 0 : i6) >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i8, 0, i1);
  i1 = i8 + 4 | 0;
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i8, HEAP32[i1 >> 2] | 0);
  if ((HEAP32[i2 >> 2] & 2147483647) >>> 0 < i3 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i8, i3);
 } else i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 _memset(HEAP32[i8 >> 2] | 0, -1, i4 << 2 | 0) | 0;
 i5 = HEAP32[i7 + 536 >> 2] | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = 0;
 do {
  i1 = i6 + (i4 * 24 | 0) + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!((i2 & 1 | 0) == 0 & 0 == 0)) {
   i1 = _bitshift64Lshr(i2 | 0, HEAP32[i1 + 4 >> 2] | 0, 21) | 0;
   getTempRet0() | 0;
   i1 = i3 + ((i1 & 524287) << 2) | 0;
   if (i1 | 0) HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] = i4;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i4, i7, i8, i6) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!i6) return;
 HEAP32[i8 >> 2] = 0;
 if (!i4) return;
 if (!(HEAP8[i4 >> 0] | 0)) return; else {
  i2 = i4;
  i1 = 0;
 }
 while (1) {
  i3 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) break; else i1 = i3;
 }
 i5 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i1 + 2 | 0) | 0;
 _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i5 + i3 >> 0] = 0;
 i3 = i5;
 L12 : while (1) {
  i2 = i3;
  while (1) {
   if (!i2) break L12;
   if (!(HEAP8[i2 >> 0] | 0)) break L12;
   i1 = i2 + 1 | 0;
   if ((HEAP8[i1 >> 0] | 0) == 124) break; else i2 = i1;
  }
  HEAP8[i1 >> 0] = 0;
  i4 = i2 + 2 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  L19 : do if (!i1) i1 = 0; else {
   i2 = i1;
   i1 = 0;
   while (1) {
    if (!(_strcasecmp(i2, i3) | 0)) break;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i6 + (i1 << 3) >> 2] | 0;
    if (!i2) {
     i1 = 0;
     break L19;
    }
   }
   i1 = HEAP32[i6 + (i1 << 3) + 4 >> 2] | 0;
  } while (0);
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i1;
  i3 = i4;
 }
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  L29 : do if (!i1) i1 = 0; else {
   i2 = i1;
   i1 = 0;
   while (1) {
    if (!(_strcasecmp(i2, i3) | 0)) break;
    i1 = i1 + 1 | 0;
    i2 = HEAP32[i6 + (i1 << 3) >> 2] | 0;
    if (!i2) {
     i1 = 0;
     break L29;
    }
   }
   i1 = HEAP32[i6 + (i1 << 3) + 4 >> 2] | 0;
  } while (0);
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i1;
 }
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i5 | 0);
 return;
}

function __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i5 + 80 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i5 + 84 >> 2] = _llvm_bswap_i32(i3 | 0) | 0;
 i1 = i4 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i4 = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 >> 0] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i5 + 88 >> 0] = i1;
 i1 = i5 + 89 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i8 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i6;
  HEAP32[i8 >> 2] = i3;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i9, i1, i6, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i8 = i10;
 __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray(i8, i2);
 if (!((i1 | 0) != 0 & i6 >>> 0 < 13)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i9 + 36 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i7 + 32 >> 2] = i6;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 HEAP32[i7 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 i1 = (__ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE9erase_oneIS1_EEjRKT_(i1 + 20 | 0, i7) | 0) != 0;
 if (i1) HEAP8[i9 + 44 >> 0] = 0;
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN15SerializeTraitsINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37224 >> 2] | 0, gb + 367250 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN19AssetBundleManifest15AssetBundleInfo8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 4;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 716123 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 << 4) | 0;
}

function __ZN4math5Limit8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i5 = i5 + 12 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i7, i8, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i5 = i9;
 i6 = i5 + 80 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 i2 = i7 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i8 * 80 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i7 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 80 | 0, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 80 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i7 >> 2] = i1;
  break;
 } while (0);
 if (i5 >>> 0 >= i8 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i1 + (i5 * 80 | 0) | 0;
 i2 = i8 - i5 | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i5 = i4 + (i1 * 80 | 0) | 0;
  i3 = i9;
  i6 = i5 + 80 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   i5 = i5 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i2 = (HEAP32[i7 + 4 >> 2] | 0) - (HEAP32[i7 >> 2] | 0) | 0;
 i9 = (i2 | 0) / 72 | 0;
 i3 = i8 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i9 | 0)) {
  HEAP32[i8 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i9) | 0;
  HEAP32[i3 >> 2] = i9;
 }
 if (!i2) return;
 i6 = i7 + 16 | 0;
 i5 = 0;
 do {
  i2 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i8 >> 2] | 0, i5) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = _il2cpp_object_new(HEAP32[i6 >> 2] | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
   HEAP32[i2 >> 2] = i1;
  }
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 + (i5 * 72 | 0) >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 24 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i4 + (i5 * 72 | 0) + 28 >> 2];
  i3 = i3 + 32 | 0;
  i1 = i4 + (i5 * 72 | 0) + 32 | 0;
  i2 = i3 + 40 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i9 | 0));
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexERKNS1_5CacheEf(i5, i1, f7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 152 >> 2] | 0;
 do if ((i2 | 0) == -1) i6 = i4; else {
  i3 = i4;
  if (Math_fround(HEAPF32[i4 + (i2 * 52 | 0) >> 2]) < f7) {
   if ((i2 + 3 | 0) >= (HEAP32[i5 + 164 >> 2] | 0)) {
    i6 = i3;
    break;
   }
   i1 = i2 + 1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 52 | 0) >> 2]) > f7) {
    i6 = i2;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + ((i2 + 2 | 0) * 52 | 0) >> 2]) > f7) {
    i6 = i1;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + ((i2 + 3 | 0) * 52 | 0) >> 2]) > f7) i1 = i2 + 2 | 0; else {
    i6 = i3;
    break;
   }
   return i1 | 0;
  } else {
   if ((i2 + -3 | 0) <= -1) {
    i6 = i3;
    break;
   }
   i1 = i2 + -1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 52 | 0) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -2 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 52 | 0) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -3 | 0;
   if (!(Math_fround(HEAPF32[i4 + (i1 * 52 | 0) >> 2]) < f7)) {
    i6 = i3;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 i5 = HEAP32[i5 + 164 >> 2] | 0;
 i1 = (i5 * 52 | 0) / 52 | 0;
 L24 : while (1) {
  while (1) {
   if (!i1) break L24;
   i2 = (i1 | 0) / 2 | 0;
   i3 = i4 + (i2 * 52 | 0) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) < f7) break; else i1 = i2;
  }
  i4 = i3 + 52 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 i4 = ((i4 - i6 | 0) / 52 | 0) + -1 | 0;
 i6 = i5 + -2 | 0;
 i6 = (i4 | 0) < (i6 | 0) ? i4 : i6;
 i6 = (i6 | 0) > 0 ? i6 : 0;
 return i6 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i9) i1 = 0; else {
  i1 = i9 << 6;
  i2 = i10 + 320 | 0;
  if (i1 >>> 0 < 321 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else if (!i1) i1 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i8 = _PxGetFoundation() | 0;
   i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
   i1 = mftCall_iiiiii(i6 | 0, i7 | 0, i1 | 0, (i8 ? gb + 832800 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = HEAP32[i10 + 328 >> 2] | 0;
 i4 = i1 + (i7 << 6) | 0;
 i8 = i10 + 324 | 0;
 if ((i7 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i5 = i2;
   i6 = i3;
   i7 = i5 + 64 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
    i5 = i5 + 4 | 0;
    i6 = i6 + 4 | 0;
   } while ((i5 | 0) < (i7 | 0));
   i2 = i2 + 64 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 64 | 0;
  }
 }
 i2 = i10 + 332 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i10 | 0) == (i3 | 0)) {
  HEAP8[i10 + 320 >> 0] = 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 if (!i3) {
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i9;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i3 | 0);
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 621;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __Z42TrailRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = f8 < Math_fround(0.0);
 f8 = i5 ? Math_fround(0.0) : f8;
 i5 = f8 > Math_fround(1.0);
 i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f8 < Math_fround(0.0);
 f8 = i6 ? Math_fround(0.0) : f8;
 i6 = f8 > Math_fround(1.0);
 i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i7 = f8 < Math_fround(0.0);
 f8 = i7 ? Math_fround(0.0) : f8;
 i7 = f8 > Math_fround(1.0);
 i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i4 = f8 < Math_fround(0.0);
 f8 = i4 ? Math_fround(0.0) : f8;
 i4 = f8 > Math_fround(1.0);
 i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = HEAP32[i3 + 384 >> 2] | 0;
 i2 = i3 + 172 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 & 255) < 2) {
  HEAP8[i2 >> 0] = 2;
  HEAP16[i3 + 142 >> 1] = -1;
  i1 = 2;
 }
 HEAP32[i3 + 108 + ((i1 & 255) + -1 << 2) >> 2] = i6 << 8 & 65280 | i5 & 255 | i7 << 16 & 16711680 | i4 << 24;
 return;
}

function __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i3 = i3 + -4 | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) & 3) << 2) >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) >>> 2 & 3) << 2) >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) >>> 4 & 3) << 2) >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + ((HEAPU8[i5 >> 0] | 0) >>> 6 << 2) >> 2];
 i1 = i1 + 16 + (i3 << 2) | 0;
 i5 = i2 + 5 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) & 3) << 2) >> 2];
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) >>> 2 & 3) << 2) >> 2];
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 + (((HEAPU8[i5 >> 0] | 0) >>> 4 & 3) << 2) >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + ((HEAPU8[i5 >> 0] | 0) >>> 6 << 2) >> 2];
 i1 = i1 + 16 + (i3 << 2) | 0;
 i6 = i2 + 6 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + (((HEAPU8[i6 >> 0] | 0) & 3) << 2) >> 2];
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 + (((HEAPU8[i6 >> 0] | 0) >>> 2 & 3) << 2) >> 2];
 i5 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 + (((HEAPU8[i6 >> 0] | 0) >>> 4 & 3) << 2) >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + ((HEAPU8[i6 >> 0] | 0) >>> 6 << 2) >> 2];
 i3 = i1 + 16 + (i3 << 2) | 0;
 i2 = i2 + 7 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + (((HEAPU8[i2 >> 0] | 0) & 3) << 2) >> 2];
 i3 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + (((HEAPU8[i2 >> 0] | 0) >>> 2 & 3) << 2) >> 2];
 i3 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + (((HEAPU8[i2 >> 0] | 0) >>> 4 & 3) << 2) >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + ((HEAPU8[i2 >> 0] | 0) >>> 6 << 2) >> 2];
 return;
}

function __ZNSt3__26localeC2ERKS0_PKci(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 do if (!i3) {
  i1 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_vii(fb + 4505 | 0, i1 | 0, gb + 1082145 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i7;
   break;
  } else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13128 | 0, fb + 3224 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  }
 } else {
  i7 = __Znwj(160) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i8 = _strlen(i3) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i5 | 0, i3 | 0, i8 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  do if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_viiii(fb + 360 | 0, i7 | 0, i1 | 0, i5 | 0, i4 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    break;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    HEAP32[i2 >> 2] = i7;
    __ZNSt3__214__shared_count12__add_sharedEv(i7);
    STACKTOP = i6;
    return;
   }
  } while (0);
  __ZdlPv(i7);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNK19TouchPhaseEmulation17CalculateTapCountExRK8Vector2f(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0, f13 = f0;
 i9 = i1 + 4 | 0;
 i4 = i1 + 16 | 0;
 i5 = i8 + 4 | 0;
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((HEAP32[i2 + (i3 * 96 | 0) >> 2] | 0) != -1) {
   if (!(HEAP8[gb + 1098144 >> 0] | 0)) {
    f11 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.400000006)) * Math_fround(.393700987));
    HEAPF32[gb + 1162096 >> 2] = f11;
    i10 = gb + 1098144 | 0;
    HEAP32[i10 >> 2] = 1;
    HEAP32[i10 + 4 >> 2] = 0;
   }
   if (!(HEAP8[gb + 1098152 >> 0] | 0)) {
    f11 = Math_fround(HEAPF32[gb + 1162096 >> 2]);
    f11 = Math_fround(f11 * f11);
    HEAPF32[gb + 1162100 >> 2] = f11;
    i10 = gb + 1098152 | 0;
    HEAP32[i10 >> 2] = 1;
    HEAP32[i10 + 4 >> 2] = 0;
   }
   i10 = i2 + (i3 * 96 | 0) + 72 | 0;
   i10 = _i64Subtract(i6 | 0, i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0) | 0;
   i12 = getTempRet0() | 0;
   if ((i12 | 0) < 0 | (i12 | 0) == 0 & i10 >>> 0 < 15e4) {
    f13 = Math_fround(HEAPF32[i2 + (i3 * 96 | 0) + 4 >> 2]);
    f13 = Math_fround(f13 - Math_fround(HEAPF32[i8 >> 2]));
    f11 = Math_fround(HEAPF32[i2 + (i3 * 96 | 0) + 8 >> 2]);
    f11 = Math_fround(f11 - Math_fround(HEAPF32[i5 >> 2]));
    f11 = Math_fround(Math_fround(f13 * f13) + Math_fround(f11 * f11));
    if (f11 < Math_fround(HEAPF32[gb + 1162100 >> 2])) {
     i12 = HEAP32[i2 + (i3 * 96 | 0) + 32 >> 2] | 0;
     i1 = i12 >>> 0 > i1 >>> 0 ? i12 : i1;
    }
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 32);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 4;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 677358 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 << 4) | 0;
}

function __ZN5physx2Gu21computeMTD_SphereMeshERNS_6PxVec3ERfRKNS0_6SphereERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i5, i3, i6, i1, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i7 + 4216 | 0;
 i13 = i7 + 4208 | 0;
 i11 = i7 + 4152 | 0;
 i8 = i7 + 4144 | 0;
 i2 = i7;
 i10 = i7 + 4116 | 0;
 i9 = i7 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 i14 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = i14;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i1);
 HEAP32[i8 >> 2] = 0;
 i1 = i2 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i2 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i10 + 16 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu17contactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i4, i9, i8, i2) | 0)) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i5, i3, HEAP32[i1 >> 2] | 0, i2) | 0)) {
  i14 = 0;
  STACKTOP = i7;
  return i14 | 0;
 }
 i14 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i14 | 0;
}

function __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN17BufferManagerGLES12AdvanceFrameEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 700 >> 0] | 0)) {
  i1 = i8 + 160 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i8;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  i7 = i8 + 148 | 0;
  i2 = HEAP32[i8 + 152 >> 2] | 0;
  i3 = i2;
  L4 : do if ((i3 | 0) == (i7 | 0)) i1 = i8 + 156 | 0; else {
   i6 = i8 + 160 | 0;
   i1 = i8 + 156 | 0;
   do {
    i4 = i2;
    i5 = i4 + 8 | 0;
    if ((mftCall_iiiii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 348 >> 2] | 0, HEAP32[i5 >> 2] | 0, 0, 0, 0) | 0) != 37146) break L4;
    HEAP32[i6 >> 2] = HEAP32[i4 + 12 >> 2];
    mftCall_vi(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 352 >> 2] | 0, HEAP32[i5 >> 2] | 0);
    i4 = i3 + 4 | 0;
    i5 = i2;
    i2 = HEAP32[i4 >> 2] | 0;
    i9 = HEAP32[i3 >> 2] | 0;
    HEAP32[i9 + 4 >> 2] = i2;
    HEAP32[HEAP32[i4 >> 2] >> 2] = i9;
    HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
    __ZdlPv(i5);
    i3 = i2;
   } while ((i3 | 0) != (i7 | 0));
  } while (0);
  i6 = mftCall_iii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 344 >> 2] | 0, 37143, 0) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i9 = __Znwj(16) | 0;
  HEAP32[i9 + 8 >> 2] = i6;
  HEAP32[i9 + 12 >> 2] = i2;
  HEAP32[i9 + 4 >> 2] = i7;
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i9 >> 2] = i6;
  HEAP32[i6 + 4 >> 2] = i9;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i8;
 }
 HEAP32[i1 >> 2] = i2 + 1;
 __ZN17BufferManagerGLES24UpdateLiveSetFromPendingEv(i8);
 if (((HEAP32[i1 >> 2] | 0) >>> 0) % 10 | 0 | 0) return;
 __ZN17BufferManagerGLES16PruneFreeBuffersEv(i8);
 return;
}

function __Z41LineRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = f8 < Math_fround(0.0);
 f8 = i5 ? Math_fround(0.0) : f8;
 i5 = f8 > Math_fround(1.0);
 i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f8 < Math_fround(0.0);
 f8 = i6 ? Math_fround(0.0) : f8;
 i6 = f8 > Math_fround(1.0);
 i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i7 = f8 < Math_fround(0.0);
 f8 = i7 ? Math_fround(0.0) : f8;
 i7 = f8 > Math_fround(1.0);
 i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i4 = f8 < Math_fround(0.0);
 f8 = i4 ? Math_fround(0.0) : f8;
 i4 = f8 > Math_fround(1.0);
 i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = HEAP32[i3 + 344 >> 2] | 0;
 i2 = i3 + 172 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 & 255) < 2) {
  HEAP8[i2 >> 0] = 2;
  HEAP16[i3 + 142 >> 1] = -1;
  i1 = 2;
 }
 HEAP32[i3 + 108 + ((i1 & 255) + -1 << 2) >> 2] = i6 << 8 & 65280 | i5 & 255 | i7 << 16 & 16711680 | i4 << 24;
 return;
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim12statemachine18StateMachineMemoryEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN8VRDevice6UpdateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0) | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1469216 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469216 | 0, i1);
  i4 = gb + 1469216 | 0;
 } else i4 = 0;
 i3 = HEAP32[i5 + 320 >> 2] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i5 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 0, i3 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 __ZN8VRDevice39UpdateTrackedDevicesAndCameraTransformsEv(i5);
 i1 = HEAP32[i5 + 280 >> 2] | 0;
 if (i1 | 0) __ZN7VRInput21UpdateControllerInputEv(i1);
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 276 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i1 + 280 >> 2] | 0) {
  i1 = mftCall_i(i2 | 0) | 0;
  if (!i1) i1 = 0; else i1 = (_memcmp(i1, i5 + 331 | 0, 16) | 0) != 0 & 1;
  i2 = mftCall_i(HEAP32[(HEAP32[i3 >> 2] | 0) + 280 >> 2] | 0) | 0;
  if (i2) {
   i3 = (_memcmp(i2, i5 + 347 | 0, 16) | 0) == 0;
   i1 = i3 ? i1 : 1;
  }
  if (i1 & 1) __ZN8VRDevice27OnAudioConfigurationChangedEv(i5);
 }
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = gb + 26828 + 8;
 i6 = i4 + 40 | 0;
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) {
  do {
   i5 = i1;
   __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i5 + 12 >> 2] | 0, HEAP32[i5 + 16 >> 2] | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i6 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i6 | 0)) do {
   i5 = i1 + 4 | 0;
   i2 = i1;
   i1 = HEAP32[i5 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 HEAP32[i3 >> 2] = i6;
 HEAP32[i6 >> 2] = i6;
 i5 = i4 + 48 | 0;
 i3 = i4 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i5 | 0)) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i5 >> 2] = i5;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 do {
  i4 = i1;
  __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i4 + 12 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i5 | 0));
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i5 >> 2] = i5;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 do {
  i4 = i1 + 4 | 0;
  i2 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 } while ((i1 | 0) != (i5 | 0));
 HEAP32[i3 >> 2] = i5;
 HEAP32[i5 >> 2] = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 return;
}

function __ZN14MemoryProfiler18PushAllocationRootEPvP13BaseAllocatorb(i1, i4, i2, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[gb + 1163240 >> 2] | 0;
 do if (!i3) if (!i4) {
  i8 = 0;
  return i8 | 0;
 } else {
  i3 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63584 | 0, 16, gb + 461921 | 0, 403) | 0;
  HEAP32[gb + 1163240 >> 2] = i3;
  HEAP32[i3 + 4 >> 2] = 10;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(40, 16, gb + 63584 | 0, 0, gb + 461921 | 0, 406) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[gb + 1163244 >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[gb + 1163244 >> 2] | 0;
  i5 = 5;
  break;
 } else {
  i1 = HEAP32[gb + 1163244 >> 2] | 0;
  if (!i4) {
   i7 = 0;
   i6 = i3;
  } else i5 = 5;
 } while (0);
 if ((i5 | 0) == 5) {
  if (!i2) i2 = __ZN13MemoryManager25GetAllocatorContainingPtrEPKv(__Z16GetMemoryManagerv() | 0, i4) | 0;
  i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i4 | 0) | 0;
  if (!i2) {
   i7 = 0;
   i6 = i3;
  } else {
   i7 = HEAP32[i2 >> 2] | 0;
   i6 = i3;
  }
 }
 if (!i8) if ((i7 | 0) == (HEAP32[i1 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = (HEAP32[gb + 1163244 >> 2] | 0) - i2 >> 2;
 i4 = i6 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) == (i5 + -1 | 0)) {
  HEAP32[i4 >> 2] = i5 << 1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i5 << 3, 16, gb + 63584 | 0, 0, gb + 461921 | 0, 428) | 0;
  HEAP32[i6 >> 2] = i1;
  i1 = i1 + (i3 << 2) | 0;
  HEAP32[gb + 1163244 >> 2] = i1;
 }
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[gb + 1163244 >> 2] = i8;
 i8 = 1;
 return i8 | 0;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKiEEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i11 + 12 | 0;
 i14 = i11 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = i2 - i1 | 0;
 i3 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i10 = i11 + 8 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 if (!i7) {
  i5 = i11;
  i9 = 0;
  i6 = i1;
  i3 = i2;
 } else {
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 85;
  HEAP32[i12 + 4 >> 2] = i9;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i5 = i11;
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 i4 = i9 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i1 = i3 - i6 | 0;
 i2 = i4 + (0 - (i1 >> 2) << 2) | 0;
 if ((i1 | 0) > 0) {
  _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i6;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i14 >> 2] = i4 + 4;
 HEAP32[i10 >> 2] = i9 + (i7 << 2);
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 85;
 HEAP32[i12 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 STACKTOP = i15;
 return;
}

function __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE7reserveEj(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = i6;
 if ((((HEAP32[i10 >> 2] | 0) - i6 | 0) / 52 | 0) >>> 0 >= i4 >>> 0) return;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 52 | 0) | 0;
 i2 = i5 + (((i2 - i6 | 0) / 52 | 0) * 52 | 0) | 0;
 i8 = i2;
 i7 = i5 + (i4 * 52 | 0) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i8;
  i5 = i6;
 } else {
  i4 = i8;
  do {
   i5 = i3;
   i3 = i3 + -52 | 0;
   HEAP32[i2 + -52 >> 2] = HEAP32[i3 >> 2];
   __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i2 + -48 | 0, i5 + -48 | 0);
   i6 = i2 + -28 | 0;
   i5 = i5 + -28 | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
   HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
   HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
   i2 = i4 + -52 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i7;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -48 | 0;
  if ((HEAP32[i1 + -32 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -44 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -52 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i15, i14) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i15 >>> 0) __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i15);
 i11 = HEAP32[i1 >> 2] | 0;
 i12 = i1 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i13 = i11 + (i15 << 6) | 0;
 if ((i1 | 0) >= (i15 | 0)) {
  HEAP32[i12 >> 2] = i15;
  return;
 }
 i2 = i14 + 4 | 0;
 i3 = i14 + 8 | 0;
 i4 = i14 + 12 | 0;
 i5 = i14 + 16 | 0;
 i6 = i14 + 20 | 0;
 i7 = i14 + 24 | 0;
 i8 = i14 + 28 | 0;
 i9 = i14 + 32 | 0;
 i10 = i14 + 36 | 0;
 i1 = i11 + (i1 << 6) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i9 >> 2];
  i11 = i1 + 36 | 0;
  HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
  HEAP32[i11 + 16 >> 2] = HEAP32[i10 + 16 >> 2];
  HEAP32[i11 + 20 >> 2] = HEAP32[i10 + 20 >> 2];
  HEAP32[i11 + 24 >> 2] = HEAP32[i10 + 24 >> 2];
  i1 = i1 + 64 | 0;
 } while (i1 >>> 0 < i13 >>> 0);
 HEAP32[i12 >> 2] = i15;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc19ClothFabricBulkDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 64 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN23ArchiveStorageConverterD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN21ArchiveStorageCreatorD2Ev(i2);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i6 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 2336 | 0;
  i4 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
  HEAP32[i3 >> 2] = i4;
  if (!i4) {
   __ZN12FileAccessor5CloseEv(i2 + 1248 | 0) | 0;
   i3 = i2 + 2376 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i4 = i2 + 2364 | 0;
    i1 = 0;
    do {
     __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i2, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
   HEAP32[i3 >> 2] = 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  }
 }
 i1 = i6 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i6 + 84 >> 2] | 0) <= -1) return;
 i5 = i6 + 68 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 72 | 0);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN14SerializedFile14GetProduceDataExRiR31LocalSerializedObjectIdentifierR18MemLabelIdentifier(i10, i6, i8, i9, i11, i12) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i13 = 0, i14 = 0;
 i2 = HEAP32[i10 + 32 >> 2] | 0;
 i7 = HEAP32[i10 + 36 >> 2] | 0;
 i1 = i7 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 * 24 | 0) | 0;
   i3 = i4;
   i14 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i14 | 0) < (i8 | 0) | ((i14 | 0) == (i8 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i6 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i7 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i14 = i1;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 if ((i13 | 0) > (i8 | 0) | ((i13 | 0) == (i8 | 0) ? (HEAP32[i14 >> 2] | 0) >>> 0 > i6 >>> 0 : 0) | (i1 | 0) == (i7 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i1 = i1 + 16 | 0;
 i14 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i14 + ((HEAP32[i1 >> 2] | 0) * 56 | 0) >> 2];
 i13 = i11 + 8 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i11 >> 2] = -1;
 i1 = HEAP16[i14 + ((HEAP32[i1 >> 2] | 0) * 56 | 0) + 42 >> 1] | 0;
 if (i1 << 16 >> 16 > -1) {
  i14 = (HEAP32[i10 + 72 >> 2] | 0) + (i1 << 16 >> 16 << 4) | 0;
  HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i14 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i14 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i14 + 12 >> 2];
 }
 HEAP32[i12 >> 2] = HEAP32[i10 + 68 >> 2];
 i14 = 1;
 return i14 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher19OnDataBlockConsumedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if (i4 | 0) {
  __ZN11UnityEngine15CloudWebService16SessionContainer11PurgeEventsEj(i4, HEAP32[i2 + 64 >> 2] | 0);
  i1 = i2 + 8 | 0;
  if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
   if (!(HEAP8[i4 + 89 >> 0] | 0)) return;
   if ((HEAP32[i4 + 72 >> 2] | 0) == (HEAP32[i4 + 68 >> 2] | 0)) {
    __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i4, i4 + 16 | 0) | 0;
    __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
    HEAP32[i3 >> 2] = 0;
    HEAP8[i2 + 52 >> 0] = 1;
    return;
   } else {
    __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i4) | 0;
    __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
    HEAP32[i3 >> 2] = 0;
    HEAP8[i2 + 52 >> 0] = 1;
    return;
   }
  }
  if (__ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE(i2, i4) | 0) return;
  i1 = i4 + 16 | 0;
  if (__ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i4, i1) | 0) {
   __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
   HEAP32[i3 >> 2] = 0;
   HEAP8[i2 + 52 >> 0] = 1;
   break;
  }
  __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr(i4, i1);
  __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE(i2, i4);
  return;
 } while (0);
 __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv(i2);
 return;
}

function __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!(i2 ^ i3)) {
  HEAP32[i1 >> 2] = 1065353216;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 1065353216;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 1065353216;
  i5 = 0;
  return i5 | 0;
 }
 if (i2) {
  i10 = HEAP32[i4 + 4 >> 2] | 0;
  i9 = HEAP32[i4 + 8 >> 2] | 0;
  i8 = HEAP32[i4 + 16 >> 2] | 0;
  i7 = HEAP32[i4 + 20 >> 2] | 0;
  i6 = HEAP32[i4 + 24 >> 2] | 0;
  i2 = HEAP32[i4 + 32 >> 2] | 0;
  i3 = HEAP32[i4 + 36 >> 2] | 0;
  i5 = HEAP32[i4 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i10;
  HEAP32[i1 + 8 >> 2] = i9;
  HEAP32[i1 + 12 >> 2] = i8;
  HEAP32[i1 + 16 >> 2] = i7;
  HEAP32[i1 + 20 >> 2] = i6;
  HEAP32[i1 + 24 >> 2] = i2;
  HEAP32[i1 + 28 >> 2] = i3;
  HEAP32[i1 + 32 >> 2] = i5;
  i5 = 1;
  return i5 | 0;
 } else {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  i4 = HEAP32[i5 + 16 >> 2] | 0;
  i6 = HEAP32[i5 + 20 >> 2] | 0;
  i7 = HEAP32[i5 + 24 >> 2] | 0;
  i8 = HEAP32[i5 + 32 >> 2] | 0;
  i9 = HEAP32[i5 + 36 >> 2] | 0;
  i10 = HEAP32[i5 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = i3;
  HEAP32[i1 + 12 >> 2] = i4;
  HEAP32[i1 + 16 >> 2] = i6;
  HEAP32[i1 + 20 >> 2] = i7;
  HEAP32[i1 + 24 >> 2] = i8;
  HEAP32[i1 + 28 >> 2] = i9;
  HEAP32[i1 + 32 >> 2] = i10;
  i10 = 1;
  return i10 | 0;
 }
 return 0;
}

function __ZNK17AnimationCurveTplI8Vector3fE9FindIndexERKNS1_5CacheEf(i5, i1, f7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 120 >> 2] | 0;
 do if ((i2 | 0) == -1) i6 = i4; else {
  i3 = i4;
  if (Math_fround(HEAPF32[i4 + (i2 * 40 | 0) >> 2]) < f7) {
   if ((i2 + 3 | 0) >= (HEAP32[i5 + 132 >> 2] | 0)) {
    i6 = i3;
    break;
   }
   i1 = i2 + 1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 40 | 0) >> 2]) > f7) {
    i6 = i2;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + ((i2 + 2 | 0) * 40 | 0) >> 2]) > f7) {
    i6 = i1;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + ((i2 + 3 | 0) * 40 | 0) >> 2]) > f7) i1 = i2 + 2 | 0; else {
    i6 = i3;
    break;
   }
   return i1 | 0;
  } else {
   if ((i2 + -3 | 0) <= -1) {
    i6 = i3;
    break;
   }
   i1 = i2 + -1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 40 | 0) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -2 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 * 40 | 0) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -3 | 0;
   if (!(Math_fround(HEAPF32[i4 + (i1 * 40 | 0) >> 2]) < f7)) {
    i6 = i3;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 i5 = HEAP32[i5 + 132 >> 2] | 0;
 i1 = (i5 * 40 | 0) / 40 | 0;
 L24 : while (1) {
  while (1) {
   if (!i1) break L24;
   i2 = (i1 | 0) / 2 | 0;
   i3 = i4 + (i2 * 40 | 0) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) < f7) break; else i1 = i2;
  }
  i4 = i3 + 40 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 i4 = ((i4 - i6 | 0) / 40 | 0) + -1 | 0;
 i6 = i5 + -2 | 0;
 i6 = (i4 | 0) < (i6 | 0) ? i4 : i6;
 i6 = (i6 | 0) > 0 ? i6 : 0;
 return i6 | 0;
}

function __ZN5physx2Sc9ClothCore16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE(i12, i9, i2) {
 i12 = i12 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 32 | 0;
 i1 = i14 + 8 | 0;
 i10 = i14;
 __ZN5physx5cloth11PhaseConfigC2Et(i1, -1);
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
 i7 = i2 + 12 | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i7 >> 2];
 i4 = i2 + 8 | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
 i1 = i12 + 32 | 0;
 i11 = __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv(HEAP32[i1 >> 2] | 0) | 0;
 if (!i11) i1 = i12 + 40 | 0; else {
  i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = i12 + 40 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = 0;
  do {
   if ((HEAP32[i8 + (i3 << 2) >> 2] | 0) == (i9 | 0)) {
    i7 = HEAP32[i1 >> 2] | 0;
    HEAP32[i7 + (i3 * 20 | 0) + 4 >> 2] = i6;
    HEAP32[i7 + (i3 * 20 | 0) + 8 >> 2] = i5;
    HEAP32[i7 + (i3 * 20 | 0) + 12 >> 2] = i4;
    HEAP32[i7 + (i3 * 20 | 0) + 16 >> 2] = i2;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i11 | 0));
 }
 i8 = HEAP32[i1 >> 2] | 0;
 i12 = HEAP32[i12 + 28 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i12 >> 2] | 0) + 160 >> 2] | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i8 + (i11 * 20 | 0);
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 mftCall_vii(i9 | 0, i12 | 0, i13 | 0);
 STACKTOP = i14;
 return;
}

function __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = i5 + (i4 << 2) | 0;
 i3 = (i4 | 0) == 0;
 L1 : do if (i3) i1 = i5; else {
  i1 = i5;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = 0;
    break;
   }
  }
  STACKTOP = i9;
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i2 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i6 + 80 >> 2] | 0;
 if (!i1) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i1 | 2 | 0) == 3) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i1 | 0) != 2 | i3) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 do {
  i2 = ((HEAP32[(HEAP32[i5 + (i1 << 2) >> 2] | 0) + 80 >> 2] | 0) == 2 & 1) + i2 | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if ((i2 | 0) != 1) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i6 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i6 + 76 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i6;
 __Z6FormatPKcz(i7, gb + 462596 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 462762 | 0, 198, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN17GeneralConnection10DisconnectEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 88 | 0;
 i4 = i7 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return; else {
  i3 = i4;
  i2 = i1;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i6 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i4 | 0)) return;
 if ((i3 | 0) == (i4 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) > (i6 | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, i6 | 0);
 i4 = i7 + 124 | 0;
 i5 = i7 + 128 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
  i2 = 0;
  do {
   mftCall_vi(HEAP32[i1 + (i2 << 2) >> 2] | 0, i6 | 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) - i1 >> 2 >>> 0);
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP32[i1 + 12 >> 2] | 0) __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv(i1);
  __ZN20BufferedSocketStreamD2Ev(i1 + 20 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) HEAP32[i8 >> 2] = i1;
 i8 = i7 + 96 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 92 >> 2] | 0, i3);
 __ZdlPv(i3);
 return;
}

function __ZN13MonoBehaviour20SetScriptingDataFromERKS_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i1 = i10;
 i4 = i6 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if (i5 | 0) {
  HEAP32[i1 >> 2] = i5;
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i8 = 7; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[i2 + 32 >> 2] | 0;
    i1 = i11 + (i3 << 3) | 0;
    i2 = i11;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i2, i1);
    i1 = HEAP32[i7 >> 2] | 0;
    i11 = HEAP32[i2 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i11 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i11 + (i1 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 9;
  }
  if ((i8 | 0) == 7) i8 = 9;
  if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i5) | 0)) break;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i9, i7, 0);
  STACKTOP = i10;
  return;
 } while (0);
 i1 = HEAP32[i6 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i9, i1, 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferentialNWDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Umbra9Matrix3x36invertERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f15 = Math_fround(Math_fround(f6 * f12) - Math_fround(f8 * f10));
 f14 = Math_fround(Math_fround(f8 * f11) - Math_fround(f4 * f12));
 f13 = Math_fround(Math_fround(f4 * f10) - Math_fround(f6 * f11));
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f9 * f13) + Math_fround(Math_fround(f7 * f15) + Math_fround(f5 * f14))));
 HEAPF32[i1 >> 2] = Math_fround(f15 * f3);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f14 * f3);
 HEAPF32[i1 + 24 >> 2] = Math_fround(f13 * f3);
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(Math_fround(f9 * f10) - Math_fround(f5 * f12)) * f3);
 HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(Math_fround(f7 * f12) - Math_fround(f9 * f11)) * f3);
 HEAPF32[i1 + 28 >> 2] = Math_fround(Math_fround(Math_fround(f5 * f11) - Math_fround(f7 * f10)) * f3);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(Math_fround(f5 * f8) - Math_fround(f9 * f6)) * f3);
 HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(Math_fround(f9 * f4) - Math_fround(f7 * f8)) * f3);
 HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(Math_fround(f7 * f6) - Math_fround(f5 * f4)) * f3);
 return i1 | 0;
}

function __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN21InheritVelocityModule8TransferI14SafeBinaryReadEEvRT_(i5, i8) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i5, i8);
 i6 = i5 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1034151 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i8 + 16 | 0;
   i2 = HEAP32[i8 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
 }
 i2 = i5 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 1034203 | 0, gb + 620173 | 0, i7, 1) | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if ((i1 | 0) > 0) __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_(i2, i8); else {
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i9;
 return;
}

function __ZN13TargetJoint2D6CreateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 48 | 0;
 i4 = i6;
 i5 = i2 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[i2 + 104 >> 0] | 0) if (!(HEAP8[i2 + 52 >> 0] | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZNK10GameObject23QueryComponentTransformEv(i1) | 0;
   if (i1 | 0) {
    __ZNK9Transform11GetPositionEv(i3, i1);
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    HEAP32[i2 + 84 >> 2] = HEAP32[i3 >> 2];
    HEAP32[i2 + 88 >> 2] = i1;
   }
  }
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 28940 | 0) | 0);
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 HEAP32[i4 >> 2] = 5;
 i5 = HEAP32[i2 + 88 >> 2] | 0;
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i4 + 24 >> 2] = i5;
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 HEAPF32[i4 + 28 >> 2] = f8;
 HEAPF32[i4 + 32 >> 2] = f7;
 HEAP32[i4 + 36 >> 2] = HEAP32[i2 + 92 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i2 + 96 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i2 + 100 >> 2];
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP8[i2 + 40 >> 0] = 1;
 __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef(i2, i4);
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKiEEvRT_(i11, i8) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i15;
 i13 = i11 + 12 | 0;
 i14 = i11 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i10 = i2 - i1 | 0;
 i3 = (i10 >> 2) + 1 | 0;
 if ((i10 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i11);
  i1 = HEAP32[i11 >> 2] | 0;
  i2 = HEAP32[i14 >> 2] | 0;
 }
 i10 = i11 + 8 | 0;
 i9 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 i7 = i9 >> 1;
 i7 = i9 >> 2 >>> 0 < 1073741823 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 2147483647;
 if (!i7) {
  i5 = i11;
  i9 = 0;
  i6 = i1;
  i3 = i2;
 } else {
  i9 = HEAP32[i13 >> 2] | 0;
  HEAP32[i12 >> 2] = 1;
  HEAP32[i12 + 4 >> 2] = i9;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 2, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
  i5 = i11;
  i6 = HEAP32[i11 >> 2] | 0;
  i3 = HEAP32[i14 >> 2] | 0;
 }
 i4 = i9 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 i1 = i3 - i6 | 0;
 i2 = i4 + (0 - (i1 >> 2) << 2) | 0;
 if ((i1 | 0) > 0) {
  _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i6;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i14 >> 2] = i4 + 4;
 HEAP32[i10 >> 2] = i9 + (i7 << 2);
 if (!i1) {
  STACKTOP = i15;
  return;
 }
 i14 = HEAP32[i13 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i14;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i12);
 STACKTOP = i15;
 return;
}

function __ZN5physx9NpFactory14addClothFabricEPNS_13NpClothFabricEb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = i1;
 if (i2) {
  i4 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
  i5 = i3 + 3944 | 0;
  i6 = i3 + 3948 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i3 + 3952 | 0;
  if (!i2) if ((HEAP32[i3 >> 2] & 2147483584) >>> 0 < 64) {
   __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i5, 64);
   i2 = HEAP32[i6 >> 2] | 0;
  } else i2 = 0;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i6 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i7) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i4 = i3 + 3944 | 0;
  i5 = i3 + 3948 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i3 + 3952 | 0;
  if (!i2) if ((HEAP32[i3 >> 2] & 2147483584) >>> 0 < 64) {
   __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i4, 64);
   i2 = HEAP32[i5 >> 2] | 0;
  } else i2 = 0;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i5 >> 2] = i2 + 1;
   STACKTOP = i8;
   return;
  } else {
   __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i7) | 0;
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i5;
 i11 = i12;
 i12 = (i5 - i12 | 0) / 24 | 0;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i12;
 HEAP8[i10 + 1 >> 0] = i12 >> 8;
 HEAP8[i10 + 2 >> 0] = i12 >> 16;
 HEAP8[i10 + 3 >> 0] = i12 >> 24;
 if ((i9 | 0) == (i11 | 0)) return;
 i1 = 0;
 do {
  i10 = i11 + (i1 * 24 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i13 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i12 >>> 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15ImportReferenceENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 4;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 672471 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 << 4) | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setMassSpaceInertiaTensorERKNS_6PxVec3E(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i7 = i10 + 48 | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f9 == Math_fround(0.0);
 f9 = Math_fround(Math_fround(1.0) / f9);
 f9 = i5 ? Math_fround(0.0) : f9;
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f8 == Math_fround(0.0);
 f8 = Math_fround(Math_fround(1.0) / f8);
 f8 = i5 ? Math_fround(0.0) : f8;
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f6 == Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / f6);
 f6 = i1 ? Math_fround(0.0) : f6;
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f6;
 i1 = i10 + 64 | 0;
 i5 = HEAP32[i10 + 52 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i3 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i3 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i10 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 96 >> 2] = f9;
 HEAPF32[i1 + 100 >> 2] = f8;
 HEAPF32[i1 + 104 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i7);
 i10 = i10 + 284 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
 STACKTOP = i11;
 return;
}

function __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZNK12NavMeshAgent22GetNextOffMeshLinkDataEP15OffMeshLinkData(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i2 = i7;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
 if (!(HEAP8[i1 + 44 >> 0] & 1)) {
  i8 = 0;
  return i8 | 0;
 }
 i5 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0;
 i6 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 if ((i4 | 0) > 1) i1 = 1; else {
  i8 = 0;
  return i8 | 0;
 }
 while (1) {
  i2 = i6 + (i1 << 3) | 0;
  i3 = i2;
  i9 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = __ZNK9dtNavMesh20getOffMeshConnectionEy(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0, i9, i3) | 0;
  if (i3 | 0) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 0;
   i8 = 8;
   break;
  }
 }
 if ((i8 | 0) == 8) return i1 | 0;
 HEAP32[i7 >> 2] = 1;
 HEAP32[i7 + 4 >> 2] = (HEAP32[i3 + 76 >> 2] | 0) != 0 & 1;
 HEAP32[i7 + 12 >> 2] = HEAPU16[i3 + 82 >> 1];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 84 >> 2];
 i8 = i6 + (i1 + -1 << 3) | 0;
 i9 = i2;
 if ((__ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_(i5, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, HEAP32[i9 >> 2] | 0, HEAP32[i9 + 4 >> 2] | 0, i7 + 16 | 0, i7 + 28 | 0) | 0) == 1073741824) {
  i9 = 1;
  return i9 | 0;
 }
 i2 = i7;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i9 = 0;
 return i9 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = i6 + 16 | 0;
 i9 = i7 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
 }
 i1 = i6 + 24 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i6 + 28 | 0;
 HEAP8[i8 >> 0] = HEAP32[i1 >> 2];
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  i9 = i9 << 24 >> 24;
  HEAP32[i1 >> 2] = i9;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE(i4, i5, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 + 152 >> 2];
 HEAP32[i3 + 4 >> 2] = 0;
 i1 = HEAP8[i2 + 8 >> 0] | 0;
 if (i1 << 24 >> 24 == 2) {
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = i1 & -64;
  HEAP32[i5 >> 2] = HEAP32[HEAP32[i7 >> 2] >> 2];
  HEAP16[i5 + 10 >> 1] = HEAP16[(HEAP32[i7 >> 2] | 0) + 34 >> 1] | 0;
  HEAP16[i5 + 8 >> 1] = i1 & 63;
 } else {
  HEAP16[i5 + 8 >> 1] = -1;
  if (i1 << 24 >> 24 == 3) {
   HEAP32[i5 >> 2] = i4;
   i1 = 0;
  } else {
   HEAP32[i5 >> 2] = (HEAP32[i4 + 100 >> 2] | 0) + ((HEAP32[i3 + ((i1 & 255) << 2) >> 2] | 0) + (HEAP32[i2 >> 2] | 0) << 5);
   i1 = (HEAP32[i2 >> 2] | 0) + 1 + (HEAP32[i3 + ((i1 & 255) << 2) >> 2] | 0) & 65535;
  }
  HEAP16[i5 + 10 >> 1] = i1;
 }
 i1 = HEAP8[i2 + 9 >> 0] | 0;
 if (i1 << 24 >> 24 == 2) {
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i7 & -64;
  HEAP32[i5 + 4 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
  HEAP16[i5 + 14 >> 1] = HEAP16[(HEAP32[i4 >> 2] | 0) + 34 >> 1] | 0;
  HEAP16[i5 + 12 >> 1] = i7 & 63;
  STACKTOP = i6;
  return;
 }
 HEAP16[i5 + 12 >> 1] = -1;
 if (i1 << 24 >> 24 == 3) {
  HEAP32[i5 + 4 >> 2] = i4;
  i1 = 0;
 } else {
  HEAP32[i5 + 4 >> 2] = (HEAP32[i4 + 100 >> 2] | 0) + ((HEAP32[i3 + ((i1 & 255) << 2) >> 2] | 0) + (HEAP32[i2 + 4 >> 2] | 0) << 5);
  i1 = (HEAP32[i2 + 4 >> 2] | 0) + 1 + (HEAP32[i3 + ((i1 & 255) << 2) >> 2] | 0) & 65535;
 }
 HEAP16[i5 + 14 >> 1] = i1;
 STACKTOP = i6;
 return;
}

function __ZN5physx18PxFabricCookerImplD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 64 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i9 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i4 = i1 + (i3 * 40 | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 602071 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i9, i1 + 12 | 0, gb + 428867 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i9, i1 + 24 | 0, gb + 428913 | 0, 0);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 36 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17SharedTextureData32GetCrunchDecompressedTextureDataI11TextureDataEEbRKT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i2 = i7 + 8 | 0;
 i12 = i7;
 i11 = i6 + 36 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 + 20 >> 2];
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i6 + 28 >> 2] = i9;
 i8 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i6 + 32 >> 2] = i8;
 i10 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i6 + 48 >> 2] = i10;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = i6 + 44 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 i1 = HEAP32[i1 >> 2] | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 i5 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i1, i2, i11, i10, i9, i8, i4, i5) | 0;
 if (!i5) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397434 | 0, 0, gb + 397959 | 0, 221, 1, 0, 0, 0);
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + 40 >> 2] = (i4 >>> 0) / ((HEAP32[i3 >> 2] | 0) >>> 0) | 0;
 i1 = i6 + 24 | 0;
 i2 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i6 + 12 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i6 + 20 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 >> 2] = i4 & 2147483647;
 i15 = 1;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7SetSizeEi(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i7 + 40 | 0;
 i6 = i7 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i4 + 320 >> 2] | 0;
    if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i10 = i4 + 56 | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i11;
     HEAP32[i10 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i11 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i11 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i11;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = __Znaj(i8 >>> 0 > 1073741823 ? -1 : i8 << 2) | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i6 >> 2] = i8;
 if ((i8 | 0) > 0) {
  HEAP32[i1 >> 2] = 0;
  if ((i8 | 0) != 1) {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  }
 }
 i11 = i7 + 28 | 0;
 HEAP32[i7 + 32 >> 2] = i11;
 HEAP32[i7 + 36 >> 2] = i11;
 i11 = i7 + 16 | 0;
 HEAP32[i7 + 20 >> 2] = i11;
 HEAP32[i7 + 24 >> 2] = i11;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 256 | 0;
 i5 = i9 + 248 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i8 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i8);
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = 0;
 do {
  i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
  if (i2 | 0) {
   i10 = __Z9GetIIMGUIv() | 0;
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i5, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0, gb + 1034525 | 0, 1);
   if (HEAP32[i5 >> 2] | 0) {
    i12 = i5;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i7;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i2, i8);
    HEAP32[i8 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i8, 0) | 0;
   }
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 256 | 0;
 i5 = i9 + 248 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i8 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i8);
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = 0;
 do {
  i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i3 >> 2] | 0, i1) | 0) >> 2] | 0;
  if (i2 | 0) {
   i10 = __Z9GetIIMGUIv() | 0;
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i5, mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0) | 0, gb + 1034525 | 0, 1);
   if (HEAP32[i5 >> 2] | 0) {
    i12 = i5;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i7;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
    __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i6, i2, i8);
    HEAP32[i8 >> 2] = 0;
    __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i8, 0) | 0;
   }
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __Z45ParticleSystem_Particle_CUSTOM_GetCurrentSizeP12Il2CppObjectR22ParticleSystemParticle(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i3 + 84 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 88 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 92 >> 2];
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 do if (HEAP8[(HEAP32[i1 + 852 >> 2] | 0) + 4 >> 0] | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
   __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(HEAP32[i1 + 852 >> 2] | 0, i3, 0, i4);
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!(HEAP8[(HEAP32[i1 + 892 >> 2] | 0) + 4 >> 0] | 0)) {
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  STACKTOP = i5;
  return Math_fround(f7);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f(HEAP32[i1 + 892 >> 2] | 0, i3, 0, i4);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 STACKTOP = i5;
 return Math_fround(f7);
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i2, i3, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i2 + 4 | 0;
 if ((i3 | 0) == (i10 | 0)) {
  STACKTOP = i9;
  return;
 }
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 do {
  i5 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  i4 = i2 ? HEAP32[i3 >> 2] | 0 : i3;
  i5 = i2 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 + 12 >> 2] = i2;
  if (i5 >>> 0 > 2147483631) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i11 = 6;
  } else if (i5 >>> 0 < 11) {
   HEAP8[i1 + 11 >> 0] = i5;
   if (i5) i11 = 8;
  } else i11 = 6;
  if ((i11 | 0) == 6) {
   i12 = i5 + 16 & -16;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i2;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 8 >> 2] = i12 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i5;
   i1 = i2;
   i11 = 8;
  }
  if ((i11 | 0) == 8) {
   i11 = 0;
   _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
  }
  HEAP8[i1 + i5 >> 0] = 0;
  i3 = i3 + 16 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 16 | 0;
  HEAP32[i6 >> 2] = i1;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i9;
 return;
}

function __ZN8VRDevice21StopRenderingToDeviceEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 i1 = HEAP32[i5 + 280 >> 2] | 0;
 if (i1 | 0) __ZN7VRInput27ResetAllReferenceTransformsEv(i1);
 __ZN8VRDevice18ReleaseEyeTexturesEv(i5);
 if (__Z11IsGfxDevicev() | 0) {
  i4 = i5 + 299 | 0;
  if (HEAP8[i4 >> 0] | 0) {
   i1 = __Z12GetGfxDevicev() | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 860 >> 2] | 0, i1 | 0, 5, 0);
   if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i2);
    i1 = gb + 1469192 | 0;
   } else i1 = 0;
   i7 = __Z12GetGfxDevicev() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 536 >> 2] | 0, i7 | 0) | 0;
   i8 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 544 >> 2] | 0, i8 | 0, i7 | 0);
   __Z15gpu_time_samplev();
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i2);
    i1 = gb + 1469204 | 0;
   } else i1 = 0;
   i2 = HEAP32[i5 + 204 >> 2] | 0;
   if (i2 | 0) mftCall_vii(i2 | 0, 10, 0);
   if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
   HEAP8[i4 >> 0] = 0;
  }
 }
 i1 = i5 + 300 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN8Animator11SetPlayableEP8Playablei(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 L1 : do if (HEAP32[i1 + 16 >> 2] | 0) while (1) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) {
   i1 = 0;
   break L1;
  }
  i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   break L1;
  }
  if (!(HEAP32[i1 + 16 >> 2] | 0)) break; else i2 = 0;
 } while (0);
 i5 = i6 + 628 | 0;
 if (__ZNK9HPlayable7IsValidEv(i5) | 0) i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0; else i2 = 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i8;
  return;
 }
 __ZN8Animator11ClearObjectEv(i6);
 if (__ZNK9HPlayable7IsValidEv(i5) | 0) i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0; else i2 = 0;
 i3 = i6 + 624 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!((i4 | 0) == 0 | (i2 | 0) != (i4 | 0))) {
  HEAP32[i6 + 108 >> 2] = 0;
  __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv(i4);
  i4 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0, i6 + 112 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i2 = gb + 37528 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN8Playable6HandleEv(i7, i1);
 i3 = i7;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP8[i6 + 76 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) & 1;
 STACKTOP = i8;
 return;
}

function __ZN7mecanim12statemachine20CreateStateWorkspaceEjjjRNS_6memory9AllocatorE(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 16, 4) | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 if (!i3) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = i3;
  return i7 | 0;
 }
 i2 = i3 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i3 << 2) | 0)) HEAP32[i7 >> 2] = i1; else {
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i3 << 2) | 0)) HEAP32[i8 >> 2] = i1; else {
  _memset(i1 | 0, 0, i2 | 0) | 0;
  HEAP32[i8 >> 2] = i1;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
 if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i1;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = i3;
 i1 = 0;
 do {
  i3 = __ZN7mecanim9animation20CreateBlendTreeInputERNS_6memory9AllocatorE(i6) | 0;
  HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i3 = __ZN7mecanim9animation21CreateBlendTreeOutputEjRNS_6memory9AllocatorE(i5, i6) | 0;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i3 = __ZN7mecanim9animation24CreateBlendTreeWorkspaceEjRNS_6memory9AllocatorE(i4, i6) | 0;
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return i7 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37224 >> 2] | 0, gb + 619781 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i7 = i2 + 4 | 0;
 i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i8 = i1 + 24 | 0;
 if (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i3, 4);
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14GraphicsHelper8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 580 >> 2] | 0, i1 | 0, 2, i2 | 0);
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(f8 + Math_fround(HEAPF32[i4 + 8 >> 2]));
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + 12 >> 2]));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 mftCall_viffff(HEAP32[(HEAP32[i1 >> 2] | 0) + 568 >> 2] | 0, i1 | 0, 1.0, 1.0, 1.0, 1.0);
 f5 = (HEAP32[tempDoublePtr >> 2] = i3 ? i4 : i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 572 >> 2] | 0, i1 | 0, +f8, +f5, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, 0.0, 0.0, .100000001);
 f7 = (HEAP32[tempDoublePtr >> 2] = i3 ? i2 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 572 >> 2] | 0, i1 | 0, +f8, +f7, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, 0.0, 1.0, .100000001);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 572 >> 2] | 0, i1 | 0, +f6, +f7, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, 1.0, 1.0, .100000001);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 572 >> 2] | 0, i1 | 0, +f6, +f5, 0.0);
 mftCall_vifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 560 >> 2] | 0, i1 | 0, 1.0, 0.0, .100000001);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 584 >> 2] | 0, i1 | 0);
 return;
}

function __Z41ComputeShader_CUSTOM_SetTextureFromGlobalP12Il2CppObjectiii(i11, i12, i9, i5) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 20 | 0;
 i15 = i16 + 8 | 0;
 i7 = i16;
 i13 = i16 + 16 | 0;
 i14 = i16 + 12 | 0;
 i6 = HEAP32[gb + 1166248 >> 2] | 0;
 i1 = HEAP32[i6 + 56 >> 2] | 0;
 i3 = HEAP32[i6 + 60 >> 2] | 0;
 if ((i1 | 0) >= (i3 | 0)) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509162 | 0, i7);
 i4 = HEAP32[i6 + 68 >> 2] | 0;
 while (1) {
  if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
  i2 = i1 + 1 | 0;
  if ((i2 | 0) < (i3 | 0)) i1 = i2; else {
   i8 = 6;
   break;
  }
 }
 if ((i8 | 0) == 6) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509162 | 0, i7);
 if ((i1 | 0) <= -1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509162 | 0, i7);
 i2 = HEAP32[(HEAP32[i6 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i6 + 88 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) >> 2] | 0;
 HEAP32[i13 >> 2] = i9;
 if (!i11) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i11) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 HEAP32[i14 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i14 >> 2];
 if (__ZN13ComputeShader15SetTextureParamEjRKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension(i1, i12, i13, i10, 2) | 0) {
  STACKTOP = i16;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509162 | 0, i15);
}

function __Z30Sprite_CUSTOM_OverrideGeometryP12Il2CppObjectP11Il2CppArrayS2_(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = i7 + 4 | 0;
 if (!i6) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i8 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (__ZN6Sprite19CanAccessFromScriptEv(i1) | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0;
  i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
  i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 2) | 0;
  __ZN6Sprite16OverrideGeometryEPK8Vector2fjPKtj(i1, i5, i6, i8, __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0) | 0;
  STACKTOP = i7;
  return;
 } else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
  HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i4, gb + 568649 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 568697 | 0, 265, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i7;
  return;
 }
}

function _psh_hint_table_activate_mask(i13, i10, i3) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i11 = HEAP32[i13 >> 2] | 0;
 i12 = i13 + 8 | 0;
 if (i11 | 0) {
  i1 = HEAP32[i12 >> 2] | 0;
  i2 = i11;
  while (1) {
   i14 = i1 + 16 | 0;
   HEAP32[i14 >> 2] = HEAP32[i14 >> 2] & -5;
   HEAP32[i1 + 24 >> 2] = -1;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i1 = i1 + 28 | 0;
  }
 }
 if (!i10) {
  HEAP32[i13 + 4 >> 2] = 0;
  return;
 }
 i9 = i13 + 12 | 0;
 i1 = 0;
 i2 = 0;
 i8 = 0;
 i5 = 0;
 while (1) {
  if (!i1) {
   i6 = 128;
   i7 = HEAPU8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
  } else {
   i6 = i1;
   i7 = i2;
  }
  if (!(i6 & i7)) i14 = i5; else {
   i2 = HEAP32[i12 >> 2] | 0;
   i1 = i2 + (i8 * 28 | 0) | 0;
   i2 = i2 + (i8 * 28 | 0) + 16 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if (!(i4 & 4)) {
    HEAP32[i2 >> 2] = i4 | 4;
    if (i5 >>> 0 < i11 >>> 0) {
     HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] = i1;
     i14 = i5 + 1 | 0;
    } else i14 = i5;
   } else i14 = i5;
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == (i10 | 0)) break; else {
   i1 = i6 >> 1;
   i2 = i7;
   i5 = i14;
  }
 }
 HEAP32[i13 + 4 >> 2] = i14;
 i4 = HEAP32[i9 >> 2] | 0;
 if ((i14 | 0) > 1) i3 = 1; else return;
 do {
  i5 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i1 = i3;
  do {
   i2 = i1;
   i1 = i1 + -1 | 0;
   i7 = i4 + (i1 << 2) | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   if ((HEAP32[i8 >> 2] | 0) < (i6 | 0)) break;
   HEAP32[i4 + (i2 << 2) >> 2] = i8;
   HEAP32[i7 >> 2] = i5;
  } while ((i2 | 0) > 1);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i14 | 0));
 return;
}

function __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(i1, i11, i13, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!(HEAP8[i1 + 112 >> 0] | 0)) return;
 i9 = i1 + 64 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
 i10 = HEAP32[i1 + 72 >> 2] | 0;
 i7 = HEAP32[i1 + 104 >> 2] | 0;
 if (i7 | 0) {
  i5 = i11;
  i5 = i5 + ~(i5 << 15) | 0;
  i5 = (i5 >>> 10 ^ i5) * 9 | 0;
  i5 = i5 >>> 6 ^ i5;
  i5 = i5 + ~(i5 << 11) | 0;
  i5 = i5 >>> 16 ^ i5;
  i8 = 0;
  do {
   i6 = i10 + (i8 << 3) | 0;
   i2 = HEAP32[i10 + (i8 << 3) + 4 >> 2] | 0;
   L8 : do if (HEAPU8[i2 + 40 >> 0] & i12 | 0) {
    if (!(HEAP8[i2 + 41 >> 0] | 0)) {
     i6 = HEAP32[i6 >> 2] | 0;
     mftCall_viiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i11 | 0, i13 | 0, i12 | 0);
     break;
    }
    i1 = HEAP32[i2 + 20 >> 2] | 0;
    if (i1 | 0) {
     i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + ((i1 + -1 & i5) << 2) >> 2] | 0;
     if ((i1 | 0) != -1) {
      i4 = HEAP32[i2 + 4 >> 2] | 0;
      i3 = i2 + 8 | 0;
      i2 = i1;
      while (1) {
       i1 = i4 + (i2 << 2) | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i11 | 0)) break;
       i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
       if ((i2 | 0) == -1) break L8;
      }
      if (i1 | 0) {
       i6 = HEAP32[i6 >> 2] | 0;
       mftCall_viiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i11 | 0, i13 | 0, i12 | 0);
      }
     }
    }
   } while (0);
   i8 = i8 + 1 | 0;
  } while ((i8 | 0) != (i7 | 0));
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf(i1, i2, i4, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0, i16 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i5 + 24 | 0;
 i15 = i5;
 HEAP32[i16 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i16, i2);
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i16, i15, i4, Math_fround(0.0), 0);
 f10 = Math_fround(HEAPF32[i15 >> 2]);
 f14 = Math_fround(HEAPF32[i15 + 12 >> 2]);
 f11 = Math_fround(f10 + f14);
 f6 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i15 + 16 >> 2]);
 f13 = Math_fround(f6 + f7);
 f9 = Math_fround(HEAPF32[i15 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i15 + 20 >> 2]);
 f11 = Math_fround(f11 * Math_fround(.5));
 f13 = Math_fround(f13 * Math_fround(.5));
 f12 = Math_fround(Math_fround(f9 + f8) * Math_fround(.5));
 f10 = Math_fround(Math_fround(Math_fround(f14 - f10) * Math_fround(.5)) * f3);
 f6 = Math_fround(Math_fround(Math_fround(f7 - f6) * Math_fround(.5)) * f3);
 f3 = Math_fround(Math_fround(Math_fround(f8 - f9) * Math_fround(.5)) * f3);
 f9 = Math_fround(f13 - f6);
 f8 = Math_fround(f12 - f3);
 f7 = Math_fround(f11 + f10);
 f6 = Math_fround(f13 + f6);
 f3 = Math_fround(f12 + f3);
 HEAPF32[i1 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i1 + 4 >> 2] = f9;
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f3;
 STACKTOP = i5;
 return;
}

function __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN17MeshRenderingData7ReleaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
 }
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
  }
 }
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
 return;
}

function __ZN9Transform17ValidateHierarchyER18TransformHierarchy(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 16 | 0;
 i5 = i10 + 12 | 0;
 i8 = i10;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 i1 = gb + 63160 | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = HEAP32[i6 >> 2] | 0;
 do if (!i2) {
  i7 = 0;
  i1 = 0;
 } else if (i2 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i7 = i1;
  i1 = i2;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 421343 | 0, 1846) | 0;
  i2 = gb + 64016 | 0;
  i11 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  i1 = i9;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = HEAP32[i6 >> 2] | 0;
  break;
 } while (0);
 _memset(i7 | 0, 0, i1 | 0) | 0;
 __ZN9Transform26ValidateHierarchyRecursiveER18TransformHierarchyRiS2_iPh(i3, i6, i4, i5, 0, i7);
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i11 = HEAP32[i8 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
  STACKTOP = i10;
  return;
 }
 i2 = i6 + 68 | 0;
 do {
  HEAP8[i7 + i1 >> 0] = 1;
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) != -1);
 i11 = HEAP32[i8 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setMassSpaceInertiaTensorERKNS_6PxVec3E(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i7 = i10 + 48 | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f9 == Math_fround(0.0);
 f9 = Math_fround(Math_fround(1.0) / f9);
 f9 = i5 ? Math_fround(0.0) : f9;
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f8 == Math_fround(0.0);
 f8 = Math_fround(Math_fround(1.0) / f8);
 f8 = i5 ? Math_fround(0.0) : f8;
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f6 == Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) / f6);
 f6 = i1 ? Math_fround(0.0) : f6;
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f6;
 i1 = i10 + 64 | 0;
 i5 = HEAP32[i10 + 52 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i3 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i3 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i10 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 96 >> 2] = f9;
 HEAPF32[i1 + 100 >> 2] = f8;
 HEAPF32[i1 + 104 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i7);
 i10 = i10 + 284 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 2;
 STACKTOP = i11;
 return;
}

function __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j(i4, _llvm_bswap_i32(i1 | 0) | 0);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i8 >> 2] = i2;
   i2 = i4;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIj8UnityStrEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_110DataStream25beginPropertyMessageGroupERKN5physx8debugger14NamespacedNameE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 12 | 0;
 i5 = i3;
 HEAP32[i2 + 204 >> 2] = 2;
 i4 = HEAP32[i2 + 64 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i6 | 0, i1 | 0);
 i6 = i7 + 4 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i2 + 312 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i2 + 320 >> 2] = HEAP32[i7 + 12 >> 2];
 i9 = i7 + 16 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i2 + 324 | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i2 + 332 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i2 + 336 >> 2] = HEAP32[i7 + 28 >> 2];
 HEAP32[i2 + 340 >> 2] = HEAP32[i7 + 32 >> 2];
 HEAP32[i2 + 344 >> 2] = HEAP32[i7 + 36 >> 2];
 HEAP32[i2 + 348 >> 2] = HEAP32[i7 + 40 >> 2];
 HEAP32[i2 + 352 >> 2] = HEAP32[i7 + 44 >> 2];
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 >> 2] | 0) | 0;
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = gb + 150140 + 8;
 i1 = i5 + 4 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i6;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i5, 12);
 i2 = (HEAPU8[i2 + 392 >> 0] | 0) ^ 1;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZL16SweepCapsuleMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i8, i9, i6, i4, i5, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 28 | 0;
 i3 = i10;
 i1 = HEAP32[i6 + 40 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i12 = (HEAP32[i8 + 8 >> 2] | 0) + ((HEAP32[i6 + 44 >> 2] | 0) * 36 | 0) | 0;
 i11 = HEAP32[i8 + 100 + (HEAP32[i8 + 96 >> 2] << 2) >> 2] | 0;
 HEAP32[i2 >> 2] = 2;
 d18 = +HEAPF64[i4 >> 3];
 d16 = +HEAPF64[i4 + 8 >> 3];
 d14 = +HEAPF64[i4 + 16 >> 3];
 d17 = +HEAPF64[i6 + 16 >> 3];
 d15 = +HEAPF64[i6 + 24 >> 3];
 d13 = +HEAPF64[i6 + 32 >> 3];
 HEAP32[i2 + 4 >> 2] = HEAP32[i9 + 40 >> 2];
 HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i9 + 44 >> 2]) * Math_fround(.5));
 HEAPF32[i3 + 16 >> 2] = Math_fround(d18 - d17);
 HEAPF32[i3 + 20 >> 2] = Math_fround(d16 - d15);
 HEAPF32[i3 + 24 >> 2] = Math_fround(d14 - d13);
 HEAP32[i3 >> 2] = HEAP32[i8 + 228 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 232 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 236 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 240 >> 2];
 i9 = __ZL17sweepVolumeVsMeshPKN5physx3Cct9SweepTestEPKNS0_11TouchedMeshERNS0_12SweptContactERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleEj(i8, i6, i7, i5, i2, i3, i1, i12, i11 >>> 0 >= i1 >>> 0 ? 0 : i11) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z28RemoteSettings_CUSTOM_HasKeyP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 48 | 0;
 i7 = i9 + 16 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i5 = (__Z21GetUnityConnectClientv() | 0) + 768 | 0;
 __ZNK11ICallString6ToUTF8Ev(i8, i2);
 i2 = (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8;
 HEAP32[i7 >> 2] = 0;
 i3 = i7 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i7 + 24 | 0;
 i10 = gb + 63648 | 0;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 > 15) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i6, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i10;
  HEAP32[i7 + 4 >> 2] = i4;
  i1 = (i10 | 0) == 0 ? i1 : i10;
 }
 _memcpy(i1 | 0, i2 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i3 >> 2] = i4;
 i1 = (__ZN11UnityEngine7Connect14RemoteSettings6HasKeyERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE(i5, i7) | 0) & 1;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN9ShaderLabL22StaticDestroyShaderLabEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1166560 >> 2] | 0;
 if (i1 | 0) __ZNSt3__25stackIPN9ShaderLab21SerializedShaderStateENS_5dequeIS3_NS_9allocatorIS3_EEEEED2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166560 >> 2] = 0;
 __ZN8keywords7CleanupEv();
 i3 = HEAP32[gb + 1166564 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 4 | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = i3; else {
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63280 | 0);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   i3 = HEAP32[gb + 1166564 >> 2] | 0;
   i2 = i3 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i3;
 }
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  HEAP32[gb + 1166564 >> 2] = 0;
  i3 = HEAP32[gb + 1166404 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  HEAP32[gb + 1166404 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166564 >> 2] = 0;
 i3 = HEAP32[gb + 1166404 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
 HEAP32[gb + 1166404 >> 2] = 0;
 return;
}

function __ZN9ShaderLab25SerializedTextureProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i4 = i7 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i6 = i7 + 4 | 0;
 i5 = i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 HEAP32[i11 >> 2] = i5;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i6 = i3 ? HEAP32[i6 >> 2] | 0 : i2 & 255;
 i3 = i1 + i6 | 0;
 if (i6 | 0) do {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i11, 4);
  i11 = HEAP32[i11 >> 2] | 0;
  HEAP32[i1 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEclERS4_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERy(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1;
 i9 = i2 - i3 | 0;
 i4 = i9 + 8 | 0;
 if (i4) {
  i6 = i5 + 20 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i2 = i1 + i9 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i6 >> 2] = i1 + i4;
  }
 }
 HEAP32[i8 >> 2] = i2 + 8;
 i8 = i10;
 i7 = i8;
 i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
 i8 = i8 + 4 | 0;
 i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8 | HEAPU8[i8 + 2 >> 0] << 16 | HEAPU8[i8 + 3 >> 0] << 24;
 i10 = i1 + i9 | 0;
 i9 = i10;
 HEAP8[i9 >> 0] = i7;
 HEAP8[i9 + 1 >> 0] = i7 >> 8;
 HEAP8[i9 + 2 >> 0] = i7 >> 16;
 HEAP8[i9 + 3 >> 0] = i7 >> 24;
 i10 = i10 + 4 | 0;
 HEAP8[i10 >> 0] = i8;
 HEAP8[i10 + 1 >> 0] = i8 >> 8;
 HEAP8[i10 + 2 >> 0] = i8 >> 16;
 HEAP8[i10 + 3 >> 0] = i8 >> 24;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i5;
 i11 = i12;
 i12 = (i5 - i12 | 0) / 12 | 0;
 i5 = HEAP32[i13 + 4 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i12;
 HEAP8[i10 + 1 >> 0] = i12 >> 8;
 HEAP8[i10 + 2 >> 0] = i12 >> 16;
 HEAP8[i10 + 3 >> 0] = i12 >> 24;
 if ((i9 | 0) == (i11 | 0)) return;
 i1 = 0;
 do {
  i10 = i11 + (i1 * 12 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i13 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i12 >>> 0);
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN17AnimationCurveTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i5 = i8 + 132 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i8 + 120 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (i5 | 0) do {
  __ZN11KeyframeTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 140 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 144 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 148 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZN16Physics2DManager16BatchOverlapInitEPK4PPtrIN5Unity9ComponentEEPP10Collider2Dj(i1, i8, i9, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i7 = i12;
 if (!i10) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i5 = 0;
 i1 = 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i8 + (i5 << 2) >> 2];
  i2 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i2) i11 = 9; else {
   if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[i2 + 32 >> 2] | 0;
    i2 = i3 + (i4 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i7);
    i3 = HEAP32[i6 >> 2] | 0;
    i13 = HEAP32[i2 + 28 >> 2] | 0;
    i4 = HEAP32[gb + 1104264 >> 2] | 0;
    i2 = (i3 | 0) == -1 ? i13 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i13 + (i3 << 3) | 0;
    i3 = HEAP32[i4 + 28 >> 2] | 0;
    i4 = HEAP32[i4 + 32 >> 2] | 0;
   }
   if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i11 = 9; else {
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (i2) {
     i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 32588 | 0) | 0;
     if (i2) {
      HEAP32[i9 + (i1 << 2) >> 2] = i2;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  if ((i11 | 0) == 9) i11 = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i10 | 0));
 STACKTOP = i12;
 return i1 | 0;
}

function __ZNSt3__218__insertion_sort_3IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i2 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i5) {
  i3 = HEAP32[i6 >> 2] | 0;
  if (i1) {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i3;
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0) {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i5;
  }
 } else if (i1) {
  i3 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0) {
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i5;
  }
 } while (0);
 i1 = i6 + 12 | 0;
 if ((i1 | 0) == (i7 | 0)) return;
 while (1) {
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i5 = i4;
   i3 = i1;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    if ((i2 | 0) == (i6 | 0)) break;
    i3 = i2 + -4 | 0;
    if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
     i9 = i2;
     i2 = i3;
     i3 = i9;
    } else break;
   }
   HEAP32[i2 >> 2] = i4;
  }
  i2 = i1 + 4 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i9 = i1;
   i1 = i2;
   i2 = i9;
  }
 }
 return;
}

function __ZN9Polygon2D7SetPathEiRK13dynamic_arrayI8Vector2fLj4EE(i3, i9, i5) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i9) {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i3, 1);
   i2 = HEAP32[i3 >> 2] | 0;
  } else i4 = 6;
 } else if ((i9 | 0) < 0) i4 = 7; else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = 6;
 }
 if ((i4 | 0) == 6) if (((i1 - i2 | 0) / 20 | 0 | 0) <= (i9 | 0)) i4 = 7;
 if ((i4 | 0) == 7) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 391593 | 0, 0, gb + 391638 | 0, 31, 1, 0, 0, 0);
  return;
 }
 i6 = i2 + (i9 * 20 | 0) | 0;
 if ((i6 | 0) == (i5 | 0)) return;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = i2 + (i9 * 20 | 0) + 12 | 0;
 i1 = HEAP32[i5 + 12 >> 2] << 3;
 i3 = i1 >> 3;
 HEAP32[i8 >> 2] = i3;
 i4 = i2 + (i9 * 20 | 0) + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i2 + (i9 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i2 + (i9 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx18PxsDynamicsContextC2EPNS_10PxsContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 + 96 >> 2] = i1;
 i1 = i4 + 100 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i4 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 140 >> 2] = Math_fround(-2.0);
 HEAP32[i4 + 148 >> 2] = 32;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i2 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i4 + 156 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i4 + 76 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAPF32[i4 + 80 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 72 >> 2] = 0;
 i1 = i4 + 68 | 0;
 i2 = i4 + 32 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 84 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAP32[i4 + 28 >> 2] = 65535;
 HEAP16[i4 + 12 >> 1] = -1;
 HEAP16[i4 + 14 >> 1] = -1;
 HEAP32[i4 + 136 >> 2] = __ZN5physx20PxsSolverCoreGeneral6createEv() | 0;
 return;
}

function __ZN5Umbra9Matrix4x49transposeERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((i2 | 0) == (i1 | 0)) {
  i4 = i2 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i2 + 16 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i2 + 32 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i1;
  i4 = i2 + 12 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i2 + 48 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 24 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i2 + 36 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i1;
  i4 = i2 + 28 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i2 + 52 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 44 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 56 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 36 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 52 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 56 >> 2];
  HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 44 >> 2];
  HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
  return;
 }
}

function __ZN4math5Limit8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i5 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i5 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i5 = i5 + 12 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i5 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN17SharedTextureData32GetCrunchDecompressedTextureDataIS_EEbRKT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i2 = i7 + 8 | 0;
 i12 = i7;
 i11 = i6 + 36 | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 + 36 >> 2];
 i9 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i6 + 28 >> 2] = i9;
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i6 + 32 >> 2] = i8;
 i10 = HEAP32[i1 + 48 >> 2] | 0;
 HEAP32[i6 + 48 >> 2] = i10;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i6 + 44 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = HEAP32[i1 + 40 >> 2];
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i15 = gb + 64016 | 0;
 i14 = HEAP32[i15 + 4 >> 2] | 0;
 i13 = i12;
 HEAP32[i13 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 i5 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i1, i2, i11, i10, i9, i8, i4, i5) | 0;
 if (!i5) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397434 | 0, 0, gb + 397959 | 0, 221, 1, 0, 0, 0);
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + 40 >> 2] = (i4 >>> 0) / ((HEAP32[i3 >> 2] | 0) >>> 0) | 0;
 i1 = i6 + 24 | 0;
 i2 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i6 + 12 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i6 + 20 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 >> 2] = i4 & 2147483647;
 i15 = 1;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN15SerializeTraitsI17SortingLayerEntryE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i6, i2, 1); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 370924 | 0, HEAP32[gb + 37304 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14EdgeCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(180, i1, 16, gb + 1048932 | 0, 0, gb + 805999 | 0, 16) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153816 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i4 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4 + 80 | 0) | 0;
 HEAP32[i4 >> 2] = gb + 155208 + 8;
 HEAP32[i4 + 160 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 HEAP32[i4 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 164 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z19DebugTextLineByLinePKci(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 4 | 0;
 i3 = (i2 | 0) == -1;
 L1 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 10:
  case 13:
   break;
  default:
   break L1;
  }
  i1 = i1 + 1 | 0;
 }
 i4 = i3 ? 1023 : i2;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 }
 i5 = i6 + 11 | 0;
 do {
  i3 = i1;
  L10 : while (1) {
   switch (i2 << 24 >> 24) {
   case 0:
   case 10:
   case 13:
    break L10;
   default:
    {}
   }
   i2 = i3 + 1 | 0;
   i3 = i2;
   i2 = HEAP8[i2 >> 0] | 0;
  }
  i9 = i1;
  i2 = (i3 - i9 | 0) > (i4 | 0) ? i1 + i4 | 0 : i3;
  i3 = HEAP8[i2 >> 0] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i6, i1, i2 - i9 | 0) | 0;
  HEAP32[i7 >> 2] = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
  _printf_console(gb + 1076431 | 0, i7);
  L14 : do switch (i3 << 24 >> 24) {
  case 10:
  case 13:
   {
    i1 = i2;
    while (1) {
     i2 = HEAP8[i1 >> 0] | 0;
     switch (i2 << 24 >> 24) {
     case 10:
     case 13:
      break;
     default:
      break L14;
     }
     i1 = i1 + 1 | 0;
    }
   }
  default:
   {
    i1 = i2;
    i2 = HEAP8[i2 >> 0] | 0;
   }
  } while (0);
 } while (i2 << 24 >> 24 != 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 3) + 1 | 0;
 if ((i8 | 0) < -8) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 2;
 i6 = i7 >> 3 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 3 << 3) | 0;
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 8;
 HEAP32[i8 >> 2] = i7 + (i6 << 3);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEclERS4_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f17 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f14 = Math_fround(f8 + f8);
 f7 = Math_fround(f17 + f17);
 f13 = Math_fround(f15 + f15);
 f5 = Math_fround(f17 * f7);
 f9 = Math_fround(f15 * f13);
 f17 = Math_fround(f14 * f17);
 f16 = Math_fround(f14 * f15);
 f6 = Math_fround(f14 * f10);
 f15 = Math_fround(f7 * f15);
 f7 = Math_fround(f7 * f10);
 f10 = Math_fround(f13 * f10);
 f13 = Math_fround(Math_fround(Math_fround(1.0) - f5) - f9);
 f12 = Math_fround(f17 + f10);
 f11 = Math_fround(f16 - f7);
 f10 = Math_fround(f17 - f10);
 f14 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f14));
 f9 = Math_fround(f14 - f9);
 f8 = Math_fround(f15 + f6);
 f7 = Math_fround(f16 + f7);
 f6 = Math_fround(f15 - f6);
 f5 = Math_fround(f14 - f5);
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAPF32[i2 + 36 >> 2] = f13;
 HEAPF32[i2 + 40 >> 2] = f12;
 HEAPF32[i2 + 44 >> 2] = f11;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAPF32[i2 + 52 >> 2] = f10;
 HEAPF32[i2 + 56 >> 2] = f9;
 HEAPF32[i2 + 60 >> 2] = f8;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAPF32[i2 + 68 >> 2] = f7;
 HEAPF32[i2 + 72 >> 2] = f6;
 HEAPF32[i2 + 76 >> 2] = f5;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = i4;
 HEAP32[i2 + 88 >> 2] = i3;
 HEAP32[i2 + 92 >> 2] = i1;
 HEAP32[i2 + 96 >> 2] = 1065353216;
 return i2 | 0;
}

function __ZN5physx19PxClothFabricCreateERNS_9PxPhysicsERKNS_15PxClothMeshDescERKNS_6PxVec3Eb(i7, i4, i5, i8) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 52 | 0;
 i1 = i10 + 40 | 0;
 i2 = i10;
 i3 = i6 + 4 | 0;
 i9 = i3;
 i11 = i9 + 72 | 0;
 do {
  HEAP32[i9 >> 2] = 0;
  i9 = i9 + 4 | 0;
 } while ((i9 | 0) < (i11 | 0));
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 if (!(__ZN5physx18PxFabricCookerImpl4cookERKNS_15PxClothMeshDescENS_6PxVec3Eb(i6, i4, i1, i8) | 0)) {
  i11 = 0;
  __ZN5physx18PxFabricCookerImplD2Ev(i6);
  STACKTOP = i10;
  return i11 | 0;
 }
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 12 >> 2] = (HEAP32[i6 + 20 >> 2] | 0) + -1;
 HEAP32[i2 + 16 >> 2] = (HEAP32[i6 + 16 >> 2] | 0) + 4;
 HEAP32[i2 + 24 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 40 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i6 + 56 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i6 + 52 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i6 + 64 >> 2];
 i11 = mftCall_iii(i11 | 0, i7 | 0, i2 | 0) | 0;
 __ZN5physx18PxFabricCookerImplD2Ev(i6);
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN19SkinnedMeshRenderer13BecameVisibleEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 467 | 0;
 HEAP8[i3 >> 0] = 1;
 i5 = HEAP32[i4 + 464 >> 2] | 0;
 i1 = i5 >>> 24 & 255;
 if (!((i5 & 255) << 24 >> 24)) {
  if (HEAP32[i4 + 380 >> 2] | 0) i2 = 3;
 } else i2 = 3;
 if ((i2 | 0) == 3) HEAP8[i4 + 272 >> 0] = 1;
 i2 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i2 = __ZNK10GameObject8IsActiveEv(i2) | 0;
  i1 = HEAP8[i3 >> 0] | 0;
 }
 do if (!(i1 << 24 >> 24)) {
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i5 = i4 + 500 | 0;
   HEAP8[i5 >> 0] = 1;
   return;
  }
 } else {
  i3 = i2 & (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0);
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(i3 ^ (i1 | 0) != 0)) {
   i5 = i4 + 500 | 0;
   HEAP8[i5 >> 0] = 1;
   return;
  }
  if (!i3) {
   if (i1 | 0) break;
   i5 = i4 + 500 | 0;
   HEAP8[i5 >> 0] = 1;
   return;
  }
  if ((i2 | 0) == (gb + 1161628 | 0)) {
   i5 = i4 + 500 | 0;
   HEAP8[i5 >> 0] = 1;
   return;
  }
  if (!i1) i1 = i4 + 528 | 0; else {
   i5 = i4 + 528 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i5;
  }
  i5 = HEAP32[gb + 1161628 >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = gb + 1161628;
  HEAP32[i5 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  i5 = i4 + 500 | 0;
  HEAP8[i5 >> 0] = 1;
  return;
 } while (0);
 i5 = i4 + 528 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i4 + 500 | 0;
 HEAP8[i5 >> 0] = 1;
 return;
}

function __ZN11AssetBundleC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 27268 + 8;
 HEAP32[i1 + 32 >> 2] = 1;
 i3 = i1 + 36 | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i1 + 72;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = i1 + 84;
 __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev(i1 + 92 | 0);
 i2 = i1 + 148 | 0;
 i3 = i1 + 168 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 0;
 __ZN14ConstantString12create_emptyEv(i3);
 i3 = i1 + 172 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
 STACKTOP = i4;
 return;
}

function __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i4);
 i1 = i6 + 48 | 0;
 i7 = i4 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 36 | 0, i4);
 i1 = i6 + 52 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 53 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function ___des_setkey(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i4 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0) | (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24;
 i3 = (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0) | (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24;
 i9 = 0;
 i10 = 0;
 i1 = 28;
 i2 = 0;
 while (1) {
  i7 = i2 << 1;
  i6 = i4 >>> i1 & 15;
  i9 = HEAP32[gb + 196596 + (i2 << 6) + (i6 << 2) >> 2] | i9 | HEAP32[gb + 196596 + (i2 + 4 << 6) + ((i3 >>> i1 & 15) << 2) >> 2];
  i8 = i1 + -4 | 0;
  i10 = HEAP32[gb + 197108 + (i7 << 6) + (i6 << 2) >> 2] | i10 | HEAP32[gb + 197108 + ((i7 | 1) << 6) + ((i4 >>> i8 & 15) << 2) >> 2] | HEAP32[gb + 197108 + (i2 + 8 << 6) + ((i3 >>> i8 & 15) << 2) >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 4) {
   i1 = 0;
   i4 = 0;
   break;
  } else i1 = i1 + -8 | 0;
 }
 do {
  i4 = (HEAPU8[gb + 1056797 + i1 >> 0] | 0) + i4 | 0;
  i8 = 28 - i4 | 0;
  i7 = i9 >>> i8 | i9 << i4;
  i8 = i10 >>> i8 | i10 << i4;
  i2 = 0;
  i3 = 0;
  i5 = 25;
  i6 = 0;
  while (1) {
   i12 = i5 + -4 | 0;
   i3 = HEAP32[gb + 197876 + (i6 << 5) + ((i7 >>> i5 & 7) << 2) >> 2] | i3 | HEAP32[gb + 198132 + (i6 << 6) + ((i7 >>> i12 & 15) << 2) >> 2];
   i2 = HEAP32[gb + 198004 + (i6 << 5) + ((i8 >>> i5 & 7) << 2) >> 2] | i2 | HEAP32[gb + 198388 + (i6 << 6) + ((i8 >>> i12 & 15) << 2) >> 2];
   i6 = i6 + 1 | 0;
   if ((i6 | 0) == 4) break; else i5 = i5 + -7 | 0;
  }
  HEAP32[i11 + (i1 << 2) >> 2] = i3;
  HEAP32[i11 + 64 + (i1 << 2) >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 return;
}

function __ZNSt3__26vectorIPN11UnityEngine15CloudWebService17WebFileDownloaderINS2_13WWWRestClientENS2_16WWWRestHeaderMapEEE13stl_allocatorIS7_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS7_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 85;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 85;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9Texture3D9SetPixelsEiPK10ColorRGBAfi(i2, i10, i11, i12) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0, i15 = 0;
 if ((i10 | 0) == 0 | (i11 | 0) == 0) return;
 i1 = i2 + 96 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418864 | 0, 0, gb + 411375 | 0, 264, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if (!((i12 | 0) > -1 & (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) > (i12 | 0))) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 411375 | 0, 271, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i2 + 80 >> 2] | 0;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 i9 = HEAP32[i2 + 88 >> 2] | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 i3 = HEAP32[gb + 45784 + (i5 << 2) >> 2] | 0;
 if ((i12 | 0) > 0) {
  i2 = 0;
  i1 = 0;
  i4 = 0;
  do {
   i15 = i7 >> i2;
   i14 = i8 >> i2;
   i13 = i9 >> i2;
   i13 = Math_imul(Math_imul(Math_imul((i15 | 0) < 1 ? 1 : i15, i3) | 0, (i14 | 0) < 1 ? 1 : i14) | 0, (i13 | 0) < 1 ? 1 : i13) | 0;
   i1 = _i64Add(i13 | 0, ((i13 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i4 | 0) | 0;
   i4 = getTempRet0() | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i12 | 0));
 } else i1 = 0;
 i14 = i7 >> i12;
 i14 = (i14 | 0) < 1 ? 1 : i14;
 i15 = i8 >> i12;
 i13 = i9 >> i12;
 i15 = Math_imul((i13 | 0) < 1 ? 1 : i13, (i15 | 0) < 1 ? 1 : i15) | 0;
 __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf(i6 + i1 | 0, i14, i15, i5, 0, 0, i14, i15, i10, i11) | 0;
 return;
}

function __ZN9GfxDevice16RestoreDrawStatsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 12 | 0;
 i1 = i7 + 8 | 0;
 i4 = i7 + 4 | 0;
 i5 = i7;
 i6 = i3 + 3640 | 0;
 i8 = i3 + 3928 | 0;
 i9 = i6 + 96 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  i6 = i6 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i6 | 0) < (i9 | 0));
 HEAP32[i4 >> 2] = HEAP32[i3 + 4024 >> 2];
 HEAP32[i5 >> 2] = i3 + 4028;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_(i3 + 3736 | 0, i1, i2);
 i6 = i3 + 3620 | 0;
 i8 = i3 + 3908 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i3 + 3892 >> 2] = HEAP32[i3 + 4180 >> 2];
 i6 = i3 + 3816 | 0;
 i8 = i3 + 4104 | 0;
 i9 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  i6 = i6 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i6 | 0) < (i9 | 0));
 i9 = i3 + 3752 | 0;
 i8 = i3 + 4040 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i3 + 3888 >> 2] = HEAP32[i3 + 4176 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN8FindClipclERK4PPtrI13AnimationClipE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i6 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i8 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i8 + 28 >> 2] | 0;
   i3 = HEAP32[i8 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i6 = i1;
    i8 = HEAP32[i6 >> 2] | 0;
    i8 = i8 + 36 | 0;
    i8 = HEAP32[i8 >> 2] | 0;
    i6 = mftCall_ii(i8 | 0, i6 | 0) | 0;
    i8 = HEAP32[i4 >> 2] | 0;
    i8 = _strcmp(i6, i8) | 0;
    i8 = (i8 | 0) == 0;
    STACKTOP = i7;
    return i8 | 0;
   }
  }
 }
 i6 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i8 = i8 + 36 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i6 = mftCall_ii(i8 | 0, i6 | 0) | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i8 = _strcmp(i6, i8) | 0;
 i8 = (i8 | 0) == 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 619;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 618;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 617;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 616;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx18PxsMaterialManager6resizeEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = i6 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (i4 >>> 0 >= i1 >>> 0) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 31 & -32;
 HEAP32[i2 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7 + 1 | 0, i1 << 5 | 19, gb + 710719 | 0, 96) | 0;
 if (!i1) i3 = 0; else {
  i3 = i1 + 19 & -16;
  HEAP32[i3 + -4 >> 2] = i3 - i1;
 }
 if (i4 | 0) {
  i1 = 0;
  do {
   i9 = i3 + (i1 << 5) | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i8 = i10 + (i1 << 5) | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP16[i3 + (i1 << 5) + 12 >> 1] = HEAP16[i10 + (i1 << 5) + 12 >> 1] | 0;
   i9 = i3 + (i1 << 5) + 14 | 0;
   i8 = i10 + (i1 << 5) + 14 | 0;
   i8 = HEAPU8[i8 >> 0] | HEAPU8[i8 + 1 >> 0] << 8;
   HEAP8[i9 >> 0] = i8;
   HEAP8[i9 + 1 >> 0] = i8 >> 8;
   i10 = i10 + (i1 << 5) + 16 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i3 + (i1 << 5) + 16 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i2 = HEAP32[i2 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  i1 = i4;
  do {
   HEAP32[i3 + (i1 << 5) + 20 >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 HEAP32[i6 >> 2] = i3;
 STACKTOP = i7;
 return;
}

function __ZN5Umbra6Random5resetEj(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = (((i1 | 0) == 0) << 31 >> 31) + i1 | 0;
 i2 = i2 << 13 ^ i2;
 i2 = i2 >>> 17 ^ i2;
 i2 = i2 << 5 ^ i2;
 HEAP32[i7 + 8 >> 2] = i2;
 i3 = i2 << 13 ^ i2;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 12 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 16 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 20 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 24 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 28 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 32 >> 2] = i3;
 i3 = i3 << 13 ^ i3;
 i3 = i3 >>> 17 ^ i3;
 i3 = i3 << 5 ^ i3;
 HEAP32[i7 + 36 >> 2] = i3;
 i6 = i3 << 13 ^ i3;
 i6 = i6 >>> 17 ^ i6;
 i6 = i6 << 5 ^ i6;
 HEAP32[i7 + 40 >> 2] = i6;
 i6 = i6 << 13 ^ i6;
 i6 = i6 >>> 17 ^ i6;
 i6 = i6 << 5 ^ i6;
 HEAP32[i7 + 44 >> 2] = i6;
 i6 = i6 << 13 ^ i6;
 i6 = i6 >>> 17 ^ i6;
 HEAP32[i7 + 48 >> 2] = i6 << 5 ^ i6;
 HEAP32[i7 >> 2] = 0;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = 7;
 i1 = 0;
 i4 = 0;
 while (1) {
  i5 = i3 + i2 | 0;
  HEAP32[i7 + 8 + (i4 << 2) >> 2] = i5 << 13 | i5 >>> 19;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  i5 = (i5 >> 31 & 11) + i5 | 0;
  HEAP32[i7 >> 2] = i5;
  i2 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  i2 = (i2 >> 31 & 11) + i2 | 0;
  HEAP32[i6 >> 2] = i2;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 9) break;
  i4 = i5;
  i3 = HEAP32[i7 + 8 + (i2 << 2) >> 2] | 0;
  i2 = HEAP32[i7 + 8 + (i5 << 2) >> 2] | 0;
 }
 return;
}

function __ZN4math4Axes8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i5, i1);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i5 + 16 | 0, i1);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i5 + 32 | 0, gb + 906554 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i5 + 44 | 0, gb + 906590 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i5 + 56 | 0, gb + 906596 | 0, 0);
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 }
 HEAP32[i5 + 68 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i5 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i2;
  i7 = i5;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN4core20StringStorageDefaultIcE6assignERKS1_(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 if ((i9 | 0) == (i1 | 0)) return;
 i11 = HEAP32[i1 >> 2] | 0;
 i8 = (i11 | 0) == 0;
 i11 = i8 ? i1 + 4 | 0 : i11;
 i10 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i7 = (i6 | 0) == 0;
 if (!((HEAP32[i1 + 4 >> 2] | 0) != 0 | i8)) {
  i1 = i9 + 4 | 0;
  if (!i7) if (HEAP32[i1 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i6, i9 + 24 | 0);
  HEAP32[i9 >> 2] = i11;
  HEAP32[i9 + 20 >> 2] = i10;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 i8 = i9 + 4 | 0;
 i5 = i7 ? i8 : i6;
 if (i5 >>> 0 <= i11 >>> 0) {
  i2 = i9 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i5 + i1 | 0) >>> 0 > i11 >>> 0) {
   i1 = i1 >>> 0 < i10 >>> 0 ? i1 : i10;
   if ((i5 | 0) != (i11 | 0)) _memmove(i5 | 0, i11 | 0, i1 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   return;
  }
 }
 i4 = i9 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (i2) if (i7) {
  i1 = 15;
  i3 = 11;
 } else i3 = 14; else {
  i1 = i7 ? 15 : i1;
  i3 = 11;
 }
 if ((i3 | 0) == 11) if (i1 >>> 0 < i10 >>> 0) if (i7 | i2) i3 = 14; else {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i9 + 24 | 0);
  i3 = 14;
 } else i1 = i5;
 if ((i3 | 0) == 14) {
  if (i10 >>> 0 > 15) {
   i1 = i10;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i10 + 1 | 0, 16, i9 + 24 | 0, 0, gb + 1047486 | 0, 251) | 0;
  } else {
   i1 = 0;
   i2 = 0;
  }
  HEAP32[i9 >> 2] = i2;
  HEAP32[i4 >> 2] = i1;
  i1 = (i2 | 0) == 0 ? i8 : i2;
 }
 _memcpy(i1 | 0, i11 | 0, i10 | 0) | 0;
 HEAP8[i1 + i10 >> 0] = 0;
 HEAP32[i9 + 20 >> 2] = i10;
 return;
}

function __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i3 = i8 + 8 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 < i2 >>> 0) {
  if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i1 + (i2 << 4) | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig8RegisterERNS_7Connect13ConfigHandlerE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i7 = i10 + 24 | 0;
 i8 = i10 + 8 | 0;
 if (HEAP8[i6 >> 0] | 0) {
  STACKTOP = i10;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i9 = i8 + 11 | 0;
 HEAP8[i9 >> 0] = 9;
 i2 = i8;
 i3 = gb + 1042554 | 0;
 i4 = i2 + 9 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i8 + 9 >> 0] = 0;
 i2 = __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr(i1, i8) | 0;
 i3 = i2 + 768 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i7, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = i6;
 HEAP8[i2 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + (i1 * 12 | 0) >> 2] = fb + 1001;
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  i9 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i7);
 }
 HEAP8[i6 >> 0] = 1;
 STACKTOP = i10;
 return;
}

function __Z36Quaternion_CUSTOM_INTERNAL_CALL_LerpRK11QuaternionfS1_fRS_(i3, i5, f1, i12) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 i12 = i12 | 0;
 var f2 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f13 = f0, i14 = 0, i15 = 0;
 i14 = f1 < Math_fround(0.0);
 i15 = f1 > Math_fround(1.0);
 f8 = i15 ? Math_fround(1.0) : f1;
 f8 = i14 ? Math_fround(0.0) : f8;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f13 = Math_fround(f11 * f2);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f9 * f4));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f10 * f6));
 f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f1 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 if (Math_fround(f13 + Math_fround(f7 * f1)) < Math_fround(0.0)) {
  f6 = Math_fround(-f6);
  f4 = Math_fround(-f4);
  f2 = Math_fround(-f2);
  f1 = Math_fround(-f1);
 }
 f2 = Math_fround(f11 + Math_fround(f8 * Math_fround(f2 - f11)));
 f4 = Math_fround(f9 + Math_fround(f8 * Math_fround(f4 - f9)));
 f11 = Math_fround(f10 + Math_fround(f8 * Math_fround(f6 - f10)));
 f13 = Math_fround(f7 + Math_fround(f8 * Math_fround(f1 - f7)));
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f11 * f11) + Math_fround(Math_fround(f4 * f4) + Math_fround(f2 * f2))))));
 f10 = Math_fround(f4 / f9);
 f11 = Math_fround(f11 / f9);
 f13 = Math_fround(f13 / f9);
 HEAPF32[i12 >> 2] = Math_fround(f2 / f9);
 HEAPF32[i12 + 4 >> 2] = f10;
 HEAPF32[i12 + 8 >> 2] = f11;
 HEAPF32[i12 + 12 >> 2] = f13;
 return;
}

function __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = HEAP16[i1 >> 1] | 0;
 i8 = HEAP16[i1 + 2 >> 1] | 0;
 i6 = (i9 & 65535) >>> 11 & 65535;
 i6 = i6 << 3 | i6 >>> 2;
 HEAP8[i7 >> 0] = i6;
 i1 = (i9 & 65535) >>> 5 & 63;
 i1 = i1 << 2 | i1 >>> 4;
 HEAP8[i7 + 1 >> 0] = i1;
 i2 = i9 & 31;
 i2 = i2 << 3 | i2 >>> 2;
 HEAP8[i7 + 2 >> 0] = i2;
 HEAP8[i7 + 3 >> 0] = -1;
 i3 = (i8 & 65535) >>> 11 & 65535;
 i3 = i3 << 3 | i3 >>> 2;
 HEAP8[i7 + 4 >> 0] = i3;
 i4 = (i8 & 65535) >>> 5 & 63;
 i4 = i4 << 2 | i4 >>> 4;
 HEAP8[i7 + 5 >> 0] = i4;
 i5 = i8 & 31;
 i5 = i5 << 3 | i5 >>> 2;
 HEAP8[i7 + 6 >> 0] = i5;
 HEAP8[i7 + 7 >> 0] = -1;
 if ((i9 & 65535) > (i8 & 65535)) {
  HEAP8[i7 + 8 >> 0] = ((i3 + (i6 << 1) | 0) >>> 0) / 3 | 0;
  HEAP8[i7 + 9 >> 0] = (((i1 << 1) + i4 | 0) >>> 0) / 3 | 0;
  HEAP8[i7 + 10 >> 0] = (((i2 << 1) + i5 | 0) >>> 0) / 3 | 0;
  HEAP8[i7 + 11 >> 0] = -1;
  HEAP8[i7 + 12 >> 0] = (((i3 << 1) + i6 | 0) >>> 0) / 3 | 0;
  i8 = -1;
  i6 = ((((i5 << 1) + i2 | 0) >>> 0) / 3 | 0) & 255;
  i5 = ((((i4 << 1) + i1 | 0) >>> 0) / 3 | 0) & 255;
  i9 = i7 + 13 | 0;
  HEAP8[i9 >> 0] = i5;
  i9 = i7 + 14 | 0;
  HEAP8[i9 >> 0] = i6;
  i9 = i7 + 15 | 0;
  HEAP8[i9 >> 0] = i8;
  return;
 } else {
  HEAP8[i7 + 8 >> 0] = (i3 + i6 | 0) >>> 1;
  HEAP8[i7 + 9 >> 0] = (i4 + i1 | 0) >>> 1;
  HEAP8[i7 + 10 >> 0] = (i5 + i2 | 0) >>> 1;
  HEAP8[i7 + 11 >> 0] = -1;
  HEAP8[i7 + 12 >> 0] = 0;
  i8 = 0;
  i6 = 0;
  i5 = 0;
  i9 = i7 + 13 | 0;
  HEAP8[i9 >> 0] = i5;
  i9 = i7 + 14 | 0;
  HEAP8[i9 >> 0] = i6;
  i9 = i7 + 15 | 0;
  HEAP8[i9 >> 0] = i8;
  return;
 }
}

function __ZNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 3) + 1 | 0;
 if ((i8 | 0) < -8) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 2;
 i6 = i7 >> 3 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 56;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 3 << 3) | 0;
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 8;
 HEAP32[i8 >> 2] = i7 + (i6 << 3);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 56;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__212__deque_baseI18ReflectionProbeJobNS_9allocatorIS1_EEED2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = i10 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i10 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + (((i1 >>> 0) / 341 | 0) << 2) | 0;
 i11 = i10 + 8 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i4 = i7;
 i5 = i2;
 if ((i7 | 0) == (i2 | 0)) {
  i6 = 0;
  i7 = i10 + 20 | 0;
  i1 = 0;
 } else {
  i7 = i10 + 20 | 0;
  i6 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i6 = (HEAP32[i2 + (((i6 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i6 >>> 0) % 341 | 0) * 12 | 0) | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
 }
 L5 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L5;
   i1 = i1 + 12 | 0;
  } while ((i1 - (HEAP32[i3 >> 2] | 0) | 0) != 4092);
  i1 = i3 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i4 - i5 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = (HEAP32[i11 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i8 >> 2] = 170;
   break;
  }
 case 2:
  {
   HEAP32[i8 >> 2] = 341;
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i7 + 36 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i6) {
  i7 = 0;
  return i7 | 0;
 } else i5 = 0;
 while (1) {
  i2 = i5 << 2;
  i3 = i4 + (i5 * 224 | 0) + 212 | 0;
  if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i7, i2) | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (HEAP8[i1 + 77 >> 0] | 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) {
     i1 = 1;
     i2 = 7;
     break;
    }
   }
  }
  if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i7, i2 | 1) | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (HEAP8[i1 + 157 >> 0] | 0) {
    i1 = HEAP32[i1 + 80 >> 2] | 0;
    if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) {
     i1 = 1;
     i2 = 7;
     break;
    }
   }
  }
  if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i7, i2 | 2) | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (HEAP8[i1 + 237 >> 0] | 0) {
    i1 = HEAP32[i1 + 160 >> 2] | 0;
    if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) {
     i1 = 1;
     i2 = 7;
     break;
    }
   }
  }
  if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i7, i2 | 3) | 0)) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (HEAP8[i1 + 317 >> 0] | 0) {
    i1 = HEAP32[i1 + 240 >> 2] | 0;
    if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) {
     i1 = 1;
     i2 = 7;
     break;
    }
   }
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN24EllipsoidParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i2, i7);
 i3 = i2 + 220 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047683 | 0, HEAP32[gb + 37324 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i7); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i4 = i2 + 232 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1047695 | 0, HEAP32[gb + 37012 >> 2] | 0, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i7 + 16 | 0;
  i5 = HEAP32[i7 + 20 >> 2] | 0;
  i2 = i5 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i5 >>> 0) i6 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i6 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN16PackedQuatVector11UnpackQuatsEP11Quaternionf(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0, i16 = 0, i17 = 0, f18 = f0;
 i15 = HEAP32[i1 >> 2] | 0;
 if ((i15 | 0) <= 0) return;
 i13 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 i11 = 0;
 do {
  i12 = 0;
  i3 = 0;
  do {
   i12 = (HEAPU8[i13 + i1 >> 0] | 0) >>> i2 << i3 | i12;
   i10 = 3 - i3 | 0;
   i9 = 8 - i2 | 0;
   i10 = (i9 | 0) < (i10 | 0) ? i9 : i10;
   i9 = i10 + i2 | 0;
   i3 = i10 + i3 | 0;
   i10 = (i9 | 0) == 8;
   i2 = i10 ? 0 : i9;
   i1 = (i10 & 1) + i1 | 0;
  } while ((i3 | 0) < 3);
  i8 = i12 & 3;
  i9 = i12 + 1 & 3;
  i10 = i14 + (i11 << 4) | 0;
  i7 = 0;
  f4 = Math_fround(0.0);
  do {
   if ((i8 | 0) != (i7 | 0)) {
    i6 = (i9 | 0) == (i7 | 0) ? 9 : 10;
    i3 = 0;
    i5 = 0;
    do {
     i3 = (HEAPU8[i13 + i1 >> 0] | 0) >>> i2 << i5 | i3;
     i16 = i6 - i5 | 0;
     i17 = 8 - i2 | 0;
     i16 = (i17 | 0) < (i16 | 0) ? i17 : i16;
     i17 = i16 + i2 | 0;
     i5 = i16 + i5 | 0;
     i16 = (i17 | 0) == 8;
     i2 = i16 ? 0 : i17;
     i1 = (i16 & 1) + i1 | 0;
    } while ((i6 | 0) > (i5 | 0));
    i17 = (1 << i6) + -1 | 0;
    f18 = Math_fround(+((i3 & i17) >>> 0) / (+(i17 | 0) * .5) + -1.0);
    HEAPF32[i10 + (i7 << 2) >> 2] = f18;
    f4 = Math_fround(f4 + Math_fround(f18 * f18));
   }
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != 4);
  f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - f4)));
  f18 = Math_fround(-f4);
  HEAPF32[i10 + (i8 << 2) >> 2] = (i12 & 4 | 0) == 0 ? f4 : f18;
  i11 = i11 + 1 | 0;
 } while ((i11 | 0) < (i15 | 0));
 return;
}

function __ZN16MemoryFileSystem4CopyER13FileEntryDataS1_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i5);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i5) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 54;
  HEAP32[i4 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 }
 if (!i1) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) == 2) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i2, i3, 1) | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 i5 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP8[i7 + 20 >> 0] = 1;
 i7 = 1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, f7 = f0, f8 = f0;
 i6 = __ZN13b2DynamicTree12AllocateNodeEv(i5) | 0;
 i3 = i5 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-.100000001));
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) + Math_fround(-.100000001));
 HEAPF32[i4 + (i6 * 36 | 0) >> 2] = f7;
 HEAPF32[i4 + (i6 * 36 | 0) + 4 >> 2] = f8;
 i4 = HEAP32[i3 >> 2] | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) + Math_fround(.100000001));
 f7 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + Math_fround(.100000001));
 HEAPF32[i4 + (i6 * 36 | 0) + 8 >> 2] = f8;
 HEAPF32[i4 + (i6 * 36 | 0) + 12 >> 2] = f7;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 + (i6 * 36 | 0) + 16 >> 2] = i2;
 HEAP32[i3 + (i6 * 36 | 0) + 32 >> 2] = 0;
 __ZN13b2DynamicTree10InsertLeafEi(i5, i6);
 i2 = i5 + 28 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i5 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i5 + 36 | 0;
 i1 = i5 + 32 | 0;
 if ((i3 | 0) != (HEAP32[i4 >> 2] | 0)) {
  i5 = i3;
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + (i5 << 2) | 0;
  HEAP32[i5 >> 2] = i6;
  i5 = HEAP32[i2 >> 2] | 0;
  i5 = i5 + 1 | 0;
  HEAP32[i2 >> 2] = i5;
  return i6 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 << 1;
 i4 = __Z7b2Alloci(i3 << 3) | 0;
 HEAP32[i1 >> 2] = i4;
 _memcpy(i4 | 0, i5 | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 __Z6b2FreePv(i5);
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4 + (i5 << 2) | 0;
 HEAP32[i5 >> 2] = i6;
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = i5 + 1 | 0;
 HEAP32[i2 >> 2] = i5;
 return i6 | 0;
}

function __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 if (!(i1 & 8388608)) {
  i5 = __ZN9Scripting32GetScriptingWrapperForInstanceIDEi(i4) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 9; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 9; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i1 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i4) | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z23ConvertCacheToBuildKeysI11QuaternionfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i10 = i9 + 12 | 0;
 i11 = i9 + 16 | 0;
 i12 = i9 + 4 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1 + 12 | 0;
 i15 = i1 + 28 | 0;
 i16 = i1 + 44 | 0;
 i3 = i1 + 60 | 0;
 i1 = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 do {
  i5 = i4;
  i4 = i4 + 1 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 24 | 0, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 + (i5 * 24 | 0) >> 2] = HEAP32[i13 >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 4 >> 2] = i1 + i8;
  HEAP32[i7 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i14 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i15 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i16 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 return;
}

function __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib(i2, i10, i6, i3, i1, i4, i5, i13) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i13 = i13 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 switch (i2 | 0) {
 case 42:
 case 41:
 case 46:
 case 45:
 case 35:
 case 34:
 case 26:
 case 10:
  {
   i7 = 8;
   break;
  }
 default:
  i7 = 16;
 }
 switch (i2 | 0) {
 case 53:
 case 59:
  {
   i2 = 12;
   break;
  }
 case 55:
 case 49:
  {
   i2 = 5;
   break;
  }
 case 56:
 case 50:
  {
   i2 = 6;
   break;
  }
 case 57:
 case 51:
  {
   i2 = 8;
   break;
  }
 case 58:
 case 52:
  {
   i2 = 10;
   break;
  }
 default:
  i2 = 4;
 }
 i12 = (i3 + -1 + i2 | 0) / (i2 | 0) | 0;
 i3 = (i4 + -1 + i2 | 0) / (i2 | 0) | 0;
 i11 = (i5 + -1 + i2 | 0) / (i2 | 0) | 0;
 i8 = Math_imul((i6 + -1 + i2 | 0) / (i2 | 0) | 0, i7) | 0;
 i9 = Math_imul(i3, i7) | 0;
 do if ((i12 | 0) > 0) {
  i5 = i9 - i8 | 0;
  i6 = Math_imul(Math_imul(i7, i12) | 0, i3) | 0;
  if (i13) {
   i4 = i1;
   i2 = i10;
   i3 = 0;
   while (1) {
    _memcpy(i4 | 0, i2 | 0, i8 | 0) | 0;
    _memset(i4 + i8 | 0, 0, i5 | 0) | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i12 | 0)) break; else {
     i4 = i4 + i9 | 0;
     i2 = i2 + i8 | 0;
    }
   }
   i1 = i1 + i6 | 0;
   break;
  } else {
   i4 = i1;
   i2 = i10;
   i3 = 0;
   while (1) {
    _memcpy(i4 | 0, i2 | 0, i8 | 0) | 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i12 | 0)) break; else {
     i4 = i4 + i9 | 0;
     i2 = i2 + i8 | 0;
    }
   }
   i1 = i1 + i6 | 0;
   break;
  }
 } while (0);
 if (!i13) return;
 _memset(i1 | 0, 0, Math_imul(i11 - i12 | 0, i9) | 0) | 0;
 return;
}

function __Z18computeSweptBoundsPKN5physx12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_(i1, i4, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i5 + 24 | 0;
 i13 = i5;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i16, i1 + 32 | 0, i3);
 HEAP32[i2 >> 2] = HEAP32[i16 >> 2];
 i15 = i2 + 4 | 0;
 HEAP32[i15 >> 2] = HEAP32[i16 + 4 >> 2];
 i14 = i2 + 8 | 0;
 HEAP32[i14 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 i8 = i2 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i16 + 16 >> 2];
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i16 + 20 >> 2];
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i13, i4, i3);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i13 >> 2]);
 f9 = Math_fround(HEAPF32[i15 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 HEAPF32[i2 >> 2] = f6 < f7 ? f6 : f7;
 HEAPF32[i15 >> 2] = f9 < f10 ? f9 : f10;
 HEAPF32[i14 >> 2] = f11 < f12 ? f11 : f12;
 i4 = i2 + 12 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i13 + 20 >> 2]);
 HEAPF32[i4 >> 2] = f12 > f11 ? f12 : f11;
 HEAPF32[i8 >> 2] = f10 > f9 ? f10 : f9;
 HEAPF32[i1 >> 2] = f7 > f6 ? f7 : f6;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i9, i1, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7 + 28 | 0;
 i6 = i7;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i9 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i9 + 20 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i6, i5);
 i5 = HEAP32[i9 + 24 >> 2] | 0;
 i12 = HEAP32[i6 + 4 >> 2] | 0;
 i11 = HEAP32[i6 + 8 >> 2] | 0;
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = HEAP32[i6 + 24 >> 2] | 0;
 i9 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i8 + 12 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = i3;
 mftCall_viii(i8 | 0, i5 | 0, i9 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Unity10HingeJoint14WriteUseLimitsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((HEAP16[i5 + 4 >> 1] | 0) == 261) if (!(HEAP8[i1 + 156 >> 0] | 0)) {
  mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0, 3, 2);
  break;
 } else {
  f10 = Math_fround(HEAPF32[i1 + 100 >> 2]);
  f8 = Math_fround(-f10);
  i9 = f10 > Math_fround(177.0);
  i11 = f8 > Math_fround(177.0);
  f8 = Math_fround(Math_fround(Math_fround((i11 ? Math_fround(177.0) : f8) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
  f8 = i9 ? Math_fround(-3.08923292) : f8;
  f10 = Math_fround(HEAPF32[i1 + 96 >> 2]);
  f7 = Math_fround(-f10);
  i1 = f10 > Math_fround(177.0);
  i9 = f7 > Math_fround(177.0);
  f7 = Math_fround(Math_fround(Math_fround((i9 ? Math_fround(177.0) : f7) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
  f7 = i1 ? Math_fround(-3.08923292) : f7;
  mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0, 3, f8 != f7 | 0);
  break;
 } else mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0, i5 | 0, 1, (HEAP8[i1 + 156 >> 0] | 0) != 0 | 0); while (0);
 i11 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0, i11 | 0, i2 | 0, i3 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i2 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i3 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN5Flare8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11);
 __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10 + 44 | 0, i11);
 i1 = i10 + 48 | 0;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i13 = i11 + 24 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i5 = i10 + 32 | 0;
 i8 = i10 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 - i1 >> 5;
 HEAP32[i9 >> 2] = i6;
 i7 = i3 + 4 | 0;
 if (i7 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i12 >> 2] = i7;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN5Flare12FlareElement8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i10 + 52 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 1);
  STACKTOP = i14;
  return;
 }
}

function __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN13WebCamTexture6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 204 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = i3 + 124 | 0;
 if (!(_JS_WebCamVideo_CanPlay(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i5 = _JS_WebCamVideo_GetNativeWidth(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) | 0;
 i1 = _JS_WebCamVideo_GetNativeHeight(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) | 0;
 i2 = HEAP32[i3 + 96 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? i5 : i2;
 i5 = HEAP32[i3 + 100 >> 2] | 0;
 i5 = (i5 | 0) == 0 ? i1 : i5;
 i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i3 | 0) | 0;
 if (!i1) {
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 172 >> 2] | 0, i3 | 0, i2 | 0, i5 | 0);
  i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i3 | 0) | 0;
  if (!i1) {
   STACKTOP = i7;
   return;
  }
 }
 _JS_WebCamVideo_GrabFrame(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i1 | 0, i2 | 0, i5 | 0);
 i6 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 224 >> 2] | 0, i3 | 0) | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i4, i2, i5, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0, i6) | 0, i6, i1);
 __ZN14ImageReference10FlipImageYEv(i4);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 184 >> 2] | 0, i3 | 0);
 STACKTOP = i7;
 return;
}

function _forkpty(i8, i1, i2, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 16 | 0;
 i5 = i11 + 8 | 0;
 i4 = i11;
 i9 = i11 + 32 | 0;
 i10 = i11 + 20 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 do if ((_openpty(i8, i9, i1, i2, i3) | 0) < 0) i1 = -1; else {
  i1 = 0;
  L2 : while (1) {
   do if ((_fcntl(i1, 3, i4) | 0) < 0) {
    i2 = HEAP32[i9 >> 2] | 0;
    HEAP32[i5 >> 2] = i1;
    i2 = _fcntl(i2, 0, i5) | 0;
    if ((i2 | 0) < 0) {
     i1 = -1;
     break L2;
    }
    if ((i2 | 0) == (i1 | 0)) {
     HEAP32[i10 + (i1 << 2) >> 2] = 1;
     break;
    } else {
     _close(i2) | 0;
     break;
    }
   } while (0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 3) {
    i7 = 8;
    break;
   }
  }
  if ((i7 | 0) == 8) if ((i1 | 0) == 3) {
   i1 = _fork() | 0;
   if (!i1) {
    _close(HEAP32[i8 >> 2] | 0) | 0;
    _setsid() | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    HEAP32[i6 >> 2] = 0;
    _ioctl(i1, 21518, i6) | 0;
    _dup2(HEAP32[i9 >> 2] | 0, 0) | 0;
    _dup2(HEAP32[i9 >> 2] | 0, 1) | 0;
    _dup2(HEAP32[i9 >> 2] | 0, 2) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
    if ((i1 | 0) <= 2) {
     i1 = 0;
     break;
    }
    _close(i1) | 0;
    i1 = 0;
    break;
   }
  } else i1 = -1;
  i2 = 0;
  do {
   if (HEAP32[i10 + (i2 << 2) >> 2] | 0) _close(i2) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 3);
  _close(HEAP32[i9 >> 2] | 0) | 0;
  if ((i1 | 0) < 0) _close(HEAP32[i8 >> 2] | 0) | 0;
 } while (0);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN9GfxDevice13SaveDrawStatsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 12 | 0;
 i1 = i7 + 8 | 0;
 i4 = i7 + 4 | 0;
 i5 = i7;
 i6 = i3 + 3928 | 0;
 i8 = i3 + 3640 | 0;
 i9 = i6 + 96 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  i6 = i6 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i6 | 0) < (i9 | 0));
 HEAP32[i4 >> 2] = HEAP32[i3 + 3736 >> 2];
 HEAP32[i5 >> 2] = i3 + 3740;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_(i3 + 4024 | 0, i1, i2);
 i6 = i3 + 3908 | 0;
 i8 = i3 + 3620 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i3 + 4180 >> 2] = HEAP32[i3 + 3892 >> 2];
 i6 = i3 + 4104 | 0;
 i8 = i3 + 3816 | 0;
 i9 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  i6 = i6 + 4 | 0;
  i8 = i8 + 4 | 0;
 } while ((i6 | 0) < (i9 | 0));
 i9 = i3 + 4040 | 0;
 i8 = i3 + 3752 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i3 + 4176 >> 2] = HEAP32[i3 + 3888 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc24ConstraintProjectionTree14rankConstraintERNS0_13ConstraintSimERNS0_8BodyRankERj(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 i2 = __ZNK5physx2Sc13ConstraintSim8isBrokenEv(i7) | 0;
 i3 = HEAPU16[HEAP32[i7 + 100 >> 2] >> 1] | 0;
 i1 = i7 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
  i4 = i2 ? 0 : i3 & 4;
  i3 = i2 ? 0 : i3 & 2;
  i1 = i7 + 112 | 0;
 } else {
  i4 = i2 ? 0 : i3 & 2;
  i3 = i2 ? 0 : i3 & 4;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (!i2) if (!(HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 44 >> 0] & 1)) {
  i2 = (i3 | 0) != 0;
  i1 = (i4 | 0) != 0;
  do if (i2 & i1) {
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -268435457;
   i1 = i6 + 8 | 0;
   i2 = HEAP32[i1 >> 2] & -268435457;
   HEAP32[i1 >> 2] = i2;
  } else {
   if (i1) {
    HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -402653185;
    i1 = i6 + 8 | 0;
    i2 = HEAP32[i1 >> 2] & -402653185;
    HEAP32[i1 >> 2] = i2;
    break;
   }
   if (i2) {
    i1 = i6 + 8 | 0;
    i2 = HEAP32[i5 >> 2] & 402653184 | HEAP32[i1 >> 2] | -2147483648;
    HEAP32[i1 >> 2] = i2;
    break;
   } else {
    i2 = i6 + 8 | 0;
    i1 = i2;
    i2 = HEAP32[i2 >> 2] | 0;
    break;
   }
  } while (0);
  HEAP32[i1 >> 2] = i2 + 1;
  return;
 }
 if (!i4) i1 = 0; else {
  HEAP32[i5 >> 2] = 0;
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -402653185;
  i1 = -2147483648;
 }
 i4 = i1 | (i2 ? 1073741824 : 536870912);
 i3 = i6 + 4 | 0;
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == 0 | i4 >>> 0 > i2 >>> 0) HEAP32[i3 >> 2] = i7;
 HEAP32[i1 >> 2] = i2 | i4;
 return;
}

function __ZN5physx2Sc19ClothFabricBulkData15importExtraDataERNS_24PxDeserializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i1 = i4 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 12 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 8 >> 2] | 0) {
   i6 = i3 + 4 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = i5 + (i2 << 2);
   HEAP32[i1 >> 2] = i5;
  }
 }
 i1 = i4 + 16 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 24 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 20 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 32 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 40 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 48 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 44 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 52 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = HEAP32[i4 + 60 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 56 >> 2] | 0) {
   i5 = i3 + 4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = i6 + (i2 << 2);
   HEAP32[i1 >> 2] = i6;
  }
 }
 i1 = i4 + 64 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i4 + 72 >> 2] | 0;
 if (!(i2 & 2147483647 | HEAP32[i4 + 68 >> 2])) return;
 i5 = i3 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + (i2 << 2);
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i10 = i8 + 8 | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i3 >>> 0 > i2 >>> 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i7, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8);
   STACKTOP = i11;
   return;
  } else {
   i7 = i3;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i10 + 4 >> 2] = i8;
   HEAP32[i9 >> 2] = i1;
   STACKTOP = i11;
   return;
  }
 } else {
  if (i5) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  } else {
   HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i9 >> 2] = i3;
  }
  i1 = i3 + 8 | 0;
  if (i1 >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i9, i10, 8); else {
   i5 = i3;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i10 + 4 >> 2] = i6;
   HEAP32[i9 >> 2] = i1;
  }
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i8, i7);
  STACKTOP = i11;
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 4 | 0;
 i3 = i11;
 i7 = i6 + 4 | 0;
 i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i10 = i2 + 16 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i1 = i5 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i10 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i3, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = i3;
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = i4 + 4 | 0;
  if (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i4 >> 2] = i3;
   HEAP32[i10 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  i5 = i2 + (i7 << 2) | 0;
  if (i7 | 0) do {
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = i3 + 4 | 0;
   if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i10 >> 2] = i4;
   } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i5 | 0));
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i11;
 return;
}

function __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i7 + 56 | 0;
 i8 = i7 + 68 | 0;
 i2 = i1 - i6 | 0;
 i3 = i2 >> 4;
 HEAP32[i8 >> 2] = i3;
 i4 = i7 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i2, 4, i7 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i7 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, HEAP32[i8 >> 2] << 4 | 0) | 0;
 i5 = i7 + 56 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 L8 : do if (i3 | 0) {
  i1 = i2;
  i4 = i2 + (i3 << 4) | 0;
  do {
   while (1) {
    if ((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) == 2139095040) break;
    if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
    i1 = i1 + 16 | 0;
    if ((i1 | 0) == (i4 | 0)) break L8;
   }
   i4 = i1 + 16 | 0;
   _memmove(i1 | 0, i4 | 0, i2 + (i3 << 4) - i4 | 0) | 0;
   i3 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
   HEAP32[i8 >> 2] = i3;
   i2 = HEAP32[i5 >> 2] | 0;
   i4 = i2 + (i3 << 4) | 0;
  } while ((i1 | 0) != (i4 | 0));
 } while (0);
 HEAPF32[i7 + 4 >> 2] = Math_fround(inf);
 HEAP32[i7 >> 2] = 0;
 HEAPF32[i7 + 32 >> 2] = Math_fround(inf);
 HEAP32[i7 + 28 >> 2] = 0;
 return;
}

function __ZN15SerializeTraitsI22OffsetPtrArrayTransferIKN4math7_float3EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i7 = i2 + 4 | 0;
 i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i8 = i1 + 24 | 0;
 if (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i3, 4);
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN12MeshCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(132, i2, 16, gb + 1048932 | 0, 0, gb + 780844 | 0, 23) | 0;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 112784 + 8;
 i9 = i4 + 64 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = i4;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i4;
 i9 = i4 + 96 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = i9;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP8[i4 + 120 >> 0] = 1;
 HEAPF32[i4 + 128 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 61 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __Z8SkinMeshR12SkinMeshInfo(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1161580 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161580 | 0, i1);
  i1 = gb + 1161580 | 0;
 } else i1 = 0;
 i3 = HEAP16[i4 + 56 >> 1] | 0;
 L4 : do if (!((i3 & 255) << 24 >> 24)) switch (HEAP32[i4 + 20 >> 2] | 0) {
 case 1:
  {
   __Z11SkinGenericILi1ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 case 2:
  {
   __Z11SkinGenericILi2ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 case 4:
  {
   __Z11SkinGenericILi4ELb0ELb0EEvR12SkinMeshInfo(i4);
   break L4;
  }
 default:
  break L4;
 } else {
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  if ((i3 & 65535) < 256) switch (i2 | 0) {
  case 1:
   {
    __Z11SkinGenericILi1ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 2:
   {
    __Z11SkinGenericILi2ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 4:
   {
    __Z11SkinGenericILi4ELb1ELb0EEvR12SkinMeshInfo(i4);
    break L4;
   }
  default:
   break L4;
  } else switch (i2 | 0) {
  case 1:
   {
    __Z11SkinGenericILi1ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 2:
   {
    __Z11SkinGenericILi2ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  case 4:
   {
    __Z11SkinGenericILi4ELb1ELb1EEvR12SkinMeshInfo(i4);
    break L4;
   }
  default:
   break L4;
  }
 } while (0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 2) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i6, i5) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 16 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[i3 + 4 >> 2] | 0, gb + 1033949 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_(i7, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!(HEAP8[i4 + 128 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = i3 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i6 + 4 | 0;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i5 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i7) >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __Z22GetComponentWithScriptR10GameObjectiP10MonoScript(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((i1 | 0) != 114) {
  i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
  if (!i1) {
   i9 = 0;
   return i9 | 0;
  }
  i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, i1) | 0;
  return i9 | 0;
 }
 if (!i2) {
  i9 = 0;
  return i9 | 0;
 }
 i8 = __ZN10MonoScript8GetClassEv(i2) | 0;
 if (!i8) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = HEAP32[i3 + 40 >> 2] | 0;
 if ((i7 | 0) <= 0) {
  i9 = 0;
  return i9 | 0;
 }
 i6 = i3 + 28 | 0;
 i5 = 0;
 while (1) {
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[gb + 1106156 + 4 + (HEAP32[i4 + (i5 << 3) >> 2] << 2) >> 2] | 0;
  if (!i1) {
   i1 = -1;
   i2 = HEAP32[gb + 1110260 >> 2] | 0;
   i9 = 12;
  } else {
   i1 = HEAP32[i1 + 16 >> 2] | 0;
   i2 = HEAP32[gb + 1110260 >> 2] | 0;
   if ((i1 | 0) > 99999) {
    i3 = (HEAP32[i2 + 24 >> 2] | 0) + (i1 + -1e5 << 3) | 0;
    i1 = HEAP32[i2 + 4 >> 2] | 0;
   } else i9 = 12;
  }
  if ((i9 | 0) == 12) {
   i9 = 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i2 + (i1 << 3) | 0;
   i1 = i2;
  }
  if (((HEAP32[i3 >> 2] | 0) - (HEAP32[i1 + 912 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 916 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i4 + (i5 << 3) + 4 >> 2] | 0;
   i2 = HEAP32[i1 + 20 >> 2] | 0;
   if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i2) | 0, i8) | 0) {
    i9 = 17;
    break;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (i7 | 0)) {
   i1 = 0;
   i9 = 17;
   break;
  }
 }
 if ((i9 | 0) == 17) return i1 | 0;
 return 0;
}

function __ZN7mecanim9animation18CreateAvatarOutputEPKNS0_14AvatarConstantEbbRNS_6memory9AllocatorE(i6, i2, i1, i7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, 32, 4) | 0;
 i5 = i4 + 8 | 0;
 i3 = i4 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP8[i4 + 28 >> 0] = 0;
 if (i2) {
  if (HEAP32[i6 + 20 >> 2] | 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + i6 | 0;
    if (HEAP32[i1 >> 2] | 0) HEAP32[i5 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i1, i7) | 0;
   }
  }
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i2 = i6;
   i1 = i1 + i2 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    HEAP32[i5 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i1, i7) | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i3 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math7affineXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i5 | 0) == 0 ? 0 : i5 + i2 | 0, i7) | 0;
   }
  }
 }
 if (!(HEAP32[i6 + 20 >> 2] | 0)) return i4 | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, 888, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i6);
 HEAP32[i4 + 20 >> 2] = i6;
 i7 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, 888, 4) | 0;
 __ZN7mecanim5human9HumanPoseC2Ev(i7);
 HEAP32[i4 + 24 >> 2] = i7;
 return i4 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN22CrashReportingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i7 = i9 + 12 | 0;
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i9 + 16 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i11 = i10 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i12 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (i8 | 0) do {
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 i1 = i9 + 8 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i13;
  return;
 }
}

function __ZN14SharedMeshDataD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 58104 + 8;
 i2 = i5 + 144 | 0;
 i1 = i5 + 204 | 0;
 if ((HEAP32[i5 + 220 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 208 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 184 | 0;
 if ((HEAP32[i5 + 200 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 188 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 164 | 0;
 if ((HEAP32[i5 + 180 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 168 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i5 + 160 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5 + 148 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 128 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 132 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -52 - i2 | 0) >>> 0) / 52 | 0) * 52 | 0);
  i4 = HEAP32[i5 + 140 >> 2] | 0;
  HEAP32[i6 >> 2] = 16;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 112 >> 2] | 0;
 if (!i1) {
  i6 = i5 + 8 | 0;
  __ZN10VertexDataD2Ev(i6);
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 116 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
 i4 = HEAP32[i5 + 124 >> 2] | 0;
 HEAP32[i6 >> 2] = 14;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 i6 = i5 + 8 | 0;
 __ZN10VertexDataD2Ev(i6);
 STACKTOP = i7;
 return;
}

function __Z51Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointNonAllocRK13Vector2fIcallP11Il2CppArrayiff(i1, i5, i2, f3, f4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 8 | 0;
 i13 = i9;
 i8 = i9 + 16 | 0;
 i12 = gb + 64016 | 0;
 i7 = HEAP32[i12 + 4 >> 2] | 0;
 i6 = i13;
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i13);
 i13 = i10;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i7;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i11 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i1 = __ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE(i11, i10, i2, f3, f4, 0, i8) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 i2 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 if (i2 | 0) {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return i2 | 0;
}

function __Z40CullingGroup_Get_Custom_PropTargetCameraP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i7 + 8 | 0;
 i4 = i7 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = i1;
 i6 = __ZN9Scripting19ScriptingWrapperForEP6Object(i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9WWWCached14GetAssetBundleEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (i1 | 0) {
  i6 = __Z18ExtractAssetBundleR3WWW(i1) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i2 + 96 >> 0] = 1;
 i5 = i1 + 84 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 521;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN14AvatarPlayback9PlayFrameEfRPN7mecanim9animation12AvatarMemoryERPNS1_16ControllerMemoryE(i9, f8, i10, i11) {
 i9 = i9 | 0;
 f8 = Math_fround(f8);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0;
 i2 = HEAP32[i9 + 24 >> 2] | 0;
 i5 = HEAP32[i9 + 20 >> 2] | 0;
 if ((i5 | 0) == -1) {
  f8 = Math_fround(0.0);
  return Math_fround(f8);
 }
 i7 = HEAP32[i9 + 16 >> 2] | 0;
 i6 = i2 + 1 | 0;
 if ((i7 | 0) > 0) {
  i6 = (i6 | 0) % (i7 | 0) | 0;
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i5;
  while (1) {
   i12 = Math_fround(HEAPF32[i1 + (i5 * 12 | 0) + 8 >> 2]) > f8;
   i2 = i12 ? i3 : i2;
   i3 = (i5 + 1 | 0) % (i7 | 0) | 0;
   if (i12 | (i3 | 0) == (i6 | 0)) {
    i5 = i2;
    break;
   } else {
    i12 = i5;
    i5 = i3;
    i3 = i12;
   }
  }
 } else {
  i4 = i9 + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i5;
  while (1) {
   i12 = Math_fround(HEAPF32[i1 + (i5 * 12 | 0) + 8 >> 2]) > f8;
   i2 = i12 ? i3 : i2;
   i3 = i5 + 1 | 0;
   if (i12 | (i3 | 0) == (i6 | 0)) {
    i5 = i2;
    break;
   } else {
    i12 = i5;
    i5 = i3;
    i3 = i12;
   }
  }
 }
 HEAP32[i9 + 28 >> 2] = i5;
 HEAP32[i10 >> 2] = HEAP32[i1 + (i5 * 12 | 0) >> 2];
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 * 12 | 0) + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) {
  i2 = i1 + 4 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
  i1 = 0;
  do {
   i12 = i2 + (i1 << 2) | 0;
   HEAP8[i12 + (HEAP32[i12 >> 2] | 0) + 86 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 f8 = Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + (i5 * 12 | 0) + 8 >> 2]);
 return Math_fround(f8);
}

function __Z23ConvertCacheToBuildKeysI8Vector3fEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i10 = i9 + 12 | 0;
 i11 = i9 + 16 | 0;
 i12 = i9 + 4 | 0;
 i13 = i1 + 4 | 0;
 i14 = i1 + 12 | 0;
 i15 = i1 + 24 | 0;
 i16 = i1 + 36 | 0;
 i3 = i1 + 48 | 0;
 i1 = 0;
 i4 = HEAP32[i10 >> 2] | 0;
 do {
  i5 = i4;
  i4 = i4 + 1 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 * 24 | 0, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 24 | 0) | 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i9 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i4;
  i7 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 + (i5 * 24 | 0) >> 2] = HEAP32[i13 >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 4 >> 2] = i1 + i8;
  HEAP32[i7 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i14 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i15 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i16 + (i1 << 2) >> 2];
  HEAP32[i7 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 3);
 return;
}

function __ZNSt3__218__insertion_sort_3IRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i2 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i5) {
  i3 = HEAP32[i6 >> 2] | 0;
  if (i1) {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i3;
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0) {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i5;
  }
 } else if (i1) {
  i3 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0) {
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i5;
  }
 } while (0);
 i1 = i6 + 12 | 0;
 if ((i1 | 0) == (i7 | 0)) return;
 while (1) {
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i5 = i4;
   i3 = i1;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    if ((i2 | 0) == (i6 | 0)) break;
    i3 = i2 + -4 | 0;
    if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
     i9 = i2;
     i2 = i3;
     i3 = i9;
    } else break;
   }
   HEAP32[i2 >> 2] = i4;
  }
  i2 = i1 + 4 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i9 = i1;
   i1 = i2;
   i2 = i9;
  }
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i2 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i1 = mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 do if (i5) {
  i3 = HEAP32[i6 >> 2] | 0;
  if (i1) {
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i3;
   break;
  }
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0) {
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i5;
  }
 } else if (i1) {
  i3 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = i3;
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0) | 0) {
   i5 = HEAP32[i6 >> 2] | 0;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i4 >> 2] = i5;
  }
 } while (0);
 i1 = i6 + 12 | 0;
 if ((i1 | 0) == (i7 | 0)) return;
 while (1) {
  if (mftCall_iii(HEAP32[i8 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i5 = i4;
   i3 = i1;
   while (1) {
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    if ((i2 | 0) == (i6 | 0)) break;
    i3 = i2 + -4 | 0;
    if (mftCall_iii(HEAP32[i8 >> 2] | 0, i5 | 0, HEAP32[i3 >> 2] | 0) | 0) {
     i9 = i2;
     i2 = i3;
     i3 = i9;
    } else break;
   }
   HEAP32[i2 >> 2] = i4;
  }
  i2 = i1 + 4 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i9 = i1;
   i1 = i2;
   i2 = i9;
  }
 }
 return;
}

function __ZNK5physx2Sc15ArticulationSim22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_(i2, i1, i9, i6, i7, i8, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 32 | 0;
 i5 = i12;
 i3 = __ZNK5physx2Sc8BodyCore6getSimEv(i1) | 0;
 i4 = HEAP32[i2 + 28 >> 2] | 0;
 L1 : do if (!i4) i1 = -2147483648; else {
  i2 = HEAP32[i2 + 24 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break L1;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i1 = -2147483648;
    break;
   }
  }
 } while (0);
 i13 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i13;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 16 >> 2] = i3;
 HEAP32[i5 + 20 >> 2] = i4;
 HEAP32[i5 + 24 >> 2] = i10;
 HEAPF32[i5 + 28 >> 2] = Math_fround(0.0);
 __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(i7, i1, i5, i11);
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i10 = HEAP32[i11 + 8 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i9 + 8 >> 2] = i10;
 i9 = HEAP32[i11 + 20 >> 2] | 0;
 i10 = HEAP32[i11 + 24 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Unity12PhysicsQuery21OverlapSphereInternalERK8Vector3ffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(i1, i6, f7, i8, i9, i10) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0, f13 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 60 | 0;
 i2 = i5 + 40 | 0;
 i3 = i5 + 32 | 0;
 i4 = i5;
 HEAP32[i1 >> 2] = gb + 114012 + 8;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i8;
 switch (i9 | 0) {
 case 0:
  {
   HEAP8[i1 + 16 >> 0] = HEAP8[(__Z21GetManagerFromContexti(9) | 0) + 56 >> 0] | 0;
   break;
  }
 case 1:
  {
   HEAP8[i1 + 16 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i1 + 16 >> 0] = 1;
   break;
  }
 default:
  {}
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP16[i2 + 16 >> 1] = 7;
 HEAP8[i2 + 18 >> 0] = 0;
 f13 = Math_fround(HEAPF32[gb + 1452812 >> 2]);
 i9 = HEAP32[gb + 1457404 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 356 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAPF32[i3 + 4 >> 2] = f13 < f7 ? f13 : f7;
 i12 = HEAP32[i6 >> 2] | 0;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 16 >> 2] = i12;
 HEAP32[i4 + 20 >> 2] = i11;
 HEAP32[i4 + 24 >> 2] = i6;
 mftCall_iiiiiii(i8 | 0, i9 | 0, i3 | 0, i4 | 0, i10 | 0, i2 | 0, i1 | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN15ResourceManager8TransferI17RemapPPtrTransferEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i8, i9);
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 i4 = i8 + 48 | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i9 + 16 | 0;
  i6 = i9 + 36 | 0;
  i7 = i9 + 40 | 0;
  i2 = i1;
  while (1) {
   i3 = i2 + 32 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i7 >> 0] | 0) HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 i6 = HEAP32[i8 + 32 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) return;
 i7 = i9 + 16 | 0;
 i8 = i9 + 36 | 0;
 i5 = i9 + 40 | 0;
 i4 = i1;
 do {
  i1 = HEAP32[i7 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i1;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = HEAP32[i4 + 8 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i4 = i4 + 20 | 0;
 } while ((i4 | 0) != (i6 | 0));
 return;
}

function __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i7, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i7, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i5 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function _tt_cmap12_validate(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = i1 + 16 | 0;
 i3 = i10 + 8 | 0;
 if (i7 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i10, 8);
 i2 = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
 i11 = (HEAPU8[i1 + 13 >> 0] | 0) << 16 | (HEAPU8[i1 + 12 >> 0] | 0) << 24 | (HEAPU8[i1 + 14 >> 0] | 0) << 8 | (HEAPU8[i1 + 15 >> 0] | 0);
 if (i2 >>> 0 < 16 ? 1 : i2 >>> 0 > ((HEAP32[i3 >> 2] | 0) - i1 | 0) >>> 0) i4 = 5; else if ((((i2 + -16 | 0) >>> 0) / 12 | 0) >>> 0 < i11 >>> 0) i4 = 5;
 if ((i4 | 0) == 5) _UNITY_ft_validator_error(i10, 8);
 if (!i11) return 0;
 i8 = i10 + 12 | 0;
 i9 = i10 + 20 | 0;
 i5 = 0;
 i6 = 0;
 i2 = i7;
 do {
  i4 = (HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0);
  i1 = i5;
  i5 = (HEAPU8[i2 + 5 >> 0] | 0) << 16 | (HEAPU8[i2 + 4 >> 0] | 0) << 24 | (HEAPU8[i2 + 6 >> 0] | 0) << 8 | (HEAPU8[i2 + 7 >> 0] | 0);
  i3 = (HEAPU8[i2 + 9 >> 0] | 0) << 16 | (HEAPU8[i2 + 8 >> 0] | 0) << 24 | (HEAPU8[i2 + 10 >> 0] | 0) << 8 | (HEAPU8[i2 + 11 >> 0] | 0);
  i2 = i2 + 12 | 0;
  if (i5 >>> 0 < i4 >>> 0) _UNITY_ft_validator_error(i10, 8);
  if (!((i6 | 0) == 0 | i4 >>> 0 > i1 >>> 0)) _UNITY_ft_validator_error(i10, 8);
  if (HEAP32[i8 >> 2] | 0) {
   i7 = i5 - i4 | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   if (!(i4 >>> 0 >= i7 >>> 0 & i3 >>> 0 < (i4 - i7 | 0) >>> 0)) _UNITY_ft_validator_error(i10, 16);
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i11 | 0));
 return 0;
}

function __ZN5physx2Sq10AABBPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj(i3, i12, i7, i11, i8) {
 i3 = i3 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 4 | 0;
 i10 = i13;
 HEAP8[i3 + 7809 >> 0] = 1;
 i2 = i3 + 7760 | 0;
 L1 : do if (!i8) i1 = 0; else {
  i1 = 0;
  do {
   i6 = __ZN5physx2Sq11PruningPool9addObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE(i2, i7 + (i1 * 24 | 0) | 0, i11 + (i1 << 3) | 0) | 0;
   HEAP32[i12 + (i1 << 2) >> 2] = i6;
   if ((i6 | 0) == -1) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i8 >>> 0);
 } while (0);
 if (!(HEAP8[i3 + 7808 >> 0] | 0)) {
  i12 = (i1 | 0) == (i8 | 0);
  STACKTOP = i13;
  return i12 | 0;
 }
 if (!(HEAP32[i3 + 4 >> 2] | 0)) {
  i12 = (i1 | 0) == (i8 | 0);
  STACKTOP = i13;
  return i12 | 0;
 }
 HEAP8[i3 + 7810 >> 0] = 1;
 if (!i1) {
  i12 = (i1 | 0) == (i8 | 0);
  STACKTOP = i13;
  return i12 | 0;
 }
 i6 = i3 + 96 | 0;
 i2 = i3 + 144 | 0;
 i5 = 0;
 do {
  i3 = HEAP32[i12 + (i5 << 2) >> 2] | 0;
  HEAP32[i10 >> 2] = i3;
  i4 = __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE6createERKjRb(HEAP32[i6 >> 2] | 0, i10, i9) | 0;
  if (!(HEAP8[i9 >> 0] | 0)) HEAP32[i4 >> 2] = i3;
  __ZN5physx2Sq16BucketPrunerCore9addObjectERKNS0_13PrunerPayloadERKNS_9PxBounds3E(i2, i11 + (i5 << 3) | 0, i7 + (i5 * 24 | 0) | 0) | 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i1 | 0));
 i12 = (i1 | 0) == (i8 | 0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_11PxMeshScaleEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN21IntermediateRenderers5ClearEj(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i6 >>> 0) {
  i1 = i6;
  do {
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0;
   if (i3 | 0) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 HEAP32[i4 >> 2] = i6;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i6 * 24 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 24 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i5 >> 2] = i3;
  break;
 } while (0);
 i1 = i5 + 20 | 0;
 i2 = i5 + 32 | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i5 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i6 >>> 0) return;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 * 24 | 0, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 24 | 0, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = i5;
  return;
 }
}

function __ZN17PersistentManager38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 if ((HEAP16[gb + 1165896 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165896 | 0, i5);
  i7 = gb + 1165896 | 0;
 } else i7 = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i3 | 0) == -1) i4 = 7; else {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if ((i1 | 0) > (i5 | 0)) i4 = 7; else if ((HEAP32[i2 + 32 >> 2] | 0) < (i5 | 0)) i4 = 7; else {
   HEAP32[i6 >> 2] = i3;
   i5 = (i5 - i1 | 0) / 2 | 0;
   i1 = i6 + 8 | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 4 >> 2] = ((i5 | 0) < 0) << 31 >> 31;
   i1 = 1;
  }
 }
 do if ((i4 | 0) == 7) {
  i4 = i2 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) {
   i1 = i4;
   L11 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L11; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i5 | 0)) {
    i1 = i1 + 24 | 0;
    HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    i1 = 1;
    break;
   }
  }
  HEAP32[i6 >> 2] = -1;
  i1 = i6 + 8 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = 0;
 } while (0);
 if (!i7) return i1 | 0;
 __Z12profiler_endP19ProfilerInformation(i7);
 return i1 | 0;
}

function __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __Z45OffMeshLinkData_CUSTOM_GetOffMeshLinkInternalP12Il2CppObjecti(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 do if (i4 | 0) {
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i5 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i7 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
    i2 = HEAP32[i7 + 28 >> 2] | 0;
    i3 = HEAP32[i7 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 169336 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 169336 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z42Terrain_CUSTOM_INTERNAL_set_legacySpecularP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 + 1 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  HEAP8[i3 + 2 >> 0] = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i2 = f6 < Math_fround(0.0);
  f6 = i2 ? Math_fround(0.0) : f6;
  i2 = f6 > Math_fround(1.0);
  HEAP8[i3 + 3 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  __ZN7Terrain17SetLegacySpecularERK11ColorRGBA32(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z15FindOrAddByNameI15ComputeShaderCBERT_RNSt3__26vectorIS1_NS3_9allocatorIS1_EEEERKS1_(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = i3 + 4 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i4 = i5 - i7 | 0;
 i6 = (i4 | 0) / 20 | 0;
 i9 = i5;
 L1 : do if (i4 | 0) {
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = i7 + (i2 * 20 | 0) | 0;
   i2 = i2 + 1 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
   if (i2 >>> 0 >= i6 >>> 0) break L1;
  }
  return i1 | 0;
 } while (0);
 if ((i9 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i8);
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i7 = i8;
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i9 + 8 | 0;
  i4 = i8 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  i7 = i9 + 12 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i9 + 16 >> 2] = 0;
  i5 = i8 + 12 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i2 = (i1 | 0) / 24 | 0;
  if (i1 | 0) {
   if (i2 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i6 = __Znwj(i1) | 0;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i3 >> 2] = i6;
   HEAP32[i9 + 16 >> 2] = i6 + (i2 * 24 | 0);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
   if ((i1 | 0) > 0) {
    _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
    HEAP32[i7 >> 2] = i6 + (((i1 >>> 0) / 24 | 0) * 24 | 0);
   }
  }
  i1 = (HEAP32[i10 >> 2] | 0) + 20 | 0;
  HEAP32[i10 >> 2] = i1;
 }
 i10 = i1 + -20 | 0;
 return i10 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i7 + 56 >> 2] | 0;
  if (i5) {
   i6 = i8 + 4 | 0;
   i3 = 0;
   while (1) {
    i2 = i1 + (i3 * 20 | 0) | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i1 + (i3 * 20 | 0) + 12 >> 2] | 0;
     HEAP32[i8 >> 2] = 54;
     HEAP32[i6 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
    }
    i1 = i3 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break;
    i3 = i1;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i6 = HEAP32[i7 + 76 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 }
 i1 = i7 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 44 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i8 >> 2] = 54;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i10;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i2 = i8 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i8 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags(i4, i8, 0);
 i7 = i1 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) i1 = HEAP32[i1 >> 2] | 0; else {
  i10 = i3 + 28 | 0;
  i11 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i10 >> 2] | 0) | 0;
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i10 >> 2] | 0, i11, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  i1 = i11;
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i6);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 3) + 1 | 0;
 if ((i8 | 0) < -8) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 2;
 i6 = i7 >> 3 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 3 << 3) | 0;
 i3 = i5;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 8;
 HEAP32[i8 >> 2] = i7 + (i6 << 3);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 4 | 0;
 __ZN26AnimatorControllerPlayable11ClearMemoryEv(i3);
 i5 = i3 + 84 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  __ZN26AnimatorControllerPlayable13GenerateGraphEv(i3);
  STACKTOP = i7;
  return;
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
 i2 = i3 + 92 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
  __Z6FormatPKcz(i4, gb + 899730 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 899812 | 0, 373, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZN26AnimatorControllerPlayable13GenerateGraphEv(i3);
  STACKTOP = i7;
  return;
 } else {
  i6 = i3 + 60 | 0;
  HEAP32[i3 + 96 >> 2] = __ZN7mecanim9animation21CreateControllerInputEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(i1, i6) | 0;
  HEAP32[i3 + 100 >> 2] = __ZN7mecanim9animation22CreateControllerMemoryEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(HEAP32[i2 >> 2] | 0, i6) | 0;
  HEAP32[i3 + 104 >> 2] = __ZN7mecanim9animation25CreateControllerWorkspaceEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(HEAP32[i2 >> 2] | 0, i6) | 0;
  HEAP32[i3 + 108 >> 2] = 0;
  __ZN26AnimatorControllerPlayable13GenerateGraphEv(i3);
  STACKTOP = i7;
  return;
 }
}

function __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 32 | 0;
 i2 = i8 + 16 | 0;
 i3 = i8;
 i4 = i8 + 8 | 0;
 __ZN6Object8TransferI14SafeBinaryReadEEvRT_(i1, i7);
 i5 = i1 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) {
  HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i7, i2, 1);
  i4 = i2 + 11 | 0;
  i1 = (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  i11 = gb + 63648 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i3;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i5, i1, i6);
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   i11 = HEAP32[i2 >> 2] | 0;
   i10 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = 1;
   HEAP32[i6 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
  }
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __Z36WebCamTexture_Get_Custom_PropDevicesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = 0;
 i7 = i5 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb(i5, 1);
 __Z26GetRegisteredWebCamDevicesRNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEEE(i5);
 i6 = HEAP32[(__Z24GetAudioScriptingClassesv() | 0) + 24 >> 2] | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(i6, 8, (HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 3) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = i3;
 if ((i1 | 0) != (i3 | 0)) {
  i3 = 0;
  i1 = i2;
  while (1) {
   i9 = i1 + (i3 << 3) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i9 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, i3, 8) | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i9;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i9 = HEAP32[i5 >> 2] | 0;
   i2 = i9;
   if (i3 >>> 0 >= i1 - i9 >> 3 >>> 0) break; else i1 = i2;
  }
 }
 if (!i2) {
  STACKTOP = i8;
  return i6 | 0;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i7 >> 2] = i1 + (~((i1 + -8 - i2 | 0) >>> 3) << 3);
 i9 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 56;
 HEAP32[i4 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 STACKTOP = i8;
 return i6 | 0;
}

function __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 40 | 0;
 i10 = i12 + 32 | 0;
 i9 = i12 + 24 | 0;
 i8 = i12 + 16 | 0;
 i3 = i12 + 8 | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403584 | 0, i12);
 i6 = i1 >>> 0 > 8 ? 8 : i1;
 if (!i2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403663 | 0, i3);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403663 | 0, i3);
 i5 = HEAP8[i1 + 31 >> 0] | 0;
 if (!i7) i4 = 0; else {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  if (!i1) i4 = 0; else i4 = HEAPU8[i1 + 31 >> 0] | 0;
 }
 i2 = 0;
 while (1) {
  if (!(i7 + (i2 << 3) | 0)) {
   i1 = 14;
   break;
  }
  i1 = HEAP32[i7 + (i2 << 3) + 4 >> 2] | 0;
  if (!i1) {
   i1 = 14;
   break;
  }
  i3 = HEAP8[i1 + 31 >> 0] | 0;
  if ((i3 & 255 | 0) != (i4 | 0)) {
   i1 = 16;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i3 << 24 >> 24 != i5 << 24 >> 24) {
   i1 = 18;
   break;
  }
  if (i2 >>> 0 >= i6 >>> 0) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 11) {
  STACKTOP = i12;
  return;
 } else if ((i1 | 0) == 14) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403724 | 0, i8); else if ((i1 | 0) == 16) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403785 | 0, i9); else if ((i1 | 0) == 18) if (!(i3 << 24 >> 24)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404012 | 0, i11); else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 403902 | 0, i10);
}

function _UNITY_FT_Face_GetCharVariantIndex(i2, i8, i9) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 if (!i2) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i10 = i2 + 92 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1970170211) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = HEAP32[i2 + 36 >> 2] | 0;
 i5 = i1 + (i6 << 2) | 0;
 if ((i6 | 0) <= 0) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i6 = i7 + 4 | 0;
 L16 : while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  do if ((HEAP32[i4 + 8 >> 2] | 0) == 327680) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i2 = HEAP32[i2 + 96 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
     if (i2 | 0) if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i4 | 0, i7 | 0) | 0)) if ((HEAP32[i6 >> 2] | 0) == 14) break L16; else break;
    }
   }
  } while (0);
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i11 = 17;
   break;
  }
 }
 if ((i11 | 0) == 17) {
  STACKTOP = i12;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i11 = mftCall_iiiii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i10 >> 2] | 0, i8 | 0, i9 | 0) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function _unity_z_inflateInit2_(i8, i7, i1, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i8 = -6;
  return i8 | 0;
 }
 if ((i2 | 0) != 56 | (HEAP8[i1 >> 0] | 0) != 49) {
  i8 = -6;
  return i8 | 0;
 }
 if (!i8) {
  i8 = -2;
  return i8 | 0;
 }
 i6 = i8 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = fb + 334;
  HEAP32[i8 + 40 >> 2] = 0;
  i2 = fb + 334 | 0;
 }
 i4 = i8 + 36 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = fb + 2370;
 i5 = i8 + 40 | 0;
 i2 = mftCall_iiii(i2 | 0, HEAP32[i5 >> 2] | 0, 1, 9520) | 0;
 if (!i2) {
  i8 = -4;
  return i8 | 0;
 }
 i3 = i8 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((i7 | 0) < 0) {
  HEAP32[i2 + 8 >> 2] = 0;
  i1 = 0 - i7 | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = (i7 >> 4) + 1;
  i1 = (i7 | 0) < 48 ? i7 & 15 : i7;
 }
 if ((i1 & -8 | 0) == 8) {
  HEAP32[i2 + 36 >> 2] = i1;
  HEAP32[i2 + 52 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i8 + 48 >> 2] = 1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 32768;
  HEAP32[i2 + 32 >> 2] = 0;
  HEAP32[i2 + 40 >> 2] = 0;
  HEAP32[i2 + 44 >> 2] = 0;
  HEAP32[i2 + 48 >> 2] = 0;
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i2 + 60 >> 2] = 0;
  i8 = i2 + 1328 | 0;
  HEAP32[i2 + 108 >> 2] = i8;
  HEAP32[i2 + 80 >> 2] = i8;
  HEAP32[i2 + 76 >> 2] = i8;
  i8 = 0;
  return i8 | 0;
 } else {
  mftCall_vii(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2 | 0);
  HEAP32[i3 >> 2] = 0;
  i8 = -2;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI23UnityVRDeviceDefinition13stl_allocatorIS1_L18MemLabelIdentifier87ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = ((i8 | 0) / 668 | 0) + 1 | 0;
 if ((i8 | 0) < -668) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 668 | 0;
 i6 = i7 << 1;
 i6 = i7 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 87;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 * 668 | 0, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (((i2 - i1 | 0) / 668 | 0) * 668 | 0) | 0;
 _memcpy(i4 | 0, i5 | 0, 668) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (((i2 | 0) / -668 | 0) * 668 | 0) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 668;
 HEAP32[i8 >> 2] = i7 + (i6 * 668 | 0);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 87;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNK2UI6Canvas13GetRenderModeEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i5 = i8;
 i1 = HEAP32[i2 + 344 >> 2] | 0;
 if (i1 | 0) {
  i7 = __ZNK2UI6Canvas13GetRenderModeEv(i1) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i6 = i2 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != 1) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = i2 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i5);
   i2 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 10; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i7 = 12;
 }
 if ((i7 | 0) == 10) i7 = 12;
 if ((i7 | 0) == 12) if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN7Terrain16SetLightmapIndexEi12LightmapType(i7, i3, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i4 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 i8 = i7 + 152 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i6 + (i2 << 1) | 0;
 do if ((i3 | 0) == -1) HEAP16[i2 >> 1] = -1; else if (i3 >>> 0 > 65535) {
  HEAP16[i2 >> 1] = -1;
  HEAP32[i5 >> 2] = 65535;
  __Z6FormatPKcz(i4, gb + 936733 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 936769 | 0, 104, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i8 >> 2] | 0;
  break;
 } else {
  HEAP16[i2 >> 1] = i3;
  break;
 } while (0);
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i2;
 i4 = i7 + 228 | 0;
 i3 = i7 + 240 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = i2;
 HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i8 >> 2];
 i1 = i1 + 20 | 0;
 if ((i1 | 0) == ((HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i8 >> 2];
  HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i8 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer11PvdTriangleEEE(i1, i15) {
 i1 = i1 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = HEAP32[i15 + 4 >> 2] | 0;
 i12 = HEAP32[i15 >> 2] | 0;
 i13 = i11 - i12 | 0;
 i14 = (i13 | 0) / 48 | 0;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i14;
 HEAP8[i10 + 1 >> 0] = i14 >> 8;
 HEAP8[i10 + 2 >> 0] = i14 >> 16;
 HEAP8[i10 + 3 >> 0] = i14 >> 24;
 if ((i11 | 0) == (i12 | 0)) return;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i15 >> 2] | 0, i13);
 return;
}

function __Z28AnimationPlayableEvaluateEndP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i5 = HEAP8[i1 + 33 >> 0] | 0;
 i6 = HEAP8[i1 + 34 >> 0] | 0;
 __ZN7mecanim15InvertValueMaskEPNS_14ValueArrayMaskE(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0);
 i7 = HEAP32[i3 >> 2] | 0;
 __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0);
 if (!((i6 | i5) << 24 >> 24)) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 if (HEAP8[i7 + 18 >> 0] | 0) return;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i1 + 4 | 0;
 if (f4 != Math_fround(0.0)) {
  f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) / f4);
  i6 = i1 + 8 | 0;
  f8 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) / f4);
  i5 = i1 + 12 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) / f4);
  HEAPF32[i2 >> 2] = f10;
  HEAPF32[i6 >> 2] = f8;
  HEAPF32[i5 >> 2] = f9;
  i5 = i1 + 16 | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) / f4);
  i6 = i1 + 20 | 0;
  f8 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) / f4);
  i7 = i1 + 24 | 0;
  f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) / f4);
  HEAPF32[i5 >> 2] = f9;
  HEAPF32[i6 >> 2] = f8;
  HEAPF32[i7 >> 2] = f4;
  return;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  return;
 }
}

function __ZNSt3__26vectorIN20FileSystemEnumerator10MountPointENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i5 = i7 >> 3;
 i5 = i7 >> 4 >>> 0 < 134217727 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 268435455;
 i1 = i2 - i1 >> 4;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 << 4) | 0;
 i2 = i4 + (i1 << 4) | 0;
 i3 = i2;
 i7 = i4 + (i5 << 4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 HEAP32[i4 + (i1 << 4) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i6 = i1;
   i1 = i1 + -16 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -16 | 0, i1);
   HEAP32[i2 + -4 >> 2] = HEAP32[i6 + -4 >> 2];
   i2 = i3 + -16 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -16 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 12 : 8;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i5, gb + 912455 | 0, 0);
 i9 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i5 + 4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i9;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 906345 | 0, 0);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = i1 + 36 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 + -10 | 0) >>> 0 < 3) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (((i7 | 1) + -25 | 0) >>> 0 < 5) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = i7 + -30 | 0;
 if (i8 >>> 0 < 15) {
  if ((i7 + -48 | 0) >>> 0 < 12 | ((i7 + -45 | 0) >>> 0 < 3 | (30847 >>> (i8 & 65535) & 1) != 0)) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 } else if ((i7 + -45 | 0) >>> 0 < 3 | (i7 + -48 | 0) >>> 0 < 12) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i8 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i3) | 0;
 i8 = (HEAP32[i1 + 8 >> 2] | 0) + i8 | 0;
 i3 = i1 + 28 | 0;
 i1 = i1 + 32 | 0;
 i8 = i8 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i7, i4) | 0) | 0;
 i3 = HEAP32[i3 >> 2] >> i4;
 i3 = (i3 | 0) < 1 ? 1 : i3;
 i4 = HEAP32[i1 >> 2] >> i4;
 i7 = HEAP32[i6 >> 2] | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i5, i3, (i4 | 0) < 1 ? 1 : i4, Math_imul(HEAP32[gb + 45784 + (i7 << 2) >> 2] | 0, i3) | 0, i7, i8);
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i6 + 148 >> 2] = 2;
 i7 = i1;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i6 + 20 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6 + 28 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 i7 = i1 + 4 | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i2 + 4 | 0;
 f5 = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
 HEAPF32[i6 + 12 >> 2] = Math_fround(f3 * Math_fround(.5));
 HEAPF32[i6 + 16 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i7 >> 2]));
 f4 = Math_fround(-f5);
 i2 = i6 + 84 | 0;
 HEAPF32[i2 >> 2] = f3;
 i1 = i6 + 88 | 0;
 HEAPF32[i1 >> 2] = f4;
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))));
 if (f5 < Math_fround(1.1920929e-07)) {
  f5 = f4;
  f4 = Math_fround(-f3);
  f5 = Math_fround(-f5);
  i9 = i6 + 92 | 0;
  HEAPF32[i9 >> 2] = f4;
  i9 = i6 + 96 | 0;
  HEAPF32[i9 >> 2] = f5;
  return;
 }
 f5 = Math_fround(Math_fround(1.0) / f5);
 f3 = Math_fround(f3 * f5);
 HEAPF32[i2 >> 2] = f3;
 f5 = Math_fround(f5 * f4);
 HEAPF32[i1 >> 2] = f5;
 f4 = f3;
 f4 = Math_fround(-f4);
 f5 = Math_fround(-f5);
 i9 = i6 + 92 | 0;
 HEAPF32[i9 >> 2] = f4;
 i9 = i6 + 96 | 0;
 HEAPF32[i9 >> 2] = f5;
 return;
}

function __ZN11SoundHandleD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
  }
  HEAP32[i5 >> 2] = 0;
  if (i4 | 0) {
   i1 = HEAP32[i4 + 120 >> 2] | 0;
   if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) == 1) if (((HEAP32[i4 + 44 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
    i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
    i3 = i4 + 116 | 0;
    if (!(HEAP8[i3 >> 0] | 0)) {
     i2 = i1 + 24 | 0;
     if ((i4 | 0) != (i2 | 0)) {
      i1 = HEAP32[i4 >> 2] | 0;
      if (!i1) i1 = i4 + 4 | 0; else {
       i6 = i4 + 4 | 0;
       HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
       HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
       HEAP32[i4 >> 2] = 0;
       HEAP32[i6 >> 2] = 0;
       i1 = i6;
      }
      i6 = HEAP32[i2 >> 2] | 0;
      HEAP32[i4 >> 2] = i6;
      HEAP32[i1 >> 2] = i2;
      HEAP32[i6 + 4 >> 2] = i4;
      HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
     }
     HEAP8[i3 >> 0] = 1;
    }
   }
  }
 }
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + -1;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (!(HEAP32[i6 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i2, i13, i14) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i15 = 0, i16 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i17;
 __ZN20SphericalHarmonicsL27SetZeroEv(i14);
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 i16 = HEAP32[i13 + 20 >> 2] | 0;
 if (!((i16 | 0) > -1 ? (i16 | 0) < (HEAP32[i1 + 12 >> 2] | 0) : 0)) {
  STACKTOP = i17;
  return;
 }
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = i2 + 124 | 0;
 i12 = i2 + 116 | 0;
 i6 = i2 + 108 | 0;
 i7 = (HEAP32[i10 + (i16 * 80 | 0) + 12 >> 2] >> 31) + 3 | 0;
 i5 = 0;
 while (1) {
  i8 = HEAP32[i10 + (i16 * 80 | 0) + (i5 << 2) >> 2] | 0;
  f9 = Math_fround(HEAPF32[i13 + (i5 << 2) >> 2]);
  i1 = HEAP32[i11 >> 2] | 0;
  if (!i1) i3 = 0; else i3 = (HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i8 >>> 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i8 >>> 0) {
   i4 = i15;
   i1 = (HEAP32[i1 >> 2] | 0) + (i8 * 108 | 0) | 0;
   i2 = i4 + 108 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    i4 = i4 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i4 | 0) < (i2 | 0));
  } else __ZN20SphericalHarmonicsL27SetZeroEv(i15);
  if (i3) __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i15, (HEAP32[HEAP32[i11 >> 2] >> 2] | 0) + (i8 * 108 | 0) | 0, Math_fround(HEAPF32[i6 >> 2]));
  __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i14, i15, f9);
  if ((i5 | 0) == (i7 | 0)) break; else i5 = i5 + 1 | 0;
 }
 STACKTOP = i17;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37296 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37248 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37304 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37040 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37012 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 8 | 0;
 i7 = i3;
 i2 = i3 + 16 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36996 >> 2] | 0, i7, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function _UNITY_png_icc_profile_error(i9, i1, i2, i8, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = (i1 | 0) != 0;
 if (i12) {
  i7 = i1 + 74 | 0;
  HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 0 | 32768;
 }
 i1 = _UNITY_png_safecat(i11, 196, 0, gb + 351218 | 0) | 0;
 i1 = _UNITY_png_safecat(i11, 196, _UNITY_png_safecat(i11, i1 + 79 | 0, i1, i2) | 0, gb + 351228 | 0) | 0;
 i2 = i8 >>> 24;
 if (((i2 & 223) + -65 | 0) >>> 0 < 26 | ((i2 | 0) == 32 | (i2 + -48 | 0) >>> 0 < 10)) {
  i3 = i8 >>> 16;
  i4 = i3 & 255;
  if (((i3 & 223) + -65 | 0) >>> 0 < 26 | ((i4 | 0) == 32 | (i4 + -48 | 0) >>> 0 < 10)) {
   i5 = i8 >>> 8;
   i6 = i5 & 255;
   if (((i5 & 223) + -65 | 0) >>> 0 < 26 | ((i6 | 0) == 32 | (i6 + -48 | 0) >>> 0 < 10)) {
    i7 = i8 & 255;
    if (((i8 & 223) + -65 | 0) >>> 0 < 26 | ((i7 | 0) == 32 | (i7 + -48 | 0) >>> 0 < 10)) {
     i14 = i11 + i1 | 0;
     HEAP8[i14 >> 0] = 39;
     HEAP8[i14 + 1 >> 0] = (i2 + -32 | 0) >>> 0 < 95 ? i2 & 255 : 63;
     HEAP8[i14 + 2 >> 0] = (i4 + -32 | 0) >>> 0 < 95 ? i3 & 255 : 63;
     HEAP8[i14 + 3 >> 0] = (i6 + -32 | 0) >>> 0 < 95 ? i5 & 255 : 63;
     HEAP8[i14 + 4 >> 0] = (i7 + -32 | 0) >>> 0 < 95 ? i8 & 255 : 63;
     HEAP8[i14 + 5 >> 0] = 39;
     HEAP8[i11 + (i1 + 6) >> 0] = 58;
     HEAP8[i11 + (i1 + 7) >> 0] = 32;
     i1 = i1 + 8 | 0;
    }
   }
  }
 }
 _UNITY_png_safecat(i11, 196, i1, i10) | 0;
 _UNITY_png_chunk_report(i9, i11, i12 ? 2 : 1);
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i4 = i2 + -1 | 0;
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i1 + (i4 << 3) + 4 >> 0] | 0)) {
   i3 = i6 + 36 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    i3 = i2;
    i2 = 0;
   } else {
    i2 = HEAP32[i6 + 20 >> 2] | 0;
    i2 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 + (i4 << 3) >> 2] | 0) | 0) & 1;
    HEAP8[i3 >> 0] = i2;
    i1 = HEAP32[i6 >> 2] | 0;
    i3 = HEAP32[i1 + 8 >> 2] | 0;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP8[i1 + (i3 + -1 << 3) + 5 >> 0] = i2;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP8[(HEAP32[i3 + 4 >> 2] | 0) + ((HEAP32[i3 + 8 >> 2] | 0) + -1 << 3) + 4 >> 0] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 i1 = HEAP8[i6 + 36 >> 0] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP8[i7 + 4 >> 0] = 0;
 HEAP8[i7 + 5 >> 0] = i1;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i3 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = i7;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i7) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx19PxsSimObjectFactory18createArticulationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i7 + 292 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, (HEAP32[i7 + 288 >> 2] | 0) + 67 | 0, gb + 773384 | 0, 183) | 0;
  if (!i1) i6 = 0; else {
   i6 = i1 + 67 & -64;
   HEAP32[i6 + -4 >> 2] = i6 - i1;
  }
  HEAP32[i3 >> 2] = i6;
  i1 = i7 + 268 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i7 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i7 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i6;
   HEAP32[i1 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEE15growAndPushBackERKS2_(i7 + 4 | 0, i3) | 0;
  i1 = i6 + ((HEAP32[i7 + 276 >> 2] | 0) + -1 << 6) | 0;
  if (i1 >>> 0 < i6 >>> 0) i1 = HEAP32[i8 >> 2] | 0; else {
   i5 = i7 + 284 | 0;
   i4 = HEAP32[i8 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   while (1) {
    HEAP32[i1 >> 2] = i4;
    i2 = i2 + 1 | 0;
    i3 = i1 + -64 | 0;
    if (i3 >>> 0 < i6 >>> 0) break; else {
     i4 = i1;
     i1 = i3;
    }
   }
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i2;
  }
 }
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i8 = i7 + 280 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i7 + 284 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN5physx15PxsArticulationC2Ev(i1);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb1EEEEvRS1_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085989 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 1085998 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 1084342 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 1085899 | 0, 0);
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i4, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i2 = i4 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i1 + 32 | 0, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085989 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 1085998 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 1084342 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 1085899 | 0, 0);
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i4, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i2 = i4 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i1 + 32 | 0, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN13OpenFileCache13ForceCloseAllEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (__ZN4File7IsValidEv(i3) | 0) {
  __ZN4File5CloseEv(i3) | 0;
  i1 = i3 + 160 | 0;
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
   HEAP32[i3 + 164 >> 2] = 0;
  } else {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i3 + 220 >> 2] = 0;
 }
 i1 = i3 + 32 | 0;
 if (__ZN4File7IsValidEv(i1) | 0) {
  __ZN4File5CloseEv(i1) | 0;
  i1 = i3 + 172 | 0;
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
   HEAP32[i3 + 176 >> 2] = 0;
  } else {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i3 + 224 >> 2] = 0;
 }
 i1 = i3 + 64 | 0;
 if (__ZN4File7IsValidEv(i1) | 0) {
  __ZN4File5CloseEv(i1) | 0;
  i1 = i3 + 184 | 0;
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
   HEAP32[i3 + 188 >> 2] = 0;
  } else {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i3 + 228 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 if (__ZN4File7IsValidEv(i1) | 0) {
  __ZN4File5CloseEv(i1) | 0;
  i1 = i3 + 196 | 0;
  i2 = i1 + 11 | 0;
  if ((HEAP8[i2 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
   HEAP32[i3 + 200 >> 2] = 0;
  } else {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
  }
  HEAP32[i3 + 232 >> 2] = 0;
 }
 i1 = i3 + 128 | 0;
 if (!(__ZN4File7IsValidEv(i1) | 0)) return;
 __ZN4File5CloseEv(i1) | 0;
 i1 = i3 + 208 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i3 + 212 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 HEAP32[i3 + 236 >> 2] = 0;
 return;
}

function __ZN12NavMeshAgent7SetPathEPK11NavMeshPath(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i4 = i8;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844605 | 0, 0, gb + 841797 | 0, 575, 1, 0, 0, 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i5 | 0) == 2 | (i7 | 0) == 0) {
  __ZN7dtCrowd14resetAgentPathERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 36 >> 2];
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i2 + 68 | 0;
 __ZN7dtCrowd12setAgentPathERK13dtCrowdHandlePKfS4_PKyib(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1, i4, i3, i6, i7, (i5 | 0) == 1);
 i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = (HEAP32[i1 + 28 >> 2] | 0) + (i2 + -1 << 3) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 i7 = i6 + (i7 + -1 << 3) | 0;
 i7 = (i1 | 0) == (HEAP32[i7 >> 2] | 0) ? (i2 | 0) == (HEAP32[i7 + 4 >> 2] | 0) : 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z18ConvertUTF32toUTF8PPKmS0_PPhS2_15ConversionFlags(i8, i6, i9, i7, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 < i6 >>> 0) i4 = i2; else {
  i6 = i2;
  i10 = 0;
  i7 = i1;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i9 >> 2] = i7;
  return i10 | 0;
 }
 while (1) {
  i2 = i4 + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < 128) i5 = 1; else if (i3 >>> 0 < 2048) i5 = 2; else if (i3 >>> 0 < 65536) i5 = 3; else {
   i11 = i3 >>> 0 < 2097152;
   i5 = i11 ? 4 : 2;
   i3 = i11 ? i3 : 65533;
  }
  i1 = i1 + i5 | 0;
  if (i1 >>> 0 > i7 >>> 0) break;
  switch (i5 & 7) {
  case 4:
   {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i10 = 9;
    break;
   }
  case 3:
   {
    i10 = 9;
    break;
   }
  case 2:
   {
    i10 = 10;
    break;
   }
  case 1:
   {
    i10 = 11;
    break;
   }
  default:
   {}
  }
  if ((i10 | 0) == 9) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i10 = 10;
  }
  if ((i10 | 0) == 10) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i10 = 11;
  }
  if ((i10 | 0) == 11) {
   i10 = 0;
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = HEAPU8[gb + 584572 + i5 >> 0] | 0 | i3;
  }
  i1 = i1 + i5 | 0;
  if (i2 >>> 0 < i6 >>> 0) i4 = i2; else {
   i3 = 0;
   i10 = 14;
   break;
  }
 }
 if ((i10 | 0) == 14) {
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  return i3 | 0;
 }
 i7 = i4;
 i11 = 2;
 i10 = i1 + (0 - i5) | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i9 >> 2] = i10;
 return i11 | 0;
}

function _unity_z_deflateSetDictionary(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i1) {
  i11 = -2;
  return i11 | 0;
 }
 i11 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i2 | 0) == 0 | (i11 | 0) == 0) {
  i11 = -2;
  return i11 | 0;
 }
 switch (HEAP32[i11 + 24 >> 2] | 0) {
 case 1:
  {
   i4 = 4;
   break;
  }
 case 0:
  break;
 case 2:
  {
   i11 = -2;
   return i11 | 0;
  }
 default:
  i4 = 5;
 }
 if ((i4 | 0) == 4) if ((HEAP32[i11 + 4 >> 2] | 0) == 42) i4 = 5; else {
  i11 = -2;
  return i11 | 0;
 }
 if ((i4 | 0) == 5) {
  i10 = i1 + 48 | 0;
  HEAP32[i10 >> 2] = _unity_z_adler32(HEAP32[i10 >> 2] | 0, i2, i3) | 0;
 }
 if (i3 >>> 0 < 3) {
  i11 = 0;
  return i11 | 0;
 }
 i7 = (HEAP32[i11 + 44 >> 2] | 0) + -262 | 0;
 i8 = i7 >>> 0 < i3 >>> 0;
 i10 = i8 ? i7 : i3;
 i6 = i11 + 56 | 0;
 _memcpy(HEAP32[i6 >> 2] | 0, (i8 ? i2 + (i3 - i7) | 0 : i2) | 0, i10 | 0) | 0;
 HEAP32[i11 + 108 >> 2] = i10;
 HEAP32[i11 + 92 >> 2] = i10;
 i6 = HEAP32[i6 >> 2] | 0;
 i3 = HEAPU8[i6 >> 0] | 0;
 i7 = i11 + 72 | 0;
 HEAP32[i7 >> 2] = i3;
 i8 = HEAP32[i11 + 88 >> 2] | 0;
 i9 = HEAP32[i11 + 84 >> 2] | 0;
 i3 = ((HEAPU8[i6 + 1 >> 0] | 0) ^ i3 << i8) & i9;
 HEAP32[i7 >> 2] = i3;
 i10 = i10 + -3 | 0;
 i4 = HEAP32[i11 + 68 >> 2] | 0;
 i5 = HEAP32[i11 + 52 >> 2] | 0;
 i2 = HEAP32[i11 + 64 >> 2] | 0;
 i1 = 0;
 do {
  i3 = ((HEAPU8[i6 + (i1 + 2) >> 0] | 0) ^ i3 << i8) & i9;
  HEAP32[i7 >> 2] = i3;
  i11 = i4 + (i3 << 1) | 0;
  HEAP16[i2 + ((i5 & i1) << 1) >> 1] = HEAP16[i11 >> 1] | 0;
  HEAP16[i11 >> 1] = i1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 <= i10 >>> 0);
 i1 = 0;
 return i1 | 0;
}

function _open_face_from_buffer(i7, i4, i2, i8, i6, i11) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i13 + 32 | 0;
 i9 = i13;
 i12 = HEAP32[i7 >> 2] | 0;
 if (!i7) {
  i1 = 33;
  i5 = 4;
 } else if (!i4) {
  i1 = 6;
  i5 = 4;
 } else {
  i10 = _UNITY_ft_mem_alloc(i12, 40, i3) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   _UNITY_FT_Stream_OpenMemory(i10, i4, i2);
   HEAP32[i10 + 24 >> 2] = fb + 3833;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) {
    HEAP32[i9 >> 2] = 2;
    HEAP32[i9 + 16 >> 2] = i10;
    if (i6 | 0) {
     HEAP32[i9 >> 2] = 10;
     i5 = HEAP32[i7 + 16 >> 2] | 0;
     i3 = i7 + 20 + (i5 << 2) | 0;
     L8 : do if ((i5 | 0) > 0) {
      i2 = i7 + 20 | 0;
      while (1) {
       i1 = HEAP32[i2 >> 2] | 0;
       i2 = i2 + 4 | 0;
       if (!(_strcmp(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i6) | 0)) break L8;
       if (i2 >>> 0 >= i3 >>> 0) {
        i1 = 0;
        break;
       }
      }
     } else i1 = 0; while (0);
     HEAP32[i9 + 20 >> 2] = i1;
    }
    i1 = _UNITY_FT_Open_Face(i7, i9, i8, i11) | 0;
    if (!i1) {
     i12 = (HEAP32[i11 >> 2] | 0) + 8 | 0;
     HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & -1025;
     i12 = 0;
     STACKTOP = i13;
     return i12 | 0;
    } else {
     _UNITY_FT_Stream_Close(i10);
     _UNITY_ft_mem_free(i12, i10);
     i12 = i1;
     STACKTOP = i13;
     return i12 | 0;
    }
   }
  } else i5 = 4;
 }
 _UNITY_ft_mem_free(i12, i4);
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 152 >> 2]);
 f12 = Math_fround(-f10);
 f9 = Math_fround(-f11);
 f4 = Math_fround(-f7);
 f12 = HEAP32[gb + 48 + (i1 << 4) >> 2] | 0 ? f10 : f12;
 f9 = HEAP32[gb + 48 + (i1 << 4) + 4 >> 2] | 0 ? f11 : f9;
 f4 = HEAP32[gb + 48 + (i1 << 4) + 8 >> 2] | 0 ? f7 : f4;
 f7 = Math_fround(HEAPF32[i8 + 48 >> 2]);
 f11 = Math_fround(HEAPF32[i8 + 52 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 56 >> 2]);
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 32 >> 2])));
 f5 = Math_fround(f12 * Math_fround(HEAPF32[i8 + 4 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 20 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 36 >> 2])));
 f12 = Math_fround(f12 * Math_fround(HEAPF32[i8 + 8 >> 2]));
 f9 = Math_fround(f12 + Math_fround(f9 * Math_fround(HEAPF32[i8 + 24 >> 2])));
 f5 = Math_fround(f11 + f5);
 f4 = Math_fround(f10 + Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 40 >> 2]))));
 HEAPF32[i2 >> 2] = Math_fround(f7 + f6);
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math8ColliderEEEclERS3_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float4EEEclERS4_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float3EEEclERS4_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN8Material33ReleaseAllMaterialsPropertySheetsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i3 = i11 + 16 | 0;
 i6 = gb + 64016 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i9;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i3 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i9);
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i6;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 30792 | 0, i3, 0);
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i7 = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 100 >> 2] | 0;
   __ZN19ShaderPropertySheet5ClearEb(i7 + 12 | 0, 0);
   i8 = i7 + 220 | 0;
   i9 = HEAP32[i8 >> 2] | 0;
   if (i9 | 0) {
    i10 = i7 + 208 | 0;
    i2 = 0;
    do {
     __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i10 >> 2] | 0) + (i2 * 244 | 0) | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i9 | 0));
   }
   HEAP32[i7 + 200 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i10 = i7 + 164 | 0;
   HEAP8[i10 >> 0] = HEAP8[i10 >> 0] & -2;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i6);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN7Striper11FreeUsedRamEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i6 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) {
  i1 = i5 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i1 | 0) do {
   i2 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3 | 0) __ZdaPv(i3);
   __ZdlPv(i2);
  } while ((i1 | 0) != 0);
  __ZdlPv(i5);
 }
 HEAP32[i4 >> 2] = 0;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) {
  i1 = i5 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i1 | 0) do {
   i2 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3 | 0) __ZdaPv(i3);
   __ZdlPv(i2);
  } while ((i1 | 0) != 0);
  __ZdlPv(i5);
 }
 HEAP32[i4 >> 2] = 0;
 i4 = i6 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) {
  i1 = i5 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i1 | 0) do {
   i2 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (i3 | 0) __ZdaPv(i3);
   __ZdlPv(i2);
  } while ((i1 | 0) != 0);
  __ZdlPv(i5);
 }
 HEAP32[i4 >> 2] = 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) {
  HEAP32[i6 >> 2] = 0;
  return i6 | 0;
 }
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 __ZdlPv(i3);
 HEAP32[i6 >> 2] = 0;
 return i6 | 0;
}

function __ZN5physx2Sc21ConstraintInteraction10onActivateEj(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 4 | 0;
 i4 = i9;
 i7 = i10 + 32 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i8 + 108 >> 2] | 0;
 i8 = HEAP32[i8 + 112 >> 2] | 0;
 i6 = i10 + 36 | 0;
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  i3 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i10 + 4 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0;
  if (!i5) i1 = -1; else i1 = HEAP32[i5 + 188 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  if (!i8) i1 = -1; else i1 = HEAP32[i8 + 188 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_(i3, 1, i2, i4, i6);
  __ZN5physx16PxsIslandManager17setEdgeConstraintERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_13PxsConstraintE(i3, i6, (HEAP32[i7 >> 2] | 0) + 32 | 0);
  __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i3, i6);
 }
 if (!i5) i1 = 1; else i1 = (HEAP8[i5 + 51 >> 0] & 1) != 0;
 if (i8 | 0) if (!(i1 | (HEAP8[i8 + 51 >> 0] & 1) != 0)) {
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 }
 if ((HEAP8[(HEAP32[i7 >> 2] | 0) + 116 >> 0] & 6) != 2) {
  i10 = 1;
  STACKTOP = i9;
  return i10 | 0;
 }
 i10 = __ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i10 + 4 >> 2] | 0) | 0;
 __ZN5physx2Sc5Scene28addActiveBreakableConstraintEPNS0_13ConstraintSimE(i10, HEAP32[i7 >> 2] | 0);
 i10 = 1;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5Umbra12PortalCuller12addStartCellERKNS0_4TileEi(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((HEAPU16[i3 + 2936 + (i5 << 1) >> 1] | 0) >= 16384) return;
 i6 = i3 + 2300 | 0;
 i2 = i3 + 2304 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 do if (!(i1 << 16 >> 16)) {
  i2 = i3 + 2306 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 << 16 >> 16)) return; else {
   i7 = i1 & 65535;
   HEAP16[i2 >> 1] = HEAP16[(HEAP32[i6 >> 2] | 0) + (i7 << 4) >> 1] | 0;
   i2 = i3 + 7048 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   __ZN5Umbra12PortalCuller12finalizeCellEt(i3, i1);
   i2 = HEAP32[i6 >> 2] | 0;
   i8 = i2 + (i7 << 4) + 8 | 0;
   __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(HEAP32[i3 + 292 >> 2] | 0, i8);
   HEAP8[i8 >> 0] = 0;
   HEAP8[i8 + 1 >> 0] = 0;
   HEAP8[i8 + 2 >> 0] = 0;
   HEAP8[i8 + 3 >> 0] = 0;
   HEAP32[i2 + (i7 << 4) + 12 >> 2] = 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP16[i3 + 2936 + ((HEAPU16[i2 + (i7 << 4) + 4 >> 1] | 0) << 1) >> 1] = i1;
   break;
  }
 } else {
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP16[i2 >> 1] = HEAP16[i8 + ((i1 & 65535) << 4) >> 1] | 0;
  i2 = i8;
 } while (0);
 i8 = i1 & 65535;
 HEAP16[i2 + (i8 << 4) + 4 >> 1] = i5;
 i9 = i3 + 344 | 0;
 i5 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i2 + (i8 << 4) + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = (HEAP32[i3 + 484 >> 2] | 0) + (HEAP32[i4 >> 2] << 1) | 0;
 HEAP16[i7 + (i8 << 4) >> 1] = HEAP16[i6 >> 1] | 0;
 HEAP16[i6 >> 1] = i1;
 HEAP16[i3 + 2936 + ((HEAPU16[i7 + (i8 << 4) + 4 >> 1] | 0) << 1) >> 1] = i8 | 32768;
 return;
}

function __ZN11MonoManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(236, i1, 16, gb + 1048932 | 0, 0, gb + 465019 | 0, 16) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 66624 + 8;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = i2;
 HEAP32[i4 + 144 >> 2] = 0;
 HEAP32[i4 + 152 >> 2] = 0;
 HEAP32[i4 + 160 >> 2] = 0;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 HEAP32[i4 + 176 >> 2] = 0;
 i2 = i4 + 184 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 188 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 192 >> 2] = 0;
 HEAP32[i4 + 180 >> 2] = i2;
 HEAP32[i4 + 200 >> 2] = 0;
 HEAP32[i4 + 204 >> 2] = 0;
 HEAP32[i4 + 208 >> 2] = 0;
 __Z22SetManagerPtrInContextiP6Object(5, i4);
 HEAP32[i4 >> 2] = gb + 66480 + 8;
 i2 = i4 + 212 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 _il2cpp_set_find_plugin_callback(fb + 1580 | 0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4);
 i1 = i6 + 48 | 0;
 i7 = i4 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 36 | 0, i4);
 i1 = i6 + 52 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 53 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 32 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 36 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 40 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 44 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 48 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 52 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 56 | 0);
 i2 = i2 + 60 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP8[i2 >> 0] = (HEAP8[i4 >> 0] | 0) != 0 & 1;
 STACKTOP = i3;
 return;
}

function __Z28Camera_CUSTOM_GetHDRWarningsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZNK6Camera14GetHDRWarningsEv(i6, i2);
 i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i4 = i6 + 4 | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, ((HEAP32[i4 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0) / 12 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i9 = i1 + (i3 * 12 | 0) | 0;
   i2 = HEAP8[i9 + 11 >> 0] | 0;
   i8 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i5, i3, __Z20scripting_string_newPKcj(i8 ? HEAP32[i9 >> 2] | 0 : i9, i8 ? HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 12 | 0) >>> 0);
 }
 i3 = i1;
 if (!i1) {
  STACKTOP = i7;
  return i5 | 0;
 }
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i9 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i9;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i7;
 return i5 | 0;
}

function __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNK6Camera20WorldToViewportPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i4 + 16 | 0;
 i7 = i4;
 __ZNK6Camera18WorldToScreenPointERK8Vector3fPb(i7, i2, i3, i4 + 32 | 0);
 __ZL19GetCameraTargetRectRK6Camerab(i14, i2, 1);
 f9 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f11 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f9 = Math_fround(f9 * f11);
 f6 = Math_fround(f6 * f11);
 f8 = Math_fround(f8 * f10);
 f5 = Math_fround(f5 * f10);
 f13 = Math_fround(HEAPF32[i14 >> 2]);
 f12 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f9 = Math_fround(f9 + f13);
 f8 = Math_fround(f8 + f12);
 f6 = Math_fround(f6 + f9);
 f5 = Math_fround(f5 + f8);
 f11 = Math_fround(f11 + f13);
 f10 = Math_fround(f10 + f12);
 f9 = f9 < f13 ? f13 : f9;
 f8 = f8 < f12 ? f12 : f8;
 f6 = Math_fround((f6 > f11 ? f11 : f6) - f9);
 i3 = f6 < Math_fround(0.0);
 f6 = i3 ? Math_fround(0.0) : f6;
 f5 = Math_fround((f5 > f10 ? f10 : f5) - f8);
 i3 = f5 < Math_fround(0.0);
 f5 = i3 ? Math_fround(0.0) : f5;
 f6 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f9) / f6);
 f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i7 + 4 >> 2]) - f8) / f5);
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN7mecanim9animation23BlendDirectDataConstant8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i3 = i6;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + 4;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 903840 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i5, i3, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 903865 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN24CompressedAnimationCurve16CompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E(i10, i6) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 i11 = i13 + 8 | 0;
 i12 = HEAP32[i6 + 164 >> 2] | 0;
 i9 = (i12 | 0) > 0;
 if (i9) {
  i3 = HEAP32[i6 + 152 >> 2] | 0;
  f2 = Math_fround(0.0);
  i1 = 0;
  do {
   f14 = Math_fround(HEAPF32[i3 + (i1 * 52 | 0) >> 2]);
   f2 = f14 < f2 ? f14 : f2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i12 | 0));
 } else f2 = Math_fround(0.0);
 HEAP32[i11 + 12 >> 2] = i12;
 i7 = i11 + 16 | 0;
 HEAP32[i7 >> 2] = i12;
 i8 = i11 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 64016 | 0);
 i3 = i4;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12 << 2, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
 HEAP32[i11 >> 2] = i5;
 if (i9) {
  i4 = HEAP32[i6 + 152 >> 2] | 0;
  i1 = 0;
  i3 = 0;
  do {
   i9 = i1;
   i1 = ~~Math_fround(Math_fround(Math_fround(HEAPF32[i4 + (i3 * 52 | 0) >> 2]) - f2) * Math_fround(100.0)) >>> 0;
   HEAP32[i5 + (i3 << 2) >> 2] = i1 - i9;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i12 | 0));
  i1 = i11;
 } else i1 = i11;
 __ZN15PackedIntVector8PackIntsIjEEvPT_i(i10, i5, i12);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i11 >> 2] | 0, i8);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i13;
 return;
}

function __ZN22BuiltinResourceManager19DestroyAllResourcesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 i1 = HEAP32[i5 >> 2] | 0;
 i9 = i5 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i1;
 while (1) {
  HEAP32[i7 >> 2] = HEAP32[i4 + 16 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i8 = 11; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
    i2 = HEAP32[i6 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 11; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
   }
  }
  if ((i8 | 0) == 11) i8 = 0;
  i2 = i4 + 24 | 0;
  if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) break; else i4 = i2;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i9 >> 2] = i2 + (~(((i4 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
 STACKTOP = i10;
 return;
}

function __ZN11ForceModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 620173 | 0, i5, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620372 | 0, i5, i1 + 800 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620354 | 0, i5, i1 + 801 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 i1 = mftCall_iii(HEAP32[i6 >> 2] | 0, i4 | 0, i3 | 0) | 0;
 i2 = mftCall_iii(HEAP32[i6 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 if (!i1) {
  if (!i2) {
   i6 = 0;
   return i6 | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i1;
  i1 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i2;
  if (!(mftCall_iii(HEAP32[i6 >> 2] | 0, i4 | 0, i3 | 0) | 0)) {
   i6 = 1;
   return i6 | 0;
  }
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i5;
  i5 = i3 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i6;
  i6 = 2;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i2) {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i1;
  i4 = i3 + 4 | 0;
  i6 = i5 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i6 >> 2] = i5;
  i6 = 1;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i2 = i3 + 4 | 0;
 i1 = i4 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 if (!(mftCall_iii(HEAP32[i6 >> 2] | 0, i5 | 0, i4 | 0) | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i6 = i5 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i5;
 i6 = 2;
 return i6 | 0;
}

function __ZNSt3__26vectorI25VirtualJoystickPropertiesNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i5 = i7 >> 3;
 i5 = i7 >> 4 >>> 0 < 134217727 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 268435455;
 i1 = i2 - i1 >> 4;
 if (!i5) i4 = 0; else i4 = __Znwj(i5 << 4) | 0;
 i2 = i4 + (i1 << 4) | 0;
 i3 = i2;
 i7 = i4 + (i5 << 4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 HEAP8[i4 + (i1 << 4) + 12 >> 0] = HEAP8[i6 + 12 >> 0] | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i3;
  i3 = i4;
  i1 = i4;
 } else {
  do {
   i6 = i1;
   i1 = i1 + -16 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -16 | 0, i1);
   HEAP8[i2 + -4 >> 0] = HEAP8[i6 + -4 >> 0] | 0;
   i2 = i3 + -16 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -16 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __Z19DestroySingleObjectP6Object(HEAP32[i2 + 20 >> 2] | 0);
 if (!(HEAP8[gb + 1099720 >> 0] | 0)) {
  i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i6 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i9 = gb + 63696 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i6, 1, gb + 1018240 | 0, 40, 32768, i4, 16);
  HEAP32[gb + 1467252 >> 2] = i6;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i6);
  if (i1) __Z19pop_allocation_rootv();
  i9 = gb + 1099720 | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = 0;
 }
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1467252 >> 2] | 0, i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = i10 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i10 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + (((i1 >>> 0) / 341 | 0) << 2) | 0;
 i11 = i10 + 8 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i4 = i7;
 i5 = i2;
 if ((i7 | 0) == (i2 | 0)) {
  i6 = 0;
  i7 = i10 + 20 | 0;
  i1 = 0;
 } else {
  i7 = i10 + 20 | 0;
  i6 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i6 = (HEAP32[i2 + (((i6 >>> 0) / 341 | 0) << 2) >> 2] | 0) + (((i6 >>> 0) % 341 | 0) * 12 | 0) | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + (((i1 >>> 0) % 341 | 0) * 12 | 0) | 0;
 }
 L5 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L5;
   i1 = i1 + 12 | 0;
  } while ((i1 - (HEAP32[i3 >> 2] | 0) | 0) != 4092);
  i1 = i3 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i4 - i5 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = (HEAP32[i11 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i8 >> 2] = 170;
   break;
  }
 case 2:
  {
   HEAP32[i8 >> 2] = 341;
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN13MonoBehaviour18TransferEngineDataI19StreamedBinaryWriteILb0EEEE4PPtrI10MonoScriptERT_(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13 + 4 | 0;
 i12 = i13;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
 HEAP32[i12 >> 2] = HEAP32[i1 + 36 >> 2];
 __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i11);
 i8 = i1 + 40 | 0;
 i6 = i8 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i7 = i1 + 44 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i9 = i11 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i11 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i8 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  i12 = HEAP32[i12 >> 2] | 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i12 = HEAP32[i12 >> 2] | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZL19HandleDecompressionPKhii13TextureFormatiiii(i13, i14, i4, i3, i15, i6, i16, i1, i2) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i6 = i6 | 0;
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = (i15 + -30 | 0) >>> 0 < 4;
 if (i5) {
  i12 = i4;
  i8 = 0;
  i9 = i4;
 } else {
  i9 = __Z29GetTextureSizeAllowedMultiple13TextureFormat(i15) | 0;
  i11 = 0 - i9 | 0;
  i10 = i1 + i6 - (i11 & i6) | 0;
  i3 = i2 + i16 - (i11 & i16) | 0;
  i12 = i9;
  i3 = ((i3 | 0) % (i9 | 0) | 0 | 0) == 0 ? i3 : (i3 & i11) + i9 | 0;
  i8 = i11;
  i9 = ((i10 | 0) % (i9 | 0) | 0 | 0) == 0 ? i10 : (i10 & i11) + i9 | 0;
 }
 i10 = (i15 | 0) == 24;
 i7 = i10 ? 20 : 4;
 i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(__Z18CalculateImageSizeii13TextureFormat(i9, i3, i7) | 0, 1, gb + 64016 | 0, 0, gb + 404494 | 0, 1957) | 0;
 if (i5) __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i15, i7, i9, i3, i14, i9, i3, i11) | 0; else {
  i5 = (i12 | 0) > (i4 | 0) ? i12 : i4;
  i4 = __Z18CalculateImageSizeii13TextureFormat(i8 & i6, i12, i15) | 0;
  if ((i3 | 0) > 0) {
   i2 = 0;
   do {
    i1 = i2 + i16 & i8;
    if (!i1) i1 = 0; else i1 = __Z18CalculateImageSizeii13TextureFormat(i5, i1, i15) | 0;
    __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i15, i7, i9, i12, i14 + i1 + i4 | 0, i9, i12, i11 + ((Math_imul(i2, i9) | 0) << 2) | 0) | 0;
    i2 = i2 + i12 | 0;
   } while ((i2 | 0) < (i3 | 0));
  }
 }
 HEAP32[i13 >> 2] = i11;
 HEAP32[i13 + 4 >> 2] = i12;
 HEAP32[i13 + 8 >> 2] = i9;
 HEAP8[i13 + 12 >> 0] = i10 & 1;
 return;
}

function __ZNK6Camera13GetCameraRectEb(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i13;
 __ZL19GetCameraTargetRectRK6Camerab(i14, i1, i2);
 i2 = i1 + 864 | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f11 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f5 = Math_fround(f11 * Math_fround(HEAPF32[i7 >> 2]));
 i2 = i7 + 8 | 0;
 f9 = Math_fround(f11 * Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i2 >> 2] = f9;
 i1 = i7 + 4 | 0;
 f6 = Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2]));
 i8 = i7 + 12 | 0;
 f10 = Math_fround(f12 * Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i8 >> 2] = f10;
 f4 = Math_fround(HEAPF32[i14 >> 2]);
 f3 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f5 = Math_fround(f4 + f5);
 HEAPF32[i7 >> 2] = f5;
 f6 = Math_fround(f3 + f6);
 HEAPF32[i1 >> 2] = f6;
 f9 = Math_fround(f5 + f9);
 f10 = Math_fround(f6 + f10);
 f11 = Math_fround(f4 + f11);
 f12 = Math_fround(f3 + f12);
 if (f5 < f4) HEAPF32[i7 >> 2] = f4; else f4 = f5;
 if (f6 < f3) HEAPF32[i1 >> 2] = f3; else f3 = f6;
 f11 = Math_fround((f9 > f11 ? f11 : f9) - f4);
 i14 = f11 < Math_fround(0.0);
 HEAPF32[i2 >> 2] = i14 ? Math_fround(0.0) : f11;
 f12 = Math_fround((f10 > f12 ? f12 : f10) - f3);
 i14 = f12 < Math_fround(0.0);
 HEAPF32[i8 >> 2] = i14 ? Math_fround(0.0) : f12;
 STACKTOP = i13;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i7 + 36 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i8 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i4 = i7 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i7 + 24 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i8 + 4 | 0;
   do {
    i3 = i2 + -36 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -24 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Gu23checkOverlapOBB_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f14 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f7 = Math_fround(f10 + f10);
 f8 = Math_fround(f15 + f15);
 f16 = Math_fround(f11 + f11);
 f10 = Math_fround(f10 * f7);
 f6 = Math_fround(f15 * f8);
 f13 = Math_fround(f11 * f16);
 f15 = Math_fround(f7 * f15);
 f9 = Math_fround(f7 * f11);
 f7 = Math_fround(f7 * f14);
 f11 = Math_fround(f8 * f11);
 f8 = Math_fround(f8 * f14);
 f14 = Math_fround(f16 * f14);
 f16 = Math_fround(f15 + f14);
 f12 = Math_fround(f9 - f8);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(Math_fround(1.0) - f6) - f13);
 HEAPF32[i5 + 4 >> 2] = f16;
 HEAPF32[i5 + 8 >> 2] = f12;
 f10 = Math_fround(Math_fround(1.0) - f10);
 f13 = Math_fround(f10 - f13);
 f12 = Math_fround(f11 + f7);
 HEAPF32[i5 + 12 >> 2] = Math_fround(f15 - f14);
 HEAPF32[i5 + 16 >> 2] = f13;
 HEAPF32[i5 + 20 >> 2] = f12;
 f7 = Math_fround(f11 - f7);
 f6 = Math_fround(f10 - f6);
 HEAPF32[i5 + 24 >> 2] = Math_fround(f9 + f8);
 HEAPF32[i5 + 28 >> 2] = f7;
 HEAPF32[i5 + 32 >> 2] = f6;
 i3 = __ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b(i2 + 4 | 0, i3 + 16 | 0, i5, i1 + 48 | 0, i1 + 36 | 0, i1, 1) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i6 + 284 >> 2] | 0) + (i5 * 12 | 0) + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 2)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i2 & -3;
 i4 = i6 + 352 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i6 + 364 | 0;
 if ((i2 | 0) == (HEAP32[i1 >> 2] | 0)) {
  i13 = i6 + 332 | 0;
  i8 = i2 << 1;
  i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7 + 1 | 0, i2 << 5, gb + 681489 | 0, 1659) | 0;
  i12 = i14 + (i8 << 2) | 0;
  i10 = i14 + (i2 << 2 << 2) | 0;
  i3 = i14 + (i2 * 6 << 2) | 0;
  _memcpy(i14 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i6 + 336 >> 2] << 2 | 0) | 0;
  i11 = i6 + 340 | 0;
  _memcpy(i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i6 + 344 >> 2] << 2 | 0) | 0;
  i9 = i6 + 356 | 0;
  _memcpy(i10 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 + 360 >> 2] << 2 | 0) | 0;
  i2 = i6 + 348 | 0;
  _memcpy(i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i13 >> 2] | 0);
  HEAP32[i13 >> 2] = i14;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i9 >> 2] = i10;
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = i8;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i6 + 348 >> 2] | 0;
  i1 = i2;
 }
 HEAP32[i3 + (i1 << 2) >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP8[i6 + 477 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN11dtPathQueueC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 200 >> 2] = -1;
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 184 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 188 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 192 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 1;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 HEAP32[i1 + 228 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __Z14TestPlanesAABBPK5PlaneiRK4AABB(i11, i3, i10) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, i18 = 0, f19 = f0;
 if ((i3 | 0) == 6) i1 = 63; else if ((i3 | 0) > 0) {
  i1 = 0;
  i2 = 0;
  do {
   i1 = 1 << i2 | i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } else {
  i11 = 1;
  return i11 | 0;
 }
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 i2 = i11;
 i3 = 1;
 while (1) {
  if (i3 & i1 | 0) {
   f16 = Math_fround(HEAPF32[i2 >> 2]);
   f19 = Math_fround(f9 * f16);
   f14 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f5 * f14));
   f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f6 * f12));
   f19 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f19);
   i18 = f16 < Math_fround(0.0);
   f17 = Math_fround(-f16);
   i10 = f14 < Math_fround(0.0);
   f15 = Math_fround(-f14);
   i11 = f12 < Math_fround(0.0);
   f13 = Math_fround(-f12);
   if (Math_fround(f19 + Math_fround(Math_fround(Math_fround(f7 * (i18 ? f17 : f16)) + Math_fround(f8 * (i10 ? f15 : f14))) + Math_fround(f4 * (i11 ? f13 : f12)))) < Math_fround(0.0)) {
    i1 = 0;
    i2 = 8;
    break;
   }
  }
  i3 = i3 << 1;
  if (i3 >>> 0 > i1 >>> 0) {
   i1 = 1;
   i2 = 8;
   break;
  } else i2 = i2 + 16 | 0;
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function _yn(i6, d1) {
 i6 = i6 | 0;
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, d9 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i7 = i5 & 2147483647;
 do if ((i7 | (i4 | 0 - i4) >>> 31) >>> 0 <= 2146435072) if ((i5 | 0) > -1 | (i5 | 0) == -1 & i4 >>> 0 > 4294967295 | (i7 | i4 | 0) == 0) if ((i7 | 0) == 2146435072) d1 = 0.0; else {
  if (!i6) {
   d1 = +_y0(d1);
   break;
  }
  i5 = (i6 | 0) < 0;
  i8 = i5 ? ~i6 : i6 + -1 | 0;
  i5 = i5 ? i6 & 1 : 0;
  if (!i8) {
   d1 = +_y1(d1);
   d1 = i5 | 0 ? -d1 : d1;
   break;
  }
  if (i7 >>> 0 > 1389363199) {
   switch (i8 & 3) {
   case 0:
    {
     d2 = -+Math_sin(+d1) - +Math_cos(+d1);
     break;
    }
   case 1:
    {
     d2 = +Math_cos(+d1) - +Math_sin(+d1);
     break;
    }
   case 2:
    {
     d2 = +Math_sin(+d1) + +Math_cos(+d1);
     break;
    }
   case 3:
    {
     d2 = +Math_sin(+d1) - +Math_cos(+d1);
     break;
    }
   default:
    {}
   }
   d1 = d2 * .5641895835477563 / +Math_sqrt(+d1);
  } else {
   d3 = +_y0(d1);
   d2 = +_y1(d1);
   HEAPF64[tempDoublePtr >> 3] = d2;
   if ((i8 | 0) > 0 & (0 ? 1 : (HEAP32[tempDoublePtr + 4 >> 2] | 0) != -1048576)) {
    i4 = 0;
    while (1) {
     i4 = i4 + 1 | 0;
     d3 = d2 * (+(i4 | 0) * 2.0 / d1) - d3;
     HEAPF64[tempDoublePtr >> 3] = d3;
     if (!((i4 | 0) < (i8 | 0) & (0 ? 1 : (HEAP32[tempDoublePtr + 4 >> 2] | 0) != -1048576))) {
      d1 = d3;
      break;
     } else {
      d9 = d2;
      d2 = d3;
      d3 = d9;
     }
    }
   } else d1 = d2;
  }
  d1 = i5 | 0 ? -d1 : d1;
 } else d1 = nan; while (0);
 return +d1;
}

function _faccessat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1216 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 24 | 0;
 i8 = i12 + 16 | 0;
 i7 = i12;
 i5 = i12 + 184 | 0;
 i10 = i12 + 56 | 0;
 i6 = i12 + 40 | 0;
 L1 : do switch (i4 | 0) {
 case 0:
  {
   i11 = 4;
   break;
  }
 case 512:
  {
   if ((_getuid() | 0) == (_geteuid() | 0)) {
    i13 = _getgid() | 0;
    if ((i13 | 0) == (_getegid() | 0)) {
     i11 = 4;
     break L1;
    }
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i3;
   ___block_all_sigs(i10 | 0);
   i1 = ___clone(fb + 2795 | 0, i5 + 1024 | 0, 0, i6 | 0, i8 | 0) | 0;
   if ((i1 | 0) > 0) {
    while (1) {
     HEAP32[i9 >> 2] = i1;
     HEAP32[i9 + 4 >> 2] = i8;
     HEAP32[i9 + 8 >> 2] = -2147483648;
     HEAP32[i9 + 12 >> 2] = 0;
     ___syscall114(114, i9 | 0) | 0;
     i2 = HEAP32[i8 >> 2] | 0;
     if (!(i2 & 127)) {
      i11 = 10;
      break;
     }
     if (((i2 & 65535) + -1 | 0) >>> 0 <= 254) {
      i1 = -16;
      break;
     }
    }
    if ((i11 | 0) == 10) i1 = HEAP32[gb + 208028 + ((i2 >>> 8 & 255) << 2) >> 2] | 0;
   } else i1 = -16;
   ___restore_sigs(i10 | 0);
   i1 = ___syscall_ret(i1) | 0;
   break;
  }
 default:
  i1 = ___syscall_ret(-22) | 0;
 } while (0);
 if ((i11 | 0) == 4) {
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = i4;
  i1 = ___syscall_ret(___syscall307(307, i7 | 0) | 0) | 0;
 }
 STACKTOP = i12;
 return i1 | 0;
}

function __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (((i3 - i1 | 0) / 24 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i8 = i1 + 8 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i8 + 12 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 24 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 24 | 0) + i2 | 0;
 if (i5 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 24 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 89478485 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 178956970;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 24 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 24 | 0) * 24 | 0) | 0;
 i5 = i5 + (i3 * 24 | 0) | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  i1 = i4 + 24 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (((i3 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (((i3 - i1 | 0) / 20 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i8 = i1 + 4 + 4 | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 4 >> 2] = -1;
   i1 = (HEAP32[i9 >> 2] | 0) + 20 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 20 | 0) + i2 | 0;
 if (i5 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 20 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 107374182 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 214748364;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 20 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 20 | 0) * 20 | 0) | 0;
 i5 = i5 + (i3 * 20 | 0) | 0;
 i4 = i6;
 i1 = i6;
 do {
  i3 = i1 + 4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = -1;
  i1 = i4 + 20 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (((i3 | 0) / -20 | 0) * 20 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE4findIS2_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN15SerializeTraitsIN22NavMeshProjectSettings15NavMeshAreaDataEE8TransferI14SafeBinaryReadEEvRS1_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i2, 1); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 844257 | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine9Animation28SetBoundCurveInstanceIDValueERKNS0_10BoundCurveEi(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i2 = i7;
 if ((HEAP32[i6 + 4 >> 2] | 0) != 9) {
  i5 = HEAP32[i6 + 8 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i6 | 0, i4 | 0);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do if (!i4) i1 = 0; else {
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i5 = 8; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i8 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
    i2 = HEAP32[i8 + 28 >> 2] | 0;
    i3 = HEAP32[i8 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) break;
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 } while (0);
 i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = (HEAP32[i6 >> 2] | 0) != (i5 | 0);
 HEAP32[i6 >> 2] = i5;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 627;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 620;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 632;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 631;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i6 + 284 >> 2] | 0) + (i5 * 12 | 0) + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 & 2 | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i2 | 2;
 i4 = i6 + 360 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = i6 + 364 | 0;
 if ((i2 | 0) == (HEAP32[i1 >> 2] | 0)) {
  i13 = i6 + 332 | 0;
  i8 = i2 << 1;
  i14 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7 + 1 | 0, i2 << 5, gb + 681489 | 0, 1659) | 0;
  i12 = i14 + (i8 << 2) | 0;
  i3 = i14 + (i2 << 2 << 2) | 0;
  i9 = i14 + (i2 * 6 << 2) | 0;
  _memcpy(i14 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i6 + 336 >> 2] << 2 | 0) | 0;
  i11 = i6 + 340 | 0;
  _memcpy(i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i6 + 344 >> 2] << 2 | 0) | 0;
  i10 = i6 + 356 | 0;
  _memcpy(i3 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  i2 = i6 + 348 | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 + 352 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i13 >> 2] | 0);
  HEAP32[i13 >> 2] = i14;
  HEAP32[i11 >> 2] = i12;
  HEAP32[i10 >> 2] = i3;
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = i8;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i3 = HEAP32[i6 + 356 >> 2] | 0;
  i1 = i2;
 }
 HEAP32[i3 + (i1 << 2) >> 2] = i5;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP8[i6 + 477 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairINS1_IttEEfEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37152 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsINSt3__24pairIttEEE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14AsyncOperation15InvokeCoroutineEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i7 = i6 + 8 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i6 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i9 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 10;
   }
  }
  if ((i5 | 0) == 8) i5 = 10;
  if ((i5 | 0) == 10) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  mftCall_iii(HEAP32[i7 >> 2] | 0, i1 | 0, HEAP32[i6 + 16 >> 2] | 0) | 0;
 } while (0);
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_ii(i1 | 0, HEAP32[i6 + 16 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN10Matrix3x3f6InvertEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i20 = i2;
 HEAP32[i20 >> 2] = HEAP32[i1 >> 2];
 i18 = i1 + 4 | 0;
 i19 = i20 + 4 | 0;
 HEAP32[i19 >> 2] = HEAP32[i18 >> 2];
 i16 = i1 + 8 | 0;
 i17 = i20 + 8 | 0;
 HEAP32[i17 >> 2] = HEAP32[i16 >> 2];
 HEAPF32[i20 + 12 >> 2] = Math_fround(0.0);
 i14 = i1 + 12 | 0;
 i15 = i20 + 16 | 0;
 HEAP32[i15 >> 2] = HEAP32[i14 >> 2];
 i12 = i1 + 16 | 0;
 i13 = i20 + 20 | 0;
 HEAP32[i13 >> 2] = HEAP32[i12 >> 2];
 i10 = i1 + 20 | 0;
 i11 = i20 + 24 | 0;
 HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
 HEAPF32[i20 + 28 >> 2] = Math_fround(0.0);
 i8 = i1 + 24 | 0;
 i9 = i20 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 i6 = i1 + 28 | 0;
 i7 = i20 + 36 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 i4 = i1 + 32 | 0;
 i5 = i20 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i3 = i20 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i20 + 60 >> 2] = Math_fround(1.0);
 i3 = __Z20InvertMatrix4x4_FullPKfPf(i20, i20) | 0;
 HEAP32[i1 >> 2] = HEAP32[i20 >> 2];
 HEAP32[i18 >> 2] = HEAP32[i19 >> 2];
 HEAP32[i16 >> 2] = HEAP32[i17 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 STACKTOP = i2;
 return i3 | 0;
}

function __Z28GUIStyle_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i3 = i9 + 16 | 0;
 i8 = i9 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i7) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 __ZNK11ICallString6ToUTF8Ev(i8, i3);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i5 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i3 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i7 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i7 + 4 >> 2] = i6;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return;
 }
}

function __ZNK9Texture2D16GetPixelBilinearEiff(i8, i6, i3, f4, f5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i9 = i10 + 4 | 0;
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i6) | 0)) {
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i6 + 52 >> 2] | 0;
 if ((i3 | 0) >= 0) {
  if (!i1) i2 = 0; else i2 = HEAP32[i1 + 44 >> 2] | 0;
  if ((i2 | 0) > (i3 | 0)) {
   i9 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i3) | 0;
   __Z21GetImagePixelBilinearPKhii13TextureFormat15TextureWrapModeff(i8, (HEAP32[i1 + 8 >> 2] | 0) + i9 | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, HEAP32[i6 + 44 >> 2] | 0, f4, f5);
   STACKTOP = i10;
   return;
  }
 }
 if (!i1) i1 = -1; else i1 = (HEAP32[i1 + 44 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i1;
 __Z6FormatPKcz(i9, gb + 416925 | 0, i7);
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 410682 | 0, 1216, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 HEAPF32[i8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i10;
 return;
}

function __ZNK27StateMachineBehaviourPlayer24FindStateBehavioursRangeERK8StateKey(i12, i1, i10) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i13 = 0;
 i11 = i1 + 8 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0) | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i9 = HEAP32[i9 + 8 >> 2] | 0;
 i1 = i9 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i7 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i10 + 4 >> 2] | 0;
  i6 = i1;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = (i6 | 0) / 2 | 0;
   i4 = i3 + (i2 << 4) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) == (i7 | 0)) {
    if ((HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0) < (i8 | 0)) i13 = 7;
   } else if (i5 >>> 0 < i7 >>> 0) i13 = 7;
   if ((i13 | 0) == 7) {
    i13 = 0;
    i3 = i4 + 16 | 0;
    i2 = i6 + -1 - i2 | 0;
    i1 = i3;
   }
   if (!i2) break; else i6 = i2;
  }
 }
 do if ((i1 | 0) == (i9 | 0)) i13 = 12; else {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) if ((HEAP32[i10 + 4 >> 2] | 0) < (HEAP32[i1 + 4 >> 2] | 0)) {
   i13 = 12;
   break;
  } else break; else if (i2 >>> 0 < i3 >>> 0) {
   i13 = 12;
   break;
  } else break;
 } while (0);
 if ((i13 | 0) == 12) i1 = i9;
 i13 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0) | 0) + 8 >> 2] | 0)) {
  HEAP32[i12 >> 2] = 0;
  HEAP32[i12 + 4 >> 2] = 0;
  return;
 } else {
  i10 = i1 + 8 | 0;
  i11 = HEAP32[i10 + 4 >> 2] | 0;
  i13 = i12;
  HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i13 + 4 >> 2] = i11;
  return;
 }
}

function __ZNK16MemoryFileSystem12LockFileDataEPKcPPvPy(i2, i1, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i4 = i7;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i2 = 0; else i2 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 if (!i2) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i4 = getTempRet0() | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 i6 = HEAP32[i2 >> 2] | 0;
 i6 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i5 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4trsXEEEclERS3_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4AxesEEEclERS3_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx9PxTaskMgr12finishBeforeERNS_6PxTaskEj(i3, i1, i10) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i9 = i3 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = i3 + 76 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i3 + 64 | 0;
 i1 = i3 + 68 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = -1;
 if ((HEAP32[i3 + 72 >> 2] & 2147483647) >>> 0 > i8 >>> 0) {
  i12 = i2;
  i2 = HEAP32[i12 + 4 >> 2] | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + (i8 << 3) | 0;
  HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_17PxTaskDepTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i7, i2) | 0;
 i1 = i6 + (i4 * 20 | 0) + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i6 + (i4 * 20 | 0) + 12 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i12 = i12 + (i10 * 20 | 0) + 4 | 0;
  __ZN5physx6shdfnd15atomicIncrementEPVi(i12) | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 3) + 4 >> 2] = i8;
  HEAP32[i1 >> 2] = i8;
  i12 = HEAP32[i5 >> 2] | 0;
  i12 = i12 + (i10 * 20 | 0) + 4 | 0;
  __ZN5physx6shdfnd15atomicIncrementEPVi(i12) | 0;
  i12 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f14 = Math_fround(f8 + f8);
 f15 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f15 + f15);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f13 + f13);
 f10 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(f14 * f10);
 f7 = Math_fround(f5 * f10);
 f10 = Math_fround(f10 * f9);
 f17 = Math_fround(f8 * f5);
 f16 = Math_fround(f8 * f9);
 f5 = Math_fround(f15 * f5);
 f15 = Math_fround(f15 * f9);
 f9 = Math_fround(f13 * f9);
 f13 = Math_fround(Math_fround(Math_fround(1.0) - f5) - f9);
 f12 = Math_fround(f17 + f10);
 f11 = Math_fround(f16 - f7);
 f10 = Math_fround(f17 - f10);
 f14 = Math_fround(Math_fround(1.0) - Math_fround(f8 * f14));
 f9 = Math_fround(f14 - f9);
 f8 = Math_fround(f15 + f6);
 f7 = Math_fround(f16 + f7);
 f6 = Math_fround(f15 - f6);
 f5 = Math_fround(f14 - f5);
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 HEAPF32[i1 >> 2] = f13;
 HEAPF32[i1 + 4 >> 2] = f12;
 HEAPF32[i1 + 8 >> 2] = f11;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i1 + 16 >> 2] = f10;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = f7;
 HEAPF32[i1 + 36 >> 2] = f6;
 HEAPF32[i1 + 40 >> 2] = f5;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = i4;
 HEAP32[i1 + 52 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __Z31WWW_CUSTOM_GetAudioClipInternalP12Il2CppObjecthhhi(i2, i1, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = __Z9GetIAudiov() | 0;
 if (!i3) {
  i8 = 0;
  STACKTOP = i5;
  return i8 | 0;
 }
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i4);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i4);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 580408 | 0, 286, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i5;
  return i8 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) {
  i4 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63328 | 0, 16, gb + 580408 | 0, 298) | 0;
  HEAP32[i4 >> 2] = gb + 71808 + 8;
  HEAP32[i4 + 4 >> 2] = i1;
  __ZN3WWW6RetainEv(i1);
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0;
  i8 = mftCall_iiiiiii(i2 | 0, i3 | 0, i4 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0, i6 << 24 >> 24 != 0 | 0, i7 << 24 >> 24 != 0 | 0, i8 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i8 | 0);
  i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(i8) | 0;
  STACKTOP = i5;
  return i8 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580504 | 0, 0, gb + 580408 | 0, 293, 1, 0, 0, 0);
  i8 = 0;
  STACKTOP = i5;
  return i8 | 0;
 }
 return 0;
}

function _UNITY_FT_Get_Glyph(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 if (!i6) {
  i8 = 37;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i8) {
  i8 = 6;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i6 + 72 >> 2] | 0;
 L7 : do if ((i1 | 0) < 1869968492) {
  switch (i1 | 0) {
  case 1651078259:
   break;
  default:
   {
    i2 = 6;
    break L7;
   }
  }
  i3 = (HEAP32[i5 + 188 >> 2] | 0) + 36 | 0;
 } else {
  switch (i1 | 0) {
  case 1869968492:
   break;
  default:
   {
    i2 = 6;
    break L7;
   }
  }
  i3 = (HEAP32[i5 + 188 >> 2] | 0) + 4 | 0;
 } while (0);
 if ((i2 | 0) == 6) {
  i1 = _UNITY_FT_Lookup_Renderer(i5, i1, 0) | 0;
  if (!i1) {
   i8 = 18;
   STACKTOP = i9;
   return i8 | 0;
  } else i3 = i1 + 20 | 0;
 }
 i7 = _UNITY_ft_mem_alloc(HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 64 >> 2] << 10;
 HEAP32[i7 + 16 >> 2] = HEAP32[i6 + 68 >> 2] << 10;
 i3 = mftCall_iii(HEAP32[i3 + 8 >> 2] | 0, i7 | 0, i6 | 0) | 0;
 if (!i3) {
  HEAP32[i8 >> 2] = i7;
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i7 | 0);
 _UNITY_ft_mem_free(i2, i7);
 i8 = i3;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN24OcclusionCullingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i9);
 __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 72 | 0, i9);
 __ZN4PPtrI20OcclusionCullingDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 28 | 0, i9);
 i4 = i5 + 44 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i9 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  __ZN4PPtrI8RendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i5 + 64 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = HEAP32[i5 + 52 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 do {
  __ZN4PPtrI15OcclusionPortalE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i5 = i8 + 68 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i8 + 56 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i5 << 4) | 0;
 if (i5 | 0) do {
  __ZN11KeyframeTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i8 + 76 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i8 + 84 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  STACKTOP = i10;
  return;
 }
}

function __ZN10HumanTrait17RequiredBoneCountEv() {
 var i1 = 0;
 i1 = (__ZN7mecanim5human12RequiredBoneEj(0) | 0) & 1;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(1) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(2) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(3) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(4) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(5) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(6) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(7) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(8) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(9) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(10) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(11) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(12) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(13) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(14) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(15) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(16) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(17) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(18) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(19) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(20) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(21) | 0) & 1) + i1 | 0;
 i1 = ((__ZN7mecanim5human12RequiredBoneEj(22) | 0) & 1) + i1 | 0;
 return ((__ZN7mecanim5human12RequiredBoneEj(23) | 0) & 1) + i1 | 0;
}

function __ZL21SetAnisoLimitEnumImplN7Texture20AnisotropicFilteringEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 i7 = i8 + 16 | 0;
 if (!((HEAP32[gb + 55816 >> 2] | 0) != (i1 | 0) | i2)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[gb + 55816 >> 2] = i1;
 switch (i1 | 0) {
 case 0:
  {
   __ZN15TextureSettings14SetAnisoLimitsEii(1, 1);
   break;
  }
 case 2:
  {
   __ZN15TextureSettings14SetAnisoLimitsEii(HEAP32[gb + 55820 >> 2] | 0, HEAP32[gb + 55824 >> 2] | 0);
   break;
  }
 default:
  __ZN15TextureSettings14SetAnisoLimitsEii(1, HEAP32[gb + 55824 >> 2] | 0);
 }
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = 0;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i1 = i5;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 26572 | 0, i7, 0);
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 92 >> 2] | 0, i6 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i4);
  HEAP32[i7 >> 2] = 0;
 }
 STACKTOP = i8;
 return;
}

function __Z13ClipAnimationR13AnimationClipS0_ffb(i1, i2, f3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f3 > f4;
 f3 = (HEAP32[tempDoublePtr >> 2] = i8 ? i6 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = (HEAP32[tempDoublePtr >> 2] = i8 ? i7 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i1 + 88 | 0;
 __Z14ClipAnimationsI11QuaternionfN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1 + 100 | 0, f3, f4, Math_fround(HEAPF32[i6 >> 2]), i5, i2 + 100 | 0);
 __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1 + 116 | 0, f3, f4, Math_fround(HEAPF32[i6 >> 2]), i5, i2 + 116 | 0);
 __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1 + 132 | 0, f3, f4, Math_fround(HEAPF32[i6 >> 2]), i5, i2 + 132 | 0);
 __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_(i1 + 148 | 0, f3, f4, Math_fround(HEAPF32[i6 >> 2]), i5, i2 + 148 | 0);
 __Z14ClipAnimationsIfN13AnimationClip10FloatCurveE13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRS9_(i1 + 164 | 0, f3, f4, Math_fround(HEAPF32[i6 >> 2]), i5, i2 + 164 | 0);
 return;
}

function _cmyk_ycck_convert(i1, i3, i15, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i15 = i15 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0, i17 = 0, i18 = 0, i19 = 0;
 i16 = HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 8 >> 2] | 0;
 i11 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i12 = i15 + 4 | 0;
 i13 = i15 + 8 | 0;
 i14 = i15 + 12 | 0;
 if (!i11) return;
 while (1) {
  i6 = i4;
  i4 = i4 + -1 | 0;
  i7 = HEAP32[(HEAP32[i15 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i8 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i9 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i10 = HEAP32[(HEAP32[i14 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i1 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  while (1) {
   i18 = (HEAPU8[i5 >> 0] | 0) ^ 255;
   i19 = (HEAPU8[i5 + 1 >> 0] | 0) ^ 255;
   i17 = (HEAPU8[i5 + 2 >> 0] | 0) ^ 255;
   HEAP8[i10 + i1 >> 0] = HEAP8[i5 + 3 >> 0] | 0;
   HEAP8[i7 + i1 >> 0] = ((HEAP32[i16 + ((i19 | 256) << 2) >> 2] | 0) + (HEAP32[i16 + (i18 << 2) >> 2] | 0) + (HEAP32[i16 + ((i17 | 512) << 2) >> 2] | 0) | 0) >>> 16;
   HEAP8[i8 + i1 >> 0] = ((HEAP32[i16 + ((i19 | 1024) << 2) >> 2] | 0) + (HEAP32[i16 + ((i18 | 768) << 2) >> 2] | 0) + (HEAP32[i16 + ((i17 | 1280) << 2) >> 2] | 0) | 0) >>> 16;
   HEAP8[i9 + i1 >> 0] = ((HEAP32[i16 + ((i19 | 1536) << 2) >> 2] | 0) + (HEAP32[i16 + ((i18 | 1280) << 2) >> 2] | 0) + (HEAP32[i16 + ((i17 | 1792) << 2) >> 2] | 0) | 0) >>> 16;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i11 | 0)) break; else i5 = i5 + 4 | 0;
  }
  if ((i6 | 0) <= 1) break; else {
   i2 = i2 + 1 | 0;
   i3 = i3 + 4 | 0;
  }
 }
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN8Animator27ClearBindingsOnDomainReloadEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 i2 = i9 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 67008 | 0, i2, 0);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = i6 + 604 | 0;
   i8 = i6 + 620 | 0;
   if ((HEAP32[i8 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i6 + 608 | 0);
    HEAP32[i7 >> 2] = 0;
   }
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 + 616 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i8 = i6 + 168 | 0;
   __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i8 >> 2] | 0, i6 + 176 | 0);
   HEAP32[i6 + 172 >> 2] = 0;
   HEAP32[i8 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 643;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN16PackedQuatVector8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 899457 | 0, HEAP32[gb + 37304 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i7, i2, 0); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37008 >> 2] | 0, gb + 469407 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z25PxLocationHitToRaycastHitRKN5physx13PxLocationHitER10RaycastHit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i1 + 4 | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 i6 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = i2 + 12 | 0;
 i7 = i1 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 >> 2] = 5;
 HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 28 >> 2] = Math_fround(1.0);
 i6 = i3 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i3 | 0) | 0)) {
  i7 = -1;
  i6 = i2 + 24 | 0;
  HEAP32[i6 >> 2] = i7;
  i6 = i1 + 40 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i2 + 28 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i3 + 36 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0, i7 | 0) | 0;
 i7 = HEAP32[i7 + (HEAP32[i1 + 8 >> 2] << 2) >> 2] | 0;
 i6 = i2 + 24 | 0;
 HEAP32[i6 >> 2] = i7;
 i6 = i1 + 40 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i2 + 28 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i4;
 return;
}

function __ZN8Playable7ProcessEiRK9FrameDataP14DirectorPlayerPv(i8, i1, i9, i2, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 280 | 0;
 i3 = i7 + 248 | 0;
 i4 = i7;
 i5 = i7 + 240 | 0;
 i2 = i8 + 24 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 if (!(i1 << 16 >> 16)) {
  i1 = __Z18GetDirectorManagerv() | 0;
  i1 = __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass(i1, __Z26scripting_object_get_classP12Il2CppObject(HEAP32[i8 + 4 >> 2] | 0) | 0) | 0;
  HEAP16[i2 >> 1] = i1;
 }
 if (i1 << 16 >> 16 <= 0) {
  STACKTOP = i7;
  return;
 }
 i1 = __Z18GetDirectorManagerv() | 0;
 i1 = (__ZNK15DirectorManager16GetScriptMethodsEs(i1, HEAP16[i2 >> 1] | 0) | 0) + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 + 24 >> 2] = HEAP32[i9 + 56 >> 2];
 HEAPF64[i3 + 16 >> 3] = +HEAPF64[i9 + 32 >> 3];
 HEAPF64[i3 + 8 >> 3] = +HEAPF64[i9 + 8 >> 3];
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i1;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i8, i6);
 __ZN18ScriptingArguments9AddStructEPKv(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, HEAP32[i9 + 68 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN19RuntimeSceneManager22EndIntegrateMainThreadEP10UnityScene(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = i7 + 60 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 i11 = i10 + 80 | 0;
 HEAP32[i11 >> 2] = 2;
 i4 = i7 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = i7 + 36 | 0;
 i12 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i12 << 2) | 0;
 L1 : do if (!i12) i9 = 4; else do {
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i9 = 4;
   break L1;
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i6 | 0)); while (0);
 if ((i9 | 0) == 4) if ((i2 | 0) != (i6 | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
  i1 = i2 + 4 | 0;
  _memmove(i2 | 0, i1 | 0, (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) - i1 | 0) | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i1 + -1;
 i1 = i7 + 44 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 if ((i10 | 0) == 0 | (HEAP32[i11 >> 2] | 0) != 2) return;
 HEAP32[i1 >> 2] = i10;
 __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(i10);
 i5 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i5 + 37052 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return; else i1 = 0;
 do {
  i4 = i5 + 36284 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i5 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i4 >> 2] | 0, 0, i2 | 0); else mftCall_viii(HEAP32[i4 >> 2] | 0, HEAP32[i5 + 36284 + (i1 * 12 | 0) + 4 >> 2] | 0, 0, i2 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager10InitializeERK8UnityStrPNS0_18ICloudJobSchedulerE(i11, i12, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (HEAP32[i11 >> 2] | 0) {
  i12 = 0;
  return i12 | 0;
 }
 HEAP32[i11 + 32 >> 2] = i1;
 HEAP32[i11 + 552 >> 2] = 4;
 i9 = i12 + 11 | 0;
 i10 = i12 + 4 | 0;
 i6 = 0;
 do {
  i1 = i11 + 40 + (i6 << 7) | 0;
  __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i1);
  HEAP16[i11 + 40 + (i6 << 7) + 104 >> 1] = i6;
  HEAP32[i11 + 40 + (i6 << 7) + 32 >> 2] = i11;
  do if ((i1 | 0) != (i12 | 0)) {
   i8 = HEAP8[i9 >> 0] | 0;
   i4 = i8 << 24 >> 24 < 0;
   i7 = i4 ? HEAP32[i12 >> 2] | 0 : i12;
   i8 = i4 ? HEAP32[i10 >> 2] | 0 : i8 & 255;
   i4 = i1 + 11 | 0;
   i2 = HEAP8[i4 >> 0] | 0;
   i3 = i2 << 24 >> 24 < 0;
   if (i3) i5 = (HEAP32[i11 + 40 + (i6 << 7) + 8 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
   if (i8 >>> 0 > i5 >>> 0) {
    if (i3) i2 = HEAP32[i11 + 40 + (i6 << 7) + 4 >> 2] | 0; else i2 = i2 & 255;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
    break;
   }
   if (i3) i1 = HEAP32[i1 >> 2] | 0;
   if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
   HEAP8[i1 + i8 >> 0] = 0;
   if ((HEAP8[i4 >> 0] | 0) < 0) {
    HEAP32[i11 + 40 + (i6 << 7) + 4 >> 2] = i8;
    break;
   } else {
    HEAP8[i4 >> 0] = i8;
    break;
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 4);
 HEAP32[i11 >> 2] = 3;
 i12 = 1;
 return i12 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher34OnSessionContainerArchivedAndReadyERNS0_16SessionContainerE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 16 | 0;
 i3 = i8;
 i1 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i3 + 11 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 i5 = i1 + 11 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i6 + 40 >> 2] = 0; else HEAP8[i5 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i5 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 }
 i2 = i6 + 52 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i2 >> 0] = 0;
 HEAP8[i7 + 88 >> 0] = 1;
 HEAP8[i7 + 90 >> 0] = 1;
 i1 = i6 + 128 | 0;
 HEAP32[i1 >> 2] = i7;
 if (__ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE(i6, i7) | 0) {
  STACKTOP = i8;
  return;
 }
 __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i7, i7 + 16 | 0) | 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i7);
 HEAP32[i1 >> 2] = 0;
 HEAP8[i2 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function __ZN11AudioSource32CorrectScheduledTimeAfterUnpauseEy(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i7 = i8;
 i5 = i2 + 456 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP16[i2 + 498 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance8getDelayE14FMOD_DELAYTYPEPjS1_(i1, 1, i6, i7) | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  i1 = i9 + i3 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4 + (i1 >>> 0 < i9 >>> 0 & 1);
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 1, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  i1 = HEAP8[i2 + 499 >> 0] | 0;
 }
 if (i1 << 24 >> 24) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance8getDelayE14FMOD_DELAYTYPEPjS1_(i1, 2, i6, i7) | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  i1 = i9 + i3 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i4 + (i1 >>> 0 < i9 >>> 0 & 1);
  HEAP32[i7 >> 2] = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 2, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 }
 STACKTOP = i8;
 return;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i6 = i8 + 44 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2) {
  i5 = 0;
  do {
   i4 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
   if (i4) {
    i1 = HEAP32[i4 + 320 >> 2] | 0;
    if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
    i1 = i4 + 52 | 0;
    i2 = i4 + 60 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) {
     i9 = i4 + 56 | 0;
     i10 = HEAP32[i9 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i3;
     HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i10;
     HEAP32[i9 >> 2] = i1;
     HEAP32[i2 >> 2] = i1;
    }
    i1 = i4 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i4 + 24 | 0)) {
     i10 = HEAP32[i4 + 28 >> 2] | 0;
     HEAP32[i10 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i10;
    }
    __ZdlPv(i4);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i8 + 28 | 0;
 i2 = i8 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i10 = i8 + 32 | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i8 + 16 | 0;
 i2 = i8 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i10 = i8 + 20 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i9;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function _log2(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = (i3 | 0) < 0;
 do if (i4 | i3 >>> 0 < 1048576) {
  if ((i2 | 0) == 0 & (i3 & 2147483647 | 0) == 0) {
   d1 = -1.0 / (d1 * d1);
   break;
  }
  if (i4) {
   d1 = (d1 - d1) / 0.0;
   break;
  } else {
   HEAPF64[tempDoublePtr >> 3] = d1 * 18014398509481984.0;
   i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
   i4 = -1077;
   i2 = HEAP32[tempDoublePtr >> 2] | 0;
   i5 = 9;
   break;
  }
 } else if (i3 >>> 0 <= 2146435071) if ((i2 | 0) == 0 & 0 == 0 & (i3 | 0) == 1072693248) d1 = 0.0; else {
  i4 = -1023;
  i5 = 9;
 } while (0);
 if ((i5 | 0) == 9) {
  i5 = i3 + 614242 | 0;
  HEAP32[tempDoublePtr >> 2] = i2;
  HEAP32[tempDoublePtr + 4 >> 2] = (i5 & 1048575) + 1072079006;
  d10 = +HEAPF64[tempDoublePtr >> 3] + -1.0;
  d8 = d10 * (d10 * .5);
  d7 = d10 / (d10 + 2.0);
  d9 = d7 * d7;
  d1 = d9 * d9;
  HEAPF64[tempDoublePtr >> 3] = d10 - d8;
  i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i3;
  d6 = +HEAPF64[tempDoublePtr >> 3];
  d1 = d10 - d6 - d8 + d7 * (d8 + (d1 * (d1 * (d1 * .15313837699209373 + .22222198432149784) + .3999999999940942) + d9 * (d1 * (d1 * (d1 * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735)));
  d9 = d6 * 1.4426950407214463;
  d8 = +(i4 + (i5 >>> 20) | 0);
  d7 = d8 + d9;
  d1 = d7 + (d9 + (d8 - d7) + (d1 * 1.4426950407214463 + (d6 + d1) * 1.6751713164886512e-10));
 }
 return +d1;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i1 + 8 | 0;
 __THREW__ = 0;
 i3 = invoke_ii(fb + 2805 | 0, HEAP32[i2 >> 2] | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) i5 = 16; else {
  __THREW__ = 0;
  i4 = invoke_iiii(fb + 507 | 0, 0, 0, 4) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   if (!i3) break;
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (!(i7 & 1)) break;
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  }
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   }
  }
  if (!i4) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i6 = 1; else {
    __THREW__ = 0;
    i1 = invoke_ii(fb + 2805 | 0, i1 | 0) | 0;
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i5 = 16;
     break;
    }
    if (!i1) i6 = 0; else {
     __THREW__ = 0;
     invoke_ii(fb + 2805 | 0, i1 | 0) | 0;
     i7 = __THREW__;
     __THREW__ = 0;
     if (i7 & 1) {
      i7 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i7);
     } else i6 = 0;
    }
   }
  } else i6 = -1;
  return i6 | 0;
 } while (0);
 if ((i5 | 0) == 16) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
 }
 ___clang_call_terminate(i1);
 return 0;
}

function __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (HEAP8[HEAP32[i2 >> 2] >> 0] | 0) {
 case 110:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 116:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 102:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 34:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b(i1, i2, i3, 0);
   return;
  }
 case 123:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 case 91:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 default:
  {
   __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_(i1, i2, i3);
   return;
  }
 }
}

function __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i4, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 4 | 0, i5);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 12 | 0, i5);
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4 + 20 | 0, i5);
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  i7 = i4 + 28 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i7 = i4 + 28 | 0;
  __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 }
}

function __ZN9JSONWriteD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = HEAP32[i8 + 104 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 + 116 >> 2] | 0, gb + 64016 | 0);
 i1 = HEAP32[i8 + 112 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i8 + 80 | 0);
 i1 = i8 + 60 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i8 + 72 >> 2] | 0;
  HEAP32[i7 >> 2] = 66;
  HEAP32[i7 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 }
 i1 = i8 + 36 | 0;
 if ((HEAP32[i8 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 40 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i6 = i8 + 16 | 0;
 if ((HEAP32[i8 + 32 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i8 + 28 >> 2] | 0;
 if (i3) {
  i4 = i7 + 4 | 0;
  i2 = 0;
  do {
   i5 = i1 + (i2 * 40 | 0) + 24 | 0;
   if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
    i5 = HEAP32[i5 >> 2] | 0;
    i10 = HEAP32[i1 + (i2 * 40 | 0) + 36 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i4 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i5, i7);
   }
   __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i1 + (i2 * 40 | 0) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8 + 20 | 0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 4;
  i2 = i7 + 80 | 0;
  if (i1 >>> 0 < 81 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 832492 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 88 >> 2] | 0;
 i4 = i1 + (i3 << 4) | 0;
 i5 = i7 + 84 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   i2 = i2 + 16 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 16 | 0;
  }
 }
 i2 = i7 + 92 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 80 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx2Sc15ArticulationSim22updateCachedTransformsERNS_17PxsTransformCacheEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i1, i11, i9) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i1 + 28 | 0;
 if (!(HEAP32[i10 >> 2] | 0)) return;
 i8 = i1 + 24 | 0;
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 if (!i9) {
  i1 = 0;
  do {
   __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0, i11);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  return;
 } else i7 = 0;
 do {
  __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0, i11);
  i4 = HEAP32[(HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] | 0) + 136 >> 2] | 0;
  if ((i4 | 0) != 1073741823) {
   i2 = (i4 + 32 | 0) >>> 5;
   if (i2 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
    i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i2 << 2, gb + 769739 | 0, 329) | 0;
    i3 = HEAP32[i9 >> 2] | 0;
    if (i3 | 0) {
     _memcpy(i1 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
     if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i9 >> 2] | 0);
    }
    i3 = HEAP32[i5 >> 2] | 0;
    _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i2 - i3 << 2 | 0) | 0;
    HEAP32[i9 >> 2] = i1;
    HEAP32[i5 >> 2] = i2;
   } else i1 = HEAP32[i9 >> 2] | 0;
   i3 = i1 + (i4 >>> 5 << 2) | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i4 & 31);
  }
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 return;
}

function __ZN27AnimationLayerMixerPlayable18SetInputConnectionEP8Playablei(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = __ZN8Playable18SetInputConnectionEPS_i(i7, i1, i2) | 0;
 HEAP8[i7 + 56 >> 0] = 1;
 if (!i6) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = i7 + 100 | 0;
 i5 = HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i1 = i7 + 112 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i2 = i7 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i5 * 12 | 0, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 12 | 0, 4, i7 + 104 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i4 >> 2] = i7;
  break;
 } while (0);
 if (i5 >>> 0 > i6 >>> 0) {
  i3 = (HEAP32[i4 >> 2] | 0) + (i6 * 12 | 0) | 0;
  i2 = i5 - i6 | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    i7 = i3 + (i1 * 12 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
    HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN21ArchiveStorageCreatorC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN12FileAccessorC2Ev(i1 + 12 | 0);
 HEAP32[i1 + 1084 >> 2] = 0;
 HEAP32[i1 + 1088 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1092 >> 2] = 0;
 HEAP32[i1 + 1080 >> 2] = i1 + 1084;
 __ZN20ArchiveStorageHeader6HeaderC2Ev(i1 + 1096 | 0);
 HEAP32[i1 + 1192 >> 2] = 0;
 HEAP32[i1 + 1196 >> 2] = 0;
 HEAP32[i1 + 1200 >> 2] = 0;
 HEAP32[i1 + 1204 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1208 >> 2] = 0;
 HEAP32[i1 + 1212 >> 2] = 0;
 HEAP32[i1 + 1216 >> 2] = 0;
 HEAP32[i1 + 1220 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAP32[i1 + 1252 >> 2] = 5;
 i6 = i1 + 1256 | 0;
 HEAP32[i1 + 1280 >> 2] = 0;
 HEAP32[i1 + 1284 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 1272 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 1288 >> 2] = 0;
 HEAP32[i1 + 1300 >> 2] = 0;
 HEAP32[i1 + 1304 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 1292 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i1 + 1320 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function _find_charmap(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = HEAP8[i8 >> 0] | 0;
 i10 = i9 << 24 >> 24 == 0;
 i1 = gb + 1069354 | 0;
 while (1) {
  L3 : do if (i10) {
   i3 = i1;
   i2 = 0;
   i11 = 9;
  } else {
   i4 = i8;
   i3 = i1;
   i2 = i9;
   while (1) {
    i7 = HEAP8[i3 >> 0] | 0;
    if (!(i7 << 24 >> 24)) {
     i11 = 9;
     break L3;
    }
    i6 = i4;
    i4 = i2;
    i2 = i2 & 255;
    while (1) {
     if (!((i2 + -48 | 0) >>> 0 > 10 & ((i2 | 32) + -97 | 0) >>> 0 > 26)) {
      i2 = i6;
      break;
     }
     i2 = i6 + 1 | 0;
     i5 = HEAP8[i2 >> 0] | 0;
     if (!(i5 << 24 >> 24)) {
      i4 = 0;
      break;
     } else {
      i6 = i2;
      i4 = i5;
      i2 = i5 & 255;
     }
    }
    if ((i4 & 255 | 32 | 0) != (i7 & 255 | 0)) break L3;
    i4 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
    i2 = HEAP8[i4 >> 0] | 0;
    if (!(i2 << 24 >> 24)) {
     i2 = 0;
     i11 = 9;
     break;
    }
   }
  } while (0);
  if ((i11 | 0) == 9) {
   i11 = 0;
   if (i2 << 24 >> 24 == (HEAP8[i3 >> 0] | 0)) {
    i11 = 10;
    break;
   }
  }
  i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
  do if (!(HEAP8[i1 >> 0] | 0)) {
   i2 = HEAP8[i1 + 1 >> 0] | 0;
   if ((i2 & 255) > 128) {
    i1 = i1 + 2 | 0;
    break;
   } else {
    i1 = i1 + ((((128 - (i2 & 255) | 0) >>> 2) * 5 | 0) + 2) | 0;
    break;
   }
  } while (0);
  if (!(HEAP8[i1 >> 0] | 0)) {
   i1 = -1;
   break;
  }
 }
 if ((i11 | 0) == 10) {
  if (HEAP8[i1 >> 0] | 0) do i1 = i1 + ((_strlen(i1) | 0) + 1) | 0; while ((HEAP8[i1 >> 0] | 0) != 0);
  i1 = i1 + 1 - (gb + 1069354) | 0;
 }
 return i1 | 0;
}

function __ZnwjRK10MemLabelIdiPKcS3_S3_i(i7, i6, i3, i9, i10, i4, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i11 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i11 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i11;
  if (i11 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i2 = i1;
   break;
  }
 } else i2 = i1; while (0);
 i2 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i2, i7, i3, i6, 0, i4, i5) | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i11 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i11;
  if (i11 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i8 = i1;
   break;
  }
 } else i8 = i1; while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) < 128) {
  i11 = HEAP32[i8 + 3824 + (i1 * 24 | 0) >> 2] | 0;
  i8 = HEAP32[gb + 1163236 >> 2] | 0;
  __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i8, i2, i7, i11, i9, i10);
  __Z20push_allocation_rootPvP13BaseAllocatorb(i2, i11, 1) | 0;
  return i2 | 0;
 } else {
  i11 = HEAP32[i8 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i11 = i11 >>> 0 > 512 >>> 0 ? i11 : 0;
  i8 = HEAP32[gb + 1163236 >> 2] | 0;
  __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i8, i2, i7, i11, i9, i10);
  __Z20push_allocation_rootPvP13BaseAllocatorb(i2, i11, 1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZnajRK10MemLabelIdiPKcS3_S3_i(i7, i6, i3, i9, i10, i4, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i11 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i11 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i11;
  if (i11 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i2 = i1;
   break;
  }
 } else i2 = i1; while (0);
 i2 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i2, i7, i3, i6, 0, i4, i5) | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i11 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i11;
  if (i11 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i8 = i1;
   break;
  }
 } else i8 = i1; while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) < 128) {
  i11 = HEAP32[i8 + 3824 + (i1 * 24 | 0) >> 2] | 0;
  i8 = HEAP32[gb + 1163236 >> 2] | 0;
  __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i8, i2, i7, i11, i9, i10);
  __Z20push_allocation_rootPvP13BaseAllocatorb(i2, i11, 1) | 0;
  return i2 | 0;
 } else {
  i11 = HEAP32[i8 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i11 = i11 >>> 0 > 512 >>> 0 ? i11 : 0;
  i8 = HEAP32[gb + 1163236 >> 2] | 0;
  __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i8, i2, i7, i11, i9, i10);
  __Z20push_allocation_rootPvP13BaseAllocatorb(i2, i11, 1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i6, i7, i4, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i2 = Math_imul(HEAP32[i10 + (i3 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i3 << 3) >> 2] | 0) | 0;
 i9 = (i2 | 0) > (Math_imul(HEAP32[i10 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i5 << 3) >> 2] | 0) | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (Math_imul(HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i1 << 3) >> 2] | 0) | 0) > (i2 | 0);
 if (!i9) {
  if (!i2) {
   i10 = 0;
   return i10 | 0;
  }
  HEAP32[i7 >> 2] = i1;
  HEAP32[i4 >> 2] = i3;
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
  i9 = Math_imul(HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i1 << 3) >> 2] | 0) | 0;
  if ((i9 | 0) <= (Math_imul(HEAP32[i10 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i2 << 3) >> 2] | 0) | 0)) {
   i10 = 1;
   return i10 | 0;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i10 = 2;
  return i10 | 0;
 }
 if (i2) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = i5;
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i6 >> 2] = i3;
 HEAP32[i7 >> 2] = i5;
 i1 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
 i9 = Math_imul(HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i1 << 3) >> 2] | 0) | 0;
 if ((i9 | 0) <= (Math_imul(HEAP32[i10 + (i5 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i5 << 3) >> 2] | 0) | 0)) {
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i4 >> 2] = i5;
 i10 = 2;
 return i10 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i11 = __Znwj(36) | 0;
 i7 = i1 + 4 | 0;
 i8 = i11;
 i1 = i11 + 16 | 0;
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i11 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i11 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i11 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 >> 2] = i8;
 i12 = i9 + 4 | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = 1;
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i11 = __Znwj(36) | 0;
 i7 = i1 + 4 | 0;
 i8 = i11;
 i1 = i11 + 16 | 0;
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i11 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i11 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i11 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 >> 2] = i8;
 i12 = i9 + 4 | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = 1;
 STACKTOP = i13;
 return;
}

function __ZNSt3__217moneypunct_bynameIwLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 212028 + 8;
 i5 = i6 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4533 | 0, i6 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIwLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211972 + 8;
 i5 = i6 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4531 | 0, i6 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIcLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211916 + 8;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4530 | 0, i6 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIcLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211860 + 8;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4528 | 0, i6 | 0, ((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i4 + 16 | 0;
 i5 = i4;
 __ZL19GetCameraTargetRectRK6Camerab(i10, i2, 1);
 f9 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f12 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f9 = Math_fround(f9 * f12);
 f7 = Math_fround(f7 * f12);
 f8 = Math_fround(f8 * f11);
 f6 = Math_fround(f6 * f11);
 f14 = Math_fround(HEAPF32[i10 >> 2]);
 f13 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f9 = Math_fround(f9 + f14);
 f8 = Math_fround(f8 + f13);
 f7 = Math_fround(f7 + f9);
 f6 = Math_fround(f6 + f8);
 f12 = Math_fround(f12 + f14);
 f11 = Math_fround(f11 + f13);
 f9 = f9 < f14 ? f14 : f9;
 f8 = f8 < f13 ? f13 : f8;
 f7 = Math_fround((f7 > f12 ? f12 : f7) - f9);
 i10 = f7 < Math_fround(0.0);
 f7 = i10 ? Math_fround(0.0) : f7;
 f6 = Math_fround((f6 > f11 ? f11 : f6) - f8);
 i10 = f6 < Math_fround(0.0);
 f6 = i10 ? Math_fround(0.0) : f6;
 f7 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f7));
 f6 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f6));
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAPF32[i5 >> 2] = f7;
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAP32[i5 + 8 >> 2] = i3;
 __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i1, i2, i5);
 STACKTOP = i4;
 return;
}

function __ZN9Texture2D17MainThreadCleanupEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 4 | 0;
 i8 = i12;
 __ZN9Texture2D16DeleteGfxTextureEv(i7);
 i9 = i7 + 116 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i10 = HEAP32[gb + 1158372 >> 2] | 0;
 i5 = i10 + 4 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 if (i11 | 0) {
  i3 = i5;
  i2 = i11;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i5 | 0)) if (i4 >>> 0 >= (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
   i10 = i10 + 8 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i11, i3);
   __ZdlPv(i3);
  }
 }
 i11 = __Z25GetUncheckedRealGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i11 >> 2] | 0) + 424 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i10 | 0, i11 | 0, i6 | 0);
 HEAP32[i9 >> 2] = 0;
 __ZN7Texture17MainThreadCleanupEv(i7);
 STACKTOP = i12;
 return;
}

function __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i8, i9, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i11 = i12;
 i4 = i8 + 60 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = i4;
  i3 = i2;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if ((i5 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) HEAPF32[i1 + 20 >> 2] = f10;
 }
 i1 = i8 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i6 = 12; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i6 = 12;
 if ((i6 | 0) == 12) {
  __ZN8Material15BuildPropertiesEv(i8);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i2 + 12 | 0, i9, f10, 0);
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i8, i7);
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN11AssetBundle8TransferI17RemapPPtrTransferEEvRT_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i8, i7);
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 i6 = HEAP32[i8 + 60 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) {
  i5 = i7 + 16 | 0;
  i6 = i7 + 36 | 0;
  i3 = i7 + 40 | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i2 = HEAP32[i8 + 68 >> 2] | 0;
 i4 = i8 + 72 | 0;
 i5 = i7 + 16 | 0;
 i6 = i7 + 36 | 0;
 i7 = i7 + 40 | 0;
 if ((i2 | 0) != (i4 | 0)) while (1) {
  i1 = i2 + 40 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i3;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 i2 = i8 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i8);
  return;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv(i8);
 return;
}

function __ZN9Texture2D26AllocateScaledOrPaddedDataE13TextureFormat(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i6 = i10;
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
 i4 = __Z25GetNextAllowedTextureSizeib13TextureFormat(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0, i8, i3) | 0;
 i5 = __Z25GetNextAllowedTextureSizeib13TextureFormat(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0, i8, i3) | 0;
 if (i8) {
  i8 = __Z22CalculateMipMapCount3Diii(i4, i5, 1) | 0;
  i2 = __Z24CalculateImageMipMapSizeii13TextureFormat(i4, i5, i3) | 0;
 } else {
  i2 = __Z18CalculateImageSizeii13TextureFormat(i4, i5, i3) | 0;
  i8 = 1;
 }
 i7 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 1035) | 0;
 i13 = gb + 63272 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i6;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  i13 = 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i7, i9, i4, i5, i3, i2, i13, i8, 1, 1);
  STACKTOP = i10;
  return i7 | 0;
 }
 i13 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb(i7, i9, i4, i5, i3, i2, i13, i8, 1, 1);
 STACKTOP = i10;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN16ReflectionProbes6UpdateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 4 | 0;
 i7 = i11;
 if ((HEAP16[gb + 1112328 + 6 >> 1] | 0) > -1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112328 | 0, i5);
  i10 = gb + 1112328 | 0;
 } else i10 = 0;
 i9 = HEAP32[gb + 1112328 >> 2] | 0;
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 648 >> 2] | 0, i8 | 0, i9 | 0);
 i9 = i6 + 12 | 0;
 i8 = i6 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = i3;
  while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i2 + 44 >> 2] | 0) == 1) if ((HEAP32[i2 + 40 >> 2] | 0) == 1) {
    i1 = HEAP32[i2 + 48 >> 2] | 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb(i2, i1, i5, 0) | 0;
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   } else i2 = i3; else i2 = i3;
   i4 = i4 + 4 | 0;
   if ((i4 | 0) == (i2 + (i1 << 2) | 0)) break; else i3 = i2;
  }
 }
 __ZN16ReflectionProbes16UpdateSampleDataEv(i6);
 i1 = __ZN16ReflectionProbes40UpdateRealtimeReflectionProbesTimeslicedEv(i6) | 0;
 i9 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 652 >> 2] | 0, i9 | 0);
 if (!i10) {
  STACKTOP = i11;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN15ResourceManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i2 = HEAP32[i6 + 56 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i1, 4);
 i3 = i6 + 48 | 0;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i6 = i6 + 28 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i7, i6, 0);
  STACKTOP = i8;
  return;
 }
 i2 = i1;
 while (1) {
  __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8UnityStr4PPtrI6ObjectEEEEEvRT_PKc17TransferMetaFlags(i7, i2 + 16 | 0, gb + 1041891 | 0, 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 i6 = i6 + 28 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i7, i6, 0);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE8__appendEj(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = i7 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (((i4 - i1 | 0) / 36 | 0) >>> 0 >= i3 >>> 0) {
  do {
   i2 = i1 + 36 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i2 | 0));
   i1 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
   HEAP32[i9 >> 2] = i1;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  STACKTOP = i10;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = ((i1 - i5 | 0) / 36 | 0) + i3 | 0;
 if (i6 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = (i4 - i5 | 0) / 36 | 0;
 i2 = i9 << 1;
 i2 = i9 >>> 0 < 59652323 ? (i2 >>> 0 < i6 >>> 0 ? i6 : i2) : 119304647;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = i7 + 8;
 if (!i2) i4 = 0; else i4 = __Znwj(i2 * 36 | 0) | 0;
 HEAP32[i8 >> 2] = i4;
 i9 = i4 + (((i1 - i5 | 0) / 36 | 0) * 36 | 0) | 0;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i8 + 12 >> 2] = i4 + (i2 * 36 | 0);
 _memset(i9 | 0, 0, i3 * 36 | 0) | 0;
 HEAP32[i8 + 8 >> 2] = i9 + (i3 * 36 | 0);
 __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i7, i8);
 __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev(i8);
 STACKTOP = i10;
 return;
}

function __ZN5Flare8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 44 | 0, i7);
 i1 = i6 + 48 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i3 = i6 + 32 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 52 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 }
}

function __ZN12_GLOBAL__N_121SphericalJointProjectEPKvRN5physx11PxTransformES4_b(i11, i6, i7, i12) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i12 = i12 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14 + 84 | 0;
 i10 = i14 + 56 | 0;
 i9 = i14 + 28 | 0;
 i13 = i14;
 __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_(i11, i6, i7, i8, i10, i9);
 f1 = Math_fround(HEAPF32[i11 + 112 >> 2]);
 f4 = Math_fround(HEAPF32[i9 + 16 >> 2]);
 f3 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f2 * f2));
 if (f3 > Math_fround(f1 * f1)) {
  f15 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3))));
  f3 = Math_fround(f1 * Math_fround(f5 * f15));
  f5 = Math_fround(f1 * Math_fround(f2 * f15));
  HEAPF32[i13 + 16 >> 2] = Math_fround(f1 * Math_fround(f4 * f15));
  HEAPF32[i13 + 20 >> 2] = f3;
  HEAPF32[i13 + 24 >> 2] = f5;
  HEAP32[i13 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i13 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb(i6, i7, i8, i10, i13, i11, i12);
  STACKTOP = i14;
  return;
 } else {
  HEAPF32[i13 + 16 >> 2] = f4;
  HEAPF32[i13 + 20 >> 2] = f5;
  HEAPF32[i13 + 24 >> 2] = f2;
  STACKTOP = i14;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService16SessionContainer32GetLastModifiedSecondsSinceEpochERK8UnityStr(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 44 | 0;
 i6 = i10 + 20 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10 + 8 | 0;
 i9 = i10;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, i1);
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, i4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i7, i8);
 __ZN15FileSystemEntryC2EPKc(i5, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNK15FileSystemEntry12LastModifiedEv(i9, i5);
 i8 = HEAPU16[i9 >> 1] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 __ZN13FileEntryDataD2Ev(i5);
 setTempRet0(i8 | 0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN11BoxCollider7SetSizeERK8Vector3f(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i6 = i7;
 i2 = i4 + 72 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 if (f8 != Math_fround(HEAPF32[i2 >> 2])) i3 = 4; else {
  f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  if (f8 != Math_fround(HEAPF32[i4 + 76 >> 2])) i3 = 4; else {
   f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   if (f8 != Math_fround(HEAPF32[i4 + 80 >> 2])) i3 = 4;
  }
 }
 if ((i3 | 0) == 4) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = 3;
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 i9 = i5 + 8 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i3 = i5 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i5 | 0) | 0;
 __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i6, i4, gb + 62512 | 0);
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 >> 2] = i2;
 HEAP32[i3 >> 2] = i4;
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i5 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if (i1 | 0) __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5ImageC2Eiii13TextureFormatPv(i9, i4, i6, i7, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i3 = i9 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i9 + 8 | 0;
 HEAP32[i3 >> 2] = i6;
 i5 = i9 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i9 >> 2] = i8;
 i1 = __Z25GetBytesFromTextureFormat13TextureFormat(i8) | 0;
 i1 = Math_imul(HEAP32[i5 >> 2] | 0, i1) | 0;
 HEAP32[i9 + 12 >> 2] = i1;
 i5 = (i8 | 0) < 9;
 if (i5) i2 = 1; else i2 = (i8 | 0) == 1e3 | ((i8 | 0) == 23 | (i8 + -13 | 0) >>> 0 < 9);
 i12 = (i4 | 0) > 0 & (i6 | 0) > 0 & (i8 | 0) > 0;
 if (i12 & i2) {
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = __Z19GetMaxBytesPerPixel13TextureFormat(HEAP32[i9 >> 2] | 0) | 0;
  i2 = Math_imul(i2, i1) | 0;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + i2 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
  _memset(i1 + i2 | 0, 0, i3 | 0) | 0;
 } else i1 = 0;
 HEAP32[i9 + 16 >> 2] = i1;
 if ((i10 | 0) == 0 | (i1 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i11 + 4 >> 2] = i4;
 HEAP32[i11 + 8 >> 2] = i6;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i11 + 12 >> 2] = i7;
 if (i5) i1 = 1; else i1 = (i8 | 0) == 1e3 | ((i8 | 0) == 23 | (i8 + -13 | 0) >>> 0 < 9);
 i12 = i12 & i1 ? i10 : 0;
 HEAP32[i11 + 16 >> 2] = i12;
 if (i12 | 0) __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i11, i9, 0);
 STACKTOP = i13;
 return;
}

function __Z50ParticleCollisionEvent_CUSTOM_InstanceIDToCollideri(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 do if (i4 | 0) {
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i3) i5 = 7; else {
   if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i7 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
    i2 = HEAP32[i7 + 28 >> 2] | 0;
    i3 = HEAP32[i7 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 32548 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32548 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z21GetMiniMemoryOverviewv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 40 | 0;
 i3 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i2 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP8[i2 + 4 >> 0] = 0;
 __Z11FormatBytesx(i3, __ZN13MemoryManager23GetTotalAllocatedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0, 0);
 __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE(i6, gb + 585087 | 0, i3);
 i1 = HEAP32[i6 >> 2] | 0;
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i2, 0, 0, (i1 | 0) == 0 ? i6 + 4 | 0 : i1, HEAP32[i6 + 20 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6 + 24 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 24 | 0);
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i1 + 36 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0);
 __Z12FormatStringPKcz(i6, gb + 585099 | 0, i5);
 i1 = HEAP32[i6 >> 2] | 0;
 __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj(i2, HEAP32[i4 >> 2] | 0, 0, (i1 | 0) == 0 ? i6 + 4 | 0 : i1, HEAP32[i6 + 20 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP32[i6 + 4 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6 + 24 | 0);
 STACKTOP = i7;
 return;
}

function _fgets(i1, i2, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 if ((HEAP32[i10 + 76 >> 2] | 0) > -1) i9 = ___lockfile(i10) | 0; else i9 = 0;
 i3 = i2 + -1 | 0;
 if ((i2 | 0) < 2) {
  i11 = i10 + 74 | 0;
  i8 = HEAP8[i11 >> 0] | 0;
  HEAP8[i11 >> 0] = i8 + 255 | i8;
  if (i9 | 0) ___unlockfile(i10);
  if (!i3) HEAP8[i1 >> 0] = 0; else i1 = 0;
 } else {
  L11 : do if (!i3) {
   i2 = i1;
   i11 = 17;
  } else {
   i7 = i10 + 4 | 0;
   i8 = i10 + 8 | 0;
   i2 = i1;
   while (1) {
    i4 = HEAP32[i7 >> 2] | 0;
    i12 = i4;
    i13 = (HEAP32[i8 >> 2] | 0) - i12 | 0;
    i5 = _memchr(i4, 10, i13) | 0;
    i6 = (i5 | 0) == 0;
    i5 = i6 ? i13 : 1 - i12 + i5 | 0;
    i5 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
    _memcpy(i2 | 0, i4 | 0, i5 | 0) | 0;
    i4 = (HEAP32[i7 >> 2] | 0) + i5 | 0;
    HEAP32[i7 >> 2] = i4;
    i2 = i2 + i5 | 0;
    i5 = i3 - i5 | 0;
    if (!(i6 & (i5 | 0) != 0)) {
     i11 = 17;
     break L11;
    }
    if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
     HEAP32[i7 >> 2] = i4 + 1;
     i6 = HEAPU8[i4 >> 0] | 0;
    } else {
     i3 = ___uflow(i10) | 0;
     if ((i3 | 0) < 0) break; else i6 = i3;
    }
    i3 = i5 + -1 | 0;
    i4 = i2 + 1 | 0;
    HEAP8[i2 >> 0] = i6;
    if (!((i3 | 0) != 0 & (i6 & 255 | 0) != 10)) {
     i2 = i4;
     i11 = 17;
     break L11;
    } else i2 = i4;
   }
   if ((i2 | 0) == (i1 | 0)) i1 = 0; else if (!(HEAP32[i10 >> 2] & 16)) i1 = 0; else i11 = 17;
  } while (0);
  if ((i11 | 0) == 17) if (!i1) i1 = 0; else HEAP8[i2 >> 0] = 0;
  if (i9) ___unlockfile(i10);
 }
 return i1 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl11getPropertyEN5physx8debugger18NonNegativeIntegerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) if ((HEAP32[i2 + 152 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[i2 + 148 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = gb + 148864 + 8;
   i4 = i1 + 4 | 0;
   i2 = HEAP32[i4 + 4 >> 2] | 0;
   i5 = i3 + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = i2;
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i5 = i1 + 16 | 0;
   i2 = HEAP32[i5 + 4 >> 2] | 0;
   i4 = i3 + 16 | 0;
   HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i4 + 4 >> 2] = i2;
   HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   i4 = i3 + 28 | 0;
   i2 = i1 + 28 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   i4 = i1 + 44 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i2 = i3 + 44 | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   HEAP8[i3 + 52 >> 0] = 1;
   return;
  }
 }
 HEAP32[i3 >> 2] = gb + 148864 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 1576256;
 HEAP32[i3 + 8 >> 2] = gb + 1576256;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP32[i3 + 16 >> 2] = gb + 1576256;
 HEAP32[i3 + 20 >> 2] = gb + 1576256;
 HEAP32[i3 + 24 >> 2] = -1;
 HEAP32[i3 + 28 >> 2] = gb + 1576256;
 HEAP32[i3 + 32 >> 2] = gb + 1576256;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = -1;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP8[i3 + 52 >> 0] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 32 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = i5 + 16 | 0;
 HEAP32[i5 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 470646 | 0, i5, 0);
 __ZN9ShaderLab26SerializedShaderDependency8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 4 | 0, i7);
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 20 | 0, i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 56 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN13MemoryManager22LogAllocationToConsoleEPvjPKcS2_i(i4, i5, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, d13 = 0.0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i3 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i3;
  if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i6 = i1;
   break;
  }
 } else i6 = i1; while (0);
 i1 = HEAP32[i6 + 1556 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 i3 = i6 + 1544 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i12 = HEAP32[i6 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 40 >> 2] | 0, i12 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = 0;
 do {
  i2 = HEAP32[i6 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 512);
 d13 = +Math_fround(Math_fround(i1 >>> 0) * Math_fround(9.53674316e-07));
 HEAP32[i10 >> 2] = i7;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i10 + 8 >> 2] = i5;
 HEAPF64[i10 + 16 >> 3] = d13;
 HEAP32[i10 + 24 >> 2] = i1;
 HEAP32[i10 + 28 >> 2] = i8;
 HEAP32[i10 + 32 >> 2] = i9;
 _printf_console(gb + 582435 | 0, i10);
 STACKTOP = i11;
 return;
}

function _UNITY_TT_New_Context(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i7 = i8;
 do if (i1 | 0) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = _UNITY_ft_mem_alloc(i4, 612, i7) | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   i5 = i1 + 8 | 0;
   HEAP32[i5 >> 2] = i4;
   i2 = i1 + 432 | 0;
   HEAP32[i2 >> 2] = 32;
   i3 = i1 + 436 | 0;
   HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i4, 16, 0, 32, 0, i6) | 0;
   if (!(HEAP32[i6 >> 2] | 0)) {
    HEAP16[i1 + 440 >> 1] = 0;
    HEAP16[i1 + 442 >> 1] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 388 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 + 392 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    i7 = i1;
    STACKTOP = i8;
    return i7 | 0;
   } else {
    i5 = HEAP32[i5 >> 2] | 0;
    HEAP16[i1 + 440 >> 1] = 0;
    HEAP16[i1 + 442 >> 1] = 0;
    i4 = i1 + 24 | 0;
    _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
    HEAP32[i4 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    _UNITY_ft_mem_free(i5, HEAP32[i3 >> 2] | 0);
    HEAP32[i3 >> 2] = 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i1 + 428 >> 2] = 0;
    i4 = i1 + 392 | 0;
    _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
    HEAP32[i4 >> 2] = 0;
    HEAP32[i1 + 388 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    _UNITY_ft_mem_free(i5, i1);
    i6 = HEAP32[i6 >> 2] | 0;
    HEAP32[i7 >> 2] = i6;
    if (i6) break;
    STACKTOP = i8;
    return i1 | 0;
   }
  }
 } while (0);
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN11NavMeshData7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 845979 | 0, 59) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 169404 + 8;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim5human5HumanEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim5human5HumanEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim10ValueArrayEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim10ValueArrayEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN10Matrix4x4f5ScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 12 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 i4 = i2 + 4 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 16 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 20 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 24 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i4 = i1 + 28 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 i2 = i2 + 8 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 32 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 36 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 40 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i2 = i1 + 44 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 return i1 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i7 = i3;
 i2 = i3 + 24 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37208 >> 2] | 0, i7, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBAHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f15 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 + 2 >> 1] | 0) << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2]);
  i10 = f15 < Math_fround(0.0);
  i9 = f15 > Math_fround(1.0);
  i9 = ~~Math_fround(Math_fround((i9 ? Math_fround(1.0) : f15) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i12 = f14 < Math_fround(0.0);
  i11 = f14 > Math_fround(1.0);
  i11 = ~~Math_fround(Math_fround((i11 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  i8 = f13 < Math_fround(0.0);
  i7 = f13 > Math_fround(1.0);
  i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
  f13 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 + 6 >> 1] | 0) << 2) >> 2]);
  i6 = f13 < Math_fround(0.0);
  i3 = f13 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
  HEAP32[i4 >> 2] = (i12 ? 0 : i11 & 16711680) | (i10 ? 0 : i9 & 65280) | (i8 ? 0 : i7) | (i6 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i5, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i7, i1, 0);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i7, i1 + 20 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i1 + 60 | 0, gb + 1034411 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i1 + 72 | 0, gb + 1034420 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i7, i1 + 40 | 0, 0);
  i1 = i1 + 84 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i4;
  i1 = i6;
 }
 i4 = i1 >>> 0 > 7 ? 7 : i1;
 HEAP32[i5 >> 2] = i4;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = i1 + (i4 * 12 | 0) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i5 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 * 12 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZL17IsSpotLightCulledRK11ActiveLightibRK4AABBS4_RK10Matrix4x4f(i1, i2, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 320 | 0;
 i10 = i13 + 256 | 0;
 i11 = i13 + 192 | 0;
 i12 = i13 + 128 | 0;
 i3 = i13 + 64 | 0;
 i4 = i13;
 if ((HEAP32[i1 + 12 >> 2] | 0) == 1 & i5 | (HEAP32[i1 + 16 >> 2] & i2 | 0) == 0) {
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 }
 if (!(__Z17IntersectAABBAABBRK4AABBS1_(i6, i1 + 24 | 0) | 0)) {
  i12 = 1;
  STACKTOP = i13;
  return i12 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i10, i3) | 0;
 f14 = Math_fround(HEAPF32[((HEAP32[i6 + 40 >> 2] | 0) == 3 ? i6 + 204 | 0 : i6 + 48 | 0) >> 2]);
 f15 = Math_fround(f14 * Math_fround(9.99999974e-06));
 i5 = f15 > Math_fround(.0000999999974);
 f15 = i5 ? f15 : Math_fround(.0000999999974);
 __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i12, Math_fround(HEAPF32[i6 + 68 >> 2]), f15, f14) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i6 + 280 | 0, i3);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, i8, i11);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i12, i11, i4);
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i4, i9);
 i12 = (__Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i7, i9) | 0) ^ 1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZNSt3__25stackIPN9ShaderLab21SerializedShaderStateENS_5dequeIS3_NS_9allocatorIS3_EEEEED2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = i10 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i10 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + (i1 >>> 10 << 2) | 0;
 i11 = i10 + 8 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i4 = i7;
 i5 = i2;
 if ((i7 | 0) == (i2 | 0)) {
  i6 = 0;
  i7 = i10 + 20 | 0;
  i1 = 0;
 } else {
  i7 = i10 + 20 | 0;
  i6 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i6 = (HEAP32[i2 + (i6 >>> 10 << 2) >> 2] | 0) + ((i6 & 1023) << 2) | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + ((i1 & 1023) << 2) | 0;
 }
 L5 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L5;
   i1 = i1 + 4 | 0;
  } while ((i1 - (HEAP32[i3 >> 2] | 0) | 0) != 4096);
  i1 = i3 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i4 - i5 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = (HEAP32[i11 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i8 >> 2] = 512;
   break;
  }
 case 2:
  {
   HEAP32[i8 >> 2] = 1024;
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK11b2EdgeShape11ComputeAABBEP6b2AABBRK11b2Transformib(i7, i8, i1, i2, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f11 = Math_fround(f3 * f13);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f11 = Math_fround(f11 - Math_fround(f12 * f10));
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f14 + f11);
 f10 = Math_fround(Math_fround(f13 * f12) + Math_fround(f3 * f10));
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(f10 + f13);
 f4 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f5 = Math_fround(f3 * f4);
 f6 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 f5 = Math_fround(f14 + Math_fround(f5 - Math_fround(f12 * f6)));
 f6 = Math_fround(f13 + Math_fround(Math_fround(f12 * f4) + Math_fround(f3 * f6)));
 f3 = f11 < f5 ? f11 : f5;
 f4 = f10 < f6 ? f10 : f6;
 f5 = f11 > f5 ? f11 : f5;
 f6 = f10 > f6 ? f10 : f6;
 if (!i9) {
  f13 = f5;
  f11 = f3;
  f14 = f6;
  f12 = f4;
  HEAPF32[i8 >> 2] = f11;
  i9 = i8 + 4 | 0;
  HEAPF32[i9 >> 2] = f12;
  i9 = i8 + 8 | 0;
  HEAPF32[i9 >> 2] = f13;
  i9 = i8 + 12 | 0;
  HEAPF32[i9 >> 2] = f14;
  return;
 }
 f12 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f13 = Math_fround(f5 + f12);
 f11 = Math_fround(f3 - f12);
 f14 = Math_fround(f6 + f12);
 f12 = Math_fround(f4 - f12);
 HEAPF32[i8 >> 2] = f11;
 i9 = i8 + 4 | 0;
 HEAPF32[i9 >> 2] = f12;
 i9 = i8 + 8 | 0;
 HEAPF32[i9 >> 2] = f13;
 i9 = i8 + 12 | 0;
 HEAPF32[i9 >> 2] = f14;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i8 = i9;
 i6 = i9 + 20 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i8 | 0, i6 | 0);
 i6 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i8 >> 2] | 0 : HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i3 = gb + 832307 | 0; else i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i6;
 if (!i6) {
  i1 = 0;
  i2 = 0;
 } else {
  if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0) | 0)) {
   i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 832052 | 0, 35, gb + 832158 | 0, i5);
  }
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i6 | 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (i4 | 0) == 0 & (i2 | 0) == 0;
  i1 = i5 ? i1 : i4;
  i2 = i5 ? 0 : i2;
 }
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 833471;
 HEAP32[i8 + 4 >> 2] = i6;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 mftCall_viii(i5 | 0, i7 | 0, i3 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5Unity14CharacterJoint5ResetEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = HEAP32[i7 + 28 >> 2] | 0;
 if (!i2) i3 = 4; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i2, i1) | 0) {
  f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f9 = Math_fround(f9 + Math_fround(HEAPF32[i1 + 16 >> 2]));
  HEAPF32[i7 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 44 >> 2] = f9;
  HEAPF32[i7 + 48 >> 2] = Math_fround(0.0);
 } else i3 = 4;
 if ((i3 | 0) == 4) {
  i6 = i7 + 40 | 0;
  HEAP32[i6 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i1 = i7 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i7 + 36 >> 0] = 1;
 i1 = i7 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 i1 = i7 + 116 | 0;
 i2 = i7 + 128 | 0;
 i3 = i7 + 148 | 0;
 i4 = i7 + 160 | 0;
 i5 = i7 + 108 | 0;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i1 >> 2] = Math_fround(-20.0);
 HEAPF32[i2 >> 2] = Math_fround(70.0);
 HEAPF32[i3 >> 2] = Math_fround(40.0);
 HEAPF32[i4 >> 2] = Math_fround(40.0);
 HEAPF32[i7 + 176 >> 2] = Math_fround(.100000001);
 HEAPF32[i7 + 180 >> 2] = Math_fround(180.0);
 STACKTOP = i8;
 return;
}

function __ZN22BlockMemoryCacheWriterC2E10MemLabelId(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 HEAP32[i6 >> 2] = gb + 37988 + 8;
 i3 = i1;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i6 + 20 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = 0;
 i2 = i6 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i8;
 i5 = HEAP32[i3 >> 2] | 0;
 if ((i5 & 2147483392) >>> 0 >= 256) {
  i9 = i6 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i6 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 if ((i5 | 0) > -1) {
  HEAP32[i3 >> 2] = 256;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 1024, 4, i4, 0, gb + 1047584 | 0, 464) | 0;
  i9 = i6 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i6 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 4, i4, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = 256;
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 4 | 0;
  HEAP32[i9 >> 2] = 0;
  i9 = i6 + 8 | 0;
  HEAP32[i9 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN16UnityAdsSettings18InitializeDefaultsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i6 = i7;
 HEAP8[i4 + 8 >> 0] = 0;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP8[i4 + 16 >> 0] = 1;
 HEAP8[i4 + 17 >> 0] = 0;
 i1 = i4 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i6 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i6 >> 0] = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i4 + 24 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 }
 i1 = i4 + 36 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i6 + 11 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i6 >> 0] = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i4 + 40 >> 2] = 0; else HEAP8[i3 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 STACKTOP = i7;
 return;
}

function __ZN14PhysicMaterial8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 754137 | 0, i5, i1 + 40 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 754122 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737122 | 0, i5, i1 + 32 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 737138 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i7 = i3;
 i2 = i3 + 24 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36980 >> 2] | 0, i7, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNK11Rigidbody2D10IsTouchingEP10Collider2D(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i3 = i10;
 i9 = i10 + 16 | 0;
 if (!i5) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i6 = i9 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 L4 : do if (!(__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i9) | 0)) i1 = 0; else {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i4 = i2;
   i3 = i2;
   while (1) {
    i2 = HEAP32[i4 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0) | (i2 | 0) == 0) i2 = i3; else {
     if (__ZNK19CollisionListener2D10IsTouchingEPK10Collider2DS2_((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2, i5) | 0) {
      i1 = 1;
      break L4;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
    if ((i4 | 0) == (i2 + (i1 << 2) | 0)) {
     i1 = 0;
     break;
    } else i3 = i2;
   }
  }
 } while (0);
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
  HEAP32[i9 >> 2] = 0;
 }
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN9JSONWrite17TransferBasicDataIyEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + ((HEAP32[i1 + 48 >> 2] | 0) + -1 << 2) >> 2] & 16777216)) {
  i4 = HEAP32[i1 + 56 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
  i3 = i4 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i3 = i4 + 16 | 0;
  HEAP32[i3 >> 2] = 8710;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  if ((i2 | 0) < 0) {
   STACKTOP = i5;
   return;
  }
  HEAP32[i3 >> 2] = 12806;
  if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 4294967295) {
   STACKTOP = i5;
   return;
  }
  HEAP32[i3 >> 2] = i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 2147483647 ? 14854 : 15878;
  STACKTOP = i5;
  return;
 }
 __Z16BytesToHexStringPKvjPc(i2, 8, i4);
 HEAP8[i4 + 16 >> 0] = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 i1 = i4;
 while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
 i3 = i1 - i4 | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2);
 i1 = i2 + 16 | 0;
 if (i3 >>> 0 < 12) {
  HEAP32[i1 >> 2] = 7340037;
  HEAP8[i2 + 11 >> 0] = 11 - i3;
  i1 = i2;
 } else {
  HEAP32[i1 >> 2] = 3145733;
  HEAP32[i2 + 4 >> 2] = i3;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx8debugger18MemPvdOutputStream10directCopyERNS0_14PvdInputStreamEj(i5, i10, i11) {
 i5 = i5 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i7 = i5 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1;
 i9 = i2 - i3 | 0;
 i4 = i9 + i11 | 0;
 if (i4) {
  i6 = i5 + 24 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 8 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 12 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i8 >> 2] | 0);
   }
   HEAP32[i8 >> 2] = i1;
   i2 = i1 + i9 | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i6 >> 2] = i1 + i4;
  }
 }
 HEAP32[i7 >> 2] = i2 + i11;
 HEAP32[i12 >> 2] = i11;
 mftCall_iiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i1 + i9 | 0, i12 | 0) | 0;
 if ((HEAP32[i12 >> 2] | 0) == (i11 | 0)) {
  i12 = i11;
  i12 = (i12 | 0) == (i11 | 0);
  STACKTOP = i13;
  return i12 | 0;
 }
 _memset((HEAP32[i8 >> 2] | 0) + i9 | 0, 0, i11 | 0) | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 i12 = (i12 | 0) == (i11 | 0);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN4gles18AliasRenderSurfaceEP17RenderSurfaceGLES9TextureID(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i3 = i8;
 i7 = i8 + 4 | 0;
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i6, i1, i3);
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63304 | 0, 16, gb + 609388 | 0, 53) | 0;
 i4 = i3;
 i2 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP32[i7 >> 2] = i5;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i6, i3);
 STACKTOP = i8;
 return;
}

function __ZNK10Matrix4x4f14GetDeterminantEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, d22 = 0.0, d23 = 0.0;
 d22 = +Math_fround(HEAPF32[i1 >> 2]);
 d23 = +Math_fround(HEAPF32[i1 + 16 >> 2]);
 d15 = +Math_fround(HEAPF32[i1 + 32 >> 2]);
 d12 = +Math_fround(HEAPF32[i1 + 48 >> 2]);
 d4 = +Math_fround(HEAPF32[i1 + 4 >> 2]);
 d11 = +Math_fround(HEAPF32[i1 + 20 >> 2]);
 d6 = +Math_fround(HEAPF32[i1 + 36 >> 2]);
 d16 = +Math_fround(HEAPF32[i1 + 52 >> 2]);
 d7 = +Math_fround(HEAPF32[i1 + 8 >> 2]);
 d5 = +Math_fround(HEAPF32[i1 + 24 >> 2]);
 d3 = +Math_fround(HEAPF32[i1 + 40 >> 2]);
 d10 = +Math_fround(HEAPF32[i1 + 56 >> 2]);
 d18 = +Math_fround(HEAPF32[i1 + 12 >> 2]);
 d14 = +Math_fround(HEAPF32[i1 + 28 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 44 >> 2]);
 d2 = +Math_fround(HEAPF32[i1 + 60 >> 2]);
 d17 = d12 * d6;
 d21 = d15 * d16;
 d20 = d12 * d11;
 d13 = d23 * d16;
 d8 = d15 * d11;
 d19 = d23 * d6;
 d12 = d12 * d4;
 d16 = d22 * d16;
 d15 = d15 * d4;
 d6 = d22 * d6;
 d4 = d23 * d4;
 d11 = d22 * d11;
 return Math_fround(d11 * d3 * d2 + (d15 * d5 * d2 + (d19 * d7 * d2 + (d4 * d10 * d9 + (d16 * d5 * d9 + (d20 * d7 * d9 + (d6 * d10 * d14 + (d12 * d3 * d14 + (d21 * d7 * d14 + (d8 * d10 * d18 + (d13 * d3 * d18 + (d17 * d5 * d18 - d21 * d5 * d18 - d20 * d3 * d18)) - d19 * d10 * d18 - d17 * d7 * d14)) - d16 * d3 * d14 - d15 * d10 * d14)) - d13 * d7 * d9 - d12 * d5 * d9)) - d11 * d10 * d9 - d8 * d7 * d2)) - d6 * d5 * d2 - d4 * d3 * d2));
}

function __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim4hand4HandEEEEvRT_PKc17TransferMetaFlags(i5, i6, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i4) {
  i7 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i5) | 0;
  i8 = HEAP8[i5 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i5, i7 ? i8 + 4 | 0 : i8, i6, 4);
 }
 i1 = i5 + 48 | 0;
 i7 = i5 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 32 | 0;
 i11 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i2 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i5, (HEAP32[i6 >> 2] | 0) != 0, i3, 4);
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) __ZN9BlobWrite8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags(i5, i2 + i6 | 0, gb + 1041891 | 0, 0);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i5, i3, 4);
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i7 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i9;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i9;
 return;
}

function __ZN6Socket26WaitForAvailableSendBufferEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 128 | 0;
 i8 = i9;
 i5 = i1 + 4 | 0;
 i6 = i7 + 4 | 0;
 while (1) {
  i1 = (i2 | 0) / 1e3 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = ((Math_imul(i1, -1e3) | 0) + i2 | 0) * 1e3;
  i1 = i8;
  i3 = i1 + 128 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = i8 + (i3 >>> 5 << 2) | 0;
  HEAP32[i1 >> 2] = 1 << (i3 & 31) | HEAP32[i1 >> 2];
  d4 = +_emscripten_get_now() * 1.0e6;
  i1 = +Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i3 = _select((HEAP32[i5 >> 2] | 0) + 1 | 0, 0, i8, 0, i7) | 0;
  if ((i3 | 0) >= 0) {
   i1 = 5;
   break;
  }
  if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 4) {
   i1 = 5;
   break;
  }
  d10 = +_emscripten_get_now() * 1.0e6;
  i3 = _i64Subtract(~~d10 >>> 0 | 0, (+Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, ~~d4 >>> 0 | 0, i1 | 0) | 0;
  i3 = __Z17TimeToNanosecondsy(i3, getTempRet0() | 0) | 0;
  i3 = ___udivdi3(i3 | 0, getTempRet0() | 0, 1e6, 0) | 0;
  getTempRet0() | 0;
  i2 = (i2 | 0) > (i3 | 0) ? i2 - i3 | 0 : 0;
 }
 if ((i1 | 0) == 5) {
  STACKTOP = i9;
  return (i3 | 0) == 1 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx3Scb5Shape12setMaterialsEPKPNS_10PxMaterialEt(i9, i8, i5) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i7 = i9 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 switch (i2 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 3;
   break;
  }
 default:
  i6 = 3;
 }
 if ((i6 | 0) == 3) {
  i9 = __ZN5physx3Scb5Shape18setMaterialsHelperEPKPNS_10PxMaterialEt(i9, i8, i5) | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i3 = i9 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i9 >> 2] | 0, i2 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 i3 = i5 & 65535;
 if (i5 << 16 >> 16 == 1) {
  HEAP16[i1 + 116 >> 1] = i5;
  i2 = i1 + 112 | 0;
  i6 = 9;
 } else {
  i11 = HEAP32[i9 >> 2] | 0;
  i2 = i11 + 2504 | 0;
  i11 = HEAP32[i11 + 2508 >> 2] | 0;
  HEAP16[i4 >> 1] = 0;
  __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt(i2, i11 + i3 | 0, i4);
  i2 = (HEAP32[i2 >> 2] | 0) + (i11 << 1) | 0;
  HEAP32[i1 + 112 >> 2] = i11;
  HEAP16[i1 + 116 >> 1] = i5;
  if (i5 << 16 >> 16) i6 = 9;
 }
 if ((i6 | 0) == 9) {
  i1 = 0;
  do {
   HEAP16[i2 + (i1 << 1) >> 1] = HEAP32[(HEAP32[i8 + (i1 << 2) >> 2] | 0) + 52 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i9 >> 2] | 0, i9);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2;
 i11 = 1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN14AssetReferenceD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i5 = HEAP32[gb + 1162408 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i5 + 4 | 0;
 if ((HEAP32[i5 + 36 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i3 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_(i2, i5, i3);
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i3 = HEAP32[i5 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 i9 = i1 + 4 | 0;
 i8 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i8;
 do if (!i8) if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
  if (!(HEAP8[i5 + 8 >> 0] | 0)) i6 = 9; else if (!(HEAP32[i4 >> 2] | 0)) i6 = 9; else {
   i9 = (HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i1 >> 2] | 0);
   i2 = i5 + 12 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   i8 = i1;
   HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 + 4 >> 2] = i3;
   if (i9) break;
  }
  if ((i6 | 0) == 9) {
   i6 = i5 + 12 | 0;
   i8 = HEAP32[i6 + 4 >> 2] | 0;
   i9 = i1;
   HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
  }
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  HEAP8[i5 + 48 >> 0] = 1;
 } while (0);
 STACKTOP = i7;
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (i1 - i2 | 0) / 72 | 0;
 if (i7 >>> 0 > i3 >>> 0) __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i5, i7 - i3 | 0); else if (i7 >>> 0 < i3 >>> 0) {
  i2 = i2 + (i7 * 72 | 0) | 0;
  if ((i1 | 0) != (i2 | 0)) do {
   HEAP32[i4 >> 2] = i1 + -72;
   i1 = HEAP32[i4 >> 2] | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if (!i7) return;
 i4 = 0;
 do {
  i1 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i6 >> 2] | 0, i4) | 0) >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i3 + (i4 * 72 | 0) >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i3 + (i4 * 72 | 0) + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i3 + (i4 * 72 | 0) + 32 | 0;
   i2 = i2 + 32 | 0;
   i3 = i1 + 40 | 0;
   do {
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i7 | 0));
 return;
}

function __ZN10Matrix4x4f8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1, gb + 1034440 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 16 | 0, gb + 1034444 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 32 | 0, gb + 1034448 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 48 | 0, gb + 1034452 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 4 | 0, gb + 1034456 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 20 | 0, gb + 1034460 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 36 | 0, gb + 1034464 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 52 | 0, gb + 1034468 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 8 | 0, gb + 1034472 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 24 | 0, gb + 1034476 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 40 | 0, gb + 1034480 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 56 | 0, gb + 1034484 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 12 | 0, gb + 1034488 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 28 | 0, gb + 1034492 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 44 | 0, gb + 1034496 | 0, 0, 0);
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 60 | 0, gb + 1034500 | 0, 0, 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPKNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 674458 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS3_9allocatorIiEEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i4 - i3 >> 2;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i6, i1 - i2 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 } else if (i1 >>> 0 < i2 >>> 0) {
  i1 = i3 + (i1 << 2) | 0;
  if ((i4 | 0) == (i1 | 0)) i1 = i3; else {
   i4 = i4 + (~((i4 + -4 - i1 | 0) >>> 2) << 2) | 0;
   HEAP32[i5 >> 2] = i4;
   i1 = i3;
  }
 } else i1 = i3;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = i1;
 do {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i1 = HEAP32[i8 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i9 >> 2] = i2;
  }
  HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN17TransformInternal25CopyTransformSubhierarchyER18TransformHierarchyjS1_jb(i11, i3, i12, i13, i7) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = HEAP32[(HEAP32[i11 + 16 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 i1 = (HEAP32[i12 + 68 >> 2] | 0) + (i14 + -1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i12 + 4 >> 2] = i2;
 if ((i2 | 0) != -1) HEAP32[(HEAP32[i12 + 72 >> 2] | 0) + (i2 << 2) >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 if (!i14) return;
 i8 = i12 + 56 | 0;
 i9 = i12 + 60 | 0;
 i10 = i11 + 68 | 0;
 i4 = i11 + 60 | 0;
 i5 = i11 + 56 | 0;
 i6 = i12 + 36 | 0;
 if (i7) {
  i1 = i3;
  i2 = 0;
  while (1) {
   __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i11, i1, i12, i2);
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i13;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i13;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i14 | 0)) break; else i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  }
  return;
 } else {
  i1 = i3;
  i2 = 0;
  while (1) {
   __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j(i11, i1, i12, i2);
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i7 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | i3 & i13;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i7;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i3;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i7;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i14 | 0)) break; else i1 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  }
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN6Socket24WaitForAvailableRecvDataEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, d10 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 128 | 0;
 i8 = i9;
 i5 = i1 + 4 | 0;
 i6 = i7 + 4 | 0;
 while (1) {
  i1 = (i2 | 0) / 1e3 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = ((Math_imul(i1, -1e3) | 0) + i2 | 0) * 1e3;
  i1 = i8;
  i3 = i1 + 128 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = i8 + (i3 >>> 5 << 2) | 0;
  HEAP32[i1 >> 2] = 1 << (i3 & 31) | HEAP32[i1 >> 2];
  d4 = +_emscripten_get_now() * 1.0e6;
  i1 = +Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i3 = _select((HEAP32[i5 >> 2] | 0) + 1 | 0, i8, 0, 0, i7) | 0;
  if ((i3 | 0) >= 0) {
   i1 = 5;
   break;
  }
  if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 4) {
   i1 = 5;
   break;
  }
  d10 = +_emscripten_get_now() * 1.0e6;
  i3 = _i64Subtract(~~d10 >>> 0 | 0, (+Math_abs(d10) >= 1.0 ? (d10 > 0.0 ? ~~+Math_min(+Math_floor(d10 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d10 - +(~~d10 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, ~~d4 >>> 0 | 0, i1 | 0) | 0;
  i3 = __Z17TimeToNanosecondsy(i3, getTempRet0() | 0) | 0;
  i3 = ___udivdi3(i3 | 0, getTempRet0() | 0, 1e6, 0) | 0;
  getTempRet0() | 0;
  i2 = (i2 | 0) > (i3 | 0) ? i2 - i3 | 0 : 0;
 }
 if ((i1 | 0) == 5) {
  STACKTOP = i9;
  return (i3 | 0) == 1 | 0;
 }
 return 0;
}

function __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj8ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i7, i6, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = i10 + 4 | 0;
 i9 = i7 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0) i1 = 6;
   break;
  }
 default:
  {}
 }
 if ((i1 | 0) == 6) {
  i2 = i7 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i7 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  i6 = i1 + 28 | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i7 >> 2] | 0, i7);
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 8;
  STACKTOP = i10;
  return;
 }
 i2 = HEAP8[i6 + 64 >> 0] | 0;
 __ZN5physx2Sc9ShapeCore23setSimulationFilterDataERKNS_12PxFilterDataE(i6, i8);
 i1 = HEAP32[i7 + -32 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i9 >> 2] & -1073741824 | 0) == 1073741824) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = 8;
 HEAP8[i4 >> 0] = i2;
 __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i6, i3, i4);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 695;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 694;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_(i5, i1, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i7 >> 2] = 693;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_(i5, i7, i4, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN16ParticleRenderer16GenerateUVFramesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i9 = 0, f10 = f0, f11 = f0;
 i9 = i8 + 356 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) < 1) {
  HEAP32[i9 >> 2] = 1;
  i1 = 1;
 }
 i2 = i8 + 360 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) < 1) {
  HEAP32[i2 >> 2] = 1;
  i3 = 1;
 }
 i2 = Math_imul(i3, i1) | 0;
 f7 = Math_fround(Math_fround(1.0) / Math_fround(i1 | 0));
 f5 = Math_fround(Math_fround(1.0) / Math_fround(i3 | 0));
 i2 = (i2 | 0) == 1 ? 0 : i2;
 i6 = i8 + 376 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 i3 = i8 + 372 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i6 >> 2] = 0;
 if (!i2) return;
 if (i2 << 4 >>> 0 <= i2 >>> 0) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 HEAP32[i6 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] << 4, 16, gb + 63264 | 0, 0, gb + 1048339 | 0, 71) | 0;
 if (i8) __Z19pop_allocation_rootv();
 if ((HEAP32[i3 >> 2] | 0) <= 0) return;
 f4 = Math_fround(Math_fround(1.0) - f5);
 i1 = 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i8 = (i1 | 0) / (i2 | 0) | 0;
  f11 = Math_fround(f7 * Math_fround(i1 - (Math_imul(i8, i2) | 0) | 0));
  f10 = Math_fround(f4 - Math_fround(f5 * Math_fround(i8 | 0)));
  i8 = HEAP32[i6 >> 2] | 0;
  HEAPF32[i8 + (i1 << 4) >> 2] = f11;
  HEAPF32[i8 + (i1 << 4) + 4 >> 2] = f10;
  HEAPF32[i8 + (i1 << 4) + 8 >> 2] = f7;
  HEAPF32[i8 + (i1 << 4) + 12 >> 2] = f5;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 return;
}

function __ZN13TargetJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 44 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 48 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 84 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i6 = gb + 1162356 | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i5;
 }
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i1;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
 }
 i6 = i2 + 92 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f3 < Math_fround(0.0);
 i4 = f3 > Math_fround(1.0e6);
 f3 = i4 ? Math_fround(1.0e6) : f3;
 HEAPF32[i6 >> 2] = i5 ? Math_fround(0.0) : f3;
 i6 = i2 + 100 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f3 < Math_fround(0.0);
 i4 = f3 > Math_fround(1.0e6);
 f3 = i4 ? Math_fround(1.0e6) : f3;
 HEAPF32[i6 >> 2] = i5 ? Math_fround(0.0) : f3;
 i6 = i2 + 96 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f3 < Math_fround(0.0);
 i4 = f3 > Math_fround(1.0);
 f3 = i4 ? Math_fround(1.0) : f3;
 HEAPF32[i6 >> 2] = i5 ? Math_fround(0.0) : f3;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP8[i2 + 40 >> 0] = 1;
 return;
}

function __ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 if (!i2) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = i1 + 180 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i7, __ZL16FMOD_ErrorString11FMOD_RESULT(i2) | 0) | 0;
 HEAP32[i1 + 192 >> 2] = i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, _strlen(i3) | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i8 = HEAP8[i5 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i8 = i9 ? HEAP32[i5 + 4 >> 2] | 0 : i8 & 255;
 i2 = i7 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 i3 = i3 << 24 >> 24 < 0 ? HEAP32[i1 + 184 >> 2] | 0 : i3 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i4, i9 ? HEAP32[i5 >> 2] | 0 : i5, i8, i3 + i8 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i4, (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i3) | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 856220 | 0, 438, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z40GetTemporaryCachePathApplicationSpecificv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 24 | 0;
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN10systeminfo21GetTemporaryCachePathEv(i2);
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
 i6 = __ZL38GetApplicationSpecificDataPathAppendixNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_(i4, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 do if (i6) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3); else if (__Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  break;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  break;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i5;
 return;
}

function __Z40GetPersistentDataPathApplicationSpecificv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 24 | 0;
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN10systeminfo21GetPersistentDataPathEv(i2);
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
 i6 = __ZL38GetApplicationSpecificDataPathAppendixNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_(i4, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 do if (i6) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3); else if (__Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  break;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  break;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i5;
 return;
}

function __Z24CalculateKnownPathLengthPKfiPKhS0_PK14dtPathCorridor(i5, i8, i2, i9, i3) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f6 = f0, f7 = f0, f10 = f0, f11 = f0, f12 = f0;
 if (!i8) {
  if ((HEAP32[i3 + 32 >> 2] | 0) != 1) {
   f7 = Math_fround(inf);
   return Math_fround(f7);
  }
  f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i5 >> 2]));
  f6 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i5 + 4 >> 2]));
  f7 = Math_fround(HEAPF32[i3 + 20 >> 2]);
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i5 + 8 >> 2]));
  f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f6 * f6)) + Math_fround(f7 * f7))));
  return Math_fround(f7);
 }
 if (!(HEAP8[i2 + (i8 + -1) >> 0] & 2)) {
  f7 = Math_fround(inf);
  return Math_fround(f7);
 }
 if ((i8 | 0) <= 0) {
  f7 = Math_fround(0.0);
  return Math_fround(f7);
 }
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f1 = Math_fround(0.0);
 i2 = 0;
 f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 do {
  i5 = i9 + (i2 * 3 << 2) | 0;
  f12 = f6;
  f6 = Math_fround(HEAPF32[i5 >> 2]);
  f12 = Math_fround(f12 - f6);
  f11 = f7;
  f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  f11 = Math_fround(f11 - f7);
  f10 = f4;
  f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
  f10 = Math_fround(f10 - f4);
  f1 = Math_fround(f1 + Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f12 * f12) + Math_fround(f11 * f11)) + Math_fround(f10 * f10)))));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 return Math_fround(f1);
}

function __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 24 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[i3 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i6, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i2 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i2);
 }
 if (HEAP8[i2 + 128 >> 0] | 0) __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i6, HEAP32[i4 + 24 >> 2] | 0, HEAP32[i3 + 28 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -16 - i1 | 0) >>> 4) << 4);
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i8;
 return;
}

function __Z16CopyActiveLightsRK12ActiveLightsRS_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i7 | 0) == (i8 | 0)) i3 = i8 + 12 | 0; else {
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = i8 + 12 | 0;
  i1 = (HEAP32[i7 + 12 >> 2] | 0) * 180 | 0;
  i2 = (i1 | 0) / 180 | 0;
  HEAP32[i3 >> 2] = i2;
  i4 = i8 + 16 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 180 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  } else i1 = HEAP32[i8 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, (HEAP32[i3 >> 2] | 0) * 180 | 0) | 0;
 }
 i6 = i8 + 20 | 0;
 i7 = i7 + 20 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP8[i6 + 24 >> 0] = HEAP8[i7 + 24 >> 0] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = 0;
 do {
  i8 = (HEAP32[i2 + (i1 * 180 | 0) >> 2] | 0) + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN12MeshCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i5);
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 60 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 121 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i1 = i4 + 124 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 } else {
  i8 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  HEAP32[i7 >> 2] = i3;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  i8 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i5);
  STACKTOP = i9;
  return;
 }
}

function __ZN12AudioManager14systemCallbackEP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 16 | 0;
 i6 = i8 + 4 | 0;
 switch (i2 | 0) {
 case 0:
  {
   i1 = __ZN4FMOD6System13getNumDriversEPi(i1, i5) | 0;
   if (!((i1 | 0) == 0 & (HEAP32[i5 >> 2] | 0) != 0)) {
    i7 = i1;
    STACKTOP = i8;
    return i7 | 0;
   }
   i1 = __Z24GetManagerPtrFromContexti(3) | 0;
   if (!i1) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   if (__ZN12AudioManager21SetActiveOutputDriverEP9FMOD_GUID(i1, i1 + 276 | 0) | 0) {
    HEAP8[i1 + 227 >> 0] = 1;
    HEAP8[i1 + 226 >> 0] = 1;
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   } else {
    HEAP32[i7 >> 2] = __ZL16FMOD_ErrorString11FMOD_RESULT(0) | 0;
    __Z6FormatPKcz(i6, gb + 861284 | 0, i7);
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 861403 | 0, 69, 512, 0, 0, 0);
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    HEAP8[i1 + 228 >> 0] = 1;
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
  }
 case 7:
  if (!i4) {
   i7 = __ZN12SoundManager26OnCreateSoundPopAllocationEv() | 0;
   STACKTOP = i8;
   return i7 | 0;
  } else {
   i7 = __ZN12SoundManager27OnCreateSoundPushAllocationEPv(i3) | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 default:
  {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 return 0;
}

function __Z20FromToQuaternionSafeRK8Vector3fS1_(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i15 + 24 | 0;
 i11 = i15 + 12 | 0;
 i12 = i15;
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f13 * f13);
 f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f14 * f14));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(f7 * f7);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 + Math_fround(f8 * f8));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f3 * f3))));
 if (f6 < Math_fround(9.99999974e-06) | f4 < Math_fround(9.99999974e-06)) {
  HEAPF32[i9 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i9 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i15;
  return;
 } else {
  HEAPF32[i11 >> 2] = Math_fround(f13 / f6);
  HEAPF32[i11 + 4 >> 2] = Math_fround(f14 / f6);
  HEAPF32[i11 + 8 >> 2] = Math_fround(f5 / f6);
  HEAPF32[i12 >> 2] = Math_fround(f7 / f4);
  HEAPF32[i12 + 4 >> 2] = Math_fround(f8 / f4);
  HEAPF32[i12 + 8 >> 2] = Math_fround(f3 / f4);
  __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i10, i11, i12) | 0;
  __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i10, i9);
  STACKTOP = i15;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNK9Texture2D8GetPixelEiii(i8, i6, i3, i4, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i9 = i10 + 4 | 0;
 if (!(__ZNK9Texture2D17CheckHasPixelDataEv(i6) | 0)) {
  HEAPF32[i8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i6 + 52 >> 2] | 0;
 if ((i3 | 0) >= 0) {
  if (!i1) i2 = 0; else i2 = HEAP32[i1 + 44 >> 2] | 0;
  if ((i2 | 0) > (i3 | 0)) {
   i9 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, i3) | 0;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i8, (HEAP32[i1 + 8 >> 2] | 0) + i9 | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, HEAP32[i6 + 44 >> 2] | 0, i4, i5);
   STACKTOP = i10;
   return;
  }
 }
 if (!i1) i1 = -1; else i1 = (HEAP32[i1 + 44 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i1;
 __Z6FormatPKcz(i9, gb + 416862 | 0, i7);
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 410682 | 0, 1202, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 HEAPF32[i8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i10;
 return;
}

function __ZNK9ShaderLab20ShaderDepthStateDesc15ToGfxDepthStateEPK19ShaderPropertySheetS3_R13GfxDepthState(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 24 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) == -1) f1 = Math_fround(HEAPF32[i4 >> 2]); else {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i5, i6, i3, i8);
  f1 = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]);
 }
 HEAP8[i7 >> 0] = f1 != Math_fround(0.0) & 1;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  i9 = ~~f1;
  i10 = (i9 | 0) < 0;
  i8 = (i9 | 0) > 8;
  i9 = i8 ? 8 : i9;
  i9 = i9 & 255;
  i9 = i10 ? 0 : i9;
  i10 = i7 + 1 | 0;
  HEAP8[i10 >> 0] = i9;
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 4;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i10, i5, i6, i3, i8);
  f1 = Math_fround(HEAPF32[HEAP32[i10 >> 2] >> 2]);
  i9 = ~~f1;
  i10 = (i9 | 0) < 0;
  i8 = (i9 | 0) > 8;
  i9 = i8 ? 8 : i9;
  i9 = i9 & 255;
  i9 = i10 ? 0 : i9;
  i10 = i7 + 1 | 0;
  HEAP8[i10 >> 0] = i9;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i4, i5, i6, i7, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 20 | 0;
 i11 = i12;
 i8 = i12 + 12 | 0;
 i9 = i12 + 16 | 0;
 HEAP32[i8 >> 2] = i5 | -1073741824;
 i10 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 + 2976 + (i5 * 20 | 0) >> 2] = i2;
 HEAP32[i10 + 2976 + (i5 * 20 | 0) + 4 >> 2] = i6;
 if (i2 | i6 | 0) {
  i1 = HEAP32[i10 + 2976 + (i5 * 20 | 0) + 8 >> 2] | 0;
  if (!((i1 | 0) == 1 | (i1 | 0) == (i6 | 0))) {
   i14 = HEAP32[gb + 68604 + (i6 << 2) >> 2] | 0;
   i13 = HEAP32[gb + 68604 + (i1 << 2) >> 2] | 0;
   i1 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i8) | 0;
   HEAP32[i11 >> 2] = i14;
   HEAP32[i11 + 4 >> 2] = i13;
   HEAP32[i11 + 8 >> 2] = i1;
   __Z6FormatPKcz(i3, gb + 478736 | 0, i11);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 478814 | 0, 41, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  }
 }
 HEAP32[i10 + 2976 + (i5 * 20 | 0) + 12 >> 2] = i7;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage(i4 + 8 | 0, i8, i3, i6, i7);
 STACKTOP = i12;
 return;
}

function __ZN20SoundChannelInstanceD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 175464 + 8;
 HEAP32[gb + 1460032 >> 2] = (HEAP32[gb + 1460032 >> 2] | 0) + -1;
 i1 = i3 + 240 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11AudioSource25UnbindFromChannelInstanceERK7WeakPtrI20SoundChannelInstanceE(i2, i3 + 248 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 172 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 176 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 184 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 188 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 196 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 200 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 248 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = HEAP32[gb + 1459912 >> 2] | 0;
  i4 = i4 + -1 | 0;
  HEAP32[gb + 1459912 >> 2] = i4;
  i4 = i3 + 168 | 0;
  __ZN11SoundHandleD2Ev(i4);
  return;
 }
 HEAP32[i2 + 16 >> 2] = 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[gb + 1459912 >> 2] | 0;
 i4 = i4 + -1 | 0;
 HEAP32[gb + 1459912 >> 2] = i4;
 i4 = i3 + 168 | 0;
 __ZN11SoundHandleD2Ev(i4);
 return;
}

function __ZN17ArchiveFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i5, i6, i2, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i1 = i7;
 if ((HEAP16[gb + 1178980 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178980 | 0, i3);
  i4 = gb + 1178980 | 0;
 } else i4 = 0;
 if (!i2) {
  __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i3, i5, i6);
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  do if (!i2) i1 = 0; else {
   i1 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63552 | 0, 16, gb + 489554 | 0, 229) | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = gb + 70660 + 8;
   HEAP32[i1 + 4 >> 2] = i3;
   HEAP32[i1 + 8 >> 2] = i2;
   i2 = i1 + 16 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   i2 = i3 + 4 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   __ZN20ArchiveStorageReader15MakeStorageUsedEv(i3) | 0;
   if (i1 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
    HEAP32[i6 + 1056 >> 2] = 14;
    i1 = 0;
    break;
   }
   HEAP32[i6 + 1040 >> 2] = i5;
   HEAP32[i6 + 1044 >> 2] = i5;
   HEAP32[i6 + 1052 >> 2] = i1;
   i1 = 1;
  } while (0);
 } else i1 = 0;
 if (!i4) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN14RotationModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, i5, i1 + 4 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, gb + 620173 | 0, i6, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620483 | 0, i5, i1 + 800 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i7 = i3;
 i2 = i3 + 24 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37328 >> 2] | 0, i7, 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z10DestripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i11, i2, i8) {
 i11 = i11 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i9 = i8 + 4 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i10 = i4 - i1 >> 2;
 i12 = i2 + -2 | 0;
 if ((i2 | 0) > 2) {
  i2 = 0;
  i3 = 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = HEAP32[i11 + 4 >> 2] | 0;
  while (1) {
   i5 = HEAP32[i11 + (i2 + 2 << 2) >> 2] | 0;
   i2 = i2 + 1 | 0;
   i3 = (((i7 | 0) == (i5 | 0) | ((i6 | 0) == (i7 | 0) | (i6 | 0) == (i5 | 0))) & 1 ^ 1) + i3 | 0;
   if ((i2 | 0) == (i12 | 0)) break; else {
    i6 = i7;
    i7 = i5;
   }
  }
  i2 = i3 * 3 | 0;
 } else i2 = 0;
 i3 = i2 + i10 | 0;
 if (i3 >>> 0 > i10 >>> 0) {
  __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj(i8, i2);
  i1 = HEAP32[i8 >> 2] | 0;
 } else if (i3 >>> 0 < i10 >>> 0) {
  i2 = i1 + (i3 << 2) | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i9 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 }
 i7 = i1 + (i10 << 2) | 0;
 i6 = 0;
 i1 = 0;
 L13 : while (1) {
  while (1) {
   if ((i1 | 0) >= (i12 | 0)) break L13;
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   i3 = i1 + 1 | 0;
   i4 = HEAP32[i11 + (i3 << 2) >> 2] | 0;
   i5 = HEAP32[i11 + (i1 + 2 << 2) >> 2] | 0;
   if ((i4 | 0) == (i5 | 0) | ((i2 | 0) == (i4 | 0) | (i2 | 0) == (i5 | 0))) i1 = i3; else break;
  }
  i1 = (i1 & 1 | 0) == 0;
  HEAP32[i7 + (i6 << 2) >> 2] = i1 ? i2 : i4;
  HEAP32[i7 + (i6 + 1 << 2) >> 2] = i1 ? i4 : i2;
  HEAP32[i7 + (i6 + 2 << 2) >> 2] = i5;
  i6 = i6 + 3 | 0;
  i1 = i3;
 }
 return;
}

function _XXH32_digest(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = i4 + 28 | 0;
 i5 = HEAP32[i4 + 44 >> 2] | 0;
 i6 = i2 + i5 | 0;
 i1 = i4;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i1 >>> 0 > 0 | (i1 | 0) == 0 & i3 >>> 0 > 15) {
  i8 = HEAP32[i4 + 12 >> 2] | 0;
  i9 = HEAP32[i4 + 16 >> 2] | 0;
  i7 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = HEAP32[i4 + 24 >> 2] | 0;
  i1 = (i9 << 7 | i9 >>> 25) + (i8 << 1 | i8 >>> 31) + (i7 << 12 | i7 >>> 20) + (i1 << 18 | i1 >>> 14) | 0;
 } else i1 = (HEAP32[i4 + 8 >> 2] | 0) + 374761393 | 0;
 i1 = i1 + i3 | 0;
 i3 = i4 + 32 | 0;
 if (i3 >>> 0 <= i6 >>> 0) while (1) {
  i1 = (Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, -1028477379) | 0) + i1 | 0;
  i1 = Math_imul(i1 << 17 | i1 >>> 15, 668265263) | 0;
  i2 = i3 + 4 | 0;
  if (i2 >>> 0 > i6 >>> 0) {
   i2 = i3;
   break;
  } else {
   i9 = i3;
   i3 = i2;
   i2 = i9;
  }
 }
 if (i2 >>> 0 >= i6 >>> 0) {
  i9 = i1;
  i8 = i9 >>> 15;
  i9 = i8 ^ i9;
  i9 = Math_imul(i9, -2048144777) | 0;
  i8 = i9 >>> 13;
  i9 = i8 ^ i9;
  i9 = Math_imul(i9, -1028477379) | 0;
  i8 = i9 >>> 16;
  i9 = i8 ^ i9;
  return i9 | 0;
 }
 i3 = i4 + (i5 + 28) | 0;
 do {
  i1 = (Math_imul(HEAPU8[i2 >> 0] | 0, 374761393) | 0) + i1 | 0;
  i1 = Math_imul(i1 << 11 | i1 >>> 21, -1640531535) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 i9 = i1 >>> 15;
 i9 = i9 ^ i1;
 i9 = Math_imul(i9, -2048144777) | 0;
 i8 = i9 >>> 13;
 i9 = i8 ^ i9;
 i9 = Math_imul(i9, -1028477379) | 0;
 i8 = i9 >>> 16;
 i9 = i8 ^ i9;
 return i9 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE(i9, i1, i10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i11 = __Znwj(36) | 0;
 i7 = i1 + 4 | 0;
 i8 = i11;
 i1 = i11 + 16 | 0;
 i6 = HEAP8[i10 + 11 >> 0] | 0;
 i2 = i6 << 24 >> 24 < 0;
 i4 = i2 ? HEAP32[i10 >> 2] | 0 : i10;
 i6 = i2 ? HEAP32[i10 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i11 + 28 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i3 >> 2] | 0;
  i12 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i11 + 27 >> 0] = i6;
  if (i6) i12 = 6;
 } else i12 = 4;
 if ((i12 | 0) == 4) {
  i3 = i6 + 16 & -16;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i11 + 24 >> 2] = i3 | -2147483648;
  HEAP32[i11 + 20 >> 2] = i6;
  i1 = i5;
  i12 = 6;
 }
 if ((i12 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 HEAP32[i11 + 32 >> 2] = HEAP32[i10 + 16 >> 2];
 HEAP32[i9 >> 2] = i8;
 i12 = i9 + 4 | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = 1;
 STACKTOP = i13;
 return;
}

function __ZNK12CubemapArray11GetPixels32EiP11ColorRGBA3211CubemapFaceii(i2, i3, i7, i8, i9, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 12 | 0;
 if (!(__ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii(i2, i3, i7, i8, i9, i1) | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = HEAP32[i2 + 92 >> 2] | 0;
 i4 = HEAP32[i2 + 100 >> 2] | 0;
 i14 = i2 + 80 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i5 = i2 + 88 | 0;
 i6 = __Z21CalculateMipMapOffsetii13TextureFormati(i6, i6, HEAP32[i5 >> 2] | 0, i1) | 0;
 i14 = HEAP32[i14 >> 2] >> i1;
 i15 = (i14 | 0) < 1;
 i1 = i15 ? 1 : i14;
 i14 = Math_imul(i14, i14) | 0;
 if (((i15 ? 1 : i14) | 0) > (i3 | 0)) {
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 418416 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 397053 | 0, 341, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i15 = 0;
  STACKTOP = i13;
  return i15 | 0;
 } else {
  i15 = i11 + (Math_imul(i4, (i9 * 6 | 0) + i8 | 0) | 0) + i6 | 0;
  __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_(i15, i1, i1, HEAP32[i5 >> 2] | 0, 0, 0, i1, i1, i7) | 0;
  i15 = 1;
  STACKTOP = i13;
  return i15 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN4Mesh12SetBindposesEPK10Matrix4x4fi(i1, i8, i4) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i1 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i3 >> 2] | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i3 >> 2] = i1;
 }
 i6 = i1 + 144 | 0;
 i7 = i1 + 156 | 0;
 i2 = i4 << 6;
 i3 = i2 >> 6;
 HEAP32[i7 >> 2] = i3;
 i4 = i1 + 160 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i3 >>> 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 6;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 16, i1 + 148 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 6;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, i1 + 148 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 6 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 6;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
}

function __ZN11UnityEngine9Animation37SetGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayER9Transformb(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i7 = i3 + 4 | 0;
   i1 = (HEAP32[i7 >> 2] | 0) + i7 + (i1 * 12 | 0) | 0;
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i4, i5);
  }
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i7 = i3 + 12 | 0;
   i7 = (HEAP32[i7 >> 2] | 0) + i7 + (i1 << 4) | 0;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i4, i5);
  }
 }
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if ((i1 | 0) == -1) {
  __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i4);
  STACKTOP = i6;
  return;
 }
 i7 = i3 + 20 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 + (i1 * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i4, i5);
 __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i4);
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sc8ClothSim20removeCollisionPlaneEPKNS0_8ShapeSimE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 8 | 0;
 i11 = i16;
 i14 = HEAP32[i8 + 52 >> 2] | 0;
 i1 = (HEAP32[i8 + 88 >> 2] | 0) + (HEAP32[i8 + 84 >> 2] | 0) | 0;
 i15 = i8 + 116 | 0;
 i9 = HEAP32[i15 >> 2] | 0;
 i12 = i8 + 92 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 if (!i13) {
  STACKTOP = i16;
  return;
 } else i5 = 0;
 while (1) {
  i4 = i1 + i5 | 0;
  i2 = i9 + (i4 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i7 = i5;
   break;
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i13 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) {
  STACKTOP = i16;
  return;
 }
 i1 = i4 + 1 | 0;
 i3 = i8 + 120 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 < i5 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i9 + (i1 << 2) >> 2];
  i1 = i4 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i15 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i3 >> 2] = i5 + -1;
 HEAP32[i12 >> 2] = i13 + -1;
 i15 = (HEAP32[i14 + 80 >> 2] | 0) + i7 | 0;
 i14 = HEAP32[i14 + 28 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i14 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 mftCall_viiii(i13 | 0, i14 | 0, i10 | 0, i15 | 0, i15 + 1 | 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx12PxsRigidBody20advancePrevPoseToToiEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 32 | 0;
 i1 = i6;
 i2 = HEAP32[i4 + 64 >> 2] | 0;
 if (Math_fround(HEAPF32[i2 + 124 >> 2]) == Math_fround(0.0)) {
  STACKTOP = i6;
  return;
 }
 f10 = Math_fround(Math_fround(1.0) - f5);
 i7 = i4 + 48 | 0;
 f14 = Math_fround(f10 * Math_fround(HEAPF32[i7 >> 2]));
 i8 = i4 + 52 | 0;
 f13 = Math_fround(f10 * Math_fround(HEAPF32[i8 >> 2]));
 i9 = i4 + 56 | 0;
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i9 >> 2]));
 f12 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f5);
 f11 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * f5);
 f12 = Math_fround(f14 + f12);
 f11 = Math_fround(f13 + f11);
 f10 = Math_fround(f10 + Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * f5));
 HEAPF32[i7 >> 2] = f12;
 HEAPF32[i8 >> 2] = f11;
 HEAPF32[i9 >> 2] = f10;
 HEAP32[i1 >> 2] = HEAP32[i4 + 32 >> 2];
 i9 = i4 + 36 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i9 >> 2];
 i8 = i4 + 40 | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i8 >> 2];
 i7 = i4 + 44 | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i7 >> 2];
 HEAPF32[i1 + 16 >> 2] = f12;
 HEAPF32[i1 + 20 >> 2] = f11;
 HEAPF32[i1 + 24 >> 2] = f10;
 __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_(i3, f5, i1, i2);
 HEAP32[i4 + 32 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN5UmbramlERKNS_7Vector4ERKNS_9Matrix4x4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f10 * Math_fround(HEAPF32[i3 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 12 >> 2])));
 f6 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 16 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 20 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 24 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 28 >> 2])));
 f5 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 32 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 36 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 40 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 44 >> 2])));
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i3 + 48 >> 2]));
 f9 = Math_fround(f10 + Math_fround(f9 * Math_fround(HEAPF32[i3 + 52 >> 2])));
 f8 = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 56 >> 2])));
 f4 = Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 60 >> 2])));
 HEAPF32[i1 >> 2] = f7;
 HEAPF32[i1 + 4 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = f4;
 return;
}

function __ZN24b2ChainAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0;
 i4 = i9 + 8 | 0;
 f11 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 151644 >> 2]);
 if (f11 <= f5) if (Math_fround(HEAPF32[i3 + 8 >> 2]) <= f5) {
  HEAP32[i8 >> 2] = gb + 151648 + 8;
  HEAP32[i8 + 4 >> 2] = 1;
  HEAPF32[i8 + 8 >> 2] = f5;
  i4 = i8 + 28 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP16[i4 + 16 >> 1] = 0;
  __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei(i9, i8, HEAP32[i1 + 56 >> 2] | 0);
  __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_(i2, i8, i6, i3, i7);
  STACKTOP = i10;
  return;
 }
 HEAP32[i8 >> 2] = gb + 151728 + 8;
 HEAP32[i8 + 4 >> 2] = 2;
 i12 = i8 + 8 | 0;
 HEAPF32[i12 >> 2] = f5;
 HEAP32[i8 + 148 >> 2] = 0;
 HEAPF32[i8 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 16 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_(i8, i9 + (i1 << 3) | 0, i9 + (i1 + 1 << 3) | 0);
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i2, i8, i6, i3, i7);
 STACKTOP = i10;
 return;
}

function __Z31CubemapArray_CUSTOM_GetPixels32P12Il2CppObjectiii(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i4 = __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i8;
 i1 = Math_imul(i2, i2) | 0;
 i1 = (i2 | 0) < 1 ? 1 : i1;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 124 >> 2] | 0, 4, i1) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZNK12CubemapArray11GetPixels32EiP11ColorRGBA3211CubemapFaceii(i4, i1, i3, i6, i7, i8) | 0;
  STACKTOP = i9;
  return i2 | 0;
 }
 return 0;
}

function _gray_render_span(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i2 + 1e3 >> 2] | 0;
 i1 = (HEAP32[i2 + 1004 >> 2] | 0) + (Math_imul(i3, 0 - i1 | 0) | 0) | 0;
 if ((i3 | 0) > -1) i6 = i1 + (Math_imul((HEAP32[i2 + 992 >> 2] | 0) + -1 | 0, i3) | 0) | 0; else i6 = i1;
 if ((i4 | 0) <= 0) return;
 while (1) {
  i3 = HEAP8[i5 + 4 >> 0] | 0;
  L8 : do if (i3 << 24 >> 24) {
   i2 = HEAP16[i5 + 2 >> 1] | 0;
   if ((i2 & 65535) > 7) {
    _memset(i6 + (HEAP16[i5 >> 1] | 0) | 0, i3 | 0, i2 & 65535 | 0) | 0;
    break;
   }
   i1 = i6 + (HEAP16[i5 >> 1] | 0) | 0;
   switch (i2 << 16 >> 16) {
   case 7:
    {
     HEAP8[i1 >> 0] = i3;
     i1 = i1 + 1 | 0;
     i7 = 9;
     break;
    }
   case 6:
    {
     i7 = 9;
     break;
    }
   case 5:
    {
     i7 = 10;
     break;
    }
   case 4:
    {
     i7 = 11;
     break;
    }
   case 3:
    {
     i7 = 12;
     break;
    }
   case 2:
    {
     i7 = 13;
     break;
    }
   case 1:
    break;
   default:
    break L8;
   }
   if ((i7 | 0) == 9) {
    HEAP8[i1 >> 0] = i3;
    i1 = i1 + 1 | 0;
    i7 = 10;
   }
   if ((i7 | 0) == 10) {
    HEAP8[i1 >> 0] = i3;
    i1 = i1 + 1 | 0;
    i7 = 11;
   }
   if ((i7 | 0) == 11) {
    HEAP8[i1 >> 0] = i3;
    i1 = i1 + 1 | 0;
    i7 = 12;
   }
   if ((i7 | 0) == 12) {
    HEAP8[i1 >> 0] = i3;
    i1 = i1 + 1 | 0;
    i7 = 13;
   }
   if ((i7 | 0) == 13) {
    i7 = 0;
    HEAP8[i1 >> 0] = i3;
    i1 = i1 + 1 | 0;
   }
   HEAP8[i1 >> 0] = i3;
  } while (0);
  if ((i4 | 0) > 1) {
   i4 = i4 + -1 | 0;
   i5 = i5 + 6 | 0;
  } else break;
 }
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIjEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIjEEclERS1_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIiEEclERS1_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 4);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIfEEclERS1_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 4);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIbEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i3) {
  i6 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
  i7 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
  __ZN9BlobWrite4PushEjPKvj(i4, i6 ? i7 + 4 | 0 : i7, i5, 4);
 }
 i1 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i1 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj(i4, (HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0) != 0, i2, 1);
 __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIbEEclERS1_17TransferMetaFlagsR9BlobWrite(i8 + 12 | 0, i5, 0, i4);
 __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj(i4, i2, 1);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN8Animator24CollectAnimatedRenderersERKNS_15BindingsDataSetE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) return;
 i3 = HEAP32[i10 >> 2] | 0;
 i13 = HEAP32[i3 + 8 >> 2] | 0;
 if ((i13 | 0) <= 0) return;
 i14 = i1 + 448 | 0;
 i11 = i1 + 460 | 0;
 i12 = i1 + 464 | 0;
 i9 = i1 + 452 | 0;
 i1 = 0;
 i2 = 0;
 while (1) {
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  if ((HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0) == 22) {
   i8 = HEAP32[i3 + (i1 << 4) + 12 >> 2] | 0;
   if ((i2 | 0) != (i8 | 0)) {
    if (!i8) i2 = 0; else i2 = HEAP32[i8 + 4 >> 2] | 0;
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = i4 + 1 | 0;
    i6 = HEAP32[i12 >> 2] | 0;
    i7 = i6 & 2147483647;
    do if (i5 >>> 0 > i7 >>> 0) {
     i3 = i6 << 1;
     i3 = (i3 | 0) == 0 ? 1 : i3;
     if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
      HEAP32[i12 >> 2] = i3;
      HEAP32[i14 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i14 >> 2] | 0, i3 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
      break;
     } else {
      i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
      _memcpy(i7 | 0, HEAP32[i14 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
      HEAP32[i12 >> 2] = i3;
      HEAP32[i14 >> 2] = i7;
      break;
     }
    } while (0);
    HEAP32[i11 >> 2] = i5;
    HEAP32[(HEAP32[i14 >> 2] | 0) + (i4 << 2) >> 2] = i2;
    i2 = i8;
   }
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i13 | 0)) break;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sc8ClothSimC2ERNS0_5SceneERNS0_9ClothCoreE(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE(i4, i2, i1, 8);
 HEAP32[i4 >> 2] = gb + 91096 + 8;
 __ZN5physx2Sc10ClothShapeC2ERNS0_8ClothSimE(i4 + 56 | 0, i4);
 i1 = i4 + 84 | 0;
 i2 = i1 + 56 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN5physx2Sc8ClothSim24updateRigidBodyPositionsEv(i4);
 i1 = i4 + 52 | 0;
 __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv(i3, HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP16[i2 + 8 >> 1] & 2) {
  i4 = i2;
  i4 = i4 + 28 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = i2 + 80 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(i2 | 0, i4 | 0, i3 | 0);
  STACKTOP = i5;
  return;
 }
 i4 = __ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0;
 f8 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i3 >> 2]));
 i4 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = i3 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = i4 + 28 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = i2 + 80 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(i2 | 0, i4 | 0, i3 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx16PxsIslandManager23updateIslandsSecondPassEPNS_10PxBaseTaskEj(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i9 + 284 | 0;
 __ZN5physx17EdgeChangeManager23cleanupBrokenEdgeEventsEPKNS_4EdgeE(i9 + 332 | 0, HEAP32[i1 >> 2] | 0);
 i7 = HEAP32[i9 + 352 >> 2] | 0;
 i8 = HEAP32[i9 + 348 >> 2] | 0;
 if (!i7) i1 = 0; else {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i9 + 16 | 0;
  i1 = 0;
  i6 = 0;
  do {
   i3 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
   i2 = HEAP32[i4 + (i3 * 12 | 0) >> 2] | 0;
   i3 = HEAP32[i4 + (i3 * 12 | 0) + 4 >> 2] | 0;
   if ((i2 | 0) != -1) i1 = (HEAP8[(HEAP32[i5 >> 2] | 0) + (i2 * 12 | 0) + 8 >> 0] & 1) + i1 | 0;
   if ((i3 | 0) != -1) i1 = (HEAP8[(HEAP32[i5 >> 2] | 0) + (i3 * 12 | 0) + 8 >> 0] & 1) + i1 | 0;
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i7 | 0));
 }
 i2 = i9 + 468 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i1;
 i2 = HEAP32[i9 + 708 >> 2] | 0;
 _memset(HEAP32[i2 >> 2] | 0, 0, HEAP32[i2 + 4 >> 2] << 2 | 0) | 0;
 i3 = HEAP32[i9 + 588 >> 2] | 0;
 i4 = HEAP32[i9 + 596 >> 2] | 0;
 i1 = i4 - (HEAP32[i9 + 600 >> 2] | 0) | 0;
 if (i1 >>> 0 >= i4 >>> 0) {
  __ZN5physx16PxsIslandManager23updateIslandsSecondPassERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i9, i2);
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 do {
  i7 = HEAP32[i3 + (i1 << 4) + 12 >> 2] | 0;
  i8 = i5 + (i7 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i7 & 31);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN5physx16PxsIslandManager23updateIslandsSecondPassERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i9, i2);
 return;
}

function __ZN26AnimatorControllerPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIPS_Lj4EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i2 = i9;
 i3 = i10 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i4 = HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i9;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i11 = 12;
    break;
   } else i3 = 0;
  }
  if ((i11 | 0) == 12) {
   i11 = 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i10 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN21ProceduralTextureData15CopyFromTextureEP17ProceduralTexture(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i2) {
  HEAP32[i1 + 24 >> 2] = 0;
  i3 = i1 + 40 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP8[i1 + 28 >> 0] = 1;
  HEAP8[i1 + 29 >> 0] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP8[i1 + 60 >> 0] = 0;
  HEAP32[i1 + 64 >> 2] = 0;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[i2 + 152 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 156 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 160 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 168 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 172 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 176 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 164 >> 2];
 i3 = i2 + 192 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 200 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = HEAP16[i2 + 180 >> 1] | 0;
 HEAP8[i1 + 28 >> 0] = i3;
 HEAP8[i1 + 29 >> 0] = (i3 & 65535) >>> 8;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 184 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 208 >> 2];
 i3 = i1 + 60 | 0;
 HEAP8[i3 >> 0] = HEAP8[i2 + 212 >> 0] | 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 56 >> 2];
 if (!(HEAP8[i2 + 224 >> 0] | 0)) i1 = 0; else i1 = (HEAP32[i2 + 88 >> 2] | 0) != 0 & 1;
 HEAP8[i3 >> 0] = i1;
 return;
}

function __ZN16MecanimAnimation19PathHashesToIndicesERN5Unity9ComponentEPKjjPt(i1, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i10 + 4 | 0;
 if (HEAP8[i4 + 561 >> 0] | 0) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = __ZN8Animator17GetAvatarConstantEv(i4) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i11 = HEAP32[i1 >> 2] | 0;
 i3 = i11 + i1 | 0;
 i2 = i3;
 if ((i11 | 0) == 0 | (i3 | 0) == 0) {
  i11 = 0;
  STACKTOP = i10;
  return i11 | 0;
 }
 if (!i6) {
  i11 = 1;
  STACKTOP = i10;
  return i11 | 0;
 } else i1 = 0;
 do {
  i11 = __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i2, HEAP32[i5 + (i1 << 2) >> 2] | 0) | 0;
  i3 = (i11 | 0) != -1;
  HEAP16[i7 + (i1 << 1) >> 1] = i11;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i6 >>> 0 & i3);
 if (i3) {
  i11 = 1;
  STACKTOP = i10;
  return i11 | 0;
 }
 i1 = __ZN8Animator9GetAvatarEv(i4) | 0;
 i2 = (i1 | 0) == 0;
 if (i2) i3 = gb + 906627 | 0; else i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i8 >> 2] = i3;
 __Z6FormatPKcz(i9, gb + 906632 | 0, i8);
 if (i2) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, 0, gb + 906816 | 0, 45, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 i11 = 0;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE15growAndPushBackERKS5_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 687437 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN22ForwardLinearAllocatorD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i6 + 8 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1;
 if ((i4 | 0) != (i6 | 0)) {
  i2 = i4;
  do {
   i3 = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 8 >> 2] | 0, i3 + 20 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i6 | 0));
  i2 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
  i2 = i6 + 12 | 0;
  i3 = i7 + 4 | 0;
  i1 = i4;
  do {
   i4 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   i9 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = 72;
   HEAP32[i3 >> 2] = i9;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
  } while ((i1 | 0) != (i6 | 0));
  if (!(HEAP32[i5 >> 2] | 0)) {
   STACKTOP = i8;
   return;
  }
 }
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[HEAP32[i9 >> 2] >> 2] = i4;
 HEAP32[i5 >> 2] = 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = i6 + 12 | 0;
 i3 = i7 + 4 | 0;
 do {
  i9 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = 72;
  HEAP32[i3 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i7);
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function __ZN10AudioMixer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 873777 | 0, 40) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 174168 + 8;
 i2 = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 32 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i4 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = i4;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAPF32[i4 + 96 >> 2] = Math_fround(-80.0);
 HEAP8[i4 + 100 >> 0] = 1;
 HEAP32[i4 + 104 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function ___dynamic_cast(i1, i2, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i10 = HEAP32[i1 >> 2] | 0;
 i13 = i1 + (HEAP32[i10 + -8 >> 2] | 0) | 0;
 i10 = HEAP32[i10 + -4 >> 2] | 0;
 HEAP32[i12 >> 2] = i11;
 HEAP32[i12 + 4 >> 2] = i1;
 HEAP32[i12 + 8 >> 2] = i2;
 HEAP32[i12 + 12 >> 2] = i3;
 i1 = i12 + 16 | 0;
 i2 = i12 + 20 | 0;
 i3 = i12 + 24 | 0;
 i4 = i12 + 28 | 0;
 i5 = i12 + 32 | 0;
 i6 = i12 + 40 | 0;
 i7 = (i10 | 0) == (i11 | 0);
 i8 = i1;
 i9 = i8 + 36 | 0;
 do {
  HEAP32[i8 >> 2] = 0;
  i8 = i8 + 4 | 0;
 } while ((i8 | 0) < (i9 | 0));
 HEAP16[i1 + 36 >> 1] = 0;
 HEAP8[i1 + 38 >> 0] = 0;
 L1 : do if (i7) {
  HEAP32[i12 + 48 >> 2] = 1;
  mftCall_viiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 20 >> 2] | 0, i11 | 0, i12 | 0, i13 | 0, i13 | 0, 1, 0);
  i1 = (HEAP32[i3 >> 2] | 0) == 1 ? i13 : 0;
 } else {
  mftCall_viiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i12 | 0, i13 | 0, 1, 0);
  switch (HEAP32[i12 + 36 >> 2] | 0) {
  case 0:
   {
    i1 = (HEAP32[i6 >> 2] | 0) == 1 & (HEAP32[i4 >> 2] | 0) == 1 & (HEAP32[i5 >> 2] | 0) == 1 ? HEAP32[i2 >> 2] | 0 : 0;
    break L1;
   }
  case 1:
   break;
  default:
   {
    i1 = 0;
    break L1;
   }
  }
  if ((HEAP32[i3 >> 2] | 0) != 1) if (!((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i4 >> 2] | 0) == 1 & (HEAP32[i5 >> 2] | 0) == 1)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 >> 2] | 0;
 } while (0);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZNK9Texture3D11GetPixels32EP11ColorRGBA32i(i2, i10, i11) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (!i10) return;
 i1 = i2 + 96 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418864 | 0, 0, gb + 411375 | 0, 322, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if (!((i11 | 0) > -1 & (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) > (i11 | 0))) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 411375 | 0, 329, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i2 + 80 >> 2] | 0;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 i9 = HEAP32[i2 + 88 >> 2] | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 i3 = HEAP32[gb + 45784 + (i5 << 2) >> 2] | 0;
 if ((i11 | 0) > 0) {
  i2 = 0;
  i1 = 0;
  i4 = 0;
  do {
   i14 = i7 >> i2;
   i13 = i8 >> i2;
   i12 = i9 >> i2;
   i12 = Math_imul(Math_imul(Math_imul((i14 | 0) < 1 ? 1 : i14, i3) | 0, (i13 | 0) < 1 ? 1 : i13) | 0, (i12 | 0) < 1 ? 1 : i12) | 0;
   i1 = _i64Add(i12 | 0, ((i12 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i4 | 0) | 0;
   i4 = getTempRet0() | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i11 | 0));
 } else i1 = 0;
 i13 = i7 >> i11;
 i13 = (i13 | 0) < 1 ? 1 : i13;
 i14 = i8 >> i11;
 i12 = i9 >> i11;
 i14 = Math_imul((i12 | 0) < 1 ? 1 : i12, (i14 | 0) < 1 ? 1 : i14) | 0;
 __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_(i6 + i1 | 0, i13, i14, i5, 0, 0, i13, i14, i10) | 0;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_18NpArticulationLinkENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 16 | 0;
  if (i1 >>> 0 < 17 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 686473 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 20 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 16 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN26DownloadHandlerAssetBundle17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i2 = i8 + 24 | 0;
 i3 = i8 + 12 | 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 if (HEAP32[i1 + 24 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i1 + 28 | 0;
 if ((HEAP32[i6 >> 2] | 0) != 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  HEAP32[i6 >> 2] = -1;
  __Z6FormatPKcz(i2, gb + 1026214 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1026280 | 0, 121, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i8;
  return;
 }
 if (__ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(i5) | 0) {
  HEAP32[i6 >> 2] = 2;
  STACKTOP = i8;
  return;
 } else {
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i3, HEAP32[i4 >> 2] | 0);
  HEAP32[i7 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  __Z6FormatPKcz(i2, gb + 1026386 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1026280 | 0, 129, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  HEAP32[i6 >> 2] = -1;
  STACKTOP = i8;
  return;
 }
}

function __ZN13GfxDeviceGLES29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i8) return;
 i10 = i1 + 8464 | 0;
 i11 = i1 + 8468 | 0;
 i12 = i1 + 8472 | 0;
 i7 = i1 + 8468 | 0;
 i6 = 0;
 do {
  i5 = i9 + (i6 << 2) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i1 = HEAP32[i11 >> 2] | 0;
   if (i1 | 0) {
    i3 = i11;
    L8 : while (1) {
     i2 = i1;
     while (1) {
      if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
      i1 = HEAP32[i2 + 4 >> 2] | 0;
      if (!i1) break L8; else i2 = i1;
     }
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) {
      i3 = i2;
      break;
     } else i3 = i2;
    }
    if ((i3 | 0) != (i11 | 0)) if (!((i3 | 0) == (i11 | 0) ? 1 : i4 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0)) {
     i1 = HEAP32[i3 + 20 >> 2] | 0;
     if (i1 | 0) __ZN14DataBufferGLES7ReleaseEv(i1);
     HEAP32[i5 >> 2] = 0;
     i1 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i1) {
      i2 = i3;
      while (1) {
       i1 = HEAP32[i2 + 8 >> 2] | 0;
       if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
      }
     } else while (1) {
      i2 = HEAP32[i1 >> 2] | 0;
      if (!i2) break; else i1 = i2;
     }
     if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
     HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
     __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 >> 2] | 0, i3);
     __ZdlPv(i3);
    }
   }
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 return;
}

function __Z45Texture2D_CUSTOM_LoadRawTextureData_ImplArrayP12Il2CppObjectP11Il2CppArray(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 111 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 1) | 0;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 if ((i2 | 0) == 0 | (i3 | 0) == 0) {
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 570566 | 0, 0, gb + 570137 | 0, 454, 1, i1, 0, 0);
  STACKTOP = i7;
  return;
 }
 if (__ZN9Texture2D18LoadRawTextureDataEPKvj(i1, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i1 + 40 >> 2] | 0) >>> 0 > i3 >>> 0) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570613 | 0, i6); else {
  STACKTOP = i7;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 64 | 0;
 i7 = i3;
 i2 = i3 + 72 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 1034429 | 0, i7, 0);
 __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i7, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNK7b2Mat3315GetSymInverse33EPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f12 = Math_fround(f4 * f10);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f13 = Math_fround(f12 - Math_fround(f6 * f7));
 f9 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f6 = Math_fround(f6 * f9);
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f11 = Math_fround(f10 * f3);
 f6 = Math_fround(f6 - f11);
 f8 = Math_fround(Math_fround(f7 * f3) - Math_fround(f4 * f9));
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f13 * f5);
 f6 = Math_fround(f13 + Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f6));
 f6 = Math_fround(f6 + Math_fround(f8 * Math_fround(HEAPF32[i1 + 8 >> 2])));
 i1 = f6 != Math_fround(0.0);
 f13 = Math_fround(Math_fround(1.0) / f6);
 f6 = i1 ? f13 : f6;
 HEAPF32[i2 >> 2] = Math_fround(f6 * Math_fround(f12 - Math_fround(f7 * f7)));
 f11 = Math_fround(f6 * Math_fround(Math_fround(f9 * f7) - f11));
 HEAPF32[i2 + 4 >> 2] = f11;
 f8 = Math_fround(f6 * f8);
 HEAPF32[i2 + 8 >> 2] = f8;
 HEAPF32[i2 + 12 >> 2] = f11;
 HEAPF32[i2 + 16 >> 2] = Math_fround(f6 * Math_fround(Math_fround(f5 * f10) - Math_fround(f9 * f9)));
 f7 = Math_fround(f6 * Math_fround(Math_fround(f9 * f3) - Math_fround(f5 * f7)));
 HEAPF32[i2 + 20 >> 2] = f7;
 HEAPF32[i2 + 24 >> 2] = f8;
 HEAPF32[i2 + 28 >> 2] = f7;
 HEAPF32[i2 + 32 >> 2] = Math_fround(f6 * Math_fround(Math_fround(f5 * f4) - Math_fround(f3 * f3)));
 return;
}

function __ZNK12CubemapArray9GetPixelsEiP10ColorRGBAf11CubemapFaceii(i2, i3, i7, i8, i9, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 12 | 0;
 if (!(__ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii(i2, i3, i7, i8, i9, i1) | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = HEAP32[i2 + 92 >> 2] | 0;
 i4 = HEAP32[i2 + 100 >> 2] | 0;
 i14 = i2 + 80 | 0;
 i6 = HEAP32[i14 >> 2] | 0;
 i5 = i2 + 88 | 0;
 i6 = __Z21CalculateMipMapOffsetii13TextureFormati(i6, i6, HEAP32[i5 >> 2] | 0, i1) | 0;
 i14 = HEAP32[i14 >> 2] >> i1;
 i15 = (i14 | 0) < 1;
 i1 = i15 ? 1 : i14;
 i14 = Math_imul(i14, i14) | 0;
 if (((i15 ? 1 : i14) | 0) > (i3 | 0)) {
  HEAP32[i12 >> 2] = i3;
  HEAP32[i12 + 4 >> 2] = i1;
  HEAP32[i12 + 8 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 418334 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 397053 | 0, 321, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i15 = 0;
  STACKTOP = i13;
  return i15 | 0;
 } else {
  i15 = i11 + (Math_imul(i4, (i9 * 6 | 0) + i8 | 0) | 0) + i6 | 0;
  __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i15, i1, i1, HEAP32[i5 >> 2] | 0, 0, 0, i1, i1, i7) | 0;
  i15 = 1;
  STACKTOP = i13;
  return i15 | 0;
 }
 return 0;
}

function __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E5Int64Ex(i2, i11, i12) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = i2 + 28 | 0;
 i10 = i2 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = i2 + 44 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i3 = i6;
 i8 = i1;
 if ((i1 + 24 | 0) >>> 0 >= i6 >>> 0) {
  i4 = i2 + 36 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5;
  if (!i5) {
   if (!(HEAP32[i7 >> 2] | 0)) {
    i3 = __Znwj(1) | 0;
    HEAP32[i7 >> 2] = i3;
    HEAP32[i2 + 32 >> 2] = i3;
   }
   i1 = HEAP32[i2 + 48 >> 2] | 0;
  } else {
   i1 = i3 - i6 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i6 = i8 - i6 | 0;
  i8 = i6 + 24 | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i5, i8, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i4 >> 2] = i7;
  i1 = i7 + i6 | 0;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i9 >> 2] = i7 + i8;
 }
 HEAP32[i10 >> 2] = i1 + 24;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 4614;
 i10 = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i10 + 4 >> 2] = i12;
 if ((i12 | 0) > -1 | (i12 | 0) == -1 & i11 >>> 0 > 4294967295) {
  i1 = i12 >>> 0 > 0 | (i12 | 0) == 0 & i11 >>> 0 > 4294967295 ? 12806 : 14854;
  HEAP32[i2 >> 2] = i1;
  if (i12 >>> 0 > 0 | (i12 | 0) == 0 & i11 >>> 0 > 2147483647) return 1;
  HEAP32[i2 >> 2] = i1 | 1024;
  return 1;
 } else {
  if (!((i12 | 0) > -1 | (i12 | 0) == -1 & i11 >>> 0 > 2147483647)) return 1;
  HEAP32[i2 >> 2] = 5638;
  return 1;
 }
 return 0;
}

function __ZN8JSONRead8TransferIN11UnityEngine7Connect13ConnectConfig14GroupingConfigEEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1041001;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1041016 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1041033 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1041050 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1041072 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 16 | 0, gb + 1041091 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 20 | 0, gb + 1041127 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 24 | 0, gb + 1041150 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc8ShapeSimENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 687567 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 3;
  i2 = i7 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 707647 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 i4 = i1 + (i3 << 3) | 0;
 i5 = i7 + 36 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i2;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
  }
 }
 i2 = i7 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 32 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE15growAndPushBackERKS3_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 524 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i1 = 0; else {
  i1 = i8 << 4;
  i2 = i9 + 512 | 0;
  if (i1 >>> 0 < 513 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i9, i1, gb + 838004 | 0, 543) | 0;
 }
 i5 = i9 + 520 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 << 4) | 0;
 i6 = i9 + 516 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   i2 = i2 + 16 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 16 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i1 + (i2 << 4) | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i9 | 0) == (i2 | 0)) {
   HEAP8[i9 + 512 >> 0] = 0;
   break;
  } else {
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i9, i2);
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i10 >> 2] = i8;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + 1;
 return i1 + (i10 << 4) | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN31CanvasBatchIntermediateRendererC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP16[i1 + 184 >> 1] = 0;
 HEAP16[i1 + 186 >> 1] = 0;
 HEAP32[i1 + 188 >> 2] = -2147450880;
 HEAP32[i1 + 192 >> 2] = 0;
 i3 = i1 + 236 | 0;
 i5 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16515072 | 1353;
 HEAP16[i3 >> 1] = i5;
 HEAP8[i3 + 2 >> 0] = i5 >>> 16;
 i3 = i1 + 228 | 0;
 HEAP16[i3 + 2 >> 1] = -1;
 HEAP16[i3 >> 1] = -1;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 232 >> 2] = -1;
 HEAP8[i1 + 240 >> 0] = 1;
 HEAP8[i1 + 241 >> 0] = 1;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 i3 = i1 + 264 | 0;
 HEAP32[i1 >> 2] = gb + 33700 + 8;
 HEAP32[i3 >> 2] = gb + 33700 + 80;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = i3;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 300 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = 0;
 HEAP32[i1 + 316 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 304 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN12AspectRatios8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 16 | 0;
 i6 = i4 + 24 | 0;
 i1 = i3 + 1 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i3, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z29CubemapArray_CUSTOM_GetPixelsP12Il2CppObjectiii(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i4 = __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i8;
 i1 = Math_imul(i2, i2) | 0;
 i1 = (i2 | 0) < 1 ? 1 : i1;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, i1) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZNK12CubemapArray9GetPixelsEiP10ColorRGBAf11CubemapFaceii(i4, i1, i3, i6, i7, i8) | 0;
  STACKTOP = i9;
  return i2 | 0;
 }
 return 0;
}

function _cff_builder_start_point(i2, i7, i8) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i2 + 64 | 0;
 i3 = HEAP16[i1 >> 1] | 0;
 if ((i3 & 255) << 24 >> 24) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i5 = i2 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 65 | 0;
 if ((i3 & 65535) < 256) {
  HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
  i1 = i2 + 12 | 0;
 } else {
  i1 = i2 + 12 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (((HEAP16[i2 + 20 >> 1] | 0) + 1 + (HEAP16[i2 + 56 >> 1] | 0) | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
   i2 = _UNITY_FT_GlyphLoader_CheckPoints(i2, 0, 1) | 0;
   if (i2 | 0) {
    i8 = i2;
    return i8 | 0;
   }
  }
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = i3 & 65535;
  if (i2 << 16 >> 16 > 0) {
   HEAP16[(HEAP32[i4 + 12 >> 2] | 0) + ((i3 << 16 >> 16) + -1 << 1) >> 1] = (i3 >>> 16) + 65535;
   i2 = HEAP16[i4 >> 1] | 0;
  }
  HEAP16[i4 >> 1] = i2 + 1 << 16 >> 16;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (((HEAP16[i1 + 22 >> 1] | 0) + 1 + (HEAP16[i1 + 58 >> 1] | 0) | 0) >>> 0 > (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
  i1 = _UNITY_FT_GlyphLoader_CheckPoints(i1, 1, 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   return i8 | 0;
  }
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP8[i6 >> 0] | 0)) i1 = i1 + 2 | 0; else {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = i1 + 2 | 0;
  i5 = HEAP16[i6 >> 1] | 0;
  i1 = (HEAP32[i1 + 8 >> 2] | 0) + i5 | 0;
  HEAP32[i4 + (i5 << 3) >> 2] = i7 >> 10;
  HEAP32[i4 + (i5 << 3) + 4 >> 2] = i8 >> 10;
  HEAP8[i1 >> 0] = 1;
  i1 = i6;
 }
 HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
 i8 = 0;
 return i8 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyERKN5physx8debugger14NamespacedNameEPKc(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropImplERKN5physx8debugger14NamespacedNameEPKc(i3, i1, i2) | 0;
 HEAP32[i4 >> 2] = gb + 148864 + 8;
 if (!i1) {
  HEAP32[i4 + 4 >> 2] = gb + 1576256;
  HEAP32[i4 + 8 >> 2] = gb + 1576256;
  HEAP32[i4 + 12 >> 2] = -1;
  HEAP32[i4 + 16 >> 2] = gb + 1576256;
  HEAP32[i4 + 20 >> 2] = gb + 1576256;
  HEAP32[i4 + 24 >> 2] = -1;
  HEAP32[i4 + 28 >> 2] = gb + 1576256;
  HEAP32[i4 + 32 >> 2] = gb + 1576256;
  HEAP32[i4 + 36 >> 2] = 0;
  HEAP32[i4 + 40 >> 2] = -1;
  HEAP32[i4 + 44 >> 2] = 0;
  HEAP32[i4 + 48 >> 2] = 0;
  i3 = 0;
  i4 = i4 + 52 | 0;
  HEAP8[i4 >> 0] = i3;
  return;
 } else {
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i4 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i5 = i1 + 16 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i2 = i4 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  i2 = i4 + 28 | 0;
  i3 = i1 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
  i1 = i1 + 44 | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i4 + 44 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  i3 = 1;
  i4 = i4 + 52 | 0;
  HEAP8[i4 >> 0] = i3;
  return;
 }
}

function __ZN6prcoreL27StretchGenericFloatBilinearI16TexFormatRGFloatEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(Math_fround(1.0) - f5);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i9 = i2 >>> 16 << 1;
  f10 = Math_fround(Math_fround((i2 & 65535) >>> 0) * Math_fround(.0000152587891));
  f12 = Math_fround(Math_fround(1.0) - f10);
  i15 = i9 + 2 | 0;
  f11 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f13 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  f14 = Math_fround(HEAPF32[i8 + (i9 << 2) >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i15 << 2) >> 2])))));
  i15 = i9 | 1;
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i9 = i9 + 3 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i9 << 2) >> 2])))));
  i1 = i1 + -1 | 0;
  if (!i1) break; else {
   i3 = i3 + 8 | 0;
   i2 = i4 + i2 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i7, i2, i5, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 if (!i2) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = i2 + 15 | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = (Math_imul(i1 >>> 16 | i1, 130329821) | 0) >>> 27;
 i1 = HEAP32[gb + 85120 + (i1 << 2) >> 2] | 0;
 i1 = i1 >>> 0 < 8 ? 8 : i1;
 if (i1 >>> 0 < 17) {
  i8 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 108 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
  i4 = HEAP32[(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 96 >> 2] | 0;
  i2 = i4 + (i1 + -8 << 2) | 0;
  i4 = i4 + (i1 + -5 << 2) | 0;
  i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i3 = (HEAP32[i3 + 96 >> 2] | 0) + (HEAP32[i3 + 100 >> 2] << 2) | 0;
  i3 = i4 >>> 0 < i3 >>> 0 ? i4 : i3;
  L6 : do if (i2 >>> 0 < i3 >>> 0) {
   i4 = i2;
   while (1) {
    i2 = HEAP32[i4 >> 2] | 0;
    if (i2 | 0) {
     i1 = i4;
     break;
    }
    i4 = i4 + 4 | 0;
    if (i4 >>> 0 >= i3 >>> 0) {
     i9 = 7;
     break L6;
    }
   }
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = (i1 - (HEAP32[(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 96 >> 2] | 0) >> 2) + 8 | 0;
  } else i9 = 7; while (0);
  if ((i9 | 0) == 7) i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, 2 << i1, i5, i6) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 } else i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i2 + 16 | 0, i5, i6) | 0;
 HEAP32[i2 >> 2] = i1;
 i9 = i2 + 16 | 0;
 return i9 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN21DownloadHandlerBuffer13OnReceiveDataEPKvj(i10, i11, i12) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i2 = i13;
 if ((HEAP16[gb + 1468892 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1468892 | 0, i1);
  i8 = gb + 1468892 | 0;
 } else i8 = 0;
 i6 = i10 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i10 + 32 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i2 = i9 + i12 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i10 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 1, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  }
 } while (0);
 _memcpy(i1 + i9 | 0, i11 | 0, i12 | 0) | 0;
 i14 = i10 + 16 | 0;
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i12;
 if (!i8) {
  STACKTOP = i13;
  return i12 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i8);
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN18AudioLowPassFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 171508 + 8;
 HEAPF32[i1 + 48 >> 2] = Math_fround(inf);
 HEAP32[i1 + 44 >> 2] = 0;
 i5 = i1 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i1 + 76 >> 2] = Math_fround(inf);
 HEAP32[i1 + 72 >> 2] = 0;
 i5 = i1 + 80 | 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 + 124 >> 2] = 2;
 HEAP32[i1 + 120 >> 2] = 2;
 HEAP32[i1 + 128 >> 2] = 4;
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 136 >> 0] = 0;
 HEAP32[i3 >> 2] = 3;
 STACKTOP = i4;
 return;
}

function __ZN15NavMeshObstacle11UpdateStateEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, f3 = f0, f5 = f0, i6 = 0;
 if (HEAP32[i4 + 136 >> 2] & 8 | 0) {
  i6 = i4 + 148 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  __ZN15NavMeshObstacle17SnapshotTransformEv(i4);
 }
 f5 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 f3 = Math_fround(HEAPF32[i4 + 72 >> 2]);
 i6 = f3 > Math_fround(9.99999974e-06);
 f1 = i6 ? f3 : Math_fround(9.99999974e-06);
 f3 = Math_fround(f3 * Math_fround(.100000001));
 i6 = f3 > Math_fround(9.99999974e-06);
 f3 = i6 ? f3 : Math_fround(9.99999974e-06);
 if (!(HEAP8[i4 + 69 >> 0] | 0)) {
  if (__ZNK15NavMeshObstacle8HasMovedEf(i4, f1) | 0) {
   i6 = i4 + 148 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   __ZN15NavMeshObstacle17SnapshotTransformEv(i4);
  }
  HEAP32[i4 + 140 >> 2] = 0;
  HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  return;
 }
 i6 = i4 + 140 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  if (!(__ZNK15NavMeshObstacle8HasMovedEf(i4, f1) | 0)) return;
  HEAP32[i6 >> 2] = 1;
  HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  i6 = i4 + 148 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  __ZN15NavMeshObstacle17SnapshotTransformEv(i4);
  return;
 }
 i2 = i4 + 144 | 0;
 if (__ZNK15NavMeshObstacle8HasMovedEf(i4, f3) | 0) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  __ZN15NavMeshObstacle17SnapshotTransformEv(i4);
  return;
 }
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i2 >> 2] = f5;
 if (!(f5 > Math_fround(HEAPF32[i4 + 76 >> 2]))) return;
 HEAP32[i6 >> 2] = 0;
 i6 = i4 + 148 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZN12InputManager5ResetEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = HEAP32[i9 + 28 >> 2] | 0;
 i5 = i9 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i3 + 4 | 0;
  i7 = i3 + 4 | 0;
  i8 = i3 + 4 | 0;
  do {
   i2 = i1 + -108 | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i2 >> 2] = gb + 59740 + 8;
   i2 = i1 + -68 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -56 >> 2] | 0;
    HEAP32[i3 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
   }
   i2 = i1 + -84 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i1 + -72 >> 2] | 0;
    HEAP32[i3 >> 2] = 66;
    HEAP32[i7 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i3);
   }
   i2 = i1 + -104 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i1 + -92 >> 2] | 0;
    HEAP32[i3 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i3);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = i9 + 148 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i9 + 152 >> 2] = 0;
  __ZN12InputManager11MakeDefaultEv(i9);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
  __ZN12InputManager11MakeDefaultEv(i9);
  STACKTOP = i10;
  return;
 }
}

function __ZN10HumanTrait12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = HEAP32[gb + 1467160 >> 2] | 0;
 if (i6 | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) {
   i4 = i6 + 4 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    i5 = i7 + 4 | 0;
    do {
     i3 = i2 + -16 | 0;
     HEAP32[i4 >> 2] = i3;
     if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i2 + -4 >> 2] | 0;
      HEAP32[i7 >> 2] = 66;
      HEAP32[i5 >> 2] = i2;
      __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
      i2 = HEAP32[i4 >> 2] | 0;
     } else i2 = i3;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i6 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  __ZdlPv(i6);
 }
 HEAP32[gb + 1467160 >> 2] = 0;
 i6 = HEAP32[gb + 1467164 >> 2] | 0;
 if (!i6) {
  HEAP32[gb + 1467164 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i4 = i6 + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i5 = i7 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i4 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i7 >> 2] = 66;
     HEAP32[i5 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
     i2 = HEAP32[i4 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZdlPv(i6);
 HEAP32[gb + 1467164 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZL12SweepBoxMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE(i8, i9, i6, i4, i5, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 32 | 0;
 i3 = i10;
 i1 = HEAP32[i6 + 40 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i12 = (HEAP32[i8 + 8 >> 2] | 0) + ((HEAP32[i6 + 44 >> 2] | 0) * 36 | 0) | 0;
 i11 = HEAP32[i8 + 100 + (HEAP32[i8 + 96 >> 2] << 2) >> 2] | 0;
 HEAP32[i2 >> 2] = 3;
 i16 = i9 + 40 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i9 + 48 >> 2];
 f15 = Math_fround(+HEAPF64[i4 >> 3] - +HEAPF64[i6 + 16 >> 3]);
 f14 = Math_fround(+HEAPF64[i4 + 8 >> 3] - +HEAPF64[i6 + 24 >> 3]);
 f13 = Math_fround(+HEAPF64[i4 + 16 >> 3] - +HEAPF64[i6 + 32 >> 3]);
 HEAP32[i3 >> 2] = HEAP32[i8 + 228 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 232 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 236 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 240 >> 2];
 HEAPF32[i3 + 16 >> 2] = f15;
 HEAPF32[i3 + 20 >> 2] = f14;
 HEAPF32[i3 + 24 >> 2] = f13;
 i9 = __ZL17sweepVolumeVsMeshPKN5physx3Cct9SweepTestEPKNS0_11TouchedMeshERNS0_12SweptContactERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleEj(i8, i6, i7, i5, i2, i3, i1, i12, i11 >>> 0 >= i1 >>> 0 ? 0 : i11) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z39GetDefaultApplicationIdentifierForCachev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 390862 | 0, 6);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 390862 | 0, 6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 390862 | 0, 6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 4 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z10pqHeapInitP13PriorityQHeap(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = HEAP32[i9 + 8 >> 2] | 0;
 if ((i10 | 0) <= 0) {
  i14 = i9 + 20 | 0;
  HEAP32[i14 >> 2] = 1;
  return;
 }
 i11 = HEAP32[i9 >> 2] | 0;
 i12 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i10;
 while (1) {
  i13 = HEAP32[i11 + (i7 << 2) >> 2] | 0;
  i14 = i12 + (i13 << 3) | 0;
  i8 = i7;
  while (1) {
   i1 = i8 << 1;
   do if ((i1 | 0) < (i10 | 0)) {
    i2 = i1 | 1;
    i3 = HEAP32[i12 + (HEAP32[i11 + (i2 << 2) >> 2] << 3) >> 2] | 0;
    f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
    i5 = HEAP32[i12 + (HEAP32[i11 + (i1 << 2) >> 2] << 3) >> 2] | 0;
    f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
    if (!(f4 < f6)) {
     if (!(f4 == f6)) break;
     f6 = Math_fround(HEAPF32[i3 + 28 >> 2]);
     if (!(f6 <= Math_fround(HEAPF32[i5 + 28 >> 2]))) break;
    }
    i1 = i2;
   } while (0);
   i2 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
   if ((i1 | 0) > (i10 | 0)) break;
   i3 = HEAP32[i14 >> 2] | 0;
   f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
   i5 = HEAP32[i12 + (i2 << 3) >> 2] | 0;
   f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
   if (f4 < f6) break;
   if (f4 == f6) {
    f6 = Math_fround(HEAPF32[i3 + 28 >> 2]);
    if (f6 <= Math_fround(HEAPF32[i5 + 28 >> 2])) break;
   }
   HEAP32[i11 + (i8 << 2) >> 2] = i2;
   HEAP32[i12 + (i2 << 3) + 4 >> 2] = i8;
   i8 = i1;
  }
  HEAP32[i11 + (i8 << 2) >> 2] = i13;
  HEAP32[i12 + (i13 << 3) + 4 >> 2] = i8;
  if ((i7 | 0) > 1) i7 = i7 + -1 | 0; else break;
 }
 i14 = i9 + 20 | 0;
 HEAP32[i14 >> 2] = 1;
 return;
}

function __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 85;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 85;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx3Scb10Constraint9syncStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i2 + 12 | 0;
 __ZNK5physx2Sc14ConstraintCore8getForceERNS_6PxVec3ES3_(i5, i2 + 84 | 0, i2 + 96 | 0);
 i7 = i2 + 108 | 0;
 HEAP16[i7 >> 1] = (HEAPU16[i5 >> 1] | 0) & 1;
 i8 = i2 + 4 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 8 | 0;
 if (!(i6 & 16777215)) {
  HEAP32[i3 >> 2] = 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 & -16777216;
  HEAP32[i8 >> 2] = i7;
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i6 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 if (i6 & 1 | 0) __ZN5physx2Sc14ConstraintCore9setBodiesEPNS0_9RigidCoreES3_(i5, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 if (i6 & 2 | 0) {
  f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  __ZN5physx2Sc14ConstraintCore13setBreakForceEff(i5, f10, Math_fround(HEAPF32[i1 + 12 >> 2]));
 }
 if (i6 & 8 | 0) __ZN5physx2Sc14ConstraintCore23setMinResponseThresholdEf(i5, Math_fround(HEAPF32[i1 + 20 >> 2]));
 if (!(i6 & 4)) {
  HEAP32[i3 >> 2] = 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 & -16777216;
  HEAP32[i8 >> 2] = i7;
  STACKTOP = i9;
  return;
 }
 HEAP16[i4 >> 1] = HEAP16[i7 >> 1] | HEAP16[i1 + 16 >> 1];
 __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i5, i4);
 HEAP32[i3 >> 2] = 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 & -16777216;
 HEAP32[i8 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sq8AABBTree12markForRefitEj(i12, i2) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) {
  i9 = HEAP32[i12 + 536 >> 2] | 0;
  i10 = i12 + 12 | 0;
  HEAP32[i10 >> 2] = ((i9 & 31 | 0) != 0 & 1) + (i9 >>> 5);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i13 + 1 | 0, i1);
  i9 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13, HEAP32[i10 >> 2] << 2, gb + 706818 | 0, 45) | 0;
  HEAP32[i11 >> 2] = i9;
  _memset(i9 | 0, 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
 }
 i8 = i12 + 4 | 0;
 i9 = i12 + 16 | 0;
 i10 = i12 + 20 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) + (i2 * 24 | 0) | 0;
 while (1) {
  i1 = HEAP32[i8 >> 2] | 0;
  i6 = (i7 - i1 | 0) / 24 | 0;
  i2 = i6 >>> 5;
  i3 = (HEAP32[i11 >> 2] | 0) + (i2 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = 1 << (i6 & 31);
  if (i4 & i5 | 0) {
   i1 = 8;
   break;
  }
  HEAP32[i3 >> 2] = i4 | i5;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 >>> 0 < i2 >>> 0 ? i2 : i5;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2 >>> 0 < 128) {
   HEAP32[i12 + 24 + (i2 << 2) >> 2] = i6;
   i2 = HEAP32[i10 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
  }
  HEAP32[i10 >> 2] = i2 + 1;
  i5 = i7 + 16 | 0;
  i5 = _bitshift64Lshr(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, 2) | 0;
  getTempRet0() | 0;
  i6 = i7;
  i7 = i1 + ((i5 & 524287) * 24 | 0) | 0;
  if ((i6 | 0) == (i7 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  STACKTOP = i13;
  return;
 }
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI23ManagedObjectTransfererEEvRT_17TransferMetaFlags(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i6, gb + 1041885 | 0, gb + 1041885 | 0, i8, i1);
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) i1 = gb + 1033805 | 0; else i1 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i6, gb + 1041891 | 0, i1, i2, 0);
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 + 20 >> 2] = i6;
 i4 = i2 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i6);
  __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i6);
  STACKTOP = i8;
  return;
 }
 i3 = i3 + 12 | 0;
 do {
  i9 = i1 + 64 | 0;
  HEAP32[i4 >> 2] = i9;
  HEAP32[i3 >> 2] = i2 - i9 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i7 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i6);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN17SubstanceEnumItem8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034365 | 0, HEAP32[gb + 37040 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 431317 | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i2, 1); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN15b2WheelJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i12 = i4 + 4 | 0;
 f7 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 i11 = i2 + 24 | 0;
 f6 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(f10 * f6);
 i2 = i2 + 20 | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(Math_fround(f6 * f7) - Math_fround(f10 * f9));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 + Math_fround(f7 * f9));
 HEAPF32[i1 + 24 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f7 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f10 * f7);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f10 = Math_fround(Math_fround(f7 * f9) - Math_fround(f10 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f8 + Math_fround(f9 * f6));
 HEAPF32[i1 + 32 >> 2] = f10;
 f10 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 f9 = Math_fround(f10 * f6);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f6 = Math_fround(Math_fround(f10 * f7) - Math_fround(f6 * f8));
 HEAPF32[i1 + 36 >> 2] = Math_fround(f9 + Math_fround(f8 * f7));
 HEAPF32[i1 + 40 >> 2] = f6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z39GraphicsSettings_CUSTOM_GetCustomShaderN16GraphicsSettings17BuiltinShaderTypeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, i1) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadyEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37296 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 8 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    i9 = i2;
    i8 = HEAP32[i9 + 4 >> 2] | 0;
    i2 = i4;
    HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
  if (HEAP32[i6 >> 2] & 512 | 0) {
   i8 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   i9 = i4 + 4 | 0;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = i8;
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadxEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37248 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 8 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    i9 = i2;
    i8 = HEAP32[i9 + 4 >> 2] | 0;
    i2 = i4;
    HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i2 + 4 >> 2] = i8;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 8);
  if (HEAP32[i6 >> 2] & 512 | 0) {
   i8 = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
   i9 = i4 + 4 | 0;
   HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i9 >> 2] = i8;
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 24) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 24) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZNK9Texture3D9GetPixelsEP10ColorRGBAfi(i2, i10, i11) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (!i10) return;
 i1 = i2 + 96 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418864 | 0, 0, gb + 411375 | 0, 322, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if (!((i11 | 0) > -1 & (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) > (i11 | 0))) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416780 | 0, 0, gb + 411375 | 0, 329, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i2 + 80 >> 2] | 0;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 i9 = HEAP32[i2 + 88 >> 2] | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 i3 = HEAP32[gb + 45784 + (i5 << 2) >> 2] | 0;
 if ((i11 | 0) > 0) {
  i2 = 0;
  i1 = 0;
  i4 = 0;
  do {
   i14 = i7 >> i2;
   i13 = i8 >> i2;
   i12 = i9 >> i2;
   i12 = Math_imul(Math_imul(Math_imul((i14 | 0) < 1 ? 1 : i14, i3) | 0, (i13 | 0) < 1 ? 1 : i13) | 0, (i12 | 0) < 1 ? 1 : i12) | 0;
   i1 = _i64Add(i12 | 0, ((i12 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i4 | 0) | 0;
   i4 = getTempRet0() | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i11 | 0));
 } else i1 = 0;
 i13 = i7 >> i11;
 i13 = (i13 | 0) < 1 ? 1 : i13;
 i14 = i8 >> i11;
 i12 = i9 >> i11;
 i14 = Math_imul((i12 | 0) < 1 ? 1 : i12, (i14 | 0) < 1 ? 1 : i14) | 0;
 __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i6 + i1 | 0, i13, i14, i5, 0, 0, i13, i14, i10) | 0;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN18GfxFramebufferGLES5ClearEjRK10ColorRGBAffib(i5, i4, i6, f7, i8, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 110 >> 0] | 0) if (HEAP8[i5 + 329 >> 0] | 0) {
  i1 = HEAP32[i5 + 212 >> 2] | 0;
  if (!(HEAP32[i5 + 296 >> 2] | 0)) if (!(HEAP32[i5 + 300 >> 2] | 0)) if ((HEAP32[i5 + 304 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) if ((HEAP32[i5 + 308 >> 2] | 0) == (HEAP32[i1 + 8 >> 2] | 0)) {
   HEAP8[i1 + 28 >> 0] = 0;
   HEAP8[(HEAP32[i5 + 244 >> 2] | 0) + 28 >> 0] = 0;
  }
 }
 __ZN18GfxFramebufferGLES7PrepareEv(i5);
 i2 = (i4 & 1 | 0) != 0 & ((__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[i5 + 92 >> 2] | 0) | 0) ^ 1);
 i1 = i5 + 124 | 0;
 i3 = (i4 & 2 | 0) != 0 & ((__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[i1 >> 2] | 0) | 0) ^ 1);
 if (!((i4 & 4 | 0) != 0 & ((__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[i1 >> 2] | 0) | 0) ^ 1))) {
  i4 = 0;
  i5 = i5 + 336 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi(i5, i2, i3, i4, i6, f7, i8);
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i1 + 31 >> 0] | 0) {
  i4 = 1;
  i5 = i5 + 336 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi(i5, i2, i3, i4, i6, f7, i8);
  return;
 }
 i4 = __ZN2gl20IsFormatDepthStencilENS_9TexFormatE(HEAP32[i1 + 40 >> 2] | 0) | 0;
 i5 = i5 + 336 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi(i5, i2, i3, i4, i6, f7, i8);
 return;
}

function __ZN13RenderTexture17MainThreadCleanupEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN13RenderTexture7ReleaseEv(i8);
 __ZN13RenderManager24OnRenderTextureDestroyedEP13RenderTexture(__Z16GetRenderManagerv() | 0, i8);
 i1 = i8 + 144 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = i8 + 148 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 }
 i6 = HEAP32[gb + 1158372 >> 2] | 0;
 i4 = i6 + 4 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 if (!i7) {
  __ZN7Texture17MainThreadCleanupEv(i8);
  return;
 }
 i5 = HEAP32[i8 + 124 >> 2] | 0;
 i3 = i4;
 i2 = i7;
 L7 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L7;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i4 | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i8);
  return;
 }
 if (i5 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
  __ZN7Texture17MainThreadCleanupEv(i8);
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i6 >> 2] | 0) == (i3 | 0)) HEAP32[i6 >> 2] = i1;
 i6 = i6 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i7, i3);
 __ZdlPv(i3);
 __ZN7Texture17MainThreadCleanupEv(i8);
 return;
}

function __Z68AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorClipInfoInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 8 | 0;
 i9 = i7;
 i6 = i7 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2, 1, i6) | 0;
 i2 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 8, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i10 = (HEAP32[i6 >> 2] | 0) + (i1 << 3) | 0;
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i10, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, i1, 8) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i2 | 0;
}

function __Z36Tree_Get_Custom_PropHasSpeedTreeWindP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 10; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 10; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 12;
  }
 }
 if ((i6 | 0) == 10) i6 = 12;
 if ((i6 | 0) == 12) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i6 = (i1 | 0) != 0 & 1;
 STACKTOP = i7;
 return i6 | 0;
}

function _erfcf(f3) {
 f3 = Math_fround(f3);
 var f1 = f0, i2 = 0, i4 = 0;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i4 >>> 31;
 i4 = i4 & 2147483647;
 do if (i4 >>> 0 > 2139095039) f1 = Math_fround(Math_fround(Math_fround(1.0) / f3) + Math_fround(i2 << 1 | 0)); else {
  if (i4 >>> 0 >= 1062731776) {
   i2 = (i2 | 0) != 0;
   if (i4 >>> 0 < 1105199104) {
    f1 = Math_fround(_erfc2_142(i4, f3));
    f3 = Math_fround(Math_fround(2.0) - f1);
    f1 = i2 ? f3 : f1;
    break;
   } else {
    f1 = i2 ? Math_fround(2.0) : Math_fround(0.0);
    break;
   }
  }
  if (i4 >>> 0 < 595591168) {
   f1 = Math_fround(Math_fround(1.0) - f3);
   break;
  }
  f1 = Math_fround(f3 * f3);
  f1 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(-.00577027025) - Math_fround(f1 * Math_fround(.0000237630175)))) + Math_fround(-.0284817498))) + Math_fround(-.325042099))) + Math_fround(.128379166)) / Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(.000132494737) - Math_fround(f1 * Math_fround(3.96022824e-06)))) + Math_fround(.00508130621))) + Math_fround(.0650222525))) + Math_fround(.397917211))) + Math_fround(1.0)));
  if ((i2 | 0) != 0 | i4 >>> 0 < 1048576e3) {
   f1 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f1 * f3) + f3));
   break;
  } else {
   f1 = Math_fround(Math_fround(.5) - Math_fround(Math_fround(f3 + Math_fround(-.5)) + Math_fround(f1 * f3)));
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZNSt3__211__stdoutbufIwE8overflowEj(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i3 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i12 = i14;
 i13 = (i9 | 0) == -1;
 do if (i13) i2 = 14; else {
  HEAP32[i3 >> 2] = i9;
  if (HEAP8[i1 + 44 >> 0] | 0) if ((_fwrite(i3, 4, 1, HEAP32[i1 + 32 >> 2] | 0) | 0) == 1) {
   i2 = 14;
   break;
  } else {
   i1 = -1;
   break;
  }
  HEAP32[i11 >> 2] = i10;
  i2 = i3 + 4 | 0;
  i4 = i1 + 36 | 0;
  i5 = i1 + 40 | 0;
  i6 = i10 + 8 | 0;
  i7 = i10;
  i8 = i1 + 32 | 0;
  while (1) {
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = mftCall_iiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i5 >> 2] | 0, i3 | 0, i2 | 0, i12 | 0, i10 | 0, i6 | 0, i11 | 0) | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i3 | 0)) {
    i2 = 13;
    break;
   }
   if ((i1 | 0) == 3) {
    i2 = 7;
    break;
   }
   if ((i1 | 1 | 0) != 1) {
    i2 = 13;
    break;
   }
   i3 = (HEAP32[i11 >> 2] | 0) - i7 | 0;
   if ((_fwrite(i10, 1, i3, HEAP32[i8 >> 2] | 0) | 0) != (i3 | 0)) {
    i2 = 13;
    break;
   }
   if ((i1 | 0) == 1) i3 = HEAP32[i12 >> 2] | 0; else {
    i2 = 12;
    break;
   }
  }
  if ((i2 | 0) == 7) if ((_fwrite(i3, 1, 1, HEAP32[i8 >> 2] | 0) | 0) == 1) i2 = 12; else i2 = 13;
  if ((i2 | 0) == 12) {
   i2 = 14;
   break;
  } else if ((i2 | 0) == 13) {
   i1 = -1;
   break;
  }
 } while (0);
 if ((i2 | 0) == 14) i1 = i13 ? 0 : i9;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZNK9ShaderLab9IntShader6GetTagEib(i2, i9, i1) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (i1) {
  i4 = (HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] | 0) + 28 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) {
   i9 = -1;
   return i9 | 0;
  } else i1 = i4;
  L5 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i9 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L5; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) == (i4 | 0)) {
   i9 = -1;
   return i9 | 0;
  }
  if ((HEAP32[i1 + 16 >> 2] | 0) > (i9 | 0)) {
   i9 = -1;
   return i9 | 0;
  }
  i9 = HEAP32[i1 + 20 >> 2] | 0;
  return i9 | 0;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i7 = i1;
 if ((i3 | 0) == (i1 | 0)) {
  i9 = -1;
  return i9 | 0;
 }
 i6 = i3 - i1 >> 2;
 i4 = 0;
 while (1) {
  i5 = (HEAP32[i7 + (i4 << 2) >> 2] | 0) + 28 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2 | 0) {
   i1 = i5;
   L26 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i9 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L26; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) != (i5 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i9 | 0)) break;
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i6 >>> 0) {
   i1 = -1;
   i8 = 21;
   break;
  }
 }
 if ((i8 | 0) == 21) return i1 | 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 2;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN17CapsuleCollider2D16CheckConsistencyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN5Unity9Component16CheckConsistencyEv(i5);
 i1 = i5 + 48 | 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f8 < Math_fround(0.0);
 i3 = f8 > Math_fround(1.0e6);
 f8 = i3 ? Math_fround(1.0e6) : f8;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f8;
 i1 = i5 + 40 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i5 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i2 = gb + 1162356 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i1 = i5 + 160 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i5 + 164 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i2 & 2139095040 | 0) != 2139095040 & (i4 & 2139095040 | 0) != 2139095040) {
  f8 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i6 >> 2] = Math_fround(.0000999999974);
  i4 = f9 > Math_fround(.0000999999974);
  HEAP32[i1 >> 2] = HEAP32[(i4 ? i1 : i6) >> 2];
  HEAPF32[i6 >> 2] = Math_fround(.0000999999974);
  i4 = f8 > Math_fround(.0000999999974);
  HEAP32[i3 >> 2] = HEAP32[(i4 ? i3 : i6) >> 2];
 } else {
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i3 >> 2] = Math_fround(1.0);
 }
 i1 = i5 + 168 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 < 2) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 32 | 0;
 i3 = i7 + 16 | 0;
 i4 = i7;
 i5 = i7 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37260 >> 2] | 0, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i3, 1);
  i5 = i3 + 11 | 0;
  i2 = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  i11 = gb + 63648 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = i10;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN14ConstantString6assignEPKc10MemLabelId(i9, i2, i6);
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   i11 = HEAP32[i3 >> 2] | 0;
   i10 = HEAP32[i3 + 12 >> 2] | 0;
   HEAP32[i6 >> 2] = 1;
   HEAP32[i6 + 4 >> 2] = i10;
   __Z19free_alloc_internalPvRK10MemLabelId(i11, i6);
  }
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 16 | 0;
 i5 = i2;
 i4 = i2 + 32 | 0;
 i6 = i2 + 20 | 0;
 i10 = i1 + 72 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1046691 | 0, 16);
 i3 = i1 + 96 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 __Z6FormatPKcz(i4, gb + 1084502 | 0, i5);
 mftCall_viii(i9 | 0, i7 | 0, i6 | 0, i4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1046708 | 0, 18);
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 88 >> 2];
 __Z6FormatPKcz(i5, gb + 1084502 | 0, i8);
 mftCall_viii(i7 | 0, i6 | 0, i4 | 0, i5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = HEAP32[i3 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i2;
 return;
}

function __Z31WWW_CUSTOM_LoadImageIntoTextureP12Il2CppObjectS0_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 580408 | 0, 346, 1, 0, 0, 0);
  STACKTOP = i7;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 if (!i4) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i5) {
  i6 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb(i5, i6, i3, (i1 + -10 | 0) >>> 0 < 3 ? 2 : 0, 0) | 0;
 STACKTOP = i7;
 return;
}

function __Z17UploadCubemapData9TextureIDPhjiiii13TextureFormatj17TextureColorSpaceR9GfxDevice(i11, i6, i2, i3, i14, i5, i15, i1, i8, i16, i12) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i5 = i5 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 var i4 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0, i17 = 0;
 i17 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i17 + 24 | 0;
 i7 = i17 + 16 | 0;
 i9 = i17 + 12 | 0;
 i4 = i17;
 i13 = i17 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i9 >> 2] = i1;
 do if ((i1 | 1 | 0) == 29) {
  i2 = gb + 64016 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  i1 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i6, i7, i9, i15, i14, i5, 6, i10) | 0;
  if (!i1) {
   i16 = 0;
   STACKTOP = i17;
   return i16 | 0;
  } else {
   i2 = HEAP32[i7 >> 2] | 0;
   i5 = i1;
   i6 = i1;
   i4 = i8 & -2;
   i3 = (i2 >>> 0) / 6 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   break;
  }
 } else {
  i5 = 0;
  i4 = i8;
 } while (0);
 i9 = HEAP32[(HEAP32[i12 >> 2] | 0) + 444 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 mftCall_viiiiiiiiii(i9 | 0, i12 | 0, i10 | 0, i6 | 0, i2 | 0, i3 | 0, i14 | 0, i1 | 0, i15 | 0, i4 | 0, i16 | 0);
 if (!i5) {
  i16 = 1;
  STACKTOP = i17;
  return i16 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 64016 | 0);
 i16 = 1;
 STACKTOP = i17;
 return i16 | 0;
}

function __ZNSt3__27promiseIvED2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 32 | 0;
 i4 = i7 + 24 | 0;
 i5 = i7 + 8 | 0;
 i6 = i7;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  do if (!(HEAP32[i1 + 88 >> 2] & 1)) {
   HEAP32[i2 >> 2] = 0;
   i1 = (HEAP32[i1 + 8 >> 2] | 0) == 0;
   __ZNSt13exception_ptrD2Ev(i2);
   if (i1) {
    i1 = HEAP32[i3 >> 2] | 0;
    if ((HEAP32[i1 + 4 >> 2] | 0) > 0) {
     __ZNSt3__215future_categoryEv() | 0;
     HEAP32[i6 >> 2] = 4;
     HEAP32[i6 + 4 >> 2] = gb + 1473484;
     __THREW__ = 0;
     HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
     HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
     invoke_vii(fb + 4499 | 0, i5 | 0, i2 | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i6 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      ___clang_call_terminate(i6);
     }
     HEAP32[i4 >> 2] = __ZSt18make_exception_ptrINSt3__212future_errorEESt13exception_ptrT_(i5) | 0;
     __THREW__ = 0;
     invoke_vii(fb + 4503 | 0, i1 | 0, i4 | 0);
     i6 = __THREW__;
     __THREW__ = 0;
     if (i6 & 1) {
      i6 = ___cxa_find_matching_catch_3(0) | 0;
      getTempRet0() | 0;
      __ZNSt13exception_ptrD2Ev(i4);
      __ZNSt3__212future_errorD2Ev(i5);
      ___clang_call_terminate(i6);
     } else {
      __ZNSt13exception_ptrD2Ev(i4);
      __ZNSt11logic_errorD2Ev(i5);
      break;
     }
    }
   }
  } while (0);
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i3 >> 2] | 0) | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP32[i2 >> 2] = 0;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = i3 + 4 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = (i1 | 0) / 20 | 0;
 if (!i1) return;
 if (i4 >>> 0 > 214748364) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
 i6 = __Znwj(i1) | 0;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 8 >> 2] = i6 + (i4 * 20 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i10 | 0)) return;
 do {
  i9 = i1;
  i4 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i6;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i6 + 8 | 0;
  i4 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  i9 = i6 + 12 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  i7 = i1 + 12 | 0;
  i2 = (HEAP32[i7 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = (i2 | 0) / 24 | 0;
  if (i2 | 0) {
   if (i5 >>> 0 > 178956970) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i8 = __Znwj(i2) | 0;
   HEAP32[i9 >> 2] = i8;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i6 + 16 >> 2] = i8 + (i5 * 24 | 0);
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = (HEAP32[i7 >> 2] | 0) - i3 | 0;
   if ((i2 | 0) > 0) {
    _memcpy(i8 | 0, i3 | 0, i2 | 0) | 0;
    HEAP32[i9 >> 2] = i8 + (((i2 >>> 0) / 24 | 0) * 24 | 0);
   }
  }
  i1 = i1 + 20 | 0;
  i6 = (HEAP32[i11 >> 2] | 0) + 20 | 0;
  HEAP32[i11 >> 2] = i6;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZNSt3__211__stdoutbufIcE8overflowEi(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 16 | 0;
 i3 = i14 + 8 | 0;
 i11 = i14 + 4 | 0;
 i12 = i14;
 i13 = (i9 | 0) == -1;
 do if (i13) i2 = 14; else {
  HEAP8[i3 >> 0] = i9;
  if (HEAP8[i1 + 44 >> 0] | 0) if ((_fwrite(i3, 1, 1, HEAP32[i1 + 32 >> 2] | 0) | 0) == 1) {
   i2 = 14;
   break;
  } else {
   i1 = -1;
   break;
  }
  HEAP32[i11 >> 2] = i10;
  i2 = i3 + 1 | 0;
  i4 = i1 + 36 | 0;
  i5 = i1 + 40 | 0;
  i6 = i10 + 8 | 0;
  i7 = i10;
  i8 = i1 + 32 | 0;
  while (1) {
   i1 = HEAP32[i4 >> 2] | 0;
   i1 = mftCall_iiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i5 >> 2] | 0, i3 | 0, i2 | 0, i12 | 0, i10 | 0, i6 | 0, i11 | 0) | 0;
   if ((HEAP32[i12 >> 2] | 0) == (i3 | 0)) {
    i2 = 13;
    break;
   }
   if ((i1 | 0) == 3) {
    i2 = 7;
    break;
   }
   if ((i1 | 1 | 0) != 1) {
    i2 = 13;
    break;
   }
   i3 = (HEAP32[i11 >> 2] | 0) - i7 | 0;
   if ((_fwrite(i10, 1, i3, HEAP32[i8 >> 2] | 0) | 0) != (i3 | 0)) {
    i2 = 13;
    break;
   }
   if ((i1 | 0) == 1) i3 = HEAP32[i12 >> 2] | 0; else {
    i2 = 12;
    break;
   }
  }
  if ((i2 | 0) == 7) if ((_fwrite(i3, 1, 1, HEAP32[i8 >> 2] | 0) | 0) == 1) i2 = 12; else i2 = 13;
  if ((i2 | 0) == 12) {
   i2 = 14;
   break;
  } else if ((i2 | 0) == 13) {
   i1 = -1;
   break;
  }
 } while (0);
 if ((i2 | 0) == 14) i1 = i13 ? 0 : i9;
 STACKTOP = i14;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpShapeEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpClothEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 731490 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i9 = i2 + 24 | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1 + 24 | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN13MonoBehaviour34StopCoroutineFromEnumeratorManagedEP12Il2CppObject(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i7 = i9 + 4 | 0;
 i4 = i9;
 HEAP32[i7 >> 2] = i1;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i2 = __Z21GetDelayedCallManagerv() | 0;
 if (!i5) i1 = 0; else i1 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i2, i3, fb + 592 | 0, fb + 696 | 0, i7);
 i1 = HEAP32[i5 + 68 >> 2] | 0;
 i6 = i5 + 64 | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1;
 while (1) {
  i4 = i5;
  if ((HEAP32[i4 + 8 >> 2] | 0) == (i3 | 0)) break;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i6 | 0)) {
   i8 = 14;
   break;
  } else i5 = i1;
 }
 if ((i8 | 0) == 14) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i8 = i4 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 HEAP32[i4 + 40 >> 2] = 0;
 i1 = i4 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i4 + 64 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
 STACKTOP = i9;
 return;
}

function __Z20RenderSceneDepthPassRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i7 = i8;
 if (!(HEAP32[i1 + 12 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i9 = __ZnwjRK10MemLabelIdiPKci(112, gb + 64024 | 0, 16, gb + 388526 | 0, 634) | 0;
 i12 = gb + 64024 | 0;
 i13 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i9 + 4 >> 2] = 1;
 HEAP32[i9 >> 2] = gb + 36916 + 8;
 i10 = i9 + 8 | 0;
 HEAP32[i10 >> 2] = 0;
 i11 = i7;
 HEAP32[i11 >> 2] = i13;
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i7);
 i11 = i6;
 i6 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i9 + 32 >> 2] = 0;
 HEAP32[i9 + 36 >> 2] = 0;
 HEAP32[i9 + 104 >> 2] = 0;
 HEAP8[i9 + 108 >> 0] = 1;
 HEAP8[i9 + 109 >> 0] = 1;
 i7 = i2 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 HEAP32[i10 >> 2] = i2;
 __ZN9DepthPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceDatab(i9, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, i1, i2 + 8 | 0, i3, i4);
 __ZN9DepthPass16PerformRenderingER17ShaderPassContext(i9, i5);
 STACKTOP = i8;
 return;
}

function __ZNSt3__2L15ucs4_to_utf16leEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i7, i8, i3, i2, i9, i10, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 i6 = i2;
 if (!(i4 & 2)) i5 = 4; else if ((i6 - i3 | 0) < 2) i1 = 1; else {
  HEAP32[i9 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -1;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -2;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L4;
   }
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 >>> 0 > i10 >>> 0 | (i1 & -2048 | 0) == 55296) {
    i1 = 2;
    break L4;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i6 - i2 | 0;
   if (i1 >>> 0 < 65536) {
    if ((i3 | 0) < 2) {
     i1 = 1;
     break L4;
    }
    HEAP32[i9 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i1;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1 >>> 8;
   } else {
    if ((i3 | 0) < 4) {
     i1 = 1;
     break L4;
    }
    i5 = i1 >>> 10;
    i4 = (i5 & 1984) + 16320 | 0;
    HEAP32[i9 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i4 | i5 & 63;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i4 >>> 8 | 216;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1 >>> 8 & 3 | 220;
   }
   i1 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__2L15ucs4_to_utf16beEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i1, i7, i8, i3, i2, i9, i10, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i9 >> 2] = i3;
 i6 = i2;
 if (!(i4 & 2)) i5 = 4; else if ((i6 - i3 | 0) < 2) i1 = 1; else {
  HEAP32[i9 >> 2] = i3 + 1;
  HEAP8[i3 >> 0] = -2;
  i5 = HEAP32[i9 >> 2] | 0;
  HEAP32[i9 >> 2] = i5 + 1;
  HEAP8[i5 >> 0] = -1;
  i5 = 4;
 }
 L4 : do if ((i5 | 0) == 4) {
  i1 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i7 >>> 0) {
    i1 = 0;
    break L4;
   }
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 >>> 0 > i10 >>> 0 | (i1 & -2048 | 0) == 55296) {
    i1 = 2;
    break L4;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   i3 = i6 - i2 | 0;
   if (i1 >>> 0 < 65536) {
    if ((i3 | 0) < 2) {
     i1 = 1;
     break L4;
    }
    HEAP32[i9 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i1 >>> 8;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1;
   } else {
    if ((i3 | 0) < 4) {
     i1 = 1;
     break L4;
    }
    i4 = i1 >>> 10;
    i3 = (i4 & 1984) + 16320 | 0;
    HEAP32[i9 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3 >>> 8 | 216;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i3 | i4 & 63;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1 >>> 8 & 3 | 220;
    i5 = HEAP32[i9 >> 2] | 0;
    HEAP32[i9 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i1;
   }
   i1 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 52 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 40 | 0;
  if (i1 >>> 0 < 41 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 709958 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 48 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 44 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 40 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 16 | 0;
  if (i1 >>> 0 < 17 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 709958 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 20 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 16 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 36 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 690959 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 36 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i1 = i1 + 36 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 36 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN23AllocationRootReferenceD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = HEAP32[(HEAP32[gb + 1163236 >> 2] | 0) + 168 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 if (i6 | 0) {
  i3 = i4;
  i2 = i6;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i7 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i4 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 <= i7 >>> 0) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) HEAP32[i5 >> 2] = i1;
   i4 = i5 + 12 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i3);
   i6 = HEAP32[i5 + 8 >> 2] | 0;
   HEAP32[i8 >> 2] = 58;
   HEAP32[i8 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
  }
 }
 i1 = i7 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i8 >> 2] = 58;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZN12LineRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i4 = HEAP32[i5 + 348 >> 2] | 0;
 i3 = i4 + 8 | 0;
 i8 = i6 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i6 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 + 20 >> 2] | 0;
 i2 = i1 + (i4 * 12 | 0) | 0;
 if (i4 | 0) do {
  __ZN18StreamedBinaryReadILb1EE8TransferIN4math14float3_storageEEEvRT_PKc17TransferMetaFlags(i6, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN14LineParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i5 + 344 >> 2] | 0, i6);
 i1 = i5 + 340 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i9 = HEAP8[i7 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 } else {
  i9 = HEAP8[i2 >> 0] | 0;
  HEAP8[i7 >> 0] = i9;
  HEAP32[i8 >> 2] = i3;
  HEAP8[i1 >> 0] = i9;
  STACKTOP = i10;
  return;
 }
}

function __Z65AnimatorControllerPlayable_CUSTOM_GetNextAnimatorClipInfoInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 8 | 0;
 i9 = i7;
 i6 = i7 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2, 0, i6) | 0;
 i2 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 12 >> 2] | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 8, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i10 = (HEAP32[i6 >> 2] | 0) + (i1 << 3) | 0;
   __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo(i10, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, i1, 8) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i2 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN26AnimatorControllerPlayableC2E18DirectorPlayerType(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 8 | 0;
 i4 = i1;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i2, 0, 0);
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i2 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i4);
 i4 = i6;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i2 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP8[i2 + 72 >> 0] = 0;
 HEAP8[i2 + 73 >> 0] = 0;
 HEAP8[i2 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i2 + 76 | 0);
 i3 = i2 + 80 | 0;
 HEAP32[i2 >> 2] = gb + 177524 + 8;
 HEAP32[i3 >> 2] = gb + 177524 + 200;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = gb + 177740 + 8;
 i5 = i2 + 92 | 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 + 116 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 __ZN27StateMachineBehaviourPlayerC2EP28IStateMachineBehaviourSender(i2 + 132 | 0, i3);
 HEAP32[i2 + 144 >> 2] = 0;
 HEAP32[i2 + 148 >> 2] = 0;
 HEAP8[i2 + 152 >> 0] = 1;
 HEAP32[i2 + 48 >> 2] = 3;
 STACKTOP = i1;
 return;
}

function _sha256_sum(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i4 >> 2] & 63;
 i2 = i3 + 1 | 0;
 i1 = i4 + 40 | 0;
 HEAP8[i4 + 40 + i3 >> 0] = -128;
 if (i2 >>> 0 > 56) {
  _memset(i4 + 40 + i2 | 0, 0, i3 ^ 63 | 0) | 0;
  _processblock_41(i4, i1);
  i2 = 0;
 }
 _memset(i4 + 40 + i2 | 0, 0, 56 - i2 | 0) | 0;
 i2 = i4;
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = _bitshift64Shl(i6 | 0, i2 | 0, 3) | 0;
 i8 = getTempRet0() | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 53) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 96 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 45) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 97 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 37) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 98 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 29) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 99 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 21) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 100 >> 0] = i7;
 i7 = _bitshift64Lshr(i6 | 0, i2 | 0, 13) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 101 >> 0] = i7;
 i2 = _bitshift64Lshr(i6 | 0, i2 | 0, 5) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 102 >> 0] = i2;
 HEAP8[i4 + 103 >> 0] = i3;
 _processblock_41(i4, i1);
 i1 = 0;
 do {
  i7 = i4 + 8 + (i1 << 2) | 0;
  i8 = i1 << 2;
  HEAP8[i5 + i8 >> 0] = (HEAP32[i7 >> 2] | 0) >>> 24;
  HEAP8[i5 + (i8 | 1) >> 0] = (HEAP32[i7 >> 2] | 0) >>> 16;
  HEAP8[i5 + (i8 | 2) >> 0] = (HEAP32[i7 >> 2] | 0) >>> 8;
  HEAP8[i5 + (i8 | 3) >> 0] = HEAP32[i7 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 28 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 16 | 0;
  if (i1 >>> 0 < 17 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else if (!i1) i1 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i1 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 707297 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = i9 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 20 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 16 >> 0] = 0;
   break;
  }
  if (i3) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __Z24Cubemap_CUSTOM_GetPixelsP12Il2CppObjectii(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i4 = __ZNK21ScriptingObjectOfTypeI7CubemapEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i7;
 i3 = (i2 | 0) < 1;
 i1 = i3 ? 1 : i2;
 i4 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0;
 i2 = Math_imul(i2, i2) | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i4, 16, i3 ? 1 : i2) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi(i4, 0, 0, i1, i1, i7, i3, i6) | 0;
  STACKTOP = i8;
  return i2 | 0;
 }
 return 0;
}

function __Z14GetAppDataPathv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 12 | 0;
 i5 = i8;
 i3 = __Z17GetPlayerSettingsv() | 0;
 i1 = i3 + 524 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 528 >> 2] | 0;
 } else {
  i2 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i2, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i5, i7, 0, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i7, 63, 0) | 0, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i7, 47, -1) | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return;
 } else {
  i5 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i5, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return;
 }
}

function __ZNK12MeshCollider16GetNonSharedMeshEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (HEAP8[i1 + 61 >> 0] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) == 4) {
  HEAP32[i2 >> 2] = 4;
  HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 28 >> 2] = Math_fround(1.0);
  i4 = i2 + 32 | 0;
  HEAP32[i4 >> 2] = 0;
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i2 | 0) | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  HEAP32[i2 >> 2] = 5;
  HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 28 >> 2] = Math_fround(1.0);
  i4 = i2 + 32 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i4 = HEAP32[i3 >> 2] | 0;
  mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i2 | 0) | 0;
  i4 = HEAP32[i2 + 36 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i6 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 do {
  if (!(_isspace(i2 & 255) | 0)) break;
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 } while (i2 << 24 >> 24 != 0);
 _memset(i6 | 0, 0, 256) | 0;
 HEAP32[i4 >> 2] = i6 + 255;
 i2 = HEAP8[i1 >> 0] | 0;
 L18 : do if (!(i2 << 24 >> 24)) i1 = i6; else if (!(_isspace(i2 & 255) | 0)) {
  i3 = i1;
  i2 = i6;
  while (1) {
   i1 = i2 + 1 | 0;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L18;
   i8 = HEAP32[i4 >> 2] | 0;
   if (!(i1 >>> 0 < i8 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) break; else i2 = i1;
  }
 } else i1 = i6; while (0);
 HEAP8[i1 >> 0] = 0;
 HEAPF32[i5 >> 2] = Math_fround(+_strtod(i6, i4));
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx14NpArticulation7releaseEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i7, HEAP32[i7 + 8 >> 2] | 0, 1);
 i6 = i7 + 92 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i3 = i7 + 88 | 0;
  i2 = 0;
  do {
   i1 = (i2 >>> 0) % (i1 >>> 0) | 0;
   i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 232 >> 2] | 0, i5 | 0) | 0)) {
    __ZN5physx18NpArticulationLink15releaseInternalEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i2 = i1;
   } else i2 = i1 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 if ((((HEAP32[i7 + 16 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
   if (i1 | 0) {
    __ZN5physx3Scb5Scene18removeArticulationERNS0_12ArticulationE(i1 + 16 | 0, i7 + 12 | 0);
    i5 = i1 + 3564 | 0;
    i3 = i1 + 3568 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    L14 : do if (!i4) i1 = 0; else {
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = 0;
     do {
      if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i7 | 0)) break L14;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i4 >>> 0);
    } while (0);
    if ((i1 | 0) != (i4 | 0)) {
     i4 = i4 + -1 | 0;
     HEAP32[i3 >> 2] = i4;
     i5 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
    }
   }
  }
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx3Scb4Base7destroyEv(i7 + 12 | 0);
 return;
}

function __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet(i9, i1, i6, i7) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 if (!((i1 | 0) != 0 & i6 >>> 0 < 13)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i9 + 36 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 } else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i4 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i8 + 32 >> 2] = i6;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 i1 = (__ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE9erase_oneIS1_EEjRKT_(i1 + 20 | 0, i8) | 0) != 0;
 if (i1) HEAP8[i9 + 44 >> 0] = 0;
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN17PersistentManager13GetAllFileIDsERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EE(i2, i1, i12) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) return;
 i2 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i1) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 __ZNK14SerializedFile13GetAllFileIDsER13dynamic_arrayIxLj8EE(i1, i12);
 i11 = i12 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) return;
 i8 = HEAP32[i12 >> 2] | 0;
 i10 = i2 + 16 | 0;
 i9 = i8;
 i2 = i8;
 L10 : while (1) {
  i7 = i9;
  i9 = i9 + 8 | 0;
  i8 = i9;
  L12 : while (1) {
   i6 = i7;
   i5 = HEAP32[i6 >> 2] | 0;
   i6 = HEAP32[i6 + 4 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
   if (!i4) break;
   i3 = HEAP32[i4 >> 2] | 0;
   i13 = HEAP32[i4 + 12 >> 2] | 0;
   i4 = i3 + (i13 << 3) | 0;
   L15 : do if (i13) while (1) {
    i13 = i3;
    if ((HEAP32[i13 >> 2] | 0) == (i5 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i6 | 0) : 0) break L15;
    i3 = i3 + 8 | 0;
    if ((i3 | 0) == (i4 | 0)) break L12;
   } while (0);
   if ((i3 | 0) == (i4 | 0)) break;
   _memmove(i7 | 0, i9 | 0, i2 + (i1 << 3) - i8 | 0) | 0;
   i1 = (HEAP32[i11 >> 2] | 0) + -1 | 0;
   HEAP32[i11 >> 2] = i1;
   i2 = HEAP32[i12 >> 2] | 0;
   if ((i7 | 0) == (i2 + (i1 << 3) | 0)) {
    i1 = 13;
    break L10;
   }
  }
  if ((i9 | 0) == (i2 + (i1 << 3) | 0)) {
   i1 = 13;
   break;
  }
 }
 if ((i1 | 0) == 13) return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP16[i8 + 8 >> 1] = 0;
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 * 12 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14MemoryProfiler27SetRootAllocationObjectNameEPvRK10MemLabelIdPKc(i3, i1, i2, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2) | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 80 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 i5 = (HEAP32[i3 + 168 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i5;
 L4 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L4;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((i1 | 0) == (i5 | 0) ? 1 : i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) return;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = i6 + 12 | 0;
 i7 = i7 | 0 ? i7 : gb + 1576256 | 0;
 i8 = _strlen(i7) | 0;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + 20 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i8 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + 16 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i7);
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
 HEAP8[i1 + i8 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i6 + 16 >> 2] = i8;
  return;
 } else {
  HEAP8[i4 >> 0] = i8;
  return;
 }
}

function __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i3);
 __ZN17JointSuspension2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 96 | 0, i3);
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
  i1 = HEAP8[i7 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i7 >> 0] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP8[i6 + 116 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 108 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 112 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __Z21AllocateStaticQueriesPK9dtNavMesh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 4 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 8 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 12 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 16 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 20 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 24 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 28 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 32 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 36 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 40 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 44 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 48 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 52 >> 2] = i2;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 56 >> 2] = i2;
 i1 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, 500) | 0;
 HEAP32[gb + 1459460 + 60 >> 2] = i1;
 return;
}

function __ZN9Projector16CheckConsistencyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f5 = f0, f6 = f0;
 __ZN5Unity9Component16CheckConsistencyEv(i4);
 if (!(HEAP8[i4 + 52 >> 0] | 0)) {
  i1 = i4 + 36 | 0;
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  if (f3 < Math_fround(.00999999977)) {
   HEAPF32[i1 >> 2] = Math_fround(.00999999977);
   f3 = Math_fround(.00999999977);
  }
  i1 = i4 + 40 | 0;
  f3 = Math_fround(f3 + Math_fround(.00999999977));
  if (Math_fround(HEAPF32[i1 >> 2]) < f3) HEAPF32[i1 >> 2] = f3;
 } else {
  i1 = i4 + 40 | 0;
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(HEAPF32[i4 + 36 >> 2]);
  f5 = Math_fround(f5 - f3);
  i2 = f5 < Math_fround(0.0);
  f6 = Math_fround(-f5);
  if ((i2 ? f6 : f5) < Math_fround(.00999999977)) HEAPF32[i1 >> 2] = Math_fround(f3 + (i2 ? Math_fround(-.00999999977) : Math_fround(.00999999977)));
 }
 i1 = i4 + 44 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if ((i2 ? f5 : f6) < Math_fround(9.99999993e-09)) HEAPF32[i1 >> 2] = i2 ? Math_fround(-9.99999993e-09) : Math_fround(9.99999993e-09);
 i1 = i4 + 48 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if ((i2 ? f5 : f6) < Math_fround(9.99999993e-09)) HEAPF32[i1 >> 2] = i2 ? Math_fround(-9.99999993e-09) : Math_fround(9.99999993e-09);
 i1 = i4 + 56 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = f6 < Math_fround(0.0);
 f5 = Math_fround(-f6);
 if (!((i2 ? f5 : f6) < Math_fround(9.99999993e-09))) return;
 HEAPF32[i1 >> 2] = i2 ? Math_fround(-9.99999993e-09) : Math_fround(9.99999993e-09);
 return;
}

function __ZN9AudioClip16EnableLegacyModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i1 + 124 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  STACKTOP = i7;
  return;
 }
 i5 = __Znwj(84) | 0;
 i1 = i5;
 i2 = i1 + 84 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i5 + 20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!((i1 | 0) == (i5 | 0) | (i1 | 0) == 0)) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i1 + 12 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i6 >> 2] = 27;
   HEAP32[i6 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
  }
  __ZdlPv(i1);
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP8[i5 + 24 >> 0] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP8[i5 + 32 >> 0] = 1;
 HEAP32[i5 + 36 >> 2] = 0;
 HEAP8[i5 + 40 >> 0] = 0;
 HEAP32[i5 + 44 >> 2] = 0;
 HEAP32[i5 + 48 >> 2] = 3;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 56 >> 2] = 0;
 i6 = i5 + 60 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i6 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i6 = (HEAP32[i4 >> 2] | 0) + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i6 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP8[i6 + 80 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx7NpScene13addCollectionERKNS_12PxCollectionE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 80 >> 2] | 0;
 if (!i4) return;
 i1 = i1 + 48 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 4) >> 2] | 0;
  switch (HEAP16[i2 + 4 >> 1] | 0) {
  case 5:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 6:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 13:
   {
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 60 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 10:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 11:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 12:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  case 14:
   {
    if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0, i2 | 0);
    break;
   }
  default:
   {}
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i1 = i7 * 12 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 738508 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 12 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 * 12 | 0) | 0;
}

function __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE22handleGeometryPropertyERKNS_23PxShapeGeometryPropertyE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 switch (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0) {
 case 0:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_16PxSphereGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 753503 | 0);
   return;
  }
 case 1:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_15PxPlaneGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 753487 | 0);
   return;
  }
 case 2:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_17PxCapsuleGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 753469 | 0);
   return;
  }
 case 3:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_13PxBoxGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 753455 | 0);
   return;
  }
 case 4:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_20PxConvexMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 672946 | 0);
   return;
  }
 case 5:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_22PxTriangleMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 672967 | 0);
   return;
  }
 case 6:
  {
   __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_21PxHeightFieldGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc(i2, i1, gb + 672990 | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i2, i8, i1) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11;
 i6 = i8 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i10 = i2 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i9 = i2 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i10 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) if (!(HEAP32[i8 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i8, HEAP32[i6 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  i7 = 7;
 } else i7 = 7;
 if ((i7 | 0) == 7) i1 = HEAP32[i8 >> 2] | 0;
 i7 = (i1 | 0) == 0;
 i4 = i8 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = (i7 ? i4 : i1) + i3 | 0;
 if (!(i7 | (i2 | 0) != 0)) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i8, i3);
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i1 = (i1 | 0) == 0 ? i4 : i1;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __ZN14NavMeshManager7CleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 52 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i4 + 40 | 0;
  i1 = 0;
  do {
   __ZN12NavMeshAgent21RemoveFromCrowdSystemEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i4 + 72 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do i1 = i1 + 1 | 0; while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i4 + 92 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i4 + 80 | 0;
  i1 = 0;
  do {
   __ZN11OffMeshLink16OnNavMeshCleanupEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z13dtFreeNavMeshP9dtNavMesh(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 116 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63704 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 + 120 >> 2] = 0;
 i2 = i4 + 124 | 0;
 i3 = i4 + 128 | 0;
 __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 100;
 HEAPF32[i4 + 32 >> 2] = Math_fround(2.0);
 return;
}

function __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 471805 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1037646 | 0, gb + 469407 | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx32PxsSolverConstraintPartitionTask11runInternalEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i4 = HEAP32[HEAP32[i8 + 24 >> 2] >> 2] | 0;
 i5 = HEAP32[i4 + 8892 >> 2] | 0;
 i6 = HEAP32[i4 + 8896 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i8 + 20 >> 2] | 0) + 100 >> 2] | 0;
 i2 = HEAP32[i8 + 64 >> 2] | 0;
 i3 = i4 + 8796 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 if (!i6) {
  _memset(HEAP32[i4 + 8820 >> 2] | 0, 0, HEAP32[i4 + 8828 >> 2] << 2 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i7 >> 2] = i1 + (i2 << 5);
  HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 9124 >> 2];
  HEAP32[i7 + 16 >> 2] = i5;
  HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 9128 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 48 >> 2];
  HEAP32[i7 + 20 >> 2] = i6;
  HEAP32[i7 + 24 >> 2] = HEAP32[i4 + 8928 >> 2];
  HEAP32[i7 + 28 >> 2] = HEAP32[i4 + 8904 >> 2];
  HEAP32[i7 + 32 >> 2] = HEAP32[i4 + 9036 >> 2];
  i8 = i7 + 36 | 0;
  HEAP32[i8 >> 2] = 0;
  i6 = i7 + 44 | 0;
  HEAP32[i6 >> 2] = 0;
  i5 = i7 + 40 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i7 + 48 >> 2] = i4 + 8820;
  HEAP32[i7 + 52 >> 2] = i4 + 8844;
  HEAP32[i4 + 9044 >> 2] = __ZN5physx27partitionContactConstraintsERNS_23ConstraintPartitionArgsE(i7) | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 8804 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 8812 >> 2] = HEAP32[i8 >> 2];
  STACKTOP = i9;
  return;
 }
}

function __ZN18BuoyancyEffector2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 92 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e6) : f2;
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 104 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 108 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-359.999908);
 i5 = f2 > Math_fround(359.999908);
 f2 = i5 ? Math_fround(359.999908) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-359.999908) : f2;
 i3 = i1 + 112 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e6) : f2;
 i1 = i1 + 116 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZL41InitializeUnityWebRequestScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63728 | 0, 16, gb + 1026606 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[gb + 1468904 >> 2] = i2;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1026738 | 0, gb + 1026761 | 0, gb + 1026777 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468904 >> 2] | 0) + 8 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1026738 | 0, gb + 1026761 | 0, gb + 1026789 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468904 >> 2] | 0) + 16 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1026738 | 0, gb + 1026761 | 0, gb + 1026801 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468904 >> 2] | 0) + 24 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1026738 | 0, gb + 1026761 | 0, gb + 1026817 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1468904 >> 2] | 0) + 32 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1026838 | 0, gb + 1026858 | 0, gb + 1026874 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 STACKTOP = i1;
 return;
}

function __Z30GetAudioSpatializerDefinitionsR13dynamic_arrayIP29AudioEffectInternalDefinitionLj4EE(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 HEAP32[i9 >> 2] = 0;
 i10 = __Z25GetAudioEffectDefinitionsPi(i9) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 i11 = i8 + 12 | 0;
 i12 = i8 + 16 | 0;
 i13 = i8 + 4 | 0;
 i7 = 0;
 do {
  i6 = i10 + (i7 << 2) | 0;
  if (!(0 == 0 ? (HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + 120 >> 2] & 2 | 0) == 0 : 0)) {
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2 + 1 | 0;
   i4 = HEAP32[i12 >> 2] | 0;
   i5 = i4 & 2147483647;
   do if (i3 >>> 0 > i5 >>> 0) {
    i1 = i4 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
     HEAP32[i12 >> 2] = i1;
     HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i5 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i1;
     HEAP32[i8 >> 2] = i5;
     break;
    }
   } while (0);
   HEAP32[i11 >> 2] = i3;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i6 >> 2];
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i1 | 0));
 STACKTOP = i14;
 return;
}

function __GLOBAL__sub_I_runtime_math_lump_cpp() {
 var i1 = 0, i2 = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546588 | 0, fb + 3402 | 0, 0, 0, 0);
 HEAPF32[gb + 1162220 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1162220 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1162220 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162220 + 32 >> 2] = Math_fround(1.0);
 i1 = gb + 1162256 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF32[gb + 1162292 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1162292 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1162292 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1162292 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1162292 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE4findIS6_EENS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj48ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i6, HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i6, i3) | 0) {
  i1 = HEAP32[i6 + 24 >> 2] | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1)) mftCall_vif(i5 | 0, i1 | 0, +f4);
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i6 + 36 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
 i3 = i1 + -1 | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i5 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i5 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i6 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx16PxVehicleDriveNW6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj(i3, i4, i5, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = (i2 + 3 | 0) >>> 2;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i8) | 0) + 768 | 0, gb + 827537 | 0, 63) | 0;
 __ZN5physx16PxVehicleDriveNWC2Ev(i7);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i7, i7 + 768 | 0, i8, i2) | 0;
 HEAP8[i7 + 113 >> 0] = 1;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i7, i3, i4, i5, i2, 0);
 i5 = i1 + 64 | 0;
 _memcpy(i7 + 224 | 0, i1 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 HEAP32[i7 + 288 >> 2] = HEAP32[i5 >> 2];
 i5 = i7 + 304 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i7 + 336 | 0, i1 + 112 | 0, 416) | 0;
 i5 = i7 + 752 | 0;
 i4 = i1 + 528 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN26AnimatorOverrideControllerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i9 = i4 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 178476 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i1 + 104 >> 2] = 0;
 i3 = i6;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 108 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 112 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 120 >> 2] = i1;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = -1;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags(i5, i7, i1, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i6 = i7 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i5 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
   i5 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 8 | 0;
  i3 = i5 + 4 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN13RenderManager22OnWindowSizeHasChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i10;
  return;
 }
 i5 = i1;
 do {
  i4 = i2 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i9 = 9; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
    i2 = HEAP32[i7 >> 2] | 0;
    i11 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i9 = 11;
   }
  }
  if ((i9 | 0) == 9) i9 = 11;
  if ((i9 | 0) == 11) {
   i9 = 0;
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  }
  __ZN6Camera20WindowSizeHasChangedEv(i1);
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i5 = i2;
 } while ((i5 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN12AspectRatios8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 16 | 0;
 i6 = i4 + 24 | 0;
 i1 = i3 + 1 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 4 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i1;
 }
 if ((i1 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo(i7, HEAP32[i2 + 24 >> 2] | 0);
 __ZN9JSONWrite8TransferINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i4, i7, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -296 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -284 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function _UNITY_FT_CMap_Done(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13;
 if (!i12) {
  STACKTOP = i13;
  return;
 }
 i9 = HEAP32[i12 >> 2] | 0;
 i5 = HEAP32[i9 + 100 >> 2] | 0;
 i10 = i9 + 36 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i9 + 40 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = 0;
 while (1) {
  if ((HEAP32[i4 + (i3 << 2) >> 2] | 0) == (i12 | 0)) break;
  i1 = i3 + 1 | 0;
  if ((i1 | 0) < (i6 | 0)) i3 = i1; else {
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) {
  STACKTOP = i13;
  return;
 }
 i1 = i6 + -1 | 0;
 i8 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
 i1 = _UNITY_ft_mem_realloc(i5, 4, i6, i1, i4, i7) | 0;
 HEAP32[i11 >> 2] = i1;
 if (HEAP32[i7 >> 2] | 0) {
  STACKTOP = i13;
  return;
 }
 i2 = i3 + 1 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 + -1 | 0;
 L16 : do if ((i2 | 0) < (i4 | 0)) while (1) {
  if ((i2 | 0) == (i5 | 0)) HEAP32[i1 + (i3 << 2) >> 2] = i8; else HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
  i1 = i2 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) break L16;
  i3 = i2;
  i2 = i1;
  i1 = HEAP32[i11 >> 2] | 0;
 } while (0);
 HEAP32[i10 >> 2] = i5;
 i1 = i9 + 92 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i12 | 0)) HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[(HEAP32[i12 >> 2] | 0) + 100 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i12 + 12 >> 2] | 0) + 8 >> 2] | 0;
 if (i2 | 0) mftCall_vi(i2 | 0, i12 | 0);
 _UNITY_ft_mem_free(i1, i12);
 STACKTOP = i13;
 return;
}

function __ZN5Image13ReformatImageERK14ImageReferenceii13TextureFormatNS0_8BlitModeE(i4, i5, i6, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i11 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i8) | 0, i6) | 0;
 i3 = (i8 | 0) < 9;
 if (i3) i1 = 1; else i1 = (i8 | 0) == 1e3 | ((i8 | 0) == 23 | (i8 + -13 | 0) >>> 0 < 9);
 i12 = (i6 | 0) > 0 & (i7 | 0) > 0 & (i8 | 0) > 0;
 if (i12 & i1) {
  i1 = __Z19GetMaxBytesPerPixel13TextureFormat(HEAP32[i4 >> 2] | 0) | 0;
  i15 = Math_imul(i11, i7) | 0;
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + i15 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
  _memset(i2 + i15 | 0, 0, i1 | 0) | 0;
 } else i2 = 0;
 HEAP32[i10 + 4 >> 2] = i6;
 HEAP32[i10 + 8 >> 2] = i7;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 12 >> 2] = i11;
 if (!i2) i13 = 10; else {
  if (i3) i1 = 1; else i1 = (i8 | 0) == 1e3 | ((i8 | 0) == 23 | (i8 + -13 | 0) >>> 0 < 9);
  if (i12 & i1) HEAP32[i10 + 16 >> 2] = i2; else i13 = 10;
 }
 if ((i13 | 0) == 10) HEAP32[i10 + 16 >> 2] = 0;
 __ZN14ImageReference9BlitImageERKS_NS_10ColorSpaceENS_8BlitModeE(i10, i5, 0, i9);
 i15 = i4 + 16 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i15 >> 2] | 0, gb + 63184 | 0);
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i11;
 HEAP32[i15 >> 2] = i2;
 STACKTOP = i14;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i7 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i7 + 8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 * 12 | 0, 4) | 0;
  i2 = i3 + (i2 * 12 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i7 * 12 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z33CreateUnloadUnusedAssetsOperationb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = __Znwj(72) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i5 = i3 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 66136 + 8;
 HEAP8[i3 + 64 >> 0] = i1 & 1;
 i1 = HEAP32[gb + 1163176 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(i5, i3);
  STACKTOP = i4;
  return i3 | 0;
 }
 i5 = __Znwj(56) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = i2;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i6 = i2;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP8[i5 + 44 >> 0] = 0;
 HEAP32[i5 + 52 >> 2] = -1;
 HEAP32[i5 + 48 >> 2] = -1;
 HEAP32[gb + 1163176 >> 2] = i5;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(i5, i3);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx9PxTaskMgrC2EPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = gb + 105568 + 8;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 i2 = i4 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i4 + 40 >> 2] = Math_fround(.75);
 HEAP32[i4 + 44 >> 2] = -1;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i2, 64);
 HEAP32[i4 + 56 >> 2] = 0;
 i2 = i4 + 60 | 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) {
  i1 = 0;
  HEAP32[i2 >> 2] = i1;
  __ZN5physx6shdfnd9MutexImplC2Ev(i1);
  i1 = i4 + 64 | 0;
  i2 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i5 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = i4 + 64 | 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN20dynamic_block_vectorI14FileIdentifierE9push_backERKS0_(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i5 = __ZN20dynamic_block_vectorI14FileIdentifierE22push_back_no_constructEv(i1) | 0;
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i6 >> 2] | 0 : i6;
 i4 = i1 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i5 + 11 >> 0] = i4;
  if (!i4) i1 = i5; else {
   i1 = i5;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i5 + 4 >> 2] = i4;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 i9 = i5 + 16 | 0;
 i7 = i6 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 STACKTOP = i8;
 return;
}

function __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i9 + 360 | 0;
 if ((i6 | 0) == (i1 | 0)) i1 = i1 + 12 | 0; else {
  i8 = HEAP32[i1 >> 2] | 0;
  i1 = i1 + 12 | 0;
  i7 = i9 + 372 | 0;
  i2 = HEAP32[i1 >> 2] << 2;
  i4 = i2 >> 2;
  HEAP32[i7 >> 2] = i4;
  i5 = i9 + 376 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i5 >> 2] = i4;
   i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 4, i9 + 364 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i2;
   break;
  } else {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i9 + 364 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i6 >> 2] = i2;
   break;
  } else i2 = HEAP32[i6 >> 2] | 0; while (0);
  _memcpy(i2 | 0, i8 | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = i9 + 408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i9);
 i1 = i9 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i9 + 384 | 0;
 i2 = i9 + 400 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN15QualitySettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11);
 i1 = i10 + 44 | 0;
 i12 = i11 + 16 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i13 = i11 + 24 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  i3 = HEAP32[i12 >> 2] | 0;
  i4 = HEAP32[i13 >> 2] | 0;
 }
 i5 = i10 + 28 | 0;
 i8 = i10 + 32 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 108 | 0;
 HEAP32[i9 >> 2] = i6;
 i7 = i3 + 4 | 0;
 if (i7 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i12 >> 2] = i7;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i9, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15QualitySettings14QualitySetting8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i10 + 40 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i13 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i12 >> 2] = i3;
  STACKTOP = i14;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i12, i1, 4);
  STACKTOP = i14;
  return;
 }
}

function __ZN10MonoScript8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i3 + 64 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 72 | 0, i4);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3 + 92 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3 + 108 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3 + 124 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = i3 + 140 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIdfEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, d10 = 0.0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   HEAP8[tempDoublePtr >> 0] = HEAP8[i3 >> 0];
   HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i3 + 1 >> 0];
   HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i3 + 2 >> 0];
   HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i3 + 3 >> 0];
   HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i3 + 4 >> 0];
   HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i3 + 5 >> 0];
   HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i3 + 6 >> 0];
   HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i3 + 7 >> 0];
   HEAPF64[i5 >> 3] = +HEAPF64[tempDoublePtr >> 3];
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  d10 = +HEAPF64[i5 >> 3];
  f9 = Math_fround(d10);
  HEAPF32[i1 >> 2] = f9;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i7 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 d10 = +HEAPF64[i5 >> 3];
 f9 = Math_fround(d10);
 HEAPF32[i1 >> 2] = f9;
 STACKTOP = i8;
 return 1;
}

function __ZNK14Texture2DArray11GetPixels32EiP11ColorRGBA32ii(i3, i4, i8, i9, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 12 | 0;
 if (!(__ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii(i3, i4, i8, i9, i1) | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = HEAP32[i3 + 96 >> 2] | 0;
 i5 = HEAP32[i3 + 104 >> 2] | 0;
 i2 = i3 + 80 | 0;
 i14 = i3 + 84 | 0;
 i6 = i3 + 92 | 0;
 i7 = __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i6 >> 2] | 0, i1) | 0;
 i2 = HEAP32[i2 >> 2] >> i1;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i1 = HEAP32[i14 >> 2] >> i1;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if ((Math_imul(i1, i2) | 0) > (i4 | 0)) {
  HEAP32[i12 >> 2] = i4;
  HEAP32[i12 + 4 >> 2] = i2;
  HEAP32[i12 + 8 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 418416 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 411289 | 0, 337, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i14 = 0;
  STACKTOP = i13;
  return i14 | 0;
 } else {
  i14 = i11 + (Math_imul(i5, i9) | 0) + i7 | 0;
  __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_(i14, i2, i1, HEAP32[i6 >> 2] | 0, 0, 0, i2, i1, i8) | 0;
  i14 = 1;
  STACKTOP = i13;
  return i14 | 0;
 }
 return 0;
}

function __ZN5physx3Scb17ArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 125316 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125316 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125316 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125316 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125316 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125316 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125316 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125316 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 747761;
 HEAP32[i4 + 4 >> 2] = gb + 747700;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 188;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125348 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125348 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125348 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125348 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125348 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125348 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125348 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125348 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12CachedReader4ReadEPvj(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 + i1 | 0) >>> 0 <= (HEAP32[i7 + 8 >> 2] | 0) >>> 0) {
  _memcpy(i2 | 0, i3 | 0, i1 | 0) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
  return;
 }
 i8 = i7 + 20 | 0;
 i4 = (Math_imul(HEAP32[i8 >> 2] | 0, HEAP32[i7 + 16 >> 2] | 0) | 0) + (i3 - (HEAP32[i7 + 4 >> 2] | 0)) | 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i7, i4, i1);
 if (HEAP8[i7 + 32 >> 0] | 0) {
  _memset(i2 | 0, 0, i1 | 0) | 0;
  return;
 }
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i4 >>> 0) % (i3 >>> 0) | 0) {
  i6 = (Math_imul(((i4 >>> 0) / (i3 >>> 0) | 0) + 1 | 0, i3) | 0) - i4 | 0;
  i6 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, i6);
  i2 = i2 + i6 | 0;
  i4 = i6 + i4 | 0;
  i1 = i1 - i6 | 0;
 }
 i5 = i4 + i1 | 0;
 i3 = i7 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0) | 0;
 i5 = (i6 >>> 0 < i5 >>> 0 ? i6 : i5) - i4 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 if (i6 >>> 0 <= i5 >>> 0) {
  i6 = i5 - ((i5 >>> 0) % (i6 >>> 0) | 0) | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i2 | 0, i4 | 0, i6 | 0);
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i6;
  i2 = i2 + i6 | 0;
  i1 = i1 - i6 | 0;
 }
 if (!i1) return;
 while (1) {
  i3 = HEAP32[i8 >> 2] | 0;
  i3 = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, i3);
  i1 = i1 - i3 | 0;
  if (!i1) break; else i2 = i2 + i3 | 0;
 }
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 32 | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i1 + 84 | 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i1 = i1 + 120 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 1 >> 0] = 0;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP8[i2 + 8 >> 0] = 0;
 return;
}

function __ZN9Transform8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i5, i6);
 i2 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 896768 | 0, HEAP32[gb + 37208 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 56 | 0;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 896797 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 68 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 896813 | 0, i3, i4, 1) | 0;
 if (!i1) {
  __ZN9Transform25CompleteTransformTransferI14SafeBinaryReadEEvRT_(i5, i6);
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 __ZN9Transform25CompleteTransformTransferI14SafeBinaryReadEEvRT_(i5, i6);
 STACKTOP = i7;
 return;
}

function __ZN9AudioClip12moviepcmreadEP10FMOD_SOUNDPvj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i9 + 16 | 0;
 i3 = i9 + 20 | 0;
 i7 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i2;
 __ZN4FMOD5Sound11getUserDataEPPv(i1, i3) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 if (!i3) {
  i8 = 23;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
  i1 = gb + 874396 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 874396 + 88 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459916 >> 2] = i1;
  i2 = gb + 1098880 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459916 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = 0;
 i1 = __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE(i1) | 0;
 if (!i1) {
  i8 = 23;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP32[i1 + 124 >> 2] | 0)) {
  HEAP32[i8 >> 2] = gb + 855114;
  __Z6FormatPKcz(i7, gb + 854751 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 854901 | 0, 180, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 }
 i8 = __ZN9AudioClip18GetQueuedAudioDataEPPvj(i1, i6, i5) | 0;
 i8 = i8 ? 0 : 54;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx7NpCloth13setTargetPoseERKNS_11PxTransformE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 4 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f10 * f10);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f8 * f8));
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f6 * f6)))));
 f8 = Math_fround(f8 * f9);
 f7 = Math_fround(f7 * f9);
 f6 = Math_fround(f6 * f9);
 HEAPF32[i2 >> 2] = Math_fround(f10 * f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = f6;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 3; else i1 = 4;
   break;
  }
 default:
  i1 = 3;
 }
 if ((i1 | 0) == 3) {
  __ZN5physx2Sc9ClothCore13setTargetPoseERKNS_11PxTransformE(i3 + 32 | 0, i2);
  STACKTOP = i5;
  return;
 } else if ((i1 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 574, gb + 698209 | 0, i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth13setGlobalPoseERKNS_11PxTransformE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 4 | 0;
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f10 * f10);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f8 * f8));
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f9 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f9 + Math_fround(f6 * f6)))));
 f8 = Math_fround(f8 * f9);
 f7 = Math_fround(f7 * f9);
 f6 = Math_fround(f6 * f9);
 HEAPF32[i2 >> 2] = Math_fround(f10 * f9);
 HEAPF32[i2 + 4 >> 2] = f8;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = f6;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 3; else i1 = 4;
   break;
  }
 default:
  i1 = 3;
 }
 if ((i1 | 0) == 3) {
  __ZN5physx2Sc9ClothCore13setGlobalPoseERKNS_11PxTransformE(i3 + 32 | 0, i2);
  STACKTOP = i5;
  return;
 } else if ((i1 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 565, gb + 698135 | 0, i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairI7Hash128iEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37008 >> 2] | 0, gb + 455698 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN12LineRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1158268 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158268 | 0, i1);
  i6 = gb + 1158268 | 0;
 } else i6 = 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + (i4 * 140 | 0) | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 * 20 | 0) >> 2] | 0;
 if (!i1) i1 = i2 + (i4 * 140 | 0) + 4 | 0; else {
  i3 = i2 + (i4 * 140 | 0) + 4 | 0;
  __Z11Build3DLineP10LineVertexRK14LineParametersRKN4math8float4x4ES7_PKNS4_14float3_storageEj(i1, HEAP32[i5 >> 2] | 0, i2 + (i4 * 140 | 0) + 8 | 0, i2 + (i4 * 140 | 0) + 72 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i2 + (i4 * 140 | 0) + 136 >> 2] | 0);
  i1 = i3;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 12 | 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (!(HEAP32[i5 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i8 = i9 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = i10;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags(i1, i8, 0);
 i5 = i2 + 4 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  i11 = i4 + 28 | 0;
  i1 = __Z34scripting_class_array_element_sizeP11Il2CppClass(HEAP32[i11 >> 2] | 0) | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[i11 >> 2] | 0, i1, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 }
 i11 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 _memcpy(i11 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z16AppendSceneRangeiiiR13dynamic_arrayI10SceneRangeLj4EE(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i7 = i6 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i10 = i6 + 16 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i11 & 2147483647;
 do if (i9 >>> 0 > i12 >>> 0) {
  i2 = i11 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i12 >>> 0 < i2 >>> 0) if ((i11 | 0) > -1) {
   HEAP32[i10 >> 2] = i2;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 * 28 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 28 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 28 | 0) | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i6 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 i12 = HEAP32[i6 >> 2] | 0;
 i11 = i12 + (i8 * 28 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i11 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i12 + (i8 * 28 | 0) + 16 >> 2] = i3;
 HEAP32[i12 + (i8 * 28 | 0) + 20 >> 2] = i4;
 HEAP32[i12 + (i8 * 28 | 0) + 24 >> 2] = i5;
 STACKTOP = i13;
 return;
}

function _mbrtowc(i2, i4, i7, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = (i1 | 0) == 0 ? gb + 1469688 | 0 : i1;
 i1 = HEAP32[i6 >> 2] | 0;
 L1 : do if (!i4) if (!i1) i1 = 0; else i8 = 15; else {
  i5 = (i2 | 0) == 0 ? i3 : i2;
  if (!i7) i1 = -2; else {
   if (!i1) {
    i1 = HEAP8[i4 >> 0] | 0;
    i2 = i1 & 255;
    if (i1 << 24 >> 24 > -1) {
     HEAP32[i5 >> 2] = i2;
     i1 = i1 << 24 >> 24 != 0 & 1;
     break;
    }
    i1 = i2 + -194 | 0;
    if (i1 >>> 0 > 50) {
     i8 = 15;
     break;
    }
    i1 = HEAP32[gb + 191408 + (i1 << 2) >> 2] | 0;
    i3 = i7 + -1 | 0;
    if (i3) {
     i4 = i4 + 1 | 0;
     i8 = 9;
    }
   } else {
    i3 = i7;
    i8 = 9;
   }
   L11 : do if ((i8 | 0) == 9) {
    i2 = HEAP8[i4 >> 0] | 0;
    i10 = (i2 & 255) >>> 3;
    if ((i10 + -16 | i10 + (i1 >> 26)) >>> 0 > 7) {
     i8 = 15;
     break L1;
    }
    while (1) {
     i4 = i4 + 1 | 0;
     i1 = (i2 & 255) + -128 | i1 << 6;
     i3 = i3 + -1 | 0;
     if ((i1 | 0) >= 0) break;
     if (!i3) break L11;
     i2 = HEAP8[i4 >> 0] | 0;
     if ((i2 & -64) << 24 >> 24 != -128) {
      i8 = 15;
      break L1;
     }
    }
    HEAP32[i6 >> 2] = 0;
    HEAP32[i5 >> 2] = i1;
    i1 = i7 - i3 | 0;
    break L1;
   } while (0);
   HEAP32[i6 >> 2] = i1;
   i1 = -2;
  }
 } while (0);
 if ((i8 | 0) == 15) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[(___errno_location() | 0) >> 2] = 84;
  i1 = -1;
 }
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i2 = i3 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[HEAP32[i7 >> 2] >> 2] = i8;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[gb + 1098096 >> 0] | 0)) {
   i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
   i7 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
   i11 = gb + 63696 | 0;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i9 = i4;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = i10;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i7, 1, gb + 1018240 | 0, 52, 32768, i5, 16);
   HEAP32[gb + 1158352 >> 2] = i7;
   __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i7);
   if (i8) __Z19pop_allocation_rootv();
   i11 = gb + 1098096 | 0;
   HEAP32[i11 >> 2] = 1;
   HEAP32[i11 + 4 >> 2] = 0;
  }
  __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1158352 >> 2] | 0, i2);
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZNK17AnimationCurveTplIfE9FindIndexERKNS0_5CacheEf(i5, i1, f7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 56 >> 2] | 0;
 do if ((i2 | 0) == -1) i6 = i4; else {
  i3 = i4;
  if (Math_fround(HEAPF32[i4 + (i2 << 4) >> 2]) < f7) {
   if ((i2 + 3 | 0) >= (HEAP32[i5 + 68 >> 2] | 0)) {
    i6 = i3;
    break;
   }
   i1 = i2 + 1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 << 4) >> 2]) > f7) {
    i6 = i2;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + (i2 + 2 << 4) >> 2]) > f7) {
    i6 = i1;
    return i6 | 0;
   }
   if (Math_fround(HEAPF32[i4 + (i2 + 3 << 4) >> 2]) > f7) i1 = i2 + 2 | 0; else {
    i6 = i3;
    break;
   }
   return i1 | 0;
  } else {
   if ((i2 + -3 | 0) <= -1) {
    i6 = i3;
    break;
   }
   i1 = i2 + -1 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 << 4) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -2 | 0;
   if (Math_fround(HEAPF32[i4 + (i1 << 4) >> 2]) < f7) {
    i6 = i1;
    return i6 | 0;
   }
   i1 = i2 + -3 | 0;
   if (!(Math_fround(HEAPF32[i4 + (i1 << 4) >> 2]) < f7)) {
    i6 = i3;
    break;
   }
   return i1 | 0;
  }
 } while (0);
 i5 = HEAP32[i5 + 68 >> 2] | 0;
 i1 = i5 << 4 >> 4;
 L24 : while (1) {
  while (1) {
   if (!i1) break L24;
   i2 = (i1 | 0) / 2 | 0;
   i3 = i4 + (i2 << 4) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) < f7) break; else i1 = i2;
  }
  i4 = i3 + 16 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 i4 = (i4 - i6 >> 4) + -1 | 0;
 i6 = i5 + -2 | 0;
 i6 = (i4 | 0) < (i6 | 0) ? i4 : i6;
 i6 = (i6 | 0) > 0 ? i6 : 0;
 return i6 | 0;
}

function __ZN9Animation10DeactivateE19DeactivateOperation(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1465164 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i9;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1465164 | 0, i1);
  i7 = gb + 1465164 | 0;
 } else i7 = 0;
 i1 = HEAP32[i9 + 104 >> 2] | 0;
 i6 = i9 + 108 | 0;
 if ((i1 | 0) != (HEAP32[i6 >> 2] | 0)) do {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + 56 | 0;
  i2 = HEAP16[i5 >> 1] | 0;
  i3 = i2 | 64;
  if ((i2 & 10) == 10) {
   HEAP16[i5 >> 1] = i3;
   i2 = i3;
  }
  HEAP16[i5 >> 1] = i2 & -3;
  __ZN14AnimationState7SetTimeEf(i4, Math_fround(0.0));
  HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -6;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i6 >> 2] | 0));
 i1 = HEAP32[i9 + 316 >> 2] | 0;
 i2 = i9 + 320 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i1 | 0) >>> 4) << 4);
 i1 = i9 + 84 | 0;
 i2 = i9 + 96 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i9 + 100 | 0;
  if ((HEAP32[i3 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 88 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i9 = i9 + 252 | 0;
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 }
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjPjPfRNS_6memory9AllocatorE(i1, i7, i5, i8, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0;
 i9 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 48, 4) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = -1;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i9 + 32 >> 2] = -1;
 HEAPF32[i9 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i9 + 40 >> 2] = Math_fround(0.0);
 HEAP8[i9 + 44 >> 0] = 0;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i9 + 12 >> 2] = i7;
 i4 = (i7 | 0) != 0;
 if (i4) {
  i1 = i9 + 16 | 0;
  i2 = i7 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i7 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i10 = i1;
  i3 = i3 | 0 ? i3 - i10 | 0 : 0;
  HEAP32[i1 >> 2] = i3;
  _memcpy(i3 + i10 | 0, i5 | 0, i2 | 0) | 0;
 }
 HEAP32[i9 >> 2] = 0;
 i5 = i9 + 20 | 0;
 i10 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 8, 4) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i1 = i5;
 i10 = i10 | 0 ? i10 - i1 | 0 : 0;
 HEAP32[i5 >> 2] = i10;
 i1 = i10 + i1 | 0;
 HEAP32[i1 >> 2] = i7;
 if (!i4) return i9 | 0;
 i2 = i1 + 4 | 0;
 i3 = i7 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i3 | 0, 4) | 0;
 if ((i1 | 0) != (i1 + (i7 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 i10 = i2;
 i7 = i1 | 0 ? i1 - i10 | 0 : 0;
 HEAP32[i2 >> 2] = i7;
 _memcpy(i7 + i10 | 0, i8 | 0, i3 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 12 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 706141 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 12 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 * 12 | 0) | 0;
}

function __ZN5physx27PxRigidDynamicGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx24PxRigidBodyGeneratedInfoC2Ev(i1);
 HEAP32[i1 + 336 >> 2] = gb + 673623;
 HEAP32[i1 + 340 >> 2] = 41;
 HEAP32[i1 + 344 >> 2] = fb + 3498;
 HEAP32[i1 + 348 >> 2] = gb + 673639;
 HEAP32[i1 + 352 >> 2] = 42;
 HEAP32[i1 + 356 >> 2] = fb + 373;
 HEAP32[i1 + 360 >> 2] = fb + 316;
 HEAP32[i1 + 364 >> 2] = gb + 673653;
 HEAP32[i1 + 368 >> 2] = 43;
 HEAP32[i1 + 372 >> 2] = fb + 374;
 HEAP32[i1 + 376 >> 2] = fb + 317;
 HEAP32[i1 + 380 >> 2] = gb + 673668;
 HEAP32[i1 + 384 >> 2] = 44;
 HEAP32[i1 + 388 >> 2] = fb + 375;
 HEAP32[i1 + 392 >> 2] = fb + 318;
 HEAP32[i1 + 396 >> 2] = gb + 673687;
 HEAP32[i1 + 400 >> 2] = 45;
 HEAP32[i1 + 404 >> 2] = fb + 2122;
 HEAP32[i1 + 408 >> 2] = gb + 756508;
 HEAP32[i1 + 412 >> 2] = 46;
 HEAP32[i1 + 416 >> 2] = fb + 376;
 HEAP32[i1 + 420 >> 2] = fb + 319;
 HEAP32[i1 + 424 >> 2] = gb + 673698;
 HEAP32[i1 + 428 >> 2] = 47;
 HEAP32[i1 + 432 >> 2] = fb + 377;
 HEAP32[i1 + 436 >> 2] = fb + 320;
 HEAP32[i1 + 440 >> 2] = gb + 673721;
 HEAP32[i1 + 444 >> 2] = 48;
 HEAP32[i1 + 448 >> 2] = fb + 378;
 HEAP32[i1 + 452 >> 2] = fb + 321;
 HEAP32[i1 + 456 >> 2] = gb + 673733;
 HEAP32[i1 + 460 >> 2] = 49;
 HEAP32[i1 + 464 >> 2] = gb + 673755;
 HEAP32[i1 + 468 >> 2] = gb + 673772;
 HEAP32[i1 + 472 >> 2] = fb + 769;
 HEAP32[i1 + 476 >> 2] = fb + 770;
 HEAP32[i1 + 480 >> 2] = gb + 673789;
 HEAP32[i1 + 484 >> 2] = 50;
 HEAP32[i1 + 488 >> 2] = fb + 379;
 HEAP32[i1 + 492 >> 2] = fb + 322;
 HEAP32[i1 + 496 >> 2] = gb + 831985;
 HEAP32[i1 + 500 >> 2] = 51;
 HEAP32[i1 + 504 >> 2] = fb + 2123;
 return;
}

function __ZN15RenderNodeQueue7CleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 12 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i5 = 0;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP32[i2 + (i5 * 360 | 0) + 344 >> 2] | 0;
   if (i1 | 0) mftCall_vii(i1 | 0, i6 | 0, i5 | 0);
   i1 = HEAP32[i2 + (i5 * 360 | 0) + 188 >> 2] | 0;
   if (i1 | 0) {
    i4 = i1 + 4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
    if (!(HEAP32[i4 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
    }
   }
   i4 = i2 + (i5 * 360 | 0) + 244 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAP32[i2 + (i5 * 360 | 0) + 324 >> 2] | 0;
    if ((i1 | 0) > 0) {
     i1 = 0;
     do {
      i2 = HEAP32[i3 + (i1 << 3) >> 2] | 0;
      if (i2 | 0) {
       i8 = i2 + 4 | 0;
       HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
       if (!(HEAP32[i8 >> 2] | 0)) {
        mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
        __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63288 | 0);
       }
      }
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
    }
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 i1 = i6 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i6 + 4 | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 11 | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i7 = i4 + 4 | 0;
 i3 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i3 & 255;
 if (!i3) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i10 = i2 + 11 | 0;
  i11 = HEAP8[i10 >> 0] | 0;
  i9 = i2 + 4 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i5, (i11 << 24 >> 24 < 0 ? HEAP32[i9 >> 2] | 0 : i11 & 255) + 1 + i3 | 0);
  i3 = HEAP8[i10 >> 0] | 0;
  i10 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, i10 ? HEAP32[i2 >> 2] | 0 : i2, i10 ? HEAP32[i9 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i5, gb + 1087625 | 0) | 0;
  i6 = HEAP8[i6 >> 0] | 0;
  i3 = i6 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i7 >> 2] | 0 : i6 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i8;
  return;
 }
}

function _UNITY_FT_Stroker_ExportBorder(i1, i2, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (!((i2 | 1 | 0) == 1 & ((i1 | 0) != 0 & (i8 | 0) != 0))) return;
 if (!(HEAP8[i1 + 64 + (i2 << 5) + 28 >> 0] | 0)) return;
 i9 = i8 + 2 | 0;
 i6 = i1 + 64 + (i2 << 5) | 0;
 _memcpy((HEAP32[i8 + 4 >> 2] | 0) + (HEAP16[i9 >> 1] << 3) | 0, HEAP32[i1 + 64 + (i2 << 5) + 8 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 64 + (i2 << 5) + 12 | 0;
 if (!i5) {
  i2 = (HEAP32[i8 >> 2] | 0) >>> 16 & 65535;
  i1 = 0;
 } else {
  i3 = (HEAP32[i8 + 8 >> 2] | 0) + (HEAP16[i9 >> 1] | 0) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = i5;
  while (1) {
   i2 = HEAPU8[i4 >> 0] | 0;
   do if (!(i2 & 1)) if (!(i2 & 2)) {
    HEAP8[i3 >> 0] = 0;
    break;
   } else {
    HEAP8[i3 >> 0] = 2;
    break;
   } else HEAP8[i3 >> 0] = 1; while (0);
   i1 = i1 + -1 | 0;
   if (!i1) break; else {
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   }
  }
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = i3 >>> 16 & 65535;
  if (!i1) i1 = 0; else {
   i3 = (HEAP32[i8 + 12 >> 2] | 0) + (i3 << 16 >> 16 << 1) | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = i1;
   i6 = i2;
   while (1) {
    if (HEAP8[i4 >> 0] & 8) {
     HEAP16[i3 >> 1] = i6;
     i2 = HEAP32[i8 >> 2] | 0;
     HEAP16[i8 >> 1] = (i2 & 65535) + 1 << 16 >> 16;
     i3 = i3 + 2 | 0;
     i2 = i2 >>> 16 & 65535;
    }
    i5 = i5 + -1 | 0;
    if (!i5) break; else {
     i4 = i4 + 1 | 0;
     i6 = i6 + 1 << 16 >> 16;
    }
   }
  }
 }
 HEAP16[i9 >> 1] = (i2 & 65535) + i1;
 return;
}

function __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 108 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE8__appendEj(i1, i2 - i4 | 0);
  STACKTOP = i10;
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i3 = i3 + (i2 * 108 | 0) | 0;
 if ((i5 | 0) == (i3 | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i8 + 4 | 0;
 i6 = i8 + 4 | 0;
 i7 = i8 + 4 | 0;
 i2 = i5;
 do {
  i1 = i2 + -108 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i1 >> 2] = gb + 59740 + 8;
  i1 = i2 + -68 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + -56 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  i1 = i2 + -84 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + -72 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i6 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  i1 = i2 + -104 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i2 + -92 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i2;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  i2 = HEAP32[i9 >> 2] | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i10;
 return;
}

function __ZNSt3__26__treeIN12ShaderErrors11ShaderErrorENS_4lessIS2_EENS_9allocatorIS2_EEE5eraseENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_PvEEiEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i4;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) HEAP32[i3 >> 2] = i1;
 i2 = i3 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i3 + 4 >> 2] | 0, i4);
 i3 = i4 + 16 | 0;
 i2 = i4 + 48 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i4 + 60 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i5);
 }
 i2 = i4 + 32 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 + 44 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i5);
 }
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i4);
  STACKTOP = i6;
  return i1 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i4 + 28 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i5);
 __ZdlPv(i4);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK22VirtualJoystickManager23GetVirtualJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i4 = i1 + -12 | 0;
  HEAP32[i7 >> 2] = i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i7 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = i3 + 24 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i5 + 8 | 0;
 do {
  if (!(HEAP8[i1 + 12 >> 0] | 0)) {
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
  } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i1);
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i5, i6); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 * 12 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 681780 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 12 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 * 12 | 0) | 0;
}

function _ycck_cmyk_convert(i1, i19, i3, i2, i4) {
 i1 = i1 | 0;
 i19 = i19 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0, i18 = 0, i20 = 0, i21 = 0, i22 = 0, i23 = 0;
 i15 = HEAP32[i1 + 420 >> 2] | 0;
 i20 = HEAP32[i1 + 92 >> 2] | 0;
 i11 = HEAP32[i1 + 288 >> 2] | 0;
 i12 = HEAP32[i15 + 8 >> 2] | 0;
 i13 = HEAP32[i15 + 12 >> 2] | 0;
 i14 = HEAP32[i15 + 16 >> 2] | 0;
 i15 = HEAP32[i15 + 20 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i16 = i19 + 4 | 0;
 i17 = i19 + 8 | 0;
 i18 = i19 + 12 | 0;
 if (!i20) return;
 while (1) {
  i6 = i4;
  i4 = i4 + -1 | 0;
  i7 = HEAP32[(HEAP32[i19 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i8 = HEAP32[(HEAP32[i16 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i9 = HEAP32[(HEAP32[i17 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i10 = HEAP32[(HEAP32[i18 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i5 = 0;
  while (1) {
   i21 = HEAPU8[i8 + i5 >> 0] | 0;
   i23 = HEAPU8[i9 + i5 >> 0] | 0;
   i22 = (HEAPU8[i7 + i5 >> 0] | 0) ^ 255;
   HEAP8[i1 >> 0] = HEAP8[i11 + (i22 - (HEAP32[i12 + (i23 << 2) >> 2] | 0)) >> 0] | 0;
   HEAP8[i1 + 1 >> 0] = HEAP8[i11 + (i22 - ((HEAP32[i14 + (i23 << 2) >> 2] | 0) + (HEAP32[i15 + (i21 << 2) >> 2] | 0) >> 16)) >> 0] | 0;
   HEAP8[i1 + 2 >> 0] = HEAP8[i11 + (i22 - (HEAP32[i13 + (i21 << 2) >> 2] | 0)) >> 0] | 0;
   HEAP8[i1 + 3 >> 0] = HEAP8[i10 + i5 >> 0] | 0;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i20 | 0)) break; else i1 = i1 + 4 | 0;
  }
  if ((i6 | 0) <= 1) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function _vfprintf(i15, i8, i1) {
 i15 = i15 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i16 + 120 | 0;
 i11 = i16 + 80 | 0;
 i13 = i16;
 i14 = i16 + 136 | 0;
 i2 = i11;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 if ((_printf_core(0, i8, i10, i13, i11) | 0) < 0) i1 = -1; else {
  if ((HEAP32[i15 + 76 >> 2] | 0) > -1) i12 = ___lockfile(i15) | 0; else i12 = 0;
  i1 = HEAP32[i15 >> 2] | 0;
  i9 = i1 & 32;
  if ((HEAP8[i15 + 74 >> 0] | 0) < 1) HEAP32[i15 >> 2] = i1 & -33;
  i2 = i15 + 48 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i3 = i15 + 44 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = i14;
   i5 = i15 + 28 | 0;
   HEAP32[i5 >> 2] = i14;
   i6 = i15 + 20 | 0;
   HEAP32[i6 >> 2] = i14;
   HEAP32[i2 >> 2] = 80;
   i7 = i15 + 16 | 0;
   HEAP32[i7 >> 2] = i14 + 80;
   i1 = _printf_core(i15, i8, i10, i13, i11) | 0;
   if (i4) {
    mftCall_iiii(HEAP32[i15 + 36 >> 2] | 0, i15 | 0, 0, 0) | 0;
    i1 = (HEAP32[i6 >> 2] | 0) == 0 ? -1 : i1;
    HEAP32[i3 >> 2] = i4;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i7 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i6 >> 2] = 0;
   }
  } else i1 = _printf_core(i15, i8, i10, i13, i11) | 0;
  i2 = HEAP32[i15 >> 2] | 0;
  HEAP32[i15 >> 2] = i2 | i9;
  if (i12 | 0) ___unlockfile(i15);
  i1 = (i2 & 32 | 0) == 0 ? i1 : -1;
 }
 STACKTOP = i16;
 return i1 | 0;
}

function __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 3 >>> 0 >= i2 >>> 0) {
  do {
   i8 = i1;
   i7 = i8;
   HEAP16[i7 >> 1] = 0;
   HEAP16[i7 + 2 >> 1] = 0 >>> 16;
   i8 = i8 + 4 | 0;
   HEAP16[i8 >> 1] = 0;
   HEAP16[i8 + 2 >> 1] = 0 >>> 16;
   i1 = (HEAP32[i9 >> 2] | 0) + 8 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 3) + i2 | 0;
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 2;
 i3 = i6 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 536870911;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 3) | 0;
 i6 = i5 + (i1 - i4 >> 3 << 3) | 0;
 i5 = i5 + (i3 << 3) | 0;
 i1 = i6;
 i4 = i6;
 do {
  i3 = i1;
  i10 = i3;
  HEAP16[i10 >> 1] = 0;
  HEAP16[i10 + 2 >> 1] = 0 >>> 16;
  i3 = i3 + 4 | 0;
  HEAP16[i3 >> 1] = 0;
  HEAP16[i3 + 2 >> 1] = 0 >>> 16;
  i1 = i4 + 8 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 3) << 3) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19findPropertyMessageERKN5physx8debugger14NamespacedNameE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl23findPropertyMessageImplERKN5physx8debugger14NamespacedNameE(i2, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = gb + 148944 + 8;
 if (!i1) {
  HEAP32[i3 + 4 >> 2] = gb + 1576256;
  HEAP32[i3 + 8 >> 2] = gb + 1576256;
  HEAP32[i3 + 16 >> 2] = gb + 1576256;
  HEAP32[i3 + 20 >> 2] = gb + 1576256;
  i2 = i3 + 28 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP8[i2 + 20 >> 0] = 0;
  i2 = -1;
  i4 = -1;
  i1 = i3 + 12 | 0;
  HEAP32[i1 >> 2] = i4;
  i3 = i3 + 24 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 } else {
  i5 = i1 + 4 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i6;
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = i1 + 16 | 0;
  i5 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = i3 + 16 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  i2 = HEAP32[i1 + 24 >> 2] | 0;
  HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
  i5 = HEAP32[i1 + 36 >> 2] | 0;
  HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i3 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i3 + 36 >> 2] = i5;
  HEAP8[i3 + 48 >> 0] = 1;
  i1 = i4;
  i4 = i3 + 12 | 0;
  HEAP32[i4 >> 2] = i1;
  i4 = i3 + 24 | 0;
  HEAP32[i4 >> 2] = i2;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 36 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 656742 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 36 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   i1 = i1 + 36 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 36 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd21computeQuatFromNormalERKNS_6PxVec3E(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 if (f1 > Math_fround(.999899983)) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  return;
 }
 if (f1 < Math_fround(-.999899983)) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
  return;
 } else {
  f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(0.0)) + Math_fround(f7 * f7))));
  f4 = Math_fround(Math_fround(1.0) / f8);
  f6 = Math_fround(f4 * Math_fround(0.0));
  f5 = Math_fround(f5 * f4);
  f4 = Math_fround(f7 * f4);
  i3 = f8 < Math_fround(1.0);
  f8 = i3 ? f8 : Math_fround(1.0);
  i3 = f8 < Math_fround(-1.0);
  f8 = i3 ? Math_fround(-1.0) : f8;
  i3 = f8 > Math_fround(1.0);
  f8 = Math_fround(+Math_asin(+(i3 ? Math_fround(1.0) : f8)));
  f7 = Math_fround(Math_fround(3.14159274) - f8);
  i3 = f1 >= Math_fround(0.0);
  f7 = Math_fround((i3 ? f8 : f7) * Math_fround(.5));
  f1 = Math_fround(+Math_sin(+f7));
  HEAPF32[i2 + 12 >> 2] = Math_fround(+Math_cos(+f7));
  HEAPF32[i2 >> 2] = Math_fround(f6 * f1);
  HEAPF32[i2 + 4 >> 2] = Math_fround(-Math_fround(f5 * f1));
  HEAPF32[i2 + 8 >> 2] = Math_fround(f4 * f1);
  return;
 }
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i5, i1, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 4 | 0;
 i4 = i5 + 92 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (HEAP32[i5 + 80 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = i5 + 132 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i9 = __ZnwjRK10MemLabelIdiPKci(96, gb + 63552 | 0, 16, gb + 366978 | 0, 168) | 0;
  __ZN23ArchiveStorageConverterC2EP32IArchiveStorageConverterListenerb(i9, i5 + 128 | 0, (HEAP8[i5 + 188 >> 0] | 0) != 0);
  HEAP32[i2 >> 2] = i9;
  __ZN23ArchiveStorageConverter11SetPriorityE14ThreadPriority(i9, HEAP32[i5 + 56 >> 2] | 0);
 }
 if ((i1 | 0) != 0 & (i3 | 0) != 0) if ((__ZN23ArchiveStorageConverter11ProcessDataEPKvj(HEAP32[i2 >> 2] | 0, i1, i3) | 0) < 0) {
  if (HEAP32[i4 >> 2] | 0) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
  HEAP32[i4 >> 2] = 9;
  i1 = i5 + 112 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  __Z6FormatPKcz(i6, gb + 366859 | 0, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5 + 96 | 0, i6) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAPF32[i5 + 136 >> 2] = Math_fround(__ZN23ArchiveStorageConverter11GetProgressEv(HEAP32[i2 >> 2] | 0));
 i9 = 1;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN15PolynomialCurve9IntegrateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, f5 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 HEAPF32[i6 + 128 >> 2] = Math_fround(0.0);
 i7 = i6 + 224 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i2 = 1;
  f3 = Math_fround(0.0);
  i4 = i6 + 192 | 0;
  f5 = Math_fround(0.0);
  do {
   f10 = f3;
   f3 = Math_fround(HEAPF32[i4 >> 2]);
   i1 = i2 + -1 | 0;
   f9 = Math_fround(HEAPF32[i6 + (i1 << 4) >> 2]);
   f8 = Math_fround(HEAPF32[i6 + (i1 << 4) + 4 >> 2]);
   f11 = Math_fround(HEAPF32[i6 + (i1 << 4) + 8 >> 2]);
   f10 = Math_fround(f3 - f10);
   f5 = Math_fround(f5 + Math_fround(f10 * Math_fround(Math_fround(HEAPF32[i6 + (i1 << 4) + 12 >> 2]) + Math_fround(f10 * Math_fround(Math_fround(f11 * Math_fround(.5)) + Math_fround(f10 * Math_fround(Math_fround(f10 * Math_fround(f9 * Math_fround(.25))) + Math_fround(f8 * Math_fround(.333333343)))))))));
   HEAPF32[i6 + 128 + (i2 << 2) >> 2] = f5;
   i4 = i6 + 192 + (i2 << 2) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 if ((i1 | 0) > 0) i1 = 0; else return;
 do {
  i12 = i6 + (i1 << 4) | 0;
  f9 = Math_fround(Math_fround(HEAPF32[i12 >> 2]) * Math_fround(.25));
  i2 = i6 + (i1 << 4) + 4 | 0;
  f10 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.333333343));
  i4 = i6 + (i1 << 4) + 8 | 0;
  f11 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.5));
  HEAPF32[i12 >> 2] = f9;
  HEAPF32[i2 >> 2] = f10;
  HEAPF32[i4 >> 2] = f11;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 return;
}

function __ZN14EdgeCollider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 0;
 i8 = gb + 1162356 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 + 53 >> 0] = 0;
 i6 = i1 + 160 | 0;
 i7 = i1 + 176 | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i5 = i1 + 164 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
  HEAP32[i6 >> 2] = 0;
 } else i5 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = 0;
 i8 = i1 + 172 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 >> 2] = 1;
 i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 8, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i1 >> 2] = -1090519040;
 HEAP32[i1 + 4 >> 2] = 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i4 >>> 0 < 2) {
  i2 = i3 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i4 >>> 0 < i2 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 3, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i6 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = 2;
 HEAP32[i1 + 8 >> 2] = 1056964608;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __Z43NavMeshPath_CUSTOM_CalculateCornersInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i1 + 8 | 0;
 i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 i5 = i6 + 4 | 0;
 i8 = gb + 63160 | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i3 = i3 + 2 | 0;
 i1 = i3 * 12 | 0;
 do if (!i1) i1 = 0; else {
  i2 = i1 | 3;
  if (i2 >>> 0 < 2e3) {
   i1 = STACKTOP;
   STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
   if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 851952 | 0, 85) | 0;
   i2 = gb + 64016 | 0;
   i9 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i6 >> 2] = i1;
   i8 = i5;
   HEAP32[i8 >> 2] = i9;
   HEAP32[i8 + 4 >> 2] = i2;
   break;
  }
 } while (0);
 i2 = i1 + 3 & -4;
 i8 = __Z17GetNavMeshManagerv() | 0;
 i8 = __ZN14NavMeshManager20CalculatePathCornersEP8Vector3fiRK11NavMeshPath(i8, i2, i3, HEAP32[i4 >> 2] | 0) | 0;
 i9 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
 i8 = (i2 | 0) == 0 ? 0 : i8;
 i9 = __Z19scripting_array_newP11Il2CppClassjj(i9, 12, i8) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i9, 0, 12) | 0, i2 | 0, i8 * 12 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 STACKTOP = i7;
 return i9 | 0;
}

function __Z42VRSettings_Get_Custom_PropSupportedDevicesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i6 = i9;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN8VRDevice19GetSupportedDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i6);
 i8 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8, 4, (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = i4;
 if ((i2 | 0) != (i4 | 0)) {
  i3 = 0;
  do {
   i1 = i1 + (i3 << 4) | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i8, i3, __Z20scripting_string_newPKc(i1) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   i1 = i4;
  } while (i3 >>> 0 < i2 - i4 >> 4 >>> 0);
 }
 if (!i1) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i5 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i8 | 0;
}

function __Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178624 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 178624 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _md5_sum(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i4 >> 2] & 63;
 i2 = i3 + 1 | 0;
 i1 = i4 + 24 | 0;
 HEAP8[i4 + 24 + i3 >> 0] = -128;
 if (i2 >>> 0 > 56) {
  _memset(i4 + 24 + i2 | 0, 0, i3 ^ 63 | 0) | 0;
  _processblock(i4, i1);
  i2 = 0;
 }
 _memset(i4 + 24 + i2 | 0, 0, 56 - i2 | 0) | 0;
 i3 = i4;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = _bitshift64Shl(i2 | 0, i3 | 0, 3) | 0;
 i8 = getTempRet0() | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP8[i4 + 80 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 5) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 81 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 13) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 82 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 21) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 83 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 29) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 84 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 37) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 85 >> 0] = i6;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 45) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 86 >> 0] = i6;
 i3 = _bitshift64Lshr(i2 | 0, i3 | 0, 53) | 0;
 getTempRet0() | 0;
 HEAP8[i4 + 87 >> 0] = i3;
 _processblock(i4, i1);
 i1 = 0;
 do {
  i7 = i4 + 8 + (i1 << 2) | 0;
  i8 = i1 << 2;
  HEAP8[i5 + i8 >> 0] = HEAP32[i7 >> 2];
  HEAP8[i5 + (i8 | 1) >> 0] = (HEAP32[i7 >> 2] | 0) >>> 8;
  HEAP8[i5 + (i8 | 2) >> 0] = (HEAP32[i7 >> 2] | 0) >>> 16;
  HEAP8[i5 + (i8 | 3) >> 0] = (HEAP32[i7 >> 2] | 0) >>> 24;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 104 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 108 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 112 >> 2])) return;
  }
 } else i1 = i9 + 108 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 112 >> 2] = i6;
 HEAP32[i9 + 536 >> 2] = 0;
 return;
}

function __ZNK14Texture2DArray9GetPixelsEiP10ColorRGBAfii(i3, i4, i8, i9, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i10 = i13 + 12 | 0;
 if (!(__ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii(i3, i4, i8, i9, i1) | 0)) {
  i12 = 0;
  STACKTOP = i13;
  return i12 | 0;
 }
 i11 = HEAP32[i3 + 96 >> 2] | 0;
 i5 = HEAP32[i3 + 104 >> 2] | 0;
 i2 = i3 + 80 | 0;
 i14 = i3 + 84 | 0;
 i6 = i3 + 92 | 0;
 i7 = __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i6 >> 2] | 0, i1) | 0;
 i2 = HEAP32[i2 >> 2] >> i1;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i1 = HEAP32[i14 >> 2] >> i1;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if ((Math_imul(i1, i2) | 0) > (i4 | 0)) {
  HEAP32[i12 >> 2] = i4;
  HEAP32[i12 + 4 >> 2] = i2;
  HEAP32[i12 + 8 >> 2] = i1;
  __Z6FormatPKcz(i10, gb + 418334 | 0, i12);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 411289 | 0, 317, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i14 = 0;
  STACKTOP = i13;
  return i14 | 0;
 } else {
  i14 = i11 + (Math_imul(i5, i9) | 0) + i7 | 0;
  __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i14, i2, i1, HEAP32[i6 >> 2] | 0, 0, 0, i2, i1, i8) | 0;
  i14 = 1;
  STACKTOP = i13;
  return i14 | 0;
 }
 return 0;
}

function __ZN5physx26PxRigidStaticGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 HEAP32[i1 + 120 >> 2] = gb + 673509;
 HEAP32[i1 + 124 >> 2] = 23;
 HEAP32[i1 + 128 >> 2] = fb + 3496;
 HEAP32[i1 + 132 >> 2] = fb + 3497;
 HEAP32[i1 + 136 >> 2] = gb + 673520;
 HEAP32[i1 + 140 >> 2] = 24;
 HEAP32[i1 + 144 >> 2] = fb + 398;
 HEAP32[i1 + 148 >> 2] = fb + 2119;
 HEAP32[i1 + 152 >> 2] = gb + 673527;
 HEAP32[i1 + 156 >> 2] = 25;
 HEAP32[i1 + 160 >> 2] = fb + 399;
 HEAP32[i1 + 164 >> 2] = fb + 2120;
 HEAP32[i1 + 168 >> 2] = gb + 831985;
 HEAP32[i1 + 172 >> 2] = 54;
 HEAP32[i1 + 176 >> 2] = fb + 2121;
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 188012 + 8;
 i1 = i5 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN13UploadHandler7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN15DownloadHandler7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 92 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 76 | 0);
 i4 = i5 + 56 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = i5 + 60 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    HEAP32[i3 >> 2] = i2 + -32;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + -12 | 0);
    __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2 + -24 | 0, HEAP32[i2 + -20 >> 2] | 0);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5 + 44 | 0, HEAP32[i5 + 48 >> 2] | 0);
 __ZN19TransportJavaScriptD2Ev(i5 + 8 | 0);
 return;
}

function __ZN19CharacterController7PRODUCEE10MemLabelId18ObjectCreationMode(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i2, 16, gb + 1048932 | 0, 0, gb + 779516 | 0, 41) | 0;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 111344 + 8;
 HEAP32[i4 + 64 >> 2] = gb + 111320 + 8;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 i9 = i4 + 112 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP8[i4 + 108 >> 0] = 1;
 HEAPF64[i4 + 144 >> 3] = 0.0;
 HEAP8[i4 + 152 >> 0] = 1;
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13AnimationClip15QuaternionCurveC2ERKS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i6 = HEAP8[i5 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
 i6 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = i1;
 if (i6 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i6 >>> 0 < 11) {
  HEAP8[i4 + 11 >> 0] = i6;
  if (!i6) i1 = i4; else {
   i1 = i4;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i6 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i4 + 4 >> 2] = i6;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 _memcpy(i4 + 16 | 0, i5 + 16 | 0, 152) | 0;
 __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEC2ERKS3_(i4 + 168 | 0, i5 + 168 | 0);
 i9 = i4 + 188 | 0;
 i7 = i5 + 188 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 200 >> 2] = HEAP32[i5 + 200 >> 2];
 STACKTOP = i8;
 return;
}

function __ZN9b2Fixture6CreateEP16b2BlockAllocatorP6b2BodyPK12b2FixtureDef(i4, i2, i1, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 HEAP32[i4 + 60 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 28 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = 0;
 i3 = i4 + 52 | 0;
 i1 = i5 + 22 | 0;
 HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
 HEAP16[i3 + 2 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
 HEAP16[i3 + 4 >> 1] = HEAP16[i1 + 4 >> 1] | 0;
 HEAP8[i4 + 58 >> 0] = HEAP8[i5 + 20 >> 0] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 HEAP32[i4 + 32 >> 2] = i3;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, i3 * 28 | 0) | 0;
 HEAP32[i4 + 44 >> 2] = i2;
 if ((i3 | 0) > 0) i1 = 0; else {
  i3 = i4 + 48 | 0;
  HEAP32[i3 >> 2] = 0;
  i3 = i5 + 16 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 20 | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  return;
 }
 do {
  HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] = 0;
  HEAP32[i2 + (i1 * 28 | 0) + 24 >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i3 = i4 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i5 + 16 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 20 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 return;
}

function __ZN9SubModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 4 | 0;
 i2 = i12;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
 i6 = i1 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i10 = i8 + 16 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i11 = i8 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i10 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + (i6 * 12 | 0) | 0;
 if (!i6) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN4PPtrI14ParticleSystemE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i6 = i1 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i11 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
   i4 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
  i2 = i1 + 8 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 8 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i4 = 0; else {
  i1 = i7 * 12 | 0;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 738666 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 * 12 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i3 = i4 + (i1 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 if ((HEAP32[i9 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 * 12 | 0) | 0;
}

function __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 & -1073741824 | 0) != -2147483648) {
  STACKTOP = i11;
  return;
 }
 i9 = i10 + 256 | 0;
 i6 = i10 + 260 | 0;
 i7 = i10 + 264 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i10 + 268 | 0;
 HEAP8[i9 >> 0] = 1;
 HEAP32[i6 >> 2] = i10;
 HEAP32[i8 >> 2] = 64;
 i3 = i1 + 16 | 0;
 i1 = (HEAP32[gb + 90260 + 24 + ((i2 >>> 24 & 15) << 2) >> 2] | 0) + i4 | 0;
 if (i5) __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i3, i1, i10, 1); else __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb(i3, i1, i10, 1);
 i1 = HEAP32[i6 >> 2] | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i2 = 0;
  do {
   __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE((HEAP32[i1 + (i2 << 2) >> 2] | 0) + -16 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 }
 i8 = HEAP32[i8 >> 2] | 0;
 do if ((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) == (i1 | 0)) {
   HEAP8[i9 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZN29AssetBundleLoadAssetOperation18GetAllLoadedAssetsER13dynamic_arrayIP6ObjectLj4EE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i6 + 160 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i1 = 0; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i5);
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if ((HEAP16[gb + 1104160 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104160 | 0, i4);
  i1 = gb + 1104160 | 0;
 } else i1 = 0;
 __ZN29AssetBundleLoadAssetOperation15GetLoadedAssetsER13dynamic_arrayIP6ObjectLj4EEb(i6, i7, 0);
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i8;
 return;
}

function __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i1, i2, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 __Z24scripting_cpp_string_forP12Il2CppString(i7, i2);
 i6 = HEAP8[i7 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 do if (!((i1 ? HEAP32[i7 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  i1 = i9 + 11 | 0;
  if ((HEAP8[i1 >> 0] | 0) < 0) {
   HEAP8[HEAP32[i9 >> 2] >> 0] = 0;
   HEAP32[i9 + 4 >> 2] = 0;
   break;
  } else {
   HEAP8[i9 >> 0] = 0;
   HEAP8[i1 >> 0] = 0;
   break;
  }
 } else {
  i5 = i1 ? HEAP32[i7 >> 2] | 0 : i7;
  i6 = _strlen(i5) | 0;
  i3 = i9 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i6 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i9, i4, i6 - i4 | 0, i1, 0, i1, i6, i5);
   break;
  }
  if (i2) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i6 | 0) _memmove(i1 | 0, i5 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i3 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper21addPropertyMessageArgERKN5physx8debugger14NamespacedNameEjj(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i9 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i7 = HEAP32[i5 + 8 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 96 >> 2] | 0, i8 | 0) | 0;
 i9 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i9 | 0, i6 + 20 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 i7 = i1;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i9;
 i1 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = i3;
 i1 = i5 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i5 + 104 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i9 = (HEAP32[i5 + 96 >> 2] | 0) + (i2 * 20 | 0) | 0;
  HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i9 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i5 + 84 | 0, i4) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZL16GetInterfaceImpl18UnityInterfaceGUID(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = (HEAP32[gb + 1163148 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = i1;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i8;
 L4 : while (1) {
  i1 = i2;
  while (1) {
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i3 = HEAP32[i3 + 4 >> 2] | 0;
   if (!(i3 >>> 0 < i7 >>> 0 | (i3 | 0) == (i7 | 0) & i2 >>> 0 < i9 >>> 0)) {
    if (!((i2 | 0) == (i9 | 0) & (i3 | 0) == (i7 | 0))) break;
    i3 = i1 + 24 | 0;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i2 >>> 0 < i6 >>> 0 | ((i2 | 0) == (i6 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i5 >>> 0 : 0))) break;
   }
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = i4;
    break L4;
   }
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i4 = i1;
 }
 if ((i1 | 0) == (i8 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i3 = i1 + 16 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i9 >>> 0 < i2 >>> 0) {
  i9 = 0;
  return i9 | 0;
 }
 if ((i9 | 0) == (i2 | 0) & (i7 | 0) == (i3 | 0)) {
  i9 = i1 + 24 | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
  if (i6 >>> 0 < i7 >>> 0 | ((i6 | 0) == (i7 | 0) ? i5 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0 : 0) | (i1 | 0) == (i8 | 0)) {
   i9 = 0;
   return i9 | 0;
  }
 } else if ((i1 | 0) == (i8 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP32[i1 + 32 >> 2] | 0;
 return i9 | 0;
}

function __Z20Cubemap_CUSTOM_ApplyP12Il2CppObjecthh(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i3) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 111 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI7CubemapEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 do if (i1 << 24 >> 24) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
  HEAP8[i1 + 111 >> 0] = 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
   HEAP8[i1 + 112 >> 0] = 1;
   break;
  }
 } while (0);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(i6 << 24 >> 24)) {
  mftCall_vi(HEAP32[i1 + 196 >> 2] | 0, i2 | 0);
  STACKTOP = i7;
  return;
 } else {
  mftCall_vi(HEAP32[i1 + 192 >> 2] | 0, i2 | 0);
  STACKTOP = i7;
  return;
 }
}

function _destroy_face(i8, i9, i3) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i9 + 120 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, HEAP32[i9 + 116 >> 2] | 0);
 i2 = i9 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  _UNITY_FT_Done_GlyphSlot(i1);
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != 0);
 _UNITY_FT_List_Finalize(i9 + 108 | 0, fb + 958 | 0, i8, i3);
 HEAP32[i9 + 88 >> 2] = 0;
 i1 = HEAP32[i9 + 48 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i9 | 0);
 i2 = i9 + 36 | 0;
 i3 = i9 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + 8 >> 2] | 0;
   if (i6 | 0) mftCall_vi(i6 | 0, i4 | 0);
   _UNITY_ft_mem_free(i5, i4);
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 _UNITY_ft_mem_free(i8, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i9 | 0);
 i1 = i9 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = HEAP32[i9 + 8 >> 2] & 1024;
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  _UNITY_FT_Stream_Close(i2);
  if (!i7) _UNITY_ft_mem_free(i3, i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i9 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  _UNITY_ft_mem_free(i8, i9);
  return;
 }
 _UNITY_ft_mem_free(i8, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i8, i9);
 return;
}

function __ZNSt3__26localeC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 do if (!i2) {
  i1 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_vii(fb + 4505 | 0, i1 | 0, gb + 1082145 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i5;
   break;
  } else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13128 | 0, fb + 3224 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break;
  }
 } else {
  i5 = __Znwj(160) | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i6 = _strlen(i2) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, i3 | 0, i2 | 0, i6 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  do if (i2 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_viii(fb + 1059 | 0, i5 | 0, i3 | 0, 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    break;
   } else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
    HEAP32[i1 >> 2] = i5;
    __ZNSt3__214__shared_count12__add_sharedEv(i5);
    STACKTOP = i4;
    return;
   }
  } while (0);
  __ZdlPv(i5);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNK7VRInput19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i2 | 0) == (i5 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 4 | 0;
 i7 = i8 + 8 | 0;
 while (1) {
  i1 = i2 + 16 | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i2 + 20 >> 2] | 0;
  } else {
   i4 = i1;
   i1 = i3 & 255;
  };
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP32[i9 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i9, i4, i1);
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i8, i9); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i9);
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 STACKTOP = i10;
 return;
}

function __ZNK5Unity10HingeJoint14GetLocalFramesERN5physx11PxTransformES3_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 1065353216;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 1065353216;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i4 + 24 >> 2] = 0;
  STACKTOP = i6;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i5 | 0, i2 | 0, 0);
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i5 | 0, i3 | 0, 1);
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __ZN9Animation13AwakeFromLoadE17AwakeFromLoadMode(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i6, i4);
 i5 = i6 + 72 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i6 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = i2; else {
  do {
   __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i6);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) i1 = i2; else {
   i7 = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2) | 0;
   HEAP32[i5 >> 2] = i7;
   i1 = i2;
   i2 = i7;
  }
 }
 if ((HEAP32[i6 + 44 >> 2] | 0) == 1) if ((HEAP32[i6 + 104 >> 2] | 0) != (HEAP32[i6 + 108 >> 2] | 0)) {
  if ((i1 | 0) != (i2 | 0)) {
   do {
    __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i6);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i2 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
  }
  __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN9Animation25CheckRendererVisibleStateEv(i6);
 }
 if ((i4 & 13 | 0) == 0 | (HEAP8[i6 + 40 >> 0] | 0) == 0) return;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 __ZN9Animation4PlayEi(i6, 4) | 0;
 return;
}

function __ZN5physx3Scb11RigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 125988 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125988 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125988 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125988 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125988 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125988 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125988 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125988 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 748057;
 HEAP32[i4 + 4 >> 2] = gb + 747951;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 64;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 126020 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 126020 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 126020 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 126020 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 126020 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 126020 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 126020 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 126020 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sn5ConvXD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 89080 + 8;
 __ZN5physx2Sn5ConvX13resetNbErrorsEv(i5);
 __ZN5physx2Sn5ConvX16resetConvexFlagsEv(i5);
 __ZN5physx2Sn5ConvX15releaseMetaDataEv(i5);
 __ZN5physx2Sn5ConvX11resetUnionsEv(i5);
 __ZN5physx2Sn12PointerRemapD2Ev(i5 + 344 | 0);
 i3 = i5 + 292 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 296 >> 2] | 0;
 i4 = i1 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) do {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (i2 | 0) {
    i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
   }
  }
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i6 = HEAP32[i5 + 300 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i6 = HEAP32[i5 + 32 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 24 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i1 | 0) == 0 | ((i6 | 0) < 0 | (i6 & 2147483647 | 0) == 0)) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i10, i4, i1) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 >> 2] = i3;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j(i4, i1);
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
   i3 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = i5;
  }
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags(i10, i1 + 8 | 0, 0);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i5 = 24;
 do {
  i4 = i6 + 84 + (i5 + -24 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do if (i1 | 0) {
   HEAP32[i8 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i7, i1, i8);
     i2 = HEAP32[i7 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 11;
    }
   }
   if ((i9 | 0) == 9) i9 = 11;
   if ((i9 | 0) == 11) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
    if (!i1) break;
   }
   __Z22SetManagerPtrInContextiP6Object(i5, i1);
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 28);
 STACKTOP = i10;
 return;
}

function ___tan(d3, d1, i6) {
 d3 = +d3;
 d1 = +d1;
 i6 = i6 | 0;
 var i2 = 0, d4 = 0.0, i5 = 0, i7 = 0, d8 = 0.0, d9 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d3;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i5 = i2 & 2147483640;
 i5 = i5 >>> 0 > 1072010279 | (i5 | 0) == 1072010279 & 0 > 0;
 if (i5) {
  i2 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, i2 | 0, 63) | 0;
  getTempRet0() | 0;
  i7 = (i2 | 0) == 0;
  d3 = .7853981633974483 - (i7 ? d3 : -d3) + (3.061616997868383e-17 - (i7 ? d1 : -d1));
  d1 = 0.0;
 } else i2 = 0;
 d8 = d3 * d3;
 d4 = d8 * d8;
 d9 = d3 * d8;
 d4 = d9 * .3333333333333341 + (d1 + d8 * (d1 + d9 * (d4 * (d4 * (d4 * (d4 * (7.817944429395571e-05 - d4 * 1.8558637485527546e-05) + 5.880412408202641e-04) + 3.5920791075913124e-03) + .021869488294859542) + .13333333333320124 + d8 * (d4 * (d4 * (d4 * (d4 * (d4 * 2.590730518636337e-05 + 7.140724913826082e-05) + 2.464631348184699e-04) + 1.4562094543252903e-03) + .0088632398235993) + .05396825397622605))));
 d1 = d3 + d4;
 if (i5) {
  d9 = +(1 - (i6 << 1) | 0);
  d1 = d9 - (d3 + (d4 - d1 * d1 / (d9 + d1))) * 2.0;
  d1 = i2 | 0 ? -d1 : d1;
 } else if (i6) {
  HEAPF64[tempDoublePtr >> 3] = d1;
  i7 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i7;
  d9 = +HEAPF64[tempDoublePtr >> 3];
  d8 = -1.0 / d1;
  HEAPF64[tempDoublePtr >> 3] = d8;
  i7 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i7;
  d1 = +HEAPF64[tempDoublePtr >> 3];
  d1 = d1 + d8 * (d9 * d1 + 1.0 + d1 * (d4 - (d9 - d3)));
 }
 return +d1;
}

function __ZN9AudioClipC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 170392 + 8;
 i3 = i1 + 32 | 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 __ZN11SoundHandleC2Ev(i1 + 56 | 0);
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP8[i1 + 64 >> 0] = 1;
 HEAP8[i1 + 65 >> 0] = 0;
 HEAP8[i1 + 66 >> 0] = 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = i1;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 170536 + 8;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[gb + 1459900 >> 2] = (HEAP32[gb + 1459900 >> 2] | 0) + 1;
 STACKTOP = i4;
 return;
}

function __ZN8JSONRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlagsb(i10, i11, i2, i12, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i10 + 36 | 0;
 HEAP8[i9 >> 0] = 0;
 if (!((i12 & 524288 | 0) == 0 | (HEAP32[i10 >> 2] & 2 | 0) == 0)) return;
 i7 = i10 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i2 | 0) {
  if (!i8) return;
  if ((HEAP32[i8 + 16 >> 2] | 0) != 3) return;
 }
 i1 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i10, i8, i2) | 0;
 HEAP32[i7 >> 2] = i1;
 i5 = i10 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i11 + 4 >> 2] | 0;
 if (!i2) i2 = gb + 1034517 | 0; else {
  i3 = HEAP32[i11 + 8 >> 2] | 0;
  HEAP8[i2 >> 0] = 80;
  HEAP8[i2 + 1 >> 0] = 80;
  HEAP8[i2 + 2 >> 0] = 116;
  HEAP8[i2 + 3 >> 0] = 114;
  HEAP8[i2 + 4 >> 0] = 60;
  i1 = i2 + 6 | 0;
  HEAP8[i2 + 5 >> 0] = 36;
  i3 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  if (i4 << 24 >> 24) do {
   HEAP8[i1 >> 0] = i4;
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while (i4 << 24 >> 24 != 0);
  HEAP8[i1 >> 0] = 62;
  HEAP8[i1 + 1 >> 0] = 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i2;
 if (i1 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i10, i12);
  __ZN4PPtrI6ObjectE8TransferI8JSONReadEEvRT_(i11, i10);
  HEAP8[i9 >> 0] = 1;
  i12 = i10 + 56 | 0;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
 }
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx5Elems17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE(i12, i11, i10) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i7 = i12 + 36 | 0;
 i9 = i12 + 44 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) == 1073741823) {
  i5 = i12 + 40 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3 << 1;
  i4 = i4 >>> 0 < 64 ? 64 : i4;
  i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i13 + 1 | 0, i4 << 3, gb + 717789 | 0, 1491) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   _memcpy(i8 | 0, i1 | 0, i3 << 3 | 0) | 0;
   _memset(i8 + (i3 << 3) | 0, 0, i4 - i3 << 3 | 0) | 0;
  }
  i2 = i4 + -1 | 0;
  HEAP32[i8 + (i2 << 3) >> 2] = HEAP32[i9 >> 2];
  if (i3 >>> 0 < i2 >>> 0) {
   i1 = i3;
   do {
    i3 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i8 + (i3 << 3) >> 2] = i1;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i9 >> 2] = HEAP32[i5 >> 2];
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i7 >> 2] | 0);
  HEAP32[i7 >> 2] = i8;
  HEAP32[i5 >> 2] = i4;
  i3 = i8;
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = i8;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = i1;
 }
 HEAP32[i9 >> 2] = HEAP32[i3 + (i2 << 3) >> 2];
 HEAP32[i3 + (i2 << 3) >> 2] = 0;
 HEAP32[i3 + (i2 << 3) + 4 >> 2] = 0;
 i8 = i10;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i1 + (i2 << 3) | 0;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP32[(HEAP32[i12 + 24 >> 2] | 0) + (i11 << 2) >> 2] = i2;
 STACKTOP = i13;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim9startStepEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = i7 + 52 | 0;
 i5 = __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv(HEAP32[i9 >> 2] | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = i6 + 8 | 0;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 if (!(HEAP16[(HEAP32[i9 >> 2] | 0) + 8 >> 1] & 2)) {
  f10 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f14 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = __ZNK5physx2Sc8ActorSim8getSceneEv(i7) | 0;
  f15 = Math_fround(HEAPF32[i1 + 48 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 52 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  HEAPF32[i6 >> 2] = Math_fround(f15 + f14);
  HEAPF32[i2 >> 2] = Math_fround(f13 + f12);
  HEAPF32[i4 >> 2] = Math_fround(f11 + f10);
  i1 = i7;
 } else i1 = i7;
 i9 = i7 + 56 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i6 | 0);
 i9 = HEAP32[i9 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i9 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vif(i7 | 0, i9 | 0, +Math_fround(HEAPF32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0) + 64 >> 2]));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 << 3;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 3) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i6 << 3) | 0;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 i3 = i9 + 4 | 0;
 i4 = i7 + 4 | 0;
 i5 = i7 + 8 | 0;
 do {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 >> 2] = i1 + 4;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i6;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i9, i7, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z27AssetBundle_CUSTOM_ContainsP12Il2CppObjectP12Il2CppString(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 __ZNK11ICallString6ToUTF8Ev(i6, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 i2 = i5 + 11 | 0;
 i8 = HEAP8[i2 >> 0] | 0;
 i1 = i8 << 24 >> 24 < 0;
 i3 = i5 + 4 | 0;
 if ((i1 ? HEAP32[i3 >> 2] | 0 : i8 & 255) | 0) {
  i1 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
  do {
   i9 = HEAP8[i1 >> 0] | 0;
   i8 = i9 << 24 >> 24;
   HEAP8[i1 >> 0] = (i9 + -65 & 255) < 26 ? i8 + 32 | 0 : i8;
   i1 = i1 + 1 | 0;
   i8 = HEAP8[i2 >> 0] | 0;
   i9 = i8 << 24 >> 24 < 0;
  } while ((i1 | 0) != ((i9 ? HEAP32[i5 >> 2] | 0 : i5) + (i9 ? HEAP32[i3 >> 2] | 0 : i8 & 255) | 0));
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i4) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i9 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 } else {
  __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i1, i5);
  i9 = (HEAP32[i6 >> 2] | 0) != (HEAP32[i6 + 4 >> 2] | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i9 | 0;
 }
 return 0;
}

function __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __Z20GetPlatformCachePathv(i4);
 i7 = HEAP8[i2 + 11 >> 0] | 0;
 if (!(((i7 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255) | 0) != 0 | i3)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 }
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i4, i2);
 do if (i3) {
  if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5);
   break;
  }
  if (!(HEAP8[gb + 1546590 >> 0] | 0)) HEAP8[gb + 1546590 >> 0] = 1;
  if (__Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5) | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5); else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
  }
 } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5); while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 92 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 96 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 100 >> 2])) return;
  }
 } else i1 = i9 + 96 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 100 >> 2] = i6;
 HEAP32[i9 + 536 >> 2] = 0;
 return;
}

function __ZN5physx9NpPhysics26unregisterDeletionListenerERNS_18PxDeletionListenerE(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 4 | 0;
 i5 = i10;
 i8 = i9 + 64 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i9 + 88 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = i6;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i9 + 80 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i9 + 72 >> 2] | 0;
   i3 = i9 + 76 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i2 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    HEAP32[i5 >> 2] = i6;
    __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE5eraseERS6_(i9 + 68 | 0, i5) | 0;
    if (i2 | 0) {
     i1 = HEAP32[i2 >> 2] | 0;
     if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
     __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i2);
    }
   }
  }
 } while (0);
 HEAP8[i9 + 112 >> 0] = (HEAP32[i9 + 104 >> 2] | 0) != 0 & 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 * 12 | 0;
  i2 = i7 + 60 | 0;
  if (i1 >>> 0 < 61 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 832684 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 68 >> 2] | 0;
 i4 = i1 + (i3 * 12 | 0) | 0;
 i5 = i7 + 64 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 12 | 0;
  }
 }
 i2 = i7 + 72 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 60 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx2Sc10StaticCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 132260 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 132260 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 132260 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 132260 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 132260 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 132260 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 132260 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 132260 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 751991;
 HEAP32[i4 + 4 >> 2] = gb + 751711;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 48;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 132292 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 132292 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 132292 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 132292 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 132292 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 132292 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 132292 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 132292 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefIhEE(i1, i14) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 i13 = i11 - i12 | 0;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i13;
 HEAP8[i10 + 1 >> 0] = i13 >> 8;
 HEAP8[i10 + 2 >> 0] = i13 >> 16;
 HEAP8[i10 + 3 >> 0] = i13 >> 24;
 if ((i11 | 0) == (i12 | 0)) return;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i14 >> 2] | 0, i13);
 return;
}

function __Z44Quaternion_CUSTOM_INTERNAL_CALL_LookRotationRK8Vector3fS1_R11Quaternionf(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 48 | 0;
 i9 = i11 + 12 | 0;
 i10 = i11;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 do if (!(__Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i2, i1, i8) | 0)) {
  f5 = Math_fround(HEAPF32[i2 >> 2]);
  f4 = Math_fround(f5 * f5);
  f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(f4 + Math_fround(f6 * f6));
  f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f4 = Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f3 * f3))));
  if (f4 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
   HEAPF32[i10 >> 2] = Math_fround(f5 / f4);
   HEAPF32[i10 + 4 >> 2] = Math_fround(f6 / f4);
   HEAPF32[i10 + 8 >> 2] = Math_fround(f3 / f4);
   __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i9, gb + 62548 | 0, i10) | 0;
   __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i9, i8);
   break;
  } else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 544288 | 0, 0, gb + 544325 | 0, 92, 4, 0, 0, 0);
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 STACKTOP = i11;
 return;
}

function __Z36EdgeCollider2D_Get_Custom_PropPointsP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i3 = HEAP32[i1 + 160 >> 2] | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i4 = HEAP32[i1 + 172 >> 2] | 0;
 i5 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i4 = (i3 | 0) == 0 ? 0 : i4;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(i5, 8, i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 8) | 0;
 if ((i4 | 0) > 0) {
  i2 = i3;
  i3 = 0;
 } else return i5 | 0;
 while (1) {
  i7 = i2;
  i9 = i7;
  i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8 | HEAPU8[i9 + 2 >> 0] << 16 | HEAPU8[i9 + 3 >> 0] << 24;
  i7 = i7 + 4 | 0;
  i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8 | HEAPU8[i7 + 2 >> 0] << 16 | HEAPU8[i7 + 3 >> 0] << 24;
  i6 = i1;
  i8 = i6;
  HEAP8[i8 >> 0] = i9;
  HEAP8[i8 + 1 >> 0] = i9 >> 8;
  HEAP8[i8 + 2 >> 0] = i9 >> 16;
  HEAP8[i8 + 3 >> 0] = i9 >> 24;
  i6 = i6 + 4 | 0;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i4 | 0)) break; else {
   i1 = i1 + 8 | 0;
   i2 = i2 + 8 | 0;
  }
 }
 return i5 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 108 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 112 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 116 >> 2])) return;
  }
 } else i1 = i9 + 112 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 116 >> 2] = i6;
 HEAP32[i9 + 540 >> 2] = 0;
 return;
}

function __ZN5Umbra9Matrix4x311flushToZeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2]))) <= 1.0e-15) HEAPF32[i2 >> 2] = Math_fround(0.0);
 i1 = i2 + 4 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 8 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 12 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 16 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 20 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 24 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 28 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 32 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 36 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 40 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 44 | 0;
 if (!(+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15)) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN21WorldParticleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 48 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 i1 = i5 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN16MessageForwarder23RegisterMessageCallbackEiPFvPviR11MessageDataEPKN5Unity4TypeE(i8, i9, i10, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12;
 i5 = i8 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i1 - i2 >> 2;
 if ((i4 | 0) > (i9 | 0)) {
  i7 = i2;
  i7 = i7 + (i9 << 2) | 0;
  HEAP32[i7 >> 2] = i10;
  i10 = i8 + 12 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 + (i9 << 2) | 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i12;
  return;
 }
 i6 = i9 + 1 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i1;
 if (i6 >>> 0 > i4 >>> 0) __ZNSt3__26vectorIPFvPviR11MessageDataENS_9allocatorIS5_EEE8__appendEjRKS5_(i8, i6 - i4 | 0, i7); else if (i6 >>> 0 < i4 >>> 0) {
  i1 = i2 + (i6 << 2) | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = i8 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i5 - i3 >> 2;
 if (i6 >>> 0 > i2 >>> 0) __ZNSt3__26vectorIPKN5Unity4TypeENS_9allocatorIS4_EEE8__appendEjRKS4_(i1, i6 - i2 | 0, i7); else if (i6 >>> 0 < i2 >>> 0) {
  i1 = i3 + (i6 << 2) | 0;
  if ((i5 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i1 | 0) >>> 2) << 2);
 }
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + (i9 << 2) | 0;
 HEAP32[i7 >> 2] = i10;
 i10 = i8 + 12 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 + (i9 << 2) | 0;
 HEAP32[i10 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 36 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE8__appendEj(i1, i2 - i4 | 0);
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) return;
 i9 = i3 + (i2 * 36 | 0) | 0;
 if ((i5 | 0) == (i9 | 0)) return;
 do {
  HEAP32[i10 >> 2] = i5 + -36;
  i7 = i5 + -16 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (i1 | 0) {
   i8 = i5 + -12 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i3 = i2 + -20 | 0;
     HEAP32[i8 >> 2] = i3;
     i4 = HEAP32[i2 + -12 >> 2] | 0;
     i6 = i4;
     if (!i4) i2 = i3; else {
      i2 = i2 + -8 | 0;
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i6 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i4);
      i2 = HEAP32[i8 >> 2] | 0;
     }
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i7 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i4 = i5 + -28 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i3 = i5 + -24 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i8 = i2 + -96 | 0;
     HEAP32[i3 >> 2] = i8;
     __ZN19ComputeShaderKernelD2Ev(i8);
     i2 = HEAP32[i3 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i5 = HEAP32[i10 >> 2] | 0;
 } while ((i5 | 0) != (i9 | 0));
 return;
}

function __ZN5physx12NpConstraint7releaseEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((((HEAP32[i7 + 20 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 < 2) {
  i1 = HEAP32[i7 + 16 >> 2] | 0;
  if (!i1) i6 = 0; else i6 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 } else i6 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i7, 0, 1);
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 if (i1 | 0) __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i1 + (HEAP32[gb + 1457020 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, i1, 0, i7, gb + 688433 | 0);
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (i1 | 0) __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i1 + (HEAP32[gb + 1457020 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0, i1, 0, i7, gb + 688494 | 0);
 if (!i6) {
  i7 = i7 + 16 | 0;
  __ZN5physx3Scb4Base7destroyEv(i7);
  return;
 }
 i3 = i6 + 3540 | 0;
 i4 = i6 + 3544 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L14 : do if (!i5) i1 = 0; else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i7 | 0)) break L14;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i2;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
 }
 __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i6 + 16 | 0, i7 + 16 | 0);
 i7 = i7 + 16 | 0;
 __ZN5physx3Scb4Base7destroyEv(i7);
 return;
}

function __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 8 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 9 >> 0] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 1);
  i1 = HEAP8[i3 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i3 >> 0] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP8[i6 + 10 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 12 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i6 + 28 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_(i1, i10, i8) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 16 | 0;
 i11 = i15 + 4 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i14 = i1 + 4 | 0;
 i3 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i7 - i3 >> 3;
 if (!i1) i2 = i3; else {
  i6 = HEAP32[i8 >> 2] | 0;
  i2 = i3;
  while (1) {
   i16 = (i1 | 0) / 2 | 0;
   i5 = i3 + (i16 << 3) | 0;
   i4 = (HEAP32[i5 >> 2] | 0) < (i6 | 0);
   i5 = i5 + 8 | 0;
   i2 = i4 ? i5 : i2;
   i1 = i4 ? i1 + -1 - i16 | 0 : i16;
   if (!i1) break; else i3 = i4 ? i5 : i3;
  }
 }
 i3 = i2;
 if ((i2 | 0) == (i7 | 0)) i1 = HEAP32[i8 >> 2] | 0; else {
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) >= (HEAP32[i2 >> 2] | 0)) {
   HEAP32[i10 >> 2] = i2 + 4;
   STACKTOP = i15;
   return;
  }
 }
 HEAP32[i11 >> 2] = i3;
 HEAP32[i13 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i13);
 HEAP32[i12 >> 2] = i1;
 i16 = i12 + 4 | 0;
 HEAP32[i16 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i16, i13);
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 >> 2] = (__ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_(i14, i9, i12) | 0) + 4;
 __ZN14ConstantStringD2Ev(i16);
 __ZN14ConstantStringD2Ev(i13);
 STACKTOP = i15;
 return;
}

function __ZN13PhysicsModule17SetRigidBodyStateER9RigidbodyRKN8IPhysics14RigidBodyStateE(i1, i4, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 __ZN9Rigidbody11SetPositionERK8Vector3f(i4, i6);
 __ZN9Rigidbody11SetRotationERK11Quaternionf(i4, i6 + 12 | 0);
 HEAP32[i7 >> 2] = HEAP32[i6 + 28 >> 2];
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 + 32 >> 2];
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 + 36 >> 2];
 i5 = i4 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 & 2 | 0) HEAPF32[i7 >> 2] = Math_fround(0.0);
 if (i2 & 4 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
 if (i2 & 8 | 0) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i2 = i4 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0, i7 | 0, 1);
 HEAP32[i7 >> 2] = HEAP32[i6 + 40 >> 2];
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 + 44 >> 2];
 i4 = i7 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 + 48 >> 2];
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 & 16 | 0) HEAPF32[i7 >> 2] = Math_fround(0.0);
 if (i1 & 32 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
 if (!(i1 & 64)) {
  i6 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 164 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_viii(i5 | 0, i6 | 0, i7 | 0, 1);
  STACKTOP = i8;
  return;
 }
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + 164 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(i5 | 0, i6 | 0, i7 | 0, 1);
 STACKTOP = i8;
 return;
}

function __ZN10Matrix3x3f10IsIdentityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + Math_fround(-1.0));
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if ((i5 ? f4 : f3) <= f2) {
  f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f3 = Math_fround(-f4);
  if ((i5 ? f3 : f4) <= f2) {
   f4 = Math_fround(HEAPF32[i1 + 24 >> 2]);
   i5 = f4 < Math_fround(0.0);
   f3 = Math_fround(-f4);
   if ((i5 ? f3 : f4) <= f2) {
    f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
    i5 = f4 < Math_fround(0.0);
    f3 = Math_fround(-f4);
    if ((i5 ? f3 : f4) <= f2) {
     f4 = Math_fround(Math_fround(HEAPF32[i1 + 16 >> 2]) + Math_fround(-1.0));
     i5 = f4 < Math_fround(0.0);
     f3 = Math_fround(-f4);
     if ((i5 ? f3 : f4) <= f2) {
      f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
      i5 = f4 < Math_fround(0.0);
      f3 = Math_fround(-f4);
      if ((i5 ? f3 : f4) <= f2) {
       f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
       i5 = f4 < Math_fround(0.0);
       f3 = Math_fround(-f4);
       if ((i5 ? f3 : f4) <= f2) {
        f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
        i5 = f4 < Math_fround(0.0);
        f3 = Math_fround(-f4);
        if ((i5 ? f3 : f4) <= f2) {
         f4 = Math_fround(Math_fround(HEAPF32[i1 + 32 >> 2]) + Math_fround(-1.0));
         i5 = f4 < Math_fround(0.0);
         f3 = Math_fround(-f4);
         if ((i5 ? f3 : f4) <= f2) {
          i5 = 1;
          return i5 | 0;
         }
        }
       }
      }
     }
    }
   }
  }
 }
 i5 = 0;
 return i5 | 0;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i5 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i7 = i5 << 1;
 i3 = i5 >>> 0 < 178956970 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 357913941;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 12 | 0) | 0;
 i2 = i4 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 i5 = i2;
 i7 = i4 + (i3 * 12 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i6);
 i6 = i2 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i1);
   i2 = i3 + -12 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNKSt3__214collate_bynameIwE10do_compareEPKwS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i6 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i8, i2, i3);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1047 | 0, i6 | 0, i4 | 0, i5 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  i1 = invoke_iiii(fb + 510 | 0, ((HEAP8[i8 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0, ((HEAP8[i6 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
   break;
  } else {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
   STACKTOP = i7;
   return ((i1 | 0) < 0 ? -1 : (i1 | 0) != 0 & 1) | 0;
  }
 } while (0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i8);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN9Animation17SampleDefaultClipEd(i6, d7) {
 i6 = i6 | 0;
 d7 = +d7;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i6 + 280 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i9 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i9 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i9 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i8;
   return;
  }
 }
 f10 = Math_fround(d7);
 i9 = HEAP32[i1 + 96 >> 2] | 0;
 __Z15SampleAnimationR10GameObjectR13AnimationClipfi(HEAP32[i6 + 28 >> 2] | 0, i1, f10, (i9 | 0) == 0 ? HEAP32[i6 + 36 >> 2] | 0 : i9);
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 685890 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i7 = i1 + 16 | 0;
   i8 = i2 + 16 | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 96 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 100 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 104 >> 2])) return;
  }
 } else i1 = i9 + 100 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 104 >> 2] = i6;
 HEAP32[i9 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(i2, i3, i4, i5, i8, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i12 = i9 + 6 | 0;
 i11 = i9 + 5 | 0;
 i10 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 73;
 HEAP8[i12 >> 0] = 67;
 HEAP8[i11 >> 0] = 69;
 HEAP8[i10 >> 0] = i6 & 1 ^ 1;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i12 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i11 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i10 | 0, 1) | 0;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i12 >> 0] = i3;
 HEAP8[i11 >> 0] = i4;
 HEAP8[i10 >> 0] = i5;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i12 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i11 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i10 | 0, 1) | 0;
 HEAP32[i1 >> 2] = i8;
 if (!i6) {
  i12 = HEAP32[i7 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_iiii(i12 | 0, i7 | 0, i1 | 0, 4) | 0;
  STACKTOP = i9;
  return 1;
 }
 HEAP8[i1 >> 0] = i8 >>> 24;
 HEAP8[i1 + 3 >> 0] = i8;
 HEAP8[i1 + 1 >> 0] = i8 >>> 16;
 HEAP8[i1 + 2 >> 0] = i8 >>> 8;
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_iiii(i12 | 0, i7 | 0, i1 | 0, 4) | 0;
 STACKTOP = i9;
 return 1;
}

function __ZN11AudioSource28SetSpatializePostEffectsGainEf(i1, f4) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7;
 i5 = i7 + 36 | 0;
 i2 = i7 + 32 | 0;
 i1 = HEAP32[i1 + 540 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(i1, 0, 0, i2) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
  HEAP32[i3 >> 2] = gb + 855390;
  HEAP32[i3 + 4 >> 2] = 1160;
  HEAP32[i3 + 8 >> 2] = gb + 865849;
  HEAP32[i3 + 12 >> 2] = i1;
  __Z6FormatPKcz(i5, gb + 883334 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZN4FMOD13DSPConnection6setMixEf(i1 | 0, +f4) | 0;
  if (i1 | 0) {
   i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
   HEAP32[i6 >> 2] = gb + 855390;
   HEAP32[i6 + 4 >> 2] = 1162;
   HEAP32[i6 + 8 >> 2] = gb + 865895;
   HEAP32[i6 + 12 >> 2] = i3;
   __Z6FormatPKcz(i5, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  }
 }
 STACKTOP = i7;
 return;
}

function __Z17dynamic_pptr_castIP18AnimatorController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 178256 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 178256 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _free_pool(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 if (i4 >>> 0 > 1) {
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 14;
  HEAP32[i3 + 24 >> 2] = i4;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i6 | 0);
 } else if ((i4 | 0) == 1) {
  i3 = i5 + 68 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) do {
   i2 = i1 + 34 | 0;
   if (HEAP8[i2 >> 0] | 0) {
    HEAP8[i2 >> 0] = 0;
    mftCall_vii(HEAP32[i1 + 48 >> 2] | 0, i6 | 0, i1 + 40 | 0);
   }
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  } while ((i1 | 0) != 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i5 + 72 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) do {
   i2 = i1 + 34 | 0;
   if (HEAP8[i2 >> 0] | 0) {
    HEAP8[i2 >> 0] = 0;
    mftCall_vii(HEAP32[i1 + 48 >> 2] | 0, i6 | 0, i1 + 40 | 0);
   }
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  } while ((i1 | 0) != 0);
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i5 + 60 + (i4 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 if (i1 | 0) {
  i2 = i5 + 76 | 0;
  do {
   i7 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = (HEAP32[i7 + 4 >> 2] | 0) + 12 + (HEAP32[i7 + 8 >> 2] | 0) | 0;
   _jpeg_free_large(i6, i7, i3);
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i3;
  } while ((i1 | 0) != 0);
 }
 i7 = i5 + 52 + (i4 << 2) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 if (!i1) return;
 i2 = i5 + 76 | 0;
 do {
  i5 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i7 = (HEAP32[i5 + 4 >> 2] | 0) + 12 + (HEAP32[i5 + 8 >> 2] | 0) | 0;
  _jpeg_free_small(i6, i5, i7);
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i7;
 } while ((i1 | 0) != 0);
 return;
}

function __ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = HEAP32[HEAP32[i5 >> 2] >> 2];
 if ((i2 | 0) == (i1 | 0) | (i1 | 0) == (gb + 13360 | 0)) i1 = 1; else if (!i1) i1 = 0; else {
  i3 = ___dynamic_cast(i1, gb + 13008 | 0, gb + 13304 | 0, 0) | 0;
  if (!i3) i1 = 0; else if (!(HEAP32[i3 + 8 >> 2] & ~HEAP32[i2 + 8 >> 2])) {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   i2 = i3 + 12 | 0;
   if ((i1 | 0) == (gb + 13336 | 0) ? 1 : (i1 | 0) == (HEAP32[i2 >> 2] | 0)) i1 = 1; else if (!i1) i1 = 0; else {
    i4 = ___dynamic_cast(i1, gb + 13008 | 0, gb + 12992 | 0, 0) | 0;
    if (!i4) i1 = 0; else {
     i1 = HEAP32[i2 >> 2] | 0;
     if (!i1) i1 = 0; else {
      i1 = ___dynamic_cast(i1, gb + 13008 | 0, gb + 12992 | 0, 0) | 0;
      if (!i1) i1 = 0; else {
       i2 = i6 + 4 | 0;
       i3 = i2 + 52 | 0;
       do {
        HEAP32[i2 >> 2] = 0;
        i2 = i2 + 4 | 0;
       } while ((i2 | 0) < (i3 | 0));
       HEAP32[i6 >> 2] = i1;
       HEAP32[i6 + 8 >> 2] = i4;
       HEAP32[i6 + 12 >> 2] = -1;
       HEAP32[i6 + 48 >> 2] = 1;
       mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i6 | 0, HEAP32[i5 >> 2] | 0, 1);
       if ((HEAP32[i6 + 24 >> 2] | 0) == 1) {
        HEAP32[i5 >> 2] = HEAP32[i6 + 16 >> 2];
        i1 = 1;
       } else i1 = 0;
      }
     }
    }
   }
  } else i1 = 0;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN7mecanim12statemachine21SelectorStateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i2 = i7 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i8 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i7 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx3Scb5Shape17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 125668 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125668 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125668 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125668 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125668 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125668 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125668 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125668 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 747923;
 HEAP32[i4 + 4 >> 2] = gb + 747700;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 160;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125700 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125700 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125700 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125700 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125700 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125700 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125700 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125700 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Scb5Cloth17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 125092 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 125092 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 125092 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 125092 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 125092 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 125092 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 125092 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 125092 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 747667;
 HEAP32[i4 + 4 >> 2] = gb + 747531;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 104;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 125124 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 125124 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 125124 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 125124 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 125124 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 125124 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 125124 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 125124 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 5 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 5) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i10 = i3 + (i1 << 5) | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl16getOrCreateClassERKN5physx8debugger14NamespacedNameE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i1 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i3, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i1) {
  i5 = i3 + 240 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 + 1;
  i1 = __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi(i3, i2, i1) | 0;
 }
 HEAP32[i4 >> 2] = gb + 148960 + 8;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i5 = i4 + 28 | 0;
 i6 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 i5 = i4 + 48 | 0;
 i3 = i1 + 48 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i4 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 i5 = i4 + 68 | 0;
 i4 = i1 + 68 | 0;
 i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8;
 HEAP8[i5 >> 0] = i4;
 HEAP8[i5 + 1 >> 0] = i4 >> 8;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 80 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 84 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 88 >> 2])) return;
  }
 } else i1 = i9 + 84 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 88 >> 2] = i6;
 HEAP32[i9 + 536 >> 2] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN22RenderingCommandBuffer23AddSetGlobalVectorArrayERKN9ShaderLab16FastPropertyNameEPK8Vector4fi(i10, i1, i11, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 24 | 0;
 i3 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i3 + 4 | 0;
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i2);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 i5 = i10 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + i3 >> 2] = 17;
 i3 = i3 + 7 & -4;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i2;
 HEAP32[i9 >> 2] = i4;
 i1 = i1 + i3 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i1 + (i12 << 4) | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i1, i2);
 HEAP32[i9 >> 2] = i2;
 i2 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
 if ((i12 | 0) > 0) i1 = 0; else {
  i12 = i10 + 36 | 0;
  HEAP8[i12 >> 0] = 1;
  return;
 }
 do {
  HEAP32[i2 + (i1 << 4) >> 2] = HEAP32[i11 + (i1 << 4) >> 2];
  HEAP32[i2 + (i1 << 4) + 4 >> 2] = HEAP32[i11 + (i1 << 4) + 4 >> 2];
  HEAP32[i2 + (i1 << 4) + 8 >> 2] = HEAP32[i11 + (i1 << 4) + 8 >> 2];
  HEAP32[i2 + (i1 << 4) + 12 >> 2] = HEAP32[i11 + (i1 << 4) + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 i12 = i10 + 36 | 0;
 HEAP8[i12 >> 0] = 1;
 return;
}

function __ZN19SpriteMeshGenerator5traceE8Vector2fS0_RS0_(i7, i1, i2, i15) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f3 - f5);
 f4 = Math_fround(f4 - f6);
 if (f3 > Math_fround(0.0)) i1 = 7; else i1 = (((f3 < Math_fround(0.0)) << 31 >> 31) * 3 | 0) + 4 | 0;
 i14 = f4 > Math_fround(0.0);
 i13 = (f4 < Math_fround(0.0)) << 31 >> 31;
 i13 = i1 - (i14 ? 1 : i13) | 0;
 i14 = HEAP32[gb + 38036 + (i13 << 2) >> 2] | 0;
 L4 : do if ((i13 | 0) != 4) {
  i13 = ~~f5;
  i10 = ~~f6;
  i11 = i7 + 40 | 0;
  i12 = i7 + 44 | 0;
  i2 = i7 + 56 | 0;
  i1 = 0;
  while (1) {
   i8 = (i1 + i14 | 0) % 8 | 0;
   i7 = i13 + (HEAP32[gb + 38072 + (i8 << 3) >> 2] | 0) | 0;
   i8 = i10 + (HEAP32[gb + 38072 + (i8 << 3) + 4 >> 2] | 0) | 0;
   if ((i7 | 0) >= 0) {
    i9 = HEAP32[i11 >> 2] | 0;
    if (!((i8 | 0) < 0 | (i9 | 0) <= (i7 | 0))) if ((HEAP32[i12 >> 2] | 0) > (i8 | 0)) {
     i9 = (Math_imul(i9, i8) | 0) + i7 | 0;
     if (HEAP32[(HEAP32[i2 >> 2] | 0) + (i9 >>> 5 << 2) >> 2] & 1 << (i9 & 31) | 0) break;
    }
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= 8) break L4;
  }
  f6 = Math_fround(i8 | 0);
  HEAPF32[i15 >> 2] = Math_fround(i7 | 0);
  HEAPF32[i15 + 4 >> 2] = f6;
  i15 = 1;
  return i15 | 0;
 } while (0);
 HEAP32[i15 >> 2] = -1082130432;
 HEAP32[i15 + 4 >> 2] = -1082130432;
 i15 = 0;
 return i15 | 0;
}

function __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 5;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 5;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIP16BaseVideoTexture13stl_allocatorIS2_L18MemLabelIdentifier19ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 19;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 19;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN9Texture2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 8 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = i1 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i7 + 8 | 0);
  i2 = i1 + 28 | 0;
  i7 = i7 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i2 = HEAP32[i3 >> 2] | 0;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i7 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i7);
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Ext15CpuWorkerThreadC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = gb + 86828 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd10ThreadImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i1 = mftCall_iiiiii(i6 | 0, i5 | 0, i1 | 0, (i2 ? gb + 775304 | 0 : gb + 837976 | 0) | 0, gb + 775428 | 0, 236) | 0;
 }
 HEAP32[i3 + 4 >> 2] = i1;
 __ZN5physx6shdfnd10ThreadImplC2Ev(i1);
 HEAP32[i3 >> 2] = gb + 86808 + 8;
 __ZN5physx3Ext20SharedQueueEntryPoolINS_6shdfnd19ReflectionAllocatorINS0_16SharedQueueEntryEEEEC2EjRKS5_(i3 + 8 | 0, 128, i4);
 i1 = i3 + 20 | 0;
 i2 = HEAP32[(__ZN5physx6shdfnd9SListImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i2) {
  i6 = 0;
  HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9SListImplC2Ev(i6);
  i6 = i3 + 24 | 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i7 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i7 | 0, i5 | 0, i2 | 0, (i6 ? gb + 741043 | 0 : gb + 837976 | 0) | 0, gb + 741165 | 0, 86) | 0;
 HEAP32[i1 >> 2] = i6;
 __ZN5physx6shdfnd9SListImplC2Ev(i6);
 i6 = i3 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE(i2, i3, i4, i5, i8, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i12 = i9 + 6 | 0;
 i11 = i9 + 5 | 0;
 i10 = i9 + 4 | 0;
 HEAP8[i1 >> 0] = 78;
 HEAP8[i12 >> 0] = 88;
 HEAP8[i11 >> 0] = 83;
 HEAP8[i10 >> 0] = i6 & 1 ^ 1;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i12 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i11 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i10 | 0, 1) | 0;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i12 >> 0] = i3;
 HEAP8[i11 >> 0] = i4;
 HEAP8[i10 >> 0] = i5;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i12 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i11 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i10 | 0, 1) | 0;
 HEAP32[i1 >> 2] = i8;
 if (!i6) {
  i12 = HEAP32[i7 >> 2] | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  mftCall_iiii(i12 | 0, i7 | 0, i1 | 0, 4) | 0;
  STACKTOP = i9;
  return 1;
 }
 HEAP8[i1 >> 0] = i8 >>> 24;
 HEAP8[i1 + 3 >> 0] = i8;
 HEAP8[i1 + 1 >> 0] = i8 >>> 16;
 HEAP8[i1 + 2 >> 0] = i8 >>> 8;
 i12 = HEAP32[i7 >> 2] | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 mftCall_iiii(i12 | 0, i7 | 0, i1 | 0, 4) | 0;
 STACKTOP = i9;
 return 1;
}

function __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 switch (HEAP32[i5 + 16 >> 2] | 0) {
 case 2:
  {
   i3 = 0;
   do {
    i2 = __ZN15TerrainRenderer23FindNeighborAndRendererER12QuadTreeNodeiRPS_(i4, i5, i3, i7) | 0;
    if (i2 | 0) if (!(HEAP32[i2 + 16 >> 2] | 0)) {
     i6 = HEAP32[i7 >> 2] | 0;
     i1 = HEAP32[i2 + 32 >> 2] | 0;
     if ((i1 | 0) != (HEAP32[(HEAP32[i6 + 20 >> 2] | 0) + -32 >> 2] | 0)) {
      i1 = __ZN15TerrainRenderer7GetNodeEiii(i6, (HEAP32[i2 + 24 >> 2] | 0) / 2 | 0, (HEAP32[i2 + 28 >> 2] | 0) / 2 | 0, i1 + 1 | 0) | 0;
      if (!(HEAP32[i1 + 16 >> 2] | 0)) __ZN15TerrainRenderer16ForceSplitParentER12QuadTreeNode(i6, i1);
     }
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) != 4);
   STACKTOP = i8;
   return;
  }
 case 0:
  {
   STACKTOP = i8;
   return;
  }
 default:
  {
   __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i5, 0) | 0);
   __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i5, 1) | 0);
   __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i5, 2) | 0);
   __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i4, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i5, 3) | 0);
   STACKTOP = i8;
   return;
  }
 }
}

function __ZNSt3__26vectorI17MessageIdentifierNS_9allocatorIS1_EEE8__appendEj(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (((i2 - i4 | 0) / 20 | 0) >>> 0 >= i9 >>> 0) {
  i1 = i9;
  i2 = i3;
  while (1) {
   HEAP32[i2 + 8 >> 2] = -1;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 1;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 20 | 0;
  }
  HEAP32[i10 >> 2] = i3 + (i9 * 20 | 0);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = ((i4 - i1 | 0) / 20 | 0) + i9 | 0;
 if (i3 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i6 = (i2 - i1 | 0) / 20 | 0;
 i2 = i6 << 1;
 i2 = i6 >>> 0 < 107374182 ? (i2 >>> 0 < i3 >>> 0 ? i3 : i2) : 214748364;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 * 20 | 0) | 0;
 i6 = i3 + (((i4 - i1 | 0) / 20 | 0) * 20 | 0) | 0;
 i5 = i3 + (i2 * 20 | 0) | 0;
 i2 = i9;
 i3 = i6;
 while (1) {
  HEAP32[i3 + 8 >> 2] = -1;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 1;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 20 | 0;
 }
 i2 = i4 - i1 | 0;
 i3 = i6 + (((i2 | 0) / -20 | 0) * 20 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i6 + (i9 * 20 | 0);
 HEAP32[i8 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7PxJoint17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 64 | 0;
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i5 >> 2] = HEAP32[gb + 116144 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 116144 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 116144 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 116144 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[gb + 116144 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[gb + 116144 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[gb + 116144 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[gb + 116144 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 32) | 0;
 HEAP32[i4 >> 2] = gb + 743901;
 HEAP32[i4 + 4 >> 2] = gb + 827530;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 12;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 1;
 HEAP32[i4 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 122852 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 122852 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 122852 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 122852 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 122852 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 122852 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 122852 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 122852 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 24 | 0;
 i6 = i9 + 16 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxQuatEE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 i3 = HEAP32[i8 + 12 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx18NpArticulationLink17resolveReferencesERNS_24PxDeserializationContextE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 288 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i2 | 0) | 0;
 i1 = i6 + 292 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i2 | 0) | 0;
 i1 = i6 + 296 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i2 | 0) | 0;
 i1 = i6 + 20 | 0;
 i2 = HEAP16[i6 + 24 >> 1] | 0;
 if (i2 << 16 >> 16 == 1) i3 = 10; else if (i2 << 16 >> 16) {
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = 10;
 }
 if ((i3 | 0) == 10) {
  i4 = i2 & 65535;
  i5 = 0;
  do {
   i3 = i1 + (i5 << 2) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    i2 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i2 | 0) | 0;
    HEAP32[i3 >> 2] = i2;
   }
   __ZN5physx6shdfnd15atomicIncrementEPVi(i2 + 16 | 0) | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i4 | 0));
 }
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i6 + 12 | 0, i7);
 i5 = HEAP32[i6 + 324 >> 2] | 0;
 if (!i5) return;
 i1 = i6 + 320 | 0;
 i4 = 0;
 do {
  i2 = (HEAP32[i1 >> 2] | 0) + (i4 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) HEAP32[i2 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i3 | 0) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i5 | 0));
 return;
}

function __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE8EndWriteEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i8 + 56 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i8 = i8 + 28 | 0;
  __ZN14DataBufferGLES16FlushMappedRangeEii(HEAP32[i8 >> 2] | 0, 0, i7);
  __ZN14DataBufferGLES5UnmapEv(HEAP32[i8 >> 2] | 0);
  HEAP8[i1 >> 0] = 0;
  return;
 }
 i6 = i8 + 60 | 0;
 i3 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i5 = 9; else {
  if ((HEAP32[i1 + 8 >> 2] | 0) >>> 0 >= i3 >>> 0) {
   i2 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i1) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i2) {
    if (!i1) {
     i5 = 9;
     break;
    }
    i2 = i8 + 32 | 0;
    break;
   }
  }
  __ZN14DataBufferGLES7ReleaseEv(i1);
  HEAP32[i4 >> 2] = 0;
  i5 = 9;
 } while (0);
 if ((i5 | 0) == 9) {
  i1 = __Z20GetBufferManagerGLESv() | 0;
  i2 = i8 + 32 | 0;
  i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i1, i3, HEAP32[i2 >> 2] | 0, 0) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 if ((HEAP32[i2 >> 2] | 0) == 3) {
  __ZN14DataBufferGLES13EnsureStorageEi(i1, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i2 = i8 + 36 | 0;
 __ZN14DataBufferGLES6UploadEiiPKv(i1, HEAP32[i6 >> 2] | 0, i7, HEAP32[i2 >> 2] | 0);
 if (HEAP32[i8 + 16 >> 2] | 0) return;
 i1 = i8 + 52 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i8 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12BaseRenderer23RendererCullingCallbackEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = i4;
 i8 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 if (!i8) i2 = gb + 1162292 | 0; else {
  i2 = i8 + 36 | 0;
  i3 = i8 + 1076 | 0;
  if (HEAP8[i3 >> 0] | 0) if (HEAP8[i8 + 1080 >> 0] | 0) {
   HEAPF32[i1 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(-1.0);
   __ZN10Matrix4x4f8SetScaleERK8Vector3f(i2, i1) | 0;
   __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i8 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   __ZN10Matrix4x4fmLERKS_(i2, i1) | 0;
   HEAP8[i3 >> 0] = 0;
  }
 }
 i3 = i4 + 236 | 0;
 i3 = (HEAPU16[i3 >> 1] | HEAPU8[i3 + 2 >> 0] << 16) & 63;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = i4 + 27792 + (i3 * 772 | 0) + 768 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i6 = i4 + 27792 + (i3 * 772 | 0) + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i4 + 27792 + (i3 * 772 | 0) + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiii(HEAP32[i6 >> 2] | 0, i7 | 0, 1, i8 | 0, i2 | 0); else mftCall_viiiii(HEAP32[i6 >> 2] | 0, HEAP32[i4 + 27792 + (i3 * 772 | 0) + (i1 * 12 | 0) + 4 >> 2] | 0, i7 | 0, 1, i8 | 0, i2 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __Z26PlayerLoadSettingsAndInputRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = i10 + 8 | 0;
 i2 = 0;
 while (1) {
  i7 = HEAP32[gb + 32312 + (i2 << 2) >> 2] | 0;
  i1 = i7 + 1 | 0;
  HEAP32[i5 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i3, i1, ((i1 | 0) < 0) << 31 >> 31) | 0;
  i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i5) | 0;
  if (!i1) {
   i9 = 5;
   break;
  }
  i4 = i1 + 8 | 0;
  if ((((HEAP32[i4 >> 2] | 0) >>> 21) - (HEAP32[gb + 28304 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28304 + 28 >> 2] | 0) >>> 0) {
   i9 = 5;
   break;
  }
  HEAP32[gb + 1104348 + (i7 << 2) >> 2] = i1;
  i1 = HEAP32[gb + 1104348 + 112 + (i7 << 2) >> 2] | 0;
  i2 = i2 + 1 | 0;
  if ((((HEAP32[i4 >> 2] | 0) >>> 21) - (HEAP32[i1 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[i1 + 28 >> 2] | 0) >>> 0) break;
  if (i2 >>> 0 >= 6) {
   i9 = 8;
   break;
  }
 }
 if ((i9 | 0) == 5) {
  HEAP32[gb + 1104348 + (i7 << 2) >> 2] = 0;
  i1 = HEAP32[gb + 1104348 + 112 + (i7 << 2) >> 2] | 0;
 } else if ((i9 | 0) == 8) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  STACKTOP = i10;
  return;
 }
 HEAP32[i8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __Z6FormatPKcz(i6, gb + 370151 | 0, i8);
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 25;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 do if (i3 | 0) {
  i9 = HEAP8[i2 + 11 >> 0] | 0;
  i8 = i9 << 24 >> 24 < 0;
  i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
  i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
  i1 = i10;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    i4 = i2 + 16 | 0;
    i6 = HEAP8[i4 + 11 >> 0] | 0;
    i5 = i6 << 24 >> 24 < 0;
    i6 = i5 ? HEAP32[i2 + 20 >> 2] | 0 : i6 & 255;
    i3 = i9 >>> 0 < i6 >>> 0 ? i9 : i6;
    if (!i3) i7 = 6; else {
     i3 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i3) | 0;
     if (!i3) i7 = 6; else if ((i3 | 0) >= 0) break;
    }
    if ((i7 | 0) == 6) {
     i7 = 0;
     if (i6 >>> 0 >= i9 >>> 0) break;
    }
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i10 | 0)) {
   i3 = i1 + 16 | 0;
   i5 = HEAP8[i3 + 11 >> 0] | 0;
   i4 = i5 << 24 >> 24 < 0;
   i5 = i4 ? HEAP32[i1 + 20 >> 2] | 0 : i5 & 255;
   i2 = i5 >>> 0 < i9 >>> 0 ? i5 : i9;
   if (i2 | 0) {
    i2 = _memcmp(i8, i4 ? HEAP32[i3 >> 2] | 0 : i3, i2) | 0;
    if (i2 | 0) {
     if ((i2 | 0) < 0) break;
     return i1 | 0;
    }
   }
   if (i9 >>> 0 >= i5 >>> 0) {
    i10 = i1;
    return i10 | 0;
   }
  }
 } while (0);
 return i10 | 0;
}

function __ZN9UnityGUID4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(HEAP8[gb + 1546621 >> 0] | 0)) {
  HEAP8[gb + 1546621 >> 0] = 1;
  _srand(_time(0) | 0);
 }
 i3 = (_rand() | 0) >>> 7;
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] ^ i3;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 1 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 2 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 3 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 4 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 5 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 6 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 7 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 8 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 9 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 10 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 11 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 12 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 13 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i2 = (_rand() | 0) >>> 7;
 i3 = i1 + 14 | 0;
 HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] ^ i2;
 i3 = (_rand() | 0) >>> 7;
 i2 = i1 + 15 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] ^ i3;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -193 | 128;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i7 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471202 | 0, i7, i1 + 16 | 0, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899057 | 0, i7, i1 + 20 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471276 | 0, i7, i1 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 28 | 0;
 HEAP8[i4 >> 0] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471291 | 0, HEAP32[gb + 37252 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP8[i4 >> 0];
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 + 4;
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i5;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 i5 = i6 + 8 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i6 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i5;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, i2 + i4 | 0, i1 << 2);
 }
 i9 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 + 16;
 HEAP32[i8 + 4 >> 2] = i6 + 12;
 HEAP32[i8 + 8 >> 2] = i9;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags(i7, i8, 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx14NpArticulation12createObjectERPhRNS_24PxDeserializationContextE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP16[i5 + 6 >> 1] = 2;
 HEAP32[i5 >> 2] = gb + 91248 + 8;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 i6 = i5 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 251658240;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP8[i5 + 64 >> 0] = 1;
 i6 = i5 + 88 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i4 = i5 + 96 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | -2147483648;
 }
 if (!(HEAP8[i5 + 84 >> 0] | 0)) {
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 108;
  if (HEAP32[i6 >> 2] | 0) {
   i1 = HEAP32[i5 + 96 >> 2] | 0;
   if (i1 & 2147483647 | HEAP32[i5 + 92 >> 2] | 0) {
    i3 = i7 + 4 | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i4 + (i1 << 2);
    HEAP32[i6 >> 2] = i4;
   }
  }
 } else {
  HEAP32[i6 >> 2] = i5 + 68;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 108;
 }
 i1 = i7 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = i3 + 4 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i5 + 104 >> 2] = (i4 | 0) == 0 ? 0 : i3;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
 i1 = HEAP32[i5 + 92 >> 2] | 0;
 if (!i1) {
  i7 = i5 + 100 | 0;
  HEAP32[i7 >> 2] = 0;
  return i5 | 0;
 }
 i4 = 0;
 do {
  i2 = (HEAP32[i6 >> 2] | 0) + (i4 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) HEAP32[i2 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i3 | 0) | 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i1 | 0));
 i7 = i5 + 100 | 0;
 HEAP32[i7 >> 2] = 0;
 return i5 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1 * 12 | 0);
 STACKTOP = i8;
 return;
}

function __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i7, i4, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 673 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = i8;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i5 = (HEAP32[i7 + 168 >> 2] | 0) == 0;
 i3 = HEAP32[i7 + 128 >> 2] | 0;
 if ((i3 | 0) > 0) if (i5) {
  i2 = 0;
  i1 = 0;
  do {
   if (HEAP8[i4 + i2 >> 0] | 0) {
    HEAP32[i8 + (i1 << 2) >> 2] = 6144;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } else {
  i2 = 0;
  i1 = 0;
  do {
   if (HEAP8[i4 + i2 >> 0] | 0) {
    HEAP32[i8 + (i1 << 2) >> 2] = i2 + 36064;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 } else i1 = 0;
 if (i5 & i6) {
  i2 = HEAP32[i7 + 124 >> 2] | 0;
  if (i2) if (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[i7 + 336 >> 2] | 0) + 860 >> 2] | 0, HEAP32[i2 + 40 >> 2] | 0) | 0) + 12 >> 2] & 8) {
   i3 = 6145;
   i2 = 6146;
   i9 = 14;
  }
 } else if (i6) {
  i3 = i5 ? 6145 : 36096;
  i2 = i5 ? 6146 : 36128;
  i9 = 14;
 }
 if ((i9 | 0) == 14) {
  HEAP32[i8 + (i1 << 2) >> 2] = i3;
  HEAP32[i8 + (i1 + 1 << 2) >> 2] = i2;
  i1 = i1 + 2 | 0;
 }
 if ((i1 | 0) > 0) mftCall_viii(HEAP32[(HEAP32[i7 + 336 >> 2] | 0) + 236 >> 2] | 0, 36160, i1 | 0, i8 | 0);
 STACKTOP = i10;
 return;
}

function __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E14find_or_insertIS2_S4_EEvRPT0_RKT_(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 16 | 0;
 i11 = i15 + 4 | 0;
 i12 = i15 + 8 | 0;
 i13 = i15;
 i14 = i1 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = i7 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i6 = HEAP32[i10 >> 2] | 0;
  i5 = i1;
  i1 = i2;
  while (1) {
   i16 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i16 << 3) | 0;
   i3 = (_strcmp(HEAP32[i4 >> 2] | 0, i6) | 0) < 0;
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i16 | 0 : i16;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i7 | 0)) if ((_strcmp(HEAP32[i10 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) >= 0) {
  HEAP32[i9 >> 2] = i1 + 4;
  STACKTOP = i15;
  return;
 }
 HEAP32[i11 >> 2] = i2;
 HEAP32[i13 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i13, i10);
 HEAP32[i12 >> 2] = 0;
 __ZN14ConstantString6assignERKS_(i12, i13);
 HEAP32[i12 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 >> 2] = (__ZNSt3__26vectorINS_4pairI14ConstantStringP11AssetBundleEENS_9allocatorIS5_EEE6insertENS_11__wrap_iterIPKS5_EERSA_(i14, i8, i12) | 0) + 4;
 __ZN14ConstantStringD2Ev(i12);
 __ZN14ConstantStringD2Ev(i13);
 STACKTOP = i15;
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer8PvdPointEEE(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = (HEAP32[i13 + 4 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
 i12 = i11 >> 4;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i12;
 HEAP8[i10 + 1 >> 0] = i12 >> 8;
 HEAP8[i10 + 2 >> 0] = i12 >> 16;
 HEAP8[i10 + 3 >> 0] = i12 >> 24;
 if (!i12) return;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i13 >> 2] | 0, i11);
 return;
}

function __ZNKSt3__214collate_bynameIcE10do_compareEPKcS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i6 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i8, i2, i3);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __THREW__ = 0;
 invoke_viii(fb + 1045 | 0, i6 | 0, i4 | 0, i5 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  i1 = invoke_iiii(fb + 509 | 0, ((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8) | 0, ((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   STACKTOP = i7;
   return ((i1 | 0) < 0 ? -1 : (i1 | 0) != 0 & 1) | 0;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i1 | 0);
 return 0;
}

function __ZN6prcoreL29inner_stretch_rgb888_bilinearEPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i6 = (HEAP32[i3 + 24 >> 2] | 0) >>> 8;
 i7 = 256 - i6 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = i3 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i12 = i1 >>> 8 & 255;
  i3 = 256 - i12 | 0;
  i14 = (i1 >>> 16) * 3 | 0;
  i11 = i8 + i14 | 0;
  i15 = i14 + 3 | 0;
  i13 = i8 + i15 | 0;
  i14 = i9 + i14 | 0;
  i15 = i9 + i15 | 0;
  i10 = ((Math_imul((Math_imul(HEAPU8[i15 + 1 >> 0] | 0, i12) | 0) + (Math_imul(HEAPU8[i14 + 1 >> 0] | 0, i3) | 0) << 8 & 16711680, i6) | 0) + (Math_imul((Math_imul(HEAPU8[i13 + 1 >> 0] | 0, i12) | 0) + (Math_imul(HEAPU8[i11 + 1 >> 0] | 0, i3) | 0) << 8 & 16711680, i7) | 0) | 0) >>> 24;
  i3 = (Math_imul(((Math_imul((HEAPU8[i15 + 2 >> 0] | 0) << 16 | (HEAPU8[i15 >> 0] | 0), i12) | 0) + (Math_imul((HEAPU8[i14 + 2 >> 0] | 0) << 16 | (HEAPU8[i14 >> 0] | 0), i3) | 0) | 0) >>> 8 & 16711935, i6) | 0) + (Math_imul(((Math_imul((HEAPU8[i13 + 2 >> 0] | 0) << 16 | (HEAPU8[i13 >> 0] | 0), i12) | 0) + (Math_imul((HEAPU8[i11 + 2 >> 0] | 0) << 16 | (HEAPU8[i11 >> 0] | 0), i3) | 0) | 0) >>> 8 & 16711935, i7) | 0) | 0;
  HEAP8[i4 >> 0] = i3 >>> 8;
  HEAP8[i4 + 1 >> 0] = i10;
  HEAP8[i4 + 2 >> 0] = i3 >>> 24;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
  }
 }
 return;
}

function __ZN17ProceduralTexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(232, i1, 16, gb + 1048932 | 0, 0, gb + 434255 | 0, 213) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 >> 2] = gb + 59360 + 8;
 i1 = i4 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 62;
 i1 = i4 + 140 | 0;
 i2 = i4 + 104 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 62;
 HEAP32[i4 + 144 >> 2] = 0;
 i8 = i4 + 152 | 0;
 HEAP32[i4 + 176 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i4 + 180 >> 0] = 1;
 HEAP8[i4 + 181 >> 0] = 0;
 HEAP32[i4 + 184 >> 2] = 0;
 i8 = i4 + 192 | 0;
 HEAP32[i4 + 216 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i8 + 20 >> 0] = 0;
 HEAP8[i4 + 224 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE8EndWriteEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i8 + 56 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i8 = i8 + 28 | 0;
  __ZN14DataBufferGLES16FlushMappedRangeEii(HEAP32[i8 >> 2] | 0, 0, i7);
  __ZN14DataBufferGLES5UnmapEv(HEAP32[i8 >> 2] | 0);
  HEAP8[i1 >> 0] = 0;
  return;
 }
 i6 = i8 + 60 | 0;
 i3 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
 i4 = i8 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) i5 = 9; else {
  if ((HEAP32[i1 + 8 >> 2] | 0) >>> 0 >= i3 >>> 0) {
   i2 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i1) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i2) {
    if (!i1) {
     i5 = 9;
     break;
    }
    i2 = i8 + 32 | 0;
    break;
   }
  }
  __ZN14DataBufferGLES7ReleaseEv(i1);
  HEAP32[i4 >> 2] = 0;
  i5 = 9;
 } while (0);
 if ((i5 | 0) == 9) {
  i1 = __Z20GetBufferManagerGLESv() | 0;
  i2 = i8 + 32 | 0;
  i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i1, i3, HEAP32[i2 >> 2] | 0, 0) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 if ((HEAP32[i2 >> 2] | 0) == 3) {
  __ZN14DataBufferGLES13EnsureStorageEi(i1, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i2 = i8 + 36 | 0;
 __ZN14DataBufferGLES6UploadEiiPKv(i1, HEAP32[i6 >> 2] | 0, i7, HEAP32[i2 >> 2] | 0);
 if (HEAP32[i8 + 16 >> 2] | 0) return;
 i1 = i8 + 52 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i8 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager10addHandlerERN5physx8debugger4comm20PvdConnectionHandlerE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i5 = i4 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 HEAP32[i1 >> 2] = i6;
 i2 = i4 + 164 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 168 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 160 >> 2] | 0) + (i3 << 2) >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEE15growAndPushBackERKS5_(i4 + 148 | 0, i1) | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
  i6 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 if (!i1) {
  i6 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i6 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer7PvdLineEEE(i1, i13) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = (HEAP32[i13 + 4 >> 2] | 0) - (HEAP32[i13 >> 2] | 0) | 0;
 i12 = i11 >> 5;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i12;
 HEAP8[i10 + 1 >> 0] = i12 >> 8;
 HEAP8[i10 + 2 >> 0] = i12 >> 16;
 HEAP8[i10 + 3 >> 0] = i12 >> 24;
 if (!i12) return;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i13 >> 2] | 0, i11);
 return;
}

function __Z24GetAABBVerticesForSpriteRK4AABBP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i1 + 12 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 i8 = i1 + 16 | 0;
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 i7 = i1 + 4 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 i6 = i1 + 8 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 HEAPF32[i2 >> 2] = f3;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f4);
 f3 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 HEAPF32[i2 + 12 >> 2] = f5;
 HEAPF32[i2 + 16 >> 2] = f4;
 HEAPF32[i2 + 20 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f3);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 HEAPF32[i2 + 24 >> 2] = f3;
 HEAPF32[i2 + 28 >> 2] = f4;
 HEAPF32[i2 + 32 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 f3 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + Math_fround(0.0));
 HEAPF32[i2 + 36 >> 2] = f5;
 HEAPF32[i2 + 40 >> 2] = f4;
 HEAPF32[i2 + 44 >> 2] = f3;
 return;
}

function __ZNSt3__214__split_bufferIPPN9ShaderLab21SerializedShaderStateENS_9allocatorIS4_EEE10push_frontERKS4_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i9 + 4 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i12;
 do if ((i11 | 0) == (i12 | 0)) {
  i12 = i9 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = i8;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2;
   i5 = ((i1 - i3 >> 2) + 1 | 0) / 2 | 0;
   i1 = i2 + (i5 << 2) | 0;
   i3 = i3 - i11 | 0;
   i10 = i3 >> 2;
   i4 = i1 + (0 - i10 << 2) | 0;
   if (i10) {
    _memmove(i4 | 0, i11 | 0, i3 | 0) | 0;
    i1 = i4;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i12 >> 2] = i2 + (i5 << 2);
   break;
  }
  i8 = i1 - i3 >> 1;
  i8 = (i8 | 0) == 0 ? 1 : i8;
  i5 = __Znwj(i8 << 2) | 0;
  i6 = i5;
  i1 = i5 + ((i8 + 3 | 0) >>> 2 << 2) | 0;
  i7 = i1;
  i8 = i5 + (i8 << 2) | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i3 = i7;
   i2 = i11;
  } else {
   i5 = i1;
   i3 = i7;
   i4 = i11;
   do {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i3 + 4 | 0;
    i3 = i5;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i6;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i8;
  if (i2) {
   __ZdlPv(i2);
   i1 = HEAP32[i14 >> 2] | 0;
  }
 } else i1 = i11; while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 f2 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i1 + 8 >> 2]));
 if (f2 != Math_fround(0.0)) {
  f2 = Math_fround(Math_fround(+Math_log(+f2)) / Math_fround(.693147182));
  i8 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 } else i8 = -1023410176;
 if (f3 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(+Math_log(+f3)) / Math_fround(.693147182));
  i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 } else i7 = -1023410176;
 if (f4 != Math_fround(0.0)) {
  f4 = Math_fround(Math_fround(+Math_log(+f4)) / Math_fround(.693147182));
  i6 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 } else i6 = -1023410176;
 i5 = i9 + 84 | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f4 == Math_fround(HEAPF32[i5 >> 2])) {
  f4 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i9 + 88 | 0;
  if (f4 == Math_fround(HEAPF32[i1 >> 2])) {
   f4 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 == Math_fround(HEAPF32[i9 + 92 >> 2])) return;
  }
 } else i1 = i9 + 88 | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i9 + 92 >> 2] = i6;
 HEAP32[i9 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sq10AABBPrunerC2Eb(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = gb + 101792 + 8;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 1;
 HEAP32[i4 + 12 >> 2] = 2147483647;
 i1 = i4 + 56 | 0;
 i2 = i4 + 80 | 0;
 i5 = i4 + 16 | 0;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAPF32[i2 >> 2] = Math_fround(.75);
 HEAP32[i4 + 84 >> 2] = -1;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj(i1, 64);
 HEAP32[i4 + 96 >> 2] = i1;
 i5 = i4 + 100 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAPF32[i4 + 124 >> 2] = Math_fround(.75);
 HEAP32[i4 + 128 >> 2] = -1;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj(i5, 64);
 HEAP32[i4 + 140 >> 2] = i5;
 __ZN5physx2Sq16BucketPrunerCoreC2Eb(i4 + 144 | 0, 0);
 HEAP32[i4 + 7744 >> 2] = 0;
 HEAP32[i4 + 7748 >> 2] = 100;
 HEAP32[i4 + 7756 >> 2] = 0;
 __ZN5physx2Sq11PruningPoolC2Ev(i4 + 7760 | 0);
 HEAP32[i4 + 7796 >> 2] = 0;
 HEAP32[i4 + 7800 >> 2] = 0;
 HEAP32[i4 + 7804 >> 2] = 0;
 HEAP8[i4 + 7808 >> 0] = i3 & 1;
 i5 = i4 + 7809 | 0;
 i6 = i5 + 15 | 0;
 do {
  HEAP8[i5 >> 0] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0));
 return;
}

function __ZN15QualitySettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 44 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i7 + 24 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i3 = i6 + 28 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i8 >> 2] = i1;
  i1 = i4;
 }
 __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j(i3, i1);
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i3;
  STACKTOP = i10;
  return;
 }
}

function __ZN12NativeBufferI16Converter_StringE15SetupForWritingER9ArrayInfo(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i3 - i1 >> 4;
 if (i10 >>> 0 > i2 >>> 0) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj(i8, i10 - i2 | 0); else if (i10 >>> 0 < i2 >>> 0) {
  i4 = i1 + (i10 << 4) | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i5 = i6 + 4 | 0;
   i2 = i3;
   while (1) {
    i1 = i2 + -16 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i6 >> 2] = 1;
     HEAP32[i5 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 i2 = i8 + 16 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[(__ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(HEAP32[i9 >> 2] | 0, i1) | 0) >> 2] | 0;
  __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i2, i7, (HEAP32[i8 >> 2] | 0) + (i1 << 4) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine9Animation14GenericBinding8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
 __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i5);
 i1 = i6 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 2);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 14 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 15 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  return;
 }
}

function __ZN11DetailPatchC2ERKS_(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP8[i8 + 24 >> 0] = HEAP8[i7 + 24 >> 0] | 0;
 i1 = i8 + 28 | 0;
 i2 = i7 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i8 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 36 >> 2] = 0;
 i4 = i7 + 32 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 if (i3 | 0) {
  if ((i3 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
  i6 = __Znwj(i3) | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 + 36 >> 2] = i6 + i3;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = i6 + i1;
  }
 }
 i2 = i8 + 40 | 0;
 i3 = i7 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i8 + 44 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i8 + 48 >> 2] = 0;
 i4 = i7 + 44 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 if (!i1) return;
 if ((i1 | 0) < 0) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
 i5 = __Znwj(i1) | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i8 + 48 >> 2] = i5 + i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) return;
 _memcpy(i5 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i6 >> 2] = i5 + i1;
 return;
}

function __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo(i7, HEAP32[i2 + 24 >> 2] | 0);
 __ZN9JSONWrite8TransferINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i4, i7, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -88 | 0;
   HEAP32[i5 >> 2] = i3;
   i4 = i2 + -32 | 0;
   if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -28 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function _UNITY_png_check_fp_number(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i2 >>> 0 < i5 >>> 0) while (1) {
  switch (HEAP8[i4 + i2 >> 0] | 0) {
  case 43:
   {
    i3 = 4;
    break;
   }
  case 45:
   {
    i3 = 132;
    break;
   }
  case 46:
   {
    i3 = 16;
    break;
   }
  case 48:
   {
    i3 = 8;
    break;
   }
  case 57:
  case 56:
  case 55:
  case 54:
  case 53:
  case 52:
  case 51:
  case 50:
  case 49:
   {
    i3 = 264;
    break;
   }
  case 101:
  case 69:
   {
    i3 = 32;
    break;
   }
  default:
   break L1;
  }
  L11 : do switch ((i3 | i1 & 3) & 63) {
  case 4:
   {
    if (i1 & 60 | 0) break L1;
    i1 = i3 | i1;
    break;
   }
  case 16:
   {
    if (i1 & 16 | 0) break L1;
    if (!(i1 & 8)) {
     i1 = i1 & 448 | i3 | 1;
     break L11;
    } else {
     i1 = i3 | i1;
     break L11;
    }
   }
  case 8:
   {
    i1 = ((i1 & 16 | 0) == 0 ? i1 : i1 & 384 | 17) | i3 | 64;
    break;
   }
  case 32:
   {
    if (!(i1 & 8)) break L1;
    i1 = i1 & 448 | 2;
    break;
   }
  case 9:
   {
    i1 = i1 | i3 | 64;
    break;
   }
  case 33:
   {
    if (!(i1 & 8)) break L1;
    i1 = i1 & 448 | 2;
    break;
   }
  case 6:
   {
    if (i1 & 60 | 0) break L1;
    i1 = i1 | 4;
    break;
   }
  case 10:
   {
    i1 = i1 | 72;
    break;
   }
  default:
   break L1;
  } while (0);
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i5 >>> 0) break L1;
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 return i1 >>> 3 & 1 | 0;
}

function _UNITY_FT_Vector_Length(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) {
  i7 = (i3 | 0) < 0 ? 0 - i3 | 0 : i3;
  return i7 | 0;
 }
 i1 = (i2 | 0) < 0 ? 0 - i2 | 0 : i2;
 if (!i3) {
  i7 = i1;
  return i7 | 0;
 }
 i1 = _FT_MSB(((i3 | 0) < 0 ? 0 - i3 | 0 : i3) | i1) | 0;
 if ((i1 | 0) < 30) {
  i1 = 29 - i1 | 0;
  i7 = i1;
  i4 = i2 << i1;
  i1 = i3 << i1;
 } else {
  i6 = i1 + -29 | 0;
  i7 = 29 - i1 | 0;
  i4 = i2 >> i6;
  i1 = i3 >> i6;
 }
 i3 = 0 - i4 | 0;
 if ((i1 | 0) > (i4 | 0)) {
  i4 = (i1 | 0) > (i3 | 0);
  i5 = 1;
  i6 = 1;
  i2 = i4 ? i3 : 0 - i1 | 0;
  i1 = i4 ? i1 : i3;
 } else {
  i3 = (i1 | 0) < (i3 | 0);
  i5 = 1;
  i6 = 1;
  i2 = i3 ? i4 : i1;
  i1 = i3 ? 0 - i1 | 0 : i4;
 }
 while (1) {
  i3 = i2 + i5 >> i6;
  if ((i2 | 0) > 0) {
   i2 = i2 - (i1 + i5 >> i6) | 0;
   i1 = i3 + i1 | 0;
  } else {
   i2 = (i1 + i5 >> i6) + i2 | 0;
   i1 = i1 - i3 | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else i5 = i5 << 1;
 }
 i6 = (i1 | 0) < 0;
 i2 = i6 ? 0 - i1 | 0 : i1;
 i1 = i2 & 65535;
 i2 = i2 >>> 16;
 i4 = i2 * 23318 | 0;
 i3 = (i1 * 56281 | 0) + i4 | 0;
 i5 = i3 << 16;
 i1 = i5 + (i1 * 23318 | 0) | 0;
 i1 = (i3 >>> 16) + (i2 * 56281 | 0) + ((i3 >>> 0 < i4 >>> 0 & 1) << 16) + (i1 >>> 0 < i5 >>> 0 & 1) + (i1 >>> 0 > 3221225471 & 1) | 0;
 i1 = i6 ? 0 - i1 | 0 : i1;
 if ((i7 | 0) > 0) {
  i7 = i1 + (1 << i7 + -1) >> i7;
  return i7 | 0;
 } else {
  i7 = i1 << 0 - i7;
  return i7 | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertIPKwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPwEEE4typeENSB_IS8_EESA_SA_(i1, i3, i4, i11) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = i1 + 8 | 0;
 i9 = i5 + 3 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i6 = i2 << 24 >> 24 < 0;
 if (i6) {
  i3 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
  i5 = (HEAP32[i5 >> 2] & 2147483647) + -1 | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = (HEAP32[i3 >> 2] | 0) - i1 | 0;
  i5 = 1;
  i8 = i2 & 255;
 }
 i10 = i3 >> 2;
 i7 = i11 - i4 >> 2;
 L5 : do if (i7) {
  if ((i5 - i8 | 0) >>> 0 < i7 >>> 0) {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i5, i8 + i7 - i5 | 0, i8, i10, 0, i7);
   i5 = HEAP32[i1 >> 2] | 0;
  } else {
   if (i6) i5 = HEAP32[i1 >> 2] | 0; else i5 = i1;
   i2 = i8 - i10 | 0;
   i3 = i5 + (i10 << 2) | 0;
   if (i2) __ZNSt3__211char_traitsIwE4moveEPwPKwj(i3 + (i7 << 2) | 0, i3, i2) | 0;
  }
  i3 = i8 + i7 | 0;
  i2 = HEAP8[i9 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) HEAP32[i1 + 4 >> 2] = i3; else {
   i2 = i3 & 255;
   HEAP8[i9 >> 0] = i2;
  }
  HEAP32[i5 + (i3 << 2) >> 2] = 0;
  i3 = i5 + (i10 << 2) | 0;
  while (1) {
   if ((i4 | 0) == (i11 | 0)) break L5;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i4 = i4 + 4 | 0;
   i3 = i3 + 4 | 0;
  }
 } while (0);
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i10 << 2) | 0;
}

function __ZN12TreeDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 40 | 0;
 i4 = i3;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932439 | 0, i6, i1 + 16 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 937620 | 0, i4, 0);
 __ZN12TreeInstance8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932455 | 0, i6, i1 + 4 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 937633 | 0, i4, 0);
 __ZN13TreePrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN12PPtrKeyframe8TransferI14SafeBinaryReadEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i6, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) {
   i3 = i7 + 16 | 0;
   i2 = HEAP32[i7 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i7 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i7 + 36 >> 2] | 0, 0 - (HEAP32[i7 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
   if (HEAP32[i7 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i7 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i7);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1034365 | 0, HEAP32[gb + 37176 >> 2] | 0, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i7); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN10Matrix4x4f8TransferI9JSONWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1034440 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 1034444 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 1034448 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 1034452 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 1034456 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 1034460 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 1034464 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 1034468 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 1034472 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 1034476 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 1034480 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1034484 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 12 | 0, gb + 1034488 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1034492 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 1034496 | 0, 0);
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 1034500 | 0, 0);
 return;
}

function __ZNSt3__26vectorIP10MemoryPool13stl_allocatorIS2_L18MemLabelIdentifier72ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 72;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 72;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26stoullERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1084469 | 0, 6);
 HEAP32[i7 >> 2] = 0;
 i3 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 518 | 0, i3 | 0, i7 | 0, i2 | 0) | 0;
 i2 = getTempRet0() | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 do if (!(i10 & 1)) {
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  if ((i10 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i8 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i8 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = (HEAP32[i7 >> 2] | 0) - i3 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  setTempRet0(i2 | 0);
  STACKTOP = i9;
  return i1 | 0;
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i10 | 0);
 return 0;
}

function __ZNK12CullingGroup12QueryIndicesEbiNS_12QueryOptionsEPjjj(i4, i5, i7, i6, i10, i2, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0;
 i9 = (i10 | 0) != 0;
 i3 = i4 + 24 | 0;
 if (i9) {
  i1 = i1 + i2 | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  i8 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
 } else i8 = HEAP32[i3 >> 2] | 0;
 if (i8 >>> 0 <= i2 >>> 0) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = i4 + 28 | 0;
 i5 = i5 & 1;
 i3 = (i6 & 2 | 0) == 0;
 if (i6 & 1 | 0) {
  if (!i3) {
   i1 = i8 - i2 | 0;
   if (i9) i3 = 0; else {
    i10 = i1;
    return i10 | 0;
   }
   while (1) {
    HEAP32[i10 + (i3 << 2) >> 2] = i2;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 1 | 0;
   }
   return i1 | 0;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  do {
   if (((HEAPU8[i3 + i2 >> 0] | 0) & 127 | 0) == (i7 | 0)) {
    if (i9) HEAP32[i10 + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
  return i1 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 if (i3) i1 = 0; else {
  i1 = 0;
  do {
   if (((HEAPU8[i4 + i2 >> 0] | 0) >>> 7 & 255 | 0) == (i5 | 0)) {
    if (i9) HEAP32[i10 + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
  return i1 | 0;
 }
 do {
  i3 = HEAP8[i4 + i2 >> 0] | 0;
  if (((i3 & 255) >>> 7 & 255 | 0) == (i5 | 0)) if ((i3 & 127 | 0) == (i7 | 0)) {
   if (i9) HEAP32[i10 + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 return i1 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5Cache32GetCachingDiskSpaceFreeAndUsableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i7 = i5 + 8 | 0;
 i6 = i5 + 20 | 0;
 i8 = i1 + 32 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = (i8 | 0) > (i3 | 0) | (i8 | 0) == (i3 | 0) & i9 >>> 0 > i4 >>> 0;
 i3 = _i64Subtract(i9 | 0, i8 | 0, i4 | 0, i3 | 0) | 0;
 i4 = getTempRet0() | 0;
 i3 = i1 ? i3 : 0;
 i4 = i1 ? i4 : 0;
 i1 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = __Z13GetFileSystemv() | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
 __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i7, i6, 1);
 i1 = __ZNK10FileSystem21GetAvailableDiskSpaceEPKcRy(i1, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (i1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
   i8 = i2;
   i9 = i1;
   setTempRet0(i8 | 0);
   STACKTOP = i5;
   return i9 | 0;
  }
 }
 i8 = i4;
 i9 = i3;
 setTempRet0(i8 | 0);
 STACKTOP = i5;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i9 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i4 = i1 + (i3 * 52 | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i9);
  __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 20 | 0, i9);
  __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 36 | 0, i9);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 * 24 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1 * 24 | 0);
 STACKTOP = i8;
 return;
}

function __Z54ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsP12Il2CppObjectS0_S0_(i4, i6, i2) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = i2 + 8 | 0;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i7 >> 2] | 0) | 0;
 if (!i4) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZNK14ParticleSystem25GetSafeCollisionEventSizeEv(i1) | 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = i1;
 if (i3 >>> 0 < i1 >>> 0) {
  i3 = HEAP32[(__Z33GetParticleSystemScriptingClassesv() | 0) + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i3, 40, HEAP32[i5 >> 2] | 0) | 0;
 }
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 if (!i6) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i7 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i7 >> 2] | 0, 0, 40) | 0;
  return __ZNK14ParticleSystem26GetCollisionEventsExternalEiP26MonoParticleCollisionEventi(i2, i6, i7, HEAP32[i5 >> 2] | 0) | 0;
 }
 return 0;
}

function __Z25computePacketSizeMultLog2ff(f3, f2) {
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = (~~Math_fround(Math_ceil(Math_fround(f3 / f2))) >>> 0) + -1 | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = (i1 >>> 16 | i1) + 1 | 0;
 i1 = i1 >>> 0 > 4 ? i1 : 4;
 do if (i1 >>> 0 < 2) i1 = 0; else if (i1 >>> 0 < 8) i1 = 2; else if (i1 >>> 0 < 16) i1 = 3; else if (i1 >>> 0 < 32) i1 = 4; else if (i1 >>> 0 < 64) i1 = 5; else if (i1 >>> 0 < 128) i1 = 6; else if (i1 >>> 0 < 256) i1 = 7; else if (i1 >>> 0 < 512) i1 = 8; else if (i1 >>> 0 < 1024) i1 = 9; else if (i1 >>> 0 < 2048) i1 = 10; else if (i1 >>> 0 < 4096) i1 = 11; else if (i1 >>> 0 < 8192) i1 = 12; else if (i1 >>> 0 < 16384) i1 = 13; else if (i1 >>> 0 < 32768) i1 = 14; else if (i1 >>> 0 < 65536) i1 = 15; else if (i1 >>> 0 < 131072) i1 = 16; else if (i1 >>> 0 < 262144) i1 = 17; else if (i1 >>> 0 < 524288) i1 = 18; else if (i1 >>> 0 < 1048576) i1 = 19; else {
  if (i1 >>> 0 < 2097152) {
   i1 = 20;
   break;
  }
  if (i1 >>> 0 < 4194304) {
   i1 = 21;
   break;
  }
  if (i1 >>> 0 < 8388608) {
   i1 = 22;
   break;
  }
  if (i1 >>> 0 < 16777216) {
   i1 = 23;
   break;
  }
  if (i1 >>> 0 < 33554432) {
   i1 = 24;
   break;
  }
  if (i1 >>> 0 < 67108864) {
   i1 = 25;
   break;
  }
  if (i1 >>> 0 < 134217728) {
   i1 = 26;
   break;
  }
  if (i1 >>> 0 < 268435456) {
   i1 = 27;
   break;
  }
  if (i1 >>> 0 < 536870912) {
   i1 = 28;
   break;
  }
  if (i1 >>> 0 < 1073741824) {
   i1 = 29;
   break;
  }
  i1 = i1 >>> 31 | 30;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__25stollERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1084463 | 0, 5);
 HEAP32[i7 >> 2] = 0;
 i3 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 517 | 0, i3 | 0, i7 | 0, i2 | 0) | 0;
 i2 = getTempRet0() | 0;
 i10 = __THREW__;
 __THREW__ = 0;
 do if (!(i10 & 1)) {
  i10 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  if ((i10 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i8 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i8 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = (HEAP32[i7 >> 2] | 0) - i3 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  setTempRet0(i2 | 0);
  STACKTOP = i9;
  return i1 | 0;
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i10 | 0);
 return 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERPKc(i2, i12) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = HEAP32[i12 >> 2] | 0;
 i1 = i1 | 0 ? i1 : gb + 1576256 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i11 = 0; else i11 = (_strlen(i1) | 0) + 1 | 0;
 i9 = i2 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i11;
 HEAP8[i10 + 1 >> 0] = i11 >> 8;
 HEAP8[i10 + 2 >> 0] = i11 >> 16;
 HEAP8[i10 + 3 >> 0] = i11 >> 24;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i12 >> 2] | 0, i11);
 return;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i5 + 24 | 0;
 i9 = i5 + 12 | 0;
 i6 = i5;
 i12 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i10 = HEAP32[i3 + 8 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 20 >> 2] = Math_fround(1.0);
 i4 = i13 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 40 >> 2] = Math_fround(1.0);
 i4 = i13 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 60 >> 2] = Math_fround(1.0);
 i4 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i13) | 0, 1) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i10;
 i4 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i4, i9) | 0;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i4, i6) | 0;
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Outline_New_Internal(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!((i1 | 0) != 0 & (i5 | 0) != 0)) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 if ((i4 | 0) < 0 | i4 >>> 0 > i2 >>> 0) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i2 >>> 0 > 32767) {
  i6 = 10;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i1, 8, 0, i2, 0, i6) | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i5 + 8 >> 2] = _UNITY_ft_mem_realloc(i1, 1, 0, i2, 0, i6) | 0;
  if (!(HEAP32[i6 >> 2] | 0)) {
   HEAP32[i5 + 12 >> 2] = _UNITY_ft_mem_realloc(i1, 2, 0, i4, 0, i6) | 0;
   if (!(HEAP32[i6 >> 2] | 0)) {
    HEAP16[i5 + 2 >> 1] = i2;
    HEAP16[i5 >> 1] = i4;
    i6 = i5 + 16 | 0;
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
  }
 }
 i4 = i5 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
 _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 8 | 0;
 _UNITY_ft_mem_free(i1, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 _UNITY_ft_mem_free(i1, HEAP32[i5 + 12 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26vectorIP9Transform13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 25;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIP11Il2CppClass13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN7mecanim4hand17Hand2SkeletonPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS0_8HandPoseEPNS4_13SkeletonPoseTIN4math4trsXEEE(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i9 = i8 + 4 | 0;
 i10 = i8 + 8 | 0;
 i3 = 0;
 do {
  i2 = i3 * 3 | 0;
  i11 = i3 << 2;
  i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   i14 = HEAP32[i6 + 40 + ((i11 | 1) << 2) >> 2] | 0;
   i13 = HEAP32[i6 + 40 + (i11 << 2) >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = i14;
   HEAP32[i10 >> 2] = i13;
   __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i5, i7, i8, i1);
  }
  i1 = HEAP32[i4 + (i2 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   i14 = HEAP32[i6 + 40 + ((i11 | 2) << 2) >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i14;
   __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i5, i7, i8, i1);
  }
  i1 = HEAP32[i4 + (i2 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   i14 = HEAP32[i6 + 40 + ((i11 | 3) << 2) >> 2] | 0;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = i14;
   __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei(i5, i7, i8, i1);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN22BaseUnityConnectClient20StartEventDispatcherEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 24 | 0;
 i3 = i6 + 12 | 0;
 i4 = i6;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 if (HEAP8[(__Z16GetBuildSettingsv() | 0) + 119 >> 0] | 0) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1040686 | 0, 12);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1087447 | 0, 4);
  __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(i2, i3, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 __ZN22BaseUnityConnectClient25PrepareCloudServiceConfigEv(i1);
 i4 = __ZN19CloudServiceHandler20StartEventDispatcherERKN11UnityEngine15CloudWebService18CloudServiceConfigERNS1_16WWWRestHeaderMapE(HEAP32[i1 + 280 >> 2] | 0, i1 + 164 | 0, i2) | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2, HEAP32[i5 >> 2] | 0);
 STACKTOP = i6;
 return i4 | 0;
}

function __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 40 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 44 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i5 + 48 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i5 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
  return;
 }
}

function __ZN16GraphicsSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 33272 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 1;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 1;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 1;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z23StringScriptingToVectorINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEEEvP11Il2CppArrayRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 i9 = i7 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = (i2 - i3 | 0) / 12 | 0;
 i1 = i2;
 if (i4 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE8__appendEj(i7, i4 - i5 | 0);
  i2 = HEAP32[i9 >> 2] | 0;
 } else if (i4 >>> 0 < i5 >>> 0) {
  i3 = i3 + (i4 * 12 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   do {
    i5 = i1 + -12 | 0;
    HEAP32[i9 >> 2] = i5;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
    i1 = HEAP32[i9 >> 2] | 0;
   } while ((i1 | 0) != (i3 | 0));
   i2 = i1;
  }
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = 0;
 do {
  __Z24scripting_cpp_string_forP12Il2CppString(i8, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i6, i2) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + (i2 * 12 | 0) | 0, i8) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i9 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function _tt_cmap12_next(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i10 = i8 + 28 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 L1 : do if ((i3 | 0) != -1) {
  i11 = i8 + 36 | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i12 = HEAP32[i8 + 40 >> 2] | 0;
  if (i2 >>> 0 < i12 >>> 0) {
   i9 = (HEAP32[i8 + 16 >> 2] | 0) + 16 | 0;
   i7 = i1 + 16 | 0;
   i1 = i2;
   i2 = i3 + 1 | 0;
   L4 : while (1) {
    i6 = i9 + (i1 * 12 | 0) + 4 | 0;
    i4 = i6 + -4 | 0;
    i4 = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
    i6 = i6 + 4 | 0;
    i5 = i6 + -4 | 0;
    i5 = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
    i6 = (HEAPU8[i6 + 1 >> 0] | 0) << 16 | (HEAPU8[i6 >> 0] | 0) << 24 | (HEAPU8[i6 + 2 >> 0] | 0) << 8 | (HEAPU8[i6 + 3 >> 0] | 0);
    i2 = i2 >>> 0 < i4 >>> 0 ? i4 : i2;
    L6 : do if (i2 >>> 0 <= i5 >>> 0) {
     while (1) {
      i3 = i2 - i4 | 0;
      if (i6 >>> 0 > ~i3 >>> 0) break L6;
      i3 = i3 + i6 | 0;
      if (i3 | 0) break;
      if ((i2 | 0) == -1) break L1;
      i2 = i2 + 1 | 0;
      if (i2 >>> 0 > i5 >>> 0) break L6;
     }
     if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) break L4;
    } while (0);
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i12 >>> 0) break L1;
   }
   HEAP32[i10 >> 2] = i2;
   HEAP32[i8 + 32 >> 2] = i3;
   HEAP32[i11 >> 2] = i1;
   return;
  }
 } while (0);
 HEAP8[i8 + 24 >> 0] = 0;
 return;
}

function __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 25;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 25;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNK22BuiltinResourceManager15GetAllResourcesEv(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 12 | 0;
 i8 = i11;
 HEAP32[i4 >> 2] = 0;
 i9 = i4 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i10 = i5 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i12 = i3 - i1 | 0;
 i2 = (i12 | 0) / 24 | 0;
 i6 = i4 + 8 | 0;
 if (i12 | 0) {
  i12 = __Znwj(i2 << 2) | 0;
  i13 = i12;
  HEAP32[i4 >> 2] = i13;
  HEAP32[i9 >> 2] = i13;
  HEAP32[i6 >> 2] = i12 + (i2 << 2);
 }
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, _strlen(i3) | 0);
  i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i5, i2, i8) | 0;
  HEAP32[i7 >> 2] = i2;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i7); else {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 4;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (HEAP32[i10 >> 2] | 0));
 STACKTOP = i11;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags(i10, i7, i2, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (!i1) {
  __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i7, 0, i2);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i7, HEAP32[i9 + 4 >> 2] | 0, i2);
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + (i6 * 24 | 0) | 0;
 if (i6 | 0) {
  i4 = HEAP32[gb + 37212 >> 2] | 0;
  i5 = i10 + 20 | 0;
  i6 = i10 + 16 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i6 >> 2] = 2;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i2, gb + 1085989 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i2 + 4 | 0, gb + 1085998 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i2 + 8 | 0, gb + 1034504 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i10, i2 + 12 | 0, gb + 1034510 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN15SerializeTraitsI13TreePrototypeE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932472 | 0, gb + 932544 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932628 | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14UnityWebStream16FeedDownloadDataEPKhib(i6, i1, i2, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i6 + 40 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i9 = i6 + 12 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i2;
 if (__ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i3, i1, i2) | 0) i1 = i6 + 20 | 0; else {
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i4, HEAP32[i5 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6 + 24 | 0, i4) | 0;
  i1 = i6 + 20 | 0;
  HEAP8[i1 >> 0] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 do if (!((HEAP8[i1 >> 0] | 0) != 0 | i7 ^ 1)) {
  if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(HEAP32[i5 >> 2] | 0) | 0)) {
   __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i4, HEAP32[i5 >> 2] | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6 + 24 | 0, i4) | 0;
   HEAP8[i1 >> 0] = 1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP8[i1 + 176 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 180 >> 2] | 0; else i1 = i2 & 255;
  HEAP8[i6 + 21 >> 0] = (i1 | 0) != 0 & 1;
 } while (0);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i6 + 19 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function _unity_z_deflateReset(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!i4) {
  i5 = -2;
  return i5 | 0;
 }
 i5 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i5) {
  i5 = -2;
  return i5 | 0;
 }
 if (!(HEAP32[i4 + 32 >> 2] | 0)) {
  i5 = -2;
  return i5 | 0;
 }
 if (!(HEAP32[i4 + 36 >> 2] | 0)) {
  i5 = -2;
  return i5 | 0;
 }
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 2;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i5 + 8 >> 2];
 i2 = i5 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = 0 - i1 | 0;
 if ((i1 | 0) < 0) {
  HEAP32[i2 >> 2] = i3;
  i1 = i3;
 }
 HEAP32[i5 + 4 >> 2] = i1 | 0 ? 42 : 113;
 if ((i1 | 0) == 2) i1 = _unity_z_crc32(0, 0, 0) | 0; else i1 = _unity_z_adler32(0, 0, 0) | 0;
 HEAP32[i4 + 48 >> 2] = i1;
 HEAP32[i5 + 40 >> 2] = 0;
 _unity_z_tr_init(i5);
 HEAP32[i5 + 60 >> 2] = HEAP32[i5 + 44 >> 2] << 1;
 i4 = HEAP32[i5 + 76 >> 2] | 0;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 HEAP16[i3 + (i4 + -1 << 1) >> 1] = 0;
 _memset(i3 | 0, 0, (i4 << 1) + -2 | 0) | 0;
 i4 = HEAP32[i5 + 132 >> 2] | 0;
 HEAP32[i5 + 128 >> 2] = HEAPU16[gb + 16368 + (i4 * 12 | 0) + 2 >> 1];
 HEAP32[i5 + 140 >> 2] = HEAPU16[gb + 16368 + (i4 * 12 | 0) >> 1];
 HEAP32[i5 + 144 >> 2] = HEAPU16[gb + 16368 + (i4 * 12 | 0) + 4 >> 1];
 HEAP32[i5 + 124 >> 2] = HEAPU16[gb + 16368 + (i4 * 12 | 0) + 6 >> 1];
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i5 + 116 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 2;
 HEAP32[i5 + 96 >> 2] = 2;
 HEAP32[i5 + 104 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 i5 = 0;
 return i5 | 0;
}

function __ZN9Transform16SetLocalPositionERK8Vector3f(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, i17 = 0;
 i10 = i11 + 32 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i10 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i10 + 8 >> 2] | 0;
 i5 = i7 + (i9 * 40 | 0) | 0;
 f16 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i7 + (i9 * 40 | 0) + 4 | 0;
 f15 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + (i9 * 40 | 0) + 8 | 0;
 i8 = f14 != f16 | f13 != f15 | f12 != Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i5 >> 2] = f14;
 HEAPF32[i6 >> 2] = f13;
 HEAPF32[i7 >> 2] = f12;
 if (!i8) return;
 i3 = HEAP32[i10 + 40 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i9 << 2) >> 2] | 0;
 if (i4 | 0) {
  i5 = HEAP32[i10 + 60 >> 2] | 0;
  i6 = HEAP32[i10 + 56 >> 2] | 0;
  i7 = i10 + 36 | 0;
  i8 = HEAP32[i10 + 68 >> 2] | 0;
  i2 = 0;
  i1 = i9;
  while (1) {
   i9 = HEAP32[i5 + (i1 << 2) >> 2] & i3;
   i17 = i6 + (i1 << 2) | 0;
   HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i9;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i9;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i1 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
  }
 }
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(i10, HEAP32[i11 + 36 >> 2] | 0, 1);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i11 + 32 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = i10 + 20 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i8 << 3 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 i7 = i10 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i13 = i2;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i11 = i9;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i4 + (i13 << 3) | 0;
  return i13 | 0;
 }
 i13 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i4;
 HEAP32[i5 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i4 + (i13 << 3) | 0;
 return i13 | 0;
}

function __ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i6 = __ZnwjRK10MemLabelIdiPKci(2416, gb + 63552 | 0, 16, gb + 365786 | 0, 93) | 0;
 __ZN20ArchiveStorageReaderC2Ev(i6);
 i5 = i4 + 80 | 0;
 HEAP32[i5 >> 2] = i6;
 i3 = (__ZN20ArchiveStorageReader10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i6, i1, i2, i3) | 0) == 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  if (!i1) {
   i6 = -1;
   return i6 | 0;
  }
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i5 >> 2] = 0;
  i6 = -1;
  return i6 | 0;
 }
 do if (HEAP8[i1 + 184 >> 0] | 0) {
  if (__ZNK20ArchiveStorageReader15HasStreamBlocksEv(i1) | 0) {
   i1 = HEAP32[i5 >> 2] | 0;
   if (!i1) i1 = 1; else break;
   return i1 | 0;
  }
  i6 = __ZN33AssetBundleLoadFromAsyncOperation12IsCrc32ValidEv(i4) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i6) {
   __ZN20ArchiveStorageReader17MakeStorageUnusedEv(i1);
   i6 = 0;
   return i6 | 0;
  }
  if (!i1) {
   i6 = -1;
   return i6 | 0;
  }
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
  HEAP32[i5 >> 2] = 0;
  i6 = -1;
  return i6 | 0;
 } while (0);
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 HEAP32[i5 >> 2] = 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN20BufferedSocketStream15FlushSendbufferEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i4 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) if (!(HEAP8[i4 + 17 >> 0] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i4 + 44 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i3 + 20 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i8 = HEAP32[i3 + 16 >> 2] | 0;
 i2 = i8 + -1 & HEAP32[i2 >> 2];
 i8 = i8 - i2 | 0;
 i7 = i8 >>> 0 < i7 >>> 0 ? i8 : i7;
 i1 = i7 >>> 0 < i1 >>> 0 ? i7 : i1;
 if (!i1) i1 = 0; else {
  i1 = __ZN6Socket4SendEPKvjP12SendUserData(i4, (HEAP32[i3 >> 2] | 0) + i2 | 0, i1, 0) | 0;
  if ((i1 | 0) < 0) {
   if (__ZN6Socket15WouldBlockErrorEv() | 0) {
    i8 = 0;
    return i8 | 0;
   }
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0);
   i8 = 0;
   return i8 | 0;
  }
 }
 i8 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i1;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1;
 if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0)) {
  i8 = 1;
  return i8 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i8 + 24 >> 2] | 0) != (HEAP32[i8 + 20 >> 2] | 0)) {
  i8 = 1;
  return i8 | 0;
 }
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2];
 if (!i1) {
  i8 = 1;
  return i8 | 0;
 }
 if (HEAP8[i1 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 8 | 0);
 __ZdlPv(i1);
 i8 = 1;
 return i8 | 0;
}

function __ZN15SerializeTraitsI16SplashScreenLogoE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 450627 | 0, gb + 450632 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6SpriteE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i4 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1040045 | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 12; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 12; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 12) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i2, i3, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 12 | 0;
 i8 = i11 + 8 | 0;
 i9 = i11 + 4 | 0;
 i10 = i11;
 HEAP32[i8 >> 2] = i2;
 do if (i2 | 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i2, i1, i1) | 0;
  i12 = HEAP32[i2 + 128 >> 2] | 0;
  i4 = i12;
  if (!i12) if (!(HEAP32[i2 + 136 >> 2] | 0)) break;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i4;
  i4 = HEAP32[i2 + 136 >> 2] | 0;
  i12 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0;
  i12 = i12 ? i3 : 0;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i9, i1, i8, i12, i5, i6, i7) | 0;
  STACKTOP = i11;
  return;
 } while (0);
 HEAP32[i8 >> 2] = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 HEAP32[i9 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 368 >> 2] | 0, i4 | 0) | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 372 >> 2] | 0, i4 | 0) | 0;
 i12 = 0;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i9, i1, i8, i12, i5, i6, i7) | 0;
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine15PlatformWrapper24GetSystemLanguageCultureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 __ZN10systeminfo24GetSystemLanguageCultureEi(i5, __ZN10systeminfo17GetSystemLanguageEv() | 0);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i6 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __ZN11UmbraModule24CullBoundingSpheresUmbraEPK8Vector4fPKN5Umbra15OcclusionBufferEjjPhhb(i1, i12, i13, i3, i14, i15, i16, i2) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i17 = 0, f18 = f0, f19 = f0, f20 = f0, f21 = f0, f22 = f0, f23 = f0, f24 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i10 = i11;
 i4 = i2 ? i16 & 255 ^ 255 : 255;
 if (i3 >>> 0 >= i14 >>> 0) {
  STACKTOP = i11;
  return;
 }
 i5 = i9 + 4 | 0;
 i6 = i9 + 8 | 0;
 i7 = i10 + 4 | 0;
 i8 = i10 + 8 | 0;
 do {
  f23 = Math_fround(HEAPF32[i12 + (i3 << 4) + 12 >> 2]);
  f24 = Math_fround(HEAPF32[i12 + (i3 << 4) >> 2]);
  f19 = Math_fround(HEAPF32[i12 + (i3 << 4) + 4 >> 2]);
  f18 = Math_fround(HEAPF32[i12 + (i3 << 4) + 8 >> 2]);
  f22 = Math_fround(f19 - f23);
  f21 = Math_fround(f18 - f23);
  f20 = Math_fround(f23 + f24);
  f19 = Math_fround(f23 + f19);
  f18 = Math_fround(f23 + f18);
  HEAPF32[i9 >> 2] = Math_fround(f24 - f23);
  HEAPF32[i5 >> 2] = f22;
  HEAPF32[i6 >> 2] = f21;
  HEAPF32[i10 >> 2] = f20;
  HEAPF32[i7 >> 2] = f19;
  HEAPF32[i8 >> 2] = f18;
  i17 = (__ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf(i13, i9, i10, 0, 0) | 0) == 0;
  i2 = i15 + i3 | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (i17) i1 = i1 & 255 & i4 & 255; else i1 = i1 | i16;
  HEAP8[i2 >> 0] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i14 | 0));
 STACKTOP = i11;
 return;
}

function _jinit_marker_reader(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 0, 168) | 0;
 i2 = i1 + 404 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = fb + 3268;
 HEAP32[i3 + 4 >> 2] = fb + 1554;
 HEAP32[i3 + 8 >> 2] = fb + 1555;
 HEAP32[i3 + 24 >> 2] = fb + 1556;
 HEAP32[i3 + 92 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = fb + 1556;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = fb + 1556;
 HEAP32[i3 + 104 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = fb + 1556;
 HEAP32[i3 + 108 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = fb + 1556;
 HEAP32[i3 + 112 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = fb + 1556;
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = fb + 1556;
 HEAP32[i3 + 120 >> 2] = 0;
 HEAP32[i3 + 56 >> 2] = fb + 1556;
 HEAP32[i3 + 124 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = fb + 1556;
 HEAP32[i3 + 128 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = fb + 1556;
 HEAP32[i3 + 132 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = fb + 1556;
 HEAP32[i3 + 136 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = fb + 1556;
 HEAP32[i3 + 140 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = fb + 1556;
 HEAP32[i3 + 144 >> 2] = 0;
 HEAP32[i3 + 80 >> 2] = fb + 1556;
 HEAP32[i3 + 148 >> 2] = 0;
 HEAP32[i3 + 152 >> 2] = 0;
 HEAP32[i3 + 88 >> 2] = fb + 1556;
 HEAP32[i3 + 156 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = fb + 1557;
 HEAP32[i3 + 84 >> 2] = fb + 1557;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 196 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP8[i2 + 13 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 160 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorIP9FieldInfo13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i7 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (((i2 - i3 | 0) / 156 | 0) >>> 0 >= i8 >>> 0) {
  __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE18__construct_at_endEj(i7, i8);
  STACKTOP = i10;
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i6 = ((i3 - i4 | 0) / 156 | 0) + i8 | 0;
 if (i6 >>> 0 > 27531841) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i5 = (i2 - i4 | 0) / 156 | 0;
 i1 = i5 << 1;
 i1 = i5 >>> 0 < 13765920 ? (i1 >>> 0 < i6 >>> 0 ? i6 : i1) : 27531841;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = i7 + 8;
 if (!i1) i2 = 0; else i2 = __Znwj(i1 * 156 | 0) | 0;
 HEAP32[i9 >> 2] = i2;
 i6 = i2 + (((i3 - i4 | 0) / 156 | 0) * 156 | 0) | 0;
 HEAP32[i9 + 8 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i9 + 12 >> 2] = i2 + (i1 * 156 | 0);
 __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEE18__construct_at_endEj(i9, i8);
 __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i7, i9);
 __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEED2Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZNK25MultiBlocksMemoryFileData4ReadEyyPv(i3, i4, i5, i1, i2, i12) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i3 + 16 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i7 = ___udivdi3(i4 | 0, i5 | 0, i6 | 0, 0) | 0;
 getTempRet0() | 0;
 i10 = _i64Add(i1 | 0, i2 | 0, i4 | 0, i5 | 0) | 0;
 i9 = getTempRet0() | 0;
 i11 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = i9 >>> 0 > 0 | (i9 | 0) == 0 & i10 >>> 0 > i11 >>> 0;
 i11 = _i64Subtract(i11 | 0, 0, i4 | 0, i5 | 0) | 0;
 i9 = getTempRet0() | 0;
 i11 = i10 ? i11 : i1;
 i9 = i10 ? i9 : i2;
 i10 = i3 + 32 | 0;
 if ((i11 | 0) == 0 & (i9 | 0) == 0) {
  i12 = 0;
  i13 = 0;
  setTempRet0(i12 | 0);
  return i13 | 0;
 }
 i5 = _i64Subtract(i4 | 0, i5 | 0, Math_imul(i7, i6) | 0, 0) | 0;
 getTempRet0() | 0;
 i8 = i3 + 20 | 0;
 i6 = 0;
 i4 = i7;
 i1 = 0;
 i3 = 0;
 while (1) {
  if (i4 >>> 0 >= (HEAP32[i10 >> 2] | 0) >>> 0) {
   i2 = 8;
   break;
  }
  i2 = (HEAP32[i13 >> 2] | 0) - i5 | 0;
  i1 = _i64Subtract(i11 | 0, i9 | 0, i1 | 0, i3 | 0) | 0;
  getTempRet0() | 0;
  i1 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
  i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  i3 = i12 + i6 | 0;
  if (!i2) _memset(i3 | 0, 0, i1 | 0) | 0; else _memcpy(i3 | 0, i2 + i5 | 0, i1 | 0) | 0;
  i1 = i1 + i6 | 0;
  if (!(i9 >>> 0 > 0 | (i9 | 0) == 0 & i11 >>> 0 > i1 >>> 0)) {
   i3 = 0;
   i2 = 8;
   break;
  } else {
   i6 = i1;
   i4 = i4 + 1 | 0;
   i5 = 0;
   i3 = 0;
  }
 }
 if ((i2 | 0) == 8) {
  setTempRet0(i3 | 0);
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx16PxVehicleDrive4W6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = (i1 + 7 | 0) >>> 2;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i8) | 0) + 800 | 0, gb + 827445 | 0, 75) | 0;
 __ZN5physx16PxVehicleDrive4WC2Ev(i6);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i6, i6 + 800 | 0, i8, i1 + 4 | 0) | 0;
 HEAP8[i6 + 113 >> 0] = 0;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i6, i2, i3, i4, 4, i1);
 i3 = i5 + 64 | 0;
 _memcpy(i6 + 224 | 0, i5 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i6 + 288 >> 2] = HEAP32[i3 >> 2];
 i3 = i6 + 304 | 0;
 i1 = i5 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 _memcpy(i6 + 336 | 0, i5 + 112 | 0, 416) | 0;
 i3 = i6 + 752 | 0;
 i1 = i5 + 528 | 0;
 i2 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags(i9, i3, i1, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = i9 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = i3;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i3 >> 2] = i1;
  i3 = i6;
 } else {
  i2 = i3;
  i3 = i9 + 4 | 0;
 }
 i5 = i1 + i2 | 0;
 i6 = i5 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 * 40 | 0, 4) | 0;
 i1 = i6;
 i2 = i2 | 0 ? i2 - i1 | 0 : 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i1 = i2 + i1 | 0;
 i2 = i1 + (i7 * 40 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_(i1, i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN16SubstanceArchive7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, i1, 16, gb + 1048932 | 0, 0, gb + 434342 | 0, 67) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i2);
 HEAP32[i4 >> 2] = gb + 59556 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i1 = i6;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63736 | 0, 16, gb + 434428 | 0, 63) | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 59540 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP8[i2 + 32 >> 0] = 0;
 i1 = i2 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = i1;
 HEAP32[i4 + 52 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14BillboardAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 422256 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN19SharedBillboardData8TransferI24GenerateTypeTreeTransferEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i2);
 i4 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 945676 | 0, gb + 946436 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14AnimationState8SetSpeedEf(i6, f3) {
 i6 = i6 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i4 = i6 + 56 | 0;
 i5 = HEAP16[i4 >> 1] | 0;
 if ((i5 & 1536) == 1536) {
  i7 = f3 == Math_fround(0.0);
  i1 = f3 > Math_fround(0.0);
  i1 = i1 ? 1 : -1;
  i2 = i7 ? 0 : i1;
  if (!i7) {
   if ((HEAP32[i6 + 68 >> 2] | 0) == 4) {
    f9 = Math_fround(HEAPF32[i6 + 88 >> 2]);
    f8 = Math_fround(HEAPF32[i6 + 92 >> 2]);
    f9 = Math_fround((+HEAPF64[i6 + 16 >> 3] - +f9) / +Math_fround(f8 - f9));
    i1 = f9 >= Math_fround(0.0);
    f8 = Math_fround(f9 + Math_fround(-.99999994));
    i1 = (~~(i1 ? f9 : f8) & 1 | 0) == 0 ? i2 : 0 - i2 | 0;
   }
   HEAP16[i4 >> 1] = i5 & -1537;
   i7 = i6 + 60 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + ((i1 | 0) > 0 ? 1 : -1);
  }
 } else {
  f9 = Math_fround(HEAPF32[i6 + 36 >> 2]);
  i10 = f9 == Math_fround(0.0);
  i1 = f9 > Math_fround(0.0);
  i2 = f3 == Math_fround(0.0);
  i7 = f3 > Math_fround(0.0);
  if (((i10 ? 0 : i1 ? 1 : -1) | 0) != ((i2 ? 0 : i7 ? 1 : -1) | 0)) HEAP16[i4 >> 1] = i5 & -1537 | 512;
 }
 HEAPF32[i6 + 36 >> 2] = f3;
 HEAPF32[i6 + 40 >> 2] = f3;
 i1 = f3 >= Math_fround(0.0);
 if ((HEAP32[i6 + 68 >> 2] | 1 | 0) != 1) {
  f9 = i1 ? Math_fround(inf) : Math_fround(-inf);
  i10 = i6 + 44 | 0;
  HEAPF32[i10 >> 2] = f9;
  return;
 }
 if (i1) {
  f9 = Math_fround(HEAPF32[i6 + 92 >> 2]);
  i10 = i6 + 44 | 0;
  HEAPF32[i10 >> 2] = f9;
  return;
 } else {
  f9 = Math_fround(HEAPF32[i6 + 88 >> 2]);
  i10 = i6 + 44 | 0;
  HEAPF32[i10 >> 2] = f9;
  return;
 }
}

function __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 40 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 40 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + (i5 * 40 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 32 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i9 + (i5 * 40 | 0) + 36 >> 2] = HEAP32[i3 + 36 >> 2];
 return;
}

function __Z29TerrainData_CUSTOM_GetHeightsP12Il2CppObjectiiii(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if ((i6 | i5 | 0) >= 0) {
  i2 = i7 + i5 | 0;
  if ((i2 | 0) >= 0) {
   i3 = i8 + i6 | 0;
   if ((i3 | 0) >= 0) {
    if (!i4) {
     i1 = 0;
     __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
    }
    i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
    if (!i1) {
     i11 = i4;
     __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
    }
    if ((i2 | 0) <= (HEAP32[i1 + 248 + 72 >> 2] | 0)) {
     i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
     if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
     if ((i3 | 0) <= (HEAP32[i1 + 248 + 76 >> 2] | 0)) {
      i1 = __Z22scripting_array_new_2dP11Il2CppClassjjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0, 4, i8, i7) | 0;
      i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
      if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
       __ZNK9Heightmap10GetHeightsEiiiiPf(i2 + 248 | 0, i5, i6, i7, i8, __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0);
       STACKTOP = i10;
       return i1 | 0;
      }
     }
    }
   }
  }
 }
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937374 | 0, i9);
 return 0;
}

function __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier52ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 52;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 52;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = i10 + 20 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i8 << 3 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 i7 = i10 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i13 = i2;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i11 = i9;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i4 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i8;
  i13 = HEAP32[i6 >> 2] | 0;
  i12 = i13 + 1 | 0;
  HEAP32[i6 >> 2] = i12;
  i13 = i4 + (i13 << 3) | 0;
  return i13 | 0;
 }
 i13 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i4;
 HEAP32[i5 >> 2] = i8;
 i13 = HEAP32[i6 >> 2] | 0;
 i12 = i13 + 1 | 0;
 HEAP32[i6 >> 2] = i12;
 i13 = i4 + (i13 << 3) | 0;
 return i13 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 36 | 0;
 i7 = i10 + 32 | 0;
 i9 = i10 + 16 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 56; else i1 = (HEAP32[i1 >> 2] | 0) + 56 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxQuatEE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function _tt_cmap4_next(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 24 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 L1 : do if (i1 >>> 0 <= 65534) {
  i1 = i1 + 1 | 0;
  i9 = i12 + 40 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  i10 = i12 + 52 | 0;
  i11 = i12 + 44 | 0;
  i7 = i12 + 48 | 0;
  i8 = i12 + 36 | 0;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  L3 : while (1) {
   i2 = HEAP32[i10 >> 2] | 0;
   i5 = HEAP32[i11 >> 2] | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   L5 : do if (i1 >>> 0 <= i5 >>> 0) {
    if (!i2) {
     i2 = i1;
     while (1) {
      i3 = i2 + i6 & 65535;
      if (i3 | 0) {
       i1 = 11;
       break L3;
      }
      i1 = i2 + 1 | 0;
      if (i1 >>> 0 > i5 >>> 0) break L5; else i2 = i1;
     }
    }
    i4 = i2 + (i1 - i3 << 1) | 0;
    i3 = i1;
    while (1) {
     i1 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
     i4 = i4 + 2 | 0;
     if (i1 | 0) {
      i2 = i1 + i6 & 65535;
      if (i2 | 0) {
       i1 = 9;
       break L3;
      }
     }
     i1 = i3 + 1 | 0;
     if (i1 >>> 0 > i5 >>> 0) break; else i3 = i1;
    }
   } while (0);
   if ((_tt_cmap4_set_range(i12, (HEAP32[i8 >> 2] | 0) + 1 | 0) | 0) < 0) break L1;
   i3 = HEAP32[i9 >> 2] | 0;
   i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  }
  if ((i1 | 0) == 9) {
   HEAP32[i13 >> 2] = i3;
   HEAP32[i12 + 28 >> 2] = i2;
   return;
  } else if ((i1 | 0) == 11) {
   HEAP32[i13 >> 2] = i2;
   HEAP32[i12 + 28 >> 2] = i3;
   return;
  }
 } while (0);
 HEAP32[i13 >> 2] = -1;
 HEAP32[i12 + 28 >> 2] = 0;
 return;
}

function __ZNK6Camera18ViewportPointToRayERK8Vector2f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 __ZL19GetCameraTargetRectRK6Camerab(i5, i2, 1);
 f9 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f13 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f9 = Math_fround(f9 * f13);
 f7 = Math_fround(f7 * f13);
 f11 = Math_fround(f11 * f12);
 f6 = Math_fround(f6 * f12);
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 f14 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f9 = Math_fround(f9 + f15);
 f11 = Math_fround(f11 + f14);
 f7 = Math_fround(f7 + f9);
 f6 = Math_fround(f6 + f11);
 f13 = Math_fround(f13 + f15);
 f12 = Math_fround(f12 + f14);
 f9 = f9 < f15 ? f15 : f9;
 f11 = f11 < f14 ? f14 : f11;
 f7 = Math_fround((f7 > f13 ? f13 : f7) - f9);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 f6 = Math_fround((f6 > f12 ? f12 : f6) - f11);
 i3 = f6 < Math_fround(0.0);
 f6 = Math_fround(f11 + Math_fround(f10 * (i3 ? Math_fround(0.0) : f6)));
 HEAPF32[i5 >> 2] = Math_fround(f9 + Math_fround(f8 * f7));
 HEAPF32[i5 + 4 >> 2] = f6;
 __ZNK6Camera16ScreenPointToRayERK8Vector2f(i1, i2, i5);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd7FastIPC7canSendEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = i2 + 8 | 0;
 do if (i4 >>> 0 <= ((HEAP32[i5 + 24 >> 2] | 0) + 8 | 0) >>> 0) {
  i2 = HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0;
  i3 = HEAP32[HEAP32[i5 + 20 >> 2] >> 2] | 0;
  if (i3 >>> 0 > i2 >>> 0) {
   if (i4 >>> 0 >= (i3 - i2 | 0) >>> 0) break;
   i1 = HEAP32[i5 + 4 >> 2] | 0;
  } else {
   i1 = HEAP32[i5 + 4 >> 2] | 0;
   i8 = i1 - i2 | 0;
   if (i4 >>> 0 >= (i8 >>> 0 > i3 >>> 0 ? i8 : i3) >>> 0) break;
  }
  i8 = i2 + i4 | 0;
  if (!((i3 | 0) == 0 & (i1 >>> 0 >= i8 >>> 0 & (i1 - i8 | 0) >>> 0 < 17))) {
   i8 = 1;
   STACKTOP = i7;
   return i8 | 0;
  }
 } while (0);
 i3 = i5 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  i8 = (i8 | 0) == 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = (__ZN5physx6shdfnd12PxRingBuffer15MultiPartPacket7processEv(i1) | 0) == 2;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i8) {
  i8 = i1;
  i8 = (i8 | 0) == 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i5 + 44 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - (HEAP32[i1 + 20 >> 2] | 0);
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i1 + 28 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1);
 }
 HEAP32[i3 >> 2] = i2;
 i8 = i2;
 i8 = (i8 | 0) == 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN26PxcContactCellMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i9, i11, i3, i4, i5, i1, i2) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f6 = f0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 32 >> 2] = HEAP32[i5 + 8 >> 2];
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 i2 = HEAP32[i9 + 16 >> 2] | 0;
 i3 = i9 + 24 | 0;
 f6 = Math_fround(HEAPF32[i9 + 96 >> 2]);
 i4 = HEAP32[i9 + 104 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i9 + 12 >> 2] | 0;
  i7 = 0;
  while (1) {
   __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE(i1 + ((HEAP32[i5 >> 2] | 0) * 176 | 0) | 0, 0, i3, i8, 1, f6, i4);
   i7 = i7 + 1 | 0;
   if ((i7 | 0) == (i2 | 0)) break; else i5 = i5 + 4 | 0;
  }
 }
 i1 = HEAP32[i9 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return 1;
 }
 i2 = HEAPU8[i1 >> 0] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 < 10) HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP8[i1 >> 0] = i3;
 STACKTOP = i10;
 return 1;
}

function __ZN24ControllerFilterCallback6filterERKN5physx12PxControllerES3_(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 36 | 0;
 i3 = i6 + 32 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 i10 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0) | 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 80 >> 2] | 0, i8 | 0) | 0;
 i1 = __Z17GetPhysicsManagerv() | 0;
 if (!(HEAP32[(HEAP32[i1 + 724 >> 2] | 0) + (HEAP32[(HEAP32[i10 + 28 >> 2] | 0) + 48 >> 2] << 2) >> 2] & 1 << HEAP32[(HEAP32[i9 + 28 >> 2] | 0) + 48 >> 2])) {
  i10 = 0;
  STACKTOP = i6;
  return i10 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0) | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 108 >> 2] | 0, i10 | 0, i2 | 0, 1, 0) | 0;
 HEAP32[i3 >> 2] = 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0) | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 108 >> 2] | 0, i10 | 0, i3 | 0, 1, 0) | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i10 | 0);
 i10 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 92 >> 2] | 0, i5 | 0, i10 | 0);
 i10 = __ZN14PhysicsManager18GetIgnoreCollisionEii(i1, HEAP32[i4 >> 2] & 255, HEAP32[i5 >> 2] & 255) | 0;
 i10 = (i10 | (__ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_(i1, i4, i5) | 0)) ^ 1;
 STACKTOP = i6;
 return i10 | 0;
}

function _UNITY_FT_CMap_New(i3, i4, i2, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 HEAP32[i10 >> 2] = 0;
 if ((i3 | 0) == 0 | (i2 | 0) == 0) {
  i10 = 6;
  STACKTOP = i11;
  return i10 | 0;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 if (!i7) {
  i10 = 6;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = HEAP32[i7 + 100 >> 2] | 0;
 i1 = _UNITY_ft_mem_alloc(i6, HEAP32[i3 >> 2] | 0, i10) | 0;
 do if (!(HEAP32[i10 >> 2] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i8 = i1 + 12 | 0;
  HEAP32[i8 >> 2] = i3;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) i5 = 6; else {
   i4 = mftCall_iii(i2 | 0, i1 | 0, i4 | 0) | 0;
   HEAP32[i10 >> 2] = i4;
   if (!i4) i5 = 6;
  }
  if ((i5 | 0) == 6) {
   i3 = i7 + 36 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   i7 = i7 + 40 | 0;
   i2 = _UNITY_ft_mem_realloc(i6, 4, i2, i2 + 1 | 0, HEAP32[i7 >> 2] | 0, i10) | 0;
   HEAP32[i7 >> 2] = i2;
   if (!(HEAP32[i10 >> 2] | 0)) {
    i8 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = i8 + 1;
    HEAP32[i2 + (i8 << 2) >> 2] = i1;
    break;
   }
  }
  i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
  if (i2 | 0) mftCall_vi(i2 | 0, i1 | 0);
  _UNITY_ft_mem_free(i3, i1);
  i1 = 0;
 } while (0);
 if (i9 | 0) HEAP32[i9 >> 2] = i1;
 i10 = HEAP32[i10 >> 2] | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 144; else i1 = (HEAP32[i1 >> 2] | 0) + 144 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 92; else i1 = (HEAP32[i1 >> 2] | 0) + 92 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 84; else i1 = (HEAP32[i1 >> 2] | 0) + 84 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 80; else i1 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 48; else i1 = (HEAP32[i1 >> 2] | 0) + 48 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(i11, i9, i8) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 HEAP32[i4 >> 2] = i9;
 i10 = HEAPU8[i9 + 20 >> 0] | 0;
 i5 = i11 + 16 + (i10 * 12 | 0) | 0;
 i6 = i11 + 16 + (i10 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i9 + 12 | 0;
 HEAP32[i7 >> 2] = i1;
 i3 = i11 + 16 + (i10 * 12 | 0) + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(i2 & 2147483647)) {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5, 64);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if ((i2 & 2147483647) >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = i9;
  HEAP32[i6 >> 2] = i1 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i4) | 0;
 if (!i8) {
  STACKTOP = i12;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i11 + 88 + (i10 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  i9 = i11 + 16 + (i10 * 12 | 0) | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  i8 = i11 + (i2 << 2) | 0;
  i10 = HEAP32[i8 >> 2] | 0;
  i11 = HEAP32[i11 + (i1 << 2) >> 2] | 0;
  HEAP32[i8 >> 2] = i11;
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = i10;
  HEAP32[i10 + 12 >> 2] = i1;
  HEAP32[i11 + 12 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i3, _llvm_bswap_i32(i1 | 0) | 0, i9 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i4 = i1 + (i3 * 40 | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 4 | 0, i9);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 24 | 0, i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __Z22TransferField_NonArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i3 = i5;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[i6 + 4 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i3, 1); else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i1 = i3 + 11 | 0;
 if (HEAP8[i4 + 128 >> 0] | 0) {
  i4 = __Z20scripting_string_newPKc((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
  i6 = HEAP32[i6 + 20 >> 2] | 0;
  HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + ((HEAP8[i7 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i7 + 12 >> 2] | 0) | 0 : i6) >> 2] = i4;
 }
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__2L15utf16le_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i8, i9, i2, i10, i11, i12, i3) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 if (!(i3 & 4)) i2 = i8; else {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i8;
  if ((i2 - i1 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == -1) if ((HEAP8[i1 + 1 >> 0] | 0) == -2) HEAP32[i9 >> 2] = i1 + 2;
 }
 i7 = i8 + -1 | 0;
 L8 : while (1) {
  i5 = HEAP32[i9 >> 2] | 0;
  if (i5 >>> 0 >= i7 >>> 0) {
   i13 = 18;
   break;
  }
  i6 = HEAP32[i11 >> 2] | 0;
  if (i6 >>> 0 >= i10 >>> 0) {
   i13 = 18;
   break;
  }
  i4 = HEAPU8[i5 + 1 >> 0] << 8;
  i1 = HEAPU8[i5 >> 0] | 0;
  i3 = i4 | i1;
  switch ((i4 & 64512) << 16 >> 16) {
  case -9216:
   {
    i1 = 2;
    break L8;
   }
  case -10240:
   {
    if ((i2 - i5 | 0) < 4) {
     i1 = 1;
     break L8;
    }
    i4 = HEAPU8[i5 + 3 >> 0] << 8;
    if ((i4 & 64512 | 0) != 56320) {
     i1 = 2;
     break L8;
    }
    i1 = (i3 << 10 & 983040) + 65536 | i1 << 10 & 64512 | i4 & 768 | HEAPU8[i5 + 2 >> 0];
    if (i1 >>> 0 > i12 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i6 >> 2] = i1;
    i1 = i5 + 4 | 0;
    break;
   }
  default:
   {
    if (i3 >>> 0 > i12 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i6 >> 2] = i3;
    i1 = i5 + 2 | 0;
   }
  }
  HEAP32[i9 >> 2] = i1;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
 }
 if ((i13 | 0) == 18) i1 = i5 >>> 0 < i8 >>> 0 & 1;
 return i1 | 0;
}

function __ZNSt3__2L15utf16be_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i1, i8, i9, i2, i10, i11, i12, i3) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i2;
 if (!(i3 & 4)) i2 = i8; else {
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = i8;
  if ((i2 - i1 | 0) > 1) if ((HEAP8[i1 >> 0] | 0) == -2) if ((HEAP8[i1 + 1 >> 0] | 0) == -1) HEAP32[i9 >> 2] = i1 + 2;
 }
 i7 = i8 + -1 | 0;
 L8 : while (1) {
  i5 = HEAP32[i9 >> 2] | 0;
  if (i5 >>> 0 >= i7 >>> 0) {
   i13 = 18;
   break;
  }
  i6 = HEAP32[i11 >> 2] | 0;
  if (i6 >>> 0 >= i10 >>> 0) {
   i13 = 18;
   break;
  }
  i4 = HEAPU8[i5 >> 0] << 8;
  i1 = HEAPU8[i5 + 1 >> 0] | 0;
  i3 = i4 | i1;
  switch ((i4 & 64512) << 16 >> 16) {
  case -9216:
   {
    i1 = 2;
    break L8;
   }
  case -10240:
   {
    if ((i2 - i5 | 0) < 4) {
     i1 = 1;
     break L8;
    }
    i4 = HEAPU8[i5 + 2 >> 0] << 8;
    if ((i4 & 64512 | 0) != 56320) {
     i1 = 2;
     break L8;
    }
    i1 = (i3 << 10 & 983040) + 65536 | i1 << 10 & 64512 | i4 & 768 | HEAPU8[i5 + 3 >> 0];
    if (i1 >>> 0 > i12 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i6 >> 2] = i1;
    i1 = i5 + 4 | 0;
    break;
   }
  default:
   {
    if (i3 >>> 0 > i12 >>> 0) {
     i1 = 2;
     break L8;
    }
    HEAP32[i6 >> 2] = i3;
    i1 = i5 + 2 | 0;
   }
  }
  HEAP32[i9 >> 2] = i1;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 4;
 }
 if ((i13 | 0) == 18) i1 = i5 >>> 0 < i8 >>> 0 & 1;
 return i1 | 0;
}

function __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i5) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i9 + 12 | 0;
 i12 = i9 + 4 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i8 = i2 - i1 | 0;
 i3 = (i8 >> 2) + 1 | 0;
 if ((i8 | 0) < -4) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i7 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i6 = i7 >> 1;
 i6 = i7 >> 2 >>> 0 < 1073741823 ? (i6 >>> 0 < i3 >>> 0 ? i3 : i6) : 2147483647;
 if (!i6) i7 = 0; else {
  i7 = HEAP32[i11 >> 2] | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = i7;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 16, i10, 0, gb + 1049224 | 0, 75) | 0;
 }
 i4 = i7 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = (HEAP32[i12 >> 2] | 0) - i1 | 0;
 i3 = i4 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i12 >> 2] = i4 + 4;
 HEAP32[i8 >> 2] = i7 + (i6 << 2);
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i11 >> 2] | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = i12;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i1 + 4 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 88 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj(i1, i2 - i4 | 0);
  STACKTOP = i8;
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i3 = i3 + (i2 * 88 | 0) | 0;
 if ((i5 | 0) == (i3 | 0)) {
  STACKTOP = i8;
  return;
 }
 i4 = i6 + 4 | 0;
 do {
  HEAP32[i7 >> 2] = i5 + -88;
  i1 = i5 + -16 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i5 + -4 >> 2] | 0;
   HEAP32[i6 >> 2] = 66;
   HEAP32[i4 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
  }
  i1 = HEAP32[i5 + -36 >> 2] | 0;
  if (i1 | 0) {
   i2 = i5 + -32 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i1 = HEAP32[i5 + -64 >> 2] | 0;
  if (i1 | 0) {
   i2 = i5 + -60 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i2 = HEAP32[i5 + -80 >> 2] | 0;
  if (i2 | 0) {
   i1 = i5 + -76 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
   __ZdlPv(i2);
  }
  i5 = HEAP32[i7 >> 2] | 0;
 } while ((i5 | 0) != (i3 | 0));
 STACKTOP = i8;
 return;
}

function __ZNSt3__214__split_bufferIPN9BlobWrite11TypeContextENS_9allocatorIS3_EEE10push_frontERKS3_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i9 + 4 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i12;
 do if ((i11 | 0) == (i12 | 0)) {
  i12 = i9 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = i8;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2;
   i5 = ((i1 - i3 >> 2) + 1 | 0) / 2 | 0;
   i1 = i2 + (i5 << 2) | 0;
   i3 = i3 - i11 | 0;
   i10 = i3 >> 2;
   i4 = i1 + (0 - i10 << 2) | 0;
   if (i10) {
    _memmove(i4 | 0, i11 | 0, i3 | 0) | 0;
    i1 = i4;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i12 >> 2] = i2 + (i5 << 2);
   break;
  }
  i8 = i1 - i3 >> 1;
  i8 = (i8 | 0) == 0 ? 1 : i8;
  i5 = __Znwj(i8 << 2) | 0;
  i6 = i5;
  i1 = i5 + ((i8 + 3 | 0) >>> 2 << 2) | 0;
  i7 = i1;
  i8 = i5 + (i8 << 2) | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i3 = i7;
   i2 = i11;
  } else {
   i5 = i1;
   i3 = i7;
   i4 = i11;
   do {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i3 + 4 | 0;
    i3 = i5;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i6;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i8;
  if (i2) {
   __ZdlPv(i2);
   i1 = HEAP32[i14 >> 2] | 0;
  }
 } else i1 = i11; while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
 return;
}

function __ZN5physx3Scb14ParticleSystem13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i7, i6, i5, i9) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 8 | 0;
 i1 = i10;
 i3 = HEAP32[i7 + 152 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 if (!i4) {
  i2 = i3 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i3 + 73 | 0; else {
   i12 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i11 = i3 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 699609;
   HEAP32[i1 + 4 >> 2] = i11;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i12, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i11;
  }
  _strncpy(i1, gb + 699609 | 0, 128) | 0;
  HEAP8[i3 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 switch ((HEAP32[i7 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 9; else i1 = 8;
   break;
  }
 default:
  i1 = 9;
 }
 if ((i1 | 0) == 8) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 167, gb + 699279 | 0, i8); else if ((i1 | 0) == 9) __ZN5physx2Sc18ParticleSystemCore13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i7 + 12 | 0, i6, i5, i9);
 if (i4) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 92; else i1 = (HEAP32[i1 >> 2] | 0) + 92 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 84; else i1 = (HEAP32[i1 >> 2] | 0) + 84 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 80; else i1 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 52; else i1 = (HEAP32[i1 >> 2] | 0) + 52 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 48; else i1 = (HEAP32[i1 >> 2] | 0) + 48 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i5 + 24 | 0;
 i9 = i5 + 12 | 0;
 i6 = i5;
 i12 = HEAP32[i3 >> 2] | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i10 = HEAP32[i3 + 8 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 HEAPF32[i13 >> 2] = Math_fround(1.0);
 i4 = i13 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 20 >> 2] = Math_fround(1.0);
 i4 = i13 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 40 >> 2] = Math_fround(1.0);
 i4 = i13 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i13 + 60 >> 2] = Math_fround(1.0);
 i4 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i13) | 0, 1) | 0;
 HEAP32[i9 >> 2] = i12;
 HEAP32[i9 + 4 >> 2] = i11;
 HEAP32[i9 + 8 >> 2] = i10;
 i4 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i4, i9) | 0;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i4, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN13RendererScene16UpdateVisibilityEPK9IndexList(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i6 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i3 = i7 + 100 | 0;
  i1 = 0;
  do {
   i5 = (HEAP32[i3 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = i7 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) i4 = 0; else {
  i4 = __Z9GetIUmbrav() | 0;
  i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0) | 0;
 }
 i5 = i6 + 16 | 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  i2 = i6 + 12 | 0;
  i3 = i7 + 100 | 0;
  i1 = 0;
  do {
   i6 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i4) | 0;
   HEAP8[i6 >> 0] = HEAPU8[i6 >> 0] | 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i5 >> 2] | 0));
 }
 i5 = i7 + 148 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
 HEAP32[i5 >> 2] = i1;
 i6 = HEAP32[i7 + 72 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  i7 = i1;
  i7 = i7 + -1 | 0;
  HEAP32[i5 >> 2] = i7;
  return;
 }
 i4 = i7 + 100 | 0;
 i2 = i7 + 60 | 0;
 i1 = 0;
 do {
  i3 = (HEAP32[i4 >> 2] | 0) + i1 | 0;
  if ((HEAP8[i3 >> 0] | 0) == 1) {
   i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
   HEAP8[i3 >> 0] = HEAPU8[i3 >> 0] | 4;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 i7 = HEAP32[i5 >> 2] | 0;
 i7 = i7 + -1 | 0;
 HEAP32[i5 >> 2] = i7;
 return;
}

function __ZN12SocketStream7RecvAllEPvjl(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = (i5 | 0) > 0;
 i3 = i2;
 L1 : while (1) {
  if (!i3) {
   i1 = 1;
   i2 = 14;
   break;
  }
  L4 : do if (i6) while (1) {
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
   if (!(__ZN6Socket24WaitForAvailableRecvDataEl(i4, i5) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0, i3 | 0) | 0;
   if ((i2 | 0) >= 0) break L4;
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, 1, 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
  } else while (1) {
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
   i2 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0, i3 | 0) | 0;
   if ((i2 | 0) >= 0) break L4;
   if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
   if (!(mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, 1, 0) | 0)) {
    i1 = 0;
    i2 = 14;
    break L1;
   }
  } while (0);
  if (!i2) {
   i1 = 0;
   i2 = 14;
   break;
  } else {
   i1 = i1 + i2 | 0;
   i3 = i3 - i2 | 0;
  }
 }
 if ((i2 | 0) == 14) return i1 | 0;
 return 0;
}

function _tt_cmap8_char_next(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i3 = (HEAPU8[i4 + 8205 >> 0] | 0) << 16 | (HEAPU8[i4 + 8204 >> 0] | 0) << 24 | (HEAPU8[i4 + 8206 >> 0] | 0) << 8 | (HEAPU8[i4 + 8207 >> 0] | 0);
 L4 : do if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  i9 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
  i2 = i2 + 1 | 0;
  i8 = i4 + 8208 | 0;
  i1 = 0;
  while (1) {
   i5 = (HEAPU8[i8 + 1 >> 0] | 0) << 16 | (HEAPU8[i8 >> 0] | 0) << 24 | (HEAPU8[i8 + 2 >> 0] | 0) << 8 | (HEAPU8[i8 + 3 >> 0] | 0);
   i6 = (HEAPU8[i8 + 5 >> 0] | 0) << 16 | (HEAPU8[i8 + 4 >> 0] | 0) << 24 | (HEAPU8[i8 + 6 >> 0] | 0) << 8 | (HEAPU8[i8 + 7 >> 0] | 0);
   i7 = (HEAPU8[i8 + 9 >> 0] | 0) << 16 | (HEAPU8[i8 + 8 >> 0] | 0) << 24 | (HEAPU8[i8 + 10 >> 0] | 0) << 8 | (HEAPU8[i8 + 11 >> 0] | 0);
   i8 = i8 + 12 | 0;
   i2 = i2 >>> 0 < i5 >>> 0 ? i5 : i2;
   L8 : do if (i2 >>> 0 <= i6 >>> 0) {
    while (1) {
     i4 = i2 - i5 | 0;
     if (i7 >>> 0 > ~i4 >>> 0) break L8;
     i1 = i4 + i7 | 0;
     if (i1 | 0) break;
     if ((i2 | 0) == -1) {
      i2 = 0;
      i1 = 0;
      break L4;
     }
     i2 = i2 + 1 | 0;
     if (i2 >>> 0 > i6 >>> 0) {
      i1 = 0;
      break L8;
     } else i1 = 0;
    }
    if (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) break L4;
   } while (0);
   i3 = i3 + -1 | 0;
   if (!i3) {
    i2 = 0;
    break;
   }
  }
 } while (0);
 HEAP32[i10 >> 2] = i2;
 i10 = i1;
 return i10 | 0;
}

function __ZN5physx9NpFactory16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i10, i2, i4, i5, i7, i6) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i9 = i12;
 i8 = i10 + 2140 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = i10 + 2136 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i10 + 1844 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 i1 = i10 + 2124 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i10 + 2128 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx12NpConstraintC2EPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i3, i2, i4, i5, i7, i6);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 >> 2] | 0);
 HEAP32[i9 >> 2] = i3;
 if (!i3) {
  STACKTOP = i12;
  return i3 | 0;
 }
 i2 = i10 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i10 + 524 | 0, i9, i11) | 0;
 if (!(HEAP8[i11 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i12;
 return i3 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E(i14, i1, i2) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0, i16 = 0, i17 = 0;
 HEAP32[i14 >> 2] = 2122317823;
 i9 = i14 + 4 | 0;
 HEAP32[i9 >> 2] = 2122317823;
 i10 = i14 + 8 | 0;
 HEAP32[i10 >> 2] = 2122317823;
 HEAP32[i14 + 12 >> 2] = -25165825;
 i11 = i14 + 16 | 0;
 HEAP32[i11 >> 2] = -25165825;
 i12 = i14 + 20 | 0;
 HEAP32[i12 >> 2] = -25165825;
 if (!i1) return;
 i13 = i14 + 12 | 0;
 f3 = Math_fround(8507058669999999534545717.0e13);
 f4 = Math_fround(8507058669999999534545717.0e13);
 f5 = Math_fround(8507058669999999534545717.0e13);
 f6 = Math_fround(-8507058669999999534545717.0e13);
 f7 = Math_fround(-8507058669999999534545717.0e13);
 f8 = Math_fround(-8507058669999999534545717.0e13);
 while (1) {
  i1 = i1 + -1 | 0;
  f15 = Math_fround(HEAPF32[i2 >> 2]);
  f3 = f3 < f15 ? f3 : f15;
  i17 = i2 + 4 | 0;
  f15 = Math_fround(HEAPF32[i17 >> 2]);
  f4 = f4 < f15 ? f4 : f15;
  i16 = i2 + 8 | 0;
  f15 = Math_fround(HEAPF32[i16 >> 2]);
  f5 = f5 < f15 ? f5 : f15;
  HEAPF32[i14 >> 2] = f3;
  HEAPF32[i9 >> 2] = f4;
  HEAPF32[i10 >> 2] = f5;
  f15 = Math_fround(HEAPF32[i2 >> 2]);
  f6 = f6 > f15 ? f6 : f15;
  f15 = Math_fround(HEAPF32[i17 >> 2]);
  f7 = f7 > f15 ? f7 : f15;
  f15 = Math_fround(HEAPF32[i16 >> 2]);
  f8 = f8 > f15 ? f8 : f15;
  HEAPF32[i13 >> 2] = f6;
  HEAPF32[i11 >> 2] = f7;
  HEAPF32[i12 >> 2] = f8;
  if (!i1) break; else i2 = i2 + 12 | 0;
 }
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN14SphereCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i2 + 8 | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 4 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i4 = i1 + 36 | 0;
 i11 = HEAP32[i4 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 40 >> 2] | 0, i11 | 0, i3 | 0) | 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f8 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f7 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 i10 = f6 < Math_fround(0.0);
 f9 = Math_fround(-f6);
 f6 = i10 ? f9 : f6;
 i10 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i10 ? f9 : f8;
 i10 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 f7 = i10 ? f9 : f7;
 f6 = f6 < f8 ? f8 : f6;
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * (f6 < f7 ? f7 : f6));
 i1 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i1 ? f7 : f6;
 i1 = f6 < Math_fround(9.99999974e-06);
 HEAPF32[i5 >> 2] = i1 ? Math_fround(9.99999974e-06) : f6;
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4); else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i5);
 i1 = i6 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 2 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 2);
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 14 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 15 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  return;
 }
}

function __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, _llvm_bswap_i32(i1 | 0) | 0, i6 + 8 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1 + (i4 * 80 | 0) | 0;
 if (i4 | 0) do {
  __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i6);
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i5 + 20 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i6, i5 + 40 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i5 + 60 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i6, i5 + 80 | 0, 0);
 STACKTOP = i7;
 return;
}

function __Z39ParticleSystemRenderer_CUSTOM_SetMeshesP12Il2CppObjectP11Il2CppArrayi(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0;
 i3 = (i2 | 0) < 0 | i3 >>> 0 < i2 >>> 0 ? i3 : i2;
 i5 = (i3 | 0) > 4 ? 4 : i3;
 L1 : do if ((i3 | 0) > 0) {
  if (!i1) {
   __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i6, 0) | 0;
   i3 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
  } else i4 = 0;
  while (1) {
   i2 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i6, i4) | 0;
   i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
   if (!i3) {
    i2 = i1;
    break;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i3 + 552 + (i4 << 2) >> 2] = i2;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i5 | 0)) break L1;
  }
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } while (0);
 if ((i5 | 0) >= 4) return;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else i7 = i5;
 while (1) {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i2) {
   i2 = 13;
   break;
  }
  HEAP32[i2 + 552 + (i7 << 2) >> 2] = 0;
  i7 = i7 + 1 | 0;
  if ((i7 | 0) >= 4) {
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) return; else if ((i2 | 0) == 13) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __ZN5physx3Scb14ParticleSystem12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i8, i6, i5, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i1 = i10;
 i3 = HEAP32[i8 + 152 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 if (!i4) {
  i2 = i3 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i3 + 73 | 0; else {
   i12 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i11 = i3 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 699641;
   HEAP32[i1 + 4 >> 2] = i11;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i12, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i11;
  }
  _strncpy(i1, gb + 699641 | 0, 128) | 0;
  HEAP8[i3 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 switch ((HEAP32[i8 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 9; else i1 = 8;
   break;
  }
 default:
  i1 = 9;
 }
 if ((i1 | 0) == 8) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 148, gb + 699279 | 0, i9); else if ((i1 | 0) == 9) __ZN5physx2Sc18ParticleSystemCore12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i8 + 12 | 0, i6, i5, i7);
 if (i4) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj556ENS_22PxRepXPropertyAccessorILj556ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 80; else i1 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN4Mesh25CreateCustomFormatChannelE13ShaderChannel19VertexChannelFormati(i6, i5, i1, i2) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i8 = i10 + 32 | 0;
 i9 = i10;
 i3 = i8;
 i4 = i3 + 16 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i4 = i8 + (i5 << 1) | 0;
 i2 = (i2 & 65535) << 8 & 65535 | i1 & 255;
 HEAP8[i4 >> 0] = i2;
 HEAP8[i4 + 1 >> 0] = i2 >> 8;
 i4 = HEAP32[i6 + 32 >> 2] | 0;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i4 + 100 >> 2] | 0;
 i1 = 1 << i5;
 if (!(HEAP32[i4 + 176 >> 2] | 0)) if ((HEAP32[i6 + 116 >> 2] | 0) == (HEAP32[i6 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i7, i2);
  HEAP32[i7 >> 2] = (HEAP32[i7 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i7 + 8 >> 2] & ~HEAP32[i7 + 12 >> 2];
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i9 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i2, i3, i1, 0, i9, i8);
  STACKTOP = i10;
  return;
 };
 HEAP32[i9 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i2, i3, i1, 0, i9, i8);
 STACKTOP = i10;
 return;
}

function __ZN31CanvasBatchIntermediateRenderer11AddSubBatchERK16DrawBuffersRangePK19ShaderPropertySheet(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = i2 + 300 | 0;
 i6 = i2 + 312 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i2 + 316 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i10 & 2147483647;
 do if (i8 >>> 0 > i11 >>> 0) {
  i1 = i10 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i11 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 * 36 | 0, 4, i2 + 304 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 4, i2 + 304 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 36 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 i11 = HEAP32[i5 >> 2] | 0;
 i10 = i11 + (i7 * 36 | 0) | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 i10 = i4 + 4 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 HEAP32[i11 + (i7 * 36 | 0) + 32 >> 2] = i4;
 return;
}

function __ZN18AwakeFromLoadQueue19DetermineQueueIndexEPKN5Unity4TypeER6Object(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = __ZNK21ExecutionOrderManager30GetCustomAwakeFromLoadQueueForEPKN5Unity4TypeE(__Z24GetExecutionOrderManagerv() | 0, i3) | 0;
 if ((i1 | 0) != 14) {
  i3 = i1;
  return i3 | 0;
 }
 i1 = HEAP32[i3 + 24 >> 2] | 0;
 if ((i1 - (HEAP32[gb + 28940 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28940 + 28 >> 2] | 0) >>> 0) {
  i3 = 2;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 27592 | 0)) {
  i3 = 13;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 28900 | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 66968 | 0)) {
  i3 = 6;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 67008 | 0)) {
  i3 = 12;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 67048 | 0) | (i3 | 0) == (gb + 67088 | 0)) {
  i3 = 9;
  return i3 | 0;
 }
 if ((i1 - (HEAP32[gb + 32588 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32588 + 28 >> 2] | 0) >>> 0) {
  i3 = 10;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 67128 | 0)) {
  i3 = 8;
  return i3 | 0;
 }
 if ((i1 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
  i3 = 11;
  return i3 | 0;
 }
 if ((i1 - (HEAP32[gb + 28608 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28608 + 28 >> 2] | 0) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 30792 | 0)) {
  i3 = 5;
  return i3 | 0;
 }
 if ((i3 | 0) == (gb + 31552 | 0)) {
  i3 = 4;
  return i3 | 0;
 }
 i3 = (i1 - (HEAP32[gb + 26572 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 26572 + 28 >> 2] | 0) >>> 0 ? 3 : 7;
 return i3 | 0;
}

function __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 92 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i1 = i6 + 76 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 5, 16, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 5, 16, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 5 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 5) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i10 = i3 + (i1 << 5) | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i9 + 20 >> 2];
  HEAP32[i10 + 24 >> 2] = HEAP32[i9 + 24 >> 2];
  HEAP32[i10 + 28 >> 2] = HEAP32[i9 + 28 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13RenderTexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i1, 16, gb + 1048932 | 0, 0, gb + 409951 | 0, 23) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 44300 + 8;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 2;
 HEAP32[i4 + 104 >> 2] = 2;
 HEAP32[i4 + 108 >> 2] = 2;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP8[i4 + 116 >> 0] = 0;
 HEAP8[i4 + 117 >> 0] = 1;
 i2 = i4 + 118 | 0;
 HEAP16[i2 >> 1] = 0;
 HEAP16[i2 + 2 >> 1] = 0;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAP8[i4 + 123 >> 0] = 1;
 i2 = i4 + 124 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 152 >> 2] = i4;
 HEAP32[i4 + 80 >> 2] = 256;
 HEAP32[i4 + 84 >> 2] = 256;
 HEAP32[i4 + 92 >> 2] = 1;
 HEAP32[i4 + 88 >> 2] = 1;
 HEAP32[i4 + 44 >> 2] = 1;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i4 + 156 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES20SetRenderSurfaceNameEP17RenderSurfaceBasePKc(i1, i2, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 124 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 if (__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(i2) | 0) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = i1 + 4620 | 0;
 if (!i3) {
  __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i6, 8, HEAP32[i2 + 36 >> 2] | 0, 0, i7);
  STACKTOP = i8;
  return;
 }
 HEAP32[i5 >> 2] = i3;
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i4, i1, i5);
  i2 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i5 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i5 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i6, 7, HEAP32[i1 >> 2] | 0, 0, i7);
 STACKTOP = i8;
 return;
}

function __ZN12AudioManager22CreateFMODSoundFromWWWEP10IWWWStream15FMOD_SOUND_TYPE17FMOD_SOUND_FORMATjjbbP10SampleClip(i10, i1, i3, i4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 136 | 0;
 i2 = i12;
 if (!(HEAP32[i10 + 88 >> 2] | 0)) {
  i11 = 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 HEAP32[i11 >> 2] = 0;
 _memset(i2 + 4 | 0, 0, 132) | 0;
 HEAP32[i2 >> 2] = 136;
 HEAP32[i2 + 24 >> 2] = 16384;
 HEAP32[i2 + 72 >> 2] = i3;
 HEAP32[i2 + 20 >> 2] = i4;
 HEAP32[i2 + 16 >> 2] = i5;
 HEAP32[i2 + 12 >> 2] = i6;
 HEAP32[i2 + 76 >> 2] = fb + 158;
 HEAP32[i2 + 80 >> 2] = fb + 920;
 HEAP32[i2 + 84 >> 2] = fb + 159;
 HEAP32[i2 + 88 >> 2] = fb + 429;
 HEAP32[i2 + 68 >> 2] = i1;
 i7 = (i7 ? 128 : i8 ? 512 : 256) | ((i3 | 0) == 13 ? 32849 : 33554513);
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb((i9 | 0) == 0 ? HEAP32[gb + 1459924 >> 2] | 0 : i9, 0, 0) | 0;
 i1 = __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i11, i1, (i3 | 0) == 16 ? i7 | 4096 : i7, i9, 0, 0, i2) | 0;
 if (i8) __Z19pop_allocation_rootv();
 if (!i1) i1 = HEAP32[i11 >> 2] | 0; else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i10 + 180 | 0, __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0) | 0;
  HEAP32[i10 + 192 >> 2] = i1;
  i1 = 0;
 }
 i11 = i1;
 STACKTOP = i12;
 return i11 | 0;
}

function __Z30LoadNamedObjectFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObject(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i12 = i7 + 8 | 0;
 i6 = i7 + 24 | 0;
 i9 = i7;
 __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i2, i1);
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i12;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i12);
 i12 = i8;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i4;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb(i2, i8, i5, i6, 1);
 if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function _UNITY_FT_Done_GlyphSlot(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (!i8) return;
 i6 = i8 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i4 + 96 >> 2] | 0;
 i9 = HEAP32[i5 + 8 >> 2] | 0;
 i4 = i4 + 84 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return; else {
  i3 = 0;
  i2 = i1;
 }
 while (1) {
  if ((i2 | 0) == (i8 | 0)) break;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) {
   i7 = 21;
   break;
  } else {
   i3 = i2;
   i2 = i1;
  }
 }
 if ((i7 | 0) == 21) return;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 if (!i3) HEAP32[i4 >> 2] = i1; else HEAP32[i3 + 8 >> 2] = i1;
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 if (!i1) {
  i2 = i5;
  i4 = i9;
 } else {
  mftCall_vi(i1 | 0, i8 | 0);
  i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0;
  i2 = i4;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
 }
 i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 68 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i8 | 0);
 i3 = i8 + 156 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i7 = 14; else if (!(HEAP32[i1 + 4 >> 2] & 1)) i7 = 14; else {
  i1 = i8 + 88 | 0;
  _UNITY_ft_mem_free(HEAP32[(HEAP32[i6 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -2;
 }
 if ((i7 | 0) == 14) HEAP32[i8 + 88 >> 2] = 0;
 if (i1 | 0) {
  if (!(HEAP32[HEAP32[i2 >> 2] >> 2] & 512)) {
   _UNITY_FT_GlyphLoader_Done(HEAP32[i1 >> 2] | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 >> 2] = 0;
  }
  _UNITY_ft_mem_free(i4, i1);
  HEAP32[i3 >> 2] = 0;
 }
 _UNITY_ft_mem_free(i9, i8);
 return;
}

function __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = i8 + 8 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = i6;
 if ((((HEAP32[i9 >> 2] | 0) - i6 | 0) / 40 | 0) >>> 0 >= i4 >>> 0) return;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 40 | 0) | 0;
 i2 = i5 + (((i2 - i6 | 0) / 40 | 0) * 40 | 0) | 0;
 i7 = i2;
 i5 = i5 + (i4 * 40 | 0) | 0;
 if ((i3 | 0) == (i1 | 0)) i4 = i7; else {
  i4 = i7;
  do {
   i6 = i2 + -40 | 0;
   i11 = i3;
   i3 = i3 + -40 | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 + -20 >> 2] = 0;
   i14 = i11 + -16 | 0;
   i13 = HEAP32[i14 + 4 >> 2] | 0;
   i12 = i2 + -16 | 0;
   HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
   HEAP32[i12 + 4 >> 2] = i13;
   HEAP8[i2 + -36 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i6, i3);
   i6 = i2 + -8 | 0;
   i11 = i11 + -8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
   HEAP8[i6 + 4 >> 0] = HEAP8[i11 + 4 >> 0] | 0;
   i2 = i4 + -40 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i9 >> 2] = i5;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -40 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -36 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -16 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i6) return;
 __ZdlPv(i6);
 return;
}

function __ZNSt3__211__libcpp_db15__iterator_copyEPvPKv(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i3, i4) | 0;
 i2 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i3, i2) | 0;
 if (!i2) {
  i2 = 0;
  i5 = 5;
 } else {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) {
   __THREW__ = 0;
   i1 = invoke_iii(fb + 1144 | 0, i3 | 0, i4 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else i5 = 5;
  } else i5 = 6;
 }
 if ((i5 | 0) == 5) if (!i1) {
  i4 = 0;
  i3 = 0;
  i1 = 0;
  i5 = 7;
 } else i5 = 6;
 if ((i5 | 0) == 6) {
  i4 = i1;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = 1;
  i5 = 7;
 }
 L9 : do if ((i5 | 0) == 7) {
  do if ((i3 | 0) != (i2 | 0)) {
   if (!i3) i5 = 11; else {
    __THREW__ = 0;
    invoke_vii(fb + 4498 | 0, i3 | 0, i4 | 0);
    i3 = __THREW__;
    __THREW__ = 0;
    if (!(i3 & 1)) i5 = 11;
   }
   if ((i5 | 0) == 11) {
    if (!i1) break;
    i1 = i4 + 8 | 0;
    HEAP32[i1 >> 2] = 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = i2;
    __THREW__ = 0;
    invoke_vii(fb + 4497 | 0, i2 | 0, i4 | 0);
    i5 = __THREW__;
    __THREW__ = 0;
    if (!(i5 & 1)) break;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   break L9;
  } while (0);
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  return;
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 660329 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 144; else i1 = (HEAP32[i1 >> 2] | 0) + 144 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEE14handleAccessorILj681ENS_22PxRepXPropertyAccessorILj681ES4_KNS_30PxVehicleDriveTankControlModel4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 208; else i1 = (HEAP32[i1 >> 2] | 0) + 208 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 834971 | 0)) i1 = 0; else {
  i3 = gb + 834971 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 166984 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 166984 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN14PreloadManager22ProcessSingleOperationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 i4 = __ZN14PreloadManager33PrepareProcessingPreloadOperationEv(i1) | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 d8 = +_emscripten_get_now() * 1.0e6;
 i7 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i5 = i4 + 32 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = ~~d8 >>> 0;
 HEAP32[i1 + 4 >> 2] = i7;
 if ((HEAP16[gb + 1163180 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163180 | 0, i2);
  i1 = gb + 1163180 | 0;
 } else i1 = 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i3 = i5;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 d8 = +_emscripten_get_now() * 1.0e6;
 i3 = _i64Subtract(~~d8 >>> 0 | 0, (+Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i5 | 0, i3 | 0) | 0;
 i5 = getTempRet0() | 0;
 i7 = i4 + 48 | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i5;
 mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0) | 0;
 HEAP32[i4 + 24 >> 2] = 1;
 STACKTOP = i6;
 return;
}

function __ZN10SampleClip7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(128, i1, 16, gb + 1048932 | 0, 0, gb + 870427 | 0, 97) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 170392 + 8;
 i2 = i4 + 32 | 0;
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 __ZN11SoundHandleC2Ev(i4 + 56 | 0);
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP8[i4 + 64 >> 0] = 1;
 HEAP8[i4 + 65 >> 0] = 0;
 HEAP8[i4 + 66 >> 0] = 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = i4;
 HEAP32[i4 + 120 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z38Gradient_CUSTOM_INTERNAL_CALL_EvaluateP12Il2CppObjectfR10ColorRGBAf(i1, f2, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i3 = i7 + 24 | 0;
 i4 = i7 + 8 | 0;
 i8 = f2 < Math_fround(0.0);
 i9 = f2 > Math_fround(1.0);
 f2 = i9 ? Math_fround(1.0) : f2;
 f2 = i8 ? Math_fround(0.0) : f2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 if (!(HEAP32[i1 + 68 >> 2] | 0)) {
  HEAPF32[i3 + 12 >> 2] = f2;
  HEAPF32[i3 + 8 >> 2] = f2;
  HEAPF32[i3 + 4 >> 2] = f2;
  HEAPF32[i3 >> 2] = f2;
  __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E(i4, i1, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAPF32[i3 + 12 >> 2] = f2;
  HEAPF32[i3 + 8 >> 2] = f2;
  HEAPF32[i3 + 4 >> 2] = f2;
  HEAPF32[i3 >> 2] = f2;
  __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E(i4, i1, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 f11 = Math_fround(Math_fround((i1 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f10 = Math_fround(Math_fround(i1 >>> 16 & 255) / Math_fround(255.0));
 f2 = Math_fround(Math_fround(i1 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(i1 & 255) / Math_fround(255.0));
 HEAPF32[i6 + 4 >> 2] = f11;
 HEAPF32[i6 + 8 >> 2] = f10;
 HEAPF32[i6 + 12 >> 2] = f2;
 STACKTOP = i7;
 return;
}

function __Z17dynamic_pptr_castIP17BillboardRenderer8RendererET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29752 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29752 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj555ENS_22PxRepXPropertyAccessorILj555ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj554ENS_22PxRepXPropertyAccessorILj554ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sn9StrToImplINS_18PxClothFabricPhaseEE5strtoERS2_RPKc(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 512 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) {
  if (_isspace(HEAPU8[i1 >> 0] | 0) | 0) do {
   i4 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
   HEAP32[i8 >> 2] = i4;
  } while ((_isspace(HEAPU8[i4 >> 0] | 0) | 0) != 0);
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i4 = i5 + 511 | 0;
   i1 = HEAP8[i1 >> 0] | 0;
   L8 : do if (!(i1 << 24 >> 24)) i1 = i5; else {
    i2 = i1;
    i3 = i5;
    while (1) {
     if (!(i3 >>> 0 < i4 >>> 0 & (_isspace(i2 & 255) | 0) == 0)) {
      i1 = i3;
      break L8;
     }
     i2 = HEAP32[i8 >> 2] | 0;
     HEAP32[i8 >> 2] = i2 + 1;
     i1 = i3 + 1 | 0;
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     i2 = HEAP8[HEAP32[i8 >> 2] >> 0] | 0;
     if (!(i2 << 24 >> 24)) break; else i3 = i1;
    }
   } while (0);
   HEAP8[i1 >> 0] = 0;
  }
 }
 i1 = HEAP32[gb + 90072 >> 2] | 0;
 if (!i1) {
  i7 = i7 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i8 = _strtoul(i5, i8, 10) | 0;
  HEAP32[i7 >> 2] = i8;
  STACKTOP = i6;
  return;
 }
 i2 = gb + 90072 | 0;
 do {
  if (!(_strcasecmp(i5, i1) | 0)) {
   i4 = i7;
   HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 4 >> 2] = 0;
  }
  i2 = i2 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i7 = i7 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i8 = _strtoul(i5, i8, 10) | 0;
 HEAP32[i7 >> 2] = i8;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEj(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i6 + 8 | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, 0) | 0;
 i3 = i6 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i7, i2);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i7);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i6 + 16 >> 2] | 0, i7);
 i7 = i6 + 32 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = i3 + 36 | 0;
 i5 = i3 + 42 | 0;
 i1 = HEAP16[i5 >> 1] | 0;
 i4 = i3 + 40 | 0;
 if (i1 << 16 >> 16 == (HEAP16[i4 >> 1] | 0)) {
  __ZN5physx2Sc19ParticlePacketShape19reallocInteractionsERPPNS0_35ParticleElementRbElementInteractionERttt(i3, i2, i4, i1, (i1 & 65535) + 1 & 65535);
  i1 = HEAP16[i5 >> 1] | 0;
 }
 i4 = i1 + 1 << 16 >> 16;
 HEAP16[i5 >> 1] = i4;
 HEAP32[(HEAP32[i2 >> 2] | 0) + ((i1 & 65535) << 2) >> 2] = i6;
 HEAP16[i6 + 44 >> 1] = (i4 & 65535) + 65535;
 i2 = i6 + 46 | 0;
 HEAP8[i2 >> 0] = 0;
 if (HEAP8[(HEAP32[i6 + 40 >> 2] | 0) + 19 >> 0] | 0) return;
 i1 = i6 + 36 | 0;
 if (HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0) + 64 >> 0] & 4) return;
 i6 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i7 >> 2] | 0) | 0;
 __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj(i6, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0, i8);
 HEAP8[i2 >> 0] = 1;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i10, i4, i1) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i7 >> 2] = i3;
  i1 = i6;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, i1, i10 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i4 + 12 >> 2] | 0;
 i6 = i1 + (i5 * 24 | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i10);
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  if (i4 >>> 0 > i5 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i7 >> 2] = i4;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i5 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __Z41BillboardAsset_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
 i2 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 + 60 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 8, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 i2 = 0;
 while (1) {
  i9 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
  HEAP32[i5 >> 2] = i9;
  HEAP32[i5 + 4 >> 2] = i8;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 8 | 0;
 }
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = i7 + 12 | 0;
 HEAP32[i9 >> 2] = i8;
 i9 = i7 + 16 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i8 = i8 + 1 | 0;
 HEAP32[i9 >> 2] = i8;
 return;
}

function __Z19TransferField_ArrayI9JSONWrite16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN12NativeBufferI16Converter_StringE15SetupForWritingER9ArrayInfo(i7, HEAP32[i3 + 24 >> 2] | 0);
 __ZN9JSONWrite8TransferINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i1, i7, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__214__split_bufferIP18ReflectionProbeJobNS_9allocatorIS2_EEE10push_frontERKS2_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i9 + 4 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i12;
 do if ((i11 | 0) == (i12 | 0)) {
  i12 = i9 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = i8;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2;
   i5 = ((i1 - i3 >> 2) + 1 | 0) / 2 | 0;
   i1 = i2 + (i5 << 2) | 0;
   i3 = i3 - i11 | 0;
   i10 = i3 >> 2;
   i4 = i1 + (0 - i10 << 2) | 0;
   if (i10) {
    _memmove(i4 | 0, i11 | 0, i3 | 0) | 0;
    i1 = i4;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i12 >> 2] = i2 + (i5 << 2);
   break;
  }
  i8 = i1 - i3 >> 1;
  i8 = (i8 | 0) == 0 ? 1 : i8;
  i5 = __Znwj(i8 << 2) | 0;
  i6 = i5;
  i1 = i5 + ((i8 + 3 | 0) >>> 2 << 2) | 0;
  i7 = i1;
  i8 = i5 + (i8 << 2) | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i3 = i7;
   i2 = i11;
  } else {
   i5 = i1;
   i3 = i7;
   i4 = i11;
   do {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i3 + 4 | 0;
    i3 = i5;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i6;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i8;
  if (i2) {
   __ZdlPv(i2);
   i1 = HEAP32[i14 >> 2] | 0;
  }
 } else i1 = i11; while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15VectorParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei(i5, i1, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i12 = i4 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i12 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i5 + 11 >> 0] = i4;
  if (!i4) i1 = i5; else {
   i1 = i5;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i12 = i4 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i5 + 4 >> 2] = i4;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i5 + 16 >> 2] = -1;
 HEAP32[i5 + 20 >> 2] = i6;
 HEAP32[i5 + 24 >> 2] = i7;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP8[i5 + 32 >> 0] = i9;
 STACKTOP = i11;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram15MatrixParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei(i5, i1, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i12 = i4 << 24 >> 24 < 0;
 i3 = i12 ? HEAP32[i1 >> 2] | 0 : i1;
 i4 = i12 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 12 >> 2] = i1;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  i10 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i5 + 11 >> 0] = i4;
  if (!i4) i1 = i5; else {
   i1 = i5;
   i10 = 6;
  }
 } else i10 = 4;
 if ((i10 | 0) == 4) {
  i12 = i4 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 8 >> 2] = i12 | -2147483648;
  HEAP32[i5 + 4 >> 2] = i4;
  i10 = 6;
 }
 if ((i10 | 0) == 6) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i5 + 16 >> 2] = -1;
 HEAP32[i5 + 20 >> 2] = i6;
 HEAP32[i5 + 24 >> 2] = i7;
 HEAP32[i5 + 28 >> 2] = i8;
 HEAP8[i5 + 32 >> 0] = i9;
 STACKTOP = i11;
 return;
}

function __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEERS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = i5 + 24 | 0;
 i3 = i5 + 8 | 0;
 i9 = i5 + 20 | 0;
 i8 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignINS_11__wrap_iterIPK8UnityStrEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISG_E9referenceEEE5valueEvE4typeESG_SG_(i3, i7, i6);
 __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i3, i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i9 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i9;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj401ENS_22PxRepXPropertyAccessorILj401ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj400ENS_22PxRepXPropertyAccessorILj400ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj568ENS_22PxRepXPropertyAccessorILj568ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj567ENS_22PxRepXPropertyAccessorILj567ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj546ENS_22PxRepXPropertyAccessorILj546ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj545ENS_22PxRepXPropertyAccessorILj545ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj544ENS_22PxRepXPropertyAccessorILj544ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx20PxsParticleSystemSim18packetShapesUpdateEPNS_10PxBaseTaskE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 i2 = i4 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 i3 = i4 + 36 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i5 = (HEAP32[i1 + 8 >> 2] << 2) + 19 | 0;
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i6 | 0, i5 | 0, (i1 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 769032 | 0, 150) | 0;
  if (!i1) i1 = 0; else {
   i7 = i1 + 19 & -16;
   HEAP32[i7 + -4 >> 2] = i7 - i1;
   i1 = i7;
  }
  HEAP32[i3 >> 2] = i1;
 }
 if (!(HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + 20 >> 2] & 65536)) {
  i1 = i4 + 1156 | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 } else {
  i7 = i4 + 1156 | 0;
  HEAP32[i4 + 1284 >> 2] = 1;
  i1 = i4 + 1280 | 0;
  HEAP32[i1 >> 2] = i7;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
  HEAP32[i4 + 1276 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
  i1 = i4 + 1268 | 0;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 __ZN5physx19PxsFluidSpatialHash16updatePacketHashERjPjPNS_16PxsFluidParticleERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjPNS_10PxBaseTaskE(HEAP32[i4 + 72 >> 2] | 0, i4 + 40 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 + 48 >> 2] | 0, i7 + 56 | 0, HEAP32[i7 + 16 >> 2] | 0, i1);
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1 << 4);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1 << 3);
 STACKTOP = i8;
 return;
}

function __ZL17Transfer_GUIStyleI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 256 | 0;
 i3 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 HEAP32[i6 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i6);
 if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 128 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (i1 | 0) {
  i2 = __Z9GetIIMGUIv() | 0;
  __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i3, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0, gb + 1034525 | 0, 1);
  if (HEAP32[i3 >> 2] | 0) {
   i8 = i3;
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i1, i6);
   HEAP32[i6 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
  }
 }
 STACKTOP = i7;
 return;
}

function ___fgetwc_unlocked(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i7 = i10 + 8 | 0;
 i8 = i10 + 12 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = i3 + 74 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = i1 + 1 | i1;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if (i1 >>> 0 < i2 >>> 0) {
  i1 = _mbrtowc(i7, i1, i2 - i1 | 0, i4) | 0;
  if (i1 >>> 0 < 4294967294) {
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + (((i1 | 0) == 0 & 1) + i1);
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  }
  if ((i1 | 0) == -1) {
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   i1 = -1;
  } else {
   i1 = -2;
   i9 = 6;
  }
 } else {
  i1 = -2;
  i9 = 6;
 } while (0);
 L7 : do if ((i9 | 0) == 6) {
  while (1) {
   i9 = 0;
   if ((i1 | 0) != -2) {
    i9 = 13;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
    HEAP32[i5 >> 2] = i1 + 1;
    HEAP8[i8 >> 0] = HEAP8[i1 >> 0] | 0;
   } else {
    i2 = ___uflow(i3) | 0;
    HEAP8[i8 >> 0] = i2;
    if ((i2 | 0) < 0) break;
   }
   i1 = _mbrtowc(i7, i8, 1, i4) | 0;
   if ((i1 | 0) == -1) {
    i1 = -1;
    break L7;
   } else i9 = 6;
  }
  if ((i9 | 0) == 13) {
   i1 = HEAP32[i7 >> 2] | 0;
   break;
  }
  if (!(_mbsinit(i4) | 0)) {
   HEAP32[(___errno_location() | 0) >> 2] = 84;
   i1 = -1;
  } else i1 = -1;
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i3 << 24 >> 24 < 0;
 i4 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 + 12 >> 2] = i1;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
  i1 = HEAP32[i5 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i5 + 11 >> 0] = i3;
  if (!i3) i1 = i5; else {
   i1 = i5;
   i7 = 6;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i3 + 16 & -16;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i5 + 4 >> 2] = i3;
  i7 = 6;
 }
 if ((i7 | 0) == 6) _memcpy(i1 | 0, i4 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 HEAP32[i5 + 16 >> 2] = -1;
 i9 = i5 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = i6;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 80; else i1 = (HEAP32[i1 >> 2] | 0) + 80 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc8ClothSim22removeCollisionCapsuleEPKNS0_8ShapeSimE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i15 + 8 | 0;
 i9 = i15;
 i10 = HEAP32[i6 + 52 >> 2] | 0;
 i11 = HEAP32[i6 + 84 >> 2] | 0;
 i12 = i6 + 116 | 0;
 i7 = HEAP32[i12 >> 2] | 0;
 i13 = i6 + 88 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 if (!i14) {
  STACKTOP = i15;
  return;
 } else i4 = 0;
 while (1) {
  i3 = i4 + i11 | 0;
  i2 = i7 + (i3 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break;
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i14 >>> 0) {
   i5 = 8;
   break;
  }
 }
 if ((i5 | 0) == 8) {
  STACKTOP = i15;
  return;
 }
 i1 = i3 + 1 | 0;
 i5 = i6 + 120 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 < i6 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i7 + (i1 << 2) >> 2];
  i1 = i3 + 2 | 0;
  if (i1 >>> 0 < i6 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 HEAP32[i5 >> 2] = i6 + -1;
 HEAP32[i13 >> 2] = i14 + -1;
 i14 = (HEAP32[i10 + 72 >> 2] | 0) + (i4 << 1) + i11 | 0;
 i13 = HEAP32[i10 + 28 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 mftCall_viiii(i12 | 0, i13 | 0, i8 | 0, i14 | 0, i14 + 2 | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx16PxsIslandManager23updateIslandsSecondPassERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 332 | 0;
 i4 = i5 + 348 | 0;
 i2 = i5 + 352 | 0;
 __ZN5physx27updateIslandsSecondPassMainEjRNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjjRNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS0_13EventProfilerE(HEAP32[i5 >> 2] | 0, i1, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, i5 + 12 | 0, i5 + 280 | 0, i5 + 372 | 0, i5 + 420 | 0, i5 + 480 | 0, i5 + 632 | 0, HEAP32[i5 + 8 >> 2] | 0);
 HEAP32[i5 + 336 >> 2] = 0;
 HEAP32[i5 + 344 >> 2] = 0;
 HEAP32[i5 + 360 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i5 + 364 | 0;
 i2 = i5 + 368 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= (HEAP32[i2 >> 2] | 0) >>> 0) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i9 = i5 + 340 | 0;
 HEAP32[i9 >> 2] = 0;
 i8 = i5 + 356 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6 + 1 | 0, HEAP32[i2 >> 2] << 4, gb + 681489 | 0, 1546) | 0;
 HEAP32[i3 >> 2] = i7;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = i7 + (i5 << 2);
 HEAP32[i8 >> 2] = i7 + (i5 * 3 << 2);
 HEAP32[i4 >> 2] = i7 + (i5 << 1 << 2);
 HEAP32[i1 >> 2] = i5;
 STACKTOP = i6;
 return;
}

function __ZN5Unity5Joint16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67048 | 0) | 0;
 i4 = i1 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 }
 if ((i1 | 0) != (i6 | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8UnityStr4PPtrI6ObjectEEEEEvRT_PKc17TransferMetaFlags(i11, i12, i1, i2) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = i12 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i7 = i12 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i8 = i11 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i9 = i11 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i12 >> 2] | 0 : i12;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (!i7) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
  i12 = i12 + 16 | 0;
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i11);
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i11);
 i12 = i12 + 16 | 0;
 __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i12, i11);
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i3 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 * 12 | 0, 4) | 0;
  i2 = i3 + (i2 * 12 | 0) | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i1 = i3;
   do {
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 10;
    HEAP32[i1 + 8 >> 2] = 0;
    i1 = i1 + 12 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  HEAP32[i4 >> 2] = i3 | 0 ? i3 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i6 * 12 | 0) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim13ValueConstantEEEvRT_PKc17TransferMetaFlags(i8, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN17AudioReverbFilter15SetReverbPresetEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 HEAP32[i1 + 104 >> 2] = i2;
 if ((i2 | 0) >= 27) {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 120 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(i2 | 0, i1 | 0);
  return;
 }
 i13 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 16 >> 2] | 0;
 i4 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 20 >> 2] | 0;
 i12 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 24 >> 2] | 0;
 i11 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 28 >> 2] | 0;
 i10 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 36 >> 2] | 0;
 i9 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 44 >> 2] | 0;
 i8 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 48 >> 2] | 0;
 i5 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 60 >> 2] | 0;
 i3 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 64 >> 2] | 0;
 i7 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 68 >> 2] | 0;
 i6 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 72 >> 2] | 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(HEAP32[gb + 171848 + (i2 * 80 | 0) + 12 >> 2] | 0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(i13 | 0);
 HEAP32[i1 + 60 >> 2] = i12;
 HEAP32[i1 + 64 >> 2] = i11;
 HEAPF32[i1 + 68 >> 2] = Math_fround(i10 | 0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(i9 | 0);
 HEAP32[i1 + 80 >> 2] = i8;
 HEAP32[i1 + 84 >> 2] = i7;
 HEAP32[i1 + 88 >> 2] = i6;
 HEAP32[i1 + 92 >> 2] = i5;
 HEAPF32[i1 + 96 >> 2] = Math_fround(i4 | 0);
 HEAP32[i1 + 100 >> 2] = i3;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = i2 + 120 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __Z17dynamic_pptr_castIP16LevelGameManager6ObjectET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28456 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28456 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (((i3 - i1 | 0) / 36 | 0) >>> 0 >= i2 >>> 0) {
  do {
   i3 = i1 + 36 | 0;
   do {
    HEAP32[i1 >> 2] = 0;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) < (i3 | 0));
   i1 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = ((i1 - i4 | 0) / 36 | 0) + i2 | 0;
 if (i5 >>> 0 > 119304647) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = (i3 - i4 | 0) / 36 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 59652323 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 119304647;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 * 36 | 0) | 0;
 i6 = i5 + (((i1 - i4 | 0) / 36 | 0) * 36 | 0) | 0;
 i5 = i5 + (i3 * 36 | 0) | 0;
 i1 = i6;
 i4 = i6;
 do {
  i3 = i1 + 36 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i1 = i4 + 36 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (((i3 | 0) / -36 | 0) * 36 | 0) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = i4 + 4 | 0;
 if ((i1 | 0) == (i10 | 0)) return;
 i8 = HEAP32[i9 >> 2] | 0;
 do {
  i7 = i1;
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i8;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  i3 = i8 + 8 | 0;
  i4 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  i7 = i8 + 12 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  i6 = i1 + 12 | 0;
  i2 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = (i2 | 0) / 96 | 0;
  if (i2 | 0) {
   if (i5 >>> 0 > 44739242) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i3);
   i2 = __Znwj(i2) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 + 16 >> 2] = i2 + (i5 * 96 | 0);
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   if ((i3 | 0) != (i4 | 0)) do {
    __ZN19ComputeShaderKernelC2ERKS_(i2, i3);
    i3 = i3 + 96 | 0;
    i2 = (HEAP32[i7 >> 2] | 0) + 96 | 0;
    HEAP32[i7 >> 2] = i2;
   } while ((i3 | 0) != (i4 | 0));
  }
  __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_(i8 + 20 | 0, i1 + 20 | 0);
  HEAP8[i8 + 32 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
  i1 = i1 + 36 | 0;
  i8 = (HEAP32[i9 >> 2] | 0) + 36 | 0;
  HEAP32[i9 >> 2] = i8;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i9 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = (i6 & 2147483647 | 0) == 0 ? 1 : i6 << 1;
 if (!i6) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 * 20 | 0, gb + 838004 | 0, 543) | 0;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i1 * 20 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 20 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i3 = i4 + (i1 * 20 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  i9 = HEAP32[i7 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i7 >> 2] = i8;
  i9 = i4 + (i9 * 20 | 0) | 0;
  return i9 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 >> 2] = i6;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i7 >> 2] = i8;
 i9 = i4 + (i9 * 20 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx42solveContactCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0;
 __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP16[i1 + 2 >> 1] | 0;
 i5 = i1 + (i4 & 65535) | 0;
 i6 = (HEAP8[i1 >> 0] | 0) == 7 ? 272 : 176;
 if (!(i4 << 16 >> 16)) return; else i4 = i1;
 while (1) {
  i1 = i4 + 112 | 0;
  i2 = HEAP8[i4 + 1 >> 0] | 0;
  if (i2 << 24 >> 24) {
   i3 = i2 & 255;
   i2 = 0;
   while (1) {
    i13 = i1 + 144 | 0;
    f14 = Math_fround(HEAPF32[i13 >> 2]);
    i11 = i1 + 148 | 0;
    f12 = Math_fround(HEAPF32[i11 >> 2]);
    i9 = i1 + 152 | 0;
    f10 = Math_fround(HEAPF32[i9 >> 2]);
    i7 = i1 + 156 | 0;
    f8 = Math_fround(HEAPF32[i7 >> 2]);
    i15 = f14 > Math_fround(0.0);
    f14 = i15 ? f14 : Math_fround(0.0);
    i15 = f12 > Math_fround(0.0);
    f12 = i15 ? f12 : Math_fround(0.0);
    i15 = f10 > Math_fround(0.0);
    f10 = i15 ? f10 : Math_fround(0.0);
    i15 = f8 > Math_fround(0.0);
    f8 = i15 ? f8 : Math_fround(0.0);
    HEAPF32[i13 >> 2] = f14;
    HEAPF32[i11 >> 2] = f12;
    HEAPF32[i9 >> 2] = f10;
    HEAPF32[i7 >> 2] = f8;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i6 | 0;
   }
   i1 = i4 + ((Math_imul(i3, i6) | 0) + 112) | 0;
  }
  if (i1 >>> 0 < i5 >>> 0) i4 = i1; else break;
 }
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj566ENS_22PxRepXPropertyAccessorILj566ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj565ENS_22PxRepXPropertyAccessorILj565ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj543ENS_22PxRepXPropertyAccessorILj543ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj542ENS_22PxRepXPropertyAccessorILj542ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN25TransformFeedbackSkinning31CleanupTransformFeedbackShadersEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 if (HEAP32[gb + 1451256 >> 2] | 0) __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, gb + 1451256 | 0);
 i1 = HEAP32[gb + 1451164 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 if ((i2 | 0) != (i7 | 0)) {
  i4 = i6 + 4 | 0;
  i5 = i6 + 8 | 0;
  i3 = i2;
  i1 = i2;
  while (1) {
   HEAP32[i6 >> 2] = HEAP32[i3 + 16 >> 2];
   i2 = i3 + 24 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i4);
   __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i5);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   if ((i1 | 0) == (i7 | 0)) break; else i3 = i1;
  }
  i1 = HEAP32[gb + 1451164 >> 2] | 0;
 }
 i7 = i1 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i7 >> 2] | 0);
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN16b2ContactManager7DestroyEP9b2Contact(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + 28 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i7 + 52 >> 2] | 0) + 28 >> 2] | 0;
 i1 = HEAP32[i6 + 72 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i7 + 4 >> 2] & 2 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i7 | 0);
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 i1 = i7 + 12 | 0;
 if (i2 | 0) HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = i2;
 i1 = i6 + 60 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) HEAP32[i1 >> 2] = i3;
 i2 = HEAP32[i7 + 24 >> 2] | 0;
 i1 = i7 + 28 | 0;
 if (i2 | 0) HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = i2;
 i1 = i4 + 112 | 0;
 if ((i7 + 16 | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i3;
 i2 = HEAP32[i7 + 40 >> 2] | 0;
 i1 = i7 + 44 | 0;
 if (i2 | 0) HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = i2;
 i1 = i5 + 112 | 0;
 if ((i7 + 32 | 0) != (HEAP32[i1 >> 2] | 0)) {
  i5 = i6 + 76 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator(i7, i5);
  i7 = i6 + 64 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + -1 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i5 = i6 + 76 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator(i7, i5);
 i7 = i6 + 64 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = i4 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i4 + 64 >> 2] | 0;
  if (i3) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   if ((i3 | 0) != 1) {
    i1 = 1;
    do {
     i7 = HEAP32[i2 >> 2] | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7 + (i1 * 24 | 0) + 12 | 0);
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7 + (i1 * 24 | 0) | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
   }
   i1 = HEAP32[i2 >> 2] | 0;
  }
  i7 = HEAP32[i4 + 84 >> 2] | 0;
  HEAP32[i5 >> 2] = 54;
  HEAP32[i5 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4 + 12 | 0);
 STACKTOP = i6;
 return;
}

function __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 __ZN12NativeBufferI16Converter_StringE15SetupForWritingER9ArrayInfo(i7, HEAP32[i3 + 24 >> 2] | 0);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorINS2_12basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES7_ISA_LS8_1ELi16EEEEEEvRT_17TransferMetaFlags(i1, i7, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i5 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 1;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i6);
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 132 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i1, i2 - i4 | 0);
  STACKTOP = i10;
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i3 + (i2 * 132 | 0) | 0;
 if ((i5 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 4 | 0;
 i7 = i8 + 4 | 0;
 i3 = i5;
 do {
  i2 = i3 + -132 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = i3 + -36 | 0;
  if ((HEAP32[i3 + -20 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -32 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + -116 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i3 + -104 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i6 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i3 + -120 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  i3 = HEAP32[i9 >> 2] | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx10PxSetGroupERNS_7PxActorEt(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 48 | 0;
 i6 = i8 + 32 | 0;
 i3 = i8 + 16 | 0;
 i4 = i8;
 i2 = i1 & 65535;
 switch (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0) {
 case 4:
 case 0:
 case 1:
  {
   if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0, i5 | 0) | 0)) {
    STACKTOP = i8;
    return;
   }
   i1 = 0;
   do {
    mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 108 >> 2] | 0, i5 | 0, i7 | 0, 1, i1 | 0) | 0;
    i4 = HEAP32[i7 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 80 >> 2] | 0, i6 | 0, i4 | 0);
    HEAP32[i6 >> 2] = i2;
    i4 = HEAP32[i7 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 76 >> 2] | 0, i4 | 0, i6 | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0, i5 | 0) | 0) >>> 0);
   STACKTOP = i8;
   return;
  }
 case 2:
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i3 | 0, i5 | 0);
   HEAP32[i3 >> 2] = i2;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 176 >> 2] | 0, i5 | 0, i3 | 0);
   STACKTOP = i8;
   return;
  }
 case 5:
  {
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 432 >> 2] | 0, i4 | 0, i5 | 0);
   HEAP32[i4 >> 2] = i2;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 428 >> 2] | 0, i5 | 0, i4 | 0);
   STACKTOP = i8;
   return;
  }
 default:
  {
   STACKTOP = i8;
   return;
  }
 }
}

function __ZN16LightmapSettings8TransferI17RemapPPtrTransferEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_(i8, i1);
 i2 = HEAP32[i8 + 100 >> 2] | 0;
 i4 = HEAP32[i8 + 112 >> 2] | 0;
 i3 = i2 + (i4 * 40 | 0) | 0;
 i6 = i1 + 16 | 0;
 i7 = i1 + 36 | 0;
 i5 = i1 + 40 | 0;
 if (i4 | 0) {
  i1 = i2;
  do {
   i2 = HEAP32[i6 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 40 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i8 + 36 >> 2] | 0;
 i3 = HEAP32[i8 + 48 >> 2] | 0;
 i4 = i1 + (i3 << 3) | 0;
 if (i3 | 0) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = (HEAP32[i8 + 28 >> 2] | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) return;
 HEAP32[i1 >> 2] = 1;
 HEAP8[i8 + 96 >> 0] = 1;
 HEAP8[i8 + 97 >> 0] = 0;
 return;
}

function __ZN10UnityScene23UnloadLevelGameManagersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 8 | 0;
 i7 = i10;
 i4 = 0;
 do {
  i8 = i5 + 84 + (i4 << 2) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i7 >> 2] = i1;
   i1 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i1) i9 = 9; else {
    if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
     i2 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[i1 + 32 >> 2] | 0;
     i1 = i2 + (i3 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i1, i7);
     i2 = HEAP32[i6 >> 2] | 0;
     i11 = HEAP32[i1 + 28 >> 2] | 0;
     i3 = HEAP32[gb + 1104264 >> 2] | 0;
     i1 = (i2 | 0) == -1 ? i11 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i11 + (i2 << 3) | 0;
     i2 = HEAP32[i3 + 28 >> 2] | 0;
     i3 = HEAP32[i3 + 32 >> 2] | 0;
    }
    if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i9 = 9; else {
     i1 = HEAP32[i1 + 4 >> 2] | 0;
     if (!i1) i9 = 11;
    }
   }
   if ((i9 | 0) == 9) i9 = 11;
   if ((i9 | 0) == 11) {
    i9 = 0;
    i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i8 >> 2] | 0) | 0;
   }
  }
  __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
  HEAP32[i8 >> 2] = 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 4);
 STACKTOP = i10;
 return;
}

function __Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 30912 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30912 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _UNITY_tt_face_load_gasp(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = HEAP32[i5 + 28 >> 2] | 0;
 i1 = mftCall_iiiii(HEAP32[i2 + 508 >> 2] | 0, i2 | 0, 1734439792, i5 | 0, 0) | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = _UNITY_FT_Stream_EnterFrame(i5, 4) | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = i2 + 540 | 0;
 HEAP16[i8 >> 1] = _UNITY_FT_Stream_GetUShort(i5) | 0;
 i1 = i2 + 542 | 0;
 HEAP16[i1 >> 1] = _UNITY_FT_Stream_GetUShort(i5) | 0;
 _UNITY_FT_Stream_ExitFrame(i5);
 i8 = HEAP32[i8 >> 2] | 0;
 i4 = i8 >>> 16;
 if ((i8 & 65535) > 1) {
  HEAP16[i1 >> 1] = 0;
  HEAP32[i6 >> 2] = 8;
  i8 = 8;
  STACKTOP = i7;
  return i8 | 0;
 }
 i2 = i2 + 544 | 0;
 HEAP32[i2 >> 2] = _UNITY_ft_mem_realloc(i3, 4, 0, i4, 0, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 }
 i1 = _UNITY_FT_Stream_EnterFrame(i5, i4 << 2) | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i7;
  return i8 | 0;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 if (i4 | 0) {
  i1 = 0;
  do {
   HEAP16[i2 + (i1 << 2) >> 1] = _UNITY_FT_Stream_GetUShort(i5) | 0;
   HEAP16[i2 + (i1 << 2) + 2 >> 1] = _UNITY_FT_Stream_GetUShort(i5) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 _UNITY_FT_Stream_ExitFrame(i5);
 i8 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN8AnimatorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 176564 + 8;
 i1 = i2 + 604 | 0;
 if ((HEAP32[i2 + 620 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 608 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 584 | 0;
 if ((HEAP32[i2 + 600 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 588 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 564 | 0;
 if ((HEAP32[i2 + 580 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 568 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN14AvatarPlaybackD2Ev(i2 + 504 | 0);
 i1 = i2 + 484 | 0;
 if ((HEAP32[i2 + 500 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 488 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 448 | 0;
 if ((HEAP32[i2 + 464 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 452 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 428 | 0;
 if ((HEAP32[i2 + 444 >> 2] | 0) <= -1) {
  i1 = i2 + 196 | 0;
  __ZN8Animator18AutoMecanimDataSet5ResetEv(i1);
  HEAP32[i2 >> 2] = gb + 37344 + 8;
  HEAP32[i2 >> 2] = gb + 37748 + 8;
  HEAP32[i2 >> 2] = gb + 29060 + 8;
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 432 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i2 + 196 | 0;
 __ZN8Animator18AutoMecanimDataSet5ResetEv(i1);
 HEAP32[i2 >> 2] = gb + 37344 + 8;
 HEAP32[i2 >> 2] = gb + 37748 + 8;
 HEAP32[i2 >> 2] = gb + 29060 + 8;
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj594ENS_22PxRepXPropertyAccessorILj594ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 36; else i1 = (HEAP32[i1 >> 2] | 0) + 36 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj593ENS_22PxRepXPropertyAccessorILj593ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj592ENS_22PxRepXPropertyAccessorILj592ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj591ENS_22PxRepXPropertyAccessorILj591ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj590ENS_22PxRepXPropertyAccessorILj590ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj589ENS_22PxRepXPropertyAccessorILj589ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj588ENS_22PxRepXPropertyAccessorILj588ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj498ENS_22PxRepXPropertyAccessorILj498ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj497ENS_22PxRepXPropertyAccessorILj497ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj624ENS_22PxRepXPropertyAccessorILj624ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 36; else i1 = (HEAP32[i1 >> 2] | 0) + 36 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj623ENS_22PxRepXPropertyAccessorILj623ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN19RenderEventsContextD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i6 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i5 = 0;
  do {
   i8 = HEAP32[i6 >> 2] | 0;
   i9 = i8 + (i5 * 20 | 0) | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i10 = i8 + (i5 * 20 | 0) + 12 | 0;
   if (!(HEAP32[i10 >> 2] | 0)) i2 = i1; else {
    i4 = i1;
    i2 = i1;
    i3 = i1;
    while (1) {
     i1 = HEAP32[i4 >> 2] | 0;
     i11 = i1 + 4 | 0;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
     if ((i1 | 0) == 0 | (HEAP32[i11 >> 2] | 0) != 0) i1 = i3; else {
      mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
      i2 = HEAP32[i9 >> 2] | 0;
      i1 = i2;
     }
     i4 = i4 + 4 | 0;
     if ((i4 | 0) == (i1 + (HEAP32[i10 >> 2] << 2) | 0)) break; else i3 = i1;
    }
   }
   i1 = i8 + (i5 * 20 | 0) + 16 | 0;
   if ((HEAP32[i1 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i8 + (i5 * 20 | 0) + 4 | 0);
    HEAP32[i9 >> 2] = 0;
   }
   HEAP32[i9 >> 2] = 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) < (HEAP32[i7 >> 2] | 0));
 }
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) return;
 i4 = i3 + -4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i1 = i3 + (i1 * 20 | 0) | 0;
  do {
   i2 = i1;
   i1 = i1 + -20 | 0;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i1 >> 2] = 0;
   }
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZdaPv(i4);
 return;
}

function __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i12 = i6 & 255;
 i5 = HEAP32[i4 >> 2] & 255;
 i13 = (i7 & 255) - i12 | 0;
 i10 = i6 >>> 8 & 255;
 i11 = (i7 >>> 8 & 255) - i10 | 0;
 i10 = i10 << 8 | 128;
 i8 = i6 >>> 16 & 255;
 i9 = (i7 >>> 16 & 255) - i8 | 0;
 i6 = i6 >>> 24;
 i7 = (i7 >>> 24) - i6 | 0;
 i5 = ((Math_imul(i5, i13) | 0) + 128 >> 8) + i12 | (Math_imul(i11, i5) | 0) + i10 & -256 | (((Math_imul(i5, i7) | 0) + 128 | 0) >>> 8) + i6 << 24 | (((Math_imul(i9, i5) | 0) + 128 | 0) >>> 8) + i8 << 16;
 i2 = HEAP32[i4 + 4 >> 2] & 255;
 i2 = ((Math_imul(i2, i13) | 0) + 128 >> 8) + i12 | (Math_imul(i2, i11) | 0) + i10 & -256 | (((Math_imul(i2, i9) | 0) + 128 | 0) >>> 8) + i8 << 16 | (((Math_imul(i2, i7) | 0) + 128 | 0) >>> 8) + i6 << 24;
 i3 = HEAP32[i4 + 8 >> 2] & 255;
 i3 = ((Math_imul(i3, i13) | 0) + 128 >> 8) + i12 | (Math_imul(i3, i11) | 0) + i10 & -256 | (((Math_imul(i3, i9) | 0) + 128 | 0) >>> 8) + i8 << 16 | (((Math_imul(i3, i7) | 0) + 128 | 0) >>> 8) + i6 << 24;
 i4 = HEAP32[i4 + 12 >> 2] & 255;
 i4 = ((Math_imul(i4, i13) | 0) + 128 >> 8) + i12 | (Math_imul(i4, i11) | 0) + i10 & -256 | (((Math_imul(i4, i9) | 0) + 128 | 0) >>> 8) + i8 << 16 | (((Math_imul(i4, i7) | 0) + 128 | 0) >>> 8) + i6 << 24;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 return;
}

function __ZN14CompressedMeshD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 228 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 232 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i2 = HEAP32[i3 + 208 >> 2] | 0;
 if (i2 | 0) {
  i1 = i3 + 212 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
  __ZdlPv(i2);
 }
 i1 = HEAP32[i3 + 188 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 192 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 168 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 172 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 140 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 144 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 120 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 124 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 92 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 96 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 72 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 76 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 48 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i2) return;
 i1 = i3 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
 __ZdlPv(i2);
 return;
}

function __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4); else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i1, i6 + 4 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i1, i6 + 20 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 36 | 0, i1);
 i1 = i6 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN12TreeRenderer21ComputeWindPropertiesEib(i8, i1, i9, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 if ((i9 | 0) <= -1) return;
 i6 = HEAP32[i1 + 380 >> 2] | 0;
 i7 = i6 + (i9 * 88 | 0) | 0;
 if (!i7) return;
 i1 = i6 + (i9 * 88 | 0) + 28 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 if (!(HEAP16[i7 >> 1] & 1)) {
  i4 = __ZN20SpeedTreeWindManager11GetInstanceEv() | 0;
  i5 = i6 + (i9 * 88 | 0) + 36 | 0;
  i4 = __ZN20SpeedTreeWindManager8TickWindER18SpeedTreeWindTimesRP18SpeedTreeLocalWindRK4AABBRK18SpeedTreeWindAsset(i4, i5, i6 + (i9 * 88 | 0) + 32 | 0, i6 + (i9 * 88 | 0) + 4 | 0, HEAP32[i1 >> 2] | 0) | 0;
  i1 = HEAP16[i7 >> 1] | 0;
  if (i4) {
   i1 = (i1 & 65535 | 2) & 65535;
   HEAP16[i7 >> 1] = i1;
  }
  HEAP16[i7 >> 1] = i1 & 65535 | 1;
  i2 = i6 + (i9 * 88 | 0) + 80 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes(i1, 0, i4, i5);
  i1 = i6 + (i9 * 88 | 0) + 84 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3) __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes(i3, 1, i4, i5);
 } else {
  i2 = i6 + (i9 * 88 | 0) + 80 | 0;
  i1 = i6 + (i9 * 88 | 0) + 84 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[(i10 ? i1 : i2) >> 2];
 HEAP8[i8 + 4 >> 0] = (HEAPU16[i7 >> 1] | 0) >>> 1 & 1;
 HEAP32[i8 + 8 >> 2] = HEAP32[i6 + (i9 * 88 | 0) + 40 >> 2];
 return;
}

function __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc(i11, i8, i12) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i13 = 0;
 i1 = __ZNK17CommonStringTable16FindCommonStringEPKc(__Z20GetCommonStringTablev() | 0, i12) | 0;
 if (i1 | 0) {
  HEAP32[i11 >> 2] = i1 - (HEAP32[gb + 36932 >> 2] | 0) | -2147483648;
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i3 = i1 + i10 | 0;
 L5 : do if ((i10 | 0) > 0) {
  i2 = i1;
  while (1) {
   if (!(_strcmp(i2, i12) | 0)) break;
   i2 = i2 + (_strlen(i2) | 0) + 1 | 0;
   if (i2 >>> 0 >= i3 >>> 0) break L5;
  }
  HEAP32[i11 >> 2] = i2 - i1;
  return;
 } while (0);
 i7 = _strlen(i12) | 0;
 i6 = i7 + 1 | 0;
 i2 = i10 + i6 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i2 >>> 0) {
  i13 = i4 << 1;
  i2 = i13 >>> 0 > i2 >>> 0 ? i13 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 1, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  }
 } while (0);
 _memcpy(i1 + i10 | 0, i12 | 0, i6 | 0) | 0;
 HEAP32[i11 >> 2] = (HEAP32[i9 >> 2] | 0) + ~i7;
 return;
}

function __Z38AnimationClip_CUSTOM_GetEventsInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 if (!i1) {
  i10 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i10 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 i9 = i2 + 196 | 0;
 i10 = HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) >> 2] | 0;
 i8 = i2 + 200 | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(i10, 4, (HEAP32[i8 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) >> 6) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i12;
  return i6 | 0;
 }
 i7 = i11 + 36 | 0;
 i5 = 0;
 do {
  i3 = i7;
  i4 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  __Z20AnimationEventToMonoRK14AnimationEventR18MonoAnimationEvent(i1 + (i5 << 6) | 0, i11);
  i1 = _il2cpp_object_new(i10 | 0) | 0;
  i3 = i1 + 8 | 0;
  i2 = i11;
  i4 = i3 + 80 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i5, i1);
  i5 = i5 + 1 | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 } while (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) - i1 >> 6 >>> 0);
 STACKTOP = i12;
 return i6 | 0;
}

function __Z17dynamic_pptr_castIP13MonoBehaviour6ObjectET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff(i1, i2, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i7 = HEAP32[i1 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f13 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 f15 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 20 >> 2]));
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i2 + 24 >> 2]));
 f12 = Math_fround(f14 * Math_fround(HEAPF32[i2 >> 2]));
 f16 = Math_fround(f14 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f12 = Math_fround(f13 + f12);
 f16 = Math_fround(f15 + f16);
 f14 = Math_fround(f11 + Math_fround(f14 * Math_fround(HEAPF32[i2 + 8 >> 2])));
 f11 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f15 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f10 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 32 >> 2]));
 f9 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f9 = Math_fround(f16 + Math_fround(f15 + f9));
 f8 = Math_fround(f14 + Math_fround(f13 + Math_fround(f8 * Math_fround(HEAPF32[i2 + 40 >> 2]))));
 HEAPF32[i7 >> 2] = Math_fround(f12 + Math_fround(f11 + f10));
 HEAPF32[i7 + 4 >> 2] = f9;
 HEAPF32[i7 + 8 >> 2] = f8;
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i5 >> 2];
 HEAPF32[i7 + 20 >> 2] = f6;
 HEAP32[i1 >> 2] = i7 + 24;
 return;
}

function __ZN5physx7NpCloth15setInertiaScaleEf(i5, f4) {
 i5 = i5 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i6 = i9;
 i1 = i9 + 12 | 0;
 i2 = i5 + 20 | 0;
 i3 = i5 + 24 | 0;
 switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i8 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 >> 2] | 0) + 2433 >> 0] | 0)) i8 = 3; else i8 = 4;
   break;
  }
 default:
  i8 = 3;
 }
 if ((i8 | 0) == 3) {
  HEAPF32[i1 >> 2] = f4;
  HEAPF32[i1 + 4 >> 2] = f4;
  HEAPF32[i1 + 8 >> 2] = f4;
  __ZN5physx2Sc9ClothCore21setLinearInertiaScaleENS_6PxVec3E(i5 + 32 | 0, i1);
 } else if ((i8 | 0) == 4) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 615, gb + 697155 | 0, i6);
 switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i8 = 8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 >> 2] | 0) + 2433 >> 0] | 0)) i8 = 7; else i8 = 8;
   break;
  }
 default:
  i8 = 7;
 }
 if ((i8 | 0) == 7) {
  HEAPF32[i1 >> 2] = f4;
  HEAPF32[i1 + 4 >> 2] = f4;
  HEAPF32[i1 + 8 >> 2] = f4;
  __ZN5physx2Sc9ClothCore22setAngularInertiaScaleENS_6PxVec3E(i5 + 32 | 0, i1);
  STACKTOP = i9;
  return;
 } else if ((i8 | 0) == 8) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 635, gb + 697237 | 0, i7);
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj494ENS_22PxRepXPropertyAccessorILj494ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj493ENS_22PxRepXPropertyAccessorILj493ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj652ENS_22PxRepXPropertyAccessorILj652ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj651ENS_22PxRepXPropertyAccessorILj651ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj649ENS_22PxRepXPropertyAccessorILj649ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj506ENS_22PxRepXPropertyAccessorILj506ENS_8PxSpringEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj560ENS_22PxRepXPropertyAccessorILj560ES4_NS_27PxVehicleClutchAccuracyMode4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 834918 | 0)) i1 = 0; else {
  i3 = gb + 834918 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 166960 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 166960 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN22ProceduralMaterialData23GetSubstancePackageNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 10;
  }
 }
 if ((i5 | 0) == 8) i5 = 10;
 if ((i5 | 0) == 10) {
  i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN20TextRenderingPrivate15GetFontMetadataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERS6_S9_RjSA_iPi(i1, i5, i6, i7, i8, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i9 >> 2] = 0;
  i2 = i9 + 4 | 0;
  HEAP8[i2 >> 0] = 0;
  if (!i1) {
   i10 = 0;
   STACKTOP = i11;
   return i10 | 0;
  } else {
   i10 = i2;
   i2 = i9;
  }
 } else {
  HEAP32[i9 >> 2] = 0;
  i10 = i9 + 4 | 0;
  HEAP8[i10 >> 0] = 0;
  i2 = i9;
 }
 i3 = (_UNITY_FT_New_Face(HEAP32[gb + 1467876 >> 2] | 0, i1, i3, i2) | 0) == 0;
 HEAP8[i10 >> 0] = i3 & 1;
 if (!i3) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) i2 = 0; else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5, i2) | 0;
  i1 = HEAP32[(HEAP32[i9 >> 2] | 0) + 24 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i6, (i1 | 0) == 0 ? gb + 1576256 | 0 : i1) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i1 + 8 >> 2];
  i2 = 1;
 }
 if (!(HEAP8[i10 >> 0] | 0)) {
  i10 = i2;
  STACKTOP = i11;
  return i10 | 0;
 }
 _UNITY_FT_Done_Face(i1) | 0;
 i10 = i2;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN16StreamedResource8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 391085 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 1);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[gb + 37296 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800947 | 0, i6, i1 + 16 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, i6, i1 + 24 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z46SortingLayer_CUSTOM_GetSortingLayerIDsInternalv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7;
 i4 = i7 + 8 | 0;
 i2 = __Z13GetTagManagerv() | 0;
 i1 = __ZN10TagManager20GetSortingLayerCountEv(i2) | 0;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 i5 = i4 + 16 | 0;
 HEAP32[i5 >> 2] = i1;
 i6 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 64016 | 0);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i6, 0, gb + 1047584 | 0, 446) | 0;
 if ((__ZN10TagManager20GetSortingLayerCountEv(i2) | 0) > 0) {
  i1 = 0;
  do {
   i10 = __ZN10TagManager23GetSortingLayerUniqueIDEi(i2, i1) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i10;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (__ZN10TagManager20GetSortingLayerCountEv(i2) | 0));
 }
 i9 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i10 = (i9 | 0) == 0 ? 0 : i10;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, i10) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0, i9 | 0, i10 << 2 | 0) | 0;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj587ENS_22PxRepXPropertyAccessorILj587ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj660ENS_22PxRepXPropertyAccessorILj660ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 48; else i1 = (HEAP32[i1 >> 2] | 0) + 48 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj659ENS_22PxRepXPropertyAccessorILj659ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj658ENS_22PxRepXPropertyAccessorILj658ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj286ENS_22PxRepXPropertyAccessorILj286ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj66ENS_22PxRepXPropertyAccessorILj66ES4_NS_28PxArticulationJointDriveType4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 84; else i1 = (HEAP32[i1 >> 2] | 0) + 84 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 673987 | 0)) i1 = 0; else {
  i3 = gb + 673987 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 89968 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 89968 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Gu29computeMTD_CapsuleHeightFieldERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i6, i4, i1, i2, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 4220 | 0;
 i10 = i7 + 4192 | 0;
 i12 = i7 + 4224 | 0;
 i13 = i7 + 4120 | 0;
 i11 = i7 + 4136 | 0;
 i8 = i7 + 4116 | 0;
 i3 = i7;
 i9 = i7 + 4112 | 0;
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i1, i1 + 12 | 0, i15);
 HEAP32[i12 >> 2] = -1;
 i14 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = 2;
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i13 + 8 >> 2] = i1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu25contactCapsuleHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i5, i9, i8, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i6, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i15 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN5physx17EdgeChangeManager17cleanupEdgeEventsEPij(i2, i12, i1) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i8 = i2 + 20 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i11 = i2 + 28 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = (i6 | 0) == 0;
 if (i3) i1 = 0; else {
  i1 = 0;
  i2 = 0;
  do {
   i5 = i12 + (HEAP32[i7 + (i2 << 2) >> 2] << 2) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i1 = i1 | (i4 | 0) != 0;
   HEAP32[i5 >> 2] = i4 + -1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
 }
 i5 = (i10 | 0) == 0;
 if (!i5) {
  i2 = 0;
  do {
   i4 = i12 + (HEAP32[i9 + (i2 << 2) >> 2] << 2) | 0;
   i13 = HEAP32[i4 >> 2] | 0;
   i1 = i1 | (i13 | 0) != 0;
   HEAP32[i4 >> 2] = i13 + 1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
 }
 if (!i1) return;
 if (i3) i1 = 0; else {
  i4 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
   i3 = i12 + (i2 << 2) | 0;
   if ((HEAP32[i3 >> 2] | 0) < 0) {
    HEAP32[i7 + (i1 << 2) >> 2] = i2;
    HEAP32[i3 >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
 }
 HEAP32[i8 >> 2] = i1;
 if (i5) i1 = 0; else {
  i4 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i9 + (i4 << 2) >> 2] | 0;
   i3 = i12 + (i2 << 2) | 0;
   if ((HEAP32[i3 >> 2] | 0) > 0) {
    HEAP32[i9 + (i1 << 2) >> 2] = i2;
    HEAP32[i3 >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i10 | 0));
 }
 HEAP32[i11 >> 2] = i1;
 return;
}

function __ZN15dtPathQueryInfo8copyFromERS_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  __Z6dtFreePv(HEAP32[i1 + 48 >> 2] | 0);
  __Z6dtFreePv(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i3 >> 2] | 0);
 }
 HEAP32[i3 >> 2] = 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = __Z7dtAlloci(64) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = i2 + 8 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i2 + 24 | 0;
 HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
 i6 = i2 + 28 | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i6 >> 2];
 i5 = i2 + 32 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i5 >> 2];
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 HEAP32[i1 + 56 >> 2] = i2;
 i7 = i2 << 2;
 i6 = __Z7dtAlloci(i7) | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] = i6;
 _memcpy(i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i7 | 0) | 0;
 i7 = i2 * 12 | 0;
 i6 = __Z7dtAlloci(i7) | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] = i6;
 _memcpy(i6 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i7 | 0) | 0;
 return;
}

function __ZN14NavMeshManager16RegisterObstacleER15NavMeshObstacleRi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = i2 + 60 | 0;
 i6 = i2 + 72 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i2 + 76 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i10 & 2147483647;
 do if (i8 >>> 0 > i11 >>> 0) {
  i1 = i10 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i11 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 * 12 | 0, 4, i2 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + (i7 * 12 | 0) >> 2] = i3;
 HEAP32[i1 + (i7 * 12 | 0) + 4 >> 2] = -1;
 HEAP32[i1 + (i7 * 12 | 0) + 8 >> 2] = -1;
 HEAP32[i4 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 168976 | 0) | 0;
 if (!i2) return;
 if ((HEAP32[i2 + 88 >> 2] | 0) == -1) return;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 842061 | 0, 0, gb + 842172 | 0, 890, 512, i1, 0, 0);
 return;
}

function __ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 12 | 0;
 i4 = i9;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!((i6 | 0) != 0 & (i1 | 0) != 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * (i1 * 12 | 0) | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = 0;
 do {
  HEAP32[i2 + (i3 * 12 | 0) >> 2] = HEAP32[i6 + (i3 * 12 | 0) >> 2];
  HEAP32[i2 + (i3 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2];
  HEAP32[i2 + (i3 * 12 | 0) + 8 >> 2] = HEAP32[i6 + (i3 * 12 | 0) + 8 >> 2];
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 __ZN5physx18ReducedVertexCloudC2EPKNS_6PxVec3Ej(i8, i2, i1);
 __ZN5physx18ReducedVertexCloud6ReduceEPNS_12REDUCEDCLOUDE(i8, i4) | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i2 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0;
 if (!(i1 | i5 ^ 1)) {
  HEAP32[i7 >> 2] = i2;
  if (!i2) i1 = 0; else {
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = 0;
   do {
    HEAP32[i6 + (i2 * 12 | 0) >> 2] = HEAP32[i1 + (i2 * 12 | 0) >> 2];
    HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2];
    HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2];
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
   i1 = 0;
  }
 }
 __ZN5physx18ReducedVertexCloudD2Ev(i8);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN9BlobWriteD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = i10 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i10 + 44 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + (i1 >>> 8 << 2) | 0;
 i11 = i10 + 36 | 0;
 i7 = HEAP32[i11 >> 2] | 0;
 i4 = i7;
 i5 = i2;
 if ((i7 | 0) == (i2 | 0)) {
  i6 = 0;
  i7 = i10 + 48 | 0;
  i1 = 0;
 } else {
  i7 = i10 + 48 | 0;
  i6 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i6 = (HEAP32[i2 + (i6 >>> 8 << 2) >> 2] | 0) + ((i6 & 255) << 4) | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + ((i1 & 255) << 4) | 0;
 }
 L5 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L5;
   i1 = i1 + 16 | 0;
  } while ((i1 - (HEAP32[i3 >> 2] | 0) | 0) != 4096);
  i1 = i3 + 4 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i4 - i5 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i2 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = (HEAP32[i11 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i8 >> 2] = 128;
   break;
  }
 case 2:
  {
   HEAP32[i8 >> 2] = 256;
   break;
  }
 default:
  {}
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i11 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj392ENS_22PxRepXPropertyAccessorILj392ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj533ENS_22PxRepXPropertyAccessorILj533ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj531ENS_22PxRepXPropertyAccessorILj531ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx20PxsParticleSystemSim24clearParticleConstraintsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = HEAP32[i9 + 48 >> 2] | 0;
 i8 = i9 + 56 | 0;
 i9 = HEAP32[i9 + 60 >> 2] & 2147483647;
 if (!i9) return;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
  if (i2 | 0) {
   i5 = i1;
   i4 = i2;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i9 >>> 0) {
   i3 = 18;
   break;
  }
 }
 if ((i3 | 0) == 18) return;
 i3 = (Math_imul(i4 & 0 - i4, 125613361) | 0) >>> 27;
 i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i5 << 5;
 i2 = i4 + -1 & i4;
 L10 : do if (!i2) {
  i1 = i5;
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i9 >>> 0) {
    i2 = 0;
    break L10;
   }
   i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
 } else i1 = i5; while (0);
 if ((i3 | 0) == -1) return;
 L18 : while (1) {
  i4 = i1 << 5;
  while (1) {
   i6 = i7 + (i3 << 5) + 30 | 0;
   HEAP16[i6 >> 1] = (HEAPU16[i6 >> 1] | 0) & 65532;
   if (!i2) {
    i3 = 18;
    break L18;
   }
   i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
   i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
   i2 = i2 + -1 & i2;
   if (!i2) break;
   if ((i3 | 0) == -1) {
    i3 = 18;
    break L18;
   }
  }
  do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i9 >>> 0) {
    i2 = 0;
    break;
   }
   i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0);
  if ((i3 | 0) == -1) {
   i3 = 18;
   break;
  }
 }
 if ((i3 | 0) == 18) return;
}

function __ZN5physx11EdgeManager6resizeEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = (i9 * 12 | 0) + 15 & -16;
 i5 = (i9 << 2) + 15 & -16;
 i8 = i7 + i5 | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, i8 + i5 | 0, gb + 681489 | 0, 1066) | 0;
 i7 = i5 + i7 | 0;
 i8 = i5 + i8 | 0;
 i4 = i10 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = i10 + 12 | 0;
  i2 = i10 + 8 | 0;
  i3 = i10 + 24 | 0;
  i1 = i4;
 } else {
  i6 = i10 + 12 | 0;
  _memcpy(i5 | 0, i1 | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
  i2 = i10 + 8 | 0;
  _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  i3 = i10 + 24 | 0;
  _memcpy(i8 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i4 >> 2] | 0);
  i1 = i4;
 }
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i3 >> 2] = i8;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i10 + 16 | 0;
 i3 = i9 + -1 | 0;
 HEAP32[i7 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 if (i3 >>> 0 > i1 >>> 0) {
  i4 = i1;
  do {
   i5 = i4;
   i4 = i4 + 1 | 0;
   HEAP32[i7 + (i5 << 2) >> 2] = i4;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAP32[i2 >> 2] = i1;
 i10 = i10 + 20 | 0;
 HEAP32[i10 >> 2] = (((i9 | 0) == 0) << 31 >> 31) + i9 - i1 + (HEAP32[i10 >> 2] | 0);
 i10 = HEAP32[i6 >> 2] | 0;
 _memset(i8 + (i10 << 2) | 0, -1, i9 - i10 << 2 | 0) | 0;
 HEAP32[i6 >> 2] = i9;
 STACKTOP = i11;
 return;
}

function __ZN23CachedSerializationDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 204 | 0;
 if ((HEAP32[i2 + 220 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 208 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 180 | 0;
 if ((HEAP32[i2 + 196 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 184 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 156 | 0;
 if ((HEAP32[i2 + 172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 160 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 132 | 0;
 if ((HEAP32[i2 + 148 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 136 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 108 | 0;
 if ((HEAP32[i2 + 124 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 112 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 84 | 0;
 if ((HEAP32[i2 + 100 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 88 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 36 | 0;
 if ((HEAP32[i2 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 40 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 12 | 0;
 if ((HEAP32[i2 + 28 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 16 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN20dynamic_block_vectorI14FileIdentifierE5clearEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i10 = i9 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 | 0) {
  i7 = i9 + 16 | 0;
  i8 = i6 + 4 | 0;
  i5 = 0;
  do {
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = (i5 >>> 0) % (i3 >>> 0) | 0;
   i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + (((i5 >>> 0) / (i3 >>> 0) | 0) << 2) >> 2] | 0;
   i4 = i3 + (i2 * 36 | 0) | 0;
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i3 + (i2 * 36 | 0) + 12 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i8 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
    i1 = HEAP32[i10 >> 2] | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i1 >>> 0);
 }
 i3 = i9 + 16 | 0;
 i4 = i9 + 28 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i9 + 8 | 0;
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i2);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i9 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i11;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i9 + 20 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15ResourceManagerD2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 HEAP32[i10 >> 2] = gb + 64484 + 8;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i10 + 44 | 0, HEAP32[i10 + 48 >> 2] | 0);
 i8 = i10 + 28 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  HEAP32[i10 >> 2] = gb + 28648 + 8;
  HEAP32[i10 >> 2] = gb + 28496 + 8;
  STACKTOP = i12;
  return;
 }
 i9 = i10 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i11 + 4 | 0;
  i4 = i2;
  while (1) {
   i2 = i4 + -20 | 0;
   HEAP32[i9 >> 2] = i2;
   i5 = HEAP32[i4 + -16 >> 2] | 0;
   i6 = i5;
   if (i5) {
    i2 = i4 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i5 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i6 | 0) >>> 2) << 2);
    i2 = HEAP32[i4 + -4 >> 2] | 0;
    HEAP32[i11 >> 2] = 51;
    HEAP32[i7 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i5, i11);
    i2 = HEAP32[i9 >> 2] | 0;
   }
   if ((i2 | 0) == (i1 | 0)) break; else i4 = i2;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i9 = HEAP32[i10 + 40 >> 2] | 0;
 HEAP32[i11 >> 2] = 51;
 HEAP32[i11 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 HEAP32[i10 >> 2] = gb + 28648 + 8;
 HEAP32[i10 >> 2] = gb + 28496 + 8;
 STACKTOP = i12;
 return;
}

function __Z17dynamic_pptr_castIP10GameObject6ObjectET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE10deallocateEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i11 >> 2] = i2 + -36;
   i9 = i2 + -16 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if (i3 | 0) {
    i8 = i2 + -12 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    if ((i4 | 0) != (i3 | 0)) {
     do {
      i5 = i4 + -20 | 0;
      HEAP32[i8 >> 2] = i5;
      i6 = HEAP32[i4 + -12 >> 2] | 0;
      i7 = i6;
      if (!i6) i4 = i5; else {
       i4 = i4 + -8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) != (i6 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i7 | 0) >>> 0) / 24 | 0) * 24 | 0);
       __ZdlPv(i6);
       i4 = HEAP32[i8 >> 2] | 0;
      }
     } while ((i4 | 0) != (i3 | 0));
     i3 = HEAP32[i9 >> 2] | 0;
    }
    __ZdlPv(i3);
   }
   i4 = i2 + -28 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    i3 = i2 + -24 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0)) i2 = i5; else {
     do {
      i9 = i2 + -96 | 0;
      HEAP32[i3 >> 2] = i9;
      __ZN19ComputeShaderKernelD2Ev(i9);
      i2 = HEAP32[i3 >> 2] | 0;
     } while ((i2 | 0) != (i5 | 0));
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZdlPv(i2);
   }
   i2 = HEAP32[i11 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 return;
}

function __ZNSt3__214__split_bufferIP10InputEventNS_9allocatorIS2_EEE10push_frontERKS2_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i9 + 4 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i12;
 do if ((i11 | 0) == (i12 | 0)) {
  i12 = i9 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = i8;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2;
   i5 = ((i1 - i3 >> 2) + 1 | 0) / 2 | 0;
   i1 = i2 + (i5 << 2) | 0;
   i3 = i3 - i11 | 0;
   i10 = i3 >> 2;
   i4 = i1 + (0 - i10 << 2) | 0;
   if (i10) {
    _memmove(i4 | 0, i11 | 0, i3 | 0) | 0;
    i1 = i4;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i12 >> 2] = i2 + (i5 << 2);
   break;
  }
  i8 = i1 - i3 >> 1;
  i8 = (i8 | 0) == 0 ? 1 : i8;
  i5 = __Znwj(i8 << 2) | 0;
  i6 = i5;
  i1 = i5 + ((i8 + 3 | 0) >>> 2 << 2) | 0;
  i7 = i1;
  i8 = i5 + (i8 << 2) | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i3 = i7;
   i2 = i11;
  } else {
   i5 = i1;
   i3 = i7;
   i4 = i11;
   do {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i3 + 4 | 0;
    i3 = i5;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i6;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i8;
  if (i2) {
   __ZdlPv(i2);
   i1 = HEAP32[i14 >> 2] | 0;
  }
 } else i1 = i11; while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
 return;
}

function __ZNK11Rigidbody2D16IsTouchingLayersEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i3 = i10;
 i9 = i10 + 16 | 0;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i9 >> 2] = 0;
 i6 = i9 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i9 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 L1 : do if (!(__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i9) | 0)) i1 = 0; else {
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i4 = i2;
   i3 = i2;
   while (1) {
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) i2 = i3; else {
     if (__ZNK19CollisionListener2D16IsTouchingLayersEPK10Collider2Di((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2, i5) | 0) {
      i1 = 1;
      break L1;
     }
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i4 = i4 + 4 | 0;
    if ((i4 | 0) == (i2 + (i1 << 2) | 0)) {
     i1 = 0;
     break;
    } else i3 = i2;
   }
  }
 } while (0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = 0;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN5physx9PxTaskMgr12dispatchTaskEjb(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i2 = HEAP32[i4 + 76 >> 2] | 0;
 i6 = i2 + (i3 * 20 | 0) + 8 | 0;
 switch (HEAP32[i6 >> 2] | 0) {
 case 3:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 718836 | 0, 776, gb + 718910 | 0, i7);
   i6 = 0;
   i5 = HEAP32[i5 >> 2] | 0;
   __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
   STACKTOP = i7;
   return i6 | 0;
  }
 case 0:
  {
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i2 + (i3 * 20 | 0) >> 2] | 0);
   break;
  }
 case 1:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 718836 | 0, 800, gb + 718934 | 0, i7 + 8 | 0);
   break;
  }
 case 2:
  {
   i1 = __ZN5physx9PxTaskMgr10resolveRowEjb(i4, i3, i1) | 0 | i1;
   break;
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 718836 | 0, 812, gb + 718952 | 0, i7 + 16 | 0);
   i1 = __ZN5physx9PxTaskMgr10resolveRowEjb(i4, i3, i1) | 0 | i1;
  }
 }
 HEAP32[i6 >> 2] = 3;
 i6 = i1;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 128; else i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj285ENS_22PxRepXPropertyAccessorILj285ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj284ENS_22PxRepXPropertyAccessorILj284ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj527ENS_22PxRepXPropertyAccessorILj527ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj526ENS_22PxRepXPropertyAccessorILj526ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj525ENS_22PxRepXPropertyAccessorILj525ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj524ENS_22PxRepXPropertyAccessorILj524ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj523ENS_22PxRepXPropertyAccessorILj523ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj78ENS_22PxRepXPropertyAccessorILj78ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 140; else i1 = (HEAP32[i1 >> 2] | 0) + 140 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj74ENS_22PxRepXPropertyAccessorILj74ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 120; else i1 = (HEAP32[i1 >> 2] | 0) + 120 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj73ENS_22PxRepXPropertyAccessorILj73ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 116; else i1 = (HEAP32[i1 >> 2] | 0) + 116 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj72ENS_22PxRepXPropertyAccessorILj72ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj70ENS_22PxRepXPropertyAccessorILj70ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 100; else i1 = (HEAP32[i1 >> 2] | 0) + 100 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Cct16shapeHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef(i1, i6, i2, f3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0) | 0;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i7 + 32 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i7 + 36 >> 2] = HEAP32[i6 + 28 >> 2];
 HEAP32[i7 + 40 >> 2] = HEAP32[i6 + 32 >> 2];
 HEAP32[i7 + 44 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i7 + 56 >> 2] = f3;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 i2 = i7 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 i4 = i7 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 + 68 >> 2] = HEAP32[i6 + 44 >> 2];
 i1 = HEAP32[i5 + 72 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0);
 i1 = HEAP32[i5 + 76 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = (mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) & 255;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx2Sn13XmlNodeWriter8beginTagEPKc(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = (HEAP32[i8 + 4 >> 2] | 0) + 8 | 0;
 i7 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, 24) | 0;
 HEAP32[i7 >> 2] = gb + 1576256;
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = gb + 1576256;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i5) i1 = gb + 1576256 | 0; else if (!(HEAP8[i5 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i5;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = gb + 1576256;
 i4 = i8 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i7 + 20 >> 2] = i1;
  i1 = i1 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = i7;
   break;
  }
  while (1) {
   i1 = i2 + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  HEAP32[i1 >> 2] = i7;
  HEAP32[i7 + 12 >> 2] = i2;
 } while (0);
 i1 = i8 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  HEAP32[i4 >> 2] = i7;
  i8 = i8 + 16 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i7 = i7 + 1 | 0;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 HEAP32[i1 >> 2] = i7;
 HEAP32[i4 >> 2] = i7;
 i8 = i8 + 16 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i7 = i7 + 1 | 0;
 HEAP32[i8 >> 2] = i7;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 4, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 << 4) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN13TargetJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i5, i2);
 if (!(i2 & 16)) {
  STACKTOP = i6;
  return;
 }
 i4 = i5 + 60 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i2 = 0; else {
  i7 = HEAP32[i5 + 88 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 + 84 >> 2];
  HEAP32[i3 + 4 >> 2] = i7;
  __ZN12b2MouseJoint9SetTargetERK6b2Vec2(i2, i3);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i7 = i5 + 92 | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 i3 = f1 < Math_fround(0.0);
 i8 = f1 > Math_fround(1.0e6);
 f1 = i8 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i7 >> 2] = f1;
 if (!i2) i2 = 0; else {
  __ZN12b2MouseJoint11SetMaxForceEf(i2, f1);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i8 = i5 + 96 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(1.0);
 f1 = i3 ? Math_fround(1.0) : f1;
 f1 = i7 ? Math_fround(0.0) : f1;
 HEAPF32[i8 >> 2] = f1;
 if (!i2) i2 = 0; else {
  __ZN12b2MouseJoint15SetDampingRatioEf(i2, f1);
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i8 = i5 + 100 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 i7 = f1 < Math_fround(0.0);
 i5 = f1 > Math_fround(1.0e6);
 f1 = i5 ? Math_fround(1.0e6) : f1;
 f1 = i7 ? Math_fround(0.0) : f1;
 HEAPF32[i8 >> 2] = f1;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __ZN12b2MouseJoint12SetFrequencyEf(i2, f1);
 STACKTOP = i6;
 return;
}

function __ZN12CubemapArray11SetPixels32EiPK11ColorRGBA3211CubemapFaceii(i2, i3, i8, i9, i10, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 20 | 0;
 i12 = i13;
 if (!(__ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii(i2, i3, i8, i9, i10, i1) | 0)) {
  STACKTOP = i13;
  return;
 }
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 i5 = HEAP32[i2 + 100 >> 2] | 0;
 i14 = i2 + 80 | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 i6 = i2 + 88 | 0;
 i7 = __Z21CalculateMipMapOffsetii13TextureFormati(i7, i7, HEAP32[i6 >> 2] | 0, i1) | 0;
 i14 = HEAP32[i14 >> 2] >> i1;
 i15 = (i14 | 0) < 1;
 i1 = i15 ? 1 : i14;
 i14 = Math_imul(i14, i14) | 0;
 if (((i15 ? 1 : i14) | 0) == (i3 | 0)) {
  i15 = i4 + (Math_imul(i5, (i10 * 6 | 0) + i9 | 0) | 0) + i7 | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i11, i1, i1, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i1, 4) | 0, 4, i8);
  i14 = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i1, HEAP32[i6 >> 2] | 0) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i12, i1, i1, i14, HEAP32[i6 >> 2] | 0, i15);
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i12, i11, 0);
  STACKTOP = i13;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418272 | 0, 0, gb + 397053 | 0, 300, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i13;
  return;
 }
}

function __Z24scripting_cpp_string_forP12Il2CppString(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 4 | 0;
 i7 = i9;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i8 = _il2cpp_string_length(i1 | 0) | 0;
 i4 = _il2cpp_string_chars(i1 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 4 | 0;
 i10 = gb + 63160 | 0;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i8 << 2;
 do if (!i2) {
  i1 = 0;
  i2 = 0;
 } else if (i2 >>> 0 < 2e3) {
  i1 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i2 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  i2 = 0;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, gb + 64016 | 0, 0, gb + 463578 | 0, 39) | 0;
  i10 = gb + 64016 | 0;
  i11 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i5;
  HEAP32[i1 >> 2] = i11;
  HEAP32[i1 + 4 >> 2] = i10;
  i1 = i2;
  break;
 } while (0);
 HEAP32[i7 >> 2] = 0;
 __Z18ConvertUTF16toUTF8PKtiPhRi(i4, i8, i1, i7) | 0;
 i11 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, i11);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i5);
 STACKTOP = i9;
 return;
}

function __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN9ShaderLab11shaderprops16GetComputeBufferEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE(i4, i6, i1, i7) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) == -1) {
  HEAP32[i7 >> 2] = -1;
  HEAP32[i7 + 4 >> 2] = 3;
  i7 = gb + 1166556 | 0;
  return i7 | 0;
 }
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 i2 = HEAP32[i4 + 28 >> 2] | 0;
 L5 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L5;
  }
  if ((i1 | 0) > -1) {
   i2 = HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   i1 = (HEAP32[i4 + 72 >> 2] | 0) + i2 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    HEAP32[i7 >> 2] = i2;
    HEAP32[i7 + 4 >> 2] = 0;
    i7 = i1;
    return i7 | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = HEAP32[i6 + 28 >> 2] | 0;
 L15 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i6 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L15;
  }
  if ((i1 | 0) > -1) {
   i2 = HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   i1 = (HEAP32[i6 + 72 >> 2] | 0) + i2 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    HEAP32[i7 >> 2] = i2;
    HEAP32[i7 + 4 >> 2] = 1;
    i7 = i1;
    return i7 | 0;
   }
  }
 } while (0);
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = 4;
 i7 = gb + 1166556 | 0;
 return i7 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj553ENS_22PxRepXPropertyAccessorILj553ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj391ENS_22PxRepXPropertyAccessorILj391ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj390ENS_22PxRepXPropertyAccessorILj390ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj581ENS_22PxRepXPropertyAccessorILj581ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj580ENS_22PxRepXPropertyAccessorILj580ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 36; else i1 = (HEAP32[i1 >> 2] | 0) + 36 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj579ENS_22PxRepXPropertyAccessorILj579ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj578ENS_22PxRepXPropertyAccessorILj578ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj577ENS_22PxRepXPropertyAccessorILj577ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj576ENS_22PxRepXPropertyAccessorILj576ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj575ENS_22PxRepXPropertyAccessorILj575ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj574ENS_22PxRepXPropertyAccessorILj574ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj490ENS_22PxRepXPropertyAccessorILj490ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj479ENS_22PxRepXPropertyAccessorILj479ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 192; else i1 = (HEAP32[i1 >> 2] | 0) + 192 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj461ENS_22PxRepXPropertyAccessorILj461ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 204; else i1 = (HEAP32[i1 >> 2] | 0) + 204 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj460ENS_22PxRepXPropertyAccessorILj460ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 200; else i1 = (HEAP32[i1 >> 2] | 0) + 200 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN4FMOD8ChannelIC2EPNS_7SystemIE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 44 >> 2] = i2;
 HEAP32[i1 + 48 >> 2] = i2;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = i2;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(44100.0);
 HEAPF32[i1 + 144 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 148 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 i2 = i1 + 156 | 0;
 HEAP32[i1 + 168 >> 2] = 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP16[i2 + 4 >> 1] = 0;
 HEAP8[i2 + 6 >> 0] = 0;
 HEAP32[i1 + 164 >> 2] = _JS_Sound_Create_Channel(fb + 3782 | 0, i1 | 0) | 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(Math_fround((_rand() | 0) % 1e3 | 0 | 0) * Math_fround(.00100000005));
 return;
}

function __ZN17AudioReverbFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 874171 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 174980 + 8;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 56 >> 2] = Math_fround(10.0);
 HEAPF32[i4 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 68 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i4 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 80 >> 2] = Math_fround(.0399999991);
 HEAPF32[i4 + 84 >> 2] = Math_fround(100.0);
 HEAPF32[i4 + 88 >> 2] = Math_fround(100.0);
 HEAPF32[i4 + 92 >> 2] = Math_fround(5.0e3);
 HEAPF32[i4 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 100 >> 2] = Math_fround(250.0);
 HEAP32[i4 + 104 >> 2] = 27;
 HEAP32[i4 + 36 >> 2] = 17;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z27DestroyAllowNameConversionsP20AllowNameConversions(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[i6 + 12 >> 0] | 0)) i1 = i6 + 4 | 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = i6 + 4 | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i3 = i2;
   while (1) {
    i2 = HEAP32[i3 + 24 >> 2] | 0;
    i5 = i3 + 28 | 0;
    if ((i2 | 0) != (i5 | 0)) {
     i4 = i2;
     while (1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 + 16 >> 2] | 0, gb + 63416 | 0);
      i2 = HEAP32[i4 + 4 >> 2] | 0;
      if (!i2) while (1) {
       i2 = HEAP32[i4 + 8 >> 2] | 0;
       if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break; else i4 = i2;
      } else while (1) {
       i4 = HEAP32[i2 >> 2] | 0;
       if (!i4) break; else i2 = i4;
      }
      if ((i2 | 0) == (i5 | 0)) break; else i4 = i2;
     }
    }
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) while (1) {
     i2 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
    } else while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
    if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
   }
   if (!i6) {
    __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63416 | 0);
    return;
   }
  }
 }
 __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i6, HEAP32[i1 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63416 | 0);
 return;
}

function __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z17dynamic_pptr_castIP9Behaviour6ObjectET_RK4PPtrIT0_E(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29672 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29672 + 28 >> 2] | 0) >>> 0) {
   i7 = i1;
   STACKTOP = i6;
   return i7 | 0;
  }
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _UNITY_png_set_gamma_fixed(i5, i2, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i5) return;
 i7 = i5 + 208 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i3 & 64 | 0) {
  _UNITY_png_app_error(i5, gb + 353836 | 0);
  return;
 }
 i1 = i3 | 16384;
 HEAP32[i7 >> 2] = i1;
 L8 : do if ((i2 | 0) < -2) if ((i2 | 0) < -5e4) switch (i2 | 0) {
 case -1e5:
  {
   i8 = 5;
   break L8;
  }
 default:
  break L8;
 } else switch (i2 | 0) {
 case -5e4:
  {
   i8 = 6;
   break L8;
  }
 default:
  break L8;
 } else switch (i2 | 0) {
 case -1:
  {
   i8 = 5;
   break;
  }
 case -2:
  {
   i8 = 6;
   break;
  }
 default:
  {}
 } while (0);
 if ((i8 | 0) == 5) {
  i1 = i3 | 20480;
  HEAP32[i7 >> 2] = i1;
  i2 = 22e4;
 } else if ((i8 | 0) == 6) i2 = 151724;
 L18 : do if ((i6 | 0) < -2) if ((i6 | 0) < -5e4) switch (i6 | 0) {
 case -1e5:
  {
   i8 = 8;
   break L18;
  }
 default:
  {
   i8 = 9;
   break L18;
  }
 } else switch (i6 | 0) {
 case -5e4:
  {
   i4 = 65909;
   break L18;
  }
 default:
  {
   i8 = 9;
   break L18;
  }
 } else switch (i6 | 0) {
 case -1:
  {
   i8 = 8;
   break;
  }
 case -2:
  {
   i4 = 65909;
   break;
  }
 default:
  i8 = 9;
 } while (0);
 if ((i8 | 0) == 8) {
  HEAP32[i7 >> 2] = i1 | 4096;
  i4 = 45455;
 } else if ((i8 | 0) == 9) if ((i6 | 0) < 1) _UNITY_png_error(i5, gb + 354031 | 0); else i4 = i6;
 if ((i2 | 0) < 1) _UNITY_png_error(i5, gb + 354067 | 0);
 HEAP32[i5 + 680 >> 2] = i4;
 i8 = i5 + 754 | 0;
 HEAP16[i8 >> 1] = HEAPU16[i8 >> 1] | 0 | 1;
 HEAP32[i5 + 484 >> 2] = i2;
 return;
}

function __ZN6Camera16SetTargetDisplayEi(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i5 + 820 >> 2] = i2;
 i2 = i5 + 1086 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i3, i5, 1);
 f1 = Math_fround(HEAPF32[i5 + 864 >> 2]);
 f4 = Math_fround(HEAPF32[i5 + 868 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 872 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 876 >> 2]);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f1 = Math_fround(f1 * f12);
 f11 = Math_fround(f11 * f12);
 f4 = Math_fround(f4 * f9);
 f8 = Math_fround(f8 * f9);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f1 = Math_fround(f1 + f10);
 f4 = Math_fround(f4 + f7);
 f11 = Math_fround(f11 + f1);
 f8 = Math_fround(f8 + f4);
 f12 = Math_fround(f12 + f10);
 f9 = Math_fround(f9 + f7);
 f1 = Math_fround((f11 > f12 ? f12 : f11) - (f1 < f10 ? f10 : f1));
 f4 = Math_fround((f8 > f9 ? f9 : f8) - (f4 < f7 ? f7 : f4));
 i3 = f4 < Math_fround(0.0);
 f4 = i3 ? Math_fround(0.0) : f4;
 if (f4 != Math_fround(0.0)) {
  i3 = f1 < Math_fround(0.0);
  f1 = Math_fround((i3 ? Math_fround(0.0) : f1) / f4);
 } else f1 = Math_fround(1.0);
 HEAPF32[i5 + 1060 >> 2] = f1;
 HEAP8[i5 + 1077 >> 0] = 1;
 HEAP8[i5 + 1079 >> 0] = 1;
 HEAP8[i5 + 1078 >> 0] = 1;
 HEAP8[i2 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 720631 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj399ENS_22PxRepXPropertyAccessorILj399ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj522ENS_22PxRepXPropertyAccessorILj522ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj396ENS_22PxRepXPropertyAccessorILj396ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj69ENS_22PxRepXPropertyAccessorILj69ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 96; else i1 = (HEAP32[i1 >> 2] | 0) + 96 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj68ENS_22PxRepXPropertyAccessorILj68ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 92; else i1 = (HEAP32[i1 >> 2] | 0) + 92 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj67ENS_22PxRepXPropertyAccessorILj67ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj603ENS_22PxRepXPropertyAccessorILj603ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj602ENS_22PxRepXPropertyAccessorILj602ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj601ENS_22PxRepXPropertyAccessorILj601ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj600ENS_22PxRepXPropertyAccessorILj600ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj209ENS_22PxRepXPropertyAccessorILj209ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj296ENS_22PxRepXPropertyAccessorILj296ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj295ENS_22PxRepXPropertyAccessorILj295ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj473ENS_22PxRepXPropertyAccessorILj473ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 216; else i1 = (HEAP32[i1 >> 2] | 0) + 216 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj472ENS_22PxRepXPropertyAccessorILj472ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 212; else i1 = (HEAP32[i1 >> 2] | 0) + 212 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj470ENS_22PxRepXPropertyAccessorILj470ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 204; else i1 = (HEAP32[i1 >> 2] | 0) + 204 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj469ENS_22PxRepXPropertyAccessorILj469ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 200; else i1 = (HEAP32[i1 >> 2] | 0) + 200 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj468ENS_22PxRepXPropertyAccessorILj468ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 196; else i1 = (HEAP32[i1 >> 2] | 0) + 196 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj189ENS_22PxRepXPropertyAccessorILj189ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj188ENS_22PxRepXPropertyAccessorILj188ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 120; else i1 = (HEAP32[i1 >> 2] | 0) + 120 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj187ENS_22PxRepXPropertyAccessorILj187ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 116; else i1 = (HEAP32[i1 >> 2] | 0) + 116 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj446ENS_22PxRepXPropertyAccessorILj446ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 180; else i1 = (HEAP32[i1 >> 2] | 0) + 180 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj445ENS_22PxRepXPropertyAccessorILj445ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 176; else i1 = (HEAP32[i1 >> 2] | 0) + 176 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj444ENS_22PxRepXPropertyAccessorILj444ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 172; else i1 = (HEAP32[i1 >> 2] | 0) + 172 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj443ENS_22PxRepXPropertyAccessorILj443ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj442ENS_22PxRepXPropertyAccessorILj442ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 164; else i1 = (HEAP32[i1 >> 2] | 0) + 164 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 92 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i1 = i6 + 76 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 80 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 84 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 88 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN10GUITexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 52 | 0, i1);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 56 | 0, i1);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i1, i7 + 72 | 0, gb + 385675 | 0, 0);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i6 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) i8 = 7; else {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, gb + 1077991 | 0, gb + 1077991 + 26 | 0, i2 | 0) | 0;
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i8 = 7; else {
   __THREW__ = 0;
   i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474596 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) i8 = 7; else {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (!(i9 & 1)) {
     HEAP32[i5 >> 2] = i2;
     __THREW__ = 0;
     invoke_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i1 | 0);
     i9 = __THREW__;
     __THREW__ = 0;
     if (!(i9 & 1)) {
      __ZNSt3__214__shared_count16__release_sharedEv(i6) | 0;
      STACKTOP = i7;
      return;
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
  }
 }
 if ((i8 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i6) | 0;
 ___resumeException(i1 | 0);
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, HEAP32[i3 + 4 >> 2] | 0);
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i3 + 64 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 68 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 88 | 0);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 40 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = 5;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i5;
 return;
}

function __ZN8DrawUtil28DrawLineOrTrailFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi(i2, i6, i9, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i1 + (i6 * 360 | 0) + 328 >> 2] | 0;
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP16[gb + 1157784 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1157784 | 0, HEAP32[i1 + (i6 * 360 | 0) + 352 >> 2] | 0);
  i2 = gb + 1157784 | 0;
 } else i2 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i4 = __ZN9GfxDevice13GetDynamicVBOEv(i3) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0, i3 | 0, gb + 1162292 | 0, 0);
 i1 = HEAP32[i1 + (i6 * 360 | 0) + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, i1 | 0);
 i6 = HEAP32[i5 + 16 >> 2] | 0;
 i1 = HEAP32[i5 + 152 >> 2] | 0;
 HEAP32[i7 >> 2] = 24;
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i7 + 8 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0;
 i6 = HEAP32[gb + 1157820 + 4 >> 2] | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 mftCall_viiiiiii(i1 | 0, i4 | 0, i5 | 0, i9 | 0, i3 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i6, HEAP32[i9 >> 2] | 0, 0) | 0, i7 | 0, 1);
 __Z15gpu_time_samplev();
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj573ENS_22PxRepXPropertyAccessorILj573ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj502ENS_22PxRepXPropertyAccessorILj502ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj501ENS_22PxRepXPropertyAccessorILj501ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN12AspectRatios8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450070 | 0, i5, i1 + 1 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450074 | 0, i5, i1 + 2 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450078 | 0, i5, i1 + 3 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450084 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450089 | 0, i5, i1, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i6 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) i8 = 7; else {
  __THREW__ = 0;
  invoke_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, gb + 1077991 | 0, gb + 1077991 + 26 | 0, i2 | 0) | 0;
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) i8 = 7; else {
   __THREW__ = 0;
   i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474572 | 0) | 0;
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) i8 = 7; else {
    __THREW__ = 0;
    i2 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
    i9 = __THREW__;
    __THREW__ = 0;
    if (!(i9 & 1)) {
     HEAP8[i5 >> 0] = i2;
     __THREW__ = 0;
     invoke_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i1 | 0);
     i9 = __THREW__;
     __THREW__ = 0;
     if (!(i9 & 1)) {
      __ZNSt3__214__shared_count16__release_sharedEv(i6) | 0;
      STACKTOP = i7;
      return;
     }
    }
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   }
  }
 }
 if ((i8 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__214__shared_count16__release_sharedEv(i6) | 0;
 ___resumeException(i1 | 0);
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags(i9, i6, i2, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i1) {
  __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i6, 0, i2);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i6, HEAP32[i8 + 4 >> 2] | 0, i2);
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + (i5 * 24 | 0) | 0;
 if (i5 | 0) {
  i4 = i9 + 20 | 0;
  i5 = i9 + 16 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i4 >> 2] = gb + 1034351;
   HEAP32[i5 >> 2] = 2;
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i9, i2, gb + 1034360 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 4 | 0, gb + 1034365 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 8 | 0, gb + 1034371 | 0, 0, 0);
   __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i9, i2 + 12 | 0, gb + 1034379 | 0, 0, 0);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 16 | 0;
  }
 }
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 720921 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj541ENS_22PxRepXPropertyAccessorILj541ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj208ENS_22PxRepXPropertyAccessorILj208ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj207ENS_22PxRepXPropertyAccessorILj207ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj261ENS_22PxRepXPropertyAccessorILj261ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx38PxVehicleDriveSimData4WGeneratedValuesC2EPKNS_23PxVehicleDriveSimData4WE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 _memcpy(i2 | 0, i1 | 0, i3 << 3 | 0) | 0;
 HEAP32[i2 + 64 >> 2] = i3;
 i3 = i2 + 80 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 112 | 0, i1 + 112 | 0, 144) | 0;
 i3 = i2 + 256 | 0;
 i4 = i1 + 256 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 _memcpy(i2 + 272 | 0, i1 + 272 | 0, 256) | 0;
 i3 = i2 + 528 | 0;
 i4 = i1 + 528 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 i2 = i2 + 560 | 0;
 i1 = i1 + 560 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __Z18dtDistancePtSegSqrPKfS0_S0_Rf(i5, i1, i2, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f11 = f0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f11 - f7);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(f9 - f8);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(f6 - f3);
 f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f7);
 f8 = Math_fround(Math_fround(HEAPF32[i5 + 4 >> 2]) - f8);
 f3 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f3);
 f4 = Math_fround(Math_fround(Math_fround(f11 * f11) + Math_fround(f9 * f9)) + Math_fround(f6 * f6));
 if (f4 == Math_fround(0.0)) {
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  f11 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f3 * f3));
  return Math_fround(f11);
 } else {
  f4 = Math_fround(Math_fround(Math_fround(Math_fround(f11 * f7) + Math_fround(f8 * f8)) + Math_fround(f6 * f3)) / f4);
  i5 = f4 < Math_fround(0.0);
  i2 = f4 > Math_fround(1.0);
  f4 = i2 ? Math_fround(1.0) : f4;
  f4 = i5 ? Math_fround(0.0) : f4;
  f7 = Math_fround(Math_fround(f11 * f4) - f7);
  f11 = Math_fround(Math_fround(f9 * f4) - f8);
  f9 = Math_fround(Math_fround(f6 * f4) - f3);
  HEAPF32[i10 >> 2] = f4;
  f11 = Math_fround(Math_fround(f9 * f9) + Math_fround(Math_fround(f7 * f7) + Math_fround(f11 * f11)));
  return Math_fround(f11);
 }
 return f0;
}

function __Z14FMOD_FILE_OpenPKciPjPPvS3_(i6, i1, i7, i8, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 24 | 0;
 i1 = i5;
 i2 = i5 + 12 | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(1068, gb + 63328 | 0, 16, gb + 856220 | 0, 185) | 0;
 __ZN12FileAccessorC2Ev(i3);
 if (!i3) {
  i8 = 43;
  STACKTOP = i5;
  return i8 | 0;
 }
 HEAP32[gb + 1459944 >> 2] = (HEAP32[gb + 1459944 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i6, _strlen(i6) | 0);
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i3, i4, 0, 0) | 0) {
  if (i7 | 0) {
   i6 = __ZNK15FileSystemEntry4SizeEv(i4) | 0;
   getTempRet0() | 0;
   HEAP32[i7 >> 2] = i6;
  }
  if (!i8) i1 = 0; else {
   HEAP32[i8 >> 2] = i3;
   i1 = 0;
  }
 } else {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63328 | 0);
  i1 = 23;
 }
 __ZN13FileEntryDataD2Ev(i4);
 i8 = i1;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZNK20LocalFileSystemPosix19GetUserConfigFolderEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = i7 + 16 | 0;
 i3 = i7 + 4 | 0;
 i4 = _getenv(gb + 491503 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, _strlen(i4) | 0);
 i4 = i6 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i7;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 491508 | 0, 15);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, i6, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (__Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6) | 0) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
 HEAP32[i5 >> 2] = i1;
 _printf_console(gb + 491524 | 0, i5);
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
 _mkdir(i1, 448) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx9PxTaskMgr17submitUnnamedTaskERNS_6PxTaskENS_10PxTaskType4EnumE(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i8 + 56 | 0) | 0;
 HEAP32[i1 + 8 >> 2] = i8;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i4 = i8 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i5 = i8 + 76 | 0;
 i6 = i8 + 80 | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = 1;
 HEAP32[i7 + 12 >> 2] = -1;
 HEAP32[i7 + 16 >> 2] = -1;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((HEAP32[i8 + 84 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i8 = (HEAP32[i5 >> 2] | 0) + (i1 * 20 | 0) | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  i8 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i9;
  return i8 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayINS_14PxTaskTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i5, i7) | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i9;
  return i8 | 0;
 }
 return 0;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10EventValueEEEvRNS0_11EventHeaderERT_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = i10 + 80 | 0;
 __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_(i1, i7);
 __ZN5physx7profile10EventValue9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE(i2, i7, i1);
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 - i2 | 0) >>> 0 < (HEAP32[i10 + 44 >> 2] | 0) >>> 0) return;
 i8 = HEAP32[i10 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (i9) i3 = i1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i2;
 i4 = i3 - i1 | 0;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 if (i5) {
  i1 = i10 + 32 | 0;
  i3 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i2 | 0, i4 | 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i9) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 return;
}

function __ZN5physx3Scb14ParticleSystem14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE(i8, i6, i5, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i1 = i10;
 i3 = HEAP32[i8 + 152 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 if (!i4) {
  i2 = i3 + 72 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i1 = i3 + 73 | 0; else {
   i12 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
   i11 = i3 + 73 | 0;
   HEAP32[i1 >> 2] = gb + 699576;
   HEAP32[i1 + 4 >> 2] = i11;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i12, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i1);
   i1 = i11;
  }
  _strncpy(i1, gb + 699576 | 0, 128) | 0;
  HEAP8[i3 + 200 >> 0] = 0;
  HEAP8[i2 >> 0] = 1;
 }
 switch ((HEAP32[i8 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 9; else i1 = 8;
   break;
  }
 default:
  i1 = 9;
 }
 if ((i1 | 0) == 8) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 186, gb + 699279 | 0, i9); else if ((i1 | 0) == 9) __ZN5physx2Sc18ParticleSystemCore14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE(i8 + 12 | 0, i6, i5, i7);
 if (i4) {
  STACKTOP = i10;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj50ENS_22PxRepXPropertyAccessorILj50ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 184; else i1 = (HEAP32[i1 >> 2] | 0) + 184 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj48ENS_22PxRepXPropertyAccessorILj48ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 172; else i1 = (HEAP32[i1 >> 2] | 0) + 172 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj47ENS_22PxRepXPropertyAccessorILj47ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 168; else i1 = (HEAP32[i1 >> 2] | 0) + 168 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj46ENS_22PxRepXPropertyAccessorILj46ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 164; else i1 = (HEAP32[i1 >> 2] | 0) + 164 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj44ENS_22PxRepXPropertyAccessorILj44ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 156; else i1 = (HEAP32[i1 >> 2] | 0) + 156 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj43ENS_22PxRepXPropertyAccessorILj43ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 152; else i1 = (HEAP32[i1 >> 2] | 0) + 152 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj42ENS_22PxRepXPropertyAccessorILj42ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj452ENS_22PxRepXPropertyAccessorILj452ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 164; else i1 = (HEAP32[i1 >> 2] | 0) + 164 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj451ENS_22PxRepXPropertyAccessorILj451ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 160; else i1 = (HEAP32[i1 >> 2] | 0) + 160 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN19SpriteMeshGenerator4path3infEi(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i11 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - i9 | 0;
 i5 = i1 >> 5;
 if ((i1 | 0) < 96) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = i10 + -1 | 0;
 if ((i5 | 0) < (i10 | 0)) i1 = (i1 | 0) % (i5 | 0) | 0; else if ((i10 | 0) <= 0) i1 = i5 + -1 - ((0 - i10 | 0) % (i5 | 0) | 0) | 0;
 f8 = Math_fround(HEAPF32[i9 + (i1 << 5) >> 2]);
 f6 = Math_fround(HEAPF32[i9 + (i1 << 5) + 4 >> 2]);
 if ((i5 | 0) > (i10 | 0)) if ((i10 | 0) > -1) i1 = i10; else i1 = i5 + -1 - ((~i10 | 0) % (i5 | 0) | 0) | 0; else i1 = (i10 | 0) % (i5 | 0) | 0;
 f7 = Math_fround(HEAPF32[i9 + (i1 << 5) >> 2]);
 f2 = Math_fround(HEAPF32[i9 + (i1 << 5) + 4 >> 2]);
 i1 = i10 + 1 | 0;
 if ((i1 | 0) < (i5 | 0)) {
  if ((i10 | 0) <= -2) i1 = i5 + -1 - ((-2 - i10 | 0) % (i5 | 0) | 0) | 0;
 } else i1 = (i1 | 0) % (i5 | 0) | 0;
 f4 = Math_fround(HEAPF32[i9 + (i1 << 5) >> 2]);
 f3 = Math_fround(f6 - Math_fround(HEAPF32[i9 + (i1 << 5) + 4 >> 2]));
 f4 = Math_fround(f4 - f8);
 f2 = Math_fround(Math_fround(Math_fround(-Math_fround(f8 * f3)) - Math_fround(f6 * f4)) + Math_fround(Math_fround(f2 * f4) + Math_fround(f7 * f3)));
 if (f2 > Math_fround(0.0)) i1 = 1; else if (f2 == Math_fround(0.0)) {
  i11 = f3 == Math_fround(0.0);
  i5 = f4 < Math_fround(0.0);
  i1 = f3 < Math_fround(0.0);
  i1 = (((i11 ? i5 : i1) & 1) << 1) + -1 | 0;
 } else i1 = -1;
 HEAP32[i9 + (i10 << 5) + 16 >> 2] = i1;
 i11 = 1;
 return i11 | 0;
}

function __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i9 = i7 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i1 = HEAP8[i8 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i8 >> 0] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP8[i6 + 101 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 HEAP32[i6 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 100 | 0;
 i2 = i4 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 1);
  i9 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  i6 = HEAP8[i4 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i9 >> 2] = i2;
  i9 = i6;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN11PreloadData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i11) {
 i5 = i5 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i11);
 i4 = i5 + 44 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 i9 = i11 + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i10 = i11 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i9 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i6 = i5 + 52 | 0;
 i7 = i5 + 56 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i2 - i1 >> 2;
 HEAP32[i8 >> 2] = i3;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i12;
 return;
}

function __Z36HumanTrait_Get_Custom_PropMuscleNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i6 = i9;
 __ZN10HumanTrait13GetMuscleNameEv(i6);
 i8 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8, 4, (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i8, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i5 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i8 | 0;
}

function __Z14tessDeleteTessP14TESStesselator(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i6;
 i2 = i7 + 104 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i4 = HEAP32[i7 + 76 >> 2] | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (i1 | 0) do {
  i9 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i9 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  __Z18tessMeshDeleteMeshP9TESSallocP8TESSmesh(i6, i1);
  HEAP32[i7 >> 2] = 0;
 }
 i1 = i7 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[i6 + 8 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[i6 + 8 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i7 + 96 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i4) {
  mftCall_vii(i2 | 0, i1 | 0, i7 | 0);
  STACKTOP = i8;
  return;
 }
 mftCall_vii(i2 | 0, i1 | 0, i4 | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vii(i2 | 0, i1 | 0, i7 | 0);
 STACKTOP = i8;
 return;
}

function _tt_cmap13_validate(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i5 = i1 + 16 | 0;
 i3 = i9 + 8 | 0;
 if (i5 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i9, 8);
 i2 = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
 i10 = (HEAPU8[i1 + 13 >> 0] | 0) << 16 | (HEAPU8[i1 + 12 >> 0] | 0) << 24 | (HEAPU8[i1 + 14 >> 0] | 0) << 8 | (HEAPU8[i1 + 15 >> 0] | 0);
 if (i2 >>> 0 < 16 ? 1 : i2 >>> 0 > ((HEAP32[i3 >> 2] | 0) - i1 | 0) >>> 0) i4 = 5; else if ((((i2 + -16 | 0) >>> 0) / 12 | 0) >>> 0 < i10 >>> 0) i4 = 5;
 if ((i4 | 0) == 5) _UNITY_ft_validator_error(i9, 8);
 if (!i10) return 0;
 i7 = i9 + 12 | 0;
 i8 = i9 + 20 | 0;
 i1 = 0;
 i2 = 0;
 do {
  i6 = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
  i3 = i2;
  i2 = (HEAPU8[i5 + 5 >> 0] | 0) << 16 | (HEAPU8[i5 + 4 >> 0] | 0) << 24 | (HEAPU8[i5 + 6 >> 0] | 0) << 8 | (HEAPU8[i5 + 7 >> 0] | 0);
  i4 = (HEAPU8[i5 + 9 >> 0] | 0) << 16 | (HEAPU8[i5 + 8 >> 0] | 0) << 24 | (HEAPU8[i5 + 10 >> 0] | 0) << 8 | (HEAPU8[i5 + 11 >> 0] | 0);
  i5 = i5 + 12 | 0;
  if (i6 >>> 0 > i2 >>> 0) _UNITY_ft_validator_error(i9, 8);
  if (!((i1 | 0) == 0 | i6 >>> 0 > i3 >>> 0)) _UNITY_ft_validator_error(i9, 8);
  if (HEAP32[i7 >> 2] | 0) if (i4 >>> 0 >= (HEAP32[i8 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i9, 16);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 return 0;
}

function __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 60 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i1, i2 - i4 | 0);
  STACKTOP = i10;
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i4 = i3 + (i2 * 60 | 0) | 0;
 if ((i5 | 0) == (i4 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 4 | 0;
 i7 = i8 + 4 | 0;
 i3 = i5;
 do {
  i2 = i3 + -60 | 0;
  HEAP32[i9 >> 2] = i2;
  i1 = i3 + -20 | 0;
  if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + -44 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i3 + -32 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i6 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i3 + -48 >> 2] | 0;
   HEAP32[i8 >> 2] = 66;
   HEAP32[i7 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i8);
  }
  i3 = HEAP32[i9 >> 2] | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i10;
 return;
}

function __ZN5physx36solveContactCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0, f14 = f0, i15 = 0;
 __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP16[i1 + 2 >> 1] | 0;
 i5 = i1 + (i4 & 65535) | 0;
 i6 = (HEAP8[i1 >> 0] | 0) == 7 ? 272 : 176;
 if (!(i4 << 16 >> 16)) return; else i4 = i1;
 while (1) {
  i1 = i4 + 112 | 0;
  i2 = HEAP8[i4 + 1 >> 0] | 0;
  if (i2 << 24 >> 24) {
   i3 = i2 & 255;
   i2 = 0;
   while (1) {
    i13 = i1 + 144 | 0;
    f14 = Math_fround(HEAPF32[i13 >> 2]);
    i11 = i1 + 148 | 0;
    f12 = Math_fround(HEAPF32[i11 >> 2]);
    i9 = i1 + 152 | 0;
    f10 = Math_fround(HEAPF32[i9 >> 2]);
    i7 = i1 + 156 | 0;
    f8 = Math_fround(HEAPF32[i7 >> 2]);
    i15 = f14 > Math_fround(0.0);
    f14 = i15 ? f14 : Math_fround(0.0);
    i15 = f12 > Math_fround(0.0);
    f12 = i15 ? f12 : Math_fround(0.0);
    i15 = f10 > Math_fround(0.0);
    f10 = i15 ? f10 : Math_fround(0.0);
    i15 = f8 > Math_fround(0.0);
    f8 = i15 ? f8 : Math_fround(0.0);
    HEAPF32[i13 >> 2] = f14;
    HEAPF32[i11 >> 2] = f12;
    HEAPF32[i9 >> 2] = f10;
    HEAPF32[i7 >> 2] = f8;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i6 | 0;
   }
   i1 = i4 + ((Math_imul(i3, i6) | 0) + 112) | 0;
  }
  if (i1 >>> 0 < i5 >>> 0) i4 = i1; else break;
 }
 return;
}

function __ZN5physx17EdgeChangeManager4initEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 1 | 0;
 i2 = i5 + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i2 >> 2] = i4;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 4, gb + 681489 | 0, 1546) | 0;
  HEAP32[i5 >> 2] = i3;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = i3 + (i4 << 2);
  HEAP32[i5 + 24 >> 2] = i3 + (i4 * 3 << 2);
  HEAP32[i5 + 16 >> 2] = i3 + (i4 << 1 << 2);
  HEAP32[i5 + 32 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 i3 = i5 + 32 | 0;
 if ((HEAP32[i3 >> 2] | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i6;
  return;
 }
 i12 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 4, gb + 681489 | 0, 1659) | 0;
 i11 = i12 + (i4 << 2) | 0;
 i9 = i12 + (i4 << 1 << 2) | 0;
 i7 = i12 + (i4 * 3 << 2) | 0;
 _memcpy(i12 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] << 2 | 0) | 0;
 i10 = i5 + 8 | 0;
 _memcpy(i11 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i5 + 12 >> 2] << 2 | 0) | 0;
 i8 = i5 + 24 | 0;
 _memcpy(i9 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 + 28 >> 2] << 2 | 0) | 0;
 i1 = i5 + 16 | 0;
 _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 20 >> 2] << 2 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i12;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN18JobBatchDispatcher26ScheduleJobForEachInternalER8JobFencePFvPvjES2_iPFvS2_ERKS0_(i10, i1, i11, i12, i13, i14, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i10 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 12 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 4, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 4 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i3;
 __Z16RecordForEachJobPFvPvjES_jPFvS_ER21SingleThreadedJobInfo(i11, i12, i13, i14, (HEAP32[i8 >> 2] | 0) + (i2 << 4) | 0);
 if ((HEAP32[i10 + 16 >> 2] | 0) == -1) return;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo((HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN17BillboardRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 64 | 0;
 i3 = i8 + 52 | 0;
 i4 = i8 + 40 | 0;
 i5 = i8 + 12 | 0;
 i6 = i8 + 24 | 0;
 i7 = i8;
 __ZN8Renderer19UpdateTransformInfoEv(i1);
 if (!(HEAP8[i1 + 272 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetRotationEv(i2, i9);
 __ZNK9Transform18GetWorldScaleLossyEv(i3, i9);
 __ZNK9Transform11GetPositionEv(i4, i9);
 HEAP32[i1 + 364 >> 2] = HEAP32[i3 >> 2];
 i9 = i3 + 4 | 0;
 HEAP32[i1 + 368 >> 2] = HEAP32[i9 >> 2];
 __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i5, i2, 4);
 f10 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 HEAPF32[i1 + 372 >> 2] = Math_fround(f10 - Math_fround(Math_fround(Math_floor(Math_fround(f10 / Math_fround(6.28318548)))) * Math_fround(6.28318548)));
 i5 = i1 + 36 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i5, i4, i6, i7);
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1 + 188 | 0, i5, i1 + 164 | 0);
 STACKTOP = i8;
 return;
}

function __ZN14NavMeshManager15LoadNavMeshDataEiPK11NavMeshData(i2, i10, i7) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!i7) return;
 i3 = i2 + 136 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 L4 : do if (!i6) i8 = 6; else {
  i5 = HEAP32[i4 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0) == (i7 | 0)) {
    i9 = i6;
    break L4;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i6 >>> 0) {
    i8 = 6;
    break;
   }
  }
 } while (0);
 if ((i8 | 0) == 6) {
  __ZN14NavMeshManager8LoadDataEPK11NavMeshData(i2, i7) | 0;
  i9 = HEAP32[i3 >> 2] | 0;
  i4 = i9;
  i9 = HEAP32[i9 + 12 >> 2] | 0;
 }
 i2 = i7;
 i3 = i4 + 12 | 0;
 i5 = i9 + 1 | 0;
 i6 = i4 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 << 3, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i4 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 + (i9 << 3) >> 2] = i10;
 HEAP32[i8 + (i9 << 3) + 4 >> 2] = i2;
 return;
}

function __ZN13MemoryManager24LogDeallocationToConsoleEPvjPKc(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i3 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i3;
  if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i7 = i1;
   break;
  }
 } else i7 = i1; while (0);
 i1 = HEAP32[i7 + 1556 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 i3 = i7 + 1544 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i10 = HEAP32[i7 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 40 >> 2] | 0, i10 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = 0;
 do {
  i2 = HEAP32[i7 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 512);
 i10 = i1 - i5 | 0;
 d11 = +Math_fround(Math_fround(i10 >>> 0) * Math_fround(9.53674316e-07));
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i4;
 HEAP32[i8 + 8 >> 2] = 0 - i5;
 HEAPF64[i8 + 16 >> 3] = d11;
 HEAP32[i8 + 24 >> 2] = i10;
 _printf_console(gb + 582400 | 0, i8);
 STACKTOP = i9;
 return;
}

function __ZN10MonoScriptC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 65032 + 8;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i1 + 92 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP8[i1 + 140 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z19SetLightScissorRectPK5RectTIfEbRS1_bR9GfxDevice(i1, i2, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f3 = f0, f4 = f0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 16 | 0;
 i9 = i10;
 i1 = i1 + ((i2 ? HEAP32[i7 + 4208 >> 2] | 0 : 0) << 4) | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 f4 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 12 >> 2]);
 f3 = Math_fround(f4 * Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i8 >> 2] = f3;
 i1 = i8 + 8 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f4 * Math_fround(HEAPF32[i1 >> 2]));
 i1 = i8 + 4 | 0;
 f4 = Math_fround(f11 * Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 i2 = i8 + 12 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f11 * Math_fround(HEAPF32[i2 >> 2]));
 if (i6) {
  __Z14RectfToRectIntRK5RectTIfE(i9, i8);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = i8 + 160 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i8 | 0, i7 | 0, i9 | 0);
  STACKTOP = i10;
  return;
 }
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 f11 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 HEAPF32[i8 >> 2] = Math_fround(f12 + f3);
 HEAPF32[i1 >> 2] = Math_fround(f11 + f4);
 __Z14RectfToRectIntRK5RectTIfE(i9, i8);
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = i8 + 160 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(i8 | 0, i7 | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function _regfree(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if (i6 | 0) {
  i4 = i6 + 4 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i3 = 0;
   do {
    if (HEAP32[i1 + (i3 << 5) + 8 >> 2] | 0) {
     i2 = HEAP32[i1 + (i3 << 5) + 16 >> 2] | 0;
     if (i2) {
      _free(i2);
      i1 = HEAP32[i6 >> 2] | 0;
     }
     i2 = HEAP32[i1 + (i3 << 5) + 28 >> 2] | 0;
     if (i2) {
      _free(i2);
      i1 = HEAP32[i6 >> 2] | 0;
     }
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  if (i1 | 0) _free(i1);
  i3 = i6 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   if (HEAP32[i1 + 8 >> 2] | 0) {
    while (1) {
     i2 = HEAP32[i1 + 16 >> 2] | 0;
     if (i2 | 0) _free(i2);
     if (!(HEAP32[i1 + 40 >> 2] | 0)) break; else i1 = i1 + 32 | 0;
    }
    i1 = HEAP32[i3 >> 2] | 0;
   }
   _free(i1);
  }
  i4 = i6 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i5 = i6 + 28 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if (i2) {
    i3 = 0;
    while (1) {
     i1 = HEAP32[i1 + (i3 * 12 | 0) + 8 >> 2] | 0;
     if (i1) {
      _free(i1);
      i2 = HEAP32[i5 >> 2] | 0;
     }
     i1 = i3 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) break;
     i3 = i1;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    i1 = HEAP32[i4 >> 2] | 0;
   }
   _free(i1);
  }
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (i1 | 0) _free(i1);
  i1 = HEAP32[i6 + 20 >> 2] | 0;
  if (i1 | 0) _free(i1);
  i1 = HEAP32[i6 + 36 >> 2] | 0;
  if (i1 | 0) _free(i1);
  _free(i6);
 }
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 48 | 0) + 1 | 0;
 if (i3 >>> 0 > 89478485) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i5 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 48 | 0;
 i7 = i5 << 1;
 i3 = i5 >>> 0 < 44739242 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 89478485;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 48 | 0) | 0;
 i2 = i4 + (((i2 - i1 | 0) / 48 | 0) * 48 | 0) | 0;
 i5 = i2;
 i7 = i4 + (i3 * 48 | 0) | 0;
 __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i6);
 i6 = i2 + 48 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -48 | 0;
   __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2 + -48 | 0, i1);
   i2 = i3 + -48 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -48 | 0;
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE16__construct_nodeERKNS_4pairIKS4_S6_EE(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i2 = i8;
 i1 = i1 + 4 | 0;
 if (!(HEAP8[gb + 1098104 >> 0] | 0)) {
  i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i4 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i11 = gb + 63696 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i2;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i4, 1, gb + 1018240 | 0, 56, 32768, i3, 16);
  HEAP32[gb + 1158356 >> 2] = i4;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i4);
  if (i5) __Z19pop_allocation_rootv();
  i11 = gb + 1098104 | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = 0;
 }
 i5 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1158356 >> 2] | 0, 56) | 0;
 i4 = i5;
 i5 = i5 + 16 | 0;
 i2 = i6;
 i3 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  i5 = i5 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i5 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = i4;
 i11 = i7 + 4 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = 1;
 STACKTOP = i8;
 return;
}

function __ZNSt3__214__split_bufferIP4NodeNS_9allocatorIS2_EEE10push_frontERKS2_(i9, i13) {
 i9 = i9 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = i9 + 4 | 0;
 i11 = HEAP32[i14 >> 2] | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 i3 = i12;
 do if ((i11 | 0) == (i12 | 0)) {
  i12 = i9 + 8 | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  i10 = i9 + 12 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = i8;
  if (i2 >>> 0 < i8 >>> 0) {
   i3 = i2;
   i5 = ((i1 - i3 >> 2) + 1 | 0) / 2 | 0;
   i1 = i2 + (i5 << 2) | 0;
   i3 = i3 - i11 | 0;
   i10 = i3 >> 2;
   i4 = i1 + (0 - i10 << 2) | 0;
   if (i10) {
    _memmove(i4 | 0, i11 | 0, i3 | 0) | 0;
    i1 = i4;
    i2 = HEAP32[i12 >> 2] | 0;
   }
   HEAP32[i14 >> 2] = i1;
   HEAP32[i12 >> 2] = i2 + (i5 << 2);
   break;
  }
  i8 = i1 - i3 >> 1;
  i8 = (i8 | 0) == 0 ? 1 : i8;
  i5 = __Znwj(i8 << 2) | 0;
  i6 = i5;
  i1 = i5 + ((i8 + 3 | 0) >>> 2 << 2) | 0;
  i7 = i1;
  i8 = i5 + (i8 << 2) | 0;
  if ((i11 | 0) == (i2 | 0)) {
   i3 = i7;
   i2 = i11;
  } else {
   i5 = i1;
   i3 = i7;
   i4 = i11;
   do {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i3 + 4 | 0;
    i3 = i5;
    i4 = i4 + 4 | 0;
   } while ((i4 | 0) != (i2 | 0));
   i2 = HEAP32[i9 >> 2] | 0;
  }
  HEAP32[i9 >> 2] = i6;
  HEAP32[i14 >> 2] = i7;
  HEAP32[i12 >> 2] = i3;
  HEAP32[i10 >> 2] = i8;
  if (i2) {
   __ZdlPv(i2);
   i1 = HEAP32[i14 >> 2] | 0;
  }
 } else i1 = i11; while (0);
 HEAP32[i1 + -4 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + -4;
 return;
}

function __ZNK5physx2Cm10Collection4findEy(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = _i64Add(-1, ~i4 | 0, i4 | 0, i5 | 0) | 0;
 i3 = getTempRet0() | 0;
 i8 = _bitshift64Lshr(i6 | 0, i3 | 0, 22) | 0;
 i6 = i8 ^ i6;
 i3 = (getTempRet0() | 0) ^ i3;
 i8 = _bitshift64Shl(i6 | 0, i3 | 0, 13) | 0;
 i8 = _i64Add(i6 | 0, i3 | 0, ~i8 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i3 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i8 | 0, i3 | 0, 8) | 0;
 i3 = ___muldi3(i6 ^ i8 | 0, (getTempRet0() | 0) ^ i3 | 0, 9, 0) | 0;
 i8 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i3 | 0, i8 | 0, 15) | 0;
 i3 = i6 ^ i3;
 i8 = (getTempRet0() | 0) ^ i8;
 i6 = _bitshift64Shl(i3 | 0, i8 | 0, 27) | 0;
 i6 = _i64Add(i3 | 0, i8 | 0, ~i6 | 0, ~(getTempRet0() | 0) | 0) | 0;
 i8 = getTempRet0() | 0;
 i3 = _bitshift64Lshr(i6 | 0, i8 | 0, 31) | 0;
 (getTempRet0() | 0) ^ i8;
 i1 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + ((i1 + -1 & (i3 ^ i6)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i8 = 0;
  return i8 | 0;
 }
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = i2 + 12 | 0;
 while (1) {
  i2 = i6 + (i1 << 4) | 0;
  i8 = i2;
  if ((HEAP32[i8 >> 2] | 0) == (i4 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i5 | 0) : 0) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return i1 | 0;
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = HEAP32[i6 + (i1 << 4) + 8 >> 2] | 0;
 return i8 | 0;
}

function __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i12, i11) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i11 + 28 >> 2] | 0, gb + 31312 | 0) | 0;
 if (i7 | 0) {
  i8 = i12 + 428 | 0;
  i9 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = i12 + 440 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = i2 + 1 | 0;
  i4 = i12 + 444 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i3 >>> 0 > i6 >>> 0) {
   i1 = i5 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i4 >> 2] = i1;
    HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i12 + 432 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i12 + 432 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    HEAP32[i8 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i3;
  HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i9;
  __ZN6Object8AddEventEPFvPvS0_iES0_(i7, fb + 915 | 0, i12);
 }
 i1 = HEAP32[i11 + 80 >> 2] | 0;
 i11 = HEAP32[i11 + 92 >> 2] | 0;
 i2 = i1 + (i11 << 2) | 0;
 if (!i11) return;
 do {
  __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i12, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj64ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 5 | 0;
 i4 = i11;
 i5 = i11 + 4 | 0;
 i10 = i8 + 4 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 switch (i6 >>> 30 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0) i1 = 6;
   break;
  }
 default:
  {}
 }
 if ((i1 | 0) == 6) {
  i2 = i8 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i8 >> 2] | 0, i6 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP8[i1 + 52 >> 0] = HEAP8[i9 >> 0] | 0;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i8 >> 2] | 0, i8);
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 64;
  STACKTOP = i11;
  return;
 }
 i2 = HEAP8[i7 + 64 >> 0] | 0;
 HEAP8[i3 >> 0] = HEAP8[i9 >> 0] | 0;
 __ZN5physx2Sc9ShapeCore8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i7, i3);
 i1 = HEAP32[i8 + -32 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 if ((HEAP32[i10 >> 2] & -1073741824 | 0) == 1073741824) {
  STACKTOP = i11;
  return;
 }
 HEAP32[i4 >> 2] = 64;
 HEAP8[i5 >> 0] = i2;
 __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i7, i4, i5);
 STACKTOP = i11;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj509ENS_22PxRepXPropertyAccessorILj509ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj505ENS_22PxRepXPropertyAccessorILj505ENS_8PxSpringEffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj91ENS_22PxRepXPropertyAccessorILj91ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 40; else i1 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj90ENS_22PxRepXPropertyAccessorILj90ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 36; else i1 = (HEAP32[i1 >> 2] | 0) + 36 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj89ENS_22PxRepXPropertyAccessorILj89ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj293ENS_22PxRepXPropertyAccessorILj293ES4_NS_19PxHeightFieldFormat4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 673360 | 0)) i1 = 0; else {
  i3 = gb + 673360 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 89672 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 89672 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx23PxsFluidDynamicsSphTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 800 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i12 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i12 + 80 >> 2] | 0) + 72 >> 2] | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 20 >> 2] | 0;
 i7 = HEAP32[i12 + 84 >> 2] | 0;
 i8 = HEAP32[i12 + 88 >> 2] | 0;
 i3 = HEAP16[i12 + 512 + (i1 << 2) >> 1] | 0;
 i9 = i12 + 512 + (i1 << 2) + 2 | 0;
 i2 = HEAP16[i9 >> 1] | 0;
 if ((i3 & 65535) >= (i2 & 65535)) {
  STACKTOP = i14;
  return;
 }
 i10 = i12 + 152 | 0;
 i4 = i12 + 160 + (i1 * 44 | 0) | 0;
 i5 = i3 & 65535;
 while (1) {
  i1 = i11 + (i5 << 4) | 0;
  if ((HEAP32[i11 + (i5 << 4) + 8 >> 2] | 0) != -1) {
   __ZN5physx19PxsFluidSpatialHash14getHaloRegionsERNS_25PxsFluidPacketHaloRegionsERKNS_17PxcGridCellVectorEPKNS_15PxsParticleCellEPKNS_22PxsFluidPacketSectionsEj(i13, i1, i11, i6, 1024);
   __ZN5physx16PxsFluidDynamics12updatePacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i12, HEAP32[i10 >> 2] | 0, i8, i7, i1, i6 + (i5 * 216 | 0) | 0, i13, i4);
   i2 = HEAP16[i9 >> 1] | 0;
  }
  i1 = i3 + 1 << 16 >> 16;
  if ((i1 & 65535) < (i2 & 65535)) {
   i5 = i1 & 65535;
   i3 = i1;
  } else break;
 }
 STACKTOP = i14;
 return;
}

function __ZN21UnityAnalyticsManager15ThreadedCleanupEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 32 | 0;
 L1 : do if (HEAP8[i1 >> 0] | 0) {
  HEAP8[i1 >> 0] = 0;
  i6 = __ZN15GlobalCallbacks3GetEv() | 0;
  i7 = i6 + 18524 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  if (i5 | 0) {
   i1 = 0;
   while (1) {
    i4 = i6 + 17756 + (i1 * 12 | 0) | 0;
    if ((HEAP32[i4 >> 2] | 0) == (fb + 199 | 0)) {
     i3 = i6 + 17756 + (i1 * 12 | 0) + 8 | 0;
     i2 = i6 + 17756 + (i1 * 12 | 0) + 4 | 0;
     if (!(HEAP8[i3 >> 0] | 0)) break;
     if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
    }
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i5 >>> 0) break L1;
   }
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   HEAP8[i3 >> 0] = 0;
   i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i5;
   if (i5 >>> 0 > i1 >>> 0) do {
    i5 = i1;
    i1 = i1 + 1 | 0;
    HEAP32[i6 + 17756 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 17756 + (i1 * 12 | 0) >> 2];
    HEAP32[i6 + 17756 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 17756 + (i1 * 12 | 0) + 4 >> 2];
    HEAP8[i6 + 17756 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0;
   } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
 } while (0);
 i1 = i8 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!(HEAP32[i8 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63800 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10AudioMixer14UpdateMuteSoloEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return;
 i9 = i7 + 72 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i8 = i5 + 4 | 0;
 i8 = i8 + (HEAP32[i8 >> 2] | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (i2 | 0) == 0;
 if (!i3) {
  i1 = 0;
  i4 = 0;
  do {
   i4 = (HEAPU8[i8 + (i1 << 4) + 13 >> 0] | i4 & 1 | 0) != 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  if (!i3) {
   i6 = i7 + 76 | 0;
   if (i4) {
    i4 = 0;
    i3 = i5;
    do {
     i1 = i4;
     do {
      i2 = (HEAP8[i8 + (i1 << 4) + 13 >> 0] | 0) == 0;
      if (!i2) break;
      i1 = HEAP32[i8 + (i1 << 4) >> 2] | 0;
     } while ((i1 | 0) > -1);
     __ZN5audio5mixer21SetResultingMuteStateERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEib(i3, HEAP32[i6 >> 2] | 0, i4, i2);
     i4 = i4 + 1 | 0;
     i3 = HEAP32[i9 >> 2] | 0;
    } while (i4 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   } else {
    i4 = 0;
    i3 = i5;
    do {
     i1 = i4;
     do {
      i2 = HEAP8[i8 + (i1 << 4) + 12 >> 0] | 0;
      if (i2 << 24 >> 24) break;
      i1 = HEAP32[i8 + (i1 << 4) >> 2] | 0;
     } while ((i1 | 0) > -1);
     __ZN5audio5mixer21SetResultingMuteStateERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEib(i3, HEAP32[i6 >> 2] | 0, i4, i2 << 24 >> 24 != 0);
     i4 = i4 + 1 | 0;
     i3 = HEAP32[i9 >> 2] | 0;
    } while (i4 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
  }
 }
 __ZN10AudioMixer24ReassignAllChannelGroupsEv(i7);
 return;
}

function __ZL17Transfer_GUIStyleI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 256 | 0;
 i3 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 HEAP32[i6 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i6);
 if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (i1 | 0) {
  i2 = __Z9GetIIMGUIv() | 0;
  __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i3, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0, gb + 1034525 | 0, 1);
  if (HEAP32[i3 >> 2] | 0) {
   i8 = i3;
   i2 = HEAP32[i8 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i1, i6);
   HEAP32[i6 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
  }
 }
 STACKTOP = i7;
 return;
}

function _unity_z_inflateCopy(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 if ((i8 | 0) == 0 | (i5 | 0) == 0) {
  i9 = -2;
  return i9 | 0;
 }
 i9 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i9) {
  i9 = -2;
  return i9 | 0;
 }
 i2 = i5 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i9 = -2;
  return i9 | 0;
 }
 i3 = i5 + 36 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i9 = -2;
  return i9 | 0;
 }
 i4 = i5 + 40 | 0;
 i6 = mftCall_iiii(i1 | 0, HEAP32[i4 >> 2] | 0, 1, 9520) | 0;
 if (!i6) {
  i9 = -4;
  return i9 | 0;
 }
 i7 = i9 + 52 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i4 = 0; else {
  i1 = mftCall_iiii(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, 1 << HEAP32[i9 + 36 >> 2] | 0, 1) | 0;
  if (!i1) {
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6 | 0);
   i9 = -4;
   return i9 | 0;
  } else i4 = i1;
 }
 i3 = i8;
 i1 = i5;
 i2 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 _memcpy(i6 | 0, i9 | 0, 9520) | 0;
 i2 = HEAP32[i9 + 76 >> 2] | 0;
 i1 = i9 + 1328 | 0;
 i3 = i6 + 1328 | 0;
 if (!(i2 >>> 0 < i1 >>> 0 | i2 >>> 0 > (i9 + 9516 | 0) >>> 0)) {
  HEAP32[i6 + 76 >> 2] = i3 + (i2 - i1 >> 2 << 2);
  HEAP32[i6 + 80 >> 2] = i3 + ((HEAP32[i9 + 80 >> 2] | 0) - i1 >> 2 << 2);
 }
 HEAP32[i6 + 108 >> 2] = i3 + ((HEAP32[i9 + 108 >> 2] | 0) - i1 >> 2 << 2);
 if (i4 | 0) _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, 1 << HEAP32[i9 + 36 >> 2] | 0) | 0;
 HEAP32[i6 + 52 >> 2] = i4;
 HEAP32[i8 + 28 >> 2] = i6;
 i9 = 0;
 return i9 | 0;
}

function __ZN6prcore9BlitImageERK14ImageReferenceRS0_ii(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 20 | 0;
 i9 = i11;
 i10 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i13 = (HEAP32[i4 + 4 >> 2] | 0) + i6 | 0;
 i12 = (HEAP32[i4 + 8 >> 2] | 0) + i7 | 0;
 i1 = (i6 | 0) > 0 ? i6 : 0;
 i3 = (i7 | 0) > 0 ? i7 : 0;
 i10 = ((i10 | 0) > (i13 | 0) ? i13 : i10) - i1 | 0;
 i10 = (i10 | 0) < 0 ? 0 : i10;
 i2 = ((i2 | 0) > (i12 | 0) ? i12 : i2) - i3 | 0;
 i2 = (i2 | 0) < 0 ? 0 : i2;
 if ((i10 | 0) == 0 | (i2 | 0) == 0) {
  STACKTOP = i11;
  return;
 }
 i14 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(HEAP32[i5 >> 2] | 0) | 0) + 4 >> 2] | 0;
 i13 = HEAP32[(__Z20GetTextureFormatInfo13TextureFormat(HEAP32[i4 >> 2] | 0) | 0) + 4 >> 2] | 0;
 i15 = HEAP32[i5 + 12 >> 2] | 0;
 i14 = (HEAP32[i5 + 16 >> 2] | 0) + (Math_imul(i15, i3) | 0) + (Math_imul(i14, i1) | 0) | 0;
 i12 = i4 + 12 | 0;
 i13 = (HEAP32[i4 + 16 >> 2] | 0) + (Math_imul(HEAP32[i12 >> 2] | 0, i3 - i7 | 0) | 0) + (Math_imul(i13, i1 - i6 | 0) | 0) | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i8, i10, i2, i15, HEAP32[i5 >> 2] | 0, i14);
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i9, i10, i2, HEAP32[i12 >> 2] | 0, HEAP32[i4 >> 2] | 0, i13);
 __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i9, i8, 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i1 + 1 | 0;
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 900348 | 0, i2, HEAPU8[i3 >> 0] & 3);
 __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 660697 | 0, i2 + 8 | 0, (HEAPU8[i3 >> 0] | 0) >>> 2 & 3);
 i3 = i2 + 16 | 0;
 i1 = i4 + 8 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 4) {
   HEAP8[i3 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
   i7 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i5 = i3 + 1 | 0;
   HEAP8[i5 >> 0] = HEAP8[i7 >> 0] | 0;
   i7 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i1 = i3 + 2 | 0;
   HEAP8[i1 >> 0] = HEAP8[i7 >> 0] | 0;
   i7 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i7;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i6 = i3 + 3 | 0;
   HEAP8[i6 >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i4 = HEAP8[i3 >> 0] | 0;
   HEAP8[i3 >> 0] = HEAP8[i6 >> 0] | 0;
   HEAP8[i6 >> 0] = i4;
   i4 = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = i4;
   return;
  }
 }
 HEAP8[i1 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_19PxsArticulationLinkENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 680583 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN19MeshParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 220 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 221 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 224 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 228 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __GLOBAL__sub_I_runtime_graphics4_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158256 | 0, gb + 406423 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158268 | 0, gb + 406457 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158280 | 0, gb + 406488 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158292 | 0, gb + 406508 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158304 | 0, gb + 406537 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158316 | 0, gb + 406575 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158232 | 0, gb + 406600 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1158244 | 0, gb + 406624 | 0, 0, 0);
 HEAP32[gb + 1158220 >> 2] = gb + 1158220;
 HEAP32[gb + 1158220 + 4 >> 2] = gb + 1158220;
 HEAP32[gb + 1158208 >> 2] = gb + 1158208;
 HEAP32[gb + 1158208 + 4 >> 2] = gb + 1158208;
 HEAP32[gb + 1158328 >> 2] = gb + 1158328;
 HEAP32[gb + 1158328 + 4 >> 2] = gb + 1158328;
 HEAP32[gb + 1158336 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1158336 | 0, gb + 406648 | 0);
 HEAP32[gb + 1158340 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1158340 | 0, gb + 1046318 | 0);
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags(i8, i7, i1, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i8 + 40 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i7, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i7, HEAP32[i6 + 4 >> 2] | 0);
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + (i4 * 24 | 0) | 0;
 if (i4 | 0) {
  i4 = i8 + 20 | 0;
  i2 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = gb + 1033949;
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i8, i1, gb + 1033960 | 0, 0, 0);
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i8, i1 + 4 | 0, gb + 1033967 | 0, 0, 0);
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i8, i1 + 8 | 0, gb + 1033975 | 0, 0, 0);
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i8, i1 + 12 | 0, gb + 1033981 | 0, 0, 0);
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 670846 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj437ENS_22PxRepXPropertyAccessorILj437ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 428; else i1 = (HEAP32[i1 >> 2] | 0) + 428 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj436ENS_22PxRepXPropertyAccessorILj436ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 424; else i1 = (HEAP32[i1 >> 2] | 0) + 424 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj84ENS_22PxRepXPropertyAccessorILj84ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __Z34HumanTrait_Get_Custom_PropBoneNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i6 = i9;
 __ZN10HumanTrait11GetBoneNameEv(i6);
 i8 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8, 4, (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 4) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i10 = i1 + (i3 << 4) | 0;
   i2 = HEAP8[i10 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i8, i3, __Z20scripting_string_newPKcj(i4 ? HEAP32[i10 >> 2] | 0 : i10, i4 ? HEAP32[i1 + (i3 << 4) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while (i3 >>> 0 < i2 - i1 >> 4 >>> 0);
 }
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i5 + 4 | 0;
  do {
   i1 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i8 | 0;
}

function __Z23ConvertImageToDoubleLDRR14ImageReference(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 4 | 0;
 i6 = i10;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 if ((i8 | 0) <= 0) {
  STACKTOP = i10;
  return;
 }
 if ((i7 | 0) > 0) i2 = 0; else {
  STACKTOP = i10;
  return;
 }
 do {
  i1 = i4 + (Math_imul(i2, i9) | 0) | 0;
  i3 = 0;
  while (1) {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   i11 = i1 + 4 | 0;
   f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.5));
   HEAPF32[i5 >> 2] = f13;
   HEAPF32[i6 >> 2] = Math_fround(1.0);
   i12 = f13 > Math_fround(1.0);
   HEAP32[i11 >> 2] = HEAP32[(i12 ? i6 : i5) >> 2];
   i11 = i1 + 8 | 0;
   f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.5));
   HEAPF32[i5 >> 2] = f13;
   HEAPF32[i6 >> 2] = Math_fround(1.0);
   i12 = f13 > Math_fround(1.0);
   HEAP32[i11 >> 2] = HEAP32[(i12 ? i6 : i5) >> 2];
   i11 = i1 + 12 | 0;
   f13 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.5));
   HEAPF32[i5 >> 2] = f13;
   HEAPF32[i6 >> 2] = Math_fround(1.0);
   i12 = f13 > Math_fround(1.0);
   HEAP32[i11 >> 2] = HEAP32[(i12 ? i6 : i5) >> 2];
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else i1 = i1 + 16 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i8 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i7 + 4 | 0;
  do {
   HEAP32[i8 >> 2] = i2 + -88;
   i3 = i2 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i5 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i7);
   }
   i3 = HEAP32[i2 + -36 >> 2] | 0;
   if (i3 | 0) {
    i4 = i2 + -32 | 0;
    if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
    __ZdlPv(i3);
   }
   i3 = HEAP32[i2 + -64 >> 2] | 0;
   if (i3 | 0) {
    i4 = i2 + -60 | 0;
    if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
    __ZdlPv(i3);
   }
   i3 = HEAP32[i2 + -80 >> 2] | 0;
   if (i3 | 0) {
    i2 = i2 + -76 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i3;
    __ZdlPv(i3);
   }
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 25;
 HEAP32[i7 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_(i1, i3, i5, i6, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i7 = i1 + 12 | 0;
 HEAP32[i7 >> 2] = i2;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255;
 if (i4 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 i3 = (i2 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i3) + i5 | 0;
 i2 = i4 - i5 | 0;
 i2 = i2 >>> 0 < i6 >>> 0 ? i2 : i6;
 if (i2 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i9 = 6;
 } else if (i2 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i2;
  if (!i2) {
   i9 = i1;
   i9 = i9 + i2 | 0;
   HEAP8[i9 >> 0] = 0;
   STACKTOP = i10;
   return;
  }
 } else i9 = 6;
 if ((i9 | 0) == 6) {
  i6 = i2 + 16 & -16;
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i9;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i8, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i2;
  i1 = i9;
 }
 _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 i9 = i1;
 i9 = i9 + i2 | 0;
 HEAP8[i9 >> 0] = 0;
 STACKTOP = i10;
 return;
}

function __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) {
  i7 = i1;
  return i7 | 0;
 }
 i5 = 11 - (HEAP8[i7 + 11 >> 0] | 0) | 0;
 if (!(HEAP32[i7 + 16 >> 2] & 4194304)) {
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = i1 + (i2 * 48 | 0) | 0;
  while (1) {
   i3 = (HEAP32[i1 + 16 >> 2] & 4194304 | 0) == 0;
   if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = 11 - (HEAP8[i1 + 11 >> 0] | 0) | 0;
   if ((i6 | 0) == (i2 | 0)) {
    i4 = HEAP32[i7 >> 2] | 0;
    if (i3) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if ((i4 | 0) == (i2 | 0)) {
     i2 = 25;
     break;
    }
    if (!(_memcmp(i4, i2, i6) | 0)) {
     i2 = 25;
     break;
    }
   }
   i1 = i1 + 48 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i5;
    i2 = 25;
    break;
   }
  }
  if ((i2 | 0) == 25) return i1 | 0;
 } else {
  i4 = i1 + (i2 * 48 | 0) | 0;
  while (1) {
   i2 = (HEAP32[i1 + 16 >> 2] & 4194304 | 0) == 0;
   if (i2) i3 = HEAP32[i1 + 4 >> 2] | 0; else i3 = 11 - (HEAP8[i1 + 11 >> 0] | 0) | 0;
   if ((i5 | 0) == (i3 | 0)) {
    if (i2) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
    if ((i7 | 0) == (i2 | 0)) {
     i2 = 25;
     break;
    }
    if (!(_memcmp(i7, i2, i5) | 0)) {
     i2 = 25;
     break;
    }
   }
   i1 = i1 + 48 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i2 = 25;
    break;
   }
  }
  if ((i2 | 0) == 25) return i1 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE14handleAccessorILj536ENS_22PxRepXPropertyAccessorILj536ES4_KffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN2UI14CanvasRenderer11SyncCullingENS0_8SyncFlagE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = HEAP32[i6 + 188 >> 2] | 0;
 if (i8 | 0) {
  if (!(HEAP8[i6 + 164 >> 0] | 0)) {
   i5 = HEAP32[i6 + 88 >> 2] | 0;
   if (!i5) {
    i2 = 0;
    i1 = 0;
   } else {
    i4 = HEAP32[i6 + 76 >> 2] | 0;
    i2 = 0;
    i1 = 0;
    i3 = 0;
    do {
     i1 = (HEAP32[i4 + (i3 * 52 | 0) + 48 >> 2] | 0) + i1 | 0;
     i2 = (HEAP32[i4 + (i3 * 52 | 0) + 36 >> 2] | 0) + i2 | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) < 8 & i3 >>> 0 < i5 >>> 0);
   }
  } else {
   i2 = 0;
   i1 = 0;
  }
  i4 = HEAPU8[i6 + 184 >> 0] | 0;
  i3 = i1 << i4;
  i4 = i2 << i4;
  i1 = i6 + 192 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i3 | 0) != (i2 | 0)) {
   i5 = i8 + 216 | 0;
   HEAP32[i5 >> 2] = i3 - i2 + (HEAP32[i5 >> 2] | 0);
   HEAP32[i1 >> 2] = i3;
  }
  i1 = i6 + 196 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) != (i2 | 0)) {
   i8 = i8 + 220 | 0;
   HEAP32[i8 >> 2] = i4 - i2 + (HEAP32[i8 >> 2] | 0);
   HEAP32[i1 >> 2] = i4;
  }
 }
 if (i7 & 1 | 0) {
  i8 = HEAP32[i6 + 204 >> 2] | 0;
  i5 = i8 + 112 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 2;
  HEAP8[(HEAP32[i8 + 84 >> 2] | 0) + ((HEAP32[i6 + 208 >> 2] | 0) * 672 | 0) + 670 >> 0] = HEAP8[i6 + 164 >> 0] | 0;
 }
 if (!(i7 & 2)) return;
 i8 = HEAP32[i6 + 220 >> 2] | 0;
 i7 = i8 + 112 | 0;
 HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 2;
 HEAP8[(HEAP32[i8 + 84 >> 2] | 0) + ((HEAP32[i6 + 224 >> 2] | 0) * 672 | 0) + 670 >> 0] = HEAP8[i6 + 164 >> 0] | 0;
 return;
}

function __ZN17AudioChorusFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 52 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 56 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 60 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.100000001);
 i5 = f2 > Math_fround(100.0);
 f2 = i5 ? Math_fround(100.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.100000001) : f2;
 i3 = i1 + 64 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(20.0);
 f2 = i5 ? Math_fround(20.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 68 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN11UnityEngine15PlatformWrapper14GetProductGUIDEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 __Z12GUIDToStringRK9UnityGUID(i5, (__Z17GetPlayerSettingsv() | 0) + 28 | 0);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i6 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i3, i8, i12, i13, i14) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i15 = 0;
 if ((i1 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i3, i8, i12, i13); else {
  i15 = i3 + 52 | 0;
  i6 = HEAP16[i15 >> 1] | 0;
  i4 = i6 & 255;
  i5 = i3 + 53 | 0;
  i6 = (i6 & 65535) >>> 8 & 255;
  i11 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = i1 + 16 + (i11 << 3) | 0;
  HEAP8[i15 >> 0] = 0;
  HEAP8[i5 >> 0] = 0;
  __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1 + 16 | 0, i3, i8, i12, i13, i14);
  L4 : do if ((i11 | 0) > 1) {
   i9 = i3 + 24 | 0;
   i10 = i1 + 8 | 0;
   i11 = i3 + 54 | 0;
   i1 = i1 + 24 | 0;
   do {
    if (HEAP8[i11 >> 0] | 0) break L4;
    i2 = HEAP16[i15 >> 1] | 0;
    if (!((i2 & 255) << 24 >> 24)) {
     if ((i2 & 65535) >= 256) if (!(HEAP32[i10 >> 2] & 1)) break L4;
    } else {
     if ((HEAP32[i9 >> 2] | 0) == 1) break L4;
     if (!(HEAP32[i10 >> 2] & 2)) break L4;
    }
    HEAP8[i15 >> 0] = 0;
    HEAP8[i5 >> 0] = 0;
    __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i3, i8, i12, i13, i14);
    i1 = i1 + 8 | 0;
   } while (i1 >>> 0 < i7 >>> 0);
  } while (0);
  HEAP8[i15 >> 0] = i4;
  HEAP8[i5 >> 0] = i6;
 }
 return;
}

function __ZN9GfxDevice23SyncAsyncResourceUploadE9TextureID10AsyncFencei(i7, i5, i2, i8) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 16 | 0;
 i1 = i12 + 8 | 0;
 i9 = i12;
 i10 = i12 + 12 | 0;
 if ((HEAP16[gb + 1157612 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157612 | 0, i11);
  i4 = gb + 1157612 | 0;
 } else i4 = 0;
 i6 = __Z21GetAsyncUploadManagerv() | 0;
 i3 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 if (!(__ZN18AsyncUploadManager12HasCompletedE10AsyncFence(i6, i11) | 0)) {
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i11 >> 2] = HEAP32[i10 >> 2];
   __ZN18AsyncUploadManager19AsyncResourceUploadER9GfxDeviceii9TextureID(i6, i7, 2, i8, i11);
   __ZN18AsyncUploadManager22WaitForActiveAsyncReadEv(i6);
   i5 = i9;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i5 + 4 >> 2] = i3;
   HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i11 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  } while (!(__ZN18AsyncUploadManager12HasCompletedE10AsyncFence(i6, i11) | 0));
 }
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Cm13SpatialVectorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 721219 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj121ENS_22PxRepXPropertyAccessorILj121ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 108; else i1 = (HEAP32[i1 >> 2] | 0) + 108 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj120ENS_22PxRepXPropertyAccessorILj120ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 104; else i1 = (HEAP32[i1 >> 2] | 0) + 104 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj165ENS_22PxRepXPropertyAccessorILj165ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 300; else i1 = (HEAP32[i1 >> 2] | 0) + 300 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj164ENS_22PxRepXPropertyAccessorILj164ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 296; else i1 = (HEAP32[i1 >> 2] | 0) + 296 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj163ENS_22PxRepXPropertyAccessorILj163ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 292; else i1 = (HEAP32[i1 >> 2] | 0) + 292 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj162ENS_22PxRepXPropertyAccessorILj162ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 288; else i1 = (HEAP32[i1 >> 2] | 0) + 288 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj160ENS_22PxRepXPropertyAccessorILj160ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 268; else i1 = (HEAP32[i1 >> 2] | 0) + 268 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj159ENS_22PxRepXPropertyAccessorILj159ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 264; else i1 = (HEAP32[i1 >> 2] | 0) + 264 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj158ENS_22PxRepXPropertyAccessorILj158ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 260; else i1 = (HEAP32[i1 >> 2] | 0) + 260 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj157ENS_22PxRepXPropertyAccessorILj157ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 256; else i1 = (HEAP32[i1 >> 2] | 0) + 256 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj389ENS_22PxRepXPropertyAccessorILj389ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu22computeMTD_CapsuleMeshERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i6, i4, i1, i2, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 4288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i7 + 4220 | 0;
 i10 = i7 + 4192 | 0;
 i12 = i7 + 4224 | 0;
 i13 = i7 + 4120 | 0;
 i11 = i7 + 4136 | 0;
 i8 = i7 + 4116 | 0;
 i3 = i7;
 i9 = i7 + 4112 | 0;
 __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf(i10, i1, i1 + 12 | 0, i15);
 HEAP32[i12 >> 2] = -1;
 i14 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = HEAP32[i15 >> 2] | 0;
 HEAP32[i13 >> 2] = 2;
 HEAP32[i13 + 4 >> 2] = i14;
 HEAP32[i13 + 8 >> 2] = i1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i13);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i8 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu18contactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i10, i5, i9, i8, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i6, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i15 = 0;
  STACKTOP = i7;
  return i15 | 0;
 }
 i15 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i7;
 return i15 | 0;
}

function __ZN5physx20PxsParticleSystemSim24updateCollisionParameterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 1104 >> 2]);
 f5 = Math_fround(f5 * f4);
 i3 = f5 < Math_fround(1.0);
 f5 = Math_fround(Math_fround(1.0) - f5);
 HEAPF32[i1 + 636 >> 2] = i3 ? f5 : Math_fround(0.0);
 HEAP32[i1 + 624 >> 2] = HEAP32[i1 + 1112 >> 2];
 HEAP32[i1 + 628 >> 2] = HEAP32[i1 + 1116 >> 2];
 HEAP32[i1 + 632 >> 2] = HEAP32[i1 + 1120 >> 2];
 HEAP32[i1 + 696 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i1 + 700 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i1 + 704 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i1 + 708 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAPF32[i1 + 688 >> 2] = f4;
 i3 = f4 > Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 HEAPF32[i1 + 692 >> 2] = i3 ? f4 : Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 i3 = f4 < Math_fround(0.0);
 f4 = i3 ? Math_fround(0.0) : f4;
 i3 = f4 > Math_fround(.949999988);
 HEAPF32[i1 + 640 >> 2] = i3 ? Math_fround(.949999988) : f4;
 f4 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 i3 = f4 < Math_fround(.00100000005);
 f4 = i3 ? Math_fround(.00100000005) : f4;
 i3 = f4 > Math_fround(1.0);
 HEAPF32[i1 + 644 >> 2] = i3 ? Math_fround(1.0) : f4;
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 HEAPF32[i1 + 648 >> 2] = Math_fround(f4 * f4);
 i3 = HEAP32[i2 + 84 >> 2] | 0;
 HEAP32[i1 + 716 >> 2] = (Math_imul(Math_imul(i3, 4999879) | 0, i3) | 0) & 65535;
 HEAP32[i1 + 712 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZN5physx18PxShortestRotationERKNS_6PxVec3ES2_(i12, i3, i4) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(f7 * f8);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f10 * f11));
 f2 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f1 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f2 * f1));
 do if (f6 > Math_fround(-1.0)) {
  f9 = Math_fround(Math_fround(f10 * f1) - Math_fround(f11 * f2));
  f5 = Math_fround(Math_fround(f8 * f2) - Math_fround(f7 * f1));
  f2 = Math_fround(Math_fround(f7 * f11) - Math_fround(f8 * f10));
  f1 = Math_fround(f6 + Math_fround(1.0));
 } else if (Math_fround(Math_abs(Math_fround(f7))) < Math_fround(.100000001)) {
  f9 = Math_fround(0.0);
  f5 = f2;
  f2 = Math_fround(-f10);
  f1 = Math_fround(0.0);
  break;
 } else {
  f9 = f10;
  f5 = Math_fround(-f7);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  break;
 } while (0);
 f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(Math_fround(f2 * f2) + Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9)))))));
 f8 = Math_fround(f5 * f7);
 f10 = Math_fround(f2 * f7);
 f11 = Math_fround(f1 * f7);
 HEAPF32[i12 >> 2] = Math_fround(f9 * f7);
 HEAPF32[i12 + 4 >> 2] = f8;
 HEAPF32[i12 + 8 >> 2] = f10;
 HEAPF32[i12 + 12 >> 2] = f11;
 return;
}

function __ZN5physx17NpMaterialManager16releaseMaterialsEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i13;
 i6 = i13 + 4 | 0;
 i7 = i12 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i8 = i12 + 16 | 0;
 if (!i1) {
  i12 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i12);
  STACKTOP = i13;
  return;
 }
 i9 = i12 + 4 | 0;
 i10 = i12 + 12 | 0;
 i11 = i12 + 8 | 0;
 i4 = 0;
 do {
  i3 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  if (i3) {
   i1 = HEAP32[i3 + 52 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   do if (((HEAP32[i12 >> 2] | 0) + -1 | 0) == (i1 | 0)) {
    HEAP32[i12 >> 2] = i1;
    i1 = i3;
   } else {
    i2 = HEAP32[i11 >> 2] | 0;
    if ((HEAP32[i10 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
     HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] = i1;
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i1 = i3;
     break;
    } else {
     __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i9, i5) | 0;
     i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] | 0;
     break;
    }
   } while (0);
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i4 << 2) >> 2] = 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 i12 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i12);
 STACKTOP = i13;
 return;
}

function __ZN5Unity10FixedJoint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(96, i1, 16, gb + 1048932 | 0, 0, gb + 780589 | 0, 17) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 112584 + 8;
 i5 = i4 + 40 | 0;
 i1 = i4 + 52 | 0;
 i2 = i4 + 64 | 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP8[i4 + 76 >> 0] = 1;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i4 + 88 >> 0] = 0;
 HEAP8[i4 + 89 >> 0] = 1;
 HEAPF32[i4 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 84 >> 2] = Math_fround(inf);
 HEAP32[i4 >> 2] = gb + 112184 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN21RotationBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = i6 + 4 | 0;
 i7 = i3 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i3 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i3);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i3);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 272 | 0, i3);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 536 | 0, i3);
 i1 = i6 + 800 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i3);
 i1 = i6 + 804 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 808 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i8, i2) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i5 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
 }
 i2 = i5 + 12 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i8 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i8;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i8 << 6, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 6, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 6 | 0) | 0;
  HEAP32[i3 >> 2] = i8;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i7 >>> 0 >= i8 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i6 = i1 + (i7 << 6) | 0;
 i2 = i8 - i7 | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 } else i1 = 0;
 do {
  i3 = i6 + (i1 << 6) | 0;
  i4 = i9;
  i5 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN12AudioManager19SetApplicationPauseEb(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i3 = i9;
 i2 = i8 + 41 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) == (i1 & 1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP8[i2 >> 0] = i1 & 1;
 i1 = HEAP32[i8 + 88 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN4FMOD6System11getDSPClockEPjS1_(i1, i3, i4) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP16[i8 + 40 >> 1] | 0;
 i2 = i8 + 208 | 0;
 i4 = i2;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = (i3 | 0) == 0 & (i4 | 0) == 0;
 if ((i6 & 65535) < 256 & (i6 & 255) << 24 >> 24 == 0) {
  i6 = i8 + 200 | 0;
  if (!i5) {
   i7 = _i64Subtract(i1 | 0, i7 | 0, i3 | 0, i4 | 0) | 0;
   i5 = getTempRet0() | 0;
   i4 = i6;
   i4 = _i64Add(i7 | 0, i5 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   i5 = getTempRet0() | 0;
   i7 = i6;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = i5;
   i7 = i2;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
 } else if (i5) {
  i6 = i2;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = i7;
 }
 i2 = HEAP32[i8 + 48 >> 2] | 0;
 i3 = i8 + 44 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11AudioSource16UpdatePauseStateEv(HEAP32[i8 + 8 >> 2] | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i9;
 return;
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 __ZN8GradientC2Ev(i3);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, HEAP32[i8 + 20 >> 2] | 0);
 i6 = i1 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i5 = i8 + 12 | 0;
 i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 i4 = i4 + 32 | 0;
 i2 = i3 + 32 | 0;
 i3 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i6) >> 2] = i1;
 STACKTOP = i9;
 return;
}

function __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 __ZN8GradientC2Ev(i3);
 __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, HEAP32[i8 + 20 >> 2] | 0);
 i6 = i1 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i5 = i8 + 12 | 0;
 i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 i4 = i4 + 32 | 0;
 i2 = i3 + 32 | 0;
 i3 = i4 + 40 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  i4 = i4 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i4 | 0) < (i3 | 0));
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP8[i8 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i6) >> 2] = i1;
 STACKTOP = i9;
 return;
}

function __ZNK26AnimatorOverrideController41GetStateMachineBehaviourVectorDescriptionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    i5 = HEAP32[i7 >> 2] | 0;
    i5 = i5 + 112 | 0;
    i5 = HEAP32[i5 >> 2] | 0;
    i7 = mftCall_ii(i5 | 0, i7 | 0) | 0;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i5 = i5 + 112 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i7 = mftCall_ii(i5 | 0, i7 | 0) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj395ENS_22PxRepXPropertyAccessorILj395ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 112 | 0;
 i5 = i6;
 __ZN9InputAxisC2Ev(i5);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 434600 | 0, i5, 0);
 __ZN9InputAxis8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 HEAP32[i5 >> 2] = gb + 59740 + 8;
 i1 = i5 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 52 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 i1 = i5 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 36 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN22UnityWebRequestManager10InitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 if (HEAP8[gb + 1573588 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 1540 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 772 + (i1 * 12 | 0) >> 2] = fb + 380;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 10032 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 9264 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 9264 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 9264 + (i1 * 12 | 0) >> 2] = fb + 381;
 HEAP8[gb + 1573588 >> 0] = 1;
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i10, i7, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i8, 4);
  i4 = HEAP32[i8 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
 }
 i5 = i7 + 20 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i2 = 15; else {
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? i3 : i2;
 }
 if (i2 >>> 0 < i4 >>> 0) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i7, i4);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i4;
 i6 = i7 + 4 | 0;
 HEAP8[((i1 | 0) == 0 ? i6 : i1) + i4 >> 0] = 0;
 if (i4 >>> 0 > i3 >>> 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  _memset(((i2 | 0) == 0 ? i6 : i2) + i3 | 0, 1, i4 - i3 | 0) | 0;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if (!((HEAP32[i7 + 4 >> 2] | 0) != 0 | (i2 | 0) == 0)) {
  __ZN4core20StringStorageDefaultIcE10reallocateEj(i7, HEAP32[i5 >> 2] | 0);
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i10, (i2 | 0) == 0 ? i6 : i2, i1);
 STACKTOP = i9;
 return;
}

function __ZN14PhysicMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13MonoBehaviour19RebuildMonoInstanceEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i5 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript(i5, 0, 0, i6);
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i8 = i1;
 __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript(i5, 0, 0, i8);
 STACKTOP = i7;
 return;
}

function __Z29NativeToScriptingVertexLayoutPK11ChannelInfoP25ScriptingVertexDataLayoutRi(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 HEAP32[i6 >> 2] = 0;
 i3 = 0;
 i1 = 0;
 do {
  if (HEAP8[i4 + (i3 << 2) + 3 >> 0] | 0) {
   i8 = HEAP16[i4 + (i3 << 2) + 2 >> 1] | 0;
   i2 = (i8 & 65535) >>> 8 & 255;
   L5 : do switch ((i8 & 255) << 24 >> 24) {
   case 0:
    switch (i2 << 24 >> 24) {
    case 0:
     {
      i2 = 0;
      break L5;
     }
    case 1:
     {
      i2 = 1;
      break L5;
     }
    case 2:
     {
      i2 = 2;
      break L5;
     }
    case 3:
     {
      i2 = 3;
      break L5;
     }
    case 4:
     {
      i2 = 4;
      break L5;
     }
    default:
     {
      i7 = 12;
      break L5;
     }
    }
   case 1:
    {
     switch (i2 << 24 >> 24) {
     case 2:
      {
       i2 = 5;
       break L5;
      }
     case 4:
      break;
     default:
      {
       i7 = 12;
       break L5;
      }
     }
     i2 = 6;
     break;
    }
   case 2:
    {
     i2 = 7;
     break;
    }
   default:
    i7 = 12;
   } while (0);
   if ((i7 | 0) == 12) {
    i7 = 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429989 | 0, 0, gb + 429904 | 0, 59, 1, 0, 0, 0);
    i2 = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i8 = HEAPU8[i4 + (i3 << 2) >> 0] | 0;
   HEAP32[i5 + (i8 << 5) + (i3 << 2) >> 2] = i2;
   i8 = i8 + 1 | 0;
   i1 = (i1 | 0) < (i8 | 0) ? i8 : i1;
   HEAP32[i6 >> 2] = i1;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 8);
 return;
}

function __Z26InitializePhysicsManager2Dv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i7 = __ZnwjRK10MemLabelIdiPKci(240, gb + 63400 | 0, 16, gb + 806430 | 0, 1429) | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i7 + 12 | 0;
 __ZN19CollisionListener2DC2Ev(i6);
 i4 = i7 + 236 | 0;
 HEAP32[i4 >> 2] = gb + 158668 + 8;
 HEAP32[gb + 1458412 >> 2] = i7;
 HEAP32[i7 >> 2] = __Z13GetIPhysics2Dv() | 0;
 i7 = __Znwj(103032) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = -1055066685;
 __ZN7b2WorldC2ERK6b2Vec2(i7, i3);
 HEAP32[i5 >> 2] = i7;
 __ZN7b2World18SetContactListenerEP17b2ContactListener(i7, i6);
 __ZN7b2World16SetContactFilterEP15b2ContactFilter(HEAP32[i5 >> 2] | 0, i4);
 HEAP32[i3 + 44 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i3 + 36 >> 0] = 1;
 HEAP8[i3 + 38 >> 0] = 0;
 HEAP8[i3 + 39 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i3 + 40 >> 0] = 1;
 HEAPF32[i3 + 48 >> 2] = Math_fround(1.0);
 HEAP8[i3 + 37 >> 0] = 0;
 HEAP32[i2 >> 2] = __ZN7b2World10CreateBodyEPK9b2BodyDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i3) | 0;
 HEAP32[gb + 1115296 + 160 >> 2] = fb + 236;
 HEAP32[gb + 1115296 + 176 >> 2] = fb + 237;
 STACKTOP = i1;
 return;
}

function __ZNK5physx2Cm10Collection6getIdsEPyjj(i5, i12, i11, i6) {
 i5 = i5 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i5 + 16 | 0;
 L1 : do if (!(HEAP32[i5 + 20 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i2 = HEAP32[i5 + 24 >> 2] | 0;
   i1 = 0;
   while (1) {
    i3 = i1 + 1 | 0;
    if ((i3 | 0) == (i2 | 0)) {
     i1 = -1;
     break L1;
    }
    i1 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i3; else {
     i2 = i3;
     break;
    }
   }
  } else i2 = 0;
 } while (0);
 i8 = i5 + 8 | 0;
 i9 = i5 + 12 | 0;
 i7 = i5 + 24 | 0;
 i3 = i6;
 i4 = i1;
 i1 = 0;
 L8 : while (1) {
  i6 = i4;
  do {
   if (!((i6 | 0) != -1 & i1 >>> 0 < i11 >>> 0)) break L8;
   i5 = (HEAP32[i8 >> 2] | 0) + (i6 << 4) | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   do if (!((i4 | 0) == 0 & (i5 | 0) == 0)) if (!i3) {
    i3 = i12 + (i1 << 3) | 0;
    HEAP32[i3 >> 2] = i4;
    HEAP32[i3 + 4 >> 2] = i5;
    i3 = 0;
    i1 = i1 + 1 | 0;
    break;
   } else {
    i3 = i3 + -1 | 0;
    break;
   } while (0);
   i6 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  } while ((i6 | 0) != -1);
  i5 = HEAP32[i7 >> 2] | 0;
  while (1) {
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) {
    i4 = -1;
    i2 = i5;
    continue L8;
   }
   i4 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i4 | 0) != -1) continue L8;
  }
 }
 return i1 | 0;
}

function __ZN9Rigidbody23UpdateInterpolationNodeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (HEAP8[i1 + 102 >> 0] | 0) if (HEAP8[i1 + 80 >> 0] | 0) {
  i5 = i1 + 108 | 0;
  if (HEAP32[i5 >> 2] | 0) return;
  i2 = __Znwj(44) | 0;
  i3 = i2;
  i4 = i3 + 40 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i5 >> 2] = i2;
  HEAP32[i2 + 36 >> 2] = i1;
  HEAP32[i2 + 40 >> 2] = 1;
  i3 = i2 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 32 >> 2] = Math_fround(1.0);
  i3 = (__Z21GetManagerFromContexti(9) | 0) + 196 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) return;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = i2 + 4 | 0; else {
   i5 = i2 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i5;
  }
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  return;
 }
 i2 = i1 + 108 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i5 = i3 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
  }
  __ZdlPv(i3);
 }
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj144ENS_22PxRepXPropertyAccessorILj144ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 68; else i1 = (HEAP32[i1 >> 2] | 0) + 68 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj142ENS_22PxRepXPropertyAccessorILj142ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 60; else i1 = (HEAP32[i1 >> 2] | 0) + 60 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj5ENS_22PxRepXPropertyAccessorILj5ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN4FMOD12ChannelGroup8addGroupEPS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
   if (!i1) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
   if (!i1) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   if (HEAP8[i1 + 16 >> 0] | 0) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   if ((HEAP32[i1 + 12 >> 2] | 0) != (i2 & 65535 | 0)) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i2 = i1 + 52 | 0;
   i6 = i1 + 60 | 0;
   i7 = i1 + 56 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 + 8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] = i4;
   HEAP32[i7 >> 2] = i2;
   i4 = i3 + 68 | 0;
   HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 >> 2] = i3 + 64;
   HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] = i2;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i1 + 48 >> 2] = i3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 860342;
 _printf(gb + 853184 | 0, i4) | 0;
 i7 = 36;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN17GeneralConnection13DisconnectAllEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = HEAP32[i7 + 88 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i5 = i7 + 92 | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i10;
  return;
 }
 i6 = i8 + 8 | 0;
 i2 = i1;
 i3 = 0;
 i4 = 0;
 while (1) {
  i1 = i2 + 16 | 0;
  if ((i3 | 0) == (i4 | 0)) __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i8, i1); else {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3 + 4;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break;
  i2 = i1;
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i2 = i6;
 if ((i1 | 0) != (i6 | 0)) {
  i3 = 0;
  do {
   __ZN17GeneralConnection10DisconnectEj(i7, HEAP32[i2 + (i3 << 2) >> 2] | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i8 >> 2] | 0;
   i2 = i6;
  } while (i3 >>> 0 < i1 - i6 >> 2 >>> 0);
 }
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i9 >> 2] = i1 + (~((i1 + -4 - i2 | 0) >>> 2) << 2);
 __ZdlPv(i2);
 STACKTOP = i10;
 return;
}

function __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i1, i6 + 8 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1 + (i4 * 80 | 0) | 0;
 if (i4 | 0) do {
  __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i6);
  i1 = i1 + 80 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i5 + 20 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i6, i5 + 40 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i6, i5 + 60 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags(i6, i5 + 80 | 0, 0);
 STACKTOP = i7;
 return;
}

function __Z20GetBufferManagerGLESv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1451092 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(164, gb + 63304 | 0, 16, gb + 602218 | 0, 533) | 0;
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = i2;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i2;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i2;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = i2;
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = i2;
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i2;
 i2 = i1 + 92 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = i2;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = i2;
 i2 = i1 + 116 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = i2;
 i2 = i1 + 128 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = i2;
 i2 = i1 + 140 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = i2;
 i2 = i1 + 148 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 152 >> 2] = i2;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[gb + 1451092 >> 2] = i1;
 return i1 | 0;
}

function __Z14RandomRotationP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0;
 i5 = HEAP32[gb + 1477028 >> 2] | 0;
 i5 = i5 << 11 ^ i5;
 HEAP32[gb + 1477028 >> 2] = HEAP32[gb + 1477032 >> 2];
 HEAP32[gb + 1477032 >> 2] = HEAP32[gb + 1477036 >> 2];
 i6 = HEAP32[gb + 1477040 >> 2] | 0;
 HEAP32[gb + 1477036 >> 2] = i6;
 i6 = i5 >>> 8 ^ i5 ^ i6 ^ i6 >>> 19;
 HEAP32[gb + 1477040 >> 2] = i6;
 f7 = Math_fround(Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07)) * Math_fround(6.28318548));
 f8 = Math_fround(Math_fround(Math_fround(+Math_cos(+f7)) * Math_fround(.5)) + Math_fround(.5));
 i6 = f8 < Math_fround(0.0);
 f8 = i6 ? Math_fround(0.0) : f8;
 i6 = f8 > Math_fround(1.0);
 i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
 HEAP8[i2 >> 0] = i6;
 f7 = Math_fround(Math_fround(+Math_sin(+f7)) * Math_fround(.5));
 f8 = Math_fround(Math_fround(.5) - f7);
 i5 = f8 < Math_fround(0.0);
 f8 = i5 ? Math_fround(0.0) : f8;
 i5 = f8 > Math_fround(1.0);
 HEAP8[i2 + 1 >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f7 = Math_fround(f7 + Math_fround(.5));
 i5 = f7 < Math_fround(0.0);
 f7 = i5 ? Math_fround(0.0) : f7;
 i5 = f7 > Math_fround(1.0);
 HEAP8[i2 + 2 >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 HEAP8[i2 + 3 >> 0] = i6;
 return;
}

function _ft_var_readpackeddeltas(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = HEAP32[i5 + 28 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 i1 = _UNITY_ft_mem_realloc(i8, 2, 0, i6, 0, i7) | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i2 = 0; else {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 do {
  if (i2 >>> 0 >= i6 >>> 0) {
   i9 = 11;
   break;
  }
  i3 = (_UNITY_FT_Stream_GetChar(i5) | 0) & 255;
  i7 = i3 & 63;
  if (!(i3 & 128)) if (!(i3 & 64)) {
   i3 = 0;
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP16[i1 + (i2 << 1) >> 1] = (_UNITY_FT_Stream_GetChar(i5) | 0) << 24 >> 24;
    i3 = i3 + 1 | 0;
    if (i4 >>> 0 < i6 >>> 0 & i3 >>> 0 <= i7 >>> 0) i2 = i4; else {
     i2 = i4;
     break;
    }
   }
  } else {
   i3 = 0;
   while (1) {
    i4 = i2 + 1 | 0;
    HEAP16[i1 + (i2 << 1) >> 1] = _UNITY_FT_Stream_GetUShort(i5) | 0;
    i3 = i3 + 1 | 0;
    if (i4 >>> 0 < i6 >>> 0 & i3 >>> 0 <= i7 >>> 0) i2 = i4; else {
     i2 = i4;
     break;
    }
   }
  } else {
   i4 = i2 - i6 | 0;
   i3 = (i3 | -64) ^ 63;
   _memset(i1 + (i2 << 1) | 0, 0, Math_imul(i4 >>> 0 > i3 >>> 0 ? i4 : i3, -2) | 0) | 0;
   i3 = 0;
   do {
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while (i2 >>> 0 < i6 >>> 0 & i3 >>> 0 <= i7 >>> 0);
  }
 } while (i3 >>> 0 > i7 >>> 0);
 if ((i9 | 0) == 11) {
  STACKTOP = i10;
  return i1 | 0;
 }
 _UNITY_ft_mem_free(i8, i1);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN36EarlyUpdatePresentBeforeUpdatestruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if (__Z11IsBatchmodev() | 0) {
  STACKTOP = i5;
  return;
 }
 i4 = __Z12GetGfxDevicev() | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 488 >> 2] | 0, i4 | 0) | 0) {
  STACKTOP = i5;
  return;
 }
 if (!(__Z17HasFrameToPresentv() | 0)) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP16[gb + 1450852 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450852 | 0, i1);
  i4 = gb + 1450852 | 0;
 } else i4 = 0;
 i3 = HEAP32[gb + 1450812 >> 2] | 0;
 if (i3 | 0) mftCall_vi(i3 | 0, 1);
 if ((HEAP16[gb + 1450840 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450840 | 0, i1);
  i1 = gb + 1450840 | 0;
 } else i1 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 508 >> 2] | 0, i3 | 0, 0);
 __Z15gpu_time_samplev();
 __Z20SetHasFrameToPresentb(0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i1 = HEAP32[gb + 1450812 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, 0);
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i5;
 return;
}

function __ZN8Renderer19SetSortingLayerNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i4 = __Z13GetTagManagerv() | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i7 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i8 = i7 + 24 | 0;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = i10;
 i1 = i7 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i10 = HEAP8[i2 + 11 >> 0] | 0;
 i11 = i10 << 24 >> 24 < 0;
 i3 = i11 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i11 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
 if (i2 >>> 0 > 15) {
  i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i8, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i7 >> 2] = i11;
  HEAP32[i7 + 4 >> 2] = i2;
  i1 = (i11 | 0) == 0 ? i1 : i11;
 }
 _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP8[i1 + i2 >> 0] = 0;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i4, i7) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  __ZN8Renderer17SetSortingLayerIDEi(i6, i1);
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i7 + 4 >> 2] | 0)) {
  __ZN8Renderer17SetSortingLayerIDEi(i6, i1);
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
 __ZN8Renderer17SetSortingLayerIDEi(i6, i1);
 STACKTOP = i9;
 return;
}

function __ZN7dtCrowd19ResizeProximityGridEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = __Z7dtAlloci(44) | 0;
 if (!i10) return;
 i1 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i7 = (HEAP32[i4 + 408 >> 2] | 0) + (HEAP32[i4 >> 2] | 0) << 3;
 i8 = i10 + 24 | 0;
 HEAP32[i8 >> 2] = 0;
 i5 = i10 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i10 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = (i7 | 0) > 65535 ? 65535 : i7;
 i2 = i7 + -1 | 0;
 i2 = i2 >>> 1 | i2;
 i2 = i2 >>> 2 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = (i2 >>> 16 | i2) + 1 | 0;
 i9 = i10 + 20 | 0;
 i3 = __Z9dtReallocPvi(0, i2 << 1) | 0;
 if (i3) {
  HEAP32[i9 >> 2] = i3;
  HEAP32[i8 >> 2] = i2;
  i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i7 << 3) | 0;
  if (i2) {
   HEAP32[i1 >> 2] = i2;
   HEAP32[i6 >> 2] = i7;
   _memset(HEAP32[i9 >> 2] | 0, -1, HEAP32[i8 >> 2] << 1 | 0) | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i10 + 28 >> 2] = 65535;
   HEAP32[i10 + 32 >> 2] = 65535;
   HEAP32[i10 + 36 >> 2] = -65535;
   HEAP32[i10 + 40 >> 2] = -65535;
   HEAPF32[i10 >> 2] = Math_fround(1.0);
   HEAPF32[i10 + 4 >> 2] = Math_fround(1.0);
   i1 = i4 + 368 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __Z6dtFreePv(HEAP32[i2 + 20 >> 2] | 0);
    __Z6dtFreePv(HEAP32[i2 + 8 >> 2] | 0);
    __Z6dtFreePv(i2);
   }
   HEAP32[i1 >> 2] = i10;
   return;
  }
 }
 __Z6dtFreePv(HEAP32[i9 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 __Z6dtFreePv(i10);
 return;
}

function __ZN6Camera22RenderHaloAndLensFlareEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN11HaloManager11RenderHalosEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f(HEAP32[gb + 1110376 >> 2] | 0, i2, i3, i4);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 30152 | 0) | 0;
 if (!i1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  }
 } while (0);
 __ZN12FlareManager12RenderFlaresERK10Matrix4x4f(i1, i4);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 3;
  i2 = i7 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 678299 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 i4 = i1 + (i3 << 3) | 0;
 i5 = i7 + 36 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   i2 = i2 + 8 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 8 | 0;
  }
 }
 i2 = i7 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 32 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Scb14ParticleSystem15createParticlesERKNS_22PxParticleCreationDataE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i1 = i7;
 switch ((HEAP32[i6 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 3;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0) i2 = 3;
   break;
  }
 default:
  {}
 }
 if ((i2 | 0) == 3) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 699190 | 0, 75, gb + 699279 | 0, i1);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = HEAP32[i6 + 152 >> 2] | 0;
 if (!i3) {
  i6 = __ZN5physx2Sc18ParticleSystemCore15createParticlesERKNS_22PxParticleCreationDataE(i6 + 12 | 0, i5) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = i3 + 72 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) i1 = i3 + 73 | 0; else {
  i8 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i1 = i3 + 73 | 0;
  HEAP32[i4 >> 2] = gb + 699707;
  HEAP32[i4 + 4 >> 2] = i1;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i8, 8, gb + 699945 | 0, 50, gb + 700038 | 0, i4);
 }
 _strncpy(i1, gb + 699707 | 0, 128) | 0;
 HEAP8[i3 + 200 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 i8 = __ZN5physx2Sc18ParticleSystemCore15createParticlesERKNS_22PxParticleCreationDataE(i6 + 12 | 0, i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj260ENS_22PxRepXPropertyAccessorILj260ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags(i10, i5, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = i5 + 4 | 0;
 i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i8 = i10 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 i6 = i1 + (i5 * 48 | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_(i1, i10);
  i2 = i1 + 40 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
  }
  i2 = i1 + 44 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i1 = i1 + 48 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18LoadSceneOperation21CompleteAwakeSequenceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i1 + 160 | 0;
 i9 = i1 + 180 | 0;
 __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue(HEAP32[i7 >> 2] | 0, i9);
 i8 = i1 + 460 | 0;
 if ((HEAP32[i8 >> 2] | 4 | 0) != 5) __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(HEAP32[i7 >> 2] | 0);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i6 + 4628 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i5 = i6 + 3860 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i6 + 3860 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viii(HEAP32[i5 >> 2] | 0, i2 | 0, i9 | 0, i3 | 0); else mftCall_viiii(HEAP32[i5 >> 2] | 0, HEAP32[i6 + 3860 + (i1 * 12 | 0) + 4 >> 2] | 0, i2 | 0, i9 | 0, i3 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEv(i9);
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i6 + 5400 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return; else i1 = 0;
 do {
  i4 = i6 + 4632 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i6 + 4632 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viii(HEAP32[i4 >> 2] | 0, i5 | 0, i9 | 0, i2 | 0); else mftCall_viiii(HEAP32[i4 >> 2] | 0, HEAP32[i6 + 4632 + (i1 * 12 | 0) + 4 >> 2] | 0, i5 | 0, i9 | 0, i2 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 12 | 0, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i3 = i1 + (i6 * 12 | 0) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 * 12 | 0) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15ConstantForce2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 20 | 0;
 i2 = (i1 | 0) / 20 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 20 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 20 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 20 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 20 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z5slerpPfS_S_f(i6, i1, i2, f7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 var f3 = f0, d4 = 0.0, i5 = 0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f8 * f9);
 i10 = i1 + 4 | 0;
 f12 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = i2 + 4 | 0;
 f12 = Math_fround(f3 + Math_fround(f12 * Math_fround(HEAPF32[i11 >> 2])));
 i5 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i2 + 8 | 0;
 f3 = Math_fround(+Math_acos(+Math_fround(f12 + Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2])))));
 if (f3 == Math_fround(0.0)) {
  HEAPF32[i6 >> 2] = f8;
  HEAP32[i6 + 4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 >> 2];
  return;
 }
 d4 = +f3;
 if (d4 == 3.141592653589793) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  return;
 } else {
  f12 = Math_fround(+Math_sin(+f3));
  f13 = Math_fround(Math_fround(+Math_sin(+Math_fround((1.0 - +f7) * d4))) / f12);
  f12 = Math_fround(Math_fround(+Math_sin(+Math_fround(f3 * f7))) / f12);
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(f8 * f13) + Math_fround(f9 * f12));
  f9 = Math_fround(f13 * Math_fround(HEAPF32[i10 >> 2]));
  HEAPF32[i6 + 4 >> 2] = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i11 >> 2])));
  f9 = Math_fround(f13 * Math_fround(HEAPF32[i5 >> 2]));
  HEAPF32[i6 + 8 >> 2] = Math_fround(f9 + Math_fround(f12 * Math_fround(HEAPF32[i1 >> 2])));
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj4ENS_22PxRepXPropertyAccessorILj4ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj3ENS_22PxRepXPropertyAccessorILj3ES4_ffEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 f5 = Math_fround(+mftCall_fi(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0));
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 d3 = +f5;
 i1 = i8;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i9 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i8, 128, gb + 832323 | 0, i9) | 0;
 if (HEAP8[i8 >> 0] | 0) {
  i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  mftCall_iiii(i2 | 0, i7 | 0, i8 | 0, _strlen(i8) | 0) | 0;
 }
 HEAP8[i9 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, i9 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0, HEAP32[i7 + 20 >> 2] | 0);
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj547ENS_22PxRepXPropertyAccessorILj547ES4_NS4_4EnumES9_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 835009 | 0)) i1 = 0; else {
  i3 = gb + 835009 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 167008 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 167008 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Cct10Controller16createProxyActorERNS_9PxPhysicsERKNS_10PxGeometryERKNS_10PxMaterialE(i7, i1, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 28 | 0;
 i3 = i8 + 32 | 0;
 i2 = i8;
 f11 = Math_fround(+HEAPF64[i7 + 408 >> 3]);
 f10 = Math_fround(+HEAPF64[i7 + 416 >> 3]);
 f9 = Math_fround(+HEAPF64[i7 + 424 >> 3]);
 HEAPF32[i2 + 16 >> 2] = f11;
 HEAPF32[i2 + 20 >> 2] = f10;
 HEAPF32[i2 + 24 >> 2] = f9;
 HEAP32[i2 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 24 >> 2];
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 i2 = i7 + 400 | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i6 >> 2] = i5;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0;
 HEAP8[i3 >> 0] = 11;
 mftCall_iiiiii(i5 | 0, i1 | 0, i4 | 0, i6 | 0, 1, i3 | 0) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 192 >> 2] | 0, i6 | 0, 1, 1);
 __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(HEAP32[i2 >> 2] | 0, Math_fround(HEAPF32[i7 + 476 >> 2]), 0, 0) | 0;
 i7 = HEAP32[i7 + 456 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 44 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0);
 i7 = 1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN21DownloadHandlerScript13OnReceiveDataEPKvj(i4, i2, i7) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 248 | 0;
 i5 = i9 + 8 | 0;
 i6 = i9;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0, 1, i7) | 0; else i3 = i1;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 1) | 0, i2 | 0, i7 | 0) | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 i2 = i4 + 20 | 0;
 do if (HEAP32[i2 >> 2] | 0) {
  i11 = i2;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i6;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i2 + 4 >> 2] = i10;
  HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i1, i8);
  __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i5, i3);
  __ZN18ScriptingArguments6AddIntEi(i5, i7);
  i1 = i4 + 16 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i7;
  HEAP32[i8 >> 2] = 0;
  i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i8, 0) | 0;
  if (!(HEAP32[i8 >> 2] | 0)) {
   if (!(HEAP8[i1 + 8 >> 0] | 0)) i1 = 0; else break;
   STACKTOP = i9;
   return i1 | 0;
  } else {
   i11 = 0;
   STACKTOP = i9;
   return i11 | 0;
  }
 } while (0);
 i11 = i7;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN19ClampVelocityModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 1068 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 88 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 > Math_fround(0.0);
 f2 = i4 ? f2 : Math_fround(0.0);
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i3 = i1 + 352 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 > Math_fround(0.0);
 f2 = i4 ? f2 : Math_fround(0.0);
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i3 = i1 + 616 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 > Math_fround(0.0);
 f2 = i4 ? f2 : Math_fround(0.0);
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i3 = i1 + 880 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 > Math_fround(0.0);
 f2 = i4 ? f2 : Math_fround(0.0);
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 886 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 800 | 0, i1 + 888 | 0, f2, HEAP16[i1 + 884 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i9, i4, i1) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i3;
  i1 = i5;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, i1, i9 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i5 = i1 + (i4 << 5) | 0;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 >> 2] = i3;
  }
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i9);
  i2 = i1 + 24 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 >> 2] = i4;
  }
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN10GUITexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 52 | 0, i1);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 56 | 0, i1);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i1, i7 + 72 | 0, gb + 385675 | 0, 0);
 i2 = i7 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 44 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZL23AddGpuProgramParametersR20GpuProgramParametersRKNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEERKNS2_INS4_15VectorParameterENS6_ISB_EEEEiP16PropertyNamesSet(i6, i7, i4, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i2 = i1 + (i3 * 36 | 0) | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
   __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet(i6, i2, HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] | 0, HEAP32[i1 + (i3 * 36 | 0) + 24 >> 2] | 0, HEAP32[i1 + (i3 * 36 | 0) + 28 >> 2] | 0, HEAP8[i1 + (i3 * 36 | 0) + 32 >> 0] | 0, i8, i9);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i3 >>> 0 < (((HEAP32[i5 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0);
 }
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) return; else i3 = 0;
 do {
  i2 = i1 + (i3 * 36 | 0) | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  __ZN20GpuProgramParameters14AddMatrixParamEPKcii15ShaderParamTypeiiiP16PropertyNamesSet(i6, i2, HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] | 0, HEAP32[i1 + (i3 * 36 | 0) + 24 >> 2] | 0, HEAP32[i1 + (i3 * 36 | 0) + 28 >> 2] | 0, HEAP8[i1 + (i3 * 36 | 0) + 32 >> 0] | 0, 4, i8, i9);
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } while (i3 >>> 0 < (((HEAP32[i4 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0);
 return;
}

function _cff_decoder_init(i6, i1, i4, i2, i5, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i8 = HEAP32[i1 + 656 >> 2] | 0;
 _memset(i6 + 4 | 0, 0, 736) | 0;
 HEAP8[i6 + 65 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i1 + 100 >> 2];
 if (i2 | 0) {
  i1 = i2 + 156 | 0;
  i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  HEAP32[i6 + 12 >> 2] = i2;
  HEAP32[i6 + 16 >> 2] = i2 + 20;
  HEAP32[i6 + 20 >> 2] = i2 + 56;
  _UNITY_FT_GlyphLoader_Rewind(i2);
  i2 = i6 + 72 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = i6 + 68 | 0;
  HEAP32[i3 >> 2] = 0;
  if ((i4 | 0) != 0 & i5 << 24 >> 24 != 0) {
   HEAP32[i2 >> 2] = HEAP32[HEAP32[i4 + 40 >> 2] >> 2];
   HEAP32[i3 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2];
  }
 }
 i1 = i6 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = i8;
 i1 = HEAP32[i8 + 92 >> 2] | 0;
 HEAP32[i6 + 700 >> 2] = i1;
 HEAP32[i6 + 716 >> 2] = HEAP32[i8 + 1308 >> 2];
 if ((HEAP32[i8 + 1368 >> 2] | 0) == 1) {
  i5 = 0;
  i8 = i6 + 708 | 0;
  HEAP32[i8 >> 2] = i5;
  i8 = i6 + 728 | 0;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 if (i1 >>> 0 < 1240) {
  i5 = 107;
  i8 = i6 + 708 | 0;
  HEAP32[i8 >> 2] = i5;
  i8 = i6 + 728 | 0;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i5 = i1 >>> 0 < 33900 ? 1131 : 32768;
 i8 = i6 + 708 | 0;
 HEAP32[i8 >> 2] = i5;
 i8 = i6 + 728 | 0;
 HEAP32[i8 >> 2] = i7;
 return;
}

function __ZNSt3__26vectorIN5physx12PxOverlapHitENS_9allocatorIS2_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = -1;
   i1 = (HEAP32[i9 >> 2] | 0) + 16 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 4) + i2 | 0;
 if (i5 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 3;
 i3 = i6 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 268435455;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 4) | 0;
 i6 = i5 + (i1 - i4 >> 4 << 4) | 0;
 i5 = i5 + (i3 << 4) | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = -1;
  i1 = i4 + 16 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 4) << 4) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN7mecanim9animation21CreateAvatarWorkspaceEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 56, 4) | 0;
 i1 = i7 + 40 | 0;
 i2 = i7 + 36 | 0;
 i3 = i7;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i7 + 44 >> 2] = 1065353216;
 HEAP32[i7 + 48 >> 2] = 1065353216;
 HEAP8[i7 + 52 >> 0] = 0;
 HEAP8[i7 + 53 >> 0] = 0;
 HEAP8[i7 + 54 >> 0] = 0;
 i3 = i5 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return i7 | 0;
 i4 = i3;
 i2 = i1 + i4 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + i2 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return i7 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return i7 | 0;
 HEAP32[i7 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i1 | 0) == 0 ? 0 : i2, i6) | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + i4 + 40 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 + 4 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i5 | 0) == 0 ? 0 : i2 + i5 | 0, i6) | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + i4 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE((i5 | 0) == 0 ? 0 : i4 + i5 | 0, i6) | 0;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 656520 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN19AutoOffMeshLinkData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 898897 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 12 | 0, gb + 843739 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 24 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843754 | 0, HEAP32[gb + 37288 >> 2] | 0, i1 + 28 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843765 | 0, i5, i1 + 30 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843772 | 0, i5, i1 + 31 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18b2DistanceJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i8 = i4 + 4 | 0;
 f11 = Math_fround(HEAPF32[i8 >> 2]);
 f11 = Math_fround(f11 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f10 = Math_fround(f7 * f6);
 f9 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f7 = Math_fround(Math_fround(f6 * f11) - Math_fround(f7 * f9));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f10 + Math_fround(f11 * f9));
 HEAPF32[i1 + 24 >> 2] = f7;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 i2 = i5 + 4 | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f10 = Math_fround(f7 * f11);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f7 = Math_fround(Math_fround(f11 * f9) - Math_fround(f7 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f10 + Math_fround(f9 * f6));
 HEAPF32[i1 + 32 >> 2] = f7;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i4 >> 2]));
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i1 + 36 >> 2] = Math_fround(Math_sqrt(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6))));
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEEEvRT_PKc17TransferMetaFlags(i9, i10, i1, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i10, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i9 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i10 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i10 + 20 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  i10 = i10 + 24 | 0;
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i9);
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i2;
  i7 = i5;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  i10 = i10 + 24 | 0;
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i10, i9);
  STACKTOP = i8;
  return;
 }
}

function __ZN11DynamicMesh15ConnectPolygonsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i7 = i9;
 i5 = i9 + 16 | 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i3 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i7);
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __ZNK11DynamicMesh20BuildEdgeConnectionsER13dynamic_arrayINS_4EdgeELj2EE(i2, i5);
 i6 = HEAP32[i6 >> 2] | 0;
 if (i6 | 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   i8 = i7 + (i1 * 12 | 0) + 10 | 0;
   if ((HEAP16[i8 >> 1] | 0) != -1) {
    i10 = i7 + (i1 * 12 | 0) + 6 | 0;
    i12 = i7 + (i1 * 12 | 0) + 4 | 0;
    i11 = HEAP32[i2 >> 2] | 0;
    HEAP16[i11 + ((HEAPU16[i12 >> 1] | 0) * 26 | 0) + (HEAPU16[i7 + (i1 * 12 | 0) + 8 >> 1] << 1) >> 1] = (HEAPU16[i10 >> 1] | 0) + 1;
    HEAP16[i11 + ((HEAPU16[i10 >> 1] | 0) * 26 | 0) + (HEAPU16[i8 >> 1] << 1) >> 1] = (HEAPU16[i12 >> 1] | 0) + 1;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z47Texture2D_CUSTOM_LoadRawTextureData_ImplPointerP12Il2CppObject13Il2Cpp_IntPtri(i2, i1, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i5 = i8;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i9 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i1 + 111 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i3) | 0;
  HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if ((i6 | 0) == 0 | (i4 | 0) == 0) {
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 570566 | 0, 0, gb + 570137 | 0, 454, 1, i1, 0, 0);
  STACKTOP = i8;
  return;
 }
 if (__ZN9Texture2D18LoadRawTextureDataEPKvj(i1, i4, i6) | 0) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP32[i1 + 40 >> 2] | 0) >>> 0 > i6 >>> 0) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570613 | 0, i7); else {
  STACKTOP = i8;
  return;
 }
}

function __Z26RecalculateSplineSlopeLoopIfEvR17AnimationCurveTplIT_Eif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0;
 i4 = HEAP32[i1 + 68 >> 2] | 0;
 if ((i4 | 0) < 2) return;
 i6 = i2 + 1 | 0;
 i11 = (i2 | 0) == 0;
 i6 = i11 ? i6 : (i6 | 0) == (i4 | 0) ? 1 : i6;
 i11 = i11 ? i4 + -2 | 0 : i2 + -1 | 0;
 i4 = HEAP32[i1 + 56 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i4 + (i2 << 4) >> 2]);
 f7 = Math_fround(f5 - Math_fround(HEAPF32[i4 + (i11 << 4) >> 2]));
 f8 = Math_fround(HEAPF32[i4 + (i2 << 4) + 4 >> 2]);
 f9 = Math_fround(f8 - Math_fround(HEAPF32[i4 + (i11 << 4) + 4 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i4 + (i6 << 4) >> 2]) - f5);
 f8 = Math_fround(Math_fround(HEAPF32[i4 + (i6 << 4) + 4 >> 2]) - f8);
 i6 = f7 < Math_fround(0.0);
 f10 = Math_fround(-f7);
 i6 = (i6 ? f10 : f7) > Math_fround(9.99999974e-06);
 f7 = Math_fround(f9 / f7);
 f7 = i6 ? f7 : Math_fround(0.0);
 i6 = f5 < Math_fround(0.0);
 f9 = Math_fround(-f5);
 i6 = (i6 ? f9 : f5) > Math_fround(9.99999974e-06);
 f5 = Math_fround(f8 / f5);
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(f3 + Math_fround(1.0)) * Math_fround(.5)) * f7) + Math_fround(Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(.5)) * (i6 ? f5 : Math_fround(0.0))));
 HEAPF32[i4 + (i2 << 4) + 8 >> 2] = f3;
 HEAPF32[i4 + (i2 << 4) + 12 >> 2] = f3;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZNK6Camera21ViewportToScreenPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i4;
 __ZL19GetCameraTargetRectRK6Camerab(i13, i2, 1);
 f8 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f8 = Math_fround(f8 * f10);
 f6 = Math_fround(f6 * f10);
 f7 = Math_fround(f7 * f9);
 f5 = Math_fround(f5 * f9);
 f12 = Math_fround(HEAPF32[i13 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f8 = Math_fround(f8 + f12);
 f7 = Math_fround(f7 + f11);
 f6 = Math_fround(f6 + f8);
 f5 = Math_fround(f5 + f7);
 f10 = Math_fround(f10 + f12);
 f9 = Math_fround(f9 + f11);
 f8 = f8 < f12 ? f12 : f8;
 f7 = f7 < f11 ? f11 : f7;
 f6 = Math_fround((f6 > f10 ? f10 : f6) - f8);
 i2 = f6 < Math_fround(0.0);
 f6 = i2 ? Math_fround(0.0) : f6;
 f5 = Math_fround((f5 > f9 ? f9 : f5) - f7);
 i2 = f5 < Math_fround(0.0);
 f5 = i2 ? Math_fround(0.0) : f5;
 f6 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f6));
 f5 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f5));
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZNK6Camera21ScreenToViewportPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i4;
 __ZL19GetCameraTargetRectRK6Camerab(i13, i2, 1);
 f8 = Math_fround(HEAPF32[i2 + 864 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 868 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 872 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 876 >> 2]);
 f10 = Math_fround(HEAPF32[i13 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i13 + 12 >> 2]);
 f8 = Math_fround(f8 * f10);
 f6 = Math_fround(f6 * f10);
 f7 = Math_fround(f7 * f9);
 f5 = Math_fround(f5 * f9);
 f12 = Math_fround(HEAPF32[i13 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 4 >> 2]);
 f8 = Math_fround(f8 + f12);
 f7 = Math_fround(f7 + f11);
 f6 = Math_fround(f6 + f8);
 f5 = Math_fround(f5 + f7);
 f10 = Math_fround(f10 + f12);
 f9 = Math_fround(f9 + f11);
 f8 = f8 < f12 ? f12 : f8;
 f7 = f7 < f11 ? f11 : f7;
 f6 = Math_fround((f6 > f10 ? f10 : f6) - f8);
 i2 = f6 < Math_fround(0.0);
 f6 = i2 ? Math_fround(0.0) : f6;
 f5 = Math_fround((f5 > f9 ? f9 : f5) - f7);
 i2 = f5 < Math_fround(0.0);
 f5 = i2 ? Math_fround(0.0) : f5;
 f6 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f8) / f6);
 f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f7) / f5);
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 5;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 731704 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
   i1 = i1 + 32 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 32 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN19CharacterController9SetRadiusEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i3 + 92 | 0;
 HEAPF32[i5 >> 2] = f1;
 i2 = i3 + 60 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i4 + 4 >> 2]));
 i3 = f1 < Math_fround(0.0);
 f7 = Math_fround(-f1);
 f1 = i3 ? f7 : f1;
 i3 = f1 < Math_fround(9.99999974e-06);
 f1 = i3 ? Math_fround(9.99999974e-06) : f1;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i3 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i4 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i4 ? f9 : f8;
 f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * (f7 < f8 ? f8 : f7));
 f1 = Math_fround(f1 - Math_fround(f7 * Math_fround(2.0)));
 i5 = f1 < Math_fround(9.99999974e-06);
 f1 = i5 ? Math_fround(9.99999974e-06) : f1;
 i5 = f7 < Math_fround(9.99999974e-06);
 f7 = i5 ? Math_fround(9.99999974e-06) : f7;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0, +f7) | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0, +f1) | 0;
 STACKTOP = i6;
 return;
}

function __ZN19CharacterController9SetHeightEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i3 + 88 | 0;
 HEAPF32[i5 >> 2] = f1;
 i2 = i3 + 60 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i4 + 4 >> 2]));
 i5 = f1 < Math_fround(0.0);
 f7 = Math_fround(-f1);
 f1 = i5 ? f7 : f1;
 i5 = f1 < Math_fround(9.99999974e-06);
 f1 = i5 ? Math_fround(9.99999974e-06) : f1;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i5 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i5 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i5 ? f9 : f8;
 f7 = Math_fround(Math_fround(HEAPF32[i3 + 92 >> 2]) * (f7 < f8 ? f8 : f7));
 f1 = Math_fround(f1 - Math_fround(f7 * Math_fround(2.0)));
 i5 = f1 < Math_fround(9.99999974e-06);
 f1 = i5 ? Math_fround(9.99999974e-06) : f1;
 i5 = f7 < Math_fround(9.99999974e-06);
 f7 = i5 ? Math_fround(9.99999974e-06) : f7;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0, +f7) | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0, +f1) | 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpENS_4fposI11__mbstate_tEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 16 | 0;
 i7 = i6 + 32 | 0;
 i4 = i6;
 __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i7, i2);
 i5 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (!(HEAP32[i5 + 16 >> 2] & 5)) {
  i5 = HEAP32[i5 + 24 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
  __THREW__ = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  invoke_viiii(i8 | 0, i4 | 0, i5 | 0, i1 | 0, 16);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i8 = i4 + 8 | 0;
   if (!((HEAP32[i8 >> 2] | 0) == -1 ? (HEAP32[i8 + 4 >> 2] | 0) == -1 : 0)) break;
   i8 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] | 4 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) break;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i7);
  ___resumeException(i1 | 0);
 } while (0);
 __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i7);
 STACKTOP = i6;
 return i2 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpENS_4fposI11__mbstate_tEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 16 | 0;
 i7 = i6 + 32 | 0;
 i4 = i6;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i7, i2);
 i5 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (!(HEAP32[i5 + 16 >> 2] & 5)) {
  i5 = HEAP32[i5 + 24 >> 2] | 0;
  i8 = HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0;
  __THREW__ = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  invoke_viiii(i8 | 0, i4 | 0, i5 | 0, i1 | 0, 16);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i8 = i4 + 8 | 0;
   if (!((HEAP32[i8 >> 2] | 0) == -1 ? (HEAP32[i8 + 4 >> 2] | 0) == -1 : 0)) break;
   i8 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i8 | 0, HEAP32[i8 + 16 >> 2] | 4 | 0);
   i8 = __THREW__;
   __THREW__ = 0;
   if (!(i8 & 1)) break;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i7);
  ___resumeException(i1 | 0);
 } while (0);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i7);
 STACKTOP = i6;
 return i2 | 0;
}

function __ZNK7Joint2D10FetchBodyBEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i7 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) i5 = 9;
   }
  }
  if ((i5 | 0) == 7) i5 = 9;
  if ((i5 | 0) == 9) {
   i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
   if (!i1) break;
  }
  __ZN11Rigidbody2D6CreateEv(i1);
  i7 = i1 + 92 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  STACKTOP = i6;
  return i7 | 0;
 } while (0);
 i7 = (HEAP32[gb + 1458412 >> 2] | 0) + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21SerializationRegistry22registerRepXSerializerEtRNS_16PxRepXSerializerE(i7, i11, i10) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i5 = i12 + 4 | 0;
 i9 = i12 + 6 | 0;
 i1 = HEAP32[i7 + 68 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i6 = i11 & 65535;
  i4 = i6 + ~(i6 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i7 + 60 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i3 = HEAP32[i7 + 52 >> 2] | 0;
   i4 = i7 + 56 | 0;
   i2 = i1;
   while (1) {
    i1 = i3 + (i2 << 3) | 0;
    if ((HEAP16[i1 >> 1] | 0) == i11 << 16 >> 16) break;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   if (i1 | 0) {
    i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i8 >> 2] = i6;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 2, gb + 667371 | 0, 223, gb + 667782 | 0, i8);
   }
  }
 } while (0);
 HEAP16[i5 >> 1] = i11;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i7 + 48 | 0, i5, i9) | 0;
 if (HEAP8[i9 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP16[i1 >> 1] = i11;
 HEAP32[i1 + 4 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZN5physx17PxcNpMemBlockPoolC2ERNS_19PxcScratchAllocatorE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 0;
 HEAP32[i6 + 48 >> 2] = 0;
 HEAP32[i6 + 52 >> 2] = 0;
 HEAP32[i6 + 56 >> 2] = 0;
 HEAP32[i6 + 60 >> 2] = 0;
 HEAP32[i6 + 64 >> 2] = 0;
 HEAP32[i6 + 68 >> 2] = 0;
 HEAP32[i6 + 72 >> 2] = 0;
 HEAP32[i6 + 76 >> 2] = 0;
 HEAP32[i6 + 80 >> 2] = 0;
 HEAP32[i6 + 84 >> 2] = 0;
 i1 = i6 + 152 | 0;
 i2 = i6 + 168 | 0;
 i3 = i6 + 88 | 0;
 i4 = i3 + 60 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i6 + 172 >> 2] = 0;
 HEAP32[i6 + 176 >> 2] = 0;
 return;
}

function __ZN11JSONUtility15SerializeObjectEP12Il2CppObjectRN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb24TransferInstructionFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i7 = __Z26scripting_object_get_classP12Il2CppObject(i1) | 0;
 __ZN24TextDOMTransferWriteBaseI9JSONWriteEC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i5, i4 | 16384, 0);
 i4 = i5 + 80 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i5 + 100 >> 2] = i5 + 76;
 i8 = i5 + 104 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i5 + 128 >> 2] = 1024;
 HEAP32[i5 + 132 >> 2] = 0;
 HEAP32[i5 + 136 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i5 + 96 >> 2] = 3;
 HEAP32[i5 + 56 >> 2] = i4;
 __Z23TransferScriptingObjectI9JSONWriteEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i5, i1, i7, 0);
 __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i5, i2, i3);
 __ZN9JSONWriteD2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471202 | 0, i5, i1 + 16 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 20 | 0;
 i7 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471088 | 0, i7, i6, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471073 | 0, i7, i6, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN26DownloadHandlerAssetBundle13OnReceiveDataEPKvj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i6 = i11 + 16 | 0;
 i7 = i11 + 4 | 0;
 i8 = i1 + 20 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (!i9) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (HEAP32[i1 + 24 >> 2] | 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i3 = i1 + 28 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == -1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 if ((i4 | 0) != 1) {
  i10 = i5;
  STACKTOP = i11;
  return i10 | 0;
 }
 if (__ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i9, i2, i5) | 0) {
  i10 = i1 + 16 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + i5;
  i10 = i5;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i7, HEAP32[i8 >> 2] | 0);
  HEAP32[i10 >> 2] = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  __Z6FormatPKcz(i6, gb + 1026386 | 0, i10);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 1026280 | 0, 145, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  HEAP32[i3 >> 2] = -1;
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 return 0;
}

function __ZN12AudioManager16SetListenerPauseEb(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 4 | 0;
 i2 = i9;
 i4 = i8 + 40 | 0;
 if ((HEAPU8[i4 >> 0] | 0 | 0) == (i1 & 1 | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP8[i4 >> 0] = i1 & 1;
 i1 = HEAP32[i8 + 88 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN4FMOD6System11getDSPClockEPjS1_(i1, i2, i3) | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP16[i4 >> 1] | 0;
 i1 = i8 + 208 | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = (i2 | 0) == 0 & (i3 | 0) == 0;
 if ((i5 & 65535) < 256 & (i5 & 255) << 24 >> 24 == 0) {
  i5 = i8 + 200 | 0;
  if (!i4) {
   i7 = _i64Subtract(i6 | 0, i7 | 0, i2 | 0, i3 | 0) | 0;
   i6 = getTempRet0() | 0;
   i4 = i5;
   i4 = _i64Add(i7 | 0, i6 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   i6 = getTempRet0() | 0;
   i7 = i5;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = i1;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
 } else if (i4) {
  i5 = i1;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 4 >> 2] = i7;
 }
 i2 = HEAP32[i8 + 48 >> 2] | 0;
 i3 = i8 + 44 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11AudioSource16UpdatePauseStateEv(HEAP32[i8 + 8 >> 2] | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i9;
 return;
}

function __Z26AnimationCurve_CUSTOM_InitP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = __Znwj(88) | 0;
 HEAPF32[i5 + 4 >> 2] = Math_fround(inf);
 HEAP32[i5 >> 2] = 0;
 i8 = i5 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAPF32[i5 + 32 >> 2] = Math_fround(inf);
 HEAP32[i5 + 28 >> 2] = 0;
 i8 = i5 + 36 | 0;
 HEAP32[i5 + 68 >> 2] = 0;
 HEAP32[i5 + 72 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i8 = i4;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5 + 60 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i5 + 80 >> 2] = 2;
 HEAP32[i5 + 76 >> 2] = 2;
 HEAP32[i5 + 84 >> 2] = 4;
 HEAP32[i1 + 8 >> 2] = i5;
 i1 = (i1 | 0) == 0 ? 0 : i5;
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1, i5, i5 + ((__Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0) << 4) | 0);
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_(i2, i2 + (HEAP32[i1 + 68 >> 2] << 4) | 0, i4);
 __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i1);
 STACKTOP = i3;
 return;
}

function mftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii(i35, i1, i2, i13, i24, i29, i30, i31, i32, i33, i34, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18, i19, i20, i21, i22, i23, i25, i26, i27, i28) {
 i35 = i35 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i24 = i24 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 if ((i35 | 0) >= (fb | 0) & (i35 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii[i35 - fb & 3](i1 | 0, i2 | 0, i13 | 0, i24 | 0, i29 | 0, i30 | 0, i31 | 0, i32 | 0, i33 | 0, i34 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0);
  return;
 }
 ftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii(i35 | 0, i1 | 0, i2 | 0, i13 | 0, i24 | 0, i29 | 0, i30 | 0, i31 | 0, i32 | 0, i33 | 0, i34 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0);
}

function __ZN9Rigidbody9AddTorqueERK8Vector3fi(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!(HEAP8[i2 + 80 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 i14 = f15 < Math_fround(0.0);
 f16 = Math_fround(-f15);
 i5 = i4 + 4 | 0;
 f12 = Math_fround(HEAPF32[i5 >> 2]);
 i11 = f12 < Math_fround(0.0);
 f13 = Math_fround(-f12);
 i6 = i4 + 8 | 0;
 f9 = Math_fround(HEAPF32[i6 >> 2]);
 i3 = f9 < Math_fround(0.0);
 f10 = Math_fround(-f9);
 i14 = (i14 ? f16 : f15) == Math_fround(HEAPF32[gb + 1162364 >> 2]);
 i11 = i14 & (i11 ? f13 : f12) == Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 if (i11 & (i3 ? f10 : f9) == Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
  STACKTOP = i8;
  return;
 }
 i2 = i2 + 52 | 0;
 i14 = HEAP32[i2 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i14 >> 2] | 0) + 200 >> 2] | 0, i14 | 0) | 0) & 1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i14 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = i11;
 HEAP32[i7 + 8 >> 2] = i14;
 switch (i1 | 0) {
 case 5:
  {
   i1 = 3;
   break;
  }
 case 1:
  break;
 case 2:
  break;
 default:
  i1 = 0;
 }
 mftCall_viiii(i3 | 0, i2 | 0, i7 | 0, i1 | 0, 1);
 STACKTOP = i8;
 return;
}

function __ZN5physx7profile17EventDeserializerILb0EE9streamifyIyEEvPKcRT_(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i4 + 8 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 8) {
   HEAP8[i3 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 1 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 3 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 4 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 5 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 6 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 7 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   return;
  }
 }
 HEAP8[i1 >> 0] = 1;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 4 | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 * 40 | 0, 4) | 0;
  i1 = i1 | 0 ? i1 - i3 | 0 : 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 i2 = i1 + (i5 * 40 | 0) | 0;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i1, gb + 1085944 | 0, 0);
  __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i1 + 12 | 0, i7);
  __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i1 + 28 | 0, gb + 1085935 | 0, 0);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i3 = i5;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i1 = i9 + 8 | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i3 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i2 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i2;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  break;
 } while (0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i9, i2, i1);
 STACKTOP = i8;
 return;
}

function __ZN15b2DistanceJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 88 | 0;
 i4 = i2 + 80 | 0;
 i5 = i2 + 72 | 0;
 i6 = i2 + 64 | 0;
 i7 = i2 + 48 | 0;
 i10 = i2 + 32 | 0;
 i11 = i2 + 24 | 0;
 i12 = i2 + 16 | 0;
 i14 = i2 + 8 | 0;
 i15 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 799334 | 0, i2);
 HEAP32[i14 >> 2] = i15;
 __Z5b2LogPKcz(gb + 799360 | 0, i14);
 HEAP32[i12 >> 2] = i13;
 __Z5b2LogPKcz(gb + 799386 | 0, i12);
 HEAP32[i11 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i11);
 d8 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 HEAPF64[i10 >> 3] = d8;
 HEAPF64[i10 + 8 >> 3] = d9;
 __Z5b2LogPKcz(gb + 799447 | 0, i10);
 d9 = +Math_fround(HEAPF32[i1 + 88 >> 2]);
 d8 = +Math_fround(HEAPF32[i1 + 92 >> 2]);
 HEAPF64[i7 >> 3] = d9;
 HEAPF64[i7 + 8 >> 3] = d8;
 __Z5b2LogPKcz(gb + 799489 | 0, i7);
 HEAPF64[i6 >> 3] = +Math_fround(HEAPF32[i1 + 104 >> 2]);
 __Z5b2LogPKcz(gb + 799531 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 __Z5b2LogPKcz(gb + 799555 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 __Z5b2LogPKcz(gb + 799584 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN15AudioMixerGroup8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863864 | 0, gb + 863877 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10AudioMixerE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 56 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863894 | 0, gb + 863904 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863909 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i2 = i3 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[HEAP32[i7 >> 2] >> 2] = i8;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!(HEAP8[gb + 1099744 >> 0] | 0)) {
   i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
   i7 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
   i11 = gb + 63696 | 0;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i9 = i4;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = i10;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i7, 1, gb + 1018240 | 0, 24, 32768, i5, 16);
   HEAP32[gb + 1468880 >> 2] = i7;
   __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i7);
   if (i8) __Z19pop_allocation_rootv();
   i11 = gb + 1099744 | 0;
   HEAP32[i11 >> 2] = 1;
   HEAP32[i11 + 4 >> 2] = 0;
  }
  __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1468880 >> 2] | 0, i2);
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN7Cursors20RenderSoftwareCursorEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 228 | 0;
 i1 = i7 + 32 | 0;
 i2 = i7 + 24 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = __ZN7Cursors17GetSoftwareCursorEv() | 0;
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 i8 = __Z16GetScreenManagerv() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i1, __Z12GetGfxDevicev() | 0);
 __Z28SetupPixelCorrectCoordinatesv();
 i8 = (__Z21GetManagerFromContexti(1) | 0) + 116 | 0;
 f12 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 __ZN7Cursors16GetCursorHotspotEv(i2);
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i2 >> 2]));
 f12 = Math_fround(~~f12 | 0);
 f10 = Math_fround(~~Math_fround(f10 + Math_fround(HEAPF32[i2 + 4 >> 2])) | 0);
 f11 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 100 >> 2] | 0, i5 | 0) | 0);
 f9 = Math_fround(0 - (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 104 >> 2] | 0, i5 | 0) | 0) | 0);
 HEAPF32[i3 >> 2] = f12;
 HEAPF32[i3 + 8 >> 2] = f11;
 HEAPF32[i3 + 4 >> 2] = f10;
 HEAPF32[i3 + 12 >> 2] = f9;
 HEAP32[i4 >> 2] = -2139062144;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i3, i5, i6, 0, -1);
 __ZN22DeviceMVPMatricesStateD2Ev(i1);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 220 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 221 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 224 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 228 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 236 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStriEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i8 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i12;
  return;
 }
}

function __ZN15LODGroupManager16CalculateLODFadeEjhf(i5, i2, f1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i2 & 255;
 i4 = i3 >>> 1;
 i2 = i3 - (i4 & 85) | 0;
 i2 = (i2 >>> 2 & 858993459) + (i2 & 858993459) | 0;
 i2 = Math_imul((i2 >>> 4) + i2 & 252645135, 16843009) | 0;
 if ((i2 & -16777216 | 0) == 16777216) {
  f1 = Math_fround(-f1);
  i6 = f1 > Math_fround(0.0);
  f1 = i6 ? Math_fround(0.0) : f1;
  STACKTOP = i7;
  return Math_fround(f1);
 }
 if ((i3 & i5 | 0) == (i3 | 0) | i2 >>> 0 > 50331647) {
  f1 = Math_fround(0.0);
  STACKTOP = i7;
  return Math_fround(f1);
 }
 i4 = i4 | i3;
 i4 = i4 >>> 2 | i4;
 i4 = (i4 >>> 4 | i4) + 1 | 0;
 HEAP32[i6 >> 2] = i4 >>> 2;
 HEAP32[i6 + 4 >> 2] = i4 >>> 1;
 f8 = Math_fround(Math_fround(1.0) - f1);
 f1 = HEAP32[i6 + (((i3 + 255 & i3 | 0) == 0 & 1) << 2) >> 2] & i5 | 0 ? f1 : f8;
 if (!(f1 <= Math_fround(.5))) {
  if (f1 < Math_fround(.500100017)) {
   f8 = Math_fround(.500100017);
   STACKTOP = i7;
   return Math_fround(f8);
  }
  i6 = f1 > Math_fround(.999899983);
  f8 = i6 ? Math_fround(.999899983) : f1;
  STACKTOP = i7;
  return Math_fround(f8);
 } else {
  if (f1 < Math_fround(.0000999999974)) {
   f8 = Math_fround(.0000999999974);
   STACKTOP = i7;
   return Math_fround(f8);
  }
  i6 = f1 > Math_fround(.499900013);
  f8 = i6 ? Math_fround(.499900013) : f1;
  STACKTOP = i7;
  return Math_fround(f8);
 }
 return f0;
}

function __ZN14SpriteRenderer11GetGeometryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = HEAP32[i1 + 364 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = (__ZNK6Sprite24GetRenderDataForPlayModeEv(i1) | 0) + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
  i2 = i1 + 4 | 0;
  i3 = i2;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 45376 + 8;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i2 = i6;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[i1 + 28 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 44 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
  i3 = i6;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i5 >> 2] = i1;
 }
 if (!(HEAP32[i1 + 20 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP32[i1 + 40 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13dynamic_arrayIN12TreeRenderer15RendererLODInfoELj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 72 | 0;
 i2 = (i1 | 0) / 72 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 72 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 72 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 72 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 72 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = HEAP32[i2 + 40 >> 2] | 0;
 i14 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i14) {
  i14 = 0;
  return i14 | 0;
 }
 i12 = HEAP32[i1 >> 2] | 0;
 if (!i13) {
  i14 = 0;
  return i14 | 0;
 }
 i3 = HEAP32[i2 + 28 >> 2] | 0;
 i1 = 0;
 L7 : while (1) {
  i4 = HEAP32[i12 + (i1 << 5) >> 2] | 0;
  i5 = i12 + (i1 << 5) + 4 | 0;
  i6 = i12 + (i1 << 5) + 8 | 0;
  i7 = i12 + (i1 << 5) + 12 | 0;
  i8 = i12 + (i1 << 5) + 16 | 0;
  i9 = i12 + (i1 << 5) + 20 | 0;
  i10 = i12 + (i1 << 5) + 24 | 0;
  i11 = i12 + (i1 << 5) + 28 | 0;
  i2 = 0;
  do {
   if ((i4 | 0) == (HEAP32[i3 + (i2 << 5) >> 2] | 0)) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 4 >> 2] | 0)) if ((HEAP32[i6 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 8 >> 2] | 0)) if ((HEAP32[i7 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 12 >> 2] | 0)) if ((HEAP32[i8 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 16 >> 2] | 0)) if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 20 >> 2] | 0)) if ((HEAP32[i10 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 24 >> 2] | 0)) if ((HEAP32[i11 >> 2] | 0) == (HEAP32[i3 + (i2 << 5) + 28 >> 2] | 0)) {
    i1 = 1;
    i2 = 15;
    break L7;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i13 | 0));
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i14 | 0)) {
   i1 = 0;
   i2 = 15;
   break;
  }
 }
 if ((i2 | 0) == 15) return i1 | 0;
 return 0;
}

function __ZNK5Umbra9Matrix4x3eqERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 4 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 8 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 12 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 16 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 20 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 24 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 28 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 32 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 36 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 40 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 i2 = f3 == Math_fround(HEAPF32[i2 + 44 >> 2]);
 return i2 | 0;
}

function __ZNK15HeightMeshQuery17SetPositionHeightEPf(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 8 | 0;
 i8 = i11 + 4 | 0;
 i9 = i11;
 if (!(HEAP32[i4 + 12 >> 2] | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = i1 + 4 | 0;
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i4 + 16 >> 2]));
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i5 = i7 + 4 | 0;
 HEAPF32[i5 >> 2] = f3;
 HEAP32[i7 + 8 >> 2] = i6;
 i6 = __ZNK15HeightMeshQuery17GetGeometryHeightERK8Vector3fPf(i4, i7, i8) | 0;
 i1 = __ZNK15HeightMeshQuery16GetTerrainHeightERK8Vector3fPf(i4, i7, i9) | 0;
 do if (i6 & i1) {
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f14 = Math_fround(f12 - f3);
  i8 = f14 < Math_fround(0.0);
  f15 = Math_fround(-f14);
  f2 = Math_fround(HEAPF32[i9 >> 2]);
  f12 = Math_fround(f12 - f2);
  i9 = f12 < Math_fround(0.0);
  f13 = Math_fround(-f12);
  if ((i8 ? f15 : f14) < (i9 ? f13 : f12)) {
   HEAPF32[i10 >> 2] = f3;
   i1 = 1;
   break;
  } else {
   HEAPF32[i10 >> 2] = f2;
   i1 = 1;
   break;
  }
 } else {
  if (i6) {
   HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
   i1 = 1;
   break;
  }
  if (i1) {
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   i1 = 1;
  } else i1 = 0;
 } while (0);
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7mecanim5human10TwistSolveEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 12 | 0;
 i7 = i4 + 8 | 0;
 i6 = i4 + 4 | 0;
 i5 = i4;
 HEAP32[i8 >> 2] = HEAP32[i1 + 368 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i1 + 364 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i1 + 376 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i1 + 372 >> 2];
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 15, 17, i8);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 13, 15, i7);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 16, 18, i8);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 14, 16, i7);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 3, 5, i6);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 1, 3, i5);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 4, 6, i6);
 __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf(i1, i2, i3, 2, 4, i5);
 STACKTOP = i4;
 return;
}

function __ZN7Texture17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 4 | 0;
 i8 = i11;
 i9 = HEAP32[gb + 1158372 >> 2] | 0;
 i5 = i9 + 4 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + 48 | 0;
 if (i10 | 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = i5;
  i2 = i10;
  L3 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L3;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break;
   } else i3 = i1;
  }
  if ((i3 | 0) != (i5 | 0)) if (i4 >>> 0 >= (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) {
    i2 = i3;
    while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    }
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) HEAP32[i9 >> 2] = i1;
   i9 = i9 + 8 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i10, i3);
   __ZdlPv(i3);
  }
 }
 i10 = __Z25GetUncheckedRealGfxDevicev() | 0;
 i9 = HEAP32[(HEAP32[i10 >> 2] | 0) + 424 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i9 | 0, i10 | 0, i7 | 0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx2Sn8MetaData11addNewClassEPKciPNS0_9MetaClassEMNS0_5ConvXEFvS3_RKNS0_15PxMetaDataEntryES9_E(i7, i3, i4, i2, i1) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i5 = mftCall_iiiiii(i11 | 0, i10 | 0, 52, (i5 ? gb + 670972 | 0 : gb + 837976 | 0) | 0, gb + 670404 | 0, 263) | 0;
 i10 = i5 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i10 + 8 >> 2] = 0;
 HEAP32[i10 + 12 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 HEAP32[i10 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = i3;
 HEAP32[i5 + 16 >> 2] = i4;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP8[i5 + 48 >> 0] = 0;
 i1 = i7 + 20 | 0;
 i2 = i7 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 28 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i8;
  return i5 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i6) | 0;
  STACKTOP = i8;
  return i5 | 0;
 }
 return 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i9, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 32 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15TerrainRendererD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 20 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i5, i1);
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i5 + 116 | 0;
 i3 = i5 + 128 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i8 = i2 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  i1 = 0;
 }
 do {
  i2 = i5 + 136 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i8 = i3 + 4 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
   if (!(HEAP32[i8 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63248 | 0);
   }
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 if ((HEAP32[i5 + 132 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i5 + 120 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -64 - i1 | 0) >>> 6) << 6);
 __ZdlPv(i1);
 return;
}

function __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i5 = i1 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i3;
 }
 HEAP8[i4 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 1 >> 0] = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i4 + 2 >> 0] = i1;
 i1 = i4 + 3 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i7 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i5;
  HEAP32[i7 >> 2] = i3;
  i7 = i5;
  HEAP8[i1 >> 0] = i7;
  STACKTOP = i8;
  return;
 }
}

function __Z43Random_CUSTOM_INTERNAL_get_insideUnitSphereP8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = __Z16GetScriptingRandv() | 0;
 i8 = HEAP32[i13 >> 2] | 0;
 i8 = i8 << 11 ^ i8;
 i11 = i13 + 4 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i10 = i13 + 8 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i7 = i13 + 12 | 0;
 i14 = HEAP32[i7 >> 2] | 0;
 i8 = i8 >>> 8 ^ i8 ^ i14;
 i12 = i8 ^ i14 >>> 19;
 f2 = Math_fround(Math_fround((i12 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f2 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f2);
 i6 = i6 << 11 ^ i6;
 i6 = i6 >>> 8 ^ i6 ^ i12;
 i8 = i6 ^ i8 >>> 19;
 f3 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f3 = Math_fround(Math_fround(f3 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f3) * Math_fround(6.28318548)));
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f2 * f2))));
 f5 = Math_fround(f4 * Math_fround(+Math_cos(+f3)));
 f3 = Math_fround(f4 * Math_fround(+Math_sin(+f3)));
 i9 = i9 << 11 ^ i9;
 HEAP32[i13 >> 2] = i14;
 HEAP32[i11 >> 2] = i12;
 HEAP32[i10 >> 2] = i8;
 i6 = i9 >>> 8 ^ i9 ^ i8 ^ i6 >>> 19;
 HEAP32[i7 >> 2] = i6;
 f4 = Math_fround(+Math_pow(+Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07)), .333333343));
 f3 = Math_fround(f3 * f4);
 f2 = Math_fround(f4 * f2);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f4);
 HEAPF32[i1 + 4 >> 2] = f3;
 HEAPF32[i1 + 8 >> 2] = f2;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19getPropertyMessagesEPN5physx8debugger26PropertyMessageDescriptionEjj(i1, i9, i4, i5) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0;
 i8 = i2 >>> 0 > i5 >>> 0 ? i5 : i2;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0;
 i7 = i3 - i8 | 0;
 i7 = i7 >>> 0 > i4 >>> 0 ? i4 : i7;
 if (!i7) return i7 | 0;
 i6 = i1 + 228 | 0;
 i2 = -2 - i3 - ~(i2 >>> 0 < i5 >>> 0 ? i2 : i5) | 0;
 i1 = ~i4;
 i1 = ~(i2 >>> 0 > i1 >>> 0 ? i2 : i1);
 i2 = 0;
 do {
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 + i8 << 2) >> 2] | 0;
  i4 = i5 + 4 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i10 = i9 + (i2 * 48 | 0) + 4 | 0;
  HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i10 + 4 >> 2] = i3;
  HEAP32[i9 + (i2 * 48 | 0) + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i10 = i5 + 16 | 0;
  i3 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = i9 + (i2 * 48 | 0) + 16 | 0;
  HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i9 + (i2 * 48 | 0) + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i9 + (i2 * 48 | 0) + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP32[i9 + (i2 * 48 | 0) + 32 >> 2] = HEAP32[i5 + 32 >> 2];
  HEAP32[i9 + (i2 * 48 | 0) + 36 >> 2] = HEAP32[i5 + 36 >> 2];
  HEAP32[i9 + (i2 * 48 | 0) + 40 >> 2] = HEAP32[i5 + 40 >> 2];
  HEAP32[i9 + (i2 * 48 | 0) + 44 >> 2] = HEAP32[i5 + 44 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i7 | 0;
}

function __ZN14EdgeCollider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 80 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 155208 + 8;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 164 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15PlatformWrapper15GetBuildVersionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = __Z19GetBuildSettingsPtrv() | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP8[i1 + 11 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
  STACKTOP = i7;
  return;
 }
 i5 = i2 + 140 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i5 = i8 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i8 ? HEAP32[i2 + 144 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 5;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (i4) i6 = 7;
 } else i6 = 5;
 if ((i6 | 0) == 5) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
  i6 = 7;
 }
 if ((i6 | 0) == 7) _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z11PremultiplyR14ImageReference(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   i1 = Math_imul(HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
   i2 = (i1 | 0) / 4 | 0;
   if ((i1 | 0) > 3) i1 = 0; else return;
   do {
    i4 = i3 + (i1 << 2) | 0;
    i5 = HEAPU8[i4 + 3 >> 0] | 0;
    HEAP8[i4 >> 0] = ((Math_imul(i5, HEAPU8[i4 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i6 = i4 + 1 | 0;
    HEAP8[i6 >> 0] = ((Math_imul(i5, HEAPU8[i6 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i4 = i4 + 2 | 0;
    HEAP8[i4 >> 0] = ((Math_imul(i5, HEAPU8[i4 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   return;
  }
 case 5:
  {
   i3 = HEAP32[i1 + 16 >> 2] | 0;
   i6 = Math_imul(HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
   i2 = (i6 | 0) / 4 | 0;
   if ((i6 | 0) > 3) i1 = 0; else return;
   do {
    i6 = i3 + (i1 << 2) | 0;
    i4 = i6 + 1 | 0;
    i5 = HEAPU8[i6 >> 0] | 0;
    HEAP8[i4 >> 0] = ((Math_imul(i5, HEAPU8[i4 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i4 = i6 + 2 | 0;
    HEAP8[i4 >> 0] = ((Math_imul(i5, HEAPU8[i4 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i6 = i6 + 3 | 0;
    HEAP8[i6 >> 0] = ((Math_imul(i5, HEAPU8[i6 >> 0] | 0) | 0) >>> 0) / 255 | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 419832 | 0, 0, gb + 404494 | 0, 967, 1, 0, 0, 0);
   return;
  }
 }
}

function __Z10EncodeRGBMRK10ColorRGBAf10RGBMRanges(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f5 = Math_fround(Math_fround(1.0) / Math_fround(i3 | 0));
 f7 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 f4 = Math_fround(_fmaxf(f7, f6));
 f4 = Math_fround(Math_fround(Math_ceil(Math_fround(Math_fround(_fmaxf(f4, Math_fround(_fmaxf(f5, Math_fround(.0199999996))))) * Math_fround(255.0)))) / Math_fround(255.0));
 f7 = Math_fround(f7 / f4);
 f6 = Math_fround(f6 / f4);
 f5 = Math_fround(f5 / f4);
 i3 = f7 < Math_fround(0.0);
 f7 = i3 ? Math_fround(0.0) : f7;
 i3 = f7 > Math_fround(1.0);
 HEAP8[i1 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f6 < Math_fround(0.0);
 f6 = i3 ? Math_fround(0.0) : f6;
 i3 = f6 > Math_fround(1.0);
 HEAP8[i1 + 1 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f5 < Math_fround(0.0);
 f5 = i3 ? Math_fround(0.0) : f5;
 i3 = f5 > Math_fround(1.0);
 HEAP8[i1 + 2 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f5) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 i3 = f4 < Math_fround(0.0);
 f4 = i3 ? Math_fround(0.0) : f4;
 i3 = f4 > Math_fround(1.0);
 HEAP8[i1 + 3 >> 0] = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 return;
}

function __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5eraseENS_21__list_const_iteratorIS9_PvEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[HEAP32[i7 >> 2] >> 2] = i8;
 i3 = i3 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP8[gb + 1098096 >> 0] | 0) {
  i8 = HEAP32[gb + 1158352 >> 2] | 0;
  __ZN10MemoryPool10DeallocateEPv(i8, i1);
  STACKTOP = i6;
  return i2 | 0;
 }
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i7 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
 i10 = gb + 63696 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i7, 1, gb + 1018240 | 0, 52, 32768, i5, 16);
 HEAP32[gb + 1158352 >> 2] = i7;
 __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i7);
 if (i8) __Z19pop_allocation_rootv();
 i10 = gb + 1098096 | 0;
 HEAP32[i10 >> 2] = 1;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = HEAP32[gb + 1158352 >> 2] | 0;
 __ZN10MemoryPool10DeallocateEPv(i10, i1);
 STACKTOP = i6;
 return i2 | 0;
}

function __ZN8Collider12SetIsTriggerEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 1 | 0;
 i6 = i8;
 HEAP8[i1 + 40 >> 0] = i2 & 1;
 i5 = i1 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (i2) {
  i7 = HEAP32[i5 >> 2] | 0;
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0;
  HEAP8[i4 >> 0] = i3 & -8 & 255 | 6;
  mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0) | 0;
  if ((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 5) i7 = 7; else if ((i1 + -5 | 0) >>> 0 > 1 | ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0) | 0) & 1) != 0) i7 = 7; else i1 = i3 & -2;
  if ((i7 | 0) == 7) i1 = (i3 & 255 | 1) & 255;
  i7 = HEAP32[i5 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0;
  HEAP8[i6 >> 0] = (i1 & 255 | 2) & 255 & -5;
  mftCall_vii(i4 | 0, i7 | 0, i6 | 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj8ENS_22PxRepXPropertyAccessorILj8ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 24; else i1 = (HEAP32[i1 >> 2] | 0) + 24 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 757377 | 0)) i1 = 0; else {
  i3 = gb + 757377 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 89304 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 89304 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj7ENS_22PxRepXPropertyAccessorILj7ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (!i1) i1 = 20; else i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i6 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i2 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 L20 : do if (!(gb + 757377 | 0)) i1 = 0; else {
  i3 = gb + 757377 | 0;
  i1 = 0;
  while (1) {
   if (!(_strcasecmp(i3, i2) | 0)) break;
   i1 = i1 + 1 | 0;
   i3 = HEAP32[gb + 89304 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    i1 = 0;
    break L20;
   }
  }
  i1 = HEAP32[gb + 89304 + (i1 << 3) + 4 >> 2] | 0;
 } while (0);
 mftCall_vii(HEAP32[i5 + 20 >> 2] | 0, HEAP32[i6 + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i7;
 return;
}

function __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 40 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 48 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 32 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function _UNITY_FT_Matrix_Invert(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 if (!i12) {
  i15 = 6;
  return i15 | 0;
 }
 i13 = HEAP32[i12 >> 2] | 0;
 i14 = i12 + 12 | 0;
 i15 = HEAP32[i14 >> 2] | 0;
 i10 = i13 >> 31;
 i2 = (i13 | 0) < 0 ? 0 - i13 | 0 : i13;
 i11 = (i15 | 0) < 0;
 i1 = i11 ? 0 - i15 | 0 : i15;
 if (((i1 >>> 8) + i2 | 0) >>> 0 < 8191) i3 = ((Math_imul(i1, i2) | 0) + 32768 | 0) >>> 16; else {
  i3 = i2 & 65535;
  i3 = (Math_imul(i1 >>> 16, i3) | 0) + (Math_imul(i2 >>> 16, i1) | 0) + (((Math_imul(i1 & 65535, i3) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i6 = i12 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i12 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i4 = i7 >> 31;
 i2 = (i7 | 0) < 0 ? 0 - i7 | 0 : i7;
 i5 = (i9 | 0) < 0;
 i1 = i5 ? 0 - i9 | 0 : i9;
 if (((i1 >>> 8) + i2 | 0) >>> 0 < 8191) i1 = ((Math_imul(i1, i2) | 0) + 32768 | 0) >>> 16; else {
  i16 = i2 & 65535;
  i1 = (Math_imul(i1 >>> 16, i16) | 0) + (Math_imul(i2 >>> 16, i1) | 0) + (((Math_imul(i1 & 65535, i16) | 0) + 32768 | 0) >>> 16) | 0;
 }
 i1 = (((i11 ? 0 - (i10 | 1) | 0 : i10) | 0) < 0 ? 0 - i3 | 0 : i3) - (((i5 ? 0 - (i4 | 1) | 0 : i4) | 0) < 0 ? 0 - i1 | 0 : i1) | 0;
 if (!i1) {
  i16 = 6;
  return i16 | 0;
 }
 HEAP32[i6 >> 2] = 0 - (_UNITY_FT_DivFix(i7, i1) | 0);
 HEAP32[i8 >> 2] = 0 - (_UNITY_FT_DivFix(i9, i1) | 0);
 HEAP32[i12 >> 2] = _UNITY_FT_DivFix(i15, i1) | 0;
 HEAP32[i14 >> 2] = _UNITY_FT_DivFix(i13, i1) | 0;
 i16 = 0;
 return i16 | 0;
}

function __ZN7Terrain14SetDynamicUVSTERK8Vector4fS2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0;
 i8 = i3 + 156 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i8 = i3 + 172 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f6 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 140 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 148 >> 2]);
 f4 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 156 >> 2]));
 f5 = Math_fround(f7 * Math_fround(HEAPF32[i3 + 160 >> 2]));
 f6 = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 164 >> 2])));
 f7 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 168 >> 2])));
 i8 = i3 + 228 | 0;
 i2 = i3 + 240 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i8 >> 2] | 0;
 do {
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAPF32[i3 + 92 >> 2] = f4;
  HEAPF32[i3 + 96 >> 2] = f5;
  HEAPF32[i3 + 100 >> 2] = f6;
  HEAPF32[i3 + 104 >> 2] = f7;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  HEAPF32[i3 + 48 >> 2] = f4;
  HEAPF32[i3 + 52 >> 2] = f5;
  HEAPF32[i3 + 56 >> 2] = f6;
  HEAPF32[i3 + 60 >> 2] = f7;
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i8 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN5physx2Sq10AABBPruner19fullRebuildAABBTreeEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i5 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx2Sq8AABBTreeD2Ev(i1);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 32 | 0, i1);
 }
 HEAP32[i4 >> 2] = 0;
 i2 = HEAP32[i5 + 7764 >> 2] | 0;
 if (!i2) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i8 | 0, i7 | 0, 548, (i1 ? gb + 706631 | 0 : gb + 837976 | 0) | 0, gb + 706743 | 0, 774) | 0;
 __ZN5physx2Sq8AABBTreeC2Ev(i1);
 HEAP32[i4 >> 2] = i1;
 i7 = i3 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 7772 >> 2];
 HEAP32[i3 + 4 >> 2] = 2;
 HEAP32[i3 >> 2] = 1;
 i1 = __ZN5physx2Sq8AABBTree5buildEPNS0_15AABBTreeBuilderE(i1, i3) | 0;
 if (!(HEAP8[i5 + 7808 >> 0] | 0)) {
  i8 = i1;
  STACKTOP = i6;
  return i8 | 0;
 }
 i8 = HEAP32[i5 + 48 >> 2] | 0;
 __ZN5physx2Sq17AABBTreeUpdateMap7initMapEjRKNS0_8AABBTreeE(i5 + 7796 | 0, i2 >>> 0 < i8 >>> 0 ? i8 : i2, HEAP32[i4 >> 2] | 0);
 i8 = i1;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = i6 + 4 | 0;
 i7 = i3 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i3 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 272 | 0, i3);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 536 | 0, i3);
 i1 = i6 + 800 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i3);
 i1 = i6 + 804 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 808 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN19RuntimeSceneManager15FindSceneByPathERK8UnityStr(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = i1 + (i8 << 2) | 0;
 L1 : do if (i8) {
  i8 = HEAP8[i7 + 11 >> 0] | 0;
  i6 = i8 << 24 >> 24 < 0;
  i8 = i6 ? HEAP32[i7 + 4 >> 2] | 0 : i8 & 255;
  if (i6) {
   i7 = HEAP32[i7 >> 2] | 0;
   while (1) {
    i5 = HEAP32[i1 >> 2] | 0;
    i3 = i5 + 12 | 0;
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    if (i2) i4 = HEAP32[i5 + 16 >> 2] | 0; else i4 = i6 & 255;
    if ((i4 | 0) == (i8 | 0)) {
     if (i2) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i5 + 16 >> 2] | 0;
     } else i2 = i6 & 255;
     if (!(_strncmp(i3, i7, i2) | 0)) break L1;
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = 0;
     break;
    }
   }
   return i1 | 0;
  } else {
   while (1) {
    i5 = HEAP32[i1 >> 2] | 0;
    i3 = i5 + 12 | 0;
    i6 = HEAP8[i3 + 11 >> 0] | 0;
    i2 = i6 << 24 >> 24 < 0;
    if (i2) i4 = HEAP32[i5 + 16 >> 2] | 0; else i4 = i6 & 255;
    if ((i4 | 0) == (i8 | 0)) {
     if (i2) {
      i3 = HEAP32[i3 >> 2] | 0;
      i2 = HEAP32[i5 + 16 >> 2] | 0;
     } else i2 = i6 & 255;
     if (!(_strncmp(i3, i7, i2) | 0)) break L1;
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = 0;
     break;
    }
   }
   return i1 | 0;
  }
 } while (0);
 if ((i1 | 0) == (i9 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP32[i1 >> 2] | 0;
 return i9 | 0;
}

function __ZN11b2WeldJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 88 | 0;
 i4 = i2 + 80 | 0;
 i5 = i2 + 72 | 0;
 i6 = i2 + 64 | 0;
 i7 = i2 + 48 | 0;
 i10 = i2 + 32 | 0;
 i11 = i2 + 24 | 0;
 i12 = i2 + 16 | 0;
 i14 = i2 + 8 | 0;
 i15 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800613 | 0, i2);
 HEAP32[i14 >> 2] = i15;
 __Z5b2LogPKcz(gb + 799360 | 0, i14);
 HEAP32[i12 >> 2] = i13;
 __Z5b2LogPKcz(gb + 799386 | 0, i12);
 HEAP32[i11 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i11);
 d8 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 HEAPF64[i10 >> 3] = d8;
 HEAPF64[i10 + 8 >> 3] = d9;
 __Z5b2LogPKcz(gb + 799447 | 0, i10);
 d9 = +Math_fround(HEAPF32[i1 + 88 >> 2]);
 d8 = +Math_fround(HEAPF32[i1 + 92 >> 2]);
 HEAPF64[i7 >> 3] = d9;
 HEAPF64[i7 + 8 >> 3] = d8;
 __Z5b2LogPKcz(gb + 799489 | 0, i7);
 HEAPF64[i6 >> 3] = +Math_fround(HEAPF32[i1 + 96 >> 2]);
 __Z5b2LogPKcz(gb + 800071 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 __Z5b2LogPKcz(gb + 799555 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 __Z5b2LogPKcz(gb + 799584 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZNK22ParticleSystemRenderer12GetMeshCountEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 8 | 0;
 i9 = i11;
 i6 = 0;
 i1 = 0;
 do {
  i5 = i7 + 552 + (i6 << 2) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  do if (i2) {
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[gb + 1104264 >> 2] | 0;
   if (!i2) i10 = 9; else {
    if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
     i3 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[i2 + 32 >> 2] | 0;
     i2 = i3 + (i4 << 3) | 0;
    } else {
     __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i8, i2, i9);
     i3 = HEAP32[i8 >> 2] | 0;
     i12 = HEAP32[i2 + 28 >> 2] | 0;
     i4 = HEAP32[gb + 1104264 >> 2] | 0;
     i2 = (i3 | 0) == -1 ? i12 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i12 + (i3 << 3) | 0;
     i3 = HEAP32[i4 + 28 >> 2] | 0;
     i4 = HEAP32[i4 + 32 >> 2] | 0;
    }
    if ((i2 | 0) == (i3 + (i4 << 3) | 0)) i10 = 9; else if (!(HEAP32[i2 + 4 >> 2] | 0)) i10 = 11;
   }
   if ((i10 | 0) == 9) i10 = 11;
   if ((i10 | 0) == 11) {
    i10 = 0;
    if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0)) break;
   }
   i1 = i1 + 1 | 0;
  } while (0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 4);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl23findPropertyMessageImplERKN5physx8debugger14NamespacedNameE(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i5 = HEAP32[i9 + 196 >> 2] | 0;
 if (!i5) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i2 = 5381;
  i3 = i7;
  do {
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i1 = HEAP8[i8 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = 5381; else {
  i3 = 5381;
  i4 = i8;
  do {
   i3 = i3 * 33 ^ i1 << 24 >> 24;
   i4 = i4 + 1 | 0;
   i1 = HEAP8[i4 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i1 = i3;
 }
 i1 = HEAP32[(HEAP32[i9 + 188 >> 2] | 0) + (((i1 ^ i2) & i5 + -1) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i6 = HEAP32[i9 + 180 >> 2] | 0;
 i5 = i7 | 0 ? i7 : gb + 1576256 | 0;
 i4 = i8 | 0 ? i8 : gb + 1576256 | 0;
 i3 = i9 + 184 | 0;
 while (1) {
  i9 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] | 0;
  if (!(_strcmp(i9 | 0 ? i9 : gb + 1576256 | 0, i5) | 0)) if (!(_strcmp(i2 | 0 ? i2 : gb + 1576256 | 0, i4) | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i10 = 13;
   break;
  }
 }
 if ((i10 | 0) == 13) return i1 | 0;
 if (!(i6 + (i1 * 12 | 0) | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = HEAP32[i6 + (i1 * 12 | 0) + 8 >> 2] | 0;
 return i10 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 48 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -48 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN19CharacterController10SimpleMoveERK8Vector3f(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 f9 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 f6 = Math_fround(f9 * Math_fround(HEAPF32[(__Z17GetPhysicsManagerv() | 0) + 36 >> 2]));
 i7 = i5 + 112 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f6);
 HEAPF32[i7 >> 2] = f6;
 i7 = i5 + 140 | 0;
 if (!(HEAP32[i7 >> 2] & 4)) {
  i2 = HEAP32[i5 + 128 >> 2] | 0;
  i1 = HEAP32[i5 + 136 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  i4 = i8 + 4 | 0;
  HEAPF32[i4 >> 2] = f6;
  i3 = i8 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  i4 = i8 + 4 | 0;
  HEAPF32[i4 >> 2] = f6;
  i3 = i8 + 8 | 0;
  HEAP32[i3 >> 2] = i1;
  i11 = i5 + 128 | 0;
  HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 }
 f13 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f9 * f13);
 HEAPF32[i4 >> 2] = Math_fround(f9 * f6);
 HEAPF32[i3 >> 2] = Math_fround(f9 * f12);
 __ZN19CharacterController4MoveERK8Vector3f(i5, i8) | 0;
 STACKTOP = i10;
 return (HEAP32[i7 >> 2] & 4 | 0) != 0 | 0;
}

function __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEC2ERKS3_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 52 | 0;
 i2 = (i1 | 0) / 52 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 52 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 52 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 52 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 52 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN10Collider2D10SetDensityEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP32[i2 + 72 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i6 + 28 >> 2] | 0;
  if (i7 | 0) {
   i1 = HEAP32[i7 + 148 >> 2] | 0;
   if (i1 | 0) if (HEAP8[i1 + 49 >> 0] | 0) if (!(HEAP32[i1 + 68 >> 2] | 0)) {
    i1 = f3 < Math_fround(0.0);
    i8 = f3 > Math_fround(1.0e6);
    f3 = i8 ? Math_fround(1.0e6) : f3;
    f3 = i1 ? Math_fround(0.0) : f3;
    HEAPF32[i2 + 48 >> 2] = f3;
    i2 = i5 + (i4 << 2) | 0;
    HEAPF32[i6 + 20 >> 2] = f3;
    if ((i4 | 0) != 1) {
     i1 = i5 + 4 | 0;
     do {
      HEAPF32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] = f3;
      i1 = i1 + 4 | 0;
     } while ((i1 | 0) != (i2 | 0));
    }
    __ZN6b2Body13ResetMassDataEv(i7);
    i1 = i7 + 4 | 0;
    i2 = HEAPU16[i1 >> 1] | 0;
    if (!(HEAP32[i7 >> 2] | 0)) {
     HEAP16[i1 >> 1] = i2 & 65533;
     HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
     i8 = i7 + 64 | 0;
     HEAP32[i8 >> 2] = 0;
     HEAP32[i8 + 4 >> 2] = 0;
     HEAP32[i8 + 8 >> 2] = 0;
     HEAP32[i8 + 12 >> 2] = 0;
     HEAP32[i8 + 16 >> 2] = 0;
     HEAP32[i8 + 20 >> 2] = 0;
     return;
    }
    if (i2 & 2 | 0) return;
    HEAP16[i1 >> 1] = i2 | 2;
    HEAPF32[i7 + 144 >> 2] = Math_fround(0.0);
    return;
   }
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 805515 | 0, 0, gb + 805624 | 0, 270, 512, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 return;
}

function __Z25CreateStreamedClipBuilderjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i7 = __ZnwjRK10MemLabelIdiPKci(24, gb + 64016 | 0, 16, gb + 913491 | 0, 31) | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i7 >> 2] = 0;
 i3 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 i6 = HEAP32[i4 >> 2] | 0;
 if ((i6 & 2147483647) >>> 0 >= i2 >>> 0) {
  i10 = i7 + 20 | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((i6 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 * 24 | 0, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  i10 = i7 + 20 | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i10 | 0, HEAP32[i7 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = i10;
  i10 = i7 + 20 | 0;
  HEAP32[i10 >> 2] = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 11; else i1 = (HEAP32[i1 >> 2] | 0) + 11 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) i1 = 10; else i1 = (HEAP32[i1 >> 2] | 0) + 10 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i1 = i3 & 255;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i3 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i3 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN18SharedMaterialDataD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 >> 2] = gb + 67612 + 8;
 i5 = i6 + 188 | 0;
 i2 = i6 + 220 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i6 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i4 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i6 + 200 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i6 + 208 | 0;
 if ((HEAP32[i6 + 224 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 212 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i6 + 204 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 192 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = HEAP32[i6 + 176 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i6 + 180 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 HEAP32[i6 + 12 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i6 + 100 >> 2] | 0) > -1) {
  i5 = i6 + 84 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 88 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i6 + 64 | 0;
 if ((HEAP32[i6 + 80 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 68 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 44 | 0;
 if ((HEAP32[i6 + 60 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 48 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN16HumanPoseHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 178900 + 8;
 i3 = i1 + 24 | 0;
 i2 = i1 + 4 | 0;
 __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 28 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 32 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 36 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 40 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 44 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 48 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 52 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15AnimationBinderD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i6 = HEAP32[i6 >> 2] | 0;
  __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5, i6);
  return;
 }
 i2 = i1;
 while (1) {
  i1 = i2 + 20 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i4 = i3 + 40 | 0;
   if ((HEAP32[i3 + 56 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i3 + 44 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   if ((HEAP32[i3 + 36 >> 2] | 0) > -1) {
    i4 = i3 + 20 | 0;
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i3 + 24 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   if ((HEAP32[i3 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
    HEAP32[i3 >> 2] = 0;
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63720 | 0);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5, i6);
 return;
}

function __ZN13AnimationClip15AddRuntimeEventER14AnimationEvent(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i9 = 0, f10 = f0, i11 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 8 | 0;
 i9 = i13;
 __ZN13AnimationClip8GetRangeEv(i7, i12);
 f10 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 i11 = i12 + 196 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = (HEAP32[i12 + 200 >> 2] | 0) - i2 >> 6;
 if (!i1) i1 = i2; else {
  f6 = Math_fround(HEAPF32[i8 >> 2]);
  i5 = i1;
  i1 = i2;
  while (1) {
   i14 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i14 << 6) | 0;
   i3 = Math_fround(HEAPF32[i4 >> 2]) < f6;
   i4 = i4 + 64 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i14 | 0 : i14;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_(i11, i7, i8) | 0;
 HEAP32[i12 + 264 >> 2] = 2139095040;
 HEAP32[i12 + 268 >> 2] = -8388608;
 __ZN13AnimationClip8GetRangeEv(i7, i12);
 if (!(Math_fround(Math_abs(Math_fround(f10 - Math_fround(HEAPF32[i7 + 4 >> 2])))) > Math_fround(9.99999974e-06))) {
  STACKTOP = i13;
  return;
 }
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i12, gb + 1105816 | 0);
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 mftCall_vii(i1 | 0, i12 | 0, i12 + 80 | 0);
 STACKTOP = i13;
 return;
}

function __ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior(i4, i1, i7, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i10 + 1040 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 __ZN15FileSystemEntry3SetEPKc(i10, i1);
 i5 = i4 + 1064 | 0;
 HEAP8[i5 >> 0] = 1;
 i6 = i4 + 4 | 0;
 if ((i6 | 0) == (i10 | 0)) {
  i2 = i4 + 1056 | 0;
  i1 = i4 + 1048 | 0;
 } else {
  i2 = i4 + 1044 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i6 | 0);
  _strncpy(i6, i10, 1040) | 0;
  HEAP8[i4 + 1043 >> 0] = 0;
  i3 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 >> 2] = i3;
  i1 = i4 + 1048 | 0;
  HEAP32[i1 >> 2] = HEAP32[i10 + 1044 >> 2];
  HEAP32[i4 + 1052 >> 2] = 0;
  i2 = i4 + 1056 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 1060 >> 2] = 0;
  if (i3) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, i6 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 HEAP8[i5 >> 0] = 1;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return i2 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i10 | 0);
 STACKTOP = i11;
 return i2 | 0;
}

function __ZN11UnityEngine15PlatformWrapper24GetRuntimePlatformStringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 __ZN10systeminfo24GetRuntimePlatformStringEv(i5);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i6 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn5ConvX17registerUnionTypeEPKcS3_i(i7, i10, i8, i9) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12 + 24 | 0;
 i11 = i12 + 8 | 0;
 i6 = i12;
 i1 = HEAP32[i7 + 296 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i5 = HEAP32[i7 + 292 >> 2] | 0;
  i2 = 0;
  while (1) {
   if (!(_strcmp(HEAP32[i5 + (i2 << 4) >> 2] | 0, i10) | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) break L1;
  }
  HEAP32[i6 >> 2] = i8;
  HEAP32[i6 + 4 >> 2] = i9;
  i1 = i5 + (i2 << 4) + 4 | 0;
  i3 = i5 + (i2 << 4) + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i5 + (i2 << 4) + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   i2 = i6;
   i5 = HEAP32[i2 + 4 >> 2] | 0;
   i6 = (HEAP32[i1 >> 2] | 0) + (i4 << 3) | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i6) | 0;
  HEAP32[i11 >> 2] = i10;
  HEAP32[i11 + 4 >> 2] = i8;
  HEAP32[i11 + 8 >> 2] = i9;
  __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i7, 1, gb + 671889 | 0, i11);
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 } while (0);
 HEAP32[i3 >> 2] = i10;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i7, 32, gb + 671927 | 0, i3);
 i11 = 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i8 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 4 | 0;
 i6 = i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 HEAP32[i4 >> 2] = i6;
 i10 = i9 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = i6;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i8 >> 2] | 0 : i8;
 i7 = i3 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i3 = i1 + i7 | 0;
 if (i7 | 0) do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  STACKTOP = i12;
  return;
 }
}

function __ZN14DetailDatabase19SetDetailResolutionEii(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i2 + 36 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i2 + 40 >> 2] = i1;
 i7 = i2 + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i8 = i2 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) i1 = i5; else {
  do {
   HEAP32[i8 >> 2] = i3 + -52;
   i1 = HEAP32[i3 + -12 >> 2] | 0;
   if (i1 | 0) {
    i2 = i3 + -8 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
    __ZdlPv(i1);
   }
   i2 = HEAP32[i3 + -24 >> 2] | 0;
   if (i2 | 0) {
    i1 = i3 + -20 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
    __ZdlPv(i2);
   }
   i3 = HEAP32[i8 >> 2] | 0;
  } while ((i3 | 0) != (i4 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
 }
 i1 = Math_imul(i1, i1) | 0;
 i2 = (i3 - i4 | 0) / 52 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj(i7, i1 - i2 | 0);
  return;
 }
 if (i1 >>> 0 >= i2 >>> 0) return;
 i4 = i4 + (i1 * 52 | 0) | 0;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  HEAP32[i8 >> 2] = i3 + -52;
  i1 = HEAP32[i3 + -12 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 + -8 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i2 = HEAP32[i3 + -24 >> 2] | 0;
  if (i2 | 0) {
   i1 = i3 + -20 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
   __ZdlPv(i2);
  }
  i3 = HEAP32[i8 >> 2] | 0;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN13SliderJoint2D14ConfigureAngleERK6b2Vec2S2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67088 | 0) | 0;
 if (i4 | 0) __ZN11Rigidbody2D6CreateEv(i4);
 i4 = HEAP32[i4 + 92 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f9 * f6);
 f11 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(f11 * f7));
 f5 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) + f5);
 f7 = Math_fround(Math_fround(f6 * f11) + Math_fround(f9 * f7));
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i4 + 16 >> 2]));
 i4 = __ZNK7Joint2D10FetchBodyBEv(i1) | 0;
 f9 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f9 * f11);
 f10 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(f6 - Math_fround(f10 * f8));
 f6 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) + f6);
 f8 = Math_fround(Math_fround(f11 * f10) + Math_fround(f9 * f8));
 f5 = Math_fround(Math_fround(+Math_atan2(+Math_fround(Math_fround(f8 + Math_fround(HEAPF32[i4 + 16 >> 2])) - f7), +Math_fround(f6 - f5))) * Math_fround(57.2957802));
 i4 = f5 < Math_fround(-1.0e6);
 i3 = f5 > Math_fround(1.0e6);
 f5 = i3 ? Math_fround(1.0e6) : f5;
 HEAPF32[i1 + 96 >> 2] = i4 ? Math_fround(-1.0e6) : f5;
 return;
}

function __ZN12MeshColliderC2E10MemLabelId18ObjectCreationMode(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 112784 + 8;
 i9 = i4 + 64 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = i4;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i4;
 i9 = i4 + 96 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = i9;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP8[i4 + 120 >> 0] = 1;
 HEAPF32[i4 + 128 >> 2] = Math_fround(0.0);
 HEAP8[i4 + 61 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__26stoullERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1084469 | 0, 6);
 HEAP32[i4 >> 2] = 0;
 i5 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i10 = ___errno_location() | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 i2 = _strtoull(i5, i4, i2) | 0;
 i3 = getTempRet0() | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i8 | 0);
  i11 = __THREW__;
  __THREW__ = 0;
  if (!(i11 & 1)) i6 = 3;
 } else i6 = 3;
 do if ((i6 | 0) == 3) {
  i11 = HEAP32[i4 >> 2] | 0;
  i1 = i11;
  if ((i11 | 0) == (i5 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i8 | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) break;
  }
  if (i7 | 0) HEAP32[i7 >> 2] = i1 - i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  setTempRet0(i3 | 0);
  STACKTOP = i9;
  return i2 | 0;
 } while (0);
 i11 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i11 | 0);
 return 0;
}

function __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE9push_backERKS9_(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i1 = i7;
 if (!(HEAP8[gb + 1098096 >> 0] | 0)) {
  i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i4 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i10 = gb + 63696 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i4, 1, gb + 1018240 | 0, 52, 32768, i2, 16);
  HEAP32[gb + 1158352 >> 2] = i4;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i4);
  if (i5) __Z19pop_allocation_rootv();
  i10 = gb + 1098096 | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = 0;
 }
 i4 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1158352 >> 2] | 0, 52) | 0;
 i5 = i4 + 8 | 0;
 i1 = i3;
 i2 = i5 + 44 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 HEAP32[i4 + 4 >> 2] = i6;
 i10 = HEAP32[i6 >> 2] | 0;
 HEAP32[i4 >> 2] = i10;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = i4;
 i10 = i6 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 STACKTOP = i7;
 return;
}

function __ZNK5physx7NpScene11getNbActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = HEAP16[i1 >> 1] | 0;
 if (!(i5 & 1)) i1 = 0; else {
  i1 = HEAP32[i6 + 3556 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = HEAP32[i6 + 3552 >> 2] | 0;
   i2 = i1;
   i1 = 0;
   do {
    i2 = i2 + -1 | 0;
    i4 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
    i1 = (((i4 | 0) == 0 ? 1 : (HEAP16[i4 + 4 >> 1] | 0) != 6) & 1 ^ 1) + i1 | 0;
   } while ((i2 | 0) != 0);
  }
 }
 if (i5 & 2) {
  i2 = HEAP32[i6 + 3556 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i6 + 3552 >> 2] | 0;
   do {
    i2 = i2 + -1 | 0;
    i4 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
    i1 = (((i4 | 0) == 0 ? 1 : (HEAP16[i4 + 4 >> 1] | 0) != 5) & 1 ^ 1) + i1 | 0;
   } while ((i2 | 0) != 0);
  }
 }
 if (i5 & 4) {
  i2 = HEAP32[i6 + 3644 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i6 + 3640 >> 2] | 0;
   i4 = 0;
   do {
    i7 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
    i1 = (((i7 | 0) == 0 ? 1 : (HEAP16[i7 + 4 >> 1] | 0) != 11) & 1 ^ 1) + i1 | 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i2 >>> 0);
  }
 }
 if (i5 & 8) {
  i2 = HEAP32[i6 + 3644 >> 2] | 0;
  if (i2) {
   i3 = HEAP32[i6 + 3640 >> 2] | 0;
   i4 = 0;
   do {
    i7 = HEAP32[i3 + (i4 << 2) >> 2] | 0;
    i1 = (((i7 | 0) == 0 ? 1 : (HEAP16[i7 + 4 >> 1] | 0) != 12) & 1 ^ 1) + i1 | 0;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i2 >>> 0);
  }
 }
 if (!(i5 & 32)) {
  i7 = i1;
  return i7 | 0;
 }
 i7 = (HEAP32[i6 + 3656 >> 2] | 0) + i1 | 0;
 return i7 | 0;
}

function __ZN8Material14DisableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i4 + 100 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = __ZN8keywords6CreateEPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
 i1 = i2 + 124 + (i3 >>> 5 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << (i3 & 31);
 if (!(i3 & i2)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i2 & ~i3;
 i1 = (HEAP32[i6 >> 2] | 0) + 124 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i1, i5);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i5, i4 + 80 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i4 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i4;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i6 = i1 + 164 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 2;
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx19updateCachedHitDataEPKjPKNS_6PxVec4EPKfS6_PNS_23PxVehicleWheels4DynDataE(i2, i4, i3, i1, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 if (HEAP32[i5 + 212 >> 2] | 0) HEAP8[i5 + 216 >> 0] = 1;
 HEAP16[i5 + 192 >> 1] = HEAP32[i2 >> 2];
 HEAP32[i5 + 96 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 100 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 104 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 108 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 176 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 160 >> 2] = HEAP32[i1 >> 2];
 HEAP16[i5 + 194 >> 1] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 112 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 116 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 120 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 124 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i5 + 180 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 164 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP16[i5 + 196 >> 1] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 128 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i5 + 132 >> 2] = HEAP32[i4 + 36 >> 2];
 HEAP32[i5 + 136 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAP32[i5 + 140 >> 2] = HEAP32[i4 + 44 >> 2];
 HEAP32[i5 + 184 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i5 + 168 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP16[i5 + 198 >> 1] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 144 >> 2] = HEAP32[i4 + 48 >> 2];
 HEAP32[i5 + 148 >> 2] = HEAP32[i4 + 52 >> 2];
 HEAP32[i5 + 152 >> 2] = HEAP32[i4 + 56 >> 2];
 HEAP32[i5 + 156 >> 2] = HEAP32[i4 + 60 >> 2];
 HEAP32[i5 + 188 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 + 172 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj556ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj555ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj554ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj553ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx13PxsCCDContext12updateCCDEndEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 92 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if ((i5 | 0) == ((HEAP32[i9 + 260 >> 2] | 0) + -1 | 0)) {
  i4 = i9 + 112 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i9 + 100 >> 2] | 0;
  i1 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
  if ((i1 | 0) != (0 - (i2 << 7) | 0)) {
   i1 = i1 + (i2 << 7) | 0;
   i2 = 0;
   do {
    HEAP32[(HEAP32[(HEAP32[i3 + (i2 >>> 7 << 3) >> 2] | 0) + ((i2 & 127) * 20 | 0) + 8 >> 2] | 0) + 60 >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i1 | 0));
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 }
 HEAP32[i9 + 144 >> 2] = 0;
 HEAP32[(HEAP32[i9 + 132 >> 2] | 0) + 4 >> 2] = 0;
 i1 = HEAP32[i9 + 192 >> 2] | 0;
 if (!i1) {
  i9 = i5;
  i9 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i9;
  return;
 }
 i7 = i9 + 208 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  i9 = i5;
  i9 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i9;
  return;
 }
 _memset(HEAP32[i9 + 184 >> 2] | 0, -1, i1 << 2 | 0) | 0;
 i6 = i9 + 188 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2 + -1 | 0;
 i4 = i9 + 180 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i5) {
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + (i3 << 2) >> 2] = i2;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
 HEAP32[i9 + 200 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = i9 + 1 | 0;
 HEAP32[i8 >> 2] = i9;
 return;
}

function __Z45Quaternion_CUSTOM_INTERNAL_CALL_LerpUnclampedRK11QuaternionfS1_fRS_(i2, i4, f9, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 var f1 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f11 = f0, f12 = f0, f13 = f0;
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f13 = Math_fround(f11 * f3);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f12 * f5));
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f13 = Math_fround(f13 + Math_fround(f8 * f6));
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 if (Math_fround(f13 + Math_fround(f7 * f1)) < Math_fround(0.0)) {
  f6 = Math_fround(-f6);
  f5 = Math_fround(-f5);
  f3 = Math_fround(-f3);
  f1 = Math_fround(-f1);
 }
 f3 = Math_fround(f11 + Math_fround(Math_fround(f3 - f11) * f9));
 f11 = Math_fround(f12 + Math_fround(Math_fround(f5 - f12) * f9));
 f12 = Math_fround(f8 + Math_fround(Math_fround(f6 - f8) * f9));
 f13 = Math_fround(f7 + Math_fround(Math_fround(f1 - f7) * f9));
 f9 = Math_fround(Math_sqrt(Math_fround(Math_fround(f13 * f13) + Math_fround(Math_fround(f12 * f12) + Math_fround(Math_fround(f11 * f11) + Math_fround(f3 * f3))))));
 f11 = Math_fround(f11 / f9);
 f12 = Math_fround(f12 / f9);
 f13 = Math_fround(f13 / f9);
 HEAPF32[i10 >> 2] = Math_fround(f3 / f9);
 HEAPF32[i10 + 4 >> 2] = f11;
 HEAPF32[i10 + 8 >> 2] = f12;
 HEAPF32[i10 + 12 >> 2] = f13;
 return;
}

function __Z44TrailRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = f6 < Math_fround(0.0);
  f6 = i4 ? Math_fround(0.0) : f6;
  i4 = f6 > Math_fround(1.0);
  i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i5 = f6 < Math_fround(0.0);
  f6 = i5 ? Math_fround(0.0) : f6;
  i5 = f6 > Math_fround(1.0);
  i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i2 = f6 < Math_fround(0.0);
  f6 = i2 ? Math_fround(0.0) : f6;
  i2 = f6 > Math_fround(1.0);
  i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 108 >> 2] = i5 << 8 & 65280 | i4 & 255 | i1 << 16 & 16711680 | i2 << 24;
  return;
 }
}

function __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 1456 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i10 + 1432 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i9 = i6 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = i1 + -12 | 0;
  HEAP32[i9 >> 2] = i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i1 = HEAP32[i9 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i2 = _emscripten_get_num_gamepads() | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i10;
  return;
 }
 i3 = i7 + 1304 | 0;
 i4 = i6 + 8 | 0;
 i1 = 0;
 do {
  if (!(_emscripten_get_gamepad_status(i1 | 0, i7 | 0) | 0)) {
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, _strlen(i3) | 0);
   i5 = HEAP32[i9 >> 2] | 0;
   if ((i5 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i6, i8); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i8);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i10;
 return;
}

function _Read_CVT_Stretched(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = HEAP32[(HEAP32[i4 + 384 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i6 = i4 + 244 | 0;
 i7 = i4 + 256 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 i2 = HEAP16[i4 + 296 >> 1] | 0;
 if (!(i2 << 16 >> 16)) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  i7 = i6;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 i3 = HEAP16[i4 + 294 >> 1] | 0;
 i1 = HEAP32[i4 + 248 >> 2] | 0;
 if (!(i3 << 16 >> 16)) {
  HEAP32[i7 >> 2] = i1;
  i7 = i1;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 } else {
  i8 = i3 << 16 >> 16;
  i9 = HEAP32[i6 >> 2] | 0;
  i6 = (i9 | 0) < 0 ? 0 - i9 | 0 : i9;
  i3 = i3 << 16 >> 16 < 0 ? 0 - i8 | 0 : i8;
  i4 = Math_imul(i6 >>> 16, i3) | 0;
  i11 = i4 << 16 | 8192;
  i3 = i11 + (Math_imul(i6 & 65535, i3) | 0) | 0;
  i3 = (i3 >>> 0 < i11 >>> 0 & 1) + (i4 >>> 16) << 18 | i3 >>> 14;
  i4 = i2 << 16 >> 16;
  i11 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
  i6 = i2 << 16 >> 16 < 0 ? 0 - i4 | 0 : i4;
  i2 = Math_imul(i11 >>> 16, i6) | 0;
  i10 = i2 << 16 | 8192;
  i6 = i10 + (Math_imul(i11 & 65535, i6) | 0) | 0;
  i6 = (i6 >>> 0 < i10 >>> 0 & 1) + (i2 >>> 16) << 18 | i6 >>> 14;
  i6 = _UNITY_FT_Hypot((i9 ^ i8 | 0) > -1 ? i3 : 0 - i3 | 0, (i1 ^ i4 | 0) > -1 ? i6 : 0 - i6 | 0) | 0;
  HEAP32[i7 >> 2] = i6;
  i7 = i6;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 return 0;
}

function __ZN8Material13EnableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i4 + 100 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = __ZN8keywords6CreateEPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
 i1 = i2 + 124 + (i3 >>> 5 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << (i3 & 31);
 if (i3 & i2 | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i3 | i2;
 i1 = (HEAP32[i6 >> 2] | 0) + 124 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i1, i5);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i5, i4 + 80 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i4 = i2 + -12 | 0;
    HEAP32[i3 >> 2] = i4;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
    i2 = HEAP32[i3 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i6 = i1 + 164 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] | 2;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 40 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -40 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 28 | 0;
 i7 = i10 + 24 | 0;
 i9 = i10 + 12 | 0;
 i5 = i10;
 i1 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i1) i1 = 72; else i1 = (HEAP32[i1 >> 2] | 0) + 72 | 0;
 HEAP8[i6 >> 0] = 1;
 HEAP32[i6 + 4 >> 2] = i1;
 i1 = HEAP32[i8 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i8 + 36 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 i3 = HEAP32[i8 + 20 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i9, i7);
 i8 = HEAP32[i8 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i8 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx18NpArticulationLink12createObjectERPhRNS_24PxDeserializationContextE(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 0;
 HEAP32[i4 >> 2] = gb + 91844 + 8;
 i2 = i4 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE(i2, i5);
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 i5 = i4 + 52 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 251658240;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP8[i4 + 75 >> 0] = 0;
 HEAP32[i4 + 220 >> 2] = 0;
 HEAP32[i4 + 280 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 92380 + 8;
 i5 = i4 + 320 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = i4 + 328 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | -2147483648;
 }
 i1 = i4 + 316 | 0;
 if (HEAP8[i1 >> 0] | 0) HEAP32[i5 >> 2] = i4 + 300;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 336;
 __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE(i2, i6);
 __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE(i4 + 12 | 0, i6);
 if (!(HEAP8[i1 >> 0] | 0)) if (HEAP32[i5 >> 2] | 0) {
  i1 = HEAP32[i4 + 328 >> 2] | 0;
  if (i1 & 2147483647 | HEAP32[i4 + 324 >> 2] | 0) {
   i2 = i6 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i3 + (i1 << 2);
   HEAP32[i5 >> 2] = i3;
  }
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 244 >> 2] | 0, i4 | 0, i6 | 0);
 STACKTOP = i7;
 return i4 | 0;
}

function __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 164 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEC2ERKS3_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 40 | 0;
 i2 = (i1 | 0) / 40 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 40 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 40 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 40 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 40 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z50RectTransform_CUSTOM_INTERNAL_set_anchoredPositionP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i7 + 152 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i1 ^ i6 | 0) > -1) {
  i1 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) <= 10) i5 = 7;
 } else if (f3 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i5 = 7;
 do if ((i5 | 0) == 7) {
  f3 = Math_fround(HEAPF32[i7 + 156 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i2 | 0) > -1) {
   i5 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) | 0;
   if ((((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0) >= 11) break;
   return;
  } else {
   if (!(f3 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
   return;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[i7 + 156 >> 2] = i2;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i7, 1, 0);
 return;
}

function __Z43LineRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  i4 = f6 < Math_fround(0.0);
  f6 = i4 ? Math_fround(0.0) : f6;
  i4 = f6 > Math_fround(1.0);
  i4 = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i5 = f6 < Math_fround(0.0);
  f6 = i5 ? Math_fround(0.0) : f6;
  i5 = f6 > Math_fround(1.0);
  i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i1 = f6 < Math_fround(0.0);
  f6 = i1 ? Math_fround(0.0) : f6;
  i1 = f6 > Math_fround(1.0);
  i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i2 = f6 < Math_fround(0.0);
  f6 = i2 ? Math_fround(0.0) : f6;
  i2 = f6 > Math_fround(1.0);
  i2 = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  HEAP32[(HEAP32[i3 + 344 >> 2] | 0) + 108 >> 2] = i5 << 8 & 65280 | i4 & 255 | i1 << 16 & 16711680 | i2 << 24;
  return;
 }
}

function __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i2, HEAP32[i4 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i1, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i5 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i5);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function _tt_sbit_decoder_load_compound(i9, i1, i4, i6, i7) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i8 = i9 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i15 = HEAP16[i2 + 4 >> 1] | 0;
 i10 = HEAP16[i2 + 6 >> 1] | 0;
 i11 = HEAP16[i2 + 8 >> 1] | 0;
 i12 = HEAP16[i2 + 10 >> 1] | 0;
 i13 = HEAP16[i2 + 12 >> 1] | 0;
 i14 = HEAP16[i2 + 14 >> 1] | 0;
 i3 = i1 + 2 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  i15 = 3;
  return i15 | 0;
 }
 i5 = (HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0);
 if ((i3 + (i5 << 2) | 0) >>> 0 > i4 >>> 0) {
  i15 = 3;
  return i15 | 0;
 }
 if (!i5) i1 = 0; else {
  i2 = i3;
  i3 = 0;
  while (1) {
   i1 = _tt_sbit_decoder_load_image(i9, (HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0), (HEAPU8[i2 + 2 >> 0] | 0) + i6 | 0, (HEAPU8[i2 + 3 >> 0] | 0) + i7 | 0) | 0;
   if (i1 | 0) break;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i5 >>> 0) {
    i1 = 0;
    break;
   } else i2 = i2 + 4 | 0;
  }
  i2 = HEAP32[i8 >> 2] | 0;
 }
 HEAP16[i2 + 4 >> 1] = (i15 << 8 & 65535) << 16 >> 16 >> 8;
 HEAP16[i2 + 6 >> 1] = (i10 << 8 & 65535) << 16 >> 16 >> 8;
 HEAP16[i2 + 8 >> 1] = i11 & 255;
 HEAP16[i2 + 10 >> 1] = (i12 << 8 & 65535) << 16 >> 16 >> 8;
 HEAP16[i2 + 12 >> 1] = (i13 << 8 & 65535) << 16 >> 16 >> 8;
 HEAP16[i2 + 14 >> 1] = i14 & 255;
 i15 = HEAP32[i9 + 8 >> 2] | 0;
 HEAP16[i2 + 2 >> 1] = HEAP32[i15 + 4 >> 2] & 255;
 HEAP16[i2 >> 1] = HEAP32[i15 >> 2] & 255;
 i15 = i1;
 return i15 | 0;
}

function __ZNSt3__25stollERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1084463 | 0, 5);
 HEAP32[i4 >> 2] = 0;
 i5 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i10 = ___errno_location() | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 i2 = _strtoll(i5, i4, i2) | 0;
 i3 = getTempRet0() | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i8 | 0);
  i11 = __THREW__;
  __THREW__ = 0;
  if (!(i11 & 1)) i6 = 3;
 } else i6 = 3;
 do if ((i6 | 0) == 3) {
  i11 = HEAP32[i4 >> 2] | 0;
  i1 = i11;
  if ((i11 | 0) == (i5 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i8 | 0);
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) break;
  }
  if (i7 | 0) HEAP32[i7 >> 2] = i1 - i5;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  setTempRet0(i3 | 0);
  STACKTOP = i9;
  return i2 | 0;
 } while (0);
 i11 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i11 | 0);
 return 0;
}

function __ZN8UserList5ClearEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i7 + 4 | 0;
 i9 = i7 + 16 | 0;
 if (HEAP32[i9 >> 2] | 0) {
  i6 = 0;
  do {
   i4 = HEAP32[i8 >> 2] | 0;
   i1 = i4 + (i6 << 3) | 0;
   i4 = HEAP32[i4 + (i6 << 3) + 4 >> 2] | 0;
   if ((i4 | 0) == -1) {
    i5 = HEAP32[i1 >> 2] | 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = -1;
   } else {
    i2 = HEAP32[i1 >> 2] | 0;
    i5 = i2 + 16 | 0;
    i1 = HEAP32[i5 >> 2] | 0;
    i3 = i1 + -1 | 0;
    if ((i3 | 0) != (i4 | 0)) {
     i1 = i2 + 4 | 0;
     i2 = HEAP32[i1 >> 2] | 0;
     i11 = i2 + (i3 << 3) | 0;
     i10 = HEAP32[i11 + 4 >> 2] | 0;
     i2 = i2 + (i4 << 3) | 0;
     HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i2 + 4 >> 2] = i10;
     i1 = HEAP32[i1 >> 2] | 0;
     i2 = i1 + (i3 << 3) | 0;
     i1 = HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0;
     if ((i1 | 0) == -1) i1 = (HEAP32[i2 >> 2] | 0) + 4 | 0; else i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0) + (i1 << 3) | 0;
     HEAP32[i1 + 4 >> 2] = i4;
     i1 = HEAP32[i5 >> 2] | 0;
    }
    HEAP32[i5 >> 2] = i1 + -1;
   }
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i8 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7 + 8 | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 8) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -256 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21SerializationRegistry18registerSerializerEtRNS_12PxSerializerE(i7, i11, i10) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 i5 = i12 + 4 | 0;
 i9 = i12 + 6 | 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i6 = i11 & 65535;
  i4 = i6 + ~(i6 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i7 + 20 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i3 = HEAP32[i7 + 12 >> 2] | 0;
   i4 = i7 + 16 | 0;
   i2 = i1;
   while (1) {
    i1 = i3 + (i2 << 3) | 0;
    if ((HEAP16[i1 >> 1] | 0) == i11 << 16 >> 16) break;
    i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L1;
   }
   if (i1 | 0) {
    i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
    HEAP32[i8 >> 2] = i6;
    __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 2, gb + 667371 | 0, 161, gb + 668103 | 0, i8);
   }
  }
 } while (0);
 HEAP16[i5 >> 1] = i11;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb(i7 + 8 | 0, i5, i9) | 0;
 if (HEAP8[i9 >> 0] | 0) {
  STACKTOP = i12;
  return;
 }
 HEAP16[i1 >> 1] = i11;
 HEAP32[i1 + 4 >> 2] = i10;
 STACKTOP = i12;
 return;
}

function __ZN35ClampVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 884 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 884 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 884 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 884 >> 2] | 0;
   HEAPF32[i3 + 880 >> 2] = f4;
   HEAP8[i3 + 886 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 800 | 0, i3 + 888 | 0, f4, HEAP16[i3 + 884 >> 1] | 0) | 0) & 1;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 1068 >> 2] = f4;
   return;
  }
 default:
  return;
 }
}

function __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 76 | 0;
 i2 = (i1 | 0) / 76 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 76 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 76 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 76 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 76 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN10TagManager8TransferI17RemapPPtrTransferEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i3 = i6 + 8 | 0;
 i1 = 0;
 do {
  i4 = i5 + 44 + (i1 << 5) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i6, i4); else {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i11 = i5 + 44 + (i1 << 5) + 24 | 0;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i9 = i2 + 24 | 0;
   HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i9 + 4 >> 2] = i10;
   HEAP8[i2 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i2, i4);
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 32;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -32 | 0;
   HEAP32[i7 >> 2] = i3;
   i4 = HEAP32[i3 >> 2] | 0;
   if (!i4) i2 = i3; else if (!(HEAP32[i2 + -28 >> 2] | 0)) i2 = i3; else {
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i2 + -8 | 0);
    i2 = HEAP32[i7 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __Z33CommandBuffer_CUSTOM_Blit_TextureP12Il2CppObjectS0_R26MonoRenderTargetIdentifierS0_i(i1, i4, i2, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i8 = i10 + 16 | 0;
 i9 = i10 + 4 | 0;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = i12;
 HEAP32[i8 + 8 >> 2] = i11;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 do if (!i4) i5 = 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) i5 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
   i5 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = 16;
 HEAP32[i9 + 4 >> 2] = -1;
 HEAP32[i9 + 8 >> 2] = i5;
 if (!i6) {
  i12 = 0;
  __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali(i2, i9, i8, i12, i7);
  STACKTOP = i10;
  return;
 }
 i12 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali(i2, i9, i8, i12, i7);
 STACKTOP = i10;
 return;
}

function __Z32Texture2D_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh13Il2Cpp_IntPtr(i2, i3, i4, i5, i6, i7, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 16 | 0;
 i11 = i8;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 265) | 0;
 i14 = gb + 63520 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i1, i10, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 if (mftCall_iiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0, i6 << 24 >> 24 != 0 | 0, 1, -1, i9 | 0) | 0) {
  __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace(i1, i7 << 24 >> 24 == 0 & 1);
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i2, i1) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
  STACKTOP = i8;
  return;
 } else {
  __Z19DestroySingleObjectP6Object(i1);
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570235 | 0, i8 + 8 | 0);
 }
}

function __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i9 = i7 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i8 + 4 | 0;
  i6 = i8 + 4 | 0;
  do {
   i4 = i2 + -132 | 0;
   HEAP32[i9 >> 2] = i4;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -116 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -104 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
   }
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i2 + -120 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
   }
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i11 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 25;
 HEAP32[i8 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK14ParticleSystem27CalculateMaxActiveParticlesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 16 | 0;
 i9 = i12 + 8 | 0;
 i10 = i12;
 __ZNK11MinMaxCurve10FindMinMaxEv(i1, (HEAP32[i8 + 44 >> 2] | 0) + 8 | 0);
 __ZNK11MinMaxCurve10FindMinMaxEv(i9, i8 + 272 | 0);
 __ZNK11MinMaxCurve10FindMinMaxEv(i10, i8 + 536 | 0);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i10 >> 2]));
 i10 = ~~Math_fround(Math_ceil(Math_fround(f6 * Math_fround(HEAPF32[i1 >> 2])))) >>> 0;
 i9 = HEAP32[i8 + 848 >> 2] | 0;
 if ((i9 | 0) <= 0) {
  i11 = 0;
  i11 = i11 + i10 | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i1 = 0;
 i5 = 0;
 while (1) {
  f4 = Math_fround(Math_fround(HEAPF32[i8 + 800 + (i5 << 2) >> 2]) + f6);
  i2 = HEAP32[i8 + 832 + (i5 << 2) >> 2] | 0;
  i5 = i5 + 1 | 0;
  i7 = (i5 | 0) < (i9 | 0);
  if (i7) i3 = i5; else break;
  do {
   if (!(Math_fround(HEAPF32[i8 + 800 + (i3 << 2) >> 2]) <= f4)) break;
   i2 = (HEAP32[i8 + 832 + (i3 << 2) >> 2] | 0) + i2 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i9 | 0));
  i1 = i1 >>> 0 < i2 >>> 0 ? i2 : i1;
  if (!i7) {
   i11 = 3;
   break;
  }
 }
 if ((i11 | 0) == 3) {
  i11 = i1 + i10 | 0;
  STACKTOP = i12;
  return i11 | 0;
 }
 i11 = i1 >>> 0 < i2 >>> 0 ? i2 : i1;
 i11 = i11 + i10 | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 6) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -64 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj401ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj400ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj399ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIi14ConstantStringEEE8TransferI14SafeBinaryReadEEvRS3_RT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 0) | 0;
 if (!i2) {
  i4 = i5 + 4 | 0;
  i5 = HEAP32[gb + 37224 >> 2] | 0;
  __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags(i6, i4, i5, 0);
  STACKTOP = i7;
  return;
 }
 if ((i2 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i5, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 i4 = i5 + 4 | 0;
 i5 = HEAP32[gb + 37224 >> 2] | 0;
 __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags(i6, i4, i5, 0);
 STACKTOP = i7;
 return;
}

function __ZN13BoxCollider2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 48 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f7 < Math_fround(0.0);
 i3 = f7 > Math_fround(1.0e6);
 f7 = i3 ? Math_fround(1.0e6) : f7;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f7;
 i1 = i2 + 40 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i8 = gb + 1162356 | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i3 = i2 + 160 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i2 + 164 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i4 & 2139095040 | 0) != 2139095040 & (i2 & 2139095040 | 0) != 2139095040) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i5 >> 2] = Math_fround(.0000999999974);
  i8 = f9 > Math_fround(.0000999999974);
  HEAP32[i3 >> 2] = HEAP32[(i8 ? i3 : i5) >> 2];
  HEAPF32[i5 >> 2] = Math_fround(.0000999999974);
  i8 = f7 > Math_fround(.0000999999974);
  HEAP32[i1 >> 2] = HEAP32[(i8 ? i1 : i5) >> 2];
  STACKTOP = i6;
  return;
 } else {
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  STACKTOP = i6;
  return;
 }
}

function __Z47UnityWebRequest_CUSTOM_InternalSetRequestHeaderP12Il2CppObjectP12Il2CppStringS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i4 = i10;
 i5 = i10 + 48 | 0;
 i6 = i10 + 44 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10 + 20 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 __ZN11ICallStringC2EP12Il2CppString(i6, i3);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 i1 = i2 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031561 | 0, i10 + 8 | 0);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i5);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i6);
 if ((HEAP32[i1 >> 2] | 0) == 1) i1 = __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b(i2 + 44 | 0, i7, i8, 1) | 0; else i1 = 31;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (!i1) {
  STACKTOP = i10;
  return;
 } else {
  HEAP32[i9 >> 2] = __Z17GetWebErrorString8WebError(i1) | 0;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i9);
 }
}

function __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayIPN5Unity9ComponentELj4EEEiP11Il2CppArrayRKT_i(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i7 = i6 + 12 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 if (!i9) {
  i8 = 0;
  i2 = i10;
 } else {
  i8 = _il2cpp_array_length(i9 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if (i2) {
  i5 = HEAP32[i6 >> 2] | 0;
  do {
   i4 = HEAP32[i5 >> 2] | 0;
   L8 : do if (!i4) i2 = 0; else {
    i2 = HEAP32[i4 + 20 >> 2] | 0;
    if (!i2) {
     i2 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i4 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
     if ((i2 | 0) == (gb + 27592 | 0)) i2 = 0; else {
      while (1) {
       i3 = __Z21GetManagerFromContexti(5) | 0;
       i3 = HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
       if (i3 | 0) break;
       i2 = HEAP32[i2 >> 2] | 0;
       if ((i2 | 0) == (gb + 28304 | 0)) {
        i2 = 0;
        break L8;
       }
      }
      i2 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i3, i4) | 0;
     }
    }
   } while (0);
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i9, i1, i2);
   i1 = i1 + 1 | 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i7 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i8 | 0)) return i10 | 0;
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i9, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return i10 | 0;
}

function __ZNSt3__217moneypunct_bynameIwLb1EEC2EPKcj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 212028 + 8;
 i5 = i6 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4533 | 0, i6 | 0, i7 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIwLb0EEC2EPKcj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211972 + 8;
 i5 = i6 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4531 | 0, i6 | 0, i7 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3);
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIcLb1EEC2EPKcj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211916 + 8;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4530 | 0, i6 | 0, i7 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__217moneypunct_bynameIcLb0EEC2EPKcj(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 + 4 >> 2] = i1 + -1;
 HEAP32[i6 >> 2] = gb + 211860 + 8;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i5 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i3 = i6 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i6 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4528 | 0, i6 | 0, i7 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  ___resumeException(i7 | 0);
 } else return;
}

function __ZNSt3__212system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (i1 | 0) {
  i2 = HEAP8[i6 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i6 + 4 >> 2] | 0; else i2 = i2 & 255;
  if (i2) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, gb + 1084762 | 0) | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i5 | 0, i4 | 0, i1 | 0);
  i4 = HEAP8[i5 + 11 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  __THREW__ = 0;
  invoke_iiii(fb + 512 | 0, i6 | 0, (i2 ? HEAP32[i5 >> 2] | 0 : i5) | 0, (i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i7 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   ___resumeException(i7 | 0);
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i6 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 396 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = i9 * 12 | 0;
  i2 = i10 + 384 | 0;
  if (i1 >>> 0 < 385 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i10;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i10, i1, gb + 838004 | 0, 543) | 0;
 }
 i5 = i10 + 392 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i2 * 12 | 0) | 0;
 i6 = i10 + 388 | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 12 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i1 + (i2 * 12 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 do if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i10 | 0) == (i2 | 0)) {
   HEAP8[i10 + 384 >> 0] = 0;
   break;
  } else {
   __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i10, i2);
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = i9;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + 1;
 return i1 + (i10 * 12 | 0) | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN18ShadowMapJobHeaderD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 35724 + 8;
 i1 = i5 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 1228 | 0;
 __ZN15RenderNodeQueue7CleanupEv(i1);
 __ZN19AtomicPageAllocatorD2Ev(i5 + 1248 | 0);
 if ((HEAP32[i5 + 1244 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 1232 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 1168 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 1172 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i2 | 0) >>> 4) << 4);
  i4 = HEAP32[i5 + 1180 >> 2] | 0;
  HEAP32[i6 >> 2] = 2;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 1152 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 1156 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
 i5 = HEAP32[i5 + 1164 >> 2] | 0;
 HEAP32[i6 >> 2] = 2;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 STACKTOP = i7;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i7 + 56 >> 2] | 0;
  if (i5) {
   i6 = i8 + 4 | 0;
   i3 = 0;
   while (1) {
    i2 = i1 + (i3 * 20 | 0) | 0;
    if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
     i2 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i1 + (i3 * 20 | 0) + 12 >> 2] | 0;
     HEAP32[i8 >> 2] = 54;
     HEAP32[i6 >> 2] = i1;
     __Z19free_alloc_internalPvRK10MemLabelId(i2, i8);
    }
    i1 = i3 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break;
    i3 = i1;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i7 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 44 >> 2] | 0;
  HEAP32[i8 >> 2] = 54;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i1 = i7 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i8 >> 2] = 54;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i6, i7, i1, i5, i9, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((2147483631 - i7 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i8 = HEAP32[i6 >> 2] | 0; else i8 = i6;
 if (i7 >>> 0 < 1073741799) {
  i3 = i1 + i7 | 0;
  i4 = i7 << 1;
  i3 = i3 >>> 0 < i4 >>> 0 ? i4 : i3;
  i3 = i3 >>> 0 < 11 ? 11 : i3 + 16 & -16;
 } else i3 = 2147483631;
 i2 = i6 + 12 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 66;
 HEAP32[i12 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 if (i9 | 0) _memcpy(i4 | 0, i8 | 0, i9 | 0) | 0;
 i1 = i5 - i10 - i9 | 0;
 if (i1 | 0) _memcpy(i4 + i9 + i11 | 0, i8 + i9 + i10 | 0, i1 | 0) | 0;
 if ((i7 | 0) == 10) {
  HEAP32[i6 >> 2] = i4;
  i11 = i3 | -2147483648;
  i12 = i6 + 8 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 66;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
 HEAP32[i6 >> 2] = i4;
 i11 = i3 | -2147483648;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj(i6, i7, i1, i5, i9, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((2147483631 - i7 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i8 = HEAP32[i6 >> 2] | 0; else i8 = i6;
 if (i7 >>> 0 < 1073741799) {
  i3 = i1 + i7 | 0;
  i4 = i7 << 1;
  i3 = i3 >>> 0 < i4 >>> 0 ? i4 : i3;
  i3 = i3 >>> 0 < 11 ? 11 : i3 + 16 & -16;
 } else i3 = 2147483631;
 i2 = i6 + 12 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 54;
 HEAP32[i12 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 if (i9 | 0) _memcpy(i4 | 0, i8 | 0, i9 | 0) | 0;
 i1 = i5 - i10 - i9 | 0;
 if (i1 | 0) _memcpy(i4 + i9 + i11 | 0, i8 + i9 + i10 | 0, i1 | 0) | 0;
 if ((i7 | 0) == 10) {
  HEAP32[i6 >> 2] = i4;
  i11 = i3 | -2147483648;
  i12 = i6 + 8 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 54;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
 HEAP32[i6 >> 2] = i4;
 i11 = i3 | -2147483648;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZN7Terrain22SetDetailObjectDensityEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 i3 = i2 + 84 | 0;
 i4 = f1 != Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = f1;
 if (!i4) return;
 i4 = i2 + 228 | 0;
 i3 = i2 + 240 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = HEAP32[i4 >> 2] | 0;
 do {
  i7 = HEAP32[i2 + 12 >> 2] | 0;
  i6 = i7 + 64 | 0;
  i5 = i7 + 68 | 0;
  __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i6, HEAP32[i5 >> 2] | 0);
  HEAP32[i7 + 72 >> 2] = 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i5 >> 2] = 0;
  i5 = i7 + 76 | 0;
  i6 = i7 + 80 | 0;
  __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i5, HEAP32[i6 >> 2] | 0);
  HEAP32[i7 + 84 >> 2] = 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i6 >> 2] = 0;
  i6 = i7 + 88 | 0;
  i5 = i7 + 92 | 0;
  __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i6, HEAP32[i5 >> 2] | 0);
  HEAP32[i7 + 96 >> 2] = 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i5 >> 2] = 0;
  i2 = i2 + 20 | 0;
 } while ((i2 | 0) != ((HEAP32[i4 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 96 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -96 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 240 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -240 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 4) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -16 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i3, i1) | 0;
 if ((i6 | 0) == -1) {
  i6 = -1;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i4 = i5 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i3, i5, i6);
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  i2 = __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i3, i4, i1) | 0;
  if ((i2 | 0) != -1) {
   i2 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i4, i2, i1) | 0;
   if ((i2 | 0) == -1 ? 1 : (i2 | 0) >= (HEAP32[i4 + 52 >> 2] & 65535 | 0)) {
    i6 = -1;
    STACKTOP = i7;
    return i6 | 0;
   }
   HEAP32[i5 >> 2] = -1;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   i1 = i5 + 28 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 + 32 >> 2] = 0;
   __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i3, i5, i6);
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) i1 = -1; else if ((HEAP32[i1 + 52 >> 2] | 0) >>> 0 < 65536) i1 = -1; else i1 = HEAP32[i1 + (HEAP32[i1 + 56 >> 2] | 0) + (i2 * 36 | 0) + 16 >> 2] | 0;
   i6 = i1;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 i6 = -1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__212strstreambuf7seekposENS_4fposI11__mbstate_tEEj(i10, i8, i2, i1) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i9 = (i1 & 8 | 0) != 0;
 i1 = i1 >>> 4 & 1;
 do if ((i1 | 0) == 0 & (i9 ^ 1)) {
  i2 = -1;
  i1 = -1;
 } else {
  if (i9) if (!(HEAP32[i8 + 12 >> 2] | 0)) {
   i2 = -1;
   i1 = -1;
   break;
  }
  i7 = (i1 | 0) != 0;
  if (i7) if (!(HEAP32[i8 + 24 >> 2] | 0)) {
   i2 = -1;
   i1 = -1;
   break;
  }
  i1 = i2 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = i8 + 28 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i6 = i3;
  if (!i3) i3 = HEAP32[i8 + 16 >> 2] | 0;
  if ((i1 | 0) > -1 | (i1 | 0) == -1 & i2 >>> 0 > 4294967295) {
   i4 = HEAP32[i8 + 8 >> 2] | 0;
   i3 = i3 - i4 | 0;
   i11 = ((i3 | 0) < 0) << 31 >> 31;
   if ((i1 | 0) > (i11 | 0) | (i1 | 0) == (i11 | 0) & i2 >>> 0 > i3 >>> 0) {
    i2 = -1;
    i1 = -1;
   } else {
    i3 = i4 + i2 | 0;
    if (i9) {
     i11 = i8 + 16 | 0;
     i9 = HEAP32[i11 >> 2] | 0;
     HEAP32[i8 + 12 >> 2] = i3;
     HEAP32[i11 >> 2] = i3 >>> 0 < i9 >>> 0 ? i9 : i3;
    }
    if (i7) {
     i11 = i8 + 20 | 0;
     i9 = HEAP32[i11 >> 2] | 0;
     HEAP32[i11 >> 2] = i3 >>> 0 < i9 >>> 0 ? i3 : i9;
     HEAP32[i5 >> 2] = i6;
     HEAP32[i8 + 24 >> 2] = i3;
    }
   }
  } else {
   i2 = -1;
   i1 = -1;
  }
 } while (0);
 i11 = i10;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = 0;
 i11 = i10 + 8 | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i1;
 return;
}

function __ZN6b2Body14DestroyFixtureEP9b2Fixtureb(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i4 = i6 + 88 | 0;
 if (HEAP32[(HEAP32[i4 >> 2] | 0) + 102868 >> 2] & 2 | 0) return;
 i1 = i6 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 L4 : do if (i2 | 0) {
  while (1) {
   i3 = i2 + 24 | 0;
   if ((i2 | 0) == (i7 | 0)) break;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) break L4; else i1 = i3;
  }
  HEAP32[i1 >> 2] = HEAP32[i7 + 24 >> 2];
 } while (0);
 i1 = HEAP32[i6 + 112 >> 2] | 0;
 if (i1 | 0) do {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if ((HEAP32[i2 + 48 >> 2] | 0) == (i7 | 0) ? 1 : (HEAP32[i2 + 52 >> 2] | 0) == (i7 | 0)) __ZN16b2ContactManager7DestroyEP9b2Contact((HEAP32[i4 >> 2] | 0) + 102872 | 0, i2);
 } while ((i1 | 0) != 0);
 i2 = HEAP32[i4 >> 2] | 0;
 if (HEAP16[i6 + 4 >> 1] & 32) {
  i3 = i2 + 102872 | 0;
  i4 = i7 + 48 | 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i5 = i7 + 44 | 0;
   i1 = 0;
   do {
    i9 = (HEAP32[i5 >> 2] | 0) + (i1 * 28 | 0) + 24 | 0;
    __ZN12b2BroadPhase12DestroyProxyEi(i3, HEAP32[i9 >> 2] | 0);
    HEAP32[i9 >> 2] = -1;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
  }
  HEAP32[i4 >> 2] = 0;
 }
 __ZN9b2Fixture7DestroyEP16b2BlockAllocator(i7, i2);
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = 0;
 __ZN16b2BlockAllocator4FreeEPvi(i2, i7, 64);
 i9 = i6 + 104 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (!i8) return;
 __ZN6b2Body13ResetMassDataEv(i6);
 return;
}

function __ZN5physx15PxsParticleData16removeParticlesVEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = i8 + 60 | 0;
 i5 = HEAP32[i7 >> 2] & 2147483647;
 L1 : do if (i5 | 0) {
  i4 = HEAP32[i8 + 56 >> 2] | 0;
  i1 = 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (i2 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
  i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i1 << 5;
  i2 = i2 + -1 & i2;
  L7 : do if (!i2) do {
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    break L7;
   }
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  } while ((i2 | 0) == 0); while (0);
  if ((i3 | 0) != -1) {
   i5 = HEAP32[i8 + 48 >> 2] | 0;
   i6 = HEAP32[i8 + 56 >> 2] | 0;
   do {
    i4 = i1 << 5;
    while (1) {
     HEAP16[i5 + (i3 << 5) + 28 >> 1] = 0;
     i9 = i6 + (i3 >>> 5 << 2) | 0;
     HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << (i3 & 31));
     if (!i2) break L1;
     i3 = (Math_imul(i2 & 0 - i2, 125613361) | 0) >>> 27;
     i3 = HEAP32[gb + 90668 + (i3 << 2) >> 2] | i4;
     i2 = i2 + -1 & i2;
     if (!i2) break;
     if ((i3 | 0) == -1) break L1;
    }
    i4 = HEAP32[i7 >> 2] & 2147483647;
    do {
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i4 >>> 0) {
      i2 = 0;
      break;
     }
     i2 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
    } while ((i2 | 0) == 0);
   } while ((i3 | 0) != -1);
  }
 } while (0);
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 return;
}

function __ZN5physx13GuMeshFactory17createHeightFieldERKNS_17PxHeightFieldDescE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i8 | 0, i3 | 0, 116, (i6 ? gb + 726403 | 0 : gb + 837976 | 0) | 0, gb + 724079 | 0, 229) | 0;
 __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE(i6, i4);
 if (!i6) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (__ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb(i6, i1, 1) | 0) {
  HEAP32[i2 >> 2] = i6;
  i3 = i4 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 88 | 0, i2, i5) | 0;
  if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i8 = i6;
  STACKTOP = i7;
  return i8 | 0;
 } else {
  i1 = i6 + 8 | 0;
  if (__ZN5physx6shdfnd15atomicDecrementEPVi(i6 + 12 | 0) | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN20ArchiveStorageHeader13GetDataOffsetERKNS_6HeaderE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i4 = i6 + 4 | 0;
 i3 = i1 ? HEAP32[i4 >> 2] | 0 : i2 & 255;
 if ((i3 | 0) == 12) if (!(_memcmp(i1 ? HEAP32[i6 >> 2] | 0 : i6, gb + 489819 | 0, 12) | 0)) {
  i5 = 0;
  i6 = HEAP32[i6 + 64 >> 2] | 0;
  setTempRet0(i5 | 0);
  return i6 | 0;
 }
 i1 = HEAP32[gb + 70780 >> 2] | 0;
 L6 : do if ((_strlen(i1) | 0) == (i3 | 0)) {
  switch (i3 | 0) {
  case -1:
   {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i6);
    break;
   }
  case 0:
   {
    i5 = i2;
    break;
   }
  default:
   if (!(_memcmp(i2 << 24 >> 24 < 0 ? HEAP32[i6 >> 2] | 0 : i6, i1, i3) | 0)) i5 = i2; else {
    i1 = 0;
    i2 = 0;
    break L6;
   }
  }
  i1 = HEAP8[i6 + 20 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i2 = HEAP32[i6 + 24 >> 2] | 0; else i2 = i1 & 255;
  i1 = HEAP8[i6 + 36 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i6 + 40 >> 2] | 0; else i1 = i1 & 255;
  i2 = i2 + 5 + i1 | 0;
  if (!(HEAP32[i6 + 72 >> 2] & 256)) {
   if (i5 << 24 >> 24 < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i5 & 255;
   i1 = i2 + 22 + i1 | 0;
  } else i1 = i2 + 31 | 0;
  i2 = 0;
 } else {
  i1 = 0;
  i2 = 0;
 } while (0);
 if (HEAP32[i6 + 72 >> 2] & 128 | 0) {
  i5 = i2;
  i6 = i1;
  setTempRet0(i5 | 0);
  return i6 | 0;
 }
 i6 = _i64Add(HEAP32[i6 + 64 >> 2] | 0, 0, i1 | 0, i2 | 0) | 0;
 i5 = getTempRet0() | 0;
 setTempRet0(i5 | 0);
 return i6 | 0;
}

function __ZN13WheelCollider7CleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = i3 + 148 | 0;
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  STACKTOP = i9;
  return;
 }
 i7 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 if (i7 | 0) {
  i4 = i7 + 56 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv(i2 + 72 | 0, HEAP32[i6 >> 2] | 0, 0);
   i5 = i2 + 8 | 0;
   __ZN5physx22PxVehicleWheelsSimData12disableWheelEj(i5, HEAP32[i6 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i5, HEAP32[i6 >> 2] | 0, i1);
   i2 = HEAP32[i2 + 48 >> 2] | 0;
   L7 : do if (!i2) i8 = 7; else {
    i1 = 0;
    while (1) {
     if (!(__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i5, i1) | 0)) break L7;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i2 >>> 0) {
      i8 = 7;
      break;
     }
    }
   } while (0);
   if ((i8 | 0) == 7) {
    i8 = i7 + 64 | 0;
    __Z13RemoveVehiclePN5physx16PxVehicleNoDriveEj(HEAP32[i4 >> 2] | 0, HEAP32[i8 >> 2] | 0);
    __ZN5physx16PxVehicleNoDrive4freeEv(HEAP32[i4 >> 2] | 0);
    HEAP32[i8 >> 2] = -1;
    HEAP32[i4 >> 2] = 0;
   }
  }
 }
 HEAP32[i6 >> 2] = -1;
 HEAP32[i3 + 144 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i3 + 4 >> 2] | 0);
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i3 + 64 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 68 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 88 | 0);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i3 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 40 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = 5;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i5;
 return;
}

function __ZNK5Umbra14TomeCollection16getObjectUserIDsEiPji(i1, i8, i9, i3) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i6 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i6) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = i6 + 76 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = (i2 | 0) == 0;
 i2 = i6 + i2 | 0;
 if (!(i1 | (i2 | 0) == 0)) {
  i5 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
  i1 = (HEAP32[i2 + (i8 + 1 << 2) >> 2] | 0) - i5 | 0;
  if (!i9) {
   i9 = i1;
   return i9 | 0;
  }
  i3 = (i1 | 0) <= (i3 | 0) ? i1 : i3;
  if ((i3 | 0) <= 0) {
   i9 = i1;
   return i9 | 0;
  }
  i4 = i6 + 80 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[((i2 | 0) == 0 ? 0 : i6 + i2 | 0) + (i5 << 2) >> 2];
  if ((i3 | 0) == 1) {
   i9 = i1;
   return i9 | 0;
  } else i2 = 1;
  do {
   i5 = HEAP32[i7 >> 2] | 0;
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP32[i9 + (i2 << 2) >> 2] = HEAP32[((i10 | 0) == 0 ? 0 : i6 + i10 | 0) + (HEAP32[((i5 | 0) == 0 ? 0 : i6 + i5 | 0) + (i8 << 2) >> 2] << 2) + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  return i1 | 0;
 }
 if ((i8 | 0) < 0) {
  i10 = 0;
  return i10 | 0;
 }
 if ((HEAP32[i6 + 64 >> 2] | 0) <= (i8 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if (i1) {
  i1 = HEAP32[i6 + 80 >> 2] | 0;
  i1 = HEAP32[((i1 | 0) == 0 ? 0 : i6 + i1 | 0) + (i8 << 2) >> 2] | 0;
 } else i1 = -1;
 if (!((i9 | 0) != 0 & (i3 | 0) > 0)) {
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i10 = 1;
 return i10 | 0;
}

function __ZN8Renderer12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[gb + 1158204 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158360 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158360 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158364 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158364 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158368 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158368 >> 2] = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 12348 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i4 = i7 + 11580 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i4 >> 2] | 0) == (fb + 49 | 0)) {
   i3 = i7 + 11580 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + 11580 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i3 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + 11580 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + 11580 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + 11580 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 11580 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + 11580 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + 11580 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 144; else i1 = (HEAP32[i1 >> 2] | 0) + 144 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 120; else i1 = (HEAP32[i1 >> 2] | 0) + 120 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 108; else i1 = (HEAP32[i1 >> 2] | 0) + 108 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu5Debug9visualizeERKNS_17PxCapsuleGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i8, i12, i11, i10, i9, i1, f3, i2) {
 i8 = i8 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f13 = f0;
 do if ((i9 & 1073741824 | 0) == 0 & 0 == 0) if ((i9 & 8192 | 0) == 0 & 0 == 0) return; else {
  i2 = i8 + 8 | 0;
  i1 = i8 + 4 | 0;
  break;
 } else {
  f7 = Math_fround(HEAPF32[i11 + 36 >> 2]);
  f4 = Math_fround(HEAPF32[i11 + 40 >> 2]);
  f5 = Math_fround(HEAPF32[i11 + 44 >> 2]);
  i2 = i8 + 8 | 0;
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f13 = Math_fround(-f6);
  i1 = i8 + 4 | 0;
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f13 = Math_fround(f7 + Math_fround(f13 - f3));
  f4 = Math_fround(f4 + Math_fround(0.0));
  f5 = Math_fround(f5 + Math_fround(0.0));
  if (f13 > Math_fround(HEAPF32[i10 + 12 >> 2])) return;
  f13 = Math_fround(f7 + Math_fround(f6 + f3));
  if (Math_fround(HEAPF32[i10 >> 2]) > f13) return;
  if (f4 > Math_fround(HEAPF32[i10 + 16 >> 2])) return;
  if (Math_fround(HEAPF32[i10 + 4 >> 2]) > f4) return;
  if (f5 > Math_fround(HEAPF32[i10 + 20 >> 2])) return;
  if ((i9 & 8192 | 0) == 0 & 0 == 0 | Math_fround(HEAPF32[i10 + 8 >> 2]) > f5) return;
 } while (0);
 __ZN5physx2Cm12RenderOutputlsEj(i12, -65281) | 0;
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 __ZN5physx2Cm12RenderOutput13outputCapsuleEffRKNS0_8Matrix34E(i12, f13, Math_fround(HEAPF32[i2 >> 2]), i11) | 0;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i4;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j(i5, i1);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  if (i4 >>> 0 > i5 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
   i4 = HEAP32[i8 >> 2] | 0;
   i5 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i4;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 > i5 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 88 | 0;
 i2 = (i1 | 0) / 88 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 88 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 88 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 88 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 88 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN12NavMeshAgent11SetPositionERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 24 | 0;
 i5 = i8 + 12 | 0;
 i6 = i8;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i7 = i2 + 28 | 0;
 i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0;
 i3 = i2 + 44 | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 4 >> 2] = i10;
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_(i5, i9, i1, i4);
 i1 = i2 + 68 | 0;
 __ZN7dtCrowd9moveAgentERK13dtCrowdHandlePKf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1, i5);
 if (HEAP8[i2 + 107 >> 0] & 1) {
  i10 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0;
  HEAP32[i6 >> 2] = HEAP32[i10 + 480 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 484 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 488 >> 2];
  i10 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 >> 2] | 0, gb + 28940 | 0) | 0;
  f11 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = f11;
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i10, i6, i4);
 }
 STACKTOP = i8;
 return;
}

function __ZN12InputManager13GetButtonDownERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = i2 + 11 | 0;
 i11 = __Z7FNVHashPKc((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i10 = HEAP32[i3 + 32 >> 2] | 0;
 if ((i4 | 0) == (i10 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i9 = HEAP8[i1 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i7 = i3 + 68 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i4 + 20 >> 2] | 0) == (i11 | 0)) {
   i3 = i4 + 4 | 0;
   i6 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   if (i2) i5 = HEAP32[i4 + 8 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i9 | 0)) {
    if (i2) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i4 + 8 >> 2] | 0;
    } else i2 = i6 & 255;
    if (!(_strncmp(i3, i8, i2) | 0)) if (!(HEAP32[i4 + 76 >> 2] | 0)) {
     i2 = HEAP32[i4 + 56 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     i12 = HEAP32[i4 + 60 >> 2] | 0;
     i3 = HEAP32[i4 + 64 >> 2] | 0;
     i6 = HEAP32[i4 + 68 >> 2] | 0;
     i1 = i1 | (1 << (i12 & 31) & HEAP32[i5 + (i12 >>> 5 << 2) >> 2] | HEAP32[i5 + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31) | 1 << (i3 & 31) & HEAP32[i5 + (i3 >>> 5 << 2) >> 2] | 1 << (i6 & 31) & HEAP32[i5 + (i6 >>> 5 << 2) >> 2] | 0) != 0;
    }
   }
  }
  i4 = i4 + 108 | 0;
 } while ((i4 | 0) != (i10 | 0));
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj(i6, i7, i1, i5, i9, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if ((2147483631 - i7 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i8 = HEAP32[i6 >> 2] | 0; else i8 = i6;
 if (i7 >>> 0 < 1073741799) {
  i3 = i1 + i7 | 0;
  i4 = i7 << 1;
  i3 = i3 >>> 0 < i4 >>> 0 ? i4 : i3;
  i3 = i3 >>> 0 < 11 ? 11 : i3 + 16 & -16;
 } else i3 = 2147483631;
 i2 = i6 + 12 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, i12, 0, gb + 1049224 | 0, 75) | 0;
 if (i9 | 0) _memcpy(i4 | 0, i8 | 0, i9 | 0) | 0;
 i1 = i5 - i10 - i9 | 0;
 if (i1 | 0) _memcpy(i4 + i9 + i11 | 0, i8 + i9 + i10 | 0, i1 | 0) | 0;
 if ((i7 | 0) == 10) {
  HEAP32[i6 >> 2] = i4;
  i11 = i3 | -2147483648;
  i12 = i6 + 8 | 0;
  HEAP32[i12 >> 2] = i11;
  STACKTOP = i13;
  return;
 }
 i11 = HEAP32[i2 >> 2] | 0;
 HEAP32[i12 >> 2] = 1;
 HEAP32[i12 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i12);
 HEAP32[i6 >> 2] = i4;
 i11 = i3 | -2147483648;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = i11;
 STACKTOP = i13;
 return;
}

function __ZN6Camera20WindowSizeHasChangedEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, f3 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i5 = i4 + 1086 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZL19GetCameraTargetRectRK6Camerab(i2, i4, 1);
 f1 = Math_fround(HEAPF32[i4 + 864 >> 2]);
 f3 = Math_fround(HEAPF32[i4 + 868 >> 2]);
 f11 = Math_fround(HEAPF32[i4 + 872 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 876 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f1 = Math_fround(f1 * f12);
 f11 = Math_fround(f11 * f12);
 f3 = Math_fround(f3 * f9);
 f8 = Math_fround(f8 * f9);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(f1 + f10);
 f3 = Math_fround(f3 + f7);
 f11 = Math_fround(f11 + f1);
 f8 = Math_fround(f8 + f3);
 f12 = Math_fround(f12 + f10);
 f9 = Math_fround(f9 + f7);
 f1 = Math_fround((f11 > f12 ? f12 : f11) - (f1 < f10 ? f10 : f1));
 f3 = Math_fround((f8 > f9 ? f9 : f8) - (f3 < f7 ? f7 : f3));
 i2 = f3 < Math_fround(0.0);
 f3 = i2 ? Math_fround(0.0) : f3;
 if (f3 != Math_fround(0.0)) {
  i2 = f1 < Math_fround(0.0);
  f1 = Math_fround((i2 ? Math_fround(0.0) : f1) / f3);
 } else f1 = Math_fround(1.0);
 HEAPF32[i4 + 1060 >> 2] = f1;
 HEAP8[i4 + 1077 >> 0] = 1;
 HEAP8[i4 + 1079 >> 0] = 1;
 HEAP8[i4 + 1078 >> 0] = 1;
 HEAP8[i5 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj76ENS0_26PxPvdRangePropertyAccessorILj76ES4_fEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj71ENS0_26PxPvdRangePropertyAccessorILj71ES4_fEEEEvjRKT0_(i3, i1, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var d2 = 0.0, i4 = 0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 16 | 0;
 i8 = i12 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i10 | 0, i8 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i4 = gb + 832307 | 0; else i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i3 + -1 << 3) >> 2] | 0;
 d2 = +(HEAP8[i7 + 8 >> 0] | 0 ? f6 : f5);
 i1 = i10;
 i3 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAPF64[i11 >> 3] = d2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i10, 128, gb + 832323 | 0, i11) | 0;
 if (HEAP8[i10 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i9 | 0, i10 | 0, _strlen(i10) | 0) | 0;
 }
 HEAP8[i11 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i11 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i4 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i12;
 return;
}

function __ZN5physx27PxHeightFieldRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i2, i1, i6, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 40 | 0;
 i7 = i1 + 8 | 0;
 i10 = i1;
 i11 = i7 + 12 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i7 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 1;
 HEAPF32[i7 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i7 + 24 >> 2] = Math_fround(0.0);
 HEAP16[i7 + 28 >> 1] = 0;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 __ZN5physx2Sn17readAllPropertiesINS_17PxHeightFieldDescEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i9, i6, i7, i3, i5) | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 __ZN5physx2Sn25readStridedBufferPropertyINS_19PxHeightFieldSampleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE(i6, gb + 752413 | 0, i9, i11, i10, i3);
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i5 = HEAP32[i4 >> 2] | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0, i7 | 0) | 0;
 HEAP32[i2 >> 2] = gb + 753780;
 HEAP32[i2 + 4 >> 2] = i5;
 i6 = i2 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZN12NavMeshAgent7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 845576 | 0, 25) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 168776 + 8;
 HEAP32[i4 + 68 >> 2] = -1;
 HEAP32[i4 + 88 >> 2] = -1;
 HEAPF32[i4 + 36 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 40 >> 2] = Math_fround(2.0);
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(3.5);
 HEAPF32[i4 + 52 >> 2] = Math_fround(120.0);
 HEAPF32[i4 + 56 >> 2] = Math_fround(inf);
 HEAPF32[i4 + 60 >> 2] = Math_fround(8.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 100 >> 2] = 50;
 HEAP32[i4 + 92 >> 2] = 4;
 i2 = i4 + 107 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 3;
 HEAP8[i4 + 104 >> 0] = 1;
 HEAP8[i4 + 105 >> 0] = 1;
 HEAP8[i4 + 106 >> 0] = 1;
 HEAP32[i4 + 96 >> 2] = -1;
 HEAP32[i4 + 72 >> 2] = 0;
 i2 = i4 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z43RectTransform_CUSTOM_INTERNAL_set_sizeDeltaP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i7 + 160 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i1 ^ i6 | 0) > -1) {
  i1 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) <= 10) i5 = 7;
 } else if (f3 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i5 = 7;
 do if ((i5 | 0) == 7) {
  f3 = Math_fround(HEAPF32[i7 + 164 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i2 | 0) > -1) {
   i5 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) | 0;
   if ((((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0) >= 11) break;
   return;
  } else {
   if (!(f3 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
   return;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[i7 + 164 >> 2] = i2;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i7, 1, 0);
 return;
}

function __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMinP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i7 + 136 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i1 ^ i6 | 0) > -1) {
  i1 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) <= 10) i5 = 7;
 } else if (f3 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i5 = 7;
 do if ((i5 | 0) == 7) {
  f3 = Math_fround(HEAPF32[i7 + 140 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i2 | 0) > -1) {
   i5 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) | 0;
   if ((((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0) >= 11) break;
   return;
  } else {
   if (!(f3 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
   return;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[i7 + 140 >> 2] = i2;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i7, 1, 0);
 return;
}

function __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMaxP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i7 + 144 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i1 ^ i6 | 0) > -1) {
  i1 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) <= 10) i5 = 7;
 } else if (f3 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i5 = 7;
 do if ((i5 | 0) == 7) {
  f3 = Math_fround(HEAPF32[i7 + 148 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i2 | 0) > -1) {
   i5 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) | 0;
   if ((((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0) >= 11) break;
   return;
  } else {
   if (!(f3 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
   return;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[i7 + 148 >> 2] = i2;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i7, 1, 0);
 return;
}

function __Z17InstantiateObjectR6ObjectRK8Vector3fRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 24 | 0;
 i5 = i10;
 if ((HEAP16[gb + 1155156 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155156 | 0, i6);
  i7 = gb + 1155156 | 0;
 } else i7 = 0;
 i4 = __Z46get_current_allocation_root_reference_internalv() | 0;
 i11 = i5 + 4 | 0;
 HEAP32[i11 >> 2] = 0;
 i8 = i5 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i9 = i5 + 16 | 0;
 HEAP32[i9 >> 2] = i4;
 i4 = __Z17InstantiateObjectR6ObjectP9TransformRK8Vector3fRK11QuaternionfR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINSA_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, 0, i2, i3, i5) | 0;
 __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i5);
 i1 = HEAP32[i11 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i8 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i11 = HEAP32[i9 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i11;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 if (!i7) {
  STACKTOP = i10;
  return i4 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i10;
 return i4 | 0;
}

function __GLOBAL__sub_I_SwSolverKernel_cpp() {
 HEAP32[gb + 1097440 >> 2] = 0;
 HEAP32[gb + 1097440 + 4 >> 2] = 0;
 HEAP32[gb + 1097440 + 8 >> 2] = 0;
 HEAP32[gb + 1097440 + 12 >> 2] = -1;
 HEAP32[gb + 1097456 >> 2] = -1;
 HEAP32[gb + 1097456 + 4 >> 2] = -1;
 HEAP32[gb + 1097456 + 8 >> 2] = 0;
 HEAP32[gb + 1097456 + 12 >> 2] = 0;
 HEAP32[gb + 1097472 >> 2] = -1;
 HEAP32[gb + 1097472 + 4 >> 2] = -1;
 HEAP32[gb + 1097472 + 8 >> 2] = -1;
 HEAP32[gb + 1097472 + 12 >> 2] = 0;
 HEAP32[gb + 1097488 >> 2] = 0;
 HEAP32[gb + 1097488 + 4 >> 2] = -1;
 HEAP32[gb + 1097488 + 8 >> 2] = -1;
 HEAP32[gb + 1097488 + 12 >> 2] = -1;
 HEAP32[gb + 1097504 >> 2] = 872415232;
 HEAP32[gb + 1097504 + 4 >> 2] = 872415232;
 HEAP32[gb + 1097504 + 8 >> 2] = 872415232;
 HEAP32[gb + 1097504 + 12 >> 2] = 872415232;
 HEAPF32[gb + 1097520 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1097520 + 4 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1097520 + 8 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1097520 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1097536 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1097536 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1097536 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1097536 + 12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[gb + 1097552 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097552 + 4 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097552 + 8 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097552 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK7ApiGLES14QueryExtensionEPKc(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 600409 | 0, 13);
 i3 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (i3) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) == 1) {
  i1 = mftCall_ii(HEAP32[i2 + 844 >> 2] | 0, 7939) | 0;
  if (!i1) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  i1 = _strstr(i1, i4) | 0;
  if (!i1) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  i4 = (HEAP8[i1 + (_strlen(i4) | 0) >> 0] | 32) << 24 >> 24 == 32;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  HEAP32[i1 >> 2] = 0;
  mftCall_vii(HEAP32[i2 + 88 >> 2] | 0, 33309, i1 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = i2 + 840 | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  while (1) {
   if (!(_strcmp(i4, mftCall_iii(HEAP32[i2 >> 2] | 0, 7939, i1 | 0) | 0) | 0)) {
    i1 = 1;
    i2 = 9;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i1 = 0;
    i2 = 9;
    break;
   }
  }
  if ((i2 | 0) == 9) {
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 96; else i1 = (HEAP32[i1 >> 2] | 0) + 96 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 84; else i1 = (HEAP32[i1 >> 2] | 0) + 84 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 72; else i1 = (HEAP32[i1 >> 2] | 0) + 72 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj568ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj567ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj566ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj565ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj546ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj545ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj544ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj543ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj542ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj541ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf(i3, i4, i7, f6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i1 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
 if (i1 >>> 0 < 5) {
  i1 = (29 >>> (i1 & 31) & 1) != 0;
  if (f6 <= Math_fround(0.0) & i1) {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  } else i2 = i1;
 } else i2 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0, i4 | 0) | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0, 1, 1);
 if (i2) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i7 | 0);
  __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f6, 0, 0) | 0;
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 128 >> 2] | 0, i7 | 0, 1, 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i7 | 0);
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0, 1.0);
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0;
  HEAPF32[i5 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
  mftCall_vii(i7 | 0, i1 | 0, i5 | 0);
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __ZN25ThreadsafeLinearAllocatorC2EiiPKc(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN13BaseAllocatorC2EPKc(i4, i1);
 HEAP32[i4 >> 2] = gb + 27156 + 8;
 i7 = i4 + 36 | 0;
 HEAP32[i7 >> 2] = -1;
 i8 = i4 + 40 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 i6 = i4 + 48 | 0;
 HEAP32[i6 >> 2] = i2;
 i5 = i4 + 52 | 0;
 HEAP32[i5 >> 2] = i3;
 i2 = i4 + 60 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z16GetMemoryManagerv() | 0;
 i2 = __ZN13MemoryManager16LowLevelAllocateEj((HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
 i3 = i4 + 32 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = HEAP32[i8 >> 2] | 0;
 L1 : do if ((i4 | 0) > 0) {
  i1 = 0;
  while (1) {
   if ((i1 | 0) != (HEAP32[i7 >> 2] | 0)) {
    i9 = i2 + (i1 * 12 | 0) + 8 | 0;
    HEAP32[i9 >> 2] = HEAP32[i9 >> 2];
    if (!(HEAP32[i9 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) break L1;
  }
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i7 >> 2] = i1;
  return;
 } while (0);
 if ((i4 | 0) >= (HEAP32[i5 >> 2] | 0)) return;
 __Z16GetMemoryManagerv() | 0;
 i1 = __ZN13MemoryManager16LowLevelAllocateEj(HEAP32[i6 >> 2] | 0) | 0;
 if (!i1) return;
 i9 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 + (i4 * 12 | 0) >> 2] = i1;
 HEAP32[i9 + (i4 * 12 | 0) + 8 >> 2] = 0;
 HEAP32[i9 + (i4 * 12 | 0) + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i7 >> 2] = i4;
 return;
}

function __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene(i9, i1, i10, i2, i3, i4, i11, i12, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(108, gb + 63824 | 0, 16, gb + 462762 | 0, 80) | 0;
 __ZN10UnitySceneC2EiRK8UnityStrS2_RK9UnityGUIDi(i5, __Z28AllocateNextLowestInstanceIDv() | 0, i1, i2, i3, i4);
 HEAP32[i13 >> 2] = i5;
 i2 = i9 + 4 | 0;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i13 >> 2];
 return __ZN19RuntimeSceneManager18LoadSceneAsyncIntoER10UnitySceneRK8UnityStrNS_11LoadingModeEb(i9, HEAP32[i13 >> 2] | 0, i10, i11, i12) | 0;
}

function __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i2 = i7;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i5, i2, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
 i4 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i1, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 1;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i1 + 4 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 4);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i7;
  return;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i6 = i5;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
}

function __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 16 | 0;
 i6 = i9;
 i7 = i2 + 8 | 0;
 i1 = HEAP32[i7 >> 2] & 2147483647;
 if ((HEAP32[i8 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i8, i1);
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i2 + 4 | 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i8, HEAP32[i3 >> 2] << 4 >> 4);
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i2 + (i10 << 4) | 0;
 if ((i10 | 0) > 0) while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 16 | 0;
 }
 i10 = HEAP32[i7 >> 2] & 2147483647;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i8, i10, i5);
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i8, HEAP32[i3 >> 2] | 0, i6);
 STACKTOP = i9;
 return;
}

function __ZN12InputManager11GetButtonUpERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = i2 + 11 | 0;
 i11 = __Z7FNVHashPKc((HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i10 = HEAP32[i3 + 32 >> 2] | 0;
 if ((i4 | 0) == (i10 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i9 = HEAP8[i1 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i7 = i3 + 88 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i4 + 20 >> 2] | 0) == (i11 | 0)) {
   i3 = i4 + 4 | 0;
   i6 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   if (i2) i5 = HEAP32[i4 + 8 >> 2] | 0; else i5 = i6 & 255;
   if ((i5 | 0) == (i9 | 0)) {
    if (i2) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i4 + 8 >> 2] | 0;
    } else i2 = i6 & 255;
    if (!(_strncmp(i3, i8, i2) | 0)) if (!(HEAP32[i4 + 76 >> 2] | 0)) {
     i2 = HEAP32[i4 + 56 >> 2] | 0;
     i5 = HEAP32[i7 >> 2] | 0;
     i12 = HEAP32[i4 + 60 >> 2] | 0;
     i3 = HEAP32[i4 + 64 >> 2] | 0;
     i6 = HEAP32[i4 + 68 >> 2] | 0;
     i1 = i1 | (1 << (i12 & 31) & HEAP32[i5 + (i12 >>> 5 << 2) >> 2] | HEAP32[i5 + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31) | 1 << (i3 & 31) & HEAP32[i5 + (i3 >>> 5 << 2) >> 2] | 1 << (i6 & 31) & HEAP32[i5 + (i6 >>> 5 << 2) >> 2] | 0) != 0;
    }
   }
  }
  i4 = i4 + 108 | 0;
 } while ((i4 | 0) != (i10 | 0));
 return i1 | 0;
}

function __Z25JsonUtility_CUSTOM_ToJsonP12Il2CppObjecth(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i6 = i7 + 8 | 0;
 if (!i4) {
  i6 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = __Z26scripting_object_get_classP12Il2CppObject(i4) | 0;
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0) {
  i1 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i1) | 0;
  if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1036840 | 0, i2);
  if ((HEAP32[i1 + 16 >> 2] | 0) != 114) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1036840 | 0, i2);
 }
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i6 + 24 | 0;
 i9 = gb + 64016 | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i2;
 i8 = i6 + 4 | 0;
 HEAP8[i8 >> 0] = 0;
 __ZN11JSONUtility15SerializeObjectEP12Il2CppObjectRN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb24TransferInstructionFlags(i4, i6, i5 << 24 >> 24 != 0, 0);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i8 : i2, HEAP32[i1 >> 2] | 0) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i6 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function _internal_memalign(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i1 >>> 0 < 16 ? 16 : i1;
 if (i1 + -1 & i1) {
  i2 = 16;
  while (1) if (i2 >>> 0 < i1 >>> 0) i2 = i2 << 1; else {
   i1 = i2;
   break;
  }
 }
 if ((-64 - i1 | 0) >>> 0 <= i3 >>> 0) {
  HEAP32[(___errno_location() | 0) >> 2] = 12;
  i6 = 0;
  return i6 | 0;
 }
 i6 = i3 >>> 0 < 11 ? 16 : i3 + 11 & -8;
 i2 = _malloc(i6 + 12 + i1 | 0) | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = i2 + -8 | 0;
 do if (!(i2 & i1 + -1)) i1 = i5; else {
  i7 = (i2 + i1 + -1 & 0 - i1) + -8 | 0;
  i4 = i5;
  i1 = (i7 - i4 | 0) >>> 0 > 15 ? i7 : i7 + i1 | 0;
  i4 = i1 - i4 | 0;
  i2 = i2 + -4 | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  i3 = (i7 & -8) - i4 | 0;
  if (!(i7 & 3)) {
   HEAP32[i1 >> 2] = (HEAP32[i5 >> 2] | 0) + i4;
   HEAP32[i1 + 4 >> 2] = i3;
   break;
  } else {
   i7 = i1 + 4 | 0;
   HEAP32[i7 >> 2] = i3 | HEAP32[i7 >> 2] & 1 | 2;
   i3 = i1 + i3 + 4 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
   HEAP32[i2 >> 2] = i4 | HEAP32[i2 >> 2] & 1 | 2;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1;
   _dispose_chunk(i5, i4);
   break;
  }
 } while (0);
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 & 3 | 0) {
  i4 = i3 & -8;
  if (i4 >>> 0 > (i6 + 16 | 0) >>> 0) {
   i7 = i4 - i6 | 0;
   i5 = i1 + i6 | 0;
   HEAP32[i2 >> 2] = i6 | i3 & 1 | 2;
   HEAP32[i5 + 4 >> 2] = i7 | 3;
   i6 = i5 + i7 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
   _dispose_chunk(i5, i7);
  }
 }
 i7 = i1 + 8 | 0;
 return i7 | 0;
}

function __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i9 = i7 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i8 + 4 | 0;
  i6 = i8 + 4 | 0;
  do {
   i4 = i2 + -60 | 0;
   HEAP32[i9 >> 2] = i4;
   i3 = i2 + -20 | 0;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -44 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
   }
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i8);
   }
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i11 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 25;
 HEAP32[i8 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZN19ShaderPropertySheet15UpdateTextureSTEiRKN9ShaderLab16FastPropertyNameEffff(i10, i8, i9, f4, f1, f7, f5) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 f7 = Math_fround(f7);
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, i6 = 0, f11 = f0, f12 = f0;
 f11 = Math_fround(f4 + Math_fround(-1.0));
 i6 = f11 < Math_fround(0.0);
 f12 = Math_fround(-f11);
 if ((i6 ? f12 : f11) <= Math_fround(9.99999997e-07)) {
  f12 = Math_fround(f1 + Math_fround(-1.0));
  i6 = f12 < Math_fround(0.0);
  f11 = Math_fround(-f12);
  i6 = (i6 ? f11 : f12) <= Math_fround(9.99999997e-07);
  f4 = i6 ? Math_fround(1.0) : f4;
  f1 = i6 ? Math_fround(1.0) : f1;
 }
 i6 = f7 < Math_fround(0.0);
 f12 = Math_fround(-f7);
 if ((i6 ? f12 : f7) <= Math_fround(9.99999997e-07)) {
  i6 = f5 < Math_fround(0.0);
  f12 = Math_fround(-f5);
  i6 = (i6 ? f12 : f5) <= Math_fround(9.99999997e-07);
  f7 = i6 ? Math_fround(0.0) : f7;
  f5 = i6 ? Math_fround(0.0) : f5;
 }
 i6 = i10 + 72 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i2 + i8 + 20 >> 2] | 0;
 if ((i3 | 0) < 0) {
  i3 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i10, i9, gb + 478716 | 0) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP32[i2 + i8 + 20 >> 2] = i3;
 }
 i10 = i2 + (HEAP32[(HEAP32[i10 + 52 >> 2] | 0) + ((HEAP32[i10 + 12 >> 2] | 0) + i3 << 2) >> 2] & 1048575) | 0;
 HEAPF32[i10 >> 2] = f4;
 HEAPF32[i10 + 4 >> 2] = f1;
 HEAPF32[i10 + 8 >> 2] = f7;
 HEAPF32[i10 + 12 >> 2] = f5;
 return;
}

function __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 __ZN10systeminfo18GetOperatingSystemEv(i5);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i6 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __Z20ConvertColorKeyArrayP11Il2CppArrayPN8Gradient8ColorKeyE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = i6 + 8 | 0;
 if (!i4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 516760 | 0, 0, gb + 516798 | 0, 68, 1, 0, 0, 0);
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i1 | 0) > 8) {
  HEAP32[i3 >> 2] = 8;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 516897 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 516798 | 0, 75, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 | 0) > 0) i2 = 0; else {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 do {
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 20) | 0;
  i9 = HEAP32[i3 + 4 >> 2] | 0;
  i8 = HEAP32[i3 + 8 >> 2] | 0;
  i7 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i5 + (i2 * 20 | 0) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + (i2 * 20 | 0) + 4 >> 2] = i9;
  HEAP32[i5 + (i2 * 20 | 0) + 8 >> 2] = i8;
  HEAP32[i5 + (i2 * 20 | 0) + 12 >> 2] = i7;
  HEAP32[i5 + (i2 * 20 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK26AnimatorOverrideController13GetBehavioursEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 6; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    i5 = HEAP32[i7 >> 2] | 0;
    i5 = i5 + 108 | 0;
    i5 = HEAP32[i5 >> 2] | 0;
    i7 = mftCall_ii(i5 | 0, i7 | 0) | 0;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i5 = i5 + 108 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i7 = mftCall_ii(i5 | 0, i7 | 0) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i5 = HEAP32[i9 + 40 >> 2] | 0;
 if (!i5) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP8[i7 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i2 = 5381; else {
  i2 = 5381;
  i3 = i7;
  do {
   i2 = i2 * 33 ^ i1 << 24 >> 24;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 i1 = HEAP8[i8 >> 0] | 0;
 if (!(i1 << 24 >> 24)) i1 = 5381; else {
  i3 = 5381;
  i4 = i8;
  do {
   i3 = i3 * 33 ^ i1 << 24 >> 24;
   i4 = i4 + 1 | 0;
   i1 = HEAP8[i4 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
  i1 = i3;
 }
 i1 = HEAP32[(HEAP32[i9 + 32 >> 2] | 0) + (((i1 ^ i2) & i5 + -1) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i6 = HEAP32[i9 + 24 >> 2] | 0;
 i5 = i7 | 0 ? i7 : gb + 1576256 | 0;
 i4 = i8 | 0 ? i8 : gb + 1576256 | 0;
 i3 = i9 + 28 | 0;
 while (1) {
  i9 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2] | 0;
  if (!(_strcmp(i9 | 0 ? i9 : gb + 1576256 | 0, i5) | 0)) if (!(_strcmp(i2 | 0 ? i2 : gb + 1576256 | 0, i4) | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i10 = 13;
   break;
  }
 }
 if ((i10 | 0) == 13) return i1 | 0;
 if (!(i6 + (i1 * 12 | 0) | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = HEAP32[i6 + (i1 * 12 | 0) + 8 >> 2] | 0;
 return i10 | 0;
}

function __ZN5physx35integrateNoDriveWheelRotationAnglesEfPKfS1_S1_PKbRKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE(f9, i4, i8, i5, i6, i11, i10) {
 f9 = Math_fround(f9);
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i7 = 0, f12 = f0, i13 = 0, i14 = 0, i15 = 0;
 i7 = 0;
 do {
  f1 = Math_fround(HEAPF32[i10 + (i7 << 2) >> 2]);
  f3 = Math_fround(HEAPF32[i8 + (i7 << 2) >> 2]);
  if (f3 > Math_fround(-Math_fround(HEAPF32[i11 + (i7 * 48 | 0) + 12 >> 2]))) if (!(HEAP8[i6 + i7 >> 0] | 0)) if (Math_fround(HEAPF32[i4 + (i7 << 2) >> 2]) == Math_fround(0.0)) {
   f2 = Math_fround(HEAPF32[i5 + (i7 << 2) >> 2]);
   f3 = Math_fround(Math_abs(Math_fround(f2)));
   if (f3 < Math_fround(HEAPF32[gb + 1458420 >> 2])) {
    f12 = Math_fround(HEAPF32[i11 + 192 + (i7 * 48 | 0) + 36 >> 2]);
    f3 = Math_fround(f3 * Math_fround(HEAPF32[gb + 1458424 >> 2]));
    f1 = Math_fround(Math_fround(f1 * f3) + Math_fround(Math_fround(f2 * f12) * Math_fround(Math_fround(1.0) - f3)));
   }
  }
  i13 = i10 + 32 + (i7 << 2) | 0;
  f12 = Math_fround(Math_fround(HEAPF32[i13 >> 2]) + Math_fround(f1 * f9));
  f2 = Math_fround(f12 + Math_fround(-31.4159279));
  f3 = Math_fround(f12 + Math_fround(31.4159279));
  i14 = Math_fround(Math_fround(-31.4159279) - f12) >= Math_fround(0.0);
  i15 = f2 >= Math_fround(0.0);
  HEAPF32[i13 >> 2] = i15 ? f2 : i14 ? f3 : f12;
  HEAPF32[i10 + 16 + (i7 << 2) >> 2] = f1;
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 4);
 return;
}

function __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh(i1, i7, i4, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = i2 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) return;
 if (!i4) {
  i3 = i2;
  do {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP8[i1 + 21 >> 0] & i8) << 24 >> 24) {
    i1 = __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE(i1) | 0;
    if (i1 | 0) {
     i2 = i1 + 4 | 0;
     HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | i7;
     i2 = i1 + 6 | 0;
     if (!(HEAP16[i2 >> 1] & 2)) {
      __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i1);
      HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 2;
     }
    }
   }
   i3 = i3 + 4 | 0;
  } while (i3 >>> 0 < i6 >>> 0);
  return;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) i5 = 10; else if ((HEAP32[i1 + 8 >> 2] | 0) == (i4 | 0)) i5 = 10;
  if ((i5 | 0) == 10) {
   i5 = 0;
   if ((HEAP8[i1 + 21 >> 0] & i8) << 24 >> 24) {
    i1 = __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE(i1) | 0;
    if (i1 | 0) {
     i3 = i1 + 4 | 0;
     HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | i7;
     i3 = i1 + 6 | 0;
     if (!(HEAP16[i3 >> 1] & 2)) {
      __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i1);
      HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
     }
    }
   }
  }
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i6 >>> 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx12NpBatchQuery16writeBatchHeaderERKNS_17BatchStreamHeaderE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = i6 + 12 | 0;
 i1 = i6 + 24 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i2 = i8 + 40 | 0;
 i3 = HEAP32[i6 + 20 >> 2] & 2147483647;
 if (i2 >>> 0 > i3 >>> 0) {
  i4 = (i2 * 3 | 0) + 256 | 0;
  if (i3 >>> 0 < i4 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i7, i4);
 }
 __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i7, i2);
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + i4 >> 2] = HEAP32[i5 >> 2];
 HEAP16[i3 + (i4 + 4) >> 1] = HEAP16[i5 + 4 >> 1] | 0;
 i9 = i3 + (i4 + 8) | 0;
 i10 = i5 + 8 | 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP16[i3 + (i4 + 24) >> 1] = HEAP16[i5 + 24 >> 1] | 0;
 HEAP8[i3 + (i4 + 26) >> 0] = HEAP8[i5 + 26 >> 0] | 0;
 i4 = i3 + (i4 + 28) | 0;
 i5 = i5 + 28 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP16[i4 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
 HEAP8[i4 + 10 >> 0] = HEAP8[i5 + 10 >> 0] | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = i6 + 144 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -16) {
  i10 = i1;
  HEAP32[i10 >> 2] = i8;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i10 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i1 >> 2] = i8;
 return;
}

function __ZN18WheelFrictionCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827340 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827355 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827371 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827387 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 827404 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN6Object17InsertObjectInMapEPS_(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i7 = i9;
 i5 = HEAP32[gb + 1104264 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj(i5, 1, 0);
 __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i5, i7);
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  __Z24profiler_register_objectP6Object(i6);
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i5 + 8 >> 0] | 0)) i8 = 6; else {
  i2 = i5 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i8 = 6; else {
   i1 = HEAP32[i5 + 28 >> 2] | 0;
   if ((HEAP32[i5 + 12 >> 2] | 0) == (HEAP32[i1 + (i4 << 3) >> 2] | 0)) HEAP32[i2 >> 2] = i3 + -1; else i8 = 6;
  }
 }
 if ((i8 | 0) == 6) {
  i1 = i5 + 36 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = HEAP32[i5 + 28 >> 2] | 0;
 }
 i5 = i7;
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i8 = i1 + (i4 << 3) | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 __Z24profiler_register_objectP6Object(i6);
 STACKTOP = i9;
 return;
}

function __ZN19CullingGroupManager17CullAndSendEventsERK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK8JobFence(i9, i3, i1, i4, i5) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 16 | 0;
 i6 = i10 + 12 | 0;
 i7 = i10;
 i11 = i10 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 __Z24ScheduleCullingAllGroupsR8JobFenceRK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK13dynamic_arrayIP12CullingGroupLj4EERKS_(i7, i3, i2, i4, i9, i5);
 if ((HEAP16[gb + 1114392 + 6 >> 1] | 0) > -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114392 | 0, i2);
  i5 = gb + 1114392 | 0;
 } else i5 = 0;
 if (HEAP32[i7 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i7);
 i4 = i9 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if ((HEAP32[i2 + 12 >> 2] | 0) == (i8 | 0)) {
    __ZN12CullingGroup13NotifyVisibleEv(i2);
    __ZN12CullingGroup15NotifyInvisibleEv(i2);
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 if (!i5) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i10;
 return;
}

function __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 24 | 0;
 i2 = (i1 | 0) / 24 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 24 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 8, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 24 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 24 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z39RectTransform_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i7 + 168 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i1 ^ i6 | 0) > -1) {
  i1 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i6 | 0) < 0 ? -2147483648 - i6 | 0 : i6) | 0;
  if ((((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) <= 10) i5 = 7;
 } else if (f3 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]))) i5 = 7;
 do if ((i5 | 0) == 7) {
  f3 = Math_fround(HEAPF32[i7 + 172 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 ^ i2 | 0) > -1) {
   i5 = ((i1 | 0) < 0 ? -2147483648 - i1 | 0 : i1) - ((i2 | 0) < 0 ? -2147483648 - i2 | 0 : i2) | 0;
   if ((((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0) >= 11) break;
   return;
  } else {
   if (!(f3 == (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])))) break;
   return;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[i7 + 172 >> 2] = i2;
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i7, 1, 0);
 return;
}

function __ZN5physx36solveExtContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i8, i7, i10, i11, i1, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (i7 | 0) {
  i3 = i10 + 16 | 0;
  i6 = 0;
  do {
   i5 = i8 + (i6 << 5) | 0;
   if ((HEAP16[i8 + (i6 << 5) + 8 >> 1] | 0) == -1) i2 = HEAPU16[i8 + (i6 << 5) + 10 >> 1] | 0; else i2 = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP16[i8 + (i6 << 5) + 12 >> 1] | 0) == -1) i4 = HEAPU16[i8 + (i6 << 5) + 14 >> 1] | 0; else i4 = 0;
   __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, 0);
   __ZN5physx23writeBackContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i5, i10, i1 + (i2 << 6) | 0, i1 + (i4 << 6) | 0);
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i7 | 0));
 }
 i5 = i10 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i9, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i10 = i11 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN15TerrainCollider8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i2, i5);
 i3 = i2 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1016773 | 0, gb + 1016787 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI11TerrainDataE8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i2 + 64 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1016805 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN14NavMeshCarving13SetDirtyLayerEi(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i8 + 68 | 0;
 i2 = i8 + 72 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i5 >> 2] = i2;
  i4 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i6 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i6 | 0)) {
     i2 = 9;
     break;
    }
    i3 = i1 + 4 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i5 >> 2] = i1;
   i4 = i1;
   i3 = i5;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i1 = __Znwj(20) | 0;
 HEAP32[i1 + 16 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 72 >> 2] | 0, i1);
 i8 = i8 + 76 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 STACKTOP = i9;
 return;
}

function __ZN7mecanim4hand13HandSetupAxesEPKNS0_4HandEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS4_8SkeletonEb(i8, i9, i10, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = 0;
 do {
  i6 = i7 * 3 | 0;
  i5 = i6 + 1 | 0;
  i4 = i8 + (i6 << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf(i10, i9, gb + 180096 + (i6 * 88 | 0) | 0, i1, (i2 | 0) > -1 ? i2 : -1, i11, Math_fround(1.0));
  i2 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
  i1 = HEAP32[i8 + (i6 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) f3 = Math_fround(1.0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   i4 = (i1 | 0) > -1;
   f3 = i4 ? Math_fround(-.75) : Math_fround(1.0);
   i1 = i4 ? i1 : -1;
  }
  if ((i2 | 0) > -1) __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf(i10, i9, gb + 180096 + (i5 * 88 | 0) | 0, i2, i1, i11, f3);
  i4 = i6 + 2 | 0;
  i5 = HEAP32[i8 + (i4 << 2) >> 2] | 0;
  i1 = HEAP32[i8 + (i6 + 1 << 2) >> 2] | 0;
  i2 = (i1 | 0) > -1;
  if ((i5 | 0) > -1) {
   f3 = i2 ? Math_fround(-.75) : Math_fround(1.0);
   __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf(i10, i9, gb + 180096 + (i4 * 88 | 0) | 0, i5, i2 ? i1 : -1, i11, f3);
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) != 5);
 return;
}

function __ZN5physx16PxsIslandManager13updateIslandsEPNS_10PxBaseTaskEj(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 __ZN5physx16PxsIslandManager17cleanupEdgeEventsEv(i8);
 __ZN5physx16PxsIslandManager12resizeArraysEv(i8);
 i1 = HEAP32[i8 + 336 >> 2] | 0;
 i2 = HEAP32[i8 + 332 >> 2] | 0;
 i3 = HEAP32[i8 + 284 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i7 = i3 + ((HEAP32[i2 + (i4 << 2) >> 2] | 0) * 12 | 0) + 8 | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -5;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i8 + 320 >> 2] | 0;
 i2 = HEAP32[i8 + 316 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[HEAP32[i8 + 264 >> 2] >> 2] | 0;
  i4 = HEAP32[HEAP32[i8 + 268 >> 2] >> 2] | 0;
  i5 = HEAP32[HEAP32[i8 + 272 >> 2] >> 2] | 0;
  i6 = HEAP32[HEAP32[i8 + 276 >> 2] >> 2] | 0;
  i7 = 0;
  do {
   i9 = HEAP32[i2 + (i7 << 2) >> 2] | 0;
   i10 = ~(1 << (i9 & 31));
   i9 = i9 >>> 5;
   i11 = i3 + (i9 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & i10;
   i11 = i4 + (i9 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & i10;
   i11 = i5 + (i9 << 2) | 0;
   HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & i10;
   i9 = i6 + (i9 << 2) | 0;
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & i10;
   i7 = i7 + 1 | 0;
  } while ((i7 | 0) != (i1 | 0));
 }
 if (HEAP8[i8 + 476 >> 0] | 0) if (!(HEAP8[i8 + 477 >> 0] | 0)) {
  HEAP8[i8 + 478 >> 0] = 0;
  return;
 }
 HEAP8[i8 + 478 >> 0] = 1;
 __ZN5physx16PxsIslandManager13updateIslandsEv(i8);
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim12statemachine21SelectorStateConstantEEEvRT_PKc17TransferMetaFlags(i10, i6, i1, i2) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 + 4;
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = i7;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags(i10, i8, 0);
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i10 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i5 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i5 = i2;
 }
 HEAP32[i6 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 12 | 0;
 i2 = i5 + 1 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 1);
  i8 = HEAP8[i8 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i10);
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP8[i5 >> 0] | 0;
  HEAP8[i8 >> 0] = i6;
  HEAP32[i7 >> 2] = i2;
  i8 = i6;
  HEAP8[i1 >> 0] = i8;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i10);
  STACKTOP = i9;
  return;
 }
}

function __ZN17GeneralConnection13MulticastInfo16SetLocalhostFlagEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = i10 + 16 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 if (!(__Z6GetIPsPA16_c(i1) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i9, gb + 459312 | 0) | 0; else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i9, i1) | 0;
 i3 = i8 + 12 | 0;
 if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i3, gb + 459312 | 0) | 0)) i1 = 1; else if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i3, gb + 661598 | 0) | 0)) i1 = 1; else {
  i1 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i6 = HEAP32[i8 + 16 >> 2] | 0; else i6 = i1 & 255;
  i5 = HEAP8[i9 + 11 >> 0] | 0;
  i4 = i5 << 24 >> 24 < 0;
  i5 = i4 ? HEAP32[i9 + 4 >> 2] | 0 : i5 & 255;
  if (i2) i2 = HEAP32[i3 >> 2] | 0; else i2 = i3;
  i3 = i5 >>> 0 < i6 >>> 0;
  i1 = i3 ? i5 : i6;
  if (!i1) i7 = 14; else {
   i1 = _memcmp(i2, i4 ? HEAP32[i9 >> 2] | 0 : i9, i1) | 0;
   if (!i1) i7 = 14;
  }
  if ((i7 | 0) == 14) i1 = i6 >>> 0 < i5 >>> 0 ? -1 : i3 & 1;
  i1 = (i1 | 0) == 0 & 1;
 }
 HEAP8[i8 + 53 >> 0] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 STACKTOP = i10;
 return;
}

function __ZN17GeneralConnection10Connection14ReceiveMessageEPNS_14NetworkMessageE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = i4 + 20 | 0;
 i7 = i4 + 17 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 if (i1 << 24 >> 24 == 0 ? (HEAP32[i4 + 92 >> 2] | 0) >>> 0 > 7 : 0) {
  HEAP8[i4 + 18 >> 0] = 1;
  i1 = i4 + 4 | 0;
  __ZN12SocketStream7RecvAllEPvjl(i6, i1, 8, 0) | 0;
  i1 = (HEAP16[i1 >> 1] | 0) == 20111 & 1;
  HEAP8[i7 >> 0] = i1;
 }
 if (!(i1 << 24 >> 24)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 i10 = HEAP32[i4 + 96 >> 2] | 0;
 i9 = i10 + 20 | 0;
 i8 = (HEAP32[i10 + 24 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i3 = HEAP32[i10 + 16 >> 2] | 0;
 i9 = i3 + -1 & HEAP32[i9 >> 2];
 i3 = i3 - i9 | 0;
 i8 = (i3 >>> 0 < i8 >>> 0 ? i3 : i8) >>> 0 < i2 >>> 0;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i10 >> 2] | 0) + i9;
 HEAP8[i4 + 16 >> 0] = i8 & 1;
 if (i8) {
  i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63560 | 0, 0, gb + 459188 | 0, 302) | 0;
  HEAP32[i3 >> 2] = i10;
  if (!(__ZN12SocketStream7RecvAllEPvjl(i6, i10, i2, 4e3) | 0)) {
   HEAP8[i7 >> 0] = 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63560 | 0);
   HEAP32[i3 >> 2] = 0;
   i10 = 0;
   return i10 | 0;
  }
 }
 i8 = i1;
 i9 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = i5;
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i10 + 4 >> 2] = i9;
 HEAP8[i7 >> 0] = 0;
 i10 = HEAP32[i3 >> 2] | 0;
 return i10 | 0;
}

function __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 16 | 0;
 i5 = i8;
 __ZN10systeminfo16GetProcessorTypeEv(i5);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i6 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i7 = i1;
   i7 = i7 + i4 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i7;
 }
 _memcpy(i1 | 0, i6 | 0, i4 | 0) | 0;
 i9 = i1;
 i9 = i9 + i4 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i8;
 return;
}

function __Z45Material_CUSTOM_INTERNAL_CALL_SetTextureScaleP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 44 | 0;
 i3 = i11 + 40 | 0;
 i7 = i11 + 24 | 0;
 i2 = i11 + 20 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i3 = __Z25ScriptingStringToPropertyR11ICallString(i3) | 0;
 if (!i5) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i12 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE(i7, i1, i4);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  HEAP32[i8 >> 2] = i3;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  i12 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i10 + 4 >> 2] = i12;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i1, i4, i9, i10);
  STACKTOP = i11;
  return;
 }
}

function __Z22Material_CUSTOM_GetTagP12Il2CppObjectP12Il2CppStringhS2_(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 40 | 0;
 i6 = i10 + 36 | 0;
 i7 = i10 + 24 | 0;
 i8 = i10 + 12 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZN11ICallStringC2EP12Il2CppString(i6, i2);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i10 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i5);
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i9, i6);
  __ZNK8Material6GetTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEbS8_(i7, i1, i8, i4 << 24 >> 24 == 0, i9);
  i6 = HEAP8[i7 + 11 >> 0] | 0;
  i5 = i6 << 24 >> 24 < 0;
  i6 = __Z20scripting_string_newPKcj(i5 ? HEAP32[i7 >> 2] | 0 : i7, i5 ? HEAP32[i7 + 4 >> 2] | 0 : i6 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i10;
  return i6 | 0;
 }
 return 0;
}

function _Ins_UNKNOWN(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i8 + 416 >> 2] | 0;
 i7 = HEAP32[i8 + 408 >> 2] | 0;
 i2 = i1 + (i7 * 24 | 0) | 0;
 L1 : do if ((i7 | 0) > 0) {
  i3 = HEAP8[i8 + 368 >> 0] | 0;
  i4 = i1;
  while (1) {
   if (i3 << 24 >> 24 == (HEAP32[i4 + 12 >> 2] & 255) << 24 >> 24) if (HEAP8[i4 + 16 >> 0] | 0) break;
   i1 = i4 + 24 | 0;
   if (i1 >>> 0 < i2 >>> 0) i4 = i1; else break L1;
  }
  i1 = i8 + 428 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) >= (HEAP32[i8 + 432 >> 2] | 0)) {
   HEAP32[i8 + 12 >> 2] = 130;
   return;
  }
  i5 = HEAP32[i8 + 436 >> 2] | 0;
  HEAP32[i1 >> 2] = i2 + 1;
  i6 = i8 + 352 | 0;
  HEAP32[i5 + (i2 << 4) >> 2] = HEAP32[i6 >> 2];
  i7 = i8 + 360 | 0;
  HEAP32[i5 + (i2 << 4) + 4 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  HEAP32[i5 + (i2 << 4) + 8 >> 2] = 1;
  HEAP32[i5 + (i2 << 4) + 12 >> 2] = i4;
  i5 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = i5 + -1 | 0;
  do if (i1 >>> 0 > 2) HEAP32[i8 + 12 >> 2] = 132; else {
   i3 = HEAP32[i8 + 444 + (i1 << 3) >> 2] | 0;
   if (!i3) {
    HEAP32[i8 + 12 >> 2] = 138;
    break;
   }
   i1 = HEAP32[i8 + 444 + (i1 << 3) + 4 >> 2] | 0;
   if ((i1 | 0) < (i2 | 0)) {
    HEAP32[i8 + 12 >> 2] = 131;
    break;
   } else {
    HEAP32[i8 + 356 >> 2] = i3;
    HEAP32[i8 + 364 >> 2] = i1;
    HEAP32[i7 >> 2] = i2;
    HEAP32[i6 >> 2] = i5;
    break;
   }
  } while (0);
  HEAP8[i8 + 376 >> 0] = 0;
  return;
 } while (0);
 HEAP32[i8 + 12 >> 2] = 128;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefIKhEE(i1, i12) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = (HEAP32[i12 + 4 >> 2] | 0) - (HEAP32[i12 >> 2] | 0) | 0;
 i9 = i1 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i10 = i5 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1;
 i8 = i2 - i3 | 0;
 i4 = i8 + 4 | 0;
 if (i4) {
  i7 = i5 + 20 | 0;
  if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i8 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
   }
   HEAP32[i6 >> 2] = i1;
   i2 = i1 + i8 | 0;
   HEAP32[i10 >> 2] = i2;
   HEAP32[i7 >> 2] = i1 + i4;
  }
 }
 HEAP32[i10 >> 2] = i2 + 4;
 i10 = i1 + i8 | 0;
 HEAP8[i10 >> 0] = i11;
 HEAP8[i10 + 1 >> 0] = i11 >> 8;
 HEAP8[i10 + 2 >> 0] = i11 >> 16;
 HEAP8[i10 + 3 >> 0] = i11 >> 24;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i9 >> 2] | 0, HEAP32[i12 >> 2] | 0, i11);
 return;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImpl11setListenerEPNS_20PxAllocationListenerE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i5 + 56 | 0;
 HEAP32[i9 >> 2] = i1;
 if (!i1) return;
 i8 = i5 + 28 | 0;
 L4 : do if (!(HEAP32[i5 + 32 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i5 + 36 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L4;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i6 = i5 + 20 | 0;
 i7 = i5 + 24 | 0;
 i4 = i5 + 36 | 0;
 L11 : while (1) {
  do {
   if ((i1 | 0) == -1) break L11;
   i5 = HEAP32[i6 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   mftCall_viiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i5 + (i1 << 5) + 16 >> 2] | 0, HEAP32[i5 + (i1 << 5) + 20 >> 2] | 0, HEAP32[i5 + (i1 << 5) + 24 >> 2] | 0, HEAP32[i5 + (i1 << 5) + 28 >> 2] | 0, HEAP32[i5 + (i1 << 5) + 8 >> 2] | 0);
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L11;
   }
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i1 = i2; else continue L11;
  }
 }
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 36 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -36 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN13MonoBehaviour22StartCoroutineManaged2EP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8 + 8 | 0;
 i3 = i8 + 12 | 0;
 i4 = i8;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 if (i5 | 0) if (__ZNK10GameObject8IsActiveEv(i5) | 0) {
  i5 = gb + 1164176 | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  i7 = i4;
  HEAP32[i7 >> 2] = i9;
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i1, i2, i6, i3) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
  HEAP32[i1 + 48 >> 2] = 1;
  i9 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 132 >> 2] | 0) | 0;
  HEAP32[i9 + 8 >> 2] = i1;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 __Z6FormatPKcz(i6, gb + 587757 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 587199 | 0, 769, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i9 = 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = i1 + 32 | 0;
 i1 = __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE4FindERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEE(i4, i2) | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = 0;
 while (1) {
  i3 = i1 << 1;
  i1 = i1 + 1 | 0;
  if (!(_strcmp(HEAP32[gb + 67868 + (i3 << 2) >> 2] | 0, i2) | 0)) break;
  if ((i1 | 0) >= 78) {
   i1 = 0;
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) {
  STACKTOP = i7;
  return i1 | 0;
 }
 i6 = HEAP32[gb + 67868 + ((i3 | 1) << 2) >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i6, _strlen(i6) | 0);
 i6 = __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE4FindERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEE(i4, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i7;
 return i6 | 0;
}

function __Z32AddAllowComponentReplacementIMPLi(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = HEAP32[gb + 1162556 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i6 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i6 | 0)) {
     i2 = 9;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 i1 = __Znwj(20) | 0;
 HEAP32[i1 + 16 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 STACKTOP = i8;
 return;
}

function __ZN9GfxDevice16EndAsyncJobFrameEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i2 = i9;
 if ((HEAP16[gb + 1157632 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157632 | 0, i1);
  i5 = gb + 1157632 | 0;
 } else i5 = 0;
 i7 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 648 >> 2] | 0, i7 | 0, HEAP32[gb + 1157632 >> 2] | 0);
 i7 = i8 + 4472 | 0;
 i6 = i8 + 4484 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    i4 = i3 + (i1 << 3) | 0;
    if (HEAP32[i4 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i4);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
  i1 = i8 + 4488 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i8 + 4476 | 0);
   HEAP32[i7 >> 2] = 0;
  }
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 if (HEAP8[(__Z17GetPlayerSettingsv() | 0) + 415 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 492 >> 2] | 0, i8 | 0);
 i8 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 652 >> 2] | 0, i8 | 0);
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i9;
 return;
}

function __ZN9GfxDevice13AddBatchStatsE17GfxBatchStatsTypeiiiy(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 switch (i2 | 0) {
 case 0:
  {
   if (!(HEAP8[i1 + 3896 >> 0] | 0)) return;
   i7 = i1 + 3676 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = i1 + 3680 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i5;
   i7 = i1 + 3684 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i3;
   i7 = i1 + 3688 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
   return;
  }
 case 1:
  {
   if (!(HEAP8[i1 + 3896 >> 0] | 0)) return;
   i2 = i1 + 3660 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   i2 = i1 + 3664 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
   i2 = i1 + 3720 | 0;
   i5 = i2;
   i5 = _i64Add(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i6 | 0, i7 | 0) | 0;
   i6 = getTempRet0() | 0;
   i7 = i2;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = i1 + 3668 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i3;
   i7 = i1 + 3672 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
   return;
  }
 case 2:
  {
   if (!(HEAP8[i1 + 3896 >> 0] | 0)) return;
   i7 = i1 + 3692 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
   i7 = i1 + 3696 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i5;
   i7 = i1 + 3700 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i3;
   i7 = i1 + 3704 | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 16 | 0;
 i6 = i9 + 12 | 0;
 i8 = i9;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc(i4, i8, i6);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 mftCall_vii(i6 | 0, i7 | 0, i4 | 0);
 STACKTOP = i9;
 return;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 744763 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 92 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738066 | 0, gb + 738082 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN4File19OpenFileSystemEntryERK15FileSystemEntryNS_10PermissionENS_12AutoBehaviorE(i6, i2, i7, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i8 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  __ZN13FileEntryDataD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  __ZN12FileAccessor5CloseEv(i1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i3 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(1060, gb + 63528 | 0, 16, gb + 488614 | 0, 395) | 0;
 i1 = i3 + 1040 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __ZN13FileEntryDataaSERKS_(i3, i2) | 0;
 HEAP32[i6 >> 2] = i3;
 i3 = __ZnwjRK10MemLabelIdiPKci(1068, gb + 63528 | 0, 16, gb + 488614 | 0, 396) | 0;
 __ZN12FileAccessorC2Ev(i3);
 HEAP32[i4 >> 2] = i3;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i5 & 2 | 0 ? 5 : 0;
 while (1) {
  if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i3, i2, i7, 0) | 0) {
   i1 = 1;
   i8 = 11;
   break;
  }
  if ((i1 | 0) > 1) i1 = i1 + -1 | 0; else break;
 }
 if ((i8 | 0) == 11) return i1 | 0;
 __ZN4File5CloseEv(i6) | 0;
 i8 = 0;
 return i8 | 0;
}

function __ZN16Physics2DManager11LinecastAllERK8Vector2fS2_iffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE(i1, i5, i6, i4, f2, f11, i7, i12, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 f11 = Math_fround(f11);
 i7 = i7 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 var f3 = f0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13 + 8 | 0;
 i1 = i13;
 if ((HEAP16[gb + 1457620 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457620 | 0, i9);
  i10 = gb + 1457620 | 0;
 } else i10 = 0;
 HEAP32[i9 >> 2] = gb + 156148 + 8;
 HEAP32[i9 + 4 >> 2] = i4;
 i1 = i9 + 8 | 0;
 i4 = i9 + 12 | 0;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i9 + 24 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i9 + 28 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 32 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i9 + 36 >> 2] = i8;
 i8 = f2 == Math_fround(-inf);
 f3 = i8 ? Math_fround(-3402823469999999843913219.0e14) : f2;
 HEAPF32[i1 >> 2] = f3;
 i8 = f11 == Math_fround(inf);
 f2 = i8 ? Math_fround(3402823469999999843913219.0e14) : f11;
 HEAPF32[i4 >> 2] = f2;
 if (!(f3 < f2)) {
  HEAPF32[i1 >> 2] = f2;
  HEAPF32[i4 >> 2] = f3;
 }
 i1 = __ZN14Raycast2DQuery8RunQueryEb(i9, i12) | 0;
 if (!i10) {
  STACKTOP = i13;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i10);
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 12 | 0;
 i2 = (i1 | 0) / 12 | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 12 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 12 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i6 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 * 12 | 0;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i3);
 i6 = i3 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i7 + 388 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN14LineParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i7 + 384 >> 2] | 0, i3);
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 }
 HEAP32[i7 + 392 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i4 = HEAP8[i3 >> 0] | 0;
  HEAP8[i5 >> 0] = i4;
  HEAP32[i6 >> 2] = i1;
  i1 = i4;
 }
 HEAP8[i7 + 396 >> 0] = i1;
 if (i1 << 24 >> 24) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i7 + 341 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN13NavMeshParams8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932905 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843623 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843638 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843653 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843667 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 8 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 8);
  return;
 } else {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i3 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i3 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i3 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i3 + 3 >> 0];
  HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i3 + 4 >> 0];
  HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i3 + 5 >> 0];
  HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i3 + 6 >> 0];
  HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i3 + 7 >> 0];
  HEAPF64[tempDoublePtr >> 3] = +HEAPF64[tempDoublePtr >> 3];
  HEAP8[i1 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i1 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i1 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i1 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i1 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i1 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i1 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i1 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 8;
  return;
 }
}

function __ZNSt3__25stoulERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1084457 | 0, 5);
 HEAP32[i7 >> 2] = 0;
 i2 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = ___errno_location() | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 516 | 0, i2 | 0, i7 | 0, i5 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
  if ((i5 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i8 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) break;
  }
  if ((HEAP32[i7 >> 2] | 0) == (i2 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i8 | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = (HEAP32[i7 >> 2] | 0) - i2 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 ___resumeException(i9 | 0);
 return 0;
}

function __ZN9Coroutine23ProcessCoroutineCurrentEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 256 | 0;
 i7 = i6 + 252 | 0;
 i2 = i6;
 i8 = i6 + 240 | 0;
 i5 = i6 + 248 | 0;
 HEAP32[i7 >> 2] = 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i11 = i4 + 32 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i2, i1, i3);
 i1 = i4 + 40 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 216 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i2 + 220 >> 2] = __ZNK13MonoBehaviour8GetClassEv(i8) | 0;
 i2 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i2, i7, 0) | 0;
 if (HEAP32[i7 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 if (i2 | 0) {
  __ZN9Coroutine35HandleIEnumerableCurrentReturnValueEP12Il2CppObject(i4, i2);
  STACKTOP = i6;
  return;
 }
 i11 = i4 + 44 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 592 | 0, i3, Math_fround(0.0), i4, Math_fround(0.0), fb + 1577 | 0, 10);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4gles22UploadTexture2DSubDataEP7ApiGLESj13TextureFormatPKviiiii17TextureColorSpace(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i12 = 0, i13 = 0;
 i3 = __ZN12_GLOBAL__N_112UploadFormatE13TextureFormat(i4) | 0;
 __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(HEAP32[gb + 1451096 >> 2] | 0, i2, 2, 0, 4);
 if ((i3 | 0) == (i4 | 0)) {
  __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv(i1, i2, 2, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i1 + 860 >> 2] | 0, i4, i11) | 0, i6, i7, i8, 0, i9, i10, 1, 0, i5);
  return;
 } else {
  i13 = __Z33GetMinimumTextureMipSizeForFormat13TextureFormat(i4) | 0;
  i13 = __Z18CalculateImageSizeii13TextureFormat((i13 | 0) > (i9 | 0) ? i13 : i9, (i13 | 0) > (i10 | 0) ? i13 : i10, i3) | 0;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i13, 1, gb + 64016 | 0, 0, gb + 609603 | 0, 318) | 0;
  __ZN12_GLOBAL__N_127ConvertUncompressedMipLevelE13TextureFormatS0_iiiPKvPv(i4, i3, i9, i10, 1, i5, i12);
  __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv(i1, i2, 2, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[i1 + 860 >> 2] | 0, i3, i11) | 0, i6, i7, i8, 0, i9, i10, 1, i13, i12);
  __Z19free_alloc_internalPvRK10MemLabelId(i12, gb + 64016 | 0);
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags(i9, i4, i1) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i3;
  i1 = i5;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i4, i1, i9 + 8 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i5 = i1 + (i4 * 40 | 0) | 0;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i9, i1 + 4 | 0, gb + 402843 | 0, 0);
  i2 = i1 + 20 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 >> 2] = i4;
  }
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 24 | 0, i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN13dynamic_arrayIN9ShaderLab16FastPropertyNameELj4EEC2ERKS2_RK10MemLabelId(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN11MonoManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 66624 + 8;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = i1 + 184;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 __Z22SetManagerPtrInContextiP6Object(5, i1);
 HEAP32[i1 >> 2] = gb + 66480 + 8;
 i3 = i1 + 212 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 _il2cpp_set_find_plugin_callback(fb + 1580 | 0);
 STACKTOP = i4;
 return;
}

function __ZL34GetComponentsImplementationRecurseILb1ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0;
 HEAP32[HEAP32[i9 >> 2] >> 2] = 0;
 if (i7) i1 = 3; else if (__ZNK10GameObject8IsActiveEv(i6) | 0) i1 = 3;
 L3 : do if ((i1 | 0) == 3) {
  i1 = HEAP32[i6 + 28 >> 2] | 0;
  i5 = HEAP32[i6 + 40 >> 2] | 0;
  i4 = i1 + (i5 << 3) | 0;
  if (i5 | 0) {
   i5 = i8 + 8 | 0;
   while (1) {
    i3 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0;
    if ((i2 | 0) == (gb + 27592 | 0)) i2 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i1 + 4 >> 2] | 0) | 0; else {
     i10 = __Z21GetManagerFromContexti(5) | 0;
     i2 = HEAP32[(HEAP32[i10 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0;
    }
    if (i2 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, i3) | 0) break;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i4 | 0)) break L3;
   }
   HEAP32[HEAP32[i9 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
   i10 = 1;
   return i10 | 0;
  }
 } while (0);
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i6, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = __ZL34GetComponentsImplementationRecurseILb1ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i7, i8, i9) | 0;
 return i10 | 0;
}

function __Z30AddAllowsMultipleInclusionIMPLi(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = HEAP32[gb + 1162552 >> 2] | 0;
 i2 = i7 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  HEAP32[i3 >> 2] = i2;
  i5 = i2;
  i3 = i2;
 } else {
  while (1) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if ((i2 | 0) > (i6 | 0)) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = 4;
     break;
    } else i1 = i2;
   } else {
    if ((i2 | 0) >= (i6 | 0)) {
     i2 = 9;
     break;
    }
    i4 = i1 + 4 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    if (!i2) {
     i2 = 8;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == 4) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 8) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   i3 = i4;
   break;
  } else if ((i2 | 0) == 9) {
   HEAP32[i3 >> 2] = i1;
   i5 = i1;
   break;
  }
 } while (0);
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i8;
  return;
 }
 i1 = __Znwj(20) | 0;
 HEAP32[i1 + 16 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i1);
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 STACKTOP = i8;
 return;
}

function _UNITY_FT_DivFix(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i1 >> 31;
 i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i6 = (i2 | 0) < 0;
 i7 = i6 ? 0 - (i7 | 1) | 0 : i7;
 i6 = i6 ? 0 - i2 | 0 : i2;
 if (!i6) {
  i6 = 2147483647;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 if (i1 >>> 0 <= (i6 >>> 17 ^ 65535) >>> 0) {
  i6 = (((i6 >>> 1) + (i1 << 16) | 0) >>> 0) / (i6 >>> 0) | 0;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 i5 = i1 << 16;
 i3 = (i6 >>> 1) + i5 | 0;
 i1 = (i3 >>> 0 < i5 >>> 0 & 1) + (i1 >>> 16) | 0;
 if (i1 >>> 0 >= i6 >>> 0) {
  i6 = 2147483647;
  i5 = (i7 | 0) < 0;
  i7 = 0 - i6 | 0;
  i7 = i5 ? i7 : i6;
  return i7 | 0;
 }
 i8 = i1 >>> 0 > 65535;
 i4 = i8 ? i1 >>> 16 : i1;
 i8 = i8 ? 16 : 0;
 i5 = (i4 & 65280 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 8;
 i8 = i5 ? i8 : i8 | 8;
 i5 = (i4 & 240 | 0) == 0;
 i4 = i5 ? i4 : i4 >>> 4;
 i8 = i5 ? i8 : i8 | 4;
 i5 = (i4 & 12 | 0) == 0;
 i4 = 31 - (i5 ? i8 : i8 | 2) - ((i5 ? i4 : i4 >>> 2) >>> 1 & 1) | 0;
 i5 = 32 - i4 | 0;
 i8 = i3 >>> i5 | i1 << i4;
 i2 = (i8 >>> 0) / (i6 >>> 0) | 0;
 i1 = i2;
 i2 = i8 - (Math_imul(i2, i6) | 0) | 0;
 i4 = i3 << i4;
 while (1) {
  i2 = i2 << 1 | i4 >>> 31;
  i3 = i2 >>> 0 < i6 >>> 0;
  i1 = (i3 & 1 | i1 << 1) ^ 1;
  i5 = i5 + -1 | 0;
  if (!i5) break; else {
   i2 = i2 - (i3 ? 0 : i6) | 0;
   i4 = i4 << 1;
  }
 }
 i7 = (i7 | 0) < 0;
 i8 = 0 - i1 | 0;
 i8 = i7 ? i8 : i1;
 return i8 | 0;
}

function __ZNSt3__24stofERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084476 | 0, 4);
 HEAP32[i6 >> 2] = 0;
 i4 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = ___errno_location() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 __THREW__ = 0;
 f3 = Math_fround(+invoke_fii(fb + 45 | 0, i4 | 0, i6 | 0));
 i9 = __THREW__;
 __THREW__ = 0;
 do if (!(i9 & 1)) {
  i9 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  if ((i9 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if (i5 | 0) HEAP32[i5 >> 2] = (HEAP32[i6 >> 2] | 0) - i4 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return Math_fround(f3);
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i9 | 0);
 return f0;
}

function __ZN8Playable12SetPlayStateE9PlayState(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 248 | 0;
 i3 = i7;
 i4 = i7 + 240 | 0;
 HEAP32[i2 + 12 >> 2] = i6;
 i1 = i2 + 24 | 0;
 do if ((HEAP16[i1 >> 1] | 0) > 0) {
  i8 = __Z18GetDirectorManagerv() | 0;
  i1 = (__ZNK15DirectorManager16GetScriptMethodsEs(i8, HEAP16[i1 >> 1] | 0) | 0) + 24 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i7;
   return;
  } else {
   i8 = HEAP32[i2 + 4 >> 2] | 0;
   i10 = i1;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i9;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i8, i5);
   __ZN18ScriptingArguments7AddEnumEi(i3, i6);
   HEAP32[i5 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
   break;
  }
 } while (0);
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 do {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (i2) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i6 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != ((HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 28 >> 2] << 3) | 0));
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_(i8, i1, i3, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = gb + 1576256;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_17MemoryEventHeaderE(i2, i8 + 48 | 0, i3);
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = _strlen(i2) | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i3 + 1 | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, gb + 773740 | 0, gb + 773752 | 0, 57) | 0;
 do if (!((i3 | 0) == 0 | ((i4 | 0) == 0 | (i2 | 0) == 0))) {
  i1 = _strlen(i2) | 0;
  if (i1 >>> 0 < i3 >>> 0) {
   _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
   HEAP8[i4 + i1 >> 0] = 0;
   break;
  } else {
   HEAP8[i4 >> 0] = 0;
   break;
  }
 } while (0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i8 + 4 | 0, i5, i6) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = i4;
  STACKTOP = i7;
  return;
 } else {
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_(i8, i1, i3, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = gb + 1576256;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_17MemoryEventHeaderE(i2, i8 + 48 | 0, i3);
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = _strlen(i2) | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i3 + 1 | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, gb + 773740 | 0, gb + 773752 | 0, 57) | 0;
 do if (!((i3 | 0) == 0 | ((i4 | 0) == 0 | (i2 | 0) == 0))) {
  i1 = _strlen(i2) | 0;
  if (i1 >>> 0 < i3 >>> 0) {
   _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
   HEAP8[i4 + i1 >> 0] = 0;
   break;
  } else {
   HEAP8[i4 >> 0] = 0;
   break;
  }
 } while (0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i8 + 4 | 0, i5, i6) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 >> 2] = i4;
  STACKTOP = i7;
  return;
 } else {
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10eventValueEtyx(i11, i6, i4, i5, i1, i2) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i12 + 24 | 0;
 i3 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i7 = HEAP32[i11 + 72 >> 2] | 0;
 i8 = (i7 | 0) == 0;
 if (!i8) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
 i13 = i9;
 HEAP32[i13 >> 2] = i1;
 HEAP32[i13 + 4 >> 2] = i2;
 i2 = i9 + 8 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i9 + 16 >> 2] = i3;
 HEAP8[i10 >> 0] = 5;
 i2 = i10 + 1 | 0;
 HEAP16[i10 + 2 >> 1] = i6;
 HEAP8[i2 >> 0] = 3;
 if (i5 >>> 0 < 0 | (i5 | 0) == 0 & i4 >>> 0 < 256) i1 = 3; else if (i5 >>> 0 < 0 | (i5 | 0) == 0 & i4 >>> 0 < 65536) i1 = 7; else i1 = i5 >>> 0 < 1 | (i5 | 0) == 1 & i4 >>> 0 < 0 ? 11 : 15;
 HEAP8[i2 >> 0] = i1;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10EventValueEEEvRNS0_11EventHeaderERT_(i11, i10, i9);
 if (i8) {
  STACKTOP = i12;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 674330 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 264 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 260 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 268 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 256 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Scb10Constraint9setBodiesEPNS0_11RigidObjectES3_(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) i7 = 0; else i7 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0;
 if (!i2) i6 = 0; else i6 = (HEAP32[gb + 90260 + 24 + (((HEAP32[i2 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i2 | 0;
 i5 = i8 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 7;
   break;
  }
 default:
  i4 = 7;
 }
 if ((i4 | 0) == 7) {
  i5 = i8 + 12 | 0;
  __ZN5physx2Sc14ConstraintCore19prepareForSetBodiesEv(i5);
  __ZN5physx2Sc14ConstraintCore9setBodiesEPNS0_9RigidCoreES3_(i5, i7, i6);
  i8 = i8 + 84 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  HEAP32[i8 + 20 >> 2] = 0;
  return;
 }
 i2 = i8 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i8 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i8 >> 2] | 0, i8);
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1;
 i8 = i8 + 84 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN21AnimationClipPlayableC2E18DirectorPlayerType(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i2 = i3;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i5, 0, 0);
 HEAP32[i5 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i5 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i2);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i5 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP8[i5 + 72 >> 0] = 0;
 HEAP8[i5 + 73 >> 0] = 0;
 HEAP8[i5 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i5 + 76 | 0);
 HEAP32[i5 >> 2] = gb + 177348 + 8;
 HEAP32[i5 + 80 >> 2] = gb + 177492 + 8;
 i1 = i5 + 84 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i5 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 108 >> 2] = Math_fround(0.0);
 HEAP8[i5 + 112 >> 0] = 0;
 HEAP8[i5 + 113 >> 0] = 1;
 HEAP32[i5 + 116 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 128;
 i1 = i5 + 168 | 0;
 i2 = i5 + 124 | 0;
 i4 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAP8[i5 + 172 >> 0] = 1;
 HEAP8[i5 + 173 >> 0] = 0;
 HEAP32[i5 + 48 >> 2] = 1;
 STACKTOP = i3;
 return;
}

function __ZN13dynamic_arrayIP26AnimatorControllerPlayableLj4EEC2ERKS2_RK10MemLabelId(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN12HingeJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 __ZN7Joint2D16CheckConsistencyEv(i2);
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 84 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i5 = gb + 1162356 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i5 = i2 + 96 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(-1.0e6);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(-1.0e6) : f6;
 i5 = i2 + 100 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f6;
 i5 = i2 + 104 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(-1.0e6);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(-1.0e6) : f6;
 i5 = i2 + 108 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(-1.0e6);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(-1.0e6) : f6;
 return;
}

function __ZN11JointLimits8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843849 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843853 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 736381 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744985 | 0, i5, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z46Material_CUSTOM_INTERNAL_CALL_SetTextureOffsetP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 44 | 0;
 i3 = i11 + 40 | 0;
 i7 = i11 + 24 | 0;
 i2 = i11 + 20 | 0;
 i8 = i11 + 16 | 0;
 i9 = i11 + 8 | 0;
 i10 = i11;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i3 = __Z25ScriptingStringToPropertyR11ICallString(i3) | 0;
 if (!i5) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i12 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE(i7, i1, i4);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  HEAP32[i8 >> 2] = i3;
  i12 = HEAP32[i7 + 4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 4 >> 2] = i12;
  HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_(i1, i4, i9, i10);
  STACKTOP = i11;
  return;
 }
}

function _UNITY_png_free_jmpbuf(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = 4;
 i8 = _malloc(40) | 0;
 HEAP32[i8 >> 2] = 0;
 i5 = i11;
 if (!i4) {
  _free(i8 | 0);
  STACKTOP = i11;
  return;
 }
 i6 = i4 + 160 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + 164 | 0;
 if (i7 | 0) if (!((i7 | 0) == (i4 | 0) | (HEAP32[i3 >> 2] | 0) == 0)) {
  i8 = _saveSetjmp(i5, 1, i8 | 0, i9 | 0) | 0;
  i9 = getTempRet0() | 0;
  __THREW__ = 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
   i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i8 | 0, i9 | 0) | 0;
   if (!i2) _longjmp(i1 | 0, threwValue | 0);
   setTempRet0(threwValue | 0);
  } else i2 = -1;
  i1 = getTempRet0() | 0;
  if ((i2 | 0) != 1) i1 = 0;
  while (1) {
   if (i1 | 0) break;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 + 156 >> 2] = fb + 2356;
   __THREW__ = 0;
   invoke_vii(fb + 2358 | 0, i4 | 0, i7 | 0);
   i1 = __THREW__;
   __THREW__ = 0;
   if ((i1 | 0) != 0 & (threwValue | 0) != 0) {
    i2 = _testSetjmp(HEAP32[i1 >> 2] | 0, i8 | 0, i9 | 0) | 0;
    if (!i2) _longjmp(i1 | 0, threwValue | 0);
    setTempRet0(threwValue | 0);
   } else i2 = -1;
   i1 = getTempRet0() | 0;
   if ((i2 | 0) != 1) {
    i10 = 8;
    break;
   }
  }
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 + 156 >> 2] = 0;
 _free(i8 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 40 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -40 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx21PxsBodyTransformVault10removeBodyERKNS_11PxsBodyCoreE(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i6 = i5;
 i6 = i6 + ~(i6 << 15) | 0;
 i6 = (i6 >>> 10 ^ i6) * 9 | 0;
 i6 = i6 >>> 6 ^ i6;
 i6 = i6 + ~(i6 << 11) | 0;
 i6 = i7 + (((i6 >>> 16 ^ i6) & 1023) << 2) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 L1 : do if (!i2) {
  i1 = 0;
  i4 = 0;
 } else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  if (!i1) {
   i1 = i2;
   i4 = 0;
  } else {
   i4 = 0;
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 28 >> 2] | 0) == (i5 | 0)) {
     i1 = i3;
     break L1;
    }
    i2 = HEAP32[i1 + 32 >> 2] | 0;
    if (!i2) {
     i4 = i3;
     break;
    } else {
     i8 = i1;
     i4 = i3;
     i1 = i2;
     i3 = i8;
    }
   }
  }
 } while (0);
 i2 = i1 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != 1) {
  HEAP32[i2 >> 2] = i3 + -1;
  return;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i4) HEAP32[i6 >> 2] = i2; else HEAP32[i4 + 32 >> 2] = i2;
 i8 = i7 + 4376 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 i8 = i7 + 4388 | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i1;
 i1 = i7 + 4380 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i8 + 1;
 if ((i8 | 0) >= ((HEAP32[i7 + 4372 >> 2] | 0) * 50 | 0)) {
  __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i7 + 4096 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i8 = i7 + 4392 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 return;
}

function __ZN4crnd25static_huffman_data_model22prepare_decoder_tablesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i3 = i8 + 16 | 0;
 i4 = i8 + 12 | 0;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i6 = i7 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 180;
  i1 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, 0, 180, i4 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  if ((i1 | 0) == 0 | (HEAP32[i4 >> 2] | 0) >>> 0 < 180) {
   HEAP32[i5 >> 2] = gb + 401209;
   HEAP32[i5 + 4 >> 2] = 2513;
   HEAP32[i5 + 8 >> 2] = gb + 401368;
   _sprintf(i3, gb + 401176 | 0, i5) | 0;
   _puts(i3) | 0;
   i1 = 0;
  } else {
   i5 = i1 + 164 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
  }
  HEAP32[i6 >> 2] = i1;
  i6 = HEAP32[i7 >> 2] | 0;
 } else i6 = i2;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 if (i6 >>> 0 > 16) {
  i2 = i6;
  i3 = 0;
 } else {
  i7 = 0;
  i7 = __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj(i1, i6, i4, i7) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 while (1) {
  i5 = i3 + 1 | 0;
  if (i2 >>> 0 > 3) {
   i2 = i2 >>> 1;
   i3 = i5;
  } else break;
 }
 i7 = i3 + 2 + ((i5 | 0) != 32 & 1 << i5 >>> 0 < i6 >>> 0 & 1) | 0;
 i7 = (i7 >>> 0 < 11 ? i7 : 11) & 255;
 i7 = __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj(i1, i6, i4, i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14OcclusionScene8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379057 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379072 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379086 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379099 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 16 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379111 | 0, gb + 863904 | 0, i1, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z28BlitCopyCompressedDXT1ToDXT5PKhiiPhii(i6, i4, i5, i3, i2, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = (i4 + 3 | 0) / 4 | 0;
 i10 = (i5 + 3 | 0) / 4 | 0;
 i8 = i9 << 3;
 i7 = ((i2 + 3 | 0) / 4 | 0) << 4;
 if ((i5 | 0) > 0 & (i4 | 0) > 0) {
  i4 = 0;
  i1 = i6;
 } else return;
 while (1) {
  i2 = 0;
  do {
   i6 = i3 + (i2 << 4) | 0;
   i5 = i6;
   i12 = i5;
   HEAP8[i12 >> 0] = -1;
   HEAP8[i12 + 1 >> 0] = -1 >> 8;
   HEAP8[i12 + 2 >> 0] = -1 >> 16;
   HEAP8[i12 + 3 >> 0] = -1 >> 24;
   i5 = i5 + 4 | 0;
   HEAP8[i5 >> 0] = -1;
   HEAP8[i5 + 1 >> 0] = -1 >> 8;
   HEAP8[i5 + 2 >> 0] = -1 >> 16;
   HEAP8[i5 + 3 >> 0] = -1 >> 24;
   i5 = i1 + (i2 << 3) | 0;
   i12 = i5;
   i12 = HEAPU8[i12 >> 0] | HEAPU8[i12 + 1 >> 0] << 8 | HEAPU8[i12 + 2 >> 0] << 16 | HEAPU8[i12 + 3 >> 0] << 24;
   i5 = i5 + 4 | 0;
   i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
   i6 = i6 + 8 | 0;
   i11 = i6;
   HEAP8[i11 >> 0] = i12;
   HEAP8[i11 + 1 >> 0] = i12 >> 8;
   HEAP8[i11 + 2 >> 0] = i12 >> 16;
   HEAP8[i11 + 3 >> 0] = i12 >> 24;
   i6 = i6 + 4 | 0;
   HEAP8[i6 >> 0] = i5;
   HEAP8[i6 + 1 >> 0] = i5 >> 8;
   HEAP8[i6 + 2 >> 0] = i5 >> 16;
   HEAP8[i6 + 3 >> 0] = i5 >> 24;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i9 | 0));
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (i10 | 0)) break; else {
   i3 = i3 + i7 | 0;
   i1 = i1 + i8 | 0;
  }
 }
 return;
}

function __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f8 * Math_fround(2.0));
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f9 * Math_fround(2.0));
 f4 = Math_fround(f8 * f5);
 f3 = Math_fround(f6 * f7);
 f9 = Math_fround(f9 * f10);
 f11 = Math_fround(f8 * f7);
 f8 = Math_fround(f8 * f10);
 f6 = Math_fround(f6 * f10);
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f5 = Math_fround(f5 * f12);
 f7 = Math_fround(f7 * f12);
 f10 = Math_fround(f12 * f10);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f3 + f9));
 HEAPF32[i2 + 4 >> 2] = Math_fround(f11 + f10);
 HEAPF32[i2 + 8 >> 2] = Math_fround(f8 - f7);
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i2 + 20 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f4 + f9));
 HEAPF32[i2 + 24 >> 2] = Math_fround(f6 + f5);
 HEAPF32[i2 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 32 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i2 + 36 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i2 + 40 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f4 + f3));
 i1 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i2 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 120 | 0, i6);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, gb + 673520 | 0);
 __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i5, HEAP32[i5 + 24 >> 2] | 0, i1 + 136 | 0, 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 3 | 0;
 return i6 | 0;
}

function __ZNK16CrashReportEvent12ToJsonStringEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i7 = gb + 63648 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP8[i1 + 4 >> 0] = 0;
 __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i4, 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1039646 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 16 | 0, gb + 1039657 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 32 | 0, gb + 1039665 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 48 | 0, gb + 1039677 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 64 | 0, gb + 1039685 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 80 | 0, gb + 1040286 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2 + 96 | 0, gb + 1039688 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i2 + 112 | 0, gb + 1039692 | 0, 0);
 __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb(i4, i1, 0);
 __ZN9JSONWriteD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx13PxcRunNpBatchEjjjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE(i24, i20, i22, i23, i21, i3, i11, i12, i19, i9, i17, i7, i15, i8, i16, i10, i18, i5, i13, i6, i14, i1, i2, i27, i26, i4, i25) {
 i24 = i24 | 0;
 i20 = i20 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i21 = i21 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i19 = i19 | 0;
 i9 = i9 | 0;
 i17 = i17 | 0;
 i7 = i7 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 i10 = i10 | 0;
 i18 = i18 | 0;
 i5 = i5 | 0;
 i13 = i13 | 0;
 i6 = i6 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i27 = i27 | 0;
 i26 = i26 | 0;
 i4 = i4 | 0;
 i25 = i25 | 0;
 HEAP32[i27 >> 2] = 0;
 HEAP32[i26 >> 2] = 0;
 i25 = (i3 | 0) == 0 ? 0 : i3 + 16 | 0;
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i9, 0, i17, i1, i2, i27, i26);
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i7, 0, i15, i1, i2, i27, i26);
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i8, 0, i16, i1, i2, i27, i26);
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i10, 0, i18, i1, i2, i27, i26);
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i5, 0, i13, i1, i2, i27, i26);
 __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i25, i6, 0, i14, i1, i2, i27, i26);
 return;
}

function __ZN5physx13GuMeshFactory18createTriangleMeshERNS_13PxInputStreamE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i8 | 0, i3 | 0, 240, (i6 ? gb + 724718 | 0 : gb + 837976 | 0) | 0, gb + 724079 | 0, 106) | 0;
 __ZN5physx2Gu12TriangleMeshC2Ev(i6);
 if (!i6) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i6 + 224 >> 2] = i4;
 if (__ZN5physx2Gu12TriangleMesh4loadERNS_13PxInputStreamE(i6, i1) | 0) {
  HEAP32[i2 >> 2] = i6;
  i3 = i4 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 8 | 0, i2, i5) | 0;
  if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i8 = i6;
  STACKTOP = i7;
  return i8 | 0;
 } else {
  i1 = i6 + 8 | 0;
  if (__ZN5physx6shdfnd15atomicDecrementEPVi(i6 + 12 | 0) | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN22RenderingCommandBuffer23AddSetGlobalMatrixArrayERKN9ShaderLab16FastPropertyNameEPK10Matrix4x4fi(i10, i1, i11, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 24 | 0;
 i3 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i3 + 4 | 0;
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i2);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 i5 = i10 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + i3 >> 2] = 18;
 i3 = i3 + 7 & -4;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i2;
 HEAP32[i9 >> 2] = i4;
 i1 = i1 + i3 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i1 + (i12 << 6) | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i1, i2);
 HEAP32[i9 >> 2] = i2;
 i2 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
 if ((i12 | 0) > 0) i1 = 0; else {
  i12 = i10 + 36 | 0;
  HEAP8[i12 >> 0] = 1;
  return;
 }
 do {
  i3 = i2 + (i1 << 6) | 0;
  i4 = i11 + (i1 << 6) | 0;
  i5 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 i12 = i10 + 36 | 0;
 HEAP8[i12 >> 0] = 1;
 return;
}

function __ZN16HumanPoseHandlerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 178900 + 8;
 i3 = i1 + 24 | 0;
 i2 = i1 + 4 | 0;
 __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 28 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 32 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 36 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 40 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 44 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 48 | 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 + 52 >> 2] | 0, i2);
 __ZdlPv(i1);
 return;
}

function __Z55Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToAxisAngleRadRK11QuaternionfP8Vector3fPf(i2, i9, i10) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f8 * f8);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * f7));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f3 * f3));
 f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f1 * f1))));
 if (f6 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f5 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f5 = Math_fround(f1 / f6);
  f4 = Math_fround(f3 / f6);
  f3 = Math_fround(f7 / f6);
  f1 = Math_fround(f8 / f6);
 }
 f8 = Math_fround(Math_fround(+Math_acos(+f5)) * Math_fround(2.0));
 HEAPF32[i10 >> 2] = f8;
 i10 = f8 < Math_fround(0.0);
 f7 = Math_fround(-f8);
 if (!((i10 ? f7 : f8) <= Math_fround(9.99999997e-07))) {
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f5 * f5)))));
  f7 = Math_fround(f3 * f6);
  f8 = Math_fround(f4 * f6);
  HEAPF32[i9 >> 2] = Math_fround(f1 * f6);
  HEAPF32[i9 + 4 >> 2] = f7;
  HEAPF32[i9 + 8 >> 2] = f8;
  return;
 } else {
  HEAP32[i9 >> 2] = HEAP32[gb + 62524 >> 2];
  HEAP32[i9 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
  HEAP32[i9 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
  return;
 }
}

function __Z18ConvertUTF32toUTF8PKmiPhRi(i2, i3, i1, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i1;
 i5 = i2 + (i3 << 2) | 0;
 i6 = i1 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) {
  i9 = i1;
  i9 = i9 - i8 | 0;
  HEAP32[i7 >> 2] = i9;
  return 1;
 }
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  if (i3 >>> 0 < 128) i4 = 1; else if (i3 >>> 0 < 2048) i4 = 2; else if (i3 >>> 0 < 65536) i4 = 3; else {
   i10 = i3 >>> 0 < 2097152;
   i4 = i10 ? 4 : 2;
   i3 = i10 ? i3 : 65533;
  }
  i1 = i1 + i4 | 0;
  if (i1 >>> 0 > i6 >>> 0) break;
  switch (i4 & 7) {
  case 4:
   {
    i1 = i1 + -1 | 0;
    HEAP8[i1 >> 0] = i3 & 63 | 128;
    i3 = i3 >>> 6;
    i9 = 9;
    break;
   }
  case 3:
   {
    i9 = 9;
    break;
   }
  case 2:
   {
    i9 = 10;
    break;
   }
  case 1:
   {
    i9 = 11;
    break;
   }
  default:
   {}
  }
  if ((i9 | 0) == 9) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i9 = 10;
  }
  if ((i9 | 0) == 10) {
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i3 & 63 | 128;
   i3 = i3 >>> 6;
   i9 = 11;
  }
  if ((i9 | 0) == 11) {
   i9 = 0;
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = HEAPU8[gb + 584572 + i4 >> 0] | 0 | i3;
  }
  i1 = i1 + i4 | 0;
  if (i2 >>> 0 >= i5 >>> 0) {
   i9 = 14;
   break;
  }
 }
 if ((i9 | 0) == 14) {
  i10 = i1;
  i10 = i10 - i8 | 0;
  HEAP32[i7 >> 2] = i10;
  return 1;
 }
 i10 = i1 + (0 - i4) | 0;
 i10 = i10 - i8 | 0;
 HEAP32[i7 >> 2] = i10;
 return 1;
}

function _jinit_forward_dct(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 4 | 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i3 | 0, 1, 40) | 0;
 HEAP32[i3 + 344 >> 2] = i5;
 HEAP32[i5 >> 2] = fb + 3261;
 i2 = i3 + 184 | 0;
 L1 : do switch (HEAP32[i2 >> 2] | 0) {
 case 0:
  {
   HEAP32[i5 + 4 >> 2] = fb + 21;
   i1 = i5 + 8 | 0;
   if (!(_jsimd_can_fdct_islow() | 0)) {
    HEAP32[i1 >> 2] = fb + 3263;
    break L1;
   } else {
    HEAP32[i1 >> 2] = fb + 3262;
    break L1;
   }
  }
 case 1:
  {
   HEAP32[i5 + 4 >> 2] = fb + 21;
   i1 = i5 + 8 | 0;
   if (!(_jsimd_can_fdct_ifast() | 0)) {
    HEAP32[i1 >> 2] = fb + 3265;
    break L1;
   } else {
    HEAP32[i1 >> 2] = fb + 3264;
    break L1;
   }
  }
 default:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 48;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i3 | 0);
  }
 } while (0);
 do if ((HEAP32[i2 >> 2] | 0) >>> 0 < 2) {
  i1 = (_jsimd_can_convsamp() | 0) == 0;
  HEAP32[i5 + 12 >> 2] = i1 ? fb + 486 | 0 : fb + 487 | 0;
  i1 = i5 + 16 | 0;
  if (!(_jsimd_can_quantize() | 0)) {
   HEAP32[i1 >> 2] = fb + 489;
   break;
  } else {
   HEAP32[i1 >> 2] = fb + 488;
   break;
  }
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i3 | 0);
 } while (0);
 HEAP32[i5 + 36 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i3 | 0, 1, 256) | 0;
 i5 = i5 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i4 + 28 | 0;
 if (HEAP8[i5 >> 0] | 0) {
  i6 = HEAP32[i4 + 8 >> 2] | 0;
  mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
  mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 766877 | 0, 2) | 0;
  mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, gb + 1074320 | 0, 1) | 0;
  i6 = i4 + 20 | 0;
  HEAP8[i5 >> 0] = 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + -1 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 i6 = i4 + 20 | 0;
 i2 = (HEAP32[i6 >> 2] | 0) + -1 + (HEAP32[i4 + 32 >> 2] | 0) | 0;
 i1 = i4 + 8 | 0;
 if (i2 | 0) {
  i3 = 0;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, gb + 1074318 | 0, 1) | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, gb + 766880 | 0, 2) | 0;
 i1 = HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) + -1 << 2) >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
  i7 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  mftCall_iiii(i7 | 0, i2 | 0, i1 | 0, _strlen(i1) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, gb + 1086447 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, gb + 1074320 | 0, 1) | 0;
 i7 = i6;
 HEAP8[i5 >> 0] = 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}
function __ZN5physx27PxsFluidParticleOpcodeCache28writeTriangles_BaseU16_9xU10EPhPKjj(i6, i9, i7) {
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i5 = (i7 | 0) == 0;
 if (i5) {
  i1 = 0;
  i3 = -1;
  i2 = -1;
 } else {
  i4 = 0;
  i1 = 0;
  i3 = -1;
  i2 = -1;
  do {
   i11 = HEAP32[i9 + (i4 << 2) >> 2] | 0;
   i12 = i11 >>> 0 < i3 >>> 0;
   i2 = i12 ? i4 : i2;
   i3 = i12 ? i11 : i3;
   i1 = i11 >>> 0 > i1 >>> 0 ? i11 : i1;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i7 | 0));
 }
 if ((i1 - i3 | 0) >>> 0 >= 1024) {
  i12 = 0;
  STACKTOP = i10;
  return i12 | 0;
 }
 if (!i5) {
  i1 = 0;
  do {
   HEAP16[i8 + (i1 << 1) >> 1] = (HEAP32[i9 + (i1 << 2) >> 2] | 0) - i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 HEAP16[i8 + (i2 << 1) >> 1] = HEAP16[i8 + (i7 + -1 << 1) >> 1] | 0;
 HEAP16[i6 >> 1] = i3;
 i11 = HEAPU16[i8 + 2 >> 1] | 0;
 HEAP16[i6 + 2 >> 1] = i11 >>> 4 | (HEAPU16[i8 >> 1] | 0) << 6;
 i12 = HEAPU16[i8 + 6 >> 1] | 0;
 HEAP16[i6 + 4 >> 1] = (HEAPU16[i8 + 4 >> 1] | 0) << 2 | i11 << 12 | i12 >>> 8;
 i11 = HEAPU16[i8 + 8 >> 1] | 0;
 HEAP16[i6 + 6 >> 1] = i11 >>> 2 | i12 << 8;
 i12 = HEAPU16[i8 + 12 >> 1] | 0;
 HEAP16[i6 + 8 >> 1] = (HEAPU16[i8 + 10 >> 1] | 0) << 4 | i11 << 14 | i12 >>> 6;
 HEAP16[i6 + 10 >> 1] = i12 << 10 | (HEAPU16[i8 + 14 >> 1] | 0);
 i12 = 1;
 STACKTOP = i10;
 return i12 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj594ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj593ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj592ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj591ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj590ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj589ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj588ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj587ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj498ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj497ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __Z49AnimatorUtility_CUSTOM_OptimizeTransformHierarchyP12Il2CppObjectP11Il2CppArray(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __Z23StringScriptingToVectorINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvP11Il2CppArrayRT_(i1, i6);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i7 >> 2] | 0) == (i1 | 0) ? 0 : i1;
 if (!i3) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __Z26OptimizeTransformHierarchyR10GameObjectPK8UnityStrj(i2, i1, (HEAP32[i7 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 4);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i5 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 32 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i1) | 0;
 i5 = i8 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i8 + 48 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (i4 & 8 | 0) {
  i1 = HEAP8[i6 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i3 = i1;
   i1 = i1 + (HEAP32[i8 + 36 >> 2] | 0) | 0;
  } else {
   i2 = i6;
   i3 = i6;
   i1 = i6 + (i1 & 255) | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 + 8 >> 2] = i2;
  HEAP32[i8 + 12 >> 2] = i3;
  HEAP32[i8 + 16 >> 2] = i1;
 }
 if (!(i4 & 16)) return;
 i2 = i6 + 11 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i4 = HEAP32[i8 + 36 >> 2] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i6 >> 2] | 0) + i4;
  i1 = (HEAP32[i8 + 40 >> 2] & 2147483647) + -1 | 0;
  i5 = i4;
 } else {
  i4 = i1 & 255;
  HEAP32[i5 >> 2] = i6 + i4;
  i1 = 10;
  i5 = i4;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i6, i1, 0);
 i1 = HEAP8[i2 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i2;
  i3 = HEAP32[i8 + 36 >> 2] | 0;
 } else {
  i4 = i6;
  i3 = i1 & 255;
  i2 = i6;
 }
 i1 = i8 + 24 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i8 + 20 >> 2] = i2;
 HEAP32[i8 + 28 >> 2] = i4 + i3;
 if (!(HEAP32[i7 >> 2] & 3)) return;
 HEAP32[i1 >> 2] = i2 + i5;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 3) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -8 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx27InternalTriangleMeshBuilder11createRTreeEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, f11 = f0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i6 = i9;
 __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv(HEAP32[i8 >> 2] | 0);
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i4 = i7 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 110264 + 8;
 HEAP32[i6 + 4 >> 2] = i5;
 i1 = i2 + 12 | 0;
 if (!(HEAP8[i2 + 156 >> 0] & 2)) {
  i3 = 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
 }
 i10 = HEAP32[i8 + 8 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i10 + 40 >> 2]);
 __ZN5physx11RTreeCooker18buildFromTrianglesERNS_2Gu5RTreeEPKNS_6PxVec3EjPKtPKjjRNS_6shdfnd5ArrayIjNSB_19ReflectionAllocatorIjEEEEPNS0_13RemapCallbackEfNS_17PxMeshCookingHint4EnumE(i2 + 32 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3, i1, i5, i7, i6, f11, HEAP32[i10 + 32 >> 2] | 0);
 __ZN5physx27InternalTriangleMeshBuilder13remapTopologyEPKj(i8, HEAP32[i7 >> 2] | 0);
 i8 = HEAP32[i4 >> 2] | 0;
 if (!((i8 | 0) > -1 & (i8 & 2147483647 | 0) != 0)) {
  STACKTOP = i9;
  return 1;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return 1;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i9;
 return 1;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN20SoundChannelInstance17set3DConeSettingsEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 16 | 0;
 i5 = HEAP32[i1 + 164 >> 2] | 0;
 i9 = (i5 | 0) == 0;
 i13 = i1 + 148 | 0;
 i14 = HEAP16[i13 >> 1] | 0;
 HEAPF32[i1 + 40 >> 2] = f2;
 i10 = i1 + 146 | 0;
 i12 = i9 & 1;
 i11 = HEAP16[i10 >> 1] | 0;
 HEAPF32[i1 + 44 >> 2] = f3;
 HEAP16[i13 >> 1] = (((i14 & 65535) >>> 15 & 65535 | i9 & 1) & 65535) << 15 & 65535 | i14 & 32767;
 HEAPF32[i1 + 48 >> 2] = f4;
 HEAP16[i10 >> 1] = i12 << 5 & 65535 | (i12 << 4 & 65535 | (i12 << 3 & 65535 | i11 & -57));
 if (i9) {
  i14 = 0;
  STACKTOP = i8;
  return i14 | 0;
 }
 i1 = __ZN4FMOD7Channel17set3DConeSettingsEfff(i5, f2, f3, f4) | 0;
 if (!i1) {
  i14 = 0;
  STACKTOP = i8;
  return i14 | 0;
 }
 i14 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i7 >> 2] = gb + 853918;
 HEAP32[i7 + 4 >> 2] = 199;
 HEAP32[i7 + 8 >> 2] = gb + 874775;
 HEAP32[i7 + 12 >> 2] = i14;
 __Z6FormatPKcz(i6, gb + 883334 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i14 = i1;
 STACKTOP = i8;
 return i14 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = i7 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = (i9 - i1 | 0) / 24 | 0;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i9 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i10 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i9 | 0));
 STACKTOP = i12;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 4 | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
  _memset(i1 | 0, 0, i2 | 0) | 0;
  i1 = i1 | 0 ? i1 - i3 | 0 : 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 i4 = i1 + i5 | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
   i2 = HEAP8[i7 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i7 >> 0] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i6 = i2 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i3;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i5 + 4 | 0;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
  _memset(i1 | 0, 0, i2 | 0) | 0;
  i1 = i1 | 0 ? i1 - i3 | 0 : 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 i4 = i1 + i5 | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 1);
   i2 = HEAP8[i7 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i7 >> 0] = i2;
   HEAP32[i8 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14NavMeshManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZN14NavMeshManager7CleanupEv(i3);
 i1 = i3 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN7dtCrowdD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63704 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN14NavMeshCarvingD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63704 | 0);
 HEAP32[i1 >> 2] = 0;
 __Z16dtAllocSetCustomPFPviEPFvS_ES1_S3_PFS_S_iE(0, 0, 0, 0, 0);
 i1 = i3 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63704 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i3 + 124 | 0, HEAP32[i3 + 128 >> 2] | 0);
 i1 = i3 + 80 | 0;
 if ((HEAP32[i3 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 60 | 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 if ((HEAP32[i3 + 56 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11TimeManager9ResetTimeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0, f5 = f0, f6 = f0;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 f6 = i2 ? Math_fround(.0199999996) : Math_fround(0.0);
 f5 = i2 ? Math_fround(50.0) : Math_fround(0.0);
 HEAPF32[i1 + 80 >> 2] = f6;
 HEAPF32[i1 + 92 >> 2] = f5;
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 48 >> 2]));
 i2 = i1 + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP8[i1 + 128 >> 0] = 1;
 HEAP8[i1 + 129 >> 0] = 1;
 HEAP8[i1 + 130 >> 0] = 1;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 d3 = +__Z19GetTimeSinceStartupv();
 HEAPF64[i1 + 152 >> 3] = d3;
 HEAPF64[i1 + 160 >> 3] = d3;
 i2 = i1 + 168 | 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __Z35GetTextRenderingScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1467896 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 945765 | 0, 16) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[gb + 1467896 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 946881 | 0) | 0;
 i2 = HEAP32[gb + 1467896 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 i2 = i2 + 4 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 945895 | 0, gb + 945900 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945930 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 12 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945944 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 16 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945955 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 20 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945966 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 24 >> 2] = i2;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 326 | 0, fb + 327 | 0);
 i2 = HEAP32[gb + 1467896 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z20RenderSceneDepthPassRK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 if (!(HEAP32[i1 + 32812 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = __ZnwjRK10MemLabelIdiPKci(112, gb + 64024 | 0, 16, gb + 388526 | 0, 623) | 0;
 i11 = gb + 64024 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i8 + 4 >> 2] = 1;
 HEAP32[i8 >> 2] = gb + 36916 + 8;
 i9 = i8 + 8 | 0;
 HEAP32[i9 >> 2] = 0;
 i10 = i6;
 HEAP32[i10 >> 2] = i12;
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i10 = i5;
 i5 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i8 + 32 >> 2] = 0;
 HEAP32[i8 + 36 >> 2] = 0;
 HEAP32[i8 + 104 >> 2] = 0;
 HEAP8[i8 + 108 >> 0] = 1;
 HEAP8[i8 + 109 >> 0] = 1;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 HEAP32[i9 >> 2] = i1;
 __ZN9DepthPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceDatab(i8, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, i1 + 8 | 0, i2, i3);
 __ZN9DepthPass16PerformRenderingER17ShaderPassContext(i8, i4);
 STACKTOP = i7;
 return;
}

function _updatewindow(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i6 + 28 >> 2] | 0;
 i9 = i8 + 52 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[i6 + 32 >> 2] | 0, HEAP32[i6 + 40 >> 2] | 0, 1 << HEAP32[i8 + 36 >> 2] | 0, 1) | 0;
  HEAP32[i9 >> 2] = i1;
  if (!i1) {
   i9 = 1;
   return i9 | 0;
  }
 }
 i7 = i8 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  i2 = 1 << HEAP32[i8 + 36 >> 2];
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 + 48 >> 2] = 0;
  HEAP32[i8 + 44 >> 2] = 0;
 }
 i3 = i3 - (HEAP32[i6 + 16 >> 2] | 0) | 0;
 if (i3 >>> 0 >= i2 >>> 0) {
  _memcpy(i1 | 0, (HEAP32[i6 + 12 >> 2] | 0) + (0 - i2) | 0, i2 | 0) | 0;
  HEAP32[i8 + 48 >> 2] = 0;
  HEAP32[i8 + 44 >> 2] = HEAP32[i7 >> 2];
  i9 = 0;
  return i9 | 0;
 }
 i4 = i8 + 48 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i5 = i2 - i10 | 0;
 i5 = i5 >>> 0 > i3 >>> 0 ? i3 : i5;
 i2 = i6 + 12 | 0;
 _memcpy(i1 + i10 | 0, (HEAP32[i2 >> 2] | 0) + (0 - i3) | 0, i5 | 0) | 0;
 i1 = i3 - i5 | 0;
 if (i1 | 0) {
  _memcpy(HEAP32[i9 >> 2] | 0, (HEAP32[i2 >> 2] | 0) + (0 - i1) | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i8 + 44 >> 2] = HEAP32[i7 >> 2];
  i10 = 0;
  return i10 | 0;
 }
 i1 = (HEAP32[i4 >> 2] | 0) + i5 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = (i1 | 0) == (i10 | 0) ? 0 : i1;
 i1 = i8 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 >= i10 >>> 0) {
  i10 = 0;
  return i10 | 0;
 }
 HEAP32[i1 >> 2] = i2 + i5;
 i10 = 0;
 return i10 | 0;
}

function __ZN9ShaderLab18SerializedPropertyD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = i7 + 68 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 80 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 i4 = i7 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i7 + 36 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i6 = i8 + 4 | 0;
   do {
    i3 = i2 + -16 | 0;
    HEAP32[i5 >> 2] = i3;
    if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i2 + -4 >> 2] | 0;
     HEAP32[i8 >> 2] = 66;
     HEAP32[i6 >> 2] = i2;
     __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i7 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 28 >> 2] | 0;
  HEAP32[i8 >> 2] = 66;
  HEAP32[i8 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 }
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj624ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj623ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5Umbra20RuntimeStructBuilderD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!(HEAP8[i8 + 137 >> 0] | 0)) {
  i5 = i8 + 152 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i6 = i8 + 144 | 0;
   i4 = 0;
   do {
    i3 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 * 12 | 0) >> 2] | 0;
    if (i2) {
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
     i1 = HEAP32[i5 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i1 | 0));
  }
 }
 i5 = i8 + 148 | 0;
 if ((HEAP32[i5 >> 2] | 0) < 0) {
  i3 = i8 + 140 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 16, 0) | 0;
  if (i4 | 0) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i8 + 144 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    i7 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 + -16 | 0);
   }
   HEAP32[i1 >> 2] = i4 + 16;
   i7 = 12;
  }
 } else i7 = 12;
 if ((i7 | 0) == 12) HEAP32[i8 + 152 >> 2] = 0;
 i1 = i8 + 144 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i8 = i8 + 152 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 i7 = HEAP32[i8 + 140 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 + -16 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i8 = i8 + 152 | 0;
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZN20SphericalHarmonicsL26ExpandERK20SphericalHarmonicsL1(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 24 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 76 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 44 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 80 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 84 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * Math_fround(2.0));
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN14NavMeshCarvingC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = i4;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i6 = i4;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i1 + 72;
 i3 = i1 + 80 | 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN14NavMeshCarving11AddObstacleER15NavMeshObstacleRi(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = i8 + 8 | 0;
  i3 = i8 + 20 | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
  i4 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
  i5 = i8 + 24 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i4 >>> 0 > i7 >>> 0) {
   i1 = i6 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 120 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 120 | 0, 4, i8 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 120 | 0) | 0;
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i3 >> 2] = i4;
 } else {
  HEAP32[i10 >> 2] = HEAP32[(HEAP32[i8 + 28 >> 2] | 0) + (i2 + -1 << 2) >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i2 + (i1 * 120 | 0) + 112 >> 2] = i9;
 HEAP32[i2 + (i1 * 120 | 0) + 116 >> 2] = -1;
 i1 = i2 + (i1 * 120 | 0) | 0;
 i2 = i1 + 88 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN11Rigidbody2D11SetRotationEf(i6, f2) {
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 92 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) return;
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = Math_fround((i5 ? Math_fround(1.0e6) : f2) * Math_fround(.0174532924));
 __ZN6b2Body12SetTransformERK6b2Vec2f(i3, i3 + 12 | 0, i4 ? Math_fround(-17453.293) : f2);
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i3 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i3 & 65533;
  HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  i5 = i4 + 64 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i1 >> 1] = i3 | 2;
  HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = i6 + 227 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  HEAP8[i1 >> 0] = 0;
  i3 = HEAP32[i6 + 124 >> 2] | 0;
  i4 = HEAP32[i3 + 92 >> 2] | 0;
  if (i4 | 0) {
   f2 = Math_fround(HEAPF32[i6 + 220 >> 2]);
   if (HEAP32[i4 >> 2] | 0) {
    i5 = i4 + 4 | 0;
    i1 = HEAP16[i5 >> 1] | 0;
    if (!(i1 & 16)) {
     if (Math_fround(f2 * f2) > Math_fround(0.0)) {
      i1 = i1 & 65535;
      if (!(i1 & 2)) {
       HEAP16[i5 >> 1] = i1 | 2;
       HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
      }
     }
     HEAPF32[i4 + 72 >> 2] = f2;
    }
   }
   HEAP32[i4 + 136 >> 2] = HEAP32[i3 + 40 >> 2];
  }
 }
 HEAP8[i6 + 225 >> 0] = 0;
 return;
}

function __ZN10GUITexture16CalculateDrawBoxERK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 12 | 0;
 i11 = i4;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i12, i13);
 __ZNK9Transform18GetWorldScaleLossyEv(i11, i13);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f10 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.5));
 f7 = Math_fround(f9 - f10);
 f10 = Math_fround(f9 + f10);
 f9 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f8 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) * Math_fround(.5));
 f5 = Math_fround(f9 - f8);
 f8 = Math_fround(f9 + f8);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 * f9);
 f6 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f7 = Math_fround(f7 + f6);
 HEAPF32[i1 >> 2] = f7;
 f9 = Math_fround(f10 * f9);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f9 + Math_fround(f6 + Math_fround(HEAPF32[i2 + 80 >> 2]))) - f7);
 f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f5 * f7);
 f6 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f5 = Math_fround(f5 + f6);
 HEAPF32[i1 + 4 >> 2] = f5;
 f7 = Math_fround(f8 * f7);
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f7 + Math_fround(f6 + Math_fround(HEAPF32[i2 + 84 >> 2]))) - f5);
 STACKTOP = i4;
 return;
}

function __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 256 | 0;
 i3 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 HEAP32[i6 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i6);
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = __Z9GetIIMGUIv() | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i3, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0, gb + 1034525 | 0, 1);
 if (HEAP32[i3 >> 2] | 0) {
  i8 = i3;
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i1, i6);
  HEAP32[i6 >> 2] = 0;
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 256 | 0;
 i3 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 HEAP32[i6 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i6);
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = __Z9GetIIMGUIv() | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i3, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0, gb + 1034525 | 0, 1);
 if (HEAP32[i3 >> 2] | 0) {
  i8 = i3;
  i2 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i1, i6);
  HEAP32[i6 >> 2] = 0;
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE15growAndPushBackERKS3_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = i11 + 8 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i7 = 0; else i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11, i8 * 104 | 0, gb + 838004 | 0, 543) | 0;
 i9 = i11 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i6 = i7 + (i1 * 104 | 0) | 0;
 if ((i1 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i11 >> 2] | 0;
  while (1) {
   i3 = i1;
   i4 = i2;
   i5 = i3 + 104 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
    i3 = i3 + 4 | 0;
    i4 = i4 + 4 | 0;
   } while ((i3 | 0) < (i5 | 0));
   i1 = i1 + 104 | 0;
   if (i1 >>> 0 >= i6 >>> 0) break; else i2 = i2 + 104 | 0;
  }
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i3 = i7 + (i1 * 104 | 0) | 0;
 i4 = i10;
 i5 = i3 + 104 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 if ((HEAP32[i12 >> 2] | 0) <= -1) {
  HEAP32[i11 >> 2] = i7;
  HEAP32[i12 >> 2] = i8;
  i12 = HEAP32[i9 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i9 >> 2] = i11;
  i12 = i7 + (i12 * 104 | 0) | 0;
  return i12 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i11, HEAP32[i11 >> 2] | 0);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i12 >> 2] = i8;
 i12 = HEAP32[i9 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i9 >> 2] = i11;
 i12 = i7 + (i12 * 104 | 0) | 0;
 return i12 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj494ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj493ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN11UmbraModule21QueryPortalVisibilityEPN5Umbra10VisibilityEPK22SceneCullingParametersjii(i1, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = i10 + 8 | 0;
 __ZN5Umbra15CameraTransformC2Ev(i4);
 i1 = HEAP32[i6 + 188 >> 2] | 0;
 if ((i1 | 0) > 6) __ZN5Umbra15CameraTransform17setUserClipPlanesEPKNS_7Vector4Ei(i4, i6 + 124 | 0, i1 + -6 | 0);
 __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE(i4, i6 + 544 | 0, i6 + 608 | 0, 0, 0);
 i2 = __ZnwjRK10MemLabelIdiPKci(102400, gb + 64024 | 0, 16, gb + 612578 | 0, 19) | 0;
 __ZN5Umbra8QueryExtC2EPKNS_4TomeE(i2, HEAP32[i6 + 836 >> 2] | 0);
 __ZN5Umbra15GateStateVectorC2EPvjb(i3, HEAP32[i6 + 840 >> 2] | 0, 0, 0);
 __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE(i2, i3);
 __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE(i2, HEAP32[i6 + 844 >> 2] | 0);
 i1 = (__ZN5Umbra5Query21queryPortalVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEffPKNS_20ObjectDistanceParamsEiii(i2, i7 | 2, i5, i4, Math_fround(HEAPF32[i6 + 620 >> 2]), Math_fround(-1.0), 0, i8, i9, 0) | 0) == 5;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
 STACKTOP = i10;
 return i1 | 0;
}

function __Z14PxToRaycastHitRKN5physx12PxRaycastHitER10RaycastHit(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = i2 + 4 | 0;
 HEAP32[i3 + 40 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 i6 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = i3 + 12 | 0;
 i7 = i2 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 >> 2] = 5;
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i1 | 0) | 0) {
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i1 + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
 } else i1 = -1;
 HEAP32[i3 + 24 >> 2] = i1;
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i3 + 36 >> 2] = HEAP32[i2 + 48 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNKSt3__214__codecvt_utf8IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_(i5, i1, i3, i10, i11, i6, i4, i12) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = i3;
 i2 = i6;
 i8 = i4;
 if (!(HEAP32[i5 + 12 >> 2] & 2)) i7 = 4; else if ((i8 - i2 | 0) < 3) i3 = 1; else {
  HEAP8[i6 >> 0] = -17;
  HEAP8[i6 + 1 >> 0] = -69;
  HEAP8[i6 + 2 >> 0] = -65;
  i2 = i6 + 3 | 0;
  i7 = 4;
 }
 L4 : do if ((i7 | 0) == 4) while (1) {
  if (i3 >>> 0 >= i10 >>> 0) {
   i3 = 0;
   break L4;
  }
  i6 = HEAP16[i3 >> 1] | 0;
  i3 = i6 & 65535;
  if (i3 >>> 0 > i9 >>> 0 | (i3 & 63488 | 0) == 55296) {
   i3 = 2;
   break L4;
  }
  do if ((i6 & 65535) < 128) {
   i3 = i2;
   if ((i8 - i2 | 0) < 1) {
    i3 = 1;
    break L4;
   }
   HEAP8[i3 >> 0] = i6;
   i2 = i3 + 1 | 0;
  } else {
   i4 = i2;
   i5 = i8 - i2 | 0;
   if ((i6 & 65535) < 2048) {
    if ((i5 | 0) < 2) {
     i3 = 1;
     break L4;
    }
    HEAP8[i4 >> 0] = i3 >>> 6 | 192;
    HEAP8[i4 + 1 >> 0] = i3 & 63 | 128;
    i2 = i4 + 2 | 0;
    break;
   } else {
    if ((i5 | 0) < 3) {
     i3 = 1;
     break L4;
    }
    HEAP8[i4 >> 0] = i3 >>> 12 | 224;
    HEAP8[i4 + 1 >> 0] = i3 >>> 6 & 63 | 128;
    HEAP8[i4 + 2 >> 0] = i3 & 63 | 128;
    i2 = i4 + 3 | 0;
    break;
   }
  } while (0);
  i3 = i1 + 2 | 0;
  i1 = i3;
  i7 = 4;
 } while (0);
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 return i3 | 0;
}

function __ZN7Terrain28CopySplatMaterialCustomPropsEPK19ShaderPropertySheet(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 116 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = (i1 | 0) != 0;
 if (!i3) {
  if (i2) {
   i4 = i1 + 4 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   if (!(HEAP32[i4 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
   }
   HEAP32[i6 >> 2] = 0;
  }
 } else {
  if (i2) if ((HEAP32[i1 + 4 >> 2] | 0) == 1) {
   __ZN19ShaderPropertySheet8CopyFromERKS_(i1, i3);
   i1 = HEAP32[i6 >> 2] | 0;
  } else i4 = 9; else i4 = 9;
  if ((i4 | 0) == 9) {
   i2 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 930687 | 0, 302) | 0;
   __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i2, gb + 63616 | 0, i3);
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) {
    i4 = i1 + 4 | 0;
    HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
    if (!(HEAP32[i4 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
    }
    HEAP32[i6 >> 2] = 0;
   }
   HEAP32[i6 >> 2] = i2;
   i1 = i2;
  }
  __ZN19ShaderPropertySheet11ComputeHashEv(i1);
 }
 i4 = HEAP32[i5 + 240 >> 2] | 0;
 if (!i4) return;
 i3 = HEAP32[i5 + 228 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[(HEAP32[i3 + (i1 * 20 | 0) + 4 >> 2] | 0) + 112 >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 40 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -40 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 32 | 0;
  if (i1 >>> 0 < 33 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 674330 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 36 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 32 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 28 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 731374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 28 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN26PlayerSettingsSplashScreen8TransferI17RemapPPtrTransferEEvRT_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i10 + 28 | 0;
 i7 = i10 + 32 | 0;
 i1 = HEAP32[i10 + 72 >> 2] | 0;
 i5 = HEAP32[i10 + 84 >> 2] | 0;
 i8 = i1 + (i5 << 3) | 0;
 if (i5 | 0) {
  i3 = i9 + 16 | 0;
  i4 = i9 + 36 | 0;
  i5 = i9 + 40 | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(0.0)) HEAPF32[i6 >> 2] = Math_fround(0.0);
 if (Math_fround(HEAPF32[i7 >> 2]) < Math_fround(0.0)) HEAPF32[i7 >> 2] = Math_fround(0.0);
 i1 = i10 + 92 | 0;
 i3 = i9 + 16 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i9 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 i5 = i9 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i10 + 96 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i10 + 116 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN18AssetBundleManager18CollectPreloadDataEiPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEER13dynamic_arrayIiLj4EE(i3, i13, i1, i2, i14) {
 i3 = i3 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i15 = 0;
 if (i1 | 0) if (__ZNK11AssetBundle14GetPreloadDataEiR13dynamic_arrayIiLj4EE(i1, i13, i14) | 0) {
  i14 = i1;
  return i14 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i12 = i2 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if ((i4 | 0) == (i1 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i11 = i3 + 4 | 0;
 i10 = i3 + 8 | 0;
 while (1) {
  i3 = HEAP32[i11 >> 2] | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i2 = i9 - i3 >> 3;
  if (!i2) i2 = i3; else {
   i8 = HEAP32[i4 >> 2] | 0;
   i7 = i2;
   i2 = i3;
   while (1) {
    i15 = (i7 | 0) / 2 | 0;
    i6 = i3 + (i15 << 3) | 0;
    i5 = (_strcmp(HEAP32[i6 >> 2] | 0, i8) | 0) < 0;
    i6 = i6 + 8 | 0;
    i2 = i5 ? i6 : i2;
    i7 = i5 ? i7 + -1 - i15 | 0 : i15;
    if (!i7) break; else i3 = i5 ? i6 : i3;
   }
  }
  if ((i2 | 0) != (i9 | 0)) if (!((_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) < 0 | (i2 | 0) == (i9 | 0))) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (__ZNK11AssetBundle14GetPreloadDataEiR13dynamic_arrayIiLj4EE(i1, i13, i14) | 0) {
    i2 = 13;
    break;
   }
   i1 = HEAP32[i12 >> 2] | 0;
  }
  i4 = i4 + 4 | 0;
  if ((i4 | 0) == (i1 | 0)) {
   i1 = 0;
   i2 = 13;
   break;
  }
 }
 if ((i2 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream5writeEPKhj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i2 + 100 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) {
  i11 = 1;
  return i11 | 0;
 }
 i9 = i2 + 88 | 0;
 i10 = i2 + 72 | 0;
 i11 = i2 + 68 | 0;
 i8 = i2 + 92 | 0;
 i6 = i2 + 96 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0) i5 = i4; else {
  i11 = 1;
  return i11 | 0;
 }
 L6 : while (1) {
  while (1) {
   if (!i1) {
    i1 = 0;
    i2 = 11;
    break L6;
   }
   __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
   i3 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i11 >> 2] | 0;
   i2 = i3 - i4 | 0;
   i2 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
   if (i2) {
    _memcpy(i4 | 0, i5 | 0, i2 | 0) | 0;
    i4 = (HEAP32[i11 >> 2] | 0) + i2 | 0;
    HEAP32[i11 >> 2] = i4;
    i3 = HEAP32[i10 >> 2] | 0;
   }
   if ((i3 | 0) == (i4 | 0)) __ZN5physx6shdfnd8SyncImpl5resetEv(HEAP32[i8 >> 2] | 0);
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i9 >> 2] | 0);
   __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i6 >> 2] | 0);
   i3 = i1 - i2 | 0;
   if ((i1 | 0) == (i2 | 0)) i1 = i3; else {
    i1 = i3;
    break;
   }
  }
  __ZN5physx6shdfnd8SyncImpl4waitEj(HEAP32[i8 >> 2] | 0, 1) | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0) i5 = i5 + i2 | 0; else {
   i1 = 1;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) return i1 | 0;
 return 0;
}

function __Z43DestroyWithoutLoadingButDontDestroyFromFilei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i2 = i5;
 __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(__Z20GetPersistentManagerv() | 0, i1, 0);
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, i1, i2);
   i2 = HEAP32[i4 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) != (i2 + (i3 << 3) | 0)) {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    STACKTOP = i5;
    return;
   }
   __Z28delete_object_internal_step1P6Object(i1);
   i6 = HEAP32[i1 + 8 >> 2] & 2047;
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   HEAP32[i4 >> 2] = i6;
   HEAP32[i4 + 4 >> 2] = 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
   STACKTOP = i5;
   return;
  }
 }
 STACKTOP = i5;
 return;
}

function __Z34FindAllRequiredComponentsRecursiveiR10vector_setIiNSt3__24lessIiEENS0_9allocatorIiEEE(i7, i11) {
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i9 = i12 + 4 | 0;
 i10 = i12;
 HEAP32[i10 >> 2] = i7;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = HEAP32[i11 + 4 >> 2] | 0;
 i1 = i8 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i8 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i7 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i11, i6, i10) | 0;
 i3 = __Z34FindRequiredComponentsForComponenti(HEAP32[i10 >> 2] | 0) | 0;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i12;
  return;
 } else i2 = 0;
 do {
  __Z34FindAllRequiredComponentsRecursiveiR10vector_setIiNSt3__24lessIiEENS0_9allocatorIiEEE(HEAP32[i1 + (i2 << 2) >> 2] | 0, i11);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx7profile16StringTableEvent9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_17MemoryEventHeaderE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRS7_(i3, gb + 774375 | 0, i2);
 i10 = i2 + 4 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i9 = i6 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = i6 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4;
 i8 = i1 - i3 | 0;
 i2 = i8 + 4 | 0;
 i5 = i6 + 16 | 0;
 if (((HEAP32[i5 >> 2] | 0) - i3 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i6 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i8 | 0) | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i6 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
   }
  }
  HEAP32[i7 >> 2] = i2;
  i1 = i2 + i8 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i5 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i10 + 3 >> 0] | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 745374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 264 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 260 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 268 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 256 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx19CVariableMemoryPoolD2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i9 + 12 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + (i7 << 2) | 0;
 if (i7 | 0) do {
  i7 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i9 + 44 >> 2] | 0;
 if (i1 | 0) {
  i7 = i9 + 60 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i9 + 36 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i9 + 40 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i9 + 32 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i9 + 52 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = HEAP32[i9 + 24 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[HEAP32[i9 + 20 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i1 | 0);
 }
 i7 = HEAP32[i9 + 16 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 i9 = HEAP32[HEAP32[i9 + 4 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj652ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj651ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj649ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5Unity11Adjacencies11AddTriangleEjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = i1 + 4 | 0;
 i10 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) >> 2] = i2;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 4 >> 2] = i3;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 8 >> 2] = i4;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 16 >> 2] = -1;
 HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 20 >> 2] = -1;
 i10 = i2 >>> 0 < i3 >>> 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 8 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 + (i6 * 12 | 0) >> 2] = i10 ? i2 : i3;
 HEAP32[i9 + (i6 * 12 | 0) + 4 >> 2] = i10 ? i3 : i2;
 HEAP32[i9 + (i6 * 12 | 0) + 8 >> 2] = i11;
 i9 = i6 + 1 | 0;
 HEAP32[i1 >> 2] = i9;
 i11 = i2 >>> 0 < i4 >>> 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 + (i9 * 12 | 0) >> 2] = i11 ? i2 : i4;
 HEAP32[i8 + (i9 * 12 | 0) + 4 >> 2] = i11 ? i4 : i2;
 HEAP32[i8 + (i9 * 12 | 0) + 8 >> 2] = i10;
 i2 = i6 + 2 | 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i3 >>> 0 < i4 >>> 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 + (i2 * 12 | 0) >> 2] = i9 ? i3 : i4;
 HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] = i9 ? i4 : i3;
 HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] = i8;
 HEAP32[i1 >> 2] = i6 + 3;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return 1;
}

function __ZN10GUITexture13GetScreenRectERK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 12 | 0;
 i11 = i4;
 i13 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i12, i13);
 __ZNK9Transform18GetWorldScaleLossyEv(i11, i13);
 f9 = Math_fround(HEAPF32[i12 >> 2]);
 f10 = Math_fround(Math_fround(HEAPF32[i11 >> 2]) * Math_fround(.5));
 f7 = Math_fround(f9 - f10);
 f10 = Math_fround(f9 + f10);
 f9 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f8 = Math_fround(Math_fround(HEAPF32[i11 + 4 >> 2]) * Math_fround(.5));
 f5 = Math_fround(f9 - f8);
 f8 = Math_fround(f9 + f8);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 * f9);
 f6 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f7 = Math_fround(f7 + f6);
 HEAPF32[i1 >> 2] = f7;
 f9 = Math_fround(f10 * f9);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f9 + Math_fround(f6 + Math_fround(HEAPF32[i2 + 80 >> 2]))) - f7);
 f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f5 = Math_fround(f5 * f7);
 f6 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f5 = Math_fround(f5 + f6);
 HEAPF32[i1 + 4 >> 2] = f5;
 f7 = Math_fround(f8 * f7);
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f7 + Math_fround(f6 + Math_fround(HEAPF32[i2 + 84 >> 2]))) - f5);
 STACKTOP = i4;
 return;
}

function __ZN9Rigidbody22FetchPoseFromTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 48 | 0;
 i10 = i3 + 32 | 0;
 i2 = i3;
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform11GetPositionEv(i4, i6);
 __ZNK9Transform11GetRotationEv(i10, i6);
 i6 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i4 + 8 >> 2] | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = HEAP32[i10 + 8 >> 2] | 0;
 i7 = HEAP32[i10 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i2 + 8 >> 2] = i8;
 HEAP32[i2 + 12 >> 2] = i7;
 HEAP32[i2 + 16 >> 2] = i6;
 HEAP32[i2 + 20 >> 2] = i5;
 HEAP32[i2 + 24 >> 2] = i4;
 if (!(HEAP8[i1 + 84 >> 0] | 0)) {
  i10 = i1 + 52 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i9 = HEAP32[i10 >> 2] | 0;
  i9 = i9 + 88 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  mftCall_viii(i9 | 0, i10 | 0, i2 | 0, 1);
  STACKTOP = i3;
  return;
 }
 if (HEAP8[i1 + 80 >> 0] | 0) {
  i10 = HEAP32[i1 + 52 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 224 >> 2] | 0, i10 | 0, i2 | 0);
 }
 i10 = i1 + 104 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 i10 = i1 + 52 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + 88 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_viii(i9 | 0, i10 | 0, i2 | 0, 1);
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 28 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 685780 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 28 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
   i1 = i1 + 28 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 28 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE(i6, i1, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11 + 24 | 0;
 i9 = i11 + 8 | 0;
 i7 = i11 + 72 | 0;
 i8 = i11;
 i4 = i11 + 36 | 0;
 i5 = i6 + 16 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i11;
  return;
 }
 i1 = (i1 | 0) == 0 ? 2097152 : i1;
 if (i3 | 0) {
  i2 = i6 + 4 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) if (!(HEAP32[i6 >> 2] | 0)) HEAP32[i2 >> 2] = i3;
 }
 _pthread_attr_init(i4 | 0) | 0;
 _pthread_attr_setstacksize(i4 | 0, i1 | 0) | 0;
 _pthread_create(i6 + 20 | 0, i4 | 0, fb + 2158 | 0, i6 | 0) | 0;
 i1 = i6 + 12 | 0;
 if (!(__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1, 1, 1) | 0)) do _sched_yield() | 0; while (!(__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1, 1, 1) | 0));
 _pthread_attr_destroy(i4 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i2;
  i4 = i8;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  if ((HEAP32[i5 >> 2] | 0) == 1) {
   i1 = i6 + 24 | 0;
   HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 + 4 >> 2] = 8;
   HEAP32[i9 + 8 >> 2] = i8;
   if ((_syscall(242, i9 | 0) | 0) >= 0) {
    HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i10 + 4 >> 2] = 4;
    HEAP32[i10 + 8 >> 2] = i7;
    _syscall(241, i10 | 0) | 0;
   }
  }
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89768 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj660ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj659ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj658ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj286ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj285ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj284ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx13GuMeshFactory16createConvexMeshERNS_13PxInputStreamE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i8 | 0, i3 | 0, 132, (i6 ? gb + 723963 | 0 : gb + 837976 | 0) | 0, gb + 724079 | 0, 168) | 0;
 __ZN5physx2Gu10ConvexMeshC2Ev(i6);
 if (!i6) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i6 + 128 >> 2] = i4;
 if (__ZN5physx2Gu10ConvexMesh4loadERNS_13PxInputStreamE(i6, i1) | 0) {
  HEAP32[i2 >> 2] = i6;
  i3 = i4 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 48 | 0, i2, i5) | 0;
  if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i8 = i6;
  STACKTOP = i7;
  return i8 | 0;
 } else {
  i1 = i6 + 8 | 0;
  if (__ZN5physx6shdfnd15atomicDecrementEPVi(i6 + 12 | 0) | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN5Umbra15StartCellFinder16processStartTileEii(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 56 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i3 = i5 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i5, i2);
 i3 = HEAP32[i3 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 56 >> 2] | 0) if (HEAP32[i3 + 28 >> 2] | 0) {
  _memset((HEAP32[i1 >> 2] | 0) + 2936 | 0, 0, 4094) | 0;
  if ((HEAP32[i1 + 8 >> 2] | 0) == -1) {
   i6 = i7;
   HEAP32[i6 >> 2] = i4;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   i8 = __ZN5Umbra15StartCellFinder14findStartCellsENS_12PortalCuller4TileEPKNS_7ImpTileE(i1, i8, i3) | 0;
   STACKTOP = i9;
   return i8 | 0;
  } else {
   i7 = i6;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = i2;
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   i8 = __ZN5Umbra15StartCellFinder23findStartCellsForObjectENS_12PortalCuller4TileERKNS_10MappedTileE(i1, i8, i5) | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + 28 >> 2] = 7;
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN22CrashReportingSettings8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i2 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1041874 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i3, 1); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i3 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1047713 | 0, HEAP32[gb + 36972 >> 2] | 0, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i4 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i3, 1);
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN11NavMeshDataC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 169404 + 8;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN19ShaderPropertySheet29PreallocateArrayUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEj(i7, i8, i9, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i10 = i11 + 12 | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = HEAP32[i7 + 8 + (i9 << 2) >> 2] | 0;
 i3 = HEAP32[i7 + 8 + (i9 + 1 << 2) >> 2] | 0;
 L4 : do if ((i2 | 0) < (i3 | 0)) {
  i4 = HEAP32[i7 + 32 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i5 | 0)) break;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) >= (i3 | 0)) break L4;
  }
  if ((i2 | 0) > -1) {
   STACKTOP = i11;
   return;
  }
 } while (0);
 if (i1 >>> 0 > 1023) {
  HEAP32[i6 >> 2] = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i8) | 0;
  HEAP32[i6 + 4 >> 2] = i1;
  HEAP32[i6 + 8 >> 2] = 1023;
  __Z6FormatPKcz(i10, gb + 479174 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i10 + 11 >> 0] | 0) < 0 ? HEAP32[i10 >> 2] | 0 : i10, 0, gb + 479016 | 0, 592, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
  i1 = 1023;
 }
 __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i10, i7, i8, i9, Math_imul(i1, (i9 | 0) == 0 ? 4 : (i9 | 0) == 1 ? 16 : 64) | 0, i1, 0);
 STACKTOP = i11;
 return;
}

function __ZN15TerrainRenderer19UnloadFromGfxDeviceEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = i5 + 20 | 0;
 if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
  __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i5, i1);
  i4 = i1 + 60 | 0;
  HEAP8[i4 >> 0] = HEAP8[i4 >> 0] | 6;
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 i3 = i5 + 116 | 0;
 i4 = i5 + 128 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = i2 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   if (!(HEAP32[i6 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i5 + 132 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i5 + 120 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = 0;
 do {
  i2 = i5 + 136 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i6 = i3 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   if (!(HEAP32[i6 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63248 | 0);
   }
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 HEAP32[i5 + 232 >> 2] = 0;
 return;
}

function __ZN13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN11OffMeshLink7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 845751 | 0, 15) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 169188 + 8;
 i2 = i4 + 56 | 0;
 i1 = i4 + 68 | 0;
 HEAP32[i4 + 88 >> 2] = 0;
 i5 = i4 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = -1;
 HEAPF32[i4 + 84 >> 2] = Math_fround(-1.0);
 HEAP8[i4 + 98 >> 0] = 1;
 HEAP8[i4 + 96 >> 0] = 0;
 HEAP8[i4 + 97 >> 0] = 0;
 HEAP8[i4 + 99 >> 0] = 1;
 HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i4 + 80 >> 2] = Math_fround(.5);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (i2 - i4 >> 4 >>> 0 >= i9 >>> 0) {
  i1 = i9;
  i2 = i3;
  while (1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = -1;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 16 | 0;
  }
  HEAP32[i10 >> 2] = i3 + (i9 << 4);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = (i4 - i1 >> 4) + i9 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i2 - i1 | 0;
 i2 = i6 >> 3;
 i2 = i6 >> 4 >>> 0 < 134217727 ? (i2 >>> 0 < i3 >>> 0 ? i3 : i2) : 268435455;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 << 4) | 0;
 i6 = i3 + (i4 - i1 >> 4 << 4) | 0;
 i5 = i3 + (i2 << 4) | 0;
 i2 = i9;
 i3 = i6;
 while (1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = -1;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 16 | 0;
 }
 i2 = i4 - i1 | 0;
 i3 = i6 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i6 + (i9 << 4);
 HEAP32[i8 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 68 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -68 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 52 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -52 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 48 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -48 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 5) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -32 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 4) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -16 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx16PxsFluidDynamics18processPacketRangeEj(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 800 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 i10 = HEAP32[(HEAP32[i13 + 80 >> 2] | 0) + 72 >> 2] | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i10 = HEAP32[i10 + 20 >> 2] | 0;
 i11 = HEAP32[i13 + 84 >> 2] | 0;
 i6 = HEAP32[i13 + 88 >> 2] | 0;
 i3 = HEAP16[i13 + 512 + (i1 << 2) >> 1] | 0;
 i7 = i13 + 512 + (i1 << 2) + 2 | 0;
 i2 = HEAP16[i7 >> 1] | 0;
 if ((i3 & 65535) >= (i2 & 65535)) {
  STACKTOP = i14;
  return;
 }
 i8 = i13 + 152 | 0;
 i4 = i13 + 160 + (i1 * 44 | 0) | 0;
 i5 = i3 & 65535;
 while (1) {
  i1 = i9 + (i5 << 4) | 0;
  if ((HEAP32[i9 + (i5 << 4) + 8 >> 2] | 0) != -1) {
   __ZN5physx19PxsFluidSpatialHash14getHaloRegionsERNS_25PxsFluidPacketHaloRegionsERKNS_17PxcGridCellVectorEPKNS_15PxsParticleCellEPKNS_22PxsFluidPacketSectionsEj(i12, i1, i9, i10, 1024);
   __ZN5physx16PxsFluidDynamics12updatePacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE(i13, HEAP32[i8 >> 2] | 0, i6, i11, i1, i10 + (i5 * 216 | 0) | 0, i12, i4);
   i2 = HEAP16[i7 >> 1] | 0;
  }
  i1 = i3 + 1 << 16 >> 16;
  if ((i1 & 65535) < (i2 & 65535)) {
   i5 = i1 & 65535;
   i3 = i1;
  } else break;
 }
 STACKTOP = i14;
 return;
}

function __ZN5physx13GuMeshFactory17createHeightFieldERNS_13PxInputStreamE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i6 = _PxGetFoundation() | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_iiiiii(i8 | 0, i3 | 0, 116, (i6 ? gb + 726403 | 0 : gb + 837976 | 0) | 0, gb + 724079 | 0, 246) | 0;
 __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE(i6, i4);
 if (!i6) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 if (__ZN5physx2Gu11HeightField4loadERNS_13PxInputStreamE(i6, i1) | 0) {
  HEAP32[i2 >> 2] = i6;
  i3 = i4 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4 + 88 | 0, i2, i5) | 0;
  if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  i8 = i6;
  STACKTOP = i7;
  return i8 | 0;
 } else {
  i1 = i6 + 8 | 0;
  if (__ZN5physx6shdfnd15atomicDecrementEPVi(i6 + 12 | 0) | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 return 0;
}

function __ZN4crnd21crnd_get_texture_infoEPKvjPNS_16crn_texture_infoE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!((i1 | 0) != 0 & i2 >>> 0 > 73 & (i3 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i3 >> 2] | 0) != 40 | i2 >>> 0 < 74) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | 0) != 18552) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0)) >>> 0 < 74) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAPU8[i1 + 7 >> 0] | 0) << 16 | (HEAPU8[i1 + 6 >> 0] | 0) << 24 | (HEAPU8[i1 + 8 >> 0] | 0) << 8 | (HEAPU8[i1 + 9 >> 0] | 0)) >>> 0 > i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 + 4 >> 2] = (HEAPU8[i1 + 12 >> 0] | 0) << 8 | (HEAPU8[i1 + 13 >> 0] | 0);
 HEAP32[i3 + 8 >> 2] = (HEAPU8[i1 + 14 >> 0] | 0) << 8 | (HEAPU8[i1 + 15 >> 0] | 0);
 HEAP32[i3 + 12 >> 2] = HEAPU8[i1 + 16 >> 0];
 HEAP32[i3 + 16 >> 2] = HEAPU8[i1 + 17 >> 0];
 i2 = i1 + 18 | 0;
 i4 = i3 + 32 | 0;
 HEAP32[i4 >> 2] = HEAPU8[i2 >> 0];
 HEAP32[i4 + 4 >> 2] = 0;
 i2 = HEAP8[i2 >> 0] | 0;
 HEAP32[i3 + 20 >> 2] = i2 << 24 >> 24 == 0 | i2 << 24 >> 24 == 9 ? 8 : 16;
 HEAP32[i3 + 24 >> 2] = (HEAPU8[i1 + 26 >> 0] | 0) << 16 | (HEAPU8[i1 + 25 >> 0] | 0) << 24 | (HEAPU8[i1 + 27 >> 0] | 0) << 8 | (HEAPU8[i1 + 28 >> 0] | 0);
 HEAP32[i3 + 28 >> 2] = (HEAPU8[i1 + 30 >> 0] | 0) << 16 | (HEAPU8[i1 + 29 >> 0] | 0) << 24 | (HEAPU8[i1 + 31 >> 0] | 0) << 8 | (HEAPU8[i1 + 32 >> 0] | 0);
 i3 = 1;
 return i3 | 0;
}

function __ZN13dynamic_arrayIP15ReflectionProbeLj4EEC2ERKS2_RK10MemLabelId(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z46Graphics_CUSTOM_Internal_DrawMeshInstancedListP12Il2CppObjectiS0_S0_S0_17ShadowCastingModehiS0_(i1, i8, i2, i7, i10, i11, i3, i12, i5) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i9 = 0;
 if (!i1) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i9) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = i3 << 24 >> 24 != 0;
 if (!i5) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i7 + 8 >> 2] | 0, 0, 64) | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (!i10) {
  i10 = 0;
  __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet(i9, i8, i6, i11, i4, i12, i2, i3, i1, i10);
  return;
 }
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet(i9, i8, i6, i11, i4, i12, i2, i3, i1, i10);
 return;
}

function __Z29StdTemplateConversionFunctionIybEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i9 = i10;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i10 + 4 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i9 = (i9 | 0) != 0;
  i10 = (i10 | 0) != 0;
  i10 = i9 | i10;
  i10 = i10 & 1;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i9 = i10;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 + 4 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i9 = (i9 | 0) != 0;
 i10 = (i10 | 0) != 0;
 i10 = i9 | i10;
 i10 = i10 & 1;
 HEAP8[i1 >> 0] = i10;
 STACKTOP = i8;
 return 1;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 745486 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 264 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 260 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 268 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 256 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Scb5Shape11setGeometryERKNS_10PxGeometryE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i8 + 4 | 0;
 i5 = i6 + 4 | 0;
 switch ((HEAP32[i5 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = 6;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i6 >> 2] | 0;
   if (!(HEAP8[i1 + 2433 >> 0] | 0)) i2 = 4; else {
    i4 = i6;
    i2 = 6;
   }
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  i2 = i6 + 16 | 0;
  __ZN5physx2Sc9ShapeCore11setGeometryERKNS_10PxGeometryE(i2, i7);
  i1 = HEAP32[i6 + -32 + 20 >> 2] | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
  HEAP32[i3 >> 2] = 1;
  HEAP8[i4 >> 0] = 0;
  __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i2, i3, i4);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 } else if ((i2 | 0) == 6) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i6);
  i3 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 >> 2] = i3 | 1;
  i2 = i6 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i1 + 56 | 0, i7);
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 137; else i1 = (HEAP32[i1 >> 2] | 0) + 137 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Cm10Collection6removeERNS_12PxCollectionE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = HEAP32[i1 + 48 >> 2] | 0;
 i8 = i1 + 80 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 i9 = i2 + 64 | 0;
 i10 = i2 + 56 | 0;
 i11 = i2 + 48 | 0;
 i12 = i2 + 52 | 0;
 i13 = i2 + 4 | 0;
 i7 = i2 + 44 | 0;
 i6 = 0;
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  L6 : do if (i2) {
   i4 = HEAP32[i14 + (i6 << 4) >> 2] | 0;
   i5 = i4;
   i5 = i5 + ~(i5 << 15) | 0;
   i5 = (i5 >>> 10 ^ i5) * 9 | 0;
   i5 = i5 >>> 6 ^ i5;
   i5 = i5 + ~(i5 << 11) | 0;
   i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (((i5 >>> 16 ^ i5) & i2 + -1) << 2) >> 2] | 0;
   if ((i2 | 0) != -1) {
    i5 = HEAP32[i11 >> 2] | 0;
    while (1) {
     i3 = i5 + (i2 << 4) | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) {
      i4 = i3;
      break;
     }
     i2 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
     if ((i2 | 0) == -1) break L6;
    }
    if (i4) {
     __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i13, i5 + (i2 << 4) + 8 | 0) | 0;
     __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_(i7, i3) | 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
   }
  } while (0);
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < i1 >>> 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj392ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj391ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj390ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj389ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN28LightProbeProxyVolumeManager25UpdateSHCoeffsTextureDataER21LightProbeProxyVolume(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = i2 + 156 + (HEAP32[i2 + 164 >> 2] << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
  if (!i1) {
   STACKTOP = i7;
   return;
  }
 }
 __ZN9Texture3D15UpdateImageDataEb(i1, 0);
 STACKTOP = i7;
 return;
}

function __ZN15ReflectionProbe16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i5 = i1 + 52 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i3 | 0) > 2 ? i3 : 2;
 i5 = i1 + 56 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i3 | 0) > 0 ? i3 : 0;
 HEAPF32[i4 >> 2] = Math_fround(.00999999977);
 i5 = i1 + 88 | 0;
 i3 = Math_fround(HEAPF32[i5 >> 2]) > Math_fround(.00999999977);
 i3 = HEAP32[(i3 ? i5 : i4) >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i5 = i1 + 96 | 0;
 i7 = Math_fround(HEAPF32[i5 >> 2]) > Math_fround(0.0);
 HEAP32[i5 >> 2] = HEAP32[(i7 ? i5 : i4) >> 2];
 f6 = Math_fround((HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(9.99999974e-06));
 HEAPF32[i4 >> 2] = f6;
 i3 = i1 + 92 | 0;
 i5 = f6 < Math_fround(HEAPF32[i3 >> 2]);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i3 : i4) >> 2];
 i3 = i1 + 132 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i5 = Math_fround(HEAPF32[i3 >> 2]) < Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i4 : i3) >> 2];
 i3 = i1 + 136 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i5 = Math_fround(HEAPF32[i3 >> 2]) < Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i4 : i3) >> 2];
 i1 = i1 + 60 | 0;
 i3 = HEAP16[i1 >> 1] | 0;
 HEAP16[i1 >> 1] = i3 << 16 >> 16 < 0 ? 0 : i3;
 STACKTOP = i2;
 return;
}

function _UNITY_png_image_size(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP32[i2 + 348 >> 2] | 0;
 i1 = HEAP32[i2 + 360 >> 2] | 0;
 if ((i1 | i3) >>> 0 >= 32768) {
  i9 = -1;
  return i9 | 0;
 }
 if (!(HEAP8[i2 + 428 >> 0] | 0)) {
  i9 = Math_imul(i1 + 1 | 0, i3) | 0;
  return i9 | 0;
 }
 i5 = HEAP8[i2 + 434 >> 0] | 0;
 i7 = i5 & 255;
 i9 = (HEAP32[i2 + 344 >> 2] | 0) + -1 | 0;
 i6 = i7 >>> 3;
 i8 = i3 + -1 | 0;
 if ((i5 & 255) > 7) {
  i2 = 0;
  i1 = 0;
  L9 : while (1) {
   i4 = i2;
   while (1) {
    if ((i4 | 0) >= 7) break L9;
    i3 = (i4 | 0) > 1 ? 7 - i4 >> 1 : 3;
    i5 = i4 & 1;
    i2 = i4 + 1 | 0;
    i3 = (i9 + (1 << i3) - (i5 << 3 - (i2 >> 1) & 7) | 0) >>> i3;
    if (!i3) i4 = i2; else break;
   }
   i3 = (Math_imul(i3, i6) | 0) + 1 | 0;
   i7 = (i4 | 0) > 2 ? 8 - i4 >> 1 : 3;
   i1 = (Math_imul(i3, (i8 + (1 << i7) - ((i5 ^ 1) << 3 - (i4 >> 1) & 7) | 0) >>> i7) | 0) + i1 | 0;
  }
  return i1 | 0;
 } else {
  i2 = 0;
  i1 = 0;
  L16 : while (1) {
   i4 = i2;
   while (1) {
    if ((i4 | 0) >= 7) break L16;
    i3 = (i4 | 0) > 1 ? 7 - i4 >> 1 : 3;
    i5 = i4 & 1;
    i2 = i4 + 1 | 0;
    i3 = (i9 + (1 << i3) - (i5 << 3 - (i2 >> 1) & 7) | 0) >>> i3;
    if (!i3) i4 = i2; else break;
   }
   i3 = (((Math_imul(i3, i7) | 0) + 7 | 0) >>> 3) + 1 | 0;
   i6 = (i4 | 0) > 2 ? 8 - i4 >> 1 : 3;
   i1 = (Math_imul(i3, (i8 + (1 << i6) - ((i5 ^ 1) << 3 - (i4 >> 1) & 7) | 0) >>> i6) | 0) + i1 | 0;
  }
  return i1 | 0;
 }
 return 0;
}

function __ZNK9dtNavMesh12getFirstLinkEy(i6, i1, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 if ((i1 & 983040 | 0) == 65536 & 0 == 0) {
  i2 = i1 & 65535;
  if (i2 >>> 0 > (HEAP32[i6 + 44 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  i5 = _bitshift64Lshr(i1 | 0, i3 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i6 + 48 >> 2] | 0;
  if ((i1 + (i2 * 104 | 0) | 0) == 0 ? 1 : (i5 | 0) != (HEAP32[i1 + (i2 * 104 | 0) + 92 >> 2] | 0)) {
   i6 = 0;
   return i6 | 0;
  }
  i1 = HEAP32[i1 + (i2 * 104 | 0) + 88 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = (HEAP32[i6 + 36 >> 2] | 0) + (i1 << 4) | 0;
  return i6 | 0;
 }
 if ((i1 | 0) == 0 & (i3 | 0) == 0) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = _bitshift64Lshr(i1 | 0, i3 | 0, 20) | 0;
 getTempRet0() | 0;
 i4 = i4 & 268435455;
 i5 = i1 & 65535;
 if (i4 >>> 0 >= (HEAP32[i6 + 16 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = _bitshift64Lshr(i1 | 0, i3 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i4 * 56 | 0) + 4 >> 2] | 0) != (i3 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + (i4 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 if (i5 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + (i4 * 56 | 0) + 12 >> 2] | 0) + (i5 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = (HEAP32[i6 + 36 >> 2] | 0) + (i1 << 4) | 0;
 return i6 | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl18getPropertyMessageEN5physx8debugger18NonNegativeIntegerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1 ? (HEAP32[i2 + 232 >> 2] | 0) > (i1 | 0) : 0) {
  i1 = HEAP32[(HEAP32[i2 + 228 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = gb + 148944 + 8;
   i2 = i1 + 4 | 0;
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   i5 = i3 + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 + 4 >> 2] = i4;
   HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   i5 = i1 + 16 | 0;
   i4 = HEAP32[i5 + 4 >> 2] | 0;
   i2 = i3 + 16 | 0;
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i2 + 4 >> 2] = i4;
   HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
   i2 = HEAP32[i1 + 36 >> 2] | 0;
   HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
   HEAP32[i3 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
   HEAP32[i3 + 36 >> 2] = i2;
   HEAP8[i3 + 48 >> 0] = 1;
   return;
  }
 }
 HEAP32[i3 >> 2] = gb + 148944 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 1576256;
 HEAP32[i3 + 8 >> 2] = gb + 1576256;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP32[i3 + 16 >> 2] = gb + 1576256;
 HEAP32[i3 + 20 >> 2] = gb + 1576256;
 HEAP32[i3 + 24 >> 2] = -1;
 i5 = i3 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP8[i5 + 20 >> 0] = 0;
 return;
}

function __ZN8Material25GetDefaultDiffuseMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 1166360 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z21GetManagerFromContexti(4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 477548 | 0, 8);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) {
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 469921 | 0, 27);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i2) | 0;
   HEAP32[gb + 1166240 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i1 = HEAP32[gb + 1166240 >> 2] | 0;
   if (!i1) i1 = 0; else HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
  }
 }
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[gb + 1166360 >> 2] = i2;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN7mecanim5human5HumanC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, f2 = f0, f4 = f0, i5 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1065353216;
 HEAP32[i3 + 28 >> 2] = 1065353216;
 HEAP32[i3 + 32 >> 2] = 1065353216;
 HEAP32[i3 + 36 >> 2] = 1065353216;
 i1 = i3 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i3 + 360 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 364 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 368 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 372 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 376 >> 2] = Math_fround(.5);
 HEAPF32[i3 + 380 >> 2] = Math_fround(.0500000007);
 HEAPF32[i3 + 384 >> 2] = Math_fround(.0500000007);
 i1 = i3 + 388 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP16[i1 + 4 >> 1] = 0;
 HEAP8[i1 + 6 >> 0] = 0;
 i1 = 0;
 f2 = Math_fround(0.0);
 do {
  HEAP32[i3 + 72 + (i1 << 2) >> 2] = -1;
  f4 = Math_fround(HEAPF32[gb + 178764 + (i1 << 2) >> 2]);
  HEAPF32[i3 + 168 + (i1 << 2) >> 2] = f4;
  f2 = Math_fround(f2 + f4);
  HEAP32[i3 + 264 + (i1 << 2) >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 i1 = 0;
 do {
  i5 = i3 + 168 + (i1 << 2) | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) / f2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 24);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 60 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -60 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 24 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 658514 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i7 = i1 + 12 | 0;
   i8 = i2 + 12 | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89768 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN28LightsModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 920 >> 2] | 0) + 8 >> 2] = f4;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 12 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 20 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 21 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 22 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 920 >> 2] | 0;
   HEAPF32[i3 + 104 >> 2] = f4;
   HEAP8[i3 + 110 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 24 | 0, i3 + 112 | 0, f4, HEAP16[i3 + 108 >> 1] | 0) | 0) & 1;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 920 >> 2] | 0;
   HEAPF32[i3 + 368 >> 2] = f4;
   HEAP8[i3 + 374 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 288 | 0, i3 + 376 | 0, f4, HEAP16[i3 + 372 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN20SoundChannelInstance19setReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i2 + 164 >> 2] | 0;
 if (i3 | 0) {
  i9 = (i1 | 0) == 0;
  i7 = i2 + 148 | 0;
  i8 = HEAP16[i7 >> 1] | 0;
  i8 = (((i8 & 65535) >>> 15 & 65535 | i9 & 1) & 65535) << 15 & 65535 | i8 & 32767;
  HEAP16[i7 >> 1] = i8;
  i2 = i2 + 128 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP16[i7 >> 1] = (i9 & 1) << 12 & 65535 | i8 & -4097;
 }
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i1, i3) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 304;
 HEAP32[i5 + 8 >> 2] = gb + 865992;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibPv(i6, i2, i7, i8, i9, i10, i11, i12, i1, i14) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i13 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i13 + 8 | 0;
 i15 = i13;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 41960 + 8;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i15;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i6 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 12 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i16, i15);
 i15 = HEAP32[i16 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i1 + 4 >> 2] = i15;
 HEAP32[i6 + 28 >> 2] = i7;
 HEAP32[i6 + 32 >> 2] = i8;
 HEAP32[i6 + 36 >> 2] = i9;
 HEAP32[i6 + 40 >> 2] = i10;
 HEAP32[i6 + 44 >> 2] = i11;
 HEAP32[i6 + 48 >> 2] = i12;
 i1 = Math_imul(i11, i10) | 0;
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = i1;
  i16 = i1 | -2147483648;
  HEAP32[i4 >> 2] = i16;
  HEAP32[i2 >> 2] = i14;
  STACKTOP = i13;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 i16 = i1 | -2147483648;
 HEAP32[i4 >> 2] = i16;
 HEAP32[i2 >> 2] = i14;
 STACKTOP = i13;
 return;
}

function __ZN11DetailPatch8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i8);
 i4 = i3 + 28 | 0;
 i5 = i8 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i6 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i4, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i4 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 i3 = i3 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i3, i1);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, HEAP32[i3 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
 STACKTOP = i9;
 return;
}

function __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE10deallocateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i9 = i8 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i4 + 4 | 0;
  i6 = i4 + 4 | 0;
  i7 = i4 + 4 | 0;
  do {
   i3 = i2 + -108 | 0;
   HEAP32[i9 >> 2] = i3;
   HEAP32[i3 >> 2] = gb + 59740 + 8;
   i3 = i2 + -68 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -56 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i5 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
   }
   i3 = i2 + -84 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -72 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
   }
   i3 = i2 + -104 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -92 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i7 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
   }
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i10;
 return;
}

function __ZNK11ICallStringcv8UnityStrEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i6 = i8;
 __ZNK11ICallString6ToUTF8Ev(i6, i2);
 i3 = HEAP8[i6 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 i5 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
 i3 = i2 ? HEAP32[i6 + 4 >> 2] | 0 : i3 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i3 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i7 = 4;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (!i3) {
   i7 = i1;
   i7 = i7 + i3 | 0;
   HEAP8[i7 >> 0] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   STACKTOP = i8;
   return;
  }
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i9 = i3 + 16 & -16;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 8 >> 2] = i9 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i7;
 }
 _memcpy(i1 | 0, i5 | 0, i3 | 0) | 0;
 i9 = i1;
 i9 = i9 + i3 | 0;
 HEAP8[i9 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZN8Material23GetStencilWriteMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 1166356 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z21GetManagerFromContexti(4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 477557 | 0, 28);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) {
  i1 = HEAP32[gb + 1166240 >> 2] | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 469921 | 0, 27);
   i1 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i2) | 0;
   HEAP32[gb + 1166240 >> 2] = i1;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   i1 = HEAP32[gb + 1166240 >> 2] | 0;
   if (!i1) i1 = 0; else HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
  }
 }
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[gb + 1166356 >> 2] = i2;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN8DrawUtil24DrawMeshRawFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 32 | 0;
 i7 = i8;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + (i4 * 360 | 0) + 328 >> 2] | 0;
 HEAP32[i7 >> 2] = -1;
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 if (!(__ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb(i3, HEAP32[i5 >> 2] | 0, i2, i6, i7, 0) | 0)) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP16[gb + 1157772 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1157772 | 0, HEAP32[i1 + (i4 * 360 | 0) + 352 >> 2] | 0);
  i2 = gb + 1157772 | 0;
 } else i2 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[i1 + (i4 * 360 | 0) + 188 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, i1 | 0);
 mftCall_viiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 244 >> 2] | 0, i3 | 0, HEAP32[i6 >> 2] | 0, i6 + 8 | 0, HEAP32[i6 + 4 >> 2] | 0, i7 | 0, 1, HEAP32[i6 + 40 >> 2] | 0, i5 | 0);
 __Z15gpu_time_samplev();
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim5human15HumanAdjustMassEPNS0_5HumanE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 if ((HEAP32[i1 + 108 >> 2] | 0) < 0) {
  i2 = i1 + 204 | 0;
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  i3 = i1 + 200 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i3 >> 2]));
  HEAPF32[i2 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 116 >> 2] | 0) < 0) {
  i3 = i1 + 212 | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i1 + 200 | 0;
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 120 >> 2] | 0) < 0) {
  i3 = i1 + 216 | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i1 + 200 | 0;
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 104 >> 2] | 0) < 0) {
  i3 = i1 + 200 | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i1 + 196 | 0;
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 148 >> 2] | 0) < 0) {
  i3 = i1 + 244 | 0;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  i2 = i1 + 188 | 0;
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 if ((HEAP32[i1 + 152 >> 2] | 0) >= 0) return;
 i3 = i1 + 248 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i2 = i1 + 192 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 756016 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i7 = i2;
   i8 = HEAP32[i7 + 4 >> 2] | 0;
   i9 = i1;
   HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i9 + 4 >> 2] = i8;
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89768 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx29solveExtContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i8, i7, i10, i11, i1, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (i7 | 0) {
  i3 = i10 + 16 | 0;
  i6 = 0;
  do {
   i5 = i8 + (i6 << 5) | 0;
   if ((HEAP16[i8 + (i6 << 5) + 8 >> 1] | 0) == -1) i2 = HEAPU16[i8 + (i6 << 5) + 10 >> 1] | 0; else i2 = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP16[i8 + (i6 << 5) + 12 >> 1] | 0) == -1) i4 = HEAPU16[i8 + (i6 << 5) + 14 >> 1] | 0; else i4 = 0;
   __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i10);
   __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i5, i10, i1 + (i2 << 6) | 0, i1 + (i4 << 6) | 0);
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i7 | 0));
 }
 i5 = i10 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i9, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i10 = i11 + (i4 + i2 << 4) | 0;
   i9 = i1 + (i2 << 4) | 0;
   HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(HEAP8[i9 + 128 >> 0] | 0)) i8 = 0; else if (!(HEAP8[i9 + 256 >> 0] | 0)) i8 = 1; else if (!(HEAP8[i9 + 384 >> 0] | 0)) i8 = 2; else if (!(HEAP8[i9 + 512 >> 0] | 0)) i8 = 3; else {
  HEAP32[i9 + 552 >> 2] = 4;
  i9 = 0;
  return i9 | 0;
 }
 HEAP8[i9 + 40 + (i8 << 7) + 88 >> 0] = 1;
 i1 = i9 + 12 | 0;
 i5 = i9 + 40 + (i8 << 7) + 52 | 0;
 do if ((i5 | 0) != (i1 | 0)) {
  i7 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i7 << 24 >> 24 < 0;
  i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i7 = i3 ? HEAP32[i9 + 16 >> 2] | 0 : i7 & 255;
  i3 = i5 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i9 + 40 + (i8 << 7) + 60 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i9 + 40 + (i8 << 7) + 56 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i4, i7 - i4 | 0, i1, 0, i1, i7, i6);
   break;
  }
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i9 + 40 + (i8 << 7) + 56 >> 2] = i7;
   break;
  } else {
   HEAP8[i3 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i9 + 552 >> 2] = i8;
 i9 = 1;
 return i9 | 0;
}

function __ZN11MonoManager14LoadAssembliesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i1 + 224 | 0;
 i10 = i1 + 212 | 0;
 i11 = i1 + 216 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i6 = i2 - i8 >> 4;
 i7 = i1 + 228 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = i5 - i4 >> 2;
 i1 = i8;
 if (i6 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorIPK11Il2CppImageNS_9allocatorIS3_EEE8__appendEj(i9, i6 - i3 | 0);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i1;
 } else if (i6 >>> 0 < i3 >>> 0) {
  i3 = i4 + (i6 << 2) | 0;
  if ((i5 | 0) == (i3 | 0)) i3 = i8; else {
   HEAP32[i7 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
   i3 = i8;
  }
 } else i3 = i8;
 if ((i2 | 0) == (i3 | 0)) return;
 i5 = 0;
 i4 = i1;
 while (1) {
  i1 = HEAP8[i4 + (i5 << 4) + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i4 + (i5 << 4) + 4 >> 2] | 0; else i1 = i1 & 255;
  if (!i1) i1 = i3; else {
   i2 = _il2cpp_domain_get() | 0;
   i1 = (HEAP32[i10 >> 2] | 0) + (i5 << 4) | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   i1 = _il2cpp_domain_assembly_open(i2 | 0, i1 | 0) | 0;
   if (!i1) i1 = 0; else i1 = _il2cpp_assembly_get_image(i1 | 0) | 0;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] = i1;
   i2 = HEAP32[i11 >> 2] | 0;
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i2 - i1 >> 4 >>> 0) break; else {
   i4 = i1;
   i3 = i1;
  }
 }
 return;
}

function __ZN10Collider2D19WakeAllBodyContactsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP32[i1 + 72 >> 2] | 0)) return;
 i1 = HEAP32[(HEAP32[HEAP32[i1 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i1) return;
 do {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  do if (!(HEAP32[i2 + 4 >> 2] & 64)) {
   i3 = HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + 28 >> 2] | 0;
   i4 = i3 + 4 | 0;
   i5 = HEAPU16[i4 >> 1] | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    HEAP16[i4 >> 1] = i5 & 65533;
    HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
    i5 = i3 + 64 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 + 12 >> 2] = 0;
    HEAP32[i5 + 16 >> 2] = 0;
    HEAP32[i5 + 20 >> 2] = 0;
   } else if (!(i5 & 2)) {
    HEAP16[i4 >> 1] = i5 | 2;
    HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
   }
   i2 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + 28 >> 2] | 0;
   i3 = i2 + 4 | 0;
   i4 = HEAPU16[i3 >> 1] | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP16[i3 >> 1] = i4 & 65533;
    HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
    i5 = i2 + 64 | 0;
    HEAP32[i5 >> 2] = 0;
    HEAP32[i5 + 4 >> 2] = 0;
    HEAP32[i5 + 8 >> 2] = 0;
    HEAP32[i5 + 12 >> 2] = 0;
    HEAP32[i5 + 16 >> 2] = 0;
    HEAP32[i5 + 20 >> 2] = 0;
    break;
   }
   if (!(i4 & 2)) {
    HEAP16[i3 >> 1] = i4 | 2;
    HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
   }
  } while (0);
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __Z27Texture2DArray_CUSTOM_ApplyP12Il2CppObjecthh(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i3) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 109 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 do if (i1 << 24 >> 24) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
  HEAP8[i1 + 109 >> 0] = 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
   HEAP8[i1 + 110 >> 0] = 1;
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN14Texture2DArray15UpdateImageDataEb(i1, i6 << 24 >> 24 != 0);
  STACKTOP = i7;
  return;
 }
}

function _tt_cmap4_set_range(i13, i1) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0, i15 = 0;
 i9 = HEAP32[i13 + 32 >> 2] | 0;
 if (i9 >>> 0 <= i1 >>> 0) {
  i14 = -1;
  return i14 | 0;
 }
 i10 = (HEAP32[i13 + 16 >> 2] | 0) + 14 | 0;
 i11 = i13 + 44 | 0;
 i12 = i9 << 1;
 i5 = i12 + 2 | 0;
 i6 = i13 + 40 | 0;
 i7 = i13 + 48 | 0;
 i8 = i9 + -1 | 0;
 i3 = i1;
 while (1) {
  i4 = i10 + (i3 << 1) | 0;
  i2 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
  HEAP32[i11 >> 2] = i2;
  i4 = i4 + i5 | 0;
  i15 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
  HEAP32[i6 >> 2] = i15;
  i4 = i4 + i12 | 0;
  HEAP32[i7 >> 2] = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0)) << 16 >> 16;
  i4 = i4 + i12 | 0;
  i1 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
  if (i3 >>> 0 >= i8 >>> 0 & (i15 | 0) == 65535 & (i2 | 0) == 65535) {
   i2 = HEAP32[i13 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
   if ((i4 + i1 + 2 | 0) >>> 0 > ((HEAP32[i2 + 500 >> 2] | 0) + (HEAP32[i2 + 504 >> 2] | 0) | 0) >>> 0) {
    i14 = 6;
    break;
   }
  }
  if ((i1 | 0) != 65535) break;
  i1 = i3 + 1 | 0;
  if (i1 >>> 0 < i9 >>> 0) i3 = i1; else {
   i1 = -1;
   i14 = 10;
   break;
  }
 }
 if ((i14 | 0) == 6) {
  HEAP32[i7 >> 2] = 1;
  i1 = 0;
 } else if ((i14 | 0) == 10) return i1 | 0;
 HEAP32[i13 + 52 >> 2] = i1 | 0 ? i4 + i1 | 0 : 0;
 HEAP32[i13 + 36 >> 2] = i3;
 i15 = 0;
 return i15 | 0;
}

function __ZNSt3__26locale5__impC2ERKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 >> 2] = gb + 212688 + 8;
 i6 = i1 + 8 | 0;
 i4 = i2 + 8 | 0;
 i5 = i2 + 12 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) >> 2;
 __THREW__ = 0;
 invoke_vii(fb + 4535 | 0, i6 | 0, (i3 >>> 0 > 28 ? i3 : 28) | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i3 = i1 + 144 | 0;
  __THREW__ = 0;
  invoke_vii(fb + 4529 | 0, i3 | 0, i2 + 144 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  do if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   if ((i1 | 0) != (i2 | 0)) {
    __THREW__ = 0;
    invoke_viii(fb + 1050 | 0, i6 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
     break;
    }
   }
   i3 = i1 + 12 | 0;
   i2 = 0;
   while (1) {
    i1 = HEAP32[i6 >> 2] | 0;
    if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0) break;
    i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
    if (i1 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i1);
    i2 = i2 + 1 | 0;
   }
   return;
  } while (0);
  __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i6);
 }
 ___resumeException(i1 | 0);
}

function __ZNKSt3__210__time_put8__do_putEPwRS1_PK2tmcc(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 16 | 0;
 i11 = i7 + 12 | 0;
 i8 = i7;
 i9 = i7 + 8 | 0;
 HEAP32[i11 >> 2] = i10 + 100;
 __ZNKSt3__210__time_put8__do_putEPcRS1_PK2tmcc(i1, i10, i11, i2, i3, i4);
 i4 = i8;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = i10;
 i4 = (HEAP32[i6 >> 2] | 0) - i5 >> 2;
 i2 = _uselocale(HEAP32[i1 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 208 | 0, i5 | 0, i9 | 0, i4 | 0, i8 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) {
    i11 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i11);
   }
  }
  ___resumeException(i1 | 0);
 }
 if (i2 | 0) {
  __THREW__ = 0;
  invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i11 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i11);
  }
 }
 if ((i1 | 0) == -1) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1079323 | 0); else {
  HEAP32[i6 >> 2] = i5 + (i1 << 2);
  STACKTOP = i7;
  return;
 }
}

function __ZN9ShaderLab11ShaderState15AddDeviceStatesEjPK19ShaderPropertySheetS3_(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0;
 i10 = i6 + 12 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 L1 : do if (i11 | 0) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 * 20 | 0) >> 2] | 0) == (i7 | 0)) {
    i1 = 0;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i11 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 i2 = i11 + 1 | 0;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 * 20 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 20 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i10 >> 2] | 0) * 20 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i2;
 i11 = (HEAP32[i6 >> 2] | 0) + (i11 * 20 | 0) | 0;
 __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE(i6, __Z12GetGfxDevicev() | 0, i8, i9, i11);
 HEAP32[i11 >> 2] = i7;
 i11 = 1;
 return i11 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 204 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -204 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 20 | 0;
  if (i1 >>> 0 < 21 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 745374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 24 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 20 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 40 | 0;
  if (i1 >>> 0 < 41 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 709958 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 48 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 44 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 52 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 40 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_(i3, i1, i4, i2, i5, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, f8 = f0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 24 | 0;
 i9 = i7;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f8 + Math_fround(HEAPF32[i1 >> 2]));
 f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(f13 + Math_fround(HEAPF32[i1 + 4 >> 2]));
 f11 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f15 = Math_fround(f11 + Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i10 >> 2] = f8;
 HEAPF32[i10 + 4 >> 2] = f13;
 HEAPF32[i10 + 8 >> 2] = f11;
 HEAPF32[i10 + 12 >> 2] = f14;
 HEAPF32[i10 + 16 >> 2] = f12;
 HEAPF32[i10 + 20 >> 2] = f15;
 f15 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f15 + Math_fround(HEAPF32[i2 >> 2]));
 f14 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(f14 + Math_fround(HEAPF32[i2 + 4 >> 2]));
 f13 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f8 = Math_fround(f13 + Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i9 >> 2] = f15;
 HEAPF32[i9 + 4 >> 2] = f14;
 HEAPF32[i9 + 8 >> 2] = f13;
 HEAPF32[i9 + 12 >> 2] = f12;
 HEAPF32[i9 + 16 >> 2] = f11;
 HEAPF32[i9 + 20 >> 2] = f8;
 f8 = Math_fround(__ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_(i10, i9, i5, i6));
 STACKTOP = i7;
 return Math_fround(f8);
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj396ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj395ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18AudioMixerSnapshot8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863864 | 0, gb + 863877 | 0, i5, 0);
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i5, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 863961 | 0, gb + 863904 | 0, i1, 0);
 __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL17setupOverlapFlagsjP13BoxPrunerData(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = (i10 | 0) == 0;
 if (i1) return; else i2 = 0;
 do {
  HEAP32[i11 + (i2 * 40 | 0) + 32 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 if (i1) return; else i9 = 0;
 do {
  i1 = i9;
  i9 = i9 + 1 | 0;
  if (i9 >>> 0 < i10 >>> 0 ? (HEAP32[i11 + (i1 * 40 | 0) + 28 >> 2] | 0) != 0 : 0) {
   i6 = i11 + (i1 * 40 | 0) + 16 | 0;
   i7 = i11 + (i1 * 40 | 0) + 4 | 0;
   i8 = i11 + (i1 * 40 | 0) + 20 | 0;
   i3 = i11 + (i1 * 40 | 0) + 8 | 0;
   i4 = i11 + (i1 * 40 | 0) + 24 | 0;
   i5 = i11 + (i1 * 40 | 0) + 12 | 0;
   i1 = i11 + (i1 * 40 | 0) + 32 | 0;
   i2 = i9;
   do {
    if (HEAP32[i11 + (i2 * 40 | 0) + 28 >> 2] | 0) if ((HEAP32[i6 >> 2] | 0) >>> 0 > (HEAP32[i11 + (i2 * 40 | 0) + 4 >> 2] | 0) >>> 0) if ((HEAP32[i11 + (i2 * 40 | 0) + 16 >> 2] | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) if ((HEAP32[i8 >> 2] | 0) >>> 0 > (HEAP32[i11 + (i2 * 40 | 0) + 8 >> 2] | 0) >>> 0) if ((HEAP32[i11 + (i2 * 40 | 0) + 20 >> 2] | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) if ((HEAP32[i4 >> 2] | 0) >>> 0 > (HEAP32[i11 + (i2 * 40 | 0) + 12 >> 2] | 0) >>> 0) if ((HEAP32[i11 + (i2 * 40 | 0) + 24 >> 2] | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
     HEAP32[i1 >> 2] = 1;
     HEAP32[i11 + (i2 * 40 | 0) + 32 >> 2] = 1;
    }
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i10 | 0));
  }
 } while ((i9 | 0) != (i10 | 0));
 return;
}

function __Z29GetTerrainScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1467748 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 937433 | 0, 16) | 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[gb + 1467748 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937557 | 0) | 0;
 HEAP32[HEAP32[gb + 1467748 >> 2] >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937573 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 4 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937588 | 0) | 0;
 i2 = HEAP32[gb + 1467748 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 i2 = i2 + 12 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 937588 | 0, gb + 937596 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937620 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 20 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937633 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 24 >> 2] = i2;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 324 | 0, fb + 325 | 0);
 i2 = HEAP32[gb + 1467748 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 3) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -8 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 140 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i5 + 724 >> 2]);
 f7 = Math_fround(f7 * f7);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 if (!i1) {
  HEAP32[i3 >> 2] = HEAP32[i5 + 572 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 576 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 580 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 584 >> 2];
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_16ConstantIteratorIS2_EEEEvRT_RKS2_(i5, i3, i5 + 588 | 0);
  STACKTOP = i6;
  return;
 } else {
  i3 = HEAP32[gb + 1097472 + 12 >> 2] & i2;
  i8 = HEAP32[gb + 1097472 + 8 >> 2] & i2;
  i9 = HEAP32[gb + 1097472 + 4 >> 2] & i2;
  HEAP32[i4 >> 2] = HEAP32[gb + 1097472 >> 2] & i2;
  HEAP32[i4 + 4 >> 2] = i9;
  HEAP32[i4 + 8 >> 2] = i8;
  HEAP32[i4 + 12 >> 2] = i3;
  HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 572 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 576 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 580 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i5 + 584 >> 2];
  HEAP32[i4 + 32 >> 2] = i1;
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_17ScaleBiasIteratorIS2_PKS2_EEEEvRT_RS6_(i5, i4, i5 + 588 | 0);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 137; else i1 = (HEAP32[i1 >> 2] | 0) + 137 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 136; else i1 = (HEAP32[i1 >> 2] | 0) + 136 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89888 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc13ConstraintSim18createLLConstraintEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP32[i5 + 100 >> 2] | 0;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = __ZN5physx2Sc5Scene23allocateConstraintBlockEj(HEAP32[i5 + 96 >> 2] | 0, i1) | 0;
 if (!i2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 680097 | 0, 112, gb + 680189 | 0, i6);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 _memset(i2 | 0, 0, i1 | 0) | 0;
 __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_(i4, i5 + 32 | 0, i5 + 36 | 0);
 HEAP32[i5 + 84 >> 2] = HEAPU16[i4 >> 1];
 HEAP32[i5 + 40 >> 2] = HEAP32[i4 + 44 >> 2];
 HEAP32[i5 + 44 >> 2] = i1;
 HEAP32[i5 + 48 >> 2] = HEAP32[i4 + 36 >> 2];
 HEAP32[i5 + 52 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i5 + 56 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAP32[i5 + 60 >> 2] = i2;
 HEAP32[i5 + 64 >> 2] = i5;
 i1 = HEAP32[i5 + 108 >> 2] | 0;
 i7 = (i1 | 0) == 0;
 i1 = i7 ? 0 : i1 + 64 | 0;
 HEAP32[i5 + 68 >> 2] = i1;
 i3 = HEAP32[i5 + 112 >> 2] | 0;
 i2 = (i3 | 0) == 0;
 i3 = i2 ? 0 : i3 + 64 | 0;
 HEAP32[i5 + 72 >> 2] = i3;
 if (i7) i1 = 0; else i1 = HEAP32[i1 + 64 >> 2] | 0;
 HEAP32[i5 + 76 >> 2] = i1;
 if (i2) i1 = 0; else i1 = HEAP32[i3 + 64 >> 2] | 0;
 HEAP32[i5 + 80 >> 2] = i1;
 HEAP32[i5 + 92 >> 2] = HEAP32[i4 + 64 >> 2];
 i7 = 1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj78ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj74ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj73ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj72ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj70ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj69ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj68ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj67ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4Mesh14ClearSkinCacheEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 164 | 0;
 i2 = i4 + 180 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 168 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 176 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 i1 = i3 + 184 | 0;
 i2 = i3 + 200 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 188 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 196 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 204 | 0;
 i2 = i3 + 220 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 208 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 188 >> 2] = -1;
 i1 = i4 + 192 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 196 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 200 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 236 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14RenderSettings8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 360 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = i4 + 352 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 348 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 380 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 384 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i4 + 388 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 36 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 36 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 36 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + (i5 * 36 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i5 * 36 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + (i5 * 36 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + (i5 * 36 | 0) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + (i5 * 36 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i9 + (i5 * 36 | 0) + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 i9 = i9 + (i5 * 36 | 0) + 24 | 0;
 i8 = i3 + 24 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 return;
}

function __ZN13GfxDeviceGLES20DestroyComputeBufferE15ComputeBufferID(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i6 + 8452 | 0;
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i5;
 L4 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L4;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) return;
 if ((i3 | 0) == (i5 | 0) ? 1 : i4 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0) return;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN14DataBufferGLES7ReleaseEv(i1);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) __ZN14DataBufferGLES7ReleaseEv(i1);
 i1 = i6 + 7428 + (HEAP32[i2 + 36 >> 2] << 2) | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) HEAP32[i1 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
 i7 = i6 + 8460 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 8456 >> 2] | 0, i3);
 __ZdlPv(i3);
 return;
}

function __ZNSt3__214__split_bufferI24CompressedAnimationCurveR13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i8 + 4 | 0;
  do {
   HEAP32[i5 >> 2] = i1 + -88;
   i2 = i1 + -16 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
   }
   i2 = HEAP32[i1 + -36 >> 2] | 0;
   if (i2 | 0) {
    i3 = i1 + -32 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
    __ZdlPv(i2);
   }
   i2 = HEAP32[i1 + -64 >> 2] | 0;
   if (i2 | 0) {
    i3 = i1 + -60 | 0;
    if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
    __ZdlPv(i2);
   }
   i2 = HEAP32[i1 + -80 >> 2] | 0;
   if (i2 | 0) {
    i1 = i1 + -76 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
    __ZdlPv(i2);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i7 = HEAP32[HEAP32[i7 + 16 >> 2] >> 2] | 0;
 HEAP32[i8 >> 2] = 25;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 24 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -24 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 336 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -336 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 16 | 0;
  if (i1 >>> 0 < 17 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 707297 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 24 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 20 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 16 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx14NpArticulation12applyImpulseEPNS_18PxArticulationLinkERKNS_24PxArticulationDriveCacheERKNS_6PxVec3ES8_(i5, i3, i1, i2, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 12 | 0;
 i8 = i10;
 if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 68 >> 2] | 0, i5 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0);
 __ZN5physx2Sc16ArticulationCore12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_(i5 + 24 | 0, i3 + 64 | 0, i1, i2, i4);
 i7 = i5 + 92 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = i5 + 88 | 0;
 i2 = i9 + 4 | 0;
 i3 = i9 + 8 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8 + 8 | 0;
 i6 = 0;
 do {
  i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[i11 + 144 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i11 + 148 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i11 + 152 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i11 + 160 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i11 + 164 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i11 + 168 >> 2];
  mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 156 >> 2] | 0, i11 | 0, i9 | 0, 1);
  i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 164 >> 2] | 0, i11 | 0, i8 | 0, 1);
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 STACKTOP = i10;
 return;
}

function __ZN17ProfilerFrameData28SerializeProfilerInformationERK19ProfilerInformationR13dynamic_arrayIiLj4EE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = _strlen(i3) | 0;
 i9 = i8 + 12 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i8, ((i2 | 0) / 4 | 0) + 1 + i4 | 0, i5, 1);
 _memcpy((HEAP32[i8 >> 2] | 0) + (i4 << 2) | 0, i3 | 0, i2 + 1 | 0) | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i2 << 16 | i2 >>> 16;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i3 << 2) >> 2] = i2;
 STACKTOP = i10;
 return;
}

function __Z36RenderSettings_Get_Custom_PropSkyboxv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = (__Z17GetRenderSettingsv() | 0) + 360 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z32ScriptingArrayToPPtrDynamicArrayI18AudioMixerSnapshotEvP11Il2CppArrayR13dynamic_arrayI4PPtrIT_EXsr11AlignOfTypeIS6_EE5alignEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i2 = i5 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 if (!i4) return;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i3 >> 2] = i6;
 i1 = HEAP32[i2 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i6 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i6 << 2, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if ((i6 | 0) > 0) i2 = 0; else return;
 do {
  i1 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i4, i2) | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i3 + (i2 << 2) >> 2] = i1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function ___dns_query(i8, i2, i3, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i9 + 24 | 0;
 i1 = i9 + 16 | 0;
 i5 = (i3 | 0) == 10;
 do if (!i4) {
  if (i5) {
   HEAP32[i1 >> 2] = 28;
   i3 = 1;
   break;
  }
  HEAP32[i1 >> 2] = 1;
  if ((i3 | 0) == 2) i3 = 1; else {
   HEAP32[i1 + 4 >> 2] = 28;
   i3 = 2;
  }
 } else {
  if (i5) {
   i3 = i7;
   i4 = 15;
   while (1) {
    i6 = i2 + i4 | 0;
    HEAP8[i3 >> 0] = HEAP8[((HEAPU8[i6 >> 0] | 0) & 15) + (gb + 1074037) >> 0] | 0;
    HEAP8[i3 + 1 >> 0] = 46;
    HEAP8[i3 + 2 >> 0] = HEAP8[((HEAPU8[i6 >> 0] | 0) >>> 4) + (gb + 1074037) >> 0] | 0;
    HEAP8[i3 + 3 >> 0] = 46;
    if ((i4 | 0) > 0) {
     i3 = i3 + 4 | 0;
     i4 = i4 + -1 | 0;
    } else break;
   }
   i2 = i7 + 64 | 0;
   i3 = gb + 1074054 | 0;
   i4 = i2 + 9 | 0;
   do {
    HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
  } else {
   i3 = HEAPU8[i2 + 2 >> 0] | 0;
   i4 = HEAPU8[i2 + 1 >> 0] | 0;
   i5 = HEAPU8[i2 >> 0] | 0;
   HEAP32[i6 >> 2] = HEAPU8[i2 + 3 >> 0];
   HEAP32[i6 + 4 >> 2] = i3;
   HEAP32[i6 + 8 >> 2] = i4;
   HEAP32[i6 + 12 >> 2] = i5;
   _sprintf(i7, gb + 1074063 | 0, i6) | 0;
  }
  HEAP32[i1 >> 2] = 12;
  i3 = 1;
  i2 = i7;
 } while (0);
 i8 = ___dns_doqueries(i8, i2, i1, i3) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 120 | 0, i6);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, gb + 673520 | 0);
 __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i5, HEAP32[i5 + 24 >> 2] | 0, i1 + 136 | 0, 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 3 | 0;
 return i6 | 0;
}

function __ZNK5physx23PxCapsuleControllerDesc7isValidEv(i5) {
 i5 = i5 | 0;
 var f1 = f0, i2 = 0, i3 = 0, f4 = f0, i6 = 0;
 if ((HEAP32[i5 + 104 >> 2] | 0) >>> 0 >= 2) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i5 + 68 >> 2]) < Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i5 + 72 >> 2]) < Math_fround(1.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i5 + 64 >> 2]) < Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i5 + 44 >> 2]) < Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i5 + 60 | 0;
 if (Math_fround(HEAPF32[i6 >> 2]) < Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i5 + 56 >> 2]) <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(HEAP32[i5 + 96 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i5 + 80 >> 2] | 0;
 if (i2 | 0) {
  i3 = i5 + 76 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   HEAP32[i3 >> 2] = i2;
   i3 = _PxGetFoundation() | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0) | 0;
   mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 2, gb + 733824 | 0, gb + 733919 | 0, 640);
  }
 }
 f4 = Math_fround(HEAPF32[i5 + 108 >> 2]);
 if (f4 <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 f1 = Math_fround(HEAPF32[i5 + 112 >> 2]);
 if (f1 <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = !(Math_fround(HEAPF32[i6 >> 2]) > Math_fround(Math_fround(f4 * Math_fround(2.0)) + f1));
 return i6 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj581ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj580ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj579ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj578ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj577ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj576ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj575ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj574ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj573ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj490ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 16 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15b2DistanceProxy3SetEPK7b2Shapei(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 switch (HEAP32[i4 + 4 >> 2] | 0) {
 case 0:
  {
   HEAP32[i3 + 16 >> 2] = i4 + 12;
   HEAP32[i3 + 20 >> 2] = 1;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 case 2:
  {
   HEAP32[i3 + 16 >> 2] = i4 + 20;
   HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 148 >> 2];
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 case 4:
  {
   HEAP32[i3 + 16 >> 2] = i4 + 12;
   HEAP32[i3 + 20 >> 2] = 2;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 case 3:
  {
   i5 = i4 + 12 | 0;
   i7 = (HEAP32[i5 >> 2] | 0) + (i1 << 3) | 0;
   i6 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = i3;
   HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i2 + 4 >> 2] = i6;
   i1 = i1 + 1 | 0;
   i2 = i3 + 8 | 0;
   if ((i1 | 0) < (HEAP32[i4 + 16 >> 2] | 0)) {
    i5 = (HEAP32[i5 >> 2] | 0) + (i1 << 3) | 0;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i7 = i2;
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = i6;
   } else {
    i5 = HEAP32[i5 >> 2] | 0;
    i6 = HEAP32[i5 + 4 >> 2] | 0;
    i7 = i2;
    HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i7 + 4 >> 2] = i6;
   }
   HEAP32[i3 + 16 >> 2] = i3;
   HEAP32[i3 + 20 >> 2] = 2;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 case 1:
  {
   HEAP32[i3 + 16 >> 2] = i4 + 12;
   HEAP32[i3 + 20 >> 2] = 2;
   HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 default:
  return;
 }
}

function _Current_Ppem_Stretched(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = HEAPU16[i2 + 252 >> 1] | 0;
 i6 = i2 + 244 | 0;
 i7 = i2 + 256 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 i4 = HEAP16[i2 + 296 >> 1] | 0;
 if (!(i4 << 16 >> 16)) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  i7 = i6;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 i3 = HEAP16[i2 + 294 >> 1] | 0;
 i1 = HEAP32[i2 + 248 >> 2] | 0;
 if (!(i3 << 16 >> 16)) {
  HEAP32[i7 >> 2] = i1;
  i7 = i1;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 } else {
  i8 = i3 << 16 >> 16;
  i9 = HEAP32[i6 >> 2] | 0;
  i6 = (i9 | 0) < 0 ? 0 - i9 | 0 : i9;
  i2 = i3 << 16 >> 16 < 0 ? 0 - i8 | 0 : i8;
  i3 = Math_imul(i6 >>> 16, i2) | 0;
  i11 = i3 << 16 | 8192;
  i2 = i11 + (Math_imul(i6 & 65535, i2) | 0) | 0;
  i2 = (i2 >>> 0 < i11 >>> 0 & 1) + (i3 >>> 16) << 18 | i2 >>> 14;
  i3 = i4 << 16 >> 16;
  i11 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
  i6 = i4 << 16 >> 16 < 0 ? 0 - i3 | 0 : i3;
  i4 = Math_imul(i11 >>> 16, i6) | 0;
  i10 = i4 << 16 | 8192;
  i6 = i10 + (Math_imul(i11 & 65535, i6) | 0) | 0;
  i6 = (i6 >>> 0 < i10 >>> 0 & 1) + (i4 >>> 16) << 18 | i6 >>> 14;
  i6 = _UNITY_FT_Hypot((i9 ^ i8 | 0) > -1 ? i2 : 0 - i2 | 0, (i1 ^ i3 | 0) > -1 ? i6 : 0 - i6 | 0) | 0;
  HEAP32[i7 >> 2] = i6;
  i7 = i6;
  i7 = _UNITY_FT_MulFix(i5, i7) | 0;
  return i7 | 0;
 }
 return 0;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i4, i3, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 HEAP32[i6 >> 2] = i3;
 i3 = _uselocale(HEAP32[i1 + 8 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 506 | 0, i2 | 0, 0, i4 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   }
  }
  ___resumeException(i1 | 0);
 }
 if (i3 | 0) {
  __THREW__ = 0;
  invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  }
 }
 L12 : do switch (i1 | 0) {
 case 0:
 case -1:
  {
   i1 = 2;
   break;
  }
 default:
  {
   i1 = i1 + -1 | 0;
   if (i1 >>> 0 > (i5 - (HEAP32[i6 >> 2] | 0) | 0) >>> 0) i1 = 1; else while (1) {
    if (!i1) {
     i1 = 0;
     break L12;
    }
    i4 = HEAP8[i2 >> 0] | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i5 + 1;
    HEAP8[i5 >> 0] = i4;
    i2 = i2 + 1 | 0;
    i1 = i1 + -1 | 0;
   }
  }
 } while (0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNKSt3__26localeeqERKS0_(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i5 | 0)) i1 = 1; else {
  i2 = i1 + 144 | 0;
  i7 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = HEAP32[i1 + 148 >> 2] | 0;
  if (((i7 << 24 >> 24 < 0 ? i4 : i7 & 255) | 0) == 1) {
   __THREW__ = 0;
   i1 = invoke_iiiiii(fb + 192 | 0, i2 | 0, 0, -1, gb + 1086428 | 0, 1) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   }
   if (!i1) {
    i1 = 0;
    break;
   }
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = i4;
   i5 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP8[i4 + 144 + 11 >> 0] | 0;
   i4 = HEAP32[i4 + 148 >> 2] | 0;
  } else i2 = i7;
  i1 = i1 + 144 | 0;
  i6 = i5 + 144 | 0;
  i7 = i2 << 24 >> 24 < 0;
  i3 = i2 & 255;
  i4 = i7 ? i4 : i3;
  i8 = HEAP8[i6 + 11 >> 0] | 0;
  i2 = i8 << 24 >> 24 < 0;
  if ((i4 | 0) == ((i2 ? HEAP32[i5 + 148 >> 2] | 0 : i8 & 255) | 0)) {
   i2 = i2 ? HEAP32[i6 >> 2] | 0 : i6;
   if (i7) {
    i1 = (__ZNSt3__211char_traitsIcE7compareEPKcS3_j(HEAP32[i1 >> 2] | 0, i2, i4) | 0) == 0;
    break;
   }
   while (1) {
    if (!i3) {
     i1 = 1;
     break L1;
    }
    if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
     i1 = 0;
     break L1;
    }
    i3 = i3 + -1 | 0;
    i2 = i2 + 1 | 0;
    i1 = i1 + 1 | 0;
   }
  } else i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 64 | 0;
  if (i1 >>> 0 < 65 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 745486 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 72 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 68 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 76 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 64 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 20 | 0;
  if (i1 >>> 0 < 21 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 745486 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 24 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 20 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEE14handleAccessorILj279ENS_22PxRepXPropertyAccessorILj279ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89472 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj459ENS_22PxRepXPropertyAccessorILj459ES4_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 196; else i1 = (HEAP32[i1 >> 2] | 0) + 196 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115504 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx25PxRigidActorGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 HEAP32[i1 + 120 >> 2] = gb + 673509;
 HEAP32[i1 + 124 >> 2] = 23;
 HEAP32[i1 + 128 >> 2] = fb + 3496;
 HEAP32[i1 + 132 >> 2] = fb + 3497;
 HEAP32[i1 + 136 >> 2] = gb + 673520;
 HEAP32[i1 + 140 >> 2] = 24;
 HEAP32[i1 + 144 >> 2] = fb + 398;
 HEAP32[i1 + 148 >> 2] = fb + 2119;
 HEAP32[i1 + 152 >> 2] = gb + 673527;
 HEAP32[i1 + 156 >> 2] = 25;
 HEAP32[i1 + 160 >> 2] = fb + 399;
 HEAP32[i1 + 164 >> 2] = fb + 2120;
 return;
}

function __ZN19AssetBundleManifestD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = gb + 27928 + 8;
 i1 = HEAP32[i8 + 64 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i8 + 68 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i3 = i8 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i8 + 56 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    HEAP32[i4 >> 2] = i2 + -8;
    __ZN14ConstantStringD2Ev(i2 + -4 | 0);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i6 = i8 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = gb + 32336 + 8;
  i7 = i8 + 28 | 0;
  __ZN14ConstantStringD2Ev(i7);
  HEAP32[i8 >> 2] = gb + 26392 + 8;
  return;
 }
 i7 = i8 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -40 | 0;
   HEAP32[i7 >> 2] = i3;
   i4 = HEAP32[i2 + -16 >> 2] | 0;
   i5 = i4;
   if (!i4) i2 = i3; else {
    i2 = i2 + -12 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
    __ZdlPv(i4);
    i2 = HEAP32[i7 >> 2] | 0;
   }
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i8 >> 2] = gb + 32336 + 8;
 i7 = i8 + 28 | 0;
 __ZN14ConstantStringD2Ev(i7);
 HEAP32[i8 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12TreeDatabase24RecalculateTreePositionsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = (HEAP32[i5 >> 2] | 0) + 248 | 0;
 __ZNK9Heightmap7GetSizeEv(i1, i6);
 i7 = i5 + 16 | 0;
 i8 = i5 + 20 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i3 | 0)) {
  __ZN12TreeDatabase13ValidateTreesEv(i5);
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i8, 2);
  STACKTOP = i9;
  return;
 }
 i4 = i1 + 4 | 0;
 i2 = 0;
 i1 = i3;
 do {
  i10 = i1;
  i12 = HEAP32[i10 + (i2 * 40 | 0) >> 2] | 0;
  i10 = HEAP32[i10 + (i2 * 40 | 0) + 8 >> 2] | 0;
  f11 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i6, f11, (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]))));
  f11 = Math_fround(f11 / Math_fround(HEAPF32[i4 >> 2]));
  i3 = HEAP32[i7 >> 2] | 0;
  HEAP32[i3 + (i2 * 40 | 0) >> 2] = i12;
  HEAPF32[i3 + (i2 * 40 | 0) + 4 >> 2] = f11;
  HEAP32[i3 + (i2 * 40 | 0) + 8 >> 2] = i10;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i8 >> 2] | 0) - i1 | 0) / 40 | 0) >>> 0);
 __ZN12TreeDatabase13ValidateTreesEv(i5);
 i12 = HEAP32[i5 >> 2] | 0;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i12, 2);
 STACKTOP = i9;
 return;
}

function __ZN11UnityEngine9Animation31GetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = HEAP32[i1 >> 2] | 0;
 if ((i12 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i10 = i1 + 4 | 0;
 i6 = i2 + 4 | 0;
 i7 = i6;
 i2 = i11 + 4 | 0;
 i3 = i11 + 8 | 0;
 i8 = i11 + 4 | 0;
 i9 = i11 + 8 | 0;
 i4 = i11 + 12 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i5 | 0) {
   i14 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
   __ZNK9Transform16GetLocalPositionEv(i11, i5);
   i15 = HEAP32[i2 >> 2] | 0;
   i16 = HEAP32[i3 >> 2] | 0;
   HEAP32[i14 + (i1 * 40 | 0) >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + (i1 * 40 | 0) + 4 >> 2] = i15;
   HEAP32[i14 + (i1 * 40 | 0) + 8 >> 2] = i16;
   i14 = (HEAP32[i6 >> 2] | 0) + i7 | 0;
   __ZNK9Transform16GetLocalRotationEv(i11, i5);
   i16 = HEAP32[i8 >> 2] | 0;
   i15 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   HEAP32[i14 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i14 + (i1 * 40 | 0) + 16 >> 2] = i16;
   HEAP32[i14 + (i1 * 40 | 0) + 20 >> 2] = i15;
   HEAP32[i14 + (i1 * 40 | 0) + 24 >> 2] = i5;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 STACKTOP = i13;
 return;
}

function __GLOBAL__sub_I_runtime_particlesystem_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452152 | 0, gb + 615387 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452164 | 0, gb + 615409 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451704 | 0, gb + 615432 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452176 | 0, gb + 615455 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452188 | 0, gb + 615483 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452200 | 0, gb + 615508 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452212 | 0, gb + 615544 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452224 | 0, gb + 615571 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452236 | 0, gb + 615603 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452248 | 0, gb + 615623 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452260 | 0, gb + 615649 | 0, 0, 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1452272 | 0, 13);
 return;
}

function _UNITY_png_write_cHRM_fixed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 32 | 0;
 i4 = i5;
 _UNITY_png_save_int_32(i4, HEAP32[i2 + 24 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 4 | 0, HEAP32[i2 + 28 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 8 | 0, HEAP32[i2 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 12 | 0, HEAP32[i2 + 4 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 16 | 0, HEAP32[i2 + 8 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 20 | 0, HEAP32[i2 + 12 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 24 | 0, HEAP32[i2 + 16 >> 2] | 0);
 _UNITY_png_save_int_32(i4 + 28 | 0, HEAP32[i2 + 20 >> 2] | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i1 + 656 | 0;
 HEAP32[i2 >> 2] = 34;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 32;
 i6 = i3 + 4 | 0;
 HEAP8[i6 >> 0] = 99;
 HEAP8[i3 + 5 >> 0] = 72;
 HEAP8[i3 + 6 >> 0] = 82;
 HEAP8[i3 + 7 >> 0] = 77;
 _UNITY_png_write_data(i1, i3, 8);
 HEAP32[i1 + 372 >> 2] = 1665684045;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i6, 4);
 HEAP32[i2 >> 2] = 66;
 _UNITY_png_write_data(i1, i4, 32);
 _UNITY_png_calculate_crc(i1, i4, 32);
 HEAP32[i2 >> 2] = 130;
 i4 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i3 >> 0] = i4 >>> 24;
 HEAP8[i3 + 1 >> 0] = i4 >>> 16;
 HEAP8[i3 + 2 >> 0] = i4 >>> 8;
 HEAP8[i3 + 3 >> 0] = i4;
 _UNITY_png_write_data(i1, i3, 4);
 STACKTOP = i5;
 return;
}

function _wcsnrtombs(i3, i11, i6, i2, i1) {
 i3 = i3 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i5 = HEAP32[i11 >> 2] | 0;
 HEAP32[i8 >> 2] = i5;
 i9 = (i3 | 0) != 0;
 i4 = i9 ? i2 : 256;
 i3 = i9 ? i3 : i7;
 i2 = i5;
 L1 : do if ((i4 | 0) != 0 & (i5 | 0) != 0) {
  i1 = 0;
  i5 = i2;
  while (1) {
   i2 = i6 >>> 0 >= i4 >>> 0;
   if (!(i2 | i6 >>> 0 > 32)) {
    i2 = i5;
    break L1;
   }
   i2 = i2 ? i4 : i6;
   i6 = i6 - i2 | 0;
   i2 = _wcsrtombs(i3, i8, i2, 0) | 0;
   if ((i2 | 0) == -1) break;
   i5 = (i3 | 0) == (i7 | 0);
   i4 = i4 - (i5 ? 0 : i2) | 0;
   i3 = i5 ? i3 : i3 + i2 | 0;
   i1 = i2 + i1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if ((i4 | 0) != 0 & (i2 | 0) != 0) i5 = i2; else break L1;
  }
  i1 = -1;
  i4 = 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else i1 = 0; while (0);
 L8 : do if (i2) if ((i4 | 0) != 0 & (i6 | 0) != 0) {
  i5 = i3;
  while (1) {
   i3 = _wcrtomb(i5, HEAP32[i2 >> 2] | 0, 0) | 0;
   if ((i3 + 1 | 0) >>> 0 < 2) break;
   i2 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
   HEAP32[i8 >> 2] = i2;
   i6 = i6 + -1 | 0;
   i4 = i4 - i3 | 0;
   i1 = i1 + 1 | 0;
   if (!((i4 | 0) != 0 & (i6 | 0) != 0)) break L8; else i5 = i5 + i3 | 0;
  }
  if (!i3) HEAP32[i8 >> 2] = 0; else i1 = -1;
 } while (0);
 if (i9) HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 STACKTOP = i10;
 return i1 | 0;
}

function _ctanh(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, i4 = 0, i5 = 0, d7 = 0.0, d8 = 0.0;
 d3 = +HEAPF64[i1 >> 3];
 d2 = +HEAPF64[i1 + 8 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d3;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i1 = i5 & 2147483647;
 do if (i1 >>> 0 > 2146435071) {
  if (i5 & 1048575 | i4 | 0) {
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i6 + 8 >> 3] = d2 == 0.0 ? d2 : d3 * d2;
   break;
  }
  HEAPF64[tempDoublePtr >> 3] = d2;
  if (!((HEAP32[tempDoublePtr >> 2] | 0) == 0 ? (HEAP32[tempDoublePtr + 4 >> 2] & 2147483647 | 0) == 2146435072 : 0)) d2 = +Math_sin(+d2) * +Math_cos(+d2);
  d3 = +_copysign(0.0, d2);
  i1 = i6;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = i5 + -1073741824;
  HEAPF64[i6 + 8 >> 3] = d3;
 } else {
  HEAPF64[tempDoublePtr >> 3] = d2;
  i5 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
  if (!(i5 >>> 0 < 2146435072 | (i5 | 0) == 2146435072 & 0 < 0)) {
   d3 = d2 - d2;
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i6 + 8 >> 3] = d3;
   break;
  }
  if (i1 >>> 0 > 1077280767) {
   d7 = +Math_exp(+-+Math_abs(+d3));
   d2 = d7 * (d7 * (+Math_sin(+d2) * 4.0 * +Math_cos(+d2)));
   HEAPF64[i6 >> 3] = +_copysign(1.0, d3);
   HEAPF64[i6 + 8 >> 3] = d2;
   break;
  } else {
   d2 = +Math_tan(+d2);
   d8 = d2 * d2 + 1.0;
   d3 = +_sinh(d3);
   d7 = d3 * (d3 * d8) + 1.0;
   HEAPF64[i6 >> 3] = d3 * (d8 * +Math_sqrt(+(d3 * d3 + 1.0))) / d7;
   HEAPF64[i6 + 8 >> 3] = d2 / d7;
   break;
  }
 } while (0);
 return;
}

function __ZNK17ProceduralTexture11IsGrayscaleEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i1 = i8;
 i4 = i5 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i2) i7 = 6; else {
  if ((HEAP32[i2 + 36 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i9 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[i2 + 32 >> 2] | 0;
   i1 = i9 + (i3 << 3) | 0;
   i2 = i9;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i6, i2, i1);
   i1 = HEAP32[i6 >> 2] | 0;
   i9 = HEAP32[i2 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i9 + (HEAP32[i2 + 32 >> 2] << 3) | 0 : i9 + (i1 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 8;
  }
 }
 if ((i7 | 0) == 6) i7 = 8;
 if ((i7 | 0) == 8) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 + 192 + 4 >> 2];
 i9 = (HEAP8[(__ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_(i1 + 272 | 0, i6) | 0) >> 0] | 0) != 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i8);
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0) | 0) __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7 + 32 | 0, i8);
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 124 >> 2] | 0, i7 | 0) | 0) {
  i4 = i8 + 16 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = i1 + 1 | 0;
  i3 = i8 + 24 | 0;
  if (i2 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i4, i9, 1);
   i1 = HEAP8[i9 >> 0] | 0;
  } else {
   i1 = HEAP8[i1 >> 0] | 0;
   HEAP8[i9 >> 0] = i1;
   HEAP32[i4 >> 2] = i2;
  }
  HEAP8[i7 + 40 >> 0] = i1;
  i6 = i4;
  i5 = i4;
 } else {
  i5 = i8 + 16 | 0;
  i3 = i8 + 24 | 0;
  i6 = i5;
 }
 i1 = i7 + 41 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i9, 1);
  i9 = HEAP8[i9 >> 0] | 0;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i9 >> 0] = i7;
  HEAP32[i6 >> 2] = i4;
  i9 = i7;
  HEAP8[i1 >> 0] = i9;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i8);
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i4 = i7;
 if (!(HEAP8[i2 + 2433 >> 0] | 0)) {
  __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv(i6 + 156 | 0);
  __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv(i6 + 168 | 0);
  __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb(i2 + 16 | 0, i6 + 12 | 0, i1);
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i2 + 2620 | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i2 >> 2] = i3 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = i3 | -1073741824;
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i4 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i4, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEE14handleAccessorILj287ENS_22PxRepXPropertyAccessorILj287ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89472 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831338;
 HEAP32[i1 + 4 >> 2] = 571;
 HEAP32[i1 + 8 >> 2] = fb + 602;
 HEAP32[i1 + 12 >> 2] = gb + 831350;
 HEAP32[i1 + 16 >> 2] = 572;
 HEAP32[i1 + 20 >> 2] = fb + 603;
 HEAP32[i1 + 24 >> 2] = gb + 831359;
 HEAP32[i1 + 28 >> 2] = 573;
 HEAP32[i1 + 32 >> 2] = fb + 604;
 HEAP32[i1 + 36 >> 2] = fb + 519;
 HEAP32[i1 + 40 >> 2] = gb + 831367;
 HEAP32[i1 + 44 >> 2] = 574;
 HEAP32[i1 + 48 >> 2] = fb + 605;
 HEAP32[i1 + 52 >> 2] = fb + 520;
 HEAP32[i1 + 56 >> 2] = gb + 831374;
 HEAP32[i1 + 60 >> 2] = 575;
 HEAP32[i1 + 64 >> 2] = fb + 606;
 HEAP32[i1 + 68 >> 2] = fb + 521;
 HEAP32[i1 + 72 >> 2] = gb + 831380;
 HEAP32[i1 + 76 >> 2] = 576;
 HEAP32[i1 + 80 >> 2] = fb + 607;
 HEAP32[i1 + 84 >> 2] = fb + 522;
 HEAP32[i1 + 88 >> 2] = gb + 831385;
 HEAP32[i1 + 92 >> 2] = 577;
 HEAP32[i1 + 96 >> 2] = fb + 608;
 HEAP32[i1 + 100 >> 2] = fb + 523;
 HEAP32[i1 + 104 >> 2] = gb + 831398;
 HEAP32[i1 + 108 >> 2] = 578;
 HEAP32[i1 + 112 >> 2] = fb + 609;
 HEAP32[i1 + 116 >> 2] = fb + 524;
 HEAP32[i1 + 120 >> 2] = gb + 831414;
 HEAP32[i1 + 124 >> 2] = 579;
 HEAP32[i1 + 128 >> 2] = fb + 610;
 HEAP32[i1 + 132 >> 2] = fb + 525;
 HEAP32[i1 + 136 >> 2] = gb + 831434;
 HEAP32[i1 + 140 >> 2] = 580;
 HEAP32[i1 + 144 >> 2] = fb + 611;
 HEAP32[i1 + 148 >> 2] = fb + 526;
 HEAP32[i1 + 152 >> 2] = gb + 831444;
 HEAP32[i1 + 156 >> 2] = 581;
 HEAP32[i1 + 160 >> 2] = fb + 612;
 HEAP32[i1 + 164 >> 2] = fb + 527;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj506ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj505ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __Z25CubemapArray_CUSTOM_ApplyP12Il2CppObjecthh(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i3) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 105 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 do if (i1 << 24 >> 24) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
  HEAP8[i1 + 105 >> 0] = 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
   HEAP8[i1 + 106 >> 0] = 1;
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN12CubemapArray15UpdateImageDataEb(i1, i6 << 24 >> 24 != 0);
  STACKTOP = i7;
  return;
 }
}

function __Z24Cubemap_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i9 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI7CubemapEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) >> i7;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  i9 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
  __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii(i2, 0, 0, i1, i1, i9, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 16) | 0, i7, i6);
  STACKTOP = i8;
  return;
 }
}

function _log1p(d1) {
 d1 = +d1;
 var i2 = 0, d3 = 0.0, i4 = 0, d5 = 0.0, i6 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 do if ((i2 | 0) < 0 | i2 >>> 0 < 1071284858) if (i2 >>> 0 > 3220176895) {
  if (d1 == -1.0) {
   d1 = -inf;
   break;
  }
  d1 = (d1 - d1) / 0.0;
  break;
 } else {
  i6 = _bitshift64Shl(i2 | 0, 0, 1) | 0;
  getTempRet0() | 0;
  if (i6 >>> 0 < 2034237440) break;
  if (i2 >>> 0 < 3218259653) {
   d5 = 0.0;
   d3 = 0.0;
   i4 = 11;
   break;
  } else {
   i4 = 8;
   break;
  }
 } else if (i2 >>> 0 <= 2146435071) i4 = 8; while (0);
 if ((i4 | 0) == 8) {
  d3 = d1 + 1.0;
  HEAPF64[tempDoublePtr >> 3] = d3;
  i2 = (HEAP32[tempDoublePtr + 4 >> 2] | 0) + 614242 | 0;
  i4 = (i2 >>> 20) + -1023 | 0;
  if ((i4 | 0) < 54) d3 = ((i4 | 0) > 1 ? 1.0 - (d3 - d1) : d1 - (d3 + -1.0)) / d3; else d3 = 0.0;
  HEAP32[tempDoublePtr >> 2] = HEAP32[tempDoublePtr >> 2];
  HEAP32[tempDoublePtr + 4 >> 2] = (i2 & 1048575) + 1072079006;
  d5 = +(i4 | 0);
  d1 = +HEAPF64[tempDoublePtr >> 3] + -1.0;
  i4 = 11;
 }
 if ((i4 | 0) == 11) {
  d7 = d1 * (d1 * .5);
  d10 = d1 / (d1 + 2.0);
  d9 = d10 * d10;
  d8 = d9 * d9;
  d1 = d5 * .6931471803691238 + (d1 + (d3 + d5 * 1.9082149292705877e-10 + d10 * (d7 + (d8 * (d8 * (d8 * .15313837699209373 + .22222198432149784) + .3999999999940942) + d9 * (d8 * (d8 * (d8 * .14798198605116586 + .1818357216161805) + .2857142874366239) + .6666666666666735))) - d7));
 }
 return +d1;
}

function __ZNK16ReflectionProbes17GetDefaultTextureEPb(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 HEAP8[i6 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i5 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (i1 | 0) {
     i8 = i1;
     STACKTOP = i7;
     return i8 | 0;
    }
   }
  }
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i8 = i1;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i8 = __ZN10builtintex12GetBlackCubeEv() | 0;
 HEAP8[i6 >> 0] = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 384 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -384 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 200 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -200 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx5cloth8SwSolverD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i4 >> 2] = gb + 168284 + 8;
 HEAP32[i4 + 4 >> 2] = gb + 168284 + 68;
 i1 = HEAP32[i4 + 96 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i1);
 i3 = HEAP32[i4 + 112 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 + 104 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 HEAP32[i4 + 44 >> 2] = gb + 87404 + 8;
 HEAP32[i4 + 52 >> 2] = 0;
 i2 = i4 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i4 + 36 >> 2] | 0;
 i3 = i1 + (i6 * 40 | 0) | 0;
 if ((i6 | 0) > 0) do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 40 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 i6 = HEAP32[i4 + 40 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) {
  i6 = i4 + 8 | 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i6 = i4 + 16 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i4 >> 2] = gb + 167276 + 8;
  __ZN5physx5cloth10deallocateEPv(i4);
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i2 >> 2] | 0);
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 87404 + 8;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89768 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj471ENS_22PxRepXPropertyAccessorILj471ES4_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 208; else i1 = (HEAP32[i1 >> 2] | 0) + 208 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115440 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj447ENS_22PxRepXPropertyAccessorILj447ES4_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 184; else i1 = (HEAP32[i1 >> 2] | 0) + 184 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115824 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj603ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj602ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj601ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj600ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj209ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj208ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj207ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj296ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj295ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN22DeviceStencilStateGLESC2ERK15GfxStencilState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP16[i1 + 12 >> 1] = __ZNK13TranslateGLES4FuncE15CompareFunction(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 4 >> 0] | 0) | 0;
 HEAP16[i1 + 14 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 5 >> 0] | 0) | 0;
 HEAP16[i1 + 16 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 6 >> 0] | 0) | 0;
 HEAP16[i1 + 18 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 7 >> 0] | 0) | 0;
 HEAP16[i1 + 20 >> 1] = __ZNK13TranslateGLES4FuncE15CompareFunction(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 8 >> 0] | 0) | 0;
 HEAP16[i1 + 22 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 9 >> 0] | 0) | 0;
 HEAP16[i1 + 24 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 10 >> 0] | 0) | 0;
 HEAP16[i1 + 26 >> 1] = __ZNK13TranslateGLES16StencilOperationE9StencilOp(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, HEAPU8[i2 + 11 >> 0] | 0) | 0;
 return;
}

function __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, i6 = 0;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i3, i1);
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i1 >> 2]));
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 i3 = i4 + 4 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i6 = i1 + 16 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i6 = i1 + 20 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i6 >> 2]));
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 i4 = i4 + 8 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i1 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i3 = i1 + 36 | 0;
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i4 = i1 + 40 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2]));
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z13ReadFileCacheR15CacheReaderBasePvjj(i8, i9, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 4 | 0;
 i12 = i13;
 i2 = (i10 >>> 0) / ((mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0) | 0) >>> 0) | 0;
 i6 = i1 + i10 | 0;
 i7 = ((i6 + -1 | 0) >>> 0) / ((mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0) | 0) >>> 0) | 0;
 if ((i2 | 0) > (i7 | 0)) {
  STACKTOP = i13;
  return;
 }
 while (1) {
  mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i2 | 0, i11 | 0, i12 | 0);
  i5 = HEAP32[i11 >> 2] | 0;
  i5 = i5 + (i10 - (Math_imul(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0) | 0, i2) | 0)) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i5 >>> 0 < i1 >>> 0) i4 = i1; else {
   i4 = HEAP32[i12 >> 2] | 0;
   i4 = i5 >>> 0 > i4 >>> 0 ? i4 : i5;
  }
  i3 = i1 + (i6 - (Math_imul(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0) | 0, i2) | 0)) | 0;
  i1 = HEAP32[i11 >> 2] | 0;
  if (i3 >>> 0 >= i1 >>> 0) {
   i1 = HEAP32[i12 >> 2] | 0;
   i1 = i3 >>> 0 > i1 >>> 0 ? i1 : i3;
  }
  i3 = i4;
  _memcpy(i9 + (i3 - i5) | 0, i4 | 0, i1 - i3 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, i2 | 0);
  if ((i2 | 0) < (i7 | 0)) i2 = i2 + 1 | 0; else break;
 }
 STACKTOP = i13;
 return;
}

function __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE9push_backERKS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if (!(HEAP8[gb + 1099744 >> 0] | 0)) {
  i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i7 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i10 = gb + 63696 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i3;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i7, 1, gb + 1018240 | 0, 24, 32768, i4, 16);
  HEAP32[gb + 1468880 >> 2] = i7;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i7);
  if (i6) __Z19pop_allocation_rootv();
  i10 = gb + 1099744 | 0;
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = 0;
 }
 i10 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1468880 >> 2] | 0, 24) | 0;
 HEAP32[i10 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 16 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i10 + 20 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i10 + 4 >> 2] = i1;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i1 >> 2] = i10;
 i10 = i1 + 8 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 STACKTOP = i5;
 return;
}

function __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i1 + 120 | 0, i6);
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc(i5, gb + 673520 | 0);
 __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb(i5, HEAP32[i5 + 24 >> 2] | 0, i1 + 136 | 0, 0);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 i4 = i1 + -1 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i3 + (i4 << 3) + 4 >> 0] | 0) if (HEAP8[i3 + (i4 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  i6 = i6 + 3 | 0;
  return i6 | 0;
 }
 HEAP8[i1 >> 0] = 0;
 i6 = i6 + 3 | 0;
 return i6 | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getWorldBoundsEf(i1, i3, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i4;
 __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE(i14, i3 + 20 | 0, i3);
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f13 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f10 = Math_fround(f9 + f13);
 f5 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f12 = Math_fround(f5 + f6);
 f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f10 = Math_fround(f10 * Math_fround(.5));
 f12 = Math_fround(f12 * Math_fround(.5));
 f11 = Math_fround(Math_fround(f8 + f7) * Math_fround(.5));
 f9 = Math_fround(Math_fround(Math_fround(f13 - f9) * Math_fround(.5)) * f2);
 f5 = Math_fround(Math_fround(Math_fround(f6 - f5) * Math_fround(.5)) * f2);
 f2 = Math_fround(Math_fround(Math_fround(f7 - f8) * Math_fround(.5)) * f2);
 f8 = Math_fround(f12 - f5);
 f7 = Math_fround(f11 - f2);
 f6 = Math_fround(f10 + f9);
 f5 = Math_fround(f12 + f5);
 f2 = Math_fround(f11 + f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f2;
 STACKTOP = i4;
 return;
}

function __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i4 + 48 >> 2] | 0;
 i7 = HEAP32[i4 + 52 >> 2] | 0;
 do if ((HEAP32[i4 + 124 >> 2] | 0) > 0) if (!(HEAP8[i6 + 58 >> 0] | 0)) if (!(HEAP8[i7 + 58 >> 0] | 0)) {
  i1 = HEAP32[i6 + 28 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAPU16[i2 >> 1] | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   HEAP16[i2 >> 1] = i3 & 65533;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   i3 = i1 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
  } else if (!(i3 & 2)) {
   HEAP16[i2 >> 1] = i3 | 2;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  }
  i1 = HEAP32[i7 + 28 >> 2] | 0;
  i2 = i1 + 4 | 0;
  i3 = HEAPU16[i2 >> 1] | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   HEAP16[i2 >> 1] = i3 & 65533;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   i3 = i1 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   break;
  }
  if (!(i3 & 2)) {
   HEAP16[i2 >> 1] = i3 | 2;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  }
 } while (0);
 mftCall_vii(HEAP32[gb + 1458112 + ((HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 4 >> 2] | 0) * 60 | 0) + ((HEAP32[(HEAP32[i7 + 32 >> 2] | 0) + 4 >> 2] | 0) * 12 | 0) + 4 >> 2] | 0, i4 | 0, i5 | 0);
 return;
}

function __ZN7mecanim4hand17Skeleton2HandPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS4_13SkeletonPoseTIN4math4trsXEEEPNS0_8HandPoseEf(i4, i5, i6, i7, f8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i13;
 i10 = i9 + 4 | 0;
 i11 = i9 + 8 | 0;
 i3 = 0;
 do {
  i2 = i3 * 3 | 0;
  i12 = i3 << 2;
  i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i9, i5, i6, i1);
   HEAPF32[i7 + 40 + ((i12 | 1) << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i10 >> 2]) + f8);
   HEAPF32[i7 + 40 + (i12 << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
  }
  i1 = HEAP32[i4 + (i2 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i9, i5, i6, i1);
   HEAPF32[i7 + 40 + ((i12 | 2) << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
  }
  i1 = HEAP32[i4 + (i2 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i9, i5, i6, i1);
   HEAPF32[i7 + 40 + ((i12 | 3) << 2) >> 2] = Math_fround(Math_fround(HEAPF32[i11 >> 2]) + f8);
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 STACKTOP = i13;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115224 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN19CharacterController12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 60 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 __ZNK9Transform18GetWorldScaleLossyEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 i9 = f5 < Math_fround(0.0);
 f6 = Math_fround(-f5);
 f5 = i9 ? f6 : f5;
 i9 = f5 < Math_fround(9.99999974e-06);
 f5 = i9 ? Math_fround(9.99999974e-06) : f5;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 i9 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i9 ? f7 : f6;
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i2 ? f8 : f7;
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * (f6 < f7 ? f7 : f6));
 f5 = Math_fround(f5 - Math_fround(f6 * Math_fround(2.0)));
 i2 = f5 < Math_fround(9.99999974e-06);
 f5 = i2 ? Math_fround(9.99999974e-06) : f5;
 i2 = f6 < Math_fround(9.99999974e-06);
 f6 = i2 ? Math_fround(9.99999974e-06) : f6;
 i2 = HEAP32[i3 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, +f6) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iif(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0, +f5) | 0;
 STACKTOP = i4;
 return;
}

function __ZN14DetailDatabaseD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 + 104 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 108 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 48 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 20 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i6 = i2 + -136 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN15DetailPrototypeD2Ev(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i6 = i5 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i5 = i5 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i5 >> 2] = i2 + -52;
   i3 = HEAP32[i2 + -12 >> 2] | 0;
   if (i3 | 0) {
    i4 = i2 + -8 | 0;
    if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
    __ZdlPv(i3);
   }
   i3 = HEAP32[i2 + -24 >> 2] | 0;
   if (i3 | 0) {
    i2 = i2 + -20 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i3;
    __ZdlPv(i3);
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 return;
}

function __ZN10AudioMixerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i8 = i4 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 174168 + 8;
 i3 = i6;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = i1;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAPF32[i1 + 96 >> 2] = Math_fround(-80.0);
 HEAP8[i1 + 100 >> 0] = 1;
 HEAP32[i1 + 104 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz(i1, i2, i4, i5, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i3 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 8 | 0;
 i9 = i8;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(80, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 444974 | 0, 786) | 0;
 i12 = gb + 63520 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i3, i6, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, i4 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, ((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 if (!i2) {
  HEAP32[i6 >> 2] = i7;
  __Z23AddComponentsFromVAListR10GameObjectPKcPi(i3, i5, i6);
  STACKTOP = i8;
  return i3 | 0;
 }
 __ZN10GameObject8ActivateEv(i3);
 HEAP32[i6 >> 2] = i7;
 __Z23AddComponentsFromVAListR10GameObjectPKcPi(i3, i5, i6);
 STACKTOP = i8;
 return i3 | 0;
}

function __Z25_SetupConstraintsParallelffjPN5physx20PxsIndexedConstraintERNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEPiS8_S8_RNS_25PxsConstraintBlockManagerE(f15, f14, i8, i12, i9, i13, i10, i16, i18, i17, i11) {
 f15 = Math_fround(f15);
 f14 = Math_fround(f14);
 i8 = i8 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 i16 = i16 | 0;
 i18 = i18 | 0;
 i17 = i17 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i19 = 0;
 i1 = (__ZN5physx6shdfnd9atomicAddEPVii(i16, 8) | 0) + -8 | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  i13 = 0;
  i16 = 0;
  __ZN5physx6shdfnd9atomicAddEPVii(i17, i13) | 0;
  __ZN5physx6shdfnd9atomicAddEPVii(i18, i16) | 0;
  return;
 }
 i7 = ~i8;
 i2 = 0;
 i5 = i1;
 i1 = 0;
 do {
  if ((i5 | 0) < (i8 | 0)) {
   i6 = i5 + i7 | 0;
   i6 = (i6 | 0) > -9 ? i6 : -9;
   i3 = ~i6;
   i4 = 0;
   do {
    i19 = i4 + i5 | 0;
    i2 = (__ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE(HEAP32[i12 + (i19 << 4) + 12 >> 2] | 0, i10, i9, f14, f15, i13 + (i19 << 5) | 0, i11) | 0) + i2 | 0;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i3 | 0));
   i1 = i1 + -1 - i6 | 0;
  }
  i5 = (__ZN5physx6shdfnd9atomicAddEPVii(i16, 8) | 0) + -8 | 0;
 } while ((i5 | 0) < (i8 | 0));
 __ZN5physx6shdfnd9atomicAddEPVii(i17, i2) | 0;
 __ZN5physx6shdfnd9atomicAddEPVii(i18, i1) | 0;
 return;
}

function _getrlimit(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i1 = i6;
 i3 = i6 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i5;
 i1 = ___syscall_ret(___syscall340(340, i1 | 0) | 0) | 0;
 if (!i1) {
  i4 = i5;
  if ((HEAP32[i4 >> 2] | 0) == -1 ? (HEAP32[i4 + 4 >> 2] | 0) == -1 : 0) {
   i4 = i5;
   HEAP32[i4 >> 2] = -1;
   HEAP32[i4 + 4 >> 2] = -1;
  }
  i1 = i5 + 8 | 0;
  i5 = i1;
  if ((HEAP32[i5 >> 2] | 0) == -1 ? (HEAP32[i5 + 4 >> 2] | 0) == -1 : 0) {
   HEAP32[i1 >> 2] = -1;
   HEAP32[i1 + 4 >> 2] = -1;
   i1 = 0;
  } else i1 = 0;
 } else if ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 38) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  if ((___syscall_ret(___syscall191(191, i4 | 0) | 0) | 0) < 0) i1 = -1; else {
   i1 = HEAP32[i3 >> 2] | 0;
   i4 = (i1 | 0) == -1;
   i7 = i5;
   HEAP32[i7 >> 2] = i4 ? -1 : i1;
   HEAP32[i7 + 4 >> 2] = i4 ? -1 : 0;
   i7 = HEAP32[i3 + 4 >> 2] | 0;
   i1 = (i7 | 0) == -1;
   i2 = i5 + 8 | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = i1 ? -1 : i7;
   HEAP32[i3 + 4 >> 2] = i1 ? -1 : 0;
   if (i4) {
    i7 = i5;
    HEAP32[i7 >> 2] = -1;
    HEAP32[i7 + 4 >> 2] = -1;
   }
   if (i1) {
    i1 = i2;
    HEAP32[i1 >> 2] = -1;
    HEAP32[i1 + 4 >> 2] = -1;
    i1 = 0;
   } else i1 = 0;
  }
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 36 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 36 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 36 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 36 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 36 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 36 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 36 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 36 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNSt3__25stoldERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084486 | 0, 5);
 HEAP32[i6 >> 2] = 0;
 i4 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = ___errno_location() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 __THREW__ = 0;
 d3 = +invoke_dii(fb + 5 | 0, i4 | 0, i6 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 do if (!(i9 & 1)) {
  i9 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  if ((i9 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if (i5 | 0) HEAP32[i5 >> 2] = (HEAP32[i6 >> 2] | 0) - i4 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return +d3;
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i9 | 0);
 return 0.0;
}

function __ZN9Polygon2D12GenerateFromEP6SpriteRK8Vector2ffhb(i3, i4, i10, f6, i5, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 f6 = Math_fround(f6);
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i9 = i3 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) {
  i2 = i1;
  while (1) {
   i1 = i2 + -20 | 0;
   HEAP32[i9 >> 2] = i1;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   if ((i1 | 0) == (i8 | 0)) break; else i2 = i1;
  }
 }
 __ZN6Sprite15GenerateOutlineEfhbRNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEi(i4, f6, i5, i7, i3, 0);
 if (!(Math_fround(HEAPF32[i10 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i10 + 4 >> 2]) != Math_fround(0.0))) return;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i10 + 4 | 0;
 do {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if (i2 | 0) {
   i9 = HEAP32[i1 >> 2] | 0;
   i3 = i9 + (i2 << 3) | 0;
   i2 = i9;
   do {
    f6 = Math_fround(HEAPF32[i10 >> 2]);
    HEAPF32[i2 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i2 >> 2]));
    f6 = Math_fround(HEAPF32[i5 >> 2]);
    i9 = i2 + 4 | 0;
    HEAPF32[i9 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i9 >> 2]));
    i2 = i2 + 8 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 48 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -48 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 200 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -200 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 96 >> 2] | 0) + 8 >> 2] | 0;
 i10 = i3 + 24 | 0;
 i11 = i3 + 28 | 0;
 i12 = i3 + 32 | 0;
 i13 = i3 + 36 | 0;
 i2 = i3 + 40 | 0;
 i3 = i3 + 44 | 0;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(HEAPF32[i13 >> 2]);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 i14 = 0;
 do {
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 20 >> 2]);
  f4 = f4 < f15 ? f4 : f15;
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 24 >> 2]);
  f5 = f5 < f15 ? f5 : f15;
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 28 >> 2]);
  f6 = f6 < f15 ? f6 : f15;
  HEAPF32[i10 >> 2] = f4;
  HEAPF32[i11 >> 2] = f5;
  HEAPF32[i12 >> 2] = f6;
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 32 >> 2]);
  f7 = f7 > f15 ? f7 : f15;
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 36 >> 2]);
  f8 = f8 > f15 ? f8 : f15;
  f15 = Math_fround(HEAPF32[i1 + 100 + (i14 * 44 | 0) + 40 >> 2]);
  f9 = f9 > f15 ? f9 : f15;
  HEAPF32[i13 >> 2] = f7;
  HEAPF32[i2 >> 2] = f8;
  HEAPF32[i3 >> 2] = f9;
  i14 = i14 + 1 | 0;
 } while ((i14 | 0) != 8);
 return;
}

function __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE7destroyEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 2 | 0;
 i8 = i11 + 1 | 0;
 i10 = i11;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i5 = i9 + 24 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = 0;
  do {
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if (!i2) i2 = 0; else {
    i1 = 0;
    do {
     i2 = i3 + (i1 * 1312 | 0) | 0;
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
     i1 = i1 + 1 | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    } while (i1 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i1 = i9 + 24 | 0;
   i2 = 0;
   do {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i9 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 560 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 32 | 0;
 i5 = i7 + 16 | 0;
 i2 = i7;
 i4 = i7 + 48 | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i3 + 168 >> 2] | 0;
 do if (i1 | 0) {
  i1 = i1 + -8 | 0;
  if (!(i1 & 7)) {
   mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
   break;
  } else {
   HEAP32[i2 >> 2] = gb + 401209;
   HEAP32[i2 + 4 >> 2] = 2513;
   HEAP32[i2 + 8 >> 2] = gb + 401349;
   _sprintf(i4, gb + 401176 | 0, i2) | 0;
   _puts(i4) | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 + 176 >> 2] | 0;
 do if (i1 | 0) {
  i1 = i1 + -8 | 0;
  if (!(i1 & 7)) {
   mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
   break;
  } else {
   HEAP32[i5 >> 2] = gb + 401209;
   HEAP32[i5 + 4 >> 2] = 2513;
   HEAP32[i5 + 8 >> 2] = gb + 401349;
   _sprintf(i4, gb + 401176 | 0, i5) | 0;
   _puts(i4) | 0;
   break;
  }
 } while (0);
 if (!(i3 & 7)) {
  mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i3 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i6 >> 2] = gb + 401209;
  HEAP32[i6 + 4 >> 2] = 2513;
  HEAP32[i6 + 8 >> 2] = gb + 401349;
  _sprintf(i4, gb + 401176 | 0, i6) | 0;
  _puts(i4) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN14Texture2DArray7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 418500 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i4 + 32 | 0);
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAPF32[i4 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 76 >> 2] = 1;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 46032 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 5;
 i2 = i4 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP8[i4 + 109 >> 0] = 1;
 HEAP8[i4 + 110 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13dynamic_arrayI4PPtrI13AnimationClipELj4EEC2ERKS3_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function _freopen(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i4 = i8;
 i6 = ___fmodeflags(i3) | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) i7 = ___lockfile(i1) | 0; else i7 = 0;
 _fflush(i1) | 0;
 do if (!i2) {
  i2 = i1 + 60 | 0;
  if (i6 & 524288 | 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i4 + 4 >> 2] = 2;
   HEAP32[i4 + 8 >> 2] = 1;
   ___syscall221(221, i4 | 0) | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = 4;
  HEAP32[i5 + 8 >> 2] = i6 & -524481;
  if ((___syscall_ret(___syscall221(221, i5 | 0) | 0) | 0) < 0) i2 = 15; else i2 = 12;
 } else {
  i2 = _fopen(i2, i3) | 0;
  if (!i2) i2 = 15; else {
   i3 = i2 + 60 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i1 + 60 >> 2] | 0;
   if ((i4 | 0) == (i5 | 0)) HEAP32[i3 >> 2] = -1; else if ((___dup3(i4, i5, i6 & 524288) | 0) < 0) {
    _fclose(i2) | 0;
    i2 = 15;
    break;
   }
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 1 | HEAP32[i2 >> 2];
   HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
   HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
   HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   _fclose(i2) | 0;
   i2 = 12;
  }
 } while (0);
 if ((i2 | 0) == 12) {
  if (i7) ___unlockfile(i1);
 } else if ((i2 | 0) == 15) {
  _fclose(i1) | 0;
  i1 = 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNSt3__24stodERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084481 | 0, 4);
 HEAP32[i6 >> 2] = 0;
 i4 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = ___errno_location() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 __THREW__ = 0;
 d3 = +invoke_dii(fb + 4 | 0, i4 | 0, i6 | 0);
 i9 = __THREW__;
 __THREW__ = 0;
 do if (!(i9 & 1)) {
  i9 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  if ((i9 | 0) == 34) {
   __THREW__ = 0;
   invoke_vi(fb + 4008 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
  }
  if (i5 | 0) HEAP32[i5 >> 2] = (HEAP32[i6 >> 2] | 0) - i4 >> 2;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return +d3;
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i9 | 0);
 return 0.0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89808 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj297ENS_22PxRepXPropertyAccessorILj297ES4_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 32; else i1 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89656 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj461ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj460ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj502ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj501ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN15MBP_PairManager10removePairEjj(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i1 >>> 0 > i2 >>> 0;
 i7 = i5 ? i2 : i1;
 i5 = i5 ? i1 : i2;
 i6 = i5 << 16 | i7 & 65535;
 i6 = i6 + ~(i6 << 15) | 0;
 i6 = (i6 >> 10 ^ i6) * 9 | 0;
 i6 = i6 >> 6 ^ i6;
 i6 = i6 + ~(i6 << 11) | 0;
 i8 = i10 + 4 | 0;
 i6 = HEAP32[i8 >> 2] & (i6 >> 16 ^ i6);
 i1 = HEAP32[i10 + 12 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  return i10 | 0;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i4 = HEAP32[i10 + 16 >> 2] | 0;
 i1 = HEAP32[i1 + (i6 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 while (1) {
  i2 = i3 + (i1 * 12 | 0) | 0;
  if (!((HEAP32[i2 >> 2] | 0) != (i7 | 0) ? 1 : (HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) != (i5 | 0))) break;
  i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i9 = 9;
   break;
  }
 }
 if ((i9 | 0) == 9) return i1 | 0;
 if (!i2) {
  i10 = 0;
  return i10 | 0;
 }
 __ZN15MBP_PairManager10removePairEjjjj(i10, 0, 0, i6, i1);
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 16 | i1;
 i2 = i1 + 1 | 0;
 if ((HEAP32[i10 >> 2] | 0) == (i2 | 0)) {
  i10 = 1;
  return i10 | 0;
 }
 if (i2 >>> 0 < (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i8 >> 2] = i1;
 __ZN15MBP_PairManager12reallocPairsEv(i10);
 i10 = 1;
 return i10 | 0;
}

function __Z33WheelCollider_CUSTOM_GetGroundHitP12Il2CppObjectP12MonoWheelHit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!(__ZNK13WheelCollider12GetGroundHitER8WheelHit(i4, i3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i4 = i2 + 12 | 0;
 i1 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i4 = i2 + 24 | 0;
 i1 = i3 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i4 = i2 + 36 | 0;
 i1 = i3 + 36 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i3 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i3 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i3 + 60 >> 2] | 0) | 0;
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z27GetTypeWithoutLoadingObjecti(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i1 = __ZN17PersistentManager17GetSerializedTypeEi(HEAP32[gb + 1166040 >> 2] | 0, i4) | 0;
 if (i1 | 0) if (HEAP32[i1 + 4 >> 2] | 0) {
  i7 = i1;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _UNITY_png_colorspace_endpoints_match(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i5 | 0) < (i3 - i4 | 0) | (i5 | 0) > (i3 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 if ((i3 | 0) < (i5 - i4 | 0) | (i3 | 0) > (i5 + i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i3 | 0) < (i1 - i4 | 0)) {
  i5 = 0;
  i5 = i5 & 1;
  return i5 | 0;
 }
 i5 = (i3 | 0) <= (i1 + i4 | 0);
 i5 = i5 & 1;
 return i5 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 288 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -288 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 108 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -108 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115928 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEE14handleAccessorILj510ENS_22PxRepXPropertyAccessorILj510ES4_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115648 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sq11PruningPool9addObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE(i8, i6, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i4 = i8 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i1 = i3 << 1;
  __ZN5physx2Sq11PruningPool6resizeEj(i8, i1 >>> 0 < 64 ? 64 : i1);
  i1 = HEAP32[i2 >> 2] | 0;
  i7 = HEAP32[i4 >> 2] | 0;
 } else i7 = i3;
 if ((i7 | 0) == (i1 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 HEAP32[i4 >> 2] = i7 + 1;
 i2 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i2 + (i7 * 24 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + (i7 * 24 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + (i7 * 24 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + (i7 * 24 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + (i7 * 24 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + (i7 * 24 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = (HEAP32[i8 + 16 >> 2] | 0) + (i7 << 3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i8 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i3 = i8 + 28 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 + 1;
  i3 = HEAP32[i8 + 20 >> 2] | 0;
 } else {
  i3 = HEAP32[i8 + 20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
  i1 = i2;
 }
 HEAP32[(HEAP32[i8 + 24 >> 2] | 0) + (i7 << 2) >> 2] = i1;
 HEAP32[i3 + (i1 << 2) >> 2] = i7;
 i8 = i1;
 return i8 | 0;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 56 | 0;
 i8 = i9 + 28 | 0;
 i6 = i9;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i3 + 8 >> 2] | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i8 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i5, i6) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i5, i3) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVES7_(i2, i3, i4, i1, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(Math_fround(Math_fround(f17 * f17) + Math_fround(f16 * f16)) + Math_fround(f6 * f6));
 f15 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(Math_fround(Math_fround(f17 * f15) + Math_fround(f16 * f13)) + Math_fround(f6 * f10));
 f11 = Math_fround(Math_fround(Math_fround(f15 * f15) + Math_fround(f13 * f13)) + Math_fround(f10 * f10));
 f14 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f17 * f14) + Math_fround(f16 * f12)) + Math_fround(f6 * f8));
 f8 = Math_fround(Math_fround(Math_fround(f15 * f14) + Math_fround(f13 * f12)) + Math_fround(f10 * f8));
 f10 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f9 * f11) - Math_fround(f7 * f7)));
 HEAPF32[i1 >> 2] = Math_fround(f10 * Math_fround(Math_fround(f11 * f6) - Math_fround(f7 * f8)));
 HEAPF32[i5 >> 2] = Math_fround(f10 * Math_fround(Math_fround(f9 * f8) - Math_fround(f7 * f6)));
 return;
}

function __ZN5Umbra9Matrix4x4mLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 28 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 36 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 40 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 44 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 48 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 52 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 56 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 60 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 return i1 | 0;
}

function __ZN20ArchiveStorageReader18AcquireCachedBlockEjj(i10, i4, i5) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i10 + 2376 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  return i10 | 0;
 }
 i7 = HEAP32[i10 + 2364 >> 2] | 0;
 i8 = i10 + 104 | 0;
 i3 = 0;
 while (1) {
  i9 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
  if ((HEAP32[i9 >> 2] | 0) == (i4 | 0)) {
   if (!(HEAP16[(HEAP32[i8 >> 2] | 0) + (i4 * 12 | 0) + 8 >> 1] & 64)) {
    i2 = 10;
    break;
   }
   i2 = i9 + 32 | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP32[i2 >> 2] = 1;
    i1 = HEAP32[i9 + 4 >> 2] | 0;
    if (i1 >>> 0 <= i5 >>> 0) if (((HEAP32[i9 + 20 >> 2] | 0) + i1 | 0) >>> 0 >= i5 >>> 0) {
     i2 = 9;
     break;
    }
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i1 >>> 0) {
   i1 = 0;
   i2 = 16;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  i8 = i9 + 28 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else if ((i2 | 0) == 10) {
  i1 = i9 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i2 = i9 + 32 | 0;
  do {} while ((HEAP32[i2 >> 2] | 0) != 0);
  HEAP32[i2 >> 2] = 0;
  if ((HEAP32[i9 >> 2] | 0) == -1) {
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   i10 = 0;
   return i10 | 0;
  }
 } else if ((i2 | 0) == 16) return i1 | 0;
 i8 = i10 + 2388 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i10 + 1;
 HEAP32[i9 + 36 >> 2] = i10;
 i10 = i9;
 return i10 | 0;
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairINS3_IttEEfEEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 2 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i1 = HEAP16[i7 >> 1] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP16[i1 >> 1] | 0;
  HEAP16[i7 >> 1] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP16[i6 >> 1] = _llvm_bswap_i16(i1 | 0) | 0;
 i1 = i2 + 2 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 2);
  i2 = HEAP16[i7 >> 1] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP16[i2 >> 1] | 0;
  HEAP16[i7 >> 1] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP16[i6 + 2 >> 1] = _llvm_bswap_i16(i2 | 0) | 0;
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim13ValueConstantEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode(i12, i13, i1, i2, i3) {
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = HEAP32[i13 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i13 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
 i3 = __ZN18AwakeFromLoadQueue19DetermineQueueIndexEPKN5Unity4TypeER6Object(0, i2, 0) | 0;
 i4 = i12 + (i3 * 20 | 0) | 0;
 i5 = i12 + (i3 * 20 | 0) + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i12 + (i3 * 20 | 0) + 16 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i7 >>> 0 > i10 >>> 0) {
  i1 = i9 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 * 12 | 0, 4, i12 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i12 + (i3 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i12 = HEAP32[i4 >> 2] | 0;
 HEAP32[i12 + (i6 * 12 | 0) >> 2] = i13;
 HEAP32[i12 + (i6 * 12 | 0) + 4 >> 2] = i11;
 HEAP32[i12 + (i6 * 12 | 0) + 8 >> 2] = i2;
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i8 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  i6 = i1;
  i2 = i2 | 0 ? i2 - i6 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i6;
 } else i3 = i8 + 4 | 0;
 i4 = i2 + i1 | 0;
 i6 = i4 + 4 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i7, 4);
  i3 = HEAP32[i7 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i3 = i2;
 }
 HEAP32[i4 >> 2] = i3;
 if (!i3) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i1 = i3 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i3 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i3 = i6;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i2 + i3 | 0, i1 << 2);
 STACKTOP = i9;
 return;
}

function __ZN13BatchRenderer20RenderSingleWithPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEiPKNS7_10GrabPassesEjib(i7, i1, i2, i3, i4, i5, i6, i10, i11, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 var i8 = 0;
 i3 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i2, i1, i3, i4, i5, 1, i6, 0) | 0;
 i1 = i7 + 8 | 0;
 if (!(HEAP32[i7 + 52 >> 2] | 0)) {
  if (HEAP32[i7 + 132 >> 2] | 0) i8 = 3;
 } else i8 = 3;
 if ((i8 | 0) == 3) {
  __ZN20DynamicPropertySheet10FlushQueueEv(i1);
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 184 >> 2] | 0, i8 | 0, i1 | 0);
  __ZN19ShaderPropertySheet5ClearEb(i1, 1);
 }
 if (!i3) return;
 i2 = i7 + 168 | 0;
 if (i9) {
  i1 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  __Z17SetupObjectMatrixRK10Matrix4x4fi(i1 + (i10 * 360 | 0) | 0, HEAP32[i1 + (i10 * 360 | 0) + 176 >> 2] | 0);
  i1 = HEAP32[i1 + (i10 * 360 | 0) + 336 >> 2] | 0;
  if (i1 | 0) {
   mftCall_viiii(i1 | 0, HEAP32[i2 >> 2] | 0, i10 | 0, i3 | 0, i11 | 0);
   return;
  }
 }
 i9 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 __Z17SetupObjectMatrixRK10Matrix4x4fi(i9 + (i10 * 360 | 0) | 0, HEAP32[i9 + (i10 * 360 | 0) + 176 >> 2] | 0);
 mftCall_viiii(HEAP32[i9 + (i10 * 360 | 0) + 332 >> 2] | 0, HEAP32[i2 >> 2] | 0, i10 | 0, i3 | 0, i11 | 0);
 return;
}

function __Z33Renderer_Set_Custom_PropMaterialsP12Il2CppObjectP11Il2CppArray(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517357 | 0, i9);
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 if (!i8) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i1) {
  i3 = i8;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN8Renderer16SetMaterialCountEi(i1, i7);
 if ((i7 | 0) <= 0) {
  STACKTOP = i9;
  return;
 }
 i2 = 0;
 while (1) {
  i1 = __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i5, i2) | 0;
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
  if (!i3) {
   i1 = 10;
   break;
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i3, i4, i2);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i7 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  STACKTOP = i9;
  return;
 } else if ((i1 | 0) == 10) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
}

function __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getWorldBoundsEf(i1, i3, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i4;
 __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE(i14, i3 + 20 | 0, i3);
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f13 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f10 = Math_fround(f9 + f13);
 f5 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f12 = Math_fround(f5 + f6);
 f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f10 = Math_fround(f10 * Math_fround(.5));
 f12 = Math_fround(f12 * Math_fround(.5));
 f11 = Math_fround(Math_fround(f8 + f7) * Math_fround(.5));
 f9 = Math_fround(Math_fround(Math_fround(f13 - f9) * Math_fround(.5)) * f2);
 f5 = Math_fround(Math_fround(Math_fround(f6 - f5) * Math_fround(.5)) * f2);
 f2 = Math_fround(Math_fround(Math_fround(f7 - f8) * Math_fround(.5)) * f2);
 f8 = Math_fround(f12 - f5);
 f7 = Math_fround(f11 - f2);
 f6 = Math_fround(f10 + f9);
 f5 = Math_fround(f12 + f5);
 f2 = Math_fround(f11 + f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f2;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 115928 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim6bitsetILj66EEEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN18ProfilerConnection17RemoveConnectionsEv(i1) {
 i1 = i1 | 0;
 __ZN17GeneralConnection27UnregisterConnectionHandlerEPFvjE(__ZN16PlayerConnection3GetEv() | 0, fb + 3427 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 33, fb + 538 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 42, fb + 539 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 40, fb + 540 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 50, fb + 541 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 51, fb + 542 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 53, fb + 543 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 54, fb + 544 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 55, fb + 545 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 56, fb + 546 | 0);
 __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 57, fb + 547 | 0);
 return;
}

function __ZN17TransformInternal36OnScaleChangedCalculateTransformTypeE15TransformAccess(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 28 >> 2]);
 f5 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + (i1 * 40 | 0) + 36 >> 2]);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i7;
 i7 = (HEAP32[tempDoublePtr >> 2] = i7 ^ (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
 i3 = ((Math_fround(Math_abs(Math_fround(f4 - f6))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f6 - f5))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f5 - f4))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i7) ^ 1;
 i3 = (i7 << 2 | 3) & ~(i3 << 1) & (i3 & ((Math_fround(Math_abs(Math_fround(f6 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f5 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f4 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2);
 HEAP32[(HEAP32[i2 + 64 >> 2] | 0) + (i1 << 2) >> 2] = i3;
 return;
}

function __ZN13dynamic_arrayI14BoneInfluence2Lj16EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 16, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN11BoxCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(132, i2, 16, gb + 1048932 | 0, 0, gb + 779037 | 0, 12) | 0;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 110728 + 8;
 i9 = i4 + 84 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i9;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 i9 = i4 + 108 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = i9;
 HEAP32[i4 + 120 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __Z23Material_CUSTOM_SetPassP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 12 | 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if ((i2 | 0) >= 0) if ((__ZNK8Material12GetPassCountEv(i4) | 0) > (i2 | 0)) {
  if (!(__Z21CheckShouldRenderPassiR8Material(i2, i4) | 0)) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
  i5 = __ZNK8Material13GetShaderPPtrEv(i4) | 0;
  HEAP32[gb + 1188344 >> 2] = i5;
  i5 = __ZN8Material11SetPassSlowEiR17ShaderPassContextib(i4, i2, HEAP32[gb + 1166248 >> 2] | 0, 0, 1) | 0;
  HEAP32[gb + 1188348 >> 2] = i5;
  i5 = (i5 | 0) != 0 & 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
 i4 = __ZNK8Material12GetPassCountEv(i4) | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i4;
 __Z6FormatPKcz(i3, gb + 563275 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 563359 | 0, 993, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 24 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 24 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 24 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 24 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 24 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -24 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -12 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getWorldBoundsEf(i1, i3, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, i14 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i4;
 __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE(i14, i3 + 20 | 0, i3);
 f9 = Math_fround(HEAPF32[i14 >> 2]);
 f13 = Math_fround(HEAPF32[i14 + 12 >> 2]);
 f10 = Math_fround(f9 + f13);
 f5 = Math_fround(HEAPF32[i14 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i14 + 16 >> 2]);
 f12 = Math_fround(f5 + f6);
 f8 = Math_fround(HEAPF32[i14 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i14 + 20 >> 2]);
 f10 = Math_fround(f10 * Math_fround(.5));
 f12 = Math_fround(f12 * Math_fround(.5));
 f11 = Math_fround(Math_fround(f8 + f7) * Math_fround(.5));
 f9 = Math_fround(Math_fround(Math_fround(f13 - f9) * Math_fround(.5)) * f2);
 f5 = Math_fround(Math_fround(Math_fround(f6 - f5) * Math_fround(.5)) * f2);
 f2 = Math_fround(Math_fround(Math_fround(f7 - f8) * Math_fround(.5)) * f2);
 f8 = Math_fround(f12 - f5);
 f7 = Math_fround(f11 - f2);
 f6 = Math_fround(f10 + f9);
 f5 = Math_fround(f12 + f5);
 f2 = Math_fround(f11 + f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i1 + 4 >> 2] = f8;
 HEAPF32[i1 + 8 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f2;
 STACKTOP = i4;
 return;
}

function __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeR9GfxBufferiii(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i2 = i9;
 if ((i7 | 0) > 1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400937 | 0, 0, gb + 400980 | 0, 191, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 if ((HEAP16[gb + 1157796 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157796 | 0, i1);
  i2 = gb + 1157796 | 0;
 } else i2 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 844 >> 2] | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
 i1 = Math_imul(i7, i6) | 0;
 if (HEAP8[i3 + 3896 >> 0] | 0) {
  i8 = i3 + 3644 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i8 = i3 + 3648 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i1;
  i8 = i3 + 3656 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i1;
  i8 = i3 + 3652 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i1;
  i8 = i3 + 3640 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __Z15gpu_time_samplev();
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 112 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -112 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj473ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj472ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj470ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj469ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj468ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj189ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj188ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj187ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj446ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj445ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj444ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj443ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj442ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN4math14float3_storageEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13set_empty_keyERKS9_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 HEAP8[i2 + 9 >> 0] = 1;
 i3 = i2 + 48 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = i2 + 36 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i1 + 12 | 0);
 i6 = i2 + 64 | 0;
 i1 = (HEAP32[i6 >> 2] | 0) * 24 | 0;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 HEAP32[i7 >> 2] = 54;
 HEAP32[i7 + 4 >> 2] = i8;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i7, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 60 >> 2] = i1;
 i2 = i1 + ((HEAP32[i6 >> 2] | 0) * 24 | 0) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i5;
  return;
 }
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 12 | 0, i3);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i5;
 return;
}

function __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i9 = i7 + 24 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i9 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 8 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 >> 2] = i1;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i4, i1);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, HEAP32[i4 >> 2] | 0, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i9 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  STACKTOP = i10;
  return;
 }
}

function __ZN13dynamic_arrayIPN9ShaderLab4PassELj4EEC2ERKS3_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 5;
 i2 = i1 >> 5;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayI13BoneInfluenceLj16EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 5;
 i2 = i1 >> 5;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 16, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 5 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 5;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13TriggerModule8TransferI17RemapPPtrTransferEEvRT_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i3, i1);
 i4 = i1 + 16 | 0;
 i5 = i1 + 36 | 0;
 i6 = i1 + 40 | 0;
 i2 = i3 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i3 + 44 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i3 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i1 = HEAP32[i7 >> 2] | 0;
 i8 = i7 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i8 = i7 + 16 | 0;
  HEAP32[i8 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i5 = i4 + 4 | 0;
 i6 = i4 + 4 | 0;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  i10 = i3 + 44 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  if (!(HEAP32[i10 >> 2] | 0)) {
   i2 = i3 + 16 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i5 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i3 + 12 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i6 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63800 | 0);
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) {
  i10 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i10 = i7 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __Z56ParticleSystem_SubEmittersModule_CUSTOM_RemoveSubEmitterP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i7 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    __ZN14ParticleSystem8SyncJobsEb(1);
    i7 = HEAP32[i1 + 916 >> 2] | 0;
    i4 = HEAP32[i7 + 8 >> 2] | 0;
    i3 = i4 + (i3 * 12 | 0) | 0;
    i5 = i3 + 12 | 0;
    i7 = i7 + 20 | 0;
    _memmove(i3 | 0, i5 | 0, i4 + ((HEAP32[i7 >> 2] | 0) * 12 | 0) - i5 | 0) | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
    STACKTOP = i6;
    return;
   }
  }
 }
 i7 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i4) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i7;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i5);
}

function __Z20IntersectAABBFrustumRK4AABBPK5Planej(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0;
 if (!i6) {
  i6 = 1;
  return i6 | 0;
 }
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i1 = i2;
 i2 = 1;
 while (1) {
  if (i2 & i6 | 0) {
   f16 = Math_fround(HEAPF32[i1 >> 2]);
   f19 = Math_fround(f16 * f7);
   f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f13 * f8));
   f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   f19 = Math_fround(f19 + Math_fround(f10 * f9));
   f19 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f19);
   i18 = f16 < Math_fround(0.0);
   f17 = Math_fround(-f16);
   i15 = f13 < Math_fround(0.0);
   f14 = Math_fround(-f13);
   i12 = f10 < Math_fround(0.0);
   f11 = Math_fround(-f10);
   if (Math_fround(f19 + Math_fround(Math_fround(Math_fround((i18 ? f17 : f16) * f4) + Math_fround((i15 ? f14 : f13) * f5)) + Math_fround((i12 ? f11 : f10) * f3))) < Math_fround(0.0)) {
    i1 = 0;
    i2 = 6;
    break;
   }
  }
  i2 = i2 << 1;
  if (i2 >>> 0 > i6 >>> 0) {
   i1 = 1;
   i2 = 6;
   break;
  } else i1 = i1 + 16 | 0;
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function _tt_size_done_bytecode(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0;
 i1 = i3 + 292 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  _UNITY_TT_Done_Context(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 244 | 0;
 _UNITY_ft_mem_free(i4, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 240 >> 2] = 0;
 i1 = i3 + 252 | 0;
 _UNITY_ft_mem_free(i4, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP16[i3 + 248 >> 1] = 0;
 i1 = i3 + 256 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = i1 + 28 | 0;
  _UNITY_ft_mem_free(i2, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i5 = i1 + 24 | 0;
  _UNITY_ft_mem_free(i2, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i5 = i1 + 16 | 0;
  _UNITY_ft_mem_free(i2, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i5 = i1 + 12 | 0;
  _UNITY_ft_mem_free(i2, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i5 = i1 + 20 | 0;
  _UNITY_ft_mem_free(i2, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
 }
 i5 = i3 + 124 | 0;
 _UNITY_ft_mem_free(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 _UNITY_ft_mem_free(i4, HEAP32[i3 + 136 >> 2] | 0);
 HEAP32[i3 + 116 >> 2] = 0;
 HEAP32[i3 + 120 >> 2] = 0;
 i5 = i3 + 128 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i3 + 296 >> 2] = -1;
 HEAP32[i3 + 300 >> 2] = -1;
 return;
}

function __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (!i1) return;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i11 >> 2] = i2 + -36;
   i9 = i2 + -16 | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if (i3 | 0) {
    i8 = i2 + -12 | 0;
    i4 = HEAP32[i8 >> 2] | 0;
    if ((i4 | 0) != (i3 | 0)) {
     do {
      i5 = i4 + -20 | 0;
      HEAP32[i8 >> 2] = i5;
      i6 = HEAP32[i4 + -12 >> 2] | 0;
      i7 = i6;
      if (!i6) i4 = i5; else {
       i4 = i4 + -8 | 0;
       i5 = HEAP32[i4 >> 2] | 0;
       if ((i5 | 0) != (i6 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i7 | 0) >>> 0) / 24 | 0) * 24 | 0);
       __ZdlPv(i6);
       i4 = HEAP32[i8 >> 2] | 0;
      }
     } while ((i4 | 0) != (i3 | 0));
     i3 = HEAP32[i9 >> 2] | 0;
    }
    __ZdlPv(i3);
   }
   i4 = i2 + -28 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) {
    i3 = i2 + -24 | 0;
    i2 = HEAP32[i3 >> 2] | 0;
    if ((i2 | 0) == (i5 | 0)) i2 = i5; else {
     do {
      i9 = i2 + -96 | 0;
      HEAP32[i3 >> 2] = i9;
      __ZN19ComputeShaderKernelD2Ev(i9);
      i2 = HEAP32[i3 >> 2] | 0;
     } while ((i2 | 0) != (i5 | 0));
     i2 = HEAP32[i4 >> 2] | 0;
    }
    __ZdlPv(i2);
   }
   i2 = HEAP32[i11 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i10 >> 2] | 0;
 }
 __ZdlPv(i1);
 return;
}

function __ZN9ShaderLab20SerializedSubProgram12UAVParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 + 16 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 20 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim9animation23BlendDirectDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i7 + 4 | 0;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = i1;
 if (!i1) HEAP32[i6 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i6;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i2 + i4 | 0, i1 << 2);
 }
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i8);
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89808 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN13dynamic_arrayIjLj4EEC2ERKS0_RK10MemLabelId(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i4 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayIP14TreeBinaryTreeLj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 28 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 28 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 28 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 28 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 28 | 0);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -28 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -16 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN5physx7NpScene17removeRigidStaticERNS_13NpRigidStaticEbb(i5, i2, i4, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0) & 8) == 0;
 if (i3) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0) __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0, i2, 0) | 0;
 __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i2 + 20 | 0, i5 + 3392 | 0);
 if (i1) __ZN5physx7NpActor26removeConstraintsFromSceneEv(i2 + 12 | 0);
 i1 = i2 + 48 | 0;
 __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb(i5 + 16 | 0, i1, i4, (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i2 + 52 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 >> 1] & 8) != 0);
 i4 = i2 + 36 | 0;
 i1 = i5 + 3556 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i1 = i5 + 3552 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
 if (!i3) return;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
 case 0:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 case 1:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 default:
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 36 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -36 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 132 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -132 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89808 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc5Actor22deactivateInteractionsEj(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i7 + 28 >> 2] | 0;
 i6 = i7 + 44 | 0;
 i5 = HEAP16[i6 >> 1] | 0;
 i1 = i5 & 65535;
 if (i5 << 16 >> 16) {
  i4 = i7 + 20 | 0;
  i5 = i7 + 36 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if ((i1 | 0) == (i7 | 0)) i1 = HEAP32[i3 + 8 >> 2] | 0;
   if (!(HEAP8[i1 + 51 >> 0] & 1)) if (__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[i5 >> 2] | 0, i3) | 0) if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i9 | 0) | 0) __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE(HEAP32[i5 >> 2] | 0, i3);
   i2 = i2 + 1 << 16 >> 16;
   i3 = HEAP16[i6 >> 1] | 0;
   i1 = i3 & 65535;
   if ((i2 & 65535) < (i3 & 65535)) i1 = i2 & 65535; else break;
  }
 }
 if (i1 >>> 0 >= i8 >>> 0) return;
 i4 = i7 + 20 | 0;
 i3 = i7 + 36 | 0;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2) | 0) if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i9 | 0) | 0) __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN10RenderLoop12PrepareFrameEbb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i5 + 8 >> 2] | 0;
 i7 = i5 + 1732 | 0;
 i9 = __ZNK6Camera22GetWorldToCameraMatrixEv(i6) | 0;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 i10 = i5 + 1812 | 0;
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i10 = i5 + 1796 | 0;
 __ZNK6Camera18GetRenderRectangleEv(i4, i6);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 switch (HEAP32[i6 + 1068 >> 2] | 0) {
 case 1:
  {
   HEAP8[i5 + 1824 >> 0] = 0;
   break;
  }
 case 2:
  {
   HEAP8[i5 + 1824 >> 0] = 1;
   break;
  }
 default:
  HEAP8[i5 + 1824 >> 0] = HEAP8[i6 + 1088 >> 0] | 0;
 }
 HEAP8[i5 + 1825 >> 0] = i2 & 1;
 HEAP8[i5 + 1826 >> 0] = i3 & 1;
 i7 = i1 + 4 | 0;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 STACKTOP = i8;
 return;
}

function __Z24IsWebCamDeviceRegisteredRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1459968 >> 2] | 0;
 i11 = i3;
 if ((i2 | 0) == (i3 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i10 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i10 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i10 & 255;
 i9 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i7 = (i2 - i3 | 0) / 20 | 0;
 i8 = (i10 | 0) == 0;
 i6 = 0;
 L4 : while (1) {
  i3 = i11 + (i6 * 20 | 0) | 0;
  i1 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  i1 = i1 & 255;
  do if (((i2 ? HEAP32[i11 + (i6 * 20 | 0) + 4 >> 2] | 0 : i1) | 0) == (i10 | 0)) {
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i2 ? i4 : i3;
   if (i2) {
    if (i8) {
     i1 = 1;
     i2 = 12;
     break L4;
    }
    if (!(_memcmp(i5, i9, i10) | 0)) {
     i1 = 1;
     i2 = 12;
     break L4;
    } else break;
   }
   if (i8) {
    i1 = 1;
    i2 = 12;
    break L4;
   }
   if ((i4 & 255) << 24 >> 24 == (HEAP8[i9 >> 0] | 0)) {
    i2 = i9;
    do {
     i1 = i1 + -1 | 0;
     i3 = i3 + 1 | 0;
     if (!i1) {
      i1 = 1;
      i2 = 12;
      break L4;
     }
     i2 = i2 + 1 | 0;
    } while ((HEAP8[i3 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
   }
  } while (0);
  i6 = i6 + 1 | 0;
  if (i6 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj509ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 844275 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 844291 | 0, gb + 844305 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff(i1, i2, i3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (Math_fround(HEAPF32[i2 + 344 >> 2]) == Math_fround(0.0)) {
  i3 = 0;
  return i3 | 0;
 }
 i11 = i1 + 8 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i10 = i10 << 11 ^ i10;
 i9 = i1 + 12 | 0;
 HEAP32[i11 >> 2] = HEAP32[i9 >> 2];
 i11 = i1 + 16 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 i9 = i1 + 20 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = i8;
 i8 = i10 >>> 8 ^ i10 ^ i8 ^ i8 >>> 19;
 HEAP32[i9 >> 2] = i8;
 f5 = Math_fround(__ZL20AccumulateContinuousRK11MinMaxCurveffff(i2 + 264 | 0, f7, f5, f6, Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07))));
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(f7 + Math_fround(f6 * f6));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f5 * Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f7 * f7)))));
 i2 = i1 + 4 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f7);
 i3 = ~~f6 >>> 0;
 HEAPF32[i2 >> 2] = Math_fround(f6 - Math_fround(i3 >>> 0));
 i2 = !(f7 >= Math_fround(.0000999999974));
 f7 = Math_fround(Math_fround(1.0) / f7);
 HEAPF32[i1 >> 2] = i2 ? Math_fround(1.0) : f7;
 return i3 | 0;
}

function __ZN13dynamic_arrayI10Matrix4x4fLj16EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 6;
 i2 = i1 >> 6;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 6;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 16, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 6;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 6 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 6;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z39Renderer_Set_Custom_PropSharedMaterialsP12Il2CppObjectP11Il2CppArray(i8, i5) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517357 | 0, i9);
 i7 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 if (!i8) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
 if (!i1) {
  i3 = i8;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN8Renderer16SetMaterialCountEi(i1, i7);
 if ((i7 | 0) <= 0) {
  STACKTOP = i9;
  return;
 }
 i2 = 0;
 while (1) {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i8) | 0;
  if (!i3) {
   i1 = 10;
   break;
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(__ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i5, i2) | 0) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i3, i4, i2);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i7 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  STACKTOP = i9;
  return;
 } else if ((i1 | 0) == 10) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
}

function __Z33GUIText_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f4 = i5 ? Math_fround(0.0) : f4;
  i5 = f4 > Math_fround(1.0);
  i5 = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  i6 = f4 < Math_fround(0.0);
  f4 = i6 ? Math_fround(0.0) : f4;
  i6 = f4 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i1 = f4 < Math_fround(0.0);
  f4 = i1 ? Math_fround(0.0) : f4;
  i1 = f4 > Math_fround(1.0);
  i1 = ~~Math_fround(Math_fround((i1 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i2 = f4 < Math_fround(0.0);
  f4 = i2 ? Math_fround(0.0) : f4;
  i2 = f4 > Math_fround(1.0);
  HEAP32[i3 + 84 >> 2] = i6 << 8 & 65280 | i5 & 255 | i1 << 16 & 16711680 | ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
  return;
 }
}

function __Z30CleanupBuiltinShaderParamNamesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1157720 >> 2] | 0;
 if (!i3) {
  HEAP32[gb + 1157720 >> 2] = 0;
  return;
 }
 i1 = i3 + 120 | 0;
 i2 = i3 + 140 | 0;
 if ((HEAP32[i3 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 144 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i3 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 80 | 0;
 i2 = i3 + 100 | 0;
 if ((HEAP32[i3 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i3 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 i2 = i3 + 60 | 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i3 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 20 | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 __ZdlPv(i3);
 HEAP32[gb + 1157720 >> 2] = 0;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 16 | 0;
 i7 = i3;
 i2 = i3 + 24 | 0;
 i11 = gb + 64016 | 0;
 i1 = HEAP32[i11 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = i2 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i11 = i8;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i1;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i5 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i2, HEAP32[i5 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i8, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i4, i7, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i7, i2, i8, i9) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i10 = i8;
 i5 = i1 + 8 | 0;
 i4 = 0;
 i6 = 0;
 L1 : while (1) {
  if ((i2 | 0) == (i8 | 0) | i4 >>> 0 >= i9 >>> 0) {
   i1 = 15;
   break;
  }
  i3 = _uselocale(HEAP32[i5 >> 2] | 0) | 0;
  __THREW__ = 0;
  i1 = invoke_iiii(fb + 508 | 0, i2 | 0, i10 - i2 | 0, i7 | 0) | 0;
  i11 = __THREW__;
  __THREW__ = 0;
  if (i11 & 1) {
   i1 = 7;
   break;
  }
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) {
    i1 = 6;
    break;
   }
  }
  switch (i1 | 0) {
  case -2:
  case -1:
   {
    i1 = 15;
    break L1;
   }
  case 0:
   {
    i2 = i2 + 1 | 0;
    i1 = 1;
    break;
   }
  default:
   i2 = i2 + i1 | 0;
  }
  i4 = i4 + 1 | 0;
  i6 = i1 + i6 | 0;
 }
 if ((i1 | 0) == 6) {
  i11 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i11);
 } else if ((i1 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i11 = __THREW__;
   __THREW__ = 0;
   if (i11 & 1) {
    i11 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i11);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i1 | 0) == 15) return i6 | 0;
 return 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 7) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -128 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj50ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj47ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj46ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj44ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj43ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj42ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj91ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj90ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj89ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj84ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 i4 = HEAP32[i6 >> 2] | 0;
 if (!i1) HEAP32[i4 >> 2] = 0; else {
  i2 = HEAP32[i6 + 8 >> 2] | 0;
  i1 = i3 * 28 | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 * 28 | 0) | 0)) _memset(i2 | 0, 0, i1 - (((i1 + -28 | 0) >>> 0) % 28 | 0) | 0) | 0;
  HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 i2 = i1 + (i6 * 28 | 0) | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags(i8, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 28 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN13dynamic_arrayI12PPtrKeyframeLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(i6, i2, i7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES6_NS_4lessIS6_EENS4_INS_4pairIKS6_S6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_(i6, i3, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  i6 = i6 + 28 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i7) | 0;
  STACKTOP = i8;
  return;
 }
 i5 = __Znwj(40) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5 + 16 | 0, i2);
 i1 = i5 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
 if (!i1) i1 = i5; else {
  HEAP32[i6 >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i6 + 4 >> 2] | 0, i1);
 i6 = i6 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i6 = i5;
 i6 = i6 + 28 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i6, i7) | 0;
 STACKTOP = i8;
 return;
}

function __Z22Texture3D_CUSTOM_ApplyP12Il2CppObjecthh(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i3) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i3 + 105 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i2) | 0;
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 do if (i1 << 24 >> 24) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
  HEAP8[i1 + 105 >> 0] = 0;
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
   HEAP8[i1 + 106 >> 0] = 1;
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN9Texture3D15UpdateImageDataEb(i1, i6 << 24 >> 24 != 0);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 88 | 0) + 1 | 0;
 if (i3 >>> 0 > 48806446) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i5 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 88 | 0;
 i7 = i5 << 1;
 i3 = i5 >>> 0 < 24403223 ? (i7 >>> 0 < i3 >>> 0 ? i3 : i7) : 48806446;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 88 | 0) | 0;
 i2 = i4 + (((i2 - i1 | 0) / 88 | 0) * 88 | 0) | 0;
 i5 = i2;
 i7 = i4 + (i3 * 88 | 0) | 0;
 __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i6);
 i6 = i2 + 88 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i2 = i5;
  i3 = i4;
  i1 = i4;
 } else {
  i3 = i5;
  do {
   i1 = i1 + -88 | 0;
   __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2 + -88 | 0, i1);
   i2 = i3 + -88 | 0;
   i3 = i2;
  } while ((i1 | 0) != (i4 | 0));
  i2 = i3;
  i3 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i7;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -88 | 0;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
  i1 = i1 + 872 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 12 | 0, i4);
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 7) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -128 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 8) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -256 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 7) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -128 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 6) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -64 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sq11PruningPool12removeObjectEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
 i7 = i6 + 4 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i4;
 if ((i4 | 0) == (i3 | 0)) {
  i7 = i6 + 32 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i6 = i2 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i7 >> 2] = i5;
  return i4 | 0;
 }
 i2 = i6 + 24 | 0;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0;
 i8 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i8 + (i3 * 24 | 0) >> 2] = HEAP32[i8 + (i4 * 24 | 0) >> 2];
 HEAP32[i8 + (i3 * 24 | 0) + 4 >> 2] = HEAP32[i8 + (i4 * 24 | 0) + 4 >> 2];
 HEAP32[i8 + (i3 * 24 | 0) + 8 >> 2] = HEAP32[i8 + (i4 * 24 | 0) + 8 >> 2];
 HEAP32[i8 + (i3 * 24 | 0) + 12 >> 2] = HEAP32[i8 + (i4 * 24 | 0) + 12 >> 2];
 HEAP32[i8 + (i3 * 24 | 0) + 16 >> 2] = HEAP32[i8 + (i4 * 24 | 0) + 16 >> 2];
 HEAP32[i8 + (i3 * 24 | 0) + 20 >> 2] = HEAP32[i8 + (i4 * 24 | 0) + 20 >> 2];
 i8 = HEAP32[i6 + 16 >> 2] | 0;
 i10 = i8 + (i4 << 3) | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i8 + (i3 << 3) | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] = i7;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + (i7 << 2) >> 2] = i3;
 i7 = i6 + 32 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i6 = i2 + (i5 << 2) | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i7 >> 2] = i5;
 return i4 | 0;
}

function __ZN20FileSystemEnumerator5MountEPKcP17FileSystemHandler(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, _strlen(i2) | 0);
 if (!i1) i1 = HEAP32[(HEAP32[gb + 1179016 >> 2] | 0) + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i6) | 0;
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN20FileSystemEnumerator10MountPointENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i5);
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i4 = i8;
 i7 = i6 + 40 | 0;
 do if (HEAP32[i7 >> 2] | 0) {
  i2 = (HEAPU16[(HEAP32[i1 + 104 >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 12 | 0) + 8 >> 1] | 0) & 63;
  i3 = i1 + 2392 + (i2 << 2) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i10 = gb + 63552 | 0;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i9;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   i1 = __Z18CreateDecompressor15CompressionType10MemLabelId(i2, i5) | 0;
   HEAP32[i3 >> 2] = i1;
   if (!i1) break;
  }
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i7 >> 2] | 0);
 } while (0);
 if ((HEAP32[i6 + 60 >> 2] | 0) > -1) {
  i10 = i6 + 44 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6 + 48 | 0);
  HEAP32[i10 >> 2] = 0;
 }
 if ((HEAP32[i6 + 24 >> 2] | 0) <= -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63552 | 0);
  STACKTOP = i8;
  return;
 }
 i10 = i6 + 8 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i10 >> 2] | 0, i6 + 12 | 0);
 HEAP32[i10 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63552 | 0);
 STACKTOP = i8;
 return;
}

function __ZN14CachingManager13GetTempFolderEv(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 444379 | 0, 4);
 __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i2, 1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  __Z6FormatPKcz(i2, gb + 444511 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 444242 | 0, 670, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i3;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i1, 47);
  __Z25CreateUniqueTempDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i4, i1, 100);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 24 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -24 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 44 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -44 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 1;
  i2 = i7 + 8 | 0;
  if (i1 >>> 0 < 9 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 i4 = i1 + (i3 << 1) | 0;
 i5 = i7 + 12 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
   i2 = i2 + 2 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 2 | 0;
  }
 }
 i2 = i7 + 20 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 8 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 20 | 0;
  if (i1 >>> 0 < 21 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 832604 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 24 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 20 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 20 | 0;
  if (i1 >>> 0 < 21 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else if (!i1) i1 = 0; else {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
   i5 = _PxGetFoundation() | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i4 | 0, i1 | 0, (i5 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 24 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 20 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx3Scb5Scene8addClothERNS0_5ClothE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i6 = i8 + 8 | 0;
 i5 = i8 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) if (__ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE(i1 + 16 | 0, i7 + 12 | 0) | 0) {
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & 268435455 | -2147483648;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 682639 | 0, 799, gb + 682719 | 0, i2);
  STACKTOP = i8;
  return;
 }
 i1 = i1 + 2820 | 0;
 i2 = i7 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 1073741823;
 if (i3 >>> 0 > 3221225471) {
  HEAP32[i2 >> 2] = i4 | -2147483648;
  if (i3 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i2 >> 2] = i4 | 1073741824;
  HEAP32[i5 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i5, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_(i12, i11, i1) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i2 = HEAP32[i9 + 20 >> 2] | 0;
 i8 = HEAP32[i9 + 28 >> 2] | 0;
 i10 = i2 + (i8 << 2) | 0;
 if ((i8 | 0) > 0) {
  i3 = i1;
  i1 = 0;
 } else {
  i12 = 0;
  return i12 | 0;
 }
 do {
  i4 = HEAP32[i2 >> 2] | 0;
  if ((HEAP8[i4 + 20 >> 0] | 0) == 1) {
   i8 = HEAP32[i4 + 32 >> 2] | 0;
   if ((i8 | 0) != (i11 | 0)) {
    i5 = __ZNK5physx2Sc13ConstraintSim8isBrokenEv(i8) | 0;
    i6 = HEAPU16[HEAP32[i8 + 100 >> 2] >> 1] | 0;
    i4 = i8 + 108 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (i9 | 0)) {
     i7 = i5 ? 0 : i6 & 4;
     i5 = i5 ? 0 : i6 & 2;
     i4 = i8 + 112 | 0;
    } else {
     i7 = i5 ? 0 : i6 & 2;
     i5 = i5 ? 0 : i6 & 4;
    }
    i6 = HEAP32[i4 >> 2] | 0;
    i4 = i6;
    if (i6) if (!(HEAP8[(HEAP32[i4 + 52 >> 2] | 0) + 44 >> 0] & 1)) if ((i5 | 0) != 0 | (i7 | 0) == 0) {
     i4 = HEAP32[i4 + 60 >> 2] | 0;
     i5 = i4 + 44 | 0;
     if (!(HEAP8[i5 >> 0] & 1)) {
      HEAP32[i3 >> 2] = i4;
      __ZN5physx2Sc19ConstraintGroupNode18initProjectionDataEPS1_PNS0_13ConstraintSimE(i4, i12, i8);
      HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 1;
      i3 = i3 + 4 | 0;
      i1 = i1 + 1 | 0;
     }
    }
   }
  }
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i10 >>> 0);
 return i1 | 0;
}

function __ZN5audio5mixer14GetFloatBufferERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDPKcPfi(i1, i7, i2, i11, i12, i13) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i14;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i9) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i3 = i1 + 20 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 4) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i3 + (i1 << 4) + 8 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + (i1 << 4) + 12 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i9 >>> 0) {
   i1 = 0;
   i10 = 12;
   break;
  }
 }
 if ((i10 | 0) == 12) {
  STACKTOP = i14;
  return i1 | 0;
 }
 HEAP32[i8 >> 2] = 0;
 i10 = (__ZN4FMOD3DSP11getUserDataEPPv(HEAP32[(HEAP32[i7 + 16 >> 2] | 0) + (i1 << 5) >> 2] | 0, i8) | 0) == 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i10 & (i1 | 0) != 0) {
  i2 = HEAP32[(HEAP32[i1 + 112 >> 2] | 0) + 192 >> 2] | 0;
  if (!i2) i1 = 0; else i1 = (mftCall_iiiii(i2 | 0, i1 | 0, i11 | 0, i12 | 0, i13 | 0) | 0) != 0;
 } else i1 = 0;
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN39AssetBundleLoadFromMemoryAsyncOperationC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 492269 | 0, 6);
 __ZN23PreloadManagerOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 27520 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 112 | 0, i4);
 HEAP8[i1 + 124 >> 0] = 1;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i1 + 128 | 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i3 >> 2] = gb + 27732 + 88;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAPF32[i1 + 136 >> 2] = Math_fround(0.0);
 __ZN4FileC2Ev(i1 + 144 | 0);
 i5 = i1 + 176 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP8[i5 + 12 >> 0] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[i1 >> 2] = gb + 28108 + 8;
 HEAP32[i3 >> 2] = gb + 28108 + 88;
 HEAP8[i1 + 188 >> 0] = 1;
 STACKTOP = i2;
 return;
}

function __ZN2UI14CanvasRenderer14GetPopMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if ((HEAP32[i1 + 128 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = HEAP32[i1 + 116 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 10;
  }
 }
 if ((i6 | 0) == 8) i6 = 10;
 if ((i6 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17UniqueIDGeneratorC2E10MemLabelId(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i6 = i10;
 i4 = i1;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i9 >> 2] = 0;
 i2 = i9 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i9 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i9 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i6 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i4, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i4, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i6;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i5 << 2) >> 2] = 16777215;
 HEAP32[i9 + 20 >> 2] = 1;
 STACKTOP = i10;
 return;
}

function __ZN13dynamic_arrayI10ColorRGBAfLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z13MurmurHash64BPKviy(i2, i5, i3, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i3 ^ i5;
 if ((i5 | 0) > 7) {
  i6 = i5 + -8 | 0;
  i7 = i6 & -8;
  i8 = i2 + (i7 + 8) | 0;
  i3 = i5;
  while (1) {
   i5 = Math_imul(HEAP32[i2 >> 2] | 0, 1540483477) | 0;
   i4 = (Math_imul(i5 >>> 24 ^ i5, 1540483477) | 0) ^ (Math_imul(i4, 1540483477) | 0);
   i5 = Math_imul(HEAP32[i2 + 4 >> 2] | 0, 1540483477) | 0;
   i1 = (Math_imul(i5 >>> 24 ^ i5, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
   i3 = i3 + -8 | 0;
   if ((i3 | 0) <= 7) break; else i2 = i2 + 8 | 0;
  }
  i3 = i6 - i7 | 0;
  i2 = i8;
 } else i3 = i5;
 if ((i3 | 0) > 3) {
  i8 = Math_imul(HEAP32[i2 >> 2] | 0, 1540483477) | 0;
  i3 = i3 + -4 | 0;
  i4 = (Math_imul(i8 >>> 24 ^ i8, 1540483477) | 0) ^ (Math_imul(i4, 1540483477) | 0);
  i2 = i2 + 4 | 0;
 }
 switch (i3 | 0) {
 case 3:
  {
   i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16 ^ i1;
   i9 = 11;
   break;
  }
 case 2:
  {
   i9 = 11;
   break;
  }
 case 1:
  {
   i9 = 12;
   break;
  }
 default:
  {}
 }
 if ((i9 | 0) == 11) {
  i1 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 ^ i1;
  i9 = 12;
 }
 if ((i9 | 0) == 12) i1 = Math_imul((HEAPU8[i2 >> 0] | 0) ^ i1, 1540483477) | 0;
 i8 = Math_imul(i1 >>> 18 ^ i4, 1540483477) | 0;
 i9 = Math_imul(i8 >>> 22 ^ i1, 1540483477) | 0;
 i8 = Math_imul(i9 >>> 17 ^ i8, 1540483477) | 0;
 i9 = Math_imul(i8 >>> 19 ^ i9, 1540483477) | 0;
 setTempRet0(i8 | 0);
 return i9 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 5) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -32 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc8ShapeSim12onFlagChangeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i6 + 28 | 0;
 i3 = HEAP8[(HEAP32[i5 >> 2] | 0) + 64 >> 0] | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 ^ i3) & 4) {
  __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh(i6, 1, 4);
  i1 = HEAP8[i2 >> 0] | 0;
 }
 i2 = (i3 & 5) != 0;
 i1 = (i1 & 5) == 0;
 if (i2 & i1) {
  i1 = i6 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i2 + 36 >> 2] | 0) + 1008 >> 2] | 0;
  __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E(i4, 0, HEAP32[i5 >> 2] | 0, i2, 0);
  __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE(i3, i4, i6);
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP8[i1 + 50 >> 0] | 0;
  if ((i1 | 0) == 0 | i5 << 24 >> 24 != 4 & i5 << 24 >> 24 != 1) {
   STACKTOP = i7;
   return;
  }
  i4 = i6 + 12 | 0;
  i5 = HEAP32[i4 + 4 >> 2] & 1073741823;
  i6 = i1 + 132 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2] & 1073741823;
  HEAP32[i6 + 4 >> 2] = i5;
  STACKTOP = i7;
  return;
 } else {
  if (i2 | i1) {
   STACKTOP = i7;
   return;
  }
  __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE(HEAP32[(HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0, 4, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN14BestStripCacheD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 72 >> 2] | 0;
 if (i1 | 0) {
  i2 = i5 + 76 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i4 = HEAP32[i5 + 60 >> 2] | 0;
 i1 = i4;
 if (i4 | 0) {
  i2 = i5 + 64 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
  __ZdlPv(i4);
 }
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 52 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 40 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 28 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __ZN13dynamic_arrayIP9b2FixtureLj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN11DetailPatch8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932716 | 0, gb + 1034406 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i4, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 28 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932723 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932736 | 0, i3, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z30TransferField_LinearCollectionI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 40 | 0;
 i4 = i8 + 32 | 0;
 i5 = i8;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i6 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = -1;
 if (!(HEAP32[i2 + 4 >> 2] | 0)) i7 = 3; else {
  __ZN21LinearCollectionField8GetArrayEv(i5, i3);
  i10 = i5;
  i9 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  i11 = i4;
  HEAP32[i11 >> 2] = i9;
  HEAP32[i11 + 4 >> 2] = i10;
  if (i10 >>> 0 > 4294967294 | (i10 | 0) == -2 & i9 >>> 0 > 4294967295) i7 = 3;
 }
 if ((i7 | 0) == 3) {
  i11 = __ZN21LinearCollectionField15GetElementClassEv(i3) | 0;
  HEAP32[i4 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i11, __Z34scripting_class_array_element_sizeP11Il2CppClass(i11) | 0, 0) | 0;
  HEAP32[i6 >> 2] = 0;
 };
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = i4;
 mftCall_vii(HEAP32[i1 + 40 >> 2] | 0, i1 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function _fnmatch(i3, i4, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = (i8 & 8 | 0) == 0;
 L1 : do if (!(i8 & 1)) {
  L3 : do if (!i7) {
   i2 = i4;
   i1 = i4;
   while (1) {
    switch (HEAP8[i1 >> 0] | 0) {
    case 0:
     break L3;
    case 47:
     {
      if (!(_fnmatch_internal(i3, -1, i4, i1 - i2 | 0, i8) | 0)) {
       i1 = 0;
       break L1;
      }
      break;
     }
    default:
     {}
    }
    i1 = i1 + 1 | 0;
   }
  } while (0);
  i1 = _fnmatch_internal(i3, -1, i4, -1, i8) | 0;
 } else {
  i1 = i4;
  while (1) {
   i4 = i1;
   L13 : while (1) {
    switch (HEAP8[i4 >> 0] | 0) {
    case 47:
    case 0:
     {
      i2 = i3;
      break L13;
     }
    default:
     {}
    }
    i4 = i4 + 1 | 0;
   }
   L16 : while (1) {
    i5 = _pat_next(i2, -1, i6, i8) | 0;
    switch (i5 | 0) {
    case 0:
    case 47:
     break L16;
    default:
     {}
    }
    i2 = i2 + (HEAP32[i6 >> 2] | 0) | 0;
   }
   i10 = HEAP8[i4 >> 0] | 0;
   if ((i5 | 0) != (i10 << 24 >> 24 | 0) & (i7 | i10 << 24 >> 24 == 0)) {
    i1 = 1;
    break L1;
   }
   i1 = (_fnmatch_internal(i3, i2 - i3 | 0, i1, i4 - i1 | 0, i8) | 0) != 0;
   if ((i5 | 0) == 0 | i1) {
    i1 = i1 & 1;
    break L1;
   }
   i3 = i2 + (HEAP32[i6 >> 2] | 0) | 0;
   i1 = i4 + 1 | 0;
  }
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i5 = i7 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i8 + 4 | 0;
  do {
   HEAP32[i5 >> 2] = i2 + -88;
   i3 = i2 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i8 >> 2] = 66;
    HEAP32[i6 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i8);
   }
   i3 = HEAP32[i2 + -36 >> 2] | 0;
   if (i3 | 0) {
    i4 = i2 + -32 | 0;
    if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
    __ZdlPv(i3);
   }
   i3 = HEAP32[i2 + -64 >> 2] | 0;
   if (i3 | 0) {
    i4 = i2 + -60 | 0;
    if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i3;
    __ZdlPv(i3);
   }
   i3 = HEAP32[i2 + -80 >> 2] | 0;
   if (i3 | 0) {
    i2 = i2 + -76 | 0;
    if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i3;
    __ZdlPv(i3);
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i8 >> 2] = 25;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i8);
 STACKTOP = i9;
 return;
}

function __ZN8Playable7SetTimeEd(i2, d6) {
 i2 = i2 | 0;
 d6 = +d6;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 248 | 0;
 i3 = i7;
 i4 = i7 + 240 | 0;
 i1 = i2 + 24 | 0;
 do if ((HEAP16[i1 >> 1] | 0) > 0) {
  i8 = __Z18GetDirectorManagerv() | 0;
  i1 = (__ZNK15DirectorManager16GetScriptMethodsEs(i8, HEAP16[i1 >> 1] | 0) | 0) + 16 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   STACKTOP = i7;
   return;
  } else {
   i8 = HEAP32[i2 + 4 >> 2] | 0;
   i10 = i1;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i9;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i8, i5);
   __ZN18ScriptingArguments8AddFloatEf(i3, Math_fround(d6));
   HEAP32[i5 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
   break;
  }
 } while (0);
 i4 = i2 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 do {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (i2) {
   mftCall_vid(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, +d6);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != ((HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 28 >> 2] << 3) | 0));
 STACKTOP = i7;
 return;
}

function __ZN8Animator12GetBehaviourEP11Il2CppClass(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 8 | 0;
 i3 = i9;
 i8 = i9 + 16 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i3);
 i10 = i2;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i8 | 0);
 L4 : do if (!(HEAP32[i5 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i1 = __ZN26AnimatorControllerPlayable12GetBehaviourEP11Il2CppClass(HEAP32[i2 >> 2] | 0, i4) | 0;
   i2 = i2 + 4 | 0;
   if (i1 | 0) break L4;
   if ((i2 | 0) == ((HEAP32[i8 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
  HEAP32[i8 >> 2] = 0;
 }
 i10 = i1;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 6) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -64 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN17GeneralConnectionC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 65600 + 8;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN15MulticastSocketC2Ev(i1 + 16 | 0);
 __ZN15MulticastSocketC2Ev(i1 + 52 | 0);
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = i1 + 92;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = i1 + 104;
 i5 = i1 + 112 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP8[i1 + 140 >> 0] = 1;
 if (!(__Z6GetIPsPA16_c(i2) | 0)) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i3, gb + 459312 | 0) | 0; else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i3, i2) | 0;
 d6 = +_emscripten_get_now() * 1.0e6;
 i3 = __Z17TimeToNanosecondsy(~~d6 >>> 0, +Math_abs(d6) >= 1.0 ? (d6 > 0.0 ? ~~+Math_min(+Math_floor(d6 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d6 - +(~~d6 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 getTempRet0() | 0;
 i5 = (Math_imul(i3, 1790253981) | 0) + 1900727103 | 0;
 i3 = i3 << 11 ^ i3;
 i5 = i5 ^ i3 ^ i3 >>> 8 ^ i5 >>> 19;
 HEAP32[i1 + 136 >> 2] = (i5 | 0) == 0 ? 1 : i5;
 STACKTOP = i4;
 return;
}

function __ZN13dynamic_arrayIP8MaterialLj4EEC2ERKS2_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z40BillboardAsset_CUSTOM_GetIndicesInternalP12Il2CppObjectS0_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 64 >> 2] | 0;
 i2 = i7 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 + 80 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i1, 2, i3) | 0;
  HEAP32[i2 >> 2] = i4;
  i3 = HEAP32[i6 >> 2] | 0;
 } else i4 = HEAP32[i2 >> 2] | 0;
 __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i3 | 0) <= 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = i7 + 12 | 0;
  HEAP32[i6 >> 2] = i5;
  i7 = i7 + 16 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 + 1 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i1 = HEAP32[i5 + 68 >> 2] | 0;
 i2 = 0;
 while (1) {
  i5 = HEAP16[i1 >> 1] | 0;
  HEAP16[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 2) | 0) >> 1] = i5;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = i5;
 i7 = i7 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 + 1 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __Z21IntersectSegmentPlaneRK8Vector3fS1_RK5PlanePS_(i1, i2, i9, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0, f15 = f0;
 f14 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i1 >> 2]);
 f14 = Math_fround(f14 - f13);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(f11 - f10);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 - f7);
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f6 = Math_fround(f14 * f3);
 f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f11 * f4));
 f5 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f8 * f5));
 i2 = f6 < Math_fround(0.0);
 f15 = Math_fround(-f6);
 if ((i2 ? f15 : f6) <= Math_fround(9.99999997e-07)) {
  i12 = 0;
  return i12 | 0;
 }
 f3 = Math_fround(-Math_fround(Math_fround(Math_fround(f13 * f3) + Math_fround(f10 * f4)) + Math_fround(f7 * f5)));
 f3 = Math_fround(Math_fround(f3 - Math_fround(HEAPF32[i9 + 12 >> 2])) / f6);
 if (f3 < Math_fround(0.0) | f3 > Math_fround(1.0)) {
  i12 = 0;
  return i12 | 0;
 }
 f11 = Math_fround(f10 + Math_fround(f11 * f3));
 f15 = Math_fround(f7 + Math_fround(f8 * f3));
 HEAPF32[i12 >> 2] = Math_fround(f13 + Math_fround(f14 * f3));
 HEAPF32[i12 + 4 >> 2] = f11;
 HEAPF32[i12 + 8 >> 2] = f15;
 i12 = 1;
 return i12 | 0;
}

function _UNITY_FT_Stream_EnterFrame(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 HEAP32[i6 >> 2] = 0;
 i3 = i7 + 20 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i1 = i7 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i7 + 4 >> 2] | 0;
  if (i5 >>> 0 <= i2 >>> 0 | (i5 - i2 | 0) >>> 0 < i8 >>> 0) {
   HEAP32[i6 >> 2] = 85;
   i8 = 85;
   STACKTOP = i9;
   return i8 | 0;
  } else {
   i6 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
   HEAP32[i7 + 32 >> 2] = i6;
   HEAP32[i7 + 36 >> 2] = i6 + i8;
   HEAP32[i1 >> 2] = i2 + i8;
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 i4 = HEAP32[i7 + 28 >> 2] | 0;
 if ((HEAP32[i7 + 4 >> 2] | 0) >>> 0 < i8 >>> 0) {
  HEAP32[i6 >> 2] = 85;
  i8 = 85;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = _UNITY_ft_mem_qalloc(i4, i8, i6) | 0;
 HEAP32[i7 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i5 = i7 + 8 | 0;
 i3 = mftCall_iiiii(HEAP32[i3 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0, i2 | 0, i8 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i8 >>> 0) {
  _UNITY_ft_mem_free(i4, i1);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 85;
  i2 = 85;
  i1 = 0;
 } else i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 + 32 >> 2] = i1;
 HEAP32[i7 + 36 >> 2] = i1 + i8;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
 i8 = i2;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNSt3__212ctype_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i6, i3, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __ZNSt3__25ctypeIcEC2EPKtbj(i6, 0, 0, i1);
 HEAP32[i6 >> 2] = gb + 212824 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, ((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0, 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i6 + 16 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i2;
   return;
  }
  i4 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1081576 | 0, i3 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i4 | 0, i5 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (!i2) break;
  }
  ___cxa_free_exception(i4 | 0);
 } while (0);
 __ZNSt3__25ctypeIcED2Ev(i6);
 ___resumeException(i1 | 0);
}

function __ZN5physx7NpScene12addAggregateERNS_11PxAggregateE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i5 = i8 + 4 | 0;
 i4 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = i6 + 8 | 0;
 switch ((HEAP32[i6 + 12 >> 2] | 0) >>> 30 | 0) {
 case 0:
  break;
 case 3:
  {
   if ((__ZN5physx3Scb5Scene10getPxSceneEv(HEAP32[i1 >> 2] | 0) | 0) != (i7 | 0)) i3 = 9;
   break;
  }
 default:
  i3 = 9;
 }
 if ((i3 | 0) == 9) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 1078, gb + 709113 | 0, i2);
  STACKTOP = i8;
  return;
 }
 __ZN5physx3Scb5Scene12addAggregateERNS0_9AggregateE(i7 + 16 | 0, i1);
 if (i4 | 0) {
  i1 = i6 + 40 | 0;
  i2 = 0;
  do {
   __ZN5physx11NpAggregate16addActorInternalERNS_7PxActorERNS_7NpSceneE(i6, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, i7);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 i1 = i7 + 3576 | 0;
 HEAP32[i5 >> 2] = i6;
 i2 = i7 + 3580 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 3584 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i5) | 0;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs5setupEjjPPKNS_10PxMaterialEPKNS_28PxVehicleDrivableSurfaceTypeE(i10, i9, i8, i5, i6) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i2 = i10 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i10 + 16 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 _memset(i10 | 0, 0, ((Math_imul(i1 << 2, i7) | 0) + 47 & -16) + ((i7 << 3) + 30 & -32) | 0) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i4 >> 2] = i7;
 i4 = i10 + 32 | 0;
 HEAP32[i10 >> 2] = i4;
 i7 = Math_imul(i8, i9) | 0;
 i2 = (i7 << 2) + 15 & -16;
 i1 = i4 + i2 | 0;
 i3 = i10 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i4 + (i2 + ((i8 << 2) + 15 & -16)) | 0;
 i4 = i10 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i8 | 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  if ((i8 | 0) != 1) {
   i1 = 1;
   do {
    i2 = HEAP32[i3 >> 2] | 0;
    HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
    HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i5 + (i1 << 2) >> 2];
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i8 | 0));
  }
 }
 if (!i7) {
  i7 = i10 + 20 | 0;
  HEAP32[i7 >> 2] = i9;
  i10 = i10 + 12 | 0;
  HEAP32[i10 >> 2] = i8;
  return;
 }
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = 0;
 do {
  HEAPF32[i1 + (i2 << 2) >> 2] = Math_fround(1.0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 i7 = i10 + 20 | 0;
 HEAP32[i7 >> 2] = i9;
 i10 = i10 + 12 | 0;
 HEAP32[i10 >> 2] = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 8; else i1 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89808 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc9StaticSim21postActor2WorldChangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 28 | 0;
 i10 = i12;
 __ZN5physx2Sc8RigidSim25notifyShapeTranformChangeEv(i1);
 i2 = HEAP32[(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0) + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i11 >> 2] = 0;
 __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i11, i1);
 i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i11) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i8 = i2 + 7628 | 0;
 i9 = i10 + 4 | 0;
 i3 = i10 + 8 | 0;
 i4 = i10 + 12 | 0;
 i5 = i10 + 16 | 0;
 i6 = i10 + 20 | 0;
 i7 = i10 + 24 | 0;
 i2 = i1;
 do {
  i1 = i2 + 24 | 0;
  if ((HEAP32[i1 >> 2] | 0) != -1) {
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i10, i2);
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i8 >> 2] | 0;
   HEAP32[i1 + (i2 * 28 | 0) >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 4 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 8 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 16 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 20 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 24 >> 2] = HEAP32[i7 >> 2];
  }
  i2 = __ZN5physx2Sc13ShapeIterator7getNextEv(i11) | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i12;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj452ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj451ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN23CloudWebServicesManager25RemoveCloudServiceHandlerEP19CloudServiceHandler(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i7 + 28 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i7 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 } else {
  i3 = i5;
  i2 = i6;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) {
  STACKTOP = i10;
  return;
 }
 if ((i3 | 0) == (i5 | 0) ? 1 : (i4 | 0) < (HEAP32[i3 + 16 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) HEAP32[i9 >> 2] = i1;
 i9 = i7 + 40 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i6, i3);
 i9 = HEAP32[i7 + 36 >> 2] | 0;
 HEAP32[i8 >> 2] = 85;
 HEAP32[i8 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
 STACKTOP = i10;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIN11UnityEngine9Animation28AnimationClipBindingConstantEEEvRT_PKc17TransferMetaFlags(i10, i8, i1, i2) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i4 = i8 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i7 = i10 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i10 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = HEAP32[i8 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 << 4) | 0;
 if (i4 | 0) do {
  __ZN11UnityEngine9Animation14GenericBinding8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i8 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i7 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = HEAP32[i8 + 20 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i10, i1, i11, i12, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i10 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i9 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i6 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 __Z9RecordJobPFvPvES_R21SingleThreadedJobInfo(i11, i12, (HEAP32[i6 >> 2] | 0) + (i8 << 4) | 0);
 if ((HEAP32[i10 + 16 >> 2] | 0) == -1) return;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo((HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN13dynamic_arrayI8Vector4fLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 3;
 i2 = i1 >> 3;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 3;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13BoxCollider2D8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i5, i6);
 __ZN14SafeBinaryRead10SetVersionEi(i6, 2);
 i2 = i5 + 160 | 0;
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 842535 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 1) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 1034411 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if ((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i5 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0) {
  STACKTOP = i7;
  return;
 }
 i4 = gb + 1162356 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZNK17BaseWebCamTexture9GetDeviceEv(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 i3 = i1 + 108 | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 112 >> 2] | 0; else i1 = i2 & 255;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i3);
  STACKTOP = i8;
  return;
 }
 HEAP32[i7 >> 2] = 0;
 i4 = i7 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb(i7, 0);
 i1 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 874895 | 0, 20);
 } else __Z24scripting_cpp_string_forP12Il2CppString(i5, HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~((i3 + -8 - i2 | 0) >>> 3) << 3);
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i6 >> 2] = 56;
  HEAP32[i6 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 STACKTOP = i8;
 return;
}

function __ZN8Animator18AutoMecanimDataSet5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN8Animator13AvatarDataSet5ResetEv(i1);
 i3 = i1 + 44 | 0;
 __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i1 + 52 | 0);
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 64 | 0;
 i4 = i1 + 32 | 0;
 __ZN25RuntimeAnimatorController23DestroyCustomControllerEPN7mecanim9animation18ControllerConstantERNS0_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i4);
 i5 = i1 + 68 | 0;
 __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(HEAP32[i5 >> 2] | 0, i4);
 i1 = i1 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 + 24 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 + 32 >> 2] | 0);
 __ZN7mecanim9animation19DestroyAnimationSetEPNS0_12AnimationSetERNS_6memory9AllocatorE(HEAP32[i2 + 36 >> 2] | 0, i4);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx7NpScene18removeRigidDynamicERNS_14NpRigidDynamicEbb(i5, i2, i4, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0) & 8) == 0;
 if (i3) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0) __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0, i2, 0) | 0;
 __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i2 + 20 | 0, i5 + 3392 | 0);
 if (i1) __ZN5physx7NpActor26removeConstraintsFromSceneEv(i2 + 12 | 0);
 i1 = i2 + 48 | 0;
 __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i5 + 16 | 0, i1, i4, (HEAP16[(HEAP32[gb + 90260 + 24 + (((HEAP32[i2 + 52 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 + 8 >> 1] & 8) != 0);
 i4 = i2 + 36 | 0;
 i1 = i5 + 3556 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i1 = i5 + 3552 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i5 + (i3 << 2) >> 2];
 if (!i3) return;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
 case 0:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 case 1:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 default:
  return;
 }
}

function __ZN2UI14CanvasRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 if ((HEAP32[i1 + 108 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = HEAP32[i1 + 96 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 10;
  }
 }
 if ((i6 | 0) == 8) i6 = 10;
 if ((i6 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 16 | 0;
 i8 = i12 + 4 | 0;
 i9 = i12;
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1159952 >> 2] | 0;
 i4 = 1 << (i3 & 31);
 if (i2) {
  i10 = i10 + (i3 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i4;
 } else {
  i10 = i10 + (i3 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~i4;
 }
 __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf(i5, i7, i8, i9);
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i11 + 1664 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 + 1668 >> 2] = i5;
 HEAP32[i11 + 1672 >> 2] = i10;
 HEAPF32[i11 + 1676 >> 2] = Math_fround(0.0);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i11 + 1648 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i11 + 1652 >> 2] = i7;
 HEAP32[i11 + 1656 >> 2] = i10;
 HEAPF32[i11 + 1660 >> 2] = Math_fround(0.0);
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i11 + 1680 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 1684 >> 2] = i8;
 HEAP32[i11 + 1688 >> 2] = i9;
 HEAP32[i11 + 1692 >> 2] = i10;
 HEAP8[i1 + 57 >> 0] = 1;
 STACKTOP = i12;
 return;
}

function __ZN19RuntimeSceneManager37ClearAndUnloadWaitingForLoadingScenesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i8 + 24 | 0;
 i10 = i8 + 36 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i5 = i8 + 4 | 0;
  i6 = i8 + 16 | 0;
  i2 = 0;
  do {
   i3 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
   __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene(i8, i3);
   i1 = HEAP32[i5 >> 2] | 0;
   i11 = HEAP32[i6 >> 2] | 0;
   i4 = i1 + (i11 << 2) | 0;
   L5 : do if (!i11) i7 = 9; else do {
    if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
     i7 = 9;
     break L5;
    }
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i4 | 0)); while (0);
   if ((i7 | 0) == 9) {
    i7 = 0;
    if ((i1 | 0) != (i4 | 0)) {
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
     i11 = i1 + 4 | 0;
     _memmove(i1 | 0, i11 | 0, (HEAP32[i5 >> 2] | 0) + (HEAP32[i6 >> 2] << 2) - i11 | 0) | 0;
     HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
    }
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
 }
 i1 = i8 + 40 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i9 >> 2] | 0, i8 + 28 | 0);
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14TerrainManager21OffsetLightmapIndicesE18RemapLightmapIndexS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i5 = i4;
 if ((i5 | 0) == (i10 | 0)) return;
 i11 = HEAP32[i2 >> 2] | 0;
 i8 = i2 + 4 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i7 = i3 + 4 | 0;
 i1 = i4;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i6 = i4 + 152 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i1 = i3 >>> 16;
  i2 = i3 & 65535;
  if ((i3 & 65535) < 65534 & i2 >>> 0 >= i11 >>> 0) i2 = (HEAP32[i8 >> 2] | 0) + i2 | 0; else i2 = i3;
  if ((i1 & 65535) < 65534 & i1 >>> 0 >= i9 >>> 0) i1 = (HEAP32[i7 >> 2] | 0) + i1 | 0;
  i1 = i1 << 16 | i2 & 65535;
  if ((i3 | 0) != (i1 | 0)) {
   HEAP32[i6 >> 2] = i1;
   i3 = i4 + 228 | 0;
   i2 = i4 + 240 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 108 >> 2] = i1;
    HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i6 >> 2];
    i1 = i4 + 20 | 0;
    if ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0)) do {
     HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i6 >> 2];
     HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i6 >> 2];
     i1 = i1 + 20 | 0;
    } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
   }
  }
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i5 = i1;
 } while ((i5 | 0) != (i10 | 0));
 return;
}

function __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i4) {
  STACKTOP = i7;
  return;
 }
 i1 = __ZN6Shader20GetScreenClearShaderEv() | 0;
 __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i5, __Z12GetGfxDevicev() | 0);
 __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
 i6 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(HEAP32[(HEAP32[HEAP32[(HEAP32[i8 >> 2] | 0) + (HEAP32[i8 + 48 >> 2] << 2) >> 2] >> 2] | 0) + 28 >> 2] | 0, 0, 0, HEAP32[gb + 1166248 >> 2] | 0, i1, 7, 0, 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 580 >> 2] | 0, i6 | 0, 0, i1 | 0);
 mftCall_viffff(HEAP32[(HEAP32[i6 >> 2] | 0) + 568 >> 2] | 0, i6 | 0, 0.0, 0.0, 0.0, 0.0);
 i1 = 0;
 do {
  i8 = i2 + (HEAP32[i3 + (i1 << 2) >> 2] << 1 << 2) | 0;
  f9 = Math_fround(HEAPF32[i8 >> 2]);
  mftCall_vifff(HEAP32[(HEAP32[i6 >> 2] | 0) + 560 >> 2] | 0, i6 | 0, +f9, +Math_fround(HEAPF32[i8 + 4 >> 2]), .100000001);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 584 >> 2] | 0, i6 | 0);
 __ZN22DeviceMVPMatricesStateD2Ev(i5);
 STACKTOP = i7;
 return;
}

function _tt_size_request(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = HEAP32[i5 >> 2] | 0;
 do if (!(HEAP32[i2 + 8 >> 2] & 2)) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[(HEAP32[i2 + 532 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i4 | 0, i3 | 0) | 0;
  if (i1 | 0) {
   HEAP32[i5 + 112 >> 2] = -1;
   i2 = HEAP32[i5 >> 2] | 0;
   break;
  }
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i5 + 112 | 0;
  HEAP32[i3 >> 2] = i1;
  if (!(HEAP32[i2 + 8 >> 2] & 1)) {
   i1 = mftCall_iiii(HEAP32[(HEAP32[i2 + 532 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0, i5 + 12 | 0) | 0;
   if (!i1) i1 = 0; else HEAP32[i3 >> 2] = -1;
  } else {
   _UNITY_FT_Select_Metrics(i2, i1);
   _UNITY_tt_size_reset(i5) | 0;
   i1 = 0;
  }
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 } while (0);
 _UNITY_FT_Request_Metrics(i2, i4);
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] & 1)) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = _UNITY_tt_size_reset(i5) | 0;
 i3 = i5 + 12 | 0;
 i5 = i5 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 i5 = i4;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj6ENS_22PxRepXPropertyAccessorILj6ES4_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 16; else i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89360 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx14NpRigidDynamicC2ERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP16[i2 + 4 >> 1] = 5;
 HEAP16[i2 + 6 >> 1] = 3;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 97896 + 8;
 __ZN5physx7NpActorC2EPKc(i2 + 12 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerC2Ev(i2 + 20 | 0);
 HEAP32[i2 >> 2] = gb + 98548 + 8;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 i4 = i2 + 52 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i2 + 64 | 0;
 __ZN5physx2Sc8BodyCoreC2ENS_11PxActorType4EnumERKNS_11PxTransformE(i3, 1, i1);
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -251658241 | 50331648;
 HEAP32[i2 + 224 >> 2] = HEAP32[i2 + 80 >> 2];
 HEAP32[i2 + 228 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i2 + 232 >> 2] = HEAP32[i2 + 88 >> 2];
 HEAP32[i2 + 236 >> 2] = HEAP32[i2 + 92 >> 2];
 HEAP32[i2 + 240 >> 2] = HEAP32[i2 + 96 >> 2];
 HEAP32[i2 + 244 >> 2] = HEAP32[i2 + 100 >> 2];
 HEAP32[i2 + 248 >> 2] = HEAP32[i2 + 104 >> 2];
 HEAP32[i2 + 252 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i2 + 256 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i2 + 260 >> 2] = HEAP32[i2 + 152 >> 2];
 HEAP32[i2 + 264 >> 2] = HEAP32[i2 + 160 >> 2];
 HEAP32[i2 + 268 >> 2] = HEAP32[i2 + 164 >> 2];
 HEAP32[i2 + 272 >> 2] = HEAP32[i2 + 168 >> 2];
 HEAPF32[i2 + 276 >> 2] = Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i3));
 HEAP32[i2 + 280 >> 2] = 1;
 HEAP32[i2 + 284 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 98884 + 8;
 return;
}

function __ZN22UnityProfilerPerThread18SampleGCAllocationEP12Il2CppObjectP11Il2CppClass(i11, i1, i2) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!(HEAP8[i11 >> 0] | 0)) return;
 i10 = __Z25scripting_object_get_sizeP12Il2CppObject(i1) | 0;
 i2 = HEAP32[(HEAP32[i11 + 36 >> 2] | 0) + ((HEAP32[i11 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
 i3 = i11 + 96 | 0;
 i4 = i11 + 108 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i11 + 112 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 3, 4, i11 + 100 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i11 + 100 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i11 = (HEAP32[i3 >> 2] | 0) + (i5 << 3) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i10;
 i11 = HEAP32[gb + 1163248 >> 2] | 0;
 i9 = i11 + 112 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i11 = i11 + 116 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i10;
 return;
}

function __ZN18ColorBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i6 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620164 | 0, gb + 620954 | 0, i6, 0);
 __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 164 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 168 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13WheelCollider19SetWheelDampingRateEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i2 + 100 | 0;
 if (Math_fround(HEAPF32[i9 >> 2]) != f1) {
  i7 = f1 < Math_fround(.00100000005);
  HEAP32[i9 >> 2] = i7 ? 981668463 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 i7 = i2 + 148 | 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  STACKTOP = i10;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 52 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 if (!(HEAP32[i2 + 56 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i2 = i3 + 56 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + 8 | 0;
 i4 = i8;
 i5 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i3, HEAP32[i7 >> 2] | 0) | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i8 + 16 >> 2] = HEAP32[i9 >> 2];
 __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i3, HEAP32[i7 >> 2] | 0, i8);
 i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i9 >> 2] | 0) + 284 >> 2] | 0, i9 | 0);
 STACKTOP = i10;
 return;
}

function __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDataR17ShaderPassContext(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i5 + 8 | 0;
 i9 = i5;
 i6 = __ZnwjRK10MemLabelIdiPKci(108, gb + 64024 | 0, 16, gb + 388526 | 0, 339) | 0;
 i11 = gb + 64024 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 36880 + 8;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i12;
 HEAP32[i8 + 4 >> 2] = i11;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i6 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP8[i6 + 104 >> 0] = 1;
 i8 = i2 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i7 >> 2] = i2;
 __ZN15ReplacementPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceData(i6, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, i1, i2 + 8 | 0, i3);
 __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext(i6, i4);
 STACKTOP = i5;
 return;
}

function _sfnt_module_class_pic_init(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 i2 = _UNITY_ft_mem_alloc(HEAP32[i6 >> 2] | 0, 156, i7) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 _memset(i2 | 0, 0, 156) | 0;
 i5 = i6 + 212 | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = _UNITY_FT_Create_Class_sfnt_services(i6, i2) | 0;
 HEAP32[i7 >> 2] = i1;
 if (!i1) {
  i1 = _UNITY_FT_Create_Class_tt_cmap_classes(i6, i2 + 20 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
  if (!i1) {
   _UNITY_FT_Init_Class_sfnt_service_ps_name(i6, i2 + 12 | 0);
   _UNITY_FT_Init_Class_tt_service_get_cmap_info(i6, i2 + 16 | 0);
   _UNITY_FT_Init_Class_sfnt_service_sfnt_table(i2 + 24 | 0);
   _UNITY_FT_Init_Class_sfnt_interface(i6, i2 + 36 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
   if (!i1) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
  }
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_sfnt_services(i6, i1);
 HEAP32[i4 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _UNITY_FT_Destroy_Class_tt_cmap_classes(i6, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i3, i4);
 HEAP32[i5 >> 2] = 0;
 i7 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorI5RectTIfENS_9allocatorIS2_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 4 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 16 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 4) + i2 | 0;
 if (i5 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 3;
 i3 = i6 >> 4 >>> 0 < 134217727 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 268435455;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 4) | 0;
 i6 = i5 + (i1 - i4 >> 4 << 4) | 0;
 i5 = i5 + (i3 << 4) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  i1 = i4 + 16 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 4) << 4) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  i7 = i9 + 4 | 0;
  do {
   i3 = i1 + -132 | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i1 + -36 | 0;
   if ((HEAP32[i1 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -32 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i1 + -116 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -104 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -120 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i7 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i11 = HEAP32[HEAP32[i8 + 16 >> 2] >> 2] | 0;
 HEAP32[i9 >> 2] = 25;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __ZNK8Material15ShaderHasErrorsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i7 = 1;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = (HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[gb + 1166244 >> 2] | 0);
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc19ClothFabricBulkData15exportExtraDataERNS_22PxSerializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 12 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 8 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 24 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 20 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 32 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 40 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 48 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 44 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 60 >> 2] | 0;
  if (i2 & 2147483647 | HEAP32[i4 + 56 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 }
 i1 = HEAP32[i4 + 64 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i4 + 72 >> 2] | 0;
 if (!(i2 & 2147483647 | HEAP32[i4 + 68 >> 2])) return;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i10 + 128 | 0;
 i1 = 1 - (HEAP32[i7 >> 2] | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i8 = i10 + 40 + (i1 * 12 | 0) + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i10 + 152 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i2;
 if (!i2) {
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  i10 = HEAP32[i7 >> 2] | 0;
  i10 = 1 - i10 | 0;
  HEAP32[i7 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 40 + (i1 * 12 | 0) | 0;
 i4 = i10 + 116 | 0;
 i5 = i10 + 112 | 0;
 i6 = i10 + 120 | 0;
 i1 = i2;
 do {
  i2 = i1 + -1 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i4 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i9) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 i10 = HEAP32[i7 >> 2] | 0;
 i10 = 1 - i10 | 0;
 HEAP32[i7 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZN4gles15UpdateColorMaskER15DeviceStateGLESPK20DeviceBlendStateGLESj(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = (i1 | 0) == 0 ? HEAP32[i5 + 468 >> 2] | 0 : i1;
 i1 = i7;
 i2 = i4;
 i3 = i1 + 68 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = i6 & 255;
 if ((HEAPU8[i7 >> 0] | 0 | 0) == (i6 | 0)) i1 = 0; else {
  HEAP8[i7 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 8 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 16 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 24 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 32 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 40 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 48 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) != (i6 | 0)) {
  HEAP8[i2 >> 0] = i3;
  i1 = 1;
 }
 i2 = i7 + 56 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) == (i6 | 0)) {
  if (!i1) {
   i7 = i4;
   STACKTOP = i8;
   return i7 | 0;
  }
 } else HEAP8[i2 >> 0] = i3;
 i7 = __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i5, i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 4;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z32AnimatorControllerParameterToCppRK31MonoAnimatorControllerParameterR27AnimatorControllerParameter(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __Z24scripting_cpp_string_forP12Il2CppString(i8, HEAP32[i4 >> 2] | 0);
 i6 = HEAP8[i8 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i9 = i7 ? HEAP32[i8 >> 2] | 0 : i8;
 i6 = i7 ? HEAP32[i8 + 4 >> 2] | 0 : i6 & 255;
 i7 = i5 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i5 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i6 >>> 0 > i3 >>> 0) {
  i7 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i5, i3, i6 - i3 | 0, i7, 0, i7, i6, i9);
 } else {
  i1 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
  if (i6 | 0) _memmove(i1 | 0, i9 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) {
   HEAP32[i5 + 4 >> 2] = i6;
   break;
  } else {
   HEAP8[i7 >> 0] = i6;
   break;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP8[i5 + 28 >> 0] = HEAP8[i4 + 16 >> 0] | 0;
 STACKTOP = i10;
 return;
}

function __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 20 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 20 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 20 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 20 | 0);
 __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -8 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNK14NavMeshCarving28CollectCarveDataAndOperationER15CarveDataArraysRK10MinMaxAABBRK13dynamic_arrayIS2_Lj4EE(i6, i7, i8, i4) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i6 + 60 >> 2] | 0;
 L1 : do if (!i2) i3 = 5; else {
  i3 = i6 + 48 | 0;
  i1 = 0;
  while (1) {
   if (__Z17IntersectAABBAABBRK10MinMaxAABBS1_((HEAP32[i3 >> 2] | 0) + (i1 * 24 | 0) | 0, i8) | 0) {
    i5 = 1;
    i3 = 9;
    break L1;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) {
    i3 = 5;
    break;
   }
  }
 } while (0);
 L6 : do if ((i3 | 0) == 5) {
  i2 = HEAP32[i4 + 12 >> 2] | 0;
  if (i2 | 0) {
   i1 = 0;
   do {
    if (__Z17IntersectAABBAABBRK10MinMaxAABBS1_((HEAP32[i4 >> 2] | 0) + (i1 * 24 | 0) | 0, i8) | 0) {
     i5 = 0;
     i3 = 9;
     break L6;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
 } while (0);
 if ((i3 | 0) == 9) {
  i4 = i6 + 20 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i2 = i6 + 8 | 0;
   i1 = 0;
   do {
    i3 = HEAP32[i2 >> 2] | 0;
    if (HEAP32[i3 + (i1 * 120 | 0) + 112 >> 2] | 0) if (__Z17IntersectAABBAABBRK10MinMaxAABBS1_(i3 + (i1 * 120 | 0) + 88 | 0, i8) | 0) __ZN15CarveDataArrays8PushBackERK16NavMeshCarveData(i7, (HEAP32[i2 >> 2] | 0) + (i1 * 120 | 0) | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  i1 = (HEAP32[i7 + 24 >> 2] | 0) != 0;
  if (i5 | i1) {
   i8 = i1 ? 2 : 1;
   return i8 | 0;
  }
 }
 i8 = 0;
 return i8 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEE14handleAccessorILj122ENS_22PxRepXPropertyAccessorILj122ES4_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 89424 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc8ClothSim21removeCollisionSphereEPKNS0_8ShapeSimE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i15 + 8 | 0;
 i10 = i15;
 i11 = HEAP32[i5 + 52 >> 2] | 0;
 i12 = i5 + 116 | 0;
 i8 = HEAP32[i12 >> 2] | 0;
 i13 = i5 + 84 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i4 = 0;
 while (1) {
  if (i4 >>> 0 >= i14 >>> 0) {
   i6 = 8;
   break;
  }
  i2 = i8 + (i4 << 2) | 0;
  i3 = i4 + 1 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
   i7 = i4;
   break;
  } else i4 = i3;
 }
 if ((i6 | 0) == 8) {
  STACKTOP = i15;
  return;
 }
 i4 = i5 + 120 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 < i5 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i8 + (i3 << 2) >> 2];
  i1 = i7 + 2 | 0;
  if (i1 >>> 0 < i5 >>> 0) do {
   i2 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[(HEAP32[i12 >> 2] | 0) + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 HEAP32[i4 >> 2] = i5 + -1;
 HEAP32[i13 >> 2] = i14 + -1;
 i14 = (HEAP32[i11 + 72 >> 2] | 0) + i7 | 0;
 i13 = HEAP32[i11 + 28 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 mftCall_viiii(i12 | 0, i13 | 0, i9 | 0, i14 | 0, i14 + 1 | 0);
 STACKTOP = i15;
 return;
}

function __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i10 + 124 | 0;
 i1 = 1 - (HEAP32[i7 >> 2] | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i8 = i10 + 64 + (i1 * 12 | 0) + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i10 + 152 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i2;
 if (!i2) {
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  i10 = HEAP32[i7 >> 2] | 0;
  i10 = 1 - i10 | 0;
  HEAP32[i7 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 64 + (i1 * 12 | 0) | 0;
 i4 = i10 + 116 | 0;
 i5 = i10 + 112 | 0;
 i6 = i10 + 120 | 0;
 i1 = i2;
 do {
  i2 = i1 + -1 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i4 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i9) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 i10 = HEAP32[i7 >> 2] | 0;
 i10 = 1 - i10 | 0;
 HEAP32[i7 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE7destroyEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 2 | 0;
 i8 = i11 + 1 | 0;
 i10 = i11;
 i7 = i9 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i5 = i9 + 24 | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = 0;
  do {
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   if (!i2) i2 = 0; else {
    i1 = 0;
    do {
     i2 = i3 + (i1 * 52 | 0) | 0;
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     i1 = i1 + 1 | 0;
     i2 = HEAP32[i9 >> 2] | 0;
    } while (i1 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i1 = i9 + 24 | 0;
   i2 = 0;
   do {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
  }
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i9 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i9 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN15ReflectionProbe13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i2, i1);
 HEAP8[i2 + 160 >> 0] = 1;
 if (__Z14IsWorldPlayingv() | 0) {
  i1 = i2 + 40 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) if (!(HEAP32[i2 + 44 >> 2] | 0)) __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(HEAP32[gb + 1112272 >> 2] | 0, 3, i2, 63);
 } else {
  __ZN15ReflectionProbe19ClearRenderTexturesEv(i2);
  __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(HEAP32[gb + 1112272 >> 2] | 0, 3, i2, 63);
  i1 = i2 + 40 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != 1) {
  STACKTOP = i5;
  return;
 }
 i1 = i2 + 140 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 708 >> 2] | 0, i2 | 0) | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 233 + i2 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i3, gb + 381266 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 380852 | 0, 274, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN13BatchRenderer5FlushEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1114552 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114552 | 0, i11);
  i4 = gb + 1114552 | 0;
 } else i4 = 0;
 i10 = i5 + 152 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i5 + 140 >> 2] | 0;
  i6 = HEAP32[i5 + 184 >> 2] | 0;
  i1 = i5 + 168 | 0;
  i7 = HEAP32[i1 >> 2] | 0;
  i8 = HEAP32[i3 >> 2] | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == 1) {
   __Z17SetupObjectMatrixRK10Matrix4x4fi(i9 + (i8 * 360 | 0) | 0, HEAP32[i9 + (i8 * 360 | 0) + 176 >> 2] | 0);
   mftCall_viiii(HEAP32[i9 + (i8 * 360 | 0) + 332 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0);
  } else {
   HEAP32[i11 >> 2] = i3;
   HEAP32[i11 + 4 >> 2] = i2;
   if (!(HEAP8[i5 + 160 >> 0] | 0)) i1 = 0; else i1 = (HEAPU8[i5 + 188 >> 0] | 0) >>> 1 & 1 ^ 1;
   HEAP8[i11 + 8 >> 0] = i1;
   HEAP32[i11 + 12 >> 2] = 0;
   mftCall_viii(HEAP32[i9 + (i8 * 360 | 0) + 340 >> 2] | 0, i7 | 0, i11 | 0, i6 | 0);
  }
  HEAP32[i10 >> 2] = 0;
 }
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i12;
 return;
}

function __ZN11GPUProfiler10BeginFrameEv() {
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0;
 if ((HEAP16[gb + 1163340 + 6 >> 1] | 0) > -1) {
  i1 = HEAP32[gb + 1163228 >> 2] | 0;
  if (!i1) i2 = gb + 1163340 | 0; else if (!(HEAP8[i1 >> 0] | 0)) i2 = gb + 1163340 | 0; else {
   __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i1, gb + 1163340 | 0, 0) | 0;
   i2 = gb + 1163340 | 0;
  }
 } else i2 = 0;
 if (__ZNK13UnityProfiler19GetEnabledThisFrameEv(HEAP32[gb + 1451e3 >> 2] | 0) | 0) if (!(HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 28 >> 2] & 16)) i3 = 9; else if (!(HEAP8[(__Z17GetPlayerSettingsv() | 0) + 415 >> 0] | 0)) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0)) i3 = 9; else {
  i1 = __Z23IsWorldPlayingThisFramev() | 0;
  HEAP8[gb + 1546603 >> 0] = i1 & 1;
  if (i1) {
   i1 = __Z12GetGfxDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 668 >> 2] | 0, i1 | 0);
   __ZN11GPUProfiler13GPUTimeSampleEv();
  }
 } else i3 = 9; else i3 = 9;
 if ((i3 | 0) == 9) HEAP8[gb + 1546603 >> 0] = 0;
 if (!i2) return;
 if ((HEAP16[i2 + 6 >> 1] | 0) <= -1) return;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 d4 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i1, i2, ~~d4 >>> 0, +Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 return;
}

function _psh_blues_snap_stem(i9, i4, i8, i10) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 HEAP32[i10 >> 2] = 0;
 i11 = HEAP8[i9 + 2080 >> 0] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 L1 : do if (!i1) i7 = 2; else {
  i5 = HEAP32[i9 + 2076 >> 2] | 0;
  i6 = 0 - i5 | 0;
  i2 = i9 + 4 | 0;
  while (1) {
   i3 = i4 - (HEAP32[i2 + 12 >> 2] | 0) | 0;
   if ((i3 | 0) < (i6 | 0)) {
    i7 = 2;
    break L1;
   }
   if (((HEAP32[i2 + 8 >> 2] | 0) + i5 | 0) >= (i4 | 0)) break;
   i1 = i1 + -1 | 0;
   if (!i1) {
    i7 = 2;
    break L1;
   } else i2 = i2 + 32 | 0;
  }
  if (!(i11 << 24 >> 24)) if ((i3 | 0) > (HEAP32[i9 + 2072 >> 2] | 0)) {
   i7 = 2;
   break;
  }
  HEAP32[i10 >> 2] = 1;
  HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 16 >> 2];
  i7 = 3;
 } while (0);
 i1 = HEAP32[i9 + 516 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i9 + 2076 >> 2] | 0;
 i5 = 0 - i4 | 0;
 i2 = i1;
 i3 = i9 + 520 + (i1 << 5) | 0;
 while (1) {
  i6 = (HEAP32[i3 + -24 >> 2] | 0) - i8 | 0;
  if ((i6 | 0) < (i5 | 0)) {
   i1 = 17;
   break;
  }
  i2 = i2 + -1 | 0;
  if (((HEAP32[i3 + -20 >> 2] | 0) - i4 | 0) <= (i8 | 0)) {
   i1 = 14;
   break;
  }
  if (!i2) {
   i1 = 17;
   break;
  } else i3 = i3 + -32 | 0;
 }
 if ((i1 | 0) == 14) {
  if (!(i11 << 24 >> 24)) if ((i6 | 0) >= (HEAP32[i9 + 2072 >> 2] | 0)) return;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i10 + 8 >> 2] = HEAP32[i3 + -16 >> 2];
  return;
 } else if ((i1 | 0) == 17) return;
}

function __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i6 + 4 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 if (!i7) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i5;
 i2 = i7;
 L4 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L4;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 if ((i3 | 0) == (i5 | 0) ? 1 : i4 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i6 >> 2] | 0) == (i3 | 0)) HEAP32[i6 >> 2] = i1;
 i6 = i6 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i7, i3);
 __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i3 + 20 | 0, HEAP32[i3 + 24 >> 2] | 0);
 __ZdlPv(i3);
 i7 = 1;
 return i7 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpShapeEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 208 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -208 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpClothEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + (((HEAP32[i4 + 276 >> 2] | 0) + -1 | 0) * 152 | 0) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -152 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj139ENS_22PxRepXPropertyAccessorILj139ES4_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESC_EEEEvRKT0_(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE(i1, HEAP32[i7 + 28 >> 2] | 0, i6, gb + 90152 | 0);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i7 | 0, i4 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx27InternalTriangleMeshBuilder14createEdgeListEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i4 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP16[i4 + 12 >> 1] = 0;
 HEAPF32[i4 + 20 >> 2] = Math_fround(.100000001);
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
 if (!(HEAP8[i2 + 156 >> 0] & 2)) {
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i4 + 8 >> 2] = 0;
 } else {
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 12 >> 2];
 }
 HEAP8[i4 + 12 >> 0] = 1;
 HEAP8[i4 + 13 >> 0] = 1;
 HEAP32[i1 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i2 | 0, 24, (i1 ? gb + 731060 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 357) | 0;
 __ZN5physx2Gu15EdgeListBuilderC2Ev(i1);
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 if (__ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE(i1, i4) | 0) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx2Gu8EdgeListD2Ev(i1);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 24 | 0, i1);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i2;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN16MessageForwarderC2ERKS_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 i4 = i9 + 4 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i9 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 if (i2 | 0) {
  if (i2 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = __Znwj(i1) | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i8 >> 2] = i3;
  HEAP32[i8 + 8 >> 2] = i3 + (i2 << 2);
  i2 = HEAP32[i9 >> 2] | 0;
  i1 = (HEAP32[i4 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = i3 + (i1 >> 2 << 2);
  }
 }
 i2 = i8 + 12 | 0;
 i3 = i9 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i7 = i8 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i5 = i9 + 16 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 >> 2;
 if (i4 | 0) {
  if (i4 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
  i6 = __Znwj(i1) | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i8 + 20 >> 2] = i6 + (i4 << 2);
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i5 >> 2] | 0) - i2 | 0;
  if ((i1 | 0) > 0) {
   _memcpy(i6 | 0, i2 | 0, i1 | 0) | 0;
   HEAP32[i7 >> 2] = i6 + (i1 >> 2 << 2);
  }
 }
 i6 = i9 + 24 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i8 + 24 | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 return;
}

function __ZN15QualitySettings14QualitySettingC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 7;
 HEAP8[i1 >> 0] = HEAP8[gb + 405492 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[gb + 405492 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[gb + 405492 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[gb + 405492 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[gb + 405492 + 4 >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = HEAP8[gb + 405492 + 5 >> 0] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[gb + 405492 + 6 >> 0] | 0;
 HEAP8[i1 + 7 >> 0] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 1;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAPF32[i1 + 36 >> 2] = Math_fround(15.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(.333333343);
 HEAPF32[i1 + 48 >> 2] = Math_fround(.0666666701);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.466666669);
 HEAP32[i1 + 60 >> 2] = 1;
 HEAP32[i1 + 64 >> 2] = 1;
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 4;
 HEAPF32[i1 + 96 >> 2] = Math_fround(512.0);
 HEAP32[i1 + 100 >> 2] = 2;
 HEAP32[i1 + 104 >> 2] = 4;
 return;
}

function __ZN14AnimationState15SetWeightTargetEffb(i6, f7, f1, i8) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f1 = Math_fround(f1);
 i8 = i8 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0;
 f3 = Math_fround(f7 - Math_fround(HEAPF32[i6 + 8 >> 2]));
 f10 = Math_fround(f3 / f1);
 f3 = Math_fround(f3 * Math_fround(1.0e5));
 f1 = +f1 > .001 ? f10 : f3;
 i4 = i6 + 56 | 0;
 i5 = HEAP16[i4 >> 1] | 0;
 if (!(i5 & 1)) i9 = 4; else {
  f10 = Math_fround(Math_fround(HEAPF32[i6 + 52 >> 2]) - f7);
  i2 = f10 < Math_fround(0.0);
  f3 = Math_fround(-f10);
  if (!((i2 ? f3 : f10) <= Math_fround(.0000999999974))) i9 = 4; else {
   i2 = i6 + 76 | 0;
   f3 = Math_fround(HEAPF32[i2 >> 2]);
   i13 = f3 < Math_fround(0.0);
   f12 = Math_fround(-f3);
   i11 = f1 < Math_fround(0.0);
   f10 = Math_fround(-f1);
   if ((i13 ? f12 : f3) > (i11 ? f10 : f1)) f1 = f3; else i9 = 4;
  }
 }
 if ((i9 | 0) == 4) {
  i2 = i6 + 76 | 0;
  HEAPF32[i2 >> 2] = f1;
 }
 i13 = f1 < Math_fround(0.0);
 f12 = Math_fround(-f1);
 if (!((i13 ? f12 : f1) <= Math_fround(.0000999999974))) {
  i11 = i6 + 52 | 0;
  HEAPF32[i11 >> 2] = f7;
  i11 = i8 & 1;
  i11 = i11 << 2 & 65535;
  i13 = i5 & -38;
  i13 = i11 | i13;
  i13 = i13 | 1;
  HEAP16[i4 >> 1] = i13;
  return;
 }
 HEAPF32[i2 >> 2] = Math_fround(1.0e5);
 i11 = i6 + 52 | 0;
 HEAPF32[i11 >> 2] = f7;
 i11 = i8 & 1;
 i11 = i11 << 2 & 65535;
 i13 = i5 & -38;
 i13 = i11 | i13;
 i13 = i13 | 1;
 HEAP16[i4 >> 1] = i13;
 return;
}

function __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_(i12, i7, i8, i9, i10) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13 + 2 | 0;
 i3 = i13 + 1 | 0;
 i4 = i13;
 i6 = i12 + 264 | 0;
 i1 = __ZN5physx11PxMeshQuery23findOverlapTriangleMeshERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_PjjjRb(i7, i8, i9, i10, HEAP32[i12 >> 2] | 0, HEAP32[i6 >> 2] | 0, 0, i11) | 0;
 if (HEAP8[i11 >> 0] | 0) {
  i1 = HEAP32[i9 + 36 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
  if (!i1) {
   HEAP32[i12 + 260 >> 2] = 0;
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  i5 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
  if (i5 >>> 0 < i1 >>> 0) {
   if ((i2 | 0) != (i12 + 4 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
   i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i1 << 2, gb + 656312 | 0, 53) | 0;
   HEAP32[i12 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
  } else i1 = i5;
  i1 = __ZN5physx11PxMeshQuery23findOverlapTriangleMeshERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_PjjjRb(i7, i8, i9, i10, i2, i1, 0, i11) | 0;
 }
 HEAP32[i12 + 260 >> 2] = i1;
 i12 = i1;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN21ExecutionOrderManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = HEAP32[gb + 1106156 >> 2] | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i6;
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i6 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 << 3, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 3, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i1 >> 2] = i5;
  break;
 } while (0);
 if (i6 >>> 0 <= i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i3 = (HEAP32[i1 >> 2] | 0) + (i7 << 3) | 0;
 i2 = i6 - i7 | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 } else i1 = 0;
 do {
  i7 = i3 + (i1 << 3) | 0;
  HEAP32[i7 >> 2] = 14;
  HEAP32[i7 + 4 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i2 - i1 >> 3;
 if (i3 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj(i4, i3 - i5 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else if (i3 >>> 0 < i5 >>> 0) {
  i3 = i1 + (i3 << 3) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -8 - i3 | 0) >>> 3) << 3) | 0;
   HEAP32[i6 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairINS3_IttEEfEEEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z34Texture2D_CUSTOM_Internal_ResizeWHP12Il2CppObjectii(i2, i5, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 if (!i2) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = HEAP8[i1 + 111 >> 0] | 0;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!(i1 << 24 >> 24)) {
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i4);
 }
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i3 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  i4 = i3 + 104 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i4 = i4 & 1;
  i6 = __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i3, i5, i6, i2, i4) | 0;
  i6 = i6 & 1;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  i4 = i3 + 104 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i4 = i4 & 1;
  i6 = __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i3, i5, i6, i2, i4) | 0;
  i6 = i6 & 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z19JoystickButtonToKeyii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = i7 + 24 | 0;
 i6 = i7 + 12 | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = i2;
  _snprintf(i3, 100, gb + 441329 | 0, i5) | 0;
 } else {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  _snprintf(i3, 100, gb + 441307 | 0, i4) | 0;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, _strlen(i3) | 0);
 i5 = HEAP8[i6 + 11 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  i5 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return i5 | 0;
 }
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i6) | 0;
 if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
  i5 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return i5 | 0;
}

function __Z16DecodeEscapedURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i11 = i8 + 11 | 0;
 i2 = HEAP8[i11 >> 0] | 0;
 i12 = i8 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i7, i2 << 24 >> 24 < 0 ? HEAP32[i12 >> 2] | 0 : i2 & 255);
 i2 = HEAP8[i11 >> 0] | 0;
 i3 = HEAP32[i12 >> 2] | 0;
 if (!((i2 << 24 >> 24 < 0 ? i3 : i2 & 255) | 0)) {
  STACKTOP = i13;
  return;
 }
 i9 = i10 + 1 | 0;
 i1 = 0;
 do {
  i5 = i2 << 24 >> 24 < 0;
  i6 = i5 ? HEAP32[i8 >> 2] | 0 : i8;
  i4 = HEAP8[i6 + i1 >> 0] | 0;
  if (i4 << 24 >> 24 == 37) {
   i4 = i1 + 2 | 0;
   if (i4 >>> 0 < (i5 ? i3 : i2 & 255) >>> 0) {
    HEAP8[i10 >> 0] = HEAP8[i6 + (i1 + 1) >> 0] | 0;
    HEAP8[i9 >> 0] = HEAP8[i6 + i4 >> 0] | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, (_strtol(i10, 0, 16) | 0) & 255);
    i1 = i4;
   }
  } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i7, i4);
  i1 = i1 + 1 | 0;
  i2 = HEAP8[i11 >> 0] | 0;
  i3 = HEAP32[i12 >> 2] | 0;
 } while (i1 >>> 0 < (i2 << 24 >> 24 < 0 ? i3 : i2 & 255) >>> 0);
 STACKTOP = i13;
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE(i1, i8, i3, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 236 >> 2] | 0, i8 | 0) | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 240 >> 2] | 0, i8 | 0) | 0;
 if (((i5 - i4 | 0) / 12 | 0 | 0) == (i3 | 0)) {
  i2 = HEAP32[i8 + 476 >> 2] | 0;
  i5 = i2 + (i3 << 4) | 0;
  if (i3 | 0) {
   i3 = i4;
   while (1) {
    i9 = HEAP32[i2 + 4 >> 2] | 0;
    i4 = HEAP32[i2 + 8 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i3 + 4 >> 2] = i9;
    HEAP32[i3 + 8 >> 2] = i4;
    i2 = i2 + 16 | 0;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 12 | 0;
   }
  }
 }
 if ((i6 - i1 >> 4 | 0) != (i7 | 0)) return;
 i2 = HEAP32[i8 + 464 >> 2] | 0;
 i9 = HEAP32[i8 + 468 >> 2] | 0;
 i5 = i2 + (i9 << 3) | 0;
 i4 = HEAP32[i8 + 24 >> 2] | 0;
 if (!i9) return;
 i3 = i2;
 do {
  i2 = HEAPU16[i3 >> 1] | 0;
  if (i2 >>> 0 < i4 >>> 0) {
   i7 = HEAPU16[i3 + 2 >> 1] | 0;
   i8 = HEAPU16[i3 + 4 >> 1] | 0;
   i9 = HEAPU16[i3 + 6 >> 1] | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i7;
   HEAP32[i1 + 8 >> 2] = i8;
   HEAP32[i1 + 12 >> 2] = i9;
   i1 = i1 + 16 | 0;
  }
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return;
}

function __ZNSt3__24stofERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084476 | 0, 4);
 HEAP32[i3 >> 2] = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i9 = ___errno_location() | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 f2 = Math_fround(_strtof(i4, i3));
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i7 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (!(i10 & 1)) i5 = 3;
 } else i5 = 3;
 do if ((i5 | 0) == 3) {
  i10 = HEAP32[i3 >> 2] | 0;
  i1 = i10;
  if ((i10 | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = i1 - i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return Math_fround(f2);
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i10 | 0);
 return f0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPcEEE4typeENSB_IS8_EESA_SA_(i1, i4, i3, i9) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i1 + 11 | 0;
 i2 = HEAP8[i10 >> 0] | 0;
 i6 = i2 << 24 >> 24 < 0;
 if (i6) {
  i5 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0;
  i8 = HEAP32[i1 + 4 >> 2] | 0;
  i11 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 } else {
  i5 = 10;
  i8 = i2 & 255;
  i11 = (HEAP32[i4 >> 2] | 0) - i1 | 0;
 }
 i7 = i9 - i3 | 0;
 if (i7) {
  if ((i5 - i8 | 0) >>> 0 < i7 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i5, i8 + i7 - i5 | 0, i8, i11, 0, i7);
   i4 = HEAP32[i1 >> 2] | 0;
  } else {
   if (i6) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
   i2 = i8 - i11 | 0;
   if (i2) {
    i6 = i4 + i11 | 0;
    _memmove(i6 + i7 | 0, i6 | 0, i2 | 0) | 0;
   }
  }
  i2 = i8 + i7 | 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) HEAP32[i1 + 4 >> 2] = i2; else HEAP8[i10 >> 0] = i2;
  HEAP8[i4 + i2 >> 0] = 0;
  i2 = i4 + i11 | 0;
  while (1) {
   if ((i3 | 0) == (i9 | 0)) break;
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
  }
  i2 = HEAP8[i10 >> 0] | 0;
 }
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i11 | 0;
}

function __ZN7mecanim12statemachine27CreateStateMachineWorkspaceEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE(i2, i11, i12) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i13 = mftCall_iiii(HEAP32[HEAP32[i12 >> 2] >> 2] | 0, i12 | 0, 16, 4) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i13 + 4 >> 2] = 0;
 HEAP32[i13 + 8 >> 2] = 0;
 HEAP32[i13 + 12 >> 2] = i11;
 i10 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i10) i2 = 0; else {
  i2 = i2 + 4 | 0;
  if (!i1) {
   i2 = 0;
   i1 = 0;
  } else {
   i6 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
   i2 = 0;
   i5 = 0;
   do {
    i7 = i6 + (i5 << 2) | 0;
    i8 = HEAP32[i7 >> 2] | 0;
    i8 = (i8 | 0) == 0 ? 0 : i7 + i8 | 0;
    i7 = i8 + 12 | 0;
    i7 = i7 + (HEAP32[i7 >> 2] | 0) | 0;
    i8 = i8 + 20 | 0;
    i9 = i8;
    i4 = 0;
    do {
     i3 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
     if ((i3 | 0) != -1) {
      i3 = (HEAP32[i8 >> 2] | 0) + i9 + (i3 << 2) | 0;
      i14 = HEAP32[i3 >> 2] | 0;
      i3 = i3 + i14 | 0;
      if (!((i14 | 0) == 0 | (i3 | 0) == 0)) {
       i14 = HEAP32[i3 >> 2] | 0;
       i2 = i2 >>> 0 < i14 >>> 0 ? i14 : i2;
      }
     }
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 < i1 >>> 0);
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i10 >>> 0);
  }
 }
 HEAP32[i13 >> 2] = __ZN7mecanim12statemachine20CreateStateWorkspaceEjjjRNS_6memory9AllocatorE(i1, i2, i11, i12) | 0;
 return i13 | 0;
}

function __ZN7ApiGLES13CreateSamplerE17TextureFilterMode15TextureWrapModei(i2, i4, i1, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i2 + 860 | 0;
 i3 = __ZNK13TranslateGLES4WrapE15TextureWrapMode(HEAP32[i7 >> 2] | 0, i1) | 0;
 HEAP32[i6 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 824 >> 2] | 0, 1, i6 | 0);
 i1 = i2 + 836 | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, 10242, i3 | 0);
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, 10243, i3 | 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0) mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, 32882, i3 | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 mftCall_viii(i3 | 0, i2 | 0, 10240, __ZNK13TranslateGLES9FilterMagE17TextureFilterMode(HEAP32[i7 >> 2] | 0, i4) | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 mftCall_viii(i2 | 0, i3 | 0, 10241, __ZNK13TranslateGLES9FilterMinE17TextureFilterModeb(HEAP32[i7 >> 2] | 0, i4, 0) | 0);
 if (!((i5 | 0) > 0 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 152 >> 0] | 0) != 0)) {
  i7 = HEAP32[i6 >> 2] | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 112 >> 2] | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0, 34046, ((i7 | 0) < (i5 | 0) ? i7 : i5) | 0);
 i7 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx2Gu23computePlane_CapsuleMTDERKNS_7PxPlaneERKNS0_7CapsuleERNS_10PxSweepHitE(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f13 = f0;
 f2 = Math_fround(HEAPF32[i11 >> 2]);
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f8);
 f6 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f6 * f10));
 f3 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f2 + Math_fround(f3 * f9));
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f2 = Math_fround(f13 + f2);
 i1 = i11 + 12 | 0;
 f7 = Math_fround(f8 * Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i11 + 16 >> 2]);
 f7 = Math_fround(f7 + Math_fround(f10 * f4));
 f5 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f7 = Math_fround(f13 + Math_fround(f7 + Math_fround(f9 * f5)));
 if (f2 < f7) {
  i1 = i11;
  f4 = f6;
 } else {
  f3 = f5;
  f2 = f7;
 }
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i12 + 28 >> 2] = f8;
 HEAPF32[i12 + 32 >> 2] = f10;
 HEAPF32[i12 + 36 >> 2] = f9;
 HEAPF32[i12 + 40 >> 2] = Math_fround(f2 - Math_fround(HEAPF32[i11 + 24 >> 2]));
 f10 = Math_fround(f4 - Math_fround(f2 * f10));
 f13 = Math_fround(f3 - Math_fround(f2 * f9));
 HEAPF32[i12 + 16 >> 2] = Math_fround(f7 - Math_fround(f2 * f8));
 HEAPF32[i12 + 20 >> 2] = f10;
 HEAPF32[i12 + 24 >> 2] = f13;
 return 1;
}

function __ZN5physx17PxcNpMemBlockPool15releaseContactsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i7 = i10 + 136 | 0;
 i1 = 1 - (HEAP32[i7 >> 2] | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i8 = i10 + 16 + (i1 * 12 | 0) + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = i10 + 152 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i2;
 if (!i2) {
  i10 = HEAP32[i10 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  i10 = HEAP32[i7 >> 2] | 0;
  i10 = 1 - i10 | 0;
  HEAP32[i7 >> 2] = i10;
  STACKTOP = i11;
  return;
 }
 i3 = i10 + 16 + (i1 * 12 | 0) | 0;
 i4 = i10 + 116 | 0;
 i5 = i10 + 112 | 0;
 i6 = i10 + 120 | 0;
 i1 = i2;
 do {
  i2 = i1 + -1 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i9 >> 2] = i1;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i4 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5, i9) | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i10 = HEAP32[i10 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 i10 = HEAP32[i7 >> 2] | 0;
 i10 = 1 - i10 | 0;
 HEAP32[i7 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZN10Collider2D19RecalculateContactsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1458016 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458016 | 0, i1);
  i6 = gb + 1458016 | 0;
 } else i6 = 0;
 i5 = i3 + 72 | 0;
 do if (HEAP32[i5 >> 2] | 0) {
  i4 = i3 + 60 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do {
   __ZN9b2Fixture8RefilterEv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i3 + (i2 << 2) | 0));
  if (i2 | 0) {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0;
   if (i1 | 0) {
    i2 = i1 + 4 | 0;
    i3 = HEAPU16[i2 >> 1] | 0;
    if (!(HEAP32[i1 >> 2] | 0)) {
     HEAP16[i2 >> 1] = i3 & 65533;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
     i5 = i1 + 64 | 0;
     HEAP32[i5 >> 2] = 0;
     HEAP32[i5 + 4 >> 2] = 0;
     HEAP32[i5 + 8 >> 2] = 0;
     HEAP32[i5 + 12 >> 2] = 0;
     HEAP32[i5 + 16 >> 2] = 0;
     HEAP32[i5 + 20 >> 2] = 0;
     break;
    }
    if (!(i3 & 2)) {
     HEAP16[i2 >> 1] = i3 | 2;
     HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
    }
   }
  }
 } while (0);
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i7;
 return;
}

function __Z24GetShaderChannelFromNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i1);
 i6 = i8 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i7 = i8 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!((i1 ? i3 : i2 & 255) | 0)) i1 = 0; else {
  i1 = i1 ? HEAP32[i8 >> 2] | 0 : i8;
  do {
   i5 = HEAP8[i1 >> 0] | 0;
   i2 = i5 << 24 >> 24;
   HEAP8[i1 >> 0] = (i5 + -97 & 255) < 26 ? i2 + 224 | 0 : i2;
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i6 >> 0] | 0;
   i5 = i2 << 24 >> 24 < 0;
   i3 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) != ((i5 ? HEAP32[i8 >> 2] | 0 : i8) + (i5 ? i3 : i2 & 255) | 0));
  i1 = 0;
 }
 while (1) {
  i4 = HEAP32[gb + 40988 + (i1 << 2) >> 2] | 0;
  i5 = _strlen(i4) | 0;
  if ((i5 | 0) == ((i2 << 24 >> 24 < 0 ? i3 : i2 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i8, 0, -1, i4, i5) | 0)) {
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 8) {
   i1 = -1;
   i2 = 8;
   break;
  }
  i2 = HEAP8[i6 >> 0] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i2 | 0) == 8) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_png_set_cHRM_XYZ(i19, i20, d1, d4, d6, d8, d10, d12, d14, d16, d17) {
 i19 = i19 | 0;
 i20 = i20 | 0;
 d1 = +d1;
 d4 = +d4;
 d6 = +d6;
 d8 = +d8;
 d10 = +d10;
 d12 = +d12;
 d14 = +d14;
 d16 = +d16;
 d17 = +d17;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i9 = 0, i11 = 0, i13 = 0, i15 = 0, i18 = 0, i21 = 0, i22 = 0;
 i22 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i21 = i22;
 i18 = _UNITY_png_fixed(i19, d1, gb + 354131 | 0) | 0;
 i15 = _UNITY_png_fixed(i19, d4, gb + 354142 | 0) | 0;
 i13 = _UNITY_png_fixed(i19, d6, gb + 354203 | 0) | 0;
 i11 = _UNITY_png_fixed(i19, d8, gb + 354131 | 0) | 0;
 i9 = _UNITY_png_fixed(i19, d10, gb + 354142 | 0) | 0;
 i7 = _UNITY_png_fixed(i19, d12, gb + 354203 | 0) | 0;
 i5 = _UNITY_png_fixed(i19, d14, gb + 354131 | 0) | 0;
 i3 = _UNITY_png_fixed(i19, d16, gb + 354142 | 0) | 0;
 i2 = _UNITY_png_fixed(i19, d17, gb + 354203 | 0) | 0;
 if ((i19 | 0) == 0 | (i20 | 0) == 0) {
  STACKTOP = i22;
  return;
 }
 HEAP32[i21 >> 2] = i18;
 HEAP32[i21 + 4 >> 2] = i15;
 HEAP32[i21 + 8 >> 2] = i13;
 HEAP32[i21 + 12 >> 2] = i11;
 HEAP32[i21 + 16 >> 2] = i9;
 HEAP32[i21 + 20 >> 2] = i7;
 HEAP32[i21 + 24 >> 2] = i5;
 HEAP32[i21 + 28 >> 2] = i3;
 HEAP32[i21 + 32 >> 2] = i2;
 if (_UNITY_png_colorspace_set_endpoints(i19, i20 + 40 | 0, i21, 2) | 0) {
  i21 = i20 + 114 | 0;
  HEAP16[i21 >> 1] = HEAPU16[i21 >> 1] | 0 | 16;
 }
 _UNITY_png_colorspace_sync_info(i19, i20);
 STACKTOP = i22;
 return;
}

function __ZN9dtNavMesh19getPolyFlagsAndAreaEyPjPh(i1, i3, i4, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = (i7 | 0) != 0;
 if (i9) HEAP32[i7 >> 2] = 0;
 i10 = (i8 | 0) != 0;
 if (i10) HEAP8[i8 >> 0] = 0;
 if ((i3 & 983040 | 0) == 65536 & 0 == 0) {
  i2 = i3 & 65535;
  if (i2 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) return;
  i6 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i1 + (i2 * 104 | 0) | 0) == 0 ? 1 : (i6 | 0) != (HEAP32[i1 + (i2 * 104 | 0) + 92 >> 2] | 0)) return;
  if (i9) HEAP32[i7 >> 2] = HEAP32[i1 + (i2 * 104 | 0) + 76 >> 2];
  if (!i10) return;
  HEAP8[i8 >> 0] = HEAP8[i1 + (i2 * 104 | 0) + 80 >> 0] | 0;
  return;
 }
 if ((i3 | 0) == 0 & (i4 | 0) == 0) return;
 i5 = _bitshift64Lshr(i3 | 0, i4 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i3 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) return;
 i4 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) return;
 i2 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) return;
 if (i6 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) return;
 i1 = HEAP32[i1 + (i5 * 56 | 0) + 16 >> 2] | 0;
 if (i9) HEAP32[i7 >> 2] = HEAP32[i1 + (i6 << 5) + 24 >> 2];
 if (!i10) return;
 HEAP8[i8 >> 0] = HEAP8[i1 + (i6 << 5) + 29 >> 0] | 0;
 return;
}

function __ZN5physx2Sc17ParticleSystemSimD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 91148 + 8;
 HEAP32[i5 + 372 >> 2] = gb + 87404 + 8;
 HEAP32[i5 + 380 >> 2] = 0;
 i4 = HEAP32[i5 + 364 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 356 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 if (HEAP32[i5 + 340 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5 + 60 | 0);
 i3 = i5 + 324 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 328 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 332 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) {
  __ZN5physx2Sc8ActorSimD2Ev(i5);
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 64 | 0) == (i1 | 0)) {
  HEAP8[i5 + 320 >> 0] = 0;
  __ZN5physx2Sc8ActorSimD2Ev(i5);
  return;
 }
 if (!i1) {
  __ZN5physx2Sc8ActorSimD2Ev(i5);
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 __ZN5physx2Sc8ActorSimD2Ev(i5);
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj5ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj4ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj3ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 71660 + 8;
 i4 = i1;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = i2;
 i2 = i6 + 20 | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 36 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i6 + 40 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 & 2147483584) >>> 0 >= 64) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = 64;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 256, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i7;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(256, 4, i5, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = 64;
  HEAP32[i2 >> 2] = i9;
  STACKTOP = i7;
  return;
 }
}

function __ZN13dynamic_arrayItLj2EEC2ERKS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 1;
 i2 = i1 >> 1;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 1;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 2, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 1;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 1 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 1;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayIiLj4EEC2ERKS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN13dynamic_arrayIfLj4EEC2ERKS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i1 + 4 | 0);
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i8;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i4 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i2 = i1 >> 2;
 HEAP32[i6 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i2 >>> 0) {
  i7 = 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
 if ((i3 | 0) > -1) {
  HEAP32[i7 >> 2] = i2;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 4, i8, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 } else {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i8 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = i8;
  i7 = i8;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 << 2;
  _memcpy(i7 | 0, i5 | 0, i8 | 0) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z31CreateMissingGlobalGameManagersv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i5 = i9;
 i4 = 0;
 do {
  i6 = gb + 1104348 + (i4 << 2) | 0;
  if (!(HEAP32[i6 >> 2] | 0)) {
   i7 = HEAP32[gb + 1104348 + 112 + (i4 << 2) >> 2] | 0;
   i1 = gb + 63520 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i7) i1 = 0; else {
    i2 = HEAP32[i7 + 4 >> 2] | 0;
    if (!i2) i1 = 0; else {
     i10 = i5;
     HEAP32[i10 >> 2] = i3;
     HEAP32[i10 + 4 >> 2] = i1;
     HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
     HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
     i1 = mftCall_iii(i2 | 0, i8 | 0, 0) | 0;
     i2 = (HEAP32[gb + 29188 >> 2] | 0) + -2 | 0;
     HEAP32[gb + 29188 >> 2] = i2;
     HEAP32[i1 + 4 >> 2] = i2;
     i2 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) + 24 >> 2] | 0;
     i3 = i1 + 8 | 0;
     HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & 2097151 | i2 << 21;
     __ZN6Object17InsertObjectInMapEPS_(i1);
    }
   }
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, HEAP32[i7 + 8 >> 2] | 0);
   HEAP32[i6 >> 2] = i1;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 24);
 STACKTOP = i9;
 return;
}

function __Z13ConvertPixelsPKh13TextureFormatPhS1_j(i4, i5, i1, i3, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 20 | 0;
 i8 = i10;
 if ((i5 | 0) == (i3 | 0)) {
  if ((i4 | 0) == (i1 | 0)) {
   STACKTOP = i10;
   return;
  }
  _memcpy(i1 | 0, i4 | 0, Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i5) | 0, i6) | 0) | 0;
  STACKTOP = i10;
  return;
 }
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i7 + 8 >> 2] = 1;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = 0;
 if (!i1) i9 = 9; else {
  if ((i3 | 0) < 9) i2 = 1; else i2 = (i3 | 0) == 1e3 | ((i3 | 0) == 23 | (i3 + -13 | 0) >>> 0 < 9);
  if ((i3 | 0) > 0 & (i6 | 0) > 0 & i2) {
   HEAP32[i7 + 16 >> 2] = i1;
   i2 = i1;
  } else i9 = 9;
 }
 if ((i9 | 0) == 9) {
  HEAP32[i7 + 16 >> 2] = 0;
  i2 = 0;
 }
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i8 + 8 >> 2] = 1;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = 0;
 if (!i4) i9 = 15; else {
  if ((i5 | 0) < 9) i1 = 1; else i1 = (i5 | 0) == 1e3 | ((i5 | 0) == 23 | (i5 + -13 | 0) >>> 0 < 9);
  if ((i5 | 0) > 0 & (i6 | 0) > 0 & i1) {
   HEAP32[i8 + 16 >> 2] = i4;
   i1 = (i4 | 0) == 0;
  } else i9 = 15;
 }
 if ((i9 | 0) == 15) {
  HEAP32[i8 + 16 >> 2] = 0;
  i1 = 1;
 }
 if (!((i2 | 0) == 0 | i1)) __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i8, i7, 0);
 STACKTOP = i10;
 return;
}

function _UNITY_png_write_end(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 if (!i5) return;
 i7 = i5 + 204 | 0;
 if (!(HEAP32[i7 >> 2] & 4)) _UNITY_png_error(i5, gb + 355868 | 0);
 if ((HEAP32[i5 + 420 >> 2] | 0) > (HEAPU16[i5 + 416 >> 1] | 0 | 0)) _UNITY_png_benign_error(i5, gb + 355895 | 0);
 if (i1 | 0) {
  i6 = i1 + 128 | 0;
  if ((HEAP32[i6 >> 2] | 0) > 0) {
   i4 = i1 + 136 | 0;
   i3 = 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do {
    i2 = HEAP32[i1 + (i3 * 28 | 0) >> 2] | 0;
    do if ((i2 | 0) > 0) {
     _UNITY_png_write_iTXt(i5, i2, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 20 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 24 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0);
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 * 28 | 0) >> 2] = -3;
    } else {
     if ((i2 | 0) > -1) {
      _UNITY_png_write_zTXt(i5, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0, 0, i2);
      i1 = HEAP32[i4 >> 2] | 0;
      HEAP32[i1 + (i3 * 28 | 0) >> 2] = -2;
      break;
     }
     if ((i2 | 0) == -1) {
      _UNITY_png_write_tEXt(i5, HEAP32[i1 + (i3 * 28 | 0) + 4 >> 2] | 0, HEAP32[i1 + (i3 * 28 | 0) + 8 >> 2] | 0, 0);
      i1 = HEAP32[i4 >> 2] | 0;
      HEAP32[i1 + (i3 * 28 | 0) >> 2] = -3;
     }
    } while (0);
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (HEAP32[i6 >> 2] | 0));
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
 _UNITY_png_write_IEND(i5);
 return;
}

function __ZNK9SubModule19GetSubEmittersCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i5 = i1 + 20 | 0;
 do if ((HEAP32[i5 >> 2] | 0) == 1) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 8; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else if (HEAP32[i1 + 4 >> 2] | 0) break;
  }
  if (!(__Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0)) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
 } while (0);
 i8 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = HEAP32[i4 + 288 >> 2] | 0;
 if (!i1) i7 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i7 = _PxGetFoundation() | 0;
  i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
  i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 773384 | 0, 183) | 0;
 }
 HEAP32[i3 >> 2] = i7;
 i1 = i4 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 272 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + (i2 << 2) >> 2] = i7;
  HEAP32[i1 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEE15growAndPushBackERKS2_(i4 + 4 | 0, i3) | 0;
 i2 = i7 + ((HEAP32[i4 + 276 >> 2] | 0) + -1 << 6) | 0;
 if (i2 >>> 0 < i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i4 + 292 | 0;
 i5 = i4 + 284 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = i4;
  i1 = i1 + 1 | 0;
  i3 = i2 + -64 | 0;
  if (i3 >>> 0 < i7 >>> 0) break; else {
   i4 = i2;
   i2 = i3;
  }
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL10onActivateEj(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i6 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 32 | 0;
 if (!((i1 & 4194304 | 0) == 0 | ((i2 & 2 | 0) != 0 | (i1 & 476 | 0) == 0))) {
  __ZN5physx2Sc10NPhaseCore32addToPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i4 >> 2] | 0) | 0) + 1104 >> 2] | 0, i6);
  i1 = HEAP32[i5 >> 2] & -4194305;
  HEAP32[i5 >> 2] = i1;
 }
 if (!(HEAP8[(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) if (!(HEAP8[(HEAP32[(HEAP32[i6 + 36 >> 2] | 0) + 8 >> 2] | 0) + 51 >> 0] & 1)) {
  HEAP32[i5 >> 2] = i1 | 134217728;
  i6 = 0;
  return i6 | 0;
 }
 i2 = i1 & -134217729;
 HEAP32[i5 >> 2] = i2;
 i3 = i6 + 56 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv(i6);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  } else {
   i2 = HEAP32[i5 >> 2] | 0;
   break;
  }
 } while (0);
 if (!(i2 & 32768)) {
  __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i4 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, i6 + 60 | 0);
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZN5physx17PxsContactManager6setCCDEb(i1, (i2 & 2048 | 0) != 0);
 i6 = 1;
 return i6 | 0;
}

function __ZN5physx2Gu9Container6ResizeEj(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, f2 = f0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, f9 = f0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i6 | 0) == -1) {
  i8 = 0;
  STACKTOP = i10;
  return i8 | 0;
 }
 f9 = Math_fround(Math_abs(Math_fround(f2)));
 i6 = f2 > Math_fround(0.0);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) i3 = 2; else i3 = ~~Math_fround(f9 * Math_fround(i1 >>> 0)) >>> 0;
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + i5 | 0;
 i3 = i3 >>> 0 < i5 >>> 0 ? i5 : i3;
 HEAP32[i7 >> 2] = i3;
 i3 = i3 >>> 0 > 1073741823 ? -1 : i3 << 2;
 if (!i3) i3 = 0; else {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i11 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i3 = mftCall_iiiiii(i11 | 0, i5 | 0, i3 | 0, (i1 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 656004 | 0, 72) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 | 0) _memcpy(i3 | 0, HEAP32[i7 + 8 >> 2] | 0, i1 << 2 | 0) | 0;
 i1 = i7 + 8 | 0;
 if (i6) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i3;
 HEAPF32[i8 >> 2] = f9;
 i11 = 1;
 STACKTOP = i10;
 return i11 | 0;
}

function __ZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPv(i12, i11, i13) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i13 = i13 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14;
 i9 = i14 + 20 | 0;
 if (!(HEAP32[i12 + 4 >> 2] | 0)) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i14 + 21 | 0, i1, gb + 727718 | 0, 410) | 0;
 _memset(i6 | 0, 0, HEAP32[i12 >> 2] | 0) | 0;
 i7 = i10 + 12 | 0;
 i3 = i10 + 4 | 0;
 i4 = i10 + 16 | 0;
 i5 = i10 + 8 | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i8 = 0;
 while (1) {
  L9 : do if (!i2) i1 = 0; else {
   i1 = 0;
   do {
    if (!(HEAP8[i6 + i1 >> 0] | 0)) break L9;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  } while (0);
  if ((i1 | 0) != (i2 | 0)) {
   HEAP32[i10 >> 2] = i12;
   HEAP32[i7 >> 2] = i6;
   HEAP32[i3 >> 2] = i8;
   HEAP32[i4 >> 2] = i11;
   HEAP32[i5 >> 2] = i13;
   __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj(i10, i1, -1, -1, -1);
   i2 = HEAP32[i12 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 | 0)) break; else i8 = i8 + 1 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i6);
 i13 = 1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN5Umbra15CameraTransformC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 _memset(i1 + 64 | 0, 0, 276) | 0;
 HEAPF32[i1 + 340 >> 2] = Math_fround(1.0);
 i2 = i1 + 344 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 360 >> 2] = Math_fround(1.0);
 i2 = i1 + 364 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 380 >> 2] = Math_fround(1.0);
 i2 = i1 + 384 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 400 >> 2] = Math_fround(1.0);
 i1 = i1 + 404 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 0;
 return;
}

function __ZN29AssetBundleLoadAssetOperation27PrepareMainAssetPreloadListER11AssetBundleR13dynamic_arrayIiLj4EE(i2, i13) {
 i2 = i2 | 0;
 i13 = i13 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 i14 = HEAP32[i2 + 40 >> 2] | 0;
 if (!(i1 | i14)) {
  i14 = 0;
  return i14 | 0;
 }
 i4 = (HEAP32[i2 + 48 >> 2] | 0) + (HEAP32[i2 + 36 >> 2] << 2) | 0;
 if ((i14 | 0) <= 0) {
  i14 = i1;
  return i14 | 0;
 }
 i5 = i13 + 12 | 0;
 i6 = i13 + 16 | 0;
 i7 = i13 + 4 | 0;
 i2 = 0;
 do {
  i8 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i10 = i9 + 1 | 0;
  i11 = HEAP32[i6 >> 2] | 0;
  i12 = i11 & 2147483647;
  do if (i10 >>> 0 > i12 >>> 0) {
   i3 = i11 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i12 >>> 0 < i3 >>> 0) if ((i11 | 0) > -1) {
    HEAP32[i6 >> 2] = i3;
    HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i3 << 2, 4, i7, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i7, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i12 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i13 >> 2] = i12;
    break;
   }
  } while (0);
  HEAP32[i5 >> 2] = i10;
  HEAP32[(HEAP32[i13 >> 2] | 0) + (i9 << 2) >> 2] = i8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i14 | 0));
 return i1 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh7SetTextERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i11, i5) {
 i11 = i11 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i1 = i11 + 32 | 0;
 i10 = i1 + 11 | 0;
 i8 = HEAP8[i10 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 if (i9) i2 = HEAP32[i11 + 36 >> 2] | 0; else i2 = i8 & 255;
 i12 = HEAP8[i5 + 11 >> 0] | 0;
 i6 = i12 << 24 >> 24 < 0;
 i12 = i6 ? HEAP32[i5 + 4 >> 2] | 0 : i12 & 255;
 i7 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i12 | 0)) {
  if (i9) {
   i2 = HEAP32[i1 >> 2] | 0;
   i3 = i6 ? i7 : i5;
   i4 = HEAP32[i11 + 36 >> 2] | 0;
  } else {
   i2 = i1;
   i3 = i6 ? i7 : i5;
   i4 = i8 & 255;
  }
  if (!(_strncmp(i2, i3, i4) | 0)) return;
 }
 i4 = i6 ? i7 : i5;
 if (i9) i3 = (HEAP32[i11 + 40 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i12 >>> 0 > i3 >>> 0) {
  if (i9) i2 = HEAP32[i11 + 36 >> 2] | 0; else i2 = i8 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i3, i12 - i3 | 0, i2, 0, i2, i12, i4);
 } else {
  if (i9) i1 = HEAP32[i1 >> 2] | 0;
  if (i12 | 0) _memmove(i1 | 0, i4 | 0, i12 | 0) | 0;
  HEAP8[i1 + i12 >> 0] = 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i11 + 36 >> 2] = i12;
   break;
  } else {
   HEAP8[i10 >> 0] = i12;
   break;
  }
 } while (0);
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i11);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 i8 = i7 + 4 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = i9 - i1 >> 3;
 HEAP32[i5 >> 2] = i6;
 i11 = i2 + 16 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i2 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i11 >> 2] = i4;
  i6 = i9;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i5, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i6 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i11 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i11 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
   i3 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i10 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i11 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i12;
 return;
}

function __ZN15QualitySettings23GetQualitySettingsNamesEv(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i7 >> 2] = 0;
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i10 = i1 + 28 | 0;
 i6 = i1 + 32 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return;
 }
 i5 = i7 + 8 | 0;
 i4 = 0;
 do {
  i2 = i1 + (i4 * 108 | 0) | 0;
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  if (i3 << 24 >> 24 < 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i1 + (i4 * 108 | 0) + 4 >> 2] | 0;
  } else i1 = i3 & 255;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, i1);
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i7, i8); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i8);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  i4 = i4 + 1 | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } while (i4 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 108 | 0) >>> 0);
 STACKTOP = i11;
 return;
}

function __ZNSt3__25stoulERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084457 | 0, 5);
 HEAP32[i3 >> 2] = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i9 = ___errno_location() | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 i2 = _strtoul(i4, i3, i2) | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i7 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (!(i10 & 1)) i5 = 3;
 } else i5 = 3;
 do if ((i5 | 0) == 3) {
  i10 = HEAP32[i3 >> 2] | 0;
  i1 = i10;
  if ((i10 | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = i1 - i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return i2 | 0;
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i10 | 0);
 return 0;
}

function __ZNSt3__214__split_bufferIN13AnimationClip9PPtrCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i6 = i9 + 4 | 0;
  i7 = i9 + 4 | 0;
  do {
   i3 = i1 + -60 | 0;
   HEAP32[i5 >> 2] = i3;
   i2 = i1 + -20 | 0;
   if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = i1 + -44 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -32 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i9);
   }
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i1 + -48 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i7 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i11 = HEAP32[HEAP32[i8 + 16 >> 2] >> 2] | 0;
 HEAP32[i9 >> 2] = 25;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __ZNSt3__211__libcpp_db11__insert_icEPvPKv(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i2 = i3 + 4 | 0;
 L1 : do if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i5;
  i7 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6 + 4 | 0, i1, 4) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i1 + (((i7 >>> 0) % ((HEAP32[i2 >> 2] | 0) - i1 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
  if (i1 | 0) {
   i2 = i1;
   while (1) {
    if ((HEAP32[i2 + 4 >> 2] | 0) == (i5 | 0)) break;
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if (!i1) break L1; else i2 = i1;
   }
   __THREW__ = 0;
   i1 = invoke_iii(fb + 1144 | 0, i3 | 0, i4 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   do if (i7 & 1) {
    i1 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
   } else {
    __THREW__ = 0;
    invoke_vii(fb + 4497 | 0, i2 | 0, i1 | 0);
    i7 = __THREW__;
    __THREW__ = 0;
    if (i7 & 1) {
     i1 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     break;
    } else {
     HEAP32[i1 + 8 >> 2] = i2;
     break L1;
    }
   } while (0);
   __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
   ___resumeException(i1 | 0);
  }
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 STACKTOP = i6;
 return;
}

function __ZNK18ProceduralMaterial22GetSubstancePropertiesEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i6 >> 2] = 0;
 i8 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 i5 = i1 + 180 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i4 = i6 + 8 | 0;
 do {
  i1 = HEAP8[i2 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
  } else {
   i3 = i2;
   i1 = i1 & 255;
  };
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i3, i1);
  i1 = HEAP32[i8 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE13stl_allocatorIS6_L18MemLabelIdentifier77ELi16EEE21__push_back_slow_pathIKS6_EEvRT_(i6, i7); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i7);
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i2 = i2 + 156 | 0;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 STACKTOP = i9;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags(i9, i6, i1) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i6, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j(i6, HEAP32[i8 + 4 >> 2] | 0);
 i5 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + (i5 * 24 | 0) | 0;
 if (i5 | 0) {
  i4 = HEAP32[gb + 37260 >> 2] | 0;
  i5 = i9 + 20 | 0;
  i2 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   __ZN8JSONRead18TransferStringDataINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_(i9, i1);
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i7 >> 2] = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 24 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739625 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN5physx2Sn21SerializationRegistryC2ERNS_9PxPhysicsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = gb + 89032 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(.75);
 HEAP32[i2 + 36 >> 2] = -1;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 i1 = i2 + 48 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i2 + 72 >> 2] = Math_fround(.75);
 HEAP32[i2 + 76 >> 2] = -1;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i1, 64);
 HEAP32[i2 + 88 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 _PxRegisterPhysicsSerializers(i2);
 __ZN5physx3Ext29RegisterExtensionsSerializersERNS_23PxSerializationRegistryE(i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3719 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3720 | 0);
 return;
}

function __ZN33EnlightenTerrainChunksInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = i1 + 4 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = i1 + 8 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i7 = i1 + 12 | 0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f10 = Math_fround(f2 * Math_fround(.25));
 f11 = Math_fround(f4 * Math_fround(.333333343));
 f12 = Math_fround(f6 * Math_fround(.5));
 f9 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 HEAPF32[i1 + 36 >> 2] = Math_fround(f9 * Math_fround(f8 + Math_fround(f9 * Math_fround(f12 + Math_fround(f9 * Math_fround(f11 + Math_fround(f10 * f9)))))));
 f4 = Math_fround(f4 * Math_fround(.0833333358));
 f6 = Math_fround(f6 * Math_fround(.166666672));
 f8 = Math_fround(f8 * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(f2 * Math_fround(.0500000007));
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i7 >> 2] = f8;
 i7 = i1 + 16 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) * Math_fround(.0500000007));
 i5 = i1 + 20 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.0833333358));
 i3 = i1 + 24 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.166666672));
 i1 = i1 + 28 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.5));
 HEAPF32[i7 >> 2] = f8;
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __ZN21UnityWebStream_Static10ReadStringERPKhS1_PNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i8, i4, i9) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  i7 = 0;
  i6 = i2;
 } else {
  i9 = 0;
  return i9 | 0;
 }
 while (1) {
  if (!(HEAP8[i6 >> 0] | 0)) break;
  i1 = i7 + 1 | 0;
  i3 = i2 + i1 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   i7 = i1;
   i6 = i3;
  } else {
   i1 = 0;
   i5 = 22;
   break;
  }
 }
 if ((i5 | 0) == 22) return i1 | 0;
 do if (i9 | 0) {
  i5 = i9 + 11 | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i3 = i1 << 24 >> 24 < 0;
  if (i3) i4 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i7 >>> 0 > i4 >>> 0) {
   if (i3) i1 = HEAP32[i9 + 4 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i9, i4, i7 - i4 | 0, i1, 0, i1, 0);
   i1 = HEAP8[i5 >> 0] | 0;
  }
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i9 >> 2] | 0; else i1 = i9;
  if (i7) {
   i3 = i1;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 1 | 0;
   }
   i1 = i1 + i7 | 0;
  }
  HEAP8[i1 >> 0] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i5 >> 0] = i7;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i7 + 1);
 i9 = 1;
 return i9 | 0;
}

function __ZN21EnlightenSceneMapping16BuildRemapTablesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 + 124 >> 2] | 0;
 i9 = i6 + 128 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i1 = i2 + (~((i2 + -8 - i1 | 0) >>> 3) << 3) | 0;
  HEAP32[i9 >> 2] = i1;
 }
 if (!i8) {
  i9 = i6 + 120 | 0;
  __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i9);
  STACKTOP = i10;
  return;
 }
 i3 = i7 + 4 | 0;
 i4 = i6 + 132 | 0;
 i5 = i6 + 124 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i7 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 * 40 | 0) >> 2];
  HEAP32[i3 >> 2] = i2;
  if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i7); else {
   i12 = i7;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i1 + 4 >> 2] = i11;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 8;
  }
  i1 = i2 + 1 | 0;
  if ((i1 | 0) == (i8 | 0)) break;
  i2 = i1;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i12 = i6 + 120 | 0;
 __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv(i12);
 STACKTOP = i10;
 return;
}

function __ZN19CharacterControllerC2E10MemLabelId18ObjectCreationMode(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 111344 + 8;
 HEAP32[i4 + 64 >> 2] = gb + 111320 + 8;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 i9 = i4 + 112 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 HEAP8[i4 + 108 >> 0] = 1;
 HEAPF64[i4 + 144 >> 3] = 0.0;
 HEAP8[i4 + 152 >> 0] = 1;
 STACKTOP = i5;
 return;
}

function __ZN12InputManager12ProcessInputEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, f11 = f0;
 i2 = i10 + 124 | 0;
 i5 = i10 + 128 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = i8;
 if ((i6 | 0) != (i8 | 0)) {
  i4 = HEAP32[i1 >> 2] | 0;
  i9 = i1 + 4 | 0;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i4 | 0) != (i3 | 0)) {
   _memset(i4 | 0, 0, i3 + -4 - i4 + 4 & -4 | 0) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[i5 >> 2] | 0;
  }
  i2 = i1 + 12 | 0;
  if ((i2 | 0) != (i6 | 0)) {
   i5 = HEAP32[i8 >> 2] | 0;
   i8 = (HEAP32[i9 >> 2] | 0) - i5 >> 2;
   i9 = i5;
   while (1) {
    i4 = HEAP32[i2 >> 2] | 0;
    i3 = (HEAP32[i1 + 16 >> 2] | 0) - i4 >> 2;
    i3 = i3 >>> 0 < i8 >>> 0 ? i3 : i8;
    if (i3 | 0) {
     i1 = 0;
     do {
      f7 = Math_fround(HEAPF32[i4 + (i1 << 2) >> 2]);
      f11 = Math_fround(Math_abs(Math_fround(f7)));
      i5 = i9 + (i1 << 2) | 0;
      if (f11 > Math_fround(Math_abs(Math_fround(HEAPF32[i5 >> 2])))) HEAPF32[i5 >> 2] = f7;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i3 >>> 0);
    }
    i1 = i2 + 12 | 0;
    if ((i1 | 0) == (i6 | 0)) break; else {
     i5 = i2;
     i2 = i1;
     i1 = i5;
    }
   }
  }
 }
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 i2 = i10 + 32 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN11UnityEngine9Analytics16TransactionEventD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 188628 + 8;
 i1 = i3 + 84 | 0;
 i2 = i3 + 100 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i3 + 112 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 i1 = i3 + 56 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 68 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 i1 = i3 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 44 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 HEAP32[i3 >> 2] = gb + 190148 + 8;
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 STACKTOP = i5;
 return;
}

function __ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb(i1, i2, i3, i4, i9, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 if (!(__ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb(i1, i2, i4, i5, 0) | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i5 + 128 >> 2] | 0;
 i5 = (HEAP32[i5 + 132 >> 2] | 0) - i6 | 0;
 i5 = i5 | 0 ? ((i5 | 0) / 52 | 0) + -1 | 0 : 0;
 i5 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 i1 = __Z12GetGfxDevicev() | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0, 4) | 0) i4 = 1; else i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0, 5) | 0;
 i2 = HEAP32[i6 + (i5 * 52 | 0) + 32 >> 2] | 0;
 i7 = HEAP32[i6 + (i5 * 52 | 0) + 44 >> 2] | 0;
 i1 = HEAP32[i6 + (i5 * 52 | 0) + 36 >> 2] | 0;
 i3 = HEAP32[i6 + (i5 * 52 | 0) + 40 >> 2] | 0;
 i8 = HEAP32[i6 + (i5 * 52 | 0) + 48 >> 2] | 0;
 if (i4) {
  if ((i3 | 0) == 1) i10 = 7;
 } else if ((i3 | 0) == 2) i10 = 7;
 if ((i10 | 0) == 7) {
  i3 = 0;
  i2 = HEAP32[i6 + (i5 * 52 | 0) >> 2] | 0;
  i1 = HEAP32[i6 + (i5 * 52 | 0) + 4 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = i1;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = i8;
 i10 = i9 + 24 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i10 + 4 >> 2] = 0;
 i10 = 1;
 return i10 | 0;
}

function __ZN5physx7NpShape16setContactOffsetEf(i6, f10) {
 i6 = i6 | 0;
 f10 = Math_fround(f10);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 i4 = i11 + 4 | 0;
 i8 = i6 + 32 | 0;
 i5 = i6 + 48 | 0;
 i7 = i6 + 36 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 switch (i9 >>> 30 | 0) {
 case 3:
  {
   i3 = i8;
   i1 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 4; else {
    i3 = i8;
    i1 = 6;
   }
   break;
  }
 default:
  i1 = 4;
 }
 if ((i1 | 0) == 4) {
  i2 = HEAP8[i6 + 112 >> 0] | 0;
  HEAPF32[i6 + 108 >> 2] = f10;
  i1 = HEAP32[i8 + -32 + 20 >> 2] | 0;
  if ((i9 & -1073741824 | 0) == 1073741824 | (i1 | 0) == 0) {
   STACKTOP = i11;
   return;
  }
  HEAP32[i3 >> 2] = 16;
  HEAP8[i4 >> 0] = i2;
  __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i5, i3, i4);
  STACKTOP = i11;
  return;
 } else if ((i1 | 0) == 6) {
  i2 = i6 + 40 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i9 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAPF32[i1 + 44 >> 2] = f10;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i8);
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx2Sn18RepXCollectionImplD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 146368 + 8;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (i1 | 0) {
  i2 = i5 + 20 | 0;
  i3 = i5 + 8 | 0;
  i4 = 0;
  do {
   __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE((HEAP32[i3 >> 2] | 0) + 4 | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 * 24 | 0) + 16 >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i1 | 0));
 }
 HEAP32[i5 + 104 >> 2] = gb + 89572 + 8;
 HEAP32[i5 + 108 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i5 + 124 >> 2] | 0;
 if (i1 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i5 + 112 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 __ZN5physx19CVariableMemoryPoolD2Ev(i5 + 36 | 0);
 i4 = HEAP32[i5 + 28 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  if (i1 | 0) {
   i4 = HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i5;
  if (i5 | 0) {
   HEAP32[i1 >> 2] = 0;
   return;
  }
 }
 HEAP32[i2 + 4 >> 2] = gb + 142044 + 8;
 __ZN5physx19CVariableMemoryPoolD2Ev(i2 + 12 | 0);
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx2Sc13ConstraintSim15preBodiesChangeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 108 >> 2] | 0;
 if (!i1) i2 = 3; else {
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  if (!i1) i2 = 3; else i2 = 6;
 }
 do if ((i2 | 0) == 3) {
  i1 = HEAP32[i4 + 112 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 60 >> 2] | 0;
   if (i1 | 0) {
    i2 = 6;
    break;
   }
  }
  i1 = i4 + 96 | 0;
 } while (0);
 if ((i2 | 0) == 6) {
  i3 = i4 + 96 | 0;
  __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i1, i4);
  i1 = i3;
 }
 i3 = i4 + 104 | 0;
 if (!(HEAP32[i4 + 12 >> 2] | 0)) {
  i4 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
 }
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 1228 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i4 = i2 + 280 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i2 + 292 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i2 + 284 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i2 + 276 >> 2] | 0) * 50 | 0)) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN18ProfilerConnection18PrepareConnectionsEv(i1) {
 i1 = i1 | 0;
 __ZN17GeneralConnection25RegisterConnectionHandlerEPFvjE(__ZN16PlayerConnection3GetEv() | 0, fb + 3427 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 33, fb + 538 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 42, fb + 539 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 40, fb + 540 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 50, fb + 541 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 51, fb + 542 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 53, fb + 543 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 54, fb + 544 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 55, fb + 545 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 56, fb + 546 | 0);
 __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE(__ZN16PlayerConnection3GetEv() | 0, 57, fb + 547 | 0);
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i8 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = (i3 - i1 | 0) / 296 | 0;
 if (i10 >>> 0 > i2 >>> 0) __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj(i8, i10 - i2 | 0); else if (i10 >>> 0 < i2 >>> 0) {
  i4 = i1 + (i10 * 296 | 0) | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i5 = i6 + 4 | 0;
   i2 = i3;
   while (1) {
    i1 = i2 + -296 | 0;
    HEAP32[i7 >> 2] = i1;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
     i1 = HEAP32[i1 >> 2] | 0;
     i3 = HEAP32[i2 + -284 >> 2] | 0;
     HEAP32[i6 >> 2] = 66;
     HEAP32[i5 >> 2] = i3;
     __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
     i1 = HEAP32[i7 >> 2] | 0;
    }
    if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
   }
  }
 }
 if (!i10) {
  STACKTOP = i11;
  return;
 }
 i1 = 0;
 do {
  i2 = HEAP32[(__ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i9 >> 2] | 0, i1) | 0) >> 2] | 0;
  if (i2 | 0) __ZN8GUIStyleaSERKS_((HEAP32[i8 >> 2] | 0) + (i1 * 296 | 0) | 0, HEAP32[i2 + 8 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 STACKTOP = i11;
 return;
}

function __Z34Texture2D_CUSTOM_GetRawTextureDataP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 if (!i3) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 + 40 >> 2] | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0, 1, i2) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) i4 = 10; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i4 = 10;
 }
 if ((i4 | 0) == 10) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
  if (!(HEAP8[i1 + 111 >> 0] | 0)) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 570685 | 0, 0, gb + 570137 | 0, 510, 1, i1, 0, 0);
   return i5 | 0;
  } else i1 = 0;
 }
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 1) | 0, i1 | 0, i2 | 0) | 0;
 return i5 | 0;
}

function __ZNK9Projector31GetProjectorToPerspectiveMatrixEv(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 256 | 0;
 i9 = i12 + 192 | 0;
 i10 = i12 + 128 | 0;
 i11 = i12 + 64 | 0;
 i1 = i12;
 HEAPF32[i9 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i9 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i8, i9) | 0;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f4 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 if (!(HEAP8[i2 + 52 >> 0] | 0)) __ZN10Matrix4x4f14SetPerspectiveEffff(i1, Math_fround(HEAPF32[i2 + 44 >> 2]), f4, f5, f6) | 0; else {
  f13 = Math_fround(HEAPF32[i2 + 56 >> 2]);
  f14 = Math_fround(-f13);
  __ZN10Matrix4x4f8SetOrthoEffffff(i1, Math_fround(f4 * f14), Math_fround(f4 * f13), f14, f13, f5, f6) | 0;
 }
 i3 = i10;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i10, i8, i11);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i11, i9, i7);
 STACKTOP = i12;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags(i9, i5, i1) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i3 = i9 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i9 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i5 >> 2] | 0)) {
   i9 = i5 + 4 | 0;
   HEAP32[i9 >> 2] = i2;
   HEAP32[i9 + 4 >> 2] = i3;
  }
  HEAP32[i5 + 12 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  STACKTOP = i8;
  return;
 }
 __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, HEAP32[i7 + 4 >> 2] | 0, i4);
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + (i4 * 24 | 0) | 0;
 if (i4 | 0) {
  i4 = i9 + 20 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i4 >> 2] = gb + 1034429;
   __ZN10Matrix4x4f8TransferI8JSONReadEEvRT_(i2, i9);
   i1 = i1 + 24 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 64 | 0;
  }
 }
 HEAP32[i6 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj437ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj436ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx17PxcNpMemBlockPool23acquireConstraintMemoryEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = HEAP32[i9 + 168 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i3 = i7 + 4 | 0;
 i4 = i7 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i13 = HEAP32[i6 + (i5 + -1 << 2) >> 2] | 0;
 i1 = i7 + 16 | 0;
 i12 = HEAP32[i1 >> 2] | 0;
 i2 = i12;
 i8 = i13 - i2 | 0;
 if ((i13 | 0) == (i12 | 0)) i1 = 0; else {
  if ((HEAP32[i7 + 12 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
   HEAP32[i6 + (i5 << 2) >> 2] = i2;
   HEAP32[i4 >> 2] = i5 + 1;
  } else __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i3, i1) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 i4 = i9 + 160 | 0;
 HEAP32[i4 >> 2] = i1;
 i13 = i8 >>> 14;
 i1 = i9 + 164 | 0;
 HEAP32[i1 >> 2] = i13;
 i3 = i9 + 88 | 0;
 HEAP32[i10 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i3, i13, i10);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i2 = 0;
 do {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = (HEAP32[i4 >> 2] | 0) + (i2 << 14);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i1 >>> 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx15PxVehicleWheels14setToRestStateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 12 | 0;
 i2 = i5;
 i3 = i4 + 104 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 204 >> 2] | 0, i6 | 0) | 0) & 1) {
  i6 = i4 + 72 | 0;
  __ZN5physx22PxVehicleWheelsDynData14setToRestStateEv(i6);
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 156 >> 2] | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 mftCall_viii(i7 | 0, i6 | 0, i1 | 0, 1);
 i6 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 mftCall_viii(i1 | 0, i6 | 0, i2 | 0, 1);
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 176 >> 2] | 0, i6 | 0, 3);
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 176 >> 2] | 0, i6 | 0, 2);
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0, 3);
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 180 >> 2] | 0, i6 | 0, 2);
 i6 = i4 + 72 | 0;
 __ZN5physx22PxVehicleWheelsDynData14setToRestStateEv(i6);
 STACKTOP = i5;
 return;
}

function __Z31GetPhysics2DScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1458416 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 801496 | 0, 16) | 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[gb + 1458416 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801622 | 0) | 0;
 HEAP32[HEAP32[gb + 1458416 >> 2] >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801634 | 0) | 0;
 i2 = HEAP32[gb + 1458416 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i2 + 8 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 801649 | 0, gb + 801659 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1458416 >> 2] | 0) + 16 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 801649 | 0, gb + 801667 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801689 | 0) | 0;
 HEAP32[(HEAP32[gb + 1458416 >> 2] | 0) + 24 >> 2] = i2;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 228 | 0, fb + 229 | 0);
 i2 = HEAP32[gb + 1458416 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z29StdTemplateConversionFunctionIyyEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i9 = i5;
  i6 = i9;
  i6 = HEAP32[i6 >> 2] | 0;
  i9 = i9 + 4 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i1;
  i7 = i10;
  HEAP32[i7 >> 2] = i6;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i9 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = i6;
 i9 = i5;
 i6 = i9;
 i6 = HEAP32[i6 >> 2] | 0;
 i9 = i9 + 4 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i1;
 i7 = i10;
 HEAP32[i7 >> 2] = i6;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIyxEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i9 = i5;
  i6 = i9;
  i6 = HEAP32[i6 >> 2] | 0;
  i9 = i9 + 4 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i10 = i1;
  i7 = i10;
  HEAP32[i7 >> 2] = i6;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i9;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i9 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i9 >> 2] | 0) | 0;
 HEAP32[i9 >> 2] = i6;
 i9 = i5;
 i6 = i9;
 i6 = HEAP32[i6 >> 2] | 0;
 i9 = i9 + 4 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i1;
 i7 = i10;
 HEAP32[i7 >> 2] = i6;
 i10 = i10 + 4 | 0;
 HEAP32[i10 >> 2] = i9;
 STACKTOP = i8;
 return 1;
}

function __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 108 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 108 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 108 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 108 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 108 | 0);
 __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -108 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -96 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i12, i8) {
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 4 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 i2 = HEAP32[i12 >> 2] | 0;
 i4 = ((i1 - i2 | 0) / 12 | 0) + 1 | 0;
 if (i4 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i12);
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = HEAP32[i12 >> 2] | 0;
 }
 i10 = i2;
 i3 = i1;
 i11 = i12 + 8 | 0;
 i9 = ((HEAP32[i11 >> 2] | 0) - i2 | 0) / 12 | 0;
 i5 = i9 << 1;
 i4 = i9 >>> 0 < 178956970 ? (i5 >>> 0 < i4 >>> 0 ? i4 : i5) : 357913941;
 i5 = (i1 - i2 | 0) / 12 | 0;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i7 = i6 + (i5 * 12 | 0) | 0;
 i2 = i7;
 i9 = i6 + (i4 * 12 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 i4 = i7 + 12 | 0;
 if ((i3 | 0) != (i10 | 0)) {
  i1 = i7;
  do {
   i8 = i3;
   i3 = i3 + -12 | 0;
   HEAP32[i1 + -12 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i8 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i8 + -4 >> 2];
   i1 = i2 + -12 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i10 | 0));
  i1 = HEAP32[i12 >> 2] | 0;
 }
 HEAP32[i12 >> 2] = i2;
 HEAP32[i13 >> 2] = i4;
 HEAP32[i11 >> 2] = i9;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZNSt3__211__libcpp_db9__erase_iEPv(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i2 = i6 + 12 | 0;
 i3 = i6 + 16 | 0;
 L1 : do if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i5;
  i1 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i7 + 4 | 0, i1, 4) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i4 = i4 + (((i1 >>> 0) % ((HEAP32[i3 >> 2] | 0) - i4 >> 2 >>> 0) | 0) << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1;
   i2 = 0;
   while (1) {
    if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) break;
    i1 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i1) break L1; else {
     i2 = i3;
     i3 = i1;
    }
   }
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i2) HEAP32[i4 >> 2] = i1; else HEAP32[i2 + 4 >> 2] = i1;
   i1 = HEAP32[i3 + 8 >> 2] | 0;
   i6 = i6 + 20 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vii(fb + 4498 | 0, i1 | 0, i3 | 0);
    i6 = __THREW__;
    __THREW__ = 0;
    if (i6 & 1) {
     i7 = ___cxa_find_matching_catch_2() | 0;
     getTempRet0() | 0;
     __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
     ___resumeException(i7 | 0);
    }
   }
   _free(i3);
  }
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx37updateAtomProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj(i3, i17, i1, i16, i12, i15) {
 i3 = i3 | 0;
 i17 = i17 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 i12 = i12 | 0;
 i15 = i15 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0, i14 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i18 + 4 | 0;
 i14 = i18;
 i10 = i18 + 9 | 0;
 i11 = i18 + 8 | 0;
 if (!i17) {
  i17 = 0;
  i17 = i17 & 65535;
  STACKTOP = i18;
  return i17 | 0;
 }
 i9 = i1;
 i2 = 0;
 i1 = 0;
 while (1) {
  __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i3, i9, i16, i12, i15, i13, i14, i10, i11) | 0;
  i7 = (HEAP8[i10 >> 0] | 0) == 0;
  if (i7) i4 = 65535; else i4 = HEAPU16[(HEAP32[i3 >> 2] | 0) + 12 >> 1] | 0;
  i8 = (HEAP8[i11 >> 0] | 0) == 0;
  if (i8) i5 = 65535; else i5 = HEAPU16[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 1] | 0;
  HEAP16[i3 + 28 >> 1] = i4;
  HEAP16[i3 + 30 >> 1] = i5;
  i6 = i4 + 1 & 65535;
  i4 = i5 + 1 & 65535;
  i5 = (i6 & 65535) < (i4 & 65535) ? i4 : i6;
  i1 = (i1 & 65535) < (i5 & 65535) ? i5 : i1;
  if (!i7) HEAP16[(HEAP32[i3 >> 2] | 0) + 12 >> 1] = i6;
  if (!i8) HEAP16[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 1] = i4;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i17 | 0)) break; else i3 = i3 + 32 | 0;
 }
 i17 = i1 & 65535;
 STACKTOP = i18;
 return i17 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN20TextRenderingPrivate22ScriptingTextGenerator19InitCharAndLineInfoEii(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i6 + 40 | 0;
 i3 = i6 + 52 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i6 + 56 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 12 | 0, 4, i6 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i6 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = i5;
  break;
 } while (0);
 i1 = i6 + 20 | 0;
 i2 = i6 + 32 | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i6 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i7 >>> 0) return;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i7 * 12 | 0, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 * 12 | 0, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = i6;
  return;
 }
}

function __ZN16LightmapSettings12SetLightmapsERK13dynamic_arrayI12LightmapDataLj4EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i8 + 36 | 0;
 if ((i5 | 0) != (i1 | 0)) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = i8 + 48 | 0;
  i1 = HEAP32[i1 + 12 >> 2] << 3;
  i3 = i1 >> 3;
  HEAP32[i7 >> 2] = i3;
  i4 = i8 + 52 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  do if ((i2 & 2147483647) >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i4 >> 2] = i3;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i8 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i8 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i3;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i6 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 }
 i1 = i8 + 56 | 0;
 i2 = i8 + 72 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i7 = i8 + 68 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  __ZN16LightmapSettings7RebuildEv(i8);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i8 + 60 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i8 + 68 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN16LightmapSettings7RebuildEv(i8);
 return;
}

function __ZN14UnityAnalytics21OnSceneTimingCallbackERK15SceneLoadTimingRK8UnityStr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, d9 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 80 | 0;
 i5 = i6;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZN11UnityEngine9Analytics9PerfEventC2Ev(i5);
 d9 = +Math_fround(HEAPF32[i2 >> 2]);
 d8 = +Math_fround(HEAPF32[i2 + 4 >> 2]);
 d7 = +Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZN11UnityEngine9Analytics9PerfEvent12SetSceneLoadERK8UnityStrdddd(i5, i3, d9, d8, d7, +Math_fround(HEAPF32[i2 + 12 >> 2]));
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i5 >> 2] = gb + 188436 + 8;
 i1 = i5 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 + 44 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 HEAP32[i5 >> 2] = gb + 190148 + 8;
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i5 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 }
 STACKTOP = i6;
 return;
}

function _y0f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if (!(i2 & 2147483647)) f1 = Math_fround(-inf); else if ((i2 | 0) < 0) f1 = Math_fround(nan); else {
  if (i2 >>> 0 > 2139095039) {
   f1 = Math_fround(Math_fround(1.0) / f1);
   break;
  }
  if (i2 >>> 0 > 1073741823) {
   f1 = Math_fround(_common_163(i2, f1, 1));
   break;
  }
  if (i2 >>> 0 > 956301311) {
   f3 = Math_fround(f1 * f1);
   f3 = Math_fround(Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(1.9559014e-08) - Math_fround(f3 * Math_fround(3.98205184e-11)))) + Math_fround(-3.81407062e-06))) + Math_fround(.000347453431))) + Math_fround(-.0138185676))) + Math_fround(.176666453))) + Math_fround(-.0738042966)) / Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(4.41110315e-10)) + Math_fround(2.59150852e-07))) + Math_fround(.0000760068651))) + Math_fround(.0127304839))) + Math_fround(1.0)));
   f1 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(_j0f(f1)) * Math_fround(+Math_log(+f1))) * Math_fround(.636619746)));
   break;
  } else {
   f1 = Math_fround(Math_fround(Math_fround(+Math_log(+f1)) * Math_fround(.636619746)) + Math_fround(-.0738042966));
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZNK17ProfilerFrameData10ThreadData22ExtractAllChildSamplesEjR13dynamic_arrayIjLj4EE(i9, i1, i13) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i14 = i2 + (i1 * 24 | 0) + 12 | 0;
 if ((HEAP32[i14 >> 2] | 0) <= 0) return;
 i10 = i13 + 12 | 0;
 i11 = i13 + 16 | 0;
 i12 = i13 + 4 | 0;
 i8 = i2 + (i1 * 24 | 0) + 24 | 0;
 i1 = 0;
 while (1) {
  i3 = (i8 - i2 | 0) / 24 | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i5 = i4 + 1 | 0;
  i6 = HEAP32[i11 >> 2] | 0;
  i7 = i6 & 2147483647;
  do if (i5 >>> 0 > i7 >>> 0) {
   i2 = i6 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i7 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
    HEAP32[i11 >> 2] = i2;
    HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i2 << 2, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
    HEAP32[i11 >> 2] = i2;
    HEAP32[i13 >> 2] = i7;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i5;
  HEAP32[(HEAP32[i13 >> 2] | 0) + (i4 << 2) >> 2] = i3;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i14 >> 2] | 0)) break;
  i2 = __Z17SkipSampleRecursePK14ProfilerSample(i8) | 0;
  i8 = i2;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 return;
}

function __ZN9ShaderLab4Pass15IsPassSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i3 = i7 + 16 | 0;
 i4 = i7 + 8 | 0;
 switch (HEAP32[i1 + 744 >> 2] | 0) {
 case 2:
  {
   i6 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 488 >> 2] | 0) > 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 1:
  {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 default:
  {
   i2 = i1 + 4 | 0;
   if (!(HEAP32[i1 + 36 >> 2] | 0)) {
    _printf_console(gb + 480440 | 0, i7);
    i1 = i1 + 728 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 >> 2] = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
    HEAP32[i4 + 4 >> 2] = i1;
    _printf_console(gb + 480511 | 0, i4);
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   if (HEAP32[i1 + 40 >> 2] | 0) {
    i6 = __ZNK9ShaderLab11ShaderState22IsShaderStateSupportedEv(i2) | 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   _printf_console(gb + 480440 | 0, i3);
   i1 = i1 + 728 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i5 >> 2] = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
   HEAP32[i5 + 4 >> 2] = i1;
   _printf_console(gb + 480563 | 0, i5);
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i9 + 8 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i5 = 0; else {
  i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i5 = mftCall_iiiiii(i3 | 0, i7 | 0, i8 | 0, (i5 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + i1 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP8[i5 + i1 >> 0] = HEAP8[i4 >> 0] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == 0 | (HEAP32[i6 >> 2] | 0) < 0) {
  HEAP32[i9 >> 2] = i5;
  HEAP32[i6 >> 2] = i8;
  i9 = HEAP32[i7 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i7 >> 2] = i8;
  i9 = i5 + i9 | 0;
  return i9 | 0;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 HEAP32[i9 >> 2] = i5;
 HEAP32[i6 >> 2] = i8;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i7 >> 2] = i8;
 i9 = i5 + i9 | 0;
 return i9 | 0;
}

function __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831454;
 HEAP32[i1 + 4 >> 2] = 584;
 HEAP32[i1 + 8 >> 2] = fb + 613;
 HEAP32[i1 + 12 >> 2] = gb + 831474;
 HEAP32[i1 + 16 >> 2] = 585;
 HEAP32[i1 + 20 >> 2] = fb + 614;
 HEAP32[i1 + 24 >> 2] = gb + 831488;
 HEAP32[i1 + 28 >> 2] = 586;
 HEAP32[i1 + 32 >> 2] = fb + 528;
 HEAP32[i1 + 36 >> 2] = gb + 831520;
 HEAP32[i1 + 40 >> 2] = 587;
 HEAP32[i1 + 44 >> 2] = fb + 615;
 HEAP32[i1 + 48 >> 2] = fb + 529;
 HEAP32[i1 + 52 >> 2] = gb + 831536;
 HEAP32[i1 + 56 >> 2] = 588;
 HEAP32[i1 + 60 >> 2] = fb + 616;
 HEAP32[i1 + 64 >> 2] = fb + 530;
 HEAP32[i1 + 68 >> 2] = gb + 831554;
 HEAP32[i1 + 72 >> 2] = 589;
 HEAP32[i1 + 76 >> 2] = fb + 617;
 HEAP32[i1 + 80 >> 2] = fb + 531;
 HEAP32[i1 + 84 >> 2] = gb + 831570;
 HEAP32[i1 + 88 >> 2] = 590;
 HEAP32[i1 + 92 >> 2] = fb + 618;
 HEAP32[i1 + 96 >> 2] = fb + 532;
 HEAP32[i1 + 100 >> 2] = gb + 831580;
 HEAP32[i1 + 104 >> 2] = 591;
 HEAP32[i1 + 108 >> 2] = fb + 619;
 HEAP32[i1 + 112 >> 2] = fb + 533;
 HEAP32[i1 + 116 >> 2] = gb + 831592;
 HEAP32[i1 + 120 >> 2] = 592;
 HEAP32[i1 + 124 >> 2] = fb + 620;
 HEAP32[i1 + 128 >> 2] = fb + 534;
 HEAP32[i1 + 132 >> 2] = gb + 831606;
 HEAP32[i1 + 136 >> 2] = 593;
 HEAP32[i1 + 140 >> 2] = fb + 621;
 HEAP32[i1 + 144 >> 2] = fb + 535;
 HEAP32[i1 + 148 >> 2] = gb + 831630;
 HEAP32[i1 + 152 >> 2] = 594;
 HEAP32[i1 + 156 >> 2] = fb + 622;
 HEAP32[i1 + 160 >> 2] = fb + 536;
 return;
}

function __ZN5physx2Sn21SerializationRegistry24unregisterRepXSerializerEt(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i9 + 4 | 0;
 HEAP16[i5 >> 1] = i7;
 i1 = HEAP32[i6 + 68 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i4 = i7 & 65535;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i6 + 60 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = 0; else {
   i4 = HEAP32[i6 + 52 >> 2] | 0;
   i3 = i6 + 56 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if ((HEAP16[i2 >> 1] | 0) == i7 << 16 >> 16) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i1 = 0;
     break L1;
    }
   }
   if (!i2) i1 = 0; else i1 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
  }
 } while (0);
 if (__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i6 + 48 | 0, i5) | 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i8 >> 2] = i7 & 65535;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 2, gb + 667371 | 0, 248, gb + 667678 | 0, i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN26AnimatorControllerPlayable11ClearMemoryEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i2 = i5 + 60 | 0;
 i3 = i5 + 96 | 0;
 __ZN7mecanim9animation22DestroyControllerInputEPNS0_15ControllerInputERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 i4 = i5 + 108 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i1 = i5 + 100 | 0;
  __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 } else {
  i1 = i5 + 100 | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 }
 i6 = i5 + 104 | 0;
 __ZN7mecanim9animation26DestroyControllerWorkspaceEPNS0_19ControllerWorkspaceERNS_6memory9AllocatorE(HEAP32[i6 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 92 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i5 + 148 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 144 | 0;
 i4 = i5 + 64 | 0;
 if ((i1 | 0) > 0) i3 = 0; else {
  i5 = HEAP32[i7 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i4);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  return;
 }
 do {
  i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 3) >> 2] | 0;
  if (i2) {
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 i5 = HEAP32[i7 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i4);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN21ProceduralTextureDataC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i1 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i7 >> 0] = 1;
 i5 = i1 + 29 | 0;
 HEAP8[i5 >> 0] = 0;
 i4 = i1 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 i9 = i1 + 40 | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP8[i9 + 20 >> 0] = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i6 = i2 + 40 | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i2 + 48 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i1 + 48 | 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 i6 = HEAP16[i2 + 28 >> 1] | 0;
 HEAP8[i7 >> 0] = i6;
 HEAP8[i5 >> 0] = (i6 & 65535) >>> 8;
 HEAP32[i4 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP8[i1 + 60 >> 0] = HEAP8[i2 + 60 >> 0] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 64 >> 2];
 return;
}

function __ZN21AssetReferenceStorageD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 6172 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 5404 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 3407 | 0)) {
    i4 = i6 + 5404 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 5404 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 5404 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 5404 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 5404 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 5404 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 5404 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 5404 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i8 = HEAP32[i8 + 52 >> 2] | 0;
 HEAP32[i9 >> 2] = 127;
 HEAP32[i9 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI4PPtrI6ShaderE8UnityStrEEEEvRT_PKc17TransferMetaFlags(i12, i3, i1, i2) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i12);
 i7 = i3 + 4 | 0;
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i3 + 8 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i9 = i12 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i10 = i12 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
 STACKTOP = i11;
 return;
}

function __ZN19SpriteMeshGenerator4path8cve_costEi(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - i5 | 0;
 i4 = i1 >> 5;
 if ((i1 | 0) < 96) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = i6 + -1 | 0;
 if ((i4 | 0) < (i6 | 0)) i1 = (i1 | 0) % (i4 | 0) | 0; else if ((i6 | 0) <= 0) i1 = i4 + -1 - ((0 - i6 | 0) % (i4 | 0) | 0) | 0;
 f3 = Math_fround(HEAPF32[i5 + (i1 << 5) >> 2]);
 f2 = Math_fround(HEAPF32[i5 + (i1 << 5) + 4 >> 2]);
 i1 = i6 + 1 | 0;
 if ((i1 | 0) < (i4 | 0)) {
  if ((i6 | 0) <= -2) i1 = i4 + -1 - ((-2 - i6 | 0) % (i4 | 0) | 0) | 0;
 } else i1 = (i1 | 0) % (i4 | 0) | 0;
 f9 = Math_fround(HEAPF32[i5 + (i1 << 5) >> 2]);
 f8 = Math_fround(HEAPF32[i5 + (i1 << 5) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + (i6 << 5) >> 2]);
 f2 = Math_fround(Math_fround(Math_fround(f9 - f3) * Math_fround(Math_fround(HEAPF32[i5 + (i6 << 5) + 4 >> 2]) - f2)) - Math_fround(Math_fround(f2 - f8) * Math_fround(f3 - f7)));
 do if (!(f2 > Math_fround(0.0))) {
  i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i1 | 0) > -1) {
   if ((i1 | 0) < 11) break;
  } else if (f2 == Math_fround(0.0)) break;
  HEAP32[i5 + (i6 << 5) + 24 >> 2] = -1082130432;
  HEAP32[i5 + (i6 << 5) + 28 >> 2] = 0;
  i6 = 0;
  return i6 | 0;
 } while (0);
 HEAPF32[i5 + (i6 << 5) + 24 >> 2] = f2;
 HEAP32[i5 + (i6 << 5) + 28 >> 2] = 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN16ParticleRenderer11UVAnimation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i1, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085899 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z24GetComponentOrScriptNameRN5Unity9ComponentE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 32 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
  i5 = __ZNK6Object12GetClassNameEv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
  STACKTOP = i6;
  return;
 }
 __ZN13MonoBehaviour18GetScriptClassNameEv(i5, i2);
 i2 = i5 + 11 | 0;
 i7 = HEAP8[i2 >> 0] | 0;
 i9 = i7 << 24 >> 24 < 0;
 i8 = i9 ? HEAP32[i5 >> 2] | 0 : i5;
 i7 = i9 ? HEAP32[i5 + 4 >> 2] | 0 : i7 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i8, i7);
 __Z6AppendRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i4, gb + 447018 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i8;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i3);
 }
 STACKTOP = i6;
 return;
}

function __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i5 = i2 + 12 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + (i4 << 3) | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i3 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (HEAP32[i5 >> 2] | 0) + (i4 + 1 << 3) | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3 + 20 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i3 + 28 | 0;
 if ((i4 | 0) > 0) {
  i6 = (HEAP32[i5 >> 2] | 0) + (i4 + -1 << 3) | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = 1;
 } else {
  i6 = i2 + 20 | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = i7;
  i1 = HEAP8[i2 + 36 >> 0] | 0;
 }
 HEAP8[i3 + 44 >> 0] = i1;
 i1 = i3 + 36 | 0;
 if (((HEAP32[i2 + 16 >> 2] | 0) + -2 | 0) > (i4 | 0)) {
  i5 = (HEAP32[i5 >> 2] | 0) + (i4 + 2 << 3) | 0;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i1;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  i6 = 1;
  i7 = i3 + 45 | 0;
  HEAP8[i7 >> 0] = i6;
  return;
 } else {
  i5 = i2 + 28 | 0;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i1;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i7;
  i6 = HEAP8[i2 + 37 >> 0] | 0;
  i7 = i3 + 45 | 0;
  HEAP8[i7 >> 0] = i6;
  return;
 }
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatRGBAFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f14 = Math_fround(HEAPF32[i1 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f12 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i9 = f14 < Math_fround(0.0);
  i8 = f14 > Math_fround(1.0);
  i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i11 = f13 < Math_fround(0.0);
  i10 = f13 > Math_fround(1.0);
  i10 = ~~Math_fround(Math_fround((i10 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  i7 = f12 < Math_fround(0.0);
  i6 = f12 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
  f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  i5 = f12 < Math_fround(0.0);
  i3 = f12 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
  HEAP32[i4 >> 2] = (i11 ? 0 : i10 & 16711680) | (i9 ? 0 : i8 & 65280) | (i7 ? 0 : i6) | (i5 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatARGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  i9 = f14 < Math_fround(0.0);
  i8 = f14 > Math_fround(1.0);
  i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f14) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i11 = f13 < Math_fround(0.0);
  i10 = f13 > Math_fround(1.0);
  i10 = ~~Math_fround(Math_fround((i10 ? Math_fround(1.0) : f13) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  i7 = f12 < Math_fround(0.0);
  i6 = f12 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  i5 = f12 < Math_fround(0.0);
  i3 = f12 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 & 255;
  HEAP32[i4 >> 2] = (i11 ? 0 : i10 & 16711680) | (i9 ? 0 : i8 & 65280) | (i7 ? 0 : i6) | (i5 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx9NpPhysics11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i1, i4, i2, i5, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i6 = i1 + 28 | 0;
 i8 = HEAP32[gb + 1457204 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i4 >> 2]);
 f12 = Math_fround(f13 * f13);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f11 * f11));
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(f10 * f10));
 f9 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f12 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f12 + Math_fround(f9 * f9)))));
 f11 = Math_fround(f11 * f12);
 f10 = Math_fround(f10 * f12);
 f9 = Math_fround(f9 * f12);
 HEAPF32[i7 >> 2] = Math_fround(f13 * f12);
 HEAPF32[i7 + 4 >> 2] = f11;
 HEAPF32[i7 + 8 >> 2] = f10;
 HEAPF32[i7 + 12 >> 2] = f9;
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP16[i6 >> 1] = HEAP16[i3 >> 1] | 0;
 i5 = __ZN5physx9NpFactory11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i8, i7, i2, i5, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_(i10, i1, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 60 | 0;
 i6 = i8 + 56 | 0;
 i7 = i8 + 28 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i10 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = HEAP32[i10 + 20 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc(i4, i7, i6);
 i10 = HEAP32[i10 + 24 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 mftCall_vii(HEAP32[i9 + 20 >> 2] | 0, i10 | 0, i5 | 0);
 STACKTOP = i8;
 return;
}

function __ZN2UI14CanvasRenderer18SyncInheritedAlphaENS0_8SyncFlagE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i5 + 188 >> 2] | 0;
 if (!i2) i4 = 0; else i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 L4 : do if ((i2 | 0) == (i4 | 0)) f1 = Math_fround(1.0); else {
  f1 = Math_fround(1.0);
  do {
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 186852 | 0) | 0;
   if (i3) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) {
    f1 = Math_fround(f1 * Math_fround(HEAPF32[i3 + 36 >> 2]));
    if (HEAP8[i3 + 42 >> 0] | 0) break L4;
   }
   i2 = HEAP32[i2 + 100 >> 2] | 0;
  } while ((i2 | 0) != (i4 | 0));
 } while (0);
 if (i6 & 1 | 0) {
  i3 = HEAP32[i5 + 204 >> 2] | 0;
  i4 = i3 + 112 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 2;
  i4 = HEAP32[i5 + 208 >> 2] | 0;
  i3 = HEAP32[i3 + 84 >> 2] | 0;
  HEAPF32[i3 + (i4 * 672 | 0) + 644 >> 2] = f1;
  HEAP16[i3 + (i4 * 672 | 0) + 664 >> 1] = 4;
 }
 if (!(i6 & 2)) return;
 i4 = HEAP32[i5 + 220 >> 2] | 0;
 i6 = i4 + 112 | 0;
 HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 2;
 i6 = HEAP32[i5 + 224 >> 2] | 0;
 i5 = HEAP32[i4 + 84 >> 2] | 0;
 HEAPF32[i5 + (i6 * 672 | 0) + 644 >> 2] = f1;
 HEAP16[i5 + (i6 * 672 | 0) + 664 >> 1] = 4;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = i2 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i8 >> 2] = i4;
  i1 = i6;
 }
 __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j(i5, i1);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 > i4 >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
  } else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i8 >> 2] = i3;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 > i4 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i8 >> 2] = i5;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN15b2RevoluteJointC2EPK18b2RevoluteJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152528 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 116 >> 2] = HEAP32[i2 + 36 >> 2];
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 104 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAP32[i1 + 108 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP8[i1 + 112 >> 0] = HEAP8[i2 + 40 >> 0] | 0;
 HEAP8[i1 + 100 >> 0] = HEAP8[i2 + 52 >> 0] | 0;
 HEAP32[i1 + 224 >> 2] = 0;
 return;
}

function __ZN14Texture2DArray11SetPixels32EiPK11ColorRGBA32ii(i3, i4, i8, i9, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 20 | 0;
 i11 = i13;
 if (!(__ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii(i3, i4, i8, i9, i1) | 0)) {
  STACKTOP = i13;
  return;
 }
 i12 = HEAP32[i3 + 96 >> 2] | 0;
 i5 = HEAP32[i3 + 104 >> 2] | 0;
 i2 = i3 + 80 | 0;
 i14 = i3 + 84 | 0;
 i6 = i3 + 92 | 0;
 i7 = __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i2 >> 2] | 0, HEAP32[i14 >> 2] | 0, HEAP32[i6 >> 2] | 0, i1) | 0;
 i2 = HEAP32[i2 >> 2] >> i1;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i1 = HEAP32[i14 >> 2] >> i1;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if ((Math_imul(i1, i2) | 0) == (i4 | 0)) {
  i14 = i12 + (Math_imul(i5, i9) | 0) + i7 | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i10, i2, i1, i2 << 2, 4, i8);
  i12 = HEAP32[i6 >> 2] | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i11, i2, i1, Math_imul(HEAP32[gb + 45784 + (i12 << 2) >> 2] | 0, i2) | 0, i12, i14);
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i10, 0);
  STACKTOP = i13;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418272 | 0, 0, gb + 411289 | 0, 296, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i13;
  return;
 }
}

function __ZN14StackAllocator13TryDeallocateEPv(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 if (!i4) return 1;
 i2 = i3 + 52 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) {
  i5 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i4 | 0) | 0;
  i1 = i3 + 16 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - i5;
  i1 = i3 + 28 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -8;
  i1 = i3 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i4 + -4 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
  i1 = HEAP32[i2 >> 2] | 0;
  while (1) {
   i1 = HEAP32[i1 + -8 >> 2] | 0;
   HEAP32[i2 >> 2] = i1;
   if (!i1) {
    i1 = 10;
    break;
   }
   if (!(HEAP32[i1 + -4 >> 2] & 1)) {
    i1 = 10;
    break;
   }
  }
  if ((i1 | 0) == 10) return 1;
 }
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 if (i1 >>> 0 <= i4 >>> 0) if ((i1 + (HEAP32[i3 + 36 >> 2] | 0) | 0) >>> 0 > i4 >>> 0) {
  i2 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i4 | 0) | 0;
  i5 = i3 + 16 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i2;
  i5 = i3 + 28 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -8;
  i5 = i3 + 12 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i5 = i4 + -4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1;
  return 1;
 }
 i5 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i3 + 44 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i4 | 0);
 return 1;
}

function __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i6 = i5 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i7 = i5 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i4, i1 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i1 & 255);
 i1 = HEAP8[i6 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i1 & 255) | 0)) return;
 i3 = 0;
 do {
  i1 = HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5) + i3 >> 0] | 0;
  i2 = i1 & 255;
  do if (i1 << 24 >> 24 == 32) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, 43); else {
   if ((i1 + -32 & 255) <= 94) if (!(_memchr(gb + 1042291 | 0, i2, 17) | 0)) {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, i1);
    break;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, 37);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, HEAP8[(i2 >>> 4) + (gb + 1074037) >> 0] | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i4, HEAP8[(i2 & 15) + (gb + 1074037) >> 0] | 0);
  } while (0);
  i3 = i3 + 1 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
 } while (i3 >>> 0 < (i1 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i1 & 255) >>> 0);
 return;
}

function __Z16return_effectiveRK21AnimationClipOverride(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) {
    i8 = i5;
    i8 = HEAP32[i8 >> 2] | 0;
    STACKTOP = i7;
    return i8 | 0;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) {
   i8 = i5;
   i8 = HEAP32[i8 >> 2] | 0;
   STACKTOP = i7;
   return i8 | 0;
  }
 }
 i8 = i4;
 i8 = HEAP32[i8 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i5, i4);
 i1 = HEAP32[i5 + 288 >> 2] | 0;
 i2 = HEAP32[i5 + 300 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 i6 = i4 + 16 | 0;
 i7 = i4 + 36 | 0;
 i8 = i4 + 40 | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, 1);
 i1 = i5 + 308 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
 i1 = i5 + 280 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i5 + 276 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN6Camera21AddPostRenderCallbackEPFvRS_PvES1_(i7, i3, i4) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = i3;
 i10 = i4;
 if (!i3) return;
 i8 = i7 + 1156 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i11 = i7 + 1168 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i5 = i1 + (i12 << 3) | 0;
 L4 : do if (!i12) {
  i2 = i1;
  i6 = 6;
 } else {
  i2 = i1;
  do {
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) {
    i6 = 6;
    break L4;
   }
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i5 | 0));
 } while (0);
 if ((i6 | 0) == 6) if ((i2 | 0) != (i5 | 0)) return;
 i6 = i12 + 1 | 0;
 i3 = i7 + 1172 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i6 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 3, 4, i7 + 1160 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i8 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i7 + 1160 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i11 >> 2] << 3 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i6;
 HEAP32[i1 + (i12 << 3) >> 2] = i9;
 HEAP32[i1 + (i12 << 3) + 4 >> 2] = i10;
 return;
}

function __ZN12InputManager10GetAxisRawERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f1 = f0, i3 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i3 = i4 + 11 | 0;
 i11 = __Z7FNVHashPKc((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i10 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i5 | 0) == (i10 | 0)) {
  f7 = Math_fround(0.0);
  return Math_fround(f7);
 }
 i9 = HEAP8[i3 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i4 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i4 >> 2] | 0 : i4;
 f7 = Math_fround(0.0);
 while (1) {
  if ((HEAP32[i5 + 20 >> 2] | 0) == (i11 | 0)) {
   i3 = i5 + 4 | 0;
   i6 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i6 << 24 >> 24 < 0;
   if (i2) i4 = HEAP32[i5 + 8 >> 2] | 0; else i4 = i6 & 255;
   if ((i4 | 0) == (i9 | 0)) {
    if (i2) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i5 + 8 >> 2] | 0;
    } else i2 = i6 & 255;
    if (!(_strncmp(i3, i8, i2) | 0)) {
     f1 = Math_fround(HEAPF32[((HEAP32[i5 + 76 >> 2] | 0) == 0 ? i5 + 84 | 0 : i5 + 80 | 0) >> 2]);
     i4 = f1 < Math_fround(0.0);
     f13 = Math_fround(-f1);
     i6 = f7 < Math_fround(0.0);
     f12 = Math_fround(-f7);
     if (!((i4 ? f13 : f1) > (i6 ? f12 : f7))) f1 = f7;
    } else f1 = f7;
   } else f1 = f7;
  } else f1 = f7;
  i5 = i5 + 108 | 0;
  if ((i5 | 0) == (i10 | 0)) break; else f7 = f1;
 }
 return Math_fround(f1);
}

function __Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0, i15 = 0, f16 = f0, f17 = f0, i18 = 0, f19 = f0;
 if ((i6 | 0) <= 0) {
  i6 = 1;
  return i6 | 0;
 }
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i1 = i2;
 i2 = 0;
 while (1) {
  f16 = Math_fround(HEAPF32[i1 >> 2]);
  f19 = Math_fround(f16 * f7);
  f13 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f19 = Math_fround(f19 + Math_fround(f13 * f8));
  f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f19 = Math_fround(f19 + Math_fround(f10 * f9));
  f19 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f19);
  i18 = f16 < Math_fround(0.0);
  f17 = Math_fround(-f16);
  i15 = f13 < Math_fround(0.0);
  f14 = Math_fround(-f13);
  i12 = f10 < Math_fround(0.0);
  f11 = Math_fround(-f10);
  if (Math_fround(f19 + Math_fround(Math_fround(Math_fround((i18 ? f17 : f16) * f4) + Math_fround((i15 ? f14 : f13) * f5)) + Math_fround((i12 ? f11 : f10) * f3))) < Math_fround(0.0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i6 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  } else i1 = i1 + 16 | 0;
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN5physx8debugger21PvdNetworkStreamOwner6createERNS_19PxAllocatorCallbackERNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 64, gb + 775132 | 0, gb + 775144 | 0, 665) | 0;
 HEAP32[i4 >> 2] = gb + 148996 + 8;
 HEAP32[i4 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i4 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i4 + 16 >> 2] = i3;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i4 + 24 >> 2] = 0;
 i3 = i1;
 i5 = i4 + 32 | 0;
 HEAP32[i5 >> 2] = i3;
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = gb + 775236;
 HEAP32[i4 + 28 >> 2] = gb + 148172 + 8;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i2 | 0, HEAP32[i1 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i4 + 40 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i1 = i4 + 48 | 0;
 HEAP32[i1 >> 2] = i3;
 i3 = i4 + 52 | 0;
 HEAP32[i3 >> 2] = gb + 775256;
 HEAP32[i4 + 44 >> 2] = gb + 148172 + 8;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, HEAP32[i3 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i4 + 56 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImplC2Ev(i3);
 HEAP8[i4 + 60 >> 0] = 0;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 24 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 706277 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 24 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   HEAP8[i1 + 20 >> 0] = HEAP8[i2 + 20 >> 0] | 0;
   i1 = i1 + 24 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 24 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd10Foundation14createInstanceEjRNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if ((i2 | 0) != 50529024) {
  i3 = __Znaj(256) | 0;
  HEAP32[i1 >> 2] = 50529024;
  HEAP32[i1 + 4 >> 2] = i2;
  __ZN5physx6string9sprintf_sEPcjPKcz(i3, 256, gb + 778563 | 0, i1) | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 4, i3 | 0, gb + 659867 | 0, 127);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (HEAP32[gb + 1452348 >> 2] | 0) {
  mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 8, gb + 778690 | 0, gb + 659867 | 0, 158);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 132, gb + 778631 | 0, gb + 659867 | 0, 137) | 0;
 HEAP32[gb + 1452348 >> 2] = i1;
 if (!i1) {
  mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 32, gb + 778642 | 0, gb + 659867 | 0, 153);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  __ZN5physx6shdfnd10FoundationC2ERNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE(i1, i4, i3);
  HEAP32[gb + 1452352 >> 2] = 1;
  i4 = HEAP32[gb + 1457400 >> 2] | 0;
  HEAP32[gb + 1457400 >> 2] = (i4 | 0) == -1 ? 1 : i4 + 1 | 0;
  i4 = HEAP32[gb + 1452348 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx3Scb5Scene3addINS0_17ArticulationJointELb0EEEvRT_RNS0_13ObjectTrackerE(i1, i7, i5) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i4 = i8;
 HEAP32[i7 >> 2] = i1;
 i2 = i7 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  HEAP32[i2 >> 2] = i3 & 268435455 | -2147483648;
  __ZN5physx35NpArticulationJointGetBodiesFromScbERNS_3Scb17ArticulationJointERPNS0_4BodyES5_(i7, i6, i4);
  __ZN5physx2Sc5Scene20addArticulationJointERNS0_21ArticulationJointCoreERNS0_8BodyCoreES5_(i1 + 16 | 0, i7 + 12 | 0, (HEAP32[i6 >> 2] | 0) + 16 | 0, (HEAP32[i4 >> 2] | 0) + 16 | 0);
  STACKTOP = i8;
  return;
 }
 i1 = i3 & 1073741823;
 if (i3 >>> 0 > 3221225471) {
  HEAP32[i2 >> 2] = i1 | -2147483648;
  if (i3 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i5, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i2 >> 2] = i1 | 1073741824;
  HEAP32[i4 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i5, i4, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN14SphereCollider6CreateEPK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 if (HEAP32[i1 + 36 >> 2] | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[gb + 62512 >> 2]));
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[gb + 62512 + 4 >> 2]));
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[gb + 62512 + 8 >> 2]));
 i3 = f6 < Math_fround(0.0);
 f9 = Math_fround(-f6);
 f6 = i3 ? f9 : f6;
 i3 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i3 ? f9 : f8;
 i3 = f7 < Math_fround(0.0);
 f9 = Math_fround(-f7);
 f7 = i3 ? f9 : f7;
 f6 = f6 < f8 ? f8 : f6;
 f6 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * (f6 < f7 ? f7 : f6));
 i3 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i3 ? f7 : f6;
 i3 = f6 < Math_fround(9.99999974e-06);
 f6 = i3 ? Math_fround(9.99999974e-06) : f6;
 HEAP32[i4 >> 2] = 0;
 HEAPF32[i4 + 4 >> 2] = f6;
 __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i1, i4, i2);
 STACKTOP = i5;
 return;
}

function __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 16 | 0;
 i2 = i5 + 4 | 0;
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = __ZnwjRK10MemLabelIdiPKci(72, i2, i3, gb + 1041912 | 0, 65) | 0;
  HEAP32[i1 >> 2] = gb + 189112 + 8;
  HEAP8[i1 + 4 >> 0] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i2 = i1 + 48 | 0;
  i3 = i1 + 16 | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i1 + 68 >> 2] = 0;
  __ZN19UnityConnectService23RegisterGlobalCallbacksEv(i1);
  HEAP32[i5 >> 2] = i1;
  return;
 } else {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(72, i2, i3, i1, i5 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i2 >> 2] = gb + 189112 + 8;
  HEAP8[i2 + 4 >> 0] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  i1 = i2 + 48 | 0;
  i3 = i2 + 16 | 0;
  i4 = i3 + 44 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP32[i2 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i2 + 68 >> 2] = 0;
  __ZN19UnityConnectService23RegisterGlobalCallbacksEv(i2);
  __Z19pop_allocation_rootv();
  HEAP32[i5 >> 2] = i2;
  return;
 }
}

function __Z39MonoBehaviour_CUSTOM_StopCoroutine_AutoP12Il2CppObjectS0_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i5 = (i4 | 0) == 0;
 if (i5) i1 = 0; else i1 = HEAP32[i4 + 8 >> 2] | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549162 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549162 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (i5) {
  i7 = 0;
  __ZN13MonoBehaviour20StopCoroutineManagedEP9Coroutine(i1, i7);
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i4 + 8 >> 2] | 0;
 __ZN13MonoBehaviour20StopCoroutineManagedEP9Coroutine(i1, i7);
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj121ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj120ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj165ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj164ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj163ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj162ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj160ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj159ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj158ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj157ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj144ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj142ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj(i5, i3, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc(i5, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 if (__ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_(i5, i4) | 0) mftCall_vif(i2 | 0, HEAP32[i5 + 24 >> 2] | 0, +Math_fround(HEAPF32[i4 >> 2]));
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  HEAP8[i5 + 36 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -1 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if (HEAP8[i4 + (i3 << 3) + 4 >> 0] | 0) if (HEAP8[i4 + (i3 << 3) + 5 >> 0] | 0) {
  i1 = HEAP32[i5 + 20 >> 2] | 0;
  mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1 + -1;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i5 + 36 | 0;
 HEAP8[i1 >> 0] = 1;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[(HEAP32[i2 + 4 >> 2] | 0) + (i3 + -1 << 3) + 5 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j(i5, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i1, gb + 1034411 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i7, i1 + 12 | 0, gb + 1034420 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i7, i1 + 28 | 0, gb + 932723 | 0, 0);
  __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i7, i1 + 40 | 0, gb + 932736 | 0, 0);
  i1 = i1 + 52 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i3 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = _llvm_bswap_i32(i1 | 0) | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i9 = i3 + 8 | 0;
  i2 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
 }
 HEAP32[i5 >> 2] = 0;
 __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i4, i1, i5, 1);
 i1 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[i4 + 12 >> 2] | 0;
 i4 = i1 + (i9 << 2) | 0;
 if (!i9) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17CapsuleCollider2D7SetSizeERK8Vector2f(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i7 + 160 | 0;
 f9 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f5 - Math_fround(HEAPF32[i4 >> 2]));
 i6 = i1 + 4 | 0;
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i2 = i7 + 164 | 0;
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i2 >> 2]));
 if (Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) <= Math_fround(f9 * f9)) {
  STACKTOP = i8;
  return;
 }
 HEAPF32[i3 >> 2] = Math_fround(.0000999999974);
 i12 = f5 > Math_fround(.0000999999974);
 HEAP32[i4 >> 2] = HEAP32[(i12 ? i1 : i3) >> 2];
 HEAPF32[i3 >> 2] = Math_fround(.0000999999974);
 i1 = Math_fround(HEAPF32[i6 >> 2]) > Math_fround(.0000999999974);
 HEAP32[i2 >> 2] = HEAP32[(i1 ? i6 : i3) >> 2];
 __ZN10Collider2D19WakeAllBodyContactsEv(i7);
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i12 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i7, i12);
  if (!i12) {
   STACKTOP = i8;
   return;
  }
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0, 0);
  STACKTOP = i8;
  return;
 }
 __ZN10Collider2D7CleanupEb(i7, 0);
 STACKTOP = i8;
 return;
}

function __ZN15TerrainRenderer11RenderStep1EPK6Cameraiff(i2, i3, i1, f4, f5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i8 + 16 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i9 = HEAP32[i2 + 28 >> 2] | 0;
  i1 = (i9 | 0) < (i1 | 0) ? i9 : i1;
 }
 f11 = Math_fround(__ZNK6Camera7GetNearEv(i3));
 f10 = Math_fround(f11 * Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(__ZNK6Camera6GetFovEv(i3)) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)))));
 __ZNK6Camera13GetCameraRectEb(i6, i3, 1);
 f4 = Math_fround(Math_fround(f11 / Math_fround(Math_abs(Math_fround(f10)))) / Math_fround(Math_fround(f4 * Math_fround(2.0)) / Math_fround(HEAPF32[i6 + 12 >> 2])));
 i9 = (HEAP32[i2 + 20 >> 2] | 0) + -64 | 0;
 i6 = i2 + 48 | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 60 >> 2] = i1;
 HEAPF32[i2 + 64 >> 2] = f4;
 HEAPF32[i2 + 68 >> 2] = Math_fround(f5 * f5);
 __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i2, i9);
 STACKTOP = i8;
 return;
}

function __ZN14NavMeshCarvingD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (HEAP32[i7 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i7);
 i1 = i7 + 92 | 0;
 if ((HEAP32[i7 + 108 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 96 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i6 = i7 + 80 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i5 = i7 + 84 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -32 | 0;
    HEAP32[i5 >> 2] = i3;
    i4 = i2 + -20 | 0;
    if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
     HEAP32[i4 >> 2] = 0;
     i2 = HEAP32[i5 >> 2] | 0;
    } else i2 = i3;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i7 + 68 | 0, HEAP32[i7 + 72 >> 2] | 0);
 i1 = i7 + 48 | 0;
 if ((HEAP32[i7 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 28 | 0;
 if ((HEAP32[i7 + 44 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 32 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i7 + 8 | 0;
 if ((HEAP32[i7 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13RenderTexture7ReleaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 12 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 i6 = i7;
 i1 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, 0) | 0;
 if (!i1) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 352 >> 2] | 0, i1 | 0) | 0;
  if (!i1) i1 = 0; else i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
 } else i1 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
 if ((i1 | 0) != (i3 | 0)) {
  __ZN13RenderTexture15DestroySurfacesEv(i3);
  STACKTOP = i7;
  return;
 }
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406136 | 0, 0, gb + 406201 | 0, 634, 1, i1, 0, 0);
 HEAP32[i4 >> 2] = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i5, i2, i4, 0, -1, 0, 0) | 0;
 __ZN13RenderTexture15DestroySurfacesEv(i3);
 STACKTOP = i7;
 return;
}

function __ZN13BitSetUtility8CopyBitsEPKjjjPjj(i11, i1, i2, i12, i3) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 if (i2 >>> 0 > 63) {
  if (!((i3 ^ i1) & 31)) {
   i10 = i1 + 31 | 0;
   i7 = i10 & -32;
   i8 = i7 - i1 | 0;
   i9 = i8 + i3 | 0;
   if (i8 | 0) {
    i4 = 0;
    do {
     i5 = i4 + i3 | 0;
     i13 = i4 + i1 | 0;
     i6 = 1 << (i5 & 31);
     if (!(HEAP32[i11 + (i13 >>> 5 << 2) >> 2] & 1 << (i13 & 31))) {
      i13 = i12 + (i5 >>> 5 << 2) | 0;
      HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & ~i6;
     } else {
      i13 = i12 + (i5 >>> 5 << 2) | 0;
      HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | i6;
     }
     i4 = i4 + 1 | 0;
    } while ((i4 | 0) != (i8 | 0));
   }
   i1 = (i2 - i8 | 0) >>> 5;
   if (i1 | 0) _memcpy(i12 + (i9 >>> 5 << 2) | 0, i11 + (i10 >>> 5 << 2) | 0, i1 << 2 | 0) | 0;
   i1 = i1 << 5;
   i4 = i1 + i8 | 0;
   i1 = i1 + i7 | 0;
   i2 = i2 - i4 | 0;
   i3 = i4 + i3 | 0;
   i4 = 11;
  }
 } else i4 = 11;
 if ((i4 | 0) == 11) if (!i2) return;
 i4 = 0;
 do {
  i5 = i4 + i3 | 0;
  i13 = i4 + i1 | 0;
  i6 = 1 << (i5 & 31);
  if (!(HEAP32[i11 + (i13 >>> 5 << 2) >> 2] & 1 << (i13 & 31))) {
   i13 = i12 + (i5 >>> 5 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] & ~i6;
  } else {
   i13 = i12 + (i5 >>> 5 << 2) | 0;
   HEAP32[i13 >> 2] = HEAP32[i13 >> 2] | i6;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i2 | 0));
 return;
}

function __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) - i1 >> 5 >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i1 >> 5;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 << 5) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 << 5) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 << 5);
 __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -32 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -20 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim5human6Handle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 1085944 | 0, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_(i6 + 12 | 0, i1);
 __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i6 + 28 | 0, gb + 1085935 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
 }
 HEAP32[i6 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 44 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f7 = f0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i6 + 32 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f7);
 i4 = i5 + 4 | 0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i6 + 36 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f7);
 i2 = i5 + 8 | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i6 + 40 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f7);
 i3 = HEAP32[i6 + 156 >> 2] | 0;
 if (i3 | 0) if (HEAP8[i6 + 44 >> 0] & 1) if (HEAP8[i3 + 28 >> 0] | 0) {
  i6 = i3 + 16 | 0;
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i3 + 20 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  f7 = Math_fround(HEAPF32[i2 >> 2]);
  i6 = i3 + 24 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
 }
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i1 + 112 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = i1 + 116 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 i6 = i1 + 120 | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
 return;
}

function __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_(i1, i2, i3, i10, i12, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 1 | 0;
 i7 = i13;
 i1 = __ZNK5physx14SapPairManager8FindPairEjj(i3, i1, i2) | 0;
 if (!i1) {
  STACKTOP = i13;
  return;
 }
 i5 = i3 + 20 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i11 = i1;
 i8 = i3 + 24 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i1 + (i11 - i2 >> 3) | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 if (!(i4 & 1)) {
  HEAP8[i3 >> 0] = i4 & 255 | 1;
  i4 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i9 >> 2] | 0)) {
   i2 = (i1 | 0) == 0 ? 64 : i1 << 1;
   i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i2 << 2, gb + 716962 | 0, 200) | 0;
   _memcpy(i3 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, HEAP32[i10 >> 2] | 0);
   HEAP32[i10 >> 2] = i3;
   HEAP32[i9 >> 2] = i2;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i12 >> 2] | 0;
  } else {
   i2 = i4;
   i3 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i3 + (i1 << 2) >> 2] = (i11 - i4 | 0) >>> 3;
  HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i12 = i1 + (i11 - i2 >> 3) | 0;
 HEAP8[i12 >> 0] = HEAPU8[i12 >> 0] | 0 | 2;
 STACKTOP = i13;
 return;
}

function __ZN4File5CloseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i2 = 1; else if (__ZN12FileAccessor5CloseEv(i2) | 0) i2 = 1; else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 488684 | 0, 13);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZNK15FileSystemEntry4PathEv(HEAP32[i3 >> 2] | 0) | 0) | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 488614 | 0, 472, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i2 = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN13FileEntryDataD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
  HEAP32[i4 >> 2] = 0;
  i4 = i3 + 28 | 0;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i5;
  return i2 | 0;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i3 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return i2 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i2 - i1 >> 5;
 if (i3 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj(i4, i3 - i5 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else if (i3 >>> 0 < i5 >>> 0) {
  i3 = i1 + (i3 << 5) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -32 - i3 | 0) >>> 5) << 5) | 0;
   HEAP32[i6 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 16 | 0, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17AudioCustomFilter4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i9 + 108 | 0;
 i5 = i9 + 16 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i9;
  return;
 }
 i7 = i1 + 4 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i2 = i5 + 52 | 0;
 i3 = i5;
 i4 = i3 + 88 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = fb + 143;
 HEAP32[i5 + 88 >> 2] = i1;
 i2 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1459928 >> 2] | 0, 0, 0) | 0;
 i1 = __ZN4FMOD6System9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE(HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i5, i7) | 0;
 if (i1 | 0) {
  i5 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i8 >> 2] = gb + 855251;
  HEAP32[i8 + 4 >> 2] = 86;
  HEAP32[i8 + 8 >> 2] = gb + 872869;
  HEAP32[i8 + 12 >> 2] = i5;
  __Z6FormatPKcz(i6, gb + 883334 | 0, i8);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 }
 __ZN4FMOD3DSP9setBypassEb(HEAP32[i7 >> 2] | 0, 1) | 0;
 if (i2) __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __Z16CullDynamicSceneR8JobFenceS0_RK22SceneCullingParametersR13CullingOutput(i5, i6, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 60 | 0;
 if (!(HEAP8[i10 >> 0] | 0)) i3 = 0; else {
  i3 = __Z9GetIUmbrav() | 0;
  i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, HEAP32[i9 + 64 >> 2] | 0) | 0;
 }
 i4 = 0;
 do {
  i1 = i8 + 752 + (i4 * 12 | 0) + 8 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i7 = __ZnwjRK10MemLabelIdiPKci(220, gb + 64024 | 0, 16, gb + 384140 | 0, 128) | 0;
   HEAP32[i7 >> 2] = i8;
   HEAP32[i7 + 8 >> 2] = i8 + 752 + (i4 * 12 | 0);
   HEAP32[i7 + 20 >> 2] = i9 + (i4 * 12 | 0);
   HEAP32[i7 + 12 >> 2] = i10;
   HEAP32[i7 + 4 >> 2] = i3;
   HEAP32[i7 + 16 >> 2] = i4;
   if (!i4) {
    i2 = i7 + 24 | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    if (!(HEAP8[i10 >> 0] | 0)) i11 = 10; else {
     i1 = __Z20ConfigureBlockRangesP10BlockRangeii(i2, i1, 1) | 0;
     HEAP32[i7 + 216 >> 2] = i1;
    }
   } else {
    i2 = i7 + 24 | 0;
    i1 = HEAP32[i1 >> 2] | 0;
    i11 = 10;
   }
   if ((i11 | 0) == 10) {
    i11 = 0;
    i1 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i2, i1, 256) | 0;
    HEAP32[i7 + 216 >> 2] = i1;
   }
   __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i5, fb + 2384 | 0, i7, i1, i6, fb + 3333 | 0, 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 5);
 return;
}

function __ZN8Animator17GetAvatarRotationEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
  return;
 } else {
  i1 = HEAP32[i1 + 136 >> 2] | 0;
  f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
  f12 = Math_fround(f10 * f10);
  f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
  f2 = Math_fround(f9 * f9);
  f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f7 = Math_fround(f8 * f8);
  f11 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f7 = Math_fround(Math_fround(f12 + f2) + Math_fround(f7 + Math_fround(f11 * f11)));
  f2 = Math_fround(Math_sqrt(Math_fround(f7)));
  f10 = Math_fround(f10 / f2);
  f9 = Math_fround(f9 / f2);
  f8 = Math_fround(f8 / f2);
  f2 = Math_fround(f11 / f2);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
  i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
  i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  i5 = f7 > Math_fround(1.0e-30);
  i13 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
  HEAP32[i6 >> 2] = i5 ? i1 : 0;
  HEAP32[i6 + 4 >> 2] = i5 ? i3 : 0;
  HEAP32[i6 + 8 >> 2] = i5 ? i4 : 0;
  HEAP32[i6 + 12 >> 2] = i13;
  return;
 }
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = i4 >>> 16 & 255;
  f3 = Math_fround(Math_fround((i4 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  f3 = Math_fround(Math_fround(i5 >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  if (!i1) break; else {
   i7 = i7 + 4 | 0;
   i6 = i6 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE8recreateEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 do if (!i7) i4 = 0; else {
  i1 = i8 + 5 | 0;
  if (i7 >>> 0 < 6 & (HEAP8[i1 >> 0] | 0) == 0) {
   HEAP8[i1 >> 0] = 1;
   i4 = i8;
   break;
  } else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i5 | 0, i6 | 0, i7 | 0, (i4 ? gb + 832410 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
   break;
  }
 } while (0);
 i2 = HEAP32[i8 + 12 >> 2] | 0;
 i3 = i4 + i2 | 0;
 i5 = i8 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = i6;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 i1 = i8 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i7;
  return;
 }
 if ((i8 | 0) == (i6 | 0)) {
  HEAP8[i8 + 5 >> 0] = 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i7;
  return;
 }
 if (!i6) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i7;
  return;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i6 | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i7;
 return;
}

function _cf2_glyphpath_pushMove(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 + 32 >> 2] = 1;
 i5 = i3 + 11728 | 0;
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 if (!(HEAP8[i3 + 20 >> 0] | 0)) _cf2_glyphpath_moveTo(i3, HEAP32[i3 + 11736 >> 2] | 0, HEAP32[i3 + 11740 >> 2] | 0);
 i7 = i4 + 8 | 0;
 i8 = _UNITY_FT_MulFix(HEAP32[i3 + 11644 >> 2] | 0, i1) | 0;
 i8 = (_UNITY_FT_MulFix(HEAP32[i3 + 11648 >> 2] | 0, i2) | 0) + i8 | 0;
 i9 = _cf2_hintmap_map(i3 + 8 | 0, i2) | 0;
 i10 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i8) | 0;
 i10 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i9) | 0) + i10 | 0;
 HEAP32[i7 >> 2] = i10 + (HEAP32[i3 + 11656 >> 2] | 0);
 i8 = _UNITY_FT_MulFix(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i8) | 0;
 i8 = (_UNITY_FT_MulFix(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i9) | 0) + i8 | 0;
 HEAP32[i4 + 12 >> 2] = i8 + (HEAP32[i3 + 11660 >> 2] | 0);
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[i8 >> 2] | 0, i8 | 0, i4 | 0);
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i3 + 11704 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function _block_prepare_used(i7, i5, i3) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i5) {
  i9 = 0;
  return i9 | 0;
 }
 i8 = i5 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 & -4;
 i9 = i5 + 8 | 0;
 if (i4 >>> 0 < (i3 + 16 | 0) >>> 0) i1 = i9; else {
  i1 = i9;
  i6 = i3 + -4 + i1 | 0;
  i2 = i6 + 4 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 3 | -4 - i3 + i4;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & 3 | i3;
  i4 = i6 + 8 | 0;
  i3 = ((HEAP32[i2 >> 2] | 0) + -4 & -4) + i4 | 0;
  HEAP32[i3 >> 2] = i6;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i3 | 1;
  HEAP32[((HEAP32[i8 >> 2] | 0) + -4 & -4) + i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i3 | 3;
  i2 = i3 & -4;
  if (i2 >>> 0 < 128) {
   i2 = i3 >>> 2;
   i3 = 0;
  } else {
   i3 = 31 - (Math_clz32(i2 | 0) | 0) | 0;
   i2 = i2 >>> (i3 + -5 | 0) ^ 32;
   i3 = i3 + -6 | 0;
  }
  i5 = i7 + 116 + (i3 << 7) + (i2 << 2) | 0;
  i10 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 >> 2] = i10;
  HEAP32[i6 + 12 >> 2] = i7;
  HEAP32[i10 + 12 >> 2] = i6;
  HEAP32[i5 >> 2] = i6;
  i6 = i7 + 16 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << i3;
  i7 = i7 + 20 + (i3 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << i2;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i10 = (i2 + -4 & -4) + i1 + 4 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -3;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -2;
 i10 = i9;
 return i10 | 0;
}

function __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i5 = i8 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i9 + 4 | 0;
  i7 = i9 + 4 | 0;
  do {
   i4 = i2 + -132 | 0;
   HEAP32[i5 >> 2] = i4;
   i3 = i2 + -36 | 0;
   if ((HEAP32[i2 + -20 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -32 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -116 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -104 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
   }
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i2 + -120 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i7 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i11 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 25;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __ZNK8VRDevice21GetShowVRSplashScreenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 i2 = i5;
 if (__Z25GetShouldShowSplashScreenv() | 0) {
  i6 = 1;
  STACKTOP = i5;
  return i6 | 0;
 }
 i4 = HEAP32[(__Z17GetPlayerSettingsv() | 0) + 260 >> 2] | 0;
 if (!i4) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i6 = 8; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 10;
  }
 }
 if ((i6 | 0) == 8) i6 = 10;
 if ((i6 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = (i1 | 0) != 0;
 STACKTOP = i5;
 return i7 | 0;
}

function __GLOBAL__sub_I_runtime_unityconnect_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1468944 >> 2] = 0;
 i3 = gb + 63160 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1468944 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468944 + 12 >> 2] = 16;
 i1 = gb + 1468944 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3939 | 0, fb + 3940 | 0, 0, gb + 1468944 | 0);
 HEAP32[gb + 1469024 >> 2] = 0;
 i3 = gb + 63160 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1469024 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1469024 + 12 >> 2] = 16;
 i1 = gb + 1469024 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(0, fb + 3941 | 0, 0, gb + 1469024 | 0);
 HEAP32[gb + 1469104 >> 2] = 0;
 i3 = gb + 63160 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1469104 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1469104 + 12 >> 2] = 16;
 i1 = gb + 1469104 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3942 | 0, fb + 3943 | 0, 0, gb + 1469104 | 0);
 return;
}

function __ZNK13TriggerEvents10SendEventsER14ParticleSystemR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i4, i6, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, i11 = 0, f12 = f0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1105116 | 0, i3);
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i6 + 520 >> 2] | 0;
 i1 = 0;
 do {
  i11 = i2 + (i1 << 2) | 0;
  f12 = Math_fround(HEAPF32[i11 >> 2]);
  i9 = i11 + 4 | 0;
  f10 = Math_fround(HEAPF32[i9 >> 2]);
  i4 = i11 + 8 | 0;
  f8 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i11 + 12 | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  i13 = f12 < Math_fround(100.000008);
  f12 = i13 ? f12 : Math_fround(100.000008);
  i13 = f10 < Math_fround(100.000008);
  f10 = i13 ? f10 : Math_fround(100.000008);
  i13 = f8 < Math_fround(100.000008);
  f8 = i13 ? f8 : Math_fround(100.000008);
  i13 = f7 < Math_fround(100.000008);
  f7 = i13 ? f7 : Math_fround(100.000008);
  HEAPF32[i11 >> 2] = f12;
  HEAPF32[i9 >> 2] = f10;
  HEAPF32[i4 >> 2] = f8;
  HEAPF32[i6 >> 2] = f7;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 STACKTOP = i5;
 return;
}

function __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0, i17 = 0;
 i10 = i1 + 32 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i7 = HEAP32[i10 + 8 >> 2] | 0;
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = i7 + (i9 * 40 | 0) | 0;
 f15 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i7 + (i9 * 40 | 0) + 4 | 0;
 f14 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + (i9 * 40 | 0) + 8 | 0;
 i8 = f13 != f15 | f12 != f14 | f11 != Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i5 >> 2] = f13;
 HEAPF32[i6 >> 2] = f12;
 HEAPF32[i7 >> 2] = f11;
 if (!i8) return;
 i3 = HEAP32[i10 + 40 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i10 + 16 >> 2] | 0) + (i9 << 2) >> 2] | 0;
 if (i4 | 0) {
  i5 = HEAP32[i10 + 60 >> 2] | 0;
  i6 = HEAP32[i10 + 56 >> 2] | 0;
  i7 = i10 + 36 | 0;
  i8 = HEAP32[i10 + 68 >> 2] | 0;
  i1 = 0;
  i2 = i9;
  while (1) {
   i16 = HEAP32[i5 + (i2 << 2) >> 2] & i3;
   i17 = i6 + (i2 << 2) | 0;
   HEAP32[i17 >> 2] = HEAP32[i17 >> 2] | i16;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i16;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i2 = HEAP32[i8 + (i2 << 2) >> 2] | 0;
  }
 }
 i17 = (HEAP32[i10 + 28 >> 2] | 0) + i9 | 0;
 HEAP8[i17 >> 0] = HEAPU8[i17 >> 0] | 0 | 1;
 return;
}

function __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i8 >> 2] = i9;
 i7 = HEAP32[i9 >> 2] | 0;
 i3 = i10 + 132 | 0;
 i4 = (i7 + 32 | 0) >>> 5;
 i5 = i10 + 136 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i6 = i10 + 140 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i4 << 2, gb + 769739 | 0, 329) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) {
   _memcpy(i1 | 0, i2 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i3 >> 2] | 0);
  }
  i6 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i6 & 2147483647) << 2) | 0, 0, i4 - i6 << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 } else i1 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + (i7 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << (i7 & 31));
 i1 = i10 + 120 | 0;
 i2 = i10 + 124 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i10 + 128 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i9;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i11;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i8) | 0;
  STACKTOP = i11;
  return;
 }
}

function __ZN34ColorBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 do switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 152 >> 0] = ~~f4;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 153 >> 0] = ~~f4;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 154 >> 0] = ~~f4;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 155 >> 0] = ~~f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 156 >> 0] = ~~f4;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 157 >> 0] = ~~f4;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 158 >> 0] = ~~f4;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 159 >> 0] = ~~f4;
   return;
  }
 case 8:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 900 >> 2] | 0) + 164 >> 2] = f4;
   return;
  }
 case 9:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 900 >> 2] | 0) + 168 >> 2] = f4;
   return;
  }
 default:
  return;
 } while (0);
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i7, i8, i1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i7, i5, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 i7 = i5 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8 + 4 | 0, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 if ((HEAP8[i7 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i4);
 STACKTOP = i6;
 return;
}

function __ZN17PersistentManager22HasPreallocatedObjectsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i7 + 168 >> 2] | 0;
 i8 = HEAP32[i7 + 172 >> 2] | 0;
 i9 = i1 + (i8 * 20 | 0) | 0;
 L1 : do if (i8) {
  i5 = HEAP32[i7 + 148 >> 2] | 0;
  i6 = i7 + 124 | 0;
  i3 = i7 + 120 | 0;
  i4 = i7 + 128 | 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break L1;
    if (!(HEAP32[i3 >> 2] | 0)) break L1;
    if ((HEAP32[i4 >> 2] | 0) != (i2 | 0)) break L1;
   }
   i1 = i1 + 20 | 0;
   if ((i1 | 0) == (i9 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i9 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i5 = i7 + 148 | 0;
 i6 = i7 + 124 | 0;
 i8 = i7 + 120 | 0;
 i4 = i7 + 128 | 0;
 L15 : while (1) {
  if ((HEAP8[i1 + 18 >> 0] | 0) != 1) {
   i1 = 1;
   i2 = 19;
   break;
  }
  i1 = i1 + 20 | 0;
  if ((i1 | 0) == (i9 | 0)) {
   i1 = 0;
   i2 = 19;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break;
    if (!(HEAP32[i8 >> 2] | 0)) break;
    if ((HEAP32[i4 >> 2] | 0) != (i2 | 0)) break;
   }
   i1 = i1 + 20 | 0;
   if ((i1 | 0) == (i9 | 0)) {
    i1 = 0;
    i2 = 19;
    break L15;
   }
  }
  if ((i1 | 0) == (i9 | 0)) {
   i1 = 0;
   i2 = 19;
   break;
  }
 }
 if ((i2 | 0) == 19) return i1 | 0;
 return 0;
}

function __ZN13BoxCollider2D7SetSizeERK8Vector2f(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i7 + 160 | 0;
 f9 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f11 = Math_fround(f5 - Math_fround(HEAPF32[i4 >> 2]));
 i6 = i1 + 4 | 0;
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i2 = i7 + 164 | 0;
 f10 = Math_fround(f10 - Math_fround(HEAPF32[i2 >> 2]));
 if (Math_fround(Math_fround(f11 * f11) + Math_fround(f10 * f10)) <= Math_fround(f9 * f9)) {
  STACKTOP = i8;
  return;
 }
 HEAPF32[i3 >> 2] = Math_fround(.0000999999974);
 i12 = f5 > Math_fround(.0000999999974);
 HEAP32[i4 >> 2] = HEAP32[(i12 ? i1 : i3) >> 2];
 HEAPF32[i3 >> 2] = Math_fround(.0000999999974);
 i1 = Math_fround(HEAPF32[i6 >> 2]) > Math_fround(.0000999999974);
 HEAP32[i2 >> 2] = HEAP32[(i1 ? i6 : i3) >> 2];
 __ZN10Collider2D19WakeAllBodyContactsEv(i7);
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i12 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i7, i12);
  if (!i12) {
   STACKTOP = i8;
   return;
  }
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 140 >> 2] | 0, i7 | 0, 0);
  STACKTOP = i8;
  return;
 }
 __ZN10Collider2D7CleanupEb(i7, 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sq16BucketPrunerCore10resizeCoreEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? 32 : i6 << 1;
 HEAP32[i4 >> 2] = i6;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9 + 5 | 0, i6 * 24 | 0, gb + 710466 | 0, 523) | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9 + 4 | 0, i6 << 3, gb + 710466 | 0, 524) | 0;
 i6 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9 + 3 | 0, i6 << 2, gb + 710466 | 0, 525) | 0;
 i7 = i8 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  _memcpy(i4 | 0, i1 | 0, (HEAP32[i8 >> 2] | 0) * 24 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9 + 2 | 0, HEAP32[i7 >> 2] | 0);
 }
 i3 = i8 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  _memcpy(i5 | 0, i1 | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9 + 1 | 0, HEAP32[i3 >> 2] | 0);
 }
 i1 = i8 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i8 = i1;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i8 >> 2] = i6;
  STACKTOP = i9;
  return;
 } else {
  _memcpy(i6 | 0, i2 | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i1 >> 2] | 0);
  i8 = i1;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i8 >> 2] = i6;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx2Sn21SerializationRegistry20unregisterSerializerEt(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i9 + 4 | 0;
 HEAP16[i5 >> 1] = i7;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i4 = i7 & 65535;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i6 + 20 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = 0; else {
   i4 = HEAP32[i6 + 12 >> 2] | 0;
   i3 = i6 + 16 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if ((HEAP16[i2 >> 1] | 0) == i7 << 16 >> 16) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i1 = 0;
     break L1;
    }
   }
   if (!i2) i1 = 0; else i1 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
  }
 } while (0);
 if (__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i6 + 8 | 0, i5) | 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 i6 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i8 >> 2] = i7 & 65535;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i6, 2, gb + 667371 | 0, 175, gb + 668007 | 0, i8);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i4 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i2 - i1 >> 4;
 if (i3 >>> 0 > i5 >>> 0) {
  __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj(i4, i3 - i5 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else if (i3 >>> 0 < i5 >>> 0) {
  i3 = i1 + (i3 << 4) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4) | 0;
   HEAP32[i6 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i1, i9);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17UniqueIDGenerator8CreateIDEv(i10, i2) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i2 + 20 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i6 = i2 + 12 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i7 = i1 + 1 | 0;
  i8 = i7 & 16777215;
  i9 = i2 + 16 | 0;
  i4 = HEAP32[i9 >> 2] | 0;
  i5 = i4 & 2147483647;
  do if (i7 >>> 0 > i5 >>> 0) {
   i3 = i4 << 1;
   i3 = (i3 | 0) == 0 ? 1 : i3;
   if (i5 >>> 0 < i3 >>> 0) if ((i4 | 0) > -1) {
    HEAP32[i9 >> 2] = i3;
    HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i3 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    HEAP32[i9 >> 2] = i3;
    HEAP32[i2 >> 2] = i5;
    break;
   }
  } while (0);
  HEAP32[i6 >> 2] = i7;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i8;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 i8 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i11 >> 2] = i9 & 16777215;
 i11 = i1 & 16777215;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -16777216 | i11;
 i8 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
 i9 = i9 + 16777216 & -16777216;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & 16777215 | i9;
 HEAP32[i10 >> 2] = i9 | i11;
 return;
}

function __ZN16MBPOS_TmpBuffers16allocateSleepingEjj(i4, i9, i2) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i4 + 12800 | 0;
 if ((HEAP32[i7 >> 2] | 0) >>> 0 >= i9 >>> 0) {
  STACKTOP = i10;
  return;
 }
 i8 = i4 + 12808 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i3 = i4 + 12288 | 0;
 if (!((i1 | 0) == (i3 | 0) | (i1 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 1 | 0, i1);
  HEAP32[i8 >> 2] = 0;
 }
 i5 = i4 + 12812 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!((i1 | 0) == (i4 | 0) | (i1 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i10 + 2 | 0, i1);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i2 + i9 | 0;
 if (i1 >>> 0 < 257) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i8 >> 2] = i3;
 } else {
  i1 = i1 >>> 0 > 178956970 ? -1 : i1 * 24 | 0;
  if (!i1) i1 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i1 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1874) | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i8 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i9 << 1, gb + 717183 | 0, 1876) | 0;
 }
 HEAP32[i7 >> 2] = i9;
 STACKTOP = i10;
 return;
}

function __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085944 | 0, gb + 906560 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1084124 | 0, gb + 906539 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1085935 | 0, gb + 906560 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN12b2MotorJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, d10 = 0.0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 80 | 0;
 i4 = i2 + 72 | 0;
 i5 = i2 + 64 | 0;
 i6 = i2 + 56 | 0;
 i7 = i2 + 48 | 0;
 i8 = i2 + 32 | 0;
 i11 = i2 + 24 | 0;
 i12 = i2 + 16 | 0;
 i14 = i2 + 8 | 0;
 i15 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i13 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 799835 | 0, i2);
 HEAP32[i14 >> 2] = i15;
 __Z5b2LogPKcz(gb + 799360 | 0, i14);
 HEAP32[i12 >> 2] = i13;
 __Z5b2LogPKcz(gb + 799386 | 0, i12);
 HEAP32[i11 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i11);
 d10 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d9 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i8 >> 3] = d10;
 HEAPF64[i8 + 8 >> 3] = d9;
 __Z5b2LogPKcz(gb + 799858 | 0, i8);
 HEAPF64[i7 >> 3] = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 __Z5b2LogPKcz(gb + 799900 | 0, i7);
 HEAPF64[i6 >> 3] = +Math_fround(HEAPF32[i1 + 92 >> 2]);
 __Z5b2LogPKcz(gb + 799683 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 96 >> 2]);
 __Z5b2LogPKcz(gb + 799709 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 100 >> 2]);
 __Z5b2LogPKcz(gb + 799931 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN9LensFlare8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN4PPtrI5FlareE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 36 | 0, i1);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 40 | 0, i1);
 i3 = i7 + 56 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  return;
 }
}

function __ZN5physx28solveConcludeContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = HEAP16[i2 + 26 >> 1] | 0;
 i9 = i1 + ((i8 & 65535) << 4) | 0;
 if (!(i8 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i8 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i7 = 32;
   i2 = i3;
   i3 = i4;
  } else {
   i6 = i2 & 255;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    i10 = f5 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i10 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i3 = (Math_imul(i7, i6) | 0) + 32 | 0;
   i7 = i3;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + i3 | 0;
  }
  i6 = i2 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i8 << 24 >> 24)) i1 = i3; else {
   i4 = i8 & 255;
   i2 = i3;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i6 | 0;
   }
   i1 = i1 + ((Math_imul(i6, i4) | 0) + i7) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN5physx14NpRigidDynamic9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb(i8, i2, i1, i3) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, i7 = 0, f9 = f0;
 i7 = i8 + 48 | 0;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i8, 0, i2, i1);
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i2 + 4 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i2 + 8 >> 2]) != Math_fround(0.0); else i1 = 1; else i1 = 1;
 f9 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i8) | 0) + 2876 >> 2]);
 i4 = i8 + 276 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i8 + 280 | 0;
 i2 = f6 < f9 & i3;
 f6 = i2 ? f9 : f6;
 if (!(i2 | (i1 | i3) & (HEAP32[i5 >> 2] | 0) != 0)) return;
 switch ((HEAP32[i8 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = 9;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 8; else i2 = 9;
   break;
  }
 default:
  i2 = 8;
 }
 if ((i2 | 0) == 8) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i8 + 64 | 0, f6, 1);
  return;
 } else if ((i2 | 0) == 9) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i7);
  i8 = i8 + 284 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN21AssetReferenceStorage22GarbageCollectCallbackER27GarbageCollectorThreadState(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i7 = HEAP32[gb + 1162408 >> 2] | 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i8 = HEAP32[i7 + 32 >> 2] | 0;
 i10 = i1 + (i8 << 3) | 0;
 L1 : do if (i8) {
  i6 = HEAP32[i7 + 20 >> 2] | 0;
  i3 = i7 + 8 | 0;
  i4 = i7 + 4 | 0;
  i5 = i7 + 12 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i6 | 0) != (i2 | 0)) {
    if (!(HEAP8[i3 >> 0] | 0)) break L1;
    if (!(HEAP32[i4 >> 2] | 0)) break L1;
    if ((HEAP32[i5 >> 2] | 0) != (i2 | 0)) break L1;
   }
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i10 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i10 | 0)) return;
 i5 = i7 + 20 | 0;
 i6 = i7 + 8 | 0;
 i8 = i7 + 4 | 0;
 i4 = i7 + 12 | 0;
 i2 = i1;
 i1 = HEAP32[i1 >> 2] | 0;
 L15 : while (1) {
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(i1, i9);
  i1 = i2 + 8 | 0;
  if ((i1 | 0) == (i10 | 0)) {
   i1 = 18;
   break;
  }
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) {
    if (!(HEAP8[i6 >> 0] | 0)) break;
    if (!(HEAP32[i8 >> 2] | 0)) break;
    if ((HEAP32[i4 >> 2] | 0) != (i1 | 0)) break;
   }
   i1 = i2 + 8 | 0;
   if ((i1 | 0) == (i10 | 0)) {
    i1 = 18;
    break L15;
   } else i2 = i1;
  }
  if ((i2 | 0) == (i10 | 0)) {
   i1 = 18;
   break;
  }
 }
 if ((i1 | 0) == 18) return;
}

function __ZN17ProceduralTextureC2E10MemLabelId18ObjectCreationMode(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 >> 2] = gb + 59360 + 8;
 i1 = i4 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 62;
 i1 = i4 + 140 | 0;
 i2 = i4 + 104 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 62;
 HEAP32[i4 + 144 >> 2] = 0;
 i8 = i4 + 152 | 0;
 HEAP32[i4 + 176 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i4 + 180 >> 0] = 1;
 HEAP8[i4 + 181 >> 0] = 0;
 HEAP32[i4 + 184 >> 2] = 0;
 i8 = i4 + 192 | 0;
 HEAP32[i4 + 216 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP8[i8 + 20 >> 0] = 0;
 HEAP8[i4 + 224 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __Z9TrimCharsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i2 = HEAP8[i9 + 11 >> 0] | 0;
 i5 = i2 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i9 >> 2] | 0 : i9;
 i2 = i5 ? HEAP32[i9 + 4 >> 2] | 0 : i2 & 255;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i4 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
 L1 : do if (i2 | 0) {
  i1 = i6 + i2 | 0;
  i3 = (i5 | 0) == 0;
  L3 : do if (i3) i2 = i6; else {
   i2 = i6;
   while (1) {
    if (!(_memchr(i7, HEAPU8[i2 >> 0] | 0, i5) | 0)) break L3;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i1 | 0)) break L1;
   }
  } while (0);
  i4 = i6;
  i2 = i2 - i4 | 0;
  if ((i2 | 0) != -1) {
   L9 : do if (i3) {
    i1 = i1 + -1 | 0;
    i10 = 11;
   } else while (1) {
    if ((i1 | 0) == (i6 | 0)) {
     i1 = -1;
     break L9;
    }
    i1 = i1 + -1 | 0;
    if (!(_memchr(i7, HEAPU8[i1 >> 0] | 0, i5) | 0)) {
     i10 = 11;
     break;
    }
   } while (0);
   if ((i10 | 0) == 11) i1 = i1 - i4 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i8, i9, i2, 1 - i2 + i1 | 0, i9);
   return;
  }
 } while (0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, gb + 1576256 | 0, 0);
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i1 = 1 - i1 | 0;
 i16 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f10 = Math_fround(HEAPF32[i16 + (i1 << 4) >> 2]);
 f12 = Math_fround(HEAPF32[i16 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + (i1 << 4) + 8 >> 2]);
 i1 = HEAP32[i16 + (i1 << 4) + 12 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 152 >> 2]);
 f9 = Math_fround(-f15);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f9 = HEAP32[gb + 48 + (i2 << 4) >> 2] | 0 ? f15 : f9;
 f8 = HEAP32[gb + 48 + (i2 << 4) + 4 >> 2] | 0 ? f14 : f8;
 f7 = HEAP32[gb + 48 + (i2 << 4) + 8 >> 2] | 0 ? f13 : f7;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9Animation13SyncLayerTimeEi(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, f12 = f0, f13 = f0, i14 = 0;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 i10 = i1 + 108 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = (i3 | 0) == (i1 | 0);
 if (i9) return; else {
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  i7 = i3;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i11 | 0)) if (HEAP16[i2 + 56 >> 1] & 2) {
   f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   i14 = f8 < Math_fround(0.0);
   f8 = i14 ? Math_fround(0.0) : f8;
   f13 = Math_fround(HEAPF32[i2 + 36 >> 2]);
   f12 = Math_fround(HEAPF32[i2 + 92 >> 2]);
   f4 = Math_fround(f4 + Math_fround(f8 * Math_fround(f13 / f12)));
   f5 = Math_fround(f5 + Math_fround(f8 * Math_fround(+HEAPF64[i2 + 16 >> 3] / +f12)));
   f6 = Math_fround(f6 + f8);
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) != (i1 | 0));
 if (!(f6 > Math_fround(.0000999999974))) return;
 f8 = Math_fround(f4 / f6);
 f4 = Math_fround(f5 / f6);
 if (i9) return;
 do {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i11 | 0)) if (HEAP16[i2 + 56 >> 1] & 2) {
   f13 = Math_fround(HEAPF32[i2 + 92 >> 2]);
   HEAPF32[i2 + 40 >> 2] = Math_fround(f8 * f13);
   __ZN14AnimationState7SetTimeEf(i2, Math_fround(f4 * f13));
   i1 = HEAP32[i10 >> 2] | 0;
  }
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i1 | 0));
 return;
}

function __ZN5physx37PxSimulationStatisticsGeneratedValuesC2EPKNS_22PxSimulationStatisticsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 872 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 876 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 880 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 884 >> 2];
 _memcpy(i2 + 52 | 0, i1 + 88 | 0, 196) | 0;
 _memcpy(i2 + 248 | 0, i1 + 480 | 0, 196) | 0;
 _memcpy(i2 + 444 | 0, i1 + 284 | 0, 196) | 0;
 _memcpy(i2 + 640 | 0, i1 + 676 | 0, 196) | 0;
 i3 = i2 + 836 | 0;
 i4 = i1 + 64 | 0;
 i5 = i3 + 12 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 848 | 0;
 i4 = i1 + 76 | 0;
 i5 = i3 + 12 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 860 | 0;
 i4 = i1 + 20 | 0;
 i5 = i3 + 28 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 return;
}

function __ZN5physx2Sc10NPhaseCore27resizeContactReportPairDataEjjRNS0_20ContactStreamManagerE(i2, i12, i1, i11) {
 i2 = i2 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13;
 i2 = i2 + 44 | 0;
 i10 = (((i1 & 15 | 0) != 0 & 1) << 4) + i1 | 0;
 i7 = i10 & -16;
 i8 = __ZN5physx2Sc19ContactReportBuffer23reallocateNotThreadSafeEjRjjj(i2, i7 + (i12 << 5) | 0, i6, 16, HEAP32[i11 >> 2] | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i2 + i3 | 0;
 if (!i8) {
  STACKTOP = i13;
  return i8 | 0;
 }
 i9 = i11 + 10 | 0;
 i5 = (HEAPU16[i9 >> 1] | 0) >>> 5 << 4;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = i7 >>> 0 > i5 >>> 0;
 if ((i3 | 0) == (i1 | 0)) {
  if (i6) _memcpy(i8 + i7 | 0, i2 + (i5 + i3) | 0, (HEAPU16[i11 + 6 >> 1] | 0) << 5 | 0) | 0;
 } else {
  if (i6) {
   _memcpy(i8 | 0, i4 | 0, HEAPU16[i11 + 8 >> 1] | 0 | 0) | 0;
   _memcpy(i8 + i7 | 0, i2 + (i5 + i3) | 0, (HEAPU16[i11 + 6 >> 1] | 0) << 5 | 0) | 0;
  } else _memcpy(i8 | 0, i4 | 0, ((HEAPU16[i11 + 6 >> 1] | 0) << 5) + i5 | 0) | 0;
  HEAP32[i11 >> 2] = i1;
 }
 i1 = i11 + 4 | 0;
 if ((HEAPU16[i1 >> 1] | 0) >>> 0 < i12 >>> 0) HEAP16[i1 >> 1] = i12;
 if (!i6) {
  STACKTOP = i13;
  return i8 | 0;
 }
 HEAP16[i9 >> 1] = (HEAPU16[i9 >> 1] | 0) & 31 | i10 >>> 4 << 5;
 STACKTOP = i13;
 return i8 | 0;
}

function __ZN5physx14NpRigidDynamic8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb(i8, i1, i2, i3) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, i7 = 0, f9 = f0;
 i7 = i8 + 48 | 0;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i8, i1, 0, i2);
 if (Math_fround(HEAPF32[i1 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i1 + 8 >> 2]) != Math_fround(0.0); else i1 = 1; else i1 = 1;
 f9 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i8) | 0) + 2876 >> 2]);
 i4 = i8 + 276 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i8 + 280 | 0;
 i2 = f6 < f9 & i3;
 f6 = i2 ? f9 : f6;
 if (!(i2 | (i1 | i3) & (HEAP32[i5 >> 2] | 0) != 0)) return;
 switch ((HEAP32[i8 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = 9;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 8; else i2 = 9;
   break;
  }
 default:
  i2 = 8;
 }
 if ((i2 | 0) == 8) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i8 + 64 | 0, f6, 1);
  return;
 } else if ((i2 | 0) == 9) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i7);
  i8 = i8 + 284 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i12, i7, i1) {
 i12 = i12 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i8 = i7 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i6 = (i5 - i1 | 0) / 40 | 0;
 HEAP32[i4 >> 2] = i6;
 i10 = i12 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i12 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i6;
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i4, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i12, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
  i2 = i1 + 32 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i10 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i2, 4);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i12);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i11;
 return;
}

function __ZN18WheelFrictionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager5StartERK8UnityStrii(i8, i3, i1, i2) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!(HEAP32[i8 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i8 >> 2] | 0) == 1) {
  i8 = 1;
  return i8 | 0;
 }
 HEAP32[i8 + 4 >> 2] = i1;
 HEAP32[i8 + 8 >> 2] = i2;
 i1 = i8 + 12 | 0;
 do if ((i1 | 0) != (i3 | 0)) {
  i6 = HEAP8[i3 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i7 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
  i6 = i4 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i8 + 20 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i8 + 16 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i8 + 16 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 HEAP32[i8 + 560 >> 2] = 0;
 i7 = i8 + 568 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i7 = i8 + 576 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 1;
 i8 = 1;
 return i8 | 0;
}

function __ZNK16MemoryFileSystem14UnlockFileDataEPKcPPv(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i4 = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i5 | 0);
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21LightProbeProxyVolume12GetProbeAABBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 92 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 96 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 100 >> 2];
 i3 = HEAP32[i2 + 104 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = i3;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i2 + 108 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 i6 = i1 + 20 | 0;
 i7 = HEAP32[i2 + 112 >> 2] | 0;
 HEAP32[i6 >> 2] = i7;
 if (HEAP32[i2 + 88 >> 2] | 0) return;
 f8 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f12 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i3 = HEAP32[i2 + 140 >> 2] | 0;
 i5 = HEAP32[i2 + 144 >> 2] | 0;
 i7 = HEAP32[i2 + 148 >> 2] | 0;
 f10 = Math_fround(i3 >>> 0);
 i3 = i3 + -1 | 0;
 f9 = Math_fround(i3 >>> 0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f12 * Math_fround(f10 / ((i3 | 0) == 0 ? Math_fround(1.0) : f9)));
 f9 = Math_fround(i5 >>> 0);
 i5 = i5 + -1 | 0;
 f10 = Math_fround(i5 >>> 0);
 HEAPF32[i4 >> 2] = Math_fround(f11 * Math_fround(f9 / ((i5 | 0) == 0 ? Math_fround(1.0) : f10)));
 f10 = Math_fround(i7 >>> 0);
 i7 = i7 + -1 | 0;
 f9 = Math_fround(i7 >>> 0);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(f10 / ((i7 | 0) == 0 ? Math_fround(1.0) : f9)) * f8);
 return;
}

function __ZN17JointSuspension2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 i5 = i2 + 32 | 0;
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i4 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 }
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i6;
 return;
}

function __ZNSt3__25stoldERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084486 | 0, 5);
 HEAP32[i3 >> 2] = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i9 = ___errno_location() | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 d2 = +_strtold(i4, i3);
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i7 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (!(i10 & 1)) i5 = 3;
 } else i5 = 3;
 do if ((i5 | 0) == 3) {
  i10 = HEAP32[i3 >> 2] | 0;
  i1 = i10;
  if ((i10 | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = i1 - i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return +d2;
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i10 | 0);
 return 0.0;
}

function __ZNK4PPtrI6ObjectEcvPS0_Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) < 1) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode(__Z20GetPersistentManagerv() | 0, i1, -1) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim9animation23BlendDirectDataConstantEEEvRT_PKc17TransferMetaFlags(i10, i6, i1, i2) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i8 = i10 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i7 = i10 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i8 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 i1 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + (i5 << 2) | 0;
 if (i5 | 0) do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = i6 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i9;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i9;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1 + 4 | 0, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function _Move_CVT_Stretched(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i6 + 244 | 0;
 i5 = i6 + 256 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  i3 = HEAP16[i6 + 296 >> 1] | 0;
  if (!(i3 << 16 >> 16)) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  }
  i2 = HEAP16[i6 + 294 >> 1] | 0;
  i1 = HEAP32[i6 + 248 >> 2] | 0;
  if (!(i2 << 16 >> 16)) {
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i10 = i2 << 16 >> 16;
   i11 = HEAP32[i4 >> 2] | 0;
   i4 = (i11 | 0) < 0 ? 0 - i11 | 0 : i11;
   i9 = i2 << 16 >> 16 < 0 ? 0 - i10 | 0 : i10;
   i2 = Math_imul(i4 >>> 16, i9) | 0;
   i13 = i2 << 16 | 8192;
   i9 = i13 + (Math_imul(i4 & 65535, i9) | 0) | 0;
   i9 = (i9 >>> 0 < i13 >>> 0 & 1) + (i2 >>> 16) << 18 | i9 >>> 14;
   i2 = i3 << 16 >> 16;
   i13 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
   i4 = i3 << 16 >> 16 < 0 ? 0 - i2 | 0 : i2;
   i3 = Math_imul(i13 >>> 16, i4) | 0;
   i12 = i3 << 16 | 8192;
   i4 = i12 + (Math_imul(i13 & 65535, i4) | 0) | 0;
   i4 = (i4 >>> 0 < i12 >>> 0 & 1) + (i3 >>> 16) << 18 | i4 >>> 14;
   i1 = _UNITY_FT_Hypot((i11 ^ i10 | 0) > -1 ? i9 : 0 - i9 | 0, (i1 ^ i2 | 0) > -1 ? i4 : 0 - i4 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  }
 } while (0);
 i12 = _UNITY_FT_DivFix(i8, i1) | 0;
 i13 = (HEAP32[i6 + 384 >> 2] | 0) + (i7 << 2) | 0;
 HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i12;
 return;
}

function ___stdio_read(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 16 | 0;
 i2 = i10;
 i1 = i10 + 32 | 0;
 HEAP32[i1 >> 2] = i7;
 i4 = i1 + 4 | 0;
 i9 = i6 + 48 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i4 >> 2] = i8 - ((i11 | 0) != 0 & 1);
 i5 = i6 + 44 | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 12 >> 2] = i11;
 if (!(HEAP32[gb + 1469464 >> 2] | 0)) {
  HEAP32[i3 >> 2] = HEAP32[i6 + 60 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = 2;
  i1 = ___syscall_ret(___syscall145(145, i3 | 0) | 0) | 0;
 } else {
  _pthread_cleanup_push(fb + 3991 | 0, i6 | 0);
  HEAP32[i2 >> 2] = HEAP32[i6 + 60 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = 2;
  i1 = ___syscall_ret(___syscall145(145, i2 | 0) | 0) | 0;
  _pthread_cleanup_pop(0);
 }
 if ((i1 | 0) < 1) {
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i1 & 48 ^ 16;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
 } else {
  i4 = HEAP32[i4 >> 2] | 0;
  if (i1 >>> 0 > i4 >>> 0) {
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = i6 + 4 | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i2 + (i1 - i4);
   if (!(HEAP32[i9 >> 2] | 0)) i1 = i8; else {
    HEAP32[i3 >> 2] = i2 + 1;
    HEAP8[i7 + (i8 + -1) >> 0] = HEAP8[i2 >> 0] | 0;
    i1 = i8;
   }
  }
 }
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i5 = i8 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i6 = i9 + 4 | 0;
  i7 = i9 + 4 | 0;
  do {
   i4 = i2 + -60 | 0;
   HEAP32[i5 >> 2] = i4;
   i3 = i2 + -20 | 0;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -44 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i6 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i9);
   }
   if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i4 >> 2] | 0;
    i4 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i9 >> 2] = 66;
    HEAP32[i7 >> 2] = i4;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i9);
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 i11 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = 25;
 HEAP32[i9 + 4 >> 2] = i11;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i9);
 STACKTOP = i10;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i8 = i9 + 16 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 56; else i1 = (HEAP32[i1 >> 2] | 0) + 56 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN4Mesh24UpdateSubMeshVertexRangeEi(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i3 = i1 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i1, HEAP32[i3 >> 2] | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i6 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i3 >> 2] = i1;
 }
 i6 = HEAP32[i1 + 128 >> 2] | 0;
 i2 = HEAP32[i6 + (i7 * 52 | 0) + 36 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 + (i7 * 52 | 0) + 44 >> 2] = 0;
  HEAP32[i6 + (i7 * 52 | 0) + 48 >> 2] = 0;
  return;
 }
 i3 = HEAP32[i6 + (i7 * 52 | 0) + 32 >> 2] | 0;
 i5 = HEAP32[i1 + 112 >> 2] | 0;
 i4 = (HEAP32[i1 + 116 >> 2] | 0) - i5 | 0;
 i3 = (i4 | 0) != 0 & i4 >>> 0 > i3 >>> 0 ? i5 + i3 | 0 : 0;
 i5 = i6 + (i7 * 52 | 0) + 44 | 0;
 i4 = i3 + (i2 << 1) | 0;
 if ((i2 | 0) > 0) {
  i2 = 0;
  i1 = -1;
  do {
   i8 = HEAP16[i3 >> 1] | 0;
   i1 = (i8 & 65535) < (i1 & 65535) ? i8 : i1;
   i2 = (i2 & 65535) < (i8 & 65535) ? i8 : i2;
   i3 = i3 + 2 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 } else {
  i2 = 0;
  i1 = -1;
 }
 i8 = i1 & 65535;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i6 + (i7 * 52 | 0) + 48 >> 2] = 1 - i8 + (i2 & 65535);
 return;
}

function __ZN12NavMeshAgent18OnTransformChangedEi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i2 = i8;
 i7 = i4 + 68 | 0;
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i3 = i4 + 107 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!((i5 & 1 | 0) == 0 | (i1 & 1) == 0)) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  f9 = Math_fround(-Math_fround(HEAPF32[i4 + 44 >> 2]));
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = f9;
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  __ZNK9Transform14TransformPointERK8Vector3f(i2, i1, i6);
  __ZN7dtCrowd19updateAgentPositionERK13dtCrowdHandlePKf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i2);
  i1 = HEAP8[i3 >> 0] | 0;
 }
 if (!((i5 & 2 | 0) == 0 | (i1 & 2) == 0)) HEAPF32[i4 + 56 >> 2] = Math_fround(inf);
 if (!(i5 & 8)) {
  STACKTOP = i8;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 if ((HEAP32[i7 >> 2] | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i4, i6);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4 + 68 | 0, i6);
 STACKTOP = i8;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab18SerializedProperty22SerializedPropertyTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNSt3__24stodERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 12 | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 1084481 | 0, 4);
 HEAP32[i3 >> 2] = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i9 = ___errno_location() | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 d2 = +_strtod(i4, i3);
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10;
 if ((i1 | 0) == 34) {
  __THREW__ = 0;
  invoke_vi(fb + 4008 | 0, i7 | 0);
  i10 = __THREW__;
  __THREW__ = 0;
  if (!(i10 & 1)) i5 = 3;
 } else i5 = 3;
 do if ((i5 | 0) == 3) {
  i10 = HEAP32[i3 >> 2] | 0;
  i1 = i10;
  if ((i10 | 0) == (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4009 | 0, i7 | 0);
   i10 = __THREW__;
   __THREW__ = 0;
   if (i10 & 1) break;
  }
  if (i6 | 0) HEAP32[i6 >> 2] = i1 - i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  STACKTOP = i8;
  return +d2;
 } while (0);
 i10 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i10 | 0);
 return 0.0;
}

function __ZN6b2Body12SetTransformERK6b2Vec2f(i4, i1, f2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i3 = HEAP32[i4 + 88 >> 2] | 0;
 if (HEAP32[i3 + 102868 >> 2] & 2 | 0) return;
 i5 = i4 + 12 | 0;
 f11 = Math_fround(+Math_sin(+f2));
 HEAPF32[i4 + 20 >> 2] = f11;
 f10 = Math_fround(+Math_cos(+f2));
 HEAPF32[i4 + 24 >> 2] = f10;
 i6 = i1;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i4 + 44 | 0;
 f12 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f9 = Math_fround(f10 * f12);
 f8 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f11 * f8));
 f9 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f9);
 f8 = Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f8));
 f8 = Math_fround(f8 + (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i7 >> 2] = f9;
 HEAPF32[i4 + 48 >> 2] = f8;
 HEAPF32[i4 + 56 >> 2] = f2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAPF32[i4 + 52 >> 2] = f2;
 i3 = i3 + 102872 | 0;
 i1 = HEAP32[i4 + 100 >> 2] | 0;
 if (!i1) return;
 do {
  __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i1, i3, i5, i5);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService13WWWRestClientD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 189940 + 8;
 i5 = i1 + 44 | 0;
 i3 = i1 + 48 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1 + 56 | 0, HEAP32[i1 + 60 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 190020 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function _UNITY_FT_GlyphLoader_Add(i11) {
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 if (!i11) return;
 i9 = i11 + 56 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 << 16 >> 16;
 i6 = i11 + 22 | 0;
 i5 = HEAP16[i6 >> 1] | 0;
 i10 = i11 + 58 | 0;
 HEAP16[i6 >> 1] = (i3 >>> 16) + i5;
 i7 = i11 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP16[i7 >> 1] = i3 + i1;
 i8 = i11 + 84 | 0;
 i2 = i11 + 48 | 0;
 i12 = (HEAP32[i2 >> 2] | 0) + (HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = i12;
 if ((i3 & 65535) << 16 >> 16 > 0) {
  i2 = i11 + 68 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = 0;
  do {
   i13 = i3 + (i1 << 1) | 0;
   HEAP16[i13 >> 1] = (HEAPU16[i13 >> 1] | 0) + i5;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i1 = HEAP16[i6 >> 1] | 0;
 } else {
  i2 = i11 + 68 | 0;
  i1 = i1 >>> 16 & 65535;
 }
 HEAP16[i10 >> 1] = 0;
 HEAP16[i9 >> 1] = 0;
 HEAP32[i8 >> 2] = 0;
 i1 = i1 << 16 >> 16;
 HEAP32[i11 + 60 >> 2] = (HEAP32[i11 + 24 >> 2] | 0) + (i1 << 3);
 HEAP32[i11 + 64 >> 2] = (HEAP32[i11 + 28 >> 2] | 0) + i1;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i11 + 32 >> 2] | 0) + (i1 << 16 >> 16 << 1);
 if (HEAP8[i11 + 16 >> 0] | 0) {
  i13 = i1 >> 16;
  HEAP32[i11 + 76 >> 2] = (HEAP32[i11 + 40 >> 2] | 0) + (i13 << 3);
  HEAP32[i11 + 80 >> 2] = (HEAP32[i11 + 44 >> 2] | 0) + (i13 << 3);
 }
 HEAP32[i11 + 88 >> 2] = (HEAP32[i11 + 52 >> 2] | 0) + (i12 << 5);
 return;
}

function __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 20 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 20 | 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 20 | 0) | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = i2 + (i1 * 20 | 0) | 0;
 i6 = i8 + 8 | 0;
 HEAP32[i6 >> 2] = i5;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i8 + 12 >> 2] = i2 + (i4 * 20 | 0);
 __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i3, i8);
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i7 + 4 | 0;
  do {
   i2 = i1 + -20 | 0;
   HEAP32[i6 >> 2] = i2;
   i3 = i1 + -16 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i5 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
    i1 = HEAP32[i6 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i9;
 return;
}

function __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!(i1 & 1)) __ZN8Renderer10SetVisibleEb(i4, (HEAP8[i4 + 329 >> 0] | 0) != 0);
 if (i1 & 13 | 0) {
  i3 = __Z13GetTagManagerv() | 0;
  HEAP16[i4 + 338 >> 1] = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i3, HEAP32[i4 + 332 >> 2] | 0) | 0;
 }
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 do if (!i1) {
  i2 = i4 + 316 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i5 = 15;
 } else {
  i3 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  i2 = i4 + 316 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i3 ^ (i1 | 0) != 0) {
   if (!i3) if (!i1) break; else {
    i5 = 15;
    break;
   }
   i3 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) {
    if (!i1) i1 = i4 + 320 | 0; else {
     i6 = i4 + 320 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
     HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     i1 = i6;
    }
    i6 = HEAP32[i3 >> 2] | 0;
    HEAP32[i2 >> 2] = i6;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i6 + 4 >> 2] = i2;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   }
  }
 } while (0);
 if ((i5 | 0) == 15) {
  i6 = i4 + 320 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[i4 + 220 >> 2] = HEAPU16[i4 + 338 >> 1] << 16 ^ -2147483648 | (HEAP16[i4 + 336 >> 1] | 0) + 32768;
 return;
}

function __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj32ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i7, i6, f8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = i10 + 4 | 0;
 i9 = i7 + 4 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 2:
  {
   if (HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0) i1 = 6;
   break;
  }
 default:
  {}
 }
 if ((i1 | 0) == 6) {
  i2 = i7 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i7 >> 2] | 0, i5 >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAPF32[i1 + 48 >> 2] = f8;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i7 >> 2] | 0, i7);
  HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 32;
  STACKTOP = i10;
  return;
 }
 i2 = HEAP8[i6 + 64 >> 0] | 0;
 __ZN5physx2Sc9ShapeCore13setRestOffsetEf(i6, f8);
 i1 = HEAP32[i7 + -32 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 if ((HEAP32[i9 >> 2] & -1073741824 | 0) == 1073741824) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = 32;
 HEAP8[i4 >> 0] = i2;
 __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1 + 64 | 0, i6, i3, i4);
 STACKTOP = i10;
 return;
}

function __ZN16SubstanceArchiveC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i6, i3);
 HEAP32[i1 >> 2] = gb + 59556 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = i6;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63736 | 0, 16, gb + 434428 | 0, 63) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 59540 + 8;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i3 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP8[i3 + 32 >> 0] = 0;
 i2 = i3 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN13NavMeshParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 8 >> 2] | 0) - i1 | 0) / 36 | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = ((HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) / 36 | 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 * 36 | 0) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 * 36 | 0) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 * 36 | 0);
 __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -36 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -24 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNK5Umbra4Tome16getObjectUserIDsEiPji(i6, i7, i9, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0;
 i8 = i6 + 76 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i1 = i6 + i5 | 0;
 if (!((i5 | 0) == 0 | (i1 | 0) == 0)) {
  i1 = (HEAP32[i1 + (i7 + 1 << 2) >> 2] | 0) - (HEAP32[i1 + (i7 << 2) >> 2] | 0) | 0;
  if (!i9) {
   i9 = i1;
   return i9 | 0;
  }
  i3 = (i1 | 0) <= (i2 | 0) ? i1 : i2;
  if ((i3 | 0) <= 0) {
   i9 = i1;
   return i9 | 0;
  }
  i4 = i6 + 80 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i9 >> 2] = HEAP32[((i2 | 0) == 0 ? 0 : i6 + i2 | 0) + (HEAP32[((i5 | 0) == 0 ? 0 : i6 + i5 | 0) + (i7 << 2) >> 2] << 2) >> 2];
  if ((i3 | 0) == 1) {
   i9 = i1;
   return i9 | 0;
  } else i2 = 1;
  do {
   i5 = HEAP32[i8 >> 2] | 0;
   i10 = HEAP32[i4 >> 2] | 0;
   HEAP32[i9 + (i2 << 2) >> 2] = HEAP32[((i10 | 0) == 0 ? 0 : i6 + i10 | 0) + (HEAP32[((i5 | 0) == 0 ? 0 : i6 + i5 | 0) + (i7 << 2) >> 2] << 2) + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
  return i1 | 0;
 }
 if ((i7 | 0) < 0) {
  i10 = 0;
  return i10 | 0;
 }
 if ((HEAP32[i6 + 64 >> 2] | 0) <= (i7 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if (!i5) {
  i1 = HEAP32[i6 + 80 >> 2] | 0;
  i1 = HEAP32[((i1 | 0) == 0 ? 0 : i6 + i1 | 0) + (i7 << 2) >> 2] | 0;
 } else i1 = -1;
 if (!((i9 | 0) != 0 & (i2 | 0) > 0)) {
  i10 = 1;
  return i10 | 0;
 }
 HEAP32[i9 >> 2] = i1;
 i10 = 1;
 return i10 | 0;
}

function __ZN9Texture3D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 418884 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i4 + 32 | 0);
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAPF32[i4 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 76 >> 2] = 1;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 46212 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 5;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP8[i4 + 104 >> 0] = 0;
 HEAP8[i4 + 105 >> 0] = 1;
 HEAP8[i4 + 106 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN7mecanim5human6Handle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906345 | 0, gb + 905989 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1085944 | 0, 0);
 i5 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084124 | 0, gb + 906539 | 0, i5, 0);
 __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 28 | 0, gb + 1085935 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 906446 | 0, i5, i1 + 40 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 910040 | 0, i5, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN19RuntimeSceneManager11MergeScenesER10UnitySceneS1_(i9, i10, i2) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i10 + 100 | 0;
 i6 = i10 + 104 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i7 = i4;
 i8 = (i7 | 0) == (i5 | 0);
 if (!i8) {
  i1 = i4;
  i3 = i7;
  do {
   HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 116 >> 2] = i2;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
  } while ((i3 | 0) != (i5 | 0));
  i1 = i2 + 100 | 0;
  if (!i8) {
   i8 = HEAP32[i1 >> 2] | 0;
   HEAP32[i8 + 4 >> 2] = i4;
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 >> 2] = i8;
   HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i5 >> 2] = i5;
  }
 }
 if (!(__ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene(i9, i10) | 0)) return;
 HEAP32[i10 + 80 >> 2] = 3;
 __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene(i9, i10);
 i4 = i9 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i9 + 16 | 0;
 i9 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + (i9 << 2) | 0;
 L10 : do if (i9) {
  do {
   if ((HEAP32[i1 >> 2] | 0) == (i10 | 0)) break L10;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i3 | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0);
 i10 = i1 + 4 | 0;
 _memmove(i1 | 0, i10 | 0, (HEAP32[i4 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) - i10 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN13OpenFileCache10ForceCloseERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0;
 i12 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i12 << 24 >> 24 < 0;
 i12 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i12 & 255;
 i9 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i10 = (i12 | 0) == 0;
 i1 = 0;
 L1 : while (1) {
  i6 = i11 + 160 + (i1 * 12 | 0) | 0;
  i7 = i6 + 11 | 0;
  i2 = HEAP8[i7 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  i8 = i11 + 160 + (i1 * 12 | 0) + 4 | 0;
  i2 = i2 & 255;
  do if (((i3 ? HEAP32[i8 >> 2] | 0 : i2) | 0) == (i12 | 0)) {
   i4 = HEAP32[i6 >> 2] | 0;
   i5 = i3 ? i4 : i6;
   if (i3) {
    if (i10) break L1;
    if (!(_memcmp(i5, i9, i12) | 0)) break L1; else break;
   }
   if (i10) break L1;
   if ((i4 & 255) << 24 >> 24 == (HEAP8[i9 >> 0] | 0)) {
    i4 = i6;
    i3 = i9;
    do {
     i2 = i2 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i2) break L1;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 5) {
   i13 = 15;
   break;
  }
 }
 if ((i13 | 0) == 15) return;
 __ZN4File5CloseEv(i11 + (i1 << 5) | 0) | 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i6 >> 2] >> 0] = 0;
  HEAP32[i8 >> 2] = 0;
 } else {
  HEAP8[i6 >> 0] = 0;
  HEAP8[i7 >> 0] = 0;
 }
 HEAP32[i11 + 220 + (i1 << 2) >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i5 = i6 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i6 + 24 | 0;
 i9 = gb + 63648 | 0;
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i6 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i4 = _strlen(i3) | 0;
 if (i4 >>> 0 > 15) {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 + 1 | 0, 16, i7, 0, gb + 1047486 | 0, 251) | 0;
  HEAP32[i6 >> 2] = i9;
  HEAP32[i6 + 4 >> 2] = i4;
  i1 = (i9 | 0) == 0 ? i1 : i9;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 HEAP32[i5 >> 2] = i4;
 i1 = (__ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_(i2, i6) | 0) != (i2 + 4 | 0);
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 if (!(HEAP32[i6 + 4 >> 2] | 0)) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i7);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN11Rigidbody2D16CorrectBodyStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i1 = i1 + 92 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 __ZN6b2Body12SetTransformERK6b2Vec2f(i4, gb + 1457504 | 0, Math_fround(0.0));
 if (HEAP32[i4 >> 2] | 0) {
  f6 = Math_fround(HEAPF32[gb + 1457504 >> 2]);
  f6 = Math_fround(f6 * f6);
  f5 = Math_fround(HEAPF32[gb + 1457504 + 4 >> 2]);
  if (Math_fround(f6 + Math_fround(f5 * f5)) > Math_fround(0.0)) {
   i2 = i4 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(i3 & 2)) {
    HEAP16[i2 >> 1] = i3 | 2;
    HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   }
  }
  i7 = gb + 1457504 | 0;
  i2 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i4 + 64 | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  if (!(HEAP16[i4 + 4 >> 1] & 16)) HEAPF32[i4 + 72 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = (__Z14IsWorldPlayingv() | 0) ^ 1;
 if (!i1) return;
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 64 >> 2] | 0;
  if (i2 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i4 | 0);
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0);
  }
 } while ((i1 | 0) != 0);
 return;
}

function __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fjPS2_ji(i1, i2, i11, i4, i13, i14) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var i3 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f12 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0, f21 = f0;
 f15 = Math_fround(HEAPF32[i1 >> 2]);
 f16 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 if ((i14 | 0) > 0) {
  i3 = i2;
  i1 = i4;
  i2 = 0;
 } else return;
 while (1) {
  f21 = Math_fround(HEAPF32[i3 >> 2]);
  f20 = Math_fround(f15 * f21);
  f17 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f20 = Math_fround(f20 + Math_fround(f7 * f17));
  f19 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f18 = Math_fround(Math_fround(Math_fround(f16 * f21) + Math_fround(f8 * f17)) + Math_fround(f12 * f19));
  f17 = Math_fround(Math_fround(Math_fround(f6 * f21) + Math_fround(f9 * f17)) + Math_fround(f5 * f19));
  HEAPF32[i1 >> 2] = Math_fround(f20 + Math_fround(f10 * f19));
  HEAPF32[i1 + 4 >> 2] = f18;
  HEAPF32[i1 + 8 >> 2] = f17;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i14 | 0)) break; else {
   i3 = i3 + i11 | 0;
   i1 = i1 + i13 | 0;
  }
 }
 return;
}

function __ZNK9DebugGLES19FramebufferBindingsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP8[i1 + 1992 >> 0] | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = 0;
 while (1) {
  HEAP32[i6 >> 2] = 0;
  i1 = HEAP32[i1 + 88 >> 2] | 0;
  if (!(HEAP8[gb + 1548967 >> 0] | 0)) {
   HEAP32[gb + 1451048 >> 2] = 36006;
   i4 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 666 >> 0] | 0) != 0;
   HEAP32[gb + 1451048 + 4 >> 2] = i4 ? 36010 : 36006;
   HEAP8[gb + 1548967 >> 0] = 1;
  }
  mftCall_vii(i1 | 0, HEAP32[gb + 1451048 + (i2 << 2) >> 2] | 0, i6 | 0);
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = __ZNK7ApiGLES10GetContextEv(i3) | 0;
  i1 = HEAP32[i3 + 876 + (i2 << 3) >> 2] | 0;
  if (!i1) i7 = 7; else if ((i4 | 0) == (HEAP32[i3 + 876 + (i2 << 3) + 4 >> 2] | 0)) i7 = 7; else i1 = -1;
  if ((i7 | 0) == 7) i7 = 0;
  if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) i1 = 1; else {
   i3 = HEAP32[i5 >> 2] | 0;
   i4 = __ZNK7ApiGLES10GetContextEv(i3) | 0;
   i1 = HEAP32[i3 + 876 + (i2 << 3) >> 2] | 0;
   if (!i1) i7 = 11; else if ((i4 | 0) == (HEAP32[i3 + 876 + (i2 << 3) + 4 >> 2] | 0)) i7 = 11; else i1 = -1;
   if ((i7 | 0) == 11) i7 = 0;
   i1 = (i1 | 0) == -1;
  }
  i2 = i2 + 1 | 0;
  if (!(i1 & (i2 | 0) < 2)) break;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN11JointSpring8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN11JointLimits8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, i16 = 0;
 i16 = HEAP32[i6 + 4 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) >> 2]);
 f12 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i16 + 96 + (i1 << 4) + 8 >> 2]);
 i1 = HEAP32[i16 + 96 + (i1 << 4) + 12 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 f15 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 f14 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f13 = Math_fround(HEAPF32[i6 + 152 >> 2]);
 f9 = Math_fround(-f15);
 f8 = Math_fround(-f14);
 f7 = Math_fround(-f13);
 f9 = HEAP32[gb + 48 + (i2 << 4) >> 2] | 0 ? f15 : f9;
 f8 = HEAP32[gb + 48 + (i2 << 4) + 4 >> 2] | 0 ? f14 : f8;
 f7 = HEAP32[gb + 48 + (i2 << 4) + 8 >> 2] | 0 ? f13 : f7;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = i10 + 12 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i5 = 0; else {
  i5 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i9 << 3 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + (i1 << 3) | 0;
 i8 = i10 + 4 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i13 = i2;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i11 = i4;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i5 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i13 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 >> 2] = i9;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i13 + 1;
 return i5 + (i13 << 3) | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS4_EENS5_9allocatorIS4_EEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = (i2 - i1 | 0) / 36 | 0;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj(i6, i3 - i4 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else if (i3 >>> 0 < i4 >>> 0) {
  i3 = i1 + (i3 * 36 | 0) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~(((i2 + -36 - i3 | 0) >>> 0) / 36 | 0) * 36 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN10JointMotor8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
  i2 = i4;
 }
 HEAP32[i6 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i1;
  i4 = i1;
 }
 HEAP32[i6 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function _UNITY_FT_Face_GetCharVariantIsDefault(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 if (!i1) {
  i10 = -1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i2) {
  i10 = -1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i5 = i2 + (i6 << 2) | 0;
 if ((i6 | 0) <= 0) {
  i10 = -1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i6 = i7 + 4 | 0;
 i1 = i2;
 L10 : while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  do if ((HEAP32[i4 + 8 >> 2] | 0) == 327680) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i2 = HEAP32[i2 + 96 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
     if (i2 | 0) if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i4 | 0, i7 | 0) | 0)) if ((HEAP32[i6 >> 2] | 0) == 14) break L10; else break;
    }
   }
  } while (0);
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = -1;
   i10 = 15;
   break;
  }
 }
 if ((i10 | 0) == 15) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i10 = -1;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = (mftCall_iiii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i8 | 0, i9 | 0) | 0) & 255;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 switch (i2 | 0) {
 case 1:
  {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = HEAP32[i1 + 24 >> 2] | 0;
   if (!i4) {
    i9 = 0;
    return i9 | 0;
   }
   i2 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = 0;
   while (1) {
    i1 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
    i3 = i3 + 1 | 0;
    if (!(_strcmp(HEAP32[i1 + 12 >> 2] | 0, i8) | 0)) {
     i5 = i1;
     break;
    }
    if (i3 >>> 0 >= i4 >>> 0) {
     i7 = 0;
     i9 = 12;
     break;
    }
   }
   if ((i9 | 0) == 12) return i7 | 0;
   while (1) {
    i1 = HEAP32[i5 + 8 >> 2] | 0;
    if (!i1) {
     i7 = i5;
     break;
    } else i5 = i1;
   }
   return i7 | 0;
  }
 case 2:
  {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   i4 = HEAP32[i1 + 24 >> 2] | 0;
   if (!i4) {
    i9 = 0;
    return i9 | 0;
   }
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   i3 = 0;
   while (1) {
    i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
    i3 = i3 + 1 | 0;
    if (!(_strcmp(HEAP32[i2 + 12 >> 2] | 0, i8) | 0)) {
     i6 = i2;
     break;
    }
    if (i3 >>> 0 >= i4 >>> 0) {
     i7 = 0;
     i9 = 12;
     break;
    }
   }
   if ((i9 | 0) == 12) return i7 | 0;
   while (1) {
    i1 = HEAP32[i6 + 8 >> 2] | 0;
    if (!i1) {
     i7 = i6;
     break;
    } else i6 = i1;
   }
   return i7 | 0;
  }
 default:
  {
   i9 = 0;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN8Animator15GetBodyRotationEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i2 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i5 = i2 + i3 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 i1 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f12 = Math_fround(f10 * f10);
 f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(f9 * f9);
 f8 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(f8 * f8);
 f11 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(Math_fround(f12 + f4) + Math_fround(f7 + Math_fround(f11 * f11)));
 f4 = Math_fround(Math_sqrt(Math_fround(f7)));
 f10 = Math_fround(f10 / f4);
 f9 = Math_fround(f9 / f4);
 f8 = Math_fround(f8 / f4);
 f4 = Math_fround(f11 / f4);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f7 > Math_fround(1.0e-30);
 i13 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i6 >> 2] = i5 ? i1 : 0;
 HEAP32[i6 + 4 >> 2] = i5 ? i2 : 0;
 HEAP32[i6 + 8 >> 2] = i5 ? i3 : 0;
 HEAP32[i6 + 12 >> 2] = i13;
 return;
}

function __ZN5physx2Sc5Scene16visualizeEndStepEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!(Math_fround(HEAPF32[i5 + 1408 >> 2]) != Math_fround(0.0))) {
  STACKTOP = i7;
  return;
 }
 i1 = (HEAP32[(HEAP32[i5 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 5924 | 0;
 i2 = i6 + 36 | 0;
 i3 = i6;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 i3 = i6 + 40 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i6 + 56 >> 2] = Math_fround(1.0);
 i3 = i6 + 60 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i6 + 76 >> 2] = Math_fround(1.0);
 i3 = i6 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i6 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i6 + 100 >> 2] = i1;
 i3 = i5 + 136 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = i5 + 132 | 0;
  i2 = 0;
  do {
   __ZN5physx2Sc17ParticleSystemSim16visualizeEndStepERNS_2Cm12RenderOutputE(__ZNK5physx2Sc18ParticleSystemCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0, i6);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx23solveConcludeExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = HEAP16[i2 + 26 >> 1] | 0;
 i9 = i1 + ((i8 & 65535) << 4) | 0;
 if (!(i8 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i8 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i7 = 32;
   i2 = i3;
   i3 = i4;
  } else {
   i6 = i2 & 255;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    i10 = f5 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i10 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i3 = (Math_imul(i7, i6) | 0) + 32 | 0;
   i7 = i3;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + i3 | 0;
  }
  i6 = i2 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i8 << 24 >> 24)) i1 = i3; else {
   i4 = i8 & 255;
   i2 = i3;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i6 | 0;
   }
   i1 = i1 + ((Math_imul(i6, i4) | 0) + i7) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags(i10, i5, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = i5 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i7 = i10 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i1 + (i5 * 24 | 0) | 0;
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  if (i4 >>> 0 < i5 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i4;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 20 | 0;
  i3 = i4 + 4 | 0;
  if (i3 >>> 0 < i5 >>> 0) {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i9;
 return;
}

function __ZN14NavMeshManager13RegisterAgentER12NavMeshAgentRi(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i6 = i2 + 40 | 0;
 i7 = i2 + 52 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i3;
 i10 = i8 + 1 | 0;
 i11 = i2 + 56 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i4 = i12 & 2147483647;
 do if (i10 >>> 0 > i4 >>> 0) {
  i1 = i12 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i12 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i2 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = i12;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i10;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
 HEAP32[i5 >> 2] = i8;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 168936 | 0) | 0;
 if (!i2) return;
 if ((HEAP32[i2 + 36 >> 2] | 0) == -1) return;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 842061 | 0, 0, gb + 842172 | 0, 866, 512, i1, 0, 0);
 return;
}

function __Z17GetUniqueTempPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 16 | 0;
 i4 = i9;
 i5 = i2 + 11 | 0;
 i6 = i2 + 4 | 0;
 i7 = i4 + 11 | 0;
 i8 = i4 + 4 | 0;
 while (1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  __ZN9UnityGUID4InitEv(i3);
  __Z12GUIDToStringRK9UnityGUID(i4, i3);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i11 = HEAP8[i5 >> 0] | 0;
  i12 = i11 << 24 >> 24 < 0;
  i11 = i12 ? HEAP32[i6 >> 2] | 0 : i11 & 255;
  i10 = HEAP8[i7 >> 0] | 0;
  i10 = i10 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i10 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i12 ? HEAP32[i2 >> 2] | 0 : i2, i11, i10 + i11 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i10) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  if (!(__Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0)) break;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 }
 STACKTOP = i9;
 return;
}

function _getservbyport_r(i4, i5, i6, i3, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 HEAP16[i9 >> 1] = 2;
 HEAP16[i9 + 2 >> 1] = i4;
 HEAP32[i9 + 4 >> 2] = 0;
 i2 = i9 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 L1 : do if (!i5) if (!(_getservbyport_r(i4, gb + 1074137 | 0, i6, i3, i7, i8) | 0)) i1 = 0; else i1 = _getservbyport_r(i4, gb + 1074141 | 0, i6, i3, i7, i8) | 0; else {
  i1 = i3 & 3;
  i1 = i1 | 0 ? i1 : 4;
  if ((12 - i1 | 0) >>> 0 > i7 >>> 0) i1 = 34; else {
   i2 = 4 - i1 | 0;
   i1 = i3 + i2 | 0;
   if (_strcmp(i5, gb + 1074137 | 0) | 0) if (_strcmp(i5, gb + 1074141 | 0) | 0) {
    i1 = 22;
    break;
   }
   HEAP32[i6 + 8 >> 2] = i4;
   HEAP32[i6 + 12 >> 2] = i5;
   i3 = i6 + 4 | 0;
   HEAP32[i3 >> 2] = i1;
   i4 = i1 + 8 | 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i6 >> 2] = i4;
   HEAP32[HEAP32[i3 >> 2] >> 2] = i4;
   i5 = (_strcmp(i5, gb + 1074141 | 0) | 0) != 0;
   switch (_getnameinfo(i9 | 0, 16, 0, 0, i4 | 0, i7 + -8 - i2 | 0, (i5 ? 0 : 16) | 0) | 0) {
   case -11:
   case -10:
    {
     i1 = 12;
     break L1;
    }
   case 0:
    {
     HEAP32[i8 >> 2] = i6;
     i1 = 0;
     break L1;
    }
   default:
    {
     i1 = 2;
     break L1;
    }
   }
  }
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_(i5, i6, i4, i1, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_(i5, i6, i4, i7) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i9 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i10 = Math_imul(HEAP32[i9 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i2 << 3) >> 2] | 0) | 0;
 if ((i10 | 0) <= (Math_imul(HEAP32[i9 + (i3 << 3) + 4 >> 2] | 0, HEAP32[i9 + (i3 << 3) >> 2] | 0) | 0)) {
  i10 = i8;
  return i10 | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i9 = Math_imul(HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i1 << 3) >> 2] | 0) | 0;
 if ((i9 | 0) <= (Math_imul(HEAP32[i10 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i2 << 3) >> 2] | 0) | 0)) {
  i10 = i8 + 1 | 0;
  return i10 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i9 = Math_imul(HEAP32[i10 + (i1 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i1 << 3) >> 2] | 0) | 0;
 if ((i9 | 0) <= (Math_imul(HEAP32[i10 + (i2 << 3) + 4 >> 2] | 0, HEAP32[i10 + (i2 << 3) >> 2] | 0) | 0)) {
  i10 = i8 + 2 | 0;
  return i10 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 i10 = i8 + 3 | 0;
 return i10 | 0;
}

function __ZNK10MinMaxAABB17CalculateVerticesEP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i8 = i1 + 8 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i2 + 8 >> 2] = i7;
 i7 = i1 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 16 >> 2] = i6;
 HEAP32[i2 + 20 >> 2] = i4;
 i4 = i1 + 16 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 + 24 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 28 >> 2] = i6;
 HEAP32[i2 + 32 >> 2] = i3;
 i3 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 40 >> 2] = i3;
 HEAP32[i2 + 44 >> 2] = i8;
 i8 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 20 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 52 >> 2] = i8;
 HEAP32[i2 + 56 >> 2] = i6;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 60 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 64 >> 2] = i5;
 HEAP32[i2 + 68 >> 2] = i6;
 i6 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 76 >> 2] = i6;
 HEAP32[i2 + 80 >> 2] = i5;
 i4 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 88 >> 2] = i4;
 HEAP32[i2 + 92 >> 2] = i3;
 return;
}

function __ZN7b2World11CreateJointEPK10b2JointDef(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (HEAP32[i2 + 102868 >> 2] & 2 | 0) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = __ZN7b2Joint6CreateEPK10b2JointDefP16b2BlockAllocator(i7, i2) | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i2 + 102960 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = i4;
 if (i4 | 0) HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i3 >> 2] = i1;
 i2 = i2 + 102968 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i1 + 16 | 0;
 HEAP32[i1 + 20 >> 2] = i1;
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 + 24 >> 2] = 0;
 i6 = HEAP32[i1 + 48 >> 2] | 0;
 i3 = i6 + 108 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = i4;
 if (i4 | 0) HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 32 | 0;
 HEAP32[i1 + 36 >> 2] = i1;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i1 + 40 >> 2] = 0;
 i2 = i5 + 108 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 44 >> 2] = i3;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[i7 + 8 >> 2] | 0;
 if (HEAP8[i7 + 16 >> 0] | 0) {
  i7 = i1;
  return i7 | 0;
 }
 i2 = HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 112 >> 2] | 0;
 if (!i2) {
  i7 = i1;
  return i7 | 0;
 }
 do {
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i7 = (HEAP32[i2 + 4 >> 2] | 0) + 4 | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
  }
  i2 = HEAP32[i2 + 12 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __ZN5physx2Gu22GJKRelativeTesselationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i2, i4, i3, i11, i5, i6, i9, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 8 | 0;
 i8 = i12;
 i1 = __ZN5physx2Gu11gjkRelativeINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i2, i4, i3, i5, i6, i9, i10) | 0;
 if ((i1 | 0) == 1) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = f14 > Math_fround(HEAPF32[i10 >> 2]);
 i1 = i13 ? 1 : (i1 | 0) == 3 ? 3 : 0;
 if ((i1 | 0) != 3) {
  i13 = i1;
  STACKTOP = i12;
  return i13 | 0;
 }
 HEAP32[i7 >> 2] = gb + 90640 + 8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i8 >> 2] = gb + 90576 + 8;
 HEAP32[i8 + 4 >> 2] = i4;
 i1 = __ZN5physx2Gu19gjkRelativeFallbackERKNS0_7ConvexVES3_PNS0_10SupportMapES5_RKNS_6shdfnd3aos5Vec3VERS8_SB_SB_RNS7_6FloatVE(i2, i4, i7, i8, i3 + 48 | 0, i5, i6, i9, i10) | 0;
 if ((i1 | 0) != 3) {
  i13 = i1;
  STACKTOP = i12;
  return i13 | 0;
 }
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = f14 > Math_fround(HEAPF32[i10 >> 2]) & 1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN20BufferedSocketStream4RecvEPvj(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(HEAP8[i4 + 18 >> 0] | 0)) if (!(HEAP8[i4 + 19 >> 0] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i4 + 76 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 20 | 0;
 i2 = (HEAP32[i7 + 24 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 i8 = HEAP32[i7 + 16 >> 2] | 0;
 i6 = i8 + -1 & HEAP32[i6 >> 2];
 i8 = i8 - i6 | 0;
 i2 = i8 >>> 0 < i2 >>> 0 ? i8 : i2;
 i2 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
 _memcpy(i3 | 0, (HEAP32[i7 >> 2] | 0) + i6 | 0, i2 | 0) | 0;
 i3 = (HEAP32[i5 >> 2] | 0) + 20 | 0;
 HEAP32[i3 >> 2] = i2 + (HEAP32[i3 >> 2] | 0);
 i3 = i4 + 72 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i2;
 if (HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0) {
  i8 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i8 + 24 >> 2] | 0) == (HEAP32[i8 + 20 >> 2] | 0)) {
   i1 = i4 + 68 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - (HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2];
   if (i1 | 0) {
    if (HEAP8[i1 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 8 | 0);
    __ZdlPv(i1);
   }
  }
 }
 if (i2 | 0) {
  i8 = i2;
  return i8 | 0;
 }
 if (!(HEAP8[i4 + 19 >> 0] | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
 i8 = 0;
 return i8 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i6 + 4 | 0;
 i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j(i5, i1);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i7, i1, 0);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags(i7, i1 + 20 | 0, 0);
  __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 60 | 0, i7);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags(i7, i1 + 40 | 0, 0);
  i1 = i1 + 84 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN10AudioMixer23GetInitialSnapshotIndexEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 8 | 0;
 i2 = i7;
 i5 = i4 + 68 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i6 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i8 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i8 + 28 >> 2] | 0;
   i3 = HEAP32[i8 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i8 = i1;
    i8 = __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot(i4, i8) | 0;
    STACKTOP = i7;
    return i8 | 0;
   }
  }
 }
 i8 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i8 = __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot(i4, i8) | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZL9CleanHullRjPN5physx2Gu9TriangleTIjEES_PNS0_6PxVec3E(i6, i4, i7, i8) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 __ZN5physx11MeshCleanerC2EjPKNS_6PxVec3EjPKjf(i3, HEAP32[i7 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0, i4, Math_fround(0.0));
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i2) {
  __ZN5physx11MeshCleanerD2Ev(i3);
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 _memcpy(i8 | 0, HEAP32[i3 + 8 >> 2] | 0, i1 * 12 | 0) | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = 0;
 do {
  i10 = i5 * 3 | 0;
  HEAP32[i4 + (i5 * 12 | 0) >> 2] = HEAP32[i1 + (i10 << 2) >> 2];
  HEAP32[i4 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i1 + (i10 + 1 << 2) >> 2];
  HEAP32[i4 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i1 + (i10 + 2 << 2) >> 2];
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i2 | 0));
 __ZN5physx11MeshCleanerD2Ev(i3);
 __ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb(i6, i4, 1) | 0;
 __ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb(HEAP32[i7 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0, i4, 1) | 0;
 __ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb(HEAP32[i7 >> 2] | 0, i8, HEAP32[i6 >> 2] | 0, i4, 1) | 0;
 __ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb(i6, i4, 1) | 0;
 STACKTOP = i9;
 return;
}

function __ZL31QueryPortalVisibilityCombineJobP28QueryPortalVisibilityJobData(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1112804 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112804 | 0, i1);
  i5 = gb + 1112804 | 0;
 } else i5 = 0;
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 i6 = i7 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 60 | 0;
 if ((i1 | 0) > 0) {
  i2 = 0;
  do {
   if (HEAP8[i7 + 32 + i2 >> 0] | 0) HEAP8[i4 >> 0] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i1 | 0));
 }
 if (HEAP8[i4 >> 0] | 0) {
  i1 = __Z9GetIUmbrav() | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[(HEAP32[i7 >> 2] | 0) + 836 >> 2] | 0, i7 + 8 | 0, HEAP32[i6 >> 2] | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) > 1) {
  i1 = 1;
  do {
   i4 = __Z9GetIUmbrav() | 0;
   mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0, HEAP32[i7 + 8 + (i1 << 2) >> 2] | 0, 1, gb + 64024 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64024 | 0);
 if (!i5) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i8;
 return;
}

function __Z42TerrainData_Get_Custom_PropSplatPrototypesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 if (!i1) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i9 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i8 = i2 + 32 | 0;
 i9 = HEAP32[(__Z26GetTerrainScriptingClassesv() | 0) + 4 >> 2] | 0;
 i6 = i8 + 4 | 0;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(i9, 4, ((HEAP32[i6 >> 2] | 0) - (HEAP32[i8 >> 2] | 0) | 0) / 44 | 0) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i11;
  return i7 | 0;
 }
 i5 = 0;
 do {
  __Z20SplatPrototypeToMonoRK14SplatPrototypeR18MonoSplatPrototype(i1 + (i5 * 44 | 0) | 0, i10);
  i1 = _il2cpp_object_new(i9 | 0) | 0;
  i2 = i1 + 8 | 0;
  i3 = i10;
  i4 = i2 + 44 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i7, i5, i1);
  i5 = i5 + 1 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
 } while (i5 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i1 | 0) / 44 | 0) >>> 0);
 STACKTOP = i11;
 return i7 | 0;
}

function __Z29Texture2D_CUSTOM_PackTexturesP12Il2CppObjectP11Il2CppArrayiih(i4, i3, i5, i6, i7) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 i9 = __Znaj(i8 >>> 0 > 1073741823 ? -1 : i8 << 2) | 0;
 if ((i8 | 0) > 0) {
  i2 = 0;
  do {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(__ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i3, i2) | 0) | 0;
   if (!i1) i1 = 0; else if (!(HEAP8[i1 + 111 >> 0] | 0)) {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 570831 | 0, 0, gb + 570137 | 0, 641, 1, 0, 0, 0);
    i1 = 0;
   }
   HEAP32[i9 + (i2 << 2) >> 2] = i1;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i8 | 0));
 }
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 284 >> 2] | 0, 16, i8) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) {
  i9 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 } else {
  i8 = __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb(i3, i6, i8, i9, i2, i5, 1, i7 << 24 >> 24 != 0) | 0;
  __ZdaPv(i9);
  return (i8 ? i1 : 0) | 0;
 }
 return 0;
}

function __Z23GetContainerElementTypeRK16TypeTreeIterator(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + (i4 * 24 | 0) | 0;
 if ((i2 + 24 | 0) >>> 0 < (i1 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) {
  i6 = (HEAPU8[i2 + 26 >> 0] | 0 | 0) == ((HEAPU8[i1 + (i4 * 24 | 0) + 2 >> 0] | 0) + 1 | 0);
  i3 = i6 ? i3 : 0;
  i4 = i6 ? i4 + 1 | 0 : 0;
 } else {
  i3 = 0;
  i4 = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + (i4 * 24 | 0) | 0;
 if ((i2 + 24 | 0) >>> 0 < (i1 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) {
  i1 = (HEAPU8[i2 + 26 >> 0] | 0 | 0) == ((HEAPU8[i1 + (i4 * 24 | 0) + 2 >> 0] | 0) + 1 | 0);
  i6 = i1 ? i3 : 0;
  i1 = i1 ? i4 + 1 | 0 : 0;
 } else {
  i6 = 0;
  i1 = 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
 i4 = i2 + ((HEAP32[i6 + 12 >> 2] | 0) * 24 | 0) | 0;
 i5 = i2;
 i2 = i2 + (i1 * 24 | 0) | 0;
 do {
  i1 = i2;
  i2 = i2 + 24 | 0;
  if (i2 >>> 0 >= i4 >>> 0) {
   i8 = 11;
   break;
  }
  i1 = HEAP8[i1 + 26 >> 0] | 0;
 } while ((i1 & 255) > (i3 & 255));
 if ((i8 | 0) == 11) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
 if (i1 << 24 >> 24 == i3 << 24 >> 24) {
  HEAP32[i7 >> 2] = i6;
  HEAP32[i7 + 4 >> 2] = (i2 - i5 | 0) / 24 | 0;
  return;
 } else {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
}

function __ZNKSt3__212ctype_bynameIwE11do_scan_notEtPKwS3_(i2, i3, i1, i14) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i13 = i2 + 8 | 0;
 i10 = i3 & 65535;
 i11 = (i10 & 8192 | 0) == 0;
 i12 = (i10 & 16384 | 0) == 0;
 i3 = (i10 & 2 | 0) == 0;
 i4 = (i10 & 256 | 0) == 0;
 i5 = (i10 & 512 | 0) == 0;
 i6 = (i10 & 1024 | 0) == 0;
 i7 = (i10 & 2048 | 0) == 0;
 i8 = (i10 & 4 | 0) == 0;
 i9 = (i10 & 4096 | 0) == 0;
 i10 = (i10 & 1 | 0) == 0;
 L1 : while (1) {
  if ((i1 | 0) == (i14 | 0)) {
   i1 = i14;
   break;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (i11) i15 = 5; else if (!(_iswspace_l(i2, HEAP32[i13 >> 2] | 0) | 0)) i15 = 5;
  do if ((i15 | 0) == 5) {
   i15 = 0;
   if (!i12) if (_iswprint_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i3) if (_iswcntrl_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i4) if (_iswupper_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i5) if (_iswlower_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i6) if (_iswalpha_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i7) if (_iswdigit_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i8) if (_iswpunct_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (!i9) if (_iswxdigit_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
   if (i10) break L1;
   if (!(_iswblank_l(i2, HEAP32[i13 >> 2] | 0) | 0)) break L1;
  } while (0);
  i1 = i1 + 4 | 0;
 }
 return i1 | 0;
}

function __ZN9LensFlare8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 36 | 0, i1);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7 + 40 | 0, i1);
 i3 = i7 + 56 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 60 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i7 + 64 | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIbNS0_19ReflectionAllocatorIbEEE15growAndPushBackERKb(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i11 + 8 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i8 | 0, i9 | 0, (i1 ? gb + 832410 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i11 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + i6 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 if ((i6 | 0) > 0) {
  i2 = i1;
  i3 = i8;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i3 = i3 + 1 | 0;
  }
 }
 HEAP8[i7 >> 0] = HEAP8[i10 >> 0] | 0;
 if ((i8 | 0) == 0 | (HEAP32[i4 >> 2] | 0) < 0) {
  i10 = i6;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i4 >> 2] = i9;
  i11 = i10 + 1 | 0;
  HEAP32[i5 >> 2] = i11;
  i11 = i1 + i10 | 0;
  return i11 | 0;
 }
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i8 | 0);
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i4 >> 2] = i9;
 i11 = i10 + 1 | 0;
 HEAP32[i5 >> 2] = i11;
 i11 = i1 + i10 | 0;
 return i11 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 32 | 0;
 i8 = i9 + 16 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 12; else i1 = (HEAP32[i1 >> 2] | 0) + 12 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN2UI6CanvasD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 186552 + 8;
 HEAP32[i5 + 440 >> 2] = 0;
 HEAP32[i5 + 436 >> 2] = 0;
 i1 = HEAP32[i5 + 424 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 428 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i2 = i5 + 228 | 0;
 i1 = i5 + 268 | 0;
 if ((HEAP32[i5 + 284 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 272 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 248 | 0;
 if ((HEAP32[i5 + 264 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 252 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i5 + 244 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5 + 232 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i5 + 196 | 0;
 if ((HEAP32[i5 + 212 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 200 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 176 | 0;
 if ((HEAP32[i5 + 192 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = gb + 37748 + 8;
  HEAP32[i5 >> 2] = gb + 29060 + 8;
  HEAP32[i5 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 180 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 37748 + 8;
 HEAP32[i5 >> 2] = gb + 29060 + 8;
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7mecanim12statemachine22StateMachineEvaluationEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __GLOBAL__sub_I_runtime_camera_renderloops2_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115160 | 0, gb + 388201 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115172 | 0, gb + 388216 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115184 | 0, gb + 388238 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115196 | 0, gb + 388265 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115208 | 0, gb + 388286 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115220 | 0, gb + 388325 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115232 | 0, gb + 388371 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115244 | 0, gb + 388388 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115256 | 0, gb + 388402 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115268 | 0, gb + 388417 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1115280 | 0, gb + 388402 | 0, 0, 0);
 return;
}

function _UNITY_FT_Create_Class_cff_driver_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 96, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _cff_driver_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 1281;
  HEAP32[i5 + 4 >> 2] = 68;
  HEAP32[i5 + 8 >> 2] = gb + 1006900;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2625;
  HEAP32[i5 + 28 >> 2] = fb + 3842;
  HEAP32[i5 + 32 >> 2] = fb + 1012;
  HEAP32[i5 + 36 >> 2] = 768;
  HEAP32[i5 + 40 >> 2] = 48;
  HEAP32[i5 + 44 >> 2] = 172;
  HEAP32[i5 + 48 >> 2] = fb + 177;
  HEAP32[i5 + 52 >> 2] = fb + 3843;
  HEAP32[i5 + 56 >> 2] = fb + 2626;
  HEAP32[i5 + 60 >> 2] = fb + 3844;
  HEAP32[i5 + 64 >> 2] = fb + 2627;
  HEAP32[i5 + 68 >> 2] = fb + 3845;
  HEAP32[i5 + 72 >> 2] = fb + 178;
  HEAP32[i5 + 76 >> 2] = fb + 179;
  HEAP32[i5 + 80 >> 2] = 0;
  HEAP32[i5 + 84 >> 2] = fb + 178;
  HEAP32[i5 + 88 >> 2] = fb + 1013;
  HEAP32[i5 + 92 >> 2] = fb + 1014;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZNSt3__210__stdinbufIwE9pbackfailEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i8 = i10 + 8 | 0;
 i4 = i10 + 4 | 0;
 i5 = i10;
 i9 = i3 + 52 | 0;
 i2 = (HEAP8[i9 >> 0] | 0) != 0;
 L1 : do if ((i1 | 0) == -1) if (i2) i1 = -1; else {
  i1 = HEAP32[i3 + 48 >> 2] | 0;
  HEAP8[i9 >> 0] = (i1 | 0) != -1 & 1;
 } else {
  L5 : do if (i2) {
   i2 = i3 + 48 | 0;
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   i11 = HEAP32[i3 + 36 >> 2] | 0;
   switch (mftCall_iiiiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i3 + 40 >> 2] | 0, i4 | 0, i4 + 4 | 0, i5 | 0, i7 | 0, i7 + 8 | 0, i8 | 0) | 0) {
   case 1:
   case 2:
    break;
   case 3:
    {
     HEAP8[i7 >> 0] = HEAP32[i2 >> 2];
     HEAP32[i8 >> 2] = i7 + 1;
     i6 = 8;
     break;
    }
   default:
    i6 = 8;
   }
   L9 : do if ((i6 | 0) == 8) {
    i3 = i3 + 32 | 0;
    while (1) {
     i4 = HEAP32[i8 >> 2] | 0;
     if (i4 >>> 0 <= i7 >>> 0) break;
     i11 = i4 + -1 | 0;
     HEAP32[i8 >> 2] = i11;
     if ((_ungetc(HEAP8[i11 >> 0] | 0, HEAP32[i3 >> 2] | 0) | 0) == -1) break L9;
    }
    break L5;
   } while (0);
   i1 = -1;
   break L1;
  } else i2 = i3 + 48 | 0; while (0);
  HEAP32[i2 >> 2] = i1;
  HEAP8[i9 >> 0] = 1;
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN9dtNavMesh25clearAllOffMeshConnectionEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i10 = i9 + 52 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i10 >> 2] = -1;
  return;
 }
 i11 = i9 + 48 | 0;
 i12 = i9 + 40 | 0;
 i13 = i9 + 36 | 0;
 i14 = i9 + 28 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 do {
  i7 = i1;
  i1 = HEAP32[i3 + (i1 * 104 | 0) + 96 >> 2] | 0;
  i2 = HEAP32[i3 + (i7 * 104 | 0) + 92 >> 2] | 0;
  i6 = _bitshift64Shl(i2 | 0, 0, 48) | 0;
  i5 = getTempRet0() | 0;
  i6 = i7 | i6 | 65536;
  i8 = i3 + (i7 * 104 | 0) + 88 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if ((i4 | 0) != -1) {
   i2 = i4;
   i3 = HEAP32[i13 >> 2] | 0;
   do {
    i4 = i2;
    i2 = HEAP32[i3 + (i2 << 4) + 8 >> 2] | 0;
    i15 = i3 + (i4 << 4) | 0;
    __ZN9dtNavMesh17removeLinkBetweenEyy(i9, HEAP32[i15 >> 2] | 0, HEAP32[i15 + 4 >> 2] | 0, i6, i5);
    i3 = HEAP32[i13 >> 2] | 0;
    HEAP32[i3 + (i4 << 4) + 8 >> 2] = HEAP32[i14 >> 2];
    HEAP32[i14 >> 2] = i4;
   } while ((i2 | 0) != -1);
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = i2;
   i2 = HEAP32[i2 + (i7 * 104 | 0) + 92 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = -1;
  i15 = i2 + 1 | 0;
  HEAP32[i3 + (i7 * 104 | 0) + 92 >> 2] = (i15 | 0) == 0 ? 1 : i15;
  HEAP32[i3 + (i7 * 104 | 0) + 96 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i12 >> 2] = i7;
 } while ((i1 | 0) != -1);
 HEAP32[i10 >> 2] = -1;
 return;
}

function __ZN2UI11CanvasGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 40 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 42 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN26AnimatorControllerPlayable12GetLayerNameEi(i5, i2, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i6 = i7 + 4 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) {
  if ((i3 | 0) >= 0) {
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) i1 = HEAP32[HEAP32[i2 + 92 >> 2] >> 2] | 0; else i1 = 0;
   if ((i1 | 0) > (i3 | 0)) {
    i4 = HEAP32[i2 + 84 >> 2] | 0;
    i6 = (HEAP32[i2 + 92 >> 2] | 0) + 4 | 0;
    i6 = i6 + (HEAP32[i6 >> 2] | 0) + (i3 << 2) | 0;
    mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0);
    STACKTOP = i7;
    return;
   }
  }
  HEAP32[i4 >> 2] = i3;
  __Z6FormatPKcz(i6, gb + 902210 | 0, i4);
  i1 = HEAP32[i2 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1576256 | 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN19ClampVelocityModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83464 + 8;
 i1 = i2 + 1032 | 0;
 if ((HEAP32[i2 + 1048 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 1036 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 944 | 0;
 if ((HEAP32[i2 + 960 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 948 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18AnimatorControllerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 178116 + 8;
 i1 = i5 + 192 | 0;
 if ((HEAP32[i5 + 208 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 196 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 172 | 0;
 if ((HEAP32[i5 + 188 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 176 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 160 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 164 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i2 | 0) >>> 4) << 4);
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i5 + 140 | 0, HEAP32[i5 + 144 >> 2] | 0);
 HEAP32[i5 + 104 >> 2] = gb + 176376 + 8;
 i2 = i5 + 112 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 + 116 >> 2] = 0;
 HEAP32[i5 + 120 >> 2] = 0;
 i1 = i5 + 80 | 0;
 if ((HEAP32[i5 + 96 >> 2] | 0) <= -1) {
  __ZN25RuntimeAnimatorControllerD2Ev(i5);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN25RuntimeAnimatorControllerD2Ev(i5);
 return;
}

function __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 44300 + 8;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 2;
 HEAP32[i1 + 104 >> 2] = 2;
 HEAP32[i1 + 108 >> 2] = 2;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP8[i1 + 116 >> 0] = 0;
 HEAP8[i1 + 117 >> 0] = 1;
 i3 = i1 + 118 | 0;
 HEAP16[i3 >> 1] = 0;
 HEAP16[i3 + 2 >> 1] = 0;
 HEAP8[i3 + 4 >> 0] = 0;
 HEAP8[i1 + 123 >> 0] = 1;
 i3 = i1 + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = i1;
 HEAP32[i1 + 80 >> 2] = 256;
 HEAP32[i1 + 84 >> 2] = 256;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 88 >> 2] = 1;
 HEAP32[i1 + 44 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP8[i1 + 156 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iii(i2, i3, i4, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 32 | 0;
 i9 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 HEAP32[i9 + 28 >> 2] = 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   i12 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
   i13 = i12 + 28 | 0;
   i11 = HEAP16[i13 >> 1] | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP32[i8 + (i1 << 2) >> 2] = i11 & 255;
   HEAP8[i12 + 29 >> 0] = 0;
   HEAP32[i9 + (i1 << 2) >> 2] = (i11 & 65535) >>> 8 & 65535;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i12 = HEAP32[i4 + 4 >> 2] | 0;
 i11 = i12 + 28 | 0;
 i13 = HEAP16[i11 >> 1] | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP8[i12 + 29 >> 0] = 0;
 __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iiiPKiS3_ii(i2, i3, i4, i5, i6, i7, i8, i9, i13 & 255, (i13 & 65535) >>> 8 & 65535);
 STACKTOP = i10;
 return;
}

function _sep_upsample(i8, i4, i9, i1, i10, i11, i12) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i8 + 416 >> 2] | 0;
 i7 = i6 + 92 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i8 + 276 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) >= (i1 | 0)) {
  i3 = i8 + 36 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 0) {
   i1 = HEAP32[i8 + 196 >> 2] | 0;
   i2 = 0;
   while (1) {
    mftCall_viiii(HEAP32[i6 + 52 + (i2 << 2) >> 2] | 0, i8 | 0, i1 | 0, (HEAP32[i4 + (i2 << 2) >> 2] | 0) + ((Math_imul(HEAP32[i6 + 100 + (i2 << 2) >> 2] | 0, HEAP32[i9 >> 2] | 0) | 0) << 2) | 0, i6 + 12 + (i2 << 2) | 0);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (HEAP32[i3 >> 2] | 0)) break; else i1 = i1 + 84 | 0;
   }
   i1 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = 0;
  i2 = 0;
 }
 i1 = i1 - i2 | 0;
 i4 = i6 + 96 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = i1 >>> 0 > i3 >>> 0 ? i3 : i1;
 i3 = HEAP32[i11 >> 2] | 0;
 i12 = i12 - i3 | 0;
 i12 = i1 >>> 0 > i12 >>> 0 ? i12 : i1;
 mftCall_viiiii(HEAP32[(HEAP32[i8 + 420 >> 2] | 0) + 4 >> 2] | 0, i8 | 0, i6 + 12 | 0, i2 | 0, i10 + (i3 << 2) | 0, i12 | 0);
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i12;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - i12;
 i12 = (HEAP32[i7 >> 2] | 0) + i12 | 0;
 HEAP32[i7 >> 2] = i12;
 if ((i12 | 0) < (HEAP32[i5 >> 2] | 0)) return;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 return;
}

function __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = i9 + 8 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if ((i1 | 0) != (i10 | 0)) do {
  HEAP32[i11 >> 2] = i1 + -36;
  i8 = i1 + -16 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if (i2 | 0) {
   i7 = i1 + -12 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i3 | 0) != (i2 | 0)) {
    do {
     i4 = i3 + -20 | 0;
     HEAP32[i7 >> 2] = i4;
     i5 = HEAP32[i3 + -12 >> 2] | 0;
     i6 = i5;
     if (!i5) i3 = i4; else {
      i3 = i3 + -8 | 0;
      i4 = HEAP32[i3 >> 2] | 0;
      if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i6 | 0) >>> 0) / 24 | 0) * 24 | 0);
      __ZdlPv(i5);
      i3 = HEAP32[i7 >> 2] | 0;
     }
    } while ((i3 | 0) != (i2 | 0));
    i2 = HEAP32[i8 >> 2] | 0;
   }
   __ZdlPv(i2);
  }
  i3 = i1 + -28 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i2 = i1 + -24 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == (i4 | 0)) i1 = i4; else {
    do {
     i8 = i1 + -96 | 0;
     HEAP32[i2 >> 2] = i8;
     __ZN19ComputeShaderKernelD2Ev(i8);
     i1 = HEAP32[i2 >> 2] | 0;
    } while ((i1 | 0) != (i4 | 0));
    i1 = HEAP32[i3 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i1 = HEAP32[i11 >> 2] | 0;
 } while ((i1 | 0) != (i10 | 0));
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210__stdinbufIcE9pbackfailEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i8 = i10 + 4 | 0;
 i4 = i10 + 8 | 0;
 i5 = i10;
 i9 = i3 + 52 | 0;
 i2 = (HEAP8[i9 >> 0] | 0) != 0;
 L1 : do if ((i1 | 0) == -1) if (i2) i1 = -1; else {
  i1 = HEAP32[i3 + 48 >> 2] | 0;
  HEAP8[i9 >> 0] = (i1 | 0) != -1 & 1;
 } else {
  L5 : do if (i2) {
   i2 = i3 + 48 | 0;
   HEAP8[i4 >> 0] = HEAP32[i2 >> 2];
   i11 = HEAP32[i3 + 36 >> 2] | 0;
   switch (mftCall_iiiiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i3 + 40 >> 2] | 0, i4 | 0, i4 + 1 | 0, i5 | 0, i7 | 0, i7 + 8 | 0, i8 | 0) | 0) {
   case 1:
   case 2:
    break;
   case 3:
    {
     HEAP8[i7 >> 0] = HEAP32[i2 >> 2];
     HEAP32[i8 >> 2] = i7 + 1;
     i6 = 8;
     break;
    }
   default:
    i6 = 8;
   }
   L9 : do if ((i6 | 0) == 8) {
    i3 = i3 + 32 | 0;
    while (1) {
     i4 = HEAP32[i8 >> 2] | 0;
     if (i4 >>> 0 <= i7 >>> 0) break;
     i11 = i4 + -1 | 0;
     HEAP32[i8 >> 2] = i11;
     if ((_ungetc(HEAP8[i11 >> 0] | 0, HEAP32[i3 >> 2] | 0) | 0) == -1) break L9;
    }
    break L5;
   } while (0);
   i1 = -1;
   break L1;
  } else i2 = i3 + 48 | 0; while (0);
  HEAP32[i2 >> 2] = i1;
  HEAP8[i9 >> 0] = 1;
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN5physx9NpFactory21onArticulationReleaseEPNS_14PxArticulationE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i9 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i9 + 504 >> 2] | 0;
 if (!i1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i2 = i7;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i2 = (HEAP32[i9 + 496 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i5 = HEAP32[i9 + 488 >> 2] | 0;
 i6 = HEAP32[i9 + 492 >> 2] | 0;
 i3 = i1;
 i4 = i2;
 while (1) {
  i1 = i4;
  i4 = i6 + (i3 << 2) | 0;
  i2 = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
  if ((i3 | 0) == -1) {
   i10 = 7;
   break;
  }
 }
 if ((i10 | 0) == 7) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i10 = i9 + 520 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 i10 = i9 + 516 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i9 + 512 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i2;
 i10 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_18PxProfileEventNameENS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = i10 + 12 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i5 = 0; else {
  i5 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i9 << 3 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + (i1 << 3) | 0;
 i8 = i10 + 4 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i13 = i2;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i11 = i4;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i5 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i13 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 >> 2] = i9;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i13 + 1;
 return i5 + (i13 << 3) | 0;
}

function __ZN5physx2Sc16InteractionScene4initERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS7_13EventProfilerE(i1, i3, i5, i6, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i1 = i1 + 1e3 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx10PxsContextD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7 + 4 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i9 | 0, i8 | 0, 7652, (i2 ? gb + 713458 | 0 : gb + 837976 | 0) | 0, gb + 679598 | 0, 60) | 0;
 __ZN5physx10PxsContextC2ERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS6_13EventProfilerEj(i2, i3, i5, i6, i4, 64);
 HEAP32[i1 >> 2] = i2;
 if (i2 | 0) {
  i9 = 1;
  STACKTOP = i7;
  return i9 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 679598 | 0, 64, gb + 713566 | 0, i7);
 i9 = 0;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN5physx20InternalTriangleMesh7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 152 | 0;
 if (!(HEAP32[i2 + 200 >> 2] | 0)) {
  i4 = i2 + 8 | 0;
  i7 = i2 + 164 | 0;
  i6 = i2 + 168 | 0;
  i5 = i2 + 160 | 0;
  i2 = i2 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 5 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  i8 = i2 + 164 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 4 | 0, HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = 0;
  i4 = i2 + 168 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 3 | 0, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  i5 = i2 + 160 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 2 | 0, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = 0;
  i6 = i2 + 12 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i6 >> 2] | 0);
  HEAP32[i6 >> 2] = 0;
  i7 = i2 + 8 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i7 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
  i2 = i8;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i3;
  return;
 }
}

function __ZN22BaseUnityConnectClient20OnEnterStatePreparedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i3 = i5;
 i4 = i1 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 2;
 i4 = i1 + 110 | 0;
 if ((i6 | 0) == 4) if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i4 >> 0] = 0;
 if (HEAP8[i1 + 111 >> 0] | 0) {
  __ZN22BaseUnityConnectClient22UpdateConfigFromServerEv(i1);
  STACKTOP = i5;
  return;
 }
 i4 = HEAP32[i1 + 280 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i6 = i3 + 11 | 0;
 HEAP8[i6 >> 0] = 6;
 HEAP8[i3 >> 0] = HEAP8[gb + 1040788 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[gb + 1040788 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[gb + 1040788 + 2 >> 0] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[gb + 1040788 + 3 >> 0] | 0;
 HEAP8[i3 + 4 >> 0] = HEAP8[gb + 1040788 + 4 >> 0] | 0;
 HEAP8[i3 + 5 >> 0] = HEAP8[gb + 1040788 + 5 >> 0] | 0;
 HEAP8[i3 + 6 >> 0] = 0;
 __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr(i4, i3) | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i2);
 }
 STACKTOP = i5;
 return;
}

function __ZN14RenderSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i7 = i4;
 i2 = i1 + 344 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i8 = Math_fround(HEAPF32[i2 >> 2]) < Math_fround(0.0);
 i8 = i8 ? i6 : i2;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i9 = Math_fround(HEAPF32[i8 >> 2]) > Math_fround(1.0);
 HEAP32[i2 >> 2] = HEAP32[(i9 ? i7 : i8) >> 2];
 i2 = i1 + 300 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i8 = Math_fround(HEAPF32[i2 >> 2]) < Math_fround(0.0);
 i6 = i8 ? i6 : i2;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 i8 = Math_fround(HEAPF32[i6 >> 2]) > Math_fround(1.0);
 HEAP32[i2 >> 2] = HEAP32[(i8 ? i7 : i6) >> 2];
 i2 = i1 + 372 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i6 | 0) > 2 ? i6 : 2;
 i2 = i1 + 340 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 336 >> 2]) + Math_fround(.00999999977));
 if (!(f5 < f3)) {
  i9 = i1 + 376 | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i7 = (i8 | 0) < 1;
  i6 = (i8 | 0) > 5;
  i8 = i6 ? 5 : i8;
  i8 = i7 ? 1 : i8;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i4;
  return;
 }
 HEAPF32[i2 >> 2] = f3;
 i9 = i1 + 376 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i7 = (i8 | 0) < 1;
 i6 = (i8 | 0) > 5;
 i8 = i6 ? 5 : i8;
 i8 = i7 ? 1 : i8;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i4;
 return;
}

function __ZN10SampleClipC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 170392 + 8;
 i3 = i1 + 32 | 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 __ZN11SoundHandleC2Ev(i1 + 56 | 0);
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP8[i1 + 64 >> 0] = 1;
 HEAP8[i1 + 65 >> 0] = 0;
 HEAP8[i1 + 66 >> 0] = 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = i1;
 HEAP32[i1 + 120 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen14UnityLogoStyleEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z18ParseGfxDeviceArgsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 396599 | 0, 16);
 i3 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (i3) {
  HEAP32[gb + 39068 >> 2] = 0;
  STACKTOP = i2;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 396616 | 0, 12);
 i3 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (i3) {
  HEAP32[gb + 39068 >> 2] = 2;
  STACKTOP = i2;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 396629 | 0, 12);
 i3 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 if (!i3) {
  STACKTOP = i2;
  return;
 }
 HEAP32[gb + 39068 >> 2] = 1;
 STACKTOP = i2;
 return;
}

function __ZZN22ParticleSystemRenderer15InitializeClassEvEN29FunctorImpl_104kDidDeleteMesh4CallEPviR11MessageData(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i4 + 408 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 424 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 428 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 412 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 436 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 440 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 416 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 448 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 452 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 420 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) return;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 460 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i5 = i4 + 464 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN8Material7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 477942 | 0, 40) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 67512 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 i1 = i4 + 48 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i1;
 i1 = i4 + 60 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = i1;
 i1 = i4 + 72 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = i1;
 i1 = i4 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i4 + 96 >> 2] = 5;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = i10 + 12 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i5 = 0; else {
  i5 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i9 << 3 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + (i1 << 3) | 0;
 i8 = i10 + 4 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   i13 = i2;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i1;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i11 = i4;
 i12 = HEAP32[i11 + 4 >> 2] | 0;
 i13 = i5 + (i1 << 3) | 0;
 HEAP32[i13 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i13 + 4 >> 2] = i12;
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i13 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 >> 2] = i9;
 i13 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i13 + 1;
 return i5 + (i13 << 3) | 0;
}

function __ZN27AnimationLayerMixerPlayableC2E18DirectorPlayerType(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i2, 0, 0);
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2 + 64 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP8[i2 + 72 >> 0] = 0;
 HEAP8[i2 + 73 >> 0] = 0;
 HEAP8[i2 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i2 + 76 | 0);
 HEAP32[i2 >> 2] = gb + 176908 + 8;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 + 84 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = 0;
 HEAP32[i2 + 116 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 104 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i2 + 120 >> 0] = 1;
 STACKTOP = i1;
 return;
}

function __ZN14dtPathCorridor25moveOverOffmeshConnectionEyPfS0_PK14dtNavMeshQuery(i8, i4, i5, i9, i10, i11) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAP32[i8 + 28 >> 2] | 0;
 i13 = i8 + 32 | 0;
 i14 = HEAP32[i13 >> 2] | 0;
 i1 = i12;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i14 | 0) < 1 | (i3 | 0) == (i4 | 0) & (i1 | 0) == (i5 | 0)) {
  i2 = 0;
  i5 = 0;
  i4 = 0;
 } else if ((i14 | 0) < 2 | (i3 | 0) == (i4 | 0) & (i1 | 0) == (i5 | 0)) {
  i2 = 1;
  i5 = i3;
  i4 = i1;
 } else {
  i2 = 1;
  while (1) {
   i7 = i12 + (i2 << 3) | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = i2 + 1 | 0;
   if ((i14 | 0) <= (i2 | 0) | (i6 | 0) == (i4 | 0) & (i7 | 0) == (i5 | 0)) {
    i5 = i3;
    i4 = i1;
    i3 = i6;
    i1 = i7;
    break;
   } else {
    i3 = i6;
    i1 = i7;
   }
  }
 }
 if ((i14 | 0) == (i2 | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 i14 = i14 - i2 | 0;
 _memmove(i12 | 0, i12 + (i2 << 3) | 0, i14 << 3 | 0) | 0;
 HEAP32[i13 >> 2] = i14;
 if (!((__ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_(HEAP32[i11 >> 2] | 0, i5, i4, i3, i1, i9, i10) | 0) & 1073741824)) {
  i14 = 0;
  return i14 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 i14 = 1;
 return i14 | 0;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen13AnimationModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z16CleanupAfterLoadv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 6944 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 6176 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 6176 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 6176 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN19RenderBufferManager14GarbageCollectEi(__Z22GetRenderBufferManagerv() | 0, 0);
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __Z29ClearRepeatingLogMessageStatev();
 __Z27scripting_gc_collect_unsafei(__Z26scripting_gc_maxgenerationv() | 0);
 __ZN13RenderManager18UpdateAllRenderersEv();
 i1 = __Z22GetGameManagerIfExistsi(9) | 0;
 if (!i1) {
  i4 = __Z21GetDelayedCallManagerv() | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i3 = i3 + 104 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(i3 | 0, i4 | 0, 16);
  i4 = __Z18GetQualitySettingsv() | 0;
  __ZN15QualitySettings13ApplySettingsEib(i4, -1, 0);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 i4 = __Z21GetDelayedCallManagerv() | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i3 = i3 + 104 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(i3 | 0, i4 | 0, 16);
 i4 = __Z18GetQualitySettingsv() | 0;
 __ZN15QualitySettings13ApplySettingsEib(i4, -1, 0);
 return;
}

function __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE7reserveEj(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = i9 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i7 = i1;
 if ((((HEAP32[i10 >> 2] | 0) - i1 | 0) / 44 | 0) >>> 0 >= i4 >>> 0) return;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 44 | 0) | 0;
 i6 = i5 + (((i2 - i1 | 0) / 44 | 0) * 44 | 0) | 0;
 i8 = i6;
 i4 = i5 + (i4 * 44 | 0) | 0;
 if ((i3 | 0) == (i7 | 0)) i2 = i8; else {
  i2 = i8;
  i1 = i6;
  do {
   i6 = i3;
   i3 = i3 + -44 | 0;
   HEAP32[i1 + -44 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + -40 >> 2] = HEAP32[i6 + -40 >> 2];
   HEAP32[i1 + -36 >> 2] = HEAP32[i6 + -36 >> 2];
   HEAP32[i1 + -32 >> 2] = HEAP32[i6 + -32 >> 2];
   HEAP32[i1 + -28 >> 2] = HEAP32[i6 + -28 >> 2];
   HEAP32[i1 + -24 >> 2] = HEAP32[i6 + -24 >> 2];
   i13 = i6 + -20 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i5 = i1 + -20 | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = i12;
   HEAP32[i1 + -12 >> 2] = HEAP32[i6 + -12 >> 2];
   HEAP32[i1 + -8 >> 2] = HEAP32[i6 + -8 >> 2];
   HEAP32[i1 + -4 >> 2] = HEAP32[i6 + -4 >> 2];
   i1 = i2 + -44 | 0;
   i2 = i1;
  } while ((i3 | 0) != (i7 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i4;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm12RenderBufferD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 86472 + 8;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i3 | 0) < 0 | (i3 & 2147483647 | 0) == 0))) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5physx20solveConcludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = HEAP16[i2 + 26 >> 1] | 0;
 i9 = i1 + ((i8 & 65535) << 4) | 0;
 if (!(i8 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i8 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i7 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i7 = 32;
   i2 = i3;
   i3 = i4;
  } else {
   i6 = i2 & 255;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f5 = Math_fround(HEAPF32[i2 >> 2]);
    i10 = f5 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i10 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i3 = (Math_imul(i7, i6) | 0) + 32 | 0;
   i7 = i3;
   i2 = HEAP8[i1 >> 0] | 0;
   i3 = i1 + i3 | 0;
  }
  i6 = i2 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i8 << 24 >> 24)) i1 = i3; else {
   i4 = i8 & 255;
   i2 = i3;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i4 | 0)) break; else i2 = i2 + i6 | 0;
   }
   i1 = i1 + ((Math_imul(i6, i4) | 0) + i7) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN19ShaderPropertySheet30SetTextureWithNoScaleAndOffsetERKN9ShaderLab16FastPropertyNameEP7Texture(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i8 = HEAP32[i2 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i8 | 0)) {
  i4 = HEAP32[i2 + 32 >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i8 | 0)) break L1;
  }
  if ((i1 | 0) > -1) {
   i8 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i2, i8, i3, i6, 1);
   STACKTOP = i9;
   return;
  }
 } while (0);
 __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i7, i2, i3, 3, 32, 0, 0);
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = (HEAP32[i2 + 72 >> 2] | 0) + i8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 1;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i7 + 16 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = -1;
 __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i2, i8, i3, i6, 1);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN14SafeBinaryRead10SetVersionEi(i5, 2);
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 0) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   i3 = i5 + 16 | 0;
   i2 = HEAP32[i5 + 20 >> 2] | 0;
   i1 = i2 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
    i2 = i1 + 4 | 0;
    if (i2 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
     HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
     HEAP32[i3 >> 2] = i2;
    }
   }
   if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i6, 4);
   if (HEAP32[i5 >> 2] & 512 | 0) HEAP32[i6 >> 2] = _llvm_bswap_i32(HEAP32[i6 >> 2] | 0) | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i5, 1) | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!(i1 & 32)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = i1 | -65536;
 STACKTOP = i7;
 return;
}

function __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i1, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085899 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN21BuiltinShaderSettings17BuiltinShaderModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z17PrepareSceneNodesP11CullResults(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i1 = i7;
 if ((HEAP16[gb + 1110680 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110680 | 0, i5);
  i1 = gb + 1110680 | 0;
 } else i1 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(2740, gb + 64024 | 0, 16, gb + 375948 | 0, 400) | 0;
 __ZN24PrepareSceneNodesJobDataC2Ev(i2);
 __ZN24PrepareSceneNodesJobDataC2Ev(i2 + 532 | 0);
 __ZN24PrepareSceneNodesJobDataC2Ev(i2 + 1064 | 0);
 __ZN24PrepareSceneNodesJobDataC2Ev(i2 + 1596 | 0);
 __ZN24PrepareSceneNodesJobDataC2Ev(i2 + 2128 | 0);
 i3 = i2 + 2660 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 + 2732 >> 2] = 5;
 HEAP32[i2 + 2736 >> 2] = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i5, fb + 3321 | 0, i2, i6 + 8 | 0, 0);
 __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i6 + 84 | 0, fb + 2373 | 0, i2, 5, i5, fb + 3322 | 0, 0);
 __Z21ClearFenceWithoutSyncR8JobFence(i5);
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i7;
 return;
}

function __ZNSt3__214collate_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212740 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0, 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 do if (i6 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1082005 | 0, i4 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNSt3__214collate_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212708 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0, 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 do if (i6 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1082083 | 0, i4 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZNK4PPtrIN5Unity9ComponentEEcvPS1_Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) < 1) i1 = 0; else i1 = __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode(__Z20GetPersistentManagerv() | 0, i1, -1) | 0;
 }
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNK25BlendshapePropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 12 | 0;
 i4 = i1;
 i8 = HEAP32[gb + 57896 >> 2] | 0;
 __Z11IntToStringi(i4, HEAP32[i3 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i7 = _strlen(i8) | 0;
 i6 = i4 + 11 | 0;
 i3 = HEAP8[i6 >> 0] | 0;
 i3 = i3 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i5, i8, i7, i3 + i7 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i3) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i2, i6 ? HEAP32[i5 >> 2] | 0 : i5, i3, i3 + 1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i2, 93);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i1;
 return;
}

function __ZNK14ImageReference9ClipImageEiiii(i8, i6, i1, i2, i3, i4) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i6 + 16 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i8 + 12 >> 2] = 0;
  HEAP32[i8 + 16 >> 2] = 0;
  return;
 }
 i5 = i6 + 4 | 0;
 if ((i1 | 0) < 0) i1 = 0; else {
  i9 = HEAP32[i5 >> 2] | 0;
  i1 = (i9 | 0) < (i1 | 0) ? i9 : i1;
 }
 i12 = HEAP32[i6 + 8 >> 2] | 0;
 i11 = (i2 | 0) < 0 ? 0 : (i12 | 0) < (i2 | 0) ? i12 : i2;
 i2 = i1 + i3 | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 i10 = ((i2 | 0) < (i10 | 0) ? i2 : i10) - i1 | 0;
 i2 = i11 + i4 | 0;
 i2 = ((i2 | 0) < (i12 | 0) ? i2 : i12) - i11 | 0;
 i4 = (i10 | 0) > 0;
 i5 = (i2 | 0) > 0;
 i12 = __Z25GetBytesFromTextureFormat13TextureFormat(HEAP32[i6 >> 2] | 0) | 0;
 i9 = HEAP32[i6 + 12 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i7 >> 2] | 0) + (Math_imul(i12, i1) | 0) + (Math_imul(i9, i11) | 0) | 0;
 HEAP32[i8 + 4 >> 2] = i4 ? i10 : 0;
 HEAP32[i8 + 8 >> 2] = i5 ? i2 : 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i9;
 if (i1 | 0) {
  if ((i3 | 0) < 9) i2 = 1; else i2 = (i3 | 0) == 1e3 | ((i3 | 0) == 23 | (i3 + -13 | 0) >>> 0 < 9);
  if (i4 & i5 & (i3 | 0) > 0 & i2) {
   HEAP32[i8 + 16 >> 2] = i1;
   return;
  }
 }
 HEAP32[i8 + 16 >> 2] = 0;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setProjectionPlaneERKNS_6PxVec3Ef(i4, i1, f12) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f12 = Math_fround(f12);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i10;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i11;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i8;
 HEAPF32[i2 + 12 >> 2] = f12;
 i9 = i4 + 20 | 0;
 i1 = i4 + 32 | 0;
 i7 = i4 + 24 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 switch (i6 >>> 30 | 0) {
 case 3:
  {
   i3 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 4; else i3 = i9;
   break;
  }
 default:
  i5 = 4;
 }
 if ((i5 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE(i1, i2);
  STACKTOP = i13;
  return;
 }
 i2 = i4 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i6 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 28 >> 2] = i10;
 HEAP32[i1 + 32 >> 2] = i11;
 HEAP32[i1 + 36 >> 2] = i8;
 HEAPF32[i1 + 40 >> 2] = f12;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i9);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 512;
 STACKTOP = i13;
 return;
}

function __ZN20SoundChannelInstance20set3DConeOrientationEP11FMOD_VECTOR(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i2 + 164 >> 2] | 0;
 if (i3 | 0) {
  i7 = (i1 | 0) == 0;
  i8 = i2 + 148 | 0;
  i9 = HEAP16[i8 >> 1] | 0;
  HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
  i8 = i2 + 28 | 0;
  HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i2 = i2 + 146 | 0;
  HEAP16[i2 >> 1] = (i7 & 1) << 2 & 65535 | HEAP16[i2 >> 1] & -5;
 }
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel20set3DConeOrientationEP11FMOD_VECTOR(i1, i3) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 179;
 HEAP32[i5 + 8 >> 2] = gb + 865586;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i4, i1) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i3;
  i1 = i5;
 }
 __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j(i4, i1);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i2 = i1 + 32 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 >> 2] = i4;
  }
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084155 | 0, i5, i1, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1086064 | 0, i5, i1 + 4 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085890 | 0, i5, i1 + 8 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085926 | 0, i5, i1 + 12 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z38Font_CUSTOM_RequestCharactersInTextureP12Il2CppObjectP12Il2CppStringii(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 48 | 0;
 i12 = i6 + 40 | 0;
 i5 = i6 + 20 | 0;
 i7 = i6 + 8 | 0;
 i9 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i12, i1);
 __ZNK11ICallString6ToUTF8Ev(i7, i12);
 i1 = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
 i12 = gb + 63672 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i5, i1, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (!i2) {
  i12 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i12 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i12);
 } else {
  __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE(HEAP32[i1 + 48 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i3, Math_fround(1.0), i4, 0) | 0;
  __ZN11UTF16StringD2Ev(i5);
  STACKTOP = i6;
  return;
 }
}

function __Z16dictInsertBeforeP4DictP8DictNodePv(i2, i1, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i2 + 20 | 0;
 i4 = i2 + 12 | 0;
 i7 = i1;
 do {
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) break;
 } while (!(mftCall_iiii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 | 0, i8 | 0) | 0));
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i6 = 7; else {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i6 = 7; else HEAP32[i5 >> 2] = i2;
 }
 if ((i6 | 0) == 7) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i6 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i8 = 0;
   return i8 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   i2 = i2 - i3 | 0;
   i6 = i1;
   i1 = i4 + i2 | 0;
   HEAP32[i1 >> 2] = i6;
  } while ((i2 | 0) != 4);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  if (!i1) {
   i8 = 0;
   return i8 | 0;
  }
 }
 HEAP32[i1 >> 2] = i8;
 i8 = i7 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] = i1;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i8 >> 2] = i1;
 i8 = i1;
 return i8 | 0;
}

function _UNITY_FT_GlyphLoader_CopyPoints(i10, i3) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i7 = HEAP16[i3 + 22 >> 1] | 0;
 i8 = i7 << 16 >> 16;
 i9 = HEAP16[i3 + 20 >> 1] | 0;
 i1 = i9 << 16 >> 16;
 i12 = _UNITY_FT_GlyphLoader_CheckPoints(i10, i8, i1) | 0;
 if (i12 | 0) return i12 | 0;
 i5 = i10 + 24 | 0;
 i4 = i8 << 3;
 _memcpy(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0, i4 | 0) | 0;
 i6 = i10 + 28 | 0;
 _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i3 + 28 >> 2] | 0, i8 | 0) | 0;
 i11 = i10 + 32 | 0;
 _memcpy(HEAP32[i11 >> 2] | 0, HEAP32[i3 + 32 >> 2] | 0, i1 << 1 | 0) | 0;
 i1 = i10 + 16 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i2 = 0; else if (HEAP8[i3 + 16 >> 0] | 0) {
  _memcpy(HEAP32[i10 + 40 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, i4 | 0) | 0;
  _memcpy(HEAP32[i10 + 44 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, i4 | 0) | 0;
  i2 = HEAP8[i1 >> 0] | 0;
 }
 HEAP16[i10 + 22 >> 1] = i7;
 i1 = i10 + 20 | 0;
 HEAP16[i1 >> 1] = i9;
 HEAP32[i10 + 60 >> 2] = (HEAP32[i5 >> 2] | 0) + (i8 << 3);
 HEAP32[i10 + 64 >> 2] = (HEAP32[i6 >> 2] | 0) + i8;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i10 + 68 >> 2] = (HEAP32[i11 >> 2] | 0) + (i1 << 16 >> 16 << 1);
 if (!(i2 << 24 >> 24)) return i12 | 0;
 i11 = i1 >> 16;
 HEAP32[i10 + 76 >> 2] = (HEAP32[i10 + 40 >> 2] | 0) + (i11 << 3);
 HEAP32[i10 + 80 >> 2] = (HEAP32[i10 + 44 >> 2] | 0) + (i11 << 3);
 return i12 | 0;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE14__count_uniqueIS7_EEjRKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 8;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 8;
  if ((i7 | 0) != 7) if ((i7 | 0) == 8) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 10; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 10; else if ((i2 | 0) >= 0) {
     i1 = 1;
     i7 = 14;
     break;
    }
   }
   if ((i7 | 0) == 10) if (!i6) {
    i1 = 1;
    i7 = 14;
    break;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZN5physx9NpFactory19onConstraintReleaseEPNS_12PxConstraintE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i9 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i9 + 544 >> 2] | 0;
 if (!i1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i2 = i7;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i2 = (HEAP32[i9 + 536 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i5 = HEAP32[i9 + 528 >> 2] | 0;
 i6 = HEAP32[i9 + 532 >> 2] | 0;
 i3 = i1;
 i4 = i2;
 while (1) {
  i1 = i4;
  i4 = i6 + (i3 << 2) | 0;
  i2 = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
  if ((i3 | 0) == -1) {
   i10 = 7;
   break;
  }
 }
 if ((i10 | 0) == 7) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i10 = i9 + 560 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 i10 = i9 + 556 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i9 + 552 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i2;
 i10 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEE15growAndPushBackERKS2_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 268 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i1 = 0; else {
  i1 = i11 << 2;
  i2 = i9 + 256 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i9;
  } else {
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i1 + 67 | 0, gb + 838004 | 0, 543) | 0;
   if (!i1) i1 = 0; else {
    i7 = i1 + 67 & -64;
    HEAP32[i7 + -4 >> 2] = i7 - i1;
    i1 = i7;
   }
  }
 }
 i6 = i9 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i2 << 2) | 0;
 i7 = i9 + 260 | 0;
 if ((i2 | 0) > 0) {
  i3 = i1;
  i4 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else i4 = i4 + 4 | 0;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 do if ((HEAP32[i10 >> 2] | 0) > -1) {
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) {
   HEAP8[i9 + 256 >> 0] = 0;
   break;
  }
  if (i3) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 HEAP32[i7 >> 2] = i1;
 HEAP32[i10 >> 2] = i11;
 HEAP32[i6 >> 2] = i2 + 1;
 return i1 + (i2 << 2) | 0;
}

function __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 28 | 0;
 i10 = i12;
 if (HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 45 >> 0] & 1) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i11 >> 2] = 0;
 __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i11, i1);
 i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i11) | 0;
 if (!i1) {
  STACKTOP = i12;
  return;
 }
 i9 = i2 + 16 | 0;
 i3 = i10 + 4 | 0;
 i4 = i10 + 8 | 0;
 i5 = i10 + 12 | 0;
 i6 = i10 + 16 | 0;
 i7 = i10 + 20 | 0;
 i8 = i10 + 24 | 0;
 i2 = i1;
 do {
  i1 = i2 + 24 | 0;
  if ((HEAP32[i1 >> 2] | 0) != -1) {
   __ZNK5physx2Sc8ShapeSim10getAbsPoseEv(i10, i2);
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   HEAP32[i1 + (i2 * 28 | 0) >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 8 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 12 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 16 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 20 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i1 + (i2 * 28 | 0) + 24 >> 2] = HEAP32[i8 >> 2];
  }
  i2 = __ZN5physx2Sc13ShapeIterator7getNextEv(i11) | 0;
 } while ((i2 | 0) != 0);
 STACKTOP = i12;
 return;
}

function __ZN5Unity17ConfigurableJoint20SetHighAngularXLimitERK14SoftJointLimit(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 f2 = Math_fround(HEAPF32[i6 + 148 >> 2]);
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f2 < Math_fround(-177.0);
 i7 = f2 > Math_fround(177.0);
 f2 = i7 ? Math_fround(177.0) : f2;
 i7 = i1 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i1 = f4 < Math_fround(-177.0);
 i8 = f4 > Math_fround(177.0);
 f4 = i8 ? Math_fround(177.0) : f4;
 f4 = i1 ? Math_fround(-177.0) : f4;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f4 < (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f3 < Math_fround(0.0);
 i10 = f3 > Math_fround(340282326000000008404918.0e15);
 f4 = i10 ? Math_fround(340282326000000008404918.0e15) : f3;
 f4 = i9 ? Math_fround(0.0) : f4;
 i9 = f5 < Math_fround(0.0);
 i10 = f5 > Math_fround(1.0);
 f5 = i10 ? Math_fround(1.0) : f5;
 f5 = i9 ? Math_fround(0.0) : f5;
 HEAP32[i6 + 160 >> 2] = i8 ? i7 : i1;
 HEAPF32[i6 + 164 >> 2] = f5;
 HEAPF32[i6 + 168 >> 2] = f4;
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i6);
 return;
}

function __ZN13TrailRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421162 | 0, i5, i1 + 388 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = HEAP32[i1 + 384 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421169 | 0, gb + 421182 | 0, i6, 0);
 __ZN14LineParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i6, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421197 | 0, i5, i1 + 392 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 421217 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 396 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZNSt3__212ctype_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212876 + 8;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 502 | 0, 2147483647, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0, 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 do if (i6 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  if (i1 | 0) {
   STACKTOP = i3;
   return;
  }
  i3 = ___cxa_allocate_exception(8) | 0;
  __THREW__ = 0;
  invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1081704 | 0, i4 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   __THREW__ = 0;
   invoke_vii(fb + 4518 | 0, i3 | 0, i5 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) i2 = 1; else {
    __THREW__ = 0;
    invoke_viii(fb + 1035 | 0, i3 | 0, gb + 13128 | 0, fb + 3224 | 0);
    __THREW__ = 0;
    i2 = 0;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   if (!i2) break;
  }
  ___cxa_free_exception(i3 | 0);
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZN8Collider13GetPxMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) {
  i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
  if (!i1) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = HEAP32[i1 + 52 >> 2] | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputENS_6PxVec3ES5_j(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 24 | 0;
 i7 = i5 + 12 | 0;
 i6 = i5;
 HEAPF32[i8 >> 2] = Math_fround(1.0);
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i8 + 20 >> 2] = Math_fround(1.0);
 i9 = i8 + 24 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i8 + 40 >> 2] = Math_fround(1.0);
 i9 = i8 + 44 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 HEAPF32[i8 + 60 >> 2] = Math_fround(1.0);
 i2 = __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(__ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(__ZN5physx2Cm12RenderOutputlsEj(i2, i1) | 0, i8) | 0, 1) | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i3 = __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i2, i7) | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setProjectionPlaneERKNS_6PxVec3Ef(i4, i1, f12) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f12 = Math_fround(f12);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13;
 i10 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i10;
 i11 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i11;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i8;
 HEAPF32[i2 + 12 >> 2] = f12;
 i9 = i4 + 20 | 0;
 i1 = i4 + 32 | 0;
 i7 = i4 + 24 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 switch (i6 >>> 30 | 0) {
 case 3:
  {
   i3 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 4; else i3 = i9;
   break;
  }
 default:
  i5 = 4;
 }
 if ((i5 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE(i1, i2);
  STACKTOP = i13;
  return;
 }
 i2 = i4 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i6 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 28 >> 2] = i10;
 HEAP32[i1 + 32 >> 2] = i11;
 HEAP32[i1 + 36 >> 2] = i8;
 HEAPF32[i1 + 40 >> 2] = f12;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i9);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 512;
 STACKTOP = i13;
 return;
}

function __ZN5Unity17ConfigurableJoint19SetLowAngularXLimitERK14SoftJointLimit(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 160 >> 2]);
 i1 = f2 < Math_fround(-177.0);
 i7 = f2 > Math_fround(177.0);
 f2 = i7 ? Math_fround(177.0) : f2;
 i1 = i1 ? -1020198912 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i7 = f4 < Math_fround(-177.0);
 i8 = f4 > Math_fround(177.0);
 f4 = i8 ? Math_fround(177.0) : f4;
 f4 = i7 ? Math_fround(-177.0) : f4;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i8 = f4 < (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i9 = f3 < Math_fround(0.0);
 i10 = f3 > Math_fround(340282326000000008404918.0e15);
 f4 = i10 ? Math_fround(340282326000000008404918.0e15) : f3;
 f4 = i9 ? Math_fround(0.0) : f4;
 i9 = f5 < Math_fround(0.0);
 i10 = f5 > Math_fround(1.0);
 f5 = i10 ? Math_fround(1.0) : f5;
 f5 = i9 ? Math_fround(0.0) : f5;
 HEAP32[i6 + 148 >> 2] = i8 ? i7 : i1;
 HEAPF32[i6 + 152 >> 2] = f5;
 HEAPF32[i6 + 156 >> 2] = f4;
 i1 = HEAP32[i6 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i6);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i6 + 4 | 0;
 i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN11TerrainData8TransferI14SafeBinaryReadEEvRT_(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
 i2 = i3 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 932081 | 0, gb + 932097 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN13SplatDatabase8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 128 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 932111 | 0, gb + 932128 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14DetailDatabase8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i3 + 248 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 932143 | 0, gb + 932155 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN9Heightmap8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN11JointLimits8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z59ParticleCollisionEvent_CUSTOM_InstanceIDToColliderComponenti(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i5 = 0;
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _gray_hline(i12, i3, i2, i1, i13) {
 i12 = i12 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = i1 >> 9;
 i1 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 do if (!(HEAP32[i12 + 988 >> 2] & 2)) i11 = (i1 | 0) > 255 ? 255 : i1; else {
  i1 = i1 & 511;
  if (i1 >>> 0 > 256) {
   i11 = 512 - i1 | 0;
   break;
  } else {
   i11 = (i1 | 0) == 256 ? 255 : i1;
   break;
  }
 } while (0);
 i9 = (HEAP32[i12 + 20 >> 2] | 0) + i2 | 0;
 i8 = (HEAP32[i12 + 12 >> 2] | 0) + i3 | 0;
 i8 = (i8 | 0) < 32767 ? i8 : 32767;
 if (!i11) return;
 i10 = i12 + 1224 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i1 = i12 + 1032 | 0;
 i4 = i12 + 1032 + (i5 * 6 | 0) | 0;
 i6 = (i5 | 0) > 0;
 i7 = i12 + 1236 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i6 & (i2 | 0) == (i9 | 0)) {
  i2 = i4 + -4 | 0;
  i3 = HEAPU16[i2 >> 1] | 0;
  if ((i3 + (HEAP16[i4 + -6 >> 1] | 0) | 0) == (i8 | 0)) if ((HEAPU8[i4 + -2 >> 0] | 0) == (i11 | 0)) {
   HEAP16[i2 >> 1] = i3 + i13;
   return;
  } else i2 = i9; else i2 = i9;
 }
 if ((i5 | 0) > 31 | (i2 | 0) != (i9 | 0)) {
  i3 = HEAP32[i12 + 1228 >> 2] | 0;
  if (i6 & (i3 | 0) != 0) mftCall_viiii(i3 | 0, i2 | 0, i5 | 0, i1 | 0, HEAP32[i12 + 1232 >> 2] | 0);
  HEAP32[i10 >> 2] = 0;
  HEAP32[i7 >> 2] = i9;
 } else i1 = i4;
 HEAP16[i1 >> 1] = i8;
 HEAP16[i1 + 2 >> 1] = i13;
 HEAP8[i1 + 4 >> 0] = i11;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 return;
}

function __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i1, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085899 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx9NpFactory18onAggregateReleaseEPNS_11PxAggregateE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i9 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i9 + 464 >> 2] | 0;
 if (!i1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i2 = i7;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i2 = (HEAP32[i9 + 456 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i5 = HEAP32[i9 + 448 >> 2] | 0;
 i6 = HEAP32[i9 + 452 >> 2] | 0;
 i3 = i1;
 i4 = i2;
 while (1) {
  i1 = i4;
  i4 = i6 + (i3 << 2) | 0;
  i2 = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
  if ((i3 | 0) == -1) {
   i10 = 7;
   break;
  }
 }
 if ((i10 | 0) == 7) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i10 = i9 + 480 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 i10 = i9 + 476 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i9 + 472 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i2;
 i10 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 return;
}

function __ZN19CloudServiceHandler12CloseServiceEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = i4 + 1144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 i1 = __Z24GetManagerPtrFromContexti(20) | 0;
 if (i1 | 0) {
  HEAP32[i2 >> 2] = i4;
  __ZNSt3__24listIP19CloudServiceHandler13stl_allocatorIS2_L18MemLabelIdentifier85ELi16EEE6removeERKS2_(i1 + 44 | 0, i2);
 }
 __ZN11UnityEngine15CloudWebService19SessionEventManager5CloseEv(i4 + 200 | 0) | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher5CloseEv(i4 + 792 | 0) | 0;
 i1 = i4 + 188 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i2 = i4 + 192 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63800 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i3 = i4 + 1140 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63800 | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = HEAP32[i4 + 1156 >> 2] | 0;
 i1 = HEAP32[i4 + 1152 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63800 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = 1;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj(i6, i1, i7, i8, i9) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(i6 + 6616 | 0, HEAP32[i1 >> 2] | 0, 0, 0);
 i5 = i6 + 7380 | 0;
 HEAP32[i5 >> 2] = 14380;
 i4 = i6 + 7376 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 & 14380;
  if (i1 | 0) mftCall_vi(HEAP32[i6 + 4860 >> 2] | 0, i1 | 0);
  i2 = i6 + 5480 | 0;
  i3 = i6 + 7368 | 0;
  i1 = 0;
  do {
   i10 = HEAP32[i5 >> 2] & HEAP32[i4 >> 2];
   if (i10 & (__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0) | 0) {
    i12 = i3;
    i11 = HEAP32[i12 + 4 >> 2] | 0;
    i10 = i6 + 7264 + (i1 << 3) | 0;
    HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
    HEAP32[i10 + 4 >> 2] = i11;
    i10 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0);
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & i10;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 13);
  i10 = i3;
  i10 = _i64Add(HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, 1, 0) | 0;
  i11 = getTempRet0() | 0;
  i12 = i3;
  HEAP32[i12 >> 2] = i10;
  HEAP32[i12 + 4 >> 2] = i11;
  HEAP32[i5 >> 2] = 15407;
 }
 __ZN7ApiGLES8DispatchEjjj(i6 + 4620 | 0, i7, i8, i9);
 return;
}

function __ZN12FileAccessorC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 70828 + 8;
 i2 = i5 + 4 | 0;
 i1 = i5 + 1044 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i3 = i6 + 1040 | 0;
 HEAP8[i6 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 if ((i2 | 0) == (i6 | 0)) {
  i6 = i5 + 1056 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i5 + 1064 | 0;
  HEAP8[i6 >> 0] = 0;
  STACKTOP = i7;
  return;
 }
 _strncpy(i2, i6, 1040) | 0;
 HEAP8[i5 + 1043 >> 0] = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i5 + 1048 >> 2] = HEAP32[i6 + 1044 >> 2];
 HEAP32[i5 + 1052 >> 2] = 0;
 HEAP32[i5 + 1056 >> 2] = 0;
 HEAP32[i5 + 1060 >> 2] = 0;
 i1 = i4;
 if (i4) {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if (!i1) {
  i6 = i5 + 1056 | 0;
  HEAP32[i6 >> 2] = 0;
  i6 = i5 + 1064 | 0;
  HEAP8[i6 >> 0] = 0;
  STACKTOP = i7;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i6 | 0);
 i6 = i5 + 1056 | 0;
 HEAP32[i6 >> 2] = 0;
 i6 = i5 + 1064 | 0;
 HEAP8[i6 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZL34GetComponentsImplementationRecurseILb1ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[HEAP32[i10 >> 2] >> 2] = 0;
 if (i8) i1 = 3; else if (__ZNK10GameObject8IsActiveEv(i7) | 0) i1 = 3;
 L3 : do if ((i1 | 0) == 3) {
  i1 = HEAP32[i7 + 28 >> 2] | 0;
  i6 = HEAP32[i7 + 40 >> 2] | 0;
  i5 = i1 + (i6 << 3) | 0;
  if (i6 | 0) {
   i6 = i9 + 8 | 0;
   while (1) {
    i2 = HEAP32[i6 >> 2] | 0;
    if ((HEAP32[gb + 1106156 + 4 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) == (gb + 27592 | 0)) {
     i3 = i1 + 4 | 0;
     i4 = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i3 >> 2] | 0) | 0;
     if (i4 | 0) {
      if ((i4 | 0) == (i2 | 0)) break;
      if (__Z26scripting_class_has_parentP11Il2CppClassS0_(i4, i2) | 0) break;
     }
    }
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i5 | 0)) break L3;
   }
   HEAP32[HEAP32[i10 >> 2] >> 2] = HEAP32[i3 >> 2];
   i10 = 1;
   return i10 | 0;
  }
 } while (0);
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i7, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = __ZL34GetComponentsImplementationRecurseILb1ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i8, i9, i10) | 0;
 return i10 | 0;
}

function __Z34TextGenerator_CUSTOM_GetLinesArrayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i2 = i8 + 16 | 0;
 i6 = i8;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = i1 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 if (!(HEAP8[i1 + 60 >> 0] | 0)) i2 = 0; else i2 = HEAP32[i1 + 52 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 20 >> 2] | 0, 12, i2) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i4 | 0;
 }
 i1 = 0;
 while (1) {
  i3 = HEAP32[i5 >> 2] | 0;
  if (!i3) {
   i1 = 10;
   break;
  }
  i3 = (HEAP32[i3 + 40 >> 2] | 0) + (i1 * 12 | 0) | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 12) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  STACKTOP = i8;
  return i4 | 0;
 } else if ((i1 | 0) == 10) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7);
 return 0;
}

function __Z26ScheduleMultiDependencyJobR8JobFenceR18JobBatchDispatcherPS_j(i11, i4, i5, i6) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i8 = i12;
 if (!i6) {
  STACKTOP = i12;
  return;
 }
 i10 = i5 + 4 | 0;
 L4 : do if ((i6 | 0) == 1) {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i9 = HEAP32[i5 >> 2] | 0;
  i2 = i9;
  i3 = 1;
  while (1) {
   if ((i9 | 0) != (HEAP32[i5 + (i3 << 3) >> 2] | 0)) break;
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) != (HEAP32[i5 + (i3 << 3) + 4 >> 2] | 0)) break;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i6 | 0)) break L4;
  }
  i10 = i6 + -1 | 0;
  __ZN14BatchAllocatorC2Ev(i7);
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i7, i8, -1, 8, 1, 4);
  HEAP32[i8 >> 2] = 0;
  __ZN14BatchAllocator16AllocateInternalEPPvijjj(i7, 0, 0, 8, i10, 4);
  __ZN14BatchAllocator6CommitERK10MemLabelId(i7, gb + 64024 | 0);
  _memcpy(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i5 + 8 | 0, i10 << 3 | 0) | 0;
  i11 = HEAP32[i8 >> 2] | 0;
  HEAP32[i11 + 4 >> 2] = i10;
  __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i4, 0, fb + 3401 | 0, i11, 0);
  STACKTOP = i12;
  return;
 } while (0);
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i1;
 STACKTOP = i12;
 return;
}

function __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i3 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i7 = i4 + 4 | 0;
  i8 = i4 + 4 | 0;
  i9 = i4 + 4 | 0;
  do {
   i2 = i1 + -108 | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i2 >> 2] = gb + 59740 + 8;
   i2 = i1 + -68 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i11 = HEAP32[i1 + -56 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i7 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
   }
   i2 = i1 + -84 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i1 + -72 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i8 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
   }
   i2 = i1 + -104 | 0;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i2 >> 2] | 0;
    i2 = HEAP32[i1 + -92 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i9 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i4);
   }
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function __ZNK14b2CapsuleShape11ComputeMassEP10b2MassDataf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(f4 - f13);
 f11 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f7 = Math_fround(f11 - f12);
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7))));
 i1 = i1 + 8 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(f7 * f6);
 f9 = Math_fround(f10 * f3);
 f6 = Math_fround(f6 * Math_fround(f6 * Math_fround(3.14159274)));
 f8 = Math_fround(f6 * f3);
 f5 = Math_fround(f9 + f8);
 HEAPF32[i2 >> 2] = f5;
 f4 = Math_fround(Math_fround(f13 + f4) * Math_fround(.5));
 f3 = Math_fround(Math_fround(f12 + f11) * Math_fround(.5));
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f3;
 HEAPF32[i2 + 16 >> 2] = Math_fround(f10 + f6);
 f7 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 12 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(f9 * Math_fround(f7 + Math_fround(f6 * f6))) / Math_fround(12.0)) + Math_fround(f8 * Math_fround(Math_fround(f7 * Math_fround(.25)) + Math_fround(f6 * Math_fround(f6 * Math_fround(.5)))))) + Math_fround(f5 * Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3))));
 return;
}

function __ZN5physx7profile12MemoryBufferINS0_21WrapperNamedAllocatorEE5writeIyEEvRKT_(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 12 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = i4;
 i6 = i1 - i3 | 0;
 i2 = i6 + 8 | 0;
 i7 = i8 + 16 | 0;
 if (((HEAP32[i7 >> 2] | 0) - i3 | 0) >>> 0 <= i2 >>> 0) {
  i3 = i2 << 1;
  if (!i3) {
   i2 = 0;
   i1 = i4;
  } else {
   i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i8 + 4 >> 2] | 0, gb + 740723 | 0, 100) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  if (i1 | 0) {
   _memcpy(i2 | 0, i1 | 0, i6 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) {
    i8 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
   }
  }
  HEAP32[i5 >> 2] = i2;
  i1 = i2 + i6 | 0;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i7 >> 2] = i2 + i3;
 }
 HEAP8[i1 >> 0] = HEAP8[i10 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i10 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i10 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i10 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[i10 + 4 >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = HEAP8[i10 + 5 >> 0] | 0;
 HEAP8[i1 + 6 >> 0] = HEAP8[i10 + 6 >> 0] | 0;
 HEAP8[i1 + 7 >> 0] = HEAP8[i10 + 7 >> 0] | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 8;
 return;
}

function __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 HEAP32[i6 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 40 | 0, i7);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 i5 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i6 + 36 >> 2] = ~~(HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 44 | 0, i7);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i6 + 48 >> 2] | 0, i7);
 STACKTOP = i8;
 return;
}

function __ZN13MemoryManager28GetTotalUnusedReservedMemoryEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i7 + 1556 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 i6 = i7 + 1544 | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i5 = HEAP32[i7 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 i3 = 0;
 while (1) {
  i2 = HEAP32[i7 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i5 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0) + i1 | 0; else i5 = i1;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 512) break; else i1 = i5;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i4 = HEAP32[i7 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i6 >> 2] | 0));
 }
 i3 = 0;
 do {
  i2 = HEAP32[i7 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 512);
 return i5 - i1 | 0;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen8DrawModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN17CapsuleCollider2D16CapsuleDirectionEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D22CollisionDetectionModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function _UNITY_FT_Create_Class_tt_driver_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 96, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _tt_driver_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 1281;
  HEAP32[i5 + 4 >> 2] = 68;
  HEAP32[i5 + 8 >> 2] = gb + 1007021;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2622;
  HEAP32[i5 + 28 >> 2] = fb + 3839;
  HEAP32[i5 + 32 >> 2] = fb + 1009;
  HEAP32[i5 + 36 >> 2] = 768;
  HEAP32[i5 + 40 >> 2] = 304;
  HEAP32[i5 + 44 >> 2] = 160;
  HEAP32[i5 + 48 >> 2] = fb + 175;
  HEAP32[i5 + 52 >> 2] = fb + 3840;
  HEAP32[i5 + 56 >> 2] = fb + 2623;
  HEAP32[i5 + 60 >> 2] = fb + 3841;
  HEAP32[i5 + 64 >> 2] = fb + 2624;
  HEAP32[i5 + 68 >> 2] = 0;
  HEAP32[i5 + 72 >> 2] = fb + 176;
  HEAP32[i5 + 76 >> 2] = fb + 177;
  HEAP32[i5 + 80 >> 2] = 0;
  HEAP32[i5 + 84 >> 2] = fb + 176;
  HEAP32[i5 + 88 >> 2] = fb + 1010;
  HEAP32[i5 + 92 >> 2] = fb + 1011;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN31CanvasBatchIntermediateRendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 33700 + 8;
 HEAP32[i3 + 264 >> 2] = gb + 33700 + 80;
 __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv(i3);
 i1 = i3 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 272 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 300 | 0;
 if ((HEAP32[i3 + 316 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 304 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = gb + 33532 + 8;
 i1 = i3 + 236 | 0;
 i2 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i3 + 256 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN19SkinnedMeshRenderer17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 512 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 516 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 524 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 528 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 508 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 304 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 468 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 472 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN8Renderer17MainThreadCleanupEv(i3);
  return;
 }
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 __ZN8Renderer17MainThreadCleanupEv(i3);
 return;
}

function __Z17IsNodeVisibleSlowRK9SceneNodeRK4AABBRK22SceneCullingParameters(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, i3 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 switch (HEAP32[i5 + 324 >> 2] | 0) {
 case 1:
  {
   HEAP32[i3 >> 2] = HEAP32[i5 + 108 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 112 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 116 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 196 + (i2 << 2) >> 2];
   i5 = (__Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i4, i3, 1) | 0) ^ 1;
   i5 = i5 ^ 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i5 + 196 + (i2 << 2) >> 2]);
   if (f1 == Math_fround(0.0)) {
    i5 = 0;
    i5 = i5 ^ 1;
    STACKTOP = i6;
    return i5 | 0;
   }
   f9 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - Math_fround(HEAPF32[i5 + 608 >> 2]));
   f8 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) - Math_fround(HEAPF32[i5 + 612 >> 2]));
   f7 = Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) - Math_fround(HEAPF32[i5 + 616 >> 2]));
   i5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f8 * f8)) + Math_fround(f7 * f7)) > Math_fround(f1 * f1);
   i5 = i5 ^ 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 default:
  {
   i5 = 0;
   i5 = i5 ^ 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 return 0;
}

function __ZNK16MemoryFileSystem12LastModifiedERK13FileEntryData(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i5);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i5) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 54;
  HEAP32[i4 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 }
 if (!i1) {
  __ZN8DateTimeC2Ev(i3);
  STACKTOP = i6;
  return;
 } else {
  i2 = i1 + 4 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx2Cm10FanoutTask15removeReferenceEv(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = i12 + 88 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 i1 = i12 + 12 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i1) | 0) {
  i12 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
  return;
 }
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1) | 0;
 HEAP8[i12 + 84 >> 0] = 0;
 i9 = i12 + 44 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  i10 = i12 + 40 | 0;
  i5 = i12 + 80 | 0;
  i6 = i12 + 76 | 0;
  i7 = i12 + 72 | 0;
  i8 = i12 + 52 | 0;
  i4 = 0;
  do {
   i2 = (HEAP32[i10 >> 2] | 0) + (i4 << 2) | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
    HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
    HEAP32[i6 >> 2] = i3 + 1;
   } else {
    __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_(i8, i2) | 0;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP32[i9 >> 2] = 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i10 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0) | 0;
 mftCall_vii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i12 | 0);
 i12 = HEAP32[i11 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i12);
 return;
}

function __ZN15LODGroupManager27GarbageCollectCameraLODDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, d9 = 0.0;
 i5 = i1 + 48 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i6 = i1 + 36 | 0;
 i7 = i1 + 32 | 0;
 i4 = i1 + 40 | 0;
 i3 = 0;
 L4 : while (1) {
  while (1) {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   f8 = Math_fround(HEAPF32[i7 >> 2]);
   d9 = +__Z19GetTimeSinceStartupv();
   if (!(Math_fround(d9 - +HEAPF64[i2 + 8 >> 3]) > f8)) break;
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i1 | 0) {
    i2 = i1 + 36 | 0;
    if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
     HEAP32[i2 >> 2] = 0;
    }
    if ((HEAP32[i1 + 32 >> 2] | 0) > -1) {
     i2 = i1 + 16 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 20 | 0);
     HEAP32[i2 >> 2] = 0;
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = 0;
   i1 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
   if ((i1 | 0) != (i3 | 0)) {
    i2 = HEAP32[i6 >> 2] | 0;
    HEAP32[i2 + (i3 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
   }
   HEAP32[i5 >> 2] = i1;
   if (i3 >>> 0 >= i1 >>> 0) {
    i1 = 4;
    break L4;
   }
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return;
}

function __Z33Graphics_CUSTOM_SetupVertexLightsP11Il2CppArray(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 if (i5 | 0) {
  if (i5 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i2 = __Znwj(i5 << 2) | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i2 + (i5 << 2);
  i1 = i5;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
   HEAP32[i6 >> 2] = i2;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
  if ((i5 | 0) > 0) {
   i1 = 0;
   do {
    i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(__ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i3, i1) | 0) | 0;
    HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 __Z17SetupVertexLightsRKNSt3__26vectorIP5LightNS_9allocatorIS2_EEEER17ShaderPassContext(i4, HEAP32[gb + 1166248 >> 2] | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab14SerializedPass8PassTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEbjPKNS_16HullTriangleDataE(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!(__ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(83, 85, 80, 77, 0, i3, i4) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE(71, 65, 85, 83, 0, i3, i4) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = i5 + 4 | 0;
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAPU16[HEAP32[i8 >> 2] >> 1] | 0, i3, i4);
 __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(HEAPU16[(HEAP32[i8 >> 2] | 0) + 2 >> 1] | 0, i3, i4);
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i8 + 4 >> 2] | 0, (HEAPU16[i8 + 2 >> 1] | 0) << 1 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAPU8[(HEAP32[i5 >> 2] | 0) + 38 >> 0];
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i1;
 HEAP8[i6 + 16 >> 0] = 1;
 __ZNK5physx20BigConvexDataBuilder7ComputeERKNS_15VALENCIESCREATEE(i5, i6) | 0;
 i6 = __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEb(i5, i4, i3) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugArcE(i13, i10) {
 i13 = i13 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i14 + 12 | 0;
 i12 = i14;
 i11 = i10 + 12 | 0;
 f2 = Math_fround(HEAPF32[i11 >> 2]);
 f3 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f9 = Math_fround(f2 - f3);
 i6 = HEAP32[i10 >> 2] | 0;
 f9 = Math_fround(f9 / Math_fround(i6 >>> 0));
 HEAP32[i13 >> 2] = 2;
 HEAP32[i13 + 32 >> 2] = 0;
 i8 = i10 + 4 | 0;
 f1 = Math_fround(HEAPF32[i8 >> 2]);
 if (i6) {
  i5 = i7 + 4 | 0;
  i6 = i7 + 8 | 0;
  i4 = 0;
  do {
   f2 = Math_fround(f1 * Math_fround(+Math_cos(+f3)));
   HEAPF32[i7 >> 2] = Math_fround(f1 * Math_fround(+Math_sin(+f3)));
   HEAPF32[i5 >> 2] = f2;
   HEAPF32[i6 >> 2] = Math_fround(0.0);
   __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i13, i7) | 0;
   i4 = i4 + 1 | 0;
   f3 = Math_fround(f9 + f3);
   f1 = Math_fround(HEAPF32[i8 >> 2]);
  } while (i4 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0);
  f2 = Math_fround(HEAPF32[i11 >> 2]);
 }
 f9 = Math_fround(f1 * Math_fround(+Math_cos(+f2)));
 HEAPF32[i12 >> 2] = Math_fround(f1 * Math_fround(+Math_sin(+f2)));
 HEAPF32[i12 + 4 >> 2] = f9;
 HEAPF32[i12 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i13, i12) | 0;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZN13PhysicsModule17GetRigidBodyStateERK9RigidbodyPN8IPhysics14RigidBodyStateE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i4 = i2 + 52 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i2 | 0);
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i7 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i7;
 i7 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i7 | 0);
 i7 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i6 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 16 >> 2] = i7;
 HEAP32[i3 + 20 >> 2] = i2;
 HEAP32[i3 + 24 >> 2] = i6;
 i6 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i6 | 0);
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i3 + 28 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 32 >> 2] = i6;
 HEAP32[i3 + 36 >> 2] = i2;
 i4 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 160 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i3 + 40 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 44 >> 2] = i4;
 HEAP32[i3 + 48 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN10AudioMixer8GetFloatEPKcPf(i2, i3, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i5 = i8 + 4 | 0;
 if ((i7 | 0) == 0 | (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) != 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i2) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 315, 1, 0, 0, 0);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i4 = __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc(HEAP32[i2 + 72 >> 2] | 0, i3) | 0;
 if ((i4 | 0) == -1) {
  HEAP32[i6 >> 2] = i3;
  __Z6FormatPKcz(i5, gb + 862953 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 861578 | 0, 320, 512, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 f1 = Math_fround(__ZN5audio5mixer23GetExposedPropertyValueERKNS0_16AudioMixerMemoryEi(HEAP32[i2 + 76 >> 2] | 0, i4));
 if (f1 == Math_fround(HEAPF32[gb + 1460016 >> 2])) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAPF32[i7 >> 2] = f1;
 i7 = 1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZL28GeomMTDCallback_SphereSphereRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i12, i11, i1, i3, i2, i8) {
 i12 = i12 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, f10 = f0, f13 = f0;
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i8 + 20 >> 2]);
 f9 = Math_fround(f13 - f9);
 f10 = Math_fround(f5 - f10);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i8 + 24 >> 2]));
 f5 = Math_fround(Math_fround(Math_fround(f9 * f9) + Math_fround(f10 * f10)) + Math_fround(f4 * f4));
 f6 = Math_fround(f7 + f6);
 if (f5 > Math_fround(f6 * f6)) {
  i12 = 0;
  return i12 | 0;
 }
 f7 = Math_fround(Math_sqrt(Math_fround(f5)));
 if (f5 < Math_fround(9.99999997e-07)) {
  HEAP32[i12 >> 2] = 1065353216;
  HEAP32[i12 + 4 >> 2] = 0;
  HEAP32[i12 + 8 >> 2] = 0;
 } else {
  f5 = Math_fround(Math_fround(1.0) / f7);
  f10 = Math_fround(f10 * f5);
  f13 = Math_fround(f4 * f5);
  HEAPF32[i12 >> 2] = Math_fround(f9 * f5);
  HEAPF32[i12 + 4 >> 2] = f10;
  HEAPF32[i12 + 8 >> 2] = f13;
 }
 f13 = Math_fround(f6 - f7);
 i12 = f13 > Math_fround(0.0);
 HEAPF32[i11 >> 2] = i12 ? f13 : Math_fround(0.0);
 i12 = 1;
 return i12 | 0;
}

function __ZN5physx2Sc10NPhaseCore18removeClothOverlapEPNS0_8ClothSimEPKNS0_8ShapeSimE(i5, i3, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb(i5 + 2512 | 0, i1, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i2;
  i7 = i1 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i1 = i7;
 } else i1 = i1 + 4 | 0;
 do {
  i2 = i1 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i4 = 9;
   break;
  }
 } while ((HEAP32[i1 >> 2] | 0) != (i3 | 0));
 if ((i4 | 0) == 9) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 i7 = i5 + 2496 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 i7 = i5 + 2508 | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i1;
 i1 = i5 + 2500 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i7 + 1;
 if ((i7 | 0) < ((HEAP32[i5 + 2492 >> 2] | 0) * 50 | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv(i5 + 2216 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5Umbra4HashIiiE10getDefaultERKiS3_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = (HEAP32[i6 + 4 >> 2] | 0) + (((i4 >>> 5) + i4 + (i4 >>> 10) + (i4 >>> 20) & i1 + -1) << 2) | 0;
  if (i2 | 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i3 = HEAP32[i6 + 8 >> 2] | 0;
    while (1) {
     if ((HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) == (i4 | 0)) break;
     i2 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
     if ((i2 | 0) == -1) break L1;
    }
    i8 = i3 + (i2 * 12 | 0) + 8 | 0;
    return i8 | 0;
   }
  }
 } while (0);
 i3 = i6 + 12 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do if ((i2 | 0) == -1) if (__ZN5Umbra4HashIiiE6rehashEj(i6, 0) | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  break;
 } else {
  i8 = 0;
  return i8 | 0;
 } while (0);
 i9 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = i9 + (i2 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i9 + (i2 * 12 | 0) + 4 >> 2] = i4;
 i7 = i9 + (i2 * 12 | 0) + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i8 = (HEAP32[i6 + 4 >> 2] | 0) + (((i4 >>> 5) + i4 + (i4 >>> 10) + (i4 >>> 20) & i1 + -1) << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i8 >> 2] = i2;
 i8 = i6 + 20 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 i8 = i7;
 return i8 | 0;
}

function __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6);
 i1 = i5 + 36 | 0;
 i7 = i6 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = i5 + 40 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 41 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 42 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function __ZN19RingbufferTemplates23PeekValueFromRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RPKT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 24 | 0;
 i7 = i1 + 20 | 0;
 i4 = i1 + 16 | 0;
 L1 : while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = i3 + 20 | 0;
  i1 = (HEAP32[i3 + 24 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
  i9 = HEAP32[i3 + 16 >> 2] | 0;
  i2 = i9 + -1 & HEAP32[i2 >> 2];
  i9 = i9 - i2 | 0;
  i1 = i9 >>> 0 < i1 >>> 0 ? i9 : i1;
  i1 = i1 >>> 0 < 12 ? i1 : 12;
  switch (i1 | 0) {
  case 12:
   break L1;
  case 0:
   {
    i1 = 0;
    i8 = 10;
    break L1;
   }
  default:
   {}
  }
  i9 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i1;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i1;
  if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0)) continue;
  i9 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i9 + 24 >> 2] | 0) != (HEAP32[i9 + 20 >> 2] | 0)) continue;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - (HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2];
  if (!i1) continue;
  if (HEAP8[i1 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 8 | 0);
  __ZdlPv(i1);
 }
 if ((i8 | 0) == 10) return i1 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
 i9 = 1;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 4;
 if (i5 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj(i3, i5 - i4 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else if (i5 >>> 0 < i4 >>> 0) {
  i3 = i1 + (i5 << 4) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4) | 0;
   HEAP32[i6 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags(i9, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN17AudioReverbFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 174980 + 8;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 68 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(.0399999991);
 HEAPF32[i1 + 84 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(250.0);
 HEAP32[i1 + 104 >> 2] = 27;
 HEAP32[i1 + 36 >> 2] = 17;
 STACKTOP = i4;
 return;
}

function __Z53AnimatorClipInfo_CUSTOM_ClipInstanceToScriptingObjecti(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i5 = 0;
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z13TransferArrayILi7EKN4math7_float3E19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP32[i1 >> 2] = 7;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = 7;
  HEAP32[i2 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 12 | 0, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 24 | 0, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 36 | 0, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 48 | 0, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 60 | 0, gb + 1041891 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i7, i6 + 72 | 0, gb + 1041891 | 0, 0);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 if (!(HEAP8[gb + 1098032 >> 0] | 0)) {
  i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i6 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i9 = gb + 63696 | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = i3;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i6, 1, gb + 1018240 | 0, 20, 32768, i4, 16);
  HEAP32[gb + 1114548 >> 2] = i6;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i6);
  if (i1) __Z19pop_allocation_rootv();
  i9 = gb + 1098032 | 0;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i9 + 4 >> 2] = 0;
 }
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1114548 >> 2] | 0, i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i6 = i4 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i5 + 4 | 0;
  i8 = i5 + 4 | 0;
  i9 = i5 + 4 | 0;
  do {
   i3 = i2 + -108 | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i3 >> 2] = gb + 59740 + 8;
   i3 = i2 + -68 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i11 = HEAP32[i2 + -56 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i7 >> 2] = i11;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
   }
   i3 = i2 + -84 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -72 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i8 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i5);
   }
   i3 = i2 + -104 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i11 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -92 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i9 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i11, i5);
   }
   i2 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i10;
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 8;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 8;
  if ((i7 | 0) != 7) if ((i7 | 0) == 8) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 10; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 10; else if ((i2 | 0) >= 0) {
     i1 = 1;
     i7 = 14;
     break;
    }
   }
   if ((i7 | 0) == 10) if (!i6) {
    i1 = 1;
    i7 = 14;
    break;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZNK5physx2Sn21SerializationRegistry17getRepXSerializerEPKc(i5, i9) {
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = i5 + 60 | 0;
 L1 : do if (!(HEAP32[i5 + 64 >> 2] | 0)) {
  i1 = -1;
  i2 = 0;
 } else {
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i3 = HEAP32[i5 + 68 >> 2] | 0;
   i1 = 0;
   while (1) {
    i2 = i1 + 1 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i1 = -1;
     i2 = i3;
     break L1;
    }
    i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) i1 = i2; else break;
   }
  } else i2 = 0;
 } while (0);
 i7 = i5 + 52 | 0;
 i6 = i5 + 56 | 0;
 i4 = i5 + 68 | 0;
 L8 : while (1) {
  do {
   if ((i1 | 0) == -1) {
    i1 = 0;
    i10 = 15;
    break L8;
   }
   i5 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
   if (!(_strcasecmp(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0) | 0, i9) | 0)) break L8;
   i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  } while ((i1 | 0) != -1);
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = i2;
  while (1) {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i1 = -1;
    i2 = i3;
    continue L8;
   }
   i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   if ((i1 | 0) == -1) i1 = i2; else continue L8;
  }
 }
 if ((i10 | 0) == 15) return i1 | 0;
 i10 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 return i10 | 0;
}

function __ZNK12NavMeshAgent25GetCurrentOffMeshLinkDataEP15OffMeshLinkData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = i1 + 68 | 0;
 if ((HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 601 >> 0] | 0) != 2) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = __ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = __ZNK9dtNavMesh20getOffMeshConnectionEy(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0, i3, i2) | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = (HEAP32[i2 + 76 >> 2] | 0) != 0 & 1;
 HEAP32[i4 + 12 >> 2] = HEAPU16[i2 + 82 >> 1];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 84 >> 2];
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 20 >> 2] = i3;
 HEAP32[i4 + 24 >> 2] = i2;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i4 + 28 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i4 + 32 >> 2] = i2;
 HEAP32[i4 + 36 >> 2] = i3;
 i4 = 1;
 return i4 | 0;
}

function __ZN8Material5ResetEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  __ZN8Material15ResetWithShaderEP6Shader(i5, i6);
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i8 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i8 = i1;
 __ZN8Material15ResetWithShaderEP6Shader(i5, i8);
 STACKTOP = i7;
 return;
}

function __ZN6IDList7GetNextER8GUIStatei9FocusTypeRK5RectTIfE(i6, i5, i1, i7, i8) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = i5 + 280 | 0;
 i2 = HEAP32[HEAP32[i9 >> 2] >> 2] | 0;
 if ((i2 | 0) == 12) i1 = -1; else {
  i3 = i7 >>> 0 > 2;
  i4 = (i7 & 1 | 0) != 0;
  i1 = __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i6, i5, i1, i3 | i4) | 0;
  if ((i2 | 0) == 4) if (!((HEAP32[i5 + 60 >> 2] | 0) != 1 | (i3 | i4) ^ 1)) {
   L5 : do switch (HEAP32[i6 >> 2] | 0) {
   case 2:
    {
     HEAP32[i6 + 16 >> 2] = i1;
     HEAP32[i6 >> 2] = 3;
     break;
    }
   case 1:
    {
     i2 = i6 + 4 | 0;
     if ((HEAP32[i2 >> 2] | 0) == -1) HEAP32[i2 >> 2] = i1;
     if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
      HEAP32[i6 >> 2] = 2;
      HEAP8[i6 + 20 >> 0] = 1;
      break L5;
     } else {
      HEAP32[i6 + 12 >> 2] = i1;
      break L5;
     }
    }
   default:
    {}
   } while (0);
   HEAP32[i6 + 8 >> 2] = i1;
  }
 }
 switch (HEAP32[HEAP32[i9 >> 2] >> 2] | 0) {
 case 12:
 case 8:
  return i1 | 0;
 default:
  {}
 }
 if (!(i7 >>> 0 > 2 | (i7 & 1 | 0) != 0)) return i1 | 0;
 i9 = (HEAP32[i6 + 24 >> 2] | 0) + (((HEAP32[i6 + 44 >> 2] | 0) + -1 | 0) * 28 | 0) + 12 | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 return i1 | 0;
}

function __ZN5physx18PxVehicleDriveTank6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj(i3, i4, i5, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = (i2 + 3 | 0) >>> 2;
 i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i8) | 0) + 768 | 0, gb + 827622 | 0, 47) | 0;
 __ZN5physx18PxVehicleDriveTankC2Ev(i7);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i7, i7 + 768 | 0, i8, i2) | 0;
 HEAP8[i7 + 113 >> 0] = 2;
 HEAP32[i7 + 752 >> 2] = 0;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i7, i3, i4, i5, i2, 0);
 i5 = i1 + 64 | 0;
 _memcpy(i7 + 224 | 0, i1 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
 HEAP32[i7 + 288 >> 2] = HEAP32[i5 >> 2];
 i5 = i7 + 304 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i7 + 336 | 0, i1 + 112 | 0, 416) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN14dtNavMeshQuery7getPathEPyPii(i4, i6, i9, i7) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = i4 + 8 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) < 0) {
  i1 = i8;
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i9 = -2147483648;
  return i9 | 0;
 }
 i3 = i4 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i4 + 32 | 0;
 L5 : do if ((i2 | 0) == (HEAP32[i5 >> 2] | 0) ? (i3 | 0) == (HEAP32[i5 + 4 >> 2] | 0) : 0) {
  i4 = i6;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  i4 = 1;
 } else {
  i2 = HEAP32[i4 + 16 >> 2] | 0;
  if (!i2) {
   i9 = -2147483648;
   return i9 | 0;
  }
  i5 = i4 + 76 | 0;
  i3 = 0;
  while (1) {
   i11 = i2 + 24 | 0;
   i10 = HEAP32[i11 + 4 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i3 = i6 + (i3 << 3) | 0;
   HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
   HEAP32[i3 + 4 >> 2] = i10;
   if ((i4 | 0) >= (i7 | 0)) break;
   i2 = HEAP32[i2 + 20 >> 2] & 1073741823;
   if (!i2) break L5;
   i2 = (HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + (i2 + -1 << 5) | 0;
   if (!i2) break L5; else i3 = i4;
  }
  i1 = i1 | 16;
  HEAP32[i8 >> 2] = i1;
 } while (0);
 i3 = i1 & 16777215;
 i1 = i8;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i9 >> 2] = i4;
 i11 = i3 | 1073741824;
 return i11 | 0;
}

function __ZN13AnimationClip15QuaternionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 __ZN17AnimationCurveTplI11QuaternionfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 16 | 0, i9);
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i7 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __Z50Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_P11Il2CppArrayfiff(i2, i3, i4, f5, i6, i7, f8, i9, f10, f11) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 var i1 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i12 + 16 | 0;
 i14 = i12 + 8 | 0;
 i13 = i12;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 36) | 0;
 i16 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i15 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i15 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 i3 = __ZN16Physics2DManager11CapsuleCastERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP12RaycastHit2Di(i16, i15, i14, i4, f5, i13, f8, i9, f10, f11, 0, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i7) | 0) | 0;
 if (!i3) {
  STACKTOP = i12;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i12;
 return i3 | 0;
}

function __Z39Physics_CUSTOM_INTERNAL_CALL_RaycastAllRK8Vector3fS1_fi23QueryTriggerInteraction(i4, i1, f5, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f9 * f9);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f10 * f10));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (f3 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f12 = Math_fround(f9 / f3);
  f9 = Math_fround(f10 / f3);
  f10 = Math_fround(f2 / f3);
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAPF32[i8 + 12 >> 2] = f12;
  HEAPF32[i8 + 16 >> 2] = f9;
  HEAPF32[i8 + 20 >> 2] = f10;
  i8 = __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE(__ZN14PhysicsManager10RaycastAllERK3Rayfi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i8, f5, i6, i7) | 0) | 0;
  STACKTOP = i11;
  return i8 | 0;
 } else {
  i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 28 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i11;
  return i8 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0;
 i7 = __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i8, i9, i6, i1) | 0;
 i1 = i5;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0 | (i1 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) {
  i10 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i7 + 1 | 0;
  i3 = i6;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i9;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if (i3 >>> 0 < i5 >>> 0 | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i1 = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i2 = i6;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i9;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i8;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if (i2 >>> 0 < i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
    i10 = i8;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = i2;
    i1 = i9;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i7 + 3 | 0;
   } else i1 = i7 + 2 | 0;
  }
 } else i1 = i7;
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i10 = 0;
 i7 = __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i8, i9, i6, i1) | 0;
 i1 = i5;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i6;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) < (i3 | 0) | (i1 | 0) == (i3 | 0) & i4 >>> 0 < i2 >>> 0) {
  i10 = i6;
  HEAP32[i10 >> 2] = i4;
  HEAP32[i10 + 4 >> 2] = i1;
  i1 = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i7 + 1 | 0;
  i3 = i6;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i9;
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i3 | 0) < (i5 | 0) | (i3 | 0) == (i5 | 0) & i2 >>> 0 < i4 >>> 0) {
   i1 = i9;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i3;
   i2 = i6;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i2 + 4 >> 2] = i5;
   i2 = i9;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = i8;
   i3 = HEAP32[i4 >> 2] | 0;
   i4 = HEAP32[i4 + 4 >> 2] | 0;
   if ((i2 | 0) < (i4 | 0) | (i2 | 0) == (i4 | 0) & i1 >>> 0 < i3 >>> 0) {
    i10 = i8;
    HEAP32[i10 >> 2] = i1;
    HEAP32[i10 + 4 >> 2] = i2;
    i1 = i9;
    HEAP32[i1 >> 2] = i3;
    HEAP32[i1 + 4 >> 2] = i4;
    i1 = i7 + 3 | 0;
   } else i1 = i7 + 2 | 0;
  }
 } else i1 = i7;
 return i1 | 0;
}

function __ZNK5physx3Ext7D6Joint14getSwingZAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i1 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 if (f6 != Math_fround(0.0)) {
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(f2 * f2)))));
  f3 = Math_fround(f6 * f5);
  f4 = Math_fround(f5 * Math_fround(0.0));
  f5 = Math_fround(f2 * f5);
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(1.0);
 }
 f3 = Math_fround(-f3);
 f4 = Math_fround(-f4);
 f7 = Math_fround(Math_fround(+Math_atan(+Math_fround(Math_fround(Math_fround(Math_fround(f6 * f4) + Math_fround(Math_fround(f8 * f5) + Math_fround(f2 * f4))) - Math_fround(f7 * f3)) / Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f5) - Math_fround(f6 * f3)) - Math_fround(f7 * f4)) - Math_fround(f8 * f4)) + Math_fround(1.0))))) * Math_fround(4.0));
 i10 = f7 <= Math_fround(3.14159274);
 f8 = Math_fround(f7 + Math_fround(-6.28318548));
 STACKTOP = i9;
 return Math_fround(i10 ? f7 : f8);
}

function __ZNK5physx3Ext7D6Joint14getSwingYAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i10 | 0, i1 | 0);
 f6 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 if (f6 != Math_fround(0.0)) {
  f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(0.0)) + Math_fround(f2 * f2)))));
  f3 = Math_fround(f6 * f5);
  f4 = Math_fround(f5 * Math_fround(0.0));
  f5 = Math_fround(f2 * f5);
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(1.0);
 }
 f3 = Math_fround(-f3);
 f4 = Math_fround(-f4);
 f7 = Math_fround(Math_fround(+Math_atan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f7 * f5) + Math_fround(f2 * f4)) + Math_fround(f8 * f3)) - Math_fround(f6 * f4)) / Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f2 * f5) - Math_fround(f6 * f3)) - Math_fround(f7 * f4)) - Math_fround(f8 * f4)) + Math_fround(1.0))))) * Math_fround(4.0));
 i10 = f7 <= Math_fround(3.14159274);
 f8 = Math_fround(f7 + Math_fround(-6.28318548));
 STACKTOP = i9;
 return Math_fround(i10 ? f7 : f8);
}

function __ZN8Renderer26UpdateAllRenderersInternalEb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (i1) {
  i1 = HEAP32[gb + 1158328 + 4 >> 2] | 0;
  if ((i1 | 0) != (gb + 1158328 | 0)) {
   i4 = HEAP32[gb + 1158208 >> 2] | 0;
   HEAP32[i4 + 4 >> 2] = i1;
   HEAP32[gb + 1158208 >> 2] = HEAP32[gb + 1158328 >> 2];
   HEAP32[i1 >> 2] = i4;
   HEAP32[(HEAP32[gb + 1158208 >> 2] | 0) + 4 >> 2] = gb + 1158208;
   HEAP32[gb + 1158328 + 4 >> 2] = gb + 1158328;
   HEAP32[gb + 1158328 >> 2] = gb + 1158328;
  }
 }
 i2 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
 i1 = i2;
 if ((i1 | 0) == (gb + 1158208 | 0)) return;
 do {
  i3 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  i3 = i1 + 316 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   i5 = i1 + 320 | 0;
   HEAP32[i4 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
  i1 = i2;
 } while ((i1 | 0) != (gb + 1158208 | 0));
 i1 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
 if ((i1 | 0) == (gb + 1158208 | 0)) return;
 i5 = HEAP32[gb + 1158328 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[gb + 1158328 >> 2] = HEAP32[gb + 1158208 >> 2];
 HEAP32[i1 >> 2] = i5;
 HEAP32[(HEAP32[gb + 1158328 >> 2] | 0) + 4 >> 2] = gb + 1158328;
 HEAP32[gb + 1158208 + 4 >> 2] = gb + 1158208;
 HEAP32[gb + 1158208 >> 2] = gb + 1158208;
 return;
}

function __ZN5physx2Gu22GJKRelativeTesselationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i2, i4, i3, i11, i5, i6, i9, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, f14 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 8 | 0;
 i8 = i12;
 i1 = __ZN5physx2Gu11gjkRelativeINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE(i2, i4, i3, i5, i6, i9, i10) | 0;
 if ((i1 | 0) == 1) {
  i11 = 1;
  STACKTOP = i12;
  return i11 | 0;
 }
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = f14 > Math_fround(HEAPF32[i10 >> 2]);
 i1 = i13 ? 1 : (i1 | 0) == 3 ? 3 : 0;
 if ((i1 | 0) != 3) {
  i13 = i1;
  STACKTOP = i12;
  return i13 | 0;
 }
 HEAP32[i7 >> 2] = gb + 90548 + 8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i8 >> 2] = gb + 90576 + 8;
 HEAP32[i8 + 4 >> 2] = i4;
 i1 = __ZN5physx2Gu19gjkRelativeFallbackERKNS0_7ConvexVES3_PNS0_10SupportMapES5_RKNS_6shdfnd3aos5Vec3VERS8_SB_SB_RNS7_6FloatVE(i2, i4, i7, i8, i3 + 48 | 0, i5, i6, i9, i10) | 0;
 if ((i1 | 0) != 3) {
  i13 = i1;
  STACKTOP = i12;
  return i13 | 0;
 }
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 i13 = f14 > Math_fround(HEAPF32[i10 >> 2]) & 1;
 STACKTOP = i12;
 return i13 | 0;
}

function __ZN5physx20BigConvexDataBuilder16PrecomputeSampleEjRKNS_6PxVec3E(i16, i15, i1) {
 i16 = i16 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, f13 = f0, f14 = f0;
 i2 = HEAP8[(HEAP32[i16 >> 2] | 0) + 38 >> 0] | 0;
 i12 = HEAP32[i16 + 8 >> 2] | 0;
 if (!(i2 << 24 >> 24)) {
  i2 = 0;
  i1 = 0;
 } else {
  f13 = Math_fround(HEAPF32[i1 >> 2]);
  f14 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i2 = i2 & 255;
  i1 = 0;
  i3 = 0;
  i8 = 0;
  f9 = Math_fround(3402823469999999843913219.0e14);
  f10 = Math_fround(3402823469999999843913219.0e14);
  while (1) {
   f4 = Math_fround(Math_fround(HEAPF32[i12 + (i8 * 12 | 0) >> 2]) * f13);
   f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i12 + (i8 * 12 | 0) + 4 >> 2]) * f14));
   f4 = Math_fround(f4 + Math_fround(Math_fround(HEAPF32[i12 + (i8 * 12 | 0) + 8 >> 2]) * f11));
   i5 = f4 < f10;
   i1 = i5 ? i8 : i1;
   f6 = Math_fround(-f4);
   i7 = f9 > f6;
   i3 = i7 ? i8 : i3;
   i8 = i8 + 1 | 0;
   if ((i8 | 0) == (i2 | 0)) break; else {
    f9 = i7 ? f6 : f9;
    f10 = i5 ? f4 : f10;
   }
  }
  i2 = i1 & 255;
  i1 = i3 & 255;
 }
 i16 = i16 + 4 | 0;
 HEAP8[(HEAP32[(HEAP32[i16 >> 2] | 0) + 4 >> 2] | 0) + i15 >> 0] = i2;
 i16 = HEAP32[i16 >> 2] | 0;
 HEAP8[(HEAP32[i16 + 4 >> 2] | 0) + ((HEAPU16[i16 + 2 >> 1] | 0) + i15) >> 0] = i1;
 return 1;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i6 + 4 | 0;
 i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN14MemoryProfiler24UnregisterRootAllocationEP23AllocationRootReference(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = HEAP32[i1 + 168 >> 2] | 0;
 i4 = i6 + 4 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 } else {
  i3 = i4;
  i2 = i7;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) >>> 0 > i5 >>> 0) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i6 >> 2] | 0) == (i3 | 0)) HEAP32[i6 >> 2] = i1;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i7, i3);
 i7 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = 58;
 HEAP32[i8 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
 STACKTOP = i9;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_118parse_template_argINS0_2DbEEEPKcS4_S4_RT_(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 L1 : do if ((i1 | 0) != (i5 | 0)) switch (HEAP8[i1 >> 0] | 0) {
 case 88:
  {
   i3 = i1 + 1 | 0;
   i2 = __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_(i3, i5, i4) | 0;
   if ((i2 | 0) == (i3 | 0) | (i2 | 0) == (i5 | 0)) break L1;
   i1 = (HEAP8[i2 >> 0] | 0) == 69 ? i2 + 1 | 0 : i1;
   break L1;
  }
 case 74:
  {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break L1;
   while (1) {
    if ((HEAP8[i2 >> 0] | 0) == 69) break;
    i3 = __ZN10__cxxabiv112_GLOBAL__N_118parse_template_argINS0_2DbEEEPKcS4_S4_RT_(i2, i5, i4) | 0;
    if ((i3 | 0) == (i2 | 0)) break L1; else i2 = i3;
   }
   i1 = i2 + 1 | 0;
   break L1;
  }
 case 76:
  {
   i2 = i1 + 1 | 0;
   if ((i2 | 0) != (i5 | 0)) if ((HEAP8[i2 >> 0] | 0) == 90) {
    i3 = i1 + 2 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_(i3, i5, i4) | 0;
    if ((i2 | 0) == (i3 | 0) | (i2 | 0) == (i5 | 0)) break L1;
    i1 = (HEAP8[i2 >> 0] | 0) == 69 ? i2 + 1 | 0 : i1;
    break L1;
   }
   i1 = __ZN10__cxxabiv112_GLOBAL__N_118parse_expr_primaryINS0_2DbEEEPKcS4_S4_RT_(i1, i5, i4) | 0;
   break L1;
  }
 default:
  {
   i1 = __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_(i1, i5, i4) | 0;
   break L1;
  }
 } while (0);
 return i1 | 0;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip17CompressionFormatEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31ParticleSystemVertexStreamFlagsEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31AnimatorControllerParameterTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i11 = 1 - i1 | 0;
 i10 = (HEAP32[i6 + 4 >> 2] | 0) + 96 | 0;
 f9 = Math_fround(HEAPF32[i10 + (i11 << 4) >> 2]);
 f8 = Math_fround(HEAPF32[i10 + (i11 << 4) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + (i11 << 4) + 8 >> 2]);
 i11 = HEAP32[i10 + (i11 << 4) + 12 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 200 >> 2] | 0;
 i10 = HEAP32[i6 + (i2 * 12 | 0) >> 2] | 0;
 i1 = HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] | 0;
 HEAPF32[i4 >> 2] = f9;
 HEAPF32[i4 + 4 >> 2] = f8;
 HEAPF32[i4 + 8 >> 2] = f7;
 HEAP32[i4 + 12 >> 2] = i11;
 HEAP32[i5 >> 2] = i10;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i6;
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 f9 = Math_fround(f9 - (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f8 = Math_fround(f8 - (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i3 >> 2] = f9;
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj49ENS0_26PxPvdRangePropertyAccessorILj49ES4_jEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = i9 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i7 | 0, i4 | 0);
 i4 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i7 >> 2] | 0 : HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj87ENS0_26PxPvdRangePropertyAccessorILj87ES4_jEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = i9 + 4 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, i7 | 0, i4 | 0);
 i4 = HEAP8[i2 + 8 >> 0] | 0 ? HEAP32[i7 >> 2] | 0 : HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN12AudioManager5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i6 = i7;
 HEAPF32[i2 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 36 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 76 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 120 >> 2] = 2;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i2 + 132 >> 2] = 512;
 HEAP32[i2 + 136 >> 2] = 32;
 i1 = i2 + 140 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i4 = i6 + 11 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP8[i6 >> 0] = 0;
 i5 = i1 + 11 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i2 + 144 >> 2] = 0; else HEAP8[i5 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i5 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP8[i2 + 224 >> 0] = 0;
 HEAP8[i2 + 225 >> 0] = 1;
 i6 = i2 + 260 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN10MeshFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1046285 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048075 | 0, gb + 1048082 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z43Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestAllP12Il2CppObjectRK8Vector3ff23QueryTriggerInteraction(i6, i1, f7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f4 * f4);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i9 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 28 >> 2] | 0, 44, 0) | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAPF32[i9 >> 2] = Math_fround(f4 / f3);
 HEAPF32[i9 + 4 >> 2] = Math_fround(f5 / f3);
 HEAPF32[i9 + 8 >> 2] = Math_fround(f2 / f3);
 if (!i6) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 i9 = __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE(__ZN9Rigidbody12SweepTestAllERK8Vector3ff23QueryTriggerInteraction(i1, i9, f7, i8) | 0) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z36QualitySettings_Get_Custom_PropNamesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 __ZN15QualitySettings23GetQualitySettingsNamesEv(i4, __Z18GetQualitySettingsv() | 0);
 i6 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(i6, 4, ((HEAP32[i5 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0) / 12 | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i3 = 0;
  do {
   i9 = i1 + (i3 * 12 | 0) | 0;
   i2 = HEAP8[i9 + 11 >> 0] | 0;
   i8 = i2 << 24 >> 24 < 0;
   __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i6, i3, __Z20scripting_string_newPKcj(i8 ? HEAP32[i9 >> 2] | 0 : i9, i8 ? HEAP32[i1 + (i3 * 12 | 0) + 4 >> 2] | 0 : i2 & 255) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while (i3 >>> 0 < ((i2 - i1 | 0) / 12 | 0) >>> 0);
 }
 i3 = i1;
 if (!i1) {
  STACKTOP = i7;
  return i6 | 0;
 }
 if ((i2 | 0) != (i3 | 0)) {
  do {
   i9 = i2 + -12 | 0;
   HEAP32[i5 >> 2] = i9;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i7;
 return i6 | 0;
}

function __Z18SkinGenericMathLibILi4ELb1ELb1EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi4ELb1ELb1EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi4ELb1ELb1EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z18SkinGenericMathLibILi4ELb1ELb0EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi4ELb1ELb0EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi4ELb1ELb0EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z18SkinGenericMathLibILi2ELb1ELb1EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi2ELb1ELb1EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi2ELb1ELb1EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z18SkinGenericMathLibILi2ELb1ELb0EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi2ELb1ELb0EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi2ELb1ELb0EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z18SkinGenericMathLibILi1ELb1ELb1EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi1ELb1ELb1EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi1ELb1ELb1EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z18SkinGenericMathLibILi1ELb1ELb0EEvR12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 48 | 0;
 i5 = i6;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 1) {
  __Z26SkinVerticesGenericMathLibILi1ELb1ELb0EEvPKhiiiiPhiPKvS4_(HEAP32[i3 + 32 >> 2] | 0, i2 + -1 | 0, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, HEAP32[i3 + 44 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 if ((i2 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) == 4) i1 = 32; else if ((i1 | 0) == 2) i1 = 16; else i1 = (i1 | 0) == 1 ? 4 : 0;
 i11 = i2 + -1 | 0;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + (Math_imul(i11, i1) | 0) | 0;
 i9 = HEAP32[i3 + 40 >> 2] | 0;
 i10 = (HEAP32[i3 + 32 >> 2] | 0) + (Math_imul(i9, i11) | 0) | 0;
 i2 = i3 + 44 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = (HEAP32[i3 + 36 >> 2] | 0) + (Math_imul(i8, i11) | 0) | 0;
 _memcpy(i4 | 0, i10 | 0, i9 | 0) | 0;
 __Z26SkinVerticesGenericMathLibILi1ELb1ELb0EEvPKhiiiiPhiPKvS4_(i4, 1, HEAP32[i3 + 48 >> 2] | 0, HEAP32[i3 + 52 >> 2] | 0, i9, i5, i8, HEAP32[i3 + 68 >> 2] | 0, i7);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z12SetupSteppedP11QuaternionfRK11KeyframeTplIS_ES4_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = i3 + 36 | 0;
 if (!(Math_fround(HEAPF32[i4 >> 2]) == Math_fround(inf))) {
  i1 = i1 + 20 | 0;
  if (!(Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf))) return;
 }
 i5 = i2 + 16 | 0;
 i1 = i2 + 32 | 0;
 i3 = i3 + 4 | 0;
 i4 = i2 + 48 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __ZN5physx9NpFactory14onActorReleaseEPNS_7PxActorE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i9 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 >> 2] | 0);
 i1 = HEAP32[i9 + 584 >> 2] | 0;
 if (!i1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i2 = i7;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i2 = (HEAP32[i9 + 576 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 i5 = HEAP32[i9 + 568 >> 2] | 0;
 i6 = HEAP32[i9 + 572 >> 2] | 0;
 i3 = i1;
 i4 = i2;
 while (1) {
  i1 = i4;
  i4 = i6 + (i3 << 2) | 0;
  i2 = i3;
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i5 + (i2 << 2) >> 2] | 0) == (i7 | 0)) break;
  if ((i3 | 0) == -1) {
   i10 = 7;
   break;
  }
 }
 if ((i10 | 0) == 7) {
  i10 = HEAP32[i8 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i10 = i9 + 600 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
 i10 = i9 + 596 | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 i10 = i9 + 592 | 0;
 HEAP32[i4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i10 >> 2] = i2;
 i10 = HEAP32[i8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i10);
 return;
}

function __ZN5physx2Sc9ShapeCore11setGeometryERKNS_10PxGeometryE(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i1 = i8 + 68 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 5:
  {
   i7 = HEAP32[i8 + 120 >> 2] | 0;
   i5 = i7 & 65535;
   i6 = HEAP32[i8 + 116 >> 2] | 0;
   i7 = i7 >>> 16 & 65535;
   break;
  }
 case 6:
  {
   i7 = HEAP32[i8 + 100 >> 2] | 0;
   i5 = i7 & 65535;
   i6 = HEAP32[i8 + 96 >> 2] | 0;
   i7 = i7 >>> 16 & 65535;
   break;
  }
 default:
  {
   i5 = 0;
   i6 = 0;
   i7 = 0;
  }
 }
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i1, i3);
 if ((i2 + -5 | 0) >>> 0 < 2) {
  i1 = (i2 | 0) == 5 ? i8 + 116 | 0 : i8 + 96 | 0;
  if (!(i5 << 16 >> 16)) {
   i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 2, gb + 687358 | 0, 90) | 0;
   HEAP32[i1 >> 2] = i7;
   HEAP16[i1 + 4 >> 1] = 1;
   HEAP16[i7 >> 1] = HEAP16[i8 + 66 >> 1] | 0;
   HEAP8[i8 + 132 >> 0] = 1;
   STACKTOP = i9;
   return;
  } else {
   HEAP32[i1 >> 2] = i6;
   HEAP16[i1 + 4 >> 1] = i5;
   HEAP16[i1 + 6 >> 1] = i7;
   STACKTOP = i9;
   return;
  }
 }
 if (!(i5 << 16 >> 16)) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP8[i8 + 132 >> 0] | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i6);
 STACKTOP = i9;
 return;
}
function __ZN5physx2Sc10NPhaseCore39pool_deleteParticleElementRbElementPairEPNS0_35ParticleElementRbElementInteractionEjj(i5, i3, i2, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = HEAP32[i3 + 40 >> 2] | 0;
 __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEbj(i3, (i2 & 3 | 0) == 3, i1);
 i2 = i5 + 1920 | 0;
 if (i3 | 0) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  i1 = i5 + 2200 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i5 + 2212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i3;
  i1 = i5 + 2204 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  if ((i3 | 0) >= ((HEAP32[i5 + 2196 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2);
   HEAP32[i1 >> 2] = 0;
  }
 }
 i2 = i4 + 16 | 0;
 i3 = (HEAP16[i2 >> 1] | 0) + -1 << 16 >> 16;
 HEAP16[i2 >> 1] = i3;
 if (i3 << 16 >> 16) return;
 i1 = i5 + 720 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i5 + 732 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i1 = i5 + 724 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i5 + 716 >> 2] | 0) * 50 | 0)) return;
 __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i5 + 440 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx17PxsFluidCollision12mergeResultsEPNS_10PxBaseTaskE(i14, i1) {
 i14 = i14 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, f15 = f0;
 i1 = HEAP32[(HEAP32[i14 + 96 >> 2] | 0) + 8 >> 2] | 0;
 i8 = i1 + 24 | 0;
 i9 = i1 + 28 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 36 | 0;
 i12 = i1 + 40 | 0;
 i1 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(HEAPF32[i11 >> 2]);
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i13 = 0;
 do {
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 20 >> 2]);
  f2 = f2 < f15 ? f2 : f15;
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 24 >> 2]);
  f3 = f3 < f15 ? f3 : f15;
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 28 >> 2]);
  f4 = f4 < f15 ? f4 : f15;
  HEAPF32[i8 >> 2] = f2;
  HEAPF32[i9 >> 2] = f3;
  HEAPF32[i10 >> 2] = f4;
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 32 >> 2]);
  f5 = f5 > f15 ? f5 : f15;
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 36 >> 2]);
  f6 = f6 > f15 ? f6 : f15;
  f15 = Math_fround(HEAPF32[i14 + 100 + (i13 * 44 | 0) + 40 >> 2]);
  f7 = f7 > f15 ? f7 : f15;
  HEAPF32[i11 >> 2] = f5;
  HEAPF32[i12 >> 2] = f6;
  HEAPF32[i1 >> 2] = f7;
  i13 = i13 + 1 | 0;
 } while ((i13 | 0) != 8);
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 20 | 0, i3);
 i1 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i5, 0);
 __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN19RuntimeSceneManager9GetScenesERK13dynamic_arrayIiLj4EERS0_IP10UnitySceneLj4EE(i3, i4, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = i4 + 12 | 0;
 if (!(HEAP32[i11 >> 2] | 0)) return;
 i12 = i8 + 12 | 0;
 i13 = i8 + 16 | 0;
 i14 = i8 + 4 | 0;
 i1 = 0;
 do {
  i10 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
  i5 = i10;
  if (i10 | 0) {
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 + 1 | 0;
   i9 = HEAP32[i13 >> 2] | 0;
   i10 = i9 & 2147483647;
   do if (i7 >>> 0 > i10 >>> 0) {
    i2 = i9 << 1;
    i2 = (i2 | 0) == 0 ? 1 : i2;
    if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
     HEAP32[i13 >> 2] = i2;
     HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i2 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i10 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
     HEAP32[i13 >> 2] = i2;
     HEAP32[i8 >> 2] = i10;
     break;
    }
   } while (0);
   HEAP32[i12 >> 2] = i7;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] = i5;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0);
 return;
}

function __ZN14UnityAnalytics16SetUserBirthYearEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 72 | 0;
 i4 = i5;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
  i4 = 2;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZN11UnityEngine9Analytics13UserInfoEventC2Ev(i4);
 HEAP32[i4 + 64 >> 2] = i2;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i4, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i4 >> 2] = gb + 188648 + 8;
 i1 = i4 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 i1 = i4 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 HEAP32[i4 >> 2] = gb + 190148 + 8;
 i1 = i4 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i4 + 16 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13TreePrototype8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932472 | 0, gb + 932544 | 0, i1, 0);
 i6 = i5 + 8 | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932628 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Face_GetVariantsOfChar(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 if (!i8) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = HEAP32[i8 + 36 >> 2] | 0;
 i7 = i1 + (i5 << 2) | 0;
 if ((i5 | 0) <= 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i6 + 4 | 0;
 L10 : while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  do if ((HEAP32[i4 + 8 >> 2] | 0) == 327680) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i2 = HEAP32[i2 + 96 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
     if (i2 | 0) if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i4 | 0, i6 | 0) | 0)) if ((HEAP32[i5 >> 2] | 0) == 14) break L10; else break;
    }
   }
  } while (0);
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i10 = 15;
   break;
  }
 }
 if ((i10 | 0) == 15) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = mftCall_iiii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, HEAP32[i8 + 100 >> 2] | 0, i9 | 0) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function _UNITY_FT_Face_GetCharsOfVariant(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 if (!i8) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = HEAP32[i8 + 36 >> 2] | 0;
 i7 = i1 + (i5 << 2) | 0;
 if ((i5 | 0) <= 0) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i6 + 4 | 0;
 L10 : while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  do if ((HEAP32[i4 + 8 >> 2] | 0) == 327680) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i2 = HEAP32[i2 + 96 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
     if (i2 | 0) if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i4 | 0, i6 | 0) | 0)) if ((HEAP32[i5 >> 2] | 0) == 14) break L10; else break;
    }
   }
  } while (0);
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i10 = 15;
   break;
  }
 }
 if ((i10 | 0) == 15) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i10 = mftCall_iiii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, HEAP32[i8 + 100 >> 2] | 0, i9 | 0) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN22ProceduralMaterialData19GetSubstancePackageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 8; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 8; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 10;
  }
 }
 if ((i5 | 0) == 8) i5 = 10;
 if ((i5 | 0) == 10) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 422379 | 0, i1, 0);
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 344 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 422397 | 0, gb + 422409 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN14EmissionModule16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 88 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = f6 > Math_fround(0.0);
 f6 = i1 ? f6 : Math_fround(0.0);
 HEAPF32[i4 >> 2] = f6;
 HEAP8[i2 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 8 | 0, i2 + 96 | 0, f6, HEAP16[i2 + 92 >> 1] | 0) | 0) & 1;
 i4 = i2 + 352 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = f6 > Math_fround(0.0);
 f6 = i1 ? f6 : Math_fround(0.0);
 HEAPF32[i4 >> 2] = f6;
 HEAP8[i2 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i2 + 272 | 0, i2 + 360 | 0, f6, HEAP16[i2 + 356 >> 1] | 0) | 0) & 1;
 i4 = HEAP32[i2 + 584 >> 2] | 0;
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 i1 = 0;
 do {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i7 = i2 + 536 + (i1 << 2) | 0;
  i8 = Math_fround(HEAPF32[i7 >> 2]) > Math_fround(0.0);
  HEAP32[i7 >> 2] = HEAP32[(i8 ? i7 : i3) >> 2];
  i7 = i2 + 552 + (i1 << 2) | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = (i8 | 0) < 0 ? 0 : i8;
  HEAP32[i7 >> 2] = i8;
  i7 = i2 + 568 + (i1 << 2) | 0;
  i9 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = (i8 | 0) < (i9 | 0) ? i9 : i8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i5;
 return;
}

function __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i9);
 i2 = i8 + 32 | 0;
 i6 = i9 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 40 | 0, i9);
 i4 = i8 + 36 | 0;
 HEAPF32[i5 >> 2] = Math_fround(HEAP32[i4 >> 2] | 0);
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  f1 = Math_fround(HEAPF32[i5 >> 2]);
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  f1 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 HEAP32[i4 >> 2] = ~~f1;
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 44 | 0, i9);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
 __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i8 + 48 >> 2] | 0, i9);
 STACKTOP = i10;
 return;
}

function __Z48TerrainData_CUSTOM_INTERNAL_CALL_GetTreeInstanceP12Il2CppObjectiR12TreeInstance(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = i2 + 100 | 0;
 if ((i3 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 944884 | 0, i5);
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = i7;
 if ((((HEAP32[i2 + 4 >> 2] | 0) - i7 | 0) / 40 | 0) >>> 0 > i3 >>> 0) {
  i5 = i1 + (i3 * 40 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i4 + 24 >> 2] = HEAP32[i1 + (i3 * 40 | 0) + 24 >> 2];
  HEAP32[i4 + 28 >> 2] = HEAP32[i1 + (i3 * 40 | 0) + 28 >> 2];
  i3 = i1 + (i3 * 40 | 0) + 32 | 0;
  i5 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = i4 + 32 | 0;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
  STACKTOP = i6;
  return;
 } else __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 944884 | 0, i5);
}

function __Z36RegisterModuleClasses_ParticleSystemv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 809;
 HEAP32[i2 + 8 >> 2] = gb + 618922;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 198;
 HEAP32[i2 + 20 >> 2] = 948;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 80300;
 HEAP32[i2 + 44 >> 2] = fb + 197;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 198;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 810;
 HEAP32[i2 + 8 >> 2] = gb + 621574;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 199;
 HEAP32[i2 + 20 >> 2] = 1036;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 80260;
 HEAP32[i2 + 44 >> 2] = fb + 199;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D13InterpolationEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead28TransitionInterruptionSourceEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZN8JSONRead8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37208 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  i9 = i6 + 56 | 0;
  i8 = (HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 3) + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1085989 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1085998 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1084342 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1085899 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN19ClampVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 536 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 800 | 0, i4);
 i1 = i3 + 1065 | 0;
 i6 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i3 + 1064 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 i1 = i3 + 1068 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  return;
 }
}

function __ZN17RenderLoopContextC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 36864 + 8;
 HEAP32[i1 + 956 >> 2] = 0;
 HEAP32[i1 + 960 >> 2] = -1;
 HEAPF32[i1 + 1596 >> 2] = Math_fround(0.0);
 i6 = i1 + 1796 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i1 + 1828 >> 2] = 0;
 HEAP32[i1 + 1832 >> 2] = 0;
 i6 = i2;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i6;
 HEAP32[i1 + 1840 >> 2] = 0;
 HEAP32[i1 + 1852 >> 2] = 0;
 HEAP32[i1 + 1856 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i9 = i5;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1 + 1844 | 0;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = i4;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 1860 >> 2] = 0;
 HEAP32[i1 + 1872 >> 2] = 0;
 HEAP32[i1 + 1876 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 1864 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i1 + 1880 >> 2] = 0;
 HEAP32[i1 + 1884 >> 2] = -1;
 HEAP32[i1 + 1888 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN15PointEffector2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 92 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i1 = i2 + 96 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i1 = i2 + 100 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(.0000999999974);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(.0000999999974) : f3;
 i1 = i2 + 104 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 108 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 112 | 0;
 if ((HEAP32[i1 >> 2] | 0) > 1) HEAP32[i1 >> 2] = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) > 1) HEAP32[i1 >> 2] = 0;
 i1 = i2 + 120 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= 2) return;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags(i7, i2, i3, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 4 | 0;
 i4 = i6;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, i3, gb + 905830 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i7 + 4 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 20, 4) | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   HEAP32[i1 + 16 >> 2] = 0;
   i4 = i2;
   i1 = i1 | 0 ? i1 - i4 | 0 : 0;
   HEAP32[i2 >> 2] = i1;
   i2 = i4;
  }
  i3 = i1 + i2 | 0;
  i1 = i3;
  i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i7, gb + 1041891 | 0, gb + 906499 | 0, i5, 1) | 0;
  if (i2 | 0) {
   if ((i2 | 0) > 0) __ZN7mecanim8skeleton8Skeleton8TransferI14SafeBinaryReadEEvRT_(i1, i7); else {
    i1 = HEAP32[i5 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i7 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i7);
  }
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i7 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i7);
 STACKTOP = i6;
 return;
}

function __Z55AssetBundle_CUSTOM_LoadAssetWithSubAssetsAsync_InternalP12Il2CppObjectP12Il2CppStringS0_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (HEAP8[i1 + 184 >> 0] | 0) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 495978 | 0, i6);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
  i4 = __ZN29AssetBundleLoadAssetOperation9LoadAssetER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb(i1, i5, i3, 1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i7 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 32 >> 2] | 0) | 0;
  HEAP32[i7 + 8 >> 2] = i4;
  STACKTOP = i6;
  return i7 | 0;
 }
 return 0;
}

function __ZN8JSONRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 36980 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  i9 = i6 + 56 | 0;
  i8 = (HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 3) + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1084155 | 0, 1, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1086064 | 0, 1, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1085890 | 0, 1, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1085926 | 0, 1, 0);
  HEAP8[i5 >> 0] = 1;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx16PxsIslandManager11freeBuffersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i3 + 632 | 0;
 if (!(HEAP32[i3 + 644 >> 2] | 0)) return;
 i2 = i3 + 478 | 0;
 if (HEAP8[i2 >> 0] | 0) if (HEAP32[i3 + 452 >> 2] | 0) {
  i8 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i3 + 636 >> 2] | 0;
  i5 = HEAP32[i3 + 720 >> 2] | 0;
  i4 = HEAP32[i3 + 724 >> 2] | 0;
  i6 = HEAP32[i3 + 704 >> 2] | 0;
  _memset(HEAP32[i6 >> 2] | 0, 0, HEAP32[i6 + 4 >> 2] << 2 | 0) | 0;
  __ZN5physx33mergeKinematicProxiesBackToSourceERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjS8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERS4_PjSG_(HEAP32[i3 + 264 >> 2] | 0, i8, i7, i3 + 12 | 0, i3 + 280 | 0, i3 + 372 | 0, i6, i5, i4);
 }
 HEAP8[i3 + 476 >> 0] = (HEAP32[i3 + 592 >> 2] | 0) == 0 & 1;
 HEAP8[i3 + 477 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i3 + 716 >> 2] = 0;
 HEAP32[i3 + 720 >> 2] = 0;
 HEAP32[i3 + 724 >> 2] = 0;
 HEAP32[i3 + 480 >> 2] = 0;
 HEAP32[i3 + 488 >> 2] = 0;
 HEAP32[i3 + 504 >> 2] = 0;
 HEAP32[i3 + 516 >> 2] = 0;
 HEAP32[i3 + 524 >> 2] = 0;
 HEAP32[i3 + 536 >> 2] = 0;
 HEAP32[i3 + 548 >> 2] = 0;
 HEAP32[i3 + 552 >> 2] = 0;
 HEAP32[i3 + 564 >> 2] = 0;
 HEAP32[i3 + 576 >> 2] = 0;
 HEAP32[i3 + 588 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer8AddEventEPNS0_14CloudEventInfoE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = i1;
 i3 = i5 + 72 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i5 + 76 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i5 + 68 | 0, i2); else {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
 }
 if (HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] & 1 | 0) {
  i4 = i5 + 84 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 i1 = i5 + 96 | 0;
 i4 = i1;
 if (!((HEAP32[i4 >> 2] | 0) == 0 & (HEAP32[i4 + 4 >> 2] | 0) == 0)) {
  i5 = i5 + 89 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i6;
  return 1;
 }
 i2 = _time(0) | 0;
 HEAP32[i5 + 104 + 4 >> 2] = i2;
 i3 = HEAP16[gb + 1478660 >> 1] | 0;
 HEAP16[gb + 1478660 >> 1] = i3 + 1 << 16 >> 16;
 HEAP16[i5 + 112 >> 1] = i3;
 i2 = ___muldi3(i2 | 0, 0, 1e5, 0) | 0;
 i2 = _i64Add(i3 & 65535 | 0, 0, i2 | 0, getTempRet0() | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 i5 = i5 + 89 | 0;
 HEAP8[i5 >> 0] = 1;
 STACKTOP = i6;
 return 1;
}

function _UNITY_FT_Glyph_Copy(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 if (!((i6 | 0) != 0 & (i7 | 0) != 0)) {
  i8 = 6;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i6 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i8 = 6;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!i5) {
  i8 = 6;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i8 = _UNITY_ft_mem_alloc(HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = i2;
 i4 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 i1 = i8 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 4 >> 2];
 i10 = i6 + 12 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i8 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 if (i1 | 0) {
  i3 = mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
  if (i3 | 0) {
   i2 = HEAP32[HEAP32[i8 >> 2] >> 2] | 0;
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0;
   if (i1 | 0) mftCall_vi(i1 | 0, i8 | 0);
   _UNITY_ft_mem_free(i2, i8);
   i10 = i3;
   STACKTOP = i9;
   return i10 | 0;
  }
 }
 HEAP32[i7 >> 2] = i8;
 i10 = 0;
 STACKTOP = i9;
 return i10 | 0;
}

function __ZNK5Umbra14TomeCollection15findObjectIndexEj(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i4) {
  i10 = 0;
  return i10 | 0;
 }
 i8 = HEAP32[i4 + 76 >> 2] | 0;
 i9 = i4 + i8 | 0;
 if ((i8 | 0) == 0 | (i9 | 0) == 0) {
  i2 = HEAP32[i4 + 80 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
  i3 = HEAP32[i4 + 64 >> 2] | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   i10 = -1;
   return i10 | 0;
  }
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i10 | 0)) {
    i2 = 12;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i1 = -1;
    i2 = 12;
    break;
   }
  }
  if ((i2 | 0) == 12) return i1 | 0;
 }
 i8 = HEAP32[i4 + 64 >> 2] | 0;
 if ((i8 | 0) <= 0) {
  i10 = -1;
  return i10 | 0;
 }
 i2 = HEAP32[i4 + 80 >> 2] | 0;
 i4 = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
 i2 = 0;
 i6 = HEAP32[i9 >> 2] | 0;
 L18 : while (1) {
  i5 = i4 + (i6 << 2) | 0;
  i1 = i2;
  i2 = i2 + 1 | 0;
  i7 = i6;
  i6 = HEAP32[i9 + (i2 << 2) >> 2] | 0;
  i7 = i6 - i7 | 0;
  if ((i7 | 0) > 0) {
   i3 = 0;
   do {
    if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i10 | 0)) {
     i2 = 12;
     break L18;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i7 | 0));
  }
  if ((i2 | 0) >= (i8 | 0)) {
   i1 = -1;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((i6 | 0) > 1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400937 | 0, 0, gb + 400980 | 0, 174, 1, 0, 0, 0);
  STACKTOP = i7;
  return;
 }
 if ((HEAP16[gb + 1157796 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157796 | 0, i1);
  i2 = gb + 1157796 | 0;
 } else i2 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 836 >> 2] | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 i1 = Math_imul(i6, i5) | 0;
 if (HEAP8[i3 + 3896 >> 0] | 0) {
  i6 = i3 + 3644 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  i6 = i3 + 3648 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
  i6 = i3 + 3656 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
  i6 = i3 + 3652 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
  i6 = i3 + 3640 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __Z15gpu_time_samplev();
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return;
}

function __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i7 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i1 = i7 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i7 + 4 | 0;
  i3 = 0;
  do {
   __ZN5physx7NpScene14removeMaterialERNS_10NpMaterialE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i4);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i4 = HEAP32[i4 + 52 >> 2] | 0;
 if ((i4 | 0) == -1) {
  i7 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return;
 }
 HEAP32[(HEAP32[i7 + 52 >> 2] | 0) + (i4 << 2) >> 2] = 0;
 HEAP32[i5 >> 2] = i4;
 i1 = i7 + 36 | 0;
 do if (((HEAP32[i1 >> 2] | 0) + -1 | 0) == (i4 | 0)) HEAP32[i1 >> 2] = i4; else {
  i1 = i7 + 40 | 0;
  i2 = i7 + 44 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((HEAP32[i7 + 48 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i4;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i5) | 0;
   break;
  }
 } while (0);
 i7 = HEAP32[i6 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Cct13BoxControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i4 >> 2] = gb + 86668 + 8;
 i7 = i4 + 8 | 0;
 __ZN5physx3Cct10ControllerC2ERKNS_16PxControllerDescEPNS_7PxSceneE(i7, i1, i2);
 HEAP32[i4 >> 2] = gb + 83652 + 8;
 HEAP32[i7 >> 2] = gb + 83652 + 160;
 HEAP32[i4 + 12 >> 2] = 0;
 i13 = HEAP32[i1 + 108 >> 2] | 0;
 HEAP32[i4 + 496 >> 2] = i13;
 i12 = HEAP32[i1 + 112 >> 2] | 0;
 HEAP32[i4 + 500 >> 2] = i12;
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 HEAP32[i4 + 504 >> 2] = i2;
 HEAP32[i6 >> 2] = 3;
 f11 = (HEAP32[tempDoublePtr >> 2] = i13, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i12, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f10 = Math_fround(HEAPF32[i4 + 488 >> 2]);
 f9 = Math_fround(f9 * f10);
 f8 = Math_fround(f8 * f10);
 HEAPF32[i6 + 4 >> 2] = Math_fround(f11 * f10);
 HEAPF32[i6 + 8 >> 2] = f9;
 HEAPF32[i6 + 12 >> 2] = f8;
 __ZN5physx3Cct10Controller16createProxyActorERNS_9PxPhysicsERKNS_10PxGeometryERKNS_10PxMaterialE(i7, i3, i6, HEAP32[i1 + 96 >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sn4peekEiPKci(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 & 2048;
 i5 = i1 & 4096;
 switch (i3 | 0) {
 case 1:
  {
   i1 = HEAP8[i2 >> 0] | 0;
   if (!i4) {
    i3 = i1;
    i5 = (i5 | 0) != 0;
    i4 = i3 << 24 >> 24 == 1;
    i4 = i5 & i4;
    i5 = i3 & 255;
    i5 = i4 ? 0 : i5;
    i4 = i4 ? 0 : 0;
    setTempRet0(i4 | 0);
    return i5 | 0;
   }
   i3 = i1 & 127;
   i5 = (i5 | 0) != 0;
   i4 = i3 << 24 >> 24 == 1;
   i4 = i5 & i4;
   i5 = i3 & 255;
   i5 = i4 ? 0 : i5;
   i4 = i4 ? 0 : 0;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
 case 2:
  {
   i1 = HEAP16[i2 >> 1] | 0;
   if (i4) i1 = i1 & 32767;
   i5 = (i5 | 0) != 0 & i1 << 16 >> 16 == 1;
   i4 = i5 ? 0 : 0;
   i5 = i5 ? 0 : i1 & 65535;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
 case 4:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   i3 = (i4 | 0) == 0 ? i3 : i3 & 2147483647;
   i5 = (i5 | 0) != 0 & (i3 | 0) == 1;
   i4 = i5 ? 0 : 0;
   i5 = i5 ? 0 : i3;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
 case 8:
  {
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   i4 = (i4 | 0) == 0;
   i3 = i4 ? i3 : i3;
   i4 = i4 ? i2 : i2 & 2147483647;
   i5 = (i5 | 0) != 0 & ((i3 | 0) == 1 & (i4 | 0) == 0);
   i4 = i5 ? 0 : i4;
   i5 = i5 ? 0 : i3;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
 default:
  {
   i4 = -1;
   i5 = -1;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
 }
 return 0;
}

function __ZN5Unity11SpringJoint16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity5Joint16CheckConsistencyEv(i1);
 i3 = i1 + 104 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 108 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 112 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(1.00000005e-20);
 i4 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i4 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(1.00000005e-20) : f2;
 return;
}

function __ZN21BillboardBatchManager23SetBillboardShaderPropsER16ShaderKeywordSetR24BuiltinShaderParamValuesbRK10Matrix4x4fRK8Vector3f(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11 + 16 | 0;
 i8 = i11 + 4 | 0;
 i9 = i11;
 i10 = HEAP32[gb + 1159952 >> 2] | 0;
 i3 = 1 << (i10 & 31);
 if (i4) {
  i10 = i1 + (i10 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | i3;
 } else {
  i10 = i1 + (i10 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~i3;
 }
 __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf(i5, i7, i8, i9);
 i5 = HEAP32[i7 + 4 >> 2] | 0;
 i10 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i2 + 1664 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 1668 >> 2] = i5;
 HEAP32[i2 + 1672 >> 2] = i10;
 HEAPF32[i2 + 1676 >> 2] = Math_fround(0.0);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i10 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i2 + 1648 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 1652 >> 2] = i7;
 HEAP32[i2 + 1656 >> 2] = i10;
 HEAPF32[i2 + 1660 >> 2] = Math_fround(0.0);
 i10 = HEAP32[i9 >> 2] | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i2 + 1680 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 1684 >> 2] = i8;
 HEAP32[i2 + 1688 >> 2] = i9;
 HEAP32[i2 + 1692 >> 2] = i10;
 STACKTOP = i11;
 return;
}

function __ZN20ArchiveStorageReader28TryReadDirectoryInfoFromFileEP5IFile(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 1068 | 0;
 i7 = i3;
 i4 = i3 + 8 | 0;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = i8;
 i6 = i5 + 1040 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 i6 = __ZnwjRK10MemLabelIdiPKci(20, i7, 16, gb + 586372 | 0, 37) | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 70720 + 8;
 HEAP32[i6 + 4 >> 2] = i2;
 i2 = i6 + 8 | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP8[i6 + 16 >> 0] = 0;
 HEAP32[i5 + 1044 >> 2] = i6;
 __ZN15FileSystemEntryC2ERK13FileEntryData(i4, i5);
 __ZN13FileEntryDataD2Ev(i5);
 __ZN12FileAccessorC2Ev(i5);
 __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i5, i4, 0, 0) | 0;
 __ZN12FileAccessor4SeekEx10FileOrigin(i5, 0, 0, 1) | 0;
 i2 = (__ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE(i5, i1 + 8 | 0, i1 + 120 | 0) | 0) == 0;
 __ZN12FileAccessorD2Ev(i5);
 __ZN13FileEntryDataD2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 __ZN17AnimationCurveTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 16 | 0, i9);
 i6 = i7 + 11 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i8 = i7 + 4 | 0;
 i1 = i2 << 24 >> 24 < 0 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 HEAP32[i5 >> 2] = i1;
 i10 = i9 + 16 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i11 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i10 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i5, 4);
  i2 = HEAP8[i6 >> 0] | 0;
 }
 i3 = i2 << 24 >> 24 < 0;
 i1 = i3 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i3 ? HEAP32[i8 >> 2] | 0 : i2 & 255;
 i3 = i1 + i8 | 0;
 if (!i8) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i12;
  return;
 }
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i11 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i12;
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1046296 | 0, i1, 0);
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 380 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426616 | 0, gb + 1048082 | 0, i4, 1);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN12LineRenderer17SetPositionsCountEi(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i1 | 0) < 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406822 | 0, 0, gb + 406663 | 0, 69, 1, 0, 0, 0);
  i1 = 0;
 }
 i2 = i8 + 316 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i7 = i8 + 320 | 0;
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i6;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
  }
 }
 i7 = i8 + 348 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = i2 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 do if ((i6 & 2147483647) >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i6;
  break;
 } while (0);
 __ZN8Renderer10SetVisibleEb(i8, (HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0) >>> 0 > 1);
 __ZN8Renderer13BoundsChangedEv(i8);
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead25ProceduralLoadingBehaviorEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 8;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 8;
  if ((i7 | 0) != 7) if ((i7 | 0) == 8) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 10; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 10; else if ((i2 | 0) >= 0) {
     i1 = 1;
     i7 = 14;
     break;
    }
   }
   if ((i7 | 0) == 10) if (!i6) {
    i1 = 1;
    i7 = 14;
    break;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx24NpPtrTableStorageManagerC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 146776 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 276 >> 2] = 0;
 HEAP8[i2 + 268 >> 0] = 1;
 HEAP32[i2 + 272 >> 2] = i2 + 12;
 HEAP32[i2 + 280 >> 2] = 64;
 HEAP32[i2 + 284 >> 2] = 256;
 HEAP32[i2 + 288 >> 2] = 0;
 HEAP32[i2 + 292 >> 2] = 0;
 HEAP32[i2 + 296 >> 2] = 4096;
 HEAP32[i2 + 300 >> 2] = 0;
 HEAP32[i2 + 572 >> 2] = 0;
 HEAP8[i2 + 564 >> 0] = 1;
 HEAP32[i2 + 568 >> 2] = i2 + 308;
 HEAP32[i2 + 576 >> 2] = 64;
 HEAP32[i2 + 580 >> 2] = 64;
 HEAP32[i2 + 584 >> 2] = 0;
 HEAP32[i2 + 588 >> 2] = 0;
 HEAP32[i2 + 592 >> 2] = 4096;
 HEAP32[i2 + 596 >> 2] = 0;
 HEAP32[i2 + 868 >> 2] = 0;
 HEAP8[i2 + 860 >> 0] = 1;
 HEAP32[i2 + 864 >> 2] = i2 + 604;
 HEAP32[i2 + 872 >> 2] = 64;
 HEAP32[i2 + 876 >> 2] = 16;
 HEAP32[i2 + 880 >> 2] = 0;
 HEAP32[i2 + 884 >> 2] = 0;
 HEAP32[i2 + 888 >> 2] = 4096;
 HEAP32[i2 + 892 >> 2] = 0;
 return;
}

function __ZN5Unity10FixedJointC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 112584 + 8;
 i5 = i1 + 40 | 0;
 i2 = i1 + 52 | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP8[i1 + 76 >> 0] = 1;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i1 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i1 + 88 >> 0] = 0;
 HEAP8[i1 + 89 >> 0] = 1;
 HEAPF32[i1 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 84 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = gb + 112184 + 8;
 STACKTOP = i4;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 i1 = i4 + 16 | 0;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 28 | 0, i3);
 __ZN24GenerateTypeTreeTransfer8TransferIN9ShaderLab19SerializedSubShaderEEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i4 + 12 | 0, HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -872 | 0;
   HEAP32[i5 >> 2] = i3;
   __ZN9ShaderLab14SerializedPassD2Ev(i3);
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN15SerializeTraitsI9OffsetPtrIN7mecanim4hand4HandEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 60, 4) | 0;
  __ZN7mecanim4hand4HandC2Ev(i2);
  i6 = i1;
  i2 = i2 | 0 ? i2 - i6 | 0 : 0;
  HEAP32[i1 >> 2] = i2;
  i1 = i6;
 }
 i3 = i2 + i1 | 0;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 i2 = _llvm_bswap_i32(i1 | 0) | 0;
 i2 = i2 >>> 0 > 15 ? 15 : i2;
 i4 = i3 + (i2 << 2) | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i7, 4);
   i1 = HEAP32[i7 >> 2] | 0;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i6 >> 2] = i2;
  }
  HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 189940 + 8;
 i5 = i1 + 44 | 0;
 i3 = i1 + 48 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1 + 56 | 0, HEAP32[i1 + 60 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 190020 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 STACKTOP = i4;
 return;
}

function __Z12UpdateClothsv() {
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 i5 = i6 + 8 | 0;
 f3 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 1459020 >> 2]);
 if (!(f4 == Math_fround(0.0))) f3 = Math_fround(Math_fround(f3 * Math_fround(.699999988)) + Math_fround(f4 * Math_fround(.300000012)));
 HEAPF32[gb + 1459020 >> 2] = f3;
 if (!(HEAP32[gb + 1459016 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1458944 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458944 | 0, i1);
  i2 = gb + 1458944 | 0;
 } else i2 = 0;
 __ZN19SkinnedMeshRenderer22UpdateAllSkinnedMeshesENS_10UpdateTypeEP13dynamic_arrayIPS_Lj4EE(0, gb + 1458984 | 0);
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0;
 HEAP16[i5 >> 1] = 32;
 i5 = (mftCall_iii(i7 | 0, i1 | 0, i5 | 0) | 0) == 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 if (i5) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  HEAP32[gb + 1459016 >> 2] = 0;
 } else __Z21SimulateClothingScenePN5physx7PxSceneE(i1);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function _catanf(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, d3 = 0.0, f4 = f0, f5 = f0, f6 = f0, i8 = 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f4 == Math_fround(0.0) & f5 > Math_fround(1.0)) i8 = 5; else {
  f6 = Math_fround(f4 * f4);
  f2 = Math_fround(Math_fround(Math_fround(1.0) - f6) - Math_fround(f5 * f5));
  if (f2 == Math_fround(0.0)) i8 = 5; else {
   f2 = Math_fround(Math_fround(+Math_atan2(+Math_fround(f4 * Math_fround(2.0)), +f2)) * Math_fround(.5));
   f4 = Math_fround(f2 / Math_fround(3.14159274));
   i1 = !(f4 >= Math_fround(0.0));
   d3 = +Math_fround(~~Math_fround(f4 + (i1 ? Math_fround(-.5) : Math_fround(.5))) | 0);
   f4 = Math_fround(f5 + Math_fround(-1.0));
   f4 = Math_fround(f6 + Math_fround(f4 * f4));
   if (f4 == Math_fround(0.0)) i8 = 5; else {
    f5 = Math_fround(f5 + Math_fround(1.0));
    f5 = Math_fround(Math_fround(+Math_log(+Math_fround(Math_fround(f6 + Math_fround(f5 * f5)) / f4))) * Math_fround(.25));
    f6 = Math_fround(f5 + Math_fround(0.0));
    HEAPF32[i7 >> 2] = Math_fround(Math_fround(+f2 - d3 * 3.140625 - d3 * 9.675025939941406e-04 - d3 * 1.5099579909783765e-07) + Math_fround(f5 * Math_fround(0.0)));
    HEAPF32[i7 + 4 >> 2] = f6;
   }
  }
 }
 if ((i8 | 0) == 5) {
  HEAPF32[i7 >> 2] = Math_fround(9999999680000000626531571.0e13);
  HEAPF32[i7 + 4 >> 2] = Math_fround(9999999680000000626531571.0e13);
 }
 return;
}

function __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE14__count_uniqueIS7_EEjRKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 8;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 8;
  if ((i7 | 0) != 7) if ((i7 | 0) == 8) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 10; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 10; else if ((i2 | 0) >= 0) {
     i1 = 1;
     i7 = 14;
     break;
    }
   }
   if ((i7 | 0) == 10) if (!i6) {
    i1 = 1;
    i7 = 14;
    break;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZNK5physx3Cct26CharacterControllerManager17onObstacleUpdatedEjPKNS_17PxObstacleContextE(i1, i11, i10) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 12 | 0;
 i8 = i12;
 i9 = i1 + 68 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = i1 + 64 | 0;
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8 + 8 | 0;
 i6 = 0;
 do {
  i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  f14 = Math_fround(+HEAPF64[i13 + 408 >> 3]);
  f15 = Math_fround(+HEAPF64[i13 + 416 >> 3]);
  f16 = Math_fround(+HEAPF64[i13 + 424 >> 3]);
  HEAPF32[i7 >> 2] = f14;
  HEAPF32[i2 >> 2] = f15;
  HEAPF32[i3 >> 2] = f16;
  f16 = Math_fround(-Math_fround(HEAPF32[i13 + 28 >> 2]));
  f15 = Math_fround(-Math_fround(HEAPF32[i13 + 32 >> 2]));
  f14 = Math_fround(-Math_fround(HEAPF32[i13 + 36 >> 2]));
  HEAPF32[i8 >> 2] = f16;
  HEAPF32[i4 >> 2] = f15;
  HEAPF32[i5 >> 2] = f14;
  __ZN5physx3Cct9SweepTest17onObstacleUpdatedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f(i13 + 88 | 0, i11, i10, i7, i8, Math_fround(+mftCall_fi(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0)));
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 STACKTOP = i12;
 return;
}

function __ZN8JSONRead8TransferI8Vector4fEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37328 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  i9 = i6 + 56 | 0;
  i8 = (HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 3) + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1085989 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1085998 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1084342 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1085899 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN7dtCrowd11AddObstacleER13dtCrowdHandle(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 HEAP32[i8 >> 2] = -1;
 i9 = i7 + 412 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = i7 + 408 | 0;
 if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i6 = i1 << 1;
  i6 = (i6 | 0) > 1 ? i6 : 1;
  if ((i1 | 0) < (i6 | 0)) {
   i4 = i7 + 416 | 0;
   i1 = __Z9dtReallocPvi(HEAP32[i4 >> 2] | 0, i6 * 92 | 0) | 0;
   if (!i1) {
    i9 = 0;
    return i9 | 0;
   }
   HEAP32[i4 >> 2] = i1;
   i1 = i7 + 396 | 0;
   i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i6 << 2) | 0;
   if (!i2) {
    i9 = 0;
    return i9 | 0;
   }
   HEAP32[i1 >> 2] = i2;
   i3 = HEAP32[i5 >> 2] | 0;
   if ((i3 | 0) < (i6 | 0)) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = i3;
    do {
     HEAP32[i2 + (i1 * 92 | 0) + 84 >> 2] = 0;
     i4 = i1;
     i1 = i1 + 1 | 0;
     HEAP32[i2 + (i4 * 92 | 0) + 88 >> 2] = i1;
    } while ((i1 | 0) != (i6 | 0));
   }
   HEAP32[i9 >> 2] = i3;
   HEAP32[i5 >> 2] = i6;
   __ZN7dtCrowd19ResizeProximityGridEv(i7);
   i4 = HEAP32[i9 >> 2] | 0;
  } else i4 = i1;
 } else i4 = i1;
 i3 = HEAP32[i7 + 416 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 + (i4 * 92 | 0) + 88 >> 2];
 HEAP32[i8 >> 2] = i4;
 i1 = i3 + (i4 * 92 | 0) | 0;
 i2 = i1 + 92 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i3 + (i4 * 92 | 0) + 84 >> 2] = 1;
 i9 = 1;
 return i9 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 28; else i1 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN24OcclusionCullingSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(88, i1, 16, gb + 1048932 | 0, 0, gb + 380476 | 0, 47) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 34976 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL16SendTriggerEventP8ColliderS0_17MessageIdentifier(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 i7 = (i7 | 0) == 0 ? i3 : i7;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 i1 = (i1 | 0) == 0 ? i2 : i1;
 HEAP32[i5 >> 2] = gb + 32548;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i3;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, i4, i5);
 HEAP32[i5 >> 2] = gb + 32548;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i2;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i7, i4, i5);
 if ((HEAP32[i7 + 28 >> 2] | 0) != (HEAP32[i3 + 28 >> 2] | 0)) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i3 | 0) | 0) {
  HEAP32[i5 >> 2] = gb + 32548;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = i2;
  __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, i4, i5);
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) == (HEAP32[i2 + 28 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i5 >> 2] = gb + 32548;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i3;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i4, i5);
 STACKTOP = i6;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9Animation11CullingTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8WindZone12WindZoneModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D9SleepModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNK13SpeedTreeWind23ComputeOscillationTimesEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[i1 + 1548 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1552 >> 2]);
 i4 = i2 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1556 >> 2]);
 i4 = i2 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1560 >> 2]);
 i4 = i2 + 12 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1564 >> 2]);
 i4 = i2 + 16 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1568 >> 2]);
 i4 = i2 + 20 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1572 >> 2]);
 i4 = i2 + 24 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1576 >> 2]);
 i4 = i2 + 28 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1580 >> 2]);
 i4 = i2 + 32 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 1584 >> 2]);
 i2 = i2 + 36 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __Z42ContactPoint_CUSTOM_ColliderFromInstanceIdi(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 if (!i4) {
  i5 = 0;
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i7) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z36SparseTexture_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormatih(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 16 | 0;
 i10 = i8;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 1378) | 0;
 i13 = gb + 63520 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN13SparseTextureC2E10MemLabelId18ObjectCreationMode(i3, i9, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 if (__ZN13SparseTexture11InitTextureEii13TextureFormatib(i3, i2, i4, i5, i6, i7 << 24 >> 24 != 0) | 0) {
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  STACKTOP = i8;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  __Z19DestroySingleObjectP6Object(i3);
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 571022 | 0, i8 + 8 | 0);
 }
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8LODGroup11LODFadeModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator11CullingModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7Terrain12MaterialTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN2UI6Canvas10RenderModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D8BodyTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead22ProceduralPropertyTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = i3 >>> 0 < i4 >>> 0 ? i3 : i4;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 if (!i4) return; else i2 = 0;
 do {
  i5 = HEAP32[i3 + (i2 * 40 | 0) + 4 >> 2] | 0;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i1 + (i2 * 40 | 0) >> 2] = HEAP32[i3 + (i2 * 40 | 0) >> 2];
  HEAP32[i1 + (i2 * 40 | 0) + 4 >> 2] = i5;
  HEAP32[i1 + (i2 * 40 | 0) + 8 >> 2] = i7;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] | 0;
  i5 = HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] | 0;
  i6 = HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i1 + (i2 * 40 | 0) + 12 >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2];
  HEAP32[i1 + (i2 * 40 | 0) + 16 >> 2] = i7;
  HEAP32[i1 + (i2 * 40 | 0) + 20 >> 2] = i5;
  HEAP32[i1 + (i2 * 40 | 0) + 24 >> 2] = i6;
  i6 = HEAP32[i3 + (i2 * 40 | 0) + 32 >> 2] | 0;
  i5 = HEAP32[i3 + (i2 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i1 + (i2 * 40 | 0) + 28 >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 28 >> 2];
  HEAP32[i1 + (i2 * 40 | 0) + 32 >> 2] = i6;
  HEAP32[i1 + (i2 * 40 | 0) + 36 >> 2] = i5;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return;
}

function __ZN7mecanim6memory16ChainedAllocator7ReserveEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 i3 = i4 + 8 | 0;
 i1 = i5 + 16 + (0 - i5 & 15) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = 25;
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i2, 0, gb + 913345 | 0, 569) | 0;
  if (!i1) {
   STACKTOP = i6;
   return;
  }
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 + 12 >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = i5;
  i7 = i1 + 12 | 0;
  i7 = (0 - i7 & 15) + i7 | 0;
  HEAP32[i1 + 4 >> 2] = i7;
  HEAP32[i4 + 16 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = 25;
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i2, 0, gb + 913345 | 0, 585) | 0;
  if (!i1) {
   STACKTOP = i6;
   return;
  }
  i7 = i4 + 12 | 0;
  HEAP32[HEAP32[i7 >> 2] >> 2] = i1;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  i7 = HEAP32[i4 + 20 >> 2] | 0;
  HEAP32[i1 + 8 >> 2] = i7 >>> 0 < i5 >>> 0 ? i5 : i7;
  i7 = i1 + 12 | 0;
  i7 = (0 - i7 & 15) + i7 | 0;
  HEAP32[i1 + 4 >> 2] = i7;
  HEAP32[i4 + 16 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN2UI15ClearCanvasDataER8JobFenceRNS_10CanvasDataE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i4 = i7 + 76 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i5 = i7 + 64 | 0;
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (i2) if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = -1;
    HEAP32[i2 + 8 >> 2] = -1;
    HEAP32[i2 + 12 >> 2] = -1;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 HEAP32[i4 >> 2] = 0;
 i6 = i7 + 96 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  i6 = i7 + 108 | 0;
  HEAP32[i6 >> 2] = 0;
  i7 = i7 + 104 | 0;
  HEAP32[i7 >> 2] = 0;
  return;
 }
 i5 = i7 + 84 | 0;
 i4 = 0;
 do {
  i2 = (HEAP32[i5 >> 2] | 0) + (i4 * 672 | 0) + 476 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   i1 = i3 + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   if (!(HEAP32[i1 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
   }
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 HEAP32[i6 >> 2] = 0;
 i6 = i7 + 108 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i7 + 104 | 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags(i10, i5, i1) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i6 = i5 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 i7 = i10 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i8 = i10 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + (i6 << 5) | 0;
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i7 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i10);
  i2 = i1 + 24 | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 >> 2] = i4;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i9;
 return;
}

function __ZN12InputManager14ResetInputAxesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 28 >> 2] | 0;
 i2 = HEAP32[i7 + 32 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i7 + 52 >> 2] | 0) _memset(HEAP32[i7 + 48 >> 2] | 0, 0, HEAP32[i7 + 56 >> 2] << 2 | 0) | 0;
 if (HEAP32[i7 + 72 >> 2] | 0) _memset(HEAP32[i7 + 68 >> 2] | 0, 0, HEAP32[i7 + 76 >> 2] << 2 | 0) | 0;
 if (HEAP32[i7 + 92 >> 2] | 0) _memset(HEAP32[i7 + 88 >> 2] | 0, 0, HEAP32[i7 + 96 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i7 + 128 >> 2] | 0;
 i2 = HEAP32[i7 + 124 >> 2] | 0;
 i6 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i7 = i7 + 100 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  return;
 }
 i4 = (i1 - i2 | 0) / 12 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] | 0;
  i2 = HEAP32[i6 + (i3 * 12 | 0) >> 2] | 0;
  i5 = i2;
  if ((i1 | 0) != (i2 | 0)) {
   i2 = i1 - i2 >> 2;
   i1 = 0;
   do {
    HEAPF32[i5 + (i1 << 2) >> 2] = Math_fround(0.0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i4 >>> 0);
 i7 = i7 + 100 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator10UpdateModeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip8LoadTypeEEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21SubstanceOutputFormatEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ParticleSystemSubTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ObstacleAvoidanceTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z11dictNewDictP9TESSallocPvPFiS1_S1_S1_E(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 12 | 0;
 i9 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, 24) | 0;
 if (!i9) {
  i9 = 0;
  return i9 | 0;
 }
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = i9;
 HEAP32[i9 + 8 >> 2] = i9;
 HEAP32[i9 + 12 >> 2] = i1;
 HEAP32[i9 + 20 >> 2] = i2;
 i1 = i7 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) < 16) {
  HEAP32[i1 >> 2] = 16;
  i2 = 16;
 } else if ((i2 | 0) > 4096) {
  HEAP32[i1 >> 2] = 4096;
  i2 = 4096;
 }
 i1 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, 24) | 0;
 HEAP32[i1 + 20 >> 2] = i7;
 HEAP32[i1 + 16 >> 2] = gb + 362984;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 12;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = mftCall_iii(HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0, (i2 * 12 | 0) + 4 | 0) | 0;
 if (!i6) {
  mftCall_vii(HEAP32[i7 + 8 >> 2] | 0, HEAP32[i8 >> 2] | 0, i1 | 0);
  i1 = 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i6;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i5 >> 2] | 0, i4) | 0) + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  do {
   i2 = i2 - i4 | 0;
   i8 = i3;
   i3 = i6 + i2 | 0;
   HEAP32[i3 >> 2] = i8;
  } while ((i2 | 0) != 4);
  HEAP32[i1 >> 2] = i3;
 }
 HEAP32[i9 + 16 >> 2] = i1;
 return i9 | 0;
}

function _erff(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i2 >>> 31;
 i2 = i2 & 2147483647;
 do if (i2 >>> 0 > 2139095039) f1 = Math_fround(Math_fround(Math_fround(1.0) / f1) + Math_fround(1 - (i3 << 1) | 0)); else if (i2 >>> 0 < 1062731776) if (i2 >>> 0 < 830472192) {
  f1 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(8.0)) + Math_fround(f1 * Math_fround(1.02703333))) * Math_fround(.125));
  break;
 } else {
  f4 = Math_fround(f1 * f1);
  f1 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(Math_fround(-.00577027025) - Math_fround(f4 * Math_fround(.0000237630175)))) + Math_fround(-.0284817498))) + Math_fround(-.325042099))) + Math_fround(.128379166)) / Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(Math_fround(f4 * Math_fround(Math_fround(.000132494737) - Math_fround(f4 * Math_fround(3.96022824e-06)))) + Math_fround(.00508130621))) + Math_fround(.0650222525))) + Math_fround(.397917211))) + Math_fround(1.0))) * f1) + f1);
  break;
 } else {
  if (i2 >>> 0 < 1086324736) f1 = Math_fround(Math_fround(1.0) - Math_fround(_erfc2_142(i2, f1))); else f1 = Math_fround(1.0);
  f4 = Math_fround(-f1);
  f1 = i3 | 0 ? f4 : f1;
  break;
 } while (0);
 return Math_fround(f1);
}

function __ZN5physx2Sc9ClothCore15getParticleDataERNS_19PxClothParticleDataE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 56 | 0;
 i3 = i7 + 28 | 0;
 i6 = i7;
 i8 = ((mftCall_ii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0) | 0) & 4) == 0;
 i4 = i1 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i8) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0);
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
  STACKTOP = i7;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i1 | 0);
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 >> 2];
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i8 = HEAP32[i3 + 24 >> 2] | 0;
 i2 = (HEAP32[i3 + 8 >> 2] | 0) + (i8 >> 1) | 0;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i6 | 0, i1 | 0);
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i8 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = (HEAP32[i6 + 8 >> 2] | 0) + (i8 >> 1) | 0;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 STACKTOP = i7;
 return;
}

function __ZN4crnd19crnd_get_level_infoEPKvjjPNS_14crn_level_infoE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!((i1 | 0) != 0 & i2 >>> 0 > 61 & (i4 | 0) != 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAP32[i4 >> 2] | 0) != 40 | i2 >>> 0 < 74) {
  i4 = 0;
  return i4 | 0;
 }
 if (((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | 0) != 18552) {
  i4 = 0;
  return i4 | 0;
 }
 if (((HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0)) >>> 0 < 74) {
  i4 = 0;
  return i4 | 0;
 }
 if (((HEAPU8[i1 + 7 >> 0] | 0) << 16 | (HEAPU8[i1 + 6 >> 0] | 0) << 24 | (HEAPU8[i1 + 8 >> 0] | 0) << 8 | (HEAPU8[i1 + 9 >> 0] | 0)) >>> 0 > i2 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAPU8[i1 + 16 >> 0] | 0) >>> 0 <= i3 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = ((HEAPU8[i1 + 12 >> 0] | 0) << 8 | (HEAPU8[i1 + 13 >> 0] | 0)) >>> i3;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 i3 = ((HEAPU8[i1 + 14 >> 0] | 0) << 8 | (HEAPU8[i1 + 15 >> 0] | 0)) >>> i3;
 i3 = (i3 | 0) == 0 ? 1 : i3;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 HEAP32[i4 + 12 >> 2] = HEAPU8[i1 + 17 >> 0];
 HEAP32[i4 + 16 >> 2] = (i2 + 3 | 0) >>> 2;
 HEAP32[i4 + 20 >> 2] = (i3 + 3 | 0) >>> 2;
 i3 = i1 + 18 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 HEAP32[i4 + 24 >> 2] = i2 << 24 >> 24 == 0 | i2 << 24 >> 24 == 9 ? 8 : 16;
 i4 = i4 + 32 | 0;
 HEAP32[i4 >> 2] = HEAPU8[i3 >> 0];
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = 1;
 return i4 | 0;
}

function __ZN4Tree23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 935475 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 935480 | 0, gb + 935501 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ReflectionProbeUsageEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ProceduralOutputTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20NavMeshObstacleShapeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20AudioMixerUpdateModeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function _UNITY_FT_Match_Size(i2, i1, i3, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!(HEAP32[i2 + 8 >> 2] & 2)) {
  i7 = 35;
  return i7 | 0;
 }
 if (HEAP32[i1 >> 2] | 0) {
  i7 = 7;
  return i7 | 0;
 }
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = ((Math_imul(i8, i9) | 0) + 36 | 0) / 72 | 0;
 i4 = (i9 | 0) == 0 ? i8 : i4;
 i9 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = ((Math_imul(i5, i9) | 0) + 36 | 0) / 72 | 0;
 i6 = (i9 | 0) == 0 ? i5 : i6;
 i1 = (i8 | 0) == 0;
 i5 = (i5 | 0) == 0 ? i4 : i6;
 i4 = (i1 ? i5 : i4) + 32 | 0;
 i5 = (i1 ? i6 : i5) + 32 | 0;
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  i9 = 23;
  return i9 | 0;
 }
 i2 = HEAP32[i2 + 32 >> 2] | 0;
 L10 : do if (!(i3 << 24 >> 24)) {
  i1 = 0;
  while (1) {
   if (((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) + 32 ^ i5) >>> 0 <= 63) if (((HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0) + 32 ^ i4) >>> 0 <= 63) break L10;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) {
    i1 = 23;
    break;
   }
  }
  return i1 | 0;
 } else {
  i1 = 0;
  while (1) {
   if (((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) + 32 ^ i5) >>> 0 <= 63) break L10;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) {
    i1 = 23;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if (!i7) {
  i9 = 0;
  return i9 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 i9 = 0;
 return i9 | 0;
}

function ___crypt_blowfish(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 288 | 0;
 i8 = i12 + 216 | 0;
 i9 = i12 + 144 | 0;
 i10 = i12 + 72 | 0;
 i11 = i12;
 i7 = _BF_crypt(i1, i4, i2, 16) | 0;
 i2 = i6;
 i1 = gb + 1059660 | 0;
 i3 = i2 + 30 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i5 = (i7 | 0) != 0;
 if (i5) HEAP8[i6 + 2 >> 0] = HEAP8[i4 + 2 >> 0] | 0;
 i1 = i6 + 30 | 0;
 i2 = i1;
 i3 = i2 + 62 | 0;
 do {
  HEAP8[i2 >> 0] = 85;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i6 + 92 >> 0] = 0;
 if ((_BF_crypt(gb + 1059690 | 0, i6, i1, 1) | 0) == (i1 | 0)) if (!(_memcmp(i1, i6, 29) | 0)) i1 = (_memcmp(i6 + 59 | 0, gb + 1059700 + (((HEAPU8[i6 + 2 >> 0] | 0) & 1) * 34 | 0) | 0, 34) | 0) == 0; else i1 = 0; else i1 = 0;
 _BF_set_key(gb + 1059768 | 0, i8, i9, 2);
 _BF_set_key(gb + 1059768 | 0, i10, i11, 4);
 i6 = HEAP32[i9 >> 2] ^ 65536;
 HEAP32[i9 >> 2] = i6;
 if (i1 & (i6 | 0) == -610510404) if ((HEAP32[i10 + 68 >> 2] | 0) == 859059456) if (!(_memcmp(i8, i10, 72) | 0)) i1 = (_memcmp(i9, i11, 72) | 0) == 0; else i1 = 0; else i1 = 0; else i1 = 0;
 i11 = i5 & i1 ? i7 : gb + 1086428 | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZNK5physx3Cct26CharacterControllerManager15onObstacleAddedEjPKNS_17PxObstacleContextE(i1, i11, i10) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0, i13 = 0, f14 = f0, f15 = f0, f16 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 12 | 0;
 i8 = i12;
 i9 = i1 + 68 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 i1 = i1 + 64 | 0;
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8 + 8 | 0;
 i6 = 0;
 do {
  i13 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  f14 = Math_fround(+HEAPF64[i13 + 408 >> 3]);
  f15 = Math_fround(+HEAPF64[i13 + 416 >> 3]);
  f16 = Math_fround(+HEAPF64[i13 + 424 >> 3]);
  HEAPF32[i7 >> 2] = f14;
  HEAPF32[i2 >> 2] = f15;
  HEAPF32[i3 >> 2] = f16;
  f16 = Math_fround(-Math_fround(HEAPF32[i13 + 28 >> 2]));
  f15 = Math_fround(-Math_fround(HEAPF32[i13 + 32 >> 2]));
  f14 = Math_fround(-Math_fround(HEAPF32[i13 + 36 >> 2]));
  HEAPF32[i8 >> 2] = f16;
  HEAPF32[i4 >> 2] = f15;
  HEAPF32[i5 >> 2] = f14;
  __ZN5physx3Cct9SweepTest15onObstacleAddedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f(i13 + 88 | 0, i11, i10, i7, i8, Math_fround(+mftCall_fi(HEAP32[(HEAP32[i13 >> 2] | 0) + 12 >> 2] | 0, i13 | 0)));
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 STACKTOP = i12;
 return;
}

function __ZNK5Umbra9Matrix4x49isUniformEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, d3 = 0.0, d4 = 0.0, f5 = f0, f6 = f0, d7 = 0.0;
 if (!(Math_fround(HEAPF32[i1 + 48 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 52 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 56 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 60 >> 2]) == Math_fround(1.0))) {
  i1 = 0;
  return i1 | 0;
 }
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 d4 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 d7 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 d3 = d4 * .0001;
 if (!(+Math_abs(+(d4 - d7)) <= d3)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = +Math_abs(+(d4 - +Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f2 * f2)))))) <= d3;
 return i1 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 124; else i1 = (HEAP32[i1 >> 2] | 0) + 124 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 112; else i1 = (HEAP32[i1 >> 2] | 0) + 112 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 24 | 0;
 i2 = i3;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 20 | 0, i5);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 37152 >> 2] | 0, i2, 0);
 __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN15b2FrictionJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 80 | 0;
 i4 = i2 + 72 | 0;
 i5 = i2 + 64 | 0;
 i6 = i2 + 48 | 0;
 i9 = i2 + 32 | 0;
 i10 = i2 + 24 | 0;
 i11 = i2 + 16 | 0;
 i13 = i2 + 8 | 0;
 i14 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i12 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 799657 | 0, i2);
 HEAP32[i13 >> 2] = i14;
 __Z5b2LogPKcz(gb + 799360 | 0, i13);
 HEAP32[i11 >> 2] = i12;
 __Z5b2LogPKcz(gb + 799386 | 0, i11);
 HEAP32[i10 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i10);
 d7 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d8 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i9 >> 3] = d7;
 HEAPF64[i9 + 8 >> 3] = d8;
 __Z5b2LogPKcz(gb + 799447 | 0, i9);
 d8 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d7 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i6 >> 3] = d8;
 HEAPF64[i6 + 8 >> 3] = d7;
 __Z5b2LogPKcz(gb + 799489 | 0, i6);
 HEAPF64[i5 >> 3] = +Math_fround(HEAPF32[i1 + 96 >> 2]);
 __Z5b2LogPKcz(gb + 799683 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 100 >> 2]);
 __Z5b2LogPKcz(gb + 799709 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN10AudioMixer8SetFloatEPKcf(i1, i2, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 269, 1, 0, 0, 0);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc(HEAP32[i1 + 72 >> 2] | 0, i2) | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i6 >> 2] = i2;
  __Z6FormatPKcz(i5, gb + 862953 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 861578 | 0, 281, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  __ZN5audio5mixer18SetExposedPropertyERKNS0_16AudioMixerMemoryEif(HEAP32[i1 + 76 >> 2] | 0, i3, f4);
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorForceMode2DEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z18MurmurHash3_x86_32PKvijPv(i1, i5, i2, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i3 = (i5 | 0) / 4 | 0;
 i4 = i1 + (i3 << 2) | 0;
 if ((i5 + 3 | 0) >>> 0 >= 7) {
  i1 = i2;
  i2 = 0 - i3 | 0;
  do {
   i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
   i1 = (Math_imul((Math_imul(i3, -862048943) | 0) >>> 17 | (Math_imul(i3, 380141568) | 0), 461845907) | 0) ^ i1;
   i1 = ((i1 >>> 19 | i1 << 13) * 5 | 0) + -430675100 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 0);
  i2 = i1;
 }
 switch (i5 & 3) {
 case 3:
  {
   i1 = (HEAPU8[i4 + 2 >> 0] | 0) << 16;
   i7 = 6;
   break;
  }
 case 2:
  {
   i1 = 0;
   i7 = 6;
   break;
  }
 case 1:
  {
   i1 = 0;
   break;
  }
 default:
  {
   i7 = i2;
   i7 = i7 ^ i5;
   i5 = i7 >>> 16;
   i7 = i5 ^ i7;
   i7 = Math_imul(i7, -2048144789) | 0;
   i5 = i7 >>> 13;
   i7 = i5 ^ i7;
   i7 = Math_imul(i7, -1028477387) | 0;
   i5 = i7 >>> 16;
   i7 = i5 ^ i7;
   HEAP32[i6 >> 2] = i7;
   return;
  }
 }
 if ((i7 | 0) == 6) i1 = (HEAPU8[i4 + 1 >> 0] | 0) << 8 | i1;
 i7 = (HEAPU8[i4 >> 0] | 0) ^ i1;
 i7 = (Math_imul((Math_imul(i7, -862048943) | 0) >>> 17 | (Math_imul(i7, 380141568) | 0), 461845907) | 0) ^ i2;
 i7 = i7 ^ i5;
 i5 = i7 >>> 16;
 i7 = i5 ^ i7;
 i7 = Math_imul(i7, -2048144789) | 0;
 i5 = i7 >>> 13;
 i7 = i5 ^ i7;
 i7 = Math_imul(i7, -1028477387) | 0;
 i5 = i7 >>> 16;
 i7 = i5 ^ i7;
 HEAP32[i6 >> 2] = i7;
 return;
}

function _raccess_guess_apple_generic(i5, i2, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = _UNITY_FT_Stream_ReadULong(i5, i7) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L1 : do if (!i1) if ((i3 | 0) == (i2 | 0)) {
  _UNITY_FT_Stream_ReadULong(i5, i7) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) {
   i1 = _UNITY_FT_Stream_Skip(i5, 16) | 0;
   HEAP32[i7 >> 2] = i1;
   if (!i1) {
    i2 = _UNITY_FT_Stream_ReadUShort(i5, i7) | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    if (!i1) {
     i4 = i2 & 65535;
     if (!(i2 << 16 >> 16)) i1 = 2; else {
      i3 = 0;
      while (1) {
       i2 = _UNITY_FT_Stream_ReadULong(i5, i7) | 0;
       i1 = HEAP32[i7 >> 2] | 0;
       if (i1 | 0) break L1;
       if ((i2 | 0) == 2) {
        i1 = _UNITY_FT_Stream_ReadULong(i5, i7) | 0;
        if (!(HEAP32[i7 >> 2] | 0)) {
         _UNITY_FT_Stream_ReadULong(i5, i7) | 0;
         if (!(HEAP32[i7 >> 2] | 0)) break;
        }
       } else {
        i1 = _UNITY_FT_Stream_Skip(i5, 8) | 0;
        HEAP32[i7 >> 2] = i1;
        if (i1 | 0) break L1;
       }
       i3 = i3 + 1 | 0;
       if ((i3 | 0) >= (i4 | 0)) {
        i1 = 2;
        break L1;
       }
      }
      HEAP32[i6 >> 2] = i1;
      i1 = 0;
     }
    }
   }
  }
 } else i1 = 2; while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN24OcclusionCullingSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i7 + 8 | 0;
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i8, 1) | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i3 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i10 = i2;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 379023 | 0, HEAP32[gb + 37316 >> 2] | 0, i2, 1) | 0;
 if (i1) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i8, i3, 0); else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i8 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i8);
  if (HEAP32[i4 >> 2] | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 379264 | 0, 0, gb + 379317 | 0, 124, 1, 0, 0, 0);
 }
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i6);
  HEAP32[i3 >> 2] = 0;
 }
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead18SubstanceInputTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE(i1, i7, i6, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 236 >> 2] | 0, i7 | 0) | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 240 >> 2] | 0, i7 | 0) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((((HEAP32[i3 + 4 >> 2] | 0) - i2 | 0) / 12 | 0 | 0) == (i4 | 0)) {
  i1 = HEAP32[i7 + 476 >> 2] | 0;
  i3 = i1 + (i4 << 4) | 0;
  if (i4 | 0) while (1) {
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i2 + 4 >> 2] = i8;
   HEAP32[i2 + 8 >> 2] = i4;
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (((HEAP32[i6 + 4 >> 2] | 0) - i1 >> 4 | 0) != (i5 | 0)) return;
 i2 = HEAP32[i7 + 464 >> 2] | 0;
 i8 = HEAP32[i7 + 468 >> 2] | 0;
 i5 = i2 + (i8 << 3) | 0;
 i4 = HEAP32[i7 + 24 >> 2] | 0;
 if (!i8) return;
 i3 = i2;
 do {
  i2 = HEAPU16[i3 >> 1] | 0;
  if (i2 >>> 0 < i4 >>> 0) {
   i6 = HEAPU16[i3 + 2 >> 1] | 0;
   i7 = HEAPU16[i3 + 4 >> 1] | 0;
   i8 = HEAPU16[i3 + 6 >> 1] | 0;
   HEAP32[i1 >> 2] = i2;
   HEAP32[i1 + 4 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i7;
   HEAP32[i1 + 12 >> 2] = i8;
   i1 = i1 + 16 | 0;
  }
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return;
}

function __ZN7Terrain7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(248, i1, 16, gb + 1048932 | 0, 0, gb + 936929 | 0, 43) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 184192 + 8;
 HEAP8[i4 + 34 >> 0] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 192 >> 2] = 0;
 i1 = i4 + 208 | 0;
 HEAP32[i4 + 228 >> 2] = 0;
 HEAP32[i4 + 240 >> 2] = 0;
 HEAP32[i4 + 244 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 232 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 88; else i1 = (HEAP32[i1 >> 2] | 0) + 88 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sn5ConvX25convertInternalReferencesEPKvRi(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i7, i1, 16) | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - (0 - i1 & 15);
 i2 = i5 + 4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i7, i5);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -4;
 if (i5) {
  i3 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i7, gb + 744814 | 0, 1) | 0;
  if ((i5 | 0) > 0) {
   i4 = i3 + 16 | 0;
   i1 = 0;
   do {
    __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i7, i2, i3, 0) | 0;
    i8 = HEAP32[i4 >> 2] | 0;
    i2 = i2 + i8 | 0;
    HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i8;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
  }
 }
 i1 = i2 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i7, i3);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -4;
 if (!i3) {
  i8 = i1;
  return i8 | 0;
 }
 i4 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i7, gb + 744784 | 0, 1) | 0;
 if ((i3 | 0) <= 0) {
  i8 = i1;
  return i8 | 0;
 }
 i5 = i4 + 16 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i7, i1, i4, 0) | 0;
  i8 = HEAP32[i5 >> 2] | 0;
  i1 = i1 + i8 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return i1 | 0;
}

function __ZN5physx29PxArticulationGeneratedValuesC2EPKNS_14PxArticulationE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 8 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 12 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 28 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAPF32[i2 + 32 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 36 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 40 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 44 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 48 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 52 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 + 20 | 0, i2 + 24 | 0);
 return;
}

function __ZN4Mesh17VerifyBoneIndicesEj(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i1 + 188 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 switch (i2 | 0) {
 case -1:
  {
   HEAP32[i10 >> 2] = -2;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   i8 = HEAP32[i1 + 176 >> 2] | 0;
   L5 : do if (!i8) i1 = 0; else {
    i7 = HEAP32[i1 + 164 >> 2] | 0;
    i6 = 0;
    i1 = 0;
    while (1) {
     i2 = HEAP32[i7 + (i6 << 5) + 16 >> 2] | 0;
     if ((i2 | 0) < 0) {
      i1 = 0;
      i2 = 11;
      break;
     }
     i3 = HEAP32[i7 + (i6 << 5) + 20 >> 2] | 0;
     if ((i3 | 0) < 0) {
      i1 = 0;
      i2 = 11;
      break;
     }
     i4 = HEAP32[i7 + (i6 << 5) + 24 >> 2] | 0;
     if ((i4 | 0) < 0) {
      i1 = 0;
      i2 = 11;
      break;
     }
     i5 = HEAP32[i7 + (i6 << 5) + 28 >> 2] | 0;
     if ((i5 | 0) < 0) {
      i1 = 0;
      i2 = 11;
      break;
     }
     i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
     i1 = (i1 | 0) < (i3 | 0) ? i3 : i1;
     i1 = (i1 | 0) < (i4 | 0) ? i4 : i1;
     i1 = (i1 | 0) < (i5 | 0) ? i5 : i1;
     i6 = i6 + 1 | 0;
     if (i6 >>> 0 >= i8 >>> 0) break L5;
    }
    if ((i2 | 0) == 11) return i1 | 0;
   } while (0);
   HEAP32[i10 >> 2] = i1;
   i10 = (i1 | 0) < (i9 | 0);
   return i10 | 0;
  }
 case -2:
  {
   i10 = 0;
   return i10 | 0;
  }
 default:
  {
   i10 = (i2 | 0) < (i9 | 0);
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags(i9, i7, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i9 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i9 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i5 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
 }
 i3 = i7 + 4 | 0;
 i6 = i7 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 - i1 >> 5;
 if (i5 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj(i3, i5 - i4 | 0);
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 } else if (i5 >>> 0 < i4 >>> 0) {
  i3 = i1 + (i5 << 5) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -32 - i3 | 0) >>> 5) << 5) | 0;
   HEAP32[i6 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i9);
  __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 16 | 0, i9);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN16MeshVertexFormatC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP8[i1 + 40 >> 0] = HEAP8[i2 + 40 >> 0] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i3 = i2 + 56 | 0;
  i3 = HEAP8[i3 >> 0] | 0;
  i4 = i1 + 56 | 0;
  HEAP8[i4 >> 0] = i3;
  return;
 }
 __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i1 + 44 | 0, HEAP32[i2 + 44 >> 2] | 0, HEAP32[i2 + 48 >> 2] | 0);
 i3 = i2 + 56 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 i4 = i1 + 56 | 0;
 HEAP8[i4 >> 0] = i3;
 return;
}

function __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034892 | 0, gb + 1034905 | 0, i1, 0);
 i6 = i5 + 8 | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i1, 1);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i6, 1);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 4 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034921 | 0, HEAP32[gb + 36980 >> 2] | 0, i1, 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZL33InitializePhysicsScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63728 | 0, 16, gb + 779183 | 0, 16) | 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[gb + 1457452 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 779307 | 0) | 0;
 HEAP32[HEAP32[gb + 1457452 >> 2] >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 779317 | 0) | 0;
 HEAP32[(HEAP32[gb + 1457452 >> 2] | 0) + 4 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 779330 | 0) | 0;
 i2 = HEAP32[gb + 1457452 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 i2 = i2 + 12 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 779352 | 0, gb + 801659 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1457452 >> 2] | 0) + 20 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 779352 | 0, gb + 779360 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 779371 | 0) | 0;
 HEAP32[(HEAP32[gb + 1457452 >> 2] | 0) + 28 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __Z50Animator_CUSTOM_IsParameterControlledByCurveStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN8Animator26ParameterControlledByCurveEi(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0) | 0;
 switch (i2 | 0) {
 case 1:
  {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 case 16:
  {
   i5 = 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 default:
  {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
   __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 return 0;
}

function __Z37Texture2DArray_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormathh(i1, i2, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 16 | 0;
 i11 = i9;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 1100) | 0;
 i14 = gb + 63520 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN14Texture2DArrayC2E10MemLabelId18ObjectCreationMode(i3, i10, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 if (__ZN14Texture2DArray11InitTextureEiii13TextureFormatb(i3, i2, i4, i5, i6, i7 << 24 >> 24 != 0) | 0) {
  __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace(i3, i8 << 24 >> 24 == 0 & 1);
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  STACKTOP = i9;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570887 | 0, i9 + 8 | 0);
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead17GfxDeviceRendererEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i8 + 8 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = i6;
 if ((HEAP32[i9 >> 2] | 0) - i6 >> 5 >>> 0 >= i4 >>> 0) return;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 << 5) | 0;
 i2 = i5 + (i2 - i6 >> 5 << 5) | 0;
 i7 = i2;
 i5 = i5 + (i4 << 5) | 0;
 if ((i3 | 0) == (i1 | 0)) i4 = i7; else {
  i4 = i7;
  do {
   i6 = i2 + -32 | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i2 + -12 >> 2] = 0;
   i13 = i3 + -8 | 0;
   i3 = i3 + -32 | 0;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i11 = i2 + -8 | 0;
   HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i11 + 4 >> 2] = i12;
   HEAP8[i2 + -28 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i6, i3);
   i2 = i4 + -32 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i6 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i9 >> 2] = i5;
 i4 = i6;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = i1;
  i1 = i1 + -32 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i2 + -28 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i2 + -8 | 0);
 } while ((i1 | 0) != (i4 | 0));
 if (!i6) return;
 __ZdlPv(i6);
 return;
}

function __ZN9Transform30SendTransformParentingMessagesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i1 + 32 | 0;
 i4 = i1 + 36 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i2);
 if (i2 & 64 | 0) {
  __ZN10GameObject25TransformParentHasChangedEv(HEAP32[i1 + 28 >> 2] | 0);
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i4 | 0) {
   i5 = i2 + 24 | 0;
   i3 = i2 + 68 | 0;
   i2 = 0;
   while (1) {
    __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, gb + 1105056 | 0, i6);
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   }
  }
  STACKTOP = i7;
  return;
 }
 if (!(i2 & 256)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105076 | 0, i6);
 STACKTOP = i7;
 return;
}

function __ZN6Skybox23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 384544 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 384551 | 0, gb + 946436 | 0, i4, 0);
 i5 = i6 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i7 = i6 + 4 | 0;
 i3 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 i9 = i2 + 16 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i8 = i2 + 24 | 0;
 if (i5 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i9 >> 2] = i5;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS5_EE13stl_allocatorIS5_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags(i8, i6, i1) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i1 = i5;
 }
 i3 = _llvm_bswap_i32(i1 | 0) | 0;
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i2 - i1 >> 2;
 if (i3 >>> 0 > i4 >>> 0) {
  __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj(i6, i3 - i4 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else if (i3 >>> 0 < i4 >>> 0) {
  i3 = i1 + (i3 << 2) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2) | 0;
   HEAP32[i5 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN12AudioManager16UpdatePauseStateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 4 | 0;
 i1 = i9;
 i2 = HEAP32[i8 + 88 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 __ZN4FMOD6System11getDSPClockEPjS1_(i2, i1, i3) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP16[i8 + 40 >> 1] | 0;
 i1 = i8 + 208 | 0;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = (i2 | 0) == 0 & (i3 | 0) == 0;
 if ((i5 & 255) << 24 >> 24 == 0 & (i5 & 65535) < 256) {
  i5 = i8 + 200 | 0;
  if (!i4) {
   i7 = _i64Subtract(i6 | 0, i7 | 0, i2 | 0, i3 | 0) | 0;
   i6 = getTempRet0() | 0;
   i4 = i5;
   i4 = _i64Add(i7 | 0, i6 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0) | 0;
   i6 = getTempRet0() | 0;
   i7 = i5;
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = i6;
   i7 = i1;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = 0;
  }
 } else if (i4) {
  i5 = i1;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 4 >> 2] = i7;
 }
 i2 = HEAP32[i8 + 48 >> 2] | 0;
 i3 = i8 + 44 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11AudioSource16UpdatePauseStateEv(HEAP32[i8 + 8 >> 2] | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i9;
 return;
}

function __ZN10Effector2D22ProcessPreSolveContactEbP10Collider2DS1_P9b2Contact(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 if (!(HEAP8[i2 + 53 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i7 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i3 = i1 & 1 ^ 1;
 HEAP8[i6 + 36 >> 0] = i3;
 HEAP32[i6 + 32 >> 2] = i5;
 HEAP32[i6 + 4 >> 2] = i2;
 if (!(HEAP32[i2 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i2 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 20 >> 2] = i4;
 if (!(HEAP32[i4 + 72 >> 2] | 0)) i1 = 0; else i1 = HEAP32[(HEAP32[HEAP32[i4 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i1;
 if (!(i3 << 24 >> 24)) {
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 52 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 60 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 48 >> 2];
  i1 = i5 + 56 | 0;
 } else {
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 48 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 56 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 52 >> 2];
  i1 = i5 + 60 | 0;
 }
 HEAP32[i6 + 28 >> 2] = HEAP32[i1 >> 2];
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, i6 | 0);
 STACKTOP = i8;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadtEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37288 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadsEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37240 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 2 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP16[i4 >> 1] = HEAP16[i2 >> 1] | 0;
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 2);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP16[i4 >> 1] = _llvm_bswap_i16(HEAP16[i4 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16TextureDimensionEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16GfxPrimitiveTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNSt3__212system_errorC2EiRKNS_14error_categoryEPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 24 | 0;
 i8 = i6 + 16 | 0;
 i7 = i6;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, i4, _strlen(i4) | 0);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i5 | 0, i8 | 0, i7 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i5 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i1 + 12 >> 2] = i3;
   STACKTOP = i6;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i1 | 0);
}

function __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6Uint64Ey(i1, i10, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 28 | 0;
 i9 = i1 + 40 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i8 = i1 + 44 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = i5;
 i7 = i2;
 if ((i2 + 24 | 0) >>> 0 >= i5 >>> 0) {
  i2 = i1 + 36 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (!i4) {
   if (!(HEAP32[i6 >> 2] | 0)) {
    i3 = __Znwj(1) | 0;
    HEAP32[i6 >> 2] = i3;
    HEAP32[i1 + 32 >> 2] = i3;
   }
   i1 = HEAP32[i1 + 48 >> 2] | 0;
  } else {
   i1 = i3 - i5 | 0;
   i1 = ((i1 + 1 | 0) >>> 1) + i1 | 0;
  }
  i5 = i7 - i5 | 0;
  i7 = i5 + 24 | 0;
  i7 = i1 >>> 0 < i7 >>> 0 ? i7 : i1;
  i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i7, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
  HEAP32[i2 >> 2] = i6;
  i2 = i6 + i5 | 0;
  HEAP32[i9 >> 2] = i2;
  HEAP32[i8 >> 2] = i6 + i7;
 }
 HEAP32[i9 >> 2] = i2 + 24;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = 8710;
 i9 = i2;
 HEAP32[i9 >> 2] = i10;
 HEAP32[i9 + 4 >> 2] = i11;
 if ((i11 | 0) < 0) return 1;
 HEAP32[i1 >> 2] = 12806;
 if (i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 4294967295) return 1;
 HEAP32[i1 >> 2] = i11 >>> 0 > 0 | (i11 | 0) == 0 & i10 >>> 0 > 2147483647 ? 14854 : 15878;
 return 1;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15setActorSimFlagEb(i5, (HEAP16[i1 >> 1] & 8) != 0);
 i10 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i5 + i3 | 0;
 i9 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i8 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i8;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i10;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i10;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN18PlayableController4TickEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var d2 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, i10 = 0, i11 = 0;
 HEAP32[i3 + 152 >> 2] = 0;
 HEAP32[i3 + 144 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 196 >> 2];
 i8 = i3 + 96 | 0;
 d9 = +HEAPF64[i8 >> 3];
 i10 = i3 + 104 | 0;
 i5 = i10;
 i4 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = i3 + 112 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 d2 = +f1;
 i11 = i3 + 88 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
 HEAPF64[i3 + 120 >> 3] = d9;
 i11 = i3 + 128 | 0;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i3 + 136 >> 2] = i7;
 if (!i7) {
  d9 = d2 + d9;
  i11 = 0;
  i5 = 0;
  i7 = 0;
  HEAPF64[i8 >> 3] = d9;
  i8 = i10;
  HEAP32[i8 >> 2] = i5;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i6 >> 2] = i11;
  return;
 } else {
  d9 = +(i4 >>> 0) + 4294967296.0 * +(i5 >>> 0) + d2 * +(i7 >>> 0);
  i5 = ~~d9 >>> 0;
  i4 = +Math_abs(d9) >= 1.0 ? (d9 > 0.0 ? ~~+Math_min(+Math_floor(d9 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d9 - +(~~d9 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i11 = ___udivdi3(i5 | 0, i4 | 0, i7 | 0, 0) | 0;
  d9 = +(i11 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0);
  i11 = i7;
  i7 = i4;
  HEAPF64[i8 >> 3] = d9;
  i8 = i10;
  HEAP32[i8 >> 2] = i5;
  i10 = i10 + 4 | 0;
  HEAP32[i10 >> 2] = i7;
  HEAP32[i6 >> 2] = i11;
  return;
 }
}

function __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE(i8, i5, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = i8 + 100 | 0;
 i4 = i8 + 104 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i1 = i4;
  i6 = 9;
 } else {
  i1 = i4;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) {
   i1 = i4;
   i6 = 9;
  } else if ((HEAP32[i1 + 16 >> 2] | 0) > (i5 | 0)) {
   i1 = i4;
   i6 = 9;
  } else if ((i1 | 0) == (i4 | 0)) i6 = 9; else i3 = i1;
 }
 if ((i6 | 0) == 9) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459490 | 0, 0, gb + 459188 | 0, 224, 1, 0, 0, 0);
  i3 = i1;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
 i7 = i8 + 108 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 104 >> 2] | 0, i3);
 __ZdlPv(i3);
 return;
}

function __ZN13SpringJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803035 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 108 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803059 | 0, i5, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803283 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853582 | 0, i5, i1 + 104 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12NavMeshAgent16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i4 = i1 + 100 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = (i6 | 0) < 0 ? 0 : (i6 | 0) > 99 ? 99 : i6;
 i4 = i1 + 48 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(999999986.0e6);
 f3 = i7 ? Math_fround(999999986.0e6) : f3;
 HEAPF32[i4 >> 2] = i6 ? Math_fround(0.0) : f3;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i4 = i1 + 64 | 0;
 i6 = Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[(i6 ? i4 : i5) >> 2];
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i4 = i1 + 60 | 0;
 i6 = Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[(i6 ? i4 : i5) >> 2];
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i4 = i1 + 52 | 0;
 i6 = Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[(i6 ? i4 : i5) >> 2];
 i4 = i1 + 40 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f3 > Math_fround(9.99999974e-06);
 HEAPF32[i4 >> 2] = i5 ? f3 : Math_fround(9.99999974e-06);
 i1 = i1 + 36 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 > Math_fround(9.99999974e-06);
 HEAPF32[i1 >> 2] = i4 ? f3 : Math_fround(9.99999974e-06);
 STACKTOP = i2;
 return;
}

function __ZN11SoundHandleaSERKS_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) return;
 i5 = (i3 | 0) == 0;
 if (i5) i7 = 0; else i7 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = i4;
 if (i4 | 0) {
  i4 = i4 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 if (!i5) {
  i5 = i3 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i3 + 8 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
 }
 HEAP32[i6 >> 2] = i1;
 if (!i7) return;
 i1 = HEAP32[i7 + 120 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) return;
 if (((HEAP32[i7 + 44 >> 2] | 0) + -3 | 0) >>> 0 >= 2) return;
 i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
 i3 = i7 + 116 | 0;
 if (HEAP8[i3 >> 0] | 0) return;
 i2 = i1 + 24 | 0;
 if ((i7 | 0) != (i2 | 0)) {
  i1 = HEAP32[i7 >> 2] | 0;
  if (!i1) i1 = i7 + 4 | 0; else {
   i6 = i7 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   i1 = i6;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i7;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i7;
 }
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 32 | 0;
 i7 = i3 + 20 | 0;
 i8 = i3;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 + 24 >> 2];
 i6 = i7 + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 28 >> 2];
 i9 = HEAP32[i1 + 44 >> 2] | 0;
 i11 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i2 = i10 + (i9 << 6) | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 8 >> 2] = i2;
 i2 = i9 << 6 >> 6;
 HEAP32[i8 + 16 >> 2] = i2;
 HEAP32[i8 + 12 >> 2] = i2;
 i2 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = i8;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, i7, HEAP32[i1 + 24 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP8[i5 + 4 >> 0] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i5 + 16 >> 2] = -1;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI23ManagedObjectTransfererEEvRT_17TransferMetaFlags(i4, i5, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i3;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15ShaderParamTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15LineTextureModeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function _Write_CVT_Stretched(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i4 = i6 + 244 | 0;
 i5 = i6 + 256 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) {
  i3 = HEAP16[i6 + 296 >> 1] | 0;
  if (!(i3 << 16 >> 16)) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  }
  i2 = HEAP16[i6 + 294 >> 1] | 0;
  i1 = HEAP32[i6 + 248 >> 2] | 0;
  if (!(i2 << 16 >> 16)) {
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i10 = i2 << 16 >> 16;
   i11 = HEAP32[i4 >> 2] | 0;
   i4 = (i11 | 0) < 0 ? 0 - i11 | 0 : i11;
   i9 = i2 << 16 >> 16 < 0 ? 0 - i10 | 0 : i10;
   i2 = Math_imul(i4 >>> 16, i9) | 0;
   i13 = i2 << 16 | 8192;
   i9 = i13 + (Math_imul(i4 & 65535, i9) | 0) | 0;
   i9 = (i9 >>> 0 < i13 >>> 0 & 1) + (i2 >>> 16) << 18 | i9 >>> 14;
   i2 = i3 << 16 >> 16;
   i13 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
   i4 = i3 << 16 >> 16 < 0 ? 0 - i2 | 0 : i2;
   i3 = Math_imul(i13 >>> 16, i4) | 0;
   i12 = i3 << 16 | 8192;
   i4 = i12 + (Math_imul(i13 & 65535, i4) | 0) | 0;
   i4 = (i4 >>> 0 < i12 >>> 0 & 1) + (i3 >>> 16) << 18 | i4 >>> 14;
   i1 = _UNITY_FT_Hypot((i11 ^ i10 | 0) > -1 ? i9 : 0 - i9 | 0, (i1 ^ i2 | 0) > -1 ? i4 : 0 - i4 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  }
 } while (0);
 i13 = _UNITY_FT_DivFix(i8, i1) | 0;
 HEAP32[(HEAP32[i6 + 384 >> 2] | 0) + (i7 << 2) >> 2] = i13;
 return;
}

function _UNITY_tt_face_load_cvt(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i1 = i8;
 i2 = HEAP32[i6 + 28 >> 2] | 0;
 i4 = mftCall_iiiii(HEAP32[i5 + 508 >> 2] | 0, i5 | 0, 1668707360, i6 | 0, i1 | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 if (i4 | 0) {
  HEAP32[i5 + 644 >> 2] = 0;
  HEAP32[i5 + 648 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = (HEAP32[i1 >> 2] | 0) >>> 1;
 i4 = i5 + 644 | 0;
 HEAP32[i4 >> 2] = i1;
 i3 = i5 + 648 | 0;
 HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i2, 2, 0, i1, 0, i7) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = _UNITY_FT_Stream_EnterFrame(i6, HEAP32[i4 >> 2] << 1) | 0;
 HEAP32[i7 >> 2] = i1;
 if (i1 | 0) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i4 << 1) | 0;
 if ((i4 | 0) > 0) do {
  HEAP16[i1 >> 1] = _UNITY_FT_Stream_GetUShort(i6) | 0;
  i1 = i1 + 2 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 _UNITY_FT_Stream_ExitFrame(i6);
 if (!(HEAP8[i5 + 672 >> 0] | 0)) {
  i7 = HEAP32[i7 >> 2] | 0;
  STACKTOP = i8;
  return i7 | 0;
 } else {
  i6 = _UNITY_tt_face_vary_cvt(i5, i6) | 0;
  HEAP32[i7 >> 2] = i6;
  i7 = i6;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function _y1f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if (!(i2 & 2147483647)) f1 = Math_fround(-inf); else if ((i2 | 0) < 0) f1 = Math_fround(nan); else {
  if (i2 >>> 0 > 2139095039) {
   f1 = Math_fround(Math_fround(1.0) / f1);
   break;
  }
  if (i2 >>> 0 > 1073741823) {
   f1 = Math_fround(_common_181(i2, f1, 1, 0));
   break;
  }
  if (i2 >>> 0 < 838860800) {
   f1 = Math_fround(Math_fround(-.636619746) / f1);
   break;
  } else {
   f3 = Math_fround(f1 * f1);
   f3 = Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(.0000235252592) - Math_fround(f3 * Math_fround(9.19099178e-08)))) + Math_fround(-.00191256893))) + Math_fround(.0504438728))) + Math_fround(-.196057096)) / Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(1.66559249e-11)) + Math_fround(6.22741458e-09))) + Math_fround(1.35608798e-06))) + Math_fround(.000202552576))) + Math_fround(.0199167319))) + Math_fround(1.0))) * f1);
   f1 = Math_fround(f3 + Math_fround(Math_fround(Math_fround(Math_fround(_j1f(f1)) * Math_fround(+Math_log(+f1))) - Math_fround(Math_fround(1.0) / f1)) * Math_fround(.636619746)));
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZNK12b2WheelJoint19GetJointTranslationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, i12 = 0;
 i12 = HEAP32[i1 + 48 >> 2] | 0;
 i9 = HEAP32[i1 + 52 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i12 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f8 = Math_fround(f3 * f2);
 f5 = Math_fround(HEAPF32[i12 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f5 * f6));
 f8 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) + f8);
 f6 = Math_fround(Math_fround(f2 * f5) + Math_fround(f3 * f6));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i12 + 16 >> 2]));
 f2 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f7 = Math_fround(f2 * f11);
 f10 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f10 * f4));
 f7 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) + f7);
 f4 = Math_fround(Math_fround(f11 * f10) + Math_fround(f2 * f4));
 f8 = Math_fround(f7 - f8);
 f6 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i9 + 16 >> 2])) - f6);
 f4 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f7 = Math_fround(f3 * f4);
 f2 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 return Math_fround(Math_fround(f8 * Math_fround(f7 - Math_fround(f5 * f2))) + Math_fround(f6 * Math_fround(Math_fround(f5 * f4) + Math_fround(f3 * f2))));
}

function __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 536 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 800 | 0, i4);
 i1 = i3 + 1065 | 0;
 i6 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i3 + 1064 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i1 = i3 + 1068 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  return;
 }
}

function __ZN19CharacterController22ApplyRootMotionBuiltinEP14RootMotionData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 f6 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 f8 = Math_fround(f6 * Math_fround(HEAPF32[(__Z17GetPhysicsManagerv() | 0) + 36 >> 2]));
 i5 = i1 + 112 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f8);
 HEAPF32[i5 >> 2] = f8;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i5 = i3 + 4 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 f8 = Math_fround(f6 * f8);
 f6 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 i9 = f6 < Math_fround(0.0);
 i10 = f6 > Math_fround(1.0);
 f6 = i10 ? Math_fround(1.0) : f6;
 f6 = i9 ? Math_fround(0.0) : f6;
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(f8 * f6) + Math_fround(f7 * Math_fround(Math_fround(1.0) - f6)));
 __ZN19CharacterController4MoveERK8Vector3f(i1, i3) | 0;
 __ZN9Transform11SetRotationERK11Quaternionf(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 12 | 0);
 HEAP8[i2 + 32 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __Z42AssetBundle_CUSTOM_LoadAssetAsync_InternalP12Il2CppObjectP12Il2CppStringS0_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (HEAP8[i1 + 184 >> 0] | 0) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 495978 | 0, i6);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
  i4 = __ZN29AssetBundleLoadAssetOperation9LoadAssetER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb(i1, i5, i3, 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  i7 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 32 >> 2] | 0) | 0;
  HEAP32[i7 + 8 >> 2] = i4;
  STACKTOP = i6;
  return i7 | 0;
 }
 return 0;
}

function __Z37PrintWarningAboutDecompressingTexture13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 80 | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) {
  _printf_console(gb + 418953 | 0, i3);
  STACKTOP = i3;
  return;
 }
 if ((i1 + -30 | 0) >>> 0 < 4) {
  _printf_console(gb + 419022 | 0, i3 + 8 | 0);
  STACKTOP = i3;
  return;
 }
 if ((i1 | 0) == 34) {
  _printf_console(gb + 419093 | 0, i3 + 16 | 0);
  STACKTOP = i3;
  return;
 }
 if ((i1 + -35 | 0) >>> 0 < 2) {
  _printf_console(gb + 419162 | 0, i3 + 24 | 0);
  STACKTOP = i3;
  return;
 }
 if ((i1 + -41 | 0) >>> 0 < 4) {
  _printf_console(gb + 419231 | 0, i3 + 32 | 0);
  STACKTOP = i3;
  return;
 }
 if ((i1 + -45 | 0) >>> 0 < 3) {
  _printf_console(gb + 419300 | 0, i3 + 40 | 0);
  STACKTOP = i3;
  return;
 }
 if ((i1 + -48 | 0) >>> 0 < 12) {
  _printf_console(gb + 419370 | 0, i3 + 48 | 0);
  STACKTOP = i3;
  return;
 }
 switch (i1 | 1 | 0) {
 case 29:
  {
   _printf_console(gb + 419440 | 0, i3 + 56 | 0);
   STACKTOP = i3;
   return;
  }
 case 27:
  {
   _printf_console(gb + 419512 | 0, i3 + 64 | 0);
   STACKTOP = i3;
   return;
  }
 case 25:
  {
   _printf_console(gb + 419585 | 0, i3 + 72 | 0);
   STACKTOP = i3;
   return;
  }
 default:
  {
   HEAP32[i2 >> 2] = i1;
   _printf_console(gb + 419659 | 0, i2);
   STACKTOP = i3;
   return;
  }
 }
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14WSAInputSourceEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14ShaderPassTypeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 12) | 0;
 i2 = i8 + ((HEAP32[i2 + 4 >> 2] | 0) * 12 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = (i2 - i8 | 0) / 12 | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 8);
  i2 = i5 + 4 | 0;
  i3 = i5;
  i7 = i2;
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i4 = _llvm_bswap_i32(i4 | 0) | 0;
  i2 = _llvm_bswap_i32(i2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
  d8 = +HEAPF64[i5 >> 3];
  HEAPF64[i1 >> 3] = d8;
  STACKTOP = i6;
  return;
 } else {
  i9 = i3;
  i10 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i3 + 4 >> 2] = i9;
  HEAP32[i2 >> 2] = i4;
  i3 = i5;
  i7 = i5 + 4 | 0;
  i4 = i10;
  i2 = i9;
  i4 = _llvm_bswap_i32(i4 | 0) | 0;
  i2 = _llvm_bswap_i32(i2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i7 >> 2] = i4;
  d8 = +HEAPF64[i5 >> 3];
  HEAPF64[i1 >> 3] = d8;
  STACKTOP = i6;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags(i6, i7, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  i1 = i2;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i3 = i6 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 8;
 HEAP32[i4 + 4 >> 2] = i7 + 4;
 HEAP32[i4 + 8 >> 2] = i2;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i2 = i7 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 20;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i1;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i4, 0);
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + 24;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags(i6, i4, 0);
 STACKTOP = i5;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TargetEyeMaskEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13RenderingPathEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13LineAlignmentEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZNK14ParticleSystem20CalculateWorldBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 i11 = i3 + 368 | 0;
 f4 = Math_fround(HEAPF32[i11 >> 2]);
 i12 = i3 + 380 | 0;
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i12 >> 2]));
 i9 = i3 + 372 | 0;
 f5 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = i3 + 384 | 0;
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i10 >> 2]));
 i7 = i3 + 376 | 0;
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 i8 = i3 + 388 | 0;
 f5 = Math_fround(f5 * Math_fround(.5));
 f6 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i8 >> 2])) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(f4 * Math_fround(.5));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f6;
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i11 >> 2]));
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i9 >> 2]));
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(.5));
 f4 = Math_fround(Math_fround(f4 - Math_fround(HEAPF32[i7 >> 2])) * Math_fround(.5));
 HEAPF32[i1 + 12 >> 2] = Math_fround(f6 * Math_fround(.5));
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAPF32[i1 + 20 >> 2] = f4;
 if ((HEAP32[(HEAP32[i2 + 36 >> 2] | 0) + 280 >> 2] | 0) == 1) return;
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i3 + 52 | 0, i1);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIN8LODGroup3LODEEEvRT_PKc17TransferMetaFlags(i10, i8, i1, i2) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i10 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i10 + 24 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i8, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i8 + 4 | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i5 = i8 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i8 << 2) | 0;
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI8RendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadjEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37304 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadiEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadfEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i6 + 16 | 0;
  i3 = HEAP32[i6 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i3 >>> 0) i5 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead12GradientModeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z30TransferField_LinearCollectionI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 40 | 0;
 i7 = i9;
 i8 = i9 + 8 | 0;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i2, i5, HEAP32[i4 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = -1;
 if (HEAP32[i5 + 4 >> 2] | 0) {
  i3 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i2 >> 2] | 0) | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = HEAP32[i1 + ((HEAP8[i2 + 4 >> 0] | 0) == 0 ? i3 + -8 + (HEAP32[i2 + 16 >> 2] | 0) | 0 : i3) >> 2] | 0;
  i6 = i3;
  do if (!i3) i1 = -1; else if (!(HEAP32[i2 + 24 >> 2] | 0)) {
   i1 = __Z22scripting_array_lengthP11Il2CppArray(i3) | 0;
   break;
  } else {
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   break;
  } while (0);
  HEAP32[i7 >> 2] = i6;
  HEAP32[i7 + 4 >> 2] = i1;
 };
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = i7;
 mftCall_vii(HEAP32[i4 + 40 >> 2] | 0, i4 | 0, i8 | 0);
 STACKTOP = i9;
 return;
}

function __Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = i1 + 1080 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = (i3 & 16711680 | 0) == 0;
 do if (!((i3 & 255) << 24 >> 24)) if (i1) {
  if (!(i6 & 8)) break; else i1 = 1;
  return i1 | 0;
 } else {
  if (!(i6 & 2)) break; else i1 = 1;
  return i1 | 0;
 } else if (i1) {
  if (!(i6 & 16)) break; else i1 = 1;
  return i1 | 0;
 } else {
  if (!(i6 & 4)) break; else i1 = 1;
  return i1 | 0;
 } while (0);
 if (!(i6 & 96)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = i5 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 i1 = i3 << 24 >> 24 < 0;
 i3 = i1 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 if (i6 & 32 | 0) {
  i1 = i1 ? HEAP32[i5 >> 2] | 0 : i5;
  if ((HEAP8[i1 >> 0] | 0) == 46) {
   i6 = 1;
   return i6 | 0;
  }
  if (!(__Z7StrICmpPKcS0_(i1, gb + 491580 | 0) | 0)) {
   i6 = 1;
   return i6 | 0;
  }
  if (__Z8EndsWithPKcjS0_j((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3, gb + 1086597 | 0, 1) | 0) {
   i6 = 1;
   return i6 | 0;
  }
 }
 if (i6 & 64 | 0) if (!(HEAP8[i4 >> 0] | 0)) if (__Z23EndsWithCaseInsensitivePKcjS0_j((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3, gb + 491584 | 0, 4) | 0) {
  i6 = 1;
  return i6 | 0;
 }
 i6 = 0;
 return i6 | 0;
}

function __ZNK24NavMeshSceneDataRegistry9GetScenesER13dynamic_arrayIiLj4EEPK11NavMeshData(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = i8 + 12 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 if (!i1) return;
 i12 = i9 + 12 | 0;
 i13 = i9 + 16 | 0;
 i14 = i9 + 4 | 0;
 i7 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((HEAP32[i2 + (i7 << 3) + 4 >> 2] | 0) == (i10 | 0)) {
   i2 = i2 + (i7 << 3) | 0;
   i3 = HEAP32[i12 >> 2] | 0;
   i4 = i3 + 1 | 0;
   i5 = HEAP32[i13 >> 2] | 0;
   i6 = i5 & 2147483647;
   do if (i4 >>> 0 > i6 >>> 0) {
    i1 = i5 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
     HEAP32[i13 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i14, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i14, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i6 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i12 >> 2] << 2 | 0) | 0;
     HEAP32[i13 >> 2] = i1;
     HEAP32[i9 >> 2] = i6;
     break;
    }
   } while (0);
   HEAP32[i12 >> 2] = i4;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
   i1 = HEAP32[i11 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < i1 >>> 0);
 return;
}

function __ZNK23ArchiveStorageConverter26GetUncompressedArchiveSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  i7 = 0;
  i8 = 0;
  setTempRet0(i7 | 0);
  return i8 | 0;
 }
 if (!(HEAP8[i1 + 56 >> 0] | 0)) {
  i7 = 0;
  i8 = 0;
  setTempRet0(i7 | 0);
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 48 >> 2] | 0;
 i1 = HEAP8[i3 + 28 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 32 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i3 + 44 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 48 >> 2] | 0; else i1 = i1 & 255;
 i2 = i2 + 5 + i1 | 0;
 if (!(HEAP32[i3 + 80 >> 2] & 256)) {
  i1 = HEAP8[i3 + 8 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 12 >> 2] | 0; else i1 = i1 & 255;
  i6 = i2 + 22 + i1 | 0;
 } else i6 = i2 + 31 | 0;
 i7 = (((HEAP32[i3 + 108 >> 2] | 0) - (HEAP32[i3 + 104 >> 2] | 0) | 0) / 12 | 0) * 10 | 0;
 i2 = HEAP32[i3 + 124 >> 2] | 0;
 i1 = HEAP32[i3 + 120 >> 2] | 0;
 i5 = i1;
 if ((i2 | 0) == (i1 | 0)) i1 = 4; else {
  i4 = (i2 - i1 | 0) / 40 | 0;
  i1 = 4;
  i3 = 0;
  do {
   i2 = HEAP8[i5 + (i3 * 40 | 0) + 20 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) i2 = HEAP32[i5 + (i3 * 40 | 0) + 24 >> 2] | 0; else i2 = i2 & 255;
   i1 = i1 + 21 + i2 | 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i4 >>> 0);
 }
 i5 = 0;
 i8 = i8 + 20 + i6 + i7 + i1 | 0;
 setTempRet0(i5 | 0);
 return i8 | 0;
}

function __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EEjPKi(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + i3 | 0;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (i2 | 0) == 0 ? 0 : i2 + i1 | 0;
 if (!i4) return; else i2 = 0;
 do {
  i6 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 4 >> 2] | 0;
  i9 = HEAP32[i3 + (i2 * 40 | 0) + 8 >> 2] | 0;
  HEAP32[i1 + (i6 * 40 | 0) >> 2] = HEAP32[i3 + (i2 * 40 | 0) >> 2];
  HEAP32[i1 + (i6 * 40 | 0) + 4 >> 2] = i7;
  HEAP32[i1 + (i6 * 40 | 0) + 8 >> 2] = i9;
  i9 = HEAP32[i3 + (i2 * 40 | 0) + 16 >> 2] | 0;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 20 >> 2] | 0;
  i8 = HEAP32[i3 + (i2 * 40 | 0) + 24 >> 2] | 0;
  HEAP32[i1 + (i6 * 40 | 0) + 12 >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 12 >> 2];
  HEAP32[i1 + (i6 * 40 | 0) + 16 >> 2] = i9;
  HEAP32[i1 + (i6 * 40 | 0) + 20 >> 2] = i7;
  HEAP32[i1 + (i6 * 40 | 0) + 24 >> 2] = i8;
  i8 = HEAP32[i3 + (i2 * 40 | 0) + 32 >> 2] | 0;
  i7 = HEAP32[i3 + (i2 * 40 | 0) + 36 >> 2] | 0;
  HEAP32[i1 + (i6 * 40 | 0) + 28 >> 2] = HEAP32[i3 + (i2 * 40 | 0) + 28 >> 2];
  HEAP32[i1 + (i6 * 40 | 0) + 32 >> 2] = i8;
  HEAP32[i1 + (i6 * 40 | 0) + 36 >> 2] = i7;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN5physx7Cooking20loadTriangleMeshDescERKNS_18PxTriangleMeshDescERNS_19TriangleMeshBuilderE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 if (Math_fround(HEAPF32[i3 + 36 >> 2]) != Math_fround(.00100000005)) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 726521 | 0, 123, gb + 732109 | 0, i7);
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 do if (i1 >>> 0 >= 3) {
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  if ((i2 | 0) != 0 | ((i1 >>> 0) % 3 | 0 | 0) == 0) {
   if (HEAP32[i3 + 32 >> 2] | 0) if ((HEAP32[i3 + 28 >> 2] | 0) >>> 0 < 2) break;
   if (i1 >>> 0 > 65535) if (HEAP16[i3 + 24 >> 1] & 2) break;
   if (HEAP32[i3 + 4 >> 2] | 0) if ((HEAP32[i3 >> 2] | 0) >>> 0 >= 12) {
    if (i2 | 0) if ((HEAP32[i3 + 12 >> 2] | 0) >>> 0 < (HEAP16[i3 + 24 >> 1] & 2 ? 6 : 12) >>> 0) break;
    i6 = __ZN5physx19TriangleMeshBuilder12loadFromDescERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb(i4, i3, i5 + 4 | 0, 0) | 0;
    STACKTOP = i7;
    return i6 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726521 | 0, 127, gb + 732210 | 0, i6);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sq17SceneQueryManager12createPrunerENS_18PxPruningStructure4EnumE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 switch (i1 | 0) {
 case 2:
  {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
   i1 = _PxGetFoundation() | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
   i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 7824, (i1 ? gb + 770597 | 0 : gb + 837976 | 0) | 0, gb + 710188 | 0, 69) | 0;
   __ZN5physx2Sq10AABBPrunerC2Eb(i1, 0);
   return i1 | 0;
  }
 case 0:
  {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
   i3 = _PxGetFoundation() | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
   i3 = mftCall_iiiiii(i1 | 0, i2 | 0, 7664, (i3 ? gb + 710270 | 0 : gb + 837976 | 0) | 0, gb + 710188 | 0, 70) | 0;
   __ZN5physx2Sq12BucketPrunerC2Ev(i3);
   return i3 | 0;
  }
 case 1:
  {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
   i3 = _PxGetFoundation() | 0;
   i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
   i3 = mftCall_iiiiii(i1 | 0, i2 | 0, 7824, (i3 ? gb + 770597 | 0 : gb + 837976 | 0) | 0, gb + 710188 | 0, 71) | 0;
   __ZN5physx2Sq10AABBPrunerC2Eb(i3, 1);
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu23computeSphere_SphereMTDERKNS0_6SphereES3_RNS_10PxSweepHitE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 i8 = i2 + 4 | 0;
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i8 >> 2]));
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 i7 = i2 + 8 | 0;
 f12 = Math_fround(f12 - Math_fround(HEAPF32[i7 >> 2]));
 f11 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)) + Math_fround(f12 * f12));
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(f9 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 f11 = Math_fround(Math_sqrt(Math_fround(f11)));
 f4 = Math_fround(Math_fround(1.0) / f11);
 f6 = Math_fround(f6 * f4);
 f5 = Math_fround(f5 * f4);
 f4 = Math_fround(f12 * f4);
 HEAPF32[i1 + 28 >> 2] = f6;
 HEAPF32[i1 + 32 >> 2] = f5;
 HEAPF32[i1 + 36 >> 2] = f4;
 HEAPF32[i1 + 40 >> 2] = Math_fround(f11 - f10);
 f6 = Math_fround(f9 * f6);
 f5 = Math_fround(f9 * f5);
 f4 = Math_fround(f9 * f4);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i8 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i1 + 16 >> 2] = f6;
 HEAPF32[i1 + 20 >> 2] = f5;
 HEAPF32[i1 + 24 >> 2] = f4;
 return 1;
}

function __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK7Hash128j(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5;
 i6 = i5 + 16 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187296 + 8;
 i7 = i1 + 20 | 0;
 i9 = __Znwj(192) | 0;
 __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i9, i2);
 HEAP32[i7 >> 2] = i9;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 i1 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i6, i1, i2, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_((HEAP32[i7 >> 2] | 0) + 176 | 0, i6) | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i3 + 88 >> 2] = i4;
 HEAP8[i3 + 188 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i5;
 return;
}

function __ZN12NavMeshAgent29UpdateTransformGetMessageMaskEfPP9Transform(i6, f7, i9) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, f11 = f0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 24 | 0;
 i3 = i10 + 12 | 0;
 i4 = i10;
 if ((HEAP32[i6 + 68 >> 2] | 0) == -1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i8 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i6 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i5 = i6 + 107 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 if (!(i2 & 1)) i1 = 0; else {
  i2 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i6 + 68 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 480 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 484 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 488 >> 2];
  f11 = Math_fround(-Math_fround(HEAPF32[i6 + 44 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = f11;
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_(i4, i8, i1, i3);
  __ZN9Transform30SetPositionWithoutNotificationERK8Vector3f(i8, i4);
  i1 = 1;
  i2 = HEAP8[i5 >> 0] | 0;
 }
 if (i2 & 2) {
  __ZN12NavMeshAgent14UpdateRotationER9Transformf(i6, i8, f7);
  i1 = i1 | 2;
 }
 HEAP32[i9 >> 2] = i8;
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z15atomIntegrationfPKPN5physx11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPS9_RjSH_(f8, i6, i9, i7, i5, i11, i10, i1, i12, i13) {
 f8 = Math_fround(f8);
 i6 = i6 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i14 = 0, i15 = 0, i16 = 0;
 if (!i7) {
  i2 = 0;
  i1 = 0;
 } else {
  i4 = 0;
  i2 = 0;
  i1 = 0;
  while (1) {
   i3 = i4 + 1 | 0;
   i14 = HEAP32[i6 + (i4 << 2) >> 2] | 0;
   i15 = HEAPU16[i14 + 30 >> 1] | 0;
   i16 = i15 & 255;
   i2 = i16 >>> 0 < i2 >>> 0 ? i2 : i16;
   i15 = i15 >>> 8;
   i1 = i15 >>> 0 < i1 >>> 0 ? i1 : i15;
   __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(i14, i5 + (i4 << 5) | 0, i5 + (i4 << 5) + 16 | 0, f8);
   __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE(i11 + (i4 << 5) | 0, i10 + (i3 << 6) | 0, i14, HEAP32[i9 + (i4 << 2) >> 2] | 0);
   HEAP32[i11 + (i4 << 5) + 28 >> 2] = 0;
   HEAP16[i11 + (i4 << 5) + 12 >> 1] = 0;
   HEAP16[i11 + (i4 << 5) + 14 >> 1] = 0;
   if ((i3 | 0) == (i7 | 0)) break; else i4 = i3;
  }
 }
 i16 = HEAP32[i12 >> 2] | 0;
 HEAP32[i12 >> 2] = i2 >>> 0 < i16 >>> 0 ? i16 : i2;
 i16 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 >> 2] = i1 >>> 0 < i16 >>> 0 ? i16 : i1;
 return;
}

function __ZN5physx2Sc5Scene16removeConstraintERNS0_14ConstraintCoreE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = HEAP32[i6 + 68 >> 2] | 0;
 if (i3 | 0) {
  i1 = HEAP32[i3 + 108 >> 2] | 0;
  if (!i1) i1 = HEAP32[i3 + 112 >> 2] | 0;
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  if (i1 | 0) __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE(HEAP32[i4 + 96 >> 2] | 0, i1, i3);
  i2 = HEAP32[i4 + 1224 >> 2] | 0;
  __ZN5physx2Sc13ConstraintSimD2Ev(i3);
  i1 = i2 + 280 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  i1 = i2 + 292 | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i1 >> 2] = i3;
  i1 = i2 + 284 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  if ((i5 | 0) >= ((HEAP32[i2 + 276 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2);
   HEAP32[i1 >> 2] = 0;
  }
 }
 i5 = i4 + 84 | 0;
 i3 = i4 + 88 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L11 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L11;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 i4 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
 return;
}

function __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i1 + 176 | 0;
 i10 = i1 + 188 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 L1 : do if (!i6) {
  i2 = 0;
  i4 = i1 + 428 | 0;
  i3 = i1 + 424 | 0;
 } else {
  i8 = HEAP32[i9 >> 2] | 0;
  i3 = i1 + 424 | 0;
  i4 = i1 + 428 | 0;
  i1 = i8;
  i2 = 0;
  i5 = -1;
  do {
   while (1) {
    i7 = HEAP32[i1 >> 2] | 0;
    i5 = i5 + 1 | 0;
    if (i7) {
     if ((i5 | 0) < (HEAP32[i7 + 4 >> 2] | 0)) {
      i6 = HEAP32[i3 >> 2] | 0;
      if (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i6 >> 2 >>> 0) break;
     }
     HEAP32[i7 + 12 >> 2] = HEAP32[i11 >> 2];
     HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + 1;
     i6 = HEAP32[i10 >> 2] | 0;
    }
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i8 + (i6 << 2) | 0)) break L1;
   }
   __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi(HEAP32[i6 + (i2 << 2) >> 2] | 0, i11);
   i2 = i2 + 1 | 0;
   i8 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i10 >> 2] | 0;
  } while ((i1 | 0) != (i8 + (i6 << 2) | 0));
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0) return;
 do {
  __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi(HEAP32[i1 + (i2 << 2) >> 2] | 0, i11);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 2 >>> 0);
 return;
}

function __ZN2UI11CanvasGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011557 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 36 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011565 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011580 | 0, i5, i1 + 41 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1011597 | 0, i5, i1 + 42 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN19ShaderPropertySheet21SerializeFromExternalEPhj(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i9 + 8 | 0;
 i2 = i7;
 i3 = i1 + 24 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i5 = HEAP32[i9 + 28 >> 2] | 0;
 i2 = i7 + 24 | 0;
 i1 = i9 + 32 | 0;
 i6 = i2 + (i5 << 2) | 0;
 i3 = i9 + 48 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i4 = i6 - i2 >> 2;
 HEAP32[i9 + 44 >> 2] = i4;
 HEAP32[i3 >> 2] = i4 | -2147483648;
 HEAP32[i1 >> 2] = i2;
 i1 = i9 + 52 | 0;
 i4 = i6 + (i5 << 2) | 0;
 i2 = i9 + 68 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i9 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i5 << 2 >> 2;
 HEAP32[i9 + 64 >> 2] = i3;
 HEAP32[i2 >> 2] = i3 | -2147483648;
 HEAP32[i1 >> 2] = i6;
 i1 = i7 + i8 + -4 + -4 | 0;
 i2 = i9 + 72 | 0;
 i3 = i9 + 88 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i9 + 76 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i8 = i1 - i4 | 0;
 HEAP32[i9 + 84 >> 2] = i8;
 HEAP32[i3 >> 2] = i8 | -2147483648;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i9 + 92 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 96 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE(i12) {
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i13 = 0;
 i13 = i12 + 12 | 0;
 i1 = HEAP32[i13 >> 2] | 0;
 if (!i1) return;
 i11 = 0;
 do {
  i10 = (HEAP32[i12 >> 2] | 0) + (i11 << 4) + 8 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i9 = HEAP32[gb + 1163260 >> 2] | 0;
   i3 = i9 + 12 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = i9 + 16 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = i7 & 2147483647;
   do if (i5 >>> 0 > i8 >>> 0) {
    i1 = i7 << 1;
    i1 = (i1 | 0) == 0 ? 1 : i1;
    if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
     HEAP32[i6 >> 2] = i1;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
     HEAP32[i6 >> 2] = i1;
     HEAP32[i9 >> 2] = i8;
     break;
    }
   } while (0);
   HEAP32[i3 >> 2] = i5;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i10 >> 2] = 0;
   i1 = HEAP32[i13 >> 2] | 0;
  }
  i11 = i11 + 1 | 0;
 } while (i11 >>> 0 < i1 >>> 0);
 return;
}

function __ZN22BaseUnityConnectClient15OnDonePreparingEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 112 | 0;
 HEAP8[i4 >> 0] = HEAP8[i5 + 552 >> 0] | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i1 = HEAP32[i5 + 664 >> 2] | 0;
  i2 = i5 + 668 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i5 + 604 >> 2] | 0;
 if ((i1 | 0) > -1) HEAP32[i5 + 8 >> 2] = i1;
 i1 = i5 + 110 | 0;
 HEAP8[i1 >> 0] = 1;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
 if ((HEAP32[i2 >> 2] | 0) != 2) return;
 i3 = i5 + 113 | 0;
 if (HEAP8[i3 >> 0] | 0) return;
 HEAP8[i3 >> 0] = 1;
 L16 : do if ((HEAP32[i2 >> 2] | 0) != 3) {
  switch (HEAP32[i2 >> 2] | 0) {
  case 5:
  case 0:
   break L16;
  case 1:
   {
    i1 = 14;
    break;
   }
  case 2:
   {
    if (!(HEAP8[i4 >> 0] | 0)) {
     mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0);
     break L16;
    } else i1 = 15;
    break;
   }
  case 4:
   {
    if (!(HEAP8[i1 >> 0] | 0)) i1 = 14; else if (!(HEAP8[i5 + 108 >> 0] | 0)) i1 = 15; else i1 = 14;
    break;
   }
  default:
   i1 = 15;
  }
  if ((i1 | 0) == 14) {
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0);
   break;
  } else if ((i1 | 0) == 15) {
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0);
   break;
  }
 } while (0);
 HEAP8[i3 >> 0] = 0;
 return;
}

function __ZN14GraphicsHelper16SetRenderTargetsER9GfxDeviceiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_i11CubemapFaceij(i6, i3, i4, i5, i7, i8, i9, i10) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i1 = i11;
 i2 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i11 + 36 >> 2] = i3;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i13 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   HEAP32[i11 + (i1 << 2) >> 2] = i13;
   i2 = i13 + 28 | 0;
   HEAP8[i11 + 56 + i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i13 = i13 + 29 | 0;
   HEAP8[i11 + 64 + i1 >> 0] = HEAP8[i13 >> 0] | 0;
   HEAP8[i13 >> 0] = 0;
   HEAP8[i2 >> 0] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i11 + 32 >> 2] = i1;
  i13 = i1 + 28 | 0;
  i5 = HEAP16[i13 >> 1] | 0;
  HEAP8[i11 + 72 >> 0] = i5;
  HEAP8[i11 + 73 >> 0] = (i5 & 65535) >>> 8;
  HEAP8[i1 + 29 >> 0] = 0;
  HEAP8[i13 >> 0] = 0;
 }
 HEAP32[i11 + 40 >> 2] = i7;
 HEAP32[i11 + 44 >> 2] = i8;
 HEAP32[i11 + 52 >> 2] = i10;
 HEAP32[i11 + 48 >> 2] = i9;
 __ZN9GfxDevice16SetRenderTargetsERK20GfxRenderTargetSetup(i6, i11);
 STACKTOP = i12;
 return;
}

function __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i3 = i2 + 12 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i4 = i9 + 1 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 72 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 72 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 72 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i2 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 + (i9 * 72 | 0) | 0;
 i3 = i8;
 i4 = i2 + 56 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP32[i1 + (i9 * 72 | 0) + 56 >> 2] = HEAP32[i8 + 56 >> 2];
 HEAP32[i1 + (i9 * 72 | 0) + 60 >> 2] = HEAP32[i8 + 60 >> 2];
 i7 = i8 + 64 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i1 + (i9 * 72 | 0) + 64 | 0;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 return;
}

function __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 3 >>> 0 >= i2 >>> 0) {
  do {
   i8 = i1;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 8 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 3) + i2 | 0;
 if (i5 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 2;
 i3 = i6 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 536870911;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 3) | 0;
 i6 = i5 + (i1 - i4 >> 3 << 3) | 0;
 i5 = i5 + (i3 << 3) | 0;
 i1 = i6;
 i4 = i6;
 do {
  i3 = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = i4 + 8 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 3) << 3) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 72; else i1 = (HEAP32[i1 >> 2] | 0) + 72 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN16ScriptingManagerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 66624 + 8;
 i1 = HEAP32[i5 + 200 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 204 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i5 + 180 | 0, HEAP32[i5 + 184 >> 2] | 0);
 i1 = HEAP32[i5 + 168 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 172 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = gb + 28648 + 8;
  HEAP32[i5 >> 2] = gb + 28496 + 8;
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i4 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP32[i6 >> 2] = 76;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 HEAP32[i5 >> 2] = gb + 28648 + 8;
 HEAP32[i5 >> 2] = gb + 28496 + 8;
 STACKTOP = i7;
 return;
}

function __ZN13MonoBehaviour17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 76 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 88 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 112 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 124 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = __Z9GetIAudiov() | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, HEAP32[i3 + 144 >> 2] | 0);
 i1 = i3 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZNK15MonoScriptCache7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z16IsDirectoryEmptyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1104 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5;
 i3 = i5 + 40 | 0;
 i2 = i5 + 8 | 0;
 i4 = i5 + 20 | 0;
 i6 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i2, i6, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 HEAP32[i4 >> 2] = 0;
 i2 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i7, __ZNK15FileSystemEntry4PathEv(i3) | 0, i4, 0, 0) | 0;
 i2 = (HEAP32[i2 >> 2] | 0) == 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  __ZN13FileEntryDataD2Ev(i3);
  STACKTOP = i5;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i1);
 HEAP32[i4 >> 2] = 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i5;
 return i2 | 0;
}

function __ZNK5physx20PxsParticleSystemSim19getSimParticleDataVERNS_28PxvParticleSystemSimDataDescEb(i10, i7, i1) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 HEAP32[i7 >> 2] = 0;
 i2 = i7 + 4 | 0;
 HEAP32[i2 >> 2] = 4;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i7 + 12 | 0;
 HEAP32[i6 >> 2] = 12;
 i8 = i7 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i7 + 20 | 0;
 HEAP32[i9 >> 2] = 12;
 i11 = i7 + 24 | 0;
 HEAP32[i11 >> 2] = 0;
 i12 = i7 + 28 | 0;
 HEAP32[i12 >> 2] = 12;
 i13 = i7 + 32 | 0;
 HEAP32[i13 >> 2] = 0;
 i14 = i7 + 36 | 0;
 HEAP32[i14 >> 2] = 4;
 i3 = HEAP32[i10 + 8 >> 2] | 0;
 if (!(HEAP32[i3 + 20 >> 2] | 0)) return;
 if (!(HEAP32[i10 + 16 >> 2] | 0)) return;
 i4 = i10 + 12 | 0;
 i1 = HEAP16[(HEAP32[i4 >> 2] | 0) + 80 >> 1] | 0;
 if (i1 & 64) {
  HEAP32[i7 >> 2] = (HEAP32[i3 + 48 >> 2] | 0) + 12;
  HEAP32[i2 >> 2] = 32;
  i1 = HEAP16[(HEAP32[i4 >> 2] | 0) + 80 >> 1] | 0;
 }
 if (i1 & 16) {
  HEAP32[i5 >> 2] = HEAP32[i10 + 64 >> 2];
  HEAP32[i6 >> 2] = 12;
  i1 = HEAP16[(HEAP32[i4 >> 2] | 0) + 80 >> 1] | 0;
 }
 if (i1 & 32) {
  HEAP32[i8 >> 2] = HEAP32[i10 + 68 >> 2];
  HEAP32[i9 >> 2] = 12;
 }
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i12 >> 2] = 16;
 HEAP32[i13 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
 HEAP32[i14 >> 2] = 16;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15setActorSimFlagEb(i5, (HEAP16[i1 >> 1] & 8) != 0);
 i10 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i5 + i3 | 0;
 i9 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i8 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i8;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i10;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i10;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj(i6, i8, i9) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i7 = i10 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = i9;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = ~(i9 << 15) + i9 | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i6 + 36 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i6 + 28 >> 2] | 0;
   i3 = i6 + 32 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i9 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) break L1;
   }
   if (i2 | 0) {
    i9 = i4 + (i1 << 3) + 4 | 0;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i9 >> 2] = i8;
    STACKTOP = i10;
    return;
   }
  }
 } while (0);
 HEAP32[i5 >> 2] = i9;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i6 + 20 | 0, i5, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i9;
  HEAP32[i1 + 4 >> 2] = i8;
 }
 STACKTOP = i10;
 return;
}

function __ZN17SizeBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 272 | 0, i7);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 536 | 0, i7);
 i1 = i6 + 800 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 804 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 808 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN13MemoryManager25GetAllocatorContainingPtrEPKv(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = i5 + 1544 | 0;
 L1 : do if ((HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  while (1) {
   i3 = i5 + 1568 + (i1 << 2) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0) | 0) {
    i4 = HEAP32[i3 >> 2] | 0;
    if (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i7 | 0) | 0) break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i2 >> 2] | 0)) break L1;
  }
  i7 = HEAP32[i3 >> 2] | 0;
  return i7 | 0;
 } while (0);
 i1 = i5 + 1560 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i7 | 0) | 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  return i7 | 0;
 }
 i1 = 0;
 do {
  i2 = i5 + 1764 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 > 512 >>> 0) if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i7 | 0) | 0) {
   i6 = 13;
   break;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < 512);
 if ((i6 | 0) == 13) {
  i7 = HEAP32[i2 >> 2] | 0;
  return i7 | 0;
 }
 i1 = i5 + 1552 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i7 | 0) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 return i7 | 0;
}

function __Z27GetAudioScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1459932 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 856675 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[gb + 1459932 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856797 | 0, gb + 856807 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1459932 >> 2] | 0) + 8 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856797 | 0, gb + 856840 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1459932 >> 2] | 0) + 16 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856878 | 0, gb + 856892 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 856926 | 0) | 0;
 HEAP32[(HEAP32[gb + 1459932 >> 2] | 0) + 24 >> 2] = i2;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 275 | 0, fb + 276 | 0);
 i2 = HEAP32[gb + 1459932 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z25dtMergeCorridorStartMovedPyiiPKyi(i11, i8, i9, i12, i10) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0;
 if ((i10 | 0) > 0) {
  i2 = -1;
  i5 = i8;
  i1 = -1;
 } else {
  i12 = i8;
  return i12 | 0;
 }
 do {
  if ((i5 | 0) <= 0) break;
  i5 = i5 + -1 | 0;
  i7 = i11 + (i5 << 3) | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i10;
  i4 = 0;
  do {
   i13 = i3;
   i3 = i3 + -1 | 0;
   i14 = i12 + (i3 << 3) | 0;
   i14 = (i6 | 0) == (HEAP32[i14 >> 2] | 0) ? (i7 | 0) == (HEAP32[i14 + 4 >> 2] | 0) : 0;
   i1 = i14 ? i3 : i1;
   i4 = i4 | i14;
   i2 = i14 ? i5 : i2;
  } while ((i13 | 0) > 1);
 } while (!i4);
 if ((i1 | 0) == -1 | (i2 | 0) == -1) {
  i14 = i8;
  return i14 | 0;
 }
 i4 = i10 - i1 | 0;
 i1 = i2 + 1 | 0;
 i1 = (i1 | 0) < (i8 | 0) ? i1 : i8;
 i3 = i8 - i1 | 0;
 i3 = (i3 | 0) < 0 ? 0 : i3;
 i3 = (i3 + i4 | 0) > (i9 | 0) ? i9 - i4 | 0 : i3;
 if (i3 | 0) _memmove(i11 + (i4 << 3) | 0, i11 + (i1 << 3) | 0, i3 << 3 | 0) | 0;
 if ((i4 | 0) > 0) {
  i2 = i10 + -1 | 0;
  i1 = 0;
  do {
   i10 = i12 + (i2 - i1 << 3) | 0;
   i13 = HEAP32[i10 + 4 >> 2] | 0;
   i14 = i11 + (i1 << 3) | 0;
   HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i14 = i3 + i4 | 0;
 return i14 | 0;
}

function _cpowf(i11, i4, i2) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 40 | 0;
 i15 = i14 + 32 | 0;
 i16 = i14 + 24 | 0;
 i9 = i14 + 16 | 0;
 i12 = i14 + 8 | 0;
 i13 = i14;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i16 + 4 >> 2] = i2;
 HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 _clogf(i15, i10);
 f5 = Math_fround(HEAPF32[i15 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 4 >> 2]);
 f3 = Math_fround(Math_fround(f8 * f5) - Math_fround(f7 * f6));
 f1 = Math_fround(Math_fround(f7 * f5) + Math_fround(f8 * f6));
 if ((f3 != f3 | Math_fround(0.0) != Math_fround(0.0)) & (f1 != f1 | Math_fround(0.0) != Math_fround(0.0))) {
  ___mulsc3(i9 | 0, +f8, +f7, +f5, +f6);
  f3 = Math_fround(HEAPF32[i9 >> 2]);
  f1 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 }
 HEAPF32[i13 >> 2] = f3;
 HEAPF32[i13 + 4 >> 2] = f1;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 _cexpf(i12, i10);
 i16 = HEAP32[i12 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = i16;
 STACKTOP = i14;
 return;
}

function __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (i2 - i4 >> 3 >>> 0 >= i9 >>> 0) {
  i1 = i9;
  i2 = i3;
  while (1) {
   HEAP32[i2 >> 2] = 0;
   HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 8 | 0;
  }
  HEAP32[i10 >> 2] = i3 + (i9 << 3);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = (i4 - i1 >> 3) + i9 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i2 - i1 | 0;
 i2 = i6 >> 2;
 i2 = i6 >> 3 >>> 0 < 268435455 ? (i2 >>> 0 < i3 >>> 0 ? i3 : i2) : 536870911;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 << 3) | 0;
 i6 = i3 + (i4 - i1 >> 3 << 3) | 0;
 i5 = i3 + (i2 << 3) | 0;
 i2 = i9;
 i3 = i6;
 while (1) {
  HEAP32[i3 >> 2] = 0;
  HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 8 | 0;
 }
 i2 = i4 - i1 | 0;
 i3 = i6 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i6 + (i9 << 3);
 HEAP32[i8 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9ShaderLab25SerializedTextureProperty8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471958 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 i6 = i2 + 16 | 0;
 i5 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 471972 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5Unity14CharacterJoint19SetSwingLimitSpringERK20SoftJointLimitSpring(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i5 + 140 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i3 ? Math_fround(340282326000000008404918.0e15) : f1;
 i3 = i4 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = f1 < Math_fround(0.0);
 i2 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i2 ? Math_fround(340282326000000008404918.0e15) : f1;
 i2 = i4 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i7 >> 2] = i3;
 i4 = i5 + 144 | 0;
 HEAP32[i4 >> 2] = i2;
 i2 = i5 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 160 >> 2] | 0, i6 | 0, i5 | 0);
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i4 >> 2];
 i7 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 156 >> 2] | 0, i7 | 0, i6 | 0);
 STACKTOP = i8;
 return;
}

function __Z41Texture2D_CUSTOM_INTERNAL_CALL_ReadPixelsP12Il2CppObjectRK5RectTIfEiih(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i10 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = HEAP8[(__Z12GetGfxDevicev() | 0) + 4380 >> 0] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  i3 = ~~Math_fround(HEAPF32[i5 >> 2]);
  i4 = ~~Math_fround(HEAPF32[i5 + 4 >> 2]);
  i10 = ~~Math_fround(HEAPF32[i5 + 8 >> 2]);
  __ZN9Texture2D10ReadPixelsEiiiiiiibb(i2, 0, i3, i4, i10, ~~Math_fround(HEAPF32[i5 + 12 >> 2]), i6, i7, i1 << 24 >> 24 != 0, i8 << 24 >> 24 != 0);
  STACKTOP = i9;
  return;
 }
}

function __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead7FogModeEvRT_RT0_PKc17TransferMetaFlags(i8, i9, i2, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i4 = HEAP32[i9 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i8 = i4;
  HEAP32[i9 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = i8 + 16 | 0;
  i4 = HEAP32[i8 + 20 >> 2] | 0;
  i2 = i4 + (HEAP32[(HEAP32[i8 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i8 + 36 >> 2] | 0, 0 - (HEAP32[i8 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 < i4 >>> 0) i6 = 6; else {
   i3 = i2 + 4 | 0;
   if (i3 >>> 0 > (HEAP32[i8 + 24 >> 2] | 0) >>> 0) i6 = 6; else {
    HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i1 >> 2] = i3;
   }
  }
  if ((i6 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 4);
  if (HEAP32[i8 >> 2] & 512 | 0) HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 24) | 0;
 i2 = i8 + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = (i2 - i8 | 0) / 24 | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI4AABBLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z19CreateWebCamTextureRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = HEAP32[gb + 1459968 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1459968 >> 2] | 0;
 i11 = i3;
 if ((i2 | 0) == (i3 | 0)) {
  i12 = 0;
  return i12 | 0;
 }
 i10 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i10 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i10 & 255;
 i9 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i7 = (i2 - i3 | 0) / 20 | 0;
 i8 = (i10 | 0) == 0;
 i1 = 0;
 L4 : while (1) {
  i4 = i11 + (i1 * 20 | 0) | 0;
  i2 = HEAP8[i4 + 11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  i2 = i2 & 255;
  do if (((i3 ? HEAP32[i11 + (i1 * 20 | 0) + 4 >> 2] | 0 : i2) | 0) == (i10 | 0)) {
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i3 ? i5 : i4;
   if (i3) {
    if (i8) break L4;
    if (!(_memcmp(i6, i9, i10) | 0)) break L4; else break;
   }
   if (i8) break L4;
   if ((i5 & 255) << 24 >> 24 == (HEAP8[i9 >> 0] | 0)) {
    i3 = i9;
    do {
     i2 = i2 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i2) break L4;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i12 = 13;
   break;
  }
 }
 if ((i12 | 0) == 13) return i1 | 0;
 i12 = mftCall_i(HEAP32[i11 + (i1 * 20 | 0) + 16 >> 2] | 0) | 0;
 return i12 | 0;
}

function _UNITY_FT_Outline_Reverse(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 if (!i6) return;
 if ((HEAP16[i6 >> 1] | 0) > 0) {
  i8 = i6 + 12 | 0;
  i9 = i6 + 4 | 0;
  i10 = i6 + 8 | 0;
  i4 = 0;
  i5 = 0;
  i1 = 0;
  while (1) {
   i7 = HEAP16[(HEAP32[i8 >> 2] | 0) + (i1 << 1) >> 1] | 0;
   i1 = HEAP32[i9 >> 2] | 0;
   i3 = (i4 | 0) < (i7 | 0);
   if (i3) {
    i2 = i1 + (i7 << 3) | 0;
    i1 = i1 + (i4 << 3) | 0;
    do {
     i12 = i1;
     i13 = HEAP32[i12 >> 2] | 0;
     i12 = HEAP32[i12 + 4 >> 2] | 0;
     i15 = i2;
     i14 = HEAP32[i15 + 4 >> 2] | 0;
     i11 = i1;
     HEAP32[i11 >> 2] = HEAP32[i15 >> 2];
     HEAP32[i11 + 4 >> 2] = i14;
     i11 = i2;
     HEAP32[i11 >> 2] = i13;
     HEAP32[i11 + 4 >> 2] = i12;
     i1 = i1 + 8 | 0;
     i2 = i2 + -8 | 0;
    } while (i1 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i10 >> 2] | 0;
    if (i3) {
     i2 = i1 + i7 | 0;
     i1 = i1 + i4 | 0;
     do {
      i15 = HEAP8[i1 >> 0] | 0;
      HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
      HEAP8[i2 >> 0] = i15;
      i1 = i1 + 1 | 0;
      i2 = i2 + -1 | 0;
     } while (i1 >>> 0 < i2 >>> 0);
    }
   }
   i5 = i5 + 1 << 16 >> 16;
   i1 = i5 & 65535;
   if ((i1 | 0) >= (HEAP16[i6 >> 1] | 0)) break; else i4 = i7 + 1 | 0;
  }
 }
 i15 = i6 + 16 | 0;
 HEAP32[i15 >> 2] = HEAP32[i15 >> 2] ^ 4;
 return;
}

function _select_scan_parameters(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i6 + 172 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[(HEAP32[i6 + 316 >> 2] | 0) + 28 >> 2] | 0;
  i5 = HEAP32[i3 + (i4 * 36 | 0) >> 2] | 0;
  HEAP32[i6 + 228 >> 2] = i5;
  if ((i5 | 0) > 0) {
   i2 = i6 + 68 | 0;
   i1 = 0;
   do {
    HEAP32[i6 + 232 + (i1 << 2) >> 2] = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i3 + (i4 * 36 | 0) + 4 + (i1 << 2) >> 2] | 0) * 84 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i5 | 0));
  }
  HEAP32[i6 + 300 >> 2] = HEAP32[i3 + (i4 * 36 | 0) + 20 >> 2];
  HEAP32[i6 + 304 >> 2] = HEAP32[i3 + (i4 * 36 | 0) + 24 >> 2];
  HEAP32[i6 + 308 >> 2] = HEAP32[i3 + (i4 * 36 | 0) + 28 >> 2];
  HEAP32[i6 + 312 >> 2] = HEAP32[i3 + (i4 * 36 | 0) + 32 >> 2];
  return;
 }
 i3 = i6 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) > 4) {
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 26;
  HEAP32[i5 + 24 >> 2] = i1;
  HEAP32[i5 + 28 >> 2] = 4;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i6 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i6 + 228 >> 2] = i1;
 if ((i1 | 0) > 0) {
  i2 = i6 + 68 | 0;
  i1 = 0;
  do {
   HEAP32[i6 + 232 + (i1 << 2) >> 2] = (HEAP32[i2 >> 2] | 0) + (i1 * 84 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 HEAP32[i6 + 300 >> 2] = 0;
 HEAP32[i6 + 304 >> 2] = 63;
 HEAP32[i6 + 308 >> 2] = 0;
 HEAP32[i6 + 312 >> 2] = 0;
 return;
}

function _block_locate_free(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (i1 >>> 0 > 31) {
  i1 = i1 + -1 + (1 << 26 - (Math_clz32(i1 | 0) | 0)) | 0;
  if (i1 >>> 0 < 128) i3 = 4; else {
   i2 = 31 - (Math_clz32(i1 | 0) | 0) | 0;
   i1 = i1 >>> (i2 + -5 | 0) ^ 32;
   i2 = i2 + -6 | 0;
  }
 } else i3 = 4;
 if ((i3 | 0) == 4) {
  i1 = i1 >>> 2;
  i2 = 0;
 }
 i1 = HEAP32[i6 + 20 + (i2 << 2) >> 2] & -1 << i1;
 do if (!i1) {
  i1 = HEAP32[i6 + 16 >> 2] & -1 << i2 + 1;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  } else {
   i1 = _llvm_cttz_i32(i1 | 0) | 0;
   i2 = i1;
   i1 = HEAP32[i6 + 20 + (i1 << 2) >> 2] | 0;
   break;
  }
 } while (0);
 i3 = _llvm_cttz_i32(i1 | 0) | 0;
 i1 = (i1 | 0) == 0 ? -1 : i3;
 i3 = i6 + 116 + (i2 << 7) + (i1 << 2) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if (!i5) {
  i6 = 0;
  return i6 | 0;
 }
 i7 = HEAP32[i5 + 12 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i7;
 HEAP32[i7 + 8 >> 2] = i4;
 if ((HEAP32[i3 >> 2] | 0) != (i5 | 0)) {
  i7 = i5;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 if ((i4 | 0) != (i6 | 0)) {
  i7 = i5;
  return i7 | 0;
 }
 i4 = i6 + 20 + (i2 << 2) | 0;
 i7 = HEAP32[i4 >> 2] & ~(1 << i1);
 HEAP32[i4 >> 2] = i7;
 i1 = i6 + 16 | 0;
 if (i7 | 0) {
  i7 = i5;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i2);
 i7 = i5;
 return i7 | 0;
}

function __ZN8LODGroup21SetAnimateCrossFadingEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 i2 = i3 + 52 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) == (i1 & 1 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i2 >> 0] = i1 & 1;
 i1 = HEAP32[i3 + 68 >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1161200 >> 2] | 0;
 i10 = i3 + 28 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0, i3 + 32 | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i10 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i10 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 i10 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i10 ? f9 : f8;
 f7 = f7 < f8 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i4 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i4 ? f9 : f8;
 __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i2, i1, i3, i5, Math_fround(Math_fround(HEAPF32[i3 + 44 >> 2]) * (f7 < f8 ? f8 : f7)));
 STACKTOP = i6;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15setActorSimFlagEb(i5, (HEAP16[i1 >> 1] & 8) != 0);
 i10 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i5 + i3 | 0;
 i9 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i8 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i8;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i10;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i10;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN5Unity5Cloth22SetStretchingStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 if (!(f1 <= Math_fround(0.0))) {
  if (f1 > Math_fround(1.0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 737, 1, 0, 0, 0);
   f1 = Math_fround(1.0);
  }
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838981 | 0, 0, gb + 838562 | 0, 736, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i2 + 40 >> 2] = f1;
 i2 = i2 + 228 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i3 | 0, 1);
 HEAPF32[i4 >> 2] = f1;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i3 | 0, 1, i4 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 264 >> 2] | 0, i5 | 0, i3 | 0, 2);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAPF32[i4 >> 2] = f1;
 i5 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 260 >> 2] | 0, i5 | 0, 2, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZN17CapsuleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(172, i1, 16, gb + 1048932 | 0, 0, gb + 805360 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153816 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i4 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4 + 80 | 0) | 0;
 HEAP32[i4 >> 2] = gb + 154196 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN16SpriteRenderDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i1 + 36 | 0;
 i4 = i1;
 i6 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 52 >> 0] = 1;
 i1 = i1 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 412121 | 0, 329) | 0;
 i4 = i2 + 4 | 0;
 i6 = i4 + 44 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 45376 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i7 = i3;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i2 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i5;
 return;
}

function __ZN13DrawImmediate11FlushBufferEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 16 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) return;
 i10 = i8 + 216 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 switch (HEAP32[i8 + 212 >> 2] | 0) {
 case 0:
  {
   i1 = (i1 | 0) / 3 | 0;
   break;
  }
 case 1:
  {
   i1 = i1 + -2 | 0;
   break;
  }
 case 2:
  {
   i1 = (i1 | 0) / 4 | 0;
   break;
  }
 case 3:
  {
   i1 = (i1 | 0) / 2 | 0;
   break;
  }
 case 4:
  {
   i1 = i1 + -1 | 0;
   break;
  }
 case 5:
  break;
 default:
  i1 = 0;
 }
 i5 = i8 + 12 | 0;
 i6 = i8 + 4 | 0;
 i7 = __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, 0) | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4512 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  if (!(HEAP32[i4 >> 2] | 0)) HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 896 >> 2] | 0, i3 | 0) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i3 = i8 + 20 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0, HEAP32[i10 >> 2] | 0, 0);
 if ((i1 | 0) > 0) mftCall_viiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0, i6 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, 0, 0);
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i8 + 24 >> 2] = 0;
 HEAP32[i8 + 28 >> 2] = -1;
 HEAP32[i8 + 32 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 return;
}

function __ZN11AudioSource15rolloffCallbackEP12FMOD_CHANNELf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 __ZN4FMOD7Channel11getUserDataEPPv(i2, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (!i4) {
  f1 = Math_fround(1.0);
  STACKTOP = i6;
  return Math_fround(f1);
 }
 i5 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[gb + 1098888 >> 0] | 0)) {
  i2 = gb + 861196 | 0;
  i3 = -1;
  do {
   i3 = HEAP32[gb + 1111240 + ((HEAPU8[i2 >> 0] ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (gb + 861196 + 87 | 0));
  i2 = ~i3;
  HEAP32[gb + 1459936 >> 2] = i2;
  i3 = gb + 1098888 | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i3 + 4 >> 2] = 0;
 } else i2 = HEAP32[gb + 1459936 >> 2] | 0;
 if ((i5 | 0) != (i2 | 0)) {
  f1 = Math_fround(1.0);
  STACKTOP = i6;
  return Math_fround(f1);
 }
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(1.0);
  STACKTOP = i6;
  return Math_fround(f1);
 }
 i2 = HEAP32[i2 + 240 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(1.0);
  STACKTOP = i6;
  return Math_fround(f1);
 }
 if (HEAP32[i2 + 540 >> 2] | 0) {
  f1 = Math_fround(1.0);
  STACKTOP = i6;
  return Math_fround(f1);
 }
 f1 = Math_fround(__ZNK11AudioSource28CalculateDistanceAttenuationEv(i2));
 STACKTOP = i6;
 return Math_fround(f1);
}

function __ZN10GameObject8ActivateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 288 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
  STACKTOP = i6;
  return;
 }
 if (HEAP32[i2 + 56 >> 2] & 16 | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 369943 | 0, 0, gb + 368833 | 0, 459, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1104688 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104688 | 0, i5);
  i1 = gb + 1104688 | 0;
 } else i1 = 0;
 HEAP8[i2 + 54 >> 0] = 1;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i3, i5);
 __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i2, 0, i3);
 __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i3, 8, 0);
 __ZN18AwakeFromLoadQueueD2Ev(i3);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN8GradientC2Ev(i5);
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + ((HEAP8[i1 >> 0] | 0) == 0 ? i3 + -8 + (HEAP32[i1 + 12 >> 2] | 0) | 0 : i3) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i2 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i1 = i5 + 32 | 0;
 i2 = i2 + 32 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN9JSONWrite8TransferI8GradientEEvRT_PKc17TransferMetaFlags(i6, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZNKSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE14__count_uniqueIS6_EEjRKT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i4 = i1 + 16 | 0;
  i3 = HEAP8[i4 + 11 >> 0] | 0;
  i5 = i3 << 24 >> 24 < 0;
  i3 = i5 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255;
  i6 = i3 >>> 0 < i9 >>> 0;
  i2 = i6 ? i3 : i9;
  if (!i2) i7 = 5; else {
   i2 = _memcmp(i8, i5 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
   if (!i2) i7 = 5; else if ((i2 | 0) < 0) i7 = 7; else i7 = 8;
  }
  if ((i7 | 0) == 5) if (i9 >>> 0 < i3 >>> 0) i7 = 7; else i7 = 8;
  if ((i7 | 0) != 7) if ((i7 | 0) == 8) {
   i7 = 0;
   i2 = i9 >>> 0 < i3 >>> 0 ? i9 : i3;
   if (!i2) i7 = 10; else {
    i2 = _memcmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i8, i2) | 0;
    if (!i2) i7 = 10; else if ((i2 | 0) >= 0) {
     i1 = 1;
     i7 = 14;
     break;
    }
   }
   if ((i7 | 0) == 10) if (!i6) {
    i1 = 1;
    i7 = 14;
    break;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZNK21LightProbeProxyVolume24GetSHCoefficientsTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 156 + (HEAP32[i1 + 164 >> 2] << 2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNK16b2PrismaticJoint19GetJointTranslationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0;
 i9 = HEAP32[i1 + 48 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f8 = Math_fround(f3 * f2);
 f5 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f5 * f6));
 f8 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) + f8);
 f6 = Math_fround(Math_fround(f2 * f5) + Math_fround(f3 * f6));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i9 + 16 >> 2]));
 i9 = HEAP32[i1 + 52 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i9 + 24 >> 2]);
 f11 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f7 = Math_fround(f2 * f11);
 f10 = Math_fround(HEAPF32[i9 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 80 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f10 * f4));
 f7 = Math_fround(Math_fround(HEAPF32[i9 + 12 >> 2]) + f7);
 f4 = Math_fround(Math_fround(f11 * f10) + Math_fround(f2 * f4));
 f8 = Math_fround(f7 - f8);
 f6 = Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i9 + 16 >> 2])) - f6);
 f4 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 f7 = Math_fround(f3 * f4);
 f2 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 return Math_fround(Math_fround(f8 * Math_fround(f7 - Math_fround(f5 * f2))) + Math_fround(f6 * Math_fround(Math_fround(f5 * f4) + Math_fround(f3 * f2))));
}

function __ZN16CircleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(164, i1, 16, gb + 1048932 | 0, 0, gb + 805438 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153816 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i4 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4 + 80 | 0) | 0;
 HEAP32[i4 >> 2] = gb + 154392 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z59ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterSystemP12Il2CppObjectiS0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i8 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    __ZN14ParticleSystem8SyncJobsEb(1);
    i8 = HEAP32[i1 + 916 >> 2] | 0;
    i6 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
    HEAP32[(HEAP32[i8 + 8 >> 2] | 0) + (i3 * 12 | 0) >> 2] = i6;
    STACKTOP = i7;
    return;
   }
  }
 }
 i8 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i5) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i8;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i6);
}

function __ZN7mecanim9animation9xformCondEbRKN4math4trsXES4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0, f20 = f0;
 f20 = Math_fround(HEAPF32[i3 >> 2]);
 f18 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f16 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f19 = Math_fround(HEAPF32[i4 >> 2]);
 f17 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i14 = i2 ? HEAP32[i3 + 12 >> 2] | 0 : HEAP32[i4 + 12 >> 2] | 0;
 i13 = i2 ? HEAP32[i3 + 16 >> 2] | 0 : HEAP32[i4 + 16 >> 2] | 0;
 i12 = i2 ? HEAP32[i3 + 20 >> 2] | 0 : HEAP32[i4 + 20 >> 2] | 0;
 i11 = i2 ? HEAP32[i3 + 24 >> 2] | 0 : HEAP32[i4 + 24 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 36 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + 36 >> 2]);
 HEAPF32[i1 >> 2] = i2 ? f20 : f19;
 HEAPF32[i1 + 4 >> 2] = i2 ? f18 : f17;
 HEAPF32[i1 + 8 >> 2] = i2 ? f16 : f15;
 HEAP32[i1 + 12 >> 2] = i14;
 HEAP32[i1 + 16 >> 2] = i13;
 HEAP32[i1 + 20 >> 2] = i12;
 HEAP32[i1 + 24 >> 2] = i11;
 HEAPF32[i1 + 28 >> 2] = i2 ? f10 : f9;
 HEAPF32[i1 + 32 >> 2] = i2 ? f8 : f7;
 HEAPF32[i1 + 36 >> 2] = i2 ? f6 : f5;
 return;
}

function __ZN5audio5mixerL19IsAnyChannelPlayingEPN4FMOD12ChannelGroupE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = i6;
 HEAP32[i2 >> 2] = 0;
 i1 = (__ZN4FMOD12ChannelGroup14getNumChannelsEPi(i3, i2) | 0) == 0;
 L1 : do if (i1 & (HEAP32[i2 >> 2] | 0) > 0) {
  i1 = 0;
  L3 : while (1) {
   HEAP32[i4 >> 2] = 0;
   do if (!(__ZN4FMOD12ChannelGroup10getChannelEiPPNS_7ChannelE(i3, i1, i4) | 0)) {
    HEAP8[i5 >> 0] = 0;
    if (!(__ZN4FMOD7Channel9isPlayingEPb(HEAP32[i4 >> 2] | 0, i5) | 0)) if (!(HEAP8[i5 >> 0] | 0)) break; else {
     i1 = 1;
     break L3;
    } else break;
   } while (0);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (HEAP32[i2 >> 2] | 0)) break L1;
  }
  STACKTOP = i6;
  return i1 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 0;
 L14 : do if (!(__ZN4FMOD12ChannelGroup12getNumGroupsEPi(i3, i4) | 0)) {
  L16 : do if ((HEAP32[i4 >> 2] | 0) > 0) {
   i1 = 0;
   while (1) {
    if (!(__ZN4FMOD12ChannelGroup8getGroupEiPPS0_(i3, i1, i5) | 0)) if (__ZN5audio5mixerL19IsAnyChannelPlayingEPN4FMOD12ChannelGroupE(HEAP32[i5 >> 2] | 0) | 0) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (HEAP32[i4 >> 2] | 0)) break L16;
   }
   i1 = 1;
   break L14;
  } while (0);
  i1 = 0;
 } else i1 = 0; while (0);
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN11UnityEngine9Analytics15UserCustomEventD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188456 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2 + 64 | 0, HEAP32[i2 + 68 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i2 + 48 | 0, HEAP32[i2 + 52 >> 2] | 0);
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function ___tre_mem_alloc_impl(i7, i1, i2, i9, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i4 = i7 + 16 | 0;
 L1 : do if (!(HEAP32[i4 >> 2] | 0)) {
  i10 = i7 + 12 | 0;
  i3 = HEAP32[i10 >> 2] | 0;
  do if (i3 >>> 0 < i8 >>> 0) {
   if (i1 | 0) if (!i2) {
    HEAP32[i4 >> 2] = 1;
    i1 = 0;
    break L1;
   } else {
    i5 = i7 + 8 | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i10 >> 2] = 1024;
    i4 = i2;
    i1 = i2;
    i3 = 1024;
    break;
   }
   i3 = i8 << 3;
   i3 = i3 >>> 0 > 1024 ? i3 : 1024;
   i5 = _malloc(8) | 0;
   if (!i5) {
    HEAP32[i4 >> 2] = 1;
    i1 = 0;
    break L1;
   }
   i1 = _malloc(i3) | 0;
   HEAP32[i5 >> 2] = i1;
   i6 = i1;
   if (!i1) {
    _free(i5);
    HEAP32[i4 >> 2] = 1;
    i1 = 0;
    break L1;
   }
   HEAP32[i5 + 4 >> 2] = 0;
   i2 = i7 + 4 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   if (i4 | 0) HEAP32[i4 + 4 >> 2] = i5;
   if (!(HEAP32[i7 >> 2] | 0)) HEAP32[i7 >> 2] = i5;
   HEAP32[i2 >> 2] = i5;
   i5 = i7 + 8 | 0;
   HEAP32[i5 >> 2] = i6;
   HEAP32[i10 >> 2] = i3;
   i4 = i6;
  } else {
   i5 = i7 + 8 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = i1;
  } while (0);
  i2 = i4 + i8 & 3;
  i2 = ((i2 | 0) == 0 ? 0 : 4 - i2 | 0) + i8 | 0;
  HEAP32[i5 >> 2] = i1 + i2;
  HEAP32[i10 >> 2] = i3 - i2;
  if (i9) _memset(i1 | 0, 0, i2 | 0) | 0;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_(i1, i2, i3) | 0;
 if ((_strcmp(HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) >= 0) return i5 | 0;
 i6 = i3;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i4;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i4 + 4 >> 2] = i6;
 if ((_strcmp(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) >= 0) {
  i10 = i5 + 1 | 0;
  return i10 | 0;
 }
 i9 = i2;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i3;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i2;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i3;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 if ((_strcmp(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) >= 0) {
  i10 = i5 + 2 | 0;
  return i10 | 0;
 }
 i9 = i1;
 i8 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = i2;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i10 + 4 >> 2] = i7;
 i10 = i2;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 i10 = i5 + 3 | 0;
 return i10 | 0;
}

function __ZN6prcoreL31inner_stretch_argb8888_bilinearEPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i5 = (HEAP32[i2 + 24 >> 2] | 0) >>> 8;
 i6 = 256 - i5 | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = i2 + 20 | 0;
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i13 = i3 >>> 16;
  i11 = i3 >>> 8 & 255;
  i9 = 256 - i11 | 0;
  i10 = HEAP32[i7 + (i13 << 2) >> 2] | 0;
  i14 = i13 + 1 | 0;
  i12 = HEAP32[i7 + (i14 << 2) >> 2] | 0;
  i13 = HEAP32[i8 + (i13 << 2) >> 2] | 0;
  i14 = HEAP32[i8 + (i14 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = (Math_imul(((Math_imul(i14 >>> 8 & 16711935, i11) | 0) + (Math_imul(i13 >>> 8 & 16711935, i9) | 0) | 0) >>> 8 & 16711935, i5) | 0) + (Math_imul(((Math_imul(i12 >>> 8 & 16711935, i11) | 0) + (Math_imul(i10 >>> 8 & 16711935, i9) | 0) | 0) >>> 8 & 16711935, i6) | 0) & -16711936 | ((Math_imul(((Math_imul(i14 & 16711935, i11) | 0) + (Math_imul(i13 & 16711935, i9) | 0) | 0) >>> 8 & 16711935, i5) | 0) + (Math_imul(((Math_imul(i12 & 16711935, i11) | 0) + (Math_imul(i10 & 16711935, i9) | 0) | 0) >>> 8 & 16711935, i6) | 0) | 0) >>> 8 & 16711935;
  if (!i1) break; else {
   i3 = (HEAP32[i4 >> 2] | 0) + i3 | 0;
   i2 = i2 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE15growAndPushBackERKS4_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i9 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = (i6 & 2147483647 | 0) == 0 ? 1 : i6 << 1;
 if (!i6) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 << 3, gb + 838004 | 0, 543) | 0;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i10 = i8;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  i12 = HEAP32[i7 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i7 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 >> 2] = i6;
 i12 = HEAP32[i7 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i7 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5Unity12PhysicsQuery14OverlapCapsuleERK8Vector3fS3_fi23QueryTriggerInteraction(i7, i8, i9, f10, i11, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i1 = i13;
 if ((HEAP16[gb + 1452644 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452644 | 0, i6);
  i1 = gb + 1452644 | 0;
 } else i1 = 0;
 i5 = i7 + 36 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i7 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = 128;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151304 + 8;
 HEAP32[i6 + 36 >> 2] = i5;
 __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(0, i8, i9, f10, i11, i12, i6);
 if (!i1) {
  STACKTOP = i13;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i13;
 return i5 | 0;
}

function __ZN24RingBufferMemoryFileData15NotifyWriteDoneEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = i2 + 28 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i11 = i2 + 32 | 0;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i11 = i2 + 98 | 0;
  HEAP8[i11 >> 0] = 1;
  return;
 }
 i6 = i2 + 52 | 0;
 i7 = i2 + 32 | 0;
 i8 = i2 + 64 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 + 1 | 0;
 i11 = i2 + 68 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i10 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i2 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i10;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i9 << 2) >> 2] = HEAP32[i7 >> 2];
 i11 = i2 + 48 | 0;
 HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + (HEAP32[i3 >> 2] | 0);
 i11 = i7;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i11 = i2 + 98 | 0;
 HEAP8[i11 >> 0] = 1;
 return;
}

function __ZN21DownloadHandlerBufferC2Ej(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187512 + 8;
 i6 = gb + 63808 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = i1 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 32 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i1 + 36 | 0;
 HEAP32[i6 >> 2] = 0;
 i1 = i1 + 24 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 >= i3 >>> 0) {
  STACKTOP = i7;
  return;
 }
 if ((i2 | 0) > -1) {
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i3, 1, i1, 0, gb + 1047584 | 0, 464) | 0;
  STACKTOP = i7;
  return;
 } else {
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i1, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i9 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i4 >> 2] = i9;
  STACKTOP = i7;
  return;
 }
}

function __ZN17RemapPPtrTransfer8TransferI13SplatDatabaseEEvRT_PKc17TransferMetaFlags(i10, i8, i1, i2) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = (i2 | 0) != 0;
 if (i9) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i10, i2);
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) {
  i7 = i10 + 16 | 0;
  i4 = i10 + 36 | 0;
  i5 = i10 + 40 | 0;
  do {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i2 >> 2] = i3;
   i1 = i1 + 44 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 i3 = HEAP32[i8 + 16 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i10 + 16 | 0;
  i5 = i10 + 36 | 0;
  i6 = i10 + 40 | 0;
  do {
   i2 = HEAP32[i4 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 if (!i9) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i10);
 return;
}

function __Z33RenderImageFilterValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 16 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7;
 i3 = i2;
 i6 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 316 >> 2] | 0;
 i12 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 316 >> 2] | 0;
 i8 = __Z14GetMonoManagerv() | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 i12 = i11;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i12 + 4 >> 2] = i3;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 if (__Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i10, i4, i9, 2, i5, i8) | 0) {
  i10 = i6;
  i12 = i3;
  i13 = i1;
  i11 = i13;
  HEAP32[i11 >> 2] = i10;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i7;
  return;
 };
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i12 = i2;
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i1;
 i11 = i13;
 HEAP32[i11 >> 2] = i10;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i7;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 4;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI11QuaternionfLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNK8VRDevice20GetScaledEyePullbackEPK6CamerafR8Vector3f(i1, i4, f2, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 f2 = Math_fround(f2 * Math_fround(.5));
 f2 = Math_fround(f2 / Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(__ZNK6Camera6GetFovEv(i4)) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)))));
 i5 = HEAP32[gb + 62512 >> 2] | 0;
 i3 = HEAP32[gb + 62512 + 4 >> 2] | 0;
 i1 = HEAP32[gb + 62512 + 8 >> 2] | 0;
 i4 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i4) i4 = i5; else {
  __ZNK9Transform18GetWorldScaleLossyEv(i6, i4);
  i4 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = HEAP32[i6 + 8 >> 2] | 0;
 }
 f10 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f9 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 f2 = Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i8 >> 2] = f10;
 HEAPF32[i8 + 4 >> 2] = f9;
 HEAPF32[i8 + 8 >> 2] = f2;
 STACKTOP = i7;
 return;
}

function __ZN7mecanim5human14GetMuscleRangeEPKNS0_5HumanEiRfS4_(i1, i8, i9, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 + 72 + (HEAP32[gb + 179672 + (i8 << 2) >> 2] << 2) >> 2] | 0;
 if ((i2 | 0) > -1) {
  i1 = i1 + 40 | 0;
  i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
  i7 = i1 + 4 | 0;
  i7 = HEAP32[i7 + (HEAP32[i7 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
  if ((i7 | 0) > -1) {
   i1 = i1 + 16 | 0;
   i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
   i2 = HEAP32[i1 + (i7 * 76 | 0) + 44 >> 2] | 0;
   i3 = HEAP32[i1 + (i7 * 76 | 0) + 48 >> 2] | 0;
   i4 = HEAP32[i1 + (i7 * 76 | 0) + 52 >> 2] | 0;
   i5 = HEAP32[i1 + (i7 * 76 | 0) + 56 >> 2] | 0;
   i6 = HEAP32[i1 + (i7 * 76 | 0) + 60 >> 2] | 0;
   i1 = HEAP32[i1 + (i7 * 76 | 0) + 64 >> 2] | 0;
  } else {
   i2 = 1065353216;
   i3 = 1065353216;
   i4 = 1065353216;
   i5 = -1082130432;
   i6 = -1082130432;
   i1 = -1082130432;
  }
 } else {
  i2 = 1065353216;
  i3 = 1065353216;
  i4 = 1065353216;
  i5 = -1082130432;
  i6 = -1082130432;
  i1 = -1082130432;
 }
 switch (HEAP32[gb + 183528 + (i8 << 2) >> 2] | 0) {
 case 0:
  {
   HEAP32[i9 >> 2] = i2;
   HEAP32[i10 >> 2] = i5;
   return;
  }
 case 1:
  {
   HEAP32[i9 >> 2] = i3;
   HEAP32[i10 >> 2] = i6;
   return;
  }
 case 2:
  {
   HEAP32[i9 >> 2] = i4;
   HEAP32[i10 >> 2] = i1;
   return;
  }
 default:
  return;
 }
}

function __ZN20TextRenderingPrivate8FontImpl16ResetPackingDataEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i1 = i7 + 148 | 0;
 i6 = i7 + 152 | 0;
 __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i6 >> 2] | 0);
 i8 = i7 + 160 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 i3 = HEAP32[i7 + 132 >> 2] | 0;
 i4 = i7 + 136 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -16 - i3 | 0) >>> 4) << 4);
 i3 = HEAP32[i7 + 156 >> 2] | 0;
 HEAP32[i2 >> 2] = 34;
 HEAP32[i2 + 4 >> 2] = i3;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 i2 = i3 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i6 >> 2] = i3;
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 if (!i2) i2 = i3; else {
  HEAP32[i1 >> 2] = i2;
  i2 = i3;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(i3, i2);
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i7 + 164 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN14PhysicsManager14OverlapCapsuleERK8Vector3fS2_fi23QueryTriggerInteraction(i7, i8, i9, f10, i11, i12) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i13 + 8 | 0;
 i1 = i13;
 if ((HEAP16[gb + 1452644 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452644 | 0, i6);
  i1 = gb + 1452644 | 0;
 } else i1 = 0;
 i5 = i7 + 772 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i7 + 776 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 i7 = HEAP32[i7 + 760 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 + 24 >> 2] = i7;
 HEAP32[i6 + 28 >> 2] = 128;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 151304 + 8;
 HEAP32[i6 + 36 >> 2] = i5;
 __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(0, i8, i9, f10, i11, i12, i6);
 if (!i1) {
  STACKTOP = i13;
  return i5 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i13;
 return i5 | 0;
}

function __ZN13BoxCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(168, i1, 16, gb + 1048932 | 0, 0, gb + 805207 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153816 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i4 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4 + 80 | 0) | 0;
 HEAP32[i4 >> 2] = gb + 153620 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11WindManager16ComputeWindForceERK4AABB(i7, i8, i16) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i16 = i16 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i17 = 0, i18 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i18;
 i10 = __Z14GetTimeManagerv() | 0;
 f9 = Math_fround(+HEAPF64[i10 + 96 >> 3] + +HEAPF64[i10 + 168 >> 3]);
 i10 = i7 + 4 | 0;
 i11 = i7 + 8 | 0;
 i12 = i7 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i8 | 0)) {
  STACKTOP = i18;
  return;
 }
 i13 = i17 + 4 | 0;
 i14 = i17 + 8 | 0;
 i15 = i17 + 12 | 0;
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 f5 = Math_fround(0.0);
 f6 = Math_fround(0.0);
 do {
  __ZNK8WindZone16ComputeWindForceERK4AABBf(i17, HEAP32[i1 + 8 >> 2] | 0, i16, f9);
  f3 = Math_fround(f3 + Math_fround(HEAPF32[i17 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i13 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i14 >> 2]));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i15 >> 2]));
  HEAPF32[i7 >> 2] = f3;
  HEAPF32[i10 >> 2] = f4;
  HEAPF32[i11 >> 2] = f5;
  HEAPF32[i12 >> 2] = f6;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i8 | 0));
 STACKTOP = i18;
 return;
}

function __ZN10Effector2D10EndContactEP9b2Contact(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = HEAP32[(HEAP32[i7 + 52 >> 2] | 0) + 60 >> 2] | 0;
 i1 = HEAP32[(HEAP32[(HEAP32[i7 + 48 >> 2] | 0) + 60 >> 2] | 0) + 156 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i5 = HEAP32[i1 + 36 >> 2] | 0;
  i2 = i1 + 48 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i4 = i5 + (i3 * 40 | 0) | 0;
   i1 = i5;
   while (1) {
    if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
    i1 = i1 + 40 | 0;
    if ((i1 | 0) == (i4 | 0)) break L1;
   }
   i4 = i3 + -1 | 0;
   HEAP32[i2 >> 2] = i4;
   i3 = i1;
   i1 = i5 + (i4 * 40 | 0) | 0;
   i2 = i3 + 40 | 0;
   do {
    HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i3 | 0) < (i2 | 0));
  }
 } while (0);
 i1 = HEAP32[i6 + 156 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = i1 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i4 = i5 + (i3 * 40 | 0) | 0;
 i1 = i5;
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i8 = 13;
   break;
  }
 }
 if ((i8 | 0) == 13) return;
 i8 = i3 + -1 | 0;
 HEAP32[i2 >> 2] = i8;
 i3 = i1;
 i1 = i5 + (i8 * 40 | 0) | 0;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZL25default_terminate_handlerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 32 | 0;
 i4 = i1 + 24 | 0;
 i8 = i1 + 16 | 0;
 i6 = i1;
 i5 = i1 + 36 | 0;
 i1 = ___cxa_get_globals_fast() | 0;
 if (i1 | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i1 = i3 + 48 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!((i2 & -256 | 0) == 1126902528 & (i1 | 0) == 1129074247)) {
    HEAP32[i4 >> 2] = HEAP32[gb + 216096 >> 2];
    _abort_message(gb + 1084935 | 0, i4);
   }
   if ((i2 | 0) == 1126902529 & (i1 | 0) == 1129074247) i1 = HEAP32[i3 + 44 >> 2] | 0; else i1 = i3 + 80 | 0;
   HEAP32[i5 >> 2] = i1;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   if (mftCall_iiii(HEAP32[(HEAP32[gb + 12984 >> 2] | 0) + 16 >> 2] | 0, gb + 12984 | 0, i4 | 0, i5 | 0) | 0) {
    i8 = HEAP32[i5 >> 2] | 0;
    i5 = HEAP32[gb + 216096 >> 2] | 0;
    i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0) | 0;
    HEAP32[i6 >> 2] = i5;
    HEAP32[i6 + 4 >> 2] = i1;
    HEAP32[i6 + 8 >> 2] = i8;
    _abort_message(gb + 1084849 | 0, i6);
   } else {
    HEAP32[i8 >> 2] = HEAP32[gb + 216096 >> 2];
    HEAP32[i8 + 4 >> 2] = i1;
    _abort_message(gb + 1084894 | 0, i8);
   }
  }
 }
 _abort_message(gb + 1084973 | 0, i7);
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN8Renderer16SetMaterialArrayERK13dynamic_arrayI4PPtrI8MaterialELj4EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i5 = i6 + 288 | 0;
 if ((i5 | 0) == (i1 | 0)) {
  i7 = i6 + 300 | 0;
  i8 = i6 + 218 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i6 = i6 & 65535;
  i7 = HEAP16[i8 >> 1] | 0;
  i5 = (i6 & 65535) < (i7 & 65535);
  i7 = i5 ? i6 : i7;
  HEAP16[i8 >> 1] = i7;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i6 + 300 | 0;
 i1 = HEAP32[i1 + 12 >> 2] << 2;
 i3 = i1 >> 2;
 HEAP32[i8 >> 2] = i3;
 i4 = i6 + 304 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((i2 & 2147483647) >>> 0 < i3 >>> 0) if ((i2 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i6 + 292 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 292 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
 i7 = i8;
 i8 = i6 + 218 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 & 65535;
 i7 = HEAP16[i8 >> 1] | 0;
 i5 = (i6 & 65535) < (i7 & 65535);
 i7 = i5 ? i6 : i7;
 HEAP16[i8 >> 1] = i7;
 return;
}

function __ZN8LODGroup6CreateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 if (!(HEAP8[i1 + 72 >> 0] | 0)) {
  i2 = 0;
  i3 = i1 + 68 | 0;
  HEAP32[i3 >> 2] = i2;
  __ZN8LODGroup23RegisterCachedRenderersEv(i1);
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[gb + 1161200 >> 2] | 0;
 i9 = i1 + 28 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0, i1 + 32 | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i9 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 i9 = f5 < Math_fround(0.0);
 f6 = Math_fround(-f5);
 f5 = i9 ? f6 : f5;
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i9 = f6 < Math_fround(0.0);
 f8 = Math_fround(-f6);
 f6 = i9 ? f8 : f6;
 f5 = f5 < f6 ? f6 : f5;
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = f6 < Math_fround(0.0);
 f8 = Math_fround(-f6);
 f6 = i2 ? f8 : f6;
 i2 = __ZN15LODGroupManager11AddLODGroupER8LODGroupRK8Vector3ff(i7, i1, i3, Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * (f5 < f6 ? f6 : f5))) | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = i2;
 __ZN8LODGroup23RegisterCachedRenderersEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN8LODGroup11SetFadeModeENS_11LODFadeModeE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 i2 = i3 + 48 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[i3 + 68 >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1161200 >> 2] | 0;
 i10 = i3 + 28 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0, i3 + 32 | 0);
 __ZNK9Transform18GetWorldScaleLossyEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i10 >> 2] | 0, gb + 28940 | 0) | 0);
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i10 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i10 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 i10 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i10 ? f9 : f8;
 f7 = f7 < f8 ? f8 : f7;
 f8 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i4 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i4 ? f9 : f8;
 __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff(i2, i1, i3, i5, Math_fround(Math_fround(HEAPF32[i3 + 44 >> 2]) * (f7 < f8 ? f8 : f7)));
 STACKTOP = i6;
 return;
}

function __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj(i1, i2, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE(i1, i2, i3) | 0;
 if (i4 | 0) if (_UNITY_FT_Get_Char_Index(i4, i5) | 0) {
  i6 = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP32[i2 + 12 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i2);
 HEAP32[i6 + 12 >> 2] = 0;
 i1 = __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE(i1, i6, i3) | 0;
 if (i1 | 0) if (_UNITY_FT_Get_Char_Index(i1, i5) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 64) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 6) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 6;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 4;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNK19CharacterController16GetGlobalExtentsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i10 = i3 + 4 | 0;
 i5 = i3;
 HEAPF32[i6 >> 2] = Math_fround(9.99999974e-06);
 __ZNK9Transform18GetWorldScaleLossyEv(i10, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f7 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i10 + 4 >> 2]));
 i11 = f7 < Math_fround(0.0);
 f4 = Math_fround(-f7);
 f7 = i11 ? f4 : f7;
 i11 = f7 < Math_fround(9.99999974e-06);
 f7 = i11 ? Math_fround(9.99999974e-06) : f7;
 f4 = Math_fround(HEAPF32[i10 >> 2]);
 i11 = f4 < Math_fround(0.0);
 f8 = Math_fround(-f4);
 f4 = i11 ? f8 : f4;
 f8 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 i10 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 f8 = i10 ? f9 : f8;
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 92 >> 2]) * (f4 < f8 ? f8 : f4));
 f7 = Math_fround(f7 - Math_fround(f4 * Math_fround(2.0)));
 HEAPF32[i5 >> 2] = f7;
 i2 = f7 < Math_fround(9.99999974e-06);
 i2 = HEAP32[(i2 ? i6 : i5) >> 2] | 0;
 i5 = f4 < Math_fround(9.99999974e-06);
 HEAPF32[i1 >> 2] = i5 ? Math_fround(9.99999974e-06) : f4;
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext19ProfileEventHandlerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 87160 + 8;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 40 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i3 = i5 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = i1 + (i2 * 20 | 0) | 0;
 if ((i2 | 0) > 0) do {
  i2 = HEAP32[i1 + 16 >> 2] | 0;
  if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (i2 | 0) {
    i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
   }
  }
  i1 = i1 + 20 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i6 = HEAP32[i5 + 32 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = i8 + 12 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) return;
 i10 = i7 + 12 | 0;
 i11 = i7 + 16 | 0;
 i12 = i7 + 4 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 do {
  i5 = HEAP32[i10 >> 2] | 0;
  i2 = i5 + 1 | 0;
  i3 = HEAP32[i11 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i2 >>> 0 > i4 >>> 0) {
   i1 = i3 << 1;
   i1 = (i1 | 0) == 0 ? 1 : i1;
   if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i11 >> 2] = i1;
    HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 6, 4, i12, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 4, i12, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i10 >> 2] << 6 | 0) | 0;
    HEAP32[i11 >> 2] = i1;
    HEAP32[i7 >> 2] = i4;
    break;
   }
  } while (0);
  HEAP32[i10 >> 2] = i2;
  i1 = (HEAP32[i7 >> 2] | 0) + (i5 << 6) | 0;
  i2 = i6;
  i3 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  i6 = i6 + 64 | 0;
 } while ((i6 | 0) != ((HEAP32[i8 >> 2] | 0) + (HEAP32[i9 >> 2] << 6) | 0));
 return;
}

function __ZN19SkinnedMeshRenderer19UnloadFromGfxDeviceEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 i3 = i4 + 348 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 256 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i4 + 468 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 472 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 508 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 304 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i4 = i7 + 84 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = HEAP32[i7 + 88 >> 2] | 0;
  if (i5) {
   i3 = 0;
   while (1) {
    i2 = HEAP32[i1 + (i3 * 36 | 0) >> 2] | 0;
    if (i2 | 0) if (HEAP32[i1 + (i3 * 36 | 0) + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + (i3 * 36 | 0) + 24 | 0);
    i1 = i3 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break;
    i3 = i1;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  i5 = HEAP32[i7 + 108 >> 2] | 0;
  HEAP32[i6 >> 2] = 57;
  HEAP32[i6 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i7 + 48 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i7 + 52 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 72 | 0);
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (!(HEAP32[i7 + 16 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7 + 36 | 0);
 STACKTOP = i8;
 return;
}

function __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 40 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i4 = i1 + 32 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 4 | 0;
 if (i7 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 4);
  i7 = HEAP32[i3 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  i7 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2);
  STACKTOP = i8;
  return;
 } else {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = i7;
  i7 = i6;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  i7 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2);
  STACKTOP = i8;
  return;
 }
}

function __Z40Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestP12Il2CppObjectRK8Vector3fP10RaycastHitf23QueryTriggerInteraction(i6, i1, i7, f8, i9) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 HEAP32[i7 + 40 >> 2] = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f5 * f5);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f4 * f4));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 HEAPF32[i10 >> 2] = Math_fround(f5 / f3);
 HEAPF32[i10 + 4 >> 2] = Math_fround(f4 / f3);
 HEAPF32[i10 + 8 >> 2] = Math_fround(f2 / f3);
 if (!i6) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 if (__ZN9Rigidbody9SweepTestERK8Vector3ff23QueryTriggerInteractionR10RaycastHit(i1, i10, f8, i9, i7) | 0) {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i7);
  i1 = 1;
 } else i1 = 0;
 i10 = i1;
 STACKTOP = i11;
 return i10 | 0;
}

function _UNITY_png_write_info_before_PLTE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((i5 | 0) == 0 | (i6 | 0) == 0) return;
 i7 = i5 + 204 | 0;
 if (HEAP32[i7 >> 2] & 1024 | 0) return;
 _UNITY_png_write_sig(i5);
 if (HEAP32[i7 >> 2] & 4096 | 0) {
  i1 = i5 + 596 | 0;
  if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 }
 i4 = HEAP32[i6 + 24 >> 2] | 0;
 i3 = i6 + 25 | 0;
 _UNITY_png_write_IHDR(i5, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i4 & 255, i4 >>> 8 & 255, i4 >>> 16 & 255, i4 >>> 24, 0);
 i4 = i6 + 114 | 0;
 i1 = HEAP16[i4 >> 1] | 0;
 if ((i1 & -32760) << 16 >> 16 == 8) if (HEAP32[i6 + 8 >> 2] & 1) {
  _UNITY_png_write_gAMA_fixed(i5, HEAP32[i6 + 40 >> 2] | 0);
  i1 = HEAP16[i4 >> 1] | 0;
 }
 i2 = i6 + 8 | 0;
 do if (i1 << 16 >> 16 >= 0) {
  i8 = HEAP32[i2 >> 2] | 0;
  i1 = (i8 & 2048 | 0) == 0;
  if (!(i8 & 4096)) {
   if (i1) break;
   _UNITY_png_write_sRGB(i5, HEAPU16[i6 + 112 >> 1] | 0);
   break;
  }
  if (!i1) _UNITY_png_app_warning(i5, gb + 354826 | 0);
  _UNITY_png_write_iCCP(i5, HEAP32[i6 + 116 >> 2] | 0, HEAP32[i6 + 120 >> 2] | 0);
 } while (0);
 if (HEAP32[i2 >> 2] & 2 | 0) _UNITY_png_write_sBIT(i5, i6 + 140 | 0, HEAPU8[i3 >> 0] | 0);
 if ((HEAP16[i4 >> 1] & -32752) << 16 >> 16 == 16) if (HEAP32[i2 >> 2] & 4 | 0) _UNITY_png_write_cHRM_fixed(i5, i6 + 44 | 0);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function _cpow(i11, i4, i2) {
 i11 = i11 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var d1 = 0.0, d3 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i14 + 80 | 0;
 i15 = i14 + 64 | 0;
 i16 = i14 + 48 | 0;
 i9 = i14 + 32 | 0;
 i12 = i14 + 16 | 0;
 i13 = i14;
 d8 = +HEAPF64[i2 >> 3];
 d7 = +HEAPF64[i2 + 8 >> 3];
 d5 = +HEAPF64[i4 + 8 >> 3];
 HEAPF64[i16 >> 3] = +HEAPF64[i4 >> 3];
 HEAPF64[i16 + 8 >> 3] = d5;
 HEAP32[i10 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i16 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i16 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i16 + 12 >> 2];
 _clog(i15, i10);
 d5 = +HEAPF64[i15 >> 3];
 d6 = +HEAPF64[i15 + 8 >> 3];
 d3 = d8 * d5 - d7 * d6;
 d1 = d7 * d5 + d8 * d6;
 if ((d3 != d3 | 0.0 != 0.0) & (d1 != d1 | 0.0 != 0.0)) {
  ___muldc3(i9 | 0, +d8, +d7, +d5, +d6);
  d3 = +HEAPF64[i9 >> 3];
  d1 = +HEAPF64[i9 + 8 >> 3];
 }
 HEAPF64[i13 >> 3] = d3;
 HEAPF64[i13 + 8 >> 3] = d1;
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
 HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
 _cexp(i12, i10);
 d8 = +HEAPF64[i12 + 8 >> 3];
 HEAPF64[i11 >> 3] = +HEAPF64[i12 >> 3];
 HEAPF64[i11 + 8 >> 3] = d8;
 STACKTOP = i14;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 24 | 0;
 i5 = i2 + 44 | 0;
 if ((HEAP32[i2 + 60 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i2 + 48 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 if ((HEAP32[i2 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + 28 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i6;
 return;
}

function __ZNKSt3__212ctype_bynameIwE5do_isEPKwS3_Pt(i1, i2, i5, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 8 | 0;
 i1 = i3;
 while (1) {
  if ((i2 | 0) == (i5 | 0)) break;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 < 128) HEAP16[i1 >> 1] = HEAP16[(__ZNSt3__25ctypeIcE13classic_tableEv() | 0) + (i3 << 1) >> 1] | 0; else {
   HEAP16[i1 >> 1] = 0;
   if (_iswspace_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 8192;
   if (_iswprint_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 16384;
   if (_iswcntrl_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 2;
   if (_iswupper_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 256;
   if (_iswlower_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 512;
   if (_iswalpha_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 1024;
   if (_iswdigit_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 2048;
   if (_iswpunct_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4;
   if (_iswxdigit_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4096;
   if (_iswblank_l(i3, HEAP32[i4 >> 2] | 0) | 0) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 1;
  }
  i2 = i2 + 4 | 0;
  i1 = i1 + 2 | 0;
 }
 return i5 | 0;
}

function __ZN5physx2Sc13ConstraintSimD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (HEAP8[i4 + 116 >> 0] & 1) __ZN5physx2Sc27ConstraintProjectionManager29removeFromPendingGroupUpdatesERNS0_13ConstraintSimE(HEAP32[(HEAP32[i4 + 96 >> 2] | 0) + 96 >> 2] | 0, i4);
 i1 = i4 + 104 | 0;
 if (!(HEAP32[i4 + 12 >> 2] | 0)) {
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 }
 i3 = i4 + 96 | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1228 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i5 = i2 + 280 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i5 = i2 + 292 | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i1;
  i1 = i2 + 284 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i5 + 1;
  if ((i5 | 0) >= ((HEAP32[i2 + 276 >> 2] | 0) * 50 | 0)) {
   __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2);
   HEAP32[i1 >> 2] = 0;
  }
 }
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 if (!i1) {
  i5 = i4 + 100 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i5 = i5 + 68 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 __ZN5physx2Sc5Scene25deallocateConstraintBlockEPvj(HEAP32[i3 >> 2] | 0, i1, HEAP32[i4 + 44 >> 2] | 0);
 i5 = i4 + 100 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = i5 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN5Light7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i7 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(64, i1, 16, gb + 1048932 | 0, 0, gb + 378151 | 0, 16) | 0;
 i9 = i1;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = i7;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 33788 + 8;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = -1;
 i2 = __ZnwjRK10MemLabelIdiPKci(344, i8, 16, gb + 374128 | 0, 17) | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15SharedLightDataC2E10MemLabelId(i2, i5);
 HEAP32[i4 + 44 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i9, i4, i1) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i6 >> 2] = i3;
  i1 = i5;
 }
 __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j(i4, i1);
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i2 = i1 + 16 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 >> 2] = i4;
  }
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i8;
 return;
}

function __ZN12NavMeshAgentC2ER10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 168776 + 8;
 HEAP32[i1 + 68 >> 2] = -1;
 HEAP32[i1 + 88 >> 2] = -1;
 HEAPF32[i1 + 36 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 40 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(3.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(120.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 60 >> 2] = Math_fround(8.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 100 >> 2] = 50;
 HEAP32[i1 + 92 >> 2] = 4;
 i3 = i1 + 107 | 0;
 HEAP8[i3 >> 0] = HEAP8[i3 >> 0] | 3;
 HEAP8[i1 + 104 >> 0] = 1;
 HEAP8[i1 + 105 >> 0] = 1;
 HEAP8[i1 + 106 >> 0] = 1;
 HEAP32[i1 + 96 >> 2] = -1;
 HEAP32[i1 + 72 >> 2] = 0;
 i3 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function _UNITY_ft_mem_realloc(i1, i4, i5, i6, i2, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 if ((i5 | i4 | i6 | 0) < 0) {
  i5 = 6;
  i6 = i2;
  HEAP32[i7 >> 2] = i5;
  return i6 | 0;
 }
 do if ((i4 | 0) == 0 | (i6 | 0) == 0) if (!i2) {
  i3 = 0;
  i1 = 0;
 } else {
  mftCall_vii(HEAP32[i1 + 8 >> 2] | 0, i1 | 0, i2 | 0);
  i3 = 0;
  i1 = 0;
 } else {
  if ((2147483647 / (i4 | 0) | 0 | 0) < (i6 | 0)) {
   i5 = 10;
   i6 = i2;
   HEAP32[i7 >> 2] = i5;
   return i6 | 0;
  }
  if (!((i5 | 0) == 0 & (i2 | 0) == 0)) {
   i3 = Math_imul(i5, i4) | 0;
   i8 = Math_imul(i6, i4) | 0;
   i1 = mftCall_iiiii(HEAP32[i1 + 12 >> 2] | 0, i1 | 0, i3 | 0, i8 | 0, i2 | 0) | 0;
   i8 = (i1 | 0) == 0;
   i3 = i8 ? 64 : 0;
   i1 = i8 ? i2 : i1;
   break;
  }
  i2 = Math_imul(i6, i4) | 0;
  if ((i2 | 0) <= 0) {
   i3 = i2 | 0 ? 6 : 0;
   i1 = 0;
   break;
  }
  i1 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  if (!i1) {
   i6 = 64;
   i8 = 0;
   HEAP32[i7 >> 2] = i6;
   return i8 | 0;
  } else {
   _memset(i1 | 0, 0, i2 | 0) | 0;
   i3 = 0;
   break;
  }
 } while (0);
 if (!((i6 | 0) > (i5 | 0) & (i3 | 0) == 0)) {
  i6 = i3;
  i8 = i1;
  HEAP32[i7 >> 2] = i6;
  return i8 | 0;
 }
 _memset(i1 + (Math_imul(i5, i4) | 0) | 0, 0, Math_imul(i6 - i5 | 0, i4) | 0) | 0;
 i6 = i3;
 i8 = i1;
 HEAP32[i7 >> 2] = i6;
 return i8 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 144; else i1 = (HEAP32[i1 >> 2] | 0) + 144 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 132; else i1 = (HEAP32[i1 >> 2] | 0) + 132 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 120; else i1 = (HEAP32[i1 >> 2] | 0) + 120 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 108; else i1 = (HEAP32[i1 >> 2] | 0) + 108 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN17RemapPPtrTransfer8TransferI24OcclusionCullingSettingsEEvRT_PKc17TransferMetaFlags(i9, i4, i1, i2) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = (i2 | 0) != 0;
 if (i8) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i9, i2);
 __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_(i4, i9);
 i2 = i4 + 28 | 0;
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i9 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 i6 = i9 + 40 | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 i2 = HEAP32[i4 + 44 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i4 = HEAP32[i4 + 64 >> 2] | 0;
 i3 = i1 + (i4 << 2) | 0;
 if (i4 | 0) do {
  i2 = HEAP32[i7 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i8) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i9);
 return;
}

function __ZNK13SplatDatabase15GetAlphaTextureEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = (HEAP32[i1 + 12 >> 2] | 0) + (i2 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9Heightmap12SetThicknessEf(i5, f3) {
 i5 = i5 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = i5 + 84 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f3) {
  STACKTOP = i6;
  return;
 }
 HEAPF32[i1 >> 2] = f3;
 i2 = i5 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i1 = i4 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 1;
  HEAPF32[i4 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i4 + 24 >> 2] = Math_fround(0.0);
  HEAP16[i4 + 28 >> 1] = 0;
  if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i5, i4) | 0) {
   i7 = __Z11GetIPhysicsv() | 0;
   HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 64 >> 2] | 0, i7 | 0, i4 | 0) | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
  }
 }
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 i4 = i5 + 64 | 0;
 i1 = i2;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = HEAP32[i7 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, 0);
  i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i6;
 return;
}

function __ZN9AudioClip18GetQueuedAudioDataEPPvj(i1, i4, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = i7 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = i1 + 124 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP32[i3 >> 2] = gb + 855193;
  __Z6FormatPKcz(i2, gb + 854751 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 854464 | 0, 693, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (((HEAP32[i3 + 12 >> 2] | 0) - i1 | 0) >>> 0 < i6 >>> 0) i1 = 0; else {
  _memcpy(HEAP32[i4 >> 2] | 0, i1 | 0, i6 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = i5 + i6 | 0;
  if (!i6) i1 = 1; else {
   i4 = i1 + 12 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   i3 = i1 - i2 | 0;
   if (!i3) i2 = i1; else {
    _memmove(i5 | 0, i2 | 0, i3 | 0) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   }
   i1 = i5 + i3 | 0;
   if ((i2 | 0) == (i1 | 0)) i1 = 1; else {
    HEAP32[i4 >> 2] = i1;
    i1 = 1;
   }
  }
 }
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx3Scb4Body14setWakeCounterEf(i5, f6) {
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = i5 + 228 | 0;
 HEAPF32[i3 >> 2] = f6;
 i2 = (HEAP32[i5 + 4 >> 2] | 0) >>> 30;
 switch (i2 | 0) {
 case 3:
  break;
 case 2:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i4 = 4;
   break;
  }
 default:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = 4;
  }
 }
 if ((i4 | 0) == 4) {
  if (f6 > Math_fround(0.0) & (i1 | 0) != 0) HEAP32[i5 + 232 >> 2] = 0;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i5 + 16 | 0, f6, 0);
  return;
 }
 if (!(f6 > Math_fround(0.0))) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i5);
  i5 = i5 + 236 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4194304;
  return;
 }
 switch (i2 | 0) {
 case 3:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = 12;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i5 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i4 = 11; else i4 = 12;
   break;
  }
 default:
  i4 = 11;
 }
 if ((i4 | 0) == 11) {
  HEAP32[i5 + 232 >> 2] = 0;
  HEAPF32[i3 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i5 + 16 | 0, f6, 1);
  return;
 } else if ((i4 | 0) == 12) {
  HEAP32[i5 + 232 >> 2] = 0;
  HEAPF32[i3 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i5);
  i5 = i5 + 236 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN4FMOD6SoundI13setLoopPointsEjjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 24 | 0;
 i9 = i10 + 16 | 0;
 i8 = i10 + 8 | 0;
 i6 = i10;
 switch (i3 | 0) {
 case 2:
  {
   HEAPF64[i1 + 328 >> 3] = +Math_fround(Math_fround(i2 >>> 0) / Math_fround(44100.0));
   break;
  }
 case 1:
  {
   HEAPF64[i1 + 328 >> 3] = +(i2 >>> 0) * .001;
   break;
  }
 default:
  {
   HEAP32[i6 >> 2] = gb + 854586;
   HEAP32[i6 + 4 >> 2] = 1476;
   _printf(gb + 854600 | 0, i6) | 0;
   HEAP32[i8 >> 2] = 37;
   HEAP32[i8 + 4 >> 2] = gb + 854586;
   _printf(gb + 853277 | 0, i8) | 0;
   i9 = 37;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 switch (i5 | 0) {
 case 2:
  {
   HEAPF64[i1 + 336 >> 3] = +Math_fround(Math_fround(i4 >>> 0) / Math_fround(44100.0));
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 case 1:
  {
   HEAPF64[i1 + 336 >> 3] = +(i4 >>> 0) * .001;
   i9 = 0;
   STACKTOP = i10;
   return i9 | 0;
  }
 default:
  {
   HEAP32[i9 >> 2] = gb + 854586;
   HEAP32[i9 + 4 >> 2] = 1488;
   _printf(gb + 854600 | 0, i9) | 0;
   HEAP32[i7 >> 2] = 37;
   HEAP32[i7 + 4 >> 2] = gb + 854586;
   _printf(gb + 853277 | 0, i7) | 0;
   i9 = 37;
   STACKTOP = i10;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEEEvRT_PKc17TransferMetaFlags(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = i3;
  i1 = i1 | 0 ? i1 - i2 | 0 : 0;
  HEAP32[i3 >> 2] = i1;
 } else i2 = i3;
 i5 = i1 + i2 | 0;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 i8 = i6 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i8 >> 2] = i3;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN10AudioMixer18EnsureValidRuntimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 76 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i4 = 1;
  return i4 | 0;
 }
 i3 = i1 + 72 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i3 >> 2] = i4;
  if (!i4) {
   i4 = 0;
   return i4 | 0;
  }
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
 i5 = __ZN5audio5mixer22CreateAudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorEib(i7, i6, i1 + 32 | 0, i5, (HEAP8[i1 + 100 >> 0] | 0) != 0) | 0;
 HEAP32[i2 >> 2] = i5;
 if (!i5) i1 = 0; else {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0);
  __ZN10AudioMixer14UpdateMuteSoloEv(i1);
  if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
   __ZN5audio5mixer12UpdateBypassERNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryE(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0);
   i1 = 1;
  } else i1 = 1;
 }
 if (!i4) {
  i7 = i1;
  return i7 | 0;
 }
 __Z19pop_allocation_rootv();
 i7 = i1;
 return i7 | 0;
}

function __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fPS2_i(i1, i3, i9, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 if ((i10 | 0) > 0) i1 = 0; else return;
 do {
  f18 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) >> 2]);
  f17 = Math_fround(f11 * f18);
  f14 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 4 >> 2]);
  f17 = Math_fround(f17 + Math_fround(f4 * f14));
  f16 = Math_fround(HEAPF32[i3 + (i1 * 12 | 0) + 8 >> 2]);
  f15 = Math_fround(Math_fround(Math_fround(f12 * f18) + Math_fround(f5 * f14)) + Math_fround(f8 * f16));
  f14 = Math_fround(Math_fround(Math_fround(f13 * f18) + Math_fround(f6 * f14)) + Math_fround(f2 * f16));
  HEAPF32[i9 + (i1 * 12 | 0) >> 2] = Math_fround(f17 + Math_fround(f7 * f16));
  HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2] = f15;
  HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2] = f14;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 return;
}

function __Z11WriteStringR13dynamic_arrayIiLj4EEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = _strlen(i3) | 0;
 i6 = i2 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = (i5 | 0) / 4 | 0;
 i9 = i8 + 1 | 0;
 i10 = i9 + i7 | 0;
 HEAP32[i6 >> 2] = i10;
 i11 = i2 + 16 | 0;
 i12 = HEAP32[i11 >> 2] | 0;
 i4 = i12 & 2147483647;
 do if (i4 >>> 0 < i10 >>> 0) {
  i1 = i12 << 1;
  i1 = i1 >>> 0 > i10 >>> 0 ? i1 : i10;
  if (i4 >>> 0 < i1 >>> 0) if ((i12 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i2 >> 2] = i12;
   break;
  }
 } while (0);
 if (i10 >>> 0 <= i7 >>> 0 | (i9 | 0) == 0) {
  i11 = HEAP32[i2 >> 2] | 0;
  i11 = i11 + (i7 << 2) | 0;
  i12 = i5 + 1 | 0;
  _memcpy(i11 | 0, i3 | 0, i12 | 0) | 0;
  return;
 }
 _memset((HEAP32[i2 >> 2] | 0) + (i7 << 2) | 0, 0, (i8 << 2) + 4 | 0) | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i11 = i11 + (i7 << 2) | 0;
 i12 = i5 + 1 | 0;
 _memcpy(i11 | 0, i3 | 0, i12 | 0) | 0;
 return;
}

function __ZN8Animator13AvatarDataSet5ResetEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i7 + 28 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i1 = i7 + 32 | 0; else {
  i6 = i7 + 32 | 0;
  __ZN7mecanim9animation21DestroyAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE(HEAP32[i7 >> 2] | 0, i6);
  HEAP8[i1 >> 0] = 0;
  i1 = i6;
 }
 i5 = i7 + 4 | 0;
 __ZN7mecanim9animation18DestroyAvatarInputEPNS0_11AvatarInputERNS_6memory9AllocatorE(HEAP32[i5 >> 2] | 0, i1);
 i6 = i7 + 8 | 0;
 __ZN7mecanim9animation19DestroyAvatarOutputEPNS0_12AvatarOutputERNS_6memory9AllocatorE(HEAP32[i6 >> 2] | 0, i1);
 i2 = i7 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = (i3 | 0) == 0;
 if (!(HEAP32[i7 + 24 >> 2] | 0)) {
  if (!i4) __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(i3, i1);
 } else if (!i4) __Z19free_alloc_internalPvRK10MemLabelId(i3, i7 + 36 | 0);
 i4 = i7 + 16 | 0;
 __ZN7mecanim9animation22DestroyAvatarWorkspaceEPNS0_15AvatarWorkspaceERNS_6memory9AllocatorE(HEAP32[i4 >> 2] | 0, i1);
 __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i7 + 20 >> 2] | 0, i1);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP16[i4 + 12 >> 1] = 0;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 96; else i1 = (HEAP32[i1 >> 2] | 0) + 96 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 84; else i1 = (HEAP32[i1 >> 2] | 0) + 84 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 72; else i1 = (HEAP32[i1 >> 2] | 0) + 72 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP32[i3 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i3 + 4 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 }
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i5, i2, HEAP32[gb + 37316 >> 2] | 0, i1, i3);
 i3 = i4 + 28 | 0;
 HEAP8[i4 + 24 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i5, gb + 1041885 | 0, gb + 1041885 | 0, i6 + 52 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI11DetailPatchEEvRT_PKc17TransferMetaFlags(i5, i4, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i5);
 i1 = HEAP32[i4 + 40 >> 2] | 0;
 if (i1 | 0) {
  i2 = i4 + 44 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
  STACKTOP = i6;
  return;
 }
 i1 = i4 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
 __ZdlPv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z26Texture2D_CUSTOM_GetPixelsP12Il2CppObjectiiiii(i4, i5, i6, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i1 = i10 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i11 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i11 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = Math_imul(i8, i7) | 0;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, i1) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi(i3, i5, i6, i7, i8, i9, i2, 0) | 0;
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __Z14CheckErrorGLESPK7ApiGLESPKcS3_l(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 8 | 0;
 i8 = i11;
 i4 = i1 + 84 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i10 = 1;
  STACKTOP = i11;
  return i10 | 0;
 } else {
  i1 = 1;
  i3 = 0;
 }
 L3 : while (1) {
  i2 = mftCall_i(i2 | 0) | 0;
  switch (i2 | 0) {
  case 0:
   {
    i10 = 13;
    break L3;
   }
  case 1283:
   {
    i1 = gb + 600646 | 0;
    break;
   }
  case 1280:
   {
    i1 = gb + 600994 | 0;
    break;
   }
  case 1281:
   {
    i1 = gb + 600946 | 0;
    break;
   }
  case 1282:
   {
    i1 = gb + 600889 | 0;
    break;
   }
  case 1285:
   {
    i1 = gb + 600829 | 0;
    break;
   }
  case 1286:
   {
    i1 = gb + 600738 | 0;
    break;
   }
  case 1284:
   {
    i1 = gb + 600691 | 0;
    break;
   }
  default:
   {
    HEAP32[i8 >> 2] = i2;
    _printf_console(gb + 600576 | 0, i8);
    i1 = gb + 600632 | 0;
   }
  }
  __Z7LogGLESPKcS0_S0_l(i5, i1, i6, i7);
  if ((i3 | 0) > 9) break;
  i1 = 0;
  i3 = i3 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 if ((i10 | 0) == 13) {
  STACKTOP = i11;
  return i1 | 0;
 }
 HEAP32[i9 >> 2] = 10;
 _printf_console(gb + 601038 | 0, i9);
 i10 = 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __GLOBAL__sub_I_runtime_imgui_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = gb + 63672 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[gb + 1468220 >> 2] = 0;
 HEAP32[gb + 1468220 + 4 >> 2] = 0;
 HEAP8[gb + 1468220 + 8 >> 0] = 0;
 i1 = gb + 1468220 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468220 + 20 >> 2] = 0;
 HEAP32[gb + 1468220 + 24 >> 2] = 0;
 HEAP8[gb + 1468220 + 28 >> 0] = 0;
 i1 = gb + 1468220 + 32 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468220 + 40 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468264 | 0, gb + 1017125 | 0, 2, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468276 | 0, gb + 1017137 | 0, 2, 0);
 HEAPF32[gb + 1468288 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1468288 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1468288 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1468288 + 12 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1468160 >> 2] = 0;
 HEAP32[gb + 1468164 >> 2] = 0;
 HEAP32[gb + 1468304 >> 2] = 0;
 HEAP32[gb + 1468304 + 4 >> 2] = 0;
 HEAP32[gb + 1468304 + 8 >> 2] = 0;
 HEAPF32[gb + 1100488 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1100496 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1099736 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1099736 + 4 >> 2] = Math_fround(0.0);
 return;
}

function __ZNSt3__212system_errorC2EiRKNS_14error_categoryE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 24 | 0;
 i7 = i5 + 16 | 0;
 i6 = i5;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i4 | 0, i7 | 0, i6 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i4 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i1 + 12 >> 2] = i3;
   STACKTOP = i5;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 ___resumeException(i1 | 0);
}

function __ZN5physx2Sc5Scene21saveLastCCDTransformsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 1204 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i6 = i2 + (i1 + -1 << 2) | 0;
 i5 = i2;
 i1 = i2 + 32 | 0;
 do {
  if (i1 >>> 0 <= i6 >>> 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   i9 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i8 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 511, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i8 = _i64Subtract(1, 0, i9 | 0, i8 | 0) | 0;
   i2 = _i64Add(i8 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  i9 = HEAP32[i5 >> 2] | 0;
  i8 = HEAP32[i9 + 128 >> 2] | 0;
  HEAP32[i9 + 96 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i9 + 100 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i9 + 104 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i9 + 108 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i9 + 112 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i9 + 116 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i9 + 120 >> 2] = HEAP32[i8 + 24 >> 2];
  i5 = i5 + 4 | 0;
 } while (i5 >>> 0 < i7 >>> 0);
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation24TryInitializeMemoryCacheEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 12 | 0;
 i2 = i6;
 i3 = i5 + 176 | 0;
 i4 = i3 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i3 >> 2] >> 0] = 0;
  HEAP32[i5 + 180 >> 2] = 0;
 } else {
  HEAP8[i3 >> 0] = 0;
  HEAP8[i4 >> 0] = 0;
 }
 __ZN10FileSystem21MountMemoryFileSystemEv(__Z13GetFileSystemv() | 0) | 0;
 i4 = i5 + 64 | 0;
 i3 = HEAP32[gb + 70824 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i3, _strlen(i3) | 0);
 __ZNK39AssetBundleLoadFromStreamAsyncOperation25CreateTempOutputDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i5, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i5 + 68 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP8[i5 + 76 >> 0] = 0;
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 272 | 0, i7);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 536 | 0, i7);
 i1 = i6 + 800 | 0;
 i8 = i7 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i7 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 804 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 808 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 i5 = i3 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i3 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i3 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i1 + 4 | 0);
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 & 2147483647) >>> 0 >= i1 >>> 0) {
  i7 = 0;
  i9 = HEAP32[i5 >> 2] | 0;
  _memcpy(i7 | 0, i4 | 0, i9 | 0) | 0;
  STACKTOP = i8;
  return;
 }
 if ((i2 | 0) > -1) {
  HEAP32[i6 >> 2] = i1;
  i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i1, 1, i7, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i7;
  i9 = HEAP32[i5 >> 2] | 0;
  _memcpy(i7 | 0, i4 | 0, i9 | 0) | 0;
  STACKTOP = i8;
  return;
 } else {
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i7, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i7 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i3 >> 2] = i7;
  i9 = HEAP32[i5 >> 2] | 0;
  _memcpy(i7 | 0, i4 | 0, i9 | 0) | 0;
  STACKTOP = i8;
  return;
 }
}

function __Z35Light_Set_Custom_PropShadowStrengthP12Il2CppObjectf(i5, f2) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, f4 = f0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i3 = i6 + 8 | 0;
 i7 = f2 < Math_fround(0.0);
 i8 = f2 > Math_fround(1.0);
 f4 = i8 ? Math_fround(1.0) : f2;
 f4 = i7 ? Math_fround(0.0) : f4;
 i7 = f4 != f4 | Math_fround(0.0) != Math_fround(0.0);
 f4 = i7 ? Math_fround(1.0) : f4;
 if (f4 != f2) {
  HEAPF64[i1 >> 3] = +f2;
  __Z6FormatPKcz(i3, gb + 540770 | 0, i1);
  if (!i5) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 540816 | 0, 166, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 if (!i5) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK5Light16UnshareLightDataEv(i1);
  HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 108 >> 2] = f4;
  STACKTOP = i6;
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 4;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector4fLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 16) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 4) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 4;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI5RectTIfELj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNK12TreeDatabase9Prototype21GetTreeInstanceMatrixER10Matrix4x4fRK8Vector3fRK12TreeInstance(i1, i7, i8, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 16 | 0;
 i10 = i11;
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * f6);
 HEAPF32[i9 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) * f5);
 HEAPF32[i9 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 52 >> 2]) * f6);
 if ((HEAP32[i1 + 4 >> 2] | 0) == 2) {
  f5 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(.5));
  f3 = Math_fround(+Math_sin(+f5));
  f5 = Math_fround(+Math_cos(+f5));
  f4 = Math_fround(f3 * Math_fround(HEAPF32[gb + 62536 >> 2]));
  f6 = Math_fround(f3 * Math_fround(HEAPF32[gb + 62536 + 4 >> 2]));
  f3 = Math_fround(f3 * Math_fround(HEAPF32[gb + 62536 + 8 >> 2]));
 } else {
  f3 = Math_fround(0.0);
  f4 = Math_fround(0.0);
  f5 = Math_fround(1.0);
  f6 = Math_fround(0.0);
 }
 HEAPF32[i10 + 12 >> 2] = f5;
 HEAPF32[i10 >> 2] = f4;
 HEAPF32[i10 + 4 >> 2] = f6;
 HEAPF32[i10 + 8 >> 2] = f3;
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i7, i8, i10, i9);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 12 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 755857 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i8) i7 = 0; else {
  i1 = i8 * 40 | 0;
  if (!i1) i7 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 721081 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7 + (i6 * 40 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i4 = i1;
   i5 = i2;
   i6 = i4 + 40 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   i1 = i1 + 40 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 40 | 0;
  }
 }
 i1 = i9 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i1 >> 2] = i8;
 return;
}

function __ZN5physx15PxGetGroupsMaskERKNS_7PxActorE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 48 | 0;
 i3 = i7 + 32 | 0;
 i4 = i7 + 16 | 0;
 i5 = i7;
 switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
 case 4:
 case 0:
 case 1:
  {
   HEAP32[i2 >> 2] = 0;
   mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0, 1, 0) | 0;
   i2 = HEAP32[i2 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i3 | 0, i2 | 0);
   i2 = HEAP32[i3 + 8 >> 2] | 0;
   i1 = HEAP32[i3 + 12 >> 2] | 0;
   break;
  }
 case 2:
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i4 | 0, i1 | 0);
   i2 = HEAP32[i4 + 8 >> 2] | 0;
   i1 = HEAP32[i4 + 12 >> 2] | 0;
   break;
  }
 case 5:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 432 >> 2] | 0, i5 | 0, i1 | 0);
   i2 = HEAP32[i5 + 8 >> 2] | 0;
   i1 = HEAP32[i5 + 12 >> 2] | 0;
   break;
  }
 default:
  {
   i2 = 0;
   i1 = 0;
  }
 }
 i5 = i6;
 i4 = i5;
 HEAP16[i4 >> 1] = 0;
 HEAP16[i4 + 2 >> 1] = 0 >>> 16;
 i5 = i5 + 4 | 0;
 HEAP16[i5 >> 1] = 0;
 HEAP16[i5 + 2 >> 1] = 0 >>> 16;
 HEAP16[i6 >> 1] = i2;
 HEAP16[i6 + 2 >> 1] = i2 >>> 16;
 HEAP16[i6 + 4 >> 1] = i1;
 HEAP16[i6 + 6 >> 1] = i1 >>> 16;
 STACKTOP = i7;
 return;
}

function __ZN5Image8SetImageEii13TextureFormatb(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i5 + 12 | 0;
 i6 = i5 + 8 | 0;
 i9 = Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
 i9 = (__Z25GetBytesFromTextureFormat13TextureFormat(HEAP32[i5 >> 2] | 0) | 0) + i9 | 0;
 i7 = i5 + 4 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z25GetBytesFromTextureFormat13TextureFormat(i3) | 0;
 i2 = Math_imul(HEAP32[i7 >> 2] | 0, i3) | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = (Math_imul(HEAP32[i6 >> 2] | 0, i2) | 0) + i3 | 0;
 if (((i9 | 0) >= (i3 | 0) | i4) & ((i9 | 0) == (i3 | 0) | i4 ^ 1)) return;
 i4 = i5 + 16 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63184 | 0);
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) < 9) i2 = 1; else i2 = (i3 | 0) == 1e3 | ((i3 | 0) == 23 | (i3 + -13 | 0) >>> 0 < 9);
 if (!((i3 | 0) > 0 & ((HEAP32[i7 >> 2] | 0) > 0 & (i1 | 0) > 0) & i2)) return;
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = __Z19GetMaxBytesPerPixel13TextureFormat(i3) | 0;
 i7 = Math_imul(i1, i7) | 0;
 i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 + i7 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
 _memset(i9 + i7 | 0, 0, i8 | 0) | 0;
 HEAP32[i4 >> 2] = i9;
 return;
}

function __ZN4FMOD6SoundI6unlockEPvS1_jj(i8, i9, i1, i4, i2) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 if ((i1 | 0) != 0 | (i2 | 0) != 0) {
  HEAP32[i3 >> 2] = 37;
  HEAP32[i3 + 4 >> 2] = gb + 1082369;
  _printf(gb + 853277 | 0, i3) | 0;
  i9 = 37;
  STACKTOP = i10;
  return i9 | 0;
 }
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1544) | 0;
 i5 = i8 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 << 2;
 i6 = (i4 >>> 0) / (i2 >>> 0) | 0;
 if ((i1 | 0) > 0) if (i2 >>> 0 <= i4 >>> 0) {
  i3 = 0;
  do {
   i4 = Math_imul(i3, i6) | 0;
   i2 = 0;
   do {
    HEAP32[i7 + (i2 + i4 << 2) >> 2] = HEAP32[i9 + ((Math_imul(i1, i2) | 0) + i3 << 2) >> 2];
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i6 >>> 0);
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 i3 = i8 + 320 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2) {
  _JS_Sound_ReleaseInstance(i2 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = _JS_Sound_Load_PCM(i1 | 0, i6 | 0, HEAP32[i8 + 40 >> 2] | 0, i7 | 0) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 64016 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i9, gb + 64016 | 0);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i1 = i6 + 16 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 20 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 28 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i7, i6 + 48 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags(i7, i6 + 68 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 return;
}

function __ZN14ParticleSystem12AddToManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i3 = i2 + 944 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) return;
 i6 = HEAP32[gb + 1451700 >> 2] | 0;
 i7 = i6 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i2;
 i10 = i8 + 1 | 0;
 i11 = i6 + 16 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i10 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i10;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i9;
 HEAP32[i3 >> 2] = i8;
 i11 = __ZNK14ParticleSystem27CalculateMaxActiveParticlesEv(i2) | 0;
 i11 = i11 >>> 0 > 5e4 ? 5e4 : i11;
 i10 = HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 2548 >> 2] | 0;
 __ZN23ParticleSystemParticles13array_reserveEj(HEAP32[i2 + 32 >> 2] | 0, (i10 >>> 0 < i11 >>> 0 ? i10 : i11) + 31 & -32);
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector2fLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayI8BitFieldLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function _UNITY_png_crc_finish(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 if (i1 | 0) if (!i6) do i1 = i1 - (i1 >>> 0 < 1024 ? i1 : 1024) | 0; while ((i1 | 0) != 0); else do {
  i3 = i1 >>> 0 < 1024 ? i1 : 1024;
  i1 = i1 - i3 | 0;
  _UNITY_png_read_data(i6, i4, i3);
  _UNITY_png_calculate_crc(i6, i4, i3);
 } while ((i1 | 0) != 0);
 i3 = i6 + 372 | 0;
 i1 = i6 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP32[i3 >> 2] & 536870912)) {
  HEAP32[i6 + 656 >> 2] = 129;
  _UNITY_png_read_data(i6, i4, 4);
  if (i2 & 2048 | 0) i5 = 8;
 } else {
  HEAP32[i6 + 656 >> 2] = 129;
  _UNITY_png_read_data(i6, i4, 4);
  if ((i2 & 768 | 0) == 768) i5 = 8;
 }
 if ((i5 | 0) == 8) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (((HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0) | 0) == (HEAP32[i6 + 408 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP32[i3 >> 2] & 536870912)) if (!(i1 & 1024)) _UNITY_png_chunk_error(i6, gb + 352413 | 0); else {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 } else if (!(i1 & 512)) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 } else _UNITY_png_chunk_error(i6, gb + 352413 | 0);
 return 0;
}

function __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = i4;
 if (((i2 - i4 | 0) / 12 | 0) >>> 0 >= i6 >>> 0) {
  HEAP32[i11 >> 2] = i3 + (i6 * 12 | 0);
  return;
 }
 i1 = HEAP32[i9 >> 2] | 0;
 i5 = ((i4 - i1 | 0) / 12 | 0) + i6 | 0;
 if (i5 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i1 = i3;
 } else {
  i8 = i1;
  i1 = i4;
 }
 i7 = i8;
 i4 = (i2 - i8 | 0) / 12 | 0;
 i2 = i4 << 1;
 i2 = i4 >>> 0 < 178956970 ? (i2 >>> 0 < i5 >>> 0 ? i5 : i2) : 357913941;
 if (!i2) i4 = 0; else i4 = __Znwj(i2 * 12 | 0) | 0;
 i1 = i4 + (((i1 - i8 | 0) / 12 | 0) * 12 | 0) | 0;
 i5 = i4 + (i2 * 12 | 0) | 0;
 i4 = i1 + (i6 * 12 | 0) | 0;
 if ((i3 | 0) != (i7 | 0)) while (1) {
  i2 = i1 + -12 | 0;
  i6 = i3;
  i3 = i3 + -12 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + -8 >> 2] = HEAP32[i6 + -8 >> 2];
  HEAP32[i1 + -4 >> 2] = HEAP32[i6 + -4 >> 2];
  if ((i3 | 0) == (i7 | 0)) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 HEAP32[i9 >> 2] = i1;
 HEAP32[i11 >> 2] = i4;
 HEAP32[i10 >> 2] = i5;
 if (!i8) return;
 __ZdlPv(i8);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwj(i2, i9, i3) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 __THREW__ = 0;
 i8 = invoke_ii(fb + 2806 | 0, i9 | 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i7);
 }
 i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 i3 = (i1 - i3 | 0) >>> 0 > i8 >>> 0 ? i3 + i8 | 0 : i1;
 i7 = i2 + (i3 << 2) | 0;
 i4 = i9 + (i8 << 2) | 0;
 i1 = i8 << 2 >> 2;
 L8 : do if (!i1) i1 = i7; else if ((i3 << 2 >> 2 | 0) < (i1 | 0)) i1 = i7; else {
  i6 = i2 + (i1 + -1 << 2) | 0;
  i5 = i4 + -4 | 0;
  i1 = i7;
  L11 : while (1) {
   while (1) {
    if ((i6 | 0) == (i1 | 0)) {
     i1 = i7;
     break L8;
    }
    i4 = i1 + -4 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
     i3 = i5;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i9 | 0)) break L8;
    i1 = i1 + -4 | 0;
    i3 = i3 + -4 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
     i1 = i4;
     continue L11;
    }
   }
  }
 } while (0);
 return ((i8 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 >> 2) | 0;
}

function __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i9 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i9 + 4 | 0;
 if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
  i6 = i2;
  i9 = HEAP32[i9 >> 2] | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = i6 + 1 | 0;
  HEAP32[i5 >> 2] = i7;
  i9 = i9 + (i6 << 2) | 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i1 = i2 + 1 & 65535;
 do if (!i1) {
  i3 = 0;
  i4 = 0;
 } else if (i1 >>> 0 < 5) {
  i3 = 4;
  i4 = i8 + 4 | 0;
  break;
 } else {
  i4 = i1 + -1 | 0;
  i4 = i4 >>> 1 | i4;
  i4 = i4 >>> 2 | i4;
  i4 = i4 >>> 4 | i4;
  i4 = i4 >>> 8 | i4;
  i4 = (i4 >>> 16 | i4) + 1 | 0;
  i3 = i4;
  i4 = __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj(HEAP32[i8 + 36 >> 2] | 0, i4) | 0;
  break;
 } while (0);
 i1 = HEAP32[i9 >> 2] | 0;
 if (i1 | 0) {
  _memcpy(i4 | 0, i1 | 0, i2 << 2 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) != (i8 + 4 | 0)) __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[i8 + 36 >> 2] | 0, i1, HEAP32[i6 >> 2] | 0);
 }
 HEAP32[i6 >> 2] = i3;
 HEAP32[i9 >> 2] = i4;
 i9 = HEAP32[i5 >> 2] | 0;
 i6 = i4;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = i9 + 1 | 0;
 HEAP32[i5 >> 2] = i7;
 i9 = i6 + (i9 << 2) | 0;
 HEAP32[i9 >> 2] = i8;
 return;
}

function __ZN26ProbeSetTetrahedralization8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 80 | 0;
 i4 = i3;
 i6 = HEAP32[gb + 37316 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378823 | 0, i6, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 378847 | 0, i4, 0);
 __ZN11Tetrahedron8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378836 | 0, i6, i1 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i5, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN17TransformInternal22CalculateTransformTypeE15TransformAccess(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 28 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + (i5 * 40 | 0) + 36 >> 2]);
 i5 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 ^ i5;
 i5 = (HEAP32[tempDoublePtr >> 2] = i5 ^ (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(0.0) & 1;
 i1 = ((Math_fround(Math_abs(Math_fround(f2 - f4))) > Math_fround(.0000999999974) | (Math_fround(Math_abs(Math_fround(f4 - f3))) > Math_fround(.0000999999974) ? 1 : Math_fround(Math_abs(Math_fround(f3 - f2))) > Math_fround(.0000999999974))) << 31 >> 31 >>> 31 | i5) ^ 1;
 return (i5 << 2 | 3) & ~(i1 << 1) & (i1 & ((Math_fround(Math_abs(Math_fround(f4 + Math_fround(-1.0)))) > Math_fround(.0000999999974) ? Math_fround(Math_abs(Math_fround(f3 + Math_fround(-1.0)))) > Math_fround(.0000999999974) : 0) & Math_fround(Math_abs(Math_fround(f2 + Math_fround(-1.0)))) > Math_fround(.0000999999974)) << 31 >> 31 >>> 31 | -2) | 0;
}

function __ZN11HaloManager7AddHaloEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) i1 = 1; else i1 = (HEAP32[i6 + -8 >> 2] | 0) + 1 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 i4 = i3 + 24 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP8[i3 + 25 >> 0] = 0;
 HEAP8[i3 + 26 >> 0] = 0;
 HEAP8[i3 + 27 >> 0] = -1;
 HEAPF32[i3 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 32 >> 2] = i1;
 HEAP32[i3 + 36 >> 2] = 1;
 if ((i6 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i2, i3);
  STACKTOP = i7;
  return i1 | 0;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  i6 = i6 + 24 | 0;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 40;
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__217__assoc_sub_state13set_exceptionESt13exception_ptr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i7 = i1 + 12 | 0;
 __ZNSt3__25mutex4lockEv(i7);
 i3 = i1 + 88 | 0;
 if (!(HEAP32[i3 >> 2] & 1)) {
  HEAP32[i5 >> 2] = 0;
  i8 = (HEAP32[i1 + 8 >> 2] | 0) == 0;
  __ZNSt13exception_ptrD2Ev(i5);
  if (i8) {
   __ZNSt13exception_ptraSERKS_(i1 + 8 | 0, i2) | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
   __ZNSt3__218condition_variable10notify_allEv(i1 + 40 | 0);
   __ZNSt3__25mutex6unlockEv(i7);
   STACKTOP = i4;
   return;
  }
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i6 >> 2] = 2;
 HEAP32[i6 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i5 | 0);
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  i1 = i8;
 } else {
  __THREW__ = 0;
  invoke_viii(fb + 1035 | 0, i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__25mutex6unlockEv(i7);
 ___resumeException(i1 | 0);
}

function __ZNK8Animator20IsInMatchTargetStateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!(HEAP8[i4 + 153 >> 0] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP32[i4 + 168 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP32[i4 + 108 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = i4 + 624 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(__ZNK26AnimatorControllerPlayable18ValidateLayerIndexEi(i2, 0) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i1 = 0;
  i2 = HEAP32[23] | 0;
 } else {
  i2 = HEAP32[i3 + 92 >> 2] | 0;
  i1 = i2;
 }
 i1 = i1 + 12 | 0;
 i2 = i2 + 4 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + i1 + (HEAP32[i2 + (HEAP32[i2 >> 2] | 0) >> 2] << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? 0 : i2 + i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 4 | 0;
 i1 = HEAP32[(__ZNK26AnimatorControllerPlayable21GetStateMachineMemoryEi(i3, 0) | 0) + 8 >> 2] | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + i2 + (i1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i1 + i2 | 0;
 i1 = HEAP32[i4 + 368 >> 2] | 0;
 if ((HEAP32[i2 + 32 >> 2] | 0) == (i1 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 if ((HEAP32[i2 + 28 >> 2] | 0) == (i1 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 i4 = (HEAP32[i2 + 24 >> 2] | 0) == (i1 | 0);
 return i4 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim25visualizeBroadPhaseBoundsERNS_2Cm12RenderOutputE(i1, i17) {
 i1 = i1 | 0;
 i17 = i17 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i18 = 0, i19 = 0;
 i18 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i16 = i18 + 32 | 0;
 i14 = i18;
 i15 = i1 + 360 | 0;
 if (!(HEAP32[i15 >> 2] | 0)) {
  STACKTOP = i18;
  return;
 }
 i7 = i1 + 356 | 0;
 i8 = i14 + 4 | 0;
 i9 = i16 + 4 | 0;
 i10 = i14 + 8 | 0;
 i11 = i16 + 8 | 0;
 i12 = i14 + 12 | 0;
 i1 = i16 + 12 | 0;
 i2 = i14 + 16 | 0;
 i3 = i16 + 16 | 0;
 i4 = i14 + 20 | 0;
 i5 = i16 + 20 | 0;
 i6 = i14 + 24 | 0;
 i13 = 0;
 do {
  i19 = HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i13 << 2) >> 2] | 0) + 44 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i19 >> 2] | 0) + 8 >> 2] | 0, i16 | 0, i19 | 0);
  i19 = __ZN5physx2Cm12RenderOutputlsEj(i17, -16776961) | 0;
  HEAP32[i14 >> 2] = HEAP32[i16 >> 2];
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP8[i6 >> 0] = 1;
  __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i19, i14) | 0;
  i13 = i13 + 1 | 0;
 } while (i13 >>> 0 < (HEAP32[i15 >> 2] | 0) >>> 0);
 STACKTOP = i18;
 return;
}

function __ZN14SubstanceValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN12b2MotorJoint15SetLinearOffsetERK6b2Vec2(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = i1 + 68 | 0;
 if (!(f7 != Math_fround(HEAPF32[i6 >> 2]))) {
  f7 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  if (!(f7 != Math_fround(HEAPF32[i1 + 72 >> 2]))) return;
 }
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAPU16[i3 >> 1] | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP16[i3 >> 1] = i4 & 65533;
  HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
  i4 = i2 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i4 & 2)) {
  HEAP16[i3 >> 1] = i4 | 2;
  HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i4 = i1 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i4 = i5;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 return;
}

function __ZN11AudioSource14SetMinDistanceEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = i7 + 4 | 0;
 HEAPF32[i6 >> 2] = f1;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i5 = f1 < Math_fround(0.0);
 i2 = HEAP32[(i5 ? i2 : i6) >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = i4 + 396 | 0;
 if (f1 != Math_fround(HEAPF32[i6 >> 2])) HEAP32[i6 >> 2] = i2;
 i3 = i4 + 456 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  __ZN20SoundChannelInstance19set3DMinMaxDistanceEff(i2, f1, Math_fround(HEAPF32[i4 + 400 >> 2])) | 0;
 }
 i2 = HEAP32[i4 + 432 >> 2] | 0;
 i5 = i4 + 428 | 0;
 i3 = i2;
 if ((i3 | 0) == (i5 | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i4 + 400 | 0;
 do {
  i2 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  f1 = Math_fround(HEAPF32[i6 >> 2]);
  __ZN20SoundChannelInstance19set3DMinMaxDistanceEff(i2, f1, Math_fround(HEAPF32[i4 >> 2])) | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i5 | 0));
 STACKTOP = i7;
 return;
}

function __Z31AudioFilterReadValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 16 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7;
 i3 = i2;
 i6 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i13 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 136 >> 2] | 0;
 i12 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i8 = __Z14GetMonoManagerv() | 0;
 HEAP32[i9 >> 2] = i13;
 HEAP32[i9 + 4 >> 2] = i12;
 i12 = i11;
 HEAP32[i12 >> 2] = i6;
 HEAP32[i12 + 4 >> 2] = i3;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 if (__Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i10, i4, i9, 2, i5, i8) | 0) {
  i10 = i6;
  i12 = i3;
  i13 = i1;
  i11 = i13;
  HEAP32[i11 >> 2] = i10;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i7;
  return;
 };
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i12 = i2;
 i10 = HEAP32[i12 >> 2] | 0;
 i12 = HEAP32[i12 + 4 >> 2] | 0;
 i13 = i1;
 i11 = i13;
 HEAP32[i11 >> 2] = i10;
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i12;
 STACKTOP = i7;
 return;
}

function _UNITY_FT_Face_GetVariantSelectors(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 if (!i8) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i1 = HEAP32[i8 + 40 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = HEAP32[i8 + 36 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 if ((i6 | 0) <= 0) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i6 = i5 + 4 | 0;
 L10 : while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  do if ((HEAP32[i4 + 8 >> 2] | 0) == 327680) {
   i2 = HEAP32[i4 >> 2] | 0;
   if (i2 | 0) {
    i2 = HEAP32[i2 + 96 >> 2] | 0;
    i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
    if (i3 | 0) {
     i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
     if (i2 | 0) if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i4 | 0, i5 | 0) | 0)) if ((HEAP32[i6 >> 2] | 0) == 14) break L10; else break;
    }
   }
  } while (0);
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i9 = 15;
   break;
  }
 }
 if ((i9 | 0) == 15) {
  STACKTOP = i10;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = mftCall_iii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, HEAP32[i8 + 100 >> 2] | 0) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZNK22NavMeshProjectSettings12GetAreaNamesEv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i6 >> 2] = 0;
 i9 = i6 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i10 = i6 + 8 | 0;
 i5 = 0;
 do {
  i2 = i7 + 28 + (i5 * 20 | 0) | 0;
  i4 = HEAP8[i2 + 11 >> 0] | 0;
  i3 = i4 << 24 >> 24 < 0;
  if (i3) i1 = HEAP32[i7 + 28 + (i5 * 20 | 0) + 4 >> 2] | 0; else i1 = i4 & 255;
  if (i1 | 0) {
   if (i3) {
    i2 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i7 + 28 + (i5 * 20 | 0) + 4 >> 2] | 0;
   } else i1 = i4 & 255;
   HEAP32[i8 >> 2] = 0;
   HEAP32[i8 + 4 >> 2] = 0;
   HEAP32[i8 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i2, i1);
   i1 = HEAP32[i9 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i10 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i6, i8); else {
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i8);
    HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 12;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 32);
 STACKTOP = i11;
 return;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 if (!(HEAP8[i6 + 57 >> 0] | 0)) i8 = 0; else i8 = 1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 i4 = i6 + 40 | 0;
 i2 = i1;
 L4 : do if ((i2 | 0) == (i4 | 0)) i5 = 7; else {
  i3 = i2;
  while (1) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (i2 >>> 0 <= i7 >>> 0) if ((i2 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) break L4;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
   if ((i3 | 0) == (i4 | 0)) {
    i5 = 7;
    break;
   }
  }
 } while (0);
 L10 : do if ((i5 | 0) == 7) {
  i1 = HEAP32[i6 + 52 >> 2] | 0;
  i4 = i6 + 48 | 0;
  i2 = i1;
  if ((i2 | 0) != (i4 | 0)) do {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i7 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) break L10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = (HEAP32[i7 + -8 >> 2] | 0) >>> 1;
  if (!i8) {
   i8 = i1;
   return i8 | 0;
  }
  i8 = i1;
  return i8 | 0;
 } while (0);
 i2 = i7 + -8 | 0;
 if (!(HEAP32[i2 >> 2] & 1)) i1 = 0; else i1 = HEAP32[i7 + -12 >> 2] | 0;
 i3 = (_tlsf_block_size(i2 + (0 - i1) | 0) | 0) + -8 | 0;
 if (!(HEAP32[i2 >> 2] & 1)) i1 = 0; else i1 = HEAP32[i7 + -12 >> 2] | 0;
 i1 = i3 - i1 | 0;
 if (!i8) {
  i8 = i1;
  return i8 | 0;
 }
 i8 = i1;
 return i8 | 0;
}

function __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i2, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 24 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0) + ((HEAP32[i4 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i1);
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation18CreateAvatarMemoryEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 140, 4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 1065353216;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i2 + 32 >> 2] = 1065353216;
 HEAP32[i2 + 36 >> 2] = 1065353216;
 i1 = i2 + 40 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 1065353216;
 HEAP32[i2 + 68 >> 2] = 1065353216;
 HEAP32[i2 + 72 >> 2] = 1065353216;
 HEAP32[i2 + 76 >> 2] = 1065353216;
 i1 = i2 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 1065353216;
 HEAP32[i2 + 108 >> 2] = 1065353216;
 HEAP32[i2 + 112 >> 2] = 1065353216;
 HEAP32[i2 + 116 >> 2] = 1065353216;
 HEAPF32[i2 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 132 >> 2] = Math_fround(.5);
 HEAP8[i2 + 136 >> 0] = 1;
 HEAP8[i2 + 137 >> 0] = 0;
 return i2 | 0;
}

function __ZN5physx2Cm17FreeListAllocator11findBestFitEjRj(i9, i1, i3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i1 >>> 5;
 i1 = HEAP32[i9 + 16 + (i2 << 2) >> 2] & -1 << (i1 & 31);
 do if (!i1) {
  i1 = HEAP32[i9 + 144 >> 2] & -1 << i2 + 1;
  if (i1 | 0) {
   i1 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
   i1 = HEAP32[gb + 90668 + (i1 << 2) >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i9 + 16 + (i1 << 2) >> 2] | 0;
   break;
  }
  HEAP32[i3 >> 2] = 65535;
  i9 = 0;
  return i9 | 0;
 } while (0);
 i8 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
 i8 = HEAP32[gb + 90668 + (i8 << 2) >> 2] | 0;
 i6 = i8 | i2 << 5;
 HEAP32[i3 >> 2] = i6;
 if ((i6 | 0) == 65535) {
  i9 = 0;
  return i9 | 0;
 }
 i3 = i9 + 148 + (i6 << 2) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1;
 i2 = i7 + 8 | 0;
 if (i1 | 0) HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = i5; else HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (HEAP32[i3 >> 2] | 0) {
  i9 = i7;
  return i9 | 0;
 }
 i1 = i6 >>> 5;
 i6 = i9 + 16 + (i1 << 2) | 0;
 i8 = HEAP32[i6 >> 2] & ~(1 << (i8 & 31));
 HEAP32[i6 >> 2] = i8;
 if (i8 | 0) {
  i9 = i7;
  return i9 | 0;
 }
 i9 = i9 + 144 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << i1);
 i9 = i7;
 return i9 | 0;
}

function __ZN17PersistentManager19UnloadMemoryStreamsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i5 + 16 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i5 + 4 | 0;
  i8 = i5 + 24 | 0;
  i9 = i5 + 40 | 0;
  i4 = 0;
  do {
   i1 = (HEAP32[i7 >> 2] | 0) + (i4 * 24 | 0) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   do if (i2 | 0) {
    if (!(HEAP8[i2 + 45 >> 0] | 0)) if (!(HEAP8[i2 + 46 >> 0] | 0)) break;
    __ZN14SerializedFile7ReleaseEv(i2);
    HEAP32[i1 >> 2] = 0;
    i2 = HEAP32[i8 >> 2] | 0;
    i1 = HEAP32[i2 + (i4 * 20 | 0) + 4 >> 2] | 0;
    i2 = i2 + (i4 * 20 | 0) + 8 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
    i2 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i2 + (i4 * 20 | 0) + 4 >> 2] | 0;
    i2 = i2 + (i4 * 20 | 0) + 8 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
   } while (0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i8 = i5 + 96 | 0;
 i9 = i5 + 100 | 0;
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i8, HEAP32[i9 >> 2] | 0);
 HEAP32[i5 + 108 >> 2] = 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i9 >> 2] = 0;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  HEAP16[i7 + 4 >> 1] = 15360;
  HEAP16[i7 + 6 >> 1] = 15360;
  if (!i1) break; else {
   i7 = i7 + 8 | 0;
   i6 = i6 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEbj(i6, i4, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0;
 i1 = i6 + 32 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[(HEAP32[i6 + 40 >> 2] | 0) + 19 >> 0] | 0)) {
  i2 = i6 + 36 | 0;
  if (!(HEAP8[(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0) + 64 >> 0] & 4)) {
   i7 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i5) | 0;
   __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj(i7, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0, i4, i3);
   HEAP8[i6 + 46 >> 0] = 0;
  }
 }
 i3 = i6 + 44 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 i1 = i5 + 42 | 0;
 i7 = (HEAP16[i1 >> 1] | 0) + -1 << 16 >> 16;
 HEAP16[i1 >> 1] = i7;
 i1 = i5 + 36 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = i4 & 65535;
 HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i5 + ((i7 & 65535) << 2) >> 2];
 if ((i4 & 65535) < (i7 & 65535)) HEAP16[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 44 >> 1] = i4;
 HEAP16[i3 >> 1] = -1;
 i7 = i6 + 8 | 0;
 i5 = i6 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i5 >> 2] | 0, i7);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i6 + 16 >> 2] | 0, i7);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i7);
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, HEAP32[gb + 37324 >> 2] | 0, i2, i4);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085989 | 0, i5, i2, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085998 | 0, i5, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1084342 | 0, i5, i2 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __ZN23ControllerContactFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE(i3, i4, i5, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i1 = i3 + 4 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!i5) {
  i5 = 2;
  STACKTOP = i6;
  return i5 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i5 | 0);
 i7 = HEAP32[i4 >> 2] & 255;
 i3 = HEAP32[i2 >> 2] & 255;
 i5 = __Z17GetPhysicsManagerv() | 0;
 i3 = __ZN14PhysicsManager18GetIgnoreCollisionEii(i5, i7, i3) | 0;
 L7 : do if (!(i3 | (__ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_(i5, i4, i2) | 0))) {
  i7 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0) + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i7 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  if (i1 | 0) do {
   if ((i1 | 0) == (i2 | 0)) break L7;
   i1 = HEAP32[i1 + 100 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i7 = 2;
  STACKTOP = i6;
  return i7 | 0;
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN15OverlapCallback14processTouchesEPKN5physx12PxOverlapHitEj(i1, i11, i12) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 i10 = i1 + 36 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = (HEAP32[i7 >> 2] | 0) - i8 | 0;
 i1 = i9 >> 2;
 i2 = i1 + i12 | 0;
 i3 = i6 + 8 | 0;
 if ((HEAP32[i3 >> 2] | 0) - i8 >> 2 >>> 0 < i2 >>> 0) {
  if (!i2) i5 = 0; else i5 = __Znwj(i2 << 2) | 0;
  i4 = i5 + (i1 << 2) | 0;
  i1 = i4 + (0 - i1 << 2) | 0;
  if ((i9 | 0) > 0) _memcpy(i1 | 0, i8 | 0, i9 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i3 >> 2] = i5 + (i2 << 2);
  if (i8 | 0) __ZdlPv(i8);
 }
 if (!i12) {
  STACKTOP = i14;
  return 1;
 }
 i1 = 0;
 do {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i11 + (i1 << 4) + 4 >> 2] | 0) + 8 >> 2] | 0;
  HEAP32[i13 >> 2] = i3;
  i4 = i2 + 4 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i2, i13); else {
   HEAP32[i5 >> 2] = i3;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 STACKTOP = i14;
 return 1;
}

function __ZN14FileCacherRead14LockCacheBlockEjPPhS1_(i6, i1, i7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = __ZN14FileCacherRead12RequestBlockEi(i6, i1) | 0;
 i10 = (i9 | 0) == 0 & 1;
 i4 = i1 + 1 | 0;
 i5 = i6 + 48 + (i10 * 40 | 0) | 0;
 if ((HEAP32[i6 + 48 + (i10 * 40 | 0) + 24 >> 2] | 0) != 1) {
  i1 = i6 + 24 + (i10 * 12 | 0) + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) {
   i2 = Math_imul(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0, i4) | 0;
   i3 = HEAP32[i6 + 8 >> 2] | 0;
   if (i3 >>> 0 > i2 >>> 0) {
    i3 = i3 - i2 | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0) | 0;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i6 + 12 | 0) | 0;
    HEAP32[i6 + 48 + (i10 * 40 | 0) + 12 >> 2] = HEAP32[i6 + 24 + (i10 * 12 | 0) >> 2];
    HEAP32[i6 + 48 + (i10 * 40 | 0) + 16 >> 2] = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
    HEAP32[i6 + 48 + (i10 * 40 | 0) + 20 >> 2] = Math_imul(HEAP32[i6 + 4 >> 2] | 0, i4) | 0;
    HEAP32[i1 >> 2] = i4;
    __Z16AsyncReadRequestP16AsyncReadCommand(i5);
   }
  }
 }
 HEAP32[i6 + 24 + (i9 * 12 | 0) + 8 >> 2] = 1;
 i10 = i6 + 24 + (i9 * 12 | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = (HEAP32[i10 >> 2] | 0) + (HEAP32[i6 + 48 + (i9 * 40 | 0) + 16 >> 2] | 0);
 return;
}

function __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 4) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i10 = i3 + (i1 << 4) | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z21ConvertImageToPNGFileRK14ImageReferenceRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 8 | 0;
 i9 = i7;
 i6 = i7 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 if (__Z23ConvertImageToPNGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EE(i1, i6) | 0) {
  __Z32TransferFileOverPlayerConnectionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvjS8_j(i2, HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
  i1 = __Z16WriteBytesToFilePKvjRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] | 0, i2) | 0;
 } else i1 = 0;
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __Z18ClearFilterExtentsP10CBBoxInt32(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 2147483647;
 HEAP32[i1 + 4 >> 2] = 2147483647;
 HEAP32[i1 + 8 >> 2] = 2147483647;
 HEAP32[i1 + 12 >> 2] = -2147483648;
 HEAP32[i1 + 16 >> 2] = -2147483648;
 HEAP32[i1 + 20 >> 2] = -2147483648;
 HEAP32[i1 + 24 >> 2] = 2147483647;
 HEAP32[i1 + 28 >> 2] = 2147483647;
 HEAP32[i1 + 32 >> 2] = 2147483647;
 HEAP32[i1 + 36 >> 2] = -2147483648;
 HEAP32[i1 + 40 >> 2] = -2147483648;
 HEAP32[i1 + 44 >> 2] = -2147483648;
 HEAP32[i1 + 48 >> 2] = 2147483647;
 HEAP32[i1 + 52 >> 2] = 2147483647;
 HEAP32[i1 + 56 >> 2] = 2147483647;
 HEAP32[i1 + 60 >> 2] = -2147483648;
 HEAP32[i1 + 64 >> 2] = -2147483648;
 HEAP32[i1 + 68 >> 2] = -2147483648;
 HEAP32[i1 + 72 >> 2] = 2147483647;
 HEAP32[i1 + 76 >> 2] = 2147483647;
 HEAP32[i1 + 80 >> 2] = 2147483647;
 HEAP32[i1 + 84 >> 2] = -2147483648;
 HEAP32[i1 + 88 >> 2] = -2147483648;
 HEAP32[i1 + 92 >> 2] = -2147483648;
 HEAP32[i1 + 96 >> 2] = 2147483647;
 HEAP32[i1 + 100 >> 2] = 2147483647;
 HEAP32[i1 + 104 >> 2] = 2147483647;
 HEAP32[i1 + 108 >> 2] = -2147483648;
 HEAP32[i1 + 112 >> 2] = -2147483648;
 HEAP32[i1 + 116 >> 2] = -2147483648;
 HEAP32[i1 + 120 >> 2] = 2147483647;
 HEAP32[i1 + 124 >> 2] = 2147483647;
 HEAP32[i1 + 128 >> 2] = 2147483647;
 HEAP32[i1 + 132 >> 2] = -2147483648;
 HEAP32[i1 + 136 >> 2] = -2147483648;
 HEAP32[i1 + 140 >> 2] = -2147483648;
 return;
}

function __ZNK9GfxDevice31CalculateDeviceProjectionMatrixER10Matrix4x4fbb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0;
 if (i3) return;
 if (i4) {
  i4 = i2 + 4 | 0;
  HEAPF32[i4 >> 2] = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
  i4 = i2 + 20 | 0;
  HEAPF32[i4 >> 2] = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
  i4 = i2 + 36 | 0;
  HEAPF32[i4 >> 2] = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
  i4 = i2 + 52 | 0;
  HEAPF32[i4 >> 2] = Math_fround(-Math_fround(HEAPF32[i4 >> 2]));
 }
 i3 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 105 >> 0] | 0) != 0;
 i4 = i2 + 8 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = i3 ? Math_fround(-.5) : Math_fround(.5);
 f6 = Math_fround(f6 * f5);
 HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(.5)));
 i4 = i2 + 24 | 0;
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i2 + 28 >> 2]) * Math_fround(.5)));
 i4 = i2 + 40 | 0;
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(Math_fround(HEAPF32[i2 + 44 >> 2]) * Math_fround(.5)));
 i4 = i2 + 56 | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i2 + 60 >> 2]) * Math_fround(.5)));
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE15growAndPushBackERKS3_(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i5 = i9 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = (i6 & 2147483647 | 0) == 0 ? 1 : i6 << 1;
 if (!i6) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 << 3, gb + 838004 | 0, 543) | 0;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i1 << 3) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i12 = i2;
   i11 = HEAP32[i12 + 4 >> 2] | 0;
   i10 = i1;
   HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
   HEAP32[i10 + 4 >> 2] = i11;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i10 = i8;
 i11 = HEAP32[i10 + 4 >> 2] | 0;
 i12 = i4 + (i1 << 3) | 0;
 HEAP32[i12 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i12 + 4 >> 2] = i11;
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  i12 = HEAP32[i7 >> 2] | 0;
  i11 = i12 + 1 | 0;
  HEAP32[i7 >> 2] = i11;
  i12 = i4 + (i12 << 3) | 0;
  return i12 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 >> 2] = i6;
 i12 = HEAP32[i7 >> 2] | 0;
 i11 = i12 + 1 | 0;
 HEAP32[i7 >> 2] = i11;
 i12 = i4 + (i12 << 3) | 0;
 return i12 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 24 | 0;
 i8 = i9 + 12 | 0;
 i6 = i9;
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 mftCall_vii(HEAP32[i2 + 16 >> 2] | 0, i8 | 0, HEAP32[i5 + 8 >> 2] | 0);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i4, i6) | 0;
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, HEAP32[i4 + 20 >> 2] | 0);
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc5Scene14postBroadPhaseEPNS_10PxBaseTaskE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i6 + 1204 | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0;
 _memset(HEAP32[i4 + 5912 >> 2] | 0, 0, HEAP32[i4 + 5916 >> 2] << 2 | 0) | 0;
 i4 = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 i1 = HEAP32[i4 + 49848 >> 2] | 0;
 i5 = i6 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj(HEAP32[i5 >> 2] | 0, HEAP32[i4 + 49832 >> 2] | 0, HEAP32[i4 + 49836 >> 2] | 0, 0);
 __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv(i4);
 if (!i1) {
  __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i4);
  __ZN5physx2Sc5Scene21processLostTouchPairsEv(i6);
  i6 = HEAP32[i3 >> 2] | 0;
  i6 = i6 + 1e3 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  __ZN5physx10PxsContext19resetThreadContextsEv(i6);
  return;
 }
 i2 = HEAP32[i4 + 49844 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j(HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 0);
  if (!i1) break; else i2 = i2 + 8 | 0;
 }
 __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i4);
 __ZN5physx2Sc5Scene21processLostTouchPairsEv(i6);
 i6 = HEAP32[i3 >> 2] | 0;
 i6 = i6 + 1e3 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 __ZN5physx10PxsContext19resetThreadContextsEv(i6);
 return;
}

function __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(i7, i8, i9, i10, i5) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = i7 + 424 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i10 | 0)) {
  __ZN7ApiGLES17ActiveTextureUnitEj(HEAP32[gb + 1451080 >> 2] | 0, i10);
  HEAP32[i1 >> 2] = i10;
 }
 i6 = i7 + 32 + (i10 * 12 | 0) | 0;
 i4 = i7 + 32 + (i10 * 12 | 0) + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) != (i5 | 0)) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) {
  if ((i5 | 0) < 4) {
   i1 = i7 + 428 + (i5 << 2) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) {
    i3 = __ZN7ApiGLES13CreateSamplerE17TextureFilterMode15TextureWrapModei(HEAP32[i7 >> 2] | 0, (i5 | 2 | 0) != 2 & 1, (i5 | 1 | 0) == 1 & 1, 0) | 0;
    HEAP32[i1 >> 2] = i3;
    i2 = i7;
    i1 = i3;
   } else {
    i2 = i7;
    i1 = i3;
   }
   __ZN7ApiGLES11BindSamplerEij(HEAP32[i2 >> 2] | 0, i10, i1);
  } else __ZN7ApiGLES11BindSamplerEij(HEAP32[i7 >> 2] | 0, i10, 0);
  HEAP32[i4 >> 2] = i5;
 }
 i1 = i7 + 416 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > i10 >>> 0) {
  if ((HEAP32[i6 >> 2] | 0) == (i8 | 0)) return;
 } else HEAP32[i1 >> 2] = i10 + 1;
 __ZN7ApiGLES11BindTextureEj16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, i8, i9);
 HEAP32[i6 >> 2] = i8;
 HEAP32[i7 + 32 + (i10 * 12 | 0) + 8 >> 2] = i9;
 return;
}

function __ZN21ComponentRequirements13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1162544 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1162544 >> 2] = 0;
 i1 = HEAP32[gb + 1162548 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1162548 >> 2] = 0;
 i1 = HEAP32[gb + 1162552 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1162552 >> 2] = 0;
 i1 = HEAP32[gb + 1162556 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
  HEAP32[gb + 1162556 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1162556 >> 2] = 0;
 return;
}

function __ZN11ForceModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 536 | 0, i4);
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i5 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i1 = HEAP8[i6 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i6 >> 0] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 HEAP8[i3 + 800 >> 0] = i1;
 i1 = i3 + 801 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 1);
  i7 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 } else {
  i5 = HEAP8[i2 >> 0] | 0;
  HEAP8[i6 >> 0] = i5;
  HEAP32[i7 >> 2] = i3;
  i7 = i5;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 }
}

function __Z39TextGenerator_CUSTOM_GetCharactersArrayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = i1 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 if (!(HEAP8[i1 + 60 >> 0] | 0)) i2 = 0; else i2 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z32GetTextRenderingScriptingClassesv() | 0) + 16 >> 2] | 0, 12, i2) | 0;
 if (!i2) {
  STACKTOP = i7;
  return i4 | 0;
 } else i1 = 0;
 while (1) {
  i3 = HEAP32[i5 >> 2] | 0;
  if (!i3) {
   i1 = 9;
   break;
  }
  i8 = HEAP32[i3 + 20 >> 2] | 0;
  i10 = HEAP32[i8 + (i1 * 12 | 0) >> 2] | 0;
  i9 = HEAP32[i8 + (i1 * 12 | 0) + 4 >> 2] | 0;
  i8 = HEAP32[i8 + (i1 * 12 | 0) + 8 >> 2] | 0;
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 12) | 0;
  HEAP32[i3 >> 2] = i10;
  HEAP32[i3 + 4 >> 2] = i9;
  HEAP32[i3 + 8 >> 2] = i8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  STACKTOP = i7;
  return i4 | 0;
 } else if ((i1 | 0) == 9) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 return 0;
}

function __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffness10updateNodeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, gb + 765177 | 0) | 0) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
  mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, gb + 765177 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, gb + 765184 | 0);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, i3 | 0);
  mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, gb + 765194 | 0) | 0)) return;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, gb + 765194 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, gb + 765211 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i3 | 0);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE7reserveEj(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = i9 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = i6;
 if ((((HEAP32[i10 >> 2] | 0) - i6 | 0) / 28 | 0) >>> 0 >= i4 >>> 0) return;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 28 | 0) | 0;
 i2 = i5 + (((i2 - i6 | 0) / 28 | 0) * 28 | 0) | 0;
 i8 = i2;
 i7 = i5 + (i4 * 28 | 0) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i8;
  i5 = i6;
 } else {
  i4 = i8;
  do {
   i6 = i3;
   i3 = i3 + -28 | 0;
   i13 = i3;
   i12 = HEAP32[i13 + 4 >> 2] | 0;
   i5 = i2 + -28 | 0;
   HEAP32[i5 >> 2] = HEAP32[i13 >> 2];
   HEAP32[i5 + 4 >> 2] = i12;
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + -20 | 0, i6 + -20 | 0);
   i2 = i4 + -28 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i7;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -28 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZN20SoundChannelInstance11set3DSpreadEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
 HEAPF32[i1 + 68 >> 2] = f2;
 i1 = i1 + 146 | 0;
 HEAP16[i1 >> 1] = (i7 & 1) << 10 & 65535 | HEAP16[i1 >> 1] & -1025;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = f2 < Math_fround(0.0);
 i9 = f2 > Math_fround(360.0);
 f2 = i9 ? Math_fround(360.0) : f2;
 i1 = __ZN4FMOD7Channel11set3DSpreadEf(i3, i1 ? Math_fround(0.0) : f2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 240;
 HEAP32[i5 + 8 >> 2] = gb + 866303;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN11TimeManager13StepFixedTimeEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, i6 = 0;
 d3 = +HEAPF64[i5 + 32 >> 3];
 d4 = d3 + +Math_fround(HEAPF32[i5 + 48 >> 2]);
 i6 = i5 + 130 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 do if (d4 > +HEAPF64[i5 + 64 >> 3]) {
  if (i2 << 24 >> 24) {
   HEAPF64[i5 + 40 >> 3] = d3;
   i1 = i5 + 32 | 0;
   break;
  }
  i6 = i5 + 96 | 0;
  i2 = i5 + 64 | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP8[i5 + 193 >> 0] = 0;
  i6 = 0;
  return i6 | 0;
 } else {
  i1 = i5 + 32 | 0;
  HEAPF64[i5 + 40 >> 3] = d3;
  if (!(i2 << 24 >> 24)) HEAPF64[i1 >> 3] = d4;
 } while (0);
 i2 = i5 + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i5 + 193 >> 0] = 1;
 HEAP8[i6 >> 0] = 0;
 i6 = 1;
 return i6 | 0;
}

function __Z47Texture2D_CUSTOM_INTERNAL_CALL_GetPixelBilinearP12Il2CppObjectffR10ColorRGBAf(i4, f5, f6, i7) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 24 | 0;
 i8 = i9 + 8 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i10 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture2D16GetPixelBilinearEiff(i8, i1, 0, f5, f6);
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = HEAP32[i8 + 8 >> 2] | 0;
  i10 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = i3;
  HEAP32[i7 + 8 >> 2] = i4;
  HEAP32[i7 + 12 >> 2] = i10;
  STACKTOP = i9;
  return;
 }
}

function __Z42InvalidateStateHashesOnMaterialsWithShaderP6Shader(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i2 = i9;
 i8 = i9 + 16 | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i8 >> 2] = 0;
 i5 = i8 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i8 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i8 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 30792 | 0, i8, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 if (i5 | 0) {
  i4 = i3 + 4 | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = 0;
  do {
   i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if ((HEAP32[i1 + 32 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) {
    i1 = HEAP32[i1 + 100 >> 2] | 0;
    if (i1 | 0) {
     i1 = i1 + 164 | 0;
     HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 2;
    }
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i5 >>> 0);
 }
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 >> 2] | 0, i7);
  HEAP32[i8 >> 2] = 0;
 }
 STACKTOP = i9;
 return;
}

function __Z41TerrainData_Get_Custom_PropTreePrototypesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = i2 + 88 | 0;
 i6 = HEAP32[(__Z26GetTerrainScriptingClassesv() | 0) + 24 >> 2] | 0;
 i3 = i5 + 4 | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i6, 4, (HEAP32[i3 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 3) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i8;
  return i4 | 0;
 }
 i2 = 0;
 do {
  __Z19TreePrototypeToMonoRK13TreePrototypeR17MonoTreePrototype(i1 + (i2 << 3) | 0, i7);
  i9 = _il2cpp_object_new(i6 | 0) | 0;
  i12 = i7;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i10 = i9 + 8 | 0;
  HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i10 + 4 >> 2] = i11;
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i2, i9);
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) - i1 >> 3 >>> 0);
 STACKTOP = i8;
 return i4 | 0;
}

function __Z35CubemapArray_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 16 | 0;
 i10 = i8;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 1244) | 0;
 i13 = gb + 63520 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN12CubemapArrayC2E10MemLabelId18ObjectCreationMode(i3, i9, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 if (__ZN12CubemapArray11InitTextureEiii13TextureFormatb(i3, i2, i2, i4, i5, i6 << 24 >> 24 != 0) | 0) {
  __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace(i3, i7 << 24 >> 24 == 0 & 1);
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  STACKTOP = i8;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570952 | 0, i8 + 8 | 0);
}

function __ZNSt3__212system_errorC2ENS_10error_codeEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, _strlen(i3) | 0);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i4 | 0, i2 | 0, i6 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i4 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   i3 = i2;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = i4;
   STACKTOP = i5;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 ___resumeException(i1 | 0);
}

function __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4ERKS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4 + 4 + 20 | 0;
 i7 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 i9 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i9;
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i4 + 8 >> 2] = i7;
 i8 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i10;
 HEAP32[i4 + 20 >> 2] = i7;
 i5 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i4 + 24 >> 2] = i9;
 HEAP32[i4 + 28 >> 2] = i5;
 HEAP32[i4 + 32 >> 2] = i7;
 HEAP32[i4 + 36 >> 2] = i8;
 HEAP32[i4 + 40 >> 2] = i5;
 HEAP32[i4 + 44 >> 2] = i7;
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i4 + 48 >> 2] = i9;
 HEAP32[i4 + 52 >> 2] = i10;
 HEAP32[i4 + 56 >> 2] = i7;
 HEAP32[i4 + 60 >> 2] = i8;
 HEAP32[i4 + 64 >> 2] = i10;
 HEAP32[i4 + 68 >> 2] = i7;
 HEAP32[i4 + 72 >> 2] = i9;
 HEAP32[i4 + 76 >> 2] = i5;
 HEAP32[i4 + 80 >> 2] = i7;
 HEAP32[i4 + 84 >> 2] = i8;
 HEAP32[i4 + 88 >> 2] = i5;
 HEAP32[i4 + 92 >> 2] = i7;
 __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector3Ei(i1, i2, i4, 8);
 STACKTOP = i6;
 return;
}

function __ZN18UnityPropertySheet11UnityTexEnv8TransferI14SafeBinaryReadEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = i4 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 944580 | 0, gb + 944590 | 0, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i3 = HEAP32[gb + 37320 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932253 | 0, i3, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i4, i6); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i4 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 800947 | 0, i3, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i6); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN16LightmapSettings15RemoveLightmapsEi(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i2 = i9 + 56 | 0;
 i7 = __Z14FindSceneIndexRK13dynamic_arrayI10SceneRangeLj4EEi(i2, i1) | 0;
 if ((i7 | 0) == -1) {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i4 + (i7 * 28 | 0) + 20 >> 2] | 0;
 i4 = HEAP32[i4 + (i7 * 28 | 0) + 24 >> 2] | 0;
 i6 = HEAP32[i9 + 36 >> 2] | 0;
 i5 = i6 + (i3 << 3) | 0;
 i10 = i5 + (i4 << 3) | 0;
 i1 = i9 + 48 | 0;
 _memmove(i5 | 0, i10 | 0, i6 + (HEAP32[i1 >> 2] << 3) - i10 | 0) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) - (i4 << 3 >> 3);
 i1 = HEAP32[i2 >> 2] | 0;
 i10 = i1 + (i7 * 28 | 0) | 0;
 i6 = i10 + 28 | 0;
 i5 = i9 + 68 | 0;
 _memmove(i10 | 0, i6 | 0, i1 + ((HEAP32[i5 >> 2] | 0) * 28 | 0) - i6 | 0) | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (i7 >>> 0 < i6 >>> 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = i7;
  do {
   i10 = i2 + (i1 * 28 | 0) + 20 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) - i4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i6 >>> 0);
 }
 __ZN16LightmapSettings7RebuildEv(i9);
 if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) {
  HEAP32[i8 >> 2] = -1;
  HEAP32[i8 + 4 >> 2] = 0;
  return;
 } else {
  HEAP32[i8 >> 2] = i4 + i3;
  HEAP32[i8 + 4 >> 2] = 0 - i4;
  return;
 }
}

function __ZN13MemoryManager13ThreadCleanupEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i8 + 1544 | 0;
 if ((HEAP32[i7 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i2 = HEAP32[i8 + 1568 + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0);
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } while ((i1 | 0) < (i2 | 0));
  HEAP32[i8 + 1552 >> 2] = 0;
  HEAP8[i8 + 1550 >> 0] = 0;
  if ((i2 | 0) > 0) do {
   i4 = i2;
   i2 = i2 + -1 | 0;
   i5 = i8 + 1568 + (i2 << 2) | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0);
   i6 = i8 + 1632 + (i2 << 2) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   i1 = i8 + 1696 + (i2 << 2) | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
  } while ((i4 | 0) > 1);
 } else {
  HEAP32[i8 + 1552 >> 2] = 0;
  HEAP8[i8 + 1550 >> 0] = 0;
 }
 HEAP32[i7 >> 2] = 0;
 i1 = i8 + 1556 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i8 + 1560 | 0;
 i1 = 0;
 do {
  HEAP32[i8 + 3824 + (i1 * 24 | 0) >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 128);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERj(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1;
 i9 = i2 - i3 | 0;
 i4 = i9 + 4 | 0;
 if (i4) {
  i6 = i5 + 20 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i2 = i1 + i9 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i6 >> 2] = i1 + i4;
  }
 }
 HEAP32[i8 >> 2] = i2 + 4;
 i9 = i1 + i9 | 0;
 i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
 HEAP8[i9 >> 0] = i10;
 HEAP8[i9 + 1 >> 0] = i10 >> 8;
 HEAP8[i9 + 2 >> 0] = i10 >> 16;
 HEAP8[i9 + 3 >> 0] = i10 >> 24;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERf(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1;
 i9 = i2 - i3 | 0;
 i4 = i9 + 4 | 0;
 if (i4) {
  i6 = i5 + 20 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i2 = i1 + i9 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i6 >> 2] = i1 + i4;
  }
 }
 HEAP32[i8 >> 2] = i2 + 4;
 i9 = i1 + i9 | 0;
 i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8 | HEAPU8[i10 + 2 >> 0] << 16 | HEAPU8[i10 + 3 >> 0] << 24;
 HEAP8[i9 >> 0] = i10;
 HEAP8[i9 + 1 >> 0] = i10 >> 8;
 HEAP8[i9 + 2 >> 0] = i10 >> 16;
 HEAP8[i9 + 3 >> 0] = i10 >> 24;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i8) i7 = 0; else {
  i1 = i8 * 56 | 0;
  if (!i1) i7 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 657015 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7 + (i6 * 56 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i4 = i1;
   i5 = i2;
   i6 = i4 + 56 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   i1 = i1 + 56 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 56 | 0;
  }
 }
 i1 = i9 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i1 >> 2] = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 450747 | 0, i5, 0);
 __ZN15ResourceManager10Dependency8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i1 = i5 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 51;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN20SoundChannelInstance13set3DPanLevelEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
 HEAPF32[i1 + 64 >> 2] = f2;
 i1 = i1 + 146 | 0;
 HEAP16[i1 >> 1] = (i7 & 1) << 9 & 65535 | HEAP16[i1 >> 1] & -513;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = f2 < Math_fround(0.0);
 i9 = f2 > Math_fround(1.0);
 f2 = i9 ? Math_fround(1.0) : f2;
 i1 = __ZN4FMOD7Channel13set3DPanLevelEf(i3, i1 ? Math_fround(0.0) : f2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 230;
 HEAP32[i5 + 8 >> 2] = gb + 866338;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN19RingbufferTemplates23PeekValueFromRingBufferIi17GrowingRingbufferEEbRT0_RPKT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 24 | 0;
 i7 = i1 + 20 | 0;
 i4 = i1 + 16 | 0;
 L1 : while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = i3 + 20 | 0;
  i1 = (HEAP32[i3 + 24 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
  i9 = HEAP32[i3 + 16 >> 2] | 0;
  i2 = i9 + -1 & HEAP32[i2 >> 2];
  i9 = i9 - i2 | 0;
  i1 = i9 >>> 0 < i1 >>> 0 ? i9 : i1;
  i1 = i1 >>> 0 < 4 ? i1 : 4;
  switch (i1 | 0) {
  case 4:
   break L1;
  case 0:
   {
    i1 = 0;
    i8 = 10;
    break L1;
   }
  default:
   {}
  }
  i9 = (HEAP32[i6 >> 2] | 0) + 20 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i1;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i1;
  if (!(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0)) continue;
  i9 = HEAP32[i6 >> 2] | 0;
  if ((HEAP32[i9 + 24 >> 2] | 0) != (HEAP32[i9 + 20 >> 2] | 0)) continue;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - (HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2];
  if (!i1) continue;
  if (HEAP8[i1 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 8 | 0);
  __ZdlPv(i1);
 }
 if ((i8 | 0) == 10) return i1 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
 i9 = 1;
 return i9 | 0;
}

function __ZNK15ReflectionProbe13GetGlobalAABBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i3;
 __ZNK9Transform11GetPositionEv(i11, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f14 = Math_fround(HEAPF32[i11 >> 2]);
 f14 = Math_fround(f14 + Math_fround(HEAPF32[i2 + 76 >> 2]));
 f13 = Math_fround(HEAPF32[i11 + 4 >> 2]);
 f13 = Math_fround(f13 + Math_fround(HEAPF32[i2 + 80 >> 2]));
 f12 = Math_fround(HEAPF32[i11 + 8 >> 2]);
 f12 = Math_fround(f12 + Math_fround(HEAPF32[i2 + 84 >> 2]));
 f9 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f9 = Math_fround(f9 * Math_fround(.5));
 f6 = Math_fround(f6 * Math_fround(.5));
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(.5));
 i11 = f9 < Math_fround(0.0);
 f10 = Math_fround(-f9);
 i8 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 i2 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 HEAPF32[i1 >> 2] = f14;
 HEAPF32[i1 + 4 >> 2] = f13;
 HEAPF32[i1 + 8 >> 2] = f12;
 HEAPF32[i1 + 12 >> 2] = i11 ? f10 : f9;
 HEAPF32[i1 + 16 >> 2] = i8 ? f7 : f6;
 HEAPF32[i1 + 20 >> 2] = i2 ? f5 : f4;
 STACKTOP = i3;
 return;
}

function __ZNK10UnityScene19GetLevelGameManagerEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = i1 + 84 + (i2 + -24 << 2) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i6 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 906560 | 0, i2, i4);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i3 = i1 + 16 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085989 | 0, i5, i2, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1085998 | 0, i5, i2 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 1084342 | 0, i5, i2 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __ZN22BuiltinResourceManager24RegisterResourceInternalExPKcPKN5Unity4TypeES1_b(i9, i4, i5, i2, i3, i1, i6) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 i3 = i7 + 8 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = i7 + 16 | 0;
 HEAP32[i3 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i9 + 12 | 0, i4, i5) | 0;
 HEAP8[i7 + 20 >> 0] = i6 & 1;
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i9 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7);
  i9 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i8;
  return i9 | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
  i9 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 return 0;
}

function __ZN19StreamedBinaryWriteILb1EE8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i6, i8, i1, i2) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i5 = i8 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i7 = i8 + 4 | 0;
 i1 = _llvm_bswap_i32((i2 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i2 & 255) | 0) | 0;
 HEAP32[i10 >> 2] = i1;
 i9 = i6 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i6 = i6 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i9 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i10, 4);
  i2 = HEAP8[i5 >> 0] | 0;
 }
 i4 = i2 << 24 >> 24 < 0;
 i1 = i4 ? HEAP32[i8 >> 2] | 0 : i8;
 i8 = i4 ? HEAP32[i7 >> 2] | 0 : i2 & 255;
 i4 = i1 + i8 | 0;
 if (!i8) {
  __ZN12CachedWriter11Align4WriteEv(i9);
  STACKTOP = i11;
  return;
 }
 do {
  i2 = HEAP8[i1 >> 0] | 0;
  HEAP8[i10 >> 0] = i2;
  i3 = HEAP32[i9 >> 2] | 0;
  if ((i3 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = i2;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i10, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN12CachedWriter11Align4WriteEv(i9);
 STACKTOP = i11;
 return;
}

function __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastRK8Vector3fS1_P10RaycastHitfi23QueryTriggerInteraction(i4, i1, i6, f7, i8, i9) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f2 = f0, f3 = f0, f5 = f0, i10 = 0, f11 = f0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 HEAP32[i6 + 40 >> 2] = 0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f11 * f11);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i10 = 0;
  STACKTOP = i12;
  return i10 | 0;
 }
 f13 = Math_fround(f11 / f3);
 f5 = Math_fround(f5 / f3);
 f11 = Math_fround(f2 / f3);
 HEAP32[i10 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAPF32[i10 + 12 >> 2] = f13;
 HEAPF32[i10 + 16 >> 2] = f5;
 HEAPF32[i10 + 20 >> 2] = f11;
 if (__ZN14PhysicsManager7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i10, f7, i6, i8, i9) | 0) {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i6);
  i1 = 1;
 } else i1 = 0;
 i10 = i1;
 STACKTOP = i12;
 return i10 | 0;
}

function _strlcpy(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + -1 | 0;
 if (!i1) {
  i4 = i3;
  i1 = i3;
 } else {
  i6 = i2;
  i1 = i3;
  do if (!((i6 ^ i1) & 3)) {
   i5 = (i4 | 0) != 0;
   L6 : do if (i5 & (i6 & 3 | 0) != 0) while (1) {
    i6 = HEAP8[i2 >> 0] | 0;
    HEAP8[i3 >> 0] = i6;
    if (!(i6 << 24 >> 24)) break L6;
    i4 = i4 + -1 | 0;
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
    i5 = (i4 | 0) != 0;
    if (!(i5 & (i2 & 3 | 0) != 0)) {
     i7 = 7;
     break;
    }
   } else i7 = 7; while (0);
   if ((i7 | 0) == 7) if (!i5) break;
   if (!(HEAP8[i2 >> 0] | 0)) i7 = 13; else {
    L14 : do if (i4 >>> 0 > 3) {
     i5 = i3;
     while (1) {
      i3 = HEAP32[i2 >> 2] | 0;
      if ((i3 & -2139062144 ^ -2139062144) & i3 + -16843009 | 0) {
       i3 = i5;
       break L14;
      }
      HEAP32[i5 >> 2] = i3;
      i4 = i4 + -4 | 0;
      i2 = i2 + 4 | 0;
      i3 = i5 + 4 | 0;
      if (i4 >>> 0 > 3) i5 = i3; else break;
     }
    } while (0);
    i7 = 13;
   }
  } else i7 = 13; while (0);
  L19 : do if ((i7 | 0) == 13) if (i4) do {
   i7 = HEAP8[i2 >> 0] | 0;
   HEAP8[i3 >> 0] = i7;
   if (!(i7 << 24 >> 24)) break L19;
   i4 = i4 + -1 | 0;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i4 | 0) != 0); while (0);
  HEAP8[i3 >> 0] = 0;
  i4 = i3;
 }
 return i4 - i1 + (_strlen(i2) | 0) | 0;
}

function __ZNSt3__26vectorIPFvPviR11MessageDataENS_9allocatorIS5_EEE8__appendEjRKS5_(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   i1 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0;
 i3 = HEAP32[i3 + 48 >> 2] | 0;
 f12 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 f11 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 f8 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 120 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 128 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 132 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 136 >> 2]);
 f17 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f15 = Math_fround(Math_fround(Math_fround(f12 * f17) + Math_fround(f9 * f16)) + Math_fround(f6 * f13));
 f14 = Math_fround(Math_fround(Math_fround(f11 * f17) + Math_fround(f8 * f16)) + Math_fround(f5 * f13));
 f13 = Math_fround(Math_fround(Math_fround(f10 * f17) + Math_fround(f7 * f16)) + Math_fround(f4 * f13));
 i2 = f15 > f14 & f15 > f13;
 i3 = f14 > f13;
 HEAPF32[i1 >> 2] = i2 ? f12 : i3 ? f11 : f10;
 HEAPF32[i1 + 4 >> 2] = i2 ? f9 : i3 ? f8 : f7;
 HEAPF32[i1 + 8 >> 2] = i2 ? f6 : i3 ? f5 : f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK16MemoryFileSystem15GetFileRefCountEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx2Sc15ObjectIDTracker9releaseIDEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 HEAP32[i7 >> 2] = i8;
 i2 = i9 + 16 | 0;
 i4 = (i8 + 32 | 0) >>> 5;
 i5 = i9 + 20 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i6 = i9 + 24 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i4 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i1 | 0, i3 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i2 >> 2] | 0);
  }
  i6 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i6 & 2147483647) << 2) | 0, 0, i4 - i6 << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 } else i1 = HEAP32[i2 >> 2] | 0;
 i1 = i1 + (i8 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i8 & 31);
 i1 = i9 + 28 | 0;
 i2 = i9 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i9 + 36 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i8;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i1, i7) | 0;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE(i10, i13, i11, i1, i3, i2) {
 i10 = i10 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 HEAPF32[i10 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i8 = i10 + 4 | 0;
 f4 = Math_fround(3402823469999999843913219.0e14);
 i1 = -1;
 do {
  i2 = HEAP32[i3 + 48 >> 2] | 0;
  i7 = HEAP32[i3 + 52 >> 2] | 0;
  if (i2 >>> 0 < i7 >>> 0) do {
   i5 = HEAP32[i11 + (i2 << 6) + 44 >> 2] | 0;
   f6 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 > f6) {
    HEAP32[i10 >> 2] = i5;
    HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
    HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
    HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
    f4 = f6;
    i1 = i2;
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
  i3 = HEAP32[i3 + 16 >> 2] | 0;
 } while ((i3 | 0) != 0);
 i3 = i13;
 i1 = i11 + (i1 << 6) | 0;
 i2 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i13 + 384 >> 2] = 1;
 STACKTOP = i12;
 return;
}

function __ZN15DirectorManager32StopScheduledPlayableControllersEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1188416 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 while (1) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (i3 | 0) {
   __ZN15DirectorManager17RemoveFromManagerEP18PlayableController(i4, i3);
   if (HEAP8[i3 + 165 >> 0] | 0) {
    i1 = i3 + 64 | 0;
    if ((HEAP32[i3 + 80 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 68 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i3 + 44 | 0;
    if ((HEAP32[i3 + 60 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 48 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i3 + 24 | 0;
    if ((HEAP32[i3 + 40 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 28 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i3 + 4 | 0;
    if ((HEAP32[i3 + 20 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 8 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63784 | 0);
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
  i1 = HEAP32[gb + 1188416 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 return;
}

function __ZN13SplatDatabase23CheckResourcesAvailableEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = (HEAP32[i3 + 4 >> 2] | 0) - i1 | 0;
 i2 = (i4 | 0) / 44 | 0;
 L1 : do if ((i4 | 0) > 0) {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i5) | 0)) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  } else i1 = 1;
  while (1) {
   if ((i1 | 0) >= (i2 | 0)) break L1;
   HEAP32[i5 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 44 | 0) >> 2];
   if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i5) | 0)) {
    i1 = 0;
    break;
   } else i1 = i1 + 1 | 0;
  }
  STACKTOP = i6;
  return i1 | 0;
 } while (0);
 i4 = i3 + 12 | 0;
 i3 = i3 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = 0;
 while (1) {
  HEAP32[i5 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
  if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i5) | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0) {
   i1 = 1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN12_GLOBAL__N_110DataStream17allocateMemForCmdEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 if (i8 >>> 0 > 4096) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i7 = i9 + 464 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 + i8 | 0) >>> 0 > 4096) {
  i6 = i9 + 468 | 0;
  i1 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  i3 = i9 + 440 | 0;
  i4 = i9 + 456 | 0;
  if (i1 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i9 + 436 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 4096, gb + 776416 | 0, gb + 775936 | 0, 194) | 0;
   HEAP32[i5 >> 2] = i1;
   i2 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i9 + 460 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
    HEAP32[(HEAP32[i9 + 452 >> 2] | 0) + (i2 << 2) >> 2] = i1;
    i1 = i2 + 1 | 0;
    HEAP32[i4 >> 2] = i1;
   } else {
    __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS2_(i3, i5) | 0;
    i1 = HEAP32[i4 >> 2] | 0;
   }
   i1 = i1 + -1 | 0;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = 0;
  i2 = i1;
  i1 = 0;
 } else i2 = HEAP32[i9 + 468 >> 2] | 0;
 i9 = (HEAP32[(HEAP32[i9 + 452 >> 2] | 0) + (i2 << 2) >> 2] | 0) + i1 | 0;
 HEAP32[i7 >> 2] = i1 + i8;
 STACKTOP = i10;
 return i9 | 0;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37320 >> 2] | 0, i4, HEAP32[i1 + 24 >> 2] | 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i3 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i1 = i3 + 16 | 0;
 i2 = i3 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1085989 | 0, i5, i4, 0);
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1085998 | 0, i5, i4 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __ZNSt3__23mapIj17DetailPatchRenderNS_4lessIjEE11memory_poolINS_4pairIKjS1_EEEE25__construct_node_with_keyERS6_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 4 | 0;
 if (!(HEAP8[gb + 1099720 >> 0] | 0)) {
  i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i8 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i11 = gb + 63696 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i8, 1, gb + 1018240 | 0, 40, 32768, i5, 16);
  HEAP32[gb + 1467252 >> 2] = i8;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i8);
  if (i7) __Z19pop_allocation_rootv();
  i11 = gb + 1099720 | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = 0;
 }
 i11 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1467252 >> 2] | 0, 40) | 0;
 HEAP32[i11 + 16 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i11 + 26 >> 0] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = i11;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = 257;
 STACKTOP = i6;
 return;
}

function __ZNK14dtNavMeshQuery14isInClosedListEy(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = _bitshift64Shl(i5 | 0, i6 | 0, 18) | 0;
 i2 = _i64Add(i2 | 0, getTempRet0() | 0, ~i5 | 0, ~i6 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 31) | 0;
 i3 = ___muldi3(i4 ^ i2 | 0, (getTempRet0() | 0) ^ i3 | 0, 21, 0) | 0;
 i2 = getTempRet0() | 0;
 i4 = _bitshift64Lshr(i3 | 0, i2 | 0, 11) | 0;
 i2 = ___muldi3(i4 ^ i3 | 0, (getTempRet0() | 0) ^ i2 | 0, 65, 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 22) | 0;
 (getTempRet0() | 0) ^ i3;
 i2 = HEAP16[(HEAP32[i1 + 4 >> 2] | 0) + (((HEAP32[i1 + 16 >> 2] | 0) + -1 & (i4 ^ i2)) << 1) >> 1] | 0;
 if (i2 << 16 >> 16 == -1) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i1 = i2 & 65535;
 while (1) {
  i2 = i4 + (i1 << 5) + 24 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i6 | 0) : 0) break;
  i1 = HEAP16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0;
  if (i1 << 16 >> 16 == -1) {
   i1 = 0;
   i7 = 8;
   break;
  } else i1 = i1 & 65535;
 }
 if ((i7 | 0) == 8) return i1 | 0;
 if (!(i4 + (i1 << 5) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = (HEAP32[i4 + (i1 << 5) + 20 >> 2] | 0) < 0;
 return i7 | 0;
}

function __ZN9dtNavMesh19getNeighbourTilesAtEiiiPP10dtMeshTilei(i4, i3, i1, i2, i9, i10) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 switch (i2 | 0) {
 case 0:
  {
   i8 = i1;
   i3 = i3 + 1 | 0;
   break;
  }
 case 1:
  {
   i8 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
   break;
  }
 case 2:
  {
   i8 = i1 + 1 | 0;
   break;
  }
 case 3:
  {
   i8 = i1 + 1 | 0;
   i3 = i3 + -1 | 0;
   break;
  }
 case 4:
  {
   i8 = i1;
   i3 = i3 + -1 | 0;
   break;
  }
 case 5:
  {
   i8 = i1 + -1 | 0;
   i3 = i3 + -1 | 0;
   break;
  }
 case 6:
  {
   i8 = i1 + -1 | 0;
   break;
  }
 case 7:
  {
   i8 = i1 + -1 | 0;
   i3 = i3 + 1 | 0;
   break;
  }
 default:
  i8 = i1;
 }
 i1 = (Math_imul(i8, -669632447) | 0) + (Math_imul(i3, -1918454973) | 0) & HEAP32[i4 + 4 >> 2];
 i1 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i7 = i4 + 20 | 0;
 i5 = i1;
 i1 = 0;
 do {
  i6 = HEAP32[i7 >> 2] | 0;
  i2 = i6 + (i5 * 56 | 0) | 0;
  i4 = HEAP32[i6 + (i5 * 56 | 0) + 8 >> 2] | 0;
  if (i4) if ((HEAP32[i4 + 8 >> 2] | 0) == (i3 | 0)) if ((i1 | 0) < (i10 | 0) ? (HEAP32[i4 + 12 >> 2] | 0) == (i8 | 0) : 0) {
   HEAP32[i9 + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i5 = HEAP32[i6 + (i5 * 56 | 0) + 52 >> 2] | 0;
 } while ((i5 | 0) != -1);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5Unity5JointC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 112584 + 8;
 i5 = i1 + 40 | 0;
 i2 = i1 + 52 | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP8[i1 + 76 >> 0] = 1;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i1 + 36 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP8[i1 + 88 >> 0] = 0;
 HEAP8[i1 + 89 >> 0] = 1;
 HEAPF32[i1 + 80 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 84 >> 2] = Math_fround(inf);
 STACKTOP = i4;
 return;
}

function __ZN13MemoryManager20RegisterDeallocationEPvRK10MemLabelIdPKc(i5, i6, i2, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 if ((i6 | 0) == 0 | (HEAP32[gb + 1163236 >> 2] | 0) == 0) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < 128) i1 = HEAP32[i5 + 3824 + (i1 * 24 | 0) >> 2] | 0; else {
  i1 = HEAP32[i5 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
 }
 i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i6 | 0) | 0;
 __ZN14MemoryProfiler20UnregisterAllocationEPvjRK10MemLabelId(HEAP32[gb + 1163236 >> 2] | 0, i6, i4, i2);
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < 128) {
  i3 = i5 + 3824 + (i1 * 24 | 0) + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i4;
  i3 = i5 + 3824 + (i1 * 24 | 0) + 20 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 }
 if (!(HEAP8[i5 + 1548 >> 0] | 0)) return;
 if (i4 >>> 0 < (HEAP32[i5 + 3816 >> 2] | 0) >>> 0) return;
 i2 = i5 + 1540 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return; else i1 = 0;
 do {
  i3 = i5 + 772 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i5 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viii(HEAP32[i3 >> 2] | 0, i6 | 0, i4 | 0, i7 | 0); else mftCall_viiii(HEAP32[i3 >> 2] | 0, HEAP32[i5 + 772 + (i1 * 12 | 0) + 4 >> 2] | 0, i6 | 0, i4 | 0, i7 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i4, i7, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 if (!(HEAP8[i4 + 36 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = i1 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i6 + 4 | 0;
 i4 = i6 + 12 | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i5 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i4 >> 2] | 0) | 0 : i7) >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __Z24IntersectAABBFrustumFullRK4AABBPK5Plane(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, i14 = 0, f15 = f0, f16 = f0, i17 = 0, f18 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i1 = i2;
 i2 = 0;
 while (1) {
  f15 = Math_fround(HEAPF32[i1 >> 2]);
  f18 = Math_fround(f5 * f15);
  f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f6 * f12));
  f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  f18 = Math_fround(f18 + Math_fround(f7 * f9));
  f18 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f18);
  i17 = f15 < Math_fround(0.0);
  f16 = Math_fround(-f15);
  i14 = f12 < Math_fround(0.0);
  f13 = Math_fround(-f12);
  i11 = f9 < Math_fround(0.0);
  f10 = Math_fround(-f9);
  if (Math_fround(f18 + Math_fround(Math_fround(Math_fround(f8 * (i17 ? f16 : f15)) + Math_fround(f4 * (i14 ? f13 : f12))) + Math_fround(f3 * (i11 ? f10 : f9)))) < Math_fround(0.0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= 6) {
   i1 = 1;
   i2 = 4;
   break;
  } else i1 = i1 + 16 | 0;
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function _UNITY_FT_Stream_New(i1, i3, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i6 >> 2] = 0;
 if (!i1) {
  i6 = 33;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!i3) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = _UNITY_ft_mem_alloc(i4, 40, i5) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i6 = i2;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i1 + 28 >> 2] = i4;
 i2 = HEAP32[i3 >> 2] | 0;
 do if (!(i2 & 1)) {
  if (i2 & 4 | 0) {
   i3 = i3 + 12 | 0;
   HEAP32[i5 >> 2] = _UNITY_FT_Stream_Open(i1, HEAP32[i3 >> 2] | 0) | 0;
   HEAP32[i1 + 16 >> 2] = HEAP32[i3 >> 2];
   i3 = 12;
   break;
  }
  if (i2 & 2 | 0) {
   i2 = i3 + 16 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    _UNITY_ft_mem_free(i4, i1);
    i1 = HEAP32[i2 >> 2] | 0;
    i3 = 12;
    break;
   }
  }
  HEAP32[i5 >> 2] = 6;
  i3 = 13;
 } else {
  _UNITY_FT_Stream_OpenMemory(i1, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0);
  i3 = 12;
 } while (0);
 if ((i3 | 0) == 12) if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP32[i1 + 28 >> 2] = i4;
  i2 = i1;
  i1 = 0;
 } else i3 = 13;
 if ((i3 | 0) == 13) {
  _UNITY_ft_mem_free(i4, i1);
  i2 = 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i2;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 4 | 0;
 i8 = i9;
 f4 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f3);
 if (!(f4 >= Math_fround(0.0) & f2 >= Math_fround(0.0))) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = i1 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!(f4 < Math_fround(Math_fround(HEAPF32[i5 + 24 >> 2]) + Math_fround(1.0)))) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(f2 < Math_fround(Math_fround(HEAPF32[i5 + 28 >> 2]) + Math_fround(1.0)))) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i5, f4, f2, i7, i8) | 0;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 if ((HEAP8[(HEAP32[i5 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) < 0) i1 = f2 > f3 | i1 << 1; else i1 = Math_fround(f3 + f2) > Math_fround(1.0) | i1 << 1;
 i8 = i1 >>> 1;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0;
 i8 = (HEAP8[((i1 & 1 | 0) == 0 ? i7 + (i8 << 2) + 2 | 0 : i7 + (i8 << 2) + 3 | 0) >> 0] & 127) != 127 ? i1 : -1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK24OcclusionCullingSettings19ShouldWriteForBuildEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = (i1 | 0) != 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNK15NavMeshObstacle15GetWorldExtentsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 __ZNK9Transform18GetWorldScaleLossyEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f7 = Math_fround(HEAPF32[i9 >> 2]);
 i10 = f7 < Math_fround(0.0);
 f3 = Math_fround(-f7);
 f7 = i10 ? f3 : f7;
 f3 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i10 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i10 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i9 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f4 = i9 ? f5 : f4;
 f5 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 60 >> 2]);
 if (!(HEAP32[i2 + 40 >> 2] | 0)) {
  f5 = Math_fround(f5 * (f7 < f4 ? f4 : f7));
  f7 = f5;
  f6 = Math_fround(f3 * f6);
  HEAPF32[i1 >> 2] = f5;
  i10 = i1 + 4 | 0;
  HEAPF32[i10 >> 2] = f6;
  i10 = i1 + 8 | 0;
  HEAPF32[i10 >> 2] = f7;
  STACKTOP = i8;
  return;
 } else {
  f5 = Math_fround(f7 * f5);
  f7 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 64 >> 2]));
  f6 = Math_fround(f3 * f6);
  HEAPF32[i1 >> 2] = f5;
  i10 = i1 + 4 | 0;
  HEAPF32[i10 >> 2] = f6;
  i10 = i1 + 8 | 0;
  HEAPF32[i10 >> 2] = f7;
  STACKTOP = i8;
  return;
 }
}

function __ZN9Scripting27BackingArrayFieldForListOfTEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 if (_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i1) | 0, gb + 466150 | 0) | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 if ((i7 | 0) != (__Z20scripting_get_corlibv() | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i1, i6);
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = i4;
 if ((HEAP32[i7 >> 2] | 0) - i4 >> 2 >>> 0 <= 1) __ZNKSt3__220__vector_base_commonILb1EE20__throw_out_of_rangeEv(i6);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1;
 if (i1 | 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
  i7 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 1;
  HEAP32[i5 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 }
 i7 = i2;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 690651 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN20SoundChannelInstance11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS4_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
 HEAP32[i1 + 72 >> 2] = i2;
 i1 = i1 + 146 | 0;
 HEAP16[i1 >> 1] = (i7 & 1) << 11 & 65535 | HEAP16[i1 >> 1] & -2049;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E(i3, i2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 249;
 HEAP32[i5 + 8 >> 2] = gb + 874858;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN16MemoryFileSystem8IsLockedERK13FileEntryData(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 + 12 >> 2] | 0) == 2;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13WheelCollider19SetSidewaysFrictionERK18WheelFrictionCurve(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f5 = f0;
 i2 = i4 + 124 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f5 != Math_fround(HEAPF32[i1 >> 2])) i3 = 6; else {
  f5 = Math_fround(HEAPF32[i4 + 128 >> 2]);
  if (f5 != Math_fround(HEAPF32[i1 + 4 >> 2])) i3 = 6; else {
   f5 = Math_fround(HEAPF32[i4 + 132 >> 2]);
   if (f5 != Math_fround(HEAPF32[i1 + 8 >> 2])) i3 = 6; else {
    f5 = Math_fround(HEAPF32[i4 + 136 >> 2]);
    if (f5 != Math_fround(HEAPF32[i1 + 12 >> 2])) i3 = 6; else {
     f5 = Math_fround(HEAPF32[i4 + 140 >> 2]);
     if (f5 != Math_fround(HEAPF32[i1 + 16 >> 2])) i3 = 6;
    }
   }
  }
 }
 if ((i3 | 0) == 6) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if ((HEAP32[i4 + 148 >> 2] | 0) == -1) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 56 >> 2] | 0)) return;
 i4 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 return;
}

function __ZN10TagManager23AddDefaultLayerIfNeededEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 48 | 0;
 i8 = i9 + 8 | 0;
 i6 = i9;
 i7 = i5 + 1068 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i5 + 1072 >> 2] | 0) - i2 | 0;
 i3 = (i1 | 0) / 40 | 0;
 L1 : do if (i1 | 0) {
  i1 = 0;
  while (1) {
   if (!(HEAP32[i2 + (i1 * 40 | 0) + 32 >> 2] | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break L1;
  }
  STACKTOP = i9;
  return;
 } while (0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i2 = i8 + 24 | 0;
 i10 = gb + 63648 | 0;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP8[i8 + 4 >> 0] = 0;
 i1 = i8 + 32 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP8[i8 + 36 >> 0] = 0;
 __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i8, gb + 1012705 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_(i7, i4, i8) | 0;
 HEAP32[i5 + 1080 >> 2] = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i8 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 STACKTOP = i9;
 return;
}

function __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP8[i10 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i7 = i5 ? HEAP32[i10 >> 2] | 0 : i10;
 i4 = i5 ? HEAP32[i10 + 4 >> 2] | 0 : i4 & 255;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i6 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
 i3 = (i4 | 0) == 0;
 i1 = i7 + i4 | 0;
 L1 : do if (i3) i2 = -1; else {
  L3 : do if (!i5) i2 = i7; else {
   i2 = i7;
   while (1) {
    if (!(_memchr(i6, HEAPU8[i2 >> 0] | 0, i5) | 0)) break L3;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i1 | 0)) {
     i2 = -1;
     break L1;
    }
   }
  } while (0);
  i2 = i2 - i7 | 0;
 } while (0);
 L9 : do if (!i5) {
  if (!i3) {
   i1 = i7 + i4 + -1 | 0;
   i8 = 11;
  }
 } else while (1) {
  if ((i1 | 0) == (i7 | 0)) break L9;
  i1 = i1 + -1 | 0;
  if (!(_memchr(i6, HEAPU8[i1 >> 0] | 0, i5) | 0)) {
   i8 = 11;
   break;
  }
 } while (0);
 if ((i8 | 0) == 11) {
  i1 = i1 - i7 | 0;
  if (!((i2 | 0) == -1 | (i1 | 0) == -1)) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i9, i10, i2, 1 - i2 + i1 | 0, i10);
   return;
  }
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 return;
}

function mftCall_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii(i31, i1, d2, i13, i24, i25, i26, i27, i28, i29, i30, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18, i19, i20, i21, i22, i23) {
 i31 = i31 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i13 = i13 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 if ((i31 | 0) >= (fb | 0) & (i31 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii[i31 - fb & 1](i1 | 0, Math_fround(d2), i13 | 0, i24 | 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0, i29 | 0, i30 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0);
  return;
 }
 ftCall_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii(i31 | 0, i1 | 0, +d2, i13 | 0, i24 | 0, i25 | 0, i26 | 0, i27 | 0, i28 | 0, i29 | 0, i30 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0);
}

function __ZN7mecanim8skeleton8Skeleton8TransferI8BlobSizeEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 20 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i3 = i2 + 16 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1 + 4 + (0 - i1 & 3);
 } else HEAP8[i4 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i3 = i2 + 16 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i5 = i5 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i5 & 3) | 0;
  i1 = (i1 & 65535) < 256 ? i5 : i5 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  HEAP32[i3 >> 2] = (0 - i1 & 3) + i1;
 } else HEAP8[i4 >> 0] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i3 = i2 + 16 | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i5 = i5 + (i1 & 16711680 | 0 ? 8 : 4) + (0 - i5 & 3) | 0;
  i1 = (i1 & 65535) < 256 ? i5 : i5 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i3 >> 2] = i1;
 } else {
  HEAP8[i4 >> 0] = 0;
  i1 = i2 + 16 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i1 = (0 - i1 & 3) + i1 | 0;
 i1 = i1 + 4 + (0 - i1 & 3) | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!((i2 & 255) << 24 >> 24)) {
  i5 = i1 + (i2 & 16711680 | 0 ? 8 : 4) + (0 - i1 & 3) | 0;
  i5 = (i2 & 65535) < 256 ? i5 : i5 + 4 | 0;
  HEAP8[i4 >> 0] = 0;
  HEAP32[i3 >> 2] = (0 - i5 & 3) + i5;
  return;
 } else {
  HEAP8[i4 >> 0] = 0;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 5;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 660329 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 5) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
  HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
  i2 = i2 + 32 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 32 | 0;
 }
 return;
}

function __ZN5physx2Sc7BodySim10sleepCheckEffb(i7, f1, f3, i2) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f8 = f0, i9 = 0, i10 = 0;
 i6 = HEAP32[i7 + 52 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i6 + 144 >> 2]);
 if (!(Math_fround(__ZN5physx2Sc7BodySim17updateWakeCounterEffffb(i7, f1, f8, Math_fround(HEAPF32[i6 + 148 >> 2]), f3, i2)) == Math_fround(0.0))) return;
 i6 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i7 + 36 >> 2] | 0) | 0;
 i2 = i7 + 188 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i6 + 16 >> 2] | 0;
 i10 = i5 + (i4 * 12 | 0) + 8 | 0;
 i9 = HEAP8[i10 >> 0] | 0;
 HEAP8[i10 >> 0] = i9 & 247;
 do if (i9 & 8) {
  i10 = (HEAP32[HEAP32[i6 + 272 >> 2] >> 2] | 0) + (i4 >>> 5 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & ~(1 << (i4 & 31));
  i2 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[i5 + (i2 * 12 | 0) + 8 >> 0] & 64)) {
   i4 = (HEAP32[HEAP32[i6 + 276 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i2 = 1 << (i2 & 31);
   if (!(i5 & i2)) {
    HEAP32[i4 >> 2] = i5 | i2;
    break;
   } else {
    HEAP32[i4 >> 2] = i5 & ~i2;
    break;
   }
  }
 } while (0);
 HEAP8[i6 + 477 >> 0] = 1;
 HEAP32[i7 + 156 >> 2] = 0;
 HEAP32[i7 + 160 >> 2] = 0;
 HEAP32[i7 + 164 >> 2] = 0;
 HEAP32[i7 + 172 >> 2] = 0;
 HEAP32[i7 + 176 >> 2] = 0;
 HEAP32[i7 + 180 >> 2] = 0;
 return;
}

function __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 16 | 0;
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __ZN13WheelCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 835976 | 0, 158) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 158928 + 8;
 HEAPF32[i4 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 124 >> 2] = Math_fround(.200000003);
 HEAPF32[i4 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 132 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 136 >> 2] = Math_fround(.75);
 HEAPF32[i4 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 104 >> 2] = Math_fround(.400000006);
 HEAPF32[i4 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 112 >> 2] = Math_fround(.800000011);
 HEAPF32[i4 + 116 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 120 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 148 >> 2] = -1;
 HEAP32[i4 + 144 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13WheelCollider18SetForwardFrictionERK18WheelFrictionCurve(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f5 = f0;
 i2 = i4 + 104 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f5 != Math_fround(HEAPF32[i1 >> 2])) i3 = 6; else {
  f5 = Math_fround(HEAPF32[i4 + 108 >> 2]);
  if (f5 != Math_fround(HEAPF32[i1 + 4 >> 2])) i3 = 6; else {
   f5 = Math_fround(HEAPF32[i4 + 112 >> 2]);
   if (f5 != Math_fround(HEAPF32[i1 + 8 >> 2])) i3 = 6; else {
    f5 = Math_fround(HEAPF32[i4 + 116 >> 2]);
    if (f5 != Math_fround(HEAPF32[i1 + 12 >> 2])) i3 = 6; else {
     f5 = Math_fround(HEAPF32[i4 + 120 >> 2]);
     if (f5 != Math_fround(HEAPF32[i1 + 16 >> 2])) i3 = 6;
    }
   }
  }
 }
 if ((i3 | 0) == 6) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if ((HEAP32[i4 + 148 >> 2] | 0) == -1) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 56 >> 2] | 0)) return;
 i4 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 return;
}

function __ZL27AnimationVisibilityCallbackPvS_i(i6, i3, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 switch (i1 | 0) {
 case 0:
  {
   HEAP8[i6 + 42 >> 0] = 1;
   if (!(__Z14IsWorldPlayingv() | 0)) return;
   i5 = i6 + 256 | 0;
   i4 = (HEAP32[i5 >> 2] | 0) != 0;
   mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 132 >> 2] | 0, i6 | 0);
   if (i4 | (HEAP32[i5 >> 2] | 0) == 0) return;
   __ZN9Animation15UpdateAnimationEd(i6, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
   return;
  }
 case 1:
  {
   __ZN9Animation25CheckRendererVisibleStateEv(i6);
   return;
  }
 case 2:
  {
   i4 = i6 + 68 | 0;
   i5 = i6 + 72 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   L13 : do if ((i1 | 0) != (i2 | 0)) {
    while (1) {
     if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i2 | 0)) break L13;
    }
    HEAP32[i1 >> 2] = HEAP32[i2 + -4 >> 2];
    i3 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i4 >> 2] | 0;
    i2 = i3 - i1 >> 2;
    if (!i2) {
     __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i4, -1);
     break;
    }
    i1 = i1 + (i2 + -1 << 2) | 0;
    if ((i3 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
   } while (0);
   __ZN9Animation25CheckRendererVisibleStateEv(i6);
   return;
  }
 default:
  return;
 }
}

function __Z41RegisterAllowNameConversionInDerivedTypesPKcS0_S0_(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i8 + 8 | 0;
 i10 = i8;
 i7 = i8 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i10;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i7 >> 2] = 0;
 i3 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(__ZN6Object15StringToClassIDEPKc(i1) | 0, i7, 1);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i11 = __ZN6Object15ClassIDToStringEi(HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   __Z27RegisterAllowNameConversionR20AllowNameConversionsPKcS2_S2_(HEAP32[gb + 1166132 >> 2] | 0, i11, i2, i6);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i5);
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN9WWWCached13StartDownloadEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i4 = i7 + 16 | 0;
 i5 = i2 + 88 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 | 0) {
  __ZN3WWW7ReleaseEv(i6);
  HEAP32[i5 >> 2] = 0;
 }
 i9 = i2 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 _printf_console(gb + 454504 | 0, i1);
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i6 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i2 + 40 | 0;
 i8 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 i3 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i9, 0, 0, i4, i3, i1, i8) | 0;
 HEAP32[i5 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0, HEAP32[i2 + 60 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i4, HEAP32[i6 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN8GUIState12GetPushStateEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Znwj(352) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 1065353216;
 HEAP32[i2 + 48 >> 2] = 1065353216;
 HEAP32[i2 + 52 >> 2] = 1065353216;
 HEAP32[i2 + 56 >> 2] = 1065353216;
 HEAP32[i2 + 28 >> 2] = 1065353216;
 HEAP32[i2 + 32 >> 2] = 1065353216;
 HEAP32[i2 + 36 >> 2] = 1065353216;
 HEAP32[i2 + 40 >> 2] = 1065353216;
 HEAP32[i2 + 12 >> 2] = 1065353216;
 HEAP32[i2 + 16 >> 2] = 1065353216;
 HEAP32[i2 + 20 >> 2] = 1065353216;
 HEAP32[i2 + 24 >> 2] = 1065353216;
 HEAP32[i2 + 60 >> 2] = 1;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 1;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i3 = i2 + 252 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 + 332 >> 2] = 0;
 HEAP32[i2 + 328 >> 2] = i1;
 HEAP32[i2 + 280 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 340 >> 2] = 0;
 HEAPF32[i2 + 344 >> 2] = Math_fround(1.0);
 HEAP32[i2 + 348 >> 2] = i1;
 __ZN8GUIState13MoveAllDataToERS_b(HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0, i2, 1);
 return i2 | 0;
}

function __ZN14RenderSettings32CleanupGeneratedSkyboxReflectionEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = i2 + 384 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = i6;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i8 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i8 = 7; else if (!(HEAP32[i1 + 4 >> 2] | 0)) i8 = 9;
 }
 if ((i8 | 0) == 7) i8 = 9;
 if ((i8 | 0) == 9) if (!(__Z31ReadObjectFromPersistentManageri(i6) | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i2, i3, i4, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 32 | 0;
 i10 = i12 + 8 | 0;
 i11 = i12;
 if (!i3) {
  HEAP32[i10 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  i13 = i10 + 12 | 0;
  HEAP32[i13 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i13 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i13 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 } else {
  i13 = i3 + 48 | 0;
  HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i13 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i13 + 8 >> 2];
  HEAP32[i10 + 12 >> 2] = HEAP32[i13 + 12 >> 2];
  HEAP32[i10 + 16 >> 2] = HEAP32[i13 + 16 >> 2];
  HEAP32[i10 + 20 >> 2] = HEAP32[i13 + 20 >> 2];
 }
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 i13 = __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebiP6Camera(i2, i3, i10, i1, i5, i6, i7, i8, i9) | 0;
 STACKTOP = i12;
 return i13 | 0;
}

function __Z19BuildAngleWeightLUTPfiiff(i4, i5, i1, f2, f3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f6 = f0, i7 = 0, d8 = 0.0;
 switch (i1 | 0) {
 case 1:
  {
   f2 = Math_fround(+f2 * 3.141592653589793 / 180.0);
   if ((i5 | 0) <= 0) return;
   f3 = Math_fround(i5 + -1 | 0);
   i1 = 0;
   do {
    f6 = Math_fround(Math_fround(f2 - Math_fround(+Math_acos(+Math_fround(Math_fround(i1 | 0) / f3)))) / f2);
    i7 = f6 < Math_fround(0.0);
    HEAPF32[i4 + (i1 << 2) >> 2] = i7 ? Math_fround(0.0) : f6;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
   return;
  }
 case 3:
  {
   d8 = +Math_fround(+f2 * 3.141592653589793 / 180.0 / 3.0);
   f2 = Math_fround(1.0 / (d8 * (d8 * 2.0)));
   if ((i5 | 0) <= 0) return;
   f3 = Math_fround(i5 + -1 | 0);
   i1 = 0;
   do {
    f6 = Math_fround(+Math_acos(+Math_fround(Math_fround(i1 | 0) / f3)));
    HEAPF32[i4 + (i1 << 2) >> 2] = Math_fround(+Math_exp(+Math_fround(-Math_fround(f2 * Math_fround(f6 * f6)))));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
   return;
  }
 case 5:
  {
   if ((i5 | 0) <= 0) return;
   f2 = Math_fround(i5 + -1 | 0);
   i1 = 0;
   do {
    HEAPF32[i4 + (i1 << 2) >> 2] = Math_fround(+Math_pow(+Math_fround(Math_fround(i1 | 0) / f2), +f3));
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i5 | 0));
   return;
  }
 default:
  return;
 }
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 if (!(HEAP8[i6 + 57 >> 0] | 0)) i8 = 0; else i8 = 1;
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 i4 = i6 + 40 | 0;
 i2 = i1;
 L4 : do if ((i2 | 0) == (i4 | 0)) i5 = 7; else {
  i3 = i2;
  while (1) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (i2 >>> 0 <= i7 >>> 0) if ((i2 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) break L4;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = i1;
   if ((i3 | 0) == (i4 | 0)) {
    i5 = 7;
    break;
   }
  }
 } while (0);
 L10 : do if ((i5 | 0) == 7) {
  i1 = HEAP32[i6 + 52 >> 2] | 0;
  i4 = i6 + 48 | 0;
  i2 = i1;
  if ((i2 | 0) != (i4 | 0)) do {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i7 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i7 >>> 0) break L10;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i6 + 64 >> 2] | 0;
  L19 : do if (i1 | 0) {
   while (1) {
    if ((HEAP32[i1 + 8 >> 2] | 0) == (i7 | 0)) break;
    i1 = HEAP32[i1 >> 2] | 0;
    if (!i1) break L19;
   }
   if (!i8) {
    i8 = 1;
    return i8 | 0;
   }
   i8 = 1;
   return i8 | 0;
  } while (0);
  if (!i8) {
   i8 = 0;
   return i8 | 0;
  }
  i8 = 0;
  return i8 | 0;
 } while (0);
 if (!i8) {
  i8 = 1;
  return i8 | 0;
 }
 i8 = 1;
 return i8 | 0;
}

function __ZNK16SpriteRenderData17AcquireSharedDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  i5 = i6 + 4 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i4 = i4 + 1 | 0;
  HEAP32[i5 >> 2] = i4;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63744 | 0, 16, gb + 568578 | 0, 99) | 0;
 i2 = i1 + 4 | 0;
 i3 = i2;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 45376 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i2 = i6;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i3 = i6;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i5 >> 2] = i1;
 i6 = i1;
 i5 = i6 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i4 = i4 + 1 | 0;
 HEAP32[i5 >> 2] = i4;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_iiNS0_15FramebufferMaskE(i2, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i14 + 40 | 0;
 i13 = i14 + 32 | 0;
 i12 = i14 + 24 | 0;
 i9 = i14 + 8 | 0;
 i10 = i14;
 i11 = i14 + 16 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 665 >> 0] | 0)) {
  STACKTOP = i14;
  return;
 }
 i16 = i3;
 i3 = HEAP32[i16 + 4 >> 2] | 0;
 i15 = i9;
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 HEAP32[i15 + 4 >> 2] = i3;
 i15 = i5;
 i3 = HEAP32[i15 + 4 >> 2] | 0;
 i5 = i10;
 HEAP32[i5 >> 2] = HEAP32[i15 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i11 + 4 >> 2] = -1;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_S3_iiiiiiiiNS0_15FramebufferMaskE(i2, i12, i4, i13, i1, 0, 0, i6, i7, 0, 0, i6, i7, i8);
 STACKTOP = i14;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i8) i7 = 0; else {
  i1 = i8 * 48 | 0;
  if (!i1) i7 = 0; else {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
   i7 = _PxGetFoundation() | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0) | 0;
   i7 = mftCall_iiiiii(i5 | 0, i6 | 0, i1 | 0, (i7 ? gb + 685654 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7 + (i6 * 48 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i4 = i1;
   i5 = i2;
   i6 = i4 + 48 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   i1 = i1 + 48 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 48 | 0;
  }
 }
 i1 = i9 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i2 = HEAP32[i9 >> 2] | 0;
 if (!i2) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i1 >> 2] = i8;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 40 | 0;
 i5 = i6;
 i1 = i5 + 8 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 451047 | 0, i5, 0);
 __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 8 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 STACKTOP = i6;
 return;
}

function __ZN22RenderingCommandBuffer7CleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = i6 + 60 | 0;
 i5 = i6 + 72 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = __Z22GetRenderBufferManagerv() | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i3 | 0) {
   i1 = 0;
   do {
    __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i2, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
  i1 = i6 + 76 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i6 + 64 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i4 = i6 + 80 | 0;
 i5 = i6 + 92 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i7 = i3 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63288 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i6 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i6 + 84 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11OffMeshLinkC2ER10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 169188 + 8;
 i3 = i1 + 56 | 0;
 i2 = i1 + 68 | 0;
 HEAP32[i1 + 88 >> 2] = 0;
 i5 = i1 + 40 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = -1;
 HEAPF32[i1 + 84 >> 2] = Math_fround(-1.0);
 HEAP8[i1 + 98 >> 0] = 1;
 HEAP8[i1 + 96 >> 0] = 0;
 HEAP8[i1 + 97 >> 0] = 0;
 HEAP8[i1 + 99 >> 0] = 1;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAPF32[i1 + 80 >> 2] = Math_fround(.5);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIPKN5Unity4TypeENS_9allocatorIS4_EEE8__appendEjRKS4_(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   i1 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE21__push_back_slow_pathIS6_EEvOT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = (i1 - i2 >> 3) + 1 | 0;
 if (i7 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = (HEAP32[i4 + 8 >> 2] | 0) - i2 | 0;
 i3 = i9 >> 2;
 __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEEC2EjjS9_(i6, i9 >> 3 >>> 0 < 268435455 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 536870911, i1 - i2 >> 3, i4 + 8 | 0);
 i7 = i6 + 8 | 0;
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 8;
 __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS8_EE(i4, i6);
 __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = 58;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i6 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i6;
  if (i6 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i3 = i1;
   break;
  }
 } else i3 = i1; while (0);
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i3, i2, i4);
 STACKTOP = i5;
 return;
}

function __ZNSt3__212system_errorC2EiRKNS_14error_categoryERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 24 | 0;
 i8 = i6 + 16 | 0;
 i7 = i6;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i7, i4);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i5 | 0, i8 | 0, i7 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 do if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i5 | 0);
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   HEAP32[i1 + 8 >> 2] = i2;
   HEAP32[i1 + 12 >> 2] = i3;
   STACKTOP = i6;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 ___resumeException(i1 | 0);
}

function __ZN7mecanim9animation21CreateControllerInputEPKNS0_18ControllerConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 16, 4) | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP8[i4 + 20 >> 0] = 0;
 if (!i3) {
  i3 = 0;
  i4 = i5 + 12 | 0;
  HEAP32[i4 >> 2] = i3;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 * 24 | 0, 4) | 0;
 i3 = i1 + (i3 * 24 | 0) | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i3 = i1;
  i4 = i5 + 12 | 0;
  HEAP32[i4 >> 2] = i3;
  STACKTOP = i6;
  return i5 | 0;
 } else i2 = i1;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i2 = i2 + 24 | 0;
 } while ((i2 | 0) != (i3 | 0));
 i4 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 690809 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN23CloudWebServicesManager23PlayerLoopHandlerStaticEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i1 = __Z21GetManagerFromContexti(20) | 0;
 i7 = i1 + 44 | 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (i7 | 0)) {
  STACKTOP = i10;
  return;
 }
 i8 = i1 + 56 | 0;
 i4 = i1 + 52 | 0;
 i5 = i6 + 4 | 0;
 i1 = i2;
 do {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!(HEAP32[i2 + 1144 >> 2] | 0)) i9 = 5; else if ((HEAP32[i2 >> 2] | 0) == 2) i9 = 5; else {
   __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv(i2);
   __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv(i2 + 200 | 0);
   __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv(i2 + 792 | 0);
   i1 = HEAP32[i3 + 4 >> 2] | 0;
  }
  if ((i9 | 0) == 5) {
   i9 = 0;
   i11 = i3 + 4 | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[HEAP32[i11 >> 2] >> 2] = i3;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP32[i6 >> 2] = 85;
   HEAP32[i5 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
   i1 = i2;
  }
  i3 = i1;
 } while ((i3 | 0) != (i7 | 0));
 STACKTOP = i10;
 return;
}

function __ZN15RelativeJoint2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 44 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 48 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 76 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(1.0e6);
 f4 = i5 ? Math_fround(1.0e6) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 80 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(1.0e6);
 f4 = i5 ? Math_fround(1.0e6) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 84 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(1.0);
 f4 = i5 ? Math_fround(1.0) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 88 | 0;
 i3 = i1 + 92 | 0;
 if (!((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i3 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
 }
 i1 = i1 + 96 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14OcclusionScene8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i8 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWriteyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIyLj8EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritexEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIxLj8EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritetEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 2) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 1) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayItLj2EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritesEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 2) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 1) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 1;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIsLj2EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritejEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIjLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWriteiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIiLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritefEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 4) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 2;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIfLj4EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritedEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 8) | 0;
 i2 = i8 + (HEAP32[i2 + 4 >> 2] << 3) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 i2 = i2 - i8 >> 3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIdLj8EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIP11Il2CppClassNS_9allocatorIS2_EEE8__appendEjRKS2_(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   i1 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) - i1 >> 4 >>> 0 >= i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i1 >> 4;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3 + 8;
 if (!i4) i2 = 0; else i2 = __Znwj(i4 << 4) | 0;
 HEAP32[i7 >> 2] = i2;
 i9 = i2 + (i1 << 4) | 0;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i7 + 12 >> 2] = i2 + (i4 << 4);
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE(i3, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i4 = i6 + 4 | 0;
  do {
   i2 = i1 + -16 | 0;
   HEAP32[i5 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i9 = HEAP32[i2 >> 2] | 0;
    i1 = HEAP32[i1 + -4 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i4 >> 2] = i1;
    __Z19free_alloc_internalPvRK10MemLabelId(i9, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   } else i1 = i2;
  } while ((i1 | 0) != (i3 | 0));
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZNK13AnimationClip13IsHumanMotionEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 + 164 >> 2] | 0;
 i5 = i6 + 168 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((i1 | 0) != (i2 | 0)) {
  i4 = i1;
  i1 = i2;
  while (1) {
   if ((HEAP32[i4 + 32 >> 2] | 0) == 95) {
    i1 = i4 + 16 | 0;
    if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
    i2 = _strlen(i1) | 0;
    i3 = i1 + i2 | 0;
    if ((i2 | 0) > 0) {
     i2 = -1;
     do {
      i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
      i1 = i1 + 1 | 0;
     } while ((i1 | 0) != (i3 | 0));
     i1 = ~i2;
    } else i1 = 0;
    if ((__ZN7mecanim9animation15FindMuscleIndexEj(i1) | 0) > 13) {
     i1 = 1;
     break;
    }
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 132 | 0;
   if ((i4 | 0) == (i1 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 if (!(HEAP32[i6 + 216 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = HEAP32[i6 + 236 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i6 + 224 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP16[i2 + (i1 << 4) + 12 >> 1] | 0) == 95) if ((HEAP32[i2 + (i1 << 4) + 4 >> 2] | 0) >>> 0 > 13) {
   i1 = 1;
   i2 = 18;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i2 = 18;
   break;
  }
 }
 if ((i2 | 0) == 18) return i1 | 0;
 return 0;
}

function __ZN5physx14PxsAABBManager19purgeAggregatePairsEj(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i7 = i1 + 49860 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 i5 = i1 + 49856 | 0;
 i1 = i2;
 i4 = 0;
 L4 : while (1) {
  while (1) {
   i1 = i1 + -1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i2 + (i4 * 12 | 0) >> 2] | 0) != (i8 | 0)) if ((HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] | 0) != (i8 | 0)) break;
   i3 = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] | 0;
   if (i3) {
    i2 = HEAP32[i3 >> 2] | 0;
    if (i2 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 8 | 0, i2);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i3);
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] = 0;
   }
   i3 = i2 + (i4 * 12 | 0) | 0;
   i10 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i10;
   i2 = i2 + (i10 * 12 | 0) | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   if (!i1) {
    i1 = 13;
    break L4;
   }
  }
  if (!i1) {
   i1 = 13;
   break;
  } else i4 = i4 + 1 | 0;
 }
 if ((i1 | 0) == 13) {
  STACKTOP = i9;
  return;
 }
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_PKc17TransferMetaFlags(i9, i3, i1, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
   i2 = HEAP8[i5 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i5 >> 0] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 STACKTOP = i8;
 return;
}

function __ZN16MemoryFileSystem8SetFlagsER13FileEntryDatajj(i2, i1, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i4 = i7;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i2 = 0; else i2 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 16 | 0;
 if (!i2) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~i5 | i6;
 i6 = 1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN12HingeJoint2D9SetLimitsERK18JointAngleLimits2D(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2 + 104 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f5 < Math_fround(-1.0e6);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(-1.0e6) : f5;
 i3 = i2 + 108 | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f5 < Math_fround(-1.0e6);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i3 >> 2] = i1 ? Math_fround(-1.0e6) : f5;
 HEAP8[i2 + 113 >> 0] = 1;
 i1 = i2 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN15b2RevoluteJoint11EnableLimitEb(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 f7 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.0174532924));
 i4 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.0174532924));
 i6 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = f7 > f5;
 f5 = (HEAP32[tempDoublePtr >> 2] = i3 ? i6 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 __ZN15b2RevoluteJoint9SetLimitsEff(i1, f5, (HEAP32[tempDoublePtr >> 2] = i3 ? i4 : i6, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 return;
}

function __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = i4 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i8 = i4 + 16 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 & 2147483647;
 do if (i7 >>> 0 > i10 >>> 0) {
  i1 = i9 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i10 >>> 0 < i1 >>> 0) if ((i9 | 0) > -1) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i1 * 24 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i4 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i4 >> 2] | 0, (HEAP32[i5 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i8 >> 2] = i1;
   HEAP32[i4 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i10 + (i6 * 24 | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + (i6 * 24 | 0) + 4 >> 2] = i3;
 HEAP32[i10 + (i6 * 24 | 0) + 8 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i10 + (i6 * 24 | 0) + 12 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i10 + (i6 * 24 | 0) + 16 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i10 + (i6 * 24 | 0) + 20 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function _UNITY_png_set_sCAL_s(i6, i7, i1, i5, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) return;
 if ((i1 + -1 | 0) >>> 0 > 1) _UNITY_png_error(i6, gb + 352686 | 0);
 if (!i5) _UNITY_png_error(i6, gb + 352704 | 0);
 i2 = _strlen(i5) | 0;
 if (!i2) _UNITY_png_error(i6, gb + 352704 | 0);
 if ((HEAP8[i5 >> 0] | 0) == 45) _UNITY_png_error(i6, gb + 352704 | 0);
 if (!(_UNITY_png_check_fp_string(i5, i2) | 0)) _UNITY_png_error(i6, gb + 352704 | 0);
 if (!i8) _UNITY_png_error(i6, gb + 352723 | 0);
 i3 = _strlen(i8) | 0;
 if (!i3) _UNITY_png_error(i6, gb + 352723 | 0);
 if ((HEAP8[i8 >> 0] | 0) == 45) _UNITY_png_error(i6, gb + 352723 | 0);
 if (!(_UNITY_png_check_fp_string(i8, i3) | 0)) _UNITY_png_error(i6, gb + 352723 | 0);
 HEAP8[i7 + 232 >> 0] = i1;
 i1 = i2 + 1 | 0;
 i2 = _UNITY_png_malloc_warn(i6, i1) | 0;
 i4 = i7 + 236 | 0;
 HEAP32[i4 >> 2] = i2;
 if (!i2) return;
 _memcpy(i2 | 0, i5 | 0, i1 | 0) | 0;
 i1 = i3 + 1 | 0;
 i2 = _UNITY_png_malloc_warn(i6, i1) | 0;
 HEAP32[i7 + 240 >> 2] = i2;
 if (!i2) {
  _UNITY_png_free(i6, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  return;
 } else {
  _memcpy(i2 | 0, i8 | 0, i1 | 0) | 0;
  i8 = i7 + 8 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 16384;
  i8 = i7 + 220 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 256;
  return;
 }
}

function __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEjRKS1_(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
   i1 = (HEAP32[i10 >> 2] | 0) + 4 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i1 = i6;
 i4 = i6;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpExNS_8ios_base7seekdirE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i5 = i7;
 __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i8, i1);
 i6 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (!(HEAP32[i6 + 16 >> 2] & 5)) {
  i6 = HEAP32[i6 + 24 >> 2] | 0;
  __THREW__ = 0;
  invoke_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i6 | 0, i2 | 0, i3 | 0, i4 | 0, 16);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i6 = i5 + 8 | 0;
   if (!((HEAP32[i6 >> 2] | 0) == -1 ? (HEAP32[i6 + 4 >> 2] | 0) == -1 : 0)) break;
   i6 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | 4 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) break;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i8);
  ___resumeException(i1 | 0);
 } while (0);
 __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i8);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpExNS_8ios_base7seekdirE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i5 = i7;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i8, i1);
 i6 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (!(HEAP32[i6 + 16 >> 2] & 5)) {
  i6 = HEAP32[i6 + 24 >> 2] | 0;
  __THREW__ = 0;
  invoke_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i6 | 0, i2 | 0, i3 | 0, i4 | 0, 16);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  } else {
   i6 = i5 + 8 | 0;
   if (!((HEAP32[i6 >> 2] | 0) == -1 ? (HEAP32[i6 + 4 >> 2] | 0) == -1 : 0)) break;
   i6 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i6 | 0, HEAP32[i6 + 16 >> 2] | 4 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (!(i6 & 1)) break;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
  }
  __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i8);
  ___resumeException(i1 | 0);
 } while (0);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i8);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK26AnimatorControllerPlayable14IsInTransitionEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i3 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) i1 = HEAP32[HEAP32[i2 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i3 | 0)) {
   i4 = (HEAP32[i2 + 92 >> 2] | 0) + 4 | 0;
   i4 = i4 + (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   i5 = (HEAP32[i2 + 100 >> 2] | 0) + 4 | 0;
   i4 = i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i4 + (HEAP32[i4 >> 2] | 0) >> 2] << 2) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   i5 = (HEAP8[((i5 | 0) == 0 ? 0 : i4 + i5 | 0) + 81 >> 0] | 0) != 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i4 >> 2] = i3;
 __Z6FormatPKcz(i5, gb + 902210 | 0, i4);
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5Umbra9UnionFindIjE9unionSetsERKjS3_(i7, i1, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = __ZNK5Umbra9UnionFindIjE8getIndexERKj(i7, i1) | 0;
 i5 = i7 + 32 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i8 = i1;
 while (1) {
  i2 = HEAP32[i3 + (i8 << 2) >> 2] | 0;
  if ((i2 | 0) == (i8 | 0) | (i2 | 0) == -1) break; else i8 = i2;
 }
 if ((i1 | 0) != (i8 | 0)) do {
  i6 = i3 + (i1 << 2) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
 } while ((i1 | 0) != (i8 | 0));
 i1 = __ZNK5Umbra9UnionFindIjE8getIndexERKj(i7, i4) | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = i1;
 while (1) {
  i6 = i5 + (i4 << 2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) == (i4 | 0) | (i2 | 0) == -1) break; else i4 = i2;
 }
 if ((i1 | 0) != (i4 | 0)) do {
  i3 = i5 + (i1 << 2) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
 } while ((i1 | 0) != (i4 | 0));
 i2 = HEAP32[i7 + 48 >> 2] | 0;
 i1 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
 i2 = i2 + (i4 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) < (i3 | 0)) {
  HEAP32[i5 + (i8 << 2) >> 2] = i4;
  HEAP32[i6 >> 2] = -1;
  return;
 }
 if ((i1 | 0) > (i3 | 0)) {
  HEAP32[i5 + (i8 << 2) >> 2] = -1;
  HEAP32[i6 >> 2] = i8;
  return;
 }
 if ((i8 | 0) == (i4 | 0)) return;
 HEAP32[i5 + (i8 << 2) >> 2] = i4;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN19AssetBundleManifest18GetAssetBundleHashERK8UnityStr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 i8 = __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr(i2, i3) | 0;
 HEAP32[i5 >> 2] = i8;
 if ((i8 | 0) == -1) {
  HEAP32[i6 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
  __Z6FormatPKcz(i4, gb + 368500 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 368569 | 0, 42, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_(i2 + 32 | 0, i4, i5);
  i8 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  STACKTOP = i7;
  return;
 }
}

function __ZN14dtPathCorridor11setCorridorEPKfPK14dtNavMeshQueryPKyib(i6, i7, i8, i9, i10, i11) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 i4 = i6 + 36 | 0;
 if ((HEAP32[i4 >> 2] | 0) < (i10 | 0)) {
  i1 = HEAP32[i6 + 40 >> 2] | 0;
  i2 = i10 + -1 | 0;
  i5 = i2 + i1 | 0;
  i1 = i5 - ((i5 | 0) % (i1 | 0) | 0) | 0;
  i5 = i6 + 28 | 0;
  i3 = __Z9dtReallocPvi(HEAP32[i5 >> 2] | 0, i1 << 3) | 0;
  if (!i3) {
   i3 = i5;
   i1 = i5;
  } else {
   HEAP32[i5 >> 2] = i3;
   HEAP32[i4 >> 2] = i1;
   i3 = i5;
   i1 = i5;
  }
 } else {
  i1 = i6 + 28 | 0;
  i3 = i1;
  i2 = i10 + -1 | 0;
 }
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 >> 2];
 i4 = i7 + 4 | 0;
 i5 = i6 + 16 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i7 + 8 >> 2];
 _memcpy(HEAP32[i3 >> 2] | 0, i9 | 0, i10 << 3 | 0) | 0;
 HEAP32[i6 + 32 >> 2] = i10;
 i10 = (i10 | 0) != 0 & 1;
 HEAP8[i6 + 44 >> 0] = i11 ? i10 | 2 : i10;
 HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
 i11 = (HEAP32[i1 >> 2] | 0) + (i2 << 3) | 0;
 __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i8, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0, i7, i12) | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 STACKTOP = i13;
 return;
}

function __ZN13SparseTexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 411468 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i4 + 32 | 0);
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAPF32[i4 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 76 >> 2] = 1;
 i1 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 45096 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 1;
 HEAP32[i4 + 92 >> 2] = 1;
 HEAP32[i4 + 96 >> 2] = 5;
 HEAP8[i4 + 100 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11MonoManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i10, i11);
 i6 = i10 + 28 | 0;
 i9 = i10 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i2 - i1 >> 2;
 HEAP32[i5 >> 2] = i7;
 i8 = i11 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i11 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  i10 = i10 + 212 | 0;
  __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i10, 0);
  STACKTOP = i12;
  return;
 }
 do {
  __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i11);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i10 = i10 + 212 | 0;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i11, i10, 0);
 STACKTOP = i12;
 return;
}

function _socket(i2, i6, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 32 | 0;
 i9 = i10 + 24 | 0;
 i8 = i10 + 16 | 0;
 i5 = i10 + 8 | 0;
 i1 = i10;
 i11 = i10 + 64 | 0;
 i4 = i10 + 40 | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i6;
 HEAP32[i11 + 8 >> 2] = i3;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAP32[i11 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i11;
 i1 = ___syscall_ret(___syscall102(102, i1 | 0) | 0) | 0;
 L1 : do if ((i1 | 0) < 0) {
  switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
  case 93:
  case 22:
   break;
  default:
   break L1;
  }
  if (i6 & 526336) {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i4 + 4 >> 2] = i6 & -526337;
   HEAP32[i4 + 8 >> 2] = i3;
   HEAP32[i4 + 12 >> 2] = 0;
   HEAP32[i4 + 16 >> 2] = 0;
   HEAP32[i4 + 20 >> 2] = 0;
   HEAP32[i5 >> 2] = 1;
   HEAP32[i5 + 4 >> 2] = i4;
   i1 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
   if ((i1 | 0) >= 0) {
    if (i6 & 524288 | 0) {
     HEAP32[i8 >> 2] = 1;
     _fcntl(i1, 2, i8) | 0;
    }
    if (i6 & 2048) {
     HEAP32[i7 >> 2] = _fcntl(i1, 3, i9) | 0 | 2048;
     _fcntl(i1, 4, i7) | 0;
    }
   }
  }
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEjRKf(i9, i2, i11) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i12 = 0;
 i10 = i9 + 8 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i12 = i9 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (i4 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  i3 = i1 + (i2 << 2) | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
   i2 = i2 + -1 | 0;
   if (!i2) break; else i1 = i1 + 4 | 0;
  }
  HEAP32[i12 >> 2] = i3;
  return;
 }
 i3 = HEAP32[i9 >> 2] | 0;
 i5 = (i1 - i3 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i12 >> 2] | 0;
 }
 i8 = i4 - i3 | 0;
 i4 = i8 >> 1;
 i4 = i8 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i5 >>> 0 ? i5 : i4) : 1073741823;
 i5 = i1 - i3 >> 2;
 if (!i4) i8 = 0; else i8 = __Znwj(i4 << 2) | 0;
 i6 = i8 + (i5 << 2) | 0;
 i7 = i8 + (i4 << 2) | 0;
 i5 = i5 + i2 | 0;
 i4 = i6;
 while (1) {
  HEAP32[i4 >> 2] = HEAP32[i11 >> 2];
  i2 = i2 + -1 | 0;
  if (!i2) break; else i4 = i4 + 4 | 0;
 }
 i2 = i1 - i3 | 0;
 i1 = i6 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i12 >> 2] = i8 + (i5 << 2);
 HEAP32[i10 >> 2] = i7;
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwj(i3, i10, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 __THREW__ = 0;
 i4 = invoke_ii(fb + 2806 | 0, i10 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 if (i9 & 1) {
  i9 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i9);
 }
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + (i2 << 2) | 0;
  i8 = i10 + (i4 << 2) | 0;
  i1 = i3 + (i1 << 2) | 0;
  i7 = i9;
  i2 = i4 << 2 >> 2;
  L11 : do if (i2) if ((i7 - i1 >> 2 | 0) < (i2 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i2 << 2) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L11;
     }
     if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 4 | 0;
    }
    do {
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break L11;
     i4 = i4 + 4 | 0;
    } while ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 >> 2] | 0));
    i1 = i5 + 4 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 >> 2;
 }
 return i1 | 0;
}

function __ZN6Avatar7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(100, i1, 16, gb + 1048932 | 0, 0, gb + 908249 | 0, 28) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 178664 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 176376 + 8;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 4096;
 HEAP32[i4 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 i1 = i4 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = i1;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = i4;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags(i12, i6, i1, i2) {
 i12 = i12 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i12);
 i1 = i6 + 4 | 0;
 i10 = i12 + 16 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i12 + 24 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i10 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i1, 4);
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i5 >> 2] | 0;
 }
 i7 = i6 + 8 | 0;
 i8 = i6 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = (i2 - i1 | 0) / 24 | 0;
 HEAP32[i9 >> 2] = i5;
 i6 = i3 + 4 | 0;
 if (i6 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i10 >> 2] = i6;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i10, i9, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN18ComputeShaderParam8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i12);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i1);
 __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 100 | 0, i1);
 __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 32 | 0, i1);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags(i1, i8 + 36 | 0, 0);
 i6 = i8 + 28 | 0;
 i3 = (HEAP32[i6 >> 2] | 0) + 12 | 0;
 i7 = i1 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i4 + 4 | 0;
 i5 = i1 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4); else {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 __ZN10GISettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8 + 76 | 0, i1);
 i1 = i8 + 236 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i1 = (HEAP32[i6 >> 2] | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) return;
 HEAP32[i1 >> 2] = 1;
 HEAP8[i8 + 96 >> 0] = 1;
 HEAP8[i8 + 97 >> 0] = 0;
 return;
}

function __ZN16LightmapSettings28SetDynamicGILightmapTexturesEPK22RealtimeLightmapIDDataj(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
  HEAP32[i2 + 4 >> 2] = 1;
  HEAP32[i2 >> 2] = gb + 43424 + 8;
  HEAP32[i2 + 8 >> 2] = 1;
  HEAP32[i2 + 12 >> 2] = 1;
  i3 = i2 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 if (!i5) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = i5;
  return;
 }
 i1 = __Znaj(i5 >>> 0 > 357913941 ? -1 : i5 * 12 | 0) | 0;
 i6 = (i5 * 12 | 0) + -12 | 0;
 _memset(i1 | 0, 0, i6 - ((i6 >>> 0) % 12 | 0) + 12 | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 + 28 >> 2] = i5;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 if ((i5 | 0) == 1) return; else i1 = 1;
 do {
  i6 = (HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) | 0;
  i2 = i4 + (i1 * 12 | 0) | 0;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEventD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188456 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2 + 64 | 0, HEAP32[i2 + 68 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE(i2 + 48 | 0, HEAP32[i2 + 52 >> 2] | 0);
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __Z37Cubemap_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiiR10ColorRGBAf(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i1 = i10 + 24 | 0;
 i9 = i10 + 8 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i11 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i11);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i11 = __ZNK21ScriptingObjectOfTypeI7CubemapEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i11 >> 2] | 0) + 36 >> 2] | 0, i11 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture2D8GetPixelEiii(i9, i1, i5, i6, i7);
  i6 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = HEAP32[i9 + 8 >> 2] | 0;
  i11 = HEAP32[i9 + 12 >> 2] | 0;
  HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i8 + 8 >> 2] = i7;
  HEAP32[i8 + 12 >> 2] = i11;
  STACKTOP = i10;
  return;
 }
}

function __Z22FindGameObjectsWithTagI13dynamic_arrayIP10GameObjectLj4EEEvjRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = __Z20GetGameObjectManagerv() | 0;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i10 | 0)) return;
 i11 = i9 + 12 | 0;
 i12 = i9 + 16 | 0;
 i13 = i9 + 4 | 0;
 do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAPU16[i1 + 52 >> 1] | 0 | 0) == (i8 | 0)) {
   i4 = HEAP32[i11 >> 2] | 0;
   i5 = i4 + 1 | 0;
   i6 = HEAP32[i12 >> 2] | 0;
   i7 = i6 & 2147483647;
   do if (i5 >>> 0 > i7 >>> 0) {
    i3 = i6 << 1;
    i3 = (i3 | 0) == 0 ? 1 : i3;
    if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
     HEAP32[i12 >> 2] = i3;
     HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i3 << 2, 4, i13, 0, gb + 1047584 | 0, 464) | 0;
     break;
    } else {
     i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i13, 0, gb + 1047584 | 0, 446) | 0;
     _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
     HEAP32[i12 >> 2] = i3;
     HEAP32[i9 >> 2] = i7;
     break;
    }
   } while (0);
   HEAP32[i11 >> 2] = i5;
   HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i1;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i10 | 0));
 return;
}

function __Z11FitTangentsIfEvR11KeyframeTplIT_ES3_ffRKS1_S5_(i1, i2, f3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, d12 = 0.0, d13 = 0.0, d14 = 0.0, d15 = 0.0, d16 = 0.0, d17 = 0.0, d18 = 0.0, d19 = 0.0, d20 = 0.0, d21 = 0.0, f22 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 >> 2]));
 if (Math_fround(Math_abs(Math_fround(f7))) < Math_fround(1.1920929e-07)) {
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  return;
 } else {
  f22 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  d11 = +f3;
  d9 = d11 * d11;
  d15 = d11 * d9;
  d12 = d15 * 2.0;
  d20 = d9 * 3.0;
  d11 = d11 + (d15 - d9 * 2.0);
  d9 = d15 - d9;
  d15 = +f4;
  d13 = d15 * d15;
  d14 = d15 * d13;
  d17 = d14 * 2.0;
  d18 = d13 * 3.0;
  d10 = d14 - d13;
  d19 = +f22;
  d16 = +Math_fround(HEAPF32[i2 + 4 >> 2]);
  d8 = +f7;
  d21 = +Math_fround(HEAPF32[i5 >> 2]);
  d12 = d21 - (d12 - d20 + 1.0) * d19 - (d20 - d12) * d16;
  d10 = (d12 / d9 - (+Math_fround(HEAPF32[i6 >> 2]) - (d17 - d18 + 1.0) * d19 - (d18 - d17) * d16) / d10) / (d11 / d9 - (d15 + (d14 - d13 * 2.0)) / d10);
  HEAPF32[i1 + 12 >> 2] = Math_fround(d10 / d8);
  HEAPF32[i2 + 8 >> 2] = Math_fround((d12 - d11 * d10) / d9 / d8);
  return;
 }
}

function __ZNSt3__212system_errorC2ENS_10error_codeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 12 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1576256 | 0, 0);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i3 | 0, i2 | 0, i5 | 0);
 i6 = __THREW__;
 __THREW__ = 0;
 do if (i6 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i3 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   i3 = i2;
   i5 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 ___resumeException(i1 | 0);
}

function __ZNK14PlayerSettings21DoesSupportResolutionEii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 f4 = Math_fround(Math_fround(i1 | 0) / Math_fround(i2 | 0));
 do if ((i1 | 0) == 0 | (i2 | 0) == 0) i5 = 6; else {
  f6 = Math_fround(f4 + Math_fround(-1.33333337));
  i2 = f6 < Math_fround(0.0);
  f7 = Math_fround(-f6);
  if ((i2 ? f7 : f6) < Math_fround(.0500000007)) if (!(HEAP8[i3 + 321 >> 0] | 0)) i1 = 1; else {
   i5 = 1;
   return i5 | 0;
  } else i1 = 0;
  f7 = Math_fround(f4 + Math_fround(-1.25));
  i2 = f7 < Math_fround(0.0);
  f6 = Math_fround(-f7);
  if ((i2 ? f6 : f7) < Math_fround(.0500000007)) if (!(HEAP8[i3 + 322 >> 0] | 0)) i1 = 1; else {
   i5 = 1;
   return i5 | 0;
  }
  f7 = Math_fround(f4 + Math_fround(-1.60000002));
  i2 = f7 < Math_fround(0.0);
  f6 = Math_fround(-f7);
  if ((i2 ? f6 : f7) < Math_fround(.0500000007)) if (!(HEAP8[i3 + 323 >> 0] | 0)) i1 = 1; else {
   i5 = 1;
   return i5 | 0;
  }
  f7 = Math_fround(f4 + Math_fround(-1.77777779));
  i2 = f7 < Math_fround(0.0);
  f6 = Math_fround(-f7);
  if (!((i2 ? f6 : f7) < Math_fround(.0500000007))) if (i1) break; else {
   i5 = 6;
   break;
  }
  if (HEAP8[i3 + 324 >> 0] | 0) {
   i5 = 1;
   return i5 | 0;
  }
 } while (0);
 if ((i5 | 0) == 6) if (HEAP8[i3 + 320 >> 0] | 0) {
  i5 = 1;
  return i5 | 0;
 }
 i5 = 0;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx3Cct17CapsuleController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE(i6, i1, f4, f2, i3, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 __ZN5physx3Cct12SweptCapsuleC2Ev(i8);
 i9 = i8 + 8 | 0;
 i11 = i6 + 416 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 i9 = HEAP32[i6 + 496 >> 2] | 0;
 HEAP32[i8 + 40 >> 2] = i9;
 i11 = HEAP32[i6 + 500 >> 2] | 0;
 HEAP32[i8 + 44 >> 2] = i11;
 f10 = Math_fround((HEAP32[tempDoublePtr >> 2] = i11, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5));
 HEAPF32[i8 + 32 >> 2] = Math_fround(f10 + (HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 i6 = __ZN5physx3Cct10Controller4moveERNS0_11SweptVolumeERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextEb(i6 + 8 | 0, i8, i1, f4, f2, i3, i5, (HEAP32[i6 + 504 >> 2] | 0) == 1) | 0;
 __ZN5physx3Cct12SweptCapsuleD2Ev(i8);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD12ChannelGroup7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i3 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
   i1 = i6 + 12 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   HEAP8[i6 + 16 >> 0] = 1;
   i1 = i6 + 24 | 0;
   i5 = i6 + 32 | 0;
   i6 = i6 + 28 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   i2 = i3 + 144 | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 >> 2] = i3 + 140;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] = i1;
   HEAP32[i2 >> 2] = i1;
   i2 = i3 + 136 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i3 = i3 + 132 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853481;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperation20ExecuteSynchronouslyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 16 | 0;
 i5 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
 i6 = i1 + 192 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i2, i5, i1 + 208 | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 176 | 0, i2) | 0;
 __ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv(i1) | 0;
 if (!(__ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i1) | 0)) {
  i3 = i1 + 92 | 0;
  if (HEAP32[i3 >> 2] | 0) if ((HEAP32[i3 >> 2] | 0) != 1) {
   i6 = i1 + 96 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN22RenderingCommandBuffer22AddSetGlobalFloatArrayERKN9ShaderLab16FastPropertyNameEPKfi(i10, i1, i11, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i8 = i10 + 8 | 0;
 i9 = i10 + 24 | 0;
 i3 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i3 + 4 | 0;
 i7 = i10 + 20 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i2);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i2;
 i5 = i10 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + i3 >> 2] = 16;
 i3 = i3 + 7 & -4;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i3, i4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else i1 = i2;
 HEAP32[i9 >> 2] = i4;
 i1 = i1 + i3 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i12;
 i1 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i2 = i1 + (i12 << 2) | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i1, i2);
 HEAP32[i9 >> 2] = i2;
 i2 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
 if ((i12 | 0) > 0) i1 = 0; else {
  i12 = i10 + 36 | 0;
  HEAP8[i12 >> 0] = 1;
  return;
 }
 do {
  HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i11 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 i12 = i10 + 36 | 0;
 HEAP8[i12 >> 0] = 1;
 return;
}

function __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 16 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i4;
 i5 = i3 + 40 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 44 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 48 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 52 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 56 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 60 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 64 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 68 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 72 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = -1;
 HEAP32[i3 + 12 >> 2] = 0;
 __ZN14SplatMaterials16LoadSplatShadersEv(i3);
 __ZN14SplatMaterials15UpdateMaterialsEv(i3);
 return;
}

function __ZN13RuntimeStaticI18AssetBundleManagerE7DestroyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 if (!i6) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i6 + 144 | 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i6 + 68 | 0);
 i1 = HEAP32[i6 + 44 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i3 = i6 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i8 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i8;
   __ZN14ConstantStringD2Ev(i8);
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Animation35CleanupGenericAnimationBindingCacheEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[gb + 1466544 >> 2] | 0;
 if (i1 | 0) __ZN11UnityEngine9Animation28GenericAnimationBindingCacheD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63320 | 0);
 HEAP32[gb + 1466544 >> 2] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 1540 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i4 = i6 + 772 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i4 >> 2] | 0) == (fb + 297 | 0)) {
   i3 = i6 + 772 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 772 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i8 = 10;
   break;
  }
 }
 if ((i8 | 0) == 10) return;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i3 >> 0] = 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (i8 >>> 0 <= i1 >>> 0) return;
 do {
  i8 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 772 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 772 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 772 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 772 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZN11LightProbes20SetBakedCoefficientsEPK20SphericalHarmonicsL2i(i5, i7, i1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i6 = i5 + 148 | 0;
 i8 = i5 + 160 | 0;
 i1 = i1 * 108 | 0;
 i2 = (i1 | 0) / 108 | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = i5 + 164 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i5 + 152 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 152 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 108 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, (HEAP32[i8 >> 2] | 0) * 108 | 0) | 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return; else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __Z42AudioListener_CUSTOM_GetSpectrumDataHelperP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = i8 + 8 | 0;
 i5 = i8 + 4 | 0;
 i6 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 if (!i6) {
  if (!(HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0)) {
   STACKTOP = i8;
   return;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 883926 | 0, 0, gb + 875076 | 0, 543, 1, 0, 0, 0);
  STACKTOP = i8;
  return;
 }
 i9 = (__ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE(i6, i4) | 0) == 0;
 do if (i9 & (HEAP32[i4 >> 2] | 0) != 0) {
  HEAP32[i5 >> 2] = 0;
  i9 = (i2 | 0) > -1 & (__ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i6, 0, 0, i5, 0, 0, 0) | 0) == 0;
  if (i9 & (HEAP32[i5 >> 2] | 0) > (i2 | 0)) {
   i7 = HEAP32[i4 >> 2] | 0;
   i9 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
   __ZN4FMOD12ChannelGroup11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i7, i9, __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0, i2, i3) | 0;
   break;
  } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 884044 | 0, i7);
 } while (0);
 STACKTOP = i8;
 return;
}

function __ZNK18MultiPointTraverse12filterPointsERKN5Umbra14KDTraverseNodeIjEEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0, i13 = 0, f14 = f0;
 i12 = HEAP32[i1 >> 2] | 0;
 i13 = HEAP32[i12 + 28 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) + 16 >> 2]);
 f10 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) + 20 >> 2]);
 f11 = Math_fround(HEAPF32[i12 + 32 + (i13 * 40 | 0) + 24 >> 2]);
 if (!i3) {
  i13 = 0;
  return i13 | 0;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  i4 = _llvm_cttz_i32(i3 | 0) | 0;
  i2 = i2 + i4 | 0;
  f14 = Math_fround(HEAPF32[i5 + (i2 * 12 | 0) >> 2]);
  if (!(!(f14 >= f6) | !(f14 <= f9))) {
   f14 = Math_fround(HEAPF32[i5 + (i2 * 12 | 0) + 4 >> 2]);
   if (!(!(f14 >= f7) | !(f14 <= f10))) {
    f14 = Math_fround(HEAPF32[i5 + (i2 * 12 | 0) + 8 >> 2]);
    if (!(!(f14 >= f8) | !(f14 <= f11))) i1 = 1 << i2 | i1;
   }
  }
  i3 = i3 >>> (i4 + 1 | 0);
  i2 = i2 + 1 | 0;
 } while ((i3 | 0) != 0 & (i2 | 0) < 32);
 if (!i1) {
  i13 = 0;
  return i13 | 0;
 }
 HEAP32[i12 + 32 + (i13 * 40 | 0) + 36 >> 2] = i1;
 i13 = 1;
 return i13 | 0;
}

function __ZNK15NavMeshSettings19ShouldWriteForBuildEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = (i1 | 0) != 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 661085 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx3Cct15ObstacleContextD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 86424 + 8;
 i6 = i2 + 28 | 0;
 i1 = i2 + 48 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = i2 + 44 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 2 | 0, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 40 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyE(i15, i13, i11, i12, i14, i10) {
 i15 = i15 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i16 = 0;
 if (!i11) return;
 i7 = i15 + 1212 | 0;
 i9 = 0;
 do {
  i8 = (HEAP32[i13 + (i9 << 2) >> 2] | 0) + i12 | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i6 + 8 >> 2] | 0;
  i3 = HEAP32[i6 + 12 >> 2] | 0;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i2 = i3 + (i5 * 12 | 0) + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  do if (!i1) {
   i1 = i3 + (i5 * 12 | 0) + 8 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
    HEAP32[i1 >> 2] = i2 + 1;
    i1 = (HEAP32[i3 + (i5 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i4) | 0) | 0;
    if (i1 | 0) {
     i16 = 8;
     break;
    }
   }
   i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
   if (i1 | 0) i16 = 8;
  } else {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i16 = 8;
  } while (0);
  if ((i16 | 0) == 8) {
   i16 = 0;
   __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(i1, i14, i8, i10, 0);
  }
  i8 = i15 + 1424 + (HEAP32[i8 + 68 >> 2] << 2) | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i11 | 0));
 return;
}

function __ZN17PxcPoolMallocDataC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 HEAP32[i2 + 272 >> 2] = 0;
 HEAP8[i2 + 264 >> 0] = 1;
 HEAP32[i2 + 268 >> 2] = i2 + 8;
 HEAP32[i2 + 276 >> 2] = 64;
 HEAP32[i2 + 280 >> 2] = 512;
 HEAP32[i2 + 284 >> 2] = 0;
 HEAP32[i2 + 288 >> 2] = 0;
 HEAP32[i2 + 292 >> 2] = 4096;
 HEAP32[i2 + 296 >> 2] = 0;
 HEAP32[i2 + 568 >> 2] = 0;
 HEAP8[i2 + 560 >> 0] = 1;
 HEAP32[i2 + 564 >> 2] = i2 + 304;
 HEAP32[i2 + 572 >> 2] = 64;
 HEAP32[i2 + 576 >> 2] = 256;
 HEAP32[i2 + 580 >> 2] = 0;
 HEAP32[i2 + 584 >> 2] = 0;
 HEAP32[i2 + 588 >> 2] = 4096;
 HEAP32[i2 + 592 >> 2] = 0;
 HEAP32[i2 + 864 >> 2] = 0;
 HEAP8[i2 + 856 >> 0] = 1;
 HEAP32[i2 + 860 >> 2] = i2 + 600;
 HEAP32[i2 + 868 >> 2] = 64;
 HEAP32[i2 + 872 >> 2] = 128;
 HEAP32[i2 + 876 >> 2] = 0;
 HEAP32[i2 + 880 >> 2] = 0;
 HEAP32[i2 + 884 >> 2] = 4096;
 HEAP32[i2 + 888 >> 2] = 0;
 return;
}

function __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i11 >> 2] = 0;
 i1 = i10 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if ((i4 | 0) < 0) {
  i2 = i1 + 64 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  i11 = -2147483648;
  return i11 | 0;
 }
 i9 = i10 + 24 | 0;
 i3 = i10 + 32 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if ((HEAP32[i9 >> 2] | 0) == (i2 | 0) ? (HEAP32[i9 + 4 >> 2] | 0) == (i3 | 0) : 0) {
  i2 = 1;
  i1 = i4;
 } else {
  i5 = HEAP32[i10 + 12 >> 2] | 0;
  i9 = i5 + 24 | 0;
  if (!((HEAP32[i9 >> 2] | 0) == (i2 | 0) ? (HEAP32[i9 + 4 >> 2] | 0) == (i3 | 0) : 0)) HEAP32[i1 >> 2] = i4 | 64;
  i9 = i10 + 76 | 0;
  i2 = 0;
  i6 = 0;
  while (1) {
   i7 = i5 + 20 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   i3 = i8 & 1073741823;
   if (!i3) i4 = 0; else i4 = (HEAP32[HEAP32[i9 >> 2] >> 2] | 0) + (i3 + -1 << 5) | 0;
   if (!i6) i3 = 0; else i3 = (i6 - (HEAP32[HEAP32[i9 >> 2] >> 2] | 0) >> 5) + 1 | 0;
   HEAP32[i7 >> 2] = i8 & -1073741824 | i3 & 1073741823;
   i2 = i2 + 1 | 0;
   if (!i4) break; else {
    i6 = i5;
    i5 = i4;
   }
  }
  HEAP32[i10 + 16 >> 2] = i5;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i11 >> 2] = i2;
 i11 = i1 & 16777215 | 1073741824;
 return i11 | 0;
}

function __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 24 | 0;
 i3 = i5 + 8 | 0;
 i7 = i5;
 __ZN6Object8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i3, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i2 = i3 + 11 | 0;
 i6 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i1 + 28 | 0, i6, i4);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
 STACKTOP = i5;
 return;
}

function __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 24 | 0;
 i3 = i5 + 8 | 0;
 i7 = i5;
 __ZN6Object8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i2, i3, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i2 = i3 + 11 | 0;
 i6 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i1 + 28 | 0, i6, i4);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i4);
 STACKTOP = i5;
 return;
}

function __Z38CombineInstance_CUSTOM_InternalGetMeshP12Il2CppObjecti(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 i2 = i5;
 if (!i4) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i6 = 7; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i6 = 9;
  }
 }
 if ((i6 | 0) == 7) i6 = 9;
 if ((i6 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN8GUIStyle14SetGUIClipRectERK5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[gb + 1468288 >> 2] = HEAP32[i1 >> 2];
 HEAP32[gb + 1468288 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[gb + 1468288 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[gb + 1468288 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 __ZN10Matrix4x4f11SetIdentityEv(i2) | 0;
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i3 = f6 > Math_fround(0.0);
 f6 = Math_fround(Math_fround(.875) / f6);
 f6 = i3 ? f6 : Math_fround(inf);
 HEAPF32[i2 >> 2] = f6;
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i3 = f5 > Math_fround(0.0);
 f5 = Math_fround(Math_fround(.875) / f5);
 f5 = i3 ? f5 : Math_fround(inf);
 HEAPF32[i2 + 20 >> 2] = f5;
 HEAPF32[i2 + 48 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f6));
 HEAPF32[i2 + 52 >> 2] = Math_fround(Math_fround(.0625) - Math_fround(Math_fround(HEAPF32[i1 + 4 >> 2]) * f5));
 HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 56 >> 2] = Math_fround(1.0);
 i1 = (__Z12GetGfxDevicev() | 0) + 2660 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 716123 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx24extContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i7, i6, i9, i10, i1, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (i6 | 0) {
  i3 = i9 + 16 | 0;
  i5 = 0;
  do {
   if ((HEAP16[i7 + (i5 << 5) + 8 >> 1] | 0) == -1) i2 = HEAPU16[i7 + (i5 << 5) + 10 >> 1] | 0; else i2 = 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if ((HEAP16[i7 + (i5 << 5) + 12 >> 1] | 0) == -1) i4 = HEAPU16[i7 + (i5 << 5) + 14 >> 1] | 0; else i4 = 0;
   __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i7 + (i5 << 5) | 0, i9, i1 + (i2 << 6) | 0, i1 + (i4 << 6) | 0);
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i6 | 0));
 }
 i5 = i9 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i8, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i9 = i10 + (i4 + i2 << 4) | 0;
   i8 = i1 + (i2 << 4) | 0;
   HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN18AsyncUploadManager18ScheduleAsyncReadsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(HEAP32[i5 + 1324 >> 2] | 0)) return;
 i6 = i5 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 32 | 0;
 do if (!i1) {
  i3 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = i4;
  if (!i4) return; else {
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i3 >> 2] = i2;
   if (i1 | 0) break;
   return;
  }
 } while (0);
 i4 = i5 + 24 | 0;
 while (1) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (!(__ZN18AsyncUploadManager17ScheduleAsyncReadEP10AtomicNodeP16AsyncReadCommand(i5, i1, (HEAP32[i5 + 44 + (i3 * 40 | 0) + 24 >> 2] | 0) == 3 ? i5 + 44 + (i3 * 40 | 0) | 0 : 0) | 0)) {
   i1 = 11;
   break;
  }
  HEAP32[i4 >> 2] = ((HEAP32[i4 >> 2] | 0) + 1 | 0) % 32 | 0;
  HEAP32[i6 >> 2] = 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  i3 = i8;
  if (!i8) {
   i1 = 9;
   break;
  }
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 >> 2] = i3;
  if (!i1) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 9) return; else if ((i1 | 0) == 11) return;
}

function __Z30Animator_CUSTOM_GetFloatStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator8GetFloatEiRfb(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i5, 0) | 0;
 if ((i1 | 0) == 1) {
  f8 = Math_fround(HEAPF32[i5 >> 2]);
  STACKTOP = i7;
  return Math_fround(f8);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 STACKTOP = i7;
 return Math_fround(f8);
}

function __ZNK9ShaderLab9IntShader13GetDependencyERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = HEAP32[i1 + 132 >> 2] | 0;
 i9 = (HEAP32[i1 + 136 >> 2] | 0) - i11 | 0;
 i10 = (i9 | 0) / 24 | 0;
 if (!i9) {
  i12 = 0;
  return i12 | 0;
 }
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 i7 = i9 << 24 >> 24 < 0;
 i9 = i7 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255;
 i7 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
 i8 = (i9 | 0) == 0;
 i1 = 0;
 L4 : while (1) {
  i4 = i11 + (i1 * 24 | 0) | 0;
  i2 = HEAP8[i4 + 11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  i2 = i2 & 255;
  do if (((i3 ? HEAP32[i11 + (i1 * 24 | 0) + 4 >> 2] | 0 : i2) | 0) == (i9 | 0)) {
   i5 = HEAP32[i4 >> 2] | 0;
   i6 = i3 ? i5 : i4;
   if (i3) {
    if (i8) break L4;
    if (!(_memcmp(i6, i7, i9) | 0)) break L4; else break;
   }
   if (i8) break L4;
   if ((i5 & 255) << 24 >> 24 == (HEAP8[i7 >> 0] | 0)) {
    i3 = i7;
    do {
     i2 = i2 + -1 | 0;
     i4 = i4 + 1 | 0;
     if (!i2) break L4;
     i3 = i3 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i3 >> 0] | 0));
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i10 >>> 0) {
   i1 = 0;
   i12 = 13;
   break;
  }
 }
 if ((i12 | 0) == 13) return i1 | 0;
 i12 = i11 + (i1 * 24 | 0) + 12 | 0;
 return i12 | 0;
}

function __ZNK14RenderSettings28GetGeneratedSkyboxReflectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 384 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN7mecanim9animation12StreamedClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i7 + 4 | 0;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i10 = i8 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i9 >> 2] = i2;
 }
 HEAP32[i7 >> 2] = i1;
 if (!i1) HEAP32[i6 >> 2] = 0; else {
  i2 = i1 << 2;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 4) | 0;
  if ((i3 | 0) != (i3 + (i1 << 2) | 0)) _memset(i3 | 0, 0, i2 | 0) | 0;
  i4 = i6;
  i2 = i3 | 0 ? i3 - i4 | 0 : 0;
  HEAP32[i6 >> 2] = i2;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i8, i2 + i4 | 0, i1 << 2);
 }
 i1 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i10 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  STACKTOP = i11;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
  STACKTOP = i11;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPNS_3Ext20ProfileZoneInterfaceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 660943 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i3, i1) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i9);
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
   i2 = HEAP32[i5 >> 2] | 0;
  } else {
   i2 = HEAP32[i2 >> 2] | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP32[i1 + 4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN15ReflectionProbe5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 128;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP16[i1 + 60 >> 1] = 1;
 f5 = Math_fround(Math_fround(HEAPF32[gb + 62512 >> 2]) * Math_fround(10.0));
 f4 = Math_fround(Math_fround(HEAPF32[gb + 62512 + 4 >> 2]) * Math_fround(10.0));
 f3 = Math_fround(Math_fround(HEAPF32[gb + 62512 + 8 >> 2]) * Math_fround(10.0));
 HEAPF32[i1 + 64 >> 2] = f5;
 HEAPF32[i1 + 68 >> 2] = f4;
 HEAPF32[i1 + 72 >> 2] = f3;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 88 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 96 >> 2] = Math_fround(100.0);
 HEAP8[i1 + 140 >> 0] = 1;
 HEAP8[i1 + 141 >> 0] = 0;
 HEAP32[i1 + 100 >> 2] = -1;
 HEAP8[i1 + 143 >> 0] = 1;
 HEAP32[i1 + 104 >> 2] = 1;
 HEAP32[i1 + 108 >> 2] = 1044694213;
 HEAP32[i1 + 112 >> 2] = 1050319515;
 HEAP32[i1 + 116 >> 2] = 1056109299;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 142 >> 0] = 0;
 HEAP32[i1 + 152 >> 2] = -1;
 return;
}

function __ZN10AudioMixer16CheckConsistencyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i3 = i7;
 i5 = i4 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[gb + 1104264 >> 2] | 0;
  if (!i1) i6 = 7; else {
   if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[i1 + 32 >> 2] | 0;
    i1 = i2 + (i3 << 3) | 0;
   } else {
    __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
    i2 = HEAP32[i2 >> 2] | 0;
    i8 = HEAP32[i1 + 28 >> 2] | 0;
    i3 = HEAP32[gb + 1104264 >> 2] | 0;
    i1 = (i2 | 0) == -1 ? i8 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i8 + (i2 << 3) | 0;
    i2 = HEAP32[i3 + 28 >> 2] | 0;
    i3 = HEAP32[i3 + 32 >> 2] | 0;
   }
   if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i6 = 7; else if (HEAP32[i1 + 4 >> 2] | 0) {
    STACKTOP = i7;
    return;
   }
  }
  if (__Z31ReadObjectFromPersistentManageri(HEAP32[i5 >> 2] | 0) | 0) {
   STACKTOP = i7;
   return;
  }
 }
 HEAP32[i5 >> 2] = HEAP32[HEAP32[i4 + 48 >> 2] >> 2];
 STACKTOP = i7;
 return;
}

function __Z16TransformIndicesPtPKvjjjjb(i8, i1, i2, i9, i3, i4, i10) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + i2 | 0;
 if ((i4 | 0) != 0 & i10) {
  HEAP16[i8 >> 1] = HEAP16[i8 + -2 >> 1] | 0;
  i4 = i4 - i3 | 0;
  HEAP16[i8 + 2 >> 1] = i4 + (HEAPU16[i7 >> 1] | 0);
  i6 = i8 + 4 | 0;
 } else {
  i6 = i8;
  i4 = i4 - i3 | 0;
 }
 i1 = i9 >>> 1;
 i5 = i1 << 1;
 i1 = (i1 | 0) == 0;
 if ((i4 | 0) > -1) {
  if (!i1) {
   i1 = 0;
   i2 = i6;
   i3 = i7;
   while (1) {
    HEAP16[i2 >> 1] = (HEAPU16[i3 >> 1] | 0) + i4;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i5 | 0)) break; else {
     i2 = i2 + 2 | 0;
     i3 = i3 + 2 | 0;
    }
   }
  }
 } else if (!i1) {
  i1 = 0;
  i2 = i6;
  i3 = i7;
  while (1) {
   HEAP16[i2 >> 1] = (HEAPU16[i3 >> 1] | 0) + i4;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i5 | 0)) break; else {
    i2 = i2 + 2 | 0;
    i3 = i3 + 2 | 0;
   }
  }
 }
 if ((i5 | 0) != (i9 | 0)) {
  i5 = i9 + -1 | 0;
  HEAP16[i6 + (i5 << 1) >> 1] = i4 + (HEAPU16[i7 + (i5 << 1) >> 1] | 0);
 }
 i1 = i6 + (i9 << 1) | 0;
 if ((i9 & 1 | 0) == 0 | i10 ^ 1) {
  i9 = i1;
  i10 = i8;
  i10 = i9 - i10 | 0;
  i10 = i10 >> 1;
  return i10 | 0;
 }
 HEAP16[i1 >> 1] = HEAP16[i1 + -2 >> 1] | 0;
 i9 = i1 + 2 | 0;
 i10 = i8;
 i10 = i9 - i10 | 0;
 i10 = i10 >> 1;
 return i10 | 0;
}

function _LzmaDec_DecodeToBuf(i9, i1, i13, i2, i14, i15, i16) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i18 = 0, i19 = 0;
 i19 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i17 = i19;
 i8 = HEAP32[i13 >> 2] | 0;
 i7 = HEAP32[i14 >> 2] | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i14 >> 2] = 0;
 i10 = i9 + 36 | 0;
 i11 = i9 + 40 | 0;
 i12 = i9 + 20 | 0;
 while (1) {
  HEAP32[i17 >> 2] = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
  if ((i3 | 0) == (i4 | 0)) {
   HEAP32[i10 >> 2] = 0;
   i3 = 0;
  }
  i5 = i8 >>> 0 > (i4 - i3 | 0) >>> 0;
  i4 = _LzmaDec_DecodeToDic(i9, i5 ? i4 : i3 + i8 | 0, i2, i17, i5 ? 0 : i15, i16) | 0;
  i5 = HEAP32[i17 >> 2] | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + i5;
  i6 = (HEAP32[i10 >> 2] | 0) - i3 | 0;
  _memcpy(i1 | 0, (HEAP32[i12 >> 2] | 0) + i3 | 0, i6 | 0) | 0;
  i8 = i8 - i6 | 0;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + i6;
  if (i4 | 0) break;
  if ((i6 | 0) == 0 | (i8 | 0) == 0) {
   i1 = 0;
   i18 = 7;
   break;
  } else {
   i1 = i1 + i6 | 0;
   i7 = i7 - i5 | 0;
   i2 = i2 + i5 | 0;
  }
 }
 if ((i18 | 0) == 7) {
  STACKTOP = i19;
  return i1 | 0;
 }
 i18 = i4;
 STACKTOP = i19;
 return i18 | 0;
}

function __ZN9Texture2D13RebuildMipMapEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(HEAP32[i1 + 104 >> 2] & 1)) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 i3 = HEAP32[i1 + 52 >> 2] | 0;
 i9 = i3 + 36 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 do if ((i8 + -10 | 0) >>> 0 >= 3) if (((i8 | 1) + -25 | 0) >>> 0 >= 5) {
  i2 = i8 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i8 + -48 | 0) >>> 0 < 12 | ((i8 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
  } else if ((i8 + -45 | 0) >>> 0 < 3 | (i8 + -48 | 0) >>> 0 < 12) break;
  i4 = i3 + 44 | 0;
  if ((HEAP32[i4 >> 2] | 0) <= 0) return;
  i5 = i3 + 40 | 0;
  i6 = i3 + 8 | 0;
  i7 = i3 + 28 | 0;
  i2 = i3 + 32 | 0;
  __Z12CreateMipMapPhiii13TextureFormat(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] | 0, 1, i8);
  if ((HEAP32[i4 >> 2] | 0) > 1) i1 = 1; else return;
  do {
   i8 = Math_imul(HEAP32[i5 >> 2] | 0, i1) | 0;
   __Z12CreateMipMapPhiii13TextureFormat((HEAP32[i6 >> 2] | 0) + i8 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i2 >> 2] | 0, 1, HEAP32[i9 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410623 | 0, 0, gb + 410682 | 0, 514, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 680709 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 677358 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN4crnd6vectorIhE6assignERKS1_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i3 = i9 + 16 | 0;
 if ((i6 | 0) == (i7 | 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = i6 + 8 | 0;
 i8 = i7 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 do if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) {
  i1 = i6 + 4 | 0;
  if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 } else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1) {
   if (!(i1 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
    HEAP32[i5 >> 2] = gb + 401209;
    HEAP32[i5 + 4 >> 2] = 2513;
    HEAP32[i5 + 8 >> 2] = gb + 401349;
    _sprintf(i3, gb + 401176 | 0, i5) | 0;
    _puts(i3) | 0;
   }
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = i6 + 12 | 0;
  HEAP8[i1 >> 0] = 0;
  if (__ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE(i6, i2, 0, 1, 0) | 0) {
   i1 = i6 + 4 | 0;
   break;
  }
  HEAP8[i1 >> 0] = 1;
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 } while (0);
 _memcpy(HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN26AnimatorControllerPlayable15SetRecorderDataEPN7mecanim9animation16ControllerMemoryERNS0_6memory9AllocatorE(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 16 | 0;
 i5 = i7;
 i6 = i1 + 100 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 108 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = gb + 177508 + 8;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i8 + 8 >> 2] = i9;
 HEAP32[i8 + 12 >> 2] = i1;
 i1 = __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i3, i8, i2) | 0;
 if (!i1) {
  __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(HEAP32[i6 >> 2] | 0, i4);
  i8 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i2 >> 2] | 0, 4) | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = gb + 177508 + 8;
  HEAP32[i5 + 4 >> 2] = i8;
  HEAP32[i5 + 8 >> 2] = i8;
  HEAP32[i5 + 12 >> 2] = i9;
  i9 = __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i3, i5, i2) | 0;
  HEAP32[i6 >> 2] = i9;
  i9 = i9 + 24 | 0;
  HEAP8[i9 >> 0] = 1;
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i6 >> 2] = i1;
  i9 = i1;
  i9 = i9 + 24 | 0;
  HEAP8[i9 >> 0] = 1;
  STACKTOP = i7;
  return;
 }
}

function __ZN16SpriteRenderDataaSERKS_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((i5 | 0) == (i1 | 0)) return i5 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i3 = i5 + 8 | 0;
 i4 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i5 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 i2 = i5 + 36 | 0;
 i4 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP8[i5 + 52 >> 0] = HEAP8[i1 + 52 >> 0] | 0;
 i2 = i1 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 i4 = i5 + 56 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3) {
  i1 = i3 + 4 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
  if (!(HEAP32[i1 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63744 | 0);
  }
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1;
 return i5 | 0;
}

function __ZN14GfxDeviceStats16CopyAllDrawStatsERKS_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 12 | 0;
 i1 = i8 + 8 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8;
 i7 = i3 + 24 | 0;
 i9 = i4 + 24 | 0;
 i10 = i7 + 96 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 if ((i3 | 0) != (i4 | 0)) {
  HEAP32[i5 >> 2] = HEAP32[i4 + 120 >> 2];
  HEAP32[i6 >> 2] = i4 + 124;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_(i3 + 120 | 0, i1, i2);
 }
 i7 = i3 + 4 | 0;
 i9 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i9 + 16 >> 2];
 HEAP32[i3 + 276 >> 2] = HEAP32[i4 + 276 >> 2];
 i7 = i3 + 200 | 0;
 i9 = i4 + 200 | 0;
 i10 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  i7 = i7 + 4 | 0;
  i9 = i9 + 4 | 0;
 } while ((i7 | 0) < (i10 | 0));
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine15PlatformWrapper30GetGraphicsDriverLibraryStringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = __Z15GetGraphicsCapsv() | 0;
 i5 = i2 + 64 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i5 = i8 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i8 ? HEAP32[i2 + 68 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i6 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN10GameObject20AddComponentInternalERS_RN5Unity9ComponentE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 i13 = i2 + 28 | 0;
 i4 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
 i5 = i3;
 i6 = i2 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i2 + 44 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i10 & 2147483647;
 do if (i8 >>> 0 > i11 >>> 0) {
  i1 = i10 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i11 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i13 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i13 >> 2] | 0, i1 << 3, 4, i2 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i13 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i13 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 i13 = HEAP32[i13 >> 2] | 0;
 HEAP32[i13 + (i7 << 3) >> 2] = i4;
 HEAP32[i13 + (i7 << 3) + 4 >> 2] = i5;
 HEAP32[i3 + 28 >> 2] = i2;
 if (!i12) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = i6;
 if ((((HEAP32[i9 >> 2] | 0) - i6 | 0) / 24 | 0) >>> 0 >= i4 >>> 0) return;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 24 | 0) | 0;
 i2 = i5 + (((i2 - i6 | 0) / 24 | 0) * 24 | 0) | 0;
 i7 = i2;
 i5 = i5 + (i4 * 24 | 0) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i7;
  i3 = i6;
 } else {
  i4 = i7;
  do {
   i6 = i3;
   i3 = i3 + -24 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -24 | 0, i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i6 + -12 | 0);
   i2 = i4 + -24 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i9 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + -12 | 0);
  i1 = i1 + -24 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i1, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12 + 4 | 0;
 i5 = i12;
 i4 = HEAP32[gb + 1179016 >> 2] | 0;
 i3 = i4 + 16 | 0;
 i2 = HEAP32[i4 + 28 >> 2] | 0;
 do {
  if (!i2) {
   i10 = 4;
   break;
  }
  i2 = i2 + -1 | 0;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 } while (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i6 | 0) | 0));
 if ((i10 | 0) == 4) i1 = HEAP32[i4 >> 2] | 0;
 i2 = i11 + 1040 | 0;
 HEAP8[i11 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 _strncpy(i11, i6, 1040) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i11 | 0);
 HEAP32[i5 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, i11 | 0, i7 | 0, i8 | 0, i5 | 0, i9 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  STACKTOP = i12;
  return i1 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i11 | 0);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN9Rigidbody26SupportedMessagesDidChangeEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 i4 = i2 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 if (!(i3 & 1)) i6 = (i3 & 3 | 0) == 0 ? 0 : 136192; else i6 = 138240;
 if (!(i3 & 512)) i5 = i4; else {
  __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK9Rigidbody(__Z21GetManagerFromContexti(9) | 0, i2);
  i5 = i4;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 if (i3 | 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i5 >> 2] | 0;
   i4 = mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, i7 | 0, 8, i1 | 0) | 0;
   if (i4 | 0) {
    i2 = 0;
    do {
     i10 = i7 + (i2 << 2) | 0;
     i11 = HEAP32[i10 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 80 >> 2] | 0, i8 | 0, i11 | 0);
     HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & 255 | i6;
     i10 = HEAP32[i10 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 76 >> 2] | 0, i10 | 0, i8 | 0);
     i2 = i2 + 1 | 0;
    } while ((i2 | 0) != (i4 | 0));
   }
   i1 = i4 + i1 | 0;
  } while (i1 >>> 0 < i3 >>> 0);
 }
 STACKTOP = i9;
 return;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 901422 | 0, 0);
 i4 = i2 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 4;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i6;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_PKc17TransferMetaFlags(i2, i5, gb + 901442 | 0, 0);
 i6 = i1 + 8 | 0;
 __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 901463 | 0, 0);
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1 + 12;
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i5 + 8 >> 2] = i4;
 __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags(i2, i5, gb + 901476 | 0, 0);
 __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim10ValueArrayEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 16 | 0, gb + 901491 | 0, 0);
 i4 = i1 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i5, gb + 901500 | 0, 0);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 901512 | 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx8debugger8renderer19PvdUserRenderParser6createERNS_19PxAllocatorCallbackEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 if (i3) {
  i3 = mftCall_iiiiii(i1 | 0, i2 | 0, 56, gb + 777429 | 0, gb + 776633 | 0, 347) | 0;
  HEAP32[i3 >> 2] = gb + 150932 + 8;
  HEAP32[i3 + 4 >> 2] = i2;
  i1 = i3 + 8 | 0;
  HEAP32[i3 + 12 >> 2] = i2;
  HEAP32[i3 + 16 >> 2] = gb + 777442;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = gb + 148684 + 8;
  HEAP32[i3 + 32 >> 2] = gb + 150956 + 8;
  HEAP32[i3 + 36 >> 2] = gb + 148700 + 8;
  HEAP32[i3 + 40 >> 2] = 0;
  HEAP32[i3 + 44 >> 2] = 0;
  HEAP8[i3 + 48 >> 0] = 1;
  HEAP32[i3 + 52 >> 2] = i1;
  return i3 | 0;
 } else {
  i3 = mftCall_iiiiii(i1 | 0, i2 | 0, 56, gb + 777471 | 0, gb + 776633 | 0, 348) | 0;
  HEAP32[i3 >> 2] = gb + 151008 + 8;
  HEAP32[i3 + 4 >> 2] = i2;
  i1 = i3 + 8 | 0;
  HEAP32[i3 + 12 >> 2] = i2;
  HEAP32[i3 + 16 >> 2] = gb + 777442;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i1 >> 2] = gb + 148684 + 8;
  HEAP32[i3 + 32 >> 2] = gb + 151032 + 8;
  HEAP32[i3 + 36 >> 2] = gb + 148700 + 8;
  HEAP32[i3 + 40 >> 2] = 0;
  HEAP32[i3 + 44 >> 2] = 0;
  HEAP8[i3 + 48 >> 0] = 1;
  HEAP32[i3 + 52 >> 2] = i1;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 702818 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 723211 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 691225 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Sc8ShapeSim21destroyLowLevelVolumeEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i9 + 12 + 4 >> 2] | 0;
 i8 = i7 & 1073741823;
 if ((i8 | 0) != 1073741823) {
  i1 = HEAP32[(HEAP32[(HEAP32[i9 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0;
  i4 = i1 + 5912 | 0;
  i5 = (i8 + 32 | 0) >>> 5;
  i6 = i1 + 5916 | 0;
  if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
   i2 = i1 + 5920 | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 2, gb + 769739 | 0, 329) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    _memcpy(i1 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
   }
   i3 = HEAP32[i6 >> 2] | 0;
   _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
  } else i1 = HEAP32[i4 >> 2] | 0;
  i8 = i1 + (i8 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~(1 << (i7 & 31));
 }
 i2 = __ZN5physx2Sc7Element21destroyLowLevelVolumeEv(i9) | 0;
 if (!i2) return i2 | 0;
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 i9 = HEAP8[i1 + 50 >> 0] | 0;
 if ((i1 | 0) == 0 | i9 << 24 >> 24 != 4 & i9 << 24 >> 24 != 1) return i2 | 0;
 HEAP32[i1 + 132 >> 2] = 1073741823;
 HEAP32[i1 + 136 >> 2] = 1073741823;
 return i2 | 0;
}

function __ZN14EdgeCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i2, i1);
 i7 = i2 + 172 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 + 4 | 0;
 i8 = i1 + 24 | 0;
 if (i6 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i9 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i3, 4);
 i1 = HEAP32[i2 + 160 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i6 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i9 >> 2] = i3;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
   i3 = HEAP32[i9 >> 2] | 0;
   i4 = HEAP32[i8 >> 2] | 0;
  }
  i2 = i1 + 4 | 0;
  i5 = i3 + 4 | 0;
  if (i5 >>> 0 < i4 >>> 0) {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i9 >> 2] = i5;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i10;
 return;
}

function __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 12 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 * 12 | 0) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i10 = i3 + (i1 * 12 | 0) | 0;
  HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i10 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i10 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN12_GLOBAL__N_110DataStream23appendPropertyValueDataEN5physx8debugger7DataRefIKhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 48 | 0;
 i9 = i3 + 24 | 0;
 i6 = i3 + 16 | 0;
 i4 = i3;
 i7 = i1 + 4 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i5 = ((i10 - i11 | 0) >>> 0) / ((HEAP32[i2 + 264 >> 2] | 0) >>> 0) | 0;
 i12 = i2 + 264 | 0;
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i12 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i2 + 276 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i2 + 280 >> 2];
 HEAP32[i6 >> 2] = i11;
 HEAP32[i6 + 4 >> 2] = i10;
 __ZN12_GLOBAL__N_110DataStream19bufferPropertyValueEN5physx8debugger24ClassDescriptionSizeInfoENS2_7DataRefIKhEE(i8, i2, i9, i6);
 i6 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i4 >> 2] = gb + 150200 + 8;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i5;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i4, 9);
 STACKTOP = i3;
 return (HEAPU8[i2 + 392 >> 0] | 0) ^ 1 | 0;
}

function __Z8StripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 40 | 0;
 i5 = i10 + 28 | 0;
 i9 = i10;
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = i3 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) != (i6 | 0)) HEAP32[i7 >> 2] = i8 + (~((i8 + -4 - i6 | 0) >>> 2) << 2);
 if (!i2) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = (i2 | 0) / 3 | 0;
 __ZN7StriperC2Ev(i9);
 if (__ZN7Striper4InitER13STRIPERCREATE(i9, i4) | 0) if (__ZN7Striper7ComputeER13STRIPERRESULT(i9, i5) | 0) if ((HEAP32[i5 >> 2] | 0) == 1) {
  i1 = HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0;
  i8 = HEAP32[i5 + 8 >> 2] | 0;
  __Z15reserve_trimmedINSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEEvRT_j(i3, i1);
  __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i3, i8, i8 + (i1 << 2) | 0);
  i1 = 1;
 } else i1 = 0; else i1 = 0; else i1 = 0;
 __ZN7StriperD2Ev(i9);
 i9 = i1;
 STACKTOP = i10;
 return i9 | 0;
}

function _gzwrite(i3, i4, i11) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0, i13 = 0, i14 = 0;
 if (!i3) {
  i13 = -2;
  return i13 | 0;
 }
 if ((HEAP8[i3 + 92 >> 0] | 0) != 119) {
  i13 = -2;
  return i13 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i12 = i3 + 4 | 0;
 HEAP32[i12 >> 2] = i11;
 L7 : do if (i11 | 0) {
  i13 = i3 + 16 | 0;
  i5 = i3 + 72 | 0;
  i6 = i3 + 12 | 0;
  i7 = i3 + 64 | 0;
  i8 = i3 + 100 | 0;
  i9 = i3 + 104 | 0;
  i10 = i3 + 56 | 0;
  i1 = HEAP32[i13 >> 2] | 0;
  i2 = i11;
  while (1) {
   if (!i1) {
    i2 = HEAP32[i5 >> 2] | 0;
    HEAP32[i6 >> 2] = i2;
    if ((_fwrite(i2, 1, 16384, HEAP32[i7 >> 2] | 0) | 0) != 16384) break;
    HEAP32[i13 >> 2] = 16384;
    i2 = HEAP32[i12 >> 2] | 0;
    i1 = 16384;
   }
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i2;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + i1;
   i14 = _unity_z_deflate(i3, 0) | 0;
   HEAP32[i10 >> 2] = i14;
   i2 = HEAP32[i12 >> 2] | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) - i2;
   i1 = HEAP32[i13 >> 2] | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) - i1;
   if ((i14 | 0) != 0 | (i2 | 0) == 0) break L7;
  }
  HEAP32[i10 >> 2] = -1;
 } while (0);
 i14 = i3 + 76 | 0;
 HEAP32[i14 >> 2] = _unity_z_crc32(HEAP32[i14 >> 2] | 0, i4, i11) | 0;
 i14 = i11 - (HEAP32[i12 >> 2] | 0) | 0;
 return i14 | 0;
}

function __ZNSt3__211__libcpp_db9__erase_cEPv(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i2 = i6 + 4 | 0;
 L1 : do if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i6 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i5;
  i1 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i7 + 4 | 0, i1, 4) | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  i4 = i4 + (((i1 >>> 0) % ((HEAP32[i2 >> 2] | 0) - i4 >> 2 >>> 0) | 0) << 2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i3 = 0;
   while (1) {
    if ((HEAP32[i1 + 4 >> 2] | 0) == (i5 | 0)) break;
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i2) break L1; else {
     i3 = i1;
     i1 = i2;
    }
   }
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if (!i3) HEAP32[i4 >> 2] = i2; else HEAP32[i3 + 8 >> 2] = i2;
   i3 = i1 + 16 | 0;
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   while (1) {
    if ((i4 | 0) == (i2 | 0)) break;
    i5 = i4 + -4 | 0;
    HEAP32[i3 >> 2] = i5;
    HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] = 0;
    i4 = i5;
   }
   _free(i2);
   _free(i1);
   i6 = i6 + 8 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  }
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 STACKTOP = i7;
 return;
}

function __ZNK27AnimatorControllerParameter13GetControllerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 683787 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_21GuMeshFactoryListenerENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 768699 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 691095 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER14SafeBinaryRead(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i4, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 801045 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i4, i5);
   i2 = i4 + 160 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 842535 | 0, HEAP32[gb + 37320 >> 2] | 0, i3, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
   __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN17CapsuleCollider2D16CapsuleDirectionEEvRT_RT0_PKc17TransferMetaFlags(i5, i4 + 168 | 0, gb + 801063 | 0, 0);
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN13b2DynamicTree12AllocateNodeEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i2 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if ((i1 | 0) == -1) {
  i3 = HEAP32[i4 >> 2] | 0;
  i6 = i2 + 12 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = i1 << 1;
  i1 = __Z7b2Alloci(i1 * 72 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  i5 = i2 + 8 | 0;
  _memcpy(i1 | 0, i3 | 0, (HEAP32[i5 >> 2] | 0) * 36 | 0) | 0;
  __Z6b2FreePv(i3);
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) < (i1 | 0)) do {
   i1 = i3;
   i3 = i3 + 1 | 0;
   HEAP32[i2 + (i1 * 36 | 0) + 20 >> 2] = i3;
   HEAP32[i2 + (i1 * 36 | 0) + 32 >> 2] = -1;
   i1 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  } while ((i3 | 0) < (i1 | 0));
  HEAP32[i2 + (i1 * 36 | 0) + 20 >> 2] = -1;
  HEAP32[i2 + (((HEAP32[i6 >> 2] | 0) + -1 | 0) * 36 | 0) + 32 >> 2] = -1;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  i3 = i5;
 } else {
  i3 = i2 + 8 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 }
 i6 = i2 + (i1 * 36 | 0) + 20 | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = -1;
 HEAP32[i2 + (i1 * 36 | 0) + 24 >> 2] = -1;
 HEAP32[i2 + (i1 * 36 | 0) + 28 >> 2] = -1;
 HEAP32[i2 + (i1 * 36 | 0) + 32 >> 2] = 0;
 HEAP32[i2 + (i1 * 36 | 0) + 16 >> 2] = 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZN13ComputeShader21DispatchComputeShaderEj15ComputeBufferIDj(i8, i9, i3, i4) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 12 | 0;
 i1 = i10 + 8 | 0;
 i5 = i10 + 4 | 0;
 i6 = i10;
 if (!(__ZN13ComputeShader14BeforeDispatchEj(i8, i9) | 0)) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 i11 = __Z12GetGfxDevicev() | 0;
 i12 = HEAP32[(HEAP32[i11 >> 2] | 0) + 832 >> 2] | 0;
 i7 = i8 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i9 * 976 | 0) >> 2];
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 mftCall_viiii(i12 | 0, i11 | 0, i1 | 0, i2 | 0, i4 | 0);
 __Z15gpu_time_samplev();
 i6 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i8, 22, 0) | 0;
 i6 = (HEAP32[i6 + 24 >> 2] | 0) - (HEAP32[i6 + 20 >> 2] | 0) | 0;
 i4 = (i6 | 0) / 20 | 0;
 if (!i6) {
  i12 = 1;
  STACKTOP = i10;
  return i12 | 0;
 }
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = i8 + 60 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i3 + (i9 * 976 | 0) + 4 + (i1 << 2) >> 2] | 0) > -1) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(1 << i1);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i1 = 1;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN12SoundManager10UnloadClipEP10SampleClip(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __ZNK10SampleClip11GetResourceEv(i7) | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i2 = i1;
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i1;
  i1 = i2;
  do {
   i2 = i3;
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (__ZN16StreamedResourceeqERKS_(i1 + 64 | 0, i5) | 0) __ZN11SoundHandle8Instance7DisposeEv(i1);
   i1 = i3;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = i6 + 16 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i4 + 8 >> 2] | 0;
  if (__ZN16StreamedResourceeqERKS_(i2 + 64 | 0, i5) | 0) __ZN11SoundHandle8Instance7DisposeEv(i2);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i2 = HEAP32[i6 + 28 >> 2] | 0;
 i3 = i6 + 24 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i6 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = HEAP32[i6 + 8 >> 2] | 0;
  __ZN11SoundHandle8InstanceD2Ev(i6);
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63328 | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 i1 = i7 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i7 = i7 + 112 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN10AudioMixer8TransferI17RemapPPtrTransferEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i6, i7);
 i2 = i6 + 92 | 0;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i7 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 i8 = i7 + 40 | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 i2 = HEAP32[i6 + 60 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i2 = i6 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  i6 = i6 + 32 | 0;
  i8 = i7 + 4 | 0;
  HEAP32[i8 >> 2] = i6;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i6 = i6 + 32 | 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = i6;
 return;
}

function __Z25GetNextAllowedTextureSizeib13TextureFormat(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 do if ((i3 + -10 | 0) >>> 0 < 3) {
  i1 = i2 + 3 & -4;
  i5 = 10;
 } else {
  if (((i3 | 1) + -25 | 0) >>> 0 < 5) {
   i1 = i2 + 3 & -4;
   i5 = 10;
   break;
  }
  switch (i3 | 0) {
  case 34:
  case 35:
  case 36:
  case 45:
  case 46:
  case 47:
   {
    i1 = 4;
    break;
   }
  default:
   i1 = (i3 + -41 | 0) >>> 0 < 4 ? 4 : 1;
  }
  i1 = i2 + -1 + i1 & 0 - i1;
  i2 = i3 + -30 | 0;
  if (i2 >>> 0 < 15) if ((i3 + -48 | 0) >>> 0 < 12 | ((i3 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
   i5 = 10;
   break;
  } else break; else if ((i3 + -45 | 0) >>> 0 < 3 | (i3 + -48 | 0) >>> 0 < 12) {
   i5 = 10;
   break;
  } else break;
 } while (0);
 if ((i5 | 0) == 10) if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0) < 2) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 492 >> 0] | 0) {
  i1 = i1 + -1 | 0;
  i1 = i1 >>> 16 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = (i1 >>> 1 | i1) + 1 | 0;
 }
 i5 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0;
 if (i4 ? (i5 | 0) == 2 : (i5 | 0) > 0) {
  i5 = i1;
  return i5 | 0;
 }
 i5 = i1 + -1 | 0;
 i5 = i5 >>> 16 | i5;
 i5 = i5 >>> 8 | i5;
 i5 = i5 >>> 4 | i5;
 i5 = i5 >>> 2 | i5;
 i5 = (i5 >>> 1 | i5) + 1 | 0;
 return i5 | 0;
}

function _mbtowc(i1, i6, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 L1 : do if (!i6) i1 = 0; else {
  do if (i4 | 0) {
   i5 = (i1 | 0) == 0 ? i2 : i1;
   i1 = HEAP8[i6 >> 0] | 0;
   i2 = i1 & 255;
   if (i1 << 24 >> 24 > -1) {
    HEAP32[i5 >> 2] = i2;
    i1 = i1 << 24 >> 24 != 0 & 1;
    break L1;
   }
   i1 = i2 + -194 | 0;
   if (i1 >>> 0 <= 50) {
    i2 = i6 + 1 | 0;
    i3 = HEAP32[gb + 191408 + (i1 << 2) >> 2] | 0;
    if (i4 >>> 0 < 4) if (i3 & -2147483648 >>> ((i4 * 6 | 0) + -6 | 0) | 0) break;
    i1 = HEAPU8[i2 >> 0] | 0;
    i4 = i1 >>> 3;
    if ((i4 + -16 | i4 + (i3 >> 26)) >>> 0 <= 7) {
     i1 = i1 + -128 | i3 << 6;
     if ((i1 | 0) >= 0) {
      HEAP32[i5 >> 2] = i1;
      i1 = 2;
      break L1;
     }
     i2 = (HEAPU8[i6 + 2 >> 0] | 0) + -128 | 0;
     if (i2 >>> 0 <= 63) {
      i2 = i2 | i1 << 6;
      if ((i2 | 0) >= 0) {
       HEAP32[i5 >> 2] = i2;
       i1 = 3;
       break L1;
      }
      i1 = (HEAPU8[i6 + 3 >> 0] | 0) + -128 | 0;
      if (i1 >>> 0 <= 63) {
       HEAP32[i5 >> 2] = i1 | i2 << 6;
       i1 = 4;
       break L1;
      }
     }
    }
   }
  } while (0);
  HEAP32[(___errno_location() | 0) >> 2] = 84;
  i1 = -1;
 } while (0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK12MeshRenderer26GetAdditionalVertexStreamsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 380 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 701805 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i3 = i1 + 40 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = -2;
 i3 = i6 + 12 | 0;
 i4 = i6 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP8[i1 + 51 >> 0] & 14) == 4) {
  i5 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
  if (i2 >>> 0 >= i5 >>> 0) return;
  HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 40 >> 2] = i2;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 | 0) == (i1 | 0)) {
  i5 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  i4 = HEAP32[i6 >> 2] | 0;
  HEAP32[i4 + (i2 << 2) >> 2] = HEAP32[i4 + (i5 << 2) >> 2];
  if (i2 >>> 0 < i5 >>> 0) HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 40 >> 2] = i2;
 } else {
  i1 = i1 + -1 | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   i7 = HEAP32[i6 >> 2] | 0;
   i8 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
   HEAP32[i8 + 40 >> 2] = i2;
   HEAP32[i7 + (i2 << 2) >> 2] = i8;
  }
  i7 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i7;
  i8 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i8 + (i7 << 2) >> 2];
  HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 40 >> 2] = i1;
 }
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 return;
}

function __ZN4FMOD6Reverb7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 308 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i3 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i3 + 308 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
   i1 = i6 + 12 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   HEAP8[i6 + 16 >> 0] = 1;
   i1 = i6 + 24 | 0;
   i5 = i6 + 32 | 0;
   i6 = i6 + 28 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   i2 = i3 + 288 | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 >> 2] = i3 + 284;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] = i1;
   HEAP32[i2 >> 2] = i1;
   i2 = i3 + 280 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i3 = i3 + 276 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853481;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i4 = i6 + 4 | 0;
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i8 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i8 = i6 + 16 | 0;
  __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i8, i7);
  return;
 }
}

function __Z48AddToTimeSliceAwakeFromLoadQueueProgressCallbackR6ObjectPv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i1 = i5;
 __ZN18AsyncUploadManager13GetAsyncFenceEP6Object(i1, __Z21GetAsyncUploadManagerv() | 0, i2);
 if (HEAP32[i1 + 4 >> 2] | 0) {
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i7 = i1;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = i6;
  HEAP32[i4 + 8 >> 2] = i2;
  __ZN19RingbufferTemplates22WriteValueToRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RKT_(i3 + 32 | 0, i4) | 0;
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
 if ((i1 - (HEAP32[gb + 65780 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 65780 + 28 >> 2] | 0) >>> 0) if ((i1 - (HEAP32[gb + 26572 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 26572 + 28 >> 2] | 0) >>> 0) if ((i1 - (HEAP32[gb + 30832 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 30832 + 28 >> 2] | 0) >>> 0) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_(i3, i4) | 0;
 STACKTOP = i5;
 return;
}

function __Z24WWW_Get_Custom_PropBytesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 580408 | 0, 171, 1, 0, 0, 0);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0)) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0)) {
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 i4 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
 i1 = (i4 | 0) == 0 ? 0 : i1;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 1, i1) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0, i4 | 0, i1 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = (HEAP8[i2 >> 0] | 0) == 0 ? i5 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i5;
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i4 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i6 = i2;
 }
 HEAP32[i5 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i5 + 4 | 0;
 i2 = i6 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i8, 4);
  i8 = HEAP32[i8 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i8 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN9ShaderLab7ProgramD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP32[i5 >> 2] = gb + 68900 + 8;
 i6 = i5 + 8 | 0;
 i3 = i5 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = 0;
  do {
   if (HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0) {
    i1 = __Z12GetGfxDevicev() | 0;
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0);
    i1 = HEAP32[i3 >> 2] | 0;
   }
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 i1 = i5 + 172 | 0;
 if ((HEAP32[i5 + 188 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 176 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 140 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i5 + 164 >> 2] | 0;
  HEAP32[i4 >> 2] = 65;
  HEAP32[i4 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i1 = i5 + 28 | 0;
 if ((HEAP32[i5 + 44 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 32 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i5 + 24 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + 12 | 0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Cct15ObstacleContextENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 657754 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc16ArticulationCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 681089 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx2Sc5Actor20activateInteractionsEj(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i7 = HEAP32[i6 + 28 >> 2] | 0;
 i5 = i6 + 44 | 0;
 i4 = HEAP16[i5 >> 1] | 0;
 i1 = i4 & 65535;
 if (i4 << 16 >> 16) {
  i3 = i6 + 20 | 0;
  i4 = i6 + 36 | 0;
  i1 = 0;
  i2 = 0;
  while (1) {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (!(__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[i4 >> 2] | 0, i1) | 0)) if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i8 | 0) | 0) __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE(HEAP32[i4 >> 2] | 0, i1);
   i2 = i2 + 1 << 16 >> 16;
   i9 = HEAP16[i5 >> 1] | 0;
   i1 = i9 & 65535;
   if ((i2 & 65535) < (i9 & 65535)) i1 = i2 & 65535; else break;
  }
 }
 if (i1 >>> 0 >= i7 >>> 0) return;
 i4 = i6 + 20 | 0;
 i3 = i6 + 36 | 0;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (!(__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2) | 0)) if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i8 | 0) | 0) __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN5physx15PxsParticleData16removeParticlesVEjRKNS_16PxStrideIteratorIKjEE(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (i6 | 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i7 + 48 >> 2] | 0;
  i3 = HEAP32[i7 + 56 >> 2] | 0;
  i4 = 0;
  do {
   i10 = HEAP32[i5 + (Math_imul(HEAP32[i1 >> 2] | 0, i4) | 0) >> 2] | 0;
   HEAP16[i2 + (i10 << 5) + 28 >> 1] = 0;
   i9 = i3 + (i10 >>> 5 << 2) | 0;
   HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << (i10 & 31));
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i6 | 0));
 }
 i9 = i7 + 20 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i10 - i6;
 if ((i10 | 0) == (i6 | 0)) {
  i9 = 0;
  i10 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = i9;
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i7 + 60 >> 2] & 2147483647;
 while (1) {
  i1 = i2 + -1 | 0;
  if (!i2) {
   i1 = 1;
   i8 = 9;
   break;
  }
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (!i2) i2 = i1; else break;
 }
 if ((i8 | 0) == 9) {
  i10 = i7 + 16 | 0;
  HEAP32[i10 >> 2] = i1;
  return;
 }
 i9 = i2 >>> 1 | i2;
 i9 = i9 >>> 2 | i9;
 i9 = i9 >>> 4 | i9;
 i9 = i9 >>> 8 | i9;
 i9 = (Math_imul(i9 >>> 16 | i9, 130329821) | 0) >>> 27;
 i9 = (i1 << 5 | 1) + (HEAP32[gb + 85120 + (i9 << 2) >> 2] | 0) | 0;
 i10 = i7 + 16 | 0;
 HEAP32[i10 >> 2] = i9;
 return;
}

function __ZN5Umbra10QueryState23findTomeByClusterPortalEi(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 if ((i7 | 0) < 0) {
  i7 = -1;
  return i7 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP32[i4 + 180 >> 2] | 0)) {
  i1 = (HEAP32[i4 + 124 >> 2] | 0) + -1 | 0;
  i6 = i4 + (HEAP32[i4 + 128 >> 2] | 0) | 0;
  i1 = (HEAP32[i6 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0) | 0;
 } else i1 = HEAP32[i4 + (HEAP32[i4 + 184 >> 2] | 0) + (HEAP32[i4 + 176 >> 2] << 2) >> 2] | 0;
 if ((i1 | 0) <= (i7 | 0)) {
  i7 = -1;
  return i7 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i3) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 if ((i1 | 0) <= (i7 | 0)) if ((i7 - i1 | 0) < (HEAP32[i2 + 116 >> 2] | 0)) {
  i7 = HEAP32[i2 + 92 >> 2] | 0;
  return i7 | 0;
 }
 i1 = HEAP32[i4 + 184 >> 2] | 0;
 i5 = i2 + 84 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + 1;
 i4 = (i1 | 0) == 0 ? 0 : i4 + i1 | 0;
 i1 = i3 + -1 | 0;
 if ((i1 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  do {
   i3 = (i1 + 1 + i2 | 0) / 2 | 0;
   i8 = (HEAP32[i4 + (i3 << 2) >> 2] | 0) > (i7 | 0);
   i1 = i8 ? i1 : i3;
   i2 = i8 ? i3 + -1 | 0 : i2;
  } while ((i2 | 0) > (i1 | 0));
 } else i1 = 0;
 HEAP32[i5 >> 2] = i6;
 i8 = i1;
 return i8 | 0;
}

function __ZN16Physics2DManager26SetTransformMessageEnabledEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i4 + 616 >> 2] | 0;
 if (!i6) {
  i7 = i4 + 624 | 0;
  i6 = i5 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 }
 i7 = i4 + 604 | 0;
 if (i5) {
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i3 = __ZN14MessageHandler3GetEv() | 0;
   i2 = HEAP32[i2 + 24 >> 2] | 0;
   if ((i2 | 0) != -2147483648) {
    i2 = (Math_imul(HEAP32[i3 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i2 | 0;
    i3 = (HEAP32[i3 + 16 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i2 & 31);
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  i7 = i4 + 624 | 0;
  i6 = i5 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 } else {
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i2 = __ZN14MessageHandler3GetEv() | 0;
   i3 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i3 | 0) != -2147483648) {
    i8 = (Math_imul(HEAP32[i2 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + i3 | 0;
    i3 = (HEAP32[i2 + 16 >> 2] | 0) + (i8 >>> 5 << 2) | 0;
    HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~(1 << (i8 & 31));
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
  i8 = i4 + 624 | 0;
  i7 = i5 & 1;
  HEAP8[i8 >> 0] = i7;
  return;
 }
}

function __ZN15AudioEchoFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853458 | 0, HEAP32[gb + 37304 >> 2] | 0, i1 + 44 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855589 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855602 | 0, i5, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853419 | 0, i5, i1 + 52 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZNK11Rigidbody2D12OverlapPointERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7 + 8 | 0;
 i9 = i7;
 i6 = i7 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i1 = (__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i1, i6) | 0) == 0;
 L1 : do if (i1 | (HEAP32[i3 >> 2] | 0) == 0) i1 = 0; else {
  i1 = HEAP32[i6 >> 2] | 0;
  while (1) {
   if (__ZNK10Collider2D12OverlapPointERK8Vector2f(HEAP32[i1 >> 2] | 0, i2) | 0) {
    i1 = 1;
    break L1;
   }
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == ((HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN8UVModule5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 536 >> 2] = 1;
 HEAP32[i1 + 540 >> 2] = 1;
 HEAP32[i1 + 544 >> 2] = 0;
 HEAP32[i1 + 548 >> 2] = 0;
 HEAPF32[i1 + 552 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 560 >> 2] = -1;
 HEAP8[i1 + 556 >> 0] = 1;
 i6 = i1 + 352 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i5 = i1 + 272 | 0;
 i4 = i1 + 360 | 0;
 i3 = i1 + 356 | 0;
 i2 = i1 + 358 | 0;
 HEAP8[i2 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i5, i4, Math_fround(0.0), HEAP16[i3 >> 1] | 0) | 0) & 1;
 i7 = i1 + 8 | 0;
 HEAP16[i1 + 92 >> 1] = 1;
 HEAPF32[i1 + 88 >> 2] = Math_fround(.999899983);
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i7, i1 + 96 | 0, Math_fround(.999899983), 1) | 0) & 1;
 __Z26SetPolynomialCurveToLinearR17AnimationCurveTplIfER24OptimizedPolynomialCurve(i1 + 96 | 0, i7);
 __Z26SetPolynomialCurveToLinearR17AnimationCurveTplIfER24OptimizedPolynomialCurve(i1 + 184 | 0, i1 + 48 | 0);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAP8[i2 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i5, i4, Math_fround(0.0), HEAP16[i3 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 564 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 568 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPFvRNS_14PxOutputStreamEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 667867 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN14Texture2DArrayC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 76 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 46032 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 5;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 1;
 HEAP8[i1 + 110 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEjRKj(i7, i10, i8) {
 i7 = i7 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i11 = i7 + 4 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 i3 = i4;
 if (i2 - i4 >> 2 >>> 0 >= i10 >>> 0) {
  i1 = i10;
  i2 = i3;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 4 | 0;
  }
  HEAP32[i11 >> 2] = i3 + (i10 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = (i4 - i1 >> 2) + i10 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i11 >> 2] | 0;
 }
 i6 = i2 - i1 | 0;
 i2 = i6 >> 1;
 i2 = i6 >> 2 >>> 0 < 536870911 ? (i2 >>> 0 < i3 >>> 0 ? i3 : i2) : 1073741823;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 << 2) | 0;
 i6 = i3 + (i4 - i1 >> 2 << 2) | 0;
 i5 = i3 + (i2 << 2) | 0;
 i2 = i10;
 i3 = i6;
 while (1) {
  HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 4 | 0;
 }
 i2 = i4 - i1 | 0;
 i3 = i6 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i11 >> 2] = i6 + (i10 << 2);
 HEAP32[i9 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK8Animator28GetRuntimeAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 678953 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx2Sc18ParticleSystemCore15exportExtraDataERNS_22PxSerializationContextE(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i5 = i8;
 i4 = i2 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx15PxsParticleData10exportDataERNS_22PxSerializationContextE(i1, i7);
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 12;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 12;
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 4;
 HEAP32[i6 + 40 >> 2] = 0;
 HEAP32[i6 + 44 >> 2] = 4;
 i3 = i2 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2) i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i2) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i6 | 0, 1, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = HEAP32[i4 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i1 | 0);
 i6 = __ZN5physx15PxsParticleData6createERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E(i6, i5) | 0;
 __ZN5physx15PxsParticleData10exportDataERNS_22PxSerializationContextE(i6, i7);
 __ZN5physx15PxsParticleData7releaseEv(i6);
 STACKTOP = i8;
 return;
}

function __ZN4FMOD3DSP7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i3 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[(HEAP32[i3 + 260 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
   i1 = i6 + 12 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   HEAP8[i6 + 16 >> 0] = 1;
   i1 = i6 + 24 | 0;
   i5 = i6 + 32 | 0;
   i6 = i6 + 28 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 + 8 >> 2] = HEAP32[i5 >> 2];
   HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i2;
   HEAP32[i6 >> 2] = i1;
   i2 = i3 + 240 | 0;
   HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i5 >> 2] = i3 + 236;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] = i1;
   HEAP32[i2 >> 2] = i1;
   i2 = i3 + 232 | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   i3 = i3 + 228 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853481;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN19ComputeShaderKernelD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i5 + 80 >> 2] | 0) > -1) {
  i4 = i5 + 64 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i5 + 68 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i4 = HEAP32[i5 + 52 >> 2] | 0;
 i1 = i4;
 if (i4 | 0) {
  i2 = i5 + 56 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -20 - i1 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i4);
 }
 i1 = HEAP32[i5 + 40 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 44 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 32 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
 __ZdlPv(i3);
 return;
}

function _UNITY_png_set_cHRM(i17, i18, d2, d4, d6, d8, d10, d12, d14, d16) {
 i17 = i17 | 0;
 i18 = i18 | 0;
 d2 = +d2;
 d4 = +d4;
 d6 = +d6;
 d8 = +d8;
 d10 = +d10;
 d12 = +d12;
 d14 = +d14;
 d16 = +d16;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0, i9 = 0, i11 = 0, i13 = 0, i15 = 0, i19 = 0, i20 = 0;
 i20 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i19 = i20;
 i15 = _UNITY_png_fixed(i17, d2, gb + 354105 | 0) | 0;
 i13 = _UNITY_png_fixed(i17, d4, gb + 354118 | 0) | 0;
 i11 = _UNITY_png_fixed(i17, d6, gb + 354131 | 0) | 0;
 i9 = _UNITY_png_fixed(i17, d8, gb + 354142 | 0) | 0;
 i7 = _UNITY_png_fixed(i17, d10, gb + 354153 | 0) | 0;
 i5 = _UNITY_png_fixed(i17, d12, gb + 354166 | 0) | 0;
 i3 = _UNITY_png_fixed(i17, d14, gb + 354179 | 0) | 0;
 i1 = _UNITY_png_fixed(i17, d16, gb + 354191 | 0) | 0;
 if ((i17 | 0) == 0 | (i18 | 0) == 0) {
  STACKTOP = i20;
  return;
 }
 HEAP32[i19 >> 2] = i11;
 HEAP32[i19 + 4 >> 2] = i9;
 HEAP32[i19 + 8 >> 2] = i7;
 HEAP32[i19 + 12 >> 2] = i5;
 HEAP32[i19 + 16 >> 2] = i3;
 HEAP32[i19 + 20 >> 2] = i1;
 HEAP32[i19 + 24 >> 2] = i15;
 HEAP32[i19 + 28 >> 2] = i13;
 if (_UNITY_png_colorspace_set_chromaticities(i17, i18 + 40 | 0, i19, 2) | 0) {
  i19 = i18 + 114 | 0;
  HEAP16[i19 >> 1] = HEAPU16[i19 >> 1] | 0 | 16;
 }
 _UNITY_png_colorspace_sync_info(i17, i18);
 STACKTOP = i20;
 return;
}

function __ZNK20LightPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 if (HEAP8[i2 + 15 >> 0] | 0) {
  i4 = -1;
  return i4 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 if ((HEAP32[i3 + 4 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 8 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 16 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 20 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 24 >> 2] | 0) == (i1 | 0)) {
  i4 = 100001;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 28 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 32 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 36 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 40 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 44 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 48 >> 2] | 0) == (i1 | 0)) {
  i4 = 100002;
  return i4 | 0;
 }
 i4 = (HEAP32[i3 + 52 >> 2] | 0) == (i1 | 0) ? 100002 : -1;
 return i4 | 0;
}

function __ZNK14RenderSettings20GetDefaultSpotCookieEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 348 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx7NpCloth16lockParticleDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i6 = i5 + 12 | 0;
 i2 = i3 + 128 | 0;
 HEAP8[i6 >> 0] = HEAP8[i1 >> 0] | 0;
 if (!(__ZN5physx19NpClothParticleData7tryLockENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i6) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 698503 | 0, 896, gb + 698578 | 0, i5);
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 5; else i1 = 6;
   break;
  }
 default:
  i1 = 5;
 }
 if ((i1 | 0) == 5) {
  __ZN5physx2Sc9ClothCore15getParticleDataERNS_19PxClothParticleDataE(i3 + 32 | 0, i2);
  i6 = i2;
  STACKTOP = i5;
  return i6 | 0;
 } else if ((i1 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1020, gb + 698678 | 0, i4);
  HEAP32[i3 + 132 >> 2] = 0;
  HEAP32[i3 + 136 >> 2] = 0;
  i6 = i2;
  STACKTOP = i5;
  return i6 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i9 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i1 = i8 << 2;
  if (!i1) i4 = 0; else {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i3 | 0, i5 | 0, i1 | 0, (i4 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i5 = i9 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i6 >> 2];
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i7 >> 2] = i8;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i9 + 1;
 return i4 + (i9 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679081 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx3Ext18ProfileZoneHandler11onZoneAddedERNS_13PxProfileZoneE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = HEAP32[i6 + 20 >> 2] | 0;
 if (!(_strstr(i4, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i3 | 0, i2 | 0, 56, (i4 ? gb + 660707 | 0 : gb + 837976 | 0) | 0, gb + 660845 | 0, 348) | 0;
 __ZN5physx3Ext20ProfileZoneInterfaceC2ERNS_13PxProfileZoneEPNS0_23DefaultBufferedProfilerE(i4, i1, HEAP32[i6 + 24 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
 i1 = i6 + 8 | 0;
 i2 = i6 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 16 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_3Ext20ProfileZoneInterfaceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i5) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN16MemoryFileSystem12CreateAsFileER13FileEntryData(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i3, i5);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i5) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 54;
  HEAP32[i4 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 }
 if (i1 | 0) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = (__ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i2, i3, 0) | 0) != 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN12_GLOBAL__N_110Connection8setColorEPKvRKN5physx8debugger8PvdColorE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 40 | 0;
 i5 = i4 + 32 | 0;
 i8 = i4 + 24 | 0;
 i6 = i4;
 i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
 HEAP32[i6 >> 2] = gb + 150388 + 8;
 i9 = i6 + 8 | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i1;
 HEAP32[i7 >> 2] = gb + 149652 + 8;
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i8 >> 2] = 11;
 __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERh(i7, i6 + 18 | 0);
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i6 + 19 | 0);
 i3 = i3 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, HEAP32[i8 >> 2] | 0, 1, 0, 0) | 0;
 HEAP32[i5 >> 2] = gb + 149708 + 8;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP8[i7 >> 0] = 21;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i7 | 0, 1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i5 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN12CullingGroup10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i1 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!((i3 | 0) != -1 ^ i2)) return;
 i9 = HEAP32[gb + 1114352 >> 2] | 0;
 if (!i2) {
  i8 = i9 + 12 | 0;
  i7 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
  i6 = HEAP32[i9 >> 2] | 0;
  i9 = HEAP32[i6 + (i7 << 2) >> 2] | 0;
  HEAP32[i6 + (i3 << 2) >> 2] = i9;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 + 8 >> 2] = i3;
  HEAP32[i4 >> 2] = -1;
  return;
 }
 i7 = i9 + 12 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 i6 = i8 + 1 | 0;
 i3 = i9 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i6 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i6;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i8 << 2) >> 2] = i1;
 return;
}

function __ZN11UnityEngine15PlatformWrapper23GetGraphicsFixedVersionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = __Z15GetGraphicsCapsv() | 0;
 i5 = i2 + 48 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i5 = i8 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i8 ? HEAP32[i2 + 52 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i6 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z20ExtractPPtrClassNameRK16TypeTreeIterator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 i3 = ((i3 | 0) < 0 ? HEAP32[gb + 36932 >> 2] | 0 : HEAP32[i6 + 20 >> 2] | 0) + (i3 & 2147483647) | 0;
 L1 : do if (!(_strncmp(i3, gb + 468234 | 0, 5) | 0)) {
  i2 = i3 + 5 | 0;
  switch (HEAP8[i2 >> 0] | 0) {
  case 36:
  case 0:
   break L1;
  default:
   {}
  }
  i4 = (_strlen(i3) | 0) + -1 | 0;
  i5 = i3 + i4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  i6 = i5 - i2 | 0;
  if (i6 >>> 0 > 4294967279) {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
   i7 = 7;
  } else if (i6 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i6; else i7 = 7;
  if ((i7 | 0) == 7) {
   i3 = i6 + 16 & -16;
   i7 = __Znwj(i3) | 0;
   HEAP32[i1 >> 2] = i7;
   HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i6;
   i1 = i7;
  }
  if ((i4 | 0) != 5) {
   i3 = i1;
   while (1) {
    HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
   }
   i1 = i1 + i6 | 0;
  }
  HEAP8[i1 >> 0] = 0;
  return;
 } while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i14;
 i13 = i7 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i13 >> 2] | 0) - i3 >> 2 >>> 0 >= i8 >>> 0) {
  STACKTOP = i14;
  return;
 }
 i9 = i7 + 12 | 0;
 i10 = i7 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if (!i8) {
  i6 = i7;
  i12 = 0;
  i1 = i3;
  i4 = i2;
 } else {
  i12 = HEAP32[i9 >> 2] | 0;
  HEAP32[i11 >> 2] = 25;
  HEAP32[i11 + 4 >> 2] = i12;
  i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 << 2, 16, i11, 0, gb + 1049224 | 0, 75) | 0;
  i6 = i7;
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i12 + (i2 - i3 >> 2 << 2) | 0;
 i2 = i4 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) {
  _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i13 >> 2] = i12 + (i8 << 2);
 if (!i1) {
  STACKTOP = i14;
  return;
 }
 i13 = HEAP32[i9 >> 2] | 0;
 HEAP32[i11 >> 2] = 25;
 HEAP32[i11 + 4 >> 2] = i13;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i11);
 STACKTOP = i14;
 return;
}

function __ZNK14RenderSettings19GetCustomReflectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 380 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i10 + 20 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i1 = 0; else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 << 2 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i4 = i10 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 i7 = i10 + 12 | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  i10 = i5;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 1 | 0;
  HEAP32[i4 >> 2] = i11;
  i11 = i1 + (i10 << 2) | 0;
  return i11 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 1 | 0;
 HEAP32[i4 >> 2] = i11;
 i11 = i1 + (i10 << 2) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 691357 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Scb5Scene3addINS0_12ArticulationELb1EEEvRT_RNS0_13ObjectTrackerE(i1, i7, i5) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i2 = i8;
 HEAP32[i7 >> 2] = i1;
 i3 = i7 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  HEAP32[i3 >> 2] = i4 & 268435455 | -2147483648;
  __ZN5physx2Sc5Scene15addArticulationERNS0_16ArticulationCoreERNS0_8BodyCoreE(i1 + 16 | 0, i7 + 12 | 0, (__ZN5physx28NpArticulationGetRootFromScbERNS_3Scb12ArticulationE(i7) | 0) + 16 | 0);
  STACKTOP = i8;
  return;
 }
 i1 = i4 & 1073741823;
 if (i4 >>> 0 > 3221225471) {
  HEAP32[i3 >> 2] = i1 | -2147483648;
  if (i4 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i5, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i3 >> 2] = i1 | 1073741824;
  HEAP32[i2 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i5, i2, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN11BoxColliderC2E10MemLabelId18ObjectCreationMode(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i6, i3);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 0;
 HEAP8[i4 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) f1 = Math_fround(0.0); else f1 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 HEAPF32[i4 + 56 >> 2] = f1;
 HEAP32[i4 >> 2] = gb + 110728 + 8;
 i9 = i4 + 84 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i9;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 i9 = i4 + 108 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = i9;
 HEAP32[i4 + 120 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Cct10ControllerENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 659058 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 679703 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 683502 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 725526 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN13SparseTexture10UploadTileEiiiPKhj(i3, i4, i5, i7, i8, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i10 = i11;
 if (!(__ZNK13SparseTexture20TileUploadErrorCheckEiii(i3, i4, i5, i7) | 0)) {
  STACKTOP = i11;
  return;
 }
 i12 = HEAP32[i3 + 80 >> 2] >> i7;
 i12 = (i12 | 0) > 1 ? i12 : 1;
 i13 = HEAP32[i3 + 84 >> 2] >> i7;
 i13 = (i13 | 0) > 1 ? i13 : 1;
 i6 = HEAP32[i3 + 88 >> 2] | 0;
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 i2 = (i13 | 0) < (i2 | 0) ? i13 : i2;
 i6 = __Z18CalculateImageSizeii13TextureFormat((i12 | 0) < (i6 | 0) ? i12 : i6, i2, HEAP32[i3 + 96 >> 2] | 0) | 0;
 if ((i8 | 0) != 0 & i6 >>> 0 > i9 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 412067 | 0, 0, gb + 411582 | 0, 214, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  STACKTOP = i11;
  return;
 } else {
  i13 = __Z12GetGfxDevicev() | 0;
  i12 = HEAP32[(HEAP32[i13 >> 2] | 0) + 484 >> 2] | 0;
  HEAP32[i10 >> 2] = HEAP32[i3 + 48 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
  mftCall_viiiiiiii(i12 | 0, i13 | 0, i1 | 0, i4 | 0, i5 | 0, i7 | 0, i8 | 0, i9 | 0, (i6 >>> 0) / (i2 >>> 0) | 0 | 0);
  STACKTOP = i11;
  return;
 }
}

function __ZN10HumanTrait9GetBoneIdERK6Avatari(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if ((i5 | 0) < 0) {
  i5 = -1;
  return i5 | 0;
 }
 do if ((i5 | 0) < 24) {
  i1 = i1 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i5 = -1;
   return i5 | 0;
  }
  i3 = i2 + i1 | 0;
  i4 = i3 + 40 | 0;
  if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) i3 = 8; else {
   i5 = HEAP32[i3 + 72 + (i5 << 2) >> 2] | 0;
   return i5 | 0;
  }
 } else {
  if ((i5 | 0) < 39) {
   i1 = i1 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i1 = -1; else {
    i3 = 8;
    break;
   }
   return i1 | 0;
  }
  if ((i5 | 0) >= 54) {
   i5 = -1;
   return i5 | 0;
  }
  i1 = i1 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i5 = -1;
   return i5 | 0;
  }
 } while (0);
 if ((i3 | 0) == 8) {
  i3 = i2 + i1 | 0;
  i4 = i3 + 40 | 0;
  if (HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0) {
   i3 = i3 + 48 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4) {
    i5 = HEAP32[i3 + i4 + (i5 + -24 << 2) >> 2] | 0;
    return i5 | 0;
   }
  }
 }
 i1 = i2 + i1 | 0;
 i4 = i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) {
  i5 = -1;
  return i5 | 0;
 }
 i1 = i1 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = -1;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + i2 + (i5 + -39 << 2) >> 2] | 0;
 return i5 | 0;
}

function __ZL32GeomOverlapCallback_SphereConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i3, i5, i4, i6, i11) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12;
 i2 = HEAP32[i4 + 32 >> 2] | 0;
 i10 = (i11 | 0) == 0;
 if (i10) {
  i7 = 0;
  i8 = 0;
  i9 = 1065353216;
 } else if ((HEAP16[i11 + 12 >> 1] | 0) == 2) {
  i7 = HEAP32[i11 >> 2] | 0;
  i8 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = HEAP32[i11 + 8 >> 2] | 0;
 } else {
  i7 = 0;
  i8 = 0;
  i9 = 1065353216;
 }
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 12 >> 2] = i3;
 i2 = __ZN5physx2Gu21intersectSphereConvexERKNS0_6SphereERKNS0_10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformEPNS_6PxVec3E(i1, i2, i4 + 4 | 0, i6, 0) | 0;
 if (!(i10 | i2 ^ 1)) {
  HEAP32[i11 >> 2] = i7;
  HEAP32[i11 + 4 >> 2] = i8;
  HEAP32[i11 + 8 >> 2] = i9;
 }
 if (i10) {
  STACKTOP = i12;
  return i2 | 0;
 }
 i1 = i11 + 12 | 0;
 if (i2) {
  HEAP16[i1 >> 1] = 2;
  STACKTOP = i12;
  return i2 | 0;
 } else {
  HEAP16[i1 >> 1] = 0;
  STACKTOP = i12;
  return i2 | 0;
 }
 return 0;
}

function __Z17TransformVerticesPhRK10Matrix4x4fRK16VertexBufferDatajjj25GfxTransformVerticesFlags(i6, i7, i11, i12, i13, i14, i15) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i16 = 0, i17 = 0, i18 = 0;
 i16 = HEAP8[i11 + 42 >> 0] | 0;
 i17 = i14 & 2;
 i8 = HEAPU8[i11 + 5 >> 0] | 0;
 i9 = i14 & 128;
 i10 = HEAPU8[i11 + 29 >> 0] | 0;
 i3 = 0;
 i1 = 0;
 i2 = -1;
 i4 = 2;
 i5 = 4;
 while (1) {
  if (i5 & i14) {
   if (!i3) {
    i2 = HEAP16[i11 + (i4 << 2) >> 1] | 0;
    i1 = HEAPU8[i11 + 32 + ((i2 & 255) * 12 | 0) + 10 >> 0] | 0;
    i2 = ((i2 & 65535) >>> 8 & 65535) + (HEAP32[i11 + 32 + ((i2 & 255) * 12 | 0) + 4 >> 2] | 0) | 0;
   }
   i18 = HEAP16[i11 + (i4 << 2) + 2 >> 1] | 0;
   i3 = (Math_imul((i18 & 65535) >>> 8 & 65535, __Z20GetChannelFormatSizeh(i18 & 255) | 0) | 0) + i3 | 0;
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == 7) break; else i5 = i5 << 1;
 }
 i16 = i16 & 255;
 i18 = HEAP32[i11 + 80 >> 2] | 0;
 i14 = i18 + (Math_imul(i16, i12) | 0) | 0;
 i18 = i18 + i2 + (Math_imul(i1, i12) | 0) | 0;
 __Z27TransformVerticesStridedREFPhRK10Matrix4x4fjPKhiiiS4_ii25GfxTransformVerticesFlags(i6, i7, i13, i14, (i17 | 0) == 0 ? -1 : i8, (i9 | 0) == 0 ? -1 : i10, i16, (i3 | 0) > 0 ? i18 : 0, i1, i3, i15);
 return i13 | 0;
}

function _UNITY_ft_corner_orientation(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if ((((i2 | 0) < 0 ? 0 - i2 | 0 : i2) + ((i1 | 0) < 0 ? 0 - i1 | 0 : i1) | 0) >>> 0 < 131072) if ((((i4 | 0) < 0 ? 0 - i4 | 0 : i4) + ((i3 | 0) < 0 ? 0 - i3 | 0 : i3) | 0) >>> 0 < 131072) {
  i5 = Math_imul(i2, i1) | 0;
  i6 = Math_imul(i4, i3) | 0;
  i6 = (i5 | 0) > (i6 | 0) ? 1 : ((i5 | 0) < (i6 | 0)) << 31 >> 31;
  return i6 | 0;
 }
 i5 = i1 & 65535;
 i9 = i1 >>> 16;
 i10 = i2 & 65535;
 i8 = i2 >>> 16;
 i1 = Math_imul(i10, i9) | 0;
 i7 = (Math_imul(i8, i5) | 0) + i1 | 0;
 i6 = i7 << 16;
 i5 = i6 + (Math_imul(i10, i5) | 0) | 0;
 i6 = (i7 >>> 16) + (Math_imul(i8, i9) | 0) + ((i7 >>> 0 < i1 >>> 0 & 1) << 16) + (i5 >>> 0 < i6 >>> 0 & 1) | 0;
 i1 = i3 & 65535;
 i7 = i3 >>> 16;
 i9 = i4 & 65535;
 i8 = i4 >>> 16;
 i4 = Math_imul(i9, i7) | 0;
 i3 = (Math_imul(i8, i1) | 0) + i4 | 0;
 i2 = i3 << 16;
 i1 = i2 + (Math_imul(i9, i1) | 0) | 0;
 i2 = (i3 >>> 16) + (Math_imul(i8, i7) | 0) + ((i3 >>> 0 < i4 >>> 0 & 1) << 16) + (i1 >>> 0 < i2 >>> 0 & 1) | 0;
 if (i6 >>> 0 > i2 >>> 0) {
  i10 = 1;
  return i10 | 0;
 }
 if (i6 >>> 0 < i2 >>> 0) {
  i10 = -1;
  return i10 | 0;
 }
 if (i5 >>> 0 > i1 >>> 0) {
  i10 = 1;
  return i10 | 0;
 }
 i10 = (i5 >>> 0 < i1 >>> 0) << 31 >> 31;
 return i10 | 0;
}

function _longest_match_fast(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 56 >> 2] | 0;
 i5 = i1 + (HEAP32[i7 + 108 >> 2] | 0) | 0;
 i6 = i5 + 258 | 0;
 i1 = i1 + i8 | 0;
 if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i5 >> 0] | 0)) {
  i8 = 2;
  return i8 | 0;
 }
 if ((HEAP8[i1 + 1 >> 0] | 0) != (HEAP8[i5 + 1 >> 0] | 0)) {
  i8 = 2;
  return i8 | 0;
 }
 i4 = 2;
 i3 = i1 + 2 | 0;
 do {
  i2 = i5 + i4 | 0;
  i1 = i2 + 1 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 1 >> 0] | 0)) break;
  i1 = i2 + 2 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 2 >> 0] | 0)) break;
  i1 = i2 + 3 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 3 >> 0] | 0)) break;
  i1 = i2 + 4 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 4 >> 0] | 0)) break;
  i1 = i2 + 5 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 5 >> 0] | 0)) break;
  i1 = i2 + 6 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 6 >> 0] | 0)) break;
  i1 = i2 + 7 | 0;
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 + 7 >> 0] | 0)) break;
  i4 = i4 + 8 | 0;
  i1 = i5 + i4 | 0;
  i3 = i3 + 8 | 0;
 } while ((i4 | 0) < 258 ? (HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0) : 0);
 i1 = i1 - i6 + 258 | 0;
 if ((i1 | 0) < 3) {
  i8 = 2;
  return i8 | 0;
 }
 HEAP32[i7 + 112 >> 2] = i8;
 i8 = HEAP32[i7 + 116 >> 2] | 0;
 i8 = i1 >>> 0 > i8 >>> 0 ? i8 : i1;
 return i8 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i5, i6, i1, i2, i9, i10, i11, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i4 = 0, i7 = 0, i8 = 0;
 if ((1073741806 - i6 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
 i7 = i5 + 8 | 0;
 if ((HEAP8[i7 + 3 >> 0] | 0) < 0) i8 = HEAP32[i5 >> 2] | 0; else i8 = i5;
 if (i6 >>> 0 < 536870887) {
  i1 = i1 + i6 | 0;
  i4 = i6 << 1;
  i1 = i1 >>> 0 < i4 >>> 0 ? i4 : i1;
  i1 = i1 >>> 0 < 2 ? 2 : i1 + 4 & -4;
  if (i1 >>> 0 > 1073741823) {
   i11 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i11);
   ___cxa_throw(i11 | 0, gb + 13048 | 0, fb + 3215 | 0);
  }
 } else i1 = 1073741807;
 i4 = __Znwj(i1 << 2) | 0;
 if (i9 | 0) __ZNSt3__211char_traitsIwE4copyEPwPKwj(i4, i8, i9) | 0;
 if (i11 | 0) __ZNSt3__211char_traitsIwE4copyEPwPKwj(i4 + (i9 << 2) | 0, i3, i11) | 0;
 i2 = i2 - i10 | 0;
 i3 = i2 - i9 | 0;
 if (i3 | 0) __ZNSt3__211char_traitsIwE4copyEPwPKwj(i4 + (i9 << 2) + (i11 << 2) | 0, i8 + (i9 << 2) + (i10 << 2) | 0, i3) | 0;
 if ((i6 | 0) != 1) __ZdlPv(i8);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i7 >> 2] = i1 | -2147483648;
 i11 = i2 + i11 | 0;
 HEAP32[i5 + 4 >> 2] = i11;
 HEAP32[i4 + (i11 << 2) >> 2] = 0;
 return;
}

function __ZN9Transform24MoveAfterSiblingInternalEPKS_b(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i7) i1 = 0; else {
  i6 = HEAP32[i7 + 100 >> 2] | 0;
  if ((i6 | 0) == (HEAP32[i8 + 100 >> 2] | 0)) i1 = i7; else return;
  do {
   if ((i1 | 0) == (i8 | 0)) {
    i2 = 17;
    break;
   }
   i1 = HEAP32[i1 + 100 >> 2] | 0;
  } while ((i1 | 0) != 0);
  if ((i2 | 0) == 17) return;
  i5 = (i6 | 0) == 0;
  do if (i5) {
   i2 = 0;
   i1 = 0;
  } else {
   i1 = HEAP32[i6 + 80 >> 2] | 0;
   i2 = HEAP32[i6 + 92 >> 2] | 0;
   i3 = i1 + (i2 << 2) | 0;
   i4 = i1;
   if (!i2) i1 = i2 << 2 >> 2; else {
    while (1) {
     if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) break;
     i1 = i1 + 4 | 0;
     if ((i1 | 0) == (i3 | 0)) {
      i1 = i3;
      break;
     }
    }
    i1 = i1 - i4 >> 2;
    if (i5) {
     i2 = 0;
     break;
    }
   }
   i2 = HEAP32[i6 + 80 >> 2] | 0;
   i6 = HEAP32[i6 + 92 >> 2] | 0;
   i3 = i2 + (i6 << 2) | 0;
   i4 = i2;
   L20 : do if (!i6) i2 = i3; else while (1) {
    if ((HEAP32[i2 >> 2] | 0) == (i7 | 0)) break L20;
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i2 = i3;
     break;
    }
   } while (0);
   i2 = i2 - i4 >> 2;
  } while (0);
  i1 = ((i1 | 0) > (i2 | 0) & 1) + i2 | 0;
 }
 __ZN9Transform23SetSiblingIndexInternalEib(i8, i1, i9);
 return;
}

function __ZN9ShaderLab19CommonPropertyNames13StaticCleanupEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1166568 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 4 | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = i3; else {
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63280 | 0);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   i3 = HEAP32[gb + 1166568 >> 2] | 0;
   i2 = i3 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i3;
 }
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166568 >> 2] = 0;
 i1 = HEAP32[gb + 1170580 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1170580 >> 2] = 0;
 __Z30CleanupBuiltinShaderParamNamesv();
 return;
}

function __ZN5physx7profile15ZoneManagerImplD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 114064 + 8;
 i2 = i4 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i3 = i4 + 12 | 0;
  __ZN5physx7profile15ZoneManagerImpl17removeProfileZoneERNS_13PxProfileZoneE(i4, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) do {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0);
   i1 = HEAP32[i2 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = i4 + 44 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[HEAP32[i4 + 24 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[HEAP32[i4 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sq10ActorShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 686601 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 678028 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 703464 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 710070 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 723349 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx5cloth9transformERKNS0_11PhaseConfigE(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 HEAP16[i2 >> 1] = HEAP16[i6 >> 1] | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 i3 = i2 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 i4 = i2 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(1.0);
 i5 = i2 + 12 | 0;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 i2 = i2 + 16 | 0;
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 f1 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i6 + 4 >> 2]));
 i7 = f1 < Math_fround(1.0);
 f1 = i7 ? f1 : Math_fround(1.0);
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 HEAPF32[i3 >> 2] = f1;
 f1 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i7 = f1 < Math_fround(1.0);
 f1 = i7 ? f1 : Math_fround(1.0);
 i7 = f1 < Math_fround(0.0);
 f1 = i7 ? Math_fround(0.0) : f1;
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i6 + 12 >> 2])));
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i6 + 16 >> 2])));
 return;
}

function __ZN21AnimationPosePlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i2 = i5 + 80 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i10 = HEAP32[i5 + 84 >> 2] | 0;
  i3 = (HEAP8[i6 + 33 >> 0] | 0) != 0;
  i4 = (HEAP8[i6 + 34 >> 0] | 0) != 0;
  __ZN7mecanim5human12FullBodyMaskEv(i1);
  __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE(i7, i10, i3, i4, i1);
  HEAP8[i2 >> 0] = 0;
 }
 HEAP8[i5 + 56 >> 0] = 0;
 i4 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  STACKTOP = i9;
  return;
 }
 i2 = 0;
 do {
  i3 = i2;
  i1 = i5;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i8 = 9;
    break;
   } else i3 = 0;
  }
  if ((i8 | 0) == 9) {
   i8 = 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i6 | 0, i7 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i2 + 1152 | 0;
 i7 = i2 + 1156 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = (HEAP32[i7 >> 2] | 0) - i1 >> 2;
 if (!i8) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 2168 | 0;
 __ZN11UnityEngine15CloudWebService13WWWRestClient17PlayerLoopHandlerEv(i3);
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0)) return;
 __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE24ExtractResponseEtagValueEv(i4);
 i1 = HEAP32[i2 + 1168 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  i5 = (HEAP8[i4 + 2252 >> 0] | 0) != 0;
  mftCall_viiiii(i2 | 0, i1 | 0, i4 + 2256 | 0, i4 + 2236 | 0, i5 | 0, __ZN11UnityEngine15CloudWebService13WWWRestClient17GetResponseStatusEv(i3) | 0);
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2 - i1 | 0;
 i5 = i3 >> 2;
 if (i5) {
  _memmove(i4 | 0, i1 | 0, i3 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i4 + (i5 << 2) | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 if (i8 >>> 0 <= 1) return;
 __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformWWWEv((HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + 2168 | 0) | 0;
 return;
}

function __ZN16ParticleAnimator17SetColorAnimationEP10ColorRGBAf(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, i5 = 0;
 i1 = 0;
 do {
  f4 = Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]);
  i5 = f4 < Math_fround(0.0);
  f4 = i5 ? Math_fround(0.0) : f4;
  i5 = f4 > Math_fround(1.0);
  HEAP8[i2 + 88 + (i1 << 2) >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f4 = i5 ? Math_fround(0.0) : f4;
  i5 = f4 > Math_fround(1.0);
  HEAP8[i2 + 88 + (i1 << 2) + 1 >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i3 + (i1 << 4) + 8 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f4 = i5 ? Math_fround(0.0) : f4;
  i5 = f4 > Math_fround(1.0);
  HEAP8[i2 + 88 + (i1 << 2) + 2 >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  f4 = Math_fround(HEAPF32[i3 + (i1 << 4) + 12 >> 2]);
  i5 = f4 < Math_fround(0.0);
  f4 = i5 ? Math_fround(0.0) : f4;
  i5 = f4 > Math_fround(1.0);
  HEAP8[i2 + 88 + (i1 << 2) + 3 >> 0] = ~~Math_fround(Math_fround((i5 ? Math_fround(1.0) : f4) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 return;
}

function __ZN11Rigidbody2D12MovePositionERK8Vector2f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, f6 = f0, f7 = f0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 807687 | 0, 0, gb + 807613 | 0, 952, 512, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if (!(HEAP32[i2 + 92 >> 2] | 0)) return;
 i5 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + 92 >> 2] | 0;
 if (!i5) return;
 f7 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]));
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i5 + 12 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f7 * Math_fround(f3 - Math_fround(HEAPF32[i5 + 16 >> 2])));
 i4 = i2 + 226 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i1 = HEAP32[i5 + 68 >> 2] | 0;
  HEAP32[i2 + 212 >> 2] = HEAP32[i5 + 64 >> 2];
  HEAP32[i2 + 216 >> 2] = i1;
 }
 if (HEAP32[i5 >> 2] | 0) {
  if (Math_fround(Math_fround(f6 * f6) + Math_fround(f3 * f3)) > Math_fround(0.0)) {
   i1 = i5 + 4 | 0;
   i2 = HEAPU16[i1 >> 1] | 0;
   if (!(i2 & 2)) {
    HEAP16[i1 >> 1] = i2 | 2;
    HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
   }
  }
  HEAPF32[i5 + 64 >> 2] = f6;
  HEAPF32[i5 + 68 >> 2] = f3;
 }
 HEAPF32[i5 + 132 >> 2] = Math_fround(0.0);
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684278 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 725646 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_12NpBatchQueryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 705108 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 656630 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Gu31SinglePersistentContactManifold31addBatchManifoldContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE(i9, i11, i8, i1, i10, i2) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 4) {
  i7 = i10;
  i1 = 0;
 } else {
  __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i9, i11, i8, i1, i10);
  HEAP32[i11 + 384 >> 2] = 3;
  return;
 }
 do {
  i2 = HEAP32[i7 + 48 >> 2] | 0;
  i6 = i7 + 52 | 0;
  if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i3 = i1;
   while (1) {
    i1 = i3 + 1 | 0;
    i3 = i11 + (i3 << 6) | 0;
    i4 = i8 + (i2 << 6) | 0;
    i5 = i3 + 52 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
   }
  }
  i7 = HEAP32[i7 + 16 >> 2] | 0;
 } while ((i7 | 0) != 0);
 HEAP32[i11 + 384 >> 2] = i1;
 i11 = i10 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 return;
}

function __ZN17CapsuleCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 160 | 0;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i3 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i9 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i2, 4);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 164 | 0;
 i2 = i3 + 4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i9 >> 2] = i2;
  i5 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i1, 4);
  i5 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i3 = i5 + 4 | 0;
 if (i3 >>> 0 < i4 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i9 >> 2] = i3;
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN11prophecysdk4half8overflowEv() {
 var i1 = 0, f2 = f0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(1.0e10);
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f2 * Math_fround(HEAPF32[i3 >> 2]));
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 STACKTOP = i1;
 return Math_fround(f2);
}

function __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN8GradientC2Ev(i4);
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(HEAP32[i3 >> 2] | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i1 = i4 + 32 | 0;
 i2 = i2 + 32 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5);
 STACKTOP = i6;
 return;
}

function __Z18PxCreateCollectionv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 84, (i1 ? gb + 740341 | 0 : gb + 837976 | 0) | 0, gb + 732479 | 0, 199) | 0;
 HEAP32[i1 >> 2] = gb + 110532 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 28 >> 2] = Math_fround(.75);
 HEAP32[i1 + 32 >> 2] = -1;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i2, 64);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(.75);
 HEAP32[i1 + 72 >> 2] = -1;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj(i2, 64);
 return i1 | 0;
}

function __Z13tessMeshUnionP9TESSallocP8TESSmeshS2_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 44 | 0;
 i6 = i5 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i4 + 48 | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i8 >> 2] = i2;
  HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i8;
  i2 = HEAP32[i5 + 48 >> 2] | 0;
  HEAP32[i2 >> 2] = i4 + 44;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i8 = i4 + 4 | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i7;
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i8 >> 2] = i7;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i7 = i3 + 8 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i8 = i3 + 12 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i7 | 0, i8 | 0, i5 | 0);
  return i4 | 0;
 }
 i7 = HEAP32[i4 + 72 >> 2] | 0;
 HEAP32[HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] >> 2] = i1;
 HEAP32[HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] >> 2] = HEAP32[i7 >> 2];
 i8 = HEAP32[i5 + 72 >> 2] | 0;
 HEAP32[HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] >> 2] = i4 + 68;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 i7 = i3 + 8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i3 + 12 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(i7 | 0, i8 | 0, i5 | 0);
 return i4 | 0;
}

function __ZNK16LightmapSettings14GetLightProbesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN7mecanim9animation28MotionOutputGetDeltaRotationEPKNS0_12MotionOutputE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f10 = Math_fround(f11 * f10);
 f9 = Math_fround(f11 * f9);
 f11 = Math_fround(f11 * Math_fround(HEAPF32[i1 + 24 >> 2]));
 f7 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(Math_fround(f11 * f11) + Math_fround(0.0)))));
 f2 = Math_fround(f7 * Math_fround(.5));
 f8 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 f10 = Math_fround(Math_fround(f10 * f8) / f7);
 f9 = Math_fround(Math_fround(f9 * f8) / f7);
 f8 = Math_fround(Math_fround(f11 * f8) / f7);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f7 == Math_fround(0.0);
 i12 = i5 ? 1065353216 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i6 >> 2] = i5 ? 0 : i1;
 HEAP32[i6 + 4 >> 2] = i5 ? 0 : i3;
 HEAP32[i6 + 8 >> 2] = i5 ? 0 : i4;
 HEAP32[i6 + 12 >> 2] = i12;
 return;
}

function __ZN5physx7NpShape7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 6 | 0;
 i2 = (HEAP16[i1 >> 1] & 2) != 0;
 if (!(i2 | (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0) ^ 1)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 689543 | 0, 170, gb + 690303 | 0, i4);
  i2 = i3 + 20 | 0;
  i1 = __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(HEAP32[i2 >> 2] | 0) | 0;
  __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb(i1, i3, HEAP32[i2 >> 2] | 0, 1);
  STACKTOP = i4;
  return;
 }
 if (!i2) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 689543 | 0, 176, gb + 690417 | 0, i4 + 8 | 0);
  STACKTOP = i4;
  return;
 }
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i3, HEAP32[i3 + 8 >> 2] | 0, 1);
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i3 + 12 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i3 + 16 | 0) | 0) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 672002 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc9ClothCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 683256 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 706391 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 725762 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 683374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx3Ext19ProfileEventHandler12reportEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 if (!i2) i1 = i8 + 28 | 0; else {
  i5 = i8 + 4 | 0;
  i1 = i8 + 28 | 0;
  i6 = i8 + 24 | 0;
  do {
   i2 = i2 + -1 | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i8, i4, i5);
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3 | 0) do {
    i3 = i3 + -1 | 0;
    __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE(i8, i4, (HEAP32[i6 >> 2] | 0) + (i3 * 20 | 0) | 0);
   } while ((i3 | 0) != 0);
   __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE(i8, i4);
  } while ((i2 | 0) != 0);
 }
 HEAP32[i8 + 16 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i7 = i8 + 44 | 0;
  HEAP32[i7 >> 2] = 0;
  i8 = i8 + 36 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 i2 = HEAP32[i8 + 24 >> 2] | 0;
 do {
  i1 = i1 + -1 | 0;
  HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
 } while ((i1 | 0) != 0);
 i7 = i8 + 44 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i8 + 36 | 0;
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZN37RotationBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 896 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 896 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 896 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 896 >> 2] | 0) + 804 >> 2] = f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 896 >> 2] | 0) + 808 >> 2] = f4;
   return;
  }
 default:
  return;
 }
}

function __ZN19SkinnedMeshRenderer11GetRootBoneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 380 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z39Physics_CUSTOM_INTERNAL_CALL_BoxCastAllRK8Vector3fS1_S1_RK11Quaternionffi23QueryTriggerInteraction(i4, i5, i1, i7, f8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f6 = f0, i11 = 0, f12 = f0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f12 * f12);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f6 * f6));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (f3 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  HEAPF32[i11 >> 2] = Math_fround(f12 / f3);
  HEAPF32[i11 + 4 >> 2] = Math_fround(f6 / f3);
  HEAPF32[i11 + 8 >> 2] = Math_fround(f2 / f3);
  i11 = __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE(__ZN14PhysicsManager10BoxCastAllERK8Vector3fS2_S2_RK11Quaternionffi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i4, i5, i11, i7, f8, i9, i10) | 0) | 0;
  STACKTOP = i13;
  return i11 | 0;
 } else {
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 28 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i13;
  return i11 | 0;
 }
 return 0;
}

function __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 i8 = HEAP32[i1 + 40 >> 2] | 0;
 i7 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i8) {
  STACKTOP = i10;
  return;
 }
 i1 = 0;
 while (1) {
  if (!(HEAP8[i7 + (i1 << 3) >> 0] | 0)) {
   i2 = HEAP32[i7 + (i1 << 3) + 4 >> 2] | 0;
   if (!i2) {
    i1 = 12;
    break;
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
   i3 = __ZNK5physx12NpConstraint18getSceneFromActorsEv(i2) | 0;
   if (i3 | 0) {
    i4 = i3 + 3540 | 0;
    HEAP32[i9 >> 2] = i2;
    i5 = i3 + 3544 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if ((HEAP32[i3 + 3548 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
     HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] = i2;
     HEAP32[i5 >> 2] = i6 + 1;
    } else __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i9) | 0;
    __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE(i3 + 16 | 0, i2 + 16 | 0);
   }
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i8 >>> 0) {
   i1 = 12;
   break;
  }
 }
 if ((i1 | 0) == 12) {
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEE15growAndPushBackERKS6_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i11 + 20 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 << 2 | 0, HEAP32[i11 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i11 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 i8 = i11 + 12 | 0;
 if ((i6 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i11 = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i9;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i1 + (i11 << 2) | 0;
  return i11 | 0;
 }
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i8 >> 2] | 0);
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i4 >> 2] = i9;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i1 + (i11 << 2) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 681584 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 745374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 * 24 | 0;
  i2 = i7 + 768 | 0;
  if (i1 >>> 0 < 769 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i7, i1, gb + 838004 | 0, 543) | 0;
 }
 i3 = HEAP32[i7 + 776 >> 2] | 0;
 i4 = i1 + (i3 * 24 | 0) | 0;
 i5 = i7 + 772 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP8[i2 + 20 >> 0] = HEAP8[i3 + 20 >> 0] | 0;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 24 | 0;
  }
 }
 i2 = i7 + 780 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 768 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 } else {
  __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, i3);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
}

function __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE(i9, i11, i8, i1, i10, i2) {
 i9 = i9 | 0;
 i11 = i11 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i10 + 56 >> 2] | 0) >>> 0 < 7) {
  i7 = i10;
  i1 = 0;
 } else {
  __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i9, i11, i8, i1, i10);
  HEAP32[i11 + 384 >> 2] = 6;
  return;
 }
 do {
  i2 = HEAP32[i7 + 48 >> 2] | 0;
  i6 = i7 + 52 | 0;
  if (i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
   i3 = i1;
   while (1) {
    i1 = i3 + 1 | 0;
    i3 = i11 + (i3 << 6) | 0;
    i4 = i8 + (i2 << 6) | 0;
    i5 = i3 + 52 | 0;
    do {
     HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
     i3 = i3 + 4 | 0;
     i4 = i4 + 4 | 0;
    } while ((i3 | 0) < (i5 | 0));
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) break; else i3 = i1;
   }
  }
  i7 = HEAP32[i7 + 16 >> 2] | 0;
 } while ((i7 | 0) != 0);
 HEAP32[i11 + 384 >> 2] = i1;
 i11 = i10 + 32 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 return;
}

function __ZN16LightmapSettings14GetLightProbesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN14UnityAnalytics15SendCustomEventERN11UnityEngine9Analytics15UserCustomEventE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
  i7 = 2;
  return i7 | 0;
 }
 if ((HEAP32[i7 + 80 >> 2] | 0) >>> 0 > (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i7 = 3;
  return i7 | 0;
 }
 if ((HEAP32[i7 + 84 >> 2] | 0) >>> 0 > (HEAP32[i1 + 40 >> 2] | 0) >>> 0) {
  i7 = 4;
  return i7 | 0;
 }
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv() | 0;
 i2 = getTempRet0() | 0;
 i3 = i4 + 752 | 0;
 i8 = i3;
 i8 = _i64Subtract(i1 | 0, i2 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
 i9 = getTempRet0() | 0;
 if (i9 >>> 0 > 0 | (i9 | 0) == 0 & i8 >>> 0 > 3599999) {
  i9 = i3;
  HEAP32[i9 >> 2] = i1;
  HEAP32[i9 + 4 >> 2] = i2;
  i2 = 1;
  i1 = i4 + 760 | 0;
 } else {
  i1 = i4 + 760 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i9 = 5;
   return i9 | 0;
  }
 }
 HEAP32[i1 >> 2] = i2;
 i9 = HEAP32[i6 >> 2] | 0;
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i9, i7, HEAP32[i9 + 12 >> 2] | 0, HEAP32[i9 + 8 >> 2] | 0, 0) | 0;
 i9 = 0;
 return i9 | 0;
}

function __ZN11UnityEngine15PlatformWrapper17GetGraphicsVendorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = __Z15GetGraphicsCapsv() | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i5 = i8 ? HEAP32[i5 >> 2] | 0 : i5;
 i4 = i8 ? HEAP32[i2 + 20 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i6 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z39CanvasBatchIntermediateRenderer_CleanupR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] | 0;
 i6 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = i2 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i5 = i3 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return; else i4 = 0;
 do {
  i2 = i6 + (i4 * 36 | 0) + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   i1 = i3 + 4 | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
   if (!(HEAP32[i1 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
   }
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 return;
}

function __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE7reserveEj(i9, i4) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 8 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 i1 = i6;
 if ((HEAP32[i10 >> 2] | 0) - i6 >> 5 >>> 0 >= i4 >>> 0) return;
 i11 = i9 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 << 5) | 0;
 i2 = i5 + (i2 - i6 >> 5 << 5) | 0;
 i8 = i2;
 i7 = i5 + (i4 << 5) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i8;
  i5 = i6;
 } else {
  i4 = i8;
  do {
   i5 = i2 + -32 | 0;
   i6 = i3;
   i3 = i3 + -32 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_(i2 + -20 | 0, i6 + -20 | 0);
   i2 = i4 + -32 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i5 = HEAP32[i9 >> 2] | 0;
  i1 = HEAP32[i11 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i4;
 HEAP32[i11 >> 2] = i8;
 HEAP32[i10 >> 2] = i7;
 i3 = i5;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + -20 | 0;
  if ((HEAP32[i1 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + -32 | 0;
 } while ((i1 | 0) != (i3 | 0));
 if (!i5) return;
 __ZdlPv(i5);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceIPKwEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_(i4, i1, i5, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i6, i2, i3);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP8[i4 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
 i3 = HEAP8[i6 + 8 + 3 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 __THREW__ = 0;
 i1 = invoke_iiiiii(fb + 194 | 0, i4 | 0, i2 - i1 >> 2 | 0, (HEAP32[i5 >> 2] | 0) - i2 >> 2 | 0, (i8 ? HEAP32[i6 >> 2] | 0 : i6) | 0, (i8 ? HEAP32[i6 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
  ___resumeException(i8 | 0);
 } else {
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i6);
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZN7b2World11ShiftOriginERK6b2Vec2(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, f6 = f0;
 if (HEAP32[i3 + 102868 >> 2] & 2 | 0) return;
 i1 = HEAP32[i3 + 102956 >> 2] | 0;
 if (i1 | 0) {
  i2 = i4 + 4 | 0;
  do {
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i1 + 12 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   i5 = i1 + 16 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i1 + 36 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   i5 = i1 + 40 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f6 = Math_fround(HEAPF32[i4 >> 2]);
   i5 = i1 + 44 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   f6 = Math_fround(HEAPF32[i2 >> 2]);
   i5 = i1 + 48 | 0;
   HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f6);
   i1 = HEAP32[i1 + 96 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i1 = HEAP32[i3 + 102960 >> 2] | 0;
 if (i1 | 0) do {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i4 | 0);
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 __ZN13b2DynamicTree11ShiftOriginERK6b2Vec2(i3 + 102872 | 0, i4);
 return;
}

function __ZN6Socket10CheckErrorEiPKcii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i9 + 24 | 0;
 i6 = i9 + 12 | 0;
 i7 = ___errno_location() | 0;
 if ((i1 | 0) >= 0) {
  HEAP32[i7 >> 2] = 0;
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!i2) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = _strerror(i1) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, _strlen(i3) | 0);
 i3 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i7;
 __Z6FormatPKcz(i5, gb + 458640 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 458557 | 0, 423, 1, 0, i4, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx9NpFactory14createMaterialEfff(i9, f4, f2, f3) {
 i9 = i9 | 0;
 f4 = Math_fround(f4);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 16 | 0;
 i8 = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP16[i8 + 12 >> 1] = 0;
 HEAP8[i8 + 14 >> 0] = 0;
 HEAPF32[i8 + 4 >> 2] = f4;
 HEAPF32[i8 >> 2] = f2;
 HEAPF32[i8 + 8 >> 2] = f3;
 i5 = i9 + 2440 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i9 + 2436 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i9 + 2144 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 i6 = i9 + 2424 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i9 = i9 + 2428 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (!i1) {
  i9 = 0;
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i10;
  return i9 | 0;
 }
 __ZN5physx2Sc12MaterialCoreC2ERKNS_15PxsMaterialDataE(i7, i8);
 __ZN5physx10NpMaterialC2ERKNS_2Sc12MaterialCoreE(i1, i7);
 i9 = i1;
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 680849 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i10 + 8 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i1 = 0; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i7 * 12 | 0, gb + 838004 | 0, 543) | 0;
 i8 = i10 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 + (i5 * 12 | 0) | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 12 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i1 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i9 = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i4 >> 2] = i7;
  i10 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i10;
  i10 = i1 + (i9 * 12 | 0) | 0;
  return i10 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i10 >> 2] | 0);
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i4 >> 2] = i7;
 i10 = i9 + 1 | 0;
 HEAP32[i8 >> 2] = i10;
 i10 = i1 + (i9 * 12 | 0) | 0;
 return i10 | 0;
}

function __ZN5physx3Cct17CapsuleController6resizeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, d7 = 0.0, f8 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 f8 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0));
 mftCall_iif(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, +f1) | 0;
 f1 = Math_fround(f1 - f8);
 i5 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 f8 = Math_fround(f1 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f6 = Math_fround(f1 * Math_fround(HEAPF32[i2 + 40 >> 2]));
 f6 = Math_fround(f6 * Math_fround(.5));
 f1 = Math_fround(Math_fround(f1 * Math_fround(HEAPF32[i2 + 44 >> 2])) * Math_fround(.5));
 d7 = +Math_fround(f8 * Math_fround(.5));
 HEAPF64[i4 >> 3] = +HEAPF64[i4 >> 3] + d7;
 i5 = i4 + 8 | 0;
 HEAPF64[i5 >> 3] = +HEAPF64[i5 >> 3] + +f6;
 i5 = i4 + 16 | 0;
 HEAPF64[i5 >> 3] = +HEAPF64[i5 >> 3] + +f1;
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN30EmissionModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 do switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i3 + 352 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i3 + 616 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAP32[i3 + 816 >> 2] | 0);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAP32[i3 + 820 >> 2] | 0);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAP32[i3 + 824 >> 2] | 0);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAP32[i3 + 828 >> 2] | 0);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAP32[i3 + 816 >> 2] | 0);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAP32[i3 + 836 >> 2] | 0);
   break;
  }
 case 8:
  {
   f1 = Math_fround(HEAP32[i3 + 840 >> 2] | 0);
   break;
  }
 case 9:
  {
   f1 = Math_fround(HEAP32[i3 + 844 >> 2] | 0);
   break;
  }
 case 10:
  {
   f1 = Math_fround(HEAPF32[i3 + 800 >> 2]);
   break;
  }
 case 11:
  {
   f1 = Math_fround(HEAPF32[i3 + 804 >> 2]);
   break;
  }
 case 12:
  {
   f1 = Math_fround(HEAPF32[i3 + 808 >> 2]);
   break;
  }
 case 13:
  {
   f1 = Math_fround(HEAPF32[i3 + 812 >> 2]);
   break;
  }
 case 14:
  {
   f1 = Math_fround(HEAP32[i3 + 848 >> 2] | 0);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN24EllipsoidParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i2 = i7 + 220 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 224 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 228 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 232 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN18UnityConnectClient25UnregisterGlobalCallbacksEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 788 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 18524 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L4 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i4 = i6 + 17756 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (fb + 200 | 0)) {
    i3 = i6 + 17756 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 17756 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i3 >> 0] | 0)) break;
    if ((HEAP32[i2 >> 2] | 0) == (i8 | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L4;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i3 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 17756 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 17756 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 17756 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 17756 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 17756 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 __ZN11UnityEngine7Connect14RemoteSettings10UnregisterEPNS0_13ConfigHandlerE(i8 + 768 | 0, HEAP32[i8 + 544 >> 2] | 0);
 return;
}

function __ZN15TerrainCollider14GetTerrainDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z33Gradient_Get_Custom_PropColorKeysP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i4 = i5 + 8 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i2 = HEAPU8[i3 + 64 >> 0] | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  f7 = Math_fround(Math_fround((i8 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f6 = Math_fround(Math_fround(i8 >>> 16 & 255) / Math_fround(255.0));
  HEAPF32[i4 + (i1 * 20 | 0) >> 2] = Math_fround(Math_fround(i8 & 255) / Math_fround(255.0));
  HEAPF32[i4 + (i1 * 20 | 0) + 4 >> 2] = f7;
  HEAPF32[i4 + (i1 * 20 | 0) + 8 >> 2] = f6;
  HEAPF32[i4 + (i1 * 20 | 0) + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + (i1 * 20 | 0) + 16 >> 2] = Math_fround(Math_fround(HEAPU16[i3 + 32 + (i1 << 1) >> 1] | 0) / Math_fround(65535.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 8);
 i8 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 208 >> 2] | 0, 20, i2) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 20) | 0, i4 | 0, i2 * 20 | 0) | 0;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 706029 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 2;
  i2 = i7 + 260 | 0;
  if (i1 >>> 0 < 257 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7 + 4 | 0;
  } else {
   i5 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i3 = HEAP32[i7 + 268 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 i5 = i7 + 264 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 i2 = i7 + 272 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 + 4 | 0) == (i3 | 0)) {
  HEAP8[i7 + 260 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i3 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 12 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739340 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Cm9FlushPoolC2Ej(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i1 = mftCall_iiiiii(i8 | 0, i3 | 0, i1 | 0, (i4 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i6 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i3 = i6 + 4 | 0;
 i4 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = i2;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7 + 4 | 0, i2, gb + 675773 | 0, 39) | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i6 + 12 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i4 >> 2] = i2 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i3, i5) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx15concludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i9 = HEAP16[i2 + 26 >> 1] | 0;
 i10 = i1 + ((i9 & 65535) << 4) | 0;
 if (!(i9 << 16 >> 16)) return;
 do {
  i4 = i1 + 32 | 0;
  i2 = HEAP8[i1 + 5 >> 0] | 0;
  i9 = HEAP8[i1 + 6 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  i8 = i3 << 24 >> 24 == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) {
   i8 = 32;
   i2 = i4;
  } else {
   i5 = i2 & 255;
   i7 = Math_imul(i8, i5) | 0;
   i3 = i4;
   i4 = 0;
   while (1) {
    i2 = i3 + 44 | 0;
    f6 = Math_fround(HEAPF32[i2 >> 2]);
    i11 = f6 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i11 ? (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    i4 = i4 + 1 | 0;
    if ((i4 | 0) == (i5 | 0)) break; else i3 = i3 + i8 | 0;
   }
   i2 = i7 + 32 | 0;
   i3 = HEAP8[i1 >> 0] | 0;
   i8 = i2;
   i2 = i1 + i2 | 0;
  }
  i7 = i3 << 24 >> 24 == 3 ? 128 : 96;
  if (!(i9 << 24 >> 24)) i1 = i2; else {
   i5 = i9 & 255;
   i4 = Math_imul(i7, i5) | 0;
   i3 = 0;
   while (1) {
    HEAP32[i2 + 44 >> 2] = 0;
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i5 | 0)) break; else i2 = i2 + i7 | 0;
   }
   i1 = i1 + (i8 + i4) | 0;
  }
 } while (i1 >>> 0 < i10 >>> 0);
 return;
}

function __ZN13GfxDeviceGLES14SetTextureNameE9TextureIDPKc(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = i1 + 4620 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i3, i1, i4);
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  i4 = 0;
  i4 = HEAP32[i4 >> 2] | 0;
  __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i5, 7, i4, 0, i6);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i5, 7, i4, 0, i6);
 STACKTOP = i7;
 return;
}

function _jinit_c_coef_controller(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = i5 + 4 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i5 | 0, 1, 104) | 0;
 HEAP32[i5 + 328 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 2363;
 if (!(i1 << 24 >> 24)) {
  i6 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, 1, 1280) | 0;
  HEAP32[i2 + 24 >> 2] = i6;
  HEAP32[i2 + 28 >> 2] = i6 + 128;
  HEAP32[i2 + 32 >> 2] = i6 + 256;
  HEAP32[i2 + 36 >> 2] = i6 + 384;
  HEAP32[i2 + 40 >> 2] = i6 + 512;
  HEAP32[i2 + 44 >> 2] = i6 + 640;
  HEAP32[i2 + 48 >> 2] = i6 + 768;
  HEAP32[i2 + 52 >> 2] = i6 + 896;
  HEAP32[i2 + 56 >> 2] = i6 + 1024;
  HEAP32[i2 + 60 >> 2] = i6 + 1152;
  HEAP32[i2 + 64 >> 2] = 0;
  return;
 }
 i4 = i5 + 60 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i3 = i2 + 64 | 0;
 i1 = 0;
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 while (1) {
  i10 = HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0;
  i9 = _jround_up(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0) | 0;
  i7 = i2 + 12 | 0;
  i8 = _jround_up(HEAP32[i2 + 32 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i3 + (i1 << 2) >> 2] = mftCall_iiiiiii(i10 | 0, i5 | 0, 1, 0, i9 | 0, i8 | 0, HEAP32[i7 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i4 >> 2] | 0)) break; else i2 = i2 + 84 | 0;
 }
 return;
}

function __ZNK6Camera20GetReplacementShaderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 828 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 677496 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i13, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0, i15 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i13 >>> 0) __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i13);
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + (i13 * 40 | 0) | 0;
 if ((i1 | 0) >= (i13 | 0)) {
  HEAP32[i10 >> 2] = i13;
  return;
 }
 i2 = i12 + 8 | 0;
 i3 = i12 + 12 | 0;
 i4 = i12 + 16 | 0;
 i5 = i12 + 20 | 0;
 i6 = i12 + 24 | 0;
 i7 = i12 + 28 | 0;
 i8 = i12 + 32 | 0;
 i1 = i9 + (i1 * 40 | 0) | 0;
 do {
  HEAP16[i1 >> 1] = HEAP16[i12 >> 1] | 0;
  HEAP16[i1 + 2 >> 1] = HEAP16[i12 + 2 >> 1] | 0;
  HEAP16[i1 + 4 >> 1] = HEAP16[i12 + 4 >> 1] | 0;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i7 >> 2];
  i15 = i8;
  i14 = HEAP32[i15 + 4 >> 2] | 0;
  i9 = i1 + 32 | 0;
  HEAP32[i9 >> 2] = HEAP32[i15 >> 2];
  HEAP32[i9 + 4 >> 2] = i14;
  i1 = i1 + 40 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 HEAP32[i10 >> 2] = i13;
 return;
}

function __ZN5physx17PxcNpMemBlockPool7releaseERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPj(i9, i8, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i9 >> 2] | 0);
 i6 = i8 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i9 + 152 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i1;
 if (i2) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i1;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (!i1) {
  i9 = HEAP32[i9 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
  STACKTOP = i10;
  return;
 }
 i3 = i9 + 116 | 0;
 i4 = i9 + 112 | 0;
 i5 = i9 + 120 | 0;
 do {
  i2 = i1 + -1 | 0;
  i1 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i7 >> 2] = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i5 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] = i1;
   HEAP32[i3 >> 2] = i2 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4, i7) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i9 = HEAP32[i9 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN33SizeBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 892 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 892 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 892 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 892 >> 2] | 0) + 800 >> 2] = f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAPF32[(HEAP32[i2 + 892 >> 2] | 0) + 804 >> 2] = f4;
   return;
  }
 default:
  return;
 }
}

function __ZN19LightProbeOcclusion8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 HEAP32[i6 >> 2] = 1;
 i8 = i1 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i7 = i1 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = 1;
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i4 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 1;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = 1;
  HEAP32[i8 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i1;
  STACKTOP = i9;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i4, 4);
  STACKTOP = i9;
  return;
 }
}

function __ZN15CapsuleCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(84, i1, 16, gb + 1048932 | 0, 0, gb + 779108 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i3, i5, i2);
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 110952 + 8;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP8[i3 + 40 >> 0] = 0;
 HEAP8[i3 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) {
  f9 = Math_fround(0.0);
  i8 = i3 + 56 | 0;
  HEAPF32[i8 >> 2] = f9;
  HEAP32[i3 >> 2] = gb + 111136 + 8;
  __Z19pop_allocation_rootv();
  STACKTOP = i4;
  return i3 | 0;
 }
 f9 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 i8 = i3 + 56 | 0;
 HEAPF32[i8 >> 2] = f9;
 HEAP32[i3 >> 2] = gb + 111136 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx6shdfnd8SyncImpl4waitEj(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i2 = i8;
 _pthread_mutex_lock(i7 | 0) | 0;
 i4 = i7 + 76 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i7 + 80 | 0;
 L1 : do if (!(HEAP8[i6 >> 0] | 0)) if ((i1 | 0) == -1) {
  i1 = i7 + 28 | 0;
  do {
   if (HEAP8[i6 >> 0] | 0) break L1;
   if ((i5 | 0) != (HEAP32[i4 >> 2] | 0)) break L1;
  } while (!(_pthread_cond_wait(i1 | 0, i7 | 0) | 0));
 } else {
  _gettimeofday(i2 | 0, 0) | 0;
  i9 = (i1 >>> 0) / 1e3 | 0;
  i1 = ((Math_imul(i9, -1e3) | 0) + i1 | 0) * 1e3 | 0;
  i1 = i1 + (HEAP32[i2 + 4 >> 2] | 0) | 0;
  i10 = (i1 >>> 0) / 1e6 | 0;
  i1 = i1 + (Math_imul(i10, -1e6) | 0) | 0;
  HEAP32[i3 >> 2] = i10 + i9 + (HEAP32[i2 >> 2] | 0);
  HEAP32[i3 + 4 >> 2] = i1 * 1e3;
  i1 = i7 + 28 | 0;
  do {
   if (HEAP8[i6 >> 0] | 0) break L1;
   if ((i5 | 0) != (HEAP32[i4 >> 2] | 0)) break L1;
  } while (!(_pthread_cond_timedwait(i1 | 0, i7 | 0, i3 | 0) | 0));
 } while (0);
 if (HEAP8[i6 >> 0] | 0) {
  i10 = 1;
  _pthread_mutex_unlock(i7 | 0) | 0;
  STACKTOP = i8;
  return i10 | 0;
 }
 i10 = (i5 | 0) != (HEAP32[i4 >> 2] | 0);
 _pthread_mutex_unlock(i7 | 0) | 0;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxClothENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 682533 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 725420 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_7NpSceneENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 701568 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 683054 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i5, i8, i7) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[(HEAP32[gb + 1457204 >> 2] | 0) + 440 >> 2] | 0;
 i2 = i5 + 4 | 0;
 i6 = HEAPU16[i2 >> 1] | 0;
 __ZN5physx2Cm8PtrTable3addEPvRNS0_22PtrTableStorageManagerE(i5, i8, i4);
 i1 = i5 + 8 | 0;
 __ZN5physx2Cm8PtrTable3addEPvRNS0_22PtrTableStorageManagerE(i1, 0, i4);
 i4 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i7) | 0;
 if (i4 | 0) if ((__ZNK5physx7NpShape8getFlagsEv(i8) | 0) & 2) {
  i3 = HEAP16[i7 + 4 >> 1] | 0;
  if ((HEAP16[i2 >> 1] | 0) == 1) i2 = i5; else i2 = HEAP32[i5 >> 2] | 0;
  i2 = __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i4 + 3392 | 0, HEAP32[i2 + (i6 << 2) >> 2] | 0, i7, i3 << 16 >> 16 == 5 | i3 << 16 >> 16 == 15, 0) | 0;
  if ((HEAP16[i5 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + (i6 << 2) >> 2] = i2;
 }
 __ZN5physx3Scb11RigidObject13onShapeAttachERNS0_5ShapeE(i7 + (HEAP32[gb + 1457020 + 68 + (HEAPU16[i7 + 4 >> 1] << 2) >> 2] | 0) | 0, i8 + 32 | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i8 + 16 | 0) | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0) | 0)) return;
 __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE(i8, i7);
 return;
}

function __ZN19SkinnedMeshRenderer7GetMeshEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 352 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 40 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 i4 = i1 + 32 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 4 | 0;
 if (i7 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 4);
  i7 = HEAP32[i3 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  i7 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2);
  STACKTOP = i8;
  return;
 } else {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = i7;
  i7 = i6;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i4 >> 2] = i7;
  i7 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i2);
  STACKTOP = i8;
  return;
 }
}

function __Z55ParticleSystemExtensionsImpl_CUSTOM_GetTriggerParticlesP12Il2CppObjectiS0_(i5, i6, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0;
 i7 = i3 + 8 | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i7 >> 2] | 0) | 0;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i2 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZNK14ParticleSystem27GetSafeTriggerParticlesSizeEN13TriggerEvents9EventTypeE(i1, i6) | 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 if (i4 >>> 0 < i1 >>> 0) {
  i4 = HEAP32[(__Z33GetParticleSystemScriptingClassesv() | 0) + 8 >> 2] | 0;
  HEAP32[i7 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i4, 120, HEAP32[i2 >> 2] | 0) | 0;
 }
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i7 >> 2] | 0, 0, 120) | 0;
  return __ZNK14ParticleSystem27GetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticlei(i1, i6, i7, HEAP32[i2 >> 2] | 0) | 0;
 }
 return 0;
}

function __Z39Texture2D_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 24 | 0;
 i8 = i9 + 8 | 0;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i10 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 111 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK9Texture2D8GetPixelEiii(i8, i1, 0, i5, i6);
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = HEAP32[i8 + 8 >> 2] | 0;
  i10 = HEAP32[i8 + 12 >> 2] | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i7 + 4 >> 2] = i5;
  HEAP32[i7 + 8 >> 2] = i6;
  HEAP32[i7 + 12 >> 2] = i10;
  STACKTOP = i9;
  return;
 }
}

function __ZN9BlobWrite8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = (HEAP8[i4 + 24 >> 0] | 0) != 0;
 if (i2) __ZN9BlobWrite4PushEjPKvj(i4, 60, i5, 4);
 i3 = i4 + 48 | 0;
 i6 = i4 + 44 | 0;
 i10 = (HEAP32[i3 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i7 = i4 + 32 | 0;
 i11 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i10 >>> 8 << 2) >> 2] | 0;
 i10 = i10 & 255;
 i9 = i11 + (i10 << 4) + 4 | 0;
 i12 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i12 + (0 - (i12 + (HEAP32[i11 + (i10 << 4) >> 2] | 0)) & 3);
 HEAP32[i1 >> 2] = 15;
 HEAP32[i1 + 4 >> 2] = i5;
 __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi15EEEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 906470 | 0, 0);
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i11 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i12 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
 if ((1 - i11 - (HEAP32[i6 >> 2] | 0) + ((i12 | 0) == 0 ? 0 : (i12 << 6) + -1 | 0) | 0) >>> 0 <= 511) {
  STACKTOP = i8;
  return;
 }
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 739765 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 4;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 683156 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739170 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN23CloudWebServicesManager15GetCloudServiceEN19CloudServiceHandler11ServiceTypeE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i6 >> 2] = i5;
 i7 = i1 + 28 | 0;
 i4 = i1 + 32 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = i4;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i5 | 0)) {
   i7 = HEAP32[i1 + 20 >> 2] | 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 switch (i5 | 0) {
 case 0:
 case 3:
  {
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 default:
  {}
 }
 i5 = __ZnwjRK10MemLabelIdiPKci(1176, gb + 63800 | 0, 16, gb + 1047287 | 0, 57) | 0;
 __ZN19CloudServiceHandlerC2Ev(i5);
 HEAP32[(__ZNSt3__23mapIN19CloudServiceHandler11ServiceTypeEPS1_NS_4lessIS2_EE13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier85ELi16EEEixERS8_(i7, i6) | 0) >> 2] = i5;
 __ZN19CloudServiceHandler14SetServiceInfoENS_11ServiceTypeE(i5, HEAP32[i6 >> 2] | 0);
 i7 = i5;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags(i7, i8, i1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 16 | 0;
 i2 = i6;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i8, 4); else {
  HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 >> 2] = i5;
 }
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i7, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i7 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i8 + 4 | 0, (HEAP8[i7 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i7 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, i1);
 STACKTOP = i6;
 return;
}

function __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER10GameObjectR13dynamic_arrayI20BoundCurveDeprecatedLj4EE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER9TransformR13dynamic_arrayI20BoundCurveDeprecatedLj4EERNS3_6vectorIPSF_S6_ISM_LSA_25ELi16EEEERi(i1, i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 28940 | 0) | 0, i4, i6, i5);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 25;
 HEAP32[i5 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i8;
 return;
}

function __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 6, 16, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 6, 16, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 6 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i6 = (HEAP32[i2 >> 2] | 0) + (i8 << 6) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i3 = i6 + (i1 << 6) | 0;
  i4 = i9;
  i5 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   i3 = i3 + 4 | 0;
   i4 = i4 + 4 | 0;
  } while ((i3 | 0) < (i5 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZeqRK14ImageReferenceS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i4 | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i3 | 0) != (HEAP32[i2 + 12 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i5 = (i1 | 0) == (i2 | 0);
  return i5 | 0;
 }
 i5 = Math_imul(i3, i4) | 0;
 i4 = (i5 | 0) / 4 | 0;
 L17 : do if ((i5 | 0) > 3) {
  i3 = 0;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
   i3 = i3 + 1 | 0;
   if ((i3 | 0) >= (i4 | 0)) break L17;
  }
  return i1 | 0;
 } while (0);
 i4 = (i5 | 0) % 4 | 0;
 if ((i4 | 0) > 0) i3 = 0; else {
  i5 = 1;
  return i5 | 0;
 }
 while (1) {
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
   i1 = 0;
   i2 = 13;
   break;
  }
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (i4 | 0)) {
   i1 = 1;
   i2 = 13;
   break;
  } else {
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 if ((i2 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = (HEAP8[i3 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i3, 16, i4, 4);
 i2 = i3 + 48 | 0;
 i6 = i3 + 44 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i5 = i3 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i8 >>> 8 << 2) >> 2] | 0;
 i8 = i8 & 255;
 i7 = i9 + (i8 << 4) + 4 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i8 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4, gb + 1085989 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4 + 8 | 0, gb + 1084342 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4 + 12 | 0, gb + 1085899 | 0, 0);
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i9 + -1;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - (HEAP32[i5 >> 2] | 0) | 0;
 if ((1 - i9 - (HEAP32[i6 >> 2] | 0) + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN8Animator12RetargetStepEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i2 = i9;
 if ((HEAP16[gb + 1466896 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i8;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466896 | 0, i1);
  i7 = gb + 1466896 | 0;
 } else i7 = 0;
 i6 = i8 + 128 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!(HEAP8[i2 + 17 >> 0] | 0)) {
  i4 = i8 + 584 | 0;
  i5 = i8 + 596 | 0;
  if (!(HEAP32[i5 >> 2] | 0)) i1 = 1; else {
   i3 = 0;
   i1 = HEAP32[i4 >> 2] | 0;
   do {
    i3 = i3 | (__ZNK26AnimatorControllerPlayable13GetLayerCountEv(HEAP32[i1 >> 2] | 0) | 0) > 1;
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != ((HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = i3 ^ 1;
  }
 } else i1 = 1;
 __ZN7mecanim9animation22EvaluateAvatarRetargetEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb(HEAP32[i8 + 124 >> 2] | 0, i2, HEAP32[i8 + 132 >> 2] | 0, HEAP32[i8 + 136 >> 2] | 0, HEAP32[i8 + 140 >> 2] | 0, i1);
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i10 + 20 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i4 = 0; else {
  i4 = HEAP32[i10 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i8 << 2 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i6 = i10 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i4 + (i1 << 2) | 0;
 i7 = i10 + 12 | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 >> 2] = i8;
  i10 = HEAP32[i6 >> 2] | 0;
  i9 = i10 + 1 | 0;
  HEAP32[i6 >> 2] = i9;
  i10 = i4 + (i10 << 2) | 0;
  return i10 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i4;
 HEAP32[i5 >> 2] = i8;
 i10 = HEAP32[i6 >> 2] | 0;
 i9 = i10 + 1 | 0;
 HEAP32[i6 >> 2] = i9;
 i10 = i4 + (i10 << 2) | 0;
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i3 = i7;
 i4 = i1 + 2740 | 0;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  __ZN5physx2Sc5Scene23removeArticulationJointERNS0_21ArticulationJointCoreE(i1 + 16 | 0, i6 + 12 | 0);
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 switch (i2 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i1 >> 2] = i2 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i4, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = i2 | -1073741824;
   if (i2 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i3 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN22ParticleSystemRenderer15OnDidDeleteMeshEP4Mesh(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = i4 + 408 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 424 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 428 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 412 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 436 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 440 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 416 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 448 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i4 + 452 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
  }
 }
 i1 = i4 + 420 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) return;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 460 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i5 = i4 + 464 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN17AudioReverbFilter16ChangePropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i2 | 0) >= 27) return;
 i13 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 16 >> 2] | 0;
 i4 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 20 >> 2] | 0;
 i12 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 24 >> 2] | 0;
 i11 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 28 >> 2] | 0;
 i10 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 36 >> 2] | 0;
 i9 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 44 >> 2] | 0;
 i8 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 48 >> 2] | 0;
 i5 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 60 >> 2] | 0;
 i3 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 64 >> 2] | 0;
 i7 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 68 >> 2] | 0;
 i6 = HEAP32[gb + 171848 + (i2 * 80 | 0) + 72 >> 2] | 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(HEAP32[gb + 171848 + (i2 * 80 | 0) + 12 >> 2] | 0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(i13 | 0);
 HEAP32[i1 + 60 >> 2] = i12;
 HEAP32[i1 + 64 >> 2] = i11;
 HEAPF32[i1 + 68 >> 2] = Math_fround(i10 | 0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(i9 | 0);
 HEAP32[i1 + 80 >> 2] = i8;
 HEAP32[i1 + 84 >> 2] = i7;
 HEAP32[i1 + 88 >> 2] = i6;
 HEAP32[i1 + 92 >> 2] = i5;
 HEAPF32[i1 + 96 >> 2] = Math_fround(i4 | 0);
 HEAP32[i1 + 100 >> 2] = i3;
 return;
}

function __ZN15TerrainCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i9 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 1016849 | 0, 25) | 0;
 i7 = i1;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 187060 + 8;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = i4;
 i1 = i6;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP8[i4 + 64 >> 0] = 1;
 HEAPF32[i4 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 108 >> 2] = Math_fround(1.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 56 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 i8 = i1 + 32 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z21CalculateGlobalMatrix23TransformAccessReadOnly(i5, i4);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = i4;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 + 28 >> 2] = 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i2 + 36 >> 2] = i1;
 HEAP32[i2 + 40 >> 2] = i4;
 HEAP32[i2 + 44 >> 2] = 0;
 i4 = HEAP32[i5 + 40 >> 2] | 0;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i2 + 52 >> 2] = i4;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = 1065353216;
 STACKTOP = i3;
 return;
}

function __ZNK6Camera16GetTargetTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 744 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = (HEAP32[i2 + 32 >> 2] | 0) != -1 & 1;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = (i7 | 0) != 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  if (!i3) {
   i7 = i1;
   return i7 | 0;
  }
  i5 = i6 + 4 | 0;
  i4 = i2 + 16 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
  i2 = 0;
  i3 = 0;
  do {
   i9 = i5 + (HEAP32[i4 + (i2 << 2) >> 2] << 2) | 0;
   i8 = i3;
   i3 = __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE(i6, i9 + (HEAP32[i9 >> 2] | 0) | 0) | 0;
   i8 = i3 + i8 | 0;
   i1 = i1 >>> 0 < i8 >>> 0 ? i8 : i1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  return i1 | 0;
 } else {
  if (!i3) {
   i9 = i1;
   return i9 | 0;
  }
  i4 = i6 + 4 | 0;
  i3 = i2 + 16 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
  i2 = 0;
  do {
   i9 = i4 + (HEAP32[i3 + (i2 << 2) >> 2] << 2) | 0;
   i1 = (__ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE(i6, i9 + (HEAP32[i9 >> 2] | 0) | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  return i1 | 0;
 }
 return 0;
}

function __ZN7mecanim8dynamics10VectorDamp8EvaluateERKN4math7_float4Ef(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0, f17 = f0, f18 = f0, f19 = f0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 i11 = i1 + 4 | 0;
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f19 = Math_fround(HEAPF32[i11 >> 2]);
 f13 = Math_fround(f12 - f19);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i8 = i1 + 8 | 0;
 f18 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f9 - f18);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = i1 + 12 | 0;
 f17 = Math_fround(HEAPF32[i5 >> 2]);
 f7 = Math_fround(f6 - f17);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i1 + 16 | 0;
 f15 = Math_fround(HEAPF32[i2 >> 2]);
 f16 = Math_fround(Math_abs(Math_fround(f3)));
 f3 = Math_fround(f16 + f14);
 f13 = Math_fround(f19 + Math_fround(Math_fround(f16 * f13) / f3));
 f10 = Math_fround(f18 + Math_fround(Math_fround(f16 * f10) / f3));
 f7 = Math_fround(f17 + Math_fround(Math_fround(f16 * f7) / f3));
 f3 = Math_fround(f15 + Math_fround(Math_fround(f16 * Math_fround(f4 - f15)) / f3));
 i1 = f14 > Math_fround(0.0);
 HEAPF32[i11 >> 2] = i1 ? f13 : f12;
 HEAPF32[i8 >> 2] = i1 ? f10 : f9;
 HEAPF32[i5 >> 2] = i1 ? f7 : f6;
 HEAPF32[i2 >> 2] = i1 ? f3 : f4;
 return;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 479351 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 32 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 479375 | 0, HEAP32[gb + 37052 >> 2] | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __Z35EnsureQuaternionContinuityLoopFrameR17AnimationCurveTplI11QuaternionfE(i10) {
 i10 = i10 | 0;
 var i1 = 0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 i1 = HEAP32[i10 + 164 >> 2] | 0;
 if ((i1 | 0) < 2) return;
 i9 = i1 + -2 | 0;
 i7 = HEAP32[i10 + 152 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 4 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 8 >> 2]);
 f12 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 12 >> 2]);
 f11 = Math_fround(HEAPF32[i7 + (i9 * 52 | 0) + 16 >> 2]);
 i9 = i1 + -1 | 0;
 i1 = i7 + (i9 * 52 | 0) + 4 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i8 = i7 + (i9 * 52 | 0) + 8 | 0;
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 i6 = i7 + (i9 * 52 | 0) + 12 | 0;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = i7 + (i9 * 52 | 0) + 16 | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 if (Math_fround(Math_fround(Math_fround(Math_fround(f14 * f2) + Math_fround(f13 * f3)) + Math_fround(f12 * f4)) + Math_fround(f11 * f5)) < Math_fround(0.0)) {
  f2 = Math_fround(-f2);
  f4 = Math_fround(-f4);
  f5 = Math_fround(-f5);
  f3 = Math_fround(-f3);
 }
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i8 >> 2] = f3;
 HEAPF32[i6 >> 2] = f4;
 HEAPF32[i7 >> 2] = f5;
 __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif(i10, i9, Math_fround(0.0));
 return;
}

function _UNITY_png_write_chunk(i3, i1, i5, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = HEAP8[i1 >> 0] | 0;
 i9 = HEAP8[i1 + 1 >> 0] | 0;
 i4 = HEAP8[i1 + 2 >> 0] | 0;
 i1 = HEAP8[i1 + 3 >> 0] | 0;
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 if ((i6 | 0) < 0) _UNITY_png_error(i3, gb + 356027 | 0);
 i2 = i3 + 656 | 0;
 HEAP32[i2 >> 2] = 34;
 HEAP8[i7 >> 0] = i6 >>> 24;
 HEAP8[i7 + 1 >> 0] = i6 >>> 16;
 HEAP8[i7 + 2 >> 0] = i6 >>> 8;
 HEAP8[i7 + 3 >> 0] = i6;
 i11 = i7 + 4 | 0;
 HEAP8[i11 >> 0] = i8;
 HEAP8[i7 + 5 >> 0] = i9;
 HEAP8[i7 + 6 >> 0] = i4;
 HEAP8[i7 + 7 >> 0] = i1;
 _UNITY_png_write_data(i3, i7, 8);
 HEAP32[i3 + 372 >> 2] = (i9 & 255) << 16 | (i8 & 255) << 24 | (i4 & 255) << 8 | i1 & 255;
 _UNITY_png_reset_crc(i3);
 _UNITY_png_calculate_crc(i3, i11, 4);
 HEAP32[i2 >> 2] = 66;
 if ((i5 | 0) != 0 & (i6 | 0) != 0) {
  _UNITY_png_write_data(i3, i5, i6);
  _UNITY_png_calculate_crc(i3, i5, i6);
 }
 HEAP32[i2 >> 2] = 130;
 i11 = HEAP32[i3 + 408 >> 2] | 0;
 HEAP8[i7 >> 0] = i11 >>> 24;
 HEAP8[i7 + 1 >> 0] = i11 >>> 16;
 HEAP8[i7 + 2 >> 0] = i11 >>> 8;
 HEAP8[i7 + 3 >> 0] = i11;
 _UNITY_png_write_data(i3, i7, 4);
 STACKTOP = i10;
 return;
}

function _cff_property_set(i10, i1, i6) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(_strcmp(i1, gb + 1008189 | 0) | 0)) {
  i7 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i6 + 4 >> 2] | 0;
  i9 = HEAP32[i6 + 8 >> 2] | 0;
  i2 = HEAP32[i6 + 12 >> 2] | 0;
  i3 = HEAP32[i6 + 16 >> 2] | 0;
  i4 = HEAP32[i6 + 20 >> 2] | 0;
  i5 = HEAP32[i6 + 24 >> 2] | 0;
  i1 = HEAP32[i6 + 28 >> 2] | 0;
  if ((i9 | 0) > (i3 | 0) | ((i7 | 0) > (i9 | 0) ? 1 : (i8 | i7 | i9 | i2 | i3 | i4 | i5 | i1 | 0) < 0)) {
   i10 = 6;
   return i10 | 0;
  }
  if ((i1 | 0) > 500 | ((i4 | 0) > 500 | ((i2 | 0) > 500 | ((i8 | 0) > 500 | (i3 | 0) > (i5 | 0))))) {
   i10 = 6;
   return i10 | 0;
  }
  HEAP32[i10 + 36 >> 2] = i7;
  HEAP32[i10 + 40 >> 2] = i8;
  HEAP32[i10 + 44 >> 2] = i9;
  HEAP32[i10 + 48 >> 2] = i2;
  HEAP32[i10 + 52 >> 2] = i3;
  HEAP32[i10 + 56 >> 2] = i4;
  HEAP32[i10 + 60 >> 2] = i5;
  HEAP32[i10 + 64 >> 2] = i1;
  i10 = 0;
  return i10 | 0;
 }
 if (!(_strcmp(i1, gb + 1008210 | 0) | 0)) {
  if ((HEAP32[i6 >> 2] | 0) != 1) {
   i10 = 7;
   return i10 | 0;
  }
  HEAP32[i10 + 28 >> 2] = 1;
  i10 = 0;
  return i10 | 0;
 } else {
  if (_strcmp(i1, gb + 1008225 | 0) | 0) {
   i10 = 12;
   return i10 | 0;
  }
  HEAP8[i10 + 32 >> 0] = HEAP8[i6 >> 0] | 0;
  i10 = 0;
  return i10 | 0;
 }
 return 0;
}

function __ZNSt3__212system_errorC2ENS_10error_codeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 i6 = i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i3);
 __THREW__ = 0;
 invoke_viii(fb + 1061 | 0, i4 | 0, i2 | 0, i6 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 do if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i1 | 0, i4 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   break;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   HEAP32[i1 >> 2] = gb + 215964 + 8;
   i3 = i2;
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   i6 = i1 + 8 | 0;
   HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 + 4 >> 2] = i4;
   STACKTOP = i5;
   return;
  }
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i10 + 20 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i1 = 0; else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 << 2 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i4 = i10 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 i7 = i10 + 12 | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  i10 = i5;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 1 | 0;
  HEAP32[i4 >> 2] = i11;
  i11 = i1 + (i10 << 2) | 0;
  return i11 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 1 | 0;
 HEAP32[i4 >> 2] = i11;
 i11 = i1 + (i10 << 2) | 0;
 return i11 | 0;
}

function __ZN5Unity12PhysicsQuery22OverlapCapsuleNonAllocERK8Vector3fS3_fPP8Colliderii23QueryTriggerInteraction(i4, i5, i6, f7, i8, i9, i10, i11) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1452752 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452752 | 0, i2);
  i3 = gb + 1452752 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 + 28 >> 2] = 128;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151400 + 8;
 HEAP32[i2 + 36 >> 2] = i8;
 HEAP32[i2 + 40 >> 2] = i9;
 i1 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(0, i5, i6, f7, i10, i11, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 24 | 0;
 i5 = i6;
 i1 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4, i3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 450991 | 0, i5, 0);
 __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i6 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  i6 = i5 + 4 | 0;
  __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
  STACKTOP = i3;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 i6 = i5 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 STACKTOP = i3;
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i6 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  i6 = i5 + 4 | 0;
  __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4);
  STACKTOP = i3;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 i6 = i5 + 4 | 0;
 __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4);
 STACKTOP = i3;
 return;
}

function __Z16CullPointShadowsR9IndexListPK9SceneNodePK4AABBR16PointCullContext(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 if ((HEAP16[gb + 1114404 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114404 | 0, i1);
  i5 = gb + 1114404 | 0;
 } else i5 = 0;
 i6 = i7 + 4 | 0;
 if ((HEAP32[i6 >> 2] | 0) > 0) {
  i4 = i10 + 12 | 0;
  i3 = 0;
  i1 = 0;
  do {
   i12 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   i2 = i9 + (i12 * 24 | 0) | 0;
   if (__ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB(i10, HEAP32[i8 + (i12 * 24 | 0) >> 2] | 0, HEAP32[i8 + (i12 * 24 | 0) + 4 >> 2] | 0, i2) | 0) if (__Z19IntersectAABBSphereRK4AABBRK6Sphere(i2, i4) | 0) {
    i12 = HEAP32[i7 >> 2] | 0;
    HEAP32[i12 + (i1 << 2) >> 2] = HEAP32[i12 + (i3 << 2) >> 2];
    i1 = i1 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (HEAP32[i6 >> 2] | 0));
 } else i1 = 0;
 HEAP32[i6 >> 2] = i1;
 if (!i5) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i11;
 return;
}

function _h2v2_downsample(i1, i4, i9, i10) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i8 = HEAP32[i4 + 28 >> 2] | 0;
 i11 = i8 << 3;
 i5 = HEAP32[i1 + 220 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = i8 << 4;
 if ((i5 | 0) > 0 & (i1 - i3 | 0) > 0) {
  i2 = i3 + ~i1 | 0;
  i2 = (i1 | 2) - i3 + ((i2 | 0) > -2 ? i2 : -2) | 0;
  i1 = 0;
  do {
   i8 = (HEAP32[i9 + (i1 << 2) >> 2] | 0) + i3 | 0;
   _memset(i8 | 0, HEAP8[i8 + -1 >> 0] | 0, i2 | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i8 = i4 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 if (!i11) {
  i1 = 0;
  do i1 = i1 + 1 | 0; while ((i1 | 0) < (i2 | 0));
  return;
 } else {
  i4 = 0;
  i6 = 0;
 }
 while (1) {
  i1 = HEAP32[i10 + (i6 << 2) >> 2] | 0;
  i2 = HEAP32[i9 + ((i4 | 1) << 2) >> 2] | 0;
  i3 = HEAP32[i9 + (i4 << 2) >> 2] | 0;
  i5 = 0;
  i7 = 1;
  while (1) {
   HEAP8[i1 >> 0] = ((HEAPU8[i3 >> 0] | 0) + i7 + (HEAPU8[i3 + 1 >> 0] | 0) + (HEAPU8[i2 >> 0] | 0) + (HEAPU8[i2 + 1 >> 0] | 0) | 0) >>> 2;
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i11 | 0)) break; else {
    i1 = i1 + 1 | 0;
    i2 = i2 + 2 | 0;
    i3 = i3 + 2 | 0;
    i7 = i7 ^ 3;
   }
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) >= (HEAP32[i8 >> 2] | 0)) break; else i4 = i4 + 2 | 0;
 }
 return;
}

function __ZNSt3__26vectorINS0_INS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEEENS4_IS8_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS8_RS9_EE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i6 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  i10 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + -16 | 0;
  i7 = i1 + -16 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i10 + -12 | 0;
  HEAP32[i9 >> 2] = 0;
  i11 = HEAP32[i1 + -4 >> 2] | 0;
  HEAP32[i10 + -8 >> 2] = 0;
  HEAP32[i10 + -4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  i8 = i1 + -12 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  i9 = i1 + -8 | 0;
  HEAP32[i10 + -8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -16;
  i1 = i7;
 }
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i9;
 i9 = i3 + 8 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 i9 = i2 + 8 | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i10;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 return;
}

function __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 160 | 0;
 i9 = i1 + 16 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i2, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 >> 2] = i4;
 }
 i1 = i7 + 164 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i1, 4);
  i4 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i9 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 168 | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i9, i8, 4);
  i9 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 } else {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i8 >> 2] = i7;
  HEAP32[i9 >> 2] = i2;
  i9 = i7;
  HEAP32[i1 >> 2] = i9;
  STACKTOP = i10;
  return;
 }
}

function __ZN14ParticleSystem10DeactivateE19DeactivateOperation(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d5 = 0.0;
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = i4 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP8[i3 + 12 >> 0] = 1;
 HEAP8[i3 + 13 >> 0] = 1;
 d5 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i2 >> 2] | 0) + 40 >> 3] = d5;
 i3 = i4 + 32 | 0;
 __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i3 >> 2] | 0, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 480 >> 2] = 0;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 13 >> 0] | 0)) {
  i3 = HEAP32[i3 >> 2] | 0;
  __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i4, i3, i1);
  __ZN14ParticleSystem17RemoveFromManagerEv(i4);
  return;
 }
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i4, i3, i1);
 __ZN14ParticleSystem17RemoveFromManagerEv(i4);
 return;
}

function __ZN11Rigidbody2D24InformCollidersOfNewBodyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 i6 = i7 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(HEAP32[i1 + 28 >> 2] | 0, 0, gb + 32588 | 0, i6);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = HEAP32[i6 >> 2] | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(i2, 0, 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i9 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i12 = i4;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform(i4, i5, 0, -2);
 HEAP8[i4 + 25 >> 0] = 0;
 __ZN9BlobWrite8TransferIN7mecanim9animation16ControllerMemoryEEEvRT_PKc17TransferMetaFlags(i4, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i6 >> 2] | 0, 16) | 0;
 if (i1 | 0) _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 __ZN9BlobWriteD2Ev(i4);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i8);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN14DataBufferGLES6UploadEiiPKv(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 do if (!(HEAP8[i4 + 20 >> 0] | 0)) {
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  if (!((i5 | 0) == 0 & (i1 | 0) == (i6 | 0))) {
   __ZN14DataBufferGLES16RecreateWithDataEiPKv(i4, i1, 0);
   break;
  }
  __ZN14DataBufferGLES16RecreateWithDataEiPKv(i4, i6, i7);
  return;
 } while (0);
 if (i7 | 0) {
  i2 = HEAP32[gb + 1451080 >> 2] | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  switch (HEAP32[i4 + 12 >> 2] | 0) {
  case 2:
  case 1:
  case 0:
   {
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
     i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
     i1 = i1 ? 1 : 2;
    } else i1 = 1;
    break;
   }
  case 6:
  case 5:
  case 4:
   {
    if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
     i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
     i1 = i1 ? 0 : 2;
    } else i1 = 0;
    break;
   }
  case 10:
  case 9:
  case 3:
  case 8:
  case 7:
   {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
    break;
   }
  default:
   i1 = -559030611;
  }
  __ZN7ApiGLES19UploadBufferSubDataEjN2gl12BufferTargetEllPKv(i2, i3, i1, i5, i6, i7);
 }
 HEAP32[i4 + 28 >> 2] = HEAP32[HEAP32[i4 >> 2] >> 2];
 return;
}

function __ZN13SpringJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 108 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i1 = i6 + 96 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN10GUITexture10GetTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN10FileSystem12MountHandlerEP17FileSystemHandler(i8, i3) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = i3;
 if (!i3) {
  i11 = 0;
  return i11 | 0;
 }
 i9 = i8 + 16 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i11 = i8 + 28 | 0;
 i4 = HEAP32[i11 >> 2] | 0;
 L4 : do if (!i4) i4 = 0; else {
  i5 = i1 + (i4 << 2) | 0;
  i2 = i1;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
    i1 = 0;
    break;
   }
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i5 | 0)) break L4;
  }
  return i1 | 0;
 } while (0);
 i7 = i4 + 1 | 0;
 i3 = i8 + 32 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i7 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 2, 4, i8 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i9 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i8 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i11 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i11 >> 2] = i7;
 HEAP32[i1 + (i4 << 2) >> 2] = i10;
 i11 = 1;
 return i11 | 0;
}

function __Z43Physics_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK8Vector3fS1_fS1_fi23QueryTriggerInteraction(i4, i5, f7, i1, f8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f7 = Math_fround(f7);
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f6 = f0, i11 = 0, f12 = f0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 f12 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f12 * f12);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f6 * f6));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (f3 > Math_fround(HEAPF32[gb + 62452 >> 2])) {
  HEAPF32[i11 >> 2] = Math_fround(f12 / f3);
  HEAPF32[i11 + 4 >> 2] = Math_fround(f6 / f3);
  HEAPF32[i11 + 8 >> 2] = Math_fround(f2 / f3);
  i11 = __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE(__ZN14PhysicsManager14CapsuleCastAllERK8Vector3fS2_fS2_fi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i4, i5, f7, i11, f8, i9, i10) | 0) | 0;
  STACKTOP = i13;
  return i11 | 0;
 } else {
  i11 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 28 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i13;
  return i11 | 0;
 }
 return 0;
}

function __Z37AssetBundle_CUSTOM_LoadAsset_InternalP12Il2CppObjectP12Il2CppStringS0_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 if (HEAP8[i1 + 184 >> 0] | 0) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 495978 | 0, i6);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 i1 = __Z30LoadNamedObjectFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObject(i1, i5, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!i1) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _do_flush(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!i4) {
  i13 = -2;
  return i13 | 0;
 }
 if ((HEAP8[i4 + 92 >> 0] | 0) != 119) {
  i13 = -2;
  return i13 | 0;
 }
 HEAP32[i4 + 4 >> 2] = 0;
 i10 = i4 + 16 | 0;
 i11 = i4 + 104 | 0;
 i12 = i4 + 56 | 0;
 i6 = i4 + 72 | 0;
 i7 = i4 + 64 | 0;
 i8 = i4 + 12 | 0;
 i3 = 0;
 i1 = HEAP32[i10 >> 2] | 0;
 while (1) {
  i2 = 16384 - i1 | 0;
  i9 = (i2 | 0) == 0;
  if (!i9) {
   if ((_fwrite(HEAP32[i6 >> 2] | 0, 1, i2, HEAP32[i7 >> 2] | 0) | 0) != (i2 | 0)) {
    i13 = 6;
    break;
   }
   HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i10 >> 2] = 16384;
   i1 = 16384;
  }
  if (i3) {
   i13 = 9;
   break;
  }
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + i1;
  i1 = _unity_z_deflate(i4, i5) | 0;
  HEAP32[i12 >> 2] = i1;
  i2 = HEAP32[i10 >> 2] | 0;
  HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) - i2;
  if (i9 & (i1 | 0) == -5) {
   HEAP32[i12 >> 2] = 0;
   i3 = (i2 | 0) != 0;
   i1 = i2;
   continue;
  } else if (i1 >>> 0 < 2) {
   i3 = (i2 | 0) != 0 | (i1 | 0) == 1;
   i1 = i2;
   continue;
  } else break;
 }
 if ((i13 | 0) == 6) {
  HEAP32[i12 >> 2] = -1;
  i13 = -1;
  return i13 | 0;
 } else if ((i13 | 0) == 9) i1 = HEAP32[i12 >> 2] | 0;
 i13 = (i1 | 0) == 1 ? 0 : i1;
 return i13 | 0;
}

function __ZN8Material17UpdateToNewShaderEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 12 | 0;
 i3 = i5;
 HEAP32[i6 + 36 >> 2] = -1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 469949 | 0, 10);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 1576256 | 0, 0);
 i4 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i1 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0;
 __ZN8Material14SetOverrideTagEii(i6, i4, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i6 + 80 | 0, (HEAP32[i6 + 100 >> 2] | 0) + 124 | 0);
 __ZN8Material15BuildPropertiesEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc5Scene8addShapeERNS0_8RigidSimERNS0_9ShapeCoreE(i10, i8, i9) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 switch (HEAPU8[i8 + 50 >> 0] | 0 | 0) {
 case 4:
 case 1:
  {
   i7 = i8 + 64 | 0;
   break;
  }
 default:
  i7 = 0;
 }
 i6 = HEAP32[i10 + 1212 >> 2] | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i5 + (i4 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i1 = i5 + (i4 * 12 | 0) + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (HEAP32[i6 >> 2] | 0)) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = (HEAP32[i5 + (i4 * 12 | 0) >> 2] | 0) + (Math_imul(i2, i3) | 0) | 0;
   if (i1 | 0) break;
  }
  i1 = __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv(i6) | 0;
  if (!i1) {
   i9 = i9 + 68 | 0;
   i9 = HEAP32[i9 >> 2] | 0;
   i10 = i10 + 1424 + (i9 << 2) | 0;
   i9 = HEAP32[i10 >> 2] | 0;
   i9 = i9 + 1 | 0;
   HEAP32[i10 >> 2] = i9;
   return;
  }
 } else HEAP32[i2 >> 2] = HEAP32[i1 >> 2]; while (0);
 __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E(i1, i8, i9, i7, 0);
 i9 = i9 + 68 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = i10 + 1424 + (i9 << 2) | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i9 = i9 + 1 | 0;
 HEAP32[i10 >> 2] = i9;
 return;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN23PreloadManagerOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 27520 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 112 | 0, i2);
 HEAP8[i1 + 124 >> 0] = 1;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i1 + 128 | 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i2 >> 2] = gb + 27732 + 88;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAPF32[i1 + 136 >> 2] = Math_fround(0.0);
 __ZN4FileC2Ev(i1 + 144 | 0);
 i3 = i1 + 176 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 27632 + 8;
 HEAP32[i2 >> 2] = gb + 27632 + 88;
 i2 = i1 + 192 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i1 + 188 >> 0] = 1;
 return;
}

function __ZN22RenderingCommandBuffer20AddClearRenderTargetEjRK10ColorRGBAffj(i4, i9, i1, f10, i11) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i6 = i4 + 8 | 0;
 i7 = i4 + 24 | 0;
 i5 = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 i3 = i5 + 4 | 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i5, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i3 = i4 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i5 >> 2] = 8;
 i4 = i5 + 7 & -4;
 i5 = i4 + 28 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + i4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = i9;
 HEAPF32[i7 + 20 >> 2] = f10;
 HEAP32[i7 + 24 >> 2] = i11;
 STACKTOP = i12;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i5, i3, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i4 = i3 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i1, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 }
 i1 = i1 + 4 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
}

function __ZN14PhysicsManager22OverlapCapsuleNonAllocERK8Vector3fS2_fPP8Colliderii23QueryTriggerInteraction(i4, i5, i6, f7, i8, i9, i10, i11) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i12 + 8 | 0;
 i1 = i12;
 if ((HEAP16[gb + 1452752 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452752 | 0, i2);
  i3 = gb + 1452752 | 0;
 } else i3 = 0;
 i1 = HEAP32[i4 + 760 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 + 28 >> 2] = 128;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 151400 + 8;
 HEAP32[i2 + 36 >> 2] = i8;
 HEAP32[i2 + 40 >> 2] = i9;
 i1 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE(0, i5, i6, f7, i10, i11, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  STACKTOP = i12;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN12LineRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5);
 i6 = (HEAP32[i4 + 348 >> 2] | 0) + 8 | 0;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i5 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i6, i1, i5 + 8 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i5, HEAP32[i6 >> 2] | 0, i1 * 12 | 0);
 __ZN14LineParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i4 + 344 >> 2] | 0, i5);
 i1 = i4 + 340 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  STACKTOP = i9;
  return;
 }
}

function __ZN12GraphicsCapsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i2 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 76 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN11TimeManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 441063 | 0, i5, i1 + 48 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 441078 | 0, i5, i1 + 200 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 441103 | 0, i5, i1 + 196 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 441115 | 0, i5, i1 + 204 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619466 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 80 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 88 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619473 | 0, gb + 1034188 | 0, i5, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = i1 + 176 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619482 | 0, gb + 1034188 | 0, i5, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i5, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619491 | 0, HEAP32[gb + 37240 >> 2] | 0, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 if ((HEAP32[gb + 1170792 >> 2] | 0) <= 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = i2 + 11 | 0;
 i5 = i2 + 4 | 0;
 i6 = i3 + 11 | 0;
 i1 = 0;
 while (1) {
  i8 = (HEAP32[gb + 1170796 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  i9 = HEAP8[i4 >> 0] | 0;
  i9 = i9 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i9 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i3, gb + 1087656 | 0, 1, i9 + 1 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i3, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i9) | 0;
  i8 = (__Z7StrICmpPKcS0_(HEAP32[i8 >> 2] | 0, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0) == 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i1 = i1 + 1 | 0;
  if (i8) {
   i1 = 1;
   i2 = 5;
   break;
  }
  if ((i1 | 0) >= (HEAP32[gb + 1170792 >> 2] | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) {
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWritehEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 1) | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIhLj1EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z29Transfer_Blittable_ArrayFieldI9JSONWriteaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 8 | 0;
 i10 = i6;
 i5 = i6 + 16 | 0;
 i3 = gb + 64016 | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i11, i10);
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 >> 2] | 0, 0, 1) | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 HEAP32[i9 >> 2] = i2;
 HEAP32[i7 >> 2] = i2 | -2147483648;
 HEAP32[i5 >> 2] = i8;
 __ZN9JSONWrite8TransferI13dynamic_arrayIaLj1EEEEvRT_PKc17TransferMetaFlags(i1, i5, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 24 >> 2] | 0);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function _jpeg_mem_dest(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 23;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i1 = i5 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = mftCall_iiii(HEAP32[HEAP32[i5 + 4 >> 2] >> 2] | 0, i5 | 0, 0, 40) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 HEAP32[i2 + 8 >> 2] = fb + 3283;
 HEAP32[i2 + 12 >> 2] = fb + 1562;
 HEAP32[i2 + 16 >> 2] = fb + 3284;
 HEAP32[i2 + 20 >> 2] = i6;
 HEAP32[i2 + 24 >> 2] = i7;
 i1 = i2 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i7 >> 2] | 0;
  if (i4 | 0) {
   i7 = i3;
   i6 = i4;
   i5 = i2 + 32 | 0;
   HEAP32[i5 >> 2] = i7;
   HEAP32[i2 >> 2] = i7;
   i7 = i2 + 36 | 0;
   HEAP32[i7 >> 2] = i6;
   i7 = i2 + 4 | 0;
   HEAP32[i7 >> 2] = i6;
   return;
  }
 }
 i4 = _malloc(4096) | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 if (!i4) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 54;
  HEAP32[i4 + 24 >> 2] = 10;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 HEAP32[i7 >> 2] = 4096;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = 4096;
 i5 = i2 + 32 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i2 >> 2] = i7;
 i7 = i2 + 36 | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i2 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZNK9Transform21GetWorldToLocalMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 56 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 i8 = i2 + 32 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z28CalculateGlobalMatrixInverse23TransformAccessReadOnly(i5, i4);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = 0;
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i4;
 HEAP32[i1 + 44 >> 2] = 0;
 i4 = HEAP32[i5 + 40 >> 2] | 0;
 i2 = HEAP32[i5 + 44 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i10 + 20 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i1 = 0; else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 << 2 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i4 = i10 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 i7 = i10 + 12 | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  i10 = i5;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 1 | 0;
  HEAP32[i4 >> 2] = i11;
  i11 = i1 + (i10 << 2) | 0;
  return i11 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 1 | 0;
 HEAP32[i4 >> 2] = i11;
 i11 = i1 + (i10 << 2) | 0;
 return i11 | 0;
}

function __ZN24EllipsoidParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i2 = i7 + 220 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 224 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 228 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 232 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN14RotationModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 536 | 0, i4);
 i1 = i3 + 800 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 }
}

function __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i2 = __Z15GetGraphicsCapsv() | 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i8 = i4 << 24 >> 24 < 0;
 i5 = i8 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i8 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 if (i4 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i4 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i4;
  if (!i4) {
   i8 = i1;
   i8 = i8 + i4 | 0;
   HEAP8[i8 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i6 = i4 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = i6 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i8;
 }
 _memcpy(i1 | 0, i5 | 0, i4 | 0) | 0;
 i8 = i1;
 i8 = i8 + i4 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZNK6Skybox11GetMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEE15growAndPushBackERKS5_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i11 + 20 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 << 2 | 0, HEAP32[i11 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i11 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 i8 = i11 + 12 | 0;
 if ((i6 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i11 = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i9;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i1 + (i11 << 2) | 0;
  return i11 | 0;
 }
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i8 >> 2] | 0);
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i4 >> 2] = i9;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i1 + (i11 << 2) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i11 + 20 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 << 2 | 0, HEAP32[i11 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i11 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 i8 = i11 + 12 | 0;
 if ((i6 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i11 = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i9;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i1 + (i11 << 2) | 0;
  return i11 | 0;
 }
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i8 >> 2] | 0);
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i4 >> 2] = i9;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i1 + (i11 << 2) | 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i10 + 20 | 0;
 i8 = HEAP32[i11 >> 2] | 0;
 i8 = (i8 & 2147483647 | 0) == 0 ? 1 : i8 << 1;
 if (!i8) i1 = 0; else {
  i1 = HEAP32[i10 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 << 2 | 0, HEAP32[i10 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i4 = i10 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 i7 = i10 + 12 | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i7 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i11 >> 2] | 0) <= -1) {
  i10 = i5;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i11 >> 2] = i8;
  i11 = i10 + 1 | 0;
  HEAP32[i4 >> 2] = i11;
  i11 = i1 + (i10 << 2) | 0;
  return i11 | 0;
 }
 i10 = HEAP32[i10 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i7 >> 2] | 0);
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i11 >> 2] = i8;
 i11 = i10 + 1 | 0;
 HEAP32[i4 >> 2] = i11;
 i11 = i1 + (i10 << 2) | 0;
 return i11 | 0;
}

function __ZN4FMOD6System23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_(i2, i1, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  if (i5 | 0) {
   i3 = i1 + 320 | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  }
  if (i6 | 0) {
   i5 = i1 + 332 | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  }
  if (i7 | 0) {
   i6 = i1 + 344 | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  }
  if (!i8) {
   i8 = 0;
   STACKTOP = i4;
   return i8 | 0;
  }
  i7 = i1 + 356 | 0;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870173;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i4;
 return i8 | 0;
}

function __Z8CopyBlobIN7mecanim9animation14AvatarConstantEEPT_RKS3_RNS0_6memory9AllocatorERj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i5 = i9 + 52 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i12 = i4;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i8;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform(i4, i5, 0, -2);
 HEAP8[i4 + 25 >> 0] = 0;
 __ZN9BlobWrite8TransferIN7mecanim9animation14AvatarConstantEEEvRT_PKc17TransferMetaFlags(i4, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i6 >> 2] | 0, 16) | 0;
 if (i1 | 0) _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 __ZN9BlobWriteD2Ev(i4);
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i8);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i9;
 return i1 | 0;
}

function __Z30Mesh_CUSTOM_RecalculateNormalsP12Il2CppObject(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i5 + 4 | 0;
 if (!i4) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i6 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (__ZNK4Mesh19CanAccessFromScriptEv(i1) | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
  __ZN4Mesh18RecalculateNormalsEv(i1);
  STACKTOP = i5;
  return;
 } else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 547266 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 546865 | 0, 470, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 }
}

function __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 88) | 0;
 i3 = i5 + 8 | 0;
 i4 = i3 + 76 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 if (__ZN14dtNavMeshQuery9initPoolsEPK9dtNavMeshi(i5, i1, i2) | 0) return i5 | 0;
 i4 = i5 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i3 = i5 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i1 = i5 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, i5 | 0);
 i5 = 0;
 return i5 | 0;
}

function __Z13TransferArrayILi3Ej19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_(i6, i1, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i1 >> 2] = 3;
 i7 = i3 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = i4 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = 3;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i2 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  STACKTOP = i8;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  STACKTOP = i8;
  return;
 }
}

function __ZN8Animator9GetAvatarEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 104 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 657137 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPKcNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 746872 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx2Cm10Collection6removeERNS_6PxBaseE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i1 = HEAP32[i7 + 64 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i4 = i6;
 i4 = i4 + ~(i4 << 15) | 0;
 i4 = (i4 >>> 10 ^ i4) * 9 | 0;
 i4 = i4 >>> 6 ^ i4;
 i4 = i4 + ~(i4 << 11) | 0;
 i1 = HEAP32[(HEAP32[i7 + 56 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[i7 + 48 >> 2] | 0;
 i3 = i7 + 52 | 0;
 while (1) {
  i2 = i4 + (i1 << 4) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i8 = 8;
   break;
  }
 }
 if ((i8 | 0) == 8) {
  STACKTOP = i9;
  return;
 }
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_(i7 + 4 | 0, i4 + (i1 << 4) + 8 | 0) | 0;
 HEAP32[i5 >> 2] = i6;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_(i7 + 44 | 0, i5) | 0;
 STACKTOP = i9;
 return;
}

function __ZN5Cache20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 68 | 0;
 i3 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i6, i1) | 0;
 if ((i3 | 0) == (i5 + 72 | 0)) return;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i6 >> 2] | 0) == (i3 | 0)) HEAP32[i6 >> 2] = i1;
 i6 = i5 + 76 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i5 + 72 >> 2] | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
 __ZdlPv(i3);
 if (!i4) return;
 __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i4, 8, 0) | 0;
 __ZN15FileSystemEntry6DeleteEb(i4, 0) | 0;
 __ZN13FileEntryDataD2Ev(i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63552 | 0);
 return;
}

function __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i7 = i6;
 i1 = i2 + 20 | 0;
 i8 = i1;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZNK16TypeTreeIterator6FatherEv(i7, i1);
 i4 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i7;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 12 >> 2] | 0) == -1) i4 = -1; else if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) + 12 >> 2] | 0) == -1) i4 = -1; else {
  i4 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) + 12 >> 2] | 0;
  i4 = (HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 12 >> 2] | 0) + i4 | 0;
 }
 i3 = i2 + 16 | 0;
 i1 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 12 >> 2] = i4;
 if (!(HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i5) | 0) + 20 >> 2] & 32768)) {
  STACKTOP = i6;
  return;
 }
 i8 = (HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 32768;
 STACKTOP = i6;
 return;
}

function __ZN17PersistentManager19RemapToAbsolutePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 i7 = i1 + 68 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = i3 - i2 | 0;
 if (!i1) i1 = i2; else {
  i6 = i9 + 11 | 0;
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i11 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i11 * 24 | 0) | 0;
   i3 = (__Z7StrICmpPKcS0_((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9) | 0) < 0;
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i11 | 0 : i11;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
  i3 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  i2 = i3;
  i1 = i3;
  i10 = 8;
 } else if ((__Z7StrICmpPKcS0_((HEAP8[i9 + 11 >> 0] | 0) < 0 ? HEAP32[i9 >> 2] | 0 : i9, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0) >= 0) {
  i2 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  i10 = 8;
 }
 if ((i10 | 0) == 8) if ((i2 | 0) != (i1 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i8, i2 + 12 | 0);
  return;
 }
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i8, i9);
 return;
}

function __ZNK13SparseTexture20TileUploadErrorCheckEiii(i3, i2, i4, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[(__Z15GetGraphicsCapsv() | 0) + 524 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP8[i3 + 100 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411792 | 0, 0, gb + 411582 | 0, 126, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 }
 if ((i1 | 0) >= 0) if ((HEAP32[i3 + 76 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[i3 + 88 >> 2] | 0;
  if ((i2 | 0) >= 0) if (((i1 + -1 + (HEAP32[i3 + 80 >> 2] | 0) | 0) / (i1 | 0) | 0 | 0) > (i2 | 0)) {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   if ((i4 | 0) >= 0) if (((i1 + -1 + (HEAP32[i3 + 84 >> 2] | 0) | 0) / (i1 | 0) | 0 | 0) > (i4 | 0)) {
    i4 = 1;
    return i4 | 0;
   }
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411958 | 0, 0, gb + 411582 | 0, 144, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
   i4 = 0;
   return i4 | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411906 | 0, 0, gb + 411582 | 0, 138, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411857 | 0, 0, gb + 411582 | 0, 132, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 i4 = 0;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 718107 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 714273 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN2UI14CanvasRenderer10SetTextureEP7Texture(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0;
 if (!i1) {
  i9 = 0;
  f2 = Math_fround(0.0);
  i3 = 0;
  f7 = Math_fround(0.0);
  f8 = Math_fround(0.0);
  f4 = Math_fround(0.0);
 } else {
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 72 >> 2]);
  f8 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
  f4 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0);
  if (((HEAP32[i1 + 8 >> 2] | 0) >>> 21 | 0) == (HEAP32[gb + 32032 + 24 >> 2] | 0)) i9 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0) | 0) == 1; else i9 = 0;
 }
 i1 = i10 + 136 | 0;
 i5 = i10 + 160 | 0;
 if ((i3 | 0) == (HEAP32[i1 >> 2] | 0)) i6 = (i9 & 1 | 0) != (HEAPU8[i5 >> 0] | 0 | 0); else i6 = 1;
 HEAP32[i1 >> 2] = i3;
 HEAPF32[i10 + 144 >> 2] = f2;
 HEAPF32[i10 + 148 >> 2] = f7;
 HEAPF32[i10 + 152 >> 2] = f8;
 HEAPF32[i10 + 156 >> 2] = f4;
 HEAP8[i5 >> 0] = i9 & 1;
 if (!i6) return;
 i9 = i10 + 162 | 0;
 HEAP16[i9 >> 1] = HEAPU16[i9 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i10 + 188 >> 2] | 0, i10);
 return;
}

function __ZN22ProceduralMaterialData17SetTextureRawDataEjP25SubstanceRawTextureShared(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i7 >> 2] = i5;
 i8 = i1 + 76 | 0;
 i4 = i1 + 80 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = i4;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) if (!((i1 | 0) == (i4 | 0) ? 1 : (HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i5 >>> 0)) {
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if (i1 | 0) {
    i5 = i1 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
    if (!(HEAP32[i5 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
    }
   }
  }
 }
 i5 = i6 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[(__ZNSt3__23mapIjP25SubstanceRawTextureSharedNS_4lessIjEE13stl_allocatorINS_4pairIKjS2_EEL18MemLabelIdentifier77ELi16EEEixERS7_(i8, i7) | 0) >> 2] = i6;
 STACKTOP = i9;
 return;
}

function __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = i11 + 4 | 0;
 i1 = HEAP32[i12 >> 2] | 0;
 if (!i1) {
  i12 = i11 + 60 | 0;
  i11 = HEAP8[i12 >> 0] | 0;
  i11 = i11 & -7;
  HEAP8[i12 >> 0] = i11;
  return;
 }
 i6 = i10 + 116 | 0;
 i7 = i10 + 128 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i3 = i10 + 132 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i9 >>> 0 > i5 >>> 0) {
  i2 = i4 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 << 2, 4, i10 + 120 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 120 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i6 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i1;
 HEAP32[i11 >> 2] = 0;
 HEAP32[i12 >> 2] = 0;
 i12 = i11 + 60 | 0;
 i11 = HEAP8[i12 >> 0] | 0;
 i11 = i11 & -7;
 HEAP8[i12 >> 0] = i11;
 return;
}

function __ZN14VelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620372 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 800 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN14TerrainManager14GetTerrainDataEP7Terrain(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 if (!i5) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i7 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i3, i1, i4);
   i2 = HEAP32[i3 >> 2] | 0;
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i7 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i7 = 9;
  }
 }
 if ((i7 | 0) == 7) i7 = 9;
 if ((i7 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i5) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN14ParticleSystem8SyncJobsEb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 i3 = (HEAP32[gb + 1451700 >> 2] | 0) + 20 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP8[i3 >> 0] = 0;
 if ((HEAP16[gb + 1451704 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451704 | 0, i1);
  i3 = gb + 1451704 | 0;
 } else i3 = 0;
 if (Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]) == Math_fround(0.0)) {
  if (!i3) {
   STACKTOP = i4;
   return;
  }
  __Z12profiler_endP19ProfilerInformation(i3);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[gb + 1451700 >> 2] | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i2 = 0;
  do {
   i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i5, HEAP32[i5 + 36 >> 2] | 0, HEAP32[i5 + 40 >> 2] | 0, 0);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[gb + 1451700 >> 2] | 0;
  } while (i2 >>> 0 < (HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 }
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i4;
 return;
}

function __ZN12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = i5 + 348 | 0;
 if ((HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0) >>> 0 < 2) {
  i7 = -1;
  return i7 | 0;
 }
 i7 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 156 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 156;
 HEAP32[i6 + (i7 * 360 | 0) + 328 >> 2] = i2;
 _memcpy(i2 | 0, i5 + 352 | 0, 152) | 0;
 i4 = HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0;
 i1 = i4 << 1;
 i3 = i2 + 152 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i5 + 344 >> 2] | 0;
 i5 = HEAP32[i2 + 180 >> 2] | 0;
 i1 = (Math_imul(((i5 | 0) < 0 ? 0 : i5) << 1, i4 + -2 | 0) | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i2 + 184 >> 2] | 0;
 if ((i2 | 0) > 0) HEAP32[i3 >> 2] = i1 + 8 + (i2 << 2);
 HEAP32[i6 + (i7 * 360 | 0) + 332 >> 2] = fb + 216;
 HEAP32[i6 + (i7 * 360 | 0) + 348 >> 2] = 393217;
 HEAP32[i6 + (i7 * 360 | 0) + 340 >> 2] = fb + 510;
 return i7 | 0;
}

function __Z29Mesh_CUSTOM_RecalculateBoundsP12Il2CppObject(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i5 + 4 | 0;
 if (!i4) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i6 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (__ZNK4Mesh19CanAccessFromScriptEv(i1) | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
  __ZN4Mesh17RecalculateBoundsEv(i1);
  STACKTOP = i5;
  return;
 } else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 547213 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 546865 | 0, 454, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i2, i9) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i3 = HEAP16[i2 + 4 >> 1] | 0;
 if (i3 << 16 >> 16 == 1) i7 = i2; else i7 = HEAP32[i2 >> 2] | 0;
 i8 = i3 & 65535;
 i1 = i2 + 8 | 0;
 if ((HEAP16[i2 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
 if (!(i3 << 16 >> 16)) return;
 i5 = i8 + -1 | 0;
 i6 = 0;
 do {
  if (i6 >>> 0 < i5 >>> 0) {
   i4 = HEAP32[i7 + (i6 + 1 << 2) >> 2] | 0;
   i3 = i4;
   i11 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i10 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 207, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i10 = _i64Subtract(1, 0, i11 | 0, i10 | 0) | 0;
   i2 = _i64Add(i10 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
  }
  i2 = i1 + (i6 << 2) | 0;
  if ((__ZNK5physx7NpShape8getFlagsEv(HEAP32[i7 + (i6 << 2) >> 2] | 0) | 0) & 2) __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i9, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 return;
}

function __ZN19SkinnedMeshRendererD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 58672 + 8;
 HEAP32[i2 + 32 >> 2] = gb + 58672 + 196;
 i1 = i2 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 if ((HEAP32[i2 + 492 >> 2] | 0) > -1) {
  i1 = i2 + 476 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 480 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 384 | 0;
 if ((HEAP32[i2 + 400 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 360 | 0;
 if ((HEAP32[i2 + 376 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 364 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 43728 + 8;
 HEAP32[i2 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i2);
 i1 = i2 + 288 | 0;
 if ((HEAP32[i2 + 304 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = gb + 29060 + 8;
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 292 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 29060 + 8;
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 3) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i7 = i9;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = i3 + (i1 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z20UnloadDynamicLibraryPv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[gb + 1162872 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i9 + 4 | 0)) return;
 i7 = i9 + 4 | 0;
 i5 = i1;
 i3 = i2;
 while (1) {
  i4 = i5;
  if ((HEAP32[i3 + 28 >> 2] | 0) == (i6 | 0)) break;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i1) {
   i1 = i4;
   while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   }
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) {
   i8 = 14;
   break;
  } else {
   i5 = i1;
   i3 = i1;
  }
 }
 if ((i8 | 0) == 14) return;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i4;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i9 >> 2] | 0) == (i3 | 0)) HEAP32[i9 >> 2] = i1;
 i8 = i9 + 8 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i9 + 4 >> 2] | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 16 | 0);
 __ZdlPv(i5);
 return;
}

function _UNITY_png_write_sCAL_s(i6, i1, i2, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 64 | 0;
 i8 = i10;
 i4 = _strlen(i2) | 0;
 i5 = _strlen(i3) | 0;
 i9 = i4 + 2 + i5 | 0;
 if (i9 >>> 0 > 64) {
  STACKTOP = i10;
  return;
 }
 HEAP8[i8 >> 0] = i1;
 _memcpy(i8 + 1 | 0, i2 | 0, i4 + 1 | 0) | 0;
 _memcpy(i8 + i4 + 2 | 0, i3 | 0, i5 | 0) | 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 i1 = i6 + 656 | 0;
 HEAP32[i1 >> 2] = 34;
 HEAP8[i7 >> 0] = i9 >>> 24;
 HEAP8[i7 + 1 >> 0] = i9 >>> 16;
 HEAP8[i7 + 2 >> 0] = i9 >>> 8;
 HEAP8[i7 + 3 >> 0] = i9;
 i5 = i7 + 4 | 0;
 HEAP8[i5 >> 0] = 115;
 HEAP8[i7 + 5 >> 0] = 67;
 HEAP8[i7 + 6 >> 0] = 65;
 HEAP8[i7 + 7 >> 0] = 76;
 _UNITY_png_write_data(i6, i7, 8);
 HEAP32[i6 + 372 >> 2] = 1933787468;
 _UNITY_png_reset_crc(i6);
 _UNITY_png_calculate_crc(i6, i5, 4);
 HEAP32[i1 >> 2] = 66;
 if (i9 | 0) {
  _UNITY_png_write_data(i6, i8, i9);
  _UNITY_png_calculate_crc(i6, i8, i9);
 }
 HEAP32[i1 >> 2] = 130;
 i9 = HEAP32[i6 + 408 >> 2] | 0;
 HEAP8[i7 >> 0] = i9 >>> 24;
 HEAP8[i7 + 1 >> 0] = i9 >>> 16;
 HEAP8[i7 + 2 >> 0] = i9 >>> 8;
 HEAP8[i7 + 3 >> 0] = i9;
 _UNITY_png_write_data(i6, i7, 4);
 STACKTOP = i10;
 return;
}

function _UNITY_png_inflate_read(i9, i5, i7, i1, i10, i2) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i8 = 0, i11 = 0;
 if ((HEAP32[i9 + 216 >> 2] | 0) != (HEAP32[i9 + 372 >> 2] | 0)) {
  HEAP32[i9 + 244 >> 2] = gb + 352218;
  return;
 }
 i6 = i9 + 220 | 0;
 HEAP32[i9 + 232 >> 2] = i1;
 i8 = i9 + 236 | 0;
 HEAP32[i8 >> 2] = 0;
 i4 = i9 + 224 | 0;
 i3 = i2 | 0 ? 4 : 2;
 i1 = 1024;
 while (1) {
  if (!(HEAP32[i4 >> 2] | 0)) {
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = i1 >>> 0 > i2 >>> 0 ? i2 : i1;
   HEAP32[i7 >> 2] = i2 - i1;
   if (i1 | 0) {
    _UNITY_png_read_data(i9, i5, i1);
    _UNITY_png_calculate_crc(i9, i5, i1);
   }
   HEAP32[i6 >> 2] = i5;
   HEAP32[i4 >> 2] = i1;
   i2 = i1;
  } else i2 = i1;
  if (!(HEAP32[i8 >> 2] | 0)) {
   i1 = HEAP32[i10 >> 2] | 0;
   HEAP32[i10 >> 2] = 0;
   HEAP32[i8 >> 2] = i1;
  }
  i1 = _unity_z_inflate(i6, (HEAP32[i7 >> 2] | 0) == 0 ? i3 : 0) | 0;
  if (i1 | 0) {
   i11 = 10;
   break;
  }
  if (HEAP32[i10 >> 2] | 0) {
   i1 = i2;
   continue;
  }
  if (!(HEAP32[i8 >> 2] | 0)) {
   i1 = 0;
   i2 = 0;
   i3 = 0;
   break;
  } else i1 = i2;
 }
 if ((i11 | 0) == 10) {
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i2 + i3;
 HEAP32[i8 >> 2] = 0;
 _UNITY_png_zstream_error(i9, i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceIPKcEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_(i4, i1, i5, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i6, i2, i3);
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
 i3 = HEAP8[i6 + 11 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 __THREW__ = 0;
 i1 = invoke_iiiiii(fb + 193 | 0, i4 | 0, i2 - i1 | 0, (HEAP32[i5 >> 2] | 0) - i2 | 0, (i8 ? HEAP32[i6 >> 2] | 0 : i6) | 0, (i8 ? HEAP32[i6 + 4 >> 2] | 0 : i3 & 255) | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i8 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  ___resumeException(i8 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZNK6Camera17GetProjectionNearEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 if (HEAP8[i1 + 1081 >> 0] | 0) {
  f3 = Math_fround(HEAPF32[i1 + 920 >> 2]);
  return Math_fround(f3);
 }
 i4 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0;
 if (!(Math_fround(HEAPF32[i4 + 16 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 32 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 36 >> 2]) != Math_fround(0.0))) {
  f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  if (!(f2 != Math_fround(0.0))) {
   f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   if (!(f3 != Math_fround(0.0))) {
    f5 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    f8 = Math_fround(HEAPF32[i4 + 44 >> 2]);
    f6 = Math_fround(HEAPF32[i4 + 60 >> 2]);
    f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
    f5 = Math_fround(f5 + f2);
    f2 = Math_fround(f9 + f3);
    f3 = Math_fround(f8 + f7);
    f3 = Math_fround(Math_fround(-Math_fround(f6 + Math_fround(HEAPF32[i4 + 56 >> 2]))) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f2 * f2)) + Math_fround(f3 * f3)))));
    return Math_fround(f3);
   }
  }
 }
 f9 = Math_fround(HEAPF32[i1 + 920 >> 2]);
 return Math_fround(f9);
}

function __ZN5physx9NpFactory17createRigidStaticERKNS_11PxTransformE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i5 = i8;
 i4 = i6 + 1240 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i1 = i6 + 1236 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i6 + 944 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 i1 = i6 + 1224 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6 + 1228 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx13NpRigidStaticC2ERKNS_11PxTransformE(i3, i2);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 >> 2] = i3;
 if (!i3) {
  STACKTOP = i8;
  return i3 | 0;
 }
 i2 = i6 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i6 + 564 | 0, i5, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i8;
 return i3 | 0;
}

function __ZN18BuoyancyEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 805281 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153396 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = i4;
 i5 = gb + 63408 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = gb + 153972 + 8;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 1;
 HEAP32[i4 + 84 >> 2] = 1812433254;
 HEAP32[i4 + 88 >> 2] = 1900727103;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i6, gb + 843849 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i6 + 12 | 0, gb + 843853 | 0, 0);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
 }
 HEAP32[i6 + 24 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 28 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN15dtLocalBoundary10addSegmentEfPKf(i3, f4, i5) {
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i6 = i3 + 236 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if (!i2) i1 = i3 + 12 | 0; else {
  if (Math_fround(HEAPF32[i3 + 12 + ((i2 + -1 | 0) * 28 | 0) + 24 >> 2]) <= f4) if ((i2 | 0) > 7) return; else {
   i1 = i3 + 12 + (i2 * 28 | 0) | 0;
   break;
  }
  L10 : do if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    if (Math_fround(HEAPF32[i3 + 12 + (i1 * 28 | 0) + 24 >> 2]) >= f4) break L10;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (i2 | 0));
  } else i1 = 0; while (0);
  if ((i2 | 0) == (i1 | 0)) return;
  i7 = i2 - i1 | 0;
  i2 = 7 - i1 | 0;
  i2 = (i7 | 0) < (i2 | 0) ? i7 : i2;
  if ((i2 | 0) > 0) {
   i7 = i3 + 12 + (i1 * 28 | 0) | 0;
   _memmove(i3 + 12 + ((i1 + 1 | 0) * 28 | 0) | 0, i7 | 0, i2 * 28 | 0) | 0;
   i1 = i7;
   break;
  } else {
   i1 = i3 + 12 + (i1 * 28 | 0) | 0;
   break;
  }
 } while (0);
 HEAPF32[i1 + 24 >> 2] = f4;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) >= 8) return;
 HEAP32[i6 >> 2] = i1 + 1;
 return;
}

function __ZN13RenderManager19GetCurrentCameraPtrEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN10BlendShape8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i4 = i5 + 4 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
  i3 = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i4, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i5 + 8 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
  return;
 }
}

function __Z54PolygonCollider2D_CUSTOM_INTERNAL_CALL_CreatePrimitiveP12Il2CppObjectiRK13Vector2fIcallS3_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9;
 if ((i2 | 0) < 3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808443 | 0, 0, gb + 808253 | 0, 2489, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 if (Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0)) {
  i8 = i4 + 4 | 0;
  if (Math_fround(HEAPF32[i8 >> 2]) > Math_fround(0.0)) {
   if (!i1) {
    i3 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   }
   i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
   if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   __ZN17PolygonCollider2D15CreatePrimitiveEi8Vector2fS0_b(i3, i2, i6, i7, 1);
   STACKTOP = i9;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808515 | 0, 0, gb + 808253 | 0, 2495, 1, 0, 0, 0);
 STACKTOP = i9;
 return;
}

function __Z42TrailRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517745 | 0, i3);
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517745 | 0, i3);
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 + 384 >> 2] | 0;
  HEAP32[i1 + 108 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 112 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 116 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 128 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 132 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 136 >> 2] = HEAP32[i2 + 28 >> 2];
  i1 = i1 + 140 | 0;
  i2 = i2 + 32 | 0;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i5;
  return;
 }
}

function _h2v1_fancy_upsample(i2, i3, i14, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i15 = 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i12 = i2 + 276 | 0;
 if ((HEAP32[i12 >> 2] | 0) <= 0) return;
 i11 = i3 + 40 | 0;
 i10 = 0;
 do {
  i3 = HEAP32[i14 + (i10 << 2) >> 2] | 0;
  i1 = HEAP32[i13 + (i10 << 2) >> 2] | 0;
  i2 = i3 + 1 | 0;
  i8 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i8;
  HEAP8[i1 + 1 >> 0] = (((i8 & 255) * 3 | 0) + 2 + (HEAPU8[i2 >> 0] | 0) | 0) >>> 2;
  i8 = HEAP32[i11 >> 2] | 0;
  i4 = i8 + -2 | 0;
  i5 = i1 + 2 | 0;
  if (!i4) i3 = i5; else {
   i9 = i8 << 1;
   i7 = i3 + -1 | 0;
   i6 = i1 + -2 | 0;
   i3 = i1;
   while (1) {
    i15 = (HEAPU8[i2 >> 0] | 0) * 3 | 0;
    HEAP8[i5 >> 0] = ((HEAPU8[i2 + -1 >> 0] | 0) + 1 + i15 | 0) >>> 2;
    i2 = i2 + 1 | 0;
    HEAP8[i3 + 3 >> 0] = (i15 + 2 + (HEAPU8[i2 >> 0] | 0) | 0) >>> 2;
    i4 = i4 + -1 | 0;
    if (!i4) break; else {
     i3 = i5;
     i5 = i5 + 2 | 0;
    }
   }
   i3 = i6 + i9 | 0;
   i2 = i7 + i8 | 0;
   i1 = i1 + -4 + i9 | 0;
  }
  i15 = HEAP8[i2 >> 0] | 0;
  HEAP8[i3 >> 0] = ((HEAPU8[i2 + -1 >> 0] | 0) + 1 + ((i15 & 255) * 3 | 0) | 0) >>> 2;
  HEAP8[i1 + 3 >> 0] = i15;
  i10 = i10 + 1 | 0;
 } while ((i10 | 0) < (HEAP32[i12 >> 2] | 0));
 return;
}

function _cf2_arrstack_push(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i10 = i8 + 20 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i7 = i8 + 12 | 0;
 do if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  i5 = (HEAP32[i8 + 16 >> 2] | 0) + i2 | 0;
  HEAP32[i6 >> 2] = 0;
  i3 = i8 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = Math_imul(i4, i5) | 0;
  if ((2147483647 / (i4 >>> 0) | 0) >>> 0 >= i5 >>> 0) {
   i4 = i8 + 24 | 0;
   i12 = i8 + 28 | 0;
   i1 = _UNITY_ft_mem_realloc(HEAP32[i8 >> 2] | 0, 1, HEAP32[i4 >> 2] | 0, i2, HEAP32[i12 >> 2] | 0, i6) | 0;
   HEAP32[i12 >> 2] = i1;
   if (!(HEAP32[i6 >> 2] | 0)) {
    HEAP32[i7 >> 2] = i5;
    HEAP32[i4 >> 2] = i2;
    i2 = HEAP32[i10 >> 2] | 0;
    if (i2 >>> 0 <= i5 >>> 0) break;
    _cf2_setError(HEAP32[i8 + 4 >> 2] | 0, 130);
    HEAP32[i10 >> 2] = i5;
    STACKTOP = i11;
    return;
   }
  }
  _cf2_setError(HEAP32[i8 + 4 >> 2] | 0, 64);
  STACKTOP = i11;
  return;
 } else {
  i3 = i8 + 8 | 0;
  i1 = HEAP32[i8 + 28 >> 2] | 0;
 } while (0);
 i12 = HEAP32[i3 >> 2] | 0;
 _memcpy(i1 + (Math_imul(i12, i2) | 0) | 0, i9 | 0, i12 | 0) | 0;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 STACKTOP = i11;
 return;
}

function __ZNK5Light8GetFlareEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5physx9NpFactory18createRigidDynamicERKNS_11PxTransformE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i5 = i8;
 i4 = i6 + 940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i1 = i6 + 936 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i6 + 644 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 i1 = i6 + 924 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i6 + 928 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx14NpRigidDynamicC2ERKNS_11PxTransformE(i3, i2);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 >> 2] = i3;
 if (!i3) {
  STACKTOP = i8;
  return i3 | 0;
 }
 i2 = i6 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i6 + 564 | 0, i5, i7) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i8;
 return i3 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 720203 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 738802 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i2 = i6 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i1 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN5physx3Scb5Scene18removeArticulationERNS0_12ArticulationE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i3 = i7;
 i4 = i1 + 2700 | 0;
 L1 : do if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -769;
  __ZN5physx2Sc5Scene18removeArticulationERNS0_16ArticulationCoreE(i1 + 16 | 0, i6 + 12 | 0);
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
 } else {
  i1 = i6 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  switch (i2 >>> 30 | 0) {
  case 1:
   {
    HEAP32[i1 >> 2] = i2 & 1073741823;
    HEAP32[i5 >> 2] = i6;
    __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i4, i5) | 0;
    break L1;
   }
  case 2:
   break;
  default:
   break L1;
  }
  HEAP32[i1 >> 2] = i2 | -1073741824;
  if (!(i2 & 268435456)) {
   HEAP32[i3 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  }
 } while (0);
 HEAP8[i6 + 52 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN5physx12NpConstraint7setFlagENS_16PxConstraintFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11;
 i9 = i6 + 16 | 0;
 i10 = i6 + 20 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP16[i6 + 124 >> 1] | 0;
 if (!(i8 & 4)) i1 = HEAP16[i6 + 28 >> 1] & (i1 | -2); else i1 = HEAP16[(HEAP32[i6 + 24 >> 2] | 0) + 16 >> 1] & (i1 | -2);
 if (i3) i5 = (i1 & 65535 | i2) & 65535; else i5 = i1 & ((i2 ^ 65535) & 65535);
 switch (i8 >>> 30 | 0) {
 case 3:
  {
   i3 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i7 = 10; else i3 = i9;
   break;
  }
 default:
  i7 = 10;
 }
 if ((i7 | 0) == 10) {
  HEAP16[i4 >> 1] = i5;
  __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i6 + 28 | 0, i4);
  STACKTOP = i11;
  return;
 }
 i2 = i6 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i8 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 + 16 >> 1] = i5;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 4;
 STACKTOP = i11;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i9, i5, i1) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i9 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i6 >> 2] = i3;
  i1 = i4;
 }
 __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j(i5, i1);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 4 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i6 >> 2] = i3;
  }
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i9, i1 + 4 | 0, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i9);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i4 | 0));
 STACKTOP = i8;
 return;
}

function __ZN13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 12 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 12 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 12 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 12 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 12 | 0) | 0;
 _memmove(i14 + (i8 * 12 | 0) | 0, i14 | 0, i11 * 12 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN12InputManager16CheckConsistencyEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (HEAP32[i6 + 52 >> 2] | 0) _memset(HEAP32[i6 + 48 >> 2] | 0, 0, HEAP32[i6 + 56 >> 2] << 2 | 0) | 0;
 if (HEAP32[i6 + 72 >> 2] | 0) _memset(HEAP32[i6 + 68 >> 2] | 0, 0, HEAP32[i6 + 76 >> 2] << 2 | 0) | 0;
 if (HEAP32[i6 + 92 >> 2] | 0) _memset(HEAP32[i6 + 88 >> 2] | 0, 0, HEAP32[i6 + 96 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i6 + 128 >> 2] | 0;
 i2 = HEAP32[i6 + 124 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i6 = i6 + 100 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
 i2 = (i1 - i2 | 0) / 12 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0;
  if ((i3 | 0) != (i4 | 0)) {
   i3 = i3 - i4 >> 2;
   _memset(i4 | 0, 0, (i3 >>> 0 > 1 ? i3 : 1) << 2 | 0) | 0;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 i6 = i6 + 100 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 return;
}

function __Z41LineRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517745 | 0, i3);
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517745 | 0, i3);
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  HEAP32[i1 + 108 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 112 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 116 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 128 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 132 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 136 >> 2] = HEAP32[i2 + 28 >> 2];
  i1 = i1 + 140 | 0;
  i2 = i2 + 32 | 0;
  i3 = i1 + 40 | 0;
  do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i1 | 0) < (i3 | 0));
  STACKTOP = i5;
  return;
 }
}

function __ZNK9Transform21GetLocalToWorldMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 56 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 i8 = i2 + 32 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z21CalculateGlobalMatrix23TransformAccessReadOnly(i5, i4);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = 0;
 i2 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i4;
 HEAP32[i1 + 44 >> 2] = 0;
 i4 = HEAP32[i5 + 40 >> 2] | 0;
 i2 = HEAP32[i5 + 44 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 STACKTOP = i3;
 return;
}

function __ZNK21EnlightenSceneMapping24GetRadiositySystemHashesER13dynamic_arrayI7Hash128Lj8EE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i7 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2 << 4, 8, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 8, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] << 4 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  break;
 } while (0);
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i7 + 20 >> 2] | 0;
 i1 = 0;
 do {
  i7 = i2 + (i1 * 56 | 0) + 40 | 0;
  i6 = HEAP32[i7 + 4 >> 2] | 0;
  i5 = i3 + (i1 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i5 + 4 >> 2] = i6;
  i5 = i2 + (i1 * 56 | 0) + 48 | 0;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i3 + (i1 << 4) + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 while (1) {
  if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0)) {
   i1 = 0;
   i2 = 11;
   break;
  }
  i2 = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
  i3 = __Z29scripting_class_get_namespaceP11Il2CppClass(i1) | 0;
  if (!(_strcmp(i2, gb + 590493 | 0) | 0)) {
   i5 = (_strcmp(i3, gb + 1049797 | 0) | 0) == 0;
   i2 = i5 ? gb + 590111 | 0 : i2;
  }
  i2 = __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(i2, 0) | 0;
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 264 >> 2] | 0) | 0) i4 = 1; else i4 = __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 356 >> 2] | 0) | 0;
  i3 = (i2 | 0) != 0;
  if (i3) i5 = ((HEAP32[i2 + 24 >> 2] | 0) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0; else i5 = 0;
  i2 = i3 & (i4 ^ i5) ? 0 : i2;
  if (i2 | 0) {
   i1 = i2;
   i2 = 11;
   break;
  }
  i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
  if (!i1) {
   i1 = 0;
   i2 = 11;
   break;
  }
 }
 if ((i2 | 0) == 11) return i1 | 0;
 return 0;
}

function __ZN12InputManager7GetAxisERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f1 = f0, i3 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i3 = i4 + 11 | 0;
 i11 = __Z7FNVHashPKc((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0;
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 i10 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i6 | 0) == (i10 | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i9 = HEAP8[i3 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i9 = i8 ? HEAP32[i4 + 4 >> 2] | 0 : i9 & 255;
 i8 = i8 ? HEAP32[i4 >> 2] | 0 : i4;
 f1 = Math_fround(0.0);
 do {
  if ((HEAP32[i6 + 20 >> 2] | 0) == (i11 | 0)) {
   i3 = i6 + 4 | 0;
   i7 = HEAP8[i3 + 11 >> 0] | 0;
   i2 = i7 << 24 >> 24 < 0;
   if (i2) i4 = HEAP32[i6 + 8 >> 2] | 0; else i4 = i7 & 255;
   if ((i4 | 0) == (i9 | 0)) {
    if (i2) {
     i3 = HEAP32[i3 >> 2] | 0;
     i2 = HEAP32[i6 + 8 >> 2] | 0;
    } else i2 = i7 & 255;
    if (!(_strncmp(i3, i8, i2) | 0)) {
     f5 = Math_fround(HEAPF32[i6 + 80 >> 2]);
     i4 = f5 < Math_fround(0.0);
     f13 = Math_fround(-f5);
     i7 = f1 < Math_fround(0.0);
     f12 = Math_fround(-f1);
     if ((i4 ? f13 : f5) > (i7 ? f12 : f1)) f1 = f5;
    }
   }
  }
  i6 = i6 + 108 | 0;
 } while ((i6 | 0) != (i10 | 0));
 return Math_fround(f1);
}

function __ZN11MonoManager8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i2, i5);
 __ZN14SafeBinaryRead10SetVersionEi(i5, 2);
 i3 = i2 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 463993 | 0, HEAP32[gb + 37228 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS4_EE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags(i5, i3, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 212 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 464003 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN9AudioClip14QueueAudioDataEPKvj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i3 = i8;
 i7 = i8 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = i1 + 124 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i3 >> 2] = gb + 872380;
  __Z6FormatPKcz(i4, gb + 854751 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 854464 | 0, 669, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = i2 + 8 | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i2 + i6 - (HEAP32[i1 >> 2] | 0) | 0) >>> 0 < 65536) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier27ELi16EEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueENS_11__wrap_iterIS6_EEE4typeENSC_IPKhEES8_S8_(i1, i4, i5, i5 + i6 | 0) | 0;
  i1 = 1;
 } else i1 = 0;
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = i9 << 2;
  if (!i1) i6 = 0; else {
   i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
   i6 = _PxGetFoundation() | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
   i6 = mftCall_iiiiii(i4 | 0, i7 | 0, i1 | 0, (i6 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN23CloudWebServicesManager17PlayerLoopHandlerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i7 = i1 + 44 | 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (i7 | 0)) {
  STACKTOP = i10;
  return;
 }
 i8 = i1 + 56 | 0;
 i4 = i1 + 52 | 0;
 i5 = i6 + 4 | 0;
 i1 = i2;
 do {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!(HEAP32[i2 + 1144 >> 2] | 0)) i9 = 6; else if ((HEAP32[i2 >> 2] | 0) == 2) i9 = 6; else {
   __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv(i2);
   __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv(i2 + 200 | 0);
   __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv(i2 + 792 | 0);
   i1 = HEAP32[i3 + 4 >> 2] | 0;
  }
  if ((i9 | 0) == 6) {
   i9 = 0;
   i11 = i3 + 4 | 0;
   i2 = HEAP32[i11 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 + 4 >> 2] = i2;
   HEAP32[HEAP32[i11 >> 2] >> 2] = i3;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
   i3 = HEAP32[i8 >> 2] | 0;
   HEAP32[i6 >> 2] = 85;
   HEAP32[i5 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
   i1 = i2;
  }
  i3 = i1;
 } while ((i3 | 0) != (i7 | 0));
 STACKTOP = i10;
 return;
}

function __ZN10SizeModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 899332 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 272 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 536 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1084342 | 0, gb + 620173 | 0, i3, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620483 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 800 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN10BlendShape11UpdateFlagsERK13dynamic_arrayI16BlendShapeVertexLj4EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 i6 = i1 + 9 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i1 + 8 | 0;
 HEAP8[i7 >> 0] = 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i8) return;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 i3 = 0;
 do {
  i12 = i5 + i1 | 0;
  f9 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 12 >> 2]);
  f9 = Math_fround(f9 * f9);
  f10 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 16 >> 2]);
  f10 = Math_fround(f9 + Math_fround(f10 * f10));
  f9 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 20 >> 2]);
  i11 = Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9)))) > Math_fround(9.99999974e-06);
  f9 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 24 >> 2]);
  f9 = Math_fround(f9 * f9);
  f10 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 28 >> 2]);
  f10 = Math_fround(f9 + Math_fround(f10 * f10));
  f9 = Math_fround(HEAPF32[i4 + (i12 * 40 | 0) + 32 >> 2]);
  i2 = (i11 | i2 << 24 >> 24 != 0) & 1;
  i3 = (i3 << 24 >> 24 ? 1 : Math_fround(Math_sqrt(Math_fround(f10 + Math_fround(f9 * f9)))) > Math_fround(9.99999974e-06)) & 1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i8 >>> 0);
 HEAP8[i7 >> 0] = i2;
 HEAP8[i6 >> 0] = i3;
 return;
}

function _encrypt(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 8 | 0;
 i10 = i11;
 i3 = 0;
 i4 = i9;
 while (1) {
  i8 = i10 + (i3 << 2) | 0;
  HEAP32[i8 >> 2] = 0;
  i2 = 31;
  i5 = i4;
  i7 = 0;
  while (1) {
   i7 = ((HEAPU8[i5 >> 0] | 0) & 1) << i2 | i7;
   HEAP32[i8 >> 2] = i7;
   if ((i2 | 0) <= 0) break; else {
    i2 = i2 + -1 | 0;
    i5 = i5 + 1 | 0;
   }
  }
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == 2) break; else i4 = i4 + 32 | 0;
 }
 if (!i6) i1 = gb + 1469560 | 0; else {
  i2 = 0;
  do {
   i8 = 15 - i2 | 0;
   HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[gb + 1469560 + (i8 << 2) >> 2];
   HEAP32[i1 + 64 + (i2 << 2) >> 2] = HEAP32[gb + 1469560 + 64 + (i8 << 2) >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != 16);
 }
 i5 = i10 + 4 | 0;
 ___do_des(HEAP32[i10 >> 2] | 0, HEAP32[i5 >> 2] | 0, i10, i5, 1, 0, i1);
 i5 = 0;
 i2 = i9;
 while (1) {
  i4 = i10 + (i5 << 2) | 0;
  i1 = 31;
  i3 = i2;
  while (1) {
   HEAP8[i3 >> 0] = (HEAP32[i4 >> 2] | 0) >>> i1 & 1;
   if ((i1 | 0) > 0) {
    i1 = i1 + -1 | 0;
    i3 = i3 + 1 | 0;
   } else break;
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 2) break; else i2 = i2 + 32 | 0;
 }
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE8__appendEj(i7, i9) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i8 = i7 + 8 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i3 = i4;
 if (i2 - i4 >> 5 >>> 0 >= i9 >>> 0) {
  i1 = i9;
  i2 = i3;
  while (1) {
   HEAP8[i2 + 31 >> 0] = 1;
   i1 = i1 + -1 | 0;
   if (!i1) break; else i2 = i2 + 32 | 0;
  }
  HEAP32[i10 >> 2] = i3 + (i9 << 5);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = (i4 - i1 >> 5) + i9 | 0;
 if (i3 >>> 0 > 134217727) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i2 - i1 | 0;
 i2 = i6 >> 4;
 i2 = i6 >> 5 >>> 0 < 67108863 ? (i2 >>> 0 < i3 >>> 0 ? i3 : i2) : 134217727;
 if (!i2) i3 = 0; else i3 = __Znwj(i2 << 5) | 0;
 i6 = i3 + (i4 - i1 >> 5 << 5) | 0;
 i5 = i3 + (i2 << 5) | 0;
 i2 = i9;
 i3 = i6;
 while (1) {
  HEAP8[i3 + 31 >> 0] = 1;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 32 | 0;
 }
 i2 = i4 - i1 | 0;
 i3 = i6 + (0 - (i2 >> 5) << 5) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i6 + (i9 << 5);
 HEAP32[i8 >> 2] = i5;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i1 + 8 | 0;
 i8 = i1 + 16 | 0;
 i1 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + 36 >> 2] | 0) | 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = i1 - i3 - (HEAP32[i8 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 if (!i3) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 * 20 | 0, 4) | 0;
  i3 = i1 + (i3 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAPF32[i4 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i4 + 12 >> 2] = 0;
 STACKTOP = i7;
 return i4 | 0;
}

function __ZN14AreaEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 805132 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 153396 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = i4;
 i5 = gb + 63408 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = gb + 153172 + 8;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 1;
 HEAP32[i4 + 84 >> 2] = 1812433254;
 HEAP32[i4 + 88 >> 2] = 1900727103;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 108 | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i1 = i6 + 96 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 104 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function _fmaf(f2, f3, f7) {
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f7 = Math_fround(f7);
 var d1 = 0.0, i4 = 0, d5 = 0.0, d6 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 d1 = +f2 * +f3;
 d5 = +f7;
 d6 = d1 + d5;
 HEAPF64[tempDoublePtr >> 3] = d6;
 i11 = HEAP32[tempDoublePtr >> 2] | 0;
 i4 = _bitshift64Lshr(i11 | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 52) | 0;
 getTempRet0() | 0;
 i4 = i4 & 2047;
 if (d6 - d1 == d5 | ((i11 & 536870911 | 0) != 268435456 | 0 != 0 | (i4 | 0) == 2047)) i9 = 3; else if (!(_fegetround() | 0)) {
  _fesetround(3072) | 0;
  HEAPF64[i8 >> 3] = d1;
  d1 = d5 + +HEAPF64[i8 >> 3];
  _fesetround(0) | 0;
  if (d6 == d1) {
   HEAPF64[tempDoublePtr >> 3] = d1;
   i8 = _i64Add(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 1, 0) | 0;
   i11 = getTempRet0() | 0;
   HEAP32[tempDoublePtr >> 2] = i8;
   HEAP32[tempDoublePtr + 4 >> 2] = i11;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 } else i9 = 3;
 if ((i9 | 0) == 3) if ((i4 + -874 | 0) >>> 0 < 23) if (!(_fetestexcept(32) | 0)) d1 = d6; else {
  HEAPF32[i8 >> 2] = f7;
  d1 = d1 + +Math_fround(HEAPF32[i8 >> 2]);
  (_fetestexcept(32) | 0) == 0;
 } else d1 = d6;
 f7 = Math_fround(d1);
 STACKTOP = i10;
 return Math_fround(f7);
}

function __ZNK5Umbra6KDTree11getMaxDepthEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = 2;
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i6 = 0;
 i1 = 0;
 i3 = 0;
 L1 : while (1) {
  i5 = i3 << 1;
  i2 = i8 + (i6 << 3) | 0;
  do if (((HEAP32[i9 + (i5 >> 5 << 2) >> 2] | 0) >>> (i5 & 30) & 3 | 0) == 3) {
   HEAP32[i2 >> 2] = 0;
   i1 = (i6 | 0) > (i1 | 0) ? i6 : i1;
   i10 = 5;
  } else {
   i4 = HEAP32[i2 >> 2] | 0;
   if (!i4) i10 = 5; else {
    i5 = i6 + 1 | 0;
    if ((i6 | 0) > 38) {
     i1 = -1;
     i10 = 13;
     break L1;
    }
    HEAP32[i8 + (i5 << 3) >> 2] = 2;
    HEAP32[i2 >> 2] = i4 + -1;
    i2 = (__ZNK5Umbra6KDTree4rankEi(i7, i3) | 0) << 1;
    if ((i4 | 0) == 2) {
     HEAP32[i8 + (i5 << 3) + 4 >> 2] = i2 + -1;
     i2 = i5;
     break;
    } else {
     HEAP32[i8 + (i5 << 3) + 4 >> 2] = i2;
     i2 = i5;
     break;
    }
   }
  } while (0);
  if ((i10 | 0) == 5) {
   i10 = 0;
   i2 = i6 + -1 | 0;
  }
  if ((i2 | 0) <= -1) break;
  i6 = i2;
  i3 = HEAP32[i8 + (i2 << 3) + 4 >> 2] | 0;
 }
 if ((i10 | 0) == 13) {
  STACKTOP = i11;
  return i1 | 0;
 }
 i10 = i1 + 1 | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7Cursors17GetSoftwareCursorEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 8 | 0;
 i3 = i5;
 i1 = HEAP32[gb + 1100512 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i4 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i6 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i4 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i4 = 9;
  }
 }
 if ((i4 | 0) == 7) i4 = 9;
 if ((i4 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(HEAP32[gb + 1100512 >> 2] | 0) | 0;
 i6 = i1;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN5physx2Sn13XmlNodeReader14addOrGotoChildEPKc(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 if (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, i5 | 0) | 0) return;
 i4 = (HEAP32[i7 + 8 >> 2] | 0) + 4 | 0;
 i8 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, 24) | 0;
 HEAP32[i8 >> 2] = gb + 1576256;
 i6 = i8 + 4 | 0;
 HEAP32[i6 >> 2] = gb + 1576256;
 i3 = i8 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i5) i1 = gb + 1576256 | 0; else if (!(HEAP8[i5 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i5;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i6 >> 2] = gb + 1576256;
 i4 = i7 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i8 + 20 >> 2] = i1;
 i1 = i1 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) HEAP32[i1 >> 2] = i8; else {
  while (1) {
   i1 = i2 + 8 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  HEAP32[i1 >> 2] = i8;
  HEAP32[i8 + 12 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i8;
 return;
}

function __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 340 | 0, i4);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3 + 344 | 0, i4);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 360 >> 0] = i1;
 i1 = i3 + 361 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i7 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i7;
  HEAP32[i6 >> 2] = i3;
  HEAP8[i1 >> 0] = i7;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i8 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i7 + 4 | 0;
  i5 = i7 + 4 | 0;
  do {
   HEAP32[i8 >> 2] = i2 + -64;
   i3 = i2 + -44 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i10 = HEAP32[i2 + -32 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i4 >> 2] = i10;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
   }
   i3 = i2 + -60 | 0;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i10 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i2 + -48 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i5 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i10, i7);
   }
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i10 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 25;
 HEAP32[i7 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZNK7VRInput21GetReferenceTransformE4PPtrI9TransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = i5;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if ((i4 | 0) >= (HEAP32[i1 + 16 >> 2] | 0)) {
   i5 = i1 + 20 | 0;
   return i5 | 0;
  }
 }
 if (HEAP8[gb + 1573589 >> 0] | 0) {
  i5 = gb + 1469228 | 0;
  return i5 | 0;
 }
 HEAP32[gb + 1469228 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[gb + 1469228 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[gb + 1469228 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[gb + 1469228 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1469228 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1469228 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1469228 + 24 >> 2] = Math_fround(1.0);
 i1 = gb + 1469228 + 28 | 0;
 i2 = gb + 1162292 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[gb + 1573589 >> 0] = 1;
 i5 = gb + 1469228 | 0;
 return i5 | 0;
}

function __ZN5Umbra12QueryContext10isGateOpenERKNS_10MappedTileERKNS_6PortalE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = i1 & 4095;
 if (!i9) {
  i9 = 1;
  return i9 | 0;
 }
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 i7 = i1 >>> 12;
 i8 = i8 + (HEAP32[i8 + 120 >> 2] | 0) | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0;
 i5 = (i6 | 0) == 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i4 = i1 + 16 | 0;
 if (!i1) {
  if (i5) {
   i9 = 1;
   return i9 | 0;
  } else i1 = 0;
  while (1) {
   i2 = HEAP32[i8 + (i7 + i1 << 2) >> 2] | 0;
   if ((i2 | 0) >= 0) if (!(HEAP32[i6 + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31))) {
    i1 = 0;
    i2 = 12;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i9 | 0)) {
    i1 = 1;
    i2 = 12;
    break;
   }
  }
  if ((i2 | 0) == 12) return i1 | 0;
 }
 if (i5) {
  i9 = 1;
  return i9 | 0;
 }
 i2 = i3 + (HEAP32[i4 >> 2] | 0) | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i2 + (HEAP32[i8 + (i7 + i1 << 2) >> 2] << 2) >> 2] | 0;
  if ((i3 | 0) >= 0) if (!(HEAP32[i6 + (i3 >> 5 << 2) >> 2] & 1 << (i3 & 31))) {
   i1 = 0;
   i2 = 12;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i9 | 0)) {
   i1 = 1;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN14SphereCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 i2 = i7 + 60 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN13dynamic_arrayI28EnlightenRendererInformationLj8EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 40 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 40 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 40 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 40 | 0) | 0;
 _memmove(i14 + (i8 * 40 | 0) | 0, i14 | 0, i11 * 40 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN10BlendShape8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426457 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426469 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426481 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 426492 | 0, i5, i1 + 9 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __Z13TransferFieldI9JSONWriteLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo(i6, HEAP32[i2 + 24 >> 2] | 0);
 __ZN9JSONWrite8TransferINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i3, i6, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i4 >> 2] = i2 + -72;
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i7;
 return;
}

function __ZNKSt3__212ctype_bynameIwE10do_scan_isEtPKwS3_(i2, i3, i1, i14) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = i2 + 8 | 0;
 i10 = i3 & 65535;
 i11 = (i10 & 8192 | 0) == 0;
 i12 = (i10 & 16384 | 0) == 0;
 i3 = (i10 & 2 | 0) == 0;
 i4 = (i10 & 256 | 0) == 0;
 i5 = (i10 & 512 | 0) == 0;
 i6 = (i10 & 1024 | 0) == 0;
 i7 = (i10 & 2048 | 0) == 0;
 i8 = (i10 & 4 | 0) == 0;
 i9 = (i10 & 4096 | 0) == 0;
 i10 = (i10 & 1 | 0) == 0;
 while (1) {
  if ((i1 | 0) == (i14 | 0)) {
   i1 = i14;
   break;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i11) if (_iswspace_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i12) if (_iswprint_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i3) if (_iswcntrl_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i4) if (_iswupper_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i5) if (_iswlower_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i6) if (_iswalpha_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i7) if (_iswdigit_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i8) if (_iswpunct_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i9) if (_iswxdigit_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  if (!i10) if (_iswblank_l(i2, HEAP32[i13 >> 2] | 0) | 0) break;
  i1 = i1 + 4 | 0;
 }
 return i1 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  if (!i1) break; else {
   i7 = i7 + 4 | 0;
   i6 = i6 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739046 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __Z63ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterPropertiesP12Il2CppObjectii(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i8 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    __ZN14ParticleSystem8SyncJobsEb(1);
    HEAP32[(HEAP32[(HEAP32[i1 + 916 >> 2] | 0) + 8 >> 2] | 0) + (i3 * 12 | 0) + 8 >> 2] = i4;
    STACKTOP = i7;
    return;
   }
  }
 }
 i8 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i5) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i8;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i6);
}

function __ZNSt3__212__get_sp_mutEPKv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i4 + 4 | 0;
 if (!(HEAP8[gb + 1100456 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100456 | 0) | 0) {
  HEAP32[gb + 1476848 >> 2] = gb + 1476400;
  HEAP32[gb + 1476848 + 4 >> 2] = gb + 1476400 + 28;
  HEAP32[gb + 1476848 + 8 >> 2] = gb + 1476400 + 56;
  HEAP32[gb + 1476848 + 12 >> 2] = gb + 1476400 + 84;
  HEAP32[gb + 1476848 + 16 >> 2] = gb + 1476400 + 112;
  HEAP32[gb + 1476848 + 20 >> 2] = gb + 1476400 + 140;
  HEAP32[gb + 1476848 + 24 >> 2] = gb + 1476400 + 168;
  HEAP32[gb + 1476848 + 28 >> 2] = gb + 1476400 + 196;
  HEAP32[gb + 1476848 + 32 >> 2] = gb + 1476400 + 224;
  HEAP32[gb + 1476848 + 36 >> 2] = gb + 1476400 + 252;
  HEAP32[gb + 1476848 + 40 >> 2] = gb + 1476400 + 280;
  HEAP32[gb + 1476848 + 44 >> 2] = gb + 1476400 + 308;
  HEAP32[gb + 1476848 + 48 >> 2] = gb + 1476400 + 336;
  HEAP32[gb + 1476848 + 52 >> 2] = gb + 1476400 + 364;
  HEAP32[gb + 1476848 + 56 >> 2] = gb + 1476400 + 392;
  HEAP32[gb + 1476848 + 60 >> 2] = gb + 1476400 + 420;
 }
 HEAP32[i2 >> 2] = i1;
 i3 = (__ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i3, i2, 4) | 0) & 15;
 i3 = gb + 1476848 + (i3 << 2) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i5, i6, i7, i1, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10;
 HEAP32[i11 >> 2] = gb + 168924 + 8;
 HEAP32[i11 + 4 >> 2] = i5;
 HEAP32[i11 + 8 >> 2] = i1;
 i4 = i11 + 16 | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i11 + 24 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i11 + 28 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i11 + 32 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i11 + 36 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i11 + 40 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 i2 = i11 + 44 | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i11 + 48 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback(HEAP32[i5 >> 2] | 0, i6, i7, i11) | 0;
 if (i8 | 0) {
  i6 = i4;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i11 = i8;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = i7;
 }
 if (!i9) {
  STACKTOP = i10;
  return 1073741824;
 }
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i10;
 return 1073741824;
}

function __ZN9dtNavMesh14unconnectLinksEP10dtMeshTile(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if (!i1) {
  i11 = 0;
  i12 = 0;
 } else {
  i10 = (i1 - (HEAP32[i9 + 20 >> 2] | 0) | 0) / 56 | 0;
  i11 = _bitshift64Shl(HEAP32[i1 + 4 >> 2] | 0, 0, 48) | 0;
  i12 = getTempRet0() | 0;
  i10 = _bitshift64Shl(i10 | 0, 0, 20) | 0;
  i11 = i10 | i11;
  i12 = getTempRet0() | 0 | i12;
 }
 i10 = i1 + 8 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((HEAP32[i2 + 20 >> 2] | 0) <= 0) return;
 i6 = i1 + 12 | 0;
 i7 = i9 + 36 | 0;
 i8 = i9 + 28 | 0;
 i5 = 0;
 i4 = HEAP32[i6 >> 2] | 0;
 while (1) {
  i3 = i5 | i11;
  i1 = HEAP32[i4 + (i5 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = i4; else {
   i2 = HEAP32[i7 >> 2] | 0;
   do {
    i4 = i1;
    i1 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
    i13 = i2 + (i4 << 4) | 0;
    __ZN9dtNavMesh17removeLinkBetweenEyy(i9, HEAP32[i13 >> 2] | 0, HEAP32[i13 + 4 >> 2] | 0, i3, i12);
    i2 = HEAP32[i7 >> 2] | 0;
    HEAP32[i2 + (i4 << 4) + 8 >> 2] = HEAP32[i8 >> 2];
    HEAP32[i8 >> 2] = i4;
   } while ((i1 | 0) != -1);
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i10 >> 2] | 0;
  }
  HEAP32[i1 + (i5 << 2) >> 2] = -1;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (HEAP32[i2 + 20 >> 2] | 0)) break; else i4 = i1;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 688777 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 717273 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Scb5Scene12addAggregateERNS0_9AggregateE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i5 = i8;
 HEAP32[i7 >> 2] = i1;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  HEAP32[i7 + 16 >> 2] = __ZN5physx2Sc5Scene15createAggregateEPvb(i1 + 16 | 0, HEAP32[i7 + 12 >> 2] | 0, (HEAP8[i7 + 24 >> 0] | 0) != 0) | 0;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & 268435455 | -2147483648;
  STACKTOP = i8;
  return;
 }
 i1 = i1 + 2780 | 0;
 i2 = i7 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 1073741823;
 if (i3 >>> 0 > 3221225471) {
  HEAP32[i2 >> 2] = i4 | -2147483648;
  if (i3 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i2 >> 2] = i4 | 1073741824;
  HEAP32[i5 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i5, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN21ProceduralTextureData20GetProceduralTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i1) i5 = 7; else {
  if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i2, i1, i3);
   i2 = HEAP32[i2 >> 2] | 0;
   i7 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i2 | 0) == -1 ? i7 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i7 + (i2 << 3) | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 7; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) i5 = 9;
 if ((i5 | 0) == 9) i1 = __Z31ReadObjectFromPersistentManageri(i4) | 0;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E9erase_oneIS2_EEjRKT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i1 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = i1 - i4 >> 3;
 if (!i2) i3 = i4; else {
  i7 = HEAP32[i8 >> 2] | 0;
  i3 = i4;
  while (1) {
   i10 = (i2 | 0) / 2 | 0;
   i6 = i4 + (i10 << 3) | 0;
   i5 = (_strcmp(HEAP32[i6 >> 2] | 0, i7) | 0) < 0;
   i6 = i6 + 8 | 0;
   i3 = i5 ? i6 : i3;
   i2 = i5 ? i2 + -1 - i10 | 0 : i10;
   if (!i2) break; else i4 = i5 ? i6 : i4;
  }
 }
 if ((i3 | 0) == (i1 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if ((_strcmp(HEAP32[i8 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) < 0) {
  i10 = 0;
  return i10 | 0;
 }
 i2 = i3 + 8 | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   __ZN14ConstantStringaSERKS_(i3, i2);
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   i2 = i2 + 8 | 0;
   i3 = i3 + 8 | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i10 = 1;
   return i10 | 0;
  }
 }
 do {
  i10 = i1 + -8 | 0;
  HEAP32[i9 >> 2] = i10;
  __ZN14ConstantStringD2Ev(i10);
  i1 = HEAP32[i9 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = 1;
 return i1 | 0;
}

function __ZN13dynamic_arrayI26EnlightenSystemInformationLj8EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 56 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 56 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 56 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 56 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 56 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 56 | 0) | 0;
 _memmove(i14 + (i8 * 56 | 0) | 0, i14 | 0, i11 * 56 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EE6insertEPS2_PKS2_S6_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 52 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 52 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 52 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 52 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 52 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 52 | 0) | 0;
 _memmove(i14 + (i8 * 52 | 0) | 0, i14 | 0, i11 * 52 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13GfxDeviceGLES28SetComputeBufferCounterValueE15ComputeBufferIDj(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = i2;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  STACKTOP = i8;
  return;
 }
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 } else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) __ZN14DataBufferGLES6UploadEiiPKv(i1, 0, 4, i7);
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP32[i6 + 7428 + (i1 << 2) >> 2] | 0) != (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 __ZN14DataBufferGLES6UploadEiiPKv(HEAP32[i6 + 7424 >> 2] | 0, i1 << 2, 4, i7);
 STACKTOP = i8;
 return;
}

function __ZN9Transform25RebuildTransformHierarchyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 while (1) {
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = __ZNK9Transform14CountNodesDeepEv(i1) | 0;
 i4 = __ZN17TransformInternal24CreateTransformHierarchyEj(i2) | 0;
 i2 = (HEAP32[i4 + 68 >> 2] | 0) + (i2 + -1 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + 4 >> 2] = i3;
 if ((i3 | 0) != -1) HEAP32[(HEAP32[i4 + 72 >> 2] | 0) + (i3 << 2) >> 2] = -1;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i5 >> 2] = 0;
 __ZN9Transform37InitializeTransformHierarchyRecursiveER18TransformHierarchyRii(i1, i4, i5, -1);
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[gb + 1158396 >> 2] | 0;
 i2 = i6 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != -1) {
  i8 = i1 + 12 | 0;
  i9 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = i5 + (i9 << 2) | 0;
  HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] = i3;
  i5 = i5 + (HEAP32[i2 >> 2] << 2) | 0;
  HEAP32[i8 >> 2] = i9;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 >> 2] = -1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63160 | 0);
 STACKTOP = i7;
 return;
}

function __ZN8Animator6IKStepEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 i5 = i4 + 140 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP8[i1 + 53 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1466884 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466884 | 0, i2);
  i2 = gb + 1466884 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } else i2 = 0;
 i8 = i4 + 124 | 0;
 i7 = i4 + 128 | 0;
 i3 = i4 + 132 | 0;
 i4 = i4 + 136 | 0;
 __ZN7mecanim9animation16EvaluateAvatarIKEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1, (HEAP8[i1 + 52 >> 0] | 0) != 0);
 __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE(HEAP32[i8 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 756142 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL25postNarrowPhaseSecondPassERNS_16PxsIslandManagerEb(i5, i4, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = (HEAP32[i5 + 48 >> 2] | 0) + 14 | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 if (!i3) {
  HEAP16[i1 >> 1] = i2 + -1 << 16 >> 16;
  i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 32 >> 2] | 0) | 0;
  i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 36 >> 2] | 0) | 0;
  if (i1 | 0) {
   i3 = i1 + 148 | 0;
   HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
  }
  if (i2 | 0) {
   i3 = i2 + 148 | 0;
   HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + -1 << 16 >> 16;
  }
  __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i4, i5 + 60 | 0);
  return;
 }
 HEAP16[i1 >> 1] = i2 + 1 << 16 >> 16;
 i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 32 >> 2] | 0) | 0;
 i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i5 + 36 >> 2] | 0) | 0;
 if (i2 | 0) {
  i3 = i2 + 148 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + 1 << 16 >> 16;
 }
 if (i1 | 0) {
  i3 = i1 + 148 | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + 1 << 16 >> 16;
 }
 if (HEAP32[i5 + 44 >> 2] & 262144 | 0) return;
 __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i4, i5 + 60 | 0);
 return;
}

function __ZN5Unity10FixedJoint5ResetEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) i4 = 4; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i2, i1) | 0) {
  f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i1 + 16 >> 2]));
  HEAPF32[i3 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 44 >> 2] = f6;
  HEAPF32[i3 + 48 >> 2] = Math_fround(0.0);
  i1 = i3 + 40 | 0;
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i1 = i3 + 40 | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i4 = i3 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i3 + 36 >> 0] = 1;
 i4 = i3 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i10, i11) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = _strlen(i11) | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i6 = (i5 | 0) == 0;
 i8 = i10 + 4 | 0;
 i7 = i6 ? i8 : i5;
 if (i7 >>> 0 <= i11 >>> 0) {
  i2 = i10 + 20 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i7 + i1 | 0) >>> 0 > i11 >>> 0) {
   i1 = i1 >>> 0 < i9 >>> 0 ? i1 : i9;
   if ((i7 | 0) != (i11 | 0)) _memmove(i7 | 0, i11 | 0, i1 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   return i10 | 0;
  }
 }
 i4 = i10 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (i1 | 0) == 0;
 if (i2) if (i6) {
  i1 = 15;
  i3 = 9;
 } else i3 = 12; else {
  i1 = i6 ? 15 : i1;
  i3 = 9;
 }
 if ((i3 | 0) == 9) if (i1 >>> 0 < i9 >>> 0) if (i6 | i2) i3 = 12; else {
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i10 + 24 | 0);
  i3 = 12;
 } else i1 = i7;
 if ((i3 | 0) == 12) {
  if (i9 >>> 0 > 15) {
   i1 = i9;
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9 + 1 | 0, 16, i10 + 24 | 0, 0, gb + 1047486 | 0, 251) | 0;
  } else {
   i1 = 0;
   i2 = 0;
  }
  HEAP32[i10 >> 2] = i2;
  HEAP32[i4 >> 2] = i1;
  i1 = (i2 | 0) == 0 ? i8 : i2;
 }
 _memcpy(i1 | 0, i11 | 0, i9 | 0) | 0;
 HEAP8[i1 + i9 >> 0] = 0;
 HEAP32[i10 + 20 >> 2] = i9;
 return i10 | 0;
}

function __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE(i1, i2, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i2;
 i8 = i10 + 64 | 0;
 i9 = i10 + 76 | 0;
 HEAP32[i2 + 8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i10 + 96 >> 2];
 HEAP32[i2 >> 2] = i10;
 __ZN13dynamic_arrayIN2UI13UIInstructionELj4EE19push_back_constructEv(i10 + 84 | 0) | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 + 1 | 0;
 i4 = i10 + 80 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i1 = i5 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i10 + 68 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 68 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i8 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i3;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 << 2) >> 2] = i7;
 i10 = i10 + 112 | 0;
 HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 0 | 6;
 return;
}

function __ZN19CloudServiceHandler29ProcessAsyncFileRestoreStaticEPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i5 = i6;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 if (HEAP32[i1 + 1144 >> 2] | 0) {
  i4 = __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_(i1, i2, i5) | 0;
  i1 = HEAP32[i1 + 1168 >> 2] | 0;
  if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i2 | 0, i5 | 0, i4 | 0);
 }
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i5 >> 2] | 0;
  i5 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i5 = i2 + 20 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63800 | 0);
 STACKTOP = i6;
 return;
}

function __ZN18b2RevoluteJointDef10InitializeEP6b2BodyS1_RK6b2Vec2(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i10 = i4 + 4 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f8 = Math_fround(f5 * f6);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f6 * f9) - Math_fround(f5 * f7));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 + Math_fround(f9 * f7));
 HEAPF32[i1 + 24 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f5 * f9);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f9 * f7) - Math_fround(f5 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f8 + Math_fround(f7 * f6));
 HEAPF32[i1 + 32 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 HEAPF32[i1 + 36 >> 2] = Math_fround(f5 - Math_fround(HEAPF32[i2 + 56 >> 2]));
 return;
}

function __ZN13TrailRenderer15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32152 | 0, gb + 1105016 | 0, fb + 514 | 0, gb + 29192 | 0);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 32420 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 31652 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 31652 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 31652 + (i1 * 12 | 0) >> 2] = fb + 218;
 if (!(__Z13GetIAnimationv() | 0)) {
  STACKTOP = i5;
  return;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63320 | 0, 16, gb + 421073 | 0, 30) | 0;
 __ZN29LineParametersPropertyBindingC2E11ClassIDTypeN11UnityEngine9Animation8BindTypeE(i4, 96, 30);
 HEAP32[gb + 1158392 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindERKS5_j(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i9 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i7 = i9 << 24 >> 24 < 0;
 i8 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
 i9 = i7 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255;
 i3 = i1 >>> 0 < i4 >>> 0 ? i1 : i4;
 i3 = (i1 - i3 | 0) >>> 0 > i9 >>> 0 ? i9 + i3 | 0 : i1;
 i7 = i2 + (i3 << 2) | 0;
 i4 = i8 + (i9 << 2) | 0;
 i1 = i9 << 2 >> 2;
 L5 : do if (!i1) i1 = i7; else if ((i3 << 2 >> 2 | 0) < (i1 | 0)) i1 = i7; else {
  i6 = i2 + (i1 + -1 << 2) | 0;
  i5 = i4 + -4 | 0;
  i1 = i7;
  L8 : while (1) {
   while (1) {
    if ((i6 | 0) == (i1 | 0)) {
     i1 = i7;
     break L5;
    }
    i4 = i1 + -4 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
     i3 = i5;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i8 | 0)) break L5;
    i1 = i1 + -4 | 0;
    i3 = i3 + -4 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
     i1 = i4;
     continue L8;
    }
   }
  }
 } while (0);
 return ((i9 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 >> 2) | 0;
}

function __ZN5physx6shdfnd5ArrayINS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i10 + 8 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i4 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
  i6 = _PxGetFoundation() | 0;
  i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0) | 0;
  i6 = mftCall_iiiiii(i4 | 0, i8 | 0, i9 | 0, (i6 ? gb + 708613 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
 }
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i4 = i6 + i1 | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
 }
 HEAP8[i6 + i1 >> 0] = HEAP8[i5 >> 0] | 0;
 if ((HEAP32[i7 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i8 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i8 >> 2] = i1 + 1;
 return i6 + i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 12 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 706141 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN13SliderJoint2D9SetLimitsERK24JointTranslationLimits2D(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i4 = i2 + 108 | 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f6 < Math_fround(-1.0e6);
 i7 = f6 > Math_fround(1.0e6);
 f6 = i7 ? Math_fround(1.0e6) : f6;
 f6 = i3 ? Math_fround(-1.0e6) : f6;
 HEAPF32[i4 >> 2] = f6;
 i3 = i2 + 112 | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f5 < Math_fround(-1.0e6);
 i7 = f5 > Math_fround(1.0e6);
 f5 = i7 ? Math_fround(1.0e6) : f5;
 f5 = i1 ? Math_fround(-1.0e6) : f5;
 HEAPF32[i3 >> 2] = f5 < f6 ? f6 : f5;
 HEAP8[i2 + 117 >> 0] = 1;
 i1 = i2 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN16b2PrismaticJoint11EnableLimitEb(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 i7 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) > f6;
 f6 = (HEAP32[tempDoublePtr >> 2] = i3 ? i7 : i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 __ZN16b2PrismaticJoint9SetLimitsEff(i1, f6, (HEAP32[tempDoublePtr >> 2] = i3 ? i4 : i7, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 return;
}

function __Z42DestroyTransformComponentAndChildHierarchyR9Transform(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 1032 | 0;
 i4 = i7;
 HEAP32[i2 >> 2] = 0;
 i5 = i3 + 80 | 0;
 i6 = i3 + 92 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE(i3, 0);
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 do {
  i8 = (HEAP32[i1 >> 2] | 0) + 28 | 0;
  __ZN10GameObject10DeactivateE19DeactivateOperation(HEAP32[i8 >> 2] | 0, 2);
  __ZL19PreDestroyRecursiveR10GameObjectPj(HEAP32[i8 >> 2] | 0, i2);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i5 >> 2] | 0) + (HEAP32[i6 >> 2] << 2) | 0));
 i1 = HEAP32[i2 >> 2] | 0;
 __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE(i3, 0);
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = i1 >>> 0 > 256 ? 256 : i1;
 HEAP32[i4 + 4 >> 2] = 0;
 if (HEAP32[i6 >> 2] | 0) {
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i4);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i5 >> 2] | 0) + (HEAP32[i6 >> 2] << 2) | 0));
 }
 __Z17CommitBatchDeleteR11BatchDelete(i4);
 STACKTOP = i7;
 return;
}

function __Z23AddComponentsFromVAListR10GameObjectPKcPi(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  STACKTOP = i6;
  return;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 if (!(__Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, i1, i5) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 444974 | 0, 718, 1, 0, 0, 0);
 i2 = (HEAP32[i4 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i2 + 4;
 if (i1 | 0) {
  i2 = i5 + 11 | 0;
  do {
   if (!(__Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, i1, i5) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 444974 | 0, 726, 1, 0, 0, 0);
   i7 = (HEAP32[i4 >> 2] | 0) + (4 - 1) & ~(4 - 1);
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 >> 2] = i7 + 4;
  } while ((i1 | 0) != 0);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function _add_huff_table(i5, i6, i4, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i1 = _jpeg_alloc_huff_table(i5) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 i2 = i4;
 i3 = i1 + 17 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = (HEAPU8[i4 + 16 >> 0] | 0) + ((HEAPU8[i4 + 15 >> 0] | 0) + ((HEAPU8[i4 + 14 >> 0] | 0) + ((HEAPU8[i4 + 13 >> 0] | 0) + ((HEAPU8[i4 + 12 >> 0] | 0) + ((HEAPU8[i4 + 11 >> 0] | 0) + ((HEAPU8[i4 + 10 >> 0] | 0) + ((HEAPU8[i4 + 9 >> 0] | 0) + ((HEAPU8[i4 + 8 >> 0] | 0) + ((HEAPU8[i4 + 7 >> 0] | 0) + ((HEAPU8[i4 + 6 >> 0] | 0) + ((HEAPU8[i4 + 5 >> 0] | 0) + ((HEAPU8[i4 + 4 >> 0] | 0) + ((HEAPU8[i4 + 3 >> 0] | 0) + ((HEAPU8[i4 + 2 >> 0] | 0) + (HEAPU8[i4 + 1 >> 0] | 0))))))))))))))) | 0;
 if ((i1 + -1 | 0) >>> 0 <= 255) {
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 17 | 0;
  _memcpy(i5 | 0, i7 | 0, i1 | 0) | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  i7 = i7 + 273 | 0;
  HEAP8[i7 >> 0] = 0;
  return;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 + 20 >> 2] = 8;
 mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + 17 | 0;
 _memcpy(i5 | 0, i7 | 0, i1 | 0) | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i7 = i7 + 273 | 0;
 HEAP8[i7 >> 0] = 0;
 return;
}

function __ZN9Transform25CompleteTransformTransferI17RemapPPtrTransferEEvRT_(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (HEAP32[i8 >> 2] & 16384 | 0) return;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i8, 65);
 i1 = HEAP32[i3 + 80 >> 2] | 0;
 i6 = HEAP32[i3 + 92 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 if (i6 | 0) {
  i4 = i8 + 16 | 0;
  i5 = i8 + 36 | 0;
  i6 = i8 + 40 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
   i9 = HEAP32[i4 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i2 | 0, HEAP32[i5 >> 2] | 0) | 0;
   if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(i2, 0) | 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i8);
 i2 = i3 + 100 | 0;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i8, 1);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = HEAP32[i8 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i1 | 0, HEAP32[i8 + 36 >> 2] | 0) | 0;
 if (HEAP8[i8 + 40 >> 0] | 0) HEAP32[i2 >> 2] = __Z38PreallocateObjectFromPersistentManagerib(i1, 0) | 0;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i8);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  if (!i1) break; else {
   i7 = i7 + 4 | 0;
   i6 = i6 + 16 | 0;
  }
 }
 return;
}

function __ZN23ShaderVariantCollection11VariantInfo8TransferI14SafeBinaryReadEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, gb + 479430 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i3, i5, 1); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
 }
 if (HEAP8[i3 + 128 >> 0] | 0) __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i5, i2);
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14ShaderPassTypeEvRT_RT0_PKc17TransferMetaFlags(i3, i2 + 32 | 0, gb + 479439 | 0, 0);
 if ((HEAP8[i5 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i3 + 72 >> 2] | 0;
 if (i4 & 128 | 0) {
  i1 = i3 + 56 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i2 | 0) == 0 & (i1 | 0) == 0) {
   i6 = -1;
   i7 = -1;
   setTempRet0(i6 | 0);
   return i7 | 0;
  }
  i7 = _i64Subtract(i2 | 0, i1 | 0, HEAP32[i3 + 64 >> 2] | 0, 0) | 0;
  i6 = getTempRet0() | 0;
  setTempRet0(i6 | 0);
  return i7 | 0;
 }
 i7 = HEAP8[i3 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = i7 & 255;
 if (((i5 ? i6 : i7) | 0) == 8) {
  if (!(_memcmp(i5 ? HEAP32[i3 >> 2] | 0 : i3, gb + 489810 | 0, 8) | 0)) {
   i6 = 0;
   i7 = 9;
   setTempRet0(i6 | 0);
   return i7 | 0;
  }
  if (!(_memcmp(i5 ? HEAP32[i3 >> 2] | 0 : i3, gb + 489801 | 0, 8) | 0)) {
   i6 = 0;
   i7 = 9;
   setTempRet0(i6 | 0);
   return i7 | 0;
  }
 }
 i1 = HEAP8[i3 + 20 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 24 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i3 + 36 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 40 >> 2] | 0; else i1 = i1 & 255;
 i1 = i2 + 5 + i1 | 0;
 if (!(i4 & 256)) i1 = i1 + 22 + (i5 ? i6 : i7) | 0; else i1 = i1 + 31 | 0;
 i6 = 0;
 i7 = i1;
 setTempRet0(i6 | 0);
 return i7 | 0;
}

function __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_(i1, i2, d3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 32 | 0;
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i8 = i6 + 11 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP8[i6 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i10 = i7 + 11 | 0;
 HEAP8[i10 >> 0] = 0;
 HEAP8[i7 >> 0] = 0;
 i1 = __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_S2_S2_b(i1, i2, d3, i4, i6, i7, 0) | 0;
 if ((HEAP8[i10 >> 0] | 0) < 0) {
  i10 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 }
 if ((HEAP8[i8 >> 0] | 0) >= 0) {
  STACKTOP = i9;
  return i1 | 0;
 }
 i10 = HEAP32[i6 >> 2] | 0;
 i8 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 66;
 HEAP32[i5 + 4 >> 2] = i8;
 __Z19free_alloc_internalPvRK10MemLabelId(i10, i5);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN13TextRendering4Font7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i7 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, i1, 16, gb + 1048932 | 0, 0, gb + 1007895 | 0, 37) | 0;
 i9 = i1;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i9;
 i1 = i7;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 185220 + 8;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(208, i8, 16, gb + 1007971 | 0, 19) | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN20TextRenderingPrivate8FontImplC2E10MemLabelIdPN13TextRendering4FontE(i2, i5, i4);
 HEAP32[i4 + 48 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN10BlendShape8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i3;
 }
 i4 = i5 + 4 | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i4, 4);
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 >> 2] = i1;
  i3 = i1;
 }
 i1 = i5 + 8 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i7 >> 2] | 0) + 1 | 0;
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i5 + 9 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  return;
 }
}

function _tempnam(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 i11 = i12 + 32 | 0;
 i8 = i12 + 24 | 0;
 i9 = _getpid() | 0;
 i7 = (i1 | 0) == 0 ? gb + 1075291 | 0 : i1;
 i1 = (i2 | 0) == 0 ? gb + 1075268 | 0 : i2;
 if (!(_access(i7, 7) | 0)) {
  i3 = _strlen(i7) | 0;
  i3 = i3 + 44 + (_strlen(i1) | 0) | 0;
  i6 = _malloc(i3) | 0;
  HEAP32[i11 >> 2] = i6;
  if (!i6) i1 = 0; else {
   i4 = i8 + 4 | 0;
   i5 = i11;
   i2 = 0;
   while (1) {
    _clock_gettime(0, i8 | 0) | 0;
    i6 = HEAP32[i11 >> 2] | 0;
    i13 = HEAP32[i4 >> 2] ^ i5 ^ i6;
    i14 = HEAP32[gb + 1470392 >> 2] | 0;
    HEAP32[gb + 1470392 >> 2] = i14 + 1;
    HEAP32[i10 >> 2] = i7;
    HEAP32[i10 + 4 >> 2] = i1;
    HEAP32[i10 + 8 >> 2] = i9;
    HEAP32[i10 + 12 >> 2] = i14;
    HEAP32[i10 + 16 >> 2] = i13;
    _snprintf(i6, i3, gb + 1075273 | 0, i10) | 0;
    if (_access(HEAP32[i11 >> 2] | 0, 0) | 0) break;
    i6 = i2 + 1 | 0;
    if ((i2 | 0) < 100) i2 = i6; else {
     i2 = i6;
     break;
    }
   }
   i1 = HEAP32[i11 >> 2] | 0;
   if ((i2 | 0) > 99) {
    _free(i1);
    i1 = 0;
   }
  }
 } else i1 = 0;
 STACKTOP = i12;
 return i1 | 0;
}

function __ZN8JSONRead18GetValueNodeForKeyEPKc(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = HEAP32[i5 + 16 >> 2] | 0;
 if ((i2 & 255 | 0) == 3) {
  i1 = i3;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 1048581;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = i1 - i3;
  i3 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i5, i4) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4);
  i5 = (i3 | 0) == ((HEAP32[i5 >> 2] | 0) + ((HEAP32[i5 + 4 >> 2] | 0) * 48 | 0) | 0) ? 0 : i3 + 24 | 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  if ((i2 | 0) != 4) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
  i3 = (HEAP32[i1 + 152 >> 2] | 0) + ((HEAP32[i1 + 164 >> 2] | 0) + -1 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i4 + 1;
  i5 = (HEAP32[i5 >> 2] | 0) + (i4 * 24 | 0) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  if (!i1) break; else {
   i7 = i7 + 4 | 0;
   i6 = i6 + 12 | 0;
  }
 }
 return;
}

function __ZN5physx9NpFactory15createAggregateEjb(i7, i2, i4) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 4 | 0;
 i6 = i9;
 i5 = i7 + 1840 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i1 = i7 + 1836 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i7 + 1544 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 i1 = i7 + 1824 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i7 + 1828 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (!i3) i3 = 0; else __ZN5physx11NpAggregateC2Ejb(i3, i2, i4);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 HEAP32[i6 >> 2] = i3;
 if (!i3) {
  STACKTOP = i9;
  return i3 | 0;
 }
 i2 = i7 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i7 + 444 | 0, i6, i8) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i9;
 return i3 | 0;
}

function __ZN5physx2Sc5Scene15addArticulationERNS0_16ArticulationCoreERNS0_8BodyCoreE(i6, i5, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i4 = i7;
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i9 | 0, i8 | 0, 164, (i2 ? gb + 680963 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 760) | 0;
 __ZN5physx2Sc15ArticulationSimC2ERNS0_16ArticulationCoreERNS0_5SceneERNS0_8BodyCoreE(i2, i5, i6, i3);
 if (i2 | 0) if (!(HEAP32[i2 >> 2] | 0)) {
  __ZN5physx2Sc15ArticulationSimD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 120 | 0;
 HEAP32[i4 >> 2] = i5;
 i2 = i6 + 124 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 128 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc16ArticulationCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i4) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN16SubstanceArchive8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 i8 = i9 + 16 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i8 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i5, 4);
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + i6 | 0;
 if (!i6) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
  STACKTOP = i10;
  return;
 }
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i9);
 STACKTOP = i10;
 return;
}

function __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_PKS2_S6_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 40 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 40 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 40 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 40 | 0, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 40 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 40 | 0) | 0;
 _memmove(i14 + (i8 * 40 | 0) | 0, i14 | 0, i11 * 40 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13WheelCollider13SetSteerAngleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 i4 = i2 + 148 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) return;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 if (!i2) return;
 if (!(HEAP32[i2 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i2 + 56 >> 2] | 0)) return;
 i3 = HEAP32[i3 + 56 >> 2] | 0;
 i2 = f1 < Math_fround(-360.0);
 i6 = f1 > Math_fround(360.0);
 f1 = i6 ? Math_fround(360.0) : f1;
 i2 = i2 ? -1011613696 : (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i2 & 2139095040 | 0) == 2139095040) i5 = 7; else {
  f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i6 = f1 < Math_fround(0.0);
  f7 = Math_fround(-f1);
  if ((i6 ? f7 : f1) < Math_fround(9.99999974e-06)) i5 = 7;
 }
 if ((i5 | 0) == 7) i2 = 0;
 __ZN5physx16PxVehicleNoDrive13setSteerAngleEjf(i3, HEAP32[i4 >> 2] | 0, Math_fround(Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
 i6 = HEAP32[i3 + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 284 >> 2] | 0, i6 | 0);
 return;
}

function __ZN13DrawImmediate5BeginE16GfxPrimitiveTypePK14ChannelAssigns(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i6 + 16 | 0;
 if (HEAP32[i7 >> 2] | 0) return;
 HEAP32[i6 + 4 >> 2] = HEAP32[(i1 | 0 ? i1 : i6 + 8 | 0) >> 2];
 i5 = i6 + 212 | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4512 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 896 >> 2] | 0, i1 | 0) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 20 | 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = -1;
 HEAP32[i6 + 32 >> 2] = 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 88, 768, 0, i2 | 0, i1 | 0) | 0) HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 i1 = i6 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i6 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i6 + 72 >> 2] = Math_fround(1.0);
 i1 = i6 + 76 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __Z37Graphics_CUSTOM_Internal_BlitMultiTapP12Il2CppObjectS0_S0_P11Il2CppArray(i5, i7, i1, i3) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517913 | 0, i2);
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517913 | 0, i2);
 if (!i3) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517930 | 0, i8 + 8 | 0);
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 8) | 0;
 i2 = HEAP32[gb + 1166248 >> 2] | 0;
 if (!i5) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i7) {
  i7 = 0;
  __ZN12ImageFilters12BlitMultiTapER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiPK8Vector2f11CubemapFace(i2, i1, i7, i6, i4, i3, -1);
  STACKTOP = i8;
  return;
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 __ZN12ImageFilters12BlitMultiTapER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiPK8Vector2f11CubemapFace(i2, i1, i7, i6, i4, i3, -1);
 STACKTOP = i8;
 return;
}

function _UNITY_FT_Select_Metrics(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 88 >> 2] | 0;
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = HEAP32[i6 + (i2 << 4) + 8 >> 2] | 0;
 HEAP16[i5 + 12 >> 1] = (i7 + 32 | 0) >>> 6;
 i3 = i6 + (i2 << 4) + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP16[i5 + 14 >> 1] = (i4 + 32 | 0) >>> 6;
 if (!(HEAP32[i1 + 8 >> 2] & 1)) {
  HEAP32[i5 + 16 >> 2] = 65536;
  HEAP32[i5 + 20 >> 2] = 65536;
  HEAP32[i5 + 24 >> 2] = i4;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = HEAP16[i6 + (i2 << 4) >> 1] << 6;
  i6 = i7;
  i7 = i5 + 36 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 } else {
  i4 = i1 + 68 | 0;
  i6 = i5 + 16 | 0;
  HEAP32[i6 >> 2] = _UNITY_FT_DivFix(i7, HEAPU16[i4 >> 1] | 0) | 0;
  i4 = _UNITY_FT_DivFix(HEAP32[i3 >> 2] | 0, HEAPU16[i4 >> 1] | 0) | 0;
  i7 = i5 + 20 | 0;
  HEAP32[i7 >> 2] = i4;
  HEAP32[i5 + 24 >> 2] = (_UNITY_FT_MulFix(HEAP16[i1 + 70 >> 1] | 0, i4) | 0) + 63 & -64;
  HEAP32[i5 + 28 >> 2] = (_UNITY_FT_MulFix(HEAP16[i1 + 72 >> 1] | 0, HEAP32[i7 >> 2] | 0) | 0) & -64;
  HEAP32[i5 + 32 >> 2] = (_UNITY_FT_MulFix(HEAP16[i1 + 74 >> 1] | 0, HEAP32[i7 >> 2] | 0) | 0) + 32 & -64;
  i6 = (_UNITY_FT_MulFix(HEAP16[i1 + 76 >> 1] | 0, HEAP32[i6 >> 2] | 0) | 0) + 32 & -64;
  i7 = i5 + 36 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 3;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 704559 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i9 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Cct15ObstacleContextC2ERNS0_26CharacterControllerManagerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 86424 + 8;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 i4 = i2 + 36 | 0;
 HEAP32[i4 >> 2] = 2;
 HEAP32[i2 + 28 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 3 | 0, 8, gb + 657886 | 0, 25) | 0;
 i7 = i2 + 40 | 0;
 HEAP32[i7 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 2 | 0, HEAP32[i4 >> 2] << 1, gb + 657886 | 0, 26) | 0;
 i6 = i2 + 44 | 0;
 HEAP32[i6 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 1 | 0, HEAP32[i4 >> 2] << 1, gb + 657886 | 0, 27) | 0;
 i5 = i2 + 48 | 0;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, HEAP32[i4 >> 2] << 1, gb + 657886 | 0, 28) | 0;
 _memset(HEAP32[i7 >> 2] | 0, -1, HEAP32[i4 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i6 >> 2] | 0, -1, HEAP32[i4 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, HEAP32[i4 >> 2] << 1 | 0) | 0;
 HEAP32[i2 + 56 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = HEAP32[i6 + 312 >> 2] | 0;
 if (i4 | 0) {
  i5 = i6 + 300 | 0;
  i3 = 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   i2 = HEAP32[i1 + (i3 * 36 | 0) + 32 >> 2] | 0;
   if (i2) {
    i7 = i2 + 4 | 0;
    HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
    if (!(HEAP32[i7 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
     i1 = HEAP32[i5 >> 2] | 0;
    }
    HEAP32[i1 + (i3 * 36 | 0) + 32 >> 2] = 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i1 = i6 + 280 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 284 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i7 = i2 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 if (!(HEAP32[i7 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN21AssetBundleFileSystem7AddPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i3 + 108 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  __ZN10FileSystem12MountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i3) | 0;
  HEAP8[i1 >> 0] = 1;
 }
 i1 = i3 + 96 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 + 100 >> 2] | 0;
 } else i2 = i2 & 255;
 i4 = __Z14SkipPathPrefixPKcS0_jb((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i1, i2, 1) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, _strlen(i4) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(__ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_11djb2_hash_tIS6_ENS0_8equal_toIS6_EE13stl_allocatorINS0_4pairIKS6_S6_EEL18MemLabelIdentifier54ELi16EEEixERSD_(i3 + 4 | 0, i6) | 0, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN20SoundChannelInstance14SetPositionPCMEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i1 + 148 | 0;
 i9 = HEAP16[i5 >> 1] | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i8 = (i3 | 0) == 0;
 HEAP32[i1 + 116 >> 2] = i2;
 HEAP16[i5 >> 1] = ((i8 & 1 | (i9 & 65535) >>> 15 & 65535) & 65535) << 15 & 65535 | i9 & 31231 | (i8 & 1) << 9 & 65535;
 if (i8) {
  STACKTOP = i7;
  return 0;
 }
 i1 = __ZN4FMOD7Channel11setPositionEjj(i3, i2, 2) | 0;
 switch (i1 | 0) {
 case 54:
  {
   HEAP16[i5 >> 1] = HEAP16[i5 >> 1] | -32256;
   STACKTOP = i7;
   return 0;
  }
 case 0:
  {
   STACKTOP = i7;
   return 0;
  }
 default:
  {
   i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i6 >> 2] = gb + 853918;
   HEAP32[i6 + 4 >> 2] = 368;
   HEAP32[i6 + 8 >> 2] = gb + 865078;
   HEAP32[i6 + 12 >> 2] = i9;
   __Z6FormatPKcz(i4, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   STACKTOP = i7;
   return 0;
  }
 }
 return 0;
}

function __ZN20SoundChannelInstance13SetPositionMSEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i1 + 148 | 0;
 i9 = HEAP16[i5 >> 1] | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i8 = (i3 | 0) == 0;
 HEAP32[i1 + 120 >> 2] = i2;
 HEAP16[i5 >> 1] = ((i8 & 1 | (i9 & 65535) >>> 15 & 65535) & 65535) << 15 & 65535 | i9 & 31231 | (i8 & 1) << 10 & 65535;
 if (i8) {
  STACKTOP = i7;
  return 0;
 }
 i1 = __ZN4FMOD7Channel11setPositionEjj(i3, i2, 1) | 0;
 switch (i1 | 0) {
 case 54:
  {
   HEAP16[i5 >> 1] = HEAP16[i5 >> 1] | -31744;
   STACKTOP = i7;
   return 0;
  }
 case 0:
  {
   STACKTOP = i7;
   return 0;
  }
 default:
  {
   i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
   HEAP32[i6 >> 2] = gb + 853918;
   HEAP32[i6 + 4 >> 2] = 389;
   HEAP32[i6 + 8 >> 2] = gb + 865078;
   HEAP32[i6 + 12 >> 2] = i9;
   __Z6FormatPKcz(i4, gb + 883334 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   STACKTOP = i7;
   return 0;
  }
 }
 return 0;
}

function __ZN14b2WeldJointDef10InitializeEP6b2BodyS1_RK6b2Vec2(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i10 = i4 + 4 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f8 = Math_fround(f5 * f6);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f6 * f9) - Math_fround(f5 * f7));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 + Math_fround(f9 * f7));
 HEAPF32[i1 + 24 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f5 * f9);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f9 * f7) - Math_fround(f5 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f8 + Math_fround(f7 * f6));
 HEAPF32[i1 + 32 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i3 + 56 >> 2]);
 HEAPF32[i1 + 36 >> 2] = Math_fround(f5 - Math_fround(HEAPF32[i2 + 56 >> 2]));
 return;
}

function __Z57ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterTypeP12Il2CppObjectii(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 HEAP32[i5 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i8 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    __ZN14ParticleSystem8SyncJobsEb(1);
    HEAP32[(HEAP32[(HEAP32[i1 + 916 >> 2] | 0) + 8 >> 2] | 0) + (i3 * 12 | 0) + 4 >> 2] = i4;
    STACKTOP = i7;
    return;
   }
  }
 }
 i8 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i5) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i8;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i6);
}

function __Z34Animator_CUSTOM_SetFloatStringDampP12Il2CppObjectP12Il2CppStringfff(i6, i1, f3, f4, f5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 if (!i6) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i2 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator12SetFloatDampEifff(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i7) | 0, f3, f4, f5) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i9;
  return;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i7);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZNK5physx2Gu5RTree23computeBottomLevelCountEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i10 + 68 >> 2] | 0;
 i1 = HEAP32[i10 + 72 >> 2] | 0;
 if ((i1 | 0) == 1) {
  i9 = 0;
  i10 = i10 + 80 | 0;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 - i9 | 0;
  return i10 | 0;
 }
 i8 = HEAP32[i10 + 92 >> 2] | 0;
 i5 = i2 + -1 | 0;
 i7 = i1 + -1 | 0;
 i6 = i5;
 i4 = 0;
 i5 = i8 + (i5 * 112 | 0) | 0;
 i1 = 0;
 while (1) {
  i1 = i1 + i2 | 0;
  if (Math_fround(HEAPF32[i8 + (i6 * 112 | 0) >> 2]) == Math_fround(3402823469999999843913219.0e14)) i2 = -1; else if (Math_fround(HEAPF32[i8 + (i6 * 112 | 0) + 4 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i2 = 0; else if (Math_fround(HEAPF32[i8 + (i6 * 112 | 0) + 8 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i2 = 1; else if (Math_fround(HEAPF32[i8 + (i6 * 112 | 0) + 12 >> 2]) == Math_fround(3402823469999999843913219.0e14)) i2 = 2; else i2 = 3;
  i6 = ((Math_imul(HEAP32[i8 + (i6 * 112 | 0) + 96 + (i2 << 2) >> 2] | 0, i9) | 0) >>> 0) / 112 | 0;
  i3 = i8 + (i6 * 112 | 0) | 0;
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i7 >>> 0) break; else {
   i2 = (i3 - i5 | 0) / 112 | 0;
   i5 = i3;
  }
 }
 i10 = i10 + 80 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 - i1 | 0;
 return i10 | 0;
}

function __ZNK5Umbra18ImpOcclusionBuffer20isAARectFullyVisibleERKNS_7Vector2ES3_f(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 if (!(HEAP32[i1 + 1408 >> 2] | 0)) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i9 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
 i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = i2;
 i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
 i3 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 f8 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
 i6 = __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f(i1, i5, i6, (HEAP32[i1 + 1200 >> 2] | 0) == 1 ? f8 : f4) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK14TerrainManager21GetInterpolatedHeightEPK6ObjectRK8Vector3fS5_Rf(i1, i2, i7, i5, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f9 = f0, f10 = f0;
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 66968 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 66968 + 28 >> 2] | 0) >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = i2 + 248 | 0;
 f10 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f10 = Math_fround(f10 * Math_fround((HEAP32[i1 + 72 >> 2] | 0) + -1 | 0));
 f9 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f9 = Math_fround(f9 * Math_fround((HEAP32[i1 + 76 >> 2] | 0) + -1 | 0));
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i7 >> 2]));
 f6 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i5 + 8 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(1.0) / f10) * f4);
 f3 = Math_fround(Math_fround(Math_fround(1.0) / f9) * Math_fround(f3 - Math_fround(HEAPF32[i7 + 8 >> 2])));
 if (f4 > Math_fround(1.0) | f4 < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (f3 > Math_fround(1.0) | f3 < Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 HEAPF32[i8 >> 2] = Math_fround(f6 + Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i1, f4, f3)));
 i8 = 1;
 return i8 | 0;
}

function __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37324 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  i9 = i6 + 56 | 0;
  i8 = (HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 3) + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1085989 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1085998 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1084342 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN8JSONRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37212 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  HEAP32[i6 + 16 >> 2] = 2;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1085989 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1085998 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1034504 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1034510 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 >> 1] = i2;
  do if (f5 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i7 + 2 >> 1] = i2;
  if (!i1) break; else {
   i7 = i7 + 4 | 0;
   i6 = i6 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc21ConstraintInteraction7destroyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = i5 + 4 | 0;
 i2 = __ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP8[i1 + 116 >> 0] & 6) == 6) __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE(i2, i1);
 i1 = i5 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i2 + 1204 >> 2] | 0) | 0, 1, i1);
 i1 = i5 + 30 | 0;
 if (HEAP16[i1 >> 1] & 2) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i5 + 24 | 0);
  HEAP16[i1 >> 1] = (HEAPU16[i1 >> 1] | 0) & 65533;
 }
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i5);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i5 + 8 >> 2] | 0, i5);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i5);
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i2 + 108 >> 2] | 0;
 i2 = HEAP32[i2 + 112 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim18onConstraintDetachEv(i1);
 if (!i2) return;
 __ZN5physx2Sc7BodySim18onConstraintDetachEv(i2);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189892 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 189892 + 36;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2 + 264 | 0, HEAP32[i2 + 268 >> 2] | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i2 + 136 | 0);
 i1 = i2 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 124 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __Z32Animator_CUSTOM_GetIntegerStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator10GetIntegerEiRi(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i5) | 0;
 if ((i1 | 0) == 1) {
  i6 = HEAP32[i5 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function _UNITY_FT_Get_TrueType_Engine_Type(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = i1 + 20 + (i5 << 2) | 0;
 if ((i5 | 0) <= 0) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = i1 + 20 | 0;
 while (1) {
  i5 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i1 + 4 | 0;
  if (!(_strcmp(HEAP32[i2 + 8 >> 2] | 0, gb + 1007021 | 0) | 0)) break;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i4 = 16;
   break;
  }
 }
 if ((i4 | 0) == 16) return i1 | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) i4 = 9; else {
  i1 = mftCall_iii(i1 | 0, i5 | 0, gb + 1008173 | 0) | 0;
  if (!i1) i4 = 9;
 }
 L18 : do if ((i4 | 0) == 9) {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  i4 = i1 + 20 + (i3 << 2) | 0;
  if ((i3 | 0) <= 0) {
   i5 = 0;
   return i5 | 0;
  }
  i3 = i1 + 20 | 0;
  while (1) {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) != (i5 | 0)) {
    i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
    if (i2 | 0) {
     i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008173 | 0) | 0;
     if (i1 | 0) break L18;
    }
   }
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i4 >>> 0) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 i5 = HEAP32[i1 >> 2] | 0;
 return i5 | 0;
}

function __ZNK6Camera16GetProjectionFarEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 if (HEAP8[i1 + 1081 >> 0] | 0) {
  f3 = Math_fround(HEAPF32[i1 + 924 >> 2]);
  return Math_fround(f3);
 }
 i4 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0;
 if (!(Math_fround(HEAPF32[i4 + 16 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 32 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) != Math_fround(0.0))) if (!(Math_fround(HEAPF32[i4 + 36 >> 2]) != Math_fround(0.0))) {
  f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
  if (!(f2 != Math_fround(0.0))) {
   f3 = Math_fround(HEAPF32[i4 + 24 >> 2]);
   if (!(f3 != Math_fround(0.0))) {
    f5 = Math_fround(HEAPF32[i4 + 12 >> 2]);
    f9 = Math_fround(HEAPF32[i4 + 28 >> 2]);
    f8 = Math_fround(HEAPF32[i4 + 44 >> 2]);
    f6 = Math_fround(HEAPF32[i4 + 60 >> 2]);
    f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
    f5 = Math_fround(f5 - f2);
    f2 = Math_fround(f9 - f3);
    f3 = Math_fround(f8 - f7);
    f3 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i4 + 56 >> 2])) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f2 * f2)) + Math_fround(f3 * f3)))));
    return Math_fround(f3);
   }
  }
 }
 f9 = Math_fround(HEAPF32[i1 + 924 >> 2]);
 return Math_fround(f9);
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EEPNS_13PxProfileZoneE(i6, i5, i1, i2) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = i6 + 416 | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE13CollisionDataC2Ev(i4);
 i9 = i6 + 424 | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE13CollisionDataC2Ev(i9);
 i8 = i6 + 432 | 0;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 + 436 >> 2] = i1;
 HEAP32[i6 + 444 >> 2] = i2;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE8allocateERNS3_13CollisionDataE(i6, i9);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!(HEAP8[i1 + 212 >> 0] | 0)) if (!(Math_fround(HEAPF32[i1 + 216 >> 2]) > Math_fround(0.0))) {
  STACKTOP = i7;
  return;
 }
 __ZN5physx5cloth11SwCollisionI8Scalar4fE8allocateERNS3_13CollisionDataE(i6, i4);
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 + 144 >> 2];
 __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fPKS1_EEvPT_RKT0_j(i9, i3, HEAP32[i5 + 152 >> 2] | 0);
 __ZN12_GLOBAL__N_113generateConesEPN5physx5cloth8ConeDataEPKNS1_10SphereDataEPKNS1_9IndexPairEj(HEAP32[i6 + 420 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 + 156 >> 2] | 0, HEAP32[i5 + 160 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Cm12RenderBuffer6appendINS_11PxDebugLineEEEvRNS_6shdfnd5ArrayIT_NS4_15AllocatorTraitsIS6_E4TypeEEEPKS6_j(i1, i7, i4, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = i7 + 4 | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + i2 | 0;
 i6 = i7 + 8 | 0;
 if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i7, i1);
 i3 = i4 + (i2 << 5) | 0;
 if ((i2 | 0) <= 0) return;
 i1 = i4;
 do {
  i2 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i6 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
   i4 = HEAP32[i7 >> 2] | 0;
   HEAP32[i4 + (i2 << 5) >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 + (i2 << 5) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i4 + (i2 << 5) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
   HEAP32[i4 + (i2 << 5) + 12 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i4 + (i2 << 5) + 16 >> 2] = HEAP32[i1 + 16 >> 2];
   HEAP32[i4 + (i2 << 5) + 20 >> 2] = HEAP32[i1 + 20 >> 2];
   HEAP32[i4 + (i2 << 5) + 24 >> 2] = HEAP32[i1 + 24 >> 2];
   HEAP32[i4 + (i2 << 5) + 28 >> 2] = HEAP32[i1 + 28 >> 2];
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i7, i1) | 0;
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return;
}

function __ZN14LogBufferEntryC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i1 + 4 >> 2] = i4;
 i4 = i1 + 12 | 0;
 i8 = gb + 63672 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 i7 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = i8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i6, i2);
 i2 = i6 + 11 | 0;
 i7 = HEAP8[i2 >> 0] | 0;
 HEAP32[i1 >> 2] = i7 << 24 >> 24 < 0 ? HEAP32[i6 + 4 >> 2] | 0 : i7 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, gb + 1017155 | 0) | 0;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 i7 = i1 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i7 ? HEAP32[i3 >> 2] | 0 : i3, i7 ? HEAP32[i3 + 4 >> 2] | 0 : i1 & 255) | 0;
 __Z17UTF8ToUTF16StringPKcR11UTF16String((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i5;
 return;
}

function _UNITY_png_read_chunk_header(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = i2 + 656 | 0;
 HEAP32[i4 >> 2] = 33;
 _UNITY_png_read_data(i2, i1, 8);
 i3 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
 if ((i3 | 0) < 0) _UNITY_png_error(i2, gb + 353053 | 0);
 i7 = i1 + 4 | 0;
 i6 = i2 + 372 | 0;
 HEAP32[i6 >> 2] = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i7 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | (HEAPU8[i1 + 7 >> 0] | 0);
 _UNITY_png_reset_crc(i2);
 _UNITY_png_calculate_crc(i2, i7, 4);
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = i1 & 255;
 if ((i6 + -65 | 0) >>> 0 > 57 | (i6 + -91 | 0) >>> 0 < 6) _UNITY_png_chunk_error(i2, gb + 353087 | 0);
 i7 = i1 >>> 8 & 255;
 if ((i7 + -65 | 0) >>> 0 > 57 | (i7 + -91 | 0) >>> 0 < 6) _UNITY_png_chunk_error(i2, gb + 353087 | 0);
 i7 = i1 >>> 16 & 255;
 if ((i7 + -65 | 0) >>> 0 > 57 | (i7 + -91 | 0) >>> 0 < 6) _UNITY_png_chunk_error(i2, gb + 353087 | 0);
 i7 = i1 >>> 24;
 if ((i7 + -65 | 0) >>> 0 > 57 | (i7 + -91 | 0) >>> 0 < 6) _UNITY_png_chunk_error(i2, gb + 353087 | 0); else {
  HEAP32[i4 >> 2] = 65;
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i6 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  i10 = HEAP32[i6 >> 2] | 0;
  i8 = i10 + -16 | 0;
  i7 = i1 + -16 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i10 + -12 | 0;
  HEAP32[i9 >> 2] = 0;
  i11 = HEAP32[i1 + -4 >> 2] | 0;
  HEAP32[i10 + -8 >> 2] = 0;
  HEAP32[i10 + -4 >> 2] = i11;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  i8 = i1 + -12 | 0;
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  i9 = i1 + -8 | 0;
  HEAP32[i10 + -8 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i9 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -16;
  i1 = i7;
 }
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i9;
 i9 = i3 + 8 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i9 >> 2] = i11;
 i9 = i2 + 8 | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i11 >> 2] = i10;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i13, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i14 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i13 >>> 0) __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i13);
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = i1 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i9 + (i13 << 5) | 0;
 if ((i1 | 0) >= (i13 | 0)) {
  HEAP32[i10 >> 2] = i13;
  return;
 }
 i2 = i12 + 4 | 0;
 i3 = i12 + 8 | 0;
 i4 = i12 + 12 | 0;
 i5 = i12 + 16 | 0;
 i6 = i12 + 20 | 0;
 i7 = i12 + 24 | 0;
 i8 = i12 + 28 | 0;
 i1 = i9 + (i1 << 5) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  i9 = i1 + 12 | 0;
  i14 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
  HEAP16[i9 >> 1] = i14;
  HEAP16[i9 + 2 >> 1] = i14 >>> 16;
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i8 >> 2];
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i11 >>> 0);
 HEAP32[i10 >> 2] = i13;
 return;
}

function __ZN5Umbra12QueryContext10isGateOpenERKNS_6PortalE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = i1 & 4095;
 if (!i9) {
  i9 = 1;
  return i9 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i4 + 100 >> 2] | 0;
 i6 = i1 >>> 12;
 i7 = i7 + (HEAP32[i7 + 120 >> 2] | 0) | 0;
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 i8 = HEAP32[i4 + 12 >> 2] | 0;
 i3 = (i8 | 0) == 0;
 i4 = i4 + 104 | 0;
 i5 = i2 + 16 | 0;
 if (!i2) {
  if (i3) {
   i9 = 1;
   return i9 | 0;
  } else i1 = 0;
  while (1) {
   i2 = HEAP32[i7 + (i6 + i1 << 2) >> 2] | 0;
   if ((i2 | 0) >= 0) if (!(HEAP32[i8 + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31))) {
    i1 = 0;
    i2 = 12;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i9 | 0)) {
    i1 = 1;
    i2 = 12;
    break;
   }
  }
  if ((i2 | 0) == 12) return i1 | 0;
 }
 if (i3) {
  i9 = 1;
  return i9 | 0;
 }
 i2 = (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] | 0) | 0;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i2 + (HEAP32[i7 + (i6 + i1 << 2) >> 2] << 2) >> 2] | 0;
  if ((i3 | 0) >= 0) if (!(HEAP32[i8 + (i3 >> 5 << 2) >> 2] & 1 << (i3 & 31))) {
   i1 = 0;
   i2 = 12;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i9 | 0)) {
   i1 = 1;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN27NoiseModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 do switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 616 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 800 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 888 >> 2] | 0) + 805 >> 0] | 0) != 0 & 1);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 812 >> 2]);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 816 >> 2]);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 904 >> 2]);
   break;
  }
 case 8:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 1172 >> 2]);
   break;
  }
 case 9:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 1436 >> 2]);
   break;
  }
 case 10:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 888 >> 2] | 0) + 1700 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN14SpriteRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(380, i1, 16, gb + 1048932 | 0, 0, gb + 430435 | 0, 25) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i4, 3, i5, i2);
 HEAP32[i4 >> 2] = gb + 58936 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 58936 + 184;
 HEAP32[i4 + 340 >> 2] = 0;
 HEAPF32[i4 + 344 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 348 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 352 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 356 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 364 >> 2] = 0;
 HEAP32[i4 + 368 >> 2] = 0;
 HEAP32[i4 + 372 >> 2] = 0;
 HEAP32[i4 + 376 >> 2] = i4;
 i2 = i4 + 268 | 0;
 i1 = HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16;
 HEAP8[i4 + 360 >> 0] = 0;
 HEAP8[i4 + 361 >> 0] = 0;
 i1 = i1 & 16531007;
 HEAP16[i2 >> 1] = i1;
 HEAP8[i2 + 2 >> 0] = i1 >>> 16;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13AnimationClip16SetRuntimeEventsERKNSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 __ZN13AnimationClip8GetRangeEv(i2, i5);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = i5 + 196 | 0;
 if ((i4 | 0) != (i1 | 0)) __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i4, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_(HEAP32[i4 >> 2] | 0, HEAP32[i5 + 200 >> 2] | 0, i2);
 HEAP32[i5 + 264 >> 2] = 2139095040;
 HEAP32[i5 + 268 >> 2] = -8388608;
 __ZN13AnimationClip8GetRangeEv(i2, i5);
 if (!(Math_fround(Math_abs(Math_fround(f3 - Math_fround(HEAPF32[i2 + 4 >> 2])))) > Math_fround(9.99999974e-06))) {
  STACKTOP = i6;
  return;
 }
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i5, gb + 1105816 | 0);
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 mftCall_vii(i1 | 0, i5 | 0, i5 + 80 | 0);
 STACKTOP = i6;
 return;
}

function __ZN12AudioManager11FixedUpdateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if (!(HEAP32[i4 + 88 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP16[gb + 1460004 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1460004 | 0, i1);
  i5 = gb + 1460004 | 0;
 } else i5 = 0;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i4, 0, 0) | 0;
 i2 = HEAP32[i4 + 56 >> 2] | 0;
 i3 = i4 + 52 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i8 | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 i2 = HEAP32[i4 + 48 >> 2] | 0;
 i3 = i4 + 44 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = HEAP32[i8 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i8 | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 if (i6) __Z19pop_allocation_rootv();
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i7;
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 if (i5 - i2 >> 2 >>> 0 < i1 >>> 0) {
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = i2 - i4 >> 2;
  i3 = i2 + i1 | 0;
  if (i3 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i6);
  i4 = i5 - i4 | 0;
  i5 = i4 >> 1;
  __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i7, i4 >> 2 >>> 0 < 536870911 ? (i5 >>> 0 < i3 >>> 0 ? i3 : i5) : 1073741823, i2, i6 + 16 | 0);
  i3 = i7 + 8 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  do {
   HEAP32[i2 >> 2] = 0;
   i2 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
   HEAP32[i3 >> 2] = i2;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) != 0);
  __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i6, i7);
  __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i7);
 } else __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i6, i1);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i4 = i7;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  __ZN5physx2Sc5Scene16removeConstraintERNS0_14ConstraintCoreE(i1 + 16 | 0, i6 + 12 | 0);
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 2660 | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i2 >> 2] = i3 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = i3 | -1073741824;
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i4 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i4, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx2Gu25PersistentContactManifold31addBatchManifoldContactsClusterEPKNS0_17PersistentContactEj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 if (i4 >>> 0 >= 5) {
  __ZN5physx2Gu25PersistentContactManifold26reduceBatchContactsClusterEPKNS0_17PersistentContactEj(i5, i3, i4);
  HEAP8[i5 + 32 >> 0] = 4;
  return;
 }
 if (i4 | 0) {
  i1 = i5 + 44 | 0;
  i2 = 0;
  do {
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) | 0;
   i7 = i3 + (i2 * 48 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 16 | 0;
   i7 = i3 + (i2 * 48 | 0) + 16 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 32 | 0;
   i7 = i3 + (i2 * 48 | 0) + 32 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 HEAP8[i5 + 32 >> 0] = i4;
 return;
}

function __ZN4crnd10dxt1_block17get_block_colors4EPNS_10color_quadIhiEEtt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = i2 & 65535;
 i8 = i4 >>> 2 & 7 | i4 << 3;
 i2 = i4 >>> 5 << 2 | i4 >>> 9 & 3;
 i4 = i4 >>> 11 << 3 | i4 >>> 13;
 i7 = i3 & 65535;
 i5 = i7 >>> 2 & 7 | i7 << 3;
 i6 = i7 >>> 5 << 2 | i7 >>> 9 & 3;
 i7 = i7 >>> 11 << 3 | i7 >>> 13;
 HEAP8[i1 >> 0] = i4;
 HEAP8[i1 + 1 >> 0] = i2;
 HEAP8[i1 + 2 >> 0] = i8;
 HEAP8[i1 + 3 >> 0] = -1;
 HEAP8[i1 + 4 >> 0] = i7;
 HEAP8[i1 + 5 >> 0] = i6;
 HEAP8[i1 + 6 >> 0] = i5;
 HEAP8[i1 + 7 >> 0] = -1;
 i10 = (((i4 << 1) + i7 | 0) >>> 0) / 3 | 0;
 i2 = i2 & 255;
 i6 = i6 & 255;
 i9 = (((i2 << 1) + i6 | 0) >>> 0) / 3 | 0;
 i3 = i8 & 255;
 i5 = i5 & 255;
 i8 = (((i3 << 1) + i5 | 0) >>> 0) / 3 | 0;
 HEAP8[i1 + 8 >> 0] = i10 >>> 0 > 255 ? 255 : i10;
 HEAP8[i1 + 9 >> 0] = i9 >>> 0 > 255 ? 255 : i9;
 HEAP8[i1 + 10 >> 0] = i8 >>> 0 > 255 ? 255 : i8;
 HEAP8[i1 + 11 >> 0] = -1;
 i4 = (((i7 << 1) + i4 | 0) >>> 0) / 3 | 0;
 i2 = (((i6 << 1) + i2 | 0) >>> 0) / 3 | 0;
 i3 = (((i5 << 1) + i3 | 0) >>> 0) / 3 | 0;
 HEAP8[i1 + 12 >> 0] = i4 >>> 0 > 255 ? 255 : i4;
 HEAP8[i1 + 13 >> 0] = i2 >>> 0 > 255 ? 255 : i2;
 HEAP8[i1 + 14 >> 0] = i3 >>> 0 > 255 ? 255 : i3;
 HEAP8[i1 + 15 >> 0] = -1;
 return 4;
}

function __ZN27AnimationLayerMixerPlayable6Memory20CreateNodeStateArrayEiRKN7mecanim18ValueArrayConstantEbbbRNS1_6memory9AllocatorE(i3, i4, i5, i6, i7, i8, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 if (i1 | 0) {
  i1 = 0;
  do {
   __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i9);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = i3 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 if (!i4) return;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, i4 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
 if ((i4 | 0) > 0) i1 = 0; else return;
 do {
  i2 = __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE(i5, i6, i7, i8, i9) | 0;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN14SphereCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i2 = i7 + 60 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 64 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 68 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 72 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN13dynamic_arrayIN4RTTI15DerivedFromInfoELj4EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 3) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  i7 = i9;
  i8 = HEAP32[i7 + 4 >> 2] | 0;
  i10 = i3 + (i1 << 3) | 0;
  HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i10 + 4 >> 2] = i8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + (i5 * 24 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i5 * 24 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + (i5 * 24 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + (i5 * 24 | 0) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i9 + (i5 * 24 | 0) + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i9 + (i5 * 24 | 0) + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 return;
}

function __Z51Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToEulerRadRK11QuaternionfR8Vector3f(i2, i9) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 var f1 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 16 | 0;
 i11 = i12;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f8 * f8);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * f7));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f3 * f3));
 f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f1 * f1))));
 if (f6 < Math_fround(HEAPF32[gb + 62452 >> 2])) {
  f5 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 } else {
  f5 = Math_fround(f1 / f6);
  f4 = Math_fround(f3 / f6);
  f3 = Math_fround(f7 / f6);
  f1 = Math_fround(f8 / f6);
 }
 HEAPF32[i10 >> 2] = f1;
 HEAPF32[i10 + 4 >> 2] = f3;
 HEAPF32[i10 + 8 >> 2] = f4;
 HEAPF32[i10 + 12 >> 2] = f5;
 __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE(i11, i10, 4);
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 STACKTOP = i12;
 return;
}

function __Z24ExtractMonoPPtrClassNameRK16TypeTreeIterator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 i3 = ((i3 | 0) < 0 ? HEAP32[gb + 36932 >> 2] | 0 : HEAP32[i6 + 20 >> 2] | 0) + (i3 & 2147483647) | 0;
 if (!(_strncmp(i3, gb + 468240 | 0, 6) | 0)) {
  i2 = i3 + 6 | 0;
  if (HEAP8[i2 >> 0] | 0) {
   i4 = (_strlen(i3) | 0) + -1 | 0;
   i5 = i3 + i4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   i6 = i5 - i2 | 0;
   if (i6 >>> 0 > 4294967279) {
    __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
    i7 = 7;
   } else if (i6 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i6; else i7 = 7;
   if ((i7 | 0) == 7) {
    i3 = i6 + 16 & -16;
    i7 = __Znwj(i3) | 0;
    HEAP32[i1 >> 2] = i7;
    HEAP32[i1 + 8 >> 2] = i3 | -2147483648;
    HEAP32[i1 + 4 >> 2] = i6;
    i1 = i7;
   }
   if ((i4 | 0) != 6) {
    i3 = i1;
    while (1) {
     HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
    }
    i1 = i1 + i6 | 0;
   }
   HEAP8[i1 >> 0] = 0;
   return;
  }
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN9Texture3DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 76 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 46212 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 5;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 1;
 HEAP8[i1 + 106 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction11updateStateEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i4 + 6 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (i1 & 2) {
  if (i2) {
   __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i4);
   i1 = HEAP16[i3 >> 1] | 0;
  }
  HEAP16[i3 >> 1] = i1 & 65533;
 }
 HEAP16[i4 + 4 >> 1] = 0;
 if (!(HEAP8[(HEAP32[i4 + 40 >> 2] | 0) + 19 >> 0] | 0)) {
  i1 = i4 + 36 | 0;
  if (!(HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0) + 64 >> 0] & 4)) {
   i2 = i4 + 46 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i4 = i4 + 32 | 0;
    i3 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i4 >> 2] | 0) | 0;
    __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj(i3, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0, 0);
    HEAP8[i2 >> 0] = 1;
    return;
   }
  }
  if (!(HEAP8[(HEAP32[(HEAP32[i4 + 36 >> 2] | 0) + 28 >> 2] | 0) + 64 >> 0] & 4)) return;
 }
 i1 = i4 + 46 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 i3 = i4 + 32 | 0;
 i2 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj(i2, HEAP32[i3 >> 2] | 0, HEAP32[i4 + 36 >> 2] | 0, 0, 0);
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN20ArchiveStorageReader8FindNodeEPKc(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = i1 + 120 | 0;
 i9 = i1 + 124 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i5 = i3;
 if ((i4 | 0) == (i3 | 0)) {
  i13 = 0;
  return i13 | 0;
 }
 i1 = 0;
 i2 = i5;
 i8 = i5;
 L4 : while (1) {
  i7 = i8 + (i1 * 40 | 0) + 20 | 0;
  i5 = _strlen(i10) | 0;
  i6 = HEAP8[i7 + 11 >> 0] | 0;
  if ((i5 | 0) == ((i6 << 24 >> 24 < 0 ? HEAP32[i8 + (i1 * 40 | 0) + 24 >> 2] | 0 : i6 & 255) | 0)) {
   switch (i5 | 0) {
   case -1:
    {
     i13 = 5;
     break L4;
    }
   case 0:
    {
     i12 = i2;
     break L4;
    }
   default:
    {}
   }
   if (!(_memcmp(i6 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i7, i10, i5) | 0)) {
    i13 = 7;
    break;
   }
   i2 = HEAP32[i11 >> 2] | 0;
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = i2;
  } else i5 = i3;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 < ((i4 - i5 | 0) / 40 | 0) >>> 0) {
   i3 = i5;
   i8 = i5;
  } else {
   i1 = 0;
   i13 = 11;
   break;
  }
 }
 if ((i13 | 0) == 5) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7); else if ((i13 | 0) == 7) i12 = HEAP32[i11 >> 2] | 0; else if ((i13 | 0) == 11) return i1 | 0;
 i13 = i12 + (i1 * 40 | 0) | 0;
 return i13 | 0;
}

function __ZN17BillboardRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(380, i1, 16, gb + 1048932 | 0, 0, gb + 422791 | 0, 24) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i4, 8, i5, i2);
 i2 = i4 + 340 | 0;
 HEAP32[i4 >> 2] = gb + 56316 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 56316 + 192;
 HEAP32[i2 >> 2] = gb + 56316 + 252;
 HEAP32[i4 + 344 >> 2] = 0;
 HEAP32[i4 + 348 >> 2] = 0;
 HEAP32[i4 + 352 >> 2] = 0;
 HEAP32[i4 + 356 >> 2] = i2;
 HEAP32[i4 + 360 >> 2] = 0;
 HEAPF32[i4 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 368 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 372 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 376 >> 2] = Math_fround(0.0);
 i2 = i4 + 268 | 0;
 i1 = (HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16531007;
 HEAP16[i2 >> 1] = i1;
 HEAP8[i2 + 2 >> 0] = i1 >>> 16;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11Rigidbody2D27SetUseFullKinematicContactsEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 i6 = i7 + 16 | 0;
 HEAP8[i5 + 50 >> 0] = i1 & 1;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = 0;
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i6 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i1 = (__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i5, i6) | 0) < 1;
 if (!(i1 | (HEAP32[i2 >> 2] | 0) == 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  do {
   __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(HEAP32[i1 >> 2] | 0, 1, 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
 }
 __ZN11Rigidbody2D19RecalculateContactsEv(i5);
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN11AudioModule22CreateAudioClipFromWWWEP10IWWWStreamPKcbbi(i1, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i2 + 8 | 0;
 i9 = i2;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(136, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 874012 | 0, 77) | 0;
 i12 = gb + 63520 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN9AudioClipC2E10MemLabelId18ObjectCreationMode(i1, i8, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 __ZN9AudioClip16EnableLegacyModeEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 if (__ZN9AudioClip10InitStreamEP10IWWWStreamPKcP13MoviePlaybackbb15FMOD_SOUND_TYPE(i1, i3, i4, 0, i5, i6, i7) | 0) {
  i12 = i1;
  STACKTOP = i2;
  return i12 | 0;
 }
 if (i3 | 0) mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63328 | 0);
 __Z19DestroySingleObjectP6Object(i1);
 i12 = 0;
 STACKTOP = i2;
 return i12 | 0;
}

function __Z24Caching_CUSTOM_AuthorizeP12Il2CppStringS0_xiS0_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i7 + 44 | 0;
 i12 = i7 + 40 | 0;
 i11 = i7 + 36 | 0;
 i8 = i7 + 24 | 0;
 i9 = i7 + 12 | 0;
 i10 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i13, i1);
 __ZN11ICallStringC2EP12Il2CppString(i12, i2);
 __ZN11ICallStringC2EP12Il2CppString(i11, i6);
 i6 = __Z17GetCachingManagerv() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i13);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i9, i12);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i10, i11);
 i6 = (__ZN14CachingManager9AuthorizeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_xiS8_(i6, i8, i9, i3, i4, i5, i10) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i10);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i7;
 return i6 | 0;
}

function _UNITY_FT_Get_Kerning(i4, i1, i3, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0;
 if (!i4) {
  i7 = 35;
  return i7 | 0;
 }
 if (!i6) {
  i7 = 6;
  return i7 | 0;
 }
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i2 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 76 >> 2] | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = mftCall_iiiii(i2 | 0, i4 | 0, i1 | 0, i3 | 0, i6 | 0) | 0;
 if (!((i5 | 0) != 2 & (i1 | 0) == 0)) {
  i7 = i1;
  return i7 | 0;
 }
 i3 = i4 + 88 | 0;
 HEAP32[i6 >> 2] = _UNITY_FT_MulFix(HEAP32[i6 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0) | 0;
 i4 = _UNITY_FT_MulFix(HEAP32[i7 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 if ((i5 | 0) == 1) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP16[i1 + 12 >> 1] | 0;
 if ((i2 & 65535) < 25) {
  HEAP32[i6 >> 2] = _UNITY_FT_MulDiv(HEAP32[i6 >> 2] | 0, i2 & 65535, 25) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i1 = HEAP16[i1 + 14 >> 1] | 0;
 if ((i1 & 65535) < 25) {
  i1 = _UNITY_FT_MulDiv(i4, i1 & 65535, 25) | 0;
  HEAP32[i7 >> 2] = i1;
 } else i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 32 & -64;
 HEAP32[i7 >> 2] = i1 + 32 & -64;
 i7 = 0;
 return i7 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i6 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i6 + 4 >> 2] | 0);
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i6 + 92 >> 2] | 0;
 i1 = i5;
 if (i5 | 0) {
  i2 = i6 + 96 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i5 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -16 - i1 | 0) >>> 4) << 4);
  __ZdlPv(i5);
 }
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = 16;
 HEAP32[i7 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 STACKTOP = i8;
 return;
}

function __ZNK5Umbra18ImpOcclusionBuffer15isAARectVisibleERKNS_7Vector2ES3_f(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 if (!(HEAP32[i1 + 1408 >> 2] | 0)) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i9 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
 i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(0.0));
 HEAP32[i5 >> 2] = i9;
 HEAP32[i5 + 4 >> 2] = i2;
 i2 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
 i3 = ~~Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)) + Math_fround(1.0));
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 f8 = Math_fround(Math_fround(f4 * Math_fround(.5)) + Math_fround(.5));
 i6 = __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f(i1, i5, i6, (HEAP32[i1 + 1200 >> 2] | 0) == 1 ? f8 : f4) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9ShaderLab19SerializedSubShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i7 = i8 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = (i2 - i1 | 0) / 872 | 0;
 HEAP32[i4 >> 2] = i5;
 i11 = i9 + 16 | 0;
 i6 = HEAP32[i11 >> 2] | 0;
 i3 = i6 + 4 | 0;
 i10 = i9 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i6 >> 2] = i5;
  HEAP32[i11 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i4, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab14SerializedPass8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i9);
  i1 = i1 + 872 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i8 + 12 | 0, i9);
 i1 = i8 + 24 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i10 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i11 >> 2] = i3;
  STACKTOP = i12;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i11, i1, 4);
  STACKTOP = i12;
  return;
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __Z40Animation_CUSTOM_INTERNAL_CALL_SyncLayerP12Il2CppObjecti(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 HEAP32[i11 >> 2] = i9;
 i7 = i2 + 268 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i6 = HEAP32[i2 + 272 >> 2] | 0;
 i1 = i6 - i5 >> 2;
 i2 = i5;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i9 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i9 | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_(i7, i8, i11) | 0;
 STACKTOP = i12;
 return;
}

function __Z20DetailPrototypeToCppRK19MonoDetailPrototypeR15DetailPrototype(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i3 + 32 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 36 >> 2] = i1;
 HEAP32[i3 + 40 >> 2] = i4;
 HEAP32[i3 + 44 >> 2] = i5;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i4 = HEAP32[i2 + 32 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 HEAP32[i3 + 48 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 52 >> 2] = i5;
 HEAP32[i3 + 56 >> 2] = i4;
 HEAP32[i3 + 60 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAP32[i3 + 68 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i3 + 72 >> 2] = HEAP32[i2 + 68 >> 2];
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc10NPhaseCore16createFilterPairEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i3 + 124 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) if (__ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EE6extendEv(i3 + 108 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i8 = 0;
  return i8 | 0;
 } while (0);
 i4 = i1 + -1 | 0;
 i8 = HEAP32[(HEAP32[i3 + 120 >> 2] | 0) + (i4 << 2) >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 i4 = i3 + 132 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i5 = (i7 + 32 | 0) >>> 5;
 i6 = i3 + 136 | 0;
 if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
  i2 = i3 + 140 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 2, gb + 769739 | 0, 329) | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 | 0) {
   _memcpy(i1 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
  }
  i3 = HEAP32[i6 >> 2] | 0;
  _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i6 >> 2] = i5;
 } else i1 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + (i7 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i7 & 31);
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP8[i8 + 8 >> 0] = 2;
 return i8 | 0;
}

function __ZN22CrashReportingSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i5 = i4 + 12 | 0;
 i7 = i6 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i8 = i6 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i5, i1, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i6, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i8 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
  STACKTOP = i9;
  return;
 }
}

function __ZN14TimerQueryGLES10PollResultERyb(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 i7 = i2;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 if (!i1) {
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 800 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, 34919, i2 | 0);
  i7 = i2;
  if ((HEAP32[i7 >> 2] | 0) == 0 & (HEAP32[i7 + 4 >> 2] | 0) == 0) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 720 >> 0] | 0)) i1 = HEAP8[i4 + 12 >> 0] | 0; else {
  i1 = (__ZNK7ApiGLES3GetEj(HEAP32[gb + 1451080 >> 2] | 0, 36795) | 0) != 0 & 1;
  HEAP8[i4 + 12 >> 0] = i1;
 }
 i7 = i3;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 if (!(i1 << 24 >> 24)) {
  mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 800 >> 2] | 0, HEAP32[i4 + 16 >> 2] | 0, 34918, i3 | 0);
  i2 = i3;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 i8 = i5;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4 + 24 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i7 = i5;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 i7 = 1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN13dynamic_arrayI14ProfilerSampleLj8EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = (i1 - i14 | 0) / 24 | 0;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = (i7 | 0) / 24 | 0;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 * 24 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 * 24 | 0, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, (HEAP32[i9 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 * 24 | 0) | 0;
 _memmove(i14 + (i8 * 24 | 0) | 0, i14 | 0, i11 * 24 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13TextRendering4Font8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i6);
 i1 = i5 + 32 | 0;
 i8 = i6 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i9 = i6 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 40 | 0, i6);
 i1 = i5 + 36 | 0;
 f4 = Math_fround(HEAP32[i1 >> 2] | 0);
 HEAPF32[i7 >> 2] = f4;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0) {
  HEAPF32[i2 >> 2] = f4;
  HEAP32[i8 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i7, 4);
 HEAP32[i1 >> 2] = ~~Math_fround(HEAPF32[i7 >> 2]);
 __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5 + 44 | 0, i6);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i6);
 __ZN20TextRenderingPrivate8FontImpl8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i5 + 48 >> 2] | 0, i6);
 STACKTOP = i10;
 return;
}

function __ZN12TreeRenderer15WillRenderTreesERK9IndexListPK9SceneNodeR13dynamic_arrayIbLj1EE(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i5 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i10 = i8 + 4 | 0;
 i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do {
  i3 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  if (!(HEAP8[i1 + i3 >> 0] | 0)) {
   i1 = HEAP32[i6 + (i3 * 24 | 0) >> 2] | 0;
   switch (HEAP32[i1 + 264 >> 2] | 0) {
   case 1:
    {
     if (!(HEAP8[i1 + 289 >> 0] | 0)) i2 = HEAP32[i1 + 284 >> 2] | 0; else i2 = -1;
     __ZN12TreeRenderer21ComputeWindPropertiesEib(i8, HEAP32[i1 + 268 >> 2] | 0, i2, 0);
     __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i1, HEAP32[i8 >> 2] | 0);
     HEAP8[i1 + 288 >> 0] = HEAP8[i10 >> 0] | 0;
     break;
    }
   case 2:
    {
     __ZN29BillboardTreeInstanceRenderer10UpdateWindEv(i1);
     break;
    }
   default:
    {}
   }
   i1 = HEAP32[i7 >> 2] | 0;
   HEAP8[i1 + i3 >> 0] = 1;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i2 | 0));
 STACKTOP = i11;
 return;
}

function __Z46Physics2D_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK13Vector2fIcallS1_fS1_P11Il2CppArrayfiff(i2, i3, f4, i5, i6, f7, i8, f9, f10) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 var i1 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 16 | 0;
 i13 = i11 + 8 | 0;
 i12 = i11;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 36) | 0;
 i15 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i3 = __ZN16Physics2DManager7BoxCastERK8Vector2fS2_fS2_fiffPK10Collider2DbP12RaycastHit2Di(i15, i14, i13, f4, i12, f7, i8, f9, f10, 0, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0) | 0;
 if (!i3) {
  STACKTOP = i11;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i11;
 return i3 | 0;
}

function __Z33PluginsInitializePreloadedPluginsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = __Z19GetBuildSettingsPtrv() | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 i6 = i1 + 56 | 0;
 if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) return;
 do {
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
  __Z22FindAndLoadUnityPluginPKcPPv(i1, 0) | 0;
  HEAP32[gb + 65704 >> 2] = 4;
  i3 = __ZN15GlobalCallbacks3GetEv() | 0;
  i4 = i3 + 39368 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = 0;
   do {
    i5 = i3 + 38600 + (i1 * 12 | 0) | 0;
    if (!(HEAP8[i3 + 38600 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i5 >> 2] | 0, 0); else mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 38600 + (i1 * 12 | 0) + 4 >> 2] | 0, 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  i1 = HEAP32[gb + 1162584 >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
   i4 = 0;
   do {
    i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 * 24 | 0) + 4 >> 2] | 0;
    if (i3) {
     mftCall_viii(i3 | 0, 0, 4, 0);
     i1 = HEAP32[gb + 1162584 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < (((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) / 24 | 0) >>> 0);
  }
  i2 = i2 + 16 | 0;
 } while ((i2 | 0) != (HEAP32[i6 >> 2] | 0));
 return;
}

function __ZNSt3__26vectorIPK11Il2CppImageNS_9allocatorIS3_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN8JSONRead14GetValueForKeyEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i3) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i2 & 255 | 0) == 3) {
  i1 = i4;
  while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 1048581;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i5 + 4 >> 2] = i1 - i4;
  i4 = __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE(i3, i5) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i5);
  STACKTOP = i6;
  return ((i4 | 0) == ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i3 + 4 >> 2] | 0) * 48 | 0) | 0) ? 0 : i4 + 24 | 0) | 0;
 }
 if ((i2 | 0) != 4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = (HEAP32[i1 + 152 >> 2] | 0) + ((HEAP32[i1 + 164 >> 2] | 0) + -1 << 2) | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i5 + 1;
 i5 = (HEAP32[i3 >> 2] | 0) + (i5 * 24 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx2Gu23computeMTD_SphereSphereERNS_6PxVec3ERfRKNS0_6SphereES6_(i10, i9, i3, i4) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f11 = f0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i4 >> 2]));
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i4 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 8 >> 2]));
 f6 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8)) + Math_fround(f5 * f5));
 f1 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f1 = Math_fround(f1 + Math_fround(HEAPF32[i4 + 12 >> 2]));
 if (f6 > Math_fround(f1 * f1)) {
  i10 = 0;
  return i10 | 0;
 }
 f2 = Math_fround(Math_sqrt(Math_fround(f6)));
 if (f6 < Math_fround(9.99999997e-07)) {
  HEAP32[i10 >> 2] = 1065353216;
  HEAP32[i10 + 4 >> 2] = 0;
  HEAP32[i10 + 8 >> 2] = 0;
 } else {
  f11 = Math_fround(Math_fround(1.0) / f2);
  f6 = Math_fround(f8 * f11);
  f8 = Math_fround(f5 * f11);
  HEAPF32[i10 >> 2] = Math_fround(f7 * f11);
  HEAPF32[i10 + 4 >> 2] = f6;
  HEAPF32[i10 + 8 >> 2] = f8;
 }
 f11 = Math_fround(f1 - f2);
 i10 = f11 > Math_fround(0.0);
 HEAPF32[i9 >> 2] = i10 ? f11 : Math_fround(0.0);
 i10 = 1;
 return i10 | 0;
}

function __ZN5Umbra9intersectERKNS_7Vector4ERKNS_8TriangleE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f2 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(f2 + f8);
 f7 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 12 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 16 >> 2])));
 f7 = Math_fround(f2 + Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 20 >> 2]))));
 i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 if (((HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 | 0) < 0) {
  i3 = 1;
  return i3 | 0;
 }
 f8 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i3 + 28 >> 2])));
 f8 = Math_fround(f2 + Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 32 >> 2]))));
 i3 = ((HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) ^ i1 | 0) < 0;
 return i3 | 0;
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags(i9, i3, i1, i2) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i9 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i7 = i9 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j(i3, _llvm_bswap_i32(i1 | 0) | 0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
  STACKTOP = i8;
  return;
 }
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
   i2 = HEAP8[i5 >> 0] | 0;
  } else {
   i2 = HEAP8[i2 >> 0] | 0;
   HEAP8[i5 >> 0] = i2;
   HEAP32[i6 >> 2] = i3;
  }
  HEAP8[i1 >> 0] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i9);
 STACKTOP = i8;
 return;
}

function __ZN16b2PrismaticJoint9SetLimitsEff(i4, f5, f6) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i4 + 120 | 0;
 if (!(Math_fround(HEAPF32[i7 >> 2]) != f5)) if (!(Math_fround(HEAPF32[i4 + 124 >> 2]) != f6)) return;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAPF32[i7 >> 2] = f5;
 HEAPF32[i4 + 124 >> 2] = f6;
 HEAPF32[i4 + 112 >> 2] = Math_fround(0.0);
 return;
}

function __ZN15SharedLightDataC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 33936 + 8;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = -1;
 HEAP32[i1 + 92 >> 2] = 0;
 __ZN14ShadowSettings5ResetEv(i1 + 96 | 0);
 HEAP32[i1 + 124 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 128 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 136 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 140 >> 2] = HEAP32[gb + 62548 >> 2];
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 62548 + 4 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 62548 + 8 >> 2];
 HEAPF32[i1 + 152 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 156 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 172 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 176 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 180 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 184 >> 2] = 1;
 __ZN19RenderEventsContextC2Ei(i1 + 208 | 0, 4);
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 216 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 280 | 0) | 0;
 return;
}

function __ZN11MonoManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS5_EE13stl_allocatorIS5_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags(i7, i5 + 28 | 0, 0);
 i6 = i5 + 212 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 216 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z31GetInterpolatedLightAttenuationRK17LightProbeContextRK29LightProbeSamplingCoordinatesPK15SharedLightData(i2, i11, i4) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 var f1 = f0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i2 + 120 >> 2] | 0;
 if (!(HEAP32[i3 + 12 >> 2] | 0)) {
  f6 = Math_fround(1.0);
  return Math_fround(f6);
 }
 i2 = HEAP32[i2 + 112 >> 2] | 0;
 i9 = HEAP32[i11 + 20 >> 2] | 0;
 if (!((i9 | 0) > -1 ? (i9 | 0) < (HEAP32[i2 + 12 >> 2] | 0) : 0)) {
  f6 = Math_fround(1.0);
  return Math_fround(f6);
 }
 i8 = HEAP32[i2 >> 2] | 0;
 i10 = (HEAP32[i8 + (i9 * 80 | 0) + 12 >> 2] >> 31) + 4 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  i2 = 0;
  f1 = Math_fround(0.0);
  do {
   f1 = Math_fround(f1 + Math_fround(HEAPF32[i11 + (i2 << 2) >> 2]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i10 | 0));
  return Math_fround(f1);
 }
 i4 = HEAP32[i4 + 88 >> 2] | 0;
 i3 = 0;
 f1 = Math_fround(0.0);
 do {
  i2 = HEAP32[i8 + (i9 * 80 | 0) + (i3 << 2) >> 2] | 0;
  f6 = Math_fround(HEAPF32[i11 + (i3 << 2) >> 2]);
  if ((HEAP32[i7 + (i2 << 3) >> 2] | 0) == (i4 | 0)) f5 = Math_fround(HEAPF32[i7 + (i2 << 3) + 4 >> 2]); else f5 = Math_fround(1.0);
  f1 = Math_fround(f1 + Math_fround(f6 * f5));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i10 | 0));
 return Math_fround(f1);
}

function __Z17InstantiateObjectR6ObjectP9TransformRK8Vector3fRK11QuaternionfR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINSA_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i2, i4, i5, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE(i1, i2, i3) | 0;
 if (!i1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 i2 = __Z37GetTransformFromComponentOrGameObjectP6Object(i1) | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i8 + 40 >> 2] | 0;
 __Z6AppendPKcS0_(i6, mftCall_ii(HEAP32[i8 + 36 >> 2] | 0, i1 | 0) | 0, gb + 391391 | 0);
 mftCall_vii(i3 | 0, i1 | 0, ((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i2) {
  STACKTOP = i7;
  return i1 | 0;
 }
 if (((HEAP32[i2 + 8 >> 2] | 0) >>> 21 | 0) == (HEAP32[gb + 28980 + 24 >> 2] | 0)) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 0);
 __ZN9Transform11SetPositionERK8Vector3f(i2, i4);
 __ZN9Transform11SetRotationERK11Quaternionf(i2, i5);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx7Cooking20validateTriangleMeshERKNS_18PxTriangleMeshDescE(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 240 | 0;
 i4 = i7;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 do if (i1 >>> 0 >= 3) {
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  if ((i2 | 0) != 0 | ((i1 >>> 0) % 3 | 0 | 0) == 0) {
   if (HEAP32[i3 + 32 >> 2] | 0) if ((HEAP32[i3 + 28 >> 2] | 0) >>> 0 < 2) break;
   if (i1 >>> 0 > 65535) if (HEAP16[i3 + 24 >> 1] & 2) break;
   if (HEAP32[i3 + 4 >> 2] | 0) if ((HEAP32[i3 >> 2] | 0) >>> 0 >= 12) {
    if (i2 | 0) if ((HEAP32[i3 + 12 >> 2] | 0) >>> 0 < (HEAP16[i3 + 24 >> 1] & 2 ? 6 : 12) >>> 0) break;
    __ZN5physx2Gu12TriangleMeshC2Ev(i4);
    HEAP32[i4 >> 2] = gb + 110164 + 8;
    HEAP32[i4 + 8 >> 2] = gb + 110164 + 88;
    i6 = __ZN5physx19TriangleMeshBuilder12loadFromDescERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb(i4, i3, i5 + 4 | 0, 1) | 0;
    __ZN5physx2Gu12TriangleMeshD2Ev(i4);
    STACKTOP = i7;
    return i6 | 0;
   }
  }
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 726521 | 0, 104, gb + 730612 | 0, i6);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13ScreenManager22SetRequestedResolutionEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) == -1) {
  if ((HEAP32[i6 + 8 >> 2] | 0) == -1) if ((HEAP32[i6 + 12 >> 2] | 0) == -1) if ((HEAP32[i6 + 16 >> 2] | 0) == -1) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
  i1 = HEAP32[i6 >> 2] | 0;
  i8 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[i1 + 80 >> 2] | 0, i6 | 0) | 0;
 } else i8 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i2 | 0) == -1) i2 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 84 >> 2] | 0, i6 | 0) | 0;
 i3 = HEAP32[i6 + 12 >> 2] | 0;
 if ((i3 | 0) == -1) i4 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0) | 0; else i4 = (i3 | 0) == 1;
 i3 = HEAP32[i6 + 16 >> 2] | 0;
 if ((i3 | 0) == -1) {
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i6 | 0);
  i3 = HEAP32[i5 + 8 >> 2] | 0;
 }
 mftCall_iiiiii(i8 | 0, i6 | 0, i1 | 0, i2 | 0, i4 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = -1;
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function _UNITY_FT_Atan2(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(i3 | i1)) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = _FT_MSB(((i3 | 0) < 0 ? 0 - i3 | 0 : i3) | ((i1 | 0) < 0 ? 0 - i1 | 0 : i1)) | 0;
 if ((i2 | 0) < 30) {
  i7 = 29 - i2 | 0;
  i2 = i1 << i7;
  i3 = i3 << i7;
 } else {
  i7 = i2 + -29 | 0;
  i2 = i1 >> i7;
  i3 = i3 >> i7;
 }
 i1 = 0 - i2 | 0;
 if ((i3 | 0) > (i2 | 0)) if ((i3 | 0) > (i1 | 0)) {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = i1;
  i1 = i3;
  i2 = 5898240;
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = 0 - i3 | 0;
  i2 = (i3 | 0) > 0 ? 11796480 : -11796480;
 } else {
  i8 = (i3 | 0) < (i1 | 0);
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i4 = i8 ? i2 : i3;
  i1 = i8 ? 0 - i3 | 0 : i2;
  i2 = i8 ? -5898240 : 0;
 }
 while (1) {
  i3 = i4 + i5 >> i6;
  if ((i4 | 0) > 0) {
   i4 = i4 - (i1 + i5 >> i6) | 0;
   i1 = i3 + i1 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i4 = (i1 + i5 >> i6) + i4 | 0;
   i1 = i1 - i3 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
  }
 }
 if ((i2 | 0) > -1) {
  i8 = i2 + 8 & -16;
  return i8 | 0;
 } else {
  i8 = 0 - (8 - i2 & -16) | 0;
  return i8 | 0;
 }
 return 0;
}

function _j0f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 do if (i2 >>> 0 > 2139095039) f1 = Math_fround(Math_fround(1.0) / Math_fround(f1 * f1)); else {
  f1 = Math_fround(Math_abs(Math_fround(f1)));
  if (i2 >>> 0 > 1073741823) {
   f1 = Math_fround(_common_163(i2, f1, 0));
   break;
  }
  if (i2 >>> 0 > 973078527) {
   f3 = Math_fround(f1 * f1);
   f1 = Math_fround(f1 * Math_fround(.5));
   f1 = Math_fround(Math_fround(Math_fround(f1 + Math_fround(1.0)) * Math_fround(Math_fround(1.0) - f1)) + Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(1.82954045e-06) - Math_fround(f3 * Math_fround(4.61832705e-09)))) + Math_fround(-.000189979299))) + Math_fround(.015625))) / Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(Math_fround(f3 * Math_fround(1.16614007e-09)) + Math_fround(5.13546524e-07))) + Math_fround(.000116926785))) + Math_fround(.0156191029))) + Math_fround(1.0)))));
   break;
  } else {
   f3 = Math_fround(f1 * Math_fround(f1 * Math_fround(.25)));
   f1 = Math_fround(Math_fround(1.0) - (i2 >>> 0 > 562036735 ? f3 : f1));
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE10deallocateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i7 = i5 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i4 = i2 + -84 | 0;
   HEAP32[i7 >> 2] = i4;
   i3 = i2 + -44 | 0;
   if ((HEAP32[i2 + -28 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -40 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -64 | 0;
   if ((HEAP32[i2 + -48 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -60 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP32[i2 + -68 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -80 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i2 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 73;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEE14handleAccessorILj550ENS_22PxRepXPropertyAccessorILj550ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i8 = _strtoul(i1, i4, 10) | 0;
 i1 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i2 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i3 = _strtoul(HEAP32[i4 >> 2] | 0, 0, 10) | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i7 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx23PxMaterialGeneratedInfoC2Ev(i10);
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i4;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i10 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i7, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i7, i1);
 i5 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i4;
  HEAP32[i2 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i5 >> 2] = i1;
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return;
}

function __ZN23ShaderVariantCollection10ShaderInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i4 = HEAP32[i1 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i4 = i5;
 }
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = (i2 - i1 | 0) / 36 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj(i6, i4 - i3 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else if (i4 >>> 0 < i3 >>> 0) {
  i3 = i1 + (i4 * 36 | 0) | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i2 = i2 + (~(((i2 + -36 - i3 | 0) >>> 0) / 36 | 0) * 36 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
  }
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN19SkinnedMeshRenderer5SetupEP4MeshRK13dynamic_arrayI4PPtrI9TransformELj4EE(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i5 = i6 + 360 | 0;
 if ((i5 | 0) != (i1 | 0)) {
  i8 = HEAP32[i1 >> 2] | 0;
  i9 = i6 + 372 | 0;
  i1 = HEAP32[i1 + 12 >> 2] << 2;
  i4 = i1 >> 2;
  HEAP32[i9 >> 2] = i4;
  i2 = i6 + 376 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  do if ((i3 & 2147483647) >>> 0 < i4 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i4;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i6 + 364 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i6 + 364 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i4;
   HEAP32[i5 >> 2] = i1;
   break;
  } else i1 = HEAP32[i5 >> 2] | 0; while (0);
  _memcpy(i1 | 0, i8 | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
 }
 if (!i7) {
  i8 = 0;
  i9 = i6 + 352 | 0;
  HEAP32[i9 >> 2] = i8;
  __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv(i6);
  return;
 }
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i6 + 352 | 0;
 HEAP32[i9 >> 2] = i8;
 __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv(i6);
 return;
}

function __ZN19ShaderPropertySheet20ReservePropertyCountEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 32 | 0;
 i2 = i4 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5 << 2, 4, i4 + 36 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i4 + 36 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 + 44 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  break;
 } while (0);
 i1 = i4 + 52 | 0;
 i2 = i4 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i5 >>> 0) return;
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5 << 2, 4, i4 + 56 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i4 + 56 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 + 64 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function __ZN15b2RevoluteJoint9SetLimitsEff(i4, f5, f6) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i4 + 120 | 0;
 if (!(Math_fround(HEAPF32[i7 >> 2]) != f5)) if (!(Math_fround(HEAPF32[i4 + 124 >> 2]) != f6)) return;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAPF32[i4 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i7 >> 2] = f5;
 HEAPF32[i4 + 124 >> 2] = f6;
 return;
}

function __ZN15LODGroupManager26CalculateAnimatedCrossFadeENS_11LODFadeDataEhfPhPf(i1, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (f6 <= Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i1 >> 2] & 2)) i1 = HEAP8[i7 >> 0] | 0; else {
  i4 = (i5 & 255) >>> 1;
  i1 = HEAP8[i7 >> 0] | 0;
  i2 = i4 | i5;
  if (i1 << 24 >> 24 == i4 << 24 >> 24) {
   HEAP8[i7 >> 0] = i2;
   HEAPF32[i8 >> 2] = Math_fround(1.0);
   i8 = 1;
   return i8 | 0;
  }
  if (i1 << 24 >> 24 == i2 << 24 >> 24) {
   f6 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f6);
   HEAPF32[i8 >> 2] = f6;
   if (!(f6 <= Math_fround(0.0))) {
    i8 = 1;
    return i8 | 0;
   }
   HEAP8[i7 >> 0] = i5;
   HEAPF32[i8 >> 2] = Math_fround(0.0);
   i8 = 1;
   return i8 | 0;
  }
 }
 i3 = i5 & 255;
 i4 = i3 << 1;
 i1 = i1 & 255;
 i2 = i4 & 254;
 if ((i1 | 0) == (i2 | 0)) {
  HEAP8[i7 >> 0] = i4 | i3;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i8 = 1;
  return i8 | 0;
 }
 if ((i1 | 0) != (i2 | i3 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 f6 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) + f6);
 HEAPF32[i8 >> 2] = f6;
 if (!(f6 >= Math_fround(1.0))) {
  i8 = 1;
  return i8 | 0;
 }
 HEAP8[i7 >> 0] = i5;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 i8 = 1;
 return i8 | 0;
}

function __ZN13RenderManager12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = gb + 1156840 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 29 | 0)) {
    i4 = gb + 1156840 + (i1 * 12 | 0) + 8 | 0;
    i2 = gb + 1156840 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[gb + 1156840 + 768 >> 2] | 0) + -1 | 0;
  HEAP32[gb + 1156840 + 768 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[gb + 1156840 + (i5 * 12 | 0) >> 2] = HEAP32[gb + 1156840 + (i1 * 12 | 0) >> 2];
   HEAP32[gb + 1156840 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[gb + 1156840 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[gb + 1156840 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[gb + 1156840 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[gb + 1156840 + 768 >> 2] | 0) >>> 0);
 } while (0);
 __Z18CleanupHaloManagerv();
 i1 = HEAP32[gb + 1112268 >> 2] | 0;
 if (!i1) {
  HEAP32[gb + 1112268 >> 2] = 0;
  return;
 }
 __ZN13RenderManagerD2Ev(i1);
 __ZdlPv(i1);
 HEAP32[gb + 1112268 >> 2] = 0;
 return;
}

function __ZN11KeyframeTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034360 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034365 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034371 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034379 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z29Animator_CUSTOM_GetBoolStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 12 | 0;
 i5 = i7 + 16 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator7GetBoolEiRb(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i5) | 0;
 if ((i1 | 0) == 1) {
  i6 = HEAP8[i5 >> 0] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i6 = HEAP8[i5 >> 0] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z20ReadObjectFromVectorILb0EEvR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 72 | 0;
 i7 = i5 + 8 | 0;
 i10 = i5;
 HEAP32[i4 >> 2] = gb + 67168 + 8;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i6 = i7 + 16 | 0;
 __ZN12CachedReaderC2Ev(i6);
 __ZNK6Object14GetMemoryLabelEv(i10, i1);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = i3;
 i3 = i2 + 12 | 0;
 __ZN12CachedReader8InitReadER15CacheReaderBasejj(i6, i4, 0, HEAP32[i3 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i7 | 0);
 i2 = __ZN12CachedReader3EndEv(i6) | 0;
 if (i2 >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = gb + 67168 + 8;
  STACKTOP = i5;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467964 | 0, 0, gb + 467886 | 0, 100, 1, 0, 0, 0);
 HEAP32[i4 >> 2] = gb + 67168 + 8;
 STACKTOP = i5;
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE(i1, i13, i9, i5, i4, i3, i2) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = HEAP32[i2 >> 2] | 0;
 i11 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i3 >> 2] | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i2 = HEAP32[i13 + 372 >> 2] | 0;
 if (i2 | 0 ? i1 >>> 0 < (HEAP32[i9 + 4 >> 2] | 0) >>> 0 : 0) _memcpy(i1 | 0, HEAP32[i13 + 368 >> 2] | 0, i2 << 4 | 0) | 0;
 i1 = HEAP32[i13 + 360 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0 & (i1 | 0) != 0) _memcpy(i4 | 0, HEAP32[i13 + 356 >> 2] | 0, i1 << 3 | 0) | 0;
 i1 = HEAP32[i13 + 408 >> 2] | 0;
 if (i7 >>> 0 < i6 >>> 0 & (i1 | 0) != 0) _memcpy(i7 | 0, HEAP32[i13 + 404 >> 2] | 0, i1 << 4 | 0) | 0;
 i1 = HEAP32[i13 + 396 >> 2] | 0;
 if (i10 >>> 0 < i8 >>> 0 & (i1 | 0) != 0) _memcpy(i10 | 0, HEAP32[i13 + 392 >> 2] | 0, i1 << 2 | 0) | 0;
 i1 = HEAP32[i13 + 432 >> 2] | 0;
 if (!(i12 >>> 0 < i11 >>> 0 & (i1 | 0) != 0)) return;
 _memcpy(i12 | 0, HEAP32[i13 + 428 >> 2] | 0, i1 * 12 | 0) | 0;
 return;
}

function __ZNK16MemoryFileSystem8IsHiddenERK13FileEntryData(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 + 16 >> 2] & 4 | 0) != 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i8 = _strtoul(i1, i4, 10) | 0;
 i1 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i2 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i3 = _strtoul(HEAP32[i4 >> 2] | 0, 0, 10) | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i7 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN18AsyncUploadManager15DoDeCruncherJobEP28FileTextureUploadInstruction(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i1 = i5 + 8 | 0;
 i11 = i5;
 i3 = i2 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 i4 = i2 + 64 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i10 = HEAP32[i2 + 68 >> 2] | 0;
 i9 = HEAP32[i2 + 36 >> 2] | 0;
 i8 = HEAP32[i2 + 40 >> 2] | 0;
 i14 = gb + 64024 | 0;
 i13 = HEAP32[i14 + 4 >> 2] | 0;
 i12 = i11;
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i12 + 4 >> 2] = i13;
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 i6 = __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId(i10, i1, i2 + 60 | 0, i7 & 255, i9, i8, (i7 & 245760 | 0) == 32768 ? 1 : 6, i6) | 0;
 HEAP32[i2 + 72 >> 2] = i6;
 if (!i6) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397888 | 0, 0, gb + 397649 | 0, 330, 1, 0, 0, 0);
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 if ((HEAP32[i4 >> 2] & 245760 | 0) != 65536) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i2 + 28 >> 2] = (i1 >>> 0) / 6 | 0;
 STACKTOP = i5;
 return;
}

function __ZL39InitializeTextRenderingScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 945765 | 0, 16) | 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[gb + 1467896 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 946881 | 0) | 0;
 i2 = HEAP32[gb + 1467896 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 i2 = i2 + 4 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 945895 | 0, gb + 945900 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945930 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 12 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945944 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 16 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945955 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 20 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 945966 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467896 >> 2] | 0) + 24 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN8TypeTree8AddChildEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP8[i9 + (i5 * 24 | 0) + 2 >> 0] = (HEAPU8[i9 + (i3 * 24 | 0) + 2 >> 0] | 0) + 1;
 HEAP32[i9 + (i5 * 24 | 0) + 8 >> 2] = 0;
 HEAP32[i9 + (i5 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i9 + (i5 * 24 | 0) + 16 >> 2] = -1;
 HEAP8[i9 + (i5 * 24 | 0) + 3 >> 0] = 0;
 HEAP16[i9 + (i5 * 24 | 0) >> 1] = 1;
 HEAP32[i9 + (i5 * 24 | 0) + 20 >> 2] = 0;
 HEAP32[i9 + (i5 * 24 | 0) + 12 >> 2] = -1;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc8BodyCore22disableInternalCachingEb(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (!i1) return;
 if (i2) {
  HEAP32[i3 + 140 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i3 + 128 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i3 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i3 + 136 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i3 + 120 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i3 + 124 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i3 + 112 >> 2] = HEAP32[i1 + 56 >> 2];
  HEAP32[i3 + 116 >> 2] = HEAP32[i1 + 60 >> 2];
  return;
 } else {
  i4 = i3 + 120 | 0;
  HEAP32[i1 + 48 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 52 >> 2] = HEAP32[i3 + 124 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i3 + 128 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i3 + 132 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i3 + 136 >> 2];
  HEAP32[i1 + 44 >> 2] = HEAP32[i3 + 140 >> 2];
  i2 = i3 + 112 | 0;
  HEAP32[i1 + 56 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 116 | 0;
  HEAP32[i1 + 60 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
  HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
  return;
 }
}

function __ZN5physx12NpWriteCheckC2EPNS_7NpSceneEPKcb(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i6 >> 2] = i3;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP8[i6 + 8 >> 0] = i2 & 1;
 i5 = i6 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 do if (!(__ZN5physx7NpScene10startWriteEb(i3, i2) | 0)) {
  i10 = HEAP32[i6 >> 2] | 0;
  i10 = (HEAP16[((HEAP32[i10 + 3388 >> 2] & 4 | 0) == 0 ? i10 + 1224 | 0 : i10 + 3364 | 0) >> 1] & 4096) == 0;
  i3 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
  if (i10) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 8, gb + 770829 | 0, 36, gb + 771120 | 0, i8);
   break;
  } else {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i3, 8, gb + 770829 | 0, 29, gb + 770903 | 0, i7);
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 3872 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i4);
 i6 = i1 + 28 | 0;
 if (!((HEAP32[i4 >> 2] & 33554432 | 0) != 0 & (HEAP8[i6 >> 0] | 0) == 0)) {
  i3 = i1 + 32 | 0;
  __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags(i4, i3, 0);
  __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv(i3);
 }
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 1 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i4;
  HEAP32[i1 >> 2] = i3;
  i1 = i4;
 }
 HEAP8[i6 >> 0] = i1;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN9Animation15ThreadedCleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i6 + 72 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i6 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i6);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i4 = i6 + 104 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 108 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   i3 = HEAP32[i1 >> 2] | 0;
   if (i3) {
    __ZN14AnimationStateD2Ev(i3);
    __ZdlPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
   }
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = i6 + 84 | 0;
 i2 = i6 + 96 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = i6 + 100 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 88 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i6 = i6 + 252 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1;
 return;
}

function __ZN8MaterialD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 67512 + 8;
 __ZN8Material15ThreadedCleanupEv(i1);
 i3 = i1 + 80 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 92 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 68 | 0, HEAP32[i1 + 72 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1 + 56 | 0, HEAP32[i1 + 60 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1 + 44 | 0, HEAP32[i1 + 48 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __ZN7mecanim15InvertValueMaskEPNS_14ValueArrayMaskE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 4 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i1 = 0;
  do {
   i5 = i3 + i1 | 0;
   HEAP8[i5 >> 0] = HEAP8[i5 >> 0] ^ 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (i3 | 0) {
  i2 = i4 + 12 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
  i1 = 0;
  do {
   i5 = i2 + i1 | 0;
   HEAP8[i5 >> 0] = HEAP8[i5 >> 0] ^ 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 20 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i1 = 0;
  do {
   i5 = i3 + i1 | 0;
   HEAP8[i5 >> 0] = HEAP8[i5 >> 0] ^ 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 28 | 0;
  i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
  i1 = 0;
  do {
   i5 = i3 + i1 | 0;
   HEAP8[i5 >> 0] = HEAP8[i5 >> 0] ^ 1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i3 = HEAP32[i4 + 32 >> 2] | 0;
 if (!i3) return;
 i2 = i4 + 36 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 0;
 do {
  i5 = i2 + i1 | 0;
  HEAP8[i5 >> 0] = HEAP8[i5 >> 0] ^ 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN29BillboardTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 276 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i7 = -1;
  return i7 | 0;
 }
 i7 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i3 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 + 24 | 0) >>> 0 > (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i3, 32768);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i3 = (HEAP32[i3 >> 2] | 0) + i1 | 0;
 HEAP32[i2 >> 2] = i1 + 24;
 HEAP32[i4 + (i7 * 360 | 0) + 328 >> 2] = i3;
 HEAP32[i4 + (i7 * 360 | 0) + 332 >> 2] = fb + 219;
 HEAP32[i4 + (i7 * 360 | 0) + 344 >> 2] = fb + 2414;
 HEAP32[i4 + (i7 * 360 | 0) + 348 >> 2] = 1;
 HEAP32[i4 + (i7 * 360 | 0) + 340 >> 2] = fb + 517;
 HEAP32[i3 >> 2] = __ZNK14BillboardAsset20AcquireBillboardDataEv(HEAP32[i6 >> 2] | 0) | 0;
 i6 = HEAP32[i5 + 296 >> 2] | 0;
 i2 = HEAP32[i5 + 288 >> 2] | 0;
 i4 = HEAP32[i5 + 292 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 284 >> 2];
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 12 >> 2] = i4;
 HEAP32[i3 + 16 >> 2] = i6;
 HEAP32[i3 + 20 >> 2] = 0;
 return i7 | 0;
}

function __ZN13MonoBehaviour10SmartResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 264 | 0;
 i3 = i9 + 256 | 0;
 i4 = i9 + 16 | 0;
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i2 + 20 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (__Z14IsWorldPlayingv() | 0) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i6, i1, gb + 587833 | 0, 4);
 if (HEAP32[i6 >> 2] | 0) {
  i1 = i6;
  i10 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i6 = i5;
  HEAP32[i6 >> 2] = i10;
  HEAP32[i6 + 4 >> 2] = i1;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i7, i8);
  HEAP8[i4 + 233 >> 0] = 1;
  HEAP32[i4 + 216 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i4);
  __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i4, i3) | 0;
 }
 STACKTOP = i9;
 return;
}

function __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 12 | 0;
 i5 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = i4 + 32;
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37316 >> 2] | 0, i5, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i4 + 24 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i2, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i2 + (~(((i2 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS2_(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i11 + 20 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i1 = 0; else {
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i9 << 2 | 0, HEAP32[i11 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i5 = i11 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + (i6 << 2) | 0;
 i8 = i11 + 12 | 0;
 if ((i6 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i11 = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i4 >> 2] = i9;
  i10 = i11 + 1 | 0;
  HEAP32[i5 >> 2] = i10;
  i11 = i1 + (i11 << 2) | 0;
  return i11 | 0;
 }
 i11 = HEAP32[i11 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 12 >> 2] | 0, i11 | 0, HEAP32[i8 >> 2] | 0);
 i11 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i4 >> 2] = i9;
 i10 = i11 + 1 | 0;
 HEAP32[i5 >> 2] = i10;
 i11 = i1 + (i11 << 2) | 0;
 return i11 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 148; else i1 = (HEAP32[i1 >> 2] | 0) + 148 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj626ENS_22PxRepXPropertyAccessorILj626ES4_KjjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj625ENS_22PxRepXPropertyAccessorILj625ES4_KjjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP8[i1 + 264 >> 0] = 1;
 HEAP32[i1 + 268 >> 2] = i1 + 8;
 HEAP32[i1 + 276 >> 2] = 64;
 HEAP32[i1 + 280 >> 2] = 32;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP32[i1 + 292 >> 2] = 1536;
 i2 = i1 + 296 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAPF32[i1 + 324 >> 2] = Math_fround(.75);
 HEAP32[i1 + 328 >> 2] = -1;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 336 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i1 + 300 | 0, 64);
 i2 = i1 + 340 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 364 >> 2] = Math_fround(.75);
 HEAP32[i1 + 368 >> 2] = -1;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj(i2, 64);
 return;
}

function __ZN14GfxContextGLES10InvalidateER7ApiGLES(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i7 + 4 | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i5 = i7 + 12 | 0;
  HEAP32[i5 >> 2] = 0;
  i7 = i7 + 16 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i2 = i1;
 while (1) {
  i10 = HEAP32[i2 + 20 >> 2] | 0;
  __ZN18GfxFramebufferGLES10InvalidateEv(i10 + 8 | 0);
  i1 = HEAP32[gb + 1451080 >> 2] | 0;
  i10 = i10 + 532 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i3;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN7ApiGLES15BindVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE(i1, i5);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 i10 = i7 + 12 | 0;
 HEAP32[i10 >> 2] = 0;
 i10 = i7 + 16 | 0;
 HEAP32[i10 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function _tt_cmap13_next(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 28 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 L1 : do if ((i3 | 0) != -1) {
  i8 = i5 + 36 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i5 + 40 >> 2] | 0;
  if (i2 >>> 0 < i9 >>> 0) {
   i6 = (HEAP32[i5 + 16 >> 2] | 0) + 16 | 0;
   i4 = i1 + 16 | 0;
   i1 = i2;
   i3 = i3 + 1 | 0;
   while (1) {
    i2 = i6 + (i1 * 12 | 0) + 4 | 0;
    i11 = i2 + -4 | 0;
    i11 = (HEAPU8[i11 + 1 >> 0] | 0) << 16 | (HEAPU8[i11 >> 0] | 0) << 24 | (HEAPU8[i11 + 2 >> 0] | 0) << 8 | (HEAPU8[i11 + 3 >> 0] | 0);
    i2 = i2 + 4 | 0;
    i10 = i2 + -4 | 0;
    i2 = (HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0);
    i3 = i3 >>> 0 < i11 >>> 0 ? i11 : i3;
    if (!((i2 | 0) == 0 ? 1 : i3 >>> 0 > ((HEAPU8[i10 + 1 >> 0] | 0) << 16 | (HEAPU8[i10 >> 0] | 0) << 24 | (HEAPU8[i10 + 2 >> 0] | 0) << 8 | (HEAPU8[i10 + 3 >> 0] | 0)) >>> 0)) if (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i9 >>> 0) break L1;
   }
   HEAP32[i7 >> 2] = i3;
   HEAP32[i5 + 32 >> 2] = i2;
   HEAP32[i8 >> 2] = i1;
   return;
  }
 } while (0);
 HEAP8[i5 + 24 >> 0] = 0;
 return;
}

function __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = Math_imul(((HEAP32[i1 + 16 >> 2] | 0) - (HEAP32[i1 + 12 >> 2] | 0) | 0) >>> 3, HEAP32[i1 + 32 >> 2] | 0) | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP8[i1 + 29 >> 0] | 0;
 if (!i12) return;
 i4 = i11 + 12 | 0;
 i5 = i11 + 16 | 0;
 i6 = i11 + 4 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i4 >> 2] | 0;
  i8 = i7 + 1 | 0;
  i9 = HEAP32[i5 >> 2] | 0;
  i10 = i9 & 2147483647;
  do if (i8 >>> 0 > i10 >>> 0) {
   i2 = i9 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i10 >>> 0 < i2 >>> 0) if ((i9 | 0) > -1) {
    HEAP32[i5 >> 2] = i2;
    HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i2, 1, i6, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i6, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i10 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
    HEAP32[i5 >> 2] = i2;
    HEAP32[i11 >> 2] = i10;
    break;
   }
  } while (0);
  HEAP32[i4 >> 2] = i8;
  HEAP8[(HEAP32[i11 >> 2] | 0) + i7 >> 0] = i3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i12 | 0));
 return;
}

function __ZN5physx6shdfnd7FastIPCD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 1 | 0;
 i3 = i5;
 HEAP32[i4 >> 2] = gb + 151112 + 8;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 | 0) {
  if (!(HEAP8[i4 + 12 >> 0] | 0)) HEAP8[i1 + 1 >> 0] = 0; else HEAP8[i1 >> 0] = 0;
  i1 = HEAP32[i4 + 132 >> 2] | 0;
  if (i1 | 0) {
   __ZN5physx6shdfnd16MemoryMappedFileD2Ev(i1);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  }
 }
 i1 = HEAP32[i4 + 100 >> 2] | 0;
 if (i1 | 0) do {
  i6 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i6 + 28 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i6);
 } while ((i1 | 0) != 0);
 if (HEAP8[i4 + 120 >> 0] | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i4 + 72 >> 2] | 0);
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 if (i1 | 0) do {
  i6 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i6 + 28 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i6);
 } while ((i1 | 0) != 0);
 if (!(HEAP8[i4 + 68 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i4 + 20 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 * 12 | 0;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 832684 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj650ENS_22PxRepXPropertyAccessorILj650ES4_KjjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i2 | 0, i3 | 0, 400, (i4 ? gb + 683622 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 3739) | 0;
 __ZN5physx2Sc17ParticleSystemSimC2ERNS0_5SceneERNS0_18ParticleSystemCoreE(i4, i6, i5);
 if (!i4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 680241 | 0, 3743, gb + 683752 | 0, i7);
  STACKTOP = i7;
  return;
 }
 i2 = i6 + 132 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 136 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 140 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx19PxcScratchAllocatorC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i2 | 0, i1 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i5 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i2 = i5 + 4 | 0;
 i3 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, 64);
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i5 + 12 >> 2] & 2147483647;
 HEAP32[i4 >> 2] = 0;
 if (i7 >>> 0 > i1 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  HEAP32[i3 >> 2] = i1 + 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i2, i4) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 i5 = i2 + 16 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 844257 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 16 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN19StreamedBinaryWriteILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i9, i1, i2, i10, i3, i4) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i4 = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = i4;
 i7 = i9 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i9 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = _llvm_bswap_i32(HEAP32[i10 + 4 >> 2] | 0) | 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  i10 = i10 + 8 | 0;
  __ZN19StreamedBinaryWriteILb1EE8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i9, i10, gb + 898362 | 0, 0);
  STACKTOP = i8;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i10 = i10 + 8 | 0;
  __ZN19StreamedBinaryWriteILb1EE8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i9, i10, gb + 898362 | 0, 0);
  STACKTOP = i8;
  return;
 }
}

function __ZN17PersistentManager22GetFromActivationQueueEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i2 = i7;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP16[gb + 1165920 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165920 | 0, i3);
  i6 = gb + 1165920 | 0;
 } else i6 = 0;
 if ((HEAP32[i4 + 176 >> 2] | 0) == (HEAP32[i4 + 120 >> 2] | 0)) {
  i2 = HEAP32[i4 + 168 >> 2] | 0;
  i3 = HEAP32[i4 + 172 >> 2] | 0;
  i1 = i2 + (i3 * 20 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i3, i4 + 116 | 0, i5);
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i4 + 168 >> 2] | 0;
  i3 = HEAP32[i4 + 172 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 * 20 | 0) | 0 : i2 + (i1 * 20 | 0) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 * 20 | 0) | 0)) i1 = 0; else i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i6) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i7;
 return i1 | 0;
}

function __Z26Resources_CUSTOM_LoadAsyncP12Il2CppStringP12Il2CppObject(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallString6ToUTF8Ev(i6, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i6);
 i8 = HEAP8[i5 + 11 >> 0] | 0;
 i2 = i8 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i5 >> 2] | 0 : i5;
 i8 = i2 ? HEAP32[i5 + 4 >> 2] | 0 : i8 & 255;
 i2 = i1 + i8 | 0;
 if (i8 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i2 = __ZN21LoadResourceOperation12LoadResourceERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i8 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 324 >> 2] | 0) | 0;
 i6 = __ZN11ICallString18GetScriptingStringEv(i4) | 0;
 HEAP32[i8 + 8 >> 2] = i2;
 HEAP32[i8 + 12 >> 2] = i6;
 HEAP32[i8 + 16 >> 2] = i3;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh(i8, i2, i7) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if ((i3 - i1 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP8[i1 >> 0] = HEAP8[i7 >> 0] | 0;
   i1 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
   HEAP32[i10 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i8 >> 2] | 0;
 i5 = i1 - i4 + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i3 = HEAP32[i9 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else i5 = __Znwj(i3) | 0;
 i6 = i5 + (i1 - i4) | 0;
 i5 = i5 + i3 | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP8[i1 >> 0] = HEAP8[i7 >> 0] | 0;
  i1 = i4 + 1 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = (HEAP32[i10 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i10 >> 2] = i4;
 HEAP32[i9 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN8JSONRead8TransferIyEEvRT_PKc17TransferMetaFlagsb(i4, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i4 + 36 | 0;
 HEAP8[i10 >> 0] = 0;
 if (!((i3 & 524288 | 0) == 0 | (HEAP32[i4 >> 2] & 2 | 0) == 0)) return;
 i8 = i4 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  if (!i9) return;
  if ((HEAP32[i9 + 16 >> 2] | 0) != 3) return;
 }
 i2 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i4, i9, i2) | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = i4 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37296 >> 2];
 if (i2 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i4, i3);
  i3 = i4 + 56 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if (!(HEAP32[(HEAP32[i4 + 44 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 2] & 16777216)) {
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = i4;
  } else {
   if (!(HEAP32[i2 + 16 >> 2] & 4194304)) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
   __Z16HexStringToBytesPKcjPv(i1, 8, i7);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP8[i10 >> 0] = 1;
  HEAP32[i3 >> 2] = i1 + -1;
 }
 HEAP32[i8 >> 2] = i9;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb(i4, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i4 + 36 | 0;
 HEAP8[i10 >> 0] = 0;
 if (!((i3 & 524288 | 0) == 0 | (HEAP32[i4 >> 2] & 2 | 0) == 0)) return;
 i8 = i4 + 40 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  if (!i9) return;
  if ((HEAP32[i9 + 16 >> 2] | 0) != 3) return;
 }
 i2 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i4, i9, i2) | 0;
 HEAP32[i8 >> 2] = i2;
 i5 = i4 + 20 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 37248 >> 2];
 if (i2 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i4, i3);
  i3 = i4 + 56 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if (!(HEAP32[(HEAP32[i4 + 44 >> 2] | 0) + (i1 + -1 << 3) + 4 >> 2] & 16777216)) {
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i7 + 4 >> 2] = i4;
  } else {
   if (!(HEAP32[i2 + 16 >> 2] & 4194304)) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
   __Z16HexStringToBytesPKcjPv(i1, 8, i7);
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP8[i10 >> 0] = 1;
  HEAP32[i3 >> 2] = i1 + -1;
 }
 HEAP32[i8 >> 2] = i9;
 HEAP32[i5 >> 2] = i6;
 return;
}

function __ZN5physx3Scb5Scene15removeAggregateERNS0_9AggregateE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i4 = i7;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  __ZN5physx2Sc5Scene15deleteAggregateEj(i1 + 16 | 0, HEAP32[i6 + 16 >> 2] | 0);
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 2780 | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i2 >> 2] = i3 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = i3 | -1073741824;
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i4 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i4, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj657ENS_22PxRepXPropertyAccessorILj657ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj656ENS_22PxRepXPropertyAccessorILj656ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj648ENS_22PxRepXPropertyAccessorILj648ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj647ENS_22PxRepXPropertyAccessorILj647ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx31PxParticleReadDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773127;
 HEAP32[i1 + 4 >> 2] = 378;
 HEAP32[i1 + 8 >> 2] = fb + 2271;
 HEAP32[i1 + 12 >> 2] = fb + 3659;
 HEAP32[i1 + 16 >> 2] = gb + 773144;
 HEAP32[i1 + 20 >> 2] = 379;
 HEAP32[i1 + 24 >> 2] = fb + 2272;
 HEAP32[i1 + 28 >> 2] = fb + 3660;
 HEAP32[i1 + 32 >> 2] = gb + 773163;
 HEAP32[i1 + 36 >> 2] = 380;
 HEAP32[i1 + 40 >> 2] = fb + 2273;
 HEAP32[i1 + 44 >> 2] = fb + 3661;
 HEAP32[i1 + 48 >> 2] = gb + 773183;
 HEAP32[i1 + 52 >> 2] = 381;
 HEAP32[i1 + 56 >> 2] = fb + 3662;
 HEAP32[i1 + 60 >> 2] = fb + 3663;
 HEAP32[i1 + 64 >> 2] = gb + 773198;
 HEAP32[i1 + 68 >> 2] = 382;
 HEAP32[i1 + 72 >> 2] = fb + 3664;
 HEAP32[i1 + 76 >> 2] = fb + 3665;
 HEAP32[i1 + 80 >> 2] = gb + 773213;
 HEAP32[i1 + 84 >> 2] = 383;
 HEAP32[i1 + 88 >> 2] = fb + 3666;
 HEAP32[i1 + 92 >> 2] = fb + 3667;
 HEAP32[i1 + 96 >> 2] = gb + 773230;
 HEAP32[i1 + 100 >> 2] = 384;
 HEAP32[i1 + 104 >> 2] = fb + 3668;
 HEAP32[i1 + 108 >> 2] = fb + 3669;
 HEAP32[i1 + 112 >> 2] = gb + 773242;
 HEAP32[i1 + 116 >> 2] = 385;
 HEAP32[i1 + 120 >> 2] = fb + 3670;
 HEAP32[i1 + 124 >> 2] = fb + 3671;
 HEAP32[i1 + 128 >> 2] = gb + 773264;
 HEAP32[i1 + 132 >> 2] = 386;
 HEAP32[i1 + 136 >> 2] = fb + 3672;
 HEAP32[i1 + 140 >> 2] = fb + 3673;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold25addBatchManifoldContacts2EPKNS0_17PersistentContactEj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 if (i4 >>> 0 >= 3) {
  __ZN5physx2Gu25PersistentContactManifold20reduceBatchContacts2EPKNS0_17PersistentContactEj(i5, i3, i4);
  HEAP8[i5 + 32 >> 0] = 2;
  return;
 }
 if (i4 | 0) {
  i1 = i5 + 44 | 0;
  i2 = 0;
  do {
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) | 0;
   i7 = i3 + (i2 * 48 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 16 | 0;
   i7 = i3 + (i2 * 48 | 0) + 16 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 32 | 0;
   i7 = i3 + (i2 * 48 | 0) + 32 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 HEAP8[i5 + 32 >> 0] = i4;
 return;
}

function __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800780 | 0, i5, i1 + 80 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800793 | 0, i5, i1 + 84 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800723 | 0, i5, i1 + 88 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 738044 | 0, i5, i1 + 89 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl22setNamedPropertyValuesEN5physx8debugger7DataRefINS2_10NamedValueEEENS2_18NonNegativeIntegerE(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP32[i2 + 152 >> 2] | 0) <= (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[(HEAP32[i2 + 148 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 i4 = i5 + 4 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) >> 3;
 HEAP32[i3 >> 2] = gb + 1576256;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i2 + 52 | 0, i1, i3);
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 i3 = i2 + 64 | 0;
 i2 = 0;
 do {
  i9 = i1 + (i2 << 3) | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i7 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = i8;
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) - i1 >> 3 >>> 0);
 STACKTOP = i6;
 return;
}

function __Z15MoveReplaceFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 16 | 0;
 i7 = i6 + 4 | 0;
 i8 = __Z13GetFileSystemv() | 0;
 i4 = i1 + 11 | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i7, i8, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i7 = __ZNK15FileSystemEntry12FolderExistsEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 if (i7) {
  HEAP32[i5 >> 2] = (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  __Z6FormatPKcz(i3, gb + 488591 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 488614 | 0, 284, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 } else {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i2;
  i8 = __ZN24MoveReplaceFileOperation7ExecuteEv(i3) | 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 return 0;
}

function _openpty(i9, i10, i1, i11, i12) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14 + 40 | 0;
 i8 = i14 + 32 | 0;
 i7 = i14 + 24 | 0;
 i6 = i14 + 16 | 0;
 i5 = i14 + 8 | 0;
 i2 = i14 + 44 | 0;
 i3 = i14 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 i4 = _open(gb + 1073916 | 0, 258, i14) | 0;
 HEAP32[i9 >> 2] = i4;
 do if ((i4 | 0) < 0) i1 = -1; else {
  HEAP32[i5 >> 2] = i2;
  if (!(_ioctl(i4, 1074025521, i5) | 0)) {
   i5 = HEAP32[i9 >> 2] | 0;
   HEAP32[i6 >> 2] = i2;
   if (!(_ioctl(i5, -2147199952, i6) | 0)) {
    i1 = (i1 | 0) == 0 ? i3 : i1;
    HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
    _snprintf(i1, 20, gb + 1073904 | 0, i7) | 0;
    i1 = _open(i1, 258, i8) | 0;
    HEAP32[i10 >> 2] = i1;
    if ((i1 | 0) < 0) {
     _close(HEAP32[i9 >> 2] | 0) | 0;
     i1 = -1;
     break;
    }
    if (i11 | 0) _tcsetattr(i1, 0, i11) | 0;
    if (!i12) {
     i1 = 0;
     break;
    }
    i1 = HEAP32[i10 >> 2] | 0;
    HEAP32[i13 >> 2] = i12;
    _ioctl(i1, 21524, i13) | 0;
    i1 = 0;
    break;
   }
  }
  _close(HEAP32[i9 >> 2] | 0) | 0;
  i1 = -1;
 } while (0);
 STACKTOP = i14;
 return i1 | 0;
}

function __ZNSt3__26vectorIP4NodeNS_9allocatorIS2_EEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (i3 - i1 >> 2 >>> 0 >= i2 >>> 0) {
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 4 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = (i1 - i4 >> 2) + i2 | 0;
 if (i5 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 >> 1;
 i3 = i6 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 1073741823;
 if (!i3) i5 = 0; else i5 = __Znwj(i3 << 2) | 0;
 i6 = i5 + (i1 - i4 >> 2 << 2) | 0;
 i5 = i5 + (i3 << 2) | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i4 + 4 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - (i3 >> 2) << 2) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i6 = i5 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i2 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i6 >> 2] = i3;
  i1 = i2;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j(i4, i1);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
  i1 = i1 + 872 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4 + 12 | 0, i5);
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  STACKTOP = i8;
  return;
 }
}

function __ZN6prcore10FlipImageYER14ImageReference(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (!((i4 | 0) != 0 & (i2 | 0) != 0 & (i1 | 0) != 0)) return;
 i6 = i3 + 12 | 0;
 i5 = Math_imul(HEAP32[i6 >> 2] | 0, i2 + -1 | 0) | 0;
 i2 = i1 + i5 | 0;
 i3 = __Z20GetTextureFormatInfo13TextureFormat(HEAP32[i3 >> 2] | 0) | 0;
 L4 : do if (!(HEAP8[i3 + 2 >> 0] | 0)) {
  if (HEAP8[i3 + 1 >> 0] | 0) {
   i3 = (Math_imul(HEAP32[i3 + 4 >> 2] | 0, i4) | 0) >>> 2;
   i4 = fb + 519 | 0;
   break;
  }
  if (!(HEAP8[i3 >> 0] | 0)) {
   i3 = 0;
   i4 = 0;
  } else switch (HEAP32[i3 + 4 >> 2] | 0) {
  case 1:
   {
    i3 = i4;
    i4 = fb + 520 | 0;
    break L4;
   }
  case 2:
   {
    i3 = i4;
    i4 = fb + 518 | 0;
    break L4;
   }
  case 3:
   {
    i3 = i4;
    i4 = fb + 521 | 0;
    break L4;
   }
  case 4:
   {
    i3 = i4;
    i4 = fb + 519 | 0;
    break L4;
   }
  default:
   return;
  }
 } else {
  i3 = (Math_imul(HEAP32[i3 + 4 >> 2] | 0, i4) | 0) >>> 1;
  i4 = fb + 518 | 0;
 } while (0);
 if ((i5 | 0) <= 0) return;
 do {
  mftCall_viii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
  i5 = HEAP32[i6 >> 2] | 0;
  i1 = i1 + i5 | 0;
  i2 = i2 + (0 - i5) | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __ZN6Camera12RenderSkyboxEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32816 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if ((HEAP32[i1 + 844 >> 2] | 0) != 1) {
  STACKTOP = i4;
  return;
 }
 i3 = __ZNK6Camera17GetSkyboxMaterialEv(i1) | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __ZN15RenderNodeQueueC2ERK10MemLabelId(i2, gb + 64016 | 0);
 i6 = HEAP32[gb + 1166248 >> 2] | 0;
 i7 = i1 + 1136 | 0;
 i5 = i1 + 4 | 0;
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i7, 14, i6, i2, gb + 1159956 | 0, HEAP32[i5 >> 2] | 0);
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i7, 14, i6, i2, gb + 1159956 | 0, HEAP32[i5 >> 2] | 0);
 __ZN6Skybox12RenderSkyboxEP8MaterialRK6Camera(i3, i1);
 __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i7, 15, i6, i2, gb + 1159956 | 0, HEAP32[i5 >> 2] | 0);
 __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i7, 15, i6, i2, gb + 1159956 | 0, HEAP32[i5 >> 2] | 0);
 __ZN15RenderNodeQueueD2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 682928 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i7 = HEAPU16[i2 >> 1] | HEAPU16[i2 + 2 >> 1] << 16;
   HEAP16[i1 >> 1] = i7;
   HEAP16[i1 + 2 >> 1] = i7 >>> 16;
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5Unity9Component16CheckConsistencyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 4 | 0;
 i6 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i6 + 40 >> 2] | 0;
 L4 : do if ((i2 | 0) > 0) {
  i3 = HEAP32[i6 + 28 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) break L4;
  }
  STACKTOP = i8;
  return;
 } while (0);
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i4 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 __Z6FormatPKcz(i5, gb + 369415 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 368833 | 0, 1172, 1, HEAP32[i6 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE(i6, i4);
 STACKTOP = i8;
 return;
}

function __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034504 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034510 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i6, 4);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 4 | 0, gb + 944890 | 0, 0);
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 20 | 0, gb + 944893 | 0, 0);
 i1 = i6 + 36 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 56 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __Z31SetShapeLocalPoseAndWakeUpActorPN5physx7PxShapeEPNS_12PxRigidActorERK10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i4 + 32 | 0;
 i5 = i4;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0;
 __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i3, i12);
 i8 = HEAP32[i3 + 48 >> 2] | 0;
 i7 = HEAP32[i3 + 52 >> 2] | 0;
 i3 = HEAP32[i3 + 56 >> 2] | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = HEAP32[i12 + 8 >> 2] | 0;
 i9 = HEAP32[i12 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i5 + 4 >> 2] = i11;
 HEAP32[i5 + 8 >> 2] = i10;
 HEAP32[i5 + 12 >> 2] = i9;
 HEAP32[i5 + 16 >> 2] = i8;
 HEAP32[i5 + 20 >> 2] = i7;
 HEAP32[i5 + 24 >> 2] = i3;
 mftCall_vii(i6 | 0, i1 | 0, i5 | 0);
 if ((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 5) {
  STACKTOP = i4;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0) | 0) & 1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE16__construct_nodeERKS3_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 4 | 0;
 if (!(HEAP8[gb + 1098032 >> 0] | 0)) {
  i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
  i8 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63696 | 0, 16, gb + 1018169 | 0, 144) | 0;
  i11 = gb + 63696 | 0;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  i9 = i4;
  HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i9 + 4 >> 2] = i10;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i8, 1, gb + 1018240 | 0, 20, 32768, i5, 16);
  HEAP32[gb + 1114548 >> 2] = i8;
  __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i8);
  if (i7) __Z19pop_allocation_rootv();
  i11 = gb + 1098032 | 0;
  HEAP32[i11 >> 2] = 1;
  HEAP32[i11 + 4 >> 2] = 0;
 }
 i11 = __ZN10MemoryPool8AllocateEj(HEAP32[gb + 1114548 >> 2] | 0, 20) | 0;
 HEAP32[i11 + 16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 >> 2] = i11;
 i11 = i2 + 4 | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = 1;
 STACKTOP = i6;
 return;
}

function __ZNSt3__219__thread_struct_impD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 12 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) break;
  __ZNSt3__25mutex6unlockEv(HEAP32[i1 + 4 >> 2] | 0);
  __ZNSt3__218condition_variable10notify_allEv(HEAP32[i1 >> 2] | 0);
  i1 = i1 + 8 | 0;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 6;
   break;
  }
  __THREW__ = 0;
  invoke_vi(fb + 4012 | 0, HEAP32[i1 >> 2] | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i1 = 9;
   break;
  }
  __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
  i1 = i1 + 4 | 0;
 }
 if ((i1 | 0) == 6) {
  __ZNSt3__213__vector_baseINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEED2Ev(i4);
  __ZNSt3__213__vector_baseIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEED2Ev(i3);
  return;
 } else if ((i1 | 0) == 9) {
  i5 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__213__vector_baseINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEED2Ev(i4);
  __ZNSt3__213__vector_baseIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEED2Ev(i3);
  ___clang_call_terminate(i5);
 }
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findERKS5_j(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 i9 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i10 = i8 ? HEAP32[i4 >> 2] | 0 : i4;
 i4 = i8 ? HEAP32[i4 + 4 >> 2] | 0 : i9 & 255;
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + (i2 << 2) | 0;
  i8 = i10 + (i4 << 2) | 0;
  i1 = i3 + (i1 << 2) | 0;
  i7 = i9;
  i2 = i4 << 2 >> 2;
  L8 : do if (i2) if ((i7 - i1 >> 2 | 0) < (i2 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i2 << 2) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L8;
     }
     if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 4 | 0;
    }
    do {
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break L8;
     i4 = i4 + 4 | 0;
    } while ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 >> 2] | 0));
    i1 = i5 + 4 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 >> 2;
 }
 return i1 | 0;
}

function __ZN7mecanim9animation21BlendTreeNodeConstant35Transfer_4_0_BackwardsCompatibilityI14SafeBinaryReadEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 12 | 0;
 i6 = i7;
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i5, 1) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i1 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = i5 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i8 = i2;
  i1 = i1 | 0 ? i1 - i8 | 0 : 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i8;
 } else i3 = i5 + 4 | 0;
 i8 = i1 + i2 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 >> 2] = i8 + 4;
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i6 + 8 >> 2] = i1;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 903818 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i5, i6, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 STACKTOP = i7;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj561ENS_22PxRepXPropertyAccessorILj561ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 if (i4 >>> 0 >= 5) {
  __ZN5physx2Gu25PersistentContactManifold19reduceBatchContactsEPKNS0_17PersistentContactEj(i5, i3, i4);
  HEAP8[i5 + 32 >> 0] = 4;
  return;
 }
 if (i4 | 0) {
  i1 = i5 + 44 | 0;
  i2 = 0;
  do {
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) | 0;
   i7 = i3 + (i2 * 48 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 16 | 0;
   i7 = i3 + (i2 * 48 | 0) + 16 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i6 = (HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) + 32 | 0;
   i7 = i3 + (i2 * 48 | 0) + 32 | 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 HEAP8[i5 + 32 >> 0] = i4;
 return;
}

function __ZN17ProceduralTexture14OnSyncMaterialER21ProceduralTextureData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 208 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i1 + 160 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 152 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 156 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 168 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 172 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 176 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 164 >> 2] = HEAP32[i2 + 12 >> 2];
 i3 = i2 + 40 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = i1 + 192 | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = i2 + 48 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i1 + 200 | 0;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 i3 = HEAP16[i2 + 28 >> 1] | 0;
 HEAP8[i1 + 180 >> 0] = i3;
 HEAP8[i1 + 181 >> 0] = (i3 & 65535) >>> 8;
 HEAP32[i1 + 184 >> 2] = HEAP32[i2 + 32 >> 2];
 i3 = i1 + 212 | 0;
 HEAP8[i3 >> 0] = HEAP8[i2 + 60 >> 0] | 0;
 HEAP32[i1 + 216 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i6 >> 2] = i7;
 HEAP32[i4 >> 2] = i5;
 if (!(HEAP8[i1 + 224 >> 0] | 0)) {
  i9 = 0;
  HEAP8[i3 >> 0] = i9;
  return;
 }
 i9 = (HEAP32[i1 + 88 >> 2] | 0) != 0 & 1;
 HEAP8[i3 >> 0] = i9;
 return;
}

function __ZN10MonoScript8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i3 = i1 + 64 | 0;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i7 = i2 + 24 | 0;
 if (i5 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i3, 4); else {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 >> 2] = i5;
 }
 __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 72 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 92 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 108 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 124 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i1 = i1 + 140 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 }
}

function __Z53PhysicMaterial_CUSTOM_Internal_CreateDynamicsMaterialP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 782106 | 0, 3727) | 0;
 i9 = gb + 63520 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14PhysicMaterialC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
 __Z19pop_allocation_rootv();
 i2 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
 __Z16SmartResetObjectR6Object(i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) | 0;
 STACKTOP = i3;
 return;
}

function __Z15GetAllArgumentsv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj(i2, HEAP32[gb + 1170792 >> 2] | 0);
 if ((HEAP32[gb + 1170792 >> 2] | 0) <= 1) {
  STACKTOP = i7;
  return;
 }
 i6 = i2 + 8 | 0;
 i1 = 1;
 do {
  i4 = HEAP32[(HEAP32[gb + 1170796 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i4, _strlen(i4) | 0);
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i6 >> 2] | 0)) __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_(i2, i3); else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i3);
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 12;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[gb + 1170792 >> 2] | 0));
 STACKTOP = i7;
 return;
}

function _realpath(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 4304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 16 | 0;
 i8 = i10 + 8 | 0;
 i2 = i10;
 i5 = i10 + 96 | 0;
 i6 = i10 + 20 | 0;
 i3 = i10 + 4272 | 0;
 i7 = i10 + 176 | 0;
 do if (!i1) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 } else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = 2656256;
  i2 = ___syscall_ret(___syscall5(5, i2 | 0) | 0) | 0;
  if ((i2 | 0) < 0) i1 = 0; else {
   ___procfdname(i3, i2);
   i1 = _readlink(i3, i7, 4095) | 0;
   if ((i1 | 0) >= 0) {
    HEAP8[i7 + i1 >> 0] = 0;
    _fstat(i2, i5) | 0;
    i1 = _stat(i7, i6) | 0;
    if ((i1 | 0) >= 0) {
     if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i6 >> 2] | 0)) if ((HEAP32[i5 + 72 >> 2] | 0) == (HEAP32[i6 + 72 >> 2] | 0)) {
      HEAP32[i8 >> 2] = i2;
      ___syscall6(6, i8 | 0) | 0;
      if (!i4) {
       i1 = mftCall_ii(fb + 1576 | 0, i7 | 0) | 0;
       break;
      } else {
       i1 = _strcpy(i4, i7) | 0;
       break;
      }
     }
     if (!i1) HEAP32[(___errno_location() | 0) >> 2] = 40;
    }
   }
   HEAP32[i9 >> 2] = i2;
   ___syscall6(6, i9 | 0) | 0;
   i1 = 0;
  }
 } while (0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i2 = HEAP8[i7 + 24 >> 0] | 0;
 i8 = i2 & 255;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = i8;
 i4 = i6 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i8 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i8;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i8 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8 * 12 | 0, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i6 >> 2] = i5;
  break;
 } while (0);
 if (!(i2 << 24 >> 24)) return;
 i2 = i1 + 20 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i6 >> 2] | 0;
  i9 = (HEAP32[i2 >> 2] | 0) + ((HEAPU16[i7 + 12 + (i1 << 1) >> 1] | 0) * 12 | 0) | 0;
  i3 = HEAP32[i9 + 4 >> 2] | 0;
  i4 = HEAP32[i9 + 8 >> 2] | 0;
  HEAP32[i5 + (i1 * 12 | 0) >> 2] = HEAP32[i9 >> 2];
  HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = i3;
  HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = i4;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj532ENS_22PxRepXPropertyAccessorILj532ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN11Rigidbody2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 32 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(.0000999999974);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(.0000999999974) : f3;
 i1 = i2 + 36 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 40 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i2 + 44 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i1 = i2 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 2) HEAP32[i1 >> 2] = 0;
 i1 = i2 + 60 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 2) HEAP32[i1 >> 2] = 1;
 i1 = i2 + 64 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > 1) HEAP32[i1 >> 2] = 0;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 3) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z40AudioListener_CUSTOM_GetOutputDataHelperP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i7 + 8 | 0;
 i4 = i7 + 4 | 0;
 i5 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 if (!i5) {
  if (!(HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0)) {
   STACKTOP = i7;
   return;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 883752 | 0, 0, gb + 875076 | 0, 511, 1, 0, 0, 0);
  STACKTOP = i7;
  return;
 }
 i8 = (__ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE(i5, i3) | 0) == 0;
 do if (i8 & (HEAP32[i3 >> 2] | 0) != 0) {
  HEAP32[i4 >> 2] = 0;
  i8 = (i2 | 0) > -1 & (__ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i5, 0, 0, i4, 0, 0, 0) | 0) == 0;
  if (i8 & (HEAP32[i4 >> 2] | 0) > (i2 | 0)) {
   i6 = HEAP32[i3 >> 2] | 0;
   i8 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
   __ZN4FMOD12ChannelGroup11getWaveDataEPfii(i6, i8, __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0, i2) | 0;
   break;
  } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 883868 | 0, i6);
 } while (0);
 STACKTOP = i7;
 return;
}

function __Z28dtMergeCorridorStartShortcutPyiiPKyi(i11, i9, i10, i12, i8) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i13 = 0, i14 = 0;
 if ((i8 | 0) > 0) {
  i1 = -1;
  i5 = i9;
  i3 = -1;
 } else {
  i12 = i9;
  return i12 | 0;
 }
 do {
  if ((i5 | 0) <= 0) break;
  i5 = i5 + -1 | 0;
  i7 = i11 + (i5 << 3) | 0;
  i6 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = i8;
  i4 = 0;
  do {
   i13 = i2;
   i2 = i2 + -1 | 0;
   i14 = i12 + (i2 << 3) | 0;
   i14 = (i6 | 0) == (HEAP32[i14 >> 2] | 0) ? (i7 | 0) == (HEAP32[i14 + 4 >> 2] | 0) : 0;
   i3 = i14 ? i2 : i3;
   i4 = i4 | i14;
   i1 = i14 ? i5 : i1;
  } while ((i13 | 0) > 1);
 } while (!i4);
 if ((i3 | 0) < 1 | (i1 | 0) == -1) {
  i14 = i9;
  return i14 | 0;
 }
 i2 = i9 - i1 | 0;
 i2 = (i2 | 0) < 0 ? 0 : i2;
 i2 = (i2 + i3 | 0) > (i10 | 0) ? i10 - i3 | 0 : i2;
 if (i2 | 0) _memmove(i11 + (i3 << 3) | 0, i11 + (i1 << 3) | 0, i2 << 3 | 0) | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i10 = i12 + (i1 << 3) | 0;
   i13 = HEAP32[i10 + 4 >> 2] | 0;
   i14 = i11 + (i1 << 3) | 0;
   HEAP32[i14 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i14 + 4 >> 2] = i13;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i14 = i2 + i3 | 0;
 return i14 | 0;
}

function _compute_reciprocal(i2, i9) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(i2 << 16 >> 16)) i5 = 0; else {
  i5 = i2 & 65535;
  i6 = (i5 & 65280 | 0) == 0;
  i5 = i6 ? i5 << 8 & 65535 : i2;
  i6 = i6 ? 8 : 16;
  i7 = i5 & 65535;
  i8 = (i7 & 61440 | 0) == 0;
  i5 = i8 ? i7 << 4 & 65535 : i5;
  i6 = i8 ? i6 + -4 | 0 : i6;
  i8 = i5 & 65535;
  i7 = (i8 & 49152 | 0) == 0;
  i5 = (i7 ? i6 + -2 | 0 : i6) + ~((i7 ? i8 << 2 & 65535 : i5) << 16 >> 16 >> 15 << 16 >> 16) | 0;
 }
 i3 = i5 + 31 | 0;
 i4 = _bitshift64Shl(1, 0, i3 | 0) | 0;
 i8 = getTempRet0() | 0;
 i7 = i2 & 65535;
 i1 = ___udivdi3(i4 | 0, i8 | 0, i7 | 0, 0) | 0;
 i6 = getTempRet0() | 0;
 i7 = ___uremdi3(i4 | 0, i8 | 0, i7 | 0, 0) | 0;
 i8 = getTempRet0() | 0;
 i4 = (i2 & 65535) >>> 1;
 i2 = i4 & 65535;
 do if ((i7 | 0) == 0 & (i8 | 0) == 0) {
  i1 = _bitshift64Lshr(i1 | 0, i6 | 0, 1) | 0;
  getTempRet0() | 0;
  i3 = i5 + 30 | 0;
 } else if (i8 >>> 0 > 0 | (i8 | 0) == 0 & i7 >>> 0 > (i4 & 65535) >>> 0) {
  i1 = _i64Add(i1 | 0, i6 | 0, 1, 0) | 0;
  getTempRet0() | 0;
  break;
 } else {
  i2 = i2 + 1 | 0;
  break;
 } while (0);
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 256 >> 2] = i2;
 HEAP32[i9 + 512 >> 2] = 1 << 64 - i3;
 HEAP32[i9 + 768 >> 2] = i3 + -32;
 return (i3 | 0) > 16 | 0;
}

function __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_(i4, i2, i7, i6, i5, i8) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i9 = 0;
 i1 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) HEAP32[i7 >> 2] = i1;
 if (i5 | 0) if (!(mftCall_iiii(i5 | 0, i2 | 0, HEAP32[i6 >> 2] | 0, i8 | 0) | 0)) return;
 i3 = i2 + 16 | 0;
 i1 = i3;
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i9 | 0, i1 | 0, 21) | 0;
 getTempRet0() | 0;
 i2 = i2 & 524287;
 i1 = _bitshift64Lshr(i9 | 0, i1 | 0, 21) | 0;
 getTempRet0() | 0;
 if (i2) {
  __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_(i4, i4 + (i2 * 24 | 0) | 0, i7, i6, i5, i8);
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  i1 = i3;
  i1 = _bitshift64Lshr(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, 21) | 0;
  getTempRet0() | 0;
 }
 i1 = i1 & 524287;
 i1 = i1 | 0 ? i4 + ((i1 + 1 | 0) * 24 | 0) | 0 : i4;
 if ((i1 | 0) == (i4 | 0)) return; else {
  __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_(i4, i1, i7, i6, i5, i8);
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  return;
 }
}

function __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj(i10, i3, i2, i1, i4) {
 i10 = i10 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 12 | 0;
 i9 = i10 + 16 | 0;
 while (1) {
  if (HEAP8[(HEAP32[i8 >> 2] | 0) + i3 >> 0] | 0) {
   i1 = 8;
   break;
  }
  i5 = HEAP32[(HEAP32[i10 >> 2] | 0) + 4 >> 2] | 0;
  mftCall_viiiii(HEAP32[i9 >> 2] | 0, i10 | 0, i3 | 0, i2 | 0, i1 | 0, i4 | 0);
  i1 = HEAP32[i5 + (i3 * 12 | 0) >> 2] | 0;
  i2 = HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] | 0;
  i4 = HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2] | 0;
  i5 = i1 & 536870911;
  i6 = i2 & 536870911;
  i7 = i4 & 536870911;
  HEAP8[(HEAP32[i8 >> 2] | 0) + i3 >> 0] = 1;
  if ((i5 | 0) != 536870911) __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj(i10, i5, i3, i1 >>> 30, 0);
  if ((i6 | 0) != 536870911) __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj(i10, i6, i3, i2 >>> 30, 1);
  if ((i7 | 0) == 536870911) {
   i1 = 8;
   break;
  } else {
   i2 = i3;
   i1 = i4 >>> 30;
   i3 = i7;
   i4 = 2;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZNSt3__212__deque_baseI10InputEventNS_9allocatorIS1_EEE5clearEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i2 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = i2 + 16 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i4 = i1 + (((i3 >>> 0) / 78 | 0) << 2) | 0;
 i8 = i2 + 8 | 0;
 if ((HEAP32[i8 >> 2] | 0) == (i1 | 0)) {
  i6 = 0;
  i5 = i2 + 20 | 0;
  i1 = 0;
 } else {
  i5 = i2 + 20 | 0;
  i6 = i3 + (HEAP32[i5 >> 2] | 0) | 0;
  i6 = (HEAP32[i1 + (((i6 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i6 >>> 0) % 78 | 0) * 52 | 0) | 0;
  i1 = (HEAP32[i4 >> 2] | 0) + (((i3 >>> 0) % 78 | 0) * 52 | 0) | 0;
 }
 i2 = i4;
 L5 : while (1) {
  do {
   if ((i1 | 0) == (i6 | 0)) break L5;
   __ZN10InputEventD2Ev(i1);
   i1 = i1 + 52 | 0;
  } while ((i1 - (HEAP32[i2 >> 2] | 0) | 0) != 4056);
  i1 = i2 + 4 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i8 >> 2] | 0) - i2 >> 2;
 if (i1 >>> 0 > 2) do {
  __ZdlPv(HEAP32[i2 >> 2] | 0);
  i1 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  HEAP32[i7 >> 2] = i1;
  i2 = i1;
  i1 = (HEAP32[i8 >> 2] | 0) - i2 >> 2;
 } while (i1 >>> 0 > 2);
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i9 >> 2] = 39;
   return;
  }
 case 2:
  {
   HEAP32[i9 >> 2] = 78;
   return;
  }
 default:
  return;
 }
}

function __ZN8Material16SetComputeBufferEN9ShaderLab16FastPropertyNameE15ComputeBufferID(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i2 + 12 | 0, i8, i6, 0);
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i7, i6);
 STACKTOP = i12;
 return;
}

function __ZN5physx7NpScene24updateScbStateAndSetupSqERKNS_12PxRigidActorERNS_3Scb5ActorERNS_14NpShapeManagerEbPNS_9PxBounds3E(i1, i13, i2, i3, i11, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 3392 | 0;
 i9 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i9;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 1073741823 | -2147483648;
 i1 = HEAP16[i3 + 4 >> 1] | 0;
 i7 = i1 << 16 >> 16 == 1 ? i3 : HEAP32[i3 >> 2] | 0;
 if (!(i1 << 16 >> 16)) return;
 i8 = i3 + 8 | 0;
 i6 = i3 + 12 | 0;
 i1 = i1 & 65535;
 i5 = 0;
 do {
  i2 = i7 + (i5 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP8[i3 + 112 >> 0] | 0;
  __ZN5physx6shdfnd15atomicIncrementEPVi(i3 + 16 | 0) | 0;
  if (__ZNK5physx7NpShape11isExclusiveEv(i3) | 0) {
   HEAP32[i3 + 32 >> 2] = i9;
   i3 = i3 + 36 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & 1073741823 | -2147483648;
  }
  if (i4 & 2) {
   i4 = __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i10, HEAP32[i2 >> 2] | 0, i13, i11, i4 & 5 ? i12 + (i5 * 24 | 0) | 0 : 0) | 0;
   HEAP32[((HEAP16[i6 >> 1] | 0) == 1 ? i8 : HEAP32[i8 >> 2] | 0) + (i5 << 2) >> 2] = i4;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i1 | 0));
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj604ENS_22PxRepXPropertyAccessorILj604ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj292ENS_22PxRepXPropertyAccessorILj292ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj291ENS_22PxRepXPropertyAccessorILj291ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim20scheduleCollisionCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i2 = i8;
 i1 = i3 + 4 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i7, i9, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = 0;
  do {
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 56 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 i1 = __ZN5physx24PxsParticleSystemBatcher20scheduleCollisionCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE((HEAP32[i5 + 1e3 >> 2] | 0) + 324 | 0, HEAP32[i7 >> 2] | 0, i1, i4) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 if (!((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0)) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j(i5, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1 + 16 | 0, 1);
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcRK8UnityStr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = _strlen(i2) | 0;
 i11 = HEAP8[i3 + 11 >> 0] | 0;
 i8 = i11 << 24 >> 24 < 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = (i8 ? HEAP32[i3 + 4 >> 2] | 0 : i11 & 255) + i4 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i4 = i6 + 40 | 0;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 5;
 __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i6 + 16 | 0, i8 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 i11 = 1;
 STACKTOP = i7;
 return i11 | 0;
}

function __Z49MonoBehaviour_CUSTOM_StartCoroutine_Auto_InternalP12Il2CppObjectS0_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i4);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549110 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549110 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i6 = __ZN13MonoBehaviour22StartCoroutineManaged2EP12Il2CppObject(i1, i4) | 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 return 0;
}

function __ZN8DrawUtil18DrawMeshBuffersRawERK11MeshBuffersR4MeshRK14ChannelAssignsii(i7, i8, i9, i10, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i1 = i6;
 if ((HEAP16[gb + 1157760 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i8;
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157760 | 0, i5);
  i1 = gb + 1157760 | 0;
 } else i1 = 0;
 i2 = __ZNK4Mesh15GetSubMeshCountEv(i8) | 0;
 i2 = i2 | 0 ? i2 + -1 | 0 : 0;
 i3 = __Z12GetGfxDevicev() | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 200 >> 2] | 0, i3 | 0, 4) | 0) i4 = 1; else i4 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 200 >> 2] | 0, i3 | 0, 5) | 0;
 __ZNK4Mesh26GetSubMeshDrawBuffersRangeEib(i5, i8, i2 >>> 0 < i10 >>> 0 ? i2 : i10, i4);
 if (HEAP32[i5 + 20 >> 2] | 0) {
  mftCall_viiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 244 >> 2] | 0, i3 | 0, HEAP32[i7 >> 2] | 0, i7 + 8 | 0, HEAP32[i7 + 4 >> 2] | 0, i5 | 0, 1, HEAP32[i7 + 40 >> 2] | 0, i9 | 0);
  __Z15gpu_time_samplev();
 }
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj93ENS_22PxRepXPropertyAccessorILj93ES4_PKcSA_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (!i1) i1 = 44; else i1 = (HEAP32[i1 >> 2] | 0) + 44 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn12PointerRemap12setObjectRefEyj(i7, i2, i3, i9) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i4 = i7 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i8 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  while (1) {
   i11 = i8 + (i1 << 4) | 0;
   if ((HEAP32[i11 >> 2] | 0) == (i2 | 0) ? (HEAP32[i11 + 4 >> 2] | 0) == (i3 | 0) : 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i8 + (i1 << 4) + 8 >> 2] = i9;
  STACKTOP = i10;
  return;
 } while (0);
 i11 = i6;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i9;
 if ((HEAP32[i7 + 8 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
  i11 = (HEAP32[i7 >> 2] | 0) + (i5 << 4) | 0;
  HEAP32[i11 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i11 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i11 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i11 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  STACKTOP = i10;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn12PointerRemap12InternalDataENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i7, i6) | 0;
  STACKTOP = i10;
  return;
 }
}

function __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE(i11, i3, i12, i1, i2) {
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 HEAPF32[i11 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i9 = i11 + 4 | 0;
 f4 = Math_fround(3402823469999999843913219.0e14);
 i1 = -1;
 do {
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  i8 = HEAP32[i2 + 52 >> 2] | 0;
  if (i5 >>> 0 < i8 >>> 0) do {
   i6 = HEAP32[i12 + (i5 << 6) + 44 >> 2] | 0;
   f7 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f4 > f7) {
    HEAP32[i11 >> 2] = i6;
    HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
    HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
    HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
    f4 = f7;
    i1 = i5;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i8 >>> 0);
  i2 = HEAP32[i2 + 16 >> 2] | 0;
 } while ((i2 | 0) != 0);
 i1 = i12 + (i1 << 6) | 0;
 i2 = i3 + 52 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i13;
 return;
}

function __ZN17PersistentManager18LoadFileCompletelyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i5 + 8 | 0;
 i8 = i5;
 i7 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i3 = gb + 63416 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 i6 = i7 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i7 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 i3 = __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress(i2, i1, 0, 0, -1, 0, i7) | 0;
 __ZN17PersistentManager27IntegrateAllThreadedObjectsEv(i2);
 i1 = i7 + 16 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i5;
  return i3 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK8Vector3fS1_RK11QuaternionfS1_P10RaycastHitfi23QueryTriggerInteraction(i4, i5, i8, i1, i9, f10, i11, i12) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, f6 = f0, f7 = f0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 HEAP32[i9 + 40 >> 2] = 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f6 * f6);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f7 * f7));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAPF32[i13 >> 2] = Math_fround(f6 / f3);
 HEAPF32[i13 + 4 >> 2] = Math_fround(f7 / f3);
 HEAPF32[i13 + 8 >> 2] = Math_fround(f2 / f3);
 if (__ZN14PhysicsManager7BoxCastERK8Vector3fS2_S2_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i4, i5, i13, i8, f10, i9, i11, i12) | 0) {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i9);
  i1 = 1;
 } else i1 = 0;
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 87;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN9GfxDevice16ScheduleAsyncJobEPFvP21GfxDeviceAsyncCommandES1_R8JobFenceR18JobBatchDispatcher(i2, i3, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i9 = i2 + 4472 | 0;
 i10 = i2 + 4484 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i12 = i11 + 1 | 0;
 i13 = i2 + 4488 | 0;
 i4 = HEAP32[i13 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i12 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i13 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 3, 4, i2 + 4476 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4476 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 3 | 0) | 0;
   HEAP32[i13 >> 2] = i1;
   HEAP32[i9 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i12;
 i12 = HEAP32[i9 >> 2] | 0;
 i13 = i12 + (i11 << 3) | 0;
 HEAP32[i13 >> 2] = 0;
 HEAP32[i12 + (i11 << 3) + 4 >> 2] = 0;
 __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_(i8, i13, i3, i6, i7);
 return i13 | 0;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 4; else i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim19schedulePipelineGpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i2 = i8;
 i1 = i3 + 4 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i7, i9, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = 0;
  do {
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 56 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 i1 = __ZN5physx24PxsParticleSystemBatcher19schedulePipelineGpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE((HEAP32[i5 + 1e3 >> 2] | 0) + 324 | 0, HEAP32[i7 >> 2] | 0, i1, i4) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 if (!((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0)) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim19scheduleDynamicsCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i2 = i8;
 i1 = i3 + 4 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i7, i9, i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = 0;
  do {
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 56 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 i1 = __ZN5physx24PxsParticleSystemBatcher19scheduleDynamicsCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE((HEAP32[i5 + 1e3 >> 2] | 0) + 324 | 0, HEAP32[i7 >> 2] | 0, i1, i4) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 if (!((i9 | 0) > -1 & (i9 & 2147483647 | 0) != 0)) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEclERS6_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i4) | 0;
 i5 = HEAP8[i4 + 26 >> 0] | 0 ? 8 : 4;
 i5 = Math_imul(i1 ? i5 + 4 | 0 : i5, HEAP32[HEAP32[i2 >> 2] >> 2] | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, i5, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i3 - (HEAP32[i4 + 44 >> 2] | 0) + ((i5 | 0) == 0 ? 0 : (i5 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN2UI6Canvas12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 if (!i5) {
  __ZN2UI20CleanupCanvasManagerEv();
  return;
 } else i1 = 0;
 while (1) {
  i3 = gb + 1156840 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 339 | 0)) {
   i4 = gb + 1156840 + (i1 * 12 | 0) + 8 | 0;
   i2 = gb + 1156840 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) {
  __ZN2UI20CleanupCanvasManagerEv();
  return;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[gb + 1156840 + 768 >> 2] | 0) + -1 | 0;
 HEAP32[gb + 1156840 + 768 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) {
  __ZN2UI20CleanupCanvasManagerEv();
  return;
 }
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[gb + 1156840 + (i6 * 12 | 0) >> 2] = HEAP32[gb + 1156840 + (i1 * 12 | 0) >> 2];
  HEAP32[gb + 1156840 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[gb + 1156840 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[gb + 1156840 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[gb + 1156840 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[gb + 1156840 + 768 >> 2] | 0) >>> 0);
 __ZN2UI20CleanupCanvasManagerEv();
 return;
}

function __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
 HEAP32[i1 + 76 >> 2] = i2;
 i1 = i1 + 146 | 0;
 HEAP16[i1 >> 1] = (i7 & 1) << 12 & 65535 | HEAP16[i1 >> 1] & -4097;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel15setChannelGroupEPNS_12ChannelGroupE(i3, i2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 258;
 HEAP32[i5 + 8 >> 2] = gb + 866924;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN18PlatformEffector2D16CheckConsistencyEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i3);
 i1 = i3 + 80 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i4 & 2139095040 | 0) == 2139095040) f2 = Math_fround(0.0); else {
  i4 = f2 < Math_fround(0.0);
  i5 = f2 > Math_fround(360.0);
  f2 = i5 ? Math_fround(360.0) : f2;
  f2 = i4 ? Math_fround(0.0) : f2;
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = i3 + 84 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i5 & 2139095040 | 0) == 2139095040) f2 = Math_fround(0.0); else {
  i5 = f2 < Math_fround(0.0);
  i4 = f2 > Math_fround(180.0);
  f2 = i4 ? Math_fround(180.0) : f2;
  f2 = i5 ? Math_fround(0.0) : f2;
 }
 HEAPF32[i1 >> 2] = f2;
 i1 = i3 + 88 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 f2 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i5 & 2139095040 | 0) == 2139095040) {
  f2 = Math_fround(0.0);
  HEAPF32[i1 >> 2] = f2;
  return;
 }
 i5 = f2 < Math_fround(-359.999908);
 i4 = f2 > Math_fround(359.999908);
 f2 = i4 ? Math_fround(359.999908) : f2;
 f2 = i5 ? Math_fround(-359.999908) : f2;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __ZN10FlareLayer17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 29832 | 0) | 0;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 if (i1 | 0) {
  __ZN12FlareManager12RemoveCameraER6Camera(i1, i2);
  return;
 }
 i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
 if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
  i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i3;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[gb + 1110296 >> 2] = i1;
  __ZN12FlareManager12RemoveCameraER6Camera(i1, i2);
  return;
 } else {
  i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i1 = i3 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = i1;
  i1 = i3 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[gb + 1110296 >> 2] = i3;
  __ZN12FlareManager12RemoveCameraER6Camera(i3, i2);
  return;
 }
}

function __ZL33InitializeTerrainScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 937433 | 0, 16) | 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[gb + 1467748 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937557 | 0) | 0;
 HEAP32[HEAP32[gb + 1467748 >> 2] >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937573 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 4 >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937588 | 0) | 0;
 i2 = HEAP32[gb + 1467748 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 i2 = i2 + 12 | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 937588 | 0, gb + 937596 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937620 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 20 >> 2] = i2;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 937633 | 0) | 0;
 HEAP32[(HEAP32[gb + 1467748 >> 2] | 0) + 24 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj(i8, i9, i1, i2, i3) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 i7 = (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 12 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i4 = ~i3 & i2 & HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2];
 HEAP16[i10 >> 1] = 0;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i5 = i9 + 4 | 0;
 i2 = 0;
 i3 = 1;
 do {
  if (i3 & i4 | 0) {
   switch (i2 | 0) {
   case 7:
   case 1:
    {
     i1 = 1;
     break;
    }
   default:
    i1 = 0;
   }
   i6 = i10 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) {
    i14 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i14 + 1;
    HEAP8[i6 >> 0] = i14;
    __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej(i11, i8, i1, i7);
    i13 = i11;
    i1 = HEAP32[i13 + 4 >> 2] | 0;
    i6 = i9 + 8 + ((i14 & 255) << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i6 + 4 >> 2] = i1;
   }
  }
  i2 = i2 + 1 | 0;
  i3 = i3 << 1;
 } while ((i2 | 0) < 8 & i3 >>> 0 <= i4 >>> 0);
 STACKTOP = i12;
 return;
}

function __Z17InitializeChannelRK8UnityStriiR17BlendShapeChannel(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i9 = i7;
 i2 = i1 + 11 | 0;
 i8 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i12 = gb + 63248 | 0;
 i11 = HEAP32[i12 + 4 >> 2] | 0;
 i10 = i9;
 HEAP32[i10 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i10 + 4 >> 2] = i11;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i6, i8, i3);
 i1 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) i2 = -1; else {
  i11 = 0;
  i12 = i6 + 4 | 0;
  HEAP32[i12 >> 2] = i11;
  i12 = i6 + 8 | 0;
  HEAP32[i12 >> 2] = i4;
  i12 = i6 + 12 | 0;
  HEAP32[i12 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
 do {
  i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i11 = ~i2;
 i12 = i6 + 4 | 0;
 HEAP32[i12 >> 2] = i11;
 i12 = i6 + 8 | 0;
 HEAP32[i12 >> 2] = i4;
 i12 = i6 + 12 | 0;
 HEAP32[i12 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjjw(i11, i8, i2, i9, i10) {
 i11 = i11 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i12 = 0;
 i3 = i11 + 8 | 0;
 i12 = i3 + 3 | 0;
 i1 = HEAP8[i12 >> 0] | 0;
 i5 = i1 << 24 >> 24 < 0;
 if (i5) i7 = HEAP32[i11 + 4 >> 2] | 0; else i7 = i1 & 255;
 if (i7 >>> 0 < i8 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i11);
 i4 = i7 - i8 | 0;
 i6 = i4 >>> 0 < i2 >>> 0 ? i4 : i2;
 if (i5) i1 = (HEAP32[i3 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 if ((i6 - i7 + i1 | 0) >>> 0 < i9 >>> 0) {
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i11, i1, i7 + i9 - i6 - i1 | 0, i7, i8, i6, i9);
  i2 = HEAP32[i11 >> 2] | 0;
 } else {
  if (i5) i2 = HEAP32[i11 >> 2] | 0; else i2 = i11;
  if ((i6 | 0) != (i9 | 0)) {
   i1 = i4 - i6 | 0;
   i3 = i2 + (i8 << 2) | 0;
   if (i1) __ZNSt3__211char_traitsIwE4moveEPwPKwj(i3 + (i9 << 2) | 0, i3 + (i6 << 2) | 0, i1) | 0;
  }
 }
 __ZNSt3__211char_traitsIwE6assignEPwjw(i2 + (i8 << 2) | 0, i9, i10) | 0;
 i1 = i9 - i6 + i7 | 0;
 if ((HEAP8[i12 >> 0] | 0) < 0) HEAP32[i11 + 4 >> 2] = i1; else HEAP8[i12 >> 0] = i1;
 HEAP32[i2 + (i1 << 2) >> 2] = 0;
 return i11 | 0;
}

function __ZNK16MemoryFileSystem5IsDirERK13FileEntryData(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 54;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 }
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 >> 2] | 0) == 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi24EEEEvRT_PKc17TransferMetaFlags(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = (HEAP8[i6 + 24 >> 0] | 0) != 0;
 if (i4) {
  __ZN9BlobWrite4PushEjPKvj(i6, HEAP32[i3 >> 2] << 2, i3, 4);
  i1 = i3;
 } else i1 = i3;
 i5 = i6 + 48 | 0;
 i7 = i6 + 44 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i6 + 32 | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i9 = i10 + (i2 << 4) + 4 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i2 << 4) >> 2] | 0)) & 3);
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + (i9 << 2) | 0;
 if (i9 | 0) do {
  __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i6, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i4) return;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + -1;
 i1 = i6 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i7 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi15EEEEvRT_PKc17TransferMetaFlags(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = (HEAP8[i6 + 24 >> 0] | 0) != 0;
 if (i4) {
  __ZN9BlobWrite4PushEjPKvj(i6, HEAP32[i3 >> 2] << 2, i3, 4);
  i1 = i3;
 } else i1 = i3;
 i5 = i6 + 48 | 0;
 i7 = i6 + 44 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i6 + 32 | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i9 = i10 + (i2 << 4) + 4 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i2 << 4) >> 2] | 0)) & 3);
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + (i9 << 2) | 0;
 if (i9 | 0) do {
  __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i6, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i4) return;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + -1;
 i1 = i6 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i7 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN9BlobWrite8TransferI19StaticArrayTransferIfLi24EEEEvRT_PKc17TransferMetaFlags(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = (HEAP8[i6 + 24 >> 0] | 0) != 0;
 if (i4) {
  __ZN9BlobWrite4PushEjPKvj(i6, HEAP32[i3 >> 2] << 2, i3, 4);
  i1 = i3;
 } else i1 = i3;
 i5 = i6 + 48 | 0;
 i7 = i6 + 44 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + -1 + (HEAP32[i7 >> 2] | 0) | 0;
 i8 = i6 + 32 | 0;
 i10 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i2 >>> 8 << 2) >> 2] | 0;
 i2 = i2 & 255;
 i9 = i10 + (i2 << 4) + 4 | 0;
 i11 = HEAP32[i9 >> 2] | 0;
 HEAP32[i9 >> 2] = i11 + (0 - (i11 + (HEAP32[i10 + (i2 << 4) >> 2] | 0)) & 3);
 i9 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + (i9 << 2) | 0;
 if (i9 | 0) do {
  __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i6, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i4) return;
 i10 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i10 + -1;
 i1 = i6 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i11 = i2 - (HEAP32[i8 >> 2] | 0) | 0;
 if ((1 - i10 - (HEAP32[i7 >> 2] | 0) + ((i11 | 0) == 0 ? 0 : (i11 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10startEventEty(i10, i8, i2, i3) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i4 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i5 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i6 = getTempRet0() | 0;
 i7 = HEAP32[i10 + 72 >> 2] | 0;
 if (!i7) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i9;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i12 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i4;
 HEAP8[i9 + 12 >> 0] = 2;
 HEAP8[i9 + 13 >> 0] = 0;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i6;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_(i10, i8, i9);
 if (i1) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN37AssetBundleLoadFromFileAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN23PreloadManagerOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 27520 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 112 | 0, i2);
 HEAP8[i1 + 124 >> 0] = 1;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i1 + 128 | 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i2 >> 2] = gb + 27732 + 88;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAPF32[i1 + 136 >> 2] = Math_fround(0.0);
 __ZN4FileC2Ev(i1 + 144 | 0);
 i3 = i1 + 176 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 27828 + 8;
 HEAP32[i2 >> 2] = gb + 27828 + 88;
 i2 = i1 + 192 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 208 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_111createClothERKN5physx11PxTransformERNS0_13PxClothFabricEPKNS0_15PxClothParticleENS0_7PxFlagsINS0_11PxClothFlag4EnumEtEE(i8, i7, i9, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i6 = HEAP32[gb + 1457204 >> 2] | 0;
 i2 = HEAP16[i1 >> 1] | 0;
 i3 = i6 + 4252 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i6 + 4248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i6 + 3956 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i4 = i6 + 4236 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i6 = i6 + 4240 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (!i1) {
  i9 = 0;
  i8 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP16[i5 >> 1] = i2;
 __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i1, i8, i7, i9, i5);
 i9 = i1;
 i8 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN11UTF16StringC2EP12Il2CppString10MemLabelId(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 8 | 0;
 i5 = i1 + 12 | 0;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 if (!i2) {
  HEAP8[i1 + 8 >> 0] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  STACKTOP = i7;
  return;
 } else {
  __Z24scripting_cpp_string_forP12Il2CppString(i4, i2);
  i8 = i4 + 11 | 0;
  i9 = HEAP8[i8 >> 0] | 0;
  i3 = i4 + 4 | 0;
  i9 = (i9 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i9 & 255) << 1;
  i10 = i5;
  i2 = HEAP32[i10 + 4 >> 2] | 0;
  i5 = i6;
  HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i5 + 4 >> 2] = i2;
  i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i9, 16, i6, 0, gb + 489101 | 0, 14) | 0;
  HEAP32[i1 >> 2] = i9;
  i8 = HEAP8[i8 >> 0] | 0;
  i6 = i8 << 24 >> 24 < 0;
  __Z18ConvertUTF8toUTF16PKhiPtRi(i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i3 >> 2] | 0 : i8 & 255, i9, i1 + 4 | 0) | 0;
  HEAP8[i1 + 8 >> 0] = 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i7;
  return;
 }
}

function __ZN11ContextGLES6CreateEi(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i2 = i5;
 i1 = i5 + 16 | 0;
 if (!(_JS_SystemInfo_HasWebGL() | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 _emscripten_webgl_init_context_attributes(i1 | 0);
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 1;
 i6 = __Z18GetQualitySettingsv() | 0;
 HEAP32[i1 + 12 >> 2] = (HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + ((HEAP32[i6 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) > 0 & 1;
 i6 = i3 + -1 | 0;
 HEAP32[i1 + 32 >> 2] = i6;
 HEAP32[i2 >> 2] = i6;
 _printf(gb + 597588 | 0, i2) | 0;
 HEAP32[i1 >> 2] = 1;
 i1 = _emscripten_webgl_create_context(0, i1 | 0) | 0;
 do if ((i1 | 0) < 1) _puts(gb + 597618 | 0) | 0; else {
  i2 = _emscripten_webgl_make_context_current(i1 | 0) | 0;
  if (i2 | 0) {
   HEAP32[i4 >> 2] = i2;
   _printf(gb + 597650 | 0, i4) | 0;
   break;
  }
  _emscripten_webgl_enable_extension(i1 | 0, gb + 597690 | 0) | 0;
  _emscripten_webgl_enable_extension(i1 | 0, gb + 607435 | 0) | 0;
  if ((i3 | 0) > 2) _emscripten_webgl_enable_extension(i1 | 0, gb + 597707 | 0) | 0;
  i6 = 1;
  STACKTOP = i5;
  return i6 | 0;
 } while (0);
 i6 = 0;
 STACKTOP = i5;
 return i6 | 0;
}

function __Z43Object_CUSTOM_DoesObjectWithInstanceIDExisti(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 i2 = i5;
 if (!i4) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 do if (i3) {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i6 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i6 + 28 >> 2] | 0;
   i3 = HEAP32[i6 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) break;
  if (HEAP32[i1 + 4 >> 2] | 0) {
   i6 = 1;
   STACKTOP = i5;
   return i6 | 0;
  }
 } while (0);
 i6 = (__ZN17PersistentManager17IsObjectAvailableEi(__Z20GetPersistentManagerv() | 0, i4) | 0) & 1;
 STACKTOP = i5;
 return i6 | 0;
}

function __Z32GUITexture_Get_Custom_PropBorderP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = __Znwj(16) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 HEAP32[i3 >> 2] = HEAP32[i1 + 36 >> 2];
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 40 >> 2];
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 44 >> 2];
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 48 >> 2];
  i4 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 288 >> 2] | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i3;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj49ES2_jEEEEvjRT_(i4, i1, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i6 = i7;
 HEAP32[i5 >> 2] = 0;
 if (!(HEAP8[i4 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 i3 = _strtoul(i1, i5, 10) | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 i2 = i8 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i5 | 0, i6 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i8 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i6 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj87ES2_jEEEEvjRT_(i4, i1, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i6 = i7;
 HEAP32[i5 >> 2] = 0;
 if (!(HEAP8[i4 + 36 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i7;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 i3 = _strtoul(i1, i5, 10) | 0;
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 i2 = i8 + 12 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i5 | 0, i6 | 0);
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!(HEAP8[i8 + 8 >> 0] | 0)) mftCall_viii(i2 | 0, i1 | 0, HEAP32[i5 >> 2] | 0, i3 | 0); else mftCall_viii(i2 | 0, i1 | 0, i3 | 0, HEAP32[i6 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXSerializerImplINS_7PxShapeEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i2, i5, i4, i7, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i3 + 48 | 0;
 i9 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 >> 2];
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 __ZN5physx20PxShapeGeneratedInfoC2Ev(i10);
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i7;
 HEAP32[i9 + 8 >> 2] = i5;
 HEAP32[i9 + 12 >> 2] = i6;
 HEAP32[i9 + 16 >> 2] = i4;
 HEAP32[i9 + 20 >> 2] = 0;
 HEAP32[i9 + 24 >> 2] = 0;
 __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j(i10, i9, 0) | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 if (!((i7 | 0) > -1 & (i7 & 2147483647 | 0) != 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i10 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN25MultiBlocksMemoryFileData17AdjustBlocksCountEj(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0;
 i9 = i6 + 20 | 0;
 i7 = i6 + 32 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 >>> 0 > i8 >>> 0) {
  i3 = i6 + 8 | 0;
  i2 = i8;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0, i3);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i7 >> 2] = i8;
 i3 = i6 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i5 >>> 0 < i8 >>> 0) {
  i2 = i4 << 1;
  i2 = i2 >>> 0 > i8 >>> 0 ? i2 : i8;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i6 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i9 >> 2] = i6;
   break;
  }
 } while (0);
 if (i1 >>> 0 >= i8 >>> 0) return;
 do {
  HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN15DirectorManager12CleanupClassEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN15DirectorManager14ConnectionPool11ClearUnsafeEv(gb + 1188456 | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188456 + 48 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188456 + 52 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188456 + 56 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188456 + 60 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188456 + 64 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188416 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188420 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[gb + 1188424 >> 2] | 0);
 i1 = HEAP32[gb + 1188432 >> 2] | 0;
 if (!(HEAP32[HEAP32[gb + 1188432 >> 2] >> 2] | 0)) {
  i2 = i1;
  __Z23DestroyMutexLockedStackP16MutexLockedStack(i2);
  return;
 }
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
  i1 = HEAP32[gb + 1188432 >> 2] | 0;
 } while ((HEAP32[HEAP32[gb + 1188432 >> 2] >> 2] | 0) != 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(i1);
 return;
}

function __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 4;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 4;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 4, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 4) | 0;
 _memmove(i14 + (i8 << 4) | 0, i14 | 0, i11 << 4 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN10Matrix4x4f10SetFrustumEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f10 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(f3 - f2);
 f11 = Math_fround(f5 - f4);
 f8 = Math_fround(f10 / f11);
 f3 = Math_fround(Math_fround(f2 + f3) / f9);
 f4 = Math_fround(Math_fround(f4 + f5) / f11);
 f2 = Math_fround(f7 - f6);
 f5 = Math_fround(Math_fround(-Math_fround(f6 + f7)) / f2);
 f7 = Math_fround(Math_fround(-Math_fround(Math_fround(f7 * Math_fround(2.0)) * f6)) / f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 / f9);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = f3;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = f8;
 HEAPF32[i1 + 36 >> 2] = f4;
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = f5;
 HEAPF32[i1 + 56 >> 2] = f7;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return i1 | 0;
}

function _cff_size_select(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i3 + 44 >> 2] = i1;
 _UNITY_FT_Select_Metrics(HEAP32[i3 >> 2] | 0, i1);
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 656 >> 2] | 0) + 2952 >> 2] | 0;
 i2 = _UNITY_FT_Get_Module(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1006904 | 0) | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return 0;
 i1 = mftCall_ii(i1 | 0, i2 | 0) | 0;
 if (!i1) return 0;
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 656 >> 2] | 0;
 i8 = HEAP32[i3 + 40 >> 2] | 0;
 i9 = HEAP32[i7 + 1392 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i6 = i3 + 16 | 0;
 i4 = i3 + 20 | 0;
 mftCall_viiiii(HEAP32[i5 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0, 0, 0);
 i1 = HEAP32[i7 + 1896 >> 2] | 0;
 if (!i1) return 0;
 do {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[(HEAP32[i7 + 1900 + (i1 << 2) >> 2] | 0) + 68 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i9 | 0) == (i3 | 0)) i3 = HEAP32[i4 >> 2] | 0; else {
   i2 = _UNITY_FT_MulDiv(i2, i9, i3) | 0;
   i3 = _UNITY_FT_MulDiv(HEAP32[i4 >> 2] | 0, i9, i3) | 0;
  }
  mftCall_viiiii(HEAP32[i5 >> 2] | 0, HEAP32[i8 + 4 + (i1 << 2) >> 2] | 0, i2 | 0, i3 | 0, 0, 0);
 } while ((i1 | 0) != 0);
 return 0;
}

function __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 156 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE8__appendEj(i1, i2 - i4 | 0);
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) return;
 i3 = i3 + (i2 * 156 | 0) | 0;
 if ((i5 | 0) == (i3 | 0)) return; else i2 = i5;
 do {
  HEAP32[i6 >> 2] = i2 + -156;
  i1 = i2 + -40 | 0;
  if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -36 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i2 + -60 | 0;
  if ((HEAP32[i2 + -44 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -56 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i2 + -80 | 0;
  if ((HEAP32[i2 + -64 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -76 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i2 + -100 | 0;
  if ((HEAP32[i2 + -84 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -96 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZNK5Umbra4Tome15findObjectIndexEj(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = HEAP32[i4 + 76 >> 2] | 0;
 i10 = i4 + i8 | 0;
 if ((i8 | 0) == 0 | (i10 | 0) == 0) {
  i2 = HEAP32[i4 + 80 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
  i3 = HEAP32[i4 + 64 >> 2] | 0;
  if ((i3 | 0) > 0) i1 = 0; else {
   i10 = -1;
   return i10 | 0;
  }
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i9 | 0)) {
    i2 = 7;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i1 = -1;
    i2 = 7;
    break;
   }
  }
  if ((i2 | 0) == 7) return i1 | 0;
 }
 i8 = HEAP32[i4 + 64 >> 2] | 0;
 if ((i8 | 0) <= 0) {
  i10 = -1;
  return i10 | 0;
 }
 i2 = HEAP32[i4 + 80 >> 2] | 0;
 i4 = (i2 | 0) == 0 ? 0 : i4 + i2 | 0;
 i2 = 0;
 i6 = HEAP32[i10 >> 2] | 0;
 L15 : while (1) {
  i5 = i4 + (i6 << 2) | 0;
  i1 = i2;
  i2 = i2 + 1 | 0;
  i7 = i6;
  i6 = HEAP32[i10 + (i2 << 2) >> 2] | 0;
  i7 = i6 - i7 | 0;
  if ((i7 | 0) > 0) {
   i3 = 0;
   do {
    if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i9 | 0)) {
     i2 = 7;
     break L15;
    }
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < (i7 | 0));
  }
  if ((i2 | 0) >= (i8 | 0)) {
   i1 = -1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1 + 1 | 0;
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 900348 | 0, i2, HEAPU8[i3 >> 0] & 3);
 __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE(i4, gb + 660697 | 0, i2 + 8 | 0, (HEAPU8[i3 >> 0] | 0) >>> 2 & 3);
 i3 = i2 + 16 | 0;
 i1 = i4 + 8 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = i4 + 4 | 0;
  if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 4) {
   HEAP8[i3 >> 0] = HEAP8[HEAP32[i4 >> 2] >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 1 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 2 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   HEAP8[i3 + 3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
   return;
  }
 }
 HEAP8[i1 >> 0] = 1;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj124ENS_22PxRepXPropertyAccessorILj124ES4_PKcSA_EEEEvRKT0_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i1) i1 = 116; else i1 = (HEAP32[i1 >> 2] | 0) + 116 | 0;
 HEAP8[i2 >> 0] = 1;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i3 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = HEAP32[i6 + 12 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 + -1 << 3) >> 2] | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
  mftCall_iiii(i6 | 0, i5 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 HEAP8[i7 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i5 + 20 >> 2] | 0);
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj86ENS_22PxRepXPropertyAccessorILj86ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj85ENS_22PxRepXPropertyAccessorILj85ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj83ENS_22PxRepXPropertyAccessorILj83ES4_jjEEEEvjRKT0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 8 | 0;
 i4 = mftCall_ii(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i2 = i7;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i8 >> 2] = i4;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084495 | 0, i8) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 HEAP8[i8 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i8 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, HEAP32[i6 + 20 >> 2] | 0);
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN5physx2Gu23computeMTD_PlaneCapsuleERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_7CapsuleE(i8, i7, i3, i2) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, f10 = f0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f9 * f4);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f9 + Math_fround(f10 * f6));
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(f10 + Math_fround(f9 * f5));
 f10 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f9 = Math_fround(f10 + f9);
 f1 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 f1 = Math_fround(f1 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 16 >> 2])));
 f1 = Math_fround(f10 + Math_fround(f1 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 20 >> 2]))));
 f1 = Math_fround((f9 < f1 ? f9 : f1) - Math_fround(HEAPF32[i2 + 24 >> 2]));
 if (f1 > Math_fround(0.0)) {
  i8 = 0;
  return i8 | 0;
 }
 f9 = Math_fround(-f6);
 f10 = Math_fround(-f5);
 HEAPF32[i8 >> 2] = Math_fround(-f4);
 HEAPF32[i8 + 4 >> 2] = f9;
 HEAPF32[i8 + 8 >> 2] = f10;
 f10 = Math_fround(-f1);
 i8 = f1 < Math_fround(-0.0);
 HEAPF32[i7 >> 2] = i8 ? f10 : Math_fround(0.0);
 i8 = 1;
 return i8 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 12;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK9dtNavMesh15findNearestPolyEPKfS1_Pf(i1, i2, i3, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP32[i10 >> 2] = gb + 169376 + 8;
 HEAP32[i10 + 4 >> 2] = i1;
 i8 = i10 + 8 | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAPF32[i10 + 16 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i10 + 20 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 24 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 + 28 >> 2] = HEAP32[i2 + 8 >> 2];
 i4 = i10 + 32 | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i5 = i10 + 36 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = i10 + 40 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback(i1, i2, i3, i10) | 0;
 if (!i7) {
  i10 = i8;
  i10 = HEAP32[i10 >> 2] | 0;
  i8 = i8 + 4 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  setTempRet0(i8 | 0);
  STACKTOP = i9;
  return i10 | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i6 >> 2];
 i10 = i8;
 i10 = HEAP32[i10 >> 2] | 0;
 i8 = i8 + 4 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 setTempRet0(i8 | 0);
 STACKTOP = i9;
 return i10 | 0;
}

function __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, gb + 1037646 | 0, HEAP32[gb + 37260 >> 2] | 0, i4, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i3, i5, 1); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
 }
 i1 = i5 + 11 | 0;
 if (HEAP8[i3 + 128 >> 0] | 0) __ZN9ShaderLab16FastPropertyName4InitEPKc(i2, (HEAP8[i1 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i6;
 return;
}

function __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 36980 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1084155 | 0, 0, 0);
  __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 1 | 0, gb + 1086064 | 0, 0, 0);
  __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 2 | 0, gb + 1085890 | 0, 0, 0);
  __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 3 | 0, gb + 1085926 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx7NpScene15flushSimulationEb(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 if (!(HEAP8[i3 + 3696 >> 0] | 0)) {
  i5 = i3 + 2520 | 0;
  HEAP16[i1 >> 1] = 0;
  __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt(i5, 0, i1);
  __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj(i5, HEAP32[i3 + 2524 >> 2] | 0);
  i5 = i3 + 2532 | 0;
  HEAP32[i1 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i5, 0, i1);
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5, HEAP32[i3 + 2536 >> 2] | 0);
  i5 = i3 + 2544 | 0;
  HEAP32[i1 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i5, 0, i1);
  __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5, HEAP32[i3 + 2548 >> 2] | 0);
  __ZN5physx2Sc5Scene5flushEb(i3 + 32 | 0, i2);
  STACKTOP = i4;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 2361, gb + 705828 | 0, i4);
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx3Scb5Scene11removeClothERNS0_5ClothE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i4 = i7;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE(i1 + 16 | 0, i6 + 12 | 0);
  i5 = i6 + 4 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & 268435455;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 2820 | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i2 >> 2] = i3 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i1, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = i3 | -1073741824;
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i4 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i4, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx2Sn21SerializationRegistryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 89032 + 8;
 _PxUnregisterPhysicsSerializers(i1);
 __ZN5physx3Ext31UnregisterExtensionsSerializersERNS_23PxSerializationRegistryE(i1);
 i3 = i1 + 8 | 0;
 if (HEAP32[i1 + 44 >> 2] | 0) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 667371 | 0, 146, gb + 667480 | 0, i4);
 i2 = i1 + 48 | 0;
 if (HEAP32[i1 + 84 >> 2] | 0) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 667371 | 0, 152, gb + 667577 | 0, i4 + 8 | 0);
 i5 = HEAP32[i1 + 96 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i1 + 88 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1);
 STACKTOP = i4;
 return;
}

function __ZN15UnityWebRequestC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = i4 + 4 | 0;
 i6 = i1;
 i7 = i6 + 116 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP16[i1 + 116 >> 1] = 0;
 HEAP32[i4 >> 2] = gb + 188012 + 8;
 HEAP32[i4 + 4 >> 2] = 1;
 __ZN19TransportJavaScriptC2Ev(i4 + 8 | 0);
 i3 = i4 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i4 + 48;
 i1 = i4 + 108 | 0;
 i2 = i4 + 120 | 0;
 i6 = i4 + 56 | 0;
 i7 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP8[i2 >> 0] = 1;
 HEAP8[i4 + 121 >> 0] = 1;
 HEAP32[i1 >> 2] = 1;
 __ZN14RedirectHelper16SetRedirectLimitEj(i3, 32) | 0;
 HEAP32[i4 >> 2] = gb + 187980 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4 + 76 | 0, i5) | 0;
 i7 = __Znwj(12) | 0;
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = gb + 1468908;
 i6 = HEAP32[gb + 1468908 >> 2] | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[gb + 1468908 >> 2] = i7;
 HEAP32[gb + 1468908 + 8 >> 2] = (HEAP32[gb + 1468908 + 8 >> 2] | 0) + 1;
 return;
}

function __ZN14Texture2DArray13RebuildMipMapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) == 1) return;
 i8 = i2 + 96 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 if (!i6) return;
 i9 = i2 + 92 | 0;
 i7 = HEAP32[i9 >> 2] | 0;
 do if ((i7 + -10 | 0) >>> 0 >= 3) if (((i7 | 1) + -25 | 0) >>> 0 >= 5) {
  i1 = i7 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i7 + -48 | 0) >>> 0 < 12 | ((i7 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
  } else if ((i7 + -45 | 0) >>> 0 < 3 | (i7 + -48 | 0) >>> 0 < 12) break;
  i3 = i2 + 88 | 0;
  if ((HEAP32[i3 >> 2] | 0) <= 0) return;
  i4 = i2 + 104 | 0;
  i5 = i2 + 80 | 0;
  i2 = i2 + 84 | 0;
  __Z12CreateMipMapPhiii13TextureFormat(i6, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, 1, i7);
  if ((HEAP32[i3 >> 2] | 0) > 1) i1 = 1; else return;
  do {
   i7 = (HEAP32[i8 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i1) | 0) | 0;
   __Z12CreateMipMapPhiii13TextureFormat(i7, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, 1, HEAP32[i9 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 418050 | 0, 0, gb + 411289 | 0, 194, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13RenderTexture25ResolveAntiAliasedSurfaceEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 12 | 0;
 i1 = i8 + 8 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8;
 i7 = i4 + 132 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP16[gb + 1158244 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158244 | 0, i2);
  i3 = gb + 1158244 | 0;
 } else i3 = 0;
 i9 = HEAP32[gb + 1158244 >> 2] | 0;
 i10 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 648 >> 2] | 0, i10 | 0, i9 | 0);
 i9 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 328 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 + 128 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 mftCall_viii(i10 | 0, i9 | 0, i1 | 0, i2 | 0);
 __Z15gpu_time_samplev();
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 652 >> 2] | 0, i7 | 0);
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i8;
 return;
}

function __ZNSt3__217__assoc_sub_state9set_valueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i6 = i1 + 12 | 0;
 __ZNSt3__25mutex4lockEv(i6);
 i2 = i1 + 88 | 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  HEAP32[i4 >> 2] = 0;
  i7 = (HEAP32[i1 + 8 >> 2] | 0) == 0;
  __ZNSt13exception_ptrD2Ev(i4);
  if (i7) {
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 5;
   __ZNSt3__218condition_variable10notify_allEv(i1 + 40 | 0);
   __ZNSt3__25mutex6unlockEv(i6);
   STACKTOP = i3;
   return;
  }
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i5 >> 2] = 2;
 HEAP32[i5 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i4 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 if (i7 & 1) {
  i7 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  i1 = i7;
 } else {
  __THREW__ = 0;
  invoke_viii(fb + 1035 | 0, i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__25mutex6unlockEv(i6);
 ___resumeException(i1 | 0);
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i10, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 4 | 0;
 i9 = i11;
 i3 = i1 + 8 | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0) | 0;
 i1 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i3 + 20 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 16 >> 2] | 0; else i1 = i1 & 255;
 do if ((i2 | 0) == (0 - i1 | 0)) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4; else {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i5, i4, i3, i3 + 24 | 0, i8, i7, 0) | 0) - i3 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) == 12 & (i1 | 0) == 0) {
   HEAP32[i10 >> 2] = 0;
   break;
  }
  if ((i2 | 0) < 12 & (i1 | 0) == 12) HEAP32[i10 >> 2] = i2 + 12;
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZNK9dtNavMesh12getPolyFlagsEy(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 if ((i3 & 983040 | 0) == 65536 & 0 == 0) {
  i2 = i3 & 65535;
  if (i2 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i1 + (i2 * 104 | 0) | 0) == 0 ? 1 : (i6 | 0) != (HEAP32[i1 + (i2 * 104 | 0) + 92 >> 2] | 0)) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = HEAP32[i1 + (i2 * 104 | 0) + 76 >> 2] | 0;
  return i6 | 0;
 }
 if ((i3 | 0) == 0 & (i4 | 0) == 0) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = _bitshift64Lshr(i3 | 0, i4 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i3 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 if (i6 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[(HEAP32[i1 + (i5 * 56 | 0) + 16 >> 2] | 0) + (i6 << 5) + 24 >> 2] | 0;
 return i6 | 0;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9stopEventEty(i10, i8, i2, i3) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i4 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 i5 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i6 = getTempRet0() | 0;
 i7 = HEAP32[i10 + 72 >> 2] | 0;
 if (!i7) i1 = 1; else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
  i1 = 0;
 }
 i12 = i9;
 HEAP32[i12 >> 2] = i2;
 HEAP32[i12 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i4;
 HEAP8[i9 + 12 >> 0] = 2;
 HEAP8[i9 + 13 >> 0] = 0;
 i4 = i9 + 16 | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i6;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_(i10, i8, i9);
 if (i1) {
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 432020 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 432037 | 0, HEAP32[gb + 37316 >> 2] | 0, (HEAP32[i1 + 52 >> 2] | 0) + 12 | 0, 0);
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 37300 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv() {
 var i1 = 0, i2 = 0;
 i1 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0) == 2;
 i1 = i1 ? 3 : 1;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 4;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 8;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 500 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 16;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 502 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 32;
 i2 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 524 >> 2] | 0) == 0;
 i1 = i2 ? i1 : i1 | 64;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 512 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 128;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 513 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 256;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 512;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 508 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 1024;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 168 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 2048;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 4096;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0) == 0;
 return (i2 ? i1 : i1 | 8192) | 16384 | 0;
}

function __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = __ZNK5physx2Sc8RigidSim14getSimForShapeERNS0_9ShapeCoreE(i1, i2) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 & 1) {
  __ZN5physx2Sc8ShapeSim16onGeometryChangeEv(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 2) {
  __ZN5physx2Sc8ShapeSim16onMaterialChangeEv(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 128) {
  __ZN5physx2Sc8ShapeSim16onResetFilteringEv(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 4) {
  __ZN5physx2Sc8ShapeSim17onTransformChangeEv(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 8) {
  __ZN5physx2Sc8ShapeSim18onFilterDataChangeEv(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (i1 & 64) {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  __ZN5physx2Sc8ShapeSim12onFlagChangeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i2, i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!(i1 & 32)) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx2Sc8ShapeSim18onRestOffsetChangeEv(i2);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4ERKNS_7Vector3ES5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(f9 - f6);
 f6 = Math_fround(Math_fround(Math_fround(f6 * Math_fround(2.0)) / f9) + Math_fround(1.0));
 f5 = Math_fround(f5 - f7);
 f8 = Math_fround(Math_fround(-2.0) / f5);
 f5 = Math_fround(Math_fround(Math_fround(f7 * Math_fround(2.0)) / f5) + Math_fround(1.0));
 f7 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f4));
 f4 = Math_fround(-Math_fround(f4 * f7));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(-2.0) / f9);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = f7;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 12 >> 2] = f6;
 HEAPF32[i1 + 28 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f4;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 return;
}

function __ZN4FMOD7SystemI23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0;
 i2 = i1 + 320 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i1 + 332 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i4 = i1 + 344 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 i4 = i1 + 356 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 d10 = +Math_fround(HEAPF32[i3 >> 2]);
 d11 = +Math_fround(HEAPF32[i3 + 4 >> 2]);
 _JS_Sound_SetListenerPosition(+d10, +d11, +(+Math_fround(HEAPF32[i3 + 8 >> 2])));
 d11 = +Math_fround(HEAPF32[i5 >> 2]);
 d10 = +Math_fround(HEAPF32[i5 + 4 >> 2]);
 d9 = +Math_fround(HEAPF32[i5 + 8 >> 2]);
 d8 = +Math_fround(HEAPF32[i6 >> 2]);
 d7 = +Math_fround(HEAPF32[i6 + 4 >> 2]);
 _JS_Sound_SetListenerOrientation(+d11, +d10, +d9, +d8, +d7, +(+Math_fround(HEAPF32[i6 + 8 >> 2])));
 return 0;
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i6, 4); else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 4 | 0, gb + 944890 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i7, i6 + 20 | 0, gb + 944893 | 0, 0);
 i1 = i6 + 36 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 56 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN12LineRenderer15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 405180 | 0, gb + 406737 | 0, gb + 405205 | 0);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 33192 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 32424 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 32424 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 32424 + (i1 * 12 | 0) >> 2] = fb + 217;
 if (!(__Z13GetIAnimationv() | 0)) {
  STACKTOP = i5;
  return;
 }
 i4 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63320 | 0, 16, gb + 406663 | 0, 51) | 0;
 HEAP32[i4 >> 2] = gb + 43452 + 8;
 HEAP32[i4 + 4 >> 2] = 120;
 i3 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, 120, 29, i4 | 0);
 HEAP32[gb + 1158200 >> 2] = i4;
 STACKTOP = i5;
 return;
}

function __Z40PhysicsMaterial2D_CUSTOM_Internal_CreateP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(44, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 808253 | 0, 3746) | 0;
 i9 = gb + 63520 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17PhysicsMaterial2DC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
 __Z19pop_allocation_rootv();
 i2 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
 __Z16SmartResetObjectR6Object(i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) | 0;
 STACKTOP = i3;
 return;
}

function __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i3, i2, i8) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i1 | 0) >= (i5 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i5 | 0)) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) {
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i1 | 0) <= -1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZNK19ShaderPropertySheet14GetVectorArrayEi(i6, i3, i1);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i6 = __Z23GetCoreScriptingClassesv() | 0;
 i7 = (i2 | 0) == 0 ? 0 : i1;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8 ? HEAP32[i6 + 120 >> 2] | 0 : HEAP32[i6 + 460 >> 2] | 0, 16, i7) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 16) | 0, i2 | 0, i7 << 4 | 0) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf(i8, i2, i1, i3, i9) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = HEAP32[i8 + 8 >> 2] | 0;
 i5 = (i2 | 0) < 0;
 if (i5) i6 = 3; else if (!((i1 | 0) > -1 & (i4 | 0) > (i2 | 0) & (i7 | 0) > (i1 | 0))) i6 = 3;
 do if ((i6 | 0) == 3) {
  if (i3 | 0) {
   if ((i4 | 0) < 1) i2 = 0; else {
    i3 = i4 + -1 | 0;
    if (i5) i2 = 0; else i2 = (i3 | 0) < (i2 | 0) ? i3 : i2;
   }
   if ((i7 | 0) < 1) {
    i1 = 0;
    break;
   }
   i3 = i7 + -1 | 0;
   if ((i1 | 0) < 0) {
    i1 = 0;
    break;
   }
   i1 = (i3 | 0) < (i1 | 0) ? i3 : i1;
   break;
  }
  if (!i4) i2 = 0; else {
   if (i5) i2 = (Math_imul(1 - ((i2 | 0) / (i4 | 0) | 0) | 0, i4) | 0) + i2 | 0;
   i2 = (i2 | 0) % (i4 | 0) | 0;
  }
  if (!i7) i1 = 0; else {
   if ((i1 | 0) < 0) i1 = (Math_imul(1 - ((i1 | 0) / (i7 | 0) | 0) | 0, i7) | 0) + i1 | 0;
   i1 = (i1 | 0) % (i7 | 0) | 0;
  }
 } while (0);
 i7 = HEAP32[i8 >> 2] | 0;
 i8 = (HEAP32[i8 + 16 >> 2] | 0) + (Math_imul(HEAP32[i8 + 12 >> 2] | 0, i1) | 0) | 0;
 __Z10WritePixelPhRK10ColorRGBAf13TextureFormat(i8 + (Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(i7) | 0, i2) | 0) | 0, i9, i7);
 return;
}

function __GLOBAL__sub_I_runtime_graphics_lump_cpp() {
 var i1 = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544239 | 0, fb + 3357 | 0, fb + 3358 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157736 | 0, gb + 397479 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157748 | 0, gb + 397508 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157760 | 0, gb + 397540 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157772 | 0, gb + 397553 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157784 | 0, gb + 397565 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157796 | 0, gb + 397584 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1157808 | 0, gb + 397608 | 0, 2, 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1157820 | 0, 13);
 i1 = gb + 1098048 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1157828 >> 2] = 0;
 HEAP32[gb + 1157828 + 4 >> 2] = 0;
 HEAP32[gb + 1157828 + 8 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE5eraseENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_PvEEiEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  i1 = i4;
  while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i2 = i1;
   break;
  } else i1 = i2;
 }
 if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) HEAP32[i3 >> 2] = i2;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i3 + 4 >> 2] | 0, i4);
 i1 = i4 + 64 | 0;
 if ((HEAP32[i4 + 80 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 68 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 44 | 0;
 if ((HEAP32[i4 + 60 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 48 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i4 + 40 >> 2] | 0) <= -1) {
  __ZdlPv(i4);
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 + 24 >> 2] | 0, i4 + 28 | 0);
 __ZdlPv(i4);
 return i2 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i10, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i11 + 4 | 0;
 i9 = i11;
 i3 = i1 + 8 | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0) | 0;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 4 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i3 + 12 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 16 >> 2] | 0; else i1 = i1 & 255;
 do if ((i2 | 0) == (0 - i1 | 0)) HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4; else {
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
  i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i5, i4, i3, i3 + 24 | 0, i8, i7, 0) | 0) - i3 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  if ((i2 | 0) == 12 & (i1 | 0) == 0) {
   HEAP32[i10 >> 2] = 0;
   break;
  }
  if ((i2 | 0) < 12 & (i1 | 0) == 12) HEAP32[i10 >> 2] = i2 + 12;
 } while (0);
 STACKTOP = i11;
 return;
}

function __ZNK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE(i1, i8, i4, i5, i6, i7, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0;
 i1 = i8 + 368 | 0;
 i2 = HEAP32[i8 + 372 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i4 + 4 >> 2] | 0) >>> 0) _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 }
 i1 = i8 + 356 | 0;
 i2 = HEAP32[i8 + 360 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i5 + 4 >> 2] | 0) >>> 0) _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, i2 << 3 | 0) | 0;
 }
 i1 = i8 + 404 | 0;
 i2 = HEAP32[i8 + 408 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i6 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i6 + 4 >> 2] | 0) >>> 0) _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 }
 i1 = i8 + 392 | 0;
 i2 = HEAP32[i8 + 396 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i7 >> 2] | 0;
  if (i3 >>> 0 < (HEAP32[i7 + 4 >> 2] | 0) >>> 0) _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, i2 << 2 | 0) | 0;
 }
 i1 = HEAP32[i8 + 432 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i9 >> 2] | 0;
 if (i2 >>> 0 >= (HEAP32[i9 + 4 >> 2] | 0) >>> 0) return;
 _memcpy(i2 | 0, HEAP32[i8 + 428 >> 2] | 0, i1 * 12 | 0) | 0;
 return;
}

function __ZN7mecanim5human22HumanComputeMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0, f15 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i6 = i11 + 4 | 0;
 i7 = i11 + 8 | 0;
 f1 = Math_fround(0.0);
 i5 = 0;
 f2 = Math_fround(0.0);
 f3 = Math_fround(0.0);
 f4 = Math_fround(0.0);
 do {
  if ((HEAP32[i9 + 72 + (i5 << 2) >> 2] | 0) > -1) {
   f14 = Math_fround(HEAPF32[i9 + 168 + (i5 << 2) >> 2]);
   __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i11, i9, i10, i5);
   f15 = Math_fround(HEAPF32[i11 >> 2]);
   f13 = Math_fround(HEAPF32[i6 >> 2]);
   f1 = Math_fround(f1 + f14);
   f2 = Math_fround(f2 + Math_fround(f14 * f15));
   f3 = Math_fround(f3 + Math_fround(f14 * Math_fround(HEAPF32[i7 >> 2])));
   f4 = Math_fround(f4 + Math_fround(f14 * f13));
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 24);
 f14 = Math_fround(f4 / f1);
 f15 = Math_fround(f3 / f1);
 HEAPF32[i8 >> 2] = Math_fround(f2 / f1);
 HEAPF32[i8 + 4 >> 2] = f14;
 HEAPF32[i8 + 8 >> 2] = f15;
 STACKTOP = i12;
 return;
}

function __ZN6Shader25SetGlobalMaximumShaderLODEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 8 | 0;
 i6 = i8;
 i7 = i8 + 16 | 0;
 if ((HEAP32[gb + 1166412 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i8;
  return;
 }
 HEAP32[gb + 1166412 >> 2] = i1;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i7 >> 2] = 0;
 i3 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i7 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i6);
 i1 = i2;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i2;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31552 | 0, i7, 0);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN9ShaderLab9IntShader8PostLoadEP6Shader(HEAP32[(HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 32 >> 2] | 0, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i5);
  HEAP32[i7 >> 2] = 0;
 }
 STACKTOP = i8;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN26AnimatorControllerPlayable13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 _strncpy(i2, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 128) | 0;
 HEAP8[i2 + 127 >> 0] = 0;
 i4 = _strlen(i2) | 0;
 i3 = i2 + i4 | 0;
 if ((i4 | 0) > 0) {
  i1 = i2;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i3 = ~i2;
 } else i3 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0, i5 | 0) | 0)) {
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = HEAP32[HEAP32[i5 + 92 >> 2] >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = (HEAP32[i5 + 92 >> 2] | 0) + 4 | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
 i1 = 0;
 while (1) {
  i5 = i2 + (i1 << 2) | 0;
  if ((HEAP32[i5 + (HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0) == (i3 | 0)) {
   i2 = 9;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = -1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN11TimeManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 200 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 196 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 204 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __Z14FindMainCamerav() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = gb + 64016 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 i6 = i5 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 i2 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!((i3 | 0) < 4 | (i1 | 0) != 0 | (i2 | 0) == 0)) i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i2) | 0;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i1;
 __Z22FindGameObjectsWithTagI13dynamic_arrayIP10GameObjectLj4EEEvjRT_(5, i5);
 L4 : do if (!(HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i2 = 0;
  while (1) {
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0, gb + 29832 | 0) | 0;
   if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
    i1 = 0;
    break L4;
   }
  }
 } while (0);
 if ((HEAP32[i6 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __Z13TransferFieldI17RemapPPtrTransferLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 24 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i6 + 16 >> 2] = HEAP32[i3 >> 2];
 i3 = i2 + 24 | 0;
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo(i6, HEAP32[i3 >> 2] | 0);
 __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i6, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i4 >> 2] = i2 + -72;
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i7;
 return;
}

function _process_data_simple_main(i3, i4, i13, i10) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i3 + 320 >> 2] | 0;
 i11 = i1 + 8 | 0;
 i12 = i3 + 224 | 0;
 if ((HEAP32[i11 >> 2] | 0) >>> 0 >= (HEAP32[i12 >> 2] | 0) >>> 0) return;
 i5 = i1 + 12 | 0;
 i6 = i3 + 324 | 0;
 i7 = i1 + 24 | 0;
 i8 = i3 + 328 | 0;
 i9 = i1 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  if (i1 >>> 0 < 8) {
   mftCall_viiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i4 | 0, i13 | 0, i10 | 0, i7 | 0, i5 | 0, 8);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  if ((i1 | 0) != 8) {
   i1 = 12;
   break;
  }
  i1 = (mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i7 | 0) | 0) << 24 >> 24 == 0;
  i2 = (HEAP8[i9 >> 0] | 0) != 0;
  if (i1) {
   i1 = 7;
   break;
  }
  if (i2) {
   HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + 1;
   HEAP8[i9 >> 0] = 0;
  }
  HEAP32[i5 >> 2] = 0;
  i2 = (HEAP32[i11 >> 2] | 0) + 1 | 0;
  HEAP32[i11 >> 2] = i2;
  if (i2 >>> 0 < (HEAP32[i12 >> 2] | 0) >>> 0) i1 = 0; else {
   i1 = 12;
   break;
  }
 }
 if ((i1 | 0) == 7) {
  if (i2) return;
  HEAP32[i13 >> 2] = (HEAP32[i13 >> 2] | 0) + -1;
  HEAP8[i9 >> 0] = 1;
  return;
 } else if ((i1 | 0) == 12) return;
}

function __ZNK9dtNavMesh11getPolyAreaEy(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 if ((i3 & 983040 | 0) == 65536 & 0 == 0) {
  i2 = i3 & 65535;
  if (i2 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
  getTempRet0() | 0;
  i1 = HEAP32[i1 + 48 >> 2] | 0;
  if ((i1 + (i2 * 104 | 0) | 0) == 0 ? 1 : (i6 | 0) != (HEAP32[i1 + (i2 * 104 | 0) + 92 >> 2] | 0)) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = HEAP8[i1 + (i2 * 104 | 0) + 80 >> 0] | 0;
  return i6 | 0;
 }
 if ((i3 | 0) == 0 & (i4 | 0) == 0) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = _bitshift64Lshr(i3 | 0, i4 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i3 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = _bitshift64Lshr(i3 | 0, i4 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 if (i6 >>> 0 >= (HEAP32[i2 + 20 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP8[(HEAP32[i1 + (i5 * 56 | 0) + 16 >> 2] | 0) + (i6 << 5) + 29 >> 0] | 0;
 return i6 | 0;
}

function __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 40 | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1);
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 __ZN4PPtrI11Rigidbody2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 36 | 0, i1);
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig11ConfigValueD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = HEAP32[i5 + 64 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 68 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 76 >> 2] | 0;
  HEAP32[i6 >> 2] = 85;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = i5 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 48 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 32 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 i1 = i5 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 STACKTOP = i7;
 return;
}

function __ZN10GameObject14SwapComponentsEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i8 = i1 + (i2 << 3) | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + (i2 << 3) + 4 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + (i3 << 3) | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
 i3 = i1 + (i3 << 3) + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = i4;
 i1 = HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0;
 i2 = i4;
 if (i1 | 0) if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29672 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29672 + 28 >> 2] | 0) >>> 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 1);
 }
 if (!i4) return;
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 29672 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 29672 + 28 >> 2] | 0) >>> 0) return;
 i1 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 i8 = i4;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 1);
 return;
}

function _UNITY_png_write_pHYs(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i6 = i7;
 HEAP8[i6 >> 0] = i2 >>> 24;
 HEAP8[i6 + 1 >> 0] = i2 >>> 16;
 HEAP8[i6 + 2 >> 0] = i2 >>> 8;
 HEAP8[i6 + 3 >> 0] = i2;
 HEAP8[i6 + 4 >> 0] = i3 >>> 24;
 HEAP8[i6 + 5 >> 0] = i3 >>> 16;
 HEAP8[i6 + 6 >> 0] = i3 >>> 8;
 HEAP8[i6 + 7 >> 0] = i3;
 HEAP8[i6 + 8 >> 0] = i4;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i4 = i1 + 656 | 0;
 HEAP32[i4 >> 2] = 34;
 HEAP8[i5 >> 0] = 0;
 HEAP8[i5 + 1 >> 0] = 0;
 HEAP8[i5 + 2 >> 0] = 0;
 HEAP8[i5 + 3 >> 0] = 9;
 i3 = i5 + 4 | 0;
 HEAP8[i3 >> 0] = 112;
 HEAP8[i5 + 5 >> 0] = 72;
 HEAP8[i5 + 6 >> 0] = 89;
 HEAP8[i5 + 7 >> 0] = 115;
 _UNITY_png_write_data(i1, i5, 8);
 HEAP32[i1 + 372 >> 2] = 1883789683;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i3, 4);
 HEAP32[i4 >> 2] = 66;
 _UNITY_png_write_data(i1, i6, 9);
 _UNITY_png_calculate_crc(i1, i6, 9);
 HEAP32[i4 >> 2] = 130;
 i6 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i5 >> 0] = i6 >>> 24;
 HEAP8[i5 + 1 >> 0] = i6 >>> 16;
 HEAP8[i5 + 2 >> 0] = i6 >>> 8;
 HEAP8[i5 + 3 >> 0] = i6;
 _UNITY_png_write_data(i1, i5, 4);
 STACKTOP = i7;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData14setChassisMassEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, i14 = 0, i15 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i16;
 i14 = i2 + 40 | 0;
 i12 = HEAP32[i14 >> 2] | 0;
 f13 = Math_fround(Math_fround(Math_fround(1.0) / Math_fround(i12 >>> 0)) * f1);
 if (!i12) {
  STACKTOP = i16;
  return;
 }
 i6 = i2 + 32 | 0;
 i7 = i15 + 16 | 0;
 f8 = Math_fround(f13 * Math_fround(93.3155975));
 f1 = Math_fround(Math_fround(f13 * Math_fround(1.24000001)) * Math_fround(9.65999984));
 i2 = i15 + 4 | 0;
 i9 = 0;
 do {
  i3 = i9 >>> 2;
  i4 = HEAP32[i6 >> 2] | 0;
  i5 = i9 & 3;
  i10 = i15;
  i11 = i4 + (i3 * 944 | 0) + (i5 * 48 | 0) | 0;
  i12 = i10 + 48 | 0;
  do {
   HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
   i10 = i10 + 4 | 0;
   i11 = i11 + 4 | 0;
  } while ((i10 | 0) < (i12 | 0));
  HEAPF32[i7 >> 2] = f13;
  HEAPF32[i15 >> 2] = f8;
  HEAPF32[i2 >> 2] = f1;
  __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i4 + (i3 * 944 | 0) | 0, i5, i15);
  i9 = i9 + 1 | 0;
 } while (i9 >>> 0 < (HEAP32[i14 >> 2] | 0) >>> 0);
 STACKTOP = i16;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN17RemapPPtrTransfer8TransferI22ParticleSystemRendererEEvRT_PKc17TransferMetaFlags(i8, i5, i1, i2) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = (i2 | 0) != 0;
 if (i7) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i8, i2);
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i5, i8);
 i2 = i5 + 552 | 0;
 i4 = i8 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i8 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i6 = i8 + 40 | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i1 = i5 + 556 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i5 + 560 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i5 + 564 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 if (!i7) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i8);
 return;
}

function __ZN12FlareManager12RemoveCameraER6Camera(i7, i4) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = i7 + 4 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 if (!i8) i6 = 8; else {
  i1 = i5;
  i3 = i8;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) i6 = 8; else if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) i6 = 8; else i5 = i1;
 }
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i5;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i7 >> 2] | 0) == (i5 | 0)) HEAP32[i7 >> 2] = i1;
 i1 = i7 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i5);
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i5);
  return;
 }
 i2 = i5 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 __ZdlPv(i5);
 return;
}

function __ZN10FileSystem5StartEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(44, gb + 63552 | 0, 16, gb + 773730 | 0, gb + 491774 | 0, gb + 491603 | 0, 352) | 0;
 i7 = gb + 63552 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 + 40 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63552 | 0, 16, gb + 491603 | 0, 66) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 25584 + 8;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 491603 | 0, 71) | 0;
 __ZN16MemoryFileSystemC2EPKc(i3, HEAP32[gb + 70824 >> 2] | 0);
 HEAP32[i2 + 12 >> 2] = i3;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1179016 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK8Vector3fS1_fS1_P10RaycastHitfi23QueryTriggerInteraction(i4, i5, f8, i1, i9, f10, i11, i12) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f8 = Math_fround(f8);
 i1 = i1 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i12 = i12 | 0;
 var f2 = f0, f3 = f0, f6 = f0, f7 = f0, i13 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i14;
 HEAP32[i9 + 40 >> 2] = 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f6 * f6);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f7 * f7));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i13 = 0;
  STACKTOP = i14;
  return i13 | 0;
 }
 HEAPF32[i13 >> 2] = Math_fround(f6 / f3);
 HEAPF32[i13 + 4 >> 2] = Math_fround(f7 / f3);
 HEAPF32[i13 + 8 >> 2] = Math_fround(f2 / f3);
 if (__ZN14PhysicsManager11CapsuleCastERK8Vector3fS2_fS2_fR10RaycastHiti23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i4, i5, f8, i13, f10, i9, i11, i12) | 0) {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i9);
  i1 = 1;
 } else i1 = 0;
 i13 = i1;
 STACKTOP = i14;
 return i13 | 0;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadhEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37300 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i3 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadaEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i4 = (HEAP8[i1 >> 0] | 0) == 0 ? i4 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37252 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do if ((i1 | 0) > 0) {
  i1 = i5 + 16 | 0;
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i3 + (HEAP32[(HEAP32[i5 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i5 + 36 >> 2] | 0, 0 - (HEAP32[i5 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 >>> 0 >= i3 >>> 0) if ((i2 + 1 | 0) >>> 0 <= (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i4, 1);
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z20TexelCoordSolidAngleiffi(i1, f2, f3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f9 = Math_fround(i4 | 0);
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f2 + Math_fround(.5)) * Math_fround(2.0)) / f9) + Math_fround(-1.0));
 f5 = Math_fround(Math_fround(Math_fround(Math_fround(f3 + Math_fround(.5)) * Math_fround(2.0)) / f9) + Math_fround(-1.0));
 f9 = Math_fround(Math_fround(1.0) / f9);
 f10 = Math_fround(f6 - f9);
 f8 = Math_fround(f5 - f9);
 f6 = Math_fround(f9 + f6);
 f5 = Math_fround(f9 + f5);
 f9 = Math_fround(f10 * f10);
 f7 = Math_fround(f8 * f8);
 f3 = Math_fround(f5 * f5);
 f2 = Math_fround(f6 * f6);
 return Math_fround(Math_fround(Math_fround(Math_fround(+Math_atan2(+Math_fround(f10 * f8), +Math_fround(Math_sqrt(Math_fround(Math_fround(f9 + f7) + Math_fround(1.0)))))) - Math_fround(+Math_atan2(+Math_fround(f10 * f5), +Math_fround(Math_sqrt(Math_fround(Math_fround(f9 + f3) + Math_fround(1.0))))))) - Math_fround(+Math_atan2(+Math_fround(f6 * f8), +Math_fround(Math_sqrt(Math_fround(Math_fround(f2 + f7) + Math_fround(1.0))))))) + Math_fround(+Math_atan2(+Math_fround(f6 * f5), +Math_fround(Math_sqrt(Math_fround(Math_fround(f2 + f3) + Math_fround(1.0)))))));
}

function __GLOBAL__sub_I_runtime_animation2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAPF32[gb + 1477092 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1477096 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1477100 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1477104 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1477108 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1477112 >> 2] = Math_fround(1.0);
 HEAPF32[gb + 1477116 >> 2] = Math_fround(-1.0);
 HEAPF32[gb + 1477120 >> 2] = Math_fround(1.0);
 HEAP32[gb + 1466992 >> 2] = -1;
 HEAP32[gb + 1466996 >> 2] = 0;
 HEAP32[gb + 1466996 + 12 >> 2] = 0;
 HEAP32[gb + 1466996 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = gb + 1466996 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467016 | 0, gb + 904379 | 0, 4, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467028 | 0, gb + 904405 | 0, 0, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1573580 | 0, fb + 3801 | 0, fb + 3802 | 0, 0, 0);
 STACKTOP = i1;
 return;
}

function _hypotf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0;
 i6 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = i6 & 2147483647;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 i7 = i6 >>> 0 < i4 >>> 0;
 i3 = i7 ? i4 : i6;
 i4 = i7 ? i6 : i4;
 f2 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f1 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if ((i4 | 0) != 2139095040) {
  if (i3 >>> 0 > 2139095039 | (i4 | 0) == 0 | (i3 - i4 | 0) >>> 0 > 209715199) {
   f1 = Math_fround(f2 + f1);
   break;
  }
  if (i3 >>> 0 > 1568669695) {
   f5 = Math_fround(1237940039999999885912834.0e3);
   f1 = Math_fround(f1 * Math_fround(8.07793567e-28));
   f2 = Math_fround(f2 * Math_fround(8.07793567e-28));
  } else if (i4 >>> 0 < 562036736) {
   f5 = Math_fround(8.07793567e-28);
   f1 = Math_fround(f1 * Math_fround(1237940039999999885912834.0e3));
   f2 = Math_fround(f2 * Math_fround(1237940039999999885912834.0e3));
  } else f5 = Math_fround(1.0);
  d9 = +f2;
  d8 = +f1;
  f1 = Math_fround(f5 * Math_fround(Math_sqrt(Math_fround(d9 * d9 + d8 * d8))));
 } while (0);
 return Math_fround(f1);
}

function __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, f15 = f0, f16 = f0;
 i4 = HEAP32[i4 + 48 >> 2] | 0;
 f16 = Math_fround(HEAPF32[i4 + 96 >> 2]);
 f15 = Math_fround(HEAPF32[i4 + 100 >> 2]);
 f5 = Math_fround(HEAPF32[i4 + 104 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 112 >> 2]);
 f13 = Math_fround(HEAPF32[i4 + 116 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 120 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 128 >> 2]);
 f10 = Math_fround(HEAPF32[i4 + 132 >> 2]);
 f8 = Math_fround(HEAPF32[i4 + 136 >> 2]);
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(Math_fround(Math_fround(f16 * f11) + Math_fround(f15 * f9)) + Math_fround(f5 * f7));
 f6 = Math_fround(Math_fround(Math_fround(f14 * f11) + Math_fround(f13 * f9)) + Math_fround(f6 * f7));
 f7 = Math_fround(Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * f9)) + Math_fround(f8 * f7));
 i4 = f6 > f7;
 f8 = i4 ? f6 : f7;
 HEAPF32[i2 >> 2] = f5 > f8 ? f5 : f8;
 f6 = i4 ? f7 : f6;
 HEAPF32[i3 >> 2] = f5 > f6 ? f6 : f5;
 return;
}

function __ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0;
 f9 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f14 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(f9 * f14);
 f12 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f12 * f10));
 f10 = Math_fround(Math_fround(f14 * f12) + Math_fround(f9 * f10));
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(f14 + f8);
 f13 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f10 = Math_fround(f13 + f10);
 f11 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f7 = Math_fround(f9 * f11);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(f14 + Math_fround(f7 - Math_fround(f12 * f6)));
 f6 = Math_fround(f13 + Math_fround(Math_fround(f12 * f11) + Math_fround(f9 * f6)));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f11 = Math_fround((f10 < f6 ? f10 : f6) - f9);
 HEAPF32[i2 >> 2] = Math_fround((f8 < f7 ? f8 : f7) - f9);
 HEAPF32[i2 + 4 >> 2] = f11;
 f6 = Math_fround(f9 + (f10 > f6 ? f10 : f6));
 HEAPF32[i2 + 8 >> 2] = Math_fround(f9 + (f8 > f7 ? f8 : f7));
 HEAPF32[i2 + 12 >> 2] = f6;
 return;
}

function __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if ((i1 | 0) < 4) {
  switch (i1 | 0) {
  case 3:
   break;
  default:
   return;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i4 + 4 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   do {
    __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i1 + 24 | 0);
    __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i1);
    i1 = i1 + 48 | 0;
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i1 | 0) != (i2 + ((HEAP32[i3 >> 2] | 0) * 48 | 0) | 0));
   i1 = i2;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
  return;
 }
 if ((i1 | 0) >= 3145733) {
  switch (i1 | 0) {
  case 3145733:
   break;
  default:
   return;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 64016 | 0);
  return;
 }
 switch (i1 | 0) {
 case 4:
  break;
 default:
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i4 + 4 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  do {
   __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i1);
   i1 = i1 + 24 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i1 | 0) != (i2 + ((HEAP32[i3 >> 2] | 0) * 24 | 0) | 0));
  i1 = i2;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 return;
}

function __ZN9ShaderLab20SerializedSubProgram14SetConstBufferEPKci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, _strlen(i1) | 0);
 __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi(i4, i5, i2);
 i1 = i3 + 172 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 176 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i3 + 168 | 0, i4);
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return;
 } else {
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_(i2, i4);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 48;
  __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN9Projector17RemoveFromManagerEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[gb + 1112268 >> 2] | 0;
 i10 = i1 + 56 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i1 + 60 | 0;
 i3 = i2;
 if ((i3 | 0) == (i11 | 0)) return;
 i12 = i1 + 64 | 0;
 i8 = i1 + 60 | 0;
 while (1) {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = (i1 | 0) == 0;
  if (i6) {
   i4 = i2;
   while (1) {
    i5 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i4 | 0)) break; else i4 = i5;
   }
  } else {
   i4 = i1;
   while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i5 = i4;
     break;
    } else i4 = i5;
   }
  }
  if ((HEAP32[i3 + 20 >> 2] | 0) == (i9 | 0)) {
   i7 = i2;
   if (i6) {
    i4 = i7;
    while (1) {
     i1 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break; else i4 = i1;
    }
   } else while (1) {
    i4 = HEAP32[i1 >> 2] | 0;
    if (!i4) break; else i1 = i4;
   }
   if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i7);
   __ZdlPv(i2);
  }
  i2 = i5;
  if ((i5 | 0) == (i11 | 0)) break; else i3 = i5;
 }
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN21UnityAnalyticsManagerC2E10MemLabelId18ObjectCreationMode(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i3 = i6;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i5, i4, i2);
 HEAP32[i5 >> 2] = gb + 188476 + 8;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP8[i5 + 32 >> 0] = 1;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 18524 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i6 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 17756 + (i1 * 12 | 0) + 4 >> 2] = i5;
 HEAP8[i2 + 17756 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i2 + 17756 + (i1 * 12 | 0) >> 2] = fb + 199;
 STACKTOP = i6;
 return;
}

function __ZN13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 5;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 5;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 5, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 8, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 5 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 5) | 0;
 _memmove(i14 + (i8 << 5) | 0, i14 | 0, i11 << 5 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13GfxDeviceGLES25GenerateRenderSurfaceMipsEP17RenderSurfaceBase(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 8 | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i2, i1, i3);
  i2 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i6 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i6 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i6;
 if (!i6) {
  STACKTOP = i5;
  return;
 }
 __ZN7ApiGLES14GenerateMipmapEj16TextureDimension(i4 + 4620 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __Z52MonoBehaviour_CUSTOM_StopCoroutineViaEnumerator_AutoP12Il2CppObjectS0_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i4);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549162 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 549162 | 0, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN13MonoBehaviour34StopCoroutineFromEnumeratorManagedEP12Il2CppObject(i1, i4);
  STACKTOP = i5;
  return;
 }
}

function __Z13TransferFieldI18StreamedBinaryReadILb1EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i6 = i2 + 11 | 0;
 i7 = __Z20scripting_string_newPKc((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
 i4 = HEAP32[i4 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i4 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0 : i4) >> 2] = i7;
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 STACKTOP = i3;
 return;
}

function __Z13TransferFieldI18StreamedBinaryReadILb0EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i6, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i6);
 i6 = i2 + 11 | 0;
 i7 = __Z20scripting_string_newPKc((HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
 i4 = HEAP32[i4 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + ((HEAP8[i5 >> 0] | 0) == 0 ? i4 + -8 + (HEAP32[i5 + 12 >> 2] | 0) | 0 : i4) >> 2] = i7;
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 STACKTOP = i3;
 return;
}

function _UNITY_TT_Run_Context(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 356 >> 2] = HEAP32[i1 + 460 >> 2];
 HEAP32[i1 + 364 >> 2] = HEAP32[i1 + 464 >> 2];
 HEAP32[i1 + 360 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 3;
 i2 = i1 + 144 | 0;
 i3 = i1 + 36 | 0;
 i4 = i2;
 i5 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i1 + 72 | 0;
 i4 = i2;
 i5 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i1 + 108 | 0;
 i4 = i2;
 i5 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP16[i1 + 344 >> 1] = 1;
 HEAP16[i1 + 346 >> 1] = 1;
 HEAP16[i1 + 348 >> 1] = 1;
 i4 = i1 + 294 | 0;
 HEAP16[i4 >> 1] = 16384;
 HEAP16[i1 + 296 >> 1] = 0;
 i5 = i1 + 298 | 0;
 i4 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
 HEAP16[i5 >> 1] = i4;
 HEAP16[i5 + 2 >> 1] = i4 >>> 16;
 i5 = i1 + 290 | 0;
 HEAP16[i5 >> 1] = i4;
 HEAP16[i5 + 2 >> 1] = i4 >>> 16;
 HEAP32[i1 + 312 >> 2] = 1;
 HEAP32[i1 + 304 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 652 >> 2] | 0, i1 | 0) | 0;
}

function _wms_write(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 HEAP32[i6 >> 2] = i3;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 i7 = i8 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + i1 | 0;
 i5 = i8 + 20 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  i3 = i8 + 12 | 0;
  i9 = 6;
 } else {
  i2 = i3 + 1 | i2 << 1 | 1;
  if (i2 >>> 0 > 536870911) i1 = 0; else {
   i3 = i8 + 12 | 0;
   i4 = _realloc(HEAP32[i3 >> 2] | 0, i2 << 2) | 0;
   if (!i4) i1 = 0; else {
    HEAP32[i3 >> 2] = i4;
    HEAP32[HEAP32[i8 >> 2] >> 2] = i4;
    i4 = HEAP32[i5 >> 2] | 0;
    _memset((HEAP32[i3 >> 2] | 0) + (i4 << 2) | 0, 0, i2 - i4 << 2 | 0) | 0;
    HEAP32[i5 >> 2] = i2;
    i4 = HEAP32[i7 >> 2] | 0;
    i9 = 6;
   }
  }
 }
 if ((i9 | 0) == 6) {
  i2 = _mbsnrtowcs((HEAP32[i3 >> 2] | 0) + (i4 << 2) | 0, i6, i1, i2 - i4 | 0, i8 + 24 | 0) | 0;
  if ((i2 | 0) == -1) i1 = 0; else {
   i3 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
   HEAP32[i7 >> 2] = i3;
   i2 = i8 + 16 | 0;
   if (i3 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) HEAP32[i2 >> 2] = i3;
   HEAP32[HEAP32[i8 + 4 >> 2] >> 2] = i3;
  }
 }
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN5physx2Sn12RepXUpgrader17upgradeCollectionERNS0_14RepXCollectionE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i3 = __ZN5physx2Sn14RepXCollection16getLatestVersionEv() | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i3 = i1;
  return i3 | 0;
 }
 if ((i2 | 0) != 0 & (i3 | 0) != 0) {
  if ((_strcmp(i2, i3) | 0) == 0 | (i2 | 0) == 0) {
   i3 = i1;
   return i3 | 0;
  }
 } else if (!i2) {
  i3 = i1;
  return i3 | 0;
 }
 if ((i2 | 0) == (gb + 766693 | 0)) i2 = 0; else if (!(_strcmp(i2, gb + 766693 | 0) | 0)) i2 = 0; else if ((i2 | 0) == (gb + 766697 | 0)) i2 = 1; else if (!(_strcmp(i2, gb + 766697 | 0) | 0)) i2 = 1; else if ((i2 | 0) == (gb + 756441 | 0)) i2 = 2; else if (!(_strcmp(i2, gb + 756441 | 0) | 0)) i2 = 2; else if ((i2 | 0) == (gb + 763455 | 0)) i2 = 3; else if (!(_strcmp(i2, gb + 763455 | 0) | 0)) i2 = 3; else if ((i2 | 0) == (gb + 764812 | 0)) i2 = 4; else if (!(_strcmp(i2, gb + 764812 | 0) | 0)) i2 = 4; else if ((i2 | 0) == (gb + 766701 | 0)) i2 = 5; else if (!(_strcmp(i2, gb + 766701 | 0) | 0)) i2 = 5; else {
  i3 = i1;
  return i3 | 0;
 }
 do {
  if (13 >>> i2 & 1) i1 = mftCall_ii(HEAP32[gb + 146344 + (i2 << 2) >> 2] | 0, i1 | 0) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 return i1 | 0;
}

function __ZN5physx2Sc10NPhaseCore28reserveContactReportPairDataEjjRj(i12, i2, i1, i11) {
 i12 = i12 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13 + 1 | 0;
 i5 = i13;
 i8 = i12 + 44 | 0;
 i9 = ((((i1 & 15 | 0) != 0 & 1) << 4) + i1 & -16) + (i2 << 5) | 0;
 i10 = i12 + 48 | 0;
 i6 = HEAP32[i10 >> 2] | 0;
 i7 = i6 + 15 & -16;
 HEAP32[i11 >> 2] = i7;
 i2 = i12 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i7 + i9 | 0) >>> 0 > i3 >>> 0) {
  if (!(HEAP8[i12 + 64 >> 0] | 0)) i1 = i3; else {
   i12 = 0;
   STACKTOP = i13;
   return i12 | 0;
  }
  do {
   i1 = i1 << 1;
   HEAP32[i2 >> 2] = i1;
  } while (((HEAP32[i11 >> 2] | 0) + i9 | 0) >>> 0 > i1 >>> 0);
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i1, gb + 705933 | 0, 150) | 0;
  _memcpy(i2 | 0, HEAP32[i8 >> 2] | 0, i3 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i8 >> 2] | 0);
  HEAP32[i8 >> 2] = i2;
  i1 = HEAP32[i11 >> 2] | 0;
 } else {
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i7;
 }
 HEAP32[i12 + 60 >> 2] = i1;
 HEAP32[i10 >> 2] = i9 - i6 + i7 + (HEAP32[i10 >> 2] | 0);
 i12 = i2 + i1 | 0;
 STACKTOP = i13;
 return i12 | 0;
}

function __ZN4Halo17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[gb + 1110376 >> 2] | 0;
 i6 = i1 + 44 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == (i1 | 0)) {
   i5 = 8;
   break;
  }
  i3 = i2 + 40 | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i4 | 0)) break; else i2 = i3;
 }
 if ((i5 | 0) == 8) {
  HEAP32[i6 >> 2] = 0;
  return;
 }
 if ((i3 | 0) != (i1 | 0)) {
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   i5 = i2 + 28 | 0;
   i4 = i3 + 28 | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i3 = i3 + 40 | 0;
   i2 = i2 + 40 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   HEAP32[i6 >> 2] = 0;
   return;
  }
 }
 HEAP32[i7 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN24OcclusionCullingSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 34976 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12b2MouseJointC2EPK15b2MouseJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152372 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 76 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 104 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 88 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 return;
}

function __ZN4Halo13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i2, i1);
 if (i1 & 1 | 0) {
  STACKTOP = i9;
  return;
 }
 i6 = HEAP32[i2 + 44 >> 2] | 0;
 if (!i6) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[gb + 1110376 >> 2] | 0;
 i3 = i2 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0);
 i5 = HEAP32[i2 + 36 >> 2] | 0;
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 i3 = 1 << HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i8 = 7;
   break;
  }
 }
 if ((i8 | 0) == 7) {
  STACKTOP = i9;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i3;
 STACKTOP = i9;
 return;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperation7ExecuteEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 16 | 0;
 i5 = __ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0;
 i6 = i1 + 192 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i2, i5, i1 + 208 | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 176 | 0, i2) | 0;
 i3 = HEAP32[gb + 1104184 >> 2] | 0;
 if (i3 | 0) {
  i6 = i3;
  __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i6, fb + 3305 | 0, i1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 }
 __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(gb + 1104184 | 0);
 i6 = HEAP32[gb + 1104184 >> 2] | 0;
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i6, fb + 3305 | 0, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN19ShaderPropertySheet5ClearEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = i3 + 32 | 0;
 if (i1) {
  HEAP32[i3 + 44 >> 2] = 0;
  HEAP32[i3 + 64 >> 2] = 0;
  HEAP32[i3 + 84 >> 2] = 0;
  i2 = i3 + 96 | 0;
  HEAP32[i2 >> 2] = 0;
  i3 = i3 + 92 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i1 = i3 + 48 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 36 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 52 | 0;
 i2 = i3 + 68 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 88 | 0;
 i2 = i3 + 72 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 76 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i3 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i3 + 92 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN15AudioEchoFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  return;
 }
}

function __ZN10GameObject18UpdateActiveGONodeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 72 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i3) | 0)) return;
 i2 = HEAP32[gb + 1104660 >> 2] | 0;
 if (!(HEAP16[i3 + 52 >> 1] | 0)) {
  i2 = i2 + 8 | 0;
  if ((i4 | 0) == (i2 | 0)) return;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i3 + 72 | 0; else {
   i3 = i3 + 72 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  return;
 } else {
  if ((i4 | 0) == (i2 | 0)) return;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i3 + 72 | 0; else {
   i3 = i3 + 72 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
   HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i3 >> 2] = 0;
   i1 = i3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
  return;
 }
}

function __ZL44RenderRemainingObjectsThatCantHandleDeferred13RenderingPathR17RenderLoopContextRK11CullResultsbP13RenderTextureS6_R13dynamic_arrayI16RenderObjectDataLj4EE(i1, i2, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0;
 if (!(HEAP32[i8 + 12 >> 2] | 0)) return;
 i3 = __Z17GetRenderSettingsv() | 0;
 if ((i1 | 0) == 3) {
  i1 = (HEAP8[i3 + 312 >> 0] | 0) != 0;
  __ZN14RenderSettings16SetUseFogNoDirtyEb(i3, 0);
  __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE(i2, i8, i4, 1, 1, 0, 128);
  __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext(i2, i6, i7, i8, i5, 1, 1, HEAP32[gb + 1166248 >> 2] | 0);
  __ZN14RenderSettings16SetUseFogNoDirtyEb(i3, i1);
  return;
 } else {
  __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE(i2, i8, i4, 1, 1, 0, 128);
  __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext(i2, i6, i7, i8, i5, 1, 1, HEAP32[gb + 1166248 >> 2] | 0);
  return;
 }
}

function __ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i3, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 1, i6, i7) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = i2 + 80 | 0;
 if (i3) {
  i2 = 0;
  do {
   i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i6, i7) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  return i1 | 0;
 } else i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
  if (HEAP8[i2 + 54 >> 0] | 0) i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i6, i7) | 0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i3, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 1, i6, i7) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = i2 + 80 | 0;
 if (i3) {
  i2 = 0;
  do {
   i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i6, i7) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  return i1 | 0;
 } else i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
  if (HEAP8[i2 + 54 >> 0] | 0) i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i6, i7) | 0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, i3, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 1, i6, i7) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = i2 + 80 | 0;
 if (i3) {
  i2 = 0;
  do {
   i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 28 >> 2] | 0, 1, i6, i7) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
  return i1 | 0;
 } else i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 28 >> 2] | 0;
  if (HEAP8[i2 + 54 >> 0] | 0) i1 = i1 | (__ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i2, 0, i6, i7) | 0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return i1 | 0;
}

function __Z29CullShadowCastersWithoutUmbraR9IndexListRK22SceneCullingParametersPK4AABBjj(i13, i1, i7, i2, i8) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i14;
 i10 = i1 + 352 | 0;
 if (i2 >>> 0 >= i8 >>> 0) {
  i12 = 0;
  i13 = i13 + 4 | 0;
  HEAP32[i13 >> 2] = i12;
  STACKTOP = i14;
  return;
 }
 i11 = i9 + 4 | 0;
 i12 = i9 + 8 | 0;
 i4 = i9 + 12 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9 + 20 | 0;
 i3 = i1 + 188 | 0;
 i1 = 0;
 do {
  HEAP32[i9 >> 2] = HEAP32[i7 + (i2 * 24 | 0) >> 2];
  HEAP32[i11 >> 2] = HEAP32[i7 + (i2 * 24 | 0) + 4 >> 2];
  HEAP32[i12 >> 2] = HEAP32[i7 + (i2 * 24 | 0) + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i7 + (i2 * 24 | 0) + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i7 + (i2 * 24 | 0) + 16 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i7 + (i2 * 24 | 0) + 20 >> 2];
  if (__Z33IntersectAABBPlaneBoundsOptimizedRK4AABBPKN4math7_float4Ei(i9, i10, HEAP32[i3 >> 2] | 0) | 0) {
   HEAP32[(HEAP32[i13 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 i13 = i13 + 4 | 0;
 HEAP32[i13 >> 2] = i1;
 STACKTOP = i14;
 return;
}

function _UNITY_tt_face_get_location(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i5 + 696 >> 2] | 0;
 if (i4 >>> 0 > i1 >>> 0) {
  i3 = HEAP32[i5 + 700 >> 2] | 0;
  if (!(HEAP16[i5 + 210 >> 1] | 0)) {
   i1 = i3 + (i1 << 1) + 2 | 0;
   i2 = i1 + -2 | 0;
   i2 = HEAPU8[i2 >> 0] << 8 | HEAPU8[i2 + 1 >> 0];
   i1 = i1 + 2 | 0;
   if (i1 >>> 0 > (i3 + (i4 << 1) | 0) >>> 0) i1 = i2; else {
    i1 = i1 + -2 | 0;
    i1 = HEAPU8[i1 >> 0] << 8 | HEAPU8[i1 + 1 >> 0];
   }
   i3 = i2 << 1;
   i2 = i1 << 1;
  } else {
   i1 = i3 + (i1 << 2) + 4 | 0;
   i2 = i1 + -4 | 0;
   i2 = HEAPU8[i2 + 1 >> 0] << 16 | HEAPU8[i2 >> 0] << 24 | HEAPU8[i2 + 2 >> 0] << 8 | HEAPU8[i2 + 3 >> 0];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 > (i3 + (i4 << 2) | 0) >>> 0) i3 = i2; else {
    i4 = i1 + -4 | 0;
    i3 = i2;
    i2 = HEAPU8[i4 + 1 >> 0] << 16 | HEAPU8[i4 >> 0] << 24 | HEAPU8[i4 + 2 >> 0] << 8 | HEAPU8[i4 + 3 >> 0];
   }
  }
  i1 = HEAP32[i5 + 668 >> 2] | 0;
  if (i3 >>> 0 > i1 >>> 0) {
   i5 = 0;
   i4 = 0;
   HEAP32[i6 >> 2] = i4;
   return i5 | 0;
  }
 } else {
  i3 = 0;
  i2 = 0;
  i1 = HEAP32[i5 + 668 >> 2] | 0;
 }
 i4 = i2 >>> 0 > i1 >>> 0 ? i1 : i2;
 i5 = i3;
 i4 = (i4 >>> 0 < i3 >>> 0 ? i1 : i4) - i3 | 0;
 HEAP32[i6 >> 2] = i4;
 return i5 | 0;
}

function __ZN5physx7NpScene8addActorERNS_7PxActorE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4 + 4 | 0;
 i1 = HEAP16[i2 >> 1] | 0;
 do if (i1 << 16 >> 16 == 6) {
  if (__ZNK5physx13NpRigidStatic23checkConstraintValidityEv(i4) | 0) {
   i1 = HEAP16[i2 >> 1] | 0;
   break;
  }
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 339, gb + 709566 | 0, i3);
  STACKTOP = i7;
  return;
 } while (0);
 switch ((HEAP32[i4 + ((HEAP32[gb + 1457020 + 68 + ((i1 & 65535) << 2) >> 2] | 0) + 4) >> 2] | 0) >>> 30 | 0) {
 case 0:
  {
   i1 = 7;
   break;
  }
 case 3:
  {
   if ((__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i4) | 0) == (i5 | 0)) i1 = 7; else i1 = 8;
   break;
  }
 default:
  i1 = 8;
 }
 if ((i1 | 0) == 7) {
  __ZN5physx7NpScene16addActorInternalERNS_7PxActorE(i5, i4);
  STACKTOP = i7;
  return;
 } else if ((i1 | 0) == 8) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 347, gb + 709646 | 0, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx21PxcArticulationHelper12saveVelocityERKNS_25PxcArticulationSolverDescE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1024 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i3 + 128 | 0;
 __ZN5physx18PxcFsFlushVelocityERNS_9PxcFsDataE(i3);
 i5 = i3 + 8 | 0;
 if (HEAP16[i5 >> 1] | 0) {
  i1 = i1 + 8 | 0;
  i2 = 0;
  do {
   i8 = HEAP32[i1 >> 2] | 0;
   i9 = i8 + (i2 << 5) | 0;
   i10 = i4 + (i2 << 5) | 0;
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   i8 = i8 + (i2 << 5) + 16 | 0;
   i9 = i4 + (i2 << 5) + 16 | 0;
   HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAPU16[i5 >> 1] | 0) >>> 0);
 }
 __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE(i6, i3, i4);
 __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE(i3, i4, i6);
 STACKTOP = i7;
 return;
}

function __ZN14PhysicMaterial13SetBouncinessEf(i7, f3) {
 i7 = i7 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i2 = i8 + 16 | 0;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0);
 if (i4 | i5) {
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0) | 0;
  HEAPF64[i6 + 8 >> 3] = +f3;
  __Z6FormatPKcz(i2, gb + 781368 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 737252 | 0, 199, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = i4 ? 0 : i5 ? 1065353216 : (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 }
 HEAP32[i7 + 48 >> 2] = i1;
 i2 = HEAP32[i7 + 52 >> 2] | 0;
 if (!i2) {
  __ZN14PhysicMaterial15ChangedMaterialEv(i7);
  STACKTOP = i8;
  return;
 }
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, +(HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 __ZN14PhysicMaterial15ChangedMaterialEv(i7);
 STACKTOP = i8;
 return;
}

function __ZN13CameraLODData5ClearEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 16 | 0;
 i2 = i5 + 28 | 0;
 HEAP32[i2 >> 2] = 1;
 i3 = i5 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if (!(i4 & 2147483647)) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 1, 1, i5 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1, 1, i5 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = i4;
  break;
 } while (0);
 i1 = i5 + 36 | 0;
 i2 = i5 + 48 | 0;
 HEAP32[i2 >> 2] = 1;
 i3 = i5 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 & 2147483647 | 0) return;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 4, 4, i5 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4, 4, i5 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = i5;
  return;
 }
}

function __Z15Transfer_StringI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE(i5 + 24 | 0, HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i7) >> 2] | 0, i4);
 __ZN9JSONWrite8TransferINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags(i6, i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 STACKTOP = i5;
 return;
}

function __ZN9Coroutine14InvokeMoveNextEPP15Il2CppException(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 248 | 0;
 i4 = i3 + 256 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 HEAP8[i4 >> 0] = 0;
 i10 = (__Z23GetCoreScriptingClassesv() | 0) + 400 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i6);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i5, HEAP32[i1 + 8 >> 2] | 0);
 __ZN18ScriptingArguments9AddIntPtrEPv(i5, i4);
 i6 = i1 + 40 | 0;
 HEAP32[i5 + 220 >> 2] = __ZNK13MonoBehaviour8GetClassEv(HEAP32[i6 >> 2] | 0) | 0;
 i7 = i5 + 224 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i7 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 HEAP32[i5 + 216 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2];
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i2, 0) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i10 = 0;
  STACKTOP = i3;
  return i10 | 0;
 }
 i10 = (HEAP32[i2 >> 2] | 0) == 0;
 STACKTOP = i3;
 return i10 | 0;
}

function __ZN8Renderer15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31312 | 0, gb + 1105016 | 0, fb + 512 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31312 | 0, gb + 1105216 | 0, fb + 513 | 0, 0);
 __Z43InitializeRendererAnimationBindingInterfacev();
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 12348 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 11580 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 11580 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 11580 + (i1 * 12 | 0) >> 2] = fb + 49;
 STACKTOP = i5;
 return;
}

function __ZN5physx18NpArticulationLink18setAngularVelocityERKNS_6PxVec3Eb(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i9) | 0;
 i4 = i9 + 48 | 0;
 HEAP32[i9 + 264 >> 2] = HEAP32[i7 >> 2];
 i5 = i7 + 4 | 0;
 HEAP32[i9 + 268 >> 2] = HEAP32[i5 >> 2];
 i6 = i7 + 8 | 0;
 HEAP32[i9 + 272 >> 2] = HEAP32[i6 >> 2];
 switch ((HEAP32[i9 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = 5;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 4; else i2 = 5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAP32[i9 + 160 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 164 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 168 >> 2] = HEAP32[i6 >> 2];
 } else if ((i2 | 0) == 5) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i4);
  i4 = i9 + 284 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2097152;
 }
 if (!i3) return;
 i7 = Math_fround(HEAPF32[i7 >> 2]) == Math_fround(0.0);
 if (i7 & Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i6 >> 2]) != Math_fround(0.0); else i1 = 1;
 __ZN5physx14NpArticulation14wakeUpInternalEbb(HEAP32[i9 + 288 >> 2] | 0, i1, i8);
 return;
}

function __ZN4Mesh26CreateDefaultFormatChannelE13ShaderChannel(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i4 = i7;
 i8 = HEAP32[i2 + 32 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i6 = HEAP32[i8 + 100 >> 2] | 0;
 i1 = 1 << i1;
 if (!(HEAP32[i8 + 176 >> 2] | 0)) if ((HEAP32[i2 + 116 >> 2] | 0) == (HEAP32[i2 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i3, i5);
  HEAP32[i3 >> 2] = (HEAP32[i3 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i3 + 8 >> 2] & ~HEAP32[i3 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i5, i6, i1, 0, i4, gb + 1546313 | 0);
  STACKTOP = i7;
  return;
 };
 HEAP32[i4 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i5, i6, i1, 0, i4, gb + 1546313 | 0);
 STACKTOP = i7;
 return;
}

function __ZN18UnityPropertySheet11UnityTexEnv8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 16 | 0, i1);
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN11CullResults11InitDynamicEPK16RendererCullData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = i3;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = i3;
 i3 = HEAP32[i2 + 44 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = i3;
 i3 = HEAP32[i2 + 56 >> 2] | 0;
 HEAP32[i1 + 64 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i3;
 if (HEAP32[i1 + 80 >> 2] | 0) return;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = i3;
 return;
}

function __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 32 | 0;
 i4 = i6 + 20 | 0;
 i7 = i6;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i8 = HEAP32[i1 + 44 >> 2] | 0;
 i10 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i2 = i9 + (i8 << 6) | 0;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 8 >> 2] = i2;
 i2 = i8 << 6 >> 6;
 HEAP32[i7 + 16 >> 2] = i2;
 HEAP32[i7 + 12 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i5, i4, 0); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z33Screen_Get_Custom_PropResolutionsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i8 + 12 | 0;
 i6 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 320 >> 2] | 0;
 i7 = __Z16GetScreenManagerv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i7 | 0, 0, 0);
 i7 = i5 + 4 | 0;
 i6 = __Z19scripting_array_newP11Il2CppClassjj(i6, 12, ((HEAP32[i7 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0) / 12 | 0) | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = i3;
 if ((i1 | 0) != (i3 | 0)) {
  i3 = 0;
  do {
   _memmove(i4 | 0, i2 + (i3 * 12 | 0) | 0, 12) | 0;
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, i3, 12) | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   i9 = HEAP32[i5 >> 2] | 0;
   i2 = i9;
  } while (i3 >>> 0 < ((i1 - i9 | 0) / 12 | 0) >>> 0);
 }
 if (!i2) {
  STACKTOP = i8;
  return i6 | 0;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i7 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i2);
 STACKTOP = i8;
 return i6 | 0;
}

function __Z32Texture3D_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormath(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 16 | 0;
 i10 = i8;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 1034) | 0;
 i13 = gb + 63520 | 0;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i11 = i10;
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i11 + 4 >> 2] = i12;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN9Texture3DC2E10MemLabelId18ObjectCreationMode(i3, i9, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 if (__ZN9Texture3D11InitTextureEiii13TextureFormatb(i3, i2, i4, i5, i6, i7 << 24 >> 24 != 0) | 0) {
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  STACKTOP = i8;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570235 | 0, i8 + 8 | 0);
}

function __Z31Font_CUSTOM_Internal_CreateFontP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3 + 8 | 0;
 i6 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 1008295 | 0, 641) | 0;
 i9 = gb + 63520 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13TextRendering4FontC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
 __Z19pop_allocation_rootv();
 i2 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
 __Z16SmartResetObjectR6Object(i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) | 0;
 STACKTOP = i3;
 return;
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = (i5 - i3 | 0) / 68 | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE8__appendEj(i1, i2 - i4 | 0);
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) return;
 i7 = i3 + (i2 * 68 | 0) | 0;
 if ((i5 | 0) == (i7 | 0)) return;
 do {
  i6 = i5 + -68 | 0;
  HEAP32[i8 >> 2] = i6;
  i1 = HEAP32[i5 + -12 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = i5 + -8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i1);
  }
  i1 = HEAP32[i5 + -24 >> 2] | 0;
  i2 = i1;
  if (i1 | 0) {
   i3 = i5 + -20 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -32 - i2 | 0) >>> 5) << 5);
   __ZdlPv(i1);
  }
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i1 = i5 + -64 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -32 - i4 | 0) >>> 5) << 5);
   __ZdlPv(i3);
  }
  i5 = HEAP32[i8 >> 2] | 0;
 } while ((i5 | 0) != (i7 | 0));
 return;
}

function __ZN8TypeTree16AssignByteOffsetERK16TypeTreeIteratorj(i7, i1, i11) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i1 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 40 | 0;
 i6 = i7 + 52 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 >= i10 >>> 0) {
  i5 = i1 + 1 | 0;
  HEAP32[i6 >> 2] = i5;
  i2 = i7 + 56 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 & 2147483647;
  do if (i4 >>> 0 < i5 >>> 0) {
   i1 = i3 << 1;
   i1 = i1 >>> 0 > i5 >>> 0 ? i1 : i5;
   if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
    HEAP32[i2 >> 2] = i1;
    HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 44 | 0, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    HEAP32[i2 >> 2] = i1;
    HEAP32[i9 >> 2] = i7;
    break;
   }
  } while (0);
  if (i5 >>> 0 > i10 >>> 0) {
   i1 = i5 - i10 | 0;
   if (i1 | 0) _memset((HEAP32[i9 >> 2] | 0) + (i10 << 2) | 0, -1, i1 << 2 | 0) | 0;
  }
 }
 HEAP32[(HEAP32[i9 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) >> 2] = i11;
 return;
}

function __ZN8Remapper38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i3 = HEAP32[i1 + 28 >> 2] | 0;
  if ((i3 | 0) <= (i5 | 0)) if ((HEAP32[i1 + 32 >> 2] | 0) >= (i5 | 0)) {
   HEAP32[i6 >> 2] = i2;
   i5 = (i5 - i3 | 0) / 2 | 0;
   i6 = i6 + 8 | 0;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i6 + 4 >> 2] = ((i5 | 0) < 0) << 31 >> 31;
   i6 = 1;
   return i6 | 0;
  }
 }
 i4 = i1 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = i4;
  L8 : while (1) {
   i3 = i2;
   while (1) {
    if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i3 + 4 >> 2] | 0;
    if (!i2) break L8; else i3 = i2;
   }
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i1 = i3;
    break;
   } else i1 = i3;
  }
  if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i5 | 0)) {
   i5 = i1 + 24 | 0;
   HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
   HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
   HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
   i6 = 1;
   return i6 | 0;
  }
 }
 HEAP32[i6 >> 2] = -1;
 i6 = i6 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = 0;
 return i6 | 0;
}

function __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1033949;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1033960 | 0, 0, 0);
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1033967 | 0, 0, 0);
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1033975 | 0, 0, 0);
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1033981 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN6Camera34UpdatePreviousViewProjectionMatrixEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 64 | 0;
 i7 = i8;
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
 i2 = i7;
 i3 = __ZNK6Camera19GetProjectionMatrixEv(i5) | 0;
 i4 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i7 | 0, i1 | 0, i1 ^ 1 | 0);
 i1 = i5 + 36 | 0;
 i2 = i5 + 1076 | 0;
 if (HEAP8[i2 >> 0] | 0) if (HEAP8[i5 + 1080 >> 0] | 0) {
  HEAPF32[i6 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i6 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i1, i6) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i1, i6) | 0;
  HEAP8[i2 >> 0] = 0;
 }
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i7, i1, i5 + 1176 | 0);
 HEAP8[i5 + 1119 >> 0] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj161ES2_RKNS_12PxFilterDataES6_EEEEvjRT_(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 i8 = _strtoul(i1, i4, 10) | 0;
 i1 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i2 = _strtoul(HEAP32[i4 >> 2] | 0, i4, 10) | 0;
 i3 = _strtoul(HEAP32[i4 >> 2] | 0, 0, 10) | 0;
 i7 = HEAP32[i7 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i3;
 mftCall_vii(HEAP32[i6 + 20 >> 2] | 0, i7 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx18NpArticulationLink17setLinearVelocityERKNS_6PxVec3Eb(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i9) | 0;
 i4 = i9 + 48 | 0;
 HEAP32[i9 + 252 >> 2] = HEAP32[i7 >> 2];
 i5 = i7 + 4 | 0;
 HEAP32[i9 + 256 >> 2] = HEAP32[i5 >> 2];
 i6 = i7 + 8 | 0;
 HEAP32[i9 + 260 >> 2] = HEAP32[i6 >> 2];
 switch ((HEAP32[i9 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = 5;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i4 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 4; else i2 = 5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAP32[i9 + 144 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i9 + 148 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i9 + 152 >> 2] = HEAP32[i6 >> 2];
 } else if ((i2 | 0) == 5) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i4);
  i4 = i9 + 284 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1048576;
 }
 if (!i3) return;
 i7 = Math_fround(HEAPF32[i7 >> 2]) == Math_fround(0.0);
 if (i7 & Math_fround(HEAPF32[i5 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i6 >> 2]) != Math_fround(0.0); else i1 = 1;
 __ZN5physx14NpArticulation14wakeUpInternalEbb(HEAP32[i9 + 288 >> 2] | 0, i1, i8);
 return;
}

function __ZN22RenderingCommandBuffer18AddSetGlobalMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i8 = HEAP32[i1 >> 2] | 0;
 i3 = i9;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 i6 = i10 + 8 | 0;
 i7 = i10 + 24 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i3 = i10 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 13;
 i4 = i4 + 7 & -4;
 i5 = i4 + 68 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i3 = i1 + i4 | 0;
 HEAP32[i3 >> 2] = i8;
 i3 = i3 + 4 | 0;
 i2 = i9;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 HEAP8[i10 + 36 >> 0] = 1;
 STACKTOP = i11;
 return;
}

function __ZN17BufferManagerGLES14InsertIntoLiveEP14DataBufferGLES(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 i7 = i8 + 16 + (i9 * 12 | 0) | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = i1;
 i2 = i8 + 16 + (i9 * 12 | 0) + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i4 = i2;
  i3 = i2;
 } else {
  while (1) if ((i6 | 0) < (HEAP32[i1 + 16 >> 2] | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = 4;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 7;
    break;
   } else i1 = i2;
  }
  if ((i2 | 0) == 4) {
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 7) {
   i4 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 16 + (i9 * 12 | 0) + 4 >> 2] | 0, i1);
 i9 = i8 + 16 + (i9 * 12 | 0) + 8 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 return;
}

function __ZN11b2RopeJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, d7 = 0.0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 72 | 0;
 i4 = i2 + 64 | 0;
 i5 = i2 + 48 | 0;
 i8 = i2 + 32 | 0;
 i9 = i2 + 24 | 0;
 i10 = i2 + 16 | 0;
 i12 = i2 + 8 | 0;
 i13 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 __Z5b2LogPKcz(gb + 800564 | 0, i2);
 HEAP32[i12 >> 2] = i13;
 __Z5b2LogPKcz(gb + 799360 | 0, i12);
 HEAP32[i10 >> 2] = i11;
 __Z5b2LogPKcz(gb + 799386 | 0, i10);
 HEAP32[i9 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i9);
 d6 = +Math_fround(HEAPF32[i1 + 68 >> 2]);
 d7 = +Math_fround(HEAPF32[i1 + 72 >> 2]);
 HEAPF64[i8 >> 3] = d6;
 HEAPF64[i8 + 8 >> 3] = d7;
 __Z5b2LogPKcz(gb + 799447 | 0, i8);
 d7 = +Math_fround(HEAPF32[i1 + 76 >> 2]);
 d6 = +Math_fround(HEAPF32[i1 + 80 >> 2]);
 HEAPF64[i5 >> 3] = d7;
 HEAPF64[i5 + 8 >> 3] = d6;
 __Z5b2LogPKcz(gb + 799489 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 84 >> 2]);
 __Z5b2LogPKcz(gb + 800586 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN10GameObject18TransferComponentsI17RemapPPtrTransferEEvRT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if (HEAP32[i8 >> 2] & 16384 | 0) {
  STACKTOP = i10;
  return;
 }
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i8, 65);
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i2 + (i7 << 3) | 0;
 if (i7 | 0) {
  i5 = i8 + 16 | 0;
  i6 = i8 + 36 | 0;
  i7 = i8 + 40 | 0;
  do {
   i3 = i2 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   i11 = HEAP32[i5 >> 2] | 0;
   i1 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i1 | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i7 >> 0] | 0) {
    HEAP32[i9 >> 2] = i1;
    i1 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i9) | 0;
    HEAP32[i3 >> 2] = i1;
    if (HEAP8[i7 >> 0] | 0) {
     if (!i1) i1 = 0; else i1 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
     HEAP32[i2 >> 2] = i1;
    }
   }
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i4 | 0));
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i8);
 STACKTOP = i10;
 return;
}

function _jpeg_huff_decode(i7, i2, i1, i8, i4) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 do if ((i1 | 0) < (i4 | 0)) if (!((_jpeg_fill_bit_buffer(i7, i2, i1, i4) | 0) << 24 >> 24)) {
  i8 = -1;
  return i8 | 0;
 } else {
  i2 = HEAP32[i7 + 8 >> 2] | 0;
  i1 = HEAP32[i7 + 12 >> 2] | 0;
  break;
 } while (0);
 i1 = i1 - i4 | 0;
 i3 = i2 >> i1 & (1 << i4) + -1;
 i5 = i7 + 8 | 0;
 i6 = i7 + 12 | 0;
 L7 : do if ((i3 | 0) > (HEAP32[i8 + (i4 << 2) >> 2] | 0)) {
  while (1) {
   i3 = i3 << 1;
   if ((i1 | 0) < 1) {
    if (!((_jpeg_fill_bit_buffer(i7, i2, i1, 1) | 0) << 24 >> 24)) {
     i1 = -1;
     break;
    }
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i1 = i1 + -1 | 0;
   i3 = i2 >>> i1 & 1 | i3;
   i4 = i4 + 1 | 0;
   if ((i3 | 0) <= (HEAP32[i8 + (i4 << 2) >> 2] | 0)) break L7;
  }
  return i1 | 0;
 } while (0);
 HEAP32[i5 >> 2] = i2;
 HEAP32[i6 >> 2] = i1;
 if ((i4 | 0) > 16) {
  i8 = HEAP32[i7 + 16 >> 2] | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 118;
  mftCall_vii(HEAP32[i7 + 4 >> 2] | 0, i8 | 0, -1);
  i8 = 0;
  return i8 | 0;
 } else {
  i8 = HEAPU8[(HEAP32[i8 + 72 + (i4 << 2) >> 2] | 0) + i3 + ((HEAP32[i8 + 144 >> 2] | 0) + 17) >> 0] | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZNK5Umbra15OcclusionBuffer9getBufferEPvPKNS0_10BufferDescE(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 if (!i5) {
  i6 = 4;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP8[i4 + 1412 >> 0] | 0)) {
  i6 = 5;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!i2) i6 = 5; else {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if (!i1) i6 = 5; else if ((HEAP32[i2 >> 2] | 0) == 64) i6 = 7; else i1 = 1;
 }
 if ((i6 | 0) == 5) {
  HEAP32[i3 >> 2] = 64;
  HEAP32[i3 + 4 >> 2] = 64;
  HEAP32[i3 + 12 >> 2] = 8;
  HEAP32[i3 + 8 >> 2] = 64;
  i2 = i3;
  i1 = 8;
  i6 = 7;
 }
 L12 : do if ((i6 | 0) == 7) if ((HEAP32[i2 + 4 >> 2] | 0) == 64) if ((HEAP32[i2 + 8 >> 2] | 0) < (i1 << 3 & 2040 | 0)) i1 = 2; else switch (i1 | 0) {
 case 8:
  {
   i1 = __ZNK5Umbra18ImpOcclusionBuffer8dump8bppEPhRKNS_15OcclusionBuffer10BufferDescE(i4, i5, i2) | 0;
   break L12;
  }
 case 288:
  {
   i1 = __ZNK5Umbra18ImpOcclusionBuffer9dumpFloatEPfRKNS_15OcclusionBuffer10BufferDescE(i4, i5, i2) | 0;
   break L12;
  }
 default:
  {
   i1 = 3;
   break L12;
  }
 } else i1 = 1; while (0);
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN7ApiGLES11SetCullModeE8CullMode(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 1992 | 0;
 i3 = HEAP8[i4 >> 0] | 0;
 i1 = i5 + 1576 | 0;
 if (i3 << 24 >> 24) if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 switch (i2 | 0) {
 case 0:
  {
   i1 = i5 + 1592 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i3 << 24 >> 24 != 0 & (i2 & 2 | 0) == 0) return;
   HEAP32[i1 >> 2] = i2 & -3;
   mftCall_vi(HEAP32[i5 + 772 >> 2] | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i5 + 860 >> 2] | 0, 1) | 0);
   return;
  }
 case 1:
  {
   mftCall_vi(HEAP32[i5 + 744 >> 2] | 0, 1028);
   i1 = i5 + 1592 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!((HEAP8[i4 >> 0] | 0) == 0 | (i2 & 2 | 0) == 0)) return;
   HEAP32[i1 >> 2] = i2 | 2;
   mftCall_vi(HEAP32[i5 + 768 >> 2] | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i5 + 860 >> 2] | 0, 1) | 0);
   return;
  }
 case 2:
  {
   mftCall_vi(HEAP32[i5 + 744 >> 2] | 0, 1029);
   i1 = i5 + 1592 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (!((HEAP8[i4 >> 0] | 0) == 0 | (i2 & 2 | 0) == 0)) return;
   HEAP32[i1 >> 2] = i2 | 2;
   mftCall_vi(HEAP32[i5 + 768 >> 2] | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i5 + 860 >> 2] | 0, 1) | 0);
   return;
  }
 default:
  return;
 }
}

function __Z43AssetBundleRequest_Get_Custom_PropAllAssetsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i9 = i6 + 8 | 0;
 i8 = i6;
 i5 = i6 + 20 | 0;
 i7 = gb + 64016 | 0;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i3 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 __ZN29AssetBundleLoadAssetOperation18GetAllLoadedAssetsER13dynamic_arrayIP6ObjectLj4EE(i1, i5);
 i1 = __Z36CreateScriptingArrayFromUnityObjectsI13dynamic_arrayIP6ObjectLj4EEEP11Il2CppArrayRKT_i(i5, 0) | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i10, i6, i9) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i11 = 0;
 i3 = i6;
 i1 = i10 + 8 | 0;
 i11 = i1 + 3 | 0;
 i2 = HEAP8[i11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0;
  i8 = HEAP32[i10 + 4 >> 2] | 0;
 } else {
  i1 = 1;
  i8 = i2 & 255;
 }
 i7 = i9 - i3 >> 2;
 do if (i7 | 0) {
  if ((i1 - i8 | 0) >>> 0 < i7 >>> 0) {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i10, i1, i8 + i7 - i1 | 0, i8, i8, 0, 0);
   i1 = HEAP8[i11 >> 0] | 0;
  } else i1 = i2;
  i5 = i1 << 24 >> 24 < 0;
  if (i5) i4 = HEAP32[i10 >> 2] | 0; else i4 = i10;
  i3 = i8 + ((i9 - i3 | 0) >>> 2) | 0;
  i2 = i4 + (i8 << 2) | 0;
  i1 = i6;
  while (1) {
   if ((i1 | 0) == (i9 | 0)) break;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
  HEAP32[i4 + (i3 << 2) >> 2] = 0;
  i1 = i8 + i7 | 0;
  if (i5) {
   HEAP32[i10 + 4 >> 2] = i1;
   break;
  } else {
   HEAP8[i11 >> 0] = i1;
   break;
  }
 } while (0);
 return i10 | 0;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i11;
 i8 = HEAP16[i1 >> 1] | 0;
 i3 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i5 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i5 + i3 | 0;
 i10 = i5 + (i3 + 4) | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i7 = i4 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i7 << 2) >> 2] | 0) + i9 | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i4 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i4 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  HEAP16[i2 >> 1] = i8;
  __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i1, i2);
  STACKTOP = i11;
  return;
 }
 i2 = i5 + (i3 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i7) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 >> 1] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i9);
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | 1;
 STACKTOP = i11;
 return;
}

function __ZN4Mesh9SetBoundsEjRK4AABB(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = (HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 128 >> 2] | 0) + (i1 * 52 | 0) + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i4 >> 2] = gb + 30832;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i5;
 i1 = HEAP32[i5 + 236 >> 2] | 0;
 i3 = i5 + 232 | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  i7 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, gb + 1105176 | 0, i4);
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i3 = i5 + 240 | 0;
 i1 = HEAP32[i5 + 244 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i5 + 356 >> 2] | 0;
 i4 = i6 + 1 | 0;
 if ((i4 | 0) < 2) {
  i8 = -1;
  return i8 | 0;
 }
 i8 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 156 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 156;
 HEAP32[i7 + (i8 * 360 | 0) + 328 >> 2] = i2;
 _memcpy(i2 | 0, i5 + 400 | 0, 152) | 0;
 i1 = i4 << 1;
 i3 = i2 + 152 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i5 + 384 >> 2] | 0;
 i5 = HEAP32[i2 + 180 >> 2] | 0;
 i1 = (Math_imul((i6 << 1) + -2 | 0, (i5 | 0) < 0 ? 0 : i5) | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i2 + 184 >> 2] | 0;
 if ((i2 | 0) > 0) HEAP32[i3 >> 2] = (i2 << 2) + 8 + i1;
 HEAP32[i7 + (i8 * 360 | 0) + 332 >> 2] = fb + 216;
 HEAP32[i7 + (i8 * 360 | 0) + 348 >> 2] = 327681;
 HEAP32[i7 + (i8 * 360 | 0) + 340 >> 2] = fb + 510;
 return i8 | 0;
}

function __ZN13SpeedTreeWind17ComputeWindAnchorEPf(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f1 = f0, f2 = f0, f3 = f0, f4 = f0, f5 = f0, i8 = 0, i9 = 0;
 f1 = Math_fround(HEAPF32[i6 + 1380 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 1384 >> 2]);
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i6 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i6 + 1388 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f4 * f4) + Math_fround(Math_fround(f1 * f1) + Math_fround(f2 * f2)))));
 if (f5 != Math_fround(0.0)) {
  f3 = Math_fround(f1 / f5);
  f2 = Math_fround(f2 / f5);
  f1 = Math_fround(f4 / f5);
 } else {
  f3 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 f4 = Math_fround(HEAPF32[i6 + 1332 >> 2]);
 i9 = i6 + 1344 | 0;
 f5 = Math_fround(f3 * Math_fround(HEAPF32[i9 >> 2]));
 i8 = i6 + 12 | 0;
 HEAPF32[i7 >> 2] = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2])));
 f5 = Math_fround(HEAPF32[i6 + 1336 >> 2]);
 f4 = Math_fround(f2 * Math_fround(HEAPF32[i9 >> 2]));
 HEAPF32[i7 + 4 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i8 >> 2])));
 f4 = Math_fround(HEAPF32[i6 + 1340 >> 2]);
 f5 = Math_fround(f1 * Math_fround(HEAPF32[i9 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i8 >> 2])));
 return;
}

function __ZN11TimeManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 48 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 200 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 196 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 204 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN10FlareLayer12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 29832 | 0) | 0;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 if (i1 | 0) {
  __ZN12FlareManager9AddCameraER6Camera(i1, i2);
  return;
 }
 i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
 if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
  i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i3;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[gb + 1110296 >> 2] = i1;
  __ZN12FlareManager9AddCameraER6Camera(i1, i2);
  return;
 } else {
  i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i1 = i3 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = i1;
  i1 = i3 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[gb + 1110296 >> 2] = i3;
  __ZN12FlareManager9AddCameraER6Camera(i3, i2);
  return;
 }
}

function __ZN7TerrainC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 184192 + 8;
 HEAP8[i1 + 34 >> 0] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 i2 = i1 + 208 | 0;
 HEAP32[i1 + 228 >> 2] = 0;
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 232 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 40 | 0;
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] | 0, i6 | 0) | 0;
 __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 36 | 0, i1);
 i1 = i6 + 44 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN6Socket19PollAsyncConnectionEil(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 136 | 0;
 i2 = i8 + 8 | 0;
 i3 = i8 + 4 | 0;
 i4 = i8;
 i7 = i1;
 i9 = i7 + 128 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 i5 = 1 << (i10 & 31);
 i6 = i10 >>> 5;
 i7 = i1 + (i6 << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | i5;
 i7 = i2;
 i9 = i7 + 128 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 i9 = i2 + (i6 << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | i5;
 switch (_select(i10 + 1 | 0, 0, i1, 0, 0) | 0) {
 case 1:
  {
   HEAP32[i3 >> 2] = 0;
   HEAP32[i4 >> 2] = 4;
   if ((_getsockopt(i10, 1, 4, i3, i4) | 0) > -1) {
    i10 = HEAP32[i3 >> 2] | 0;
    HEAP32[(___errno_location() | 0) >> 2] = i10;
    if (!i10) {
     i10 = 0;
     STACKTOP = i8;
     return i10 | 0;
    }
   }
   i10 = -1;
   STACKTOP = i8;
   return i10 | 0;
  }
 case 0:
  {
   HEAP32[(___errno_location() | 0) >> 2] = 115;
   i10 = -1;
   STACKTOP = i8;
   return i10 | 0;
  }
 default:
  {
   i10 = -1;
   STACKTOP = i8;
   return i10 | 0;
  }
 }
 return 0;
}

function __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i7, i6, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 L1 : do if (i4 | 0) {
  i2 = HEAP32[i4 + 40 >> 2] | 0;
  if (i2 | 0) {
   i3 = HEAP32[i4 + 36 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP8[i3 + (i1 << 3) >> 0] | 0) == 1) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i2 >>> 0) break L1;
   }
   if (HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0) {
    if (i6 | 0) {
     HEAP32[(HEAP32[i4 + 36 >> 2] | 0) + (i1 << 3) + 4 >> 2] = i6;
     return;
    }
    i3 = HEAP32[i4 + 36 >> 2] | 0;
    i7 = i4 + 40 | 0;
    i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
    HEAP32[i7 >> 2] = i6;
    i6 = i3 + (i6 << 3) | 0;
    i7 = HEAP32[i6 + 4 >> 2] | 0;
    i1 = i3 + (i1 << 3) | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i1 + 4 >> 2] = i7;
    i1 = HEAP32[i5 >> 2] | 0;
    if (HEAP32[i1 + 40 >> 2] | 0) return;
    if ((HEAP32[i1 + 44 >> 2] | 0) > -1) __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(HEAP32[gb + 1457204 >> 2] | 0, i1);
    HEAP32[i5 >> 2] = 0;
    return;
   }
  }
 } while (0);
 __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i7, 1, i6, gb + 678148 | 0);
 return;
}

function __ZN13RenderManager21RemoveCameraProjectorEP9Projector(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i1 + 56 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i1 + 60 | 0;
 i3 = i2;
 if ((i3 | 0) == (i11 | 0)) return;
 i12 = i1 + 64 | 0;
 i8 = i1 + 60 | 0;
 while (1) {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = (i1 | 0) == 0;
  if (i6) {
   i4 = i2;
   while (1) {
    i5 = HEAP32[i4 + 8 >> 2] | 0;
    if ((HEAP32[i5 >> 2] | 0) == (i4 | 0)) break; else i4 = i5;
   }
  } else {
   i4 = i1;
   while (1) {
    i5 = HEAP32[i4 >> 2] | 0;
    if (!i5) {
     i5 = i4;
     break;
    } else i4 = i5;
   }
  }
  if ((HEAP32[i3 + 20 >> 2] | 0) == (i9 | 0)) {
   i7 = i2;
   if (i6) {
    i4 = i7;
    while (1) {
     i1 = HEAP32[i4 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break; else i4 = i1;
    }
   } else while (1) {
    i4 = HEAP32[i1 >> 2] | 0;
    if (!i4) break; else i1 = i4;
   }
   if ((HEAP32[i10 >> 2] | 0) == (i3 | 0)) HEAP32[i10 >> 2] = i1;
   HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + -1;
   __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 >> 2] | 0, i7);
   __ZdlPv(i2);
  }
  i2 = i5;
  if ((i5 | 0) == (i11 | 0)) break; else i3 = i5;
 }
 return;
}

function __Z31CubemapArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayiii(i5, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i10 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN12CubemapArray11SetPixels32EiPK11ColorRGBA3211CubemapFaceii(i2, i3, i1, i6, i7, i8);
  STACKTOP = i9;
  return;
 }
}

function __GLOBAL__sub_I_runtime_scripting_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1164184 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1164184 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1164184 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1164184 + 768 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1164956 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1164956 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1164956 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1164956 + 768 >> 2] = 0;
 HEAP32[gb + 1165744 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1165744 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1165744 + 12 >> 2] = 16;
 i1 = gb + 1165744 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3414 | 0, fb + 3415 | 0, 0, gb + 1165744 | 0);
 HEAP32[gb + 1165728 >> 2] = gb + 1165728;
 HEAP32[gb + 1165728 + 4 >> 2] = gb + 1165728;
 HEAP32[gb + 1165728 + 8 >> 2] = 0;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1165728 + 12 >> 2] = i3;
 return;
}

function __ZN8MaterialC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 67512 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1 + 48;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = i1 + 60;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i1 + 72;
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = -1;
 HEAP32[i1 + 96 >> 2] = 5;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN11Rigidbody2D11SetMaterialE4PPtrI17PhysicsMaterial2DE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 i6 = i7 + 16 | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, i8);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 i2 = (__ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE(i2, i6) | 0) == 0;
 if (!(i2 | (HEAP32[i3 >> 2] | 0) == 0)) {
  i1 = HEAP32[i6 >> 2] | 0;
  do {
   __ZN10Collider2D27UpdateColliderMaterialStateEv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb(i6, i5, i2, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i7 + i2 | 0;
 if (HEAP8[i1 >> 0] | 0) return;
 i3 = i6 + 4 | 0;
 i4 = i6 + 8 | 0;
 while (1) {
  HEAP8[i1 >> 0] = 1;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
   __ZN5physx2Gu9Container6ResizeEj(i6, 1) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = i1 + 1;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] = i2;
  i1 = HEAP32[i5 + (i2 * 12 | 0) >> 2] | 0;
  if (!(i1 & 536870912)) __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb(i6, i5, i1 & 536870911, i7);
  i1 = HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0;
  if (!(i1 & 536870912)) __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb(i6, i5, i1 & 536870911, i7);
  i1 = HEAP32[i5 + (i2 * 12 | 0) + 8 >> 2] | 0;
  i2 = i1 & 536870911;
  if (i1 & 536870912 | 0) {
   i1 = 11;
   break;
  }
  i1 = i7 + i2 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 11) return;
}

function __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i3 = i6;
 if ((((HEAP32[i9 >> 2] | 0) - i6 | 0) / 52 | 0) >>> 0 >= i4 >>> 0) return;
 i10 = i8 + 4 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 52 | 0) | 0;
 i1 = i5 + (((i1 - i6 | 0) / 52 | 0) * 52 | 0) | 0;
 i7 = i1;
 i5 = i5 + (i4 * 52 | 0) | 0;
 if ((i2 | 0) == (i3 | 0)) i4 = i7; else {
  i4 = i7;
  do {
   i2 = i2 + -52 | 0;
   __ZN11DetailPatchC2ERKS_(i1 + -52 | 0, i2);
   i1 = i4 + -52 | 0;
   i4 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i6 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i9 >> 2] = i5;
 i4 = i6;
 if ((i3 | 0) != (i4 | 0)) do {
  i1 = HEAP32[i3 + -12 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 + -8 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i1 = HEAP32[i3 + -24 >> 2] | 0;
  if (i1 | 0) {
   i2 = i3 + -20 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
   __ZdlPv(i1);
  }
  i3 = i3 + -52 | 0;
 } while ((i3 | 0) != (i4 | 0));
 if (!i6) return;
 __ZdlPv(i6);
 return;
}

function __ZNK16MemoryFileSystem6ExistsERK13FileEntryData(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  i4 = (i1 | 0) != 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 i4 = (i1 | 0) != 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN8Renderer13BoundsChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 HEAP8[i1 + 273 >> 0] = 1;
 i1 = i1 + 284 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i11 = __Z16GetRendererScenev() | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = (HEAP32[i11 + 60 >> 2] | 0) + (i9 * 24 | 0) + 20 | 0;
 if (HEAP8[i10 >> 0] & 2) return;
 i2 = i11 + 120 | 0;
 i3 = i11 + 132 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i11 + 136 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i11 + 124 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 124 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i9;
 HEAP8[i10 >> 0] = HEAP8[i10 >> 0] | 2;
 return;
}

function __ZN5physx2Sc7BodySim18internalWakeUpBaseEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i3 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (HEAP8[i1 + 44 >> 0] & 1) return;
 if (!(Math_fround(__ZNK5physx2Sc8BodyCore14getWakeCounterEv(i1)) < f2)) return;
 HEAPF32[(HEAP32[i6 >> 2] | 0) + 152 >> 2] = f2;
 __ZN5physx2Sc5Actor9setActiveEbj(i3, 1, 0);
 i5 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i3 + 36 >> 2] | 0) | 0;
 i1 = i3 + 188 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i8 = i4 + (i3 * 12 | 0) + 8 | 0;
 i7 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i7 & 231 | 8;
 do if (!(i7 & 8)) {
  i8 = (HEAP32[HEAP32[i5 + 272 >> 2] >> 2] | 0) + (i3 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 1 << (i3 & 31);
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i4 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i3 = (HEAP32[HEAP32[i5 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i4 & i1)) {
    HEAP32[i3 >> 2] = i4 | i1;
    break;
   } else {
    HEAP32[i3 >> 2] = i4 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i5 + 477 >> 0] = 1;
 i8 = (HEAP32[i6 >> 2] | 0) + 45 | 0;
 HEAP8[i8 >> 0] = (HEAPU8[i8 >> 0] | 0) & 254;
 return;
}

function __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb(i7, i6, i1, i8) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[(HEAP32[gb + 1457204 >> 2] | 0) + 440 >> 2] | 0;
 i4 = __ZNK5physx2Cm8PtrTable4findEPKv(i7, i6) | 0;
 i5 = i1 + (HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0) | 0;
 i2 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
 if (i2 | 0) if ((__ZNK5physx7NpShape8getFlagsEv(i6) | 0) & 2) {
  i1 = i7 + 8 | 0;
  if ((HEAP16[i7 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i2 + 3392 | 0, HEAP32[i1 + (i4 << 2) >> 2] | 0);
 }
 i1 = i6 + 12 | 0;
 i2 = i6 + 16 | 0;
 __ZN5physx3Scb11RigidObject13onShapeDetachERNS0_5ShapeEbb(i5, i6 + 32 | 0, i8, (HEAP32[i2 >> 2] | 0) == 1);
 __ZN5physx2Cm8PtrTable15replaceWithLastEjRNS0_22PtrTableStorageManagerE(i7, i4, i3);
 __ZN5physx2Cm8PtrTable15replaceWithLastEjRNS0_22PtrTableStorageManagerE(i7 + 8 | 0, i4, i3);
 if (__ZNK5physx7NpShape11isExclusiveEv(i6) | 0) __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE(i6, 0);
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN26AnimatorControllerPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE(i10, i11, i1) {
 i10 = i10 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 180 >> 2] | 0, i10 | 0) | 0)) return;
 i1 = HEAP32[i10 + 8 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) return;
 HEAP8[i10 + 56 >> 0] = 0;
 i2 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 4 >> 2] | 0;
 if (!i2) return;
 HEAP8[i2 + 56 >> 0] = 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i9 = i1 + 28 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if (i3 | 0) {
  i6 = i1 + 16 | 0;
  i7 = i2 + 80 | 0;
  i8 = i10 + 92 | 0;
  i5 = i2 + 100 | 0;
  i4 = 0;
  i1 = i3;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
   if (i2) {
    mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, i11 | 0, HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] | 0);
    i1 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
    i1 = i1 + (HEAP32[i1 >> 2] | 0) + (i4 << 2) | 0;
    HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 * 12 | 0) + 8 >> 2] = i1 + (HEAP32[i1 >> 2] | 0) + 8;
    i1 = HEAP32[i9 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 HEAP8[i10 + 73 >> 0] = 0;
 return;
}

function __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 397134 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 397147 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 397155 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 896261 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14AreaEffector2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 92 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(-359.999908);
 i5 = f3 > Math_fround(359.999908);
 f3 = i5 ? Math_fround(359.999908) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(-359.999908) : f3;
 i2 = i1 + 96 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i2 = i1 + 100 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(-1.0e6);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(-1.0e6) : f3;
 i2 = i1 + 104 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(0.0) : f3;
 i2 = i1 + 108 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(0.0) : f3;
 i1 = i1 + 112 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= 1) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i6 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = (i3 - i1 | 0) / 88 | 0;
 if (i8 >>> 0 > i2 >>> 0) __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj(i6, i8 - i2 | 0); else if (i8 >>> 0 < i2 >>> 0) {
  i4 = i1 + (i8 * 88 | 0) | 0;
  if ((i3 | 0) != (i4 | 0)) while (1) {
   i1 = i3 + -88 | 0;
   HEAP32[i5 >> 2] = i1;
   i2 = i3 + -32 | 0;
   if ((HEAP32[i3 + -16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -28 | 0);
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i3 = i1;
  }
 }
 if (!i8) return;
 i2 = i6 + 16 | 0;
 i1 = 0;
 do {
  i3 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i7 >> 2] | 0, i1) | 0;
  if (HEAP32[i3 >> 2] | 0) __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_(i2, i3, (HEAP32[i6 >> 2] | 0) + (i1 * 88 | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN11TrailModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 i4 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(1.0);
 f3 = i7 ? Math_fround(1.0) : f3;
 HEAPF32[i4 >> 2] = i6 ? Math_fround(0.0) : f3;
 i4 = i1 + 92 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(1.0);
 f3 = i7 ? Math_fround(1.0) : f3;
 f3 = i6 ? Math_fround(0.0) : f3;
 HEAPF32[i4 >> 2] = f3;
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, f3, HEAP16[i1 + 96 >> 1] | 0) | 0) & 1;
 i4 = i1 + 276 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = Math_fround(HEAPF32[i4 >> 2]) < Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 i4 = i1 + 528 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f3 < Math_fround(0.0);
 f3 = i5 ? Math_fround(0.0) : f3;
 HEAPF32[i4 >> 2] = f3;
 HEAP8[i1 + 534 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 448 | 0, i1 + 536 | 0, f3, HEAP16[i1 + 532 >> 1] | 0) | 0) & 1;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Scb5Scene20switchRigidFromNoSimERNS0_11RigidObjectEb(i5, i4, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i4 + 4 | 0;
 if ((HEAP32[i1 >> 2] & -1073741824 | 0) != -2147483648) {
  STACKTOP = i8;
  return;
 }
 i2 = __ZN5physx21NpShapeGetScPtrOffsetEv() | 0;
 i6 = i2 + -16 | 0;
 if (i3) {
  i3 = __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i4, i7) | 0;
  __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj(i5 + 16 | 0, (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i4 | 0, HEAP32[i7 >> 2] | 0, i3, i2);
  i2 = i3;
 } else {
  i3 = __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i4, i7) | 0;
  __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj(i5 + 16 | 0, (HEAP32[gb + 90260 + 24 + (((HEAP32[i1 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i4 | 0, HEAP32[i7 >> 2] | 0, i3, i2);
  i2 = i3;
 }
 if (!i2) {
  STACKTOP = i8;
  return;
 } else i1 = 0;
 do {
  __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE((HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0) + i6 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i8;
 return;
}

function __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_(i6, i8, i3, i4, f9, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f9 = Math_fround(f9);
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 >= 5) {
  i8 = 0;
  STACKTOP = i10;
  return i8 | 0;
 }
 if (f9 <= Math_fround(0.0) | (29 >>> (i2 & 31) & 1) == 0) {
  i8 = 0;
  STACKTOP = i10;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i4;
 i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = 11;
 i2 = mftCall_iiiiiii(i2 | 0, i6 | 0, i3 | 0, i5 | 0, 1, 1, i1 | 0) | 0;
 if (!i2) {
  i8 = 0;
  STACKTOP = i10;
  return i8 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i7 | 0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 108 >> 2] | 0, i6 | 0, i8 | 0) | 0;
 if (i1 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i2 | 0);
  __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f9, 0, 0) | 0;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 i8 = i1;
 STACKTOP = i10;
 return i8 | 0;
}

function __ZN4Mesh24QueryGpuSkinSourceBufferEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i4 = i1 + 32 | 0;
 i5 = __ZN16MeshSkinningData16GetSkinInfluenceEi((HEAP32[i4 >> 2] | 0) + 144 | 0, i3) | 0;
 if (!i5) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i1, i2, HEAP32[(HEAP32[i4 >> 2] | 0) + 96 >> 2] | 0, 0, 0) | 0;
 if (!(HEAP32[i2 >> 2] | 0)) i1 = 0; else {
  i2 = (i3 | 0) == 4 ? i1 + 192 | 0 : (i3 | 0) == 2 ? i1 + 196 | 0 : i1 + 200 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __Z12GetGfxDevicev() | 0;
   HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 220 >> 2] | 0, i1 | 0) | 0;
   switch (i3 | 0) {
   case 1:
    {
     i1 = 4;
     break;
    }
   case 2:
    {
     i1 = 16;
     break;
    }
   case 4:
    {
     i1 = 32;
     break;
    }
   default:
    i1 = 1;
   }
   i3 = __Z12GetGfxDevicev() | 0;
   mftCall_viiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 224 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, 0, 0, Math_imul(HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0, i1) | 0, i5 | 0, 0);
   i1 = HEAP32[i2 >> 2] | 0;
  }
 }
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 32 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 471259 | 0, i2, 0);
 __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i6 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  i6 = i5 + 4 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
  STACKTOP = i3;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 i6 = i5 + 4 | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i4);
 STACKTOP = i3;
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i6 = i2 + 11 | 0;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i5, (HEAP8[i6 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if ((HEAP8[i6 >> 0] | 0) >= 0) {
  i6 = i5 + 4 | 0;
  __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4);
  STACKTOP = i3;
  return;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 i6 = i5 + 4 | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i4);
 STACKTOP = i3;
 return;
}

function __ZN12TreeDatabase8TransferI14SafeBinaryReadEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932439 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI12TreeInstanceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i5 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 932455 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i6, 1) | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i5 + 40 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN12SoundManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i4;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = i4;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = i4;
 i4 = i1 + 32 | 0;
 i3 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = i3;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 24700 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 23932 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 23932 + (i1 * 12 | 0) >> 2] = fb + 277;
 STACKTOP = i5;
 return;
}

function __ZN10GameObject10DeactivateE19DeactivateOperation(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 288 | 0;
 i4 = i8 + 8 | 0;
 i5 = i8;
 if ((HEAP16[gb + 1104700 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104700 | 0, i7);
  i1 = gb + 1104700 | 0;
 } else i1 = 0;
 i6 = i2 + 54 | 0;
 if (__ZNK10GameObject8IsActiveEv(i2) | 0) {
  HEAP8[i6 >> 0] = 0;
  i10 = gb + 64016 | 0;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i6 = i5;
  HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i6 + 4 >> 2] = i9;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN18AwakeFromLoadQueueC2E10MemLabelId(i4, i7);
  __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i2, i3, i4);
  __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i4, 8, 0);
  __ZN18AwakeFromLoadQueueD2Ev(i4);
 } else if (HEAP8[i6 >> 0] | 0) HEAP8[i6 >> 0] = 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i8;
 return;
}

function __ZNK5physx2Gu11HeightField14computeExtremeEjjjj(i4, i2, i9, i8, i7) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i10 = 0;
 i6 = Math_fround(HEAPF32[i4 + 40 >> 2]) <= Math_fround(0.0);
 i1 = i6 ? -2147483648 : 2147483647;
 i3 = i2 >>> 0 > i9 >>> 0;
 L1 : do if (i6) {
  if (!i3) {
   if (i8 >>> 0 > i7 >>> 0) while (1) {
    i2 = i2 + 1 | 0;
    if (i2 >>> 0 > i9 >>> 0) break L1;
   }
   i6 = HEAP32[i4 + 20 >> 2] | 0;
   i5 = HEAP32[i4 + 36 >> 2] | 0;
   do {
    i3 = Math_imul(i6, i2) | 0;
    i4 = i8;
    do {
     i10 = HEAP16[i5 + (i3 + i4 << 2) >> 1] | 0;
     i1 = (i1 | 0) < (i10 | 0) ? i10 : i1;
     i4 = i4 + 1 | 0;
    } while (i4 >>> 0 <= i7 >>> 0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 <= i9 >>> 0);
  }
 } else if (!i3) {
  if (i8 >>> 0 > i7 >>> 0) while (1) {
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 > i9 >>> 0) break L1;
  }
  i6 = HEAP32[i4 + 20 >> 2] | 0;
  i5 = HEAP32[i4 + 36 >> 2] | 0;
  do {
   i3 = Math_imul(i6, i2) | 0;
   i4 = i8;
   do {
    i10 = HEAP16[i5 + (i3 + i4 << 2) >> 1] | 0;
    i1 = (i1 | 0) < (i10 | 0) ? i1 : i10;
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 <= i7 >>> 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 <= i9 >>> 0);
 } while (0);
 return Math_fround(i1 | 0);
}

function __ZN20ExternalForcesModule8TransferI14SafeBinaryReadEEvRT_(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i1, i6);
 i4 = i1 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 620343 | 0, HEAP32[gb + 37012 >> 2] | 0, i2, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i5 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN17ProceduralTexture17TextureParameters8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034504 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034510 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 431996 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 432006 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i2 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i7 + 56 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 52 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  return;
 }
}

function __ZN13ComputeShader23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 469287 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 32 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 479409 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN13AudioProfiler12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i5 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 12 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i5 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function _UNITY_png_build_16bit_table(i9, i1, i2, i3) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 i11 = 8 - i2 | 0;
 i12 = 1 << i11;
 i8 = (1 << 16 - i2) + -1 | 0;
 i7 = 1 << 15 - i2;
 i10 = _UNITY_png_calloc(i9, i12 << 2) | 0;
 HEAP32[i1 >> 2] = i10;
 d4 = +(i8 >>> 0);
 d5 = +(i3 | 0) * 1.0e-05;
 i6 = (i2 | 0) == 0;
 if ((i3 + -95e3 | 0) >>> 0 > 1e4) {
  i1 = 0;
  do {
   i3 = _UNITY_png_malloc(i9, 512) | 0;
   HEAP32[i10 + (i1 << 2) >> 2] = i3;
   i2 = 0;
   do {
    HEAP16[i3 + (i2 << 1) >> 1] = ~~+Math_floor(+(+Math_pow(+(+(((i2 << i11) + i1 | 0) >>> 0) / d4), +d5) * 65535.0 + .5));
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != 256);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i12 >>> 0);
  return;
 } else i2 = 0;
 do {
  i3 = _UNITY_png_malloc(i9, 512) | 0;
  HEAP32[i10 + (i2 << 2) >> 2] = i3;
  if (i6) {
   i1 = 0;
   do {
    HEAP16[i3 + (i1 << 1) >> 1] = (i1 << i11) + i2;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 256);
  } else {
   i1 = 0;
   do {
    HEAP16[i3 + (i1 << 1) >> 1] = (((((i1 << i11) + i2 | 0) * 65535 | 0) + i7 | 0) >>> 0) / (i8 >>> 0) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != 256);
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i12 >>> 0);
 return;
}

function __ZThn8_NK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i2 = i2 + -8 | 0;
 i6 = i2 + 416 | 0;
 f9 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 500 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 504 >> 2]);
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 d5 = +f9;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d5;
 d4 = +f8;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d4;
 d3 = +f7;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d3;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAPF64[i2 >> 3] = d5 + +HEAPF64[i2 >> 3];
 i2 = i1 + 32 | 0;
 HEAPF64[i2 >> 3] = d4 + +HEAPF64[i2 >> 3];
 i2 = i1 + 40 | 0;
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 return 1;
}

function __ZN7mecanim9animation12GetWeights1dERKNS0_19Blend1dDataConstantEPff(i1, i8, f2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i4 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i3 + i4 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i7 = HEAP32[i1 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i4 + (i7 + -1 << 2) >> 2]);
 f6 = Math_fround(_fminf(Math_fround(_fmaxf(f2, f5)), f6));
 if (!i7) return;
 i3 = (i3 | 0) == 0 ? 0 : i4;
 i4 = 0;
 do {
  f2 = Math_fround(HEAPF32[i3 + (i4 << 2) >> 2]);
  if (!(f2 <= f6)) if (!i4) f2 = Math_fround(1.0); else {
   f5 = Math_fround(HEAPF32[i3 + (i4 + -1 << 2) >> 2]);
   if (f5 > f6) f2 = Math_fround(0.0); else {
    f2 = Math_fround(f2 - f5);
    if (f2 != Math_fround(0.0)) f2 = Math_fround(Math_fround(f6 - f5) / f2); else f2 = Math_fround(1.0);
   }
  } else {
   i1 = i4 + 1 | 0;
   if ((i1 | 0) == (i7 | 0)) f2 = Math_fround(1.0); else {
    f5 = Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]);
    if (f5 < f6) f2 = Math_fround(0.0); else {
     f2 = Math_fround(f2 - f5);
     if (f2 != Math_fround(0.0)) f2 = Math_fround(Math_fround(f6 - f5) / f2); else f2 = Math_fround(1.0);
    }
   }
  }
  HEAPF32[i8 + (i4 << 2) >> 2] = f2;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i7 >>> 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx23ArticulationRootManager6resizeEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = (i7 << 3) + 15 & -16;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9 + 1 | 0, i6 + ((i7 << 2) + 15 & -16) | 0, gb + 681489 | 0, 1215) | 0;
 i6 = i4 + i6 | 0;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i2 = i8 + 8 | 0;
  i5 = i8 + 12 | 0;
  i1 = i3;
 } else {
  i5 = i8 + 12 | 0;
  _memcpy(i4 | 0, i1 | 0, HEAP32[i5 >> 2] << 3 | 0) | 0;
  i2 = i8 + 8 | 0;
  _memcpy(i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i3 >> 2] | 0);
  i1 = i3;
 }
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 >> 2] = i6;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i8 + 16 | 0;
 i3 = i7 + -1 | 0;
 HEAP32[i6 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 if (i3 >>> 0 > i1 >>> 0) {
  i4 = i1;
  do {
   i10 = i4;
   i4 = i4 + 1 | 0;
   HEAP32[i6 + (i10 << 2) >> 2] = i4;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAP32[i2 >> 2] = i1;
 i10 = i8 + 20 | 0;
 HEAP32[i10 >> 2] = (((i7 | 0) == 0) << 31 >> 31) + i7 - i1 + (HEAP32[i10 >> 2] | 0);
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZN5CacheD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP8[i3 + 52 >> 0] = 1;
 i4 = i3 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 72 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (i1 | 0) {
    __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i1, 8, 0) | 0;
    __ZN15FileSystemEntry6DeleteEb(i1, 0) | 0;
    __ZN13FileEntryDataD2Ev(i1);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i4, HEAP32[i5 >> 2] | 0);
 __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i3 + 56 | 0, HEAP32[i3 + 60 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 4 | 0);
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 40 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 471336 | 0, i2, 0);
 __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 40 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 471297 | 0, i2, 0);
 __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN19SpriteMeshGenerator4path9clip_isecE8Vector2fS1_i(i11, i6, i2, i3, i7) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var d1 = 0.0, d4 = 0.0, d5 = 0.0, d8 = 0.0, d9 = 0.0, i10 = 0, f12 = f0, f13 = f0, f14 = f0, f15 = f0;
 f15 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f15 = Math_fround(f15 - f12);
 f14 = Math_fround(HEAPF32[i3 >> 2]);
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 d8 = +Math_fround(f15 / Math_fround(f14 - f13));
 HEAPF64[tempDoublePtr >> 3] = d8;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 d1 = +f13;
 d9 = +f12 - d1 * d8;
 switch (i7 | 0) {
 case 2:
  {
   i2 = i6 + 36 | 0;
   i10 = 4;
   break;
  }
 case 1:
  {
   i2 = i6 + 28 | 0;
   i10 = 4;
   break;
  }
 case 8:
  {
   i2 = i6 + 32 | 0;
   i10 = 7;
   break;
  }
 case 4:
  {
   i2 = i6 + 40 | 0;
   i10 = 7;
   break;
  }
 default:
  {
   d5 = 0.0;
   d1 = 0.0;
  }
 }
 if ((i10 | 0) == 4) {
  d1 = +Math_fround(HEAPF32[i2 >> 2]);
  d5 = d9 + d8 * d1;
 } else if ((i10 | 0) == 7) {
  d4 = +Math_fround(HEAPF32[i2 >> 2]);
  if (0 == 0 & (i3 & 2146435072 | 0) == 2146435072) d5 = d4; else {
   d5 = d4;
   d1 = (d4 - d9) / d8;
  }
 }
 f15 = Math_fround(d5);
 HEAPF32[i11 >> 2] = Math_fround(d1);
 HEAPF32[i11 + 4 >> 2] = f15;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i7, i5, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j(i5, i1);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i1 + 16 | 0, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  i1 = i1 + 32 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i6;
 return;
}

function __ZN14PhysicsManager10SetGravityERK8Vector3f(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f7 = f0;
 i1 = i5 + 32 | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f7 != Math_fround(HEAPF32[i6 >> 2]))) {
  f7 = Math_fround(HEAPF32[i5 + 36 >> 2]);
  if (!(f7 != Math_fround(HEAPF32[i6 + 4 >> 2]))) {
   f7 = Math_fround(HEAPF32[i5 + 40 >> 2]);
   if (!(f7 != Math_fround(HEAPF32[i6 + 8 >> 2]))) return;
  }
 };
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 i3 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 248 >> 2] | 0, i3 | 0, i6 | 0);
 i3 = 0;
 do {
  i1 = HEAP32[i5 + 204 + (i3 << 3) + 4 >> 2] | 0;
  i4 = i5 + 204 + (i3 << 3) | 0;
  i2 = i1;
  if ((i2 | 0) != (i4 | 0)) do {
   i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 52 >> 2] | 0;
   if (!((i1 | 0) == 0 ? 1 : (HEAP16[i1 + 4 >> 1] | 0) != 5)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 64);
 if (!(__Z9GetIClothv() | 0)) return;
 i5 = __Z9GetIClothv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i6 | 0);
 return;
}

function __ZN13CameraLODData7ReserveEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 16 | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5, 1, i4 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 1, i4 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 + 28 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  break;
 } while (0);
 i1 = i4 + 36 | 0;
 i2 = i4 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 & 2147483647) >>> 0 >= i5 >>> 0) return;
 if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5 << 2, 4, i4 + 40 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 2, 4, i4 + 40 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 + 48 >> 2] << 2 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function __ZN11NamedObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 370829 | 0, i1, 0);
 __ZN6Object8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 28 | 0, 1);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z29CubemapArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayiii(i5, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i1 = i9 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i10 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i10 = __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 36 >> 2] | 0, i10 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN12CubemapArray9SetPixelsEiPK10ColorRGBAf11CubemapFaceii(i2, i3, i1, i6, i7, i8);
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE7destroyEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 2 | 0;
 i6 = i9 + 1 | 0;
 i8 = i9;
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = 0;
  do {
   if (!i2) i2 = 0; else {
    i1 = 0;
    do {
     i1 = i1 + 1 | 0;
     i2 = HEAP32[i7 >> 2] | 0;
    } while (i1 >>> 0 < i2 >>> 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  if (i1 | 0) {
   i1 = i7 + 24 | 0;
   i2 = 0;
   do {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
    HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
  }
 }
 HEAP32[i5 >> 2] = 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2);
 HEAP32[i1 >> 2] = 0;
 i1 = i7 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i1, i7, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i1);
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i7, i5);
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
 }
 HEAP32[i5 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if ((HEAP8[i7 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return;
}

function __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 16 | 0, i1);
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN16ReflectionProbes12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[gb + 1112272 >> 2] | 0;
 if (i1 | 0) {
  __ZN16ReflectionProbesD2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[gb + 1112272 >> 2] = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 37052 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i6 + 36284 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 2381 | 0)) {
   i4 = i6 + 36284 + (i1 * 12 | 0) + 8 | 0;
   i2 = i6 + 36284 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i8 = 10;
   break;
  }
 }
 if ((i8 | 0) == 10) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i8 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i8;
 if (i8 >>> 0 <= i1 >>> 0) return;
 do {
  i8 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i6 + 36284 + (i8 * 12 | 0) >> 2] = HEAP32[i6 + 36284 + (i1 * 12 | 0) >> 2];
  HEAP32[i6 + 36284 + (i8 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 36284 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i6 + 36284 + (i8 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 return;
}

function __ZN15QualitySettings13ApplySettingsEib(i2, i5, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i2 + 44 >> 2] | 0;
 i4 = i2 + 28 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 __ZN7Texture13SetAnisoLimitENS_20AnisotropicFilteringE(HEAP32[i7 + (i6 * 108 | 0) + 68 >> 2] | 0);
 __ZN7Texture21SetMasterTextureLimitEib(HEAP32[i7 + (i6 * 108 | 0) + 64 >> 2] | 0, 1);
 if (__Z21GetLODGroupManagerPtrv() | 0) {
  i1 = __Z18GetLODGroupManagerv() | 0;
  HEAP32[i1 + 24 >> 2] = HEAP32[i7 + (i6 * 108 | 0) + 84 >> 2];
 }
 i1 = HEAP32[i7 + (i6 * 108 | 0) + 88 >> 2] | 0;
 if (__Z14IsWorldPlayingv() | 0) {
  i2 = HEAP32[i2 + 40 >> 2] | 0;
  i1 = (i2 | 0) < (i1 | 0) ? i1 : i2;
 }
 if (__Z21GetLODGroupManagerPtrv() | 0) HEAP32[(__Z18GetLODGroupManagerv() | 0) + 28 >> 2] = i1;
 if (!i3) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 108 | 0) + 72 >> 2] | 0) == (HEAP32[i7 + (i6 * 108 | 0) + 72 >> 2] | 0)) if ((HEAP32[i1 + (i5 * 108 | 0) + 76 >> 2] | 0) == (HEAP32[i7 + (i6 * 108 | 0) + 76 >> 2] | 0)) return;
 i1 = HEAP32[gb + 1158216 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 i1 = __Z12GetIVRDevicev() | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12AudioManager24CreateFMODSoundFromMovieEP9AudioClip(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 136 | 0;
 i2 = i7;
 if (!(HEAP32[i5 + 88 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 i3 = i2 + 4 + 4 | 0;
 i4 = i3 + 128 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = 136;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 24 >> 2] = 4096;
 HEAP32[i2 + 20 >> 2] = 2;
 HEAP32[i2 + 16 >> 2] = 22050;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i2 + 44 >> 2] = fb + 430;
 HEAP32[i2 + 68 >> 2] = i1;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb((i1 | 0) == 0 ? HEAP32[gb + 1459924 >> 2] | 0 : i1, 0, 0) | 0;
 i1 = __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i6, 0, 33555665, i1, 0, 0, i2) | 0;
 if (i4) __Z19pop_allocation_rootv();
 if (!i1) i1 = HEAP32[i6 >> 2] | 0; else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i5 + 180 | 0, __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0) | 0;
  HEAP32[i5 + 192 >> 2] = i1;
  i1 = 0;
 }
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z30Cubemap_CUSTOM_Internal_CreateP12Il2CppObjecti13TextureFormath(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 i8 = i6;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(164, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 878) | 0;
 i11 = gb + 63520 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN7CubemapC2E10MemLabelId18ObjectCreationMode(i3, i7, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 if (mftCall_iiiiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, i2 | 0, i2 | 0, i4 | 0, i5 << 24 >> 24 != 0 | 0, 6, -1, 0) | 0) {
  __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
  STACKTOP = i6;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570235 | 0, i6 + 8 | 0);
}

function __ZNSt3__26vectorINS_4pairIxN14SerializedFile10ObjectInfoEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 24 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 24;
 HEAP32[i8 >> 2] = i6 + (i4 * 24 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE(i10, i8, i9, i7) {
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 5136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 1024 | 0;
 i2 = i11;
 i3 = i11 + 5121 | 0;
 i4 = i11 + 5120 | 0;
 if ((i8 | 0) == 0 | (i9 | 0) < 1) {
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = i10 + 4 | 0;
 i6 = HEAP32[i5 >> 2] & 2147483647;
 if ((i6 | 0) != (i9 | 0)) {
  if (i6 >>> 0 < i9 >>> 0) if (HEAP8[i10 + 32 >> 0] | 0) {
   i6 = i10 + 12 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i6 >> 2] | 0);
   HEAP32[i6 >> 2] = 0;
   i13 = i10 + 8 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i13 >> 2] | 0);
   HEAP32[i13 >> 2] = 0;
   i12 = i9 << 2;
   HEAP32[i13 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i12, gb + 657536 | 0, 53) | 0;
   HEAP32[i6 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i12, gb + 657536 | 0, 54) | 0;
  }
  HEAP32[i5 >> 2] = i9 | -2147483648;
 }
 HEAP32[i10 + 16 >> 2] = i1;
 HEAP32[i10 + 20 >> 2] = i2;
 __ZN5physx2Gu9RadixSort4SortEPKjjNS0_9RadixHintE(i10, i8, i9, i7) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN23ForwardShaderRenderLoopD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 36812 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  }
 }
 __ZN9ShaderLab10GrabPassesD2Ev(i2 + 372 | 0);
 i1 = i2 + 340 | 0;
 if ((HEAP32[i2 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 344 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 168 | 0;
 if ((HEAP32[i2 + 184 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 172 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 164 >> 2] | 0) > -1) {
  i3 = i2 + 148 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 152 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i2 + 128 | 0;
 if ((HEAP32[i2 + 144 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 132 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 108 | 0;
 if ((HEAP32[i2 + 124 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 112 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 5;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 5;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 5, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 5 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 5) | 0;
 _memmove(i14 + (i8 << 5) | 0, i14 | 0, i11 << 5 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13TrailRenderer12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 32420 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 31652 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 218 | 0)) {
    i4 = i6 + 31652 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 31652 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 31652 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 31652 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 31652 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 31652 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 31652 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 31652 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if (!(__Z13GetIAnimationv() | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158392 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158392 >> 2] = 0;
 return;
}

function __ZN12CubemapArray13RebuildMipMapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) == 1) return;
 i7 = i2 + 92 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 if (!i5) return;
 i8 = i2 + 88 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 do if ((i6 + -10 | 0) >>> 0 >= 3) if (((i6 | 1) + -25 | 0) >>> 0 >= 5) {
  i1 = i6 + -30 | 0;
  if (i1 >>> 0 < 15) {
   if ((i6 + -48 | 0) >>> 0 < 12 | ((i6 + -45 | 0) >>> 0 < 3 | (30847 >>> (i1 & 65535) & 1) != 0)) break;
  } else if ((i6 + -45 | 0) >>> 0 < 3 | (i6 + -48 | 0) >>> 0 < 12) break;
  i3 = i2 + 84 | 0;
  if ((HEAP32[i3 >> 2] | 0) <= 0) return;
  i4 = i2 + 100 | 0;
  i2 = i2 + 80 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  __Z12CreateMipMapPhiii13TextureFormat(i5, i1, i1, 1, i6);
  if (((HEAP32[i3 >> 2] | 0) * 6 | 0) > 1) i1 = 1; else return;
  do {
   i5 = (HEAP32[i7 >> 2] | 0) + (Math_imul(HEAP32[i4 >> 2] | 0, i1) | 0) | 0;
   i6 = HEAP32[i2 >> 2] | 0;
   __Z12CreateMipMapPhiii13TextureFormat(i5, i6, i6, 1, HEAP32[i8 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < ((HEAP32[i3 >> 2] | 0) * 6 | 0));
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 400434 | 0, 0, gb + 397053 | 0, 193, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 return;
}

function __Z18BuildTransformListR9TransformR13dynamic_arrayIPS_Lj4EE(i9, i10) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i9;
 i3 = i10 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i10 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i10 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 i3 = HEAP32[i9 + 92 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i9 + 80 | 0;
 i1 = 0;
 do {
  __Z18BuildTransformListR9TransformR13dynamic_arrayIPS_Lj4EE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i10);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN4crnd19crnd_get_level_dataEPKvjjPj(i5, i1, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i3 = (i6 | 0) != 0;
 if (i3) HEAP32[i6 >> 2] = 0;
 if ((i5 | 0) == 0 | i1 >>> 0 < 74) {
  i7 = 0;
  return i7 | 0;
 }
 if (((HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0) | 0) != 18552) {
  i7 = 0;
  return i7 | 0;
 }
 if (((HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0)) >>> 0 < 74) {
  i7 = 0;
  return i7 | 0;
 }
 if (((HEAPU8[i5 + 7 >> 0] | 0) << 16 | (HEAPU8[i5 + 6 >> 0] | 0) << 24 | (HEAPU8[i5 + 8 >> 0] | 0) << 8 | (HEAPU8[i5 + 9 >> 0] | 0)) >>> 0 > i1 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = HEAPU8[i5 + 16 >> 0] | 0;
 if (i4 >>> 0 <= i2 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = (HEAPU8[i5 + 70 + (i2 << 2) + 1 >> 0] | 0) << 16 | (HEAPU8[i5 + 70 + (i2 << 2) >> 0] | 0) << 24 | (HEAPU8[i5 + 70 + (i2 << 2) + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 70 + (i2 << 2) + 3 >> 0] | 0);
 if (i3) {
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 < i4 >>> 0) i1 = (HEAPU8[i5 + 70 + (i2 << 2) + 1 >> 0] | 0) << 16 | (HEAPU8[i5 + 70 + (i2 << 2) >> 0] | 0) << 24 | (HEAPU8[i5 + 70 + (i2 << 2) + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 70 + (i2 << 2) + 3 >> 0] | 0);
  HEAP32[i6 >> 2] = i1 - i7;
 }
 i7 = i5 + i7 | 0;
 return i7 | 0;
}

function __ZN23SharedMeshRenderingData6UnloadEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
 }
 i1 = i2 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 32 >> 2] = 0;
 }
 i1 = i2 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i3 = i2 + 44 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 i3 = i2 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN21EnlightenSceneMappingD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 124 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 128 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = i5 + 100 | 0;
 if ((HEAP32[i5 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 80 | 0;
 if ((HEAP32[i5 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 60 | 0;
 if ((HEAP32[i5 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 40 | 0;
 if ((HEAP32[i5 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 20 | 0;
 if ((HEAP32[i5 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i5 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 8 | 0, i1);
 i8 = i1 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i8 >> 2] = i4;
 }
 HEAP32[i6 + 164 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i7, 4);
  i8 = HEAP32[i7 >> 2] | 0;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  HEAP32[i8 >> 2] = i2;
  i8 = i6;
  i8 = _llvm_bswap_i32(i8 | 0) | 0;
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i9;
  return;
 }
}

function __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i3, i4, f5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 156 >> 2] | 0, i8 | 0, i9 | 0);
 i1 = HEAP32[i9 + 4200 >> 2] | 0;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 360 >> 2] | 0, i9 | 0) | 0) >> i1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 i1 = (mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 364 >> 2] | 0, i9 | 0) | 0) >> i1;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 496 >> 0] | 0)) {
  if (!(HEAP32[i8 >> 2] | 0)) if (!(HEAP32[i8 + 4 >> 2] | 0)) if ((HEAP32[i8 + 8 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i8 + 12 >> 2] | 0) == (i1 | 0)) i10 = 6;
 } else i10 = 6;
 if ((i10 | 0) == 6) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 537 >> 0] | 0)) {
  mftCall_viiifi(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, i3 | 0, i4 | 0, +f5, i6 | 0);
  STACKTOP = i11;
  return;
 }
 __Z18ClearByDrawingQuadjRK10ColorRGBAffjR17ShaderPassContext(i3, i4, Math_fround(0.0), 0, i7);
 STACKTOP = i11;
 return;
}

function __ZN12LineRenderer12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 33192 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 32424 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 217 | 0)) {
    i4 = i6 + 32424 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 32424 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 32424 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 32424 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 32424 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 32424 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 32424 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 32424 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 if (!(__Z13GetIAnimationv() | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158200 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158200 >> 2] = 0;
 return;
}

function __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f4 = Math_fround(+Math_sin(+f3));
 f5 = Math_fround(+Math_cos(+f3));
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f8 * f8);
 f3 = Math_fround(f11 * f11);
 f12 = Math_fround(f13 * f8);
 f6 = Math_fround(f8 * f11);
 f9 = Math_fround(f13 * f11);
 f7 = Math_fround(f4 * f13);
 f8 = Math_fround(f4 * f8);
 f11 = Math_fround(f4 * f11);
 f4 = Math_fround(Math_fround(1.0) - f5);
 HEAPF32[i1 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(f13 * f13)));
 f12 = Math_fround(f4 * f12);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f12 - f11);
 f9 = Math_fround(f4 * f9);
 HEAPF32[i1 + 24 >> 2] = Math_fround(f8 + f9);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f12 + f11);
 HEAPF32[i1 + 16 >> 2] = Math_fround(f5 + Math_fround(f4 * f10));
 f6 = Math_fround(f4 * f6);
 HEAPF32[i1 + 28 >> 2] = Math_fround(f6 - f7);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i1 + 20 >> 2] = Math_fround(f7 + f6);
 HEAPF32[i1 + 32 >> 2] = Math_fround(f5 + Math_fround(f4 * f3));
 return i1 | 0;
}

function __Z63ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterPropertiesP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i7 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    STACKTOP = i6;
    return HEAP32[(HEAP32[(HEAP32[i1 + 916 >> 2] | 0) + 8 >> 2] | 0) + (i3 * 12 | 0) + 8 >> 2] | 0;
   }
  }
 }
 i7 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i4) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i7;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i5);
 return 0;
}

function __Z15CullLocalLightsR8JobFenceS0_RK22SceneCullingParametersRK13dynamic_arrayI8Vector4fLj4EERKS4_IiLj4EER9IndexListSD_RS4_IfLj4EERS4_I5RectTIfELj4EERS4_I13TargetEyeMaskLj4EEPPK5LightRK14ShadowCullData(i1, i2, i6, i7, i8, i9, i10, i11, i12, i13, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i14 = 0;
 i5 = i7 + 12 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i14 = __ZnwjRK10MemLabelIdiPKci(304, gb + 64024 | 0, 16, gb + 379914 | 0, 267) | 0;
 HEAP32[i14 >> 2] = i6;
 HEAP32[i14 + 4 >> 2] = HEAP32[i7 >> 2];
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i14 + 8 >> 2] = i7;
 HEAP32[i14 + 12 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i14 + 16 >> 2] = i3;
 HEAP32[i14 + 20 >> 2] = i4;
 HEAP32[i14 + 24 >> 2] = i9;
 HEAP32[i14 + 28 >> 2] = i10;
 HEAP32[i14 + 32 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i14 + 36 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i14 + 40 >> 2] = HEAP32[i13 >> 2];
 i13 = __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i14 + 44 | 0, i7, 16) | 0;
 HEAP32[i14 + 300 >> 2] = i13;
 __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i1, fb + 2377 | 0, i14, i13, i2, fb + 3326 | 0, 0);
 return;
}

function __ZN6Sphere3SetEPK8Vector3fj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 12 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 if (!i4) {
  f1 = Math_fround(0.0);
  f1 = Math_fround(Math_sqrt(Math_fround(f1)));
  HEAPF32[i6 >> 2] = f1;
  STACKTOP = i7;
  return;
 }
 i2 = 0;
 f1 = Math_fround(0.0);
 do {
  f9 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) >> 2]);
  f9 = Math_fround(f9 * f9);
  f10 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 4 >> 2]);
  f10 = Math_fround(f9 + Math_fround(f10 * f10));
  f9 = Math_fround(HEAPF32[i3 + (i2 * 12 | 0) + 8 >> 2]);
  f9 = Math_fround(f10 + Math_fround(f9 * f9));
  HEAPF32[i5 >> 2] = f9;
  i8 = HEAP32[(f1 < f9 ? i5 : i6) >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  i2 = i2 + 1 | 0;
  f1 = (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } while ((i2 | 0) != (i4 | 0));
 f10 = Math_fround(Math_sqrt(Math_fround(f1)));
 HEAPF32[i6 >> 2] = f10;
 STACKTOP = i7;
 return;
}

function __ZN5physx12PxsRigidBody23updatePoseDependenciesVERNS_10PxsContextE(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i8 + 72 >> 2] | 0;
 if ((i7 | 0) != 1073741823) {
  i4 = i9 + 5912 | 0;
  i5 = (i7 + 32 | 0) >>> 5;
  i6 = i9 + 5916 | 0;
  if (i5 >>> 0 > (HEAP32[i6 >> 2] & 2147483647) >>> 0) {
   i2 = i9 + 5920 | 0;
   i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i5 << 2, gb + 769739 | 0, 329) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    _memcpy(i1 | 0, i3 | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
    if ((HEAP32[i6 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
   }
   i3 = HEAP32[i6 >> 2] | 0;
   _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i5 - i3 << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
  } else i1 = HEAP32[i4 >> 2] | 0;
  i6 = i1 + (i7 >>> 5 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i7 & 31);
 }
 i2 = i9 + 1444 | 0;
 i1 = i8 + 64 | 0;
 if (!(HEAP32[i9 + 5836 >> 2] | 0)) return;
 if (!(__ZNK5physx21PxsBodyTransformVault17isInVaultInternalERKNS_11PxsBodyCoreE(i2, HEAP32[i1 >> 2] | 0) | 0)) return;
 __ZN5physx21PxsBodyTransformVault12teleportBodyERKNS_11PxsBodyCoreE(i2, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN4Mesh13RemoveChannelE13ShaderChannel(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 16 | 0;
 i4 = i7;
 i8 = HEAP32[i2 + 32 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i6 = HEAP32[i8 + 100 >> 2] | 0;
 i1 = 1 << i1;
 if (!(HEAP32[i8 + 176 >> 2] | 0)) if ((HEAP32[i2 + 116 >> 2] | 0) == (HEAP32[i2 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i3, i5);
  HEAP32[i3 >> 2] = (HEAP32[i3 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i3 + 8 >> 2] & ~HEAP32[i3 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i5, i6, 0, i1, i4, gb + 1546313 | 0);
  STACKTOP = i7;
  return;
 };
 HEAP32[i4 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout(i5, i6, 0, i1, i4, gb + 1546313 | 0);
 STACKTOP = i7;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i3, gb + 469148 | 0, i4, 0);
 i3 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 744923 | 0, i3, i4, 0);
 i5 = i1 + 16 | 0;
 i6 = i1 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 945671 | 0, i3, i4 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i5 >> 2] >> 2] | 0) + ((HEAP32[i6 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 i6 = i4 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i6, 0);
 __ZN29SerializeTraitsForStringTypesI8UnityStrE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_(i6, i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __ZN21EnlightenSceneMapping28GetDynamicLightmapSTInSystemEPK12BaseRendererRK28EnlightenRendererInformation(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) {
  f11 = Math_fround(HEAPF32[i2 + 212 >> 2]);
  f6 = Math_fround(HEAPF32[i2 + 216 >> 2]);
  f9 = Math_fround(HEAPF32[i2 + 220 >> 2]);
  f12 = Math_fround(HEAPF32[i2 + 224 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f4 = Math_fround(HEAPF32[i3 + 16 >> 2]);
  f10 = Math_fround(Math_fround(1.0) / f6);
  f9 = Math_fround(Math_fround(-f9) / f11);
  f6 = Math_fround(Math_fround(-f12) / f6);
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(1.0) / f11) * f8);
  HEAPF32[i1 + 4 >> 2] = Math_fround(f10 * f5);
  HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f9 * f8) + f7);
  HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(f6 * f5) + f4);
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 16 >> 2];
 return;
}

function __ZN17BufferManagerGLESC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = i1 + 20;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i1 + 32;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i1 + 44;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = i1 + 56;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = i1 + 68;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i1 + 80;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = i1 + 92;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = i1 + 104;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = i1 + 116;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = i1 + 128;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = i1 + 140;
 i2 = i1 + 148 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 152 >> 2] = i2;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 return;
}

function __ZN13dynamic_arrayI11KeyframeTplIfELj4EE6insertEPS1_PKS1_S5_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 4;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 4;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 4, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 4, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 4 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 4) | 0;
 _memmove(i14 + (i8 << 4) | 0, i14 | 0, i11 << 4 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN11UnityEngine9AnimationL22GenericBindingCallbackEPvS1_i(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if ((i1 | 0) != 2) return;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) == (i5 | 0)) {
    i6 = i2 + (i1 << 4) | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0) == (i5 | 0)) {
    i6 = i2 + (i1 << 4) | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i6 + 4 >> 2] = 0;
    HEAP32[i6 + 8 >> 2] = 0;
    HEAP32[i6 + 12 >> 2] = 0;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 if ((i2 | 0) > 0) i1 = 0; else return;
 do {
  if ((HEAP32[i3 + (i1 << 4) + 12 >> 2] | 0) == (i5 | 0)) {
   i6 = i3 + (i1 << 4) | 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   HEAP32[i6 + 12 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISC_EE5valueERS7_E4typeESC_SC_(i9, i5, i8) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0;
 i3 = i5;
 i10 = i9 + 11 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i7 = i1 & 255;
 }
 i6 = i8 - i3 | 0;
 do if (i6 | 0) {
  if ((i2 - i7 | 0) >>> 0 < i6 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj(i9, i2, i7 + i6 - i2 | 0, i7, i7, 0);
   i1 = HEAP8[i10 >> 0] | 0;
  }
  if (i1 << 24 >> 24 < 0) i4 = HEAP32[i9 >> 2] | 0; else i4 = i9;
  i3 = i8 + (i7 - i3) | 0;
  i2 = i4 + i7 | 0;
  i1 = i5;
  while (1) {
   if ((i1 | 0) == (i8 | 0)) break;
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i4 + i3 >> 0] = 0;
  i1 = i7 + i6 | 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i1;
   break;
  } else {
   HEAP8[i10 >> 0] = i1;
   break;
  }
 } while (0);
 return;
}

function __ZNK6Camera15IsValidToRenderEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0;
 f1 = Math_fround(HEAPF32[i3 + 872 >> 2]);
 if (f1 <= Math_fround(9.99999974e-06)) {
  i3 = 0;
  return i3 | 0;
 }
 f2 = Math_fround(HEAPF32[i3 + 876 >> 2]);
 if (f2 <= Math_fround(9.99999974e-06)) {
  i3 = 0;
  return i3 | 0;
 }
 f4 = Math_fround(HEAPF32[i3 + 864 >> 2]);
 if (!(!(f4 >= Math_fround(1.0)) & !(Math_fround(f4 + f1) <= Math_fround(0.0)))) {
  i3 = 0;
  return i3 | 0;
 }
 f4 = Math_fround(HEAPF32[i3 + 868 >> 2]);
 if (!(!(f4 >= Math_fround(1.0)) & !(Math_fround(f4 + f2) <= Math_fround(0.0)))) {
  i3 = 0;
  return i3 | 0;
 }
 f4 = Math_fround(HEAPF32[i3 + 924 >> 2]);
 f1 = Math_fround(HEAPF32[i3 + 920 >> 2]);
 if (f4 <= f1) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP8[i3 + 1088 >> 0] | 0)) {
  if (f1 <= Math_fround(0.0)) {
   i3 = 0;
   return i3 | 0;
  }
  f4 = Math_fround(HEAPF32[i3 + 292 >> 2]);
  i3 = f4 < Math_fround(0.0);
  f2 = Math_fround(-f4);
  if ((i3 ? f2 : f4) < Math_fround(9.99999997e-07)) {
   i3 = 0;
   return i3 | 0;
  }
 } else {
  f4 = Math_fround(HEAPF32[i3 + 916 >> 2]);
  i3 = f4 < Math_fround(0.0);
  f2 = Math_fround(-f4);
  if ((i3 ? f2 : f4) < Math_fround(9.99999997e-07)) {
   i3 = 0;
   return i3 | 0;
  }
 }
 i3 = 1;
 return i3 | 0;
}

function __ZN5physx2Sc8ClothSim9startStepEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZN5physx2Sc8ClothSim24updateRigidBodyPositionsEv(i4);
 i1 = i4 + 52 | 0;
 __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv(i3, HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP16[i2 + 8 >> 1] & 2) {
  i4 = i2;
  i4 = i4 + 28 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = i2 + 80 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(i2 | 0, i4 | 0, i3 | 0);
  STACKTOP = i5;
  return;
 }
 i4 = __ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0;
 f8 = Math_fround(HEAPF32[i4 + 48 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 52 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 56 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i3 >> 2]));
 i4 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = i3 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = i4 + 28 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = i2 + 80 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(i2 | 0, i4 | 0, i3 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx20solve1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i9, i8, i7) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (i8 >>> 0 > 1) {
  i5 = HEAP32[i9 + 16 >> 2] | 0;
  i6 = 1;
  do {
   i2 = i5;
   i5 = HEAP32[i9 + (i6 << 5) + 16 >> 2] | 0;
   __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i9 + (i6 + -1 << 5) | 0, i7);
   i4 = (HEAP8[i2 >> 0] | 0) == 4 ? 176 : 112;
   i1 = HEAP8[i2 + 1 >> 0] | 0;
   if (i1 << 24 >> 24) {
    i3 = i1 & 255;
    i1 = i2 + 48 | 0;
    i2 = 0;
    while (1) {
     HEAP32[i1 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i4 | 0;
    }
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i8 | 0));
 }
 i2 = i8 + -1 | 0;
 __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i9 + (i2 << 5) | 0, i7);
 i2 = HEAP32[i9 + (i2 << 5) + 16 >> 2] | 0;
 i4 = (HEAP8[i2 >> 0] | 0) == 4 ? 176 : 112;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i3 = i1 & 255;
 i1 = i2 + 48 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i1 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i4 | 0;
 }
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i2 = __ZNK23ArchiveStorageConverter16GetDirectoryInfoEv(HEAP32[i7 + 132 >> 2] | 0) | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i2;
 L1 : do if ((i1 | 0) != (i2 | 0)) {
  i2 = (i1 - i2 | 0) / 40 | 0;
  i1 = 0;
  while (1) {
   if (HEAP32[i3 + (i1 * 40 | 0) + 16 >> 2] & 4 | 0) {
    i1 = 1;
    break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  STACKTOP = i6;
  return i1 | 0;
 } while (0);
 i1 = i7 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = 4;
 i1 = i7 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 __Z6FormatPKcz(i4, gb + 366764 | 0, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i7 + 96 | 0, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN20SoundChannelInstance17set3DDopplerLevelEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32767;
 HEAPF32[i1 + 52 >> 2] = f2;
 i1 = i1 + 146 | 0;
 HEAP16[i1 >> 1] = (i7 & 1) << 6 & 65535 | HEAP16[i1 >> 1] & -65;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel17set3DDopplerLevelEf(i3, f2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 208;
 HEAP32[i5 + 8 >> 2] = gb + 866877;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN11KeyframeTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034360 | 0, HEAP32[gb + 37012 >> 2] | 0, i1, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 4 | 0;
 i3 = HEAP32[gb + 37208 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034365 | 0, i3, i4, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i4 = i1 + 20 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034371 | 0, i3, i4, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034379 | 0, i3, i1, 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZL25LogCallbackImplementationRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 248 | 0;
 i5 = i8;
 i6 = i8 + 240 | 0;
 if (!(__Z17GetMonoManagerPtrv() | 0)) {
  STACKTOP = i8;
  return;
 }
 if (!(__Z20scripting_domain_getv() | 0)) {
  STACKTOP = i8;
  return;
 }
 i11 = (__Z23GetCoreScriptingClassesv() | 0) + 16 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i7);
 __ZN18ScriptingArguments9AddStringEPKc(i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN18ScriptingArguments9AddStringEPKc(i5, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZN18ScriptingArguments6AddIntEi(i5, i3);
 __ZN18ScriptingArguments10AddBooleanEb(i5, i4);
 HEAP32[i7 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeIP12Il2CppObjectEET_PP15Il2CppExceptionb(i5, i7, 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZThn4_N12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i3 = i3 + -4 | 0;
 i8 = HEAP32[i3 + 64 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0, i1 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 i8 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i2 >> 2] | 0) | 0;
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i2 + 4 >> 2] | 0) | 0;
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 >> 2] | 0) | 0;
 i1 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = gb + 149632 + 8;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i5 + 12 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 3);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZNK5physx2Sn22DeserializationContext16resolveReferenceEjj(i6, i3, i4) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[i6 + 20 >> 2] | 0;
 i7 = ~(i3 << 15) + i3 | 0;
 i7 = (i7 >>> 10 ^ i7) * 9 | 0;
 i7 = i7 >>> 6 ^ i7;
 i7 = i7 + ~(i7 << 11) | 0;
 i1 = ~(i4 << 15) + i4 | 0;
 i1 = (i1 >>> 10 ^ i1) * 9 | 0;
 i1 = i1 >>> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i5 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i8 + 8 | 0;
 i1 = (HEAP32[i8 + 12 >> 2] | 0) + (((HEAP32[i8 + 20 >> 2] | 0) + -1 & (i7 >>> 16 ^ i7 ^ (i1 ^ -57320555 ^ i1 >>> 16) * 1000007)) << 2) | 0;
 while (1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i5 + (i1 * 12 | 0) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i3 | 0)) break;
  i1 = (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0;
 }
 i8 = HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] | 0;
 i1 = i8 & 2147483647;
 if ((i8 | 0) > -1) {
  i8 = (HEAP32[i6 + 16 >> 2] | 0) + (HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + (i1 << 3) >> 2] | 0) | 0;
  return i8 | 0;
 } else {
  i7 = HEAP32[i6 + 24 >> 2] | 0;
  i8 = (HEAP32[i6 + 12 >> 2] | 0) + (i1 << 4) | 0;
  i8 = mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
  return i8 | 0;
 }
 return 0;
}

function __ZN9Heightmap13AwakeFromLoadEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = __Z11GetIPhysicsv() | 0;
 if (i3 | 0) {
  i4 = i5 + 100 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   HEAP32[i4 >> 2] = 0;
  }
  HEAP32[i2 + 12 >> 2] = 0;
  i1 = i2 + 16 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 1;
  HEAPF32[i2 + 20 >> 2] = Math_fround(-1.0);
  HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
  HEAP16[i2 + 28 >> 1] = 0;
  if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i5, i2) | 0) {
   HEAP32[i4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0, i2 | 0) | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
  }
 }
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 i3 = i5 + 64 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i5 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i5 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i5 | 0, 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 << 4;
  i2 = i7 + 512 | 0;
  if (i1 >>> 0 < 513 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i7, i1, gb + 838004 | 0, 543) | 0;
 }
 i3 = HEAP32[i7 + 520 >> 2] | 0;
 i4 = i1 + (i3 << 4) | 0;
 i5 = i7 + 516 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   i2 = i2 + 16 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 16 | 0;
  }
 }
 i3 = i7 + 524 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i2 | 0)) {
  HEAP8[i7 + 512 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i6;
  return;
 } else {
  __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, i2);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = i6;
  return;
 }
}

function __ZN5physx2Gu28computeMTD_ConvexHeightFieldERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES9_(i7, i5, i1, i4, i2, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 4240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i8 + 4176 | 0;
 i11 = i8 + 4120 | 0;
 i9 = i8 + 4116 | 0;
 i3 = i8;
 i10 = i8 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i1);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i9 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i4, i6, i10, i9, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i7, i5, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 i12 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i8;
 return i12 | 0;
}

function __ZN22UnityProfilerPerThread20SampleGCMonoCallbackEPvii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var d4 = 0.0, i5 = 0;
 switch (i2 | 0) {
 case 6:
  {
   i1 = HEAP32[gb + 1163228 >> 2] | 0;
   if (!i1) return;
   d4 = +_emscripten_get_now() * 1.0e6;
   i2 = +Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0;
   i3 = i1 + 240 | 0;
   HEAP32[i3 >> 2] = ~~d4 >>> 0;
   HEAP32[i3 + 4 >> 2] = i2;
   return;
  }
 case 9:
  {
   i1 = HEAP32[gb + 1163228 >> 2] | 0;
   if (!i1) return;
   i5 = i1 + 240 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i5 = HEAP32[i5 + 4 >> 2] | 0;
   d4 = +_emscripten_get_now() * 1.0e6;
   i5 = __Z17TimeToNanosecondsy(_i64Subtract(~~d4 >>> 0 | 0, (+Math_abs(d4) >= 1.0 ? (d4 > 0.0 ? ~~+Math_min(+Math_floor(d4 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d4 - +(~~d4 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i2 | 0, i5 | 0) | 0, getTempRet0() | 0) | 0;
   i2 = getTempRet0() | 0;
   i3 = i1 + 248 | 0;
   i1 = i3;
   i1 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i5 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i3 + 4 >> 2] = i2;
   return;
  }
 default:
  return;
 }
}

function __ZN21AudioDistortionFilter8TransferI14SafeBinaryReadEEvRT_(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i1, i6);
 i4 = i1 + 44 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 855555 | 0, HEAP32[gb + 37012 >> 2] | 0, i2, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i5 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i5 = 6; else {
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i5 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i4, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i4 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN13RendererScene22RecalculateDirtyBoundsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i12 + 4 | 0;
 i2 = i12;
 if ((HEAP16[gb + 1112692 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112692 | 0, i1);
  i6 = gb + 1112692 | 0;
 } else i6 = 0;
 i7 = i3 + 132 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if ((i8 | 0) > 0) {
  i9 = i3 + 120 | 0;
  i10 = i3 + 72 | 0;
  i11 = i3 + 60 | 0;
  i2 = i3 + 80 | 0;
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if ((i3 | 0) < (HEAP32[i10 >> 2] | 0)) {
    i4 = HEAP32[i11 >> 2] | 0;
    i5 = i4 + (i3 * 24 | 0) + 20 | 0;
    if (HEAP8[i5 >> 0] & 2) {
     __ZN12BaseRenderer12GetWorldAABBER4AABB(HEAP32[i4 + (i3 * 24 | 0) >> 2] | 0, (HEAP32[i2 >> 2] | 0) + (i3 * 24 | 0) | 0);
     HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -3;
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
 }
 HEAP32[i7 >> 2] = 0;
 if (!i6) {
  STACKTOP = i12;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i12;
 return;
}

function __Z45GUIStyle_CUSTOM_INTERNAL_CALL_SetMouseTooltipP12Il2CppObjectP12Il2CppStringRK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 48 | 0;
 i9 = i10 + 8 | 0;
 i4 = i10 + 44 | 0;
 i5 = i10 + 24 | 0;
 i6 = i10 + 12 | 0;
 i7 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 if (!(HEAP32[i1 + 8 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9); else {
  i9 = __Z11GetGUIStatev() | 0;
  __ZNK11ICallString6ToUTF8Ev(i6, i4);
  i4 = (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6;
  i11 = gb + 63672 | 0;
  i1 = HEAP32[i11 + 4 >> 2] | 0;
  i2 = i7;
  HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  __ZN11UTF16StringC2EPKc10MemLabelId(i5, i4, i8);
  __ZN8GUIStyle15SetMouseTooltipER8GUIStateRK11UTF16StringRK5RectTIfE(i9, i5, i3);
  __ZN11UTF16StringD2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i10;
  return;
 }
}

function _UNITY_tt_size_run_prep(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i5 + 292 >> 2] | 0;
 i3 = _UNITY_TT_Load_Context(i6, i2, i5) | 0;
 if (i3 | 0) {
  i6 = i3;
  return i6 | 0;
 }
 HEAP32[i6 + 428 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP8[i6 + 488 >> 0] = 0;
 HEAP8[i6 + 561 >> 0] = i1;
 i4 = i2 + 636 | 0;
 _UNITY_TT_Set_CodeRange(i6, 2, HEAP32[i2 + 640 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 _UNITY_TT_Clear_CodeRange(i6, 3);
 if (!(HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  _UNITY_TT_Goto_CodeRange(i6, 2, 0);
  i1 = mftCall_ii(HEAP32[i2 + 652 >> 2] | 0, i6 | 0) | 0;
 }
 HEAP32[i5 + 300 >> 2] = i1;
 i3 = i6 + 284 | 0;
 HEAP16[i6 + 290 >> 1] = 16384;
 HEAP16[i6 + 292 >> 1] = 0;
 HEAP16[i6 + 294 >> 1] = 16384;
 HEAP16[i6 + 296 >> 1] = 0;
 HEAP16[i6 + 298 >> 1] = 16384;
 HEAP16[i6 + 300 >> 1] = 0;
 HEAP16[i3 >> 1] = 0;
 HEAP16[i6 + 286 >> 1] = 0;
 HEAP16[i6 + 288 >> 1] = 0;
 HEAP16[i6 + 344 >> 1] = 1;
 HEAP16[i6 + 346 >> 1] = 1;
 HEAP16[i6 + 348 >> 1] = 1;
 HEAP32[i6 + 304 >> 2] = 1;
 i2 = i5 + 172 | 0;
 i4 = i2 + 68 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 _UNITY_TT_Save_Context(i6, i5);
 i6 = i1;
 return i6 | 0;
}

function __ZNK20LightPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i4, i1, i2, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i2 = ~i2;
 } else i2 = 0;
 if ((HEAP32[i4 + 4 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 8 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 12 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 16 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 20 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 24 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 28 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 32 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 36 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 40 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 44 >> 2] | 0) == (i2 | 0)) i1 = 1; else if ((HEAP32[i4 + 48 >> 2] | 0) == (i2 | 0)) i1 = 1; else i1 = (HEAP32[i4 + 52 >> 2] | 0) == (i2 | 0);
 HEAP32[i5 + 4 >> 2] = i2;
 return i1 | 0;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i8 = i9;
 i4 = i6 + 104 | 0;
 __ZN19TransportJavaScript7CleanupEv(i6 + 8 | 0);
 i5 = i6 + 68 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i3) {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 1 | 0) == 1) mftCall_vi(HEAP32[i2 + 24 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 48 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 1 | 0) == 1) {
   i1 = HEAP32[i5 >> 2] | 0;
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
  }
 }
 HEAP32[i6 + 108 >> 2] = (i1 | 1 | 0) == 1 ? 3 : 4;
 i1 = i6 + 112 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z19MainThreadSchedulerPFvPvES_10JobGroupID(fb + 3924 | 0, i2, i7);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i9;
 return;
}

function __ZN17CapsuleCollider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 80 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 154196 + 8;
 STACKTOP = i4;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 3, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) return;
 i3 = i1 + (i6 << 3) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) return; else i1 = 0;
 do {
  i7 = i3 + (i1 << 3) | 0;
  HEAP32[i7 >> 2] = -2;
  HEAP32[i7 + 4 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN14ParticleSystem27SetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticleii(i1, i3, i8, i9, i10) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 868 >> 0] | 0)) {
  __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(i1, 2);
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i4 + 876 | 0;
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = 0;
 if (!i10) {
  HEAP8[i5 >> 0] = i6;
  return;
 }
 i7 = i4 + 640 + (i3 * 20 | 0) + 12 | 0;
 i2 = i4 + 640 + (i3 * 20 | 0) | 0;
 i1 = 0;
 while (1) {
  i3 = i1 + i9 | 0;
  if (i3 >>> 0 >= (HEAP32[i7 >> 2] | 0) >>> 0) break;
  __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii(i4, i8 + (i1 * 120 | 0) | 0, 1, HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i10 >>> 0) {
   i11 = 8;
   break;
  }
 }
 if ((i11 | 0) == 8) {
  HEAP8[i5 >> 0] = i6;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 622230 | 0, 0, gb + 612988 | 0, 2230, 1, 0, 0, 0);
 HEAP8[i5 >> 0] = i6;
 return;
}

function __ZN13dynamic_arrayI11CulledLightLj4EE6insertEPS0_PKS0_S4_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 3;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 3;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 3) | 0;
 _memmove(i14 + (i8 << 3) | 0, i14 | 0, i11 << 3 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function ___stpncpy(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = i3;
 do if (!((i5 ^ i2) & 3)) {
  i4 = (i1 | 0) != 0;
  L3 : do if (i4 & (i5 & 3 | 0) != 0) while (1) {
   i5 = HEAP8[i3 >> 0] | 0;
   HEAP8[i2 >> 0] = i5;
   if (!(i5 << 24 >> 24)) break L3;
   i1 = i1 + -1 | 0;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
   i4 = (i1 | 0) != 0;
   if (!(i4 & (i3 & 3 | 0) != 0)) {
    i6 = 5;
    break;
   }
  } else i6 = 5; while (0);
  if ((i6 | 0) == 5) if (!i4) {
   i1 = 0;
   break;
  }
  if (HEAP8[i3 >> 0] | 0) {
   L11 : do if (i1 >>> 0 > 3) {
    i4 = i3;
    while (1) {
     i3 = HEAP32[i4 >> 2] | 0;
     if ((i3 & -2139062144 ^ -2139062144) & i3 + -16843009 | 0) {
      i3 = i4;
      break L11;
     }
     HEAP32[i2 >> 2] = i3;
     i1 = i1 + -4 | 0;
     i3 = i4 + 4 | 0;
     i2 = i2 + 4 | 0;
     if (i1 >>> 0 > 3) i4 = i3; else break;
    }
   } while (0);
   i6 = 11;
  }
 } else i6 = 11; while (0);
 L16 : do if ((i6 | 0) == 11) if (!i1) i1 = 0; else while (1) {
  i6 = HEAP8[i3 >> 0] | 0;
  HEAP8[i2 >> 0] = i6;
  if (!(i6 << 24 >> 24)) break L16;
  i1 = i1 + -1 | 0;
  i2 = i2 + 1 | 0;
  if (!i1) {
   i1 = 0;
   break;
  } else i3 = i3 + 1 | 0;
 } while (0);
 _memset(i2 | 0, 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiRKNS_7Vector3ES7_PNS_9AllocatorEPKS0_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, f10 = f0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i11 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i11 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 f10 = Math_fround(HEAPF32[i8 >> 2]);
 if (!(f10 <= Math_fround(HEAPF32[i8 + 12 >> 2]))) {
  i11 = 2;
  STACKTOP = i9;
  return i11 | 0;
 }
 f10 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 if (!(f10 <= Math_fround(HEAPF32[i8 + 16 >> 2]))) {
  i11 = 2;
  STACKTOP = i9;
  return i11 | 0;
 }
 f10 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 if (!(f10 <= Math_fround(HEAPF32[i8 + 20 >> 2]))) {
  i11 = 2;
  STACKTOP = i9;
  return i11 | 0;
 }
 i11 = __ZN5Umbra17ImpTomeCollection5buildEPPKNS_7ImpTomeEiRKNS_4AABBEPNS_9AllocatorEPKS0_((i1 | 0) == 0 ? 0 : i1 + 3 & -4, i2, i3, i8, i6, (i7 | 0) == 0 ? 0 : i7 + 3 & -4) | 0;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i7 = i8;
 __Z7ToLowerI8UnityStrET_RKS1_(i7, i1);
 i5 = i7 + 11 | 0;
 i4 = HEAP8[i5 >> 0] | 0;
 i2 = i4 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i7 >> 2] | 0 : i7;
 i4 = i2 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255;
 i2 = i1 + i4 | 0;
 if (i4 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 i4 = HEAP32[i3 + 56 >> 2] | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 L8 : do if ((i1 | 0) == (i4 | 0)) i1 = -1; else {
  i2 = i3 << 24 >> 24 < 0 ? HEAP32[i7 >> 2] | 0 : i7;
  while (1) {
   if (!(_strcmp(HEAP32[i1 + 4 >> 2] | 0, i2) | 0)) break;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = -1;
    break L8;
   }
  }
  i1 = HEAP32[i1 >> 2] | 0;
 } while (0);
 if (i3 << 24 >> 24 >= 0) {
  STACKTOP = i8;
  return i1 | 0;
 }
 i5 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN16CircleCollider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 80 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 154392 + 8;
 STACKTOP = i4;
 return;
}

function __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawMeshP12Il2CppObjectS0_RK10Matrix4x4fS0_iiS0_(i2, i1, i7, i4, i8, i9, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 8 | 0;
 i3 = i11;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 558304 | 0, i3);
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 558304 | 0, i3);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 if (!i4) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i10) {
  i10 = 0;
  __ZN22RenderingCommandBuffer11AddDrawMeshERK10Matrix4x4fP4MeshP8MaterialiiP19ShaderPropertySheet(i2, i7, i5, i1, i8, i9, i10);
  STACKTOP = i11;
  return;
 }
 i10 = HEAP32[i10 + 8 >> 2] | 0;
 __ZN22RenderingCommandBuffer11AddDrawMeshERK10Matrix4x4fP4MeshP8MaterialiiP19ShaderPropertySheet(i2, i7, i5, i1, i8, i9, i10);
 STACKTOP = i11;
 return;
}

function __Z29StdTemplateConversionFunctionIytEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 & 65535;
  HEAP16[i1 >> 1] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 & 65535;
 HEAP16[i1 >> 1] = i10;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIysEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 & 65535;
  HEAP16[i1 >> 1] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 & 65535;
 HEAP16[i1 >> 1] = i10;
 STACKTOP = i8;
 return 1;
}

function __Z11MoveTowardsRK8Vector3fS1_f(i9, i3, i2, f12) {
 i9 = i9 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 f12 = Math_fround(f12);
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f10 = f0, f11 = f0, f13 = f0, f14 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f13 = Math_fround(HEAPF32[i3 >> 2]);
 f14 = Math_fround(f7 - f13);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(f8 - f10);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(f4 - f5);
 f1 = Math_fround(Math_fround(Math_fround(f14 * f14) + Math_fround(f11 * f11)) + Math_fround(f6 * f6));
 if (!(f1 > Math_fround(f12 * f12))) {
  HEAPF32[i9 >> 2] = f7;
  HEAPF32[i9 + 4 >> 2] = f8;
  HEAPF32[i9 + 8 >> 2] = f4;
  return;
 }
 f1 = Math_fround(Math_sqrt(Math_fround(f1)));
 if (f1 > Math_fround(9.99999974e-06)) {
  f10 = Math_fround(f10 + Math_fround(Math_fround(f11 / f1) * f12));
  f11 = Math_fround(f5 + Math_fround(Math_fround(f6 / f1) * f12));
  HEAPF32[i9 >> 2] = Math_fround(f13 + Math_fround(Math_fround(f14 / f1) * f12));
  HEAPF32[i9 + 4 >> 2] = f10;
  HEAPF32[i9 + 8 >> 2] = f11;
  return;
 } else {
  HEAPF32[i9 >> 2] = f13;
  HEAPF32[i9 + 4 >> 2] = f10;
  HEAPF32[i9 + 8 >> 2] = f5;
  return;
 }
}

function _UNITY_FT_Vector_Unit(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (!i8) return;
 HEAP32[i8 >> 2] = 14408027;
 i9 = i8 + 4 | 0;
 HEAP32[i9 >> 2] = 0;
 if ((i2 | 0) < -2949120) {
  i3 = 0;
  i1 = 14408027;
  while (1) {
   i1 = 0 - i1 | 0;
   i2 = i2 + 5898240 | 0;
   if ((i2 | 0) < -2949120) {
    i7 = i3;
    i3 = i1;
    i1 = i7;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    break;
   }
  }
 } else if ((i2 | 0) > 2949120) {
  i1 = 0;
  i4 = 14408027;
  while (1) {
   i3 = 0 - i1 | 0;
   i2 = i2 + -5898240 | 0;
   if ((i2 | 0) > 2949120) {
    i1 = i4;
    i4 = i3;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    i1 = i4;
    break;
   }
  }
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i3 = 14408027;
  i1 = 0;
 }
 while (1) {
  i4 = i1 + i5 >> i6;
  if ((i2 | 0) < 0) {
   i1 = i1 - (i3 + i5 >> i6) | 0;
   i3 = i4 + i3 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i1 = (i3 + i5 >> i6) + i1 | 0;
   i3 = i3 - i4 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
  }
 }
 HEAP32[i8 >> 2] = i3 + 128 >> 8;
 HEAP32[i9 >> 2] = i1 + 128 >> 8;
 return;
}

function _t2_hints_stems(i8, i1, i2, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12;
 if ((i2 | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i11 = i8 + 4 | 0;
 i7 = i8 + 16 + ((i1 >>> 0 > 1 ? 1 : i1) * 36 | 0) | 0;
 i1 = 0;
 do {
  i6 = (i2 | 0) > 16 ? 16 : i2;
  i4 = i6 << 1;
  i3 = 0;
  do {
   i1 = (HEAP32[i9 + (i3 << 2) >> 2] | 0) + i1 | 0;
   HEAP32[i10 + (i3 << 2) >> 2] = (_UNITY_FT_RoundFix(i1) | 0) >> 16;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i4 | 0));
  i3 = 0;
  do {
   i5 = i10 + ((i3 | 1) << 2) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - (HEAP32[i10 + (i3 << 2) >> 2] | 0);
   i3 = i3 + 2 | 0;
  } while ((i3 | 0) < (i4 | 0));
  L11 : do if (!(HEAP32[i11 >> 2] | 0)) {
   i3 = i6;
   i4 = i10;
   while (1) {
    i5 = _ps_dimension_add_t1stem(i7, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i8 >> 2] | 0, 0) | 0;
    if (i5 | 0) break;
    if ((i3 | 0) > 1) {
     i3 = i3 + -1 | 0;
     i4 = i4 + 8 | 0;
    } else break L11;
   }
   HEAP32[i11 >> 2] = i5;
  } while (0);
  i2 = i2 - i6 | 0;
 } while ((i2 | 0) > 0);
 STACKTOP = i12;
 return;
}

function _start_pass_coef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 328 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = 0;
 do if ((HEAP32[i1 + 228 >> 2] | 0) > 1) HEAP32[i4 + 20 >> 2] = 1; else {
  i3 = HEAP32[i1 + 232 >> 2] | 0;
  if ((HEAP32[i1 + 224 >> 2] | 0) == 1) {
   HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 72 >> 2];
   break;
  } else {
   HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 12 >> 2];
   break;
  }
 } while (0);
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 switch (i2 | 0) {
 case 0:
  {
   if (HEAP32[i4 + 64 >> 2] | 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 4;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
   }
   HEAP32[i4 + 4 >> 2] = fb + 499;
   return;
  }
 case 3:
  {
   if (!(HEAP32[i4 + 64 >> 2] | 0)) {
    i3 = HEAP32[i1 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 4;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
   }
   HEAP32[i4 + 4 >> 2] = fb + 500;
   return;
  }
 case 2:
  {
   if (!(HEAP32[i4 + 64 >> 2] | 0)) {
    i3 = HEAP32[i1 >> 2] | 0;
    HEAP32[i3 + 20 >> 2] = 4;
    mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
   }
   HEAP32[i4 + 4 >> 2] = fb + 501;
   return;
  }
 default:
  {
   i4 = HEAP32[i1 >> 2] | 0;
   HEAP32[i4 + 20 >> 2] = 4;
   mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
   return;
  }
 }
}

function __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 24 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 24;
 HEAP32[i8 >> 2] = i6 + (i4 * 24 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 432020 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = (HEAP32[i3 + 52 >> 2] | 0) + 12 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 432037 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN13RendererScene11AddRendererEP8Renderer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 8 | 0;
 i2 = i6;
 i5 = i6 + 16 | 0;
 if (!(HEAP32[i1 + 148 >> 2] | 0)) {
  i4 = i3 + 32 | 0;
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i4, i5);
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0);
  i5 = __ZN13RendererScene19AddRendererInternalEP8RendereriRK4AABB(i1, i3, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0) | 0, i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!i3) {
  HEAP32[i2 >> 2] = gb + 587985;
  __Z6FormatPKcz(i5, gb + 384038 | 0, i2);
  i1 = 0;
 } else {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  if (!i1) i1 = gb + 587985 | 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  __Z6FormatPKcz(i5, gb + 384038 | 0, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 383163 | 0, 277, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = -1;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z57ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterTypeP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i3 | 0) >= 0) {
  if (!i2) {
   i1 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  }
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) {
   i7 = i2;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
  }
  if ((__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i1 + 916 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
    STACKTOP = i6;
    return HEAP32[(HEAP32[(HEAP32[i1 + 916 >> 2] | 0) + 8 >> 2] | 0) + (i3 * 12 | 0) + 4 >> 2] | 0;
   }
  }
 }
 i7 = (__ZNK9SubModule19GetSubEmittersCountEv(HEAP32[(__ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i4) | 0) + 916 >> 2] | 0) | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i7;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622601 | 0, i5);
 return 0;
}

function __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPwEEEET_S4_S4_S4_(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i11 = i2 - i8 >> 2;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = i9 - i2 >> 2;
 i1 = i8;
 if ((i11 | 0) == (i10 | 0)) {
  i3 = i2;
  i2 = i3;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) break;
   i11 = HEAP32[i1 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i2 >> 2] = i11;
   i1 = i1 + 4 | 0;
   i2 = i2 + 4 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = i11;
  i3 = i10;
  while (1) {
   i2 = (i2 | 0) % (i3 | 0) | 0;
   if (!i2) break; else {
    i8 = i3;
    i3 = i2;
    i2 = i8;
   }
  }
  i8 = HEAP32[i4 >> 2] | 0;
  i2 = i1 + (i3 << 2) | 0;
  while (1) {
   if ((i2 | 0) == (i1 | 0)) break;
   i6 = i2 + -4 | 0;
   i2 = i6;
   i7 = HEAP32[i6 >> 2] | 0;
   i4 = i6 + (i11 << 2) | 0;
   i5 = i2;
   while (1) {
    HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
    i5 = i4;
    i3 = i9 - i5 >> 2;
    i3 = (i11 | 0) < (i3 | 0) ? i4 + (i11 << 2) | 0 : i1 + (i11 - i3 << 2) | 0;
    if ((i3 | 0) == (i6 | 0)) break; else i4 = i3;
   }
   HEAP32[i4 >> 2] = i7;
   i1 = i8;
  }
  i1 = i1 + (i10 << 2) | 0;
 }
 return i1 | 0;
}

function __ZN7mecanim9animation24CreateBlendTreeWorkspaceEjRNS_6memory9AllocatorE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, 16, 4) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if (!i2) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  i3 = 0;
  i5 = i4 + 12 | 0;
  HEAP32[i5 >> 2] = i3;
  return i4 | 0;
 }
 i5 = i2 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i5 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i2 << 2) | 0)) HEAP32[i4 >> 2] = i1; else {
  _memset(i1 | 0, 0, i5 | 0) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i5 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i2 << 2) | 0)) HEAP32[i4 + 4 >> 2] = i1; else {
  _memset(i1 | 0, 0, i5 | 0) | 0;
  HEAP32[i4 + 4 >> 2] = i1;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i5 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i2 << 2) | 0)) HEAP32[i4 + 8 >> 2] = i1; else {
  _memset(i1 | 0, 0, i5 | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i1;
 }
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 << 3 | 0, 4) | 0;
 i5 = i4 + 12 | 0;
 HEAP32[i5 >> 2] = i3;
 return i4 | 0;
}

function __ZN7dtCrowd10setNavMeshEPK9dtNavMeshPK15HeightMeshQueryfi(i1, i2, i4, f5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i3 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = i1 + 260 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 i7 = i1 + 80 | 0;
 __Z6dtFreePv(HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i3 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i2, i6) | 0;
 HEAP32[i8 >> 2] = i3;
 if (!i3) {
  i8 = 0;
  return i8 | 0;
 }
 i3 = i1 + 252 | 0;
 HEAP32[i3 >> 2] = 32;
 HEAP32[i1 + 32 >> 2] = 0;
 i8 = __Z7dtAlloci(256) | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i1 + 88 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 256 >> 2] = 0;
 i7 = i1 + 464 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i7 >> 2] | 0);
 i8 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i2, (i6 | 0) < 512 ? i6 : 512) | 0;
 HEAP32[i7 >> 2] = i8;
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 __Z17FreeStaticQueriesv();
 __Z21AllocateStaticQueriesPK9dtNavMesh(i2);
 f9 = Math_fround(f5 * Math_fround(2.0));
 f5 = Math_fround(f5 * Math_fround(1.5));
 HEAPF32[i1 + 432 >> 2] = f9;
 HEAPF32[i1 + 436 >> 2] = f5;
 HEAPF32[i1 + 440 >> 2] = f9;
 HEAP32[i1 + 468 >> 2] = i4;
 i8 = 1;
 return i8 | 0;
}

function __ZN5physx9PxTaskMgrD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 105568 + 8;
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 88 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 84 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 76 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 72 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 64 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i1 = i2 + 60 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = i2 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN5physx2Cm12RefCountable17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i4 >> 2] = HEAP32[gb + 121540 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 121540 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 121540 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 121540 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 121540 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 121540 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 121540 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 121540 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 121572 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 121572 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 121572 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[gb + 121572 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[gb + 121572 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[gb + 121572 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[gb + 121572 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[gb + 121572 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN14DetailDatabase8TransferI17RemapPPtrTransferEEvRT_(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 i4 = HEAP32[i8 + 20 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i5 = i9 + 16 | 0;
  i6 = i9 + 36 | 0;
  i7 = i9 + 40 | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i7 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i2 = i1 + 4 | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i7 >> 0] | 0) HEAP32[i2 >> 2] = i3;
   i1 = i1 + 136 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __ZN12TreeDatabase8TransferI17RemapPPtrTransferEEvRT_(HEAP32[i8 + 32 >> 2] | 0, i9);
 i1 = HEAP32[i8 + 104 >> 2] | 0;
 i4 = HEAP32[i8 + 108 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i9 + 16 | 0;
 i6 = i9 + 36 | 0;
 i3 = i9 + 40 | 0;
 do {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN12MeshCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5);
 i1 = i4 + 60 | 0;
 i6 = i5 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i4 + 121 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
 i1 = i4 + 124 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
  i7 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i7 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i5);
  return;
 }
}

function __ZN11dtPathQueue7requestEyyPKfS1_PK13dtQueryFilterb(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 if (HEAP32[i1 >> 2] | 0) {
  i10 = 0;
  return i10 | 0;
 }
 i11 = i1 + 216 | 0;
 i10 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + 1 | 0;
 HEAP32[i11 >> 2] = (i12 | 0) == 0 ? i10 + 2 | 0 : i12;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 16 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i7 + 8 >> 2];
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 _memcpy(i1 + 72 | 0, i8 | 0, 132) | 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP8[i1 + 204 >> 0] = i9 & 1;
 i1 = i1 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
  __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i12 = i10;
 return i12 | 0;
}

function __ZN10Effector2D25CheckEffectorColliderMaskEP10Collider2DS1_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (HEAP8[i3 + 53 >> 0] | 0) {
  i2 = HEAP32[i3 + 156 >> 2] | 0;
  if (!i2) {
   i3 = 0;
   return i3 | 0;
  }
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0) | 0) {
   i3 = 0;
   return i3 | 0;
  }
  if (!(1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i2 + 60 >> 2])) {
   i3 = 0;
   return i3 | 0;
  }
  if ((HEAP32[HEAP32[(HEAP32[HEAP32[i1 + 60 >> 2] >> 2] | 0) + 28 >> 2] >> 2] | 0) != 2) {
   i3 = 0;
   return i3 | 0;
  }
 }
 if (!(HEAP8[i1 + 53 >> 0] | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0) | 0) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(1 << HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i1 + 60 >> 2])) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[HEAP32[(HEAP32[HEAP32[i3 + 60 >> 2] >> 2] | 0) + 28 >> 2] >> 2] | 0) == 2;
 return i3 | 0;
}

function __ZL35InitializePhysics2DScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 801496 | 0, 16) | 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[gb + 1458416 >> 2] = i4;
 i4 = __Z11RequireTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801622 | 0) | 0;
 HEAP32[HEAP32[gb + 1458416 >> 2] >> 2] = i4;
 i4 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801634 | 0) | 0;
 i2 = HEAP32[gb + 1458416 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = i2 + 8 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 801649 | 0, gb + 801659 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1458416 >> 2] | 0) + 16 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 801649 | 0, gb + 801667 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 801689 | 0) | 0;
 HEAP32[(HEAP32[gb + 1458416 >> 2] | 0) + 24 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __Z26CreateGameObjectWithVAListRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 24 | 0;
 i5 = i4 + 8 | 0;
 i7 = i4;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(80, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 444974 | 0, 774) | 0;
 i10 = gb + 63520 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i3, i6, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, ((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 __ZN10GameObject8ActivateEv(i3);
 __Z23AddComponentsFromVAListR10GameObjectPKcPi(i3, i2, i5);
 STACKTOP = i4;
 return i3 | 0;
}

function _unity_z_inflateInit_(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i4 = -6;
  return i4 | 0;
 }
 if ((i2 | 0) != 56 | (HEAP8[i1 >> 0] | 0) != 49) {
  i4 = -6;
  return i4 | 0;
 }
 if (!i4) {
  i4 = -2;
  return i4 | 0;
 }
 i3 = i4 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i4 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = fb + 334;
  HEAP32[i4 + 40 >> 2] = 0;
  i1 = fb + 334 | 0;
 }
 i2 = i4 + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = fb + 2370;
 i1 = mftCall_iiii(i1 | 0, HEAP32[i4 + 40 >> 2] | 0, 1, 9520) | 0;
 if (!i1) {
  i4 = -4;
  return i4 | 0;
 }
 HEAP32[i4 + 28 >> 2] = i1;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 36 >> 2] = 15;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 32768;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 i4 = i1 + 1328 | 0;
 HEAP32[i1 + 108 >> 2] = i4;
 HEAP32[i1 + 80 >> 2] = i4;
 HEAP32[i1 + 76 >> 2] = i4;
 i4 = 0;
 return i4 | 0;
}

function __ZNKSt3__212ctype_bynameIwE9do_narrowEPKwS3_cPc(i1, i2, i7, i6, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 i4 = i1 + 8 | 0;
 i1 = i3;
 while (1) {
  if ((i2 | 0) == (i7 | 0)) {
   i1 = 12;
   break;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  i5 = _uselocale(HEAP32[i4 >> 2] | 0) | 0;
  __THREW__ = 0;
  i3 = invoke_ii(fb + 2808 | 0, i3 | 0) | 0;
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i1 = 7;
   break;
  }
  if (i5 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i5 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = 6;
    break;
   }
  }
  HEAP8[i1 >> 0] = (i3 | 0) != -1 ? i3 & 255 : i6;
  i2 = i2 + 4 | 0;
  i1 = i1 + 1 | 0;
 }
 if ((i1 | 0) == 6) {
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 } else if ((i1 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i5 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i5 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i8 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i8);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i1 | 0) == 12) return i7 | 0;
 return 0;
}

function __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 HEAP32[i1 + 68 >> 2] = gb + 831985;
 HEAP32[i1 + 72 >> 2] = 673;
 HEAP32[i1 + 76 >> 2] = fb + 2423;
 HEAP32[i1 + 80 >> 2] = gb + 834551;
 HEAP32[i1 + 84 >> 2] = 674;
 HEAP32[i1 + 88 >> 2] = fb + 3966;
 HEAP32[i1 + 92 >> 2] = fb + 3967;
 HEAP32[i1 + 96 >> 2] = gb + 834960;
 HEAP32[i1 + 100 >> 2] = 681;
 HEAP32[i1 + 104 >> 2] = fb + 2425;
 HEAP32[i1 + 108 >> 2] = fb + 3970;
 HEAP32[i1 + 112 >> 2] = gb + 831985;
 HEAP32[i1 + 116 >> 2] = 682;
 HEAP32[i1 + 120 >> 2] = fb + 2426;
 HEAP32[i1 + 124 >> 2] = gb + 834565;
 HEAP32[i1 + 128 >> 2] = 683;
 HEAP32[i1 + 132 >> 2] = fb + 3971;
 HEAP32[i1 + 136 >> 2] = fb + 3972;
 return;
}

function __ZN5IMGUI20MoveWindowFromLayoutER8GUIStateiRK5RectTIfE(i1, i5, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, f8 = f0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i4 | 0)) i6 = 4; else {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
   if ((i2 | 0) == (i4 | 0)) {
    i6 = 4;
    break L1;
   }
  }
  if (!i1) return;
 } while (0);
 if ((i6 | 0) == 4) {
  i1 = HEAP32[i3 + 24 >> 2] | 0;
  if (!i1) return;
  if ((HEAP32[i1 >> 2] | 0) != (i5 | 0)) return;
 }
 i2 = i1 + 52 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f8 != Math_fround(HEAPF32[i7 >> 2]))) {
  f8 = Math_fround(HEAPF32[i1 + 56 >> 2]);
  if (!(f8 != Math_fround(HEAPF32[i7 + 4 >> 2]))) {
   f8 = Math_fround(HEAPF32[i1 + 60 >> 2]);
   if (!(f8 != Math_fround(HEAPF32[i7 + 8 >> 2]))) {
    f8 = Math_fround(HEAPF32[i1 + 64 >> 2]);
    if (!(f8 != Math_fround(HEAPF32[i7 + 12 >> 2]))) return;
   }
  }
 };
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP8[i1 + 117 >> 0] = 1;
 return;
}

function __ZN13BoxCollider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 80 | 0) | 0;
 HEAP32[i1 >> 2] = gb + 153620 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12InputManagerD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 >> 2] = gb + 59752 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8 + 148 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8 + 136 | 0);
 i6 = i8 + 124 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 128 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i3 = i2 + -12 | 0;
    HEAP32[i7 >> 2] = i3;
    i4 = HEAP32[i3 >> 2] | 0;
    i5 = i4;
    if (!i4) i2 = i3; else {
     i2 = i2 + -8 | 0;
     i3 = HEAP32[i2 >> 2] | 0;
     if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
     __ZdlPv(i4);
     i2 = HEAP32[i7 >> 2] | 0;
    }
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 + 88 >> 2] | 0, i8 + 80 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 + 68 >> 2] | 0, i8 + 60 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i8 + 48 >> 2] | 0, i8 + 40 | 0);
 __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev(i8 + 28 | 0);
 HEAP32[i8 >> 2] = gb + 28648 + 8;
 HEAP32[i8 >> 2] = gb + 28496 + 8;
 return;
}

function __Z46ParticleSystem_EmissionModule_CUSTOM_SetBurstsP12Il2CppObjectP11Il2CppArrayi(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i7) return;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0)) return;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 i3 = (i1 | 0) < 0 | i3 >>> 0 < i1 >>> 0 ? i3 : i1;
 i6 = (i3 | 0) > 4 ? 4 : i3;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = i1 + 264 | 0;
 i5 = i4 + 8 | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i5 + 528 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 3) >> 2];
   HEAP32[i5 + 544 + (i1 << 2) >> 2] = HEAPU16[i2 + (i1 << 3) + 4 >> 1];
   HEAP32[i5 + 560 + (i1 << 2) >> 2] = HEAPU16[i2 + (i1 << 3) + 6 >> 1];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i6 | 0));
 }
 HEAP32[i4 + 584 >> 2] = i6;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
 return;
}

function __ZNK12NavMeshAgent20CalculatePolygonPathERK8Vector3fP11NavMeshPath(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i1 + 68 | 0;
 if ((HEAP32[i5 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844509 | 0, 0, gb + 841797 | 0, 555, 1, 0, 0, 0);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!(((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 4 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i2 + 8 >> 2] & 2139095040 | 0) != 2139095040)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
 i5 = __ZNK7dtCrowd14getAgentFilterEi(i1, HEAP32[i5 >> 2] | 0) | 0;
 i5 = __ZN14NavMeshManager20CalculatePolygonPathEP11NavMeshPathRK8Vector3fS4_RK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i3, i4, i2, i5) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN9Transform7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 422187 | 0, 106) | 0;
 i7 = i1;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 56064 + 8;
 i1 = i6;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = i4;
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = -1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN8Playable10DisconnectEPS_i(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i3 = i7 + 4 | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i5 = i1 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 >>> 0 <= i6 >>> 0) {
  HEAP32[i4 >> 2] = i6;
  __Z6FormatPKcz(i3, gb + 390514 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 390333 | 0, 156, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i6 << 3) + 4 >> 2] | 0;
 if (i3) {
  i4 = HEAP32[i3 + 8 >> 2] | 0;
  if (HEAP32[i4 + 48 >> 2] | 0) HEAP32[(HEAP32[i4 + 36 >> 2] | 0) + 4 >> 2] = 0;
  if (HEAP16[i3 + 52 >> 1] & 2) {
   __ZN15DirectorManager22ScheduleForDestructionEP8Playable(__Z18GetDirectorManagerv() | 0, i3);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
  }
 }
 if (i2 >>> 0 <= i6 >>> 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i6 << 3) + 4 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN7mecanim4hand13HandPoseSolveEPKNS0_8HandPoseEPS1_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0;
 i4 = i2 + 120 | 0;
 i5 = i2 + 124 | 0;
 i6 = i2 + 128 | 0;
 i1 = 0;
 do {
  i7 = i1 << 2;
  f8 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i4 >> 2]));
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 40 + (i7 << 2) >> 2]));
  HEAPF32[i3 + 40 + (i7 << 2) >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  f8 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i4 >> 2]));
  i9 = i7 | 1;
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 40 + (i9 << 2) >> 2]));
  HEAPF32[i3 + 40 + (i9 << 2) >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i6 >> 2]));
  f8 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i4 >> 2]));
  i9 = i7 | 2;
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 40 + (i9 << 2) >> 2]));
  HEAPF32[i3 + 40 + (i9 << 2) >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  f8 = Math_fround(Math_fround(1.0) - Math_fround(HEAPF32[i4 >> 2]));
  i7 = i7 | 3;
  f8 = Math_fround(f8 * Math_fround(HEAPF32[i2 + 40 + (i7 << 2) >> 2]));
  HEAPF32[i3 + 40 + (i7 << 2) >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER14SafeBinaryRead(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i4, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 744763 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i4, i5);
   i2 = i4 + 92 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 738066 | 0, gb + 738082 | 0, i3, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
   __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_(i4, i5);
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN14CompressedMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 28 | 0, i5);
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 56 | 0, i5);
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 104 | 0, i5);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 180 | 0, i5);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 84 | 0, i5);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 132 | 0, i5);
 __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 152 | 0, i5);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 200 | 0, i5);
 __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 220 | 0, i5);
 i1 = i1 + 240 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __ZN7Cubemap23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 397454 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN9Texture2D8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 152 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 397462 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN29AssetBundleLoadAssetOperationD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 27408 + 8;
 i2 = HEAP32[gb + 1104056 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 if (i3 | 0) __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E5eraseERS4_(i2 + 16 | 0, i1) | 0;
 i1 = i3 + 216 | 0;
 if ((HEAP32[i3 + 232 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 220 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 196 | 0;
 if ((HEAP32[i3 + 212 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 200 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3 + 184 | 0, HEAP32[i3 + 188 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 168 | 0);
 __ZN14ConstantStringD2Ev(i3 + 164 | 0);
 __ZN13LoadOperationD2Ev(i3);
 STACKTOP = i4;
 return;
}

function __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f8 * Math_fround(2.0));
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f9 * Math_fround(2.0));
 f4 = Math_fround(f8 * f5);
 f3 = Math_fround(f6 * f7);
 f9 = Math_fround(f9 * f10);
 f11 = Math_fround(f8 * f7);
 f8 = Math_fround(f8 * f10);
 f6 = Math_fround(f6 * f10);
 f12 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f5 = Math_fround(f5 * f12);
 f7 = Math_fround(f7 * f12);
 f10 = Math_fround(f12 * f10);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f3 + f9));
 HEAPF32[i2 + 4 >> 2] = Math_fround(f11 + f10);
 HEAPF32[i2 + 8 >> 2] = Math_fround(f8 - f7);
 HEAPF32[i2 + 12 >> 2] = Math_fround(f11 - f10);
 HEAPF32[i2 + 16 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f4 + f9));
 HEAPF32[i2 + 20 >> 2] = Math_fround(f6 + f5);
 HEAPF32[i2 + 24 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i2 + 28 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i2 + 32 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(f4 + f3));
 return;
}

function _cf2_glyphpath_moveTo(i8, i6, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i4 = i8 + 11664 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i8 + 11740 | 0;
  i3 = i8 + 11667 | 0;
  i1 = i8 + 11736 | 0;
 } else {
  i5 = i8 + 11665 | 0;
  HEAP8[i5 >> 0] = 1;
  i1 = i8 + 11736 | 0;
  i2 = i8 + 11740 | 0;
  _cf2_glyphpath_lineTo(i8, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0);
  i3 = i8 + 11744 | 0;
  if (HEAP8[i3 >> 0] | 0) _cf2_glyphpath_pushPrevElem(i8, i8 + 8 | 0, i8 + 11704 | 0, HEAP32[i8 + 11712 >> 2] | 0, HEAP32[i8 + 11716 >> 2] | 0, 1);
  i9 = i8 + 11667 | 0;
  HEAP8[i9 >> 0] = 1;
  HEAP8[i4 >> 0] = 0;
  HEAP8[i5 >> 0] = 0;
  HEAP8[i3 >> 0] = 0;
  i3 = i9;
 }
 HEAP32[i1 >> 2] = i6;
 HEAP32[i8 + 11720 >> 2] = i6;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i8 + 11724 >> 2] = i7;
 HEAP8[i3 >> 0] = 1;
 i2 = i8 + 8 | 0;
 i1 = i8 + 11676 | 0;
 if (HEAP8[i8 + 20 >> 0] | 0) if (!((_cf2_hintmask_isNew(HEAP32[i1 >> 2] | 0) | 0) << 24 >> 24)) {
  i9 = i8 + 3876 | 0;
  _memcpy(i9 | 0, i2 | 0, 3868) | 0;
  return;
 }
 _cf2_hintmap_build(i2, HEAP32[i8 + 11668 >> 2] | 0, HEAP32[i8 + 11672 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 + 11680 >> 2] | 0, 0);
 i9 = i8 + 3876 | 0;
 _memcpy(i9 | 0, i2 | 0, 3868) | 0;
 return;
}

function __ZNSt3__26vectorIN19UnityPluginRegistry6PluginENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 24 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 24;
 HEAP32[i8 >> 2] = i6 + (i4 * 24 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = i5 + 436 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i5 + 140 | 0;
 if (!i2) {
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return;
 }
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 do if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 36 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) {
   HEAP8[i2 + 32 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 } while (0);
 i1 = i5 + 420 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i5 + 432 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i5 + 424 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + 1;
 if ((i6 | 0) < ((HEAP32[i5 + 416 >> 2] | 0) * 50 | 0)) {
  i6 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i4);
 HEAP32[i1 >> 2] = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL19getContactPointDataERPKvRjS5_RPKfj(i1, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  i4 = HEAP32[i2 + 44 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  i3 = (HEAP16[i2 + 114 >> 1] & 16) == 0 ? 0 : i4 + (i5 + 15 & -16) | 0;
  i11 = HEAP16[i2 + 36 >> 1] | 0;
  i2 = i11 & 65535;
  if (!(i11 << 16 >> 16)) i2 = 0; else if (!i10) {
   HEAP32[i6 >> 2] = i4;
   HEAP32[i7 >> 2] = i5;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i9 >> 2] = i3;
   return (i1 | 0) != 0 | 0;
  } else i2 = 1;
  if (i1 | 0) {
   while (1) {
    if ((i2 | 0) == (i10 | 0)) break;
    i1 = HEAP32[i1 >> 2] | 0;
    if (!i1) break L1; else i2 = i2 + 1 | 0;
   }
   i11 = i1;
   i5 = HEAP16[i11 + 4 >> 1] | 0;
   HEAP32[i6 >> 2] = i11 + 8;
   i6 = i5 & 65535;
   HEAP32[i7 >> 2] = i6 + -8;
   HEAP32[i8 >> 2] = 1;
   HEAP32[i9 >> 2] = i1 + (i6 + 15 & 131056);
   i11 = ((HEAP32[i11 >> 2] | 0) != 0 & 1) + i10 | 0;
   return i11 | 0;
  }
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i10;
 return i11 | 0;
}

function __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_(i14, i9, i10, i11, i12) {
 i14 = i14 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15 + 2 | 0;
 i4 = i15 + 1 | 0;
 i5 = i15;
 HEAP8[i13 >> 0] = 1;
 i6 = i14 + 264 | 0;
 i7 = i14 + 4 | 0;
 i2 = HEAP32[i14 >> 2] | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 while (1) {
  i1 = __ZN5physx11PxMeshQuery22findOverlapHeightFieldERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_PjjjRb(i9, i10, i11, i12, i2, i8, 0, i13) | 0;
  if (!(HEAP8[i13 >> 0] | 0)) {
   i2 = 6;
   break;
  }
  i3 = HEAP32[i6 >> 2] | 0;
  i8 = i3 << 1;
  i2 = HEAP32[i14 >> 2] | 0;
  if ((i2 | 0) != (i7 | 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i3 << 3, gb + 656312 | 0, 78) | 0;
  HEAP32[i14 >> 2] = i2;
  HEAP32[i6 >> 2] = i8;
  if (!(HEAP8[i13 >> 0] | 0)) {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  HEAP32[i14 + 260 >> 2] = i1;
  STACKTOP = i15;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx11NpReadCheckC2EPKNS_7NpSceneEPKc(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 HEAP32[i6 >> 2] = i2;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 if (!i2) {
  STACKTOP = i9;
  return;
 }
 do if (!(__ZNK5physx7NpScene9startReadEv(i2) | 0)) {
  i10 = HEAP32[i6 >> 2] | 0;
  i10 = (HEAP16[((HEAP32[i10 + 3388 >> 2] & 4 | 0) == 0 ? i10 + 1224 | 0 : i10 + 3364 | 0) >> 1] & 4096) == 0;
  i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
  if (i10) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 8, gb + 769897 | 0, 36, gb + 770185 | 0, i8);
   break;
  } else {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i7 + 4 >> 2] = i2;
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 8, gb + 769897 | 0, 29, gb + 769970 | 0, i7);
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 3872 >> 2];
 STACKTOP = i9;
 return;
}

function __ZN5Umbra14TomeCollection4initEPNS_9AllocatorE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = (i7 | 0) == 0 ? 0 : i7 + 3 & -4;
 if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
  i1 = gb + 1451688 | 0;
 } else i1 = gb + 1451688 | 0;
 i5 = i2 + 28 | 0;
 i6 = i2 + 24 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  i2 = i2 + 32 | 0;
  i3 = i5;
 } else {
  i4 = HEAP32[i5 >> 2] | 0;
  i2 = i2 + 32 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i3 = i5; else {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   i3 = i5;
  }
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i6 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i7 >> 2] = gb + 80192 + 8;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = gb + 80216 + 8;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP8[i7 + 20 >> 0] = 0;
 HEAP8[i7 + 24 >> 0] = 0;
 i7 = i7 + 28 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 return;
}

function __ZN16ReflectionProbes24RefreshAllRealtimeProbesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i1 + 12 | 0;
 i5 = i1 + 24 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i4 = HEAP32[i7 >> 2] | 0;
 do {
  i6 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[gb + 1112272 >> 2] | 0;
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = HEAP32[i1 + 24 >> 2] | 0;
  L6 : do if (!i3) i8 = 8; else {
   i3 = i2 + (i3 << 2) | 0;
   while (1) {
    if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break L6;
    i2 = i2 + 4 | 0;
    if ((i2 | 0) == (i3 | 0)) {
     i8 = 8;
     break;
    }
   }
  } while (0);
  if ((i8 | 0) == 8) {
   i8 = 0;
   if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 383656 | 0, 0, gb + 380852 | 0, 370, 512, i1, 0, 0);
   i1 = HEAP32[gb + 1112272 >> 2] | 0;
  }
  HEAP8[i6 + 144 >> 0] = 0;
  HEAP32[i6 + 168 >> 2] = 0;
  HEAP32[i6 + 172 >> 2] = 0;
  HEAP8[i6 + 160 >> 0] = 1;
  __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i1, 3, i6, 63);
  HEAP32[i6 + 152 >> 2] = HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2];
  i4 = i4 + 4 | 0;
 } while (((HEAP32[i7 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0) != (i4 | 0));
 return;
}

function __Z29StdTemplateConversionFunctionIyhEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 & 255;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 & 255;
 HEAP8[i1 >> 0] = i10;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIyaEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  i10 = i10 & 255;
  HEAP8[i1 >> 0] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 i10 = i10 & 255;
 HEAP8[i1 >> 0] = i10;
 STACKTOP = i8;
 return 1;
}

function __Z28Scene_CUSTOM_SetNameInternaliP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i5 = i9 + 32 | 0;
 i6 = i9 + 24 | 0;
 i7 = i9 + 8 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i6, i2);
 i4 = __Z15GetSceneManagerv() | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i2 = i4 + 12 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i1 = HEAP32[i4 + 16 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  __ZNK11ICallStringcv8UnityStrEv(i7, i6);
  __ZN10UnityScene7SetNameERK8UnityStr(i4, i7);
  if ((HEAP8[i7 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i7 >> 2] | 0;
   i7 = HEAP32[i7 + 12 >> 2] | 0;
   HEAP32[i5 >> 2] = 66;
   HEAP32[i5 + 4 >> 2] = i7;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
  }
  STACKTOP = i9;
  return;
 }
 if (i3) {
  i9 = HEAP32[i2 >> 2] | 0;
  HEAP32[i8 >> 2] = i9;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 560884 | 0, i8);
 } else {
  i9 = i2;
  HEAP32[i8 >> 2] = i9;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 560884 | 0, i8);
 }
}

function __Z16b2GetPointStatesP12b2PointStateS0_PK10b2ManifoldS3_(i4, i8, i9, i10) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i11 = HEAP32[i9 + 60 >> 2] | 0;
 i12 = (i11 | 0) > 0;
 i7 = HEAP32[i10 + 60 >> 2] | 0;
 if (i12) {
  i5 = (i7 | 0) > 0;
  i2 = 0;
  do {
   i3 = HEAP32[i9 + (i2 * 20 | 0) + 16 >> 2] | 0;
   i6 = i4 + (i2 << 2) | 0;
   HEAP32[i6 >> 2] = 3;
   L5 : do if (i5) {
    i1 = 0;
    while (1) {
     if ((HEAP32[i10 + (i1 * 20 | 0) + 16 >> 2] | 0) == (i3 | 0)) break;
     i1 = i1 + 1 | 0;
     if ((i1 | 0) >= (i7 | 0)) break L5;
    }
    HEAP32[i6 >> 2] = 2;
   } while (0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i11 | 0));
 }
 if ((i7 | 0) > 0) i1 = 0; else return;
 do {
  i3 = HEAP32[i10 + (i1 * 20 | 0) + 16 >> 2] | 0;
  i4 = i8 + (i1 << 2) | 0;
  HEAP32[i4 >> 2] = 1;
  L16 : do if (i12) {
   i2 = 0;
   while (1) {
    if ((HEAP32[i9 + (i2 * 20 | 0) + 16 >> 2] | 0) == (i3 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i11 | 0)) break L16;
   }
   HEAP32[i4 >> 2] = 2;
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i7 | 0));
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 + 4 >> 2] | 0);
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i3 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i3 + 40 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 6;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i5;
 return;
}

function __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPcEEEET_S4_S4_S4_(i7, i5, i8) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = i2 - i1 | 0;
 i10 = (HEAP32[i8 >> 2] | 0) - i2 | 0;
 if ((i9 | 0) == (i10 | 0)) {
  i4 = i2;
  i3 = i2;
  i2 = i4;
  while (1) {
   if ((i1 | 0) == (i4 | 0)) break;
   i10 = HEAP8[i1 >> 0] | 0;
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP8[i2 >> 0] = i10;
   i10 = i3 + 1 | 0;
   i3 = i10;
   i1 = i1 + 1 | 0;
   i2 = i10;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i2 = i9;
  i3 = i10;
  while (1) {
   i2 = (i2 | 0) % (i3 | 0) | 0;
   if (!i2) break; else {
    i6 = i3;
    i3 = i2;
    i2 = i6;
   }
  }
  i2 = i1 + i3 | 0;
  while (1) {
   if ((i2 | 0) == (i1 | 0)) break;
   i5 = i2 + -1 | 0;
   i2 = i5;
   i6 = HEAP8[i5 >> 0] | 0;
   i3 = i5 + i9 | 0;
   i4 = i2;
   while (1) {
    HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
    i4 = i3;
    i1 = (HEAP32[i8 >> 2] | 0) - i4 | 0;
    i1 = (i9 | 0) < (i1 | 0) ? i3 + i9 | 0 : (HEAP32[i7 >> 2] | 0) + (i9 - i1) | 0;
    if ((i1 | 0) == (i5 | 0)) break; else i3 = i1;
   }
   HEAP8[i3 >> 0] = i6;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i1 = i1 + i10 | 0;
 }
 return i1 | 0;
}

function __ZN5physx13NpRigidStatic7releaseEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i7, HEAP32[i7 + 8 >> 2] | 0, 1);
 i6 = i7 + 48 | 0;
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 if (((i1 >>> 30) + -1 | 0) >>> 0 < 2) i5 = HEAP32[i6 >> 2] | 0; else i5 = 0;
 i3 = (HEAP16[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i6 + 8 >> 1] & 8) != 0;
 i4 = (i5 | 0) != 0;
 if (i4 & i3) {
  i1 = i7 + 20 | 0;
  __ZN5physx14NpShapeManager20clearShapesOnReleaseERNS_3Scb5SceneERNS_12PxRigidActorE(i1, i5, i7);
  i2 = i7;
 } else {
  i1 = i7 + 20 | 0;
  i2 = i7;
 }
 i8 = i7 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i8, i2);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i1, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i7) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i8, i7);
 if (!i4) {
  __ZN5physx3Scb4Base7destroyEv(i6);
  return;
 }
 __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb(i5, i6, 1, i3);
 __ZN5physx7NpScene24removeFromRigidActorListERKj(__ZN5physx3Scb5Scene10getPxSceneEv(i5) | 0, i7 + 36 | 0);
 __ZN5physx3Scb4Base7destroyEv(i6);
 return;
}

function __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i3 = i6 + 80 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i3;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i6 + 88 | 0;
 if ((i3 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i6 + 89 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  return;
 }
}

function __ZN15AnchoredJoint2D17ConfigureDistanceERK6b2Vec2S2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0;
 i11 = __ZNK7Joint2D10FetchBodyAEv(i1) | 0;
 f8 = Math_fround(HEAPF32[i11 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f8 * f7);
 f10 = Math_fround(HEAPF32[i11 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(f10 * f4));
 f5 = Math_fround(Math_fround(HEAPF32[i11 + 12 >> 2]) + f5);
 f4 = Math_fround(Math_fround(f7 * f10) + Math_fround(f8 * f4));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i11 + 16 >> 2]));
 i2 = __ZNK7Joint2D10FetchBodyBEv(i1) | 0;
 f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(f8 * f10);
 f9 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f9 * f6));
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f7);
 f6 = Math_fround(Math_fround(f10 * f9) + Math_fround(f8 * f6));
 f5 = Math_fround(f7 - f5);
 f4 = Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i2 + 16 >> 2])) - f4);
 return Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4))));
}

function __ZN14SafeBinaryRead8TransferIN7mecanim9animation17BlendTreeConstantEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 903598 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5 + 4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 903616 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN13RuntimeStaticI12EventManagerE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i2 = i7;
 i3 = i1 + 16 | 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i5 = __ZnwjRK10MemLabelIdiPKci(52, i4, i5, gb + 1041912 | 0, 65) | 0;
  i8 = gb + 63696 | 0;
  i3 = HEAP32[i8 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i5, 0, gb + 369596 | 0, 16, 4096, i6, 16);
  HEAP32[i1 >> 2] = i5;
  STACKTOP = i7;
  return;
 } else {
  i8 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, i4, i5, i3, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = gb + 63696 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i8, 0, gb + 369596 | 0, 16, 4096, i6, 16);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i8;
  STACKTOP = i7;
  return;
 }
}

function __ZN11dtNodeQueue11trickleDownEiP6dtNode(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i2 = i1 << 1 | 1;
 i5 = HEAP32[i7 + 8 >> 2] | 0;
 if ((i2 | 0) < (i5 | 0)) {
  i4 = i1;
  while (1) {
   i1 = i2 + 1 | 0;
   i3 = HEAP32[i7 >> 2] | 0;
   if ((i1 | 0) < (i5 | 0)) {
    f6 = Math_fround(HEAPF32[(HEAP32[i3 + (i2 << 2) >> 2] | 0) + 16 >> 2]);
    if (!(f6 > Math_fround(HEAPF32[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 16 >> 2]))) i1 = i2;
   } else i1 = i2;
   HEAP32[i3 + (i4 << 2) >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
   i2 = i1 << 1 | 1;
   if ((i2 | 0) >= (i5 | 0)) break; else i4 = i1;
  }
 }
 if ((i1 | 0) <= 0) {
  i5 = i1;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 + (i5 << 2) | 0;
  HEAP32[i7 >> 2] = i8;
  return;
 }
 f6 = Math_fround(HEAPF32[i8 + 16 >> 2]);
 i3 = i1;
 while (1) {
  i2 = i3 + -1 | 0;
  i1 = (i2 | 0) / 2 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i5 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  if (!(Math_fround(HEAPF32[i5 + 16 >> 2]) > f6)) {
   i1 = i3;
   i2 = 10;
   break;
  }
  HEAP32[i4 + (i3 << 2) >> 2] = i5;
  if ((i2 | 0) > 1) i3 = i1; else {
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) {
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 + (i1 << 2) | 0;
  HEAP32[i7 >> 2] = i8;
  return;
 }
}

function __ZN5RandN7SetSeedERKi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i3 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i6 = i1 + 16 | 0;
 i4 = i1 + 32 | 0;
 i2 = i1 + 48 | 0;
 i5 = (Math_imul(i3, 1812433253) | 0) + 1 | 0;
 i7 = (Math_imul(i5, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i7;
 i7 = i8 + 367 | 0;
 i5 = (Math_imul(i7, 1812433253) | 0) + 1 | 0;
 i3 = (Math_imul(i5, 1812433253) | 0) + 1 | 0;
 i9 = (Math_imul(i3, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i9;
 i9 = i8 + 734 | 0;
 i3 = (Math_imul(i9, 1812433253) | 0) + 1 | 0;
 i5 = (Math_imul(i3, 1812433253) | 0) + 1 | 0;
 i7 = (Math_imul(i5, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 8 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i4 + 8 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i7;
 i8 = i8 + 1101 | 0;
 i7 = (Math_imul(i8, 1812433253) | 0) + 1 | 0;
 i5 = (Math_imul(i7, 1812433253) | 0) + 1 | 0;
 i3 = (Math_imul(i5, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 12 >> 2] = i8;
 HEAP32[i6 + 12 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i5;
 HEAP32[i2 + 12 >> 2] = i3;
 return;
}

function __ZN13WheelCollider6CreateEPK9Rigidbody(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if ((HEAP32[i3 + 148 >> 2] | 0) != -1) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 152 >> 2] | 0, i3 | 0);
 i2 = i3 + 28 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 67048 | 0) | 0;
 L4 : do if ((i1 | 0) == 0 | (i1 | 0) == (i4 | 0)) {
  i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  if (!i1) i2 = 11; else while (1) {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   if (i2 | 0) {
    i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
    if (!((i2 | 0) == 0 | (i2 | 0) == (i4 | 0))) {
     i1 = i2;
     i2 = 8;
     break L4;
    }
   }
   i1 = HEAP32[i1 + 100 >> 2] | 0;
   if (!i1) {
    i2 = 10;
    break;
   }
  }
 } else i2 = 8; while (0);
 if ((i2 | 0) == 8) if (!i1) i2 = 10; else {
  __ZN13WheelCollider14FinalizeCreateEPK9Rigidbody(i3, i4);
  return;
 }
 if ((i2 | 0) == 10) if (!i3) i1 = 0; else i2 = 11;
 if ((i2 | 0) == 11) i1 = HEAP32[i3 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 826781 | 0, 0, gb + 826839 | 0, 242, 512, i1, 0, 0);
 return;
}

function __ZN12AudioManager16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0;
 i2 = i1 + 28 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(1.0);
 f4 = i5 ? Math_fround(1.0) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 36 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(10.0);
 f4 = i5 ? Math_fround(10.0) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 76 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(10.0);
 f4 = i5 ? Math_fround(10.0) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i2 = i1 + 120 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i3 | 0) < 1 ? 1 : (i3 | 0) > 7 ? 7 : i3;
 i2 = i1 + 124 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i3 | 0) < 0 ? 0 : (i3 | 0) > 96e3 ? 96e3 : i3;
 i2 = i1 + 128 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i3 | 0) < 0 ? 0 : (i3 | 0) > 8192 ? 8192 : i3;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i3 | 0) < 1 ? 1 : (i3 | 0) > 4095 ? 4095 : i3;
 i1 = i1 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2;
 return;
}

function __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 20 | 0;
 i6 = i5;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 i9 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i2 = i8 + (i7 << 6) | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 8 >> 2] = i2;
 i2 = i7 << 6 >> 6;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i6;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i1) {
  __ZN17RemapPPtrTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i4, i3, 0);
  STACKTOP = i5;
  return;
 } else {
  __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i4, i1);
  __ZN17RemapPPtrTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i4, i3, 0);
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZNK14SplatMaterials12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i4 + 12 | 0;
 i8 = i4 + 16 | 0;
 i9 = i4 + 4 | 0;
 i1 = 0;
 while (1) {
  i10 = i3 + 40 + (i1 << 2) | 0;
  if (!(HEAP32[i10 >> 2] | 0)) {
   i1 = 9;
   break;
  }
  i11 = HEAP32[i7 >> 2] | 0;
  i12 = i11 + 1 | 0;
  i5 = HEAP32[i8 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i12 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i4 >> 2] | 0, i2 << 2, 4, i9, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
    HEAP32[i8 >> 2] = i2;
    HEAP32[i4 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i7 >> 2] = i12;
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i11 << 2) >> 2] = HEAP32[i10 >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 8) {
   i1 = 9;
   break;
  }
 }
 if ((i1 | 0) == 9) return;
}

function __ZN5physx9PxTaskMgr12getNamedTaskEPKc(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i7 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i4 = HEAP32[i7 + 36 >> 2] | 0;
 L1 : do if (!i4) i8 = 8; else {
  i1 = HEAP8[i6 >> 0] | 0;
  if (!(i1 << 24 >> 24)) i1 = 5381; else {
   i2 = 5381;
   i3 = i6;
   do {
    i2 = i2 * 33 ^ i1 << 24 >> 24;
    i3 = i3 + 1 | 0;
    i1 = HEAP8[i3 >> 0] | 0;
   } while (i1 << 24 >> 24 != 0);
   i1 = i2;
  }
  i1 = HEAP32[(HEAP32[i7 + 28 >> 2] | 0) + ((i1 & i4 + -1) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i8 = 8; else {
   i4 = HEAP32[i7 + 20 >> 2] | 0;
   i3 = i7 + 24 | 0;
   while (1) {
    i2 = i4 + (i1 << 3) | 0;
    if (!(_strcmp(HEAP32[i2 >> 2] | 0, i6) | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i8 = 8;
     break L1;
    }
   }
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
   if (i2 | 0) {
    i8 = HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0;
    return i8 | 0;
   }
  }
 } while (0);
 if ((i8 | 0) == 8) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 i8 = mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 48 >> 2] | 0, i7 | 0, 0, i6 | 0, 2) | 0;
 return i8 | 0;
}

function __ZN2UI13RectTransform7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(180, i1, 16, gb + 1048932 | 0, 0, gb + 407335 | 0, 42) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TransformC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 44168 + 8;
 HEAP32[i4 + 136 >> 2] = 1056964608;
 HEAP32[i4 + 140 >> 2] = 1056964608;
 HEAP32[i4 + 144 >> 2] = 1056964608;
 HEAP32[i4 + 148 >> 2] = 1056964608;
 HEAP32[i4 + 152 >> 2] = 0;
 HEAP32[i4 + 156 >> 2] = 0;
 HEAP32[i4 + 160 >> 2] = 1120403456;
 HEAP32[i4 + 164 >> 2] = 1120403456;
 HEAP32[i4 + 168 >> 2] = 1056964608;
 HEAP32[i4 + 172 >> 2] = 1056964608;
 i2 = i4 + 120 | 0;
 HEAP8[i4 + 176 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i4 + 177 >> 0] = 1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13TryDeallocateEPv(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i2 = i3 + 36 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv(i1, i6) | 0) {
  i6 = 1;
  return i6 | 0;
 }
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  i6 = __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv(HEAP32[i3 + 40 >> 2] | 0, i6) | 0;
  return i6 | 0;
 }
 i2 = i3 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE28CreateDelayedDeletionManagerEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i3 = i1 + 4 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i5 >>> 0) {
  i5 = i5 << 1;
  i5 = i5 >>> 0 < 128 ? 128 : i5;
  HEAP32[i4 >> 2] = i5;
  i2 = HEAP32[i1 + 20 >> 2] | 0;
  i5 = mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, i5 << 2 | 0, 16) | 0;
  HEAP32[i1 >> 2] = i5;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = i5;
 } else i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + (i2 + -1 << 2) >> 2] = i6;
 HEAP32[i1 + 12 >> 2] = 1;
 i6 = 1;
 return i6 | 0;
}

function __ZN18CrashReportManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 12 | 0;
 i6 = i5;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i4, i3);
 HEAP32[i1 >> 2] = gb + 188668 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 18524 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i4, gb + 1048800 | 0, i5 + 8 | 0);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[i2 + 17756 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i2 + 17756 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i2 + 17756 + (i1 * 12 | 0) >> 2] = fb + 167;
 STACKTOP = i5;
 return;
}

function __ZN16ScriptingManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 66624 + 8;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 188 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = i1 + 184;
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 __Z22SetManagerPtrInContextiP6Object(5, i1);
 STACKTOP = i4;
 return;
}

function __ZN10Matrix3x3f5ScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 8 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 i4 = i2 + 4 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 12 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 16 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i4 = i1 + 20 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 i2 = i2 + 8 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 24 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 28 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i2 = i1 + 32 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2]));
 return i1 | 0;
}

function __ZN10AudioMixer10ClearFloatEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!(__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 294, 1, 0, 0, 0);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc(HEAP32[i1 + 72 >> 2] | 0, i2) | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i5 >> 2] = i2;
  __Z6FormatPKcz(i4, gb + 862953 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 861578 | 0, 299, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  __ZN5audio5mixer20ClearExposedPropertyERKNS0_16AudioMixerMemoryEi(HEAP32[i1 + 76 >> 2] | 0, i3);
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, HEAP32[i6 + 20 >> 2] | 0);
 i4 = i1 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 4 | 0;
 i2 = i6 + 12 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i3 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = HEAP32[i4 >> 2] | 0;
 HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i2 >> 2] | 0) | 0 : i7) >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, HEAP32[i6 + 20 >> 2] | 0);
 i4 = i1 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 4 | 0;
 i2 = i6 + 12 | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i3 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i7 = HEAP32[i4 >> 2] | 0;
 HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP8[i6 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i2 >> 2] | 0) | 0 : i7) >> 2] = i1;
 STACKTOP = i8;
 return;
}

function __Z51Graphics_CUSTOM_Internal_SetRandomWriteTargetBufferiP12Il2CppObjecth(i6, i4, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 24 | 0;
 i8 = i9 + 16 | 0;
 i2 = i9 + 8 | 0;
 i7 = i9 + 20 | 0;
 if ((i6 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 517946 | 0, i9);
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 148 >> 2] | 0) <= (i6 | 0)) {
  i3 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 148 >> 2] | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 4 >> 2] = i3;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 517969 | 0, i2);
 }
 if (!(i1 << 24 >> 24)) {
  if (!i4) i1 = 0; else i1 = HEAP32[i4 + 8 >> 2] | 0;
  __ZN13ComputeBuffer15SetCounterValueEj(i1, 0);
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 772 >> 2] | 0;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8);
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8); else {
  HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  mftCall_viii(i3 | 0, i2 | 0, i6 | 0, i5 | 0);
  STACKTOP = i9;
  return;
 }
}

function __Z29AddIntegerCurveToStreamedClipP19StreamedClipBuilderiPfPii(i2, i3, i8, i9, i10) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i15;
 if ((i10 | 0) <= 0) {
  STACKTOP = i15;
  return;
 }
 i12 = i11 + 4 | 0;
 i13 = i11 + 8 | 0;
 i14 = i11 + 20 | 0;
 i4 = i11 + 16 | 0;
 i5 = i11 + 12 | 0;
 i6 = i11 + 24 | 0;
 i1 = 0;
 do {
  HEAPF32[i12 >> 2] = Math_fround(inf);
  HEAP32[i11 >> 2] = 0;
  HEAP32[i13 >> 2] = 0;
  HEAP32[i13 + 4 >> 2] = 0;
  HEAP32[i13 + 8 >> 2] = 0;
  HEAP32[i13 + 12 >> 2] = 0;
  HEAP32[i13 + 16 >> 2] = 0;
  if (!i1) f7 = Math_fround(-3402823469999999843913219.0e14); else f7 = Math_fround(HEAPF32[i8 + (i1 << 2) >> 2]);
  HEAPF32[i12 >> 2] = f7;
  HEAPF32[i14 >> 2] = Math_fround(0.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(HEAP32[i9 + (i1 << 2) >> 2] | 0);
  __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder(i11, i3, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 STACKTOP = i15;
 return;
}

function __Z13PlayerCleanupb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __Z20SetPlayerPauseDirect11PlayerPause(2);
 if (!(__Z16NotifyPlayerQuitb(i1) | 0)) {
  __Z20SetPlayerPauseDirect11PlayerPause(0);
  i4 = 0;
  return i4 | 0;
 }
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 20840 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 20072 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 20072 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 20072 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __Z21ReleasePreloadManagerv();
 __ZN11PlayerPrefs4SyncEv();
 __ZN13UnityProfiler10CleanupGfxEv();
 __Z13CleanupEnginev();
 __Z13CleanupIl2Cppv();
 __Z16DestroyJobSystemv();
 __Z13InputShutdownv();
 __Z24CleanupPersistentManagerv();
 __ZN18ProfilerConnection7CleanupEv();
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(__ZN16PlayerConnection3GetEv() | 0, 0, 301, 0, 0);
 i4 = __ZN16PlayerConnection3GetEv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
 __ZN17GeneralConnection13DisconnectAllEv(__ZN16PlayerConnection3GetEv() | 0);
 __ZN16PlayerConnection7CleanupEv();
 i4 = 1;
 return i4 | 0;
}

function _modf(d1, i4) {
 d1 = +d1;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i5 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i5 | 0, i6 | 0, 52) | 0;
 getTempRet0() | 0;
 i2 = i2 & 2047;
 i3 = i2 + -1023 | 0;
 do if ((i3 | 0) > 51) {
  HEAPF64[i4 >> 3] = d1;
  if ((i5 | 0) == 0 & (i6 & 1048575 | 0) == 0 | (i3 | 0) != 1024) {
   HEAP32[tempDoublePtr >> 2] = 0;
   HEAP32[tempDoublePtr + 4 >> 2] = i6 & -2147483648;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 } else {
  if (i2 >>> 0 < 1023) {
   i5 = i4;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = i6 & -2147483648;
   break;
  }
  i2 = _bitshift64Lshr(-1, 1048575, i3 | 0) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 & i5 | 0) == 0 & (i3 & i6 | 0) == 0) {
   HEAPF64[i4 >> 3] = d1;
   HEAP32[tempDoublePtr >> 2] = 0;
   HEAP32[tempDoublePtr + 4 >> 2] = i6 & -2147483648;
   d1 = +HEAPF64[tempDoublePtr >> 3];
   break;
  } else {
   i2 = i5 & ~i2;
   i5 = i6 & ~i3;
   HEAP32[tempDoublePtr >> 2] = i2;
   HEAP32[tempDoublePtr + 4 >> 2] = i5;
   d7 = +HEAPF64[tempDoublePtr >> 3];
   i6 = i4;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i6 + 4 >> 2] = i5;
   d1 = d1 - d7;
   break;
  }
 } while (0);
 return +d1;
}

function __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i2 = i8;
 i3 = i1 + 2620 | 0;
 HEAP32[i7 >> 2] = i1;
 i4 = i7 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!(HEAP8[i1 + 2433 >> 0] | 0)) {
  HEAP32[i4 >> 2] = i5 & 268435455 | -2147483648;
  __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE(i1 + 16 | 0, i7 + 12 | 0);
  STACKTOP = i8;
  return;
 }
 i1 = i5 & 1073741823;
 if (i5 >>> 0 > 3221225471) {
  HEAP32[i4 >> 2] = i1 | -2147483648;
  if (i5 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i3, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i4 >> 2] = i1 | 1073741824;
  HEAP32[i2 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i3, i2, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 32 | 0;
 i6 = i8;
 i7 = i2 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 16 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + (i9 << 2) | 0;
 __ZN16CompareSceneNameC2ERK8UnityStr(i6, i3);
 L1 : do if (i9) while (1) {
  if (__ZNK16CompareSceneNameclEPK10UnityScene(i6, HEAP32[i1 >> 2] | 0) | 0) break L1;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = i2;
   break;
  }
 } while (0);
 i2 = i6 + 16 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i6 + 28 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) {
  i9 = HEAP32[i6 >> 2] | 0;
  i6 = HEAP32[i6 + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i9, i5);
 }
 if ((i1 | 0) == ((HEAP32[i7 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0)) {
  i9 = 0;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN18ProfilerConnection21SendFrameDataToEditorER17ProfilerFrameData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i6 = i7;
 i5 = i7 + 16 | 0;
 if (!(HEAP32[(__ZN16PlayerConnection3GetEv() | 0) + 96 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = gb + 64016 | 0;
 i8 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = 0;
 i9 = i5 + 12 | 0;
 HEAP32[i9 >> 2] = 0;
 i8 = i5 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i4 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, i6);
 i10 = i3;
 i3 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 __ZN13UnityProfiler18SerializeFrameDataER17ProfilerFrameDataR13dynamic_arrayIiLj4EE(i2, i5);
 i6 = __ZN16PlayerConnection3GetEv() | 0;
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i6, HEAP32[i1 >> 2] | 0, 32, HEAP32[i5 >> 2] | 0, HEAP32[i9 >> 2] << 2);
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4);
  HEAP32[i5 >> 2] = 0;
 }
 STACKTOP = i7;
 return;
}

function __ZN10CastFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE(i6, i3, i4, i2, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if ((i2 | 0) == (HEAP32[i6 + 8 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0) & 4) if (!(HEAP8[i6 + 16 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) if (!(HEAP8[i1 + 100 >> 0] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i5 | 0, i4 | 0);
 i1 = __ZN8Collider14WordsToPointerEjj(HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0) | 0;
 i2 = __ZN8Collider14WordsToPointerEjj(HEAP32[i5 + 4 >> 2] | 0, HEAP32[i5 + 12 >> 2] | 0) | 0;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) i1 = __ZNK8Collider21ShouldIgnoreCollisionEPS_(i1, i2) | 0; else i1 = 0;
 if (i1 | (1 << (HEAP32[i5 >> 2] & 255) & HEAP32[i6 + 12 >> 2] | 0) == 0) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z17UTF8ToUTF16StringPKcR11UTF16String(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 8 | 0;
 i4 = gb + 63672 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = _strlen(i1) | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  i1 = 0;
  i2 = 0;
  i3 = 0;
 } else {
  i9 = i5;
  HEAP32[i9 >> 2] = i3;
  HEAP32[i9 + 4 >> 2] = i4;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 16, i5, 0, gb + 489101 | 0, 14) | 0;
  HEAP32[i6 >> 2] = i5;
  i3 = i6 + 4 | 0;
  __Z18ConvertUTF8toUTF16PKhiPtRi(i1, i2, i5, i3) | 0;
  i1 = 1;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 HEAP8[i6 + 8 >> 0] = i1;
 i1 = i7 + 8 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP32[i7 >> 2] = i2;
  i9 = i7 + 4 | 0;
  HEAP32[i9 >> 2] = i3;
  HEAP8[i1 >> 0] = 1;
  STACKTOP = i8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i7 + 12 | 0);
 HEAP32[i7 >> 2] = i2;
 i9 = i7 + 4 | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP8[i1 >> 0] = 1;
 STACKTOP = i8;
 return;
}

function __Z10CreateFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEii(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 24 | 0;
 i5 = i3 + 12 | 0;
 i2 = i3;
 HEAP16[i1 >> 1] = 47;
 __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i2, i4, i1);
 i6 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i5, i6, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZN15FileSystemEntryC2EPKc(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = __ZNK15FileSystemEntry12FolderExistsEv(i1) | 0;
 __ZN13FileEntryDataD2Ev(i1);
 if (!i5) {
  i6 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i3;
  return i6 | 0;
 }
 __ZN15FileSystemEntryC2EPKc(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 i6 = __ZN15FileSystemEntry12CreateAsFileEv(i1) | 0;
 __ZN13FileEntryDataD2Ev(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i3;
 return i6 | 0;
}

function __ZN5physx9NpFactory13createNpClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i9, i7, i5, i8, i6) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 i3 = i9 + 4252 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i9 + 4248 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i9 + 3956 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i4 = i9 + 4236 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i9 = i9 + 4240 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (!i1) {
  i9 = 0;
  i8 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP16[i2 >> 1] = HEAP16[i6 >> 1] | 0;
 __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i1, i7, i5, i8, i2);
 i9 = i1;
 i8 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i14, i13) {
 i1 = i1 | 0;
 i14 = i14 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i14 >>> 0) __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i14);
 i10 = HEAP32[i1 >> 2] | 0;
 i11 = i1 + 4 | 0;
 i1 = HEAP32[i11 >> 2] | 0;
 i12 = i10 + (i14 * 36 | 0) | 0;
 if ((i1 | 0) >= (i14 | 0)) {
  HEAP32[i11 >> 2] = i14;
  return;
 }
 i2 = i13 + 4 | 0;
 i3 = i13 + 8 | 0;
 i4 = i13 + 12 | 0;
 i5 = i13 + 16 | 0;
 i6 = i13 + 20 | 0;
 i7 = i13 + 24 | 0;
 i8 = i13 + 28 | 0;
 i9 = i13 + 32 | 0;
 i1 = i10 + (i1 * 36 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i13 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 36 | 0;
 } while (i1 >>> 0 < i12 >>> 0);
 HEAP32[i11 >> 2] = i14;
 return;
}

function __ZN5physx2Gu21computeMTD_ConvexMeshERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES9_(i7, i5, i1, i4, i2, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 4240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i8 + 4176 | 0;
 i11 = i8 + 4120 | 0;
 i9 = i8 + 4116 | 0;
 i3 = i8;
 i10 = i8 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i1);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i9 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i4, i6, i10, i9, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i7, i5, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 i12 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i8;
 return i12 | 0;
}

function __ZN21UnityAnalyticsManager25UnregisterGlobalCallbacksEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i6 + 32 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 18524 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i4 = i7 + 17756 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i4 >> 2] | 0) == (fb + 199 | 0)) {
   i3 = i7 + 17756 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + 17756 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) break;
   if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i9 = 9;
   break;
  }
 }
 if ((i9 | 0) == 9) return;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i3 >> 0] = 0;
 i9 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i9;
 if (i9 >>> 0 <= i1 >>> 0) return;
 do {
  i9 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + 17756 + (i9 * 12 | 0) >> 2] = HEAP32[i7 + 17756 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + 17756 + (i9 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 17756 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + 17756 + (i9 * 12 | 0) + 8 >> 0] = HEAP8[i7 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z38Material_Set_Custom_PropShaderKeywordsP12Il2CppObjectP11Il2CppArray(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __Z23StringScriptingToVectorINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEEEvP11Il2CppArrayRT_(i1, i3);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN8Material21SetShaderKeywordNamesERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i3);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i6 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i6;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i5;
 return;
}

function __Z22ConvertAddressToStringP8sockaddrj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = i8 + 40 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8 + 4 | 0;
 i1 = _getnameinfo(i1 | 0, i2 | 0, i4 | 0, 1024, i5 | 0, 20, 3) | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, _strlen(i4) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, gb + 459166 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i6, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i6);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i7 >> 2] = _gai_strerror(i1 | 0) | 0;
  _printf_console(gb + 459141 | 0, i7);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 459158 | 0, 7);
  STACKTOP = i8;
  return;
 }
}

function __Z20ConvertAlphaKeyArrayP11Il2CppArrayPN8Gradient8AlphaKeyE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = i6 + 8 | 0;
 if (!i4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 516939 | 0, 0, gb + 516798 | 0, 94, 1, 0, 0, 0);
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if ((i1 | 0) > 8) {
  HEAP32[i3 >> 2] = 8;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 516977 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 516798 | 0, 101, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 | 0) > 0) i2 = 0; else {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 do {
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i2, 8) | 0;
  HEAP32[i5 + (i2 << 3) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + (i2 << 3) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZThn8_NK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, d4 = 0.0, i5 = 0, f6 = f0, f7 = f0;
 i2 = i2 + -8 | 0;
 i5 = i2 + 416 | 0;
 f7 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f6 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i2 + 500 >> 2]) * Math_fround(.5)));
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 d3 = +f7;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d3;
 d4 = +f6;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d4;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d3;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 i2 = i1 + 32 | 0;
 HEAPF64[i2 >> 3] = d4 + +HEAPF64[i2 >> 3];
 i2 = i1 + 40 | 0;
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 return 1;
}

function __ZN8GUIStateC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 1065353216;
 HEAP32[i1 + 48 >> 2] = 1065353216;
 HEAP32[i1 + 52 >> 2] = 1065353216;
 HEAP32[i1 + 56 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = 1065353216;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 60 >> 2] = 1;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 i3 = i1 + 252 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i1 + 328 >> 2] = i2;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 348 >> 2] = i2;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERt(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i5 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i1;
 i9 = i2 - i3 | 0;
 i4 = i9 + 2 | 0;
 if (i4) {
  i6 = i5 + 20 | 0;
  if (((HEAP32[i6 >> 2] | 0) - i3 | 0) >>> 0 <= i4 >>> 0) {
   i1 = i4 << 1;
   if (i1 >>> 0 > 8192) i4 = ~~Math_fround(Math_fround(i4 >>> 0) * Math_fround(1.20000005)) >>> 0; else i4 = i1;
   i3 = i5 + 4 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i5 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i2 | 0) {
    _memcpy(i1 | 0, i2 | 0, i9 | 0) | 0;
    i5 = HEAP32[i3 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i7 >> 2] | 0);
   }
   HEAP32[i7 >> 2] = i1;
   i2 = i1 + i9 | 0;
   HEAP32[i8 >> 2] = i2;
   HEAP32[i6 >> 2] = i1 + i4;
  }
 }
 HEAP32[i8 >> 2] = i2 + 2;
 i9 = i1 + i9 | 0;
 i10 = HEAPU8[i10 >> 0] | HEAPU8[i10 + 1 >> 0] << 8;
 HEAP8[i9 >> 0] = i10;
 HEAP8[i9 + 1 >> 0] = i10 >> 8;
 return;
}

function __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 HEAP32[i1 + 68 >> 2] = gb + 832017;
 HEAP32[i1 + 72 >> 2] = 693;
 HEAP32[i1 + 76 >> 2] = fb + 57;
 HEAP32[i1 + 80 >> 2] = fb + 23;
 HEAP32[i1 + 88 >> 2] = fb + 2401;
 HEAP32[i1 + 92 >> 2] = gb + 832029;
 HEAP32[i1 + 96 >> 2] = 694;
 HEAP32[i1 + 100 >> 2] = fb + 58;
 HEAP32[i1 + 104 >> 2] = fb + 24;
 HEAP32[i1 + 112 >> 2] = fb + 2402;
 HEAP32[i1 + 116 >> 2] = gb + 832041;
 HEAP32[i1 + 120 >> 2] = 695;
 HEAP32[i1 + 124 >> 2] = fb + 59;
 HEAP32[i1 + 128 >> 2] = fb + 25;
 HEAP32[i1 + 136 >> 2] = fb + 2403;
 HEAP32[i1 + 140 >> 2] = gb + 831985;
 HEAP32[i1 + 144 >> 2] = 696;
 HEAP32[i1 + 148 >> 2] = fb + 2404;
 return;
}

function __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i7, i5, i6, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0;
 i2 = i7 + 420 | 0;
 i3 = i7 + 436 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  i1 = HEAP32[i7 + 432 >> 2] | 0;
  if (!i1) {
   i1 = -1;
   i2 = HEAP32[i7 + 424 >> 2] | 0;
   break;
  } else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 << 1 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   i8 = 5;
   break;
  }
 } else i8 = 5; while (0);
 if ((i8 | 0) == 5) {
  i2 = (HEAP32[i7 + 428 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = -1;
  i2 = HEAP32[i7 + 424 >> 2] | 0;
  HEAP32[i2 + (i1 << 3) >> 2] = -1;
  HEAP32[i2 + (i1 << 3) + 4 >> 2] = 0;
  i8 = i7 + 440 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i2 + (i1 << 3) >> 2] = i5;
 HEAP32[i2 + (i1 << 3) + 4 >> 2] = i6;
 i8 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i7 + 16 >> 2] | 0;
 i5 = i6 + (i8 * 12 | 0) + 8 | 0;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 0 | 4;
 HEAP32[i6 + (i8 * 12 | 0) >> 2] = i1;
 i8 = i7 + 448 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP8[i7 + 477 >> 0] = 1;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl12LoadAllFontsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 8 | 0;
 i7 = i6;
 i2 = i6 + 16 | 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 64868 | 0, i2, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 if (i5 | 0) {
  i1 = 0;
  do {
   __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 48 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 __ZN20TextRenderingPrivate13ApplyToMeshesEv();
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN15CapsuleCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, i5, i1 + 60 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932223 | 0, i5, i1 + 64 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801063 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 68 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 1034411 | 0, 0);
 return;
}

function __ZN9JSONWrite12EndMetaGroupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i3 + 28 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = i2 + -1 | 0;
 i7 = i3 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i2 = i2 >>> 0 > 1 ? i5 + ((i2 + -2 | 0) * 40 | 0) | 0 : i3 + 80 | 0;
 i1 = i5 + (i4 * 40 | 0) + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i3, i2, i1, i5 + (i4 * 40 | 0) | 0);
 HEAP32[i3 + 56 >> 2] = i2;
 i3 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i3;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i3 * 40 | 0) + 24 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  i8 = i1 + (i3 * 40 | 0) | 0;
  __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i8);
  STACKTOP = i9;
  return;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i1 + (i3 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i8 >> 2] = 66;
 HEAP32[i8 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i8);
 i8 = i1 + (i3 * 40 | 0) | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 120 >> 2] | 0, i6 | 0) | 0) __ZN4PPtrI14PhysicMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 32 | 0, i7);
 do if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0, i6 | 0) | 0) {
  i1 = i6 + 40 | 0;
  i4 = i7 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = i7 + 24 | 0;
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i5 = i4;
   break;
  } else {
   __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i1, 1);
   i5 = i4;
   break;
  }
 } else {
  i4 = i7 + 16 | 0;
  i3 = i7 + 24 | 0;
  i5 = i4;
 } while (0);
 i1 = i6 + 41 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN5physx7NpShape18checkMaterialSetupERKNS_10PxGeometryEPKcPKPNS_10PxMaterialEt(i4, i3, i6, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i2 = i5 & 65535;
 if (!(i5 << 16 >> 16)) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 } else i1 = 0;
 do {
  if (!(HEAP32[i6 + (i1 << 2) >> 2] | 0)) {
   i9 = 3;
   break;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 if ((i9 | 0) == 3) {
  i9 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i8 >> 2] = i1;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i9, 2, gb + 689543 | 0, 836, gb + 770507 | 0, i8);
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 if ((i5 & 65535) <= 1) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 if (((HEAP32[i4 >> 2] | 0) + -5 | 0) >>> 0 < 2) {
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 }
 i9 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i7 >> 2] = i3;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i9, 4, gb + 689543 | 0, 845, gb + 770536 | 0, i7);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 4 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = 0;
  do {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0);
   HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] = 0;
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i4 + 28 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 32 | 0, i1);
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 + 12 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5Unity5Cloth8TransferI17RemapPPtrTransferEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i7, i8);
 i1 = HEAP32[i7 + 148 >> 2] | 0;
 i6 = HEAP32[i7 + 160 >> 2] | 0;
 i4 = i1 + (i6 << 2) | 0;
 if (i6 | 0) {
  i5 = i8 + 16 | 0;
  i6 = i8 + 36 | 0;
  i3 = i8 + 40 | 0;
  do {
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 i1 = HEAP32[i7 + 168 >> 2] | 0;
 i7 = HEAP32[i7 + 180 >> 2] | 0;
 i5 = i1 + (i7 << 3) | 0;
 if (!i7) return;
 i6 = i8 + 16 | 0;
 i7 = i8 + 36 | 0;
 i4 = i8 + 40 | 0;
 i3 = i1;
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i3 >> 2] = i1;
  i1 = i3 + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i3 = i3 + 8 | 0;
 } while ((i3 | 0) != (i5 | 0));
 return;
}

function __ZN22BuiltinResourceManager16RegisterResourceExPKcPKN5Unity4TypeEb(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i4;
 i4 = i7 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i7 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i6 + 12 | 0, i1, i2) | 0;
 HEAP8[i7 + 20 >> 0] = i5 & 1;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i6 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i6, i7);
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
  STACKTOP = i8;
  return;
 }
}

function __ZN19SkinnedMeshRenderer30GetActualRootBoneFromAnyThreadEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 + 380 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __ZN8Renderer12GetTransformEv(i4) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags(i1, i7 + 120 | 0, 0);
 i2 = i7 + 140 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i6 = i1 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i7 + 144 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  i4 = i2;
 }
 i1 = i7 + 148 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i7);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
  __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i7);
  return;
 }
}

function __ZN12MeshCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i5);
 i1 = i4 + 60 | 0;
 i6 = i5 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i2 = HEAP32[i6 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
  HEAP32[i6 >> 2] = i2;
 }
 i1 = i4 + 121 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
 i1 = i4 + 124 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i7 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
  i7 = i4 + 64 | 0;
  __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i5);
  return;
 }
}

function __Z24Animation_CUSTOM_AddClipP12Il2CppObjectS0_P12Il2CppStringiih(i2, i4, i1, i5, i6, i7) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 12 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i8, i1);
 if (!i2) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i10 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i9, i8);
  __ZN9Animation7AddClipER13AnimationClipRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEiib(i3, i1, i9, i5, i6, i7 << 24 >> 24 != 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i9);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 51;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN7dtCrowd17requestMoveTargetERK13dtCrowdHandlePKf(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i6 = i7 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 HEAP32[i4 + (i3 * 608 | 0) + 564 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + (i3 * 608 | 0) + 568 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + (i3 * 608 | 0) + 572 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = i4 + (i3 * 608 | 0) + 602 | 0;
 HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 16;
 __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i5 + 464 >> 2] | 0, i2, i5 + 432 | 0, (HEAP32[i5 + 24 >> 2] | 0) + (i3 * 132 | 0) | 0, i8, i6) | 0;
 i2 = i8;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i8 = i4 + (i3 * 608 | 0) + 592 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 __ZN7dtCrowd17requestMoveTargetEiyPKf(i5, i3, i1, i2, i6);
 i1 = i4 + (i3 * 608 | 0) + 601 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 2) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN13RenderManager16GetCurrentCameraEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z17IsStringValidUTF8PKhj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + i2 | 0;
 if ((i2 | 0) <= 0) {
  i7 = 1;
  return i7 | 0;
 }
 L3 : while (1) {
  i3 = HEAPU8[i1 >> 0] | 0;
  do if (!(i3 & 128)) {
   i2 = 1;
   i3 = i3 & 127;
  } else {
   if ((i3 & 224 | 0) == 192) {
    i2 = 2;
    i3 = i3 & 31;
    break;
   }
   if ((i3 & 240 | 0) == 224) i2 = 3; else i2 = (i3 & 248 | 0) == 240 ? 4 : 0;
   if ((i3 & 240 | 0) == 224) i3 = i3 & 15; else i3 = (i3 & 248 | 0) == 240 ? i3 & 7 : 0;
   if (!i2) {
    i1 = 0;
    i2 = 21;
    break L3;
   }
  } while (0);
  i6 = i1;
  i1 = i1 + i2 | 0;
  if (i1 >>> 0 > i7 >>> 0) {
   i1 = 0;
   i2 = 21;
   break;
  }
  if (i2 >>> 0 > 1) {
   i5 = 1;
   do {
    i4 = HEAPU8[i6 + i5 >> 0] | 0;
    if ((i4 & 192 | 0) != 128) {
     i1 = 0;
     i2 = 21;
     break L3;
    }
    i3 = i4 & 63 | i3 << 6;
    i5 = i5 + 1 | 0;
   } while (i5 >>> 0 < i2 >>> 0);
   if ((i2 | 0) != 1) if (!((i2 | 0) == 2 & i3 >>> 0 > 127)) if (!((i2 | 0) == 3 & i3 >>> 0 > 2047)) if (!((i2 | 0) == 4 & i3 >>> 0 > 65535)) {
    i1 = 0;
    i2 = 21;
    break;
   }
  }
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 1;
   i2 = 21;
   break;
  }
 }
 if ((i2 | 0) == 21) return i1 | 0;
 return 0;
}

function _ynf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 <= 2139095040) if ((i2 | 0) < 0 & (i3 | 0) != 0) f1 = Math_fround(nan); else if ((i3 | 0) == 2139095040) f1 = Math_fround(0.0); else {
  if (!i4) {
   f1 = Math_fround(_y0f(f1));
   break;
  }
  i3 = (i4 | 0) < 0;
  i7 = i3 ? i4 & 1 : 0;
  i3 = i3 ? ~i4 : i4 + -1 | 0;
  if (!i3) {
   f1 = Math_fround(_y1f(f1));
   f6 = Math_fround(-f1);
   f1 = i7 | 0 ? f6 : f1;
   break;
  }
  f6 = Math_fround(_y0f(f1));
  f5 = Math_fround(_y1f(f1));
  if ((i3 | 0) > 0 & ((HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) | 0) != -8388608) {
   i2 = 0;
   while (1) {
    i2 = i2 + 1 | 0;
    f6 = Math_fround(Math_fround(f5 * Math_fround(Math_fround(Math_fround(i2 | 0) * Math_fround(2.0)) / f1)) - f6);
    if (!((i2 | 0) < (i3 | 0) & ((HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) | 0) != -8388608)) {
     f1 = f6;
     break;
    } else {
     f8 = f5;
     f5 = f6;
     f6 = f8;
    }
   }
  } else f1 = f5;
  f8 = Math_fround(-f1);
  f1 = i7 | 0 ? f8 : f1;
 } while (0);
 return Math_fround(f1);
}

function __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_(i1, i2, i3, i4, i6) | 0;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i6, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0)) return i7 | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i8;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i6, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) {
  i8 = i7 + 1 | 0;
  return i8 | 0;
 }
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i8;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i6, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0)) {
  i8 = i7 + 2 | 0;
  return i8 | 0;
 }
 i8 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i8;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i6, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
  i8 = i7 + 3 | 0;
  return i8 | 0;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i8;
 i8 = i7 + 4 | 0;
 return i8 | 0;
}

function __ZN5physx22PxPhysicsGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 771624;
 HEAP32[i1 + 4 >> 2] = 196;
 HEAP32[i1 + 8 >> 2] = fb + 2187;
 HEAP32[i1 + 12 >> 2] = gb + 771640;
 HEAP32[i1 + 16 >> 2] = 197;
 HEAP32[i1 + 20 >> 2] = fb + 409;
 HEAP32[i1 + 24 >> 2] = fb + 2188;
 HEAP32[i1 + 28 >> 2] = fb + 832;
 HEAP32[i1 + 32 >> 2] = gb + 771655;
 HEAP32[i1 + 36 >> 2] = 198;
 HEAP32[i1 + 40 >> 2] = fb + 410;
 HEAP32[i1 + 44 >> 2] = fb + 2189;
 HEAP32[i1 + 48 >> 2] = fb + 833;
 HEAP32[i1 + 52 >> 2] = gb + 771668;
 HEAP32[i1 + 56 >> 2] = 199;
 HEAP32[i1 + 60 >> 2] = fb + 411;
 HEAP32[i1 + 64 >> 2] = fb + 2190;
 HEAP32[i1 + 68 >> 2] = fb + 834;
 HEAP32[i1 + 72 >> 2] = gb + 771681;
 HEAP32[i1 + 76 >> 2] = 200;
 HEAP32[i1 + 80 >> 2] = fb + 412;
 HEAP32[i1 + 84 >> 2] = fb + 2191;
 HEAP32[i1 + 88 >> 2] = gb + 771694;
 HEAP32[i1 + 92 >> 2] = 201;
 HEAP32[i1 + 96 >> 2] = fb + 413;
 HEAP32[i1 + 100 >> 2] = fb + 2192;
 HEAP32[i1 + 104 >> 2] = fb + 835;
 HEAP32[i1 + 108 >> 2] = gb + 673520;
 HEAP32[i1 + 112 >> 2] = 202;
 HEAP32[i1 + 116 >> 2] = fb + 414;
 HEAP32[i1 + 120 >> 2] = fb + 2193;
 HEAP32[i1 + 124 >> 2] = gb + 672885;
 HEAP32[i1 + 128 >> 2] = 203;
 HEAP32[i1 + 132 >> 2] = fb + 415;
 HEAP32[i1 + 136 >> 2] = fb + 2194;
 return;
}

function __ZN13dynamic_arrayItLj2EE6insertEPtPKtS3_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 1;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 1;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 1, 2, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 1 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 1) | 0;
 _memmove(i14 + (i8 << 1) | 0, i14 | 0, i11 << 1 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_(i10, i1, i13, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i13 = i13 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[i10 >> 2] | 0;
 i12 = i1 - i14 >> 2;
 i9 = i10 + 12 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i11 = i3 - i12 | 0;
 i7 = i2 - i13 | 0;
 i8 = i7 >> 2;
 i2 = i3 + i8 | 0;
 HEAP32[i9 >> 2] = i2;
 i3 = i10 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 i6 = i14;
 i1 = i14;
 do if (i5 >>> 0 < i2 >>> 0) {
  i14 = i4 << 1;
  i2 = i14 >>> 0 > i2 >>> 0 ? i14 : i2;
  if (i5 >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i10 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i10 >> 2] = i1;
   break;
  }
 } while (0);
 i14 = i1 + (i12 << 2) | 0;
 _memmove(i14 + (i8 << 2) | 0, i14 | 0, i11 << 2 | 0) | 0;
 _memcpy(i14 | 0, i13 | 0, i7 | 0) | 0;
 return i14 | 0;
}

function __ZN13RenderTexture10GrabPixelsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii(i4, i5, i7, i8, i9, i10) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i13 + 12 | 0;
 i1 = i13 + 8 | 0;
 i11 = i13 + 4 | 0;
 i12 = i13;
 if ((HEAP16[gb + 1158316 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158316 | 0, i2);
  i3 = gb + 1158316 | 0;
 } else i3 = 0;
 i6 = __Z12GetGfxDevicev() | 0;
 i14 = HEAP32[(HEAP32[i6 >> 2] | 0) + 604 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i12 >> 2];
 mftCall_viiiiiii(i14 | 0, i6 | 0, i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
 __Z15gpu_time_samplev();
 if (HEAP8[i6 + 3896 >> 0] | 0) {
  i14 = i6 + 3620 | 0;
  HEAP32[i14 >> 2] = (HEAP32[i14 >> 2] | 0) + 1;
 }
 if (!i3) {
  STACKTOP = i13;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i13;
 return;
}

function __ZN13MonoBehaviour18TransferEngineDataI14SafeBinaryReadEE4PPtrI10MonoScriptERT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i5 = i6;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i2, i4);
 HEAP32[i5 >> 2] = HEAP32[i2 + 36 >> 2];
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 588832 | 0, gb + 899338 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_(i5, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 40 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  i5 = HEAP32[i5 >> 2] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i2, 1); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 i5 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN12ShaderErrors18ClearRuntimeErrorsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 if ((i1 | 0) == (i7 | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = i1;
 while (1) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = (i1 | 0) == 0;
  L6 : do if (!(HEAP8[i2 + 73 >> 0] | 0)) {
   if (!i3) while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break L6; else i1 = i2;
   }
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   }
  } else {
   if (i3) {
    i3 = i2;
    while (1) {
     i1 = HEAP32[i3 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break; else i3 = i1;
    }
   } else while (1) {
    i3 = HEAP32[i1 >> 2] | 0;
    if (!i3) break; else i1 = i3;
   }
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   __ZNSt3__26__treeIN12ShaderErrors11ShaderErrorENS_4lessIS2_EENS_9allocatorIS2_EEE5eraseENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_PvEEiEE(i5, i4) | 0;
  } while (0);
  if ((i1 | 0) == (i7 | 0)) break; else i2 = i1;
 }
 STACKTOP = i8;
 return;
}

function __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1033960 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1033967 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1033975 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1033981 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z19GetRotMatrixNormVecPfPKff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f4 = Math_fround(+Math_sin(+f3));
 f5 = Math_fround(+Math_cos(+f3));
 f13 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f10 = Math_fround(f8 * f8);
 f3 = Math_fround(f11 * f11);
 f12 = Math_fround(f13 * f8);
 f6 = Math_fround(f8 * f11);
 f9 = Math_fround(f13 * f11);
 f7 = Math_fround(f4 * f13);
 f8 = Math_fround(f4 * f8);
 f11 = Math_fround(f4 * f11);
 f4 = Math_fround(Math_fround(1.0) - f5);
 HEAPF32[i1 >> 2] = Math_fround(f5 + Math_fround(f4 * Math_fround(f13 * f13)));
 f12 = Math_fround(f4 * f12);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f12 - f11);
 f9 = Math_fround(f4 * f9);
 HEAPF32[i1 + 24 >> 2] = Math_fround(f8 + f9);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f12 + f11);
 HEAPF32[i1 + 16 >> 2] = Math_fround(f5 + Math_fround(f4 * f10));
 f6 = Math_fround(f4 * f6);
 HEAPF32[i1 + 28 >> 2] = Math_fround(f6 - f7);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i1 + 20 >> 2] = Math_fround(f7 + f6);
 HEAPF32[i1 + 32 >> 2] = Math_fround(f5 + Math_fround(f4 * f3));
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN30PreUpdateSendMouseEventsstruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 248 | 0;
 i2 = i5;
 i3 = i5 + 240 | 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 120 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP16[gb + 1450948 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450948 | 0, i4);
  i1 = gb + 1450948 | 0;
 } else i1 = 0;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 360 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i2, i4);
 __ZN18ScriptingArguments6AddIntEi(i2, 1);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i2, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 24 | 0) + 1 | 0;
 if (i3 >>> 0 > 178956970) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 24 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 89478485 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 178956970;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 24 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 24 | 0) * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -24 | 0) * 24 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 24;
 HEAP32[i8 >> 2] = i6 + (i4 * 24 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = i2 + 416 | 0;
 f9 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 500 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 504 >> 2]);
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 d5 = +f9;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d5;
 d4 = +f8;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d4;
 d3 = +f7;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d3;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAPF64[i2 >> 3] = d5 + +HEAPF64[i2 >> 3];
 i2 = i1 + 32 | 0;
 HEAPF64[i2 >> 3] = d4 + +HEAPF64[i2 >> 3];
 i2 = i1 + 40 | 0;
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 return 1;
}

function __ZN5physx3Cct13BoxController20setHalfForwardExtentEf(i4, f3) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (f3 <= Math_fround(0.0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i4 + 504 | 0;
 HEAPF32[i1 >> 2] = f3;
 if (HEAP32[i4 + 408 >> 2] | 0) {
  i6 = __ZNK5physx3Cct10Controller12getKineShapeEv(i4 + 8 | 0) | 0;
  HEAP32[i2 >> 2] = 3;
  i10 = i2 + 4 | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  i8 = i2 + 8 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i7 = i2 + 12 | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, i2 | 0) | 0;
  f12 = Math_fround(HEAPF32[i4 + 496 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 500 >> 2]);
  f3 = Math_fround(HEAPF32[i1 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 488 >> 2]);
  f9 = Math_fround(f9 * f11);
  f3 = Math_fround(f3 * f11);
  HEAPF32[i10 >> 2] = Math_fround(f12 * f11);
  HEAPF32[i8 >> 2] = f9;
  HEAPF32[i7 >> 2] = f3;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i2 | 0);
 }
 i10 = 1;
 STACKTOP = i5;
 return i10 | 0;
}

function __ZN5physx14NpRigidDynamic7releaseEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i7, HEAP32[i7 + 8 >> 2] | 0, 1);
 i6 = i7 + 48 | 0;
 i1 = HEAP32[i7 + 52 >> 2] | 0;
 if (((i1 >>> 30) + -1 | 0) >>> 0 < 2) i5 = HEAP32[i6 >> 2] | 0; else i5 = 0;
 i3 = (HEAP16[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i6 + 8 >> 1] & 8) != 0;
 i4 = (i5 | 0) != 0;
 if (i4 & i3) {
  i1 = i7 + 20 | 0;
  __ZN5physx14NpShapeManager20clearShapesOnReleaseERNS_3Scb5SceneERNS_12PxRigidActorE(i1, i5, i7);
  i2 = i7;
 } else {
  i1 = i7 + 20 | 0;
  i2 = i7;
 }
 i8 = i7 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i8, i2);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i1, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i7) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i8, i7);
 if (!i4) {
  __ZN5physx3Scb4Base7destroyEv(i6);
  return;
 }
 __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i5, i6, 1, i3);
 __ZN5physx7NpScene24removeFromRigidActorListERKj(__ZN5physx3Scb5Scene10getPxSceneEv(i5) | 0, i7 + 36 | 0);
 __ZN5physx3Scb4Base7destroyEv(i6);
 return;
}

function __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i3 = i6 + 80 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i7 = i1 + 24 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i3, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 84 | 0;
 i3 = i4 + 4 | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i3;
 }
 i1 = i6 + 88 | 0;
 if ((i3 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  i2 = HEAP32[i8 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
  HEAP32[i8 >> 2] = i2;
 }
 i1 = i6 + 89 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  return;
 }
}

function __ZN23CloudWebServicesManagerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i5 >> 2] = gb + 189740 + 8;
 __ZN23CloudWebServicesManager15ThreadedCleanupEv(i5);
 i7 = i5 + 44 | 0;
 i1 = i5 + 52 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = HEAP32[i5 + 48 >> 2] | 0;
  i3 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  if ((i4 | 0) != (i7 | 0)) {
   i2 = i5 + 56 | 0;
   i3 = i6 + 4 | 0;
   i1 = i4;
   do {
    i4 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i9 = HEAP32[i2 >> 2] | 0;
    HEAP32[i6 >> 2] = 85;
    HEAP32[i3 >> 2] = i9;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
   } while ((i1 | 0) != (i7 | 0));
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5 + 28 | 0, HEAP32[i5 + 32 >> 2] | 0);
 HEAP32[i5 >> 2] = gb + 28648 + 8;
 HEAP32[i5 >> 2] = gb + 28496 + 8;
 STACKTOP = i8;
 return;
}

function __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i5, i6, i7, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i5 + 252 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 260 >> 2] = i2 >>> 0 > 31 ? 0 : i2;
 i1 = i5 + 236 | 0;
 i2 = (i4 & 1) << 8 | i3 << 6 & 192 | (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773183;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i5 + 4 | 0;
 i2 = i6;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i5 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i6, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0;
 i4 = i5 + 156 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i7, i6, i5 + 132 | 0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0);
 HEAP8[i5 + 240 >> 0] = 0;
 HEAP8[i5 + 241 >> 0] = 0;
 return;
}

function __ZN14Physics2DState10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 >> 2] = __Z13GetIPhysics2Dv() | 0;
 i5 = __Znwj(103032) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = -1055066685;
 __ZN7b2WorldC2ERK6b2Vec2(i5, i3);
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = i5;
 __ZN7b2World18SetContactListenerEP17b2ContactListener(i5, i1 + 12 | 0);
 __ZN7b2World16SetContactFilterEP15b2ContactFilter(HEAP32[i4 >> 2] | 0, i1 + 236 | 0);
 HEAP32[i3 + 44 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i3 + 36 >> 0] = 1;
 HEAP8[i3 + 38 >> 0] = 0;
 HEAP8[i3 + 39 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i3 + 40 >> 0] = 1;
 HEAPF32[i3 + 48 >> 2] = Math_fround(1.0);
 HEAP8[i3 + 37 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = __ZN7b2World10CreateBodyEPK9b2BodyDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i3) | 0;
 HEAP32[gb + 1115296 + 160 >> 2] = fb + 236;
 HEAP32[gb + 1115296 + 176 >> 2] = fb + 237;
 STACKTOP = i2;
 return;
}

function __Z29Animator_CUSTOM_SetBoolStringP12Il2CppObjectP12Il2CppStringh(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i1 = __ZN8Animator7SetBoolEib(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i2 << 24 >> 24 != 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_(i6, i1, i2, i4, i5, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 i13 = HEAP32[i6 + 4 >> 2] | 0;
 f10 = Math_fround(HEAPF32[i13 + 96 + (i1 << 4) >> 2]);
 f12 = Math_fround(HEAPF32[i13 + 96 + (i1 << 4) + 4 >> 2]);
 f11 = Math_fround(HEAPF32[i13 + 96 + (i1 << 4) + 8 >> 2]);
 i1 = HEAP32[i13 + 96 + (i1 << 4) + 12 >> 2] | 0;
 i2 = 1 - i2 | 0;
 i6 = (HEAP32[i6 + 8 >> 2] | 0) + 96 | 0;
 f9 = Math_fround(HEAPF32[i6 + (i2 << 4) >> 2]);
 f8 = Math_fround(HEAPF32[i6 + (i2 << 4) + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + (i2 << 4) + 8 >> 2]);
 i6 = HEAP32[i6 + (i2 << 4) + 12 >> 2] | 0;
 HEAPF32[i4 >> 2] = f10;
 HEAPF32[i4 + 4 >> 2] = f12;
 HEAPF32[i4 + 8 >> 2] = f11;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAPF32[i5 >> 2] = f9;
 HEAPF32[i5 + 4 >> 2] = f8;
 HEAPF32[i5 + 8 >> 2] = f7;
 HEAP32[i5 + 12 >> 2] = i6;
 f8 = Math_fround(f12 - f8);
 f7 = Math_fround(f11 - f7);
 HEAPF32[i3 >> 2] = Math_fround(f10 - f9);
 HEAPF32[i3 + 4 >> 2] = f8;
 HEAPF32[i3 + 8 >> 2] = f7;
 HEAPF32[i3 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK4PPtrI18AudioMixerSnapshotEptEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __Z31ReadObjectFromPersistentManageri(HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = (HEAP8[i3 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i3, 12, i4, 4);
 i2 = i3 + 48 | 0;
 i6 = i3 + 44 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i5 = i3 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i8 >>> 8 << 2) >> 2] | 0;
 i8 = i8 & 255;
 i7 = i9 + (i8 << 4) + 4 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i8 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4, gb + 1085989 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4 + 4 | 0, gb + 1085998 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i3, i4 + 8 | 0, gb + 1084342 | 0, 0);
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i9 + -1;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - (HEAP32[i5 >> 2] | 0) | 0;
 if ((1 - i9 - (HEAP32[i6 >> 2] | 0) + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN16LightmapSettings14ClearLightmapsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 36 | 0;
 i2 = i3 + 52 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 40 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 56 | 0;
 i2 = i3 + 72 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __ZN16LightmapSettings7RebuildEv(i3);
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
  HEAP32[i2 + 4 >> 2] = 1;
  HEAP32[i2 >> 2] = gb + 43424 + 8;
  HEAP32[i2 + 8 >> 2] = 1;
  HEAP32[i2 + 12 >> 2] = 1;
  i3 = i2 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
 }
 i1 = i2 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  i3 = i2 + 28 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 __ZdaPv(i3);
 HEAP32[i1 >> 2] = 0;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 28 | 0, i5);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 56 | 0, i5);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 104 | 0, i5);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 180 | 0, i5);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 84 | 0, i5);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 132 | 0, i5);
 __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 152 | 0, i5);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 200 | 0, i5);
 __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 220 | 0, i5);
 i1 = i1 + 240 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function _finish_pass_gather(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i12 + 4 | 0;
 i9 = i12;
 i10 = HEAP32[i6 + 348 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 i11 = i6 + 228 | 0;
 if ((HEAP32[i11 >> 2] | 0) <= 0) {
  STACKTOP = i12;
  return;
 }
 i5 = 0;
 do {
  i8 = HEAP32[i6 + 232 + (i5 << 2) >> 2] | 0;
  i3 = HEAP32[i8 + 20 >> 2] | 0;
  i8 = HEAP32[i8 + 24 >> 2] | 0;
  i4 = i7 + i3 | 0;
  if (!(HEAP8[i4 >> 0] | 0)) {
   i2 = i6 + 88 + (i3 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = _jpeg_alloc_huff_table(i6) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   _jpeg_gen_optimal_table(i6, i1, HEAP32[i10 + 76 + (i3 << 2) >> 2] | 0);
   HEAP8[i4 >> 0] = 1;
  }
  i3 = i9 + i8 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) {
   i2 = i6 + 104 + (i8 << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = _jpeg_alloc_huff_table(i6) | 0;
    HEAP32[i2 >> 2] = i1;
   }
   _jpeg_gen_optimal_table(i6, i1, HEAP32[i10 + 92 + (i8 << 2) >> 2] | 0);
   HEAP8[i3 >> 0] = 1;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i11 >> 2] | 0));
 STACKTOP = i12;
 return;
}

function __ZNK9Transform13GetWorldScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 72 | 0;
 i4 = i3 + 32 | 0;
 i7 = i3 + 8 | 0;
 i5 = i3 + 16 | 0;
 i8 = i3;
 i9 = i2 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = i8;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z23CalculateGlobalRotation23TransformAccessReadOnly(i5, i6);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E(i4, i6, i5);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i4 + 32 >> 2];
 STACKTOP = i3;
 return;
}

function __ZNK7Terrain37GetLightmapSTConsideringDynamicUVRectE12LightmapType(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 i5 = HEAP32[i2 + 120 + (i4 << 4) >> 2] | 0;
 i6 = HEAP32[i2 + 120 + (i4 << 4) + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 120 + (i4 << 4) + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 120 + (i4 << 4) + 12 >> 2] | 0;
 if ((i4 | 0) == 1) {
  f10 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f11 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f9 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  HEAPF32[i1 >> 2] = Math_fround(f10 * Math_fround(HEAPF32[i2 + 156 >> 2]));
  HEAPF32[i1 + 4 >> 2] = Math_fround(f8 * Math_fround(HEAPF32[i2 + 160 >> 2]));
  HEAPF32[i1 + 8 >> 2] = Math_fround(f11 + Math_fround(f10 * Math_fround(HEAPF32[i2 + 164 >> 2])));
  HEAPF32[i1 + 12 >> 2] = Math_fround(f9 + Math_fround(f8 * Math_fround(HEAPF32[i2 + 168 >> 2])));
  return;
 } else {
  HEAP32[i1 >> 2] = i5;
  HEAP32[i1 + 4 >> 2] = i6;
  HEAP32[i1 + 8 >> 2] = i7;
  HEAP32[i1 + 12 >> 2] = i3;
  return;
 }
}

function __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = i5;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) {
  i1 = i4 + 36 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0) | 0) {
    HEAP32[i3 >> 2] = HEAP32[i4 + 32 >> 2];
    HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
    __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE(i4, i2);
   }
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0, (HEAP8[i4 + 40 >> 0] | 0) != 0 | 0);
  }
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 160 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) {
   STACKTOP = i5;
   return;
  }
  i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
  if (!i1) {
   STACKTOP = i5;
   return;
  }
  __ZN9Rigidbody22UpdateMassDistributionEv(i1);
  STACKTOP = i5;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 56 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = i2 + 76 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 28 >> 2] | 0, i9 | 0, i8 | 0, i8 + 4 | 0);
 __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE(i7, i2, HEAP32[i8 + (i1 << 2) >> 2] | 0);
 __ZNK5physx11PxTransform12transformInvERKS0_(i6, i7, i2 + 20 + (i1 * 28 | 0) | 0);
 HEAP32[i5 + (i1 * 28 | 0) >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + (i1 * 28 | 0) + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 i2 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx21contactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i4, i3, i7, i8, i1, i6) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i5 = 0;
 if (i3 | 0) {
  i1 = i7 + 16 | 0;
  i2 = 0;
  do {
   i5 = HEAP32[i1 >> 2] | 0;
   __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i4 + (i2 << 5) | 0, i7, i5 + ((HEAPU16[i4 + (i2 << 5) + 10 >> 1] | 0) << 6) | 0, i5 + ((HEAPU16[i4 + (i2 << 5) + 14 >> 1] | 0) << 6) | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 i5 = i7 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= ((HEAP32[i7 + 12 >> 2] | 0) + -4 | 0) >>> 0) return;
 i4 = __ZN5physx6shdfnd9atomicAddEPVii(i6, i1) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i4 - i3 | 0;
 if (i3 | 0) {
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  i2 = 0;
  do {
   i7 = i8 + (i4 + i2 << 4) | 0;
   i6 = i1 + (i2 << 4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN16CrashReportEvent14GetCacheKeyForERK8UnityStrS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i10 = HEAP8[i2 + 11 >> 0] | 0;
 i9 = i10 << 24 >> 24 < 0;
 i10 = i9 ? HEAP32[i2 + 4 >> 2] | 0 : i10 & 255;
 i8 = i3 + 11 | 0;
 i7 = HEAP8[i8 >> 0] | 0;
 i7 = i7 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
 i9 = i9 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i5;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i9, i10 >>> 0 < 255 ? i10 : 255, i5, i6);
 i10 = i5;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = (HEAP8[i8 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZN10SpookyHash7Hash128EPKvjPyS2_(i2, i7 >>> 0 < 4096 ? i7 : 4096, i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN15b2DistanceJointC2EPK18b2DistanceJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152164 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 80 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 104 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13BoxCollider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i6 = i1 + 160 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, HEAP32[gb + 37320 >> 2] | 0, i6, 0);
 i5 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i2 + 20 | 0) | 0) + 20 >> 2] | 2097152;
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 20 >> 2] = i5;
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085989 | 0, i5, i6, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1085998 | 0, i5, i1 + 164 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7SetSizeEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = i6 + 40 | 0;
 i5 = i6 + 44 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i9 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i9 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i9;
    }
    __ZdlPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = __Znaj(i7 >>> 0 > 1073741823 ? -1 : i7 << 2) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i5 >> 2] = i7;
 if ((i7 | 0) > 0) {
  HEAP32[i1 >> 2] = 0;
  if ((i7 | 0) != 1) {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
 }
 i9 = i6 + 28 | 0;
 HEAP32[i6 + 32 >> 2] = i9;
 HEAP32[i6 + 36 >> 2] = i9;
 i9 = i6 + 16 | 0;
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 return;
}

function __Z36CommandBuffer_CUSTOM_Blit_IdentifierP12Il2CppObjectR26MonoRenderTargetIdentifierS2_S0_i(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i6 = i9 + 16 | 0;
 i7 = i9 + 4 | 0;
 i11 = HEAP32[i2 + 4 >> 2] | 0;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i11;
 HEAP32[i6 + 8 >> 2] = i10;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i7 + 8 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8);
 if (!i4) {
  i11 = 0;
  __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali(i1, i6, i7, i11, i5);
  STACKTOP = i9;
  return;
 }
 i11 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali(i1, i6, i7, i11, i5);
 STACKTOP = i9;
 return;
}

function __GLOBAL__sub_I_runtime_utilities2_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1170808 >> 2] = 0;
 i3 = gb + 63680 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1170808 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1170808 + 12 >> 2] = 16;
 _strncpy(gb + 1170808 + 16 | 0, gb + 488455 | 0, 32) | 0;
 i1 = gb + 1170808 + 47 | 0;
 i2 = i1 + 33 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = HEAP32[gb + 1170888 >> 2] | 0;
 if ((i1 | 0) > 399) _exit(-1);
 HEAP32[gb + 1170892 + (i1 * 20 | 0) + 8 >> 2] = fb + 3450;
 HEAP32[gb + 1170892 + (i1 * 20 | 0) + 12 >> 2] = fb + 3451;
 HEAP32[gb + 1170892 + (i1 * 20 | 0) + 4 >> 2] = gb + 1170808;
 HEAP32[gb + 1170892 + (i1 * 20 | 0) >> 2] = 0;
 HEAP8[gb + 1170892 + (i1 * 20 | 0) + 16 >> 0] = 0;
 i2 = i1 + 1 | 0;
 HEAP32[gb + 1170888 >> 2] = i2;
 if ((i1 | 0) == 399) _exit(-1); else {
  HEAP32[gb + 1170892 + (i2 * 20 | 0) + 8 >> 2] = fb + 3452;
  HEAP32[gb + 1170892 + (i2 * 20 | 0) + 12 >> 2] = fb + 3453;
  HEAP32[gb + 1170892 + (i2 * 20 | 0) + 4 >> 2] = 0;
  HEAP32[gb + 1170892 + (i2 * 20 | 0) >> 2] = 0;
  HEAP8[gb + 1170892 + (i2 * 20 | 0) + 16 >> 0] = 0;
  HEAP32[gb + 1170888 >> 2] = i1 + 2;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 + 4 >> 2] | 0);
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i3 + 24 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i3 + 44 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 6;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i3 + 4 >> 2] | 0);
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i3 + 24 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, i3 + 44 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 5;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 STACKTOP = i5;
 return;
}

function __ZN8LODGroup11SetLODArrayERKNSt3__26vectorINS_3LODENS0_9allocatorIS2_EEEE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i7 + 56 | 0;
 if ((i2 | 0) != (i1 | 0)) __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i2, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 i6 = i7 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i5 = i7 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2) {
  i4 = i7 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i6 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i7);
 return;
}

function __ZN8Collider20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAPF32[i4 >> 2] = Math_fround(inf);
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i6) {
  __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  f10 = Math_fround(f10 - Math_fround(HEAPF32[i3 >> 2]));
  f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i3 + 4 >> 2]));
  f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f8 = Math_fround(f8 - Math_fround(HEAPF32[i3 + 8 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(f10 * f10) + Math_fround(f9 * f9)) + Math_fround(f8 * f8));
  STACKTOP = i7;
  return;
 } else {
  __Z19getShapeWorldBoundsRKN5physx7PxShapeE(i5, i6);
  __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf(i2, i5, i3, i4);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx3Cct13BoxController17setHalfSideExtentEf(i4, f3) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (f3 <= Math_fround(0.0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i4 + 500 | 0;
 HEAPF32[i1 >> 2] = f3;
 if (HEAP32[i4 + 408 >> 2] | 0) {
  i6 = __ZNK5physx3Cct10Controller12getKineShapeEv(i4 + 8 | 0) | 0;
  HEAP32[i2 >> 2] = 3;
  i10 = i2 + 4 | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  i8 = i2 + 8 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i7 = i2 + 12 | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, i2 | 0) | 0;
  f12 = Math_fround(HEAPF32[i4 + 496 >> 2]);
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f3 = Math_fround(HEAPF32[i4 + 504 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 488 >> 2]);
  f9 = Math_fround(f9 * f11);
  f3 = Math_fround(f3 * f11);
  HEAPF32[i10 >> 2] = Math_fround(f12 * f11);
  HEAPF32[i8 >> 2] = f9;
  HEAPF32[i7 >> 2] = f3;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i2 | 0);
 }
 i10 = 1;
 STACKTOP = i5;
 return i10 | 0;
}

function __ZN5physx2Sc5Scene19updateCCDSinglePassEPNS_10PxBaseTaskE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f9 = f0;
 i3 = i8 + 80 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i8 + 1204 | 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0;
 i6 = (__ZNK5physx10PxsContext17getCurrentCCDPassEv(i5) | 0) + 1 | 0;
 i3 = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 49848 >> 2] | 0;
 i4 = i8 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj(HEAP32[i4 >> 2] | 0, HEAP32[i3 + 49832 >> 2] | 0, HEAP32[i3 + 49836 >> 2] | 0, i6);
 __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv(i3);
 if (i1 | 0) {
  i2 = HEAP32[i3 + 49844 >> 2] | 0;
  while (1) {
   i1 = i1 + -1 | 0;
   __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j(HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i6);
   if (!i1) break; else i2 = i2 + 8 | 0;
  }
 }
 __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i3);
 __ZN5physx10PxsContext19resetThreadContextsEv(i5);
 f9 = Math_fround(HEAPF32[i8 + 64 >> 2]);
 __ZN5physx10PxsContext9updateCCDEfPNS_10PxBaseTaskEb(i5, f9, i7, (HEAP16[i8 + 1192 >> 1] & 8) != 0);
 return;
}

function __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i7 + 156 | 0;
 i4 = i7 + 160 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i5) i1 = 0; else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 } while (0);
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i2;
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i2 << 2) >> 2];
 }
 __ZN5physx2Sc8ClothSim20clearCollisionShapesEv(__ZNK5physx2Sc9ClothCore6getSimEv(i6) | 0);
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i5 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0) + 4 >> 2] | 0;
 i4 = HEAP32[i7 + 168 + (i5 << 2) >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 if (i5 | 0) {
  i7 = HEAP32[i7 + 184 >> 2] | 0;
  __ZN5physx2Sc9ClothCore11switchClothEPNS_5cloth5ClothE(i6, mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, i1 | 0) | 0);
 }
 i1 = __ZNK5physx2Sc9ClothCore6getSimEv(i6) | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN22BuiltinResourceManager14RegisterShaderExPKcS1_b(i8, i2, i3, i4, i1, i5) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = gb + 31552;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i6 + 16 >> 2] = __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(__Z20GetPersistentManagerv() | 0, i8 + 12 | 0, i2, i3) | 0;
 HEAP8[i6 + 20 >> 0] = i5 & 1;
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i8 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i8, i6);
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 24;
  STACKTOP = i7;
  return;
 }
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 801380 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 160 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 802559 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN13MonoBehaviour17StopAllCoroutinesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i3 = i6;
 i4 = i2 + 68 | 0;
 i5 = i2 + 64 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i5 | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZN18DelayedCallManager18CancelCallDelayed2E4PPtrI6ObjectEPF15CallObjectStatePS1_PvES7_(i7, i1, fb + 592 | 0, fb + 691 | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i7 = i1 + 4 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  HEAP32[i1 + 40 >> 2] = 0;
  i2 = i1 + 60 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   if (HEAP32[i1 + 64 >> 2] | 0) __ZN9Coroutine16CleanupCoroutineEPv(i1) | 0;
  } else {
   HEAP32[i3 + 56 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   __ZN9Coroutine16CleanupCoroutineEPv(i1) | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i6;
 return;
}

function __ZN13BuildSettings12GetSceneNameEi(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = i3;
 if (!((i5 | 0) > -1 ? ((HEAP32[i1 + 32 >> 2] | 0) - i3 >> 4 | 0) > (i5 | 0) : 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  STACKTOP = i9;
  return;
 }
 i1 = i4 + (i5 << 4) | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + (i5 << 4) + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i8, i3, i1);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i8);
 __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 8 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE7reserveEj(i3, 64);
 i1 = i3 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i3 >> 2] >> 0] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 } else {
  HEAP8[i3 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 i7 = __ZN12FileAccessor4ReadEyPvPy(i2, 1, 0, i5, i4) | 0;
 i1 = i4;
 L5 : do if (i7 & ((HEAP32[i1 >> 2] | 0) == 1 & (HEAP32[i1 + 4 >> 2] | 0) == 0)) {
  while (1) {
   i1 = HEAP8[i5 >> 0] | 0;
   if (!(i1 << 24 >> 24)) break;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9push_backEc(i3, i1);
   i1 = __ZN12FileAccessor4ReadEyPvPy(i2, 1, 0, i5, i4) | 0;
   i7 = i4;
   if (!(i1 & ((HEAP32[i7 >> 2] | 0) == 1 & (HEAP32[i7 + 4 >> 2] | 0) == 0))) break L5;
  }
  i7 = 1;
  STACKTOP = i6;
  return i7 | 0;
 } while (0);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN11ChannelInfo8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37300 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 430659 | 0, i5, i1, 1);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 744923 | 0, i5, i1 + 1 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 752357 | 0, i5, i1 + 2 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 430666 | 0, i5, i1 + 3 | 0, 1);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function _scandir(i1, i12, i8, i13) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i8 = i8 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = _opendir(i1) | 0;
 i10 = ___errno_location() | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 do if (!i9) i1 = -1; else {
  i6 = (i8 | 0) == 0;
  i3 = 0;
  i1 = 0;
  i2 = 0;
  L3 : while (1) {
   do {
    HEAP32[i10 >> 2] = 0;
    i7 = _readdir(i9) | 0;
    if (!i7) break L3;
    if (i6) break;
   } while (!(mftCall_ii(i8 | 0, i7 | 0) | 0));
   if (i1 >>> 0 >= i3 >>> 0) {
    i3 = i3 << 1 | 1;
    if (i3 >>> 0 > 1073741823) break;
    i4 = _realloc(i2, i3 << 2) | 0;
    if (!i4) break;
    i2 = i4;
   }
   i4 = i7 + 8 | 0;
   i5 = _malloc(HEAPU16[i4 >> 1] | 0) | 0;
   HEAP32[i2 + (i1 << 2) >> 2] = i5;
   if (!i5) break;
   _memcpy(i5 | 0, i7 | 0, HEAPU16[i4 >> 1] | 0 | 0) | 0;
   i1 = i1 + 1 | 0;
  }
  _closedir(i9) | 0;
  if (!(HEAP32[i10 >> 2] | 0)) {
   HEAP32[i10 >> 2] = i11;
   if (i13 | 0) _qsort(i2, i1, 4, i13);
   HEAP32[i12 >> 2] = i2;
   break;
  } else {
   if (!((i2 | 0) == 0 | (i1 | 0) == 0)) do {
    i1 = i1 + -1 | 0;
    _free(HEAP32[i2 + (i1 << 2) >> 2] | 0);
   } while ((i1 | 0) != 0);
   _free(i2);
   i1 = -1;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj(i5, i1, i6, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i8 = HEAP8[i5 + 11 >> 0] | 0;
 i7 = i8 << 24 >> 24 < 0;
 i4 = i5 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i8 = i8 & 255;
 do if ((i7 ? i2 : i8) | 0) {
  if ((i1 | 0) != (i6 | 0)) {
   i2 = i6;
   i3 = i1;
   while (1) {
    i2 = i2 + -4 | 0;
    if (i3 >>> 0 >= i2 >>> 0) break;
    i11 = HEAP32[i3 >> 2] | 0;
    HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i2 >> 2] = i11;
    i3 = i3 + 4 | 0;
   }
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i11 = i7 ? HEAP32[i5 >> 2] | 0 : i5;
  i6 = i6 + -4 | 0;
  i5 = i11 + (i7 ? i2 : i8) | 0;
  i2 = i11;
  while (1) {
   i3 = HEAP8[i2 >> 0] | 0;
   i4 = i3 << 24 >> 24 > 0 & i3 << 24 >> 24 != 127;
   if (i1 >>> 0 >= i6 >>> 0) break;
   if (i4) if ((i3 << 24 >> 24 | 0) != (HEAP32[i1 >> 2] | 0)) {
    i10 = 10;
    break;
   }
   i1 = i1 + 4 | 0;
   i2 = (i5 - i2 | 0) > 1 ? i2 + 1 | 0 : i2;
  }
  if ((i10 | 0) == 10) {
   HEAP32[i9 >> 2] = 4;
   break;
  }
  if (i4) if (((HEAP32[i6 >> 2] | 0) + -1 | 0) >>> 0 >= i3 << 24 >> 24 >>> 0) HEAP32[i9 >> 2] = 4;
 } while (0);
 return;
}

function __ZNK18AudioLowPassFilter30GetCustomLowpassLevelCurveCopyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKci(88, gb + 63328 | 0, 16, gb + 873287 | 0, 91) | 0;
 HEAPF32[i3 + 4 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(inf);
 HEAP32[i3 + 28 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 80 >> 2] = 2;
 HEAP32[i3 + 76 >> 2] = 2;
 HEAP32[i3 + 84 >> 2] = 4;
 i4 = HEAP32[i1 + 100 >> 2] | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i3, i4, i4 + (HEAP32[i1 + 112 >> 2] << 4) | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN11LightProbes14LightProbeDataD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = HEAP32[i6 + 84 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i6 + 88 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
  i5 = HEAP32[i6 + 96 >> 2] | 0;
  HEAP32[i1 >> 2] = 79;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 }
 i1 = i6 + 60 | 0;
 if ((HEAP32[i6 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 40 | 0;
 if ((HEAP32[i6 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 20 | 0;
 if ((HEAP32[i6 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i6 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i6 + 4 | 0);
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z19CreateCullingOutputPK16RendererCullDataR13CullingOutput(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = i3;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = i3;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i2 + 24 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = i3;
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = i3;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = i1;
 return;
}

function _sincos(d1, i5, i6) {
 d1 = +d1;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 L1 : do if (i3 >>> 0 < 1072243196) if (i3 >>> 0 < 1044816030) {
  HEAPF64[i5 >> 3] = d1;
  HEAPF64[i6 >> 3] = 1.0;
  break;
 } else {
  HEAPF64[i5 >> 3] = +___sin(d1, 0.0, 0);
  HEAPF64[i6 >> 3] = +___cos(d1, 0.0);
  break;
 } else {
  if (i3 >>> 0 > 2146435071) {
   d2 = d1 - d1;
   HEAPF64[i6 >> 3] = d2;
   HEAPF64[i5 >> 3] = d2;
   break;
  }
  i3 = ___rem_pio2(d1, i4) | 0;
  i8 = i4 + 8 | 0;
  d2 = +___sin(+HEAPF64[i4 >> 3], +HEAPF64[i8 >> 3], 1);
  d1 = +___cos(+HEAPF64[i4 >> 3], +HEAPF64[i8 >> 3]);
  switch (i3 & 3) {
  case 0:
   {
    HEAPF64[i5 >> 3] = d2;
    HEAPF64[i6 >> 3] = d1;
    break L1;
   }
  case 1:
   {
    HEAPF64[i5 >> 3] = d1;
    HEAPF64[i6 >> 3] = -d2;
    break L1;
   }
  case 2:
   {
    HEAPF64[i5 >> 3] = -d2;
    HEAPF64[i6 >> 3] = -d1;
    break L1;
   }
  case 3:
   {
    HEAPF64[i5 >> 3] = -d1;
    HEAPF64[i6 >> 3] = d2;
    break L1;
   }
  default:
   {}
  }
 } while (0);
 STACKTOP = i7;
 return;
}

function __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 37304 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379117 | 0, i5, i1, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379125 | 0, i5, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379133 | 0, i5, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379141 | 0, i5, i1 + 12 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx2Sc9ClothCore12setParticlesEPKNS_15PxClothParticleES4_(i4, i2, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 28 | 0;
 i6 = i7;
 if (i2 | 0) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i2 | 0)) _memcpy(i1 | 0, i2 | 0, (HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) | 0;
  i1 = HEAP32[i3 + 20 >> 2] | 0;
  i8 = HEAP32[i3 + 24 >> 2] | 0;
  i2 = (HEAP32[i3 + 8 >> 2] | 0) + (i8 >> 1) | 0;
  if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
  mftCall_vi(i1 | 0, i2 | 0);
 }
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i6 | 0, i1 | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) _memcpy(i1 | 0, i5 | 0, (HEAP32[i6 + 4 >> 2] | 0) - i1 | 0) | 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i8 = HEAP32[i6 + 24 >> 2] | 0;
 i2 = (HEAP32[i6 + 8 >> 2] | 0) + (i8 >> 1) | 0;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 STACKTOP = i7;
 return;
}

function __ZN4Halo23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 374123 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i4 = i1 + 36 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 946541 | 0, HEAP32[gb + 36980 >> 2] | 0, i4, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i4, 1);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 842535 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN3MBP17prepareOverlapsMTEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i6) return; else i5 = 0;
 do {
  i4 = HEAP32[i3 + (i5 * 40 | 0) + 28 >> 2] | 0;
  do if (i4 | 0) {
   i2 = i4 + 116 | 0;
   i1 = (HEAP8[i4 + 168 >> 0] | 0) == 0;
   if (!(HEAP32[i2 >> 2] | 0)) if (i1) break; else i7 = 6; else if (!i1) i7 = 6;
   if ((i7 | 0) == 6) {
    i7 = 0;
    __ZN9BoxPruner10staticSortEv(i4);
    HEAP32[i2 >> 2] = HEAP32[i4 + 92 >> 2];
    HEAP32[i4 + 120 >> 2] = 0;
    HEAP8[i4 + 169 >> 0] = 1;
   }
   __ZN9BoxPruner14preparePruningER16MBPOS_TmpBuffers(i4, i4 + 176 | 0);
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    i2 = HEAP32[i4 + 84 >> 2] | 0;
    if (i2 | 0) {
     HEAP32[i4 + 32 >> 2] = HEAP32[i4 + 76 >> 2];
     HEAP32[i4 + 36 >> 2] = i1;
     HEAP32[i4 + 40 >> 2] = i2;
     HEAP32[i4 + 44 >> 2] = HEAP32[i4 + 12992 >> 2];
     HEAP32[i4 + 48 >> 2] = HEAP32[i4 + 96 >> 2];
     HEAP32[i4 + 52 >> 2] = HEAP32[i4 + 104 >> 2];
     HEAP32[i4 + 56 >> 2] = HEAP32[i4 + 144 >> 2];
     HEAP8[i4 + 60 >> 0] = 1;
     break;
    }
   }
   HEAP8[i4 + 60 >> 0] = 0;
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i6 | 0));
 return;
}

function __ZN2UI6Canvas15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 4 | 0;
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67128 | 0, gb + 1105016 | 0, fb + 976 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67128 | 0, gb + 1106096 | 0, fb + 977 | 0, 0);
 __ZN2UI23InitializeCanvasManagerEv();
 i1 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[gb + 1156840 + 768 >> 2] | 0;
 }
 HEAP32[gb + 1156840 + 768 >> 2] = i1 + 1;
 HEAP32[gb + 1156840 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[gb + 1156840 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[gb + 1156840 + (i1 * 12 | 0) >> 2] = fb + 339;
 STACKTOP = i3;
 return;
}

function __ZN2UI14CanvasRenderer10SyncBoundsENS0_8SyncFlagE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (i2 & 1 | 0) {
  i4 = HEAP32[i1 + 204 >> 2] | 0;
  i3 = i4 + 112 | 0;
  HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
  i3 = HEAP32[i1 + 208 >> 2] | 0;
  i4 = HEAP32[i4 + 84 >> 2] | 0;
  i6 = i1 + 52 | 0;
  i5 = i4 + (i3 * 672 | 0) + 548 | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP16[i4 + (i3 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!(i2 & 2)) return;
 i5 = HEAP32[i1 + 220 >> 2] | 0;
 i6 = i5 + 112 | 0;
 HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 0 | 2;
 i6 = HEAP32[i1 + 224 >> 2] | 0;
 i5 = HEAP32[i5 + 84 >> 2] | 0;
 i3 = i1 + 52 | 0;
 i4 = i5 + (i6 * 672 | 0) + 548 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP16[i5 + (i6 * 672 | 0) + 664 >> 1] = 2;
 return;
}

function __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 24 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 24 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i6 = HEAP32[i2 >> 2] | 0;
 i8 = i6 + (i4 * 24 | 0) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i6 + (i4 * 24 | 0) + 4 >> 2] = 0;
 HEAP32[i6 + (i4 * 24 | 0) + 8 >> 2] = -1;
 i7 = i6 + (i4 * 24 | 0) + 20 | 0;
 i6 = i6 + (i4 * 24 | 0) + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP8[i7 >> 0] = HEAP8[i7 >> 0] & -8;
 return i8 | 0;
}

function __Z42Graphics_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectiS0_P11Il2CppArrayiS0_17ShadowCastingModehiS0_(i1, i7, i2, i4, i9, i6, i10, i11, i12, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i5 = 0, i8 = 0;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!i3) i3 = 0; else i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 64) | 0;
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet(i8, i7, i5, i10, i11 << 24 >> 24 != 0, i12, i3, i2, i9, i1);
 return;
}

function __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 120 >> 2] | 0, i6 | 0) | 0) __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 32 | 0, i7);
 do if (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0, i6 | 0) | 0) {
  i1 = i6 + 40 | 0;
  i4 = i7 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = i7 + 24 | 0;
  if ((i2 + 1 | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
   __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
   i5 = i4;
   break;
  } else {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i5 = i4;
   break;
  }
 } else {
  i4 = i7 + 16 | 0;
  i3 = i7 + 24 | 0;
  i5 = i4;
 } while (0);
 i1 = i6 + 41 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN15QualitySettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 5);
 i5 = HEAP32[gb + 37040 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405365 | 0, i5, i1 + 44 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i6 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405382 | 0, HEAP32[gb + 37316 >> 2] | 0, i6, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i6, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 405547 | 0, i5, i1 + 40 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14AnimationState20UpdateBlendingWeightEfb(i8, f2, i1) {
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0;
 f6 = Math_fround(HEAPF32[i8 + 76 >> 2]);
 f7 = Math_fround(f6 * f2);
 i3 = i8 + 8 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f7);
 HEAPF32[i3 >> 2] = f7;
 do if (i1) i1 = HEAP32[i8 + 52 >> 2] | 0; else {
  if (f6 > Math_fround(0.0)) {
   f2 = Math_fround(HEAPF32[i8 + 52 >> 2]);
   if (f7 > f2) {
    i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
    break;
   }
  }
  if (!(f6 <= Math_fround(0.0))) {
   i8 = 0;
   return i8 | 0;
  }
  f2 = Math_fround(HEAPF32[i8 + 52 >> 2]);
  if (f7 < f2) i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0); else {
   i8 = 0;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i3 >> 2] = i1;
 i5 = i8 + 56 | 0;
 i3 = HEAP16[i5 >> 1] | 0;
 i1 = i3 & -34;
 HEAP16[i5 >> 1] = i1;
 if (!(i3 & 4)) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i8 + 80 >> 2] = HEAP32[i8 + 12 >> 2];
 i4 = i1 | 64;
 if ((i3 & 10) == 10) {
  HEAP16[i5 >> 1] = i4;
  i1 = i4;
 }
 HEAP16[i5 >> 1] = i1 & -3;
 __ZN14AnimationState7SetTimeEf(i8, Math_fround(0.0));
 HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -6;
 i8 = 1;
 return i8 | 0;
}

function __ZN12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i8 = HEAP32[i3 + 64 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0, i1 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0);
 i8 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i2 >> 2] | 0) | 0;
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i2 + 4 >> 2] | 0) | 0;
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 >> 2] | 0) | 0;
 i1 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = gb + 149632 + 8;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 i2 = i5 + 12 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 3);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __Z30Animator_CUSTOM_SetFloatStringP12Il2CppObjectP12Il2CppStringf(i4, i1, f3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i2 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator8SetFloatEif(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i5) | 0, f3) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i7;
  return;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZNSt3__27promiseIvE28set_exception_at_thread_exitESt13exception_ptr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4 + 8 | 0;
 i3 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 do if (!i1) {
  i1 = ___cxa_allocate_exception(16) | 0;
  __ZNSt3__215future_categoryEv() | 0;
  HEAP32[i6 >> 2] = 3;
  HEAP32[i6 + 4 >> 2] = gb + 1473484;
  __THREW__ = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  invoke_vii(fb + 4499 | 0, i1 | 0, i5 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i6;
   break;
  } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
 } else {
  __ZNSt13exception_ptrC2ERKS_(i3, i2);
  __THREW__ = 0;
  invoke_vii(fb + 4504 | 0, i1 | 0, i3 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt13exception_ptrD2Ev(i3);
   break;
  } else {
   __ZNSt13exception_ptrD2Ev(i3);
   STACKTOP = i4;
   return;
  }
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZN6prcoreL29inner_stretch_rgb565_bilinearEPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = (HEAP32[i3 + 24 >> 2] | 0) >>> 11;
 i7 = 32 - i6 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i13 = i1 >>> 16;
  i12 = i1 >>> 11 & 31;
  i10 = 32 - i12 | 0;
  i11 = (HEAPU16[i8 + (i13 << 1) >> 1] | 0) << 16 | (HEAPU16[i9 + (i13 << 1) >> 1] | 0);
  i13 = i13 + 1 | 0;
  i13 = (HEAPU16[i8 + (i13 << 1) >> 1] | 0) << 16 | (HEAPU16[i9 + (i13 << 1) >> 1] | 0);
  i3 = (Math_imul(i13 >>> 5 & 130086975, i12) | 0) + (Math_imul(i11 >>> 5 & 130086975, i10) | 0) | 0;
  i10 = (Math_imul(i13 & 132184095, i12) | 0) + (Math_imul(i11 & 132184095, i10) | 0) | 0;
  HEAP16[i4 >> 1] = ((Math_imul(i3 >>> 16 & 63519, i7) | 0) + (Math_imul(i10 >>> 5 & 63519, i6) | 0) | 0) >>> 5 & 63519 | ((Math_imul(i10 >>> 21 & 2016, i7) | 0) + (Math_imul(i3 & 2016, i6) | 0) | 0) >>> 5 & 2016;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i5 + i1 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIdyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
  HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i1 + 4 >> 0];
  HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i1 + 5 >> 0];
  HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i1 + 6 >> 0];
  HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i1 + 7 >> 0];
  d8 = +HEAPF64[tempDoublePtr >> 3];
  i7 = ~~d8 >>> 0;
  i5 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIdxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
  HEAP8[tempDoublePtr + 4 >> 0] = HEAP8[i1 + 4 >> 0];
  HEAP8[tempDoublePtr + 5 >> 0] = HEAP8[i1 + 5 >> 0];
  HEAP8[tempDoublePtr + 6 >> 0] = HEAP8[i1 + 6 >> 0];
  HEAP8[tempDoublePtr + 7 >> 0] = HEAP8[i1 + 7 >> 0];
  d8 = +HEAPF64[tempDoublePtr >> 3];
  i7 = ~~d8 >>> 0;
  i5 = +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx3Cct13BoxController13setHalfHeightEf(i4, f3) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, i10 = 0, f11 = f0, f12 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (f3 <= Math_fround(0.0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i4 + 496 | 0;
 HEAPF32[i1 >> 2] = f3;
 if (HEAP32[i4 + 408 >> 2] | 0) {
  i6 = __ZNK5physx3Cct10Controller12getKineShapeEv(i4 + 8 | 0) | 0;
  HEAP32[i2 >> 2] = 3;
  i10 = i2 + 4 | 0;
  HEAPF32[i10 >> 2] = Math_fround(0.0);
  i8 = i2 + 8 | 0;
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  i7 = i2 + 12 | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0, i2 | 0) | 0;
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  f9 = Math_fround(HEAPF32[i4 + 500 >> 2]);
  f3 = Math_fround(HEAPF32[i4 + 504 >> 2]);
  f11 = Math_fround(HEAPF32[i4 + 488 >> 2]);
  f9 = Math_fround(f9 * f11);
  f3 = Math_fround(f3 * f11);
  HEAPF32[i10 >> 2] = Math_fround(f12 * f11);
  HEAPF32[i8 >> 2] = f9;
  HEAPF32[i7 >> 2] = f3;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i2 | 0);
 }
 i10 = 1;
 STACKTOP = i5;
 return i10 | 0;
}

function __ZN5physx2Sc5Scene12createClientEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i6 + 1152 | 0;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i5 | 0, i4 | 0, 24, (i3 ? gb + 707409 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 3452) | 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 >> 2] = i3;
 i4 = i6 + 1156 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i6 + 1160 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 << 2) >> 2] = i3;
  i6 = i5 + 1 | 0;
  HEAP32[i4 >> 2] = i6;
  i6 = i6 + 255 | 0;
  i6 = i6 & 255;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i6 = i6 + 255 | 0;
  i6 = i6 & 255;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN5physx10PxsContext11preAllocateEjjjj(i11, i7, i9, i8, i10) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i8 + i9 | 0;
 if ((i1 | 0) == (0 - i10 | 0)) {
  i11 = i11 + 6172 | 0;
  __ZN5physx16PxsIslandManager11preAllocateEj(i11, i7);
  return;
 }
 i6 = i11 + 5912 | 0;
 i1 = (i1 << 1) + 256 & -256;
 i4 = i1 >>> 5;
 i5 = i11 + 5916 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] & 2147483647) >>> 0) {
  i3 = i11 + 5920 | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 >>> 3, gb + 769739 | 0, 329) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 | 0) {
   _memcpy(i1 | 0, i2 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i6 >> 2] | 0);
  }
  i3 = HEAP32[i5 >> 2] | 0;
  _memset(i1 + ((i3 & 2147483647) << 2) | 0, 0, i4 - i3 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i5 >> 2] = i4;
 }
 i1 = HEAP32[i11 + 8 >> 2] | 0;
 if (!i1) {
  i11 = i11 + 6172 | 0;
  __ZN5physx16PxsIslandManager11preAllocateEj(i11, i7);
  return;
 }
 __ZN5physx14PxsAABBManager11preAllocateEjjj(i1, i9, i8, i10);
 i11 = i11 + 6172 | 0;
 __ZN5physx16PxsIslandManager11preAllocateEj(i11, i7);
 return;
}

function __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb(i9, i2, i1) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP8[i9 + 4 >> 0] = 0;
 HEAP8[i9 + 5 >> 0] = 1;
 HEAP32[i9 + 8 >> 2] = 0;
 i8 = __ZnwjRK10MemLabelIdiPKci(208, gb + 63328 | 0, 16, gb + 860370 | 0, 294) | 0;
 __ZN30AudioEffectInternalDescriptionC2EP26UnityAudioEffectDefinition(i8, i2);
 if (i8 | 0) {
  i7 = i8 + 200 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i7 = HEAP32[i9 >> 2] | 0;
 if (!i7) {
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i5 = i7 + 200 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (i6 | 0) {
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i5 = i7 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 64 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
   if (i3) {
    __ZdaPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = HEAP32[i7 + 180 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63328 | 0);
 HEAP32[i9 >> 2] = i8;
 return;
}

function __ZN21LightProbeProxyVolume21GetWorldToLocalMatrixEv(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 192 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 128 | 0;
 i6 = i7 + 64 | 0;
 i2 = i7;
 if ((HEAP32[i1 + 36 >> 2] | 0) == 2) {
  f10 = Math_fround(-Math_fround(HEAPF32[i1 + 76 >> 2]));
  f9 = Math_fround(-Math_fround(HEAPF32[i1 + 80 >> 2]));
  f8 = Math_fround(-Math_fround(HEAPF32[i1 + 84 >> 2]));
  HEAPF32[i2 >> 2] = f10;
  HEAPF32[i2 + 4 >> 2] = f9;
  HEAPF32[i2 + 8 >> 2] = f8;
  __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i5, i2) | 0;
  __ZNK9Transform21GetWorldToLocalMatrixEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i3 = i6;
  i1 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i3 | 0) < (i1 | 0));
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i6, i5, i4);
  STACKTOP = i7;
  return;
 } else {
  __ZNK9Transform21GetWorldToLocalMatrixEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  STACKTOP = i7;
  return;
 }
}

function __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i5, i6, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 L1 : do if (!(i1 & 2)) {
  i1 = HEAP32[i5 + 24 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  if ((i1 | 0) < (i2 | 0)) {
   i3 = HEAP32[i5 + 32 >> 2] | 0;
   i4 = HEAP32[i6 >> 2] | 0;
   while (1) {
    if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) break L1;
   }
   if ((i1 | 0) > -1) {
    i8 = HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
    i6 = i5 + 72 | 0;
    i6 = HEAP32[i6 >> 2] | 0;
    i8 = i6 + i8 | 0;
    i7 = HEAP32[i7 >> 2] | 0;
    HEAP32[i8 >> 2] = i7;
    STACKTOP = i9;
    return;
   }
  }
 } while (0);
 __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i8, i5, i6, 4, 4, 0, 0);
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5 + 72 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i8 = i6 + i8 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = i7;
 STACKTOP = i9;
 return;
}

function __ZN14GfxContextGLES7ReleaseEN2gl13ContextHandleE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i7 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) i6 = 9; else {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = i5;
  L3 : while (1) {
   i2 = i3;
   while (1) {
    if (i4 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L3;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) i6 = 9; else if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 < i4 >>> 0) i6 = 9; else i3 = i1;
 }
 if ((i6 | 0) == 9) i3 = i5;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  __ZN14GfxContextGLES8InstanceD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i7 + 4 >> 2] | 0, i3);
 __ZdlPv(i3);
 return;
}

function __ZN12_GLOBAL__N_116CollectionSorterD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 140260 + 8;
 i4 = HEAP32[i5 + 72 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i5 + 64 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 i3 = i5 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 48 >> 2] | 0;
 i4 = i1 + (i2 << 5) | 0;
 if ((i2 | 0) > 0) do {
  i2 = HEAP32[i1 + 24 >> 2] | 0;
  if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 16 >> 2] | 0;
   if (i2 | 0) {
    i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
   }
  }
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i6 = HEAP32[i5 + 52 >> 2] | 0;
 if ((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
  }
 }
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __Z33Texture2DArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayii(i5, i4, i6, i7) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i9 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i2 + 109 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN14Texture2DArray11SetPixels32EiPK11ColorRGBA32ii(i2, i3, i1, i6, i7);
  STACKTOP = i8;
  return;
 }
}

function _UNITY_FT_New_Size(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i3) {
  i7 = 35;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!i4) {
  i7 = 6;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i3 + 96 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i7 = 34;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 i5 = HEAP32[i3 + 100 >> 2] | 0;
 i6 = _UNITY_ft_mem_alloc(i5, HEAP32[i2 + 40 >> 2] | 0, i7) | 0;
 do if (!(HEAP32[i7 >> 2] | 0)) {
  i1 = _UNITY_ft_mem_alloc(i5, 12, i7) | 0;
  if (!(HEAP32[i7 >> 2] | 0)) {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i6 + 40 >> 2] = 0;
   i2 = HEAP32[i2 + 56 >> 2] | 0;
   if (i2 | 0) {
    i2 = mftCall_ii(i2 | 0, i6 | 0) | 0;
    HEAP32[i7 >> 2] = i2;
    if (i2 | 0) break;
   }
   HEAP32[i4 >> 2] = i6;
   HEAP32[i1 + 8 >> 2] = i6;
   _UNITY_FT_List_Add(i3 + 108 | 0, i1);
   if (!(HEAP32[i7 >> 2] | 0)) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
  }
 } else i1 = 0; while (0);
 _UNITY_ft_mem_free(i5, i1);
 _UNITY_ft_mem_free(i5, i6);
 i7 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__220__get_up_to_n_digitsIcPcEEiRT0_S2_RjRKNS_5ctypeIT_EEi(i5, i6, i7, i8, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i6 | 0)) {
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 6;
  i1 = 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  if (i1 << 24 >> 24 > -1) {
   i4 = i8 + 8 | 0;
   if (HEAP16[(HEAP32[i4 >> 2] | 0) + (i1 << 24 >> 24 << 1) >> 1] & 2048) {
    i1 = (mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, i1 | 0, 0) | 0) << 24 >> 24;
    i3 = i2;
    while (1) {
     i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
     HEAP32[i5 >> 2] = i2;
     i1 = i1 + -48 | 0;
     if (!((i3 | 0) > 1 & (i2 | 0) != (i6 | 0))) break;
     i2 = HEAP8[i2 >> 0] | 0;
     if (i2 << 24 >> 24 <= -1) break L1;
     if (!(HEAP16[(HEAP32[i4 >> 2] | 0) + (i2 << 24 >> 24 << 1) >> 1] & 2048)) break L1;
     i1 = ((mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0, i2 | 0, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
     i3 = i3 + -1 | 0;
    }
    if ((i2 | 0) != (i6 | 0)) break;
    HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2;
    break;
   }
  }
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4;
  i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZN8Animator19GetPerformanceHintsEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 32 | 0;
 i4 = i5;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 910878 | 0, 15);
  STACKTOP = i5;
  return;
 };
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i3, gb + 911067 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 __Z11FormatBytesx(i4, i1, ((i1 | 0) < 0) << 31 >> 31);
 i1 = HEAP32[i4 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i3, (i1 | 0) == 0 ? i4 + 4 | 0 : i1) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i4 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sq17SceneQueryManager11flushShapesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 24 | 0;
 i7 = i8;
 i2 = i6 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 i4 = i6 + 52 | 0;
 i5 = 0;
 do {
  i11 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i10 = i11 & 1;
  i9 = i11 >>> 2;
  i11 = (HEAP32[i6 + 28 + (i10 * 12 | 0) >> 2] | 0) + (i11 >>> 7 << 2) | 0;
  HEAP32[i11 >> 2] = HEAP32[i11 >> 2] & ~(1 << (i9 & 31));
  HEAP32[i1 >> 2] = i9;
  i9 = i6 + 12 + (i10 << 2) | 0;
  i11 = HEAP32[i9 >> 2] | 0;
  i11 = mftCall_iii(HEAP32[(HEAP32[i11 >> 2] | 0) + 28 >> 2] | 0, i11 | 0, i1 | 0) | 0;
  __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE(i7, HEAP32[i11 >> 2] | 0, HEAP32[i11 + 4 >> 2] | 0);
  i10 = i6 + 20 + (i10 << 2) | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  i9 = HEAP32[i9 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i1 | 0, i7 | 0, 1);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i3 | 0));
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx12NpBatchQueryC2ERNS_7NpSceneERKNS_16PxBatchQueryDescE(i5, i2, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 >> 2] = gb + 92916 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd8SyncImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i6 | 0, i1 | 0, (i3 ? gb + 775627 | 0 : gb + 837976 | 0) | 0, gb + 775747 | 0, 83) | 0;
 }
 HEAP32[i5 + 4 >> 2] = i1;
 __ZN5physx6shdfnd8SyncImplC2Ev(i1);
 HEAP32[i5 + 8 >> 2] = i2;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 i3 = i5 + 44 | 0;
 i1 = i4;
 i2 = i3 + 88 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i5 + 144 >> 2] = -16;
 HEAP32[i5 + 132 >> 2] = 0;
 HEAP32[i5 + 136 >> 2] = 0;
 HEAP32[i5 + 140 >> 2] = 0;
 HEAP8[i5 + 148 >> 0] = 0;
 return;
}

function __ZN11UnityEngine9Analytics9PerfEvent12SetSceneLoadERK8UnityStrdddd(i7, i1, d9, d10, d11, d12) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d9 = +d9;
 d10 = +d10;
 d11 = +d11;
 d12 = +d12;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = i7 + 32 | 0;
 do if ((i6 | 0) != (i1 | 0)) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i5 << 24 >> 24 < 0;
  i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
  i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
  i3 = i6 + 11 | 0;
  i1 = HEAP8[i3 >> 0] | 0;
  i2 = i1 << 24 >> 24 < 0;
  if (i2) i4 = (HEAP32[i7 + 40 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
  if (i5 >>> 0 > i4 >>> 0) {
   if (i2) i1 = HEAP32[i7 + 36 >> 2] | 0; else i1 = i1 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i5 - i4 | 0, i1, 0, i1, i5, i8);
   break;
  }
  if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  if (i5 | 0) _memmove(i1 | 0, i8 | 0, i5 | 0) | 0;
  HEAP8[i1 + i5 >> 0] = 0;
  if ((HEAP8[i3 >> 0] | 0) < 0) {
   HEAP32[i7 + 36 >> 2] = i5;
   break;
  } else {
   HEAP8[i3 >> 0] = i5;
   break;
  }
 } while (0);
 HEAPF64[i7 + 48 >> 3] = d9;
 HEAPF64[i7 + 56 >> 3] = d10;
 HEAPF64[i7 + 64 >> 3] = d11;
 HEAPF64[i7 + 72 >> 3] = d12;
 return;
}

function __ZN11ChannelInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i3, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 1 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7SetSizeEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = i6 + 40 | 0;
 i5 = i6 + 44 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i9 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i9 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i9;
    }
    __ZdlPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i8 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = __Znaj(i7 >>> 0 > 1073741823 ? -1 : i7 << 2) | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i5 >> 2] = i7;
 if ((i7 | 0) > 0) {
  HEAP32[i1 >> 2] = 0;
  if ((i7 | 0) != 1) {
   i1 = 1;
   do {
    HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i7 | 0));
  }
 }
 i9 = i6 + 28 | 0;
 HEAP32[i6 + 32 >> 2] = i9;
 HEAP32[i6 + 36 >> 2] = i9;
 i9 = i6 + 16 | 0;
 HEAP32[i6 + 20 >> 2] = i9;
 HEAP32[i6 + 24 >> 2] = i9;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindERKS5_j(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i9 = HEAP8[i3 + 11 >> 0] | 0;
 i6 = i9 << 24 >> 24 < 0;
 i8 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
 i9 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i9 & 255;
 i6 = i1 >>> 0 < i4 >>> 0 ? i1 : i4;
 i6 = (i1 - i6 | 0) >>> 0 > i9 >>> 0 ? i9 + i6 | 0 : i1;
 i7 = i2 + i6 | 0;
 L5 : do if ((i9 | 0) == 0 | (i6 | 0) < (i9 | 0)) i1 = i7; else {
  i5 = i2 + (i9 + -1) | 0;
  i6 = i8 + i9 + -1 | 0;
  i1 = i7;
  L7 : while (1) {
   while (1) {
    if ((i5 | 0) == (i1 | 0)) {
     i1 = i7;
     break L5;
    }
    i4 = i1 + -1 | 0;
    if ((HEAP8[i4 >> 0] | 0) == (HEAP8[i6 >> 0] | 0)) {
     i3 = i6;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i8 | 0)) break L5;
    i1 = i1 + -1 | 0;
    i3 = i3 + -1 | 0;
    if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
     i1 = i4;
     continue L7;
    }
   }
  }
 } while (0);
 return ((i9 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 | 0) | 0;
}

function __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i6 + 16 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + (i5 * 608 | 0) + 292 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 i4 = (HEAP32[i6 + 24 >> 2] | 0) + (i5 * 132 | 0) + 128 | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + (i5 * 608 | 0) + 476 >> 2] | 0) > 0) i7 = 5; else if ((HEAP32[i1 + (i5 * 608 | 0) + 32 >> 2] | 0) > 1) i7 = 5; else if (HEAP8[i1 + (i5 * 608 | 0) + 44 >> 0] & 2) i7 = 5;
 if ((i7 | 0) == 5) HEAP32[i1 + (i5 * 608 | 0) + 48 >> 2] = 0;
 if ((HEAP8[i1 + (i5 * 608 | 0) + 600 >> 0] | 0) != 2) return;
 if ((HEAP32[i6 + 32 >> 2] | 0) != (HEAP32[i6 + 452 >> 2] | 0)) return;
 if (!(HEAP32[i6 + 92 >> 2] & 536870912)) return;
 HEAP32[i6 + 100 >> 2] = 0;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager11shiftOriginERKNS_6PxVec3E(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = i4 + 68 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 64 | 0;
  i3 = 0;
  do {
   __ZN5physx3Cct10Controller13onOriginShiftERKNS_6PxVec3E(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 120 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 116 | 0;
  i3 = 0;
  do {
   __ZN5physx3Cct15ObstacleContext13onOriginShiftERKNS_6PxVec3E(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 f10 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 f9 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
 f8 = Math_fround(-Math_fround(HEAPF32[i6 + 8 >> 2]));
 HEAPF32[i5 >> 2] = f10;
 HEAPF32[i5 + 4 >> 2] = f9;
 HEAPF32[i5 + 8 >> 2] = f8;
 __ZN5physx2Cm12RenderBuffer5shiftERKNS_6PxVec3E(i1, i5);
 STACKTOP = i7;
 return;
}

function __ZN5physx3Cct17CapsuleControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i4 >> 2] = gb + 86528 + 8;
 i7 = i4 + 8 | 0;
 __ZN5physx3Cct10ControllerC2ERKNS_16PxControllerDescEPNS_7PxSceneE(i7, i1, i2);
 HEAP32[i4 >> 2] = gb + 86100 + 8;
 HEAP32[i7 >> 2] = gb + 86100 + 160;
 HEAP32[i4 + 12 >> 2] = 1;
 i10 = HEAP32[i1 + 108 >> 2] | 0;
 HEAP32[i4 + 496 >> 2] = i10;
 i2 = HEAP32[i1 + 112 >> 2] | 0;
 HEAP32[i4 + 500 >> 2] = i2;
 HEAP32[i4 + 504 >> 2] = HEAP32[i1 + 116 >> 2];
 HEAP32[i6 >> 2] = 2;
 f9 = (HEAP32[tempDoublePtr >> 2] = i10, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f8 = Math_fround(HEAPF32[i4 + 488 >> 2]);
 HEAPF32[i6 + 4 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround((HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2])) * Math_fround(.5)) * f8);
 __ZN5physx3Cct10Controller16createProxyActorERNS_9PxPhysicsERKNS_10PxGeometryERKNS_10PxMaterialE(i7, i3, i6, HEAP32[i1 + 96 >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5audio5mixer11GetCPUUsageERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID(i2, i8, i3) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i10) {
  f1 = Math_fround(0.0);
  STACKTOP = i12;
  return Math_fround(f1);
 }
 i4 = i2 + 20 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i4 + (i2 << 4) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i4 + (i2 << 4) + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i4 + (i2 << 4) + 8 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i4 + (i2 << 4) + 12 >> 2] | 0) == (i3 | 0)) break;
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i10 >>> 0) {
   f1 = Math_fround(0.0);
   i11 = 9;
   break;
  }
 }
 if ((i11 | 0) == 9) {
  STACKTOP = i12;
  return Math_fround(f1);
 }
 __ZN4FMOD3DSP11getCPUUsageEPt(HEAP32[(HEAP32[i8 + 16 >> 2] | 0) + (i2 << 5) >> 2] | 0, i9 | 0) | 0;
 f1 = Math_fround(HEAPU16[i9 >> 1] | 0);
 STACKTOP = i12;
 return Math_fround(f1);
}

function __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayout(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 if (!(HEAP32[i8 + 176 >> 2] | 0)) if ((HEAP32[i1 + 116 >> 2] | 0) == (HEAP32[i1 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i6, i8 + 8 | 0);
  HEAP32[i6 >> 2] = (HEAP32[i6 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i6 + 8 >> 2] & ~HEAP32[i6 + 12 >> 2];
  HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i1, i2, i3, i4, i5, i7);
  STACKTOP = i9;
  return;
 };
 HEAP32[i7 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i1, i2, i3, i4, i5, i7);
 STACKTOP = i9;
 return;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 844275 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN14SafeBinaryRead10SetVersionEi(i5, 2);
   __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 28 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 844291 | 0, gb + 844305 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI11NavMeshDataE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN14PhysicMaterial15ChangedMaterialEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if ((HEAP32[(__Z21GetManagerFromContexti(9) | 0) + 64 >> 2] | 0) != (i2 | 0)) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i1 | 0, 1, 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (i1 | 0) i3 = 4;
 } else i3 = 4;
 if ((i3 | 0) == 4) {
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 40 >> 2]));
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 44 >> 2]));
  f6 = Math_fround(HEAPF32[i2 + 48 >> 2]);
  i5 = f6 < Math_fround(0.0);
  i3 = f6 > Math_fround(1.0);
  f6 = i3 ? Math_fround(1.0) : f6;
  mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i5 ? Math_fround(0.0) : f6));
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i2 + 32 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0);
 }
 STACKTOP = i4;
 return;
}

function __ZN13WheelColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 158928 + 8;
 HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 136 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(.800000011);
 HEAPF32[i1 + 116 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 148 >> 2] = -1;
 HEAP32[i1 + 144 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN13UnityProfiler21StartNewFrameInternalE12ProfilerMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, d5 = 0.0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = i3 + 24 | 0;
 HEAP32[i2 >> 2] = i4;
 if (!(i4 & 1)) {
  i4 = (HEAP8[i3 + 1 >> 0] | 0) != 0;
  return i4 | 0;
 }
 __ZN13UnityProfiler10BeginFrameEv(i3);
 if (HEAP32[i2 >> 2] & i1 | 0) {
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  i4 = i1 + 248 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  if ((HEAP32[i3 >> 2] & 255) << 24 >> 24) {
   i2 = i3 + 4 | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i2 >> 2] = i4 + 1;
   if (!i4) {
    i4 = i3 + 2 | 0;
    HEAP8[i4 >> 0] = 1;
    __ZN22UnityProfilerPerThread11SetIsActiveEb(i1, 1);
    i2 = __Z12GetGfxDevicev() | 0;
    mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 656 >> 2] | 0, i2 | 0, 2, 1);
    if (HEAP8[i4 >> 0] | 0) {
     d5 = +_emscripten_get_now() * 1.0e6;
     i2 = +Math_abs(d5) >= 1.0 ? (d5 > 0.0 ? ~~+Math_min(+Math_floor(d5 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d5 - +(~~d5 >>> 0)) / 4294967296.0) >>> 0) : 0;
     i4 = i3 + 48 | 0;
     HEAP32[i4 >> 2] = ~~d5 >>> 0;
     HEAP32[i4 + 4 >> 2] = i2;
    }
   }
  }
 }
 __ZN11GPUProfiler10BeginFrameEv();
 HEAP8[i3 + 1 >> 0] = 1;
 i4 = 1;
 return i4 | 0;
}

function __ZN11b2WeldJointC2EPK14b2WeldJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152632 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 80 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 96 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 return;
}

function __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i4 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i1 | 0) >= (i4 | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) {
  STACKTOP = i8;
  return i1 | 0;
 }
 if ((i1 | 0) <= -1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZNK19ShaderPropertySheet14GetMatrixArrayEi(i6, i3, i1);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 260 >> 2] | 0;
 i6 = (i2 | 0) == 0 ? 0 : i1;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(i7, 64, i6) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 64) | 0, i2 | 0, i6 << 6 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function _UNITY_FT_Set_Charmap(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 if (!i5) {
  i7 = 35;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = HEAP32[i5 + 40 >> 2] | 0;
 if (!((i6 | 0) != 0 & (i1 | 0) != 0)) {
  i7 = 38;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) i7 = 7; else {
  i2 = HEAP32[i2 + 96 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
  if (!i3) i7 = 7; else {
   i2 = mftCall_iii(i3 | 0, i2 | 0, gb + 1008121 | 0) | 0;
   if (!i2) i7 = 7; else if (!(mftCall_iii(HEAP32[i2 >> 2] | 0, i6 | 0, i4 | 0) | 0)) {
    if ((HEAP32[i4 + 4 >> 2] | 0) == 14) {
     i7 = 6;
     STACKTOP = i8;
     return i7 | 0;
    }
   } else i7 = 7;
  }
 }
 i4 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if ((i4 | 0) <= 0) {
  i7 = 6;
  STACKTOP = i8;
  return i7 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 6;
   i7 = 13;
   break;
  }
 }
 if ((i7 | 0) == 13) {
  STACKTOP = i8;
  return i1 | 0;
 }
 HEAP32[i5 + 92 >> 2] = i6;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i3 - i1 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 - i4 + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else i5 = __Znwj(i3) | 0;
 i6 = i5 + (i1 - i4) | 0;
 i5 = i5 + i3 | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i4 + 1 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZNSt3__26vectorIcNS_9allocatorIcEEE8__appendEj(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 8 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = i7 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i3 - i1 | 0) >>> 0 >= i2 >>> 0) {
  do {
   HEAP8[i1 >> 0] = 0;
   i1 = (HEAP32[i9 >> 2] | 0) + 1 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
  return;
 }
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 - i4 + i2 | 0;
 if ((i5 | 0) < 0) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i3 = HEAP32[i8 >> 2] | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i6 = i3 - i4 | 0;
 i3 = i6 << 1;
 i3 = i6 >>> 0 < 1073741823 ? (i3 >>> 0 < i5 >>> 0 ? i5 : i3) : 2147483647;
 if (!i3) i5 = 0; else i5 = __Znwj(i3) | 0;
 i6 = i5 + (i1 - i4) | 0;
 i5 = i5 + i3 | 0;
 i4 = i6;
 i1 = i6;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i4 + 1 | 0;
  i4 = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = (HEAP32[i9 >> 2] | 0) - i2 | 0;
 i1 = i6 + (0 - i3) | 0;
 if ((i3 | 0) > 0) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i8 >> 2] = i5;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN9b2Fixture7DestroyEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0;
 i1 = i1 + 44 | 0;
 __ZN16b2BlockAllocator4FreeEPvi(i2, HEAP32[i1 >> 2] | 0, i4 * 28 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 0:
  {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 20);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 case 1:
  {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 48);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 case 2:
  {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 152);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 case 4:
  {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 180);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 case 3:
  {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 40);
   HEAP32[i3 >> 2] = 0;
   return;
  }
 default:
  {
   HEAP32[i3 >> 2] = 0;
   return;
  }
 }
}

function __ZN26LightProbeProxyVolumeUtilsL20FindTetrahedronIndexER9TransformRi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i7 >> 2] | 0) != -1) return;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 L7 : do if ((i5 | 0) > 0) {
  i2 = i1 + 28 | 0;
  i1 = 0;
  while (1) {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
   if (i3 | 0) if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) {
    i4 = HEAP32[i3 + 28 >> 2] | 0;
    if (i4 | 0) if (__ZNK10GameObject8IsActiveEv(i4) | 0) {
     i4 = i3 + 268 | 0;
     if (((HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 196608 | 0) == 131072) break;
    }
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) break L7;
  }
  HEAP32[i7 >> 2] = HEAP32[i3 + 264 >> 2];
  return;
 } while (0);
 i3 = HEAP32[i6 + 92 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i6 + 80 | 0;
 i1 = 0;
 do {
  __ZN26LightProbeProxyVolumeUtilsL20FindTetrahedronIndexER9TransformRi(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 + 380 >> 2];
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (i1 | 0) {
    i7 = i1;
    STACKTOP = i6;
    return i7 | 0;
   }
  }
 }
 i7 = __ZN8Renderer12GetTransformEv(i4) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN15DeviceStateGLESD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i6 + 512 | 0, HEAP32[i6 + 516 >> 2] | 0);
 __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i6 + 500 | 0, HEAP32[i6 + 504 >> 2] | 0);
 __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i6 + 488 | 0, HEAP32[i6 + 492 >> 2] | 0);
 __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i6 + 476 | 0, HEAP32[i6 + 480 >> 2] | 0);
 i1 = i6 + 8 | 0;
 __ZN19ConstantBuffersGLES5ClearEv(i1);
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i6 + 24 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i2);
 }
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) return;
 i1 = i6 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __ZN13RuntimeStaticI15ApplicationInfoE7DestroyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 if (!i4) {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i1 = i4 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i4 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i7;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i4 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i3);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN13GfxDeviceGLES20CreateComputeProgramEPKhj(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = i8 + 20 | 0;
 i4 = i8 + 16 | 0;
 i5 = i8 + 4 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = i2 + 4620 | 0;
 HEAP32[i3 >> 2] = __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i1, 5, i7) | 0;
 if (__ZN7ApiGLES11CheckShaderERjb(i1, i3, 0) | 0) {
  HEAP32[i4 >> 2] = __ZN7ApiGLES20CreateComputeProgramEj(i1, HEAP32[i3 >> 2] | 0) | 0;
  if (__ZN7ApiGLES12CheckProgramERj(i1, i4) | 0) {
   i1 = __Znwj(4) | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  } else {
   __Z6FormatPKcz(i5, gb + 603703 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 603515 | 0, 2088, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   __ZN7ApiGLES13DeleteProgramERj(i1, i4);
   i1 = 0;
  }
 } else {
  __ZN7ApiGLES12DeleteShaderERj(i1, i3);
  i1 = 0;
 }
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN11Rigidbody2D12MoveRotationEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 807569 | 0, 0, gb + 807613 | 0, 972, 512, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if (!(HEAP32[i2 + 92 >> 2] | 0)) return;
 i5 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + 92 >> 2] | 0;
 if (!i5) return;
 f1 = Math_fround(f1 * Math_fround(.0174532924));
 f6 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i5 + 56 >> 2]));
 f1 = Math_fround(f6 * Math_fround(+Math_atan2(+Math_fround(+Math_sin(+f1)), +Math_fround(+Math_cos(+f1)))));
 i4 = i2 + 227 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) HEAP32[i2 + 220 >> 2] = HEAP32[i5 + 72 >> 2];
 if (HEAP32[i5 >> 2] | 0) {
  i3 = i5 + 4 | 0;
  i2 = HEAP16[i3 >> 1] | 0;
  if (!(i2 & 16)) {
   if (Math_fround(f1 * f1) > Math_fround(0.0)) {
    i2 = i2 & 65535;
    if (!(i2 & 2)) {
     HEAP16[i3 >> 1] = i2 | 2;
     HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
    }
   }
   HEAPF32[i5 + 72 >> 2] = f1;
  }
 }
 HEAPF32[i5 + 136 >> 2] = Math_fround(0.0);
 HEAP8[i4 >> 0] = 1;
 return;
}

function __Z32Animator_CUSTOM_SetIntegerStringP12Il2CppObjectP12Il2CppStringi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i1 = __ZN8Animator10SetIntegerEii(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i2) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __Z23ConvertIntegerToTypePtrIsEbPvR14SafeBinaryRead(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i4 + 16 | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i5 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) i5 = 4; else {
   i1 = HEAP16[i1 >> 1] | 0;
   HEAP16[i7 >> 1] = i1;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i5 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
  i1 = HEAP16[i7 >> 1] | 0;
 }
 if (HEAP32[i4 >> 2] & 512) {
  i1 = _llvm_bswap_i16(i1 | 0) | 0;
  HEAP16[i7 >> 1] = i1;
 }
 if (i1 << 16 >> 16 == -1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i5 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1 << 16 >> 16) | 0;
 HEAP32[i6 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i8;
  return 1;
 }
 HEAP32[i6 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(HEAP16[i7 >> 1] | 0) | 0;
 STACKTOP = i8;
 return 1;
}

function __Z13FileNameNoExtRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 24 | 0;
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
 i8 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i8 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
 i8 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
 i2 = i1 + i8 | 0;
 if (i8 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i4);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipEiRNS_6memory9AllocatorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, 20, 4) | 0;
 i7 = i1 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i2 - i4 - (HEAP32[i1 + 16 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 if (!i4) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i4 * 20 | 0, 4) | 0;
  i3 = i1 + (i4 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 >> 2];
 HEAPF32[i6 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i8;
 return i6 | 0;
}

function __ZN5physx19PxsFluidSpatialHash32reorderParticlesToPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEPKNS_16PxsFluidParticleEPKjPjPt(i2, i3, i11, i1, i9, i10, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0;
 i8 = i3 + 8 | 0;
 i4 = HEAP32[i8 >> 2] & 511;
 i4 = (i4 | 0) == 0 ? 512 : i4;
 i1 = i11;
 i2 = i1 + 108 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i2 = HEAP32[i8 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) return;
 i7 = i3 + 12 | 0;
 i1 = i5;
 i6 = i4;
 i5 = 0;
 while (1) {
  if (i6 >>> 0 > i5 >>> 0) {
   i4 = i6 - i5 | 0;
   i3 = i1;
   i2 = i5;
   while (1) {
    i12 = HEAPU16[i3 >> 1] | 0;
    i5 = i11 + (i12 << 2) | 0;
    HEAP32[i10 + ((HEAP32[i5 >> 2] | 0) + (HEAP32[i11 + 108 + (i12 << 2) >> 2] | 0) - (HEAP32[i7 >> 2] | 0) << 2) >> 2] = HEAP32[i9 + (i2 << 2) >> 2];
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i3 = i3 + 2 | 0;
   }
   i1 = i1 + (i4 << 1) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i3 = i6 + 512 | 0;
  if (i3 >>> 0 > i2 >>> 0) break; else {
   i5 = i6;
   i6 = i3;
  }
 }
 return;
}

function __ZN17MemoryCacheWriter14LockCacheBlockEjPPhS1_(i7, i1, i8, i9) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i7 + 4 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i5 = i1 << 8;
 i1 = i5 + 256 | 0;
 i6 = i11 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = (i1 | 0) < (i2 | 0) ? i2 : i1;
 HEAP32[i6 >> 2] = i1;
 i2 = i11 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i4 >>> 0 < i1 >>> 0) {
  i12 = i3 << 1;
  i1 = i12 >>> 0 > i1 >>> 0 ? i12 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i11 >> 2] | 0, i1, 1, i11 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i12 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 1, i11 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i12 | 0, HEAP32[i11 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i11 >> 2] = i12;
   break;
  }
 } while (0);
 i12 = (HEAP32[HEAP32[i10 >> 2] >> 2] | 0) + i5 | 0;
 HEAP32[i8 >> 2] = i12;
 HEAP32[i9 >> 2] = i12 + 256;
 i12 = i7 + 8 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 return;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __Z29StdTemplateConversionFunctionIsyEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i4 = i4 << 16 >> 16;
  i6 = (i4 | 0) < 0;
  i6 = i6 << 31 >> 31;
  i7 = i5;
  i5 = i7;
  HEAP32[i5 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i4;
 i4 = i4 << 16 >> 16;
 i6 = (i4 | 0) < 0;
 i6 = i6 << 31 >> 31;
 i7 = i5;
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIsxEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i4 = i4 << 16 >> 16;
  i6 = (i4 | 0) < 0;
  i6 = i6 << 31 >> 31;
  i7 = i5;
  i5 = i7;
  HEAP32[i5 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i4;
 i4 = i4 << 16 >> 16;
 i6 = (i4 | 0) < 0;
 i6 = i6 << 31 >> 31;
 i7 = i5;
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i8;
 return 1;
}

function _jpeg_add_quant_table(i3, i1, i5, i6, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i7 = 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if ((i2 | 0) != 100) {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 20;
  HEAP32[i7 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i3 | 0);
 }
 if (i1 >>> 0 > 3) {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 31;
  HEAP32[i7 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i3 | 0);
 }
 i1 = i3 + 72 + (i1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = _jpeg_alloc_quant_table(i3) | 0;
  HEAP32[i1 >> 2] = i2;
 }
 if (!(i4 << 24 >> 24)) {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[i5 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) > 32767 ? 32767 : i7;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  i7 = i2 + 128 | 0;
  HEAP8[i7 >> 0] = 0;
  return;
 } else {
  i1 = 0;
  do {
   i7 = ((Math_imul(HEAP32[i5 + (i1 << 2) >> 2] | 0, i6) | 0) + 50 | 0) / 100 | 0;
   i7 = (i7 | 0) < 1 ? 1 : i7;
   HEAP16[i2 + (i1 << 1) >> 1] = (i7 | 0) < 255 ? i7 : 255;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 64);
  i7 = i2 + 128 | 0;
  HEAP8[i7 >> 0] = 0;
  return;
 }
}

function __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 20 | 0) + 1 | 0;
 if (i3 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 20 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 107374182 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 214748364;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 20 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 20 | 0) * 20 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -20 | 0) * 20 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 20;
 HEAP32[i8 >> 2] = i6 + (i4 * 20 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sq17AABBTreeUpdateMap10invalidateEjjRNS0_8AABBTreeE(i6, i4, i5, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (i1 >>> 0 > i4 >>> 0) i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0; else i3 = -1;
 if (i1 >>> 0 > i5 >>> 0) i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0; else i2 = -1;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i3 | 0) != -1) {
  i9 = HEAP32[i7 >> 2] | 0;
  i10 = i1 + (i3 * 24 | 0) + 16 | 0;
  i11 = i10;
  i12 = HEAP32[i11 >> 2] | 0;
  i11 = HEAP32[i11 + 4 >> 2] | 0;
  i8 = _bitshift64Lshr(i12 | 0, i11 | 0, 21) | 0;
  getTempRet0() | 0;
  HEAP32[i10 >> 2] = i12 & -3;
  HEAP32[i10 + 4 >> 2] = i11;
  HEAP32[i9 + ((i8 & 524287) << 2) >> 2] = -1;
  HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] = -1;
 }
 if ((i2 | 0) == -1 | (i3 | 0) == (i2 | 0)) return;
 i11 = HEAP32[i7 >> 2] | 0;
 i12 = i1 + (i2 * 24 | 0) + 16 | 0;
 i12 = _bitshift64Lshr(HEAP32[i12 >> 2] | 0, HEAP32[i12 + 4 >> 2] | 0, 21) | 0;
 getTempRet0() | 0;
 HEAP32[i11 + ((i12 & 524287) << 2) >> 2] = i4;
 i12 = HEAP32[i6 >> 2] | 0;
 HEAP32[i12 + (i4 << 2) >> 2] = i2;
 HEAP32[i12 + (i5 << 2) >> 2] = -1;
 return;
}

function __ZN27ForceModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 876 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 876 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 876 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 876 >> 2] | 0) + 801 >> 0] = f4 != Math_fround(0.0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN23LODTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i5 + 280 >> 2] | 0;
 if (!i7) {
  i7 = -1;
  return i7 | 0;
 }
 __ZN4Mesh18CheckIfBuffersLostEv(i7);
 if (HEAP8[i7 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i7);
 i6 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2) | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + (i6 * 360 | 0) + 248 >> 2] = HEAP32[i7 + 228 >> 2];
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 28 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 28;
 HEAP32[i4 + (i6 * 360 | 0) + 328 >> 2] = i2;
 __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i2, i7, 0, 0, 0, 0);
 HEAP32[i4 + (i6 * 360 | 0) + 348 >> 2] = (HEAP8[i5 + 288 >> 0] ^ 1) & 255 | 2;
 HEAP32[i4 + (i6 * 360 | 0) + 340 >> 2] = fb + 492;
 HEAP32[i4 + (i6 * 360 | 0) + 332 >> 2] = fb + 211;
 HEAP32[i4 + (i6 * 360 | 0) + 344 >> 2] = fb + 2371;
 i7 = i6;
 return i7 | 0;
}

function __ZN19RenderEventsContext16AddCommandBufferEiP22RenderingCommandBuffer(i1, i10, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = i11;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4 + (i10 * 20 | 0) | 0;
 i6 = i4 + (i10 * 20 | 0) + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i4 + (i10 * 20 | 0) + 16 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i8 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1 << 2, 4, i4 + (i10 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i4 + (i10 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i5 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 HEAP32[(HEAP32[i5 >> 2] | 0) + (i7 << 2) >> 2] = i12;
 i12 = i11 + 4 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 return;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 48 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 904242 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5 + 4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 899468 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN13ComputeShader21DispatchComputeShaderEjiii(i7, i8, i2, i3, i4) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 4 | 0;
 i5 = i9;
 if (!(__ZN13ComputeShader14BeforeDispatchEj(i7, i8) | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i10 = __Z12GetGfxDevicev() | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 828 >> 2] | 0;
 i6 = i7 + 44 | 0;
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 * 976 | 0) >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 mftCall_viiiii(i11 | 0, i10 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
 __Z15gpu_time_samplev();
 i5 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i7, 22, 0) | 0;
 i5 = (HEAP32[i5 + 24 >> 2] | 0) - (HEAP32[i5 + 20 >> 2] | 0) | 0;
 i4 = (i5 | 0) / 20 | 0;
 if (!i5) {
  i11 = 1;
  STACKTOP = i9;
  return i11 | 0;
 }
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i7 + 60 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i3 + (i8 * 976 | 0) + 4 + (i1 << 2) >> 2] | 0) > -1) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(1 << i1);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 i1 = 1;
 STACKTOP = i9;
 return i1 | 0;
}

function __Z33Random_CUSTOM_GetRandomUnitCircleP13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = __Z16GetScriptingRandv() | 0;
 i5 = HEAP32[i12 >> 2] | 0;
 i5 = i5 << 11 ^ i5;
 i10 = i12 + 4 | 0;
 i8 = HEAP32[i10 >> 2] | 0;
 i9 = i12 + 8 | 0;
 i6 = i12 + 12 | 0;
 i11 = HEAP32[i6 >> 2] | 0;
 i5 = i5 >>> 8 ^ i5 ^ i11;
 i7 = i5 ^ i11 >>> 19;
 f4 = Math_fround(Math_fround((i7 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(f4 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f4) * Math_fround(6.28318548)));
 f3 = Math_fround(+Math_cos(+f4));
 f4 = Math_fround(+Math_sin(+f4));
 i8 = i8 << 11 ^ i8;
 HEAP32[i12 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 >> 2] = i11;
 HEAP32[i9 >> 2] = i7;
 i5 = i8 >>> 8 ^ i8 ^ i7 ^ i5 >>> 19;
 HEAP32[i6 >> 2] = i5;
 f2 = Math_fround(Math_fround((i5 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(f2 * Math_fround(0.0)) + Math_fround(Math_fround(1.0) - f2))));
 f3 = Math_fround(f3 * f2);
 f3 = Math_fround(f3);
 f2 = Math_fround(f4 * f2);
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i1 + 4 >> 2] = f2;
 return;
}

function __Z31Texture2DArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii(i5, i4, i6, i7) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i1 = i8 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i9 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 if (!(HEAP8[i2 + 109 >> 0] | 0)) {
  i9 = __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN14Texture2DArray9SetPixelsEiPK10ColorRGBAfii(i2, i3, i1, i6, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i4 = i2 + -84 | 0;
   HEAP32[i5 >> 2] = i4;
   i3 = i2 + -44 | 0;
   if ((HEAP32[i2 + -28 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -40 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -64 | 0;
   if ((HEAP32[i2 + -48 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -60 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   if ((HEAP32[i2 + -68 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -80 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 73;
 HEAP32[i7 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i8;
 return;
}

function __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fEiii(i4, i3, i1, i2, i15) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 var i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0, f14 = f0, f16 = f0, i17 = 0, i18 = 0, f19 = f0;
 f16 = Math_fround(HEAPF32[i4 + 88 >> 2]);
 f14 = Math_fround(HEAPF32[i4 + 92 >> 2]);
 f12 = Math_fround(HEAPF32[i4 + 96 >> 2]);
 f13 = Math_fround(1 << i15 | 0);
 f14 = Math_fround(f14 / Math_fround(32766.0));
 i11 = i1 << 4;
 i9 = i2 << 4;
 i10 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i4 + 76 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = 0;
 do {
  i1 = i2 + i11 | 0;
  i4 = Math_imul(i8, i1) | 0;
  i5 = i2 * 17 | 0;
  f6 = Math_fround(f13 * Math_fround(f16 * Math_fround(i1 | 0)));
  i1 = 0;
  do {
   i18 = i1 + i9 | 0;
   f19 = Math_fround(f14 * Math_fround(HEAP16[i3 + (i4 + i18 << i15 << 1) >> 1] | 0));
   i17 = i10 + (Math_imul(i1 + i5 | 0, i7) | 0) | 0;
   HEAPF32[i17 >> 2] = f6;
   HEAPF32[i17 + 4 >> 2] = f19;
   HEAPF32[i17 + 8 >> 2] = Math_fround(f13 * Math_fround(f12 * Math_fround(i18 | 0)));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 17);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 17);
 return;
}

function __ZN20SoundChannelInstance19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 if (i2 | 0) {
  i6 = i1 + 128 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 }
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i1 = __ZN4FMOD7Channel19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i1, i2) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i6 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 313;
 HEAP32[i4 + 8 >> 2] = gb + 866045;
 HEAP32[i4 + 12 >> 2] = i6;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i6 = i1;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN19VREyeTextureManager22CreateEyeTextureStagesEjbi(i7, i8, i1, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i9 = __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i7, i8, 0, i9, 0, i7 + 16 | 0) | 0;
  return i9 | 0;
 }
 i6 = i7 + 64 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i7 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i2 = (i4 - i3 | 0) / 20 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj(i7, i1 - i2 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i2 >>> 0) {
  i2 = i3 + (i1 * 20 | 0) | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i5 >> 2] = i4 + (~(((i4 + -20 - i2 | 0) >>> 0) / 20 | 0) * 20 | 0);
 }
 if ((i1 | 0) <= 0) {
  i9 = 1;
  return i9 | 0;
 }
 i3 = 1;
 i4 = 0;
 i2 = i1;
 while (1) {
  if (!(i3 << 24 >> 24)) i1 = 0; else {
   i1 = __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE(i7, i8, 1, i9, i4, (HEAP32[i7 >> 2] | 0) + (i4 * 20 | 0) | 0) | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (i2 | 0)) break; else i3 = i1 & 1;
 }
 return i1 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN16b2PrismaticJoint11EnableMotorEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 137 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 137 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 137 | 0;
 i5 = i5 & 1;
 HEAP8[i4 >> 0] = i5;
 return;
}

function __ZN13SparseTextureC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 76 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 45096 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 1;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 5;
 HEAP8[i1 + 100 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __Z28StartCreateTextureFromBufferPKhjb(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i7 = i6;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 404765 | 0, 224) | 0;
 i10 = gb + 63520 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i4, i1, 1);
 __Z19pop_allocation_rootv();
 i4 = __ZN6Object24CalculateCachedTypeIndexEPS_(i4) | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0);
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (__ZL35LoadMemoryBufferIntoTextureInternalR9Texture2DPKhj20LoadImageCompressionb(i4, i2, i3, (i1 + -10 | 0) >>> 0 < 3 ? 2 : 0, i5) | 0) {
  i10 = i4;
  STACKTOP = i6;
  return i10 | 0;
 }
 __Z19DestroySingleObjectP6Object(i4);
 i10 = 0;
 STACKTOP = i6;
 return i10 | 0;
}

function __Z23ConvertIntegerToTypePtrItEbPvR14SafeBinaryRead(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i4 + 16 | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i5 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) i5 = 4; else {
   i1 = HEAP16[i1 >> 1] | 0;
   HEAP16[i7 >> 1] = i1;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i5 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
  i1 = HEAP16[i7 >> 1] | 0;
 }
 if (HEAP32[i4 >> 2] & 512) {
  i1 = _llvm_bswap_i16(i1 | 0) | 0;
  HEAP16[i7 >> 1] = i1;
 }
 if (i1 << 16 >> 16 == -1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i5 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1 & 65535) | 0;
 HEAP32[i6 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i8;
  return 1;
 }
 HEAP32[i6 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(HEAPU16[i7 >> 1] | 0) | 0;
 STACKTOP = i8;
 return 1;
}

function _fstatvfs(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i4 = i7 + 16 | 0;
 i5 = i4;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = 64;
 HEAP32[i2 + 8 >> 2] = i4;
 if ((___syscall_ret(___syscall269(269, i2 | 0) | 0) | 0) < 0) i1 = -1; else {
  i1 = i3 + 4 | 0;
  i2 = i4 + 4 | 0;
  i5 = i1 + 20 | 0;
  i6 = i5 + 48 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i5;
  i6 = HEAP32[i4 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = (i6 | 0) == 0 ? i5 : i6;
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i1 = HEAP32[i4 + 24 >> 2] | 0;
  HEAP32[i3 + 24 >> 2] = i1;
  HEAP32[i3 + 28 >> 2] = i1;
  HEAP32[i3 + 32 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 44 >> 2];
  HEAP32[i3 + 44 >> 2] = HEAP32[i4 + 36 >> 2];
  i1 = 0;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i5, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, HEAP32[i7 + 4 >> 2] | 0);
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + (i4 * 24 | 0) | 0;
 if (i4 | 0) {
  i4 = i8 + 20 | 0;
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = gb + 1034188;
   __ZN17AnimationCurveTplIfE8TransferI8JSONReadEEvRT_(i1, i8);
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 88 | 0;
  }
 }
 HEAP32[i6 >> 2] = i7;
 return;
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 32 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 36 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __ZN15b2RevoluteJoint11EnableMotorEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 100 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 100 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 100 | 0;
 i5 = i5 & 1;
 HEAP8[i4 >> 0] = i5;
 return;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 96 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 100 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __Z55SceneManager_CUSTOM_INTERNAL_CALL_MoveGameObjectToSceneP12Il2CppObjectRKi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i3 = __Z15GetSceneManagerv() | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 if (!i3) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562158 | 0, i5);
 if (!(HEAP32[i3 + 80 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562075 | 0, i5 + 8 | 0);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562189 | 0, i4);
 if (!(HEAP32[i1 + 100 >> 2] | 0)) {
  __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i1, 1);
  __ZN10UnityScene14AddRootToSceneERS_R9Transform(i3, i1);
  STACKTOP = i5;
  return;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562189 | 0, i4);
}

function _statvfs(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i4 = i7 + 16 | 0;
 i5 = i4;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = 64;
 HEAP32[i2 + 8 >> 2] = i4;
 if ((___syscall_ret(___syscall268(268, i2 | 0) | 0) | 0) < 0) i1 = -1; else {
  i1 = i3 + 4 | 0;
  i2 = i4 + 4 | 0;
  i5 = i1 + 20 | 0;
  i6 = i5 + 48 | 0;
  do {
   HEAP32[i5 >> 2] = 0;
   i5 = i5 + 4 | 0;
  } while ((i5 | 0) < (i6 | 0));
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i5;
  i6 = HEAP32[i4 + 40 >> 2] | 0;
  HEAP32[i1 >> 2] = (i6 | 0) == 0 ? i5 : i6;
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i1 = HEAP32[i4 + 24 >> 2] | 0;
  HEAP32[i3 + 24 >> 2] = i1;
  HEAP32[i3 + 28 >> 2] = i1;
  HEAP32[i3 + 32 >> 2] = HEAP32[i4 + 28 >> 2];
  HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 44 >> 2];
  HEAP32[i3 + 44 >> 2] = HEAP32[i4 + 36 >> 2];
  i1 = 0;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx2Sc5Scene13addConstraintERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_(i8, i7, i4, i5) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i2 = HEAP32[i8 + 1224 >> 2] | 0;
 i3 = i2 + 292 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i2 + 280 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i2 + 284 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (i1 | 0) __ZN5physx2Sc13ConstraintSimC2ERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_RNS0_5SceneE(i1, i7, i4, i5, i8);
 i1 = i8 + 84 | 0;
 HEAP32[i6 >> 2] = i7;
 i2 = i8 + 88 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i8 + 92 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i7;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i9;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i6) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z23CleanupDeveloperConsolev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 36280 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 35512 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 324 | 0)) {
    i4 = i6 + 35512 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 35512 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 35512 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 35512 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 35512 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 35512 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 35512 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 35512 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = HEAP32[gb + 1468316 >> 2] | 0;
 HEAP32[gb + 1468316 >> 2] = 0;
 if (!i1) return;
 __ZN16DeveloperConsoleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i4, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[i4 + 20 >> 2] | 0;
 i8 = i1 + 20 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i9 = i4 + 4 | 0;
 i5 = i4 + 12 | 0;
 i2 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i2 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i2) >> 2] | 0) | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = (i1 | 0) != 0;
 if (i3) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i7, i1);
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, HEAP32[i7 + 36 >> 2] | 0) | 0;
 i1 = (HEAP8[i7 + 40 >> 0] | 0) == 0 ? i2 : i1;
 if (i3) __ZN17RemapPPtrTransfer11PopMetaFlagEv(i7);
 i7 = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(i1, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0) | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[(HEAP32[i9 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i8 + -8 + (HEAP32[i5 >> 2] | 0) | 0 : i8) >> 2] = i7;
 return;
}

function _UNITY_png_handle_pHYs(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 204 >> 2] | 0;
 if (!(i5 & 1)) _UNITY_png_chunk_error(i1, gb + 352205 | 0);
 if (i5 & 4 | 0) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352423 | 0);
  STACKTOP = i6;
  return;
 }
 if (i2 | 0) if (HEAP32[i2 + 8 >> 2] & 128 | 0) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352436 | 0);
  STACKTOP = i6;
  return;
 }
 if ((i3 | 0) != 9) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352446 | 0);
  STACKTOP = i6;
  return;
 }
 _UNITY_png_read_data(i1, i4, 9);
 _UNITY_png_calculate_crc(i1, i4, 9);
 if (_UNITY_png_crc_finish(i1, 0) | 0) {
  STACKTOP = i6;
  return;
 }
 _UNITY_png_set_pHYs(i1, i2, (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0), (HEAPU8[i4 + 5 >> 0] | 0) << 16 | (HEAPU8[i4 + 4 >> 0] | 0) << 24 | (HEAPU8[i4 + 6 >> 0] | 0) << 8 | (HEAPU8[i4 + 7 >> 0] | 0), HEAPU8[i4 + 8 >> 0] | 0);
 STACKTOP = i6;
 return;
}

function _UNITY_png_handle_oFFs(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 204 >> 2] | 0;
 if (!(i5 & 1)) _UNITY_png_chunk_error(i1, gb + 352205 | 0);
 if (i5 & 4 | 0) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352423 | 0);
  STACKTOP = i6;
  return;
 }
 if (i2 | 0) if (HEAP32[i2 + 8 >> 2] & 256 | 0) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352436 | 0);
  STACKTOP = i6;
  return;
 }
 if ((i3 | 0) != 9) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352446 | 0);
  STACKTOP = i6;
  return;
 }
 _UNITY_png_read_data(i1, i4, 9);
 _UNITY_png_calculate_crc(i1, i4, 9);
 if (_UNITY_png_crc_finish(i1, 0) | 0) {
  STACKTOP = i6;
  return;
 }
 _UNITY_png_set_oFFs(i1, i2, (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0), (HEAPU8[i4 + 5 >> 0] | 0) << 16 | (HEAPU8[i4 + 4 >> 0] | 0) << 24 | (HEAPU8[i4 + 6 >> 0] | 0) << 8 | (HEAPU8[i4 + 7 >> 0] | 0), HEAPU8[i4 + 8 >> 0] | 0);
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab9IntShader27RemoveUnsupportedSubShadersEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = i7 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = (HEAP32[i8 >> 2] | 0) - i2 >> 2;
 if (!i1) return;
 i11 = i7 + 96 | 0;
 i12 = i7 + 16 | 0;
 i9 = i7 + 20 | 0;
 i10 = i7 + 12 | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  if (!(__ZN9ShaderLab9SubShader20IsSubShaderSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(HEAP32[i2 + (i1 << 2) >> 2] | 0, i11) | 0)) {
   i6 = (HEAP32[i7 >> 2] | 0) + (i1 << 2) | 0;
   i2 = HEAP32[i12 >> 2] | 0;
   if ((i2 | 0) == (HEAP32[i9 >> 2] | 0)) __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i10, i6); else {
    HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
    HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 4;
   }
   i2 = i6 + 4 | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   i4 = i3 - i2 | 0;
   i5 = i4 >> 2;
   if (i5) {
    _memmove(i6 | 0, i2 | 0, i4 | 0) | 0;
    i3 = HEAP32[i8 >> 2] | 0;
   }
   i2 = i6 + (i5 << 2) | 0;
   if ((i3 | 0) != (i2 | 0)) HEAP32[i8 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  }
  if (!i1) break;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 return;
}

function __ZN6prcoreL31inner_stretch_argb4444_bilinearEPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = (HEAP32[i3 + 24 >> 2] | 0) >>> 12;
 i7 = 16 - i6 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i13 = i1 >>> 16;
  i12 = i1 >>> 12 & 15;
  i3 = 16 - i12 | 0;
  i11 = (HEAPU16[i8 + (i13 << 1) >> 1] | 0) << 16 | (HEAPU16[i9 + (i13 << 1) >> 1] | 0);
  i13 = i13 + 1 | 0;
  i13 = (HEAPU16[i8 + (i13 << 1) >> 1] | 0) << 16 | (HEAPU16[i9 + (i13 << 1) >> 1] | 0);
  i10 = (Math_imul(i13 >>> 4 & 252645135, i12) | 0) + (Math_imul(i11 >>> 4 & 252645135, i3) | 0) | 0;
  i3 = (Math_imul(i13 & 252645135, i12) | 0) + (Math_imul(i11 & 252645135, i3) | 0) | 0;
  HEAP16[i4 >> 1] = (Math_imul(i10 >>> 20 & 3855, i7) | 0) + (Math_imul(i10 >>> 4 & 3855, i6) | 0) & 61680 | ((Math_imul(i3 >>> 20 & 3855, i7) | 0) + (Math_imul(i3 >>> 4 & 3855, i6) | 0) | 0) >>> 4 & 3855;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i5 + i1 | 0;
  }
 }
 return;
}

function __ZN5physx3Scb13ObjectTracker5clearEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i10 + 36 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) return; else i7 = 0;
 do {
  i3 = i8 + (i7 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = i4 + 4 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i2 = i6 & 268435455;
  if (((i6 >>> 30) + -1 | 0) >>> 0 < 2) HEAP32[i5 >> 2] = i2 | -2147483648; else {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = 0;
  }
  if (i6 & 536870912) {
   __ZN5physx9NpDestroyERNS_3Scb4BaseE(HEAP32[i3 >> 2] | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  i7 = i7 + 1 | 0;
 } while (i7 >>> 0 < i1 >>> 0);
 i2 = HEAP32[i10 + 20 >> 2] | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 _memset(HEAP32[i10 + 12 >> 2] | 0, -1, i2 << 2 | 0) | 0;
 i6 = i10 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2 + -1 | 0;
 i4 = i10 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i5) {
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + (i3 << 2) >> 2] = i2;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
 HEAP32[i10 + 28 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 return;
}

function __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 48 | 0;
 i8 = i5 + 32 | 0;
 i6 = i5;
 i9 = i2 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 __ZN5physx12_GLOBAL__N_122getImpulseResponseSimdERKNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES6_(i6, i4, i3, i8, i7);
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i4 = i1 + 16 | 0;
 i3 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN5physx15PxsParticleData6createEjb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = (i1 + 31 | 0) >>> 5;
 i4 = i7 << 2;
 i6 = i4 + 15 & 1073741808;
 i5 = i1 << 5;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i8 = _PxGetFoundation() | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 24 >> 2] | 0, i8 | 0) | 0;
 i8 = mftCall_iiiiii(i9 | 0, i3 | 0, i5 + 99 + (i2 ? i1 << 2 : 0) + i6 | 0, (i8 ? gb + 698983 | 0 : gb + 837976 | 0) | 0, gb + 699101 | 0, 226) | 0;
 i3 = i8 + 19 & -16;
 HEAP32[i3 + -4 >> 2] = i3 - i8;
 HEAP32[i3 >> 2] = gb + 96500 + 8;
 HEAP8[i3 + 4 >> 0] = 1;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP8[i3 + 12 >> 0] = i2 & 1;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 2122317823;
 HEAP32[i3 + 28 >> 2] = 2122317823;
 HEAP32[i3 + 32 >> 2] = 2122317823;
 HEAP32[i3 + 36 >> 2] = -25165825;
 HEAP32[i3 + 40 >> 2] = -25165825;
 HEAP32[i3 + 44 >> 2] = -25165825;
 i1 = i3 + 80 | 0;
 HEAP32[i3 + 56 >> 2] = i1;
 HEAP32[i3 + 60 >> 2] = i7 | -2147483648;
 HEAP32[i3 + 48 >> 2] = i1 + i6;
 HEAP32[i3 + 52 >> 2] = i2 ? i1 + (i6 + i5) | 0 : 0;
 _memset(i1 | 0, 0, i4 | 0) | 0;
 return i3 | 0;
}

function __ZN34ColorBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 do switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 152 >> 0] | 0);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 153 >> 0] | 0);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 154 >> 0] | 0);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 155 >> 0] | 0);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 156 >> 0] | 0);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 157 >> 0] | 0);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 158 >> 0] | 0);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 900 >> 2] | 0) + 159 >> 0] | 0);
   break;
  }
 case 8:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 900 >> 2] | 0) + 164 >> 2]);
   break;
  }
 case 9:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 900 >> 2] | 0) + 168 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 } while (0);
 return Math_fround(f1);
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 if (!i6) return;
 i8 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   if (i4 | 0) __ZN6Object11RemoveEventEPFvPvS0_iES0_(i4, fb + 914 | 0, i6);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = i6 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 20 | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 * 12 | 0) >> 2] | 0;
   if (i2) {
    __ZN6Object11RemoveEventEPFvPvS0_iES0_(i2, fb + 914 | 0, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, HEAP32[i4 >> 2] | 0);
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i6 + 24 >> 2] | 0, i7);
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0, i6 | 0);
 return;
}

function __Z46UnityWebRequest_CUSTOM_InternalSetCustomMethodP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7;
 i4 = i7 + 32 | 0;
 i5 = i7 + 20 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = i2 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031092 | 0, i7 + 8 | 0);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 if ((HEAP32[i1 >> 2] | 0) == 1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 92 | 0, i5) | 0;
  HEAP32[i2 + 88 >> 2] = 4;
  i1 = 0;
 } else i1 = 31;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!i1) {
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i6 >> 2] = __Z17GetWebErrorString8WebError(i1) | 0;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i6);
 }
}

function _UNITY_tt_face_free_ps_names(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 100 >> 2] | 0;
 i6 = i2 + 612 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  HEAP8[i6 >> 0] = 0;
  return;
 }
 i1 = HEAP32[i2 + 468 >> 2] | 0;
 if ((i1 | 0) >= 163840) {
  switch (i1 | 0) {
  case 163840:
   break;
  default:
   {
    HEAP8[i6 >> 0] = 0;
    return;
   }
  }
  i4 = i2 + 620 | 0;
  _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  HEAP16[i2 + 616 >> 1] = 0;
  HEAP8[i6 >> 0] = 0;
  return;
 }
 switch (i1 | 0) {
 case 131072:
  break;
 default:
  {
   HEAP8[i6 >> 0] = 0;
   return;
  }
 }
 i4 = i2 + 620 | 0;
 _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP16[i2 + 616 >> 1] = 0;
 i4 = i2 + 618 | 0;
 i3 = i2 + 624 | 0;
 if (HEAP16[i4 >> 1] | 0) {
  i2 = 0;
  i1 = 0;
  while (1) {
   _UNITY_ft_mem_free(i5, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i2 + 1 << 16 >> 16;
   if ((i1 & 65535) < (HEAPU16[i4 >> 1] | 0)) {
    i2 = i1;
    i1 = i1 & 65535;
   } else break;
  }
 }
 _UNITY_ft_mem_free(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP16[i4 >> 1] = 0;
 HEAP8[i6 >> 0] = 0;
 return;
}

function __ZNK5physx5cloth11SwClothData9reconcileERNS0_7SwClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i4 = i2 + 12 | 0;
 i7 = i1 + 32 | 0;
 i3 = i1 + 44 | 0;
 i6 = i2 + 24 | 0;
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 i4 = i2 + 28 | 0;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = i2 + 16 | 0;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i6 >> 2])) * Math_fround(.5));
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2])) * Math_fround(.5));
 i6 = i2 + 32 | 0;
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 i4 = i2 + 20 | 0;
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i3 + 8 >> 2] = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i4 >> 2])) * Math_fround(.5));
 HEAP32[i1 + 528 >> 2] = HEAP32[i2 + 248 >> 2];
 HEAP32[i1 + 524 >> 2] = HEAP32[i2 + 244 >> 2];
 return;
}

function __ZN8JSONRead8TransferIN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfigEEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1037433;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1037451 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1037470 | 0, 0, 0);
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 8 | 0, gb + 1037487 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx22PxDefaultErrorCallback11reportErrorENS_11PxErrorCode4EnumEPKcS4_i(i1, i5, i8, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i4 + 16 | 0;
 switch (i5 | 0) {
 case 0:
  {
   i2 = gb + 661570 | 0;
   break;
  }
 case 4:
  {
   i2 = gb + 661552 | 0;
   break;
  }
 case 8:
  {
   i2 = gb + 661534 | 0;
   break;
  }
 case 16:
  {
   i2 = gb + 661520 | 0;
   break;
  }
 case 1:
  {
   i2 = gb + 661515 | 0;
   break;
  }
 case 2:
  {
   i2 = gb + 661507 | 0;
   break;
  }
 case 128:
  {
   i2 = gb + 661487 | 0;
   break;
  }
 case 64:
  {
   i2 = gb + 661481 | 0;
   break;
  }
 case 32:
  {
   i2 = gb + 661466 | 0;
   break;
  }
 default:
  i2 = gb + 661452 | 0;
 }
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 12 >> 2] = i8;
 __ZN5physx6string9sprintf_sEPcjPKcz(i1, 1024, gb + 661579 | 0, i3) | 0;
 __ZN5physx6shdfnd11printStringEPKc(i1);
 if ((i5 | 0) == 64) while (1) {
  __ZN5physx6shdfnd11printStringEPKc(i1);
  __ZN5physx6shdfnd10ThreadImpl5sleepEj(1e3);
 } else {
  STACKTOP = i4;
  return;
 }
}

function __ZN4Mesh18SwapBlendShapeDataER14BlendShapeData(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i5 + 32 | 0;
 if ((HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0) != 1) {
  i4 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
  __ZN14SharedMeshDataC2ERKS_(i4, HEAP32[i3 >> 2] | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i8 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  if (!(HEAP32[i8 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
  }
  HEAP32[i3 >> 2] = i4;
 }
 __ZN14BlendShapeDataaSERKS_(i5 + 72 | 0, i1) | 0;
 HEAP32[i6 >> 2] = gb + 30832;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = i5;
 i2 = HEAP32[i5 + 236 >> 2] | 0;
 i3 = i5 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i7;
  return;
 }
 do {
  i8 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i8 + 8 >> 2] | 0, gb + 1105196 | 0, i6);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i7;
 return;
}

function __ZN15LODGroupManagerD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i7 + 36 | 0;
 i3 = i7 + 48 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = i7 + 40 | 0;
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i4 | 0) {
    i5 = i4 + 36 | 0;
    if ((HEAP32[i4 + 52 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 40 | 0);
     HEAP32[i5 >> 2] = 0;
    }
    if ((HEAP32[i4 + 32 >> 2] | 0) > -1) {
     i5 = i4 + 16 | 0;
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 20 | 0);
     HEAP32[i5 >> 2] = 0;
    }
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 __ZN17UniqueIDGenerator16DestroyPureIndexEj(gb + 1161220 | 0, (HEAP32[i7 >> 2] | 0) + 1 | 0);
 if ((HEAP32[i7 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i7 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i7 + 4 | 0;
 if ((HEAP32[i7 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 164 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __ZN12b2WheelJoint11EnableMotorEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 128 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 128 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 128 | 0;
 i5 = i5 & 1;
 HEAP8[i4 >> 0] = i5;
 return;
}

function __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 1 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 2 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 3 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  return;
 }
}

function _BF_set_key(i11, i12, i13, i1) {
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i15;
 i10 = i1 & 255;
 i8 = i10 << 15;
 i9 = i14 + 4 | 0;
 i10 = i14 + ((i10 & 1) << 2) | 0;
 i2 = 0;
 i1 = i11;
 i6 = 0;
 i7 = 0;
 do {
  HEAP32[i9 >> 2] = 0;
  HEAP32[i14 >> 2] = 0;
  i5 = 0;
  i3 = 0;
  i4 = 0;
  do {
   i17 = i3 << 8;
   HEAP32[i14 >> 2] = i17;
   i3 = HEAPU8[i1 >> 0] | i17;
   HEAP32[i14 >> 2] = i3;
   i17 = i4 << 8;
   HEAP32[i9 >> 2] = i17;
   i16 = HEAP8[i1 >> 0] | 0;
   i4 = i16 | i17;
   HEAP32[i9 >> 2] = i4;
   i2 = ((i5 | 0) == 0 ? 0 : i16 & 128) | i2;
   i1 = (HEAP8[i1 >> 0] | 0) == 0 ? i11 : i1 + 1 | 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != 4);
  i7 = i4 ^ i3 | i7;
  i17 = HEAP32[i10 >> 2] | 0;
  HEAP32[i12 + (i6 << 2) >> 2] = i17;
  HEAP32[i13 + (i6 << 2) >> 2] = HEAP32[gb + 199012 + (i6 << 2) >> 2] ^ i17;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != 18);
 HEAP32[i13 >> 2] = HEAP32[i13 >> 2] ^ i8 & 65536 & i2 << 9 & -65536 - (i7 & 65535 | i7 >>> 16);
 STACKTOP = i15;
 return;
}

function __ZN5physx18PxcSkipNarrowPhaseERNS_13PxcNpWorkUnitE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 98 | 0;
 HEAP16[i3 >> 1] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP16[i1 + 20 >> 1] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP16[i1 + 56 >> 1] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 i1 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  i2 = i2 & 65535;
  i2 = i2 & 65531;
  i2 = i2 & 65535;
  HEAP16[i3 >> 1] = i2;
  return;
 }
 if (!(i2 & 1)) {
  i1 = i2;
  HEAP8[i1 + 33 >> 0] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP32[i1 + 16 >> 2] = 2139095039;
  HEAP32[i1 + 20 >> 2] = 2139095039;
  HEAP32[i1 + 24 >> 2] = 2139095039;
  HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 1065353216;
  i2 = HEAP16[i3 >> 1] | 0;
  i2 = i2 & 65535;
  i2 = i2 & 65531;
  i2 = i2 & 65535;
  HEAP16[i3 >> 1] = i2;
  return;
 } else {
  HEAP32[i1 >> 2] = 1;
  i2 = 0;
  i2 = i2 & 65535;
  i2 = i2 & 65531;
  i2 = i2 & 65535;
  HEAP16[i3 >> 1] = i2;
  return;
 }
}

function __ZN18DelayedCallManager18CancelCallDelayed2E4PPtrI6ObjectEPF15CallObjectStatePS1_PvES7_(i6, i7, i8, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i12 + 4 | 0;
 i10 = i12;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i11 = i6 + 32 | 0;
 i2 = i1;
 if ((i2 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 i4 = i2;
 while (1) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   }
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  i3 = i4 + 16 | 0;
  if ((HEAP32[i4 + 48 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
   i4 = HEAP32[i4 + 40 >> 2] | 0;
   if ((i4 | 0) == (i8 | 0) | (i4 | 0) == (i9 | 0)) {
    HEAP32[i10 >> 2] = i1;
    HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
    __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i6, i3, i5);
   }
  }
  i1 = i2;
  if ((i2 | 0) == (i11 | 0)) break; else i4 = i2;
 }
 STACKTOP = i12;
 return;
}

function __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i1 | 0) >= (i4 | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) {
  STACKTOP = i8;
  return i1 | 0;
 }
 if ((i1 | 0) <= -1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZNK19ShaderPropertySheet13GetFloatArrayEi(i6, i3, i1);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
 i6 = (i2 | 0) == 0 ? 0 : i1;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(i7, 4, i6) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 4) | 0, i2 | 0, i6 << 2 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 200 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) >> 2]);
 f7 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i9 + (i1 * 12 | 0) + 8 >> 2]);
 f6 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 96 >> 2]));
 f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 112 >> 2])));
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 128 >> 2])));
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 100 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 116 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 132 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 104 >> 2]));
 f7 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 120 >> 2])));
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 136 >> 2])));
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f4;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx3Cct10Controller6setPosERKNS_14PxExtendedVec3E(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i5 + 408 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i1 = i5 + 400 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i6;
  return 1;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i2 | 0);
 f9 = Math_fround(+HEAPF64[i3 >> 3]);
 f8 = Math_fround(+HEAPF64[i5 + 416 >> 3]);
 f7 = Math_fround(+HEAPF64[i5 + 424 >> 3]);
 HEAPF32[i4 + 16 >> 2] = f9;
 HEAPF32[i4 + 20 >> 2] = f8;
 HEAPF32[i4 + 24 >> 2] = f7;
 HEAP32[i4 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 24 >> 2];
 i5 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, i4 | 0);
 STACKTOP = i6;
 return 1;
}

function __ZN5physx2Sc5Scene16scheduleClothGpuERNS_10PxBaseTaskE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 160 | 0;
 i4 = i6 + 156 | 0;
 i5 = i6 + 172 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0)) {
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 180 >> 2] = mftCall_iifi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, +Math_fround(HEAPF32[i6 + 64 >> 2]), i2 | 0) | 0;
  STACKTOP = i7;
  return;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 680241 | 0, 887, gb + 719208 | 0, i7);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0, 1, 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 180 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN19ConstantBuffersGLES13UpdateBuffersEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i7 + 12 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i6 = (HEAP32[i7 + 16 >> 2] | 0) - i2 | 0;
 i9 = (i6 | 0) / 12 | 0;
 if ((i6 | 0) <= 0) return;
 i1 = 0;
 while (1) {
  i6 = i2 + (i1 * 12 | 0) + 10 | 0;
  if (HEAP8[i6 >> 0] | 0) {
   i5 = (HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0) >>> 16;
   i4 = i2 + (i1 * 12 | 0) + 4 | 0;
   i10 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(HEAP32[i4 >> 2] | 0) | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i10) {
    __ZN14DataBufferGLES7ReleaseEv(i3);
    i3 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, i5, 8, 0) | 0;
    HEAP32[i4 >> 2] = i3;
   }
   __ZN14DataBufferGLES6UploadEiiPKv(i3, 0, i5, HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0);
  }
  i3 = HEAP16[i2 + (i1 * 12 | 0) + 8 >> 1] | 0;
  if (i3 << 16 >> 16 > -1) __ZN7ApiGLES17BindUniformBufferEjj(HEAP32[gb + 1451080 >> 2] | 0, i3 << 16 >> 16, HEAP32[(HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) + 4 >> 2] | 0);
  HEAP8[i6 >> 0] = 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i9 | 0)) break;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 return;
}

function __ZN15DirectorManager16PrepareFrameFuncEP11DirectorJobj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 i5 = i1 + (i2 * 24 | 0) | 0;
 i6 = i1 + (i2 * 24 | 0) + 12 | 0;
 __ZN18PlayableController12PrepareFrameEP8PlayableRy(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, i4);
 i3 = i1 + (i2 * 24 | 0) + 16 | 0;
 i9 = i3;
 i8 = i4;
 if ((HEAP32[i9 >> 2] | 0) == (HEAP32[i8 >> 2] | 0) ? (HEAP32[i9 + 4 >> 2] | 0) == (HEAP32[i8 + 4 >> 2] | 0) : 0) {
  STACKTOP = i7;
  return;
 }
 i9 = (__ZN18PlayableController12GetFrameDataEv(HEAP32[i5 >> 2] | 0) | 0) + 64 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 1;
 i9 = HEAP32[i1 + (i2 * 24 | 0) + 4 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 144 >> 2] | 0;
 i8 = __ZN18PlayableController12GetFrameDataEv(HEAP32[i5 >> 2] | 0) | 0;
 mftCall_viiii(i10 | 0, i9 | 0, i8 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i1 + (i2 * 24 | 0) + 8 >> 2] | 0);
 i6 = i4;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 STACKTOP = i7;
 return;
}

function __ZN14NavMeshCarving14RemoveObstacleERi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i10 + (i9 * 120 | 0) + 112 >> 2] = 0;
 __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_(i2 + 48 | 0, i10 + (i9 * 120 | 0) + 88 | 0);
 i9 = i2 + 28 | 0;
 i10 = i2 + 40 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 44 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i1 << 2, 4, i2 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = -1;
 return;
}

function __ZL33GeomMTDCallback_ConvexHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i5, i4, i1, i6, i2, i7) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 4240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i8 + 4176 | 0;
 i11 = i8 + 4120 | 0;
 i9 = i8 + 4116 | 0;
 i3 = i8;
 i10 = i8 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i1);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i9 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i6, i7, i10, i9, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i5, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 i12 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i8;
 return i12 | 0;
}

function __Z39Random_CUSTOM_INTERNAL_get_onUnitSphereP8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = __Z16GetScriptingRandv() | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i6 = i6 << 11 ^ i6;
 i11 = i13 + 4 | 0;
 i9 = HEAP32[i11 >> 2] | 0;
 i10 = i13 + 8 | 0;
 i7 = i13 + 12 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 i6 = i6 >>> 8 ^ i6 ^ i12;
 i8 = i6 ^ i12 >>> 19;
 f2 = Math_fround(Math_fround((i8 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f2 = Math_fround(Math_fround(Math_fround(1.0) - f2) - f2);
 i9 = i9 << 11 ^ i9;
 HEAP32[i13 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i11 >> 2] = i12;
 HEAP32[i10 >> 2] = i8;
 i6 = i9 >>> 8 ^ i9 ^ i8 ^ i6 >>> 19;
 HEAP32[i7 >> 2] = i6;
 f4 = Math_fround(Math_fround((i6 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f4 = Math_fround(Math_fround(f4 * Math_fround(0.0)) + Math_fround(Math_fround(Math_fround(1.0) - f4) * Math_fround(6.28318548)));
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(1.0) - Math_fround(f2 * f2))));
 f3 = Math_fround(f5 * Math_fround(+Math_sin(+f4)));
 HEAPF32[i1 >> 2] = Math_fround(f5 * Math_fround(+Math_cos(+f4)));
 HEAPF32[i1 + 4 >> 2] = f3;
 HEAPF32[i1 + 8 >> 2] = f2;
 return;
}

function __Z20ComputeTransformTypeRK10Matrix4x4ff(i1, f5) {
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var f2 = f0, f3 = f0, f4 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f2 * f2)) + Math_fround(f3 * f3));
 f2 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(f2 * f2) + Math_fround(f7 * f7)) + Math_fround(f6 * f6));
 f7 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f4 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f2 * f2)) + Math_fround(f4 * f4));
 f2 = f6 < f3 ? f6 : f3;
 f2 = f4 < f2 ? f4 : f2;
 f3 = f3 < f6 ? f6 : f3;
 f3 = f3 < f4 ? f4 : f3;
 f4 = Math_fround(f5 + Math_fround(1.0));
 if (!(f2 < Math_fround(Math_fround(1.0) - f5) | f3 > f4)) {
  i1 = 0;
  return i1 | 0;
 }
 if (f2 != Math_fround(0.0)) if (Math_fround(Math_fround(Math_sqrt(Math_fround(f3))) / Math_fround(Math_sqrt(Math_fround(f2)))) < f4) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = 2;
 return i1 | 0;
}

function __ZNSt3__214__split_bufferI14HeightMeshDataR13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i3 = i1 + -84 | 0;
  HEAP32[i5 >> 2] = i3;
  i2 = i1 + -44 | 0;
  if ((HEAP32[i1 + -28 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -40 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -64 | 0;
  if ((HEAP32[i1 + -48 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -60 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  if ((HEAP32[i1 + -68 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + -80 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i6 = HEAP32[HEAP32[i6 + 16 >> 2] >> 2] | 0;
 HEAP32[i7 >> 2] = 73;
 HEAP32[i7 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i8;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findERKS5_j(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 i9 = HEAP8[i4 + 11 >> 0] | 0;
 i8 = i9 << 24 >> 24 < 0;
 i10 = i8 ? HEAP32[i4 >> 2] | 0 : i4;
 i4 = i8 ? HEAP32[i4 + 4 >> 2] | 0 : i9 & 255;
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + i2 | 0;
  i8 = i10 + i4 | 0;
  i1 = i3 + i1 | 0;
  i7 = i9;
  L8 : do if ((i7 - i1 | 0) < (i4 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i4) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L8;
     }
     if ((HEAP8[i5 >> 0] | 0) == (HEAP8[i10 >> 0] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 1 | 0;
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i8 | 0)) break L8;
     i4 = i4 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i5 + 1 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 | 0;
 }
 return i1 | 0;
}

function __ZNK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, d4 = 0.0, i5 = 0, f6 = f0, f7 = f0;
 i5 = i2 + 416 | 0;
 f7 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f6 = Math_fround(f7 + Math_fround(Math_fround(HEAPF32[i2 + 500 >> 2]) * Math_fround(.5)));
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 d3 = +f7;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - d3;
 d4 = +f6;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d4;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - d3;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 i2 = i1 + 32 | 0;
 HEAPF64[i2 >> 3] = d4 + +HEAPF64[i2 >> 3];
 i2 = i1 + 40 | 0;
 HEAPF64[i2 >> 3] = d3 + +HEAPF64[i2 >> 3];
 return 1;
}

function __ZN9Texture2D16DeleteGfxTextureEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 12 | 0;
 i2 = i7 + 8 | 0;
 i3 = i7 + 4 | 0;
 i6 = i7;
 if (HEAP32[i5 + 104 >> 2] & 16 | 0) {
  i1 = i5 + 48 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i8 = __Z12GetGfxDevicev() | 0;
   i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 432 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   mftCall_vii(i9 | 0, i8 | 0, i4 | 0);
  }
 }
 i1 = i5 + 109 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i9 = __Z12GetGfxDevicev() | 0;
  i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 + 48 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  mftCall_vii(i8 | 0, i9 | 0, i4 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 i1 = i5 + 110 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i9 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[(HEAP32[i9 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i8 | 0, i9 | 0, i4 | 0);
 HEAP8[i1 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN7b2WorldC2ERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN16b2BlockAllocatorC2Ev(i1);
 __ZN16b2StackAllocatorC2Ev(i1 + 68 | 0);
 __ZN12b2BroadPhaseC2Ev(i1 + 102872 | 0);
 HEAP32[i1 + 102932 >> 2] = 0;
 HEAP32[i1 + 102936 >> 2] = 0;
 HEAP32[i1 + 102940 >> 2] = gb + 152736;
 HEAP32[i1 + 102944 >> 2] = gb + 152760;
 i3 = i1 + 102948 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i1 + 102952 >> 0] = 0;
 HEAP32[i1 + 102984 >> 2] = 0;
 HEAP32[i1 + 102988 >> 2] = 0;
 i5 = i1 + 102956 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP8[i1 + 102996 >> 0] = 1;
 HEAP8[i1 + 102997 >> 0] = 1;
 HEAP8[i1 + 102998 >> 0] = 0;
 HEAP8[i1 + 102999 >> 0] = 1;
 HEAP8[i1 + 102980 >> 0] = 1;
 i5 = i2;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 102972 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i1 + 102868 >> 2] = 4;
 HEAPF32[i1 + 102992 >> 2] = Math_fround(0.0);
 HEAP32[i3 >> 2] = i1;
 i2 = i1 + 103e3 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZN5physx45updateAtomFrictionProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj(i3, i15, i1, i14, i10, i13) {
 i3 = i3 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i14 = i14 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0, i16 = 0;
 i16 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i16 + 4 | 0;
 i12 = i16;
 i8 = i16 + 9 | 0;
 i9 = i16 + 8 | 0;
 if (!i15) {
  STACKTOP = i16;
  return;
 }
 i2 = 0;
 while (1) {
  __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_(i3, i1, i14, i10, i13, i11, i12, i8, i9) | 0;
  i4 = (HEAP8[i8 >> 0] | 0) == 0;
  if (i4) i5 = 65535; else i5 = HEAPU16[(HEAP32[i3 >> 2] | 0) + 14 >> 1] | 0;
  HEAP16[i3 + 28 >> 1] = i5;
  i6 = (HEAP8[i9 >> 0] | 0) == 0;
  if (i6) i7 = 65535; else i7 = HEAPU16[(HEAP32[i3 + 4 >> 2] | 0) + 14 >> 1] | 0;
  HEAP16[i3 + 30 >> 1] = i7;
  if (!i4) HEAP16[(HEAP32[i3 >> 2] | 0) + 14 >> 1] = i5 + 1;
  if (!i6) HEAP16[(HEAP32[i3 + 4 >> 2] | 0) + 14 >> 1] = i7 + 1;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i15 | 0)) break; else i3 = i3 + 32 | 0;
 }
 STACKTOP = i16;
 return;
}

function __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 24 | 0;
 i2 = i3;
 HEAP32[i2 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i1, i5);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, gb + 1041891 | 0, gb + 844241 | 0, i2, 0);
 __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i4);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i3;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 STACKTOP = i3;
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN17GenericDynamicVBO19ReserveVertexBufferEjj(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i5 + 36 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 L1 : do switch (i4 | 0) {
 case 4:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i5 = i6;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   } else i2 = i6;
   break;
  }
 case 1:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i5 = i6;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   } else i2 = i6;
   break;
  }
 default:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if (i1 >>> 0 < i6 >>> 0) {
    i2 = i6 + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 | 0;
    break L1;
   } else {
    i5 = i1;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   }
  }
 } while (0);
 if (!i2) {
  i5 = i1;
  i6 = i5 >>> 0 >= i6 >>> 0;
  return i6 | 0;
 }
 i5 = HEAP32[i5 + 28 >> 2] | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, i3 | 0, i4 | 0, 1, i2 | 0, 0, 0);
 i5 = HEAP32[i3 + 24 >> 2] | 0;
 i6 = i5 >>> 0 >= i6 >>> 0;
 return i6 | 0;
}

function __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0;
 f3 = Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i1 + 48 | 0, i2 + 36 | 0));
 f4 = Math_fround(HEAPF32[i1 + 64 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 if (!(f3 > Math_fround(f4 * f4))) if ((HEAP32[i2 + 32 >> 2] | 0) != (HEAP32[i1 + 60 >> 2] | 0)) {
  HEAP32[i2 + 16 >> 2] = 1;
  __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 0) | 0);
  __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 1) | 0);
  __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 2) | 0);
  __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 3) | 0);
  return;
 }
 HEAP32[i2 + 16 >> 2] = 2;
 i5 = i2 + 60 | 0;
 i6 = f3 < Math_fround(HEAPF32[i1 + 68 >> 2]) & 1;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2 | i6;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i1, i2, 0);
 return;
}

function __ZN11TimeManager7SetTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, d7 = 0.0;
 i3 = i1 + 64 | 0;
 d7 = +HEAPF64[i3 >> 3];
 HEAPF64[i1 + 72 >> 3] = d7;
 HEAPF64[i3 >> 3] = d2;
 f6 = Math_fround(d2 - d7);
 HEAPF32[i1 + 80 >> 2] = f6;
 i4 = f6 > Math_fround(9.99999974e-06);
 f5 = Math_fround(Math_fround(1.0) / f6);
 HEAPF32[i1 + 92 >> 2] = i4 ? f5 : Math_fround(1.0);
 i4 = i1 + 88 | 0;
 f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.800000011)) + Math_fround(.200000003));
 HEAPF32[i4 >> 2] = f5;
 f5 = Math_fround(Math_fround(.200000003) / f5);
 i4 = i1 + 84 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(f6 * f5) + Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(Math_fround(1.0) - f5)));
 i4 = i1 + 96 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 d2 = +__Z19GetTimeSinceStartupv();
 HEAPF64[i1 + 152 >> 3] = d2 - +HEAPF64[i3 >> 3];
 return;
}

function __GLOBAL__sub_I_modules_particleslegacy_private_lump_cpp() {
 HEAP32[gb + 1469384 >> 2] = 3;
 HEAP32[gb + 1469384 + 4 >> 2] = 1142332464;
 HEAP32[gb + 1469384 + 8 >> 2] = 2077314801;
 HEAP32[gb + 1469384 + 12 >> 2] = -1318445546;
 HEAP32[gb + 1477044 >> 2] = 4;
 HEAP32[gb + 1477048 >> 2] = -1340201579;
 HEAP32[gb + 1477052 >> 2] = -2129358646;
 HEAP32[gb + 1477056 >> 2] = 471808435;
 HEAP32[gb + 1477060 >> 2] = 2;
 HEAP32[gb + 1477064 >> 2] = -670100789;
 HEAP32[gb + 1477068 >> 2] = 1989020952;
 HEAP32[gb + 1477072 >> 2] = 1186267769;
 HEAP32[gb + 1477076 >> 2] = 5;
 HEAP32[gb + 1477080 >> 2] = 472231674;
 HEAP32[gb + 1477084 >> 2] = -2041064797;
 HEAP32[gb + 1477088 >> 2] = -2032904880;
 HEAP32[gb + 1469400 >> 2] = gb + 1469400;
 HEAP32[gb + 1469400 + 4 >> 2] = gb + 1469400;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469428 | 0, gb + 1048738 | 0, 7, 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1469420 | 0, 15);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469440 | 0, gb + 1048754 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469408 | 0, gb + 1048778 | 0, 0, 0);
 return;
}

function __ZZN4Halo15InitializeClassEvEN31FunctorImpl_48kTransformChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = HEAP32[i3 + 44 >> 2] | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 i4 = HEAP32[gb + 1110376 >> 2] | 0;
 i1 = i3 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0);
 i5 = HEAP32[i3 + 36 >> 2] | 0;
 i2 = HEAP32[i3 + 40 >> 2] | 0;
 i3 = 1 << HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i8;
  return;
 }
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i9 = 6;
   break;
  }
 }
 if ((i9 | 0) == 6) {
  STACKTOP = i8;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i3;
 STACKTOP = i8;
 return;
}

function __ZN7ApiGLES14RecreateBufferEjN2gl12BufferTargetElPKvj(i3, i10, i1, i5, i6, i7) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i2 = i1;
 i4 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i8 + 860 >> 2] | 0, i2) | 0;
 i2 = i8 + 892 + (i2 << 2) | 0;
 if (!(HEAP8[i8 + 1992 >> 0] | 0)) i9 = 5; else if ((HEAP32[i2 >> 2] | 0) != (i10 | 0)) i9 = 5;
 if ((i9 | 0) == 5) {
  HEAP32[i2 >> 2] = i10;
  mftCall_vii(HEAP32[i8 + 644 >> 2] | 0, i4 | 0, i10 | 0);
 }
 mftCall_viiii(HEAP32[i3 + 656 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 706 >> 0] | 0)) return i10 | 0;
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i2 + 892 + (i1 << 2) >> 2] = 0;
 i9 = HEAP32[i2 + 644 >> 2] | 0;
 mftCall_vii(i9 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0, 0);
 return i10 | 0;
}

function __ZN5physx5cloth8SwSolverC2EPNS_13PxProfileZoneEPNS_13PxTaskManagerE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = gb + 168284 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 168284 + 68;
 i2 = i3 + 8 | 0;
 HEAP16[i3 + 12 >> 1] = -1;
 HEAP16[i3 + 14 >> 1] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 168404 + 8;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = 0;
 i2 = i3 + 44 | 0;
 HEAP16[i3 + 48 >> 1] = -1;
 HEAP16[i3 + 50 >> 1] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 168448 + 8;
 HEAP32[i3 + 72 >> 2] = i1;
 if (!i1) i1 = -1; else i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, gb + 837632 | 0) | 0;
 HEAP16[i3 + 76 >> 1] = i1;
 HEAPF32[i3 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 84 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 88 >> 2] = 1;
 i2 = i3 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = i3;
 HEAP32[i3 + 64 >> 2] = i3;
 return;
}

function __ZN17GenericDynamicVBO18ReserveIndexBufferEjj(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i5 + 56 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 L1 : do switch (i4 | 0) {
 case 4:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i5 = i6;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   } else i2 = i6;
   break;
  }
 case 1:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if ((i1 | 0) == (i6 | 0)) {
    i5 = i6;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   } else i2 = i6;
   break;
  }
 default:
  {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if (i1 >>> 0 < i6 >>> 0) {
    i2 = i6 + -1 | 0;
    i2 = i2 >>> 16 | i2;
    i2 = i2 >>> 8 | i2;
    i2 = i2 >>> 4 | i2;
    i2 = i2 >>> 2 | i2;
    i2 = (i2 >>> 1 | i2) + 1 | 0;
    break L1;
   } else {
    i5 = i1;
    i6 = i5 >>> 0 >= i6 >>> 0;
    return i6 | 0;
   }
  }
 } while (0);
 if (!i2) {
  i5 = i1;
  i6 = i5 >>> 0 >= i6 >>> 0;
  return i6 | 0;
 }
 i5 = HEAP32[i5 + 28 >> 2] | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 224 >> 2] | 0, i5 | 0, i3 | 0, i4 | 0, 1, i2 | 0, 0, 0);
 i5 = HEAP32[i3 + 24 >> 2] | 0;
 i6 = i5 >>> 0 >= i6 >>> 0;
 return i6 | 0;
}

function __ZN14SafeBinaryRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i8, i9, i5, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 if (!i1) i1 = gb + 1034517 | 0; else {
  i3 = HEAP32[i9 + 8 >> 2] | 0;
  HEAP8[i1 >> 0] = 80;
  HEAP8[i1 + 1 >> 0] = 80;
  HEAP8[i1 + 2 >> 0] = 116;
  HEAP8[i1 + 3 >> 0] = 114;
  HEAP8[i1 + 4 >> 0] = 60;
  i2 = i1 + 6 | 0;
  HEAP8[i1 + 5 >> 0] = 36;
  i3 = __Z24scripting_class_get_nameP11Il2CppClass(i3) | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  if (i4 << 24 >> 24) do {
   HEAP8[i2 >> 0] = i4;
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while (i4 << 24 >> 24 != 0);
  HEAP8[i2 >> 0] = 62;
  HEAP8[i2 + 1 >> 0] = 0;
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i5, i1, i6, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i9, i8); else {
  i1 = HEAP32[i6 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i9 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function _UNITY_png_read_filter_row_paeth_multibyte_pixel(i1, i7, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = ((HEAPU8[i1 + 11 >> 0] | 0) + 7 | 0) >>> 3;
 i8 = (HEAP32[i1 + 4 >> 2] | 0) - i6 | 0;
 if (!i6) {
  i3 = i7;
  i1 = i4;
 } else {
  i1 = i4 + i6 | 0;
  i2 = i7;
  i3 = i4;
  i5 = 0;
  while (1) {
   HEAP8[i2 >> 0] = (HEAPU8[i3 >> 0] | 0) + (HEAPU8[i2 >> 0] | 0);
   i5 = i5 + 1 | 0;
   if ((i5 | 0) == (i6 | 0)) break; else {
    i2 = i2 + 1 | 0;
    i3 = i3 + 1 | 0;
   }
  }
  i3 = i7 + i6 | 0;
 }
 if (!i8) return; else {
  i5 = i7;
  i2 = 0;
 }
 while (1) {
  i7 = HEAPU8[i5 >> 0] | 0;
  i9 = HEAPU8[i1 >> 0] | 0;
  i6 = HEAPU8[i4 >> 0] | 0;
  i13 = i9 - i6 | 0;
  i10 = i7 - i6 | 0;
  i12 = (i13 | 0) < 0 ? 0 - i13 | 0 : i13;
  i11 = (i10 | 0) < 0 ? 0 - i10 | 0 : i10;
  i10 = i13 + i10 | 0;
  i10 = (i10 | 0) < 0 ? 0 - i10 | 0 : i10;
  HEAP8[i3 >> 0] = ((i12 | 0) > (i11 | 0) | (i12 | 0) > (i10 | 0) ? ((i11 | 0) <= (i10 | 0) ? i9 : i6) : i7) + (HEAPU8[i3 >> 0] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i8 | 0)) break; else {
   i5 = i5 + 1 | 0;
   i4 = i4 + 1 | 0;
   i3 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function _jpeg_write_scanlines(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if ((i1 | 0) != 101) {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
 }
 i2 = i4 + 208 | 0;
 i3 = i4 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 123;
  mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i4 | 0, -1);
 }
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
 }
 i1 = HEAP32[i4 + 316 >> 2] | 0;
 if (HEAP8[i1 + 12 >> 0] | 0) mftCall_vi(HEAP32[i1 + 4 >> 2] | 0, i4 | 0);
 i3 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 + 320 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i5 | 0, i7 | 0, (i3 >>> 0 < i6 >>> 0 ? i3 : i6) | 0);
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i7;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__27promiseIvE13set_exceptionESt13exception_ptr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4 + 8 | 0;
 i3 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 do if (!i1) {
  i1 = ___cxa_allocate_exception(16) | 0;
  __ZNSt3__215future_categoryEv() | 0;
  HEAP32[i6 >> 2] = 3;
  HEAP32[i6 + 4 >> 2] = gb + 1473484;
  __THREW__ = 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  invoke_vii(fb + 4499 | 0, i1 | 0, i5 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___cxa_free_exception(i1 | 0);
   i1 = i6;
   break;
  } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
 } else {
  __ZNSt13exception_ptrC2ERKS_(i3, i2);
  __THREW__ = 0;
  invoke_vii(fb + 4503 | 0, i1 | 0, i3 | 0);
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt13exception_ptrD2Ev(i3);
   break;
  } else {
   __ZNSt13exception_ptrD2Ev(i3);
   STACKTOP = i4;
   return;
  }
 } while (0);
 ___resumeException(i1 | 0);
}

function __ZN7ApiGLES9MapBufferEjN2gl12BufferTargetEllj(i3, i4, i1, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i2 = i1;
 i5 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i9 + 860 >> 2] | 0, i2) | 0;
 i2 = i9 + 892 + (i2 << 2) | 0;
 if (!(HEAP8[i9 + 1992 >> 0] | 0)) i10 = 5; else if ((HEAP32[i2 >> 2] | 0) != (i4 | 0)) i10 = 5;
 if ((i10 | 0) == 5) {
  HEAP32[i2 >> 2] = i4;
  mftCall_vii(HEAP32[i9 + 644 >> 2] | 0, i5 | 0, i4 | 0);
 }
 i2 = mftCall_iiiii(HEAP32[i3 + 668 >> 2] | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 706 >> 0] | 0)) return i2 | 0;
 i3 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i3 + 892 + (i1 << 2) >> 2] = 0;
 i10 = HEAP32[i3 + 644 >> 2] | 0;
 mftCall_vii(i10 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i3 + 860 >> 2] | 0, i1) | 0, 0);
 return i2 | 0;
}

function __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 i6 = i5 + 160 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 164 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i7, i1, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN13CameraLODDataC2EPK6CamerajhfRK10MemLabelId(i1, i2, i3, i4, f5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i7;
 HEAP32[i1 >> 2] = i2;
 HEAPF64[i1 + 8 >> 3] = 0.0;
 HEAP32[i1 + 28 >> 2] = i3;
 HEAP32[i1 + 32 >> 2] = i3;
 i2 = i1 + 20 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i6);
 i11 = i10;
 i9 = HEAP32[i11 + 4 >> 2] | 0;
 i8 = i2;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i8 = i1 + 16 | 0;
 HEAP32[i8 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 1, i2, 0, gb + 1047584 | 0, 446) | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i1 + 48 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = i3;
 i1 = i1 + 40 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i6);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i2 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 2, 4, i1, 0, gb + 1047584 | 0, 446) | 0;
 HEAP8[HEAP32[i8 >> 2] >> 0] = i4;
 HEAPF32[HEAP32[i2 >> 2] >> 2] = f5;
 STACKTOP = i7;
 return;
}

function __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i6 + 64 | 0;
 i5 = i6 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i8 | 0)) {
  i3 = i6 + 16 | 0;
  i4 = i6 + 20 | 0;
  do {
   i10 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_viiii(HEAP32[HEAP32[i10 >> 2] >> 2] | 0, i10 | 0, i6 | 0, (HEAP8[i3 >> 0] | 0) != 0 | 0, i4 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i8 | 0));
 }
 i2 = i6 + 72 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i10 = (HEAP32[i8 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i10 >> 2];
 HEAP32[HEAP32[i10 >> 2] >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i8 | 0)) {
  STACKTOP = i9;
  return;
 }
 i2 = i6 + 76 | 0;
 i3 = i7 + 4 | 0;
 do {
  i10 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i7 >> 2] = 5;
  HEAP32[i3 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i10, i7);
 } while ((i1 | 0) != (i8 | 0));
 STACKTOP = i9;
 return;
}

function __Z18ReleaseLogHandlersv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[gb + 1450784 >> 2] | 0;
 if (!i6) {
  i6 = HEAP32[gb + 1450760 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63176 | 0);
  HEAP32[gb + 1450760 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  if ((i4 | 0) != (i6 | 0)) {
   i2 = i6 + 12 | 0;
   i3 = i5 + 4 | 0;
   i1 = i4;
   do {
    i4 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = HEAP32[i2 >> 2] | 0;
    HEAP32[i5 >> 2] = 7;
    HEAP32[i3 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
   } while ((i1 | 0) != (i6 | 0));
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 63176 | 0);
 HEAP32[gb + 1450784 >> 2] = 0;
 i8 = HEAP32[gb + 1450760 >> 2] | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 63176 | 0);
 HEAP32[gb + 1450760 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN7Joint2D16SetConnectedBodyE4PPtrI11Rigidbody2DE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i5 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0) | 0)) {
  HEAP32[i3 >> 2] = __ZNK6Object12GetClassNameEv(i4) | 0;
  __Z6FormatPKcz(i2, gb + 806315 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 801199 | 0, 136, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 56 >> 2] = i1;
 HEAP32[i4 + 36 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, 1);
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN6AvatarC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 178664 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 176376 + 8;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 4096;
 HEAP32[i1 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = i1 + 64;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i1;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i4, i2, HEAP32[gb + 37316 >> 2] | 0, i1, i3);
 HEAP32[i6 >> 2] = -1;
 i1 = i6 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i6 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i4, gb + 1041885 | 0, gb + 1041885 | 0, i5 + 20 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags(i4, i6, gb + 1041891 | 0, 0);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i4);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i2 + (~(((i2 + -24 - i1 | 0) >>> 0) / 24 | 0) * 24 | 0);
 __ZdlPv(i1);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId(i5, i7, i2) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i6 = i5 + 4 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
 }
 i2 = i5 + 12 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i7 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i7 << 3, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 << 3, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i7;
  HEAP32[i5 >> 2] = i1;
  break;
 } while (0);
 if (i6 >>> 0 >= i7 >>> 0) return;
 i3 = i1 + (i6 << 3) | 0;
 i2 = i7 - i6 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 3) + 4 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN15LODGroupManager26CollectAllLODGroupManagersEPK6CameraR13dynamic_arrayIPS_Lj4EEb(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i2 = HEAP32[gb + 1161220 + 12 >> 2] | 0;
 i8 = i7 + 12 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i7 >> 2] = i5;
  break;
 } while (0);
 if (i2 >>> 0 > i3 >>> 0) _memset((HEAP32[i7 >> 2] | 0) + (i3 << 2) | 0, 0, i2 - i3 << 2 | 0) | 0;
 HEAP32[HEAP32[i7 >> 2] >> 2] = HEAP32[gb + 1161200 >> 2];
 if (i1) return;
 i1 = __Z18GetITerrainManagerv() | 0;
 if (!i1) return;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i6 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] | 0);
 return;
}

function __Z30TransferField_LinearCollectionI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 40 | 0;
 i4 = i7 + 32 | 0;
 i5 = i7;
 __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo(i3, i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i6 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = -1;
 if (HEAP32[i2 + 4 >> 2] | 0) {
  __ZN21LinearCollectionField8GetArrayEv(i5, i3);
  i10 = i5;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i4;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
 };
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = i4;
 mftCall_vii(HEAP32[i1 + 40 >> 2] | 0, i1 | 0, i5 | 0);
 if ((HEAP32[i6 >> 2] | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 __ZN21LinearCollectionField8SetArrayERK9ArrayInfo(i3, i4);
 STACKTOP = i7;
 return;
}

function __Z15ResolveSymlinksRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 2120 | 0;
 i4 = i7 + 1060 | 0;
 i5 = i7;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, i2);
 i8 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i8 << 24 >> 24 < 0;
 if (!((i6 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i7;
  return;
 }
 __ZN15FileSystemEntryC2EPKc(i4, i6 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZN15FileSystemEntryC2Ev(i5);
 if (__ZNK15FileSystemEntry6TargetERS_(i4, i5) | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i3, __ZNK15FileSystemEntry4PathEv(i5) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3);
 __ZN13FileEntryDataD2Ev(i5);
 __ZN13FileEntryDataD2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i7;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5cloneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i7 = i4;
 i8 = i1 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 148660 + 8;
 i5 = i6 + 4 | 0;
 i3 = i6 + 8 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = gb + 774875;
 i2 = i6 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i9 = i6 + 20 | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 148684 + 8;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0, i6 | 0);
 HEAP32[i7 >> 2] = gb + 148700 + 8;
 HEAP8[i7 + 12 >> 0] = 1;
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 >> 2];
 i1 = __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackERNS0_14PvdInputStreamE(HEAP32[i8 >> 2] | 0, i7) | 0;
 HEAP32[i6 >> 2] = gb + 148660 + 8;
 HEAP32[i5 >> 2] = gb + 148720 + 8;
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return i1 | 0;
 }
 i9 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 12 >> 2] | 0, i9 | 0, i2 | 0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN9TextAsset7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(64, i1, 16, gb + 1048932 | 0, 0, gb + 466218 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 66792 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN22ProceduralMaterialDataC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i3 + 11 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i1 + 80;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 1;
 __ZN22ProceduralMaterialData12CopyFromDataERKS_(i1, i2);
 return;
}

function __ZN20TextRenderingPrivate13ApplyToMeshesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 8 | 0;
 i7 = i6;
 i2 = i6 + 16 | 0;
 __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv();
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 185320 | 0, i2, 0);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN15AudioReverbZone5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(15.0);
 HEAP32[i1 + 56 >> 2] = 1;
 i13 = HEAP32[gb + 171848 + 96 >> 2] | 0;
 i3 = HEAP32[gb + 171848 + 100 >> 2] | 0;
 i12 = HEAP32[gb + 171848 + 104 >> 2] | 0;
 i11 = HEAP32[gb + 171848 + 108 >> 2] | 0;
 i10 = HEAP32[gb + 171848 + 116 >> 2] | 0;
 i9 = HEAP32[gb + 171848 + 120 >> 2] | 0;
 i8 = HEAP32[gb + 171848 + 124 >> 2] | 0;
 i7 = HEAP32[gb + 171848 + 128 >> 2] | 0;
 i6 = HEAP32[gb + 171848 + 140 >> 2] | 0;
 i2 = HEAP32[gb + 171848 + 144 >> 2] | 0;
 i5 = HEAP32[gb + 171848 + 148 >> 2] | 0;
 i4 = HEAP32[gb + 171848 + 152 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[gb + 171848 + 92 >> 2];
 HEAP32[i1 + 64 >> 2] = i13;
 HEAP32[i1 + 72 >> 2] = i12;
 HEAP32[i1 + 76 >> 2] = i11;
 HEAP32[i1 + 80 >> 2] = i10;
 HEAP32[i1 + 84 >> 2] = i9;
 HEAP32[i1 + 88 >> 2] = i8;
 HEAP32[i1 + 92 >> 2] = i7;
 HEAP32[i1 + 96 >> 2] = i6;
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 108 >> 2] = i5;
 HEAP32[i1 + 112 >> 2] = i4;
 HEAP32[i1 + 68 >> 2] = i3;
 HEAP32[i1 + 100 >> 2] = i2;
 return;
}

function __ZN14PhysicsManager17MainThreadCleanupEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i2 = i5 + 196 | 0;
 i3 = i5 + 200 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i4 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i2 = 0;
 do {
  i3 = i5 + 204 + (i2 << 3) | 0;
  i4 = i5 + 204 + (i2 << 3) + 4 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1 + 4 | 0;
   i7 = i1;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  } while ((i1 | 0) != (i3 | 0));
  HEAP32[i4 >> 2] = i3;
  HEAP32[i3 >> 2] = i3;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 64);
 i2 = i5 + 716 | 0;
 i3 = i5 + 720 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i7 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = i2;
 i7 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 164 >> 2] | 0, i7 | 0, 0, 0);
 __ZN11GameManager17MainThreadCleanupEv(i5);
 return;
}

function __Z36AssetBundle_CUSTOM_LoadFromFileAsyncP12Il2CppStringjy(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 12 | 0;
 i6 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 i1 = __Znwj(216) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i7);
 __ZN37AssetBundleLoadFromFileAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 HEAP32[i1 + 88 >> 2] = i2;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 192 | 0, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i2 = i1 + 208 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 __ZN37AssetBundleLoadFromFileAsyncOperation7ExecuteEv(i1);
 i4 = _il2cpp_object_new(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 28 >> 2] | 0) | 0;
 HEAP32[i4 + 8 >> 2] = i1;
 STACKTOP = i5;
 return i4 | 0;
}

function _cff_fd_select_get(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 switch (HEAP8[i6 >> 0] | 0) {
 case 0:
  {
   i9 = HEAP8[(HEAP32[i6 + 8 >> 2] | 0) + i1 >> 0] | 0;
   return i9 | 0;
  }
 case 3:
  {
   i9 = i6 + 16 | 0;
   i7 = i6 + 20 | 0;
   if ((i1 - (HEAP32[i9 >> 2] | 0) | 0) >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
    i9 = HEAP8[i6 + 24 >> 0] | 0;
    return i9 | 0;
   }
   i5 = HEAP32[i6 + 8 >> 2] | 0;
   i2 = i5 + (HEAP32[i6 + 12 >> 2] | 0) | 0;
   i4 = HEAPU8[i5 >> 0] << 8 | HEAPU8[i5 + 1 >> 0];
   i5 = i5 + 2 | 0;
   while (1) {
    if (i4 >>> 0 > i1 >>> 0) {
     i1 = 0;
     i2 = 10;
     break;
    }
    i3 = i5 + 3 | 0;
    i8 = HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0];
    if (i8 >>> 0 > i1 >>> 0) {
     i2 = 8;
     break;
    }
    if (i3 >>> 0 < i2 >>> 0) {
     i4 = i8;
     i5 = i3;
    } else {
     i1 = 0;
     i2 = 10;
     break;
    }
   }
   if ((i2 | 0) == 8) {
    i5 = HEAP8[i5 >> 0] | 0;
    HEAP32[i9 >> 2] = i4;
    HEAP32[i7 >> 2] = i8 - i4;
    HEAP8[i6 + 24 >> 0] = i5;
    i9 = i5;
    return i9 | 0;
   } else if ((i2 | 0) == 10) return i1 | 0;
   break;
  }
 default:
  {
   i9 = 0;
   return i9 | 0;
  }
 }
 return 0;
}

function __ZNK9Heightmap20ExtractRawHeightDataER13dynamic_arrayIsLj2EEiiii(i5, i6, i7, i8, i9, i10) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i11 = 0;
 i1 = Math_imul(i10, i9) | 0;
 i2 = i6 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = i4;
  break;
 } while (0);
 if ((i9 | 0) <= 0) return;
 i4 = i5 + 76 | 0;
 i2 = i5 + 4 | 0;
 i3 = i10 << 1;
 i1 = 0;
 do {
  i11 = Math_imul(i1, i10) | 0;
  i5 = (Math_imul(HEAP32[i4 >> 2] | 0, i1 + i7 | 0) | 0) + i8 | 0;
  _memcpy((HEAP32[i6 >> 2] | 0) + (i11 << 1) | 0, (HEAP32[i2 >> 2] | 0) + (i5 << 1) | 0, i3 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i9 | 0));
 return;
}

function __ZNK12HandlerChain12GetAssetGUIDERK13FileEntryData(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = i4 + 4 | 0;
 i8 = i4 + 8 | 0;
 i9 = i4 + 12 | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i6 | 0, i2 | 0, i5 | 0);
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  if (HEAP32[i4 >> 2] | 0) {
   i1 = 8;
   break;
  }
  if (HEAP32[i7 >> 2] | 0) {
   i1 = 8;
   break;
  }
  if (HEAP32[i8 >> 2] | 0) {
   i1 = 8;
   break;
  }
  if (HEAP32[i9 >> 2] | 0) {
   i1 = 8;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) {
  STACKTOP = i10;
  return;
 }
}

function __ZN8Material21SetShaderKeywordNamesERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEER8UnityStr(i2, i4);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i4, i3);
 __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet(i1, i3);
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN29AudioEffectInternalDefinitionC2E13FMOD_DSP_TYPE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i8 + 4 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP8[i8 + 5 >> 0] = 1;
 HEAP32[i8 + 8 >> 2] = i1;
 i9 = __ZnwjRK10MemLabelIdiPKci(208, gb + 63328 | 0, 16, gb + 860370 | 0, 286) | 0;
 __ZN30AudioEffectInternalDescriptionC2E13FMOD_DSP_TYPEPb(i9, i1, i7);
 if (i9 | 0) {
  i7 = i9 + 200 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 }
 i7 = HEAP32[i8 >> 2] | 0;
 if (!i7) {
  HEAP32[i8 >> 2] = i9;
  return;
 }
 i5 = i7 + 200 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (i6 | 0) {
  HEAP32[i8 >> 2] = i9;
  return;
 }
 i5 = i7 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 64 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
   if (i3) {
    __ZdaPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = HEAP32[i7 + 180 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i7, gb + 63328 | 0);
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i8, i6, i1, i2) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 L1 : do if (!(i2 & 2)) {
  i2 = HEAP32[i8 + 16 >> 2] | 0;
  i3 = HEAP32[i8 + 20 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   i4 = HEAP32[i8 + 32 >> 2] | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i5 | 0)) break;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) >= (i3 | 0)) {
     i9 = 8;
     break L1;
    }
   }
   if ((i2 | 0) > -1) i2 = HEAP32[(HEAP32[i8 + 52 >> 2] | 0) + (i2 << 2) >> 2] & 1048575; else i9 = 8;
  } else i9 = 8;
 } else i9 = 8; while (0);
 if ((i9 | 0) == 8) {
  __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj(i7, i8, i6, 2, 64, 0, 0);
  i2 = HEAP32[i7 + 4 >> 2] | 0;
 }
 i3 = (HEAP32[i8 + 72 >> 2] | 0) + i2 | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i10;
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 906486 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5 + 4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906345 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN13AnimationClip15ClipWasModifiedEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (i1) {
  HEAP32[i3 + 216 >> 2] = 0;
  HEAP32[i3 + 220 >> 2] = 0;
  i2 = i3 + 64 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) do {
   i4 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63320 | 0);
  } while ((i1 | 0) != 0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 + 68 >> 2] = 0;
  HEAP32[i3 + 72 >> 2] = 0;
  i1 = i3 + 224 | 0;
  i2 = i3 + 240 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 228 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 236 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i3 + 244 | 0;
  i2 = i3 + 260 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 248 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 256 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i3, gb + 1105816 | 0);
 HEAP32[i3 + 264 >> 2] = 2139095040;
 HEAP32[i3 + 268 >> 2] = -8388608;
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(i1 | 0, i3 | 0, i3 + 80 | 0);
 return;
}

function __Z29StdTemplateConversionFunctionIyjEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i1 >> 2] = i10;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIyiEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 8 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i10 = i3;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i3 = i5;
   HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i3 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 8);
 if (!(HEAP32[i2 >> 2] & 512)) {
  i10 = i5;
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i1 >> 2] = i10;
  STACKTOP = i8;
  return 1;
 }
 i9 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
 i10 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = _llvm_bswap_i32(HEAP32[i10 >> 2] | 0) | 0;
 HEAP32[i10 >> 2] = i9;
 i10 = i5;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i1 >> 2] = i10;
 STACKTOP = i8;
 return 1;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj(i7, i1, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7);
 i6 = (i2 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i1) + i4 | 0;
 i4 = i3 - i4 | 0;
 i4 = i4 >>> 0 < i5 >>> 0 ? i4 : i5;
 i5 = i7 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i4 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i4 - i3 + i1 | 0, i1, i1, 0, i4, i6);
  return i7 | 0;
 }
 if (!i4) return i7 | 0;
 if (i2) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
 _memcpy(i2 + i1 | 0, i6 | 0, i4 | 0) | 0;
 i1 = i1 + i4 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 return i7 | 0;
}

function __ZN9Rigidbody7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 782037 | 0, 34) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 113356 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = i4;
 i2 = i4 + 44 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i4 + 48 >> 2] = i2;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP8[i4 + 81 >> 0] = 1;
 HEAP8[i4 + 82 >> 0] = 1;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP8[i4 + 100 >> 0] = 1;
 HEAP8[i4 + 101 >> 0] = 1;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = -1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 723624 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN10Collider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 144 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 148 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 152 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 156 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 80 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __Z33Renderer_Get_Custom_PropMaterialsP12Il2CppObject(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i4 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i4 = __Z19GetScriptingManagerv() | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i4 + 168 >> 2] | 0) + (HEAP32[gb + 30792 + 24 >> 2] << 2) >> 2] | 0, 4, i3) | 0;
 if ((i3 | 0) > 0) i1 = 0; else return i4 | 0;
 while (1) {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
  if (!i2) {
   i1 = 7;
   break;
  }
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Renderer32GetAndAssignInstantiatedMaterialEib(i2, i1, 0) | 0) | 0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i3 | 0)) {
   i1 = 5;
   break;
  }
 }
 if ((i1 | 0) == 5) return i4 | 0; else if ((i1 | 0) == 7) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 return 0;
}

function __Z20CreateObjectFromCodeI23ShaderVariantCollectionEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 HEAP32[i4 >> 2] = gb + 68748 + 8;
 i1 = i4 + 36 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = i1;
 HEAP8[i4 + 44 >> 0] = 0;
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK17ProceduralTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i4, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i5 >> 2] | 0) != 4;
 do if (i3) {
  i1 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63752 | 0, 16, gb + 431386 | 0, 442) | 0;
  __ZN5ImageC2Eii13TextureFormat(i1, HEAP32[i4 + 128 >> 2] | 0, HEAP32[i4 + 132 >> 2] | 0, 4);
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  } else {
   i2 = i1;
   i1 = i1 + 16 | 0;
   break;
  }
 } else {
  i2 = 0;
  i1 = i5 + 16 | 0;
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(__ZNK17ProceduralTexture11GetPixels32EiiiiP11ColorRGBA32(i4, 0, 0, 0, 0, i1) | 0)) {
  if (!i4) i1 = 0; else i1 = HEAP32[i4 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 431475 | 0, 0, gb + 431386 | 0, 453, 1, i1, 0, 0);
  i6 = 0;
  return i6 | 0;
 }
 if (!i3) {
  i6 = 1;
  return i6 | 0;
 }
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i2, i6);
 if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63752 | 0);
 i6 = 1;
 return i6 | 0;
}

function __ZNK17BaseWebCamTexture9GetPixelsEiiiiP10ColorRGBAf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895035 | 0, 0, gb + 895080 | 0, 102, 1, 0, 0, 0);
  i6 = 0;
  return i6 | 0;
 }
 if (!(HEAP8[i1 + 94 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895154 | 0, 0, gb + 895080 | 0, 108, 1, 0, 0, 0);
  i6 = 0;
  return i6 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (!((i4 | 0) > 0 & (i5 | 0) > 0)) {
  i6 = 1;
  return i6 | 0;
 }
 i9 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_(i9, i8, i7, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0) | 0, i2, i3, i4, i5, i6) | 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN9CGProgram7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(96, i1, 16, gb + 1048932 | 0, 0, gb + 479252 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 68632 + 8;
 i2 = i4 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i4 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPKNS_24PxsIndexedContactManagerENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 720769 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx17PxcNpMemBlockPool13setBlockCountEj(i11, i10) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12;
 i5 = i12 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 i1 = HEAP32[i11 + 152 >> 2] | 0;
 if (i1 >>> 0 >= i10 >>> 0) {
  i11 = HEAP32[i11 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
  STACKTOP = i12;
  return;
 }
 i6 = i11 + 112 | 0;
 i7 = i11 + 120 | 0;
 i8 = i11 + 116 | 0;
 i9 = i11 + 140 | 0;
 do {
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, 16384, gb + 703366 | 0, 83) | 0;
  HEAP32[i4 >> 2] = i2;
  i3 = HEAP32[i8 >> 2] | 0;
  if ((HEAP32[i7 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i2;
   HEAP32[i8 >> 2] = i3 + 1;
  } else __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i4) | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i10 | 0));
 i11 = HEAP32[i11 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 STACKTOP = i12;
 return;
}

function __ZN10Matrix4x4f14SetPerspectiveEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0;
 f8 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(f3 - f2);
 HEAPF32[i1 >> 2] = Math_fround(f8 / f9);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(Math_fround(f2 + f3) / f9);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 f3 = Math_fround(f4 - f5);
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 / f3);
 HEAPF32[i1 + 36 >> 2] = Math_fround(Math_fround(f4 + f5) / f3);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 f5 = Math_fround(f7 - f6);
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(-Math_fround(f6 + f7)) / f5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(-Math_fround(Math_fround(f7 * Math_fround(2.0)) * f6)) / f5);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return i1 | 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = (HEAP8[i2 >> 0] | 0) == 0 ? i5 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i5;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 8 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 8);
  i4 = i6 + 4 | 0;
  i1 = i6;
  i2 = i4;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
 } else {
  i4 = i2;
  i8 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i6;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  i1 = i6;
  i2 = i6 + 4 | 0;
  i3 = i8;
 }
 i8 = _llvm_bswap_i32(i3 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i2 >> 2] = i8;
 i4 = i6;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = (HEAP8[i2 >> 0] | 0) == 0 ? i5 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i5;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 8 | 0;
 if (i3 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 8);
  i4 = i6 + 4 | 0;
  i1 = i6;
  i2 = i4;
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
 } else {
  i4 = i2;
  i8 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = i6;
  HEAP32[i2 >> 2] = i8;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = i3;
  i1 = i6;
  i2 = i6 + 4 | 0;
  i3 = i8;
 }
 i8 = _llvm_bswap_i32(i3 | 0) | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(i4 | 0) | 0;
 HEAP32[i2 >> 2] = i8;
 i4 = i6;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i9, i5, i8) {
 i9 = i9 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i10 = 0;
 i3 = i5;
 i10 = i9 + 11 | 0;
 i1 = HEAP8[i10 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = (HEAP32[i9 + 8 >> 2] & 2147483647) + -1 | 0;
  i7 = HEAP32[i9 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i7 = i1 & 255;
 }
 i6 = i8 - i3 | 0;
 do if (i6 | 0) {
  if ((i2 - i7 | 0) >>> 0 < i6 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i9, i2, i7 + i6 - i2 | 0, i7, i7, 0, 0);
   i1 = HEAP8[i10 >> 0] | 0;
  }
  if (i1 << 24 >> 24 < 0) i4 = HEAP32[i9 >> 2] | 0; else i4 = i9;
  i3 = i8 + (i7 - i3) | 0;
  i2 = i4 + i7 | 0;
  i1 = i5;
  while (1) {
   if ((i1 | 0) == (i8 | 0)) break;
   HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
  HEAP8[i4 + i3 >> 0] = 0;
  i1 = i7 + i6 | 0;
  if ((HEAP8[i10 >> 0] | 0) < 0) {
   HEAP32[i9 + 4 >> 2] = i1;
   break;
  } else {
   HEAP8[i10 >> 0] = i1;
   break;
  }
 } while (0);
 return i9 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj(i7, i1, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7);
 i6 = (i2 << 24 >> 24 < 0 ? HEAP32[i1 >> 2] | 0 : i1) + i4 | 0;
 i4 = i3 - i4 | 0;
 i4 = i4 >>> 0 < i5 >>> 0 ? i4 : i5;
 i5 = i7 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) {
  i3 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
 } else {
  i3 = 10;
  i1 = i1 & 255;
 }
 if ((i3 - i1 | 0) >>> 0 < i4 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i3, i4 - i3 + i1 | 0, i1, i1, 0, i4, i6);
  return i7 | 0;
 }
 if (!i4) return i7 | 0;
 if (i2) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
 _memcpy(i2 + i1 | 0, i6 | 0, i4 | 0) | 0;
 i1 = i1 + i4 | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i5 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 return i7 | 0;
}

function __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i5 = i4 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 128 | 0;
 if ((HEAP32[i1 + 132 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) return;
 i4 = i4 + 4 | 0;
 i3 = 0;
 do {
  switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i6, i3, i2, i1) | 0) {
  case 1:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i4 >> 2] | 0, 0, 0);
    break;
   }
  case 4:
   {
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i4 >> 2] | 0, 0, 0);
    break;
   }
  default:
   {}
  }
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = i1 + 128 | 0;
 } while (i3 >>> 0 < (((HEAP32[i1 + 132 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 52 | 0) >>> 0);
 return;
}

function __ZNK16MemoryFileSystem8FindNodeEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return i1 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN9ShaderLab20SerializedProperties17AddVectorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i6, i1, i2, 1, i3);
 i1 = i6 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i6);
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i6);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 88;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN22RenderingCommandBuffer12AddGetTempRTERKN9ShaderLab16FastPropertyNameEii19RenderTextureFormat17DepthBufferFormat17TextureFilterMode22RenderTextureReadWritei(i4, i1, i9, i10, i11, i12, i13, i14, i15) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i6 = i4 + 8 | 0;
 i7 = i4 + 24 | 0;
 i5 = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 i3 = i5 + 4 | 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i5, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i3 = i4 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i5 >> 2] = 9;
 i4 = i5 + 7 & -4;
 i5 = i4 + 36 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + i4 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i7 + 8 >> 2] = i10;
 HEAP32[i7 + 12 >> 2] = i11;
 HEAP32[i7 + 16 >> 2] = i12;
 HEAP32[i7 + 20 >> 2] = i13;
 HEAP32[i7 + 24 >> 2] = i14;
 HEAP32[i7 + 28 >> 2] = i15;
 HEAP32[i7 + 32 >> 2] = 0;
 return;
}

function __ZN20HardwareInfoReporter12CleanupClassEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i7 = i6 + 10804 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i1 = 0;
  while (1) {
   i3 = i6 + 10036 + (i1 * 12 | 0) | 0;
   if ((HEAP32[i3 >> 2] | 0) == (fb + 403 | 0)) {
    i4 = i6 + 10036 + (i1 * 12 | 0) + 8 | 0;
    i2 = i6 + 10036 + (i1 * 12 | 0) + 4 | 0;
    if (!(HEAP8[i4 >> 0] | 0)) break;
    if (!(HEAP32[i2 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) break L1;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  HEAP8[i4 >> 0] = 0;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  HEAP32[i7 >> 2] = i5;
  if (i5 >>> 0 > i1 >>> 0) do {
   i5 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i6 + 10036 + (i5 * 12 | 0) >> 2] = HEAP32[i6 + 10036 + (i1 * 12 | 0) >> 2];
   HEAP32[i6 + 10036 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 10036 + (i1 * 12 | 0) + 4 >> 2];
   HEAP8[i6 + 10036 + (i5 * 12 | 0) + 8 >> 0] = HEAP8[i6 + 10036 + (i1 * 12 | 0) + 8 >> 0] | 0;
  } while (i1 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0);
 } while (0);
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 __ZN3WWW7ReleaseEv(i1);
 HEAP32[i8 >> 2] = 0;
 return;
}

function __Z51ParticleSystemRenderer_Set_Custom_PropTrailMaterialP12Il2CppObjectS0_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 do if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) < 2) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   __ZN8Renderer16SetMaterialCountEi(i1, 2);
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i1, i2, 1);
  STACKTOP = i6;
  return;
 }
}

function __Z34VRSettings_CUSTOM_LoadDeviceByNameP11Il2CppArray(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __Z23StringScriptingToVectorINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvP11Il2CppArrayRT_(i1, i6);
 if (!(__Z12GetIVRDevicev() | 0)) i1 = 0; else i1 = __ZNK8VRDevice10GetEnabledEv(__Z12GetIVRDevicev() | 0) | 0;
 __ZN8VRDevice21RequestReloadVRDeviceERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i6, i1);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i5 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i7 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i4 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __Z23ConvertIntegerToTypePtrIjEbPvR14SafeBinaryRead(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i4 + 16 | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i5 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) i5 = 4; else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i5 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (HEAP32[i4 >> 2] & 512) {
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 if ((i1 | 0) == -1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i5 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 HEAP32[i6 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i8;
  return 1;
 }
 HEAP32[i6 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(HEAP32[i7 >> 2] | 0) | 0;
 STACKTOP = i8;
 return 1;
}

function __Z23ConvertIntegerToTypePtrIiEbPvR14SafeBinaryRead(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i4 + 16 | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i5 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) i5 = 4; else {
   i1 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i5 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
  i1 = HEAP32[i7 >> 2] | 0;
 }
 if (HEAP32[i4 >> 2] & 512) {
  i1 = _llvm_bswap_i32(i1 | 0) | 0;
  HEAP32[i7 >> 2] = i1;
 }
 if ((i1 | 0) == -1) {
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i5 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 HEAP32[i6 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i8;
  return 1;
 }
 HEAP32[i6 >> 2] = __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(HEAP32[i7 >> 2] | 0) | 0;
 STACKTOP = i8;
 return 1;
}

function __ZNK9Polygon2D15GetNearestPointERK8Vector2fRiS3_Rf(i1, i11, i12, i13, i14) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f15 = f0;
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = (HEAP32[i1 + 4 >> 2] | 0) - i8 | 0;
 i10 = (i9 | 0) / 20 | 0;
 if ((i9 | 0) <= 0) {
  i14 = 0;
  return i14 | 0;
 }
 i9 = i11 + 4 | 0;
 i1 = 0;
 f2 = Math_fround(3402823469999999843913219.0e14);
 i7 = 0;
 do {
  i5 = HEAP32[i8 + (i7 * 20 | 0) + 12 >> 2] | 0;
  if ((i5 | 0) > 0) {
   i6 = HEAP32[i8 + (i7 * 20 | 0) >> 2] | 0;
   i4 = 0;
   do {
    f15 = Math_fround(HEAPF32[i6 + (i4 << 3) >> 2]);
    f15 = Math_fround(f15 - Math_fround(HEAPF32[i11 >> 2]));
    f3 = Math_fround(HEAPF32[i6 + (i4 << 3) + 4 >> 2]);
    f3 = Math_fround(f3 - Math_fround(HEAPF32[i9 >> 2]));
    f3 = Math_fround(Math_fround(f15 * f15) + Math_fround(f3 * f3));
    if (f3 < f2) {
     HEAP32[i12 >> 2] = i7;
     HEAP32[i13 >> 2] = i4;
     HEAPF32[i14 >> 2] = Math_fround(Math_sqrt(Math_fround(f3)));
     i1 = 1;
     f2 = f3;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) != (i5 | 0));
  }
  i7 = i7 + 1 | 0;
 } while ((i7 | 0) < (i10 | 0));
 return i1 | 0;
}

function __ZNK14b2CapsuleShape9TestPointERK11b2TransformRK6b2Vec2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i7 = i4;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f11 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f10 = Math_fround(f5 * f11);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(Math_fround(f11 * f9) - Math_fround(f5 * f6));
 HEAPF32[i8 >> 2] = Math_fround(f10 + Math_fround(f9 * f6));
 i3 = i8 + 4 | 0;
 HEAPF32[i3 >> 2] = f5;
 __Z20b2NearestPointOnLineRK6b2Vec2S1_S1_(i7, i8, i1 + 12 | 0, i1 + 20 | 0);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i8 >> 2]));
 f6 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i3 = f6 <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9ShaderLab20SerializedProperties16AddColorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i6, i1, i2, 0, i3);
 i1 = i6 + 52 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i6);
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i6);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 88;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN8Playable12PrepareFrameERK9FrameDataPS_(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 280 | 0;
 i2 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 i1 = i7 + 24 | 0;
 if ((HEAP16[i1 >> 1] | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i9 = __Z18GetDirectorManagerv() | 0;
 i1 = __ZNK15DirectorManager16GetScriptMethodsEs(i9, HEAP16[i1 >> 1] | 0) | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 + 24 >> 2] = HEAP32[i8 + 56 >> 2];
 HEAPF64[i2 + 16 >> 3] = +HEAPF64[i8 + 32 >> 3];
 HEAPF64[i2 + 8 >> 3] = +HEAPF64[i8 + 8 >> 3];
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 i9 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i9, i5);
 __ZN18ScriptingArguments9AddStructEPKv(i3, i2);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN8JSONRead8TransferI8Vector2fEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 37320 >> 2];
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  i9 = i6 + 56 | 0;
  i8 = (HEAP32[i6 + 44 >> 2] | 0) + ((HEAP32[i9 >> 2] | 0) + -1 << 3) + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2097152;
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1085989 | 0, 0, 0);
  __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 4 | 0, gb + 1085998 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN7mecanim12statemachine21DestroyStateWorkspaceEPNS0_14StateWorkspaceERNS_6memory9AllocatorE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 i4 = i5 + 12 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = i5 + 8 | 0;
  i1 = i5 + 4 | 0;
 } else {
  i1 = i5 + 4 | 0;
  i2 = i5 + 8 | 0;
  i3 = 0;
  do {
   __ZN7mecanim9animation21DestroyBlendTreeInputEPNS0_14BlendTreeInputERNS_6memory9AllocatorE(HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6);
   __ZN7mecanim9animation22DestroyBlendTreeOutputEPNS0_15BlendTreeOutputERNS_6memory9AllocatorE(HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6);
   __ZN7mecanim9animation25DestroyBlendTreeWorkspaceEPNS0_18BlendTreeWorkspaceERNS_6memory9AllocatorE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i5 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0, i5 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 680709 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Cct13BoxController6resizeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 f7 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0));
 mftCall_iif(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, +f1) | 0;
 f1 = Math_fround(f1 - f7);
 i5 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 f7 = Math_fround(f1 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f6 = Math_fround(f1 * Math_fround(HEAPF32[i2 + 40 >> 2]));
 f1 = Math_fround(f1 * Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF64[i4 >> 3] = +f7 + +HEAPF64[i4 >> 3];
 i5 = i4 + 8 | 0;
 HEAPF64[i5 >> 3] = +f6 + +HEAPF64[i5 >> 3];
 i5 = i4 + 16 | 0;
 HEAPF64[i5 >> 3] = +f1 + +HEAPF64[i5 >> 3];
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 8 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN18ScreenManagerWebGL22SetResolutionImmediateEiibi(i3, i4, i5, i6, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i7 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0;
 i2 = i3 + 52 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 if (!((i7 | 0) == -1 | (i7 | 0) == (i1 | 0))) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 363313 | 0, 0, gb + 363219 | 0, 16, 512, 0, 0, 0);
 HEAP32[i2 >> 2] = i1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0) | 0 | i6)) {
  _emscripten_set_canvas_size(i4 | 0, i5 | 0);
  HEAP32[i3 + 64 >> 2] = i4;
  HEAP32[i3 + 68 >> 2] = i5;
 }
 if (!((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0) | 0) ^ i6)) {
  i7 = 1;
  return i7 | 0;
 }
 if (!i6) {
  _emscripten_exit_fullscreen() | 0;
  i7 = 1;
  return i7 | 0;
 }
 if (!(_JS_SystemInfo_HasFullscreen() | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 363393 | 0, 0, gb + 363219 | 0, 33, 1, 0, 0, 0);
  i7 = 0;
  return i7 | 0;
 } else {
  _emscripten_request_fullscreen(0, 1) | 0;
  i7 = 1;
  return i7 | 0;
 }
 return 0;
}

function __ZN15GUIEventManager18RemoveEventAtIndexEi(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 16 | 0;
 i6 = i8;
 i7 = i8 + 8 | 0;
 i9 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = i9 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
 if ((HEAP32[i5 + 8 >> 2] | 0) == (i9 | 0)) i1 = 0; else i1 = (HEAP32[i2 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
 do if (i3) {
  i1 = ((i1 - (HEAP32[i2 >> 2] | 0) | 0) / 52 | 0) + i3 | 0;
  if ((i1 | 0) > 0) {
   i9 = i2 + (((i1 >>> 0) / 78 | 0) << 2) | 0;
   i2 = i9;
   i1 = (HEAP32[i9 >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
   break;
  } else {
   i1 = 77 - i1 | 0;
   i9 = i2 + (((i1 | 0) / -78 | 0) << 2) | 0;
   i2 = i9;
   i1 = (HEAP32[i9 >> 2] | 0) + ((77 - ((i1 | 0) % 78 | 0) | 0) * 52 | 0) | 0;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE5eraseENS_16__deque_iteratorIS1_PKS1_RS6_PKS7_iLi0EEE(i7, i5, i4);
 STACKTOP = i8;
 return;
}

function __ZN13MonoBehaviour18CallMethodInactiveEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 264 | 0;
 i4 = i9 + 256 | 0;
 i5 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9;
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i7, i1, i3, 4);
 if (!(HEAP32[i7 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i7;
 i10 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = i10;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i7, i8);
 HEAP8[i5 + 233 >> 0] = 1;
 HEAP32[i5 + 216 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i5);
 __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i5, i4) | 0;
 i8 = 1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN12AdsIdHandler14SetCachedAdsIdERK8UnityStrb(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 if ((i6 | 0) == (i1 | 0)) {
  i8 = i6 + 16 | 0;
  i7 = i7 & 1;
  HEAP8[i8 >> 0] = i7;
  return;
 }
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
 i3 = i6 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i6 + 8 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i5 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i4, i5 - i4 | 0, i1, 0, i1, i5, i8);
  i8 = i6 + 16 | 0;
  i7 = i7 & 1;
  HEAP8[i8 >> 0] = i7;
  return;
 }
 if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
 if (i5 | 0) _memmove(i1 | 0, i8 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i6 + 4 >> 2] = i5;
  i8 = i6 + 16 | 0;
  i7 = i7 & 1;
  HEAP8[i8 >> 0] = i7;
  return;
 } else {
  HEAP8[i3 >> 0] = i5;
  i8 = i6 + 16 | 0;
  i7 = i7 & 1;
  HEAP8[i8 >> 0] = i7;
  return;
 }
}

function __ZN11UnityEngine15PlatformWrapper14GetDeviceModelEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = __ZN10systeminfo14GetDeviceModelEv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 i5 = _strlen(i4) | 0;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (!i5) {
   i6 = i1;
   i6 = i6 + i5 | 0;
   HEAP8[i6 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i8 = i5 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i6;
 }
 _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 i8 = i1;
 i8 = i8 + i5 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = i7 + 44 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i8 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i8 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i8;
    }
    __ZdlPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i7 + 28 | 0;
 i2 = i7 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 32 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i7 + 16 | 0;
 i2 = i7 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i8 = i7 + 20 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i7;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z33AllocExtractMeshIndicesFromScriptRK4Meshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZNK4Mesh10GetIndicesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj(i1, i5, i2);
 i3 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, i2) | 0;
 if (i2 | 0) {
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  _memcpy(i2 | 0, HEAP32[i5 >> 2] | 0, i1 | 0) | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i6 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 STACKTOP = i7;
 return i3 | 0;
}

function __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i7 = i4;
 i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(80, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 444974 | 0, 756) | 0;
 i10 = gb + 63520 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i5, i6, 0);
 __Z19pop_allocation_rootv();
 i5 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i5) | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, ((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, 4);
 __ZN10GameObject8ActivateEv(i5);
 HEAP32[i6 >> 2] = i3;
 __Z23AddComponentsFromVAListR10GameObjectPKcPi(i5, i2, i6);
 STACKTOP = i4;
 return i5 | 0;
}

function _memccpy(i1, i3, i8, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i8 & 255;
 i4 = i3;
 L1 : do if (!((i4 ^ i1) & 3)) {
  i4 = (i4 & 3 | 0) != 0;
  if ((i2 | 0) != 0 & i4) {
   i5 = i8 & 255;
   do {
    i4 = HEAP8[i3 >> 0] | 0;
    HEAP8[i1 >> 0] = i4;
    if (i4 << 24 >> 24 == i5 << 24 >> 24) break L1;
    i2 = i2 + -1 | 0;
    i3 = i3 + 1 | 0;
    i1 = i1 + 1 | 0;
    i4 = (i3 & 3 | 0) != 0;
   } while ((i2 | 0) != 0 & i4);
  }
  if (!i4) {
   i5 = Math_imul(i6, 16843009) | 0;
   L10 : do if (i2 >>> 0 > 3) do {
    i4 = HEAP32[i3 >> 2] | 0;
    i7 = i4 ^ i5;
    if ((i7 & -2139062144 ^ -2139062144) & i7 + -16843009 | 0) break L10;
    HEAP32[i1 >> 2] = i4;
    i2 = i2 + -4 | 0;
    i3 = i3 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while (i2 >>> 0 > 3); while (0);
   i7 = 11;
  }
 } else i7 = 11; while (0);
 L15 : do if ((i7 | 0) == 11) if (i2) {
  i4 = i8 & 255;
  do {
   i7 = HEAP8[i3 >> 0] | 0;
   HEAP8[i1 >> 0] = i7;
   if (i7 << 24 >> 24 == i4 << 24 >> 24) break L15;
   i2 = i2 + -1 | 0;
   i3 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 return ((HEAP8[i3 >> 0] | 0) == (i8 & 255) << 24 >> 24 ? i1 + 1 | 0 : 0) | 0;
}

function _exp2f(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0, d6 = 0.0, d7 = 0.0, f8 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 > 1123811328) if (i2 >>> 0 > 1124073471 & (i2 | 0) > -1) {
  f1 = Math_fround(f1 * Math_fround(1701411830000000029203285.0e14));
  break;
 } else if ((i2 | 0) < 0 & i2 >>> 0 > 3272998911) {
  f1 = Math_fround(0.0);
  break;
 } else {
  i4 = 7;
  break;
 } else if (i3 >>> 0 < 855638017) f1 = Math_fround(f1 + Math_fround(1.0)); else i4 = 7; while (0);
 if ((i4 | 0) == 7) {
  f8 = Math_fround(f1 + Math_fround(786432.0));
  i2 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0) + 8 | 0;
  i3 = _bitshift64Shl((i2 >>> 4) + 1023 | 0, 0, 52) | 0;
  i4 = getTempRet0() | 0;
  d6 = +Math_fround(f1 - Math_fround(f8 + Math_fround(-786432.0)));
  d7 = +HEAPF64[gb + 8384 + ((i2 & 15) << 3) >> 3];
  d5 = d6 * d7;
  HEAP32[tempDoublePtr >> 2] = i3;
  HEAP32[tempDoublePtr + 4 >> 2] = i4;
  f1 = Math_fround(+HEAPF64[tempDoublePtr >> 3] * (d7 + (d6 * .24022650718688965 + .6931471824645996) * d5 + (d6 * .009618354961276054 + .055505409836769104) * (d6 * d6 * d5)));
 }
 return Math_fround(f1);
}

function _cf2_hintmap_map(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i6 + 13 >> 0] | 0) {
  i4 = i6 + 24 | 0;
  i2 = i1 + -1 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  while (1) {
   if (i1 >>> 0 >= i2 >>> 0) break;
   i3 = i1 + 1 | 0;
   if ((HEAP32[i6 + 28 + (i3 * 20 | 0) + 8 >> 2] | 0) > (i7 | 0)) break; else i1 = i3;
  }
  L8 : do if (!i1) i5 = 11; else {
   while (1) {
    i3 = i6 + 28 + (i1 * 20 | 0) + 8 | 0;
    if ((HEAP32[i3 >> 2] | 0) <= (i7 | 0)) break;
    i1 = i1 + -1 | 0;
    if (!i1) {
     i5 = 11;
     break L8;
    }
   }
   HEAP32[i4 >> 2] = i1;
   i2 = i1;
   i1 = HEAP32[i3 >> 2] | 0;
  } while (0);
  if ((i5 | 0) == 11) {
   HEAP32[i4 >> 2] = 0;
   i1 = HEAP32[i6 + 36 >> 2] | 0;
   if ((i1 | 0) > (i7 | 0)) {
    i7 = _UNITY_FT_MulFix(i7 - i1 | 0, HEAP32[i6 + 16 >> 2] | 0) | 0;
    i7 = (HEAP32[i6 + 40 >> 2] | 0) + i7 | 0;
    return i7 | 0;
   } else i2 = 0;
  }
  i7 = _UNITY_FT_MulFix(i7 - i1 | 0, HEAP32[i6 + 28 + (i2 * 20 | 0) + 16 >> 2] | 0) | 0;
  i7 = (HEAP32[i6 + 28 + (i2 * 20 | 0) + 12 >> 2] | 0) + i7 | 0;
  return i7 | 0;
 }
 i7 = _UNITY_FT_MulFix(i7, HEAP32[i6 + 16 >> 2] | 0) | 0;
 return i7 | 0;
}

function __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13RenderingPathEvRT_RT0_PKc17TransferMetaFlags(i4, i1, gb + 374035 | 0, 0);
 i3 = i1 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 374049 | 0, HEAP32[gb + 36972 >> 2] | 0, i2, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i4 + 16 | 0;
  i6 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = i6 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead8TransferIN7mecanim18ValueArrayConstantEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 899011 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5 + 4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 899030 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN11UnityEngine15CloudWebService17SessionEventQueueD2Ev(i2 + 68 | 0);
 i1 = i2 + 52 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 64 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 if ((HEAP8[i2 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient18GetResponseHeadersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0)) {
  i3 = i1 + 56 | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = i1 + 40 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i3 = i1 + 56 | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i6 = i1 + 32 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i5 | 0);
 i5 = i1 + 36 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc(0, i2, i1 + 56 | 0, i5, mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i6 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (((HEAP32[i5 >> 2] | 0) + -200 | 0) >>> 0 < 5) {
  HEAP32[i3 >> 2] = 1;
  i6 = i1 + 56 | 0;
  STACKTOP = i4;
  return i6 | 0;
 } else {
  HEAP32[i3 >> 2] = 2;
  i6 = i1 + 56 | 0;
  STACKTOP = i4;
  return i6 | 0;
 }
 return 0;
}

function __Z34Animator_CUSTOM_ResetTriggerStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN8Animator12ResetTriggerEi(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0) | 0;
 if ((i2 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function _Vertical_Sweep_Span(i9, i1, i5, i6, i7, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i8 = 0;
 i3 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = 0 - i3 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i4 = (i5 + -1 + i3 & i1) >> i2;
 if ((HEAP16[i7 + 12 >> 1] & 7) == 2) i8 = 3; else if ((i6 - i5 - i3 | 0) > (HEAP32[i9 + 20 >> 2] | 0)) i8 = 3; else i2 = i4;
 if ((i8 | 0) == 3) i2 = (i1 & i6) >> i2;
 if ((i2 | 0) <= -1) return;
 i1 = HEAPU16[i9 + 56 >> 1] | 0;
 if ((i4 | 0) >= (i1 | 0)) return;
 i6 = (i4 | 0) < 0 ? 0 : i4;
 i8 = (i2 | 0) < (i1 | 0) ? i2 : i1 + -1 | 0;
 i4 = i6 << 13 >> 16;
 i5 = i8 << 13 >> 16;
 i6 = 255 >>> (i6 & 7);
 i8 = 127 >>> (i8 & 7) ^ 255;
 i7 = HEAP32[i9 + 60 >> 2] | 0;
 i3 = HEAP32[i9 + 148 >> 2] | 0;
 i1 = i7 + i3 + i4 | 0;
 i2 = i5 - i4 | 0;
 if ((i2 | 0) <= 0) {
  HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | i8 & i6;
  return;
 }
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | i6;
 if ((i2 | 0) != 1) {
  i9 = i4 - i5 | 0;
  _memset(i7 + (i3 + i4 + 1) | 0, -1, i5 + ((i9 | 0) > -2 ? i9 : -2) + 1 - i4 | 0) | 0;
  do {
   i2 = i2 + -1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 | 0) > 1);
 }
 i9 = i1 + 1 | 0;
 HEAP8[i9 >> 0] = HEAPU8[i9 >> 0] | 0 | i8;
 return;
}

function _unity_z_deflateEnd(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!i4) {
  i6 = -2;
  return i6 | 0;
 }
 i5 = i4 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i6 = -2;
  return i6 | 0;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 switch (i6 | 0) {
 case 42:
 case 69:
 case 73:
 case 91:
 case 103:
 case 113:
 case 666:
  break;
 default:
  {
   i6 = -2;
   return i6 | 0;
  }
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i4 + 36 >> 2] | 0, HEAP32[i4 + 40 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i4 + 36 >> 2] | 0, HEAP32[i4 + 40 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 64 >> 2] | 0;
 if (i2) {
  mftCall_vii(HEAP32[i4 + 36 >> 2] | 0, HEAP32[i4 + 40 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i2) {
  i3 = i4 + 40 | 0;
  i2 = i4 + 36 | 0;
 } else {
  i1 = i4 + 36 | 0;
  i3 = i4 + 40 | 0;
  mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0, i2 | 0);
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i1 | 0);
 HEAP32[i5 >> 2] = 0;
 i6 = (i6 | 0) == 113 ? -3 : 0;
 return i6 | 0;
}

function _ungetwc(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 do if ((i1 | 0) == -1) i1 = -1; else {
  i8 = i1 >>> 0 < 128;
  if (i8) i2 = 1; else {
   i2 = _wctomb(i7, i1) | 0;
   if ((i2 | 0) < 0) {
    i1 = -1;
    break;
   }
  }
  if ((HEAP32[i6 + 76 >> 2] | 0) > -1) i5 = ___lockfile(i6) | 0; else i5 = 0;
  i4 = i6 + 74 | 0;
  i10 = HEAP8[i4 >> 0] | 0;
  HEAP8[i4 >> 0] = i10 + 1 | i10;
  if (!(HEAP32[i6 + 8 >> 2] | 0)) {
   if (!(___toread(i6) | 0)) i3 = 8;
  } else i3 = 8;
  if ((i3 | 0) == 8) {
   i3 = i6 + 4 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if (i4 >>> 0 >= ((HEAP32[i6 + 44 >> 2] | 0) + -8 + i2 | 0) >>> 0) {
    if (i8) {
     i10 = i4 + -1 | 0;
     HEAP32[i3 >> 2] = i10;
     HEAP8[i10 >> 0] = i1;
    } else {
     i10 = i4 + (0 - i2) | 0;
     HEAP32[i3 >> 2] = i10;
     _memcpy(i10 | 0, i7 | 0, i2 | 0) | 0;
    }
    HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -17;
    if (!i5) break;
    ___unlockfile(i6);
    break;
   }
  }
  if (!i5) i1 = -1; else {
   ___unlockfile(i6);
   i1 = -1;
  }
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEw(i1, i2, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i3 = i1 + 8 | 0;
 i9 = i3 + 3 | 0;
 i4 = HEAP8[i9 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 if (i5) {
  i2 = (HEAP32[i2 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
  i3 = (HEAP32[i3 >> 2] & 2147483647) + -1 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i2 = (HEAP32[i2 >> 2] | 0) - i1 | 0;
  i3 = 1;
  i6 = i4 & 255;
 }
 i7 = i2 >> 2;
 if ((i3 | 0) == (i6 | 0)) {
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i6, 1, i6, i7, 0, 1);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  if (i5) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  i2 = i6 - i7 | 0;
  i4 = i3 + (i7 << 2) | 0;
  if (i2) __ZNSt3__211char_traitsIwE4moveEPwPKwj(i4 + 4 | 0, i4, i2) | 0;
 }
 HEAP32[i3 + (i7 << 2) >> 2] = i8;
 i2 = i6 + 1 | 0;
 HEAP32[i3 + (i2 << 2) >> 2] = 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  HEAP32[i1 + 4 >> 2] = i2;
  i10 = 14;
 } else {
  i8 = i2 & 255;
  HEAP8[i9 >> 0] = i8;
  if (i8 << 24 >> 24 < 0) i10 = 14;
 }
 if ((i10 | 0) == 14) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i7 << 2) | 0;
}

function __ZNK29ParticleSystemPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i4, i1, i2, i8) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i7 = _strlen(i1) | 0;
 i3 = i1 + i7 | 0;
 if ((i7 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i7 = ~i2;
 } else i7 = 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 << 4) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i9 = 0;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i7;
  return i9 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i9 = 0;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i7;
  return i9 | 0;
 }
 i9 = (HEAP32[i1 + 8 >> 2] | 0) != -1;
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 return i9 | 0;
}

function __ZN8Material14SetMatrixArrayEN9ShaderLab16FastPropertyNameEPK10Matrix4x4fj(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 4 | 0;
 i11 = i12;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i2 + 12 | 0, i8, 2, i9, 64, i10) | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i7, i6);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 683787 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN11UnityEngine15PlatformWrapper13GetDeviceNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = __ZN10systeminfo13GetDeviceNameEv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 i5 = _strlen(i4) | 0;
 if (i5 >>> 0 > 2147483631) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i6 = 4;
 } else if (i5 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i5;
  if (!i5) {
   i6 = i1;
   i6 = i6 + i5 | 0;
   HEAP8[i6 >> 0] = 0;
   STACKTOP = i7;
   return;
  }
 } else i6 = 4;
 if ((i6 | 0) == 4) {
  i8 = i5 + 16 & -16;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i2;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i8, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i1 + 8 >> 2] = i8 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i5;
  i1 = i6;
 }
 _memcpy(i1 | 0, i4 | 0, i5 | 0) | 0;
 i8 = i1;
 i8 = i8 + i5 | 0;
 HEAP8[i8 >> 0] = 0;
 STACKTOP = i7;
 return;
}

function __Z41Camera_CUSTOM_GetStereoProjectionMatricesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 260 >> 2] | 0, 64, 2) | 0;
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 64) | 0;
 if (!i3) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = i5;
 i1 = __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye(i1, 0) | 0;
 i2 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i6 = i6 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i6 | 0) < (i2 | 0));
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i6 = i5 + 64 | 0;
  i1 = __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye(i1, 1) | 0;
  i2 = i6 + 64 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   i6 = i6 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i6 | 0) < (i2 | 0));
  return i4 | 0;
 }
 return 0;
}

function __Z38Animator_Get_Custom_PropParameterCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 __ZN8Animator13GetParametersEv(i8, i2);
 i5 = i8 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = (i2 - i1 | 0) / 36 | 0;
 i4 = i1;
 if (!i1) {
  STACKTOP = i9;
  return i6 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i7 + 4 | 0;
  while (1) {
   i1 = i2 + -36 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -24 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i9;
 return i6 | 0;
}

function __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 if (!i9) {
  i9 = __ZNK6Shader23GetActiveSubShaderIndexEv(i7) | 0;
  return i9 | 0;
 }
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 176 >> 2] | 0;
 i6 = HEAP32[i2 + 180 >> 2] | 0;
 i1 = i6 - i5 >> 3;
 i2 = i5;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i8 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) i1 = -1; else if ((HEAP32[i1 >> 2] | 0) > (i8 | 0)) i1 = -1; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i8 | 0) > -1) {
  if ((i1 | 0) < 0) {
   i1 = __ZNK9ShaderLab9IntShader6GetTagEib(HEAP32[i7 + 32 >> 2] | 0, i8, 1) | 0;
   if ((i1 | 0) < 0) {
    i10 = -1;
    return i10 | 0;
   }
  }
  i1 = __ZNK6Shader24GetSubShaderWithTagValueEii(i9, i8, i1) | 0;
  if ((i1 | 0) == -1) {
   i10 = -1;
   return i10 | 0;
  }
 } else i1 = 0;
 i10 = i1;
 return i10 | 0;
}

function __Z12CanAddScriptR10GameObjectP11Il2CppClassPS2_S3_(i2, i1, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i4 = __ZN23ManagedAttributeManager41GetParentTypeDisallowingMultipleInclusionEP11Il2CppClass(__Z26GetManagedAttributeManagerv() | 0, i1) | 0;
 HEAP32[i5 >> 2] = i4;
 if (!i4) return 1;
 i4 = i2 + 40 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) {
  i6 = 2;
  i6 = (i6 | 0) == 2;
  return i6 | 0;
 }
 i3 = i2 + 28 | 0;
 i2 = 0;
 L7 : while (1) {
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
  if ((i1 | 0) == 0 ? 1 : (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) i1 = 4; else {
   i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
   if (!i1) i1 = 0; else if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[i5 >> 2] | 0) | 0) {
    HEAP32[i6 >> 2] = i1;
    i1 = 1;
   } else i1 = 0;
  }
  switch (i1 & 7) {
  case 4:
  case 0:
   break;
  default:
   {
    i2 = 10;
    break L7;
   }
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (HEAP32[i4 >> 2] | 0)) {
   i1 = 2;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) {
  i6 = (i1 | 0) == 2;
  return i6 | 0;
 }
 return 0;
}

function __ZNK6Camera26GetStereoWorldToClipMatrixE15StereoscopicEye(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (HEAP8[i1 + 1084 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) {
  i5 = __Z12GetIVRDevicev() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i4 | 0, i5 | 0, i1 | 0, i2 | 0);
  i5 = i1 + 424 + (i2 << 6) | 0;
  i7 = i4;
  i8 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   i5 = i5 + 4 | 0;
   i7 = i7 + 4 | 0;
  } while ((i5 | 0) < (i8 | 0));
 }
 i3 = i1 + 424 + (i2 << 6) | 0;
 if (HEAP8[i1 + 1083 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) {
  i5 = __Z12GetIVRDevicev() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i5 | 0, i1 | 0, i2 | 0);
  i5 = i1 + 296 + (i2 << 6) | 0;
  i7 = i4;
  i8 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   i5 = i5 + 4 | 0;
   i7 = i7 + 4 | 0;
  } while ((i5 | 0) < (i8 | 0));
 }
 i8 = i1 + 552 + (i2 << 6) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, i1 + 296 + (i2 << 6) | 0, i8);
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i3 = i1 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 41960 + 8;
  __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i1 + 8 | 0, i7 + 8 | 0);
  i2 = i1 + 28 | 0;
  i7 = i7 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
  i2 = HEAP32[i3 >> 2] | 0;
  i7 = i2 + 4 | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
  if (!(HEAP32[i7 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i3 >> 2] = i1;
 }
 i7 = __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i1, i4, i5, i6) | 0;
 return i7 | 0;
}

function __ZN8Animator25WriteDefaultValuesNoDirtyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 168 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) return;
 i3 = i1 + 144 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i5 = i1 + 132 | 0;
 __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(i2, HEAP32[HEAP32[i5 >> 2] >> 2] | 0);
 __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(HEAP32[i4 >> 2] | 0, HEAP32[HEAP32[i5 >> 2] >> 2] | 0);
 i1 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = i1 + i2 + 40 | 0;
  if (HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if (i2 | 0) __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb(i1, i2, 0);
  }
 }
 i5 = HEAP32[i4 >> 2] | 0;
 __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform(i5, HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 4 >> 2] | 0, 0);
 return;
}

function __ZN7ApiGLES19UploadBufferSubDataEjN2gl12BufferTargetEllPKv(i3, i4, i1, i6, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i5 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i2 = i1;
 i5 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i9 + 860 >> 2] | 0, i2) | 0;
 i2 = i9 + 892 + (i2 << 2) | 0;
 if (!(HEAP8[i9 + 1992 >> 0] | 0)) i10 = 5; else if ((HEAP32[i2 >> 2] | 0) != (i4 | 0)) i10 = 5;
 if ((i10 | 0) == 5) {
  HEAP32[i2 >> 2] = i4;
  mftCall_vii(HEAP32[i9 + 644 >> 2] | 0, i5 | 0, i4 | 0);
 }
 mftCall_viiii(HEAP32[i3 + 660 >> 2] | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 706 >> 0] | 0)) return;
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i2 + 892 + (i1 << 2) >> 2] = 0;
 i10 = HEAP32[i2 + 644 >> 2] | 0;
 mftCall_vii(i10 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0, 0);
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl12onAllocationEjPKcS3_iPv(i1, i7, i8, i5, i6, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 24 | 0;
 i3 = i9;
 i1 = i1 + 16 | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i10 = __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9getHandleEPKc(i1, i8) | 0;
 i8 = __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9getHandleEPKc(i1, i5) | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i7;
 HEAP32[i3 + 12 >> 2] = i10;
 HEAP32[i3 + 16 >> 2] = i8;
 HEAP32[i3 + 20 >> 2] = i6;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_15AllocationEventEEEvT_(i1, i2);
 STACKTOP = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 701805 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE(i5, i1, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i5 + 152 >> 2] = i1;
 i1 = i5 + 148 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i5 + 80 | 0;
 i3 = 0;
 do {
  i7 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0) + 6960 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
  i6 = __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj(i7, 28, 16) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
  HEAP16[i6 + 4 >> 1] = -1;
  HEAP16[i6 + 6 >> 1] = 0;
  i7 = i6 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = gb + 87404 + 8;
  i8 = i6 + 12 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i6 + 16 | 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i6 >> 2] = gb + 147496 + 8;
  HEAP32[i6 + 20 >> 2] = i5;
  HEAP32[i6 + 24 >> 2] = i3;
  HEAP32[i9 >> 2] = 1;
  HEAP32[i8 >> 2] = i4;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  HEAP32[i7 >> 2] = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 return;
}

function __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i4 = i1 + 264 | 0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f7 < Math_fround(.100000001);
 i6 = f7 > Math_fround(1.0e5);
 f7 = i6 ? Math_fround(1.0e5) : f7;
 HEAPF32[i4 >> 2] = i5 ? Math_fround(.100000001) : f7;
 i4 = i1 + 80 | 0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f7 < Math_fround(0.0);
 f7 = i5 ? Math_fround(0.0) : f7;
 HEAPF32[i4 >> 2] = f7;
 i5 = i1 + 88 | 0;
 i6 = i1 + 84 | 0;
 i2 = i1 + 86 | 0;
 HEAP8[i2 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i5, f7, HEAP16[i6 >> 1] | 0) | 0) & 1;
 i3 = i1 + 268 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 i8 = f7 < Math_fround(0.0);
 i9 = f7 > Math_fround(100.0);
 f7 = i9 ? Math_fround(100.0) : f7;
 HEAPF32[i3 >> 2] = i8 ? Math_fround(0.0) : f7;
 i3 = i1 + 278 | 0;
 if (!(HEAP8[i1 + 277 >> 0] | 0)) {
  HEAP8[i3 >> 0] = 0;
  return;
 }
 if (!(HEAP8[i3 >> 0] | 0)) return;
 HEAP16[i6 >> 1] = 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAP8[i2 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i5, Math_fround(0.0), 0) | 0) & 1;
 return;
}

function __ZN22LocalFileSystemHandler10ToAbsoluteEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i3, _strlen(i3) | 0);
 if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i3 | 0) | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  i3 = _strlen(gb + 1546878 | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1546878 | 0, i3);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i5, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 2) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z39Animator_CUSTOM_SetLookAtWeightInternalP12Il2CppObjectfffff(i6, f4, f2, f3, f5, f7) {
 i6 = i6 | 0;
 f4 = Math_fround(f4);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 f7 = Math_fround(f7);
 var i1 = 0, i8 = 0;
 if (!i6) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i8 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 __ZN8Animator19SetLookAtBodyWeightEf(i1, Math_fround(f4 * f2));
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 __ZN8Animator19SetLookAtHeadWeightEf(i1, Math_fround(f4 * f3));
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 __ZN8Animator19SetLookAtEyesWeightEf(i1, Math_fround(f4 * f5));
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6); else {
  __ZN8Animator20SetLookAtClampWeightEf(i1, f7);
  return;
 }
}

function __Z35AllocExtractMeshTrianglesFromScriptRK4Meshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7;
 i3 = (i2 | 0) == -1 ? fb + 505 | 0 : fb + 506 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 mftCall_viii(i3 | 0, i1 | 0, i2 | 0, i5 | 0);
 i3 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0;
 i1 = (HEAP32[i6 >> 2] | 0) - (HEAP32[i5 >> 2] | 0) | 0;
 i2 = i1 >> 2;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, i2) | 0;
 if (i2 | 0) {
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  _memcpy(i2 | 0, HEAP32[i5 >> 2] | 0, i1 | 0) | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return i3 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i6 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 STACKTOP = i7;
 return i3 | 0;
}

function _UNITY_png_icc_check_tag_table(i6, i7, i8, i10, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i11 = 0, i12 = 0;
 i9 = (HEAPU8[i1 + 129 >> 0] | 0) << 16 | (HEAPU8[i1 + 128 >> 0] | 0) << 24 | (HEAPU8[i1 + 130 >> 0] | 0) << 8 | (HEAPU8[i1 + 131 >> 0] | 0);
 if (!i9) {
  i11 = 1;
  return i11 | 0;
 }
 i5 = 0;
 i1 = i1 + 132 | 0;
 while (1) {
  i2 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
  i12 = HEAPU8[i1 + 7 >> 0] | 0;
  i3 = (HEAPU8[i1 + 5 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24 | (HEAPU8[i1 + 6 >> 0] | 0) << 8 | i12;
  i4 = (HEAPU8[i1 + 9 >> 0] | 0) << 16 | (HEAPU8[i1 + 8 >> 0] | 0) << 24 | (HEAPU8[i1 + 10 >> 0] | 0) << 8 | (HEAPU8[i1 + 11 >> 0] | 0);
  if (i12 & 3 | 0) _UNITY_png_icc_profile_error(i6, 0, i8, i2, gb + 351705 | 0);
  if (i3 >>> 0 > i10 >>> 0 | i4 >>> 0 > (i10 - i3 | 0) >>> 0) break;
  i5 = i5 + 1 | 0;
  if (i5 >>> 0 >= i9 >>> 0) {
   i1 = 1;
   i11 = 8;
   break;
  } else i1 = i1 + 12 | 0;
 }
 if ((i11 | 0) == 8) return i1 | 0;
 _UNITY_png_icc_profile_error(i6, i7, i8, i2, gb + 351747 | 0);
 i12 = 0;
 return i12 | 0;
}

function __ZNK13InitialModule10GetGravityERK27ParticleSystemReadOnlyStateRK19ParticleSystemState(i6, i3, i1, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i3 + 2356 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == Math_fround(0.0)) {
  HEAPF32[i6 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i6 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i6 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
 i1 = __Z11GetIPhysicsv() | 0;
 if (!i1) {
  i4 = Math_fround(HEAPF32[i2 >> 2]) != Math_fround(0.0);
  if (i4 & (HEAP8[gb + 1548983 >> 0] | 0) == 0) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 613558 | 0, 0, gb + 613743 | 0, 59, 512, 0, 0, 0);
   HEAP8[gb + 1548983 >> 0] = 1;
   i2 = 0;
   i3 = -1055066685;
   i1 = 0;
  } else {
   i2 = 0;
   i3 = -1055066685;
   i1 = 0;
  }
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i1 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = HEAP32[i4 + 8 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i1;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL23postIslandGenSecondPassEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!((i1 & 476 | 0) == 0 | (i1 & 4194304 | 0) == 0)) {
  __ZN5physx2Sc10NPhaseCore32addToPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i4 + 32 >> 2] | 0) | 0) + 1104 >> 2] | 0, i4);
  i1 = HEAP32[i3 >> 2] & -4194305;
  HEAP32[i3 >> 2] = i1;
 }
 i2 = (i1 & 32768 | 0) != 0;
 if (HEAP16[(HEAP32[i4 + 56 >> 2] | 0) + 114 >> 1] & 2) {
  if (!i2) {
   __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb(i4, 0, 0);
   return;
  }
  if (!(i1 & 8)) return;
  __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i4, 8, 0, 0, 0);
  return;
 }
 if (!i2) return;
 if (!(__ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb(i4, 0, 0) | 0)) return;
 if (HEAP32[i3 >> 2] & 262144 | 0) return;
 i3 = i4 + 32 | 0;
 i2 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0;
 i3 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_(i2, i3, __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i4 + 36 >> 2] | 0) | 0);
 return;
}

function __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10;
 i4 = i9 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 L1 : do if (i5 | 0) {
  i6 = HEAP32[i9 + 40 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = i6 + (i2 << 2) | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i5 >>> 0) break L1;
  }
  i5 = i5 + -1 | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i1 >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
  i5 = HEAPU16[i7 + 4 >> 1] | 0;
  i6 = i7 + (HEAP32[gb + 1457020 + 68 + (i5 << 2) >> 2] | 0) | 0;
  __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i7 + (HEAP32[gb + 1457020 + (i5 << 2) >> 2] | 0) | 0, 0, i7);
  __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i9 + 8 | 0, i6, i8);
  i9 = 1;
  STACKTOP = i10;
  return i9 | 0;
 } while (0);
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 172, gb + 681999 | 0, i3);
 i9 = 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZL26GeomMTDCallback_ConvexMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i5, i4, i1, i6, i2, i7) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 4240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i8 + 4176 | 0;
 i11 = i8 + 4120 | 0;
 i9 = i8 + 4116 | 0;
 i3 = i8;
 i10 = i8 + 4112 | 0;
 HEAP32[i12 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i12, i1);
 HEAP32[i11 >> 2] = -1;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i11, i2);
 HEAP32[i9 >> 2] = 0;
 i1 = i3 + 4096 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i3 + 4100 >> 2] = Math_fround(0.0);
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 if (!(__ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i12, i11, i6, i7, i10, i9, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 if (!(__ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE(i5, i4, HEAP32[i1 >> 2] | 0, i3) | 0)) {
  i12 = 0;
  STACKTOP = i8;
  return i12 | 0;
 }
 i12 = (HEAP32[i1 >> 2] | 0) != 0;
 STACKTOP = i8;
 return i12 | 0;
}

function __Z17IsObjectAvailablei(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i4;
 i3 = HEAP32[gb + 1104264 >> 2] | 0;
 if (!i3) i5 = 6; else {
  if ((HEAP32[i3 + 36 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i3 = HEAP32[i3 + 32 >> 2] | 0;
   i1 = i2 + (i3 << 3) | 0;
  } else {
   __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i1, i3, i2);
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = HEAP32[i3 + 28 >> 2] | 0;
   i7 = HEAP32[gb + 1104264 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? i2 + (HEAP32[i3 + 32 >> 2] << 3) | 0 : i2 + (i1 << 3) | 0;
   i2 = HEAP32[i7 + 28 >> 2] | 0;
   i3 = HEAP32[i7 + 32 >> 2] | 0;
  }
  if ((i1 | 0) == (i2 + (i3 << 3) | 0)) i5 = 6; else if (HEAP32[i1 + 4 >> 2] | 0) {
   i7 = 1;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = __ZN17PersistentManager17IsObjectAvailableEi(__Z20GetPersistentManagerv() | 0, i4) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZNK15NavMeshObstacle21GetWorldCenterAndAxesER8Vector3fS1_S1_S1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 40 | 0;
 i7 = i6;
 i9 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i8, i9, i1 + 44 | 0);
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZNK9Transform11GetRotationEv(i8, i9);
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f(i8, i7);
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 8 >> 2] = i2;
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = HEAP32[i7 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 i3 = HEAP32[i7 + 28 >> 2] | 0;
 i4 = HEAP32[i7 + 32 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN8Material14SetVectorArrayEN9ShaderLab16FastPropertyNameEPK8Vector4fj(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 4 | 0;
 i11 = i12;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i2 + 12 | 0, i8, 1, i9, 16, i10) | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i7, i6);
 STACKTOP = i12;
 return;
}

function __ZN5physx40solveContactCoulomb_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 if (!i10) return; else i9 = 0;
 do {
  __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i11 + (i9 << 5) | 0, 0);
  i1 = HEAP32[i11 + (i9 << 5) + 16 >> 2] | 0;
  i7 = HEAP16[i1 + 2 >> 1] | 0;
  i8 = i1 + (i7 & 65535) | 0;
  if (i7 << 16 >> 16) do {
   i3 = i1 + 48 | 0;
   i2 = HEAP8[i1 + 1 >> 0] | 0;
   i7 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
   if (!(i2 << 24 >> 24)) i1 = i3; else {
    i6 = i2 & 255;
    i5 = 0;
    while (1) {
     i2 = i3 + 32 | 0;
     f4 = Math_fround(HEAPF32[i2 >> 2]);
     i12 = f4 > Math_fround(0.0);
     HEAP32[i2 >> 2] = i12 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
    }
    i1 = i1 + ((Math_imul(i7, i6) | 0) + 48) | 0;
   }
  } while (i1 >>> 0 < i8 >>> 0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i10 | 0));
 return;
}

function __Z32Animator_CUSTOM_SetTriggerStringP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN8Animator10SetTriggerEi(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0) | 0;
 if ((i2 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZNSt3__28ios_base4moveERS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = 0;
 __ZNSt3__26localeC2ERKS0_(i1 + 28 | 0, i2 + 28 | 0);
 i3 = i2 + 32 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 36 | 0;
 HEAP32[i1 + 36 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 40 | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 44 | 0;
 HEAP32[i1 + 44 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 48 | 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 52 | 0;
 HEAP32[i1 + 52 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 56 | 0;
 HEAP32[i1 + 56 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 60 | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 64 | 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i2 = i2 + 68 | 0;
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZNKSt3__212ctype_bynameIwE8do_widenEPKcS3_Pw(i1, i3, i6, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i4 = i1 + 8 | 0;
 i1 = i3;
 while (1) {
  if ((i1 | 0) == (i6 | 0)) {
   i1 = 12;
   break;
  }
  i3 = HEAP8[i1 >> 0] | 0;
  i5 = _uselocale(HEAP32[i4 >> 2] | 0) | 0;
  __THREW__ = 0;
  i3 = invoke_ii(fb + 2807 | 0, i3 | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i1 = 7;
   break;
  }
  if (i5 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i5 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = 6;
    break;
   }
  }
  HEAP32[i2 >> 2] = i3;
  i2 = i2 + 4 | 0;
  i1 = i1 + 1 | 0;
 }
 if ((i1 | 0) == 6) {
  i7 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i7);
 } else if ((i1 | 0) == 7) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i5 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i5 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i7 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i7);
   }
  }
  ___resumeException(i1 | 0);
 } else if ((i1 | 0) == 12) return i6 | 0;
 return 0;
}

function __ZN9AudioClip9LoadSoundEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (!i1) i2 = 5; else if (!(HEAP8[i1 + 224 >> 0] | 0)) i2 = 5; else i1 = i4 + 56 | 0;
 if ((i2 | 0) == 5) {
  i1 = i4 + 56 | 0;
  __ZN11SoundHandle7ReleaseEv(i1);
  i2 = HEAP8[i4 + 72 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i4 + 76 >> 2] | 0; else i2 = i2 & 255;
  if (i2) if (__Z24GetManagerPtrFromContexti(3) | 0) __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i4);
 }
 HEAP32[i3 >> 2] = __ZN9AudioClip11CreateSoundEv(i4) | 0;
 __ZN11SoundHandleaSERKS_(i1, i3);
 __ZN11SoundHandleD2Ev(i3);
 i1 = HEAP32[i4 + 56 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP32[i4 + 124 >> 2] | 0;
 if (!i1) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i1 + 48 >> 2] = 0;
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 678953 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fEC2EPKNS0_20SwInterCollisionDataEjffjPFbPvS7_ER14StackAllocatorILj16EEPNS_13PxProfileZoneE(i6, i8, i9, f3, f5, i4, i2, i1, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f3 = Math_fround(f3);
 f5 = Math_fround(f5);
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i10 = 0;
 HEAP32[i6 + 96 >> 2] = i8;
 HEAP32[i6 + 100 >> 2] = i9;
 HEAP32[i6 + 104 >> 2] = 0;
 HEAP32[i6 + 108 >> 2] = 0;
 HEAP32[i6 + 112 >> 2] = 0;
 i10 = i6 + 120 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i6 + 124 >> 2] = i2;
 HEAP32[i6 + 128 >> 2] = i1;
 HEAP32[i6 + 132 >> 2] = i7;
 HEAPF32[i6 + 32 >> 2] = f3;
 HEAPF32[i6 + 36 >> 2] = f3;
 HEAPF32[i6 + 40 >> 2] = f3;
 HEAP32[i6 + 44 >> 2] = 0;
 f3 = Math_fround(f3 * f3);
 HEAPF32[i6 + 48 >> 2] = f3;
 HEAPF32[i6 + 52 >> 2] = f3;
 HEAPF32[i6 + 56 >> 2] = f3;
 HEAPF32[i6 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i6 + 64 >> 2] = f5;
 HEAPF32[i6 + 68 >> 2] = f5;
 HEAPF32[i6 + 72 >> 2] = f5;
 HEAPF32[i6 + 76 >> 2] = f5;
 HEAP32[i6 + 92 >> 2] = i4;
 if (!i9) return; else {
  i1 = 0;
  i2 = 0;
 }
 do {
  i1 = i1 + (HEAP32[i8 + (i2 * 76 | 0) + 8 >> 2] | 0) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i9 | 0));
 HEAP32[i10 >> 2] = i1;
 return;
}

function __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE(i11, i9) {
 i11 = i11 | 0;
 i9 = i9 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i10 = 0, i12 = 0, f13 = f0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i12 + 12 | 0;
 i10 = i12;
 i8 = HEAP32[i9 >> 2] | 0;
 f6 = Math_fround(Math_fround(6.28318548) / Math_fround(i8 >>> 0));
 HEAP32[i11 >> 2] = 2;
 HEAP32[i11 + 32 >> 2] = 0;
 i7 = i9 + 4 | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 if (i8) {
  i8 = i4 + 4 | 0;
  i5 = i4 + 8 | 0;
  f2 = Math_fround(0.0);
  i3 = 0;
  do {
   f13 = Math_fround(f1 * Math_fround(+Math_cos(+f2)));
   HEAPF32[i4 >> 2] = Math_fround(f1 * Math_fround(+Math_sin(+f2)));
   HEAPF32[i8 >> 2] = f13;
   HEAPF32[i5 >> 2] = Math_fround(0.0);
   __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i11, i4) | 0;
   i3 = i3 + 1 | 0;
   f2 = Math_fround(f6 + f2);
   f1 = Math_fround(HEAPF32[i7 >> 2]);
  } while (i3 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 }
 HEAPF32[i10 >> 2] = Math_fround(0.0);
 HEAPF32[i10 + 4 >> 2] = f1;
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E(i11, i10) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx29PxRigidDynamicGeneratedValuesC2EPKNS_14PxRigidDynamicE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx26PxRigidBodyGeneratedValuesC2EPKNS_11PxRigidBodyE(i2, i1);
 HEAPF32[i2 + 148 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 152 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 244 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 156 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 252 >> 2] | 0, i1 | 0));
 HEAP8[i2 + 160 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAPF32[i2 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 168 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 172 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 280 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 184 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 300 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 188 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0, i2 + 176 | 0, i2 + 180 | 0);
 return;
}

function __ZN3MBP11preallocateEjj(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 | 0) __ZN5physx2Gu9Container7SetSizeEj(i6 + 20 | 0, i1 * 10 | 0) | 0;
 if (!i5) {
  STACKTOP = i7;
  return 1;
 }
 __ZN5physx2Gu9Container7SetSizeEj(i6 + 36 | 0, i5 * 3 | 0) | 0;
 i4 = i6 + 5252 | 0;
 i1 = ((i5 & 31 | 0) != 0 & 1) + (i5 >>> 5) | 0;
 i3 = i6 + 5256 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7 + 1 | 0, i2);
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7, i1 << 2, gb + 717183 | 0, 392) | 0;
 HEAP32[i4 >> 2] = i2;
 _memset(i2 | 0, 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
 i2 = i6 + 52 | 0;
 i1 = i5 << 1;
 if (!i1) {
  STACKTOP = i7;
  return 1;
 }
 if (i1 + -1 & i1) {
  i1 = i5 & 2147483647 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 + 56 >> 2] = i1 + -1;
 HEAP32[i6 + 76 >> 2] = i1;
 __ZN15MBP_PairManager12reallocPairsEv(i2);
 STACKTOP = i7;
 return 1;
}

function __ZN14PhysicsManager26SetTransformMessageEnabledEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i2 + 188 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i5 = i2 + 58 | 0;
  i4 = i3 & 1;
  HEAP8[i5 >> 0] = i4;
  return;
 }
 i5 = i2 + 176 | 0;
 if (i3) {
  i1 = 0;
  do {
   i6 = __ZN14MessageHandler3GetEv() | 0;
   i7 = (Math_imul(HEAP32[i6 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i6 = (HEAP32[i6 + 16 >> 2] | 0) + (i7 >>> 5 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i7 & 31);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  i7 = i2 + 58 | 0;
  i6 = i3 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 } else {
  i1 = 0;
  do {
   i7 = __ZN14MessageHandler3GetEv() | 0;
   i6 = (Math_imul(HEAP32[i7 + 44 >> 2] | 0, HEAP32[gb + 1105016 + 8 >> 2] | 0) | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
   i7 = (HEAP32[i7 + 16 >> 2] | 0) + (i6 >>> 5 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << (i6 & 31));
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  i7 = i2 + 58 | 0;
  i6 = i3 & 1;
  HEAP8[i7 >> 0] = i6;
  return;
 }
}

function __ZN14MemoryProfiler16StaticInitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __ZN13MemoryManager16LowLevelAllocateEj(176) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 _memset(i1 + 16 | 0, 0, 136) | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63584 | 0, 16, gb + 461921 | 0, 120) | 0;
 HEAP32[gb + 1163240 >> 2] = i3;
 HEAP32[i3 + 4 >> 2] = 20;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(80, 16, gb + 63584 | 0, 0, gb + 461921 | 0, 124) | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[gb + 1163244 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63584 | 0, 16, gb + 461921 | 0, 133) | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 + 160 >> 2] = i2;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63584 | 0, 16, gb + 461921 | 0, 134) | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 + 168 >> 2] = i2;
 HEAP32[gb + 1163236 >> 2] = i1;
 return;
}

function __ZN13RuntimeStaticI17UniqueIDGeneratorE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i2 = i8 + 8 | 0;
 i3 = i8;
 i4 = i1 + 16 | 0;
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i6 = __ZnwjRK10MemLabelIdiPKci(24, i5, i6, gb + 1041912 | 0, 65) | 0;
  i2 = gb + 63664 | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN17UniqueIDGeneratorC2E10MemLabelId(i6, i7);
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 } else {
  i6 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(24, i5, i6, i4, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = gb + 63664 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN17UniqueIDGeneratorC2E10MemLabelId(i6, i7);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = i7 + 44 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (i3) {
    i1 = i3 + 32 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if ((i2 | 0) != (i3 + 24 | 0)) {
     i8 = HEAP32[i3 + 28 >> 2] | 0;
     HEAP32[i8 + 8 >> 2] = i2;
     HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = i8;
    }
    __ZdlPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = i7 + 28 | 0;
 i2 = i7 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i8 = i7 + 32 | 0;
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i7 + 16 | 0;
 i2 = i7 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i8 = i7 + 20 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i7;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZL27GeomMTDCallback_SpherePlaneRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i11, i10, i2, i7, i1, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f9 = f0, i12 = 0, f13 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i1;
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + 16 >> 2]);
 f13 = Math_fround(HEAPF32[i7 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i12, i8);
 f6 = Math_fround(HEAPF32[i12 >> 2]);
 f4 = Math_fround(f4 * f6);
 f3 = Math_fround(HEAPF32[i12 + 4 >> 2]);
 f13 = Math_fround(f4 + Math_fround(f13 * f3));
 f4 = Math_fround(HEAPF32[i12 + 8 >> 2]);
 f5 = Math_fround(f13 + Math_fround(f5 * f4));
 f5 = Math_fround(Math_fround(HEAPF32[i12 + 12 >> 2]) + f5);
 if (f5 > f9) {
  i12 = 0;
  STACKTOP = i1;
  return i12 | 0;
 }
 HEAPF32[i11 >> 2] = f6;
 HEAPF32[i11 + 4 >> 2] = f3;
 HEAPF32[i11 + 8 >> 2] = f4;
 f13 = Math_fround(f9 - f5);
 i12 = f13 > Math_fround(0.0);
 HEAPF32[i10 >> 2] = i12 ? f13 : Math_fround(0.0);
 i12 = 1;
 STACKTOP = i1;
 return i12 | 0;
}

function _nextafter(d4, d1) {
 d4 = +d4;
 d1 = +d1;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAPF64[tempDoublePtr >> 3] = d4;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i6 = HEAP32[tempDoublePtr >> 2] | 0;
 i8 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i7 = i5 & 2147483647;
 L1 : do if (i7 >>> 0 > 2146435072 | (i7 | 0) == 2146435072 & i3 >>> 0 > 0) i9 = 3; else {
  i2 = i8 & 2147483647;
  if (i2 >>> 0 > 2146435072 | (i2 | 0) == 2146435072 & i6 >>> 0 > 0) i9 = 3; else if (!((i3 | 0) == (i6 | 0) & (i5 | 0) == (i8 | 0))) {
   do if ((i3 | 0) == 0 & (i7 | 0) == 0) {
    if ((i6 | 0) == 0 & (i2 | 0) == 0) break L1;
    i3 = 1;
    i2 = i8 & -2147483648;
   } else if (i7 >>> 0 > i2 >>> 0 | (i7 | 0) == (i2 | 0) & i3 >>> 0 > i6 >>> 0 | (i8 ^ i5 | 0) < 0) {
    i3 = _i64Add(i3 | 0, i5 | 0, -1, -1) | 0;
    i2 = getTempRet0() | 0;
    break;
   } else {
    i3 = _i64Add(i3 | 0, i5 | 0, 1, 0) | 0;
    i2 = getTempRet0() | 0;
    break;
   } while (0);
   HEAP32[tempDoublePtr >> 2] = i3;
   HEAP32[tempDoublePtr + 4 >> 2] = i2;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 } while (0);
 if ((i9 | 0) == 3) d1 = d4 + d1;
 return +d1;
}

function __ZNSt3__213__vector_baseI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEED2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  STACKTOP = i11;
  return;
 }
 i8 = i9 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i7 = i2 + -32 | 0;
   HEAP32[i8 >> 2] = i7;
   i3 = HEAP32[i2 + -20 >> 2] | 0;
   i4 = i3;
   if (i3 | 0) {
    i5 = i2 + -16 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i4 | 0) >>> 2) << 2);
    __ZdlPv(i3);
   }
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = i4;
   if (i4 | 0) {
    i2 = i2 + -28 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i5 | 0) >>> 2) << 2);
    __ZdlPv(i4);
   }
   i2 = HEAP32[i8 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i9 >> 2] | 0;
 }
 i9 = HEAP32[i9 + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = 6;
 HEAP32[i10 + 4 >> 2] = i9;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i10);
 STACKTOP = i11;
 return;
}

function __ZNK39AssetBundleLoadFromStreamAsyncOperation25CreateTempOutputDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __ZNK23ArchiveStorageConverter16GetDirectoryInfoEv(HEAP32[i1 + 132 >> 2] | 0) | 0;
 if (!i1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i4, gb + 366918 | 0) | 0; else {
  i1 = (HEAP32[i1 >> 2] | 0) + 20 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i4, i1) | 0;
 }
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i5, i3, i4);
 __Z25CreateUniqueTempDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i2, i5, 100);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZNK12b2ChainShape5CloneEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 40) | 0;
 HEAP32[i2 >> 2] = gb + 151604 + 8;
 HEAP32[i2 + 4 >> 2] = 3;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 151644 >> 2];
 i8 = i2 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 i7 = i2 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i2 + 36 | 0;
 HEAP8[i4 >> 0] = 0;
 i3 = i2 + 37 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 8 >> 2];
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i7 >> 2] = i6;
 i6 = __Z7b2Alloci(i6 << 3) | 0;
 HEAP32[i8 >> 2] = i6;
 _memcpy(i6 | 0, i5 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
 i7 = i2 + 20 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP16[i7 + 16 >> 1] = 0;
 i5 = i1 + 20 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = i1 + 28 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i2 + 28 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i1 = HEAP16[i1 + 36 >> 1] | 0;
 HEAP8[i4 >> 0] = i1;
 HEAP8[i3 >> 0] = (i1 & 65535) >>> 8;
 return i2 | 0;
}

function __ZN16MemoryFileSystem8FindNodeEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE(i2, i1, i4);
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_(i2 + 4 | 0, i4) | 0;
 if ((i1 | 0) == (i2 + 8 | 0)) i1 = 0; else i1 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return i1 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN16ControllerFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE(i5, i7, i9, i6, i8) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 136 >> 2] | 0, i9 | 0) | 0) & 4) {
  i9 = 0;
  return i9 | 0;
 }
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 L4 : do if (i1 | 0) {
  i4 = i9;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) != -1) {
   i4 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i2 + 8 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 2) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i9 | 0)) break;
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) break L4;
   }
   if (i1 | 0) {
    i9 = 0;
    return i9 | 0;
   }
  }
 } while (0);
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if (!i1) {
  i9 = 2;
  return i9 | 0;
 }
 i9 = mftCall_iiiiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 | 0, i9 | 0, i6 | 0, i8 | 0) | 0;
 return i9 | 0;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache11BindGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP8[i2 + 14 >> 0] | 0) {
  i4 = __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) | 0;
  return i4 | 0;
 }
 switch (HEAP16[i2 + 12 >> 1] | 0) {
 case 1:
  {
   if ((HEAP32[i2 + 4 >> 2] | 0) != (HEAP32[i1 + 80 >> 2] | 0)) {
    i4 = -1;
    return i4 | 0;
   }
   if (!(HEAP32[i2 >> 2] | 0)) {
    i4 = -1;
    return i4 | 0;
   }
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 7;
   HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 28 >> 2];
   i4 = 100001;
   return i4 | 0;
  }
 case 114:
  {
   i4 = __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) | 0;
   return i4 | 0;
  }
 case 95:
  {
   i4 = 100002;
   return i4 | 0;
  }
 default:
  {
   i4 = __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) | 0;
   return i4 | 0;
  }
 }
 return 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager26ProcessEventQueueJobStaticEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 __ZN11UnityEngine15CloudWebService19SessionEventManager20ProcessEventQueueJobEPNS0_14CloudEventInfoE(i3, i1) | 0;
 i5 = i1 + 44 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (HEAP32[i5 >> 2] | 0) {
  i5 = i3 + 556 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i3 = i3 + -1 | 0;
  HEAP32[i5 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
 if ((HEAP8[i1 + 27 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 + 16 >> 2] | 0;
  i6 = HEAP32[i1 + 28 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i2);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
 i6 = i3 + 556 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + -1 | 0;
 HEAP32[i6 >> 2] = i5;
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer24GetSessionHeaderJsonDataERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i4, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i1 = i2 + 52 | 0;
 i5 = i1 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) i2 = HEAP32[i2 + 56 >> 2] | 0; else i2 = i3 & 255;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, gb + 1046926 | 0, 2) | 0;
 i4 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, gb + 1046923 | 0, 2) | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i1, _strlen(i1) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, gb + 1046929 | 0, 2) | 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN11PreloadData8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i2, i6);
 i3 = i2 + 32 | 0;
 i4 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 461104 | 0, i4, i5, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i6, i3, 0); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i2 + 52 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 470499 | 0, i4, i5, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i6, i2, 0); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __GLOBAL__sub_I_runtime_misc_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1162408 >> 2] = 0;
 i3 = gb + 64160 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162408 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162408 + 12 >> 2] = 16;
 _strncpy(gb + 1162408 + 16 | 0, gb + 443729 | 0, 32) | 0;
 i1 = gb + 1162408 + 47 | 0;
 i2 = i1 + 33 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3403 | 0, fb + 3404 | 0, 0, gb + 1162408 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162496 | 0, gb + 443751 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162508 | 0, gb + 443770 | 0, 10, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546589 | 0, fb + 3405 | 0, fb + 3406 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162520 | 0, gb + 443795 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162532 | 0, gb + 443803 | 0, 11, 0);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 85;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i4 = i2 + 16 | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i4 >> 2] | 0;
  i6 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i3);
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 87;
 HEAP32[i3 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN9allocutil14BuddyAllocator12InternalFreeEjh(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = i4 & 255;
 i9 = HEAP8[i3 + 26 >> 0] | 0;
 i10 = HEAP32[HEAP32[i3 + 8 >> 2] >> 2] | 0;
 L1 : do if (i9 << 24 >> 24 != i4 << 24 >> 24) {
  while (1) {
   i4 = (i1 & 1 | 0) != 0;
   i5 = i1 | 1;
   i6 = i1 >>> 5;
   i7 = i1 & 31;
   i8 = (HEAP32[i10 + (i2 << 5) >> 2] | 0) + (i6 << 2) | 0;
   do i3 = HEAP32[i8 >> 2] | 0; while ((i3 | 0) != (HEAP32[i8 >> 2] | 0));
   i4 = 1 << ((i4 ? i1 & 30 : i5) & 31);
   i5 = (i3 & i4 | 0) == 0;
   HEAP32[i8 >> 2] = i5 ? i3 | 1 << i7 : i3 & ~i4;
   i8 = i10 + (i2 << 5) + 20 | 0;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (i5 ? 1 : -1);
   if (i5) break;
   HEAP32[i10 + (i2 << 5) + 28 >> 2] = i6;
   i8 = i2 + 1 | 0;
   i1 = i1 >>> 1;
   i2 = i8 & 255;
   if (i9 << 24 >> 24 == (i8 & 255) << 24 >> 24) break L1;
  }
  return;
 } while (0);
 i9 = i1 >>> 5;
 i8 = (HEAP32[i10 + (i2 << 5) >> 2] | 0) + (i9 << 2) | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + (1 << (i1 & 31));
 i8 = i10 + (i2 << 5) + 20 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i10 + (i2 << 5) + 28 >> 2] = i9;
 return;
}

function __ZN4core20StringStorageDefaultIcE10reallocateEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!i1) if (i5 >>> 0 < 16) return; else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i4 + 24 | 0, 0, gb + 1047486 | 0, 276) | 0;
  HEAP32[i4 >> 2] = i2;
  i3 = 0;
  i1 = i4 + 4 | 0;
  break;
 } else {
  i2 = i4 + 4 | 0;
  i3 = i5 >>> 0 > 15;
  if (!(HEAP32[i2 >> 2] | 0)) if (i3) {
   i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + 1 | 0, 16, i4 + 24 | 0, 0, gb + 1047486 | 0, 305) | 0;
   HEAP32[i4 >> 2] = i2;
   i3 = 0;
   break;
  } else {
   HEAP32[i4 >> 2] = 0;
   i3 = 0;
   i2 = 0;
   break;
  }
  if (!i3) {
   HEAP32[i4 >> 2] = 0;
   i3 = 1;
   i2 = 0;
   break;
  }
  HEAP32[i4 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i5 + 1 | 0, 16, i4 + 24 | 0, 0, gb + 1047486 | 0, 285) | 0;
  HEAP32[i2 >> 2] = i5;
  return;
 } while (0);
 _memcpy(((i2 | 0) == 0 ? i4 + 4 | 0 : i2) | 0, i1 | 0, (HEAP32[i4 + 20 >> 2] | 0) + 1 | 0) | 0;
 if (i3) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4 + 24 | 0);
 if (!(HEAP32[i4 >> 2] | 0)) return;
 HEAP32[i4 + 4 >> 2] = i5;
 return;
}

function __ZN19SkinnedMeshRenderer15BecameInvisibleEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 467 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 do if (!i1) i4 = 3; else {
  i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i4 = 3; else {
   i3 = i1 & (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0);
   i2 = i5 + 524 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!(i3 ^ (i1 | 0) != 0)) return;
   if (!i3) {
    if (i1 | 0) break;
    return;
   }
   if ((i2 | 0) == (gb + 1161628 | 0)) return;
   if (!i1) i1 = i5 + 528 | 0; else {
    i5 = i5 + 528 | 0;
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
    HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i5 >> 2] = 0;
    i1 = i5;
   }
   i5 = HEAP32[gb + 1161628 >> 2] | 0;
   HEAP32[i2 >> 2] = i5;
   HEAP32[i1 >> 2] = gb + 1161628;
   HEAP32[i5 + 4 >> 2] = i2;
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   return;
  }
 } while (0);
 if ((i4 | 0) == 3) {
  i2 = i5 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) return;
 }
 i5 = i5 + 528 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN17ProfilerFrameData10ThreadDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 132 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 120 | 0);
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN16b2PrismaticJoint16SetMaxMotorForceEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 128 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 128 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 128 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN15b2RevoluteJoint17SetMaxMotorTorqueEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 104 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 104 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 104 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEE7SortJobEPS6_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i2 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i5);
 } else i1 = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_(i8, i7, i2, i5);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEE7SortJobEPS6_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i2 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i5);
 } else i1 = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_(i8, i7, i2, i5);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjjc(i10, i7, i2, i8, i9) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0;
 i11 = i10 + 11 | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 if (i4) i6 = HEAP32[i10 + 4 >> 2] | 0; else i6 = i1 & 255;
 if (i6 >>> 0 < i7 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i10);
 i3 = i6 - i7 | 0;
 i5 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
 if (i4) i1 = (HEAP32[i10 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 if ((i5 - i6 + i1 | 0) >>> 0 < i8 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i10, i1, i6 + i8 - i5 - i1 | 0, i6, i7, i5, i8);
  i2 = HEAP32[i10 >> 2] | 0;
 } else {
  if (i4) i2 = HEAP32[i10 >> 2] | 0; else i2 = i10;
  if ((i5 | 0) != (i8 | 0)) {
   i1 = i3 - i5 | 0;
   if (i1) {
    i4 = i2 + i7 | 0;
    _memmove(i4 + i8 | 0, i4 + i5 | 0, i1 | 0) | 0;
   }
  }
 }
 if (i8 | 0) _memset(i2 + i7 | 0, i9 | 0, i8 | 0) | 0;
 i1 = i8 - i5 + i6 | 0;
 if ((HEAP8[i11 >> 0] | 0) < 0) HEAP32[i10 + 4 >> 2] = i1; else HEAP8[i11 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 return i10 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 679703 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 740105 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 725526 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN24MeshIntermediateRendererC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP16[i1 + 184 >> 1] = 0;
 HEAP16[i1 + 186 >> 1] = 0;
 HEAP32[i1 + 188 >> 2] = -2147450880;
 HEAP32[i1 + 192 >> 2] = 0;
 i2 = i1 + 236 | 0;
 i3 = (HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16515072 | 1353;
 HEAP16[i2 >> 1] = i3;
 HEAP8[i2 + 2 >> 0] = i3 >>> 16;
 i2 = i1 + 228 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 232 >> 2] = -1;
 HEAP8[i1 + 240 >> 0] = 1;
 HEAP8[i1 + 241 >> 0] = 1;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 i2 = i1 + 264 | 0;
 HEAP32[i1 >> 2] = gb + 33604 + 8;
 HEAP32[i2 >> 2] = gb + 33604 + 84;
 HEAP32[i1 + 268 >> 2] = 0;
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP32[i1 + 276 >> 2] = i2;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 return;
}

function __ZN19ShaderPropertySheet18SetTexturePropertyERKN9ShaderLab16FastPropertyNameERKNS_15TexturePropertyE(i6, i2, i7) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i4 = HEAP32[i6 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i4 | 0)) {
  i5 = HEAP32[i6 + 32 >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) {
    i8 = 7;
    break L1;
   }
  }
  if ((i1 | 0) > -1) i1 = HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575; else i8 = 7;
 } else i8 = 7; while (0);
 if ((i8 | 0) == 7) i1 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i6, i2, 0) | 0;
 i8 = (HEAP32[i6 + 72 >> 2] | 0) + i1 | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i8 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 HEAP32[i8 + 20 >> 2] = HEAP32[i7 + 20 >> 2];
 HEAP32[i8 + 24 >> 2] = HEAP32[i7 + 24 >> 2];
 HEAP32[i8 + 28 >> 2] = HEAP32[i7 + 28 >> 2];
 return;
}

function __ZN19LightProbeOcclusion8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i2;
 i3 = HEAP32[gb + 37256 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 378493 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi1EEEEvRT_17TransferMetaFlags(i5, i6, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i2 + 4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 378511 | 0, i3, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi1EEEEvRT_17TransferMetaFlags(i5, i6, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i7;
 return;
}

function __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 24 | 0;
 i5 = i7 + 16 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 125 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZN18GfxFramebufferGLES7PrepareEv(i1);
 __ZN18GfxFramebufferGLES37GetFramebufferNameFromDepthAttachmentEP17RenderSurfaceBase(i4, i1, i2);
 i11 = i1 + 168 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = HEAP32[i1 + 336 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = i10;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_iiNS0_15FramebufferMaskE(i9, i5, 3, i6, i8, i2, 1);
 __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i1, 2);
 STACKTOP = i7;
 return;
}

function __ZN13dynamic_arrayIP8MaterialLj4EE18resize_initializedEjRKS1_12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 2) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13GfxDeviceGLES23GetNativeTexturePointerE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[gb + 1157724 >> 2] | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i3, i1, i4);
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  i3 = HEAP32[gb + 1157724 >> 2] | 0;
  i1 = (i2 | 0) == -1 ? i4 + (HEAP32[i1 + 32 >> 2] << 3) | 0 : i4 + (i2 << 3) | 0;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i3 = HEAP32[i3 + 32 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13ComputeBufferC2Ejjj(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i8 = i9;
 HEAP32[i7 >> 2] = i1;
 i5 = i7 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 i4 = i7 + 8 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = i7 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i7 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i7 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = i7;
 if ((i2 | 0) != (gb + 1166280 | 0)) {
  i10 = HEAP32[gb + 1166280 >> 2] | 0;
  HEAP32[i2 >> 2] = i10;
  HEAP32[i3 >> 2] = gb + 1166280;
  HEAP32[i10 + 4 >> 2] = i2;
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 }
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 744 >> 2] | 0, i2 | 0) | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 804 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 i3 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 mftCall_viiiii(i11 | 0, i2 | 0, i6 | 0, i3 | 0, i7 | 0, i10 | 0);
 STACKTOP = i9;
 return;
}

function __Z44Physics_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK8Vector3fS1_S1_P11Il2CppArrayRK11Quaternionffi23QueryTriggerInteraction(i1, i2, i3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, f10 = f0, f11 = f0, i12 = 0;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f10 * f10);
 f11 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f11 = Math_fround(f10 + Math_fround(f11 * f11));
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f10 * f10))));
 if (!(f10 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 44) | 0;
 i12 = __Z17GetPhysicsManagerv() | 0;
 i1 = __ZN14PhysicsManager15BoxCastNonAllocERK8Vector3fS2_S2_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction(i12, i1, i2, i3, i9, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0, i5, f6, i7, i8) | 0;
 if (!i1) {
  i12 = 0;
  return i12 | 0;
 } else i2 = 0;
 do {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i9 + (i2 * 44 | 0) | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i1 | 0;
}

function _tmpnam(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10 + 32 | 0;
 i8 = i10 + 24 | 0;
 i7 = i10 + 8 | 0;
 i2 = i10;
 i9 = i10 + 40 | 0;
 i5 = i10 + 48 | 0;
 HEAP32[i9 >> 2] = i1;
 if (!i1) HEAP32[i9 >> 2] = gb + 1576148;
 HEAP32[i2 >> 2] = gb + 1075291;
 HEAP32[i2 + 4 >> 2] = 7;
 if (!(___syscall33(33, i2 | 0) | 0)) {
  i3 = i5 + 4 | 0;
  i4 = i9;
  i1 = 0;
  while (1) {
   HEAP32[i7 >> 2] = 0;
   HEAP32[i7 + 4 >> 2] = i5;
   HEAP32[i7 + 8 >> 2] = 0;
   ___syscall265(265, i7 | 0) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
   i11 = HEAP32[i3 >> 2] ^ i4 ^ i2;
   i12 = HEAP32[gb + 1470396 >> 2] | 0;
   HEAP32[gb + 1470396 >> 2] = i12 + 1;
   HEAP32[i8 >> 2] = i12;
   HEAP32[i8 + 4 >> 2] = i11;
   _snprintf(i2, 20, gb + 1075296 | 0, i8) | 0;
   HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i6 + 4 >> 2] = 0;
   if (___syscall33(33, i6 | 0) | 0) break;
   i2 = i1 + 1 | 0;
   if ((i1 | 0) < 100) i1 = i2; else {
    i1 = i2;
    break;
   }
  }
  i1 = (i1 | 0) > 99 ? 0 : HEAP32[i9 >> 2] | 0;
 } else i1 = 0;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN5physx7NpActor26removeConstraintsFromSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 i10 = HEAP32[i1 + 40 >> 2] | 0;
 i9 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i10) return; else i8 = 0;
 while (1) {
  if (!(HEAP8[i9 + (i8 << 3) >> 0] | 0)) {
   i3 = HEAP32[i9 + (i8 << 3) + 4 >> 2] | 0;
   if (!i3) {
    i1 = 14;
    break;
   }
   i4 = __ZNK5physx12NpConstraint10getNpSceneEv(i3) | 0;
   if (i4 | 0) {
    i5 = i4 + 3540 | 0;
    i6 = i4 + 3544 | 0;
    i7 = HEAP32[i6 >> 2] | 0;
    L12 : do if (!i7) i1 = 0; else {
     i2 = HEAP32[i5 >> 2] | 0;
     i1 = 0;
     do {
      if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break L12;
      i1 = i1 + 1 | 0;
     } while (i1 >>> 0 < i7 >>> 0);
    } while (0);
    if ((i1 | 0) != (i7 | 0)) {
     i2 = i7 + -1 | 0;
     HEAP32[i6 >> 2] = i2;
     i7 = HEAP32[i5 >> 2] | 0;
     HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i2 << 2) >> 2];
    }
    __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE(i4 + 16 | 0, i3 + 16 | 0);
   }
  }
  i8 = i8 + 1 | 0;
  if (i8 >>> 0 >= i10 >>> 0) {
   i1 = 14;
   break;
  }
 }
 if ((i1 | 0) == 14) return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 678028 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 703464 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739987 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 739869 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 710070 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 723349 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_(i3, i4, i5, i6, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i7 + 144 | 0;
 i16 = i7 + 128 | 0;
 i17 = i7 + 112 | 0;
 i14 = i7 + 96 | 0;
 i15 = i7 + 80 | 0;
 i11 = i7 + 64 | 0;
 i12 = i7 + 48 | 0;
 i8 = i7 + 32 | 0;
 i9 = i7 + 16 | 0;
 i10 = i7;
 __ZanRK8Scalar4fS1_(i13, i2, i1);
 __ZmlRK8Scalar4fS1_(i17, i4, i13);
 __ZmiRK8Scalar4fS1_(i16, i3, i17);
 __ZN8Scalar4faSERKS_(i3, i16) | 0;
 i4 = i3 + 16 | 0;
 __ZmlRK8Scalar4fS1_(i15, i5, i13);
 __ZmiRK8Scalar4fS1_(i14, i4, i15);
 __ZN8Scalar4faSERKS_(i4, i14) | 0;
 i5 = i3 + 32 | 0;
 __ZmlRK8Scalar4fS1_(i12, i6, i13);
 __ZmiRK8Scalar4fS1_(i11, i5, i12);
 __ZN8Scalar4faSERKS_(i5, i11) | 0;
 i6 = i3 + 96 | 0;
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i10, i7 + 160 | 0);
 __ZanRK8Scalar4fS1_(i9, i10, i1);
 __ZplRK8Scalar4fS1_(i8, i6, i9);
 __ZN8Scalar4faSERKS_(i6, i8) | 0;
 STACKTOP = i7;
 return;
}

function __ZN15TerrainColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i9 = i4 + 8 | 0;
 i7 = i2;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 187060 + 8;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i1;
 i2 = i6;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 64 >> 0] = 1;
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 STACKTOP = i4;
 return;
}

function __ZN13RuntimeStaticI22VirtualJoystickManagerE7DestroyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 if (!i6) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i3 = i6 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i6 + 24 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i8 = i2 + -16 | 0;
    HEAP32[i4 >> 2] = i8;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i3 = i6 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i4 = i6 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i8 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i8;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZdlPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN13InitialModuleC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 83624 + 8;
 __ZN11MinMaxCurveC2Ev(i1 + 8 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 272 | 0);
 __ZN8GradientC2Ev(i1 + 536 | 0);
 __ZN8GradientC2Ev(i1 + 608 | 0);
 i2 = i1 + 680 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP16[i1 + 688 >> 1] = 0;
 __ZN11MinMaxCurveC2Ev(i1 + 692 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 956 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1220 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1484 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 1748 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 2012 | 0);
 __ZN11MinMaxCurveC2Ev(i1 + 2276 | 0);
 i2 = i1 + 2556 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 2572 >> 2] = 1;
 HEAP32[i1 + 2576 >> 2] = 1;
 HEAP32[i1 + 2580 >> 2] = 1;
 HEAP32[i1 + 2584 >> 2] = 1;
 HEAP32[i1 + 2588 >> 2] = 1812433254;
 HEAP32[i1 + 2592 >> 2] = 1812433254;
 HEAP32[i1 + 2596 >> 2] = 1812433254;
 HEAP32[i1 + 2600 >> 2] = 1812433254;
 HEAP32[i1 + 2604 >> 2] = 1900727103;
 HEAP32[i1 + 2608 >> 2] = 1900727103;
 HEAP32[i1 + 2612 >> 2] = 1900727103;
 HEAP32[i1 + 2616 >> 2] = 1900727103;
 __ZN13InitialModule5ResetEv(i1);
 return;
}

function __Z31ComputeShader_CUSTOM_SetTextureP12Il2CppObjectiiS0_(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9 + 12 | 0;
 i6 = i9 + 8 | 0;
 i7 = i9 + 4 | 0;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 HEAP32[i6 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i8 + 48 >> 2];
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 148 >> 2] | 0, i8 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 if (__ZN13ComputeShader15SetTextureParamEjRKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension(i1, i4, i6, i2, i8) | 0) {
  STACKTOP = i9;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509162 | 0, i9);
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 684278 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 740225 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 725646 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Gu11ReadIndicesEtjPtRNS_13PxInputStreamEb(i1, i7, i6, i5, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 if ((i1 & 65535) < 256) {
  i2 = STACKTOP;
  STACKTOP = STACKTOP + ((1 * i7 | 0) + 15 & -16) | 0;
  if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
  mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, i7 | 0) | 0;
  if (!i7) {
   STACKTOP = i8;
   return;
  } else i1 = 0;
  do {
   HEAP16[i6 + (i1 << 1) >> 1] = HEAPU8[i2 + i1 >> 0] | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i8;
  return;
 }
 i1 = i7 << 1;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + ((1 * i1 | 0) + 15 & -16) | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i3 | 0, i1 | 0) | 0;
 i2 = (i7 | 0) == 0;
 if (!(i2 | i4 ^ 1)) {
  i1 = 0;
  do {
   i9 = i3 + (i1 << 1) | 0;
   i4 = HEAP8[i9 >> 0] | 0;
   i5 = i9 + 1 | 0;
   HEAP8[i9 >> 0] = HEAP8[i5 >> 0] | 0;
   HEAP8[i5 >> 0] = i4;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
 }
 if (i2) {
  STACKTOP = i8;
  return;
 }
 _memcpy(i6 | 0, i3 | 0, i7 << 1 | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN5Umbra9Matrix3x311flushToZeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2]))) <= 1.0e-15) HEAPF32[i2 >> 2] = Math_fround(0.0);
 i1 = i2 + 4 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 8 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 12 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 16 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 20 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 24 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 28 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 32 | 0;
 if (!(+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15)) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN2UI14CanvasRenderer9SyncColorENS0_8SyncFlagE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (i2 & 1 | 0) {
  i4 = HEAP32[i1 + 204 >> 2] | 0;
  i3 = i4 + 112 | 0;
  HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
  i3 = HEAP32[i1 + 208 >> 2] | 0;
  i4 = HEAP32[i4 + 84 >> 2] | 0;
  i7 = HEAP32[i1 + 36 >> 2] | 0;
  i6 = HEAP32[i1 + 40 >> 2] | 0;
  i5 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i4 + (i3 * 672 | 0) + 628 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i4 + (i3 * 672 | 0) + 632 >> 2] = i7;
  HEAP32[i4 + (i3 * 672 | 0) + 636 >> 2] = i6;
  HEAP32[i4 + (i3 * 672 | 0) + 640 >> 2] = i5;
  HEAP16[i4 + (i3 * 672 | 0) + 664 >> 1] = 4;
 }
 if (!(i2 & 2)) return;
 i6 = HEAP32[i1 + 220 >> 2] | 0;
 i7 = i6 + 112 | 0;
 HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 0 | 2;
 i7 = HEAP32[i1 + 224 >> 2] | 0;
 i6 = HEAP32[i6 + 84 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i5 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i6 + (i7 * 672 | 0) + 628 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i6 + (i7 * 672 | 0) + 632 >> 2] = i3;
 HEAP32[i6 + (i7 * 672 | 0) + 636 >> 2] = i4;
 HEAP32[i6 + (i7 * 672 | 0) + 640 >> 2] = i5;
 HEAP16[i6 + (i7 * 672 | 0) + 664 >> 1] = 4;
 return;
}

function __ZN16b2PrismaticJoint13SetMotorSpeedEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 132 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 132 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 132 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN13SplatDatabase16AllocateAlphamapERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 24 | 0;
 i6 = i3 + 8 | 0;
 i7 = i3;
 i5 = i3 + 12 | 0;
 i10 = gb + 63520 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 i4 = __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(0, i4) | 0;
 i7 = HEAP32[i1 + 36 >> 2] | 0;
 __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i4, i7, i7, 5, 1) | 0;
 __ZN7Texture11SetWrapModeEi(i4, 1);
 __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf(i4, i2);
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i6 >> 2] = (HEAP32[i1 + 16 >> 2] | 0) - (HEAP32[i1 + 12 >> 2] | 0) >> 2;
 __Z6FormatPKcz(i5, gb + 934259 | 0, i6);
 mftCall_vii(i2 | 0, i4 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12b2WheelJoint17SetMaxMotorTorqueEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 120 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 120 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 120 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher23PreformRetryWebDispatchEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i1 = i2 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) return;
 i1 = HEAP32[i4 + 104 + 4 >> 2] | 0;
 i5 = _time(0) | 0;
 if (!((i1 + -1 | 0) >>> 0 < i5 >>> 0 ? ((HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 8 >> 2] | 0) + -1 | 0) >>> 0 < (i5 - i1 | 0) >>> 0 : 0)) {
  __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv(i2);
  return;
 }
 i1 = i2 + 92 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i4 + 16 | 0;
 if (__ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i4, i1) | 0) {
  __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
  HEAP32[i3 >> 2] = 0;
  HEAP8[i2 + 52 >> 0] = 1;
  __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv(i2);
  return;
 } else {
  __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr(i4, i1);
  __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE(i2, i4);
  return;
 }
}

function __Z26Texture2D_CUSTOM_SetPixelsP12Il2CppObjectiiiiP11Il2CppArrayi(i3, i4, i5, i6, i7, i8, i9) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP8[i1 + 111 >> 0] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (!(i1 << 24 >> 24)) {
  HEAP32[i10 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i10);
 } else {
  i10 = __Z21GetScriptingArraySizeP11Il2CppArray(i8) | 0;
  __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii(i2, i4, i5, i6, i7, i10, __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 16) | 0, i9, 0);
  STACKTOP = i11;
  return;
 }
}

function __ZNK14SphereCollider15GetScaledRadiusERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3;
 __ZNK9Transform18GetWorldScaleLossyEv(i8, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f4 = Math_fround(HEAPF32[i8 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 f6 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 8 >> 2]));
 i2 = f4 < Math_fround(0.0);
 f7 = Math_fround(-f4);
 f4 = i2 ? f7 : f4;
 i2 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f6 = i2 ? f7 : f6;
 i2 = f5 < Math_fround(0.0);
 f7 = Math_fround(-f5);
 f5 = i2 ? f7 : f5;
 f4 = f4 < f6 ? f6 : f4;
 f4 = Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * (f4 < f5 ? f5 : f4));
 i2 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f4 = i2 ? f5 : f4;
 i2 = f4 < Math_fround(9.99999974e-06);
 f4 = i2 ? Math_fround(9.99999974e-06) : f4;
 STACKTOP = i3;
 return Math_fround(f4);
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 706391 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_11PxsBodyCoreENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 721341 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 725762 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 683374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 722866 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx14NpArticulation14setWakeCounterEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = i4 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 88 | 0;
  i3 = 0;
  do {
   __ZN5physx3Scb4Body14setWakeCounterEf((HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 48 | 0, f5);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i2 = i4 + 12 | 0;
 HEAPF32[i4 + 60 >> 2] = f5;
 i3 = i4 + 16 | 0;
 switch ((HEAP32[i3 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i6 = 8;
   break;
  }
 default:
  {
   i1 = HEAP32[i2 >> 2] | 0;
   i6 = 8;
  }
 }
 if ((i6 | 0) == 8) {
  if (f5 > Math_fround(0.0) & (i1 | 0) != 0) HEAP8[i4 + 64 >> 0] = 0;
  __ZN5physx2Sc16ArticulationCore14setWakeCounterEf(i4 + 24 | 0, f5);
  return;
 }
 if (f5 > Math_fround(0.0)) {
  HEAP8[i4 + 64 >> 0] = 0;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i2);
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -897 | 640;
  return;
 } else {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i2);
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 128;
  return;
 }
}

function __ZN15b2RevoluteJoint13SetMotorSpeedEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 108 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 108 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 108 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN14ParticleSystem25AddParticleSystemRendererEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 16 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 80260 | 0) | 0) {
  STACKTOP = i5;
  return;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, 199, 0, i2) | 0;
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 i1 = i6 << 24 >> 24 < 0;
 if ((i1 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255) | 0) {
  HEAP32[i4 >> 2] = i1 ? HEAP32[i2 >> 2] | 0 : i2;
  __Z6FormatPKcz(i3, gb + 1074693 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 612988 | 0, 2461, 4, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i5;
 return;
}

function __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 1, 2, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 2, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 1) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP16[i3 + (i1 << 1) >> 1] = HEAP16[i9 >> 1] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 16 | 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i5 = __ZnwjRK10MemLabelIdiPKci(24, i4, i5, gb + 1041912 | 0, 65) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i5 + 21 >> 0] = 1;
  HEAP32[i1 >> 2] = i5;
  STACKTOP = i6;
  return;
 } else {
  i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(24, i4, i5, i3, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP8[i5 + 21 >> 0] = 1;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i5;
  STACKTOP = i6;
  return;
 }
}

function __Z43AnimationCurve_CUSTOM_INTERNAL_CALL_MoveKeyP12Il2CppObjectiRK16KeyframeTplFloat(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 32 | 0;
 i7 = i8 + 8 | 0;
 i6 = i8;
 i5 = i8 + 16 | 0;
 if ((i3 | 0) <= -1) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544420 | 0, i7);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 if ((HEAP32[i1 + 68 >> 2] | 0) > (i3 | 0)) {
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i7 = __Z12MoveCurveKeyR17AnimationCurveTplIfEi11KeyframeTplIfE(i1, i3, i2) | 0;
  STACKTOP = i8;
  return i7 | 0;
 } else __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544420 | 0, i7);
 return 0;
}

function __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 20 | 0) + 1 | 0;
 if (i3 >>> 0 > 214748364) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 20 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 107374182 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 214748364;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 20 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 20 | 0) * 20 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -20 | 0) * 20 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 20;
 HEAP32[i8 >> 2] = i6 + (i4 * 20 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9BoxPruner13resizeObjectsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i3 + 68 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + 128 | 0;
 i1 = i7 >>> 0 > 536870911 ? -1 : i7 << 3;
 if (!i1) i4 = 0; else {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i9 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i4 = mftCall_iiiiii(i9 | 0, i2 | 0, i1 | 0, (i4 ? gb + 717519 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1310) | 0;
 }
 if (i7 | 0) {
  i1 = i4 + (i7 << 3) | 0;
  i2 = i4;
  do {
   HEAP32[i2 + 4 >> 2] = -1;
   i2 = i2 + 8 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i1 = HEAP32[i3 + 64 >> 2] | 0;
 i2 = i3 + 76 | 0;
 if (i1 | 0) _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, i1 << 3 | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i6 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i6 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 681584 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 716358 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 722754 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 745374 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Gu17RadixSortBuffered4SortEPKfj(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 5136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 1024 | 0;
 i2 = i10;
 i3 = i10 + 5121 | 0;
 i4 = i10 + 5120 | 0;
 if ((i7 | 0) == 0 | (i8 | 0) < 1) {
  STACKTOP = i10;
  return i9 | 0;
 }
 i5 = i9 + 4 | 0;
 i6 = HEAP32[i5 >> 2] & 2147483647;
 if ((i6 | 0) != (i8 | 0)) {
  if (i6 >>> 0 < i8 >>> 0) if (HEAP8[i9 + 32 >> 0] | 0) {
   i6 = i9 + 12 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i6 >> 2] | 0);
   HEAP32[i6 >> 2] = 0;
   i12 = i9 + 8 | 0;
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i12 >> 2] | 0);
   HEAP32[i12 >> 2] = 0;
   i11 = i8 << 2;
   HEAP32[i12 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i11, gb + 657536 | 0, 53) | 0;
   HEAP32[i6 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i11, gb + 657536 | 0, 54) | 0;
  }
  HEAP32[i5 >> 2] = i8 | -2147483648;
 }
 HEAP32[i9 + 16 >> 2] = i1;
 HEAP32[i9 + 20 >> 2] = i2;
 __ZN5physx2Gu9RadixSort4SortEPKfj(i9, i7, i8) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN18StreamedBinaryReadILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i8, i1, i2, i9, i3, i4) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i8 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i4 = i8 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i6 >> 2] = i3;
 }
 HEAP32[i9 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i1 = HEAP32[i5 >> 2] | 0;
 } else {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i6 >> 2] = i1;
  i1 = i4;
 }
 HEAP32[i9 + 4 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i8, i9 + 8 | 0, 1);
 __ZN12CachedReader10Align4ReadEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN14ParticleSystemD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 82792 + 8;
 __ZN14ParticleSystem15ThreadedCleanupEv(i2);
 HEAP32[i2 + 264 >> 2] = gb + 83016 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 + 48 >> 2] = gb + 83032 + 8;
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = gb + 29060 + 8;
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 29060 + 8;
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14BillboardAsset5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 i2 = i1 + 28 | 0;
 i3 = i1 + 44 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 32 | 0);
  HEAP32[i2 >> 2] = 0;
  i5 = HEAP32[i4 >> 2] | 0;
 } else i5 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 48 | 0;
 i2 = i5 + 64 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else i3 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 68 | 0;
 i2 = i3 + 84 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i5 = i3 + 80 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 72 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i3 + 80 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_10StaticCoreE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i1 = __ZNK5physx2Sc10StaticCore6getSimEv(i1) | 0;
 if (!i1) return;
 i3 = i1;
 i5 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 59, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i5 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i3;
 i4 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
 i5 = getTempRet0() | 0;
 i2 = _i64Add(i2 | 0, 0, 19, 0) | 0;
 i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
 i1 = getTempRet0() | 0;
 i5 = _i64Subtract(1, 0, i4 | 0, i5 | 0) | 0;
 i1 = _i64Add(i5 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
 i2 = getTempRet0() | 0;
 while (1) {
  i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i2 = getTempRet0() | 0;
  if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 680849 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN14SafeBinaryRead8TransferIN7mecanim9animation19Blend1dDataConstantEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 4 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 904041 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i5 + 4;
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i6 + 8 >> 2] = i1;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 903818 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __Z35DebugLogHandler_CUSTOM_Internal_Log7LogTypeP12Il2CppStringP12Il2CppObject(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 switch (i1 | 0) {
 case 3:
  {
   i1 = 17408;
   break;
  }
 case 2:
  {
   i1 = 16896;
   break;
  }
 case 0:
  {
   i1 = 16640;
   break;
  }
 case 4:
  {
   i1 = 147456;
   break;
  }
 default:
  i1 = 2113536;
 }
 do if (!i4) i3 = 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) i3 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 __ZNK11ICallString6ToUTF8Ev(i6, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 511374 | 0, 51, i1, i3, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __Z10DecodeRGBMiiPhi13TextureFormat10RGBMRanges(i13, i14, i2, i15, i1, i16) {
 i13 = i13 | 0;
 i14 = i14 | 0;
 i2 = i2 | 0;
 i15 = i15 | 0;
 i1 = i1 | 0;
 i16 = i16 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i17 = 0, i18 = 0, i19 = 0, i20 = 0, i21 = 0;
 i1 = __Z20GetTextureFormatInfo13TextureFormat(i1) | 0;
 i12 = HEAP32[i1 + 40 >> 2] | 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 i7 = HEAP32[i1 + 64 >> 2] | 0;
 i8 = HEAP32[i1 + 28 >> 2] | 0;
 i9 = HEAP32[i1 + 36 >> 2] & 255;
 i10 = HEAP32[i1 + 48 >> 2] & 255;
 i11 = HEAP32[i1 + 60 >> 2] & 255;
 if ((i14 | 0) <= 0) return;
 i4 = HEAP32[i1 + 24 >> 2] & 255;
 i5 = 255 << i4;
 if ((i13 | 0) > 0) i3 = 0; else return;
 while (1) {
  i1 = 0;
  do {
   i17 = i2 + (i1 << 2) | 0;
   i19 = HEAP32[i17 >> 2] | 0;
   i18 = Math_imul((i19 & i8) >>> i4, i16) | 0;
   i21 = __Z17DecodeRGBMChanneljjjh(i19, i18, i12, i9) | 0;
   i20 = __Z17DecodeRGBMChanneljjjh(i19, i18, i6, i10) | 0;
   HEAP32[i17 >> 2] = i21 + i5 + i20 + (__Z17DecodeRGBMChanneljjjh(i19, i18, i7, i11) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i13 | 0));
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i14 | 0)) break; else i2 = i2 + i15 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj(i8, i5, i1, i7) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i9 = 0;
 i3 = i8 + 8 | 0;
 i9 = i3 + 3 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i6 = HEAP32[i8 + 4 >> 2] | 0; else i6 = i2 & 255;
 if (i6 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i4) i2 = (HEAP32[i3 >> 2] & 2147483647) + -1 | 0; else i2 = 1;
 if ((i2 - i6 | 0) >>> 0 < i7 >>> 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i8, i2, i6 + i7 - i2 | 0, i6, i5, 0, i7, i1); else if (i7 | 0) {
  if (i4) i4 = HEAP32[i8 >> 2] | 0; else i4 = i8;
  i3 = i6 - i5 | 0;
  i2 = i4 + (i5 << 2) | 0;
  if (i3) {
   __ZNSt3__211char_traitsIwE4moveEPwPKwj(i2 + (i7 << 2) | 0, i2, i3) | 0;
   i1 = i2 >>> 0 <= i1 >>> 0 & (i4 + (i6 << 2) | 0) >>> 0 > i1 >>> 0 ? i1 + (i7 << 2) | 0 : i1;
  }
  __ZNSt3__211char_traitsIwE4moveEPwPKwj(i2, i1, i7) | 0;
  i1 = i6 + i7 | 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
  HEAP32[i4 + (i1 << 2) >> 2] = 0;
 }
 return i8 | 0;
}

function __ZNK12AudioManager10GetDSPTimeEv(i2) {
 i2 = i2 | 0;
 var d1 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i4 = i9 + 4 | 0;
 i5 = i9;
 i6 = i2 + 88 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (!i7) {
  d1 = 0.0;
  STACKTOP = i9;
  return +d1;
 }
 __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i7, i3, 0, 0, 0, 0, 0) | 0;
 if (!(HEAP8[i2 + 41 >> 0] | 0)) if (!(HEAP8[i2 + 40 >> 0] | 0)) {
  __ZN4FMOD6System11getDSPClockEPjS1_(HEAP32[i6 >> 2] | 0, i5, i4) | 0;
  i7 = i2 + 200 | 0;
  i7 = _i64Subtract(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0) | 0;
  d1 = +(i7 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0);
  d1 = d1 / +(HEAP32[i3 >> 2] | 0);
 } else i8 = 4; else i8 = 4;
 if ((i8 | 0) == 4) {
  i7 = i2 + 208 | 0;
  i8 = i2 + 200 | 0;
  i8 = _i64Subtract(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0) | 0;
  d1 = +(i8 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0);
  d1 = d1 / +(HEAP32[i3 >> 2] | 0);
 }
 STACKTOP = i9;
 return +d1;
}

function __ZN8Material13SetFloatArrayEN9ShaderLab16FastPropertyNameEPKfj(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i12 + 4 | 0;
 i11 = i12;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i2 + 12 | 0, i8, 0, i9, 4, i10) | 0;
 HEAP32[i11 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i11 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i7, i6);
 STACKTOP = i12;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 707297 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 675661 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 706029 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i1 = 0; else {
  i1 = i6 * 12 | 0;
  i2 = i7 + 384 | 0;
  if (i1 >>> 0 < 385 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   i1 = i7;
  } else i1 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i7, i1, gb + 838004 | 0, 543) | 0;
 }
 i3 = HEAP32[i7 + 392 >> 2] | 0;
 i4 = i1 + (i3 * 12 | 0) | 0;
 i5 = i7 + 388 | 0;
 if ((i3 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   i2 = i2 + 12 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 12 | 0;
  }
 }
 i2 = i7 + 396 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i7 | 0) == (i3 | 0)) {
  HEAP8[i7 + 384 >> 0] = 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 } else {
  __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i7, i3);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
  return;
 }
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator3addERKS2_S6_S6_S6_S6_(i3, i4, i5, i6, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i7 + 144 | 0;
 i16 = i7 + 128 | 0;
 i17 = i7 + 112 | 0;
 i14 = i7 + 96 | 0;
 i15 = i7 + 80 | 0;
 i11 = i7 + 64 | 0;
 i12 = i7 + 48 | 0;
 i8 = i7 + 32 | 0;
 i9 = i7 + 16 | 0;
 i10 = i7;
 __ZanRK8Scalar4fS1_(i13, i2, i1);
 __ZmlRK8Scalar4fS1_(i17, i4, i13);
 __ZplRK8Scalar4fS1_(i16, i3, i17);
 __ZN8Scalar4faSERKS_(i3, i16) | 0;
 i4 = i3 + 16 | 0;
 __ZmlRK8Scalar4fS1_(i15, i5, i13);
 __ZplRK8Scalar4fS1_(i14, i4, i15);
 __ZN8Scalar4faSERKS_(i4, i14) | 0;
 i5 = i3 + 32 | 0;
 __ZmlRK8Scalar4fS1_(i12, i6, i13);
 __ZplRK8Scalar4fS1_(i11, i5, i12);
 __ZN8Scalar4faSERKS_(i5, i11) | 0;
 i6 = i3 + 96 | 0;
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i10, i7 + 160 | 0);
 __ZanRK8Scalar4fS1_(i9, i10, i1);
 __ZplRK8Scalar4fS1_(i8, i6, i9);
 __ZN8Scalar4faSERKS_(i6, i8) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN4Mesh14ResizeVerticesEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7;
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 if (!(HEAP32[i6 + 176 >> 2] | 0)) if ((HEAP32[i1 + 116 >> 2] | 0) == (HEAP32[i1 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i4, i6 + 8 | 0);
  HEAP32[i4 >> 2] = (HEAP32[i4 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i4 + 8 >> 2] & ~HEAP32[i4 + 12 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i1, i2, i3, 0, gb + 1546313 | 0, i5);
  STACKTOP = i7;
  return;
 };
 HEAP32[i5 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout(i1, i2, i3, 0, gb + 1546313 | 0, i5);
 STACKTOP = i7;
 return;
}

function __ZN19AtomicPageAllocator12AllocatePageEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i3 = i7 + 40 | 0;
 i6 = i7 + 8 | 0;
 i8 = i1 + 32780 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 if ((i4 | 0) <= 8191) {
  i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 128, i1, 0, gb + 364828 | 0, 37) | 0;
  HEAP32[i1 + 12 + (i4 << 2) >> 2] = i8;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 __Z11FormatBytesx(i6, 268435456, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i5 + 4 >> 2] = (i1 | 0) == 0 ? i6 + 4 | 0 : i1;
 __Z6FormatPKcz(i3, gb + 364768 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 364828 | 0, 28, 17, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i6 + 24 | 0);
 i8 = 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN17ProceduralTexture17TextureParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN12b2WheelJoint13SetMotorSpeedEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  i4 = i4 + 124 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 if (i3 & 2 | 0) {
  i4 = i4 + 124 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 }
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 i4 = i4 + 124 | 0;
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i1;
 i1 = __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj(i1, 24) | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i1 + 24;
 __THREW__ = 0;
 invoke_vii(fb + 4621 | 0, i1 | 0, i2 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 do if (i5 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4621 | 0, i1 + 12 | 0, i2 + 12 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
   i1 = i5;
   break;
  } else {
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 24;
   return;
  }
 } while (0);
 __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i4);
 ___resumeException(i1 | 0);
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 677496 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx22PxVehicleTelemetryData5setupEffffPKfS2_RKNS_6PxVec3ES5_S5_(i3, f9, f10, f1, f2, i13, i14, i8, i11, i12) {
 i3 = i3 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i8 = i8 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i15 = 0;
 __ZN5physx14PxVehicleGraph16setupEngineGraphEffffRKNS_6PxVec3ES3_S3_(HEAP32[i3 >> 2] | 0, f9, f10, f1, f2, i8, i11, i12);
 i5 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i5) return;
 i6 = i3 + 4 | 0;
 i7 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 i4 = 0;
 do {
  f2 = Math_fround(HEAPF32[i13 + (i4 << 2) >> 2]);
  __ZN5physx14PxVehicleGraph15setupWheelGraphEffffRKNS_6PxVec3ES3_S3_((HEAP32[i6 >> 2] | 0) + (i4 * 15840 | 0) | 0, f9, f10, f2, Math_fround(HEAPF32[i14 + (i4 << 2) >> 2]), i8, i11, i12);
  i15 = HEAP32[i7 >> 2] | 0;
  HEAP32[i15 + (i4 * 12 | 0) >> 2] = 0;
  HEAP32[i15 + (i4 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i15 + (i4 * 12 | 0) + 8 >> 2] = 0;
  i15 = HEAP32[i3 >> 2] | 0;
  HEAP32[i15 + (i4 * 12 | 0) >> 2] = 0;
  HEAP32[i15 + (i4 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i15 + (i4 * 12 | 0) + 8 >> 2] = 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i5 | 0));
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN4Mesh9SetBoundsERK4AABB(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = i5 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 >> 2] = gb + 30832;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i5;
 i2 = HEAP32[i5 + 236 >> 2] | 0;
 i3 = i5 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, gb + 1105176 | 0, i4);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 i3 = i5 + 240 | 0;
 i1 = HEAP32[i5 + 244 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_6vectorIiNS4_IiEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 24 | 0;
 i8 = i4 + 20 | 0;
 i6 = i4 + 8 | 0;
 i10 = i4 + 4 | 0;
 i9 = i4;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 i5 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i5;
 __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE(i1, i2, i6);
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i9 >> 2] = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignINS_21__tree_const_iteratorIiPNS_11__tree_nodeIiPvEEiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(i3, i8, i7);
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i6, HEAP32[i5 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN15ResourceManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 450701 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450717 | 0, HEAP32[gb + 37052 >> 2] | 0, i3, 0);
 __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i3, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 450729 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 2) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 2) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i7, i1);
 i2 = i7 + 388 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 if (i4 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i2, 4); else {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 __ZN14LineParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i7 + 384 >> 2] | 0, i1);
 i1 = i7 + 392 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 >> 2] = i4;
 }
 i1 = i7 + 396 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i5 = HEAP8[i4 >> 0] | 0;
  HEAP8[i1 >> 0] = i5;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  i1 = i5;
 }
 if (i1 << 24 >> 24) return;
 HEAP8[i7 + 341 >> 0] = 0;
 return;
}

function __ZN10dtNodePool8findNodeEy(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i2 = _bitshift64Shl(i4 | 0, i5 | 0, 18) | 0;
 i2 = _i64Add(i2 | 0, getTempRet0() | 0, ~i4 | 0, ~i5 | 0) | 0;
 i3 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 31) | 0;
 i3 = ___muldi3(i6 ^ i2 | 0, (getTempRet0() | 0) ^ i3 | 0, 21, 0) | 0;
 i2 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i3 | 0, i2 | 0, 11) | 0;
 i2 = ___muldi3(i6 ^ i3 | 0, (getTempRet0() | 0) ^ i2 | 0, 65, 0) | 0;
 i3 = getTempRet0() | 0;
 i6 = _bitshift64Lshr(i2 | 0, i3 | 0, 22) | 0;
 (getTempRet0() | 0) ^ i3;
 i2 = HEAP16[(HEAP32[i1 + 4 >> 2] | 0) + (((HEAP32[i1 + 16 >> 2] | 0) + -1 & (i6 ^ i2)) << 1) >> 1] | 0;
 if (i2 << 16 >> 16 == -1) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i1 = i2 & 65535;
 while (1) {
  i2 = i6 + (i1 << 5) + 24 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i5 | 0) : 0) break;
  i1 = HEAP16[(HEAP32[i3 >> 2] | 0) + (i1 << 1) >> 1] | 0;
  if (i1 << 16 >> 16 == -1) {
   i1 = 0;
   i7 = 6;
   break;
  } else i1 = i1 & 65535;
 }
 if ((i7 | 0) == 6) return i1 | 0;
 i7 = i6 + (i1 << 5) | 0;
 return i7 | 0;
}

function __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastTestRK8Vector3fS1_fi23QueryTriggerInteraction(i4, i1, f5, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f2 = f0, f3 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, f12 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f9 * f9);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f10 * f10));
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f2 * f2))));
 if (!(f3 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i8 = 0;
  STACKTOP = i11;
  return i8 | 0;
 }
 f12 = Math_fround(f9 / f3);
 f9 = Math_fround(f10 / f3);
 f10 = Math_fround(f2 / f3);
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAPF32[i8 + 12 >> 2] = f12;
 HEAPF32[i8 + 16 >> 2] = f9;
 HEAPF32[i8 + 20 >> 2] = f10;
 i8 = (__ZN14PhysicsManager11RaycastTestERK3Rayfi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i8, f5, i6, i7) | 0) & 1;
 STACKTOP = i11;
 return i8 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (HEAP32[i1 + 24 >> 2] | 0) if (!(HEAP32[i1 + 16 >> 2] | 0)) if (HEAP32[i1 + 4 >> 2] & 8192 | 0) if (!(__ZSt18uncaught_exceptionv() | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
  __THREW__ = 0;
  i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i3 = __THREW__;
  __THREW__ = 0;
  if (!(i3 & 1)) {
   if ((i1 | 0) != -1) break;
   i3 = HEAP32[i2 >> 2] | 0;
   i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (!(i3 & 1)) break;
  }
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___cxa_begin_catch(i3 | 0) | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  }
 } while (0);
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 do if (HEAP32[i1 + 24 >> 2] | 0) if (!(HEAP32[i1 + 16 >> 2] | 0)) if (HEAP32[i1 + 4 >> 2] & 8192 | 0) if (!(__ZSt18uncaught_exceptionv() | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
  __THREW__ = 0;
  i1 = invoke_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i3 = __THREW__;
  __THREW__ = 0;
  if (!(i3 & 1)) {
   if ((i1 | 0) != -1) break;
   i3 = HEAP32[i2 >> 2] | 0;
   i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4508 | 0, i3 | 0, HEAP32[i3 + 16 >> 2] | 1 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (!(i3 & 1)) break;
  }
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___cxa_begin_catch(i3 | 0) | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  }
 } while (0);
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f12 = Math_fround(HEAPF32[i1 >> 2]);
  f11 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
  i9 = f12 < Math_fround(0.0);
  i8 = f12 > Math_fround(1.0);
  i8 = ~~Math_fround(Math_fround((i8 ? Math_fround(1.0) : f12) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i7 = f11 < Math_fround(0.0);
  i6 = f11 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f11) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  i5 = f10 < Math_fround(0.0);
  i3 = f10 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 24;
  HEAP32[i4 >> 2] = (i9 ? 255 : i8 & 65280 | 255) | (i7 ? 0 : i6 & 16711680) | (i5 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 12 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 745486 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 725420 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (HEAP32[i2 >> 2] & 16384 | 0) {
  STACKTOP = i4;
  return;
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 369402 | 0, gb + 932544 | 0, i1 + 28 | 0, 65);
 i5 = i3 + 8 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048093 | 0, HEAP32[gb + 37040 >> 2] | 0, i3, 1);
 i1 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048102 | 0, HEAP32[gb + 37248 >> 2] | 0, i5, 1);
 HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i4;
 return;
}

function __ZN16BaseVideoTexture17UploadTextureDataEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i13 + 4 | 0;
 i3 = i13;
 i10 = i2 + 80 | 0;
 if (HEAP32[i10 >> 2] | 0) {
  i8 = i2 + 84 | 0;
  i9 = i2 + 88 | 0;
  i4 = Math_imul(HEAP32[i8 >> 2] << 2, HEAP32[i9 >> 2] | 0) | 0;
  i5 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 440 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
  i7 = HEAP32[i10 >> 2] | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  i11 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0) | 0;
  if ((__Z19GetActiveColorSpacev() | 0) == 1) i12 = HEAP32[i2 + 60 >> 2] | 0; else i12 = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  mftCall_viiiiiiiiiii(i6 | 0, i5 | 0, i1 | 0, i7 | 0, i4 | 0, 0, 0, 0, i8 | 0, i9 | 0, i11 | 0, i12 | 0);
  if (HEAP32[i10 >> 2] | 0) {
   i11 = 1;
   i12 = i2 + 93 | 0;
   HEAP8[i12 >> 0] = i11;
   STACKTOP = i13;
   return;
  }
 }
 i11 = HEAP8[i2 + 94 >> 0] ^ 1;
 i12 = i2 + 93 | 0;
 HEAP8[i12 >> 0] = i11;
 STACKTOP = i13;
 return;
}

function __Z29GameObject_Get_Custom_PropTagP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 i2 = __Z13GetTagManagerv() | 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i3 = __ZN10TagManager11TagToStringEj(i2, HEAPU16[i3 + 52 >> 1] | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, (i1 | 0) == 0 ? i3 + 4 | 0 : i1, i2);
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i2 = i1 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255;
 if (!i2) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 514673 | 0, i5); else {
  i3 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function _ps_unicodes_char_next(i8, i10) {
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i2 = (HEAP32[i10 >> 2] | 0) + 1 | 0;
 i9 = HEAP32[i8 + 16 >> 2] | 0;
 do if (!i9) i1 = 0; else {
  i7 = HEAP32[i8 + 20 >> 2] | 0;
  i1 = 0;
  i4 = i9;
  i5 = 0;
  while (1) {
   i6 = ((i4 - i5 | 0) >>> 1) + i5 | 0;
   i3 = HEAP32[i7 + (i6 << 3) >> 2] | 0;
   if ((i3 | 0) == (i2 | 0)) {
    i3 = 4;
    break;
   }
   i3 = i3 & 2147483647;
   if ((i3 | 0) == (i2 | 0)) i1 = HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0;
   i3 = i3 >>> 0 < i2 >>> 0;
   i5 = i3 ? i6 + 1 | 0 : i5;
   i4 = i3 ? i4 : i6;
   if (i4 >>> 0 <= i5 >>> 0) {
    i3 = 8;
    break;
   }
  }
  if ((i3 | 0) == 4) {
   i8 = i2;
   i9 = HEAP32[i7 + (i6 << 3) + 4 >> 2] | 0;
   HEAP32[i10 >> 2] = i8;
   return i9 | 0;
  } else if ((i3 | 0) == 8) {
   if (!i1) {
    i1 = i5;
    break;
   }
   HEAP32[i10 >> 2] = i2;
   return i1 | 0;
  }
 } while (0);
 if (i1 >>> 0 >= i9 >>> 0) {
  i8 = 0;
  i9 = 0;
  HEAP32[i10 >> 2] = i8;
  return i9 | 0;
 }
 i9 = HEAP32[i8 + 20 >> 2] | 0;
 i8 = HEAP32[i9 + (i1 << 3) >> 2] & 2147483647;
 i9 = HEAP32[i9 + (i1 << 3) + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i8;
 return i9 | 0;
}

function __ZZN13WheelCollider15InitializeClassEvEN29FunctorImpl_1262kLayerChanged4CallEPviR11MessageData(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i5 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i1 = (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 136 >> 2] | 0, i5 | 0) | 0) + 56 >> 2] | 0) + 8 | 0;
 i6 = __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i1, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[(HEAP32[i5 + 28 >> 2] | 0) + 48 >> 2];
 __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i1, HEAP32[i3 >> 2] | 0, i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 54;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx9NpPhysics16initOffsetTablesERNS_14PxvOffsetTableE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[gb + 1097392 >> 2] = -64;
 HEAP32[gb + 1097392 + 4 >> 2] = -64;
 HEAP32[gb + 1097392 + 8 >> 2] = -64;
 HEAP32[gb + 1097392 + 16 >> 2] = -24;
 HEAP32[gb + 1097392 + 20 >> 2] = -28;
 HEAP32[gb + 1097392 + 12 >> 2] = -48;
 HEAP32[gb + 1097392 + 24 >> 2] = -32;
 HEAP32[gb + 1097392 + 28 >> 2] = -32;
 HEAP32[gb + 1097392 + 32 >> 2] = -32;
 i2 = gb + 1457208 | 0;
 i3 = i2 + 68 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[gb + 1457208 + 24 >> 2] = 48;
 HEAP32[gb + 1457208 + 20 >> 2] = 48;
 HEAP32[gb + 1457208 + 44 >> 2] = 20;
 HEAP32[gb + 1457208 + 48 >> 2] = 20;
 HEAP32[gb + 1457208 + 60 >> 2] = 48;
 HEAP32[gb + 1457208 + 40 >> 2] = 20;
 i2 = gb + 1457208 + 68 | 0;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[gb + 1457208 + 88 >> 2] = 16;
 HEAP32[gb + 1457208 + 80 >> 2] = 16;
 HEAP32[gb + 1457208 + 84 >> 2] = 16;
 HEAP32[gb + 1457208 + 96 >> 2] = 12;
 HEAP32[gb + 1457208 + 112 >> 2] = 12;
 HEAP32[i1 >> 2] = -80;
 HEAP32[i1 + 4 >> 2] = -80;
 HEAP32[i1 + 8 >> 2] = -80;
 return;
}

function __ZN5Umbra15MemOutputStream5writeEPKvj(i3, i8, i9) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i3 + 16 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i11 = i1 + i9 | 0;
 i7 = i3 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i11 >>> 0 > i2 >>> 0) {
  i6 = i2;
  do {
   i5 = i6 << 1;
   i6 = i5 >>> 0 > 64 ? i5 : 64;
  } while (i11 >>> 0 > i6 >>> 0);
  if ((i6 | 0) == (i2 | 0)) i12 = 4; else {
   i5 = i3 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i6 | 0, 0) | 0;
   if (!i2) {
    i12 = 0;
    return i12 | 0;
   }
   i4 = i3 + 8 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) {
    i3 = HEAP32[i10 >> 2] | 0;
    if (i3) {
     _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
     i1 = HEAP32[i4 >> 2] | 0;
    }
    i5 = HEAP32[i5 >> 2] | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
   }
   HEAP32[i4 >> 2] = i2;
   HEAP32[i7 >> 2] = i6;
   i1 = HEAP32[i10 >> 2] | 0;
  }
 } else i12 = 4;
 if ((i12 | 0) == 4) i2 = HEAP32[i3 + 8 >> 2] | 0;
 _memcpy(i2 + i1 | 0, i8 | 0, i9 | 0) | 0;
 HEAP32[i10 >> 2] = i11;
 i12 = i9;
 return i12 | 0;
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i7);
 i6 = i5 + 160 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j(i6, i1);
 i2 = HEAP32[i5 + 164 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i7, i1, 0);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __Z43Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i2 = __ZN14PhysicsManager14OverlapCapsuleERK8Vector3fS2_fi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i1, i2, f3, i4, i5) | 0;
 i5 = __Z19GetScriptingManagerv() | 0;
 i4 = i2 + 4 | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i5 + 168 >> 2] | 0) + (HEAP32[gb + 32548 + 24 >> 2] << 2) >> 2] | 0, 4, (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i4 >> 2] | 0));
 }
 if ((i1 | 0) >= (i6 | 0)) return i5 | 0;
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i5, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return i5 | 0;
}

function __Z31TerrainData_CUSTOM_GetAlphamapsP12Il2CppObjectiiii(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i5 | i4 | i6 | i7 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 937733 | 0, i8);
 i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i9 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i2 = i2 + 32 | 0;
 i1 = __Z22scripting_array_new_3dP11Il2CppClassjjjj(i1, 4, i7, i6, ((HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 44 | 0) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN13SplatDatabase12GetAlphamapsEjjjjPf(i2 + 32 | 0, i4, i5, i6, i7, __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0);
  STACKTOP = i8;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__223__future_error_category7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 4:
 case 0:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1076810 | 0, 88);
   break;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1076899 | 0, 72);
   break;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1076972 | 0, 46);
   break;
  }
 case 3:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1077019 | 0, 65);
   break;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1077085 | 0, 30);
  }
 }
 return;
}

function __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_8BodyCoreE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i1 = __ZNK5physx2Sc8BodyCore6getSimEv(i1) | 0;
 if (!i1) return;
 i3 = i1;
 i5 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
 i4 = getTempRet0() | 0;
 i3 = _i64Add(i3 | 0, 0, 191, 0) | 0;
 i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Subtract(1, 0, i5 | 0, i4 | 0) | 0;
 i2 = _i64Add(i4 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1;
 while (1) {
  i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
  i3 = getTempRet0() | 0;
  if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i3;
 i4 = _bitshift64Lshr(i2 | 0, 0, 6) | 0;
 i5 = getTempRet0() | 0;
 i2 = _i64Add(i2 | 0, 0, 19, 0) | 0;
 i2 = _bitshift64Lshr(i2 | 0, getTempRet0() | 0, 6) | 0;
 i1 = getTempRet0() | 0;
 i5 = _i64Subtract(1, 0, i4 | 0, i5 | 0) | 0;
 i1 = _i64Add(i5 | 0, getTempRet0() | 0, i2 | 0, i1 | 0) | 0;
 i2 = getTempRet0() | 0;
 while (1) {
  i1 = _i64Add(i1 | 0, i2 | 0, -1, -1) | 0;
  i2 = getTempRet0() | 0;
  if ((i1 | 0) == 0 & (i2 | 0) == 0) break; else i3 = i3 + 64 | 0;
 }
 return;
}

function __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i1, i8, i9, i10, i11, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i12 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i12 = i14;
 i13 = __Z21GetUncheckedGfxDevicev() | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (i2) {
  i5 = (i8 | 0) == 2 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0) < 2;
  i1 = i5 ? 1 : i1;
 }
 i5 = HEAP32[(HEAP32[i13 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i12 >> 2] = i3;
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i4 | 0) == 0 | (i3 | 0) == 0) i2 = 1; else {
  i2 = HEAP32[gb + 56192 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) {
   i2 = HEAP32[gb + 56196 >> 2] | 0;
   i2 = (i3 | 0) > (i2 | 0) ? i2 : i3;
  }
 }
 f15 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
 mftCall_viiiiiifiii(i5 | 0, i13 | 0, i6 | 0, i8 | 0, i4 | 0, i1 | 0, i2 | 0, +f15, i9 | 0, i10 | 0, i11 | 0);
 STACKTOP = i14;
 return;
}

function __ZN9GfxDevice23UnregisterNativeTextureE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 i4 = HEAP32[gb + 1157724 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i1, i4, i3);
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = i4 + 12 | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP8[i4 + 48 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN18b2FrictionJointDef10InitializeEP6b2BodyS1_RK6b2Vec2(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, i10 = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i10 = i4 + 4 | 0;
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f9 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f8 = Math_fround(f5 * f6);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f6 * f9) - Math_fround(f5 * f7));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f8 + Math_fround(f9 * f7));
 HEAPF32[i1 + 24 >> 2] = f5;
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 12 >> 2]));
 f7 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 16 >> 2]));
 f9 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f8 = Math_fround(f5 * f9);
 f6 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f5 = Math_fround(Math_fround(f9 * f7) - Math_fround(f5 * f6));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f8 + Math_fround(f7 * f6));
 HEAPF32[i1 + 32 >> 2] = f5;
 return;
}

function __ZN16b2PrismaticJoint11EnableLimitEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = i4 + 136 | 0;
 if ((i5 & 1 | 0) == (HEAPU8[i6 >> 0] | 0 | 0)) return;
 i3 = HEAP32[i4 + 48 >> 2] | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i3 = i3 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAP8[i6 >> 0] = i5 & 1;
 HEAPF32[i4 + 112 >> 2] = Math_fround(0.0);
 return;
}

function __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStr(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i1 = i6 + 2256 | 0;
 do if ((i1 | 0) != (i7 | 0)) {
  i8 = HEAP8[i7 + 11 >> 0] | 0;
  i4 = i8 << 24 >> 24 < 0;
  i9 = i4 ? HEAP32[i7 >> 2] | 0 : i7;
  i8 = i4 ? HEAP32[i7 + 4 >> 2] | 0 : i8 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i6 + 2264 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i8 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i6 + 2260 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i9);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i9 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + 2260 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 return __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr(i6, i7) | 0;
}

function __Z32AudioSource_Set_Custom_PropPitchP12Il2CppObjectf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 if (((HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040 | 0) == 2139095040) {
  if (!i2) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884104 | 0, 0, gb + 875076 | 0, 620, 512, i1, 0, 0);
  return;
 }
 i1 = (i2 | 0) == 0;
 if (f3 != f3 | Math_fround(0.0) != Math_fround(0.0)) {
  if (i1) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884164 | 0, 0, gb + 875076 | 0, 625, 512, i1, 0, 0);
  return;
 }
 if (i1) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN11AudioSource8SetPitchEf(i1, f3);
 return;
}

function __Z28Texture3D_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayi(i5, i4, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN9Texture3D11SetPixels32EiPK11ColorRGBA32i(i2, i3, i1, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZNK9DebugGLES15SamplerBindingsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i6 = i8;
 if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 1992 >> 0] | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 690 >> 0] | 0)) {
  i7 = 1;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i7 >> 2] = 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 88 >> 2] | 0, 34016, i7 | 0);
 i3 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 120 >> 2] | 0;
 i4 = (i3 | 0) > 32 ? 32 : i3;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 808 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i3 = 0;
  do {
   mftCall_vi(i1 | 0, i3 + 33984 | 0);
   HEAP32[i6 >> 2] = 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 88 >> 2] | 0, 35097, i6 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i1 + 1860 + (i3 << 2) >> 2] | 0;
   i2 = (i2 | 0) == -1 ? 1 : (i2 | 0) == (HEAP32[i6 >> 2] | 0);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i1 + 808 >> 2] | 0;
  } while (i2 & (i3 | 0) < (i4 | 0));
 } else i2 = 1;
 mftCall_vi(i1 | 0, HEAP32[i7 >> 2] | 0);
 i7 = i2;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN18BuoyancyEffector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 i5 = gb + 63408 | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 153972 + 8;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 1812433254;
 HEAP32[i1 + 88 >> 2] = 1900727103;
 STACKTOP = i4;
 return;
}

function __ZN15b2FrictionJointC2EPK18b2FrictionJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152216 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 96 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 100 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i2, i7, i9, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i3 = i2 + 12 | 0;
 i8 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i6 >>> 0 < i7 >>> 0) {
  i10 = i5 << 1;
  i1 = (i1 | 0) == 0 & i10 >>> 0 > i7 >>> 0 ? i10 : i7;
  if (i6 >>> 0 < i1 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i10;
   break;
  }
 } while (0);
 if (i8 >>> 0 >= i7 >>> 0) return;
 i3 = (HEAP32[i2 >> 2] | 0) + (i8 << 2) | 0;
 i2 = i7 - i8 | 0;
 if (!i2) return;
 i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i9 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZL31InitializeAudioScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63728 | 0, 16, gb + 856675 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[gb + 1459932 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856797 | 0, gb + 856807 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1459932 >> 2] | 0) + 8 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856797 | 0, gb + 856840 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = (HEAP32[gb + 1459932 >> 2] | 0) + 16 | 0;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 856878 | 0, gb + 856892 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 856926 | 0) | 0;
 HEAP32[(HEAP32[gb + 1459932 >> 2] | 0) + 24 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __Z48Physics_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK8Vector3fS1_fS1_P11Il2CppArrayfi23QueryTriggerInteraction(i1, i2, f3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, f10 = f0, f11 = f0, i12 = 0;
 f10 = Math_fround(HEAPF32[i4 >> 2]);
 f10 = Math_fround(f10 * f10);
 f11 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f11 = Math_fround(f10 + Math_fround(f11 * f11));
 f10 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f10 = Math_fround(Math_sqrt(Math_fround(f11 + Math_fround(f10 * f10))));
 if (!(f10 > Math_fround(HEAPF32[gb + 62452 >> 2]))) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 44) | 0;
 i12 = __Z17GetPhysicsManagerv() | 0;
 i1 = __ZN14PhysicsManager19CapsuleCastNonAllocERK8Vector3fS2_fS2_P10RaycastHitifi23QueryTriggerInteraction(i12, i1, i2, f3, i4, i9, __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0, f6, i7, i8) | 0;
 if (!i1) {
  i12 = 0;
  return i12 | 0;
 } else i2 = 0;
 do {
  __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i9 + (i2 * 44 | 0) | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i1 | 0;
}

function __Z42Transform_Set_Custom_PropHierarchyCapacityP12Il2CppObjecti(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i6 + 8 | 0;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i7 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i2 = __ZNK9Transform17GetHierarchyCountEv(i2) | 0;
 if ((i2 | 0) > (i1 | 0)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  __Z6FormatPKcz(i3, gb + 577294 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 577381 | 0, 608, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i1 = i2;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN9Transform20SetHierarchyCapacityEj(i2, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z39Physics_CUSTOM_INTERNAL_CALL_OverlapBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = __ZN14PhysicsManager10OverlapBoxERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i1, i2, i3, i4, i5) | 0;
 i4 = __Z19GetScriptingManagerv() | 0;
 i3 = i2 + 4 | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i4 + 168 >> 2] | 0) + (HEAP32[gb + 32548 + 24 >> 2] << 2) >> 2] | 0, 4, (HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2) | 0;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i3 >> 2] | 0));
 }
 if ((i1 | 0) >= (i5 | 0)) return i4 | 0;
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return i4 | 0;
}

function __Z35Camera_CUSTOM_GetStereoViewMatricesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 260 >> 2] | 0, 64, 2) | 0;
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 64) | 0;
 if (!i3) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = i5;
 i1 = __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye(i1, 0) | 0;
 i2 = i6 + 64 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i6 = i6 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i6 | 0) < (i2 | 0));
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i6 = i5 + 64 | 0;
  i1 = __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye(i1, 1) | 0;
  i2 = i6 + 64 | 0;
  do {
   HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
   i6 = i6 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i6 | 0) < (i2 | 0));
  return i4 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i3 = __ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 i6 = __ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i3) {
  if (!i6) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i6;
  if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
   i6 = 1;
   return i6 | 0;
  }
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i6;
  i6 = 2;
  return i6 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 if (i6) {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i3;
  i6 = 1;
  return i6 | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i4 >> 2] | 0, i3) | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i6;
 i6 = 2;
 return i6 | 0;
}

function __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i7 = (i1 - i2 >> 2) + 1 | 0;
 if (i7 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i9 = (HEAP32[i4 + 8 >> 2] | 0) - i2 | 0;
 i3 = i9 >> 1;
 __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEEC2EjjS5_(i6, i9 >> 2 >>> 0 < 536870911 ? (i3 >>> 0 < i7 >>> 0 ? i7 : i3) : 1073741823, i1 - i2 >> 2, i4 + 8 | 0);
 i7 = i6 + 8 | 0;
 HEAP32[HEAP32[i7 >> 2] >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
 __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i4, i6);
 __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZNK14SerializedFile7GetTypeEx(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i8 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = i8 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 * 24 | 0) | 0;
   i3 = i4;
   i11 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i11 | 0) < (i9 | 0) | ((i11 | 0) == (i9 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i8 | 0)) {
  i11 = i1;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  if (!((i10 | 0) > (i9 | 0) | ((i10 | 0) == (i9 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 > i7 >>> 0 : 0))) {
   i11 = i1;
   i11 = i11 + 16 | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i11 = i10 + (i11 * 56 | 0) + 4 | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   return i11 | 0;
  }
 }
 i11 = i8;
 i11 = i11 + 16 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = i10 + (i11 * 56 | 0) + 4 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 return i11 | 0;
}

function __ZN6ShaderD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 67676 + 8;
 if ((HEAP32[gb + 1166240 >> 2] | 0) == (i5 | 0)) HEAP32[gb + 1166240 >> 2] = 0;
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 84 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 if ((HEAP32[i5 + 76 >> 2] | 0) > -1) {
  i4 = i5 + 60 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i5 + 64 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i5 + 44 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  HEAP32[i5 >> 2] = gb + 32336 + 8;
  i6 = i5 + 28 | 0;
  __ZN14ConstantStringD2Ev(i6);
  HEAP32[i5 >> 2] = gb + 26392 + 8;
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 + 56 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 HEAP32[i5 >> 2] = gb + 32336 + 8;
 i6 = i5 + 28 | 0;
 __ZN14ConstantStringD2Ev(i6);
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx32solveContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i11, i10, i1) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i12 = 0;
 if (!i10) return; else i9 = 0;
 do {
  __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i11 + (i9 << 5) | 0, 0);
  i1 = HEAP32[i11 + (i9 << 5) + 16 >> 2] | 0;
  i7 = HEAP16[i1 + 2 >> 1] | 0;
  i8 = i1 + (i7 & 65535) | 0;
  if (i7 << 16 >> 16) do {
   i3 = i1 + 48 | 0;
   i2 = HEAP8[i1 + 1 >> 0] | 0;
   i7 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
   if (!(i2 << 24 >> 24)) i1 = i3; else {
    i6 = i2 & 255;
    i5 = 0;
    while (1) {
     i2 = i3 + 32 | 0;
     f4 = Math_fround(HEAPF32[i2 >> 2]);
     i12 = f4 > Math_fround(0.0);
     HEAP32[i2 >> 2] = i12 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
     HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
    }
    i1 = i1 + ((Math_imul(i7, i6) | 0) + 48) | 0;
   }
  } while (i1 >>> 0 < i8 >>> 0);
  i9 = i9 + 1 | 0;
 } while ((i9 | 0) != (i10 | 0));
 return;
}

function __ZN5physx23PxMaterialGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 672678;
 HEAP32[i1 + 4 >> 2] = 2;
 HEAP32[i1 + 8 >> 2] = fb + 2087;
 HEAP32[i1 + 12 >> 2] = gb + 672693;
 HEAP32[i1 + 16 >> 2] = 3;
 HEAP32[i1 + 20 >> 2] = fb + 360;
 HEAP32[i1 + 24 >> 2] = fb + 303;
 HEAP32[i1 + 28 >> 2] = gb + 672709;
 HEAP32[i1 + 32 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = fb + 361;
 HEAP32[i1 + 40 >> 2] = fb + 304;
 HEAP32[i1 + 44 >> 2] = gb + 741375;
 HEAP32[i1 + 48 >> 2] = 5;
 HEAP32[i1 + 52 >> 2] = fb + 362;
 HEAP32[i1 + 56 >> 2] = fb + 305;
 HEAP32[i1 + 60 >> 2] = gb + 743223;
 HEAP32[i1 + 64 >> 2] = 6;
 HEAP32[i1 + 68 >> 2] = fb + 2088;
 HEAP32[i1 + 72 >> 2] = fb + 3455;
 HEAP32[i1 + 76 >> 2] = gb + 672724;
 HEAP32[i1 + 80 >> 2] = 7;
 HEAP32[i1 + 84 >> 2] = fb + 2089;
 HEAP32[i1 + 88 >> 2] = fb + 3456;
 HEAP32[i1 + 92 >> 2] = gb + 672744;
 HEAP32[i1 + 96 >> 2] = 8;
 HEAP32[i1 + 100 >> 2] = fb + 2090;
 HEAP32[i1 + 104 >> 2] = fb + 3457;
 HEAP32[i1 + 108 >> 2] = gb + 831985;
 HEAP32[i1 + 112 >> 2] = 9;
 HEAP32[i1 + 116 >> 2] = fb + 2091;
 HEAP32[i1 + 120 >> 2] = gb + 741613;
 HEAP32[i1 + 124 >> 2] = 10;
 HEAP32[i1 + 128 >> 2] = fb + 2092;
 HEAP32[i1 + 132 >> 2] = fb + 3458;
 return;
}

function __ZN2UI6Canvas12AddToManagerEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE(HEAP32[gb + 1467948 >> 2] | 0, i5);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1106096 | 0, i3);
 i1 = i5;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i4 = i5 + 112 | 0;
 i1 = i3;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i1 = i5 + 224 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 6;
 i1 = HEAP32[i5 + 344 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i5 = i1 + 224 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 6;
 STACKTOP = i6;
 return;
}

function __ZN24AudioScriptBufferManager4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 8 | 0;
 i3 = i5 + 4 | 0;
 i4 = i5;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 __ZN4FMOD6System16getDSPBufferSizeEPjPi(i6, i2, 0) | 0;
 __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i6, 0, 0, i3, i4, 0, 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i4 = Math_imul((i3 | 0) < (i4 | 0) ? i4 : i3, HEAP32[i2 >> 2] | 0) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 4096;
 i3 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i2) | 0;
 HEAP32[i1 + 20 >> 2] = i4;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, i4) | 0;
 HEAP32[i1 + 12 >> 2] = i4;
 HEAP32[i1 + 16 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i4) | 0;
 STACKTOP = i5;
 return;
}

function __ZN15b2RevoluteJoint11EnableLimitEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = i4 + 112 | 0;
 if ((i5 & 1 | 0) == (HEAPU8[i6 >> 0] | 0 | 0)) return;
 i3 = HEAP32[i4 + 48 >> 2] | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i3 = i3 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i3 = i1 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAP8[i6 >> 0] = i5 & 1;
 HEAPF32[i4 + 92 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14SafeBinaryRead8TransferItEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, HEAP32[gb + 37288 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
   i2 = i1 + 2 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
    HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP16[i7 >> 1] = _llvm_bswap_i16(HEAP16[i7 >> 1] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE10deallocateEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i7 = i5 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i7 >> 2] = i2 + -36;
   i4 = i2 + -4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i2 = i2 + -8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 16 >> 2] | 0, gb + 63184 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = HEAP32[i7 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 77;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN7dtCrowd17requestMoveTargetEiPKf(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i5 = i7 + 8 | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i6 + (i4 * 608 | 0) + 564 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + (i4 * 608 | 0) + 568 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + (i4 * 608 | 0) + 572 >> 2] = HEAP32[i1 + 8 >> 2];
 i8 = i6 + (i4 * 608 | 0) + 602 | 0;
 HEAP8[i8 >> 0] = HEAP8[i8 >> 0] | 16;
 __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(HEAP32[i3 + 464 >> 2] | 0, i1, i3 + 432 | 0, (HEAP32[i3 + 24 >> 2] | 0) + (i4 * 132 | 0) | 0, i2, i5) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) {
  i8 = i6 + (i4 * 608 | 0) + 592 | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 __ZN7dtCrowd17requestMoveTargetEiyPKf(i3, i4, i1, i2, i5);
 i1 = i6 + (i4 * 608 | 0) + 601 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 2) {
  i8 = 1;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i8 = 1;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj(i10, i4) {
 i10 = i10 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i10 + 12 | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i5 = 0; else {
  i5 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
  i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i9 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i5 + (i1 << 2) | 0;
 i8 = i10 + 4 | 0;
 if ((i1 | 0) > 0) {
  i1 = i5;
  i2 = HEAP32[i8 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i4 >> 2];
 if ((HEAP32[i6 >> 2] | 0) > -1) {
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i10 = HEAP32[HEAP32[i10 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, i1 | 0);
  }
 }
 HEAP32[i8 >> 2] = i5;
 HEAP32[i6 >> 2] = i9;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + 1;
 return i5 + (i10 << 2) | 0;
}

function __ZN5physx3Cct15ObstacleContext13onOriginShiftERKNS_6PxVec3E(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, d4 = 0.0, d5 = 0.0, i6 = 0, i9 = 0;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  d4 = +Math_fround(HEAPF32[i8 >> 2]);
  d5 = +Math_fround(HEAPF32[i8 + 4 >> 2]);
  d1 = +Math_fround(HEAPF32[i8 + 8 >> 2]);
  i6 = 0;
  do {
   i9 = i3 + (i6 * 72 | 0) + 16 | 0;
   HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d4;
   i9 = i3 + (i6 * 72 | 0) + 24 | 0;
   HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d5;
   i9 = i3 + (i6 * 72 | 0) + 32 | 0;
   HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d1;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < i2 >>> 0);
 }
 i6 = HEAP32[i7 + 20 >> 2] | 0;
 if (!i6) return;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 d4 = +Math_fround(HEAPF32[i8 >> 2]);
 d5 = +Math_fround(HEAPF32[i8 + 4 >> 2]);
 d1 = +Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = 0;
 do {
  i9 = i3 + (i2 << 6) + 16 | 0;
  HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d4;
  i9 = i3 + (i2 << 6) + 24 | 0;
  HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d5;
  i9 = i3 + (i2 << 6) + 32 | 0;
  HEAPF64[i9 >> 3] = +HEAPF64[i9 >> 3] - d1;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i6 >>> 0);
 return;
}

function __ZN5physx16PxsIslandManager12setKinematicERKNS_20PxsIslandManagerHookIjLj4294967295EEEb(i7, i4, i5) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i7 + 16 >> 2] | 0;
 i2 = i6 + (i1 * 12 | 0) + 8 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 i8 = i3 & 255;
 HEAP8[i2 >> 0] = i5 ? i8 | 1 : i8 & 254;
 i3 = (i3 & 1) != 0 ^ i5;
 i2 = i7 + 444 | 0;
 HEAP32[i2 >> 2] = (i3 ? (i5 ? -1 : 1) : 0) + (HEAP32[i2 >> 2] | 0);
 i2 = i7 + 452 | 0;
 HEAP32[i2 >> 2] = (i3 ? (i5 ? 1 : -1) : 0) + (HEAP32[i2 >> 2] | 0);
 if (!i3) return;
 i2 = 1 << (i1 & 31);
 i3 = HEAP32[HEAP32[i7 + 264 >> 2] >> 2] | 0;
 if (i5) {
  i8 = i3 + (i1 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i2;
 } else {
  i8 = i3 + (i1 >>> 5 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~i2;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 do if (!(HEAP8[i6 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
  i2 = (HEAP32[HEAP32[i7 + 268 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = 1 << (i1 & 31);
  if (!(i3 & i1)) {
   HEAP32[i2 >> 2] = i3 | i1;
   break;
  } else {
   HEAP32[i2 >> 2] = i3 & ~i1;
   break;
  }
 } while (0);
 HEAP8[i7 + 477 >> 0] = 1;
 return;
}

function __ZN5Umbra9Matrix4x45scaleERKNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = i1 + 16 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = i1 + 32 | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 * f9);
 f8 = Math_fround(f8 * f9);
 HEAPF32[i1 >> 2] = Math_fround(f4 * f9);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i3 >> 2] = f8;
 i3 = i1 + 4 | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = i1 + 20 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i7 = i1 + 36 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 * f4);
 f9 = Math_fround(f9 * f4);
 HEAPF32[i3 >> 2] = Math_fround(f8 * f4);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i7 >> 2] = f9;
 i7 = i1 + 8 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 i5 = i1 + 24 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = i1 + 40 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 * f8);
 f4 = Math_fround(f4 * f8);
 HEAPF32[i7 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i3 >> 2] = f4;
 return i1 | 0;
}

function __ZN5Umbra12QueryContext8findCellERKNS_7Vector3E(i4, i2, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i6 = __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E(i2, i5) | 0;
 if ((i6 | 0) == -1) {
  HEAP32[i4 >> 2] = -1;
  HEAP32[i4 + 4 >> 2] = -1;
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi(i2, i1, i6);
 i3 = HEAP32[i3 >> 2] | 0;
 do if (!i3) {
  HEAP32[i4 >> 2] = -1;
  HEAP32[i4 + 4 >> 2] = -1;
 } else {
  i1 = __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E(i2, i3, i5) | 0;
  if ((i1 | 0) == -1) {
   HEAP32[i4 >> 2] = -1;
   HEAP32[i4 + 4 >> 2] = -1;
   break;
  } else {
   i5 = __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E(i3, i1, i5) | 0;
   i5 = (i5 | 0) < (HEAP32[i3 + 52 >> 2] & 65535 | 0) ? i5 : -1;
   HEAP32[i4 >> 2] = i6;
   HEAP32[i4 + 4 >> 2] = i5;
   break;
  }
 } while (0);
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i1 = HEAP32[i6 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 + 260 >> 2] = 0;
  HEAP32[i5 + 264 >> 2] = 0;
  HEAP32[i5 + 268 >> 2] = 0;
  return;
 }
 HEAP32[i5 + 268 >> 2] = i1;
 i4 = i5 + 264 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = i1 << 2;
 i3 = i5 + 256 | 0;
 if (i2 >>> 0 < 257 & (HEAP8[i3 >> 0] | 0) == 0) {
  HEAP8[i3 >> 0] = 1;
  i2 = i5;
 } else if (!i2) i2 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i3 | 0, i2 | 0, (i1 ? gb + 687437 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i5 + 260 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i6 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i3 = i1 + -16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 > 16) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
  STACKTOP = i6;
  return;
 }
 i1 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 108 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = i4 + -8 | 0;
 if ((HEAP32[(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 100 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i7 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 96 | 0;
  HEAP32[i5 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE6resizeEjRKS3_(i7, i4 + -7 | 0, i5);
 }
 HEAP32[i3 >> 2] = HEAP32[(HEAP32[(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 96 >> 2] | 0) + (i2 << 2) >> 2];
 HEAP32[(HEAP32[(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 96 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN26LegacyTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i1 + 280 >> 2] | 0;
 if (!i6) {
  i6 = -1;
  return i6 | 0;
 }
 __ZN4Mesh18CheckIfBuffersLostEv(i6);
 if (HEAP8[i6 + 44 >> 0] & 3) __ZN4Mesh10CreateMeshEv(i6);
 i5 = __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i2, i3) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 + (i5 * 360 | 0) + 248 >> 2] = HEAP32[i6 + 228 >> 2];
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + 28 | 0) >>> 0 > (HEAP32[i2 + 8 >> 2] | 0) >>> 0) {
  __ZN22PerThreadPageAllocator14AcquireNewPageEj(i2, 32768);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = (HEAP32[i2 >> 2] | 0) + i1 | 0;
 HEAP32[i3 >> 2] = i1 + 28;
 HEAP32[i4 + (i5 * 360 | 0) + 328 >> 2] = i2;
 __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i2, i6, 0, 0, 0, 0);
 HEAP32[i4 + (i5 * 360 | 0) + 348 >> 2] = 3;
 HEAP32[i4 + (i5 * 360 | 0) + 340 >> 2] = fb + 492;
 HEAP32[i4 + (i5 * 360 | 0) + 332 >> 2] = fb + 211;
 HEAP32[i4 + (i5 * 360 | 0) + 344 >> 2] = fb + 2371;
 i6 = i5;
 return i6 | 0;
}

function __ZN14SphereCollider16TransformChangedEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN8Collider16TransformChangedEi(i3, i4);
 i6 = i3 + 36 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if (i4 & 8) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  __ZN8Collider29FetchPoseFromTransformUtilityERK8Vector3f(i3, i3 + 64 | 0);
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 28 | 0;
 if (__ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0, i5) | 0) __Z31SetShapeLocalPoseAndWakeUpActorPN5physx7PxShapeEPNS_12PxRigidActorERK10Matrix4x4f(HEAP32[i6 >> 2] | 0, i2, i5);
 if (!((i4 & -2147483640 | 0) == 0 ? (HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 28 >> 2] | 0) : 0)) __ZN8Collider32RigidbodyMassDistributionChangedEv(i3);
 STACKTOP = i7;
 return;
}

function __ZN13DrawImmediate6CreateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 127;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 1 >> 0] = 0;
 HEAP8[i4 + 2 >> 0] = 0;
 HEAP8[i4 + 3 >> 0] = 3;
 HEAP8[i4 + 5 >> 0] = 12;
 HEAP8[i4 + 6 >> 0] = 0;
 HEAP8[i4 + 7 >> 0] = 3;
 HEAP8[i4 + 9 >> 0] = 24;
 HEAP8[i4 + 10 >> 0] = 0;
 HEAP8[i4 + 11 >> 0] = 4;
 HEAP8[i4 + 13 >> 0] = 40;
 HEAP8[i4 + 14 >> 0] = 0;
 HEAP8[i4 + 15 >> 0] = 3;
 HEAP8[i4 + 17 >> 0] = 52;
 HEAP8[i4 + 18 >> 0] = 0;
 HEAP8[i4 + 19 >> 0] = 3;
 HEAP8[i4 + 21 >> 0] = 64;
 HEAP8[i4 + 22 >> 0] = 0;
 HEAP8[i4 + 23 >> 0] = 3;
 HEAP8[i4 + 25 >> 0] = 76;
 HEAP8[i4 + 26 >> 0] = 0;
 HEAP8[i4 + 27 >> 0] = 3;
 i3 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63304 | 0, 16, gb + 396312 | 0, 152) | 0;
 __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob(i3, 1, i4, 1);
 HEAP32[i1 + 12 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z12SetupSteppedP8Vector3fRK11KeyframeTplIS_ES4_(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 28 | 0;
 i7 = i5 + 12 | 0;
 i8 = i5 + 24 | 0;
 i3 = i1 + 4 | 0;
 i4 = i5 + 36 | 0;
 i1 = i2 + 16 | 0;
 i2 = Math_fround(HEAPF32[i6 >> 2]) == Math_fround(inf);
 if (i2 | Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 }
 if (Math_fround(HEAPF32[i6 + 4 >> 2]) == Math_fround(inf)) i9 = 5; else if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf)) i9 = 5;
 if ((i9 | 0) == 5) {
  HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 }
 if (!(Math_fround(HEAPF32[i6 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf))) return;
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function _mwrite(i11, i10, i8) {
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i11 + 84 >> 2] | 0;
 i2 = i11 + 20 | 0;
 i3 = HEAP32[i11 + 28 >> 2] | 0;
 i1 = (HEAP32[i2 >> 2] | 0) - i3 | 0;
 if (!i1) i4 = 3; else {
  HEAP32[i2 >> 2] = i3;
  if ((_mwrite(i11, i3, i1) | 0) >>> 0 < i1 >>> 0) i1 = 0; else i4 = 3;
 }
 do if ((i4 | 0) == 3) {
  if ((HEAP32[i9 + 16 >> 2] | 0) == 97) {
   i5 = i9 + 4 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   HEAP32[i9 >> 2] = i2;
   i6 = i9;
  } else {
   i5 = i9 + 4 | 0;
   i6 = i9;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  i7 = i9 + 8 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
  i1 = i1 >>> 0 < i8 >>> 0 ? i1 : i8;
  i4 = i9 + 12 | 0;
  _memcpy((HEAP32[i4 >> 2] | 0) + i2 | 0, i10 | 0, i1 | 0) | 0;
  i3 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
  HEAP32[i6 >> 2] = i3;
  if (i3 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   if (i3 >>> 0 < i2 >>> 0) {
    HEAP8[(HEAP32[i4 >> 2] | 0) + i3 >> 0] = 0;
    break;
   }
   if (!((i2 | 0) == 0 | (HEAP32[i11 >> 2] & 4 | 0) == 0)) HEAP8[(HEAP32[i4 >> 2] | 0) + (i2 + -1) >> 0] = 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN9Texture2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 i6 = i5 + 152 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 156 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i7);
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i9, i6) {
 i9 = i9 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i1 = i6;
 i7 = i1 & 1;
 i3 = i1 >>> 2;
 HEAP32[i8 >> 2] = i3;
 i1 = (HEAP32[i9 + 28 + (i7 * 12 | 0) >> 2] | 0) + (i1 >>> 7 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << (i3 & 31);
 if (i2 & i3 | 0) {
  HEAP32[i1 >> 2] = i2 & ~i3;
  i3 = i9 + 52 | 0;
  i4 = i9 + 56 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  L3 : do if (!i5) i1 = 0; else {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = 0;
   do {
    if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L3;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i5 >>> 0);
  } while (0);
  if ((i1 | 0) != (i5 | 0)) {
   i5 = i5 + -1 | 0;
   HEAP32[i4 >> 2] = i5;
   i6 = HEAP32[i3 >> 2] | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
  }
 }
 i6 = i9 + 20 + (i7 << 2) | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i9 = HEAP32[i9 + 12 + (i7 << 2) >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, i8 | 0, 1);
 STACKTOP = i10;
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE14setOwnerClientEh(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 if (__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701099 | 0, 190, gb + 701174 | 0, i6);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i3 = i1 + i2 | 0;
 i1 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 switch (i1 >>> 30 | 0) {
 case 3:
  {
   i2 = 6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP8[(HEAP32[gb + 90260 + 24 + ((i1 >>> 24 & 15) << 2) >> 2] | 0) + i3 + 13 >> 0] = i4;
  STACKTOP = i6;
  return;
 } else if ((i2 | 0) == 6) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 701240 | 0, 146, gb + 701318 | 0, i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN15DistanceJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i7);
 i1 = i6 + 101 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
 i1 = i6 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i8 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i8, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i7);
  return;
 }
}

function __ZN14AreaEffector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 i5 = gb + 63408 | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 153172 + 8;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 1812433254;
 HEAP32[i1 + 88 >> 2] = 1900727103;
 STACKTOP = i4;
 return;
}

function __Z37UnityWebRequest_CUSTOM_InternalSetUrlP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7;
 i4 = i7 + 32 | 0;
 i5 = i7 + 20 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = i2 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031263 | 0, i7 + 8 | 0);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 if ((HEAP32[i1 >> 2] | 0) == 1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 76 | 0, i5) | 0;
  i1 = 0;
 } else i1 = 31;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!i1) {
  STACKTOP = i7;
  return;
 } else {
  HEAP32[i6 >> 2] = __Z17GetWebErrorString8WebError(i1) | 0;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i6);
 }
}

function __Z26Texture3D_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayi(i5, i4, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = i5;
 if (!i5) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) {
  i8 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 if (!(HEAP8[i2 + 105 >> 0] | 0)) {
  i8 = __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i1) | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 36 >> 2] | 0, i8 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i3);
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5); else {
  __ZN9Texture3D9SetPixelsEiPK10ColorRGBAfi(i2, i3, i1, i6);
  STACKTOP = i7;
  return;
 }
}

function __ZNK14SerializedFile10GetClassIDEx(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i8 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = i8 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 * 24 | 0) | 0;
   i3 = i4;
   i11 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i11 | 0) < (i9 | 0) | ((i11 | 0) == (i9 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i8 | 0)) {
  i11 = i1;
  i10 = HEAP32[i11 + 4 >> 2] | 0;
  if (!((i10 | 0) > (i9 | 0) | ((i10 | 0) == (i9 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 > i7 >>> 0 : 0))) {
   i11 = i1;
   i11 = i11 + 16 | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   i10 = HEAP32[i6 >> 2] | 0;
   i11 = i10 + (i11 * 56 | 0) | 0;
   i11 = HEAP32[i11 >> 2] | 0;
   return i11 | 0;
  }
 }
 i11 = i8;
 i11 = i11 + 16 | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = i10 + (i11 * 56 | 0) | 0;
 i11 = HEAP32[i11 >> 2] | 0;
 return i11 | 0;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx(i9, i8, i3, i4, i5, i6) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 2 | 0;
 i1 = i10;
 HEAP16[i1 >> 1] = i8;
 i7 = i9 + 280 | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i9 + 212 | 0, i1, i2) | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i8;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i1 | 0, i5 | 0, i6 | 0);
 }
 if (!(HEAP8[i9 + 276 >> 0] | 0)) {
  STACKTOP = i10;
  return;
 }
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10eventValueEtyx(i9, i8, i3, i4, i5, i6);
 STACKTOP = i10;
 return;
}

function __ZN5physx6shdfnd6SocketD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 8 | 0;
 i4 = i10;
 i9 = i10 + 12 | 0;
 HEAP32[i1 >> 2] = gb + 110712 + 8;
 i7 = i1 + 4 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0) | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = i8 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i6 = i8 + 14 | 0;
 if ((i1 | 0) == -1) i1 = i8; else {
  if (HEAP8[i6 >> 0] | 0) {
   i2 = i8 + 15 | 0;
   if ((HEAP8[i2 >> 0] | 0) != 1) {
    HEAP32[i4 >> 2] = 0;
    i1 = (_fcntl(i1, 3, i4) | 0) & -2049;
    i4 = HEAP32[i3 >> 2] | 0;
    HEAP32[i5 >> 2] = i1;
    if ((_fcntl(i4, 4, i5) | 0) != -1) HEAP8[i2 >> 0] = 1;
   }
   _shutdown(HEAP32[i3 >> 2] | 0, 2) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  _close(i1) | 0;
  HEAP32[i3 >> 2] = -1;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP8[i6 >> 0] = 0;
 HEAP16[i8 + 12 >> 1] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i7 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx11NpAggregate17resolveReferencesERNS_24PxDeserializationContextE(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = i7 + 36 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i4 = i7 + 40 | 0;
 i6 = 0;
 do {
  i1 = (HEAP32[i4 >> 2] | 0) + (i6 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 0; else {
   HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, -2147483648, i2 | 0) | 0;
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  }
  i1 = i1 + (HEAP32[gb + 1457020 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0;
  if (!(__ZNK5physx7NpActor12getAggregateEv(i1) | 0)) __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i1, i7, HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0);
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0) == 4) {
   i1 = HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0) + 288 >> 2] | 0;
   if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0)) HEAP32[i1 + 100 >> 2] = i7;
  }
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN14SafeBinaryRead8TransferIjEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, HEAP32[gb + 37304 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead8TransferIiEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, HEAP32[gb + 37040 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, HEAP32[gb + 37012 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  i3 = i6 + 16 | 0;
  i2 = HEAP32[i6 + 20 >> 2] | 0;
  i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (i1 >>> 0 < i2 >>> 0) i4 = 6; else {
   i2 = i1 + 4 | 0;
   if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 6; else {
    HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i3 >> 2] = i2;
   }
  }
  if ((i4 | 0) == 6) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
  if (HEAP32[i6 >> 2] & 512 | 0) HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN14ParticleSystem12EndUpdateAllEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if ((HEAP16[gb + 1452176 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452176 | 0, i1);
  i5 = gb + 1452176 | 0;
 } else i5 = 0;
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[gb + 1451700 >> 2] | 0;
 L4 : do if (HEAP32[i1 + 12 >> 2] | 0) {
  i4 = 0;
  do {
   while (1) {
    i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 << 2) >> 2] | 0;
    i3 = HEAP32[i2 + 40 >> 2] | 0;
    if (HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 12 >> 2] | 0) break;
    if (!(HEAP8[i3 + 13 >> 0] | 0)) break;
    HEAP32[i3 + 8 >> 2] = 0;
    __ZN14ParticleSystem17RemoveFromManagerEv(i2);
    i1 = HEAP32[gb + 1451700 >> 2] | 0;
    if (i4 >>> 0 >= (HEAP32[i1 + 12 >> 2] | 0) >>> 0) break L4;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 + 12 >> 2] | 0) >>> 0);
 } while (0);
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 STACKTOP = i6;
 return;
}

function _cbrt(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0, d6 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 > 2146435071) d1 = d1 + d1; else {
  if (i3 >>> 0 < 1048576) {
   HEAPF64[tempDoublePtr >> 3] = d1 * 18014398509481984.0;
   i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
   i2 = i3 & 2147483647;
   if (!i2) break;
   i4 = ((i2 >>> 0) / 3 | 0) + 696219795 | 0;
   i2 = i3;
  } else i4 = ((i3 >>> 0) / 3 | 0) + 715094163 | 0;
  HEAP32[tempDoublePtr >> 2] = 0;
  HEAP32[tempDoublePtr + 4 >> 2] = i4 | i2 & -2147483648;
  d6 = +HEAPF64[tempDoublePtr >> 3];
  d5 = d6 * d6 * (d6 / d1);
  HEAPF64[tempDoublePtr >> 3] = d6 * (d5 * (d5 * d5) * (d5 * .14599619288661245 + -.758397934778766) + (d5 * (d5 * 1.6214297201053545 + -1.8849797954337717) + 1.87595182427177));
  i3 = _i64Add(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, -2147483648, 0) | 0;
  i4 = getTempRet0() | 0;
  HEAP32[tempDoublePtr >> 2] = i3 & -1073741824;
  HEAP32[tempDoublePtr + 4 >> 2] = i4;
  d5 = +HEAPF64[tempDoublePtr >> 3];
  d1 = d1 / (d5 * d5);
  d1 = d5 + d5 * ((d1 - d5) / (d5 + d5 + d1));
 } while (0);
 return +d1;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImpl12onAllocationEjPKcS3_iPv(i4, i8, i9, i6, i7, i5) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i3 = i10 + 8 | 0;
 i2 = i5;
 if (!i5) {
  STACKTOP = i10;
  return;
 }
 i11 = i1;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = 0;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i4 + 12 | 0, i1, i3) | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i11 = i1;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = 0;
  i11 = i1 + 8 | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = i8;
  HEAP32[i1 + 20 >> 2] = i9;
  HEAP32[i1 + 24 >> 2] = i6;
  HEAP32[i1 + 28 >> 2] = i7;
 }
 i1 = HEAP32[i4 + 56 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0, i9 | 0, i6 | 0, i7 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx2Gu29checkOverlapCapsule_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i2, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f9 = f0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i10, i2);
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(HEAPF32[i10 >> 2]);
 f9 = Math_fround(f9 * f3);
 f5 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f5 = Math_fround(f9 + Math_fround(f5 * f7));
 f9 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f9 = Math_fround(f5 + Math_fround(f9 * f4));
 f5 = Math_fround(HEAPF32[i10 + 12 >> 2]);
 f9 = Math_fround(f5 + f9);
 f6 = Math_fround(HEAPF32[i8 + 24 >> 2]);
 if (f9 <= f6) {
  i10 = 1;
  STACKTOP = i1;
  return i10 | 0;
 }
 f9 = Math_fround(f3 * Math_fround(HEAPF32[i8 + 12 >> 2]));
 f9 = Math_fround(f9 + Math_fround(f7 * Math_fround(HEAPF32[i8 + 16 >> 2])));
 i10 = Math_fround(f5 + Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i8 + 20 >> 2])))) <= f6;
 STACKTOP = i1;
 return i10 | 0;
}

function __ZN22ParticleSystemRenderer13ResetInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 340 >> 1] = 0;
 HEAPF32[i1 + 360 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 364 >> 2] = Math_fround(0.0);
 HEAP16[i1 + 342 >> 1] = 0;
 HEAPF32[i1 + 368 >> 2] = Math_fround(1.0);
 i2 = i1 + 372 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP16[i2 + 16 >> 1] = 0;
 HEAP32[i1 + 392 >> 2] = 27;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP16[i1 + 400 >> 1] = 0;
 HEAPF32[i1 + 404 >> 2] = Math_fround(0.0);
 i2 = i1 + 552 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 568 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i1 = i1 + 580 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN12ImageFilters24GetBlitCopyDepthMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 4 | 0;
 i1 = HEAP32[gb + 1110916 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z15GetScriptMapperv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 375700 | 0, 20);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) {
  __Z6FormatPKcz(i2, gb + 375649 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 375577 | 0, 604, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1110916 >> 2] = i2;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z25GL_CUSTOM_InvalidateStatev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1180120 | 0, i1);
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1179092 | 0, i1);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1181148 | 0, i2);
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i2 = __Z12GetGfxDevicev() | 0;
 __ZN11MatrixStack3PopEv(gb + 1179092 | 0);
 __ZN11MatrixStack3PopEv(gb + 1180120 | 0);
 __ZN11MatrixStack3PopEv(gb + 1181148 | 0);
 i1 = __ZNK11MatrixStack9GetMatrixEv(gb + 1179092 | 0) | 0;
 i3 = __ZNK11MatrixStack9GetMatrixEv(gb + 1180120 | 0) | 0;
 i4 = __ZNK11MatrixStack9GetMatrixEv(gb + 1181148 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _pipe2(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 56 | 0;
 i4 = i8 + 40 | 0;
 i7 = i8 + 24 | 0;
 i6 = i8 + 8 | 0;
 i1 = i8;
 do if (!i3) i1 = _pipe(i2) | 0; else {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = ___syscall331(331, i1 | 0) | 0;
  if ((i1 | 0) != -38) {
   i1 = ___syscall_ret(i1) | 0;
   break;
  }
  i1 = _pipe(i2) | 0;
  if (!i1) {
   if (i3 & 524288 | 0) {
    HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i6 + 4 >> 2] = 2;
    HEAP32[i6 + 8 >> 2] = 1;
    ___syscall221(221, i6 | 0) | 0;
    HEAP32[i7 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i7 + 4 >> 2] = 2;
    HEAP32[i7 + 8 >> 2] = 1;
    ___syscall221(221, i7 | 0) | 0;
   }
   if (!(i3 & 2048)) i1 = 0; else {
    HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
    HEAP32[i4 + 4 >> 2] = 4;
    HEAP32[i4 + 8 >> 2] = 2048;
    ___syscall221(221, i4 | 0) | 0;
    HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2];
    HEAP32[i5 + 4 >> 2] = 4;
    HEAP32[i5 + 8 >> 2] = 2048;
    ___syscall221(221, i5 | 0) | 0;
    i1 = 0;
   }
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK5Umbra9Matrix4x48getScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6)) + Math_fround(f5 * f5))));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f8 * f8)) + Math_fround(f4 * f4))));
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6)) + Math_fround(f3 * f3))));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZNK13b2DynamicTree12GetAreaRatioEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 f1 = Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 8 >> 2]);
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i5 + (i2 * 36 | 0) >> 2]));
 f4 = Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 12 >> 2]);
 f4 = Math_fround(Math_fround(f1 + Math_fround(f4 - Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 4 >> 2]))) * Math_fround(2.0));
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i2 = 0;
  f1 = Math_fround(0.0);
  do {
   if ((HEAP32[i5 + (i2 * 36 | 0) + 32 >> 2] | 0) >= 0) {
    f7 = Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 8 >> 2]);
    f7 = Math_fround(f7 - Math_fround(HEAPF32[i5 + (i2 * 36 | 0) >> 2]));
    f6 = Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 12 >> 2]);
    f1 = Math_fround(f1 + Math_fround(Math_fround(f7 + Math_fround(f6 - Math_fround(HEAPF32[i5 + (i2 * 36 | 0) + 4 >> 2]))) * Math_fround(2.0)));
   }
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } else f1 = Math_fround(0.0);
 f7 = Math_fround(f1 / f4);
 return Math_fround(f7);
}

function __ZN7ApiGLES14GenerateMipmapEj16TextureDimension(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = i1 + 860 | 0;
 i7 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i6 >> 2] | 0, i5) | 0;
 i8 = i1 + 1600 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i9 = HEAP32[i1 + 1604 + (i3 << 2) >> 2] | 0;
 i3 = HEAP32[i1 + 1732 + (i3 << 2) >> 2] | 0;
 i4 = i1 + 1992 | 0;
 if (!((HEAP8[i4 >> 0] | 0) != 0 & (i9 | 0) == (i2 | 0))) {
  i10 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i6 >> 2] | 0, i5) | 0;
  mftCall_vii(HEAP32[i1 + 812 >> 2] | 0, i10 | 0, i2 | 0);
  HEAP32[i1 + 1604 + (HEAP32[i8 >> 2] << 2) >> 2] = i2;
  HEAP32[i1 + 1732 + (HEAP32[i8 >> 2] << 2) >> 2] = i5;
 }
 mftCall_vi(HEAP32[i1 + 612 >> 2] | 0, i7 | 0);
 if (HEAP8[i4 >> 0] | 0) if ((HEAP32[i1 + 1604 + (HEAP32[i8 >> 2] << 2) >> 2] | 0) == (i9 | 0)) return;
 i10 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i6 >> 2] | 0, i3) | 0;
 mftCall_vii(HEAP32[i1 + 812 >> 2] | 0, i10 | 0, i9 | 0);
 HEAP32[i1 + 1604 + (HEAP32[i8 >> 2] << 2) >> 2] = i9;
 HEAP32[i1 + 1732 + (HEAP32[i8 >> 2] << 2) >> 2] = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 1;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 1) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   i1 = i1 + 2 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 2 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_20PxProfileZoneHandlerENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 657137 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i8, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i8, i1);
 i7 = i1 + 16 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = i1 + 24 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i3 = i4;
 }
 HEAP32[i8 + 36 >> 2] = i1;
 i1 = i3 + 4 | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i7 >> 2] = i1;
  i1 = i5;
 }
 HEAP32[i8 + 40 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i9) {
  STACKTOP = i10;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i10;
 return;
}

function __ZN10Matrix4x4f14SetPerspectiveEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var f6 = f0;
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f6 = Math_fround(Math_fround(+Math_cos(+f6)) / Math_fround(+Math_sin(+f6)));
 f2 = Math_fround(f4 - f5);
 HEAPF32[i1 >> 2] = Math_fround(f6 / f3);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = f6;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(f4 + f5) / f2);
 HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(Math_fround(f4 * Math_fround(2.0)) * f5) / f2);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return i1 | 0;
}

function __Z36LoadAssetWithSubAssetFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 i9 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i9 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i9 & 255) | 0)) {
  HEAP32[i5 >> 2] = HEAP32[i1 + 68 >> 2];
  HEAP32[i5 + 4 >> 2] = i1 + 72;
 } else __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i1, i2);
 i2 = i5;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = i5;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb(i1, i7, i3, i4, 0);
 STACKTOP = i8;
 return;
}

function __Z35Transfer_Blittable_SingleValueFieldI8JSONRead10Matrix4x4fEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i7 = (HEAP8[i1 >> 0] | 0) == 0 ? i7 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i7;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = i8 + 36 | 0;
 HEAP8[i4 >> 0] = 0;
 if (!((i3 & 524288 | 0) == 0 | (HEAP32[i8 >> 2] & 2 | 0) == 0)) return;
 i5 = i8 + 40 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if (!i6) return;
  if ((HEAP32[i6 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i8, i6, i1) | 0;
 HEAP32[i5 >> 2] = i9;
 i1 = i8 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1034429;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i8, i3);
  __ZN10Matrix4x4f8TransferI8JSONReadEEvRT_(i7, i8);
  HEAP8[i4 >> 0] = 1;
  i9 = i8 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i5 >> 2] = i6;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z28RenderTextureDiscardContentsP13RenderTexturebb(i1, i3, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 i7 = i9;
 i8 = __Z12GetGfxDevicev() | 0;
 if (!i1) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 368 >> 2] | 0, i8 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 372 >> 2] | 0, i8 | 0) | 0;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 128 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  i10 = HEAP32[i1 + 132 >> 2] | 0;
  HEAP32[i6 >> 2] = i10;
  HEAP32[i7 >> 2] = HEAP32[i1 + 136 >> 2];
  i1 = i10;
 }
 if (i3) {
  if (i2) {
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 336 >> 2] | 0, i8 | 0, i4 | 0);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 336 >> 2] | 0, i8 | 0, i6 | 0);
 }
 if (!i5) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 336 >> 2] | 0, i8 | 0, i7 | 0);
 STACKTOP = i9;
 return;
}

function __Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!(HEAP8[i1 + 776 >> 0] | 0)) {
  i4 = __Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei(i2, i1 + 740 | 0, 1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = i1 + 756 | 0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i4 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 + 760 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 764 >> 2]));
 f6 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f7 * f7)) + Math_fround(f6 * f6));
 if (f6 < Math_fround(HEAPF32[i1 + 772 >> 2])) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP32[i1 + 768 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = i1;
 i4 = __Z19IntersectAABBSphereRK4AABBRK6Sphere(i2, i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK17BaseWebCamTexture8GetPixelEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 do if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 228 >> 2] | 0, i2 | 0) | 0) {
  if (!(HEAP8[i2 + 94 >> 0] | 0)) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895154 | 0, 0, gb + 895080 | 0, 108, 1, 0, 0, 0);
   break;
  }
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) {
   i8 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0;
   i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
   i6 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
   i5 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0) | 0;
   __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii(i1, i8, i7, i6, i5, HEAP32[i2 + 44 >> 2] | 0, i3, i4);
   return;
  }
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 895035 | 0, 0, gb + 895080 | 0, 102, 1, 0, 0, 0); while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 718107 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 714273 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_19PxProfileZoneClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx2Sq11PruningPool11shiftOriginERKNS_6PxVec3E(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i5) return;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = i6 + 4 | 0;
 i3 = i6 + 8 | 0;
 i4 = 0;
 do {
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i1 + (i4 * 24 | 0) | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i7 = i1 + (i4 * 24 | 0) + 4 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i7 = i1 + (i4 * 24 | 0) + 8 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i6 >> 2]);
  i7 = i1 + (i4 * 24 | 0) + 12 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i2 >> 2]);
  i7 = i1 + (i4 * 24 | 0) + 16 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  f8 = Math_fround(HEAPF32[i3 >> 2]);
  i7 = i1 + (i4 * 24 | 0) + 20 | 0;
  HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[i7 >> 2]) - f8);
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i5 >>> 0);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i3);
 __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 4 | 0, i3);
 i1 = i6 + 8 | 0;
 i7 = i3 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 16 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN19LowerResBlitTexture17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 + 48 >> 2];
 i4 = HEAP32[gb + 1157724 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if ((HEAP32[i4 + 36 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = i2 + (i3 << 3) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_(i2, i4, i3);
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 + 28 >> 2] | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? i2 + (i3 << 3) | 0 : i2 + (i1 << 3) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 << 3) | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = i4 + 12 | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP8[i4 + 48 >> 0] = 1;
 STACKTOP = i6;
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEE7SortJobEPS5_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i2 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i5);
 } else i1 = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_(i8, i7, i2, i5);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __ZN10Matrix4x4f8SetOrthoEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0, f10 = f0;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 f10 = Math_fround(f3 - f2);
 f9 = Math_fround(f5 - f4);
 f8 = Math_fround(f7 - f6);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(2.0) / f10);
 HEAPF32[i1 + 48 >> 2] = Math_fround(Math_fround(-Math_fround(f2 + f3)) / f10);
 HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(2.0) / f9);
 HEAPF32[i1 + 52 >> 2] = Math_fround(Math_fround(-Math_fround(f4 + f5)) / f9);
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(-2.0) / f8);
 HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(-Math_fround(f6 + f7)) / f8);
 return i1 | 0;
}

function __Z39Collider2D_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfiff(i2, i3, i5, f6, i7, f8, f9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i1 = 0, i4 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 36) | 0;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZNK10Collider2D7RaycastERK8Vector2ffiffP12RaycastHit2Di(i4, i10, f6, i7, f8, f9, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0) | 0;
 if (!i3) {
  STACKTOP = i11;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i11;
 return i3 | 0;
}

function __ZNK9ShaderLab11ShaderState34ShouldRemoveAnyUnsupportedProgramsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 700 | 0;
 if (!(HEAP32[i3 + 712 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i4) | 0;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 if (i2) i1 = i1 | (__ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i2, i4) | 0);
 i2 = HEAP32[i3 + 36 >> 2] | 0;
 if (i2) i1 = i1 | (__ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i2, i4) | 0);
 i2 = HEAP32[i3 + 40 >> 2] | 0;
 if (i2) i1 = i1 | (__ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i2, i4) | 0);
 i2 = HEAP32[i3 + 44 >> 2] | 0;
 if (!i2) i2 = i1; else i2 = i1 | (__ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i2, i4) | 0);
 i1 = HEAP32[i3 + 48 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  return i4 | 0;
 }
 i4 = i2 | (__ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE(i1, i4) | 0);
 return i4 | 0;
}

function __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvRS2_RNS_16PxcSolverContextERS7_SC_E(i1, i8, i9, i2, i3, i10, i7, i11) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i11 = i11 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 + 16 >> 2] = i7;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = i3;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 if (!i9) {
  i11 = 0;
  HEAP32[i10 >> 2] = i11;
  STACKTOP = i6;
  return;
 } else i4 = 0;
 do {
  if ((HEAP16[i8 + (i4 << 5) + 8 >> 1] | 0) == -1) i1 = HEAPU16[i8 + (i4 << 5) + 10 >> 1] | 0; else i1 = 0;
  if ((HEAP16[i8 + (i4 << 5) + 12 >> 1] | 0) == -1) i2 = HEAPU16[i8 + (i4 << 5) + 14 >> 1] | 0; else i2 = 0;
  mftCall_viiii(HEAP32[i11 + (HEAPU8[HEAP32[i8 + (i4 << 5) + 16 >> 2] >> 0] << 2) >> 2] | 0, i8 + (i4 << 5) | 0, i5 | 0, i7 + (i1 << 6) | 0, i7 + (i2 << 6) | 0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i9 | 0));
 i11 = HEAP32[i3 >> 2] | 0;
 HEAP32[i10 >> 2] = i11;
 STACKTOP = i6;
 return;
}

function __ZNK14b2PolygonShape9TestPointERK11b2TransformRK6b2Vec2(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f7 = f0, f8 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(f6 * f8);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f7 * f4));
 f4 = Math_fround(Math_fround(f8 * f7) - Math_fround(f6 * f4));
 i2 = HEAP32[i5 + 148 >> 2] | 0;
 if ((i2 | 0) > 0) i1 = 0; else {
  i5 = 1;
  return i5 | 0;
 }
 while (1) {
  f7 = Math_fround(f3 - Math_fround(HEAPF32[i5 + 20 + (i1 << 3) >> 2]));
  f8 = Math_fround(f4 - Math_fround(HEAPF32[i5 + 20 + (i1 << 3) + 4 >> 2]));
  f7 = Math_fround(f7 * Math_fround(HEAPF32[i5 + 84 + (i1 << 3) >> 2]));
  if (Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i5 + 84 + (i1 << 3) + 4 >> 2]))) > Math_fround(0.0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = 1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZNK11Rigidbody2D24GetRelativePointVelocityERK8Vector2f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 if (i4 | 0) if ((HEAP32[i2 + 68 >> 2] | 0) != 2) {
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 24 >> 2]);
  f5 = Math_fround(f7 * f8);
  f6 = Math_fround(HEAPF32[i4 + 20 >> 2]);
  f5 = Math_fround(f5 - Math_fround(f9 * f6));
  f5 = Math_fround(Math_fround(HEAPF32[i4 + 12 >> 2]) + f5);
  f6 = Math_fround(Math_fround(f9 * f8) + Math_fround(f7 * f6));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i4 + 16 >> 2]));
  f7 = Math_fround(HEAPF32[i4 + 72 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 44 >> 2]));
  f6 = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i4 + 48 >> 2])));
  f5 = Math_fround(f7 * f5);
  f6 = Math_fround(Math_fround(HEAPF32[i4 + 64 >> 2]) - f6);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + 68 >> 2]));
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i1 + 4 >> 2] = f5;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN26AnimatorOverrideController8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN25RuntimeAnimatorController8TransferI14SafeBinaryReadEEvRT_(i2, i5);
 i3 = i2 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 905632 | 0, gb + 905645 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 84 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 905677 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 178296 + 8;
 HEAP32[i1 + 32 >> 2] = i1;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = i1;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 422379 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 344 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 422397 | 0, gb + 422409 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI14BillboardAssetE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZL34GetComponentsImplementationRecurseILb1ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[HEAP32[i8 >> 2] >> 2] = 0;
 if (i6) i1 = 3; else if (__ZNK10GameObject8IsActiveEv(i5) | 0) i1 = 3;
 L3 : do if ((i1 | 0) == 3) {
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  i3 = HEAP32[i5 + 40 >> 2] | 0;
  i4 = i1 + (i3 << 3) | 0;
  if (i3 | 0) {
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   i2 = HEAP32[i3 + 24 >> 2] | 0;
   i3 = HEAP32[i3 + 28 >> 2] | 0;
   while (1) {
    if (((HEAP32[i1 >> 2] | 0) - i2 | 0) >>> 0 < i3 >>> 0) break;
    i1 = i1 + 8 | 0;
    if ((i1 | 0) == (i4 | 0)) break L3;
   }
   HEAP32[HEAP32[i8 >> 2] >> 2] = HEAP32[i1 + 4 >> 2];
   i8 = 1;
   return i8 | 0;
  }
 } while (0);
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i5, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = __ZL34GetComponentsImplementationRecurseILb1ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i6, i7, i8) | 0;
 return i8 | 0;
}

function __ZNK9DebugGLES8CullModeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[i1 + 1992 >> 0] | 0)) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 switch ((mftCall_ii(HEAP32[i1 + 764 >> 2] | 0, 2884) | 0) << 24 >> 24) {
 case 1:
  {
   i2 = HEAP32[i3 >> 2] | 0;
   i1 = HEAP32[i2 + 1576 >> 2] | 0;
   if (!i1) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   if ((i1 + -1 | 0) >>> 0 >= 2) {
    i4 = 1;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i4 >> 2] = 0;
   mftCall_vii(HEAP32[i2 + 88 >> 2] | 0, 2885, i4 | 0);
   switch (HEAP32[i4 >> 2] | 0) {
   case 1028:
    {
     i1 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 1576 >> 2] | 0) == 1;
     break;
    }
   case 1029:
    {
     i1 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 1576 >> 2] | 0) == 2;
     break;
    }
   default:
    i1 = 0;
   }
   i4 = i1;
   STACKTOP = i5;
   return i4 | 0;
  }
 case 0:
  {
   STACKTOP = i5;
   return (HEAP32[(HEAP32[i3 >> 2] | 0) + 1576 >> 2] | 0) == 0 | 0;
  }
 default:
  {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 return 0;
}

function __ZN9LensFlare17RemoveFromManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  }
 } while (0);
 i3 = i2 + 68 | 0;
 HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 52 | 0) + 49 >> 0] = 0;
 HEAP32[i3 >> 2] = -1;
 return;
}

function __ZN17Physics2DSettings23SetLinearSleepToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 84 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151900 >> 2] = f3;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAPF32[gb + 151916 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN15DistanceJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 36972 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803035 | 0, i5, i1 + 101 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803059 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 96 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801285 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN12LightManager9GetLightsE9LightTypei(i6, i7, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 HEAP32[i6 >> 2] = 0;
 i10 = i6 + 4 | 0;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i5 = 1 << i1;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i7 | 0)) {
  STACKTOP = i11;
  return;
 }
 i4 = i6 + 8 | 0;
 do {
  i3 = i1 + -36 | 0;
  HEAP32[i9 >> 2] = i3;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  do if ((HEAP32[i1 + 40 >> 2] | 0) == (i8 | 0)) if (HEAP32[i1 + 36 >> 2] & i5 | 0) {
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
    __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier52ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i6, i9);
    break;
   } else {
    HEAP32[i1 >> 2] = i3;
    HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 4;
    break;
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 STACKTOP = i11;
 return;
}

function __ZNK5Umbra4AABB11getSideQuadEiPNS_7Vector3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = i1 + 12 | 0;
 i5 = i1 + 16 | 0;
 i8 = i1 + 4 | 0;
 i4 = i1 + 20 | 0;
 i7 = i1 + 8 | 0;
 i10 = HEAP32[((i2 | 0) != 4 ? i8 : i5) >> 2] | 0;
 i9 = HEAP32[((i2 | 0) != 5 ? i7 : i4) >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[((i2 | 0) != 3 ? i1 : i6) >> 2];
 HEAP32[i3 + 4 >> 2] = i10;
 HEAP32[i3 + 8 >> 2] = i9;
 i9 = HEAP32[((i2 + -2 | 0) >>> 0 > 2 ? i8 : i5) >> 2] | 0;
 i10 = HEAP32[((i2 + -1 | 0) >>> 0 < 3 ? i7 : i4) >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[(21 >>> i2 & 1 | 0 ? i1 : i6) >> 2];
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = i10;
 i10 = HEAP32[((i2 | 0) == 1 ? i8 : i5) >> 2] | 0;
 i9 = HEAP32[((i2 | 0) == 2 ? i7 : i4) >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = HEAP32[((i2 | 0) == 0 ? i1 : i6) >> 2];
 HEAP32[i3 + 28 >> 2] = i10;
 HEAP32[i3 + 32 >> 2] = i9;
 i5 = HEAP32[((i2 + -1 | 0) >>> 0 < 3 ? i8 : i5) >> 2] | 0;
 i4 = HEAP32[(21 >>> i2 & 1 | 0 ? i7 : i4) >> 2] | 0;
 HEAP32[i3 + 36 >> 2] = HEAP32[((i2 + -2 | 0) >>> 0 > 2 ? i1 : i6) >> 2];
 HEAP32[i3 + 40 >> 2] = i5;
 HEAP32[i3 + 44 >> 2] = i4;
 return;
}

function __ZN7mecanim12statemachine23SetMessageOnChildStatesENS0_19StateMachineMessageERNS0_18StateMachineMemoryERNS0_18StateMachineOutputEb(i7, i8, i1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i6 = i1 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 i5 = i2 & 1 ^ 1;
 i4 = 0;
 while (1) {
  i2 = HEAP32[(HEAP32[(HEAP32[HEAP32[i6 >> 2] >> 2] | 0) + (i4 << 2) >> 2] | 0) + 8 >> 2] | 0;
  if (i5 >>> 0 >= (HEAP32[i2 + 28 >> 2] | 0) >>> 0) {
   i1 = 10;
   break;
  }
  i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i5 << 3) + 4 >> 2] | 0;
  if (i2) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   if (i3) {
    i2 = i2 + 16 | 0;
    i1 = 0;
    do {
     i9 = HEAP32[i2 >> 2] | 0;
     i10 = HEAP32[i9 + (i1 << 3) + 4 >> 2] | 0;
     i9 = Math_fround(HEAPF32[i9 + (i1 << 3) >> 2]) > Math_fround(0.0);
     mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 124 >> 2] | 0, i10 | 0, (i9 ? i7 : 128) | 0);
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i3 | 0));
    i1 = HEAP32[i8 >> 2] | 0;
   }
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i1 >>> 0) {
   i1 = 10;
   break;
  }
 }
 if ((i1 | 0) == 10) return;
}

function __ZN5physx7profile15ZoneManagerImpl21addProfileZoneHandlerERNS_20PxProfileZoneHandlerE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i5 = i4 + 44 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 HEAP32[i1 >> 2] = i6;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 36 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 28 >> 2] | 0) + (i3 << 2) >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_20PxProfileZoneHandlerENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4 + 24 | 0, i1) | 0;
 i3 = i4 + 16 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i6 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
 i1 = i4 + 12 | 0;
 i2 = 0;
 do {
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 i6 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = i5 << 2;
  if (!i1) i4 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 832326 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN20SoundChannelInstance7SetLoopEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP8[i1 + 145 >> 0] = i2 & 1;
 HEAP16[i8 >> 1] = (i7 & 1) << 14 & 65535 | ((((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 16383);
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel7setModeEj(i3, i2 ? 2 : 1) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 401;
 HEAP32[i5 + 8 >> 2] = gb + 865734;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN19AssetBundleManifest15AssetBundleInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_(i4, i7);
 i8 = i4 + 16 | 0;
 i1 = i7 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i1, i6, 4);
  i1 = HEAP32[i6 >> 2] | 0;
 } else {
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  i1 = i5;
 }
 i4 = i4 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i2 = i5 - i3 >> 2;
 if (i1 >>> 0 > i2 >>> 0) {
  __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i8, i1 - i2 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 } else if (i1 >>> 0 < i2 >>> 0) {
  i2 = i3 + (i1 << 2) | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i2 | 0) >>> 2) << 2);
 }
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, HEAP32[i8 >> 2] | 0, i1 << 2);
 STACKTOP = i9;
 return;
}

function __ZN18ProceduralMaterial21AddSubstanceGraphDataEP13SubstanceDataPhjRNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS6_L18MemLabelIdentifier1ELi16EEEE(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63736 | 0, 1, gb + 432051 | 0, 685) | 0;
 if (i4 | 0) {
  _memcpy(i4 | 0, i1 | 0, i2 | 0) | 0;
  HEAP32[i5 >> 2] = i4;
  i5 = 1;
  return i5 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 432139 | 0, 0, gb + 432051 | 0, 695, 1, 0, 0, 0);
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i3 + 4 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) > 0) {
  i1 = (i1 >> 2) + -1 | 0;
  do {
   i4 = (HEAP32[i2 + (i1 << 2) >> 2] | 0) + 28 | 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2048;
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) > -1);
 }
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP8[i5 + 16 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, gb + 63736 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63736 | 0);
 i5 = 0;
 return i5 | 0;
}

function __ZN12ImageFilters19GetBlitCopyMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 4 | 0;
 i1 = HEAP32[gb + 1110912 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z15GetScriptMapperv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 410414 | 0, 15);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) {
  __Z6FormatPKcz(i2, gb + 375649 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 375577 | 0, 588, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
  HEAP32[gb + 1110912 >> 2] = i2;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z29StdTemplateConversionFunctionIiyEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i6 = (i4 | 0) < 0;
  i6 = i6 << 31 >> 31;
  i7 = i5;
  i5 = i7;
  HEAP32[i5 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 i6 = (i4 | 0) < 0;
 i6 = i6 << 31 >> 31;
 i7 = i5;
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIixEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i6 = (i4 | 0) < 0;
  i6 = i6 << 31 >> 31;
  i7 = i5;
  i5 = i7;
  HEAP32[i5 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 i6 = (i4 | 0) < 0;
 i6 = i6 << 31 >> 31;
 i7 = i5;
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = i6;
 STACKTOP = i8;
 return 1;
}

function _accept4(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9 + 8 | 0;
 i2 = i9;
 i1 = i9 + 40 | 0;
 L1 : do if (!i6) i1 = _accept(i3, i4, i5) | 0; else {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i4;
  HEAP32[i1 + 8 >> 2] = i5;
  HEAP32[i1 + 12 >> 2] = i6;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i2 >> 2] = 18;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = ___syscall_ret(___syscall102(102, i2 | 0) | 0) | 0;
  if ((i1 | 0) <= -1) {
   switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
   case 22:
   case 38:
    break;
   default:
    break L1;
   }
   i1 = _accept(i3, i4, i5) | 0;
   if ((i1 | 0) >= 0) {
    if (i6 & 524288 | 0) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i7 + 4 >> 2] = 2;
     HEAP32[i7 + 8 >> 2] = 1;
     ___syscall221(221, i7 | 0) | 0;
    }
    if (i6 & 2048) {
     HEAP32[i8 >> 2] = i1;
     HEAP32[i8 + 4 >> 2] = 4;
     HEAP32[i8 + 8 >> 2] = 2048;
     ___syscall221(221, i8 | 0) | 0;
    }
   }
  }
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (((i2 - i3 | 0) / 12 | 0) >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 * 12 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 * 12 | 0);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = ((i3 - i1 | 0) / 12 | 0) + i8 | 0;
 if (i4 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = (i2 - i1 | 0) / 12 | 0;
 i6 = i5 << 1;
 i4 = i5 >>> 0 < 178956970 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 357913941;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i5 = i6 + (((i3 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 _memset(i5 | 0, 0, i8 * 12 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 * 12 | 0);
 HEAP32[i9 >> 2] = i6 + (i4 * 12 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK9dtNavMesh19getTileAndPolyByRefEyPPK10dtMeshTilePPK6dtPoly(i1, i4, i2, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 if ((i4 | 0) == 0 & (i2 | 0) == 0) {
  i8 = -2147483648;
  return i8 | 0;
 }
 i5 = _bitshift64Lshr(i4 | 0, i2 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i4 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i8 = -2147483640;
  return i8 | 0;
 }
 i9 = _bitshift64Lshr(i4 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i2 = i1 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + (i5 * 56 | 0) | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i9 | 0)) {
  i9 = -2147483640;
  return i9 | 0;
 }
 i1 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i1) {
  i9 = -2147483640;
  return i9 | 0;
 }
 do if ((i4 & 983040 | 0) == 65536 & 0 == 0) {
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 } else if (i6 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
  HEAP32[i7 >> 2] = i3;
  i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 * 56 | 0) + 16 >> 2] | 0) + (i6 << 5) | 0;
  break;
 } else {
  i9 = -2147483640;
  return i9 | 0;
 } while (0);
 HEAP32[i8 >> 2] = i1;
 i9 = 1073741824;
 return i9 | 0;
}

function __ZN8LODGroup7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(96, i1, 16, gb + 1048932 | 0, 0, gb + 425313 | 0, 37) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 57764 + 8;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP8[i4 + 52 >> 0] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = -1;
 HEAP8[i4 + 72 >> 0] = 1;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx3Cct17CapsuleController15setFootPositionERKNS_14PxExtendedVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 f5 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 + 496 >> 2]));
 f5 = Math_fround(f5 + Math_fround(Math_fround(HEAPF32[i2 + 500 >> 2]) * Math_fround(.5)));
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * f5);
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * f5);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF64[i4 >> 3] = +HEAPF64[i4 >> 3] + +f7;
 i1 = i4 + 8 | 0;
 HEAPF64[i1 >> 3] = +f6 + +HEAPF64[i1 >> 3];
 i1 = i4 + 16 | 0;
 HEAPF64[i1 >> 3] = +f5 + +HEAPF64[i1 >> 3];
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN18ProfilerConnection33HandleQueryFunctionCalleesMessageEPKvjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1 + 8 | 0;
 i5 = i1;
 i2 = i1 + 36 | 0;
 i4 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i3, _strlen(i3) | 0);
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i3 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = __ZN16PlayerConnection3GetEv() | 0;
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i4, HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0, 52, 0, 0);
 __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __ZN14NavMeshManager18UnregisterObstacleERi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 60 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + (i2 * 12 | 0) + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) != -1) {
  __ZN14NavMeshCarving14RemoveObstacleERi(HEAP32[i4 + 104 >> 2] | 0, i3);
  i1 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i1 + (i2 * 12 | 0) + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  __ZN7dtCrowd14RemoveObstacleER13dtCrowdHandle(HEAP32[i4 + 100 >> 2] | 0, i1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i4 + 72 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i3 + -1 | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i6 = i3;
  i6 = i6 + -1 | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i5 >> 2] = -1;
  return;
 }
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i7 + (i2 * 12 | 0) | 0;
 i4 = i7 + (i4 * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 * 12 | 0) >> 2] | 0) + 36 >> 2] = i4;
 i6 = HEAP32[i1 >> 2] | 0;
 i6 = i6 + -1 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsUInt64ERK8UnityStry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 12 | 0;
 i5 = i4 + 24 | 0;
 i6 = i4;
 i9 = HEAP8[i1 + 11 >> 0] | 0;
 i10 = i9 << 24 >> 24 < 0;
 i8 = i10 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = i10 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i8, i1);
 __Z21UnsignedInt64ToStringy(i6, i2, i3);
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i7, i5, i6);
 i3 = __Z14StringToUInt64PKc((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 i2 = getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 setTempRet0(i2 | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i7, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i7, i3);
 i5 = i3 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i6 = i3 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 1);
  i1 = HEAP8[i4 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i4 >> 0] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP8[i7 + 56 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i3);
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4);
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
 }
 HEAP32[i7 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __Z26CaptureScreenshotImmediateNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiiii(i1, i2, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i8 = 0;
 i3 = __Z16GetScreenManagerv() | 0;
 mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i3 | 0) | 0;
 mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
 i3 = __Znwj(20) | 0;
 __ZN5ImageC2Eii13TextureFormat(i3, i6, i7, 4);
 i8 = __Z12GetGfxDevicev() | 0;
 i4 = i3 + 16 | 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 596 >> 2] | 0, i8 | 0, i2 | 0, i5 | 0, i6 | 0, i7 | 0, HEAP32[i4 >> 2] | 0) | 0) {
  i8 = __Znwj(16) | 0;
  HEAP32[i8 >> 2] = 0;
  HEAP32[i8 + 4 >> 2] = 0;
  HEAP32[i8 + 8 >> 2] = 0;
  HEAP32[i8 + 12 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i8, i1) | 0;
  HEAP32[i8 + 12 >> 2] = i3;
  __Z21WriteImageAsyncThreadPv(i8) | 0;
  return;
 } else {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63184 | 0);
  __ZdlPv(i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 444909 | 0, 0, gb + 444834 | 0, 376, 1, 0, 0, 0);
  return;
 }
}

function __ZNK8VRDevice38GetProjectionMatrixWithClippingOffsetsEPK6Camera21MonoOrStereoscopicEyeffR10Matrix4x4f(i6, i7, i8, f2, f5, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 f5 = Math_fround(f5);
 i9 = i9 | 0;
 var i1 = 0, i3 = 0, f4 = f0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i3 = i11;
 if ((HEAP16[gb + 1469216 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i7;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469216 | 0, i1);
  i3 = gb + 1469216 | 0;
 } else i3 = 0;
 f4 = Math_fround(Math_fround(__ZNK6Camera7GetNearEv(i7)) + f2);
 f2 = Math_fround(Math_fround(__ZNK6Camera6GetFarEv(i7)) + f5);
 i1 = HEAP32[i6 + 228 >> 2] | 0;
 if (!i1) i10 = 5; else if (!(mftCall_iiffi(i1 | 0, i8 | 0, +f4, +f2, i9 | 0) | 0)) i10 = 5;
 if ((i10 | 0) == 5) {
  f5 = Math_fround(__ZNK6Camera6GetFovEv(i7));
  __ZN10Matrix4x4f14SetPerspectiveEffff(i9, f5, Math_fround(__ZNK6Camera9GetAspectEv(i7)), f4, f2) | 0;
 }
 if (!i3) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i11;
 return;
}

function __ZN5physx30PxRevoluteJointGeneratedValuesC2EPKNS_15PxRevoluteJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 HEAPF32[i2 + 160 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i2 + 168 | 0, i1 | 0);
 HEAPF32[i2 + 196 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 200 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 204 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0));
 HEAP16[i2 + 208 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 212 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 216 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 220 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN4Tree23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 935475 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 32 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 935480 | 0, gb + 935501 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI18SpeedTreeWindAssetE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN2UI14CanvasRenderer8SetColorERK10ColorRGBAf(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i5 = i3 + 32 | 0;
 f8 = Math_fround(HEAPF32[i5 >> 2]);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 if (f8 == f6) {
  i2 = i3 + 36 | 0;
  f9 = Math_fround(HEAPF32[i2 >> 2]);
  f8 = Math_fround(HEAPF32[i4 + 4 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
  if (f9 == f8) {
   f9 = Math_fround(HEAPF32[i3 + 40 >> 2]);
   if (f9 == Math_fround(HEAPF32[i4 + 8 >> 2])) {
    f9 = Math_fround(HEAPF32[i3 + 44 >> 2]);
    if (!(f9 == Math_fround(HEAPF32[i4 + 12 >> 2]))) i7 = 6;
   } else i7 = 6;
  } else i7 = 6;
 } else {
  i2 = i3 + 36 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = 6;
 }
 if ((i7 | 0) == 6) {
  i10 = HEAP32[i4 + 8 >> 2] | 0;
  i7 = HEAP32[i4 + 12 >> 2] | 0;
  HEAPF32[i5 >> 2] = f6;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 + 40 >> 2] = i10;
  HEAP32[i3 + 44 >> 2] = i7;
 }
 i10 = i3 + 162 | 0;
 HEAP16[i10 >> 1] = HEAPU16[i10 >> 1] | 0 | 2112;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i3 + 188 >> 2] | 0, i3);
 return;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 481702 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 32 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 481721 | 0, gb + 481728 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN13SpeedTreeWind8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN17ProfilerFrameData30DeserializeProfilerInformationEPPib(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i1) {
  i2 = (_strlen(i5) | 0) >>> 2;
  i1 = 0;
  while (1) {
   i7 = i5 + (i1 << 2) | 0;
   HEAP32[i7 >> 2] = _llvm_bswap_i32(HEAP32[i7 >> 2] | 0) | 0;
   if ((i1 | 0) == (i2 | 0)) break; else i1 = i1 + 1 | 0;
  }
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, _strlen(i5) | 0);
 i7 = HEAP8[i4 + 11 >> 0] | 0;
 i5 = i7 << 24 >> 24 < 0;
 i7 = (HEAP32[i3 >> 2] | 0) + (((i5 ? HEAP32[i4 + 4 >> 2] | 0 : i7 & 255) >>> 2) + 1 << 2) | 0;
 HEAP32[i3 >> 2] = i7 + 4;
 i7 = HEAP32[i7 >> 2] | 0;
 i7 = __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE(HEAP32[gb + 1163228 >> 2] | 0, i5 ? HEAP32[i4 >> 2] | 0 : i4, i7 >>> 16, i7 & 65535) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN17Physics2DSettings20SetBaumgarteTOIScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 76 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151900 >> 2] = f3;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAPF32[gb + 151908 >> 2] = f2;
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function _ps_dimension_done(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = i5 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  while (1) {
   _UNITY_ft_mem_free(i6, HEAP32[i1 + 8 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i1 = i1 + 16 | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
 }
 _UNITY_ft_mem_free(i6, i1);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i5 + 16 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i5 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  while (1) {
   _UNITY_ft_mem_free(i6, HEAP32[i1 + 8 >> 2] | 0);
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i1 = i1 + 16 | 0;
  }
  i1 = HEAP32[i4 >> 2] | 0;
 }
 _UNITY_ft_mem_free(i6, i1);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 8 | 0;
 _UNITY_ft_mem_free(i6, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 return;
}

function _ms_write(i2, i7, i1) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i2 + 84 >> 2] | 0;
 i4 = i2 + 20 | 0;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i3 = (HEAP32[i4 >> 2] | 0) - i5 | 0;
 if (!i3) i6 = 3; else {
  HEAP32[i4 >> 2] = i5;
  if ((_ms_write(i2, i5, i3) | 0) >>> 0 < i3 >>> 0) i1 = 0; else i6 = 3;
 }
 do if ((i6 | 0) == 3) {
  i6 = i8 + 8 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = i2 + i1 | 0;
  i5 = i8 + 20 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) i3 = i8 + 12 | 0; else {
   i2 = i3 + 1 | i4 << 1 | 1;
   i3 = i8 + 12 | 0;
   i4 = _realloc(HEAP32[i3 >> 2] | 0, i2) | 0;
   if (!i4) {
    i1 = 0;
    break;
   }
   HEAP32[i3 >> 2] = i4;
   HEAP32[HEAP32[i8 >> 2] >> 2] = i4;
   i4 = HEAP32[i5 >> 2] | 0;
   _memset((HEAP32[i3 >> 2] | 0) + i4 | 0, 0, i2 - i4 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  _memcpy((HEAP32[i3 >> 2] | 0) + i2 | 0, i7 | 0, i1 | 0) | 0;
  i3 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
  HEAP32[i6 >> 2] = i3;
  i2 = i8 + 16 | 0;
  if (i3 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) HEAP32[i2 >> 2] = i3;
  HEAP32[HEAP32[i8 + 4 >> 2] >> 2] = i3;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i1 + 4 | 0;
 i6 = i2 + 4 | 0;
 __ZNSt3__26localeC2ERKS0_(i5, i4);
 __ZNSt3__26localeaSERKS0_(i4, i6) | 0;
 __ZNSt3__26localeaSERKS0_(i6, i5) | 0;
 __ZNSt3__26localeD2Ev(i5);
 i5 = i1 + 8 | 0;
 i6 = i2 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 12 | 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 16 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 20 | 0;
 i6 = i2 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 24 | 0;
 i4 = i2 + 24 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 28 | 0;
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i1 + 4 | 0;
 i6 = i2 + 4 | 0;
 __ZNSt3__26localeC2ERKS0_(i5, i4);
 __ZNSt3__26localeaSERKS0_(i4, i6) | 0;
 __ZNSt3__26localeaSERKS0_(i6, i5) | 0;
 __ZNSt3__26localeD2Ev(i5);
 i5 = i1 + 8 | 0;
 i6 = i2 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 12 | 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 16 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i6;
 i5 = i1 + 20 | 0;
 i6 = i2 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i1 + 24 | 0;
 i4 = i2 + 24 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 28 | 0;
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwjj(i2, i8, i3, i9) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 i3 = (i1 - i3 | 0) >>> 0 > i9 >>> 0 ? i3 + i9 | 0 : i1;
 i7 = i2 + (i3 << 2) | 0;
 i4 = i8 + (i9 << 2) | 0;
 i1 = i9 << 2 >> 2;
 L5 : do if (!i1) i1 = i7; else if ((i3 << 2 >> 2 | 0) < (i1 | 0)) i1 = i7; else {
  i6 = i2 + (i1 + -1 << 2) | 0;
  i5 = i4 + -4 | 0;
  i1 = i7;
  L8 : while (1) {
   while (1) {
    if ((i6 | 0) == (i1 | 0)) {
     i1 = i7;
     break L5;
    }
    i4 = i1 + -4 | 0;
    if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i5 >> 2] | 0)) {
     i3 = i5;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i8 | 0)) break L5;
    i1 = i1 + -4 | 0;
    i3 = i3 + -4 | 0;
    if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) {
     i1 = i4;
     continue L8;
    }
   }
  }
 } while (0);
 return ((i9 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 >> 2) | 0;
}

function __ZNK5Umbra15ShadowCullerExt21getReceiverMaskBufferERNS_18ReceiverMaskBufferE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 i3 = i2 + 1 & -2;
 _memcpy(i3 | 0, i1 + 240 | 0, 32768) | 0;
 i3 = i3 + 32768 + 3 & -4;
 i2 = i3;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAPF32[i2 + 320 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 324 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 328 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 436 >> 0] = 0;
 HEAP32[i2 + 336 >> 2] = 0;
 return 0;
}

function __ZNK14NavMeshManager19GetSourceTileDataAtEiii(i1, i8, i9, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 + 124 >> 2] | 0;
 i7 = i1 + 128 | 0;
 if ((i2 | 0) == (i7 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 L4 : while (1) {
  if ((HEAP32[i2 + 16 >> 2] | 0) == (i8 | 0)) {
   i3 = HEAP32[i2 + 20 >> 2] | 0;
   i1 = HEAP32[i3 + 56 >> 2] | 0;
   i3 = HEAP32[i3 + 52 >> 2] | 0;
   i6 = i3;
   if ((i1 | 0) != (i3 | 0)) {
    i4 = (i1 - i3 | 0) / 20 | 0;
    i3 = 0;
    do {
     i1 = i6 + (i3 * 20 | 0) | 0;
     i5 = HEAP32[i1 >> 2] | 0;
     if ((HEAP32[i5 + 8 >> 2] | 0) == (i9 | 0)) if ((HEAP32[i5 + 12 >> 2] | 0) == (i10 | 0)) {
      i2 = 14;
      break L4;
     }
     i3 = i3 + 1 | 0;
    } while (i3 >>> 0 < i4 >>> 0);
   }
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) {
   i1 = 0;
   i2 = 14;
   break;
  } else i2 = i1;
 }
 if ((i2 | 0) == 14) return i1 | 0;
 return 0;
}

function __ZNK10GameObject27FindConflictingComponentPtrEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = __Z25FindConflictingComponentsi(i1) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + 4 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i10 = i2 + 28 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i7 = i2 + 40 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) {
  i11 = 0;
  return i11 | 0;
 } else {
  i6 = i5;
  i2 = i1;
  i1 = i5;
 }
 L6 : while (1) {
  if ((i2 | 0) == (i3 | 0)) i5 = i1; else {
   do {
    i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(HEAP32[i2 >> 2] | 0) | 0;
    if (i1 | 0) if (((HEAP32[i6 >> 2] | 0) - (HEAP32[i1 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[i1 + 28 >> 2] | 0) >>> 0) break L6;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) != (HEAP32[i9 >> 2] | 0));
   i5 = HEAP32[i10 >> 2] | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i3 = i2;
  }
  i1 = i6 + 8 | 0;
  if ((i1 | 0) == (i5 + (i4 << 3) | 0)) {
   i1 = 0;
   i11 = 12;
   break;
  }
  i6 = i1;
  i2 = HEAP32[i8 >> 2] | 0;
  i1 = i5;
 }
 if ((i11 | 0) == 12) return i1 | 0;
 i11 = HEAP32[i6 + 4 >> 2] | 0;
 return i11 | 0;
}

function __ZN9dtNavMesh19getTileAndPolyByRefEyPP10dtMeshTilePPK6dtPoly(i1, i4, i2, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 if ((i4 | 0) == 0 & (i2 | 0) == 0) {
  i8 = -2147483648;
  return i8 | 0;
 }
 i5 = _bitshift64Lshr(i4 | 0, i2 | 0, 20) | 0;
 getTempRet0() | 0;
 i5 = i5 & 268435455;
 i6 = i4 & 65535;
 if (i5 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i8 = -2147483640;
  return i8 | 0;
 }
 i9 = _bitshift64Lshr(i4 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i2 = i1 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + (i5 * 56 | 0) | 0;
 if ((HEAP32[i1 + (i5 * 56 | 0) + 4 >> 2] | 0) != (i9 | 0)) {
  i9 = -2147483640;
  return i9 | 0;
 }
 i1 = HEAP32[i1 + (i5 * 56 | 0) + 8 >> 2] | 0;
 if (!i1) {
  i9 = -2147483640;
  return i9 | 0;
 }
 do if ((i4 & 983040 | 0) == 65536 & 0 == 0) {
  HEAP32[i7 >> 2] = 0;
  i1 = 0;
 } else if (i6 >>> 0 < (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
  HEAP32[i7 >> 2] = i3;
  i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 * 56 | 0) + 16 >> 2] | 0) + (i6 << 5) | 0;
  break;
 } else {
  i9 = -2147483640;
  return i9 | 0;
 } while (0);
 HEAP32[i8 >> 2] = i1;
 i9 = 1073741824;
 return i9 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxProfileZoneENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx2Sq17SceneQueryManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 80 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 }
 i2 = HEAP32[i3 + 60 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 52 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i3 + 44 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 48 | 0, i1);
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i3 + 32 >> 2] | 0) <= -1) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 36 | 0, i1);
 return;
}

function __ZN5physx2Sc8ShapeSim16onResetFilteringEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = i3 + 12 | 0;
 if (!(0 == 0 ? (HEAP32[i4 >> 2] & 1073741823 | 0) == 1073741823 : 0)) __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE(HEAP32[(HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0, 4, i3);
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!(HEAP8[i2 + 64 >> 0] & 5)) {
  STACKTOP = i5;
  return;
 }
 i6 = i3 + 8 | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i8 + 36 >> 2] | 0) + 1008 >> 2] | 0;
 __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E(i1, 0, i2, i8, 0);
 __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE(i7, i1, i3);
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP8[i1 + 50 >> 0] | 0;
 if ((i1 | 0) == 0 | i3 << 24 >> 24 != 4 & i3 << 24 >> 24 != 1) {
  STACKTOP = i5;
  return;
 }
 i6 = i4;
 i7 = HEAP32[i6 + 4 >> 2] & 1073741823;
 i8 = i1 + 132 | 0;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2] & 1073741823;
 HEAP32[i8 + 4 >> 2] = i7;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL19sendLostTouchReportEbj(i7, i6, i2) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i7 + 44 >> 2] | 0;
 i1 = (i1 >>> 11 & 256 | 16) & i1;
 i5 = i7 + 48 | 0;
 if (i1 | 0) __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i7, i1, (HEAP16[(HEAP32[i5 >> 2] | 0) + 14 >> 1] | 0) == 1 ? 8 : 0, 1, i2);
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 20 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i4 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i7 + 32 >> 2] | 0) | 0) + 76 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) != (i4 | 0)) return;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 20 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = i1 + 10 | 0;
 if (i6) if (!(HEAP16[i2 >> 1] & 8)) i1 = 17; else {
  __ZN5physx2Sc19ShapeInstancePairLL34setContactReportPostSolverVelocityERNS0_20ContactStreamManagerE(i7, i1);
  i1 = 17;
 } else i1 = 16;
 HEAP16[i2 >> 1] = HEAP16[i2 >> 1] | i1;
 return;
}

function __ZN24RingBufferMemoryFileDataD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = gb + 71708 + 8;
 i6 = i4 + 32 | 0;
 i5 = i4 + 8 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = 0;
 i6 = i4 + 52 | 0;
 i2 = i4 + 64 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0, i5);
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i4 + 76 | 0;
 i3 = i4 + 88 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i5);
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 + 92 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 80 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i4 + 68 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4 + 56 | 0);
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN20SoundChannelInstance11setPriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP32[i1 + 124 >> 2] = i2;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 30719 | (i7 & 1) << 11 & 65535;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel11setPriorityEi(i3, i2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 295;
 HEAP32[i5 + 8 >> 2] = gb + 866505;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN14PlayerSettings8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 268 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 __ZN26PlayerSettingsSplashScreen8TransferI17RemapPPtrTransferEEvRT_(i4 + 144 | 0, i1);
 i1 = i4 + 264 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i1 = i4 + 400 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 1;
 i1 = HEAP32[i4 + 604 >> 2] | 0;
 i4 = HEAP32[i4 + 616 >> 2] | 0;
 i3 = i1 + (i4 << 2) | 0;
 if (!i4) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = i2 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 + 1 | 0;
 i9 = i2 + 16 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i11 = i10 & 2147483647;
 do if (i8 >>> 0 > i11 >>> 0) {
  i1 = i10 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i11 >>> 0 < i1 >>> 0) if ((i10 | 0) > -1) {
   HEAP32[i9 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
   HEAP32[i9 >> 2] = i1;
   HEAP32[i2 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i8;
 i11 = (HEAP32[i2 >> 2] | 0) + (i7 << 3) | 0;
 HEAP32[i11 >> 2] = i3;
 HEAP32[i11 + 4 >> 2] = i4;
 HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + (i4 << 2) >> 2] = i5;
 return;
}

function __ZN11AudioSource11AssignPropsEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i5 = 0, i6 = 0;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i2);
 __ZN11AudioSource15SetDopplerLevelEf(i2, Math_fround(HEAPF32[i2 + 392 >> 2]));
 __ZN11AudioSource8SetPitchEf(i2, Math_fround(HEAPF32[i2 + 408 >> 2]));
 __ZN11AudioSource11SetPriorityEi(i2, HEAP32[i2 + 388 >> 2] | 0);
 __ZN11AudioSource14SetMinDistanceEf(i2, Math_fround(HEAPF32[i2 + 396 >> 2]));
 __ZN11AudioSource14SetMaxDistanceEf(i2, Math_fround(HEAPF32[i2 + 400 >> 2]));
 i3 = i2 + 404 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = f4 < Math_fround(-1.0);
 i6 = f4 > Math_fround(1.0);
 f1 = i6 ? Math_fround(1.0) : f4;
 f1 = i5 ? Math_fround(-1.0) : f1;
 if (f1 != f4) HEAPF32[i3 >> 2] = f1;
 __ZN11AudioSource16UpdateParametersEv(i2);
 __ZN11AudioSource9SetVolumeEf(i2, Math_fround(HEAPF32[i2 + 412 >> 2]));
 __ZN11AudioSource7SetLoopEb(i2, (HEAP8[i2 + 420 >> 0] | 0) != 0);
 __ZN11AudioSource7SetMuteEb(i2, (HEAP8[i2 + 421 >> 0] | 0) != 0);
 if (!((HEAP8[i2 + 422 >> 0] | 0) != 0 ^ (HEAP32[i2 + 540 >> 2] | 0) != 0)) return;
 __ZN11AudioSource16CreateFMODGroupsEv(i2);
 __ZN11AudioSource27ForceRolloffCurveEvaluationEv(i2);
 return;
}

function __Z16ClearBlendShapesR14BlendShapeData(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = i4 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i2 = i4 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i2 = HEAP32[i4 + 40 >> 2] | 0;
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = i1 + -16 | 0;
  HEAP32[i3 >> 2] = i5;
  __ZN14ConstantStringD2Ev(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 52 | 0;
 i2 = i4 + 68 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i5 = i4 + 64 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 56 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i4 + 64 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZNK21EnlightenSceneMapping27GetRadiosityHashForRendererEPK6Object(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i9 + 124 >> 2] | 0;
 i6 = HEAP32[i9 + 128 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i7 | 0)) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 + (i1 * 40 | 0) | 0) {
   i10 = (HEAP32[i9 + 20 >> 2] | 0) + ((HEAP32[i2 + (i1 * 40 | 0) + 20 >> 2] | 0) * 56 | 0) + 40 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   return;
  }
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 return;
}

function __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i3 = i5 + 8 | 0;
 i2 = i5;
 i1 = i5 + 20 | 0;
 switch (i6 | 0) {
 case 2:
  {
   HEAP32[i2 >> 2] = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
   __Z6FormatPKcz(i1, gb + 913702 | 0, i2);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   STACKTOP = i5;
   return;
  }
 case 4:
  {
   HEAP32[i3 >> 2] = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
   __Z6FormatPKcz(i1, gb + 913738 | 0, i3);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   STACKTOP = i5;
   return;
  }
 case 16:
  {
   HEAP32[i4 >> 2] = (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7;
   __Z6FormatPKcz(i1, gb + 913804 | 0, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
   STACKTOP = i5;
   return;
  }
 default:
  {
   STACKTOP = i5;
   return;
  }
 }
}

function __ZN5physx7Cooking18createTriangleMeshERKNS_18PxTriangleMeshDescERNS_26PxPhysicsInsertionCallbackE(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i5 | 0, 240, (i1 ? gb + 731983 | 0 : gb + 837976 | 0) | 0, gb + 726521 | 0, 172) | 0;
 __ZN5physx2Gu12TriangleMeshC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 110164 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110164 + 88;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(__ZN5physx7Cooking20loadTriangleMeshDescERKNS_18PxTriangleMeshDescERNS_19TriangleMeshBuilderE(i4, i2, i1) | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 0;
  return i6 | 0;
 }
 if (!(HEAP32[i4 + 32 >> 2] & 32)) __ZN5physx2Gu12TriangleMesh20checkMeshIndicesSizeEv(i1);
 if (mftCall_iii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0) | 0) {
  i6 = i1;
  return i6 | 0;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN5Unity9Component23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 589668 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   if (!(HEAP32[i5 >> 2] & 16384)) {
    i2 = i3 + 28 | 0;
    i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 369402 | 0, gb + 932544 | 0, i4, 1) | 0;
    if (i1 | 0) {
     if ((i1 | 0) > 0) __ZN12ImmediatePtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
      i1 = HEAP32[i4 >> 2] | 0;
      if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
     }
     __ZN14SafeBinaryRead11EndTransferEv(i5);
    }
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN4Mesh16SetChannelsDirtyEjb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i6 = i3 + 44 | 0;
 i7 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = (i7 & 255 | (i1 | 0) != 0) & 1 | i7 & -4 | (((i7 & 255) >>> 1 & 255 | i2 & 1) & 255) << 1 & 2;
 if ((i1 & 1 | 0) != 0 | i2) {
  __ZN17CollisionMeshData20VertexDataHasChangedEv(i3 + 204 | 0);
  i1 = i3 + 164 | 0;
  i2 = i3 + 180 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 168 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 176 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 30832;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i3;
 i2 = HEAP32[i3 + 236 >> 2] | 0;
 i3 = i3 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i5;
  return;
 }
 do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, gb + 1105196 | 0, i4);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i5;
 return;
}

function __ZN25ShadowMapJobHeaderScratchD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i6 >> 2] = gb + 35804 + 8;
 i2 = HEAP32[i6 + 168 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i6 + 172 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
  i5 = HEAP32[i6 + 180 >> 2] | 0;
  HEAP32[i1 >> 2] = 2;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 }
 HEAP32[i6 + 52 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i6 + 140 >> 2] | 0) > -1) {
  i5 = i6 + 124 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 128 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i6 + 104 | 0;
 if ((HEAP32[i6 + 120 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 108 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i6 + 84 | 0;
 if ((HEAP32[i6 + 100 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 88 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN22ParticleSystemRenderer5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 340 >> 1] = 0;
 HEAPF32[i1 + 360 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 356 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 344 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 364 >> 2] = Math_fround(0.0);
 HEAP16[i1 + 342 >> 1] = 0;
 HEAPF32[i1 + 368 >> 2] = Math_fround(1.0);
 i2 = i1 + 372 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP16[i2 + 16 >> 1] = 0;
 HEAP32[i1 + 392 >> 2] = 27;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP16[i1 + 400 >> 1] = 0;
 HEAPF32[i1 + 404 >> 2] = Math_fround(0.0);
 i2 = i1 + 552 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 568 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i1 = i1 + 580 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN17GeneralConnectionD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 65600 + 8;
 __ZN17GeneralConnection13DisconnectAllEv(i5);
 i1 = HEAP32[i5 + 124 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 128 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 112 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 116 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5 + 100 | 0, HEAP32[i5 + 104 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i5 + 88 | 0, HEAP32[i5 + 92 >> 2] | 0);
 __ZN6SocketD2Ev(i5 + 52 | 0);
 __ZN6SocketD2Ev(i5 + 16 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5 + 4 | 0);
 return;
}

function __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i1 = i6 + 101 | 0;
 i8 = i7 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i5 = i7 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 i1 = i6 + 96 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 if ((i4 + 1 | 0) >>> 0 > i2 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
  return;
 }
}

function __ZNSt3__26vectorINS_4pairI7Hash12813ProbeSetIndexEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 40 | 0) + 1 | 0;
 if (i3 >>> 0 > 107374182) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i10 + 8 | 0;
 i6 = ((HEAP32[i9 >> 2] | 0) - i1 | 0) / 40 | 0;
 i8 = i6 << 1;
 i3 = i6 >>> 0 < 53687091 ? (i8 >>> 0 < i3 >>> 0 ? i3 : i8) : 107374182;
 if (!i3) i4 = 0; else i4 = __Znwj(i3 * 40 | 0) | 0;
 i8 = i4 + (((i2 - i1 | 0) / 40 | 0) * 40 | 0) | 0;
 i6 = i4 + (i3 * 40 | 0) | 0;
 i5 = i8;
 i3 = i7;
 i4 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  i5 = i5 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i5 | 0) < (i4 | 0));
 i2 = i2 - i1 | 0;
 i3 = i8 + (((i2 | 0) / -40 | 0) * 40 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i8 + 40;
 HEAP32[i9 >> 2] = i6;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__225__num_get_signed_integralIlEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i1 = 0;
 } else {
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoll_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  L7 : do if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   do if ((i3 | 0) == 34) {
    HEAP32[i5 >> 2] = 4;
    if ((i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 0) {
     i1 = 2147483647;
     break L7;
    }
   } else {
    if ((i2 | 0) < -1 | (i2 | 0) == -1 & i1 >>> 0 < 2147483648) {
     HEAP32[i5 >> 2] = 4;
     break;
    }
    if ((i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 2147483647) {
     HEAP32[i5 >> 2] = 4;
     i1 = 2147483647;
     break L7;
    } else break L7;
   } while (0);
   i1 = -2147483648;
  } else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
  } while (0);
 }
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i5, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, HEAP32[i7 + 4 >> 2] | 0);
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + (i4 * 24 | 0) | 0;
 if (i4 | 0) {
  i4 = i8 + 20 | 0;
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = gb + 1034552;
   __ZN8GUIStyle8TransferI8JSONReadEEvRT_(i1, i8);
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 296 | 0;
  }
 }
 HEAP32[i6 >> 2] = i7;
 return;
}

function __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRFloatEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0, f14 = f0, i15 = 0;
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(Math_fround(1.0) - f5);
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i15 = i2 >>> 16;
  f10 = Math_fround(Math_fround((i2 & 65535) >>> 0) * Math_fround(.0000152587891));
  f12 = Math_fround(Math_fround(1.0) - f10);
  f14 = Math_fround(HEAPF32[i7 + (i15 << 2) >> 2]);
  i9 = i15 + 1 | 0;
  f13 = Math_fround(HEAPF32[i7 + (i9 << 2) >> 2]);
  f11 = Math_fround(HEAPF32[i8 + (i15 << 2) >> 2]);
  HEAPF32[i3 >> 2] = Math_fround(Math_fround(f6 * Math_fround(Math_fround(f12 * f14) + Math_fround(f10 * f13))) + Math_fround(f5 * Math_fround(Math_fround(f12 * f11) + Math_fround(f10 * Math_fround(HEAPF32[i8 + (i9 << 2) >> 2])))));
  if (!i1) break; else {
   i3 = i3 + 4 | 0;
   i2 = i4 + i2 | 0;
  }
 }
 return;
}

function __ZN20FileSystemEnumerator5MountERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP17FileSystemHandler(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) i1 = HEAP32[(HEAP32[gb + 1179016 >> 2] | 0) + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i3 = i5 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i2) | 0;
 i2 = i4 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN20FileSystemEnumerator10MountPointENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i5);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i5);
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return;
 }
}

function __ZN17Physics2DSettings17SetBaumgarteScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 72 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151900 >> 2] = f3;
 HEAPF32[gb + 151904 >> 2] = f2;
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN14SpriteRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 3, i5, i3);
 HEAP32[i1 >> 2] = gb + 58936 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 58936 + 184;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 352 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 356 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 364 >> 2] = 0;
 HEAP32[i1 + 368 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = 0;
 HEAP32[i1 + 376 >> 2] = i1;
 i3 = i1 + 268 | 0;
 i2 = HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16;
 HEAP8[i1 + 360 >> 0] = 0;
 HEAP8[i1 + 361 >> 0] = 0;
 i2 = i2 & 16531007;
 HEAP16[i3 >> 1] = i2;
 HEAP8[i3 + 2 >> 0] = i2 >>> 16;
 STACKTOP = i4;
 return;
}

function __ZN14ParticleSystem13SetStartColorE10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 f3 = i4 ? Math_fround(0.0) : f3;
 i4 = f3 > Math_fround(1.0);
 HEAP8[i1 + 684 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f3) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = f3 < Math_fround(0.0);
 f3 = i4 ? Math_fround(0.0) : f3;
 i4 = f3 > Math_fround(1.0);
 HEAP8[i1 + 685 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f3) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i4 = f3 < Math_fround(0.0);
 f3 = i4 ? Math_fround(0.0) : f3;
 i4 = f3 > Math_fround(1.0);
 HEAP8[i1 + 686 >> 0] = ~~Math_fround(Math_fround((i4 ? Math_fround(1.0) : f3) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = f3 < Math_fround(0.0);
 f3 = i2 ? Math_fround(0.0) : f3;
 i2 = f3 > Math_fround(1.0);
 HEAP8[i1 + 687 >> 0] = ~~Math_fround(Math_fround((i2 ? Math_fround(1.0) : f3) * Math_fround(255.0)) + Math_fround(.5)) >>> 0;
 return;
}

function __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsStringERK8UnityStrS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i8 = i6 << 24 >> 24 < 0;
 i7 = i8 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i8 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i7, i6);
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = i7 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, i2);
 __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i4, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags(i8, i5, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i8 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) {
  __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, 0);
  return;
 }
 if ((i1 & 255 | 0) != 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1034256 | 0, 0, gb + 1034278 | 0, 286, 1, 0, 0, 0);
  return;
 }
 __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j(i5, HEAP32[i7 + 4 >> 2] | 0);
 i4 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + (i4 * 24 | 0) | 0;
 if (i4 | 0) {
  i4 = i8 + 20 | 0;
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = gb + 1033990;
   __ZN8Gradient8TransferI8JSONReadEEvRT_(i1, i8);
   i2 = i2 + 24 | 0;
   if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 72 | 0;
  }
 }
 HEAP32[i6 >> 2] = i7;
 return;
}

function __ZN4FMOD6SoundI9getLengthEPjj(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i2 = i7;
 if (!i3) {
  HEAP32[i2 >> 2] = 37;
  HEAP32[i2 + 4 >> 2] = gb + 868952;
  _printf(gb + 853277 | 0, i2) | 0;
  i6 = 37;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = _JS_Sound_GetLength(HEAP32[i1 + 320 >> 2] | 0) | 0;
 switch (i4 | 0) {
 case 2:
  {
   HEAP32[i3 >> 2] = i1;
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 1:
  {
   HEAP32[i3 >> 2] = ~~(+(i1 >>> 0) * 1.0e3 / 44100.0) >>> 0;
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 4:
  {
   HEAP32[i3 >> 2] = i1 << 2;
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 case 8:
  {
   HEAP32[i3 >> 2] = i1 << 2;
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 default:
  {
   HEAP32[i5 >> 2] = gb + 868952;
   HEAP32[i5 + 4 >> 2] = 1275;
   _printf(gb + 854600 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 37;
   HEAP32[i6 + 4 >> 2] = gb + 868952;
   _printf(gb + 853277 | 0, i6) | 0;
   i6 = 37;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN27ColorModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 152 >> 0] = ~~f4;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 153 >> 0] = ~~f4;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 154 >> 0] = ~~f4;
   return;
  }
 case 3:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 155 >> 0] = ~~f4;
   return;
  }
 case 4:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 156 >> 0] = ~~f4;
   return;
  }
 case 5:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 157 >> 0] = ~~f4;
   return;
  }
 case 6:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 158 >> 0] = ~~f4;
   return;
  }
 case 7:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 159 >> 0] = ~~f4;
   return;
  }
 default:
  return;
 }
}

function __ZN20SoundChannelInstance6setPanEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAPF32[i1 + 112 >> 2] = f2;
 HEAP16[i8 >> 1] = (((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 32511 | (i7 & 1) << 8 & 65535;
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel6setPanEf(i3, f2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 286;
 HEAP32[i5 + 8 >> 2] = gb + 866276;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN11KeyframeTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZL40FlattenSkeletonTransformHierarchyRecurseRK13dynamic_arrayIPK9TransformLj4EERS0_S6_(i8, i9, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i1 + 92 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 i6 = i1 + 80 | 0;
 i7 = i8 + 12 | 0;
 i5 = 0;
 i1 = i2;
 L4 : while (1) {
  while (1) {
   i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i12 = HEAP32[i7 >> 2] | 0;
   i4 = i2 + (i12 << 2) | 0;
   L8 : do if (!i12) i11 = 7; else do {
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
     i11 = 7;
     break L8;
    }
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) != (i4 | 0)); while (0);
   if ((i11 | 0) == 7) {
    i11 = 0;
    if ((i2 | 0) != (i4 | 0)) break;
   }
   __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i3, i9, 1) | 0;
   __ZL40FlattenSkeletonTransformHierarchyRecurseRK13dynamic_arrayIPK9TransformLj4EERS0_S6_(i8, i9, i3);
   i1 = HEAP32[i10 >> 2] | 0;
   if ((i1 | 0) <= (i5 | 0)) {
    i11 = 10;
    break L4;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i1 | 0) <= (i5 | 0)) {
   i11 = 10;
   break;
  }
 }
 if ((i11 | 0) == 10) return;
}

function __ZNK9ShaderLab7Program40EnsureCompiledAndMarkUnsupportedIfFailedEPKNS_10SubProgramERK16ShaderKeywordSetPS4_R19ShaderSnippetResult(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0;
 i2 = i4 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN9ShaderLab10SubProgram7CompileEv(i4);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i8 = 3;
 } else i8 = 3;
 if ((i8 | 0) == 3) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) return;
 if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 4) return;
 __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i3, i5);
 if (i6 | 0) {
  i8 = i4 + 16 | 0;
  __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet(i3, i8);
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i8 + 16 >> 2];
  HEAP32[i6 + 20 >> 2] = HEAP32[i8 + 20 >> 2];
  HEAP32[i6 + 24 >> 2] = HEAP32[i8 + 24 >> 2];
  HEAP32[i6 + 28 >> 2] = HEAP32[i8 + 28 >> 2];
 }
 HEAP32[i7 >> 2] = 2;
 return;
}

function __ZN8VRDevice20CreateVRSplashScreenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 32 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6;
 i5 = i1 + 284 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i1 + 364 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63816 | 0, 16, gb + 1044184 | 0, 1131) | 0;
  HEAPF32[i3 >> 2] = Math_fround(.301960796);
  HEAPF32[i3 + 4 >> 2] = Math_fround(.301960796);
  HEAPF32[i3 + 8 >> 2] = Math_fround(.301960796);
  HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  __ZN14VRSplashScreenC2Ebf10ColorRGBAfif8Vector3f(i1, 1, Math_fround(4.5), i2, 1, Math_fround(1.0), i4);
  HEAP32[i5 >> 2] = i1;
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = mftCall_i(i1 | 0) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sn7XmlNodeENS_7profile26WrapperReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx16PxVehicleNoDrive6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 40 | 0;
 i10 = HEAP32[i6 >> 2] | 0;
 i11 = (i10 + 3 | 0) >>> 2;
 i7 = i11 << 4;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, (__ZN5physx15PxVehicleWheels15computeByteSizeEj(i11) | 0) + 144 + (i11 * 48 | 0) | 0, gb + 827083 | 0, 47) | 0;
 __ZN5physx16PxVehicleNoDriveC2Ev(i5);
 i10 = __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i5, i5 + 144 | 0, i11, i10, 1) | 0;
 HEAP32[i5 + 128 >> 2] = i10;
 i9 = i5 + 132 | 0;
 HEAP32[i9 >> 2] = i10 + i7;
 i8 = i5 + 136 | 0;
 HEAP32[i8 >> 2] = i10 + (i11 << 5);
 _memset(i10 | 0, 0, i7 | 0) | 0;
 _memset(HEAP32[i9 >> 2] | 0, 0, i7 | 0) | 0;
 _memset(HEAP32[i8 >> 2] | 0, 0, i7 | 0) | 0;
 HEAP8[i5 + 113 >> 0] = 3;
 __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i5, i1, i2, i3, 0, HEAP32[i6 >> 2] | 0);
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN5IMGUI9GUIWindowC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i1 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 i4 = gb + 63672 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP8[i1 + 80 >> 0] = 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP8[i1 + 100 >> 0] = 0;
 i3 = i1 + 104 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP8[i1 + 118 >> 0] = 0;
 HEAP8[i1 + 117 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN38StateMachineBehaviourVectorDescription8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 902597 | 0, HEAP32[gb + 37052 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS2_EENS4_9allocatorINS4_4pairIS2_S3_EEEEEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 902627 | 0, HEAP32[gb + 37316 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN24MeshIntermediateRendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 33604 + 8;
 HEAP32[i3 + 264 >> 2] = gb + 33604 + 84;
 i1 = i3 + 268 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 272 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = gb + 33532 + 8;
 i1 = i3 + 236 | 0;
 i2 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i3 + 256 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN17BillboardRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 8, i5, i3);
 i3 = i1 + 340 | 0;
 HEAP32[i1 >> 2] = gb + 56316 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 56316 + 192;
 HEAP32[i3 >> 2] = gb + 56316 + 252;
 HEAP32[i1 + 344 >> 2] = 0;
 HEAP32[i1 + 348 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = i3;
 HEAP32[i1 + 360 >> 2] = 0;
 HEAPF32[i1 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 368 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 372 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 376 >> 2] = Math_fround(0.0);
 i3 = i1 + 268 | 0;
 i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16531007;
 HEAP16[i3 >> 1] = i2;
 HEAP8[i3 + 2 >> 0] = i2 >>> 16;
 STACKTOP = i4;
 return;
}

function __ZN16ReflectionProbes16RenderProbeFacesEP15ReflectionProbei(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if ((HEAP32[(__Z21GetManagerFromContexti(25) | 0) + 376 >> 2] | 0) != 1) {
  i2 = i5 + 168 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i5) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  __ZN13ProbeRenderer6RenderEP15ReflectionProbeib(i1, i5, i6, (HEAP8[i5 + 143 >> 0] | 0) != 0);
  return;
 }
 i2 = i4 + 12 | 0;
 i3 = i4 + 24 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  do {
   __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture(i4, HEAP32[i1 >> 2] | 0, 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 i2 = i5 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i5) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 __ZN13ProbeRenderer6RenderEP15ReflectionProbeib(i1, i5, i6, (HEAP8[i5 + 143 >> 0] | 0) != 0);
 __ZN16ReflectionProbes16UpdateSampleDataEv(i4);
 return;
}

function __ZN13PhysicsModule24CreateNxMeshFromNxStreamEbPKvj(i1, i7, i2, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = gb + 113908 + 8;
 HEAP32[i9 >> 2] = gb + 113908 + 32;
 if (!i2) {
  i3 = 1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 63552 | 0, 0, gb + 738098 | 0, 20) | 0;
 } else {
  i3 = 0;
  i1 = i2;
 }
 i6 = i8 + 24 | 0;
 HEAP32[i6 >> 2] = i1;
 i5 = i8 + 8 | 0;
 HEAP8[i5 >> 0] = i3;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = i4;
 i1 = HEAP32[gb + 1457408 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i7) i1 = mftCall_iii(HEAP32[i2 + 64 >> 2] | 0, i1 | 0, i8 + 4 | 0) | 0; else i1 = mftCall_iii(HEAP32[i2 + 36 >> 2] | 0, i1 | 0, i8 + 4 | 0) | 0;
 HEAP32[i8 >> 2] = gb + 113908 + 8;
 HEAP32[i9 >> 2] = gb + 113908 + 32;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, gb + 63552 | 0);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcS3_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = _strlen(i2) | 0;
 i3 = (_strlen(i4) | 0) + i3 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i3 = i6 + 40 | 0;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 5;
 __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc(i6 + 16 | 0, i4) | 0;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i10 = 1;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN10MeshFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 1046285 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 32 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1048075 | 0, gb + 1048082 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN9BlobWrite8TransferIN4math5LimitEEEvRT_PKc17TransferMetaFlags(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = (HEAP8[i3 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i3, 24, i4, 4);
 i2 = i3 + 48 | 0;
 i6 = i3 + 44 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i5 = i3 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i8 >>> 8 << 2) >> 2] | 0;
 i8 = i8 & 255;
 i7 = i9 + (i8 << 4) + 4 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i8 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i3, i4, gb + 906590 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i3, i4 + 12 | 0, gb + 906596 | 0, 0);
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i9 + -1;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - (HEAP32[i5 >> 2] | 0) | 0;
 if ((1 - i9 - (HEAP32[i6 >> 2] | 0) + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN26AnimatorControllerPlayable14GetLayerWeightEi(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i5 = i6 + 4 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) {
  if ((i4 | 0) >= 0) {
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) i1 = HEAP32[HEAP32[i2 + 92 >> 2] >> 2] | 0; else i1 = 0;
   if ((i1 | 0) > (i4 | 0)) {
    i5 = (HEAP32[i2 + 100 >> 2] | 0) + 12 | 0;
    f7 = Math_fround(HEAPF32[i5 + (HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2]);
    STACKTOP = i6;
    return Math_fround(f7);
   }
  }
  HEAP32[i3 >> 2] = i4;
  __Z6FormatPKcz(i5, gb + 902210 | 0, i3);
  i1 = HEAP32[i2 + 84 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 }
 f7 = Math_fround((i4 | 0) == 0 & 1);
 STACKTOP = i6;
 return Math_fround(f7);
}

function __ZN23AnimationOffsetPlayable11GetRotationEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0;
 f10 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f12 = Math_fround(f10 * f10);
 f9 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f2 = Math_fround(f9 * f9);
 f8 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f7 = Math_fround(f8 * f8);
 f11 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f7 = Math_fround(Math_fround(f12 + f2) + Math_fround(f7 + Math_fround(f11 * f11)));
 f2 = Math_fround(Math_sqrt(Math_fround(f7)));
 f10 = Math_fround(f10 / f2);
 f9 = Math_fround(f9 / f2);
 f8 = Math_fround(f8 / f2);
 f2 = Math_fround(f11 / f2);
 i1 = (HEAPF32[tempDoublePtr >> 2] = f10, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = (HEAPF32[tempDoublePtr >> 2] = f9, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f8, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = f7 > Math_fround(1.0e-30);
 i13 = i5 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 1065353216;
 HEAP32[i6 >> 2] = i5 ? i1 : 0;
 HEAP32[i6 + 4 >> 2] = i5 ? i3 : 0;
 HEAP32[i6 + 8 >> 2] = i5 ? i4 : 0;
 HEAP32[i6 + 12 >> 2] = i13;
 return;
}

function __ZN20TextRenderingPrivate15ReadOSFontFilesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i4);
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = i3;
 if ((i2 | 0) != (i3 | 0)) {
  i3 = 0;
  do {
   __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + (i3 * 12 | 0) | 0);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i7 = HEAP32[i4 >> 2] | 0;
   i1 = i7;
  } while (i3 >>> 0 < ((i2 - i7 | 0) / 12 | 0) >>> 0);
 }
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i7 = i2 + -12 | 0;
   HEAP32[i5 >> 2] = i7;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN20SoundChannelInstance7setMuteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 i7 = (i3 | 0) == 0;
 i8 = i1 + 148 | 0;
 i9 = HEAP16[i8 >> 1] | 0;
 HEAP8[i1 + 144 >> 0] = i2 & 1;
 HEAP16[i8 >> 1] = (i7 & 1) << 13 & 65535 | ((((i9 & 65535) >>> 15 & 65535 | i7 & 1) & 65535) << 15 & 65535 | i9 & 24575);
 if (i7) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i1 = __ZN4FMOD7Channel7setMuteEb(i3, i2) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i6;
  return i9 | 0;
 }
 i9 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 277;
 HEAP32[i5 + 8 >> 2] = gb + 865705;
 HEAP32[i5 + 12 >> 2] = i9;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i9 = i1;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN17Physics2DSettings27SetMinPenetrationForPenaltyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 f2 = i3 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 68 >> 2] = f2;
 HEAPF32[gb + 151644 >> 2] = f2;
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN17Physics2DSettings14SetTimeToSleepEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 80 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151900 >> 2] = f3;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAPF32[gb + 151912 >> 2] = f2;
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelperD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149440 + 8;
 HEAP32[i1 + 84 >> 2] = gb + 149600 + 8;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 88 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 96 >> 2] | 0);
 }
 HEAP32[i1 + 60 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 64 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 72 >> 2] | 0);
 }
 HEAP32[i1 + 36 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 40 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 48 >> 2] | 0);
 }
 HEAP32[i1 + 12 >> 2] = gb + 149616 + 8;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 24 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine9Animation38InitializeGenericAnimationBindingCacheEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __ZN7mecanim13crc32_table_tILj79764919EE10init_tableEv();
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(84, gb + 63320 | 0, 16, gb + 904444 | 0, gb + 1576256 | 0, gb + 896915 | 0, 463) | 0;
 __ZN11UnityEngine9Animation28GenericAnimationBindingCacheC2Ev(i3);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1466544 >> 2] = i3;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 1540 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 772 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 772 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 772 + (i1 * 12 | 0) >> 2] = fb + 297;
 STACKTOP = i5;
 return;
}

function __Z30Material_CUSTOM_SetOverrideTagP12Il2CppObjectP12Il2CppStringS2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 28 | 0;
 i5 = i8 + 24 | 0;
 i6 = i8 + 12 | 0;
 i7 = i8;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i8 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i4);
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i5);
  __ZN8Material14SetOverrideTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i1, i6, i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 }
}

function __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj(i7, i8, i9, i1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i12 + 8 | 0;
 i11 = i12;
 i4 = ~i2 & i1 & HEAP32[(__Z15GetGraphicsCapsv() | 0) + 96 >> 2];
 HEAP16[i10 >> 1] = 0;
 if (!i4) {
  STACKTOP = i12;
  return;
 }
 i5 = i8 + 4 | 0;
 i2 = 0;
 i3 = 1;
 do {
  if (i3 & i4 | 0) {
   switch (i2 | 0) {
   case 7:
   case 1:
    {
     i1 = 1;
     break;
    }
   default:
    i1 = 0;
   }
   i6 = i10 + i1 | 0;
   if (!(HEAP8[i6 >> 0] | 0)) {
    i14 = HEAP32[i5 >> 2] | 0;
    HEAP32[i5 >> 2] = i14 + 1;
    HEAP8[i6 >> 0] = i14;
    __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej(i11, i7, i1, i9);
    i13 = i11;
    i1 = HEAP32[i13 + 4 >> 2] | 0;
    i6 = i8 + 8 + ((i14 & 255) << 3) | 0;
    HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
    HEAP32[i6 + 4 >> 2] = i1;
   }
  }
  i2 = i2 + 1 | 0;
  i3 = i3 << 1;
 } while (i3 >>> 0 <= i4 >>> 0 & (i2 | 0) < 8);
 STACKTOP = i12;
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i6 = (HEAP8[i2 >> 0] | 0) == 0 ? i6 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i6;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i5 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function _memchr(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 & 255;
 i3 = (i1 | 0) != 0;
 L1 : do if (i3 & (i2 & 3 | 0) != 0) {
  i4 = i5 & 255;
  while (1) {
   if ((HEAP8[i2 >> 0] | 0) == i4 << 24 >> 24) {
    i7 = 6;
    break L1;
   }
   i2 = i2 + 1 | 0;
   i1 = i1 + -1 | 0;
   i3 = (i1 | 0) != 0;
   if (!(i3 & (i2 & 3 | 0) != 0)) {
    i7 = 5;
    break;
   }
  }
 } else i7 = 5; while (0);
 if ((i7 | 0) == 5) if (i3) i7 = 6; else i1 = 0;
 L8 : do if ((i7 | 0) == 6) {
  i4 = i5 & 255;
  if ((HEAP8[i2 >> 0] | 0) != i4 << 24 >> 24) {
   i3 = Math_imul(i6, 16843009) | 0;
   L11 : do if (i1 >>> 0 > 3) while (1) {
    i6 = HEAP32[i2 >> 2] ^ i3;
    if ((i6 & -2139062144 ^ -2139062144) & i6 + -16843009 | 0) break;
    i2 = i2 + 4 | 0;
    i1 = i1 + -4 | 0;
    if (i1 >>> 0 <= 3) {
     i7 = 11;
     break L11;
    }
   } else i7 = 11; while (0);
   if ((i7 | 0) == 11) if (!i1) {
    i1 = 0;
    break;
   }
   while (1) {
    if ((HEAP8[i2 >> 0] | 0) == i4 << 24 >> 24) break L8;
    i2 = i2 + 1 | 0;
    i1 = i1 + -1 | 0;
    if (!i1) {
     i1 = 0;
     break;
    }
   }
  }
 } while (0);
 return (i1 | 0 ? i2 : 0) | 0;
}

function __ZNK5Umbra9Matrix4x310isIdentityEv(i1) {
 i1 = i1 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) == Math_fround(1.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 16 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 20 >> 2]) == Math_fround(1.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 24 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 28 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 32 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 36 >> 2]) == Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(Math_fround(HEAPF32[i1 + 40 >> 2]) == Math_fround(1.0))) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = Math_fround(HEAPF32[i1 + 44 >> 2]) == Math_fround(0.0);
 return i1 | 0;
}

function __ZNK14TerrainManager23CollectLODGroupManagersEPK6CameraPP15LODGroupManagerj(i2, i9, i10, i1) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i7 = i2 + 4 | 0;
 i2 = i1;
 if ((i2 | 0) == (i7 | 0)) return;
 i8 = i9 + 880 | 0;
 do {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  L6 : do if (HEAP32[i1 + 204 >> 2] & 2 | 0) if (HEAP8[i1 + 90 >> 0] | 0) if (+Math_fround(HEAPF32[i1 + 64 >> 2]) > .001) if (1 << HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i8 >> 2] | 0) {
   i5 = HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
   i6 = HEAP32[i1 + 240 >> 2] | 0;
   if (i6 | 0) {
    i4 = HEAP32[i1 + 228 >> 2] | 0;
    i1 = 0;
    while (1) {
     i3 = i4 + (i1 * 20 | 0) | 0;
     if ((HEAP32[i3 >> 2] | 0) == (i9 | 0)) break;
     i1 = i1 + 1 | 0;
     if (i1 >>> 0 >= i6 >>> 0) break L6;
    }
    HEAP32[i4 + (i1 * 20 | 0) + 16 >> 2] = i5;
    if (i3 | 0) {
     i6 = (HEAP32[i4 + (i1 * 20 | 0) + 8 >> 2] | 0) + 304 | 0;
     HEAP32[i10 + (HEAP32[i6 >> 2] << 2) >> 2] = i6;
    }
   }
  } while (0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 return;
}

function __ZN5physx7profile19MemoryEventRecorder12onAllocationEjPKcS3_iPv(i4, i8, i9, i6, i7, i5) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10;
 i3 = i10 + 8 | 0;
 i2 = i5;
 if (!i5) {
  STACKTOP = i10;
  return;
 }
 i11 = i1;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = 0;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb(i4 + 8 | 0, i1, i3) | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i11 = i1;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = 0;
  i11 = i1 + 8 | 0;
  HEAP32[i11 >> 2] = i2;
  HEAP32[i11 + 4 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = i8;
  HEAP32[i1 + 20 >> 2] = i9;
  HEAP32[i1 + 24 >> 2] = i6;
  HEAP32[i1 + 28 >> 2] = i7;
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i10;
  return;
 }
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i8 | 0, i9 | 0, i6 | 0, i7 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN4crnd13prefix_coding14decoder_tablesaSERKS1_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 if ((i6 | 0) == (i2 | 0)) return i6 | 0;
 __ZN4crnd13prefix_coding14decoder_tables5clearEv(i6);
 _memcpy(i6 | 0, i2 | 0, 180) | 0;
 i4 = i2 + 168 | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i5 = i6 + 164 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = i1 | 0 ? i1 : 1;
  i3 = __ZN4crnd11crnd_mallocEjPj((i1 << 2) + 8 | 0, 0) | 0;
  if (!i3) {
   HEAP32[i6 + 168 >> 2] = 0;
   break;
  } else {
   i7 = i3 + 8 | 0;
   HEAP32[i3 + 4 >> 2] = i1;
   HEAP32[i3 >> 2] = ~i1;
   HEAP32[i6 + 168 >> 2] = i7;
   _memcpy(i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   break;
  }
 } while (0);
 i2 = i2 + 176 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return i6 | 0;
 i3 = i6 + 172 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = i1 | 0 ? i1 : 1;
 i4 = __ZN4crnd11crnd_mallocEjPj((i1 << 1) + 8 | 0, 0) | 0;
 if (!i4) {
  HEAP32[i6 + 176 >> 2] = 0;
  return i6 | 0;
 } else {
  i7 = i4 + 8 | 0;
  HEAP32[i4 + 4 >> 2] = i1;
  HEAP32[i4 >> 2] = ~i1;
  HEAP32[i6 + 176 >> 2] = i7;
  _memcpy(i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN17Physics2DSettings22SetMaxLinearCorrectionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 f2 = i3 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 52 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAPF32[gb + 151880 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN14ParticleSystem24UpdateModulesIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjfPj(i1, i2, i3, i4, i5, f6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8;
 i9 = i8 + 8 | 0;
 HEAPF32[i10 >> 2] = f6;
 i11 = HEAP32[i4 + 12 >> 2] | 0;
 HEAPF32[i9 + 12 >> 2] = f6;
 HEAPF32[i9 + 8 >> 2] = f6;
 HEAPF32[i9 + 4 >> 2] = f6;
 HEAPF32[i9 >> 2] = f6;
 __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E(i1, i2, i3, i4, i5, i11, i9);
 __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj(i1, i2, i3, i4, i5, i10, i7);
 HEAPF32[i9 >> 2] = f6;
 __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf(i1, i2, i3, i4, i5, i9);
 STACKTOP = i8;
 return;
}

function __Z42Physics_CUSTOM_INTERNAL_CALL_OverlapSphereRK8Vector3ffi23QueryTriggerInteraction(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i3 = __ZN14PhysicsManager13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i1, f2, i3, i4) | 0;
 i5 = __Z19GetScriptingManagerv() | 0;
 i4 = i3 + 4 | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i5 + 168 >> 2] | 0) + (HEAP32[gb + 32548 + 24 >> 2] << 2) >> 2] | 0, 4, (HEAP32[i4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) >> 2) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i3 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (HEAP32[i4 >> 2] | 0));
 }
 if ((i1 | 0) >= (i6 | 0)) return i5 | 0;
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i5, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return i5 | 0;
}

function __ZNK5Umbra9Matrix3x3eqERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 4 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 8 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 12 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 16 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 20 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 24 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 28 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 32 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1;
 return i2 | 0;
}

function __ZNK11AudioSource31GetCustomReverbZoneMixCurveCopyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(88) | 0;
 HEAPF32[i3 + 4 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(inf);
 HEAP32[i3 + 28 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 80 >> 2] = 2;
 HEAP32[i3 + 76 >> 2] = 2;
 HEAP32[i3 + 84 >> 2] = 4;
 i4 = HEAP32[i1 + 180 >> 2] | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i3, i4, i4 + (HEAP32[i1 + 192 >> 2] << 4) | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(92, i1, 16, gb + 1048932 | 0, 0, gb + 946664 | 0, 26) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 185632 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP8[i4 + 84 >> 0] = 1;
 HEAP32[i4 + 80 >> 2] = -1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN17PersistentManager63RegisterAndAwakeThreadedObjectAndUnlockIntegrationMutexInternalERK17ThreadedAwakeData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 8 | 0;
 __ZN6Object18RegisterInstanceIDEPS_(HEAP32[i4 >> 2] | 0);
 i4 = HEAP32[i4 >> 2] | 0;
 if ((HEAP16[gb + 1165848 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165848 | 0, i1);
  i1 = gb + 1165848 | 0;
 } else i1 = 0;
 i2 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
 if (!i2) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 3); else {
  __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 3);
  __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i2);
 }
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN13TextRendering4Font8TransferI17RemapPPtrTransferEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i5, i6);
 i2 = i5 + 40 | 0;
 i3 = i6 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 i7 = i6 + 40 | 0;
 if (HEAP8[i7 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 i2 = i5 + 36 | 0;
 HEAP32[i2 >> 2] = ~~Math_fround(HEAP32[i2 >> 2] | 0);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i6, 1);
 i2 = i5 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i6);
  i7 = i5 + 48 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  __ZN20TextRenderingPrivate8FontImpl8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
  return;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i6);
 i7 = i5 + 48 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 __ZN20TextRenderingPrivate8FontImpl8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
 return;
}

function __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __Z38Renderer_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i6 = i7;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i2 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
 __ZN8Renderer16SetMaterialCountEi(i1, (i2 | 0) > 1 ? i2 : 1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP32[i6 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i5) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i1, i3, 0);
  STACKTOP = i7;
  return;
 }
}

function _PxCreateControllerManager(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx6shdfnd10Foundation11incRefCountEv();
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i3 | 0, i2 | 0, 136, (i4 ? gb + 738174 | 0 : gb + 837976 | 0) | 0, gb + 657349 | 0, 669) | 0;
 HEAP32[i4 >> 2] = gb + 86304 + 8;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i4 + 100 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.75);
 HEAP32[i4 + 104 >> 2] = -1;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i4 + 76 | 0, 64);
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAPF32[i4 + 128 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 132 >> 0] = 0;
 HEAP8[i4 + 133 >> 0] = 1;
 HEAP8[i4 + 134 >> 0] = 1;
 HEAP8[i4 + 135 >> 0] = 0;
 return i4 | 0;
}

function _jpeg_write_raw_data(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i1 | 0) != 102) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i4 = i5 + 208 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 123;
  mftCall_vii(HEAP32[i7 + 4 >> 2] | 0, i5 | 0, -1);
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 if (i3 | 0) {
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = i2;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i5 | 0);
 }
 i1 = HEAP32[i5 + 316 >> 2] | 0;
 if (HEAP8[i1 + 12 >> 0] | 0) mftCall_vi(HEAP32[i1 + 4 >> 2] | 0, i5 | 0);
 i1 = HEAP32[i5 + 220 >> 2] << 3;
 if (i1 >>> 0 > i7 >>> 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 23;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 if (!((mftCall_iii(HEAP32[(HEAP32[i5 + 328 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i6 | 0) | 0) << 24 >> 24)) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
 i7 = i1;
 return i7 | 0;
}

function _jpeg_start_output(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 20 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 switch (i2 | 0) {
 case 204:
 case 207:
  break;
 default:
  {
   i5 = HEAP32[i3 >> 2] | 0;
   HEAP32[i5 + 20 >> 2] = 20;
   HEAP32[i5 + 24 >> 2] = i2;
   mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
  }
 }
 i1 = (i1 | 0) < 1 ? 1 : i1;
 if (HEAP8[(HEAP32[i3 + 400 >> 2] | 0) + 17 >> 0] | 0) {
  i5 = HEAP32[i3 + 124 >> 2] | 0;
  i1 = (i1 | 0) > (i5 | 0) ? i5 : i1;
 }
 HEAP32[i3 + 132 >> 2] = i1;
 i1 = i3 + 384 | 0;
 if ((HEAP32[i4 >> 2] | 0) != 204) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i3 | 0);
  HEAP32[i3 + 120 >> 2] = 0;
  HEAP32[i4 >> 2] = 204;
 }
 if (!(HEAP8[(HEAP32[i1 >> 2] | 0) + 8 >> 0] | 0)) {
  i5 = i3 + 65 | 0;
  i5 = HEAP8[i5 >> 0] | 0;
  i5 = i5 << 24 >> 24 != 0;
  i5 = i5 ? 206 : 205;
  HEAP32[i4 >> 2] = i5;
  return 1;
 }
 do {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 } while ((HEAP8[(HEAP32[i1 >> 2] | 0) + 8 >> 0] | 0) != 0);
 i5 = i3 + 65 | 0;
 i5 = HEAP8[i5 >> 0] | 0;
 i5 = i5 << 24 >> 24 != 0;
 i5 = i5 ? 206 : 205;
 HEAP32[i4 >> 2] = i5;
 return 1;
}

function __ZN8Material25DidModifyShaderKeywordSetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i5 = i1 + 100 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + 124 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i2, i3);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i3, i1 + 80 | 0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i7 = i2 + -12 | 0;
    HEAP32[i4 >> 2] = i7;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i7 = i1 + 164 | 0;
 HEAP8[i7 >> 0] = HEAP8[i7 >> 0] | 2;
 STACKTOP = i6;
 return;
}

function __ZN7mecanim13CopyValueMaskEPNS_14ValueArrayMaskEPKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 _memcpy(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, ((i6 | 0) == 0 ? 0 : i6 + i3 | 0) | 0, HEAP32[i1 >> 2] | 0) | 0;
 i3 = i1 + 12 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memcpy(((i6 | 0) == 0 ? 0 : i6 + i3 | 0) | 0, ((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = i2 + 20 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 _memcpy(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, ((i6 | 0) == 0 ? 0 : i6 + i3 | 0) | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
 i3 = i1 + 28 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + 28 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memcpy(((i6 | 0) == 0 ? 0 : i6 + i3 | 0) | 0, ((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, HEAP32[i1 + 24 >> 2] | 0) | 0;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i2 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memcpy(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, ((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
 return;
}

function __ZN7dtCrowd16UpdateFilterCostEif(i2, i3, f9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f9 = Math_fround(f9);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 HEAPF32[(HEAP32[i2 + 12 >> 2] | 0) + (i3 << 2) >> 2] = f9;
 if ((HEAP32[i2 >> 2] | 0) <= 0) return;
 i11 = i2 + 16 | 0;
 i12 = i2 + 24 | 0;
 i4 = i2 + 452 | 0;
 i5 = i2 + 32 | 0;
 i6 = i2 + 92 | 0;
 i7 = i2 + 100 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i11 >> 2] | 0;
  if (HEAP8[i8 + (i1 * 608 | 0) + 602 >> 0] & 1) {
   i10 = (HEAP32[i12 >> 2] | 0) + (i1 * 132 | 0) + (i3 << 2) | 0;
   if (Math_fround(HEAPF32[i10 >> 2]) != f9) {
    HEAPF32[i10 >> 2] = f9;
    if ((HEAP32[i8 + (i1 * 608 | 0) + 476 >> 2] | 0) > 0) i13 = 9; else if ((HEAP32[i8 + (i1 * 608 | 0) + 32 >> 2] | 0) > 1) i13 = 9; else if (HEAP8[i8 + (i1 * 608 | 0) + 44 >> 0] & 2) i13 = 9;
    if ((i13 | 0) == 9) {
     i13 = 0;
     HEAP32[i8 + (i1 * 608 | 0) + 48 >> 2] = 0;
    }
    if ((HEAP8[i8 + (i1 * 608 | 0) + 600 >> 0] | 0) == 2) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if (HEAP32[i6 >> 2] & 536870912 | 0) HEAP32[i7 >> 2] = 0;
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN5physx3Ext20ProfileZoneInterfaceD0Ev(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 HEAP32[i10 >> 2] = gb + 87192 + 8;
 i9 = i10 + 8 | 0;
 i1 = HEAP32[i10 + 28 >> 2] | 0;
 if (i1 | 0) {
  i7 = i10 + 44 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i10 + 20 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i10 + 24 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i10 + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i10 + 36 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i10);
  STACKTOP = i11;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i10);
 STACKTOP = i11;
 return;
}

function __ZN25ShadowMapJobHeaderScratchD0Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i6 >> 2] = gb + 35804 + 8;
 i2 = HEAP32[i6 + 168 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i6 + 172 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
  i5 = HEAP32[i6 + 180 >> 2] | 0;
  HEAP32[i1 >> 2] = 2;
  HEAP32[i1 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 }
 HEAP32[i6 + 52 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i6 + 140 >> 2] | 0) > -1) {
  i5 = i6 + 124 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i6 + 128 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i6 + 104 | 0;
 if ((HEAP32[i6 + 120 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 108 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i6 + 100 >> 2] | 0) <= -1) {
  __ZdlPv(i6);
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 + 84 >> 2] | 0, i6 + 88 | 0);
 __ZdlPv(i6);
 STACKTOP = i7;
 return;
}

function __ZN17Physics2DSettings20SetVelocityThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 f2 = i3 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 48 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAPF32[gb + 151876 >> 2] = f2;
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN14Physics2DState11CreateWorldERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = __Znwj(103032) | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i6;
 __ZN7b2WorldC2ERK6b2Vec2(i5, i4);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i5;
 __ZN7b2World18SetContactListenerEP17b2ContactListener(i5, i1 + 12 | 0);
 __ZN7b2World16SetContactFilterEP15b2ContactFilter(HEAP32[i2 >> 2] | 0, i1 + 236 | 0);
 HEAP32[i4 + 44 >> 2] = 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i4 + 36 >> 0] = 1;
 HEAP8[i4 + 38 >> 0] = 0;
 HEAP8[i4 + 39 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP8[i4 + 40 >> 0] = 1;
 HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 37 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = __ZN7b2World10CreateBodyEPK9b2BodyDef(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN12ScriptMapper8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 i1 = i2 + 28 | 0;
 if (!(HEAP32[i3 >> 2] & 33554432)) i4 = 3; else if (HEAP8[i1 >> 0] | 0) i4 = 3;
 if ((i4 | 0) == 3) {
  i4 = i2 + 32 | 0;
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 479375 | 0, gb + 476540 | 0, i4, 0);
  __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 476556 | 0, HEAP32[gb + 37052 >> 2] | 0, i4, 0);
  __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags(i3, i4, 0);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 }
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 476571 | 0, HEAP32[gb + 36972 >> 2] | 0, i1, 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __ZNK5physx2Sc9ClothCore16getStretchConfigENS_22PxClothFabricPhaseType4EnumE(i5, i7, i4) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 __ZN5physx5cloth11PhaseConfigC2Et(i6, -1);
 i1 = i7 + 32 | 0;
 i3 = __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv(HEAP32[i1 >> 2] | 0) | 0;
 L1 : do if (i3 | 0) {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break L1;
  }
  i7 = (HEAP32[i7 + 40 >> 2] | 0) + (i1 * 20 | 0) | 0;
  HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
  HEAP32[i6 + 16 >> 2] = HEAP32[i7 + 16 >> 2];
 } while (0);
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 i4 = HEAP32[i6 + 12 >> 2] | 0;
 i7 = HEAP32[i6 + 16 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[i5 + 12 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZNK11AudioSource30GetCustomSpatialBlendCurveCopyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(88) | 0;
 HEAPF32[i3 + 4 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(inf);
 HEAP32[i3 + 28 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 80 >> 2] = 2;
 HEAP32[i3 + 76 >> 2] = 2;
 HEAP32[i3 + 84 >> 2] = 4;
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i3, i4, i4 + (HEAP32[i1 + 104 >> 2] << 4) | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i1;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN5LightC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 33788 + 8;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = -1;
 i3 = __ZnwjRK10MemLabelIdiPKci(344, i2, 16, gb + 374128 | 0, 17) | 0;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15SharedLightDataC2E10MemLabelId(i3, i5);
 HEAP32[i1 + 44 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i1) {
  i11 = 0;
  return i11 | 0;
 }
 i4 = __ZN8Material25AcquireSharedMaterialDataEv(i1) | 0;
 i5 = i4;
 i6 = i11 + 80 | 0;
 i7 = i11 + 92 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 + 1 | 0;
 i10 = i11 + 96 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i9 >>> 0 > i3 >>> 0) {
  i1 = i2 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i3 >>> 0 < i1 >>> 0) if ((i2 | 0) > -1) {
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i11 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i11 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i11 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i11 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 2 | 0) | 0;
   HEAP32[i10 >> 2] = i1;
   HEAP32[i6 >> 2] = i11;
   break;
  }
 } while (0);
 HEAP32[i7 >> 2] = i9;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i8 << 2) >> 2] = i5;
 i11 = i4;
 return i11 | 0;
}

function __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 12 | 0;
 i6 = i4 + 24 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i3 = i4 + 4 | 0;
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
   HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  i3 = i4 + 16 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3);
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
  HEAP32[i5 >> 2] = 0;
  return;
 } else {
  i3 = i4 + 16 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  __Z19free_alloc_internalPvRK10MemLabelId(0, i3);
  HEAP32[i5 >> 2] = 0;
  return;
 }
}

function __ZN15CapsuleColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 0;
 HEAP8[i1 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) {
  f9 = Math_fround(0.0);
  i8 = i1 + 56 | 0;
  HEAPF32[i8 >> 2] = f9;
  HEAP32[i1 >> 2] = gb + 111136 + 8;
  STACKTOP = i4;
  return;
 }
 f9 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 i8 = i1 + 56 | 0;
 HEAPF32[i8 >> 2] = f9;
 HEAP32[i1 >> 2] = gb + 111136 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 1046296 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 380 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 426616 | 0, gb + 1048082 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN10GameObject25SetSupportedMessagesDirtyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i1 + 60 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 if (HEAP32[i1 + 56 >> 2] & 16 | 0) return;
 HEAP32[i8 >> 2] = 0;
 i9 = i1 + 28 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i7 = i1 + 40 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i5 = i3;
  i2 = 0;
  i4 = i3;
  while (1) {
   i3 = HEAP32[i5 + 4 >> 2] | 0;
   if (!i3) i3 = i4; else {
    i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0) | 0;
    i2 = HEAP32[i8 >> 2] | i2;
    HEAP32[i8 >> 2] = i2;
    i3 = HEAP32[i9 >> 2] | 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i5 = i5 + 8 | 0;
   if ((i5 | 0) == (i3 + (i1 << 3) | 0)) break; else i4 = i3;
  }
 }
 if ((i6 | 0) == (i2 | 0) | (i1 | 0) == 0) return; else i4 = i3;
 while (1) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i2) i2 = i3; else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, HEAP32[i8 >> 2] | 0);
   i2 = HEAP32[i9 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 8 | 0;
  if ((i4 | 0) == (i2 + (i1 << 3) | 0)) break; else i3 = i2;
 }
 return;
}

function __ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 8 | 0;
 i2 = i6;
 i5 = i6 + 12 | 0;
 switch (__Z21CheckGpuProgramUsable20ShaderGpuProgramType(i1) | 0) {
 case 0:
  {
   i5 = 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 case 2:
  {
   if (!i3) {
    HEAP32[i2 >> 2] = gb + 475787;
    __Z6FormatPKcz(i5, gb + 476414 | 0, i2);
    i1 = 0;
   } else {
    i1 = HEAP32[i3 + 28 >> 2] | 0;
    if (!(HEAP8[i1 >> 0] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
    HEAP32[i4 >> 2] = i1;
    __Z6FormatPKcz(i5, gb + 476414 | 0, i4);
    i1 = HEAP32[i3 + 4 >> 2] | 0;
   }
   __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE(i5, 0, gb + 472212 | 0, 436, 512, i1, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 default:
  {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 return 0;
}

function __Z41InitializeTransferFieldFromScriptingFieldR18TransferField_InfoPKS_P9FieldInfoP11Il2CppClassRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsRK20CoreScriptingClasses(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i1 >> 2] = i3;
 i8 = __Z24scripting_field_get_typeP9FieldInfo(i3) | 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i1 + 12 >> 2] = __Z23scripting_type_get_typePK10Il2CppType(i8) | 0;
 HEAP32[i1 + 4 >> 2] = __Z25scripting_class_from_typePK10Il2CppType(HEAP32[i7 >> 2] | 0) | 0;
 HEAP32[i1 + 16 >> 2] = __Z25scripting_field_get_flagsP9FieldInfo(i3) | 0;
 HEAP32[i1 + 20 >> 2] = __Z24scripting_field_get_nameP9FieldInfo(i3) | 0;
 HEAP16[i1 + 24 >> 1] = HEAP16[i5 + 16 >> 1] | 0;
 i7 = HEAP32[i5 + 12 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = i7;
 HEAP32[i1 + 28 >> 2] = 0;
 i8 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = i8;
 HEAP32[i1 + 40 >> 2] = i2;
 return __Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses(i6, i4, i7, i1, i8) | 0;
}

function _UNITY_FT_GlyphSlot_Own_Bitmap(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((HEAP32[i1 + 72 >> 2] | 0) != 1651078259) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = i1 + 156 | 0;
 if (HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] & 1 | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i3 = i1 + 76 | 0;
 i1 = _UNITY_FT_Bitmap_Copy(HEAP32[i1 >> 2] | 0, i3, i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  i4 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function _UNITY_FT_Create_Class_ft_smooth_lcdv_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 60, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _UNITY_ft_smooth_lcdv_renderer_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 2;
  HEAP32[i5 + 4 >> 2] = 64;
  HEAP32[i5 + 8 >> 2] = gb + 1008254;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2630;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = 0;
  HEAP32[i5 + 36 >> 2] = 1869968492;
  HEAP32[i5 + 40 >> 2] = fb + 194;
  HEAP32[i5 + 44 >> 2] = fb + 183;
  HEAP32[i5 + 48 >> 2] = fb + 963;
  HEAP32[i5 + 52 >> 2] = fb + 441;
  HEAP32[i5 + 56 >> 2] = (HEAP32[i1 + 216 >> 2] | 0) + 4;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _strspn(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i2 = HEAP8[i1 >> 0] | 0;
 do if (!(i2 << 24 >> 24)) i1 = 0; else {
  if (!(HEAP8[i1 + 1 >> 0] | 0)) {
   i1 = i4;
   while (1) if ((HEAP8[i1 >> 0] | 0) == i2 << 24 >> 24) i1 = i1 + 1 | 0; else break;
   i1 = i1 - i4 | 0;
   break;
  }
  do {
   i6 = i3 + (((i2 & 255) >>> 5 & 255) << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i2 & 31);
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i2 = HEAP8[i4 >> 0] | 0;
  L10 : do if (!(i2 << 24 >> 24)) i1 = i4; else {
   i1 = i4;
   do {
    if (!(HEAP32[i3 + (((i2 & 255) >>> 5 & 255) << 2) >> 2] & 1 << (i2 & 31))) break L10;
    i1 = i1 + 1 | 0;
    i2 = HEAP8[i1 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
  } while (0);
  i1 = i1 - i4 | 0;
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK22NavMeshProjectSettings15GetAreaFromNameERK8UnityStr(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i9 << 24 >> 24 < 0;
 i9 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i9 & 255;
 i7 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = 0;
 do {
  i3 = i6 + 28 + (i1 * 20 | 0) | 0;
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) {
   i5 = HEAP32[i6 + 28 + (i1 * 20 | 0) + 4 >> 2] | 0;
   i3 = HEAP32[i3 >> 2] | 0;
  } else i5 = i2 & 255;
  i4 = i9 >>> 0 < i5 >>> 0;
  i2 = i4 ? i9 : i5;
  if (!i2) i8 = 7; else if (!(_memcmp(i3, i7, i2) | 0)) i8 = 7;
  if ((i8 | 0) == 7) {
   i8 = 0;
   if (i5 >>> 0 >= i9 >>> 0 & (i4 ^ 1)) {
    i8 = 13;
    break;
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < 32);
 if ((i8 | 0) == 13) return i1 | 0;
 i2 = i9 >>> 0 > 7;
 i1 = i2 ? 7 : i9;
 if (i1 | 0) if (_memcmp(i7, gb + 1012705 | 0, i1) | 0) {
  i9 = -1;
  return i9 | 0;
 }
 if (!(i9 >>> 0 > 6 & (i2 ^ 1))) {
  i9 = -1;
  return i9 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(HEAP32[gb + 169548 >> 2] | 0, 0, gb + 841974 | 0, 244, 512, 0, 0, 0);
 i9 = 0;
 return i9 | 0;
}

function __ZN9ShaderLab21ClearParserStateStackEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i5 = HEAP32[gb + 1166560 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 i4 = i5 + 4 | 0;
 i3 = i2 + 4 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i6;
 i3 = i5 + 8 | 0;
 i6 = i2 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i6 = i5 + 12 | 0;
 i4 = i2 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i3;
 i5 = i5 + 20 | 0;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 __ZNSt3__25stackIPN9ShaderLab21SerializedShaderStateENS_5dequeIS3_NS_9allocatorIS3_EEEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __ZN9Coroutine3RunEPb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i7 = i4 + 44 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 HEAP32[i1 >> 2] = 0;
 i3 = __ZN9Coroutine14InvokeMoveNextEPP15Il2CppException(i4, i1) | 0;
 i7 = (HEAP32[i7 >> 2] | 0) == 1;
 i5 = i4 + 56 | 0;
 __ZN9Coroutine16CleanupCoroutineEPv(i4) | 0;
 if (i7) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP8[i2 >> 0] = (i1 | 0) != 0 & 1;
 if (i1 | 0) {
  i7 = 1;
  STACKTOP = i6;
  return i7 | 0;
 }
 if (i3) {
  if (!(HEAP32[i4 + 40 >> 2] | 0)) {
   i7 = 1;
   STACKTOP = i6;
   return i7 | 0;
  }
  __ZN9Coroutine23ProcessCoroutineCurrentEv(i4);
  i7 = 1;
  STACKTOP = i6;
  return i7 | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i7 = 1;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 if (HEAP32[i1 + 40 >> 2] | 0) {
  HEAP8[i4 + 52 >> 0] = 1;
  __ZN9Coroutine3RunEPb(i1, 0) | 0;
 }
 __ZN9Coroutine16CleanupCoroutineEPv(i1) | 0;
 i7 = 1;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix4x3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f8 * Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) + f6);
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 16 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 20 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 24 >> 2])));
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) + f5);
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 32 >> 2]));
 f7 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 36 >> 2])));
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 40 >> 2])));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 44 >> 2]) + f4);
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZN20BufferedSocketStream4PollEy(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, d7 = 0.0, i8 = 0, i9 = 0;
 i4 = i3 + 18 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 d7 = +_emscripten_get_now() * 1.0e6;
 i5 = ~~d7 >>> 0;
 i6 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i1 = ___muldi3(i1 | 0, i2 | 0, 1e6, 0) | 0;
 i2 = getTempRet0() | 0;
 do {
  d7 = +_emscripten_get_now() * 1.0e6;
  i8 = _i64Subtract(~~d7 >>> 0 | 0, (+Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0, i5 | 0, i6 | 0) | 0;
  i8 = __Z17TimeToNanosecondsy(i8, getTempRet0() | 0) | 0;
  i9 = getTempRet0() | 0;
  if (!(i9 >>> 0 < i2 >>> 0 | (i9 | 0) == (i2 | 0) & i8 >>> 0 < i1 >>> 0)) break;
  i9 = __ZN20BufferedSocketStream15FlushSendbufferEv(i3) | 0;
  i9 = i9 | (__ZN20BufferedSocketStream14FillRecvbufferEv(i3) | 0);
 } while (i9 & (HEAP8[i4 >> 0] | 0) != 0);
 i9 = (HEAP8[i4 >> 0] | 0) != 0;
 return i9 | 0;
}

function __ZN19TouchPhaseEmulation11InitTouchesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i2 + 4 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 + (i1 * 96 | 0) >> 2] = -1;
  HEAP32[i4 + (i1 * 96 | 0) + 36 >> 2] = 4;
  HEAP32[i4 + (i1 * 96 | 0) + 92 >> 2] = 0;
  HEAP32[i4 + (i1 * 96 | 0) + 84 >> 2] = 0;
  HEAP32[i4 + (i1 * 96 | 0) + 88 >> 2] = 0;
  i5 = i4 + (i1 * 96 | 0) + 4 | 0;
  i6 = i4 + (i1 * 96 | 0) + 72 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = 0;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i4 + (i1 * 96 | 0) + 80 >> 2] = -1;
  HEAPF32[i4 + (i1 * 96 | 0) + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + (i1 * 96 | 0) + 48 >> 2] = Math_fround(1.0);
  HEAP32[i4 + (i1 * 96 | 0) + 40 >> 2] = 0;
  i4 = i4 + (i1 * 96 | 0) + 52 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 1;
 return;
}

function __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 480 | 0;
 i3 = i4 + 492 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN18GfxFramebufferGLES25CleanupFBOMapForTextureIDERK9TextureID(i4, (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 496 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 484 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 500 | 0;
 i3 = i4 + 512 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN18GfxFramebufferGLES20CleanupFBOMapForRBIDERKj(i4, (HEAP32[i2 >> 2] | 0) + (i1 << 2) | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 516 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4 + 504 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN17Physics2DSettings24SetAngularSleepToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151900 >> 2] = f3;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(f2 * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN8Animator12CreateObjectEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 if (HEAP32[i5 + 100 >> 2] & 16 | 0) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i6;
  return;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 if ((HEAP16[gb + 1466968 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1466968 | 0, i2);
  i1 = gb + 1466968 | 0;
 } else i1 = 0;
 __ZN8Animator11ClearObjectEv(i5);
 __ZN8Animator16InitializeAvatarEv(i5);
 if (HEAP8[i5 + 153 >> 0] | 0) {
  __ZN8Animator14CreateBindingsEv(i5);
  __ZN8Animator20CreatePlayableMemoryEv(i5);
  __ZN8Animator24CollectAnimatedRenderersERKNS_15BindingsDataSetE(i5, i5 + 168 | 0);
 }
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = i8 + 12 | 0;
 i6 = i8 + 20 | 0;
 if (!(HEAP32[i6 >> 2] & 2147483647)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i5, i1 + 3 & -4, i2);
 }
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i5, i1);
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i2 + (i4 << 4);
 i1 = i8 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i9;
  return;
 }
 i7 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = 0;
 i7 = i8 + 8 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i8;
 STACKTOP = i9;
 return;
}

function __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN15LODGroupManager20DestroyCameraLODDataEPK6Camera(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i2 + 48 | 0;
 i4 = HEAP32[i9 >> 2] | 0;
 if (!i4) return;
 i10 = i2 + 36 | 0;
 i5 = HEAP32[i10 >> 2] | 0;
 i8 = 0;
 while (1) {
  i7 = HEAP32[i5 + (i8 << 2) >> 2] | 0;
  if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) break;
  i1 = i8 + 1 | 0;
  if (i1 >>> 0 < i4 >>> 0) i8 = i1; else {
   i6 = 13;
   break;
  }
 }
 if ((i6 | 0) == 13) return;
 i1 = i2 + 40 | 0;
 if (i7 | 0) {
  i2 = i7 + 36 | 0;
  if ((HEAP32[i7 + 52 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i7 + 40 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  if ((HEAP32[i7 + 32 >> 2] | 0) > -1) {
   i6 = i7 + 16 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i7 + 20 | 0);
   HEAP32[i6 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i1);
 HEAP32[(HEAP32[i10 >> 2] | 0) + (i8 << 2) >> 2] = 0;
 i1 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 if ((i1 | 0) != (i8 | 0)) {
  i10 = HEAP32[i10 >> 2] | 0;
  HEAP32[i10 + (i8 << 2) >> 2] = HEAP32[i10 + (i1 << 2) >> 2];
 }
 HEAP32[i9 >> 2] = i1;
 return;
}

function __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 898314 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 898330 | 0, i3, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZL27DestroySpeedTreeWindManagerPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = HEAP32[gb + 1170600 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i5 = i2 + 24 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i4 | 0) >>> 2) << 2);
   i6 = HEAP32[i2 + 32 >> 2] | 0;
   HEAP32[i1 >> 2] = 62;
   HEAP32[i1 + 4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63616 | 0);
 HEAP32[gb + 1170600 >> 2] = 0;
 i1 = HEAP32[gb + 1170604 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
  HEAP32[gb + 1170604 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
 __ZN10MemoryPoolD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
 HEAP32[gb + 1170604 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i3, i4, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 if ((i7 | 0) <= 0) return;
 i8 = i3 + 12 | 0;
 i9 = i3 + 16 | 0;
 i10 = i3 + 4 | 0;
 i1 = 0;
 do {
  i11 = i4 + (i1 << 2) | 0;
  i12 = HEAP32[i8 >> 2] | 0;
  i13 = i12 + 1 | 0;
  i5 = HEAP32[i9 >> 2] | 0;
  i6 = i5 & 2147483647;
  do if (i13 >>> 0 > i6 >>> 0) {
   i2 = i5 << 1;
   i2 = (i2 | 0) == 0 ? 1 : i2;
   if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
    HEAP32[i9 >> 2] = i2;
    HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i10, 0, gb + 1047584 | 0, 464) | 0;
    break;
   } else {
    i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10, 0, gb + 1047584 | 0, 446) | 0;
    _memcpy(i6 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
    HEAP32[i9 >> 2] = i2;
    HEAP32[i3 >> 2] = i6;
    break;
   }
  } while (0);
  HEAP32[i8 >> 2] = i13;
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i12 << 2) >> 2] = HEAP32[i11 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function _UNITY_FT_Create_Class_ft_smooth_lcd_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 60, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _UNITY_ft_smooth_lcd_renderer_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 2;
  HEAP32[i5 + 4 >> 2] = 64;
  HEAP32[i5 + 8 >> 2] = gb + 1008243;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2630;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = 0;
  HEAP32[i5 + 36 >> 2] = 1869968492;
  HEAP32[i5 + 40 >> 2] = fb + 193;
  HEAP32[i5 + 44 >> 2] = fb + 183;
  HEAP32[i5 + 48 >> 2] = fb + 963;
  HEAP32[i5 + 52 >> 2] = fb + 441;
  HEAP32[i5 + 56 >> 2] = (HEAP32[i1 + 216 >> 2] | 0) + 4;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE5writeEPKvj(i3, i9, i8) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i3 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + i8 | 0;
 i7 = i3 + 24 | 0;
 if ((HEAP32[i7 >> 2] | 0) >>> 0 < i2 >>> 0) i1 = 32; else {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  i7 = i1;
  i7 = i5 + i7 | 0;
  _memcpy(i7 | 0, i9 | 0, i8 | 0) | 0;
  i9 = HEAP32[i6 >> 2] | 0;
  i9 = i9 + i8 | 0;
  HEAP32[i6 >> 2] = i9;
  return i8 | 0;
 }
 while (1) if (i1 >>> 0 < i2 >>> 0) i1 = i1 << 1; else break;
 i5 = i3 + 8 | 0;
 i4 = __ZN5physx19CVariableMemoryPool8allocateEj((HEAP32[i5 >> 2] | 0) + 4 | 0, i1) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i3 + 20 | 0;
 if (i2 | 0) _memcpy(i4 | 0, HEAP32[i3 >> 2] | 0, i2 | 0) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i5 >> 2] | 0) + 4 | 0, i2 + -8 | 0, HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i3 >> 2] = i4;
 HEAP32[i7 >> 2] = i1;
 i5 = i4;
 i7 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + i7 | 0;
 _memcpy(i7 | 0, i9 | 0, i8 | 0) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i9 = i9 + i8 | 0;
 HEAP32[i6 >> 2] = i9;
 return i8 | 0;
}

function __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP8[i1 + 16 >> 0] | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 12 >> 2] | 0, gb + 63560 | 0);
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 96 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 20 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i4;
 i2 = i1 + 92 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i4;
 if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0)) {
  i4 = i1 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i4 + 24 >> 2] | 0) != (HEAP32[i4 + 20 >> 2] | 0)) {
  i4 = i1 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - (HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0);
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2];
 if (!i2) {
  i4 = i1 + 12 | 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
 __ZdlPv(i2);
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN12AdsIdHandler37ExecuteOnMainThreadAdsIdJobDoneStaticEPv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i4 + 48 | 0;
 i3 = i4 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) do {
  i8 = i1 + 8 | 0;
  __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj(i4, HEAP32[i8 >> 2] | 0);
  __Z23scripting_gchandle_freej(HEAP32[i8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 i2 = i4 + 56 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i4 + 60 | 0;
 i3 = i5 + 4 | 0;
 do {
  i8 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = 5;
  HEAP32[i3 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i7;
 return;
}

function __ZN11b2RopeJointC2EPK14b2RopeJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152580 + 8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 68 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAPF32[i1 + 160 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 164 >> 2] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i6 = (HEAP8[i2 >> 0] | 0) == 0 ? i6 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i6;
 i7 = i5 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i5 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
 }
 i1 = i6 + 4 | 0;
 i4 = i2 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKcj(i8, i4, i1, i7) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = i8 + 11 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i6 = HEAP32[i8 + 4 >> 2] | 0; else i6 = i2 & 255;
 if (i6 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i3) i2 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
 if ((i2 - i6 | 0) >>> 0 < i7 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc(i8, i2, i6 + i7 - i2 | 0, i6, i4, 0, i7, i1); else if (i7 | 0) {
  if (i3) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
  i3 = i6 - i4 | 0;
  i2 = i5 + i4 | 0;
  if (i3) {
   _memmove(i2 + i7 | 0, i2 | 0, i3 | 0) | 0;
   i1 = i2 >>> 0 <= i1 >>> 0 & (i5 + i6 | 0) >>> 0 > i1 >>> 0 ? i1 + i7 | 0 : i1;
  }
  _memmove(i2 | 0, i1 | 0, i7 | 0) | 0;
  i1 = i6 + i7 | 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
  HEAP8[i5 + i1 >> 0] = 0;
 }
 return i8 | 0;
}

function __ZNK11AudioSource25GetCustomRolloffCurveCopyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(88) | 0;
 HEAPF32[i3 + 4 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(inf);
 HEAP32[i3 + 28 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 80 >> 2] = 2;
 HEAP32[i3 + 76 >> 2] = 2;
 HEAP32[i3 + 84 >> 2] = 4;
 i4 = HEAP32[i1 + 356 >> 2] | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i3, i4, i4 + (HEAP32[i1 + 368 >> 2] << 4) | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN9ShaderLab20SerializedProperties16AddRangePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEfff(i7, i1, i2, i3, f4, f5, f6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i8, i1, i2, 3, i3);
 HEAPF32[i8 + 52 >> 2] = f4;
 HEAPF32[i8 + 56 >> 2] = f5;
 HEAPF32[i8 + 60 >> 2] = f6;
 i1 = i7 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i7 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i7, i8);
  __ZN9ShaderLab18SerializedPropertyD2Ev(i8);
  STACKTOP = i9;
  return;
 } else {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i8);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 88;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i8);
  STACKTOP = i9;
  return;
 }
}

function __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11 + 4 | 0;
 i10 = i11;
 i1 = i7 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 164 >> 0] & 1)) i3 = 3; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i7);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i2 + 12 | 0, i8, i9, 0);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE(i7, i6);
 STACKTOP = i11;
 return;
}

function __ZN7ApiGLES11FlushBufferEjN2gl12BufferTargetEll(i3, i4, i1, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i2 = i1;
 i5 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i8 + 860 >> 2] | 0, i2) | 0;
 i2 = i8 + 892 + (i2 << 2) | 0;
 if (!(HEAP8[i8 + 1992 >> 0] | 0)) i9 = 5; else if ((HEAP32[i2 >> 2] | 0) != (i4 | 0)) i9 = 5;
 if ((i9 | 0) == 5) {
  HEAP32[i2 >> 2] = i4;
  mftCall_vii(HEAP32[i8 + 644 >> 2] | 0, i5 | 0, i4 | 0);
 }
 mftCall_viii(HEAP32[i3 + 676 >> 2] | 0, i5 | 0, i6 | 0, i7 | 0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 706 >> 0] | 0)) return;
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i2 + 892 + (i1 << 2) >> 2] = 0;
 i9 = HEAP32[i2 + 644 >> 2] | 0;
 mftCall_vii(i9 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0, 0);
 return;
}

function __ZN5physx6shdfnd10Foundation19AlignCheckAllocator8allocateEjPKcS4_i(i7, i6, i8, i3, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i6 | 0, i8 | 0, i3 | 0, i5 | 0) | 0;
 if (!i1) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(HEAP32[gb + 1452348 >> 2] | 0, 64, gb + 659867 | 0, 240, gb + 732402 | 0, i9);
 if (i1 & 15 | 0) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(HEAP32[gb + 1452348 >> 2] | 0, 64, gb + 659867 | 0, 254, gb + 732432 | 0, i9 + 8 | 0);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i7 + 28 >> 2] | 0;
 if (!i2) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 } else i4 = 0;
 do {
  i10 = HEAP32[i7 + 8 + (i4 << 2) >> 2] | 0;
  mftCall_viiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, i6 | 0, i8 | 0, i3 | 0, i5 | 0, i1 | 0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i2 | 0));
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN5physx3Cct13BoxController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE(i6, i1, f4, f2, i3, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 __ZN5physx3Cct8SweptBoxC2Ev(i8);
 i9 = i8 + 8 | 0;
 i11 = i6 + 416 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i9 + 8 >> 2] = HEAP32[i11 + 8 >> 2];
 HEAP32[i9 + 12 >> 2] = HEAP32[i11 + 12 >> 2];
 HEAP32[i9 + 16 >> 2] = HEAP32[i11 + 16 >> 2];
 HEAP32[i9 + 20 >> 2] = HEAP32[i11 + 20 >> 2];
 i9 = HEAP32[i6 + 496 >> 2] | 0;
 i11 = HEAP32[i6 + 500 >> 2] | 0;
 i10 = HEAP32[i6 + 504 >> 2] | 0;
 HEAP32[i8 + 40 >> 2] = i9;
 HEAP32[i8 + 44 >> 2] = i11;
 HEAP32[i8 + 48 >> 2] = i10;
 HEAP32[i8 + 32 >> 2] = i9;
 i6 = __ZN5physx3Cct10Controller4moveERNS0_11SweptVolumeERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextEb(i6 + 8 | 0, i8, i1, f4, f2, i3, i5, 0) | 0;
 __ZN5physx3Cct8SweptBoxD2Ev(i8);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx14NpRigidDynamic18setKinematicTargetERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f9 * f9);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f5 * f5)))));
 f7 = Math_fround(f7 * f8);
 f6 = Math_fround(f6 * f8);
 f5 = Math_fround(f5 * f8);
 HEAPF32[i4 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 HEAPF32[i4 + 12 >> 2] = f5;
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 __ZN5physx14NpRigidDynamic26setKinematicTargetInternalERKNS_11PxTransformE(i2, i4);
 STACKTOP = i3;
 return;
}

function __ZN27LightProbeProxyVolumeSample10InvalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i1 >> 2] = HEAP32[(__ZN10builtintex16GetDefaultTexEnvE16TextureDimension(3) | 0) >> 2];
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 i2 = i1 + 8 | 0;
 i5 = i4 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 i2 = i1 + 32 | 0;
 i4 = gb + 1162292 | 0;
 i5 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  i2 = i2 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP8[i1 + 96 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __ZN19RenderEventsContext23RemoveAllCommandBuffersEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i6 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) <= 0) return;
 i5 = 0;
 do {
  i8 = HEAP32[i6 >> 2] | 0;
  i9 = i8 + (i5 * 20 | 0) | 0;
  i1 = HEAP32[i9 >> 2] | 0;
  i10 = i8 + (i5 * 20 | 0) + 12 | 0;
  if (!(HEAP32[i10 >> 2] | 0)) i2 = i1; else {
   i4 = i1;
   i2 = i1;
   i3 = i1;
   while (1) {
    i1 = HEAP32[i4 >> 2] | 0;
    i11 = i1 + 4 | 0;
    HEAP32[i11 >> 2] = (HEAP32[i11 >> 2] | 0) + -1;
    if ((i1 | 0) == 0 | (HEAP32[i11 >> 2] | 0) != 0) i1 = i3; else {
     mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
     i2 = HEAP32[i9 >> 2] | 0;
     i1 = i2;
    }
    i4 = i4 + 4 | 0;
    if ((i4 | 0) == (i1 + (HEAP32[i10 >> 2] << 2) | 0)) break; else i3 = i1;
   }
  }
  i1 = i8 + (i5 * 20 | 0) + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i8 + (i5 * 20 | 0) + 4 | 0);
   HEAP32[i9 >> 2] = 0;
  }
  HEAP32[i9 >> 2] = 0;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (HEAP32[i7 >> 2] | 0));
 return;
}

function __ZN17AudioChorusFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(72, i1, 16, gb + 1048932 | 0, 0, gb + 870353 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 170016 + 8;
 HEAPF32[i4 + 44 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 60 >> 2] = Math_fround(40.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(.800000011);
 HEAPF32[i4 + 68 >> 2] = Math_fround(.0299999993);
 HEAP32[i4 + 36 >> 2] = 12;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 128 | 0;
 if (HEAP32[i2 >> 2] | 0) return;
 i4 = i1 + 8 | 0;
 i5 = i1 + 52 | 0;
 while (1) {
  if ((HEAP32[i4 >> 2] | 0) != 1) if ((HEAP32[i4 >> 2] | 0) != 2) break;
  i3 = __ZN11UnityEngine15CloudWebService14DataDispatcher30FindSessionContainerToDispatchEv(i1) | 0;
  if (!i3) break;
  if ((HEAP32[i4 >> 2] | 0) == 1) i6 = 10; else if ((HEAP32[i4 >> 2] | 0) == 2) i6 = 10;
  if ((i6 | 0) == 10) {
   i6 = 0;
   HEAP8[i5 >> 0] = 0;
   HEAP8[i3 + 88 >> 0] = 1;
   HEAP8[i3 + 90 >> 0] = 1;
   HEAP32[i2 >> 2] = i3;
   if (!(__ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE(i1, i3) | 0)) {
    __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i3, i3 + 16 | 0) | 0;
    __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i3);
    HEAP32[i2 >> 2] = 0;
    HEAP8[i5 >> 0] = 1;
   }
  }
  if (HEAP32[i2 >> 2] | 0) {
   i6 = 12;
   break;
  }
 }
 if ((i6 | 0) == 12) return;
 HEAP8[i5 >> 0] = 1;
 HEAP32[i1 + 88 >> 2] = 0;
 return;
}

function __Z49Physics2D_CUSTOM_INTERNAL_CALL_CircleCastNonAllocRK13Vector2fIcallfS1_P11Il2CppArrayfiff(i2, f4, i3, i5, f6, i7, f8, f9) {
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 i3 = i3 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i1 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i10 + 8 | 0;
 i11 = i10;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 36) | 0;
 i13 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di(i13, i12, f4, i11, f6, i7, f8, f9, 0, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0) | 0;
 if (!i3) {
  STACKTOP = i10;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i10;
 return i3 | 0;
}

function __Z32Renderer_Set_Custom_PropMaterialP12Il2CppObjectS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i6 = i7;
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i2 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
 __ZN8Renderer16SetMaterialCountEi(i1, (i2 | 0) > 1 ? i2 : 1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP32[i6 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i5) | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i1, i3, 0);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__221recursive_timed_mutex4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i2 = _pthread_self() | 0;
 HEAP32[i6 >> 2] = i1;
 i7 = i6 + 4 | 0;
 HEAP8[i7 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i1);
 i3 = i1 + 80 | 0;
 i4 = i1 + 76 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  do if ((i1 | 0) == -1) {
   __THREW__ = 0;
   invoke_vii(fb + 4496 | 0, 11, gb + 1082463 | 0);
   i3 = __THREW__;
   __THREW__ = 0;
   if (!(i3 & 1)) {
    i1 = HEAP32[i4 >> 2] | 0;
    break;
   }
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   if (HEAP8[i7 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i6 >> 2] | 0);
   ___resumeException(i1 | 0);
  } while (0);
  HEAP32[i4 >> 2] = i1 + 1;
 } else {
  i1 = i1 + 28 | 0;
  while (1) {
   if (!(HEAP32[i4 >> 2] | 0)) break;
   __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i1, i6);
  }
  HEAP32[i4 >> 2] = 1;
  HEAP32[i3 >> 2] = i2;
 }
 if (HEAP8[i7 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i6 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZNK11AudioSource24GetCustomSpreadCurveCopyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(88) | 0;
 HEAPF32[i3 + 4 >> 2] = Math_fround(inf);
 HEAP32[i3 >> 2] = 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAPF32[i3 + 32 >> 2] = Math_fround(inf);
 HEAP32[i3 + 28 >> 2] = 0;
 i5 = i3 + 36 | 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 60 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i3 + 80 >> 2] = 2;
 HEAP32[i3 + 76 >> 2] = 2;
 HEAP32[i3 + 84 >> 2] = 4;
 i4 = HEAP32[i1 + 268 >> 2] | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i3, i4, i4 + (HEAP32[i1 + 280 >> 2] << 4) | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN8VRDevice17SendVRDeviceEventEjj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 4 | 0;
 i4 = i7;
 i3 = __Z16GetRealGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i2);
  __Z12profiler_endP19ProfilerInformation(gb + 1469192 | 0);
 }
 i3 = i1 + 208 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i2);
   i2 = gb + 1469204 | 0;
   i1 = HEAP32[i3 >> 2] | 0;
  } else i2 = 0;
  mftCall_vii(i1 | 0, i5 | 0, i6 | 0);
  if (i2 | 0) __Z12profiler_endP19ProfilerInformation(i2);
 }
 i6 = __Z16GetRealGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
 STACKTOP = i7;
 return;
}

function __ZN6Skybox23VirtualRedirectTransferER14SafeBinaryRead(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i1 = i7;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 67408 >> 2] | 0, gb + 384544 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i5);
   i2 = i3 + 36 | 0;
   i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 384551 | 0, gb + 946436 | 0, i4, 1) | 0;
   if (i1 | 0) {
    if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
     i1 = HEAP32[i4 >> 2] | 0;
     if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
    }
    __ZN14SafeBinaryRead11EndTransferEv(i5);
   }
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i7;
 return;
}

function __ZN14RenderSettings15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 381335 | 0, gb + 383934 | 0, gb + 381810 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 381335 | 0, gb + 383944 | 0, gb + 381483 | 0);
 __ZN12LightManager15InitializeClassEv();
 __ZN16ReflectionProbes15InitializeClassEv();
 __ZN28LightProbeProxyVolumeManager15InitializeClassEv();
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 37052 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 36284 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 36284 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 36284 + (i1 * 12 | 0) >> 2] = fb + 2383;
 STACKTOP = i5;
 return;
}

function __Z51Physics2D_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiffP12RaycastHit2D(i1, i2, i3, f4, i5, f6, i7, f8, f9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i14 = i11 + 16 | 0;
 i13 = i11 + 8 | 0;
 i12 = i11;
 i15 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i14 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 if ((__ZN16Physics2DManager11CapsuleCastERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP12RaycastHit2Di(i15, i14, i13, i3, f4, i12, f6, i7, f8, f9, 0, 0, i10, 1) | 0) != 1) {
  STACKTOP = i11;
  return;
 }
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i10);
 STACKTOP = i11;
 return;
}

function __Z51ParticleSystem_CUSTOM_SetCustomParticleDataInternalP12Il2CppObjectS0_i(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622636 | 0, i5);
 if (i4 >>> 0 > 1) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 4 >> 2] = 1;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 622655 | 0, i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 16) | 0;
  __ZN14ParticleSystem21SetCustomParticleDataEPKN4math14float4_storageEii(i1, i6, i4, HEAP32[i3 + 12 >> 2] | 0);
  STACKTOP = i5;
  return;
 }
}

function __Z44BillboardAsset_CUSTOM_MakeMaterialPropertiesP12Il2CppObjectS0_S0_(i5, i1, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i6 = __ZN21BillboardBatchManager3GetEv() | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (!i5) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i1) {
  i7 = i5;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZN21BillboardBatchManager18MakeTempPropertiesER19ShaderPropertySheetRK6CameraRK19SharedBillboardData(i6, i4, i2, HEAP32[i1 + 32 >> 2] | 0);
  STACKTOP = i7;
  return;
 }
}

function __Z33UnregisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = __ZN15GlobalCallbacks3GetEv() | 0;
 i9 = i8 + 39368 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 if (!i6) return; else i1 = 0;
 while (1) {
  i3 = i8 + 38600 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i5 | 0)) {
   i4 = i8 + 38600 + (i1 * 12 | 0) + 8 | 0;
   i2 = i8 + 38600 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i6 >>> 0) {
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i7 = (HEAP32[i9 >> 2] | 0) + -1 | 0;
 HEAP32[i9 >> 2] = i7;
 if (i7 >>> 0 <= i1 >>> 0) return;
 do {
  i7 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i8 + 38600 + (i7 * 12 | 0) >> 2] = HEAP32[i8 + 38600 + (i1 * 12 | 0) >> 2];
  HEAP32[i8 + 38600 + (i7 * 12 | 0) + 4 >> 2] = HEAP32[i8 + 38600 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i8 + 38600 + (i7 * 12 | 0) + 8 >> 0] = HEAP8[i8 + 38600 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 return;
}

function __Z23CullObjectsWithoutUmbraRK17CullingParametersPK4AABBR9IndexList(i3, i9, i10) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i11 + 4 | 0;
 i2 = i11;
 if ((HEAP16[gb + 1114440 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114440 | 0, i1);
  i7 = gb + 1114440 | 0;
 } else i7 = 0;
 i8 = i10 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i3 + 352 | 0;
 if ((i5 | 0) > 0) {
  i4 = i3 + 188 | 0;
  i3 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[(HEAP32[i10 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   if (__Z33IntersectAABBPlaneBoundsOptimizedRK4AABBPKN4math7_float4Ei(i9 + (i2 * 24 | 0) | 0, i6, HEAP32[i4 >> 2] | 0) | 0) {
    HEAP32[(HEAP32[i10 >> 2] | 0) + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i5 | 0));
 } else i1 = 0;
 HEAP32[i8 >> 2] = i1;
 if (!i7) {
  STACKTOP = i11;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i11;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwj(i2, i6, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 __THREW__ = 0;
 i5 = invoke_ii(fb + 2806 | 0, i6 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i4);
 }
 L8 : do if (i1 >>> 0 > i3 >>> 0) {
  i4 = i2 + (i1 << 2) | 0;
  i3 = i2 + (i3 << 2) | 0;
  while (1) {
   if ((i3 | 0) == (i4 | 0)) {
    i7 = -1;
    break L8;
   }
   __THREW__ = 0;
   i1 = invoke_iiii(fb + 514 | 0, i6 | 0, i5 | 0, i3 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = 10;
    break;
   }
   if (!i1) {
    i1 = 12;
    break;
   }
   i3 = i3 + 4 | 0;
  }
  if ((i1 | 0) == 10) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else if ((i1 | 0) == 12) {
   i7 = i3 - i2 >> 2;
   break;
  }
 } else i7 = -1; while (0);
 return i7 | 0;
}

function __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN9Texture2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i7);
 i6 = i5 + 152 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j(i6, i1);
 i2 = HEAP32[i5 + 156 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i7);
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN26AnimatorControllerPlayable7SetBoolEiRKb(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i5 = 8;
  return i5 | 0;
 }
 i3 = i4 + 92 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i6 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  i6 = 4;
  return i6 | 0;
 }
 i6 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 2) >> 2] | 0) != -1) {
  i6 = 16;
  return i6 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 switch (HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) {
 case 9:
 case 4:
  break;
 default:
  {
   i6 = 2;
   return i6 | 0;
  }
 }
 i6 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) + 44 | 0;
 HEAP8[i6 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] = HEAP8[i5 >> 0] | 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN17Physics2DSettings19SetMaxRotationSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 64 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f3;
 f3 = Math_fround(f3 * f3);
 HEAPF32[gb + 151892 >> 2] = f3;
 f2 = Math_fround(f2 * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 16 | 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i5 = __ZnwjRK10MemLabelIdiPKci(20, i4, i5, gb + 1041912 | 0, 65) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = i5;
  STACKTOP = i6;
  return;
 } else {
  i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(20, i4, i5, i3, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i5;
  STACKTOP = i6;
  return;
 }
}

function __ZN13ComputeShader10FindKernelERKN9ShaderLab16FastPropertyNameE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i9 + 4 | 0;
 i5 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i2, 22, 0) | 0;
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 i5 = (HEAP32[i5 + 12 >> 2] | 0) - i4 | 0;
 i6 = (i5 | 0) / 96 | 0;
 L1 : do if (i5 | 0) {
  i5 = HEAP32[i3 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i4 + (i1 * 96 | 0) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i6 >>> 0) break L1;
  }
  STACKTOP = i9;
  return i1 | 0;
 } while (0);
 HEAP32[i7 >> 2] = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i3) | 0;
 __Z6FormatPKcz(i8, gb + 476816 | 0, i7);
 if (!i2) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8, 0, gb + 476838 | 0, 270, 1, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 i8 = -1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx3Scb5Scene7releaseEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 __ZN5physx2Sc5Scene7releaseEv(i8 + 16 | 0);
 HEAP32[i8 + 2508 >> 2] = 0;
 HEAP32[i8 + 2520 >> 2] = 0;
 HEAP32[i8 + 2532 >> 2] = 0;
 i5 = i8 + 2436 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i8 + 2452 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) + 2 | 0;
 i3 = i8 + 2444 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 <= i7 >>> 0) {
  HEAP32[i6 >> 2] = 0;
  i8 = i8 + 2456 | 0;
  HEAP32[i8 >> 2] = 0;
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i9;
  return;
 }
 i4 = i8 + 2440 | 0;
 do {
  i11 = i1 + -1 | 0;
  i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i11 << 2) >> 2] | 0;
  HEAP32[i3 >> 2] = i11;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i10);
  i1 = HEAP32[i3 >> 2] | 0;
 } while (i1 >>> 0 > i7 >>> 0);
 HEAP32[i6 >> 2] = 0;
 i11 = i8 + 2456 | 0;
 HEAP32[i11 >> 2] = 0;
 i11 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i11);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManager33markConnectedConstraintsForUpdateERNS0_7BodySimEPNS0_13ConstraintSimE(i2, i1, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i7 = i10;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = i3 + (i5 << 2) | 0;
 if ((i5 | 0) <= 0) {
  STACKTOP = i10;
  return;
 }
 i5 = i2 + 300 | 0;
 do {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP8[i1 + 20 >> 0] | 0) == 1) {
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if ((i1 | 0) != (i8 | 0)) if (__ZN5physx2Sc13ConstraintSim15needsProjectionEv(i1) | 0) {
    i2 = i1 + 116 | 0;
    if (!(HEAP8[i2 >> 0] & 1)) {
     HEAP32[i7 >> 2] = i1;
     i4 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i5, i7, i9) | 0;
     if (!(HEAP8[i9 >> 0] | 0)) HEAP32[i4 >> 2] = i1;
     HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 1;
    }
   }
  }
  i3 = i3 + 4 | 0;
 } while (i3 >>> 0 < i6 >>> 0);
 STACKTOP = i10;
 return;
}

function __ZN5physx16writeFabricPhaseERNS_14PxOutputStreamERKNS_18PxClothFabricPhaseE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 8 | 0;
 i1 = HEAP32[gb + 90072 >> 2] | 0;
 if (!i1) i4 = i6; else {
  i2 = gb + 90072 | 0;
  do {
   if ((HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if (HEAP8[i1 >> 0] | 0) {
    i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
    mftCall_iiii(i4 | 0, i6 | 0, i1 | 0, _strlen(i1) | 0) | 0;
   }
   i2 = i2 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i4 = i6;
 }
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i6 | 0, gb + 1086395 | 0, 1) | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i5;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 1084495 | 0, i7) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 i7 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 mftCall_iiii(i7 | 0, i6 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN2UIL17UnloadAllCanvasesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 8 | 0;
 i7 = i6;
 i2 = i6 + 16 | 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 67128 | 0, i2, 0);
 i5 = HEAP32[i5 >> 2] | 0;
 if (i5 | 0) {
  i1 = 0;
  do {
   i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 140 >> 2] | 0, i8 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 288 | 0;
 i6 = i8 + 8 | 0;
 i4 = i8;
 i9 = gb + 64016 | 0;
 i2 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i6, i7);
 __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue(i1, i6);
 i1 = 0;
 do {
  i3 = i6 + (i1 * 20 | 0) + 12 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = i6 + (i1 * 20 | 0) | 0;
   i2 = 0;
   do {
    HEAP32[i7 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 * 12 | 0) + 4 >> 2];
    __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_(i5, i7) | 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 14);
 __ZN18AwakeFromLoadQueueD2Ev(i6);
 STACKTOP = i8;
 return;
}

function __ZN14ParticleSystem17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 + 944 >> 2] | 0;
 if ((i3 | 0) < 0) return;
 i6 = HEAP32[gb + 1451700 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2 + (i3 << 2) | 0;
 HEAP32[(HEAP32[i5 >> 2] | 0) + 944 >> 2] = -1;
 HEAP32[i5 >> 2] = HEAP32[i2 + ((HEAP32[i6 + 12 >> 2] | 0) + -1 << 2) >> 2];
 i5 = HEAP32[gb + 1451700 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i2 + 944 >> 2] = i3;
 i1 = i5 + 12 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i6, i2 << 2, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i6;
  return;
 }
}

function __ZN13GUIStyleState8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = i2 + 36 | 0;
 HEAP8[i6 >> 0] = 0;
 i7 = i2 + 40 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (i8 | 0) if ((HEAP32[i8 + 16 >> 2] | 0) == 3) {
  i10 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i2, i8, gb + 1034892 | 0) | 0;
  HEAP32[i7 >> 2] = i10;
  i3 = i2 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = gb + 1034905;
  if (i10 | 0) {
   __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i2, 0);
   HEAP32[i5 >> 2] = 0;
   __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i5, gb + 1034719 | 0, 0, 0);
   HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
   HEAP8[i6 >> 0] = 1;
   i10 = i2 + 56 | 0;
   HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + -1;
  }
  HEAP32[i7 >> 2] = i8;
  HEAP32[i3 >> 2] = i4;
 }
 __ZN8JSONRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 4 | 0, gb + 1034921 | 0, 0, 0);
 STACKTOP = i9;
 return;
}

function __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 i6 = i5 + 32 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 36 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = i7 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 if (i4) i3 = HEAP32[i7 + 4 >> 2] | 0; else i3 = i1 & 255;
 if (i3 >>> 0 >= i2 >>> 0) if (i4) {
  HEAP8[(HEAP32[i7 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i7 + 4 >> 2] = i2;
  return;
 } else {
  HEAP8[i7 + i2 >> 0] = 0;
  HEAP8[i8 >> 0] = i2;
  return;
 }
 i5 = i2 - i3 | 0;
 if (!i5) return;
 if (i4) {
  i2 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0;
  i3 = HEAP32[i7 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i3 = i1 & 255;
 }
 if ((i2 - i3 | 0) >>> 0 < i5 >>> 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj(i7, i2, i5 - i2 + i3 | 0, i3, i3, 0, 0);
  i1 = HEAP8[i8 >> 0] | 0;
 }
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
 _memset(i2 + i3 | 0, i6 | 0, i5 | 0) | 0;
 i1 = i3 + i5 | 0;
 if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
 HEAP8[i2 + i1 >> 0] = 0;
 return;
}

function __ZNK2UI6Canvas20CalculateCanvasAlphaEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i5 = 0, f6 = f0;
 i3 = i4 + 344 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  f6 = Math_fround(1.0);
 } else {
  f1 = Math_fround(__ZNK2UI6Canvas20CalculateCanvasAlphaEv(i2));
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i5 = 0;
   f6 = f1;
  } else {
   i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
   f6 = f1;
  }
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 L5 : do if ((i2 | 0) == (i5 | 0)) f1 = Math_fround(1.0); else {
  f1 = Math_fround(1.0);
  while (1) {
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 186852 | 0) | 0;
   if (i3) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) {
    f1 = Math_fround(f1 * Math_fround(HEAPF32[i3 + 36 >> 2]));
    if (HEAP8[i3 + 42 >> 0] | 0) break;
   }
   i2 = HEAP32[i2 + 100 >> 2] | 0;
   if ((i2 | 0) == (i5 | 0)) break L5;
  }
  return Math_fround(f1);
 } while (0);
 f6 = Math_fround(f6 * f1);
 return Math_fround(f6);
}

function __ZNK21DownloadHandlerScript11GetProgressEv(i4) {
 i4 = i4 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 248 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) i3 = 0; else i3 = __Z29scripting_gchandle_get_targetj(i2) | 0;
 i2 = i4 + 28 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  f1 = Math_fround(0.0);
  STACKTOP = i8;
  return Math_fround(f1);
 }
 i9 = i2;
 i4 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i3, i7);
 HEAP32[i7 >> 2] = 0;
 i2 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i7, 0) | 0;
 if ((i2 | 0) == 0 | (HEAP32[i7 >> 2] | 0) != 0) f1 = Math_fround(0.0); else {
  f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i9 = f1 > Math_fround(0.0);
  f1 = i9 ? f1 : Math_fround(0.0);
  i9 = f1 > Math_fround(1.0);
  f1 = i9 ? Math_fround(1.0) : f1;
 }
 STACKTOP = i8;
 return Math_fround(f1);
}

function __ZN9JSONWrite10SetVersionEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 24 | 0;
 HEAP32[i6 >> 2] = i1;
 _snprintf(i5, 256, gb + 1084492 | 0, i6) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 i1 = i5;
 while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
 i2 = i6 + 16 | 0;
 i3 = i1 - i5 | 0;
 if (i3 >>> 0 < 12) {
  HEAP32[i2 >> 2] = 7340037;
  HEAP8[i6 + 11 >> 0] = 11 - i3;
  i1 = i6;
 } else {
  HEAP32[i2 >> 2] = 3145733;
  HEAP32[i6 + 4 >> 2] = i3;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 _memcpy(i1 | 0, i5 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_(i4, HEAP32[i4 + 56 >> 2] | 0, gb + 1034388 | 0, i6);
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKcNS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN4FMOD6SoundI7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 52 | 0;
 i3 = i4 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = HEAP32[i1 >> 2] | 0;
  _JS_Sound_Stop(HEAP32[i5 + 164 >> 2] | 0, 0.0);
  __ZN4FMOD8ChannelI11EndCallbackEv(i5);
  i1 = HEAP32[i3 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 320 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _JS_Sound_ReleaseInstance(i2 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i5 + 212 >> 2] | 0) + (HEAP32[i4 + 8 >> 2] << 2) >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP8[i1 + 16 >> 0] = 1;
 i3 = i1 + 24 | 0;
 i2 = i1 + 32 | 0;
 i1 = i1 + 28 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = i3;
 i4 = i5 + 192 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = i5 + 188;
 HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] = i3;
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 184 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i5 = i5 + 180 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return 0;
}

function __ZN4FMOD13ChannelGroupID2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = i4 + 76 | 0;
 i2 = i4 + 84 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i5 = i4 + 80 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 64 | 0;
 i2 = i4 + 72 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i6 = i4 + 68 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 52 | 0;
 i2 = i4 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i6 = i4 + 56 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 24 | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i6 = i4 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager8setColorEPKvRKN5physx8debugger8PvdColorE(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv(i1, i5) | 0;
 i6 = i2 + 2 | 0;
 i7 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i6 >> 0] = i7;
 HEAP8[i6 + 1 >> 0] = i7 >> 8;
 HEAP8[i6 + 2 >> 0] = i7 >> 16;
 HEAP8[i6 + 3 >> 0] = i7 >> 24;
 HEAP8[i2 + 6 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i5 | 0, i4 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function _gzerror(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if (!i4) {
  HEAP32[i1 >> 2] = -2;
  i5 = HEAP32[gb + 16328 + 16 >> 2] | 0;
  return i5 | 0;
 }
 i2 = i4 + 56 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 switch (i5 | 0) {
 case -1:
  {
   i1 = _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0;
   break;
  }
 case 0:
  {
   i5 = gb + 1576256 | 0;
   return i5 | 0;
  }
 default:
  i1 = HEAP32[i4 + 24 >> 2] | 0;
 }
 if (!i1) i3 = 8; else if (!(HEAP8[i1 >> 0] | 0)) i3 = 8;
 if ((i3 | 0) == 8) i1 = HEAP32[gb + 16328 + (2 - (HEAP32[i2 >> 2] | 0) << 2) >> 2] | 0;
 i5 = i4 + 80 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) _free(i2);
 i2 = HEAP32[i4 + 84 >> 2] | 0;
 i3 = _strlen(i2) | 0;
 i3 = i3 + 3 + (_strlen(i1) | 0) | 0;
 i4 = _malloc(i3) | 0;
 HEAP32[i5 >> 2] = i4;
 if (!i4) {
  i5 = HEAP32[gb + 16328 + 24 >> 2] | 0;
  return i5 | 0;
 } else {
  _strncpy(i4, i2, i3) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i4 = i3 - (_strlen(i2) | 0) | 0;
  _strncat(i2, gb + 1084762 | 0, i4) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  _strncat(i4, i1, i3 - (_strlen(i4) | 0) | 0) | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  return i5 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6resizeEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = (i2 - i4 | 0) / 28 | 0;
 if (i5 >>> 0 < i3 >>> 0) {
  __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE8__appendEj(i1, i3 - i5 | 0);
  return;
 }
 if (i5 >>> 0 <= i3 >>> 0) return;
 i5 = i4 + (i3 * 28 | 0) | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 do {
  i4 = i2 + -28 | 0;
  HEAP32[i6 >> 2] = i4;
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + -16 | 0, HEAP32[i2 + -12 >> 2] | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) {
   i3 = i2 + -24 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if ((i2 | 0) != (i1 | 0)) {
    do {
     i7 = i2 + -872 | 0;
     HEAP32[i3 >> 2] = i7;
     __ZN9ShaderLab14SerializedPassD2Ev(i7);
     i2 = HEAP32[i3 >> 2] | 0;
    } while ((i2 | 0) != (i1 | 0));
    i1 = HEAP32[i4 >> 2] | 0;
   }
   __ZdlPv(i1);
  }
  i2 = HEAP32[i6 >> 2] | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZNK4Mesh15ExtractTriangleEjPj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i1, i7);
 i1 = i2 * 3 | 0;
 i10 = HEAP32[i8 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i2;
 i4 = i10;
 if (i1 >>> 0 > i10 - i2 >> 2 >>> 0) i1 = 0; else {
  HEAP32[i5 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + (i1 + 1 << 2) >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i3 + (i1 + 2 << 2) >> 2];
  i1 = 1;
 }
 if (!i2) {
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i4 | 0) != (i3 | 0)) HEAP32[i8 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 i10 = HEAP32[i7 + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i10;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i6);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + 16 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i2 = i6 + 4 | 0;
 i1 = i4 + 4 | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i1;
 }
 i2 = i6 + 8 | 0;
 i4 = i1 + 4 | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 12 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPhNS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i6 + 12 | 0;
 i11 = HEAP32[i8 >> 2] | 0;
 i11 = (i11 & 2147483647 | 0) == 0 ? 1 : i11 << 1;
 if (!i11) i7 = 0; else {
  i7 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  i7 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i11 << 2 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i9 = i6 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i4 = i7 + (i1 << 2) | 0;
 i10 = i6 + 4 | 0;
 if ((i1 | 0) > 0) {
  i2 = i7;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   i1 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i7;
 HEAP32[i8 >> 2] = i11;
 HEAP32[i9 >> 2] = i1 + 1;
 return i7 + (i1 << 2) | 0;
}

function __ZN5physx2Sc5Scene13scheduleClothERNS_10PxBaseTaskEb(i7, i6, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i7 + 168 | 0;
 do if (HEAP32[i4 >> 2] | 0) {
  i1 = i7 + 160 | 0;
  i2 = i7 + 156 | 0;
  i3 = 0;
  while (1) {
   if (i3 >>> 0 >= (HEAP32[i1 >> 2] | 0) >>> 0) {
    i1 = 4;
    break;
   }
   if (!((__ZNK5physx2Sc9ClothCore13getClothFlagsEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) & 4)) i3 = i3 + 1 | 0; else {
    i1 = 6;
    break;
   }
  }
  if ((i1 | 0) == 4) {
   if (i5) break;
  } else if ((i1 | 0) == 6) if (!i5) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i6 = mftCall_iifi(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, +Math_fround(HEAPF32[i7 + 64 >> 2]), i6 | 0) | 0;
  HEAP32[i7 + 1564 >> 2] = 1;
  i5 = i7 + 1560 | 0;
  HEAP32[i5 >> 2] = i6;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  HEAP32[i7 + 1556 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
  i7 = i7 + 1548 | 0;
  return i7 | 0;
 } while (0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
 i7 = i6;
 return i7 | 0;
}

function __ZN18ProfilerConnection22GetObjectMemoryProfileEPKvjj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 8 | 0;
 if ((HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0) != (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 if (!i2) i1 = 1; else i1 = (HEAP32[i2 >> 2] | 0) != 0;
 HEAP32[i5 >> 2] = 0;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i5 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i9 = i4;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 __ZN20ObjectMemoryProfiler18TakeMemorySnapshotER13dynamic_arrayIiLj4EEb(i5, i1);
 i4 = __ZN16PlayerConnection3GetEv() | 0;
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i4, HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0, 41, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 2);
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i2);
  HEAP32[i5 >> 2] = 0;
 }
 STACKTOP = i6;
 return;
}

function __ZN15ArchiveReadFile4ReadEyyPvPy(i8, i9, i10, i3, i4, i5, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i11 = 0, i12 = 0;
 i6 = HEAP32[i8 + 8 >> 2] | 0;
 i2 = i6 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if (i2 >>> 0 < i10 >>> 0 | (i2 | 0) == (i10 | 0) & i1 >>> 0 < i9 >>> 0) {
  i10 = i7;
  HEAP32[i10 >> 2] = 0;
  HEAP32[i10 + 4 >> 2] = 0;
  i10 = 0;
  return i10 | 0;
 }
 i11 = _i64Subtract(i1 | 0, i2 | 0, i9 | 0, i10 | 0) | 0;
 i2 = getTempRet0() | 0;
 i1 = i2 >>> 0 > i4 >>> 0 | (i2 | 0) == (i4 | 0) & i11 >>> 0 > i3 >>> 0;
 i12 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = _i64Add(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i9 | 0, i10 | 0) | 0;
 i3 = __ZN20ArchiveStorageReader4ReadEyyPvPy(i12, i6, getTempRet0() | 0, i1 ? i3 : i11, i1 ? i4 : i2, i5, i7) | 0;
 if (i3) {
  i2 = i7;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 i10 = _i64Add(i1 | 0, i2 | 0, i9 | 0, i10 | 0) | 0;
 i11 = getTempRet0() | 0;
 i12 = i8 + 16 | 0;
 HEAP32[i12 >> 2] = i10;
 HEAP32[i12 + 4 >> 2] = i11;
 i12 = i3;
 return i12 | 0;
}

function __ZN10GpuProgram20ApplyValueParametersI21GLESGpuProgramApplierEEPKhRT_RK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EES3_(i6, i7, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i2 + 4 | 0;
 i3 = HEAP16[i2 >> 1] | 0;
 if (i3 << 16 >> 16 == -1) {
  i7 = i1;
  return i7 | 0;
 }
 do {
  i5 = HEAP16[i2 + 2 >> 1] | 0;
  i2 = i3 << 16 >> 16;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + (i2 * 20 | 0) | 0;
  do if (!(HEAP8[i3 + (i2 * 20 | 0) + 18 >> 0] & 1)) if ((HEAP8[i3 + (i2 * 20 | 0) + 17 >> 0] | 0) == 1) {
   __ZN21GLESGpuProgramApplier10ApplyFloatERKN20GpuProgramParameters14ValueParameterEPKft(i6, i4, i1, i5);
   i2 = i1 + ((i5 & 65535) << 2) | 0;
   break;
  } else {
   __ZN21GLESGpuProgramApplier11ApplyVectorERKN20GpuProgramParameters14ValueParameterEPK8Vector4ft(i6, i4, i1, i5);
   i2 = i1 + ((i5 & 65535) << 4) | 0;
   break;
  } else {
   __ZN21GLESGpuProgramApplier11ApplyMatrixERKN20GpuProgramParameters14ValueParameterEPK10Matrix4x4ft(i6, i4, i1, i5);
   i2 = i1 + ((i5 & 65535) << 6) | 0;
  } while (0);
  i1 = i2 + 4 | 0;
  i3 = HEAP16[i2 >> 1] | 0;
 } while (i3 << 16 >> 16 != -1);
 return i1 | 0;
}

function __ZL27GetDestRenderTargetSurfacesP13RenderTextureR12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = (i1 | 0) != 0;
 if (i4) if (!(__ZN13RenderTexture6CreateEv(i1) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[gb + 1110920 >> 2] | 0;
 if (i4 & (HEAP8[gb + 1544216 >> 0] | 0) != 0 & (i5 | 0) != 0 & (HEAP32[gb + 1110924 >> 2] | 0) == (i1 | 0)) if ((HEAP32[i1 + 80 >> 2] | 0) == (HEAP32[i5 + 80 >> 2] | 0)) if ((HEAP32[i1 + 84 >> 2] | 0) == (HEAP32[i5 + 84 >> 2] | 0)) {
  __ZN13RenderTexture6CreateEv(i5) | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 128 >> 2];
  HEAP32[i3 >> 2] = HEAP32[(HEAP32[gb + 1110920 >> 2] | 0) + 136 >> 2];
  i5 = 1;
  return i5 | 0;
 }
 if (i4) {
  HEAP32[i2 >> 2] = HEAP32[i1 + 128 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i1 + 136 >> 2];
  i5 = 1;
  return i5 | 0;
 } else {
  i5 = __Z12GetGfxDevicev() | 0;
  HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 368 >> 2] | 0, i5 | 0) | 0;
  i5 = __Z12GetGfxDevicev() | 0;
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 372 >> 2] | 0, i5 | 0) | 0;
  i5 = 1;
  return i5 | 0;
 }
 return 0;
}

function __Z22GetShaderGlobalTextureN9ShaderLab16FastPropertyNameE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i7 = i9;
 i5 = HEAP32[gb + 1166248 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i5 + 56 >> 2] | 0;
 i4 = HEAP32[i5 + 60 >> 2] | 0;
 if ((i1 | 0) >= (i4 | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 0;
   i8 = 8;
   break;
  }
 }
 if ((i8 | 0) == 8) {
  STACKTOP = i9;
  return i1 | 0;
 }
 if ((i1 | 0) <= -1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[(HEAP32[i5 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i5 + 88 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) >> 2] | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i8 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN7Texture15FindTextureByIDE9TextureID(i6) | 0) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function _UNITY_FT_Create_Class_ft_raster1_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 60, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _UNITY_ft_raster1_renderer_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 2;
  HEAP32[i5 + 4 >> 2] = 64;
  HEAP32[i5 + 8 >> 2] = gb + 947106;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2629;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = 0;
  HEAP32[i5 + 36 >> 2] = 1869968492;
  HEAP32[i5 + 40 >> 2] = fb + 180;
  HEAP32[i5 + 44 >> 2] = fb + 181;
  HEAP32[i5 + 48 >> 2] = fb + 962;
  HEAP32[i5 + 52 >> 2] = fb + 440;
  HEAP32[i5 + 56 >> 2] = (HEAP32[i1 + 208 >> 2] | 0) + 4;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _tt_driver_class_pic_init(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i5 >> 2] | 0, 36, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = i3;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i4 = i5 + 220 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = _UNITY_FT_Create_Class_tt_services(i5, i3) | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  _UNITY_FT_Init_Class_tt_service_gx_multi_masters(i3 + 4 | 0);
  _UNITY_FT_Init_Class_tt_service_truetype_glyf(i3 + 24 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_tt_services(i5, i1);
 HEAP32[i3 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i3);
 HEAP32[i4 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i7, i8, i3, i9, i10, i11, i12, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i13 = 0, i14 = 0, f15 = f0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i14 + 4 | 0;
 i13 = i14;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 if (i2) {
  i5 = (i9 | 0) == 2 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0) < 2;
  i1 = i5 ? 1 : i1;
 }
 i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 i4 = HEAP32[i7 >> 2] | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i4 | 0) == 0 | (i3 | 0) == 0) i2 = 1; else {
  i2 = HEAP32[gb + 56192 >> 2] | 0;
  if ((i3 | 0) >= (i2 | 0)) {
   i2 = HEAP32[gb + 56196 >> 2] | 0;
   i2 = (i3 | 0) > (i2 | 0) ? i2 : i3;
  }
 }
 f15 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 mftCall_viiiiiifiii(i5 | 0, i8 | 0, i6 | 0, i9 | 0, i4 | 0, i1 | 0, i2 | 0, +f15, i10 | 0, i11 | 0, i12 | 0);
 STACKTOP = i14;
 return;
}

function __ZNK11MinMaxCurve10FindMinMaxEv(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8;
 HEAPF32[i3 >> 2] = Math_fround(inf);
 i5 = i3 + 4 | 0;
 HEAPF32[i5 >> 2] = Math_fround(-inf);
 __ZL25CalculateCurveRangesValueRKN4math7_float2ERK17AnimationCurveTplIfE(i4, i3, i7 + 88 | 0);
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i5 >> 2] = i1;
 if ((HEAP16[i7 + 84 >> 1] & -2) << 16 >> 16 == 2) {
  __ZL25CalculateCurveRangesValueRKN4math7_float2ERK17AnimationCurveTplIfE(i4, i3, i7 + 176 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
 }
 f10 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f9 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f11 = Math_fround(HEAPF32[i7 + 80 >> 2]);
 f9 = Math_fround(f11 * f9);
 HEAPF32[i6 >> 2] = Math_fround(f11 * f10);
 HEAPF32[i6 + 4 >> 2] = f9;
 STACKTOP = i8;
 return;
}

function __ZN5audio5mixer20GetGroupNameFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (!i6) {
  i10 = gb + 1576256 | 0;
  return i10 | 0;
 }
 i7 = i3 + 8 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i10 = 0;
 while (1) {
  if ((HEAP32[i7 + (i10 << 4) >> 2] | 0) == (i8 | 0)) if ((HEAP32[i7 + (i10 << 4) + 4 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i7 + (i10 << 4) + 8 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i7 + (i10 << 4) + 12 >> 2] | 0) == (i2 | 0)) break;
  i1 = i10 + 1 | 0;
  if (i1 >>> 0 < i6 >>> 0) i10 = i1; else {
   i1 = gb + 1576256 | 0;
   i9 = 11;
   break;
  }
 }
 if ((i9 | 0) == 11) return i1 | 0;
 if ((i10 | 0) == -1) {
  i10 = gb + 1576256 | 0;
  return i10 | 0;
 }
 i1 = i3 + 48 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 if ((i10 | 0) > 0) i2 = 0; else {
  i10 = i1;
  return i10 | 0;
 }
 do {
  i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i10 | 0));
 return i1 | 0;
}

function __ZN28LightProbeProxyVolumeContext8CopyFromERKS_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) * 100 | 0;
 i2 = (i1 | 0) / 100 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 * 100 | 0;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i4;
  i5 = i4;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 * 100 | 0;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 100 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i4;
  i5 = i4;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 * 100 | 0;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 }
}

function __ZN14NavMeshManager18UpdateOffMeshLinksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 i5 = i1 + 80 | 0;
 i4 = i1 + 92 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 if ((HEAP16[gb + 1459248 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459248 | 0, i2);
  i2 = gb + 1459248 | 0;
 } else i2 = 0;
 i3 = __Z14IsWorldPlayingv() | 0;
 i1 = (HEAP32[i4 >> 2] | 0) != 0;
 if (i3) {
  if (i1) {
   i1 = 0;
   do {
    __ZN11OffMeshLink20UpdateMovedPositionsEv(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
 } else if (i1) {
  i1 = 0;
  do {
   __ZN11OffMeshLink15UpdatePositionsEv(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN13AudioListener7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(144, i1, 16, gb + 1048932 | 0, 0, gb + 873217 | 0, 17) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 171280 + 8;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4 + 68 | 0) | 0;
 HEAP32[i4 + 132 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 HEAP32[i4 + 140 >> 2] = i4;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z32Animation_CUSTOM_CrossFadeQueuedP12Il2CppObjectP12Il2CppStringfii(i2, i1, f3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 12 | 0;
 i7 = i8;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i8 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i6);
  i6 = __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii(i1, i7, f3, i4, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i7 = __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i6, HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 4 >> 2] | 0) | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __Z10FindStringRKNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEEj(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3;
  i2 = i1;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i4 = i1;
    break;
   } else i4 = i1;
  }
  if ((i4 | 0) != (i3 | 0)) if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 <= i5 >>> 0) {
   i1 = i4 + 20 | 0;
   i2 = HEAP8[i1 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i4 + 24 >> 2] | 0;
   } else {
    i3 = i1;
    i1 = i2 & 255;
   };
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i1);
   return;
  }
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
 return;
}

function __ZNSt3__210__time_putC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 i4 = _newlocale(2147483647, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0) | 0;
 HEAP32[i1 >> 2] = i4;
 if (i4 | 0) {
  STACKTOP = i2;
  return;
 }
 i4 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1081765 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i6 = 7;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i4 | 0, i5 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i2 = 1; else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
   __THREW__ = 0;
   i2 = 0;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  if (i2) i6 = 7;
 }
 if ((i6 | 0) == 7) ___cxa_free_exception(i4 | 0);
 ___resumeException(i1 | 0);
}

function __ZNSt3__210__time_getC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 i4 = _newlocale(2147483647, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0) | 0;
 HEAP32[i1 >> 2] = i4;
 if (i4 | 0) {
  STACKTOP = i2;
  return;
 }
 i4 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1049 | 0, i5 | 0, gb + 1081634 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  i6 = 7;
 } else {
  __THREW__ = 0;
  invoke_vii(fb + 4518 | 0, i4 | 0, i5 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) i2 = 1; else {
   __THREW__ = 0;
   invoke_viii(fb + 1035 | 0, i4 | 0, gb + 13128 | 0, fb + 3224 | 0);
   __THREW__ = 0;
   i2 = 0;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  if (i2) i6 = 7;
 }
 if ((i6 | 0) == 7) ___cxa_free_exception(i4 | 0);
 ___resumeException(i1 | 0);
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwjj(i3, i10, i1, i4) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + (i2 << 2) | 0;
  i8 = i10 + (i4 << 2) | 0;
  i1 = i3 + (i1 << 2) | 0;
  i7 = i9;
  i2 = i4 << 2 >> 2;
  L8 : do if (i2) if ((i7 - i1 >> 2 | 0) < (i2 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i2 << 2) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L8;
     }
     if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i10 >> 2] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 4 | 0;
    }
    do {
     i2 = i2 + 4 | 0;
     if ((i2 | 0) == (i8 | 0)) break L8;
     i4 = i4 + 4 | 0;
    } while ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 >> 2] | 0));
    i1 = i5 + 4 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 >> 2;
 }
 return i1 | 0;
}

function __ZN5physx3Ext21InertiaTensorComputer6setBoxERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 i9 = f8 != Math_fround(0.0);
 f6 = i9 ? f8 : Math_fround(1.0);
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i9 = f7 != Math_fround(0.0);
 f4 = Math_fround(f7 * f6);
 f6 = i9 ? f4 : f6;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f4 != Math_fround(0.0);
 f3 = Math_fround(f4 * f6);
 f6 = Math_fround((i1 ? f3 : f6) * Math_fround(8.0));
 f3 = Math_fround(f6 * Math_fround(.333333343));
 f8 = Math_fround(f8 * f8);
 f7 = Math_fround(f7 * f7);
 f4 = Math_fround(f4 * f4);
 f5 = Math_fround(Math_fround(f7 + f4) * f3);
 f4 = Math_fround(Math_fround(f8 + f4) * f3);
 f3 = Math_fround(Math_fround(f8 + f7) * f3);
 HEAPF32[i2 + 48 >> 2] = f6;
 HEAPF32[i2 >> 2] = f5;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i2 + 16 >> 2] = f4;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = f3;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 return;
}

function __ZN2UI6Canvas18RemoveNestedCanvasEPS0_(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i6 + 428 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i2;
 i5 = HEAP32[i6 + 424 >> 2] | 0;
 while (1) {
  if ((i5 | 0) == (i2 | 0)) {
   i3 = 11;
   break;
  }
  i4 = i5 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) == (i8 | 0)) break; else i5 = i4;
 }
 if ((i3 | 0) == 11) {
  STACKTOP = i10;
  return;
 }
 i1 = i1 - i4 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 }
 i1 = i5 + (i3 << 2) | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i7 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 i1 = i6 + 224 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4;
 i1 = HEAP32[gb + 1467948 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 if (i8 | 0) __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i1 + 12 | 0, i9) | 0;
 STACKTOP = i10;
 return;
}

function __ZN2UI6Canvas16UpdateBatchOrderEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 4 | 0;
 i3 = i10;
 i9 = i7 + 224 | 0;
 if (!(HEAP16[i9 >> 1] & 4)) {
  STACKTOP = i10;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 i4 = i7 + 332 | 0;
 __ZN2UI15ClearCanvasDataER8JobFenceRNS_10CanvasDataE(i4, i7 + 112 | 0);
 i5 = i7 + 424 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 428 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  HEAPF32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] = Math_fround(-1.0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN2UIL20AddRenderersToCanvasER8JobFencePK9TransformPNS_6CanvasERi(i4, __ZNK10GameObject23QueryComponentTransformEv(HEAP32[i7 + 28 >> 2] | 0) | 0, i7, i3);
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  HEAP32[i8 >> 2] = fb + 1104;
  __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i2, i1, i8);
 }
 __ZN2UI6Canvas18UpdateEventIndexesEv(i7);
 HEAP16[i9 >> 1] = (HEAPU16[i9 >> 1] | 0) & 65529 | 2;
 STACKTOP = i10;
 return;
}

function __ZN17Physics2DSettings23SetMaxAngularCorrectionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 f2 = i3 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 56 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f2 = Math_fround(f2 * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function _UNITY_FT_Create_Class_ft_smooth_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 60, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _UNITY_ft_smooth_renderer_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 2;
  HEAP32[i5 + 4 >> 2] = 64;
  HEAP32[i5 + 8 >> 2] = gb + 947099;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = fb + 2630;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = 0;
  HEAP32[i5 + 36 >> 2] = 1869968492;
  HEAP32[i5 + 40 >> 2] = fb + 182;
  HEAP32[i5 + 44 >> 2] = fb + 183;
  HEAP32[i5 + 48 >> 2] = fb + 963;
  HEAP32[i5 + 52 >> 2] = fb + 441;
  HEAP32[i5 + 56 >> 2] = (HEAP32[i1 + 216 >> 2] | 0) + 4;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN5physx11HullLibrary18CreateTriangleMeshERNS_10HullResultEPNS_27ConvexHullTriangleInterfaceE(i1, i2, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i9 | 0) != 0 & (i1 | 0) != 0 & (i7 | 0) != 0) {
  i8 = 0;
  i6 = i1;
 } else {
  i10 = 1;
  return i10 | 0;
 }
 while (1) {
  i4 = HEAP32[i6 >> 2] | 0;
  i1 = i6 + 16 | 0;
  i5 = i9 + ((HEAP32[i6 + 4 >> 2] | 0) * 3 << 2) | 0;
  i3 = i9 + ((HEAP32[i6 + 12 >> 2] | 0) * 3 << 2) | 0;
  __ZN5physxL17AddConvexTriangleEPNS_27ConvexHullTriangleInterfaceEPKfS3_S3_(i10, i5, i9 + ((HEAP32[i6 + 8 >> 2] | 0) * 3 << 2) | 0, i3);
  i2 = i4 + -3 | 0;
  if (i2) {
   while (1) {
    i11 = i3;
    i3 = i9 + ((HEAP32[i1 >> 2] | 0) * 3 << 2) | 0;
    __ZN5physxL17AddConvexTriangleEPNS_27ConvexHullTriangleInterfaceEPKfS3_S3_(i10, i5, i11, i3);
    i2 = i2 + -1 | 0;
    if (!i2) break; else i1 = i1 + 4 | 0;
   }
   i1 = i6 + (i4 + 1 << 2) | 0;
  }
  i8 = i8 + 1 | 0;
  if ((i8 | 0) == (i7 | 0)) {
   i1 = 0;
   break;
  } else i6 = i1;
 }
 return i1 | 0;
}

function __ZN25PathNamePersistentManager30PathIDToFileIdentifierInternalEi(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i4 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i5 = HEAP32[i1 + 208 >> 2] | 0;
 i3 = i5 + (i2 * 12 | 0) | 0;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 i6 = i1 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
 i1 = i6 ? HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0 : i1 & 255;
 i2 = i4 + 11 | 0;
 if (i1 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, 10, i1 + -10 | 0, 0, 0, 0, i1, i3);
  return;
 }
 if (i1 | 0) _memmove(i4 | 0, i3 | 0, i1 | 0) | 0;
 HEAP8[i4 + i1 >> 0] = 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP32[i4 + 4 >> 2] = i1;
  return;
 } else {
  HEAP8[i2 >> 0] = i1;
  return;
 }
}

function __ZN16BaseVideoTexture17MainThreadCleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 4 | 0;
 i4 = i7;
 i1 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 + 48 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 mftCall_vii(i5 | 0, i1 | 0, i2 | 0);
 i2 = HEAP32[gb + 1459952 + 4 >> 2] | 0;
 i1 = i2;
 i5 = HEAP32[gb + 1459952 >> 2] | 0;
 while (1) {
  if ((i5 | 0) == (i2 | 0)) {
   i3 = 8;
   break;
  }
  i4 = i5 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) == (i6 | 0)) break; else i5 = i4;
 }
 if ((i3 | 0) == 8) {
  __ZN7Texture17MainThreadCleanupEv(i6);
  STACKTOP = i7;
  return;
 }
 i1 = i1 - i4 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
  i2 = HEAP32[gb + 1459952 + 4 >> 2] | 0;
 }
 i1 = i5 + (i3 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i6);
  STACKTOP = i7;
  return;
 }
 HEAP32[gb + 1459952 + 4 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZN7Texture17MainThreadCleanupEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 590111 | 0, 0, 1) | 0;
 HEAP32[i4 >> 2] = __ZN13MonoBehaviour18TransferEngineDataI14SafeBinaryReadEE4PPtrI10MonoScriptERT_(i1, i2) | 0;
 __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i1, i4, 0);
 i4 = i1 + 20 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  __ZN14SafeBinaryRead20OverrideRootTypeNameEPKc(i2, __Z24scripting_class_get_nameP11Il2CppClass(__ZNK13MonoBehaviour8GetClassEv(i1) | 0) | 0);
  i6 = HEAP32[i4 >> 2] | 0;
  i4 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
  __Z23TransferScriptingObjectI14SafeBinaryReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i6, i4, HEAP32[i1 + 56 >> 2] | 0);
 }
 __ZN14SafeBinaryRead11EndTransferEv(i2);
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return;
}

function __ZN12GUIClipState9SetMatrixER10InputEventRK10Matrix4x4f(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i3 = i7 + 12 | 0;
 i4 = i3;
 i5 = i1;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 if (!(__Z20InvertMatrix4x4_FullPKfPf(i1, i2) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017878 | 0, 0, gb + 1017283 | 0, 258, 1, 0, 0, 0);
  STACKTOP = i9;
  return;
 }
 i4 = i3;
 i5 = i1;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i4 = i7 + 76 | 0;
 i5 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 if ((HEAP32[i7 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i9;
  return;
 }
 __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i7, i8, i1 + -56 | 0);
 STACKTOP = i9;
 return;
}

function __ZL17MouseWheelHandleriPK20EmscriptenWheelEventPv(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i10 = __Z15GetInputManagerv() | 0;
 f4 = Math_fround(__Z19NormalizeWheelInputf(Math_fround(+HEAPF64[i3 + 72 >> 3])));
 f5 = Math_fround(__Z19NormalizeWheelInputf(Math_fround(+HEAPF64[i3 + 80 >> 3])));
 i8 = i10 + 108 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i6 = i10 + 112 | 0;
 f9 = Math_fround(f4 + f9);
 f7 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f5);
 HEAP32[i10 + 100 >> 2] = HEAP32[i10 + 100 >> 2];
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i6 >> 2] = f7;
 HEAP32[i2 + 44 >> 2] = 0;
 __ZN10InputEvent4InitEi(i2, 0);
 HEAP32[i2 >> 2] = 6;
 HEAPF32[i2 + 12 >> 2] = f4;
 HEAPF32[i2 + 16 >> 2] = f5;
 f5 = Math_fround(HEAP32[i3 + 60 >> 2] | 0);
 f4 = Math_fround(HEAP32[i3 + 64 >> 2] | 0);
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f4;
 __ZN15GUIEventManager10QueueEventERK10InputEvent(__Z18GetGUIEventManagerv() | 0, i2);
 __ZN10InputEventD2Ev(i2);
 STACKTOP = i1;
 return 1;
}

function __Z62DownloadHandler_CUSTOM_INTERNAL_CALL_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringRK7Hash128j(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 12 | 0;
 i7 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i8, i1);
 i4 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63808 | 0, 16, gb + 1027567 | 0, 110) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i7, i8);
 __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK7Hash128j(i4, i7, i2, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 HEAP32[i5 + 8 >> 2] = i4;
 i1 = i4 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i5) | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i5 | 0);
 STACKTOP = i6;
 return;
}

function __Z38UploadHandler_CUSTOM_InternalCreateRawP12Il2CppObjectP11Il2CppArray(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 do if (!i1) {
  i4 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63808 | 0, 16, gb + 1029102 | 0, 44) | 0;
  __ZN16UploadHandlerRawC2Ev(i4);
 } else {
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
  i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
  if ((i1 | 0) < 1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1029052 | 0, i3); else {
   i4 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63808 | 0, 16, gb + 1029102 | 0, 41) | 0;
   __ZN16UploadHandlerRawC2EPKvj(i4, i2, i1);
   break;
  }
 } while (0);
 HEAP32[i5 + 8 >> 2] = i4;
 i1 = i4 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i5) | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i5 | 0);
 STACKTOP = i6;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh7GetMeshEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 i1 = i1 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 945690 | 0, 48) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i2, i4, 0);
 __Z19pop_allocation_rootv();
 i4 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0;
 HEAP32[i1 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0);
 i4 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 4);
 i4 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, 61);
 i4 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN17Physics2DSettings22SetMaxTranslationSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.0000999999974) : f2;
 HEAPF32[i1 + 60 >> 2] = f2;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f3;
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN16PlayerConnection15PollConnectModeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 if (!(HEAP8[i3 + 141 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 if (HEAP32[i3 + 96 >> 2] | 0) {
  STACKTOP = i7;
  return;
 }
 i1 = i3 + 224 | 0;
 i4 = i1 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
 i2 = __ZN6Socket7ConnectEPKctlbb(i2, -10538, 4e3, 0, 1) | 0;
 if ((i2 | 0) != -1) {
  HEAP32[gb + 1163124 >> 2] = (HEAP32[gb + 1163124 >> 2] | 0) + 1;
  __ZN17GeneralConnection18RegisterConnectionEji(i3, HEAP32[gb + 1163124 >> 2] | 0, i2);
  STACKTOP = i7;
  return;
 }
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = 54998;
 __Z6FormatPKcz(i5, gb + 460283 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 459789 | 0, 441, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i7;
 return;
}

function __Z59AnimatorControllerPlayable_CUSTOM_GetParameterCountInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 16 | 0;
 i8 = i9;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i8 = -1;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN26AnimatorControllerPlayable13GetParametersEv(i8, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0);
 i5 = i8 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i7 = (i2 - i1 | 0) / 36 | 0;
 i4 = i1;
 if (!i1) {
  i8 = i7;
  STACKTOP = i9;
  return i8 | 0;
 }
 if ((i2 | 0) != (i4 | 0)) {
  i3 = i6 + 4 | 0;
  while (1) {
   i1 = i2 + -36 | 0;
   HEAP32[i5 >> 2] = i1;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i1 = HEAP32[i1 >> 2] | 0;
    i2 = HEAP32[i2 + -24 >> 2] | 0;
    HEAP32[i6 >> 2] = 66;
    HEAP32[i3 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZdlPv(i1);
 i8 = i7;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZZN11Rigidbody2D15InitializeClassEvEN28FunctorImpl_199kLayerChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1457872 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457872 | 0, i1);
  i4 = gb + 1457872 | 0;
 } else i4 = 0;
 i3 = HEAP32[i3 + 92 >> 2] | 0;
 do if (i3 | 0) {
  i1 = i3 + 4 | 0;
  i2 = HEAPU16[i1 >> 1] | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   HEAP16[i1 >> 1] = i2 & 65533;
   HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
   i3 = i3 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   break;
  }
  if (!(i2 & 2)) {
   HEAP16[i1 >> 1] = i2 | 2;
   HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  }
 } while (0);
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx28PxProfileMemoryEventRecorder14createRecorderEPNS_12PxFoundationE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = (i4 | 0) == 0;
 if (i3) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 60, gb + 766896 | 0, gb + 740601 | 0, 165) | 0;
 HEAP32[i2 >> 2] = gb + 147700 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 147732 + 8;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 if (!i3) HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = i1;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i2 + 40 >> 2] = Math_fround(.75);
 HEAP32[i2 + 44 >> 2] = -1;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj(i4, 64);
 HEAP32[i2 + 56 >> 2] = 0;
 return i2 | 0;
}

function __ZN17PersistentManager24GetTypeFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i2, i1, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(__ZNK14SerializedFile11IsAvailableEx(i1, i4, i5) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 L10 : do if (i2 | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[i2 + 12 >> 2] | 0;
  i2 = i1 + (i6 << 3) | 0;
  L12 : do if (i6) while (1) {
   i6 = i1;
   if ((HEAP32[i6 >> 2] | 0) == (i4 | 0) ? (HEAP32[i6 + 4 >> 2] | 0) == (i5 | 0) : 0) break L12;
   i1 = i1 + 8 | 0;
   if ((i1 | 0) == (i2 | 0)) break L10;
  } while (0);
  if ((i1 | 0) != (i2 | 0)) {
   i6 = 0;
   return i6 | 0;
  }
 } while (0);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = __ZNK14SerializedFile7GetTypeEx(i1, i4, i5) | 0;
 return i6 | 0;
}

function __ZN15NavMeshObstacle16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 40 | 0;
 if ((HEAP32[i3 >> 2] | 0) != 1) HEAP32[i3 >> 2] = 0;
 i8 = i1 + 56 | 0;
 f9 = Math_fround(HEAPF32[i8 >> 2]);
 i5 = f9 > Math_fround(9.99999974e-06);
 f9 = i5 ? f9 : Math_fround(9.99999974e-06);
 i5 = i1 + 60 | 0;
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = f7 > Math_fround(9.99999974e-06);
 f7 = i3 ? f7 : Math_fround(9.99999974e-06);
 i3 = i1 + 64 | 0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 i10 = f6 > Math_fround(9.99999974e-06);
 f6 = i10 ? f6 : Math_fround(9.99999974e-06);
 HEAPF32[i8 >> 2] = f9;
 HEAPF32[i5 >> 2] = f7;
 HEAPF32[i3 >> 2] = f6;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i1 + 72 | 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i3 : i2) >> 2];
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i3 = i1 + 76 | 0;
 i1 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i1 ? i3 : i2) >> 2];
 STACKTOP = i4;
 return;
}

function __ZN14FileCacherRead12RequestBlockEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i5 + 28 >> 2] | 0) == (i6 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if ((HEAP32[i5 + 40 >> 2] | 0) == (i6 | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 i1 = (HEAP32[i5 + 112 >> 2] | 0) == 1 ? ((HEAP32[i5 + 72 >> 2] | 0) == 1) << 31 >> 31 : 1;
 if ((i1 | 0) == -1) i1 = 0;
 i4 = i5 + 48 + (i1 * 40 | 0) | 0;
 i2 = Math_imul(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0) | 0, i6) | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 if (i3 >>> 0 <= i2 >>> 0) {
  i6 = i1;
  return i6 | 0;
 }
 i3 = i3 - i2 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i5 + 12 | 0) | 0;
 HEAP32[i5 + 48 + (i1 * 40 | 0) + 12 >> 2] = HEAP32[i5 + 24 + (i1 * 12 | 0) >> 2];
 HEAP32[i5 + 48 + (i1 * 40 | 0) + 16 >> 2] = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 HEAP32[i5 + 48 + (i1 * 40 | 0) + 20 >> 2] = Math_imul(HEAP32[i5 + 4 >> 2] | 0, i6) | 0;
 HEAP32[i5 + 24 + (i1 * 12 | 0) + 4 >> 2] = i6;
 __Z16AsyncReadRequestP16AsyncReadCommand(i4);
 i6 = i1;
 return i6 | 0;
}

function __ZN12WheelJoint2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN15AnchoredJoint2D16CheckConsistencyEv(i1);
 i3 = i1 + 108 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e6) : f2;
 i3 = i1 + 112 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 104 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __Z48AnimatorControllerPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(160, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN26AnimatorControllerPlayableC2E18DirectorPlayerType(i3, 0);
 __ZN8Playable6HandleEv(i1, i3);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 i3 = HEAP32[i3 + 20 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (i5) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 if (i5) {
  i5 = 0;
  __ZN17AnimationPlayable8OwnAssetEP11NamedObject(i1, i5);
  STACKTOP = i6;
  return;
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 __ZN17AnimationPlayable8OwnAssetEP11NamedObject(i1, i5);
 STACKTOP = i6;
 return;
}

function __Z31CullBoundingSpheresWithoutUmbraRK17CullingParametersPK8Vector4fjjPhhb(i2, i9, i3, i10, i11, i12, i1) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0, i17 = 0;
 i15 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i15;
 i14 = i2 + 352 | 0;
 i5 = i1 ? i12 & 255 ^ 255 : 255;
 if (i3 >>> 0 >= i10 >>> 0) {
  STACKTOP = i15;
  return;
 }
 i6 = i13 + 4 | 0;
 i7 = i13 + 8 | 0;
 i8 = i13 + 12 | 0;
 i4 = i2 + 188 | 0;
 do {
  i17 = i9 + (i3 << 4) | 0;
  i1 = HEAP32[i17 + 4 >> 2] | 0;
  i2 = HEAP32[i17 + 8 >> 2] | 0;
  i16 = HEAP32[i17 + 12 >> 2] | 0;
  HEAP32[i13 >> 2] = HEAP32[i17 >> 2];
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i2;
  HEAP32[i8 >> 2] = i16;
  i16 = __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i(i13, i14, HEAP32[i4 >> 2] | 0) | 0;
  i2 = i11 + i3 | 0;
  i1 = HEAP8[i2 >> 0] | 0;
  if (i16) i1 = i1 | i12; else i1 = i1 & 255 & i5 & 255;
  HEAP8[i2 >> 0] = i1;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i10 | 0));
 STACKTOP = i15;
 return;
}

function __Z19FindCommandsInCachePK15MonoScriptCacheRK24TransferRequestSignatureRb(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = i1 + 44 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L4 : do if (!i1) {
  while (1) {
   i1 = __Z26BuildSerializationCacheForP11Il2CppClassRb(HEAP32[i2 >> 2] | 0, i3) | 0;
   if (!(HEAP32[i4 >> 2] | 0)) break;
   if (i1 | 0) __ZN23CachedSerializationDataD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63496 | 0);
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) {
    i3 = i1;
    break L4;
   }
  }
  HEAP32[i4 >> 2] = i1;
  i3 = i1;
 } else i3 = i1; while (0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i4) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = HEAP8[i6 >> 0] | 0;
 i2 = HEAP8[i6 + 1 >> 0] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP8[i3 + 8 + (i1 * 24 | 0) >> 0] | 0) == i5 << 24 >> 24) if ((HEAP8[i3 + 8 + (i1 * 24 | 0) + 1 >> 0] | 0) == i2 << 24 >> 24) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i7 = 14;
   break;
  }
 }
 if ((i7 | 0) == 14) return i1 | 0;
 i7 = i3 + 8 + (i1 * 24 | 0) + 4 | 0;
 return i7 | 0;
}

function __Z14DecompressDXT5iiiPKjPj(i4, i5, i9, i10, i11) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0, i16 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i14;
 HEAP8[i12 + 3 >> 0] = 0;
 HEAP8[i12 + 2 >> 0] = -1;
 HEAP8[i12 + 1 >> 0] = -1;
 HEAP8[i12 >> 0] = -1;
 i13 = HEAP32[i12 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  STACKTOP = i14;
  return;
 }
 i6 = i4 << 2;
 i7 = i9 << 2;
 if ((i4 | 0) > 0) i1 = 0; else {
  STACKTOP = i14;
  return;
 }
 do {
  i8 = Math_imul(i7, i1) | 0;
  i2 = 0;
  i3 = i10 + ((Math_imul(i6, i1) | 0) << 2) | 0;
  while (1) {
   i16 = i3 + 8 | 0;
   __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i16, i12);
   i15 = i11 + (i2 << 2 << 2) + (i8 << 2) | 0;
   __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i15, i16, i9, i12);
   __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i15, i3, i9, i13, 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i4 | 0)) break; else i3 = i3 + 16 | 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 STACKTOP = i14;
 return;
}

function _LzmaDec_AllocateProbs(i9, i2, i1, i10) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 if (i1 >>> 0 < 5) {
  i11 = 4;
  return i11 | 0;
 }
 i8 = (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0) | (HEAPU8[i2 + 3 >> 0] | 0) << 16 | (HEAPU8[i2 + 4 >> 0] | 0) << 24;
 i8 = i8 >>> 0 < 4096 ? 4096 : i8;
 i1 = HEAP8[i2 >> 0] | 0;
 if ((i1 & 255) > 224) {
  i11 = 4;
  return i11 | 0;
 }
 i6 = ((i1 & 255) % 9 | 0) & 255;
 i7 = ((i1 & 255) / 45 | 0) & 255;
 i2 = ((((i1 & 255) / 9 | 0) & 255) % 5 | 0) & 255;
 i3 = (768 << i2 + i6) + 1846 | 0;
 i4 = i9 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i9 + 84 | 0;
 if (!i5) i11 = 5; else if ((i3 | 0) != (HEAP32[i1 >> 2] | 0)) i11 = 5;
 if ((i11 | 0) == 5) {
  mftCall_vii(HEAP32[i10 + 4 >> 2] | 0, i10 | 0, i5 | 0);
  HEAP32[i4 >> 2] = 0;
  i11 = mftCall_iii(HEAP32[i10 >> 2] | 0, i10 | 0, i3 << 1 | 0) | 0;
  HEAP32[i4 >> 2] = i11;
  HEAP32[i1 >> 2] = i3;
  if (!i11) {
   i11 = 2;
   return i11 | 0;
  }
 }
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = i7;
 HEAP32[i9 + 12 >> 2] = i8;
 i11 = 0;
 return i11 | 0;
}

function mftCall_vifiiiiiiiiiiiiiiiiiiiiiii(i26, i1, d2, i13, i19, i20, i21, i22, i23, i24, i25, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18) {
 i26 = i26 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i13 = i13 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 if ((i26 | 0) >= (fb | 0) & (i26 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiiiiiiii[i26 - fb & 1](i1 | 0, Math_fround(d2), i13 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i24 | 0, i25 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0);
  return;
 }
 ftCall_vifiiiiiiiiiiiiiiiiiiiiiii(i26 | 0, i1 | 0, +d2, i13 | 0, i19 | 0, i20 | 0, i21 | 0, i22 | 0, i23 | 0, i24 | 0, i25 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0);
}

function __ZNK14GfxContextGLES21GetDefaultVertexArrayEv(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 i3 = i1 + 16 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + 532 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 695 >> 0] | 0) != 0;
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(i9 & (i2 | 0) != 0)) {
  STACKTOP = i8;
  return;
 }
 i9 = i6;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (__ZN7ApiGLES13IsVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE(i2, i7) | 0) {
  STACKTOP = i8;
  return;
 }
 i9 = (HEAP32[i3 >> 2] | 0) + 532 | 0;
 __ZN7ApiGLES17CreateVertexArrayEv(i7, HEAP32[gb + 1451080 >> 2] | 0);
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i7;
 i9 = i5;
 HEAP32[i9 >> 2] = i6;
 HEAP32[i9 + 4 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN13AudioListener12AddToManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i2 + 36 | 0;
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = (__Z21GetManagerFromContexti(3) | 0) + 52 | 0;
 i4 = i2 + 132 | 0;
 if ((i4 | 0) == (i3 | 0)) {
  __ZN13AudioListener12ApplyFiltersEv(i2);
  __ZN13AudioListener8DoUpdateEv(i2);
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 136 | 0; else {
  i6 = i2 + 136 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  i1 = i6;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 __ZN13AudioListener12ApplyFiltersEv(i2);
 __ZN13AudioListener8DoUpdateEv(i2);
 STACKTOP = i5;
 return;
}

function __ZL40UpdateTransformsGetMessagesMultiThreadedP30UpdateTransformGetMessagesInfoj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1459224 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459224 | 0, i1);
  i3 = gb + 1459224 | 0;
 } else i3 = 0;
 i8 = HEAP32[i4 + (i5 * 20 | 0) >> 2] | 0;
 i9 = HEAP32[i4 + (i5 * 20 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i4 + (i5 * 20 | 0) + 8 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i4 + (i5 * 20 | 0) + 16 >> 2]);
 i2 = HEAP32[i4 + (i5 * 20 | 0) + 12 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i6 + (i1 << 2) >> 2] = __ZN12NavMeshAgent29UpdateTransformGetMessageMaskEfPP9Transform(HEAP32[i8 + (i1 << 2) >> 2] | 0, f7, i9 + (i1 << 2) | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 if (!i3) {
  STACKTOP = i10;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i10;
 return;
}

function ___mkostemps(i5, i1, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i2 = _strlen(i5) | 0;
 L1 : do if (i2 >>> 0 < 6 | (i2 + -6 | 0) >>> 0 < i1 >>> 0) i7 = 4; else {
  i4 = i5 + i2 + (0 - i1) + -6 | 0;
  if (!(_memcmp(i4, gb + 1076012 | 0, 6) | 0)) {
   i3 = i3 | 194;
   i2 = 100;
   do {
    ___randname(i4) | 0;
    HEAP32[i6 >> 2] = 384;
    i1 = _open(i5, i3, i6) | 0;
    if ((i1 | 0) > -1) break L1;
    i2 = i2 + -1 | 0;
    if (!i2) break;
   } while ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 17);
   HEAP8[i4 >> 0] = HEAP8[gb + 1076012 >> 0] | 0;
   HEAP8[i4 + 1 >> 0] = HEAP8[gb + 1076012 + 1 >> 0] | 0;
   HEAP8[i4 + 2 >> 0] = HEAP8[gb + 1076012 + 2 >> 0] | 0;
   HEAP8[i4 + 3 >> 0] = HEAP8[gb + 1076012 + 3 >> 0] | 0;
   HEAP8[i4 + 4 >> 0] = HEAP8[gb + 1076012 + 4 >> 0] | 0;
   HEAP8[i4 + 5 >> 0] = HEAP8[gb + 1076012 + 5 >> 0] | 0;
   i1 = -1;
  } else i7 = 4;
 } while (0);
 if ((i7 | 0) == 4) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferI13TrailRendererEEvRT_PKc17TransferMetaFlags(i4, i7, i1, i2) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i4);
 i1 = i7 + 388 | 0;
 i6 = i4 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i5 = i4 + 24 | 0;
 if (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i3;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
 __ZN14LineParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i7 + 384 >> 2] | 0, i4);
 i1 = i7 + 392 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 < i2 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 4);
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i7 + 396 | 0;
 if ((i4 + 1 | 0) >>> 0 < i2 >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 1);
  return;
 }
}

function __ZN12b2MotorJoint16SetAngularOffsetEf(i1, f5) {
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i1 + 76 | 0;
 if (!(Math_fround(HEAPF32[i6 >> 2]) != f5)) return;
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i2 = HEAPU16[i4 >> 1] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i4 >> 1] = i2 & 65533;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i4 = i3 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i4 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  i4 = i1 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
 } else if (!(i3 & 2)) {
  HEAP16[i2 >> 1] = i3 | 2;
  HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 }
 HEAPF32[i6 >> 2] = f5;
 return;
}

function __ZN12CullingGroup4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 i7 = HEAP32[gb + 1114352 >> 2] | 0;
 i8 = i1;
 i9 = i7 + 12 | 0;
 i6 = HEAP32[i9 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i6;
 i2 = i6 + 1 | 0;
 i3 = i7 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i7 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i2;
 HEAP32[(HEAP32[i7 >> 2] | 0) + (i6 << 2) >> 2] = i8;
 return;
}

function __Z25TextGenerator_CUSTOM_InitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __Znwj(80) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = i6;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i3 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i7 = i6;
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 56 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 44 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i3 + 60 >> 0] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN9Transform25CompleteTransformTransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (HEAP32[i5 >> 2] & 16384 | 0) {
  STACKTOP = i6;
  return;
 }
 i3 = i2 + 80 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863909 | 0, HEAP32[gb + 37316 >> 2] | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i5, i3, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 100 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 421284 | 0, gb + 842702 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 STACKTOP = i6;
 return;
}

function __ZN9BlobWrite8TransferIN7mecanim8skeleton4NodeEEEvRT_PKc17TransferMetaFlags(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = (HEAP8[i3 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i3, 8, i4, 4);
 i2 = i3 + 48 | 0;
 i6 = i3 + 44 | 0;
 i8 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i5 = i3 + 32 | 0;
 i9 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i8 >>> 8 << 2) >> 2] | 0;
 i8 = i8 & 255;
 i7 = i9 + (i8 << 4) + 4 | 0;
 i10 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i10 + (0 - (i10 + (HEAP32[i9 + (i8 << 4) >> 2] | 0)) & 3);
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i3, i4, gb + 906607 | 0, 0);
 __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i3, i4 + 4 | 0, gb + 906618 | 0, 0);
 if (!i1) return;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i9 + -1;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i10 = i2 - (HEAP32[i5 >> 2] | 0) | 0;
 if ((1 - i9 - (HEAP32[i6 >> 2] | 0) + ((i10 | 0) == 0 ? 0 : (i10 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN8JSONRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlagsb(i8, i9, i2, i6, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i8 + 36 | 0;
 HEAP8[i7 >> 0] = 0;
 if (!((i6 & 524288 | 0) == 0 | (HEAP32[i8 >> 2] & 2 | 0) == 0)) return;
 i4 = i8 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  if (!i5) return;
  if ((HEAP32[i5 + 16 >> 2] | 0) != 3) return;
 }
 i1 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i8, i5, i2) | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = i8 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 1048681;
 if (i1 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i8, i6);
  HEAP32[i8 + 16 >> 2] = 2;
  __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i8, i9, gb + 1048690 | 0, 4194305, 0);
  if ((__ZN8JSONRead14GetDataVersionEv(i8) | 0) == 1) {
   i1 = HEAP32[i9 >> 2] | 0;
   if (i1 & 32 | 0) HEAP32[i9 >> 2] = i1 | -65536;
  }
  HEAP8[i7 >> 0] = 1;
  i9 = i8 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i1 + i4 | 0;
 i9 = i1 + (i4 + 4) | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i4 = i1 + (i4 + 8) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i8 + 11 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 if ((HEAP8[((i5 & 4 | 0) == 0 ? i2 : i1 + 3 | 0) >> 0] | 0) == i3 << 24 >> 24) return;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i2 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i7 = 5; else i2 = i8;
   break;
  }
 default:
  i7 = 5;
 }
 if ((i7 | 0) == 5) {
  HEAP8[i2 >> 0] = i3;
  return;
 }
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i6) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i3;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
 return;
}

function __ZN11b2GearJoint4DumpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 56 | 0;
 i4 = i2 + 48 | 0;
 i5 = i2 + 40 | 0;
 i7 = i2 + 32 | 0;
 i9 = i2 + 24 | 0;
 i10 = i2 + 16 | 0;
 i12 = i2 + 8 | 0;
 i13 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 8 >> 2] | 0;
 i11 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i1 + 68 >> 2] | 0) + 56 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i1 + 72 >> 2] | 0) + 56 >> 2] | 0;
 __Z5b2LogPKcz(gb + 799736 | 0, i2);
 HEAP32[i12 >> 2] = i13;
 __Z5b2LogPKcz(gb + 799360 | 0, i12);
 HEAP32[i10 >> 2] = i11;
 __Z5b2LogPKcz(gb + 799386 | 0, i10);
 HEAP32[i9 >> 2] = HEAPU8[i1 + 61 >> 0];
 __Z5b2LogPKcz(gb + 799412 | 0, i9);
 HEAP32[i7 >> 2] = i8;
 __Z5b2LogPKcz(gb + 799758 | 0, i7);
 HEAP32[i5 >> 2] = i6;
 __Z5b2LogPKcz(gb + 799785 | 0, i5);
 HEAPF64[i4 >> 3] = +Math_fround(HEAPF32[i1 + 152 >> 2]);
 __Z5b2LogPKcz(gb + 799812 | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 __Z5b2LogPKcz(gb + 799614 | 0, i3);
 STACKTOP = i2;
 return;
}

function __Z24TransferMeshDataByteSwapI14SafeBinaryReadEvRT_R13dynamic_arrayIhLj1EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i3, gb + 843899 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i3, i4, 0); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i3 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i3);
 }
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (!(__Z23dtNavMeshDataSwapEndianPhi(HEAP32[i4 >> 2] | 0, i1) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 843910 | 0, 0, gb + 843960 | 0, 27, 1, 0, 0, 0);
 if (__Z25dtNavMeshHeaderSwapEndianPh(HEAP32[i4 >> 2] | 0) | 0) {
  STACKTOP = i5;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844036 | 0, 0, gb + 843960 | 0, 28, 1, 0, 0, 0);
 STACKTOP = i5;
 return;
}

function __ZN9Scripting24UnloadAssetFromScriptingEP6Object(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!i4) return;
 i2 = i4 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(i1 & 1048576)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 465246 | 0, 0, gb + 465174 | 0, 429, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i3 = i1 >>> 21;
 do if ((i3 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) if ((i3 - (HEAP32[gb + 27368 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27368 + 28 >> 2] | 0) >>> 0) {
  if ((i3 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) {
   if (!(__ZNK13MonoBehaviour18IsScriptableObjectEv(i4) | 0)) {
    i1 = HEAP32[i2 >> 2] | 0;
    i5 = 9;
   }
  } else i5 = 9;
  if ((i5 | 0) == 9) if (((i1 >>> 21) - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) break;
  __Z12UnloadObjectP6Object(i4);
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 465286 | 0, 0, gb + 465174 | 0, 436, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN5physx38PxVehicleDriveSimDataNWGeneratedValuesC2EPKNS_23PxVehicleDriveSimDataNWE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 _memcpy(i2 | 0, i1 | 0, i3 << 3 | 0) | 0;
 HEAP32[i2 + 64 >> 2] = i3;
 i3 = i2 + 80 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 112 | 0, i1 + 112 | 0, 144) | 0;
 i3 = i2 + 256 | 0;
 i4 = i1 + 256 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 _memcpy(i2 + 272 | 0, i1 + 272 | 0, 256) | 0;
 i2 = i2 + 528 | 0;
 i1 = i1 + 528 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5Unity9Component7PRODUCEE10MemLabelId18ObjectCreationMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(32, i2, 16, gb + 1048932 | 0, 0, gb + 369816 | 0, 401) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i5 >> 2] = gb + 28204 + 8;
 i1 = i5 + 8 | 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = i2 & 2047 | -2097152;
 i2 = __Z16GetMemoryManagerv() | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i3 = i7 & 2047;
 if (!(i7 & 2048)) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = 0;
 } else __Z14CreateMemLabel18MemLabelIdentifierPv(i4, i3, i5);
 i7 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i2, i4) | 0;
 i7 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i5 | 0) | 0) != 0 & 1;
 HEAP32[i1 >> 2] = i7 << 11 | HEAP32[i1 >> 2] & -2049;
 HEAP32[i5 + 24 >> 2] = -1;
 HEAP32[i5 >> 2] = gb + 29060 + 8;
 HEAP32[i5 + 28 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN12_GLOBAL__N_116MetaDataProvider14createInstanceERKN5physx8debugger14NamespacedNameEPKv(i4, i2, i7) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 76 | 0;
 i6 = i8 + 80 | 0;
 i1 = i8;
 i5 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i9 = HEAP32[i4 + 8 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i9 | 0, i2 | 0);
 if (!(HEAP8[i1 + 72 >> 0] | 0)) {
  i9 = 0;
  i7 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return i9 | 0;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb(i4 + 32 | 0, i3, i6) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  HEAP32[i1 >> 2] = i7;
  HEAP32[i1 + 4 >> 2] = i2;
 }
 i9 = 1;
 i7 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode(i3, i1, f4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i2 = 0;
 HEAP32[i5 + 248 >> 2] = 0;
 HEAP16[i5 + 270 >> 1] = 0;
 HEAPF32[i5 + 256 >> 2] = Math_fround(0.0);
 HEAP16[i5 + 268 >> 1] = -1;
 HEAP16[i5 + 272 >> 1] = -1;
 HEAP32[i5 + 348 >> 2] = 0;
 _memcpy(i5 | 0, i3 + 4 | 0, 235) | 0;
 i1 = HEAP32[i5 + 188 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i2 = HEAP32[i1 + 96 >> 2] | 0;
  i1 = HEAP32[i1 + 92 >> 2] | 0;
 }
 HEAP32[i5 + 260 >> 2] = i1;
 HEAP32[i5 + 264 >> 2] = i2;
 HEAP32[i5 + 236 >> 2] = 0;
 HEAPF32[i5 + 252 >> 2] = f4;
 HEAP32[i5 + 240 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i2 = i3 + 236 | 0;
 if (((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 63) >>> 0 >= 9) {
  i1 = 0;
  i2 = i5 + 352 | 0;
  HEAP32[i2 >> 2] = i1;
  i5 = i5 + 356 | 0;
  HEAP32[i5 >> 2] = i3;
  return;
 }
 i1 = HEAP32[i3 + -32 + 4 >> 2] | 0;
 i2 = i5 + 352 | 0;
 HEAP32[i2 >> 2] = i1;
 i5 = i5 + 356 | 0;
 HEAP32[i5 >> 2] = i3;
 return;
}

function __Z32Renderer_CUSTOM_SetPropertyBlockP12Il2CppObjectS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (i1 | 0) {
  i2 = i1 + 8 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet11ComputeHashEv(i1);
   if (!i4) {
    i3 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   }
   i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
   if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
   __ZN8Renderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i3, i1);
   STACKTOP = i6;
   return;
  }
 }
 if (!i4) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN8Renderer21ClearCustomPropertiesEv(i1);
 STACKTOP = i6;
 return;
}

function __ZNK21EnlightenSceneMapping17GetProbesetHashesER13dynamic_arrayI7Hash128Lj8EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 40 >> 2] | 0;
 i7 = i5 + 12 | 0;
 i1 = HEAP32[i1 + 52 >> 2] << 4;
 i2 = i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i4 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i4;
  i5 = i4;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 8, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i4;
  i5 = i4;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i5 | 0, i6 | 0, i7 | 0) | 0;
  return;
 }
}

function __ZN9ShaderLab19CommonPropertyNames16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __Z33InitializeBuiltinShaderParamNamesv();
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63280 | 0, 16, gb + 480206 | 0, 51) | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[gb + 1166568 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63280 | 0, 16, gb + 480206 | 0, 52) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[gb + 1170580 >> 2] = i1;
 if ((HEAP32[gb + 1166572 >> 2] | 0) > 0) i1 = 0; else {
  STACKTOP = i2;
  return;
 }
 do {
  __ZN9ShaderLab16FastPropertyName4InitEPKc(HEAP32[gb + 1166576 + (i1 << 3) >> 2] | 0, HEAP32[gb + 1166576 + (i1 << 3) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[gb + 1166572 >> 2] | 0));
 STACKTOP = i2;
 return;
}

function __ZN21AssetBundleFileSystem10AddArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 108 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  __ZN10FileSystem12MountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i5) | 0;
  HEAP8[i6 >> 0] = 1;
 }
 i4 = i5 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(160, gb + 63552 | 0, 16, gb + 585751 | 0, 82) | 0;
  i2 = i5 + 96 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  __ZN17ArchiveFileSystemC2EPKc(i1, i2);
  HEAP32[i4 >> 2] = i1;
 }
 i2 = __ZN17ArchiveFileSystem12MountArchiveEPKcS1_(i1, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0) | 0;
 if (i2) return i2 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) return i2 | 0;
 if ((HEAP32[i5 + 72 >> 2] | 0) != (HEAP32[i5 + 8 >> 2] | 0)) return i2 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return i2 | 0;
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) | 0) return i2 | 0;
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i5) | 0;
 HEAP8[i6 >> 0] = 0;
 return i2 | 0;
}

function __ZN14SerializedFile14InitializeReadERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER18ResourceImageGroupjj24TransferInstructionFlagsjj(i6, i2, i7, i4, i5, i8, i1, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i9 = 0;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 HEAP32[i6 + 20 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(168, gb + 63552 | 0, 16, gb + 588245 | 0, 394) | 0;
 __ZN14FileCacherReadC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjj(i1, i2, i4, i5);
 i2 = i6 + 128 | 0;
 HEAP32[i2 >> 2] = i1;
 if ((i3 | 0) == -1) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i6 + 24 >> 2] = i3;
 i5 = i6 + 132 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 48 >> 2] = i8 | 256;
 HEAP8[i6 + 44 >> 0] = i8 >>> 9 & 1;
 if (!i1) i1 = 0; else i1 = __ZN14SerializedFile10ReadHeaderEv(i6) | 0;
 if (!i9) return i1 | 0;
 __Z19pop_allocation_rootv();
 return i1 | 0;
}

function __ZN13TrailRendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 55828 + 8;
 HEAP32[i3 + 32 >> 2] = gb + 55828 + 184;
 i1 = i3 + 384 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 344 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 43728 + 8;
 HEAP32[i3 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i3);
 i1 = i3 + 288 | 0;
 if ((HEAP32[i3 + 304 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 292 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12AdsIdHandler22InvokeAllAdsIdDelegateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i4 + 48 | 0;
 i3 = i4 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i6 | 0)) do {
  i8 = i1 + 8 | 0;
  __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj(i4, HEAP32[i8 >> 2] | 0);
  __Z23scripting_gchandle_freej(HEAP32[i8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 i2 = i4 + 56 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i8 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = i4 + 60 | 0;
 i3 = i5 + 4 | 0;
 do {
  i8 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = 5;
  HEAP32[i3 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i8, i5);
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i7;
 return;
}

function __ZNK14b2CapsuleShape5CloneEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 180) | 0;
 HEAP32[i2 >> 2] = gb + 151688 + 8;
 HEAP32[i2 + 28 >> 2] = gb + 151728 + 8;
 i4 = i2 + 32 | 0;
 HEAP32[i4 >> 2] = 2;
 i6 = HEAP32[gb + 151644 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = i6;
 HEAP32[i2 + 176 >> 2] = 0;
 i3 = i2 + 40 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 4;
 HEAP32[i2 + 8 >> 2] = i6;
 i6 = i2 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i8 = i1 + 4 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = i7;
 i5 = i1 + 12 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i6 = i1 + 32 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 _memcpy(i3 | 0, i1 + 40 | 0, 140) | 0;
 return i2 | 0;
}

function __ZN9LensFlare12AddToManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
  if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
   i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  } else {
   i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
   i3 = i1 + 4 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 >> 2] = i3;
   i3 = i1 + 12 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   __Z19pop_allocation_rootv();
   HEAP32[gb + 1110296 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i2 + 68 >> 2] = __ZN12FlareManager8AddFlareEv(i1) | 0;
 __ZN9LensFlare11UpdateFlareEv(i2);
 return;
}

function __ZN7Joint2D18SetEnableCollisionEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i5 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0) | 0)) {
  HEAP32[i3 >> 2] = __ZNK6Object12GetClassNameEv(i4) | 0;
  __Z6FormatPKcz(i2, gb + 806367 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 801199 | 0, 152, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 }
 HEAP8[i4 + 40 >> 0] = i1 & 1;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, 0);
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx26PxSceneLimitsGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 674637;
 HEAP32[i1 + 4 >> 2] = 308;
 HEAP32[i1 + 8 >> 2] = fb + 2226;
 HEAP32[i1 + 12 >> 2] = fb + 3608;
 HEAP32[i1 + 16 >> 2] = gb + 772438;
 HEAP32[i1 + 20 >> 2] = 309;
 HEAP32[i1 + 24 >> 2] = fb + 2227;
 HEAP32[i1 + 28 >> 2] = fb + 3609;
 HEAP32[i1 + 32 >> 2] = gb + 772450;
 HEAP32[i1 + 36 >> 2] = 310;
 HEAP32[i1 + 40 >> 2] = fb + 2228;
 HEAP32[i1 + 44 >> 2] = fb + 3610;
 HEAP32[i1 + 48 >> 2] = gb + 772468;
 HEAP32[i1 + 52 >> 2] = 311;
 HEAP32[i1 + 56 >> 2] = fb + 2229;
 HEAP32[i1 + 60 >> 2] = fb + 3611;
 HEAP32[i1 + 64 >> 2] = gb + 772487;
 HEAP32[i1 + 68 >> 2] = 312;
 HEAP32[i1 + 72 >> 2] = fb + 2230;
 HEAP32[i1 + 76 >> 2] = fb + 3612;
 HEAP32[i1 + 80 >> 2] = gb + 772503;
 HEAP32[i1 + 84 >> 2] = 313;
 HEAP32[i1 + 88 >> 2] = fb + 2231;
 HEAP32[i1 + 92 >> 2] = fb + 3613;
 HEAP32[i1 + 96 >> 2] = gb + 772520;
 HEAP32[i1 + 100 >> 2] = 314;
 HEAP32[i1 + 104 >> 2] = fb + 2232;
 HEAP32[i1 + 108 >> 2] = fb + 3614;
 HEAP32[i1 + 112 >> 2] = gb + 772533;
 HEAP32[i1 + 116 >> 2] = 315;
 HEAP32[i1 + 120 >> 2] = fb + 2233;
 HEAP32[i1 + 124 >> 2] = fb + 3615;
 return;
}

function __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i3, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 if (!(HEAP32[i3 + 32 >> 2] | 0)) return;
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i3, 0) | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i2 >> 2] = i5;
  __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, i5);
 }
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i3, 1) | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i2 >> 2] = i5;
  __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, i5);
 }
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i3, 2) | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i5 | 0)) {
  HEAP32[i2 >> 2] = i5;
  __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, i5);
 }
 i1 = __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i4, i3, 3) | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) return;
 HEAP32[i2 >> 2] = i5;
 __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei(i4, i1, i5);
 return;
}

function __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 4, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 4, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] << 4 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + (i5 << 4) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i5 << 4) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + (i5 << 4) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i9 + (i5 << 4) + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = (HEAP32[i6 + 4 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) >> 4;
 i2 = i7 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i8 | 0)) {
  HEAP32[i7 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i8) | 0;
  HEAP32[i2 >> 2] = i8;
 }
 if (!i8) return;
 i4 = i6 + 16 | 0;
 i3 = 0;
 do {
  i2 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i7 >> 2] | 0, i3) | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + (i3 << 4) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = _il2cpp_object_new(HEAP32[i4 >> 2] | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
   HEAP32[i2 >> 2] = i1;
  }
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i8 | 0));
 return;
}

function __Z21CheckGpuProgramUsable20ShaderGpuProgramType(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
 if ((i1 | 0) == 4) {
  i3 = 0;
  return i3 | 0;
 }
 switch (i3 | 0) {
 case 2:
 case 3:
 case 4:
 case 5:
 case 6:
 case 7:
 case 8:
  {
   i1 = i1 + -8 | 0;
   if (i1 >>> 0 >= 10) {
    i3 = 1;
    return i3 | 0;
   }
   if (!(521 >>> (i1 & 1023) & 1)) {
    i3 = 1;
    return i3 | 0;
   }
   i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 628 >> 2] | 0;
   if ((i2 | 0) > 0) i1 = 0; else {
    i3 = 1;
    return i3 | 0;
   }
   while (1) {
    if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 588 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
     i1 = 0;
     i2 = 9;
     break;
    }
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i2 | 0)) {
     i1 = 1;
     i2 = 9;
     break;
    }
   }
   if ((i2 | 0) == 9) return i1 | 0;
   break;
  }
 case 9:
 case 10:
 case 11:
 case 12:
 case 13:
 case 14:
 case 15:
 case 16:
 case 17:
 case 18:
 case 19:
 case 20:
 case 21:
 case 22:
 case 23:
 case 24:
 case 1:
  {
   i3 = 1;
   return i3 | 0;
  }
 default:
  {
   i3 = (i3 | 0) == 25 & 1;
   return i3 | 0;
  }
 }
 return 0;
}

function __Z20dtDistancePtSegSqr2DPKfS0_S0_Rf(i5, i1, i2, i8) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f3 = f0, f4 = f0, f6 = f0, f7 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f9 - f7);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(f6 - f3);
 f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f7);
 f3 = Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) - f3);
 f4 = Math_fround(Math_fround(f9 * f9) + Math_fround(f6 * f6));
 if (f4 == Math_fround(0.0)) {
  HEAPF32[i8 >> 2] = Math_fround(0.0);
  f9 = Math_fround(Math_fround(f7 * f7) + Math_fround(f3 * f3));
  return Math_fround(f9);
 } else {
  f4 = Math_fround(Math_fround(Math_fround(f9 * f7) + Math_fround(f6 * f3)) / f4);
  i5 = f4 < Math_fround(0.0);
  i2 = f4 > Math_fround(1.0);
  f4 = i2 ? Math_fround(1.0) : f4;
  f4 = i5 ? Math_fround(0.0) : f4;
  f7 = Math_fround(Math_fround(f9 * f4) - f7);
  f9 = Math_fround(Math_fround(f6 * f4) - f3);
  HEAPF32[i8 >> 2] = f4;
  f9 = Math_fround(Math_fround(f7 * f7) + Math_fround(f9 * f9));
  return Math_fround(f9);
 }
 return f0;
}

function __Z18IntersectRaySphereRK3RayRK6SpherePfS5_(i1, i3, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f2 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 16 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f2 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f4 * f4)) + Math_fround(f2 * f2));
 f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f4 = Math_fround(f4 * f4);
 if (f5 < Math_fround(0.0) & f2 > f4) {
  i7 = 0;
  return i7 | 0;
 }
 f2 = Math_fround(f2 - Math_fround(f5 * f5));
 if (f2 > f4) {
  i7 = 0;
  return i7 | 0;
 }
 f8 = Math_fround(Math_sqrt(Math_fround(f4 - f2)));
 HEAPF32[i6 >> 2] = Math_fround(f5 - f8);
 HEAPF32[i7 >> 2] = Math_fround(f5 + f8);
 i7 = 1;
 return i7 | 0;
}

function __Z16WriteBytesToFilePKvjRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 2160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 1088 | 0;
 i8 = i7 + 8 | 0;
 i5 = i7 + 20 | 0;
 i6 = i7;
 i9 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i8, i9, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i8 + 11 >> 0] | 0) < 0 ? HEAP32[i8 >> 2] | 0 : i8);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
 __ZN12FileAccessorC2Ev(i5);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i5, i4, 1, 0) | 0)) {
  i9 = 0;
  __ZN12FileAccessorD2Ev(i5);
  __ZN13FileEntryDataD2Ev(i4);
  STACKTOP = i7;
  return i9 | 0;
 }
 i9 = i6;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 i9 = __ZN12FileAccessor5WriteEyPKvPy(i5, i2, 0, i1, i6) | 0;
 __ZN12FileAccessor5CloseEv(i5) | 0;
 __ZN12FileAccessorD2Ev(i5);
 __ZN13FileEntryDataD2Ev(i4);
 STACKTOP = i7;
 return i9 | 0;
}

function _erfc(d4) {
 d4 = +d4;
 var d1 = 0.0, i2 = 0, i3 = 0, i5 = 0;
 HEAPF64[tempDoublePtr >> 3] = d4;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, i5 | 0, 63) | 0;
 i2 = getTempRet0() | 0;
 i5 = i5 & 2147483647;
 do if (i5 >>> 0 > 2146435071) {
  i5 = _bitshift64Shl(i3 | 0, i2 | 0, 1) | 0;
  getTempRet0() | 0;
  d1 = 1.0 / d4 + +(i5 | 0);
 } else {
  if (i5 >>> 0 >= 1072365568) {
   i2 = (i3 | 0) != 0;
   if (i5 >>> 0 < 1077673984) {
    d1 = +_erfc2(i5, d4);
    d1 = i2 ? 2.0 - d1 : d1;
    break;
   } else {
    d1 = i2 ? 2.0 : 0.0;
    break;
   }
  }
  if (i5 >>> 0 < 1013972992) {
   d1 = 1.0 - d4;
   break;
  }
  d1 = d4 * d4;
  d1 = (d1 * (d1 * (d1 * (-.005770270296489442 - d1 * 2.3763016656650163e-05) + -.02848174957559851) + -.3250421072470015) + .12837916709551256) / (d1 * (d1 * (d1 * (d1 * (1.3249473800432164e-04 - d1 * 3.960228278775368e-06) + .005081306281875766) + .0650222499887673) + .39791722395915535) + 1.0);
  if ((i3 | 0) != 0 | i5 >>> 0 < 1070596096) {
   d1 = 1.0 - (d1 * d4 + d4);
   break;
  } else {
   d1 = .5 - (d4 + -.5 + d1 * d4);
   break;
  }
 } while (0);
 return +d1;
}

function __ZThn4_NK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_(i1, i3, i5, i7, i6, i4, i2, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 40 | 0;
 i10 = i1 + 32 | 0;
 i11 = i1 + 24 | 0;
 i12 = i1 + 16 | 0;
 i13 = i1 + 8 | 0;
 i14 = i1;
 HEAP32[i14 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i14 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZNK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_(0, i3, i14, i13, i12, i11, i10, i9);
 STACKTOP = i1;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i1 + i4 | 0;
 i9 = i1 + (i4 + 4) | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i4 = i1 + (i4 + 8) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i8 + 11 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 if ((HEAP8[((i5 & 4 | 0) == 0 ? i2 : i1 + 3 | 0) >> 0] | 0) == i3 << 24 >> 24) return;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i2 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i7 = 5; else i2 = i8;
   break;
  }
 default:
  i7 = 5;
 }
 if ((i7 | 0) == 5) {
  HEAP8[i2 >> 0] = i3;
  return;
 }
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i6) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i3;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
 return;
}

function __ZN5Unity12PhysicsQueryD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 52 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 40 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 24 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 28 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i2 | 0) >>> 4) << 4);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -64 - i2 | 0) >>> 6) << 6);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN20TextRenderingPrivate7GUIText7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(96, i1, 16, gb + 1048932 | 0, 0, gb + 946758 | 0, 23) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10GUIElementC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 185436 + 8;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP8[i4 + 65 >> 0] = 1;
 HEAP32[i4 + 84 >> 2] = -1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14TerrainManager26Heightmap_GetPxHeightFieldER9Heightmap(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i6 + 100 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i4 = __Z11GetIPhysicsv() | 0;
 if (!i4) {
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i2 + 12 >> 2] = 0;
 i1 = i2 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 1;
 HEAPF32[i2 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i2 + 24 >> 2] = Math_fround(0.0);
 HEAP16[i2 + 28 >> 1] = 0;
 if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i6, i2) | 0) {
  HEAP32[i3 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 64 >> 2] | 0, i4 | 0, i2 | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
 }
 i6 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i6 | 0;
}

function __Z40UnityWebRequest_CUSTOM_GetResponseHeaderP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i6 + 16 | 0;
 i5 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i3);
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) == (i1 | 0)) i1 = 0; else i1 = __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + -24 | 0, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z30Light_CUSTOM_GetCommandBuffersP12Il2CppObject20RenderLightEventType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZNK19RenderEventsContext17GetCommandBuffersEi((HEAP32[i3 + 44 >> 2] | 0) + 208 | 0, i2) | 0;
 i2 = HEAP32[i7 + 12 >> 2] | 0;
 i3 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 300 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i3, 4, i2) | 0;
 if (!i2) return i4 | 0;
 i1 = 0;
 do {
  i5 = __Z20scripting_object_newP11Il2CppClass(i3) | 0;
  HEAP32[i5 + 8 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2];
  i6 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i6 | 0) {
   i6 = i6 + 4 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
  }
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i1, i5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return i4 | 0;
}

function __Z18MurmurHashNeutral2PKvij(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i1 ^ i2;
 if ((i2 | 0) > 3) {
  i4 = i2 + -4 | 0;
  i5 = i4 & -4;
  i6 = i3 + (i5 + 4) | 0;
  while (1) {
   i8 = Math_imul((HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) | (HEAPU8[i3 + 2 >> 0] | 0) << 16 | (HEAPU8[i3 + 3 >> 0] | 0) << 24, 1540483477) | 0;
   i1 = (Math_imul(i8 >>> 24 ^ i8, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
   i2 = i2 + -4 | 0;
   if ((i2 | 0) <= 3) break; else i3 = i3 + 4 | 0;
  }
  i2 = i4 - i5 | 0;
  i3 = i6;
 }
 switch (i2 | 0) {
 case 3:
  {
   i1 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 ^ i1;
   i7 = 7;
   break;
  }
 case 2:
  {
   i7 = 7;
   break;
  }
 case 1:
  break;
 default:
  {
   i8 = i1;
   i7 = i8 >>> 13;
   i8 = i7 ^ i8;
   i8 = Math_imul(i8, 1540483477) | 0;
   i7 = i8 >>> 15;
   i8 = i7 ^ i8;
   return i8 | 0;
  }
 }
 if ((i7 | 0) == 7) i1 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 ^ i1;
 i8 = Math_imul((HEAPU8[i3 >> 0] | 0) ^ i1, 1540483477) | 0;
 i7 = i8 >>> 13;
 i8 = i7 ^ i8;
 i8 = Math_imul(i8, 1540483477) | 0;
 i7 = i8 >>> 15;
 i8 = i7 ^ i8;
 return i8 | 0;
}

function __Z12MurmurHash2APKvij(i2, i7, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if ((i7 | 0) > 3) {
  i4 = i7 + -4 | 0;
  i5 = i4 & -4;
  i6 = i2 + (i5 + 4) | 0;
  i1 = i7;
  while (1) {
   i9 = Math_imul(HEAP32[i2 >> 2] | 0, 1540483477) | 0;
   i3 = (Math_imul(i9 >>> 24 ^ i9, 1540483477) | 0) ^ (Math_imul(i3, 1540483477) | 0);
   i1 = i1 + -4 | 0;
   if ((i1 | 0) <= 3) break; else i2 = i2 + 4 | 0;
  }
  i1 = i4 - i5 | 0;
  i2 = i6;
 } else i1 = i7;
 switch (i1 | 0) {
 case 3:
  {
   i1 = (HEAPU8[i2 + 2 >> 0] | 0) << 16;
   i8 = 7;
   break;
  }
 case 2:
  {
   i1 = 0;
   i8 = 7;
   break;
  }
 case 1:
  {
   i1 = 0;
   i8 = 8;
   break;
  }
 default:
  i1 = 0;
 }
 if ((i8 | 0) == 7) {
  i1 = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | i1;
  i8 = 8;
 }
 if ((i8 | 0) == 8) i1 = Math_imul((HEAPU8[i2 >> 0] | 0) ^ i1, 1540483477) | 0;
 i9 = Math_imul(i7, 1540483477) | 0;
 i9 = (Math_imul((Math_imul(i1 >>> 24 ^ i1, 1540483477) | 0) ^ (Math_imul(i3, 1540483477) | 0), 1540483477) | 0) ^ (Math_imul(i9 >>> 24 ^ i9, 1540483477) | 0);
 i9 = Math_imul(i9 >>> 13 ^ i9, 1540483477) | 0;
 return i9 >>> 15 ^ i9 | 0;
}

function _UNITY_png_handle_sRGB(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[i3 + 204 >> 2] | 0;
 if (!(i2 & 1)) _UNITY_png_chunk_error(i3, gb + 352205 | 0);
 if (i2 & 6 | 0) {
  _UNITY_png_crc_finish(i3, i1) | 0;
  _UNITY_png_chunk_benign_error(i3, gb + 352423 | 0);
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) != 1) {
  _UNITY_png_crc_finish(i3, i1) | 0;
  _UNITY_png_chunk_benign_error(i3, gb + 352446 | 0);
  STACKTOP = i6;
  return;
 }
 _UNITY_png_read_data(i3, i5, 1);
 _UNITY_png_calculate_crc(i3, i5, 1);
 if (_UNITY_png_crc_finish(i3, 0) | 0) {
  STACKTOP = i6;
  return;
 }
 i1 = i3 + 754 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (i2 & 32768 | 0) {
  STACKTOP = i6;
  return;
 }
 if (!(i2 & 4)) {
  _UNITY_png_colorspace_set_sRGB(i3, i3 + 680 | 0, HEAPU8[i5 >> 0] | 0) | 0;
  _UNITY_png_colorspace_sync(i3, i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP16[i1 >> 1] = i2 | 32768;
  _UNITY_png_colorspace_sync(i3, i4);
  _UNITY_png_chunk_benign_error(i3, gb + 352581 | 0);
  STACKTOP = i6;
  return;
 }
}

function __ZN7mecanim9animation21CreateBlendTreeOutputEjRNS_6memory9AllocatorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 12, 4) | 0;
 HEAPF32[i5 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 4 >> 2] = i2;
 if (!i2) {
  i4 = 0;
  HEAP32[i5 >> 2] = i4;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 * 24 | 0, 4) | 0;
 i3 = i1 + (i2 * 24 | 0) | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i4 = i1;
  HEAP32[i5 >> 2] = i4;
  STACKTOP = i6;
  return i5 | 0;
 } else i2 = i1;
 do {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 4 >> 2] = 0;
  HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
  HEAP8[i2 + 12 >> 0] = 0;
  i7 = i2 + 13 | 0;
  HEAP8[i7 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP8[i7 + 1 >> 0] = HEAP8[i4 + 1 >> 0] | 0;
  HEAP8[i7 + 2 >> 0] = HEAP8[i4 + 2 >> 0] | 0;
  HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
  i2 = i2 + 24 | 0;
 } while ((i2 | 0) != (i3 | 0));
 HEAP32[i5 >> 2] = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i1 + 4 >> 1] << 2) >> 2] | 0;
 i8 = i1 + i4 | 0;
 i9 = i1 + (i4 + 4) | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i4 = i1 + (i4 + 8) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i8 + 11 | 0;
 i3 = HEAP8[i3 >> 0] | 0;
 if ((HEAP8[((i5 & 4 | 0) == 0 ? i2 : i1 + 3 | 0) >> 0] | 0) == i3 << 24 >> 24) return;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i2 = i8;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i8 >> 2] | 0) + 2433 >> 0] | 0)) i7 = 5; else i2 = i8;
   break;
  }
 default:
  i7 = 5;
 }
 if ((i7 | 0) == 5) {
  HEAP8[i2 >> 0] = i3;
  return;
 }
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i2 >> 2] | 0, i6) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i3;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i8);
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] | 4;
 return;
}

function __ZN21BillboardBatchManager16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 32 | 0;
 i2 = i4;
 i3 = __ZnwjRK10MemLabelIdiPKci(1, gb + 63616 | 0, 16, gb + 422286 | 0, 131) | 0;
 HEAP32[gb + 1159948 >> 2] = i3;
 i3 = i1;
 i5 = gb + 1546313 | 0;
 i6 = i3 + 16 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i5 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i5 = i5 + 1 | 0;
 } while ((i3 | 0) < (i6 | 0));
 HEAP8[i1 + 9 >> 0] = 4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 i6 = __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(25, i1, i2) | 0;
 HEAP32[gb + 1159904 >> 2] = i6;
 i6 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i2) | 0;
 HEAP32[gb + 1159920 >> 2] = i6;
 i6 = __ZN8keywords6CreateEPKc(gb + 422592 | 0) | 0;
 HEAP32[gb + 1159952 >> 2] = i6;
 STACKTOP = i4;
 return;
}

function __ZN15ParticleEmitter14ClearParticlesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 56 >> 2] | 0;
 i2 = i4 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -48 - i1 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 do if (!i1) {
  i2 = i4 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) return;
 } else {
  i3 = __ZNK10GameObject8IsActiveEv(i1) | 0;
  i2 = i4 + 208 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!(i3 ^ (i1 | 0) != 0)) return;
  if (!i3) {
   if (i1 | 0) break;
   return;
  }
  if ((i2 | 0) == (gb + 1469400 | 0)) return;
  if (!i1) i1 = i4 + 212 | 0; else {
   i4 = i4 + 212 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
   HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i4 >> 2] = 0;
   i1 = i4;
  }
  i4 = HEAP32[gb + 1469400 >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = gb + 1469400;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  return;
 } while (0);
 i4 = i4 + 212 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcy(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i6, i2) | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i3 = (_strlen(i2) | 0) + 8 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i7 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i7 + 36 >> 2] = 0;
 i3 = i7 + 40 | 0;
 i11 = gb + 63648 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP8[i7 + 20 >> 0] = 0;
 HEAP32[i7 >> 2] = 2;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = i4;
 HEAP32[i9 + 4 >> 2] = i5;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i6, i2, i7);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i7 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i11 = 1;
 STACKTOP = i8;
 return i11 | 0;
}

function __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_set_originCustomP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i4 = i7 + 76 | 0;
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 if (f8 == (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
  i1 = i7 + 84 | 0;
  f8 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i7 + 80 | 0;
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  i9 = f10 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f8 == (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) & i9) return;
 } else {
  i2 = i7 + 80 | 0;
  i1 = i7 + 84 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i1 >> 2] = i3;
 HEAP8[i7 + 154 >> 0] = 1;
 return;
}

function __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetVectorP12Il2CppObjectiR8Vector4f(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = HEAP32[i4 + 16 >> 2] | 0;
 L7 : do if ((i1 | 0) < (i2 | 0)) {
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i1 = gb + 1162376 | 0;
    break L7;
   }
  }
  if ((i1 | 0) > -1) i1 = (HEAP32[i4 + 72 >> 2] | 0) + (HEAP32[(HEAP32[i4 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0; else i1 = gb + 1162376 | 0;
 } else i1 = gb + 1162376 | 0; while (0);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 STACKTOP = i7;
 return;
}

function __GLOBAL__sub_I_runtime_cloth_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[gb + 1458904 >> 2] = 1;
 HEAP32[gb + 1458904 + 4 >> 2] = 1812433254;
 HEAP32[gb + 1458904 + 8 >> 2] = 1900727103;
 HEAP32[gb + 1458904 + 12 >> 2] = -603986212;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458920 | 0, gb + 837483 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458932 | 0, gb + 837509 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1458944 | 0, gb + 837533 | 0, 3, 0);
 __ZN14CompletionTaskC2Ev(gb + 1458956 | 0);
 HEAP32[gb + 1458984 >> 2] = 0;
 HEAP32[gb + 1458984 + 12 >> 2] = 0;
 HEAP32[gb + 1458984 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = gb + 1458984 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[gb + 1459004 >> 2] = 0;
 HEAP32[gb + 1459004 + 4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZN5physx23writeBackContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i7 = HEAP16[i1 + 2 >> 1] | 0;
 i8 = i1 + (i7 & 65535) | 0;
 i9 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
 if (!(i7 << 16 >> 16)) return;
 i4 = HEAP32[i4 + 20 >> 2] | 0;
 while (1) {
  i2 = HEAP8[i1 + 1 >> 0] | 0;
  i7 = i2 & 255;
  if (!i4) {
   i1 = i1 + ((Math_imul(i7, i9) | 0) + 48) | 0;
   if (i1 >>> 0 < i8 >>> 0) {
    i4 = 0;
    continue;
   } else {
    i1 = 10;
    break;
   }
  }
  i3 = i1 + 48 | 0;
  if (!(i2 << 24 >> 24)) {
   i1 = i3;
   i2 = i4;
  } else {
   i6 = i7 >>> 0 > 1 ? i7 : 1;
   i2 = i4 + (i6 << 2) | 0;
   i6 = Math_imul(i9, i6) | 0;
   i5 = 0;
   while (1) {
    HEAP32[i4 >> 2] = HEAP32[i3 + 12 >> 2];
    i5 = i5 + 1 | 0;
    if (i5 >>> 0 >= i7 >>> 0) break; else {
     i3 = i3 + i9 | 0;
     i4 = i4 + 4 | 0;
    }
   }
   i1 = i1 + (i6 + 48) | 0;
  }
  if (i1 >>> 0 < i8 >>> 0) i4 = i2; else {
   i1 = 10;
   break;
  }
 }
 if ((i1 | 0) == 10) return;
}

function __ZN2UI6Canvas14SetScaleFactorEf(i5, f2) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i4 = i7;
 HEAPF32[i4 >> 2] = f2;
 i1 = HEAP32[i5 + 344 >> 2] | 0;
 if (i1 | 0) {
  __ZN2UI6Canvas14SetScaleFactorEf(i1, f2);
  STACKTOP = i7;
  return;
 }
 HEAPF32[i6 >> 2] = Math_fround(.0000999999974);
 i3 = f2 < Math_fround(.0000999999974);
 i3 = HEAP32[(i3 ? i6 : i4) >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 f2 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = i5 + 352 | 0;
 if (f2 != f2 | Math_fround(0.0) != Math_fround(0.0) | f2 == Math_fround(HEAPF32[i1 >> 2])) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i5, 1);
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1106036 | 0, i6);
 STACKTOP = i7;
 return;
}

function __ZN20SoundChannelInstance20get3DConeOrientationEP11FMOD_VECTOR(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 if (i2 | 0) {
  i6 = i1 + 28 | 0;
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 }
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i1 = __ZN4FMOD7Channel20get3DConeOrientationEP11FMOD_VECTOR(i1, i2) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i6 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 188;
 HEAP32[i4 + 8 >> 2] = gb + 865635;
 HEAP32[i4 + 12 >> 2] = i6;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i6 = i1;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN19SkinnedMeshRenderer15UpdateClothDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 504 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i1, 3, 0) | 0;
 if (!i3) return;
 __Z17DeformSkinnedMeshR12SkinMeshInfo(i3);
 i5 = i3 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP16[i3 + 56 >> 1] | 0;
 i4 = (i6 & 255) << 24 >> 24 ? i1 + (HEAP32[i3 + 48 >> 2] | 0) | 0 : 0;
 i1 = (i6 & 65535) > 255 ? i1 + (HEAP32[i3 + 52 >> 2] | 0) | 0 : 0;
 i6 = __Z9GetIClothv() | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i5 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i3 + 44 >> 2] | 0, 1);
 i1 = i3 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = HEAP32[i3 + 100 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 return;
}

function __ZN19ShaderPropertySheet22CopyVectorPropertyFromERKS_i(i7, i1, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = (HEAP32[i1 + 32 >> 2] | 0) + (i5 << 2) | 0;
 i6 = i1 + 52 | 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i7, i2, (HEAP32[i1 + 72 >> 2] | 0) + (HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] & 1048575) | 0, 0);
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 i3 = HEAP32[i7 + 16 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i3 | 0)) {
  i4 = HEAP32[i7 + 32 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
    i3 = i1;
    break L1;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    i3 = -1;
    break;
   }
  }
 } else i3 = -1; while (0);
 i2 = (HEAP32[i6 >> 2] | 0) + (i5 << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 & 1073741824) {
  i1 = (HEAP32[i7 + 52 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1073741824;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) >= 0) return;
 i7 = (HEAP32[i7 + 52 >> 2] | 0) + (i3 << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | -2147483648;
 return;
}

function __ZN15CollisionModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 HEAPF32[i1 + 936 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 940 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 944 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 948 >> 0] = 1;
 HEAP8[i1 + 949 >> 0] = 1;
 HEAP32[i1 + 952 >> 2] = 256;
 HEAP32[i1 + 960 >> 2] = 0;
 HEAPF32[i1 + 964 >> 2] = Math_fround(.5);
 HEAP8[i1 + 968 >> 0] = 0;
 HEAP32[i1 + 956 >> 2] = -1;
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 230 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 144 | 0, i1 + 232 | 0, Math_fround(0.0), HEAP16[i1 + 228 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 488 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 494 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 408 | 0, i1 + 496 | 0, Math_fround(1.0), HEAP16[i1 + 492 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 752 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 758 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 672 | 0, i1 + 760 | 0, Math_fround(0.0), HEAP16[i1 + 756 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, gb + 374101 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN21BuiltinShaderSettings17BuiltinShaderModeEEvRT_RT0_PKc17TransferMetaFlags(i6, i7 + 4 | 0, gb + 1034151 | 0, 0);
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 469700 | 0, gb + 479385 | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i7, i6); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN12b2MotorJointC2EPK15b2MotorJointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = i1 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 152320 + 8;
 i5 = i2 + 20 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 92 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 96 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 100 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __ZN12_GLOBAL__N_110Connection22setIsTopLevelUIElementEPKvb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 32 | 0;
 i6 = i4 + 24 | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = gb + 150328 + 8;
 i7 = i8 + 8 | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = 0;
 i1 = i8 + 16 | 0;
 HEAP8[i1 >> 0] = i3 & 1;
 i3 = i2 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 10, 1, 0, 0) | 0;
 HEAP32[i6 >> 2] = gb + 149708 + 8;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP8[i5 >> 0] = 22;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i7 | 0, 8) | 0;
 HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh(i6, i5);
 HEAP8[i1 >> 0] = (HEAP8[i5 >> 0] | 0) != 0 & 1;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN11prophecysdk4half8selftestEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = 0;
 while (1) {
  i4 = i5 >>> 15;
  i6 = i5 >>> 10;
  i2 = i6 & 31;
  i1 = i5 & 1023;
  L3 : do switch (i6 & 31) {
  case 0:
   {
    if (!i1) {
     i1 = i4 << 31;
     break L3;
    } else i2 = 0;
    while (1) {
     i1 = i1 << 1;
     if (i1 & 1024 | 0) break; else i2 = i2 + -1 | 0;
    }
    i1 = i1 & -1026;
    i3 = 12;
    break;
   }
  case 31:
   {
    i1 = ((i1 | 0) == 0 ? 2139095040 : i5 << 13 | 2139095040) | i4 << 31;
    break;
   }
  default:
   i3 = 12;
  } while (0);
  if ((i3 | 0) == 12) {
   i3 = 0;
   i1 = (i2 << 23) + 939524096 | i4 << 31 | i1 << 13;
  }
  HEAP32[gb + 1188616 + (i5 << 2) >> 2] = i1;
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == 65536) {
   i1 = 0;
   break;
  }
 }
 do {
  if ((i1 + -113 | 0) >>> 0 > 28) {
   HEAP16[gb + 1477636 + (i1 << 1) >> 1] = 0;
   HEAP16[gb + 1477636 + ((i1 | 256) << 1) >> 1] = 0;
  } else {
   i6 = (i1 << 10) + -114688 | 0;
   HEAP16[gb + 1477636 + (i1 << 1) >> 1] = i6;
   HEAP16[gb + 1477636 + ((i1 | 256) << 1) >> 1] = i6 | 32768;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 return 1;
}

function __ZNK9ShaderLab11ShaderState29BuildDeviceStatesForWireframeER9GfxDevicePK19ShaderPropertySheetS5_RKS0_RNS0_12DeviceStatesE(i1, i10, i3, i4, i5, i11) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 var f2 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE(i5, i10, i3, i4, i11);
 HEAP32[i6 >> 2] = 2;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i6 + 8 | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 __ZNK9ShaderLab21ShaderRasterStateDesc16ToGfxRasterStateEPK19ShaderPropertySheetS3_R14GfxRasterState(i5 + 556 | 0, i3, i4, i6);
 i1 = HEAP32[i7 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 if (!((HEAP32[i6 >> 2] | 0) != 2 | (i1 | 0) != 0 | f2 != Math_fround(0.0))) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i7 >> 2] = i1 + -1;
 HEAPF32[i8 >> 2] = Math_fround(f2 + Math_fround(-1.0));
 HEAP32[i11 + 12 >> 2] = mftCall_iii(HEAP32[(HEAP32[i10 >> 2] | 0) + 56 >> 2] | 0, i10 | 0, i6 | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 92 | 0, i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 40 | 0, gb + 946522 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 64 | 0, gb + 734913 | 0, 0);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 36 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 52 | 0, gb + 800705 | 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN4crnd13prefix_coding14decoder_tables5clearEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7;
 i5 = i7 + 32 | 0;
 i2 = i4 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + -8 | 0;
  if (!(i1 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i3 >> 2] = gb + 401209;
   HEAP32[i3 + 4 >> 2] = 2513;
   HEAP32[i3 + 8 >> 2] = gb + 401349;
   _sprintf(i5, gb + 401176 | 0, i3) | 0;
   _puts(i5) | 0;
  }
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 164 >> 2] = 0;
 }
 i2 = i4 + 176 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + -8 | 0;
 if (!(i1 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
  HEAP32[i6 >> 2] = gb + 401209;
  HEAP32[i6 + 4 >> 2] = 2513;
  HEAP32[i6 + 8 >> 2] = gb + 401349;
  _sprintf(i5, gb + 401176 | 0, i6) | 0;
  _puts(i5) | 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN15DetailPrototypeD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 124 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 128 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -2 - i2 | 0) >>> 1) << 1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 112 >> 2] | 0;
 if (i1 | 0) {
  i2 = i5 + 116 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 100 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 104 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 88 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 92 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 + 76 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN11TimeManager4SyncEfb(i4, f3, i1) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 var d2 = 0.0, i5 = 0, d6 = 0.0, d7 = 0.0, d8 = 0.0, f9 = f0;
 d6 = +__Z19GetTimeSinceStartupv();
 do if (f3 > Math_fround(0.0)) {
  d8 = 1.0 / +f3 + -.0001;
  f3 = Math_fround(d6);
  i1 = i4 + 208 | 0;
  d2 = +HEAPF64[i1 >> 3];
  f3 = Math_fround(f3 - Math_fround(d2));
  i5 = f3 < Math_fround(0.0);
  f9 = Math_fround(-f3);
  if ((i5 ? f9 : f3) <= Math_fround(9.99999997e-07)) {
   if (__Z20IsHumanControllingUsv() | 0) break;
   d2 = +HEAPF64[i1 >> 3];
  }
  if (d6 - d2 < d8) {
   d2 = +__Z19GetTimeSinceStartupv();
   i4 = 0;
   while (1) {
    d7 = +__Z19GetTimeSinceStartupv();
    i5 = i4 + 1 | 0;
    if ((i4 | 0) > 998) if (d7 - d2 == 0.0) {
     i4 = 10;
     break;
    } else {
     d2 = d7;
     i4 = 0;
    } else i4 = i5;
    d6 = +HEAPF64[i1 >> 3];
    if (!(d7 - d6 < d8)) {
     i4 = 12;
     break;
    }
   }
   if ((i4 | 0) == 10) d2 = +__Z19GetTimeSinceStartupv(); else if ((i4 | 0) == 12) d2 = d8 + d6;
   HEAPF64[i1 >> 3] = d2;
   return;
  }
 } else i1 = i4 + 208 | 0; while (0);
 HEAPF64[i1 >> 3] = +__Z19GetTimeSinceStartupv();
 return;
}

function __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_set_sizeCustomP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, i9 = 0, f10 = f0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i4 = i7 + 64 | 0;
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 if (f8 == (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]))) {
  i1 = i7 + 72 | 0;
  f8 = Math_fround(HEAPF32[i1 >> 2]);
  i2 = i7 + 68 | 0;
  f10 = Math_fround(HEAPF32[i2 >> 2]);
  i9 = f10 == (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (f8 == (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2])) & i9) return;
 } else {
  i2 = i7 + 68 | 0;
  i1 = i7 + 72 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i1 >> 2] = i3;
 HEAP8[i7 + 154 >> 0] = 1;
 return;
}

function __ZN5physx7NpShape12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 93696 + 8;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = gb + 93676 + 8;
 HEAP32[i4 + 16 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 93856 + 8;
 HEAP32[i6 >> 2] = gb + 93856 + 184;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 i6 = i4 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 251658240;
 i6 = i4 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Sc9ShapeCoreC2ERKNS_7PxEMPTYE(i6, i5);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 208;
 __ZN5physx2Sc9ShapeCore15importExtraDataERNS_24PxDeserializationContextE(i6, i2);
 i1 = i2 + 4 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = i6 + 4 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i4 + 192 >> 2] = (i5 | 0) == 0 ? 0 : i6;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i5;
 __ZN5physx7NpShape17resolveReferencesERNS_24PxDeserializationContextE(i4, i2);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 12 | 0;
 i4 = i5;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i3 >> 2] = 0;
 i2 = i3 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i7;
 HEAP32[i2 >> 2] = 0;
 i2 = i6;
 if (!((i7 & 2147483647 | 0) == 0 | (i7 | 0) < 0 | (i6 | 0) == 0)) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 i1 = i3 + 12 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 16 | 0;
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 20 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 i1 = i7;
 if ((i6 & 2147483647 | 0) == 0 | (i6 | 0) < 0 | (i7 | 0) == 0) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Cm10FanoutTaskC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP16[i2 + 4 >> 1] = -1;
 HEAP16[i2 + 6 >> 1] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 101584 + 8;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP8[i2 + 36 >> 0] = 1;
 HEAP32[i2 + 40 >> 2] = i2 + 20;
 HEAP32[i2 + 48 >> 2] = 4;
 HEAP32[i2 + 76 >> 2] = 0;
 HEAP8[i2 + 68 >> 0] = 1;
 HEAP32[i2 + 72 >> 2] = i2 + 52;
 HEAP32[i2 + 80 >> 2] = 4;
 HEAP8[i2 + 84 >> 0] = 0;
 i1 = i2 + 88 | 0;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i2) {
  i3 = 0;
  HEAP32[i1 >> 2] = i3;
  __ZN5physx6shdfnd9MutexImplC2Ev(i3);
  return;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i5 | 0, i4 | 0, i2 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImplC2Ev(i3);
 return;
}

function __ZN5physx16PxcRunNpPCMBatchEjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE(i16, i17, i18, i3, i9, i10, i15, i8, i14, i6, i12, i7, i13, i5, i11, i1, i2, i21, i20, i4, i19) {
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i15 = i15 | 0;
 i8 = i8 | 0;
 i14 = i14 | 0;
 i6 = i6 | 0;
 i12 = i12 | 0;
 i7 = i7 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i21 = i21 | 0;
 i20 = i20 | 0;
 i4 = i4 | 0;
 i19 = i19 | 0;
 HEAP32[i21 >> 2] = 0;
 HEAP32[i20 >> 2] = 0;
 i19 = (i3 | 0) == 0 ? 0 : i3 + 16 | 0;
 __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i19, i8, 0, i14, i1, i2, i21, i20);
 __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i19, i6, 0, i12, i1, i2, i21, i20);
 __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i19, i7, 0, i13, i1, i2, i21, i20);
 __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_(i19, i5, 0, i11, i1, i2, i21, i20);
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP16RenderObjectDatai26RenderDeferredObjectSorterE7SortJobEPS4_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i2 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i5);
 } else i1 = 0;
 i8 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i11 = i3 + 12 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i4;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_(i8, i7, i2, i5);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i7);
 i6 = i5 + 28 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j(i6, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9InputAxis8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __Z20DeformSkinnedMeshJobP12SkinMeshInfo(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1161568 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161568 | 0, i1);
  i2 = gb + 1161568 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) HEAP32[i3 + 36 >> 2] = i1;
 __Z17DeformSkinnedMeshR12SkinMeshInfo(i3);
 if (HEAP8[i3 + 92 >> 0] | 0) {
  i1 = i3 + 84 | 0;
  if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
  i1 = HEAP32[i3 + 100 >> 2] | 0;
  if (i1 | 0) {
   i5 = i1 + 4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   if (!(HEAP32[i5 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
   }
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 }
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i4 = i6 + 244 | 0;
 i7 = i6 + 260 | 0;
 HEAP32[i7 >> 2] = i2;
 i5 = HEAP32[i4 >> 2] | 0;
 i8 = i6 + 256 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  i1 = i5;
  do {
   i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   HEAP32[i1 >> 2] = i2 - i3;
   i1 = i1 + ((i2 >>> 0 <= i3 >>> 0 & 1) << 3) | 0;
  } while (i2 >>> 0 < i3 >>> 0);
  if ((i1 | 0) != (i5 | 0)) {
   i6 = i6 + 248 | 0;
   __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj(i4, i5 + (HEAP32[i6 >> 2] << 3) - i1 >> 3);
   i2 = HEAP32[i4 >> 2] | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + (i6 << 3) | 0;
   if ((i6 | 0) > 0) while (1) {
    i4 = i1;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = i2;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
   }
  }
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
 return;
}

function __ZN5physx7Cooking16cookTriangleMeshERKNS_18PxTriangleMeshDescERNS_14PxOutputStreamE(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i5 | 0, 240, (i1 ? gb + 731983 | 0 : gb + 837976 | 0) | 0, gb + 726521 | 0, 146) | 0;
 __ZN5physx2Gu12TriangleMeshC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 110164 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110164 + 88;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (__ZN5physx7Cooking20loadTriangleMeshDescERKNS_18PxTriangleMeshDescERNS_19TriangleMeshBuilderE(i4, i2, i1) | 0) {
  __ZNK5physx19TriangleMeshBuilder4saveERNS_14PxOutputStreamEbRKNS_15PxCookingParamsE(i1, i3, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0, i4 + 4 | 0) | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 1;
  return i6 | 0;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i6 = 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN5physx10PxGetGroupERKNS_7PxActorE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 48 | 0;
 i1 = i6 + 32 | 0;
 i2 = i6 + 16 | 0;
 i3 = i6;
 switch (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0) {
 case 4:
 case 0:
 case 1:
  {
   HEAP32[i5 >> 2] = 0;
   mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, i5 | 0, 1, 0) | 0;
   i5 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i5 | 0);
   i5 = HEAP32[i1 >> 2] | 0;
   i5 = i5 & 65535;
   STACKTOP = i6;
   return i5 | 0;
  }
 case 2:
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i2 | 0, i4 | 0);
   i5 = HEAP32[i2 >> 2] | 0;
   i5 = i5 & 65535;
   STACKTOP = i6;
   return i5 | 0;
  }
 case 5:
  {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 432 >> 2] | 0, i3 | 0, i4 | 0);
   i5 = HEAP32[i3 >> 2] | 0;
   i5 = i5 & 65535;
   STACKTOP = i6;
   return i5 | 0;
  }
 default:
  {
   i5 = 0;
   i5 = i5 & 65535;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 return 0;
}

function __ZN23CloudWebServicesManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, i1, 16, gb + 1048932 | 0, 0, gb + 1047380 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 189740 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = i2;
 i2 = i4 + 44 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i4 + 48 >> 2] = i2;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1115296 + 32 >> 2] = fb + 428;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0, d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0, d10 = 0.0, d11 = 0.0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i3;
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, i12 | 0) | 0;
 d6 = +HEAPF64[i12 >> 3];
 d7 = +HEAPF64[i12 + 24 >> 3];
 d10 = +HEAPF64[i12 + 8 >> 3];
 d11 = +HEAPF64[i12 + 32 >> 3];
 d8 = +HEAPF64[i12 + 16 >> 3];
 d9 = +HEAPF64[i12 + 40 >> 3];
 HEAPF64[i1 >> 3] = (d6 + d7) * .5;
 HEAPF64[i1 + 8 >> 3] = (d10 + d11) * .5;
 HEAPF64[i1 + 16 >> 3] = (d8 + d9) * .5;
 f5 = Math_fround(d11 - d10);
 f4 = Math_fround(d9 - d8);
 HEAPF32[i1 + 24 >> 2] = Math_fround(Math_fround(d7 - d6) * Math_fround(.5));
 HEAPF32[i1 + 28 >> 2] = Math_fround(f5 * Math_fround(.5));
 HEAPF32[i1 + 32 >> 2] = Math_fround(f4 * Math_fround(.5));
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 32 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx16PxVehicleDriveNW5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj(i4, i3, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i4, i3, i5, i6, i2, 0);
 i6 = i1 + 64 | 0;
 _memcpy(i4 + 224 | 0, i1 | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
 HEAP32[i4 + 288 >> 2] = HEAP32[i6 >> 2];
 i6 = i4 + 304 | 0;
 i5 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 _memcpy(i4 + 336 | 0, i1 + 112 | 0, 416) | 0;
 i6 = i4 + 752 | 0;
 i5 = i1 + 528 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 return;
}

function __ZN4Halo16TransformChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 i4 = HEAP32[gb + 1110376 >> 2] | 0;
 i3 = i1 + 28 | 0;
 __ZNK9Transform11GetPositionEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 28940 | 0) | 0);
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = 1 << HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2];
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i9;
  return;
 }
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i7 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i8 = 6;
   break;
  }
 }
 if ((i8 | 0) == 6) {
  STACKTOP = i9;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = i6;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i3;
 STACKTOP = i9;
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 27520 + 8;
 i1 = i3 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 64 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 68 >> 2] | 0; else i1 = i1 & 255;
 do if (i1 | 0) if (!(HEAP8[i3 + 76 >> 0] | 0)) {
  __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
  __ZN10FileSystem23UnmountMemoryFileSystemEv(__Z13GetFileSystemv() | 0);
  break;
 } else {
  __ZN14CachingManager20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z17GetCachingManagerv() | 0, i2);
  break;
 } while (0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 112 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 96 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZN14AsyncOperationD2Ev(i3);
 return;
}

function __ZN13MonoBehaviour16DelayedStartCallEP6ObjectPv(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = i8 + 141 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  STACKTOP = i7;
  return 1;
 }
 HEAP8[i1 >> 0] = 1;
 i3 = i8 + 60 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if (i1) {
  i2 = HEAPU8[i2 + 100 >> 0] | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i8, i6, 0) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return 1;
 }
 i4 = HEAPU8[i2 + 92 >> 0] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject(i8, i6, 0) | 0;
 STACKTOP = i7;
 return 1;
}

function __ZL16CompareCarveDataRK16NavMeshCarveDataS1_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, f5 = f0;
 f1 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 if (f1 < f2) {
  i4 = 1;
  return i4 | 0;
 }
 if (f2 < f1) {
  i4 = 0;
  return i4 | 0;
 }
 f2 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 if (f2 < f1) {
  i4 = 1;
  return i4 | 0;
 }
 if (f1 < f2) {
  i4 = 0;
  return i4 | 0;
 }
 f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 if (f1 < f2) {
  i4 = 1;
  return i4 | 0;
 }
 if (f2 < f1) {
  i4 = 0;
  return i4 | 0;
 }
 f5 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f5 = Math_fround(f5 * f5);
 f2 = Math_fround(HEAPF32[i3 + 20 >> 2]);
 f2 = Math_fround(f5 + Math_fround(f2 * f2));
 f5 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f5 = Math_fround(f2 + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f2 = Math_fround(f2 * f2);
 f1 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f1 = Math_fround(f2 + Math_fround(f1 * f1));
 f2 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 i4 = f5 > Math_fround(f1 + Math_fround(f2 * f2));
 return i4 | 0;
}

function __Z29StdTemplateConversionFunctionIfdEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, d9 = 0.0, f10 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 < i4 >>> 0) i7 = 4; else {
  i4 = i3 + 4 | 0;
  if (i4 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i6 >> 2] = i4;
  }
 }
 if ((i7 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
 if (!(HEAP32[i2 >> 2] & 512)) {
  f10 = Math_fround(HEAPF32[i5 >> 2]);
  d9 = +f10;
  HEAPF64[i1 >> 3] = d9;
  STACKTOP = i8;
  return 1;
 } else {
  i7 = _llvm_bswap_i32(HEAP32[i5 >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i7;
  f10 = (HEAP32[tempDoublePtr >> 2] = i7, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  d9 = +f10;
  HEAPF64[i1 >> 3] = d9;
  STACKTOP = i8;
  return 1;
 }
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEc(i1, i3, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i1 + 11 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i5 = i2 << 24 >> 24 < 0;
 if (i5) {
  i4 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 } else {
  i4 = 10;
  i6 = i2 & 255;
  i8 = (HEAP32[i3 >> 2] | 0) - i1 | 0;
 }
 if ((i4 | 0) == (i6 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i6, 1, i6, i8, 0, 1);
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  if (i5) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
  i2 = i6 - i8 | 0;
  if (i2) {
   i5 = i3 + i8 | 0;
   _memmove(i5 + 1 | 0, i5 | 0, i2 | 0) | 0;
  }
 }
 HEAP8[i3 + i8 >> 0] = i7;
 i2 = i6 + 1 | 0;
 HEAP8[i3 + i2 >> 0] = 0;
 if ((HEAP8[i9 >> 0] | 0) < 0) {
  HEAP32[i1 + 4 >> 2] = i2;
  i10 = 14;
 } else {
  i7 = i2 & 255;
  HEAP8[i9 >> 0] = i7;
  if (i7 << 24 >> 24 < 0) i10 = 14;
 }
 if ((i10 | 0) == 14) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i8 | 0;
}

function __ZN8VRModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = __Z12GetIVRDevicev() | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  __Z12SetIVRDeviceP9IVRDevice(0);
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63816 | 0);
  HEAP32[i2 + 16 >> 2] = HEAP32[gb + 189476 >> 2];
  HEAP8[i2 + 20 >> 0] = 0;
 }
 i6 = i2 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i4 = i2 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i5 = i7 + 4 | 0;
  do {
   i3 = i2 + -16 | 0;
   HEAP32[i4 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -4 >> 2] | 0;
    HEAP32[i7 >> 2] = 66;
    HEAP32[i5 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i7);
    i2 = HEAP32[i4 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim9animation10SampleClipERKNS0_9DenseClipEfPf(i2, f1, i6) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 f1 = Math_fround(_modff(Math_fround(f1 * Math_fround(HEAPF32[i2 + 8 >> 2])), i4));
 i4 = ~~Math_fround(HEAPF32[i4 >> 2]);
 i8 = i4 + 1 | 0;
 i4 = (i4 | 0) > 0 ? i4 : 0;
 i5 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 i8 = (i8 | 0) > 0 ? i8 : 0;
 i9 = i2 + 20 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = Math_imul((i4 | 0) < (i5 | 0) ? i4 : i5, i3) | 0;
 i2 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
 i4 = i2 + (i4 << 2) | 0;
 i5 = i2 + ((Math_imul((i8 | 0) < (i5 | 0) ? i8 : i5, i3) | 0) << 2) | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 } else i2 = 0;
 do {
  f10 = Math_fround(HEAPF32[i4 + (i2 << 2) >> 2]);
  HEAPF32[i6 + (i2 << 2) >> 2] = Math_fround(f10 + Math_fround(f1 * Math_fround(Math_fround(HEAPF32[i5 + (i2 << 2) >> 2]) - f10)));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i7;
 return;
}

function __ZN6Camera21CleanupAfterRenderingEPK11CullResults(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (i1 | 0) {
  i3 = HEAP32[i1 + 372 >> 2] | 0;
  if (i3 | 0) {
   i4 = i1 + 360 | 0;
   i2 = i1 + 312 | 0;
   i1 = 0;
   do {
    __ZNK19RenderEventsContext7CleanupEv((HEAP32[(HEAP32[i2 >> 2] | 0) + ((HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 * 960 | 0) >> 2] | 0) * 180 | 0) >> 2] | 0) + 208 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i3 | 0));
  }
 }
 __ZNK19RenderEventsContext7CleanupEv(i5 + 1136 | 0);
 __Z22CleanupAfterRenderLoopR10RenderLoop(HEAP32[i5 + 1124 >> 2] | 0);
 i1 = i5 + 1148 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z22GetRenderBufferManagerv() | 0;
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 1152 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z22GetRenderBufferManagerv() | 0;
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i4, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if (__ZNK6Camera16GetStereoEnabledEv(i5) | 0) return;
 __Z19ClearShadowMapCacheP14ShadowMapCache(HEAP32[i5 + 1128 >> 2] | 0);
 return;
}

function __ZN5physx9NpPhysics18createRigidDynamicERKNS_11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = HEAP32[gb + 1457204 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f9 * f9);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f5 * f5)))));
 f7 = Math_fround(f7 * f8);
 f6 = Math_fround(f6 * f8);
 f5 = Math_fround(f5 * f8);
 HEAPF32[i3 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f6;
 HEAPF32[i3 + 12 >> 2] = f5;
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 i2 = __ZN5physx9NpFactory18createRigidDynamicERKNS_11PxTransformE(i4, i3) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN5physx3Ext23DefaultBufferedProfilerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 87220 + 8;
 i1 = i2 + 100 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 96 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 88 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 HEAP32[i2 + 60 >> 2] = gb + 87256 + 8;
 i3 = HEAP32[i2 + 76 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) {
  i3 = i2 + 8 | 0;
  __ZN5physx3Ext19ProfileEventHandlerD2Ev(i3);
  return;
 }
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if (!i1) {
  i3 = i2 + 8 | 0;
  __ZN5physx3Ext19ProfileEventHandlerD2Ev(i3);
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 i3 = i2 + 8 | 0;
 __ZN5physx3Ext19ProfileEventHandlerD2Ev(i3);
 return;
}

function __ZN5physx2Sc13ConstraintSim21checkMaxForceExceededEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP32[i1 + 12 >> 2] | 0)) return;
 i3 = i1 + 100 | 0;
 __ZN5physx2Sc5Scene19addBrokenConstraintEPNS0_14ConstraintCoreE(HEAP32[i1 + 96 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 __ZN5physx2Sc14ConstraintCore10breakApartEv(HEAP32[i3 >> 2] | 0);
 i3 = i1 + 104 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) >>> 0 < (HEAP32[i3 + 28 >> 2] | 0) >>> 0 ? i1 : i3;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (HEAP8[i2 + 21 >> 0] & 1) {
   i2 = (i2 | 0) == 0 ? 0 : i2 + -8 | 0;
   i3 = i2 + 4 | 0;
   HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 1;
   i3 = i2 + 6 | 0;
   if (!(HEAP16[i3 >> 1] & 2)) {
    __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i2);
    HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
   }
  }
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN20BaseBehaviourManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP32[i3 >> 2] = gb + 37612 + 8;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 + 20 >> 2] | 0;
   if (i1 | 0) __ZdlPv(i1);
   i1 = HEAP32[i2 + 24 >> 2] | 0;
   if (i1 | 0) __ZdlPv(i1);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i4, 0);
 return;
}

function __ZN19SkinnedMeshRenderer8TransferI17RemapPPtrTransferEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i4, i5);
 i2 = i4 + 352 | 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i8 = i5 + 40 | 0;
 if (HEAP8[i8 >> 0] | 0) HEAP32[i2 >> 2] = i1;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i5, 1);
 i1 = HEAP32[i4 + 360 >> 2] | 0;
 i2 = HEAP32[i4 + 372 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i8 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i5);
 i2 = i4 + 380 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i8 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN9Coroutine16CleanupCoroutineEPv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + -1;
 if ((i2 | 0) > 1) {
  i3 = 1;
  return i3 | 0;
 }
 HEAP8[i3 + 52 >> 0] = 1;
 i1 = i3 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN9Coroutine16CleanupCoroutineEPv(i2) | 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN14AsyncOperation20SetCoroutineCallbackEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E(i2, 0, 0, 0, 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 12 | 0;
 __Z23scripting_gchandle_freej(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 if (HEAP32[i3 + 48 >> 2] | 0) {
  i3 = 1;
  return i3 | 0;
 }
 __ZdlPv(i3);
 i3 = 0;
 return i3 | 0;
}

function __ZN15AudioReverbZone17GetReverbPropertyEi(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 if ((i1 | 0) < 27) {
  i5 = i3;
  i1 = gb + 171848 + (i1 * 80 | 0) | 0;
  i2 = i5 + 80 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  return;
 } else {
  i5 = i3;
  i1 = gb + 174008 | 0;
  i2 = i5 + 80 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 60 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 64 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 72 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 76 >> 2];
  HEAP32[i3 + 36 >> 2] = HEAP32[i4 + 80 >> 2];
  HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 84 >> 2];
  HEAP32[i3 + 44 >> 2] = HEAP32[i4 + 88 >> 2];
  HEAP32[i3 + 48 >> 2] = HEAP32[i4 + 92 >> 2];
  HEAP32[i3 + 60 >> 2] = HEAP32[i4 + 96 >> 2];
  HEAP32[i3 + 68 >> 2] = HEAP32[i4 + 108 >> 2];
  HEAP32[i3 + 72 >> 2] = HEAP32[i4 + 112 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 68 >> 2];
  HEAP32[i3 + 64 >> 2] = HEAP32[i4 + 100 >> 2];
  return;
 }
}

function __ZN15AnimationBinder23InsertCurveIDIntoLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEERS8_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = (HEAP32[i1 + 68 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0);
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj(i1, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_(i4, i1, i5);
 STACKTOP = i3;
 return HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 20 >> 2] | 0;
}

function __ZN11UmbraModule21BuildMaskShadowCullerERN5Umbra15ShadowCullerExtEPKNS0_10VisibilityEPK22SceneCullingParametersPK8Vector3fSB_i(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __ZnwjRK10MemLabelIdiPKci(102400, gb + 64024 | 0, 16, gb + 612578 | 0, 19) | 0;
 __ZN5Umbra8QueryExtC2EPKNS_4TomeE(i8, HEAP32[i4 + 836 >> 2] | 0);
 __ZN5Umbra15GateStateVectorC2EPvjb(i1, HEAP32[i4 + 840 >> 2] | 0, 0, 0);
 __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE(i8, i1);
 __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE(i8, HEAP32[i4 + 844 >> 2] | 0);
 i1 = __ZN5Umbra8QueryExt21buildMaskShadowCullerERNS_15ShadowCullerExtERKNS_10VisibilityERKNS_7Vector3EPS7_iPfjPPKNS_15CameraTransformEi(i8, i2, i3, i5, i6, i7, 0, 0, 0, 0) | 0;
 if (!i8) {
  __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64024 | 0);
  STACKTOP = i9;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 64024 | 0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN11ShapeModule5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP32[i1 + 8 >> 2] = 4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(25.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(360.0);
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 72 >> 2] = 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1155204 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1155204 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1155204 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[gb + 1155204 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[gb + 1155204 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[gb + 1155204 + 20 >> 2];
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i2 = i1 + 204 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP16[i2 + 8 >> 1] = 0;
 HEAP8[i1 + 214 >> 0] = 1;
 return;
}

function __Z27Animation_CUSTOM_PlayQueuedP12Il2CppObjectP12Il2CppStringii(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  i5 = __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii(i1, i6, Math_fround(0.0), i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  i6 = __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i5, HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 4 >> 2] | 0) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZN8VRModule30BeforeInitializeEngineGraphicsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 __Z24RegisterBuiltinVRDevicesv();
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i1, i6);
 __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i1, i6, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = i5 + 4 | 0;
  i3 = i2;
  while (1) {
   i2 = i3 + -16 | 0;
   HEAP32[i7 >> 2] = i2;
   if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i2 >> 2] | 0;
    i3 = HEAP32[i3 + -4 >> 2] | 0;
    HEAP32[i5 >> 2] = 66;
    HEAP32[i4 >> 2] = i3;
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i5);
    i2 = HEAP32[i7 >> 2] | 0;
   }
   if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
  }
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i8;
 return;
}

function __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAPF32[i4 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 4 >> 2] = Math_fround(-.5);
 HEAPF32[i4 + 8 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 12 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 16 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 20 >> 2] = Math_fround(-.5);
 HEAPF32[i4 + 24 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 28 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 32 >> 2] = Math_fround(.707107007);
 HEAPF32[i4 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 40 >> 2] = Math_fround(.707107007);
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(.707107007);
 HEAPF32[i4 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 60 >> 2] = Math_fround(.707107007);
 i2 = i4 + (i2 << 4) | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx9NpPhysics17createRigidStaticERKNS_11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = HEAP32[gb + 1457204 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f9 * f9);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = Math_fround(f8 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f8 + Math_fround(f5 * f5)))));
 f7 = Math_fround(f7 * f8);
 f6 = Math_fround(f6 * f8);
 f5 = Math_fround(f5 * f8);
 HEAPF32[i3 >> 2] = Math_fround(f9 * f8);
 HEAPF32[i3 + 4 >> 2] = f7;
 HEAPF32[i3 + 8 >> 2] = f6;
 HEAPF32[i3 + 12 >> 2] = f5;
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 i2 = __ZN5physx9NpFactory17createRigidStaticERKNS_11PxTransformE(i4, i3) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i2 = i1 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) != -1) return;
 if (!(HEAP32[i1 + 36 >> 2] & ~HEAP32[i7 + 48 >> 2])) return;
 i8 = i7 + 12 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i2 >> 2] = i9;
 i3 = i9 + 1 | 0;
 i4 = i7 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i3 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i7 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i3;
 HEAP32[(HEAP32[i7 >> 2] | 0) + (i9 << 2) >> 2] = i1;
 return;
}

function __ZN14BillboardAsset11SetVerticesEPK8Vector2fj(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = i5 + 48 | 0;
 i7 = i5 + 60 | 0;
 i1 = i2 << 3;
 i2 = i1 >> 3;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 64 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 3;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i5 + 52 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 3;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 52 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 3;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
}

function __Z28PlayerPrefs_CUSTOM_GetStringP12Il2CppStringS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 40 | 0;
 i7 = i3 + 36 | 0;
 i6 = i3 + 24 | 0;
 i4 = i3 + 12 | 0;
 i5 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i8, i1);
 __ZN11ICallStringC2EP12Il2CppString(i7, i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i8);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i7);
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i6, i4, i5);
 i2 = HEAP8[i6 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i6 >> 2] | 0 : i6, i1 ? HEAP32[i6 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i4 = i6 + 248 | 0;
 i7 = i6 + 264 | 0;
 HEAP32[i7 >> 2] = i2;
 i5 = HEAP32[i4 >> 2] | 0;
 i8 = i6 + 260 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  i1 = i5;
  do {
   i2 = (HEAP32[i1 >> 2] | 0) + i2 | 0;
   HEAP32[i1 >> 2] = i2 - i3;
   i1 = i1 + ((i2 >>> 0 <= i3 >>> 0 & 1) << 3) | 0;
  } while (i2 >>> 0 < i3 >>> 0);
  if ((i1 | 0) != (i5 | 0)) {
   i6 = i6 + 252 | 0;
   __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj(i4, i5 + (HEAP32[i6 >> 2] << 3) - i1 >> 3);
   i2 = HEAP32[i4 >> 2] | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   i3 = i2 + (i6 << 3) | 0;
   if ((i6 | 0) > 0) while (1) {
    i4 = i1;
    i5 = HEAP32[i4 + 4 >> 2] | 0;
    i6 = i2;
    HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i6 + 4 >> 2] = i5;
    i2 = i2 + 8 | 0;
    if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
   }
  }
 }
 i6 = HEAP32[i8 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = i6 >>> 0 < i7 >>> 0 ? i6 : i7;
 return;
}

function __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyINS_12PxFilterDataEEEbRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 if (!(HEAP8[i1 + 36 >> 0] | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = gb + 832307 | 0; else i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 + -1 << 3) >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i5 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == 0 | i3 ^ 1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = _strtoul(i1, i5, 10) | 0;
 HEAP32[i4 + 4 >> 2] = _strtoul(HEAP32[i5 >> 2] | 0, i5, 10) | 0;
 HEAP32[i4 + 8 >> 2] = _strtoul(HEAP32[i5 >> 2] | 0, i5, 10) | 0;
 HEAP32[i4 + 12 >> 2] = _strtoul(HEAP32[i5 >> 2] | 0, 0, 10) | 0;
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN22ProceduralMaterialDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i2 + 11 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i1 + 80;
 i2 = i1 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 1;
 return;
}

function __ZN13GfxDeviceGLES17CreateIndexBufferEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 i3 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63304 | 0, 16, gb + 603515 | 0, 1412) | 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 1;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 i5 = i3 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 76952 + 8;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, gb + 63664 | 0);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP8[i3 + 56 >> 0] = 0;
 HEAP32[i5 >> 2] = 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 0:
  {
   i1 = 4;
   break;
  }
 case 1:
  {
   i1 = 5;
   break;
  }
 case 2:
  {
   i1 = 6;
   break;
  }
 default:
  i1 = 5;
 }
 HEAP32[i3 + 32 >> 2] = i1;
 __ZN9GfxDevice14OnCreateBufferEP9GfxBuffer(i2, i3);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i3, i4);
 i6 = i4 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i7 = i4 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
  i1 = HEAP8[i5 >> 0] | 0;
 } else {
  i1 = HEAP8[i1 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  HEAP32[i6 >> 2] = i2;
 }
 HEAP8[i3 + 56 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i4);
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 } else {
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i6 >> 2] = i3;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i8, i5, i6, i7) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i2 = i8 + 8 | 0;
 i9 = i2 + 3 | 0;
 i1 = HEAP8[i9 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i4 = HEAP32[i8 + 4 >> 2] | 0; else i4 = i1 & 255;
 if (i4 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i6 | 0) {
  if (i3) i1 = (HEAP32[i2 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
  if ((i1 - i4 | 0) >>> 0 < i6 >>> 0) {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i8, i1, i4 + i6 - i1 | 0, i4, i5, 0, i6);
   i2 = HEAP32[i8 >> 2] | 0;
  } else {
   if (i3) i2 = HEAP32[i8 >> 2] | 0; else i2 = i8;
   i1 = i4 - i5 | 0;
   i3 = i2 + (i5 << 2) | 0;
   if (i1) __ZNSt3__211char_traitsIwE4moveEPwPKwj(i3 + (i6 << 2) | 0, i3, i1) | 0;
  }
  __ZNSt3__211char_traitsIwE6assignEPwjw(i2 + (i5 << 2) | 0, i6, i7) | 0;
  i1 = i4 + i6 | 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
 }
 return i8 | 0;
}

function __ZN9TextAsset9SetScriptERK8UnityStrb(i7, i2, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = __Z20push_allocation_rootPvP13BaseAllocatorb(i7, 0, 0) | 0;
 i1 = i7 + 48 | 0;
 do if ((i1 | 0) != (i2 | 0)) {
  i6 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i6 << 24 >> 24 < 0;
  i8 = i4 ? HEAP32[i2 >> 2] | 0 : i2;
  i6 = i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255;
  i4 = i1 + 11 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  if (i3) i5 = (HEAP32[i7 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
  if (i6 >>> 0 > i5 >>> 0) {
   if (i3) i2 = HEAP32[i7 + 52 >> 2] | 0; else i2 = i2 & 255;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i8);
   break;
  }
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
  HEAP8[i1 + i6 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i7 + 52 >> 2] = i6;
   break;
  } else {
   HEAP8[i4 >> 0] = i6;
   break;
  }
 } while (0);
 if (!i9) return 1;
 __Z19pop_allocation_rootv();
 return 1;
}

function __ZN9InputAxis7SetNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = i6 + 4 | 0;
 i9 = i7 + 11 | 0;
 i8 = HEAP8[i9 >> 0] | 0;
 i4 = i8 << 24 >> 24 < 0;
 i10 = i4 ? HEAP32[i7 >> 2] | 0 : i7;
 i8 = i4 ? HEAP32[i7 + 4 >> 2] | 0 : i8 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i6 + 12 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 do if (i8 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i6 + 8 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i8 - i5 | 0, i2, 0, i2, i8, i10);
 } else {
  if (i3) i1 = HEAP32[i1 >> 2] | 0;
  if (i8 | 0) _memmove(i1 | 0, i10 | 0, i8 | 0) | 0;
  HEAP8[i1 + i8 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i6 + 8 >> 2] = i8;
   break;
  } else {
   HEAP8[i4 >> 0] = i8;
   break;
  }
 } while (0);
 HEAP32[i6 + 20 >> 2] = __Z7FNVHashPKc((HEAP8[i9 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7) | 0;
 return;
}

function __ZN7ApiGLES17CopyBufferSubDataEjjlll(i6, i7, i3, i8, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i1 = 2;
 i2 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i4 + 860 >> 2] | 0, i1) | 0;
 i1 = i4 + 892 + (i1 << 2) | 0;
 if (!(HEAP8[i4 + 1992 >> 0] | 0)) i5 = 5; else if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) i5 = 5;
 if ((i5 | 0) == 5) {
  HEAP32[i1 >> 2] = i3;
  mftCall_vii(HEAP32[i4 + 644 >> 2] | 0, i2 | 0, i3 | 0);
 }
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 i1 = i2 + 904 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) {
  i7 = i6 + 684 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_viiiii(i7 | 0, 36662, 36663, i8 | 0, i9 | 0, i10 | 0);
  return;
 }
 HEAP32[i1 >> 2] = i7;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 36662, i7 | 0);
 i7 = i6 + 684 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_viiiii(i7 | 0, 36662, 36663, i8 | 0, i9 | 0, i10 | 0);
 return;
}

function __ZN5physx7NpScene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 | 0) > 36) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 678666 | 0, 2633, gb + 705546 | 0, i4);
  i2 = 0;
  STACKTOP = i4;
  return i2 | 0;
 }
 if (f3 < Math_fround(0.0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 678666 | 0, 2638, gb + 705597 | 0, i4 + 8 | 0);
  i2 = 0;
  STACKTOP = i4;
  return i2 | 0;
 }
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(i2 + 32 | 0, i1, f3);
  i2 = 1;
  STACKTOP = i4;
  return i2 | 0;
 } else {
  HEAP8[i2 + 3028 + i1 >> 0] = 1;
  HEAPF32[i2 + 2880 + (i1 << 2) >> 2] = f3;
  i2 = i2 + 3388 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 64;
  i2 = 1;
  STACKTOP = i4;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx2Sn13XmlWriterImpl5writeEPKcRKNS_12PxRepXObjectE(i9, i8, i1) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i7 = i11 + 8 | 0;
 i5 = i9 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i7;
 i4 = i3 + 128 | 0;
 do {
  HEAP8[i3 >> 0] = 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i4 = i10;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 __ZN5physx6string9sprintf_sEPcjPKcz(i7, 128, gb + 1084511 | 0, i10) | 0;
 if (HEAP8[i7 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i6 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i6 | 0, i7 | 0, _strlen(i7) | 0) | 0;
 }
 i7 = HEAP32[i9 + 8 >> 2] | 0;
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP8[i10 >> 0] = 0;
 mftCall_iiii(HEAP32[HEAP32[i9 >> 2] >> 2] | 0, i9 | 0, i10 | 0, 1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0, i8 | 0, HEAP32[i9 + 20 >> 2] | 0);
 HEAP32[i9 + 16 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 STACKTOP = i11;
 return;
}

function __ZN5physx29PxVehicleDriveGeneratedValuesC2EPKNS_14PxVehicleDriveE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 108 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 112 | 0;
 i4 = i1 + 128 | 0;
 i5 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 return;
}

function __ZN22RenderingCommandBuffer15AddDrawRendererEP8RendererP8Materialii(i10, i1, i2, i11, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i1) i9 = 0; else i9 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) i7 = 0; else i7 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i8 = i10 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i10 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 0;
 i4 = i4 + 7 & -4;
 i5 = i4 + 24 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i8 = i1 + i4 | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP16[i8 + 8 >> 1] = i11;
 HEAP16[i8 + 10 >> 1] = i12;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 i12 = i10 + 32 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + 1;
 return;
}

function __ZN15OcclusionPortal7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(76, i1, 16, gb + 1048932 | 0, 0, gb + 380558 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 35128 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = i4;
 HEAP8[i4 + 72 >> 0] = 1;
 HEAP32[i4 + 68 >> 2] = -1;
 HEAPF32[i4 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 64 >> 2] = Math_fround(1.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i7);
 i6 = i5 + 32 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j(i6, i1);
 i2 = HEAP32[i5 + 36 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelperD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149440 + 8;
 HEAP32[i1 + 84 >> 2] = gb + 149600 + 8;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 88 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 96 >> 2] | 0);
 }
 HEAP32[i1 + 60 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 64 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 72 >> 2] | 0);
 }
 HEAP32[i1 + 36 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 40 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 48 >> 2] | 0);
 }
 HEAP32[i1 + 12 >> 2] = gb + 149616 + 8;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z32Renderer_CUSTOM_GetPropertyBlockP12Il2CppObjectS0_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517678 | 0, i2);
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 517678 | 0, i2);
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) {
  i2 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 8 | 0);
 if (!(HEAP32[i3 + 32 + 192 >> 2] | 0)) {
  __ZN19ShaderPropertySheet5ClearEb(i2, 1);
  STACKTOP = i5;
  return;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN19ShaderPropertySheet8CopyFromERKS_(i2, HEAP32[i1 + 32 + 192 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Get_Glyph_Name(i5, i6, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i8 = 35;
  return i8 | 0;
 }
 if ((i7 | 0) == 0 | (i8 | 0) == 0) {
  i8 = 6;
  return i8 | 0;
 }
 HEAP8[i7 >> 0] = 0;
 if ((HEAP32[i5 + 16 >> 2] | 0) <= (i6 | 0)) {
  i8 = 16;
  return i8 | 0;
 }
 if (!(HEAP32[i5 + 8 >> 2] & 512)) {
  i8 = 6;
  return i8 | 0;
 }
 i4 = i5 + 128 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 switch (i1 | 0) {
 case 0:
  {
   i2 = 6;
   break;
  }
 case -2:
  {
   i8 = 6;
   return i8 | 0;
  }
 default:
  {}
 }
 do if ((i2 | 0) == 6) {
  i1 = HEAP32[i5 + 96 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
  if (!i2) {
   HEAP32[i3 >> 2] = -2;
   i8 = 6;
   return i8 | 0;
  } else {
   i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1007761 | 0) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] = i1 | 0 ? i1 : -2;
   if (!i1) i1 = 6; else break;
   return i1 | 0;
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i8 = 6;
  return i8 | 0;
 }
 i8 = mftCall_iiiii(i1 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 return i8 | 0;
}

function _lockf(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i6 = i9 + 8 | 0;
 i5 = i9;
 i4 = i9 + 24 | 0;
 HEAP16[i4 >> 1] = 1;
 HEAP16[i4 + 2 >> 1] = 1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i1;
 i1 = i4 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 switch (i3 | 0) {
 case 3:
  {
   HEAP16[i4 >> 1] = 0;
   HEAP32[i5 >> 2] = i4;
   if ((_fcntl(i2, 12, i5) | 0) < 0) i1 = -1; else if ((HEAP16[i4 >> 1] | 0) == 2) i1 = 0; else {
    i7 = HEAP32[i1 >> 2] | 0;
    if ((i7 | 0) == (_getpid() | 0)) i1 = 0; else {
     HEAP32[(___errno_location() | 0) >> 2] = 13;
     i1 = -1;
    }
   }
   break;
  }
 case 0:
  {
   HEAP16[i4 >> 1] = 2;
   i8 = 7;
   break;
  }
 case 2:
  {
   i8 = 7;
   break;
  }
 case 1:
  {
   HEAP32[i7 >> 2] = i4;
   i1 = _fcntl(i2, 14, i7) | 0;
   break;
  }
 default:
  {
   HEAP32[(___errno_location() | 0) >> 2] = 22;
   i1 = -1;
  }
 }
 if ((i8 | 0) == 7) {
  HEAP32[i6 >> 2] = i4;
  i1 = _fcntl(i2, 13, i6) | 0;
 }
 STACKTOP = i9;
 return i1 | 0;
}

function _h2v1_downsample(i1, i4, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 i6 = HEAP32[i4 + 28 >> 2] | 0;
 i9 = i6 << 3;
 i5 = HEAP32[i1 + 220 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = i6 << 4;
 if ((i5 | 0) > 0 & (i1 - i3 | 0) > 0) {
  i2 = i3 + ~i1 | 0;
  i2 = (i1 | 2) - i3 + ((i2 | 0) > -2 ? i2 : -2) | 0;
  i1 = 0;
  do {
   i6 = (HEAP32[i7 + (i1 << 2) >> 2] | 0) + i3 | 0;
   _memset(i6 | 0, HEAP8[i6 + -1 >> 0] | 0, i2 | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i6 = i4 + 12 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 if (!i9) {
  i1 = 0;
  do i1 = i1 + 1 | 0; while ((i1 | 0) < (i2 | 0));
  return;
 } else i3 = 0;
 do {
  i1 = HEAP32[i8 + (i3 << 2) >> 2] | 0;
  i2 = HEAP32[i7 + (i3 << 2) >> 2] | 0;
  i4 = 0;
  i5 = 0;
  while (1) {
   HEAP8[i1 >> 0] = ((HEAPU8[i2 >> 0] | 0) + i5 + (HEAPU8[i2 + 1 >> 0] | 0) | 0) >>> 1;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i9 | 0)) break; else {
    i1 = i1 + 1 | 0;
    i2 = i2 + 2 | 0;
    i5 = i5 ^ 1;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i6 >> 2] | 0));
 return;
}

function __ZN26AnimatorControllerPlayable10SetIntegerEiRKi(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i4 = 8;
  return i4 | 0;
 }
 i1 = i4 + 92 | 0;
 i6 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i5 | 0) == 0 ? 0 : i6 + i5 | 0, i2) | 0;
 if ((i2 | 0) == -1) {
  i6 = 4;
  return i6 | 0;
 }
 i6 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 2) >> 2] | 0) != -1) {
  i6 = 16;
  return i6 | 0;
 }
 i1 = (HEAP32[i1 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) != 3) {
  i6 = 2;
  return i6 | 0;
 }
 i6 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) + 36 | 0;
 HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2] = i3;
 i6 = 1;
 return i6 | 0;
}

function __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i3 = i4;
 i1 = i1 + 192 | 0;
 i2 = i3 + 108 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 HEAP32[i4 + 108 >> 2] = HEAP32[i5 + 80 >> 2];
 i1 = __ZNK16LightmapSettings14GetLightProbesEv(i5) | 0;
 if (!i1) i6 = 4; else {
  i2 = i1 + 32 | 0;
  if (!(__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2) | 0)) i6 = 4; else {
   HEAP32[i4 + 112 >> 2] = i2;
   HEAP32[i4 + 116 >> 2] = i1 + 148;
   HEAP32[i4 + 120 >> 2] = i1 + 168;
   HEAP32[i4 + 124 >> 2] = HEAP32[i1 + 188 >> 2];
  }
 }
 if ((i6 | 0) == 4) {
  i6 = i4 + 112 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
 }
 i3 = (__ZNK16LightmapSettings19AreLightProbesBakedEv(i5) | 0) & 1;
 i6 = i4 + 128 | 0;
 HEAP8[i6 >> 0] = HEAP8[i6 >> 0] & -2 | i3;
 i4 = __ZNK16LightmapSettings23HasLightProbeTetrahedraEv(i5) | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i5 & -3 | (i4 ? i5 << 1 & 2 : 0);
 return;
}

function __ZN14BillboardAsset9SetImagesEPK8Vector4fj(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = i5 + 28 | 0;
 i7 = i5 + 40 | 0;
 i1 = i2 << 4;
 i2 = i1 >> 4;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 32 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 4 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 4;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
}

function __Z43InitializeRendererAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 410128 | 0, 391) | 0;
 HEAP32[i1 >> 2] = gb + 44836 + 8;
 HEAP32[gb + 1158360 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 25, 21, HEAP32[gb + 1158360 >> 2] | 0);
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 410128 | 0, 395) | 0;
 HEAP32[i1 >> 2] = gb + 44876 + 8;
 HEAP32[gb + 1158368 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 25, 22, HEAP32[gb + 1158368 >> 2] | 0);
 i1 = __ZnwjRK10MemLabelIdiPKci(264, gb + 63320 | 0, 16, gb + 410128 | 0, 399) | 0;
 HEAP32[i1 >> 2] = gb + 64732 + 8;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[gb + 1158364 >> 2] = i1;
 __ZN22GenericPropertyBinding8RegisterEPKc11ClassIDTypePFfPvEPFvS3_fE(i1, gb + 404998 | 0, 100001, fb + 198 | 0, fb + 153 | 0);
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 25, 26, HEAP32[gb + 1158364 >> 2] | 0);
 return;
}

function __Z22IsSplashScreenFinishedv() {
 var i1 = 0, i2 = 0, d3 = 0.0;
 switch (HEAP32[gb + 1157848 >> 2] | 0) {
 case 0:
  {
   i2 = 9;
   break;
  }
 case 3:
  {
   i1 = 3;
   break;
  }
 default:
  {
   do if (+Math_fround(+__Z19GetTimeSinceStartupv() - +HEAPF64[gb + 1098064 >> 3]) >= +HEAPF64[gb + 1098080 >> 3]) {
    if ((HEAP32[gb + 1157848 >> 2] | 0) == 1) {
     i1 = (HEAP32[gb + 1157872 >> 2] | 0) + 1 | 0;
     HEAP32[gb + 1157872 >> 2] = i1;
     if (!(__ZL17CreateLogoPresetsj(i1) | 0)) {
      HEAP32[gb + 1157848 >> 2] = 2;
      HEAPF64[gb + 1098080 >> 3] = .5;
      d3 = +__Z19GetTimeSinceStartupv();
      HEAPF64[gb + 1098064 >> 3] = d3;
      break;
     }
    } else HEAP32[gb + 1157848 >> 2] = 3;
    d3 = +__Z19GetTimeSinceStartupv();
    HEAPF64[gb + 1098064 >> 3] = d3;
   } while (0);
   i1 = HEAP32[gb + 1157848 >> 2] | 0;
   if (!i1) i2 = 9;
  }
 }
 do if ((i2 | 0) == 9) if (__ZNK26PlayerSettingsSplashScreen24GetShowUnitySplashScreenEv((__Z17GetPlayerSettingsv() | 0) + 144 | 0) | 0) {
  i1 = HEAP32[gb + 1157848 >> 2] | 0;
  break;
 } else {
  i2 = 1;
  return i2 | 0;
 } while (0);
 i2 = (i1 | 0) == 3;
 return i2 | 0;
}

function _jpeg_finish_decompress(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 + -205 | 0) >>> 0 < 2) if (!(HEAP8[i3 + 64 >> 0] | 0)) {
  if ((HEAP32[i3 + 120 >> 2] | 0) >>> 0 < (HEAP32[i3 + 96 >> 2] | 0) >>> 0) {
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 + 20 >> 2] = 67;
   mftCall_vi(HEAP32[i2 >> 2] | 0, i3 | 0);
  }
  mftCall_vi(HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
  HEAP32[i1 >> 2] = 210;
 } else i4 = 6; else i4 = 6;
 L7 : do if ((i4 | 0) == 6) switch (i2 | 0) {
 case 210:
  break L7;
 case 207:
  {
   HEAP32[i1 >> 2] = 210;
   break L7;
  }
 default:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 + 20 >> 2] = 20;
   HEAP32[i1 + 24 >> 2] = i2;
   mftCall_vi(HEAP32[i1 >> 2] | 0, i3 | 0);
   break L7;
  }
 } while (0);
 i1 = i3 + 400 | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (HEAP8[i2 + 17 >> 0] | 0) break;
  if (!(mftCall_ii(HEAP32[i2 >> 2] | 0, i3 | 0) | 0)) {
   i1 = 0;
   i4 = 13;
   break;
  }
 }
 if ((i4 | 0) == 13) return i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 + 24 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 _jpeg_abort(i3);
 i4 = 1;
 return i4 | 0;
}

function __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = i8 + 8 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 i1 = i6;
 if ((((HEAP32[i9 >> 2] | 0) - i6 | 0) / 12 | 0) >>> 0 >= i4 >>> 0) return;
 i10 = i8 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i3 = i2;
 if (!i4) i5 = 0; else i5 = __Znwj(i4 * 12 | 0) | 0;
 i2 = i5 + (((i2 - i6 | 0) / 12 | 0) * 12 | 0) | 0;
 i7 = i2;
 i5 = i5 + (i4 * 12 | 0) | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = i7;
  i3 = i6;
 } else {
  i4 = i7;
  do {
   i3 = i3 + -12 | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2 + -12 | 0, i3);
   i2 = i4 + -12 | 0;
   i4 = i2;
  } while ((i3 | 0) != (i1 | 0));
  i3 = HEAP32[i8 >> 2] | 0;
  i1 = HEAP32[i10 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i4;
 HEAP32[i10 >> 2] = i7;
 HEAP32[i9 >> 2] = i5;
 i2 = i3;
 if ((i1 | 0) != (i2 | 0)) do {
  i1 = i1 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 } while ((i1 | 0) != (i2 | 0));
 if (!i3) return;
 __ZdlPv(i3);
 return;
}

function __ZNK13RenderTexture20GetRuntimeMemorySizeEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i2 = HEAP32[i8 + 80 >> 2] | 0;
 i3 = HEAP32[i8 + 84 >> 2] | 0;
 i6 = HEAP32[i8 + 92 >> 2] | 0;
 i1 = HEAP32[i8 + 96 >> 2] | 0;
 i9 = HEAP32[i8 + 100 >> 2] | 0;
 i5 = HEAP32[i8 + 104 >> 2] | 0;
 i7 = (HEAP8[i8 + 116 >> 0] | 0) == 0;
 switch (i1 | 0) {
 case 1:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 505 >> 0] | 0)) i4 = 4; else i1 = 0;
   break;
  }
 case 3:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0)) i4 = 4; else i1 = 0;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) i1 = HEAP32[gb + 44480 + (i1 << 2) >> 2] | 0;
 i2 = Math_imul(i3, i2) | 0;
 i1 = Math_imul(i1, i2) | 0;
 switch (i5 | 0) {
 case 3:
 case 5:
 case 6:
  {
   i1 = Math_imul(i1, i6) | 0;
   break;
  }
 case 4:
  {
   i1 = i1 * 6 | 0;
   break;
  }
 default:
  {}
 }
 if (!i7) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 170 >> 0] | 0) i1 = ((i1 | 0) / 3 | 0) + i1 | 0;
 i9 = (Math_imul(HEAP32[gb + 44572 + (i9 << 2) >> 2] | 0, i2) | 0) + i1 | 0;
 return Math_imul(i9, HEAP32[i8 + 88 >> 2] | 0) | 0;
}

function __ZN8LODGroup10SetEnabledEb(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i8 + 72 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) == (i1 & 1 | 0)) return;
 HEAP8[i2 >> 0] = i1 & 1;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (!i1) i7 = 0; else i7 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 i5 = i8 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i6 = i8 + 88 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2) {
   i4 = i8 + 76 | 0;
   i3 = 0;
   i1 = i2;
   do {
    i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
    i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
    if ((i2 | 0) != -1) {
     i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     i1 = HEAP32[i6 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i6 >> 2] = 0;
  if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = -1;
 }
 if (!i7) return;
 __ZN8LODGroup6CreateEv(i8);
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty(i7, i6, i3, i4) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 2 | 0;
 i1 = i8;
 HEAP16[i1 >> 1] = i6;
 i5 = i7 + 280 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i7 + 212 | 0, i1, i2) | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i6;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i1 | 0, i3 | 0, i4 | 0, 0);
 }
 if (!(HEAP8[i7 + 276 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9stopEventEty(i7, i6, i3, i4);
 STACKTOP = i8;
 return;
}

function __ZN5physx3Cct10Controller18filterTouchedShapeERKNS_19PxControllerFiltersE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i1 = i7;
 i5 = i7 + 36 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 };
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP16[i4 + 16 >> 1] = 6;
 HEAP8[i4 + 18 >> 0] = 0;
 HEAP16[i5 >> 1] = 4;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = (mftCall_iiiiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, HEAP32[i6 + 244 >> 2] | 0, HEAP32[i6 + 248 >> 2] | 0, i5 | 0) | 0) != 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2Sc8ClothSim14insertShapeSimEjPKNS0_8ShapeSimE(i4, i6, i7) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i5 = i4 + 116 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i4 + 120 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 124 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] = 0;
  i4 = i3 + 1 | 0;
  HEAP32[i2 >> 2] = i4;
  i2 = i4;
 } else {
  __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i5, i1) | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i1 = i2 + -1 | 0;
 if (i1 >>> 0 <= i6 >>> 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = i5 + (i6 << 2) | 0;
  HEAP32[i6 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 while (1) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i4 + (i2 + -2 << 2) >> 2];
  i2 = i1 + -1 | 0;
  if (i2 >>> 0 > i6 >>> 0) {
   i4 = i1;
   i1 = i2;
   i2 = i4;
  } else break;
 }
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = i5 + (i6 << 2) | 0;
 HEAP32[i6 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __ZN5physx22PxShapeGeneratedValuesC2EPKNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i2 + 4 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i2 + 44 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i2 + 72 | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i2 + 88 | 0, i1 | 0);
 HEAPF32[i2 + 104 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 108 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
 HEAP8[i2 + 112 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 113 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAP32[i2 + 116 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 120 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 124 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 57 >> 0] | 0)) return;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[gb + 1159952 >> 2] | 0;
 i2 = 1 << (i4 & 31);
 if (!(HEAP8[i1 + 56 >> 0] | 0)) {
  i4 = i3 + (i4 >>> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i2;
 } else {
  i4 = i3 + (i4 >>> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i2;
 }
 i4 = i1 + 4 | 0;
 i3 = i1 + 8 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) + 1664 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i2 = i1 + 24 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 1648 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i3 = i1 + 40 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + 1680 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __ZN18CrashReportManager12CloseServiceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZN18CrashReportHandler12CloseServiceEv(i3);
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i3 + 40 | 0, HEAP32[i3 + 44 >> 2] | 0);
 i1 = i3 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i6 = HEAP32[i3 + 32 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 }
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i3 + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = 66;
  HEAP32[i4 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63160 | 0);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_110Connection11setPickableEPKvb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 32 | 0;
 i6 = i4 + 24 | 0;
 i8 = i4;
 HEAP32[i8 >> 2] = gb + 150408 + 8;
 i7 = i8 + 8 | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = 0;
 i1 = i8 + 16 | 0;
 HEAP8[i1 >> 0] = i2 & 1;
 i3 = i3 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 10, 1, 0, 0) | 0;
 HEAP32[i6 >> 2] = gb + 149708 + 8;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP8[i5 >> 0] = 20;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0, 1) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i7 | 0, 8) | 0;
 HEAP8[i5 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh(i6, i5);
 HEAP8[i1 >> 0] = (HEAP8[i5 >> 0] | 0) != 0 & 1;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN11TerrainData14BeforeShutdownEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 8 | 0;
 i7 = i6;
 i2 = i6 + 16 | 0;
 i5 = gb + 64016 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 66968 | 0, i2, 0);
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __Z22delete_object_internalP6Object(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 884 >> 2] | 0;
 HEAPF32[i1 + 880 >> 2] = f2;
 HEAP8[i1 + 886 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 800 | 0, i1 + 888 | 0, f2, HEAP16[i1 + 884 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z19IsDirectoryWritableRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 1072 | 0;
 i4 = i2 + 12 | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 488252 | 0, 14);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i4, i1, i5);
 __Z17GetUniqueTempPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 i1 = __ZN15FileSystemEntry12CreateAsFileEv(i4) | 0;
 __ZN15FileSystemEntry6DeleteEb(i4, 0) | 0;
 __ZN13FileEntryDataD2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function _cf2_doStems(i1, i8, i9, i2, i10) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i13;
 i12 = _cf2_stack_count(i8) | 0;
 i7 = i12 & 1;
 if (i7 | 0) if (!(HEAP8[i10 >> 0] | 0)) {
  i6 = _cf2_stack_getReal(i8, 0) | 0;
  HEAP32[i2 >> 2] = (_cf2_getNominalWidthX(HEAP32[i1 + 132 >> 2] | 0) | 0) + i6;
 }
 if (HEAP8[(HEAP32[i1 + 132 >> 2] | 0) + 561 >> 0] | 0) {
  HEAP8[i10 >> 0] = 1;
  STACKTOP = i13;
  return;
 }
 if (i7 >>> 0 < i12 >>> 0) {
  i3 = i11 + 4 | 0;
  i4 = i11 + 8 | 0;
  i5 = i11 + 12 | 0;
  i6 = i11 + 16 | 0;
  i2 = 0;
  i1 = i7;
  do {
   i7 = (_cf2_stack_getReal(i8, i1) | 0) + i2 | 0;
   HEAP32[i3 >> 2] = i7;
   i2 = (_cf2_stack_getReal(i8, i1 + 1 | 0) | 0) + i7 | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP8[i11 >> 0] = 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   _cf2_arrstack_push(i9, i11);
   i1 = i1 + 2 | 0;
  } while (i1 >>> 0 < i12 >>> 0);
 }
 _cf2_stack_clear(i8);
 HEAP8[i10 >> 0] = 1;
 STACKTOP = i13;
 return;
}

function __ZNSt3__220__get_up_to_n_digitsIwPwEEiRT0_S2_RjRKNS_5ctypeIT_EEi(i4, i5, i6, i7, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i5 | 0)) {
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 6;
  i1 = 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, 2048, i1 | 0) | 0)) {
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
   i1 = 0;
   break;
  }
  i1 = (mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0, i1 | 0, 0) | 0) << 24 >> 24;
  i3 = i2;
  while (1) {
   i2 = (HEAP32[i4 >> 2] | 0) + 4 | 0;
   HEAP32[i4 >> 2] = i2;
   i1 = i1 + -48 | 0;
   if (!((i3 | 0) > 1 & (i2 | 0) != (i5 | 0))) break;
   i2 = HEAP32[i2 >> 2] | 0;
   if (!(mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, 2048, i2 | 0) | 0)) break L1;
   i1 = ((mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 52 >> 2] | 0, i7 | 0, i2 | 0, 0) | 0) << 24 >> 24) + (i1 * 10 | 0) | 0;
   i3 = i3 + -1 | 0;
  }
  if ((i2 | 0) == (i5 | 0)) HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__214__num_put_base14__format_floatEPcPKcj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (i2 & 2048) {
  HEAP8[i1 >> 0] = 43;
  i1 = i1 + 1 | 0;
 }
 if (i2 & 1024) {
  HEAP8[i1 >> 0] = 35;
  i1 = i1 + 1 | 0;
 }
 i7 = i2 & 260;
 i4 = i2 >>> 14;
 i6 = (i7 | 0) == 260;
 if (i6) i5 = 0; else {
  HEAP8[i1 >> 0] = 46;
  HEAP8[i1 + 1 >> 0] = 42;
  i5 = 1;
  i1 = i1 + 2 | 0;
 }
 while (1) {
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 << 24 >> 24)) break;
  HEAP8[i1 >> 0] = i2;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 L14 : do switch (i7 & 511) {
 case 4:
  if (!(i4 & 1)) {
   HEAP8[i1 >> 0] = 102;
   break L14;
  } else {
   HEAP8[i1 >> 0] = 70;
   break L14;
  }
 case 256:
  if (!(i4 & 1)) {
   HEAP8[i1 >> 0] = 101;
   break L14;
  } else {
   HEAP8[i1 >> 0] = 69;
   break L14;
  }
 default:
  {
   i2 = (i4 & 1 | 0) != 0;
   if (i6) if (i2) {
    HEAP8[i1 >> 0] = 65;
    break L14;
   } else {
    HEAP8[i1 >> 0] = 97;
    break L14;
   } else if (i2) {
    HEAP8[i1 >> 0] = 71;
    break L14;
   } else {
    HEAP8[i1 >> 0] = 103;
    break L14;
   }
  }
 } while (0);
 return i5 | 0;
}

function __ZN8Animator12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN10HumanTrait12CleanupClassEv();
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 1540 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + 772 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 308 | 0)) {
   i4 = i7 + 772 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + 772 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + 772 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + 772 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + 772 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 772 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + 772 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + 772 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Unity5Joint5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) i4 = 4; else if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i2) | 0) {
  f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 + 16 >> 2]));
  HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 44 >> 2] = f6;
  HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  i4 = i1 + 40 | 0;
  HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 }
 i4 = i1 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP8[i1 + 36 >> 0] = 1;
 i4 = i1 + 64 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 62524 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62524 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62524 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN12TreeRenderer11ReloadTreesEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i(i2, i4 + 136 | 0, i4 + 120 | 0, i1) | 0;
  i2 = i4 + 148 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!((i3 | 0) == (i1 | 0) | (i3 | 0) == 0)) {
   __ZN14TreeBinaryTreeD2Ev(i3);
   __ZdlPv(i3);
  }
  HEAP32[i2 >> 2] = i1;
  i1 = i4 + 176 | 0;
  i2 = i4 + 192 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 180 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 188 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i4 + 156 | 0;
 i2 = i4 + 172 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i3 = i4 + 168 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i4 = i4 + 232 | 0;
  HEAP8[i4 >> 0] = 1;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 160 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i4 + 168 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i4 = i4 + 232 | 0;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __Z68AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i1 = __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi(i1, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0) | 0;
 switch (i1 | 0) {
 case 1:
  {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 case 16:
  {
   i4 = 1;
   STACKTOP = i5;
   return i4 | 0;
  }
 default:
  {
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
   __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
   __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i4);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 return 0;
}

function __Z29StdTemplateConversionFunctionItyEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i4 = i4 & 65535;
  i7 = i5;
  i6 = i7;
  HEAP32[i6 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i4;
 i4 = i4 & 65535;
 i7 = i5;
 i6 = i7;
 HEAP32[i6 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionItxEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i4 = i4 & 65535;
  i7 = i5;
  i6 = i7;
  HEAP32[i6 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i4;
 i4 = i4 & 65535;
 i7 = i5;
 i6 = i7;
 HEAP32[i6 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return 1;
}

function __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 i3 = i1 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 1047713 | 0, HEAP32[gb + 37300 >> 2] | 0, i2, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i4 + 16 | 0;
  i6 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = i6 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN4math8Collider8TransferI8BlobSizeEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 20 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i2 = i3 + 16 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = (0 - i6 & 3) + i6;
  __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i1, i3);
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (0 - i1 & 3) + i1 | 0;
  HEAP32[i2 >> 2] = i1;
  if (!(HEAP8[i4 >> 0] | 0)) i5 = 5; else HEAP8[i4 >> 0] = 0;
 } else {
  HEAP8[i4 >> 0] = 0;
  i1 = i3 + 16 | 0;
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = 5;
 }
 if ((i5 | 0) == 5) {
  i1 = (0 - i1 & 3) + i1 | 0;
  i1 = i1 + 4 + (0 - i1 & 3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i6 = (0 - i1 & 3) + i1 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 i6 = i6 + 4 + (0 - i6 & 3) | 0;
 i6 = (0 - i6 & 3) + i6 | 0;
 HEAP32[i2 >> 2] = i6 + 4 + (0 - i6 & 3);
 return;
}

function __ZN22BaseUnityConnectClient22RestoreAsyncConfigFileEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 16 | 0;
 i3 = i4;
 i5 = HEAP32[i1 + 280 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i1 = i3 + 11 | 0;
 HEAP8[i1 >> 0] = 6;
 HEAP8[i3 >> 0] = HEAP8[gb + 1040788 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[gb + 1040788 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[gb + 1040788 + 2 >> 0] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[gb + 1040788 + 3 >> 0] | 0;
 HEAP8[i3 + 4 >> 0] = HEAP8[gb + 1040788 + 4 >> 0] | 0;
 HEAP8[i3 + 5 >> 0] = HEAP8[gb + 1040788 + 5 >> 0] | 0;
 HEAP8[i3 + 6 >> 0] = 0;
 __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr(i5, i3) | 0;
 if ((HEAP8[i1 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 STACKTOP = i4;
 return;
}

function __ZN14TerrainManager23CreateTerrainGameObjectEP11TerrainData(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 937588 | 0, 7);
 HEAP32[i4 >> 2] = gb + 937588;
 HEAP32[i4 + 4 >> 2] = 0;
 i2 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i3, gb + 1044255 | 0, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 35740 | 0) | 0;
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i3, i4);
 if (!(__Z18GetITerrainPhysicsv() | 0)) {
  STACKTOP = i5;
  return i2 | 0;
 }
 i4 = __Z18GetITerrainPhysicsv() | 0;
 mftCall_viii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i2 | 0, i6 | 0);
 STACKTOP = i5;
 return i2 | 0;
}

function __Z24GetCompressionTypeString13TextureFormat(i1) {
 i1 = i1 | 0;
 L1 : do if ((i1 + -48 | 0) >>> 0 < 12) i1 = gb + 419822 | 0; else do switch (i1 | 0) {
 case 10:
  {
   i1 = gb + 419827 | 0;
   break L1;
  }
 case 11:
  {
   i1 = gb + 419817 | 0;
   break L1;
  }
 case 12:
  {
   i1 = gb + 419812 | 0;
   break L1;
  }
 case 26:
  {
   i1 = gb + 419808 | 0;
   break L1;
  }
 case 27:
  {
   i1 = gb + 419804 | 0;
   break L1;
  }
 case 24:
  {
   i1 = gb + 419799 | 0;
   break L1;
  }
 case 25:
  {
   i1 = gb + 419795 | 0;
   break L1;
  }
 case 34:
  {
   i1 = gb + 419790 | 0;
   break L1;
  }
 case 47:
 case 46:
 case 45:
  {
   i1 = gb + 419785 | 0;
   break L1;
  }
 case 44:
 case 43:
 case 42:
 case 41:
  {
   i1 = gb + 419781 | 0;
   break L1;
  }
 case 33:
 case 32:
 case 31:
 case 30:
  {
   i1 = gb + 419775 | 0;
   break L1;
  }
 case 36:
 case 35:
  {
   i1 = gb + 419771 | 0;
   break L1;
  }
 case 29:
 case 28:
  {
   i1 = gb + 419764 | 0;
   break L1;
  }
 case 61:
 case 60:
  {
   i1 = gb + 419753 | 0;
   break L1;
  }
 default:
  {
   i1 = gb + 419740 | 0;
   break L1;
  }
 } while (0); while (0);
 return i1 | 0;
}

function __GLOBAL__sub_I_runtime_profiler_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163340 | 0, gb + 461458 | 0, 14, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163352 | 0, gb + 461483 | 0, 14, 0);
 HEAP32[gb + 1163240 >> 2] = 0;
 HEAP32[gb + 1163244 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163364 | 0, gb + 461506 | 0, 12, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163376 | 0, gb + 461517 | 0, 14, 0);
 HEAP32[gb + 1163228 >> 2] = 0;
 HEAP32[gb + 1163260 >> 2] = 0;
 i3 = gb + 63576 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1163260 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1163260 + 12 >> 2] = 16;
 i1 = gb + 1163260 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3424 | 0, fb + 3425 | 0, 0, gb + 1163260 | 0);
 return;
}

function __ZNK28RectTransformPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i2, i5, i6, i7) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 44296 >> 2] | 0;
 i3 = _strlen(i2) | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 if ((i3 | 0) != ((i4 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 L4 : do switch (i3 | 0) {
 case -1:
  {
   __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i5);
   break;
  }
 case 0:
  {
   if (i6) {
    i7 = 0;
    return i7 | 0;
   } else i1 = i2;
   break;
  }
 default:
  if ((_memcmp(i4 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i5, i2, i3) | 0) != 0 | i6) {
   i7 = 0;
   return i7 | 0;
  } else {
   i1 = HEAP32[gb + 44296 >> 2] | 0;
   break L4;
  }
 } while (0);
 i6 = _strlen(i1) | 0;
 i3 = i1 + i6 | 0;
 if ((i6 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = 1;
 return i7 | 0;
}

function __ZN9TextAsset8TransferI14SafeBinaryReadEEvRT_(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i2, i6);
 i3 = i2 + 48 | 0;
 i4 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 588832 | 0, i4, i5, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i3, 1); else {
   i1 = HEAP32[i5 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i6 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i6);
 }
 i2 = i2 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 465937 | 0, i4, i5, 0) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i6, i2, 1); else {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile15ZoneManagerImplC2EPNS_12PxFoundationE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 HEAP32[i3 >> 2] = gb + 114064 + 8;
 i1 = i3 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 i2 = i1;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = i2;
 i2 = i3 + 28 | 0;
 i1 = i3 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i2) {
  i3 = 0;
  HEAP32[i1 >> 2] = i3;
  __ZN5physx6shdfnd9MutexImplC2Ev(i3);
  return;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i5 | 0, i4 | 0, i2 | 0, (i3 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i1 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImplC2Ev(i3);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, (i5 << 4) + 19 | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i4 = 0; else {
   i4 = i1 + 19 & -16;
   HEAP32[i4 + -4 >> 2] = i4 - i1;
  }
 }
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN20SoundChannelInstance12UpdateVolumeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 f2 = Math_fround(HEAPF32[i1 + 216 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 208 >> 2]));
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 212 >> 2]));
 if (HEAP32[i1 + 244 >> 2] & 1) f2 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 220 >> 2]));
 i1 = __ZN4FMOD7Channel9setVolumeEf(i3, f2) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 462;
 HEAP32[i5 + 8 >> 2] = gb + 857891;
 HEAP32[i5 + 12 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN11ForceModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 536 | 0, i4);
 i1 = i3 + 800 | 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 801 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 864 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 8 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  i5 = i1;
  i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
  i1 = i1 + 4 | 0;
  i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  i4 = i3;
  i3 = i4;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i4 = i4 + 4 | 0;
  HEAP8[i4 >> 0] = i1;
  HEAP8[i4 + 1 >> 0] = i1 >> 8;
  HEAP8[i4 + 2 >> 0] = i1 >> 16;
  HEAP8[i4 + 3 >> 0] = i1 >> 24;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 8;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 8);
  return;
 }
}

function _j1f(f4) {
 f4 = Math_fround(f4);
 var f1 = f0, i2 = 0, i3 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 >>> 31;
 i3 = i3 & 2147483647;
 do if (i3 >>> 0 > 2139095039) f1 = Math_fround(Math_fround(1.0) / Math_fround(f4 * f4)); else {
  if (i3 >>> 0 > 1073741823) {
   f1 = Math_fround(_common_181(i3, Math_fround(Math_abs(Math_fround(f4))), 0, i2));
   break;
  }
  if (i3 >>> 0 > 838860799) {
   f1 = Math_fround(f4 * f4);
   f1 = Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(4.96727992e-08)) + Math_fround(-.0000159955634))) + Math_fround(.0014070567))) + Math_fround(-.0625))) / Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(1.2354227e-11)) + Math_fround(5.04636244e-09))) + Math_fround(1.17718469e-06))) + Math_fround(.000185946788))) + Math_fround(.0191537607))) + Math_fround(1.0)));
  } else f1 = f4;
  f1 = Math_fround(Math_fround(f1 + Math_fround(.5)) * f4);
 } while (0);
 return Math_fround(f1);
}

function __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 8 | 0;
 if (!i1) {
  i4 = gb + 1164176 | 0;
  i5 = HEAP32[i4 + 4 >> 2] | 0;
  i6 = i2;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
 __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i5, i1, i3, -1, i4);
 if ((i4 & 8 | 0) == 0 & (HEAP32[i5 >> 2] | 0) == 0) {
  i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
  if (i1 | 0) {
   __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i6, i1, i3, i4);
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP8[i5 + 4 >> 0] = HEAP8[i6 + 4 >> 0] | 0;
  }
 }
 i4 = i5;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZN37InheritVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = gb + 616300 | 0;
 i3 = -1;
 do {
  i3 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 616300 + 36 | 0));
 HEAP32[i5 >> 2] = ~i3;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  STACKTOP = i6;
  return;
 }
}

function __ZN26AnimatorOverrideController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 __ZN25RuntimeAnimatorController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 80 | 0, i8);
 i7 = i1 + 96 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i2, 4);
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 4 | 0, i8);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZN26AnimatorControllerPlayable12ResetTriggerEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i4 = 8;
  return i4 | 0;
 }
 i3 = i4 + 92 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i5 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  i5 = 4;
  return i5 | 0;
 }
 i5 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 2) >> 2] | 0) != -1) {
  i5 = 16;
  return i5 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 switch (HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) {
 case 9:
 case 4:
  break;
 default:
  {
   i5 = 2;
   return i5 | 0;
  }
 }
 i5 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) + 44 | 0;
 HEAP8[i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] = 0;
 i5 = 1;
 return i5 | 0;
}

function __ZN13RenderManager18AddCameraProjectorEP9Projectori(i8, i1, i6) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i8 + 56 | 0;
 i5 = i1;
 i2 = i8 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) {
  i4 = i2;
  i3 = i2;
 } else {
  while (1) if ((HEAP32[i1 + 16 >> 2] | 0) > (i6 | 0)) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i2 = 4;
    break;
   } else i1 = i2;
  } else {
   i3 = i1 + 4 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) {
    i2 = 7;
    break;
   } else i1 = i2;
  }
  if ((i2 | 0) == 4) {
   i4 = i1;
   i3 = i1;
   break;
  } else if ((i2 | 0) == 7) {
   i4 = i1;
   break;
  }
 } while (0);
 i1 = __Znwj(24) | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 if (i2) {
  HEAP32[i7 >> 2] = i2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_(HEAP32[i8 + 60 >> 2] | 0, i1);
 i8 = i8 + 64 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 return;
}

function __ZN13MonoBehaviour20RemoveNodesFromListsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 76 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 88 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 112 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i3 + 124 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7ReleaseEPS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i6 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
  i2 = i6 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i2 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1 + 16;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z66CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralIndirectP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeS0_iS0_(i2, i8, i4, i9, i10, i1, i11, i6) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 var i3 = 0, i5 = 0, i7 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i13 + 8 | 0;
 i5 = i13;
 i12 = i13 + 4 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 if (!i4) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 HEAP32[i12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (!i6) i1 = 0; else i1 = HEAP32[i6 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i12 >> 2];
 __ZN22RenderingCommandBuffer25AddDrawProceduralIndirectERK10Matrix4x4fP8Materiali16GfxPrimitiveType15ComputeBufferIDiP19ShaderPropertySheet(i3, i8, i2, i9, i10, i7, i11, i1);
 STACKTOP = i13;
 return;
}

function __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_boundsGlobalP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i6 = i4 + 116 | 0;
  i1 = i4 + 128 | 0;
  i4 = i3 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z32BillboardRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i6 = i4 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i2 = (HEAP32[i3 >> 2] | 0) + ((HEAP32[HEAP32[i4 >> 2] >> 2] | 0) * 360 | 0) + 188 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (i1 >>> 0 > 1) {
  __ZN21BillboardBatchManager15BatchBillboardsERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(0, i3, i4, i5);
  return;
 }
 if (!i1) return; else i1 = 0;
 do {
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 3) >> 2] | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  __Z17SetupObjectMatrixRK10Matrix4x4fi(i7 + (i2 * 360 | 0) | 0, HEAP32[i7 + (i2 * 360 | 0) + 176 >> 2] | 0);
  __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns(0, HEAP32[i7 + (i2 * 360 | 0) + 328 >> 2] | 0, i5);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 return;
}

function __Z19AddCurveToDenseClipI11QuaternionfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 if ((HEAP32[i2 >> 2] | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i7 = i2 + 12 | 0;
 i8 = i2 + 8 | 0;
 i9 = i2 + 20 | 0;
 i10 = i2 + 4 | 0;
 i4 = i9;
 i1 = 0;
 do {
  f14 = Math_fround(HEAPF32[i7 >> 2]);
  f13 = Math_fround(i1 | 0);
  f13 = Math_fround(f14 + Math_fround(f13 / Math_fround(HEAPF32[i8 >> 2])));
  i12 = (Math_imul(HEAP32[i10 >> 2] | 0, i1) | 0) + i3 | 0;
  i12 = (HEAP32[i9 >> 2] | 0) + i4 + (i12 << 2) | 0;
  __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE(i6, i5, f13, 0);
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i12 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 STACKTOP = i11;
 return;
}

function __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = (i3 - i4 | 0) / 84 | 0;
 if (i5 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj(i1, i2 - i5 | 0);
  return;
 }
 if (i5 >>> 0 <= i2 >>> 0) return;
 i4 = i4 + (i2 * 84 | 0) | 0;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i2 = i3 + -84 | 0;
  HEAP32[i6 >> 2] = i2;
  i1 = i3 + -44 | 0;
  if ((HEAP32[i3 + -28 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -40 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + -64 | 0;
  if ((HEAP32[i3 + -48 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + -60 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  if ((HEAP32[i3 + -68 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -80 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i3 = HEAP32[i6 >> 2] | 0;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_24PxsConstraintBatchHeaderEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvS3_jRNS_16PxcSolverContextES7_jPiE(i2, i7, i1, i6, i8, i10, i11, i9, i5, i12) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 4 | 0;
 i3 = i4;
 HEAP32[i2 + 16 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i2 + 12 >> 2] = i11;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 if (!i8) {
  i12 = 0;
  HEAP32[i9 >> 2] = i12;
  STACKTOP = i4;
  return;
 } else i1 = 0;
 do {
  i5 = HEAP32[i6 + (i1 << 3) >> 2] | 0;
  mftCall_viiiiii(HEAP32[i12 + ((HEAPU8[HEAP32[i7 + (i5 << 5) + 16 >> 2] >> 0] | 0) << 2) >> 2] | 0, i7 + (i5 << 5) | 0, HEAPU16[i6 + (i1 << 3) + 4 >> 1] | 0 | 0, i2 | 0, i10 | 0, i11 | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 i12 = HEAP32[i3 >> 2] | 0;
 HEAP32[i9 >> 2] = i12;
 STACKTOP = i4;
 return;
}

function __ZN9BlobWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i5, i3, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i5, 1, i3, 1);
 i2 = i5 + 48 | 0;
 i6 = i5 + 44 | 0;
 i7 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i8 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 >>> 8 << 2) >> 2] | 0;
 i7 = i7 & 255;
 HEAP8[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i8 + (i7 << 4) + 4 >> 2] | 0) + (HEAP32[i8 + (i7 << 4) >> 2] | 0)) >> 0] = HEAP8[i3 >> 0] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i6 = (HEAP32[i2 >> 2] | 0) + -1 + i3 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i6 = (HEAP32[i4 + (i6 >>> 8 << 2) >> 2] | 0) + ((i6 & 255) << 4) + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - i4 | 0;
 if ((1 - i7 - i3 + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i5, i3, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (HEAP8[i5 + 24 >> 0] | 0) != 0;
 if (i1) __ZN9BlobWrite4PushEjPKvj(i5, 1, i3, 1);
 i2 = i5 + 48 | 0;
 i6 = i5 + 44 | 0;
 i7 = (HEAP32[i2 >> 2] | 0) + -1 + (HEAP32[i6 >> 2] | 0) | 0;
 i4 = i5 + 32 | 0;
 i8 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 >>> 8 << 2) >> 2] | 0;
 i7 = i7 & 255;
 HEAP8[(HEAP32[HEAP32[i5 + 16 >> 2] >> 2] | 0) + ((HEAP32[i8 + (i7 << 4) + 4 >> 2] | 0) + (HEAP32[i8 + (i7 << 4) >> 2] | 0)) >> 0] = HEAP8[i3 >> 0] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i6 = (HEAP32[i2 >> 2] | 0) + -1 + i3 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i6 = (HEAP32[i4 + (i6 >>> 8 << 2) >> 2] | 0) + ((i6 & 255) << 4) + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 if (!i1) return;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i7 + -1;
 i1 = i5 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i8 = i2 - i4 | 0;
 if ((1 - i7 - i3 + ((i8 | 0) == 0 ? 0 : (i8 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN36ExternalForcesModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = gb + 615224 | 0;
 i3 = -1;
 do {
  i3 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 615224 + 31 | 0));
 HEAP32[i5 >> 2] = ~i3;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  STACKTOP = i6;
  return;
 }
}

function __ZN14BillboardAsset10SetIndicesEPKtj(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = i5 + 68 | 0;
 i7 = i5 + 80 | 0;
 i1 = i2 << 1;
 i2 = i1 >> 1;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 84 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i2 >>> 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 1;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i5 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 2, i5 + 72 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 1;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 2, i5 + 72 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i7 >> 2] << 1 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  i6 = i5;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = i7 << 1;
  _memcpy(i6 | 0, i8 | 0, i7 | 0) | 0;
  return;
 }
}

function __ZN11MonoManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE(0);
 if (!(HEAP32[gb + 1165728 + 8 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i1 = HEAP32[gb + 1165728 + 4 >> 2] | 0;
 i5 = (HEAP32[gb + 1165728 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 HEAP32[gb + 1165728 + 8 >> 2] = 0;
 if ((i1 | 0) == (gb + 1165728 | 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = i4 + 4 | 0;
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  i3 = HEAP32[gb + 1165728 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = 49;
  HEAP32[i5 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 } while ((i1 | 0) != (gb + 1165728 | 0));
 STACKTOP = i6;
 return;
}

function __ZN11HaloManager10DeleteHaloEiP6Object(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == (i1 | 0)) {
   i5 = 8;
   break;
  }
  i3 = i2 + 40 | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i4 | 0)) break; else i2 = i3;
 }
 if ((i5 | 0) == 8) return;
 if ((i3 | 0) != (i1 | 0)) {
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
   HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
   HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
   i5 = i2 + 28 | 0;
   i4 = i3 + 28 | 0;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   i3 = i3 + 40 | 0;
   i2 = i2 + 40 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) return;
 }
 HEAP32[i6 >> 2] = i1 + (~(((i1 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
 return;
}

function __Z21CubemapConvolutionJobP22CubemapConvolutionDataj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1157748 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157748 | 0, i1);
  i1 = gb + 1157748 | 0;
 } else i1 = 0;
 i2 = HEAP32[i3 + (i4 << 4) + 12 >> 2] | 0;
 i8 = HEAP32[i3 + (i4 << 4) >> 2] | 0;
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 __Z10FilterRowsP13CImageSurfaceRS_iiiiifbfiiR17PrecomputeContext(HEAP32[i2 >> 2] | 0, (HEAP32[i2 + 4 >> 2] | 0) + (i8 << 4) | 0, i8, HEAP32[i3 + (i4 << 4) + 4 >> 2] | 0, HEAP32[i3 + (i4 << 4) + 8 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0, f7, (HEAP8[i2 + 20 >> 0] | 0) != 0, f6, 0, HEAP32[i2 + 32 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__221recursive_timed_mutex6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i2 >> 2] = i1;
 i3 = i2 + 4 | 0;
 HEAP8[i3 >> 0] = 1;
 __THREW__ = 0;
 invoke_vi(fb + 4006 | 0, i1 | 0);
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i6);
 }
 i7 = i1 + 76 | 0;
 i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 do if (!i6) {
  HEAP32[i1 + 80 >> 2] = 0;
  __THREW__ = 0;
  invoke_vi(fb + 4007 | 0, i2 | 0);
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   __ZNSt3__218condition_variable10notify_oneEv(i1 + 28 | 0);
   if (!(HEAP8[i3 >> 0] | 0)) break; else {
    i4 = 8;
    break;
   }
  }
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  if (HEAP8[i3 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i2 >> 2] | 0);
  ___clang_call_terminate(i1);
 } else i4 = 8; while (0);
 if ((i4 | 0) == 8) __ZNSt3__25mutex6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty(i7, i6, i3, i4) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 2 | 0;
 i1 = i8;
 HEAP16[i1 >> 1] = i6;
 i5 = i7 + 280 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb(i7 + 212 | 0, i1, i2) | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   HEAP16[i1 >> 1] = i6;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = 0;
  } else i1 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_viiiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i1 | 0, i3 | 0, i4 | 0, 0);
 }
 if (!(HEAP8[i7 + 276 >> 0] | 0)) {
  STACKTOP = i8;
  return;
 }
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10startEventEty(i7, i6, i3, i4);
 STACKTOP = i8;
 return;
}

function __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i8 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i2 | 0) | 0;
 i5 = i8 + 44 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i2 = i8 + 72 | 0;
  i6 = 0;
  do {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i6 * 224 | 0) + 208 >> 2] | 0;
   i4 = i3 + 368 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, -2147483648, i1 | 0) | 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i3 | 0, gb + 159112 | 0);
   HEAP32[i4 >> 2] = i1;
   i6 = i6 + 1 | 0;
  } while (i6 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 i3 = HEAP32[i8 + 48 >> 2] | 0;
 if (!i3) return;
 i4 = i8 + 40 | 0;
 i1 = i8 + 76 | 0;
 i2 = 0;
 do {
  HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + (i2 << 2) >> 2] = (HEAP32[i4 >> 2] | 0) + ((i2 >>> 2) * 944 | 0) + 384 + ((i2 & 3) << 6);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return;
}

function __ZN26AnimatorControllerPlayable10SetTriggerEi(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i4 = 8;
  return i4 | 0;
 }
 i3 = i4 + 92 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i5 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  i5 = 4;
  return i5 | 0;
 }
 i5 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 2) >> 2] | 0) != -1) {
  i5 = 16;
  return i5 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 switch (HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) {
 case 9:
 case 4:
  break;
 default:
  {
   i5 = 2;
   return i5 | 0;
  }
 }
 i5 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i5 = i5 + (HEAP32[i5 >> 2] | 0) + 44 | 0;
 HEAP8[i5 + (HEAP32[i5 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] = 1;
 i5 = 1;
 return i5 | 0;
}

function __ZN22RenderingCommandBuffer13ClearCommandsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP8[i5 + 36 >> 0] = 0;
 i6 = i5 + 40 | 0;
 i7 = i5 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  i3 = i1;
  while (1) {
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
   if (!i2) i1 = i3; else {
    i3 = i2 + 4 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
    if (!(HEAP32[i3 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
     i1 = HEAP32[i6 >> 2] | 0;
    }
    HEAP32[i1 + (i4 << 2) >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   if (i4 >>> 0 >= i1 >>> 0) break; else i3 = i1;
  }
 }
 i1 = i5 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + 44 | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 864 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z66ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = i1 + 264 | 0;
 i1 = i5 + 272 | 0;
 HEAPF32[i5 + 352 >> 2] = f2;
 HEAP8[i1 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i5 + 360 | 0, f2, HEAP16[i5 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48AnimatorControllerPlayable_CUSTOM_GetFloatStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0;
 i1 = mftCall_iiii(i7 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0, i4 | 0) | 0;
 if ((i1 | 0) == 1) {
  f8 = Math_fround(HEAPF32[i4 >> 2]);
  STACKTOP = i6;
  return Math_fround(f8);
 }
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i3);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i7, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 STACKTOP = i6;
 return Math_fround(f8);
}

function __Z18HiearchyMatchesOptP9TransformPKN7mecanim8skeleton8SkeletonEPKj(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i1 + 80 | 0;
 i8 = i1 + 92 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  i11 = 0;
  return i11 | 0;
 }
 i4 = HEAP32[i11 >> 2] | 0;
 i7 = i4;
 i1 = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 do {
  if (!i3) i3 = 0; else {
   i6 = 0;
   do {
    i5 = HEAP32[i10 + (i6 << 2) >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
    i3 = _strlen(i2) | 0;
    i4 = i2 + i3 | 0;
    if ((i3 | 0) > 0) {
     i3 = -1;
     do {
      i3 = HEAP32[gb + 1111240 + (((HEAPU8[i2 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
      i2 = i2 + 1 | 0;
     } while ((i2 | 0) != (i4 | 0));
     i2 = ~i3;
    } else i2 = 0;
    i1 = ((i5 | 0) == (i2 | 0) & 1) + i1 | 0;
    i6 = i6 + 1 | 0;
    i3 = HEAP32[i9 >> 2] | 0;
   } while (i6 >>> 0 < i3 >>> 0);
   i4 = HEAP32[i11 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) != (i4 + (i2 << 2) | 0));
 return i1 | 0;
}

function __Z11MurmurHash1PKvij(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = (Math_imul(i2, -962287725) | 0) ^ i1;
 if ((i2 | 0) > 3) {
  i4 = i2 + -4 | 0;
  i5 = i4 & -4;
  i6 = i3 + (i5 + 4) | 0;
  while (1) {
   i8 = Math_imul((HEAP32[i3 >> 2] | 0) + i1 | 0, -962287725) | 0;
   i1 = i8 >>> 16 ^ i8;
   i2 = i2 + -4 | 0;
   if ((i2 | 0) <= 3) break; else i3 = i3 + 4 | 0;
  }
  i2 = i4 - i5 | 0;
  i3 = i6;
 }
 switch (i2 | 0) {
 case 3:
  {
   i1 = ((HEAPU8[i3 + 2 >> 0] | 0) << 16) + i1 | 0;
   i7 = 7;
   break;
  }
 case 2:
  {
   i7 = 7;
   break;
  }
 case 1:
  break;
 default:
  {
   i8 = i1;
   i8 = Math_imul(i8, -962287725) | 0;
   i7 = i8 >>> 10;
   i8 = i7 ^ i8;
   i8 = Math_imul(i8, -962287725) | 0;
   i7 = i8 >>> 17;
   i8 = i7 ^ i8;
   return i8 | 0;
  }
 }
 if ((i7 | 0) == 7) i1 = ((HEAPU8[i3 + 1 >> 0] | 0) << 8) + i1 | 0;
 i8 = Math_imul((HEAPU8[i3 >> 0] | 0) + i1 | 0, -962287725) | 0;
 i8 = i8 >>> 16 ^ i8;
 i8 = Math_imul(i8, -962287725) | 0;
 i7 = i8 >>> 10;
 i8 = i7 ^ i8;
 i8 = Math_imul(i8, -962287725) | 0;
 i7 = i8 >>> 17;
 i8 = i7 ^ i8;
 return i8 | 0;
}

function _UNITY_FT_Stroker_GetBorderCounts(i8, i9, i10, i11) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 L1 : do if ((i8 | 0) == 0 | i9 >>> 0 > 1) {
  i3 = 6;
  i2 = 0;
  i1 = 0;
 } else {
  i1 = HEAP32[i8 + 64 + (i9 << 5) >> 2] | 0;
  if (!i1) {
   i2 = 0;
   i1 = 0;
  } else {
   i7 = HEAP32[i8 + 64 + (i9 << 5) + 12 >> 2] | 0;
   i5 = i1;
   i2 = 0;
   i1 = 0;
   i3 = 0;
   while (1) {
    i6 = HEAP8[i7 >> 0] | 0;
    i4 = (i3 | 0) == 0;
    if (!(i6 & 4)) {
     if (i4) {
      i3 = 0;
      i2 = 0;
      i1 = 0;
      break L1;
     }
    } else if (i4) i3 = 1; else {
     i3 = 0;
     i2 = 0;
     i1 = 0;
     break L1;
    }
    i6 = i6 & 8;
    i2 = ((i6 & 255) >>> 3 & 255) + i2 | 0;
    i3 = i6 << 24 >> 24 == 0 ? i3 : 0;
    i5 = i5 + -1 | 0;
    i1 = i1 + 1 | 0;
    if (!i5) break; else i7 = i7 + 1 | 0;
   }
   if (i3) {
    i3 = 0;
    i2 = 0;
    i1 = 0;
    break;
   }
  }
  HEAP8[i8 + 64 + (i9 << 5) + 28 >> 0] = 1;
  i3 = 0;
 } while (0);
 if (i10 | 0) HEAP32[i10 >> 2] = i1;
 if (!i11) return i3 | 0;
 HEAP32[i11 >> 2] = i2;
 return i3 | 0;
}

function __ZN12LightsModule5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 12 >> 0] = 1;
 HEAP8[i1 + 20 >> 0] = 1;
 HEAP8[i1 + 21 >> 0] = 1;
 HEAP8[i1 + 22 >> 0] = 1;
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 110 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 24 | 0, i1 + 112 | 0, Math_fround(1.0), HEAP16[i1 + 108 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 368 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 374 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 288 | 0, i1 + 376 | 0, Math_fround(1.0), HEAP16[i1 + 372 >> 1] | 0) | 0) & 1;
 HEAP32[i1 + 552 >> 2] = 20;
 HEAPF32[i1 + 572 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 592 >> 2] = 0;
 i3 = i1 + 584 | 0;
 i4 = i1 + 576 | 0;
 i1 = i1 + 580 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) return;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = i5;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i4 >> 2] = i4;
 return;
}

function __ZN11TerrainData7AddUserEP10GameObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i9 = i12 + 4 | 0;
 i10 = i12;
 i11 = i2 + 352 | 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = i7;
 i5 = HEAP32[i11 >> 2] | 0;
 i6 = HEAP32[i2 + 356 >> 2] | 0;
 i1 = i6 - i5 >> 2;
 i2 = i5;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i6 | 0)) if ((i7 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i11, i8, i10) | 0;
 STACKTOP = i12;
 return;
}

function __ZN10TagManager28GetSortingLayerValueFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i9) {
  i10 = 0;
  return i10 | 0;
 }
 i2 = HEAP32[i7 + 1072 >> 2] | 0;
 i3 = HEAP32[i7 + 1068 >> 2] | 0;
 i8 = i3;
 if ((i2 | 0) == (i3 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? i1 + 4 | 0 : i6;
 i5 = (i2 - i3 | 0) / 40 | 0;
 i1 = 0;
 L7 : while (1) {
  L9 : do if ((HEAP32[i8 + (i1 * 40 | 0) + 20 >> 2] | 0) == (i9 | 0)) {
   i4 = HEAP32[i8 + (i1 * 40 | 0) >> 2] | 0;
   i2 = i9;
   i3 = i6;
   i4 = (i4 | 0) == 0 ? i8 + (i1 * 40 | 0) + 4 | 0 : i4;
   while (1) {
    if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break L9;
    i2 = i2 + -1 | 0;
    if (!i2) break L7; else {
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i10 = 10;
   break;
  }
 }
 if ((i10 | 0) == 10) return i1 | 0;
 i10 = i1 - (HEAP32[i7 + 1080 >> 2] | 0) | 0;
 return i10 | 0;
}

function __Z16UnloadAllPluginsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[gb + 1162584 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i6;
 if ((i4 | 0) == (i6 | 0)) {
  i3 = i1;
  i1 = i4;
  i2 = i5;
 } else {
  i6 = 0;
  while (1) {
   i1 = HEAP32[i1 + (i6 * 24 | 0) + 20 >> 2] | 0;
   if (i1) {
    mftCall_v(i1 | 0);
    i2 = HEAP32[gb + 1162584 >> 2] | 0;
   }
   i6 = i6 + 1 | 0;
   i5 = i2 + 4 | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   i4 = HEAP32[i2 >> 2] | 0;
   i3 = i4;
   if (i6 >>> 0 >= ((i1 - i4 | 0) / 24 | 0) >>> 0) {
    i2 = i5;
    break;
   } else i1 = i3;
  }
 }
 if ((i1 | 0) != (i3 | 0)) HEAP32[i2 >> 2] = i1 + (~(((i1 + -24 - i4 | 0) >>> 0) / 24 | 0) * 24 | 0);
 i5 = HEAP32[gb + 1162664 >> 2] | 0;
 i6 = i5 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5, HEAP32[i6 >> 2] | 0);
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 return;
}

function _UNITY_png_set_iCCP(i4, i5, i2, i1, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0;
 if ((i4 | 0) == 0 | (i5 | 0) == 0 | (i2 | 0) == 0 | (i6 | 0) == 0) return;
 if (i1 | 0) _UNITY_png_app_error(i4, gb + 354227 | 0);
 i3 = _UNITY_png_colorspace_set_ICC(i4, i5 + 40 | 0, i2, i7, i6, HEAPU8[i5 + 25 >> 0] | 0) | 0;
 _UNITY_png_colorspace_sync_info(i4, i5);
 if (!i3) return;
 i1 = i5 + 114 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 24;
 i1 = (_strlen(i2) | 0) + 1 | 0;
 i3 = _UNITY_png_malloc_warn(i4, i1) | 0;
 if (!i3) {
  _UNITY_png_benign_error(i4, gb + 354259 | 0);
  return;
 }
 _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
 i1 = _UNITY_png_malloc_warn(i4, i7) | 0;
 if (!i1) {
  _UNITY_png_free(i4, i3);
  _UNITY_png_benign_error(i4, gb + 354301 | 0);
  return;
 } else {
  _memcpy(i1 | 0, i6 | 0, i7 | 0) | 0;
  _UNITY_png_free_data(i4, i5, 16, 0);
  HEAP32[i5 + 124 >> 2] = i7;
  HEAP32[i5 + 116 >> 2] = i3;
  HEAP32[i5 + 120 >> 2] = i1;
  i7 = i5 + 220 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
  i7 = i5 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4096;
  return;
 }
}

function __ZThn4_N11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + -4 | 0;
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) return;
 i5 = HEAP32[i6 + 96 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
 if ((HEAP8[i6 + 105 >> 0] | 0) == 0 | (i5 + -400 | 0) >>> 0 < 100) {
  HEAP32[i6 + 84 >> 2] = 0;
  HEAP32[i6 + 76 >> 2] = 0;
  i5 = HEAP32[i6 + 32 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, fb + 3957 | 0, i6 | 0) | 0;
  return;
 }
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 100 | 0;
 i5 = i6 + 76 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
 i4 = i1 + 104 | 0;
 if (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2 >>> 0) HEAP32[i5 >> 2] = i3;
 HEAP32[i6 + 80 >> 2] = _time(0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i6 + 84 >> 2] = 60;
  return;
 } else {
  HEAP32[i6 + 84 >> 2] = HEAP32[i1 + (HEAP32[i5 >> 2] << 2) >> 2];
  return;
 }
}

function __ZN8Animator4PlayE9HPlayableP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i9 = i2;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14DirectorPlayer4PlayE9HPlayableP12Il2CppObject(i1, i5, i3);
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) __ZN8Animator11SetPlayableEP8Playablei(i1, HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, 0);
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP8[i1 + 88 >> 0] | 0)) if ((HEAP32[i1 + 92 >> 2] | 0) == 2) {
  i9 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, 0);
  STACKTOP = i4;
  return;
 }
 i9 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i9 >> 2] | 0) + 32 >> 2] | 0, i9 | 0, 1);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i9 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = (i6 & 2147483647 | 0) == 0 ? 1 : i6 << 1;
 if (!i6) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i6 << 2, gb + 838004 | 0, 543) | 0;
 i7 = i9 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
  i1 = HEAP32[i7 >> 2] | 0;
 }
 HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i8 >> 2];
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  i9 = HEAP32[i7 >> 2] | 0;
  i8 = i9 + 1 | 0;
  HEAP32[i7 >> 2] = i8;
  i9 = i4 + (i9 << 2) | 0;
  return i9 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i4;
 HEAP32[i5 >> 2] = i6;
 i9 = HEAP32[i7 >> 2] | 0;
 i8 = i9 + 1 | 0;
 HEAP32[i7 >> 2] = i8;
 i9 = i4 + (i9 << 2) | 0;
 return i9 | 0;
}

function __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831350;
 HEAP32[i1 + 4 >> 2] = 519;
 HEAP32[i1 + 8 >> 2] = fb + 639;
 HEAP32[i1 + 12 >> 2] = gb + 833974;
 HEAP32[i1 + 16 >> 2] = 520;
 HEAP32[i1 + 20 >> 2] = fb + 640;
 __ZN5physx20MTorqueCurvePropertyC2Ev(i1 + 24 | 0);
 HEAP32[i1 + 52 >> 2] = gb + 831380;
 HEAP32[i1 + 56 >> 2] = 522;
 HEAP32[i1 + 60 >> 2] = fb + 641;
 HEAP32[i1 + 64 >> 2] = fb + 554;
 HEAP32[i1 + 68 >> 2] = gb + 833988;
 HEAP32[i1 + 72 >> 2] = 523;
 HEAP32[i1 + 76 >> 2] = fb + 642;
 HEAP32[i1 + 80 >> 2] = fb + 555;
 HEAP32[i1 + 84 >> 2] = gb + 834e3;
 HEAP32[i1 + 88 >> 2] = 524;
 HEAP32[i1 + 92 >> 2] = fb + 643;
 HEAP32[i1 + 96 >> 2] = fb + 556;
 HEAP32[i1 + 100 >> 2] = gb + 834010;
 HEAP32[i1 + 104 >> 2] = 525;
 HEAP32[i1 + 108 >> 2] = fb + 644;
 HEAP32[i1 + 112 >> 2] = fb + 557;
 HEAP32[i1 + 116 >> 2] = gb + 834035;
 HEAP32[i1 + 120 >> 2] = 526;
 HEAP32[i1 + 124 >> 2] = fb + 645;
 HEAP32[i1 + 128 >> 2] = fb + 558;
 HEAP32[i1 + 132 >> 2] = gb + 834073;
 HEAP32[i1 + 136 >> 2] = 527;
 HEAP32[i1 + 140 >> 2] = fb + 646;
 HEAP32[i1 + 144 >> 2] = fb + 559;
 return;
}

function __ZN5physx19PxsSimObjectFactoryD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = HEAP32[i8 >> 2] | 0;
 if (HEAP32[i6 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15disposeElementsEv(i6);
 i7 = i6 + 4 | 0;
 i4 = i6 + 264 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i6 + 268 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i3 = HEAP32[i6 + 272 >> 2] | 0;
 do if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if ((i7 | 0) == (i1 | 0)) {
   HEAP8[i6 + 260 >> 0] = 0;
   break;
  }
  if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 } while (0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i8 >> 2] | 0);
 STACKTOP = i9;
 return;
}

function __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i2 + 20 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i1 = i2 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  i2 = i2 + 4 + (0 - i2 & 3) | 0;
  i2 = (0 - i2 & 3) + i2 | 0;
  HEAP32[i1 >> 2] = i2;
 } else {
  HEAP8[i1 >> 0] = 0;
  i2 = i2 + 16 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 i2 = (0 - i2 & 3) + i2 | 0;
 i2 = i2 + 4 + (0 - i2 & 3) | 0;
 HEAP32[i1 >> 2] = (0 - i2 & 3) + i2;
 return;
}

function __ZN15AudioMixerGroup7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(72, i1, 16, gb + 1048932 | 0, 0, gb + 873844 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 174700 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = i4 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14DataBufferGLES3MapEiij(i2, i3, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i7 = 0;
 if (!(HEAP8[i2 + 20 >> 0] | 0)) __ZN14DataBufferGLES16RecreateWithDataEiPKv(i2, HEAP32[i2 + 8 >> 2] | 0, 0);
 i7 = HEAP32[gb + 1451080 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 switch (HEAP32[i2 + 12 >> 2] | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
   } else i1 = 1;
   break;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 0 : 2;
   } else i1 = 0;
   break;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   break;
  }
 default:
  i1 = -559030611;
 }
 i7 = __ZN7ApiGLES9MapBufferEjN2gl12BufferTargetEllj(i7, i4, i1, i3, i5, i6) | 0;
 HEAP8[i2 + 21 >> 0] = (i6 & 1 | 0) == 0 ? 0 : (i6 >>> 1 & 1 ^ 1) & 255;
 return i7 | 0;
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 884 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 884 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56AnimatorOverrideController_CUSTOM_Internal_SetClipByNameP12Il2CppObjectP12Il2CppStringS0_(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 20 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8 + 4 | 0;
 i7 = i8;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i8 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  HEAP32[i7 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  __ZN26AnimatorOverrideController7SetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI13AnimationClipEb(i1, i6, i2, 1);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return;
 }
}

function __Z31Camera_CUSTOM_GetCommandBuffersP12Il2CppObject21RenderCameraEventType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i6 = __ZNK19RenderEventsContext17GetCommandBuffersEi(i3 + 1136 | 0, i2) | 0;
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 300 >> 2] | 0;
 i3 = __Z19scripting_array_newP11Il2CppClassjj(i2, 4, i7) | 0;
 if (!i7) return i3 | 0;
 i1 = 0;
 do {
  i4 = __Z20scripting_object_newP11Il2CppClass(i2) | 0;
  HEAP32[i4 + 8 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2];
  i5 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i5 | 0) {
   i5 = i5 + 4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  }
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i3, i1, i4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return i3 | 0;
}

function __ZNSt3__213__vector_baseIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEED2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return;
 i9 = i8 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i7 = i2 + -68 | 0;
   HEAP32[i9 >> 2] = i7;
   i6 = HEAP32[i2 + -12 >> 2] | 0;
   i3 = i6;
   if (i6 | 0) {
    i4 = i2 + -8 | 0;
    i5 = HEAP32[i4 >> 2] | 0;
    if ((i5 | 0) != (i6 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
    __ZdlPv(i6);
   }
   i3 = HEAP32[i2 + -24 >> 2] | 0;
   i4 = i3;
   if (i3 | 0) {
    i5 = i2 + -20 | 0;
    i6 = HEAP32[i5 >> 2] | 0;
    if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -32 - i4 | 0) >>> 5) << 5);
    __ZdlPv(i3);
   }
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = i4;
   if (i4 | 0) {
    i2 = i2 + -64 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -32 - i5 | 0) >>> 5) << 5);
    __ZdlPv(i4);
   }
   i2 = HEAP32[i9 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i8 >> 2] | 0;
 }
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn21getBinaryPlatformNameEj(i1) {
 i1 = i1 | 0;
 do if ((i1 | 0) == 842227543) i1 = 0; else if ((i1 | 0) == 875978583) i1 = 1; else if ((i1 | 0) == 842227532) i1 = 2; else if ((i1 | 0) == 875978572) i1 = 3; else if ((i1 | 0) == 842227533) i1 = 4; else if ((i1 | 0) == 875978573) i1 = 5; else if ((i1 | 0) == 1094930253) i1 = 6; else if ((i1 | 0) == 861885264) i1 = 7; else if ((i1 | 0) == 808858456) i1 = 8; else if ((i1 | 0) == 1380208193) i1 = 9; else if ((i1 | 0) == 1397705025) i1 = 10; else if ((i1 | 0) == 844125008) i1 = 11; else if ((i1 | 0) == 1297236311) i1 = 12; else if ((i1 | 0) == 1430866263) i1 = 13; else if ((i1 | 0) == 1162760024) i1 = 14; else if ((i1 | 0) == 1314539860) i1 = 15; else if ((i1 | 0) == 808534594) i1 = 16; else if ((i1 | 0) == 945770583) i1 = 17; else if ((i1 | 0) == 1448370003) i1 = 18; else {
  if ((i1 | 0) == 1128484165) {
   i1 = 19;
   break;
  }
  if ((i1 | 0) == 1396978510) {
   i1 = 20;
   break;
  }
  if ((i1 | 0) == 875970881) {
   i1 = 21;
   break;
  } else i1 = gb + 1030883 | 0;
  return i1 | 0;
 } while (0);
 i1 = HEAP32[gb + 89112 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_117EventBufferClient4lockEjjy(i5, i4, i3, i1, i2) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6;
 i5 = HEAP32[i5 + 8 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 i10 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i9 = getTempRet0() | 0;
 HEAP32[i11 >> 2] = gb + 148976 + 8;
 i8 = i11 + 4 | 0;
 HEAP32[i8 >> 2] = i4;
 i7 = i11 + 8 | 0;
 HEAP32[i7 >> 2] = i3;
 i3 = i11 + 16 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i4 = i11 + 24 | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i9;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i8 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i7 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i3 | 0, 8) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, 8) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN11dtPathQueue13getPathResultEjPyPiPfPjP15dtPathQueryInfoi(i6, i1, i2, i3, i4, i7, i9, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 var i8 = 0, i10 = 0;
 if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) {
  i9 = -2147483648;
  return i9 | 0;
 }
 i10 = i6 + 60 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i8 = i1 & 16777215;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i10 >> 2] = 0;
 i10 = HEAP32[i6 + 52 >> 2] | 0;
 i5 = (i10 | 0) < (i5 | 0) ? i10 : i5;
 _memcpy(i2 | 0, HEAP32[i6 + 48 >> 2] | 0, i5 << 3 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i3 >> 2] = i5;
 if (!(i1 & 32)) i1 = HEAP32[i6 + 68 >> 2] | 0; else i1 = 0;
 HEAP32[i7 >> 2] = i1;
 if (i9 | 0) {
  i2 = i6 + 208 | 0;
  __ZN15dtPathQueryInfo8copyFromERS_(i9, i2);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __Z6dtFreePv(HEAP32[i1 + 48 >> 2] | 0);
   __Z6dtFreePv(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0);
   __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i10 = i8 | 1073741824;
 return i10 | 0;
}

function __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, i1, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i9 = i2 + 40 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) return;
 i7 = i2 + 28 | 0;
 i6 = 0;
 do {
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 + (i6 << 3) >> 2] | 0;
  i5 = (Math_imul(HEAP32[gb + 1104584 + 44 >> 2] | 0, i8) | 0) + i3 | 0;
  if (1 << (i5 & 31) & HEAP32[(HEAP32[gb + 1104584 + 16 >> 2] | 0) + (i5 >>> 5 << 2) >> 2] | 0) {
   i4 = HEAP32[i1 + (i6 << 3) + 4 >> 2] | 0;
   i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
   i11 = HEAP32[gb + 1104584 + 28 >> 2] | 0;
   i1 = HEAP32[i11 + (i3 << 5) + 24 >> 2] | 0;
   i2 = HEAP32[i11 + (i3 << 5) >> 2] | 0;
   if (((HEAP32[i11 + (i3 << 5) + 4 >> 2] | 0) - i2 >> 2 | 0) > (i8 | 0)) {
    i11 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
    i1 = (i11 | 0) == 0 ? i1 : i11;
   }
   mftCall_viii(i1 | 0, i4 | 0, i8 | 0, i10 | 0);
   if (i5) __Z19pop_allocation_rootv();
  }
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < (HEAP32[i9 >> 2] | 0) >>> 0);
 return;
}

function __Z37MaterialPropertyBlock_CUSTOM_GetFloatP12Il2CppObjecti(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f1 = f0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i2 | 0) >= (i4 | 0)) {
  f1 = Math_fround(0.0);
  STACKTOP = i8;
  return Math_fround(f1);
 }
 i3 = HEAP32[i5 + 32 >> 2] | 0;
 while (1) {
  if ((HEAP32[i3 + (i2 << 2) >> 2] | 0) == (i6 | 0)) break;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i4 | 0)) {
   f1 = Math_fround(0.0);
   i7 = 10;
   break;
  }
 }
 if ((i7 | 0) == 10) {
  STACKTOP = i8;
  return Math_fround(f1);
 }
 if ((i2 | 0) <= -1) {
  f1 = Math_fround(0.0);
  STACKTOP = i8;
  return Math_fround(f1);
 }
 f1 = Math_fround(HEAPF32[(HEAP32[i5 + 72 >> 2] | 0) + (HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i2 << 2) >> 2] & 1048575) >> 2]);
 STACKTOP = i8;
 return Math_fround(f1);
}

function __Z15FindChildWithIDP9TransformRKN7mecanim5crc32EjRS2_i(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = HEAP32[i1 + 92 >> 2] | 0;
 if ((i11 | 0) <= 0) {
  i12 = 0;
  return i12 | 0;
 }
 i6 = i1 + 80 | 0;
 i4 = 0;
 while (1) {
  i5 = (i4 + i10 | 0) % (i11 | 0) | 0;
  i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  if ((i1 | 0) == -1) i1 = -1; else i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 47) << 2) >> 2] ^ i1 >>> 8;
  i13 = _strlen(i2) | 0;
  i3 = i2 + i13 | 0;
  if ((i13 | 0) > 0) do {
   i1 = HEAP32[gb + 1111240 + (((HEAPU8[i2 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i4 = i4 + 1 | 0;
  if ((~i1 | 0) == (i8 | 0)) break;
  if ((i4 | 0) >= (i11 | 0)) {
   i1 = 0;
   i12 = 10;
   break;
  }
 }
 if ((i12 | 0) == 10) return i1 | 0;
 HEAP32[i9 >> 2] = i1;
 i13 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0;
 return i13 | 0;
}

function __ZN5Umbra9Matrix4x3mLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 28 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 36 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 40 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 44 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 return i1 | 0;
}

function __ZN18ScBeforeSolverTask11runInternalEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, f12 = f0, f13 = f0;
 i1 = i9 + 172 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i9 + 20 | 0;
 i3 = i9 + 32 | 0;
 i4 = i9 + 36 | 0;
 i5 = i9 + 29 | 0;
 i6 = i9 + 24 | 0;
 i7 = i9 + 28 | 0;
 i8 = 0;
 do {
  i10 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i8 << 2) >> 2] | 0;
  f13 = Math_fround(HEAPF32[i3 >> 2]);
  f12 = Math_fround(HEAPF32[i4 >> 2]);
  __ZN5physx2Sc7BodySim12updateForcesEffbRKNS_6PxVec3Ebb(i10 + -64 | 0, f13, f12, (HEAP8[i5 >> 0] | 0) != 0, HEAP32[i6 >> 2] | 0, (HEAP8[i9 + 44 + i8 >> 0] | 0) != 0, (HEAP8[i7 >> 0] | 0) != 0);
  i11 = HEAP32[i10 + 64 >> 2] | 0;
  HEAP32[i10 + 32 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i10 + 36 >> 2] = HEAP32[i11 + 4 >> 2];
  HEAP32[i10 + 40 >> 2] = HEAP32[i11 + 8 >> 2];
  HEAP32[i10 + 44 >> 2] = HEAP32[i11 + 12 >> 2];
  HEAP32[i10 + 48 >> 2] = HEAP32[i11 + 16 >> 2];
  HEAP32[i10 + 52 >> 2] = HEAP32[i11 + 20 >> 2];
  HEAP32[i10 + 56 >> 2] = HEAP32[i11 + 24 >> 2];
  i8 = i8 + 1 | 0;
 } while (i8 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 return;
}

function __ZNK3Ray14SqrDistToPointERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f12 - f11);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f10 - f4);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(Math_fround(f5 * f13) + Math_fround(f9 * f6)) + Math_fround(f7 * Math_fround(f8 - f3))) / Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f9 * f9)) + Math_fround(f7 * f7)));
 f5 = Math_fround(f12 - Math_fround(f11 + Math_fround(f5 * f6)));
 f4 = Math_fround(f10 - Math_fround(Math_fround(f9 * f6) + f4));
 f3 = Math_fround(f8 - Math_fround(Math_fround(f7 * f6) + f3));
 return Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f3 * f3));
}

function __ZNK14SoundHandleAPI12GetFrequencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 if (!i1) {
  f6 = Math_fround(0.0);
  STACKTOP = i5;
  return Math_fround(f6);
 }
 if ((HEAP32[i1 + 44 >> 2] | 0) != 3) {
  f6 = Math_fround(0.0);
  STACKTOP = i5;
  return Math_fround(f6);
 }
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i1 = __ZN4FMOD5Sound11getDefaultsEPfS1_S1_Pi(HEAP32[i1 + 40 >> 2] | 0, i3, 0, 0, 0) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 633;
  HEAP32[i4 + 8 >> 2] = gb + 872588;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 STACKTOP = i5;
 return Math_fround(f6);
}

function __ZN8Playable19SetOutputConnectionEPS_i(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 4 | 0;
 i3 = (i1 | 0) == -1 ? 0 : i1;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i3 | 0) > -1) if ((i3 | 0) >= (HEAP32[i1 + 48 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 390259 | 0, 0, gb + 390333 | 0, 133, 1, 0, 0, 0);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = (HEAP32[i1 + 36 >> 2] | 0) + (i3 << 3) + 4 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 2:
 case 0:
  {
   HEAP32[i1 >> 2] = i4;
   i6 = 1;
   STACKTOP = i7;
   return i6 | 0;
  }
 default:
  {
   HEAP32[i6 >> 2] = i3;
   __Z6FormatPKcz(i5, gb + 390408 | 0, i6);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 390333 | 0, 139, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN6Camera27SetSurfaceUseResolvedBufferEP13RenderTexture(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 i6 = i7;
 if (!i2) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
  i4 = __Z12GetGfxDevicev() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 372 >> 2] | 0, i4 | 0) | 0;
 } else {
  i4 = HEAP32[i2 + 136 >> 2] | 0;
  i1 = HEAP32[i2 + 128 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 <= 1) {
  STACKTOP = i7;
  return;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + 416 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 mftCall_viiii(i8 | 0, i2 | 0, i3 | 0, 4, 0);
 if (!i4) {
  STACKTOP = i7;
  return;
 }
 i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + 416 >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_viiii(i8 | 0, i2 | 0, i3 | 0, 4, 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Gu10ConvexMeshC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = 2;
 HEAP16[i1 + 6 >> 1] = 3;
 HEAP32[i1 >> 2] = gb + 106988 + 8;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 93676 + 8;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 107052 + 8;
 HEAP32[i2 >> 2] = gb + 107052 + 84;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 16 >> 2] = 2122317823;
 HEAP32[i1 + 20 >> 2] = 2122317823;
 HEAP32[i1 + 24 >> 2] = 2122317823;
 HEAP32[i1 + 28 >> 2] = -25165825;
 HEAP32[i1 + 32 >> 2] = -25165825;
 HEAP32[i1 + 36 >> 2] = -25165825;
 i1 = i1 + 40 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5physx2Gu10ConvexMesh12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 106988 + 8;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 93676 + 8;
 HEAP32[i4 + 12 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 107052 + 8;
 HEAP32[i6 >> 2] = gb + 107052 + 84;
 i6 = i4 + 80 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i2 | -2147483648;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 132;
 i2 = ((HEAPU8[i4 + 55 >> 0] | 0) * 20 | 0) + (i2 & 2147483647) + ((HEAPU8[i4 + 54 >> 0] | 0) * 15 | 0) + ((HEAPU16[i4 + 52 >> 1] | 0) << 1) | 0;
 i6 = i2 & 3;
 i1 = i5 + 4 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 15 & -16;
 i2 = i3 + (((i6 | 0) == 0 ? 0 : 4 - i6 | 0) + i2) | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 56 >> 2] = i3;
 i3 = i4 + 84 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return i4 | 0;
 i2 = i2 + 15 & -16;
 i6 = i2;
 HEAP32[i1 >> 2] = i2 + 28;
 HEAP32[i3 >> 2] = i6;
 __ZN5physx13BigConvexData15importExtraDataERNS_24PxDeserializationContextE(i6, i5);
 HEAP32[i4 + 60 >> 2] = HEAP32[i3 >> 2];
 return i4 | 0;
}

function __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4Effffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0;
 f8 = Math_fround(f2 - f3);
 f3 = Math_fround(Math_fround(Math_fround(f3 * Math_fround(2.0)) / f8) + Math_fround(1.0));
 f4 = Math_fround(f4 - f5);
 f2 = Math_fround(Math_fround(-2.0) / f4);
 f5 = Math_fround(Math_fround(Math_fround(f5 * Math_fround(2.0)) / f4) + Math_fround(1.0));
 f4 = Math_fround(Math_fround(1.0) / Math_fround(f7 - f6));
 f7 = Math_fround(-Math_fround(f4 * f6));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(-2.0) / f8);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAPF32[i1 + 12 >> 2] = f3;
 HEAPF32[i1 + 28 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f7;
 HEAP32[i1 + 60 >> 2] = 1065353216;
 return;
}

function __ZN4FMOD12ChannelGroup18overrideSpeakerMixEffffffff(i2, f7, f8, f9, f10, f11, f12, f13, f14) {
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868322;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868322;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868322;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN26AnimatorControllerPlayable14SetLayerWeightEif(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 if ((i3 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) i1 = HEAP32[HEAP32[i2 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i3 | 0)) {
   i6 = (HEAP32[i2 + 100 >> 2] | 0) + 12 | 0;
   HEAPF32[i6 + (HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = f4;
   STACKTOP = i7;
   return;
  }
 }
 HEAP32[i5 >> 2] = i3;
 __Z6FormatPKcz(i6, gb + 902210 | 0, i5);
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN14SplatMaterialsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = i1 + 40 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 44 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 48 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 52 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 56 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 60 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 64 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 68 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 72 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = -1;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i2 + 64 | 0;
 i6 = HEAP32[i2 + 76 >> 2] | 0;
 HEAP32[i5 >> 2] = 5;
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i4;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = i5;
 i1 = i2 + 72 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = i2 + 40 | 0;
 do if (HEAP8[i1 >> 0] | 0) {
  f7 = Math_fround(+__Z19GetTimeSinceStartupv());
  if (Math_fround(f7 - Math_fround(HEAPF32[i2 + 36 >> 2])) > Math_fround(120.0)) {
   HEAP8[i1 >> 0] = 0;
   break;
  }
  if (HEAP8[i1 >> 0] | 0) {
   __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv(i2);
   i6 = (HEAP32[i2 + 44 >> 2] | 0) != 1;
   STACKTOP = i3;
   return i6 | 0;
  }
 } while (0);
 HEAP32[i2 + 44 >> 2] = 1;
 i6 = 0;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i5 = i8;
 HEAP32[i2 >> 2] = gb + 71428 + 8;
 i6 = i2 + 4 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i2 + 8 >> 2] = i1;
 i1 = i2 + 12 | 0;
 i10 = i3;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 i3 = i2 + 24 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 if (!i4) {
  i10 = __ZnwjRK10MemLabelIdiPKci(48, i1, 16, gb + 492276 | 0, 15) | 0;
  i3 = i1;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i5;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i4;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj(i10, i7, 8192);
  HEAP32[i6 >> 2] = i10;
  STACKTOP = i8;
  return;
 } else {
  i10 = i4 + 4 | 0;
  HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
  STACKTOP = i8;
  return;
 }
}

function __ZL20ShaderWarmupFuncImplP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContext(i1, i2, i3, i4, i6, i7, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 i1 = __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms(i3, 0, HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 92 >> 2] | 0, i5, i1, 0, 0, 0) | 0;
 if (!i1) return;
 i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
 i5 = HEAP32[gb + 1166396 + 4 >> 2] | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 mftCall_viiiiiii(i3 | 0, i6 | 0, i7 | 0, i1 | 0, i4 | 0, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_(i5, HEAP32[i1 >> 2] | 0, 0) | 0, 0, 0);
 __Z15gpu_time_samplev();
 return;
}

function __Z61ParticleSystem_MainModule_CUSTOM_SetGravityModifierMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 2356 >> 2] = f2;
 HEAP8[i1 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2276 | 0, i1 + 2364 | 0, f2, HEAP16[i1 + 2360 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29Cloth_Get_Custom_PropVerticesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 do if (!(HEAP32[i1 + 288 + 12 >> 2] | 0)) i2 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   i2 = HEAP32[i1 + 288 >> 2] | 0;
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i3 = HEAP32[i1 + 288 + 12 >> 2] | 0;
  i4 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
  i3 = (i2 | 0) == 0 ? 0 : i3;
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 12, i3) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 12) | 0, i2 | 0, i3 * 12 | 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZNK4Mesh10GetIndicesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i5 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 128 >> 2] | 0;
 i2 = i3;
 if ((((HEAP32[i1 + 132 >> 2] | 0) - i3 | 0) / 52 | 0) >>> 0 > i6 >>> 0) {
  i4 = HEAP32[i2 + (i6 * 52 | 0) + 32 >> 2] | 0;
  i3 = HEAP32[i1 + 112 >> 2] | 0;
  i1 = (HEAP32[i1 + 116 >> 2] | 0) - i3 | 0;
  i4 = (i1 | 0) != 0 & i1 >>> 0 > i4 >>> 0 ? i3 + i4 | 0 : 0;
  __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_(i5, i4, i4 + (HEAP32[i2 + (i6 * 52 | 0) + 36 >> 2] << 1) | 0);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547109 | 0, 0, gb + 425656 | 0, 1065, 1, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  return;
 }
}

function __ZN8Animator21SetupPlayableConstantEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 168 >> 2] | 0;
 if (!i1) {
  i1 = i2 + 40 | 0;
  HEAP8[i2 + 76 >> 0] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  return;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i2 + 124 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i3 + 8 >> 2];
 i3 = HEAP32[(HEAP32[i2 + 172 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i2 + 56 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 64 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i2 + 68 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP8[i2 + 72 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
 if (__ZNK8Animator7IsHumanEv(i2) | 0) i1 = 0; else i1 = (HEAP32[(HEAP32[i2 + 132 >> 2] | 0) + 16 >> 2] | 0) != 0 & 1;
 HEAP8[i2 + 73 >> 0] = i1;
 HEAP8[i2 + 74 >> 0] = (__ZNK8Animator7IsHumanEv(i2) | 0) & 1;
 HEAP8[i2 + 75 >> 0] = HEAP8[(HEAP32[i2 + 128 >> 2] | 0) + 17 >> 0] | 0;
 return;
}

function __ZN5physx2Sn5ConvX9convert64EPKcRKNS0_15PxMetaDataEntryES6_(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if (HEAP8[i3 + 325 >> 0] | 0) {
  STACKTOP = i10;
  return;
 }
 i6 = i2 + 16 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= 0) {
  STACKTOP = i10;
  return;
 }
 i7 = i3 + 308 | 0;
 i8 = i3 + 304 | 0;
 i5 = i3 + 312 | 0;
 i3 = i4;
 i4 = 0;
 while (1) {
  i2 = i3;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i11 = i9;
  HEAP32[i11 >> 2] = i1;
  HEAP32[i11 + 4 >> 2] = i2;
  if (HEAP8[i7 >> 0] | 0) {
   i1 = _llvm_bswap_i64(i1 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   i11 = i9;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i11 + 4 >> 2] = i2;
  }
  i11 = HEAP32[i8 >> 2] | 0;
  i11 = mftCall_iiii(HEAP32[HEAP32[i11 >> 2] >> 2] | 0, i11 | 0, i9 | 0, 8) | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i11;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= (HEAP32[i6 >> 2] | 0)) break; else i3 = i3 + 8 | 0;
 }
 STACKTOP = i10;
 return;
}

function __ZN29TriggerModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = gb + 618767 | 0;
 i3 = -1;
 do {
  i3 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 618767 + 25 | 0));
 HEAP32[i5 >> 2] = ~i3;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  STACKTOP = i6;
  return;
 }
}

function __ZN22BaseUnityConnectClient19OnEnterStateStoppedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 32 | 0;
 i4 = i5;
 i2 = i1 + 4 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 3) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 __ZN11UnityEngine7Connect12AppStopEventC2Ev(i4);
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i4, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 1) | 0;
 i1 = i1 + 280 | 0;
 __ZN19CloudServiceHandler11FlushEventsEv(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 5;
 __ZN19CloudServiceHandler16StopEventHandlerEv(HEAP32[i1 >> 2] | 0) | 0;
 __ZN19CloudServiceHandler19StopEventDispatcherEv(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = gb + 190148 + 8;
 i1 = i4 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i5;
 return;
}

function __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 2092 >> 2] = f2;
 HEAP8[i1 + 2098 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2012 | 0, i1 + 2100 | 0, f2, HEAP16[i1 + 2096 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 1828 >> 2] = f2;
 HEAP8[i1 + 1834 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1748 | 0, i1 + 1836 | 0, f2, HEAP16[i1 + 1832 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 1564 >> 2] = f2;
 HEAP8[i1 + 1570 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1484 | 0, i1 + 1572 | 0, f2, HEAP16[i1 + 1568 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 178956970 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 357913941;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 12;
 HEAP32[i8 >> 2] = i6 + (i4 * 12 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 57;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9AudioClip13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!(i1 & 2)) {
  if (!(HEAP8[i5 + 64 >> 0] | 0)) {
   STACKTOP = i7;
   return;
  }
  if ((HEAP32[i5 + 52 >> 2] | 0) == 2) {
   STACKTOP = i7;
   return;
  }
  __ZN9AudioClip9LoadSoundEv(i5) | 0;
  STACKTOP = i7;
  return;
 } else {
  i2 = i5 + 128 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   STACKTOP = i7;
   return;
  }
  i3 = __Z15GetSoundManagerv() | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[i5 + 44 >> 0] | 0)) i1 = 0; else i1 = (HEAP32[i5 + 52 >> 2] | 0) == 1 ? 2 : 0;
  i8 = ((__ZNK10SampleClip17CalculateFMODModeEv(i5) | 0) & 128 | 0) == 0;
  HEAP32[i6 >> 2] = __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE(i3, i4, i5 + 72 | 0, i8 ? i1 : 2, HEAP32[i5 + 60 >> 2] | 0, 1) | 0;
  __ZN11SoundHandleaSERKS_(i5 + 56 | 0, i6);
  __ZN11SoundHandleD2Ev(i6);
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN7mecanim9animation24CreateStreamedClipMemoryERKNS0_12StreamedClipERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i1 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 if (!i3) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 * 20 | 0, 4) | 0;
  i3 = i1 + (i3 * 20 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
    HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
    i2 = i2 + 20 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAPF32[i6 + 8 >> 2] = Math_fround(-inf);
 HEAP32[i6 + 12 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15growAndPushBackERKS2_(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, (i9 << 2) + 67 | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i6 = 0; else {
   i6 = i1 + 67 & -64;
   HEAP32[i6 + -4 >> 2] = i6 - i1;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN26PlayerSettingsSplashScreen5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 12 >> 2] = 1;
 i4 = HEAP32[gb + 1162568 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1162568 + 8 >> 2] | 0;
 i2 = HEAP32[gb + 1162568 + 12 >> 2] | 0;
 HEAP32[i1 + 100 >> 2] = HEAP32[gb + 1162568 >> 2];
 HEAP32[i1 + 104 >> 2] = i4;
 HEAP32[i1 + 108 >> 2] = i3;
 HEAP32[i1 + 112 >> 2] = i2;
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP8[i1 + 5 >> 0] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode(i4, i5, i6, i7, i8, i9, f10, i11, i1, i12) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 i11 = i11 | 0;
 i1 = i1 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i13 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((i6 + -2 | 0) >>> 0 > 4) {
  STACKTOP = i3;
  return;
 }
 i13 = i4 + 4620 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 i5 = __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID(i13, i6, i1) | 0;
 __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState(i4 + 6616 | 0, HEAP32[i5 >> 2] | 0, i6, 0, 4);
 __ZN7ApiGLES14TextureSamplerEj16TextureDimension17TextureFilterMode15TextureWrapModeifb18ShadowSamplingModeN2gl17TextureSrgbDecodeE(i13, HEAP32[i5 >> 2] | 0, i6, (i7 | 0) == 2 & (i11 ^ 1) ? 1 : i7, i8, i9, f10, i11, i12, 0);
 STACKTOP = i3;
 return;
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 868 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 868 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 856 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 856 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z63ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 904 >> 2] | 0;
 HEAPF32[i1 + 752 >> 2] = f2;
 HEAP8[i1 + 758 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 672 | 0, i1 + 760 | 0, f2, HEAP16[i1 + 756 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 i6 = HEAP32[i2 + 12 >> 2] | 0;
 i7 = i2 + 56 | 0;
 i8 = i2 + 68 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i10 = i9 + 1 | 0;
 i11 = i2 + 72 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i10 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i11 >> 2] = i1;
   HEAP32[i7 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i7 >> 2] | 0, i1 << 3, 4, i2 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i2 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i11 >> 2] = i1;
   HEAP32[i7 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i10;
 i11 = (HEAP32[i7 >> 2] | 0) + (i9 << 3) | 0;
 HEAP32[i11 >> 2] = i5;
 HEAP32[i11 + 4 >> 2] = i6;
 return;
}

function __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 3;
 i4 = i6 >> 4 >>> 0 < 134217727 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 268435455;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 4) | 0;
 i5 = i6 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 16;
 HEAP32[i8 >> 2] = i6 + (i4 << 4);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9TransformC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i7 = i2;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 56064 + 8;
 i2 = i6;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = i1;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZN2UI6Canvas16TransformChangedEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!(HEAP8[i5 + 33 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 if (i1 & 64 | 0) __ZN2UI6Canvas19SyncTransformParentEv(i5);
 if (i1 & 256 | 0) {
  i1 = HEAP32[i5 + 344 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1 + 224 | 0;
   HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 4;
  }
 }
 __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE(__ZNK10GameObject23QueryComponentTransformEv(HEAP32[i5 + 28 >> 2] | 0) | 0, i5);
 i1 = i5;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i3 = i5 + 112 | 0;
 i1 = i4;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i5 = i5 + 224 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 6;
 STACKTOP = i6;
 return;
}

function __ZN27ShapeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = gb + 617687 | 0;
 i3 = -1;
 do {
  i3 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (gb + 617687 + 31 | 0));
 HEAP32[i5 >> 2] = ~i3;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = 100002;
 HEAP32[i5 + 12 >> 2] = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i4 + 4 | 0, i5);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 16;
  STACKTOP = i6;
  return;
 }
}

function __ZN11UnityEngine9Analytics16TransactionEvent12ToJsonStringER9JSONWrite(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i2, i3);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i3, i2 + 32 | 0, gb + 1037783 | 0, 0);
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i3, i2 + 48 | 0, gb + 1037793 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i3, i2 + 56 | 0, gb + 1037800 | 0, 0);
 __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i3, i2 + 72 | 0, gb + 1037809 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i3, i2 + 80 | 0, gb + 1037823 | 0, 0);
 i4 = i2 + 84 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 88 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i1 = HEAP8[i2 + 100 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 104 >> 2] | 0; else i1 = i1 & 255;
  if (!i1) return;
 }
 __ZN9JSONWrite8TransferIN11UnityEngine9Analytics16TransactionEvent11ReceiptDataEEEvRT_PKc17TransferMetaFlags(i3, i4, gb + 1037835 | 0, 0);
 return;
}

function __ZN11ForceModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 536 | 0, i4);
 i1 = i3 + 800 | 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 801 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 884 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z15StringToHash128RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i8 = i6 ? HEAP32[i1 >> 2] | 0 : i1;
 i5 = i6 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i5 = i5 >>> 0 > 32 ? 16 : i5 >>> 1;
 if (!i5) return;
 i6 = 0;
 do {
  i3 = i6 << 1;
  i1 = HEAP8[i8 + i3 >> 0] | 0;
  i2 = i1 << 24 >> 24;
  do if ((i1 + -48 & 255) < 10) i1 = i2 + -48 | 0; else if ((i1 + -97 & 255) < 6) {
   i1 = i2 + -87 | 0;
   break;
  } else {
   i1 = (i1 + -65 & 255) < 6 ? i2 + -55 | 0 : 0;
   break;
  } while (0);
  i4 = i1 << 4;
  i1 = HEAP8[i8 + (i3 | 1) >> 0] | 0;
  i2 = i1 << 24 >> 24;
  do if ((i1 + -48 & 255) < 10) i1 = i2 + -48 | 0; else if ((i1 + -97 & 255) < 6) {
   i1 = i2 + -87 | 0;
   break;
  } else {
   i1 = (i1 + -65 & 255) < 6 ? i2 + -55 | 0 : 0;
   break;
  } while (0);
  HEAP8[i7 + i6 >> 0] = i1 + i4;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i5 | 0));
 return;
}

function _strcspn(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i5 = 3; else if (!(HEAP8[i1 + 1 >> 0] | 0)) i5 = 3; else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  do {
   i7 = i3 + (((i2 & 255) >>> 5 & 255) << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i2 & 31);
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i2 = HEAP8[i4 >> 0] | 0;
  L7 : do if (!(i2 << 24 >> 24)) i1 = i4; else {
   i1 = i4;
   do {
    if (HEAP32[i3 + (((i2 & 255) >>> 5 & 255) << 2) >> 2] & 1 << (i2 & 31) | 0) break L7;
    i1 = i1 + 1 | 0;
    i2 = HEAP8[i1 >> 0] | 0;
   } while (i2 << 24 >> 24 != 0);
  } while (0);
  i1 = i1 - i4 | 0;
 }
 if ((i5 | 0) == 3) i1 = (___strchrnul(i4, i2 << 24 >> 24) | 0) - i4 | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__26vectorIN19ConstantBuffersGLES11ConstBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 178956970 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 357913941;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 12;
 HEAP32[i8 >> 2] = i6 + (i4 * 12 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN8WindZone7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(72, i1, 16, gb + 1048932 | 0, 0, gb + 487546 | 0, 15) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 69132 + 8;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = i4;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAPF32[i4 + 40 >> 2] = Math_fround(20.0);
 HEAPF32[i4 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 56 >> 2] = Math_fround(.00999999977);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj(i6, i8, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i7 & 134217727;
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > (i2 & 2147483647) >>> 0) {
  i2 = i6 + 8 | 0;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, i1 << 2, gb + 769739 | 0, 329) | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4 | 0) {
   _memcpy(i3 | 0, i4 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   if ((HEAP32[i5 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i6 >> 2] | 0);
  }
  i4 = HEAP32[i5 >> 2] | 0;
  _memset(i3 + ((i4 & 2147483647) << 2) | 0, 0, i1 - i4 << 2 | 0) | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[i5 >> 2] = i1;
 } else i1 = i2;
 i5 = i1 & 2147483647;
 if (!((i5 >>> 0 < i7 >>> 0 ? i5 : i7) | 0)) return;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = ~i7;
 i1 = (i1 | -2147483648) ^ 2147483647;
 i1 = ~(i1 >>> 0 < i2 >>> 0 ? i2 : i1);
 i2 = 0;
 do {
  i7 = i3 + (i2 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i8 + (i2 << 2) >> 2] | HEAP32[i7 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN20LocalFileSystemPosix10AtomicMoveER13FileEntryDataS1_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 12 | 0;
 i6 = i4;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, i1 | 0, i3 | 0);
 i7 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i1 | 0, i2 | 0);
 i2 = _rename(i7, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 L1 : do if (!i2) i1 = 0; else switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
 case 0:
  {
   i1 = 0;
   break L1;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break L1;
  }
 case 2:
  {
   i1 = 1;
   break L1;
  }
 case 18:
  {
   i1 = 10;
   break L1;
  }
 default:
  {
   i1 = 14;
   break L1;
  }
 } while (0);
 HEAP32[i3 + 1056 >> 2] = i1;
 STACKTOP = i4;
 return (i1 | 0) == 0 | 0;
}

function __ZN11TerrainData12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 13120 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + 12352 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 318 | 0)) {
   i4 = i7 + 12352 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + 12352 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + 12352 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + 12352 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + 12352 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 12352 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + 12352 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + 12352 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN10MemoryFile4ReadEyyPvPy(i6, i7, i9, i1, i2, i3, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i10 = i10 | 0;
 var i4 = 0, i5 = 0, i8 = 0, i11 = 0;
 i4 = i6 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  i10 = 0;
  return i10 | 0;
 }
 if ((HEAP32[i6 + 8 >> 2] | 2 | 0) != 2) {
  i10 = 0;
  return i10 | 0;
 }
 i8 = (i10 | 0) != 0;
 if (i8) {
  i11 = i10;
  HEAP32[i11 >> 2] = 0;
  HEAP32[i11 + 4 >> 2] = 0;
 }
 i11 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0) | 0;
 i5 = getTempRet0() | 0;
 if (!(i5 >>> 0 > i9 >>> 0 | (i5 | 0) == (i9 | 0) & i11 >>> 0 > i7 >>> 0)) {
  i11 = 1;
  return i11 | 0;
 }
 i11 = HEAP32[i4 >> 2] | 0;
 i1 = mftCall_iiiiiii(HEAP32[(HEAP32[i11 >> 2] | 0) + 16 >> 2] | 0, i11 | 0, i7 | 0, i9 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i2 = getTempRet0() | 0;
 i7 = _i64Add(i1 | 0, i2 | 0, i7 | 0, i9 | 0) | 0;
 i9 = getTempRet0() | 0;
 i11 = i6 + 24 | 0;
 HEAP32[i11 >> 2] = i7;
 HEAP32[i11 + 4 >> 2] = i9;
 if (!i8) {
  i11 = 1;
  return i11 | 0;
 }
 i11 = i10;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i2;
 i11 = 1;
 return i11 | 0;
}

function __Z62ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = i1 + 264 | 0;
 i1 = i5 + 8 | 0;
 HEAPF32[i5 + 88 >> 2] = f2;
 HEAP8[i1 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i5 + 96 | 0, f2, HEAP16[i5 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z61ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 908 >> 2] | 0;
 HEAPF32[i1 + 528 >> 2] = f2;
 HEAP8[i1 + 534 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 448 | 0, i1 + 536 | 0, f2, HEAP16[i1 + 532 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z40ParticleEmitter_Get_Custom_PropParticlesP12Il2CppObject(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i3 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = ((HEAP32[i1 + 60 >> 2] | 0) - (HEAP32[i1 + 56 >> 2] | 0) | 0) / 48 | 0;
 i1 = HEAP32[(__Z34GetParticlesLegacyScriptingClassesv() | 0) >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 60, ((HEAP32[i2 + 60 >> 2] | 0) - (HEAP32[i2 + 56 >> 2] | 0) | 0) / 48 | 0) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZNK15ParticleEmitter13ReadParticlesEP14SimpleParticleii(i2, __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 60) | 0, 0, i3);
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i4, i5, i1, i2, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i6 = 0, i10 = 0;
 if ((1073741807 - i5 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i4);
 i10 = i4 + 8 | 0;
 if ((HEAP8[i10 + 3 >> 0] | 0) < 0) i6 = HEAP32[i4 >> 2] | 0; else i6 = i4;
 if (i5 >>> 0 < 536870887) {
  i1 = i1 + i5 | 0;
  i3 = i5 << 1;
  i1 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
  i1 = i1 >>> 0 < 2 ? 2 : i1 + 4 & -4;
  if (i1 >>> 0 > 1073741823) {
   i10 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i10);
   ___cxa_throw(i10 | 0, gb + 13048 | 0, fb + 3215 | 0);
  }
 } else i1 = 1073741807;
 i3 = __Znwj(i1 << 2) | 0;
 if (i7 | 0) __ZNSt3__211char_traitsIwE4copyEPwPKwj(i3, i6, i7) | 0;
 i2 = i2 - i8 - i7 | 0;
 if (i2 | 0) __ZNSt3__211char_traitsIwE4copyEPwPKwj(i3 + (i7 << 2) + (i9 << 2) | 0, i6 + (i7 << 2) + (i8 << 2) | 0, i2) | 0;
 if ((i5 | 0) != 1) __ZdlPv(i6);
 HEAP32[i4 >> 2] = i3;
 HEAP32[i10 >> 2] = i1 | -2147483648;
 return;
}

function __ZN5physx6shdfnd5ArrayIfNS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKf(i10, i5) {
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i10 + 8 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i9 = (i9 & 2147483647 | 0) == 0 ? 1 : i9 << 1;
 if (!i9) i6 = 0; else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, (i9 << 2) + 19 | 0, gb + 838004 | 0, 543) | 0;
  if (!i1) i6 = 0; else {
   i6 = i1 + 19 & -16;
   HEAP32[i6 + -4 >> 2] = i6 - i1;
  }
 }
 i7 = i10 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = i6 + (i1 << 2) | 0;
 if ((i1 | 0) > 0) {
  i2 = i6;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i4 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 if ((HEAP32[i8 >> 2] | 0) > -1) {
  i2 = HEAP32[i10 >> 2] | 0;
  if (i2) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
 }
 HEAP32[i10 >> 2] = i6;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i7 >> 2] = i1 + 1;
 return i6 + (i1 << 2) | 0;
}

function __ZN5physx14PxsAABBManager16addAggregatePairEjj(i1, i9, i10) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 i8 = i1 + 49860 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + 49864 | 0;
 if ((i2 | 0) == (HEAP32[i7 >> 2] | 0)) {
  i5 = (i2 | 0) == 0 ? 32 : i2 << 1;
  i4 = i1 + 49856 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, i5 * 12 | 0, gb + 717789 | 0, 59) | 0;
  if (i3 | 0) _memcpy(i1 | 0, i3 | 0, i2 * 12 | 0) | 0;
  _memset(i1 + (i2 * 12 | 0) | 0, 0, (i5 - i2 | 0) * 12 | 0) | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i3);
  HEAP32[i4 >> 2] = i1;
  HEAP32[i7 >> 2] = i5;
  i2 = HEAP32[i8 >> 2] | 0;
 } else i1 = HEAP32[i1 + 49856 >> 2] | 0;
 HEAP32[i8 >> 2] = i2 + 1;
 i8 = i1 + (i2 * 12 | 0) | 0;
 i7 = i9 >>> 0 < i10 >>> 0;
 HEAP32[i8 >> 2] = i7 ? i9 : i10;
 HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] = i7 ? i10 : i9;
 HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] = 0;
 STACKTOP = i11;
 return i8 | 0;
}

function __ZN26AnimatorControllerPlayable8SetFloatEiRKf(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i5 = 8;
  return i5 | 0;
 }
 i3 = i4 + 92 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i6 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  i6 = 4;
  return i6 | 0;
 }
 i6 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 96 >> 2] | 0, i6 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 2) >> 2] | 0) != -1) {
  i6 = 16;
  return i6 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) != 1) {
  i6 = 2;
  return i6 | 0;
 }
 i6 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i6 = i6 + (HEAP32[i6 >> 2] | 0) + 28 | 0;
 HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i5 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9;
 i8 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i7);
 i6 = i5 + 28 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j(i6, i1);
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN9InputAxis8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i7);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if (!i8) {
  STACKTOP = i9;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i9;
 return;
}

function __ZN12InputManager15HasAxisOrButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = i3 + 11 | 0;
 i9 = __Z7FNVHashPKc((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i8 = HEAP32[i1 + 32 >> 2] | 0;
 if ((i4 | 0) == (i8 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = HEAP8[i2 >> 0] | 0;
 i6 = i7 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
 i6 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
 while (1) {
  if ((HEAP32[i4 + 20 >> 2] | 0) == (i9 | 0)) {
   i2 = i4 + 4 | 0;
   i5 = HEAP8[i2 + 11 >> 0] | 0;
   i1 = i5 << 24 >> 24 < 0;
   if (i1) i3 = HEAP32[i4 + 8 >> 2] | 0; else i3 = i5 & 255;
   if ((i3 | 0) == (i7 | 0)) {
    if (i1) {
     i2 = HEAP32[i2 >> 2] | 0;
     i1 = HEAP32[i4 + 8 >> 2] | 0;
    } else i1 = i5 & 255;
    if (!(_strncmp(i2, i6, i1) | 0)) {
     i1 = 1;
     i2 = 13;
     break;
    }
   }
  }
  i4 = i4 + 108 | 0;
  if ((i4 | 0) == (i8 | 0)) {
   i1 = 0;
   i2 = 13;
   break;
  }
 }
 if ((i2 | 0) == 13) return i1 | 0;
 return 0;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7ReleaseEPS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i6 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
  i2 = i6 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i2 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1 + 16;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 876 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 876 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 1300 >> 2] = f2;
 HEAP8[i1 + 1306 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1220 | 0, i1 + 1308 | 0, f2, HEAP16[i1 + 1304 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46Physics2D_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayfiff(i2, i3, i4, f5, i6, f7, f8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 var i1 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 36) | 0;
 i12 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di(i12, i11, i10, f5, i6, f7, f8, 0, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0) | 0;
 if (!i3) {
  STACKTOP = i9;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i9;
 return i3 | 0;
}

function _UNITY_FT_Tan(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) < -2949120) {
  i3 = 0;
  i1 = 14408027;
  while (1) {
   i1 = 0 - i1 | 0;
   i2 = i2 + 5898240 | 0;
   if ((i2 | 0) < -2949120) {
    i7 = i3;
    i3 = i1;
    i1 = i7;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    break;
   }
  }
 } else if ((i2 | 0) > 2949120) {
  i1 = 0;
  i4 = 14408027;
  while (1) {
   i3 = 0 - i1 | 0;
   i2 = i2 + -5898240 | 0;
   if ((i2 | 0) > 2949120) {
    i1 = i4;
    i4 = i3;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    i1 = i4;
    break;
   }
  }
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i3 = 14408027;
  i1 = 0;
 }
 while (1) {
  i4 = i1 + i5 >> i6;
  if ((i2 | 0) < 0) {
   i1 = i1 - (i3 + i5 >> i6) | 0;
   i3 = i4 + i3 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i1 = (i3 + i5 >> i6) + i1 | 0;
   i3 = i3 - i4 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
  }
 }
 return _UNITY_FT_DivFix(i1 + 128 >> 8, i3 + 128 >> 8) | 0;
}

function __ZNSt3__213__vector_baseI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEED2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = i6 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i5 >> 2] = i2 + -36;
   i4 = i2 + -4 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
    HEAP32[i4 >> 2] = 0;
   }
   i2 = i2 + -8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 | 0) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 16 >> 2] | 0, gb + 63184 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
    HEAP32[i2 >> 2] = 0;
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i7 >> 2] = 77;
 HEAP32[i7 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i7);
 STACKTOP = i8;
 return;
}

function __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i2 + ((HEAP32[i1 + 4 >> 2] | 0) - i2 >> 2 << 2);
 i2 = i8 + 11 | 0;
 i3 = i8 + 4 | 0;
 L1 : while (1) {
  do {
   i1 = __ZN15ScriptsIterator4NextEv(i9) | 0;
   if (!i1) {
    i1 = 0;
    i2 = 6;
    break L1;
   }
   i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
   i6 = HEAP8[i4 + 11 >> 0] | 0;
   i5 = i6 << 24 >> 24 < 0;
   i6 = i5 ? HEAP32[i4 + 4 >> 2] | 0 : i6 & 255;
   i11 = HEAP8[i2 >> 0] | 0;
   i7 = i11 << 24 >> 24 < 0;
  } while ((i6 | 0) != ((i7 ? HEAP32[i3 >> 2] | 0 : i11 & 255) | 0));
  if (!(_strncmp(i5 ? HEAP32[i4 >> 2] | 0 : i4, i7 ? HEAP32[i8 >> 2] | 0 : i8, i6) | 0)) {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i10;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i5 = i9 + 4 | 0;
 i8 = i1 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 do if (HEAP32[i5 >> 2] | 0) {
  i2 = i1 + 15 & -16;
  i7 = i2;
  i3 = i2;
  i1 = i7 + 48 | 0;
  HEAP32[i8 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
  i4 = i3 + 36 | 0;
  i6 = i2;
  if (HEAP32[i4 >> 2] | 0) {
   i10 = i3 + 44 | 0;
   HEAP32[i10 >> 2] = HEAP32[i10 >> 2] | -2147483648;
  }
  if (HEAP8[i3 + 32 >> 0] | 0) HEAP32[i4 >> 2] = i3;
  if (!(HEAP32[i2 + 40 >> 2] | 0)) {
   HEAP32[i5 >> 2] = 0;
   break;
  }
  if (!(HEAP8[i6 + 32 >> 0] | 0)) {
   i2 = i6 + 36 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i3 = HEAP32[i6 + 44 >> 2] | 0;
    if (i3 & 2147483647 | HEAP32[i6 + 40 >> 2]) {
     i10 = i7 + ((i3 << 3) + 48) | 0;
     HEAP32[i8 >> 2] = i10;
     HEAP32[i2 >> 2] = i1;
     i1 = i10;
    }
   }
  }
 } while (0);
 i10 = HEAP32[i1 >> 2] | 0;
 i7 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i9 >> 2] = (i10 | 0) == 0 ? 0 : i7;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i10;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_5cloth8SwFabricENS0_9AllocatorEE15growAndPushBackERKS4_(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i10 + 8 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i1 = 0; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i7 << 2, gb + 838004 | 0, 543) | 0;
 i8 = i10 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 4 | 0;
  }
 }
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i9 = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i4 >> 2] = i7;
  i10 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i10;
  i10 = i1 + (i9 << 2) | 0;
  return i10 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i10 >> 2] | 0);
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i4 >> 2] = i7;
 i10 = i9 + 1 | 0;
 HEAP32[i8 >> 2] = i10;
 i10 = i1 + (i9 << 2) | 0;
 return i10 | 0;
}

function __ZN5physx10PxsContext16createFluidShapeEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE(i6, i5, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i6 + 320 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = i6 + 296 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) if (__ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE6extendEv(i6 + 276 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i6 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 } while (0);
 i1 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[(HEAP32[i6 + 292 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = (HEAP32[i6 + 308 >> 2] | 0) + (i2 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i2 & 31);
 if (!i1) {
  i6 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 __ZN5physx16PxsParticleShape4initEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE(i1, i5, i4);
 i6 = i1;
 i5 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 if ((i2 | 0) == (HEAP32[i3 + 32912 >> 2] | 0)) return;
 i4 = ((Math_imul((HEAPU8[i1 + 2 >> 0] | 0) - (HEAPU8[i1 >> 0] | 0) << 2, (HEAPU8[i1 + 3 >> 0] | 0) - (HEAPU8[i1 + 1 >> 0] | 0) | 0) | 0) + 31 | 0) >>> 5;
 i1 = i2 - (i3 + 144) | 0;
 i5 = i1 >> 5;
 i6 = i3 + 132 | 0;
 if ((i5 | 0) >= (HEAP32[i6 >> 2] | 0)) return;
 i7 = i4 + i5 | 0;
 i8 = i1 >> 10;
 i1 = i3 + (i8 << 2) | 0;
 i2 = 1 << (i5 & 31);
 i3 = 0 - i2 | 0;
 if ((i3 | 0) == -1 | (i8 | 0) == (i7 >> 5 | 0)) i2 = i4; else {
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & i2 + -1;
  i3 = -1;
  i2 = i4 + (i5 | -32) | 0;
  i1 = i1 + 4 | 0;
 }
 if ((i2 | 0) > 31) {
  i2 = i2 + -32 | 0;
  i8 = i2 >>> 5;
  _memset(i1 | 0, 0, (i8 << 2) + 4 | 0) | 0;
  i2 = i2 - (i8 << 5) | 0;
  i1 = i1 + (i8 + 1 << 2) | 0;
 }
 if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(i3 & (1 << (i7 & 31)) + -1);
 if ((i7 | 0) != (HEAP32[i6 >> 2] | 0)) return;
 HEAP32[i6 >> 2] = i5;
 return;
}

function __ZN4FMOD8ChannelI9setPausedEb(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var d1 = 0.0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f8 = f0;
 i6 = i7 + 161 | 0;
 if ((HEAPU8[i6 >> 0] | 0) == (i2 & 1 | 0)) return 0;
 HEAP8[i6 >> 0] = i2 & 1;
 d1 = +__Z19GetTimeSinceStartupv() * 44100.0;
 i3 = ~~d1 >>> 0;
 i4 = +Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i5 = i7 + 120 | 0;
 if (i2) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i4;
 } else {
  i2 = i5;
  i2 = _i64Subtract(i3 | 0, i4 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i4 = getTempRet0() | 0;
  i5 = i7 + 104 | 0;
  i3 = i5;
  i3 = _i64Add(i2 | 0, i4 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
  i4 = getTempRet0() | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = i4;
 }
 if (!(HEAP8[i6 >> 0] | 0)) {
  f8 = Math_fround(HEAPF32[i7 + 140 >> 2]);
  d1 = +Math_fround(Math_fround(f8 * Math_fround(HEAPF32[i7 + 152 >> 2])) / Math_fround(44100.0));
 } else d1 = 1.0e-07;
 _JS_Sound_SetPitch(HEAP32[i7 + 164 >> 2] | 0, +d1);
 return 0;
}

function __ZN13MonoBehaviour20StopCoroutineManagedEP9Coroutine(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i6;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 i4 = __Z21GetDelayedCallManagerv() | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i4, i2, fb + 592 | 0, fb + 697 | 0, i5);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i5 + 40 >> 2] = 0;
 i1 = i5 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 56 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i5 + 64 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZN9Coroutine16CleanupCoroutineEPv(i5) | 0;
 STACKTOP = i6;
 return;
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 852 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 852 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 1036 >> 2] = f2;
 HEAP8[i1 + 1042 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 956 | 0, i1 + 1044 | 0, f2, HEAP16[i1 + 1040 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z42CommandBuffer_CUSTOM_Internal_DrawRendererP12Il2CppObjectS0_S0_ii(i1, i3, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i2 = i8;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 558317 | 0, i2);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 558317 | 0, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i5) {
  i5 = 0;
  __ZN22RenderingCommandBuffer15AddDrawRendererEP8RendererP8Materialii(i2, i1, i5, i6, i7);
  STACKTOP = i8;
  return;
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 __ZN22RenderingCommandBuffer15AddDrawRendererEP8RendererP8Materialii(i2, i1, i5, i6, i7);
 STACKTOP = i8;
 return;
}

function __Z36Collider2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfh(i2, i3, i4, f5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 36) | 0;
 if (!i2) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i8) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZN10Collider2D4CastERK8Vector2ffbP12RaycastHit2Di(i8, i7, f5, i6 << 24 >> 24 != 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0) | 0;
 if (!i3) {
  STACKTOP = i9;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i9;
 return i3 | 0;
}

function __ZN9Animation6RewindERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i2 = i1 + 104 | 0;
 i3 = i1 + 108 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) return;
 __ZN9Animation20BuildAnimationStatesEv(i1);
 i1 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) return;
 i8 = HEAP8[i4 + 11 >> 0] | 0;
 i7 = i8 << 24 >> 24 < 0;
 i8 = i7 ? HEAP32[i4 + 4 >> 2] | 0 : i8 & 255;
 i7 = i7 ? HEAP32[i4 >> 2] | 0 : i4;
 while (1) {
  i6 = HEAP32[i1 >> 2] | 0;
  i3 = i6 + 112 | 0;
  i5 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i5 << 24 >> 24 < 0;
  if (i2) i4 = HEAP32[i6 + 116 >> 2] | 0; else i4 = i5 & 255;
  if ((i4 | 0) == (i8 | 0)) {
   if (i2) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i6 + 116 >> 2] | 0;
   } else i2 = i5 & 255;
   if (!(_strncmp(i3, i7, i2) | 0)) break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i9 | 0)) {
   i10 = 15;
   break;
  }
 }
 if ((i10 | 0) == 15) return;
 if (!i6) return;
 __ZN14AnimationState7SetTimeEf(i6, Math_fround(0.0));
 return;
}

function __ZN5Umbra12PortalCullerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 292 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] = i1;
 i1 = HEAP32[i3 + 348 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] = i1;
 i1 = HEAP32[i3 + 2300 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i3 + 2872 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 2876 >> 2];
 i1 = HEAP32[i3 + 2836 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 2840 >> 2];
 i2 = i3 + 432 | 0;
 i1 = HEAP32[i3 + 484 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
 i1 = HEAP32[i3 + 452 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i3 + 424 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 428 >> 2];
 i1 = HEAP32[i3 + 412 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 416 >> 2];
 i1 = HEAP32[i3 + 384 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 388 >> 2];
 i1 = HEAP32[i3 + 372 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 376 >> 2];
 return;
}

function __ZN2UI13RectTransformC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TransformC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 44168 + 8;
 HEAP32[i1 + 136 >> 2] = 1056964608;
 HEAP32[i1 + 140 >> 2] = 1056964608;
 HEAP32[i1 + 144 >> 2] = 1056964608;
 HEAP32[i1 + 148 >> 2] = 1056964608;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 1120403456;
 HEAP32[i1 + 164 >> 2] = 1120403456;
 HEAP32[i1 + 168 >> 2] = 1056964608;
 HEAP32[i1 + 172 >> 2] = 1056964608;
 i3 = i1 + 120 | 0;
 HEAP8[i1 + 176 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i1 + 177 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i3, i8) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = i3 + 44 | 0;
 i9 = i3 + 56 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i11 = HEAP32[i1 + (i10 + -1 << 3) + 4 >> 2] | 0;
 i12 = i10 + 1 | 0;
 i4 = i3 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i12 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[i4 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2 << 3, 4, i3 + 48 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i7 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i3 + 48 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i7 >> 2] | 0, HEAP32[i9 >> 2] << 3 | 0) | 0;
   HEAP32[i4 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   break;
  }
 } while (0);
 HEAP32[i9 >> 2] = i12;
 HEAP32[i1 + (i10 << 3) >> 2] = -1;
 HEAP32[i1 + (i10 << 3) + 4 >> 2] = i11 | i8;
 return;
}

function __ZN17Physics2DSettings20IgnoreLayerCollisionEiib(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i1 = i7 + 4 | 0;
 if ((i5 | 0) > 31 | ((i4 | 0) > 31 | (i5 | i4 | 0) < 0)) {
  HEAP32[i2 >> 2] = 31;
  __Z6FormatPKcz(i1, gb + 806581 | 0, i2);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 805767 | 0, 402, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i7;
  return;
 }
 i1 = 1 << i5;
 if (i6) {
  i6 = HEAP32[i3 + 168 >> 2] | 0;
  i3 = i6 + (i4 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~i1;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~(1 << i4);
  STACKTOP = i7;
  return;
 } else {
  i6 = HEAP32[i3 + 168 >> 2] | 0;
  i3 = i6 + (i4 << 2) | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i1;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << i4;
  STACKTOP = i7;
  return;
 }
}

function __ZN17GeneralConnection30UnregisterDisconnectionHandlerEPFvjE(i4, i7) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = HEAP32[i4 + 88 >> 2] | 0;
 i3 = i4 + 92 | 0;
 if ((i1 | 0) != (i3 | 0)) {
  i2 = i1;
  while (1) {
   mftCall_vi(i7 | 0, HEAP32[i2 + 16 >> 2] | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
  }
 }
 i6 = i4 + 128 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i2;
 i5 = HEAP32[i4 + 124 >> 2] | 0;
 while (1) {
  if ((i5 | 0) == (i2 | 0)) {
   i8 = 15;
   break;
  }
  i4 = i5 + 4 | 0;
  if ((HEAP32[i5 >> 2] | 0) == (i7 | 0)) break; else i5 = i4;
 }
 if ((i8 | 0) == 15) return;
 i1 = i1 - i4 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i5 | 0, i4 | 0, i1 | 0) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i5 + (i3 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = i2 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i2 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i1 = i8 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i9 >>> 0 < i1 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 12 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 12 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i4 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i7 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 i9 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 + (i5 * 12 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i9 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i8) {
  i9 = 0;
  return i9 | 0;
 }
 i3 = HEAP32[i1 + 1072 >> 2] | 0;
 i1 = HEAP32[i1 + 1068 >> 2] | 0;
 i7 = i1;
 if ((i3 | 0) == (i1 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i6 = (i6 | 0) == 0 ? i2 + 4 | 0 : i6;
 i5 = (i3 - i1 | 0) / 40 | 0;
 i1 = 0;
 L7 : while (1) {
  L9 : do if ((HEAP32[i7 + (i1 * 40 | 0) + 20 >> 2] | 0) == (i8 | 0)) {
   i4 = HEAP32[i7 + (i1 * 40 | 0) >> 2] | 0;
   i2 = i8;
   i3 = i6;
   i4 = (i4 | 0) == 0 ? i7 + (i1 * 40 | 0) + 4 | 0 : i4;
   while (1) {
    if ((HEAP8[i4 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) break L9;
    i2 = i2 + -1 | 0;
    if (!i2) break L7; else {
     i3 = i3 + 1 | 0;
     i4 = i4 + 1 | 0;
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i9 = 10;
   break;
  }
 }
 if ((i9 | 0) == 10) return i1 | 0;
 i9 = HEAP32[i7 + (i1 * 40 | 0) + 32 >> 2] | 0;
 return i9 | 0;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7ReleaseEPS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i6 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
  i2 = i6 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i2 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1 + 16;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZL36PostLoadSceneStatic_LightmapSettingsiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if ((HEAP16[gb + 1158140 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158140 | 0, i1);
  i2 = gb + 1158140 | 0;
 } else i2 = 0;
 i1 = __Z21GetManagerFromContexti(26) | 0;
 if ((i4 | 4 | 0) == 5) __Z17MergeLightmapDataiR18AwakeFromLoadQueue(i5, i3); else {
  __ZN21EnlightenSceneMapping14SetSceneHandleEi(i1 + 100 | 0, i5);
  __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE(i5, HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 36 + 12 >> 2] | 0, i1 + 56 | 0);
 }
 i1 = __Z13GetIEnlightenv() | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 | 0);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __Z62ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 872 >> 2] | 0;
 HEAPF32[i1 + 92 >> 2] = f2;
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, f2, HEAP16[i1 + 96 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 896 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 896 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 904 >> 2] = f2;
 HEAP8[i1 + 910 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 824 | 0, i1 + 912 | 0, f2, HEAP16[i1 + 908 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 1700 >> 2] = f2;
 HEAP8[i1 + 1706 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1620 | 0, i1 + 1708 | 0, f2, HEAP16[i1 + 1704 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 1436 >> 2] = f2;
 HEAP8[i1 + 1442 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1356 | 0, i1 + 1444 | 0, f2, HEAP16[i1 + 1440 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 1172 >> 2] = f2;
 HEAP8[i1 + 1178 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 1092 | 0, i1 + 1180 | 0, f2, HEAP16[i1 + 1176 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 3;
 i4 = i6 >> 4 >>> 0 < 134217727 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 268435455;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 4) | 0;
 i5 = i6 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 16;
 HEAP32[i8 >> 2] = i6 + (i4 << 4);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx2Gu13MeshInterface13CheckTopologyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if (!i6) {
  i8 = 0;
  return i8 | 0;
 }
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i1 = 0;
  i5 = 0;
  do {
   i4 = HEAP32[i7 + (i5 * 12 | 0) >> 2] | 0;
   i2 = HEAP32[i7 + (i5 * 12 | 0) + 4 >> 2] | 0;
   i3 = HEAP32[i7 + (i5 * 12 | 0) + 8 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) i8 = 5; else if ((i2 | 0) == (i3 | 0) | (i3 | 0) == (i4 | 0)) i8 = 5;
   if ((i8 | 0) == 5) {
    i8 = 0;
    i1 = i1 + 1 | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i6 >>> 0);
  return i1 | 0;
 } else {
  i1 = 0;
  i5 = 0;
  do {
   i2 = HEAP16[i7 + (i5 * 6 | 0) >> 1] | 0;
   i3 = HEAP16[i7 + (i5 * 6 | 0) + 2 >> 1] | 0;
   i4 = HEAP16[i7 + (i5 * 6 | 0) + 4 >> 1] | 0;
   if (i2 << 16 >> 16 == i3 << 16 >> 16) i8 = 9; else if (i3 << 16 >> 16 == i4 << 16 >> 16 ? 1 : i4 << 16 >> 16 == i2 << 16 >> 16) i8 = 9;
   if ((i8 | 0) == 9) {
    i8 = 0;
    i1 = i1 + 1 | 0;
   }
   i5 = i5 + 1 | 0;
  } while (i5 >>> 0 < i6 >>> 0);
  return i1 | 0;
 }
 return 0;
}

function __ZNK18AnimatorController12StringFromIDEj(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 144 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3;
  i2 = i1;
  L2 : while (1) {
   i1 = i2;
   while (1) {
    if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i1) break L2;
   }
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) {
    i4 = i1;
    break;
   } else i4 = i1;
  }
  if ((i4 | 0) != (i3 | 0)) if ((HEAP32[i4 + 16 >> 2] | 0) >>> 0 <= i5 >>> 0) {
   i1 = i4 + 20 | 0;
   i2 = HEAP8[i1 + 11 >> 0] | 0;
   if (i2 << 24 >> 24 < 0) {
    i3 = HEAP32[i1 >> 2] | 0;
    i1 = HEAP32[i4 + 24 >> 2] | 0;
   } else {
    i3 = i1;
    i1 = i2 & 255;
   };
   HEAP32[i6 >> 2] = 0;
   HEAP32[i6 + 4 >> 2] = 0;
   HEAP32[i6 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i1);
   return;
  }
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 1576256 | 0, 0);
 return;
}

function __ZN8Renderer10SetVisibleEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 HEAP8[i3 + 329 >> 0] = i1 & 1;
 i1 = HEAP16[i3 + 328 >> 1] | 0;
 if ((i1 & 65535) < 256 | (i1 & 255) << 24 >> 24 == 0) i2 = 3; else {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  if (!i1) i2 = 3; else {
   i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
   if (!(i1 ^ (HEAP32[i3 + 284 >> 2] | 0) != -1)) return;
   if (i1) {
    i1 = i3 + 316 | 0;
    if (HEAP32[i1 >> 2] | 0) return;
    i2 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
    if ((i1 | 0) == (i2 | 0)) return;
    i3 = i3 + 320 | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    HEAP32[i1 >> 2] = i4;
    HEAP32[i3 >> 2] = i2;
    HEAP32[i4 + 4 >> 2] = i1;
    HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
    return;
   }
  }
 }
 if ((i2 | 0) == 3) if ((HEAP32[i3 + 284 >> 2] | 0) == -1) return;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 160 >> 2] | 0, i3 | 0);
 i1 = i3 + 316 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 320 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 __ZN6Object11InvokeEventEi(i3, 1);
 return;
}

function __ZN5physx3Scb14ParticleSystem12ForceUpdates10initializeEj(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i3 * 12 | 0, gb + 699190 | 0, 31) | 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i1 | 0, i5 | 0, 12, (i2 ? gb + 699407 | 0 : gb + 837976 | 0) | 0, gb + 699190 | 0, 32) | 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 i1 = (i3 + 31 | 0) >>> 5;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  HEAP32[i5 >> 2] = i1;
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2 + 8 | 0, i1 << 2, gb + 769739 | 0, 352) | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i1;
  i1 = HEAP32[i5 >> 2] << 2;
 }
 _memset(i2 | 0, 0, i1 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i6 >> 2] | 0)) do {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = i4 + 120 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2 | 0) {
   __Z23scripting_gchandle_freej(i2);
   HEAP32[i3 >> 2] = 0;
  }
  i2 = i4 + 124 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __Z23scripting_gchandle_freej(i3);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i4 + 128 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __Z23scripting_gchandle_freej(i3);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i6 >> 2] | 0));
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i3) return;
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN20SoundChannelInstance4StopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 if (HEAP32[i1 + 184 >> 2] | 0) {
  i2 = i1 + 240 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __ZN11AudioSource25UnbindFromChannelInstanceERK7WeakPtrI20SoundChannelInstanceE(i3, i1 + 248 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP8[i1 + 239 >> 0] = 1;
 }
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZN4FMOD7Channel4stopEv(i1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 447;
 HEAP32[i5 + 8 >> 2] = gb + 853995;
 HEAP32[i5 + 12 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN12LightsModule17MainThreadCleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = i6 + 580 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 576 | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = i1 + -344 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i7 = i1 + 4 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 i5 = i6 + 588 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 584 | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -344 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i7 = i1 + 4 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN12LightsModule17DeleteLightsCacheEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = i6 + 580 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 576 | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i2 = i1 + -344 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i7 = i1 + 4 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 i5 = i6 + 588 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i6 + 584 | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -344 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i7 = i1 + 4 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[HEAP32[i7 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if ((HEAP32[i8 >> 2] | 0) != 1) return;
 i6 = i8 + 560 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i7 = _time(0) | 0;
 i5 = i8 + 576 | 0;
 i1 = i5;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i8 + 568 | 0;
 i9 = i4;
 i3 = i8 + 584 | 0;
 if ((i2 | 0) == (HEAP32[i9 >> 2] | 0) ? (i1 | 0) == (HEAP32[i9 + 4 >> 2] | 0) : 0) i3 = HEAP32[i3 >> 2] | 0; else {
  HEAP32[i3 >> 2] = i7;
  i1 = i4;
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i5;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  i3 = i7;
 }
 if ((i7 - i3 | 0) < (HEAP32[i8 + 8 >> 2] | 0)) return;
 HEAP32[i6 >> 2] = 0;
 i1 = __ZN11UnityEngine15CloudWebService16SessionContainer18GetIndexFromDataIdEy(i2, i1) | 0;
 if ((i1 & 65535) > 4) return;
 i9 = i1 & 65535;
 HEAP8[i8 + 40 + (i9 << 7) + 92 >> 0] = 1;
 i7 = HEAP32[i8 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, fb + 3961 | 0, i8 + 40 + (i9 << 7) | 0) | 0;
 return;
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 868 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 856 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z57ParticleSystem_LightsModule_CUSTOM_SetIntensityMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 920 >> 2] | 0;
 HEAPF32[i1 + 368 >> 2] = f2;
 HEAP8[i1 + 374 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 288 | 0, i1 + 376 | 0, f2, HEAP16[i1 + 372 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z57ParticleSystem_CollisionModule_CUSTOM_SetDampenMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 904 >> 2] | 0;
 HEAPF32[i1 + 224 >> 2] = f2;
 HEAP8[i1 + 230 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 144 | 0, i1 + 232 | 0, f2, HEAP16[i1 + 228 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z57ParticleSystem_CollisionModule_CUSTOM_SetBounceMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 904 >> 2] | 0;
 HEAPF32[i1 + 488 >> 2] = f2;
 HEAP8[i1 + 494 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 408 | 0, i1 + 496 | 0, f2, HEAP16[i1 + 492 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 3;
 i4 = i6 >> 4 >>> 0 < 134217727 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 268435455;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 4) | 0;
 i5 = i6 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 16;
 HEAP32[i8 >> 2] = i6 + (i4 << 4);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i8 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 _memset(i5 | 0, 0, i8 << 2 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 2);
 HEAP32[i9 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj(i3, i1, i4, i5, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 mftCall_vii(HEAP32[i3 + 636 >> 2] | 0, 1, i7 | 0);
 i8 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 i2 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i3 + 860 >> 2] | 0, i1) | 0;
 i1 = i3 + 892 + (i1 << 2) | 0;
 if (HEAP8[i3 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i8 | 0)) {
  i8 = i3 + 656 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_viiii(i8 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0);
  i8 = HEAP32[i7 >> 2] | 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = i8;
 mftCall_vii(HEAP32[i3 + 644 >> 2] | 0, i2 | 0, i8 | 0);
 i8 = i3 + 656 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_viiii(i8 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0);
 i8 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN21DownloadHandlerScript17InvokeReceiveDataEP12Il2CppObjectP11Il2CppArrayi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 248 | 0;
 i5 = i9 + 8 | 0;
 i6 = i9;
 i7 = i1 + 20 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i11 = i7;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i2, i8);
 __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i5, i3);
 __ZN18ScriptingArguments6AddIntEi(i5, i4);
 i1 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
 HEAP32[i8 >> 2] = 0;
 i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i8, 0) | 0;
 if (!(HEAP32[i8 >> 2] | 0)) i1 = (HEAP8[i1 + 8 >> 0] | 0) != 0; else i1 = 0;
 i11 = i1;
 STACKTOP = i9;
 return i11 | 0;
}

function __ZN17PolygonCollider2D8TransferI14SafeBinaryReadEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i2 = i6;
 __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i1, i5);
 i4 = i1 + 160 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 802559 | 0, gb + 802568 | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 802578 | 0, HEAP32[gb + 37316 >> 2] | 0, i3, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i5, i4, 0); else {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i5);
  }
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 469407 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, gb + 469909 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN18UnityPropertySheet11UnityTexEnv8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN14SafeBinaryRead8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags(i8, i5, i2, i1) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i6 = i7 + 8 | 0;
 i3 = i7;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, i2, gb + 906465 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 if ((i1 | 0) > 0) {
  HEAP32[i6 >> 2] = 15;
  HEAP32[i6 + 4 >> 2] = i5;
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i8, gb + 906470 | 0, HEAP32[gb + 37256 >> 2] | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi15EEEEvRT_17TransferMetaFlags(i8, i6, 0); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i8 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i8);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i8 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i8);
 STACKTOP = i7;
 return;
}

function __ZN11Rigidbody2D11SetVelocityERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808121 | 0, 0, gb + 807613 | 0, 1007, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i5 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i5) return;
 if (HEAP8[i1 + 226 >> 0] | 0) {
  i3 = i2;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1 + 212 | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  return;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f7 = Math_fround(f7 * f7);
 f6 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (Math_fround(f7 + Math_fround(f6 * f6)) > Math_fround(0.0)) {
  i2 = i5 + 4 | 0;
  i3 = HEAPU16[i2 >> 1] | 0;
  if (!(i3 & 2)) {
   HEAP16[i2 >> 1] = i3 | 2;
   HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
  }
 }
 HEAP32[i5 + 64 >> 2] = i4;
 HEAP32[i5 + 68 >> 2] = i1;
 return;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7ReleaseEPS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i6 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
  i2 = i6 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i2 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1 + 16;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53LightProbes_CUSTOM_INTERNAL_CALL_GetInterpolatedProbeRK8Vector3fP12Il2CppObjectP20SphericalHarmonicsL2(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 24 | 0;
 i7 = i8;
 i3 = __Z19GetLightmapSettingsv() | 0;
 __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings(i6, i3, __Z17GetRenderSettingsv() | 0);
 do if (!i2) i4 = -1; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) i4 = -1; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
   i4 = HEAP32[i3 + 32 + 232 >> 2] | 0;
   break;
  }
 } while (0);
 __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates(i6, i1, i4, i7) | 0;
 __Z37InterpolateLightProbeCoefficientsSafeRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i6, i7, i5);
 STACKTOP = i8;
 return;
}

function __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_(i3, i1, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i3 + 8 | 0;
 i7 = i3 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 L1 : while (1) switch (HEAP32[i2 + (i1 << 3) >> 2] & 3) {
 case 2:
  break L1;
 case 1:
  {
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i9 = i1 + 1 | 0;
   __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_(i3, i9, i4, i5);
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = ((HEAP32[i2 + (i1 << 3) >> 2] | 0) >>> 4) + i9 | 0;
   continue L1;
  }
 case 0:
  {
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   i9 = i1 + 1 | 0;
   __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_(i3, i9, i4, i5);
   i2 = HEAP32[i6 >> 2] | 0;
   i1 = ((HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[i2 + (i1 << 3) >> 2] | 0) >>> 2 << 3) >> 2] | 0) >>> 2) + i9 | 0;
   continue L1;
  }
 default:
  {
   i8 = 6;
   break L1;
  }
 }
 if ((i8 | 0) == 6) return;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZNK19ShaderPropertySheet11SerializeToEPh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2;
 i4 = i1 + 8 | 0;
 i5 = i3 + 24 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i4 = i2 + 24 | 0;
 i5 = HEAP32[i1 + 44 >> 2] << 2;
 _memcpy(i4 | 0, HEAP32[i1 + 32 >> 2] | 0, i5 | 0) | 0;
 i5 = i4 + i5 | 0;
 i4 = HEAP32[i1 + 64 >> 2] << 2;
 _memcpy(i5 | 0, HEAP32[i1 + 52 >> 2] | 0, i4 | 0) | 0;
 i4 = i5 + i4 | 0;
 i5 = HEAP32[i1 + 84 >> 2] | 0;
 _memcpy(i4 | 0, HEAP32[i1 + 72 >> 2] | 0, i5 | 0) | 0;
 i5 = i4 + i5 | 0;
 i4 = i1 + 92 | 0;
 i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i5 >> 0] = i4;
 HEAP8[i5 + 1 >> 0] = i4 >> 8;
 HEAP8[i5 + 2 >> 0] = i4 >> 16;
 HEAP8[i5 + 3 >> 0] = i4 >> 24;
 i5 = i5 + 4 | 0;
 i4 = i1 + 96 | 0;
 i4 = HEAPU8[i4 >> 0] | HEAPU8[i4 + 1 >> 0] << 8 | HEAPU8[i4 + 2 >> 0] << 16 | HEAPU8[i4 + 3 >> 0] << 24;
 HEAP8[i5 >> 0] = i4;
 HEAP8[i5 + 1 >> 0] = i4 >> 8;
 HEAP8[i5 + 2 >> 0] = i4 >> 16;
 HEAP8[i5 + 3 >> 0] = i4 >> 24;
 return;
}

function __ZN8Renderer19PostInitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 i2 = i1 + 8 | 0;
 i4 = i1;
 i5 = gb + 63520 | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = __Z20CreateObjectFromCodeI10GameObjectEPT_17AwakeFromLoadMode10MemLabelId(4, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, gb + 410102 | 0);
 i7 = gb + 63520 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i3 = __Z20CreateObjectFromCodeI9TransformEPT_17AwakeFromLoadMode10MemLabelId(4, i3) | 0;
 HEAP32[gb + 1158204 >> 2] = i3;
 __ZN10GameObject20AddComponentInternalERS_RN5Unity9ComponentE(i2, i3);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 125);
 STACKTOP = i1;
 return;
}

function __ZN7mecanim13crc32_table_tILj79764919EE10init_tableEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = 0;
 do {
  i2 = i3 << 24 >> 24 < 0 ? 159529838 : 0;
  i2 = (i3 & 64 ? i2 ^ 79764919 : i2) << 1;
  i2 = i3 & 32 ? i2 ^ 79764919 : i2;
  i2 = (i3 & 16) == 0 ? i2 : i2 ^ -2147483648;
  i1 = i2 << 1;
  i1 = (i2 | 0) < 0 ? i1 ^ 79764919 : i1;
  i1 = (i3 & 8) == 0 ? i1 : i1 ^ -2147483648;
  i2 = i1 << 1;
  i2 = (i1 | 0) < 0 ? i2 ^ 79764919 : i2;
  i2 = (i3 & 4) == 0 ? i2 : i2 ^ -2147483648;
  i1 = i2 << 1;
  i1 = (i2 | 0) < 0 ? i1 ^ 79764919 : i1;
  i1 = (i3 & 2) == 0 ? i1 : i1 ^ -2147483648;
  i2 = i1 << 1;
  i2 = (i1 | 0) < 0 ? i2 ^ 79764919 : i2;
  i2 = (i3 & 1) == 0 ? i2 : i2 ^ -2147483648;
  i1 = i2 << 1;
  i1 = (i2 | 0) < 0 ? i1 ^ 79764919 : i1;
  i2 = 0;
  i4 = 0;
  while (1) {
   i2 = ((i1 & 1 | 0) == 0 ? 0 : 1 << 31 - i4) | i2;
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == 32) break; else i1 = i1 >>> 1;
  }
  i4 = (__ZN7mecanim9reflectorILj8EE7reflectEh(i3) | 0) & 255;
  HEAP32[gb + 1111240 + (i4 << 2) >> 2] = i2;
  i3 = i3 + 1 << 24 >> 24;
 } while (i3 << 24 >> 24 != 0);
 HEAP8[gb + 1573581 >> 0] = 1;
 return;
}

function __ZN6Sprite9ReloadAllEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 8 | 0;
 i1 = i7;
 i2 = i7 + 16 | 0;
 i4 = gb + 64016 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i2 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i1);
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i1;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 31832 | 0, i2, 1);
 i5 = HEAP32[i5 >> 2] | 0;
 if (i5 | 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = 0;
  do {
   HEAP8[(HEAP32[i6 + (i1 << 2) >> 2] | 0) + 132 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i5 >>> 0);
 }
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i4);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE(i1, i8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i5 = i1 + 60 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16384;
 return;
}

function __ZN24RigidbodyMovementState2D18SetLinearMoveStateERK8Vector2f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, f5 = f0, i6 = 0, f7 = f0;
 i6 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 92 >> 2] | 0;
 if (!i6) return;
 f7 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]));
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f7 * Math_fround(f5 - Math_fround(HEAPF32[i6 + 12 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f7 * Math_fround(f3 - Math_fround(HEAPF32[i6 + 16 >> 2])));
 i4 = i2 + 110 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i1 = HEAP32[i6 + 68 >> 2] | 0;
  HEAP32[i2 + 96 >> 2] = HEAP32[i6 + 64 >> 2];
  HEAP32[i2 + 100 >> 2] = i1;
 }
 if (HEAP32[i6 >> 2] | 0) {
  if (Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3)) > Math_fround(0.0)) {
   i1 = i6 + 4 | 0;
   i2 = HEAPU16[i1 >> 1] | 0;
   if (!(i2 & 2)) {
    HEAP16[i1 >> 1] = i2 | 2;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  HEAPF32[i6 + 64 >> 2] = f5;
  HEAPF32[i6 + 68 >> 2] = f3;
 }
 HEAPF32[i6 + 132 >> 2] = Math_fround(0.0);
 HEAP8[i4 >> 0] = 1;
 return;
}

function __Z56ParticleSystem_MainModule_CUSTOM_SetStartSpeedMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 772 >> 2] = f2;
 HEAP8[i1 + 778 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 692 | 0, i1 + 780 | 0, f2, HEAP16[i1 + 776 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _unity_z_tr_tally(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 5792 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP16[(HEAP32[i1 + 5796 >> 2] | 0) + (i5 << 1) >> 1] = i2;
 HEAP32[i4 >> 2] = i5 + 1;
 HEAP8[(HEAP32[i1 + 5784 >> 2] | 0) + i5 >> 0] = i3;
 if (!i2) {
  i5 = i1 + 148 + (i3 << 2) | 0;
  HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
  i4 = HEAP32[i4 >> 2] | 0;
  i5 = i1 + 5788 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i5 = i5 + -1 | 0;
  i5 = (i4 | 0) == (i5 | 0);
  i5 = i5 & 1;
  return i5 | 0;
 } else {
  i5 = i1 + 5808 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = i2 + -1 | 0;
  i3 = i1 + 148 + ((HEAPU8[gb + 361974 + i3 >> 0] | 0 | 256) + 1 << 2) | 0;
  HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | 0) + 1 << 16 >> 16;
  i5 = i1 + 2440 + ((HEAPU8[(i5 >>> 0 < 256 ? i5 : (i5 >>> 7) + 256 | 0) + (gb + 361462) >> 0] | 0) << 2) | 0;
  HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + 1 << 16 >> 16;
  i4 = HEAP32[i4 >> 2] | 0;
  i5 = i1 + 5788 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i5 = i5 + -1 | 0;
  i5 = (i4 | 0) == (i5 | 0);
  i5 = i5 & 1;
  return i5 | 0;
 }
 return 0;
}

function __ZN8VRDevice18ReleaseEyeTexturesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = i5;
 i4 = i1 + 288 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZN19VREyeTextureManager18ReleaseEyeTexturesEv(i1) | 0)) {
  STACKTOP = i5;
  return;
 }
 if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i2);
  i1 = gb + 1469192 | 0;
 } else i1 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 536 >> 2] | 0, i3 | 0) | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 544 >> 2] | 0, i2 | 0, i3 | 0);
 __Z15gpu_time_samplev();
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN19VREyeTextureManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63816 | 0);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN7ApiGLES11UnmapBufferEjN2gl12BufferTargetE(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0; else i2 = i1;
 i5 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i6 + 860 >> 2] | 0, i2) | 0;
 i2 = i6 + 892 + (i2 << 2) | 0;
 if (!(HEAP8[i6 + 1992 >> 0] | 0)) i7 = 5; else if ((HEAP32[i2 >> 2] | 0) != (i4 | 0)) i7 = 5;
 if ((i7 | 0) == 5) {
  HEAP32[i2 >> 2] = i4;
  mftCall_vii(HEAP32[i6 + 644 >> 2] | 0, i5 | 0, i4 | 0);
 }
 mftCall_ii(HEAP32[i3 + 672 >> 2] | 0, i5 | 0) | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 706 >> 0] | 0)) return;
 i2 = HEAP32[gb + 1451080 >> 2] | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i2 + 892 + (i1 << 2) >> 2] = 0;
 i7 = HEAP32[i2 + 644 >> 2] | 0;
 mftCall_vii(i7 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0, 0);
 return;
}

function __ZN5physx30PxHeightFieldDescGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 673134;
 HEAP32[i1 + 4 >> 2] = 290;
 HEAP32[i1 + 8 >> 2] = fb + 2106;
 HEAP32[i1 + 12 >> 2] = gb + 673368;
 HEAP32[i1 + 16 >> 2] = 291;
 HEAP32[i1 + 20 >> 2] = fb + 2107;
 HEAP32[i1 + 24 >> 2] = fb + 3484;
 HEAP32[i1 + 28 >> 2] = gb + 673375;
 HEAP32[i1 + 32 >> 2] = 292;
 HEAP32[i1 + 36 >> 2] = fb + 2108;
 HEAP32[i1 + 40 >> 2] = fb + 3485;
 HEAP32[i1 + 44 >> 2] = gb + 673385;
 HEAP32[i1 + 48 >> 2] = 293;
 HEAP32[i1 + 52 >> 2] = fb + 2109;
 HEAP32[i1 + 56 >> 2] = fb + 3486;
 HEAP32[i1 + 60 >> 2] = gb + 673392;
 HEAP32[i1 + 64 >> 2] = 294;
 HEAP32[i1 + 68 >> 2] = fb + 3487;
 HEAP32[i1 + 72 >> 2] = fb + 3488;
 HEAP32[i1 + 76 >> 2] = gb + 673400;
 HEAP32[i1 + 80 >> 2] = 295;
 HEAP32[i1 + 84 >> 2] = fb + 371;
 HEAP32[i1 + 88 >> 2] = fb + 314;
 HEAP32[i1 + 92 >> 2] = gb + 673410;
 HEAP32[i1 + 96 >> 2] = 296;
 HEAP32[i1 + 100 >> 2] = fb + 372;
 HEAP32[i1 + 104 >> 2] = fb + 315;
 HEAP32[i1 + 108 >> 2] = gb + 743223;
 HEAP32[i1 + 112 >> 2] = 297;
 HEAP32[i1 + 116 >> 2] = fb + 2110;
 HEAP32[i1 + 120 >> 2] = fb + 3489;
 return;
}

function __ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj(i5, i8, i7) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + i7 | 0;
 i3 = i5 + 16 | 0;
 if (i2 >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0) {
  i4 = HEAP32[i5 + 8 >> 2] | 0;
  i5 = i1;
  i5 = i4 + i5 | 0;
  _memcpy(i5 | 0, i8 | 0, i7 | 0) | 0;
  i8 = HEAP32[i6 >> 2] | 0;
  i8 = i8 + i7 | 0;
  HEAP32[i6 >> 2] = i8;
  return i7 | 0;
 }
 i1 = i2 + 4096 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i5 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, gb + 666835 | 0, gb + 666863 | 0, 46) | 0;
 i1 = i5 + 8 | 0;
 _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 }
 HEAP32[i1 >> 2] = i3;
 i4 = i3;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i4 + i5 | 0;
 _memcpy(i5 | 0, i8 | 0, i7 | 0) | 0;
 i8 = HEAP32[i6 >> 2] | 0;
 i8 = i8 + i7 | 0;
 HEAP32[i6 >> 2] = i8;
 return i7 | 0;
}

function __ZN5physx16PxsParticleShape4initEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 44 >> 2] = i1;
 i12 = HEAP16[i1 >> 1] | 0;
 HEAP16[i3 + 36 >> 1] = i12;
 i11 = HEAP16[i1 + 2 >> 1] | 0;
 HEAP16[i3 + 38 >> 1] = i11;
 i1 = HEAP16[i1 + 4 >> 1] | 0;
 HEAP16[i3 + 40 >> 1] = i1;
 f6 = Math_fround(i12 << 16 >> 16);
 f5 = Math_fround(i11 << 16 >> 16);
 f4 = Math_fround(i1 << 16 >> 16);
 f7 = Math_fround(HEAPF32[i2 + 668 >> 2]);
 f6 = Math_fround(f6 * f7);
 f5 = Math_fround(f5 * f7);
 f4 = Math_fround(f4 * f7);
 f8 = Math_fround(HEAPF32[i2 + 684 >> 2]);
 f10 = Math_fround(f5 - f8);
 f9 = Math_fround(f4 - f8);
 HEAPF32[i3 + 12 >> 2] = Math_fround(f6 - f8);
 HEAPF32[i3 + 16 >> 2] = f10;
 HEAPF32[i3 + 20 >> 2] = f9;
 f5 = Math_fround(f8 + Math_fround(f7 + f5));
 f4 = Math_fround(f8 + Math_fround(f7 + f4));
 HEAPF32[i3 + 24 >> 2] = Math_fround(f8 + Math_fround(f7 + f6));
 HEAPF32[i3 + 28 >> 2] = f5;
 HEAPF32[i3 + 32 >> 2] = f4;
 return;
}

function __ZN5physx13SingleManager6resizeEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11;
 i6 = i10 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i11 + 1 | 0, (i9 << 3) + 30 & -32, gb + 717789 | 0, 1093) | 0;
 i8 = i10 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 | 0) _memcpy(i2 | 0, i1 | 0, i7 << 2 | 0) | 0;
 i3 = i9 - i7 << 2;
 _memset(i2 + (i7 << 2) | 0, 0, i3 | 0) | 0;
 i4 = i2 + ((i9 << 2) + 15 & -16) | 0;
 HEAP32[i8 >> 2] = i2;
 if (i7 >>> 0 < i9 >>> 0) {
  i1 = i7;
  do {
   HEAP32[i2 + (i1 << 2) >> 2] = 1073741823;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 i1 = i10 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _memcpy(i4 | 0, i2 | 0, i7 << 2 | 0) | 0;
 _memset(i4 + (i7 << 2) | 0, 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i6 >> 2] = i9;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i10 >> 2] | 0);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 STACKTOP = i11;
 return;
}

function __ZN4crnd10dxt1_block16get_block_colorsEPNS_10color_quadIhiEEtt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 & 65535) > (i3 & 65535)) {
  __ZN4crnd10dxt1_block17get_block_colors4EPNS_10color_quadIhiEEtt(i1, i2, i3) | 0;
  i3 = 4;
  return i3 | 0;
 } else {
  i6 = i2 & 65535;
  i2 = i6 >>> 2 & 7 | i6 << 3;
  i4 = i6 >>> 5 << 2 | i6 >>> 9 & 3;
  i6 = i6 >>> 11 << 3 | i6 >>> 13;
  i7 = i3 & 65535;
  i3 = i7 >>> 2 & 7 | i7 << 3;
  i5 = i7 >>> 5 << 2 | i7 >>> 9 & 3;
  i7 = i7 >>> 11 << 3 | i7 >>> 13;
  HEAP8[i1 >> 0] = i6;
  HEAP8[i1 + 1 >> 0] = i4;
  HEAP8[i1 + 2 >> 0] = i2;
  HEAP8[i1 + 3 >> 0] = -1;
  HEAP8[i1 + 4 >> 0] = i7;
  HEAP8[i1 + 5 >> 0] = i5;
  HEAP8[i1 + 6 >> 0] = i3;
  HEAP8[i1 + 7 >> 0] = -1;
  HEAP8[i1 + 8 >> 0] = (i7 + i6 | 0) >>> 1;
  HEAP8[i1 + 9 >> 0] = ((i5 & 255) + (i4 & 255) | 0) >>> 1;
  HEAP8[i1 + 10 >> 0] = ((i3 & 255) + (i2 & 255) | 0) >>> 1;
  HEAP8[i1 + 11 >> 0] = -1;
  i3 = i1 + 12 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i3 = 3;
  return i3 | 0;
 }
 return 0;
}

function __ZN4FMOD7Channel13setSpeakerMixEffffffff(i2, f7, f8, f9, f10, f11, f12, f13, f14) {
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868743;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868743;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868743;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN12ServerSocket14StartListeningEPK8sockaddrjb(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i6 = i1 + 17 | 0;
 if (HEAP8[i6 >> 0] | 0) {
  __Z6FormatPKcz(i3, gb + 584741 | 0, i7);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 584759 | 0, 44, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(__ZN6Socket11SetBlockingEb(i1, i2) | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = i1 + 4 | 0;
 if (__ZN6Socket10CheckErrorEiPKcii(_bind(HEAP32[i1 >> 2] | 0, i4, i5) | 0, gb + 584715 | 0, 0, 0) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (__ZN6Socket10CheckErrorEiPKcii(_listen(HEAP32[i1 >> 2] | 0, 5) | 0, gb + 584727 | 0, 0, 0) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP8[i6 >> 0] = 1;
 i6 = 1;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 876 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 892 >> 2] | 0;
 HEAPF32[i1 + 616 >> 2] = f2;
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, f2, HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 892 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46DownloadHandler_CUSTOM_InternalCreateAudioClipP12Il2CppObjectP12Il2CppStringi(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 12 | 0;
 i6 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 i3 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63808 | 0, 16, gb + 1027567 | 0, 127) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i7);
 __ZN24DownloadHandlerAudioClipC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15FMOD_SOUND_TYPE(i3, i6, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 HEAP32[i4 + 8 >> 2] = i3;
 i1 = i3 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i4) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __Z43AnimationClipPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(184, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN21AnimationClipPlayableC2E18DirectorPlayerType(i3, 0);
 __ZN8Playable6HandleEv(i1, i3);
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 i3 = HEAP32[i3 + 20 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (i5) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 __ZN21AnimationClipPlayable7SetClipEP13AnimationClip(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 if (i5) {
  i5 = 0;
  __ZN17AnimationPlayable8OwnAssetEP11NamedObject(i1, i5);
  STACKTOP = i6;
  return;
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 __ZN17AnimationPlayable8OwnAssetEP11NamedObject(i1, i5);
 STACKTOP = i6;
 return;
}

function __Z28Cloth_Get_Custom_PropNormalsP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 do if (!(HEAP32[i1 + 320 >> 2] | 0)) i2 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   i2 = HEAP32[i1 + 308 >> 2] | 0;
   break;
  }
 } while (0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i3 = HEAP32[i1 + 320 >> 2] | 0;
  i4 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
  i3 = (i2 | 0) == 0 ? 0 : i3;
  i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 12, i3) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 12) | 0, i2 | 0, i3 * 12 | 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i8 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 _memset(i5 | 0, 0, i8 << 2 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 2);
 HEAP32[i9 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcj(i2, i9, i3) {
 i2 = i2 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i8 = _strlen(i9) | 0;
 i6 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 i6 = (i1 - i6 | 0) >>> 0 > i8 >>> 0 ? i6 + i8 | 0 : i1;
 i7 = i2 + i6 | 0;
 L5 : do if ((i8 | 0) == 0 | (i6 | 0) < (i8 | 0)) i1 = i7; else {
  i5 = i2 + (i8 + -1) | 0;
  i6 = i9 + i8 + -1 | 0;
  i1 = i7;
  L7 : while (1) {
   while (1) {
    if ((i5 | 0) == (i1 | 0)) {
     i1 = i7;
     break L5;
    }
    i4 = i1 + -1 | 0;
    if ((HEAP8[i4 >> 0] | 0) == (HEAP8[i6 >> 0] | 0)) {
     i3 = i6;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i9 | 0)) break L5;
    i1 = i1 + -1 | 0;
    i3 = i3 + -1 | 0;
    if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
     i1 = i4;
     continue L7;
    }
   }
  }
 } while (0);
 return ((i8 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 | 0) | 0;
}

function __ZN9Heightmap16GetPxHeightFieldEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i2 + 100 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = HEAP32[i4 >> 2] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i5 = __Z11GetIPhysicsv() | 0;
 if (!i5) {
  i5 = HEAP32[i4 >> 2] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 1;
 HEAPF32[i3 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 HEAP16[i3 + 28 >> 1] = 0;
 if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i2, i3) | 0) {
  HEAP32[i4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 64 >> 2] | 0, i5 | 0, i3 | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
 }
 i5 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 HEAP32[i1 + 68 >> 2] = gb + 831985;
 HEAP32[i1 + 72 >> 2] = 673;
 HEAP32[i1 + 76 >> 2] = fb + 2423;
 HEAP32[i1 + 80 >> 2] = gb + 834551;
 HEAP32[i1 + 84 >> 2] = 674;
 HEAP32[i1 + 88 >> 2] = fb + 3966;
 HEAP32[i1 + 92 >> 2] = fb + 3967;
 HEAP32[i1 + 96 >> 2] = gb + 831985;
 HEAP32[i1 + 100 >> 2] = 689;
 HEAP32[i1 + 104 >> 2] = fb + 2424;
 HEAP32[i1 + 108 >> 2] = gb + 834565;
 HEAP32[i1 + 112 >> 2] = 690;
 HEAP32[i1 + 116 >> 2] = fb + 3968;
 HEAP32[i1 + 120 >> 2] = fb + 3969;
 return;
}

function __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 HEAP32[i1 + 68 >> 2] = gb + 831985;
 HEAP32[i1 + 72 >> 2] = 673;
 HEAP32[i1 + 76 >> 2] = fb + 2423;
 HEAP32[i1 + 80 >> 2] = gb + 834551;
 HEAP32[i1 + 84 >> 2] = 674;
 HEAP32[i1 + 88 >> 2] = fb + 3966;
 HEAP32[i1 + 92 >> 2] = fb + 3967;
 HEAP32[i1 + 96 >> 2] = gb + 831985;
 HEAP32[i1 + 100 >> 2] = 677;
 HEAP32[i1 + 104 >> 2] = fb + 2427;
 HEAP32[i1 + 108 >> 2] = gb + 834565;
 HEAP32[i1 + 112 >> 2] = 678;
 HEAP32[i1 + 116 >> 2] = fb + 3973;
 HEAP32[i1 + 120 >> 2] = fb + 3974;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE(i1, i8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 i5 = i1 + 60 | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16384;
 return;
}

function __ZN5physx17NodeChangeManager4initEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 1 | 0;
 i2 = i5 + 20 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  HEAP32[i2 >> 2] = i4;
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 3, gb + 681489 | 0, 1416) | 0;
  HEAP32[i5 >> 2] = i3;
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = i3 + (i4 << 2);
  HEAP32[i5 + 16 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 i3 = i5 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) >>> 0 >= i4 >>> 0) {
  STACKTOP = i6;
  return;
 }
 i8 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, i4 << 3, gb + 681489 | 0, 1482) | 0;
 i7 = i8 + (i4 << 2) | 0;
 _memcpy(i8 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] << 2 | 0) | 0;
 i1 = i5 + 8 | 0;
 _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 + 12 >> 2] << 2 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i8;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN5Umbra13MatrixFactory7frustumEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0, f10 = f0;
 f10 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(f3 - f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 / f9);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 f8 = Math_fround(f5 - f4);
 f10 = Math_fround(f10 / f8);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f10;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 f8 = Math_fround(Math_fround(f4 + f5) / f8);
 f5 = Math_fround(f7 - f6);
 f4 = Math_fround(Math_fround(-Math_fround(f6 + f7)) / f5);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f2 + f3) / f9);
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAP32[i1 + 56 >> 2] = -1082130432;
 f7 = Math_fround(Math_fround(-Math_fround(Math_fround(f7 * Math_fround(2.0)) * f6)) / f5);
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = f7;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN3MBP12storeHandlesEP10MBP_ObjectjPK15BoxPrunerHandle(i6, i4, i8, i7) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 switch (i8 | 0) {
 case 1:
  {
   i8 = i4 + 8 | 0;
   i7 = HEAPU16[i7 >> 1] | HEAPU16[i7 + 2 >> 1] << 16;
   HEAP16[i8 >> 1] = i7;
   HEAP16[i8 + 2 >> 1] = i7 >>> 16;
   return;
  }
 case 0:
  return;
 default:
  {
   i5 = i6 + 96 + (i8 << 4) | 0;
   i1 = i6 + 4208 + (i8 << 2) | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == -1) {
    i3 = i6 + 96 + (i8 << 4) + 4 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    HEAP32[i4 + 8 >> 2] = i1;
    i2 = i8 & 1073741823;
    if ((i1 + i2 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
     __ZN5physx2Gu9Container6ResizeEj(i5, i2) | 0;
     i1 = HEAP32[i3 >> 2] | 0;
    }
    i6 = (HEAP32[i6 + 96 + (i8 << 4) + 8 >> 2] | 0) + (i1 << 2) | 0;
    HEAP32[i3 >> 2] = i1 + i2;
    i1 = i6;
   } else {
    HEAP32[i4 + 8 >> 2] = i2;
    i6 = (HEAP32[i6 + 96 + (i8 << 4) + 8 >> 2] | 0) + (i2 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
    i1 = i6;
   }
   _memcpy(i1 | 0, i7 | 0, i8 << 2 | 0) | 0;
   return;
  }
 }
}

function __ZN13WheelCollider10SetupLayerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  STACKTOP = i5;
  return;
 }
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP32[i4 + 52 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP32[i4 + 56 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i4 = (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) + 56 >> 2] | 0) + 8 | 0;
 i6 = __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i4, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2];
 __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i4, HEAP32[i3 >> 2] | 0, i2);
 STACKTOP = i5;
 return;
}

function __ZN10Collider2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i4, i1);
 i5 = i4 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!((i1 | 0) != 0 & (i1 & 20 | 0) == 0)) {
  __ZN10Collider2D19WakeAllBodyContactsEv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i3 = 6; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0;
   __ZN10Collider2D7CleanupEb(i4, i2);
   if (i2) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i4 | 0, 0);
  } else i3 = 6;
  if ((i3 | 0) == 6) __ZN10Collider2D7CleanupEb(i4, 0);
  if ((HEAP32[i4 + 72 >> 2] | 0) > 0) {
   i1 = HEAP32[(HEAP32[HEAP32[i4 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
   if (i1 | 0) {
    i1 = HEAP32[i1 + 148 >> 2] | 0;
    if (i1 | 0) __ZN11Rigidbody2D11SetSleepingEb(i1, 0);
   }
  }
 }
 HEAP32[i4 + 156 >> 2] = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 >> 2] | 0, gb + 153580 | 0) | 0;
 return;
}

function __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 4 | 0;
 i3 = i2 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (!i1) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 i1 = __ZN5audio5mixer16GetSnapshotIndexERNS0_18AudioMixerConstantEPKc(i1, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0) | 0;
 if ((i1 | 0) != -1) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
 __Z6FormatPKcz(i5, gb + 861647 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 861578 | 0, 486, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 852 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i5) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 L7 : do if ((i1 | 0) < (i2 | 0)) {
  i4 = HEAP32[i5 + 32 >> 2] | 0;
  while (1) {
   if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i1 = gb + 1162292 | 0;
    break L7;
   }
  }
  if ((i1 | 0) > -1) i1 = (HEAP32[i5 + 72 >> 2] | 0) + (HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0; else i1 = gb + 1162292 | 0;
 } else i1 = gb + 1162292 | 0; while (0);
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i7;
 return;
}

function _UNITY_tt_size_run_fpgm(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i4 + 292 >> 2] | 0;
 i3 = _UNITY_TT_Load_Context(i5, i2, i4) | 0;
 if (i3 | 0) {
  i5 = i3;
  return i5 | 0;
 }
 HEAP32[i5 + 428 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 476 >> 2] = 64;
 HEAP32[i5 + 480 >> 2] = 0;
 HEAP32[i5 + 484 >> 2] = 0;
 HEAP8[i5 + 488 >> 0] = 0;
 HEAP32[i5 + 564 >> 2] = 16384;
 HEAP8[i5 + 561 >> 0] = i1;
 i3 = i5 + 216 | 0;
 HEAP16[i5 + 252 >> 1] = 0;
 HEAP32[i5 + 260 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i5 + 256 >> 2] = 65536;
 i3 = i2 + 628 | 0;
 _UNITY_TT_Set_CodeRange(i5, 1, HEAP32[i2 + 632 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 _UNITY_TT_Clear_CodeRange(i5, 2);
 _UNITY_TT_Clear_CodeRange(i5, 3);
 if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i4 + 296 >> 2] = 0; else {
  _UNITY_TT_Goto_CodeRange(i5, 1, 0);
  i1 = mftCall_ii(HEAP32[i2 + 652 >> 2] | 0, i5 | 0) | 0;
  HEAP32[i4 + 296 >> 2] = i1;
  if (i1 | 0) {
   i5 = i1;
   return i5 | 0;
  }
 }
 _UNITY_TT_Save_Context(i5, i4);
 i5 = 0;
 return i5 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5imbueERKNS_6localeE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i6 = i8 + 8 | 0;
 i2 = i8 + 4 | 0;
 i7 = i8;
 HEAP32[i6 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i3 = invoke_iii(fb + 1146 | 0, i1 | 0, i4 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 do if (!(i9 & 1)) {
  HEAP32[i2 >> 2] = i3;
  __ZNSt3__26localeD2Ev(i2);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  if (i1 | 0) {
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
   i9 = i1 + 4 | 0;
   __ZNSt3__26localeC2ERKS0_(i5, i9);
   __ZNSt3__26localeaSERKS0_(i9, i4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   __ZNSt3__26localeD2Ev(i7);
  }
  STACKTOP = i8;
  return HEAP32[i6 >> 2] | 0;
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i6);
 ___resumeException(i9 | 0);
 return 0;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5imbueERKNS_6localeE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 12 | 0;
 i6 = i8 + 8 | 0;
 i2 = i8 + 4 | 0;
 i7 = i8;
 HEAP32[i6 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i3 = invoke_iii(fb + 1146 | 0, i1 | 0, i4 | 0) | 0;
 i9 = __THREW__;
 __THREW__ = 0;
 do if (!(i9 & 1)) {
  HEAP32[i2 >> 2] = i3;
  __ZNSt3__26localeD2Ev(i2);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  if (i1 | 0) {
   __THREW__ = 0;
   invoke_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
   i9 = __THREW__;
   __THREW__ = 0;
   if (i9 & 1) break;
   i9 = i1 + 4 | 0;
   __ZNSt3__26localeC2ERKS0_(i5, i9);
   __ZNSt3__26localeaSERKS0_(i9, i4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   __ZNSt3__26localeD2Ev(i7);
  }
  STACKTOP = i8;
  return HEAP32[i6 >> 2] | 0;
 } while (0);
 i9 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i6);
 ___resumeException(i9 | 0);
 return 0;
}

function __ZNK9Rigidbody24GetRelativePointVelocityERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 40 | 0;
 i10 = i4;
 i5 = i4 + 28 | 0;
 i2 = i2 + 52 | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i11 >> 2] | 0) + 84 >> 2] | 0, i10 | 0, i11 | 0);
 f9 = Math_fround(HEAPF32[i10 + 16 >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i3 >> 2]));
 f8 = Math_fround(HEAPF32[i10 + 20 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f7 = Math_fround(HEAPF32[i10 + 24 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i6 >> 2] = f9;
 HEAPF32[i6 + 4 >> 2] = f8;
 HEAPF32[i6 + 8 >> 2] = f7;
 __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E(i5, HEAP32[i2 >> 2] | 0, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 f1 = Math_fround(HEAPF32[i3 + 108 >> 2]);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(f1 - Math_fround(HEAPF32[i3 + 104 >> 2])) / f1); else f1 = Math_fround(0.0);
 i7 = (HEAP32[i3 + 100 >> 2] | 0) + 1494990940 | 0;
 i3 = (Math_imul(i7, 1790253981) | 0) + 1900727103 | 0;
 i7 = i7 << 11 ^ i7;
 __Z8EvaluateRK14MinMaxGradientff(i5, i2 + 8 | 0, f1, Math_fround(Math_fround(((i3 ^ i7 ^ i7 >>> 8) & 8388607 ^ i3 >>> 19) >>> 0) * Math_fround(1.19209304e-07)));
 i3 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i2 = i3 >>> 8;
 HEAP32[i4 >> 2] = (Math_imul((i5 >>> 8 & 255) + 1 | 0, i2 & 255) | 0) & 65280 | (Math_imul((i5 >>> 24) + 1 | 0, i2 & 16711680) | 0) & -16777216 | (Math_imul((i5 & 255) + 1 | 0, i3 & 255) | 0) >>> 8 & 255 | (Math_imul((i5 >>> 16 & 255) + 1 | 0, i3 & 16711680) | 0) >>> 8 & 16711680;
 STACKTOP = i6;
 return;
}

function __ZN6b2Body19SynchronizeFixturesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 f8 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f9 = Math_fround(+Math_sin(+f8));
 HEAPF32[i3 + 8 >> 2] = f9;
 f8 = Math_fround(+Math_cos(+f8));
 HEAPF32[i3 + 12 >> 2] = f8;
 f10 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f7 = Math_fround(f8 * f10);
 f6 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f7 = Math_fround(f7 - Math_fround(f9 * f6));
 f6 = Math_fround(Math_fround(f10 * f9) + Math_fround(f8 * f6));
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) - f7);
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) - f6);
 HEAPF32[i3 >> 2] = f7;
 HEAPF32[i3 + 4 >> 2] = f6;
 i4 = (HEAP32[i2 + 88 >> 2] | 0) + 102872 | 0;
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i2 + 12 | 0;
 do {
  __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_(i1, i4, i3, i2);
  i1 = HEAP32[i1 + 24 >> 2] | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sq12BucketPruner13updateObjectsEPKjPKNS_9PxBounds3Ej(i8, i5, i7, i4) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i9 = 0;
 if (!i4) i1 = HEAP32[i8 + 7628 >> 2] | 0; else {
  i2 = HEAP32[i8 + 7636 >> 2] | 0;
  i3 = HEAP32[i8 + 7628 >> 2] | 0;
  i1 = i3;
  i6 = 0;
  do {
   i9 = HEAP32[i2 + (HEAP32[i5 + (i6 << 2) >> 2] << 2) >> 2] | 0;
   HEAP32[i3 + (i9 * 24 | 0) >> 2] = HEAP32[i7 + (i6 * 24 | 0) >> 2];
   HEAP32[i3 + (i9 * 24 | 0) + 4 >> 2] = HEAP32[i7 + (i6 * 24 | 0) + 4 >> 2];
   HEAP32[i3 + (i9 * 24 | 0) + 8 >> 2] = HEAP32[i7 + (i6 * 24 | 0) + 8 >> 2];
   HEAP32[i3 + (i9 * 24 | 0) + 12 >> 2] = HEAP32[i7 + (i6 * 24 | 0) + 12 >> 2];
   HEAP32[i3 + (i9 * 24 | 0) + 16 >> 2] = HEAP32[i7 + (i6 * 24 | 0) + 16 >> 2];
   HEAP32[i3 + (i9 * 24 | 0) + 20 >> 2] = HEAP32[i7 + (i6 * 24 | 0) + 20 >> 2];
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i4 | 0));
 }
 i9 = HEAP32[i8 + 7632 >> 2] | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i8 + 7620 >> 2];
 HEAP32[i8 + 24 >> 2] = i1;
 HEAP32[i8 + 28 >> 2] = i9;
 HEAP32[i8 + 32 >> 2] = 0;
 HEAP8[i8 + 7600 >> 0] = 1;
 return;
}

function __ZN28LightProbeProxyVolumeManager21AllocateVolumeTextureER21LightProbeProxyVolumePKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i8 = i3;
 i6 = HEAP32[i1 + 140 >> 2] | 0;
 i5 = HEAP32[i1 + 144 >> 2] | 0;
 i4 = HEAP32[i1 + 148 >> 2] | 0;
 i10 = gb + 63520 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 i1 = __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId(4, i7) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
 __ZN9Texture3D11InitTextureEiii13TextureFormatb(i1, i6 << 2, i5, i4, 6, 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAP32[i1 + 44 >> 2] = 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN12CachedReader4SkipEj(i9, i2) {
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i1 = i3 + i2 | 0;
 i7 = i9 + 8 | 0;
 if (i1 >>> 0 <= (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i9 >> 2] = i1;
  return;
 }
 i8 = i9 + 4 | 0;
 i4 = i9 + 16 | 0;
 i6 = i9 + 20 | 0;
 i5 = i3 + i2 - (HEAP32[i8 >> 2] | 0) + (Math_imul(HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) | 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i9, i5, 0);
 if (HEAP8[i9 + 32 >> 0] | 0) return;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = (i5 >>> 0) / (i1 >>> 0) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i9 + 12 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0);
  i2 = (i5 >>> 0) / ((HEAP32[i6 >> 2] | 0) >>> 0) | 0;
  HEAP32[i4 >> 2] = i2;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i8 | 0, i7 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i7 = i5 - (Math_imul(i2, i1) | 0) | 0;
 HEAP32[i9 >> 2] = (HEAP32[i8 >> 2] | 0) + i7;
 return;
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7ReleaseEPS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i6 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 2) >> 2] | 0;
  i2 = i6 + 12 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i2 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i2;
  i3 = i1 + 20 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i1 + 16;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i2;
  HEAP32[i3 >> 2] = i2;
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z59ParticleSystem_MainModule_CUSTOM_SetStartLifetimeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 896 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_LightsModule_CUSTOM_SetRangeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 920 >> 2] | 0;
 HEAPF32[i1 + 104 >> 2] = f2;
 HEAP8[i1 + 110 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 24 | 0, i1 + 112 | 0, f2, HEAP16[i1 + 108 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_(i8, i7, i9) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 i6 = i7;
 i10 = i9 - i6 >> 2;
 i2 = i8 + 8 | 0;
 i11 = i2 + 3 | 0;
 i1 = HEAP8[i11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i2 = (HEAP32[i2 >> 2] & 2147483647) + -1 | 0; else i2 = 1;
 if (i10 >>> 0 > i2 >>> 0) {
  if (i3) i1 = HEAP32[i8 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i8, i2, i10 - i2 | 0, i1, 0, i1, 0);
  i1 = HEAP8[i11 >> 0] | 0;
 }
 i5 = i1 << 24 >> 24 < 0;
 if (i5) i4 = HEAP32[i8 >> 2] | 0; else i4 = i8;
 i3 = (i9 - i6 | 0) >>> 2;
 i2 = i4;
 i1 = i7;
 while (1) {
  if ((i1 | 0) == (i9 | 0)) break;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 }
 HEAP32[i4 + (i3 << 2) >> 2] = 0;
 if (i5) HEAP32[i8 + 4 >> 2] = i10; else HEAP8[i11 >> 0] = i10;
 return i8 | 0;
}

function __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_PKNS0_10SphereDataESA_(i8, i2, i1, i11) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12 + 88 | 0;
 i3 = i12 + 80 | 0;
 i10 = i12 + 64 | 0;
 i4 = i12 + 48 | 0;
 i5 = i12 + 32 | 0;
 i6 = i12 + 16 | 0;
 i7 = i12;
 __ZN5physx5cloth11BoundingBoxI8Scalar4fEC2ERKS3_(i8, i2);
 if ((i1 | 0) == (i11 | 0)) {
  STACKTOP = i12;
  return;
 }
 i2 = i8 + 16 | 0;
 do {
  HEAP32[i3 >> 2] = __Z11loadAlignedPKf(__ZN5physx5cloth5arrayERKNS_6PxVec3E(i1) | 0) | 0;
  __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i9, i3);
  __Z5splatILj3EE8Scalar4fRKS0_(i10, i9);
  __ZmiRK8Scalar4fS1_(i5, i9, i10);
  __Z3minRK8Scalar4fS1_(i4, i8, i5);
  __ZN8Scalar4faSERKS_(i8, i4) | 0;
  __ZplRK8Scalar4fS1_(i7, i9, i10);
  __Z3maxRK8Scalar4fS1_(i6, i2, i7);
  __ZN8Scalar4faSERKS_(i2, i6) | 0;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i11 | 0));
 STACKTOP = i12;
 return;
}

function __ZN24MoveReplaceFileOperation7ExecuteEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 1084 | 0;
 i6 = i2 + 12 | 0;
 i4 = i2 + 24 | 0;
 i5 = i2;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i6, i8, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i5, i6, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i1 = __ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags(i3, i4, 2) | 0;
 __ZN13FileEntryDataD2Ev(i4);
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN15ResourceManager10Dependency8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 450774 | 0, HEAP32[gb + 37176 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 470499 | 0, HEAP32[gb + 37316 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __Z55ParticleSystem_TrailModule_CUSTOM_SetLifetimeMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 908 >> 2] | 0;
 HEAPF32[i1 + 92 >> 2] = f2;
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, f2, HEAP16[i1 + 96 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z41LightmapSettings_Set_Custom_PropLightmapsP11Il2CppArray(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i7 = i4;
 i3 = i4 + 16 | 0;
 i6 = gb + 64016 | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = i3 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i8, i7);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i2;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 __Z33ScriptingClassArrayToDynamicArrayI12LightmapData16LightmapDataMono13dynamic_arrayIS0_Lj4EEEvP11Il2CppArrayRT1_PFvRT0_RT_E(i1, i3, fb + 2852 | 0);
 __ZN16LightmapSettings12SetLightmapsERK13dynamic_arrayI12LightmapDataLj4EE(__Z19GetLightmapSettingsv() | 0, i3);
 if ((HEAP32[i5 >> 2] | 0) <= -1) {
  STACKTOP = i4;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function _UNITY_png_write_oFFs(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 16 | 0;
 i6 = i7;
 _UNITY_png_save_int_32(i6, i2);
 _UNITY_png_save_int_32(i6 + 4 | 0, i3);
 HEAP8[i6 + 8 >> 0] = i4;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i4 = i1 + 656 | 0;
 HEAP32[i4 >> 2] = 34;
 HEAP8[i5 >> 0] = 0;
 HEAP8[i5 + 1 >> 0] = 0;
 HEAP8[i5 + 2 >> 0] = 0;
 HEAP8[i5 + 3 >> 0] = 9;
 i3 = i5 + 4 | 0;
 HEAP8[i3 >> 0] = 111;
 HEAP8[i5 + 5 >> 0] = 70;
 HEAP8[i5 + 6 >> 0] = 70;
 HEAP8[i5 + 7 >> 0] = 115;
 _UNITY_png_write_data(i1, i5, 8);
 HEAP32[i1 + 372 >> 2] = 1866876531;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i3, 4);
 HEAP32[i4 >> 2] = 66;
 _UNITY_png_write_data(i1, i6, 9);
 _UNITY_png_calculate_crc(i1, i6, 9);
 HEAP32[i4 >> 2] = 130;
 i6 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i5 >> 0] = i6 >>> 24;
 HEAP8[i5 + 1 >> 0] = i6 >>> 16;
 HEAP8[i5 + 2 >> 0] = i6 >>> 8;
 HEAP8[i5 + 3 >> 0] = i6;
 _UNITY_png_write_data(i1, i5, 4);
 STACKTOP = i7;
 return;
}

function _UNITY_png_user_version_check(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = (i3 | 0) == 0;
 i2 = i1 + 208 | 0;
 if (i4) {
  i1 = HEAP32[i2 >> 2] | 131072;
  HEAP32[i2 >> 2] = i1;
 } else {
  if ((HEAP8[i3 >> 0] | 0) != 49) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  if ((HEAP8[i3 + 1 >> 0] | 0) != 46) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  if ((HEAP8[i3 + 2 >> 0] | 0) != 54) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  if ((HEAP8[i3 + 3 >> 0] | 0) != 46) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  if ((HEAP8[i3 + 4 >> 0] | 0) != 49) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  if ((HEAP8[i3 + 5 >> 0] | 0) != 48) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 131072;
  i1 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i3 + 6 >> 0] | 0) {
   i1 = i1 | 131072;
   HEAP32[i2 >> 2] = i1;
  }
 }
 if (i1 & 131072 | 0) {
  if (i4) {
   i4 = 0;
   return i4 | 0;
  }
  if ((HEAP8[i3 >> 0] | 0) != 49) {
   i4 = 0;
   return i4 | 0;
  }
  if ((HEAP8[i3 + 2 >> 0] | 0) != 54) {
   i4 = 0;
   return i4 | 0;
  }
  if ((HEAP8[i3 + 3 >> 0] | 0) != 46) {
   i4 = 0;
   return i4 | 0;
  }
 }
 i4 = 1;
 return i4 | 0;
}

function _exp2(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0, d6 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 > 1083174911) {
  i2 = (i2 | 0) > -1 | (i2 | 0) == -1 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 4294967295;
  if (i2 & i3 >>> 0 > 1083179007) {
   d1 = d1 * 8988465674311579538646525.0e283;
   break;
  }
  if (i3 >>> 0 > 2146435071) {
   d1 = -1.0 / d1;
   break;
  } else if (!(d1 <= -1075.0) | i2) {
   i4 = 9;
   break;
  } else {
   d1 = 0.0;
   break;
  }
 } else if (i3 >>> 0 < 1016070144) d1 = d1 + 1.0; else i4 = 9; while (0);
 if ((i4 | 0) == 9) {
  d6 = d1 + 26388279066624.0;
  HEAPF64[tempDoublePtr >> 3] = d6;
  i4 = (HEAP32[tempDoublePtr >> 2] | 0) + 128 | 0;
  i3 = i4 << 1 & 510;
  d5 = +HEAPF64[gb + 4288 + (i3 << 3) >> 3];
  d1 = d1 - (d6 + -26388279066624.0) - +HEAPF64[gb + 4288 + ((i3 | 1) << 3) >> 3];
  d1 = +_scalbn(d5 + d5 * d1 * (d1 * (d1 * (d1 * (d1 * 1.3333559164630223e-03 + .009618129842126066) + .0555041086648214) + .2402265069591) + .6931471805599453), (i4 & -256 | 0) / 256 | 0);
 }
 return +d1;
}

function __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 3 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 3 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 3);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 3) + i8 | 0;
 if (i4 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 2;
 i4 = i5 >> 3 >>> 0 < 268435455 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i3 - i1 >> 3 << 3) | 0;
 _memset(i5 | 0, 0, i8 << 3 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 3);
 HEAP32[i9 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj(i8, i4, i1, i7) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = i8 + 11 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i6 = HEAP32[i8 + 4 >> 2] | 0; else i6 = i2 & 255;
 if (i6 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i3) i2 = (HEAP32[i8 + 8 >> 2] & 2147483647) + -1 | 0; else i2 = 10;
 if ((i2 - i6 | 0) >>> 0 < i7 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i8, i2, i6 + i7 - i2 | 0, i6, i4, 0, i7, i1); else if (i7 | 0) {
  if (i3) i5 = HEAP32[i8 >> 2] | 0; else i5 = i8;
  i3 = i6 - i4 | 0;
  i2 = i5 + i4 | 0;
  if (i3) {
   _memmove(i2 + i7 | 0, i2 | 0, i3 | 0) | 0;
   i1 = i2 >>> 0 <= i1 >>> 0 & (i5 + i6 | 0) >>> 0 > i1 >>> 0 ? i1 + i7 | 0 : i1;
  }
  _memmove(i2 | 0, i1 | 0, i7 | 0) | 0;
  i1 = i6 + i7 | 0;
  if ((HEAP8[i9 >> 0] | 0) < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
  HEAP8[i5 + i1 >> 0] = 0;
 }
 return i8 | 0;
}

function __ZN9Scripting30CreateScriptableObjectWithTypeEP12Il2CppObjectb(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 8 | 0;
 i2 = i6;
 i3 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 if (!i3) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(148, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 465174 | 0, 558) | 0;
 i9 = gb + 63520 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode(i1, i4, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject(i1, i3, 0);
 if (i5) __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb(i1, 1);
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN5physx2Sn5ConvX22convertReferenceTablesEPKvRiS4_(i6, i2, i5, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 356 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 + 348 >> 2] = 0;
 HEAP32[i6 + 360 >> 2] = 0;
 i1 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i6, i2, 16) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - (0 - i2 & 15);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i6, i2);
 HEAP32[i3 >> 2] = i2;
 if (!i2) __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i6, 1, gb + 669800 | 0, i7);
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -4;
 i1 = __ZN5physx2Sn5ConvX20convertManifestTableEPKvRi(i6, i1 + 4 | 0, i5) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i5 = __ZN5physx2Sn5ConvX25convertInternalReferencesEPKvRi(i6, __ZN5physx2Sn5ConvX23convertExportReferencesEPKvRi(i6, __ZN5physx2Sn5ConvX23convertImportReferencesEPKvRi(i6, i1, i5) | 0, i5) | 0, i5) | 0;
 HEAP32[i4 >> 2] = i6 + 344;
 i6 = i5;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN26ProbeSetTetrahedralization8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[gb + 37316 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 378823 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11TetrahedronLj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 20 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 378836 | 0, i3, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags(i5, i2, 0); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN17Physics2DSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i9 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(188, i1, 16, gb + 1048932 | 0, 0, gb + 807826 | 0, 21) | 0;
 i7 = i1;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i9;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 156328 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 i1 = i6;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 180 >> 2] = 0;
 HEAP32[i4 + 184 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 172 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 37008 >> 2] | 0, i3, i4, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i2, 1); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[gb + 37224 >> 2] | 0, i3, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i2, 1); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 888 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx2Sn13XmlNodeWriter10addContentEPKc(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 8 | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i4 | 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i4 >> 0] | 0) {
   i1 = i4;
   do i1 = i1 + 1 | 0; while ((HEAP8[i1 >> 0] | 0) != 0);
   __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj(i3 + 8 | 0, i4 + -8 | 0, HEAP32[i4 + -4 >> 2] | 0);
  }
 }
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i6) {
  i4 = gb + 1576256 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i6 = i6 + 4 | 0;
  HEAP32[i6 >> 2] = i4;
  return;
 }
 if (!(HEAP8[i6 >> 0] | 0)) {
  i4 = gb + 1576256 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i6 = i6 + 4 | 0;
  HEAP32[i6 >> 2] = i4;
  return;
 } else {
  i2 = i6;
  i1 = 0;
 }
 while (1) {
  i3 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
  if (!(HEAP8[i2 >> 0] | 0)) {
   i2 = i3;
   break;
  } else i1 = i3;
 }
 i4 = __ZN5physx19CVariableMemoryPool8allocateEj(i4 + 8 | 0, i1 + 2 | 0) | 0;
 _memcpy(i4 | 0, i6 | 0, i2 | 0) | 0;
 HEAP8[i4 + i2 >> 0] = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = i4;
 return;
}

function __ZN5physx11Adjacencies4LoadERNS_13PxInputStreamE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(65, 68, 74, 65, i4, i1, i2) | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i5 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i1 >> 0] | 0) != 0, i2) | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = i5 * 12 | 0;
 i7 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i8 | 0, i7 | 0, (i5 >>> 0 > 357913941 | i6 >>> 0 > 4294967291 ? -1 : i6 + 4 | 0) | 0, (i1 ? gb + 727608 | 0 : gb + 837976 | 0) | 0, gb + 727718 | 0, 569) | 0;
 HEAP32[i1 >> 2] = i5;
 i1 = i1 + 4 | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, (HEAP32[i3 >> 2] | 0) * 12 | 0) | 0;
 i3 = 1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5Unity17ConfigurableJoint14SetLinearLimitERK14SoftJointLimit(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(1.0);
 f4 = i7 ? Math_fround(1.0) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i7 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i6 ? Math_fround(0.0) : f3;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
  i7 = f2 < Math_fround(.00100000005);
  i6 = f2 > Math_fround(340282326000000008404918.0e15);
  f2 = i6 ? Math_fround(340282326000000008404918.0e15) : f2;
  f2 = i7 ? Math_fround(.00100000005) : f2;
 }
 HEAPF32[i5 + 128 >> 2] = f2;
 HEAPF32[i5 + 132 >> 2] = f4;
 HEAPF32[i5 + 136 >> 2] = f3;
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i5);
 return;
}

function __ZN24DownloadHandlerAudioClip13OnReceiveDataEPKvj(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i4 = i8 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i8 + 32 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i2 = i11 + i10 | 0;
 HEAP32[i5 >> 2] = i2;
 i6 = i8 + 36 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i7 & 2147483647;
 do if (i3 >>> 0 < i2 >>> 0) {
  i12 = i7 << 1;
  i2 = i12 >>> 0 > i2 >>> 0 ? i12 : i2;
  if (i3 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 1, i8 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i4 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i8 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = i1;
   break;
  }
 } while (0);
 _memcpy(i1 + i11 | 0, i9 | 0, i10 | 0) | 0;
 i12 = i8 + 16 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i10;
 return i10 | 0;
}

function __ZN21LightProbeProxyVolume21GetLocalToWorldMatrixER10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i1 + 36 | 0;
 switch (HEAP32[i4 >> 2] | 0) {
 case 2:
 case 0:
  break;
 default:
  {
   i5 = i2;
   i7 = gb + 1162292 | 0;
   i8 = i5 + 64 | 0;
   do {
    HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
    i5 = i5 + 4 | 0;
    i7 = i7 + 4 | 0;
   } while ((i5 | 0) < (i8 | 0));
   i8 = 0;
   STACKTOP = i6;
   return i8 | 0;
  }
 }
 __ZNK9Transform21GetLocalToWorldMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i5 = i2;
 i7 = i3;
 i8 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  i5 = i5 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 if ((HEAP32[i4 >> 2] | 0) != 2) {
  i8 = 1;
  STACKTOP = i6;
  return i8 | 0;
 }
 __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i3, i1 + 76 | 0) | 0;
 __ZN10Matrix4x4fmLERKS_(i2, i3) | 0;
 i8 = 1;
 STACKTOP = i6;
 return i8 | 0;
}

function __Z17tessMeshSplitEdgeP8TESSmeshP12TESShalfEdge(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge(i1, i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 12 >> 2] | 0;
 i6 = i4 + 8 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = i8 + 8 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 12 >> 2] = i8;
 HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i4;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i5 >> 2] = i3;
 i5 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 12 >> 2] = i1;
 HEAP32[(HEAP32[i7 + 4 >> 2] | 0) + 12 >> 2] = i4;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + 8 >> 2] = i3;
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 i2 = i1;
 return i2 | 0;
}

function __ZNK9Texture2D13IsNPOTAllowedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 switch (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i3 = 0;
   return i3 | 0;
  }
 default:
  {}
 }
 do if ((i1 | 0) == 2) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 492 >> 0] | 0) {
  i1 = HEAP32[i3 + 52 >> 2] | 0;
  if (!i1) {
   i1 = HEAP32[i3 + 92 >> 2] | 0;
   i1 = (i1 | 0) == -1 ? 5 : i1;
  } else i1 = HEAP32[i1 + 36 >> 2] | 0;
  if ((i1 + -10 | 0) >>> 0 < 3) {
   i3 = 0;
   return i3 | 0;
  }
  if (((i1 | 1) + -25 | 0) >>> 0 < 5) {
   i3 = 0;
   return i3 | 0;
  }
  i2 = i1 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) i1 = 0; else break;
   return i1 | 0;
  } else {
   if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) i1 = 0; else break;
   return i1 | 0;
  }
 } while (0);
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
 i3 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0;
 i3 = i2 ? (i3 | 0) == 2 : (i3 | 0) > 0;
 return i3 | 0;
}

function __ZNK21EnlightenSceneMapping18GetInputSystemHashEi(i8, i9, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i2 = HEAP32[i9 + 124 >> 2] | 0;
 i6 = HEAP32[i9 + 128 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i7 | 0)) {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  if (i2 + (i1 * 40 | 0) | 0) {
   i10 = (HEAP32[i9 + 20 >> 2] | 0) + ((HEAP32[i2 + (i1 * 40 | 0) + 20 >> 2] | 0) * 56 | 0) + 24 | 0;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   return;
  }
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 return;
}

function __ZNK15CapsuleCollider16GetLocalRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (HEAP32[i2 + 68 >> 2] | 0) {
 case 1:
  {
   HEAPF32[i1 + 12 >> 2] = Math_fround(.707106769);
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62548 >> 2]) * Math_fround(-.707106769));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62548 + 4 >> 2]) * Math_fround(-.707106769));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62548 + 8 >> 2]) * Math_fround(-.707106769));
   return;
  }
 case 2:
  {
   HEAPF32[i1 + 12 >> 2] = Math_fround(.707106769);
   HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62536 >> 2]) * Math_fround(.707106769));
   HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62536 + 4 >> 2]) * Math_fround(.707106769));
   HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[gb + 62536 + 8 >> 2]) * Math_fround(.707106769));
   return;
  }
 default:
  {
   HEAPF32[i1 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
   HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
   return;
  }
 }
}

function __ZN9Rigidbody16UpdateSortedBodyEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 36 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 if (!(HEAP8[i3 + 80 >> 0] | 0)) return;
 i2 = __Z21GetManagerFromContexti(9) | 0;
 i1 = __Z17GetTransformDepthR9Transform(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0) | 0;
 if ((i1 | 0) > 62) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737601 | 0, 0, gb + 662472 | 0, 1463, 1, 0, 0, 0);
  i1 = 63;
 }
 i2 = i2 + 204 + (i1 << 3) | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i3 + 36 | 0; else {
  i3 = i3 + 36 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i1 = i3;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN8b2Island6ReportEPK27b2ContactVelocityConstraint(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11;
 i9 = i1 + 4 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i10 = i1 + 36 | 0;
 if ((HEAP32[i10 >> 2] | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i6 = i1 + 12 | 0;
 i3 = i8 + 16 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i5 = HEAP32[i7 + (i1 * 156 | 0) + 148 >> 2] | 0;
  HEAP32[i3 >> 2] = i5;
  if ((i5 | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 16 >> 2];
    HEAP32[i8 + 8 + (i2 << 2) >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 20 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i5 | 0));
  }
  i5 = HEAP32[i9 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i4 | 0, i8 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i10 >> 2] | 0));
 STACKTOP = i11;
 return;
}

function __ZN5physx24PxVehicleSetBasisVectorsERKNS_6PxVec3ES2_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i6 = i2 + 4 | 0;
 f10 = Math_fround(HEAPF32[i6 >> 2]);
 i3 = i1 + 8 | 0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(f10 * f8);
 i5 = i2 + 8 | 0;
 f13 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i1 + 4 | 0;
 f12 = Math_fround(HEAPF32[i4 >> 2]);
 f9 = Math_fround(f9 - Math_fround(f13 * f12));
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f13 * f7);
 f11 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f13 - Math_fround(f8 * f11));
 f7 = Math_fround(Math_fround(f12 * f11) - Math_fround(f10 * f7));
 HEAPF32[gb + 158836 >> 2] = f9;
 HEAPF32[gb + 158836 + 4 >> 2] = f8;
 HEAPF32[gb + 158836 + 8 >> 2] = f7;
 HEAP32[gb + 158848 >> 2] = HEAP32[i2 >> 2];
 HEAP32[gb + 158848 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[gb + 158848 + 8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[gb + 158860 >> 2] = HEAP32[i1 >> 2];
 HEAP32[gb + 158860 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[gb + 158860 + 8 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + ((HEAP8[i1 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i1 + 12 >> 2] | 0) | 0 : i7) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i2 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags(i5, i4, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 24 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 892 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50AnimatorOverrideController_CUSTOM_GetOverrideClipsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 __ZNK26AnimatorOverrideController16GetOverrideClipsEv(i3, i2);
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(74) | 0;
 i2 = __Z19GetScriptingManagerv() | 0;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i3 + 12 >> 2] | 0) | 0;
 __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i(i1, i3, 0) | 0;
 if ((HEAP32[i3 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i4;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i4;
 return i1 | 0;
}

function __Z14DecompressBC45iiiPKjPjb(i6, i7, i8, i1, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 if ((i7 | 0) <= 0) return;
 i11 = i8 << 2;
 if ((i6 | 0) <= 0) return;
 i12 = i6 << 1;
 i5 = 0;
 while (1) {
  i2 = i9 + ((Math_imul(i11, i5) | 0) << 2) | 0;
  if (i10) {
   i3 = 0;
   i4 = i1;
   while (1) {
    __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i2, i4, i8, 0, 24);
    __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i2, i4 + 8 | 0, i8, 16777215, 16);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i6 | 0)) {
     i2 = i12;
     break;
    } else {
     i2 = i2 + 16 | 0;
     i4 = i4 + 16 | 0;
    }
   }
  } else {
   i3 = 0;
   i4 = i1;
   while (1) {
    __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji(i2, i4, i8, 0, 24);
    i3 = i3 + 1 | 0;
    if ((i3 | 0) == (i6 | 0)) {
     i2 = i6;
     break;
    } else {
     i2 = i2 + 16 | 0;
     i4 = i4 + 8 | 0;
    }
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i7 | 0)) break; else i1 = i1 + (i2 << 3) | 0;
 }
 return;
}

function _psnames_module_class_pic_init(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i5 >> 2] | 0, 36, i6) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = i3;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i4 = i5 + 204 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = _UNITY_FT_Create_Class_pscmaps_services(i5, i3) | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  _UNITY_FT_Init_Class_pscmaps_interface(i5, i3 + 4 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_pscmaps_services(i5, i1);
 HEAP32[i3 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i3);
 HEAP32[i4 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN6Shader27MarkShaderStateNotSupportedEPKS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1166332 + 12 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = HEAP32[gb + 1166332 + 16 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i4 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[gb + 1166332 + 16 >> 2] = i2;
   i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1166332 >> 2] | 0, i2 << 2, 4, gb + 1166332 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[gb + 1166332 >> 2] = i6;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, gb + 1166332 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[gb + 1166332 >> 2] | 0, HEAP32[gb + 1166332 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[gb + 1166332 + 16 >> 2] = i2;
   HEAP32[gb + 1166332 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[gb + 1166332 + 12 >> 2] = i4;
 HEAP32[(HEAP32[gb + 1166332 >> 2] | 0) + (i3 << 2) >> 2] = i1;
 return;
}

function __ZN5physx2Sc7BodySim12onDeactivateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP16[i4 + 144 >> 1] | 0;
 if (!(i1 & 8)) {
  i2 = i4 + 52 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 + 80 >> 2] = 0;
  HEAP32[i3 + 84 >> 2] = 0;
  HEAP32[i3 + 88 >> 2] = 0;
  HEAP32[i3 + 96 >> 2] = 0;
  HEAP32[i3 + 100 >> 2] = 0;
  HEAP32[i3 + 104 >> 2] = 0;
  i3 = i1 & 1;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i1 + 156 | 0;
  if (HEAP32[i2 >> 2] | 0) if (__ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i1, 0) | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    HEAP32[i1 + 48 >> 2] = 0;
    HEAP32[i1 + 52 >> 2] = 0;
    HEAP32[i1 + 56 >> 2] = 0;
    HEAP32[i1 + 32 >> 2] = 0;
    HEAP32[i1 + 36 >> 2] = 0;
    HEAP32[i1 + 40 >> 2] = 0;
    HEAP32[i1 + 16 >> 2] = 0;
    HEAP32[i1 + 20 >> 2] = 0;
    HEAP32[i1 + 24 >> 2] = 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    HEAP32[i1 + 8 >> 2] = 0;
   }
  }
  HEAP8[i4 + 146 >> 0] = i3 ^ 1;
 }
 if ((HEAP8[i4 + 50 >> 0] | 0) == 4) return;
 __ZN5physx2Sc5Scene11onBodySleepEPNS0_7BodySimE(__ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0, i4);
 return;
}

function __ZN2UI14CanvasRenderer18OnParentingChangedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = __Z34FindAncestorComponentExactTypeImplR10GameObjecti(HEAP32[i2 + 28 >> 2] | 0, 223) | 0;
 i3 = i2 + 188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i4, i2);
 HEAP32[i3 >> 2] = i1;
 if (!i1) {
  i1 = HEAP32[i2 + 204 >> 2] | 0;
  if (!i1) {
   i4 = 1;
   return i4 | 0;
  }
  i4 = i1 + 112 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 112 | 0;
 i3 = i4 + 112 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 4;
 i2 = HEAP32[i2 + 204 >> 2] | 0;
 if (!((i2 | 0) == 0 | (i4 | 0) == (i2 | 0))) {
  i4 = i2 + 112 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
 }
 while (1) {
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 10;
   break;
  }
  i4 = i1 + 224 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
  if (HEAP32[i1 + 208 >> 2] | 0) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZN25ThreadsafeLinearAllocator15SelectFreeBlockEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 L1 : do if ((i7 | 0) > 0) {
  i3 = i5 + 36 | 0;
  i4 = i5 + 32 | 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) != (HEAP32[i3 >> 2] | 0)) {
    i2 = HEAP32[i4 >> 2] | 0;
    i8 = i2 + (i1 * 12 | 0) + 8 | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2];
    if (!(HEAP32[i8 >> 2] | 0)) break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i7 | 0)) break L1;
  }
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = i1;
  i8 = 1;
  return i8 | 0;
 } while (0);
 if ((i7 | 0) >= (HEAP32[i5 + 52 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 __Z16GetMemoryManagerv() | 0;
 i1 = __ZN13MemoryManager16LowLevelAllocateEj(HEAP32[i5 + 48 >> 2] | 0) | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i8 + (i7 * 12 | 0) >> 2] = i1;
 HEAP32[i8 + (i7 * 12 | 0) + 8 >> 2] = 0;
 HEAP32[i8 + (i7 * 12 | 0) + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 HEAP32[i5 + 36 >> 2] = i7;
 i8 = 1;
 return i8 | 0;
}

function __ZN22DownloadHandlerTexture13OnReceiveDataEPKvj(i8, i9, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i4 = i8 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i8 + 32 | 0;
 i11 = HEAP32[i5 >> 2] | 0;
 i2 = i11 + i10 | 0;
 HEAP32[i5 >> 2] = i2;
 i6 = i8 + 36 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i7 & 2147483647;
 do if (i3 >>> 0 < i2 >>> 0) {
  i12 = i7 << 1;
  i2 = i12 >>> 0 > i2 >>> 0 ? i12 : i2;
  if (i3 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 1, i8 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[i4 >> 2] = i1;
   break;
  } else {
   i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i8 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i4 >> 2] = i1;
   break;
  }
 } while (0);
 _memcpy(i1 + i11 | 0, i9 | 0, i10 | 0) | 0;
 i12 = i8 + 16 | 0;
 HEAP32[i12 >> 2] = (HEAP32[i12 >> 2] | 0) + i10;
 return i10 | 0;
}

function __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEE8TransferI14SafeBinaryReadEEvRS5_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 469407 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 36980 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN14ParticleSystem4StopE26ParticleSystemStopBehavior(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, d6 = 0.0;
 i3 = i5 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP8[i4 + 12 >> 0] = 1;
 HEAP8[i4 + 13 >> 0] = 1;
 d6 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i3 >> 2] | 0) + 40 >> 3] = d6;
 i4 = i5 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i1 + 12 >> 2] | 0) return;
 __ZN23ParticleSystemParticles12array_resizeEj(i1, 0);
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 480 >> 2] = 0;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP8[i1 + 13 >> 0] | 0) HEAP32[i1 + 8 >> 2] = 0;
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i5, HEAP32[i4 >> 2] | 0, i1);
 return;
}

function __ZN13MonoBehaviour26CalculateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 i1 = (HEAP32[i2 + ((HEAP32[gb + 1104836 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) != 0 | (((HEAP32[i2 + ((HEAP32[gb + 1104796 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? (HEAP32[i2 + ((HEAP32[gb + 1104816 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 : 0) ? 0 : 2);
 i1 = (HEAP32[i2 + ((HEAP32[gb + 1104776 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? i1 : i1 | 512;
 i1 = (HEAP32[i2 + ((HEAP32[gb + 1105336 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? i1 : i1 | 16;
 i1 = (HEAP32[i2 + ((HEAP32[gb + 1105436 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? i1 : i1 | 64;
 i1 = (HEAP32[i2 + ((HEAP32[gb + 1105476 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? i1 : i1 | 128;
 i1 = ((HEAP32[i2 + ((HEAP32[gb + 1104856 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? (HEAP32[i2 + ((HEAP32[gb + 1104876 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 : 0) & (HEAP32[i2 + ((HEAP32[gb + 1104896 + 8 >> 2] | 0) + 27 << 3) >> 2] | 0) == 0 ? i1 : i1 | 256;
 return i1 | 0;
}

function __ZN11AudioSource21SetScheduledStartTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i5 = i1 + 456 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i4 + 16 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 + 498 >> 0] = 1;
 __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i3, 0, 0, 0, 0, 0) | 0;
 d2 = +(HEAP32[i3 >> 2] | 0) * d2;
 i4 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i3 = (__Z15GetAudioManagerv() | 0) + 200 | 0;
 i3 = _i64Add(~~d2 >>> 0 | 0, i4 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
 i4 = getTempRet0() | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 1, i4, i3) | 0;
 STACKTOP = i6;
 return;
}

function __ZL28VehicleWheelRaycastPreFilterN5physx12PxFilterDataES0_PKvjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEE(i6, i7, i1, i2, i3) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i6 + 8 | 0;
 i3 = HEAP32[i4 >> 2] & -65536;
 i5 = i7 + 8 | 0;
 if (!((i3 | 0) == 0 ? 1 : (i3 | 0) != (HEAP32[i5 >> 2] & -65536 | 0))) {
  i7 = 0;
  return i7 | 0;
 }
 if (!(HEAP32[i6 + 4 >> 2] | 0)) if (!(HEAP32[i6 + 12 >> 2] | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = __ZN8Collider14WordsToPointerEjj(HEAP32[i7 + 4 >> 2] | 0, HEAP32[i7 + 12 >> 2] | 0) | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = __Z17GetPhysicsManagerv() | 0;
 i3 = __ZN14PhysicsManager18GetIgnoreCollisionEii(i2, HEAP32[i6 >> 2] & 255, HEAP32[i7 >> 2] & 255) | 0;
 i2 = __ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_(i2, i6, i7) | 0;
 if (!(HEAP32[i4 >> 2] & 16)) i1 = (HEAP32[i5 >> 2] & 16 | 0) != 0; else i1 = 1;
 i7 = i3 | i2 | i1 ? 0 : 2;
 return i7 | 0;
}

function __Z38GetScriptingBuiltinResourceFromManagerR22BuiltinResourceManagerP12Il2CppObjectRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 454405 | 0, i5);
 i4 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i2) | 0;
 i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(__Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i2) | 0) | 0, i3) | 0) | 0;
 if (i1 | 0) if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(__Z26scripting_object_get_classP12Il2CppObject(i1) | 0, i4) | 0) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_png_write_gAMA_fixed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 HEAP8[i4 >> 0] = i2 >>> 24;
 HEAP8[i4 + 1 >> 0] = i2 >>> 16;
 HEAP8[i4 + 2 >> 0] = i2 >>> 8;
 HEAP8[i4 + 3 >> 0] = i2;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i1 + 656 | 0;
 HEAP32[i2 >> 2] = 34;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 4;
 i6 = i3 + 4 | 0;
 HEAP8[i6 >> 0] = 103;
 HEAP8[i3 + 5 >> 0] = 65;
 HEAP8[i3 + 6 >> 0] = 77;
 HEAP8[i3 + 7 >> 0] = 65;
 _UNITY_png_write_data(i1, i3, 8);
 HEAP32[i1 + 372 >> 2] = 1732332865;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i6, 4);
 HEAP32[i2 >> 2] = 66;
 _UNITY_png_write_data(i1, i4, 4);
 _UNITY_png_calculate_crc(i1, i4, 4);
 HEAP32[i2 >> 2] = 130;
 i4 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i3 >> 0] = i4 >>> 24;
 HEAP8[i3 + 1 >> 0] = i4 >>> 16;
 HEAP8[i3 + 2 >> 0] = i4 >>> 8;
 HEAP8[i3 + 3 >> 0] = i4;
 _UNITY_png_write_data(i1, i3, 4);
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Init_Class_sfnt_interface(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 186;
 HEAP32[i2 + 4 >> 2] = fb + 181;
 HEAP32[i2 + 8 >> 2] = fb + 182;
 HEAP32[i2 + 12 >> 2] = fb + 3849;
 HEAP32[i2 + 16 >> 2] = fb + 1016;
 HEAP32[i2 + 20 >> 2] = fb + 179;
 HEAP32[i2 + 24 >> 2] = fb + 1065;
 HEAP32[i2 + 28 >> 2] = fb + 447;
 HEAP32[i2 + 32 >> 2] = fb + 1066;
 HEAP32[i2 + 36 >> 2] = fb + 1067;
 HEAP32[i2 + 40 >> 2] = fb + 1068;
 HEAP32[i2 + 44 >> 2] = fb + 1069;
 HEAP32[i2 + 48 >> 2] = fb + 1070;
 HEAP32[i2 + 52 >> 2] = fb + 3850;
 HEAP32[i2 + 56 >> 2] = fb + 1071;
 HEAP32[i2 + 60 >> 2] = fb + 1072;
 HEAP32[i2 + 64 >> 2] = fb + 1073;
 HEAP32[i2 + 68 >> 2] = fb + 1074;
 HEAP32[i2 + 72 >> 2] = fb + 98;
 HEAP32[i2 + 76 >> 2] = fb + 448;
 HEAP32[i2 + 80 >> 2] = fb + 3851;
 HEAP32[i2 + 84 >> 2] = fb + 449;
 HEAP32[i2 + 88 >> 2] = fb + 1075;
 HEAP32[i2 + 92 >> 2] = fb + 450;
 HEAP32[i2 + 96 >> 2] = fb + 1076;
 HEAP32[i2 + 100 >> 2] = fb + 3852;
 HEAP32[i2 + 104 >> 2] = fb + 451;
 HEAP32[i2 + 108 >> 2] = fb + 452;
 HEAP32[i2 + 112 >> 2] = fb + 160;
 HEAP32[i2 + 116 >> 2] = fb + 453;
 return;
}

function __ZNSt3__217__assoc_sub_state4copyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i2 = i4 + 4 | 0;
 i3 = i4;
 i7 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = i7;
 i6 = i5 + 4 | 0;
 HEAP8[i6 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i7);
 __THREW__ = 0;
 invoke_vii(fb + 4502 | 0, i1 | 0, i5 | 0);
 i7 = __THREW__;
 __THREW__ = 0;
 do if (i7 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 } else {
  i1 = i1 + 8 | 0;
  HEAP32[i2 >> 2] = 0;
  i7 = (HEAP32[i1 >> 2] | 0) == 0;
  __ZNSt13exception_ptrD2Ev(i2);
  if (!i7) {
   __ZNSt13exception_ptrC2ERKS_(i3, i1);
   __THREW__ = 0;
   invoke_vi(fb + 3996 | 0, i3 | 0);
   __THREW__ = 0;
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt13exception_ptrD2Ev(i3);
   break;
  }
  if (HEAP8[i6 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i5 >> 2] | 0);
  STACKTOP = i4;
  return;
 } while (0);
 if (HEAP8[i6 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i5 >> 2] | 0);
 ___resumeException(i1 | 0);
}

function __ZNK14PhysicMaterial21CopyMaterialToDefaultEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i4 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0, i1 | 0, 1, 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (!i1) {
   STACKTOP = i3;
   return;
  }
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 40 >> 2]));
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 44 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 i4 = f5 < Math_fround(0.0);
 i6 = f5 > Math_fround(1.0);
 f5 = i6 ? Math_fround(1.0) : f5;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i4 ? Math_fround(0.0) : f5));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i2 + 32 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN7GUIClipC2ERK5RectTIfES3_RK8Vector2fS6_S6_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i2 = i4;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i5;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 i4 = i6;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i10 + 8 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i7 = (i7 & 2147483647 | 0) == 0 ? 1 : i7 << 1;
 if (!i7) i1 = 0; else i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i10, i7 << 1, gb + 838004 | 0, 543) | 0;
 i8 = i10 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i1 + (i5 << 1) | 0;
 if ((i5 | 0) > 0) {
  i2 = i1;
  i3 = HEAP32[i10 >> 2] | 0;
  while (1) {
   HEAP16[i2 >> 1] = HEAP16[i3 >> 1] | 0;
   i2 = i2 + 2 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break; else i3 = i3 + 2 | 0;
  }
 }
 HEAP16[i6 >> 1] = HEAP16[i9 >> 1] | 0;
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  i9 = i5;
  HEAP32[i10 >> 2] = i1;
  HEAP32[i4 >> 2] = i7;
  i10 = i9 + 1 | 0;
  HEAP32[i8 >> 2] = i10;
  i10 = i1 + (i9 << 1) | 0;
  return i10 | 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i10, HEAP32[i10 >> 2] | 0);
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i4 >> 2] = i7;
 i10 = i9 + 1 | 0;
 HEAP32[i8 >> 2] = i10;
 i10 = i1 + (i9 << 1) | 0;
 return i10 | 0;
}

function __ZN5physx2Sc5Scene12onBodyWakeUpEPNS0_7BodySimE(i7, i3) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if (!(HEAP32[(HEAP32[HEAP32[i7 + 1152 >> 2] >> 2] | 0) + 16 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i8 = i3 + 144 | 0;
 i1 = HEAP16[i8 >> 1] | 0;
 i2 = i1 & 65535;
 if (i2 & 64) {
  i1 = i2 & 65471;
  HEAP16[i8 >> 1] = i1;
  HEAP8[i7 + 1149 >> 0] = 0;
 }
 i5 = i1 & 65535;
 i1 = (i5 | 128) & 65535;
 HEAP16[i8 >> 1] = i1;
 if (i5 & 32 | 0) {
  STACKTOP = i9;
  return;
 }
 i5 = i7 + 1136 | 0;
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 HEAP32[i6 >> 2] = i2;
 i3 = i7 + 1140 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i7 + 1144 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] = i2;
  HEAP32[i3 >> 2] = i4 + 1;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i5, i6) | 0;
  i1 = HEAP16[i8 >> 1] | 0;
 }
 HEAP16[i8 >> 1] = i1 & 65535 | 32;
 STACKTOP = i9;
 return;
}

function __ZN5audio5mixer16FindChannelGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID(i1, i9, i2) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 if (!i8) {
  i10 = 0;
  return i10 | 0;
 }
 i7 = i1 + 8 | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i7 + (i2 << 4) >> 2] | 0) == (i4 | 0)) if ((HEAP32[i7 + (i2 << 4) + 4 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i7 + (i2 << 4) + 8 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i7 + (i2 << 4) + 12 >> 2] | 0) == (i3 | 0)) break;
  i1 = i2 + 1 | 0;
  if (i1 >>> 0 < i8 >>> 0) i2 = i1; else {
   i1 = 0;
   i10 = 13;
   break;
  }
 }
 if ((i10 | 0) == 13) return i1 | 0;
 if ((i2 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i1 = HEAP32[i9 + 64 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + i2 >> 0] | 0) {
  i10 = HEAP32[i9 + 68 >> 2] | 0;
  return i10 | 0;
 }
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 return i10 | 0;
}

function __ZN15UnityWebRequestC2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = i4 + 4 | 0;
 i5 = i1;
 i6 = i5 + 116 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP16[i1 + 116 >> 1] = 0;
 HEAP32[i4 >> 2] = gb + 188012 + 8;
 HEAP32[i4 + 4 >> 2] = 1;
 __ZN19TransportJavaScriptC2Ev(i4 + 8 | 0);
 i3 = i4 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i4 + 48;
 i1 = i4 + 108 | 0;
 i2 = i4 + 120 | 0;
 i5 = i4 + 56 | 0;
 i6 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 HEAP8[i2 >> 0] = 1;
 HEAP8[i4 + 121 >> 0] = 1;
 HEAP32[i1 >> 2] = 1;
 __ZN14RedirectHelper16SetRedirectLimitEj(i3, 32) | 0;
 HEAP32[i4 >> 2] = gb + 187980 + 8;
 i6 = __Znwj(12) | 0;
 HEAP32[i6 + 8 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = gb + 1468908;
 i5 = HEAP32[gb + 1468908 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[gb + 1468908 >> 2] = i6;
 HEAP32[gb + 1468908 + 8 >> 2] = (HEAP32[gb + 1468908 + 8 >> 2] | 0) + 1;
 return;
}

function __ZN14DetailDatabase24RelocateProtoUVFromRectsEP5RectTIfE(i1, i11) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 i10 = i1;
 if ((i2 | 0) == (i1 | 0)) return;
 i9 = (i2 - i1 | 0) / 136 | 0;
 i3 = 0;
 do {
  f4 = Math_fround(HEAPF32[i11 + (i3 << 4) >> 2]);
  f5 = Math_fround(HEAPF32[i11 + (i3 << 4) + 4 >> 2]);
  f6 = Math_fround(HEAPF32[i11 + (i3 << 4) + 8 >> 2]);
  f7 = Math_fround(HEAPF32[i11 + (i3 << 4) + 12 >> 2]);
  i1 = HEAP32[i10 + (i3 * 136 | 0) + 104 >> 2] | 0;
  i2 = HEAP32[i10 + (i3 * 136 | 0) + 100 >> 2] | 0;
  i8 = i2;
  if ((i1 | 0) != (i2 | 0)) {
   i2 = i1 - i2 >> 3;
   i1 = 0;
   do {
    i12 = i8 + (i1 << 3) | 0;
    HEAPF32[i12 >> 2] = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i12 >> 2])));
    i12 = i8 + (i1 << 3) + 4 | 0;
    HEAPF32[i12 >> 2] = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i12 >> 2])));
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i9 >>> 0);
 return;
}

function __ZN8VRDevice11PostPresentEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = __Z12GetGfxDevicev() | 0;
 i4 = i3 + 320 | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 860 >> 2] | 0, i5 | 0, 3, HEAP32[i4 >> 2] | 0);
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i1 = gb + 1469204 | 0;
 } else i1 = 0;
 i2 = HEAP32[i3 + 204 >> 2] | 0;
 if (i2 | 0) mftCall_vii(i2 | 0, 8, i5 | 0);
 if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 if ((HEAP32[i3 + 156 >> 2] | 0) == 2) {
  i5 = __Z12GetGfxDevicev() | 0;
  HEAP32[i3 + 324 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 536 >> 2] | 0, i5 | 0) | 0;
 }
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 STACKTOP = i6;
 return;
}

function __ZN7mecanim9animation26DestroyControllerWorkspaceEPNS0_19ControllerWorkspaceERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 if (!i3) return;
 i5 = i3 + 12 | 0;
 i2 = i3 + 4 | 0;
 if (HEAP32[i5 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN7mecanim12statemachine25DestroyStateMachineOutputEPNS0_18StateMachineOutputERNS_6memory9AllocatorE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i4);
   __ZN7mecanim12statemachine28DestroyStateMachineWorkspaceEPNS0_21StateMachineWorkspaceERNS_6memory9AllocatorE(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i4);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i3 + 16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i3 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 >> 2] = gb + 147848 + 8;
 i3 = i6 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i6 + 32 | 0;
  i5 = i6 + 76 | 0;
  do {
   i2 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
   if (!i1) i1 = 0; else {
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
    i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
    HEAP32[i3 >> 2] = i1;
    i2 = HEAP32[i4 >> 2] | 0;
    HEAP32[i2 >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
   }
   HEAP8[i5 >> 0] = (i1 | 0) != 0 & 1;
   i1 = HEAP32[i3 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i5 = HEAP32[i6 + 40 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[HEAP32[i6 + 28 >> 2] >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i6 + 16 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[HEAP32[i6 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext7D6Joint16setDrivePositionERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 i3 = HEAP32[i2 + 80 >> 2] | 0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f9 * f9);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f8 * f8));
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * f7));
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f10 * f10)))));
 f9 = Math_fround(f9 * f6);
 f8 = Math_fround(f8 * f6);
 f7 = Math_fround(f7 * f6);
 f6 = Math_fround(f10 * f6);
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAPF32[i3 + 272 >> 2] = f9;
 HEAPF32[i3 + 276 >> 2] = f8;
 HEAPF32[i3 + 280 >> 2] = f7;
 HEAPF32[i3 + 284 >> 2] = f6;
 HEAP32[i3 + 288 >> 2] = i5;
 HEAP32[i3 + 292 >> 2] = i4;
 HEAP32[i3 + 296 >> 2] = i1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc5Scene15kinematicsSetupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = HEAP32[i1 + 1204 >> 2] | 0;
 i7 = HEAP32[i8 + 12 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + (i7 << 2) | 0;
 if (!i7) return;
 i5 = i1 + 68 | 0;
 i6 = 0;
 i1 = i8 + 64 | 0;
 do {
  if (i1 >>> 0 < i9 >>> 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   i11 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i10 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 1023, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i10 = _i64Subtract(1, 0, i11 | 0, i10 | 0) | 0;
   i2 = _i64Add(i10 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(HEAP32[i8 + (i6 << 2) >> 2] | 0, Math_fround(HEAPF32[i5 >> 2]));
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 return;
}

function __ZN5physx16PxsBroadPhaseMBPD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = gb + 104052 + 8;
 i1 = i3 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, HEAP32[i3 + 88 >> 2] | 0);
 i2 = HEAP32[i3 + 116 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 108 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 104 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 96 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 HEAP32[i3 + 44 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 52 >> 2] = 0;
 __ZN5physx17MBPUpdateWorkTaskD2Ev(i3 + 4 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx16PxVehicleDrive4W5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj(i3, i2, i4, i5, i6, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i3, i2, i4, i5, 4, i1);
 i1 = i6 + 64 | 0;
 _memcpy(i3 + 224 | 0, i6 | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
 HEAP32[i3 + 288 >> 2] = HEAP32[i1 >> 2];
 i1 = i3 + 304 | 0;
 i2 = i6 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 _memcpy(i3 + 336 | 0, i6 + 112 | 0, 416) | 0;
 i3 = i3 + 752 | 0;
 i1 = i6 + 528 | 0;
 i2 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI14SafeBinaryReadEEvRS5_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i2, 1); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, gb + 365524 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN11AssetBundle9AssetInfo8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11AudioSource19SetScheduledEndTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i5 = i1 + 456 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i4 + 16 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 + 499 >> 0] = 1;
 __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i3, 0, 0, 0, 0, 0) | 0;
 d2 = +(HEAP32[i3 >> 2] | 0) * d2;
 i4 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i3 = (__Z15GetAudioManagerv() | 0) + 200 | 0;
 i3 = _i64Add(~~d2 >>> 0 | 0, i4 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
 i4 = getTempRet0() | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj(i1, 2, i4, i3) | 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__213__vector_baseIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i5 = i4 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   HEAP32[i5 >> 2] = i2 + -156;
   i3 = i2 + -40 | 0;
   if ((HEAP32[i2 + -24 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -36 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -60 | 0;
   if ((HEAP32[i2 + -44 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -56 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -80 | 0;
   if ((HEAP32[i2 + -64 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -76 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i3 = i2 + -100 | 0;
   if ((HEAP32[i2 + -84 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -96 | 0);
    HEAP32[i3 >> 2] = 0;
   }
   i2 = HEAP32[i5 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcj(i3, i10, i1) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 i4 = _strlen(i10) | 0;
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + i2 | 0;
  i8 = i10 + i4 | 0;
  i1 = i3 + i1 | 0;
  i7 = i9;
  L8 : do if ((i7 - i1 | 0) < (i4 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i4) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L8;
     }
     if ((HEAP8[i5 >> 0] | 0) == (HEAP8[i10 >> 0] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 1 | 0;
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i8 | 0)) break L8;
     i4 = i4 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i5 + 1 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 | 0;
 }
 return i1 | 0;
}

function __ZN5physx3Cct9SweepTest9onReleaseERKNS_6PxBaseE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP16[i4 + 4 >> 1] | 0;
 if ((i1 + -5 & 65535) < 2) {
  i1 = i3 + 160 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) return;
  HEAP32[i3 + 156 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 if (i1 << 16 >> 16 != 7) return;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i5 = HEAP32[i3 + 36 >> 2] | 0;
 i2 = i1 + (i5 << 2) | 0;
 L11 : do if (i5 | 0) {
  while (1) {
   if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + (HEAP32[gb + 83868 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) | 0;
   if ((i1 | 0) == (i2 | 0)) break L11;
  }
  HEAPF64[i3 + 48 >> 3] = 1797693134862315708145274.0e284;
  HEAPF64[i3 + 56 >> 3] = 1797693134862315708145274.0e284;
  HEAPF64[i3 + 64 >> 3] = 1797693134862315708145274.0e284;
  HEAPF64[i3 + 72 >> 3] = -1797693134862315708145274.0e284;
  HEAPF64[i3 + 80 >> 3] = -1797693134862315708145274.0e284;
  HEAPF64[i3 + 88 >> 3] = -1797693134862315708145274.0e284;
 } while (0);
 i1 = i3 + 156 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene14stepSetupSolveEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = HEAP32[i1 + 1204 >> 2] | 0;
 i7 = HEAP32[i8 + 12 >> 2] | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = i8 + (i7 << 2) | 0;
 if (!i7) return;
 i5 = i1 + 68 | 0;
 i6 = 0;
 i1 = i8 + 64 | 0;
 do {
  if (i1 >>> 0 < i9 >>> 0) {
   i4 = HEAP32[i1 >> 2] | 0;
   i3 = i4;
   i11 = _bitshift64Lshr(i3 | 0, 0, 6) | 0;
   i10 = getTempRet0() | 0;
   i3 = _i64Add(i3 | 0, 0, 1023, 0) | 0;
   i3 = _bitshift64Lshr(i3 | 0, getTempRet0() | 0, 6) | 0;
   i2 = getTempRet0() | 0;
   i10 = _i64Subtract(1, 0, i11 | 0, i10 | 0) | 0;
   i2 = _i64Add(i10 | 0, getTempRet0() | 0, i3 | 0, i2 | 0) | 0;
   i3 = getTempRet0() | 0;
   while (1) {
    i2 = _i64Add(i2 | 0, i3 | 0, -1, -1) | 0;
    i3 = getTempRet0() | 0;
    if ((i2 | 0) == 0 & (i3 | 0) == 0) break; else i4 = i4 + 64 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf(HEAP32[i8 + (i6 << 2) >> 2] | 0, Math_fround(HEAPF32[i5 >> 2]));
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) return;
 i5 = HEAP32[i6 + 96 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
 if ((HEAP8[i6 + 105 >> 0] | 0) == 0 | (i5 + -400 | 0) >>> 0 < 100) {
  HEAP32[i6 + 84 >> 2] = 0;
  HEAP32[i6 + 76 >> 2] = 0;
  i5 = HEAP32[i6 + 32 >> 2] | 0;
  mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, fb + 3957 | 0, i6 | 0) | 0;
  return;
 }
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 100 | 0;
 i5 = i6 + 76 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
 i4 = i1 + 104 | 0;
 if (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) >> 2 >>> 0) HEAP32[i5 >> 2] = i3;
 HEAP32[i6 + 80 >> 2] = _time(0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i6 + 84 >> 2] = 60;
  return;
 } else {
  HEAP32[i6 + 84 >> 2] = HEAP32[i1 + (HEAP32[i5 >> 2] << 2) >> 2];
  return;
 }
}

function __Z23CreateAsFileIfNotExistsPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 1060 | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i1, _strlen(i1) | 0);
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if (__ZNK15FileSystemEntry6ExistsEv(i3) | 0) {
  i1 = (__ZNK15FileSystemEntry5IsDirEv(i3) | 0) ^ 1;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i1 | 0;
 } else {
  i1 = __ZN15FileSystemEntry12CreateAsFileEv(i3) | 0;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function __ZNK23ArchiveStorageConverter25ArchiveRequiresConversionE15CompressionType(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = HEAP32[i2 + 108 >> 2] | 0;
 i2 = HEAP32[i2 + 104 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = (i1 - i2 | 0) / 12 | 0;
 if ((i4 | 0) == 2) {
  i1 = 0;
  while (1) {
   i2 = HEAP16[i5 + (i1 * 12 | 0) + 8 >> 1] | 0;
   if (!((i2 & 64) == 0 | (i2 & 63) == 0)) {
    i1 = 1;
    i2 = 9;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i2 & 62 | 1 | 0) != 3) {
    i1 = 1;
    i2 = 9;
    break;
   }
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = 0;
    i2 = 9;
    break;
   }
  }
  if ((i2 | 0) == 9) return i1 | 0;
 } else {
  i1 = 0;
  while (1) {
   i2 = HEAP16[i5 + (i1 * 12 | 0) + 8 >> 1] | 0;
   if (!((i2 & 64) == 0 | (i2 & 63) == 0)) {
    i1 = 1;
    i2 = 9;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i2 & 63 | 0) != (i4 | 0)) {
    i1 = 1;
    i2 = 9;
    break;
   }
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = 0;
    i2 = 9;
    break;
   }
  }
  if ((i2 | 0) == 9) return i1 | 0;
 }
 return 0;
}

function __ZNK14SoundHandleAPI11GetLengthMSEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 if (!i1) {
  f6 = Math_fround(0.0);
  STACKTOP = i5;
  return Math_fround(f6);
 }
 if ((HEAP32[i1 + 44 >> 2] | 0) != 3) {
  f6 = Math_fround(0.0);
  STACKTOP = i5;
  return Math_fround(f6);
 }
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN4FMOD5Sound9getLengthEPjj(HEAP32[i1 + 40 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 579;
  HEAP32[i4 + 8 >> 2] = gb + 872813;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 f6 = Math_fround((HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i5;
 return Math_fround(f6);
}

function __ZN9Transform19SetLocalEulerAnglesERK8Vector3fN4math13RotationOrderE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 24 | 0;
 i7 = i4;
 i5 = i4 + 8 | 0;
 i10 = i1 + 32 | 0;
 i8 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i7;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i5 + 8 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 if (!(__Z13SetLocalEuler15TransformAccessRKN4math7_float3ENS0_13RotationOrderE(i6, i5, i3) | 0)) {
  STACKTOP = i4;
  return;
 }
 i10 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i10 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 2);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i10 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx7NpScene18releaseVolumeCacheEPNS_13NpVolumeCacheE(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 3608 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i2 = i8;
  i2 = i2 + ~(i2 << 15) | 0;
  i2 = (i2 >>> 10 ^ i2) * 9 | 0;
  i2 = i2 >>> 6 ^ i2;
  i2 = i2 + ~(i2 << 11) | 0;
  i2 = (HEAP32[i7 + 3600 >> 2] | 0) + ((i1 + -1 & (i2 >>> 16 ^ i2)) << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) != -1) {
   i5 = HEAP32[i7 + 3592 >> 2] | 0;
   i6 = HEAP32[i7 + 3596 >> 2] | 0;
   i4 = i2;
   while (1) {
    i2 = i4;
    i4 = i6 + (i1 << 2) | 0;
    i3 = i1;
    i1 = HEAP32[i4 >> 2] | 0;
    if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) == (i8 | 0)) break;
    if ((i1 | 0) == -1) break L1;
   }
   HEAP32[i2 >> 2] = i1;
   i6 = i7 + 3624 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
   i6 = i7 + 3620 | 0;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
   i7 = i7 + 3616 | 0;
   HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i7 >> 2] = i3;
  }
 } while (0);
 if (!i8) return;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 60 >> 2] | 0, i8 | 0);
 return;
}

function __ZN5physx2Sc5Scene23postIslandGenSecondPassEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i2 + 1204 >> 2] | 0) | 0;
 i4 = HEAP32[i7 + 496 >> 2] | 0;
 i5 = (HEAP32[i7 + 500 >> 2] | 0) - i4 | 0;
 i3 = HEAP32[i7 + 488 >> 2] | 0;
 if (i4 | 0) {
  i6 = 0;
  do {
   i1 = HEAP32[i3 + (i5 + i6 << 2) >> 2] | 0;
   i2 = i1;
   if (!(i2 & 15)) if (!i1) {
    i1 = 0;
    i8 = 6;
   } else __ZN5physx2Sc5Actor9setActiveEbj(i1, 0, 4); else {
    i1 = i2 & -2;
    i8 = 6;
   }
   if ((i8 | 0) == 6) {
    i8 = 0;
    __ZN5physx2Sc15ArticulationSim9setActiveEbj(i1, 0, 4);
   }
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i4 | 0));
 }
 __ZN5physx16PxsIslandManager33removeSleepingPairContactManagersEv(i7);
 i3 = HEAP32[i7 + 504 >> 2] | 0;
 i1 = HEAP32[i7 + 508 >> 2] | 0;
 if (!i1) return; else i2 = 0;
 do {
  __ZN5physx2Sc19ShapeInstancePairLL23postIslandGenSecondPassEv(HEAP32[(HEAP32[i3 + (i2 << 3) >> 2] | 0) + 12 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN5physx12NpConstraint8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 i9 = i3 + 16 | 0;
 i7 = HEAP16[i1 >> 1] | 0;
 i8 = i3 + 20 | 0;
 i6 = HEAP32[i8 >> 2] | 0;
 switch (i6 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP16[i2 >> 1] = i7;
  __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i3 + 28 | 0, i2);
  STACKTOP = i10;
  return;
 }
 i2 = i3 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 + 16 >> 1] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 STACKTOP = i10;
 return;
}

function __ZN5physx10BPWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = i1 + 20 | 0;
 __ZN5physx14PxsAABBManager9prepareBPEv(HEAP32[i4 >> 2] | 0);
 i4 = HEAP32[i4 >> 2] | 0;
 i12 = HEAP32[i4 + 112 >> 2] | 0;
 i11 = HEAP32[i4 + 80 >> 2] | 0;
 i10 = HEAP32[i4 + 84 >> 2] | 0;
 i9 = HEAP32[i4 + 136 >> 2] | 0;
 i8 = HEAP32[i4 + 140 >> 2] | 0;
 i7 = HEAP32[i4 + 12 >> 2] | 0;
 i6 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = HEAP32[i4 + 36 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + 108 >> 2];
 HEAP32[i3 + 4 >> 2] = i12;
 HEAP32[i3 + 8 >> 2] = i11;
 HEAP32[i3 + 12 >> 2] = i10;
 HEAP32[i3 + 16 >> 2] = i9;
 HEAP32[i3 + 20 >> 2] = i8;
 HEAP32[i3 + 24 >> 2] = i7;
 HEAP32[i3 + 28 >> 2] = i6;
 HEAP32[i3 + 32 >> 2] = i5;
 i4 = HEAP32[i4 + 49828 >> 2] | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, HEAP32[i1 + 24 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, i3 | 0, HEAP32[i1 + 12 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer16ArchiveGroupDataERK8UnityStrS4_(i5, i2, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i9 + 8 | 0;
 i6 = i5 + 36 | 0;
 i4 = i6 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i5 + 40 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 __ZN12FileAccessorC2Ev(i8);
 if (__ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i2, i3, i8) | 0) {
  i1 = i7;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i1 = HEAP8[i4 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = HEAP32[i5 + 40 >> 2] | 0;
   i3 = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } else {
   i2 = i1 & 255;
   i3 = 0;
   i1 = i6;
  }
  i1 = __ZN12FileAccessor5WriteEyPKvPy(i8, i2, i3, i1, i7) | 0;
  __ZN12FileAccessor5CloseEv(i8) | 0;
 } else i1 = 0;
 __ZN12FileAccessorD2Ev(i8);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z20GetTextureFormatInfo13TextureFormat(i1) {
 i1 = i1 | 0;
 do switch (i1 | 0) {
 case 1:
  {
   i1 = gb + 1158400 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 1158468 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 1158604 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 1158536 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 1158672 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 1158740 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 1158808 | 0;
   break;
  }
 case 1e3:
  {
   i1 = gb + 1158876 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 1158944 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 1159012 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 1159080 | 0;
   break;
  }
 case 16:
  {
   i1 = gb + 1159148 | 0;
   break;
  }
 case 17:
  {
   i1 = gb + 1159216 | 0;
   break;
  }
 case 18:
  {
   i1 = gb + 1159284 | 0;
   break;
  }
 case 19:
  {
   i1 = gb + 1159352 | 0;
   break;
  }
 case 23:
  {
   i1 = gb + 1159420 | 0;
   break;
  }
 case 20:
  {
   i1 = gb + 1159488 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 1159556 | 0;
   break;
  }
 default:
  i1 = gb + 1158808 | 0;
 } while (0);
 return i1 | 0;
}

function _UNITY_FT_Get_First_Char(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i3 = i1 + 92 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!i2) {
   i2 = 0;
   i1 = 0;
  } else {
   i4 = i1 + 16 | 0;
   if (!(HEAP32[i4 >> 2] | 0)) {
    i2 = 0;
    i1 = 0;
   } else {
    i1 = mftCall_iii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 0) | 0;
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = i1 >>> 0 >= i2 >>> 0 ? 0 : i1;
    if (!i1) {
     i3 = HEAP32[i3 >> 2] | 0;
     if ((i3 | 0) == 0 | (i2 | 0) == 0) {
      i2 = 0;
      i1 = 0;
     } else {
      HEAP32[i5 >> 2] = 0;
      i2 = i3 + 12 | 0;
      do i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i5 | 0) | 0; while (i1 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0);
      i2 = (i1 | 0) == 0 ? 0 : HEAP32[i5 >> 2] | 0;
     }
    } else i2 = 0;
   }
  }
 }
 if (!i6) {
  STACKTOP = i7;
  return i2 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 STACKTOP = i7;
 return i2 | 0;
}

function __ZNSt3__26vectorI15RecordedTriggerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 178956970 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 357913941;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 12;
 HEAP32[i8 >> 2] = i6 + (i4 * 12 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx7NpShape23getTriangleMeshGeometryERNS_22PxTriangleMeshGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 5) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i2 + 36 >> 2] & 1)) i2 = 5; else {
  i2 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i3 + 32 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
 i3 = i3 + 33 | 0;
 i2 = i1 + 33 | 0;
 HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
 HEAP8[i3 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 HEAP8[i3 + 5 >> 0] = HEAP8[i2 + 5 >> 0] | 0;
 HEAP8[i3 + 6 >> 0] = HEAP8[i2 + 6 >> 0] | 0;
 i3 = 1;
 return i3 | 0;
}

function __ZNK5physx2Sn8MetaData12getMetaClassENS_14PxConcreteType4EnumE(i6, i3) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i6 + 68 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 i2 = HEAP32[i6 + 64 >> 2] | 0;
 i4 = 0;
 while (1) {
  if ((HEAP32[i2 + (i4 << 3) >> 2] | 0) == (i3 | 0)) {
   i5 = i4;
   break;
  }
  i4 = i4 + 1 | 0;
  if (i4 >>> 0 >= i1 >>> 0) {
   i7 = 0;
   i8 = 12;
   break;
  }
 }
 if ((i8 | 0) == 12) return i7 | 0;
 i1 = HEAP32[i2 + (i5 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) == (-1 | 0)) i4 = 0; else i4 = (HEAP32[i6 + 16 >> 2] | 0) + i1 | 0;
 i5 = HEAP32[i6 + 24 >> 2] | 0;
 if (!i5) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 i3 = 0;
 while (1) {
  i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
  i3 = i3 + 1 | 0;
  if (!(_strcmp(HEAP32[i2 + 12 >> 2] | 0, i4) | 0)) {
   i9 = i2;
   break;
  }
  if (i3 >>> 0 >= i5 >>> 0) {
   i7 = 0;
   i8 = 12;
   break;
  }
 }
 if ((i8 | 0) == 12) return i7 | 0;
 while (1) {
  i1 = HEAP32[i9 + 8 >> 2] | 0;
  if (!i1) {
   i7 = i9;
   break;
  } else i9 = i1;
 }
 return i7 | 0;
}

function __ZNK19RenderEventsContext25PostExecuteCommandBuffersEiR17ShaderPassContextP13RenderTextureP19ProfilerInformationi(i1, i5, i7, i8, i2, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = i4 + (i5 * 20 | 0) + 12 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i1 = i2 + (i5 << 3) | 0;
 if ((HEAP16[i2 + (i5 << 3) + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(i1, i3);
  i3 = i1;
 } else i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 648 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = HEAP32[i4 + (i5 * 20 | 0) >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN22RenderingCommandBuffer24PostExecuteCommandBufferER17ShaderPassContextP13RenderTexture(HEAP32[i1 >> 2] | 0, i7, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 652 >> 2] | 0, i8 | 0);
 if (!i3) return;
 __Z12profiler_endP19ProfilerInformation(i3);
 return;
}

function __ZN5Unity10HingeJoint9SetSpringERK11JointSpring(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = f6 < Math_fround(0.0);
 i7 = f6 > Math_fround(340282326000000008404918.0e15);
 f6 = i7 ? Math_fround(340282326000000008404918.0e15) : f6;
 f6 = i2 ? Math_fround(0.0) : f6;
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i2 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i2 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f4 < Math_fround(-180.0);
 i2 = f4 > Math_fround(180.0);
 f4 = i2 ? Math_fround(180.0) : f4;
 f4 = i1 ? Math_fround(-180.0) : f4;
 HEAPF32[i3 + 116 >> 2] = f6;
 HEAPF32[i3 + 120 >> 2] = f5;
 HEAPF32[i3 + 124 >> 2] = f4;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 if ((HEAP16[(HEAP32[i1 >> 2] | 0) + 4 >> 1] | 0) != 261) return;
 __ZN5Unity10HingeJoint16WriteJointSpringEv(i3);
 return;
}

function __Z28CreateAsDirectoryIfNotExistsPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 1060 | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i1, _strlen(i1) | 0);
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 if (__ZNK15FileSystemEntry6ExistsEv(i3) | 0) {
  i1 = __ZNK15FileSystemEntry5IsDirEv(i3) | 0;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i1 | 0;
 } else {
  i1 = __ZN15FileSystemEntry11CreateAsDirEv(i3) | 0;
  __ZN13FileEntryDataD2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofERKS5_j(i2, i3, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i5 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
 i5 = i4 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
 L5 : do if (i1 >>> 0 > i7 >>> 0) {
  i4 = i2 + (i1 << 2) | 0;
  i3 = i2 + (i7 << 2) | 0;
  while (1) {
   if ((i3 | 0) == (i4 | 0)) {
    i8 = -1;
    break L5;
   }
   __THREW__ = 0;
   i1 = invoke_iiii(fb + 514 | 0, i6 | 0, i5 | 0, i3 | 0) | 0;
   i7 = __THREW__;
   __THREW__ = 0;
   if (i7 & 1) {
    i1 = 9;
    break;
   }
   if (!i1) {
    i1 = 11;
    break;
   }
   i3 = i3 + 4 | 0;
  }
  if ((i1 | 0) == 9) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  } else if ((i1 | 0) == 11) {
   i8 = i3 - i2 >> 2;
   break;
  }
 } else i8 = -1; while (0);
 return i8 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcjj(i2, i8, i3, i9) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i6 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
 i6 = (i1 - i6 | 0) >>> 0 > i9 >>> 0 ? i6 + i9 | 0 : i1;
 i7 = i2 + i6 | 0;
 L5 : do if ((i9 | 0) == 0 | (i6 | 0) < (i9 | 0)) i1 = i7; else {
  i5 = i2 + (i9 + -1) | 0;
  i6 = i8 + i9 + -1 | 0;
  i1 = i7;
  L7 : while (1) {
   while (1) {
    if ((i5 | 0) == (i1 | 0)) {
     i1 = i7;
     break L5;
    }
    i4 = i1 + -1 | 0;
    if ((HEAP8[i4 >> 0] | 0) == (HEAP8[i6 >> 0] | 0)) {
     i3 = i6;
     i1 = i4;
     break;
    } else i1 = i4;
   }
   while (1) {
    if ((i3 | 0) == (i8 | 0)) break L5;
    i1 = i1 + -1 | 0;
    i3 = i3 + -1 | 0;
    if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i3 >> 0] | 0)) {
     i1 = i4;
     continue L7;
    }
   }
  }
 } while (0);
 return ((i9 | 0) != 0 & (i1 | 0) == (i7 | 0) ? -1 : i1 - i2 | 0) | 0;
}

function __ZNK5physx3Cct15ObstacleContext19getObstacleByHandleEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = i4 & 65535;
 i2 = HEAP32[i5 + 36 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i6 = HEAP16[(HEAP32[i5 + 40 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 i3 = i6 & 65535;
 if (!(i6 << 16 >> 16 != -1 & i3 >>> 0 < i2 >>> 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if ((HEAPU16[(HEAP32[i5 + 48 >> 2] | 0) + (i1 << 1) >> 1] | 0 | 0) != (i4 >>> 16 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[(HEAP32[i5 + 28 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i1;
 i1 = i6 >>> 16;
 switch (i6 & 65535 | 0) {
 case 4:
  {
   if (i1 >>> 0 >= (HEAP32[i5 + 8 >> 2] | 0) >>> 0) {
    i6 = 0;
    return i6 | 0;
   }
   i6 = (HEAP32[i5 + 4 >> 2] | 0) + (i1 * 72 | 0) + 8 | 0;
   return i6 | 0;
  }
 case 3:
  {
   if (i1 >>> 0 >= (HEAP32[i5 + 20 >> 2] | 0) >>> 0) {
    i6 = 0;
    return i6 | 0;
   }
   i6 = (HEAP32[i5 + 16 >> 2] | 0) + (i1 << 6) + 8 | 0;
   return i6 | 0;
  }
 default:
  {
   i6 = 0;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN5physx30PxcGetMaterialShapeHeightFieldEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i1, i2, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 if ((HEAPU16[i2 + 68 >> 1] | 0) < 2) {
  i4 = HEAP32[i6 + 4480 >> 2] | 0;
  if (!i4) return 1;
  i3 = HEAP16[i1 + 34 >> 1] | 0;
  i1 = HEAP16[i2 + 34 >> 1] | 0;
  i2 = 0;
  do {
   HEAP16[i7 + (i2 << 2) >> 1] = i3;
   HEAP16[i7 + (i2 << 2) + 2 >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i4 >>> 0);
  return 1;
 } else {
  i4 = HEAP32[i2 + 64 >> 2] | 0;
  i5 = HEAP32[i6 + 4480 >> 2] | 0;
  if (!i5) return 1;
  i3 = HEAP32[(HEAP32[i2 + 60 >> 2] | 0) + 20 >> 2] | 0;
  i1 = HEAP16[i1 + 34 >> 1] | 0;
  i2 = 0;
  do {
   HEAP16[i7 + (i2 << 2) >> 1] = i1;
   i9 = HEAP32[i6 + 384 + (i2 << 6) + 52 >> 2] | 0;
   i8 = i9 >>> 1;
   HEAP16[i7 + (i2 << 2) + 2 >> 1] = HEAP16[i4 + (((HEAPU8[((i9 & 1 | 0) == 0 ? i3 + (i8 << 2) + 2 | 0 : i3 + (i8 << 2) + 3 | 0) >> 0] | 0) & 127) << 1) >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i5 >>> 0);
  return 1;
 }
 return 0;
}

function __ZN5physx19NpArticulationJoint13setTwistLimitEff(i1, f4, f7) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 8 | 0;
 i6 = i1 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  __ZN5physx2Sc21ArticulationJointCore13setTwistLimitEff(i1 + 20 | 0, f4, f7);
  return;
 }
 i2 = i1 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAPF32[i1 + 136 >> 2] = f4;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
   i2 = i5;
  } else i2 = i5;
 } else {
  HEAPF32[i1 + 136 >> 2] = f4;
  i2 = i5;
 }
 HEAPF32[i1 + 140 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 65536;
 return;
}

function __ZN5physx19NpArticulationJoint13setSwingLimitEff(i1, f4, f7) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 8 | 0;
 i6 = i1 + 12 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  break;
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  __ZN5physx2Sc21ArticulationJointCore13setSwingLimitEff(i1 + 20 | 0, f4, f7);
  return;
 }
 i2 = i1 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
  HEAPF32[i1 + 128 >> 2] = f4;
  if (!i1) {
   i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, (HEAP32[i6 >> 2] | 0) >>> 24 & 15) | 0;
   HEAP32[i2 >> 2] = i1;
   i2 = i5;
  } else i2 = i5;
 } else {
  HEAPF32[i1 + 128 >> 2] = f4;
  i2 = i5;
 }
 HEAPF32[i1 + 132 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i2 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 32768;
 return;
}

function __ZN15ResourceManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(64, i1, 16, gb + 1048932 | 0, 0, gb + 454334 | 0, 196) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 64484 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i2;
 HEAP8[i4 + 60 >> 0] = 1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z48DownloadHandler_CUSTOM_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringj(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 12 | 0;
 i6 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 i3 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63808 | 0, 16, gb + 1027567 | 0, 93) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i7);
 __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEj(i3, i6, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 HEAP32[i4 + 8 >> 2] = i3;
 i1 = i3 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i4) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZNK5Umbra4Tome15checkCorruptionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) {
  i4 = 1;
  return i4 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = i4 & 65535;
 if ((i4 & -65536 | 0) != -704643072) {
  i4 = (i1 | 0) == 214 ? 5 : 2;
  return i4 | 0;
 }
 if ((i1 | 0) != 18) {
  i4 = i1 >>> 0 > 18 ? 4 : 3;
  return i4 | 0;
 }
 if (i2 & 15 | 0) {
  i4 = 6;
  return i4 | 0;
 }
 i1 = (HEAP32[i2 + 8 >> 2] | 0) + -8 | 0;
 i4 = i2 + 4 | 0;
 if (!i1) {
  i3 = 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i4 = (i3 | 0) == (i4 | 0);
  i4 = i4 ? 0 : 2;
  return i4 | 0;
 } else {
  i3 = -1;
  i2 = i4;
 }
 do {
  i2 = i2 + 4 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i6 = HEAP32[gb + 79084 + (((i5 ^ i3) & 255) << 2) >> 2] ^ i3 >>> 8;
  i6 = i6 >>> 8 ^ HEAP32[gb + 79084 + (((i6 ^ i5 >>> 8) & 255) << 2) >> 2];
  i6 = i6 >>> 8 ^ HEAP32[gb + 79084 + (((i6 ^ i5 >>> 16) & 255) << 2) >> 2];
  i3 = i6 >>> 8 ^ HEAP32[gb + 79084 + ((i6 & 255 ^ i5 >>> 24) << 2) >> 2];
  i1 = i1 + -4 | 0;
 } while ((i1 | 0) != 0);
 i5 = ~i3;
 i6 = HEAP32[i4 >> 2] | 0;
 i6 = (i5 | 0) == (i6 | 0);
 i6 = i6 ? 0 : 2;
 return i6 | 0;
}

function __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi(i1, i5, i7, i8, i2, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = i4 + (i5 * 20 | 0) + 12 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i1 = i2 + (i5 << 3) | 0;
 if ((HEAP16[i2 + (i5 << 3) + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(i1, i3);
  i3 = i1;
 } else i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 648 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = HEAP32[i4 + (i5 * 20 | 0) >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN22RenderingCommandBuffer20ExecuteCommandBufferER17ShaderPassContextRK15RenderNodeQueue(HEAP32[i1 >> 2] | 0, i7, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i8 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 652 >> 2] | 0, i8 | 0);
 if (!i3) return;
 __Z12profiler_endP19ProfilerInformation(i3);
 return;
}

function __ZN5Umbra16testBitRangeFullEPKjii(i1, i3, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = i3 >> 5;
 i1 = i1 + (i6 << 2) | 0;
 i2 = i7 - i3 | 0;
 i4 = i3 & 31;
 i5 = -1 << i4;
 if ((i4 | 0) == 0 | (i6 | 0) == (i7 >> 5 | 0)) {
  i4 = i1;
  i3 = 0;
  i1 = 0;
 } else {
  i6 = HEAP32[i1 >> 2] & i5;
  i4 = i1 + 4 | 0;
  i2 = i2 + (i3 | -32) | 0;
  i3 = i6;
  i1 = i6 ^ i5;
  i5 = -1;
 }
 L4 : do if ((i2 | 0) > 31) while (1) {
  if (!((i1 | 0) == 0 | (i3 | 0) == 0)) {
   i2 = i3;
   break L4;
  }
  i6 = i4 + 4 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i3 = i4 | i3;
  i1 = i1 | ~i4;
  i2 = i2 + -32 | 0;
  if ((i2 | 0) > 31) i4 = i6; else {
   i4 = i6;
   i8 = 6;
   break;
  }
 } else i8 = 6; while (0);
 if ((i8 | 0) == 6) if (!i2) {
  i7 = i3;
  i8 = i1;
  i7 = (i7 | 0) == 0;
  i8 = (i8 | 0) == 0;
  i8 = i8 ? 2 : 1;
  i8 = i7 ? 0 : i8;
  return i8 | 0;
 } else i2 = i3;
 i8 = i5 & (1 << (i7 & 31)) + -1;
 i6 = HEAP32[i4 >> 2] & i8;
 i7 = i6 | i2;
 i8 = i6 ^ i8 | i1;
 i7 = (i7 | 0) == 0;
 i8 = (i8 | 0) == 0;
 i8 = i8 ? 2 : 1;
 i8 = i7 ? 0 : i8;
 return i8 | 0;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 72 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 44 | 0, gb + 1034411 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 56 | 0, gb + 842535 | 0, 0);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __Z20b2NearestPointOnLineRK6b2Vec2S1_S1_(i5, i6, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f8 = f0, f9 = f0, f10 = f0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f9 = Math_fround(f9 - f8);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f3 = Math_fround(f3 - f2);
 f4 = Math_fround(Math_fround(f9 * f9) + Math_fround(f3 * f3));
 if (f4 < Math_fround(1.42108547e-14)) {
  i1 = i7;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i7 = i5;
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  return;
 } else {
  f10 = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f8);
  f10 = Math_fround(Math_fround(Math_fround(f9 * f10) + Math_fround(f3 * Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) - f2))) / f4);
  i7 = f10 < Math_fround(1.0);
  f10 = i7 ? f10 : Math_fround(1.0);
  i7 = f10 < Math_fround(0.0);
  f10 = i7 ? Math_fround(0.0) : f10;
  f4 = Math_fround(f2 + Math_fround(f3 * f10));
  HEAPF32[i5 >> 2] = Math_fround(f8 + Math_fround(f9 * f10));
  HEAPF32[i5 + 4 >> 2] = f4;
  return;
 }
}

function __ZN6Shader19MarkShaderHasErrorsEPKS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[gb + 1166312 + 12 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = HEAP32[gb + 1166312 + 16 >> 2] | 0;
 i6 = i5 & 2147483647;
 do if (i4 >>> 0 > i6 >>> 0) {
  i2 = i5 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i6 >>> 0 < i2 >>> 0) if ((i5 | 0) > -1) {
   HEAP32[gb + 1166312 + 16 >> 2] = i2;
   i6 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[gb + 1166312 >> 2] | 0, i2 << 2, 4, gb + 1166312 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   HEAP32[gb + 1166312 >> 2] = i6;
   break;
  } else {
   i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, gb + 1166312 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i6 | 0, HEAP32[gb + 1166312 >> 2] | 0, HEAP32[gb + 1166312 + 12 >> 2] << 2 | 0) | 0;
   HEAP32[gb + 1166312 + 16 >> 2] = i2;
   HEAP32[gb + 1166312 >> 2] = i6;
   break;
  }
 } while (0);
 HEAP32[gb + 1166312 + 12 >> 2] = i4;
 HEAP32[(HEAP32[gb + 1166312 >> 2] | 0) + (i3 << 2) >> 2] = i1;
 return;
}

function __ZN22RenderingCommandBuffer18AddSetGlobalVectorERKN9ShaderLab16FastPropertyNameERK8Vector4f(i13, i1, i2) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i11 = HEAP32[i2 + 4 >> 2] | 0;
 i12 = HEAP32[i2 + 8 >> 2] | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 i6 = i13 + 8 | 0;
 i8 = i13 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i13 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i13 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 12;
 i4 = i4 + 7 & -4;
 i5 = i4 + 20 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i8 = i1 + i4 | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i8 + 8 >> 2] = i11;
 HEAP32[i8 + 12 >> 2] = i12;
 HEAP32[i8 + 16 >> 2] = i7;
 HEAP8[i13 + 36 >> 0] = 1;
 return;
}

function __ZN19SkinnedMeshRenderer10DeactivateE19DeactivateOperation(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN8Renderer10DeactivateE19DeactivateOperation(i4, i1);
 if (!(HEAP8[i4 + 467 >> 0] | 0)) {
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i3 = 4;
 } else {
  mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0;
  i2 = i4 + 524 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) i3 = 4;
 }
 if ((i3 | 0) == 4) {
  i3 = i4 + 528 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i4 + 408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i4);
 i1 = i4 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i4 + 384 | 0;
 i2 = i4 + 400 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN18CrashReportHandler12CloseServiceEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 HEAP8[i3 >> 0] = 0;
 __ZN18CrashReportHandler25UnregisterGlobalCallbacksEv(i3);
 i4 = i3 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 44 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   i1 = i2 + 144 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i3, i2 + 32 | 0) | 0;
    HEAP32[i1 >> 2] = 0;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN13TextRendering4FontC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i8 = i4 + 8 | 0;
 i6 = i4;
 i10 = i2;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = i8;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 185220 + 8;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(208, i2, 16, gb + 1007971 | 0, 19) | 0;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN20TextRenderingPrivate8FontImplC2E10MemLabelIdPN13TextRendering4FontE(i3, i5, i1);
 HEAP32[i1 + 48 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN12SpriteVertex8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZN14SafeBinaryRead10SetVersionEi(i4, 2);
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 410618 | 0, HEAP32[gb + 37324 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!(__ZN14SafeBinaryRead12IsOldVersionEi(i4, 1) | 0)) {
  STACKTOP = i5;
  return;
 }
 i2 = i2 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 944890 | 0, HEAP32[gb + 37320 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 STACKTOP = i5;
 return;
}

function __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i8 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 _memset(i5 | 0, 0, i8 << 2 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 2);
 HEAP32[i9 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i8 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 _memset(i5 | 0, 0, i8 << 2 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 2);
 HEAP32[i9 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = i7 + 8 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i10 = i7 + 4 | 0;
 i3 = HEAP32[i10 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i8 >>> 0) {
  _memset(i3 | 0, 0, i8 << 2 | 0) | 0;
  HEAP32[i10 >> 2] = i3 + (i8 << 2);
  return;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i8 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i7);
  i1 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
  i3 = HEAP32[i10 >> 2] | 0;
 }
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 _memset(i5 | 0, 0, i8 << 2 | 0) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + (i8 << 2);
 HEAP32[i9 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = ((i2 - i1 | 0) / 12 | 0) + 1 | 0;
 if (i3 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = ((HEAP32[i8 >> 2] | 0) - i1 | 0) / 12 | 0;
 i4 = i6 << 1;
 i4 = i6 >>> 0 < 178956970 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 357913941;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 * 12 | 0) | 0;
 i5 = i6 + (((i2 - i1 | 0) / 12 | 0) * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (((i2 | 0) / -12 | 0) * 12 | 0) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 12;
 HEAP32[i8 >> 2] = i6 + (i4 * 12 | 0);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i4, i8 + 16 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i4, i8 + 24 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i4, i8 + 16 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i4, i8 + 24 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc(i3, i2, i7, i6, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i5 = i3 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) return;
 i3 = HEAP32[i4 + 40 >> 2] | 0;
 L4 : do if (!i3) i1 = -1; else {
  i2 = HEAP32[i4 + 36 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAPU8[i2 + (i1 << 3) >> 0] | 0 | 0) == (i7 | 0)) if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i6 | 0)) break L4;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = -1;
    break;
   }
  }
 } while (0);
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 i7 = i4 + 40 | 0;
 i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 i6 = i3 + (i6 << 3) | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i3 + (i1 << 3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 i1 = HEAP32[i5 >> 2] | 0;
 if (HEAP32[i1 + 40 >> 2] | 0) return;
 if ((HEAP32[i1 + 44 >> 2] | 0) > -1) __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN18AnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_(i7, i8);
 HEAP32[i8 + 4 >> 2] = i7 + 104;
 i1 = HEAP32[i7 + 80 >> 2] | 0;
 i5 = HEAP32[i7 + 92 >> 2] | 0;
 i6 = i1 + (i5 << 2) | 0;
 if (i5 | 0) {
  i3 = i8 + 16 | 0;
  i4 = i8 + 36 | 0;
  i5 = i8 + 40 | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 i1 = HEAP32[i7 + 192 >> 2] | 0;
 i7 = HEAP32[i7 + 204 >> 2] | 0;
 i4 = i1 + (i7 << 2) | 0;
 if (!i7) return;
 i5 = i8 + 16 | 0;
 i6 = i8 + 36 | 0;
 i3 = i8 + 40 | 0;
 do {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 32 | 0, gb + 842535 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 44 | 0, gb + 1034411 | 0, 0);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 56 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfigC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 >> 0] = 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue11ResetValuesEv(i1 + 4 | 0);
 return;
}

function _skip_variable(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i4 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (!i1) if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i7 = 0;
  return i7 | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  break;
 } while (0);
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = i1 + -1 | 0;
 i3 = i2 + 1 | 0;
 i2 = (HEAPU8[i2 >> 0] | 0) << 8;
 do if (!i1) if (!((mftCall_ii(HEAP32[i6 + 12 >> 2] | 0, i4 | 0) | 0) << 24 >> 24)) {
  i7 = 0;
  return i7 | 0;
 } else {
  i1 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  break;
 } while (0);
 i8 = HEAPU8[i3 >> 0] | 0 | i2;
 i2 = i8 + -2 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i9 + 20 >> 2] = 91;
 HEAP32[i9 + 24 >> 2] = HEAP32[i4 + 380 >> 2];
 HEAP32[i9 + 28 >> 2] = i2;
 mftCall_vii(HEAP32[i9 + 4 >> 2] | 0, i4 | 0, 1);
 HEAP32[i6 >> 2] = i3 + 1;
 HEAP32[i7 >> 2] = i1 + -1;
 if (i8 >>> 0 <= 2) {
  i9 = 1;
  return i9 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, i2 | 0);
 i9 = 1;
 return i9 | 0;
}

function __ZNSt3__214__split_bufferIN19SpriteMeshGenerator4pathERNS_9allocatorIS2_EEED2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i7 + 8 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) != (i8 | 0)) do {
  i6 = i1 + -68 | 0;
  HEAP32[i9 >> 2] = i6;
  i5 = HEAP32[i1 + -12 >> 2] | 0;
  i2 = i5;
  if (i5 | 0) {
   i3 = i1 + -8 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
   __ZdlPv(i5);
  }
  i2 = HEAP32[i1 + -24 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + -20 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -32 - i3 | 0) >>> 5) << 5);
   __ZdlPv(i2);
  }
  i3 = HEAP32[i6 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i1 = i1 + -64 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -32 - i4 | 0) >>> 5) << 5);
   __ZdlPv(i3);
  }
  i1 = HEAP32[i9 >> 2] | 0;
 } while ((i1 | 0) != (i8 | 0));
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK21EnlightenSceneMapping19GetTerrainNumChunksERiS0_RK7Hash128(i1, i8, i9, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i10) {
  i12 = 0;
  return i12 | 0;
 }
 i11 = HEAP32[i1 + 100 >> 2] | 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i7 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = i2 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i11 + (i1 * 12 | 0) >> 2] | 0;
  i13 = i5 + (i2 * 56 | 0) + 24 | 0;
  if ((HEAP32[i13 >> 2] | 0) == (i6 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i7 | 0) : 0) {
   i13 = i5 + (i2 * 56 | 0) + 32 | 0;
   if ((HEAP32[i13 >> 2] | 0) == (i3 | 0) ? (HEAP32[i13 + 4 >> 2] | 0) == (i4 | 0) : 0) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i10 >>> 0) {
   i1 = 0;
   i12 = 7;
   break;
  }
 }
 if ((i12 | 0) == 7) return i1 | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 + (i1 * 12 | 0) + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 + (i1 * 12 | 0) + 8 >> 2];
 i13 = 1;
 return i13 | 0;
}

function __ZN7Cubemap23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN9Texture2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
 i8 = i1 + 152 | 0;
 i9 = i1 + 156 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = i2 - i1 >> 2;
 HEAP32[i7 >> 2] = i5;
 i6 = i10 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
  STACKTOP = i11;
  return;
 }
 do {
  __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i10);
 STACKTOP = i11;
 return;
}

function __ZN21RotationBySpeedModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83512 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i2, 1); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37176 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient17GetResponseStatusEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 do if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) {
  i3 = i1 + 40 | 0;
  if (!(HEAP32[i3 >> 2] | 0)) {
   i6 = i1 + 32 | 0;
   i5 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i5 | 0);
   i5 = i1 + 36 | 0;
   i6 = HEAP32[i6 >> 2] | 0;
   __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc(0, i2, i1 + 56 | 0, i5, mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i6 | 0) | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
   if (((HEAP32[i5 >> 2] | 0) + -200 | 0) >>> 0 < 5) {
    HEAP32[i3 >> 2] = 1;
    break;
   } else {
    HEAP32[i3 >> 2] = 2;
    break;
   }
  }
 } while (0);
 STACKTOP = i4;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (HEAP8[i2 + 3 >> 0] | 0) if (HEAP8[i2 + 2 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i2 + 7 >> 0] | 0) if (HEAP8[i2 + 6 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i2 + 31 >> 0] | 0) if (HEAP8[i2 + 30 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP8[i2 + 15 >> 0] | 0)) i1 = 0; else {
  i1 = HEAP16[i2 + 14 >> 1] | 0;
  i1 = Math_imul((i1 & 65535) >>> 8 & 65535, __Z20GetChannelFormatSizeh(i1 & 255) | 0) | 0;
 }
 if (HEAP8[i2 + 19 >> 0] | 0) {
  i3 = HEAP16[i2 + 18 >> 1] | 0;
  i1 = (Math_imul((i3 & 65535) >>> 8 & 65535, __Z20GetChannelFormatSizeh(i3 & 255) | 0) | 0) + i1 | 0;
 }
 if (HEAP8[i2 + 23 >> 0] | 0) {
  i3 = HEAP16[i2 + 22 >> 1] | 0;
  i1 = (Math_imul((i3 & 65535) >>> 8 & 65535, __Z20GetChannelFormatSizeh(i3 & 255) | 0) | 0) + i1 | 0;
 }
 if (HEAP8[i2 + 27 >> 0] | 0) {
  i3 = HEAP16[i2 + 26 >> 1] | 0;
  i1 = (Math_imul((i3 & 65535) >>> 8 & 65535, __Z20GetChannelFormatSizeh(i3 & 255) | 0) | 0) + i1 | 0;
 }
 i3 = (i1 & 3 | 0) == 0;
 return i3 | 0;
}

function __Z27JsonUtility_CUSTOM_FromJsonP12Il2CppStringP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (__ZNK11ICallString6IsNullEv(i3) | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(__ZNK11ICallString6LengthEv(i3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!i2) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1047471 | 0);
 i1 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i2) | 0;
 if (!(__Z27scripting_class_is_abstractP11Il2CppClass(i1) | 0)) if (!(__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0)) {
  i4 = __Z14FromJsonSharedR11ICallStringP12Il2CppObjectP11Il2CppClass(i3, 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = __Z24scripting_class_get_nameP11Il2CppClass(i1) | 0;
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1036890 | 0, i4);
 return 0;
}

function __Z16FlaggedAsSkippedIA256_cEbRK13FileEntryInfoRKT_19FileEnumerationFlag(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = i1 + 1080 | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  i1 = (i5 & 16711680 | 0) == 0;
  do if (!((i5 & 255) << 24 >> 24)) if (i1) if (!(i4 & 8)) break; else {
   i1 = 1;
   break L1;
  } else if (!(i4 & 2)) break; else {
   i1 = 1;
   break L1;
  } else if (i1) if (!(i4 & 16)) break; else {
   i1 = 1;
   break L1;
  } else if (!(i4 & 4)) break; else {
   i1 = 1;
   break L1;
  } while (0);
  if (!(i4 & 96)) i1 = 0; else {
   i1 = _strlen(i3) | 0;
   if (i4 & 32 | 0) {
    if ((HEAP8[i3 >> 0] | 0) == 46) {
     i1 = 1;
     break;
    }
    if (!(__Z7StrICmpPKcS0_(i3, gb + 491580 | 0) | 0)) {
     i1 = 1;
     break;
    }
    if (__Z8EndsWithPKcjS0_j(i3, i1, gb + 1086597 | 0, 1) | 0) {
     i1 = 1;
     break;
    }
   }
   if (i4 & 64 | 0) if (!(HEAP8[i2 >> 0] | 0)) if (__Z23EndsWithCaseInsensitivePKcjS0_j(i3, i1, gb + 491584 | 0, 4) | 0) {
    i1 = 1;
    break;
   }
   i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function __Z14UpdateCurveKeyR17AnimationCurveTplIfEiRK11KeyframeTplIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i4 = HEAP32[i1 + 56 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i4 + (i2 << 4) >> 2]);
 i6 = i2 + -1 | 0;
 if ((i2 | 0) < 1) i7 = 3; else if ((i2 + 1 | 0) < (HEAP32[i1 + 68 >> 2] | 0)) i7 = 3;
 if ((i7 | 0) == 3) if (f5 > Math_fround(HEAPF32[i4 + (i6 << 4) >> 2])) if (f5 < Math_fround(HEAPF32[i4 + (i2 + 1 << 4) >> 2])) {
  i7 = i4 + (i2 << 4) | 0;
  HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  i7 = i2;
  return i7 | 0;
 }
 i2 = i4 + (i2 << 4) | 0;
 i6 = i2 + 16 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 i7 = i1 + 68 | 0;
 _memmove(i2 | 0, i6 | 0, i4 + (HEAP32[i7 >> 2] << 4) - i6 | 0) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 i7 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i1, i3) | 0;
 return i7 | 0;
}

function __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(+Math_cos(+f8));
 f8 = Math_fround(+Math_sin(+f8));
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(+Math_cos(+f6));
 f6 = Math_fround(+Math_sin(+f6));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(+Math_cos(+f5));
 f5 = Math_fround(+Math_sin(+f5));
 f7 = Math_fround(f3 * f9);
 HEAPF32[i2 >> 2] = Math_fround(f7 + Math_fround(Math_fround(f8 * f6) * f5));
 HEAPF32[i2 + 12 >> 2] = Math_fround(Math_fround(f6 * Math_fround(f8 * f9)) - Math_fround(f3 * f5));
 HEAPF32[i2 + 24 >> 2] = Math_fround(f4 * f6);
 HEAPF32[i2 + 4 >> 2] = Math_fround(f4 * f5);
 HEAPF32[i2 + 16 >> 2] = Math_fround(f4 * f9);
 HEAPF32[i2 + 28 >> 2] = Math_fround(-f8);
 HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(Math_fround(f8 * f3) * f5) - Math_fround(f6 * f9));
 HEAPF32[i2 + 20 >> 2] = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f5));
 HEAPF32[i2 + 32 >> 2] = Math_fround(f4 * f3);
 return;
}

function __ZN5physx3Cct13HandleManager6RemoveEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i8 & 65535;
 i1 = HEAP32[i9 + 8 >> 2] | 0;
 if (i4 >>> 0 >= i1 >>> 0) return;
 i5 = i9 + 12 | 0;
 i6 = HEAP16[(HEAP32[i5 >> 2] | 0) + (i4 << 1) >> 1] | 0;
 i7 = i6 & 65535;
 if (!(i6 << 16 >> 16 != -1 & i7 >>> 0 < i1 >>> 0)) return;
 i1 = i9 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i9 + 20 | 0;
 if ((HEAPU16[(HEAP32[i3 >> 2] | 0) + (i4 << 1) >> 1] | 0 | 0) != (i8 >>> 16 | 0)) return;
 i2 = i2 + -1 | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i9 >> 2] | 0;
 HEAP32[i1 + (i7 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 i2 = i1 + (i2 << 1) | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP16[i5 + ((HEAPU16[i2 >> 1] | 0) << 1) >> 1] = i6;
 HEAP16[i1 + (i7 << 1) >> 1] = HEAP16[i2 >> 1] | 0;
 HEAP16[i2 >> 1] = i8;
 HEAP16[i5 + (i4 << 1) >> 1] = -1;
 i9 = i9 + 24 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 i9 = (HEAP32[i3 >> 2] | 0) + (i4 << 1) | 0;
 HEAP16[i9 >> 1] = (HEAP16[i9 >> 1] | 0) + 1 << 16 >> 16;
 return;
}

function __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831112;
 HEAP32[i1 + 4 >> 2] = 597;
 HEAP32[i1 + 8 >> 2] = fb + 595;
 HEAP32[i1 + 12 >> 2] = gb + 831153;
 HEAP32[i1 + 16 >> 2] = 598;
 HEAP32[i1 + 20 >> 2] = fb + 596;
 HEAP32[i1 + 24 >> 2] = gb + 831187;
 HEAP32[i1 + 28 >> 2] = 599;
 HEAP32[i1 + 32 >> 2] = fb + 597;
 HEAP32[i1 + 36 >> 2] = gb + 831221;
 HEAP32[i1 + 40 >> 2] = 600;
 HEAP32[i1 + 44 >> 2] = fb + 598;
 HEAP32[i1 + 48 >> 2] = fb + 515;
 HEAP32[i1 + 52 >> 2] = gb + 831232;
 HEAP32[i1 + 56 >> 2] = 601;
 HEAP32[i1 + 60 >> 2] = fb + 599;
 HEAP32[i1 + 64 >> 2] = fb + 516;
 HEAP32[i1 + 68 >> 2] = gb + 831243;
 HEAP32[i1 + 72 >> 2] = 602;
 HEAP32[i1 + 76 >> 2] = fb + 600;
 HEAP32[i1 + 80 >> 2] = fb + 517;
 HEAP32[i1 + 84 >> 2] = gb + 831280;
 HEAP32[i1 + 88 >> 2] = 603;
 HEAP32[i1 + 92 >> 2] = fb + 601;
 HEAP32[i1 + 96 >> 2] = fb + 518;
 HEAP32[i1 + 100 >> 2] = gb + 831311;
 HEAP32[i1 + 104 >> 2] = 604;
 HEAP32[i1 + 108 >> 2] = fb + 2385;
 HEAP32[i1 + 112 >> 2] = fb + 3927;
 __ZN5physx28MFrictionVsSlipGraphPropertyC2Ev(i1 + 116 | 0);
 return;
}

function __ZN5physx2Sn5ConvX12convertFloatEPKcRKNS0_15PxMetaDataEntryES6_(i3, i8, i2, i1) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if (HEAP8[i3 + 325 >> 0] | 0) {
  STACKTOP = i13;
  return;
 }
 i9 = i2 + 16 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i10 = i3 + 308 | 0;
 i11 = i3 + 304 | 0;
 i6 = i3 + 312 | 0;
 i7 = i12 + 3 | 0;
 i4 = i12 + 1 | 0;
 i5 = i12 + 2 | 0;
 i2 = i8;
 i3 = 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  if (HEAP8[i10 >> 0] | 0) {
   HEAP8[i12 >> 0] = i1 >>> 24;
   HEAP8[i7 >> 0] = i1;
   HEAP8[i4 >> 0] = i1 >>> 16;
   HEAP8[i5 >> 0] = i1 >>> 8;
  }
  i8 = HEAP32[i11 >> 2] | 0;
  i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i12 | 0, 4) | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i8;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (HEAP32[i9 >> 2] | 0)) break; else i2 = i2 + 4 | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx17PxsFluidCollisionC2ERNS_20PxsParticleSystemSimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 96 >> 2] = i1;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i2 + 144 >> 2] = 0;
 HEAP32[i2 + 148 >> 2] = 0;
 HEAP32[i2 + 152 >> 2] = 0;
 HEAP32[i2 + 188 >> 2] = 0;
 HEAP32[i2 + 192 >> 2] = 0;
 HEAP32[i2 + 196 >> 2] = 0;
 HEAP32[i2 + 232 >> 2] = 0;
 HEAP32[i2 + 236 >> 2] = 0;
 HEAP32[i2 + 240 >> 2] = 0;
 HEAP32[i2 + 276 >> 2] = 0;
 HEAP32[i2 + 280 >> 2] = 0;
 HEAP32[i2 + 284 >> 2] = 0;
 HEAP32[i2 + 320 >> 2] = 0;
 HEAP32[i2 + 324 >> 2] = 0;
 HEAP32[i2 + 328 >> 2] = 0;
 HEAP32[i2 + 364 >> 2] = 0;
 HEAP32[i2 + 368 >> 2] = 0;
 HEAP32[i2 + 372 >> 2] = 0;
 HEAP32[i2 + 408 >> 2] = 0;
 HEAP32[i2 + 412 >> 2] = 0;
 HEAP32[i2 + 416 >> 2] = 0;
 i1 = i2 + 452 | 0;
 HEAP16[i2 + 456 >> 1] = -1;
 HEAP16[i2 + 458 >> 1] = 0;
 HEAP32[i2 + 460 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i2 + 464 >> 2] = 0;
 HEAP32[i2 + 468 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 147540 + 8;
 HEAP32[i2 + 472 >> 2] = i2;
 HEAP32[i2 + 476 >> 2] = gb + 769808;
 return;
}

function __ZN2UI13RectTransform10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 if ((i2 | 0) == 1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105896 | 0, i5);
 }
 if (!(__Z25IsManagerContextAvailablei(5) | 0)) {
  STACKTOP = i6;
  return;
 }
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 292 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i3, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN17MonoScriptManager21RegisterRuntimeScriptER10MonoScript(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i12 + 8 | 0;
 i10 = i12 + 4 | 0;
 i11 = i12;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i11 >> 2] = i7;
 i2 = HEAP32[i9 >> 2] | 0;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i13 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i13 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i13 | 0 : i13;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 i2 = i1;
 if ((i1 | 0) != (i6 | 0)) if ((i7 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i10 >> 2] = i2;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_(i9, i8, i11) | 0;
 STACKTOP = i12;
 return;
}

function __ZNK20LocalFileSystemPosix21GetUserAppCacheFolderEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i5;
  return;
 };
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 491557 | 0, 6);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i2, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 STACKTOP = i5;
 return;
}

function __ZN9shadertag7CleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1166564 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 4 | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = i3; else {
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63280 | 0);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   i3 = HEAP32[gb + 1166564 >> 2] | 0;
   i2 = i3 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i3;
 }
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  HEAP32[gb + 1166564 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166564 >> 2] = 0;
 return;
}

function __ZN5physx36PxsSolverCoreRegisterArticulationFnsEv() {
 HEAP32[gb + 103784 + 12 >> 2] = fb + 3581;
 HEAP32[gb + 103784 + 16 >> 2] = fb + 3582;
 HEAP32[gb + 146848 + 12 >> 2] = fb + 3583;
 HEAP32[gb + 146848 + 16 >> 2] = fb + 3584;
 HEAP32[gb + 103620 + 12 >> 2] = fb + 787;
 HEAP32[gb + 103620 + 16 >> 2] = fb + 788;
 HEAP32[gb + 103660 + 12 >> 2] = fb + 182;
 HEAP32[gb + 103660 + 16 >> 2] = fb + 183;
 HEAP32[gb + 103580 + 12 >> 2] = fb + 789;
 HEAP32[gb + 103580 + 16 >> 2] = fb + 790;
 HEAP32[gb + 103700 + 12 >> 2] = fb + 3585;
 HEAP32[gb + 103700 + 16 >> 2] = fb + 3582;
 HEAP32[gb + 146876 + 12 >> 2] = fb + 3586;
 HEAP32[gb + 146876 + 16 >> 2] = fb + 3584;
 HEAP32[gb + 103460 + 12 >> 2] = fb + 791;
 HEAP32[gb + 103460 + 16 >> 2] = fb + 788;
 HEAP32[gb + 103520 + 12 >> 2] = fb + 184;
 HEAP32[gb + 103520 + 16 >> 2] = fb + 183;
 HEAP32[gb + 103400 + 12 >> 2] = fb + 792;
 HEAP32[gb + 103400 + 16 >> 2] = fb + 790;
 HEAP32[gb + 103700 + 48 >> 2] = fb + 3587;
 HEAP32[gb + 103460 + 48 >> 2] = fb + 793;
 HEAP32[gb + 103520 + 48 >> 2] = fb + 185;
 HEAP32[gb + 103400 + 48 >> 2] = fb + 793;
 return;
}

function __ZN17PersistentManager42GetSerializedFileInternalIfObjectAvailableEix(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) == -1) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i1, i2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(__ZNK14SerializedFile11IsAvailableEx(i1, i4, i5) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i2) {
  i6 = HEAP32[i3 >> 2] | 0;
  return i6 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i7 << 3) | 0;
 if (!i7) {
  i6 = i1;
  i6 = (i6 | 0) != (i2 | 0);
  i7 = HEAP32[i3 >> 2] | 0;
  i7 = i6 ? 0 : i7;
  return i7 | 0;
 }
 do {
  i7 = i1;
  if ((HEAP32[i7 >> 2] | 0) == (i4 | 0) ? (HEAP32[i7 + 4 >> 2] | 0) == (i5 | 0) : 0) {
   i6 = 10;
   break;
  }
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 if ((i6 | 0) == 10) {
  i6 = (i1 | 0) != (i2 | 0);
  i7 = HEAP32[i3 >> 2] | 0;
  i7 = i6 ? 0 : i7;
  return i7 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 return i7 | 0;
}

function __ZN11IMGUIModule21QueryGUIDisplayTargetEP11Il2CppClass(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 248 | 0;
 i1 = i4 + 8 | 0;
 i2 = i4;
 if (!((i5 | 0) != 0 & (HEAP32[(__Z24GetIMGUIScriptingClassesv() | 0) + 24 >> 2] | 0) != 0)) {
  i5 = 1;
  STACKTOP = i4;
  return i5 | 0;
 }
 i8 = (__Z24GetIMGUIScriptingClassesv() | 0) + 24 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i2;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i1, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i1, __Z26scripting_class_get_objectP11Il2CppClass(i5) | 0);
 __ZN18ScriptingArguments9AddStringEPKc(i1, gb + 1019051 | 0);
 HEAP32[i3 >> 2] = 0;
 i5 = __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb(i1, i3, 0) | 0;
 i5 = (i5 | 0) != -1 & (HEAP32[i3 >> 2] | 0) == 0 ? i5 : 1;
 STACKTOP = i4;
 return i5 | 0;
}

function __Z39GameObject_CUSTOM_GetComponentsInternalP12Il2CppObjectS0_hhhhS0_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 if (!i1) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i9) {
  i10 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  HEAP32[i8 >> 2] = i9;
  HEAP32[i8 + 4 >> 2] = i2;
  HEAP8[i8 + 21 >> 0] = 1;
  HEAP8[i8 + 22 >> 0] = 1;
  HEAP8[i8 + 13 >> 0] = 0;
  HEAP8[i8 + 20 >> 0] = i3 << 24 >> 24 != 0 & 1;
  HEAP8[i8 + 12 >> 0] = i4 << 24 >> 24 != 0 & 1;
  HEAP8[i8 + 14 >> 0] = i5 << 24 >> 24 != 0 & 1;
  HEAP32[i8 + 16 >> 2] = i6 << 24 >> 24 != 0 & 1;
  HEAP32[i8 + 8 >> 2] = i7;
  i9 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i8) | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function __Z36JsonUtility_CUSTOM_FromJsonOverwriteP12Il2CppStringP12Il2CppObject(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (__ZNK11ICallString6IsNullEv(i4) | 0) {
  STACKTOP = i6;
  return;
 }
 if (!(__ZNK11ICallString6LengthEv(i4) | 0)) {
  STACKTOP = i6;
  return;
 }
 if (!i3) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1036945 | 0);
 i2 = __Z26scripting_object_get_classP12Il2CppObject(i3) | 0;
 if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i2, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 268 >> 2] | 0) | 0) {
  i1 = __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass(i2) | 0;
  if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1036963 | 0, i5);
  if ((HEAP32[i1 + 16 >> 2] | 0) != 114) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1036963 | 0, i5);
 }
 __Z14FromJsonSharedR11ICallStringP12Il2CppObjectP11Il2CppClass(i4, i3, i2) | 0;
 STACKTOP = i6;
 return;
}

function __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 31312 | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 i2 = i4;
 if (i4 | 0) {
  i3 = i6 + 72 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (HEAP32[i6 + 76 >> 2] | 0)) __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i6 + 68 | 0, i1); else {
   HEAP32[i4 >> 2] = i2;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
  }
  __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i6);
 }
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 i5 = HEAP32[i5 + 92 >> 2] | 0;
 i2 = i1 + (i5 << 2) | 0;
 if (!i5) {
  STACKTOP = i7;
  return;
 }
 do {
  __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i6, HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 3;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 671669 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 3) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  i5 = i1;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i7 = i2;
  HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  i2 = i2 + 8 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function __ZN5physx2Cm26dumpFreeListAllocatorStateERNS0_17FreeListAllocatorE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 _puts(gb + 778870 | 0) | 0;
 i1 = HEAP32[i1 + 4240 >> 2] | 0;
 if (!i1) {
  _puts(gb + 778905 | 0) | 0;
  STACKTOP = i6;
  return;
 }
 do {
  HEAP32[i4 >> 2] = i1;
  _printf(gb + 778911 | 0, i4) | 0;
  i3 = i1 + 12 | 0;
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i5 + 4 >> 2] = i2 & 1023;
   HEAP32[i5 + 8 >> 2] = i2 >>> 10 & 1023;
   HEAP32[i5 + 12 >> 2] = (i2 | 0) < 0 ? gb + 778922 | 0 : gb + 1576256 | 0;
   HEAP32[i5 + 16 >> 2] = i2 & 1073741824 | 0 ? gb + 778927 | 0 : gb + 1576256 | 0;
   HEAP32[i5 + 20 >> 2] = i2 & 536870912 | 0 ? gb + 778933 | 0 : gb + 1576256 | 0;
   _printf(gb + 778938 | 0, i5) | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2 & 536870912 | 0) break;
   i3 = i3 + (i2 << 4 & 16368) | 0;
  } while ((i3 | 0) != 0);
  i1 = HEAP32[i1 >> 2] | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i6;
 return;
}

function __ZN5physx20InternalTriangleMesh9loadRTreeERNS_13PxInputStreamEj(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 180 | 0;
 HEAP32[i4 + 184 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E(i1, HEAP32[i4 + 12 >> 2] | 0, (HEAP8[i4 + 156 >> 0] & 2) != 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 if (i2 >>> 0 < 10) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 724949 | 0, 245, gb + 725042 | 0, i5);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 + 16 >> 2] = i1;
 if (__ZN5physx2Gu5RTree4loadERNS_13PxInputStreamEj(i4 + 32 | 0, i3, i2) | 0) {
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 724949 | 0, 254, gb + 725128 | 0, i5 + 8 | 0);
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5Umbra9RasterOps6blitOrERNS_17BlockRasterBufferERKS1_(i8, i2) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i12 = HEAPU8[i2 >> 0] | 0;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 i11 = HEAP8[i2 + 3 >> 0] | 0;
 i13 = i11 & 255;
 if ((i1 & 255) >= (i11 & 255)) {
  i13 = 0;
  return i13 | 0;
 }
 i9 = HEAPU8[i8 + 2 >> 0] | 0;
 i10 = HEAP32[i8 + 4 >> 2] | 0;
 i11 = (HEAPU8[i2 + 2 >> 0] | 0) - i12 | 0;
 i6 = 0;
 i7 = i1 & 255;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i5 = HEAP16[i8 >> 1] | 0;
  i3 = i5 & 255;
  i2 = i11;
  i3 = i10 + (i12 - i3 + (Math_imul(i7 - ((i5 & 65535) >>> 8 & 65535) | 0, i9 - i3 | 0) | 0) << 2) | 0;
  i5 = i4;
  i1 = i6;
  while (1) {
   i14 = HEAP32[i3 >> 2] | 0;
   i6 = HEAP32[i5 >> 2] | i14;
   i1 = i6 ^ i14 | i1;
   HEAP32[i3 >> 2] = i6;
   i2 = i2 + -1 | 0;
   if (!i2) break; else {
    i3 = i3 + 4 | 0;
    i5 = i5 + 4 | 0;
   }
  }
  i7 = i7 + 1 | 0;
  if ((i7 | 0) == (i13 | 0)) break; else {
   i6 = i1;
   i4 = i4 + (i11 << 2) | 0;
  }
 }
 i14 = (i1 | 0) != 0;
 return i14 | 0;
}

function __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_(i5, i2, i3, i4, i1, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = HEAP32[i2 + 32 >> 2] | 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 HEAP32[i5 >> 2] = i7;
 i2 = HEAP32[i2 + 36 >> 2] | 0;
 i7 = i2 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 HEAP32[i5 + 8 >> 2] = i2;
 if (!i3) {
  HEAP32[i5 + 4 >> 2] = 0;
  i2 = 0;
 } else {
  i2 = HEAP32[i3 + 32 >> 2] | 0;
  i8 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  HEAP32[i5 + 4 >> 2] = i2;
  i2 = HEAP32[i3 + 36 >> 2] | 0;
  i8 = i2 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i5 + 12 >> 2] = i2;
 HEAP32[i5 + 16 >> 2] = i4;
 if (!i1) i1 = 0; else {
  i8 = i1 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 }
 HEAP32[i5 + 20 >> 2] = i1;
 if (!i6) {
  i7 = 0;
  i8 = i5 + 24 | 0;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i7 = i6;
 i8 = i5 + 24 | 0;
 HEAP32[i8 >> 2] = i7;
 return;
}

function __Z29StdTemplateConversionFunctionIjyEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i7 = i5;
  i6 = i7;
  HEAP32[i6 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 i7 = i5;
 i6 = i7;
 HEAP32[i6 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIjxEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i4 = i1;
  i7 = i5;
  i6 = i7;
  HEAP32[i6 >> 2] = i4;
  i7 = i7 + 4 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return 1;
 }
 i4 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i4;
 i7 = i5;
 i6 = i7;
 HEAP32[i6 >> 2] = i4;
 i7 = i7 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return 1;
}

function __ZNSt3__26vectorINS_4pairIb4PPtrI10GUIElementEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i10, i7) {
 i10 = i10 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i11 = 0, i12 = 0;
 i11 = i10 + 4 | 0;
 i2 = HEAP32[i11 >> 2] | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i10);
  i1 = HEAP32[i10 >> 2] | 0;
  i2 = HEAP32[i11 >> 2] | 0;
 }
 i9 = i1;
 i8 = i10 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i12 = i7;
 i7 = HEAP32[i12 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i9 | 0, i2 | 0) | 0;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i11 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i9);
 return;
}

function __ZN5physx3Cct13BoxController20updateKinematicProxyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, f8 = f0, i9 = 0, f10 = f0, f11 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 if (!(HEAP32[i2 + 408 >> 2] | 0)) {
  STACKTOP = i3;
  return 1;
 }
 i4 = __ZNK5physx3Cct10Controller12getKineShapeEv(i2 + 8 | 0) | 0;
 HEAP32[i1 >> 2] = 3;
 i9 = i1 + 4 | 0;
 HEAPF32[i9 >> 2] = Math_fround(0.0);
 i7 = i1 + 8 | 0;
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 i5 = i1 + 12 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 f11 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 500 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 504 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 488 >> 2]);
 f8 = Math_fround(f8 * f10);
 f6 = Math_fround(f6 * f10);
 HEAPF32[i9 >> 2] = Math_fround(f11 * f10);
 HEAPF32[i7 >> 2] = f8;
 HEAPF32[i5 >> 2] = f6;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0, i1 | 0);
 STACKTOP = i3;
 return 1;
}

function __ZN5physx2Sc20ArticulationJointSim10onActivateEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 i3 = i6 + 32 | 0;
 i4 = i6 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  i7 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 188 >> 2];
  HEAP32[i2 >> 2] = HEAP32[(HEAP32[i6 + 8 >> 2] | 0) + 188 >> 2];
  __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_(i7, 2, i1, i2, i3);
  __ZN5physx16PxsIslandManager24setEdgeArticulationJointERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i7, i3);
  __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i7, i3);
 }
 if (!(HEAP8[(HEAP32[i4 >> 2] | 0) + 51 >> 0] & 1)) {
  STACKTOP = i5;
  return 0;
 } else {
  STACKTOP = i5;
  return (HEAP8[(HEAP32[i6 + 8 >> 2] | 0) + 51 >> 0] & 1) != 0 | 0;
 }
 return 0;
}

function __ZN17SizeBySpeedModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83496 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15ReflectionProbe12AddToManagerEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i3 = i7;
 i4 = HEAP32[gb + 1112272 >> 2] | 0;
 if (!i5) i2 = 0; else i2 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZN16ReflectionProbes8AddProbeE4PPtrI15ReflectionProbeE(i4, i1);
 HEAP8[i5 + 160 >> 0] = 1;
 if ((HEAP32[i5 + 40 >> 2] | 0) != 1) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i5 + 44 >> 2] | 0) != 1) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i6 = 10;
   break;
  }
 }
 if ((i6 | 0) == 10) {
  STACKTOP = i7;
  return;
 }
 __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i3, 3, i5, 63);
 STACKTOP = i7;
 return;
}

function __ZN12HandlerChain10ToAbsoluteEPKc(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 L1 : do if ((i2 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i4 = i6 + 11 | 0;
  i5 = i6 + 4 | 0;
  i1 = i2;
  while (1) {
   i1 = i1 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i6 | 0, i2 | 0, i7 | 0);
   i2 = _strlen(i7) | 0;
   i8 = HEAP8[i4 >> 0] | 0;
   if ((i2 | 0) != ((i8 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i8 & 255) | 0)) {
    i1 = 7;
    break;
   }
   if (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i6, 0, -1, i7, i2) | 0) {
    i1 = 7;
    break;
   }
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) break L1;
  }
  if ((i1 | 0) == 7) return;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i7, _strlen(i7) | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient18UpdateResponseInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 i3 = i1 + 40 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  STACKTOP = i4;
  return;
 }
 i6 = i1 + 32 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i5 | 0);
 i5 = i1 + 36 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc(0, i2, i1 + 56 | 0, i5, mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0, i6 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (((HEAP32[i5 >> 2] | 0) + -200 | 0) >>> 0 < 5) {
  HEAP32[i3 >> 2] = 1;
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i3 >> 2] = 2;
  STACKTOP = i4;
  return;
 }
}

function __Z15HumanBoneToMonoRK9HumanBoneR13MonoHumanBone(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 HEAP32[i2 >> 2] = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0;
 i5 = i1 + 16 | 0;
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 HEAP32[i2 + 4 >> 2] = __Z20scripting_string_newPKcj(i3 ? HEAP32[i5 >> 2] | 0 : i5, i3 ? HEAP32[i1 + 20 >> 2] | 0 : i4 & 255) | 0;
 i4 = i1 + 32 | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i2 + 48 >> 2] = (HEAP8[i1 + 72 >> 0] ^ 1) & 255;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = i2 + 20 | 0;
 i4 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = i2 + 32 | 0;
 i4 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 68 >> 2];
 return;
}

function __ZNK5physx2Sq10AABBPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE(i6, i4, i7, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 if (i2 | 0) {
  i9 = HEAP32[i6 + 7776 >> 2] | 0;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  if (!(__ZN15AABBTreeRaycastILb0EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE(i8 + 12 | 0, i9, i2, i4, i7, i3, i1, i5) | 0)) {
   i9 = 0;
   STACKTOP = i8;
   return i9 | 0;
  }
 }
 if (!(HEAP8[i6 + 7808 >> 0] | 0)) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 if (!(HEAP32[i6 + 92 >> 2] | 0)) if (!(HEAP32[i6 + 136 >> 2] | 0)) {
  i9 = 1;
  STACKTOP = i8;
  return i9 | 0;
 }
 i9 = __ZNK5physx2Sq16BucketPrunerCore7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE(i6 + 144 | 0, i4, i7, i3, i5) | 0;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN5physx2Sn5ConvX9convert32EPKcRKNS0_15PxMetaDataEntryES6_(i3, i8, i2, i1) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i13;
 if (HEAP8[i3 + 325 >> 0] | 0) {
  STACKTOP = i13;
  return;
 }
 i9 = i2 + 16 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i10 = i3 + 308 | 0;
 i11 = i3 + 304 | 0;
 i6 = i3 + 312 | 0;
 i7 = i12 + 3 | 0;
 i4 = i12 + 1 | 0;
 i5 = i12 + 2 | 0;
 i2 = i8;
 i3 = 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i12 >> 2] = i1;
  if (HEAP8[i10 >> 0] | 0) {
   HEAP8[i12 >> 0] = i1 >>> 24;
   HEAP8[i7 >> 0] = i1;
   HEAP8[i4 >> 0] = i1 >>> 16;
   HEAP8[i5 >> 0] = i1 >>> 8;
  }
  i8 = HEAP32[i11 >> 2] | 0;
  i8 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i12 | 0, 4) | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i8;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (HEAP32[i9 >> 2] | 0)) break; else i2 = i2 + 4 | 0;
 }
 STACKTOP = i13;
 return;
}

function __ZN5physx19PxcScratchAllocator5allocEjb(i10, i1, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i3 = i11 + 4 | 0;
 i2 = i1 + 15 & -16;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i10 >> 2] | 0);
 i4 = i10 + 4 | 0;
 i5 = i10 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i7 + (i6 + -1 << 2) >> 2] | 0;
 do if ((i1 - (HEAP32[i10 + 16 >> 2] | 0) | 0) < (i2 | 0)) if (i8) i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i2, gb + 717976 | 0, 82) | 0; else i1 = 0; else {
  i1 = i1 + (0 - i2) | 0;
  HEAP32[i9 >> 2] = i1;
  if ((HEAP32[i10 + 12 >> 2] & 2147483647) >>> 0 > i6 >>> 0) {
   HEAP32[i7 + (i6 << 2) >> 2] = i1;
   HEAP32[i5 >> 2] = i6 + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i4, i9) | 0;
   break;
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i10 >> 2] | 0);
 STACKTOP = i11;
 return i1 | 0;
}

function __ZN5Umbra12QueryContextC2EPNS_10QueryStateEj(i7, i4, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i8 = 0;
 HEAP32[i7 >> 2] = i4;
 i3 = HEAP32[i4 + 76 >> 2] | 0;
 HEAP32[i7 + 4 >> 2] = i3;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = i3 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = i8 + -16 - i1 & -16;
 i2 = i1 + i5 | 0;
 if (i2 >>> 0 > i8 >>> 0) i1 = 0; else HEAP32[i3 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = i1 + i5;
 i2 = i7 + 16 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i7 + 20 >> 2] = i5;
 HEAP32[i7 + 24 >> 2] = 0;
 HEAP32[i7 + 28 >> 2] = 0;
 HEAP32[i7 + 32 >> 2] = i6;
 HEAP32[i7 + 36 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = -1;
 i8 = HEAP32[i4 + 84 >> 2] | 0;
 HEAP32[i7 + 44 >> 2] = i8;
 HEAP32[i7 + 48 >> 2] = i8;
 HEAP32[i7 + 52 >> 2] = 0;
 HEAP32[i7 + 56 >> 2] = 0;
 if ((i5 | 0) < 80) i1 = 0; else {
  HEAP32[i2 >> 2] = i1 + 80;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = 13;
   i1 = i1 + 16 | 0;
  }
 }
 HEAP32[i7 + 60 >> 2] = i1;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN21AnimationClipPlayable12PrepareFrameERK9FrameDataP8Playable(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, f8 = f0, i9 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 36 >> 2] | 0, i6 | 0) | 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i6 + 176 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) return;
 i7 = i6 + 96 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + 100 >> 2] = i9;
 i5 = i2 + 8 | 0;
 i4 = i2 + 32 | 0;
 f8 = Math_fround(+HEAPF64[i5 >> 3] - +HEAPF64[i4 >> 3]);
 f8 = Math_fround(Math_fround(HEAPF32[i6 + 168 >> 2]) * f8);
 HEAPF32[i7 >> 2] = Math_fround((HEAP32[tempDoublePtr >> 2] = i9, Math_fround(HEAPF32[tempDoublePtr >> 2])) + f8);
 HEAP32[i3 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0, i6 | 0, 128);
 i2 = i6 + 116 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == 1) {
  HEAP32[i2 >> 2] = 2;
  i1 = 2;
 }
 if (i1 | 0 ? 1 : Math_fround(+HEAPF64[i5 >> 3] - +HEAPF64[i4 >> 3]) == Math_fround(0.0)) return;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 124 >> 2] | 0, i6 | 0, 1);
 HEAP32[i2 >> 2] = 1;
 return;
}

function __ZN12CullingGroupD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != -1) {
  i7 = HEAP32[gb + 1114352 >> 2] | 0;
  i5 = i7 + 12 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  i7 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
  HEAP32[i7 + (i2 << 2) >> 2] = i4;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i4 + 8 >> 2] = i2;
  HEAP32[i1 >> 2] = -1;
 }
 i1 = HEAP32[i3 + 108 >> 2] | 0;
 if (i1 | 0) __Z23scripting_gchandle_freej(i1);
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __Z23scripting_gchandle_freej(i1);
 i1 = i3 + 84 | 0;
 if ((HEAP32[i3 + 100 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 88 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 64 >> 2] | 0) > -1) {
  i7 = i3 + 48 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i3 + 52 | 0);
  HEAP32[i7 >> 2] = 0;
 }
 if ((HEAP32[i3 + 44 >> 2] | 0) <= -1) return;
 i7 = i3 + 28 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, i3 + 32 | 0);
 HEAP32[i7 >> 2] = 0;
 return;
}

function __Z38LightProbes_Set_Custom_PropBakedProbesP12Il2CppObjectP11Il2CppArray(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 if ((i1 | 0) != (__ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2 + 32 | 0) | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 518038 | 0, i5);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 108) | 0;
  __ZN11LightProbes20SetBakedCoefficientsEPK20SphericalHarmonicsL2i(i1, i6, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0);
  STACKTOP = i5;
  return;
 }
}

function __Z17UpdateVelocityJobP9CrowdInfoj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, f9 = f0, i10 = 0, f11 = f0;
 f3 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 368 >> 2]));
 i4 = HEAP32[i1 + (i2 << 4) + 12 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i5 = HEAP32[i1 + (i2 << 4) + 8 >> 2] | 0;
 i2 = HEAP32[i1 + (i2 << 4) >> 2] | 0;
 i1 = 0;
 do {
  i6 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  i10 = i2 + (i6 * 608 | 0) + 540 | 0;
  f11 = Math_fround(HEAPF32[i2 + (i6 * 608 | 0) + 480 >> 2]);
  f11 = Math_fround(f11 - Math_fround(HEAPF32[i10 >> 2]));
  f9 = Math_fround(HEAPF32[i2 + (i6 * 608 | 0) + 484 >> 2]);
  i8 = i2 + (i6 * 608 | 0) + 544 | 0;
  f9 = Math_fround(f9 - Math_fround(HEAPF32[i8 >> 2]));
  f7 = Math_fround(HEAPF32[i2 + (i6 * 608 | 0) + 488 >> 2]);
  i6 = i2 + (i6 * 608 | 0) + 548 | 0;
  f7 = Math_fround(f7 - Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i10 >> 2] = Math_fround(f3 * f11);
  HEAPF32[i8 >> 2] = Math_fround(f3 * f9);
  HEAPF32[i6 >> 2] = Math_fround(f3 * f7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function _UNITY_FT_Set_Transform(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 if (!i1) return;
 i4 = HEAP32[i1 + 128 >> 2] | 0;
 i7 = i4 + 24 | 0;
 HEAP32[i7 >> 2] = 0;
 if (!i2) {
  HEAP32[i4 >> 2] = 65536;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 65536;
  i1 = i4;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i2;
 }
 if (!(HEAP32[i1 + 8 >> 2] | HEAP32[i1 + 4 >> 2])) if ((HEAP32[i1 >> 2] | 0) == 65536) if ((HEAP32[i1 + 12 >> 2] | 0) == 65536) i3 = 2; else i5 = 8; else i5 = 8; else i5 = 8;
 if ((i5 | 0) == 8) {
  HEAP32[i7 >> 2] = 1;
  i3 = 3;
 }
 i2 = i4 + 16 | 0;
 if (!i6) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  i1 = 0;
 } else {
  i5 = i6;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  i2 = i6;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (!(HEAP32[i2 + 4 >> 2] | i1)) return;
 HEAP32[i7 >> 2] = i3;
 return;
}

function mftCall_iiiiiiffiiiiiiiiiffffiii(i24, i1, i2, i13, i17, i18, d19, d20, i21, i22, i23, i3, i4, i5, i6, i7, i8, d9, d10, d11, d12, i14, i15, i16) {
 i24 = i24 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 d19 = +d19;
 d20 = +d20;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 d9 = +d9;
 d10 = +d10;
 d11 = +d11;
 d12 = +d12;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 if ((i24 | 0) >= (fb | 0) & (i24 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiiiffiiiiiiiiiffffiii[i24 - fb & 1](i1 | 0, i2 | 0, i13 | 0, i17 | 0, i18 | 0, Math_fround(d19), Math_fround(d20), i21 | 0, i22 | 0, i23 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, Math_fround(d9), Math_fround(d10), Math_fround(d11), Math_fround(d12), i14 | 0, i15 | 0, i16 | 0) | 0;
 return ftCall_iiiiiiffiiiiiiiiiffffiii(i24 | 0, i1 | 0, i2 | 0, i13 | 0, i17 | 0, i18 | 0, +d19, +d20, i21 | 0, i22 | 0, i23 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, +d9, +d10, +d11, +d12, i14 | 0, i15 | 0, i16 | 0) | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcjj(i3, i10, i1, i4) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 & 255;
 if (i2 >>> 0 < i1 >>> 0 | (i2 - i1 | 0) >>> 0 < i4 >>> 0) i1 = -1; else if (i4) {
  i9 = i3 + i2 | 0;
  i8 = i10 + i4 | 0;
  i1 = i3 + i1 | 0;
  i7 = i9;
  L8 : do if ((i7 - i1 | 0) < (i4 | 0)) i1 = i7; else {
   i6 = i9 + (1 - i4) | 0;
   while (1) {
    while (1) {
     i5 = i1;
     if ((i5 | 0) == (i6 | 0)) {
      i1 = i7;
      break L8;
     }
     if ((HEAP8[i5 >> 0] | 0) == (HEAP8[i10 >> 0] | 0)) {
      i2 = i10;
      i4 = i5;
      break;
     }
     i1 = i5 + 1 | 0;
    }
    do {
     i2 = i2 + 1 | 0;
     if ((i2 | 0) == (i8 | 0)) break L8;
     i4 = i4 + 1 | 0;
    } while ((HEAP8[i4 >> 0] | 0) == (HEAP8[i2 >> 0] | 0));
    i1 = i5 + 1 | 0;
   }
  } while (0);
  i1 = (i1 | 0) == (i9 | 0) ? -1 : i1 - i3 | 0;
 }
 return i1 | 0;
}

function __ZN7Terrain17SetLegacySpecularERK11ColorRGBA32(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i6 = 0, i7 = 0;
 i2 = i5 + 100 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = i6 & 255;
 if ((i4 & 255) << 24 >> 24 == i7 << 24 >> 24) if (!((i4 >>> 24 & 255) << 24 >> 24 != (i6 >>> 24 & 255) << 24 >> 24 | ((i4 >>> 16 & 255) << 24 >> 24 != (i6 >>> 16 & 255) << 24 >> 24 ? 1 : ((i4 & 65535) >>> 8 & 255) << 24 >> 24 != ((i6 & 65535) >>> 8 & 255) << 24 >> 24))) return;
 HEAP32[i2 >> 2] = i6;
 i4 = HEAP32[i5 + 112 >> 2] | 0;
 if (!i4) return;
 f3 = Math_fround(HEAPF32[i5 + 104 >> 2]);
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 255) << 24 >> 24 == i7 << 24 >> 24) if (!((i2 >>> 24 & 255) << 24 >> 24 != (i6 >>> 24 & 255) << 24 >> 24 | ((i2 >>> 16 & 255) << 24 >> 24 != (i6 >>> 16 & 255) << 24 >> 24 ? 1 : ((i2 & 65535) >>> 8 & 255) << 24 >> 24 != ((i6 & 65535) >>> 8 & 255) << 24 >> 24))) if (!(Math_fround(HEAPF32[i4 + 24 >> 2]) != f3)) return;
 HEAP32[i1 >> 2] = i6;
 HEAPF32[i4 + 24 >> 2] = f3;
 __ZN14SplatMaterials15UpdateMaterialsEv(i4);
 return;
}

function __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i7, i1, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i4 = i7 + 876 | 0;
 i5 = i7 + 876 + (i1 << 3) | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) if (!(HEAP32[i5 >> 2] | 0)) return;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 if ((HEAP32[i7 + 876 + (i1 << 3) + 4 >> 2] | 0) == (i8 | 0)) if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) return;
 i6 = __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(HEAP32[i7 + 860 >> 2] | 0, i1) | 0;
 if ((i6 | 0) == 36160) {
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i3;
  i5 = i7 + 884 | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i3;
 } else {
  i4 = i3;
  i1 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i2 = HEAP32[i7 + 544 >> 2] | 0;
 if (!i1) i9 = 10; else if ((HEAP32[i7 + 1988 >> 2] | 0) == (i8 | 0)) i9 = 10; else i1 = -1;
 mftCall_vii(i2 | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN5physx32PxHeightFieldDescGeneratedValuesC2EPKNS_17PxHeightFieldDescE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f6 = f0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 < 2 | i1 >>> 0 < 2) i3 = 0; else if ((HEAP32[i4 + 8 >> 2] | 0) == 1) if ((HEAP32[i4 + 12 >> 2] | 0) >>> 0 < 4) i3 = 0; else if (Math_fround(HEAPF32[i4 + 24 >> 2]) < Math_fround(0.0)) i3 = 0; else {
  i3 = HEAP16[i4 + 28 >> 1] | 0;
  if ((i3 & 1) << 16 >> 16 == i3 << 16 >> 16) {
   f6 = Math_fround(HEAPF32[i4 + 20 >> 2]);
   i3 = !(f6 > Math_fround(8507058669999999534545717.0e13)) & !(f6 < Math_fround(-8507058669999999534545717.0e13)) & 1;
  } else i3 = 0;
 } else i3 = 0;
 HEAP8[i5 >> 0] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 8 >> 2];
 i1 = i4 + 12 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP16[i5 + 32 >> 1] = HEAP16[i4 + 28 >> 1] | 0;
 return;
}

function __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb(i3, i5, i2) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = i3 + 156 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 if (i2) {
  HEAP32[i3 + 140 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i3 + 128 >> 2] = HEAP32[i1 + 32 >> 2];
  HEAP32[i3 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i3 + 136 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i3 + 120 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i3 + 124 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i3 + 112 >> 2] = HEAP32[i1 + 56 >> 2];
  HEAP32[i3 + 116 >> 2] = HEAP32[i1 + 60 >> 2];
 }
 i3 = i5 + 280 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = i5 + 292 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i1;
 i1 = i5 + 284 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 1;
 if ((i3 | 0) >= ((HEAP32[i5 + 276 >> 2] | 0) * 50 | 0)) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i5);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE(i9, i7, i8) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(i8) | 0;
 i6 = __ZNK5physx2Sc8ShapeSim8getRbSimEv(i8) | 0;
 i6 = (HEAP8[i6 + 50 >> 0] | 0) == 0 ? 0 : (HEAP32[i6 + 56 >> 2] | 0) + 2 | 0;
 if (!i1) {
  i1 = 1073741823;
  i2 = 0;
  i3 = 0;
  i4 = 1073741823;
 } else {
  i4 = i1 + 132 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = 0;
  i3 = 0;
  i4 = HEAP32[i4 + 4 >> 2] | 0;
 }
 i11 = HEAP32[HEAP32[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i8) | 0) + 52 >> 2] >> 2] | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = i1 | i2;
 HEAP32[i12 + 4 >> 2] = i3 | i4;
 __ZN5physx2Sc8ShapeSim20createLowLevelVolumeEjRKNS_9PxBounds3EjNS_9AABBMgrIdE(i8, i6, i7, i11, i5);
 i9 = (HEAP32[(HEAP32[HEAP32[i9 + 1104 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 24 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 STACKTOP = i10;
 return;
}

function __ZN5physx2Sc10NPhaseCore30createElementInteractionMarkerERNS0_10ElementSimES3_(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i2 = i5 + 1916 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i5 + 1624 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i5 + 1904 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i5 = i5 + 1908 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (!i1) {
  i5 = 0;
  __ZN5physx2Sc24ElementInteractionMarker10initializeEv(i5);
  return i5 | 0;
 }
 HEAP32[i1 >> 2] = gb + 101220 + 8;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 1;
 i5 = i1 + 8 | 0;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i5, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, 3, 5);
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = i4;
 HEAP32[i1 >> 2] = gb + 101244 + 8;
 HEAP32[i5 >> 2] = gb + 101244 + 52;
 i5 = i1;
 __ZN5physx2Sc24ElementInteractionMarker10initializeEv(i5);
 return i5 | 0;
}

function __ZN12ScriptMapper9AddShaderER6Shader(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3 + 4 | 0;
 i6 = i3;
 i9 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0) | 0;
 i7 = HEAP8[i9 + 11 >> 0] | 0;
 i10 = i7 << 24 >> 24 < 0;
 i8 = i10 ? HEAP32[i9 >> 2] | 0 : i9;
 i7 = i10 ? HEAP32[i9 + 4 >> 2] | 0 : i7 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i8, i7);
 HEAP32[i6 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE3AddERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEES4_(i1 + 32 | 0, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function _tt_cmap14_variants(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 i8 = HEAP32[i2 + 16 >> 2] | 0;
 i6 = i1 + 1 | 0;
 i7 = i2 + 28 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 do if (i4 >>> 0 < i6 >>> 0) {
  HEAP32[i2 + 36 >> 2] = i3;
  i10 = i2 + 32 | 0;
  i2 = _UNITY_ft_mem_realloc(i3, 4, i4, i6, HEAP32[i10 >> 2] | 0, i5) | 0;
  HEAP32[i10 >> 2] = i2;
  if (!(HEAP32[i5 >> 2] | 0)) {
   HEAP32[i7 >> 2] = i6;
   i4 = i2;
   break;
  }
  i10 = 0;
  STACKTOP = i9;
  return i10 | 0;
 } else i4 = HEAP32[i2 + 32 >> 2] | 0; while (0);
 if (!i1) i1 = 0; else {
  i2 = i8 + 10 | 0;
  i3 = 0;
  while (1) {
   HEAP32[i4 + (i3 << 2) >> 2] = (HEAPU8[i2 + 1 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) << 16 | (HEAPU8[i2 + 2 >> 0] | 0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 11 | 0;
  }
 }
 HEAP32[i4 + (i1 << 2) >> 2] = 0;
 i10 = i4;
 STACKTOP = i9;
 return i10 | 0;
}

function _jpeg_read_raw_data(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i1 | 0) != 206) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i4 = i5 + 120 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 + 96 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 123;
  mftCall_vii(HEAP32[i7 + 4 >> 2] | 0, i5 | 0, -1);
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 if (i3 | 0) {
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = i2;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i5 | 0);
 }
 i1 = Math_imul(HEAP32[i5 + 280 >> 2] | 0, HEAP32[i5 + 276 >> 2] | 0) | 0;
 if (i1 >>> 0 > i7 >>> 0) {
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 23;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i5 | 0);
 }
 if (!(mftCall_iii(HEAP32[(HEAP32[i5 + 392 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i6 | 0) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
 i7 = i1;
 return i7 | 0;
}

function __ZNSt3__26vectorI9UnityGUIDNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 4) + 1 | 0;
 if (i3 >>> 0 > 268435455) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 3;
 i4 = i6 >> 4 >>> 0 < 134217727 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 268435455;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 4) | 0;
 i5 = i6 + (i2 - i1 >> 4 << 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 4) << 4) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 16;
 HEAP32[i8 >> 2] = i6 + (i4 << 4);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK10GameObject8IsActiveEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 55 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 L1 : do if (i1 << 24 >> 24 == -1) {
  if (!(HEAP8[i3 + 54 >> 0] | 0)) i1 = 0; else i1 = ((HEAP32[i3 + 8 >> 2] | 0) >>> 20 & 1 ^ 1) & 255;
  HEAP8[i7 >> 0] = i1;
  i2 = HEAP32[i3 + 28 >> 2] | 0;
  i6 = HEAP32[i3 + 40 >> 2] | 0;
  i4 = i2 + (i6 << 3) | 0;
  if (i6) {
   i5 = HEAP32[gb + 28940 + 24 >> 2] | 0;
   i6 = HEAP32[gb + 28940 + 28 >> 2] | 0;
   i3 = i2;
   while (1) {
    if (((HEAP32[i3 >> 2] | 0) - i5 | 0) >>> 0 < i6 >>> 0) break;
    i3 = i3 + 8 | 0;
    if ((i3 | 0) == (i4 | 0)) break L1;
   }
   if (HEAP32[i3 + 4 >> 2] | 0) {
    while (1) if (((HEAP32[i2 >> 2] | 0) - i5 | 0) >>> 0 < i6 >>> 0) break; else i2 = i2 + 8 | 0;
    i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 100 >> 2] | 0;
    if (i2) {
     i2 = HEAP32[i2 + 28 >> 2] | 0;
     if (i2) {
      if (!(i1 << 24 >> 24)) i1 = 0; else i1 = (__ZNK10GameObject8IsActiveEv(i2) | 0) & 1;
      HEAP8[i7 >> 0] = i1;
     }
    }
   }
  }
 } while (0);
 return i1 << 24 >> 24 != 0 | 0;
}

function __ZN14VelocityModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83400 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14SpriteRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3, i4);
 __ZN4PPtrI6SpriteE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 340 | 0, i4);
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i3 + 344 | 0, i4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 i1 = i3 + 360 | 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i3 + 361 | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN14RotationModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83352 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj(i6, i7, i8, i1, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) return;
 HEAP32[i6 + 7380 >> 2] = 15471;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 608 >> 2] | 0, i6 | 0);
 i6 = i6 + 4620 | 0;
 __ZN7ApiGLES22BindElementArrayBufferEj(i6, HEAP32[(HEAP32[i8 + 28 >> 2] | 0) + 4 >> 2] | 0);
 __ZN7ApiGLES20DrawElementsIndirectE16GfxPrimitiveTypejj(i6, i7, HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i9);
 return;
}

function __ZN10GUITexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 385875 | 0, 20) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 36436 + 8;
 HEAP32[i4 + 52 >> 2] = 0;
 i2 = i4 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = __ZN7Texture21GetMasterTextureLimitEv() | 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN10FileSystemC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63552 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63552 | 0, 16, gb + 491603 | 0, 66) | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 25584 + 8;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 491603 | 0, 71) | 0;
 __ZN16MemoryFileSystemC2EPKc(i3, HEAP32[gb + 70824 >> 2] | 0);
 HEAP32[i1 + 12 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z56ParticleSystem_MainModule_CUSTOM_SetStartDelayMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 i1 = __ZN14ParticleSystem18GetStartDelayCurveEv(i1) | 0;
 HEAPF32[i1 + 80 >> 2] = f2;
 HEAP8[i1 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i1 + 88 | 0, f2, HEAP16[i1 + 84 >> 1] | 0) | 0) & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi(i1, i6, i2, i7, i3, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i2 + (i6 * 20 | 0) + 12 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i1 = i3 + (i6 << 3) | 0;
 if ((HEAP16[i3 + (i6 << 3) + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(i1, i4);
  i3 = i1;
 } else i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 648 >> 2] | 0, i4 | 0, i1 | 0);
 i1 = HEAP32[i2 + (i6 * 20 | 0) >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN22RenderingCommandBuffer20FlattenCommandBufferER17ShaderPassContextR15RenderNodeQueue(HEAP32[i1 >> 2] | 0, 0, i7);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i7 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 652 >> 2] | 0, i7 | 0);
 if (!i3) return;
 __Z12profiler_endP19ProfilerInformation(i3);
 return;
}

function __ZN8JSONRead8TransferI4AABBEEvRT_PKc17TransferMetaFlagsb(i6, i7, i2, i8, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = i6 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 if (!((i8 & 524288 | 0) == 0 | (HEAP32[i6 >> 2] & 2 | 0) == 0)) return;
 i3 = i6 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  if (!i4) return;
  if ((HEAP32[i4 + 16 >> 2] | 0) != 3) return;
 }
 i9 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i6, i4, i2) | 0;
 HEAP32[i3 >> 2] = i9;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1034406;
 if (i9 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i6, i8);
  __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(i6, i7, gb + 1034411 | 0, 0, 0);
  __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(i6, i7 + 12 | 0, gb + 1034420 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i9 = i6 + 56 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 0;
 HEAP8[i1 + 41 >> 0] = 1;
 if (!(__Z20GetPhysicsManagerPtrv() | 0)) {
  f9 = Math_fround(0.0);
  i8 = i1 + 56 | 0;
  HEAPF32[i8 >> 2] = f9;
  STACKTOP = i4;
  return;
 }
 f9 = Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
 i8 = i1 + 56 | 0;
 HEAPF32[i8 >> 2] = f9;
 STACKTOP = i4;
 return;
}

function __ZN12b2BroadPhaseC2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = -1;
 i5 = i4 + 12 | 0;
 HEAP32[i5 >> 2] = 16;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z7b2Alloci(576) | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 _memset(i1 | 0, 0, (HEAP32[i5 >> 2] | 0) * 36 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = 0;
  do {
   i3 = i2;
   i2 = i2 + 1 | 0;
   HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] = i2;
   HEAP32[i1 + (i3 * 36 | 0) + 32 >> 2] = -1;
   i3 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } else {
  i3 = i1 + -1 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] = -1;
 HEAP32[i1 + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 36 | 0) + 32 >> 2] = -1;
 i5 = i4 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 16;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = __Z7b2Alloci(128) | 0;
 HEAP32[i4 + 36 >> 2] = 16;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = __Z7b2Alloci(64) | 0;
 return;
}

function __ZN12_GLOBAL__N_127ConvertUncompressedMipLevelE13TextureFormatS0_iiiPKvPv(i2, i3, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13 + 20 | 0;
 i11 = i13;
 i12 = __Z18CalculateImageSizeii13TextureFormat(i5, i6, i2) | 0;
 i4 = __Z18CalculateImageSizeii13TextureFormat(i5, i6, i3) | 0;
 if ((i7 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i1 = 0;
 do {
  i15 = i8 + (Math_imul(i1, i12) | 0) | 0;
  i14 = i9 + (Math_imul(i1, i4) | 0) | 0;
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i10, i5, i6, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i5, i2) | 0, i2, i15);
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i11, i5, i6, __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i5, i3) | 0, i3, i14);
  __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i11, i10, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 STACKTOP = i13;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcb(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = (_strlen(i2) | 0) + 1 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i3 = i6 + 40 | 0;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 4;
 HEAP8[i6 + 8 >> 0] = i4 & 1;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i10 = 1;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN11TerrainData13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1467388 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467388 | 0, i1);
  i1 = gb + 1467388 | 0;
 } else i1 = 0;
 i2 = i5 + 32 | 0;
 __ZN13SplatDatabase16CheckConsistencyEv(i2);
 i3 = HEAP32[i5 + 56 >> 2] | 0;
 if (!i3) i6 = 6; else if (!(HEAP32[i3 + 4 >> 2] | 0)) __ZN13SplatDatabase13UploadBasemapEv(i2); else i6 = 6;
 if ((i6 | 0) == 6) __ZN13SplatDatabase18RecalculateBasemapEb(i2, 0);
 __ZN14DetailDatabase17RefreshPrototypesEv(i5 + 128 | 0);
 __ZN12TreeDatabase17RefreshPrototypesEv(i5 + 84 | 0);
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i5, 8);
 __ZN9Heightmap13AwakeFromLoadEv(i5 + 248 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i4, i8 + 20 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm(i4, i5, i6, i1, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 4 | 0;
 i9 = i10;
 i1 = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 HEAP32[i3 >> 2] = i1;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i11 = __THREW__;
 __THREW__ = 0;
 if (i11 & 1) {
  i11 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  ___resumeException(i11 | 0);
 } else {
  __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i4, i8 + 20 | 0, i5, i3, i7, i2);
  STACKTOP = i10;
  return HEAP32[i5 >> 2] | 0;
 }
 return 0;
}

function __ZNK10Collider2D7RaycastERK8Vector2ffiffP12RaycastHit2Di(i1, i2, f3, i4, f5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11 + 12 | 0;
 i10 = i11;
 if (!i8) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i12 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i13 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i10 + 4 >> 2] = i13;
 HEAPF32[i10 + 8 >> 2] = Math_fround(0.0);
 __ZNK9Transform14TransformPointERK8Vector3f(i9, i12, i10);
 i12 = __Z19GetPhysicsManager2Dv() | 0;
 i13 = HEAP32[i9 + 4 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i10 + 4 >> 2] = i13;
 i10 = __ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di(i12, i10, i2, f3, i4, f5, f6, i1, 1, i7, i8) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN9b2Simplex6Solve2Ev(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f1 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 f6 = Math_fround(f1 - f9);
 f7 = Math_fround(f5 - f8);
 f8 = Math_fround(Math_fround(f9 * f6) + Math_fround(f8 * f7));
 if (f8 >= Math_fround(-0.0)) {
  HEAPF32[i2 + 24 >> 2] = Math_fround(1.0);
  HEAP32[i2 + 108 >> 2] = 1;
  return;
 }
 f1 = Math_fround(Math_fround(f1 * f6) + Math_fround(f5 * f7));
 if (!(f1 <= Math_fround(0.0))) {
  f9 = Math_fround(Math_fround(1.0) / Math_fround(f1 - f8));
  HEAPF32[i2 + 24 >> 2] = Math_fround(f1 * f9);
  HEAPF32[i2 + 60 >> 2] = Math_fround(-Math_fround(f8 * f9));
  HEAP32[i2 + 108 >> 2] = 2;
  return;
 } else {
  HEAPF32[i2 + 60 >> 2] = Math_fround(1.0);
  HEAP32[i2 + 108 >> 2] = 1;
  i4 = i2;
  i2 = i2 + 36 | 0;
  i3 = i4 + 36 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
   i4 = i4 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i4 | 0) < (i3 | 0));
  return;
 }
}

function __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 66792 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN9SubModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 619592 | 0, HEAP32[gb + 37316 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3 + 12 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, gb + 619732 | 0, i4, 0);
 __ZN9SubModule14SubEmitterData8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx14NpRigidDynamic29wakeUpInternalNoKinematicTestERNS_3Scb4BodyEbb(i1, i7, i3, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[(__ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0) + 2876 >> 2]);
 i4 = i7 + 228 | 0;
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i7 + 232 | 0;
 i1 = f6 < f8 & i2;
 f6 = i1 ? f8 : f6;
 if (!(i1 | (i3 | i2) & (HEAP32[i5 >> 2] | 0) != 0)) return;
 switch ((HEAP32[i7 + 4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = 6;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i7 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 5; else i2 = 6;
   break;
  }
 default:
  i2 = 5;
 }
 if ((i2 | 0) == 5) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i7 + 16 | 0, f6, 1);
  return;
 } else if ((i2 | 0) == 6) {
  HEAP32[i5 >> 2] = 0;
  HEAPF32[i4 >> 2] = f6;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i7);
  i7 = i7 + 236 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN24MaterialDisplayListCache16CachedShaderPass11InsertEntryERKNS_17CachedShaderEntryE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 243 | 0;
 i7 = HEAPU8[i6 >> 0] | 0;
 i2 = i7 & 127;
 i3 = i5 + (i2 * 60 | 0) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i8 = i4 + 4 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
  if (!(HEAP32[i8 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63304 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i2 = i5 + (i2 * 60 | 0) + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = i3 + 60 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i8 = i5 + 242 | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
 i6 = i5 + 241 | 0;
 HEAP8[i8 >> 0] = HEAP8[i6 >> 0] | 0;
 i8 = i5 + 240 | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i7 | 128;
 return;
}

function __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!(HEAP8[i10 + 21 >> 0] | 0)) return;
 i8 = i10 + 12 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i4 = i9 + 1 | 0;
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i3 = i6 << 1;
  i3 = (i3 | 0) == 0 ? 1 : i3;
  if (i7 >>> 0 < i3 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i3;
   HEAP32[i10 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i10 >> 2] | 0, i3 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3 << 3, 4, i10 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i10 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = i3;
   HEAP32[i10 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i4;
 i10 = HEAP32[i10 >> 2] | 0;
 HEAP32[i10 + (i9 << 3) >> 2] = i1;
 HEAP32[i10 + (i9 << 3) + 4 >> 2] = i2;
 return;
}

function __ZN18AudioMixerSnapshot8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i2, i5);
 i3 = i2 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863864 | 0, gb + 863877 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI10AudioMixerE8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 863961 | 0, gb + 863904 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN13BatchRenderer15ApplyShaderPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEi13BatchingFlagsbPKNS7_10GrabPassesE(i8, i2, i3, i9, i4, i5, i1, i10, i6) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i1 = __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms(i3, i2, i9, i4, i5, (HEAP32[i4 + 744 >> 2] | 0) == 0, i6, i1) | 0;
 HEAP32[i8 + 184 >> 2] = i1;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 >> 2] & 1;
 i8 = i8 + 188 | 0;
 i10 = i1 | (i10 & 1) << 1 & 255 | HEAP8[i8 >> 0] & -4;
 HEAP8[i8 >> 0] = i10;
 HEAP8[i8 >> 0] = (HEAP32[(HEAP32[i9 + 32 >> 2] | 0) + 64 >> 2] & 255) << 2 & 12 | i10 & -13;
 STACKTOP = i7;
 return;
}

function __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800860 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 56 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 i1 = i1 + 60 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 800878 | 0, gb + 1048681 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i1, 4194305);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9Texture2DD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 45572 + 8;
 i1 = i3 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i6 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 __ZN9Texture2D16DeleteGfxTextureEv(i3);
 i1 = i3 + 128 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  HEAP32[i3 >> 2] = gb + 32336 + 8;
  i6 = i3 + 28 | 0;
  __ZN14ConstantStringD2Ev(i6);
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 + 140 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i4);
 HEAP32[i3 >> 2] = gb + 32336 + 8;
 i6 = i3 + 28 | 0;
 __ZN14ConstantStringD2Ev(i6);
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN30VelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 868 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 868 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 868 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN30RotationModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 856 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 856 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 856 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN13MonoBehaviour26HandleCoroutineReturnValueE21ScriptingMethodIl2CppP12Il2CppObject(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 24 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = i10;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i1;
 i9 = (__Z14GetMonoManagerv() | 0) + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 if (!(__Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses(i7, i9) | 0)) {
  i10 = 0;
  STACKTOP = i8;
  return i10 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i10 = i6;
 HEAP32[i10 >> 2] = i2;
 HEAP32[i10 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i3, i4, i7, i5) | 0;
 i10 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i8;
 return i10 | 0;
}

function __ZN12CullingGroupC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = i5;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN12CullingGroup4InitEv(i1);
 STACKTOP = i2;
 return;
}

function __ZN11ForceModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83432 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z29Font_Get_Custom_PropFontNamesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 i1 = i3 + 100 | 0;
 i4 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0;
 i3 = i3 + 104 | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, (HEAP32[i3 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 4) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) return i4 | 0; else i2 = 0;
 while (1) {
  i5 = HEAP8[i1 + 11 >> 0] | 0;
  i6 = i5 << 24 >> 24 < 0;
  __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i4, i2, __Z20scripting_string_newPKcj(i6 ? HEAP32[i1 >> 2] | 0 : i1, i6 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0);
  i1 = i1 + 16 | 0;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) break; else i2 = i2 + 1 | 0;
 }
 return i4 | 0;
}

function _UNITY_FT_Sin(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) < -2949120) {
  i3 = 0;
  i1 = 14408027;
  while (1) {
   i1 = 0 - i1 | 0;
   i2 = i2 + 5898240 | 0;
   if ((i2 | 0) < -2949120) {
    i7 = i3;
    i3 = i1;
    i1 = i7;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    break;
   }
  }
 } else if ((i2 | 0) > 2949120) {
  i1 = 0;
  i4 = 14408027;
  while (1) {
   i3 = 0 - i1 | 0;
   i2 = i2 + -5898240 | 0;
   if ((i2 | 0) > 2949120) {
    i1 = i4;
    i4 = i3;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    i1 = i4;
    break;
   }
  }
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i3 = 14408027;
  i1 = 0;
 }
 while (1) {
  i4 = i1 + i5 >> i6;
  if ((i2 | 0) < 0) {
   i1 = i1 - (i3 + i5 >> i6) | 0;
   i3 = i4 + i3 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i1 = (i3 + i5 >> i6) + i1 | 0;
   i3 = i3 - i4 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
  }
 }
 return i1 + 128 >> 8 | 0;
}

function _UNITY_FT_Cos(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((i2 | 0) < -2949120) {
  i3 = 0;
  i1 = 14408027;
  while (1) {
   i1 = 0 - i1 | 0;
   i2 = i2 + 5898240 | 0;
   if ((i2 | 0) < -2949120) {
    i7 = i3;
    i3 = i1;
    i1 = i7;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    break;
   }
  }
 } else if ((i2 | 0) > 2949120) {
  i1 = 0;
  i4 = 14408027;
  while (1) {
   i3 = 0 - i1 | 0;
   i2 = i2 + -5898240 | 0;
   if ((i2 | 0) > 2949120) {
    i1 = i4;
    i4 = i3;
   } else {
    i5 = 1;
    i6 = 1;
    i7 = gb + 186464 | 0;
    i1 = i4;
    break;
   }
  }
 } else {
  i5 = 1;
  i6 = 1;
  i7 = gb + 186464 | 0;
  i3 = 14408027;
  i1 = 0;
 }
 while (1) {
  i4 = i1 + i5 >> i6;
  if ((i2 | 0) < 0) {
   i1 = i1 - (i3 + i5 >> i6) | 0;
   i3 = i4 + i3 | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + i2 | 0;
  } else {
   i1 = (i3 + i5 >> i6) + i1 | 0;
   i3 = i3 - i4 | 0;
   i2 = i2 - (HEAP32[i7 >> 2] | 0) | 0;
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 23) break; else {
   i5 = i5 << 1;
   i7 = i7 + 4 | 0;
  }
 }
 return i3 + 128 >> 8 | 0;
}

function __ZNKSt3__211__libcpp_db17__find_c_and_lockEPv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i3 = i1 + 4 | 0;
 L1 : do if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) {
  __ZNSt3__212_GLOBAL__N_13mutEv();
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  i1 = 0;
 } else {
  HEAP32[i2 >> 2] = i4;
  i2 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i5 + 4 | 0, i2, 4) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + (((i2 >>> 0) % ((HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
  if (!i1) {
   __ZNSt3__212_GLOBAL__N_13mutEv();
   __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
   i1 = 0;
   break;
  }
  do {
   if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) break L1;
   i1 = HEAP32[i1 + 8 >> 2] | 0;
  } while ((i1 | 0) != 0);
  __ZNSt3__212_GLOBAL__N_13mutEv();
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  i1 = 0;
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK11AudioSource24EvaluateAttenuationCurveEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f4 = f0, f5 = f0;
 f2 = Math_fround(HEAPF32[(__Z15GetAudioManagerv() | 0) + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 400 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 396 >> 2]);
 switch (HEAP32[i3 + 416 >> 2] | 0) {
 case 1:
  {
   f2 = Math_fround(f4 - f5);
   if (!(f2 <= Math_fround(0.0))) f1 = Math_fround(Math_fround(f4 - f1) / f2); else f1 = Math_fround(1.0);
   break;
  }
 case 0:
  {
   if (f2 != Math_fround(1.0) & f5 < f1) f1 = Math_fround(f5 + Math_fround(f2 * Math_fround(f1 - f5)));
   i3 = f1 < Math_fround(9.99999997e-07);
   f1 = Math_fround(f5 / (i3 ? Math_fround(9.99999997e-07) : f1));
   break;
  }
 case 2:
  {
   if (f4 > Math_fround(0.0)) f1 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i3 + 300 | 0, Math_fround(f1 / f4), 0)); else f1 = Math_fround(1.0);
   break;
  }
 default:
  f1 = Math_fround(1.0);
 }
 i3 = f1 < Math_fround(0.0);
 f5 = i3 ? Math_fround(0.0) : f1;
 i3 = f5 > Math_fround(1.0);
 return Math_fround(i3 ? Math_fround(1.0) : f5);
}

function __ZN6Camera14StandaloneCullEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEER11CullResults(i5, i1, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i3 = i7 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = -1;
 HEAP32[i7 >> 2] = i5;
 i4 = i7 + 12 | 0;
 HEAP32[i4 >> 2] = 5;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 if (HEAP8[i5 + 1089 >> 0] | 0) HEAP32[i4 >> 2] = 7;
 if (!i1) {
  __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i5, i7, i6);
  STACKTOP = i9;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255) | 0)) i1 = -1; else i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0;
 HEAP32[i8 >> 2] = i1;
 __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i5, i7, i6);
 STACKTOP = i9;
 return;
}

function __ZN5physx2Sc8BodyCore10putToSleepEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAP32[i3 + 88 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 i2 = i3 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = (i4 | 0) != 0;
 if (i5) {
  __ZN5physx2Sc7BodySim30notifyClearSpatialAccelerationEv(i4);
  __ZN5physx2Sc7BodySim26notifyClearSpatialVelocityEv(i4);
 }
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (i1 | 0) if (!(HEAP8[i1 + 31 >> 0] | 0)) {
  HEAP32[i1 + 48 >> 2] = 0;
  HEAP32[i1 + 52 >> 2] = 0;
  HEAP32[i1 + 56 >> 2] = 0;
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 24 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
 }
 HEAPF32[i3 + 152 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim18postSetWakeCounterEfb(i1, Math_fround(0.0), 0);
 if (!i5) return;
 __ZN5physx2Sc7BodySim10putToSleepEv(i4);
 return;
}

function __ZN5physx27InternalTriangleMeshBuilder14fillRemapTableEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[(HEAP32[i4 >> 2] | 0) + 164 >> 2] | 0);
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 + 164 >> 2] = 0;
 i5 = i2 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 >>> 0 > 1073741823 ? -1 : i1 << 2;
 if (!i3) i3 = 0; else {
  i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
  i2 = _PxGetFoundation() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i3 = mftCall_iiiiii(i7 | 0, i1 | 0, i3 | 0, (i2 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 730919 | 0, 128) | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i2 + 164 >> 2] = i3;
 if (!i1) {
  STACKTOP = i6;
  return;
 } else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra13MatrixFactory5orthoEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f8 = Math_fround(f3 - f2);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(2.0) / f8);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 f10 = Math_fround(f5 - f4);
 f9 = Math_fround(Math_fround(2.0) / f10);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f9;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 f9 = Math_fround(f7 - f6);
 f11 = Math_fround(Math_fround(-2.0) / f9);
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = f11;
 HEAP32[i1 + 56 >> 2] = 0;
 f5 = Math_fround(Math_fround(-Math_fround(f4 + f5)) / f10);
 f7 = Math_fround(Math_fround(-Math_fround(f6 + f7)) / f9);
 HEAPF32[i1 + 12 >> 2] = Math_fround(Math_fround(-Math_fround(f2 + f3)) / f8);
 HEAPF32[i1 + 28 >> 2] = f5;
 HEAPF32[i1 + 44 >> 2] = f7;
 HEAP32[i1 + 60 >> 2] = -1082130432;
 return;
}

function __ZN4FMOD13ChannelGroupI7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  STACKTOP = i4;
  return 0;
 } else {
  i6 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] << 2) >> 2] | 0;
  i1 = i6 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i1 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  i3 = i2 + 144 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i2 + 140;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i1;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 136 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i2 + 132 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  STACKTOP = i4;
  return 0;
 }
 return 0;
}

function __ZN15FrictionJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 __ZN7Joint2D16CheckConsistencyEv(i2);
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 84 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i5 = gb + 1162356 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i5 = i2 + 96 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f6;
 i5 = i2 + 100 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f6;
 return;
}

function __ZN12ImageFilters17SwitchTargetToLDREP13RenderTexture(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __Z22GetRenderBufferManagerv() | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 704 >> 2] | 0, i2 | 0) | 0;
 i4 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i4, -1, -1, 0, i2, 0, 0, HEAP32[i4 + 24 >> 2] | 0, 1) | 0;
 if (i4 | 0) {
  __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i4, 1);
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, gb + 375803 | 0);
 }
 i2 = i1 + 24 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i3);
  HEAP32[i2 >> 2] = i4;
  return i4 | 0;
 }
 i1 = i1 + 28 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) == (i3 | 0);
 __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i3);
 if (!i2) return i4 | 0;
 HEAP32[i1 >> 2] = i4;
 return i4 | 0;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = (_strlen(i2) | 0) + 4 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i3 = i6 + 40 | 0;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 8 >> 2] = i4;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i10 = 1;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = (_strlen(i2) | 0) + 4 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i3 = i6 + 40 | 0;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = i4;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i10 = 1;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN10SizeModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83336 + 8;
 i1 = i2 + 768 | 0;
 if ((HEAP32[i2 + 784 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 772 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z21OrthoNormalVectorFastRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if ((i5 ? f4 : f3) > Math_fround(.707106769)) {
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f6 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)))));
  f4 = Math_fround(f6 * f4);
  f3 = Math_fround(-Math_fround(f6 * f3));
  f6 = Math_fround(0.0);
  HEAPF32[i1 >> 2] = f6;
  i5 = i1 + 4 | 0;
  HEAPF32[i5 >> 2] = f3;
  i5 = i1 + 8 | 0;
  HEAPF32[i5 >> 2] = f4;
  return;
 } else {
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  f3 = Math_fround(f4 * f4);
  f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f7 * f7)))));
  f6 = Math_fround(0.0);
  f4 = Math_fround(f3 * f4);
  f3 = Math_fround(-Math_fround(f7 * f3));
  HEAPF32[i1 >> 2] = f3;
  i5 = i1 + 4 | 0;
  HEAPF32[i5 >> 2] = f4;
  i5 = i1 + 8 | 0;
  HEAPF32[i5 >> 2] = f6;
  return;
 }
}

function __ZNSt3__211__libcpp_db16__invalidate_allEPv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i3 = i1 + 4 | 0;
 L1 : do if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
  HEAP32[i2 >> 2] = i4;
  i2 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i5 + 4 | 0, i2, 4) | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + (((i2 >>> 0) % ((HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
  if (i1 | 0) {
   while (1) {
    if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) break;
    i1 = HEAP32[i1 + 8 >> 2] | 0;
    if (!i1) break L1;
   }
   i3 = i1 + 16 | 0;
   i1 = HEAP32[i1 + 12 >> 2] | 0;
   i2 = HEAP32[i3 >> 2] | 0;
   while (1) {
    if ((i2 | 0) == (i1 | 0)) break L1;
    i4 = i2 + -4 | 0;
    HEAP32[i3 >> 2] = i4;
    HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] = 0;
    i2 = i4;
   }
  }
 } while (0);
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 STACKTOP = i5;
 return;
}

function __ZN9Transform11SetRotationERK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i6 = i3;
 i4 = i3 + 8 | 0;
 i7 = i1 + 32 | 0;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 i9 = i6;
 HEAP32[i9 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 + 4 >> 2] = i8;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = HEAP32[i2 + 8 >> 2] | 0;
 i7 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i9;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i4 + 12 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (!(__Z10SetGlobalR15TransformAccessRKN4math7_float4E(i5, i4) | 0)) {
  STACKTOP = i3;
  return;
 }
 i9 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i9 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 2);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN9RigidbodyC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 113356 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i1;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 81 >> 0] = 1;
 HEAP8[i1 + 82 >> 0] = 1;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP8[i1 + 100 >> 0] = 1;
 HEAP8[i1 + 101 >> 0] = 1;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZN9CGProgramC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 68632 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Cct13BoxController15setFootPositionERKNS_14PxExtendedVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 f5 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 + 52 >> 2]));
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * f5);
 f6 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 40 >> 2]));
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF64[i4 >> 3] = +f7 + +HEAPF64[i4 >> 3];
 i1 = i4 + 8 | 0;
 HEAPF64[i1 >> 3] = +f6 + +HEAPF64[i1 >> 3];
 i1 = i4 + 16 | 0;
 HEAPF64[i1 >> 3] = +f5 + +HEAPF64[i1 >> 3];
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN12MeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(384, i1, 16, gb + 1048932 | 0, 0, gb + 428790 | 0, 19) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i4, 1, i5, i2);
 HEAP32[i4 >> 2] = gb + 58344 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 58344 + 188;
 HEAP32[i4 + 340 >> 2] = 0;
 HEAP32[i4 + 344 >> 2] = 0;
 HEAP8[i4 + 348 >> 0] = 0;
 HEAP32[i4 + 352 >> 2] = 0;
 HEAP32[i4 + 356 >> 2] = 0;
 HEAP32[i4 + 360 >> 2] = i4;
 HEAP32[i4 + 364 >> 2] = 0;
 HEAP32[i4 + 368 >> 2] = 0;
 HEAP32[i4 + 372 >> 2] = i4;
 HEAP32[i4 + 376 >> 2] = 0;
 HEAP32[i4 + 380 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z50AnimatorControllerPlayable_CUSTOM_GetIntegerStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0;
 i1 = mftCall_iiii(i7 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0, i4 | 0) | 0;
 if ((i1 | 0) == 1) {
  i7 = HEAP32[i4 >> 2] | 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i3);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i7, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i7 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z32Animation_CUSTOM_GetStateAtIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if ((i2 | 0) <= -1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 915324 | 0, i4);
 __ZN9Animation20BuildAnimationStatesEv(i3);
 i1 = i3 + 104 | 0;
 if (((HEAP32[i3 + 108 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 2 | 0) > (i2 | 0)) {
  __ZN9Animation20BuildAnimationStatesEv(i3);
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i4 = __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i4, HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 4 >> 2] | 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 915324 | 0, i4);
 return 0;
}

function __Z20CreateObjectFromCodeI19LowerResBlitTextureEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(88, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 HEAP32[i4 >> 2] = gb + 44916 + 8;
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _UNITY_png_check_IHDR(i10, i1, i2, i3, i4, i6, i7, i8) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i5 = 0, i9 = 0, i11 = 0;
 switch (i3 | 0) {
 case 1:
 case 2:
 case 4:
 case 8:
 case 16:
  {
   i1 = (i2 | i1 | 0) < 0 | ((HEAP32[i10 + 624 >> 2] | 0) >>> 0 < i1 >>> 0 ? 1 : (i2 + -1 | 0) >>> 0 >= (HEAP32[i10 + 628 >> 2] | 0) >>> 0) ? 1 : (i1 | 0) == 0 & 1;
   break;
  }
 default:
  i1 = 1;
 }
 i5 = i4 | 4;
 if ((i3 | 0) > 8 & (i4 | 0) == 3) i11 = 5; else if ((i3 | 0) < 8 & ((i4 | 0) == 4 | (i5 | 0) == 6)) i11 = 5; else i1 = i4 >>> 0 > 6 | (i5 | 0) == 5 ? 1 : i1;
 if ((i11 | 0) == 5) i1 = 1;
 i1 = (i7 | 0) == 0 ? ((i6 | 0) > 1 ? 1 : i1) : 1;
 i2 = HEAP32[i10 + 204 >> 2] & 4096;
 if (!i8) i9 = i1; else {
  if ((i8 | 0) == 64 ? (HEAP32[i10 + 596 >> 2] & 4 | 0) != 0 : 0) {
   if (!((i5 | 0) == 6 & (i2 | 0) == 0)) i11 = 9;
  } else i11 = 9;
  if ((i11 | 0) == 9) i1 = 1;
  if (!i2) i9 = i1; else _UNITY_png_error(i10, gb + 351907 | 0);
 }
 if ((i9 | 0) == 1) _UNITY_png_error(i10, gb + 351907 | 0); else return;
}

function __ZNK20TextRenderingPrivate8FontImpl10IsRectFreeERKNS0_7IntRectE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) < 0) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i6 | 0) < 0) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = (HEAP32[i1 + 8 >> 2] | 0) + i5 | 0;
 i2 = HEAP32[i3 + 180 >> 2] | 0;
 if ((i7 | 0) > (i2 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = (HEAP32[i1 + 12 >> 2] | 0) + i6 | 0;
 if ((i4 | 0) > (i2 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i3 + 132 >> 2] | 0;
 i3 = HEAP32[i3 + 136 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i7 = 1;
  return i7 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (((HEAP32[i1 + 8 >> 2] | 0) + i2 | 0) > (i5 | 0)) {
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   if (((i2 | 0) < (i7 | 0) ? ((HEAP32[i1 + 12 >> 2] | 0) + i8 | 0) > (i6 | 0) : 0) & (i8 | 0) < (i4 | 0)) {
    i1 = 0;
    i2 = 9;
    break;
   }
  }
  i1 = i1 + 16 | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN18ProfilerConnection17GetMemorySnapshotEPKvjj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i4 + 8 | 0;
 if ((HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0) != (i5 | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 i6 = i3 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = i3 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, gb + 63664 | 0);
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 __ZN15MemorySnapshots21CaptureMemorySnapshotER13dynamic_arrayIhLj1EE(i3);
 i2 = __ZN16PlayerConnection3GetEv() | 0;
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i2, HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0, 43, HEAP32[i3 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 if ((HEAP32[i5 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1);
  HEAP32[i3 >> 2] = 0;
 }
 STACKTOP = i4;
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI14SafeBinaryReadEEvRS6_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 479385 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i2, 1); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcd(i1, i2, d4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d4 = +d4;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 48 | 0;
 if (__ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc(i5, i2) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i3 = (_strlen(i2) | 0) + 8 | 0;
 i1 = i1 + 84 | 0;
 HEAP32[i1 >> 2] = i3 + (HEAP32[i1 >> 2] | 0);
 i1 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i3 = i6 + 40 | 0;
 i10 = gb + 63648 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP8[i6 + 20 >> 0] = 0;
 HEAP32[i6 >> 2] = 3;
 HEAPF64[i6 + 8 >> 3] = d4;
 __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE(i5, i2, i6);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i6 + 20 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 i10 = 1;
 STACKTOP = i7;
 return i10 | 0;
}

function __ZN11UmbraModule18AllocateVisibilityEPKN5Umbra4TomeEPiRK10MemLabelId(i2, i3, i1, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i4 = __ZNK5Umbra4Tome15getClusterCountEv(i3) | 0;
 i2 = __ZNK5Umbra4Tome14getObjectCountEv(i3) | 0;
 if (!i1) i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, gb + 64024 | 0, 0, gb + 612578 | 0, 146) | 0;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 16, i5, 0, gb + 612578 | 0, 148) | 0;
 i7 = __ZnwjRK10MemLabelIdiPKci(32, i5, 16, gb + 612578 | 0, 150) | 0;
 __ZN5Umbra9IndexListC2EPiii(i7, i1, i2, 0);
 i2 = __ZnwjRK10MemLabelIdiPKci(67584, i5, 16, gb + 612578 | 0, 151) | 0;
 __ZN5Umbra15OcclusionBufferC2Ev(i2);
 i3 = __ZnwjRK10MemLabelIdiPKci(128, i5, 16, gb + 612578 | 0, 152) | 0;
 __ZN5Umbra10VisibilityC2EPNS_9IndexListEPNS_15OcclusionBufferE(i3, i7, i2);
 i5 = __ZnwjRK10MemLabelIdiPKci(32, i5, 16, gb + 612578 | 0, 153) | 0;
 __ZN5Umbra9IndexListC2EPiii(i5, i6, i4, 0);
 __ZN5Umbra10Visibility17setOutputClustersEPNS_9IndexListE(i3, i5);
 return i3 | 0;
}

function __Z47Physics2D_CUSTOM_INTERNAL_CALL_LinecastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff(i2, i3, i4, i5, f6, f7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i1 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 36) | 0;
 i11 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZN16Physics2DManager8LinecastERK8Vector2fS2_iffPK10Collider2DbP12RaycastHit2Di(i11, i10, i9, i5, f6, f7, 0, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i8;
 return i3 | 0;
}

function __ZNSt3__211regex_errorC2ENS_15regex_constants10error_typeE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 do switch (i3 | 0) {
 case 1:
  {
   i1 = gb + 1083599 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 1083541 | 0;
   break;
  }
 case 3:
  {
   i1 = gb + 1083464 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 1083412 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 1083367 | 0;
   break;
  }
 case 6:
  {
   i1 = gb + 1083322 | 0;
   break;
  }
 case 7:
  {
   i1 = gb + 1083277 | 0;
   break;
  }
 case 8:
  {
   i1 = gb + 1083215 | 0;
   break;
  }
 case 9:
  {
   i1 = gb + 1083129 | 0;
   break;
  }
 case 10:
  {
   i1 = gb + 1083044 | 0;
   break;
  }
 case 11:
  {
   i1 = gb + 1082984 | 0;
   break;
  }
 case 12:
  {
   i1 = gb + 1082892 | 0;
   break;
  }
 case 13:
  {
   i1 = gb + 1082772 | 0;
   break;
  }
 case 14:
  {
   i1 = gb + 1082727 | 0;
   break;
  }
 case 15:
  {
   i1 = gb + 1082675 | 0;
   break;
  }
 default:
  i1 = gb + 1082656 | 0;
 } while (0);
 __ZNSt13runtime_errorC2EPKc(i2, i1);
 HEAP32[i2 >> 2] = gb + 214272 + 8;
 HEAP32[i2 + 8 >> 2] = i3;
 return;
}

function __ZN9ShaderLab4Pass7ReleaseEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i5 + 748 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 if (i4 | 0) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i5 + 772 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i1 = i5 + 776 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
  __ZdlPv(i3);
 }
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i5 + 756 | 0, HEAP32[i5 + 760 >> 2] | 0);
 i1 = i5 + 728 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 740 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 __ZN9ShaderLab11ShaderStateD2Ev(i5 + 4 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63280 | 0);
 STACKTOP = i7;
 return;
}

function __ZN26SizeModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 852 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 852 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 case 2:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 852 >> 2] | 0;
   HEAPF32[i3 + 616 >> 2] = f4;
   HEAP8[i3 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 536 | 0, i3 + 624 | 0, f4, HEAP16[i3 + 620 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN14TimerQueryGLES7MeasureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 mftCall_vi(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 788 >> 2] | 0, 35007);
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 1) | 0;
 getTempRet0() | 0;
 mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 784 >> 2] | 0, 35007, HEAP32[i2 + 16 >> 2] | 0);
 HEAP32[gb + 1098256 + 560 >> 2] = (HEAP32[gb + 1098256 + 560 >> 2] | 0) + 1;
 i3 = i2 + 4 | 0;
 if ((i3 | 0) == (gb + 1098256 + 544 | 0)) {
  i3 = i2 + 24 | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = -1;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = -1;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i2 + 8 | 0; else {
  i4 = i2 + 8 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[gb + 1098256 + 544 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = gb + 1098256 + 544;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 i4 = i2 + 24 | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = -1;
 i4 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = -1;
 return;
}

function __ZN8keywords7CleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1166252 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 4 | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = i3; else {
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63280 | 0);
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
     i1 = i2;
     break;
    } else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
   }
   i3 = HEAP32[gb + 1166252 >> 2] | 0;
   i2 = i3 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i3;
 }
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
  HEAP32[gb + 1166252 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166252 >> 2] = 0;
 return;
}

function __ZN7dtCrowd19SetObstacleCylinderERK13dtCrowdHandlePKfS4_S4_S4_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 + 416 >> 2] | 0;
 HEAP32[i1 + (i2 * 92 | 0) + 84 >> 2] = 1;
 HEAP32[i1 + (i2 * 92 | 0) + 24 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 28 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 32 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 48 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 52 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 56 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 60 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 64 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 68 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 72 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 76 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 80 >> 2] = HEAP32[i6 + 8 >> 2];
 __Z23CalcCapsuleWorldExtentsPfPKfS1_S1_S1_(i1 + (i2 * 92 | 0) + 36 | 0, i3, i4, i5, i6);
 return;
}

function __ZN5physx7NpScene16createBatchQueryERKNS_16PxBatchQueryDescE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i3 | 0, i2 | 0, 152, (i4 ? gb + 704996 | 0 : gb + 837976 | 0) | 0, gb + 678666 | 0, 3177) | 0;
 __ZN5physx12NpBatchQueryC2ERNS_7NpSceneERKNS_16PxBatchQueryDescE(i4, i6, i1);
 HEAP32[i5 >> 2] = i4;
 i1 = i6 + 3628 | 0;
 i2 = i6 + 3632 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 3636 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i7;
  return i4 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_12NpBatchQueryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1, i5) | 0;
  STACKTOP = i7;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx18PxsDynamicsContextD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 136 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 i1 = i2 + 156 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 120 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 112 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
   if (i1 | 0) {
    i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
   }
  }
 }
 i3 = HEAP32[i2 + 108 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 1040830 | 0, HEAP32[gb + 36972 >> 2] | 0, i2, 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 do if ((i1 | 0) > 0) {
  i2 = i4 + 16 | 0;
  i6 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = i6 + (HEAP32[(HEAP32[i4 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i4 + 36 >> 2] | 0, 0 - (HEAP32[i4 + 32 >> 2] | 0) | 0) | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (i1 >>> 0 >= i6 >>> 0) if ((i1 + 1 | 0) >>> 0 <= (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
   HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
   HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
   break;
  }
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1);
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 } while (0);
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN18ColorBySpeedModule8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i2, i5);
 i3 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620164 | 0, gb + 620954 | 0, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 164 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 620185 | 0, HEAP32[gb + 37320 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN15AudioMixerGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
 __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 52 | 0, i8);
 __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 56 | 0, i8);
 i7 = i1 + 44 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i2, 4);
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + (i7 << 2) | 0;
 if (!i7) {
  STACKTOP = i9;
  return;
 }
 do {
  __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i9;
 return;
}

function __ZL41AssemblyNameMatchesWithOrWithoutExtensionPKcS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 24 | 0;
 i4 = i6;
 i5 = i6 + 12 | 0;
 if (!(_strcmp(i1, i2) | 0)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i5);
 __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i3 = (_strcmp(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0) == 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = i3;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN8VRDevice25CreateEyeTextureResourcesEPvP17RenderSurfaceBaseS0_PS0_(i1, i4, i6, i2, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i11 + 4 | 0;
 i9 = i11;
 i3 = i11 + 8 | 0;
 i10 = i1 + 288 | 0;
 if (!(__ZN19VREyeTextureManager16SetRenderSurfaceEP17RenderSurfaceBasePiS2_Pb(HEAP32[i10 >> 2] | 0, i6, i8, i9, i3) | 0)) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i5 = (HEAP32[i6 + 20 >> 2] & 4 | 0) != 0;
 if (i2 | 0) HEAP8[i2 >> 0] = HEAP8[i3 >> 0] ^ 1;
 i1 = HEAP32[i1 + 220 >> 2] | 0;
 if (!i1) {
  i10 = 0;
  STACKTOP = i11;
  return i10 | 0;
 }
 i8 = HEAP32[i8 >> 2] | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 i10 = __ZNK19VREyeTextureManager22GetDeviceTextureFormatEv(HEAP32[i10 >> 2] | 0) | 0;
 i10 = mftCall_iiiiiiiiiii(i1 | 0, i8 | 0, i9 | 0, i10 | 0, i4 | 0, HEAP32[i6 + 4 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, HEAP32[i6 + 16 >> 2] | 0, i5 | 0, 0, i7 | 0) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEclERS4_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] << 3, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 3) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIN7mecanim8skeleton4NodeEEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN16MBPOS_TmpBuffers15allocateUpdatedEjj(i1, i7, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 12804 | 0;
 if ((HEAP32[i5 >> 2] | 0) >>> 0 >= i7 >>> 0) {
  STACKTOP = i8;
  return;
 }
 i6 = i1 + 12816 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 6144 | 0;
 if (!((i2 | 0) == (i3 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i8, i2);
  HEAP32[i6 >> 2] = 0;
 }
 i1 = i4 + i7 | 0;
 if (i1 >>> 0 < 257) HEAP32[i6 >> 2] = i3; else {
  i1 = i1 >>> 0 > 178956970 ? -1 : i1 * 24 | 0;
  if (!i1) i1 = 0; else {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
   i4 = _PxGetFoundation() | 0;
   i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
   i1 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 717435 | 0 : gb + 837976 | 0) | 0, gb + 717183 | 0, 1904) | 0;
  }
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function __Z38RectOffset_CUSTOM_INTERNAL_CALL_RemoveP12Il2CppObjectRK5RectTIfERS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  f7 = Math_fround(HEAP32[i1 >> 2] | 0);
  f9 = Math_fround(f4 + f7);
  f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(HEAP32[i1 + 8 >> 2] | 0);
  f8 = Math_fround(f8 + f4);
  f7 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f7);
  f7 = Math_fround(f7 - Math_fround(HEAP32[i1 + 4 >> 2] | 0));
  f4 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) - f4);
  f4 = Math_fround(f4 - Math_fround(HEAP32[i1 + 12 >> 2] | 0));
  HEAPF32[i3 >> 2] = f9;
  HEAPF32[i3 + 4 >> 2] = f8;
  HEAPF32[i3 + 8 >> 2] = f7;
  HEAPF32[i3 + 12 >> 2] = f4;
  STACKTOP = i6;
  return;
 }
}

function __Z29NeedUpdateLODGroupBoundingBoxRK8LODGroup(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i3 + 4 | 0;
 i2 = i3;
 __Z36CalculateLODGroupBoundsCenterAndSizeR8Vector3fRfRK8LODGroup(i8, i2, i1);
 f7 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 62452 >> 2]);
 f7 = Math_fround(Math_fround(HEAPF32[i8 >> 2]) - f7);
 f6 = Math_fround(Math_fround(HEAPF32[i8 + 4 >> 2]) - f6);
 f5 = Math_fround(Math_fround(HEAPF32[i8 + 8 >> 2]) - f5);
 if (!(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)) <= Math_fround(f4 * f4))) {
  i8 = 1;
  STACKTOP = i3;
  return i8 | 0;
 }
 f7 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i2 >> 2]));
 i8 = f7 < Math_fround(0.0);
 f6 = Math_fround(-f7);
 i8 = !((i8 ? f6 : f7) <= Math_fround(9.99999997e-07));
 STACKTOP = i3;
 return i8 | 0;
}

function __Z24CalculateImageMipMapSizeii13TextureFormat(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i3 = i4 >>> 0 > 65535;
 i7 = i3 ? i4 >>> 16 : i4;
 i3 = i3 ? 16 : 0;
 i2 = (i7 & 65280 | 0) == 0;
 i7 = i2 ? i7 : i7 >>> 8;
 i3 = i2 ? i3 : i3 | 8;
 i2 = (i7 & 240 | 0) == 0;
 i3 = (HEAP8[(i2 ? i7 : i7 >>> 4) + (gb + 936717) >> 0] | 0) + (i2 ? i3 : i3 | 4) | 0;
 i2 = i5 >>> 0 > 65535;
 i7 = i2 ? i5 >>> 16 : i5;
 i2 = i2 ? 16 : 0;
 i1 = (i7 & 65280 | 0) == 0;
 i7 = i1 ? i7 : i7 >>> 8;
 i2 = i1 ? i2 : i2 | 8;
 i1 = (i7 & 240 | 0) == 0;
 i2 = (HEAP8[(i1 ? i7 : i7 >>> 4) + (gb + 936717) >> 0] | 0) + (i1 ? i2 : i2 | 4) | 0;
 i3 = (i3 | 0) < (i2 | 0) ? i2 : i3;
 i3 = (i3 | 0) < 0 ? 0 : i3;
 if ((i4 | 0) != 0 & (i5 | 0) != 0 & (i3 | 0) > -1) {
  i1 = 0;
  i2 = 0;
 } else {
  i7 = 0;
  return i7 | 0;
 }
 while (1) {
  i8 = i4 >> i2;
  i7 = i5 >> i2;
  i1 = (__Z18CalculateImageSizeii13TextureFormat((i8 | 0) < 1 ? 1 : i8, (i7 | 0) < 1 ? 1 : i7, i6) | 0) + i1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
 }
 return i1 | 0;
}

function __ZN9ShaderLab9IntShaderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 2e3;
 HEAP32[i1 + 56 >> 2] = -1;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP8[i1 + 68 >> 0] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 24 | 0;
 i1 = i1 + 92 | 0;
 i2 = i1 + 52 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i3 >> 2] = -1;
 HEAP32[i3 + 4 >> 2] = -1;
 HEAP32[i3 + 8 >> 2] = -1;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP32[i3 + 16 >> 2] = -1;
 HEAP32[i3 + 20 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager21createObstacleContextEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i2 | 0, i1 | 0, 60, (i4 ? gb + 657626 | 0 : gb + 837976 | 0) | 0, gb + 657349 | 0, 208) | 0;
 __ZN5physx3Cct15ObstacleContextC2ERNS0_26CharacterControllerManagerE(i4, i6);
 HEAP32[i5 >> 2] = i4;
 i1 = i6 + 116 | 0;
 i2 = i6 + 120 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i6 + 124 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i7;
  return i4 | 0;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_3Cct15ObstacleContextENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i1, i5) | 0;
  STACKTOP = i7;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx2Sc5Scene17createClothSolverEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 168 | 0;
 if (HEAP32[i2 >> 2] | 0) return;
 i1 = HEAP32[(HEAP32[gb + 1457332 >> 2] | 0) + 12 >> 2] | 0;
 if (i1 | 0) HEAP32[i5 + 184 >> 2] = i1;
 i4 = i5 + 2388 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 i3 = HEAP32[i5 + 1176 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? 0 : i3 + -8 | 0;
 i1 = HEAP32[i5 + 184 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 >> 2] | 0; else {
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i4 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, fb + 827 | 0);
 i1 = HEAP32[i5 + 188 >> 2] | 0;
 if (!i1) i1 = HEAP32[i5 + 172 >> 2] | 0; else {
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i4 >> 2] | 0) | 0;
  HEAP32[i5 + 172 >> 2] = i1;
 }
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, fb + 827 | 0);
 return;
}

function __ZN5physx13BigConvexData4LoadERNS_13PxInputStreamE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = i5 + 5 | 0;
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(83, 85, 80, 77, i2, i1, i3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(__ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE(71, 65, 85, 83, i2, i1, i3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP16[i4 >> 1] = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i1 >> 0] | 0) != 0, i3) | 0;
 i1 = __ZN5physx9readDwordEbRNS_13PxInputStreamE((HEAP8[i1 >> 0] | 0) != 0, i3) | 0;
 i2 = i4 + 2 | 0;
 HEAP16[i2 >> 1] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5 + 4 | 0, i1 << 1 & 131070, gb + 724398 | 0, 142) | 0;
 HEAP32[i4 + 4 >> 2] = i1;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, HEAPU16[i2 >> 1] << 1 | 0) | 0;
 i4 = __ZN5physx13BigConvexData5VLoadERNS_13PxInputStreamE(i4, i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float3EEEclERS4_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, (HEAP32[HEAP32[i2 >> 2] >> 2] | 0) * 12 | 0, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 * 12 | 0) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN15OcclusionPortal13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 32 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  if (i1 | 0) {
   i3 = (__ZNK10GameObject8IsActiveEv(i1) | 0) ^ 1;
   if (!((i2 | 0) == (gb + 1111068 | 0) | i3)) {
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) i1 = i4 + 36 | 0; else {
     i3 = i4 + 36 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
     i1 = i3;
    }
    i3 = HEAP32[gb + 1111068 >> 2] | 0;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i1 >> 2] = gb + 1111068;
    HEAP32[i3 + 4 >> 2] = i2;
    HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   }
  }
 }
 i1 = i4 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i3 = __Z16GetRendererScenev() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i1 = 1; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) i1 = (HEAP8[i4 + 72 >> 0] | 0) != 0; else i1 = 1;
 __ZN13RendererScene25SetOcclusionPortalEnabledEjb(i3, i2, i1);
 return;
}

function __ZN12FlareManager11UpdateFlareEiP5FlareRK8Vector3fbfRK10ColorRGBAffjj(i1, i5, i3, i4, i6, f7, i8, f9, i10, i11) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = i2 + (i5 * 52 | 0) + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 + (i5 * 52 | 0) + 28 >> 2] = i1;
 HEAP8[i2 + (i5 * 52 | 0) + 48 >> 0] = i6 & 1;
 HEAPF32[i2 + (i5 * 52 | 0) + 40 >> 2] = f7;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = HEAP32[i8 + 8 >> 2] | 0;
 i6 = HEAP32[i8 + 12 >> 2] | 0;
 HEAP32[i2 + (i5 * 52 | 0) >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + (i5 * 52 | 0) + 4 >> 2] = i3;
 HEAP32[i2 + (i5 * 52 | 0) + 8 >> 2] = i4;
 HEAP32[i2 + (i5 * 52 | 0) + 12 >> 2] = i6;
 HEAPF32[i2 + (i5 * 52 | 0) + 44 >> 2] = f9;
 HEAP32[i2 + (i5 * 52 | 0) + 32 >> 2] = i10;
 HEAP32[i2 + (i5 * 52 | 0) + 36 >> 2] = i11;
 return;
}

function __ZN11Rigidbody2D15SetGravityScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0;
 i4 = f1 < Math_fround(-1.0e6);
 i3 = f1 > Math_fround(1.0e6);
 f1 = i3 ? Math_fround(1.0e6) : f1;
 f1 = i4 ? Math_fround(-1.0e6) : f1;
 HEAPF32[i2 + 44 >> 2] = f1;
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 if (!i4) return;
 i2 = i4 + 140 | 0;
 f5 = Math_fround(f1 - Math_fround(HEAPF32[i2 >> 2]));
 i3 = f5 < Math_fround(0.0);
 f6 = Math_fround(-f5);
 if ((i3 ? f6 : f5) <= Math_fround(9.99999997e-07)) return;
 HEAPF32[i2 >> 2] = f1;
 if (f1 != f1 | Math_fround(0.0) != Math_fround(0.0) | f1 == Math_fround(0.0)) return;
 i2 = i4 + 4 | 0;
 i3 = HEAPU16[i2 >> 1] | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP16[i2 >> 1] = i3 & 65533;
  HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  i4 = i4 + 64 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  return;
 }
 if (i3 & 2 | 0) return;
 HEAP16[i2 >> 1] = i3 | 2;
 HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
 return;
}

function __Z47AnimatorControllerPlayable_CUSTOM_GetBoolStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0;
 i1 = mftCall_iiii(i7 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0, i4 | 0) | 0;
 if ((i1 | 0) == 1) {
  i7 = HEAP8[i4 >> 0] | 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i3);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i7, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i7 = HEAP8[i4 >> 0] | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z37Rigidbody2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayf(i2, i3, i4, f5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 36) | 0;
 if (!i2) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i7) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i3 = __ZN11Rigidbody2D4CastERK8Vector2ffP12RaycastHit2Di(i7, i6, f5, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0) | 0;
 if (!i3) {
  STACKTOP = i8;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 STACKTOP = i8;
 return i3 | 0;
}

function __Z36Graphics_CUSTOM_ExecuteCommandBufferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32832 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 20 | 0;
 __ZN15RenderNodeQueueC2ERK10MemLabelId(i4, gb + 64016 | 0);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 __ZN22RenderingCommandBuffer20FlattenCommandBufferER17ShaderPassContextR15RenderNodeQueue(i1, HEAP32[gb + 1166248 >> 2] | 0, i4);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 8 | 0);
 __ZN22RenderingCommandBuffer20ExecuteCommandBufferER17ShaderPassContextRK15RenderNodeQueue(i1, HEAP32[gb + 1166248 >> 2] | 0, i4);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 16 | 0); else {
  __ZN22RenderingCommandBuffer7CleanupEv(i1);
  __ZN15RenderNodeQueueD2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 64 | 0;
 if ((HEAP32[i2 + 80 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 68 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 44 | 0;
 if ((HEAP32[i2 + 60 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 48 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 40 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 24 >> 2] | 0, i2 + 28 | 0);
 __ZdlPv(i2);
 return;
}

function __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEED2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  HEAP32[i5 >> 2] = i1 + -156;
  i2 = i1 + -40 | 0;
  if ((HEAP32[i1 + -24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -36 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -60 | 0;
  if ((HEAP32[i1 + -44 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -56 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -80 | 0;
  if ((HEAP32[i1 + -64 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -76 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i2 = i1 + -100 | 0;
  if ((HEAP32[i1 + -84 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + -96 | 0);
   HEAP32[i2 >> 2] = 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7ReverbI7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  STACKTOP = i4;
  return 0;
 } else {
  i6 = HEAP32[(HEAP32[i2 + 308 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] << 2) >> 2] | 0;
  i1 = i6 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i1 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  i3 = i2 + 288 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i2 + 284;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i1;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 280 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i2 + 276 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  STACKTOP = i4;
  return 0;
 }
 return 0;
}

function __ZN22RenderingCommandBuffer18AddSetRenderTargetERK18RenderTextureParami11CubemapFacei(i4, i1, i9, i10, i11) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i12 = 0, i13 = 0;
 i12 = HEAP32[i1 + 8 >> 2] | 0;
 i13 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i4 + 8 | 0;
 i7 = i4 + 24 | 0;
 i5 = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 i3 = i5 + 4 | 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i5, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i3 = i4 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i5 >> 2] = 5;
 i4 = i5 + 7 & -4;
 i5 = i4 + 28 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + i4 | 0;
 HEAP32[i7 >> 2] = i12;
 HEAP32[i7 + 4 >> 2] = i13;
 HEAP32[i7 + 8 >> 2] = i8;
 HEAP32[i7 + 12 >> 2] = i9;
 HEAP32[i7 + 16 >> 2] = i10;
 HEAP32[i7 + 20 >> 2] = i11;
 HEAP32[i7 + 24 >> 2] = 0;
 return;
}

function __ZN19TouchPhaseEmulation9ExpireOldER9TouchImpl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 441549 | 0, 0, gb + 441584 | 0, 504, 1, 0, 0, 0);
  return;
 } else {
  i1 = i1 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i3);
  HEAP32[i2 >> 2] = -1;
  HEAP32[i2 + 36 >> 2] = 4;
  HEAP32[i2 + 92 >> 2] = 0;
  HEAP32[i2 + 84 >> 2] = 0;
  HEAP32[i2 + 88 >> 2] = 0;
  i3 = i2 + 4 | 0;
  i1 = i2 + 72 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 0;
  HEAP32[i2 + 80 >> 2] = -1;
  HEAPF32[i2 + 44 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 48 >> 2] = Math_fround(1.0);
  HEAP32[i2 + 40 >> 2] = 0;
  i3 = i2 + 52 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  return;
 }
}

function __ZN17GeneralConnection13WaitForFinishEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i4 + 88 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 92 | 0;
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i8;
  return;
 }
 i3 = 60;
 i2 = i1;
 L4 : while (1) {
  while (1) {
   if (HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + 60 >> 2] | 0) break;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i6 | 0)) {
    i1 = 13;
    break L4;
   } else i2 = i1;
  }
  if ((i3 | 0) == 60) {
   _printf_console(gb + 459168 | 0, i7);
   i1 = 0;
  } else i1 = i3 + 1 | 0;
  __ZN17GeneralConnection4PollEv(i4);
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) == (i6 | 0)) {
   i1 = 13;
   break;
  } else i3 = i1;
 }
 if ((i1 | 0) == 13) {
  STACKTOP = i8;
  return;
 }
}

function __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3, i4);
 __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 340 | 0, i4);
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_(i3 + 344 | 0, i4);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i1 = i3 + 360 | 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  i2 = HEAP32[i5 >> 2] | 0;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
  HEAP32[i5 >> 2] = i2;
 }
 i1 = i3 + 361 | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN12FixedJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 __ZN7Joint2D16CheckConsistencyEv(i2);
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 84 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i5 = gb + 1162356 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i5 = i2 + 100 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f6;
 i5 = i2 + 96 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0);
 f6 = i3 ? Math_fround(1.0) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(0.0) : f6;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer25GetSessionHeaderJsonArrayERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i4, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i1 = i2 + 52 | 0;
 i5 = i1 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) i2 = HEAP32[i2 + 56 >> 2] | 0; else i2 = i3 & 255;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, gb + 1046779 | 0, 1) | 0;
 i4 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i4, _strlen(i4) | 0) | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, gb + 1046923 | 0, 2) | 0;
 if ((HEAP8[i5 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j(i6, i1, _strlen(i1) | 0) | 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN10InputEventaSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 12 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 HEAP16[i1 + 36 >> 1] = i3;
 HEAP16[i1 + 38 >> 1] = i3 >>> 16;
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP8[i1 + 48 >> 0] = HEAP8[i2 + 48 >> 0] | 0;
 i3 = i1 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  __ZdaPv(i1);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i2 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = __Znaj((_strlen(i2) | 0) + 1 | 0) | 0;
 HEAP32[i3 >> 2] = i4;
 i5 = HEAP32[i1 >> 2] | 0;
 _memcpy(i4 | 0, i5 | 0, (_strlen(i5) | 0) + 1 | 0) | 0;
 return;
}

function __Z56ParticleSystem_ShapeModule_CUSTOM_SetSkinnedMeshRendererP12Il2CppObjectS0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = i1 + 48 | 0;
 i1 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 i2 = i3 + 52 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
}

function __Z42Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaRK13Vector2fIcallS1_iff(i1, i2, i3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 8 | 0;
 i7 = i6;
 f11 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f13 = Math_fround(Math_fround(f12 + f9) * Math_fround(.5));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(f11 + f10) * Math_fround(.5));
 HEAPF32[i8 + 4 >> 2] = f13;
 f9 = Math_fround(Math_abs(Math_fround(f12 - f9)));
 HEAPF32[i7 >> 2] = Math_fround(Math_abs(Math_fround(f11 - f10)));
 HEAPF32[i7 + 4 >> 2] = f9;
 i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16Physics2DManager10OverlapBoxERK8Vector2fS2_fiffPK10Collider2D(__Z19GetPhysicsManager2Dv() | 0, i8, i7, Math_fround(0.0), i3, f4, f5, 0) | 0) | 0;
 STACKTOP = i6;
 return i3 | 0;
}

function __Z13dtFreeNavMeshP9dtNavMesh(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (!i5) return;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i5 + 20 | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[i4 >> 2] | 0;
   if (HEAP32[i2 + (i3 * 56 | 0) + 8 >> 2] | 0) {
    if (HEAP32[i2 + (i3 * 56 | 0) + 48 >> 2] & 1 | 0) {
     i1 = i2 + (i3 * 56 | 0) + 40 | 0;
     mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
     HEAP32[i1 >> 2] = 0;
     HEAP32[i2 + (i3 * 56 | 0) + 44 >> 2] = 0;
    }
    i1 = i2 + (i3 * 56 | 0) + 12 | 0;
    mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 8 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 48 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 36 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, i5 | 0);
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getParentClassEN5physx8debugger18NonNegativeIntegerE(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) if ((HEAP32[i3 + 128 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[i3 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   i6 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i1 + 16 >> 2];
   mftCall_viii(i6 | 0, i4 | 0, i3 | 0, i2 | 0);
   STACKTOP = i5;
   return;
  }
 }
 HEAP32[i4 >> 2] = gb + 148960 + 8;
 HEAP32[i4 + 4 >> 2] = gb + 1576256;
 HEAP32[i4 + 8 >> 2] = gb + 1576256;
 i2 = i4 + 12 | 0;
 i1 = i4 + 28 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 i2 = i1;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP16[i1 + 40 >> 1] = 0;
 HEAP8[i4 + 72 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZNK10Collider2D20GetAttachedRigidbodyEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) > 0) {
  i1 = HEAP32[(HEAP32[HEAP32[i2 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
  if (!i1) i4 = 4; else {
   i1 = HEAP32[i1 + 148 >> 2] | 0;
   if ((i1 | 0) != 0 | i3 ^ 1) {
    i4 = i1;
    return i4 | 0;
   }
  }
 } else i4 = 4;
 if ((i4 | 0) == 4) if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = i2 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 67088 | 0) | 0;
 if (i2 | 0) {
  i4 = i2;
  return i4 | 0;
 }
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) {
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67088 | 0) | 0;
   if (i2 | 0) break;
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = 11;
   break;
  }
 }
 if ((i4 | 0) == 11) return i1 | 0;
 i4 = i2;
 return i4 | 0;
}

function __ZN8GUIStateD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 __ZN10InputEventD2Ev(i5 + 288 | 0);
 i1 = HEAP32[i5 + 96 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 100 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -56 - i2 | 0) >>> 0) / 56 | 0) * 56 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 if (i1 | 0) {
  __ZN11UTF16StringD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 88 >> 2] | 0;
 if (i1 | 0) {
  __ZN11UTF16StringD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN5IMGUI14GUIWindowStateD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 767900 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 767735 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN2UI11CompareFuncEPNS_6CanvasES1_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0, i5 = 0;
 i1 = __ZNK2UI6Canvas13GetRenderModeEv(i6) | 0;
 i4 = __ZNK2UI6Canvas13GetRenderModeEv(i7) | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i7 = (i1 | 0) < (i4 | 0);
  return i7 | 0;
 }
 switch (i1 | 0) {
 case 0:
  {
   i1 = i6;
   while (1) {
    i4 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i4; else break;
   }
   i5 = HEAP16[i1 + 372 >> 1] | 0;
   i1 = i7;
   while (1) {
    i4 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i4) break;
    if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i4; else break;
   }
   i1 = HEAP16[i1 + 372 >> 1] | 0;
   if (i5 << 16 >> 16 != i1 << 16 >> 16) {
    i7 = i5 << 16 >> 16 < i1 << 16 >> 16;
    return i7 | 0;
   }
   break;
  }
 case 1:
  {
   f2 = Math_fround(HEAPF32[i6 + 364 >> 2]);
   f3 = Math_fround(HEAPF32[i7 + 364 >> 2]);
   if (!(f2 == f3)) {
    i7 = f2 > f3;
    return i7 | 0;
   }
   break;
  }
 default:
  {}
 }
 i7 = (HEAP32[i6 + 4 >> 2] | 0) < (HEAP32[i7 + 4 >> 2] | 0);
 return i7 | 0;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE8AllocateEji(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZN17LowLevelAllocator6MallocEj(i4 + 7 + i1 | 0) | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = -8 - i2 & i1 + -1;
 i3 = i2 + i1 | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -2;
  i1 = 0;
  i2 = i3;
 } else {
  _memset(i2 | 0, -86, i1 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
  HEAP32[i3 + -4 >> 2] = i1;
  i1 = 1;
  i2 = i3;
 }
 HEAP32[i2 >> 2] = i1 | i4 << 1;
 i1 = i3 + 8 | 0;
 i2 = (HEAP32[i1 + -8 >> 2] | 0) >>> 1;
 i4 = i5 + 16 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + i2 | 0;
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 28 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 23;
 i4 = i5 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i4 >> 2] | 0) >>> 0) HEAP32[i4 >> 2] = i3;
 i4 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i5 + 20 | 0;
 HEAP32[i4 >> 2] = i2 + 23 + (HEAP32[i4 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv(i5, i1) | 0;
 i5 = i1;
 return i5 | 0;
}

function __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 if ((HEAP16[gb + 1165932 + 6 >> 1] | 0) > -1) {
  __Z26profiler_begin_instance_idP19ProfilerInformationi(gb + 1165932 | 0, i2);
  i5 = gb + 1165932 | 0;
 } else i5 = 0;
 i1 = __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi(i4, i2) | 0;
 if (!i1) if ((HEAP32[i4 + 84 >> 2] | 0) == -1) {
  i1 = __ZN17PersistentManager18ReadObjectThreadedEi(i4, i2) | 0;
  if (!i1) i1 = 0; else {
   i2 = i4 + 176 | 0;
   i3 = i4 + 120 | 0;
   if ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) do {
    __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i4);
    __ZN17PersistentManager27IntegrateAllThreadedObjectsEv(i4);
   } while ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0));
  }
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 467569 | 0, 0, gb + 466878 | 0, 1171, 1, 0, 0, 0);
  i1 = 0;
 }
 if (!i5) return i1 | 0;
 __Z12profiler_endP19ProfilerInformation(i5);
 return i1 | 0;
}

function __Z35RectOffset_CUSTOM_INTERNAL_CALL_AddP12Il2CppObjectRK5RectTIfERS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  f7 = Math_fround(HEAP32[i1 >> 2] | 0);
  f9 = Math_fround(f4 - f7);
  f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f4 = Math_fround(HEAP32[i1 + 8 >> 2] | 0);
  f8 = Math_fround(f8 - f4);
  f7 = Math_fround(f7 + Math_fround(HEAPF32[i2 + 8 >> 2]));
  f7 = Math_fround(f7 + Math_fround(HEAP32[i1 + 4 >> 2] | 0));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 12 >> 2]));
  f4 = Math_fround(f4 + Math_fround(HEAP32[i1 + 12 >> 2] | 0));
  HEAPF32[i3 >> 2] = f9;
  HEAPF32[i3 + 4 >> 2] = f8;
  HEAPF32[i3 + 8 >> 2] = f7;
  HEAPF32[i3 + 12 >> 2] = f4;
  STACKTOP = i6;
  return;
 }
}

function _UNITY_png_inflate_claim(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i4 = i5 + 216 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP8[i1 >> 0] = i2 >>> 24;
  HEAP8[i1 + 1 >> 0] = i2 >>> 16;
  HEAP8[i1 + 2 >> 0] = i2 >>> 8;
  HEAP8[i1 + 3 >> 0] = i2;
  _UNITY_png_safecat(i1, 64, 4, gb + 355064 | 0) | 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i5 + 220 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 + 224 >> 2] = 0;
 HEAP32[i5 + 232 >> 2] = 0;
 HEAP32[i5 + 236 >> 2] = 0;
 i2 = i5 + 208 | 0;
 if (!(HEAP32[i2 >> 2] & 2)) {
  i1 = _unity_z_inflateInit_(i1, gb + 362978 | 0, 56) | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 2;
   i2 = 7;
  } else i2 = 8;
 } else {
  i1 = _unity_z_inflateReset(i1) | 0;
  if (!i1) i2 = 7; else i2 = 8;
 }
 if ((i2 | 0) == 7) {
  HEAP32[i4 >> 2] = i3;
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else if ((i2 | 0) == 8) {
  _UNITY_png_zstream_error(i5, i1);
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEfEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i11 = i7;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK6Camera28CalculateNeedsToRenderIntoRTEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if ((__ZNK6Camera22CalculateRenderingPathEv(i1) | 0 | 1 | 0) == 3) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) i2 = 5; else {
  i3 = __Z18GetQualitySettingsv() | 0;
  if ((HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) > 1) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 158 >> 0] | 0)) {
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 159 >> 0] | 0) {
    i1 = __Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i1 + 1124 >> 2] | 0) | 0;
    if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
     i3 = 1;
     return i3 | 0;
    }
    if ((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) {
     i3 = 1;
     return i3 | 0;
    }
   }
  } else i2 = 5; else i2 = 5;
 }
 if ((i2 | 0) == 5) {
  i3 = __Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i1 + 1124 >> 2] | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i3 + 4 >> 2] | 0)) {
   i3 = 1;
   return i3 | 0;
  }
 }
 i3 = 0;
 return i3 | 0;
}

function __ZN5physx9NpPhysics9lockSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1;
  i3 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(i3);
  STACKTOP = i4;
  return 1;
 }
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 4, gb + 689263 | 0, 931) | 0;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i5 = _PxGetFoundation() | 0;
  i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
  i1 = mftCall_iiiiii(i7 | 0, i6 | 0, i1 | 0, (i5 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 i7 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(i7);
 STACKTOP = i4;
 return 1;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 767572 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN4FMOD6System4initEijPv(i3, i8, i1, i2) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  _JS_Sound_Init();
  __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi(i2 + 76 | 0, i8);
  i8 = __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi(i2 + 124 | 0, -1) | 0;
  HEAP32[i2 + 316 >> 2] = i8;
  if (i8 | 0) {
   i8 = 0;
   STACKTOP = i7;
   return i8 | 0;
  }
  HEAP32[i5 >> 2] = 33;
  HEAP32[i5 + 4 >> 2] = gb + 860991;
  _printf(gb + 860996 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 33;
  HEAP32[i6 + 4 >> 2] = gb + 860991;
  _printf(gb + 853343 | 0, i6) | 0;
  i8 = 33;
  STACKTOP = i7;
  return i8 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 860991;
 _printf(gb + 853184 | 0, i4) | 0;
 i8 = 36;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN26b2PolygonAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152104 + 8;
 return i2 | 0;
}

function __ZN24b2ChainAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i2, i6, i3, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i4 = __ZN16b2BlockAllocator8AllocateEi(i1, 156) | 0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i2;
 HEAP32[i4 + 60 >> 2] = i3;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 152004 + 8;
 return i4 | 0;
}

function __ZN24b2ChainAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i2, i6, i3, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i4 = __ZN16b2BlockAllocator8AllocateEi(i1, 156) | 0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i2;
 HEAP32[i4 + 60 >> 2] = i3;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 151964 + 8;
 return i4 | 0;
}

function __ZN23AnimationOffsetPlayableC2E18DirectorPlayerType(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i2, 0, 0);
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i2 + 72 >> 0] = 0;
 HEAP8[i2 + 73 >> 0] = 0;
 HEAP8[i2 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i2 + 76 | 0);
 HEAP32[i2 >> 2] = gb + 178944 + 8;
 i3 = i2 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i2 + 104 >> 2] = Math_fround(1.0);
 STACKTOP = i1;
 return;
}

function __ZN19VREyeTextureManager18ReleaseEyeTexturesEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP8[i7 + 104 >> 0] | 0)) i1 = 0; else {
  i1 = i7 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 0; else {
   __Z19DestroySingleObjectP6Object(i2);
   HEAP32[i1 >> 2] = 0;
   i1 = 1;
  }
  i2 = i7 + 20 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   __Z19DestroySingleObjectP6Object(i3);
   HEAP32[i2 >> 2] = 0;
   i1 = 1;
  }
 }
 i6 = i7 + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) {
  i7 = i1;
  return i7 | 0;
 } else i5 = 0;
 do {
  i4 = i2;
  i2 = i4 + (i5 * 20 | 0) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) i2 = 0; else {
   __Z19DestroySingleObjectP6Object(i3);
   HEAP32[i2 >> 2] = 0;
   i2 = 1;
  }
  i3 = i4 + (i5 * 20 | 0) + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4) {
   __Z19DestroySingleObjectP6Object(i4);
   HEAP32[i3 >> 2] = 0;
   i2 = 1;
  }
  i1 = i1 | i2;
  i5 = i5 + 1 | 0;
  i2 = HEAP32[i7 >> 2] | 0;
 } while (i5 >>> 0 < (((HEAP32[i6 >> 2] | 0) - i2 | 0) / 20 | 0) >>> 0);
 return i1 | 0;
}

function __ZN15GUIEventManager22GetLastEventForDisplayEi(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = i4 + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i5 + (((i3 >>> 0) / 78 | 0) << 2) | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) == (i5 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = (HEAP32[i2 >> 2] | 0) + (((i3 >>> 0) % 78 | 0) * 52 | 0) | 0;
 i6 = (HEAP32[i5 + (((i4 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i4 >>> 0) % 78 | 0) * 52 | 0) | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 while (1) {
  i3 = i2;
  i4 = (i1 | 0) == (HEAP32[i3 >> 2] | 0);
  if (i4) i5 = (HEAP32[i3 + -4 >> 2] | 0) + 4056 | 0; else i5 = i1;
  if ((HEAP32[i5 + -12 >> 2] | 0) == (i7 | 0)) break;
  if (i4) {
   i1 = i3 + -4 | 0;
   i2 = i1;
   i1 = (HEAP32[i1 >> 2] | 0) + 4056 | 0;
  }
  i1 = i1 + -52 | 0;
  if ((i1 | 0) == (i6 | 0)) {
   i1 = 0;
   i8 = 13;
   break;
  }
 }
 if ((i8 | 0) == 13) return i1 | 0;
 if (i4) i1 = (HEAP32[i3 + -4 >> 2] | 0) + 4056 | 0;
 i8 = i1 + -52 | 0;
 return i8 | 0;
}

function __ZN14RotationModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 16 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i2, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN14NavMeshManager20AddOffMeshConnectionERK8Vector3fS2_ibh(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  i7 = 0;
  setTempRet0(i6 | 0);
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i7 + 24 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAPF32[i7 + 28 >> 2] = Math_fround(-1.0);
 HEAP8[i7 + 32 >> 0] = i5 & 1;
 HEAP32[i7 + 36 >> 2] = 1 << (i6 & 255);
 HEAP8[i7 + 40 >> 0] = i6;
 HEAP16[i7 + 42 >> 1] = 0;
 HEAP32[i7 + 44 >> 2] = i4;
 i7 = __ZN9dtNavMesh20addOffMeshConnectionEPK25dtOffMeshConnectionParams(i1, i7) | 0;
 i6 = getTempRet0() | 0;
 setTempRet0(i6 | 0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN11Rigidbody2D12LayerChangedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1457872 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1457872 | 0, i1);
  i4 = gb + 1457872 | 0;
 } else i4 = 0;
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 do if (i2 | 0) {
  i3 = i2 + 4 | 0;
  i1 = HEAPU16[i3 >> 1] | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP16[i3 >> 1] = i1 & 65533;
   HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
   i3 = i2 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   break;
  }
  if (!(i1 & 2)) {
   HEAP16[i3 >> 1] = i1 | 2;
   HEAPF32[i2 + 144 >> 2] = Math_fround(0.0);
  }
 } while (0);
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i5;
 return;
}

function __Z39UploadHandlerRaw_CUSTOM_InternalGetDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i2);
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0)) {
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
  i1 = (i4 | 0) == 0 ? 0 : i1;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 1, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0, i4 | 0, i1 | 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z13RequireMethodPKcS0_S0_S0_(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i7 = i9 + 16 | 0;
 i2 = __Z12OptionalTypePKcS0_S0_(i3, i4, i5) | 0;
 if (!i2) {
  i10 = gb + 1164176 | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i10 = HEAP32[i10 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i10;
  i1 = i2;
 } else {
  __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i1, i2, i6, -1);
  i1 = HEAP32[i1 >> 2] | 0;
 }
 if (i1 | 0) {
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i3;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i5;
 __Z6FormatPKcz(i7, gb + 464393 | 0, i8);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7, 0, gb + 464113 | 0, 137, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 STACKTOP = i9;
 return;
}

function __Z12FormatStringPKcz(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 10256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = i2;
 __Z13VFormatBufferPciPKcPi(i6, 10240, i1, i3) | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = i5 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i5 + 24 | 0;
 i8 = gb + 64016 | 0;
 i2 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i5 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = _strlen(i6) | 0;
 if (i2 >>> 0 <= 15) {
  i8 = i1;
  _memcpy(i8 | 0, i6 | 0, i2 | 0) | 0;
  i8 = i8 + i2 | 0;
  HEAP8[i8 >> 0] = 0;
  HEAP32[i3 >> 2] = i2;
  STACKTOP = i7;
  return;
 }
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i4, 0, gb + 1047486 | 0, 251) | 0;
 HEAP32[i5 >> 2] = i8;
 HEAP32[i5 + 4 >> 2] = i2;
 i8 = (i8 | 0) == 0 ? i1 : i8;
 _memcpy(i8 | 0, i6 | 0, i2 | 0) | 0;
 i8 = i8 + i2 | 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i3 >> 2] = i2;
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 676636 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Ext15CpuWorkerThread24tryAcceptJobToLocalQueueERNS_10PxBaseTaskEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i3 + 24 >> 2] | 0) != (i1 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i3 + 12 >> 2] | 0) | 0;
 if (!i1) {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i1 = mftCall_iiiiii(i6 | 0, i5 | 0, 27, (i1 ? gb + 661229 | 0 : gb + 837976 | 0) | 0, gb + 661359 | 0, 109) | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = i1 + 11 & -8;
  HEAP32[i6 + -4 >> 2] = i6 - i1;
  i1 = i6;
  if (!i6) i4 = 7; else {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = i2;
   HEAP8[i1 + 8 >> 0] = 0;
  }
 } else {
  HEAP32[i1 + 4 >> 2] = i2;
  i4 = 7;
 }
 if ((i4 | 0) == 7) if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i3 + 20 >> 2] | 0, i1);
 i6 = 1;
 return i6 | 0;
}

function __ZN5physx15PxsParticleData10exportDataERNS_22PxSerializationContextE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i1 = HEAP32[i9 + 16 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i9 + 56 >> 2] | 0;
  i4 = (i1 + -1 | 0) >>> 5;
  i5 = i9 + 48 | 0;
  i6 = 0;
  while (1) {
   i1 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
   if (i1 | 0) {
    i2 = i6 << 5;
    i3 = HEAP32[i5 >> 2] | 0;
    do {
     i10 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
     i10 = HEAP32[gb + 90668 + (i10 << 2) >> 2] | i2;
     HEAP16[i3 + (i10 << 5) + 30 >> 1] = 0;
     HEAPF32[i3 + (i10 << 5) + 12 >> 2] = Math_fround(0.0);
     i1 = i1 + -1 & i1;
    } while ((i1 | 0) != 0);
   }
   if ((i6 | 0) == (i4 | 0)) break; else i6 = i6 + 1 | 0;
  }
 }
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, 16);
 i10 = HEAP32[i9 + 8 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i9 | 0, (i10 << 5) + 80 + (HEAP8[i9 + 12 >> 0] | 0 ? i10 << 2 : 0) + (((i10 + 31 | 0) >>> 5 << 2) + 15 & 1073741808) | 0);
 return;
}

function __ZN5Unity17ConfigurableJoint17SetAngularYZDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 240 >> 2] = f5;
 HEAPF32[i2 + 244 >> 2] = f4;
 HEAPF32[i2 + 248 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Umbra20RuntimeStructBuilder5cleanEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP8[i7 + 137 >> 0] | 0)) {
  i5 = i7 + 152 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) > 0) {
   i6 = i7 + 144 | 0;
   i4 = 0;
   do {
    i3 = HEAP32[i7 >> 2] | 0;
    i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 * 12 | 0) >> 2] | 0;
    if (i2) {
     mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
     i1 = HEAP32[i5 >> 2] | 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i1 | 0));
  }
 }
 i1 = i7 + 148 | 0;
 if ((HEAP32[i1 >> 2] | 0) < 0) {
  i3 = i7 + 140 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 16, 0) | 0;
  if (!i4) return;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = i7 + 144 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = HEAP32[i3 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 + -16 | 0);
  }
  HEAP32[i1 >> 2] = i4 + 16;
 }
 HEAP32[i7 + 152 >> 2] = 0;
 return;
}

function __ZN4FMOD4DSPI7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 868356;
  _printf(gb + 853184 | 0, i3) | 0;
  STACKTOP = i4;
  return 0;
 } else {
  i6 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] << 2) >> 2] | 0;
  i1 = i6 + 12 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  HEAP8[i6 + 16 >> 0] = 1;
  i1 = i6 + 24 | 0;
  i5 = i6 + 32 | 0;
  i6 = i6 + 28 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  i3 = i2 + 240 | 0;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 >> 2] = i2 + 236;
  HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] = i1;
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 232 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  i3 = i2 + 228 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  STACKTOP = i4;
  return 0;
 }
 return 0;
}

function __ZN25b2PolygonAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152124 + 8;
 return i2 | 0;
}

function __ZN25b2CapsuleAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 151924 + 8;
 return i2 | 0;
}

function __ZN23b2ChainAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i2, i6, i3, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i4 = __ZN16b2BlockAllocator8AllocateEi(i1, 156) | 0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i2;
 HEAP32[i4 + 60 >> 2] = i3;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 151984 + 8;
 return i4 | 0;
}

function __Z23ConvertImageToJPGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EEi(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 if ((HEAP32[i2 >> 2] | 0) == 3) i1 = i3 + 16 | 0; else {
  __ZN5Image8SetImageEii13TextureFormatb(i3, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, 3, 1);
  i1 = i3 + 16 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) i2 = i3; else if (!(HEAP32[i2 + 16 >> 2] | 0)) i2 = i3; else {
   __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i2, i3, 0);
   i2 = i3;
  }
 }
 __Z24ConvertBufferToJPGBufferPKhjjjiPvPFvS1_PhjE(HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, i5, i4, fb + 507 | 0) | 0;
 i5 = (HEAP32[i4 + 12 >> 2] | 0) != 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63184 | 0);
 STACKTOP = i6;
 return i5 | 0;
}

function __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, f13 = f0, f14 = f0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i11;
 if ((HEAP32[i2 >> 2] | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i7 = i2 + 12 | 0;
 i8 = i2 + 8 | 0;
 i9 = i2 + 20 | 0;
 i10 = i2 + 4 | 0;
 i4 = i9;
 i1 = 0;
 do {
  f14 = Math_fround(HEAPF32[i7 >> 2]);
  f13 = Math_fround(i1 | 0);
  f13 = Math_fround(f14 + Math_fround(f13 / Math_fround(HEAPF32[i8 >> 2])));
  i12 = (Math_imul(HEAP32[i10 >> 2] | 0, i1) | 0) + i3 | 0;
  i12 = (HEAP32[i9 >> 2] | 0) + i4 + (i12 << 2) | 0;
  __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE(i6, i5, f13, 0);
  HEAP32[i12 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i12 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i12 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 STACKTOP = i11;
 return;
}

function _vsnprintf(i2, i1, i8, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11 + 112 | 0;
 i10 = i11;
 i4 = i10;
 i5 = gb + 198644 | 0;
 i6 = i4 + 112 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 if ((i1 + -1 | 0) >>> 0 > 2147483646) if (!i1) {
  i2 = i3;
  i1 = 1;
  i7 = 4;
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 75;
  i1 = -1;
 } else i7 = 4;
 if ((i7 | 0) == 4) {
  i7 = -2 - i2 | 0;
  i7 = i1 >>> 0 > i7 >>> 0 ? i7 : i1;
  HEAP32[i10 + 48 >> 2] = i7;
  i3 = i10 + 20 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i10 + 44 >> 2] = i2;
  i1 = i2 + i7 | 0;
  i2 = i10 + 16 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i10 + 28 >> 2] = i1;
  i1 = _vfprintf(i10, i8, i9) | 0;
  if (i7) {
   i10 = HEAP32[i3 >> 2] | 0;
   HEAP8[i10 + (((i10 | 0) == (HEAP32[i2 >> 2] | 0)) << 31 >> 31) >> 0] = 0;
  }
 }
 STACKTOP = i11;
 return i1 | 0;
}

function __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i11 = i7;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + 4 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i5 - i3 >> 5;
 if (i4 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE8__appendEj(i1, i2 - i4 | 0);
  return;
 }
 if (i4 >>> 0 <= i2 >>> 0) return;
 i7 = i3 + (i2 << 5) | 0;
 if ((i5 | 0) == (i7 | 0)) return;
 do {
  i1 = i5 + -32 | 0;
  HEAP32[i8 >> 2] = i1;
  i2 = HEAP32[i5 + -20 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i5 + -16 | 0;
   i6 = HEAP32[i4 >> 2] | 0;
   if ((i6 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i6 + (~((i6 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i2);
  }
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i3;
  if (i3 | 0) {
   i1 = i5 + -28 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   __ZdlPv(i3);
  }
  i5 = HEAP32[i8 >> 2] | 0;
 } while ((i5 | 0) != (i7 | 0));
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 87;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9shadertag16GetShaderTagNameEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[gb + 1166564 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i5 | 0)) {
  while (1) {
   if ((HEAP32[i2 + 20 >> 2] | 0) == (i4 | 0)) break;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i5 | 0)) break L1; else i1 = i2;
  }
  i5 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, _strlen(i5) | 0);
  return;
 } while (0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 480497 | 0, 13);
 return;
}

function __ZN5Unity17ConfigurableJoint16SetAngularXDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 252 >> 2] = f5;
 HEAPF32[i2 + 256 >> 2] = f4;
 HEAPF32[i2 + 260 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __Z19InterpolateKeyframeIfET_RK11KeyframeTplIS0_ES4_f(i5, i6, f1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, f4 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(f4 - f2);
 if (f4 != Math_fround(0.0)) {
  f3 = Math_fround(Math_fround(f1 - f2) / f4);
  f2 = Math_fround(f4 * Math_fround(HEAPF32[i5 + 12 >> 2]));
  f1 = Math_fround(f4 * Math_fround(HEAPF32[i6 + 8 >> 2]));
 } else {
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
 }
 f8 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 f9 = Math_fround(f3 * f3);
 f10 = Math_fround(f3 * f9);
 f7 = Math_fround(f10 * Math_fround(2.0));
 f4 = Math_fround(f9 * Math_fround(3.0));
 return Math_fround(Math_fround(Math_fround(HEAPF32[i6 + 4 >> 2]) * Math_fround(f4 - f7)) + Math_fround(Math_fround(f1 * Math_fround(f10 - f9)) + Math_fround(Math_fround(f2 * Math_fround(f3 + Math_fround(f10 - Math_fround(f9 * Math_fround(2.0))))) + Math_fround(f8 * Math_fround(Math_fround(f7 - f4) + Math_fround(1.0))))));
}

function __ZN9ShaderLab26SerializedShaderDependency8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[gb + 37260 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 470673 | 0, i3, i4, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i2, 1); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 470678 | 0, i3, i4, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i2, 1); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 if (!i4) return;
 if (HEAP32[i4 >> 2] | 0) {
  i2 = i4 + 4 | 0;
  i3 = i2;
  i1 = 0;
  do {
   i7 = (HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim12statemachine25DestroyStateMachineMemoryEPNS0_18StateMachineMemoryERNS_6memory9AllocatorE((i6 | 0) == 0 ? 0 : i7 + i6 | 0, i5);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE((i2 | 0) == 0 ? 0 : i2 + i1 | 0, i5);
 i1 = i4 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i2 + i1 | 0);
 i1 = i4 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i4 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 676802 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN24TreeIntermediateRenderer15UpdateTransformERK10Matrix4x4fRK4AABB(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = i2 + 4 | 0;
 i6 = i3;
 i7 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  i5 = i5 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i2 + 180 >> 2] = __Z20ComputeTransformTypeRK10Matrix4x4ff(i3, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0;
 i7 = i2 + 156 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i7 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i7 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 i7 = i2 + 132 | 0;
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i4, i3, i7);
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 136 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 140 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 152 >> 2];
 return;
}

function __ZN23b2EdgeAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152084 + 8;
 return i2 | 0;
}

function __ZN23b2EdgeAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152044 + 8;
 return i2 | 0;
}

function __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i1 + 96 | 0;
 i7 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i5 = i1 + 200 | 0;
 i8 = i1 + 224 | 0;
 i7 = i1 + 208 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i8 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i8 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i4, __Z26scripting_object_get_classP12Il2CppObject(i2) | 0, i3, -1);
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[i4 + 4 >> 0] | 0;
 HEAP32[i7 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function ___fwritex(i3, i5, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) if (!(___towrite(i6) | 0)) {
  i1 = HEAP32[i1 >> 2] | 0;
  i4 = 5;
 } else i1 = 0; else {
  i1 = i2;
  i4 = 5;
 }
 L5 : do if ((i4 | 0) == 5) {
  i7 = i6 + 20 | 0;
  i4 = HEAP32[i7 >> 2] | 0;
  i2 = i4;
  if ((i1 - i4 | 0) >>> 0 < i5 >>> 0) {
   i1 = mftCall_iiii(HEAP32[i6 + 36 >> 2] | 0, i6 | 0, i3 | 0, i5 | 0) | 0;
   break;
  }
  L10 : do if ((HEAP8[i6 + 75 >> 0] | 0) > -1) {
   i1 = i5;
   while (1) {
    if (!i1) {
     i4 = i5;
     i1 = 0;
     break L10;
    }
    i4 = i1 + -1 | 0;
    if ((HEAP8[i3 + i4 >> 0] | 0) == 10) break; else i1 = i4;
   }
   if ((mftCall_iiii(HEAP32[i6 + 36 >> 2] | 0, i6 | 0, i3 | 0, i1 | 0) | 0) >>> 0 < i1 >>> 0) break L5;
   i4 = i5 - i1 | 0;
   i3 = i3 + i1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   i4 = i5;
   i1 = 0;
  } while (0);
  _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i4;
  i1 = i1 + i4 | 0;
 } while (0);
 return i1 | 0;
}

function __ZNSt3__28ios_base5pwordEi(i4, i9) {
 i4 = i4 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 1 | 0;
 i7 = i4 + 68 | 0;
 do if (i10 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i4 + 56 >> 2] << 1;
  i5 = i10 >>> 0 < 536870911 ? (i5 >>> 0 < i10 >>> 0 ? i10 : i5) : 1073741823;
  i6 = i4 + 60 | 0;
  i1 = _realloc(HEAP32[i6 >> 2] | 0, i5 << 2) | 0;
  if (!i1) {
   __ZNSt3__28ios_base5clearEj(i4, HEAP32[i4 + 16 >> 2] | 1);
   HEAP32[gb + 1473504 >> 2] = 0;
   i1 = gb + 1473504 | 0;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  i3 = i4 + 64 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i4 = i1 + (i2 << 2) | 0;
  while (1) {
   if (i4 >>> 0 >= (i1 + (i5 << 2) | 0) >>> 0) break;
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i5;
  i8 = 9;
 } else {
  i2 = i4 + 64 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 + 60 >> 2] | 0;
  i8 = 9;
 } while (0);
 if ((i8 | 0) == 9) {
  HEAP32[i3 >> 2] = i2 >>> 0 < i10 >>> 0 ? i10 : i2;
  i1 = i1 + (i9 << 2) | 0;
 }
 return i1 | 0;
}

function __ZN7dtCrowd14SetObstacleBoxERK13dtCrowdHandlePKfS4_S4_S4_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 + 416 >> 2] | 0;
 HEAP32[i1 + (i2 * 92 | 0) + 84 >> 2] = 2;
 HEAP32[i1 + (i2 * 92 | 0) + 24 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 28 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 32 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 48 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 52 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 56 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 60 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 64 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 68 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 72 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 76 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 80 >> 2] = HEAP32[i6 + 8 >> 2];
 __Z19CalcBoxWorldExtentsPfPKfS1_S1_S1_(i1 + (i2 * 92 | 0) + 36 | 0, i3, i4, i5, i6);
 return;
}

function __ZN5IMGUI22GetEventTypeForControlERK8GUIStateRK10InputEventi(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 + 276 >> 2] | 0) + 4 >> 2] | 0;
 L1 : do if (!i2) {
  if (!(HEAP32[i3 + 60 >> 2] | 0)) {
   switch (i1 | 0) {
   case 7:
   case 8:
   case 12:
    break L1;
   default:
    {}
   }
   i1 = 11;
   break;
  }
  if (!(HEAP32[i3 + 268 >> 2] | 0)) switch (i1 | 0) {
  case 0:
  case 1:
  case 9:
  case 10:
  case 16:
   {
    i1 = 11;
    break L1;
   }
  default:
   {}
  }
 } else switch (i1 | 0) {
 case 3:
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP32[i3 + 60 >> 2] | 0)) {
    i1 = 11;
    break L1;
   }
   if (HEAP32[i3 + 268 >> 2] | 0) break L1;
   return ((i2 | 0) == (i4 | 0) ? i1 : 11) | 0;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP32[i3 + 60 >> 2] | 0)) {
    i1 = 11;
    break L1;
   }
   if ((HEAP32[i3 + 268 >> 2] | 0) != 0 | (i2 | 0) == (i4 | 0)) break L1;
   i1 = (HEAP32[i3 >> 2] | 0) == (i4 | 0) ? i1 : 11;
   break L1;
  }
 default:
  break L1;
 } while (0);
 return i1 | 0;
}

function __ZN2UI13RectTransform13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 __ZN9Transform13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, (i2 & 13 | 0) == 0, 0);
 HEAP8[i1 + 176 >> 0] = 0;
 if (!(__Z25IsManagerContextAvailablei(5) | 0)) {
  STACKTOP = i6;
  return;
 }
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 292 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i3, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN22b2EdgeAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152064 + 8;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl10CacheRectsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i4 + 60 >> 2] | 0;
 i2 = i4 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -60 - i1 | 0) >>> 0) / 60 | 0) * 60 | 0);
 i5 = i4 + 52 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 i6 = i4 + 40 | 0;
 i7 = i4 + 76 | 0;
 i3 = i4 + 60 | 0;
 i2 = 0;
 do {
  i1 = HEAP32[i6 >> 2] | 0;
  i4 = i1 + (i2 * 60 | 0) | 0;
  if ((HEAP32[i4 >> 2] | 0) == -1) HEAP32[i4 >> 2] = i2;
  i1 = i1 + (i2 * 60 | 0) + 40 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2];
  __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_(i8, i3, i4);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 STACKTOP = i9;
 return;
}

function __ZN16GraphicsSettingsD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 33272 + 8;
 i1 = HEAP32[i5 + 108 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 112 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  i4 = HEAP32[i5 + 120 >> 2] | 0;
  HEAP32[i6 >> 2] = 52;
  HEAP32[i6 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 }
 i1 = HEAP32[i5 + 92 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = gb + 28648 + 8;
  HEAP32[i5 >> 2] = gb + 28496 + 8;
  STACKTOP = i7;
  return;
 }
 i2 = i5 + 96 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i4 = HEAP32[i5 + 104 >> 2] | 0;
 HEAP32[i6 >> 2] = 52;
 HEAP32[i6 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i6);
 HEAP32[i5 >> 2] = gb + 28648 + 8;
 HEAP32[i5 >> 2] = gb + 28496 + 8;
 STACKTOP = i7;
 return;
}

function __Z19SimpleStringToFloatPKcPi(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0, f9 = f0;
 i4 = HEAP8[i7 >> 0] | 0;
 switch (i4 << 24 >> 24 | 0) {
 case 45:
  {
   i2 = 1;
   i5 = 3;
   break;
  }
 case 43:
  {
   i2 = 0;
   i5 = 3;
   break;
  }
 default:
  {
   i3 = i7;
   i2 = 0;
  }
 }
 if ((i5 | 0) == 3) {
  i4 = i7 + 1 | 0;
  i3 = i4;
  i4 = HEAP8[i4 >> 0] | 0;
 }
 if ((i4 + -48 & 255) < 10) {
  d1 = 0.0;
  do {
   d1 = d1 * 10.0 + +((i4 << 24 >> 24) + -48 | 0);
   i3 = i3 + 1 | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while ((i4 + -48 & 255) < 10);
 } else d1 = 0.0;
 if (i4 << 24 >> 24 == 46) {
  i3 = i3 + 1 | 0;
  i4 = HEAP8[i3 >> 0] | 0;
  if ((i4 + -48 & 255) < 10) {
   d6 = .1;
   while (1) {
    d1 = d1 + d6 * +((i4 << 24 >> 24) + -48 | 0);
    i3 = i3 + 1 | 0;
    i4 = HEAP8[i3 >> 0] | 0;
    if ((i4 + -48 & 255) >= 10) break; else d6 = d6 * .1;
   }
  }
 }
 d1 = i2 ? -d1 : d1;
 if (!i8) {
  f9 = Math_fround(d1);
  return Math_fround(f9);
 }
 HEAP32[i8 >> 2] = i3 - i7;
 f9 = Math_fround(d1);
 return Math_fround(f9);
}

function __ZNKSt3__220__time_get_c_storageIcE7__am_pmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099840 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099840 | 0) | 0) {
  if (!(HEAP8[gb + 1099848 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099848 | 0) | 0) {
   i2 = gb + 1474676 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1474676 + 288 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1149 | 0, gb + 1474676 | 0, gb + 1078500 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1149 | 0, gb + 1474676 + 12 | 0, gb + 1078503 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    HEAP32[gb + 1474964 >> 2] = gb + 1474676;
    break;
   }
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1474964 >> 2] | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEjjPKjjjj(i1, i7, i3, i4, i5, i8, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i2 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (i3 >>> 0 <= 1) {
  if (HEAP16[i2 + 48 >> 1] & 1) {
   i8 = 0;
   return i8 | 0;
  }
  i6 = HEAP32[i4 >> 2] | 0;
  i8 = i6 >>> 1;
  i7 = HEAP32[i2 + 36 >> 2] | 0;
  i8 = (HEAP8[((i6 & 1 | 0) == 0 ? i7 + (i8 << 2) + 2 | 0 : i7 + (i8 << 2) + 3 | 0) >> 0] & 127) != 127;
  return i8 | 0;
 }
 i10 = HEAP32[i4 >> 2] | 0;
 i3 = i10 >>> 1;
 i9 = HEAP32[i2 + 36 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i4 >>> 1;
 i1 = (HEAPU8[((i4 & 1 | 0) == 0 ? i9 + (i1 << 2) + 2 | 0 : i9 + (i1 << 2) + 3 | 0) >> 0] | 0) & 127;
 if ((HEAP8[((i10 & 1 | 0) == 0 ? i9 + (i3 << 2) + 2 | 0 : i9 + (i3 << 2) + 3 | 0) >> 0] & 127) == 127) {
  i10 = i1 << 16 >> 16 != 127;
  return i10 | 0;
 }
 if (i1 << 16 >> 16 == 127) {
  i10 = 1;
  return i10 | 0;
 }
 i10 = __ZNK5physx2Gu11HeightField12isConvexEdgeEjjjj(i2, i7, i5, i8, i6) | 0;
 return i10 | 0;
}

function __ZN8Playable19DeallocateResourcesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 i1 = i2 + 24 | 0;
 if ((HEAP16[i1 >> 1] | 0) > 0) {
  i7 = __Z18GetDirectorManagerv() | 0;
  i1 = (__ZNK15DirectorManager16GetScriptMethodsEs(i7, HEAP16[i1 >> 1] | 0) | 0) + 32 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i7 = HEAP32[i2 + 4 >> 2] | 0;
   i9 = i1;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i1 = i4;
   HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i1 + 4 >> 2] = i8;
   HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i7, i5);
   HEAP32[i5 >> 2] = 0;
   __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
  }
 }
 i1 = i2 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 702402 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i12, i11) {
 i1 = i1 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i12 >>> 0) __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i12);
 i8 = HEAP32[i1 >> 2] | 0;
 i9 = i1 + 4 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i10 = i8 + (i12 * 28 | 0) | 0;
 if ((i1 | 0) >= (i12 | 0)) {
  HEAP32[i9 >> 2] = i12;
  return;
 }
 i2 = i11 + 4 | 0;
 i3 = i11 + 8 | 0;
 i4 = i11 + 12 | 0;
 i5 = i11 + 16 | 0;
 i6 = i11 + 20 | 0;
 i7 = i11 + 24 | 0;
 i1 = i8 + (i1 * 28 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i11 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i7 >> 2];
  i1 = i1 + 28 | 0;
 } while (i1 >>> 0 < i10 >>> 0);
 HEAP32[i9 >> 2] = i12;
 return;
}

function __ZN5Unity17ConfigurableJoint13SetSlerpDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 264 >> 2] = f5;
 HEAPF32[i2 + 268 >> 2] = f4;
 HEAPF32[i2 + 272 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Umbra8QueryExtC2EPKNS_14TomeCollectionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) return;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, 0, i2);
 return;
}

function __ZN5Umbra5Query4initEPKNS_14TomeCollectionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) return;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, 0, i2);
 return;
}

function __ZN5Umbra10QueryState17findTomeByClusterEi(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 if ((i7 | 0) < 0) {
  i7 = -1;
  return i7 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 124 >> 2] | 0) <= (i7 | 0)) {
  i7 = -1;
  return i7 | 0;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i3) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i2 + 108 >> 2] | 0;
 if ((i1 | 0) <= (i7 | 0)) if ((i7 - i1 | 0) < (HEAP32[(HEAP32[i2 + 100 >> 2] | 0) + 124 >> 2] | 0)) {
  i7 = HEAP32[i2 + 92 >> 2] | 0;
  return i7 | 0;
 }
 i1 = HEAP32[i4 + 180 >> 2] | 0;
 i5 = i2 + 84 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i6 + 1;
 i4 = (i1 | 0) == 0 ? 0 : i4 + i1 | 0;
 i1 = i3 + -1 | 0;
 if ((i1 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  do {
   i3 = (i1 + 1 + i2 | 0) / 2 | 0;
   i8 = (HEAP32[i4 + (i3 << 2) >> 2] | 0) > (i7 | 0);
   i1 = i8 ? i1 : i3;
   i2 = i8 ? i3 + -1 | 0 : i2;
  } while ((i2 | 0) > (i1 | 0));
 } else i1 = 0;
 HEAP32[i5 >> 2] = i6;
 i8 = i1;
 return i8 | 0;
}

function __ZN19AssetBundleManifest15AssetBundleInfo8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 367266 | 0, gb + 455698 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 367282 | 0, HEAP32[gb + 37228 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS2_9allocatorIiEEEEEvRT_17TransferMetaFlags(i4, i2, 0); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i5 = i6 + 16 | 0;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j(i5, _llvm_bswap_i32(i1 | 0) | 0);
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  __ZN12TreeInstance8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i7);
  i1 = i1 + 40 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i7, i6 + 4 | 0, 0);
 STACKTOP = i8;
 return;
}

function __Z49ParticleSystem_ShapeModule_CUSTOM_SetMeshRendererP12Il2CppObjectS0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = i1 + 48 | 0;
 i1 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 i2 = i3 + 48 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
}

function __ZN9AudioClip7WWWReadEPvS0_jPjS0_(i1, i6, i7, i8, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i8 = 37;
  return i8 | 0;
 }
 i5 = i2 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 i3 = HEAP32[i5 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0;
 i1 = i2 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 >= i2 >>> 0) {
  i4 = i4 - i2 | 0;
  i4 = i4 >>> 0 < i7 >>> 0 ? i4 : i7;
  HEAP32[i8 >> 2] = i4;
  _memcpy(i6 | 0, i3 + (HEAP32[i1 >> 2] | 0) | 0, i4 | 0) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i8 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
  i6 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  return ((HEAP32[i8 >> 2] | 0) >>> 0 < i7 >>> 0 ? 22 : 0) | 0;
 }
 i8 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
 i8 = 54;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 702246 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN19SkinnedMeshRenderer15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31632 | 0, gb + 1105296 | 0, fb + 529 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31632 | 0, gb + 1105316 | 0, fb + 530 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31632 | 0, gb + 1105156 | 0, fb + 531 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 31632 | 0, gb + 1105196 | 0, fb + 532 | 0, 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 429151 | 0, gb + 430168 | 0, gb + 1048075 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 429151 | 0, gb + 896236 | 0, gb + 430178 | 0);
 __Z45InitializeBlendShapeAnimationBindingInterfacev();
 return;
}

function __ZL12InvokeMethodI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 57 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 if (HEAP8[i1 + 56 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i11 = i7;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__220__time_get_c_storageIwE7__am_pmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099920 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099920 | 0) | 0) {
  if (!(HEAP8[gb + 1099928 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099928 | 0) | 0) {
   i2 = gb + 1475488 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    i1 = 0;
    while (1) {
     if ((i1 | 0) == 3) break;
     HEAP32[i2 + (i1 << 2) >> 2] = 0;
     i1 = i1 + 1 | 0;
    }
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (gb + 1475488 + 288 | 0));
  }
  __THREW__ = 0;
  invoke_iii(fb + 1150 | 0, gb + 1475488 | 0, gb + 210240 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_iii(fb + 1150 | 0, gb + 1475488 + 12 | 0, gb + 210252 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    HEAP32[gb + 1475776 >> 2] = gb + 1475488;
    break;
   }
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return HEAP32[gb + 1475776 >> 2] | 0;
}

function __ZN9Rigidbody12SweepTestAllERK8Vector3ff23QueryTriggerInteraction(i3, i4, f5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1452828 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452828 | 0, i1);
  i2 = gb + 1452828 | 0;
 } else i2 = 0;
 i1 = HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 48 >> 2] | 0;
 if (i1 >>> 0 < 32) i1 = HEAP32[(HEAP32[(__Z21GetManagerFromContexti(9) | 0) + 724 >> 2] | 0) + (i1 << 2) >> 2] | 0; else i1 = -5;
 i8 = __Z21GetManagerFromContexti(9) | 0;
 i1 = __ZN5Unity12PhysicsQuery21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction(i8 + 736 | 0, HEAP32[i3 + 52 >> 2] | 0, i4, f5, i1, i6) | 0;
 if (!i2) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN19SkinnedMeshRenderer17SkinMeshImmediateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i4 = i6;
 i5 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i1, 8, 0) | 0;
 if (!i5) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (HEAP8[i5 + 93 >> 0] | 0) HEAP32[i5 + 96 >> 2] = __ZN4Mesh24QueryGpuSkinSourceBufferEi(HEAP32[i1 + 356 >> 2] | 0, HEAP32[i5 + 20 >> 2] | 0) | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN19SkinnedMeshRenderer8SkinMeshEP12SkinMeshInfobR9GfxDeviceP22GeometryJobInstructionRi(i1, i5, 1, i3, i2, i4);
 if ((HEAP32[i4 >> 2] | 0) == 1) mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 248 >> 2] | 0, i3 | 0, fb + 3391 | 0, i2 | 0, 1);
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN13ComputeShader7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i6 = i5;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(256, i1, 16, gb + 1048932 | 0, 0, gb + 477017 | 0, 168) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i3, i2);
 HEAP32[i4 >> 2] = gb + 67412 + 8;
 i1 = i4 + 32 | 0;
 i2 = i4 + 192 | 0;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN6Object8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034561 | 0, HEAP32[gb + 37260 >> 2] | 0, i1 + 28 | 0, 1);
 __Z46get_current_allocation_root_reference_internalv() | 0;
 __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i2, gb + 1041885 | 0, gb + 1041885 | 0, i3, 1);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1041891 | 0, HEAP32[gb + 36976 >> 2] | 0, i3 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z47AnimatorControllerPlayable_CUSTOM_SetBoolStringR9HPlayableP12Il2CppStringh(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 156 >> 2] | 0;
 i1 = __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0;
 HEAP8[i5 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = mftCall_iiii(i8 | 0, i7 | 0, i1 | 0, i5 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i8, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __Z11GetImageTagR11UTF16StringRi(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i5 = HEAP32[gb + 185396 + (i1 << 2) >> 2] | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  L3 : do if (!(i2 << 24 >> 24)) i10 = 6; else {
   i4 = 0;
   while (1) {
    i3 = i8 + i4 | 0;
    if ((i3 | 0) == (i6 | 0)) break L3;
    i11 = HEAP16[i9 + (i3 << 1) >> 1] & 255;
    i3 = i11 << 24 >> 24;
    i4 = i4 + 1 | 0;
    if ((((i11 + -65 & 255) < 26 ? i3 + 32 | 0 : i3) & 255) << 24 >> 24 != i2 << 24 >> 24) break L3;
    i2 = HEAP8[i5 + i4 >> 0] | 0;
    if (!(i2 << 24 >> 24)) {
     i10 = 6;
     break;
    }
   }
  } while (0);
  if ((i10 | 0) == 6) {
   i10 = 0;
   i2 = (_strlen(i5) | 0) + i8 | 0;
   if ((HEAP16[i9 + (i2 << 1) >> 1] | 0) == 61) break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 10) {
   i1 = -1;
   i10 = 9;
   break;
  }
 }
 if ((i10 | 0) == 9) return i1 | 0;
 HEAP32[i7 >> 2] = i2;
 i11 = i1;
 return i11 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 57;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 676356 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5Umbra5QueryC2EPKNS_14TomeCollectionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) return;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, 0, i2);
 return;
}

function __ZN12_GLOBAL__N_116CollectionSorter10AddElementERNS0_7ElementE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i6 + 28 | 0;
 if (HEAP8[i5 >> 0] | 0) return;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = i7 + 44 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  do {
   __ZN12_GLOBAL__N_116CollectionSorter10AddElementERNS0_7ElementE(i7, (HEAP32[i1 >> 2] | 0) + (HEAP32[i4 >> 2] << 5) | 0);
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 i1 = i7 + 64 | 0;
 i2 = i7 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i7 + 72 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  i7 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 + (i3 << 4) >> 2] = HEAP32[i6 >> 2];
  i4 = i6 + 8 | 0;
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  i7 = i7 + (i3 << 4) + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 + 4 >> 2] = i6;
  HEAP32[i2 >> 2] = i3 + 1;
 } else __ZN5physx6shdfnd5ArrayINS0_4PairIPNS_6PxBaseEyEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i1, i6) | 0;
 HEAP8[i5 >> 0] = 1;
 return;
}

function __ZN12GUIClipState8EndOnGUIER10InputEvent(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, f6 = f0, f7 = f0;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 - (HEAP32[i3 >> 2] | 0) | 0;
 do if ((i2 | 0) != 56 ? ((HEAP32[i4 >> 2] | 0) + -11 | 0) >>> 0 > 1 : 0) {
  if (((i2 | 0) / 56 | 0) >>> 0 > 1) {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017191 | 0, 0, gb + 1017283 | 0, 424, 1, 0, 0, 0);
   i1 = HEAP32[i5 >> 2] | 0;
   break;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017349 | 0, 0, gb + 1017283 | 0, 428, 1, 0, 0, 0);
  return;
 } while (0);
 HEAP32[i5 >> 2] = i1 + -56;
 i2 = i3 + 140 | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 148 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 144 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 152 >> 2]));
 HEAPF32[i4 + 12 >> 2] = f7;
 HEAPF32[i4 + 16 >> 2] = f6;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 return;
}

function __Z24tessMeshSetWindingNumberP8TESSmeshii(i4, i5, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i4 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i6 | 0)) {
  i7 = 1;
  return i7 | 0;
 }
 i7 = 0 - i5 | 0;
 if (!i2) {
  do {
   i4 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i3 = HEAP8[(HEAP32[i4 + 20 >> 2] | 0) + 21 >> 0] | 0;
   HEAP32[i4 + 28 >> 2] = (HEAP8[(HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 20 >> 2] | 0) + 21 >> 0] | 0) == i3 << 24 >> 24 ? 0 : i3 << 24 >> 24 ? i5 : i7;
  } while ((i1 | 0) != (i6 | 0));
  i1 = 1;
  return i1 | 0;
 }
 while (1) {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 21 >> 0] | 0;
  if ((HEAP8[(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 20 >> 2] | 0) + 21 >> 0] | 0) == i3 << 24 >> 24) {
   if (!(__Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge(i4, i2) | 0)) {
    i1 = 0;
    i2 = 8;
    break;
   }
  } else HEAP32[i2 + 28 >> 2] = i3 << 24 >> 24 ? i5 : i7;
  if ((i1 | 0) == (i6 | 0)) {
   i1 = 1;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __Z12pqExtractMinP9PriorityQ(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i1 + 12 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 if (!i5) {
  i8 = __Z16pqHeapExtractMinP13PriorityQHeap(HEAP32[i1 >> 2] | 0) | 0;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = HEAP32[HEAP32[i8 + (i5 + -1 << 2) >> 2] >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 do if (!(HEAP32[i1 + 8 >> 2] | 0)) i1 = i5; else {
  i2 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i2 + 24 >> 2]);
  f4 = Math_fround(HEAPF32[i7 + 24 >> 2]);
  if (!(f3 < f4)) {
   if (!(f3 == f4)) {
    i1 = i5;
    break;
   }
   f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
   if (!(f4 <= Math_fround(HEAPF32[i7 + 28 >> 2]))) {
    i1 = i5;
    break;
   }
  }
  i8 = __Z16pqHeapExtractMinP13PriorityQHeap(i1) | 0;
  return i8 | 0;
 } while (0);
 do {
  i2 = i1;
  i1 = i1 + -1 | 0;
  if ((i2 | 0) <= 1) break;
 } while (!(HEAP32[HEAP32[i8 + (i2 + -2 << 2) >> 2] >> 2] | 0));
 HEAP32[i6 >> 2] = i1;
 i8 = i7;
 return i8 | 0;
}

function ___crypt_r(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 L1 : do if ((HEAP8[i3 >> 0] | 0) == 36) {
  i5 = HEAP8[i3 + 1 >> 0] | 0;
  if (!(i5 << 24 >> 24)) i6 = 13; else {
   i1 = HEAP8[i3 + 2 >> 0] | 0;
   if (!(i1 << 24 >> 24)) i6 = 13; else {
    i1 = i1 << 24 >> 24 == 36;
    if (i5 << 24 >> 24 == 49 & i1) {
     i1 = ___crypt_md5(i2, i3, i4) | 0;
     break;
    }
    switch (i5 << 24 >> 24) {
    case 50:
     {
      if ((HEAP8[i3 + 3 >> 0] | 0) != 36) {
       i6 = 13;
       break L1;
      }
      i1 = ___crypt_blowfish(i2, i3, i4) | 0;
      break L1;
     }
    case 53:
     {
      if (!i1) {
       i6 = 13;
       break L1;
      }
      i1 = ___crypt_sha256(i2, i3, i4) | 0;
      break L1;
     }
    case 54:
     {
      if (!i1) {
       i6 = 13;
       break L1;
      }
      i1 = ___crypt_sha512(i2, i3, i4) | 0;
      break L1;
     }
    default:
     {
      i6 = 13;
      break L1;
     }
    }
   }
  }
 } else i6 = 13; while (0);
 if ((i6 | 0) == 13) i1 = ___crypt_des(i2, i3, i4) | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i7, i1, i2, i9, i10, i11, i3) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 if ((-18 - i7 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i8 = HEAP32[i6 >> 2] | 0; else i8 = i6;
 if (i7 >>> 0 < 2147483623) {
  i4 = i1 + i7 | 0;
  i5 = i7 << 1;
  i4 = i4 >>> 0 < i5 >>> 0 ? i5 : i4;
  i4 = i4 >>> 0 < 11 ? 11 : i4 + 16 & -16;
 } else i4 = -17;
 i5 = _malloc(i4) | 0;
 if (i9 | 0) _memcpy(i5 | 0, i8 | 0, i9 | 0) | 0;
 if (i11 | 0) _memcpy(i5 + i9 | 0, i3 | 0, i11 | 0) | 0;
 i1 = i2 - i10 | 0;
 i2 = i1 - i9 | 0;
 if (i2 | 0) _memcpy(i5 + i9 + i11 | 0, i8 + i9 + i10 | 0, i2 | 0) | 0;
 if ((i7 | 0) != 10) _free(i8);
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
 i11 = i1 + i11 | 0;
 HEAP32[i6 + 4 >> 2] = i11;
 HEAP8[i5 + i11 >> 0] = 0;
 return;
}

function __ZNK5physx14NpSceneQueries7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheE(i8, i7, i9, f2, i6, i5, i4, i3, i1) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 f2 = Math_fround(f2);
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i10;
 i11 = i10 + 24 | 0;
 HEAP32[i12 >> 2] = i7;
 HEAP32[i12 + 4 >> 2] = i9;
 HEAPF32[i12 + 8 >> 2] = f2;
 HEAP32[i12 + 12 >> 2] = 0;
 HEAP32[i12 + 16 >> 2] = 0;
 HEAPF32[i12 + 20 >> 2] = Math_fround(0.0);
 HEAP16[i11 >> 1] = HEAP16[i5 >> 1] | 0;
 i9 = __ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i8, i12, i6, i11, i1, i4, i3, 0) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5physx3Ext20DefaultCpuDispatcher13fetchNextTaskEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i5 + 16 >> 2] | 0) | 0;
 if (i1 | 0) {
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!(HEAP8[i1 + 8 >> 0] | 0)) {
   i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
   if (i1 | 0) {
    i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
   }
  } else {
   HEAP32[i2 >> 2] = 0;
   __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i5 + 12 >> 2] | 0, i1);
  }
  if (i3 | 0) {
   i5 = i3;
   return i5 | 0;
  }
 }
 i4 = i5 + 4 | 0;
 i2 = i5 + 28 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i3 = 0;
 while (1) {
  i1 = __ZN5physx3Ext15CpuWorkerThread9giveUpJobEv((HEAP32[i4 >> 2] | 0) + (i3 * 28 | 0) | 0) | 0;
  i3 = i3 + 1 | 0;
  if (i1 | 0) {
   i2 = 10;
   break;
  }
  if (i3 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZN4FMOD6System19getRecordDriverInfoEiPciP9FMOD_GUID(i3, i1, i6, i2, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP8[i6 >> 0] = HEAP8[gb + 869570 >> 0] | 0;
  HEAP8[i6 + 1 >> 0] = HEAP8[gb + 869570 + 1 >> 0] | 0;
  HEAP8[i6 + 2 >> 0] = HEAP8[gb + 869570 + 2 >> 0] | 0;
  HEAP8[i6 + 3 >> 0] = HEAP8[gb + 869570 + 3 >> 0] | 0;
  HEAP8[i6 + 4 >> 0] = HEAP8[gb + 869570 + 4 >> 0] | 0;
  HEAP8[i6 + 5 >> 0] = HEAP8[gb + 869570 + 5 >> 0] | 0;
  HEAP8[i6 + 6 >> 0] = HEAP8[gb + 869570 + 6 >> 0] | 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = 0;
  i7 = 0;
  STACKTOP = i5;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870268;
 _printf(gb + 853184 | 0, i4) | 0;
 i7 = 36;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN21AssetBundleFileSystem10AddArchiveEP20ArchiveStorageReader(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 108 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) {
  __ZN10FileSystem12MountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i5) | 0;
  HEAP8[i6 >> 0] = 1;
 }
 i4 = i5 + 92 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(160, gb + 63552 | 0, 16, gb + 585751 | 0, 59) | 0;
  i2 = i5 + 96 | 0;
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
  __ZN17ArchiveFileSystemC2EPKc(i1, i2);
  HEAP32[i4 >> 2] = i1;
 }
 i2 = __ZN17ArchiveFileSystem12MountArchiveEP20ArchiveStorageReader(i1, i3) | 0;
 if (i2) return i2 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) return i2 | 0;
 if ((HEAP32[i5 + 72 >> 2] | 0) != (HEAP32[i5 + 8 >> 2] | 0)) return i2 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return i2 | 0;
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) | 0) return i2 | 0;
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i5) | 0;
 HEAP8[i6 >> 0] = 0;
 return i2 | 0;
}

function __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig11ResetValuesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i3 = i8;
 HEAP32[i2 >> 2] = 1800;
 i4 = i2 + 4 | 0;
 i9 = HEAP32[i4 >> 2] | 0;
 i5 = i2 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i9;
 if ((i6 | 0) != (i9 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i7 | 0) >>> 2) << 2);
 HEAP32[i3 >> 2] = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_(i4, i1, gb + 189452 | 0, gb + 189452 + 24 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = 300;
 HEAP32[i2 + 24 >> 2] = 30;
 HEAP32[i2 + 28 >> 2] = 1;
 HEAP32[i2 + 32 >> 2] = 300;
 HEAP32[i2 + 36 >> 2] = 2592e3;
 HEAP32[i2 + 40 >> 2] = 20;
 HEAP32[i2 + 44 >> 2] = 60;
 STACKTOP = i8;
 return;
}

function __Z59GUIStyle_CUSTOM_Internal_GetNumCharactersThatFitWithinWidth13Il2Cpp_IntPtrP12Il2CppStringf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 48 | 0;
 i11 = i4 + 40 | 0;
 i6 = i4 + 20 | 0;
 i5 = i4 + 8 | 0;
 i8 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN11ICallStringC2EP12Il2CppString(i11, i2);
 __ZNK11ICallString6ToUTF8Ev(i5, i11);
 i2 = (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5;
 i11 = gb + 63672 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN11UTF16StringC2EPKc10MemLabelId(i6, i2, i7);
 i2 = __ZNK8GUIStyle34GetNumCharactersThatFitWithinWidthERK11UTF16Stringf(i1, i6, f3) | 0;
 __ZN11UTF16StringD2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i4;
 return i2 | 0;
}

function __Z30AddTransformComponentUncheckedR10GameObjecti(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i7 = gb + 63520 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i1 = __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode(i1, 0, i4, 0) | 0;
 if (!i1) {
  i8 = 0;
  STACKTOP = i3;
  return i8 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE(i2, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 i8 = i1;
 STACKTOP = i3;
 return i8 | 0;
}

function _UNITY_ft_base_pic_init(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 i2 = _UNITY_ft_mem_alloc(HEAP32[i4 >> 2] | 0, 140, i5) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 _memset(i2 | 0, 0, 140) | 0;
 i3 = i4 + 188 | 0;
 HEAP32[i3 >> 2] = i2;
 i1 = _UNITY_ft_create_default_module_classes(i4) | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  _UNITY_FT_Init_Class_ft_outline_glyph_class(i2 + 4 | 0);
  _UNITY_FT_Init_Class_ft_bitmap_glyph_class(i2 + 36 | 0);
  _FT_Init_Table_ft_raccess_guess_table(i2 + 68 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 _UNITY_ft_destroy_default_module_classes(i4);
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK14SoundHandleAPI16GetBitsPerSampleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((HEAP32[i1 + 44 >> 2] | 0) != 3) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(HEAP32[i1 + 40 >> 2] | 0, 0, 0, 0, i3) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 615;
  HEAP32[i4 + 8 >> 2] = gb + 872649;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i5 | 0, (i4 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
 }
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + i1 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 if ((i2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) < 0) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i4 = mftCall_iiiiii(i2 | 0, i3 | 0, i5 | 0, (i4 ? gb + 768950 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
 }
 i1 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + i1 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 if ((i2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) < 0) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 677076 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Scb5Scene11addMaterialERNS_2Sc12MaterialCoreE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = i6 + 2428 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 20 >> 2];
 i2 = i6 + 2416 | 0;
 i3 = i6 + 2420 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 2424 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i8 = i5;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i6 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return 1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i5) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i7;
  return 1;
 }
 return 0;
}

function __ZN5Unity17ConfigurableJoint9SetZDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 228 >> 2] = f5;
 HEAPF32[i2 + 232 >> 2] = f4;
 HEAPF32[i2 + 236 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint9SetYDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 216 >> 2] = f5;
 HEAPF32[i2 + 220 >> 2] = f4;
 HEAPF32[i2 + 224 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint9SetXDriveERK10JointDrive(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i6 = f5 < Math_fround(0.0);
 i7 = f5 > Math_fround(340282326000000008404918.0e15);
 f5 = i7 ? Math_fround(340282326000000008404918.0e15) : f5;
 f5 = i6 ? Math_fround(0.0) : f5;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(340282326000000008404918.0e15);
 f4 = i7 ? Math_fround(340282326000000008404918.0e15) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i6 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i6 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 + 204 >> 2] = f5;
 HEAPF32[i2 + 208 >> 2] = f4;
 HEAPF32[i2 + 212 >> 2] = f3;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN4Mesh18CreateMeshIfNeededEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 36 | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0;
 do if (i1 | 0) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
   i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
   if (!i1) break;
   if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
    i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0;
    if (!i1) break;
    if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
     i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0;
     if (!i1) break;
     if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) break;
    }
   }
  }
  i1 = i3 + 44 | 0;
  HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 1;
 } while (0);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 if (i1 | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
  i2 = i3 + 44 | 0;
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 2;
 }
 if (!(HEAP8[i3 + 44 >> 0] & 3)) return;
 __ZN4Mesh10CreateMeshEv(i3);
 return;
}

function __ZN22RenderingCommandBuffer19AddSetGlobalTextureERKN9ShaderLab16FastPropertyNameERK18RenderTextureParam(i12, i1, i2) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i10 = HEAP32[i2 + 8 >> 2] | 0;
 i11 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i12 + 8 | 0;
 i7 = i12 + 24 | 0;
 i4 = (HEAP32[i7 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i12 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i3;
 i3 = i12 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 14;
 i4 = i4 + 7 & -4;
 i5 = i4 + 20 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 i7 = i1 + i4 | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = i10;
 HEAP32[i7 + 8 >> 2] = i11;
 HEAP32[i7 + 12 >> 2] = i8;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP8[i12 + 36 >> 0] = 1;
 return;
}

function __ZN21PxsParallelSolverTask11runInternalEv(i1) {
 i1 = i1 | 0;
 mftCall_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii(HEAP32[gb + 106200 + (HEAP32[i1 + 148 >> 2] << 2) >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 44 >> 2] | 0, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, HEAP32[i1 + 56 >> 2] | 0, HEAP32[i1 + 60 >> 2] | 0, HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0, HEAP32[i1 + 64 >> 2] | 0, HEAP32[i1 + 92 >> 2] | 0, HEAP32[i1 + 68 >> 2] | 0, HEAP32[i1 + 96 >> 2] | 0, HEAP32[i1 + 108 >> 2] | 0, HEAP32[i1 + 112 >> 2] | 0, HEAP32[i1 + 116 >> 2] | 0, HEAP32[i1 + 120 >> 2] | 0, HEAP32[i1 + 124 >> 2] | 0, HEAP32[i1 + 132 >> 2] | 0, HEAP32[i1 + 140 >> 2] | 0, HEAP32[i1 + 144 >> 2] | 0, HEAP32[i1 + 128 >> 2] | 0, HEAP32[i1 + 76 >> 2] | 0, HEAP32[i1 + 80 >> 2] | 0, HEAP32[i1 + 104 >> 2] | 0, HEAP32[i1 + 84 >> 2] | 0, HEAP32[i1 + 88 >> 2] | 0, HEAP32[i1 + 136 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, HEAP32[i1 + 152 >> 2] | 0, HEAP32[i1 + 156 >> 2] | 0);
 return;
}

function __ZN16b2PolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152144 + 8;
 return i2 | 0;
}

function __ZN16b2CapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 151944 + 8;
 return i2 | 0;
}

function __ZN12AudioManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 171696 + 8;
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 180 | 0);
 i1 = i2 + 140 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 152 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 i5 = i2 + 44 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 28648 + 8;
 HEAP32[i2 >> 2] = gb + 28496 + 8;
 STACKTOP = i4;
 return;
}

function __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb(i7, i2, i4, i5) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i8 = 0;
 i6 = i4 + 4 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP8[i7 >> 0] = 1;
  HEAP32[i7 + 4 >> 2] = 0;
  HEAP32[i7 + 8 >> 2] = 0;
  HEAP32[i7 + 12 >> 2] = -1;
  return;
 }
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(i2) | 0;
 i3 = i4 + 12 | 0;
 i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i3 >> 2] | 0) | 0 : i1) >> 2] | 0;
 i8 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i2) | 0) | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i8 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
  if (i5) {
   i5 = __Z26scripting_field_get_offsetP9FieldInfo(i2) | 0;
   HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP8[i4 >> 0] | 0) == 0 ? i5 + -8 + (HEAP32[i3 >> 2] | 0) | 0 : i5) >> 2] = i1;
  }
 }
 HEAP8[i7 >> 0] = 1;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i7 + 8 >> 2] = i8;
 HEAP32[i7 + 12 >> 2] = -1;
 return;
}

function _UNITY_png_get_cHRM_XYZ(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i11 = 0;
  return i11 | 0;
 }
 if (!(HEAP16[i2 + 114 >> 1] & 2)) {
  i11 = 0;
  return i11 | 0;
 }
 if (i4 | 0) HEAPF64[i4 >> 3] = +(HEAP32[i2 + 76 >> 2] | 0) * 1.0e-05;
 if (i5 | 0) HEAPF64[i5 >> 3] = +(HEAP32[i2 + 80 >> 2] | 0) * 1.0e-05;
 if (i6 | 0) HEAPF64[i6 >> 3] = +(HEAP32[i2 + 84 >> 2] | 0) * 1.0e-05;
 if (i7 | 0) HEAPF64[i7 >> 3] = +(HEAP32[i2 + 88 >> 2] | 0) * 1.0e-05;
 if (i8 | 0) HEAPF64[i8 >> 3] = +(HEAP32[i2 + 92 >> 2] | 0) * 1.0e-05;
 if (i9 | 0) HEAPF64[i9 >> 3] = +(HEAP32[i2 + 96 >> 2] | 0) * 1.0e-05;
 if (i10 | 0) HEAPF64[i10 >> 3] = +(HEAP32[i2 + 100 >> 2] | 0) * 1.0e-05;
 if (i11 | 0) HEAPF64[i11 >> 3] = +(HEAP32[i2 + 104 >> 2] | 0) * 1.0e-05;
 if (!i3) {
  i11 = 4;
  return i11 | 0;
 }
 HEAPF64[i3 >> 3] = +(HEAP32[i2 + 108 >> 2] | 0) * 1.0e-05;
 i11 = 4;
 return i11 | 0;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIyyEEPyEEvT0_S5_T_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 16 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_(i9, i9 + 8 | 0, i8, i1) | 0;
 i6 = i9 + 24 | 0;
 i1 = i8;
 while (1) {
  if ((i6 | 0) == (i10 | 0)) break;
  i7 = i6;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if (i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i8 >>> 0 < i2 >>> 0) {
   i4 = i6;
   i5 = i2;
   while (1) {
    HEAP32[i4 >> 2] = i5;
    HEAP32[i4 + 4 >> 2] = i3;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
    i2 = i1 + -8 | 0;
    i3 = i2;
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i7 >>> 0 < i3 >>> 0 | (i7 | 0) == (i3 | 0) & i8 >>> 0 < i5 >>> 0)) break; else {
     i4 = i1;
     i1 = i2;
    }
   }
   i5 = i1;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i5 + 4 >> 2] = i7;
  }
  i1 = i6;
  i6 = i6 + 8 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_(i9, i10, i1) {
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i9 + 16 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_(i9, i9 + 8 | 0, i8, i1) | 0;
 i6 = i9 + 24 | 0;
 i1 = i8;
 while (1) {
  if ((i6 | 0) == (i10 | 0)) break;
  i7 = i6;
  i8 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i3 = i1;
  i2 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  if ((i7 | 0) < (i3 | 0) | (i7 | 0) == (i3 | 0) & i8 >>> 0 < i2 >>> 0) {
   i4 = i6;
   i5 = i2;
   while (1) {
    HEAP32[i4 >> 2] = i5;
    HEAP32[i4 + 4 >> 2] = i3;
    if ((i1 | 0) == (i9 | 0)) {
     i1 = i9;
     break;
    }
    i2 = i1 + -8 | 0;
    i3 = i2;
    i5 = HEAP32[i3 >> 2] | 0;
    i3 = HEAP32[i3 + 4 >> 2] | 0;
    if (!((i7 | 0) < (i3 | 0) | (i7 | 0) == (i3 | 0) & i8 >>> 0 < i5 >>> 0)) break; else {
     i4 = i1;
     i1 = i2;
    }
   }
   i5 = i1;
   HEAP32[i5 >> 2] = i8;
   HEAP32[i5 + 4 >> 2] = i7;
  }
  i1 = i6;
  i6 = i6 + 8 | 0;
 }
 return;
}

function __ZN9Rigidbody4MoveERK8Vector3fRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i8 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i10;
 HEAP32[i4 + 8 >> 2] = i9;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i7;
 HEAP32[i4 + 20 >> 2] = i6;
 HEAP32[i4 + 24 >> 2] = i2;
 if (!(HEAP8[i1 + 84 >> 0] | 0)) {
  i10 = HEAP32[i1 + 52 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i10 >> 2] | 0) + 88 >> 2] | 0, i10 | 0, i4 | 0, 1);
  STACKTOP = i5;
  return;
 }
 if (HEAP8[i1 + 80 >> 0] | 0) {
  i10 = HEAP32[i1 + 52 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 224 >> 2] | 0, i10 | 0, i4 | 0);
 }
 i10 = i1 + 104 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -2;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc19ParticlePacketShape19reallocInteractionsERPPNS0_35ParticleElementRbElementInteractionERttt(i7, i6, i5, i4, i2) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 & 65535;
 do if (!(i2 << 16 >> 16)) {
  i2 = 0;
  i3 = 0;
 } else if ((i2 & 65535) < 5) {
  i2 = 4;
  i3 = i7 + 20 | 0;
  break;
 } else {
  i3 = i1 + -1 | 0;
  i3 = i3 >>> 1 | i3;
  i3 = i3 >>> 2 | i3;
  i3 = i3 >>> 4 | i3;
  i3 = i3 >>> 8 | i3;
  i3 = (i3 >>> 16 | i3) + 1 | 0;
  i2 = i3 & 65535;
  i3 = __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj(HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 36 >> 2] | 0, i3 & 65535) | 0;
  break;
 } while (0);
 _memcpy(i3 | 0, HEAP32[i6 >> 2] | 0, (i4 & 65535) << 2 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == 0 | (i1 | 0) == (i7 + 20 | 0)) {
  HEAP16[i5 >> 1] = i2;
  HEAP32[i6 >> 2] = i3;
  return;
 }
 __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[(HEAP32[i7 + 8 >> 2] | 0) + 36 >> 2] | 0, i1, HEAPU16[i5 >> 1] | 0);
 HEAP16[i5 >> 1] = i2;
 HEAP32[i6 >> 2] = i3;
 return;
}

function __ZN5Umbra14TomeCollection4initEPvj(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i1 = (i4 | 0) == 0 ? 0 : i4 + 3 & -4;
 i7 = i1 + 28 | 0;
 i8 = i1 + 24 | 0;
 if (!(HEAP8[i8 >> 0] | 0)) {
  i1 = i1 + 32 | 0;
  i2 = i7;
 } else {
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = i1 + 32 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i2 = i7; else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
   i2 = i7;
  }
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i8 >> 0] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 80192 + 8;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = gb + 80216 + 8;
 HEAP32[i4 + 12 >> 2] = i5;
 HEAP32[i4 + 16 >> 2] = i6;
 HEAP8[i4 + 20 >> 0] = 0;
 HEAP8[i4 + 24 >> 0] = 0;
 i8 = i4 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 return;
}

function __ZN5Umbra11checkStatusEPKNS_7ImpTomeEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i3) {
  i4 = 1;
  return i4 | 0;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i4 & 65535;
 if ((i4 & -65536 | 0) != -704643072) {
  i4 = (i2 | 0) == 214 ? 5 : 2;
  return i4 | 0;
 }
 if ((i2 | 0) != 18) {
  i4 = i2 >>> 0 > 18 ? 4 : 3;
  return i4 | 0;
 }
 if (i3 & 15 | 0) {
  i4 = 6;
  return i4 | 0;
 }
 if (i1) {
  i1 = (HEAP32[i3 + 8 >> 2] | 0) + -8 | 0;
  i4 = i3 + 4 | 0;
  if (!i1) i1 = 0; else {
   i3 = -1;
   i2 = i4;
   do {
    i2 = i2 + 4 | 0;
    i5 = HEAP32[i2 >> 2] | 0;
    i6 = HEAP32[gb + 79084 + (((i5 ^ i3) & 255) << 2) >> 2] ^ i3 >>> 8;
    i6 = i6 >>> 8 ^ HEAP32[gb + 79084 + (((i6 ^ i5 >>> 8) & 255) << 2) >> 2];
    i6 = i6 >>> 8 ^ HEAP32[gb + 79084 + (((i6 ^ i5 >>> 16) & 255) << 2) >> 2];
    i3 = i6 >>> 8 ^ HEAP32[gb + 79084 + ((i6 & 255 ^ i5 >>> 24) << 2) >> 2];
    i1 = i1 + -4 | 0;
   } while ((i1 | 0) != 0);
   i1 = ~i3;
  }
  if ((i1 | 0) != (HEAP32[i4 >> 2] | 0)) {
   i6 = 2;
   return i6 | 0;
  }
 }
 i6 = 0;
 return i6 | 0;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float4EEEclERS4_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] << 4, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 4) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN2UI6Canvas25SetReferencePixelsPerUnitEf(i5, f2) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i4 = i7;
 HEAPF32[i4 >> 2] = f2;
 i1 = HEAP32[i5 + 344 >> 2] | 0;
 if (i1 | 0) {
  __ZN2UI6Canvas25SetReferencePixelsPerUnitEf(i1, f2);
  STACKTOP = i7;
  return;
 }
 HEAPF32[i6 >> 2] = Math_fround(.0000999999974);
 i3 = f2 < Math_fround(.0000999999974);
 i3 = HEAP32[(i3 ? i6 : i4) >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 f2 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = i5 + 356 | 0;
 if (f2 == Math_fround(HEAPF32[i1 >> 2])) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1106036 | 0, i6);
 STACKTOP = i7;
 return;
}

function __ZN16MemoryFileSystem18CreateFileFromDataEPKcPvjb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 i1 = __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb(i1, i2, 1) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i9 = i2 + 4 | 0;
  HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
  if (!(HEAP32[i9 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  }
 }
 i9 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63552 | 0, 16, gb + 492052 | 0, 51) | 0;
 i11 = gb + 63552 | 0;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i2 + 4 >> 2] = i10;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb(i9, i7, i3, i4, i5);
 HEAP32[i1 >> 2] = i9;
 STACKTOP = i8;
 return 1;
}

function __ZN15b2CircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator(i5, i1, i6, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f7 = f0, f8 = f0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i3, 156) | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 124 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i3 = i2 + 8 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i2 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i2 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i2 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 >> 2] = gb + 152024 + 8;
 return i2 | 0;
}

function __ZN14VelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 272 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 536 | 0, i5);
 i1 = i1 + 800 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 1);
  i6 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i6 = i3;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 }
}

function __ZN14RotationModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 4 | 0;
 i5 = i4 + 16 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i2, 1); else {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 i3 = i1 + 28 | 0;
 if (!((HEAP32[i4 >> 2] & 33554432 | 0) != 0 & (HEAP8[i3 >> 0] | 0) == 0)) {
  i2 = i1 + 32 | 0;
  __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags(i4, i2, 0);
  __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv(i2);
 }
 i2 = i4 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i3, 1); else {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 }
 if (!i5) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z48AnimatorControllerPlayable_CUSTOM_SetFloatStringR9HPlayableP12Il2CppStringf(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 12 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAPF32[i7 >> 2] = f2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0;
 i1 = mftCall_iiii(i8 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i7 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i8, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __Z29StdTemplateConversionFunctionItbEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 << 16 >> 16 != 0;
  i7 = i7 & 1;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 << 16 >> 16 != 0;
 i7 = i7 & 1;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIsbEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 << 16 >> 16 != 0;
  i7 = i7 & 1;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 << 16 >> 16 != 0;
 i7 = i7 & 1;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z23DeleteSparseTextureGLES9TextureID(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 1451152 + 4 >> 2] | 0;
 if (!i5) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = gb + 1451152 + 4 | 0;
 i2 = i5;
 L4 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L4;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (gb + 1451152 + 4 | 0)) return;
 if (i4 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0) return;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[gb + 1451152 >> 2] | 0) == (i3 | 0)) HEAP32[gb + 1451152 >> 2] = i1;
 HEAP32[gb + 1451152 + 8 >> 2] = (HEAP32[gb + 1451152 + 8 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i5, i3);
 __ZdlPv(i3);
 return;
}

function __Z17FMODMemoryReallocPvjjPKc(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 switch ((i5 & 65535) << 16 >> 16) {
 case 2:
 case 1:
  {
   i7 = gb + 63368 | 0;
   i6 = HEAP32[i7 + 4 >> 2] | 0;
   i5 = i1;
   HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
   HEAP32[i5 + 4 >> 2] = i6;
   break;
  }
 case 4:
  {
   i5 = gb + 63376 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 case 8:
  {
   i5 = gb + 63384 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
   break;
  }
 default:
  {
   i5 = gb + 63360 | 0;
   i6 = HEAP32[i5 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
   HEAP32[i7 + 4 >> 2] = i6;
  }
 }
 i7 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i3, i4, 16, i1, 0, gb + 856220 | 0, 166) | 0;
 STACKTOP = i2;
 return i7 | 0;
}

function __Z13SetGLViewportRK5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i1 = __Z12GetGfxDevicev() | 0;
 f10 = Math_fround(f9 + Math_fround(.5));
 i7 = f10 >= Math_fround(0.0);
 f11 = Math_fround(f10 + Math_fround(-.99999994));
 i7 = ~~(i7 ? f10 : f11);
 HEAP32[i3 >> 2] = i7;
 f11 = Math_fround(f6 + Math_fround(.5));
 i4 = f11 >= Math_fround(0.0);
 f10 = Math_fround(f11 + Math_fround(-.99999994));
 i4 = ~~(i4 ? f11 : f10);
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = (~~Math_fround(Math_fround(f9 + f8) + Math_fround(.5)) >>> 0) - i7;
 HEAP32[i3 + 12 >> 2] = (~~Math_fround(Math_fround(f6 + f5) + Math_fround(.5)) >>> 0) - i4;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK14SoundHandleAPI14GetNumChannelsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((HEAP32[i1 + 44 >> 2] | 0) != 3) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(HEAP32[i1 + 40 >> 2] | 0, 0, 0, i3, 0) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 597;
  HEAP32[i4 + 8 >> 2] = gb + 872530;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 677606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 726138 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 726006 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN21EnlightenSceneMapping14SetSceneHandleEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 60 | 0;
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 76 | 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i7) return;
 HEAP32[i2 >> 2] = 1;
 i4 = HEAP32[i3 >> 2] | 0;
 do if (!(i4 & 2147483647)) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, 28, 4, i1 + 64 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 4, i1 + 64 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 28 | 0) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i5;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = i7;
 return;
}

function __ZN17PersistentManager25ExtractAwakeFromLoadQueueER18AwakeFromLoadQueue(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue(i5, i1);
 i4 = i5 + 168 | 0;
 i2 = i5 + 172 | 0;
 HEAP32[i2 >> 2] = 32;
 HEAP32[i5 + 184 >> 2] = 16;
 HEAP32[i5 + 180 >> 2] = 6;
 HEAP8[i5 + 188 >> 0] = 0;
 i1 = __Znwj(640) | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!i3) i2 = 32; else {
  __ZdlPv(i3);
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i2 = i1 + (i2 * 20 | 0) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i4 = i5 + 176 | 0;
  HEAP32[i4 >> 2] = 0;
  i5 = i5 + 120 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i3 = i5 + 148 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i4 = i5 + 176 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i5 + 120 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN14TerrainManager10AddTerrainEP7Terrain(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i6 = i3;
 i7 = i4 + 4 | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 L1 : do if ((i2 | 0) == (i7 | 0)) {
  i1 = i2;
  i8 = 5;
 } else {
  i1 = i2;
  do {
   if ((HEAP32[i2 + 8 >> 2] | 0) == (i3 | 0)) {
    i8 = 5;
    break L1;
   }
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
  } while ((i1 | 0) != (i7 | 0));
 } while (0);
 if ((i8 | 0) == 5) if ((i1 | 0) != (i7 | 0)) {
  STACKTOP = i9;
  return;
 }
 i8 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i5 >> 2] = 52;
 HEAP32[i5 + 4 >> 2] = i8;
 i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i8 + 8 >> 2] = i6;
 HEAP32[i8 + 4 >> 2] = i7;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i8 >> 2] = i6;
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i7 >> 2] = i8;
 i8 = i4 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
 STACKTOP = i9;
 return;
}

function __Z25Animation_CUSTOM_GetStateP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = __ZN9Animation8GetStateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i4 = __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i3, HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 4 >> 2] | 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function _tre_ast_to_tnfa(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 L1 : while (1) {
  switch (HEAP32[i1 >> 2] | 0) {
  case 2:
   {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if ((HEAP32[i2 + 8 >> 2] | 0) == -1) {
     i1 = HEAP32[i2 >> 2] | 0;
     i1 = _tre_make_trans(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, i4, i5, i6) | 0;
     if (!i1) i1 = i2; else break L1;
    } else i1 = i2;
    break;
   }
  case 3:
   {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i1 = _tre_ast_to_tnfa(HEAP32[i2 >> 2] | 0, i4, i5, i6) | 0;
    if (i1 | 0) break L1;
    i1 = i2 + 4 | 0;
    break;
   }
  case 1:
   {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i3 = i2 + 4 | 0;
    i1 = _tre_make_trans(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i4, i5, i6) | 0;
    if (i1 | 0) break L1;
    i1 = _tre_ast_to_tnfa(HEAP32[i2 >> 2] | 0, i4, i5, i6) | 0;
    if (!i1) i1 = i3; else break L1;
    break;
   }
  default:
   {
    i1 = 0;
    break L1;
   }
  }
  i1 = HEAP32[i1 >> 2] | 0;
 }
 return i1 | 0;
}
function ___rem_pio2f(f3, i6) {
 f3 = Math_fround(f3);
 i6 = i6 | 0;
 var i1 = 0, d2 = 0.0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, d9 = 0.0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 i5 = i8;
 i7 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = i7 & 2147483647;
 do if (i4 >>> 0 < 1305022427) {
  d9 = +f3;
  d2 = d9 * .6366197723675814 + 6755399441055744.0 + -6755399441055744.0;
  HEAPF64[i6 >> 3] = d9 - d2 * 1.5707963109016418 - d2 * 1.5893254773528196e-08;
  i1 = ~~d2;
 } else {
  if (i4 >>> 0 > 2139095039) {
   HEAPF64[i6 >> 3] = +Math_fround(f3 - f3);
   i1 = 0;
   break;
  }
  i10 = (i4 >>> 23) + -150 | 0;
  HEAPF64[i1 >> 3] = +(HEAP32[tempDoublePtr >> 2] = i4 - (i10 << 23), Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = ___rem_pio2_large(i1, i5, i10, 1, 0) | 0;
  d2 = +HEAPF64[i5 >> 3];
  if ((i7 | 0) < 0) {
   HEAPF64[i6 >> 3] = -d2;
   i1 = 0 - i1 | 0;
   break;
  } else {
   HEAPF64[i6 >> 3] = d2;
   break;
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i11 = i7;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i7, i4, i5, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = i7 + 11 | 0;
 i1 = HEAP8[i8 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = HEAP32[i7 + 4 >> 2] | 0; else i3 = i1 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7);
 if (i5 | 0) {
  if (i2) i1 = (HEAP32[i7 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
  if ((i1 - i3 | 0) >>> 0 < i5 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i7, i1, i3 + i5 - i1 | 0, i3, i4, 0, i5);
   i2 = HEAP32[i7 >> 2] | 0;
  } else {
   if (i2) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
   i1 = i3 - i4 | 0;
   if (i1) {
    i9 = i2 + i4 | 0;
    _memmove(i9 + i5 | 0, i9 | 0, i1 | 0) | 0;
   }
  }
  _memset(i2 + i4 | 0, i6 | 0, i5 | 0) | 0;
  i1 = i3 + i5 | 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
 }
 return i7 | 0;
}

function __ZN9AudioClip17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[gb + 1459900 >> 2] = (HEAP32[gb + 1459900 >> 2] | 0) + -1;
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (!i1) i2 = 3; else if (!(HEAP8[i1 + 224 >> 0] | 0)) i2 = 3;
 if ((i2 | 0) == 3) {
  __ZN11SoundHandle7ReleaseEv(i3 + 56 | 0);
  i1 = HEAP8[i3 + 72 + 11 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 76 >> 2] | 0; else i1 = i1 & 255;
  if (i1 | 0) if (__Z24GetManagerPtrFromContexti(3) | 0) __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i3);
 }
 i2 = i3 + 124 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 36 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63328 | 0);
   HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] = 0;
  }
 }
 i1 = i3 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 112 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN5physx20PxActorGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 13;
 HEAP32[i1 + 8 >> 2] = fb + 2111;
 HEAP32[i1 + 12 >> 2] = gb + 741602;
 HEAP32[i1 + 16 >> 2] = 14;
 HEAP32[i1 + 20 >> 2] = fb + 2112;
 HEAP32[i1 + 24 >> 2] = fb + 3490;
 HEAP32[i1 + 28 >> 2] = gb + 673441;
 HEAP32[i1 + 32 >> 2] = 15;
 HEAP32[i1 + 36 >> 2] = fb + 2113;
 HEAP32[i1 + 40 >> 2] = fb + 3491;
 HEAP32[i1 + 44 >> 2] = gb + 673452;
 HEAP32[i1 + 48 >> 2] = 16;
 HEAP32[i1 + 52 >> 2] = fb + 2114;
 HEAP32[i1 + 56 >> 2] = fb + 3492;
 HEAP32[i1 + 60 >> 2] = gb + 673467;
 HEAP32[i1 + 64 >> 2] = 17;
 HEAP32[i1 + 68 >> 2] = fb + 2115;
 HEAP32[i1 + 72 >> 2] = fb + 3493;
 HEAP32[i1 + 76 >> 2] = gb + 673479;
 HEAP32[i1 + 80 >> 2] = 18;
 HEAP32[i1 + 84 >> 2] = fb + 2116;
 HEAP32[i1 + 88 >> 2] = fb + 3494;
 HEAP32[i1 + 92 >> 2] = gb + 673499;
 HEAP32[i1 + 96 >> 2] = 19;
 HEAP32[i1 + 100 >> 2] = fb + 2117;
 HEAP32[i1 + 104 >> 2] = gb + 741613;
 HEAP32[i1 + 108 >> 2] = 20;
 HEAP32[i1 + 112 >> 2] = fb + 2118;
 HEAP32[i1 + 116 >> 2] = fb + 3495;
 return;
}

function __ZN15HeightMeshQuery16RemoveHeightDataEi(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i6 + 4 | 0;
 i5 = i6 + 8 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 if (!i8) return; else {
  i3 = i5;
  i2 = i8;
 }
 L3 : while (1) {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 + 16 >> 2] | 0) >= (i4 | 0)) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L3;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) return;
 if ((i3 | 0) == (i5 | 0) ? 1 : (HEAP32[i3 + 16 >> 2] | 0) > (i4 | 0)) return;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i2 = i3;
  while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  }
 } else while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) HEAP32[i7 >> 2] = i1;
 i7 = i6 + 12 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_(i8, i3);
 __ZdlPv(i3);
 return;
}

function __ZN14b2CapsuleShape13SetByExtentsYEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 HEAPF32[i1 + 8 >> 2] = f2;
 f3 = Math_fround(f3 * Math_fround(.5));
 f5 = Math_fround(-f3);
 HEAP32[i1 + 12 >> 2] = 0;
 HEAPF32[i1 + 16 >> 2] = f5;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i1 + 24 >> 2] = f3;
 HEAP32[i1 + 176 >> 2] = 4;
 f4 = Math_fround(-f2);
 HEAPF32[i1 + 48 >> 2] = f4;
 HEAPF32[i1 + 52 >> 2] = f5;
 HEAPF32[i1 + 56 >> 2] = f2;
 HEAPF32[i1 + 60 >> 2] = f5;
 HEAPF32[i1 + 64 >> 2] = f2;
 HEAPF32[i1 + 68 >> 2] = f3;
 HEAPF32[i1 + 72 >> 2] = f4;
 HEAPF32[i1 + 76 >> 2] = f3;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __Z41ParticleSystem_ShapeModule_CUSTOM_SetMeshP12Il2CppObjectS0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = i1 + 48 | 0;
 i1 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 i2 = i3 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i3 + 72 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 725876 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN23TransformChangeDispatch14RegisterSystemENS_12InterestTypeE(i6, i8) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i2 = i6 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = 0;
 while (1) {
  i7 = 1 << i5;
  if (!(i3 & i7)) break;
  i1 = i5 + 1 | 0;
  if (i1 >>> 0 < 32) i5 = i1; else {
   i4 = 4;
   break;
  }
 }
 if ((i4 | 0) == 4) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 422042 | 0, 0, gb + 421957 | 0, 248, 1, 0, 0, 0);
  i8 = -1;
  return i8 | 0;
 }
 HEAP32[i2 >> 2] = i3 | i7;
 i1 = i6 + 20 | 0;
 if (i8 & 1 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i1 = i6 + 24 | 0;
 if (i8 & 2 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i1 = i6 + 28 | 0;
 if (i8 & 4 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i1 = i6 + 32 | 0;
 if (i8 & 8 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i1 = i6 + 36 | 0;
 if (i8 & 16 | 0) HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i1 = i6 + 40 | 0;
 if (!(i8 & 32)) {
  i8 = i5;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
 i8 = i5;
 return i8 | 0;
}

function __ZL16DrawMeshInternalRK14ChannelAssignsR4MeshRK10Matrix4x4fi13TransformType(i7, i8, i1, i2, i3) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i11;
 i10 = __Z12GetGfxDevicev() | 0;
 i4 = i9;
 i5 = mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 128 >> 2] | 0, i10 | 0) | 0;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 __Z17SetupObjectMatrixRK10Matrix4x4fi(i1, i3);
 if ((i2 | 0) == -1) {
  i2 = __ZNK4Mesh15GetSubMeshCountEv(i8) | 0;
  if ((i2 | 0) > 0) {
   i1 = 0;
   do {
    __ZN8DrawUtil11DrawMeshRawERK14ChannelAssignsR4MeshiiPS3_(i7, i8, i1, 0, 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 } else __ZN8DrawUtil11DrawMeshRawERK14ChannelAssignsR4MeshiiPS3_(i7, i8, i2, 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 108 >> 2] | 0, i10 | 0, i9 | 0);
 STACKTOP = i11;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 679825 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 3, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i8 = i2;
   i10 = i8;
   i10 = HEAPU16[i10 >> 1] | HEAPU16[i10 + 2 >> 1] << 16;
   i8 = i8 + 4 | 0;
   i8 = HEAPU16[i8 >> 1] | HEAPU16[i8 + 2 >> 1] << 16;
   i7 = i1;
   i9 = i7;
   HEAP16[i9 >> 1] = i10;
   HEAP16[i9 + 2 >> 1] = i10 >>> 16;
   i7 = i7 + 4 | 0;
   HEAP16[i7 >> 1] = i8;
   HEAP16[i7 + 2 >> 1] = i8 >>> 16;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx33PxParticleReadDataGeneratedValuesC2EPKNS_18PxParticleReadDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 12 >> 2];
 i5 = i1 + 16 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 32 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 40 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 36 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 48 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 56 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sn5ConvX13registerUnionEPKc(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i6 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i5, 1, gb + 671646 | 0, i2);
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 >> 2] = i1;
 i2 = i5 + 292 | 0;
 i3 = i5 + 296 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i5 + 300 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  i5 = i2 + (i4 << 4) | 0;
  HEAP32[i5 >> 2] = i1;
  __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE(i2 + (i4 << 4) + 4 | 0, i6 + 4 | 0);
  HEAP32[i5 >> 2] = i1;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  STACKTOP = i7;
  return 1;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn5UnionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i6) | 0;
  STACKTOP = i7;
  return 1;
 }
 return 0;
}

function __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI14SafeBinaryReadEEvRS5_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 839349 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI14SphereColliderE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, gb + 839349 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI14SphereColliderE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN10SizeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 272 | 0, i5);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 536 | 0, i5);
 i1 = i1 + 800 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 1);
  i6 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i6 = i3;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 }
}

function ___fputwc_unlocked(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i5 + 74 | 0;
 i2 = HEAP16[i3 >> 1] | 0;
 i7 = (i2 & 65535) << 24 >> 24;
 HEAP8[i3 >> 0] = i7 + 1 | i7;
 do if (i1 >>> 0 < 128) {
  if ((((i2 & 65535) >>> 8 & 65535) << 24 >> 24 | 0) != (i1 | 0)) {
   i2 = i5 + 20 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i2 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i1;
    i1 = i1 & 255;
    break;
   }
  }
  i1 = ___overflow(i5, i1) | 0;
 } else {
  i3 = i5 + 20 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 + 4 | 0) >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
   i2 = _wctomb(i2, i1) | 0;
   if ((i2 | 0) < 0) {
    i1 = -1;
    break;
   }
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
   break;
  }
  i2 = _wctomb(i4, i1) | 0;
  if ((i2 | 0) >= 0) if ((___fwritex(i4, i2, i5) | 0) >>> 0 >= i2 >>> 0) break;
  i1 = -1;
 } while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwj(i2, i5, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 __THREW__ = 0;
 i4 = invoke_ii(fb + 2806 | 0, i5 | 0) | 0;
 i8 = __THREW__;
 __THREW__ = 0;
 if (i8 & 1) {
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 }
 i1 = i2 + ((i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) << 2) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i6 = -1;
   break;
  }
  i1 = i1 + -4 | 0;
  __THREW__ = 0;
  i3 = invoke_iiii(fb + 514 | 0, i5 | 0, i4 | 0, i1 | 0) | 0;
  i8 = __THREW__;
  __THREW__ = 0;
  if (i8 & 1) {
   i7 = 9;
   break;
  }
  if (!i3) {
   i7 = 10;
   break;
  }
 }
 if ((i7 | 0) == 9) {
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 } else if ((i7 | 0) == 10) i6 = i1 - i2 >> 2;
 return i6 | 0;
}

function __ZN25BuiltinShaderParamIndices16CheckMatrixParamEPKciiiib(i5, i6, i7, i8, i9, i10, i11) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i12 = 0, i13 = 0, i14 = 0;
 i4 = HEAP32[gb + 1157720 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = i4 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i14 = (i2 | 0) / 2 | 0;
   i12 = i1 + (i14 << 3) | 0;
   i13 = (_strcmp(HEAP32[i12 >> 2] | 0, i6) | 0) < 0;
   i2 = i13 ? i2 + -1 - i14 | 0 : i14;
   i1 = i13 ? i12 + 8 | 0 : i1;
  } while ((i2 | 0) != 0);
 }
 if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
  i14 = 0;
  return i14 | 0;
 }
 if (_strcmp(HEAP32[i1 >> 2] | 0, i6) | 0) {
  i14 = 0;
  return i14 | 0;
 }
 i14 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 + (i14 * 20 | 0) >> 2] = i7;
 HEAP16[i5 + (i14 * 20 | 0) + 4 >> 1] = i8;
 HEAP16[i5 + (i14 * 20 | 0) + 6 >> 1] = i9;
 HEAP32[i5 + (i14 * 20 | 0) + 8 >> 2] = i10;
 HEAP8[i5 + (i14 * 20 | 0) + 16 >> 0] = i11 & 1;
 i14 = 1;
 return i14 | 0;
}

function __ZN17PolygonCollider2DD2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i6 >> 2] = gb + 156928 + 8;
 i4 = i6 + 160 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i6 + 164 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i3 = i2;
   while (1) {
    i2 = i3 + -20 | 0;
    HEAP32[i5 >> 2] = i2;
    if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -16 | 0);
     HEAP32[i2 >> 2] = 0;
     i2 = HEAP32[i5 >> 2] | 0;
    }
    if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 HEAP32[i6 >> 2] = gb + 153816 + 8;
 i1 = i6 + 60 | 0;
 if ((HEAP32[i6 + 76 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = gb + 37748 + 8;
  HEAP32[i6 >> 2] = gb + 29060 + 8;
  HEAP32[i6 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i6 + 64 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = gb + 37748 + 8;
 HEAP32[i6 >> 2] = gb + 29060 + 8;
 HEAP32[i6 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13GfxDeviceGLES15SetStereoTargetE15StereoscopicEye(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7;
 i5 = i1 + 4620 | 0;
 i1 = (__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0) + 376 | 0;
 if (!i2) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i3;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i5, i6, 1, gb + 76804 | 0);
  STACKTOP = i7;
  return;
 } else {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = i4;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i5, i6, 1, gb + 76808 | 0);
  STACKTOP = i7;
  return;
 }
}

function __ZN13AnimationClip15QuaternionCurve8TransferI14SafeBinaryReadEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = i4 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 899332 | 0, gb + 1034188 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4, 1); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN10Collider2D15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32588 | 0, gb + 1105016 | 0, fb + 861 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32588 | 0, gb + 1105216 | 0, fb + 862 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32588 | 0, gb + 1105256 | 0, fb + 863 | 0, gb + 29020 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32588 | 0, gb + 1105276 | 0, fb + 864 | 0, gb + 29020 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32588 | 0, gb + 1106116 | 0, fb + 865 | 0, gb + 29352 | 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0;
 if (!i1) {
  i1 = _il2cpp_object_new(i3 | 0) | 0;
  __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i4, i5);
 STACKTOP = i6;
 return;
}

function __Z49Material_CUSTOM_Internal_GetTextureScaleAndOffsetP12Il2CppObjectP12Il2CppStringP8Vector4f(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8 + 28 | 0;
 i5 = i8 + 24 | 0;
 i6 = i8 + 8 | 0;
 i7 = i8;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i8 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  HEAP32[i7 >> 2] = __Z25ScriptingStringToPropertyR11ICallString(i5) | 0;
  HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
  __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE(i6, i1, i2);
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  STACKTOP = i8;
  return;
 }
}

function __Z36CreateScriptingArrayFromUnityObjectsI13dynamic_arrayIP6ObjectLj4EEEP11Il2CppArrayRKT_i(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 i6 = __Z19GetScriptingManagerv() | 0;
 i3 = i4 + 12 | 0;
 i5 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i6 + 168 >> 2] | 0) + (HEAP32[i5 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i3 >> 2] | 0) | 0;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = 0; else {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = 0;
  do {
   __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 >> 2] | 0) | 0);
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != ((HEAP32[i4 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 if ((i1 | 0) >= (i6 | 0)) return i5 | 0;
 do {
  HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i5, i1, 4) | 0) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return i5 | 0;
}

function __Z23CleanupPhysicsManager2Dv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[gb + 1458412 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = i1 + 8 | 0;
 __ZN7b2World11DestroyBodyEP6b2Body(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN7b2WorldD2Ev(i3);
  __ZdlPv(i3);
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[gb + 1458412 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 12 >> 2] = gb + 154588 + 8;
  i1 = i2 + 216 | 0;
  if ((HEAP32[i2 + 232 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 220 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = HEAP32[i2 + 188 >> 2] | 0;
  if (i1 | 0) {
   i3 = HEAP32[i2 + 212 >> 2] | 0;
   HEAP32[i4 >> 2] = 65;
   HEAP32[i4 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63400 | 0);
 HEAP32[gb + 1458412 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z19TestAndInsertObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE(i3, i1, i2, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i3;
 if ((i1 | 0) != (i2 | 0)) return;
 i6 = i8 + 12 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i3 + 24 >> 2] = i7;
 i5 = i7 + 1 | 0;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i5 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i6 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i8 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i6 >> 2] = i5;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i7 << 2) >> 2] = i9;
 return;
}

function __ZNK5physx13NpVolumeCache5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i9, i4, i8, i10, f1, i5, i6, i3, i2, f7) {
 i9 = i9 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 f1 = Math_fround(f1);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 f7 = Math_fround(f7);
 var i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i11;
 i12 = i11 + 24 | 0;
 HEAP32[i13 >> 2] = 0;
 HEAPF32[i13 + 8 >> 2] = f1;
 HEAP32[i13 + 4 >> 2] = i10;
 HEAP32[i13 + 12 >> 2] = i4;
 HEAP32[i13 + 16 >> 2] = i8;
 HEAPF32[i13 + 20 >> 2] = Math_fround(0.0);
 HEAP16[i12 >> 1] = HEAP16[i6 >> 1] | 0;
 i10 = __ZNK5physx13NpVolumeCache10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i9, i13, i5, i12, i3, i2, f7) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN7b2Joint7DestroyEPS_P16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 do switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 3:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 176);
   return;
  }
 case 5:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 168);
   return;
  }
 case 2:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 256);
   return;
  }
 case 1:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 228);
   return;
  }
 case 4:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 196);
   return;
  }
 case 6:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 276);
   return;
  }
 case 7:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 224);
   return;
  }
 case 8:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 208);
   return;
  }
 case 9:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 180);
   return;
  }
 case 10:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 168);
   return;
  }
 case 11:
  {
   __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 192);
   return;
  }
 default:
  return;
 } while (0);
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 677224 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684144 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 679963 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Scb11RigidObject17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i4 >> 2] = HEAP32[gb + 126052 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 126052 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 126052 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 126052 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 126052 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 126052 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 126052 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 126052 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = gb + 747951;
 HEAP32[i3 + 4 >> 2] = gb + 747531;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 12;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1;
 HEAP32[i3 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN5Unity10HingeJoint15WriteJointMotorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 4 | 0;
 i3 = i2;
 i5 = i1 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i6 >> 2] | 0) + 136 >> 2] | 0, i6 | 0, +Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(HEAPF32[i1 + 128 >> 2])) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
 i6 = HEAP32[i5 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i6 >> 2] | 0) + 144 >> 2] | 0, i6 | 0, +Math_fround(HEAPF32[i1 + 132 >> 2]));
 i6 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, 4, (HEAP32[i1 + 136 >> 2] | 0) != 0 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i4 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i3 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN24EllipsoidParticleEmitter12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 768 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 432 | 0)) {
   i4 = i7 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __Z29DeleteFileOrDirectoryIfExistsPKcb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 1060 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i1, _strlen(i1) | 0);
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 if (!(__ZNK15FileSystemEntry6ExistsEv(i4) | 0)) {
  i2 = 0;
  __ZN13FileEntryDataD2Ev(i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return i2 | 0;
 }
 i2 = __ZN15FileSystemEntry6DeleteEb(i4, i2) | 0;
 __ZN13FileEntryDataD2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return i2 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwj(i2, i7, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 __THREW__ = 0;
 i4 = invoke_ii(fb + 2806 | 0, i7 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i5);
 }
 L8 : do if (!i4) i6 = -1; else {
  i5 = i2;
  i1 = i2 + ((i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) << 2) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i6 = -1;
    break L8;
   }
   i1 = i1 + -4 | 0;
   __THREW__ = 0;
   i3 = invoke_iiii(fb + 514 | 0, i7 | 0, i4 | 0, i1 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) break;
   if (i3) {
    i6 = i1 - i5 >> 2;
    break L8;
   }
  }
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 } while (0);
 return i6 | 0;
}

function __ZNK5physx7NpCloth13getGlobalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 554, gb + 698061 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpScene14resetFilteringERNS_12PxRigidActorEPKPNS_7PxShapeEj(i1, i5, i4, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 switch (HEAPU16[i5 + 4 >> 1] | 0 | 0) {
 case 6:
  {
   __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i5, i5 + 48 | 0, i4, i3) | 0;
   return;
  }
 case 5:
  {
   i2 = i5 + 48 | 0;
   __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i5, i2, i4, i3) | 0;
   if (!(HEAP32[i5 + 284 >> 2] & 4096)) i1 = i5 + 108 | 0; else i1 = (HEAP32[i5 + 56 >> 2] | 0) + 268 | 0;
   if (HEAP8[i1 >> 0] & 1) return;
   __ZN5physx14NpRigidDynamic29wakeUpInternalNoKinematicTestERNS_3Scb4BodyEbb(i5, i2, 0, 1);
   return;
  }
 case 15:
  {
   __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj(i5, i5 + 48 | 0, i4, i3) | 0;
   __ZN5physx14NpArticulation14wakeUpInternalEbb(HEAP32[i5 + 288 >> 2] | 0, 0, 1);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 677750 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE(i7, i4, i5, i1, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 __ZN5physx23PxsBroadPhaseContextSap13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE(i7, i1) | 0;
 i2 = i7 + 44 | 0;
 HEAP32[i7 + 64 >> 2] = i7;
 i3 = i7 + 12 | 0;
 HEAP32[i7 + 32 >> 2] = i7;
 HEAP32[i7 + 68 >> 2] = i4;
 HEAP32[i7 + 72 >> 2] = i5;
 HEAP32[i7 + 36 >> 2] = i4;
 HEAP32[i7 + 40 >> 2] = i5;
 HEAP32[i7 + 60 >> 2] = 1;
 i1 = i7 + 56 | 0;
 HEAP32[i1 >> 2] = i6;
 if (i6 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  HEAP32[i7 + 52 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 HEAP32[i7 + 28 >> 2] = 1;
 i6 = i7 + 24 | 0;
 HEAP32[i6 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 HEAP32[i7 + 20 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 return;
}

function __ZN17MemoryCacheWriter15CompleteWritingEj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = i6;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 & 2147483647) >>> 0 < i6 >>> 0) if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i6;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i6, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 1, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i6;
  HEAP32[i2 >> 2] = i5;
  break;
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) return 1;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 1, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
 return 1;
}

function __ZN16ReflectionProbes20DidChangeActiveSceneEP10UnitySceneS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[gb + 1112272 >> 2] | 0;
 i7 = i8 + 40 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i8 = i8 + 52 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) return; else i6 = i2;
 L3 : while (1) {
  i4 = i6;
  i6 = i6 + 4 | 0;
  i5 = i6;
  while (1) {
   i3 = HEAP32[i4 >> 2] | 0;
   if (!i3) break;
   if (!(HEAP8[i3 + 16 >> 0] | 0)) break;
   if (HEAP8[i3 + 28 >> 0] | 0) {
    __Z19DestroySingleObjectP6Object(HEAP32[i3 + 20 >> 2] | 0);
    __Z19DestroySingleObjectP6Object(HEAP32[i3 + 24 >> 2] | 0);
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63536 | 0);
   _memmove(i4 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) + (HEAP32[i8 >> 2] << 2) - i5 | 0) | 0;
   i1 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
   HEAP32[i8 >> 2] = i1;
   i2 = HEAP32[i7 >> 2] | 0;
   if ((i4 | 0) == (i2 + (i1 << 2) | 0)) {
    i1 = 9;
    break L3;
   }
  }
  if ((i6 | 0) == (i2 + (i1 << 2) | 0)) {
   i1 = 9;
   break;
  }
 }
 if ((i1 | 0) == 9) return;
}

function __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEj(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0, i11 = 0;
 i10 = i8 + 8 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i11 = i8 + 4 | 0;
 i3 = HEAP32[i11 >> 2] | 0;
 if (i2 - i3 >> 2 >>> 0 >= i9 >>> 0) {
  HEAP32[i11 >> 2] = i3 + (i9 << 2);
  return;
 }
 i1 = HEAP32[i8 >> 2] | 0;
 i4 = (i3 - i1 >> 2) + i9 | 0;
 if (i4 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i8);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
  i3 = HEAP32[i11 >> 2] | 0;
 }
 i7 = i1;
 i5 = i2 - i1 | 0;
 i6 = i5 >> 1;
 i4 = i5 >> 2 >>> 0 < 536870911 ? (i6 >>> 0 < i4 >>> 0 ? i4 : i6) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i3 - i1 >> 2 << 2) | 0;
 i2 = i3 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i7 | 0, i2 | 0) | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i11 >> 2] = i5 + (i9 << 2);
 HEAP32[i10 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i7);
 return;
}

function __ZNK9dtNavMesh12getTileRefAtEiii(i2, i4, i5, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i7 = 0;
 i1 = HEAP32[i2 + 4 >> 2] & (Math_imul(i6, -669632447) | 0) + (Math_imul(i5, -1918454973) | 0);
 i1 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = 0;
  i7 = 0;
  setTempRet0(i6 | 0);
  return i7 | 0;
 }
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 while (1) {
  i2 = HEAP32[i3 + (i1 * 56 | 0) + 8 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i2 + 8 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + (i1 * 56 | 0) >> 2] | 0) == (i4 | 0)) break;
  i1 = HEAP32[i3 + (i1 * 56 | 0) + 52 >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i2 = 0;
   i7 = 9;
   break;
  }
 }
 if ((i7 | 0) == 9) {
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i7 = _bitshift64Shl(HEAP32[i3 + (i1 * 56 | 0) + 4 >> 2] | 0, 0, 48) | 0;
 i6 = getTempRet0() | 0;
 i5 = _bitshift64Shl((i1 * 56 | 0) / 56 | 0 | 0, 0, 20) | 0;
 i6 = getTempRet0() | 0 | i6;
 i7 = i5 | i7;
 setTempRet0(i6 | 0);
 return i7 | 0;
}

function __ZNK14NavMeshManager16TileDataConformsEPK11NavMeshData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 32 >> 2]));
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if (!((i5 ? f4 : f3) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 36 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 if (!((i5 ? f3 : f4) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 40 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 if (!((i5 ? f3 : f4) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 44 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 i5 = (i5 ? f3 : f4) <= Math_fround(9.99999974e-06);
 return i5 | 0;
}

function __ZN9ShaderLab16FastPropertyName15InitBy28BitHashEj(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = -1;
 i2 = HEAP32[gb + 1166568 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i2 + 4 | 0)) return;
 i6 = i2 + 4 | 0;
 while (1) {
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  i4 = _strlen(i2) | 0;
  i5 = i2 + i4 | 0;
  if ((i4 | 0) > 0) {
   i4 = -1;
   do {
    i4 = HEAP32[gb + 1111240 + (((HEAPU8[i2 >> 0] | 0) ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i5 | 0));
   i2 = i4 & 268435455 ^ 268435455;
  } else i2 = 0;
  if ((i2 | 0) == (i8 | 0)) HEAP32[i7 >> 2] = HEAP32[i3 + 20 >> 2];
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i6 | 0)) break; else {
   i1 = i2;
   i3 = i2;
  }
 }
 return;
}

function __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i10 = 0;
 i7 = i8 + 52 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i9 + 28 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  i6 = i4 + -1 | 0;
  i3 = i9 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (!((i2 | 0) == (i6 | 0) | i4 >>> 0 >= i1 >>> 0)) {
   i10 = HEAP32[i9 + 16 >> 2] | 0;
   i4 = HEAP32[i10 + (i6 << 2) >> 2] | 0;
   HEAP32[i10 + (i2 << 2) >> 2] = i4;
   HEAP32[i4 + 52 >> 2] = i2;
   i2 = i6;
  }
  HEAP32[i5 >> 2] = i6;
 } else {
  i1 = i9 + 20 | 0;
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 i10 = i8 + 44 | 0;
 HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & -2097153;
 HEAP32[i7 >> 2] = -1;
 i10 = i1 + -1 | 0;
 HEAP32[i3 >> 2] = i10;
 i1 = i9 + 16 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 + (i2 << 2) >> 2] = HEAP32[i9 + (i10 << 2) >> 2];
 if (i2 >>> 0 >= i10 >>> 0) return;
 HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 52 >> 2] = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN5Umbra12QueryContext11getGateCostERKNS_10MappedTileERKNS_6PortalE(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var f1 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!i8) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i7 = i2 & 4095;
 if (!i7) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 i5 = i2 >>> 12;
 i6 = i6 + (HEAP32[i6 + 120 >> 2] | 0) | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(0.0);
  i2 = 0;
  do {
   f1 = Math_fround(f1 + Math_fround(HEAPF32[i8 + (HEAP32[i6 + (i5 + i2 << 2) >> 2] << 2) >> 2]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
  return Math_fround(f1);
 }
 i3 = (HEAP32[i4 + 12 >> 2] | 0) + (HEAP32[i2 + 16 >> 2] | 0) | 0;
 f1 = Math_fround(0.0);
 i2 = 0;
 do {
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i8 + (HEAP32[i3 + (HEAP32[i6 + (i5 + i2 << 2) >> 2] << 2) >> 2] << 2) >> 2]));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 return Math_fround(f1);
}

function __ZN19RenderEventsContext20RemoveCommandBuffersEi(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i5 + (i8 * 20 | 0) | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i8 * 20 | 0) + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) i1 = i2; else {
  i4 = i2;
  i1 = i2;
  i3 = i2;
  while (1) {
   i2 = HEAP32[i4 >> 2] | 0;
   i9 = i2 + 4 | 0;
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   if ((i2 | 0) == 0 | (HEAP32[i9 >> 2] | 0) != 0) i2 = i3; else {
    mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
    i1 = HEAP32[i6 >> 2] | 0;
    i2 = i1;
   }
   i4 = i4 + 4 | 0;
   if ((i4 | 0) == (i2 + (HEAP32[i7 >> 2] << 2) | 0)) break; else i3 = i2;
  }
 }
 i2 = i5 + (i8 * 20 | 0) + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5 + (i8 * 20 | 0) + 4 | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13WheelCollider9SetCenterERK8Vector3f(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f5 = f0;
 i2 = i4 + 60 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f5 != Math_fround(HEAPF32[i1 >> 2])) i3 = 4; else {
  f5 = Math_fround(HEAPF32[i4 + 64 >> 2]);
  if (f5 != Math_fround(HEAPF32[i1 + 4 >> 2])) i3 = 4; else {
   f5 = Math_fround(HEAPF32[i4 + 68 >> 2]);
   if (f5 != Math_fround(HEAPF32[i1 + 8 >> 2])) i3 = 4;
  }
 }
 if ((i3 | 0) == 4) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if ((HEAP32[i4 + 148 >> 2] | 0) == -1) return;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 if (!i2) return;
 if (!(HEAP32[i2 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i2 + 56 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 168 >> 2] | 0, i4 | 0, 3);
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 return;
}

function __ZL12InvokeMethodI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 57 >> 0] | 0) if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 40 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z39UnityWebRequest_CUSTOM_GetRequestHeaderP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i6 + 16 | 0;
 i5 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i4);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i3);
 i1 = __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + 44 | 0, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i5 << 24 >> 24 < 0;
 i5 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z27Profiler_CUSTOM_BeginSampleP12Il2CppStringP12Il2CppObject(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i3 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i2);
 do if (!i4) i5 = 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) i5 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
   i5 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 __ZN22UnityProfilerPerThread18BeginSampleDynamicERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, i6, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function _stbir_resize_subpixel(i1, i2, i13, i16, i17, i18, i19, i20, i21, i22, i3, i4, i5, i6, i7, i8, i9, i10, f11, f12, f14, f15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 var i23 = 0, i24 = 0;
 i23 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i24 = i23;
 HEAPF32[i24 >> 2] = f11;
 HEAPF32[i24 + 4 >> 2] = f12;
 HEAPF32[i24 + 8 >> 2] = f14;
 HEAPF32[i24 + 12 >> 2] = f15;
 i22 = __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i10, i1, i2, i13, i16, i17, i18, i19, i20, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), i24, i22, i3, i4, i21, i7, i8, i5, i6, i9) | 0;
 STACKTOP = i23;
 return i22 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 676508 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684606 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx20PxsParticleSystemSim18removeInteractionVERKNS_16PxvParticleShapeEjjbbb(i10, i6, i2, i3, i5, i4, i1) {
 i10 = i10 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i1 = i2;
 if (!i4) return;
 if (i5) {
  if (!(HEAP32[i10 + 20 >> 2] | 0)) return;
  __ZN5physx20PxsParticleSystemSim24removeTwoWayRbReferencesERKNS_16PxsParticleShapeEPKNS_11PxsBodyCoreE(i10, i6, i3);
  return;
 }
 i9 = HEAP32[i10 + 60 >> 2] | 0;
 if (!i9) return;
 i8 = i1 + 36 | 0;
 if ((HEAP32[i8 >> 2] | 0) != 5) return;
 i7 = HEAP32[i6 + 44 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i10 + 8 >> 2] | 0) + 48 >> 2] | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 i7 = (HEAP32[i7 + 8 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= i7 >>> 0) return;
 i5 = HEAP32[i10 + 36 >> 2] | 0;
 do {
  i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  i3 = i6 + (i2 << 5) + 30 | 0;
  i4 = HEAP16[i3 >> 1] | 0;
  if (i4 & 48) if ((HEAP32[i9 + (i2 << 5) + 28 >> 2] | 0) == (i8 | 0)) HEAP16[i3 >> 1] = i4 & 65487;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i2, i10) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = (__ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i10) | 0) + 3392 | 0;
 i3 = HEAP16[i2 + 4 >> 1] | 0;
 if (i3 << 16 >> 16 == 1) {
  i6 = HEAP16[i10 + 4 >> 1] | 0;
  i6 = i6 << 16 >> 16 == 5 | i6 << 16 >> 16 == 15;
  i8 = i2;
 } else {
  i1 = HEAP16[i10 + 4 >> 1] | 0;
  if (!(i3 << 16 >> 16)) return; else {
   i6 = i1 << 16 >> 16 == 5 | i1 << 16 >> 16 == 15;
   i8 = HEAP32[i2 >> 2] | 0;
  }
 }
 i7 = i2 + 8 | 0;
 i5 = i2 + 12 | 0;
 i3 = i3 & 65535;
 i4 = 0;
 do {
  i1 = i8 + (i4 << 2) | 0;
  if ((__ZNK5physx7NpShape8getFlagsEv(HEAP32[i1 >> 2] | 0) | 0) & 2) {
   i1 = __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i9, HEAP32[i1 >> 2] | 0, i10, i6, 0) | 0;
   if ((HEAP16[i5 >> 1] | 0) == 1) i2 = i7; else i2 = HEAP32[i7 >> 2] | 0;
   HEAP32[i2 + (i4 << 2) >> 2] = i1;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __ZN18CrashReportHandler12FlushReportsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 40 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 44 | 0;
 if ((i2 | 0) == (i6 | 0)) i1 = 0; else {
  i1 = 0;
  do {
   i3 = i2 + 144 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i4, i2 + 32 | 0) | 0;
    HEAP32[i3 >> 2] = 0;
    i1 = i1 + 1 | 0;
   }
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
     i2 = i3;
     break;
    } else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) break; else i2 = i3;
    }
   }
  } while ((i2 | 0) != (i6 | 0));
 }
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i5, HEAP32[i6 >> 2] | 0);
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 return i1 | 0;
}

function __ZN16PlayerConnection18CreateListenSocketEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i4 = i1 + 164 | 0;
 HEAP16[i4 >> 1] = -10536;
 d8 = +_emscripten_get_now() * 1.0e6;
 i3 = __Z17TimeToNanosecondsy(~~d8 >>> 0, +Math_abs(d8) >= 1.0 ? (d8 > 0.0 ? ~~+Math_min(+Math_floor(d8 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d8 - +(~~d8 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 getTempRet0() | 0;
 i7 = (Math_imul(i3, 1790253981) | 0) + 1900727103 | 0;
 i7 = ((i7 ^ i3 ^ (i3 << 11 ^ i3) >>> 8 ^ i7 >>> 19) & 511) + (HEAPU16[i4 >> 1] | 0) | 0;
 i3 = i7 & 65535;
 HEAP16[i4 >> 1] = i3;
 i4 = i1 + 152 | 0;
 i5 = i4 + 11 | 0;
 HEAP32[i6 >> 2] = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 HEAP32[i6 + 4 >> 2] = i7 & 65535;
 _printf_console(gb + 459885 | 0, i6);
 __ZN12ServerSocket14StartListeningEPKctb(i1 + 192 | 0, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i3, 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZN11PreloadData7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(64, i1, 16, gb + 1048932 | 0, 0, gb + 461381 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 66036 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNSt3__219__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i3, i4, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = i3 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) != (fb + 4003 | 0);
 i6 = HEAP32[i3 >> 2] | 0;
 i2 = (HEAP32[i7 >> 2] | 0) - i6 | 0;
 i2 = i2 >>> 0 < 2147483647 ? i2 << 1 : -1;
 i2 = (i2 | 0) == 0 ? 4 : i2;
 i5 = (HEAP32[i4 >> 2] | 0) - i6 >> 2;
 i6 = _realloc(i1 ? i6 : 0, i2) | 0;
 if (!i6) __ZSt17__throw_bad_allocv();
 do if (i1) {
  HEAP32[i3 >> 2] = i6;
  i8 = i6;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  if (!i1) i8 = i6; else {
   __THREW__ = 0;
   invoke_vi(HEAP32[i9 >> 2] | 0, i1 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   } else {
    i8 = HEAP32[i3 >> 2] | 0;
    break;
   }
  }
 } while (0);
 HEAP32[i9 >> 2] = fb + 4005;
 HEAP32[i4 >> 2] = i8 + (i5 << 2);
 HEAP32[i7 >> 2] = (HEAP32[i3 >> 2] | 0) + (i2 >>> 2 << 2);
 return;
}

function __ZNSt3__219__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i3, i4, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = i3 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) != (fb + 4003 | 0);
 i6 = HEAP32[i3 >> 2] | 0;
 i2 = (HEAP32[i7 >> 2] | 0) - i6 | 0;
 i2 = i2 >>> 0 < 2147483647 ? i2 << 1 : -1;
 i2 = (i2 | 0) == 0 ? 4 : i2;
 i5 = (HEAP32[i4 >> 2] | 0) - i6 >> 2;
 i6 = _realloc(i1 ? i6 : 0, i2) | 0;
 if (!i6) __ZSt17__throw_bad_allocv();
 do if (i1) {
  HEAP32[i3 >> 2] = i6;
  i8 = i6;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  if (!i1) i8 = i6; else {
   __THREW__ = 0;
   invoke_vi(HEAP32[i9 >> 2] | 0, i1 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   } else {
    i8 = HEAP32[i3 >> 2] | 0;
    break;
   }
  }
 } while (0);
 HEAP32[i9 >> 2] = fb + 4005;
 HEAP32[i4 >> 2] = i8 + (i5 << 2);
 HEAP32[i7 >> 2] = (HEAP32[i3 >> 2] | 0) + (i2 >>> 2 << 2);
 return;
}

function __ZN8LODGroup22SetLocalReferencePointERK8Vector3f(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i7 + 32 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i5 = i7 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i6 = i7 + 88 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i2) {
  i4 = i7 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i5 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i7);
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 685312 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx2Sc9RigidCore17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i4 >> 2] = HEAP32[gb + 132324 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 132324 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 132324 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 132324 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 132324 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 132324 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 132324 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 132324 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = gb + 751711;
 HEAP32[i3 + 4 >> 2] = gb + 748168;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 16;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1;
 HEAP32[i3 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN19AssetBundleManifest7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(76, i1, 16, gb + 1048932 | 0, 0, gb + 368417 | 0, 26) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 27928 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 i2 = i4 + 52 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = i4 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -1040385 | 499712;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN18DelayedCallManager20CancelAllCallDelayedE4PPtrI6ObjectE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 4 | 0;
 i8 = i10;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i9 = i6 + 32 | 0;
 i2 = i1;
 if ((i2 | 0) == (i9 | 0)) {
  STACKTOP = i10;
  return;
 }
 i4 = i2;
 while (1) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   while (1) {
    i2 = HEAP32[i3 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break; else i3 = i2;
   }
  } else while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) break; else i2 = i3;
  }
  if ((HEAP32[i4 + 48 >> 2] | 0) == (HEAP32[i7 >> 2] | 0)) {
   HEAP32[i8 >> 2] = i1;
   HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
   __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE(i6, i4 + 16 | 0, i5);
  }
  if ((i2 | 0) == (i9 | 0)) break; else {
   i1 = i2;
   i4 = i2;
  }
 }
 STACKTOP = i10;
 return;
}

function __ZN18AwakeFromLoadQueue34PersistentManagerAwakeSingleObjectER6Object17AwakeFromLoadMode(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1165848 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165848 | 0, i1);
  i1 = gb + 1165848 | 0;
 } else i1 = 0;
 i2 = __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() | 0;
 if (!i2) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0); else {
  __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(0);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
  __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i2);
 }
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader7OpenVFSEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i1 = i5 + 16 | 0;
 i4 = i1 + 11 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i3, _strlen(i3) | 0);
 __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i2, 10, 10) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i2 = i5 + 32 | 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN15FileSystemEntry3SetEPKc(i2, i1);
 i1 = __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i5 + 1092 | 0, i2, 1, 1) | 0;
 HEAP8[i5 + 13 >> 0] = i1 & 1;
 if (i1) {
  STACKTOP = i6;
  return i1 | 0;
 }
 HEAP8[i5 + 14 >> 0] = 1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__26futureIvEC2EPNS_17__assoc_sub_stateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 HEAP32[i1 >> 2] = i2;
 if (!(HEAP32[i2 + 88 >> 2] & 2)) {
  __ZNSt3__214__shared_count12__add_sharedEv(i2);
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + 12 | 0;
  __ZNSt3__25mutex4lockEv(i5);
  i4 = i4 + 88 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
  __ZNSt3__25mutex6unlockEv(i5);
  STACKTOP = i3;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i4 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
}

function __ZNSt3__219__libcpp_asprintf_lEPPcP15__locale_structPKcz(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i2;
 i2 = _uselocale(i1) | 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 503 | 0, i3 | 0, i4 | 0, i6 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   }
  }
  ___resumeException(i1 | 0);
 } else {
  if (i2 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   }
  }
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 67048 | 0) | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) if (!((i2 | 0) == (i4 | 0) | (__ZNK10GameObject8IsActiveEv(i3) | 0) ^ 1)) {
   i4 = i2;
   return i4 | 0;
  }
 }
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) {
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
   if (i2 | 0) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    if (i3 | 0) if (!((i2 | 0) == (i4 | 0) | (__ZNK10GameObject8IsActiveEv(i3) | 0) ^ 1)) {
     i1 = i2;
     i2 = 10;
     break;
    }
   }
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 679207 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 679338 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Scb5Scene14updateMaterialERNS_2Sc12MaterialCoreE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i4 = i6 + 2428 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 + 4 >> 2] = 1;
 HEAP32[i5 >> 2] = HEAP32[i1 + 20 >> 2];
 i2 = i6 + 2416 | 0;
 i3 = i6 + 2420 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 2424 >> 2] & 2147483647) >>> 0 > i1 >>> 0) {
  i8 = i5;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = (HEAP32[i2 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i6 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i5) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx2Gu10ConvexMesh14onRefCountZeroEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i5 = ((HEAPU8[i3 + 55 >> 0] | 0) * 20 | 0) + (HEAP32[i3 + 80 >> 2] & 2147483647) + ((HEAPU8[i3 + 54 >> 0] | 0) * 15 | 0) + ((HEAPU16[i3 + 52 >> 1] | 0) << 1) | 0;
 i6 = i5 & 3;
 i1 = i3 + 128 | 0;
 if ((((i6 | 0) == 0 ? 0 : 4 - i6 | 0) | 0) != (0 - i5 | 0)) if (!(__ZN5physx13GuMeshFactory16removeConvexMeshERNS_12PxConvexMeshE(HEAP32[i1 >> 2] | 0, i3) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 724158 | 0, 300, gb + 724486 | 0, i2);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP16[i3 + 6 >> 1] & 1)) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i3 | 0);
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i3, 2, 1);
 STACKTOP = i4;
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN5physx13GuMeshFactory15addTriangleMeshEPNS_2Gu12TriangleMeshEb(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i3 = i8;
 i4 = i2 + 8 | 0;
 i2 = i1 ? i2 + 4 | 0 : 0;
 HEAP32[i3 >> 2] = i6;
 i5 = i6;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 if (!i2) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 }
}

function __ZN19MeshParticleEmitter12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 768 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 435 | 0)) {
   i4 = i7 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN13GfxDeviceGLES16DoMemoryBarriersEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i4 + 7376 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i6 = i4 + 7380 | 0;
 i1 = HEAP32[i6 >> 2] & i1;
 if (i1 | 0) mftCall_vi(HEAP32[i4 + 4860 >> 2] | 0, i1 | 0);
 i2 = i4 + 5480 | 0;
 i3 = i4 + 7368 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i6 >> 2] & HEAP32[i5 >> 2];
  if (i7 & (__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0) | 0) {
   i9 = i3;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i4 + 7264 + (i1 << 3) | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i7 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i2 >> 2] | 0, i1) | 0);
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & i7;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 13);
 i7 = i3;
 i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, 1, 0) | 0;
 i8 = getTempRet0() | 0;
 i9 = i3;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i9 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = 15407;
 return;
}

function __Z26SetupLightShaderPropertiesRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_(i2, f3, i6, i1, i4, i5) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, f8 = f0, f9 = f0, f10 = f0;
 i7 = __Z12GetGfxDevicev() | 0;
 f10 = Math_fround(Math_fround(HEAPF32[i2 + 156 >> 2]) * f3);
 f9 = Math_fround(Math_fround(HEAPF32[i2 + 160 >> 2]) * f3);
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 164 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 168 >> 2]) * f3);
 HEAPF32[i7 + 564 >> 2] = f10;
 HEAPF32[i7 + 568 >> 2] = f9;
 HEAPF32[i7 + 572 >> 2] = f8;
 HEAPF32[i7 + 576 >> 2] = f3;
 switch (HEAP32[i2 + 40 >> 2] | 0) {
 case 0:
  {
   i1 = HEAP8[i2 + 84 >> 0] | 0 ? i1 : i4;
   break;
  }
 case 2:
  {
   i1 = HEAP8[i2 + 84 >> 0] | 0 ? i1 : i5;
   break;
  }
 case 1:
  {
   if (!(HEAP8[i2 + 84 >> 0] | 0)) return;
   break;
  }
 default:
  return;
 }
 __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef(i6 + 36 | 0, gb + 1111220 | 0, i1);
 return;
}

function __Z23dtMergeCorridorEndMovedPyiiPKyi(i11, i6, i9, i12, i10) {
 i11 = i11 | 0;
 i6 = i6 | 0;
 i9 = i9 | 0;
 i12 = i12 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i13 = 0, i14 = 0;
 if ((i6 | 0) > 0 & (i10 | 0) > 0) {
  i2 = -1;
  i1 = -1;
  i5 = 0;
 } else {
  i12 = i6;
  return i12 | 0;
 }
 do {
  i8 = i11 + (i5 << 3) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i8 = HEAP32[i8 + 4 >> 2] | 0;
  i3 = i10;
  i4 = 0;
  do {
   i13 = i3;
   i3 = i3 + -1 | 0;
   i14 = i12 + (i3 << 3) | 0;
   i14 = (i7 | 0) == (HEAP32[i14 >> 2] | 0) ? (i8 | 0) == (HEAP32[i14 + 4 >> 2] | 0) : 0;
   i4 = i4 | i14;
   i1 = i14 ? i3 : i1;
   i2 = i14 ? i5 : i2;
  } while ((i13 | 0) > 1);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i6 | 0) & (i4 ^ 1));
 if ((i1 | 0) == -1 | (i2 | 0) == -1) {
  i14 = i6;
  return i14 | 0;
 }
 i3 = i2 + 1 | 0;
 i2 = i1 + 1 | 0;
 i14 = i10 - i2 | 0;
 i1 = i9 - i3 | 0;
 i1 = (i14 | 0) < (i1 | 0) ? i14 : i1;
 if (i1 | 0) _memcpy(i11 + (i3 << 3) | 0, i12 + (i2 << 3) | 0, i1 << 3 | 0) | 0;
 i14 = i1 + i3 | 0;
 return i14 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 85;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 14;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK9Texture2D30ExtractCompressedImageInternalEPhiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i6) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 416544 | 0, 0, gb + 410682 | 0, 340, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 } else {
  i7 = i6 + 28 | 0;
  i11 = HEAP32[i7 >> 2] | 0;
  i10 = i6 + 32 | 0;
  i8 = HEAP32[i10 >> 2] | 0;
  i1 = __Z21SourceMipLevelForBlitiiii(i11, i8, i3, i4) | 0;
  i9 = (HEAP32[i6 + 48 >> 2] | 0) + -1 | 0;
  i1 = (i9 | 0) < (i1 | 0) ? i9 : i1;
  i9 = i6 + 36 | 0;
  i8 = __Z21CalculateMipMapOffsetii13TextureFormati(i11, i8, HEAP32[i9 >> 2] | 0, i1) | 0;
  i7 = HEAP32[i7 >> 2] >> i1;
  i1 = HEAP32[i10 >> 2] >> i1;
  __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib(HEAP32[i9 >> 2] | 0, (HEAP32[i6 + 8 >> 2] | 0) + ((Math_imul(HEAP32[i6 + 40 >> 2] | 0, i5) | 0) + i8) | 0, (i7 | 0) < 1 ? 1 : i7, (i1 | 0) < 1 ? 1 : i1, i2, i3, i4, 1);
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 680325 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 686721 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 686868 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 687015 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 679469 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684966 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 678179 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx14SapPairManager11RemovePairsERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i10 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return 1;
 i7 = i10 + 20 | 0;
 i8 = i10 + 36 | 0;
 i2 = 0;
 L4 : while (1) {
  while (1) {
   i5 = HEAP32[i7 >> 2] | 0;
   i4 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
   i5 = HEAP32[i5 + (i2 << 3) + 4 >> 2] | 0;
   i3 = HEAP32[i9 >> 2] | 0;
   if (!(HEAP32[i3 + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31))) if (!(HEAP32[i3 + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31))) break;
   i1 = i5 << 16 | i4;
   i1 = i1 + ~(i1 << 15) | 0;
   i1 = (i1 >> 10 ^ i1) * 9 | 0;
   i1 = i1 >> 6 ^ i1;
   i1 = i1 + ~(i1 << 11) | 0;
   __ZN5physx14SapPairManager10RemovePairEjjjj(i10, 0, 0, HEAP32[i8 >> 2] & (i1 >> 16 ^ i1), i2);
   i1 = HEAP32[i6 >> 2] | 0;
   if (i2 >>> 0 >= i1 >>> 0) {
    i1 = 8;
    break L4;
   }
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i1 >>> 0) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return 1;
 return 0;
}

function __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 40 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i3 = i1 + 32 | 0;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i6 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
  return;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = i6;
  i6 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
  return;
 }
}

function __ZN13AnimationClip12Vector3Curve8TransferI14SafeBinaryReadEEvRT_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i2 = i4 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 899332 | 0, gb + 1034188 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN17AnimationCurveTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 898362 | 0, HEAP32[gb + 37260 >> 2] | 0, i3, 0) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i5, i4, 1); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i4 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN11CullResults30GetOrCreateSharedRendererSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 1372 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(65964, gb + 64024 | 0, 16, gb + 375877 | 0, 173) | 0;
 __ZN19SharedRendererSceneC2ERK10MemLabelId(i3, gb + 64024 | 0);
 HEAP32[i2 >> 2] = i3;
 __Z22ExtractRenderNodeQueueRK11CullResults15ExtractionFlagsR15RenderNodeQueue(i1, 3, i3 + 8 | 0) | 0;
 __Z16CopyActiveLightsRK12ActiveLightsRS_(i1 + 312 | 0, (HEAP32[i2 >> 2] | 0) + 65632 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 __Z22CullAllPerObjectLightsiRK15RenderNodeQueueRK12ActiveLightsR27PerObjectLightCullingOutput(HEAP32[i1 + 1204 >> 2] | 0, i3 + 8 | 0, i3 + 65632 | 0, i3 + 65680 | 0);
 i3 = (HEAP32[i2 >> 2] | 0) + 65728 | 0;
 __ZN23ReflectionProbesContext8CopyFromERKS_(i3, (__Z19GetReflectionProbesv() | 0) + 104 | 0);
 i3 = (HEAP32[i2 >> 2] | 0) + 65940 | 0;
 __ZN28LightProbeProxyVolumeContext8CopyFromERKS_(i3, (__Z31GetLightProbeProxyVolumeManagerv() | 0) + 20 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __ZL10CleanUpJobP20CullingGroupsJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1114380 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114380 | 0, i1);
  i2 = gb + 1114380 | 0;
 } else i2 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 12 >> 2] | 0, gb + 64024 | 0);
 if (i3 | 0) {
  i1 = i3 + 36 | 0;
  if ((HEAP32[i3 + 52 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 40 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i3 + 16 | 0;
  if ((HEAP32[i3 + 32 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 20 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __Z20CreateObjectFromCodeI14Texture2DArrayEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14Texture2DArrayC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _jpeg_read_scanlines(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i1 | 0) != 205) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i1 = i5 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 + 96 >> 2] | 0;
 if (i2 >>> 0 >= i3 >>> 0) {
  i8 = HEAP32[i5 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 123;
  mftCall_vii(HEAP32[i8 + 4 >> 2] | 0, i5 | 0, -1);
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i4 = HEAP32[i5 + 8 >> 2] | 0;
 if (i4 | 0) {
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i3;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 HEAP32[i8 >> 2] = 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 + 388 >> 2] | 0) + 4 >> 2] | 0, i5 | 0, i6 | 0, i8 | 0, i7 | 0);
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i8;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx7NpScene14addRigidStaticERNS_13NpRigidStaticE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i4 = ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0) & 8) != 0;
 __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb(i6 + 16 | 0, i5 + 48 | 0, i4);
 __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i5 + 20 | 0, i5);
 if (!i4) if (HEAP32[i5 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i5 + 12 | 0);
 i2 = i6 + 3552 | 0;
 i3 = i6 + 3556 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 36 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 if ((HEAP32[i6 + 3560 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 681369 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684848 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Scb5Actor17getBinaryMetaDataERNS_14PxOutputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 32 | 0;
 i3 = i2;
 HEAP32[i4 >> 2] = HEAP32[gb + 126084 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 126084 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 126084 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 126084 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 126084 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[gb + 126084 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[gb + 126084 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[gb + 126084 + 28 >> 2];
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i4 | 0, 32) | 0;
 HEAP32[i3 >> 2] = gb + 747531;
 HEAP32[i3 + 4 >> 2] = gb + 747700;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 12;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1;
 HEAP32[i3 + 28 >> 2] = 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 32) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5ImageC2Eii13TextureFormat(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = i4;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = i5;
 i7 = __Z25GetBytesFromTextureFormat13TextureFormat(i5) | 0;
 i7 = Math_imul(HEAP32[i3 >> 2] | 0, i7) | 0;
 HEAP32[i1 + 12 >> 2] = i7;
 if ((i5 | 0) < 9) i3 = 1; else i3 = (i5 | 0) == 1e3 | ((i5 | 0) == 23 | (i5 + -13 | 0) >>> 0 < 9);
 if (!((i2 | 0) > 0 & (i4 | 0) > 0 & (i5 | 0) > 0 & i3)) {
  i6 = 0;
  i7 = i1 + 16 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i6 = HEAP32[i6 >> 2] | 0;
 i5 = __Z19GetMaxBytesPerPixel13TextureFormat(HEAP32[i1 >> 2] | 0) | 0;
 i7 = Math_imul(i6, i7) | 0;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 + i7 | 0, 16, gb + 63184 | 0, 0, gb + 404494 | 0, 755) | 0;
 _memset(i6 + i7 | 0, 0, i5 | 0) | 0;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __ZN17PersistentManager11GetPathNameEi(i6, i7, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i7 + 56 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i1 | 0) == -1) i3 = 4; else if ((HEAP32[i2 + 28 >> 2] | 0) > (i5 | 0)) i3 = 4; else if ((HEAP32[i2 + 32 >> 2] | 0) < (i5 | 0)) i3 = 4;
 do if ((i3 | 0) == 4) {
  i4 = i2 + 16 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i2 | 0) {
   i1 = i4;
   L7 : while (1) {
    i3 = i2;
    while (1) {
     if ((HEAP32[i3 + 16 >> 2] | 0) >= (i5 | 0)) break;
     i2 = HEAP32[i3 + 4 >> 2] | 0;
     if (!i2) break L7; else i3 = i2;
    }
    i2 = HEAP32[i3 >> 2] | 0;
    if (!i2) {
     i1 = i3;
     break;
    } else i1 = i3;
   }
   if ((i1 | 0) != (i4 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i5 | 0)) {
    i1 = HEAP32[i1 + 24 >> 2] | 0;
    if ((i1 | 0) != -1) break;
   }
  };
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  return;
 } while (0);
 mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, i7 | 0, i1 | 0);
 return;
}

function __ZN15ReflectionProbe7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(180, i1, 16, gb + 1048932 | 0, 0, gb + 383755 | 0, 105) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 35464 + 8;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP8[i4 + 144 >> 0] = 0;
 HEAP32[i4 + 148 >> 2] = -9999;
 HEAP32[i4 + 156 >> 2] = -1;
 HEAP8[i4 + 160 >> 0] = 1;
 HEAP32[i4 + 164 >> 2] = 0;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12MemoryStream5writeEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + 20 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i5 + i3 | 0) >>> 0 < i7 >>> 0) {
  i6 = HEAP32[i1 + 24 >> 2] | 0;
  i7 = i5;
  i7 = i6 + i7 | 0;
  _memcpy(i7 | 0, i2 | 0, i3 | 0) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i7 = i7 + i3 | 0;
  HEAP32[i4 >> 2] = i7;
  return i3 | 0;
 } else {
  i5 = i3 >>> 0 > 4096 ? i3 << 1 : 4096;
  i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i7 + i5 | 0, 16, gb + 63552 | 0, 0, gb + 738098 | 0, 56) | 0;
  i1 = i1 + 24 | 0;
  _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63552 | 0);
  HEAP32[i1 >> 2] = i7;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
  i6 = i7;
  i7 = HEAP32[i4 >> 2] | 0;
  i7 = i6 + i7 | 0;
  _memcpy(i7 | 0, i2 | 0, i3 | 0) | 0;
  i7 = HEAP32[i4 >> 2] | 0;
  i7 = i7 + i3 | 0;
  HEAP32[i4 >> 2] = i7;
  return i3 | 0;
 }
 return 0;
}

function __Z45SceneManager_CUSTOM_INTERNAL_CALL_MergeScenesRKiS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __Z15GetSceneManagerv() | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 if (!i3) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562047 | 0, i4);
 if ((HEAP32[i3 + 80 >> 2] | 0) != 2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562075 | 0, i4 + 8 | 0);
 i1 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562107 | 0, i4 + 16 | 0);
 if ((HEAP32[i1 + 80 >> 2] | 0) != 2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 562131 | 0, i4 + 24 | 0);
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __Z15GetSceneManagerv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN9ShaderLab20SerializedProperties16AddFloatPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEf(i5, i1, i2, i3, f4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE(i6, i1, i2, 2, i3);
 HEAPF32[i6 + 52 >> 2] = f4;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i6);
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN9ShaderLab18SerializedPropertyC2ERKS0_(i2, i6);
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 88;
  __ZN9ShaderLab18SerializedPropertyD2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 685436 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684732 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx14NpRigidDynamic12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 98212 + 8;
 i5 = i4 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE(i5, i6);
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 i6 = i4 + 52 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 251658240;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP8[i4 + 75 >> 0] = 0;
 HEAP32[i4 + 220 >> 2] = 0;
 HEAP32[i4 + 280 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 98884 + 8;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 288;
 __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE(i5, i2);
 __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE(i4 + 12 | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 312 >> 2] | 0, i4 | 0, i2 | 0);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx13GuMeshFactory14addHeightFieldEPNS_2Gu11HeightFieldEb(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i3 = i8;
 i4 = i2 + 88 | 0;
 i2 = i1 ? i2 + 4 | 0 : 0;
 HEAP32[i3 >> 2] = i6;
 i5 = i6;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 if (!i2) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 }
}

function __ZN5Umbra12PortalCuller7executeERNS_16VisibilityResultEbbRKNS_4AABBEi(i5, i1, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (i2) {
  i2 = HEAP32[i2 + 1408 >> 2] | 0;
  HEAP32[i5 + 356 >> 2] = i2;
  HEAP8[i5 + 364 >> 0] = 0;
  i3 = i2 + 16384 | 0;
  if (i2 >>> 0 < 4294950912) {
   i1 = i2;
   do {
    _memset(i1 | 0, 0, 1024) | 0;
    i1 = i1 + 1024 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAPF32[i5 + 360 >> 2] = Math_fround(0.0);
 }
 HEAP32[i5 + 396 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i5 + 404 >> 0] = 1;
 HEAP32[i5 + 400 >> 2] = HEAP32[i1 + 32 >> 2];
 if (!(__ZN5Umbra12PortalCuller4initEbbRKNS_4AABBEi(i5, i7, i6, i8, i9) | 0)) {
  i9 = HEAP32[i5 >> 2] | 0;
  i9 = i9 + 28 | 0;
  i9 = HEAP32[i9 >> 2] | 0;
  return i9 | 0;
 }
 __ZN5Umbra12PortalCuller8traverseEv(i5);
 i9 = HEAP32[i5 >> 2] | 0;
 i9 = i9 + 28 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 return i9 | 0;
}

function __ZN17PersistentManager24GetPartiallyLoadedObjectEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = i2;
 if ((HEAP32[i1 + 176 >> 2] | 0) == (HEAP32[i1 + 120 >> 2] | 0)) {
  i2 = HEAP32[i1 + 168 >> 2] | 0;
  i3 = HEAP32[i1 + 172 >> 2] | 0;
  i1 = i2 + (i3 * 20 | 0) | 0;
 } else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i3, i1 + 116 | 0, i4);
  i4 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i1 + 168 >> 2] | 0;
  i3 = HEAP32[i1 + 172 >> 2] | 0;
  i1 = (i4 | 0) == -1 ? i2 + (i3 * 20 | 0) | 0 : i2 + (i4 * 20 | 0) | 0;
 }
 if ((i1 | 0) == (i2 + (i3 * 20 | 0) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP8[i1 + 17 >> 0] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN16ParticleAnimator12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 768 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 440 | 0)) {
   i4 = i7 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN15dtProximityGrid4initEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i5 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 16 | 0;
 HEAP32[i8 >> 2] = 0;
 i4 = (i1 | 0) > 65535 ? 65535 : i1;
 i1 = i4 + -1 | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = (i1 >>> 16 | i1) + 1 | 0;
 i3 = i5 + 20 | 0;
 i2 = __Z9dtReallocPvi(HEAP32[i3 >> 2] | 0, i1 << 1) | 0;
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = i2;
 HEAP32[i6 >> 2] = i1;
 i1 = i5 + 8 | 0;
 i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i4 << 3) | 0;
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 HEAP32[i8 >> 2] = i4;
 _memset(HEAP32[i3 >> 2] | 0, -1, HEAP32[i6 >> 2] << 1 | 0) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 65535;
 HEAP32[i5 + 32 >> 2] = 65535;
 HEAP32[i5 + 36 >> 2] = -65535;
 HEAP32[i5 + 40 >> 2] = -65535;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
 i8 = 1;
 return i8 | 0;
}

function __ZN14CachingManager7DisposeEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[gb + 1162492 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[gb + 1162492 >> 2] = i1;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (HEAP32[i2 + 4 >> 2] | 0)) {
   i5 = i2;
   i4 = i3;
   i7 = 10;
  } else {
   i6 = i3;
   do {
    i3 = HEAP32[i6 >> 2] | 0;
    if (i3) {
     __ZN5CacheD2Ev(i3);
     __ZdlPv(i3);
     i2 = HEAP32[i1 >> 2] | 0;
    }
    i6 = i6 + 4 | 0;
   } while ((i6 | 0) != (HEAP32[i2 + 4 >> 2] | 0));
   if (i2 | 0) {
    i5 = i2;
    i4 = HEAP32[i2 >> 2] | 0;
    i3 = i6;
    i7 = 10;
   }
  }
  if ((i7 | 0) == 10) {
   i2 = i4;
   if (i4 | 0) {
    if ((i3 | 0) != (i4 | 0)) HEAP32[i5 + 4 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
    __ZdlPv(i4);
   }
   __ZdlPv(i5);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i8 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5CacheD2Ev(i2);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13UnityProfiler10BeginFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 656 >> 2] | 0, i2 | 0, 2, 0);
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = i1 + 24 | 0;
 HEAP32[i5 >> 2] = i4;
 i6 = i4 & 1;
 HEAP8[i1 >> 0] = i6;
 i3 = i1 + 72 | 0;
 HEAP8[HEAP32[i3 >> 2] >> 0] = 0;
 HEAP8[i1 + 2 >> 0] = 0;
 if (!(i6 << 24 >> 24)) return;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 656 >> 2] | 0, i2 | 0, 0, i4 | 0);
 __ZN22UnityProfilerPerThread10BeginFrameE12ProfilerMode(HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0);
 __ZN19MemoryProfilerStats18ResetGCAllocationsEv(__Z22GetMemoryProfilerStatsv() | 0);
 d7 = +_emscripten_get_now() * 1.0e6;
 i5 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = ~~d7 >>> 0;
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = i1 + 40 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 return;
}

function __Z32CalculateCustomCullingParametersR17CullingParametersRK13LODParametersjPK5Planei(i3, i1, i4, i5, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i2 = i3 + 188 | 0;
 HEAP32[i2 >> 2] = i6;
 if ((i6 | 0) > 0) {
  i1 = 0;
  do {
   i7 = i3 + 28 + (i1 << 4) | 0;
   i8 = i5 + (i1 << 4) | 0;
   HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
   HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
   HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
   HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E(i5, i6, i3 + 352 | 0) | 0;
 HEAP32[i2 >> 2] = i6;
 HEAP32[i3 + 324 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = i4;
 return;
}

function __Z24GenerateIntegrationCacheR15PolynomialCurve(i4) {
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, i11 = 0;
 HEAPF32[i4 + 128 >> 2] = Math_fround(0.0);
 i6 = i4 + 224 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= 1) return;
 i1 = 1;
 f2 = Math_fround(0.0);
 i3 = i4 + 192 | 0;
 f5 = Math_fround(0.0);
 do {
  f9 = f2;
  f2 = Math_fround(HEAPF32[i3 >> 2]);
  i11 = i1 + -1 | 0;
  f8 = Math_fround(HEAPF32[i4 + (i11 << 4) >> 2]);
  f7 = Math_fround(HEAPF32[i4 + (i11 << 4) + 4 >> 2]);
  f10 = Math_fround(HEAPF32[i4 + (i11 << 4) + 8 >> 2]);
  f9 = Math_fround(f2 - f9);
  f5 = Math_fround(f5 + Math_fround(f9 * Math_fround(Math_fround(HEAPF32[i4 + (i11 << 4) + 12 >> 2]) + Math_fround(f9 * Math_fround(Math_fround(f10 * Math_fround(.5)) + Math_fround(f9 * Math_fround(Math_fround(f9 * Math_fround(f8 * Math_fround(.25))) + Math_fround(f7 * Math_fround(.333333343)))))))));
  HEAPF32[i4 + 128 + (i1 << 2) >> 2] = f5;
  i3 = i4 + 192 + (i1 << 2) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i6 >> 2] | 0));
 return;
}

function __Z20CreateObjectFromCodeI13RenderTextureEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNK5physx2Cm10Collection5getIdERKNS_6PxBaseE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 64 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  i6 = 0;
  setTempRet0(i5 | 0);
  return i6 | 0;
 }
 i5 = i4;
 i5 = i5 + ~(i5 << 15) | 0;
 i5 = (i5 >>> 10 ^ i5) * 9 | 0;
 i5 = i5 >>> 6 ^ i5;
 i5 = i5 + ~(i5 << 11) | 0;
 i1 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i5 = 0;
  i6 = 0;
  setTempRet0(i5 | 0);
  return i6 | 0;
 }
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 i3 = i2 + 52 | 0;
 while (1) {
  i2 = i5 + (i1 << 4) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i2 = 0;
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) {
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 if (!i2) {
  i5 = 0;
  i6 = 0;
  setTempRet0(i5 | 0);
  return i6 | 0;
 }
 i6 = i5 + (i1 << 4) + 8 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 setTempRet0(i5 | 0);
 return i6 | 0;
}

function __ZN8LODGroupC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 57764 + 8;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = -1;
 HEAP8[i1 + 72 >> 0] = 1;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 685198 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 688663 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx3Scb5Cloth9syncStateEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 i7 = i8 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 & 7) {
  i3 = i1 >>> 24 & 15;
  i6 = (HEAP32[gb + 90260 + 24 + (i3 << 2) >> 2] | 0) + i8 | 0;
  i2 = i8 + 8 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (!i4) {
   i4 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i8 >> 2] | 0, i3) | 0;
   HEAP32[i2 >> 2] = i4;
   i1 = HEAP32[i7 >> 2] | 0;
   i2 = i4;
  } else i2 = i4;
  if (i1 & 1) {
   HEAP16[i5 >> 1] = HEAP16[i2 >> 1] | 0;
   __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i6, i5);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 & 2) {
   __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i6, HEAP8[i2 + 2 >> 0] | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  if (i1 & 4) HEAP8[i6 + 11 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
 }
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i7 >> 2] = i1 & -16777216;
 STACKTOP = i9;
 return;
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER17RemapPPtrTransfer(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 80 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 i3 = HEAP32[i4 + 96 >> 2] | 0;
 i4 = i1 + (i3 << 3) | 0;
 if (!i3) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN15ParticleEmitter12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = i7 + 768 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (!i5) return; else i1 = 0;
 while (1) {
  i3 = i7 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (fb + 441 | 0)) {
   i4 = i7 + (i1 * 12 | 0) + 8 | 0;
   i2 = i7 + (i1 * 12 | 0) + 4 | 0;
   if (!(HEAP8[i4 >> 0] | 0)) break;
   if (!(HEAP32[i2 >> 2] | 0)) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 i6 = (HEAP32[i8 >> 2] | 0) + -1 | 0;
 HEAP32[i8 >> 2] = i6;
 if (i6 >>> 0 <= i1 >>> 0) return;
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i7 + (i6 * 12 | 0) >> 2] = HEAP32[i7 + (i1 * 12 | 0) >> 2];
  HEAP32[i7 + (i6 * 12 | 0) + 4 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
  HEAP8[i7 + (i6 * 12 | 0) + 8 >> 0] = HEAP8[i7 + (i1 * 12 | 0) + 8 >> 0] | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN13RenderTexture12SetDimensionE16TextureDimension(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i4 = i5 + 4 | 0;
 if ((i3 + -2 | 0) >>> 0 >= 5) {
  HEAP32[i1 >> 2] = i3;
  __Z6FormatPKcz(i4, gb + 408869 | 0, i1);
  if (!i2) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 406201 | 0, 846, 1, i1, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
 i1 = i2 + 104 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  STACKTOP = i5;
  return;
 }
 if (!(HEAP32[i2 + 128 >> 2] | 0)) if (!(HEAP32[i2 + 136 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i3;
  STACKTOP = i5;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 408970 | 0, 0, gb + 406201 | 0, 849, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine7Connect16PersistentValuesC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 189084 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 189368 + 8;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 return;
}

function __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = (HEAP32[i1 + 896 >> 2] | 0) + 804 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK13Vector2fIcallS1_fS1_fiffP12RaycastHit2D(i1, i2, f3, i4, f5, i6, f7, f8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i10 + 16 | 0;
 i12 = i10 + 8 | 0;
 i11 = i10;
 i14 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i13 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 if ((__ZN16Physics2DManager7BoxCastERK8Vector2fS2_fS2_fiffPK10Collider2DbP12RaycastHit2Di(i14, i13, i12, f3, i11, f5, i6, f7, f8, 0, 0, i9, 1) | 0) != 1) {
  STACKTOP = i10;
  return;
 }
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i9);
 STACKTOP = i10;
 return;
}

function __Z45CommandBuffer_CUSTOM_SetRenderTarget_ColDepthP12Il2CppObjectR26MonoRenderTargetIdentifierS2_iii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i7 = i10 + 16 | 0;
 i8 = i10 + 4 | 0;
 i12 = HEAP32[i2 + 4 >> 2] | 0;
 i11 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = i12;
 HEAP32[i7 + 8 >> 2] = i11;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = i11;
 HEAP32[i8 + 8 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9); else {
  __ZN22RenderingCommandBuffer18AddSetRenderTargetEiPK18RenderTextureParamRS1_i11CubemapFacei(i1, 1, i7, i8, i4, i5, i6);
  STACKTOP = i10;
  return;
 }
}

function _cff_builder_close_contour(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i6) return;
 i8 = HEAP32[i6 >> 2] | 0;
 i9 = i8 & 65535;
 i1 = i8 >>> 16 & 65535;
 if (i9 << 16 >> 16 < 2) i7 = 0; else i7 = (HEAP16[(HEAP32[i6 + 12 >> 2] | 0) + ((i8 << 16 >> 16) + -2 << 1) >> 1] | 0) + 1 | 0;
 i5 = i6 + 2 | 0;
 i2 = i8 >> 16;
 if (i1 << 16 >> 16 > 1) {
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i3 + (i2 << 3) + -8 | 0;
  i2 = (HEAP32[i6 + 8 >> 2] | 0) + i2 + -1 | 0;
  if ((HEAP32[i3 + (i7 << 3) >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if ((HEAP32[i3 + (i7 << 3) + 4 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) if ((HEAP8[i2 >> 0] | 0) == 1) {
   i1 = i1 + -1 << 16 >> 16;
   HEAP16[i5 >> 1] = i1;
  }
 }
 if (i9 << 16 >> 16 <= 0) return;
 i2 = (i1 << 16 >> 16) + -1 | 0;
 if ((i7 | 0) == (i2 | 0)) {
  HEAP16[i6 >> 1] = i9 + -1 << 16 >> 16;
  HEAP16[i5 >> 1] = i1 + -1 << 16 >> 16;
  return;
 } else {
  HEAP16[(HEAP32[i6 + 12 >> 2] | 0) + ((i8 << 16 >> 16) + -1 << 1) >> 1] = i2;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __ZN16CrashReportEventD2Ev(i2 + 32 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 5;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9Rigidbody9SweepTestERK8Vector3ff23QueryTriggerInteractionR10RaycastHit(i3, i4, f5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1452816 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452816 | 0, i1);
  i2 = gb + 1452816 | 0;
 } else i2 = 0;
 i1 = HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 48 >> 2] | 0;
 if (i1 >>> 0 < 32) i1 = HEAP32[(HEAP32[(__Z21GetManagerFromContexti(9) | 0) + 724 >> 2] | 0) + (i1 << 2) >> 2] | 0; else i1 = -5;
 i1 = __ZN5Unity12PhysicsQuery18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction(0, HEAP32[i3 + 52 >> 2] | 0, i4, f5, i7, i1, i6) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 685086 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN13MonoBehaviour22DoScriptRebuildWarningEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i3 + 56 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i1 + 4 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 if (!(__Z14IsWorldPlayingv() | 0)) {
  STACKTOP = i6;
  return;
 }
 i2 = i3 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = gb + 587985 | 0; else if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0)) i1 = gb + 587985 | 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 }
 HEAP32[i5 >> 2] = i1;
 __Z6FormatPKcz(i4, gb + 587992 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 587199 | 0, 1754, 512, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __Z50AnimatorControllerPlayable_CUSTOM_SetIntegerStringR9HPlayableP12Il2CppStringi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 12 | 0;
 i4 = i6 + 16 | 0;
 i5 = i6;
 HEAP32[i7 >> 2] = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0;
 i1 = mftCall_iiii(i2 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i4) | 0, i7 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i7, i1, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return;
}

function __Z29StdTemplateConversionFunctionIjbEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = (i7 | 0) != 0;
  i7 = i7 & 1;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = (i7 | 0) != 0;
 i7 = i7 & 1;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIibEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = (i7 | 0) != 0;
  i7 = i7 & 1;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = (i7 | 0) != 0;
 i7 = i7 & 1;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z27FindActiveTransformWithPathPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = (HEAP8[i1 >> 0] | 0) == 47;
 i4 = i5 ? i1 + 1 | 0 : i1;
 if (!(HEAP8[i4 >> 0] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = __Z20GetGameObjectManagerv() | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1;
 L4 : do if ((i2 | 0) != (i3 | 0)) {
  while (1) {
   i1 = __ZL31FindActiveTransformWithPathImplPKcR10GameObjectb(i4, HEAP32[i1 + 8 >> 2] | 0, i5) | 0;
   if (i1 | 0) break;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i3 | 0)) break L4;
  }
  return i1 | 0;
 } while (0);
 i3 = __Z20GetGameObjectManagerv() | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = i3 + 8 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 while (1) {
  i1 = __ZL31FindActiveTransformWithPathImplPKcR10GameObjectb(i4, HEAP32[i1 + 8 >> 2] | 0, i5) | 0;
  if (i1 | 0) {
   i2 = 8;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __Z20CreateObjectFromCodeI12CubemapArrayEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN12CubemapArrayC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __Z18pqHeapNewPriorityQP9TESSallociPFiPvS1_E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 12 | 0;
 i5 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, 28) | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = i1;
 i1 = i1 + 1 | 0;
 i6 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 << 2 | 0) | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) {
  mftCall_vii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i4 >> 2] | 0, i5 | 0);
  i6 = 0;
  return i6 | 0;
 }
 i1 = mftCall_iii(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 << 3 | 0) | 0;
 HEAP32[i5 + 4 >> 2] = i1;
 if (!i1) {
  i6 = i2 + 8 | 0;
  mftCall_vii(HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0);
  mftCall_vii(HEAP32[i6 >> 2] | 0, HEAP32[i4 >> 2] | 0, i5 | 0);
  i6 = 0;
  return i6 | 0;
 } else {
  HEAP32[i5 + 20 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 24 >> 2] = i3;
  HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = 1;
  HEAP32[i1 + 8 >> 2] = 0;
  i6 = i5;
  return i6 | 0;
 }
 return 0;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = i1 + -116 | 0;
 i2 = i1 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 HEAP32[i5 >> 2] = i6;
 i3 = i1 + 268 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i1 + 272 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i1 + 264 >> 2] | 0) + (i4 << 2) >> 2] = i6;
  HEAP32[i3 >> 2] = i4 + 1;
  i6 = i1 + 276 | 0;
  HEAP8[i6 >> 0] = 1;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_19PxProfileZoneClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i1 + 260 | 0, i5) | 0;
  i6 = i1 + 276 | 0;
  HEAP8[i6 >> 0] = 1;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN6Camera14UpdateVelocityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __ZNK9Transform11GetPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i3 = i1 + 904 | 0;
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 908 >> 2]));
 f5 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 912 >> 2]));
 f7 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 124 >> 2]);
 f6 = Math_fround(f6 * f7);
 f5 = Math_fround(f5 * f7);
 HEAPF32[i1 + 892 >> 2] = Math_fround(f8 * f7);
 HEAPF32[i1 + 896 >> 2] = f6;
 HEAPF32[i1 + 900 >> 2] = f5;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 676962 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684496 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN13WheelCollider5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 72 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 76 >> 2] = Math_fround(35.0e3);
 HEAPF32[i1 + 80 >> 2] = Math_fround(4500.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 88 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(.25);
 HEAPF32[i1 + 104 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 108 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(.800000011);
 HEAPF32[i1 + 116 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 128 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 136 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 140 >> 2] = Math_fround(1.0);
 return;
}

function __ZN11GPUProfiler8EndFrameEv() {
 var i1 = 0, i2 = 0, d3 = 0.0;
 if ((HEAP16[gb + 1163352 + 6 >> 1] | 0) > -1) {
  i1 = HEAP32[gb + 1163228 >> 2] | 0;
  if (!i1) i1 = gb + 1163352 | 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = gb + 1163352 | 0; else {
   __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i1, gb + 1163352 | 0, 0) | 0;
   i1 = gb + 1163352 | 0;
  }
 } else i1 = 0;
 if (HEAP8[gb + 1546603 >> 0] | 0) {
  __ZN11GPUProfiler13GPUTimeSampleEv();
  i2 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 672 >> 2] | 0, i2 | 0);
  HEAP8[gb + 1546603 >> 0] = 0;
 }
 if (!i1) return;
 if ((HEAP16[i1 + 6 >> 1] | 0) <= -1) return;
 i2 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 d3 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i2, i1, ~~d3 >>> 0, +Math_abs(d3) >= 1.0 ? (d3 > 0.0 ? ~~+Math_min(+Math_floor(d3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d3 - +(~~d3 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 return;
}

function __Z39Scene_CUSTOM_GetRootGameObjectsInternaliP12Il2CppObject(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = __Z15GetSceneManagerv() | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 i2 = HEAP32[i5 + 104 >> 2] | 0;
 i5 = i5 + 100 | 0;
 i3 = i2;
 if ((i3 | 0) == (i5 | 0)) {
  i4 = 0;
  i5 = i6 + 12 | 0;
  HEAP32[i5 >> 2] = i4;
  i6 = i6 + 16 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 1 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 i4 = i6 + 8 | 0;
 i1 = 0;
 do {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if (i2) {
   i2 = HEAP32[i2 + 28 >> 2] | 0;
   if (i2) {
    i7 = HEAP32[i4 >> 2] | 0;
    __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i7, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0);
    i1 = i1 + 1 | 0;
   }
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i5 | 0));
 i7 = i6 + 12 | 0;
 HEAP32[i7 >> 2] = i1;
 i7 = i6 + 16 | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 i6 = i6 + 1 | 0;
 HEAP32[i7 >> 2] = i6;
 return;
}

function __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i2 = (i1 | 0) == (i9 | 0) ? 0 : i9;
 i8 = HEAP32[(__Z26GetPhysicsScriptingClassesv() | 0) + 28 >> 2] | 0;
 i9 = (i2 | 0) == 0 ? 0 : (i1 - i9 | 0) / 44 | 0;
 i8 = __Z19scripting_array_newP11Il2CppClassjj(i8, 44, i9) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 44) | 0, i2 | 0, i9 * 44 | 0) | 0;
 i9 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 44) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return i8 | 0; else i5 = 0;
 do {
  i3 = i9 + (i5 * 44 | 0) + 40 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4) {
   HEAP32[i3 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i4) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < ((i2 - i1 | 0) / 44 | 0) >>> 0);
 return i8 | 0;
}

function __Z13InvokeDelayedR13MonoBehaviourR11ICallStringff(i3, i1, f4, f5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 8 | 0;
 i6 = i7 + 4 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i2, HEAP32[i1 >> 2] | 0);
 i8 = HEAP8[i2 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i8 = (i9 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255) + 1 | 0;
 i1 = _malloc(i8) | 0;
 _strncpy(i1, i9 ? HEAP32[i2 >> 2] | 0 : i2, i8) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (f5 > Math_fround(9.99999974e-06) | f5 == Math_fround(0.0)) {
  HEAP32[i6 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
  __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 595 | 0, i2, f4, i1, f5, fb + 1579 | 0, 3);
  STACKTOP = i7;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 464651 | 0, i7);
}

function __GLOBAL__sub_I_runtime_input_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1161936 >> 2] = 0;
 i3 = gb + 63424 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1161936 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1161936 + 12 >> 2] = 16;
 _strncpy(gb + 1161936 + 16 | 0, gb + 441141 | 0, 32) | 0;
 i1 = gb + 1161936 + 47 | 0;
 i2 = i1 + 33 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3397 | 0, fb + 3398 | 0, 0, gb + 1161936 | 0);
 HEAP32[gb + 1162016 >> 2] = 0;
 i3 = gb + 63424 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162016 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162016 + 12 >> 2] = 16;
 i1 = gb + 1162016 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3399 | 0, fb + 3400 | 0, 0, gb + 1162016 | 0);
 return;
}

function __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 3) + 1 | 0;
 if (i3 >>> 0 > 536870911) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 2;
 i4 = i6 >> 3 >>> 0 < 268435455 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 536870911;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 3) | 0;
 i5 = i6 + (i2 - i1 >> 3 << 3) | 0;
 i11 = i7;
 i7 = HEAP32[i11 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 3) << 3) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 8;
 HEAP32[i8 >> 2] = i6 + (i4 << 3);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd7FastIPC18receiveAcknowledgeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[i1 + 128 >> 2] | 0;
 do if (!i4) i1 = 1; else {
  i1 = i4 + 32 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 + 8 >> 2] | 0);
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
   HEAP32[i1 >> 2] = 0;
   i1 = 0;
   break;
  }
  i3 = HEAP32[i4 + 20 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0)) i1 = 1; else {
   i2 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i2 + (i1 + 4) >> 2] | 0) < 0) {
    HEAP32[i3 >> 2] = 0;
    i1 = 0;
    break;
   }
   i2 = (HEAP32[i2 + i1 >> 2] | 0) + i1 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   if (i2 >>> 0 < i1 >>> 0) {
    HEAP32[i3 >> 2] = i2;
    i1 = 0;
    break;
   } else {
    HEAP32[i3 >> 2] = i2 - i1;
    i1 = 0;
    break;
   }
  }
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 688555 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx5cloth8SwSolver19StartSimulationTask11runInternalEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i1 + 72 >> 2] | 0;
 if (i3) {
  i3 = i3 + 8 | 0;
  i5 = i1;
  mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP16[i1 + 76 >> 1] | 0, i5 | 0, ((i5 | 0) < 0) << 31 >> 31 | 0, i5 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i5 = i2 + (i3 * 40 | 0) | 0;
 if (!i3) return;
 i4 = i4 + 12 | 0;
 do {
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  if ((HEAP32[i3 + 524 >> 2] | 0) >>> 0 < (HEAP32[i3 + 516 >> 2] | 0) >>> 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i2 + 16 >> 2] = 1;
   i3 = i2 + 12 | 0;
   HEAP32[i3 >> 2] = i1;
   if (i1 | 0) {
    mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
    HEAP32[i2 + 8 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
   }
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  }
  i2 = i2 + 40 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZN5physx2Gu9Container5RefitEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((HEAP32[i4 + 12 >> 2] | 0) < 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = i4 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i3 = i1 >>> 0 > 1073741823 ? -1 : i1 << 2;
 if (!i3) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i3 = mftCall_iiiiii(i7 | 0, i6 | 0, i3 | 0, (i1 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 656004 | 0, 153) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i3;
 }
 i7 = i4 + 8 | 0;
 _memcpy(i2 | 0, HEAP32[i7 >> 2] | 0, i1 << 2 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = i2;
 i7 = 1;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVE(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f9 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(f9 - f7);
 f10 = Math_fround(f10 - f6);
 f8 = Math_fround(f8 - f5);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(Math_fround(f12 - f7) - f9);
 f6 = Math_fround(Math_fround(f11 - f6) - f10);
 f5 = Math_fround(Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) - f5) - f8);
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(-Math_fround(f10 * f6)) - Math_fround(f9 * f7)) - Math_fround(f8 * f5)) / Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)));
 return;
}

function __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, f9 = f0;
 i1 = HEAP32[i8 >> 2] | 0;
 i2 = i8 + 4 + (i1 * 12 | 0) | 0;
 L1 : do if ((i1 | 0) > 0) {
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
  f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
  i6 = i8 + 4 | 0;
  while (1) {
   f9 = Math_fround(f3 * Math_fround(HEAPF32[i6 >> 2]));
   f9 = Math_fround(f9 + Math_fround(f4 * Math_fround(HEAPF32[i6 + 4 >> 2])));
   if (Math_fround(Math_abs(Math_fround(f9 + Math_fround(f5 * Math_fround(HEAPF32[i6 + 8 >> 2]))))) > Math_fround(.999899983)) {
    i1 = 0;
    break;
   }
   i6 = i6 + 12 | 0;
   if (i6 >>> 0 >= i2 >>> 0) break L1;
  }
  return i1 | 0;
 } while (0);
 if (i1 >>> 0 >= 256) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = i1 + 1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i8 + 4 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i8 + 4 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i8 = 1;
 return i8 | 0;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i9 = i3 + i2 | 0;
 i7 = HEAP8[i1 >> 0] | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i9 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i9;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP8[i1 + 11 >> 0] = i7;
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 3 >> 0] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 4;
 return;
}

function __ZN5physx13GuMeshFactory13addConvexMeshEPNS_2Gu10ConvexMeshEb(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i3 = i8;
 i4 = i2 + 48 | 0;
 i2 = i1 ? i2 + 4 | 0 : 0;
 HEAP32[i3 >> 2] = i6;
 i5 = i6;
 if (!i6) {
  STACKTOP = i8;
  return;
 }
 if (!i2) {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i3, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 }
}

function __ZN12AdsIdHandlerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 40 >> 0] = 0;
 HEAP8[i1 + 41 >> 0] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i2;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 68 >> 2] = i2;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 return;
}

function __ZN11Rigidbody2D9AddTorqueEfNS_9ForceModeE(i1, f4, i2) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i5) return;
 if (HEAP32[i1 + 68 >> 2] | 0) return;
 i1 = (HEAP32[i5 >> 2] | 0) == 2;
 if (!i2) {
  if (!i1) return;
  i2 = i5 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  i5 = i5 + 84 | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f4);
  return;
 } else {
  if (!i1) return;
  i2 = i5 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 2)) {
   i3 = i1 & 65535;
   if (!(i3 & 2)) {
    i1 = (i3 | 2) & 65535;
    HEAP16[i2 >> 1] = i1;
    HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
   }
  }
  if (!(i1 & 2)) return;
  f4 = Math_fround(Math_fround(HEAPF32[i5 + 128 >> 2]) * f4);
  i5 = i5 + 72 | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f4);
  return;
 }
}

function __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = (HEAP32[i1 + 900 >> 2] | 0) + 164 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 28 | 0;
 i4 = i5;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 52 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 228 >> 2] | 0, i6 | 0, i4 | 0) | 0)) {
  i8 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 84 >> 2] | 0, i3 | 0, i8 | 0);
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = HEAP32[i3 + 8 >> 2] | 0;
  i6 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i8;
  HEAP32[i4 + 8 >> 2] = i7;
  HEAP32[i4 + 12 >> 2] = i6;
 }
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 i8 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 224 >> 2] | 0, i8 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5IMGUI23CacheGUIStatePropertiesER8GUIStateRNS_23GUIStatePropertiesCacheE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2;
 i4 = i1 + 108 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 68 >> 2] = i3;
 HEAP32[i2 + 72 >> 2] = i4;
 HEAP32[i2 + 76 >> 2] = i5;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 84 >> 2] = i5;
 HEAP32[i2 + 88 >> 2] = i4;
 HEAP32[i2 + 92 >> 2] = i3;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 100 >> 2] = i3;
 HEAP32[i2 + 104 >> 2] = i4;
 HEAP32[i2 + 108 >> 2] = i5;
 HEAP8[i2 + 112 >> 0] = (HEAP32[i1 + 60 >> 2] | 0) != 0 & 1;
 return;
}

function __ZN30ReportScriptingObjectsTransfer8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i3 + 4 | 0;
 mftCall_vi(HEAP32[i4 + 16 >> 2] | 0, i1 | 0);
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 + 20 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = i3;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = i3 + 12 | 0;
 do {
  i8 = i1 + 64 | 0;
  HEAP32[i4 >> 2] = i8;
  HEAP32[i3 >> 2] = i2 - i8 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i6 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN14NavMeshManager19RegisterOffMeshLinkER11OffMeshLinkRi(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = i7 + 80 | 0;
 i10 = i7 + 92 | 0;
 i11 = HEAP32[i10 >> 2] | 0;
 i4 = i11 + 1 | 0;
 i5 = i7 + 96 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i3 = i6 & 2147483647;
 do if (i4 >>> 0 > i3 >>> 0) {
  i2 = i6 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i3 >>> 0 < i2 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i7 + 84 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i10 >> 2] << 2 | 0) | 0;
   HEAP32[i5 >> 2] = i2;
   HEAP32[i9 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i10 >> 2] = i4;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i11 << 2) >> 2] = i1;
 HEAP32[i8 >> 2] = i11;
 return;
}

function __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = (HEAP32[i1 + 892 >> 2] | 0) + 800 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 2);
  i5 = HEAP16[i5 >> 1] | 0;
  i5 = _llvm_bswap_i16(i5 | 0) | 0;
  HEAP16[i1 >> 1] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP16[i3 >> 1] | 0;
  HEAP16[i5 >> 1] = i3;
  HEAP32[i2 >> 2] = i4;
  i5 = i3;
  i5 = _llvm_bswap_i16(i5 | 0) | 0;
  HEAP16[i1 >> 1] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 2);
  i5 = HEAP16[i5 >> 1] | 0;
  i5 = _llvm_bswap_i16(i5 | 0) | 0;
  HEAP16[i1 >> 1] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP16[i3 >> 1] | 0;
  HEAP16[i5 >> 1] = i3;
  HEAP32[i2 >> 2] = i4;
  i5 = i3;
  i5 = _llvm_bswap_i16(i5 | 0) | 0;
  HEAP16[i1 >> 1] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z18SRGB_LinearToGammaR14ImageReference(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = (i1 | 0) < 64 ? i1 : 64;
 i9 = (i1 | 0) / (i5 | 0) | 0;
 if ((i1 | 0) > 0) {
  i4 = i1 - (Math_imul(i5 + -1 | 0, i9) | 0) | 0;
  i2 = 0;
  do {
   HEAP32[i7 + (i2 * 12 | 0) >> 2] = i6;
   if (!i2) {
    i1 = i4;
    i3 = 0;
   } else {
    i1 = i9;
    i3 = HEAP32[i7 + ((i2 + -1 | 0) * 12 | 0) + 8 >> 2] | 0;
   }
   HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] = i3;
   HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] = i1 + i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i8, fb + 2405 | 0, i7, i5, 0, 0);
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i8);
 STACKTOP = i10;
 return;
}

function __Z18SRGB_GammaToLinearR14ImageReference(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = (i1 | 0) < 64 ? i1 : 64;
 i9 = (i1 | 0) / (i5 | 0) | 0;
 if ((i1 | 0) > 0) {
  i4 = i1 - (Math_imul(i5 + -1 | 0, i9) | 0) | 0;
  i2 = 0;
  do {
   HEAP32[i7 + (i2 * 12 | 0) >> 2] = i6;
   if (!i2) {
    i1 = i4;
    i3 = 0;
   } else {
    i1 = i9;
    i3 = HEAP32[i7 + ((i2 + -1 | 0) * 12 | 0) + 8 >> 2] | 0;
   }
   HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] = i3;
   HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] = i1 + i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i8, fb + 2404 | 0, i7, i5, 0, 0);
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i8);
 STACKTOP = i10;
 return;
}

function __Z18ConvertImageToRGBMR14ImageReference(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 784 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10 + 8 | 0;
 i8 = i10;
 i1 = HEAP32[i6 + 8 >> 2] | 0;
 i5 = (i1 | 0) < 64 ? i1 : 64;
 i9 = (i1 | 0) / (i5 | 0) | 0;
 if ((i1 | 0) > 0) {
  i4 = i1 - (Math_imul(i5 + -1 | 0, i9) | 0) | 0;
  i2 = 0;
  do {
   HEAP32[i7 + (i2 * 12 | 0) >> 2] = i6;
   if (!i2) {
    i1 = i4;
    i3 = 0;
   } else {
    i1 = i9;
    i3 = HEAP32[i7 + ((i2 + -1 | 0) * 12 | 0) + 8 >> 2] | 0;
   }
   HEAP32[i7 + (i2 * 12 | 0) + 4 >> 2] = i3;
   HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] = i1 + i3;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i5 | 0));
 }
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i8, fb + 2406 | 0, i7, i5, 0, 0);
 if (!(HEAP32[i8 >> 2] | 0)) {
  STACKTOP = i10;
  return;
 }
 __Z21CompleteFenceInternalR8JobFence(i8);
 STACKTOP = i10;
 return;
}

function __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 532 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 520 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 508 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 496 | 0);
 i1 = i3 + 472 | 0;
 i2 = i3 + 496 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 184 | 0;
 i2 = i3 + 472 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 16 | 0;
 i2 = i3 + 184 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__210__time_getD2Ev(i3 + 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 532 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 520 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 508 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 496 | 0);
 i1 = i3 + 472 | 0;
 i2 = i3 + 496 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 184 | 0;
 i2 = i3 + 472 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 16 | 0;
 i2 = i3 + 184 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__210__time_getD2Ev(i3 + 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN5physx25PxConstraintGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741607;
 HEAP32[i1 + 4 >> 2] = 105;
 HEAP32[i1 + 8 >> 2] = fb + 2183;
 HEAP32[i1 + 12 >> 2] = gb + 756565;
 HEAP32[i1 + 16 >> 2] = 106;
 HEAP32[i1 + 20 >> 2] = gb + 771563;
 HEAP32[i1 + 24 >> 2] = gb + 771570;
 HEAP32[i1 + 28 >> 2] = fb + 794;
 HEAP32[i1 + 32 >> 2] = fb + 795;
 HEAP32[i1 + 36 >> 2] = gb + 743223;
 HEAP32[i1 + 40 >> 2] = 107;
 HEAP32[i1 + 44 >> 2] = fb + 2184;
 HEAP32[i1 + 48 >> 2] = fb + 3588;
 HEAP32[i1 + 52 >> 2] = gb + 673134;
 HEAP32[i1 + 56 >> 2] = 108;
 HEAP32[i1 + 60 >> 2] = fb + 2185;
 HEAP32[i1 + 64 >> 2] = gb + 771577;
 HEAP32[i1 + 68 >> 2] = 109;
 HEAP32[i1 + 72 >> 2] = gb + 771588;
 HEAP32[i1 + 76 >> 2] = gb + 771595;
 HEAP32[i1 + 80 >> 2] = fb + 18;
 HEAP32[i1 + 84 >> 2] = fb + 796;
 HEAP32[i1 + 88 >> 2] = gb + 771603;
 HEAP32[i1 + 92 >> 2] = 110;
 HEAP32[i1 + 96 >> 2] = fb + 475;
 HEAP32[i1 + 100 >> 2] = fb + 411;
 HEAP32[i1 + 104 >> 2] = gb + 831985;
 HEAP32[i1 + 108 >> 2] = 111;
 HEAP32[i1 + 112 >> 2] = fb + 2186;
 return;
}

function __ZN14NavMeshManager20CalculatePathCornersEP8Vector3fiRK11NavMeshPath(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 24 | 0;
 i7 = i9 + 12 | 0;
 i8 = i9;
 i2 = HEAP32[i1 + 112 >> 2] | 0;
 if ((i4 | 0) < 2 | ((i3 | 0) == 0 | (i2 | 0) == 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = HEAP32[i5 + 20 >> 2] | 0;
 if ((i1 | 0) < 1) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i5 + 32 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i5 + 36 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i5 + 40 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 48 >> 2];
 i8 = (__ZNK14dtNavMeshQuery16findStraightPathEPKfS1_PKyiPfPhPyPii(i2, i7, i8, HEAP32[i5 + 8 >> 2] | 0, i1, i3, 0, 0, i6, i4) | 0) < 0;
 i8 = i8 ? 0 : HEAP32[i6 >> 2] | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z29StdTemplateConversionFunctionIifEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  f9 = Math_fround(i7 | 0);
  HEAPF32[i5 >> 2] = f9;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 f9 = Math_fround(i7 | 0);
 HEAPF32[i5 >> 2] = f9;
 STACKTOP = i8;
 return 1;
}

function __Z18SkeletonBoneToMonoRK12SkeletonBoneR16MonoSkeletonBone(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 HEAP32[i2 >> 2] = __Z20scripting_string_newPKcj(i3 ? HEAP32[i1 >> 2] | 0 : i1, i3 ? HEAP32[i1 + 4 >> 2] | 0 : i5 & 255) | 0;
 i5 = i1 + 16 | 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 HEAP32[i2 + 4 >> 2] = __Z20scripting_string_newPKcj(i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 20 >> 2] | 0 : i3 & 255) | 0;
 i3 = i2 + 8 | 0;
 i4 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = i2 + 20 | 0;
 i4 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i2 = i2 + 36 | 0;
 i1 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function _fread(i3, i6, i1, i7) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = Math_imul(i1, i6) | 0;
 if ((HEAP32[i7 + 76 >> 2] | 0) > -1) i8 = ___lockfile(i7) | 0; else i8 = 0;
 i2 = i7 + 74 | 0;
 i5 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i5 + 255 | i5;
 i2 = i7 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = (HEAP32[i7 + 8 >> 2] | 0) - i5 | 0;
 if ((i4 | 0) > 0) {
  i4 = i4 >>> 0 < i9 >>> 0 ? i4 : i9;
  _memcpy(i3 | 0, i5 | 0, i4 | 0) | 0;
  HEAP32[i2 >> 2] = i5 + i4;
  i2 = i9 - i4 | 0;
  i3 = i3 + i4 | 0;
 } else i2 = i9;
 L7 : do if (!i2) i10 = 13; else {
  i5 = i7 + 32 | 0;
  while (1) {
   if (___toread(i7) | 0) break;
   i4 = mftCall_iiii(HEAP32[i5 >> 2] | 0, i7 | 0, i3 | 0, i2 | 0) | 0;
   if ((i4 + 1 | 0) >>> 0 < 2) break;
   i2 = i2 - i4 | 0;
   if (!i2) {
    i10 = 13;
    break L7;
   } else i3 = i3 + i4 | 0;
  }
  if (i8 | 0) ___unlockfile(i7);
  i1 = ((i9 - i2 | 0) >>> 0) / (i6 >>> 0) | 0;
 } while (0);
 if ((i10 | 0) == 13) if (i8) ___unlockfile(i7);
 return i1 | 0;
}

function __ZNSt3__213random_deviceC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 4 | 0;
 i5 = _open((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, i4) | 0;
 HEAP32[i1 >> 2] = i5;
 do if ((i5 | 0) < 0) {
  i5 = HEAP32[(___errno_location() | 0) >> 2] | 0;
  __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EEPKS6_RKS9_(i3, gb + 1082544 | 0, i2);
  __THREW__ = 0;
  invoke_vii(fb + 4496 | 0, i5 | 0, ((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   ___resumeException(i5 | 0);
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   break;
  }
 } while (0);
 STACKTOP = i4;
 return;
}

function __ZNK26AnimatorControllerPlayable18ValidateLayerIndexEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i3 | 0) >= 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0) i1 = HEAP32[HEAP32[i2 + 92 >> 2] >> 2] | 0; else i1 = 0;
  if ((i1 | 0) > (i3 | 0)) {
   i5 = 1;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i4 >> 2] = i3;
 __Z6FormatPKcz(i5, gb + 902210 | 0, i4);
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 899812 | 0, 734, 512, i1, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx7NpScene15addRigidDynamicERNS_14NpRigidDynamicE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i4 = ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0) | 0) & 8) != 0;
 __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i6 + 16 | 0, i5 + 48 | 0, i4);
 __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i5 + 20 | 0, i5);
 if (!i4) if (HEAP32[i5 + 16 >> 2] | 0) __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i5 + 12 | 0);
 i2 = i6 + 3552 | 0;
 i3 = i6 + 3556 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 36 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 if ((HEAP32[i6 + 3560 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5Unity17ConfigurableJoint16SetAngularZLimitERK14SoftJointLimit(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(1.0);
 f4 = i7 ? Math_fround(1.0) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i7 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i6 ? Math_fround(0.0) : f3;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
  i7 = f2 < Math_fround(3.0);
  i6 = f2 > Math_fround(177.0);
  f2 = i6 ? Math_fround(177.0) : f2;
  f2 = i7 ? Math_fround(3.0) : f2;
 }
 HEAPF32[i5 + 192 >> 2] = f2;
 HEAPF32[i5 + 196 >> 2] = f4;
 HEAPF32[i5 + 200 >> 2] = f3;
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i5);
 return;
}

function __ZN5Unity17ConfigurableJoint16SetAngularYLimitERK14SoftJointLimit(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i6 = f4 < Math_fround(0.0);
 i7 = f4 > Math_fround(1.0);
 f4 = i7 ? Math_fround(1.0) : f4;
 f4 = i6 ? Math_fround(0.0) : f4;
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(340282326000000008404918.0e15);
 f3 = i7 ? Math_fround(340282326000000008404918.0e15) : f3;
 f3 = i6 ? Math_fround(0.0) : f3;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 == Math_fround(0.0)) f2 = Math_fround(0.0); else {
  i7 = f2 < Math_fround(3.0);
  i6 = f2 > Math_fround(177.0);
  f2 = i6 ? Math_fround(177.0) : f2;
  f2 = i7 ? Math_fround(3.0) : f2;
 }
 HEAPF32[i5 + 180 >> 2] = f2;
 HEAPF32[i5 + 184 >> 2] = f4;
 HEAPF32[i5 + 188 >> 2] = f3;
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i5);
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 i1 = i2 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (HEAP32[i2 + 80 >> 2] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (__ZN39AssetBundleLoadFromStreamAsyncOperation22FinalizeArchiveCreatorEv(i2) | 0) {
  HEAPF32[i2 + 136 >> 2] = Math_fround(1.0);
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (HEAP32[i1 >> 2] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = 9;
 i1 = i2 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 __Z6FormatPKcz(i3, gb + 366859 | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 96 | 0, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI13CanvasManager12RemoveCanvasEPNS_6CanvasE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 HEAP32[i8 >> 2] = i1;
 i9 = i7 + 4 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i3 = i2;
 i6 = HEAP32[i7 >> 2] | 0;
 while (1) {
  if ((i6 | 0) == (i2 | 0)) {
   i4 = 9;
   break;
  }
  i5 = i6 + 4 | 0;
  if ((HEAP32[i6 >> 2] | 0) == (i1 | 0)) break; else i6 = i5;
 }
 if ((i4 | 0) == 9) {
  STACKTOP = i10;
  return;
 }
 i1 = i3 - i5 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i6 | 0, i5 | 0, i1 | 0) | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 i1 = i6 + (i3 << 2) | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i7 + 12 | 0, i8) | 0;
 STACKTOP = i10;
 return;
}

function __Z34TerrainData_CUSTOM_Internal_CreateP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(368, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 937264 | 0, 96) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN11TerrainDataC2E10MemLabelId18ObjectCreationMode(i1, i4, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 if (i1 | 0) __ZN9Heightmap13SetResolutionEi(i1 + 248 | 0, 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i3, i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 STACKTOP = i2;
 return;
}

function __Z34ParticleSystem_CUSTOM_GetParticlesP12Il2CppObjectP11Il2CppArray(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 i1 = __ZNK14ParticleSystem16GetParticleCountEv(i1) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 i1 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN14ParticleSystem20GetParticlesExternalEP22ParticleSystemParticlei(i2, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 120) | 0, i1);
  return i1 | 0;
 }
 return 0;
}

function __Z27scripting_class_get_methodsP11Il2CppClassRNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i5 = i8;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i1 = _il2cpp_class_get_methods(i2 | 0, i4 | 0) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i6 = i3 + 4 | 0;
 i7 = i3 + 8 | 0;
 do {
  HEAP32[i5 >> 2] = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) __ZNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i3, i5); else {
   i10 = i5;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i1 + 4 >> 2] = i9;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 8;
  }
  i1 = _il2cpp_class_get_methods(i2 | 0, i4 | 0) | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i8;
 return;
}

function __Z20CreateObjectFromCodeI10GameObjectEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(80, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _tt_cmap8_char_index(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 i2 = (HEAPU8[i1 + 8205 >> 0] | 0) << 16 | (HEAPU8[i1 + 8204 >> 0] | 0) << 24 | (HEAPU8[i1 + 8206 >> 0] | 0) << 8 | (HEAPU8[i1 + 8207 >> 0] | 0);
 if (!i2) return 0;
 i3 = i1 + 8208 | 0;
 i1 = i2;
 while (1) {
  i2 = (HEAPU8[i3 + 1 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0);
  if (i2 >>> 0 > i4 >>> 0) {
   i1 = 7;
   break;
  }
  i1 = i1 + -1 | 0;
  if (((HEAPU8[i3 + 5 >> 0] | 0) << 16 | (HEAPU8[i3 + 4 >> 0] | 0) << 24 | (HEAPU8[i3 + 6 >> 0] | 0) << 8 | (HEAPU8[i3 + 7 >> 0] | 0)) >>> 0 >= i4 >>> 0) {
   i1 = 6;
   break;
  }
  if (!i1) {
   i1 = 7;
   break;
  } else i3 = i3 + 12 | 0;
 }
 if ((i1 | 0) == 6) {
  i3 = (HEAPU8[i3 + 9 >> 0] | 0) << 16 | (HEAPU8[i3 + 8 >> 0] | 0) << 24 | (HEAPU8[i3 + 10 >> 0] | 0) << 8 | (HEAPU8[i3 + 11 >> 0] | 0);
  i4 = i4 - i2 | 0;
  return (i3 >>> 0 > ~i4 >>> 0 ? 0 : i3 + i4 | 0) | 0;
 } else if ((i1 | 0) == 7) return 0;
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 6;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 685552 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 684394 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN4FMOD6System9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i1 = __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi(i1 + 220 | 0, -1) | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 37;
   HEAP32[i4 + 4 >> 2] = gb + 860448;
   _printf(gb + 853277 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 37;
   HEAP32[i5 + 4 >> 2] = gb + 860448;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 37;
   STACKTOP = i6;
   return i7 | 0;
  }
  if (!i7) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 860448;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN15TerrainRenderer21BuildPatchMeshStreamsERA4_10StreamInfoRA8_11ChannelInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAPU8[gb + 1546313 + 1 >> 0] | 0;
 i5 = Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 >> 0] | 0) | 0, i5) | 0;
 i4 = HEAPU8[gb + 1546313 + 3 >> 0] | 0;
 i4 = (Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 + 2 >> 0] | 0) | 0, i4) | 0) + i5 | 0;
 i3 = HEAPU8[gb + 1546313 + 7 >> 0] | 0;
 i3 = (Math_imul(__Z20GetChannelFormatSizeh(HEAP8[gb + 1546313 + 6 >> 0] | 0) | 0, i3) | 0) + i4 & 255;
 HEAP8[i2 + 2 >> 0] = HEAP8[gb + 1546313 >> 0] | 0;
 HEAP8[i2 + 3 >> 0] = HEAP8[gb + 1546313 + 1 >> 0] | 0;
 HEAP8[i2 + 6 >> 0] = HEAP8[gb + 1546313 + 2 >> 0] | 0;
 HEAP8[i2 + 7 >> 0] = HEAP8[gb + 1546313 + 3 >> 0] | 0;
 HEAP8[i2 + 5 >> 0] = i5;
 HEAP8[i2 + 14 >> 0] = HEAP8[gb + 1546313 + 6 >> 0] | 0;
 HEAP8[i2 + 15 >> 0] = HEAP8[gb + 1546313 + 7 >> 0] | 0;
 HEAP8[i2 + 13 >> 0] = i4;
 HEAP32[i2 + 16 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 >> 2] = 27;
 HEAP8[i1 + 10 >> 0] = i3;
 return;
}

function __ZN7mecanim12statemachine24CreateStateMachineMemoryEPKNS0_20StateMachineConstantERNS_6memory9AllocatorE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, 88, 4) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = -1;
 HEAP32[i7 + 24 >> 2] = -1;
 HEAP32[i7 + 28 >> 2] = 1;
 i1 = i7 + 32 | 0;
 i2 = i1;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP16[i1 + 52 >> 1] = 0;
 HEAP8[i1 + 54 >> 0] = 0;
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 24 >> 2];
 i5 = i7 + 4 | 0;
 i4 = i4 + 28 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 return i7 | 0;
}

function __ZN5physx2Cm10FanoutTaskD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 101584 + 8;
 i1 = i2 + 88 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i3 = HEAP32[i2 + 80 >> 2] | 0;
 do if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 72 >> 2] | 0;
  if ((i2 + 52 | 0) == (i1 | 0)) {
   HEAP8[i2 + 68 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 } while (0);
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if ((i2 + 20 | 0) == (i1 | 0)) {
  HEAP8[i2 + 36 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5Umbra8QueryExtC2EPKNS_4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, i2, 0);
 return;
}

function __ZN5Umbra5Query4initEPKNS_4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, i2, 0);
 return;
}

function __ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i1 = __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi(i1 + 220 | 0, -1) | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 37;
   HEAP32[i4 + 4 >> 2] = gb + 853261;
   _printf(gb + 853277 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 37;
   HEAP32[i5 + 4 >> 2] = gb + 853261;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 37;
   STACKTOP = i6;
   return i7 | 0;
  }
  if (!i7) {
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
  HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853261;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN23PreloadManagerOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 27520 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 112 | 0, i2);
 HEAP8[i1 + 124 >> 0] = 1;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i1 + 128 >> 2] = gb + 27732 + 88;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAPF32[i1 + 136 >> 2] = Math_fround(0.0);
 __ZN4FileC2Ev(i1 + 144 | 0);
 i2 = i1 + 176 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 return;
}

function __ZN13SpringJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1);
 if (!(i1 & 16)) return;
 i4 = i3 + 96 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = f2 < Math_fround(.00499999989);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i1 ? Math_fround(.00499999989) : f2;
 HEAPF32[i4 >> 2] = f2;
 i4 = HEAP32[i3 + 60 >> 2] | 0;
 i1 = (i4 | 0) == 0;
 if (!i1) HEAPF32[i4 + 104 >> 2] = f2;
 i5 = i3 + 100 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 i6 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.0);
 f2 = i7 ? Math_fround(1.0) : f2;
 f2 = i6 ? Math_fround(0.0) : f2;
 HEAPF32[i5 >> 2] = f2;
 if (!i1) HEAPF32[i4 + 72 >> 2] = f2;
 i7 = i3 + 104 | 0;
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 i6 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i6 ? Math_fround(0.0) : f2;
 HEAPF32[i7 >> 2] = f2;
 if (i1) return;
 HEAPF32[i4 + 68 >> 2] = f2;
 return;
}

function __ZN12NavMeshAgent13SetBaseOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i4 = i6;
 i5 = i1 + 44 | 0;
 HEAPF32[i5 >> 2] = f2;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP8[i1 + 107 >> 0] & 1)) {
  STACKTOP = i6;
  return;
 }
 i7 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 + 480 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 484 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i7 + 488 >> 2];
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 f2 = Math_fround(-Math_fround(HEAPF32[i5 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4 >> 2] = f2;
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_(i1, i4, i3);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra12QueryContext11getGateCostERKNS_6PortalE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i4 + 16 >> 2] | 0;
 if (!i8) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i7 = i2 & 4095;
 if (!i7) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i6 = HEAP32[i4 + 100 >> 2] | 0;
 i5 = i2 >>> 12;
 i6 = i6 + (HEAP32[i6 + 120 >> 2] | 0) | 0;
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 if (!i2) {
  f1 = Math_fround(0.0);
  i2 = 0;
  do {
   f1 = Math_fround(f1 + Math_fround(HEAPF32[i8 + (HEAP32[i6 + (i5 + i2 << 2) >> 2] << 2) >> 2]));
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i7 | 0));
  return Math_fround(f1);
 }
 i3 = (HEAP32[i4 + 104 >> 2] | 0) + (HEAP32[i2 + 16 >> 2] | 0) | 0;
 f1 = Math_fround(0.0);
 i2 = 0;
 do {
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i8 + (HEAP32[i3 + (HEAP32[i6 + (i5 + i2 << 2) >> 2] << 2) >> 2] << 2) >> 2]));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 return Math_fround(f1);
}

function __ZN20TextRenderingPrivate8TextMeshC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 185632 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP8[i1 + 84 >> 0] = 1;
 HEAP32[i1 + 80 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(i8, i1) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i1;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i8 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 1 | 0;
 i2 = i8 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 2147483647;
 do if (i7 >>> 0 > i4 >>> 0) {
  i1 = i3 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i4 >>> 0 < i1 >>> 0) if ((i3 | 0) > -1) {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i4 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
   HEAP32[i2 >> 2] = i1;
   HEAP32[i8 >> 2] = i4;
   break;
  }
 } while (0);
 HEAP32[i5 >> 2] = i7;
 HEAP32[(HEAP32[i8 >> 2] | 0) + (i6 << 2) >> 2] = i9;
 return;
}

function __ZN14GfxDeviceStats26AccumulateUsedTextureUsageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 120 | 0;
 i5 = i1 + 132 | 0;
 i2 = i1 + 112 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i5 >> 2] | 0);
 i2 = HEAP32[i4 >> 2] | 0;
 i6 = i1 + 124 | 0;
 if ((i2 | 0) != (i6 | 0)) {
  i3 = i1 + 116 | 0;
  while (1) {
   i1 = __ZN14MemoryProfiler22GetRelatedIDMemorySizeEj(HEAP32[gb + 1163236 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i4, HEAP32[i6 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __Z20CreateObjectFromCodeI9TransformEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9TransformC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9Texture3DC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _open_memstream(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = _malloc(1160) | 0;
 if (!i1) i1 = 0; else {
  i4 = i1 + 4 | 0;
  i5 = i4 + 116 | 0;
  do {
   HEAP32[i4 >> 2] = 0;
   i4 = i4 + 4 | 0;
  } while ((i4 | 0) < (i5 | 0));
  i5 = i1 + 112 | 0;
  HEAP32[i1 + 84 >> 2] = i5;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i1 + 116 >> 2] = i3;
  i5 = i1 + 120 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = 4;
  HEAP32[i1 + 60 >> 2] = -1;
  HEAP32[i1 + 44 >> 2] = i1 + 136;
  HEAP32[i1 + 48 >> 2] = 1024;
  HEAP8[i1 + 75 >> 0] = -1;
  HEAP32[i1 + 36 >> 2] = fb + 493;
  HEAP32[i1 + 40 >> 2] = fb + 494;
  HEAP32[i1 + 12 >> 2] = fb + 2793;
  if (!(HEAP32[gb + 1469464 + 4 >> 2] | 0)) HEAP32[i1 + 76 >> 2] = -1;
  ___lock(gb + 1469464 + 28 | 0);
  i2 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
  HEAP32[i1 + 56 >> 2] = i2;
  if (i2 | 0) HEAP32[i2 + 52 >> 2] = i1;
  HEAP32[gb + 1469464 + 24 >> 2] = i1;
  ___unlock(gb + 1469464 + 28 | 0);
 }
 return i1 | 0;
}

function _casinf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, f9 = f0, i10 = 0, i11 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 32 | 0;
 i10 = i3 + 24 | 0;
 i11 = i3 + 16 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(+f7 * -2.0 * +f8);
 HEAPF32[i11 >> 2] = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f7 - f8) * Math_fround(f7 + f8)));
 HEAPF32[i11 + 4 >> 2] = f9;
 HEAP32[i5 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 _csqrtf(i10, i5);
 f9 = Math_fround(HEAPF32[i10 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i10 + 4 >> 2]));
 HEAPF32[i6 >> 2] = Math_fround(f9 - f8);
 HEAPF32[i6 + 4 >> 2] = f7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 _clogf(i4, i5);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function _casin(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 64 | 0;
 i9 = i3 + 48 | 0;
 i10 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 d8 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i10 >> 3] = 1.0 - (d4 - d8) * (d4 + d8);
 HEAPF64[i10 + 8 >> 3] = d4 * -2.0 * d8;
 HEAP32[i6 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 _csqrt(i9, i6);
 d4 = d4 + +HEAPF64[i9 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i9 >> 3] - d8;
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _clog(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZNSt3__2L22utf16le_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i8, i2, i9, i10, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i2;
 if (!(i1 & 4)) i1 = i8; else if ((i7 - i8 | 0) > 1) if ((HEAP8[i8 >> 0] | 0) == -1) i1 = (HEAP8[i8 + 1 >> 0] | 0) == -2 ? i8 + 2 | 0 : i8; else i1 = i8; else i1 = i8;
 i6 = i2 + -1 | 0;
 i5 = 0;
 L6 : while (1) {
  if (!(i5 >>> 0 < i9 >>> 0 & i1 >>> 0 < i6 >>> 0)) break;
  i4 = HEAPU8[i1 + 1 >> 0] << 8;
  i2 = HEAPU8[i1 >> 0] | 0;
  i3 = i4 | i2;
  switch ((i4 & 64512) << 16 >> 16) {
  case -9216:
   break L6;
  case -10240:
   {
    if ((i7 - i1 | 0) < 4) break L6;
    i4 = HEAPU8[i1 + 3 >> 0] << 8;
    if ((i4 & 64512 | 0) != 56320) break L6;
    if (((i3 << 10 & 983040) + 65536 | i2 << 10 & 64512 | i4 & 768 | HEAPU8[i1 + 2 >> 0]) >>> 0 > i10 >>> 0) break L6; else i1 = i1 + 4 | 0;
    break;
   }
  default:
   {
    if (i3 >>> 0 > i10 >>> 0) break L6;
    i1 = i1 + 2 | 0;
   }
  }
  i5 = i5 + 1 | 0;
 }
 return i1 - i8 | 0;
}

function __ZNSt3__2L22utf16be_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i8, i2, i9, i10, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i2;
 if (!(i1 & 4)) i1 = i8; else if ((i7 - i8 | 0) > 1) if ((HEAP8[i8 >> 0] | 0) == -2) i1 = (HEAP8[i8 + 1 >> 0] | 0) == -1 ? i8 + 2 | 0 : i8; else i1 = i8; else i1 = i8;
 i6 = i2 + -1 | 0;
 i5 = 0;
 L6 : while (1) {
  if (!(i5 >>> 0 < i9 >>> 0 & i1 >>> 0 < i6 >>> 0)) break;
  i4 = HEAPU8[i1 >> 0] << 8;
  i2 = HEAPU8[i1 + 1 >> 0] | 0;
  i3 = i4 | i2;
  switch ((i4 & 64512) << 16 >> 16) {
  case -9216:
   break L6;
  case -10240:
   {
    if ((i7 - i1 | 0) < 4) break L6;
    i4 = HEAPU8[i1 + 2 >> 0] << 8;
    if ((i4 & 64512 | 0) != 56320) break L6;
    if (((i3 << 10 & 983040) + 65536 | i2 << 10 & 64512 | i4 & 768 | HEAPU8[i1 + 3 >> 0]) >>> 0 > i10 >>> 0) break L6; else i1 = i1 + 4 | 0;
    break;
   }
  default:
   {
    if (i3 >>> 0 > i10 >>> 0) break L6;
    i1 = i1 + 2 | 0;
   }
  }
  i5 = i5 + 1 | 0;
 }
 return i1 - i8 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i3, i1, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i1;
 i4 = i6 - i5 >> 2;
 if (i4 >>> 0 > 1073741807) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i3);
  i2 = 5;
 } else if (i4 >>> 0 < 2) {
  HEAP8[i3 + 8 + 3 >> 0] = i4;
  i4 = i3;
 } else i2 = 5;
 do if ((i2 | 0) == 5) {
  i2 = i4 + 4 & -4;
  if (i2 >>> 0 > 1073741823) {
   i6 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i6);
   ___cxa_throw(i6 | 0, gb + 13048 | 0, fb + 3215 | 0);
  } else {
   i7 = __Znwj(i2 << 2) | 0;
   HEAP32[i3 >> 2] = i7;
   HEAP32[i3 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i3 + 4 >> 2] = i4;
   i4 = i7;
   break;
  }
 } while (0);
 i3 = (i6 - i5 | 0) >>> 2;
 i2 = i4;
 while (1) {
  if ((i1 | 0) == (i6 | 0)) break;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 }
 HEAP32[i4 + (i3 << 2) >> 2] = 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i7, i1, i2, i9, i10, i11, i3) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 if ((-18 - i7 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i6);
 if ((HEAP8[i6 + 11 >> 0] | 0) < 0) i8 = HEAP32[i6 >> 2] | 0; else i8 = i6;
 if (i7 >>> 0 < 2147483623) {
  i4 = i1 + i7 | 0;
  i5 = i7 << 1;
  i4 = i4 >>> 0 < i5 >>> 0 ? i5 : i4;
  i4 = i4 >>> 0 < 11 ? 11 : i4 + 16 & -16;
 } else i4 = -17;
 i5 = __Znwj(i4) | 0;
 if (i9 | 0) _memcpy(i5 | 0, i8 | 0, i9 | 0) | 0;
 if (i11 | 0) _memcpy(i5 + i9 | 0, i3 | 0, i11 | 0) | 0;
 i1 = i2 - i10 | 0;
 i2 = i1 - i9 | 0;
 if (i2 | 0) _memcpy(i5 + i9 + i11 | 0, i8 + i9 + i10 | 0, i2 | 0) | 0;
 if ((i7 | 0) != 10) __ZdlPv(i8);
 HEAP32[i6 >> 2] = i5;
 HEAP32[i6 + 8 >> 2] = i4 | -2147483648;
 i11 = i1 + i11 | 0;
 HEAP32[i6 + 4 >> 2] = i11;
 HEAP8[i5 + i11 >> 0] = 0;
 return;
}

function __ZNK21EnlightenSceneMapping15GetInstanceHashEi(i9, i8, i7) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i2 = HEAP32[i8 + 124 >> 2] | 0;
 i6 = HEAP32[i8 + 128 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((HEAP32[i1 >> 2] | 0) <= (i7 | 0)) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 + (i2 * 40 | 0) | 0) {
   i10 = i1 + (i2 * 40 | 0) + 24 | 0;
   HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
   HEAP32[i9 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
   HEAP32[i9 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
   return;
  }
 };
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP32[i9 + 12 >> 2] = 0;
 return;
}

function __ZN6Camera24OnRenderTextureDestroyedEP13RenderTexture(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 12 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 i6 = i7;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 if ((HEAP32[i3 + 4 >> 2] | 0) != (HEAP32[i2 + 744 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i4 >> 2] = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 368 >> 2] | 0, i3 | 0) | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 372 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i2, 0, 1, i5, i1, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 377645 | 0, 0, gb + 375437 | 0, 3269, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 3 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i10 = i2;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i10 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx3Scb13ObjectTracker17scheduleForRemoveERNS0_4BaseE(i4, i6) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i1 = i7;
 i2 = i6 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 1:
  {
   HEAP32[i2 >> 2] = i3 & 1073741823;
   HEAP32[i5 >> 2] = i6;
   __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i4, i5) | 0;
   STACKTOP = i7;
   return;
  }
 case 2:
  {
   HEAP32[i2 >> 2] = i3 | -1073741824;
   if (i3 & 268435456 | 0) {
    STACKTOP = i7;
    return;
   }
   HEAP32[i1 >> 2] = i6;
   i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i1, i5) | 0;
   if (!(HEAP8[i5 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return;
  }
 default:
  {
   STACKTOP = i7;
   return;
  }
 }
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setExternalAccelerationERKNS_6PxVec3E(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E(i1, i8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 256;
 return;
}

function __ZN23AllocationRootReferenceC2EP24ProfilerAllocationHeaderjPKcS3_(i5, i6, i1, i2, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i2;
 i4 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = i3 | 0 ? i3 : gb + 1576256 | 0;
 i2 = _strlen(i1) | 0;
 i3 = i4 + 11 | 0;
 if (i2 >>> 0 > 10) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i4, 10, i2 + -10 | 0, 0, 0, 0, i2, i1);
  HEAP32[i6 >> 2] = i5;
  return;
 }
 if (i2 | 0) _memmove(i4 | 0, i1 | 0, i2 | 0) | 0;
 HEAP8[i4 + i2 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 16 >> 2] = i2;
  HEAP32[i6 >> 2] = i5;
  return;
 } else {
  HEAP8[i3 >> 0] = i2;
  HEAP32[i6 >> 2] = i5;
  return;
 }
}

function __Z20CompareNavMeshParamsRK13NavMeshParamsS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 >> 2]));
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if (!((i5 ? f4 : f3) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 if (!((i5 ? f3 : f4) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 if (!((i5 ? f3 : f4) <= Math_fround(9.99999974e-06))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 i5 = (i5 ? f3 : f4) <= Math_fround(9.99999974e-06);
 return i5 | 0;
}

function __ZN9profiling14SamplerManager17UnregisterSamplerEP19ProfilerInformation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  STACKTOP = i5;
  return;
 }
 i4 = i3 + 24 | 0;
 i8 = gb + 63648 | 0;
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = _strlen(i7) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 20 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5eraseERS7_(i1, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!((i1 | 0) == 0 | (HEAP32[i2 >> 2] | 0) == 0)) __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 STACKTOP = i5;
 return;
}

function __ZN9HeightmapD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = i5 + 64 | 0;
 i4 = i5 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i2 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i4 >> 2] = i3;
 HEAP32[i3 >> 2] = i3;
 i1 = i5 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i5 + 44 | 0;
 if ((HEAP32[i5 + 60 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 48 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 24 | 0;
 if ((HEAP32[i5 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 28 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 4 | 0;
 if ((HEAP32[i5 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx9NpFactory15addArticulationEPNS_14PxArticulationEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 484 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx16PxsBroadPhaseMBP6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE(i7, i4, i5, i1, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 __ZN5physx16PxsBroadPhaseMBP13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE(i7, i1);
 i2 = i7 + 44 | 0;
 HEAP32[i7 + 64 >> 2] = i7;
 i3 = i7 + 4 | 0;
 HEAP32[i7 + 24 >> 2] = i7;
 HEAP32[i7 + 68 >> 2] = i4;
 HEAP32[i7 + 28 >> 2] = i4;
 HEAP32[i7 + 72 >> 2] = i5;
 HEAP32[i7 + 32 >> 2] = i5;
 HEAP32[i7 + 60 >> 2] = 1;
 i1 = i7 + 56 | 0;
 HEAP32[i1 >> 2] = i6;
 if (i6 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0);
  HEAP32[i7 + 52 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 }
 HEAP32[i7 + 20 >> 2] = 1;
 i6 = i7 + 16 | 0;
 HEAP32[i6 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 HEAP32[i7 + 12 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5Unity11SpringJoint14SetMinDistanceEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i7 = f1 < Math_fround(0.0);
 i6 = f1 > Math_fround(340282326000000008404918.0e15);
 f5 = i6 ? Math_fround(340282326000000008404918.0e15) : f1;
 i6 = i3 + 96 | 0;
 HEAPF32[i6 >> 2] = i7 ? Math_fround(0.0) : f5;
 i7 = i3 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 i2 = i3 + 100 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
 if (f5 < f1) {
  mftCall_vif(i4 | 0, i3 | 0, +f5);
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0, +Math_fround(HEAPF32[i2 >> 2]));
  return;
 } else {
  mftCall_vif(i4 | 0, i3 | 0, +f1);
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0, +Math_fround(HEAPF32[i6 >> 2]));
  return;
 }
}

function __ZN5Unity11SpringJoint14SetMaxDistanceEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i7 = f1 < Math_fround(0.0);
 i6 = f1 > Math_fround(340282326000000008404918.0e15);
 f4 = i6 ? Math_fround(340282326000000008404918.0e15) : f1;
 i6 = i3 + 100 | 0;
 HEAPF32[i6 >> 2] = i7 ? Math_fround(0.0) : f4;
 i7 = i3 + 32 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 i2 = i3 + 96 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 i3 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
 if (f1 < f4) {
  mftCall_vif(i5 | 0, i3 | 0, +f1);
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0, +Math_fround(HEAPF32[i6 >> 2]));
  return;
 } else {
  mftCall_vif(i5 | 0, i3 | 0, +f4);
  i7 = HEAP32[i7 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i7 >> 2] | 0) + 132 >> 2] | 0, i7 | 0, +Math_fround(HEAPF32[i2 >> 2]));
  return;
 }
}

function __ZN5Umbra5QueryC2EPKNS_4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 i4 = i3 + 36 | 0;
 i5 = i3 + 120 + 15 & -16;
 i6 = i5;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = i6;
 i1 = i6 + (i1 + 102400 - i5) | 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = i5;
 HEAP32[i3 + 52 >> 2] = i1 - i5;
 i1 = i3 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i4;
 HEAP32[i3 + 80 >> 2] = 1;
 HEAP32[i3 + 84 >> 2] = 1;
 HEAP32[i3 + 88 >> 2] = 1;
 HEAP32[i3 + 92 >> 2] = -1;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP32[i3 + 100 >> 2] = 0;
 HEAP32[i3 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i3, i2, 0);
 return;
}

function __ZN26AnimatorOverrideController8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 80 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 i3 = HEAP32[i4 + 96 >> 2] | 0;
 i4 = i1 + (i3 << 3) | 0;
 if (!i3) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN19SkinnedMeshRenderer29UpdateVisibleSkinnedMeshQueueEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 do if (!(HEAP8[i4 + 467 >> 0] | 0)) {
  i1 = i4 + 524 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return;
 } else {
  i1 = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 112 >> 2] | 0, i4 | 0) | 0) & i1;
  i3 = i4 + 524 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (!(i1 ^ (i2 | 0) != 0)) return;
  if (!i1) {
   if (i2 | 0) {
    i1 = i3;
    break;
   }
   return;
  }
  if ((i3 | 0) == (gb + 1161628 | 0)) return;
  if (!i2) i1 = i4 + 528 | 0; else {
   i1 = i4 + 528 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
  }
  i4 = HEAP32[gb + 1161628 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
  HEAP32[i1 >> 2] = gb + 1161628;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  return;
 } while (0);
 i4 = i4 + 528 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN13ComputeShaderD2Ev(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = gb + 67412 + 8;
 i6 = i9 + 44 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (i7 | 0) {
  i8 = i7 + -4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i5 = i7 + (i1 * 976 | 0) | 0;
   do {
    i1 = HEAP32[i5 + -12 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = i5 + -8 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i1);
    }
    i5 = i5 + -976 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  __ZdaPv(i8);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 i1 = i9 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i9 + 56 >> 2] = 0;
 HEAP32[i9 + 60 >> 2] = 0;
 __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev(i9 + 32 | 0);
 HEAP32[i9 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i9 + 28 | 0);
 HEAP32[i9 >> 2] = gb + 26392 + 8;
 return;
}

function __Z28Font_CUSTOM_GetCharacterInfoP12Il2CppObjecttPN20TextRenderingPrivate22ScriptingCharacterInfoEii(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[i2 + 48 >> 2] | 0;
 i1 = i3 & 65535;
 if (!(__ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj(i2, i1, i5, i6, Math_fround(1.0), 0) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 40 >> 2] = i5;
 HEAP32[i4 + 44 >> 2] = i6;
 __ZNK20TextRenderingPrivate8FontImpl22GetCharacterRenderInfoEjijfR5RectTIfES3_RbPj(i2, i1, i5, i6, Math_fround(1.0), i4 + 20 | 0, i4 + 4 | 0, i4 + 48 | 0, 0);
 HEAPF32[i4 + 36 >> 2] = Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(i2, i1, i5, i6, Math_fround(1.0), 0));
 i6 = 1;
 return i6 | 0;
}

function __ZNK9dtNavMesh14isValidPolyRefEy(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if ((i3 | 0) == 0 & (i1 | 0) == 0) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = _bitshift64Lshr(i3 | 0, i1 | 0, 48) | 0;
 getTempRet0() | 0;
 i4 = _bitshift64Lshr(i3 | 0, i1 | 0, 20) | 0;
 getTempRet0() | 0;
 i4 = i4 & 268435455;
 i5 = i3 & 65535;
 if ((i3 & 983040 | 0) == 65536 & 0 == 0) {
  if (i5 >>> 0 >= (HEAP32[i2 + 44 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  if ((HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + (i5 * 104 | 0) + 92 >> 2] | 0) != (i6 | 0)) {
   i6 = 0;
   return i6 | 0;
  }
 } else {
  if (i4 >>> 0 >= (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  if ((HEAP32[i1 + (i4 * 56 | 0) + 4 >> 2] | 0) != (i6 | 0)) {
   i6 = 0;
   return i6 | 0;
  }
  i1 = HEAP32[i1 + (i4 * 56 | 0) + 8 >> 2] | 0;
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
  if (i5 >>> 0 >= (HEAP32[i1 + 20 >> 2] | 0) >>> 0) {
   i6 = 0;
   return i6 | 0;
  }
 }
 i6 = 1;
 return i6 | 0;
}

function __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i3, f4, f5, i1, i2) {
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f6 = f0, f7 = f0, i8 = 0;
 i8 = f4 > Math_fround(0.0);
 f7 = i8 ? f4 : Math_fround(0.0);
 i8 = f5 > Math_fround(0.0);
 f5 = i8 ? f5 : Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f7 + Math_fround(1.0)))) * Math_fround(9.99999997e-07)));
 f6 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(Math_abs(Math_fround(f5 + Math_fround(1.0)))) * Math_fround(9.99999997e-07)));
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) + f4);
 f4 = f7 < f4 ? f7 : f4;
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 28 >> 2]) + f6);
 f6 = f5 < f6 ? f5 : f6;
 f5 = Math_fround(Math_floor(Math_fround(f4)));
 HEAPF32[i1 >> 2] = Math_fround(f4 - f5);
 f4 = Math_fround(Math_floor(Math_fround(f6)));
 HEAPF32[i2 >> 2] = Math_fround(f6 - f4);
 return ~~Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i3 + 32 >> 2]))) >>> 0 | 0;
}

function __ZNK5Umbra14TomeCollection15getObjectBoundsEiRNS_7Vector3ES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 i2 = i1 + (HEAP32[i1 + 68 >> 2] | 0) + (i2 * 24 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 _memmove(i3 | 0, i2 | 0, 12) | 0;
 i5 = i5 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 3 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i10 = i2;
   i9 = HEAP32[i10 + 4 >> 2] | 0;
   i8 = i1;
   HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i8 + 4 >> 2] = i9;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i10 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setExternalAccelerationERKNS_6PxVec3E(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E(i1, i8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 16 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 256;
 return;
}

function __ZN5Umbra15BufferAllocator11findFreeRunEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i6 + 136 >> 2] >> 5;
 if ((i8 | 0) > 0) {
  i1 = 0;
  i5 = 0;
  i2 = 0;
 } else {
  i8 = -1;
  return i8 | 0;
 }
 L3 : while (1) {
  i3 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
  if ((i2 | 0) >= (i7 | 0)) {
   i2 = 10;
   break;
  }
  switch (i3 | 0) {
  case 0:
   {
    i3 = i1;
    i2 = i2 + 32 | 0;
    break;
   }
  case -1:
   {
    i3 = (i5 << 5) + 32 | 0;
    i2 = 0;
    break;
   }
  default:
   {
    while (1) {
     i9 = _llvm_cttz_i32(i3 | 0) | 0;
     i4 = i9 + i2 | 0;
     i2 = i3 >>> i9;
     if ((i4 | 0) >= (i7 | 0)) {
      i2 = 10;
      break L3;
     }
     i9 = _llvm_cttz_i32(~i2 | 0) | 0;
     i3 = i2 >>> i9;
     i1 = i4 + i1 + i9 | 0;
     if (!i3) break; else i2 = 0;
    }
    i3 = i1;
    i2 = 0 - i1 & 31;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) >= (i8 | 0)) {
   i1 = -1;
   i2 = 10;
   break;
  } else i1 = i3;
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __Z11MurmurHash2PKvij(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = i1 ^ i2;
 if ((i2 | 0) > 3) {
  i4 = i2 + -4 | 0;
  i5 = i4 & -4;
  i6 = i3 + (i5 + 4) | 0;
  while (1) {
   i8 = Math_imul(HEAP32[i3 >> 2] | 0, 1540483477) | 0;
   i1 = (Math_imul(i8 >>> 24 ^ i8, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
   i2 = i2 + -4 | 0;
   if ((i2 | 0) <= 3) break; else i3 = i3 + 4 | 0;
  }
  i2 = i4 - i5 | 0;
  i3 = i6;
 }
 switch (i2 | 0) {
 case 3:
  {
   i1 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 ^ i1;
   i7 = 7;
   break;
  }
 case 2:
  {
   i7 = 7;
   break;
  }
 case 1:
  break;
 default:
  {
   i8 = i1;
   i7 = i8 >>> 13;
   i8 = i7 ^ i8;
   i8 = Math_imul(i8, 1540483477) | 0;
   i7 = i8 >>> 15;
   i8 = i7 ^ i8;
   return i8 | 0;
  }
 }
 if ((i7 | 0) == 7) i1 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 ^ i1;
 i8 = Math_imul((HEAPU8[i3 >> 0] | 0) ^ i1, 1540483477) | 0;
 i7 = i8 >>> 13;
 i8 = i7 ^ i8;
 i8 = Math_imul(i8, 1540483477) | 0;
 i7 = i8 >>> 15;
 i8 = i7 ^ i8;
 return i8 | 0;
}

function __ZNSt3__28ios_base5iwordEi(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 1 | 0;
 i7 = i4 + 56 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 do if (i9 >>> 0 > i1 >>> 0) {
  i6 = i1 << 1;
  i6 = i9 >>> 0 < 536870911 ? (i6 >>> 0 < i9 >>> 0 ? i9 : i6) : 1073741823;
  i2 = i4 + 48 | 0;
  i1 = _realloc(HEAP32[i2 >> 2] | 0, i6 << 2) | 0;
  if (!i1) {
   __ZNSt3__28ios_base5clearEj(i4, HEAP32[i4 + 16 >> 2] | 1);
   HEAP32[gb + 1473500 >> 2] = 0;
   i1 = gb + 1473500 | 0;
   break;
  }
  HEAP32[i2 >> 2] = i1;
  i4 = i4 + 52 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i5 = i1 + (i6 << 2) | 0;
  i3 = i1 + (i2 << 2) | 0;
  while (1) {
   if (i3 >>> 0 >= i5 >>> 0) break;
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  }
  HEAP32[i7 >> 2] = i6;
  i3 = i4;
  i5 = 9;
 } else {
  i2 = i4 + 52 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 + 48 >> 2] | 0;
  i5 = 9;
 } while (0);
 if ((i5 | 0) == 9) {
  HEAP32[i3 >> 2] = i2 >>> 0 < i9 >>> 0 ? i9 : i2;
  i1 = i1 + (i8 << 2) | 0;
 }
 return i1 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 i12 = i1 + 8 | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP8[i12 + 8 + 3 >> 0] | 0;
 i13 = i3 << 24 >> 24 < 0;
 i2 = i13 ? HEAP32[i12 >> 2] | 0 : i12;
 i3 = i2 + ((i13 ? HEAP32[i12 + 4 >> 2] | 0 : i3 & 255) << 2) | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i9, i8, i4, i5, i6, i2, i3) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN8JSONRead14BeginMetaGroupEPKc(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN23TextDOMTransferReadBaseI8JSONReadE14BeginMetaGroupEPKc(i9, i1);
 i2 = i9 + 152 | 0;
 i3 = i9 + 164 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 168 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 << 2, 4, i9 + 156 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i9 + 156 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = 0;
 return;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBuffer31CopyDataAndMakeAvailableForReadEP26AtomicCircularBufferHandlePhii(i7, i8, i6, i1, i5) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if ((i6 | 0) != 0 & (i5 | 0) > 0) {
  i3 = i8 + 4 + i1 | 0;
  i1 = HEAP32[i7 + 4 >> 2] | 0;
  if (i3 >>> 0 < i1 >>> 0) {
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = i2 - i3 + (HEAP32[i7 + 8 >> 2] | 0) | 0;
   i1 = i1 >>> 0 > i5 >>> 0 ? i5 : i1;
   if (!i1) i4 = 0; else {
    _memcpy(i3 | 0, i6 | 0, i1 | 0) | 0;
    i4 = i1;
    i2 = HEAP32[i7 >> 2] | 0;
   }
  } else {
   i4 = 0;
   i2 = (HEAP32[i7 >> 2] | 0) + (i1 - i3) | 0;
  }
  i1 = i5 - i4 | 0;
  if ((i1 | 0) > 0) _memcpy(i2 | 0, i6 + i4 | 0, i1 | 0) | 0;
 }
 i2 = i7 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i1 + i3 | 0) != (i8 | 0)) continue;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) break;
 }
 HEAP32[i2 >> 2] = (HEAP32[i7 + 8 >> 2] | 0) + -1 & (i9 + 7 & -4) + i3;
 return;
}

function __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i7 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i7 + 24 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 if (i1 | 0) __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, i6, i1 << 2);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (i2 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = i2;
 }
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i7, i6 + 4 | 0, i1 << 2);
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb(i2, i1, gb + 1040830 | 0, 0, 0);
 i5 = i2 + 36 | 0;
 HEAP8[i5 >> 0] = 0;
 i6 = i2 + 40 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (!i7) return;
 if ((HEAP32[i7 + 16 >> 2] | 0) != 3) return;
 i8 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i2, i7, gb + 1046975 | 0) | 0;
 HEAP32[i6 >> 2] = i8;
 i3 = i2 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = gb + 1037407;
 if (i8 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i2, 0);
  __ZN8JSONRead8TransferIN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfigEEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 4 | 0, gb + 1037420 | 0, 0, 0);
  HEAP8[i5 >> 0] = 1;
  i8 = i2 + 56 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i6 >> 2] = i7;
 HEAP32[i3 >> 2] = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1 + 40 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1 + 168 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1 + 296 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev(i1 + 424 | 0);
 HEAP32[i1 + 552 >> 2] = 4;
 HEAP32[i1 + 556 >> 2] = 0;
 HEAP32[i1 + 560 >> 2] = 0;
 i2 = i1 + 568 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i1 + 576 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 584 >> 2] = 0;
 return;
}

function __Z20CreateObjectFromCodeI7CubemapEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(164, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7CubemapC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _getgrouplist(i7, i1, i2, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = HEAP32[i8 >> 2] | 0;
 if ((i9 | 0) < 1) i1 = -1; else {
  HEAP32[i2 >> 2] = i1;
  HEAP32[i8 >> 2] = 1;
  _setgrent();
  i1 = _getgrent() | 0;
  L3 : do if (i1 | 0) do {
   i2 = i2 + 4 | 0;
   L6 : while (1) {
    i6 = HEAP32[i8 >> 2] | 0;
    if ((i6 | 0) == 2147483647) break L3;
    i5 = HEAP32[i1 + 12 >> 2] | 0;
    i3 = HEAP32[i5 >> 2] | 0;
    L9 : do if (i3 | 0) {
     i4 = 0;
     while (1) {
      if (!(_strcmp(i7, i3) | 0)) break;
      i4 = i4 + 1 | 0;
      i3 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
      if (!i3) break L9;
     }
     i6 = i6 + 1 | 0;
     HEAP32[i8 >> 2] = i6;
     if (i6 >>> 0 <= i9 >>> 0) break L6;
    } while (0);
    i1 = _getgrent() | 0;
    if (!i1) break L3;
   }
   HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
   i1 = _getgrent() | 0;
  } while ((i1 | 0) != 0); while (0);
  _endgrent();
  i1 = HEAP32[i8 >> 2] | 0;
  i1 = i1 >>> 0 > i9 >>> 0 ? -1 : i1;
 }
 return i1 | 0;
}

function __ZN7mecanim24CreateValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
 i4 = i8 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i8 >> 2] = i7;
 i5 = (i7 | 0) == 0;
 if (i5) {
  HEAP32[i4 >> 2] = 0;
  return i8 | 0;
 }
 i3 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i7 * 12 | 0, 4) | 0;
 i2 = i3 + (i7 * 12 | 0) | 0;
 if ((i3 | 0) == (i2 | 0)) {
  i1 = i4;
  i2 = i3 | 0 ? i3 - i1 | 0 : 0;
  HEAP32[i4 >> 2] = i2;
 } else {
  i1 = i3;
  do {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 10;
   HEAP32[i1 + 8 >> 2] = 0;
   i1 = i1 + 12 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = i4;
  i2 = i3 | 0 ? i3 - i1 | 0 : 0;
  HEAP32[i4 >> 2] = i2;
  if (i5) return i8 | 0;
 }
 i2 = i2 + i1 | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = i6;
  HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return i8 | 0;
}

function __ZN5physx2Sc5Scene33updateFromVisualizationParametersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 1412 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 i2 = i3 + 1204 | 0;
 if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0, 7)) != Math_fround(0.0)) i4 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0, 8)) != Math_fround(0.0)) i4 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0, 9)) != Math_fround(0.0)) i4 = 6; else if (Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0, 10)) != Math_fround(0.0)) i4 = 6;
 if ((i4 | 0) == 6) {
  i4 = i3 + 1188 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
 }
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN5Umbra13MatrixFactory9frustumLHEffffff(i1, f2, f3, f4, f5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var f8 = f0, f9 = f0, f10 = f0;
 f10 = Math_fround(f6 * Math_fround(2.0));
 f9 = Math_fround(f3 - f2);
 HEAPF32[i1 >> 2] = Math_fround(f10 / f9);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 f8 = Math_fround(f5 - f4);
 f10 = Math_fround(f10 / f8);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f10;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 f8 = Math_fround(Math_fround(f4 + f5) / f8);
 f5 = Math_fround(f6 - f7);
 f4 = Math_fround(f7 / f5);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f2 + f3) / f9);
 HEAPF32[i1 + 24 >> 2] = f8;
 HEAPF32[i1 + 40 >> 2] = f4;
 HEAP32[i1 + 56 >> 2] = -1082130432;
 f7 = Math_fround(Math_fround(f6 * f7) / f5);
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = f7;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN2UI30RemoveCanvasRendererFromCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i5 = i5 + 112 | 0;
  i4 = HEAP16[i5 >> 1] | 0;
  i4 = i4 & 65535;
  i4 = i4 | 6;
  i4 = i4 & 65535;
  HEAP16[i5 >> 1] = i4;
  return;
 }
 i2 = i4 + 4 | 0;
 i3 = (HEAP32[i5 + 84 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 672 | 0) + 476 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
  if (!(HEAP32[i6 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i6 = i4 + 8 | 0;
 HEAP32[(HEAP32[i5 + 64 >> 2] | 0) + (HEAP32[i6 >> 2] << 2) >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i4 + 12 >> 2] = -1;
 i6 = i5 + 112 | 0;
 i5 = HEAP16[i6 >> 1] | 0;
 i5 = i5 & 65535;
 i5 = i5 | 6;
 i5 = i5 & 65535;
 HEAP16[i6 >> 1] = i5;
 return;
}

function __ZN21LightProbeProxyVolume7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(168, i1, 16, gb + 1048932 | 0, 0, gb + 380009 | 0, 62) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 34500 + 8;
 HEAP32[i4 + 140 >> 2] = 1;
 HEAP32[i4 + 144 >> 2] = 1;
 HEAP32[i4 + 148 >> 2] = 1;
 HEAP16[i4 + 152 >> 1] = -1;
 HEAP8[i4 + 154 >> 0] = 1;
 i2 = i4 + 156 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN18BuoyancyEffector2D10SetDensityEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(1.0e6);
 f1 = i3 ? Math_fround(1.0e6) : f1;
 HEAPF32[i2 + 96 >> 2] = i9 ? Math_fround(0.0) : f1;
 i9 = i2 + 36 | 0;
 i3 = HEAP32[i9 >> 2] | 0;
 i8 = i2 + 48 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) return; else i7 = i3;
 do {
  i4 = HEAP32[i7 + 16 >> 2] | 0;
  i5 = i4 + 4 | 0;
  i6 = HEAPU16[i5 >> 1] | 0;
  if (!(HEAP32[i4 >> 2] | 0)) {
   HEAP16[i5 >> 1] = i6 & 65533;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   i3 = i4 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
   i3 = HEAP32[i9 >> 2] | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else if (!(i6 & 2)) {
   HEAP16[i5 >> 1] = i6 | 2;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  }
  i7 = i7 + 40 | 0;
 } while ((i7 | 0) != (i3 + (i2 * 40 | 0) | 0));
 return;
}

function __ZN17AudioChorusFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 170016 + 8;
 HEAPF32[i1 + 44 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 60 >> 2] = Math_fround(40.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.800000011);
 HEAPF32[i1 + 68 >> 2] = Math_fround(.0299999993);
 HEAP32[i1 + 36 >> 2] = 12;
 STACKTOP = i4;
 return;
}

function __Z41Quaternion_CUSTOM_INTERNAL_CALL_AngleAxisfRK8Vector3fR11Quaternionf(f3, i2, i8) {
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 i8 = i8 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f6 * f6));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(Math_sqrt(Math_fround(f1 + Math_fround(f4 * f4))));
 if (f1 > Math_fround(9.99999997e-07)) {
  f5 = Math_fround(Math_fround(Math_fround(Math_fround(f3 / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)) * Math_fround(.5));
  f1 = Math_fround(Math_fround(+Math_sin(+f5)) / f1);
  f5 = Math_fround(+Math_cos(+f5));
  f4 = Math_fround(f4 * f1);
  f3 = Math_fround(f6 * f1);
  f1 = Math_fround(f7 * f1);
 } else {
  f5 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i8 >> 2] = f1;
 HEAPF32[i8 + 4 >> 2] = f3;
 HEAPF32[i8 + 8 >> 2] = f4;
 HEAPF32[i8 + 12 >> 2] = f5;
 return;
}

function __Z40TerrainData_Set_Custom_PropTreeInstancesP12Il2CppObjectP11Il2CppArray(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 40) | 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i3 + 100 | 0, i2, i2 + ((__Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0) * 40 | 0) | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  __ZN12TreeDatabase19UpdateTreeInstancesEv(i1 + 84 | 0);
  return;
 }
}

function __ZNK5physx7NpCloth16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES3_PNS_24PxClothCollisionTriangleE(i5, i4, i1, i3, i2, i6) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 switch ((HEAP32[i5 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i8 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i8 = 3; else i8 = 4;
   break;
  }
 default:
  i8 = 3;
 }
 if ((i8 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES4_PNS_24PxClothCollisionTriangleE(i5 + 32 | 0, i4, i1, i3, i2, i6);
  STACKTOP = i9;
  return;
 } else if ((i8 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 378, gb + 693958 | 0, i7);
  STACKTOP = i9;
  return;
 }
}

function __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math7affineXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i3) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 * 48 | 0, 4) | 0;
  i3 = i1 + (i3 * 48 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = 1065353216;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 1065353216;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 0;
    HEAP32[i2 + 28 >> 2] = 0;
    HEAP32[i2 + 32 >> 2] = 1065353216;
    HEAP32[i2 + 36 >> 2] = 0;
    HEAP32[i2 + 40 >> 2] = 0;
    HEAP32[i2 + 44 >> 2] = 0;
    i2 = i2 + 48 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 return i4 | 0;
}

function __ZN26AnimatorControllerPlayable8GetFloatEiRf(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i5 = 8;
  return i5 | 0;
 }
 i3 = i4 + 92 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i6 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i6 = 4;
  return i6 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) == 1) {
  i6 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
  i6 = i6 + (HEAP32[i6 >> 2] | 0) + 28 | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2];
  i6 = 1;
  return i6 | 0;
 } else {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  i6 = 2;
  return i6 | 0;
 }
 return 0;
}

function __ZN14EdgeCollider2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 48 | 0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f6 < Math_fround(0.0);
 i4 = f6 > Math_fround(1.0e6);
 f6 = i4 ? Math_fround(1.0e6) : f6;
 HEAPF32[i1 >> 2] = i5 ? Math_fround(0.0) : f6;
 i1 = i2 + 40 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i3 = gb + 1162356 | 0;
  i4 = HEAP32[i3 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i5 = HEAP32[i2 + 172 >> 2] | 0;
 if (!i5) return;
 i2 = HEAP32[i2 + 160 >> 2] | 0;
 i1 = 0;
 do {
  i3 = i2 + (i1 << 3) | 0;
  i4 = i2 + (i1 << 3) + 4 | 0;
  if (!((HEAP32[i3 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i4 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
   HEAPF32[i3 >> 2] = Math_fround(0.0);
   HEAPF32[i4 >> 2] = Math_fround(0.0);
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 return;
}

function __Z24CullStaticSceneWithUmbraR8JobFenceRK22SceneCullingParametersR13CullingOutput(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = __ZnwjRK10MemLabelIdiPKci(44, gb + 64024 | 0, 16, gb + 384140 | 0, 193) | 0;
 if ((__Z22GetJobQueueThreadCountv() | 0) > 2) i3 = (HEAP32[i1 + 844 >> 2] | 0) == 0 ? 6 : 1; else i3 = 1;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 40 >> 2] = i2;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 + 64 >> 2];
 if (i3 >>> 0 <= 1) {
  __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i4, fb + 2385 | 0, i6, i3, fb + 3334 | 0, 1);
  return;
 }
 i2 = i1 + 836 | 0;
 i1 = 1;
 do {
  i7 = __Z9GetIUmbrav() | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0, 0, gb + 64024 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i4, fb + 2385 | 0, i6, i3, fb + 3334 | 0, 1);
 return;
}

function __Z20GetTypeChildrenCountRK16TypeTreeIterator(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + (i4 * 24 | 0) | 0;
 if ((i2 + 24 | 0) >>> 0 >= (i1 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 if ((i3 | 0) == 0 ? 1 : (HEAPU8[i2 + 26 >> 0] | 0 | 0) != ((HEAPU8[i1 + (i4 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i5 = i7 + ((HEAP32[i3 + 12 >> 2] | 0) * 24 | 0) | 0;
 i6 = i7;
 i1 = 0;
 i2 = i4 + 1 | 0;
 L7 : while (1) {
  i1 = i1 + 1 | 0;
  i4 = HEAP8[i7 + (i2 * 24 | 0) + 2 >> 0] | 0;
  i3 = i7 + (i2 * 24 | 0) | 0;
  do {
   i2 = i3;
   i3 = i3 + 24 | 0;
   if (i3 >>> 0 >= i5 >>> 0) {
    i2 = 4;
    break L7;
   }
   i2 = HEAP8[i2 + 26 >> 0] | 0;
  } while ((i2 & 255) > (i4 & 255));
  if (i2 << 24 >> 24 != i4 << 24 >> 24) {
   i2 = 4;
   break;
  }
  i2 = (i3 - i6 | 0) / 24 | 0;
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z20CreateObjectFromCodeI6SpriteEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6SpriteC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function __ZNSt3__219__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_(i3, i4, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = i3 + 4 | 0;
 i1 = (HEAP32[i9 >> 2] | 0) != (fb + 4003 | 0);
 i6 = HEAP32[i3 >> 2] | 0;
 i2 = (HEAP32[i7 >> 2] | 0) - i6 | 0;
 i2 = i2 >>> 0 < 2147483647 ? i2 << 1 : -1;
 i2 = (i2 | 0) == 0 ? 1 : i2;
 i5 = (HEAP32[i4 >> 2] | 0) - i6 | 0;
 i6 = _realloc(i1 ? i6 : 0, i2) | 0;
 if (!i6) __ZSt17__throw_bad_allocv();
 do if (i1) {
  HEAP32[i3 >> 2] = i6;
  i8 = i6;
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  if (!i1) i8 = i6; else {
   __THREW__ = 0;
   invoke_vi(HEAP32[i9 >> 2] | 0, i1 | 0);
   i6 = __THREW__;
   __THREW__ = 0;
   if (i6 & 1) {
    i6 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i6);
   } else {
    i8 = HEAP32[i3 >> 2] | 0;
    break;
   }
  }
 } while (0);
 HEAP32[i9 >> 2] = fb + 4005;
 HEAP32[i4 >> 2] = i8 + i5;
 HEAP32[i7 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
 return;
}

function __ZNK20TextRenderingPrivate7FontRefltERKS0_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i3 = HEAP8[i6 + 11 >> 0] | 0;
 i5 = i3 << 24 >> 24 < 0;
 i3 = i5 ? HEAP32[i6 + 4 >> 2] | 0 : i3 & 255;
 i2 = HEAP8[i7 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = i4 ? HEAP32[i7 + 4 >> 2] | 0 : i2 & 255;
 i8 = i2 >>> 0 < i3 >>> 0;
 i1 = i8 ? i2 : i3;
 if (!i1) i9 = 3; else {
  i1 = _memcmp(i5 ? HEAP32[i6 >> 2] | 0 : i6, i4 ? HEAP32[i7 >> 2] | 0 : i7, i1) | 0;
  if (!i1) i9 = 3; else if ((i1 | 0) < 0) {
   i9 = 1;
   return i9 | 0;
  }
 }
 if ((i9 | 0) == 3) if (i3 >>> 0 < i2 >>> 0) {
  i9 = 1;
  return i9 | 0;
 }
 i1 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
 if (!i1) i9 = 7; else {
  i1 = _memcmp(i4 ? HEAP32[i7 >> 2] | 0 : i7, i5 ? HEAP32[i6 >> 2] | 0 : i6, i1) | 0;
  if (!i1) i9 = 7; else if ((i1 | 0) < 0) {
   i9 = 0;
   return i9 | 0;
  }
 }
 if ((i9 | 0) == 7) if (i8) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = (HEAP32[i6 + 12 >> 2] | 0) >>> 0 < (HEAP32[i7 + 12 >> 2] | 0) >>> 0;
 return i9 | 0;
}

function __ZN5physx2Sc7BodySim6wakeUpEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5physx2Sc5Actor9setActiveEbj(i1, 1, 0);
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
 i1 = i1 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 i6 = i3 + (i2 * 12 | 0) + 8 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i5 & 231 | 8;
 if (i5 & 8) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i6 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i2 & 31);
 i1 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] & 64) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = 1 << (i1 & 31);
 if (!(i3 & i1)) {
  HEAP32[i2 >> 2] = i3 | i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 } else {
  HEAP32[i2 >> 2] = i3 & ~i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
}

function __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 92 | 0, i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 40 | 0, gb + 946522 | 0, 0);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 36 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 52 | 0, gb + 800705 | 0, 0);
 STACKTOP = i7;
 return;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIjEEclERS1_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] << 2, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIiEEclERS1_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] << 2, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIfEEclERS1_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] << 2, (HEAP32[i1 >> 2] | 0) + i1 | 0, 4);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function _UNITY_ft_mem_qrealloc(i5, i2, i3, i4, i1, i6) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 do if ((i3 | i2 | i4 | 0) < 0) i2 = 6; else {
  if ((i2 | 0) == 0 | (i4 | 0) == 0) {
   if (!i1) {
    i2 = 0;
    i1 = 0;
    break;
   }
   mftCall_vii(HEAP32[i5 + 8 >> 2] | 0, i5 | 0, i1 | 0);
   i2 = 0;
   i1 = 0;
   break;
  }
  if ((2147483647 / (i2 | 0) | 0 | 0) < (i4 | 0)) i2 = 10; else {
   if (!((i3 | 0) == 0 & (i1 | 0) == 0)) {
    i3 = Math_imul(i3, i2) | 0;
    i4 = Math_imul(i4, i2) | 0;
    i5 = mftCall_iiiii(HEAP32[i5 + 12 >> 2] | 0, i5 | 0, i3 | 0, i4 | 0, i1 | 0) | 0;
    i4 = (i5 | 0) == 0;
    i2 = i4 ? 64 : 0;
    i1 = i4 ? i1 : i5;
    break;
   }
   i2 = Math_imul(i4, i2) | 0;
   if ((i2 | 0) <= 0) {
    i2 = i2 | 0 ? 6 : 0;
    i1 = 0;
    break;
   }
   i1 = mftCall_iii(HEAP32[i5 + 4 >> 2] | 0, i5 | 0, i2 | 0) | 0;
   if (!i1) {
    i2 = 64;
    i1 = 0;
   } else {
    _memset(i1 | 0, 0, i2 | 0) | 0;
    i2 = 0;
   }
  }
 } while (0);
 HEAP32[i6 >> 2] = i2;
 return i1 | 0;
}

function ___dup3(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 24 | 0;
 i7 = i9 + 16 | 0;
 i3 = i9;
 L1 : do if ((i4 | 0) == (i5 | 0)) i1 = ___syscall_ret(-22) | 0; else {
  i6 = (i1 & 524288 | 0) != 0;
  L4 : do if (i6) {
   L5 : while (1) {
    HEAP32[i3 >> 2] = i4;
    HEAP32[i3 + 4 >> 2] = i5;
    HEAP32[i3 + 8 >> 2] = i1;
    i2 = ___syscall330(330, i3 | 0) | 0;
    switch (i2 | 0) {
    case -38:
     break L4;
    case -16:
     break;
    default:
     break L5;
    }
   }
   i1 = ___syscall_ret(i2) | 0;
   break L1;
  } while (0);
  do {
   HEAP32[i7 >> 2] = i4;
   HEAP32[i7 + 4 >> 2] = i5;
   i1 = ___syscall63(63, i7 | 0) | 0;
  } while ((i1 | 0) == -16);
  if (i6) {
   HEAP32[i8 >> 2] = i5;
   HEAP32[i8 + 4 >> 2] = 2;
   HEAP32[i8 + 8 >> 2] = 1;
   ___syscall221(221, i8 | 0) | 0;
  }
  i1 = ___syscall_ret(i1) | 0;
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN5physx2Cm20visualizeJointFramesERNS0_12RenderOutputEfRKNS_11PxTransformES5_(i2, f4, i3, i1) {
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 24 | 0;
 i6 = i5;
 i3 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i2, i3) | 0;
 f8 = Math_fround(f4 * Math_fround(1.5));
 HEAPF32[i7 >> 2] = f8;
 HEAPF32[i7 + 4 >> 2] = f8;
 HEAPF32[i7 + 8 >> 2] = f8;
 HEAP32[i7 + 12 >> 2] = -2004353024;
 HEAP32[i7 + 16 >> 2] = -2013231104;
 HEAP32[i7 + 20 >> 2] = -2013265784;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i3, i7) | 0;
 i3 = __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i2, i1) | 0;
 HEAPF32[i6 >> 2] = f4;
 HEAPF32[i6 + 4 >> 2] = f4;
 HEAPF32[i6 + 8 >> 2] = f4;
 HEAP32[i6 + 12 >> 2] = -65536;
 HEAP32[i6 + 16 >> 2] = -16711936;
 HEAP32[i6 + 20 >> 2] = -16776961;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE(i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN4FMOD5Sound4lockEjjPPvS2_PjS3_(i2, i1, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   if (i6 | 0) HEAP32[i6 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1408) | 0;
   if (i8 | 0) HEAP32[i8 >> 2] = i5;
   if (i7 | 0) HEAP32[i7 >> 2] = 0;
   if (!i9) {
    i9 = 0;
    STACKTOP = i4;
    return i9 | 0;
   }
   HEAP32[i9 >> 2] = 0;
   i9 = 0;
   STACKTOP = i4;
   return i9 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870106;
 _printf(gb + 853184 | 0, i3) | 0;
 i9 = 36;
 STACKTOP = i4;
 return i9 | 0;
}

function __ZN20SoundChannelInstance11UpdatePitchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 i2 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 f6 = Math_fround(HEAPF32[i1 + 224 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i1 + 228 >> 2]));
 i1 = __ZN4FMOD7Channel12setFrequencyEf(i2, Math_fround(f6 * Math_fround(HEAPF32[i1 + 232 >> 2]))) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 472;
 HEAP32[i4 + 8 >> 2] = gb + 857806;
 HEAP32[i4 + 12 >> 2] = i2;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN17PersistentManager23PostReadActivationQueueEiPK8TypeTreeb(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 i4 = i7;
 HEAP32[i4 >> 2] = i2;
 if ((HEAP32[i1 + 176 >> 2] | 0) == (HEAP32[i1 + 120 >> 2] | 0)) i1 = (HEAP32[i1 + 168 >> 2] | 0) + ((HEAP32[i1 + 172 >> 2] | 0) * 20 | 0) | 0; else {
  __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_(i3, i1 + 116 | 0, i4);
  i4 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i1 + 168 >> 2] | 0;
  i1 = (i4 | 0) == -1 ? i3 + ((HEAP32[i1 + 172 >> 2] | 0) * 20 | 0) | 0 : i3 + (i4 * 20 | 0) | 0;
 }
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP8[i1 + 16 >> 0] = i6 & 1;
 HEAP8[i1 + 17 >> 0] = 1;
 STACKTOP = i7;
 return;
}

function __ZN11AudioSource14SetMaxDistanceEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0;
 i6 = i4 + 396 | 0;
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f1 = f7 > f1 ? f7 : f1;
 i5 = i4 + 400 | 0;
 if (f1 != Math_fround(HEAPF32[i5 >> 2])) HEAPF32[i5 >> 2] = f1;
 i2 = i4 + 456 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  __ZN20SoundChannelInstance19set3DMinMaxDistanceEff(i2, f7, Math_fround(HEAPF32[i5 >> 2])) | 0;
 }
 i2 = HEAP32[i4 + 432 >> 2] | 0;
 i4 = i4 + 428 | 0;
 i3 = i2;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i2 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  f7 = Math_fround(HEAPF32[i6 >> 2]);
  __ZN20SoundChannelInstance19set3DMinMaxDistanceEff(i2, f7, Math_fround(HEAPF32[i5 >> 2])) | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_SetBoxP12Il2CppObjectRK8Vector3f(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = i1 + 48 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z36Mesh_CUSTOM_PrintErrorCantAccessMeshP12Il2CppObject30InternalScriptingShaderChannel(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 i1 = HEAP32[gb + 58184 + (i1 << 2) >> 2] | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = i3;
  __Z6FormatPKcz(i4, gb + 546960 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 546865 | 0, 80, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 }
}

function __ZNK17CommonStringTable16FindCommonStringEPKc(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i7) {
  i7 = 0;
  return i7 | 0;
 }
 if (i7 >>> 0 < (gb + 388687 + 1052 | 0) >>> 0 & i7 >>> 0 >= (gb + 388687 | 0) >>> 0) return i7 | 0;
 i2 = HEAP8[i7 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i4 = 0; else {
  i1 = 0;
  i3 = i7;
  do {
   i1 = (i1 << 4) + (i2 << 24 >> 24) | 0;
   i5 = i1 & -268435456;
   i1 = (i5 >>> 24 | i5) ^ i1;
   i3 = i3 + 1 | 0;
   i2 = HEAP8[i3 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i4 = i1;
 }
 i1 = (i4 >>> 0) % 20 | 0;
 i5 = HEAP32[i6 + (i1 * 20 | 0) + 12 >> 2] | 0;
 if (!i5) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i6 + (i1 * 20 | 0) >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i3 + (i2 << 3) >> 2] | 0) == (i4 | 0)) {
   i1 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
   if (!(_strcmp(i1, i7) | 0)) {
    i2 = 10;
    break;
   }
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i1 + 72 + (i4 << 2) >> 2] | 0;
 if ((i6 | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i9 = HEAP32[i2 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) + 4 >> 2] << 2) >> 2] & 0 - (15106022 >>> i4 & 1);
 i8 = i4 | 0 ? HEAP32[i2 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) >> 2] << 2) >> 2] | 0 : 0;
 HEAP32[i5 >> 2] = HEAP32[i2 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] & 0 - (124830 >>> i4 & 1);
 HEAP32[i5 + 4 >> 2] = i9;
 HEAP32[i5 + 8 >> 2] = i8;
 i4 = i1 + 40 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei((i2 | 0) == 0 ? 0 : i2 + i4 | 0, i3, i5, i6);
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile15ZoneManagerImpl24removeProfileZoneHandlerERNS_20PxProfileZoneHandlerE(i4, i8) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i4 + 44 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i1 = i4 + 16 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 12 | 0;
  i3 = 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i6 = i4 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i8 = HEAP32[i7 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return;
 }
 i5 = i4 + 28 | 0;
 i4 = 0;
 do {
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i2 + (i4 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i8 | 0)) {
   i1 = i1 + -1 | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i3 >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 i8 = HEAP32[i7 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return;
}

function __ZN5physx2Sc8ClothSim17addCollisionShapeEPKNS0_8ShapeSimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 68 >> 2] | 0) {
 case 0:
  {
   i2 = __ZN5physx2Sc8ClothSim18addCollisionSphereEPKNS0_8ShapeSimE(i2, i1) | 0;
   return i2 | 0;
  }
 case 1:
  {
   i2 = __ZN5physx2Sc8ClothSim17addCollisionPlaneEPKNS0_8ShapeSimE(i2, i1) | 0;
   return i2 | 0;
  }
 case 2:
  {
   i2 = __ZN5physx2Sc8ClothSim19addCollisionCapsuleEPKNS0_8ShapeSimE(i2, i1) | 0;
   return i2 | 0;
  }
 case 3:
  {
   i2 = __ZN5physx2Sc8ClothSim15addCollisionBoxEPKNS0_8ShapeSimE(i2, i1) | 0;
   return i2 | 0;
  }
 case 4:
  {
   i2 = __ZN5physx2Sc8ClothSim18addCollisionConvexEPKNS0_8ShapeSimE(i2, i1) | 0;
   return i2 | 0;
  }
 case 5:
  {
   __ZN5physx2Sc8ClothSim16addCollisionMeshEPKNS0_8ShapeSimE(i2, i1) | 0;
   i2 = 1;
   return i2 | 0;
  }
 case 6:
  {
   __ZN5physx2Sc8ClothSim23addCollisionHeightfieldEPKNS0_8ShapeSimE(i2, i1) | 0;
   i2 = 1;
   return i2 | 0;
  }
 default:
  {
   i2 = 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Gu12selectNormalEhff(i5, f2, f3) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0;
 do if (f2 == Math_fround(0.0)) if (f3 == Math_fround(0.0)) i4 = 9; else {
  i1 = f3 == Math_fround(1.0);
  i1 = i1 ? 2 : 5;
  i4 = 8;
 } else {
  i1 = f3 == Math_fround(0.0);
  if (f2 == Math_fround(1.0)) {
   i1 = i1 ? 1 : 7;
   i4 = 8;
   break;
  }
  if (i1) i4 = 12; else {
   i1 = !(Math_fround(f2 + f3) >= Math_fround(.999899983));
   i1 = i1 ? 6 : 4;
   i4 = 8;
  }
 } while (0);
 L9 : do if ((i4 | 0) == 8) switch (i1 | 0) {
 case 0:
  {
   i4 = 9;
   break L9;
  }
 case 3:
  {
   i4 = 12;
   break L9;
  }
 case 1:
  {
   i1 = (i5 & 24) == 0;
   break L9;
  }
 case 2:
  {
   i1 = (i5 & 48) == 0;
   break L9;
  }
 case 4:
  {
   i1 = (i5 & 16) == 0;
   break L9;
  }
 case 5:
  return (i5 & 32) == 0 | 0;
 case 6:
  {
   i1 = 1;
   break L9;
  }
 default:
  {
   i1 = 0;
   break L9;
  }
 } while (0);
 if ((i4 | 0) == 9) i1 = (i5 & 40) == 0; else if ((i4 | 0) == 12) i1 = (i5 & 8) == 0;
 return i1 | 0;
}

function __ZN22BaseUnityConnectClient13ResumeSessionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 113 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP8[i4 >> 0] = 1;
 i1 = i2 + 4 | 0;
 L4 : do if ((HEAP32[i1 >> 2] | 0) == 3) i1 = 0; else {
  switch (HEAP32[i1 >> 2] | 0) {
  case 5:
  case 0:
   {
    i1 = 0;
    break L4;
   }
  case 1:
   {
    i3 = 7;
    break;
   }
  case 2:
   {
    if (!(HEAP8[i2 + 112 >> 0] | 0)) {
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
     i1 = 1;
     break L4;
    } else i3 = 8;
    break;
   }
  case 4:
   {
    if (!(HEAP8[i2 + 110 >> 0] | 0)) i3 = 7; else if (!(HEAP8[i2 + 108 >> 0] | 0)) i3 = 8; else i3 = 7;
    break;
   }
  default:
   i3 = 8;
  }
  if ((i3 | 0) == 7) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
   i1 = 1;
   break;
  } else if ((i3 | 0) == 8) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
   i1 = 1;
   break;
  }
 } while (0);
 HEAP8[i4 >> 0] = 0;
 i4 = i1;
 return i4 | 0;
}

function __ZN14DetailDatabaseC2EP11TerrainDataP12TreeDatabase(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 4 | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 1;
 HEAP32[i1 + 96 >> 2] = 1812433254;
 HEAP32[i1 + 100 >> 2] = 1900727103;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 60 >> 2] = 1060320051;
 HEAP32[i1 + 64 >> 2] = 1058642330;
 HEAP32[i1 + 68 >> 2] = 1056964608;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 80 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.5);
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 8;
 HEAP8[i1 >> 0] = 1;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 return;
}

function __ZN11AudioSource15GetSpectrumDataEPfii19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 16 | 0;
 i1 = HEAP32[i1 + 488 >> 2] | 0;
 if (!i1) {
  _memset(i2 | 0, 0, i3 << 2 | 0) | 0;
  STACKTOP = i8;
  return;
 }
 i1 = __ZN4FMOD12ChannelGroup11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4, i5) | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i5 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
 HEAP32[i7 >> 2] = gb + 855390;
 HEAP32[i7 + 4 >> 2] = 1749;
 HEAP32[i7 + 8 >> 2] = gb + 874664;
 HEAP32[i7 + 12 >> 2] = i5;
 __Z6FormatPKcz(i6, gb + 883334 | 0, i7);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return;
}

function __Z38TranslateQuadIndexBufferToTriangleListPtPKtj(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 i5 = i2 & -4;
 i2 = (i5 | 0) != 0;
 if (!i4) {
  if (i2) i2 = 0; else return;
  while (1) {
   i3 = i2 & 65535;
   HEAP16[i1 >> 1] = i3;
   HEAP16[i1 + 2 >> 1] = i2 | 1;
   i4 = (i2 | 2) & 65535;
   HEAP16[i1 + 4 >> 1] = i4;
   HEAP16[i1 + 6 >> 1] = i3;
   HEAP16[i1 + 8 >> 1] = i4;
   HEAP16[i1 + 10 >> 1] = i2 | 3;
   i2 = i2 + 4 | 0;
   if (i2 >>> 0 >= i5 >>> 0) break; else i1 = i1 + 12 | 0;
  }
  return;
 } else {
  if (i2) {
   i3 = 0;
   i2 = i4;
  } else return;
  while (1) {
   HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP16[i1 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | 0;
   i4 = i2 + 4 | 0;
   HEAP16[i1 + 4 >> 1] = HEAP16[i4 >> 1] | 0;
   HEAP16[i1 + 6 >> 1] = HEAP16[i2 >> 1] | 0;
   HEAP16[i1 + 8 >> 1] = HEAP16[i4 >> 1] | 0;
   HEAP16[i1 + 10 >> 1] = HEAP16[i2 + 6 >> 1] | 0;
   i3 = i3 + 4 | 0;
   if (i3 >>> 0 >= i5 >>> 0) break; else {
    i2 = i2 + 8 | 0;
    i1 = i1 + 12 | 0;
   }
  }
  return;
 }
}

function __Z35GetHasLateBoundSceneFromAssetBundleRK8UnityStrRS_S2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(__ZNK18AssetBundleManager24GetAssetBundleScenePathsERK8UnityStrRS0_S3_(__Z21GetAssetBundleManagerv() | 0, i1, i2, i3) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __Z20GetPersistentManagerv() | 0;
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i1 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i7 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i1, i3);
 i3 = __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = i3;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 532 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 520 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 508 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i3 + 496 | 0);
 i1 = i3 + 472 | 0;
 i2 = i3 + 496 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 184 | 0;
 i2 = i3 + 472 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 16 | 0;
 i2 = i3 + 184 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__210__time_getD2Ev(i3 + 12 | 0);
 return;
}

function __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 532 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 520 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 508 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 496 | 0);
 i1 = i3 + 472 | 0;
 i2 = i3 + 496 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 184 | 0;
 i2 = i3 + 472 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 i1 = i3 + 16 | 0;
 i2 = i3 + 184 | 0;
 do {
  i2 = i2 + -12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 } while ((i2 | 0) != (i1 | 0));
 __ZNSt3__210__time_getD2Ev(i3 + 12 | 0);
 return;
}

function __ZNK13OcclusionArea16GetGlobalExtentsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, f10 = f0, f11 = f0, i12 = 0;
 __ZNK9Transform18GetWorldScaleLossyEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f10 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f10 = Math_fround(f10 * Math_fround(HEAPF32[i1 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 i6 = i1 + 4 | 0;
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i6 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 i2 = i1 + 8 | 0;
 f10 = Math_fround(f10 * Math_fround(.5));
 f7 = Math_fround(f7 * Math_fround(.5));
 f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i2 >> 2])) * Math_fround(.5));
 i12 = f10 < Math_fround(0.0);
 f11 = Math_fround(-f10);
 i9 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 HEAPF32[i1 >> 2] = i12 ? f11 : f10;
 HEAPF32[i6 >> 2] = i9 ? f8 : f7;
 HEAPF32[i2 >> 2] = i5 ? f4 : f3;
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRGHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f10 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2]);
  f9 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 + 2 >> 1] | 0) << 2) >> 2]);
  i8 = f10 < Math_fround(0.0);
  i7 = f10 > Math_fround(1.0);
  i7 = ~~Math_fround(Math_fround((i7 ? Math_fround(1.0) : f10) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i6 = f9 < Math_fround(0.0);
  i3 = f9 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  HEAP32[i4 >> 2] = (i8 ? -16776961 : i7 & 65280 | -16776961) | (i6 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6Camera20PreMultiCustomRenderER11CullResultsNS_10RenderFlagEb(i5, i6, i1, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if (!i3) {
  if ((HEAP16[gb + 1110484 + 6 >> 1] | 0) > -1) {
   HEAP32[i2 >> 2] = i5;
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110484 | 0, i1);
   i1 = gb + 1110484 | 0;
  } else i1 = 0;
  i3 = HEAP32[gb + 1110484 >> 2] | 0;
  i2 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 648 >> 2] | 0, i2 | 0, i3 | 0);
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 652 >> 2] | 0, i3 | 0);
  if (i1 | 0) __Z12profiler_endP19ProfilerInformation(i1);
 }
 __Z27InitializeRenderLoopContextP6CameraRK19SharedRendererSceneP10RenderLoop(i5, HEAP32[i6 + 1372 >> 2] | 0, HEAP32[i5 + 1124 >> 2] | 0);
 __Z12GetGfxDevicev() | 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx9NpFactory13addConstraintEPNS_12PxConstraintEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 524 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx19NpArticulationJoint20setTargetOrientationERKNS_6PxQuatE(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore20setTargetOrientationERKNS_6PxQuatE(i1, i8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 56 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 64 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[i8 + 12 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4;
 return;
}

function __ZN2UI11CanvasGroup8SetAlphaEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i1 + 36 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == f3) {
  STACKTOP = i5;
  return;
 }
 i6 = f3 < Math_fround(0.0);
 i7 = f3 > Math_fround(1.0);
 f3 = i7 ? Math_fround(1.0) : f3;
 HEAPF32[i2 >> 2] = i6 ? Math_fround(0.0) : f3;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i7, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN22BaseUnityConnectClient12StartSessionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 113 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP8[i4 >> 0] = 1;
 i1 = i2 + 4 | 0;
 L4 : do if ((HEAP32[i1 >> 2] | 0) == 3) i1 = 0; else {
  switch (HEAP32[i1 >> 2] | 0) {
  case 5:
  case 0:
   {
    i1 = 0;
    break L4;
   }
  case 1:
   {
    i3 = 7;
    break;
   }
  case 2:
   {
    if (!(HEAP8[i2 + 112 >> 0] | 0)) {
     mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
     i1 = 1;
     break L4;
    } else i3 = 8;
    break;
   }
  case 4:
   {
    if (!(HEAP8[i2 + 110 >> 0] | 0)) i3 = 7; else if (!(HEAP8[i2 + 108 >> 0] | 0)) i3 = 8; else i3 = 7;
    break;
   }
  default:
   i3 = 8;
  }
  if ((i3 | 0) == 7) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
   i1 = 1;
   break;
  } else if ((i3 | 0) == 8) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
   i1 = 1;
   break;
  }
 } while (0);
 HEAP8[i4 >> 0] = 0;
 i4 = i1;
 return i4 | 0;
}

function __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI14SafeBinaryReadEEvRS4_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 902658 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8StateKey8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, gb + 902667 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN10StateRange8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN13AnimationClip18CleanupMecanimDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 220 >> 2] = 0;
 i2 = i3 + 64 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 i1 = i3 + 224 | 0;
 i2 = i3 + 240 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 228 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 236 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 244 | 0;
 i2 = i3 + 260 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i4 = i3 + 256 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 248 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i3 + 256 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN10InputEventC2ERKS_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 12 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 HEAP16[i3 + 36 >> 1] = i2;
 HEAP16[i3 + 38 >> 1] = i2 >>> 16;
 HEAP32[i3 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP8[i3 + 48 >> 0] = HEAP8[i1 + 48 >> 0] | 0;
 i1 = i1 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 + 44 >> 2] = 0;
  return;
 } else {
  i4 = __Znaj((_strlen(i2) | 0) + 1 | 0) | 0;
  HEAP32[i3 + 44 >> 2] = i4;
  i5 = HEAP32[i1 >> 2] | 0;
  _memcpy(i4 | 0, i5 | 0, (_strlen(i5) | 0) + 1 | 0) | 0;
  return;
 }
}

function __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, i1, 16, gb + 1048932 | 0, 0, gb + 1044596 | 0, 915) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i4, i5, 0);
 __Z19pop_allocation_rootv();
 i1 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i4) | 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 if (!i4) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i1 | 0;
}

function _nexttowardf(f1, d3) {
 f1 = Math_fround(f1);
 d3 = +d3;
 var i2 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if ((i5 & 2147483647) >>> 0 > 2139095040) i6 = 3; else {
  HEAPF64[tempDoublePtr >> 3] = d3;
  i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i7 = i2 & 2147483647;
  if (i7 >>> 0 > 2146435072 | (i7 | 0) == 2146435072 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 0) i6 = 3; else {
   d4 = +f1;
   if (d4 == d3) {
    f1 = Math_fround(d3);
    break;
   }
   do if (f1 == Math_fround(0.0)) i2 = (i2 | 0) < 0 ? -2147483647 : 1; else {
    i2 = (i5 | 0) < 0;
    if (d4 < d3) if (i2) {
     i2 = i5 + -1 | 0;
     break;
    } else {
     i2 = i5 + 1 | 0;
     break;
    } else if (i2) {
     i2 = i5 + 1 | 0;
     break;
    } else {
     i2 = i5 + -1 | 0;
     break;
    }
   } while (0);
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
 } while (0);
 if ((i6 | 0) == 3) f1 = Math_fround(+f1 + d3);
 return Math_fround(f1);
}

function __ZNK12NavMeshAgent7RaycastERK8Vector3fP10NavMeshHit(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i1 + 68 | 0;
 if ((HEAP32[i5 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844863 | 0, 0, gb + 841797 | 0, 653, 1, 0, 0, 0);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i1 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
  i5 = __ZNK7dtCrowd14getAgentFilterEi(i1, HEAP32[i5 >> 2] | 0) | 0;
  i5 = __ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i3, i4, i2, i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZN5physx3Cct26CharacterControllerManager7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0) do __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE(i2, mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 0) | 0); while ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0) != 0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0)) {
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = i1 + 76 | 0;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(i1 | 0, i2 | 0);
  __ZN5physx6shdfnd10Foundation11decRefCountEv();
  return;
 }
 i1 = i2 + 116 | 0;
 do {
  i3 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 } while ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) != 0);
 i3 = HEAP32[i2 >> 2] | 0;
 i3 = i3 + 76 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(i3 | 0, i2 | 0);
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 return;
}

function __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_(i7, i9, i3, i4, f6, i8) {
 i7 = i7 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10;
 i1 = i10 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 < 5) if (f6 <= Math_fround(0.0) & (29 >>> (i2 & 31) & 1) != 0) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = i4;
 i4 = HEAP32[(HEAP32[i7 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = 11;
 i1 = mftCall_iiiiiii(i4 | 0, i7 | 0, i3 | 0, i5 | 0, 1, 1, i1 | 0) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i8 | 0);
 i9 = __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf(i7, i9, i1, f6) | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 STACKTOP = i10;
 return i9 | 0;
}

function __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (!(HEAP32[i4 + 8 >> 2] & 4096)) {
  i1 = HEAP32[i4 + 80 >> 2] | 0;
  i4 = HEAP32[i4 + 92 >> 2] | 0;
  i2 = i1 + (i4 << 2) | 0;
  if (!i4) {
   STACKTOP = i6;
   return;
  }
  do {
   __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE(HEAP32[i1 >> 2] | 0, i5);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  STACKTOP = i6;
  return;
 }
 HEAP32[i1 >> 2] = i4;
 i2 = i5 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i5 + 8 >> 2] | 0)) __ZNSt3__26vectorIP9Transform13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i5, i1); else {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
 }
 STACKTOP = i6;
 return;
}

function __Z28SetupPixelCorrectCoordinatesv() {
 var i1 = 0, i2 = 0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 i6 = i1;
 i2 = __Z12GetGfxDevicev() | 0;
 i7 = __Z16GetScreenManagerv() | 0;
 f5 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0) | 0);
 f4 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i7 | 0) | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = ~~Math_fround(f5 + Math_fround(.5)) >>> 0;
 HEAP32[i6 + 12 >> 2] = ~~Math_fround(f4 + Math_fround(.5)) >>> 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, i6 | 0);
 __ZN10Matrix4x4f8SetOrthoEffffff(i3, Math_fround(0.0), f5, Math_fround(0.0), f4, Math_fround(-1.0), Math_fround(100.0)) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, gb + 1162292 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK17ArchiveFileSystem4SizeERK13FileEntryData(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i1 = i6;
 if ((HEAP16[gb + 1178932 + 6 >> 1] | 0) > -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178932 | 0, i2);
  i5 = gb + 1178932 | 0;
 } else i5 = 0;
 i1 = HEAP32[i4 + 1052 >> 2] | 0;
 if (!i1) {
  __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i2, i3, i4);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 0;
  } else {
   i2 = i1 + 8 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
 } else {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  i2 = getTempRet0() | 0;
 }
 if (!i5) {
  setTempRet0(i2 | 0);
  STACKTOP = i6;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i5);
 setTempRet0(i2 | 0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxQuatE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 28 | 0;
 i4 = i5;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 52 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 228 >> 2] | 0, i6 | 0, i4 | 0) | 0)) {
  i7 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 84 >> 2] | 0, i3 | 0, i7 | 0);
  i7 = HEAP32[i3 + 20 >> 2] | 0;
  i6 = HEAP32[i3 + 24 >> 2] | 0;
  HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = i7;
  HEAP32[i4 + 24 >> 2] = i6;
 }
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i7 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 224 >> 2] | 0, i7 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sn5ConvX11getTypeNameEPKci(i5, i7, i6) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 i1 = HEAP32[i5 + 296 >> 2] | 0;
 L1 : do if (i1 | 0) {
  i4 = HEAP32[i5 + 292 >> 2] | 0;
  i2 = 0;
  while (1) {
   if (!(_strcmp(HEAP32[i4 + (i2 << 4) >> 2] | 0, i7) | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i1 >>> 0) break L1;
  }
  i3 = HEAP32[i4 + (i2 << 4) + 8 >> 2] | 0;
  if (i3 | 0) {
   i2 = HEAP32[i4 + (i2 << 4) + 4 >> 2] | 0;
   i1 = 0;
   while (1) {
    if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i6 | 0)) break;
    i1 = i1 + 1 | 0;
    if (i1 >>> 0 >= i3 >>> 0) break L1;
   }
   i8 = HEAP32[i2 + (i1 << 3) >> 2] | 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 } while (0);
 HEAP32[i8 >> 2] = i7;
 HEAP32[i8 + 4 >> 2] = i6;
 __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz(i5, 32, gb + 669413 | 0, i8);
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Umbra9BitVector6resizeEjbb(i3, i1, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = (i1 + 31 | 0) >>> 5;
 i8 = i3 + 8 | 0;
 if (i7 >>> 0 <= (HEAP32[i8 >> 2] | 0) >>> 0) {
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i6 = i3 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i7 << 2) + 16 | 0, 0) | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = i7;
  i1 = i1 + 16 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 _memcpy(i1 | 0, i2 | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
 if (i2 | 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 + -16 | 0);
 }
 if (!i4) {
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i3 = i5 << 31 >> 31;
 i1 = HEAP32[i8 >> 2] | 0;
 if (i1 >>> 0 >= i7 >>> 0) {
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 do {
  HEAP32[i2 + (i1 << 2) >> 2] = i3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 HEAP32[i8 >> 2] = i7;
 return;
}

function __Z23DrawSplashAndWatermarksv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = __ZN10systeminfo18GetRuntimePlatformEv() | 0;
 i3 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 111 >> 0] | 0) == 0;
 i4 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 113 >> 0] | 0) == 0;
 i2 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 112 >> 0] | 0) == 0;
 i5 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 115 >> 0] | 0) == 0;
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0)) {
  i1 = __ZN10systeminfo19IsPlatformWebPlayerE15RuntimePlatform(i1) | 0;
  __Z16GetBuildSettingsv() | 0;
  if (i1) __Z13DrawWaterMarkb(0);
 } else __Z16GetBuildSettingsv() | 0;
 i1 = (__ZL19DrawSimpleWatermark13WatermarkEnumff(3, Math_fround(3.0)) | 0) + 6 | 0;
 if (!i3) return;
 if (!i4) {
  __ZL19DrawSimpleWatermark13WatermarkEnumff(1, Math_fround(i1 | 0)) | 0;
  return;
 }
 if (!i2) {
  __ZL19DrawSimpleWatermark13WatermarkEnumff(2, Math_fround(i1 | 0)) | 0;
  return;
 }
 if (!i5) return;
 __ZL19DrawSimpleWatermark13WatermarkEnumff(0, Math_fround(i1 | 0)) | 0;
 return;
}

function _UNITY_png_colorspace_sync(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 if (!i6) return;
 i1 = i6 + 40 | 0;
 i2 = i5 + 680 | 0;
 i3 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = HEAP16[i6 + 114 >> 1] | 0;
 i1 = i3 & 65535;
 if (i1 & 32768 | 0) {
  i1 = i6 + 8 | 0;
  i2 = HEAP32[i1 >> 2] & -6150;
  HEAP32[i1 >> 2] = i2;
  i3 = i6 + 220 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 & 16 | 0) {
   i7 = i6 + 116 | 0;
   _UNITY_png_free(i5, HEAP32[i7 >> 2] | 0);
   i6 = i6 + 120 | 0;
   _UNITY_png_free(i5, HEAP32[i6 >> 2] | 0);
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
   HEAP32[i1 >> 2] = i2;
  }
  HEAP32[i3 >> 2] = i4 & -17;
  return;
 }
 i2 = i6 + 8 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = (i1 & 128 | 0) == 0 ? i7 & -2049 : i7 | 2048;
 i1 = (i3 & 2) == 0 ? i1 & -5 : i1 | 4;
 HEAP32[i2 >> 2] = i1;
 if (!(i3 & 1)) {
  HEAP32[i2 >> 2] = i1 & -2;
  return;
 } else {
  HEAP32[i2 >> 2] = i1 | 1;
  return;
 }
}

function __ZN5Umbra13MatrixFactory7frustumEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var f6 = f0, i7 = 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i1 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 f6 = Math_fround(Math_fround(1.0) / Math_fround(f5 - f4));
 f2 = Math_fround(Math_fround(1.0) / Math_fround(+Math_tan(+Math_fround(Math_fround(f2 * Math_fround(3.14159274)) / Math_fround(360.0)))));
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 20 >> 2] = Math_fround(f2 / f3);
 HEAPF32[i1 + 40 >> 2] = Math_fround(-Math_fround(Math_fround(f4 + f5) * f6));
 HEAPF32[i1 + 44 >> 2] = Math_fround(Math_fround(Math_fround(f4 * f5) * Math_fround(-2.0)) * f6);
 HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13AudioListenerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 171280 + 8;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 68 | 0) | 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN13AnimationClip7SetNameEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i4, _strlen(i4) | 0);
 __ZN11NamedObject7SetNameEPKc(i1, i2);
 i4 = _strlen(i2) | 0;
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 if ((i4 | 0) == ((i6 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i3, 0, -1, i2, i4) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return;
 }
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105816 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN13AnimationClip15ThreadedCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 + 216 >> 2] = 0;
 HEAP32[i3 + 220 >> 2] = 0;
 i2 = i3 + 64 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 HEAP32[i3 + 72 >> 2] = 0;
 i1 = i3 + 224 | 0;
 i2 = i3 + 240 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 228 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 236 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 244 | 0;
 i2 = i3 + 260 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i4 = i3 + 256 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 248 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i3 + 256 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(i4, i5, i8, i9, i10, i1, i11, i12, i13) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i14 = 0;
 i14 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i14 + 4 | 0;
 i3 = i14;
 i6 = HEAP32[i9 + 100 >> 2] | 0;
 i7 = __ZN8Material9GetShaderEv(i9) | 0;
 if (!(i1 & 2)) {
  HEAP32[i3 >> 2] = HEAP32[gb + 1110892 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i3 = __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i9, i2) | 0;
  i1 = i3 ? i1 | 2 : i1;
 }
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_(i4, i5, i8, i6, mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 36 >> 2] | 0, i9 | 0) | 0, i7, i10, i1, i11, i12, i13);
 STACKTOP = i14;
 return;
}

function __Z29StdTemplateConversionFunctionIsjEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 << 16 >> 16;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 << 16 >> 16;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIsiEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 << 16 >> 16;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 << 16 >> 16;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 i12 = i1 + 8 | 0;
 i12 = mftCall_ii(HEAP32[(HEAP32[i12 >> 2] | 0) + 20 >> 2] | 0, i12 | 0) | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP8[i12 + 11 >> 0] | 0;
 i13 = i3 << 24 >> 24 < 0;
 i2 = i13 ? HEAP32[i12 >> 2] | 0 : i12;
 i3 = i2 + (i13 ? HEAP32[i12 + 4 >> 2] | 0 : i3 & 255) | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i9, i8, i4, i5, i6, i2, i3) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN8LODGroup18GetWorldSpaceScaleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 8 | 0;
 i5 = i2 + 4 | 0;
 i7 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i1 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i1 ? f4 : f3;
 HEAPF32[i5 >> 2] = f3;
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i1 = f4 < Math_fround(0.0);
 f8 = Math_fround(-f4);
 f4 = i1 ? f8 : f4;
 HEAPF32[i7 >> 2] = f4;
 i1 = HEAP32[(f3 < f4 ? i7 : i5) >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i6 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 f4 = i6 ? f3 : f4;
 i1 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2])) < f4;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 STACKTOP = i2;
 return Math_fround(i1 ? f4 : f3);
}

function __ZN5physx9NpFactory17addParticleSystemEPNS_16PxParticleSystemEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 564 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx9NpFactory12addAggregateEPNS_11PxAggregateEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 444 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc5Scene20clearSleepWakeBodiesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = i5 + 1128 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = i5 + 1124 | 0;
  i2 = 0;
  do {
   i3 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0) + 144 | 0;
   HEAP16[i3 >> 1] = (HEAPU16[i3 >> 1] | 0) & 65423;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i5 + 1140 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i4 = i5 + 1148 | 0;
  HEAP8[i4 >> 0] = 1;
  i5 = i5 + 1149 | 0;
  HEAP8[i5 >> 0] = 1;
  return;
 }
 i2 = i5 + 1136 | 0;
 i3 = 0;
 do {
  i6 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0) + 144 | 0;
  HEAP16[i6 >> 1] = (HEAPU16[i6 >> 1] | 0) & 65359;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i6 = i5 + 1148 | 0;
 HEAP8[i6 >> 0] = 1;
 i6 = i5 + 1149 | 0;
 HEAP8[i6 >> 0] = 1;
 return;
}

function __ZN5Umbra6RandomC2Ev(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 HEAP32[i6 + 8 >> 2] = 253983;
 HEAP32[i6 + 12 >> 2] = -66585089;
 HEAP32[i6 + 16 >> 2] = 1958451267;
 HEAP32[i6 + 20 >> 2] = -238253862;
 HEAP32[i6 + 24 >> 2] = 2049502865;
 HEAP32[i6 + 28 >> 2] = -1733996308;
 HEAP32[i6 + 32 >> 2] = 1705115568;
 HEAP32[i6 + 36 >> 2] = 279806459;
 HEAP32[i6 + 40 >> 2] = -1295742990;
 HEAP32[i6 + 44 >> 2] = 1700793103;
 HEAP32[i6 + 48 >> 2] = -465897233;
 HEAP32[i6 >> 2] = 0;
 i7 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = 7;
 i1 = 0;
 i4 = 0;
 i3 = 253983;
 i2 = 279806459;
 while (1) {
  i2 = i3 + i2 | 0;
  HEAP32[i6 + 8 + (i4 << 2) >> 2] = i2 << 13 | i2 >>> 19;
  i2 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  i2 = (i2 >> 31 & 11) + i2 | 0;
  HEAP32[i6 >> 2] = i2;
  i5 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
  i5 = (i5 >> 31 & 11) + i5 | 0;
  HEAP32[i7 >> 2] = i5;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 9) break;
  i4 = i2;
  i3 = HEAP32[i6 + 8 + (i2 << 2) >> 2] | 0;
  i2 = HEAP32[i6 + 8 + (i5 << 2) >> 2] | 0;
 }
 return;
}

function __ZN15SerializeTraitsI23ManagedObjectTransfererE8TransferI30ReportScriptingObjectsTransferEEvRS0_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i1 + 4 | 0;
 mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i5 | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 + 20 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = i3;
 i5 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i3 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i7;
  return;
 }
 i3 = i3 + 12 | 0;
 do {
  i8 = i1 + 64 | 0;
  HEAP32[i5 >> 2] = i8;
  HEAP32[i3 >> 2] = i2 - i8 >> 6;
  mftCall_vii(HEAP32[i1 >> 2] | 0, i1 + 4 | 0, i6 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i7;
 return;
}

function __ZN13ScreenManager26ReapplyRequestedResolutionEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i2 | 0) == -1) i2 = mftCall_ii(HEAP32[i1 + 80 >> 2] | 0, i5 | 0) | 0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i5 | 0) | 0;
 i3 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i3 | 0) == -1) i4 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i5 | 0) | 0; else i4 = (i3 | 0) == 1;
 i3 = HEAP32[i5 + 16 >> 2] | 0;
 if ((i3 | 0) != -1) {
  i6 = i3;
  mftCall_viiiii(i7 | 0, i5 | 0, i2 | 0, i1 | 0, i4 | 0, i6 | 0);
  STACKTOP = i8;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i5 | 0);
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 mftCall_viiiii(i7 | 0, i5 | 0, i2 | 0, i1 | 0, i4 | 0, i6 | 0);
 STACKTOP = i8;
 return;
}

function __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i2 = (HEAP32[i6 + 4 >> 2] | 0) - (HEAP32[i6 >> 2] | 0) | 0;
 i8 = (i2 | 0) / 296 | 0;
 i3 = i7 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i8 | 0)) {
  HEAP32[i7 >> 2] = __Z19scripting_array_newP11Il2CppClassjj(i1, __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) | 0, i8) | 0;
  HEAP32[i3 >> 2] = i8;
 }
 if (!i2) return;
 i4 = i6 + 16 | 0;
 i3 = 0;
 do {
  i2 = __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(HEAP32[i7 >> 2] | 0, i3) | 0;
  i5 = (HEAP32[i6 >> 2] | 0) + (i3 * 296 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = _il2cpp_object_new(HEAP32[i4 >> 2] | 0) | 0;
   __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1);
   HEAP32[i2 >> 2] = i1;
  }
  __ZN8GUIStyleaSERKS_(HEAP32[i1 + 8 >> 2] | 0, i5) | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i8 | 0));
 return;
}

function __Z21GetLayerAndStateIndexPKN7mecanim9animation18ControllerConstantEjPiS4_(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) <= 0) {
  i12 = 0;
  return i12 | 0;
 }
 i8 = i4 + 4 | 0;
 i9 = i8;
 i10 = i4 + 12 | 0;
 i11 = i10;
 i3 = 0;
 while (1) {
  i2 = (HEAP32[i8 >> 2] | 0) + i9 + (i3 << 2) | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
  if (!(HEAP32[i2 + 4 >> 2] | 0)) {
   i2 = (HEAP32[i10 >> 2] | 0) + i11 + (HEAP32[i2 >> 2] << 2) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i1 = __ZN7mecanim12statemachine13GetStateIndexEPKNS0_20StateMachineConstantEj((i1 | 0) == 0 ? 0 : i2 + i1 | 0, i5) | 0;
   if ((i1 | 0) != -1) break;
   i2 = HEAP32[i4 >> 2] | 0;
  } else i2 = i1;
  i1 = i3 + 1 | 0;
  if ((i1 | 0) < (i2 | 0)) {
   i3 = i1;
   i1 = i2;
  } else {
   i1 = 0;
   i12 = 8;
   break;
  }
 }
 if ((i12 | 0) == 8) return i1 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = i3;
 i12 = 1;
 return i12 | 0;
}

function _UNITY_png_colorspace_set_gamma(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, d4 = 0.0;
 if ((i6 + -16 | 0) >>> 0 > 624999984) {
  i1 = i5 + 74 | 0;
  i3 = gb + 350957 | 0;
  i2 = i1;
  i1 = HEAP16[i1 >> 1] | 0;
 } else {
  i2 = i5 + 74 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if ((i1 & 8) == 0 ? 1 : (HEAP32[i7 + 204 >> 2] & 32768 | 0) == 0) {
   if (i1 << 16 >> 16 < 0) return;
   do if (i1 & 1) {
    i3 = HEAP32[i5 >> 2] | 0;
    if (!((i6 | 0) == 0 | (i3 | 0) == 0)) {
     d4 = +Math_floor(+(+(i3 | 0) * 1.0e5 / +(i6 | 0) + .5));
     if (d4 <= 2147483647.0 & d4 >= -2147483648.0) if ((~~d4 + -95e3 | 0) >>> 0 <= 1e4) break;
    }
    if (!(i1 & 32)) {
     _UNITY_png_chunk_report(i7, gb + 350882 | 0, 0);
     break;
    }
    _UNITY_png_chunk_report(i7, gb + 350925 | 0, 2);
    return;
   } while (0);
   HEAP32[i5 >> 2] = i6;
   HEAP16[i2 >> 1] = i1 & 65535 | 9;
   return;
  } else i3 = gb + 352436 | 0;
 }
 HEAP16[i2 >> 1] = i1 & 65535 | 32768;
 _UNITY_png_chunk_report(i7, i3, 1);
 return;
}

function __ZN9UdpSocketC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 16384;
 HEAP32[i1 >> 2] = gb + 65580 + 8;
 i4 = i1 + 17 | 0;
 HEAP8[i4 >> 0] = (i2 | 0) != -1 & 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i5 >> 2] = 2048;
 if ((_fcntl(i2, 4, i5) | 0) != -1) {
  STACKTOP = i6;
  return;
 }
 __Z6FormatPKcz(i5, gb + 458740 | 0, i6 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 458557 | 0, 390, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 if (HEAP8[i4 >> 0] | 0) {
  _close(HEAP32[i3 >> 2] | 0) | 0;
  HEAP8[i4 >> 0] = 0;
 }
 _printf_console(gb + 458768 | 0, i6 + 24 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx35solveConcludeContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, 0);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i7 = HEAP16[i1 + 2 >> 1] | 0;
 i8 = i1 + (i7 & 65535) | 0;
 if (!(i7 << 16 >> 16)) return;
 do {
  i3 = i1 + 48 | 0;
  i2 = HEAP8[i1 + 1 >> 0] | 0;
  i7 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) i1 = i3; else {
   i6 = i2 & 255;
   i5 = 0;
   while (1) {
    i2 = i3 + 32 | 0;
    f4 = Math_fround(HEAPF32[i2 >> 2]);
    i9 = f4 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i1 = i1 + ((Math_imul(i7, i6) | 0) + 48) | 0;
  }
 } while (i1 >>> 0 < i8 >>> 0);
 return;
}

function __ZN5physx2Sc20ArticulationJointSimC2ERNS0_21ArticulationJointCoreERNS0_8ActorSimES5_(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i4, i3, i1, 5, 0);
 HEAP16[i4 + 28 >> 1] = -1;
 HEAP16[i4 + 30 >> 1] = 0;
 HEAP32[i4 >> 2] = gb + 90892 + 8;
 HEAP32[i4 + 24 >> 2] = gb + 90892 + 44;
 HEAP32[i4 + 32 >> 2] = -1;
 i5 = i4 + 36 | 0;
 HEAP32[i5 >> 2] = i2;
 i6 = __ZN5physx2Sc20ArticulationJointSim10onActivateEj(i4, 0) | 0;
 i2 = i4 + 4 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i4, i6);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i2 >> 2] | 0, i4);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i4 + 8 >> 2] | 0, i4);
 __ZN5physx2Sc15ArticulationSim7addBodyERNS0_7BodySimEPS2_PNS0_20ArticulationJointSimE(HEAP32[i3 + 152 >> 2] | 0, i1, i3, i4);
 HEAP32[HEAP32[i5 >> 2] >> 2] = i4;
 return;
}

function __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIbEEclERS1_17TransferMetaFlagsR9BlobWrite(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = i3 + 4 | 0;
 if (!(HEAP32[HEAP32[i2 >> 2] >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN9BlobWrite4PushEjPKvj(i4, HEAP32[HEAP32[i2 >> 2] >> 2] | 0, (HEAP32[i1 >> 2] | 0) + i1 | 0, 1);
 i1 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i3 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 i2 = i1 + i3 | 0;
 if (i3 | 0) do {
  __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1041891 | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 48 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 + -1;
 i1 = i4 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 - (HEAP32[i4 + 32 >> 2] | 0) | 0;
 if ((1 - i5 - (HEAP32[i4 + 44 >> 2] | 0) + ((i3 | 0) == 0 ? 0 : (i3 << 6) + -1 | 0) | 0) >>> 0 <= 511) return;
 __ZdlPv(HEAP32[i2 + -4 >> 2] | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -4;
 return;
}

function __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 i6 = i1 + 8 | 0;
 i5 = i1 + 24 | 0;
 i4 = i1 + 40 | 0;
 i7 = i3 + 1664 | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 i6 = i3 + 1648 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 i3 = i3 + 1680 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 i3 = HEAP32[gb + 1159952 >> 2] | 0;
 HEAP8[i1 + 56 >> 0] = (1 << (i3 & 31) & HEAP32[i2 + (i3 >>> 5 << 2) >> 2] | 0) != 0 & 1;
 HEAP8[i1 + 57 >> 0] = 0;
 return;
}

function __Z46ParticleSystem_EmissionModule_CUSTOM_GetBurstsP12Il2CppObjectP11Il2CppArray(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = i2 + 264 | 0;
 i4 = i2 + 8 | 0;
 i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 8) | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 i3 = HEAP32[i2 + 584 >> 2] | 0;
 i1 = (i3 | 0) < (i1 | 0) ? i3 : i1;
 if ((i1 | 0) > 0) i2 = 0; else {
  i5 = i1;
  return i5 | 0;
 }
 do {
  HEAP32[i5 + (i2 << 3) >> 2] = HEAP32[i4 + 528 + (i2 << 2) >> 2];
  HEAP16[i5 + (i2 << 3) + 4 >> 1] = HEAP32[i4 + 544 + (i2 << 2) >> 2];
  HEAP16[i5 + (i2 << 3) + 6 >> 1] = HEAP32[i4 + 560 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i1 | 0));
 return i1 | 0;
}

function __Z37Cubemap_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiiRK10ColorRGBAf(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP8[i1 + 111 >> 0] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (!(i1 << 24 >> 24)) {
  HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i8);
 } else {
  __ZN9Texture2D8SetPixelEiiiRK10ColorRGBAf(i2, i4, i5, i6, i7);
  STACKTOP = i9;
  return;
 }
}

function __ZNKSt3__211__libcpp_db8__find_cEPv(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = i4;
 i8 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i6 + 16 | 0, i8, 4) | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i7 + (((i8 >>> 0) % ((HEAP32[i2 + 4 >> 2] | 0) - i7 >> 2 >>> 0) | 0) << 2) >> 2] | 0;
 if (!i2) {
  i8 = HEAP32[gb + 191628 >> 2] | 0;
  HEAP32[i3 >> 2] = gb + 1076524;
  _fprintf(i8, gb + 1076431 | 0, i3) | 0;
  _abort();
 } else i1 = i2;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) {
   i2 = 6;
   break;
  }
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) {
  i8 = HEAP32[gb + 191628 >> 2] | 0;
  HEAP32[i5 >> 2] = gb + 1076567;
  _fprintf(i8, gb + 1076431 | 0, i5) | 0;
  _abort();
 } else if ((i2 | 0) == 6) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN7mecanim12statemachine27CreateSelectorStateConstantEPPNS0_26SelectorTransitionConstantEjjbRNS_6memory9AllocatorE(i7, i8, i3, i4, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 16, 4) | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 + 8 >> 2] = 0;
 HEAP8[i9 + 12 >> 0] = 0;
 i5 = i9 + 4 | 0;
 i6 = (i8 | 0) == 0;
 if (i6) i1 = 0; else {
  i2 = i8 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i8 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i2 = i5;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP8[i9 + 12 >> 0] = i4 & 1;
 if (i6) return i9 | 0;
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  i6 = i2 + (i1 << 2) | 0;
  i5 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  HEAP32[i6 >> 2] = i5 | 0 ? i5 - i6 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return i9 | 0;
}

function __ZN7ApiGLES18CreateRenderbufferEiN2gl9TexFormatEii(i3, i4, i1, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[i3 + 860 >> 2] | 0, i1) | 0;
 HEAP32[i7 >> 2] = 0;
 mftCall_vii(HEAP32[i3 + 616 >> 2] | 0, 1, i7 | 0);
 i1 = i3 + 624 | 0;
 mftCall_vii(HEAP32[i1 >> 2] | 0, 36161, HEAP32[i7 >> 2] | 0);
 if ((i4 | 0) > 1) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0) {
  mftCall_viiiii(HEAP32[i3 + 632 >> 2] | 0, 36161, i4 | 0, HEAP32[i2 >> 2] | 0, i5 | 0, i6 | 0);
  i6 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(i6 | 0, 36161, 0);
  i7 = HEAP32[i7 >> 2] | 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 mftCall_viiii(HEAP32[i3 + 628 >> 2] | 0, 36161, HEAP32[i2 >> 2] | 0, i5 | 0, i6 | 0);
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(i6 | 0, 36161, 0);
 i7 = HEAP32[i7 >> 2] | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx9NpFactory16addParticleFluidEPNS_15PxParticleFluidEb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 564 | 0;
 HEAP32[i4 >> 2] = i1;
 i6 = i1;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (i2) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5IMGUI18BringWindowToFrontER8GUIStatei(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i10) return;
 i4 = HEAP32[i10 + 24 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (!i5) if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) return;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = (i1 | 0) == (i9 | 0);
 L8 : do if (i7) i8 = 7; else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) break;
   if ((i2 | 0) == (i9 | 0)) {
    i8 = 7;
    break L8;
   }
  }
  if (!i3) return;
 } while (0);
 if ((i8 | 0) == 7) {
  if (i5) return;
  if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) i3 = i4; else return;
 }
 if (i7) i1 = -1; else {
  i2 = 0;
  do {
   i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0;
   i2 = (i8 | 0) < (i2 | 0) ? i8 : i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i9 | 0));
  i1 = i2 + -1 | 0;
 }
 HEAP32[i3 + 68 >> 2] = i1;
 HEAP8[i10 + 16 >> 0] = 1;
 return;
}

function __ZN24UserAuthorizationManager24RequestUserAuthorizationEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  if ((HEAP32[i1 >> 2] & i2 | 0) != (i2 | 0)) {
   HEAP32[i1 + 4 >> 2] = i2;
   i2 = __Znwj(24) | 0;
   i1 = i2 + 4 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   HEAP32[i1 + 12 >> 2] = 0;
   i1 = i2 + 4 | 0;
   HEAP32[i1 >> 2] = 1;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   HEAP32[i2 >> 2] = gb + 70328 + 8;
   HEAP32[i3 >> 2] = i2;
   HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
   i3 = i2;
   return i3 | 0;
  }
 } else __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 489172 | 0, 0, gb + 489219 | 0, 46, 1, 0, 0, 0);
 i3 = __Znwj(24) | 0;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 70372 + 8;
 return i3 | 0;
}

function __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 28204 + 8;
 i2 = i6 + 8 | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = i3 & 2047 | -2097152;
 i3 = __Z16GetMemoryManagerv() | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = i7 & 2047;
 if (!(i7 & 2048)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = i6;
 } else {
  __Z14CreateMemLabel18MemLabelIdentifierPv(i4, i1, i6);
  i1 = i6;
 }
 i7 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i3, i4) | 0;
 i7 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i1 | 0) | 0) != 0 & 1;
 HEAP32[i2 >> 2] = i7 << 11 | HEAP32[i2 >> 2] & -2049;
 HEAP32[i6 + 24 >> 2] = -1;
 HEAP32[i6 >> 2] = gb + 28648 + 8;
 STACKTOP = i5;
 return;
}

function __ZN17AnimationPlayable16DestroyRecursiveERN7mecanim6memory16MecanimAllocatorE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  i8 = HEAP32[i5 >> 2] | 0;
  i8 = i8 + 132 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vii(i8 | 0, i5 | 0, i6 | 0);
  return;
 }
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i8 = 8;
    break;
   } else i3 = 0;
  }
  if ((i8 | 0) == 8) {
   i8 = 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i6 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i1 + 28 >> 2] | 0) >>> 0);
 i8 = HEAP32[i5 >> 2] | 0;
 i8 = i8 + 132 | 0;
 i8 = HEAP32[i8 >> 2] | 0;
 mftCall_vii(i8 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZN13ComputeShader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
 i8 = i1 + 32 | 0;
 i9 = i1 + 36 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = (i2 - i1 | 0) / 36 | 0;
 HEAP32[i7 >> 2] = i5;
 i6 = i10 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN20ComputeShaderVariant8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 36 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer13drawTrianglesEPKN5physx8debugger8renderer11PvdTriangleEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i3 + (i1 * 48 | 0);
 i8 = i2 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 150564 + 8;
 HEAP32[i6 + 4 >> 2] = i8;
 i1 = i2 + 24 | 0;
 i3 = i2 + 20 | 0;
 i7 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i8, i7 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i3 >> 2] | 0) + i7 >> 0] = 4;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 32 >> 2] | 0, i6 | 0, i5 | 0);
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0) >>> 0 < (HEAP32[i2 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE6SetUrlERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 4 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 12 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 8 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 8 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function _wcstox_528(i8, i9, i5, i6, i7) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 i11 = i10 + 8 | 0;
 i12 = i10 + 4 | 0;
 i2 = i13 + 112 + 4 | 0;
 i1 = i10 + 44 | 0;
 i3 = i10;
 i4 = i3 + 112 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = i2;
 HEAP32[i10 + 48 >> 2] = 60;
 HEAP32[i10 + 76 >> 2] = -1;
 HEAP32[i10 + 32 >> 2] = fb + 500;
 i3 = i8;
 while (1) if (!(_iswspace(HEAP32[i3 >> 2] | 0) | 0)) break; else i3 = i3 + 4 | 0;
 HEAP32[i10 + 84 >> 2] = i3;
 ___shlim(i10, 0);
 i1 = ___intscan(i10, i5, 1, i6, i7) | 0;
 i2 = getTempRet0() | 0;
 if (i9 | 0) {
  i12 = (HEAP32[i12 >> 2] | 0) - (HEAP32[i11 >> 2] | 0) + (HEAP32[i10 + 108 >> 2] | 0) | 0;
  HEAP32[i9 >> 2] = (i12 | 0) == 0 ? i8 : i3 + (i12 << 2) | 0;
 }
 setTempRet0(i2 | 0);
 STACKTOP = i13;
 return i1 | 0;
}

function __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i1 + 32 >> 2] | 0;
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, i10);
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i8 = i10 + 16 | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i6 = HEAP32[i10 + 28 >> 2] | 0;
 if (!i9) return;
 i7 = i10 + 68 | 0;
 i2 = 0;
 do {
  i3 = HEAP8[i6 + i1 >> 0] | 0;
  if (!(i3 << 24 >> 24)) {
   i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i2 = i2 + 1 | 0;
  } else {
   __ZL24SendTransformChangedMaskRK18TransformHierarchyii(i10, i1, i3 & 255);
   i5 = HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i5) {
    i4 = HEAP32[i7 >> 2] | 0;
    i3 = 0;
    do {
     i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
     i3 = i3 + 1 | 0;
    } while ((i3 | 0) != (i5 | 0));
   }
   i2 = i5 + i2 | 0;
  }
 } while ((i2 | 0) != (i9 | 0));
 return;
}

function __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 76 >> 2] = 1;
 i2 = __Z25GetUncheckedRealGfxDevicev() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 420 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN19MemoryProfilerStatsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 120 | 0;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 28204 + 8;
 i2 = i6 + 8 | 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = i3 & 2047 | -2097152;
 i3 = __Z16GetMemoryManagerv() | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = i7 & 2047;
 if (!(i7 & 2048)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = 0;
  i1 = i6;
 } else {
  __Z14CreateMemLabel18MemLabelIdentifierPv(i4, i1, i6);
  i1 = i6;
 }
 i7 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i3, i4) | 0;
 i7 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i1 | 0) | 0) != 0 & 1;
 HEAP32[i2 >> 2] = i7 << 11 | HEAP32[i2 >> 2] & -2049;
 HEAP32[i6 + 24 >> 2] = -1;
 HEAP32[i6 >> 2] = gb + 28344 + 8;
 STACKTOP = i5;
 return;
}

function __ZN15ParticleEmitter18InitParticleEnergyER4RandR8Particlef(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0;
 f7 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 i8 = HEAP32[i2 >> 2] | 0;
 i8 = i8 << 11 ^ i8;
 i1 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i9 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 i1 = i2 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = i2;
 i2 = i8 >>> 8 ^ i8 ^ i2 ^ i2 >>> 19;
 HEAP32[i1 >> 2] = i2;
 f5 = Math_fround(Math_fround((i2 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 f5 = Math_fround(Math_fround(f7 * f5) + Math_fround(f6 * Math_fround(Math_fround(1.0) - f5)));
 i2 = f5 < Math_fround(0.0);
 i1 = f5 > Math_fround(100000001999999991808.0);
 f5 = i1 ? Math_fround(100000001999999991808.0) : f5;
 f5 = i2 ? Math_fround(0.0) : f5;
 HEAPF32[i3 + 40 >> 2] = f5;
 HEAPF32[i3 + 36 >> 2] = Math_fround(Math_fround(f5 + f4) + Math_fround(.00100000005));
 return;
}

function __Z22PointDistanceToFrustumRK8Vector4fPK5Planei(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var f1 = f0, i4 = 0, f5 = f0, f7 = f0, f8 = f0, f9 = f0;
 if ((i6 | 0) <= 0) {
  f8 = Math_fround(-inf);
  i6 = f8 != Math_fround(-inf);
  f8 = Math_fround(-f8);
  f8 = i6 ? f8 : Math_fround(0.0);
  return Math_fround(f8);
 }
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i4 = 0;
 f1 = Math_fround(-inf);
 i2 = i3;
 while (1) {
  f9 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f7);
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * f8));
  f9 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * f5));
  f9 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f9);
  i3 = f9 < Math_fround(0.0) & f9 > f1;
  f1 = i3 ? f9 : f1;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) == (i6 | 0)) break; else i2 = i2 + 16 | 0;
 }
 i6 = f1 != Math_fround(-inf);
 f9 = Math_fround(-f1);
 f9 = i6 ? f9 : Math_fround(0.0);
 return Math_fround(f9);
}

function __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!i4) return;
 i5 = i4 + 72 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i3 = i4 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i1 = i4 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, i4 | 0);
 return;
}

function __Z12SetupLODFadeR9GfxDeviceR17ShaderPassContextf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, i6 = 0, f7 = f0;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 f5 = Math_fround(Math_abs(Math_fround(f3)));
 f7 = Math_fround(f5 * Math_fround(16.0));
 i6 = f7 >= Math_fround(0.0);
 f3 = Math_fround(f7 + Math_fround(-.99999994));
 i6 = ~~(i6 ? f7 : f3);
 f3 = Math_fround(Math_fround(((i6 | 0) > 15 ? 15 : i6) | 0) * Math_fround(.0625));
 HEAPF32[i1 + 964 >> 2] = f5;
 HEAPF32[i1 + 968 >> 2] = f3;
 HEAPF32[i1 + 972 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 976 >> 2] = Math_fround(0.0);
 switch (((i4 & 2147483647 | 0) == 0 ? 0 : i4 >> 31 | 1) | 0) {
 case 1:
  {
   i6 = i2 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -12582913 | 8388608;
   return;
  }
 case -1:
  {
   i6 = i2 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -12582913 | 4194304;
   return;
  }
 default:
  {
   i6 = i2 + 4 | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -12582913;
   return;
  }
 }
}

function _PxCreateCooking(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 __ZN5physx6shdfnd10Foundation11incRefCountEv();
 i1 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i4 | 0, i1 | 0, 48, (i2 ? gb + 773551 | 0 : gb + 837976 | 0) | 0, gb + 726521 | 0, 415) | 0;
 HEAP32[i2 >> 2] = gb + 11e4 + 8;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i3 + 28 >> 2];
 i1 = i2 + 36 | 0;
 i3 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return i2 | 0;
}

function __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc(i3, i7, i1, i2, i4, i5, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i1 + 100;
 __ZNKSt3__210__time_put8__do_putEPcRS1_PK2tmcc(i3 + 8 | 0, i1, i2, i4, i5, i6);
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  if ((i5 | 0) == (i6 | 0)) break;
  i2 = HEAP8[i5 >> 0] | 0;
  do if (!i1) i1 = 0; else {
   i3 = i1 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) {
    i7 = (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 & 255 | 0) | 0) == -1;
    i1 = i7 ? 0 : i1;
    break;
   } else {
    HEAP32[i3 >> 2] = i4 + 1;
    HEAP8[i4 >> 0] = i2;
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx9NpFactory15addRigidDynamicEPNS_14PxRigidDynamicEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 564 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5Unity5Cloth10SetEnabledEb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 if (!((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) ^ i4)) return;
 __ZN9Behaviour10SetEnabledEb(i3, i4);
 i5 = i3 + 352 | 0;
 i2 = (HEAP32[i5 >> 2] | 0) + (i4 ? -1 : 1) | 0;
 HEAP32[i5 >> 2] = i2;
 i5 = i3 + 228 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (i1 | 0) {
  if (i2 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 476 >> 2] | 0, i1 | 0) | 0)) {
   HEAP8[i3 + 356 >> 0] = 1;
   i5 = HEAP32[i5 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 472 >> 2] | 0, i5 | 0);
   break;
  }
  i1 = i3 + 356 | 0;
  if (HEAP8[i1 >> 0] | 0) {
   HEAP8[i1 >> 0] = 0;
   i5 = HEAP32[i5 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 468 >> 2] | 0, i5 | 0);
  }
 } while (0);
 if (!i4) return;
 HEAPF32[i3 + 340 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 344 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 348 >> 2] = Math_fround(.100000001);
 HEAP8[i3 + 358 >> 0] = 1;
 __ZN5Unity5Cloth6CreateEv(i3);
 return;
}

function __ZN5Umbra21testAllAndSetBitRangeEPjii(i1, i3, i9) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = i3 >> 5;
 i1 = i1 + (i8 << 2) | 0;
 i2 = i9 - i3 | 0;
 i7 = i3 & 31;
 i4 = -1 << i7;
 if ((i7 | 0) == 0 | (i8 | 0) == (i9 >> 5 | 0)) {
  i7 = i1;
  i8 = i4;
  i1 = 0;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i6 | i4;
  i7 = i1 + 4 | 0;
  i2 = i2 + (i3 | -32) | 0;
  i8 = -1;
  i1 = i4 & ~i6;
 }
 if ((i2 | 0) > 31) {
  i5 = i2 + -32 | 0;
  i6 = i5 >>> 5;
  i4 = i6 + 1 | 0;
  i6 = i6 << 5;
  i3 = i7;
  while (1) {
   i10 = HEAP32[i3 >> 2] | 0;
   HEAP32[i3 >> 2] = -1;
   i1 = i1 | ~i10;
   i2 = i2 + -32 | 0;
   if ((i2 | 0) <= 31) break; else i3 = i3 + 4 | 0;
  }
  i3 = i7 + (i4 << 2) | 0;
  i2 = i5 - i6 | 0;
 } else i3 = i7;
 if (!i2) {
  i10 = i1;
  i10 = (i10 | 0) == 0;
  return i10 | 0;
 }
 i10 = HEAP32[i3 >> 2] | 0;
 i9 = i8 & (1 << (i9 & 31)) + -1;
 HEAP32[i3 >> 2] = i10 | i9;
 i10 = i9 & ~i10 | i1;
 i10 = (i10 | 0) == 0;
 return i10 | 0;
}

function __ZN26AnimatorControllerPlayable7GetBoolEiRb(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  HEAP8[i5 >> 0] = 0;
  i5 = 8;
  return i5 | 0;
 }
 i3 = i4 + 92 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i6 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  HEAP8[i5 >> 0] = 0;
  i6 = 4;
  return i6 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 switch (HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) {
 case 9:
 case 4:
  {
   i6 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
   i6 = i6 + (HEAP32[i6 >> 2] | 0) + 44 | 0;
   HEAP8[i5 >> 0] = HEAP8[i6 + (HEAP32[i6 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] | 0) >> 0] | 0;
   i6 = 1;
   return i6 | 0;
  }
 default:
  {
   HEAP8[i5 >> 0] = 0;
   i6 = 2;
   return i6 | 0;
  }
 }
 return 0;
}

function __ZN24DownloadHandlerAudioClipC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15FMOD_SOUND_TYPE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 8 | 0;
 i6 = i4;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187440 + 8;
 i9 = gb + 63808 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = i6;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = i8;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, i6);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 40 | 0, i2);
 HEAP32[i1 + 52 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z57ParticleSystem_MainModule_CUSTOM_SetCustomSimulationSpaceP12Il2CppObjectS0_(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i3 = i5 + 4 | 0;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 HEAP32[i3 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 __ZN14ParticleSystem24SetCustomSimulationSpaceERK4PPtrI9TransformE(i1, i3);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPFlPKwPPwiEEET_RKNS2_IcNS3_IcEENS5_IcEEEERKT0_PjiT1_(i4, i1, i5, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = 0;
 i2 = (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i8 = ___errno_location() | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = _wcstol(i2, i6, i3) | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i9;
 if ((i3 | 0) == 34) __ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4);
 if ((HEAP32[i6 >> 2] | 0) == (i2 | 0)) __ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4);
 if (i5 | 0) HEAP32[i5 >> 2] = (HEAP32[i6 >> 2] | 0) - i2 >> 2;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNK14VertexDataInfo17GetChannelsLayoutEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 12 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 i3 = HEAP16[i2 + 2 >> 1] | 0;
 HEAP8[i1 >> 0] = i3;
 HEAP8[i1 + 1 >> 0] = i3 >> 8;
 i3 = HEAP16[i2 + 6 >> 1] | 0;
 i4 = i1 + 2 | 0;
 HEAP8[i4 >> 0] = i3;
 HEAP8[i4 + 1 >> 0] = i3 >> 8;
 i4 = HEAP16[i2 + 10 >> 1] | 0;
 i3 = i1 + 4 | 0;
 HEAP8[i3 >> 0] = i4;
 HEAP8[i3 + 1 >> 0] = i4 >> 8;
 i3 = HEAP16[i2 + 14 >> 1] | 0;
 i4 = i1 + 6 | 0;
 HEAP8[i4 >> 0] = i3;
 HEAP8[i4 + 1 >> 0] = i3 >> 8;
 i4 = HEAP16[i2 + 18 >> 1] | 0;
 i3 = i1 + 8 | 0;
 HEAP8[i3 >> 0] = i4;
 HEAP8[i3 + 1 >> 0] = i4 >> 8;
 i3 = HEAP16[i2 + 22 >> 1] | 0;
 i4 = i1 + 10 | 0;
 HEAP8[i4 >> 0] = i3;
 HEAP8[i4 + 1 >> 0] = i3 >> 8;
 i4 = HEAP16[i2 + 26 >> 1] | 0;
 i3 = i1 + 12 | 0;
 HEAP8[i3 >> 0] = i4;
 HEAP8[i3 + 1 >> 0] = i4 >> 8;
 i3 = HEAP16[i2 + 30 >> 1] | 0;
 i2 = i1 + 14 | 0;
 HEAP8[i2 >> 0] = i3;
 HEAP8[i2 + 1 >> 0] = i3 >> 8;
 return;
}

function __ZN6Avatar23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i4);
 HEAP32[i4 + 4 >> 2] = i1 + 32;
 i1 = i5 + 40 | 0;
 i2 = i5;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 >> 2] = -1;
 i3 = i5 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i5 + 68 >> 2] = 1065353216;
 HEAP32[i5 + 72 >> 2] = 1065353216;
 HEAP32[i5 + 76 >> 2] = 1065353216;
 HEAP32[i5 + 80 >> 2] = 1065353216;
 i3 = i5 + 84 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __ZN7mecanim9animation14AvatarConstant8TransferI17RemapPPtrTransferEEvRT_(i5, i4);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc5Scene27prepareOutOfBoundsCallbacksEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 i1 = HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 51604 >> 2] | 0;
 i7 = i2 + 1264 | 0;
 i8 = i2 + 1268 | 0;
 HEAP32[i8 >> 2] = 0;
 if (!i6) {
  STACKTOP = i10;
  return;
 }
 i5 = i1 + 51600 | 0;
 i3 = i2 + 1272 | 0;
 i4 = 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 20 >> 2] | 0;
  HEAP32[i9 >> 2] = i2;
  if ((HEAP32[i3 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i4 << 2) >> 2] = i2;
   HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + 1;
  } else __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i7, i9) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i6 | 0)) break;
  i4 = HEAP32[i8 >> 2] | 0;
 }
 STACKTOP = i10;
 return;
}

function __ZN5IMGUI17BringWindowToBackER8GUIStatei(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i10) return;
 i4 = HEAP32[i10 + 24 >> 2] | 0;
 i5 = (i4 | 0) == 0;
 if (!i5) if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) return;
 i1 = HEAP32[i10 >> 2] | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i7 = (i1 | 0) == (i9 | 0);
 L8 : do if (i7) i8 = 7; else {
  i2 = i1;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) break;
   if ((i2 | 0) == (i9 | 0)) {
    i8 = 7;
    break L8;
   }
  }
  if (!i3) return;
 } while (0);
 if ((i8 | 0) == 7) {
  if (i5) return;
  if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) i3 = i4; else return;
 }
 if (i7) i1 = 1; else {
  i2 = 0;
  do {
   i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0;
   i2 = (i8 | 0) > (i2 | 0) ? i8 : i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i9 | 0));
  i1 = i2 + 1 | 0;
 }
 HEAP32[i3 + 68 >> 2] = i1;
 HEAP8[i10 + 16 >> 0] = 1;
 return;
}

function __ZN22ParticleSystemRenderer17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 424 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 428 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 436 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 440 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 448 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 452 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 460 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN8Renderer17MainThreadCleanupEv(i3);
  return;
 }
 i4 = i3 + 464 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Renderer17MainThreadCleanupEv(i3);
 return;
}

function __ZN11UnityEngine9Analytics13UserInfoEventD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188648 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine7Connect15AppInstallEventD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188916 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 i5 = gb + 63408 | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __Z26IntersectAABBAABBInclusiveRK4AABBS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 i8 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (!((i8 ? f7 : f6) <= Math_fround(f5 + Math_fround(HEAPF32[i2 + 12 >> 2])))) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = f4 < Math_fround(0.0);
 f6 = Math_fround(-f4);
 f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (!((i8 ? f6 : f4) <= Math_fround(f7 + Math_fround(HEAPF32[i2 + 16 >> 2])))) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = f3 < Math_fround(0.0);
 f6 = Math_fround(-f3);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i8 = (i8 ? f6 : f3) <= Math_fround(f7 + Math_fround(HEAPF32[i2 + 20 >> 2]));
 return i8 | 0;
}

function __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!i5) return;
 i1 = i6 + 12 | 0;
 HEAP32[i1 >> 2] = 1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if (!(i3 & 2147483647)) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 1;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, 28, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(28, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i1 >> 2] | 0) * 28 | 0) | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i6 >> 2] = i3;
  i1 = i3;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + 16 >> 2] = i4;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = i5;
 return;
}

function __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EEPKS8_RKSB_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i6 = _strlen(i4) | 0;
 i2 = i5 + 11 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i1 & 255;
 __THREW__ = 0;
 invoke_viiii(fb + 365 | 0, i3 | 0, i4 | 0, i6 | 0, i1 + i6 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  __THREW__ = 0;
  invoke_iiii(fb + 519 | 0, i3 | 0, ((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0, i1 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) return;
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i3);
 ___resumeException(i6 | 0);
}

function __ZN9Transform13SetLocalScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i6 = i3;
 i4 = i3 + 8 | 0;
 i9 = i1 + 32 | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (!(__Z9SetLocalS15TransformAccessRKN4math7_float3E(i5, i4) | 0)) {
  STACKTOP = i3;
  return;
 }
 i9 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i9 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 11);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN9Animation25CheckRendererVisibleStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = HEAP32[i2 + 72 >> 2] | 0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 L1 : do if ((i1 | 0) != (i3 | 0)) {
  while (1) {
   if (__ZNK8Renderer16IsVisibleInSceneEv(HEAP32[i1 >> 2] | 0) | 0) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) break L1;
  }
  HEAP8[i2 + 42 >> 0] = 1;
  if (!(__Z14IsWorldPlayingv() | 0)) return;
  i3 = i2 + 256 | 0;
  i1 = (HEAP32[i3 >> 2] | 0) != 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0);
  if (i1 | (HEAP32[i3 >> 2] | 0) == 0) return;
  __ZN9Animation15UpdateAnimationEd(i2, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
  return;
 } while (0);
 HEAP8[i2 + 42 >> 0] = 0;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 i3 = i2 + 256 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) != 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0);
 if (i1 | (HEAP32[i3 >> 2] | 0) == 0) return;
 __ZN9Animation15UpdateAnimationEd(i2, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
 return;
}

function __ZN8JSONReadD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 124 >> 2] | 0, gb + 64016 | 0);
 i1 = HEAP32[i2 + 120 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2 + 88 | 0);
 i1 = i2 + 64 | 0;
 if ((HEAP32[i2 + 80 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 68 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 44 | 0;
 if ((HEAP32[i2 + 60 >> 2] | 0) <= -1) {
  i2 = i2 + 24 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 48 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i2 + 24 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 return;
}

function __ZN7Joint2D13SetBreakForceEf(i5, f2) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 44 | 0;
 if (f2 < Math_fround(0.0)) HEAPF32[i1 >> 2] = Math_fround(0.0); else {
  HEAPF32[i1 >> 2] = f2;
  if (f2 == Math_fround(inf)) if (Math_fround(HEAPF32[i5 + 48 >> 2]) == Math_fround(inf)) {
   i1 = i5 + 64 | 0;
   i3 = HEAP32[i1 >> 2] | 0;
   if (!i3) return;
   i5 = i5 + 68 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   return;
  }
 }
 i3 = (HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0) + 588 | 0;
 i4 = i5 + 64 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i5 + 68 | 0; else {
  i5 = i5 + 68 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i1 = i5;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN5physx9NpFactory14addRigidStaticEPNS_13PxRigidStaticEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 564 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i2;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 if (i1) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc5Scene8simulateEfPNS_10PxBaseTaskE(i5, f1, i4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 if (!(f1 != Math_fround(0.0))) return;
 HEAPF32[i5 + 64 >> 2] = f1;
 i2 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 HEAPF32[i5 + 68 >> 2] = i2 ? f1 : Math_fround(0.0);
 __ZN5physx2Sc5Scene15prepareSimulateEv(i5);
 __ZN5physx2Sc5Scene17stepSetupSimulateEv(i5);
 i2 = i5 + 2304 | 0;
 HEAP32[i5 + 2320 >> 2] = 1;
 i3 = i5 + 2316 | 0;
 HEAP32[i3 >> 2] = i4;
 if (i4 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  HEAP32[i5 + 2312 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
 }
 i4 = i5 + 2332 | 0;
 HEAP32[i5 + 2348 >> 2] = 1;
 i3 = i5 + 2344 | 0;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 HEAP32[i5 + 2340 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 return;
}

function __ZN11UnityEngine7Connect14AppUpdateEventD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188916 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager14SetSessionInfoERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 12 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 20 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 16 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 16 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __Z21GetShaderGlobalVectorN9ShaderLab16FastPropertyNameE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 L1 : do if ((i5 | 0) != -1 & (i5 & -1073741824 | 0) == 1073741824) i1 = (__Z12GetGfxDevicev() | 0) + 4 + ((i5 & 1073741823) << 4) | 0; else {
  i2 = HEAP32[gb + 1166248 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
  i3 = HEAP32[i2 + 52 >> 2] | 0;
  if ((i1 | 0) < (i3 | 0)) {
   i4 = HEAP32[i2 + 68 >> 2] | 0;
   while (1) {
    if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i3 | 0)) {
     i1 = gb + 1162376 | 0;
     break L1;
    }
   }
   if ((i1 | 0) > -1) i1 = (HEAP32[i2 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 88 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0; else i1 = gb + 1162376 | 0;
  } else i1 = gb + 1162376 | 0;
 } while (0);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function _UNITY_png_set_IHDR(i1, i10, i9, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i11 = 0;
 if ((i1 | 0) == 0 | (i10 | 0) == 0) return;
 HEAP32[i10 >> 2] = i9;
 HEAP32[i10 + 4 >> 2] = i2;
 i8 = i10 + 24 | 0;
 HEAP8[i8 >> 0] = i3;
 i11 = i10 + 25 | 0;
 HEAP8[i11 >> 0] = i4;
 HEAP8[i10 + 26 >> 0] = i6;
 HEAP8[i10 + 27 >> 0] = i7;
 HEAP8[i10 + 28 >> 0] = i5;
 _UNITY_png_check_IHDR(i1, i9, i2, i3 & 255, i4 & 255, i5 & 255, i6 & 255, i7 & 255);
 i2 = HEAP8[i11 >> 0] | 0;
 if (i2 << 24 >> 24 == 3) {
  HEAP8[i10 + 29 >> 0] = 1;
  i1 = 1;
 } else {
  i1 = i2 & 2 | 1;
  HEAP8[i10 + 29 >> 0] = i1;
  if (i2 & 4) {
   i1 = i1 + 1 << 24 >> 24;
   HEAP8[i10 + 29 >> 0] = i1;
  }
 }
 i1 = Math_imul(HEAPU8[i8 >> 0] | 0, i1 & 255) | 0;
 HEAP8[i10 + 30 >> 0] = i1;
 i1 = i1 & 255;
 if (i1 >>> 0 > 7) i1 = Math_imul(i1 >>> 3, i9) | 0; else i1 = ((Math_imul(i1, i9) | 0) + 7 | 0) >>> 3;
 HEAP32[i10 + 12 >> 2] = i1;
 return;
}

function _cf2_arrstack_setCount(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i5 + 12 | 0;
 do if ((HEAP32[i3 >> 2] | 0) >>> 0 < i6 >>> 0) {
  HEAP32[i2 >> 2] = 0;
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i4 = Math_imul(i1, i6) | 0;
  if ((2147483647 / (i1 >>> 0) | 0) >>> 0 >= i6 >>> 0) {
   i1 = i5 + 24 | 0;
   i8 = i5 + 28 | 0;
   HEAP32[i8 >> 2] = _UNITY_ft_mem_realloc(HEAP32[i5 >> 2] | 0, 1, HEAP32[i1 >> 2] | 0, i4, HEAP32[i8 >> 2] | 0, i2) | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    HEAP32[i3 >> 2] = i6;
    HEAP32[i1 >> 2] = i4;
    i1 = i5 + 20 | 0;
    if ((HEAP32[i1 >> 2] | 0) >>> 0 <= i6 >>> 0) break;
    _cf2_setError(HEAP32[i5 + 4 >> 2] | 0, 130);
    HEAP32[i1 >> 2] = i6;
    STACKTOP = i7;
    return;
   }
  }
  _cf2_setError(HEAP32[i5 + 4 >> 2] | 0, 64);
  STACKTOP = i7;
  return;
 } else i1 = i5 + 20 | 0; while (0);
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return;
}

function __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 37;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i2 = gb + 480196 | 0;
  return i2 | 0;
 }
 i1 = i2 & -1073741824;
 L4 : do if ((i1 | 0) < -1073741824) {
  switch (i1 | 0) {
  case -2147483648:
   break;
  default:
   break L4;
  }
  i2 = __Z25GetBuiltinMatrixParamNamei(i2 & 1073741823) | 0;
  return i2 | 0;
 } else if ((i1 | 0) < 1073741824) {
  switch (i1 | 0) {
  case -1073741824:
   break;
  default:
   break L4;
  }
  i2 = __Z25GetBuiltinTexEnvParamNamei(i2 & 1073741823) | 0;
  return i2 | 0;
 } else {
  switch (i1 | 0) {
  case 1073741824:
   break;
  default:
   break L4;
  }
  i2 = __Z25GetBuiltinVectorParamNamei(i2 & 1073741823) | 0;
  return i2 | 0;
 } while (0);
 if ((i2 | 0) <= -1) {
  i2 = gb + 480196 | 0;
  return i2 | 0;
 }
 i1 = HEAP32[gb + 1170580 >> 2] | 0;
 if ((i2 | 0) >= (HEAP32[i1 + 12 >> 2] | 0)) {
  i2 = gb + 480196 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZNK5physx7NpScene19checkPositionSanityERKNS_12PxRigidActorERKNS_11PxTransformEPKc(i5, i3, i2, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f1 = f0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 f1 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 if (!(f1 < Math_fround(HEAPF32[i5 + 3664 >> 2]))) if (!(f1 > Math_fround(HEAPF32[i5 + 3676 >> 2]))) {
  f1 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  if (!(f1 < Math_fround(HEAPF32[i5 + 3668 >> 2]))) if (!(f1 > Math_fround(HEAPF32[i5 + 3680 >> 2]))) {
   f1 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   if (!(f1 < Math_fround(HEAPF32[i5 + 3672 >> 2]))) if (!(f1 > Math_fround(HEAPF32[i5 + 3684 >> 2]))) {
    STACKTOP = i7;
    return;
   }
  }
 }
 i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i3;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 2, gb + 678666 | 0, 2776, gb + 770458 | 0, i6);
 STACKTOP = i7;
 return;
}

function __ZN9Transform11SetPositionERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i6 = i3;
 i4 = i3 + 8 | 0;
 i9 = i1 + 32 | 0;
 i7 = HEAP32[i9 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (!(__Z10SetGlobalT15TransformAccessRKN4math7_float3E(i5, i4) | 0)) {
  STACKTOP = i3;
  return;
 }
 i9 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i9 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, 1);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i9 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i6 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 268 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 272 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i6 + 264 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  i6 = i6 + 276 | 0;
  HEAP8[i6 >> 0] = 1;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_19PxProfileZoneClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i6 + 260 | 0, i1) | 0;
  i6 = i6 + 276 | 0;
  HEAP8[i6 >> 0] = 1;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx2Sq8AABBTree7releaseEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 1 | 0;
 i5 = i7;
 i2 = i6 + 544 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) {
    i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 | 0);
   }
  }
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2 + -8 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 _memset(HEAP32[i6 + 8 >> 2] | 0, 0, HEAP32[i6 + 12 >> 2] << 2 | 0) | 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN17PersistentManager27GetLoadErrorMessageFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0, 1) | 0;
 L1 : do if ((i4 | 0) != -1) switch (HEAP32[(__ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i4) | 0) + 20 >> 2] | 0) {
 case -1:
  break L1;
 case 1:
  {
   HEAP32[i6 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
   __Z6FormatPKcz(i1, gb + 467047 | 0, i6);
   STACKTOP = i7;
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   HEAP32[i1 + 8 >> 2] = 0;
   STACKTOP = i7;
   return;
  }
 } while (0);
 HEAP32[i5 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 __Z6FormatPKcz(i1, gb + 467004 | 0, i5);
 STACKTOP = i7;
 return;
}

function __ZN17GeneralConnection25RegisterConnectionHandlerEPFvjE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = i1;
 i2 = i4 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i4 + 120 >> 2] | 0)) __ZNSt3__26vectorIPFvjENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i4 + 112 | 0, i5); else {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
 }
 i2 = HEAP32[i4 + 88 >> 2] | 0;
 i3 = i4 + 92 | 0;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 while (1) {
  mftCall_vi(HEAP32[i5 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 STACKTOP = i6;
 return;
}

function __ZN14SerializedFile11GetTypeTreeEx(i6, i7, i9) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i10 = 0, i11 = 0;
 i2 = HEAP32[i6 + 32 >> 2] | 0;
 i8 = HEAP32[i6 + 36 >> 2] | 0;
 i1 = i8 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 * 24 | 0) | 0;
   i3 = i4;
   i11 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i11 | 0) < (i9 | 0) | ((i11 | 0) == (i9 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i8 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i11 = i1;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 if ((i10 | 0) > (i9 | 0) | ((i10 | 0) == (i9 | 0) ? (HEAP32[i11 >> 2] | 0) >>> 0 > i7 >>> 0 : 0) | (i1 | 0) == (i8 | 0)) {
  i11 = 0;
  return i11 | 0;
 }
 i11 = HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP32[i1 + 16 >> 2] | 0) * 56 | 0) + 44 >> 2] | 0;
 return i11 | 0;
}

function __ZN12InputManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i11;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
 i8 = i1 + 28 | 0;
 i9 = i1 + 32 | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i5 = (i2 - i1 | 0) / 108 | 0;
 HEAP32[i7 >> 2] = i5;
 i6 = i10 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i10 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i5;
  HEAP32[i6 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i7, 4);
  i1 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i9 >> 2] | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  STACKTOP = i11;
  return;
 }
 do {
  __ZN9InputAxis8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i10);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (i2 | 0));
 STACKTOP = i11;
 return;
}

function __Z8FileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i1);
 i7 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i7 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 >> 2] | 0 : i4;
 i7 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i7 & 255;
 i2 = i1 + i7 | 0;
 if (i7 | 0) do {
  if ((HEAP8[i1 >> 0] | 0) == 92) HEAP8[i1 >> 0] = 47;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i4);
 __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __Z47Graphics_CUSTOM_Internal_SetRandomWriteTargetRTiP12Il2CppObject(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 20 | 0;
 i2 = i6 + 8 | 0;
 i5 = i6 + 16 | 0;
 if ((i4 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 517946 | 0, i6);
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 148 >> 2] | 0) <= (i4 | 0)) {
  i7 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 148 >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i2 + 4 >> 2] = i7;
  __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 517969 | 0, i2);
 }
 if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 48 >> 2] | 0;
 }
 i7 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + 768 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 mftCall_viii(i2 | 0, i7 | 0, i4 | 0, i3 | 0);
 STACKTOP = i6;
 return;
}

function __Z29StdTemplateConversionFunctionItjEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionItiEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __ZNK6Camera31GetStereoSkyboxProjectionMatrixE15StereoscopicEyefR10Matrix4x4f(i3, i4, f5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, f9 = f0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 if (HEAP8[i3 + 1084 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i3) | 0) {
  i7 = __Z12GetIVRDevicev() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0);
  i7 = i3 + 424 + (i4 << 6) | 0;
  i2 = i7 + 64 | 0;
  do {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   i7 = i7 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i7 | 0) < (i2 | 0));
 }
 i7 = i6;
 i1 = i3 + 424 + (i4 << 6) | 0;
 i2 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i2 | 0));
 f9 = Math_fround(HEAPF32[i3 + 920 >> 2]);
 __ZN10Matrix4x4f16AdjustDepthRangeEfff(i6, f9, f5, Math_fround(HEAPF32[i3 + 924 >> 2])) | 0;
 STACKTOP = i8;
 return;
}

function __ZNK5Umbra9Matrix4x39isUniformEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, d3 = 0.0, d4 = 0.0, f5 = f0, f6 = f0, d7 = 0.0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 d4 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 d7 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 d3 = d4 * .0001;
 if (!(+Math_abs(+(d4 - d7)) <= d3)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = +Math_abs(+(d4 - +Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f2 * f2)))))) <= d3;
 return i1 | 0;
}

function __ZNK5Umbra9Matrix3x39isUniformEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, d3 = 0.0, d4 = 0.0, f5 = f0, f6 = f0, d7 = 0.0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 d4 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 * f5);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(f5 + Math_fround(f6 * f6));
 f5 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 d7 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f5 * f5))));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 d3 = d4 * .0001;
 if (!(+Math_abs(+(d4 - d7)) <= d3)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = +Math_abs(+(d4 - +Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f6 * f6)) + Math_fround(f2 * f2)))))) <= d3;
 return i1 | 0;
}

function __ZN7mecanim4hand12HandPoseCopyEPKNS0_8HandPoseEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i2 + 76 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i2 + 88 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i2 + 92 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i2 + 100 >> 2] = HEAP32[i1 + 100 >> 2];
 HEAP32[i2 + 104 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 108 >> 2] = HEAP32[i1 + 108 >> 2];
 HEAP32[i2 + 112 >> 2] = HEAP32[i1 + 112 >> 2];
 HEAP32[i2 + 116 >> 2] = HEAP32[i1 + 116 >> 2];
 return;
}

function __ZN7ApiGLES14SetPolygonModeEb(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 718 >> 0] | 0)) return;
 i3 = HEAP8[i5 + 1992 >> 0] | 0;
 i4 = i3 << 24 >> 24 == 0;
 i1 = i5 + 1596 | 0;
 if (!i4) if ((HEAPU8[i1 >> 0] | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 if (i2) {
  i1 = i5 + 1592 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i4 | (i2 & 1024 | 0) == 0) {
   HEAP32[i1 >> 2] = i2 | 1024;
   i4 = HEAP32[i5 + 768 >> 2] | 0;
   mftCall_vi(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i5 + 860 >> 2] | 0, 10) | 0);
  }
  mftCall_vii(HEAP32[i5 + 780 >> 2] | 0, 1032, 6913);
  return;
 } else {
  i1 = i5 + 1592 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i3 << 24 >> 24 != 0 & (i2 & 1024 | 0) == 0)) {
   HEAP32[i1 >> 2] = i2 & -1025;
   i4 = HEAP32[i5 + 772 >> 2] | 0;
   mftCall_vi(i4 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i5 + 860 >> 2] | 0, 10) | 0);
  }
  mftCall_vii(HEAP32[i5 + 780 >> 2] | 0, 1032, 6914);
  return;
 }
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5);
 i3 = i5 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 268 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 272 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 4 | 0) == (i1 | 0)) {
  HEAP8[i5 + 260 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5);
 i3 = i5 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 268 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 272 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 4 | 0) == (i1 | 0)) {
  HEAP8[i5 + 260 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN20SpeedTreeWindManager15DeleteLocalWindEP18SpeedTreeLocalWind(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 if (!i10) return;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i9 = i1 + 24 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i1 = i8 - i3 >> 2;
 i2 = i8;
 if (i1) {
  i4 = i3;
  i5 = i3;
  while (1) {
   i11 = (i1 | 0) / 2 | 0;
   i7 = i5 + (i11 << 2) | 0;
   i6 = (HEAP32[i7 >> 2] | 0) >>> 0 < i10 >>> 0;
   i7 = i7 + 4 | 0;
   i3 = i6 ? i7 : i4;
   i1 = i6 ? i1 + -1 - i11 | 0 : i11;
   if (!i1) break; else {
    i4 = i3;
    i5 = i6 ? i7 : i5;
   }
  }
 }
 if ((i3 | 0) != (i2 | 0)) if ((HEAP32[i3 >> 2] | 0) >>> 0 <= i10 >>> 0) {
  i4 = i3 + 4 | 0;
  i1 = i8 - i4 | 0;
  i5 = i1 >> 2;
  if (i5) {
   _memmove(i3 | 0, i4 | 0, i1 | 0) | 0;
   i2 = HEAP32[i9 >> 2] | 0;
  }
  i1 = i3 + (i5 << 2) | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i9 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1170604 >> 2] | 0, i10);
 return;
}

function __ZN15TerrainRenderer24ReclaimPatchVertexBufferEP15SharedGfxBuffer(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 116 | 0;
 i4 = i10 + 128 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i10 + 132 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i2 = i8 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i10 + 120 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 120 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
 return;
}

function __ZNK9BoxPruner14retrieveBoundsER5IAABBt(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i2 = i1 & 65535;
 i5 = HEAP32[i4 + 76 >> 2] | 0;
 i1 = i5 + (i2 << 3) + 4 | 0;
 i2 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
 if (!(HEAP32[i1 >> 2] & 1)) {
  i5 = (HEAP32[i4 + 100 >> 2] | 0) + (i2 * 24 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  i5 = HEAP32[i1 >> 2] | 0;
  return i5 | 0;
 } else {
  i5 = (HEAP32[i4 + 96 >> 2] | 0) + (i2 * 24 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  i5 = HEAP32[i1 >> 2] | 0;
  return i5 | 0;
 }
 return 0;
}

function __ZNK5physx7NpCloth16getStretchConfigENS_22PxClothFabricPhaseType4EnumE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore16getStretchConfigENS_22PxClothFabricPhaseType4EnumE(i1, i2 + 32 | 0, i3);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 903, gb + 695650 | 0, i4);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx2Sc9ShapeCoreC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKtt(i5, i1, i4, i3, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0;
 i7 = i5 + 68 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i7 >> 2] = -1;
 HEAPF32[i5 + 128 >> 2] = Math_fround(0.0);
 HEAP8[i5 + 132 >> 0] = 1;
 i6 = HEAP32[gb + 1457332 >> 2] | 0;
 __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE(i7, i1);
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 HEAP32[i5 + 44 >> 2] = 1065353216;
 HEAP32[i5 + 48 >> 2] = 0;
 HEAP32[i5 + 52 >> 2] = 0;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAPF32[i5 + 60 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * Math_fround(.0199999996));
 HEAP8[i5 + 64 >> 0] = HEAP8[i4 >> 0] | 0;
 __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt(i5, i3, i2);
 return;
}

function __ZN20TextRenderingPrivate7GUITextC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10GUIElementC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 185436 + 8;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP8[i1 + 65 >> 0] = 1;
 HEAP32[i1 + 84 >> 2] = -1;
 STACKTOP = i4;
 return;
}

function __ZL12PhysxJobFuncPN5physx10PxBaseTaskE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i1 + 6 | 0;
 i6 = i4 + 128 | 0;
 do {
  HEAP8[i4 >> 0] = 0;
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP8[i1 >> 0] = 80;
 HEAP8[i1 + 1 >> 0] = 104;
 HEAP8[i1 + 2 >> 0] = 121;
 HEAP8[i1 + 3 >> 0] = 115;
 HEAP8[i1 + 4 >> 0] = 88;
 HEAP8[i1 + 5 >> 0] = 46;
 _strncpy(i1 + 6 | 0, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0, 128) | 0;
 HEAP8[i1 + 133 >> 0] = 0;
 i6 = __Z26profiler_get_info_for_namePKc13ProfilerGroup(i1, 3) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i6, i1);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
 __Z12profiler_endP19ProfilerInformation(i6);
 STACKTOP = i5;
 return;
}

function __ZNK21EnlightenSceneMapping32GetSystemAtlasForInputSystemHashERK7Hash128(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = HEAP32[i4 + 32 >> 2] | 0;
 if (!i6) {
  i9 = 0;
  return i9 | 0;
 }
 i7 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i1;
 i8 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i10 = i7 + (i1 * 56 | 0) + 24 | 0;
  if ((HEAP32[i10 >> 2] | 0) == (i8 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i5 | 0) : 0) {
   i10 = i7 + (i1 * 56 | 0) + 32 | 0;
   if ((HEAP32[i10 >> 2] | 0) == (i2 | 0) ? (HEAP32[i10 + 4 >> 2] | 0) == (i3 | 0) : 0) break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i9 = 8;
   break;
  }
 }
 if ((i9 | 0) == 8) return i1 | 0;
 if ((i1 | 0) == -1 | (i7 + (i1 * 56 | 0) | 0) == 0) {
  i10 = 0;
  return i10 | 0;
 }
 i10 = (HEAP32[i4 + 80 >> 2] | 0) + (HEAP32[i7 + (i1 * 56 | 0) + 8 >> 2] << 5) | 0;
 return i10 | 0;
}

function __ZNK11PreloadData18GetInstanceIDArrayER13dynamic_arrayIiLj4EE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i5 + 44 >> 2] | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i6 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6 << 2, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i1 >> 2] = i3;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6 << 2, 4, i1 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = i4;
  i3 = i4;
  break;
 } else i3 = HEAP32[i1 >> 2] | 0; while (0);
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i6) return; else i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (HEAP32[i5 + 280 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv(i5);
 i3 = i5 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 268 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 272 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 4 | 0) == (i1 | 0)) {
  HEAP8[i5 + 260 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN4math5Limit8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 906590 | 0, gb + 906560 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 906596 | 0, gb + 906560 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN22UnityProfilerPerThread21InjectGCCollectSampleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, d7 = 0.0;
 i2 = i1 + 248 | 0;
 i4 = i2;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i1, gb + 1163364 | 0, 0) | 0;
 i2 = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + ((HEAP32[i1 + 48 >> 2] | 0) + -1 << 4) >> 2] | 0;
 i3 = HEAP32[HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 >>> 14 << 2) >> 2] >> 2] | 0;
 d7 = +_emscripten_get_now() * 1.0e6;
 i6 = +Math_abs(d7) >= 1.0 ? (d7 > 0.0 ? ~~+Math_min(+Math_floor(d7 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d7 - +(~~d7 >>> 0)) / 4294967296.0) >>> 0) : 0;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i1, gb + 1163364 | 0, ~~d7 >>> 0, i6) | 0;
 i1 = ___udivdi3(i5 | 0, i4 | 0, 1e3, 0) | 0;
 HEAPF32[i3 + ((i2 & 16383) * 24 | 0) + 8 >> 2] = Math_fround(+(i1 >>> 0) + 4294967296.0 * +((getTempRet0() | 0) >>> 0));
 return;
}

function __ZN15SerializeTraitsINSt3__24pairI7Hash128S2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37008 >> 2] | 0, gb + 455698 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 16 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 37224 >> 2] | 0, gb + 455698 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZNK14SoundHandleAPI12GetLengthPCMEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if ((HEAP32[i1 + 44 >> 2] | 0) != 3) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN4FMOD5Sound9getLengthEPjj(HEAP32[i1 + 40 >> 2] | 0, i3, 2) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
  HEAP32[i4 >> 2] = gb + 853741;
  HEAP32[i4 + 4 >> 2] = 561;
  HEAP32[i4 + 8 >> 2] = gb + 872473;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i2 = i7 + (HEAP32[i2 + 28 >> 2] << 2) | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i1;
 i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i5) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 do {
  if ((HEAP8[i1 + 21 >> 0] & i4) << 24 >> 24) {
   i1 = i1 + -8 | 0;
   i2 = i1 + 4 | 0;
   HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | i3;
   i2 = i1 + 6 | 0;
   if (!(HEAP16[i2 >> 1] & 2)) {
    __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i1);
    HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 2;
   }
  }
  i1 = __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i5) | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i6;
 return;
}

function __ZN31CollisionModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 224 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 488 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 752 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 936 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 940 >> 2]);
   break;
  }
 case 5:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 904 >> 2] | 0) + 948 >> 0] | 0) != 0 & 1);
   break;
  }
 case 6:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 904 >> 2] | 0) + 949 >> 0] | 0) != 0 & 1);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 904 >> 2] | 0) + 944 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN14DirectorPlayer9GetStagesER13dynamic_arrayI9StageDescLj4EE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i8 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 i5 = i8 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 & 2147483647;
 do if (i4 >>> 0 > i7 >>> 0) {
  i1 = i6 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i7 >>> 0 < i1 >>> 0) if ((i6 | 0) > -1) {
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i8 >> 2] | 0, i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 3, 4, i8 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i8 >> 2] | 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
   HEAP32[i5 >> 2] = i1;
   HEAP32[i8 >> 2] = i7;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = i4;
 i8 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 + (i3 << 3) + 4 >> 2] = 2;
 HEAP32[i8 + (i3 << 3) >> 2] = fb + 3355;
 return;
}

function __ZN13GfxDeviceGLES16AddPendingMipGenEP17RenderSurfaceBase(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 8476 | 0;
 i4 = i10 + 8488 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i10 + 8492 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i2 = i8 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i10 + 8480 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 8480 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
 return;
}

function __ZN10UnitySceneD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 66456 + 8;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i1 = i2 + 44 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __Z29StdTemplateConversionFunctionIjtEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIjsEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIitEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIisEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 65535;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 65535;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function _erf(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, i2 | 0, 63) | 0;
 i4 = getTempRet0() | 0;
 i2 = i2 & 2147483647;
 do if (i2 >>> 0 > 2146435071) {
  i4 = _bitshift64Shl(i3 | 0, i4 | 0, 1) | 0;
  getTempRet0() | 0;
  d1 = 1.0 / d1 + +(1 - i4 | 0);
 } else if (i2 >>> 0 < 1072365568) if (i2 >>> 0 < 1043333120) {
  d1 = (d1 * 8.0 + d1 * 1.0270333367641007) * .125;
  break;
 } else {
  d5 = d1 * d1;
  d1 = (d5 * (d5 * (d5 * (-.005770270296489442 - d5 * 2.3763016656650163e-05) + -.02848174957559851) + -.3250421072470015) + .12837916709551256) / (d5 * (d5 * (d5 * (d5 * (1.3249473800432164e-04 - d5 * 3.960228278775368e-06) + .005081306281875766) + .0650222499887673) + .39791722395915535) + 1.0) * d1 + d1;
  break;
 } else {
  if (i2 >>> 0 < 1075314688) d1 = 1.0 - +_erfc2(i2, d1); else d1 = 1.0;
  d1 = (i3 | 0) != 0 | (i4 | 0) != 0 ? -d1 : d1;
  break;
 } while (0);
 return +d1;
}

function __ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 8 | 0;
 __ZN5physx14PxsAABBManager12createVolumeEjjjPvRKNS_9PxBounds3E(i7, HEAP32[(HEAP32[(HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i2, HEAP32[i1 + 4 >> 2] | 0, i4, i5, i3);
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i5 + 12 | 0;
 i2 = i5;
 i3 = HEAP32[i7 + 4 >> 2] & 1073741823 | HEAP32[i2 + 4 >> 2] & -1073741824;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2] & -1073741824 | i4 & 1073741823;
 HEAP32[i5 + 4 >> 2] = i3;
 if ((i4 | 0) != 1073741823) {
  i7 = 1;
  STACKTOP = i6;
  return i7 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 675845 | 0, 95, gb + 675941 | 0, i6);
 i7 = 0;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN2UI14CanvasRenderer25UpdatePotentialMeshCountsEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = HEAP32[i6 + 188 >> 2] | 0;
 if (!i7) return;
 if (!(HEAP8[i6 + 164 >> 0] | 0)) {
  i5 = HEAP32[i6 + 88 >> 2] | 0;
  if (!i5) {
   i2 = 0;
   i1 = 0;
  } else {
   i4 = HEAP32[i6 + 76 >> 2] | 0;
   i2 = 0;
   i1 = 0;
   i3 = 0;
   do {
    i1 = (HEAP32[i4 + (i3 * 52 | 0) + 48 >> 2] | 0) + i1 | 0;
    i2 = (HEAP32[i4 + (i3 * 52 | 0) + 36 >> 2] | 0) + i2 | 0;
    i3 = i3 + 1 | 0;
   } while ((i3 | 0) < 8 & i3 >>> 0 < i5 >>> 0);
  }
 } else {
  i2 = 0;
  i1 = 0;
 }
 i4 = HEAPU8[i6 + 184 >> 0] | 0;
 i3 = i1 << i4;
 i4 = i2 << i4;
 i1 = i6 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i5 = i7 + 216 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i2 + i3;
  HEAP32[i1 >> 2] = i3;
 }
 i1 = i6 + 196 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i7 = i7 + 220 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) - i2 + i4;
 HEAP32[i1 >> 2] = i4;
 return;
}

function __ZN14UnityAnalytics22HandleCustomEventLimitERN11UnityEngine9Analytics15UserCustomEventE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 80 >> 2] | 0) >>> 0 > (HEAP32[i2 + 36 >> 2] | 0) >>> 0) {
  i5 = 3;
  return i5 | 0;
 }
 if ((HEAP32[i1 + 84 >> 2] | 0) >>> 0 > (HEAP32[i2 + 40 >> 2] | 0) >>> 0) {
  i5 = 4;
  return i5 | 0;
 }
 i5 = HEAP32[i2 + 32 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv() | 0;
 i2 = getTempRet0() | 0;
 i3 = i4 + 752 | 0;
 i6 = i3;
 i6 = _i64Subtract(i1 | 0, i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0) | 0;
 i7 = getTempRet0() | 0;
 if (i7 >>> 0 > 0 | (i7 | 0) == 0 & i6 >>> 0 > 3599999) {
  i7 = i3;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = 1;
  i1 = i4 + 760 | 0;
 } else {
  i1 = i4 + 760 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i7 = 5;
   return i7 | 0;
  }
 }
 HEAP32[i1 >> 2] = i2;
 i7 = 0;
 return i7 | 0;
}

function __ZN14PreloadManager18PushIntegrateQueueEP23PreloadManagerOperation(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 20 | 0;
 i4 = i10 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i10 + 36 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i2 = i8 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
 return;
}

function __Z39TrailRenderer_Get_Custom_PropWidthCurveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i5 = __Znwj(88) | 0;
  i1 = HEAP32[i2 + 384 >> 2] | 0;
  i2 = i5;
  i3 = i1 + 20 | 0;
  i4 = i2 + 56 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i5 + 56 | 0, i1 + 76 | 0);
  i4 = i5 + 76 | 0;
  i3 = i1 + 96 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i4 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i5;
  return i4 | 0;
 }
 return 0;
}

function _cpowl(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, d5 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, d11 = 0.0, d12 = 0.0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 64 | 0;
 i8 = i4 + 48 | 0;
 i6 = i4 + 32 | 0;
 i10 = i4 + 16 | 0;
 i9 = i4;
 d12 = +HEAPF64[i2 + 8 >> 3];
 d11 = +HEAPF64[i3 >> 3];
 d5 = +HEAPF64[i3 + 8 >> 3];
 HEAPF64[i10 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i10 + 8 >> 3] = d12;
 HEAPF64[i9 >> 3] = d11;
 HEAPF64[i9 + 8 >> 3] = d5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 _cpow(i6, i8, i7);
 d5 = +HEAPF64[i6 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i6 >> 3];
 HEAPF64[i1 + 8 >> 3] = d5;
 STACKTOP = i4;
 return;
}

function __ZNK10SampleClip17CalculateFMODModeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 104 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + -4 | 0;
 if (i1 >>> 0 < 5) i1 = ((19 >>> (i1 & 31) & 1) << 5 ^ 32) + 50 | 0; else i1 = 82;
 if (!(HEAP8[i3 + 44 >> 0] | 0)) i2 = (HEAP8[i3 + 65 >> 0] | 0) == 0 ? i1 : i1 | 65536; else {
  i1 = i1 | 16384;
  if (!(HEAP8[i3 + 65 >> 0] | 0)) i2 = i1; else {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 854254 | 0, 0, gb + 854464 | 0, 176, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
   i2 = i1;
  }
 }
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if ((HEAP32[i3 + 36 >> 2] | 0) > 2) i1 = (HEAP32[i4 >> 2] | 0) == 0 ? i1 : (i1 | 0) == 1 ? 2 : i1; else if (Math_fround(HEAPF32[i3 + 48 >> 2]) < Math_fround(.5)) i1 = (i1 | 0) == 2 ? 1 : i1;
 switch (i1 | 0) {
 case 0:
  {
   i4 = i2 | 256;
   return i4 | 0;
  }
 case 1:
  {
   i4 = i2 | 512;
   return i4 | 0;
  }
 case 2:
  {
   i4 = i2 | 128;
   return i4 | 0;
  }
 default:
  {
   i4 = i2;
   return i4 | 0;
  }
 }
 return 0;
}

function __ZN9Animation8GetStateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN9Animation20BuildAnimationStatesEv(i1);
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 i9 = HEAP32[i1 + 108 >> 2] | 0;
 if ((i3 | 0) == (i9 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i8 = HEAP8[i2 + 11 >> 0] | 0;
 i7 = i8 << 24 >> 24 < 0;
 i8 = i7 ? HEAP32[i2 + 4 >> 2] | 0 : i8 & 255;
 i7 = i7 ? HEAP32[i2 >> 2] | 0 : i2;
 while (1) {
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i1 + 112 | 0;
  i6 = HEAP8[i4 + 11 >> 0] | 0;
  i2 = i6 << 24 >> 24 < 0;
  if (i2) i5 = HEAP32[i1 + 116 >> 2] | 0; else i5 = i6 & 255;
  if ((i5 | 0) == (i8 | 0)) {
   if (i2) {
    i4 = HEAP32[i4 >> 2] | 0;
    i2 = HEAP32[i1 + 116 >> 2] | 0;
   } else i2 = i6 & 255;
   if (!(_strncmp(i4, i7, i2) | 0)) {
    i2 = 12;
    break;
   }
  }
  i3 = i3 + 4 | 0;
  if ((i3 | 0) == (i9 | 0)) {
   i1 = 0;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN8VRDeviceC2EPK23UnityVRDeviceDefinition(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 189484 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP32[i1 + 296 >> 2] = 0;
 HEAP8[i1 + 300 >> 0] = 1;
 HEAP8[i1 + 301 >> 0] = 0;
 HEAP8[i1 + 302 >> 0] = 1;
 HEAP8[i1 + 303 >> 0] = 0;
 HEAP32[i1 + 304 >> 2] = 0;
 HEAPF32[i1 + 308 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 312 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 316 >> 2] = -1;
 i2 = i1 + 320 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP16[i2 + 8 >> 1] = 0;
 HEAP8[i1 + 330 >> 0] = 1;
 HEAP32[i1 + 364 >> 2] = 0;
 HEAP32[i1 + 368 >> 2] = 0;
 _memset(i1 + 8 | 0, 0, 272) | 0;
 i2 = i1 + 331 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 i2 = i1 + 347 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 __ZN21VRGlobalSettingsState15SaveGlobalStateEv(i1 + 292 | 0);
 return;
}

function __ZN7Texture13ApplySettingsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i3 = i8;
 i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0) | 0;
 if (!(i7 + -1 & i7)) {
  i7 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0) | 0;
  i7 = (i7 + -1 & i7 | 0) != 0;
 } else i7 = 1;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i6 = HEAP32[i2 + 60 >> 2] | 0; else i6 = 0;
 i9 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb(i2 + 32 | 0, i1, i4, i5, i6, i9, i7);
 STACKTOP = i8;
 return;
}

function __ZN5physx7NpScene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE(i6, i1, i2, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!(HEAP8[i6 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE(i6 + 32 | 0, i1, i2, i5);
  return;
 }
 i3 = i1 & 255;
 i4 = i2 & 255;
 if ((i1 & 255) < (i2 & 255)) {
  i2 = i6 + 3096 + (i3 << 2) | 0;
  i1 = 1 << i4;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i1;
  i2 = 1 << i3;
 } else {
  i1 = i6 + 3096 + (i4 << 2) | 0;
  i2 = 1 << i3;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i2;
  i1 = 1 << i4;
 }
 i8 = Math_fround(HEAPF32[i5 >> 2]) != Math_fround(0.0);
 i3 = i6 + 3220 + (i3 << 2) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i8 ? i7 | i1 : i7 & ~i1;
 i3 = Math_fround(HEAPF32[i5 + 4 >> 2]) != Math_fround(0.0);
 i5 = i6 + 3220 + (i4 << 2) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i3 ? i4 | i2 : i4 & ~i2;
 i6 = i6 + 3388 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 8;
 return;
}

function __ZN5physx3Scb5Scene14removeMaterialERNS_2Sc12MaterialCoreE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = i1 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i4 = i6 + 2428 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 + 4 >> 2] = 2;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 i3 = i6 + 2416 | 0;
 i1 = i6 + 2420 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i6 + 2424 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i8 = i5;
  i5 = HEAP32[i8 + 4 >> 2] | 0;
  i6 = (HEAP32[i3 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i6 + 4 >> 2] = i5;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 } else __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sq10AABBPrunerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 101792 + 8;
 __ZN5physx2Sq10AABBPruner7releaseEv(i3);
 i2 = HEAP32[i3 + 7820 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 7812 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i2 = HEAP32[i3 + 7804 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 7796 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 __ZN5physx2Sq11PruningPoolD2Ev(i3 + 7760 | 0);
 __ZN5physx2Sq16BucketPrunerCoreD2Ev(i3 + 144 | 0);
 i1 = i3 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i1 = __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi(i1 + 124 | 0, -1) | 0;
  if (!i1) {
   HEAP32[i4 >> 2] = 36;
   HEAP32[i4 + 4 >> 2] = gb + 860351;
   _printf(gb + 853184 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 36;
   HEAP32[i5 + 4 >> 2] = gb + 860351;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 36;
   STACKTOP = i6;
   return i7 | 0;
  } else {
   HEAP32[i7 >> 2] = HEAP32[i1 + 20 >> 2];
   i7 = 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 860351;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN13UnityProfiler8EndFrameEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 if (i1 | 0) __ZN13UnityProfiler21FinalizeAndStoreFrameEP17ProfilerFrameData(i4, i1);
 if (!(HEAP8[i4 >> 0] | 0)) return;
 i2 = i4 + 72 | 0;
 i1 = i4 + 40 | 0;
 __ZN22UnityProfilerPerThread24AddMiscSamplesAfterFrameEyb(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, 1);
 __ZN22UnityProfilerPerThread8EndFrameEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) i5 = 8; else if (!(HEAP32[(HEAP32[HEAP32[HEAP32[i1 + 16 >> 2] >> 2] >> 2] | 0) + 12 >> 2] | 0)) i5 = 8; else if (!(HEAP8[i1 + 157 >> 0] | 0)) {
  __ZN13UnityProfiler25SaveCurrentFrameRecordingEv(i4) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else i5 = 8;
 if ((i5 | 0) == 8) {
  i5 = i4 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = 0;
 }
 __ZN22UnityProfilerPerThread10ClearFrameEv(i1);
 HEAP8[i4 >> 0] = 0;
 HEAP8[i4 + 2 >> 0] = 0;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer10drawPointsEPKN5physx8debugger8renderer8PvdPointEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i2 + (i1 << 4);
 i8 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 150564 + 8;
 HEAP32[i6 + 4 >> 2] = i8;
 i1 = i3 + 24 | 0;
 i2 = i3 + 20 | 0;
 i7 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i8, i7 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i7 >> 0] = 2;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0, i5 | 0);
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __Z53ParticleSystem_SubEmittersModule_CUSTOM_AddSubEmitterP12Il2CppObjectS0_ii(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622582 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622582 | 0, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZN14ParticleSystem8SyncJobsEb(1);
  i2 = HEAP32[i1 + 916 >> 2] | 0;
  __ZN9SubModule13AddSubEmitterEP14ParticleSystem21ParticleSystemSubTypei(i2, __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0, i4, i5);
  STACKTOP = i6;
  return;
 }
}

function __Z49RenderTexture_CUSTOM_Internal_CreateRenderTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(160, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 570137 | 0, 1457) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 HEAP8[i3 + 121 >> 0] = 1;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return;
}

function __Z38LineRenderer_Get_Custom_PropWidthCurveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i5 = __Znwj(88) | 0;
  i1 = HEAP32[i2 + 344 >> 2] | 0;
  i2 = i5;
  i3 = i1 + 20 | 0;
  i4 = i2 + 56 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_(i5 + 56 | 0, i1 + 76 | 0);
  i4 = i5 + 76 | 0;
  i3 = i1 + 96 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  i4 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z17IntersectRayPlaneRK3RayRK5PlanePf(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, i9 = 0;
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 * f7);
 f8 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f5 + Math_fround(f8 * f3));
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f8 + Math_fround(f5 * f4));
 i9 = f5 < Math_fround(0.0);
 f8 = Math_fround(-f5);
 if ((i9 ? f8 : f5) <= Math_fround(9.99999997e-07)) {
  i9 = 0;
  return i9 | 0;
 }
 f8 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i1 >> 2]));
 f7 = Math_fround(f7 + Math_fround(f3 * Math_fround(HEAPF32[i1 + 4 >> 2])));
 f8 = Math_fround(Math_fround(Math_fround(-Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 8 >> 2])))) - f8) / f5);
 HEAPF32[i6 >> 2] = f8;
 i9 = f8 > Math_fround(0.0);
 return i9 | 0;
}

function __ZZN8Collider15InitializeClassEvEN28FunctorImpl_777kLayerChanged4CallEPviR11MessageData(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 16 | 0;
 i2 = i5;
 i3 = i6 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i4 | 0);
 i4 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i4 | 0);
 i4 = HEAP32[(HEAP32[i6 + 28 >> 2] | 0) + 48 >> 2] | HEAP32[i1 >> 2] & -256;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i2 + 12 >> 2] = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 76 >> 2] | 0, i6 | 0, i1 | 0);
 i6 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 88 >> 2] | 0, i6 | 0, i2 | 0);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9ShaderLab11ShaderState10SetProgramE10ShaderTypePNS_7ProgramEPK6Shader(i2, i3, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 if (!i5) return;
 if (HEAP8[i5 + 204 >> 0] | 0) if (HEAP32[i5 + 20 >> 2] | 0) {
  i1 = HEAP32[i5 + 184 >> 2] | 0;
  if (i1 | 0) {
   i7 = i2 + 700 | 0;
   i4 = HEAP32[i5 + 172 >> 2] | 0;
   __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i7, (HEAP32[i7 >> 2] | 0) + (HEAP32[i2 + 712 >> 2] << 5) | 0, i4, i4 + (i1 << 5) | 0) | 0;
  }
  HEAP32[i2 + 28 + (i3 << 2) >> 2] = i5;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i3 = i5 + 205 | 0;
  HEAP8[i3 >> 0] = 0;
  i4 = HEAP32[i5 + 40 >> 2] | 0;
  if (!i4) return;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  i1 = 0;
  while (1) {
   if (HEAP32[i2 + (i1 << 5) >> 2] & 224 | 0) break;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i4 >>> 0) {
    i6 = 12;
    break;
   }
  }
  if ((i6 | 0) == 12) return;
  HEAP8[i3 >> 0] = 1;
  return;
 }
 HEAP8[i2 + 52 >> 0] = 1;
 return;
}

function __ZN5Umbra8QueryExtC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i4 = i2 + 120 + 15 & -16;
 i5 = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = i5;
 i1 = i5 + (i1 + 102400 - i4) | 0;
 HEAP32[i2 + 44 >> 2] = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = i4;
 HEAP32[i2 + 52 >> 2] = i1 - i4;
 i1 = i2 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = i3;
 HEAP32[i2 + 80 >> 2] = 1;
 HEAP32[i2 + 84 >> 2] = 1;
 HEAP32[i2 + 88 >> 2] = 1;
 HEAP32[i2 + 92 >> 2] = -1;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i2, 0, 0);
 return;
}

function __ZN22BaseUnityConnectClient7ReleaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 284 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) return;
 i2 = i3 + 4 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i4 = i3 + 280 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i1 = i3 + 113 | 0;
   if (!(HEAP8[i1 >> 0] | 0)) {
    HEAP8[i1 >> 0] = 1;
    L8 : do if ((HEAP32[i2 >> 2] | 0) != 5) {
     switch (HEAP32[i2 >> 2] | 0) {
     case 5:
     case 0:
      break L8;
     default:
      {}
     }
     mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0);
    } while (0);
    HEAP8[i1 >> 0] = 0;
    __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE(i3 + 548 | 0, HEAP32[i3 + 544 >> 2] | 0);
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     __ZN19CloudServiceHandler7ReleaseEv(i1);
     HEAP32[i4 >> 2] = 0;
    }
   }
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63800 | 0);
 return;
}

function __ZN21BillboardBatchManager24FillInstanceDataFromNodeERNS_17BillboardInstanceERK15RenderNodeQueueRK18RenderMultipleDataj(i1, i6, i4, i2, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 3) >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i3 + (i5 * 360 | 0) + 328 >> 2] | 0;
 i2 = i1 + 4 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (Math_fround(HEAPF32[i1 + 8 >> 2]) <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 i1 = HEAP32[i3 + (i5 * 360 | 0) + 52 >> 2] | 0;
 i4 = HEAP32[i3 + (i5 * 360 | 0) + 56 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + (i5 * 360 | 0) + 48 >> 2];
 HEAP32[i6 + 8 >> 2] = i1;
 HEAP32[i6 + 12 >> 2] = i4;
 i6 = i6 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN19RuntimeSceneManager24BeginIntegrateMainThreadEP10UnityScene(i10, i1) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i10 + 48 | 0;
 i4 = i10 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i10 + 64 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i2 = i8 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i10 + 52 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i10 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i10 + 52 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i10 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i10;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
 return;
}

function __ZN14SafeBinaryRead4InitERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = i2 + 100 | 0;
 i10 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 i6 = i2 + 88 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i9 = HEAP32[i7 + (i10 << 5) + 12 >> 2] | 0;
 i4 = (HEAP32[i2 + 64 >> 2] | 0) - i9 + (HEAP32[i2 + 68 >> 2] | 0) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i10 = i7 + (i10 << 5) | 0;
 i7 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i1 + 72 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP32[i1 + 64 >> 2] = i9;
 i9 = i2 + 8 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i1 + 68 >> 2] = i4;
 HEAP32[i1 >> 2] = i3;
 i3 = i1 + 132 | 0;
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 16 | 0;
 __ZN12CachedReader8InitReadER15CacheReaderBasejj(i1, HEAP32[i2 + 28 >> 2] | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) + -1 << 5) + 12 >> 2] | 0, i4);
 HEAP32[i3 >> 2] = HEAP32[i2 + 132 >> 2];
 return i1 | 0;
}

function __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_GetKey_InternalP12Il2CppObjectiR16KeyframeTplFloat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 if ((i2 | 0) <= -1) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544438 | 0, i5);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 if ((HEAP32[i1 + 68 >> 2] | 0) > (i2 | 0)) {
  i7 = HEAP32[i1 + 56 >> 2] | 0;
  i1 = HEAP32[i7 + (i2 << 4) + 4 >> 2] | 0;
  i4 = HEAP32[i7 + (i2 << 4) + 8 >> 2] | 0;
  i5 = HEAP32[i7 + (i2 << 4) + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i7 + (i2 << 4) >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = i4;
  HEAP32[i3 + 12 >> 2] = i5;
  STACKTOP = i6;
  return;
 } else __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544438 | 0, i5);
}

function __Z20GetPlatformCachePathv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 __ZN10systeminfo21GetPersistentDataPathEv(i2);
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i5 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 444170 | 0, 10);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 }
}

function __Z15GetFlareManagerv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1110296 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = HEAP32[gb + 1110296 + 12 >> 2] | 0;
 if (!(HEAP8[gb + 1110296 + 16 >> 0] | 0)) {
  i1 = __ZnwjRK10MemLabelIdiPKci(28, gb + 1110296 + 4 | 0, i1, gb + 1041912 | 0, 65) | 0;
  i2 = i1 + 4 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i2;
  i2 = i1 + 12 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[gb + 1110296 >> 2] = i1;
  return i1 | 0;
 } else {
  i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, gb + 1110296 + 4 | 0, i1, gb + 1110296 + 16 | 0, gb + 1110296 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i1 = i2 + 4 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
  i1 = i2 + 12 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[gb + 1110296 >> 2] = i2;
  return i2 | 0;
 }
 return 0;
}

function _sift(i3, i10, i7, i1, i8) {
 i3 = i3 | 0;
 i10 = i10 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 HEAP32[i11 >> 2] = i3;
 L1 : do if ((i1 | 0) > 1) {
  i9 = 0 - i10 | 0;
  i2 = i3;
  i6 = i1;
  i1 = 1;
  while (1) {
   i4 = i2 + i9 | 0;
   i5 = i6 + -2 | 0;
   i2 = i4 + (0 - (HEAP32[i8 + (i5 << 2) >> 2] | 0)) | 0;
   if ((mftCall_iii(i7 | 0, i3 | 0, i2 | 0) | 0) > -1) if ((mftCall_iii(i7 | 0, i3 | 0, i4 | 0) | 0) > -1) break L1;
   i3 = i1 + 1 | 0;
   i1 = i11 + (i1 << 2) | 0;
   if ((mftCall_iii(i7 | 0, i2 | 0, i4 | 0) | 0) > -1) {
    HEAP32[i1 >> 2] = i2;
    i1 = i6 + -1 | 0;
   } else {
    HEAP32[i1 >> 2] = i4;
    i2 = i4;
    i1 = i5;
   }
   if ((i1 | 0) <= 1) {
    i1 = i3;
    break L1;
   }
   i6 = i1;
   i1 = i3;
   i3 = HEAP32[i11 >> 2] | 0;
  }
 } else i1 = 1; while (0);
 _cycle(i10, i11, i1);
 STACKTOP = i12;
 return;
}

function __ZN8keywords18KeywordSetToStringERK16ShaderKeywordSetR8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE(i1, i3);
 __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr(i3, i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i6 = i2 + -12 | 0;
   HEAP32[i4 >> 2] = i6;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN5physx7NpCloth26setCentrifugalInertiaScaleENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore26setCentrifugalInertiaScaleENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 655, gb + 697407 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc5Scene20initContactsIteratorERNS0_15ContactIteratorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i2 = HEAP32[i2 + 1204 >> 2] | 0;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = i4 + (HEAP32[i2 + 88 >> 2] << 2) | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 16 | 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i2 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 i2 = i1 + 88 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 120 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 148 >> 2] = 0;
 return;
}

function __ZN5UmbramlERKNS_9Matrix2x2ES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i2 = i1 + 8 | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f5 * f9);
 f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f6 + Math_fround(f7 * f8));
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f5 * f6);
 f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(f5 + Math_fround(f7 * f4));
 i2 = i1 + 4 | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i1 + 12 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(f7 * f9) + Math_fround(f5 * f8));
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(f7 * f6) + Math_fround(f5 * f4));
 return;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i1);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i1, i6 + 220 | 0, gb + 1047683 | 0, 0);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i2, 4);
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 HEAP32[i6 + 232 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN15SkyboxGenerator28GetCubemapSkyboxVertexFormatEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 32 | 0;
 i5 = i6;
 i1 = HEAP32[gb + 1114344 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = i4;
 i2 = gb + 1546313 | 0;
 i3 = i1 + 16 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP8[i4 + 7 >> 0] = 3;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i5 + 24 >> 2] = 0;
 HEAP32[i5 + 28 >> 2] = 0;
 __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(13, i4, i5) | 0;
 i5 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(__Z26GetMeshVertexFormatManagerv() | 0, i5) | 0;
 HEAP32[gb + 1114344 >> 2] = i5;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14TimerQueryGLES12MeasureBeginEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 1) | 0;
 getTempRet0() | 0;
 mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 784 >> 2] | 0, 35007, HEAP32[i2 + 16 >> 2] | 0);
 HEAP32[gb + 1098256 + 560 >> 2] = (HEAP32[gb + 1098256 + 560 >> 2] | 0) + 1;
 i3 = i2 + 4 | 0;
 if ((i3 | 0) == (gb + 1098256 + 544 | 0)) {
  i3 = i2 + 24 | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = -1;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = -1;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i2 + 8 | 0; else {
  i4 = i2 + 8 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[gb + 1098256 + 544 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = gb + 1098256 + 544;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 i4 = i2 + 24 | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = -1;
 i4 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = -1;
 return;
}

function _UNITY_FT_Property_Get(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 if (!i2) {
  i5 = 33;
  return i5 | 0;
 }
 if (!((i3 | 0) != 0 & (i4 | 0) != 0 & (i5 | 0) != 0)) {
  i5 = 6;
  return i5 | 0;
 }
 i1 = i2 + 20 | 0;
 i6 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = i2 + 20 + (i6 << 2) | 0;
 L7 : do if ((i6 | 0) > 0) while (1) {
  if (!(_strcmp(HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + 8 >> 2] | 0, i3) | 0)) {
   i3 = i1;
   break L7;
  }
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i3 = i1;
   break;
  }
 } else i3 = i1; while (0);
 if ((i3 | 0) == (i2 | 0)) {
  i6 = 11;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i2) {
  i6 = 7;
  return i6 | 0;
 }
 i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008162 | 0) | 0;
 if (!i1) {
  i6 = 7;
  return i6 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i6 = 7;
  return i6 | 0;
 }
 i6 = mftCall_iiii(i1 | 0, HEAP32[i3 >> 2] | 0, i4 | 0, i5 | 0) | 0;
 return i6 | 0;
}

function __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 833768;
 HEAP32[i1 + 4 >> 2] = 541;
 HEAP32[i1 + 8 >> 2] = fb + 629;
 HEAP32[i1 + 12 >> 2] = fb + 544;
 HEAP32[i1 + 16 >> 2] = gb + 833784;
 HEAP32[i1 + 20 >> 2] = 542;
 HEAP32[i1 + 24 >> 2] = fb + 630;
 HEAP32[i1 + 28 >> 2] = fb + 545;
 HEAP32[i1 + 32 >> 2] = gb + 833805;
 HEAP32[i1 + 36 >> 2] = 543;
 HEAP32[i1 + 40 >> 2] = fb + 631;
 HEAP32[i1 + 44 >> 2] = fb + 546;
 HEAP32[i1 + 48 >> 2] = gb + 833825;
 HEAP32[i1 + 52 >> 2] = 544;
 HEAP32[i1 + 56 >> 2] = fb + 632;
 HEAP32[i1 + 60 >> 2] = fb + 547;
 HEAP32[i1 + 64 >> 2] = gb + 833837;
 HEAP32[i1 + 68 >> 2] = 545;
 HEAP32[i1 + 72 >> 2] = fb + 633;
 HEAP32[i1 + 76 >> 2] = fb + 548;
 HEAP32[i1 + 80 >> 2] = gb + 833848;
 HEAP32[i1 + 84 >> 2] = 546;
 HEAP32[i1 + 88 >> 2] = fb + 634;
 HEAP32[i1 + 92 >> 2] = fb + 549;
 HEAP32[i1 + 96 >> 2] = gb + 831311;
 HEAP32[i1 + 100 >> 2] = 547;
 HEAP32[i1 + 104 >> 2] = fb + 2405;
 HEAP32[i1 + 108 >> 2] = fb + 3936;
 return;
}

function __ZN26AnimatorControllerPlayable10GetIntegerEiRi(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 180 >> 2] | 0, i4 | 0) | 0)) {
  i3 = 0;
  i4 = 8;
  HEAP32[i5 >> 2] = i3;
  return i4 | 0;
 }
 i3 = i4 + 92 | 0;
 i6 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i2 | 0) == 0 ? 0 : i6 + i2 | 0, i1) | 0;
 if ((i2 | 0) == -1) {
  i4 = 0;
  i6 = 4;
  HEAP32[i5 >> 2] = i4;
  return i6 | 0;
 }
 i1 = (HEAP32[i3 >> 2] | 0) + 16 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) | 0;
 if ((HEAP32[i1 + (i2 * 12 | 0) + 4 >> 2] | 0) != 3) {
  i4 = 0;
  i6 = 2;
  HEAP32[i5 >> 2] = i4;
  return i6 | 0;
 }
 i4 = (HEAP32[i4 + 100 >> 2] | 0) + 16 | 0;
 i4 = i4 + (HEAP32[i4 >> 2] | 0) + 36 | 0;
 i4 = HEAP32[i4 + (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 + (i2 * 12 | 0) + 8 >> 2] << 2) >> 2] | 0;
 i6 = 1;
 HEAP32[i5 >> 2] = i4;
 return i6 | 0;
}

function __ZN20OcclusionCullingData7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, i1, 16, gb + 1048932 | 0, 0, gb + 380398 | 0, 41) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 34876 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i4 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13dynamic_arrayIN2UI13UIInstructionELj4EE19push_back_constructEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = i2 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i2 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i1 = i7 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i8 >>> 0 < i1 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, i1 * 672 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 * 672 | 0, 4, i2 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i3 >> 2] | 0) * 672 | 0) | 0;
   HEAP32[i6 >> 2] = i1;
   HEAP32[i2 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 i8 = (HEAP32[i2 >> 2] | 0) + (i4 * 672 | 0) | 0;
 __ZN2UI13UIInstructionC2Ev(i8);
 return i8 | 0;
}

function __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i3 = i4;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 HEAP32[i5 >> 2] = HEAP32[i1 + 36 >> 2];
 __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i1, i3, 0);
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i5 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI18StreamedBinaryReadILb1EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i5, HEAP32[i1 + 56 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i3 = i4;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 HEAP32[i5 >> 2] = HEAP32[i1 + 36 >> 2];
 __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i5, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 40 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i1, i3, 0);
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i5 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI18StreamedBinaryReadILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i5, HEAP32[i1 + 56 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer9drawLinesEPKN5physx8debugger8renderer7PvdLineEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i2 + (i1 << 5);
 i8 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 150564 + 8;
 HEAP32[i6 + 4 >> 2] = i8;
 i1 = i3 + 24 | 0;
 i2 = i3 + 20 | 0;
 i7 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i8, i7 + 1 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i2 >> 2] | 0) + i7 >> 0] = 3;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0, i5 | 0);
 if (((HEAP32[i1 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) >>> 0 < (HEAP32[i3 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __Z3md5PhiS_(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 1732584193;
 HEAP32[i8 + 12 >> 2] = -271733879;
 HEAP32[i8 + 16 >> 2] = -1732584194;
 HEAP32[i8 + 20 >> 2] = 271733878;
 if ((i1 | 0) < 1) {
  __Z10md5_finishP11md5_contextPh(i8, i7);
  STACKTOP = i9;
  return;
 }
 HEAP32[i8 >> 2] = i1;
 if ((i1 | 0) > 63) {
  i4 = i1 + -64 | 0;
  i5 = i4 & -64;
  i6 = i5 + 64 | 0;
  i3 = i2;
  while (1) {
   __ZL11md5_processP11md5_contextPh(i8, i3);
   i1 = i1 + -64 | 0;
   if ((i1 | 0) <= 63) break; else i3 = i3 + 64 | 0;
  }
  i1 = i4 - i5 | 0;
  if ((i1 | 0) > 0) i2 = i2 + i6 | 0; else {
   __Z10md5_finishP11md5_contextPh(i8, i7);
   STACKTOP = i9;
   return;
  }
 }
 _memcpy(i8 + 24 | 0, i2 | 0, i1 | 0) | 0;
 __Z10md5_finishP11md5_contextPh(i8, i7);
 STACKTOP = i9;
 return;
}

function __ZNK15RelativeJoint2D9GetTargetEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 } else {
  i2 = __ZNK7Joint2D10FetchBodyBEv(i2) | 0;
  f6 = Math_fround(HEAPF32[i2 + 56 >> 2]);
  f6 = Math_fround(f6 - Math_fround(__ZNK12b2MotorJoint16GetAngularOffsetEv(i3)));
  f8 = Math_fround(+Math_sin(+f6));
  f6 = Math_fround(+Math_cos(+f6));
  i3 = __ZNK12b2MotorJoint15GetLinearOffsetEv(i3) | 0;
  f7 = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
  f4 = Math_fround(-Math_fround(HEAPF32[i3 + 4 >> 2]));
  f5 = Math_fround(Math_fround(f6 * f7) - Math_fround(f8 * f4));
  f4 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f4));
  f5 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f5);
  f4 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) + f4);
  HEAPF32[i1 >> 2] = f5;
  HEAPF32[i1 + 4 >> 2] = f4;
  return;
 }
}

function __ZNK12NavMeshAgent14DistanceToEdgeEP10NavMeshHit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 68 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844773 | 0, 0, gb + 841797 | 0, 642, 1, 0, 0, 0);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i1 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
  i4 = __ZNK7dtCrowd14getAgentFilterEi(i1, HEAP32[i4 >> 2] | 0) | 0;
  i4 = __ZN14NavMeshManager14DistanceToEdgeEP10NavMeshHitRK8Vector3fRK13dtQueryFilter(__Z17GetNavMeshManagerv() | 0, i2, i3, i4) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingIydE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = i1;
  i5 = i3;
  i3 = i3 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = +((HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24) >>> 0) + 4294967296.0 * +((HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24) >>> 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i5, i3, i1, i4, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP16[i5 + 4 >> 1] = 10;
 HEAP16[i5 + 6 >> 1] = 3;
 i8 = i5 + 8 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 94100 + 8;
 __ZN5physx7NpActorC2EPKc(i5 + 12 | 0, 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i5 >> 2] = gb + 94588 + 8;
 HEAP16[i7 >> 1] = HEAP16[i2 >> 1] | 0;
 __ZN5physx3Scb5ClothC2ERKNS_11PxTransformERNS_2Sc15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i5 + 20 | 0, i3, i1 + 16 | 0, i4, i7);
 HEAP32[i5 + 124 >> 2] = i1;
 HEAP32[i5 + 128 >> 2] = gb + 95092 + 8;
 HEAP32[i5 + 140 >> 2] = i5;
 HEAP32[i5 + 144 >> 2] = 0;
 HEAP8[i5 + 148 >> 0] = 1;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 12 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx7NpCloth25setAngularDragCoefficientENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore25setAngularDragCoefficientENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 735, gb + 696735 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx27solveConcludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, 0);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i7 = HEAP16[i1 + 2 >> 1] | 0;
 i8 = i1 + (i7 & 65535) | 0;
 if (!(i7 << 16 >> 16)) return;
 do {
  i3 = i1 + 48 | 0;
  i2 = HEAP8[i1 + 1 >> 0] | 0;
  i7 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) i1 = i3; else {
   i6 = i2 & 255;
   i5 = 0;
   while (1) {
    i2 = i3 + 32 | 0;
    f4 = Math_fround(HEAPF32[i2 >> 2]);
    i9 = f4 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i9 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + i7 | 0;
   }
   i1 = i1 + ((Math_imul(i7, i6) | 0) + 48) | 0;
  }
 } while (i1 >>> 0 < i8 >>> 0);
 return;
}

function __ZN5Umbra5QueryC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i4 = i2 + 120 + 15 & -16;
 i5 = i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = i5;
 i1 = i5 + (i1 + 102400 - i4) | 0;
 HEAP32[i2 + 44 >> 2] = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = i4;
 HEAP32[i2 + 52 >> 2] = i1 - i4;
 i1 = i2 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = i3;
 HEAP32[i2 + 80 >> 2] = 1;
 HEAP32[i2 + 84 >> 2] = 1;
 HEAP32[i2 + 88 >> 2] = 1;
 HEAP32[i2 + 92 >> 2] = -1;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE(i2, 0, 0);
 return;
}

function __ZN27ColorModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 152 >> 0] | 0);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 153 >> 0] | 0);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 154 >> 0] | 0);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 155 >> 0] | 0);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 156 >> 0] | 0);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 157 >> 0] | 0);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 158 >> 0] | 0);
   break;
  }
 case 7:
  {
   f1 = Math_fround(HEAPU8[(HEAP32[i3 + 860 >> 2] | 0) + 159 >> 0] | 0);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN19SkinnedMeshRenderer22CreateSkinMatricesTaskEP10Matrix4x4fjbb(i4, i7, i5, i6, i8) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 396 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) == 0 | (HEAP32[gb + 1162104 >> 2] | 0) == 0) {
  i8 = 0;
  return i8 | 0;
 }
 i3 = __ZnwjRK10MemLabelIdiPKci(28, gb + 64024 | 0, 16, gb + 429036 | 0, 351) | 0;
 i2 = i4 + 408 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 384 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAPU16[i4 + 404 >> 1];
 HEAP32[i3 + 12 >> 2] = i5;
 if (i6) i1 = __ZN4Mesh21AcquireSharedMeshDataEv(HEAP32[i4 + 356 >> 2] | 0) | 0; else i1 = 0;
 HEAP32[i3 + 16 >> 2] = i1;
 HEAP8[i3 + 20 >> 0] = i8 & 1;
 HEAP32[i3 + 24 >> 2] = i7;
 i8 = i3;
 return i8 | 0;
}

function __ZN18AssetBundleManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i2 + 144 | 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev(i2 + 68 | 0);
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 i4 = i2 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i3 = i2 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i5 = i2 + -8 | 0;
   HEAP32[i3 >> 2] = i5;
   __ZN14ConstantStringD2Ev(i5);
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 return;
}

function __ZN16StreamedResource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i1, i6, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i1);
 i2 = i6 + 16 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 8 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 8);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  i8 = i5;
  i1 = HEAP32[i8 + 4 >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 24 | 0;
 i2 = i4 + 8 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 8);
  return;
 } else {
  i5 = i4;
  i6 = HEAP32[i5 + 4 >> 2] | 0;
  i8 = i1;
  HEAP32[i8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 + 4 >> 2] = i6;
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1 + 44 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1 + 28 | 0, 0);
 __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, i3);
 if (!i4) {
  STACKTOP = i3;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return;
}

function __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1 + 44 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags(i2, i1 + 28 | 0, 0);
 __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0, i3);
 if (!i4) {
  STACKTOP = i3;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return;
}

function __ZL30FindScriptingClassForClassNamePKc(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66600 >> 2] | 0, i2) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66604 >> 2] | 0, i2) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66608 >> 2] | 0, i2) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66612 >> 2] | 0, i2) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66616 >> 2] | 0, i2) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i2 = __Z29scripting_class_from_fullnamePKcS0_S0_(HEAP32[gb + 66596 >> 2] | 0, HEAP32[gb + 66620 >> 2] | 0, i2) | 0;
 return i2 | 0;
}

function __Z61AnimatorOverrideController_CUSTOM_Internal_CreateAnimationSetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(152, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 928155 | 0, 21) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN26AnimatorOverrideControllerC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return;
}

function __Z54DirectorPlayer_CUSTOM_INTERNAL_CALL_PlayStructInternalP12Il2CppObjectRK9HPlayable(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i3 = i6;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 511946 | 0, i6 + 8 | 0);
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 164 >> 2] | 0;
  i8 = i2;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  mftCall_viii(i1 | 0, i4 | 0, i5 | 0, 0);
  STACKTOP = i6;
  return;
 }
}

function __Z46Camera_CUSTOM_INTERNAL_CALL_ViewportPointToRayP12Il2CppObjectRK8Vector3fR3Ray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  __ZNK6Camera18ViewportPointToRayERK8Vector2f(i4, i6, i5);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  STACKTOP = i7;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIjhEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIjaEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIihEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIiaEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  i7 = i7 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 i7 = i7 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z24InvokeOnWillRenderObjectRK13dynamic_arrayIP12BaseRendererLj4EE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 __ZN13RendererScene27SetPreventAddRemoveRendererEb(__Z16GetRendererScenev() | 0, 1);
 i4 = i2 + 12 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i6 = __Z16GetRendererScenev() | 0;
  __ZN13RendererScene27SetPreventAddRemoveRendererEb(i6, 0);
  STACKTOP = i7;
  return;
 }
 i5 = i3 + 4 | 0;
 i6 = i3 + 8 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData((i8 | 0) == 0 ? 0 : i8 + -32 | 0, gb + 1105336 | 0, i3);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 i8 = __Z16GetRendererScenev() | 0;
 __ZN13RendererScene27SetPreventAddRemoveRendererEb(i8, 0);
 STACKTOP = i7;
 return;
}

function __Z17IntersectAABBAABBRK4AABBS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 i8 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (!((i8 ? f7 : f6) < Math_fround(f5 + Math_fround(HEAPF32[i2 + 12 >> 2])))) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = f4 < Math_fround(0.0);
 f6 = Math_fround(-f4);
 f7 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (!((i8 ? f6 : f4) < Math_fround(f7 + Math_fround(HEAPF32[i2 + 16 >> 2])))) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = f3 < Math_fround(0.0);
 f6 = Math_fround(-f3);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i8 = (i8 ? f6 : f3) < Math_fround(f7 + Math_fround(HEAPF32[i2 + 20 >> 2]));
 return i8 | 0;
}

function _jpeg_calc_output_dimensions(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i1 | 0) != 202) {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i2 | 0);
 }
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i2 + 92 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i2 + 96 >> 2] = i1;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 switch (i1 | 0) {
 case 1:
  {
   HEAP32[i2 + 100 >> 2] = 1;
   i1 = 1;
   break;
  }
 case 15:
 case 14:
 case 13:
 case 12:
 case 11:
 case 10:
 case 9:
 case 8:
 case 7:
 case 6:
 case 2:
  {
   i1 = HEAP32[gb + 16264 + (i1 << 2) >> 2] | 0;
   HEAP32[i2 + 100 >> 2] = i1;
   break;
  }
 case 3:
  {
   HEAP32[i2 + 100 >> 2] = 3;
   i1 = 3;
   break;
  }
 case 5:
 case 4:
  {
   HEAP32[i2 + 100 >> 2] = 4;
   i1 = 4;
   break;
  }
 default:
  {
   i1 = HEAP32[i2 + 36 >> 2] | 0;
   HEAP32[i2 + 100 >> 2] = i1;
  }
 }
 HEAP32[i2 + 104 >> 2] = (HEAP8[i2 + 74 >> 0] | 0) == 0 ? i1 : 1;
 HEAP32[i2 + 108 >> 2] = 1;
 return;
}

function __ZN5physx2Sc7BodySim25notifyNotReadyForSleepingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
 i1 = i1 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 i6 = i3 + (i2 * 12 | 0) + 8 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i5 & 255 | 8;
 if (i5 & 8) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i6 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i2 & 31);
 i1 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] & 64) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = 1 << (i1 & 31);
 if (!(i3 & i1)) {
  HEAP32[i2 >> 2] = i3 | i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 } else {
  HEAP32[i2 >> 2] = i3 & ~i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
}

function __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 1034892 | 0, gb + 1034905 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 1034921 | 0, HEAP32[gb + 36980 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN12AdsIdHandler13SetStateErrorER8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i5 + 44 >> 2] = 1;
 i7 = i5 + 20 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 28 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 24 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 24 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZL12InvokeMethodI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 57 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z24PluginsSetGraphicsDevicePvi18GfxDeviceEventType(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i7) HEAP32[gb + 65704 >> 2] = i6;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 39368 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = i2 + 38600 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 38600 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i4 >> 2] | 0, i7 | 0); else mftCall_vii(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 38600 + (i1 * 12 | 0) + 4 >> 2] | 0, i7 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[gb + 1162584 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) return; else i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 * 24 | 0) + 4 >> 2] | 0;
  if (i2) {
   mftCall_viii(i2 | 0, i5 | 0, i6 | 0, i7 | 0);
   i1 = HEAP32[gb + 1162584 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) / 24 | 0) >>> 0);
 return;
}

function _UNITY_FT_Outline_Get_CBox(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!((i1 | 0) != 0 & (i9 | 0) != 0)) return;
 i2 = HEAP16[i1 + 2 >> 1] | 0;
 if (!(i2 << 16 >> 16)) {
  i3 = 0;
  i4 = 0;
  i2 = 0;
  i1 = 0;
 } else {
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i8 = i5 + (i2 << 16 >> 16 << 3) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if (i2 << 16 >> 16 > 1) {
   i4 = i1;
   i2 = i6;
   i7 = i5 + 8 | 0;
   i3 = i6;
   while (1) {
    i6 = HEAP32[i7 >> 2] | 0;
    i3 = (i6 | 0) < (i3 | 0) ? i6 : i3;
    i2 = (i6 | 0) > (i2 | 0) ? i6 : i2;
    i5 = HEAP32[i5 + 12 >> 2] | 0;
    i4 = (i5 | 0) < (i4 | 0) ? i5 : i4;
    i1 = (i5 | 0) > (i1 | 0) ? i5 : i1;
    i5 = i7 + 8 | 0;
    if (i5 >>> 0 < i8 >>> 0) {
     i6 = i7;
     i7 = i5;
     i5 = i6;
    } else break;
   }
  } else {
   i3 = i6;
   i4 = i1;
   i2 = i6;
  }
 }
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i9 + 12 >> 2] = i1;
 return;
}

function _jpeg_CreateDecompress(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 if ((i1 | 0) != 62) {
  i4 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 12;
  HEAP32[i4 + 24 >> 2] = 62;
  HEAP32[i4 + 28 >> 2] = i1;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i3 | 0);
 }
 if ((i2 | 0) == 432) i1 = i3; else {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 21;
  HEAP32[i1 + 24 >> 2] = 432;
  HEAP32[i1 + 28 >> 2] = i2;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i3 | 0);
  i1 = i3;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = i3 + 12 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 _memset(i3 + 4 | 0, 0, 428) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i2 >> 2] = i4;
 HEAP8[i3 + 16 >> 0] = 1;
 _jinit_memory_mgr(i1);
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 268 >> 2] = 0;
 i1 = i3 + 144 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 _jinit_marker_reader(i3);
 _jinit_input_controller(i3);
 HEAP32[i3 + 20 >> 2] = 200;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 77;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK12NavMeshAgent11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 12 | 0;
 i4 = i6;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  __ZNK9Transform11GetPositionEv(i1, i5);
  STACKTOP = i6;
  return;
 } else {
  i8 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0) | 0;
  HEAP32[i3 >> 2] = HEAP32[i8 + 480 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i8 + 484 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i8 + 488 >> 2];
  f7 = Math_fround(-Math_fround(HEAPF32[i2 + 44 >> 2]));
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = f7;
  HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
  __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_(i1, i5, i3, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx7NpCloth24setLinearDragCoefficientENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore24setLinearDragCoefficientENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 715, gb + 696906 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc7BodySim22notifyReadyForSleepingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
 i1 = i1 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 i6 = i3 + (i2 * 12 | 0) + 8 | 0;
 i5 = HEAP8[i6 >> 0] | 0;
 HEAP8[i6 >> 0] = i5 & 247;
 if (!(i5 & 8)) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i6 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~(1 << (i2 & 31));
 i1 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] & 64) {
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
 i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = 1 << (i1 & 31);
 if (!(i3 & i1)) {
  HEAP32[i2 >> 2] = i3 | i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 } else {
  HEAP32[i2 >> 2] = i3 & ~i1;
  i6 = i4 + 477 | 0;
  HEAP8[i6 >> 0] = 1;
  return;
 }
}

function __ZN17Physics2DSettings10SetGravityERK8Vector2f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i2 + 32 | 0;
 i6 = i1;
 i7 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = (HEAP32[gb + 1458412 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 102972 >> 2] = i7;
 HEAP32[i5 + 102976 >> 2] = i6;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 if (f4 == Math_fround(HEAPF32[gb + 1162356 >> 2])) {
  f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
  if (f4 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) return;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 102956 >> 2] | 0;
 if (!i1) return;
 do {
  if ((HEAP32[i1 >> 2] | 0) == 2) if (Math_fround(HEAPF32[i1 + 140 >> 2]) != Math_fround(0.0)) {
   i2 = i1 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(i3 & 2)) {
    HEAP16[i2 >> 1] = i3 | 2;
    HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   }
  }
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN17ArchiveFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 12 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i2, _strlen(i2) | 0);
 __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i5, i1, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 STACKTOP = i4;
 return (HEAP32[i5 + 4 >> 2] | 0) != 0 | 0;
}

function __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i3, i1, i2, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 8 | 0;
 i9 = i1;
 i2 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, i9);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i3 + 16 | 0;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i3 + 40 >> 2] = i7;
 i7 = i3 + 44 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = (i4 | 0) < 4 ? 4 : i4;
 HEAP32[i3 >> 2] = i7;
 i6 = i5 + 4095 & -4096;
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i3 + 8 >> 2] = (i6 >>> 0) / (i7 >>> 0) | 0;
 HEAP8[i3 + 36 >> 0] = 1;
 HEAP32[i3 + 32 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZL12InvokeMethodI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 56 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZL12InvokeMethodI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 56 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z39Texture2D_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiRK10ColorRGBAf(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = HEAP8[i1 + 111 >> 0] | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (!(i2 << 24 >> 24)) {
  HEAP32[i7 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i7);
 } else {
  __ZN9Texture2D8SetPixelEiiiRK10ColorRGBAf(i1, 0, i4, i5, i6);
  STACKTOP = i8;
  return;
 }
}

function __Z30GenerateDoubleIntegrationCacheR15PolynomialCurve(i4) {
 i4 = i4 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i5 = 0, f6 = f0, f7 = f0, i8 = 0;
 i5 = i4 + 224 | 0;
 if ((HEAP32[i5 >> 2] | 0) > 0) {
  f1 = Math_fround(0.0);
  f2 = Math_fround(0.0);
  i3 = 0;
 } else return;
 do {
  HEAPF32[i4 + 160 + (i3 << 2) >> 2] = f2;
  f7 = f1;
  f1 = Math_fround(HEAPF32[i4 + 192 + (i3 << 2) >> 2]);
  f7 = Math_fround(f1 - f7);
  i8 = f7 < Math_fround(0.0);
  f7 = i8 ? Math_fround(0.0) : f7;
  f6 = Math_fround(f7 * Math_fround(HEAPF32[i4 + (i3 << 4) >> 2]));
  f6 = Math_fround(f7 * Math_fround(f6 + Math_fround(HEAPF32[i4 + (i3 << 4) + 4 >> 2])));
  f6 = Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i4 + (i3 << 4) + 8 >> 2]) + f6));
  f6 = Math_fround(f7 * Math_fround(f7 * Math_fround(Math_fround(HEAPF32[i4 + (i3 << 4) + 12 >> 2]) + f6)));
  f2 = Math_fround(f2 + Math_fround(Math_fround(f7 * Math_fround(HEAPF32[i4 + 128 + (i3 << 2) >> 2])) + f6));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (HEAP32[i5 >> 2] | 0));
 return;
}

function __Z16SelectDataFolderv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[gb + 1450972 >> 2] | 0;
 if (i3 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3);
  STACKTOP = i4;
  return;
 }
 i3 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63680 | 0, 16, gb + 583930 | 0, 129) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[gb + 1450972 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i3 = HEAP32[gb + 1450972 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3);
 STACKTOP = i4;
 return;
}

function _UNITY_FT_Property_Set(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 if (!i2) {
  i5 = 33;
  return i5 | 0;
 }
 if (!((i3 | 0) != 0 & (i4 | 0) != 0 & (i5 | 0) != 0)) {
  i5 = 6;
  return i5 | 0;
 }
 i1 = i2 + 20 | 0;
 i6 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = i2 + 20 + (i6 << 2) | 0;
 L7 : do if ((i6 | 0) > 0) while (1) {
  if (!(_strcmp(HEAP32[(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + 8 >> 2] | 0, i3) | 0)) {
   i3 = i1;
   break L7;
  }
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i3 = i1;
   break;
  }
 } else i3 = i1; while (0);
 if ((i3 | 0) == (i2 | 0)) {
  i6 = 11;
  return i6 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i2) {
  i6 = 7;
  return i6 | 0;
 }
 i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008162 | 0) | 0;
 if (!i1) {
  i6 = 7;
  return i6 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i6 = 7;
  return i6 | 0;
 }
 i6 = mftCall_iiii(i1 | 0, HEAP32[i3 >> 2] | 0, i4 | 0, i5 | 0) | 0;
 return i6 | 0;
}

function __ZNSt3__28ios_base17register_callbackEPFvNS0_5eventERS0_iEi(i7, i8, i9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0;
 i10 = i7 + 40 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 i2 = i1 + 1 | 0;
 i6 = i7 + 44 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  i5 = i3 << 1;
  i5 = i2 >>> 0 < 536870911 ? (i5 >>> 0 < i2 >>> 0 ? i2 : i5) : 1073741823;
  i2 = i7 + 32 | 0;
  i4 = i5 << 2;
  i1 = _realloc(HEAP32[i2 >> 2] | 0, i4) | 0;
  if (!i1) __ZNSt3__28ios_base5clearEj(i7, HEAP32[i7 + 16 >> 2] | 1);
  HEAP32[i2 >> 2] = i1;
  i3 = i7 + 36 | 0;
  i1 = _realloc(HEAP32[i3 >> 2] | 0, i4) | 0;
  if (!i1) __ZNSt3__28ios_base5clearEj(i7, HEAP32[i7 + 16 >> 2] | 1);
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 >> 2] = i5;
  i1 = HEAP32[i10 >> 2] | 0;
 } else {
  i3 = i7 + 36 | 0;
  i2 = i7 + 32 | 0;
 }
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i8;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = i9;
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 return;
}

function __ZNK5physx3Ext13RevoluteJoint8getAngleEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, f4 = f0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, i2 | 0);
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 if (f4 != Math_fround(0.0)) {
  f1 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f1 = Math_fround(f1 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(0.0)) + Math_fround(f1 * f1))))));
 } else f1 = Math_fround(1.0);
 i3 = f1 < Math_fround(-1.0);
 f1 = i3 ? Math_fround(-1.0) : f1;
 i3 = f1 > Math_fround(1.0);
 f1 = Math_fround(Math_fround(+Math_acos(+(i3 ? Math_fround(1.0) : f1))) * Math_fround(2.0));
 i3 = f4 < Math_fround(0.0);
 f4 = Math_fround(Math_fround(6.28318548) - f1);
 f4 = i3 ? f4 : f1;
 i3 = f4 > Math_fround(3.14159274);
 f1 = Math_fround(f4 + Math_fround(-6.28318548));
 STACKTOP = i5;
 return Math_fround(i3 ? f1 : f4);
}

function __ZN5physx9NpFactory8addClothEPNS_7PxClothEb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 4 | 0;
 i4 = i8;
 i5 = i3 + 564 | 0;
 HEAP32[i4 >> 2] = i1;
 i6 = i1;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if (i2) {
  i2 = i3 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i8;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i5, i4, i7) | 0;
  if (!(HEAP8[i7 >> 0] | 0)) HEAP32[i1 >> 2] = i6;
  STACKTOP = i8;
  return;
 }
}

function __ZN15OcclusionPortalC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 35128 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i1;
 HEAP8[i1 + 72 >> 0] = 1;
 HEAP32[i1 + 68 >> 2] = -1;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 STACKTOP = i4;
 return;
}

function __ZN14b2CapsuleShape13SetByExtentsXEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 HEAPF32[i1 + 8 >> 2] = f2;
 f4 = Math_fround(f3 * Math_fround(.5));
 f3 = Math_fround(-f4);
 HEAPF32[i1 + 12 >> 2] = f3;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 4;
 f5 = Math_fround(-f2);
 HEAPF32[i1 + 48 >> 2] = f3;
 HEAPF32[i1 + 52 >> 2] = f5;
 HEAPF32[i1 + 56 >> 2] = f4;
 HEAPF32[i1 + 60 >> 2] = f5;
 HEAPF32[i1 + 64 >> 2] = f4;
 HEAPF32[i1 + 68 >> 2] = f2;
 HEAPF32[i1 + 72 >> 2] = f3;
 HEAPF32[i1 + 76 >> 2] = f2;
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 120 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 128 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 136 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 140 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __Z30ComputeShader_CUSTOM_SetBufferP12Il2CppObjectiiS0_(i1, i5, i2, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10 + 12 | 0;
 i9 = i10;
 i6 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 HEAP32[i6 >> 2] = i2;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9); else {
  HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  __ZN13ComputeShader14SetBufferParamEjRKN9ShaderLab16FastPropertyNameE15ComputeBufferID(i8, i5, i6, i4) | 0;
  STACKTOP = i10;
  return;
 }
}

function __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i1);
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i4 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i6 = i2 + -12 | 0;
   HEAP32[i3 >> 2] = i6;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
   i2 = HEAP32[i3 >> 2] | 0;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZdlPv(i1);
 STACKTOP = i5;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIxdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = i1;
  i5 = i3;
  i3 = i3 + 4 | 0;
  HEAPF64[tempDoublePtr >> 3] = +((HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24) >>> 0) + 4294967296.0 * +(HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24 | 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx7NpCloth23setExternalAccelerationENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore23setExternalAccelerationENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 595, gb + 696565 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx3Cct13HandleManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 2;
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2 + 3 | 0, 8, gb + 657886 | 0, 25) | 0;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2 + 2 | 0, HEAP32[i3 >> 2] << 1, gb + 657886 | 0, 26) | 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2 + 1 | 0, HEAP32[i3 >> 2] << 1, gb + 657886 | 0, 27) | 0;
 i1 = i1 + 20 | 0;
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, HEAP32[i3 >> 2] << 1, gb + 657886 | 0, 28) | 0;
 _memset(HEAP32[i5 >> 2] | 0, -1, HEAP32[i3 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i4 >> 2] | 0, -1, HEAP32[i3 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i1 >> 2] | 0, 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc7BodySim10putToSleepEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 __ZN5physx2Sc5Actor9setActiveEbj(i5, 0, 0);
 i4 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i5 + 36 >> 2] | 0) | 0;
 i1 = i5 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 i7 = i3 + (i2 * 12 | 0) + 8 | 0;
 i6 = HEAP8[i7 >> 0] | 0;
 HEAP8[i7 >> 0] = i6 & 231 | 16;
 do if (i6 & 8) {
  i7 = (HEAP32[HEAP32[i4 + 272 >> 2] >> 2] | 0) + (i2 >>> 5 << 2) | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & ~(1 << (i2 & 31));
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] & 64)) {
   i2 = (HEAP32[HEAP32[i4 + 276 >> 2] >> 2] | 0) + (i1 >>> 5 << 2) | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = 1 << (i1 & 31);
   if (!(i3 & i1)) {
    HEAP32[i2 >> 2] = i3 | i1;
    break;
   } else {
    HEAP32[i2 >> 2] = i3 & ~i1;
    break;
   }
  }
 } while (0);
 HEAP8[i4 + 477 >> 0] = 1;
 i7 = i5 + 144 | 0;
 HEAP16[i7 >> 1] = (HEAPU16[i7 >> 1] | 0) & 65023;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN5physx11NpAggregate16addActorInternalERNS_7PxActorERNS_7NpSceneE(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) != 4) {
  __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE(i2 + 8 | 0, i1 + (HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0);
  __ZN5physx7NpScene16addActorInternalERNS_7PxActorE(i5, i1);
  return;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) return;
 i3 = HEAP32[i1 + 288 >> 2] | 0;
 i4 = HEAP32[i3 + 88 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0) | 0) {
  i1 = i2 + 8 | 0;
  i2 = 0;
  do {
   __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE(i1, (HEAP32[i4 + (i2 << 2) >> 2] | 0) + 48 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0) | 0) >>> 0);
 }
 __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE(i5, i3);
 return;
}

function __ZN4crnd10dxt5_block16get_block_valuesEPNS_10color_quadIhiEEjj(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP8[i9 + 3 >> 0] = i1;
 HEAP8[i9 + 7 >> 0] = i2;
 if (i1 >>> 0 > i2 >>> 0) {
  i3 = 8;
  i4 = ((((i2 * 6 | 0) + i1 | 0) >>> 0) / 7 | 0) & 255;
  i5 = ((((i2 * 5 | 0) + (i1 << 1) | 0) >>> 0) / 7 | 0) & 255;
  i6 = (((i2 << 2) + (i1 * 3 | 0) | 0) >>> 0) / 7 | 0;
  i7 = (((i2 * 3 | 0) + (i1 << 2) | 0) >>> 0) / 7 | 0;
  i8 = (((i2 << 1) + (i1 * 5 | 0) | 0) >>> 0) / 7 | 0;
  i1 = (((i1 * 6 | 0) + i2 | 0) >>> 0) / 7 | 0;
 } else {
  i3 = 6;
  i4 = -1;
  i5 = 0;
  i6 = (((i2 << 2) + i1 | 0) >>> 0) / 5 | 0;
  i7 = (((i2 * 3 | 0) + (i1 << 1) | 0) >>> 0) / 5 | 0;
  i8 = (((i2 << 1) + (i1 * 3 | 0) | 0) >>> 0) / 5 | 0;
  i1 = (((i1 << 2) + i2 | 0) >>> 0) / 5 | 0;
 }
 HEAP8[i9 + 11 >> 0] = i1;
 HEAP8[i9 + 15 >> 0] = i8;
 HEAP8[i9 + 19 >> 0] = i7;
 HEAP8[i9 + 23 >> 0] = i6;
 HEAP8[i9 + 27 >> 0] = i5;
 HEAP8[i9 + 31 >> 0] = i4;
 return i3 | 0;
}

function __ZN15AudioEchoFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, i1, 16, gb + 1048932 | 0, 0, gb + 873010 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 170904 + 8;
 HEAP32[i4 + 44 >> 2] = 500;
 HEAPF32[i4 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 56 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 36 >> 2] = 6;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13BitSetUtility8MoveBitsEPjjjj(i5, i6, i2, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i8 = 0;
 if (i6 >>> 0 < i7 >>> 0) {
  i1 = i2 + -1 | 0;
  if ((i1 | 0) <= -1) return;
  do {
   i3 = i1 + i7 | 0;
   i4 = i1 + i6 | 0;
   i2 = 1 << (i3 & 31);
   if (!(HEAP32[i5 + (i4 >>> 5 << 2) >> 2] & 1 << (i4 & 31))) {
    i4 = i5 + (i3 >>> 5 << 2) | 0;
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i2;
   } else {
    i4 = i5 + (i3 >>> 5 << 2) | 0;
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i2;
   }
   i1 = i1 + -1 | 0;
  } while ((i1 | 0) > -1);
  return;
 } else {
  if (!i2) return; else i1 = 0;
  do {
   i3 = i1 + i7 | 0;
   i8 = i1 + i6 | 0;
   i4 = 1 << (i3 & 31);
   if (!(HEAP32[i5 + (i8 >>> 5 << 2) >> 2] & 1 << (i8 & 31))) {
    i8 = i5 + (i3 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~i4;
   } else {
    i8 = i5 + (i3 >>> 5 << 2) | 0;
    HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i4;
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i2 | 0));
  return;
 }
}

function __ZN13BatchRenderer11RenderBatchEPK17BatchInstanceDatajRK14ChannelAssigns(i1, i2, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i10;
 i4 = i1 + 168 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) == 1) {
  __Z17SetupObjectMatrixRK10Matrix4x4fi(i9 + (i8 * 360 | 0) | 0, HEAP32[i9 + (i8 * 360 | 0) + 176 >> 2] | 0);
  mftCall_viiii(HEAP32[i9 + (i8 * 360 | 0) + 332 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, i5 | 0, HEAP32[i2 + 4 >> 2] | 0);
  STACKTOP = i10;
  return;
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 if (!(HEAP8[i1 + 160 >> 0] | 0)) i1 = 0; else i1 = (HEAPU8[i1 + 188 >> 0] | 0) >>> 1 & 1 ^ 1;
 HEAP8[i6 + 8 >> 0] = i1;
 HEAP32[i6 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[i9 + (i8 * 360 | 0) + 340 >> 2] | 0, i7 | 0, i6 | 0, i5 | 0);
 STACKTOP = i10;
 return;
}

function __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 40 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 16 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i3 = i1 + 32 | 0;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4);
  i6 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
  return;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = i6;
  i6 = i1 + 36 | 0;
  __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i2);
  return;
 }
}

function __Z44Camera_CUSTOM_INTERNAL_CALL_ScreenPointToRayP12Il2CppObjectRK8Vector3fR3Ray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  __ZNK6Camera16ScreenPointToRayERK8Vector2f(i4, i6, i5);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  STACKTOP = i7;
  return;
 }
}

function __Z31RegisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i4 + 39368 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 > 63) {
  __Z6FormatPKcz(i1, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i1 = HEAP32[i3 >> 2] | 0;
 } else i1 = i2;
 HEAP32[i3 >> 2] = i1 + 1;
 i2 = i4 + 38600 + (i1 * 12 | 0) | 0;
 HEAP32[i4 + 38600 + (i1 * 12 | 0) + 4 >> 2] = 0;
 i1 = i4 + 38600 + (i1 * 12 | 0) + 8 | 0;
 if (!i5) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i2 >> 2] = i5;
  STACKTOP = i6;
  return;
 }
}

function _UNITY_FT_Matrix_Multiply_Scaled(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i1 = i1 << 16;
 if (!((i2 | 0) != 0 & (i3 | 0) != 0)) return;
 i8 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i9 = _UNITY_FT_MulDiv(i8, i6, i1) | 0;
 i13 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 i14 = HEAP32[i5 >> 2] | 0;
 i9 = (_UNITY_FT_MulDiv(i13, i14, i1) | 0) + i9 | 0;
 i7 = i3 + 4 | 0;
 i12 = HEAP32[i7 >> 2] | 0;
 i8 = _UNITY_FT_MulDiv(i8, i12, i1) | 0;
 i4 = i3 + 12 | 0;
 i10 = HEAP32[i4 >> 2] | 0;
 i8 = (_UNITY_FT_MulDiv(i13, i10, i1) | 0) + i8 | 0;
 i13 = HEAP32[i2 + 8 >> 2] | 0;
 i6 = _UNITY_FT_MulDiv(i13, i6, i1) | 0;
 i11 = HEAP32[i2 + 12 >> 2] | 0;
 i6 = (_UNITY_FT_MulDiv(i11, i14, i1) | 0) + i6 | 0;
 i2 = _UNITY_FT_MulDiv(i13, i12, i1) | 0;
 i2 = (_UNITY_FT_MulDiv(i11, i10, i1) | 0) + i2 | 0;
 HEAP32[i3 >> 2] = i9;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i4 >> 2] = i2;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofERKS5_j(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i4 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i9 = i4 << 24 >> 24 < 0;
 i5 = i9 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i9 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 i1 = i2 + ((i1 >>> 0 > i6 >>> 0 ? i6 + 1 | 0 : i1) << 2) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i7 = -1;
   break;
  }
  i1 = i1 + -4 | 0;
  __THREW__ = 0;
  i3 = invoke_iiii(fb + 514 | 0, i5 | 0, i4 | 0, i1 | 0) | 0;
  i9 = __THREW__;
  __THREW__ = 0;
  if (i9 & 1) {
   i8 = 8;
   break;
  }
  if (!i3) {
   i8 = 9;
   break;
  }
 }
 if ((i8 | 0) == 8) {
  i9 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i9);
 } else if ((i8 | 0) == 9) i7 = i1 - i2 >> 2;
 return i7 | 0;
}

function __ZN8Animator8SetFloatEif(i3, i6, f2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 HEAPF32[i7 >> 2] = f2;
 i1 = i3 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1) | 0)) {
  i7 = 64;
  STACKTOP = i8;
  return i7 | 0;
 }
 i5 = i3 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i3 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i3 + 584 | 0);
 }
 i4 = i3 + 584 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i1 = 0;
 i3 = HEAP32[i4 >> 2] | 0;
 do {
  i9 = HEAP32[i3 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 140 >> 2] | 0, i9 | 0, i6 | 0, i7 | 0) | 0 | i1;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != ((HEAP32[i4 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741375;
 HEAP32[i1 + 4 >> 2] = 483;
 HEAP32[i1 + 8 >> 2] = fb + 416;
 HEAP32[i1 + 12 >> 2] = fb + 359;
 HEAP32[i1 + 16 >> 2] = gb + 741387;
 HEAP32[i1 + 20 >> 2] = 484;
 HEAP32[i1 + 24 >> 2] = fb + 417;
 HEAP32[i1 + 28 >> 2] = fb + 360;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 485;
 HEAP32[i1 + 40 >> 2] = fb + 418;
 HEAP32[i1 + 44 >> 2] = fb + 361;
 HEAP32[i1 + 48 >> 2] = gb + 741403;
 HEAP32[i1 + 52 >> 2] = 486;
 HEAP32[i1 + 56 >> 2] = fb + 419;
 HEAP32[i1 + 60 >> 2] = fb + 362;
 HEAP32[i1 + 64 >> 2] = gb + 741411;
 HEAP32[i1 + 68 >> 2] = 487;
 HEAP32[i1 + 72 >> 2] = fb + 420;
 HEAP32[i1 + 76 >> 2] = fb + 363;
 HEAP32[i1 + 80 >> 2] = gb + 742176;
 HEAP32[i1 + 84 >> 2] = 497;
 HEAP32[i1 + 88 >> 2] = fb + 428;
 HEAP32[i1 + 92 >> 2] = fb + 371;
 HEAP32[i1 + 96 >> 2] = gb + 742182;
 HEAP32[i1 + 100 >> 2] = 498;
 HEAP32[i1 + 104 >> 2] = fb + 429;
 HEAP32[i1 + 108 >> 2] = fb + 372;
 return;
}

function __ZN4Mesh18CheckIfBuffersLostEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 36 | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0;
 do if (i1 | 0) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
   i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
   if (!i1) break;
   if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
    i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0;
    if (!i1) break;
    if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
     i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0;
     if (!i1) break;
     if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) break;
    }
   }
  }
  i1 = i3 + 44 | 0;
  HEAP8[i1 >> 0] = HEAP8[i1 >> 0] | 1;
 } while (0);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 if (!i1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) return;
 i3 = i3 + 44 | 0;
 HEAP8[i3 >> 0] = HEAP8[i3 >> 0] | 2;
 return;
}

function __ZN2UI15DoSyncMaterialsERNS_13UIInstructionER13dynamic_arrayI4PPtrI8MaterialELj4EERS2_I7SubMeshLj4EE9TextureIDSB_8Vector4fb(i5, i1, i6, i7, i8, i9, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 12 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) i1 = 0; else {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = 0;
  do {
   HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while ((i2 | 0) < 8 & i2 >>> 0 < i1 >>> 0);
 }
 i6 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
 HEAP32[i5 + 448 >> 2] = (i6 | 0) > 8 ? 8 : i6;
 HEAP32[i5 + 452 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 456 >> 2] = HEAP32[i8 >> 2];
 i8 = i5 + 460 | 0;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 HEAP8[i5 + 666 >> 0] = i10 & 1;
 HEAP16[i5 + 664 >> 1] = 2;
 return;
}

function __ZN22BaseUnityConnectClient20QueueAppRunningEventEjjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 56 | 0;
 i7 = i8;
 __ZN11UnityEngine7Connect15AppRunningEventC2Ejjjj(i7, i2, i3, i4, i5);
 _time(i6 | 0) | 0;
 i5 = _localtime(i6 | 0) | 0;
 i4 = _mktime(_gmtime(i6 | 0) | 0) | 0;
 HEAP32[i7 + 48 >> 2] = ~~(+_difftime(i4 | 0, _mktime(i5 | 0) | 0) * 1.0e3);
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i7, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 HEAP32[i7 >> 2] = gb + 190148 + 8;
 i1 = i7 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i7 + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i7;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i6);
 STACKTOP = i8;
 return;
}

function __ZN19UnityConnectService18OnAdsIdRequestDoneERK8UnityStrbS2_(i8, i3, i1, i2) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i8 + 48 | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 i6 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i7 = i4 ? HEAP32[i3 >> 2] | 0 : i3;
 i6 = i4 ? HEAP32[i3 + 4 >> 2] | 0 : i6 & 255;
 i4 = i1 + 11 | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i5 = (HEAP32[i8 + 56 >> 2] & 2147483647) + -1 | 0; else i5 = 10;
 if (i6 >>> 0 > i5 >>> 0) {
  if (i3) i2 = HEAP32[i8 + 52 >> 2] | 0; else i2 = i2 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i1, i5, i6 - i5 | 0, i2, 0, i2, i6, i7);
  return;
 }
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 if (i6 | 0) _memmove(i1 | 0, i7 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i8 + 52 >> 2] = i6;
  return;
 } else {
  HEAP8[i4 >> 0] = i6;
  return;
 }
}

function __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 884 >> 2] | 0) + 800 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_TrailModule_CUSTOM_SetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i2, (HEAP32[i1 + 908 >> 2] | 0) + 292 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z23ChooseSuitableFSAALeveliiiiii(i2, i3, i4, i8, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 if (__Z12GetIVRDevicev() | 0) {
  i7 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0) | 0) {
   i8 = 0;
   return i8 | 0;
  }
 }
 i6 = ~~Math_fround(Math_fround(HEAPF32[(__Z15GetGraphicsCapsv() | 0) + 100 >> 2]) * Math_fround(1024.0));
 i7 = ~~Math_fround(Math_fround(i6 | 0) * Math_fround(.5));
 i6 = i6 + -16384 | 0;
 i6 = (i6 | 0) < 262144 ? i6 : 262144;
 i7 = (i6 | 0) < (i7 | 0) ? i6 : i7;
 i6 = Math_imul(i3, i2) | 0;
 i3 = i5 + i4 | 0;
 while (1) {
  if (((Math_imul(i6, (Math_imul((i1 | 0) < 1 ? 1 : i1, i3) | 0) + i8 | 0) | 0) / 1024 | 0 | 0) < (i7 | 0)) break;
  i2 = (i1 | 0) / 2 | 0;
  if ((i1 | 0) > 3) i1 = i2; else {
   i1 = i2;
   break;
  }
 }
 i8 = (i1 | 0) == 1 ? 0 : i1;
 return i8 | 0;
}

function __Z17createBucketAllocP9TESSallocPKcjj(i5, i1, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 12 | 0;
 i7 = mftCall_iii(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, 24) | 0;
 HEAP32[i7 + 20 >> 2] = i5;
 HEAP32[i7 + 16 >> 2] = i1;
 i3 = i7 + 8 | 0;
 i8 = i2 >>> 0 < 4 ? 4 : i2;
 HEAP32[i3 >> 2] = i8;
 i2 = i7 + 12 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i7 >> 2] = 0;
 i1 = i7 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i4 = (Math_imul(i8, i4) | 0) + 4 | 0;
 i4 = mftCall_iii(HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, i4 | 0) | 0;
 if (!i4) {
  mftCall_vii(HEAP32[i5 + 8 >> 2] | 0, HEAP32[i6 >> 2] | 0, i7 | 0);
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 do {
  i1 = i1 - i3 | 0;
  i8 = i2;
  i2 = i4 + i1 | 0;
  HEAP32[i2 >> 2] = i8;
 } while ((i1 | 0) != 4);
 HEAP32[i7 >> 2] = i2;
 i8 = i7;
 return i8 | 0;
}

function __ZNK11AudioSource9IsPlayingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (HEAP32[i1 + 464 >> 2] | 0) if (!(HEAP8[i1 + 532 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 432 >> 2] | 0) != (i1 + 428 | 0)) if (!(HEAP8[i1 + 532 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = i1 + 456 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!(__ZN20SoundChannelInstance9isPlayingEPb(i1, i3) | 0)) if (!(HEAP8[i3 >> 0] | 0)) i1 = 0; else i1 = (HEAP8[(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0) + 236 >> 0] | 0) == 0; else i1 = (HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0) + 184 >> 2] | 0) != 0;
 i3 = i1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!(HEAP8[i1 + 111 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417432 | 0, 0, gb + 410682 | 0, 1563, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  i6 = 0;
  return i6 | 0;
 }
 do if ((i4 + -10 | 0) >>> 0 >= 3) if (((i4 | 1) + -25 | 0) >>> 0 >= 5) {
  i6 = i4 + -30 | 0;
  if (i6 >>> 0 < 15) {
   if ((i4 + -48 | 0) >>> 0 < 12 | ((i4 + -45 | 0) >>> 0 < 3 | (30847 >>> (i6 & 65535) & 1) != 0)) break;
  } else if ((i4 + -45 | 0) >>> 0 < 3 | (i4 + -48 | 0) >>> 0 < 12) break;
  i6 = mftCall_iiiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, 1, -1, 0) | 0;
  return i6 | 0;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 417457 | 0, 0, gb + 410682 | 0, 1569, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 i6 = 0;
 return i6 | 0;
}

function __ZN8Animator8SetSpeedEf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i7 + 4 | 0;
 HEAPF32[i2 >> 2] = f1;
 i6 = HEAP32[i5 + 548 >> 2] | 0;
 if (!i6) {
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  i4 = f1 > Math_fround(0.0);
  i4 = HEAP32[(i4 ? i2 : i3) >> 2] | 0;
  HEAP32[i5 + 420 >> 2] = i4;
  f1 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } else {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
  HEAPF32[i5 + 420 >> 2] = f1;
 }
 if (!(HEAP32[i5 + 108 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i5 + 624 >> 2] | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 i5 = f1 < Math_fround(0.0) & 1;
 HEAP8[i3 + 24 >> 0] = (i6 | 0) == 2 ? i5 : 0;
 HEAP32[HEAP32[i2 + 96 >> 2] >> 2] = i4;
 STACKTOP = i7;
 return;
}

function __ZN5physx7NpCloth22setAngularInertiaScaleENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore22setAngularInertiaScaleENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 635, gb + 697237 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx3Ext21InertiaTensorComputer12setEllipsoidEfff(i4, f1, f2, f3) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 i9 = f1 != Math_fround(0.0);
 f7 = i9 ? f1 : Math_fround(1.0);
 i9 = f2 != Math_fround(0.0);
 f8 = Math_fround(f7 * f2);
 f7 = i9 ? f8 : f7;
 i9 = f3 != Math_fround(0.0);
 f8 = Math_fround(f7 * f3);
 f7 = Math_fround((i9 ? f8 : f7) * Math_fround(4.18879032));
 f8 = Math_fround(f7 * Math_fround(.400000006));
 f6 = Math_fround(Math_fround(f2 * f3) * f8);
 f5 = Math_fround(Math_fround(f1 * f3) * f8);
 f3 = Math_fround(Math_fround(f1 * f2) * f8);
 HEAPF32[i4 + 48 >> 2] = f7;
 HEAPF32[i4 >> 2] = f6;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i4 + 16 >> 2] = f5;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAPF32[i4 + 32 >> 2] = f3;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 return;
}

function __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741375;
 HEAP32[i1 + 4 >> 2] = 483;
 HEAP32[i1 + 8 >> 2] = fb + 416;
 HEAP32[i1 + 12 >> 2] = fb + 359;
 HEAP32[i1 + 16 >> 2] = gb + 741387;
 HEAP32[i1 + 20 >> 2] = 484;
 HEAP32[i1 + 24 >> 2] = fb + 417;
 HEAP32[i1 + 28 >> 2] = fb + 360;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 485;
 HEAP32[i1 + 40 >> 2] = fb + 418;
 HEAP32[i1 + 44 >> 2] = fb + 361;
 HEAP32[i1 + 48 >> 2] = gb + 741403;
 HEAP32[i1 + 52 >> 2] = 486;
 HEAP32[i1 + 56 >> 2] = fb + 419;
 HEAP32[i1 + 60 >> 2] = fb + 362;
 HEAP32[i1 + 64 >> 2] = gb + 741411;
 HEAP32[i1 + 68 >> 2] = 487;
 HEAP32[i1 + 72 >> 2] = fb + 420;
 HEAP32[i1 + 76 >> 2] = fb + 363;
 HEAP32[i1 + 80 >> 2] = gb + 742176;
 HEAP32[i1 + 84 >> 2] = 493;
 HEAP32[i1 + 88 >> 2] = fb + 437;
 HEAP32[i1 + 92 >> 2] = fb + 378;
 HEAP32[i1 + 96 >> 2] = gb + 742182;
 HEAP32[i1 + 100 >> 2] = 494;
 HEAP32[i1 + 104 >> 2] = fb + 438;
 HEAP32[i1 + 108 >> 2] = fb + 379;
 return;
}

function __ZN5physx2Sq16BucketPrunerNodeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = -25165825;
 HEAP32[i1 + 68 >> 2] = -25165825;
 HEAP32[i1 + 72 >> 2] = -25165825;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = -25165825;
 HEAP32[i1 + 100 >> 2] = -25165825;
 HEAP32[i1 + 104 >> 2] = -25165825;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = -25165825;
 HEAP32[i1 + 132 >> 2] = -25165825;
 HEAP32[i1 + 136 >> 2] = -25165825;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = -25165825;
 HEAP32[i1 + 164 >> 2] = -25165825;
 HEAP32[i1 + 168 >> 2] = -25165825;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = -25165825;
 HEAP32[i1 + 196 >> 2] = -25165825;
 HEAP32[i1 + 200 >> 2] = -25165825;
 return;
}

function __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAPU8[i1 + 20 >> 0] | 0;
 i1 = i1 + 12 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = i3 + 16 + (i2 * 12 | 0) + 4 | 0;
 i5 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
 HEAP32[i6 >> 2] = i5;
 i6 = i3 + 16 + (i2 * 12 | 0) | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 HEAP32[i7 + (i4 << 2) >> 2] = HEAP32[i7 + (i5 << 2) >> 2];
 HEAP32[i1 >> 2] = -1;
 if (i4 >>> 0 < i5 >>> 0) HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 12 >> 2] = i4;
 i2 = i3 + 88 + (i2 << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i4 >>> 0 >= i1 >>> 0) return;
 i1 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i1;
 if (i1 >>> 0 >= i5 >>> 0) return;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = i7 + (i4 << 2) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i5;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = i4;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN19SkinnedMeshRenderer23GetSkinnedMeshLocalAABBER4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 32 | 0;
 i4 = i1 + 272 | 0;
 i5 = HEAP16[i4 >> 1] | 0;
 if ((i5 & 65535) > 255 | (i5 & 255) << 24 >> 24 != 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0);
  HEAP8[i4 >> 0] = 0;
  HEAP8[i1 + 273 >> 0] = 0;
 }
 if (!(HEAP8[i1 + 464 >> 0] | 0)) {
  i5 = i1 + 436 | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  return;
 } else {
  i5 = i1 + 188 | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  return;
 }
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient11PerformPostEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i4 = i5;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i4 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i1, i7, i6, i3 + 44 | 0, 0, i2, 0) | 0;
 HEAP32[i3 + 32 >> 2] = i4;
 STACKTOP = i5;
 return (i4 | 0) != 0 | 0;
}

function __Z35Component_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i2, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z17IsContainedInAABBRK4AABBS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0, i10 = 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i10 = i1 + 12 | 0;
 f5 = Math_fround(HEAPF32[i10 >> 2]);
 f8 = Math_fround(f7 - f5);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i9 = i2 + 12 | 0;
 f3 = Math_fround(HEAPF32[i9 >> 2]);
 i6 = f8 < Math_fround(f4 - f3) ? 1 : Math_fround(f7 + f5) > Math_fround(f4 + f3);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i10 + 4 >> 2]);
 f5 = Math_fround(f3 - f4);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i6 = Math_fround(f3 + f4) > Math_fround(f7 + f8) | (i6 | f5 < Math_fround(f7 - f8));
 f8 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 8 >> 2]);
 f5 = Math_fround(f8 - f7);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 return (Math_fround(f8 + f7) > Math_fround(f4 + f3) | (i6 | f5 < Math_fround(f4 - f3))) ^ 1 | 0;
}

function _y0(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Shl(i2 | 0, 0, 1) | 0;
 getTempRet0() | 0 | i2;
 do if (!(i4 | i3)) d1 = -inf; else if ((i2 | 0) < 0) d1 = nan; else {
  if (i2 >>> 0 > 2146435071) {
   d1 = 1.0 / d1;
   break;
  }
  if (i2 >>> 0 > 1073741823) {
   d1 = +_common(i2, d1, 1);
   break;
  }
  if (i2 >>> 0 > 1044381695) {
   d5 = d1 * d1;
   d1 = (d5 * (d5 * (d5 * (d5 * (d5 * (1.9559013703502292e-08 - d5 * 3.982051941321034e-11) + -3.8140705372436416e-06) + 3.4745343209368365e-04) + -.01381856719455969) + .17666645250918112) + -.07380429510868723) / (d5 * (d5 * (d5 * (d5 * 4.4111031133267547e-10 + 2.591508518404578e-07) + 7.600686273503533e-05) + .01273048348341237) + 1.0) + +_j0(d1) * +Math_log(+d1) * .6366197723675814;
   break;
  } else {
   d1 = +Math_log(+d1) * .6366197723675814 + -.07380429510868723;
   break;
  }
 } while (0);
 return +d1;
}

function _tt_cmap10_char_next(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = (HEAPU8[i4 + 13 >> 0] | 0) << 16 | (HEAPU8[i4 + 12 >> 0] | 0) << 24 | (HEAPU8[i4 + 14 >> 0] | 0) << 8 | (HEAPU8[i4 + 15 >> 0] | 0);
 i5 = (HEAPU8[i4 + 17 >> 0] | 0) << 16 | (HEAPU8[i4 + 16 >> 0] | 0) << 24 | (HEAPU8[i4 + 18 >> 0] | 0) << 8 | (HEAPU8[i4 + 19 >> 0] | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = i1 + 1 | 0;
 i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
 i1 = i2 - i3 | 0;
 L4 : do if (i1 >>> 0 < i5 >>> 0) {
  i4 = i4 + 20 + (i1 << 1) | 0;
  i3 = i1;
  while (1) {
   i1 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
   if (i1 | 0) break L4;
   if ((i2 | 0) == -1) {
    i1 = 0;
    break;
   }
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i5 >>> 0) {
    i1 = 0;
    break L4;
   } else i4 = i4 + 2 | 0;
  }
  return i1 | 0;
 } else i1 = 0; while (0);
 HEAP32[i6 >> 2] = i2;
 i6 = i1;
 return i6 | 0;
}

function __ZN5physx20updateAtomProgressesEPNS_23PxcSolverConstraintDescEjjj(i1, i13, i11, i12) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i13) {
  i13 = 0;
  i13 = i13 & 65535;
  return i13 | 0;
 } else {
  i2 = 0;
  i10 = i1;
  i1 = 0;
 }
 while (1) {
  i6 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = (i6 - i11 | 0) >>> 5 >>> 0 < i12 >>> 0;
  if (i8) i3 = HEAPU16[i6 + 12 >> 1] | 0; else i3 = 65535;
  i9 = (i7 - i11 | 0) >>> 5 >>> 0 < i12 >>> 0;
  if (i9) i4 = HEAPU16[i7 + 12 >> 1] | 0; else i4 = 65535;
  HEAP16[i10 + 28 >> 1] = i3;
  HEAP16[i10 + 30 >> 1] = i4;
  i5 = i3 + 1 & 65535;
  i3 = i4 + 1 & 65535;
  i4 = (i5 & 65535) < (i3 & 65535) ? i3 : i5;
  i1 = (i1 & 65535) < (i4 & 65535) ? i4 : i1;
  if (i8) HEAP16[i6 + 12 >> 1] = i5;
  if (i9) HEAP16[i7 + 12 >> 1] = i3;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i13 | 0)) break; else i10 = i10 + 32 | 0;
 }
 i13 = i1 & 65535;
 return i13 | 0;
}

function __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE(i2, i3, i4, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i1 = i3 + -1 | 0;
 if (!i3) {
  STACKTOP = i9;
  return;
 }
 i3 = i7 + 3 | 0;
 i5 = i7 + 1 | 0;
 i6 = i7 + 2 | 0;
 if (i4) {
  while (1) {
   i4 = HEAP32[i2 >> 2] | 0;
   HEAP32[i7 >> 2] = i4;
   HEAP8[i7 >> 0] = i4 >>> 24;
   HEAP8[i3 >> 0] = i4;
   HEAP8[i5 >> 0] = i4 >>> 16;
   HEAP8[i6 >> 0] = i4 >>> 8;
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 4) | 0;
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  STACKTOP = i9;
  return;
 } else {
  while (1) {
   HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i7 | 0, 4) | 0;
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN2UI6Canvas9SetCameraE4PPtrI6CameraE(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 4 | 0;
 i1 = i6;
 i2 = HEAP32[i5 + 344 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  __ZN2UI6Canvas9SetCameraE4PPtrI6CameraE(i2, i4);
  STACKTOP = i6;
  return;
 }
 i2 = i5 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 if ((HEAP32[i5 + 36 >> 2] | 0) != 1) {
  STACKTOP = i6;
  return;
 }
 __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i5, 1);
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i5, gb + 1106036 | 0, i4);
 STACKTOP = i6;
 return;
}

function __ZN23CloudWebServicesManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 189740 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i1 + 32;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1115296 + 32 >> 2] = fb + 428;
 STACKTOP = i4;
 return;
}

function __ZN19CullingGroupManager15AddCullingGroupEP12CullingGroup(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i1;
 i8 = i6 + 12 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i9;
 i2 = i9 + 1 | 0;
 i3 = i6 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 & 2147483647;
 do if (i2 >>> 0 > i5 >>> 0) {
  i1 = i4 << 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  if (i5 >>> 0 < i1 >>> 0) if ((i4 | 0) > -1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 2, 4, i6 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   HEAP32[i6 >> 2] = i5;
   break;
  }
 } while (0);
 HEAP32[i8 >> 2] = i2;
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i9 << 2) >> 2] = i7;
 return;
}

function __ZN18ProfilerConnection41HandleQueryInstrumentableFunctionsMessageEPKvjj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 8 | 0;
 i3 = i4;
 i2 = i4 + 16 | 0;
 if ((HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0) != (i5 | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i5 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i3);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = __ZN16PlayerConnection3GetEv() | 0;
 __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj(i3, HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] | 0, 52, 0, 0);
 __Z19free_alloc_internalPvRK10MemLabelId(0, i5);
 STACKTOP = i4;
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP32[i5 + 60 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i6, i5 + 64 | 0, gb + 1034411 | 0, 0);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformWWWEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i4 = i5;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i4 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i1, i7, i6, i3 + 44 | 0, 0, i2, 0) | 0;
 HEAP32[i3 + 32 >> 2] = i4;
 STACKTOP = i5;
 return (i4 | 0) != 0 | 0;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformGetEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i4 = i5;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 i1 = i3 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i3 + 20 >> 2] | 0;
 i6 = HEAP32[i3 + 24 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i4 = __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j(i1, i7, i6, i3 + 44 | 0, 0, i2, 0) | 0;
 HEAP32[i3 + 32 >> 2] = i4;
 STACKTOP = i5;
 return (i4 | 0) != 0 | 0;
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 864 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i2, (HEAP32[i1 + 860 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIhyEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i4 = i3;
   i4 = i4 & 255;
   i6 = i1;
   i5 = i6;
   HEAP32[i5 >> 2] = i4;
   i6 = i6 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i4 = HEAP8[i5 >> 0] | 0;
 i4 = i4 & 255;
 i6 = i1;
 i5 = i6;
 HEAP32[i5 >> 2] = i4;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIhxEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i4 = i3;
   i4 = i4 & 255;
   i6 = i1;
   i5 = i6;
   HEAP32[i5 >> 2] = i4;
   i6 = i6 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i4 = HEAP8[i5 >> 0] | 0;
 i4 = i4 & 255;
 i6 = i1;
 i5 = i6;
 HEAP32[i5 >> 2] = i4;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbyEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i4 = i3;
   i4 = i4 & 255;
   i6 = i1;
   i5 = i6;
   HEAP32[i5 >> 2] = i4;
   i6 = i6 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i4 = HEAP8[i5 >> 0] | 0;
 i4 = i4 & 255;
 i6 = i1;
 i5 = i6;
 HEAP32[i5 >> 2] = i4;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbxEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i4 = i3;
   i4 = i4 & 255;
   i6 = i1;
   i5 = i6;
   HEAP32[i5 >> 2] = i4;
   i6 = i6 + 4 | 0;
   HEAP32[i6 >> 2] = 0;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i4 = HEAP8[i5 >> 0] | 0;
 i4 = i4 & 255;
 i6 = i1;
 i5 = i6;
 HEAP32[i5 >> 2] = i4;
 i6 = i6 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i7;
 return 1;
}

function __Z18CalculateWorldAABBR10GameObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31312 | 0) | 0;
 if (i1 | 0) {
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i1 + 32 | 0, i2);
  f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 >> 2])) {
   i2 = 1;
   return i2 | 0;
  }
  f3 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) {
   i2 = 1;
   return i2 | 0;
  }
  f3 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) {
   i2 = 1;
   return i2 | 0;
  }
 };
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = 0;
 return i2 | 0;
}

function __ZNK6Shader24GetSubShaderWithTagValueEii(i1, i8, i9) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 if ((i2 | 0) == (i7 | 0)) {
  i9 = -1;
  return i9 | 0;
 } else i1 = 0;
 while (1) {
  i6 = (HEAP32[i2 >> 2] | 0) + 28 | 0;
  i4 = HEAP32[i6 >> 2] | 0;
  if (i4 | 0) {
   i3 = i6;
   L6 : while (1) {
    i5 = i4;
    while (1) {
     if ((HEAP32[i5 + 16 >> 2] | 0) >= (i8 | 0)) break;
     i4 = HEAP32[i5 + 4 >> 2] | 0;
     if (!i4) break L6; else i5 = i4;
    }
    i4 = HEAP32[i5 >> 2] | 0;
    if (!i4) {
     i3 = i5;
     break;
    } else i3 = i5;
   }
   if ((i3 | 0) != (i6 | 0)) if ((HEAP32[i3 + 16 >> 2] | 0) <= (i8 | 0)) if ((HEAP32[i3 + 20 >> 2] | 0) == (i9 | 0)) {
    i2 = 11;
    break;
   }
  }
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (i7 | 0)) {
   i1 = -1;
   i2 = 11;
   break;
  } else i1 = i1 + 1 | 0;
 }
 if ((i2 | 0) == 11) return i1 | 0;
 return 0;
}

function __ZN5physx7NpCloth21setLinearInertiaScaleENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore21setLinearInertiaScaleENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 615, gb + 697155 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx7NpCloth21setDampingCoefficientENS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i8 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i2 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 3; else i2 = 4;
   break;
  }
 default:
  i2 = 3;
 }
 if ((i2 | 0) == 3) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[i3 + 8 >> 2] = i1;
  __ZN5physx2Sc9ClothCore21setDampingCoefficientENS_6PxVec3E(i6 + 32 | 0, i3);
  STACKTOP = i8;
  return;
 } else if ((i2 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 675, gb + 697073 | 0, i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc17ParticleSystemSim27releaseParticlePacketShapesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i5 = i1 + 360 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i7 = i1 + 356 | 0;
 i8 = i1 + 60 | 0;
 i9 = i1 + 340 | 0;
 i10 = i1 + 352 | 0;
 i11 = i1 + 344 | 0;
 i4 = i1 + 336 | 0;
 i2 = i6;
 i3 = 0;
 while (1) {
  i1 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
  if (i1 | 0) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
   HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
   HEAP32[i10 >> 2] = i1;
   i2 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i2 + 1;
   if ((i2 | 0) >= ((HEAP32[i4 >> 2] | 0) * 50 | 0)) {
    __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i8);
    HEAP32[i11 >> 2] = 0;
   }
  }
  i1 = i3 + 1 | 0;
  if ((i1 | 0) == (i6 | 0)) break;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i1;
 }
 return;
}

function __ZN5physx2Gu5RTree8validateEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 28 | 0;
 i2 = i7;
 i3 = i6 + 68 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i6 + 92 | 0;
 i5 = 0;
 do {
  __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE((HEAP32[i4 >> 2] | 0) + (i5 * 112 | 0) | 0, i2);
  i8 = (HEAP32[i4 >> 2] | 0) + (i5 * 112 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
  __ZN5physx2Gu5RTree17validateRecursiveEjNS0_10RTreeNodeQEPNS0_9RTreePageE(i6, 0, i1, i8);
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN20IntermediateRendererC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP16[i1 + 184 >> 1] = 0;
 HEAP16[i1 + 186 >> 1] = 0;
 HEAP32[i1 + 188 >> 2] = -2147450880;
 HEAP32[i1 + 192 >> 2] = 0;
 i2 = i1 + 236 | 0;
 i3 = (HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16515072 | 1353;
 HEAP16[i2 >> 1] = i3;
 HEAP8[i2 + 2 >> 0] = i3 >>> 16;
 i2 = i1 + 228 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 232 >> 2] = -1;
 HEAP8[i1 + 240 >> 0] = 1;
 HEAP8[i1 + 241 >> 0] = 1;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 33532 + 8;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 256 >> 2] = 0;
 return;
}

function __ZN19MeshParticleEmitter15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 768 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + (i1 * 12 | 0) >> 2] = fb + 435;
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 190748 | 0, gb + 1106136 | 0, fb + 1005 | 0, 0);
 STACKTOP = i5;
 return;
}

function __ZN11Rigidbody2D13FindRigidbodyEPK10GameObjectPKS_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 67088 | 0) | 0;
 if (!((i2 | 0) == 0 | (i2 | 0) == (i4 | 0))) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
   i4 = i2;
   return i4 | 0;
  }
 }
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) {
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67088 | 0) | 0;
   if (!((i2 | 0) == 0 | (i2 | 0) == (i4 | 0))) {
    i3 = HEAP32[i2 + 28 >> 2] | 0;
    if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
     i1 = i2;
     i2 = 10;
     break;
    }
   }
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 864 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_TrailModule_CUSTOM_SetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i2, (HEAP32[i1 + 908 >> 2] | 0) + 712 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _UNITY_png_write_sRGB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 HEAP8[i4 >> 0] = i2;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i1 + 656 | 0;
 HEAP32[i2 >> 2] = 34;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 1;
 i6 = i3 + 4 | 0;
 HEAP8[i6 >> 0] = 115;
 HEAP8[i3 + 5 >> 0] = 82;
 HEAP8[i3 + 6 >> 0] = 71;
 HEAP8[i3 + 7 >> 0] = 66;
 _UNITY_png_write_data(i1, i3, 8);
 HEAP32[i1 + 372 >> 2] = 1934772034;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i6, 4);
 HEAP32[i2 >> 2] = 66;
 _UNITY_png_write_data(i1, i4, 1);
 _UNITY_png_calculate_crc(i1, i4, 1);
 HEAP32[i2 >> 2] = 130;
 i4 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i3 >> 0] = i4 >>> 24;
 HEAP8[i3 + 1 >> 0] = i4 >>> 16;
 HEAP8[i3 + 2 >> 0] = i4 >>> 8;
 HEAP8[i3 + 3 >> 0] = i4;
 _UNITY_png_write_data(i1, i3, 4);
 STACKTOP = i5;
 return;
}

function _rgb_gray_convert_22(i1, i13, i3, i2, i4) {
 i1 = i1 | 0;
 i13 = i13 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i14 = 0;
 i14 = HEAP32[(HEAP32[i1 + 420 >> 2] | 0) + 24 >> 2] | 0;
 i10 = HEAP32[i1 + 92 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i11 = i13 + 4 | 0;
 i12 = i13 + 8 | 0;
 if (!i10) return;
 while (1) {
  i5 = i4;
  i4 = i4 + -1 | 0;
  i6 = HEAP32[(HEAP32[i13 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i7 = HEAP32[(HEAP32[i11 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i8 = HEAP32[(HEAP32[i12 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i3 = i3 + 1 | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  i1 = 0;
  do {
   HEAP8[i9 + i1 >> 0] = ((HEAP32[i14 + ((HEAPU8[i7 + i1 >> 0] | 0 | 256) << 2) >> 2] | 0) + (HEAP32[i14 + ((HEAPU8[i6 + i1 >> 0] | 0) << 2) >> 2] | 0) + (HEAP32[i14 + ((HEAPU8[i8 + i1 >> 0] | 0 | 512) << 2) >> 2] | 0) | 0) >>> 16;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i10 | 0));
  if ((i5 | 0) <= 1) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZNK12TreeRenderer13GetTreeBoundsERK12TreeInstance(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, i12 = 0;
 i12 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0;
 f11 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 20 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 24 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 28 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 32 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 36 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + (i12 * 156 | 0) + 40 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f11);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f7 * f10);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f5 * f9);
 HEAPF32[i1 + 12 >> 2] = Math_fround(f5 * f8);
 HEAPF32[i1 + 16 >> 2] = Math_fround(f7 * f6);
 HEAPF32[i1 + 20 >> 2] = Math_fround(f5 * f4);
 return;
}

function __ZN8VRDevice10InitializeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 264 >> 2] | 0;
 if (i4 | 0) if (!(mftCall_ii(i4 | 0, i1 + 8 | 0) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP8[i1 + 296 >> 0] = i2 & 1;
 if (HEAP8[i1 + 166 >> 0] | 0) {
  i4 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63816 | 0, 16, gb + 1044184 | 0, 89) | 0;
  __ZN7VRInputC2EPK34UnityVRDeviceSpecificConfiguration(i4, i1 + 8 | 0);
  HEAP32[i1 + 280 >> 2] = i4;
 }
 HEAP32[gb + 1115296 + 152 >> 2] = fb + 423;
 HEAP32[gb + 1115296 + 100 >> 2] = fb + 424;
 HEAP32[gb + 1115296 + 420 >> 2] = fb + 425;
 HEAP32[gb + 1115296 + 424 >> 2] = fb + 426;
 HEAP32[gb + 1115296 + 348 >> 2] = fb + 427;
 __ZN8VRDevice27OnAudioConfigurationChangedEv(i1);
 HEAP32[i3 >> 2] = 3;
 __ZN21VRGlobalSettingsState18RestoreGlobalStateEv(i3);
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN5IMGUI13GetWindowRectER8GUIStatei(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 L1 : do if ((i1 | 0) == (i3 | 0)) i2 = 4; else {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
   if ((i2 | 0) == (i3 | 0)) {
    i2 = 4;
    break L1;
   }
  }
  if (!i1) i2 = 8; else i2 = 7;
 } while (0);
 if ((i2 | 0) == 4) {
  i1 = HEAP32[i4 + 24 >> 2] | 0;
  if (!i1) i2 = 8; else if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) i2 = 7; else i2 = 8;
 }
 if ((i2 | 0) == 7) {
  i5 = i1 + 52 | 0;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  return;
 } else if ((i2 | 0) == 8) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  return;
 }
}

function __ZN11TerrainData10RemoveUserEP10GameObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!i1) i8 = 0; else i8 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 352 >> 2] | 0;
 i10 = i2 + 356 | 0;
 i9 = HEAP32[i10 >> 2] | 0;
 i1 = i9 - i3 >> 2;
 i2 = i9;
 if (!i1) i5 = i3; else {
  i4 = i3;
  i5 = i3;
  while (1) {
   i11 = (i1 | 0) / 2 | 0;
   i7 = i5 + (i11 << 2) | 0;
   i6 = (HEAP32[i7 >> 2] | 0) < (i8 | 0);
   i7 = i7 + 4 | 0;
   i3 = i6 ? i7 : i4;
   i1 = i6 ? i1 + -1 - i11 | 0 : i11;
   if (!i1) {
    i5 = i3;
    break;
   } else {
    i4 = i3;
    i5 = i6 ? i7 : i5;
   }
  }
 }
 if ((i5 | 0) == (i2 | 0)) return;
 if ((i8 | 0) < (HEAP32[i5 >> 2] | 0)) return;
 i3 = i5 + 4 | 0;
 i1 = i9 - i3 | 0;
 i4 = i1 >> 2;
 if (i4) {
  _memmove(i5 | 0, i3 | 0, i1 | 0) | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i1 = i5 + (i4 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i10 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN11BoxCollider7CleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 88 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 108 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 112 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 if (__Z12GetIVehiclesv() | 0) {
  i4 = __Z12GetIVehiclesv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0); else mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, 1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z19CheckChannelBinding13ShaderChannel15VertexComponentP12ShaderErrors(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 if ((i2 | i1 | 0) == 0 | ((i2 | 0) == -1 | (i2 + -12 | 0) >>> 0 < 16)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 | 0) == 1 & (i2 | 0) == 2) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 | 0) == 2 & (i2 | 0) == 1) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i1 + -3 | 0) >>> 0 < 5 & (i2 + -3 | 0) >>> 0 < 9) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 __Z6FormatPKcz(i4, gb + 478009 | 0, i5);
 __ZN12ShaderErrors21AddShaderCompileErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEib(i3, i4, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function _UNITY_tt_face_load_os2(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i1 = mftCall_iiiii(HEAP32[i2 + 508 >> 2] | 0, i2 | 0, 1330851634, i4 | 0, 0) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i3 = i2 + 364 | 0;
 i1 = _UNITY_FT_Stream_ReadFields(i4, gb + 223508 | 0, i3) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i1 = i2 + 444 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP16[i2 + 464 >> 1] = -1;
 if (!(HEAP16[i3 >> 1] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadFields(i4, gb + 223684 | 0, i3) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 if ((HEAPU16[i3 >> 1] | 0) <= 1) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadFields(i4, gb + 223700 | 0, i3) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 if ((HEAPU16[i3 >> 1] | 0) <= 4) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = _UNITY_FT_Stream_ReadFields(i4, gb + 223728 | 0, i3) | 0;
 return i4 | 0;
}

function _UNITY_tt_face_load_any(i7, i4, i3, i8, i6) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 do if (!i4) i1 = HEAP32[(HEAP32[i7 + 104 >> 2] | 0) + 4 >> 2] | 0; else {
  i1 = HEAP32[i7 + 156 >> 2] | 0;
  i2 = HEAP16[i7 + 152 >> 1] | 0;
  i5 = i1 + ((i2 & 65535) << 4) | 0;
  if (!(i2 << 16 >> 16)) {
   i8 = 142;
   return i8 | 0;
  } else i2 = i1;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) {
    i1 = HEAP32[i2 + 12 >> 2] | 0;
    if (i1 | 0) {
     i4 = 6;
     break;
    }
   }
   i1 = i2 + 16 | 0;
   if (i1 >>> 0 < i5 >>> 0) i2 = i1; else {
    i1 = 142;
    i4 = 12;
    break;
   }
  }
  if ((i4 | 0) == 6) {
   i3 = (HEAP32[i2 + 8 >> 2] | 0) + i3 | 0;
   break;
  } else if ((i4 | 0) == 12) return i1 | 0;
 } while (0);
 if (i6) {
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) {
   HEAP32[i6 >> 2] = i1;
   i8 = 0;
   return i8 | 0;
  } else i1 = i2;
 }
 i8 = _UNITY_FT_Stream_ReadAt(HEAP32[i7 + 104 >> 2] | 0, i3, i8, i1) | 0;
 return i8 | 0;
}

function _tanhf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 & 2147483647;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (i2 >>> 0 > 1057791828) if (i2 >>> 0 > 1092616192) {
  f1 = Math_fround(Math_fround(Math_fround(0.0) / f1) + Math_fround(1.0));
  break;
 } else {
  f1 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(2.0) / Math_fround(Math_fround(_expm1f(Math_fround(f1 * Math_fround(2.0)))) + Math_fround(2.0))));
  break;
 } else {
  if (i2 >>> 0 > 1048757624) {
   f1 = Math_fround(_expm1f(Math_fround(f1 * Math_fround(2.0))));
   f1 = Math_fround(f1 / Math_fround(f1 + Math_fround(2.0)));
   break;
  }
  if (i2 >>> 0 > 8388607) {
   f1 = Math_fround(_expm1f(Math_fround(f1 * Math_fround(-2.0))));
   f1 = Math_fround(Math_fround(-f1) / Math_fround(f1 + Math_fround(2.0)));
  }
 } while (0);
 f4 = Math_fround(-f1);
 return Math_fround((i3 | 0) < 0 ? f4 : f1);
}

function __ZN9Texture2D17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (HEAP8[i1 + 112 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!((HEAP32[i1 + 52 >> 2] | 0) == 0 & (HEAP8[i1 + 111 >> 0] | 0) == 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
  STACKTOP = i4;
  return;
 }
 i3 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (HEAP32[i1 + 8 >> 2] & 1048576 | 0) __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc8ShapeSim21destroyTransformCacheERNS_17PxsTransformCacheE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i1 = i1 + 24 | 0;
 i4 = (HEAP32[i7 + 28 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (i5 | 0) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i6 >> 2] = i5;
 do if (((HEAP32[i7 >> 2] | 0) + -1 | 0) == (i5 | 0)) HEAP32[i7 >> 2] = i5; else {
  i2 = i7 + 4 | 0;
  i3 = i7 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i7 + 12 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
   HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   break;
  } else {
   __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj(i2, i6) | 0;
   break;
  }
 } while (0);
 HEAP32[i1 >> 2] = -1;
 STACKTOP = i8;
 return;
}

function __ZN15LightmapSTCache26ApplyLegacyVertexLitMatrixERK10RenderNodeR9GfxDevice(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i5 = i2 + 224 | 0;
 if ((HEAPU16[i5 >> 1] | 0) < 65534 ? 1 : (HEAPU16[i5 + 2 >> 1] | 0) < 65534) if (!(HEAP16[i2 + 182 >> 1] | 0)) {
  i3 = HEAP32[i2 + 192 >> 2] | 0;
  i4 = HEAP32[i2 + 196 >> 2] | 0;
  i5 = HEAP32[i2 + 200 >> 2] | 0;
  i2 = HEAP32[i2 + 204 >> 2] | 0;
 } else {
  i3 = 1065353216;
  i4 = 1065353216;
  i5 = 0;
  i2 = 0;
 } else {
  i3 = 1065353216;
  i4 = 1065353216;
  i5 = 0;
  i2 = 0;
 }
 __ZN10Matrix4x4f11SetIdentityEv(i1) | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 48 >> 2] = i5;
 HEAP32[i1 + 52 >> 2] = i2;
 i3 = i6 + 2404 | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 STACKTOP = i7;
 return;
}

function __Z33Component_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting25BroadcastScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i2, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z30Camera_CUSTOM_RenderWithShaderP12Il2CppObjectS0_P12Il2CppString(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
 __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i4, 4, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __Z14TriangleArea3DRK8Vector3fS1_S1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(f9 - f6);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f7 - f8);
 f10 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f10 = Math_fround(f10 - f4);
 f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f6);
 f8 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f8);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) - f4);
 f5 = Math_fround(Math_fround(f7 * f4) - Math_fround(f10 * f8));
 f4 = Math_fround(Math_fround(f10 * f6) - Math_fround(f9 * f4));
 f6 = Math_fround(Math_fround(f9 * f8) - Math_fround(f7 * f6));
 return Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f6 * f6) + Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4))))) * Math_fround(.5));
}

function __ZNK6Camera20GetWorldToClipMatrixEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i1 + 1078 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i6 = i1 + 164 | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0;
 i5 = i1 + 36 | 0;
 i6 = i1 + 1076 | 0;
 if (HEAP8[i6 >> 0] | 0) if (HEAP8[i1 + 1080 >> 0] | 0) {
  HEAPF32[i2 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i5, i2) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i5, i2) | 0;
  HEAP8[i6 >> 0] = 0;
 }
 i6 = i1 + 164 | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i4, i5, i6);
 HEAP8[i3 >> 0] = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK5physx2Sc7BodySim13isConnectedToERKNS0_8RigidSimERb(i5, i4, i7) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 i3 = HEAP32[i4 + 28 >> 2] | 0;
 if (i1 >>> 0 > i3 >>> 0) {
  i6 = HEAP32[i4 + 20 >> 2] | 0;
  i2 = i6;
  i6 = i6 + (i3 << 2) | 0;
  i3 = i5;
 } else {
  i6 = HEAP32[i5 + 20 >> 2] | 0;
  i2 = i6;
  i6 = i6 + (i1 << 2) | 0;
  i3 = i4;
 }
 if (i2 >>> 0 >= i6 >>> 0) {
  i8 = 0;
  i6 = 0;
  HEAP8[i7 >> 0] = i6;
  return i8 | 0;
 }
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((HEAP8[i1 + 20 >> 0] | 0) == 1) {
   if ((HEAP32[i1 + 4 >> 2] | 0) == (i3 | 0)) break;
   if ((HEAP32[i1 + 8 >> 2] | 0) == (i3 | 0)) break;
  }
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i2 = 0;
   i8 = 10;
   break;
  }
 }
 if ((i8 | 0) == 10) {
  HEAP8[i7 >> 0] = i2;
  return i1 | 0;
 }
 i8 = 1;
 i6 = (HEAPU16[HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] >> 1] | 0) >>> 3 & 1 ^ 1;
 HEAP8[i7 >> 0] = i6;
 return i8 | 0;
}

function __ZN5physx9NpFactory8addShapeEPNS_7PxShapeEb(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = i2;
 i5 = i2;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 if (i1) {
  i2 = i4 + 4 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb(i4 + 604 | 0, i3, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
  STACKTOP = i7;
  return;
 } else {
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb(i4 + 604 | 0, i3, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
  STACKTOP = i7;
  return;
 }
}

function __ZN18UnityConnectClient23RegisterGlobalCallbacksEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 HEAP8[i3 + 788 >> 0] = 1;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = i4 + 18524 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i1 + 1;
 HEAP32[i4 + 17756 + (i1 * 12 | 0) + 4 >> 2] = i3;
 HEAP8[i4 + 17756 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i4 + 17756 + (i1 * 12 | 0) >> 2] = fb + 200;
 __ZN11UnityEngine7Connect14RemoteSettings8RegisterEPNS0_13ConfigHandlerE(i3 + 768 | 0, HEAP32[i3 + 544 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN17BufferManagerGLES16GetTotalFreeSizeEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP32[i6 + 8 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i5 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  do {
   i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0) + i1 | 0;
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (i3 | 0));
  i5 = 0;
 }
 do {
  i2 = HEAP32[i6 + 16 + (i5 * 12 | 0) >> 2] | 0;
  i4 = i6 + 16 + (i5 * 12 | 0) + 4 | 0;
  i3 = i2;
  if ((i3 | 0) != (i4 | 0)) while (1) {
   i1 = (HEAP32[(HEAP32[i3 + 20 >> 2] | 0) + 8 >> 2] | 0) + i1 | 0;
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i3) while (1) {
    i3 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) break; else i2 = i3;
   } else {
    i2 = i3;
    while (1) {
     i3 = HEAP32[i2 >> 2] | 0;
     if (!i3) {
      i3 = i2;
      break;
     } else i2 = i3;
    }
   }
   if ((i3 | 0) == (i4 | 0)) break; else i2 = i3;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 11);
 return i1 | 0;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801408 | 0, i1, 0);
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802602 | 0, i5, i1 + 96 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802613 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SplatMaterials16DestroyMaterialsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 44 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 48 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 52 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 56 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 60 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 64 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 68 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 72 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = -1;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 378973 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 842535 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 378987 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 56 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z19SplatPrototypeToCppRK18MonoSplatPrototypeR14SplatPrototype(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = i2 + 8 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = i3 + 24 | 0;
 i4 = i2 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __ZNK9Transform18GetWorldScaleLossyEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 72 | 0;
 i5 = i3 + 32 | 0;
 i7 = i3 + 8 | 0;
 i4 = i3 + 16 | 0;
 i8 = i3;
 i9 = i2 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i9;
 i2 = i8;
 HEAP32[i2 >> 2] = i10;
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z23CalculateGlobalRotation23TransformAccessReadOnly(i4, i6);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E(i5, i6, i4);
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i2 = HEAP32[i5 + 32 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741375;
 HEAP32[i1 + 4 >> 2] = 483;
 HEAP32[i1 + 8 >> 2] = fb + 416;
 HEAP32[i1 + 12 >> 2] = fb + 359;
 HEAP32[i1 + 16 >> 2] = gb + 741387;
 HEAP32[i1 + 20 >> 2] = 484;
 HEAP32[i1 + 24 >> 2] = fb + 417;
 HEAP32[i1 + 28 >> 2] = fb + 360;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 485;
 HEAP32[i1 + 40 >> 2] = fb + 418;
 HEAP32[i1 + 44 >> 2] = fb + 361;
 HEAP32[i1 + 48 >> 2] = gb + 741403;
 HEAP32[i1 + 52 >> 2] = 486;
 HEAP32[i1 + 56 >> 2] = fb + 419;
 HEAP32[i1 + 60 >> 2] = fb + 362;
 HEAP32[i1 + 64 >> 2] = gb + 741411;
 HEAP32[i1 + 68 >> 2] = 487;
 HEAP32[i1 + 72 >> 2] = fb + 420;
 HEAP32[i1 + 76 >> 2] = fb + 363;
 HEAP32[i1 + 80 >> 2] = gb + 741427;
 HEAP32[i1 + 84 >> 2] = 501;
 HEAP32[i1 + 88 >> 2] = fb + 421;
 HEAP32[i1 + 92 >> 2] = fb + 364;
 HEAP32[i1 + 96 >> 2] = gb + 741434;
 HEAP32[i1 + 100 >> 2] = 502;
 HEAP32[i1 + 104 >> 2] = fb + 422;
 HEAP32[i1 + 108 >> 2] = fb + 365;
 return;
}

function __ZN4crnd11crnd_mallocEjPj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i2 = i8;
 i6 = i8 + 32 | 0;
 i4 = i8 + 28 | 0;
 i3 = i1 + 3 & -4;
 i3 = i3 | 0 ? i3 : 4;
 if (i3 >>> 0 > 2147418112) {
  HEAP32[i2 >> 2] = gb + 401209;
  HEAP32[i2 + 4 >> 2] = 2513;
  HEAP32[i2 + 8 >> 2] = gb + 401323;
  _sprintf(i6, gb + 401176 | 0, i2) | 0;
  _puts(i6) | 0;
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = i3;
 i1 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, 0, i3 | 0, i4 | 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) HEAP32[i5 >> 2] = i2;
 if ((i1 | 0) == 0 | i2 >>> 0 < i3 >>> 0) {
  HEAP32[i7 >> 2] = gb + 401209;
  HEAP32[i7 + 4 >> 2] = 2513;
  HEAP32[i7 + 8 >> 2] = gb + 401368;
  _sprintf(i6, gb + 401176 | 0, i7) | 0;
  _puts(i6) | 0;
  i1 = 0;
 }
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855611 | 0, i1, 0);
 __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855631 | 0, i5, i1 + 44 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855649 | 0, i5, i1 + 48 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i3 = i4 + 4 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 168 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 156 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 168 | 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 156 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
   i2 = HEAP32[i4 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN15RelativeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 807408 | 0, 14) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 52 >> 0] = 0;
 i2 = i4 + 56 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = i4;
 HEAP32[i4 >> 2] = gb + 157128 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12LightsModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 i2 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0);
 f3 = i5 ? Math_fround(1.0) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(0.0) : f3;
 i2 = i1 + 104 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 f3 = i4 ? Math_fround(0.0) : f3;
 HEAPF32[i2 >> 2] = f3;
 HEAP8[i1 + 110 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 24 | 0, i1 + 112 | 0, f3, HEAP16[i1 + 108 >> 1] | 0) | 0) & 1;
 i2 = i1 + 368 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 f3 = i4 ? Math_fround(0.0) : f3;
 HEAPF32[i2 >> 2] = f3;
 HEAP8[i1 + 374 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 288 | 0, i1 + 376 | 0, f3, HEAP16[i1 + 372 >> 1] | 0) | 0) & 1;
 i1 = i1 + 552 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) < 0 ? 0 : i2;
 return;
}

function __ZN10GameObject28IsActiveIgnoreImplicitPrefabEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 L1 : do if (i3) {
  i5 = HEAP32[gb + 28940 + 24 >> 2] | 0;
  i6 = HEAP32[gb + 28940 + 28 >> 2] | 0;
  i4 = i2 + (i3 << 3) | 0;
  while (1) {
   i3 = i2;
   while (1) {
    if (((HEAP32[i3 >> 2] | 0) - i5 | 0) >>> 0 < i6 >>> 0) break;
    i3 = i3 + 8 | 0;
    if ((i3 | 0) == (i4 | 0)) break L1;
   }
   if (!(HEAP32[i3 + 4 >> 2] | 0)) break L1;
   while (1) if (((HEAP32[i2 >> 2] | 0) - i5 | 0) >>> 0 < i6 >>> 0) break; else i2 = i2 + 8 | 0;
   i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 100 >> 2] | 0;
   if (!i2) break L1;
   if (!(HEAP8[i1 + 54 >> 0] | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i3 = HEAP32[i1 + 40 >> 2] | 0;
   if (!i3) break L1; else i4 = i2 + (i3 << 3) | 0;
  }
  return i1 | 0;
 } while (0);
 i6 = (HEAP8[i1 + 54 >> 0] | 0) != 0;
 return i6 | 0;
}

function __ZL12InvokeMethodI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 56 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i2, (HEAP32[i1 + 900 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z30AudioClip_CUSTOM_Init_InternalP12Il2CppObjectP12Il2CppStringiiih(i2, i1, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 12 | 0;
 i8 = i9;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i9 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i8, i7);
  __ZN9AudioClip15CreateUserSoundERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjsjb(i1, i8, i3, i4 & 65535, i5, i6 << 24 >> 24 != 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i8);
  STACKTOP = i9;
  return;
 }
}

function __ZThn4_N12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = i2 + -4 | 0;
 i6 = HEAP32[i2 + 64 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i3 + 16 | 0, i5 | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 >> 2] | 0) | 0;
 i5 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = gb + 149840 + 8;
 i1 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i5;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i4, 2);
 STACKTOP = i3;
 return (HEAPU8[i2 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofERKS5_j(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i5 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i7 = i6 ? HEAP32[i3 >> 2] | 0 : i3;
 i5 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
 L5 : do if (!i5) i8 = -1; else {
  i6 = i2;
  i1 = i2 + ((i1 >>> 0 > i4 >>> 0 ? i4 + 1 | 0 : i1) << 2) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i8 = -1;
    break L5;
   }
   i1 = i1 + -4 | 0;
   __THREW__ = 0;
   i3 = invoke_iiii(fb + 514 | 0, i7 | 0, i5 | 0, i1 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) break;
   if (i3) {
    i8 = i1 - i6 >> 2;
    break L5;
   }
  }
  i7 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i7);
 } while (0);
 return i8 | 0;
}

function __ZN9dtNavMeshD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i5 + 20 | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[i4 >> 2] | 0;
   if (HEAP32[i2 + (i3 * 56 | 0) + 8 >> 2] | 0) {
    if (HEAP32[i2 + (i3 * 56 | 0) + 48 >> 2] & 1 | 0) {
     i1 = i2 + (i3 * 56 | 0) + 40 | 0;
     mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
     HEAP32[i1 >> 2] = 0;
     HEAP32[i2 + (i3 * 56 | 0) + 44 >> 2] = 0;
    }
    i1 = i2 + (i3 * 56 | 0) + 12 | 0;
    mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 8 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 48 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i5 + 36 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN7mecanim5human29HumanFixEndPointsSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_i(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0;
 i6 = i4 + 4 | 0;
 i7 = HEAP32[i1 + 72 + (i7 << 2) >> 2] | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i9 = i2 + 4 | 0;
 i9 = (HEAP32[i9 >> 2] | 0) + i9 | 0;
 i8 = HEAP32[i9 + (i7 * 40 | 0) + 16 >> 2] | 0;
 i2 = HEAP32[i9 + (i7 * 40 | 0) + 20 >> 2] | 0;
 i3 = HEAP32[i9 + (i7 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i6 + (i7 * 40 | 0) + 12 >> 2] = HEAP32[i9 + (i7 * 40 | 0) + 12 >> 2];
 HEAP32[i6 + (i7 * 40 | 0) + 16 >> 2] = i8;
 HEAP32[i6 + (i7 * 40 | 0) + 20 >> 2] = i2;
 HEAP32[i6 + (i7 * 40 | 0) + 24 >> 2] = i3;
 i6 = i1 + 40 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii((i3 | 0) == 0 ? 0 : i3 + i6 | 0, i4, i5, i7, i7);
 return;
}

function __ZN20TextRenderingPrivate8FontImpl34GetNumCharactersThatFitWithinWidthERK11UTF16Stringfij(i2, i4, f6, i7, i8) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, f3 = f0, f5 = f0, i9 = 0;
 i9 = i4 + 4 | 0;
 __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE(i2, HEAP32[i4 >> 2] | 0, HEAP32[i9 >> 2] | 0, 0, Math_fround(1.0), 0, 0) | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 if (!i9) {
  i9 = 0;
  return i9 | 0;
 } else {
  f3 = Math_fround(0.0);
  i1 = 0;
 }
 while (1) {
  f5 = Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(i2, HEAPU16[(HEAP32[i4 >> 2] | 0) + (i1 << 1) >> 1] | 0, i7, i8, Math_fround(1.0), 0));
  if (f5 == Math_fround(0.0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
  f3 = Math_fround(f3 + f5);
  if (f3 > f6) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i9 >>> 0) {
   i1 = i9;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN15AudioMixerGroupC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 174700 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 884 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 884 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function ___shgetc(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i2 = i6 + 104 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i7 = 3; else if ((HEAP32[i6 + 108 >> 2] | 0) < (i1 | 0)) i7 = 3; else i7 = 4;
 if ((i7 | 0) == 3) {
  i1 = ___uflow(i6) | 0;
  if ((i1 | 0) < 0) i7 = 4; else {
   i2 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i6 + 8 >> 2] | 0;
   if (!i2) {
    i3 = i5;
    i7 = 9;
   } else {
    i4 = HEAP32[i6 + 4 >> 2] | 0;
    i2 = i2 - (HEAP32[i6 + 108 >> 2] | 0) | 0;
    i3 = i5;
    if ((i5 - i4 | 0) < (i2 | 0)) i7 = 9; else HEAP32[i6 + 100 >> 2] = i4 + (i2 + -1);
   }
   if ((i7 | 0) == 9) HEAP32[i6 + 100 >> 2] = i5;
   i2 = i6 + 4 | 0;
   if (!i3) i2 = HEAP32[i2 >> 2] | 0; else {
    i2 = HEAP32[i2 >> 2] | 0;
    i6 = i6 + 108 | 0;
    HEAP32[i6 >> 2] = i3 + 1 - i2 + (HEAP32[i6 >> 2] | 0);
   }
   i2 = i2 + -1 | 0;
   if ((HEAPU8[i2 >> 0] | 0 | 0) != (i1 | 0)) HEAP8[i2 >> 0] = i1;
  }
 }
 if ((i7 | 0) == 4) {
  HEAP32[i6 + 100 >> 2] = 0;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZNK11b2EdgeShape5CloneEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 48) | 0;
 HEAP32[i2 >> 2] = gb + 151648 + 8;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 151644 >> 2];
 i5 = i2 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP16[i5 + 16 >> 1] = 0;
 i5 = i1 + 4 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i2 + 12 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP16[i3 + 32 >> 1] = HEAP16[i1 + 32 >> 1] | 0;
 return i2 | 0;
}

function __ZN7mecanim9animation17SampleClipAtIndexERKNS0_9DenseClipEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 f5 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 12 >> 2]));
 f5 = Math_fround(_modff(Math_fround(f5 * Math_fround(HEAPF32[i1 + 8 >> 2])), i6));
 i6 = ~~Math_fround(HEAPF32[i6 >> 2]);
 i9 = i6 + 1 | 0;
 i6 = (i6 | 0) > 0 ? i6 : 0;
 i8 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 i9 = (i9 | 0) > 0 ? i9 : 0;
 i7 = i1 + 20 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = Math_imul((i6 | 0) < (i8 | 0) ? i6 : i8, i1) | 0;
 i7 = (HEAP32[i7 >> 2] | 0) + i7 | 0;
 i1 = i7 + ((Math_imul((i9 | 0) < (i8 | 0) ? i9 : i8, i1) | 0) << 2) | 0;
 f3 = Math_fround(HEAPF32[i7 + (i6 << 2) + (i2 << 2) >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]) - f3)));
 STACKTOP = i4;
 return Math_fround(f3);
}

function __ZN4crnd17crnd_unpack_levelEPvPS0_jjj(i3, i4, i5, i7, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 if ((i3 | 0) == 0 | (i4 | 0) == 0 | i5 >>> 0 < 8 | i8 >>> 0 > 15) {
  i8 = 0;
  return i8 | 0;
 }
 if ((HEAP32[i3 >> 2] | 0) != 519686845) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 i6 = (HEAPU8[i1 + 70 + (i8 << 2) + 1 >> 0] | 0) << 16 | (HEAPU8[i1 + 70 + (i8 << 2) >> 0] | 0) << 24 | (HEAPU8[i1 + 70 + (i8 << 2) + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 70 + (i8 << 2) + 3 >> 0] | 0);
 i2 = i8 + 1 | 0;
 if (i2 >>> 0 < (HEAPU8[i1 + 16 >> 0] | 0) >>> 0) i1 = (HEAPU8[i1 + 70 + (i2 << 2) + 1 >> 0] | 0) << 16 | (HEAPU8[i1 + 70 + (i2 << 2) >> 0] | 0) << 24 | (HEAPU8[i1 + 70 + (i2 << 2) + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 70 + (i2 << 2) + 3 >> 0] | 0); else i1 = HEAP32[i3 + 8 >> 2] | 0;
 i8 = __ZN4crnd12crn_unpacker12unpack_levelEPKvjPPvjjj(i3, (HEAP32[i3 + 4 >> 2] | 0) + i6 | 0, i1 - i6 | 0, i4, i5, i7, i8) | 0;
 return i8 | 0;
}

function __ZN4FMOD7Channel13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_(i2, i1, i3, i4, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868616;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868616;
   _printf(gb + 853343 | 0, i5) | 0;
   i9 = 78;
   STACKTOP = i6;
   return i9 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868616;
 _printf(gb + 853184 | 0, i3) | 0;
 i9 = 36;
 STACKTOP = i6;
 return i9 | 0;
}

function __ZN20UnityConnectSettings16SetTestConfigUrlE8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 216 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 224 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 220 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 220 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801702 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 835574 | 0, i5, i1 + 32 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 801720 | 0, i5, i1 + 36 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13TargetJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 807186 | 0, 14) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 52 >> 0] = 0;
 i2 = i4 + 56 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = i4;
 HEAP32[i4 >> 2] = gb + 158108 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801395 | 0, i1, 0);
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i5 = HEAP32[gb + 37012 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 803283 | 0, i5, i1 + 96 | 0, 0);
 i4 = i2 + 16 | 0;
 i3 = i2 + 24 | 0;
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 853582 | 0, i5, i1 + 100 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartColorP12Il2CppObjectR18MonoMinMaxGradient(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient(i2, (HEAP32[i1 + 44 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __GLOBAL__sub_I_runtime_application_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1103884 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1103884 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1103884 + 12 >> 2] = 16;
 i1 = gb + 1103884 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3296 | 0, fb + 3297 | 0, 0, gb + 1103884 | 0);
 HEAP32[gb + 1103964 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1103964 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1103964 + 12 >> 2] = 16;
 i1 = gb + 1103964 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3298 | 0, fb + 3299 | 0, 0, gb + 1103964 | 0);
 return;
}

function _UNITY_png_set_background(i8, i9, i10, i11, d1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = _UNITY_png_fixed(i8, d1, gb + 353895 | 0) | 0;
 if (!i8) return;
 i7 = i8 + 208 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2 & 64 | 0) {
  _UNITY_png_app_error(i8, gb + 353836 | 0);
  return;
 }
 i2 = i2 | 16384;
 HEAP32[i7 >> 2] = i2;
 if ((i9 | 0) == 0 | (i10 | 0) == 0) return;
 i3 = i8 + 212 | 0;
 i4 = HEAP32[i3 >> 2] & -8650881;
 i5 = i4 | 262272;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i7 >> 2] = i2 & -8193;
 i7 = i8 + 448 | 0;
 HEAP16[i7 >> 1] = HEAP16[i9 >> 1] | 0;
 HEAP16[i7 + 2 >> 1] = HEAP16[i9 + 2 >> 1] | 0;
 HEAP16[i7 + 4 >> 1] = HEAP16[i9 + 4 >> 1] | 0;
 HEAP16[i7 + 6 >> 1] = HEAP16[i9 + 6 >> 1] | 0;
 HEAP16[i7 + 8 >> 1] = HEAP16[i9 + 8 >> 1] | 0;
 HEAP32[i8 + 444 >> 2] = i6;
 HEAP8[i8 + 442 >> 0] = i10;
 if (!i11) {
  HEAP32[i3 >> 2] = i5 & -8388865;
  return;
 } else {
  HEAP32[i3 >> 2] = i4 | 262528;
  return;
 }
}

function __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EERKSB_PKS8_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
 i1 = _strlen(i4) | 0;
 __THREW__ = 0;
 invoke_viiii(fb + 365 | 0, i2 | 0, (i6 ? HEAP32[i3 >> 2] | 0 : i3) | 0, i5 | 0, i5 + i1 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (!(i3 & 1)) {
  __THREW__ = 0;
  invoke_iiii(fb + 519 | 0, i2 | 0, i4 | 0, i1 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) return;
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i2);
 ___resumeException(i6 | 0);
}

function __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_(i8, i9, i6, i5, i4, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i7 = 0;
 i7 = __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 if (f2 < f3) {
  HEAPF32[i5 >> 2] = f2;
  HEAPF32[i4 >> 2] = f3;
  i1 = i7 + 1 | 0;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  f3 = Math_fround(HEAPF32[i6 >> 2]);
  if (f2 < f3) {
   HEAPF32[i6 >> 2] = f2;
   HEAPF32[i5 >> 2] = f3;
   i1 = i7 + 2 | 0;
   f2 = Math_fround(HEAPF32[i6 >> 2]);
   f3 = Math_fround(HEAPF32[i9 >> 2]);
   if (f2 < f3) {
    HEAPF32[i9 >> 2] = f2;
    HEAPF32[i6 >> 2] = f3;
    f2 = Math_fround(HEAPF32[i9 >> 2]);
    f3 = Math_fround(HEAPF32[i8 >> 2]);
    if (f2 < f3) {
     HEAPF32[i8 >> 2] = f2;
     HEAPF32[i9 >> 2] = f3;
     i1 = i7 + 4 | 0;
    } else i1 = i7 + 3 | 0;
   }
  }
 } else i1 = i7;
 return i1 | 0;
}

function __ZNSt3__211__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i4 = i5;
 __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2Ev(i2);
 HEAP32[i2 >> 2] = gb + 209316 + 8;
 HEAP32[i2 + 32 >> 2] = i1;
 __ZNSt3__26localeC2ERKS0_(i6, i2 + 4 | 0);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1476360 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i4);
  __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev(i2);
  ___resumeException(i6 | 0);
 } else {
  __ZNSt3__26localeD2Ev(i4);
  HEAP32[i2 + 36 >> 2] = i1;
  HEAP32[i2 + 40 >> 2] = i3;
  HEAP8[i2 + 44 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) & 1;
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__211__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i4 = i5;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i2);
 HEAP32[i2 >> 2] = gb + 209380 + 8;
 HEAP32[i2 + 32 >> 2] = i1;
 __ZNSt3__26localeC2ERKS0_(i6, i2 + 4 | 0);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1476352 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (i6 & 1) {
  i6 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i4);
  __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i2);
  ___resumeException(i6 | 0);
 } else {
  __ZNSt3__26localeD2Ev(i4);
  HEAP32[i2 + 36 >> 2] = i1;
  HEAP32[i2 + 40 >> 2] = i3;
  HEAP8[i2 + 44 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) & 1;
  STACKTOP = i5;
  return;
 }
}

function __ZN6Camera18DoRenderPostLayersEPK11CullResultsR17ShaderPassContextNS_10RenderFlagE(i5, i6, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i5 + 36 | 0;
 i3 = i5 + 1076 | 0;
 if (HEAP8[i3 >> 0] | 0) if (HEAP8[i5 + 1080 >> 0] | 0) {
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(-1.0);
  __ZN10Matrix4x4f8SetScaleERK8Vector3f(i2, i1) | 0;
  __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i5 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  __ZN10Matrix4x4fmLERKS_(i2, i1) | 0;
  HEAP8[i3 >> 0] = 0;
 }
 __ZN6Camera22RenderHaloAndLensFlareEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f(i5, i6, i7, i2);
 __ZN13RenderManager29InvokeOnRenderObjectCallbacksEv(__Z16GetRenderManagerv() | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIfdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, d5 = 0.0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
  d5 = +Math_fround(HEAPF32[tempDoublePtr >> 2]);
  HEAPF64[tempDoublePtr >> 3] = d5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i7, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i7 >>> 0) __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + (i7 << 5) | 0;
 if ((i1 | 0) >= (i7 | 0)) {
  HEAP32[i4 >> 2] = i7;
  return;
 }
 i2 = i6 + 16 | 0;
 i1 = i3 + (i1 << 5) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 HEAP32[i4 >> 2] = i7;
 return;
}

function __ZN4FMOD7Channel15setChannelGroupEPNS_12ChannelGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
    if (!i1) i1 = 0; else if (!(HEAP8[i1 + 16 >> 0] | 0)) i1 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0; else i1 = 0;
   }
   HEAP32[i3 + 68 >> 2] = i1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859059;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN20UnityConnectSettings15SetTestEventUrlE8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 200 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 208 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 204 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 204 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN13GfxDeviceGLES18CreateVertexBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63304 | 0, 16, gb + 603515 | 0, 1419) | 0;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 76928 + 8;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, gb + 63664 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 40 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i3 + 56 >> 0] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i4 = HEAP32[i3 + 16 >> 2] | 0;
 HEAP32[i3 + 32 >> 2] = i4 >>> 0 < 4 ? i4 : 1;
 __ZN9GfxDevice14OnCreateBufferEP9GfxBuffer(i1, i3);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZL22CleanupUnityWebStreamsPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[gb + 1451260 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = i3;
  i1 = i3;
  i2 = i3 + 4 | 0;
  i5 = 7;
 } else {
  do {
   __ZN14UnityWebStream7ReleaseEv(i1);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = HEAP32[gb + 1451260 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i2 = i3 + 4 | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i4 = i3;
   i1 = i3;
   i5 = 7;
  } else {
   do {
    i4 = i1 + 4 | 0;
    i6 = i1;
    i1 = HEAP32[i4 >> 2] | 0;
    HEAP32[i6 >> 2] = 0;
    HEAP32[i4 >> 2] = 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[gb + 1451260 >> 2] | 0;
   HEAP32[i2 >> 2] = i3;
   HEAP32[i3 >> 2] = i3;
   if (i1 | 0) i5 = 9;
  }
 }
 if ((i5 | 0) == 7) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = i4;
  i5 = 9;
 }
 if ((i5 | 0) == 9) __ZdlPv(i1);
 HEAP32[gb + 1451260 >> 2] = 0;
 return;
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 884 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZNK14ParticleSystem13GetStartColorEv(i3, i4);
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i4;
  STACKTOP = i5;
  return;
 }
}

function __Z45GUIElement_CUSTOM_INTERNAL_CALL_GetScreenRectP12Il2CppObjectS0_R5RectTIfE(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i6 = i8;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0;
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 __Z21GetCameraOrWindowRectPK6Camera(i6, i1);
 mftCall_viii(i3 | 0, i5 | 0, i7 | 0, i6 | 0);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i8;
 return;
}

function __Z37Graphics_CUSTOM_Internal_BlitMaterialP12Il2CppObjectS0_S0_ih(i3, i5, i1, i7, i8) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517913 | 0, i2);
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517913 | 0, i2);
 i4 = HEAP32[gb + 1166248 >> 2] | 0;
 if (!i3) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i5) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(i4, i2, i1, i6, i7, i8 << 24 >> 24 != 0 & 1, -1, gb + 62472 | 0, gb + 1162356 | 0);
 STACKTOP = i9;
 return;
}

function __Z17mono_profiler_endi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, d6 = 0.0;
 i2 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 i3 = HEAP32[gb + 1451e3 >> 2] | 0;
 i4 = i2 + 48 | 0;
 i5 = i2 + 36 | 0;
 do {
  if ((HEAP32[(HEAP32[i5 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) + -1 << 4) >> 2] | 0) == (i1 | 0)) break;
  d6 = +_emscripten_get_now() * 1.0e6;
 } while (__ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i2, 0, ~~d6 >>> 0, +Math_abs(d6) >= 1.0 ? (d6 > 0.0 ? ~~+Math_min(+Math_floor(d6 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d6 - +(~~d6 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 if (HEAP32[i3 + 24 >> 2] & 4 | 0) return;
 d6 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i2, 0, ~~d6 >>> 0, +Math_abs(d6) >= 1.0 ? (d6 > 0.0 ? ~~+Math_min(+Math_floor(d6 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d6 - +(~~d6 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 return;
}

function __ZN9Texture2D18UnshareTextureDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 1) return;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63272 | 0, 16, gb + 410682 | 0, 378) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 41960 + 8;
 __ZN13dynamic_arrayIhLj1EEC2ERKS0_(i2 + 8 | 0, i4 + 8 | 0);
 i1 = i2 + 28 | 0;
 i4 = i4 + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
 }
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN8Animator20OnCullingModeChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) {
  __ZN8Animator23ClearContainedRenderersEv(i1);
  if (!(HEAP32[i1 + 92 >> 2] | 0)) {
   HEAP8[i1 + 88 >> 0] = 1;
   break;
  } else {
   __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0);
   HEAP8[i1 + 88 >> 0] = (__ZNK8Animator20IsAnyRendererVisibleEv(i1) | 0) & 1;
   break;
  }
 } while (0);
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 if (!(HEAP8[i1 + 88 >> 0] | 0)) if ((HEAP32[i1 + 92 >> 2] | 0) == 2) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, 0);
  return;
 }
 i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, 1);
 return;
}

function __ZN5physx7NpScene17createVolumeCacheEjj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i7 = i5;
 i8 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i9 | 0, i8 | 0, 120, (i4 ? gb + 704445 | 0 : gb + 837976 | 0) | 0, gb + 678666 | 0, 2579) | 0;
 __ZN5physx13NpVolumeCacheC2EPNS_2Sq17SceneQueryManagerEjj(i4, i3 + 3392 | 0, i2, i1);
 HEAP32[i7 >> 2] = i4;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb(i3 + 3588 | 0, i7, i6) | 0;
 if (HEAP8[i6 >> 0] | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = i4;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx2Sc19ParticlePacketShapeD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 106748 + 8;
 i4 = i5 + 8 | 0;
 __ZN5physx2Sc17ParticleSystemSim19unlinkParticleShapeEPNS0_19ParticlePacketShapeE(HEAP32[i4 >> 2] | 0, i5);
 __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_19ParticlePacketShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i4 >> 2] | 0) | 0, i5);
 i1 = i5 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP16[i5 + 42 >> 1] = 0;
 i1 = i5 + 36 | 0;
 i2 = i5 + 40 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == 0 | (i3 | 0) == (i5 + 20 | 0)) {
  HEAP16[i2 >> 1] = 0;
  HEAP32[i1 >> 2] = 0;
  __ZN5physx2Sc7ElementD2Ev(i5);
  return;
 }
 __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i3, HEAPU16[i2 >> 1] | 0);
 HEAP16[i2 >> 1] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx2Sc7ElementD2Ev(i5);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE17setDominanceGroupEh(i3, i9) {
 i3 = i3 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + (HEAPU16[i3 + 4 >> 1] << 2) >> 2] | 0;
 i7 = i3 + i2 | 0;
 i8 = i3 + (i2 + 4) | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i5 >>> 24 & 15;
 i1 = (HEAP32[gb + 90260 + 24 + (i6 << 2) >> 2] | 0) + i7 | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i1, i9);
  return;
 }
 i2 = i3 + (i2 + 8) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i6) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 2 >> 0] = i9;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 2;
 return;
}

function __ZN5physx13NpRigidStatic12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 99672 + 8;
 i5 = i4 + 20 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE(i5, i6);
 HEAP32[i4 + 36 >> 2] = -1;
 HEAP32[i4 >> 2] = gb + 99820 + 8;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 56 >> 2] = 0;
 i6 = i4 + 52 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & 251658240;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP8[i4 + 75 >> 0] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 112;
 __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE(i5, i2);
 __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE(i4 + 12 | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i2 | 0);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN22UnityAnalyticsSettings16SetTestConfigUrlE8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 28 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 36 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 32 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 32 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN21AnimationClipOverride8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 905707 | 0, gb + 905722 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 905742 | 0, gb + 905722 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855869 | 0, i1, 0);
 __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 3);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855888 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 132 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 44 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855908 | 0, gb + 1034188 | 0, i1, 0);
 __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17ProfilerFrameData17ReleaseTimerQueryEP13GfxTimerQuery(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = HEAP32[gb + 1163260 >> 2] | 0;
 i4 = i3 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 1 | 0;
 i7 = i3 + 16 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i9 = i8 & 2147483647;
 do if (i6 >>> 0 > i9 >>> 0) {
  i2 = i8 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i9 >>> 0 < i2 >>> 0) if ((i8 | 0) > -1) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i9 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i9 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i3 >> 2] = i9;
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i6;
 HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i1;
 return;
}

function __Z50AnimatorOverrideController_CUSTOM_Internal_SetClipP12Il2CppObjectS0_S0_h(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 12 | 0;
 i1 = i10 + 8 | 0;
 i7 = i10 + 4 | 0;
 i8 = i10;
 if (!i3) {
  i9 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i9);
 }
 i9 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i9) {
  i10 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  HEAP32[i7 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i8 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i5) | 0;
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  __ZN26AnimatorOverrideController7SetClipE4PPtrI13AnimationClipES2_b(i9, i1, i2, i6 << 24 >> 24 != 0);
  STACKTOP = i10;
  return;
 }
}

function __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 i2 = HEAP16[i4 >> 1] | 0;
 if (i1 << 16 >> 16 < i2 << 16 >> 16) {
  HEAP16[i4 >> 1] = i1;
  HEAP16[i3 >> 1] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP16[i4 >> 1] | 0;
  i3 = HEAP16[i5 >> 1] | 0;
  if (i2 << 16 >> 16 < i3 << 16 >> 16) {
   HEAP16[i5 >> 1] = i2;
   HEAP16[i4 >> 1] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP16[i5 >> 1] | 0;
   i3 = HEAP16[i8 >> 1] | 0;
   if (i2 << 16 >> 16 < i3 << 16 >> 16) {
    HEAP16[i8 >> 1] = i2;
    HEAP16[i5 >> 1] = i3;
    i1 = HEAP16[i8 >> 1] | 0;
    i2 = HEAP16[i7 >> 1] | 0;
    if (i1 << 16 >> 16 < i2 << 16 >> 16) {
     HEAP16[i7 >> 1] = i1;
     HEAP16[i8 >> 1] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZN8Collider29FetchPoseFromTransformUtilityERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 48 | 0;
 i6 = i3 + 32 | 0;
 i4 = i3;
 i7 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i5, i7, i2);
 __ZNK9Transform11GetRotationEv(i6, i7);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 8 >> 2];
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i4 | 0, 1);
 STACKTOP = i3;
 return;
}

function __ZN6Object16StaticInitializeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1104724 >> 2] | 0, 0, 0) | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63520 | 0, 16, gb + 369627 | 0, 804) | 0;
 __ZN28InstanceIdToObjectPtrHashMapC2Ei(i3, 131072);
 HEAP32[gb + 1104264 >> 2] = i3;
 i3 = i1;
 i5 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP32[i1 + 8 >> 2] = gb + 590125;
 HEAP32[i1 + 12 >> 2] = gb + 1576256;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 28;
 HEAP32[i1 + 24 >> 2] = -2147483648;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP32[i1 + 40 >> 2] = gb + 28304;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i1);
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i4;
 return;
}

function __ZN22UnityAnalyticsSettings15SetTestEventUrlE8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 12 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 20 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 16 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 16 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN19TouchPhaseEmulation18PostprocessTouchesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 12 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 i4 = i1 + 4 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i4 >> 2] | 0;
  do if ((HEAP32[i5 + (i1 * 96 | 0) >> 2] | 0) != -1) {
   i6 = i5 + (i1 * 96 | 0) + 36 | 0;
   if (((HEAP32[i6 >> 2] | 0) + -3 | 0) >>> 0 >= 2) {
    i2 = i5 + (i1 * 96 | 0) + 92 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 + -3 | 0) >>> 0 < 2) {
     HEAP32[i5 + (i1 * 96 | 0) + 20 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 24 >> 2] = 0;
     HEAP32[i6 >> 2] = i3;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 84 >> 2] = HEAP32[i7 >> 2];
     break;
    } else {
     HEAP32[i6 >> 2] = 2;
     HEAP32[i5 + (i1 * 96 | 0) + 20 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 24 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 84 >> 2] = HEAP32[i7 >> 2];
     break;
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 return;
}

function __ZN11UnityEngine9Analytics13UserInfoEventD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188648 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine7Connect15AppInstallEventD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188916 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __Z6md5_32PKvijPv(i2, i5, i1, i10) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 1732584193;
 HEAP32[i7 + 12 >> 2] = -271733879;
 HEAP32[i7 + 16 >> 2] = -1732584194;
 HEAP32[i7 + 20 >> 2] = 271733878;
 do if ((i5 | 0) >= 1) {
  HEAP32[i7 >> 2] = i5;
  if ((i5 | 0) > 63) {
   i4 = i5 + -64 | 0;
   i6 = i4 & -64;
   i3 = i2;
   i1 = i5;
   while (1) {
    __ZL11md5_processP11md5_contextPh(i7, i3);
    i1 = i1 + -64 | 0;
    if ((i1 | 0) <= 63) break; else i3 = i3 + 64 | 0;
   }
   i1 = i4 - i6 | 0;
   if ((i1 | 0) > 0) i2 = i2 + (i6 + 64) | 0; else break;
  } else i1 = i5;
  _memcpy(i7 + 24 | 0, i2 | 0, i1 | 0) | 0;
 } while (0);
 __Z10md5_finishP11md5_contextPh(i7, i8);
 HEAP32[i10 >> 2] = HEAP32[i8 >> 2];
 STACKTOP = i9;
 return;
}

function __Z46ShaderVariantCollection_CUSTOM_Internal_CreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 563359 | 0, 1259) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN23ShaderVariantCollectionC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return;
}

function __Z29StdTemplateConversionFunctionIthEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionItaEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIshEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIsaEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1 & 255;
  HEAP8[i5 >> 0] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6 & 255;
 HEAP8[i5 >> 0] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z23PlayerSendFrameCompleteb(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1450864 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450864 | 0, i1);
  i1 = gb + 1450864 | 0;
 } else i1 = 0;
 i2 = HEAP32[gb + 1450864 >> 2] | 0;
 i5 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 648 >> 2] | 0, i5 | 0, i2 | 0);
 i2 = __Z21GetDelayedCallManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, 32);
 i2 = HEAP32[gb + 1115296 + 424 >> 2] | 0;
 if ((i2 | 0) != 0 & i3) mftCall_v(i2 | 0);
 i5 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 652 >> 2] | 0, i5 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function _jpeg_CreateCompress(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 if ((i1 | 0) != 62) {
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 12;
  HEAP32[i3 + 24 >> 2] = 62;
  HEAP32[i3 + 28 >> 2] = i1;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
 }
 if ((i2 | 0) == 360) i1 = i4; else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 21;
  HEAP32[i1 + 24 >> 2] = 360;
  HEAP32[i1 + 28 >> 2] = i2;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
  i1 = i4;
 }
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = i4 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(i4 + 4 | 0, 0, 356) | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 HEAP8[i4 + 16 >> 0] = 0;
 _jinit_memory_mgr(i1);
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 352 >> 2] = 0;
 i1 = i4 + 48 | 0;
 i2 = i4 + 68 | 0;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF64[i1 >> 3] = 1.0;
 HEAP32[i4 + 20 >> 2] = 100;
 return;
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_(i5, i1, i3, i9, i11, i6, i4, i12) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = i3;
 i2 = i6;
 i7 = i4;
 if (!(HEAP32[i5 + 12 >> 2] & 2)) i10 = 4; else if ((i7 - i2 | 0) < 2) i3 = 1; else {
  HEAP8[i6 >> 0] = -1;
  HEAP8[i6 + 1 >> 0] = -2;
  i2 = i6 + 2 | 0;
  i10 = 4;
 }
 L4 : do if ((i10 | 0) == 4) while (1) {
  if (i3 >>> 0 >= i9 >>> 0) {
   i3 = 0;
   break L4;
  }
  i3 = HEAP16[i3 >> 1] | 0;
  i10 = i3 & 65535;
  if (i10 >>> 0 > i8 >>> 0 | (i10 & 63488 | 0) == 55296) {
   i3 = 2;
   break L4;
  }
  i4 = i2;
  if ((i7 - i2 | 0) < 2) {
   i3 = 1;
   break L4;
  }
  HEAP8[i4 >> 0] = i3;
  HEAP8[i4 + 1 >> 0] = (i3 & 65535) >>> 8;
  i3 = i1 + 2 | 0;
  i2 = i4 + 2 | 0;
  i1 = i3;
  i10 = 4;
 } while (0);
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 return i3 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_(i5, i1, i3, i9, i11, i6, i4, i12) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i12 = i12 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i10 = 0;
 i8 = HEAP32[i5 + 8 >> 2] | 0;
 i1 = i3;
 i2 = i6;
 i7 = i4;
 if (!(HEAP32[i5 + 12 >> 2] & 2)) i10 = 4; else if ((i7 - i2 | 0) < 2) i3 = 1; else {
  HEAP8[i6 >> 0] = -2;
  HEAP8[i6 + 1 >> 0] = -1;
  i2 = i6 + 2 | 0;
  i10 = 4;
 }
 L4 : do if ((i10 | 0) == 4) while (1) {
  if (i3 >>> 0 >= i9 >>> 0) {
   i3 = 0;
   break L4;
  }
  i3 = HEAP16[i3 >> 1] | 0;
  i10 = i3 & 65535;
  if (i10 >>> 0 > i8 >>> 0 | (i10 & 63488 | 0) == 55296) {
   i3 = 2;
   break L4;
  }
  i4 = i2;
  if ((i7 - i2 | 0) < 2) {
   i3 = 1;
   break L4;
  }
  HEAP8[i4 >> 0] = (i3 & 65535) >>> 8;
  HEAP8[i4 + 1 >> 0] = i3;
  i3 = i1 + 2 | 0;
  i2 = i4 + 2 | 0;
  i1 = i3;
  i10 = 4;
 } while (0);
 HEAP32[i11 >> 2] = i1;
 HEAP32[i12 >> 2] = i2;
 return i3 | 0;
}

function __ZNK5physx2Sc9ClothCore25getVirtualParticleWeightsEPNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 24 | 0;
 i5 = i3 + 16 | 0;
 i9 = i3 + 8 | 0;
 i8 = i3;
 i1 = i1 + 28 | 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i10 = i2 + ((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 240 >> 2] | 0, i10 | 0) | 0) * 12 | 0) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i10;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 mftCall_viiii(i7 | 0, i6 | 0, i1 | 0, i5 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZNK29ParticleSystemPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, f10 = f0;
 i8 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 << 4) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i8 | 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  f10 = Math_fround(0.0);
  return Math_fround(f10);
 }
 if ((i1 | 0) == (i6 | 0) ? 1 : (i8 | 0) < (HEAP32[i1 >> 2] | 0)) {
  f10 = Math_fround(0.0);
  return Math_fround(f10);
 }
 i9 = HEAP32[i1 + 4 >> 2] | 0;
 f10 = Math_fround(+mftCall_fiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 4 >> 2] | 0, i9 | 0, HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0));
 return Math_fround(f10);
}

function __ZN9AudioClipD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i4 >> 2] = gb + 170536 + 8;
 i1 = HEAP32[i4 + 124 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   i3 = i1 + 12 | 0;
   if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i5 >> 2] = 27;
   HEAP32[i5 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i5);
  }
  __ZdlPv(i1);
 }
 HEAP32[i4 >> 2] = gb + 170392 + 8;
 i1 = i4 + 72 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i4 + 84 >> 2] | 0;
  HEAP32[i5 >> 2] = 66;
  HEAP32[i5 + 4 >> 2] = i2;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i5);
 }
 __ZN11SoundHandleD2Ev(i4 + 56 | 0);
 HEAP32[i4 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i4 + 28 | 0);
 HEAP32[i4 >> 2] = gb + 26392 + 8;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc24ConstraintProjectionTree11projectPoseERNS0_19ConstraintGroupNodeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i5 + 36 | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 do {
  __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE(i5, HEAP32[i3 >> 2] | 0);
  HEAP32[i4 >> 2] = i3;
  i2 = i5;
  i1 = i3;
  while (1) {
   if (!i1) {
    i1 = HEAP32[i2 + 28 >> 2] | 0;
    if (!i1) break;
   } else while (1) {
    i2 = HEAP32[i1 + 40 >> 2] | 0;
    if (i2 | 0) if (__ZN5physx2Sc13ConstraintSim14hasDynamicBodyEv(i2) | 0) if (__ZN5physx2Sc13ConstraintSim15needsProjectionEv(i2) | 0) __ZN5physx2Sc13ConstraintSim11projectPoseEPNS0_7BodySimE(i2, HEAP32[i1 >> 2] | 0);
    i2 = HEAP32[i1 + 32 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   i2 = i1;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
  }
  i3 = HEAP32[i3 + 24 >> 2] | 0;
 } while ((i3 | 0) != 0);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Gu16computeBoxPointsERKNS_9PxBounds3EPNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i2 + 8 >> 2] = i7;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = i5;
 HEAP32[i2 + 16 >> 2] = i6;
 HEAP32[i2 + 20 >> 2] = i7;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 24 >> 2] = i5;
 HEAP32[i2 + 28 >> 2] = i3;
 HEAP32[i2 + 32 >> 2] = i7;
 HEAP32[i2 + 36 >> 2] = i4;
 HEAP32[i2 + 40 >> 2] = i3;
 HEAP32[i2 + 44 >> 2] = i7;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = i4;
 HEAP32[i2 + 52 >> 2] = i6;
 HEAP32[i2 + 56 >> 2] = i1;
 HEAP32[i2 + 60 >> 2] = i5;
 HEAP32[i2 + 64 >> 2] = i6;
 HEAP32[i2 + 68 >> 2] = i1;
 HEAP32[i2 + 72 >> 2] = i5;
 HEAP32[i2 + 76 >> 2] = i3;
 HEAP32[i2 + 80 >> 2] = i1;
 HEAP32[i2 + 84 >> 2] = i4;
 HEAP32[i2 + 88 >> 2] = i3;
 HEAP32[i2 + 92 >> 2] = i1;
 return;
}

function __ZN14Texture2DArrayD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 HEAP32[i2 >> 2] = gb + 46032 + 8;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i4 = i2 + 108 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  HEAP32[i2 >> 2] = gb + 32336 + 8;
  i4 = i2 + 28 | 0;
  __ZN14ConstantStringD2Ev(i4);
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 i4 = i2 + 28 | 0;
 __ZN14ConstantStringD2Ev(i4);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN13ComputeBuffer20ReloadAllToGfxDeviceEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i4 = i5;
 i1 = HEAP32[gb + 1166280 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1166280 | 0)) {
  STACKTOP = i5;
  return;
 }
 do {
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i9 = __Z25GetUncheckedRealGfxDevicev() | 0;
  i8 = i6 + 12 | 0;
  HEAP32[i8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i9 >> 2] | 0) + 744 >> 2] | 0, i9 | 0) | 0;
  i9 = __Z12GetGfxDevicev() | 0;
  i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 804 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
  i8 = HEAP32[i6 >> 2] | 0;
  i7 = HEAP32[i6 + 4 >> 2] | 0;
  i6 = HEAP32[i6 + 8 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  mftCall_viiiii(i10 | 0, i9 | 0, i3 | 0, i8 | 0, i7 | 0, i6 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (gb + 1166280 | 0));
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine9Animation31UnregisterGenericBindingObjectsEPNS0_30AnimatorGenericBindingConstantE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0;
   if (i4 | 0) __ZN6Object11RemoveEventEPFvPvS0_iES0_(i4, fb + 913 | 0, i5);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i5 + 12 >> 2] | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0;
   if (i4 | 0) __ZN6Object11RemoveEventEPFvPvS0_iES0_(i4, fb + 913 | 0, i5);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i3 = HEAP32[i5 + 16 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i1 = 0;
 do {
  i4 = HEAP32[i2 + (i1 << 4) + 12 >> 2] | 0;
  if (i4 | 0) __ZN6Object11RemoveEventEPFvPvS0_iES0_(i4, fb + 913 | 0, i5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZL12InvokeMethodI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 57 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 868 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 868 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 856 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 856 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 904 >> 2] | 0) + 672 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z21UpdateCollisionPlanesR13dynamic_arrayI20BatchedRaycastResultLj4EEbjbibRK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK33ParticleSystemCollisionParametersR23ParticleSystemParticlesjRKf(i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i2) {
  __Z14PlaneCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersif(i1, 0, i10, i12, i11, i3, Math_fround(0.0));
  return;
 }
 if (!(HEAP32[i11 + 28 >> 2] | 0)) if (!(HEAP32[i11 + 32 >> 2] | 0)) return;
 __Z14WorldCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjibibRKf(i1, i9, i10, i12, i11, i3, i5, i6, i7, i8, i4);
 return;
}

function _UNITY_png_handle_gAMA(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 204 >> 2] | 0;
 if (!(i5 & 1)) _UNITY_png_chunk_error(i1, gb + 352205 | 0);
 if (i5 & 6 | 0) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352423 | 0);
  STACKTOP = i6;
  return;
 }
 if ((i3 | 0) != 4) {
  _UNITY_png_crc_finish(i1, i3) | 0;
  _UNITY_png_chunk_benign_error(i1, gb + 352446 | 0);
  STACKTOP = i6;
  return;
 }
 _UNITY_png_read_data(i1, i4, 4);
 _UNITY_png_calculate_crc(i1, i4, 4);
 if (_UNITY_png_crc_finish(i1, 0) | 0) {
  STACKTOP = i6;
  return;
 }
 i5 = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
 _UNITY_png_colorspace_set_gamma(i1, i1 + 680 | 0, (i5 | 0) > -1 ? i5 : -1);
 _UNITY_png_colorspace_sync(i1, i2);
 STACKTOP = i6;
 return;
}

function _unity_z_deflateParams(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 if (!i2) {
  i6 = -2;
  return i6 | 0;
 }
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i6) {
  i6 = -2;
  return i6 | 0;
 }
 i3 = (i1 | 0) == -1 ? 6 : i1;
 if (i5 >>> 0 > 4 | i3 >>> 0 > 9) {
  i6 = -2;
  return i6 | 0;
 }
 i4 = i6 + 132 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[gb + 16368 + (i1 * 12 | 0) + 8 >> 2] | 0) == (HEAP32[gb + 16368 + (i3 * 12 | 0) + 8 >> 2] | 0)) i2 = 0; else if (!(HEAP32[i2 + 8 >> 2] | 0)) i2 = 0; else {
  i2 = _unity_z_deflate(i2, 1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if ((i1 | 0) != (i3 | 0)) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 + 128 >> 2] = HEAPU16[gb + 16368 + (i3 * 12 | 0) + 2 >> 1];
  HEAP32[i6 + 140 >> 2] = HEAPU16[gb + 16368 + (i3 * 12 | 0) >> 1];
  HEAP32[i6 + 144 >> 2] = HEAPU16[gb + 16368 + (i3 * 12 | 0) + 4 >> 1];
  HEAP32[i6 + 124 >> 2] = HEAPU16[gb + 16368 + (i3 * 12 | 0) + 6 >> 1];
 }
 HEAP32[i6 + 136 >> 2] = i5;
 i6 = i2;
 return i6 | 0;
}

function _scalb(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 do if (i3 >>> 0 > 2146435072 | (i3 | 0) == 2146435072 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 0) i4 = 3; else {
  HEAPF64[tempDoublePtr >> 3] = d2;
  i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i5 = i3 & 2147483647;
  if (i5 >>> 0 > 2146435072 | (i5 | 0) == 2146435072 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 0) i4 = 3; else {
   i5 = i3 & 2146435072;
   if (!(i5 >>> 0 < 2146435072 | (i5 | 0) == 2146435072 & 0 < 0)) if (d2 > 0.0) {
    d1 = d1 * d2;
    break;
   } else {
    d1 = d1 / -d2;
    break;
   }
   if (+_rint(d2) != d2) {
    d1 = d2 - d2;
    d1 = d1 / d1;
    break;
   }
   if (d2 > 65.0e3) {
    d1 = +_scalbn(d1, 65e3);
    break;
   }
   if (d2 < -65.0e3) {
    d1 = +_scalbn(d1, -65e3);
    break;
   } else {
    d1 = +_scalbn(d1, ~~d2);
    break;
   }
  }
 } while (0);
 if ((i4 | 0) == 3) d1 = d1 * d2;
 return +d1;
}

function __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwj(i2, i7, i6) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i3 = i1 & 255;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2806 | 0, i7 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i5);
 }
 if (i3 >>> 0 <= i6 >>> 0 | (i1 | 0) == 0) i1 = -1; else {
  i5 = i2 + (i3 << 2) | 0;
  i4 = i7 + (i1 << 2) | 0;
  i1 = i2 + (i6 << 2) | 0;
  L10 : while (1) {
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i5;
    break;
   } else i3 = i7;
   while (1) {
    if ((i3 | 0) == (i4 | 0)) break;
    if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) break L10; else i3 = i3 + 4 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = (i1 | 0) == (i5 | 0) ? -1 : i1 - i2 >> 2;
 }
 return i1 | 0;
}

function __ZN7mecanim9animation20GetMuscleCurveInMaskERKNS_6bitsetILj66EEEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 do if ((i1 | 0) < 7) i1 = 1; else {
  if ((i1 | 0) < 14) {
   i1 = (HEAP32[i2 >> 2] & 1 | 0) != 0;
   break;
  }
  if ((i1 | 0) < 42) {
   i1 = ((i1 + -14 | 0) / 7 | 0) + 53 | 0;
   if (i1 >>> 0 >= 66) {
    i1 = 0;
    break;
   }
   i1 = (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0;
   break;
  }
  if ((i1 | 0) < 94) {
   i1 = i1 + -41 | 0;
   if (i1 >>> 0 >= 66) {
    i1 = 0;
    break;
   }
   i1 = (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0;
   break;
  }
  if ((i1 | 0) < 114) {
   i1 = (HEAP32[i2 + 4 >> 2] & 33554432 | 0) != 0;
   break;
  }
  if ((i1 | 0) < 134) {
   i1 = (HEAP32[i2 + 4 >> 2] & 67108864 | 0) != 0;
   break;
  }
  if ((i1 | 0) < 155) {
   i1 = ((i1 + -134 | 0) / 3 | 0) + 59 | 0;
   if (i1 >>> 0 < 66) i1 = (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0; else i1 = 0;
  } else i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZN7Joint2D14SetBreakTorqueEf(i5, f1) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = f1 < Math_fround(0.0);
 f1 = i4 ? Math_fround(0.0) : f1;
 HEAPF32[i5 + 48 >> 2] = f1;
 i4 = Math_fround(HEAPF32[i5 + 44 >> 2]) == Math_fround(inf);
 if (f1 == Math_fround(inf) & i4) {
  i2 = i5 + 64 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) return;
  i5 = i5 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i3 = (HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0) + 588 | 0;
 i4 = i5 + 64 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i2 = i5 + 68 | 0; else {
  i5 = i5 + 68 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  i2 = i5;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[HEAP32[i2 >> 2] >> 2] = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 << 2;
 if (!i2) i2 = 0; else {
  i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i7 | 0, i6 | 0, i2 | 0, (i1 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i2;
 i3 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx30PxDistanceJointGeneratedValuesC2EPKNS_15PxDistanceJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 HEAPF32[i2 + 160 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 168 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 172 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 176 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 180 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
 HEAP16[i2 + 184 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 188 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN24b2ChainAndPolygonContactC2EP9b2FixtureiS1_i(i4, i5, i1, i6, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, f7 = f0, f8 = f0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i1;
 HEAP32[i4 + 60 >> 2] = i2;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 152004 + 8;
 return;
}

function __ZN24b2ChainAndCapsuleContactC2EP9b2FixtureiS1_i(i4, i5, i1, i6, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, f7 = f0, f8 = f0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i1;
 HEAP32[i4 + 60 >> 2] = i2;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 151964 + 8;
 return;
}

function __ZN22CrashReportingSettings11SetEventUrlERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 12 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 20 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 16 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 16 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN20LocalFileSystemPosix4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i2 | 0) {
 case 3:
  {
   i1 = gb + 491592 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 777169 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 491595 | 0;
   break;
  }
 default:
  i1 = gb + 945625 | 0;
 }
 i1 = _fopen(i4, i1) | 0;
 if ((i2 | 0) == 2 & (i1 | 0) == 0) i1 = _fopen(i4, gb + 491599 | 0) | 0; else if ((i2 | 0) == 3 & (i1 | 0) != 0) _fseek(i1, 0, 2) | 0;
 HEAP32[i4 + 1052 >> 2] = i1;
 HEAP32[i4 + 1040 >> 2] = i3;
 HEAP32[i4 + 1044 >> 2] = i3;
 L11 : do if (!i1) switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
 case 0:
  {
   i1 = 0;
   break L11;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break L11;
  }
 case 2:
  {
   i1 = 1;
   break L11;
  }
 case 18:
  {
   i1 = 10;
   break L11;
  }
 default:
  {
   i1 = 14;
   break L11;
  }
 } else i1 = 0; while (0);
 HEAP32[i4 + 1056 >> 2] = i1;
 return (i1 | 0) == 0 | 0;
}

function __ZN12HingeJoint2D8SetMotorERK12JointMotor2D(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2 + 96 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f5 < Math_fround(-1.0e6);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(-1.0e6) : f5;
 i3 = i2 + 100 | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f5 < Math_fround(0.0);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i3 >> 2] = i1 ? Math_fround(0.0) : f5;
 HEAP8[i2 + 112 >> 0] = 1;
 i1 = i2 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN15b2RevoluteJoint11EnableMotorEb(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN15b2RevoluteJoint13SetMotorSpeedEf(i1, Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.0174532924)));
 __ZN15b2RevoluteJoint17SetMaxMotorTorqueEf(i1, Math_fround(HEAPF32[i3 >> 2]));
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValuesD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189084 + 8;
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZL12InvokeMethodI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6;
 i4 = i6 + 240 | 0;
 if (HEAP8[i1 + 56 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i8 = i1 + 48 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i3, i5);
 i4 = HEAP8[i2 >> 0] | 0;
 i7 = i4 << 24 >> 24 == 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 + 212 >> 2] = i7 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : 0;
 HEAP32[i3 + 208 >> 2] = i7 ? 0 : i1;
 HEAP8[i3 + 232 >> 0] = i4;
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __Z38Material_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i7 = i9;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i8 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i8 = 6;
 if ((i8 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i6, i1 + 12 | 0, i4, 0);
 STACKTOP = i9;
 return;
}

function __Z13FindConverterPKcS0_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = (HEAP32[gb + 1166052 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) i8 = 12; else {
  i1 = i7;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    i4 = HEAP32[i2 + 20 >> 2] | 0;
    i3 = __Z6StrCmpPKcS0_(HEAP32[i2 + 16 >> 2] | 0, i5) | 0;
    if (!i3) i3 = __Z6StrCmpPKcS0_(i4, i6) | 0;
    if ((i3 | 0) >= 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i7 | 0)) i8 = 12; else {
   i3 = HEAP32[i1 + 20 >> 2] | 0;
   i2 = __Z6StrCmpPKcS0_(i5, HEAP32[i1 + 16 >> 2] | 0) | 0;
   if (!i2) i2 = __Z6StrCmpPKcS0_(i6, i3) | 0;
   if ((i2 | 0) < 0) i8 = 12;
  }
 }
 if ((i8 | 0) == 12) i1 = i7;
 if ((i1 | 0) == ((HEAP32[gb + 1166052 >> 2] | 0) + 4 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 24 >> 2] | 0;
 return i8 | 0;
}

function _Split_Cubic(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i1 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 48 >> 2] = i3;
 i4 = i1 + 8 | 0;
 i5 = i1 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 i8 = i7 + (HEAP32[i1 >> 2] | 0) >> 1;
 HEAP32[i4 >> 2] = i8;
 i3 = i6 + 1 + i3 >> 1;
 HEAP32[i1 + 40 >> 2] = i3;
 i6 = (i7 + i6 >> 1) + 1 | 0;
 i8 = i6 + i8 >> 1;
 HEAP32[i5 >> 2] = i8;
 i3 = i6 + i3 >> 1;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i2 >> 2] = i8 + 1 + i3 >> 1;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 52 >> 2] = i3;
 i8 = i1 + 12 | 0;
 i6 = i1 + 20 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i7 = (HEAP32[i8 >> 2] | 0) + 1 | 0;
 i4 = i7 + (HEAP32[i1 + 4 >> 2] | 0) >> 1;
 HEAP32[i8 >> 2] = i4;
 i3 = i5 + 1 + i3 >> 1;
 HEAP32[i1 + 44 >> 2] = i3;
 i5 = (i7 + i5 >> 1) + 1 | 0;
 i4 = i5 + i4 >> 1;
 HEAP32[i6 >> 2] = i4;
 i3 = i5 + i3 >> 1;
 HEAP32[i1 + 36 >> 2] = i3;
 HEAP32[i2 >> 2] = i4 + 1 + i3 >> 1;
 return;
}

function __ZNSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9Transform25CompleteTransformTransferI19StreamedBinaryWriteILb0EEEEvRT_(i7, i8) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 if (HEAP32[i8 >> 2] & 16384 | 0) {
  STACKTOP = i9;
  return;
 }
 i6 = i7 + 92 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i4 = i8 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = i5 + 4 | 0;
 if (i1 >>> 0 < (HEAP32[i8 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i2, 4);
 i1 = HEAP32[i7 + 80 >> 2] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i6 << 2) | 0;
 if (i6 | 0) do {
  __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i7 + 100 | 0, i8);
 STACKTOP = i9;
 return;
}

function __ZN8WindZoneC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 69132 + 8;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i1;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.00999999977);
 STACKTOP = i4;
 return;
}

function __ZN8TypeTree14AppendChildrenERK16TypeTreeIterator(i8, i9) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = HEAP32[i9 + 4 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i6 + (i3 * 24 | 0) | 0;
 i7 = i6 + ((HEAP32[i1 + 12 >> 2] | 0) * 24 | 0) | 0;
 L1 : do if ((i2 + 24 | 0) >>> 0 < i7 >>> 0) if ((i1 | 0) == 0 ? 1 : (HEAPU8[i2 + 26 >> 0] | 0 | 0) != ((HEAPU8[i6 + (i3 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) i1 = 0; else {
  i5 = i6;
  i1 = 0;
  i2 = i3 + 1 | 0;
  while (1) {
   i1 = i1 + 1 | 0;
   i4 = HEAP8[i6 + (i2 * 24 | 0) + 2 >> 0] | 0;
   i3 = i6 + (i2 * 24 | 0) | 0;
   do {
    i2 = i3;
    i3 = i3 + 24 | 0;
    if (i3 >>> 0 >= i7 >>> 0) break L1;
    i2 = HEAP8[i2 + 26 >> 0] | 0;
   } while ((i2 & 255) > (i4 & 255));
   if (i2 << 24 >> 24 != i4 << 24 >> 24) break L1;
   i2 = (i3 - i5 | 0) / 24 | 0;
  }
 } else i1 = 0; while (0);
 __ZN8TypeTree19AppendChildrenRangeERK16TypeTreeIteratorjjb(i8, i9, 0, i1, 0);
 return;
}

function __ZN8Animator10SetIntegerEii(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i1;
 i1 = i2 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1) | 0)) {
  i6 = 64;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = i2 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i2 + 584 | 0);
 }
 i3 = i2 + 584 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i8 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 148 >> 2] | 0, i8 | 0, i5 | 0, i6 | 0) | 0 | i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx6shdfnd6Socket10disconnectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 14 | 0;
 if ((i1 | 0) == -1) {
  HEAP8[i3 >> 0] = 0;
  i7 = i4 + 12 | 0;
  HEAP16[i7 >> 1] = 0;
  i7 = i4 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 if (HEAP8[i3 >> 0] | 0) {
  i2 = i4 + 15 | 0;
  if ((HEAP8[i2 >> 0] | 0) != 1) {
   HEAP32[i6 >> 2] = 0;
   i1 = (_fcntl(i1, 3, i6) | 0) & -2049;
   i6 = HEAP32[i5 >> 2] | 0;
   HEAP32[i7 >> 2] = i1;
   if ((_fcntl(i6, 4, i7) | 0) != -1) HEAP8[i2 >> 0] = 1;
  }
  _shutdown(HEAP32[i5 >> 2] | 0, 2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 _close(i1) | 0;
 HEAP32[i5 >> 2] = -1;
 HEAP8[i3 >> 0] = 0;
 i7 = i4 + 12 | 0;
 HEAP16[i7 >> 1] = 0;
 i7 = i4 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx34NpConstraintGetRigidObjectsFromScbERKNS_3Scb10ConstraintERPNS0_11RigidObjectES6_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i2 = i5;
 i1 = i1 + -16 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i6 | 0, i2 | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else switch (HEAP16[i1 + 4 >> 1] | 0) {
 case 5:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 case 15:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 default:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 } while (0);
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[i2 >> 2] | 0;
 L8 : do if (!i1) i1 = 0; else switch (HEAP16[i1 + 4 >> 1] | 0) {
 case 5:
  {
   i1 = i1 + 48 | 0;
   break L8;
  }
 case 15:
  {
   i1 = i1 + 48 | 0;
   break L8;
  }
 default:
  {
   i1 = i1 + 48 | 0;
   break L8;
  }
 } while (0);
 HEAP32[i4 >> 2] = i1;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc10NPhaseCore34insertParticleElementRbElementPairEPNS0_19ParticlePacketShapeEPNS0_8ShapeSimEPNS0_16ActorElementPairEj(i7, i5, i6, i3, i4) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i2 = i7 + 2212 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i7 + 1920 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i7 + 2200 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i7 = i7 + 2204 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 __ZN5physx2Sc35ParticleElementRbElementInteractionC2ERNS0_19ParticlePacketShapeERNS0_8ShapeSimERNS0_16ActorElementPairE(i1, i5, i6, i3);
 i7 = i3 + 16 | 0;
 HEAP16[i7 >> 1] = (HEAP16[i7 >> 1] | 0) + 1 << 16 >> 16;
 __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEj(i1, i4);
 i7 = i1;
 return i7 | 0;
}

function __ZN23b2ChainAndCircleContactC2EP9b2FixtureiS1_i(i4, i5, i1, i6, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, f7 = f0, f8 = f0;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i1;
 HEAP32[i4 + 60 >> 2] = i2;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 >> 2] = gb + 151984 + 8;
 return;
}

function __ZN22RenderingCommandBuffer24AddSetShadowSamplingModeERK18RenderTextureParam18ShadowSamplingMode(i4, i1, i9) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = HEAP32[i1 + 8 >> 2] | 0;
 i11 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i4 + 8 | 0;
 i8 = i4 + 24 | 0;
 i5 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i5 + 4 | 0;
 i1 = i4 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i5, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i4 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i5 >> 2] = 19;
 i4 = i5 + 7 & -4;
 i5 = i4 + 20 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i8 = i1 + i4 | 0;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i11;
 HEAP32[i8 + 8 >> 2] = i7;
 HEAP32[i8 + 12 >> 2] = i9;
 HEAP32[i8 + 16 >> 2] = 0;
 return;
}

function __ZN14PreloadManagerD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 12 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN14AsyncOperation16CleanupCoroutineEv(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i3 = i4 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 i1 = i4 + 20 | 0;
 if ((HEAP32[i4 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
  if ((HEAP32[i3 >> 2] | 0) <= -1) return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN13HeightmapData8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 932479 | 0, HEAP32[gb + 37324 >> 2] | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 843871 | 0, HEAP32[gb + 37176 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 868 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 856 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z52ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 872 >> 2] | 0) + 12 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z51SceneManager_CUSTOM_LoadSceneAsyncNameIndexInternalP12Il2CppStringihh(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 12 | 0;
 i6 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 i1 = __Z15GetSceneManagerv() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i7);
 i1 = __ZN19RuntimeSceneManager32LoadSceneAsyncByNameOrBuildIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiNS_11LoadingModeEb(i1, i6, i2, i3 << 24 >> 24 != 0 & 1, i4 << 24 >> 24 != 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 if (!i1) {
  i7 = 0;
  STACKTOP = i5;
  return i7 | 0;
 }
 i7 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 36 >> 2] | 0) | 0;
 HEAP32[i7 + 8 >> 2] = i1;
 STACKTOP = i5;
 return i7 | 0;
}

function __Z51ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 908 >> 2] | 0) + 448 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_MainModule_CUSTOM_SetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 2276 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z37Material_CUSTOM_GetColorArrayImplListP12Il2CppObjectiS0_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i7 = i9;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i8 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i8 = 6;
 if ((i8 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i6, i1 + 12 | 0, i4, 1);
 STACKTOP = i9;
 return;
}

function __Z28Component_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting20SendScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i2, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z26Texture2D_CUSTOM_LoadImageP12Il2CppObjectP11Il2CppArrayh(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 if (!i2) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 return (__Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb(i6, i7, i4, (i1 + -10 | 0) >>> 0 < 3 ? 2 : 0, i5 << 24 >> 24 != 0) | 0) & 1 | 0;
}

function __Z20FinishUpdatingClothsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1458944 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458944 | 0, i1);
  i1 = gb + 1458944 | 0;
 } else i1 = 0;
 if (HEAP32[gb + 1459004 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(gb + 1459004 | 0);
 __ZN19SkinnedMeshRenderer12UploadClothsERK13dynamic_arrayIPS_Lj4EE(gb + 1458984 | 0);
 if ((HEAP32[gb + 1458984 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1458984 >> 2] | 0, gb + 1458984 + 4 | 0);
  HEAP32[gb + 1458984 >> 2] = 0;
 }
 HEAP32[gb + 1458984 >> 2] = 0;
 HEAP32[gb + 1458984 + 12 >> 2] = 0;
 HEAP32[gb + 1458984 + 16 >> 2] = 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZN8Animator7SetBoolEib(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP8[i6 >> 0] = i1 & 1;
 i1 = i2 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1) | 0)) {
  i6 = 64;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = i2 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i2 + 584 | 0);
 }
 i3 = i2 + 584 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i8 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 156 >> 2] | 0, i8 | 0, i5 | 0, i6 | 0) | 0 | i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN5physx3Scb13ObjectTracker17scheduleForInsertERNS0_4BaseE(i5, i7) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 i1 = i8;
 i2 = i7 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 & 1073741823;
 if (i3 >>> 0 > 3221225471) {
  HEAP32[i2 >> 2] = i4 | -2147483648;
  if (i3 & 268435456 | 0) {
   STACKTOP = i8;
   return;
  }
  HEAP32[i6 >> 2] = i7;
  __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i5, i6) | 0;
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i2 >> 2] = i4 | 1073741824;
  HEAP32[i1 >> 2] = i7;
  i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i5, i1, i6) | 0;
  if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx3Ext19ProfileEventHandlerC2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 >> 2] = gb + 87160 + 8;
 i1 = i5 + 16 | 0;
 i2 = i5 + 28 | 0;
 i6 = i5 + 36 | 0;
 i7 = i5 + 44 | 0;
 i3 = i5 + 12 | 0;
 i4 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5 + 12 | 0, 512);
 i4 = (HEAP32[i5 + 32 >> 2] & 2147483640) >>> 0 < 8;
 HEAP32[i5 + 4 >> 2] = 99999789;
 if (i4) __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i5 + 24 | 0, 8);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  return;
 }
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 do {
  i1 = i1 + -1 | 0;
  HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
 } while ((i1 | 0) != 0);
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN5physx2Gu9Container7SetSizeEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if ((HEAP32[i5 + 12 >> 2] | 0) > -1) {
  i2 = i5 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 + 4 >> 2] = 0;
 if (!i4) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i4;
 i1 = i4 >>> 0 > 1073741823 ? -1 : i4 << 2;
 if (!i1) i1 = 0; else {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
  i4 = _PxGetFoundation() | 0;
  i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
  i1 = mftCall_iiiiii(i2 | 0, i3 | 0, i1 | 0, (i4 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 656004 | 0, 127) | 0;
 }
 HEAP32[i5 + 8 >> 2] = i1;
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx17ConvexMeshBuilder16computeGaussMapsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = i4 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx13BigConvexDataD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 12 | 0, i2);
 }
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i7 | 0, i6 | 0, 28, (i2 ? gb + 729661 | 0 : gb + 837976 | 0) | 0, gb + 726597 | 0, 327) | 0;
 __ZN5physx13BigConvexDataC2Ev(i2);
 HEAP32[i1 >> 2] = i2;
 __ZN5physx20BigConvexDataBuilderC2EPKNS_2Gu14ConvexHullDataEPNS_13BigConvexDataEPKNS_6PxVec3E(i3, i4 + 16 | 0, i2, HEAP32[i4 + 132 >> 2] | 0);
 __ZN5physx20BigConvexDataBuilder10PrecomputeEj(i3, 16) | 0;
 STACKTOP = i5;
 return 1;
}

function __ZN5physx17ConvexHullBuilderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 28 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 6 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 5 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 4 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN20SoundChannelInstance14GetPositionPCMEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = HEAP32[i1 + 116 >> 2];
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __ZN4FMOD7Channel11getPositionEPjj(i3, i2, 2) | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 336;
 HEAP32[i5 + 8 >> 2] = gb + 874543;
 HEAP32[i5 + 12 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN18CrashReportHandler18HandleFlushReportsEPS_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 40 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 44 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   i1 = i2 + 144 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    __ZN18CrashReportHandler10SendReportER16CrashReportEvent(i3, i2 + 32 | 0) | 0;
    HEAP32[i1 >> 2] = 0;
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN15QualitySettingsD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 HEAP32[i8 >> 2] = gb + 44056 + 8;
 i5 = i8 + 28 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP32[i8 >> 2] = gb + 28648 + 8;
  HEAP32[i8 >> 2] = gb + 28496 + 8;
  STACKTOP = i9;
  return;
 }
 i6 = i8 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i7 = i4 + 4 | 0;
  do {
   i3 = i2 + -108 | 0;
   HEAP32[i6 >> 2] = i3;
   if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
    i3 = HEAP32[i3 >> 2] | 0;
    i2 = HEAP32[i2 + -96 >> 2] | 0;
    HEAP32[i4 >> 2] = 66;
    HEAP32[i7 >> 2] = i2;
    __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
    i2 = HEAP32[i6 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i8 >> 2] = gb + 28648 + 8;
 HEAP32[i8 >> 2] = gb + 28496 + 8;
 STACKTOP = i9;
 return;
}

function __ZN14SafeBinaryRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(i5, i6, i2, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, i2, HEAP32[gb + 36980 >> 2] | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if ((i1 | 0) > 0) {
  __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6, gb + 1084155 | 0, 1);
  __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 4 | 0, gb + 1086064 | 0, 1);
  __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 8 | 0, gb + 1085890 | 0, 1);
  __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags(i5, i6 + 12 | 0, gb + 1085926 | 0, 1);
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i6 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i4;
 return;
}

function __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 2012 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 1748 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 1484 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 876 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 876 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z34Camera_CUSTOM_SetReplacementShaderP12Il2CppObjectS0_P12Il2CppString(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
 __ZN6Camera20SetReplacementShaderEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i4, i1, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i7;
 return;
}

function __Z17GetPreloadManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1163176 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __Znwj(56) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i6 = i1;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, gb + 63664 | 0);
 i5 = i1;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i2 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP8[i2 + 44 >> 0] = 0;
 HEAP32[i2 + 52 >> 2] = -1;
 HEAP32[i2 + 48 >> 2] = -1;
 HEAP32[gb + 1163176 >> 2] = i2;
 STACKTOP = i3;
 return i2 | 0;
}

function _unity_z_inflateSetDictionary(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 if (!i2) {
  i6 = -2;
  return i6 | 0;
 }
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i6) {
  i6 = -2;
  return i6 | 0;
 }
 i3 = (HEAP32[i6 >> 2] | 0) == 10;
 if (!(HEAP32[i6 + 8 >> 2] | 0)) {
  if (i3) i4 = 6;
 } else if (i3) i4 = 6; else {
  i6 = -2;
  return i6 | 0;
 }
 if ((i4 | 0) == 6) {
  i4 = _unity_z_adler32(_unity_z_adler32(0, 0, 0) | 0, i5, i1) | 0;
  if ((i4 | 0) != (HEAP32[i6 + 24 >> 2] | 0)) {
   i6 = -3;
   return i6 | 0;
  }
 }
 if (_updatewindow(i2, HEAP32[i2 + 16 >> 2] | 0) | 0) {
  HEAP32[i6 >> 2] = 28;
  i6 = -4;
  return i6 | 0;
 }
 i2 = i6 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i6 + 52 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  _memcpy(i4 | 0, i5 + i1 + (0 - i3) | 0, i3 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else _memcpy(i4 + i3 + (0 - i1) | 0, i5 | 0, i1 | 0) | 0;
 HEAP32[i6 + 44 >> 2] = i1;
 HEAP32[i6 + 12 >> 2] = 1;
 i6 = 0;
 return i6 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFlPKcPPciEEET_RKS7_RKT0_PjiT1_(i5, i1, i6, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 HEAP32[i3 >> 2] = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i8 = ___errno_location() | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = 0;
 i2 = _strtol(i4, i3, i2) | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 HEAP32[i8 >> 2] = i9;
 if ((i1 | 0) == 34) __ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5);
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) __ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5);
 if (i6 | 0) HEAP32[i6 >> 2] = i1 - i4;
 STACKTOP = i7;
 return i2 | 0;
}

function __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix3x3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(f8 * Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 f5 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 12 >> 2]));
 f5 = Math_fround(f5 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 16 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 20 >> 2])));
 f8 = Math_fround(f8 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 f7 = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 28 >> 2])));
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 32 >> 2])));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZN20SoundChannelInstance13GetPositionMSEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i3 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = HEAP32[i1 + 120 >> 2];
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = __ZN4FMOD7Channel11getPositionEPjj(i3, i2, 1) | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i5 >> 2] = gb + 853918;
 HEAP32[i5 + 4 >> 2] = 348;
 HEAP32[i5 + 8 >> 2] = gb + 874485;
 HEAP32[i5 + 12 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 883334 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i3, i6, i1, i2) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i7 = 0;
 i7 = i3 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = i3 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i6, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 4 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i4 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i6 + 8 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN19ScriptingInvocationC2EPKcS1_S1_S1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = i1 + 96 | 0;
 i9 = i7 + 48 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i9 = i1 + 200 | 0;
 i7 = i1 + 224 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i9 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i7 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 __ZN9Scripting9GetMethodEPKcS1_S1_S1_(i6, i2, i3, i4, i5);
 HEAP32[i9 >> 2] = HEAP32[i6 >> 2];
 HEAP8[i9 + 4 >> 0] = HEAP8[i6 + 4 >> 0] | 0;
 STACKTOP = i8;
 return;
}

function __ZN12LineRenderer11SetPositionEiRK8Vector3f(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i1 = i4 + 348 | 0;
 i2 = i4 + 316 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i7 = i4 + 320 | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) > -1 ? (HEAP32[i1 + 20 >> 2] | 0) > (i5 | 0) : 0) {
  i8 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i8 + (i5 * 12 | 0) >> 2] = HEAP32[i6 >> 2];
  HEAP32[i8 + (i5 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i8 + (i5 * 12 | 0) + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  __ZN8Renderer13BoundsChangedEv(i4);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406896 | 0, 0, gb + 406663 | 0, 100, 1, 0, 0, 0);
  __ZN8Renderer13BoundsChangedEv(i4);
  return;
 }
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 852 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 852 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z21FillShaderRenderStateR22BasicShaderRenderStateRK10RenderNodeRK15RenderNodeQueueRK15RODataDepthPass(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i2 >> 2] = HEAP32[(HEAP32[i3 + 324 >> 2] | 0) + ((HEAP32[i4 + 20 >> 2] & 65535) << 3) >> 2];
 i6 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i6;
 i7 = i2 + 12 | 0;
 HEAP32[i7 >> 2] = 0;
 i4 = i4 + 12 | 0;
 i8 = HEAP32[i4 >> 2] & 32767;
 HEAP32[i7 >> 2] = i8;
 i8 = HEAP32[i3 + 176 >> 2] << 13 & 32768 | i8;
 HEAP32[i7 >> 2] = i8;
 i3 = HEAP32[i3 + 252 >> 2] | 0;
 HEAP32[i7 >> 2] = ((i3 & 2147483647 | 0) == 0 ? 0 : i3 >> 15 & 131072 | 65536) | i8;
 i3 = i2 + 16 | 0;
 HEAP16[i3 + 2 >> 1] = -1;
 HEAP16[i3 >> 1] = -1;
 HEAP32[i2 + 8 >> 2] = __ZNK6Shader24GetShadowCasterPassToUseEiRi(i6, HEAP32[i4 >> 2] | 0, i5) | 0;
 STACKTOP = i1;
 return HEAP32[i5 >> 2] | 0;
}

function __ZNK5physx13NpVolumeCache7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE(i7, i6, i8, f1, i4, i5, i3, i2) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9;
 i10 = i9 + 24 | 0;
 HEAP32[i11 >> 2] = i6;
 HEAP32[i11 + 4 >> 2] = i8;
 HEAPF32[i11 + 8 >> 2] = f1;
 HEAP32[i11 + 12 >> 2] = 0;
 HEAP32[i11 + 16 >> 2] = 0;
 HEAPF32[i11 + 20 >> 2] = Math_fround(0.0);
 HEAP16[i10 >> 1] = HEAP16[i5 >> 1] | 0;
 i8 = __ZNK5physx13NpVolumeCache10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i7, i11, i4, i10, i3, i2, Math_fround(0.0)) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i1 + 72 + (i4 << 2) >> 2] | 0;
 if ((i6 | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i1 = i1 + 40 | 0;
 i8 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi(i5, (i8 | 0) == 0 ? 0 : i8 + i1 | 0, i2, i6);
 if (124830 >>> i4 & 1 | 0) HEAP32[i3 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) + 8 >> 2] << 2) >> 2] = HEAP32[i5 >> 2];
 if (15106022 >>> i4 & 1 | 0) HEAP32[i3 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) + 4 >> 2] << 2) >> 2] = HEAP32[i5 + 4 >> 2];
 if (i4 | 0) HEAP32[i3 + 596 + (HEAP32[gb + 177812 + (i4 * 12 | 0) >> 2] << 2) >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sc5Scene21buildActiveTransformsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i1 + 1152 >> 2] | 0;
 i9 = HEAP32[i1 + 1156 >> 2] | 0;
 i7 = HEAP32[i1 + 1204 >> 2] | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 if (i9 | 0) {
  i1 = 0;
  do {
   HEAP32[(HEAP32[i8 + (i1 << 2) >> 2] | 0) + 4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
 }
 i1 = i6 & -32;
 if (i1 | 0) {
  i2 = i6 + -1 | 0;
  i4 = 0;
  do {
   i5 = 0;
   do {
    i3 = i5 + i4 | 0;
    __Z20buildActiveTransformPN5physx2Sc5ActorEPPNS0_6ClientEj(HEAP32[i7 + (i3 << 2) >> 2] | 0, i8, i9);
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) != 32);
   i4 = i4 + 32 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 if (i1 >>> 0 >= i6 >>> 0) return;
 i3 = i6 + -1 | 0;
 do {
  i2 = i1;
  i1 = i1 + 1 | 0;
  __Z20buildActiveTransformPN5physx2Sc5ActorEPPNS0_6ClientEj(HEAP32[i7 + (i2 << 2) >> 2] | 0, i8, i9);
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBuffer19ReserveSpaceForDataEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = i6 + 20 | 0;
 i2 = i7 + 7 & -4;
 i3 = i6 + 12 | 0;
 i4 = (HEAP32[i6 + 8 >> 2] | 0) + -1 | 0;
 while (1) {
  i10 = HEAP32[i9 >> 2] | 0;
  i5 = i2 + i10 | 0;
  i8 = i5 & i4;
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 - i10 | 0) == 1) {
   i1 = 0;
   i2 = 8;
   break;
  }
  if ((i1 | 0) == 0 & (i10 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 8;
   break;
  }
  if (!((i1 | 0) <= (i10 | 0) | (i5 | 0) < (i1 | 0))) {
   i1 = 0;
   i2 = 8;
   break;
  }
  if (!((i8 | 0) < (i1 | 0) | ((i1 | 0) > (i10 | 0) | (i5 | 0) == (i8 | 0)))) {
   i1 = 0;
   i2 = 8;
   break;
  }
  if ((HEAP32[i9 >> 2] | 0) == (i10 | 0)) {
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) {
  HEAP32[i9 >> 2] = i8;
  i10 = (HEAP32[i6 >> 2] | 0) + i10 | 0;
  HEAP32[i10 >> 2] = i7;
  return i10 | 0;
 } else if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN14MemoryProfiler15AllocateStructsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63584 | 0, 16, gb + 461921 | 0, 120) | 0;
 HEAP32[gb + 1163240 >> 2] = i3;
 HEAP32[i3 + 4 >> 2] = 20;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(80, 16, gb + 63584 | 0, 0, gb + 461921 | 0, 124) | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[gb + 1163244 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63584 | 0, 16, gb + 461921 | 0, 133) | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 + 160 >> 2] = i2;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63584 | 0, 16, gb + 461921 | 0, 134) | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 + 168 >> 2] = i2;
 return;
}

function __ZN11UnityEngine7Connect16PersistentValuesD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189084 + 8;
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 16 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 i1 = i3 + 52 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 56 >> 2] = 0;
 } else HEAP8[i2 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 i1 = i3 + 36 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 40 >> 2] = 0;
 } else HEAP8[i2 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv(i3 + 68 | 0);
 HEAP8[i3 + 90 >> 0] = 0;
 HEAP8[i3 + 89 >> 0] = 0;
 i2 = i3 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i3 + 104 + 4 >> 2] = 0;
 HEAP16[i3 + 112 >> 1] = 0;
 HEAP8[i3 + 88 >> 0] = 0;
 HEAP8[i3 + 91 >> 0] = 0;
 HEAP8[i3 + 92 >> 0] = 0;
 return;
}

function __ZN10UnitySceneD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 66456 + 8;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i1 = i2 + 44 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 40 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN10MonoScriptD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 65032 + 8;
 i1 = i2 + 124 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 136 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 108 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 120 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 92 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN9TextAssetD2Ev(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZN9TextAssetD2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN10Collider2D9SetOffsetERK8Vector2f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0;
 i2 = i3 + 40 | 0;
 f4 = Math_fround(HEAPF32[gb + 62456 >> 2]);
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 44 >> 2]));
 if (Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)) <= Math_fround(f4 * f4)) return;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 __ZN10Collider2D19WakeAllBodyContactsEv(i3);
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i8 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i3, i8);
  if (!i8) return;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, 0);
  return;
 }
 __ZN10Collider2D7CleanupEb(i3, 0);
 return;
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 876 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z49ParticleSystem_LightsModule_CUSTOM_SetLightPrefabP12Il2CppObjectS0_(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 i1 = HEAP32[i1 + 920 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 896 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 896 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 824 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z38Material_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i7 = i9;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i8 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i8 = 6;
 if ((i8 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i6, i1 + 12 | 0, i4);
 STACKTOP = i9;
 return;
}

function __Z24InitializeCleanedLogFileP8_IO_FILE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[gb + 1450792 >> 2] = i1;
 i1 = HEAP32[gb + 1450784 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63176 | 0, 16, gb + 582853 | 0, 169) | 0;
  HEAP32[i1 >> 2] = i1;
  HEAP32[i1 + 4 >> 2] = i1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[gb + 1450784 >> 2] = i1;
 }
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 7;
 HEAP32[i2 + 4 >> 2] = i4;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i2, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i2 + 8 >> 2] = fb + 375;
 HEAP32[i2 + 4 >> 2] = i1;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __Z23ClearVertexDataChannelsjjjR14VertexDataInfo(i5, i6, i7, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i7) return;
 i12 = i9 + 84 | 0;
 if (!i6) return; else {
  i3 = 0;
  i4 = 1;
 }
 do {
  if (i4 & i7 | 0) {
   i1 = HEAP16[i9 + (i3 << 2) >> 1] | 0;
   i8 = HEAPU8[i9 + 32 + ((i1 & 255) * 12 | 0) + 10 >> 0] | 0;
   i10 = HEAP16[i9 + (i3 << 2) + 2 >> 1] | 0;
   i10 = Math_imul((i10 & 65535) >>> 8 & 65535, HEAPU8[(i10 & 255) + (gb + 430676) >> 0] | 0) | 0;
   i11 = ((i3 | 0) == 2) << 31 >> 31;
   i1 = (HEAP32[i12 >> 2] | 0) + (((i1 & 65535) >>> 8 & 65535) + (HEAP32[i9 + 32 + ((i1 & 255) * 12 | 0) + 4 >> 2] | 0)) + (Math_imul(i8, i5) | 0) | 0;
   i2 = 0;
   while (1) {
    _memset(i1 | 0, i11 | 0, i10 | 0) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i6 | 0)) break; else i1 = i1 + i8 | 0;
   }
  }
  i3 = i3 + 1 | 0;
  i4 = i4 << 1;
 } while ((i3 | 0) < 8 & i4 >>> 0 <= i7 >>> 0);
 return;
}

function __Z21GetShaderGlobalMatrixN9ShaderLab16FastPropertyNameE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 L1 : do if ((i6 | 0) != -1 & (i6 & -1073741824 | 0) == -2147483648) i1 = (__Z12GetGfxDevicev() | 0) + 1764 + ((i6 & 1073741823) << 6) | 0; else {
  i2 = HEAP32[gb + 1166248 >> 2] | 0;
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  i4 = HEAP32[i2 + 56 >> 2] | 0;
  if ((i1 | 0) < (i4 | 0)) {
   i5 = HEAP32[i2 + 68 >> 2] | 0;
   while (1) {
    if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
    i1 = i1 + 1 | 0;
    if ((i1 | 0) >= (i4 | 0)) {
     i1 = gb + 1162292 | 0;
     break L1;
    }
   }
   if ((i1 | 0) > -1) i1 = (HEAP32[i2 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 88 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) | 0; else i1 = gb + 1162292 | 0;
  } else i1 = gb + 1162292 | 0;
 } while (0);
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZNK14SerializedFile11GetByteSizeEx(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = i6 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 * 24 | 0) | 0;
   i3 = i4;
   i10 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i10 | 0) < (i8 | 0) | ((i10 | 0) == (i8 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) {
  i10 = i1;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  if (!((i9 | 0) > (i8 | 0) | ((i9 | 0) == (i8 | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 > i7 >>> 0 : 0))) {
   i10 = i1;
   i10 = i10 + 12 | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   return i10 | 0;
  }
 }
 i10 = i6;
 i10 = i10 + 12 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 return i10 | 0;
}

function __ZN5physx9NpFactory25createNpArticulationJointERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_(i8, i6, i7, i4, i5) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i8 + 3340 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i8 + 3336 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i8 + 3044 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i8 + 3324 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i8 = i8 + 3328 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!i1) {
  i8 = 0;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  return i8 | 0;
 }
 __ZN5physx19NpArticulationJointC2ERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_(i1, i6, i7, i4, i5);
 i8 = i1;
 i7 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 return i8 | 0;
}

function __ZN5physx2Sc9ClothCore19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i11 = i4;
 i6 = i3 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 176 >> 2] | 0, i5 | 0) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i2 + (i1 << 4);
 i2 = i3 + 72 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 mftCall_viiii(i10 | 0, i9 | 0, i8 | 0, 0, i7 | 0);
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 176 >> 2] | 0, i6 | 0) | 0;
 i3 = i3 + 76 | 0;
 HEAP32[i3 >> 2] = i6 - i5 + (HEAP32[i3 >> 2] | 0);
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc5Actor19reallocInteractionsERPPNS0_11InteractionERjjj(i7, i6, i5, i4, i1) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 do if (!i1) {
  i2 = 0;
  i3 = 0;
 } else if (i1 >>> 0 < 5) {
  i2 = 4;
  i3 = i7 + 4 | 0;
  break;
 } else {
  i3 = i1 + -1 | 0;
  i3 = i3 >>> 1 | i3;
  i3 = i3 >>> 2 | i3;
  i3 = i3 >>> 4 | i3;
  i3 = i3 >>> 8 | i3;
  i3 = (i3 >>> 16 | i3) + 1 | 0;
  i2 = i3;
  i3 = __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj(HEAP32[i7 + 36 >> 2] | 0, i3) | 0;
  break;
 } while (0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i6 >> 2] = i3;
  return;
 }
 _memcpy(i3 | 0, i1 | 0, i4 << 2 | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i7 + 4 | 0)) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i6 >> 2] = i3;
  return;
 }
 __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[i7 + 36 >> 2] | 0, i1, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i2;
 HEAP32[i6 >> 2] = i3;
 return;
}

function __ZN13ComputeShader30DestroyRuntimeDataWorkerThreadEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i9 + 44 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (i7 | 0) {
  i8 = i7 + -4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i5 = i7 + (i1 * 976 | 0) | 0;
   do {
    i1 = HEAP32[i5 + -12 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = i5 + -8 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i1);
    }
    i5 = i5 + -976 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  __ZdaPv(i8);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 i1 = i9 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i8 = i9 + 56 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i9 + 60 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i8 = i9 + 56 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i9 + 60 | 0;
 HEAP32[i9 >> 2] = 0;
 return;
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 852 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_LightsModule_CUSTOM_SetIntensityP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 920 >> 2] | 0) + 288 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_CollisionModule_CUSTOM_SetDampenP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 904 >> 2] | 0) + 144 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_CollisionModule_CUSTOM_SetBounceP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 904 >> 2] | 0) + 408 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _cff_decoder_prepare(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 656 >> 2] | 0;
 i3 = i2 + 1896 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i2 = i2 + 1324 | 0; else {
  i1 = (_cff_fd_select_get(i2 + 2924 | 0, i1) | 0) & 255;
  if (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
   i5 = 3;
   return i5 | 0;
  }
  i2 = HEAP32[i2 + 1900 + (i1 << 2) >> 2] | 0;
  if ((i4 | 0) != 0 & (HEAP32[i5 + 68 >> 2] | 0) != 0) HEAP32[i5 + 72 >> 2] = HEAP32[(HEAP32[i4 + 40 >> 2] | 0) + 4 + (i1 << 2) >> 2];
 }
 i1 = HEAP32[i2 + 544 >> 2] | 0;
 HEAP32[i5 + 696 >> 2] = i1;
 HEAP32[i5 + 712 >> 2] = HEAP32[i2 + 568 >> 2];
 if ((HEAP32[(HEAP32[i5 + 76 >> 2] | 0) + 1368 >> 2] | 0) == 1) i1 = 0; else if (i1 >>> 0 < 1240) i1 = 107; else i1 = i1 >>> 0 < 33900 ? 1131 : 32768;
 HEAP32[i5 + 704 >> 2] = i1;
 HEAP32[i5 + 552 >> 2] = HEAP32[i2 + 528 >> 2];
 HEAP32[i5 + 556 >> 2] = HEAP32[i2 + 532 >> 2];
 HEAP32[i5 + 736 >> 2] = i2;
 i5 = 0;
 return i5 | 0;
}

function __ZNK4Mesh22CalculateTriangleCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i1 + 32 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = (HEAP32[i3 + 132 >> 2] | 0) - (HEAP32[i3 + 128 >> 2] | 0) | 0;
 i6 = (i4 | 0) / 52 | 0;
 if ((i4 | 0) > 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i6 = 0;
  return i6 | 0;
 }
 while (1) {
  i4 = HEAP32[i3 + 128 >> 2] | 0;
  switch (HEAP32[i4 + (i2 * 52 | 0) + 40 >> 2] | 0) {
  case 1:
   {
    i7 = HEAP32[i4 + (i2 * 52 | 0) + 32 >> 2] | 0;
    i8 = HEAP32[i3 + 112 >> 2] | 0;
    i3 = (HEAP32[i3 + 116 >> 2] | 0) - i8 | 0;
    i1 = (__Z21CountTrianglesInStripItEiPKT_i((i3 | 0) != 0 & i3 >>> 0 > i7 >>> 0 ? i8 + i7 | 0 : 0, HEAP32[i4 + (i2 * 52 | 0) + 36 >> 2] | 0) | 0) + i1 | 0;
    break;
   }
  case 0:
   {
    i1 = (((HEAP32[i4 + (i2 * 52 | 0) + 36 >> 2] | 0) >>> 0) / 3 | 0) + i1 | 0;
    break;
   }
  default:
   {}
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i6 | 0)) break;
  i3 = HEAP32[i5 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZNK14SerializedFile12GetByteStartEx(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = i6 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 * 24 | 0) | 0;
   i3 = i4;
   i10 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i10 | 0) < (i8 | 0) | ((i10 | 0) == (i8 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) {
  i10 = i1;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  if (!((i9 | 0) > (i8 | 0) | ((i9 | 0) == (i8 | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 > i7 >>> 0 : 0))) {
   i10 = i1;
   i10 = i10 + 8 | 0;
   i10 = HEAP32[i10 >> 2] | 0;
   return i10 | 0;
  }
 }
 i10 = i6;
 i10 = i10 + 8 | 0;
 i10 = HEAP32[i10 >> 2] | 0;
 return i10 | 0;
}

function __ZN5physx25PxcGetMaterialHeightFieldEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i1, i6, i5, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 if ((HEAPU16[i1 + 68 >> 1] | 0) < 2) {
  i3 = HEAP32[i5 + 4480 >> 2] | 0;
  if (!i3) return 1;
  i1 = i1 + 34 | 0;
  i2 = 0;
  do {
   HEAP16[i7 + (i2 << 2) + (i6 << 1) >> 1] = HEAP16[i1 >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i3 >>> 0);
  return 1;
 } else {
  i3 = HEAP32[i1 + 64 >> 2] | 0;
  i4 = HEAP32[i5 + 4480 >> 2] | 0;
  if (!i4) return 1;
  i1 = HEAP32[(HEAP32[i1 + 60 >> 2] | 0) + 20 >> 2] | 0;
  i2 = 0;
  do {
   i9 = HEAP32[i5 + 384 + (i2 << 6) + 48 + (i6 << 2) >> 2] | 0;
   i8 = i9 >>> 1;
   HEAP16[i7 + (i2 << 2) + (i6 << 1) >> 1] = HEAP16[i3 + (((HEAPU8[((i9 & 1 | 0) == 0 ? i1 + (i8 << 2) + 2 | 0 : i1 + (i8 << 2) + 3 | 0) >> 0] | 0) & 127) << 1) >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i4 >>> 0);
  return 1;
 }
 return 0;
}

function __ZN5physx14PxVehicleGraphC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 15808 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i2 + 15792 >> 2] = 1132396544;
 HEAP32[i2 + 15796 >> 2] = 1132396544;
 HEAP32[i2 + 15800 >> 2] = 1132396544;
 HEAPF32[i2 + 15804 >> 2] = Math_fround(1.0);
 i1 = 0;
 do {
  HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 48 + (i1 << 2) >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 96 + (i1 << 2) >> 2] = Math_fround(0.0);
  HEAP32[i2 + 144 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[i2 + 144 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 144 + (i1 * 12 | 0) + 8 >> 2] = 1132396544;
  HEAP32[i2 + 288 + (i1 * 12 | 0) >> 2] = 1132396544;
  HEAP32[i2 + 288 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i2 + 288 + (i1 * 12 | 0) + 8 >> 2] = 0;
  _memset(i2 + 3504 + (i1 << 10) | 0, 0, 1024) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 12);
 HEAP32[i2 + 15828 >> 2] = 0;
 return;
}

function __ZN5Umbra15CameraTransform16setCameraToWorldERKNS_9Matrix4x4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = i1 + 340 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 344 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 348 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 352 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 356 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 360 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 364 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 368 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 372 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 376 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 380 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 384 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 388 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 392 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 396 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 400 >> 2] = HEAP32[i2 + 60 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i3, i3) | 0;
 HEAP8[i1 + 436 >> 0] = 1;
 return;
}

function __ZN10TagManagerD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = gb + 32436 + 8;
 __ZN10TagManager15ThreadedCleanupEv(i7);
 i5 = i7 + 1068 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 1072 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   i3 = i2;
   while (1) {
    i2 = i3 + -40 | 0;
    HEAP32[i6 >> 2] = i2;
    i4 = HEAP32[i2 >> 2] | 0;
    if (i4) if (HEAP32[i3 + -36 >> 2] | 0) {
     __Z19free_alloc_internalPvRK10MemLabelId(i4, i3 + -16 | 0);
     i2 = HEAP32[i6 >> 2] | 0;
    }
    if ((i2 | 0) == (i1 | 0)) break; else i3 = i2;
   }
   i1 = HEAP32[i5 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i7 + 44 | 0;
 i2 = i7 + 1068 | 0;
 do {
  i3 = i2;
  i2 = i2 + -32 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4 | 0) if (HEAP32[i3 + -28 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i4, i3 + -8 | 0);
 } while ((i2 | 0) != (i1 | 0));
 HEAP32[i7 >> 2] = gb + 28648 + 8;
 HEAP32[i7 >> 2] = gb + 28496 + 8;
 return;
}

function __Z49ParticleSystem_MainModule_CUSTOM_SetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z49AnimationClip_CUSTOM_Internal_CreateAnimationClipP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(296, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 915178 | 0, 43) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return;
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 896 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 1220 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z37Material_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i7 = i9;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i8 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i8 = 6;
 if ((i8 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i6, i1 + 12 | 0, i4);
 STACKTOP = i9;
 return;
}

function __Z21TransposeMatrix4x4REFPK10Matrix4x4fPS_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i4 = i3 + 16 | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i3 + 32 | 0;
 i2 = i3 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i4;
 i2 = i3 + 48 | 0;
 i4 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i4 = i3 + 36 | 0;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 i1 = i3 + 52 | 0;
 i2 = i3 + 28 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i4;
 i2 = i3 + 56 | 0;
 i4 = i3 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 return;
}

function _scalbf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 do if (((HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647) >>> 0 > 2139095040) i4 = 3; else {
  i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i3 & 2147483647) >>> 0 > 2139095040) i4 = 3; else {
   if ((i3 & 2139095040) >>> 0 >= 2139095040) if (f2 > Math_fround(0.0)) {
    f1 = Math_fround(f1 * f2);
    break;
   } else {
    f1 = Math_fround(f1 / Math_fround(-f2));
    break;
   }
   if (Math_fround(_rintf(f2)) != f2) {
    f1 = Math_fround(f2 - f2);
    f1 = Math_fround(f1 / f1);
    break;
   }
   if (f2 > Math_fround(65.0e3)) {
    f1 = Math_fround(_scalbnf(f1, 65e3));
    break;
   }
   if (f2 < Math_fround(-65.0e3)) {
    f1 = Math_fround(_scalbnf(f1, -65e3));
    break;
   } else {
    f1 = Math_fround(_scalbnf(f1, ~~f2));
    break;
   }
  }
 } while (0);
 if ((i4 | 0) == 3) f1 = Math_fround(f1 * f2);
 return Math_fround(f1);
}

function __ZNK5physx7NpShape12getMaterialsEPPNS_10PxMaterialEj(i3, i8, i7) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 1457324 >> 2] | 0;
 do if (!(HEAP32[i3 + 36 >> 2] & 2)) {
  i1 = i3 + 48 | 0;
  i6 = __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i1) | 0;
  i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i1) | 0;
 } else {
  i2 = HEAP32[i3 + 40 >> 2] | 0;
  i1 = HEAP16[i2 + 116 >> 1] | 0;
  if (i1 << 16 >> 16 == 1) {
   i1 = 1;
   i6 = i2 + 112 | 0;
   break;
  } else {
   i6 = (HEAP32[(HEAP32[i3 + 32 >> 2] | 0) + 2504 >> 2] | 0) + (HEAP32[i2 + 112 >> 2] << 1) | 0;
   break;
  }
 } while (0);
 i1 = i1 & 65535;
 i4 = i1 >>> 0 < i7 >>> 0 ? i1 : i7;
 if (!i4) return i4 | 0;
 i3 = i5 + 52 | 0;
 i1 = i1 >>> 0 > i7 >>> 0 ? i7 : i1;
 i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAPU16[i6 + (i2 << 1) >> 1] | 0) << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i4 | 0;
}

function __ZN9TextAsset18SetScriptDontDirtyERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 48 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 56 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 52 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 52 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN8Playable11ClearInputsEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2) {
  if (!i3) {
   i5 = i1 + 28 | 0;
   HEAP32[i5 >> 2] = 0;
   return;
  } else i3 = 0;
  do {
   i2 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (i2) {
    __ZN8Playable11ClearInputsEb(i2, 1);
    i1 = __Z18GetDirectorManagerv() | 0;
    __ZN15DirectorManager22ScheduleForDestructionEP8Playable(i1, HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i1 + 28 >> 2] | 0;
  } while (i3 >>> 0 < i2 >>> 0);
 } else i2 = i3;
 if (!i2) {
  i5 = i1 + 28 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 } else i2 = 0;
 do {
  __ZN8Playable10DisconnectEPS_i(i4, i2);
  i2 = i2 + 1 | 0;
  i1 = (HEAP32[i5 >> 2] | 0) + 28 | 0;
 } while (i2 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx8debugger4comm14CreateProperty9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 i4 = i2 + 28 | 0;
 HEAP8[i5 >> 0] = HEAP32[i4 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 | 0);
 HEAP32[i4 >> 2] = HEAPU8[i5 >> 0];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i2 + 32 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc9ClothCore18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 8 | 0;
 i11 = i4;
 i6 = i3 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 192 >> 2] | 0, i5 | 0) | 0;
 i9 = HEAP32[i6 >> 2] | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i11 >> 2] = i2;
 HEAP32[i11 + 4 >> 2] = i2 + (i1 << 4);
 i2 = i3 + 80 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 mftCall_viiii(i10 | 0, i9 | 0, i8 | 0, 0, i7 | 0);
 i6 = HEAP32[i6 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 192 >> 2] | 0, i6 | 0) | 0;
 i3 = i3 + 84 | 0;
 HEAP32[i3 >> 2] = i6 - i5 + (HEAP32[i3 >> 2] | 0);
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN5physx12NpBatchQueryD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i3 >> 2] = gb + 92916 + 8;
 __ZN5physx2Sq17SceneQueryManager12freeSPUTasksEPNS_12NpBatchQueryE((HEAP32[i3 + 8 >> 2] | 0) + 3392 | 0, i3);
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i5 | 0) < 0 | (i5 & 2147483647 | 0) == 0))) {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 i1 = i3 + 4 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
  STACKTOP = i4;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN14RenderSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(408, i1, 16, gb + 1048932 | 0, 0, gb + 383966 | 0, 37) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 35612 + 8;
 i2 = i4 + 348 | 0;
 HEAP32[i4 + 380 >> 2] = 0;
 HEAP32[i4 + 384 >> 2] = 0;
 HEAP32[i4 + 388 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __ZN20SphericalHarmonicsL27SetZeroEv(i4 + 76 | 0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_113StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1103788 >> 2] | 0;
 i1 = i2 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[gb + 1103788 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
  __ZdlPv(i1);
 }
 HEAP32[gb + 1103788 >> 2] = 0;
 if ((HEAP8[gb + 1103776 + 11 >> 0] | 0) < 0) {
  HEAP8[HEAP32[gb + 1103776 >> 2] >> 0] = 0;
  HEAP32[gb + 1103776 + 4 >> 2] = 0;
  return;
 } else {
  HEAP8[gb + 1103776 >> 0] = 0;
  HEAP8[gb + 1103776 + 11 >> 0] = 0;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 956 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 44 >> 2] | 0) + 692 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _sha512_update(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i7;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4 & 127;
 i8 = _i64Add(i4 | 0, HEAP32[i8 + 4 >> 2] | 0, i2 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i4;
 do if (!i3) i5 = 5; else {
  i4 = 128 - i3 | 0;
  i3 = i7 + 72 + i3 | 0;
  if (i4 >>> 0 > i2 >>> 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   break;
  } else {
   _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
   _processblock_51(i7, i7 + 72 | 0);
   i2 = i2 - i4 | 0;
   i1 = i1 + i4 | 0;
   i5 = 5;
   break;
  }
 } while (0);
 if ((i5 | 0) == 5) {
  if (i2 >>> 0 > 127) {
   i4 = i2 + -128 | 0;
   i5 = i4 & -128;
   i6 = i5 + 128 | 0;
   i3 = i1;
   while (1) {
    _processblock_51(i7, i3);
    i2 = i2 + -128 | 0;
    if (i2 >>> 0 <= 127) break; else i3 = i3 + 128 | 0;
   }
   i2 = i4 - i5 | 0;
   i1 = i1 + i6 | 0;
  }
  _memcpy(i7 + 72 | 0, i1 | 0, i2 | 0) | 0;
 }
 return;
}

function _jinit_memory_mgr(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = _jpeg_mem_init(i1) | 0;
 i4 = _jpeg_get_small(i1, 84) | 0;
 if (!i4) {
  _jpeg_mem_term(i1);
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 54;
  HEAP32[i5 + 24 >> 2] = 0;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
 }
 HEAP32[i4 >> 2] = fb + 332;
 HEAP32[i4 + 4 >> 2] = fb + 333;
 HEAP32[i4 + 8 >> 2] = fb + 136;
 HEAP32[i4 + 12 >> 2] = fb + 137;
 HEAP32[i4 + 16 >> 2] = fb + 130;
 HEAP32[i4 + 20 >> 2] = fb + 131;
 HEAP32[i4 + 24 >> 2] = fb + 3248;
 HEAP32[i4 + 28 >> 2] = fb + 131;
 HEAP32[i4 + 32 >> 2] = fb + 132;
 HEAP32[i4 + 36 >> 2] = fb + 2359;
 HEAP32[i4 + 40 >> 2] = fb + 3249;
 HEAP32[i4 + 48 >> 2] = 1e9;
 HEAP32[i4 + 44 >> 2] = i3;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 64 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = 0;
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = 84;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZN5physx2Gu12StoreIndicesEtjPKtRNS_14PxOutputStreamEb(i2, i7, i6, i8, i5) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9;
 i3 = i9 + 2 | 0;
 i1 = (i7 | 0) == 0;
 if ((i2 & 65535) < 256) {
  if (i1) {
   STACKTOP = i9;
   return;
  }
  i1 = 0;
  do {
   HEAP8[i3 >> 0] = HEAP16[i6 + (i1 << 1) >> 1];
   mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i3 | 0, 1) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  STACKTOP = i9;
  return;
 }
 if (i1) {
  STACKTOP = i9;
  return;
 }
 i2 = i4 + 1 | 0;
 i3 = 0;
 do {
  i1 = HEAP16[i6 + (i3 << 1) >> 1] | 0;
  HEAP16[i4 >> 1] = i1;
  if (i5) {
   HEAP8[i4 >> 0] = (i1 & 65535) >>> 8;
   HEAP8[i2 >> 0] = i1;
  }
  mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i4 | 0, 2) | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i7 | 0));
 STACKTOP = i9;
 return;
}

function __ZN5physx26NpPhysicsInsertionCallback12insertObjectERNS_6PxBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 switch (HEAP16[i2 + 4 >> 1] | 0) {
 case 3:
  {
   HEAP32[i2 + 224 >> 2] = HEAP32[gb + 1457204 >> 2];
   __ZN5physx2Gu12TriangleMesh18setupMeshInterfaceEv(i2);
   __ZN5physx13GuMeshFactory15addTriangleMeshEPNS_2Gu12TriangleMeshEb(HEAP32[gb + 1457204 >> 2] | 0, i2, 1);
   i2 = 1;
   STACKTOP = i1;
   return i2 | 0;
  }
 case 1:
  {
   HEAP32[i2 + 112 >> 2] = HEAP32[gb + 1457204 >> 2];
   __ZN5physx13GuMeshFactory14addHeightFieldEPNS_2Gu11HeightFieldEb(HEAP32[gb + 1457204 >> 2] | 0, i2, 1);
   i2 = 1;
   STACKTOP = i1;
   return i2 | 0;
  }
 default:
  {
   __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 768264 | 0, 50, gb + 768350 | 0, i1);
   i2 = 0;
   STACKTOP = i1;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN28LightProbeProxyVolumeManager14AddProxyVolumeEP21LightProbeProxyVolume(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = i9 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 return;
}

function __ZN14Texture2DArray17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (HEAP8[i1 + 110 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!((HEAP32[i1 + 52 >> 2] | 0) == 0 & (HEAP8[i1 + 109 >> 0] | 0) == 0)) {
  __ZN14Texture2DArray13UploadTextureEv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (HEAP32[i1 + 8 >> 2] & 1048576 | 0) __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZL33GeomOverlapCallback_CapsuleConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i9 = (i10 | 0) == 0;
 if (i9) {
  i6 = 0;
  i7 = 0;
  i8 = 1065353216;
 } else if ((HEAP16[i10 + 12 >> 1] | 0) == 2) {
  i6 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = HEAP32[i10 + 8 >> 2] | 0;
 } else {
  i6 = 0;
  i7 = 0;
  i8 = 1065353216;
 }
 i2 = __ZN5physx2Gu22intersectCapsuleConvexERKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i2, i4, i1, i3 + 4 | 0, i5, 0) | 0;
 if (!(i9 | i2 ^ 1)) {
  HEAP32[i10 >> 2] = i6;
  HEAP32[i10 + 4 >> 2] = i7;
  HEAP32[i10 + 8 >> 2] = i8;
 }
 if (i9) return i2 | 0;
 i1 = i10 + 12 | 0;
 if (i2) {
  HEAP16[i1 >> 1] = 2;
  return i2 | 0;
 } else {
  HEAP16[i1 >> 1] = 0;
  return i2 | 0;
 }
 return 0;
}

function __Z52GeometryUtility_CUSTOM_INTERNAL_CALL_CalculateBoundsP11Il2CppArrayRK10Matrix4x4fR4AABB(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 if (!i1) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 518224 | 0);
 if (!(__Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 558494 | 0, i5); else {
  i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
  __Z30CalculateAABBFromPositionArrayRK10Matrix4x4fPK8Vector3fj(i4, i2, i6, __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_TrailModule_CUSTOM_SetLifetimeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 908 >> 2] | 0) + 12 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 892 >> 2] | 0) + 536 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 892 >> 2] | 0) + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapZP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 1620 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapYP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 1356 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 888 >> 2] | 0) + 1092 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIttEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionItsEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIstEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIssEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 2 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP16[i7 >> 1] = HEAP16[i1 >> 1] | 0;
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 2);
 i1 = HEAP16[i7 >> 1] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP16[i5 >> 1] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i16(i1 | 0) | 0;
 HEAP16[i7 >> 1] = i6;
 i7 = i6;
 HEAP16[i5 >> 1] = i7;
 STACKTOP = i8;
 return 1;
}

function __ZN5physx13NpVolumeCacheD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i3 >> 2] = gb + 101476 + 8;
 i1 = HEAP32[i3 + 104 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 96 >> 2] | 0;
  if (i1 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
  }
 }
 i5 = HEAP32[i3 + 92 >> 2] | 0;
 if (!((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i3 + 84 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
  STACKTOP = i4;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra13MatrixFactory7frustumEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var f5 = f0, i6 = 0;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i6 = i1 + 48 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 f5 = Math_fround(Math_fround(1.0) / Math_fround(f4 - f3));
 f2 = Math_fround(Math_fround(1.0) / Math_fround(+Math_tan(+Math_fround(Math_fround(f2 * Math_fround(3.14159274)) / Math_fround(360.0)))));
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAPF32[i1 + 40 >> 2] = Math_fround(-Math_fround(Math_fround(f3 + f4) * f5));
 HEAPF32[i1 + 44 >> 2] = Math_fround(Math_fround(Math_fround(f3 * f4) * Math_fround(-2.0)) * f5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return;
}

function __ZN17BillboardRenderer15UpdateLocalAABBEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0;
 i2 = HEAP32[i1 + 360 >> 2] | 0;
 if (!i2) {
  i2 = i1 + 188 | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  i2 = i1 + 200 | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 } else {
  i2 = HEAP32[i2 + 32 >> 2] | 0;
  f4 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(.5));
  f5 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 24 >> 2]));
  f3 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(.5));
  HEAPF32[i1 + 188 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 192 >> 2] = f5;
  HEAPF32[i1 + 196 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 200 >> 2] = f3;
  HEAPF32[i1 + 204 >> 2] = f4;
  HEAPF32[i1 + 208 >> 2] = f3;
  return;
 }
}

function __ZN14DataBufferGLES16FlushMappedRangeEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 692 >> 0] | 0)) return;
 i4 = HEAP32[gb + 1451080 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 switch (HEAP32[i1 + 12 >> 2] | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
   } else i1 = 1;
   break;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 0 : 2;
   } else i1 = 0;
   break;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   break;
  }
 default:
  i1 = -559030611;
 }
 __ZN7ApiGLES11FlushBufferEjN2gl12BufferTargetEll(i4, i5, i1, i2, i3);
 return;
}

function _UNITY_FT_Create_Class_cff_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 64, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = gb + 1007777;
 HEAP32[i3 + 4 >> 2] = gb + 1006997;
 HEAP32[i3 + 8 >> 2] = gb + 1007001;
 i4 = HEAP32[i1 + 196 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = i4 + 8;
 HEAP32[i3 + 16 >> 2] = gb + 1008130;
 HEAP32[i3 + 20 >> 2] = i4 + 36;
 HEAP32[i3 + 24 >> 2] = gb + 1007761;
 HEAP32[i3 + 28 >> 2] = i4 + 28;
 HEAP32[i3 + 32 >> 2] = gb + 1008121;
 HEAP32[i3 + 36 >> 2] = i4 + 40;
 HEAP32[i3 + 40 >> 2] = gb + 1007017;
 HEAP32[i3 + 44 >> 2] = i4 + 44;
 HEAP32[i3 + 48 >> 2] = gb + 1008162;
 HEAP32[i3 + 52 >> 2] = i4 + 56;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_(i1, i2, i3, i5) | 0;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0)) return i6 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0)) {
  i7 = i6 + 1 | 0;
  return i7 | 0;
 }
 i7 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i7;
 if (!(__ZN15ReflProbeSorterclEPK15ReflectionProbeS2_(i5, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0)) {
  i7 = i6 + 2 | 0;
  return i7 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i7;
 i7 = i6 + 3 | 0;
 return i7 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 64;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN24TextDOMTransferWriteBaseI9JSONWriteEC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2, i3);
 i3 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = i1 + 76;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 1024;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i3);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 3;
 HEAP32[i1 + 56 >> 2] = i3;
 return;
}

function __ZN8VRModule11EarlyUpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (__Z12GetIVRDevicev() | 0) if (__ZNK8VRDevice10ShouldQuitEv(__Z12GetIVRDevicev() | 0) | 0) {
  i2 = __Z15GetInputManagerv() | 0;
  HEAP8[i2 + 189 >> 0] = 1;
  HEAP8[i2 + 188 >> 0] = 1;
  break;
 } else {
  __ZN8VRDevice12ProcessFocusEv(__Z12GetIVRDevicev() | 0);
  break;
 } while (0);
 if (__Z12GetIVRDevicev() | 0) __ZN8VRDevice11EarlyUpdateEv(__Z12GetIVRDevicev() | 0);
 if (HEAP8[i1 >> 0] | 0) if ((HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) != 4) __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i1, i1 + 4 | 0, 1);
 i1 = i1 + 1 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i2 = __Z12GetIVRDevicev() | 0;
  if (i2 | 0) {
   __ZN8VRDevice22StartRenderingToDeviceEv(i2);
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) HEAP8[i1 >> 0] = 0;
  }
 }
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice20UpdateVRSplashScreenEv(__Z12GetIVRDevicev() | 0);
 return;
}

function __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i3) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 * 40 | 0, 4) | 0;
  i3 = i1 + (i3 * 40 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    HEAP32[i2 + 8 >> 2] = 0;
    HEAP32[i2 + 12 >> 2] = 0;
    HEAP32[i2 + 16 >> 2] = 0;
    HEAP32[i2 + 20 >> 2] = 0;
    HEAP32[i2 + 24 >> 2] = 1065353216;
    HEAP32[i2 + 28 >> 2] = 1065353216;
    HEAP32[i2 + 32 >> 2] = 1065353216;
    HEAP32[i2 + 36 >> 2] = 1065353216;
    i2 = i2 + 40 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE4copyIS5_EEvRKNS1_IS4_T_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 8 >> 2] = i1;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 << 3, gb + 838004 | 0, 543) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i2 + (HEAP32[i5 >> 2] << 3) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  i4 = i1;
  i7 = i4;
  i7 = HEAPU16[i7 >> 1] | HEAPU16[i7 + 2 >> 1] << 16;
  i4 = i4 + 4 | 0;
  i4 = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
  i5 = i2;
  i6 = i5;
  HEAP16[i6 >> 1] = i7;
  HEAP16[i6 + 2 >> 1] = i7 >>> 16;
  i5 = i5 + 4 | 0;
  HEAP16[i5 >> 1] = i4;
  HEAP16[i5 + 2 >> 1] = i4 >>> 16;
  i2 = i2 + 8 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function __ZN5physx12NpBatchQuery18resetResultBuffersEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 80 >> 2] | 0;
  i3 = 0;
  do {
   i5 = i2 + (i3 * 80 | 0) + 64 | 0;
   i3 = i3 + 1 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP16[i5 + 12 >> 1] = 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 96 >> 2] | 0;
  i3 = 0;
  do {
   i5 = i2 + (i3 << 5) + 16 | 0;
   i3 = i3 + 1 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP16[i5 + 12 >> 1] = 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i4 + 88 >> 2] | 0;
 i2 = 0;
 do {
  i5 = i1 + (i2 << 6) + 48 | 0;
  i2 = i2 + 1 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP16[i5 + 12 >> 1] = 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return;
}

function __ZN4Mesh24RecalculateSubmeshBoundsEj(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 __ZN4Mesh32RecalculateSubmeshBoundsInternalEj(i5, i1);
 HEAP32[i4 >> 2] = gb + 30832;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i5;
 i2 = HEAP32[i5 + 236 >> 2] | 0;
 i3 = i5 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, gb + 1105176 | 0, i4);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 i3 = i5 + 240 | 0;
 i1 = HEAP32[i5 + 244 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN31ParticleSystemParticlesTempDataC2Ejbbb(i8, i1, i7, i5, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i8 + 12 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 HEAP32[i8 + 20 >> 2] = 0;
 if (!i1) return;
 i3 = i8 + 8 | 0;
 i2 = i1 + 3 & -4;
 i4 = i2 << 2;
 i1 = (Math_imul(i4, i5 ? 3 : 1) | 0) + i4 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 + (i7 ? i4 : 0) + (i9 ? i2 << 3 : 0) | 0, 16, gb + 64024 | 0, 0, gb + 621865 | 0, 1585) | 0;
 HEAP32[i8 >> 2] = i2;
 i2 = i2 + i4 | 0;
 HEAP32[i8 + 4 >> 2] = i2;
 i1 = i2 + i4 | 0;
 if (i5) {
  HEAP32[i3 >> 2] = i1;
  i1 = i1 + i4 | 0;
  HEAP32[i6 >> 2] = i1;
  i1 = i1 + i4 | 0;
 } else {
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i2;
 }
 if (i7) {
  HEAP32[i8 + 16 >> 2] = i1;
  i1 = i1 + i4 | 0;
 }
 if (!i9) return;
 HEAP32[i8 + 20 >> 2] = i1;
 return;
}

function __ZN18LoadSceneOperationC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 __ZN13LoadOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 65820 + 8;
 i6 = i1 + 160 | 0;
 i7 = i1 + 164 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i7 = gb + 63416 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i1 + 180 | 0, i3);
 HEAP32[i1 + 464 >> 2] = 50;
 HEAP8[i1 + 468 >> 0] = 1;
 HEAP8[i1 + 469 >> 0] = 0;
 HEAP8[i1 + 470 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE16StripInvalidKeysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 152 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + 164 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i2;
 i4 = i2 + (i3 * 52 | 0) | 0;
 L4 : while (1) {
  while (1) {
   if (!(((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 8 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i1 + 12 >> 2] & 2139095040 | 0) != 2139095040 & (HEAP32[i1 + 16 >> 2] & 2139095040 | 0) != 2139095040)) break;
   if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
   i1 = i1 + 52 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 8;
    break L4;
   }
  }
  i4 = i1 + 52 | 0;
  _memmove(i1 | 0, i4 | 0, i2 + (i3 * 52 | 0) - i4 | 0) | 0;
  i3 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i3;
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i2 + (i3 * 52 | 0) | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZN13RenderTexture10ReleaseAllEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 12 | 0;
 i1 = i3 + 8 | 0;
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i1 >> 2] = 0;
 i6 = __Z12GetGfxDevicev() | 0;
 HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 368 >> 2] | 0, i6 | 0) | 0;
 i6 = __Z12GetGfxDevicev() | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 372 >> 2] | 0, i6 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij(1, i4, i2, i1, 0, -1, 0, 0) | 0;
 i1 = HEAP32[gb + 1158220 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1158220 | 0)) {
  STACKTOP = i3;
  return;
 }
 do {
  __ZN13RenderTexture7ReleaseEv(HEAP32[i1 + 8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (gb + 1158220 | 0));
 STACKTOP = i3;
 return;
}

function __ZN13ComputeBuffer22UnloadAllFromGfxDeviceEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = i6;
 i1 = HEAP32[gb + 1166280 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1166280 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  i8 = __Z12GetGfxDevicev() | 0;
  i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 808 >> 2] | 0;
  i7 = i7 + 12 | 0;
  HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  mftCall_vii(i9 | 0, i8 | 0, i3 | 0);
  i8 = __Z25GetUncheckedRealGfxDevicev() | 0;
  i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 748 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  mftCall_vii(i9 | 0, i8 | 0, i3 | 0);
  HEAP32[i7 >> 2] = 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (gb + 1166280 | 0));
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_112UploadFormatE13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (__Z29NeedToDecompressTextureFormat13TextureFormat(i1) | 0) {
  if ((i1 | 0) == 24) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0) {
   i2 = 17;
   return i2 | 0;
  }
  i2 = 4;
  return i2 | 0;
 }
 i2 = HEAP32[gb + 1451148 >> 2] | 0;
 if ((HEAP32[i2 + 140 >> 2] | 0) != 2) if ((i1 | 0) == 1 & (HEAP8[i2 + 145 >> 0] | 0) == 0) {
  i2 = 4;
  return i2 | 0;
 }
 switch (i1 | 0) {
 case 8:
  {
   i2 = 3;
   return i2 | 0;
  }
 case 6:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 177 >> 0] | 0)) {
    i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 191 >> 0] | 0) == 0;
    i2 = i2 ? 4 : 20;
    return i2 | 0;
   }
   break;
  }
 case 14:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 185 >> 0] | 0)) {
    i2 = 4;
    return i2 | 0;
   }
   break;
  }
 case 2:
  {
   i2 = 13;
   return i2 | 0;
  }
 case 5:
  {
   i2 = 4;
   return i2 | 0;
  }
 default:
  {}
 }
 i2 = i1;
 return i2 | 0;
}

function __Z52AnimatorControllerPlayable_CUSTOM_ResetTriggerStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0;
 i1 = mftCall_iii(i6 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i6, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i5;
 return;
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 892 >> 2] | 0) + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_LightsModule_CUSTOM_SetRangeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, (HEAP32[i1 + 920 >> 2] | 0) + 24 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN14SafeBinaryRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i7, i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 if (!(HEAP8[i7 + 128 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[i3 >> 2] | 0, i4, 0, i5) | 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i7) >> 2] = i5;
 STACKTOP = i6;
 return;
}

function __Z19ClearShadowMapCacheP14ShadowMapCache(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   i1 = i2 + 20 | 0;
   if (HEAP32[i1 >> 2] | 0) {
    i5 = __Z22GetRenderBufferManagerv() | 0;
    __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i5, HEAP32[i1 >> 2] | 0);
   }
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i3, HEAP32[i4 >> 2] | 0);
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 return;
}

function _tt_cmap10_validate(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i3 + 20 | 0;
 i5 = i7 + 8 | 0;
 if (i1 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i7, 8);
 i4 = (HEAPU8[i3 + 5 >> 0] | 0) << 16 | (HEAPU8[i3 + 4 >> 0] | 0) << 24 | (HEAPU8[i3 + 6 >> 0] | 0) << 8 | (HEAPU8[i3 + 7 >> 0] | 0);
 i2 = (HEAPU8[i3 + 17 >> 0] | 0) << 16 | (HEAPU8[i3 + 16 >> 0] | 0) << 24 | (HEAPU8[i3 + 18 >> 0] | 0) << 8 | (HEAPU8[i3 + 19 >> 0] | 0);
 if (i4 >>> 0 < 20 ? 1 : i4 >>> 0 > ((HEAP32[i5 >> 2] | 0) - i3 | 0) >>> 0) i6 = 5; else if ((i4 + -20 | 0) >>> 1 >>> 0 < i2 >>> 0) i6 = 5;
 if ((i6 | 0) == 5) _UNITY_ft_validator_error(i7, 8);
 if ((HEAP32[i7 + 12 >> 2] | 0) == 0 | (i2 | 0) == 0) return 0;
 i3 = i7 + 20 | 0;
 while (1) {
  if (((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0)) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i7, 16);
  i2 = i2 + -1 | 0;
  if (!i2) break; else i1 = i1 + 2 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 5) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 5) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
  i1 = i1 + 32 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Ext15CpuWorkerThreadD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 86808 + 8;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 HEAP32[i2 >> 2] = gb + 86828 + 8;
 i1 = i2 + 4 | 0;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN13LoadOperationD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 65708 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4 + 148 | 0);
 i3 = i4 + 140 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 108 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i4 + 64 | 0;
 if ((HEAP32[i4 + 80 >> 2] | 0) <= -1) {
  __ZN14AsyncOperationD2Ev(i4);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 68 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN14AsyncOperationD2Ev(i4);
 return;
}

function __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i1 + 16 | 0;
 if (!(HEAP32[i9 >> 2] | 0)) return;
 i8 = i1 + 20 | 0;
 i6 = i2 + 36 | 0;
 i7 = i6;
 i5 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i8 >> 2] | 0;
  if (HEAP32[i2 + (i5 << 4) + 4 >> 2] | 0) if (__ZN11UnityEngine9Animation28SetBoundCurveInstanceIDValueERKNS0_10BoundCurveEi(i2 + (i5 << 4) | 0, HEAP32[(HEAP32[i6 >> 2] | 0) + i7 + (i5 << 2) >> 2] | 0) | 0) {
   i4 = i1;
   i2 = i2 + (i5 << 4) + 12 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) != (i3 | 0)) if (!i1) i1 = i3; else {
    mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, 16);
    i1 = HEAP32[i2 >> 2] | 0;
   }
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (HEAP32[i9 >> 2] | 0));
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 return;
}

function __GLOBAL__sub_I_runtime_modules_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1162872 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162872 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162872 + 12 >> 2] = 16;
 i1 = gb + 1162872 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3414 | 0, fb + 3415 | 0, 0, gb + 1162872 | 0);
 HEAP32[gb + 1162952 >> 2] = 0;
 i3 = gb + 63216 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1162952 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1162952 + 12 >> 2] = 16;
 i1 = gb + 1162952 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(0, fb + 3416 | 0, 0, gb + 1162952 | 0);
 return;
}

function __ZN7mecanim9animation19DestroyAvatarOutputEPNS0_12AvatarOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE(HEAP32[i1 + 4 >> 2] | 0, i2);
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 + 8 >> 2] | 0, i2);
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math7affineXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 + 12 >> 2] | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 24 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 20 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn5ConvX9convert16EPKcRKNS0_15PxMetaDataEntryES6_(i3, i6, i2, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 if (HEAP8[i3 + 325 >> 0] | 0) {
  STACKTOP = i11;
  return;
 }
 i7 = i2 + 16 | 0;
 if ((HEAP32[i7 >> 2] | 0) <= 0) {
  STACKTOP = i11;
  return;
 }
 i8 = i3 + 308 | 0;
 i9 = i3 + 304 | 0;
 i4 = i3 + 312 | 0;
 i5 = i10 + 1 | 0;
 i2 = i6;
 i3 = 0;
 while (1) {
  i1 = HEAP16[i2 >> 1] | 0;
  HEAP16[i10 >> 1] = i1;
  if (HEAP8[i8 >> 0] | 0) {
   HEAP8[i10 >> 0] = (i1 & 65535) >>> 8;
   HEAP8[i5 >> 0] = i1;
  }
  i6 = HEAP32[i9 >> 2] | 0;
  i6 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i10 | 0, 2) | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i6;
  i3 = i3 + 1 | 0;
  if ((i3 | 0) >= (HEAP32[i7 >> 2] | 0)) break; else i2 = i2 + 2 | 0;
 }
 STACKTOP = i11;
 return;
}

function __ZN5physx19NpArticulationJoint17setTargetVelocityERKNS_6PxVec3E(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore17setTargetVelocityERKNS_6PxVec3E(i1, i8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 72 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 76 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i1 + 80 >> 2] = HEAP32[i8 + 8 >> 2];
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
 return;
}

function __ZN5Umbra14TomeCollection16findClusterIndexEiRiS1_(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = -1;
  HEAP32[i6 >> 2] = -1;
  return;
 }
 i3 = HEAP32[i1 + 180 >> 2] | 0;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = i4;
  return;
 }
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 if ((i2 | 0) > 1) {
  i1 = i1 + i3 | 0;
  i3 = i2 + -1 | 0;
  i2 = 0;
  do {
   i7 = (i2 + 1 + i3 | 0) / 2 | 0;
   i8 = (HEAP32[i1 + (i7 << 2) >> 2] | 0) > (i4 | 0);
   i3 = i8 ? i7 + -1 | 0 : i3;
   i2 = i8 ? i2 : i7;
  } while ((i3 | 0) > (i2 | 0));
 } else {
  i2 = 0;
  i1 = i1 + i3 | 0;
 }
 HEAP32[i5 >> 2] = i2;
 i8 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
 i7 = HEAP32[i1 + (i2 + 1 << 2) >> 2] | 0;
 i4 = i4 - i8 | 0;
 HEAP32[i6 >> 2] = i4;
 if ((i4 | 0) > -1 & (i4 | 0) < (i7 - i8 | 0)) return;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 1040 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i5 | 0, i1 | 0) | 0;
 if (!((i6 | 0) != 0 & i1)) {
  i6 = i1;
  return i6 | 0;
 }
 i2 = i6 + 4 | 0;
 if ((i2 | 0) != (i5 | 0)) {
  i3 = i6 + 1044 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 | 0);
  _strncpy(i2, i5, 1040) | 0;
  HEAP8[i6 + 1043 >> 0] = 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i6 + 1048 >> 2] = HEAP32[i5 + 1044 >> 2];
  HEAP32[i6 + 1052 >> 2] = 0;
  HEAP32[i6 + 1056 >> 2] = 0;
  HEAP32[i6 + 1060 >> 2] = 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 }
 HEAP32[i6 + 1056 >> 2] = HEAP32[i5 + 1052 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN14SafeBinaryRead8TransferIN8LODGroup11LODRendererEEEvRT_PKc17TransferMetaFlags(i6, i7, i2, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i2, gb + 425225 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) {
  i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, gb + 425237 | 0, gb + 425246 | 0, i4, 1) | 0;
  if (i1 | 0) {
   if ((i1 | 0) > 0) __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_(i7, i6); else {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
   }
   __ZN14SafeBinaryRead11EndTransferEv(i6);
  }
 } else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i7 | 0, i6 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i6);
 STACKTOP = i5;
 return;
}

function __ZN12LineRenderer12SetPositionsEPK8Vector3fj(i5, i6, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i1 = i5 + 348 | 0;
 i2 = i5 + 316 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) {
   i7 = i5 + 320 | 0;
   i8 = HEAP32[i3 >> 2] | 0;
   HEAP32[i2 >> 2] = i8;
   HEAP32[i7 >> 2] = i3;
   HEAP32[i8 + 4 >> 2] = i2;
   HEAP32[HEAP32[i7 >> 2] >> 2] = i2;
  }
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i3 >>> 0 < i4 >>> 0 ? i3 : i4;
 if (!i3) {
  __ZN8Renderer13BoundsChangedEv(i5);
  return;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 12 | 0) >> 2] = HEAP32[i6 + (i1 * 12 | 0) >> 2];
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i6 + (i1 * 12 | 0) + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 __ZN8Renderer13BoundsChangedEv(i5);
 return;
}

function __Z50AnimatorControllerPlayable_CUSTOM_SetTriggerStringR9HPlayableP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 i1 = mftCall_iii(i6 | 0, i1 | 0, __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i6, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i5;
 return;
}

function __Z30TextAsset_Get_Custom_PropBytesP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = i1 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i1 = i1 + 48 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 i2 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
 i1 = (i3 | 0) == 0 ? 0 : i1;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 1, i1) | 0;
 _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0, i3 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __Z29StdTemplateConversionFunctionIjjEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIjiEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIijEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIiiEbPvR14SafeBinaryRead(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i3 = i6 + 16 | 0;
 i2 = HEAP32[i6 + 20 >> 2] | 0;
 i1 = i2 + (HEAP32[(HEAP32[i6 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i6 + 36 >> 2] | 0, 0 - (HEAP32[i6 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i3 >> 2] = i1;
 if (i1 >>> 0 < i2 >>> 0) i4 = 4; else {
  i2 = i1 + 4 | 0;
  if (i2 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) i4 = 4; else {
   HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
   HEAP32[i3 >> 2] = i2;
  }
 }
 if ((i4 | 0) == 4) __ZN12CachedReader15UpdateReadCacheEPvj(i3, i7, 4);
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i6 >> 2] & 512)) {
  i7 = i1;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return 1;
 }
 i6 = _llvm_bswap_i32(i1 | 0) | 0;
 HEAP32[i7 >> 2] = i6;
 i7 = i6;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return 1;
}

function __ZZN2UI23InitializeCanvasManagerEvEN32UIEventsWillRenderCanvasesstruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 248 | 0;
 i4 = i3 + 8 | 0;
 i5 = i3;
 i2 = HEAP32[gb + 1467948 >> 2] | 0;
 i8 = __Z21GetUIScriptingClassesv() | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i1);
 HEAP32[i1 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i1, 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 do {
  __ZN2UI6Canvas13UpdateBatchesEb(HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 76;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9push_backEc(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = i4 + 11 | 0;
 i1 = HEAP8[i6 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i1 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i2 = i1 & 255;
  i1 = 10;
 }
 if ((i2 | 0) == (i1 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj(i4, i1, 1, i1, i1, 0, 0);
  if ((HEAP8[i6 >> 0] | 0) > -1) i1 = 7; else i1 = 8;
 } else if (i3) i1 = 8; else i1 = 7;
 if ((i1 | 0) == 7) {
  HEAP8[i6 >> 0] = i2 + 1;
  i6 = i4;
  i6 = i6 + i2 | 0;
  HEAP8[i6 >> 0] = i5;
  i6 = i6 + 1 | 0;
  HEAP8[i6 >> 0] = 0;
  return;
 } else if ((i1 | 0) == 8) {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = i2 + 1;
  i6 = i6 + i2 | 0;
  HEAP8[i6 >> 0] = i5;
  i6 = i6 + 1 | 0;
  HEAP8[i6 >> 0] = 0;
  return;
 }
}

function __ZN9ShaderLab4PassD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = HEAP32[i5 + 772 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 776 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i5 + 756 | 0, HEAP32[i5 + 760 >> 2] | 0);
 i1 = i5 + 728 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  i6 = i5 + 4 | 0;
  __ZN9ShaderLab11ShaderStateD2Ev(i6);
  STACKTOP = i7;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 + 740 >> 2] | 0;
 HEAP32[i6 >> 2] = 66;
 HEAP32[i6 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 i6 = i5 + 4 | 0;
 __ZN9ShaderLab11ShaderStateD2Ev(i6);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Cm9FlushPoolD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i5 + 4 | 0;
 i3 = i5 + 8 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = 0;
  do {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i4 = HEAP32[i5 + 12 >> 2] | 0;
 if ((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
  }
 }
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra14TomeCollection15findPortalIndexEiRiS1_(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = -1;
  HEAP32[i6 >> 2] = -1;
  return;
 }
 i3 = HEAP32[i1 + 184 >> 2] | 0;
 if (!i3) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = i4;
  return;
 }
 i2 = HEAP32[i1 + 176 >> 2] | 0;
 if ((i2 | 0) > 1) {
  i1 = i1 + i3 | 0;
  i3 = i2 + -1 | 0;
  i2 = 0;
  do {
   i7 = (i2 + 1 + i3 | 0) / 2 | 0;
   i8 = (HEAP32[i1 + (i7 << 2) >> 2] | 0) > (i4 | 0);
   i3 = i8 ? i7 + -1 | 0 : i3;
   i2 = i8 ? i2 : i7;
  } while ((i3 | 0) > (i2 | 0));
 } else {
  i2 = 0;
  i1 = i1 + i3 | 0;
 }
 HEAP32[i5 >> 2] = i2;
 i8 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
 i7 = HEAP32[i1 + (i2 + 1 << 2) >> 2] | 0;
 i4 = i4 - i8 | 0;
 HEAP32[i6 >> 2] = i4;
 if ((i4 | 0) > -1 & (i4 | 0) < (i7 - i8 | 0)) return;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZN2UI6Canvas19GetProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!(HEAP8[i1 + 44 >> 0] | 0)) {
  i4 = i1 + 48 | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __Z16GetScreenManagerv() | 0;
 f6 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0);
 i2 = __Z16GetScreenManagerv() | 0;
 i4 = i1 + 48 | 0;
 __ZN10Matrix4x4f8SetOrthoEffffff(i4, Math_fround(0.0), f6, Math_fround(0.0), Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0), Math_fround(-1.0e3), Math_fround(1.0e3)) | 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetLocalToWorldMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN10Matrix4x4fmLERKS_(i4, i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI14CanvasRenderer18EnableRectClippingE5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0;
 i3 = i1 + 165 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  f4 = Math_fround(HEAPF32[i1 + 168 >> 2]);
  if (f4 == Math_fround(HEAPF32[i2 >> 2])) {
   f4 = Math_fround(HEAPF32[i1 + 172 >> 2]);
   if (f4 == Math_fround(HEAPF32[i2 + 4 >> 2])) {
    f4 = Math_fround(HEAPF32[i1 + 176 >> 2]);
    if (f4 == Math_fround(HEAPF32[i2 + 8 >> 2])) {
     f4 = Math_fround(HEAPF32[i1 + 180 >> 2]);
     if (f4 == Math_fround(HEAPF32[i2 + 12 >> 2])) return;
    }
   }
  }
 }
 HEAP8[i3 >> 0] = 1;
 i3 = i1 + 168 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 2064;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN21LightProbeProxyVolume12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[gb + 1110944 >> 2] | 0;
 i3 = i9 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 i6 = i9 + 16 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i7 & 2147483647;
 do if (i5 >>> 0 > i8 >>> 0) {
  i2 = i7 << 1;
  i2 = (i2 | 0) == 0 ? 1 : i2;
  if (i8 >>> 0 < i2 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i9 >> 2] | 0, i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i8 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 4, i9 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i8 | 0, HEAP32[i9 >> 2] | 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
   HEAP32[i6 >> 2] = i2;
   HEAP32[i9 >> 2] = i8;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i5;
 HEAP32[(HEAP32[i9 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 return;
}

function __ZN17Physics2DSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i6 = i4;
 i9 = i4 + 8 | 0;
 i7 = i2;
 i8 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i9;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 156328 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i8;
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i6);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 172 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN17AudioCustomFilter7CleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 16 | 0;
 i4 = i2 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 if (i2) {
  __ZN11AudioSource4StopEb(i2, 1);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i1 = __ZN4FMOD3DSP7releaseEv(i1) | 0;
 if (i1 | 0) {
  i2 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i5 >> 2] = gb + 855251;
  HEAP32[i5 + 4 >> 2] = 107;
  HEAP32[i5 + 8 >> 2] = gb + 855327;
  HEAP32[i5 + 12 >> 2] = i2;
  __Z6FormatPKcz(i3, gb + 883334 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __Z34ReflectionProbe_CUSTOM_RenderProbeP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i4 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  i6 = HEAP32[i6 + 48 >> 2] | 0;
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  i6 = __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb(i5, i6, i1, 0) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 i2 = HEAP16[i4 >> 1] | 0;
 if ((i1 & 65535) < (i2 & 65535)) {
  HEAP16[i4 >> 1] = i1;
  HEAP16[i3 >> 1] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP16[i4 >> 1] | 0;
  i3 = HEAP16[i5 >> 1] | 0;
  if ((i2 & 65535) < (i3 & 65535)) {
   HEAP16[i5 >> 1] = i2;
   HEAP16[i4 >> 1] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP16[i5 >> 1] | 0;
   i3 = HEAP16[i8 >> 1] | 0;
   if ((i2 & 65535) < (i3 & 65535)) {
    HEAP16[i8 >> 1] = i2;
    HEAP16[i5 >> 1] = i3;
    i1 = HEAP16[i8 >> 1] | 0;
    i2 = HEAP16[i7 >> 1] | 0;
    if ((i1 & 65535) < (i2 & 65535)) {
     HEAP16[i7 >> 1] = i1;
     HEAP16[i8 >> 1] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < i2 << 24 >> 24) {
  HEAP8[i4 >> 0] = i1;
  HEAP8[i3 >> 0] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i5 >> 0] = i2;
   HEAP8[i4 >> 0] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP8[i5 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i5 >> 0] = i3;
    i1 = HEAP8[i8 >> 0] | 0;
    i2 = HEAP8[i7 >> 0] | 0;
    if (i1 << 24 >> 24 < i2 << 24 >> 24) {
     HEAP8[i7 >> 0] = i1;
     HEAP8[i8 >> 0] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < i2 << 24 >> 24) {
  HEAP8[i4 >> 0] = i1;
  HEAP8[i3 >> 0] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i5 >> 0] = i2;
   HEAP8[i4 >> 0] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP8[i5 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i5 >> 0] = i3;
    i1 = HEAP8[i8 >> 0] | 0;
    i2 = HEAP8[i7 >> 0] | 0;
    if (i1 << 24 >> 24 < i2 << 24 >> 24) {
     HEAP8[i7 >> 0] = i1;
     HEAP8[i8 >> 0] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNK5Umbra6KDTree4rankEi(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 1 | 0;
 if (i4 >>> 0 > 65535) i1 = HEAP32[i2 + ((i4 >> 16) + -1 << 2) >> 2] | 0; else i1 = 0;
 if (i4 & 65280) {
  i7 = (i4 >> 8) - (i4 >> 16) + -1 | 0;
  i6 = i7 << 4 & 16;
  i7 = HEAP32[i2 + ((i3 >>> 16) + (i7 >> 1) << 2) >> 2] | 0;
  i1 = (i7 >>> (i6 | 8) << 8 & 65280 | i7 >>> i6 & 255) + i1 | 0;
 }
 if (i4 & 240) {
  i7 = (i4 >> 4) - (i4 >> 8) + -1 | 0;
  i6 = i3 >>> 16;
  i1 = ((HEAP32[i2 + (i6 + (i7 >> 2) + ((1 - i6 + (i3 >>> 8) | 0) >>> 1) << 2) >> 2] | 0) >>> (i7 << 3 & 24) & 255) + i1 | 0;
 }
 i6 = i4 & 15;
 i7 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + (i4 << 1 >> 5 << 2) >> 2] & (1 << (i6 << 1)) + -1;
 i7 = i7 & 1431655765 & i7 >>> 1;
 i7 = (i7 >>> 2 & 286331153) + (i7 & 286331153) | 0;
 i7 = (i7 >>> 4) + i7 & 117901063;
 i7 = (i7 >>> 8) + i7 | 0;
 return i1 + i6 - ((i7 >>> 16) + i7 & 31) | 0;
}

function __ZN19VREyeTextureManager16SetRenderSurfaceEP17RenderSurfaceBasePiS2_Pb(i4, i5, i6, i7, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i9 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i3 = (i1 - i2 | 0) / 20 | 0;
 i2 = 0;
 while (1) {
  i1 = HEAP32[i9 + (i2 * 20 | 0) >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i1 + 48 >> 2] | 0)) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i9 + (i2 * 20 | 0) + 4 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i5 >> 2] | 0) == (HEAP32[i1 + 48 >> 2] | 0)) {
   i1 = 1;
   break;
  }
  i1 = i2 + 1 | 0;
  if (i1 >>> 0 < i3 >>> 0) i2 = i1; else {
   i1 = 0;
   i10 = 7;
   break;
  }
 }
 if ((i10 | 0) == 7) return i1 | 0;
 HEAP32[i9 + (i2 * 20 | 0) + 8 + (i1 << 2) >> 2] = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 HEAP8[i8 >> 0] = HEAP8[i4 + 52 >> 0] | 0;
 i10 = 1;
 return i10 | 0;
}

function __ZN12LightmapData8TransferI14SafeBinaryReadEEvRT_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 402465 | 0, gb + 1034905 | 0, i3, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
   i1 = HEAP32[i3 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 i2 = i2 + 4 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 402476 | 0, gb + 1034905 | 0, i3, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_(i2, i4); else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager20ArchivePendingEventsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 556 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2];
 if (HEAP32[i4 >> 2] | 0) return;
 i1 = i2 + 552 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 4) return;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 40 + (i3 << 7) | 0;
 if ((HEAPU16[i2 + 40 + (i3 << 7) + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i2 + 40 + (i3 << 7) + 92 >> 0] = 0;
 HEAP8[i2 + 40 + (i3 << 7) + 91 >> 0] = 0;
 if (HEAP8[i2 + 40 + (i3 << 7) + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i4) | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i2 >> 2] | 0) != 1) if ((HEAP32[i2 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i4 | 0);
 } while (0);
 if (HEAP8[i2 + 40 + (i3 << 7) + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN9ShaderLab20SerializedSubProgram11SetKeywordsERKNSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEENS6_IS8_EEEE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = i4 + 56 | 0;
 if ((HEAP32[i4 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 i3 = i5 + 4 | 0;
 i1 = i4 + 68 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return; else i2 = 0;
 do {
  i1 = i1 + (i2 * 12 | 0) | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  i6 = __ZN8keywords6CreateEPKc(i1) | 0;
  i1 = i4 + 76 + (i6 >>> 5 << 2) | 0;
  HEAP32[i1 >> 2] = 1 << (i6 & 31) | HEAP32[i1 >> 2];
  i2 = i2 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 } while (i2 >>> 0 < (((HEAP32[i3 >> 2] | 0) - i1 | 0) / 12 | 0) >>> 0);
 return;
}

function __ZN5physx19NpArticulationJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP32[i3 >> 2] = gb + 91416 + 8;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 251658240;
 i4 = i3 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 204;
 i1 = i3 + 196 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, -2147483648, i2 | 0) | 0;
 i1 = i3 + 200 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, -2147483648, i2 | 0) | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0) | 0) >>> 0 >= 50528768) return i3 | 0;
 __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE(i4, 0);
 return i3 | 0;
}

function __ZN19SkinnedMeshRenderer19SetBlendShapeWeightEjf(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i5 = i7 + 8 | 0;
 i6 = HEAP32[i2 + 412 >> 2] | 0;
 if (i6 >>> 0 <= i3 >>> 0) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i6;
  __Z6FormatPKcz(i5, gb + 430294 | 0, i1);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 429036 | 0, 1494, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 428 >> 2] | 0) >>> 0 <= i3 >>> 0) {
  HEAPF32[i5 >> 2] = Math_fround(0.0);
  __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy(i1, i6, i5, 1);
 }
 HEAPF32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = f4;
 STACKTOP = i7;
 return;
}

function __ZN15GUIEventManager10QueueEventERK10InputEvent(i1, i9) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 switch (HEAP32[i9 >> 2] | 0) {
 case 16:
 case 11:
  return;
 default:
  {}
 }
 i7 = i1 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = i1 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i11 = i3 - i2 >> 2;
 i5 = i1 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i10 = i1 + 20 | 0;
 i4 = HEAP32[i10 >> 2] | 0;
 if ((((i11 | 0) == 0 ? 0 : (i11 * 78 | 0) + -1 | 0) | 0) == (i4 + i6 | 0)) {
  __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE19__add_back_capacityEv(i1);
  i4 = HEAP32[i10 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } else i1 = i6;
 i1 = i4 + i1 | 0;
 if ((i3 | 0) == (i2 | 0)) i1 = 0; else i1 = (HEAP32[i2 + (((i1 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i1 >>> 0) % 78 | 0) * 52 | 0) | 0;
 __ZN10InputEventC2ERKS_(i1, i9);
 HEAP32[i10 >> 2] = (HEAP32[i10 >> 2] | 0) + 1;
 return;
}

function __ZL35PrepareRenderNodesQueueToMainThreadR35RenderNodeQueuePrepareThreadContext(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i1 + 12 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = i1 + 32 | 0;
 i7 = i1 + 48 | 0;
 i3 = (HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
 i3 = HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16;
 i4 = i1 + 36 | 0;
 if (i5 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) return;
 while (1) {
  __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext(i1);
  i5 = (HEAP32[i2 >> 2] | 0) + 1 | 0;
  HEAP32[i2 >> 2] = i5;
  if (i5 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) {
   i1 = 4;
   break;
  }
  i5 = (HEAP32[(HEAP32[i7 >> 2] | 0) + ((HEAP32[(HEAP32[i6 >> 2] | 0) + (i5 << 2) >> 2] | 0) * 24 | 0) >> 2] | 0) + 236 | 0;
  if (((HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16) ^ i3) & 63 | 0) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return;
}

function __Z56ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, i1 + 264 + 272 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z27Terrain_CUSTOM_SetNeighborsP12Il2CppObjectS0_S0_S0_S0_(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!i2) i3 = 0; else i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i5) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i5) | 0;
 if (!i6) {
  i6 = 0;
  __ZN7Terrain12SetNeighborsEPS_S0_S0_S0_(i7, i3, i2, i1, i6);
  return;
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 __ZN7Terrain12SetNeighborsEPS_S0_S0_S0_(i7, i3, i2, i1, i6);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i3 = i9 + 160 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f4 - Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i8 = i9 + 164 | 0;
 f12 = Math_fround(f7 - Math_fround(HEAPF32[i8 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = i9 + 168 | 0;
 f11 = Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2]));
 f2 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i1 = i9 + 172 | 0;
 f10 = Math_fround(f2 - Math_fround(HEAPF32[i1 >> 2]));
 if (Math_fround(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)) + Math_fround(f11 * f11)) + Math_fround(f10 * f10)) == Math_fround(0.0)) return;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i8 >> 2] = f7;
 HEAPF32[i6 >> 2] = f5;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i9 + 536 >> 2] = 0;
 return;
}

function __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc(i3, i7, i1, i2, i4, i5, i6) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 8 | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = i1 + 400;
 __ZNKSt3__210__time_put8__do_putEPwRS1_PK2tmcc(i3 + 8 | 0, i1, i2, i4, i5, i6);
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = i1;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  if ((i5 | 0) == (i6 | 0)) break;
  i2 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i3 = i1 + 24 | 0;
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0) | 0; else {
    HEAP32[i3 >> 2] = i4 + 4;
    HEAP32[i4 >> 2] = i2;
   }
   i1 = (i2 | 0) == -1 ? 0 : i1;
  }
  i5 = i5 + 4 | 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil30getFaceIndexAtShapePointNoTestEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 4 | 0;
 i7 = i5;
 i4 = i1 + 12 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i1 = __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_(i6, f2, Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * f3), i8, i7) | 0;
 f2 = Math_fround(HEAPF32[i8 >> 2]);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 if ((HEAP8[(HEAP32[i6 + 36 >> 2] | 0) + (i1 << 2) + 2 >> 0] | 0) < 0) i1 = f3 > f2 | i1 << 1; else i1 = Math_fround(f2 + f3) > Math_fround(1.0) | i1 << 1;
 i8 = i1 >>> 1;
 i7 = HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0;
 STACKTOP = i5;
 return ((HEAP8[((i1 & 1 | 0) == 0 ? i7 + (i8 << 2) + 2 | 0 : i7 + (i8 << 2) + 3 | 0) >> 0] & 127) != 127 ? i1 : -1) | 0;
}

function __ZN9b2ContactC2EP9b2FixtureiS1_i(i4, i5, i1, i6, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, f7 = f0, f8 = f0;
 HEAP32[i4 >> 2] = gb + 158572 + 8;
 HEAP32[i4 + 4 >> 2] = 4;
 HEAP32[i4 + 48 >> 2] = i5;
 HEAP32[i4 + 52 >> 2] = i6;
 HEAP32[i4 + 56 >> 2] = i1;
 HEAP32[i4 + 60 >> 2] = i2;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAP32[i4 + 136 >> 2] = 0;
 i1 = i5 + 36 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i6 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i6 + 40 >> 2]);
 HEAPF32[i4 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i4 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 128 >> 2] = HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i4 + 132 >> 2] = HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 8 >> 2];
 return;
}

function __ZN9Animation20GetClipLegacyWarningEP13AnimationClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 8 | 0;
 if (!i2) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i6 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = i6;
 HEAP32[i4 + 4 >> 2] = i1;
 __Z6FormatPKcz(i3, gb + 896682 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 896407 | 0, 2019, 512, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN8Animator20GetAnimatorStateNameEib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i2 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i5) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
  return;
 }
 i6 = i2 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i5) | 0) if (!(HEAP32[i6 >> 2] | 0)) {
  i5 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i5 | 0, i2 + 584 | 0);
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
  return;
 } else {
  __ZN26AnimatorControllerPlayable20GetAnimatorStateNameEib(i1, HEAP32[HEAP32[i2 + 584 >> 2] >> 2] | 0, i3, i4);
  return;
 }
}

function __ZN6Avatar8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 HEAP32[i4 + 4 >> 2] = i1 + 32;
 __Z21TransferBlobSerializeIN7mecanim9animation14AvatarConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_(i1 + 56 | 0, gb + 905764 | 0, i1 + 72 | 0, gb + 905773 | 0, i4);
 i3 = i1 + 60 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 905786 | 0, HEAP32[gb + 37052 >> 2] | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags(i4, i3, 0); else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler11onStopEventERKNS_16PxProfileEventIdEjyhhy(i5, i7, i6, i1, i2, i3, i4, i8, i9) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0;
 if ((i6 | 0) == 99999789) i1 = i5 + 4 | 0; else {
  i3 = HEAP32[i5 + 24 >> 2] | 0;
  i2 = HEAP32[i5 + 28 >> 2] | 0;
  do {
   i2 = i2 + -1 | 0;
   i1 = i3 + (i2 * 20 | 0) | 0;
  } while ((HEAP32[i1 >> 2] | 0) != (i6 | 0));
 }
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i5) return;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP16[i7 >> 1] | 0;
 i3 = 0;
 while (1) {
  if ((HEAP16[i4 + (i3 << 5) >> 1] | 0) == i2 << 16 >> 16) {
   i1 = i4 + (i3 << 5) + 24 | 0;
   i7 = i1;
   if ((HEAP32[i7 >> 2] | 0) == -1 ? (HEAP32[i7 + 4 >> 2] | 0) == -1 : 0) break;
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i5 >>> 0) {
   i10 = 11;
   break;
  }
 }
 if ((i10 | 0) == 11) return;
 i10 = i1;
 HEAP32[i10 >> 2] = i8;
 HEAP32[i10 + 4 >> 2] = i9;
 return;
}

function __ZN5audio5mixer12SetSuspendedERNS0_16AudioMixerMemoryEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8;
 HEAP32[i3 >> 2] = 0;
 __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i3) | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 HEAP8[i4 >> 0] = 0;
 __ZN4FMOD3DSP9getActiveEPb(i7, i4) | 0;
 if (!((HEAP8[i4 >> 0] | 0) == 0 | i2)) {
  HEAP32[i5 >> 2] = 0;
  __ZN4FMOD3DSP15getSystemObjectEPPNS_6SystemE(HEAP32[i3 >> 2] | 0, i5) | 0;
  __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(HEAP32[i5 >> 2] | 0, i6, 0, 0, 0, 0, 0) | 0;
  HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 32 >> 2] = HEAP32[i6 >> 2];
 }
 __ZN4FMOD3DSP9setActiveEb(HEAP32[i3 >> 2] | 0, i2 ^ 1) | 0;
 STACKTOP = i8;
 return;
}

function __ZN5Umbra9Matrix2x2mLERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, f10 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 i8 = i1 + 8 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f10 = Math_fround(f5 * Math_fround(HEAPF32[i2 >> 2]));
 i9 = i2 + 4 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f10 + Math_fround(f6 * Math_fround(HEAPF32[i9 >> 2])));
 i7 = i2 + 8 | 0;
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i7 >> 2]));
 i4 = i2 + 12 | 0;
 HEAPF32[i8 >> 2] = Math_fround(f5 + Math_fround(f6 * Math_fround(HEAPF32[i4 >> 2])));
 i8 = i1 + 4 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 i3 = i1 + 12 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f10 + Math_fround(f5 * Math_fround(HEAPF32[i9 >> 2])));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i7 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i4 >> 2])));
 return i1 | 0;
}

function __ZN4crnd10dxt5_block16get_block_valuesEPjjj(i9, i1, i2) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 if (i1 >>> 0 > i2 >>> 0) {
  i3 = 8;
  i4 = (((i2 * 6 | 0) + i1 | 0) >>> 0) / 7 | 0;
  i5 = (((i2 * 5 | 0) + (i1 << 1) | 0) >>> 0) / 7 | 0;
  i6 = (((i2 << 2) + (i1 * 3 | 0) | 0) >>> 0) / 7 | 0;
  i7 = (((i2 * 3 | 0) + (i1 << 2) | 0) >>> 0) / 7 | 0;
  i8 = (((i2 << 1) + (i1 * 5 | 0) | 0) >>> 0) / 7 | 0;
  i1 = (((i1 * 6 | 0) + i2 | 0) >>> 0) / 7 | 0;
 } else {
  i3 = 6;
  i4 = 255;
  i5 = 0;
  i6 = (((i2 << 2) + i1 | 0) >>> 0) / 5 | 0;
  i7 = (((i2 * 3 | 0) + (i1 << 1) | 0) >>> 0) / 5 | 0;
  i8 = (((i2 << 1) + (i1 * 3 | 0) | 0) >>> 0) / 5 | 0;
  i1 = (((i1 << 2) + i2 | 0) >>> 0) / 5 | 0;
 }
 HEAP32[i9 + 8 >> 2] = i1;
 HEAP32[i9 + 12 >> 2] = i8;
 HEAP32[i9 + 16 >> 2] = i7;
 HEAP32[i9 + 20 >> 2] = i6;
 HEAP32[i9 + 24 >> 2] = i5;
 HEAP32[i9 + 28 >> 2] = i4;
 return i3 | 0;
}

function __ZN19SpriteMeshGenerator4mask6dilateEiR14dynamic_bitset(i6, i7, i3) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i8 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = i6 + 4 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 i5 = Math_imul(i2, i1) | 0;
 i5 = __Znaj(i5 >>> 0 > 1073741823 ? -1 : i5 << 2) | 0;
 if (!(__ZN19SpriteMeshGenerator4mask5mdistEPjR14dynamic_bitset(i6, i5, i3) | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((Math_imul(i1, i2) | 0) > 0) {
  i4 = i3 + 8 | 0;
  i3 = 0;
  do {
   if ((HEAP32[i5 + (i3 << 2) >> 2] | 0) >>> 0 <= i7 >>> 0) {
    i1 = (HEAP32[i4 >> 2] | 0) + (i3 >>> 5 << 2) | 0;
    HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i3 & 31);
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (Math_imul(i1, i2) | 0));
 }
 __ZdaPv(i5);
 i8 = 1;
 return i8 | 0;
}

function __ZN19ScriptingInvocationC2EP11Il2CppClassPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i1 + 96 | 0;
 i7 = i5 + 48 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i7 = i1 + 200 | 0;
 i5 = i1 + 224 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i7 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i7 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i4, i2, i3, -1);
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP8[i7 + 4 >> 0] = HEAP8[i4 + 4 >> 0] | 0;
 STACKTOP = i6;
 return;
}

function __ZN13BatchRendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 140 | 0;
 if ((HEAP32[i3 + 156 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 144 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 35824 + 8;
 i2 = i3 + 120 | 0;
 if ((HEAP32[i3 + 136 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i3 + 96 >> 2] | 0) > -1) {
  i2 = i3 + 80 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 60 | 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 if ((HEAP32[i3 + 56 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10SampleClip13LoadBaseSoundEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 i5 = i3 + 72 | 0;
 i1 = HEAP8[i5 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 76 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i2 = __ZNK10SampleClip17CalculateFMODModeEv(i3) | 0;
 if (!(HEAP8[i3 + 44 >> 0] | 0)) i1 = 0; else i1 = (HEAP32[i3 + 52 >> 2] | 0) == 1 ? 2 : 0;
 i7 = ((__ZNK10SampleClip17CalculateFMODModeEv(i3) | 0) & 128 | 0) == 0;
 i8 = __Z15GetSoundManagerv() | 0;
 HEAP32[i4 >> 2] = __ZN12SoundManager9GetHandleERK16StreamedResourceijjP10SampleClipb(i8, i5, HEAP32[i3 + 60 >> 2] | 0, i2, i7 ? i1 : 2, i3, 0) | 0;
 __ZN11SoundHandleaSERKS_(i3 + 56 | 0, i4);
 __ZN11SoundHandleD2Ev(i4);
 STACKTOP = i6;
 return;
}

function _sha256_update(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i7;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4 & 63;
 i8 = _i64Add(i4 | 0, HEAP32[i8 + 4 >> 2] | 0, i2 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i4;
 do if (!i3) i5 = 5; else {
  i4 = 64 - i3 | 0;
  i3 = i7 + 40 + i3 | 0;
  if (i4 >>> 0 > i2 >>> 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   break;
  } else {
   _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
   _processblock_41(i7, i7 + 40 | 0);
   i2 = i2 - i4 | 0;
   i1 = i1 + i4 | 0;
   i5 = 5;
   break;
  }
 } while (0);
 if ((i5 | 0) == 5) {
  if (i2 >>> 0 > 63) {
   i4 = i2 + -64 | 0;
   i5 = i4 & -64;
   i6 = i5 + 64 | 0;
   i3 = i1;
   while (1) {
    _processblock_41(i7, i3);
    i2 = i2 + -64 | 0;
    if (i2 >>> 0 <= 63) break; else i3 = i3 + 64 | 0;
   }
   i2 = i4 - i5 | 0;
   i1 = i1 + i6 | 0;
  }
  _memcpy(i7 + 40 | 0, i1 | 0, i2 | 0) | 0;
 }
 return;
}

function __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i6 >> 2] = gb + 28204 + 8;
 i4 = i6 + 8 | 0;
 i2 = HEAP32[i2 >> 2] & 2047;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2 | -2097152;
 i2 = __Z16GetMemoryManagerv() | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i1 = i7 & 2047;
 if (!(i7 & 2048)) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = 0;
  i1 = i6;
 } else {
  __Z14CreateMemLabel18MemLabelIdentifierPv(i3, i1, i6);
  i1 = i6;
 }
 i7 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i2, i3) | 0;
 i7 = (mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 80 >> 2] | 0, i7 | 0, i1 | 0) | 0) != 0 & 1;
 HEAP32[i4 >> 2] = i7 << 11 | HEAP32[i4 >> 2] & -2049;
 HEAP32[i6 + 24 >> 2] = -1;
 STACKTOP = i5;
 return;
}

function __ZN5physx16PxsIslandManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 1 | 0;
 i1 = HEAP32[i3 + 628 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
 HEAP32[i3 + 420 >> 2] = gb + 101628 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 + 424 >> 2] | 0);
 HEAP32[i3 + 372 >> 2] = gb + 101648 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 + 376 >> 2] | 0);
 i1 = HEAP32[i3 + 332 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 i1 = HEAP32[i3 + 308 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 HEAP32[i3 + 280 >> 2] = gb + 101668 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 + 284 >> 2] | 0);
 HEAP32[i3 + 12 >> 2] = gb + 101688 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 + 16 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN5Cache10CleanCacheEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (HEAP32[i1 + 76 >> 2] | 0) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 __Z17GetCachingManagerv() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i1 + 4 | 0);
 i4 = __ZN14CachingManager10CleanCacheENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(0, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i4) {
  i4 = 0;
  STACKTOP = i3;
  return i4 | 0;
 }
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i1 + 56 | 0;
 i4 = i1 + 60 | 0;
 __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 i4 = 1;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN4FMOD6System12createReverbEPPNS_6ReverbE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i1 = __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7GetFreeEi(i2 + 268 | 0, -1) | 0;
  if (!i1) {
   HEAP32[i5 >> 2] = 36;
   HEAP32[i5 + 4 >> 2] = gb + 857621;
   _printf(gb + 853184 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 36;
   HEAP32[i6 + 4 >> 2] = gb + 857621;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 36;
   STACKTOP = i7;
   return i6 | 0;
  } else {
   HEAP32[i4 >> 2] = HEAP32[i1 + 20 >> 2];
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857621;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2UI30GetETC1SupportedCanvasMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 1468148 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z15GetScriptMapperv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1012274 | 0, 14);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) i1 = __ZN6Shader10GetDefaultEv() | 0;
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[gb + 1468148 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, gb + 1012289 | 0);
 i2 = HEAP32[gb + 1468148 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN19SkinnedMeshRenderer25CalculateSkinningMatricesERK10Matrix4x4fPS0_j(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1161604 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161604 | 0, i1);
  i2 = gb + 1161604 | 0;
 } else i2 = 0;
 if (__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i3, i5, i6) | 0) {
  i1 = HEAP32[(HEAP32[i3 + 356 >> 2] | 0) + 32 >> 2] | 0;
  __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j(i4, i5, (HEAP32[i1 + 156 >> 2] | 0) == 0 ? 0 : HEAP32[i1 + 144 >> 2] | 0, i5, i6);
  i1 = 1;
 } else i1 = 0;
 if (!i2) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN10UnityScene7SetNameERK8UnityStr(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 28 | 0;
 if ((i7 | 0) == (i1 | 0)) return;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 i8 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 i6 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 i3 = i7 + 11 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i4 = (HEAP32[i5 + 36 >> 2] & 2147483647) + -1 | 0; else i4 = 10;
 if (i6 >>> 0 > i4 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 32 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i7, i4, i6 - i4 | 0, i1, 0, i1, i6, i8);
  return;
 }
 if (i2) i1 = HEAP32[i7 >> 2] | 0; else i1 = i7;
 if (i6 | 0) _memmove(i1 | 0, i8 | 0, i6 | 0) | 0;
 HEAP8[i1 + i6 >> 0] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[i5 + 32 >> 2] = i6;
  return;
 } else {
  HEAP8[i3 >> 0] = i6;
  return;
 }
}

function __ZN10AudioMixer17MainThreadCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 72 | 0;
 if (i2 | 0) {
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i2, i5, HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i4 + 32 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE(i1, i4 + 32 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer(__Z21GetManagerFromContexti(3) | 0, i4);
 i1 = i4 + 80 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i5 = i4 + 84 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __Z14FMODMemoryFreePvjPKc(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 switch ((i4 & 65535) << 16 >> 16) {
 case 2:
 case 1:
  {
   i6 = gb + 63368 | 0;
   i5 = HEAP32[i6 + 4 >> 2] | 0;
   i4 = i1;
   HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i4 + 4 >> 2] = i5;
   break;
  }
 case 4:
  {
   i4 = gb + 63376 | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i1;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   break;
  }
 case 8:
  {
   i4 = gb + 63384 | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i1;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
   break;
  }
 default:
  {
   i4 = gb + 63360 | 0;
   i5 = HEAP32[i4 + 4 >> 2] | 0;
   i6 = i1;
   HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i6 + 4 >> 2] = i5;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
 STACKTOP = i2;
 return;
}

function ___ldexp_cexp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, i9 = 0, i10 = 0;
 d8 = +HEAPF64[i2 + 8 >> 3];
 d7 = +Math_exp(+(+HEAPF64[i2 >> 3] + -1246.9717778273416));
 HEAPF64[tempDoublePtr >> 3] = d7;
 i10 = HEAP32[tempDoublePtr >> 2] | 0;
 i9 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i10 | 0, i9 | 0, 52) | 0;
 getTempRet0() | 0;
 HEAP32[tempDoublePtr >> 2] = i10;
 HEAP32[tempDoublePtr + 4 >> 2] = i9 & 1048575 | 2145386496;
 d7 = +HEAPF64[tempDoublePtr >> 3];
 i2 = i3 + -247 + i2 | 0;
 i3 = (i2 | 0) / 2 | 0;
 HEAP32[tempDoublePtr >> 2] = 0;
 HEAP32[tempDoublePtr + 4 >> 2] = (i3 << 20) + 1072693248;
 d6 = +HEAPF64[tempDoublePtr >> 3];
 HEAP32[tempDoublePtr >> 2] = 0;
 HEAP32[tempDoublePtr + 4 >> 2] = (i2 - i3 << 20) + 1072693248;
 d5 = +HEAPF64[tempDoublePtr >> 3];
 d4 = +Math_sin(+d8) * d7 * d6 * d5;
 HEAPF64[i1 >> 3] = +Math_cos(+d8) * d7 * d6 * d5;
 HEAPF64[i1 + 8 >> 3] = d4;
 return;
}

function __ZN27AnimationLayerMixerPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 72 | 0;
 if (!(HEAP8[i1 + 120 >> 0] | 0)) {
  HEAP8[i3 >> 0] = 1;
  return;
 }
 if (HEAP8[i3 >> 0] | 0) {
  HEAP8[i3 >> 0] = 1;
  return;
 }
 i6 = HEAP16[i2 + 34 >> 1] | 0;
 i4 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0;
 i5 = i1 + 80 | 0;
 __ZN27AnimationLayerMixerPlayable6Memory20CreateNodeStateArrayEiRKN7mecanim18ValueArrayConstantEbbbRNS1_6memory9AllocatorE(i5, i4, HEAP32[i2 >> 2] | 0, (HEAP8[i2 + 33 >> 0] | 0) != 0, (i6 & 255) << 24 >> 24 != 0, (i6 & 65535) > 255, i1 + 60 | 0);
 if (!i4) {
  HEAP8[i3 >> 0] = 1;
  return;
 }
 i2 = i2 + 4 | 0;
 i1 = 0;
 do {
  __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_(HEAP32[i2 >> 2] | 0, HEAP32[HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZN19CharacterController9SetCenterERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, d8 = 0.0, d9 = 0.0, d10 = 0.0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i6 + 24 | 0;
 i5 = i2 + 96 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i5);
 d10 = +Math_fround(HEAPF32[i4 >> 2]);
 d9 = +Math_fround(HEAPF32[i4 + 4 >> 2]);
 d8 = +Math_fround(HEAPF32[i4 + 8 >> 2]);
 HEAPF64[i3 >> 3] = d10;
 HEAPF64[i3 + 8 >> 3] = d9;
 HEAPF64[i3 + 16 >> 3] = d8;
 mftCall_iii(i7 | 0, i1 | 0, i3 | 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN17Physics2DSettings21UpdateBox2DPropertiesEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 HEAP32[gb + 151644 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[gb + 151876 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[gb + 151880 >> 2] = HEAP32[i1 + 52 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 56 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151884 >> 2] = f2;
 f2 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 HEAPF32[gb + 151888 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151892 >> 2] = f2;
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151896 >> 2] = f2;
 f2 = Math_fround(f2 * f2);
 HEAPF32[gb + 151900 >> 2] = f2;
 HEAP32[gb + 151904 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[gb + 151908 >> 2] = HEAP32[i1 + 76 >> 2];
 HEAP32[gb + 151912 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[gb + 151916 >> 2] = HEAP32[i1 + 84 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.0174532924));
 HEAPF32[gb + 151920 >> 2] = f2;
 return;
}

function __ZN16StreamedResourceeqERKS_(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP8[i6 + 11 >> 0] | 0;
 i2 = i5 << 24 >> 24 < 0;
 if (i2) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i5 & 255;
 i4 = HEAP8[i7 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 if ((i1 | 0) != ((i3 ? HEAP32[i7 + 4 >> 2] | 0 : i4 & 255) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = HEAP32[i7 >> 2] | 0;
 if (i2) {
  i4 = HEAP32[i6 >> 2] | 0;
  i2 = i3 ? i1 : i7;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  i4 = i6;
  i2 = i3 ? i1 : i7;
  i1 = i5 & 255;
 }
 if (_strncmp(i4, i2, i1) | 0) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = i6 + 16 | 0;
 i5 = i7 + 16 | 0;
 if (!((HEAP32[i4 >> 2] | 0) == (HEAP32[i5 >> 2] | 0) ? (HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i5 + 4 >> 2] | 0) : 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = i6 + 24 | 0;
 i7 = i7 + 24 | 0;
 i7 = (HEAP32[i6 >> 2] | 0) == (HEAP32[i7 >> 2] | 0) ? (HEAP32[i6 + 4 >> 2] | 0) == (HEAP32[i7 + 4 >> 2] | 0) : 0;
 return i7 | 0;
}

function __ZN12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = HEAP32[i2 + 64 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i3 + 16 | 0, i5 | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0);
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 >> 2] | 0) | 0;
 i5 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i4 >> 2] = gb + 149840 + 8;
 i1 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i5;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i4, 2);
 STACKTOP = i3;
 return (HEAPU8[i2 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN10MonoScript7RebuildEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 88 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   i5 = i4 + 8 | 0;
   if ((HEAP32[i4 + 24 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 12 | 0);
    HEAP32[i5 >> 2] = 0;
   }
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63728 | 0);
  } else {
   i5 = __Z19GetScriptingManagerv() | 0;
   __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i5, HEAP32[i4 + 32 >> 2] | 0);
  }
  HEAP32[i3 >> 2] = 0;
 }
 i5 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i2, HEAPU8[i1 + 140 >> 0] | 0, i1, HEAP32[i1 + 64 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache(__Z19GetScriptingManagerv() | 0, i5);
 return;
}

function __ZN10Matrix4x4f17SetFromToRotationERK8Vector3fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i5, i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 32 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i5 + 32 >> 2];
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 STACKTOP = i4;
 return i1 | 0;
}

function __Z37BillboardAsset_CUSTOM_Internal_CreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 500367 | 0, 23) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN14BillboardAssetC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 STACKTOP = i2;
 return;
}

function __Z25LoadAssetsFromAssetBundleR11AssetBundleRKNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP13dynamic_arrayIiLj4EEP12Il2CppObjectbRSI_IP6ObjectLj4EE(i2, i3, i1, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1 + 8 | 0;
 i8 = i1;
 i10 = i3;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i8;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb(i2, i7, i4, i6, i5);
 STACKTOP = i1;
 return;
}

function _UNITY_FT_Attach_File(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 32 | 0;
 i6 = i8;
 if (!i1) {
  i7 = 6;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = i6 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i6 >> 2] = 4;
 HEAP32[i6 + 12 >> 2] = i1;
 if (!i5) i1 = 35; else {
  i2 = HEAP32[i5 + 96 >> 2] | 0;
  if (!i2) i1 = 34; else {
   i1 = _UNITY_FT_Stream_New(HEAP32[i2 + 4 >> 2] | 0, i6, i3) | 0;
   if (!i1) {
    i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 80 >> 2] | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i1) i1 = 7; else i1 = mftCall_iii(i1 | 0, i5 | 0, i4 | 0) | 0;
    if (!(HEAP32[i7 >> 2] | 0)) i3 = 0; else i3 = (HEAP32[i6 >> 2] | 0) >>> 1 & 1;
    if (i4) {
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     _UNITY_FT_Stream_Close(i4);
     if (!i3) _UNITY_ft_mem_free(i2, i4);
    }
   }
  }
 }
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorIPN5physx15PxVehicleWheelsENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i5 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i5 + 4 >> 2] | 0);
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i1 = i5 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -36 - i4 | 0) >>> 0) / 36 | 0) * 36 | 0);
  __ZdlPv(i3);
 }
 __ZdlPv(i5);
 return;
}

function __ZNSt3__227__num_get_unsigned_integralItEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 do if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i1 = 0;
 } else {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
   break;
  }
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoull_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  do if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 65535 | (i3 | 0) == 34) {
   HEAP32[i5 >> 2] = 4;
   i1 = -1;
   break;
  } else {
   i1 = i1 & 65535;
   break;
  } else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
  } while (0);
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore19getVirtualParticlesEPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 24 | 0;
 i5 = i3 + 16 | 0;
 i9 = i3 + 8 | 0;
 i8 = i3;
 i2 = i2 + 28 | 0;
 i10 = HEAP32[i2 >> 2] | 0;
 i10 = i1 + ((mftCall_ii(HEAP32[(HEAP32[i10 >> 2] | 0) + 236 >> 2] | 0, i10 | 0) | 0) << 4) | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 44 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i10;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 mftCall_viiii(i7 | 0, i6 | 0, i2 | 0, i5 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN4FMOD8ChannelID2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i4 + 164 >> 2] | 0;
 if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
 i1 = i4 + 52 | 0;
 i2 = i4 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i5 = i4 + 56 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 40 | 0;
 i2 = i4 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i6 = i4 + 44 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 24 | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i6 = i4 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN21ProceduralTextureData12CopyFromDataERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i3 = i2 + 40 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i1 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i2 + 48 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = HEAP16[i2 + 28 >> 1] | 0;
 HEAP8[i1 + 28 >> 0] = i3;
 HEAP8[i1 + 29 >> 0] = (i3 & 65535) >>> 8;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP8[i1 + 60 >> 0] = HEAP8[i2 + 60 >> 0] | 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 64 >> 2];
 return;
}

function __ZN13PhysicsModule31GetColliderComponentsInChildrenERK10GameObjectbbR13dynamic_arrayIPN5Unity9ComponentELj4EE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE(i2, i3, gb + 32548 | 0, i5);
 if (i4) return;
 i3 = i5 + 12 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = HEAP32[i5 >> 2] | 0;
 L7 : while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  while (1) {
   if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) break;
   i2 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
   HEAP32[i3 >> 2] = i2;
   i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   HEAP32[i1 >> 2] = i2;
   if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0)) {
    i1 = 8;
    break L7;
   }
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == ((HEAP32[i5 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i5, i3, i6, i7) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0;
 i8 = i5 + 4 | 0;
 if ((i8 | 0) == (i3 | 0)) {
  i2 = i5 + 1048 | 0;
  i1 = i5 + 1056 | 0;
 } else {
  i2 = i5 + 1044 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i8 | 0);
  _strncpy(i8, i3, 1040) | 0;
  HEAP8[i5 + 1043 >> 0] = 0;
  i4 = HEAP32[i3 + 1040 >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  i2 = i5 + 1048 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 1044 >> 2];
  HEAP32[i5 + 1052 >> 2] = 0;
  i1 = i5 + 1056 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 + 1060 >> 2] = 0;
  if (i4) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 60 >> 2] | 0, i4 | 0, i8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP8[i5 + 1064 >> 0] = 1;
 i5 = HEAP32[i2 >> 2] | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i8 | 0, i6 | 0, i7 | 0) | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 11 >> 0] = 8;
 i3 = i2;
 i5 = i3;
 i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24;
 i3 = i3 + 4 | 0;
 i3 = HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24;
 i2 = i1;
 i4 = i2;
 HEAP8[i4 >> 0] = i5;
 HEAP8[i4 + 1 >> 0] = i5 >> 8;
 HEAP8[i4 + 2 >> 0] = i5 >> 16;
 HEAP8[i4 + 3 >> 0] = i5 >> 24;
 i2 = i2 + 4 | 0;
 HEAP8[i2 >> 0] = i3;
 HEAP8[i2 + 1 >> 0] = i3 >> 8;
 HEAP8[i2 + 2 >> 0] = i3 >> 16;
 HEAP8[i2 + 3 >> 0] = i3 >> 24;
 HEAP8[i1 + 8 >> 0] = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z37TerrainData_CUSTOM_GetSupportedLayersP12Il2CppObjectiiii(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZNK14DetailDatabase18GetSupportedLayersEiiiiPi(i1 + 128 | 0, i4, i5, i6, i7, 0) | 0;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0, 4, i1) | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZNK14DetailDatabase18GetSupportedLayersEiiiiPi(i2 + 128 | 0, i4, i5, i6, i7, __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0) | 0;
  return i1 | 0;
 }
 return 0;
}

function __Z36GameObject_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i1, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z29Component_CUSTOM_GetComponentP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = __ZN9Scripting42GetScriptingWrapperOfComponentOfGameObjectER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i2, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z22CalculateMipMapCount3Diii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 >>> 0 > 65535;
 i5 = i4 ? i1 >>> 16 : i1;
 i1 = i4 ? 16 : 0;
 i4 = (i5 & 65280 | 0) == 0;
 i5 = i4 ? i5 : i5 >>> 8;
 i1 = i4 ? i1 : i1 | 8;
 i4 = (i5 & 240 | 0) == 0;
 i1 = (HEAP8[(i4 ? i5 : i5 >>> 4) + (gb + 936717) >> 0] | 0) + (i4 ? i1 : i1 | 4) | 0;
 i4 = i2 >>> 0 > 65535;
 i5 = i4 ? i2 >>> 16 : i2;
 i2 = i4 ? 16 : 0;
 i4 = (i5 & 65280 | 0) == 0;
 i5 = i4 ? i5 : i5 >>> 8;
 i2 = i4 ? i2 : i2 | 8;
 i4 = (i5 & 240 | 0) == 0;
 i2 = (HEAP8[(i4 ? i5 : i5 >>> 4) + (gb + 936717) >> 0] | 0) + (i4 ? i2 : i2 | 4) | 0;
 i2 = (i1 | 0) < (i2 | 0) ? i2 : i1;
 i1 = i3 >>> 0 > 65535;
 i4 = i1 ? i3 >>> 16 : i3;
 i3 = i1 ? 16 : 0;
 i1 = (i4 & 65280 | 0) == 0;
 i4 = i1 ? i4 : i4 >>> 8;
 i3 = i1 ? i3 : i3 | 8;
 i1 = (i4 & 240 | 0) == 0;
 i3 = (HEAP8[(i1 ? i4 : i4 >>> 4) + (gb + 936717) >> 0] | 0) + (i1 ? i3 : i3 | 4) | 0;
 return ((i2 | 0) < (i3 | 0) ? i3 : i2) + 1 | 0;
}

function __ZN9Texture3D17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (HEAP8[i1 + 106 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 if (!((HEAP32[i1 + 52 >> 2] | 0) == 0 & (HEAP8[i1 + 105 >> 0] | 0) == 0)) {
  __ZN9Texture3D13UploadTextureEv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 if (HEAP32[i1 + 8 >> 2] & 1048576 | 0) __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx8debugger19PvdNetworkOutStream14createFromFileERNS_19PxAllocatorCallbackEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i1 = _fopen(i1, gb + 777169 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 40, gb + 777172 | 0, gb + 775144 | 0, 677) | 0;
 HEAP32[i3 >> 2] = gb + 150816 + 8;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i1;
 i4 = i3 + 16 | 0;
 HEAP32[i4 >> 2] = i2;
 i2 = i3 + 20 | 0;
 HEAP32[i2 >> 2] = gb + 777196;
 HEAP32[i3 + 12 >> 2] = gb + 148172 + 8;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, HEAP32[i2 >> 2] | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i3 + 24 >> 2] = i2;
 __ZN5physx6shdfnd9MutexImplC2Ev(i2);
 HEAP8[i3 + 28 >> 0] = 1;
 i2 = i3 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i2 = i3;
 return i2 | 0;
}

function __ZN5physx13NpRigidStaticC2ERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP16[i2 + 4 >> 1] = 6;
 HEAP16[i2 + 6 >> 1] = 3;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 99544 + 8;
 __ZN5physx7NpActorC2EPKc(i2 + 12 | 0, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 99672 + 8;
 __ZN5physx14NpShapeManagerC2Ev(i2 + 20 | 0);
 HEAP32[i2 >> 2] = gb + 99820 + 8;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 i3 = i2 + 52 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE(i2 + 64 | 0, 0);
 HEAP32[i2 + 80 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 88 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 92 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 100 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 104 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP8[i2 + 108 >> 0] = 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -251658241 | 83886080;
 return;
}

function __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = HEAP32[i2 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i6 | 0)) {
  i7 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((HEAP32[i7 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) break L1;
  }
  if ((i1 | 0) > -1) {
   i7 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEPK10TextureRef(i2, i7, i3, i5);
   return;
  }
 } while (0);
 i7 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i2, i3, 0) | 0;
 __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEPK10TextureRef(i2, i7, i3, i5);
 return;
}

function __ZN13RenderTexture15DiscardContentsEbb(i3, i4, i8) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i11 + 8 | 0;
 i9 = i11 + 4 | 0;
 i10 = i11;
 i1 = i3 + 128 | 0;
 i6 = i3 + 136 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i6 >> 2] | 0)) {
  STACKTOP = i11;
  return;
 }
 i7 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i3 + 132 >> 2] | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i10 >> 2] = HEAP32[i6 >> 2];
 if (i4) {
  if (i2) {
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 336 >> 2] | 0, i7 | 0, i5 | 0);
   i1 = HEAP32[i9 >> 2] | 0;
  }
  if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 336 >> 2] | 0, i7 | 0, i9 | 0);
 }
 if (i8) if (HEAP32[i10 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 336 >> 2] | 0, i7 | 0, i10 | 0);
 STACKTOP = i11;
 return;
}

function __ZN13ComputeShader15ThreadedCleanupEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i9 + 44 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if (i7 | 0) {
  i8 = i7 + -4 | 0;
  i1 = HEAP32[i8 >> 2] | 0;
  if (i1 | 0) {
   i5 = i7 + (i1 * 976 | 0) | 0;
   do {
    i1 = HEAP32[i5 + -12 >> 2] | 0;
    i2 = i1;
    if (i1 | 0) {
     i3 = i5 + -8 | 0;
     i4 = HEAP32[i3 >> 2] | 0;
     if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -24 - i2 | 0) >>> 0) / 24 | 0) * 24 | 0);
     __ZdlPv(i1);
    }
    i5 = i5 + -976 | 0;
   } while ((i5 | 0) != (i7 | 0));
  }
  __ZdaPv(i8);
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i9 + 48 >> 2] = 0;
 i1 = i9 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i8 = i9 + 56 | 0;
  HEAP32[i8 >> 2] = 0;
  i9 = i9 + 60 | 0;
  HEAP32[i9 >> 2] = 0;
  return;
 }
 __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i8 = i9 + 56 | 0;
 HEAP32[i8 >> 2] = 0;
 i9 = i9 + 60 | 0;
 HEAP32[i9 >> 2] = 0;
 return;
}

function __ZN12ScriptMapper7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, i1, 16, gb + 1048932 | 0, 0, gb + 478561 | 0, 17) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 68492 + 8;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = i2;
 i2 = i4 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i2;
 HEAP32[i4 + 56 >> 2] = i4;
 HEAP8[i4 + 28 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12BaseRendererC2E12RendererType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = gb + 32668 + 8;
 HEAP16[i1 + 184 >> 1] = 0;
 HEAP16[i1 + 186 >> 1] = 0;
 HEAP32[i1 + 188 >> 2] = -2147450880;
 HEAP32[i1 + 192 >> 2] = 0;
 i3 = i1 + 236 | 0;
 i2 = i2 & 63 | (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16515072 | 1344;
 HEAP16[i3 >> 1] = i2;
 HEAP8[i3 + 2 >> 0] = i2 >>> 16;
 i2 = i1 + 228 | 0;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAP16[i2 >> 1] = -1;
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 200 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 216 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 220 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 232 >> 2] = -1;
 HEAP8[i1 + 240 >> 0] = 1;
 HEAP8[i1 + 241 >> 0] = 1;
 HEAP32[i1 + 244 >> 2] = 0;
 HEAP32[i1 + 248 >> 2] = 0;
 return;
}

function __ZN11BoxCollider22FetchPoseFromTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 48 | 0;
 i5 = i2 + 32 | 0;
 i3 = i2;
 i6 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i4, i6, i1 + 60 | 0);
 __ZNK9Transform11GetRotationEv(i5, i6);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i3 | 0, 1);
 STACKTOP = i2;
 return;
}

function __ZL29GeomOverlapCallback_BoxConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = HEAP32[i3 + 32 >> 2] | 0;
 i9 = (i10 | 0) == 0;
 if (i9) {
  i6 = 0;
  i7 = 0;
  i8 = 1065353216;
 } else if ((HEAP16[i10 + 12 >> 1] | 0) == 2) {
  i6 = HEAP32[i10 >> 2] | 0;
  i7 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = HEAP32[i10 + 8 >> 2] | 0;
 } else {
  i6 = 0;
  i7 = 0;
  i8 = 1065353216;
 }
 i2 = __ZN5physx2Gu18intersectBoxConvexERKNS_13PxBoxGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E(i2, i4, i1, i3 + 4 | 0, i5, 0) | 0;
 if (!(i9 | i2 ^ 1)) {
  HEAP32[i10 >> 2] = i6;
  HEAP32[i10 + 4 >> 2] = i7;
  HEAP32[i10 + 8 >> 2] = i8;
 }
 if (i9) return i2 | 0;
 i1 = i10 + 12 | 0;
 if (i2) {
  HEAP16[i1 >> 1] = 2;
  return i2 | 0;
 } else {
  HEAP16[i1 >> 1] = 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 40 | 0;
 i6 = i4 + 24 | 0;
 i5 = i4 + 8 | 0;
 i8 = i4;
 i10 = i1 + 32 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i8;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E(i7, i6, i5);
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN8LODGroup23GetLODGroupIndexAndMaskEP8RendererPjS2_(i10, i1, i11, i12) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i1) i8 = 0; else i8 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i10 + 60 >> 2] | 0;
 i1 = HEAP32[i10 + 56 >> 2] | 0;
 i9 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i9 = 0;
  HEAP32[i12 >> 2] = i9;
  i12 = i10 + 68 | 0;
  i12 = HEAP32[i12 >> 2] | 0;
  HEAP32[i11 >> 2] = i12;
  return;
 }
 i7 = (i2 - i1 | 0) / 28 | 0;
 i1 = 0;
 i6 = 0;
 do {
  i3 = HEAP32[i9 + (i6 * 28 | 0) + 20 >> 2] | 0;
  if (i3) {
   i4 = HEAP32[i9 + (i6 * 28 | 0) + 8 >> 2] | 0;
   i5 = 1 << i6;
   i2 = 0;
   do {
    i1 = ((HEAP32[i4 + (i2 << 2) >> 2] | 0) == (i8 | 0) ? i5 : 0) | i1;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i3 >>> 0);
  }
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < i7 >>> 0);
 HEAP32[i12 >> 2] = i1;
 i12 = i10 + 68 | 0;
 i12 = HEAP32[i12 >> 2] | 0;
 HEAP32[i11 >> 2] = i12;
 return;
}

function __ZN6IDList7GetNextER8GUIStatei9FocusType(i5, i6, i2, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[HEAP32[i6 + 280 >> 2] >> 2] | 0;
 if ((i3 | 0) == 12) {
  i6 = -1;
  return i6 | 0;
 }
 i4 = i1 >>> 0 > 2;
 i1 = (i1 & 1 | 0) != 0;
 i2 = __ZN6IDList25CalculateNextFromHintListER8GUIStateib(i5, i6, i2, i4 | i1) | 0;
 if ((i3 | 0) != 4) {
  i6 = i2;
  return i6 | 0;
 }
 if ((HEAP32[i6 + 60 >> 2] | 0) != 1 | (i4 | i1) ^ 1) {
  i6 = i2;
  return i6 | 0;
 }
 L10 : do switch (HEAP32[i5 >> 2] | 0) {
 case 2:
  {
   HEAP32[i5 + 16 >> 2] = i2;
   HEAP32[i5 >> 2] = 3;
   break;
  }
 case 1:
  {
   i1 = i5 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) == -1) HEAP32[i1 >> 2] = i2;
   if ((i2 | 0) == (HEAP32[i6 >> 2] | 0)) {
    HEAP32[i5 >> 2] = 2;
    HEAP8[i5 + 20 >> 0] = 1;
    break L10;
   } else {
    HEAP32[i5 + 12 >> 2] = i2;
    break L10;
   }
  }
 default:
  {}
 } while (0);
 HEAP32[i5 + 8 >> 2] = i2;
 i6 = i2;
 return i6 | 0;
}

function __ZN5physx9NpFactory24createNpArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE(i7, i6, i4, i5) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i7 + 3040 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i7 + 3036 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i7 + 2744 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i7 + 3024 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i7 = i7 + 3028 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 if (!i1) {
  i7 = 0;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  return i7 | 0;
 }
 __ZN5physx18NpArticulationLinkC2ERKNS_11PxTransformERNS_14NpArticulationEPS0_(i1, i5, i6, i4);
 i7 = i1;
 i6 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
 return i7 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0, i8 = 0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 i3 = i9 + 164 | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f13 = Math_fround(f4 - Math_fround(HEAPF32[i3 >> 2]));
 f7 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i8 = i9 + 168 | 0;
 f12 = Math_fround(f7 - Math_fround(HEAPF32[i8 >> 2]));
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i6 = i9 + 172 | 0;
 f11 = Math_fround(f5 - Math_fround(HEAPF32[i6 >> 2]));
 f2 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i1 = i9 + 176 | 0;
 f10 = Math_fround(f2 - Math_fround(HEAPF32[i1 >> 2]));
 if (Math_fround(Math_fround(Math_fround(Math_fround(f13 * f13) + Math_fround(f12 * f12)) + Math_fround(f11 * f11)) + Math_fround(f10 * f10)) == Math_fround(0.0)) return;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i8 >> 2] = f7;
 HEAPF32[i6 >> 2] = f5;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i9 + 540 >> 2] = 0;
 return;
}

function __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i4 = i3 + (i1 * 48 | 0) | 0;
 i5 = i2;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i6 = f7 > Math_fround(0.0);
 f7 = Math_fround(Math_fround(1.0) / f7);
 HEAPF32[i3 + (i1 * 48 | 0) + 32 >> 2] = i6 ? f7 : Math_fround(1.0);
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i6 = f7 > Math_fround(0.0);
 f7 = Math_fround(Math_fround(1.0) / f7);
 HEAPF32[i3 + (i1 * 48 | 0) + 36 >> 2] = i6 ? f7 : Math_fround(1.0);
 f7 = Math_fround(HEAPF32[i3 + 192 + (i1 * 48 | 0) + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 + (i1 * 48 | 0) + 16 >> 2]));
 HEAPF32[i3 + 832 + (i1 << 2) >> 2] = f7;
 HEAPF32[i3 + 848 + (i1 << 2) >> 2] = Math_fround(Math_fround(1.0) / f7);
 return;
}

function __ZN5audio5mixer32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRNSt3__26vectorI9UnityGUIDNS6_9allocatorIS8_EEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i3 >> 2] | 0;
 i6 = i3 + 4 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 if ((i7 | 0) != (i5 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -16 - i5 | 0) >>> 4) << 4);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __ZN5audio5mixerL32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRKNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEiRNS6_6vectorI9UnityGUIDNSA_ISG_EEEE(i1, i2, i4, -1, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i8;
 return;
}

function __ZN4FMOD12ChannelGroup13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868197;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868197;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = HEAP32[gb + 37324 >> 2] | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1034411 | 0, i3, i4, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
   i1 = HEAP32[i4 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i5);
 }
 i2 = i2 + 12 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, gb + 1034420 | 0, i3, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i2, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i2 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN15LODGroupManager21ReserveInternalArraysEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 4 | 0;
 i2 = i4 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if ((i3 & 2147483647) >>> 0 < i5 >>> 0) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i5 * 96 | 0, 4, i4 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 * 96 | 0, 4, i4 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i4 + 16 >> 2] | 0) * 96 | 0) | 0;
  HEAP32[i2 >> 2] = i5;
  HEAP32[i1 >> 2] = i3;
  break;
 } while (0);
 i3 = i4 + 48 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i4 + 36 | 0;
 i1 = 0;
 do {
  __ZN13CameraLODData7ReserveEj(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i5);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i1 + 7264 + (i4 << 3) | 0;
 i6 = i5;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 if (!(i7 >>> 0 < i3 >>> 0 | ((i7 | 0) == (i3 | 0) ? (HEAP32[i6 >> 2] | 0) >>> 0 < i2 >>> 0 : 0))) return;
 i7 = HEAP32[i1 + 4860 >> 2] | 0;
 i6 = i1 + 5480 | 0;
 mftCall_vi(i7 | 0, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i6 >> 2] | 0, i4) | 0);
 i7 = i1 + 7368 | 0;
 i3 = i7;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = _i64Add(i2 | 0, i3 | 0, 1, 0) | 0;
 i8 = getTempRet0() | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = i8;
 i7 = i5;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 i6 = ~(__ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i6 >> 2] | 0, i4) | 0);
 i7 = i1 + 7376 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & i6;
 return;
}

function __Z52ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, i1 + 264 + 8 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z26Transfer_UnityEngineObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN8JSONRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlagsb(i7, i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 if (!(HEAP8[i7 + 36 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[i3 >> 2] | 0, i4, 0, i5) | 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i7 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i7) >> 2] = i5;
 STACKTOP = i6;
 return;
}

function __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9Rigidbody24SetInertiaTensorRotationERK11Quaternionf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i2 + 81 >> 0] = 0;
 i5 = i2 + 52 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i8 | 0);
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i6;
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i4 | 0);
 i1 = i2 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 i8 = __Z12GetIVehiclesv() | 0;
 mftCall_viif(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i2 + 68 >> 2]));
 STACKTOP = i3;
 return;
}

function __ZN5physx31PxVehicleNoDriveGeneratedValuesC2EPKNS_16PxVehicleNoDriveE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i5 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 HEAP32[i2 + 108 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 56 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 56 >> 2];
 i3 = i5 + 1240 | 0;
 i1 = i5 + 1244 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i5 + 1248 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i5 = (HEAP32[i3 >> 2] | 0) + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i3, i4) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN4FMOD3DSP16getParameterInfoEiPcS1_S1_iPfS2_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868815;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868815;
   _printf(gb + 853343 | 0, i5) | 0;
   i8 = 78;
   STACKTOP = i6;
   return i8 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868815;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN26b2PolygonAndCapsuleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152104 + 8;
 return;
}

function __ZN14MemoryProfiler13StaticDestroyEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1163236 >> 2] | 0;
 i2 = i1 + 160 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i3, HEAP32[i3 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63584 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63584 | 0);
 HEAP32[i1 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1163240 >> 2] | 0, gb + 63584 | 0);
 __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[gb + 1163236 >> 2] | 0, 176);
 HEAP32[gb + 1163236 >> 2] = 0;
 return;
}

function __ZN12CubemapArray7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 400684 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 41156 + 8;
 HEAP32[i4 + 80 >> 2] = 0;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 5;
 i2 = i4 + 92 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP8[i4 + 105 >> 0] = 1;
 HEAP8[i4 + 106 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11TerrainData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i3 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932081 | 0, gb + 932097 | 0, i3, 1);
 __ZN13SplatDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i3 = i1 + 128 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932111 | 0, gb + 932128 | 0, i3, 1);
 __ZN14DetailDatabase8TransferI24GenerateTypeTreeTransferEEvRT_(i3, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 248 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 932143 | 0, gb + 932155 | 0, i1, 1);
 __ZN9Heightmap8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 1);
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i5 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i5 = i3;
  HEAP8[i1 >> 0] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 1);
  i5 = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 >> 0] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i5 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i5 = i3;
  HEAP8[i1 >> 0] = i5;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
  STACKTOP = i7;
  return;
 }
}

function _UNITY_png_set_add_alpha(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if (!i3) return;
 L4 : do if (!(HEAP32[i3 + 204 >> 2] & 32768)) switch (HEAP8[i3 + 431 >> 0] | 0) {
 case 2:
  {
   HEAP8[i3 + 436 >> 0] = 4;
   i2 = 10;
   break L4;
  }
 case 0:
  if ((HEAPU8[i3 + 432 >> 0] | 0) > 7) {
   HEAP8[i3 + 436 >> 0] = 2;
   i2 = 10;
   break L4;
  } else {
   _UNITY_png_app_error(i3, gb + 354626 | 0);
   break L4;
  }
 default:
  {
   _UNITY_png_app_error(i3, gb + 354682 | 0);
   break L4;
  }
 } else {
  HEAP16[i3 + 440 >> 1] = i1;
  i2 = 10;
 } while (0);
 do if ((i2 | 0) == 10) {
  i1 = i3 + 212 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 32768;
  i1 = i3 + 208 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i4 | 0) == 1) {
   HEAP32[i1 >> 2] = i2 | 128;
   break;
  } else {
   HEAP32[i1 >> 2] = i2 & -129;
   break;
  }
 } while (0);
 i1 = i3 + 212 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 32768)) return;
 HEAP32[i1 >> 2] = i2 | 16777216;
 return;
}

function __ZN9BoxPrunerC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i2 + 28 >> 0] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = -1;
 i1 = i2 + 132 | 0;
 i3 = i2 + 76 | 0;
 i4 = i3 + 56 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx2Gu17RadixSortBufferedC2Ev(i1);
 HEAP8[i2 + 168 >> 0] = 0;
 HEAP8[i2 + 169 >> 0] = 1;
 i4 = i2 + 12976 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 return;
}

function __ZN7mecanim4hand13FingerLengthsEPKNS0_4HandEPKNS_8skeleton8SkeletonEPf(i8, i1, i9) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 16 | 0;
 i6 = i5;
 i4 = 0;
 do {
  i7 = i9 + (i4 << 2) | 0;
  HEAPF32[i7 >> 2] = Math_fround(0.0);
  i3 = i4 * 3 | 0;
  i1 = HEAP32[i8 + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   f2 = Math_fround(Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 * 76 | 0) + 68 >> 2]) + Math_fround(0.0));
   HEAPF32[i7 >> 2] = f2;
  } else f2 = Math_fround(0.0);
  i1 = HEAP32[i8 + (i3 + 1 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) {
   f2 = Math_fround(Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 * 76 | 0) + 68 >> 2]) + f2);
   HEAPF32[i7 >> 2] = f2;
  }
  i1 = HEAP32[i8 + (i3 + 2 << 2) >> 2] | 0;
  if ((i1 | 0) > -1) HEAPF32[i7 >> 2] = Math_fround(Math_fround(HEAPF32[(HEAP32[i5 >> 2] | 0) + i6 + (i1 * 76 | 0) + 68 >> 2]) + f2);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 5);
 return;
}

function __ZN5physx10poseWheelsERKNS_23PxVehicleWheels4SimDataEPKNS_11PxTransformEjPNS_14PxRigidDynamicE(i8, i3, i4, i7) {
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 8 | 0;
 i6 = i9;
 mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i5 | 0, 128, 0) | 0;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i2 = 0;
 do {
  i1 = HEAP8[i8 + 928 + i2 >> 0] | 0;
  i10 = i1 << 24 >> 24 == -1;
  i1 = i10 ? -1 : i1 & 255;
  if (!i10) {
   if ((i1 | 0) < 128) i1 = HEAP32[i5 + (i1 << 2) >> 2] | 0; else {
    mftCall_iiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 108 >> 2] | 0, i7 | 0, i6 | 0, 1, i1 | 0) | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i3 + (i2 * 28 | 0) | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 STACKTOP = i9;
 return;
}

function __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (i3 | 0) HEAP32[i3 >> 2] = 0;
   if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i2 + 48 >> 2];
   if (i5 | 0) HEAP32[i5 >> 2] = HEAP32[i2 + 36 >> 2];
   if (!i6) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   HEAP32[i6 >> 2] = 32;
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 870111;
 _printf(gb + 853184 | 0, i7) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN25b2PolygonAndCircleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152124 + 8;
 return;
}

function __ZN25b2CapsuleAndCircleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 151924 + 8;
 return;
}

function __ZN19RuntimeSceneManager11UnloadSceneEP10UnityScene(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (!(__ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene(i1, i5) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i5 + 80 >> 2] = 3;
 __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene(i1, i5);
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i1 << 2) | 0;
 L4 : do if (!i1) i1 = i2; else {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break L4;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 1;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 i5 = i1 + 4 | 0;
 _memmove(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) - i5 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i6 = 1;
 return i6 | 0;
}

function __ZN16CircleCollider2D9SetRadiusEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i1 = i3 + 160 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f2);
 i6 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 if ((i6 ? f5 : f4) <= Math_fround(9.99999997e-07)) return;
 i6 = f2 < Math_fround(.0000999999974);
 i7 = f2 > Math_fround(1.0e6);
 f5 = i7 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 >> 2] = i6 ? Math_fround(.0000999999974) : f5;
 if (!(HEAP32[i3 + 72 >> 2] | 0)) return;
 if (!(HEAP32[HEAP32[i3 + 60 >> 2] >> 2] | 0)) return;
 __ZN10Collider2D19WakeAllBodyContactsEv(i3);
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i7 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i3, i7);
  if (!i7) return;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, 0);
  return;
 }
 __ZN10Collider2D7CleanupEb(i3, 0);
 return;
}

function __ZN14ParticleSystem5ClearEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 32 | 0;
 __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i3 >> 2] | 0, 0);
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 652 >> 2] = 0;
 HEAP32[i1 + 672 >> 2] = 0;
 HEAP32[i1 + 692 >> 2] = 0;
 HEAP32[i1 + 712 >> 2] = 0;
 if (HEAP32[i1 + 732 >> 2] | 0) _memset(HEAP32[i1 + 728 >> 2] | 0, 0, HEAP32[i1 + 736 >> 2] << 2 | 0) | 0;
 i1 = i2 + 40 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 480 >> 2] = 0;
 i4 = i4 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i1 + 13 >> 0] | 0)) {
  i4 = HEAP32[i3 >> 2] | 0;
  __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i2, i4, i1);
  return;
 }
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState(i2, i4, i1);
 return;
}

function __ZN14DetailRenderer16ReloadAllDetailsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 64 | 0;
 i2 = i1 + 68 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 76 | 0;
 i3 = i1 + 80 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 88 | 0;
 i2 = i1 + 92 | 0;
 __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer13setInstanceIdEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i6 = i3 + 8 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = 0;
 i8 = i2 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 150564 + 8;
 HEAP32[i6 + 4 >> 2] = i8;
 i4 = i2 + 24 | 0;
 i1 = i2 + 20 | 0;
 i7 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i8, i7 + 1 | 0);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP8[(HEAP32[i1 >> 2] | 0) + i7 >> 0] = 1;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i5 | 0);
 if (((HEAP32[i4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) >>> 0 < (HEAP32[i2 + 32 >> 2] | 0) >>> 0) {
  STACKTOP = i3;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN11CustomArray8CollapseEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 do if (!i1) {
  i5 = i2 + 8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) i1 = i3; else {
   __ZdaPv(i1);
   i1 = HEAP32[i4 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = 0;
  i2 = 0;
  do {
   i4 = i1;
   i1 = HEAP32[i1 >> 2] | 0;
   i2 = (HEAP32[i4 + 8 >> 2] | 0) + i2 | 0;
  } while ((i1 | 0) != 0);
  if (i2 | 0) {
   i1 = __Znaj(i2) | 0;
   HEAP32[i5 >> 2] = i1;
   break;
  }
  HEAP32[i5 >> 2] = 0;
  i5 = 0;
  return i5 | 0;
 } while (0);
 i5 = (HEAP32[i3 >> 2] | 0) == 0;
 i2 = i3 + 8 | 0;
 _memcpy(i1 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (i5) {
  i5 = i1;
  return i5 | 0;
 } else i4 = i1;
 do {
  i4 = i4 + (HEAP32[i2 >> 2] | 0) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = (HEAP32[i3 >> 2] | 0) == 0;
  i2 = i3 + 8 | 0;
  _memcpy(i4 | 0, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 } while (!i5);
 return i1 | 0;
}

function __Z34GameObject_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting25BroadcastScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i1, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __Z22Texture2D_CUSTOM_ApplyP12Il2CppObjecthh(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP8[i1 + 111 >> 0] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (!(i1 << 24 >> 24)) {
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 570291 | 0, i6);
 } else {
  __ZN9Texture2D5ApplyEbb(i2, i4 << 24 >> 24 != 0, i5 << 24 >> 24 != 0);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__26vectorI4PPtrIN5Unity5JointEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26solveVBlockDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj(i17, f9, i15, i20, i5, i3, i16, i4, i2, i1, i7, i8, i12, i11, i6, i10, i13, i18, i19, i14) {
 i17 = i17 | 0;
 f9 = Math_fround(f9);
 i15 = i15 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 mftCall_vifiiiiiiiiiiiiiiiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 28 >> 2] | 0, i17 | 0, +f9, i15 | 0, i20 | 0, i5 | 0, i3 | 0, i16 | 0, i4 | 0, i2 | 0, i1 | 0, i7 | 0, i8 | 0, i12 | 0, i11 | 0, i6 | 0, i10 | 0, i13 | 0, i18 | 0, i19 | 0, i14 | 0);
 return;
}

function __ZN5physx26solveVBlockCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj(i17, f9, i15, i20, i5, i3, i16, i4, i2, i1, i7, i8, i12, i11, i6, i10, i13, i18, i19, i14) {
 i17 = i17 | 0;
 f9 = Math_fround(f9);
 i15 = i15 | 0;
 i20 = i20 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i16 = i16 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i12 = i12 | 0;
 i11 = i11 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i13 = i13 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i14 = i14 | 0;
 mftCall_vifiiiiiiiiiiiiiiiiii(HEAP32[(HEAP32[i17 >> 2] | 0) + 32 >> 2] | 0, i17 | 0, +f9, i15 | 0, i20 | 0, i5 | 0, i3 | 0, i16 | 0, i4 | 0, i2 | 0, i1 | 0, i7 | 0, i8 | 0, i12 | 0, i11 | 0, i6 | 0, i10 | 0, i13 | 0, i18 | 0, i19 | 0, i14 | 0);
 return;
}

function __ZN13RenderTexture9SetMipMapEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f6 = f0;
 if (!(HEAP32[i5 + 128 >> 2] | 0)) if (!(HEAP32[i5 + 136 >> 2] | 0)) {
  i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 170 >> 0] | 0) != 0 & i1;
  if ((HEAP32[i5 + 104 >> 2] | 0) == 3) i1 = i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 534 >> 0] | 0) == 0;
  HEAP8[i5 + 116 >> 0] = i1 & 1;
  i4 = i5 + 76 | 0;
  HEAP32[i4 >> 2] = 1;
  i2 = HEAP32[i5 + 80 >> 2] | 0;
  if (!i2) return;
  i3 = HEAP32[i5 + 84 >> 2] | 0;
  if (!i3) return;
  f6 = Math_fround(Math_fround(1.0) / Math_fround(i3 | 0));
  HEAPF32[i5 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
  HEAPF32[i5 + 72 >> 2] = f6;
  if (i1) i1 = __Z22CalculateMipMapCount3Diii(i2, i3, 1) | 0; else i1 = 1;
  HEAP32[i4 >> 2] = i1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409879 | 0, 0, gb + 406201 | 0, 931, 1, HEAP32[i5 + 4 >> 2] | 0, 0, 0);
 return;
}

function __Z31Mesh_Get_Custom_PropBoneWeightsP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 100 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i4 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = (HEAP32[i4 + 176 >> 2] | 0) == 0 ? 0 : HEAP32[i4 + 164 >> 2] | 0;
  i3 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 80 >> 2] | 0;
  i2 = (i4 | 0) == 0 ? 0 : i1;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 32, i2) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 32) | 0, i4 | 0, i2 << 5 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z25Input_CUSTOM_GetKeyStringP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i2, i5);
 i1 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536702 | 0, i3);
 } else {
  i3 = __Z15GetInputManagerv() | 0;
  i5 = i1 >>> 5;
  i5 = ((HEAP32[(HEAP32[i3 + 48 >> 2] | 0) + (i5 << 2) >> 2] | HEAP32[(HEAP32[i3 + 68 >> 2] | 0) + (i5 << 2) >> 2]) & 1 << (i1 & 31) | 0) != 0 & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function _y1(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr >> 2] | 0;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Shl(i2 | 0, 0, 1) | 0;
 getTempRet0() | 0 | i2;
 do if (!(i4 | i3)) d1 = -inf; else if ((i2 | 0) < 0) d1 = nan; else {
  if (i2 >>> 0 > 2146435071) {
   d1 = 1.0 / d1;
   break;
  }
  if (i2 >>> 0 > 1073741823) {
   d1 = +_common_180(i2, d1, 1, 0);
   break;
  }
  if (i2 >>> 0 < 1016070144) {
   d1 = -.6366197723675814 / d1;
   break;
  } else {
   d5 = d1 * d1;
   d1 = (d5 * (d5 * (d5 * (2.352526005616105e-05 - d5 * 9.190991580398789e-08) + -1.9125689587576355e-03) + .05044387166398113) + -.19605709064623894) / (d5 * (d5 * (d5 * (d5 * (d5 * 1.6655924620799208e-11 + 6.227414523646215e-09) + 1.3560880109751623e-06) + 2.0255258102513517e-04) + .01991673182366499) + 1.0) * d1 + (+_j1(d1) * +Math_log(+d1) - 1.0 / d1) * .6366197723675814;
   break;
  }
 } while (0);
 return +d1;
}

function __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN4crnd12crnd_reallocEPvjPjb(i1, i2, i6, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 544 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 16 | 0;
 i4 = i8;
 i7 = i8 + 32 | 0;
 if (i1 & 7 | 0) {
  HEAP32[i4 >> 2] = gb + 401209;
  HEAP32[i4 + 4 >> 2] = 2513;
  HEAP32[i4 + 8 >> 2] = gb + 401301;
  _sprintf(i7, gb + 401176 | 0, i4) | 0;
  _puts(i7) | 0;
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (i2 >>> 0 > 2147418112) {
  HEAP32[i5 >> 2] = gb + 401209;
  HEAP32[i5 + 4 >> 2] = 2513;
  HEAP32[i5 + 8 >> 2] = gb + 401323;
  _sprintf(i7, gb + 401176 | 0, i5) | 0;
  _puts(i7) | 0;
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 HEAP32[i7 >> 2] = i2;
 i1 = mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, i2 | 0, i7 | 0, i3 | 0, HEAP32[gb + 1157844 >> 2] | 0) | 0;
 if (i6 | 0) HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN4FMOD5Sound16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj(i7, i1, i2, i3, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869053;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869053;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869053;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD5Sound12getOpenStateEP14FMOD_OPENSTATEPjPbS4_(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (i3 | 0) HEAP32[i3 >> 2] = _JS_Sound_GetLoadState(HEAP32[i2 + 320 >> 2] | 0) | 0;
   if (i4 | 0) HEAP32[i4 >> 2] = 100;
   if (i5 | 0) HEAP8[i5 >> 0] = 0;
   if (!i6) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   HEAP8[i6 >> 0] = 0;
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 859497;
 _printf(gb + 853184 | 0, i7) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN26LegacyTreeInstanceRendererC2ER12TreeRendereriP4MeshRK13dynamic_arrayIP8MaterialLj4EERK10Matrix4x4fRK4AABB(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 4 | 0;
 i10 = i8;
 __ZN20IntermediateRendererC2Ev(i1);
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = i2;
 HEAP32[i1 + 272 >> 2] = i3;
 HEAP32[i1 >> 2] = gb + 184592 + 8;
 HEAP32[i1 + 276 >> 2] = i5;
 HEAP32[i1 + 280 >> 2] = i4;
 HEAP32[i10 >> 2] = 0;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb(i1, i6, i7, i9, 0, 1, 1);
 __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i1, __ZN20IntermediateRenderer27GetWritableSharedPropertiesEv(i1) | 0);
 STACKTOP = i8;
 return;
}

function __ZN23b2EdgeAndPolygonContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152084 + 8;
 return;
}

function __ZN23b2EdgeAndCapsuleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152044 + 8;
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(16, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(16, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11AudioSource13GetOutputDataEPfii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 16 | 0;
 i1 = HEAP32[i1 + 488 >> 2] | 0;
 if (!i1) {
  _memset(i2 | 0, 0, i3 << 2 | 0) | 0;
  STACKTOP = i7;
  return;
 }
 i1 = __ZN4FMOD12ChannelGroup11getWaveDataEPfii(i1, i2, i3, i4) | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i4 = __ZL16FMOD_ErrorString11FMOD_RESULT_59(i1) | 0;
 HEAP32[i6 >> 2] = gb + 855390;
 HEAP32[i6 + 4 >> 2] = 1734;
 HEAP32[i6 + 8 >> 2] = gb + 874603;
 HEAP32[i6 + 12 >> 2] = i4;
 __Z6FormatPKcz(i5, gb + 883334 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i7;
 return;
}

function __Z28Random_CUSTOM_RandomRangeIntii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = __Z16GetScriptingRandv() | 0;
 if ((i1 | 0) < (i2 | 0)) {
  i5 = HEAP32[i3 >> 2] | 0;
  i5 = i5 << 11 ^ i5;
  i4 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i6 = i3 + 8 | 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i4 = i3 + 12 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 >> 2] = i3;
  i3 = i5 >>> 8 ^ i5 ^ i3 ^ i3 >>> 19;
  HEAP32[i4 >> 2] = i3;
  i3 = ((i3 >>> 0) % ((i2 - i1 | 0) >>> 0) | 0) + i1 | 0;
  return i3 | 0;
 }
 if ((i2 | 0) >= (i1 | 0)) {
  i6 = i1;
  return i6 | 0;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 i4 = i4 << 11 ^ i4;
 i5 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i7 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i5 = i3 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i6;
 i6 = i4 >>> 8 ^ i4 ^ i6 ^ i6 >>> 19;
 HEAP32[i5 >> 2] = i6;
 i6 = i1 - ((i6 >>> 0) % ((i1 - i2 | 0) >>> 0) | 0) | 0;
 return i6 | 0;
}

function __Z12GUIDToStringRK9UnityGUIDPc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  i4 = i1 << 3;
  HEAP8[i3 + (i4 | 7) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 28) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 6) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 24 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 5) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 20 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 4) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 16 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 3) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 12 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 2) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 8 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + (i4 | 1) >> 0] = HEAP8[((HEAP32[i5 >> 2] | 0) >>> 4 & 15) + (gb + 488429) >> 0] | 0;
  HEAP8[i3 + i4 >> 0] = HEAP8[(HEAP32[i5 >> 2] & 15) + (gb + 488429) >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 4);
 return;
}

function _IsMacBinary(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i3) i1 = 85; else {
  i1 = _UNITY_FT_Stream_Seek(i3, 0) | 0;
  if (!i1) {
   i1 = _UNITY_FT_Stream_Read(i3, i6, 128) | 0;
   if (!i1) if (!(HEAP8[i6 >> 0] | 0)) if (!(HEAP8[i6 + 74 >> 0] | 0)) if (!(HEAP8[i6 + 82 >> 0] | 0)) {
    i8 = HEAP8[i6 + 1 >> 0] | 0;
    i1 = i8 & 255;
    if ((i8 + -1 & 255) > 32) i1 = 2; else if (!(HEAP8[i6 + 63 >> 0] | 0)) if (!(HEAP8[i6 + (i1 + 2) >> 0] | 0)) {
     i1 = HEAP8[i6 + 83 >> 0] | 0;
     if (i1 << 24 >> 24 < 0) i1 = 2; else i1 = _IsMacResource(i2, i3, (HEAPU8[i6 + 84 >> 0] << 16 | (i1 & 255) << 24 | HEAPU8[i6 + 85 >> 0] << 8 | HEAPU8[i6 + 86 >> 0]) + 255 & -128, i4, i5) | 0;
    } else i1 = 2; else i1 = 2;
   } else i1 = 2; else i1 = 2; else i1 = 2;
  }
 }
 STACKTOP = i7;
 return i1 | 0;
}

function _tt_cmap14_get_def_chars(i6, i7, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = _tt_cmap14_def_char_count(i7) | 0;
 i3 = HEAP8[i7 >> 0] | 0;
 i4 = HEAP8[i7 + 1 >> 0] | 0;
 i5 = HEAP8[i7 + 2 >> 0] | 0;
 i1 = HEAP8[i7 + 3 >> 0] | 0;
 if (_tt_cmap14_ensure(i6, i8 + 1 | 0, i2) | 0) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = (i4 & 255) << 16 | (i3 & 255) << 24 | (i5 & 255) << 8 | i1 & 255;
 i8 = HEAP32[i6 + 32 >> 2] | 0;
 if (!i2) i1 = i8; else {
  i1 = i8;
  do {
   i3 = i7;
   i7 = i7 + 4 | 0;
   i5 = HEAPU8[i3 + 7 >> 0] | 0;
   i6 = i1 + 4 | 0;
   i3 = (HEAPU8[i3 + 5 >> 0] | 0) << 8 | (HEAPU8[i7 >> 0] | 0) << 16 | (HEAPU8[i3 + 6 >> 0] | 0);
   i4 = i5 + 1 | 0;
   while (1) {
    HEAP32[i1 >> 2] = i3;
    i4 = i4 + -1 | 0;
    if (!i4) break; else {
     i3 = i3 + 1 | 0;
     i1 = i1 + 4 | 0;
    }
   }
   i1 = i6 + (i5 << 2) | 0;
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
 }
 HEAP32[i1 >> 2] = 0;
 return i8 | 0;
}

function _md5_update(i7, i1, i2) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i7;
 i4 = HEAP32[i8 >> 2] | 0;
 i3 = i4 & 63;
 i8 = _i64Add(i4 | 0, HEAP32[i8 + 4 >> 2] | 0, i2 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i4;
 do if (!i3) i5 = 5; else {
  i4 = 64 - i3 | 0;
  i3 = i7 + 24 + i3 | 0;
  if (i4 >>> 0 > i2 >>> 0) {
   _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
   break;
  } else {
   _memcpy(i3 | 0, i1 | 0, i4 | 0) | 0;
   _processblock(i7, i7 + 24 | 0);
   i2 = i2 - i4 | 0;
   i1 = i1 + i4 | 0;
   i5 = 5;
   break;
  }
 } while (0);
 if ((i5 | 0) == 5) {
  if (i2 >>> 0 > 63) {
   i4 = i2 + -64 | 0;
   i5 = i4 & -64;
   i6 = i5 + 64 | 0;
   i3 = i1;
   while (1) {
    _processblock(i7, i3);
    i2 = i2 + -64 | 0;
    if (i2 >>> 0 <= 63) break; else i3 = i3 + 64 | 0;
   }
   i2 = i4 - i5 | 0;
   i1 = i1 + i6 | 0;
  }
  _memcpy(i7 + 24 | 0, i1 | 0, i2 | 0) | 0;
 }
 return;
}

function _mallopt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i5 = i3 & -16 ^ 1431655768;
  HEAP32[i3 >> 2] = i5;
  HEAP32[gb + 1470876 >> 2] = i5;
 }
 switch (i1 | 0) {
 case -1:
  {
   HEAP32[gb + 1470876 + 16 >> 2] = i2;
   i1 = 1;
   break;
  }
 case -2:
  {
   if ((HEAP32[gb + 1470876 + 4 >> 2] | 0) >>> 0 > i2 >>> 0) i1 = 0; else if (!(i2 + -1 & i2)) {
    HEAP32[gb + 1470876 + 8 >> 2] = i2;
    i1 = 1;
   } else i1 = 0;
   break;
  }
 case -3:
  {
   HEAP32[gb + 1470876 + 12 >> 2] = i2;
   i1 = 1;
   break;
  }
 default:
  i1 = 0;
 }
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EEPKS6_RKS9_(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i6 = _strlen(i4) | 0;
 i2 = i5 + 11 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i1 = i1 << 24 >> 24 < 0 ? HEAP32[i5 + 4 >> 2] | 0 : i1 & 255;
 __THREW__ = 0;
 invoke_viiii(fb + 359 | 0, i3 | 0, i4 | 0, i6 | 0, i1 + i6 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  __THREW__ = 0;
  invoke_iiii(fb + 512 | 0, i3 | 0, ((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0, i1 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) return;
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 ___resumeException(i6 | 0);
}

function __ZNSt3__26vectorIPN5IMGUI9GUIWindowENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i5 + ~(i5 >>> 0 < 3 ? i5 : 3) + 4 & -4;
 i6 = i2 + i4 | 0;
 i3 = i5;
 i1 = i5;
 while (1) {
  if (i3 >>> 0 <= 3) break;
  i8 = Math_imul(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24, 1540483477) | 0;
  i3 = i3 + -4 | 0;
  i2 = i2 + 4 | 0;
  i1 = (Math_imul(i8 >>> 24 ^ i8, 1540483477) | 0) ^ (Math_imul(i1, 1540483477) | 0);
 }
 switch (i5 - i4 | 0) {
 case 3:
  {
   i1 = (HEAPU8[i6 + 2 >> 0] | 0) << 16 ^ i1;
   i7 = 6;
   break;
  }
 case 2:
  {
   i7 = 6;
   break;
  }
 case 1:
  {
   i7 = 7;
   break;
  }
 default:
  {}
 }
 if ((i7 | 0) == 6) {
  i1 = (HEAPU8[i6 + 1 >> 0] | 0) << 8 ^ i1;
  i7 = 7;
 }
 if ((i7 | 0) == 7) i1 = Math_imul((HEAPU8[i6 >> 0] | 0) ^ i1, 1540483477) | 0;
 i8 = Math_imul(i1 >>> 13 ^ i1, 1540483477) | 0;
 return i8 >>> 15 ^ i8 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwjj(i2, i5, i3, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (i1 >>> 0 > i3 >>> 0) {
  i4 = i2 + (i1 << 2) | 0;
  i3 = i2 + (i3 << 2) | 0;
  while (1) {
   if ((i3 | 0) == (i4 | 0)) {
    i7 = -1;
    break L5;
   }
   __THREW__ = 0;
   i1 = invoke_iiii(fb + 514 | 0, i5 | 0, i6 | 0, i3 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) {
    i1 = 9;
    break;
   }
   if (!i1) {
    i1 = 11;
    break;
   }
   i3 = i3 + 4 | 0;
  }
  if ((i1 | 0) == 9) {
   i8 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i8);
  } else if ((i1 | 0) == 11) {
   i7 = i3 - i2 >> 2;
   break;
  }
 } else i7 = -1; while (0);
 return i7 | 0;
}

function __ZNK13BuildSettings13GetHashOfTypeEPKN5Unity4TypeE(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 i6 = HEAP32[i1 + 84 >> 2] | 0;
 i1 = i6 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 * 24 | 0) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i8 >>> 0;
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if (!((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) >>> 0 > i8 >>> 0)) {
  i9 = i1 + 8 | 0;
  HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
  HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
  return;
 };
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 return;
}

function __ZN9Transform28ApplyRuntimeToSerializedDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 32 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i3 = i1 + 56 | 0;
 i6 = HEAP32[i5 + (i4 * 40 | 0) + 4 >> 2] | 0;
 i7 = HEAP32[i5 + (i4 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 + (i4 * 40 | 0) >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i3 + 8 >> 2] = i7;
 i3 = i1 + 40 | 0;
 i7 = HEAP32[i5 + (i4 * 40 | 0) + 16 >> 2] | 0;
 i6 = HEAP32[i5 + (i4 * 40 | 0) + 20 >> 2] | 0;
 i2 = HEAP32[i5 + (i4 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 + (i4 * 40 | 0) + 12 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i2;
 i1 = i1 + 68 | 0;
 i3 = HEAP32[i5 + (i4 * 40 | 0) + 32 >> 2] | 0;
 i2 = HEAP32[i5 + (i4 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + (i4 * 40 | 0) + 28 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN4FMOD5Sound11setDefaultsEfffi(i5, f1, f2, f3, i4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i6 = i9;
 i4 = HEAP32[gb + 1459872 + (i5 >>> 28 << 2) >> 2] | 0;
 if (i4 | 0) {
  i4 = HEAP32[(HEAP32[i4 + 212 >> 2] | 0) + ((i5 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i4 | 0) if (!(HEAP8[i4 + 16 >> 0] | 0)) if ((HEAP32[i4 + 12 >> 2] | 0) == (i5 & 65535 | 0)) {
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 868863;
   _printf(gb + 857490 | 0, i7) | 0;
   HEAP32[i8 >> 2] = 78;
   HEAP32[i8 + 4 >> 2] = gb + 868863;
   _printf(gb + 853343 | 0, i8) | 0;
   i8 = 78;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 868863;
 _printf(gb + 853184 | 0, i6) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN22b2EdgeAndCircleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152064 + 8;
 return;
}

function __ZN18CrashReportHandlerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN18CrashReportHandler12CloseServiceEv(i2);
 __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2 + 40 | 0, HEAP32[i2 + 44 >> 2] | 0);
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer20ArchiveSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1088 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 8 | 0;
 __ZN12FileAccessorC2Ev(i6);
 if (!(__ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i2, i3, i6) | 0)) {
  i5 = 0;
  __ZN12FileAccessorD2Ev(i6);
  STACKTOP = i7;
  return i5 | 0;
 }
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = 0;
  i1 = HEAP32[i4 >> 2] | 0;
 } else {
  i2 = i1 & 255;
  i3 = 0;
  i1 = i4;
 }
 i5 = __ZN12FileAccessor5WriteEyPKvPy(i6, i2, i3, i1, i5) | 0;
 __ZN12FileAccessor5CloseEv(i6) | 0;
 __ZN12FileAccessorD2Ev(i6);
 STACKTOP = i7;
 return i5 | 0;
}

function __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 884 >> 2] | 0) + 1065 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z28GetAbsoluteAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i7 = HEAP32[gb + 27264 >> 2] | 0;
 __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i6 = _strlen(i7) | 0;
 i5 = i4 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i2 = i2 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i7, i6, i2 + i6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_billboard_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1159924 | 0, gb + 422430 | 0, 0, 0);
 HEAP32[gb + 1159936 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159936 | 0, gb + 422449 | 0);
 HEAP32[gb + 1159940 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159940 | 0, gb + 422472 | 0);
 HEAP32[gb + 1159944 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159944 | 0, gb + 422494 | 0);
 HEAP32[gb + 1159908 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159908 | 0, gb + 422522 | 0);
 HEAP32[gb + 1159912 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159912 | 0, gb + 422542 | 0);
 HEAP32[gb + 1159916 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1159916 | 0, gb + 422562 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546309 | 0, fb + 3383 | 0, fb + 3384 | 0, 1, 0);
 return;
}

function _UNITY_png_get_cHRM(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if (!(HEAP16[i2 + 114 >> 1] & 2)) {
  i10 = 0;
  return i10 | 0;
 }
 if (i3 | 0) HEAPF64[i3 >> 3] = +(HEAP32[i2 + 68 >> 2] | 0) * 1.0e-05;
 if (i4 | 0) HEAPF64[i4 >> 3] = +(HEAP32[i2 + 72 >> 2] | 0) * 1.0e-05;
 if (i5 | 0) HEAPF64[i5 >> 3] = +(HEAP32[i2 + 44 >> 2] | 0) * 1.0e-05;
 if (i6 | 0) HEAPF64[i6 >> 3] = +(HEAP32[i2 + 48 >> 2] | 0) * 1.0e-05;
 if (i7 | 0) HEAPF64[i7 >> 3] = +(HEAP32[i2 + 52 >> 2] | 0) * 1.0e-05;
 if (i8 | 0) HEAPF64[i8 >> 3] = +(HEAP32[i2 + 56 >> 2] | 0) * 1.0e-05;
 if (i9 | 0) HEAPF64[i9 >> 3] = +(HEAP32[i2 + 60 >> 2] | 0) * 1.0e-05;
 if (!i10) {
  i10 = 4;
  return i10 | 0;
 }
 HEAPF64[i10 >> 3] = +(HEAP32[i2 + 64 >> 2] | 0) * 1.0e-05;
 i10 = 4;
 return i10 | 0;
}

function __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE11flushEventsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = HEAP32[i10 + 72 >> 2] | 0;
 i8 = (i7 | 0) == 0;
 if (!i8) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i9 = i10 + 20 | 0;
 i1 = i6;
 i3 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 i4 = HEAP32[i10 + 36 >> 2] | 0;
 if (i4) {
  i1 = i10 + 32 | 0;
  i2 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i6 | 0, i3 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i8) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd10SocketImpl10disconnectEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i3 = i8;
 i6 = i7 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i7 + 14 | 0;
 if ((i1 | 0) == -1) {
  HEAP8[i5 >> 0] = 0;
  i6 = i7 + 12 | 0;
  HEAP16[i6 >> 1] = 0;
  i7 = i7 + 8 | 0;
  HEAP32[i7 >> 2] = 0;
  STACKTOP = i8;
  return;
 }
 if (HEAP8[i5 >> 0] | 0) {
  i2 = i7 + 15 | 0;
  if ((HEAP8[i2 >> 0] | 0) != 1) {
   HEAP32[i3 >> 2] = 0;
   i1 = (_fcntl(i1, 3, i3) | 0) & -2049;
   i3 = HEAP32[i6 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   if ((_fcntl(i3, 4, i4) | 0) != -1) HEAP8[i2 >> 0] = 1;
  }
  _shutdown(HEAP32[i6 >> 2] | 0, 2) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 _close(i1) | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP8[i5 >> 0] = 0;
 i6 = i7 + 12 | 0;
 HEAP16[i6 >> 1] = 0;
 i7 = i7 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7setMassEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 i2 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 f1 = i2 ? f1 : Math_fround(0.0);
 i2 = i7 + 64 | 0;
 i5 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc8BodyCore14setInverseMassEf(i2, f1);
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 92 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1;
 return;
}

function __ZN4FMOD7Channel13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868197;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868197;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN2UI20GetDefaultUIMaterialEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 1468144 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 i1 = __Z15GetScriptMapperv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1012243 | 0, 10);
 i1 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 if (!i1) i1 = __ZN6Shader10GetDefaultEv() | 0;
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i1, 61, 0) | 0;
 HEAP32[gb + 1468144 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, gb + 1012254 | 0);
 i2 = HEAP32[gb + 1468144 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN22VertexDeclarationCache5ClearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 __ZN22VertexDeclarationCache6CommitEv(i3);
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + 8 | 0;
 if ((i1 | 0) != (i5 | 0)) {
  i2 = i1;
  while (1) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i2 + 48 >> 2] | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
  }
 }
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator16OffsetCharactersE8Vector2fPN2UI8UIVertexEPS1_i(i3, i8, i4, i1, i2) {
 i3 = i3 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, f6 = f0, f7 = f0, i9 = 0;
 i5 = (i2 | 0) == 0;
 if (i5) return;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 i3 = i4;
 i4 = i2 << 2;
 while (1) {
  i4 = i4 + -1 | 0;
  HEAPF32[i3 >> 2] = Math_fround(f6 + Math_fround(HEAPF32[i3 >> 2]));
  i9 = i3 + 4 | 0;
  HEAPF32[i9 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i9 >> 2]));
  if (!i4) break; else i3 = i3 + 60 | 0;
 }
 if ((i1 | 0) == 0 | i5) return;
 i3 = i8 + 4 | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f7 = Math_fround(HEAPF32[i8 >> 2]);
  HEAPF32[i1 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i1 >> 2]));
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  i9 = i1 + 4 | 0;
  HEAPF32[i9 >> 2] = Math_fround(f7 + Math_fround(HEAPF32[i9 >> 2]));
  if (!i2) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function __ZN18GlslGpuProgramGLESD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77020 + 8;
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 56 | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 60 | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 64 | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 68 | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 72 | 0);
 __ZN7ApiGLES12DeleteShaderERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 76 | 0);
 __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 88 | 0);
 i2 = i1 + 16 | 0;
 i3 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 if ((HEAP32[i1 + 32 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 20 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12InputManager8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 __ZN14SafeBinaryRead10SetVersionEi(i4, 2);
 i3 = i1 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 434529 | 0, HEAP32[gb + 37316 >> 2] | 0, i2, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i4, i3, 0); else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!(__ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i4, 1) | 0)) {
  STACKTOP = i5;
  return;
 }
 __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE(i3);
 STACKTOP = i5;
 return;
}

function __ZN12CachedWriter11SetPositionEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i6 = (i2 >>> 0) / (i5 >>> 0) | 0;
 i7 = i1 + 12 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i6 | 0) == (i3 | 0)) {
  i4 = i1 + 4 | 0;
  i7 = i6;
  i7 = Math_imul(i7, i5) | 0;
  i7 = i2 - i7 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  i7 = i6 + i7 | 0;
  HEAP32[i1 >> 2] = i7;
  return;
 } else {
  i8 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0, i3 | 0);
  HEAP32[i7 >> 2] = i6;
  i3 = HEAP32[i4 >> 2] | 0;
  i4 = i1 + 4 | 0;
  mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i6 | 0, i4 | 0, i1 + 8 | 0);
  i6 = i4;
  i7 = HEAP32[i7 >> 2] | 0;
  i7 = Math_imul(i7, i5) | 0;
  i7 = i2 - i7 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  i7 = i6 + i7 | 0;
  HEAP32[i1 >> 2] = i7;
  return;
 }
}

function __ZN11Rigidbody2D17SetFreezeRotationEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i1) {
  i1 = i3 | 4;
  if ((i3 | 0) == (i1 | 0)) return;
  HEAP32[i2 >> 2] = i1;
  if (HEAP32[i4 + 92 >> 2] | 0) {
   __ZN11Rigidbody2D17UpdateConstraintsEb(i4, 0);
   if (!(HEAP32[i2 >> 2] | 0)) return;
  }
  if ((HEAP32[i4 + 68 >> 2] | 0) != 2) return;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808078 | 0, 0, gb + 807613 | 0, 833, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i1 = i3 & -5;
 if ((i3 | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 if (HEAP32[i4 + 92 >> 2] | 0) {
  __ZN11Rigidbody2D17UpdateConstraintsEb(i4, 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (!i1) return;
 if ((HEAP32[i4 + 68 >> 2] | 0) != 2) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808078 | 0, 0, gb + 807613 | 0, 833, 512, HEAP32[i4 + 4 >> 2] | 0, 0, 0);
 return;
}

function _tt_cmap2_char_index(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (i5 >>> 0 >= 65536) return 0;
 i3 = i5 >>> 8;
 i4 = i1 + 6 | 0;
 i2 = i1 + 518 | 0;
 if (!i3) {
  i4 = i4 + (i5 << 1 & 510) | 0;
  if ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0)) return 0;
 } else {
  i1 = i4 + (i3 << 1) | 0;
  i1 = (HEAPU8[i1 + 1 >> 0] | 0) & 248 | (HEAPU8[i1 >> 0] | 0) << 8;
  if (!i1) return 0; else i2 = i2 + i1 | 0;
 }
 i3 = i2 + 6 | 0;
 i4 = (HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i2 + 7 >> 0] | 0);
 i1 = (i5 & 255) - ((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0)) | 0;
 if (i4 | 0 ? i1 >>> 0 < ((HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0)) >>> 0 : 0) {
  i5 = i3 + (i4 + (i1 << 1)) | 0;
  i5 = (HEAPU8[i5 >> 0] | 0) << 8 | (HEAPU8[i5 + 1 >> 0] | 0);
  return ((i5 | 0) == 0 ? 0 : i5 + ((HEAPU8[i2 + 4 >> 0] | 0) << 8 | (HEAPU8[i2 + 5 >> 0] | 0)) & 65535) | 0;
 } else return 0;
 return 0;
}

function __ZNSt3__26vectorIP14DataBufferGLESNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK11AudioSource21AreAllChannelsVirtualEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i1 = 1; else if (!(HEAP32[i2 + 16 >> 2] | 0)) i1 = 1; else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance9isVirtualEPb(i1, i5) | 0;
  i1 = (HEAP8[i5 >> 0] | 0) != 0;
 }
 i2 = HEAP32[i3 + 432 >> 2] | 0;
 i4 = i3 + 428 | 0;
 i3 = i2;
 if ((i3 | 0) == (i4 | 0)) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 do {
  i2 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance9isVirtualEPb(i2, i5) | 0;
  i1 = (HEAPU8[i5 >> 0] & (i1 & 1) | 0) != 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i4 | 0));
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN4FMOD6Reverb13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868197;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868197;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD3DSP11setDefaultsEfffi(i5, f1, f2, f3, i4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i6 = i9;
 i4 = HEAP32[gb + 1459872 + (i5 >>> 28 << 2) >> 2] | 0;
 if (i4 | 0) {
  i4 = HEAP32[(HEAP32[i4 + 260 >> 2] | 0) + ((i5 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i4 | 0) if (!(HEAP8[i4 + 16 >> 0] | 0)) if ((HEAP32[i4 + 12 >> 2] | 0) == (i5 & 65535 | 0)) {
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 868863;
   _printf(gb + 857490 | 0, i7) | 0;
   HEAP32[i8 >> 2] = 78;
   HEAP32[i8 + 4 >> 2] = gb + 868863;
   _printf(gb + 853343 | 0, i8) | 0;
   i8 = 78;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 868863;
 _printf(gb + 853184 | 0, i6) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 884 >> 2] | 0) + 1064 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z34ProcessIndexListIsNodeVisibleStep1RK22SceneCullingParametersPK9SceneNodejjR9IndexList(i1, i5, i2, i6, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 if (i2 >>> 0 >= i6 >>> 0) {
  i7 = 0;
  i8 = i8 + 4 | 0;
  HEAP32[i8 >> 2] = i7;
  return;
 }
 i7 = i1 + 192 | 0;
 i4 = i1 + 812 | 0;
 i1 = 0;
 do {
  do if (1 << HEAP32[i5 + (i2 * 24 | 0) + 4 >> 2] & HEAP32[i7 >> 2]) if (HEAP32[i5 + (i2 * 24 | 0) >> 2] | 0) if (!(HEAP8[i5 + (i2 * 24 | 0) + 20 >> 0] & 4)) {
   i3 = HEAP16[i5 + (i2 * 24 | 0) + 14 >> 1] | 0;
   if (i3 << 16 >> 16) if (!((HEAPU8[(HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAPU16[i5 + (i2 * 24 | 0) + 12 >> 1] | 0) * 12 | 0) >> 2] | 0) + (i3 & 65535) >> 0] | 0) & HEAP32[i5 + (i2 * 24 | 0) + 16 >> 2])) break;
   HEAP32[(HEAP32[i8 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  } while (0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 i8 = i8 + 4 | 0;
 HEAP32[i8 >> 2] = i1;
 return;
}

function __Z32CullingGroup_CUSTOM_QueryIndicesP12Il2CppObjecthiN12CullingGroup12QueryOptionsEP11Il2CppArrayi(i4, i5, i6, i7, i1, i8) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 if ((i8 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 510224 | 0, i10);
 if (!i1) {
  i2 = 0;
  i3 = 0;
 } else {
  i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
  i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 }
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9);
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i9); else {
  i9 = __ZNK12CullingGroup12QueryIndicesEbiNS_12QueryOptionsEPjjj(i1, i5 << 24 >> 24 != 0, i6, i7, i3, i8, i2) | 0;
  STACKTOP = i10;
  return i9 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd10ThreadImpl15setAffinityMaskEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 24 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7 + 36 | 0;
 i4 = i7;
 HEAP32[i3 >> 2] = i1;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i2 + 28 >> 2] = i1;
 i1 = i4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 if ((HEAP32[i2 + 16 >> 2] | 0) != 1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = i2 + 24 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = 8;
 HEAP32[i5 + 8 >> 2] = i4;
 if ((_syscall(242, i5 | 0) | 0) < 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = 4;
 HEAP32[i6 + 8 >> 2] = i3;
 if (_syscall(241, i6 | 0) | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) do {
  i3 = i1;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE(i5, i3);
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i6 + 20 >> 2] | 0;
 if (i1 | 0) {
  i1 = i1 + 16 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i6 | 0)) HEAP32[i1 >> 2] = HEAP32[i6 + 8 >> 2];
 }
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i3 = i6 + 8 | 0;
 if (i1 | 0) HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 + 12 >> 2] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj(i5 + 4 | 0, i6 + -8 | 0, HEAP32[i6 + -4 >> 2] | 0);
 return;
}

function __ZN5physx21PxsBodyTransformVaultD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (HEAP32[i5 + 4376 >> 2] | 0) __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv(i5 + 4096 | 0);
 i3 = i5 + 4360 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i5 + 4364 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i6 = HEAP32[i5 + 4368 >> 2] | 0;
 if (!((i6 | 0) > -1 & (i6 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i5 + 4100 | 0) == (i1 | 0)) {
  HEAP8[i5 + 4356 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 | 0);
 return;
}

function __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i6 = i4 + 24 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i3;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i4, i1 + 4 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i3;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN11UnityEngine7Connect20BasePersistentValuesD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189084 + 8;
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __Z23AddCleanLogEntryHandlerPFb7LogTypePKcPiE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1450784 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63176 | 0, 16, gb + 582853 | 0, 169) | 0;
  HEAP32[i1 >> 2] = i1;
  HEAP32[i1 + 4 >> 2] = i1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[gb + 1450784 >> 2] = i1;
 }
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 7;
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i3, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = i3;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 STACKTOP = i4;
 return;
}

function _UNITY_LZ4_compress_forceExtDict(i3, i4, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = i3 + 16392 | 0;
 i9 = i3 + 16400 | 0;
 i10 = (HEAP32[i8 >> 2] | 0) + (HEAP32[i9 >> 2] | 0) | 0;
 i5 = i3 + 16384 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > 2147483648 ? 1 : i1 >>> 0 > (i10 >>> 0 > i4 >>> 0 ? i4 : i10) >>> 0) {
  i2 = i1 + -65536 | 0;
  i1 = 0;
  do {
   i11 = i3 + (i1 << 2) | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = i12 >>> 0 < i2 >>> 0 ? 0 : i12 - i2 | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != 4096);
  HEAP32[i5 >> 2] = 65536;
  i1 = HEAP32[i9 >> 2] | 0;
  if (i1 >>> 0 > 65536) {
   HEAP32[i9 >> 2] = 65536;
   i1 = 65536;
  }
  HEAP32[i8 >> 2] = i10 + (0 - i1);
 }
 i12 = _LZ4_compress_generic(i3, i4, i6, i7, 0, 0, 1, 2, 0) | 0;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i9 >> 2] = i7;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i7;
 return i12 | 0;
}

function __ZN5physx2Sc16InteractionScene14retrieveMemoryEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, HEAP32[i1 + 4 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 16 | 0, HEAP32[i1 + 20 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 28 | 0, HEAP32[i1 + 32 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 40 | 0, HEAP32[i1 + 44 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 52 | 0, HEAP32[i1 + 56 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 64 | 0, HEAP32[i1 + 68 >> 2] | 0);
 __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1 + 76 | 0, HEAP32[i1 + 80 >> 2] | 0);
 return;
}

function __ZN5IMGUI19NamedKeyControlList16GetNameOfControlEi(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i2 = i3;
 L1 : do if ((i2 | 0) != (i4 | 0)) {
  i1 = i3;
  while (1) {
   if ((HEAP32[i2 + 28 >> 2] | 0) == (i6 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) while (1) {
    i2 = HEAP32[i1 + 8 >> 2] | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
   } else {
    i1 = i2;
    while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) {
      i2 = i1;
      break;
     } else i1 = i2;
    }
   }
   if ((i2 | 0) == (i4 | 0)) break L1; else i1 = i2;
  }
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i2 + 16 | 0);
  return;
 } while (0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 1576256 | 0, 0);
 return;
}

function __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i4 + (i1 * 20 | 0) >> 2] | 0;
  i3 = HEAP32[i4 + (i1 * 20 | 0) + 12 >> 2] | 0;
  HEAP32[i5 >> 2] = fb + 599;
  __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i2, i2 + (i3 * 12 | 0) | 0, i5);
  if ((i1 | 0) == 1) {
   i1 = __Z24SetExecutionRestrictions21ExecutionRestrictions(4) | 0;
   __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i2, i3, 3);
   __Z24SetExecutionRestrictions21ExecutionRestrictions(i1) | 0;
   i1 = 2;
   continue;
  } else {
   __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i2, i3, 3);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == 14) break; else continue;
  }
 }
 STACKTOP = i6;
 return;
}

function __ZN14AnimationStateC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = i1;
 i2 = i1 + 112 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 128 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 HEAP32[i1 + 144 >> 2] = i1 + 148;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = i1 + 56 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -257;
 return;
}

function __Z46ParticleSystem_MainModule_CUSTOM_SetStartDelayP12Il2CppObjectR15MonoMinMaxCurve(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve(i2, __ZN14ParticleSystem18GetStartDelayCurveEv(i1) | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z40GameObject_CUSTOM_GetComponentInChildrenP12Il2CppObjectS0_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  i5 = i4 + 20 | 0;
  HEAP16[i5 >> 1] = 257;
  HEAP8[i5 + 2 >> 0] = 1;
  HEAP8[i4 + 22 >> 0] = 0;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP8[i4 + 13 >> 0] = 1;
  HEAP8[i4 + 12 >> 0] = 1;
  HEAP8[i4 + 14 >> 0] = i3 << 24 >> 24 != 0 & 1;
  i5 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i4) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZZN15DirectorManager15InitializeClassEvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1188524 >> 2] | 0;
 __ZN15DirectorManager32StopScheduledPlayableControllersEv(i1);
 __ZN15DirectorManager23DestroyPendingPlayablesEv(0);
 i3 = i1 + 404 | 0;
 i2 = i1 + 408 | 0;
 __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 416 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 420 | 0;
 i3 = i1 + 436 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  i2 = i1 + 432 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 424 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 432 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNSt3__26vectorIP11GameManagerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorI4PPtrI6ObjectENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9BlobWrite23WritePtrValueAtLocationEjx(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP16[i1 + 26 >> 1] | 0;
 i5 = (i6 & 65535) >>> 8 & 255;
 i1 = HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0;
 if (!((i6 & 255) << 24 >> 24)) {
  i6 = _llvm_bswap_i32(i3 | 0) | 0;
  i5 = i5 << 24 >> 24 == 0 ? i3 : i6;
  i6 = i1 + i2 | 0;
  HEAP8[i6 >> 0] = i5;
  HEAP8[i6 + 1 >> 0] = i5 >> 8;
  HEAP8[i6 + 2 >> 0] = i5 >> 16;
  HEAP8[i6 + 3 >> 0] = i5 >> 24;
  return;
 } else {
  i7 = i5 << 24 >> 24 == 0;
  i5 = _llvm_bswap_i32(i3 | 0) | 0;
  i6 = _llvm_bswap_i32(i4 | 0) | 0;
  i5 = i7 ? i4 : i5;
  i3 = i7 ? i3 : i6;
  i6 = i1 + i2 | 0;
  i4 = i6;
  HEAP8[i4 >> 0] = i3;
  HEAP8[i4 + 1 >> 0] = i3 >> 8;
  HEAP8[i4 + 2 >> 0] = i3 >> 16;
  HEAP8[i4 + 3 >> 0] = i3 >> 24;
  i6 = i6 + 4 | 0;
  HEAP8[i6 >> 0] = i5;
  HEAP8[i6 + 1 >> 0] = i5 >> 8;
  HEAP8[i6 + 2 >> 0] = i5 >> 16;
  HEAP8[i6 + 3 >> 0] = i5 >> 24;
  return;
 }
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7setMassEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 i2 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 f1 = i2 ? f1 : Math_fround(0.0);
 i2 = i7 + 64 | 0;
 i5 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc8BodyCore14setInverseMassEf(i2, f1);
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 92 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1;
 return;
}

function __ZN5physx14NpArticulation10putToSleepEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i5 + 88 | 0;
  i3 = 0;
  do {
   __ZN5physx3Scb4Body18putToSleepInternalEv((HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 48 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i3 = i5 + 12 | 0;
 HEAPF32[i5 + 60 >> 2] = Math_fround(0.0);
 HEAP8[i5 + 64 >> 0] = 1;
 i4 = i5 + 16 | 0;
 switch ((HEAP32[i4 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   i2 = 8;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   if (!(HEAP8[i1 + 2432 >> 0] | 0)) i2 = 7; else i2 = 8;
   break;
  }
 default:
  i2 = 7;
 }
 if ((i2 | 0) == 7) {
  __ZN5physx2Sc16ArticulationCore10putToSleepEv(i5 + 24 | 0);
  return;
 } else if ((i2 | 0) == 8) {
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i1, i3);
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -897 | 384;
  return;
 }
}

function __ZN4FMOD5Sound17set3DConeSettingsEfff(i5, f1, f2, f3) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i6 = i9;
 i4 = HEAP32[gb + 1459872 + (i5 >>> 28 << 2) >> 2] | 0;
 if (i4 | 0) {
  i4 = HEAP32[(HEAP32[i4 + 212 >> 2] | 0) + ((i5 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i4 | 0) if (!(HEAP8[i4 + 16 >> 0] | 0)) if ((HEAP32[i4 + 12 >> 2] | 0) == (i5 & 65535 | 0)) {
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 858972;
   _printf(gb + 857490 | 0, i7) | 0;
   HEAP32[i8 >> 2] = 78;
   HEAP32[i8 + 4 >> 2] = gb + 858972;
   _printf(gb + 853343 | 0, i8) | 0;
   i8 = 78;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 858972;
 _printf(gb + 853184 | 0, i6) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN4FMOD3DSP13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868197;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868197;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN19CloudServiceHandler23ProcessAsyncFileRestoreERN11UnityEngine15CloudWebService11FileRestoreE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i4 = i6;
 HEAP32[i4 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 if (HEAP32[i1 + 1144 >> 2] | 0) {
  i5 = __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_(i1, i2, i4) | 0;
  i1 = HEAP32[i1 + 1168 >> 2] | 0;
  if (i1 | 0) mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0);
 }
 if ((HEAP8[i4 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i6;
  return;
 }
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i6;
 return;
}

function __ZN18GfxFramebufferGLES21InvalidateAttachmentsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = HEAP32[i5 + 128 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i1 = 0;
  i3 = 0;
  do {
   i2 = HEAP32[i5 + 92 + (i3 << 2) >> 2] | 0;
   if (i2) {
    i8 = i2 + 29 | 0;
    i2 = (HEAP8[i8 >> 0] | 0) == 1;
    HEAP8[i6 + i3 >> 0] = i2 & 1;
    HEAP8[i8 >> 0] = 0;
    i1 = (i2 & 1) + i1 | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } else i1 = 0;
 i8 = HEAP32[i5 + 124 >> 2] | 0;
 i2 = i8 + 29 | 0;
 if (!i8) i2 = 0; else {
  i8 = (HEAP8[i2 >> 0] | 0) == 1;
  HEAP8[i2 >> 0] = 0;
  i2 = i8;
  i1 = (i8 & 1) + i1 | 0;
 }
 if ((i1 | 0) <= 0) {
  STACKTOP = i7;
  return;
 }
 __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i5, i6, i2);
 STACKTOP = i7;
 return;
}

function __ZN16MBPOS_TmpBuffersD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 1 | 0;
 i1 = i4 + 12808 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 | 0) == (i4 + 12288 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 12812 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((i2 | 0) == (i4 | 0) | (i2 | 0) == 0)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 12816 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i4 + 6144 | 0) | (i2 | 0) == 0) {
  i3 = i4 + 12800 | 0;
  HEAP32[i3 >> 2] = 0;
  i4 = i4 + 12804 | 0;
  HEAP32[i4 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 HEAP32[i1 >> 2] = 0;
 i3 = i4 + 12800 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i4 + 12804 | 0;
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN15ResourceManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 64484 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1 + 48;
 HEAP8[i1 + 60 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider20getInstanceClassTypeEPKv(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i2 + 64 >> 2] | 0;
 L1 : do if (!i1) i1 = -1; else {
  i5 = i4;
  i5 = i5 + ~(i5 << 15) | 0;
  i5 = (i5 >>> 10 ^ i5) * 9 | 0;
  i5 = i5 >>> 6 ^ i5;
  i5 = i5 + ~(i5 << 11) | 0;
  i1 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = -1; else {
   i5 = HEAP32[i2 + 48 >> 2] | 0;
   i3 = i2 + 52 | 0;
   while (1) {
    i2 = i5 + (i1 << 3) | 0;
    if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
    i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
    if ((i1 | 0) == -1) {
     i1 = -1;
     break L1;
    }
   }
   if (!i2) i1 = -1; else i1 = HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0;
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 return i1 | 0;
}

function __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUseRandomRowP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 864 >> 2] | 0) + 556 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z65ParticleSystem_CollisionModule_CUSTOM_SetEnableInteriorCollisionsP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 904 >> 2] | 0) + 949 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _checker(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 40 | 0;
 i2 = i6 + 32 | 0;
 i4 = i6 + 24 | 0;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = ___syscall(202, i6 | 0) | 0;
 HEAP32[i7 + 4 >> 2] = -1;
 if (!(___syscall204(204, i7 | 0) | 0)) {
  HEAP32[i4 >> 2] = ___syscall(201, i6 + 16 | 0) | 0;
  HEAP32[i4 + 4 >> 2] = -1;
  if (___syscall203(203, i4 | 0) | 0) i5 = 3;
 } else i5 = 3;
 if ((i5 | 0) == 3) {
  HEAP32[i2 >> 2] = 1;
  ___syscall1(1, i2 | 0) | 0;
 }
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 12 >> 2] = 0;
 i2 = ___syscall307(307, i3 | 0) | 0;
 i1 = 0;
 do {
  if ((i2 | 0) == (HEAP32[gb + 208028 + (i1 << 2) >> 2] | 0)) break;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < 13);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx3Cct17CapsuleController15getFootPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0;
 i6 = i2 + 416 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 f3 = Math_fround(HEAPF32[i2 + 52 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 + 496 >> 2]));
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i2 + 500 >> 2]) * Math_fround(.5)));
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * f3);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) * f3);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - +f5;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - +f4;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - +f3;
 return;
}

function __ZN7mecanim12statemachine32CreateSelectorTransitionConstantEPPNS0_17ConditionConstantEjjRNS_6memory9AllocatorE(i7, i8, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0;
 i9 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 12, 4) | 0;
 HEAP32[i9 >> 2] = 0;
 i4 = i9 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i9 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = (i8 | 0) == 0;
 if (i6) i1 = 0; else {
  i2 = i8 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i8 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 i2 = i5;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i8;
 HEAP32[i9 >> 2] = i3;
 if (i6) return i9 | 0;
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  i6 = i2 + (i1 << 2) | 0;
  i5 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  HEAP32[i6 >> 2] = i5 | 0 ? i5 - i6 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return i9 | 0;
}

function __ZN5physx2Sc7BodySim21postSwitchToKinematicEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE(i2, 2);
 i1 = i2 + 64 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(i1, HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i2) | 0) + 96 >> 2] | 0);
 __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh(i2, 5, 0, 4);
 i1 = i2 + 188 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 __ZN5physx16PxsIslandManager12setKinematicERKNS_20PxsIslandManagerHookIjLj4294967295EEEb(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i2 + 36 >> 2] | 0) | 0, i1, 1);
 return;
}

function __ZN5physx28PxRigidStaticGeneratedValuesC2EPKNS_13PxRigidStaticE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i2 + 24 | 0, i1 | 0);
 HEAP32[i2 + 52 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN27AnimationLayerMixerPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE(i5, f6, i7) {
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = i5 + 8 | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i10 = 8;
    break;
   } else i3 = 0;
  }
  if ((i10 | 0) == 8) {
   i10 = 0;
   f1 = Math_fround(Math_fround(HEAPF32[(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0) + (i4 << 3) >> 2]) * f6);
   if (f1 > Math_fround(0.0)) mftCall_vifi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, +f1, i7 | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i9 | 0));
 return;
}

function __ZN16b2PolygonContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152144 + 8;
 return;
}

function __ZN16b2CapsuleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 151944 + 8;
 return;
}

function __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 856 >> 2] | 0) + 800 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNSt3__26vectorIPN4FMOD3DSPENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN9Texture3DD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 HEAP32[i2 >> 2] = gb + 46212 + 8;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  HEAP32[i2 >> 2] = gb + 32336 + 8;
  i4 = i2 + 28 | 0;
  __ZN14ConstantStringD2Ev(i4);
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 i4 = i2 + 28 | 0;
 __ZN14ConstantStringD2Ev(i4);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN17Physics2DSettings15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 801731 | 0, gb + 807803 | 0, gb + 802161 | 0);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 3084 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 2316 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 2316 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 2316 + (i1 * 12 | 0) >> 2] = fb + 245;
 __Z26InitializePhysicsManager2Dv();
 STACKTOP = i5;
 return;
}

function __ZN15b2CircleContactC2EP9b2FixtureS1_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i3 = i2 + 36 | 0;
 i5 = i1 + 8 | 0;
 i6 = i5 + 40 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i6 | 0));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i1 + 144 >> 2] = Math_fround(Math_sqrt(Math_fround(f8 * Math_fround(HEAPF32[i4 + 36 >> 2]))));
 f8 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i4 + 40 >> 2]);
 HEAPF32[i1 + 148 >> 2] = f8 > f7 ? f8 : f7;
 HEAPF32[i1 + 152 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 128 >> 2] = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[(HEAP32[i4 + 32 >> 2] | 0) + 8 >> 2];
 HEAP32[i1 >> 2] = gb + 152024 + 8;
 return;
}

function __ZN10GUITextureC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 36436 + 8;
 HEAP32[i1 + 52 >> 2] = 0;
 i3 = i1 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = __ZN7Texture21GetMasterTextureLimitEv() | 0;
 STACKTOP = i4;
 return;
}

function __Z63ParticleSystem_CollisionModule_CUSTOM_SetEnableDynamicCollidersP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 904 >> 2] | 0) + 948 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29GameObject_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Scripting20SendScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i1, i6, i3, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function _UNITY_FT_Outline_Get_Bitmap(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 48 | 0;
 i6 = i7;
 if (!i1) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i2 = i6 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 switch (HEAP8[i1 + 18 >> 0] | 0) {
 case 6:
 case 5:
 case 2:
  {
   HEAP32[i2 >> 2] = 1;
   break;
  }
 default:
  {}
 }
 L7 : do if (!i4) i1 = 33; else if (!i3) i1 = 20; else {
  i2 = HEAP32[i4 + 156 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 + 148 >> 2];
  HEAP32[i6 + 4 >> 2] = i3;
  if (!i2) i1 = 19; else do {
   i1 = mftCall_iii(HEAP32[i2 + 56 >> 2] | 0, HEAP32[i2 + 52 >> 2] | 0, i6 | 0) | 0;
   if (!((i1 | 0) != 0 & (i1 & 255 | 0) == 19)) break L7;
   i2 = _UNITY_FT_Lookup_Renderer(i4, 1869968492, i5) | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26vectorIP9Texture2DNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, (i1 << 4) + 19 | 0, gb + 838004 | 0, 543) | 0;
 if (!i1) i2 = 0; else {
  i2 = i1 + 19 & -16;
  HEAP32[i2 + -4 >> 2] = i2 - i1;
 }
 HEAP32[i4 >> 2] = i2;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (i4 << 4) | 0;
 if ((i4 | 0) <= 0) return;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 16 | 0;
 }
 return;
}

function __ZN5physx2Sq16BucketPrunerCore7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP8[i1 + 7584 >> 0] = 1;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 if (HEAP8[i1 + 7585 >> 0] | 0) {
  i3 = i1 + 8 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 4 | 0, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 12 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i1 + 16 | 0;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i3 = i1 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 584 >> 2] = 0;
 HEAP32[i1 + 588 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f7 * Math_fround(2.0));
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f3 = Math_fround(f6 * Math_fround(2.0));
 f6 = Math_fround(Math_fround(f7 * f8) + Math_fround(Math_fround(f6 * f3) + Math_fround(-1.0)));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f7 * f3);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f8 * f4));
 f4 = Math_fround(Math_fround(f8 * f7) - Math_fround(f3 * f4));
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * f6);
 f3 = Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * f5));
 f3 = Math_fround(-Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 24 >> 2]))));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = f3;
 return;
}

function __ZN4crnd25crnd_crn_format_to_fourccE10crn_format(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 do switch (i1 | 0) {
 case 0:
  {
   if (!i2) i1 = 827611204; else i3 = 23;
   break;
  }
 case 1:
  {
   if (!i2) i1 = 861165636; else i3 = 23;
   break;
  }
 case 2:
  {
   if (!i2) i1 = 894720068; else i3 = 23;
   break;
  }
 case 3:
  {
   if (!i2) i1 = 1501053763; else i3 = 23;
   break;
  }
 case 4:
  {
   if (!i2) i1 = 1383614328; else i3 = 23;
   break;
  }
 case 5:
  {
   if (!i2) i1 = 1380075384; else i3 = 23;
   break;
  }
 case 6:
  {
   if (!i2) i1 = 1380075329; else i3 = 23;
   break;
  }
 case 7:
  {
   if (!i2) i1 = 1498952257; else i3 = 23;
   break;
  }
 case 8:
  {
   if (!i2) i1 = 843666497; else i3 = 23;
   break;
  }
 case 9:
  {
   if (!i2) i1 = 826889281; else i3 = 23;
   break;
  }
 case 10:
  {
   if (!i2) i1 = 826496069; else i3 = 23;
   break;
  }
 default:
  i3 = 23;
 } while (0);
 if ((i3 | 0) == 23) i1 = 0;
 return i1 | 0;
}

function __ZN24RigidbodyMovementState2D20ResetLinearMoveStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 i1 = i2 + 110 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i5 = i2 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i6) return;
 i4 = HEAP32[i2 + 96 >> 2] | 0;
 i3 = HEAP32[i2 + 100 >> 2] | 0;
 if (HEAP32[i6 >> 2] | 0) {
  f8 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  f8 = Math_fround(f8 * f8);
  f7 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  if (Math_fround(f8 + Math_fround(f7 * f7)) > Math_fround(0.0)) {
   i1 = i6 + 4 | 0;
   i2 = HEAPU16[i1 >> 1] | 0;
   if (!(i2 & 2)) {
    HEAP16[i1 >> 1] = i2 | 2;
    HEAPF32[i6 + 144 >> 2] = Math_fround(0.0);
   }
  }
  HEAP32[i6 + 64 >> 2] = i4;
  HEAP32[i6 + 68 >> 2] = i3;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i6 + 132 >> 2] = HEAP32[i1 + 36 >> 2];
 return;
}

function __ZN18GfxFramebufferGLES11SetViewportERK5RectTIiE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 296 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (HEAP8[i3 + 329 >> 0] | 0) return;
 i2 = i3 + 176 | 0;
 i1 = i3 + 180 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 300 >> 2] | 0)) if ((HEAP32[i3 + 184 >> 2] | 0) == (HEAP32[i3 + 304 >> 2] | 0)) if ((HEAP32[i3 + 188 >> 2] | 0) == (HEAP32[i3 + 308 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 mftCall_viiii(HEAP32[(HEAP32[i3 + 336 >> 2] | 0) + 172 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 184 >> 2] | 0, HEAP32[i3 + 188 >> 2] | 0);
 return;
}

function __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = i4 + 56 | 0;
 i6 = i4 + 68 | 0;
 HEAP32[i6 >> 2] = 1;
 i2 = i4 + 72 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 do if (!(i3 & 2147483647)) if ((i3 | 0) > -1) {
  HEAP32[i2 >> 2] = 1;
  i3 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 16, 4, i4 + 60 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i1 >> 2] = i3;
  i1 = i3;
  break;
 } else {
  i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 4, i4 + 60 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i1 >> 2] = i3;
  i1 = i3;
  break;
 } else i1 = HEAP32[i1 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i5 | 0, HEAP32[i6 >> 2] << 4 | 0) | 0;
 __ZN17AnimationCurveTplIfE16StripInvalidKeysEv(i4);
 __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i4);
 return;
}

function __ZN15SharedLightData5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN14ShadowSettings5ResetEv(i1 + 96 | 0);
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 2;
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(30.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(3.73205066);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.03527617);
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 4;
 HEAP8[i1 + 84 >> 0] = 0;
 HEAP8[i1 + 85 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = -1;
 HEAP32[i1 + 188 >> 2] = 1065353216;
 HEAP32[i1 + 192 >> 2] = 1065353216;
 HEAP32[i1 + 196 >> 2] = 1065353216;
 HEAP32[i1 + 200 >> 2] = 1065353216;
 HEAPF32[i1 + 204 >> 2] = Math_fround(7.05336809);
 return;
}

function __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 884 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 868 >> 2] | 0) + 800 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z62ParticleSystem_CollisionModule_CUSTOM_SetUsesCollisionMessagesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 904 >> 2] | 0) + 968 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29Mesh_Get_Custom_PropBindposesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = (HEAP32[i1 + 156 >> 2] | 0) == 0 ? 0 : HEAP32[i1 + 144 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i2 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 156 >> 2] | 0;
  i3 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 260 >> 2] | 0;
  i2 = (i1 | 0) == 0 ? 0 : i2;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 64, i2) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 64) | 0, i1 | 0, i2 << 6 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z20AddKeySmoothTangentsR17AnimationCurveTplIfEff(i5, f1, f4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i2 + 4 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAPF32[i2 >> 2] = f1;
 HEAPF32[i2 + 4 >> 2] = f4;
 i2 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i5, i2) | 0;
 if ((i2 | 0) == -1) {
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((i2 | 0) > 0) __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i5, i2 + -1 | 0, Math_fround(0.0));
 __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i5, i2, Math_fround(0.0));
 i3 = i2 + 1 | 0;
 if ((i3 | 0) >= (HEAP32[i5 + 68 >> 2] | 0)) {
  i5 = i2;
  STACKTOP = i6;
  return i5 | 0;
 }
 __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i5, i3, Math_fround(0.0));
 i5 = i2;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackERNS_15PxErrorCallbackE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i1 + 12 | 0;
 i3 = i1 + 8 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!((i5 | 0) != (i4 | 0) | (i5 | 0) == 0)) {
  i5 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -2;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 }
 i1 = i1 + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) != (i4 | 0) | (i5 | 0) == 0) return;
 i5 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -3;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 return;
}

function __ZN5physx2Sq16BucketPrunerCore20allocateSortedMemoryEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 + 584 >> 2] = i2;
 i1 = i3 + 588 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!(i5 >>> 0 < i2 >>> 0 | i5 >>> 1 >>> 0 > i2 >>> 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = i2 >>> 1 | i2;
 i2 = i2 >>> 2 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = (i2 >>> 16 | i2) + 1 | 0;
 HEAP32[i1 >> 2] = i2;
 i5 = i3 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 3 | 0, HEAP32[i5 >> 2] | 0);
 i3 = i3 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 1 | 0, i2 << 5, gb + 710466 | 0, 506) | 0;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, (i2 << 3) + 15 & -16, gb + 710466 | 0, 507) | 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc13ConstraintSim15setBreakForceLLEff(i6, f5, f4) {
 i6 = i6 | 0;
 f5 = Math_fround(f5);
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i6 + 116 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = f5 < Math_fround(3402823469999999843913219.0e14) | f4 < Math_fround(3402823469999999843913219.0e14);
 do if ((i2 ? 2 : 0) << 24 >> 24 != (i1 & 2)) {
  if (i2) {
   HEAP8[i3 >> 0] = i1 | 2;
   i1 = i6 + 96 | 0;
   if (!(__ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(HEAP32[(HEAP32[i1 >> 2] | 0) + 1204 >> 2] | 0, HEAP32[i6 + 104 >> 2] | 0) | 0)) break;
   __ZN5physx2Sc5Scene28addActiveBreakableConstraintEPNS0_13ConstraintSimE(HEAP32[i1 >> 2] | 0, i6);
   break;
  }
  if (i1 & 4) {
   __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE(HEAP32[i6 + 96 >> 2] | 0, i6);
   i1 = HEAP8[i3 >> 0] | 0;
  }
  HEAP8[i3 >> 0] = i1 & 253;
 } while (0);
 HEAPF32[i6 + 32 >> 2] = f5;
 HEAPF32[i6 + 36 >> 2] = f4;
 return;
}

function __ZN4FMOD5Sound13setVariationsEfff(i5, f1, f2, f3) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 16 | 0;
 i7 = i9 + 8 | 0;
 i6 = i9;
 i4 = HEAP32[gb + 1459872 + (i5 >>> 28 << 2) >> 2] | 0;
 if (i4 | 0) {
  i4 = HEAP32[(HEAP32[i4 + 212 >> 2] | 0) + ((i5 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i4 | 0) if (!(HEAP8[i4 + 16 >> 0] | 0)) if ((HEAP32[i4 + 12 >> 2] | 0) == (i5 & 65535 | 0)) {
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 869173;
   _printf(gb + 857490 | 0, i7) | 0;
   HEAP32[i8 >> 2] = 78;
   HEAP32[i8 + 4 >> 2] = gb + 869173;
   _printf(gb + 853343 | 0, i8) | 0;
   i8 = 78;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 869173;
 _printf(gb + 853184 | 0, i6) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN18GfxFramebufferGLES10SetScissorERK5RectTIiE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 312 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (HEAP8[i3 + 329 >> 0] | 0) return;
 i2 = i3 + 192 | 0;
 i1 = i3 + 196 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i4 >> 2] | 0)) if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i3 + 316 >> 2] | 0)) if ((HEAP32[i3 + 200 >> 2] | 0) == (HEAP32[i3 + 320 >> 2] | 0)) if ((HEAP32[i3 + 204 >> 2] | 0) == (HEAP32[i3 + 324 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 mftCall_viiii(HEAP32[(HEAP32[i3 + 336 >> 2] | 0) + 120 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 200 >> 2] | 0, HEAP32[i3 + 204 >> 2] | 0);
 return;
}

function __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetCycleCountP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 864 >> 2] | 0) + 552 >> 2] = Math_fround(i2 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z34Material_CUSTOM_GetVectorArrayImplP12Il2CppObjecti(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i7 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i7 = 6;
 if ((i7 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i7 = __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i1 + 12 | 0, i4, 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (!(i6 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 10) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   __ZNSt3__26localeD2Ev(i4);
   i6 = __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EEw(i2, i3, i1) | 0;
   STACKTOP = i5;
   return i6 | 0;
  }
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i4);
 ___resumeException(i6 | 0);
 return 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (!(i6 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 10) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   __ZNSt3__26localeD2Ev(i4);
   i6 = __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EEc(i2, i3, i1) | 0;
   STACKTOP = i5;
   return i6 | 0;
  }
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i4);
 ___resumeException(i6 | 0);
 return 0;
}

function __ZNK5physx15PxsParticleData13getParticlesVERNS_30PxvParticleSystemStateDataDescEbb(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 + 12 >> 2] = i4 + 56;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 16 >> 2];
 if (!i2) {
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 12;
  HEAP32[i3 + 24 >> 2] = 0;
  HEAP32[i3 + 28 >> 2] = 12;
  HEAP32[i3 + 32 >> 2] = 0;
  HEAP32[i3 + 36 >> 2] = 4;
  HEAP32[i3 + 40 >> 2] = 0;
  i4 = i3 + 44 | 0;
  HEAP32[i4 >> 2] = 4;
  return;
 } else {
  i2 = i4 + 48 | 0;
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 20 >> 2] = 32;
  HEAP32[i3 + 24 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
  HEAP32[i3 + 28 >> 2] = 32;
  HEAP32[i3 + 32 >> 2] = (HEAP32[i2 >> 2] | 0) + 28;
  HEAP32[i3 + 36 >> 2] = 32;
  HEAP32[i3 + 40 >> 2] = HEAP32[i4 + 52 >> 2];
  i4 = i3 + 44 | 0;
  HEAP32[i4 >> 2] = 4;
  return;
 }
}

function __ZNK12NavMeshAgent21GetCurrentPolygonMaskEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = i1 + 68 | 0;
  i3 = 5;
 } else {
  i1 = i1 + 68 | 0;
  if ((HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 601 >> 0] | 0) == 2) {
   i2 = (__ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 40 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  } else i3 = 5;
 }
 if ((i3 | 0) == 5) {
  i1 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0;
  if (!(HEAP32[i1 + 32 >> 2] | 0)) {
   i1 = 0;
   i2 = 0;
  } else {
   i2 = HEAP32[i1 + 28 >> 2] | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
 }
 return __ZNK9dtNavMesh12getPolyFlagsEy(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0, i1, i2) | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 2 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN13WebCamTexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(128, i1, 16, gb + 1048932 | 0, 0, gb + 363932 | 0, 20) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16BaseVideoTextureC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 i2 = i4 + 96 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 25856 + 8;
 HEAP8[i4 + 120 >> 0] = 0;
 HEAP32[i4 + 124 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13SliderJoint2D8SetMotorERK12JointMotor2D(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2 + 100 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 i3 = f5 < Math_fround(-1.0e6);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(-1.0e6) : f5;
 i3 = i2 + 104 | 0;
 f5 = (HEAP32[tempDoublePtr >> 2] = i1, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i1 = f5 < Math_fround(0.0);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i3 >> 2] = i1 ? Math_fround(0.0) : f5;
 HEAP8[i2 + 116 >> 0] = 1;
 i1 = i2 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN16b2PrismaticJoint11EnableMotorEb(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN16b2PrismaticJoint13SetMotorSpeedEf(i1, Math_fround(HEAPF32[i4 >> 2]));
 __ZN16b2PrismaticJoint16SetMaxMotorForceEf(i1, Math_fround(HEAPF32[i3 >> 2]));
 return;
}

function __ZN11UTF16String18GetScriptingStringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i2 = i7;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__26vectorIcNS_9allocatorIcEEE8__appendEj(i5, i4 << 2);
 __Z18ConvertUTF16toUTF8PKtiPhRi(HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2) | 0;
 HEAP8[(HEAP32[i5 >> 2] | 0) + (HEAP32[i2 >> 2] | 0) >> 0] = 0;
 i2 = __Z20scripting_string_newPKc(HEAP32[i5 >> 2] | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if ((HEAP32[i6 >> 2] | 0) != (i1 | 0)) HEAP32[i6 >> 2] = i1;
  __ZdlPv(i1);
 }
 i6 = i2;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 852 >> 2] | 0) + 800 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z33Material_CUSTOM_GetColorArrayImplP12Il2CppObjecti(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i7 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i7 = 6;
 if ((i7 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i7 = __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i1 + 12 | 0, i4, 1) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorIP6IDListNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN3WWW20GetCachedErrorStringEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = i3 + 20 | 0;
 i4 = i5 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 24 >> 2] | 0; else i2 = i1 & 255;
 do if (!i2) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i3 | 0) | 0;
  if (!i1) {
   i5 = 0;
   return i5 | 0;
  }
  if (!(HEAP8[i1 + 20 >> 0] | 0)) {
   i5 = 0;
   return i5 | 0;
  } else {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i1 + 24 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i5, gb + 586456 | 0) | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i5, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0) | 0) | 0;
   i1 = HEAP8[i4 >> 0] | 0;
   break;
  }
 } while (0);
 if (i1 << 24 >> 24 < 0) {
  i5 = HEAP32[i5 >> 2] | 0;
  return i5 | 0;
 } else return i5 | 0;
 return 0;
}

function __ZN24RigidbodyMovementState2D19SetAngularMoveStateEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 92 >> 2] | 0;
 if (!i5) return;
 f6 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]));
 f1 = Math_fround(f1 - Math_fround(HEAPF32[i5 + 56 >> 2]));
 f1 = Math_fround(f6 * Math_fround(+Math_atan2(+Math_fround(+Math_sin(+f1)), +Math_fround(+Math_cos(+f1)))));
 i4 = i2 + 111 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) HEAP32[i2 + 104 >> 2] = HEAP32[i5 + 72 >> 2];
 if (HEAP32[i5 >> 2] | 0) {
  i3 = i5 + 4 | 0;
  i2 = HEAP16[i3 >> 1] | 0;
  if (!(i2 & 16)) {
   if (Math_fround(f1 * f1) > Math_fround(0.0)) {
    i2 = i2 & 65535;
    if (!(i2 & 2)) {
     HEAP16[i3 >> 1] = i2 | 2;
     HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
    }
   }
   HEAPF32[i5 + 72 >> 2] = f1;
  }
 }
 HEAPF32[i5 + 136 >> 2] = Math_fround(0.0);
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN14DataBufferGLES5UnmapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 1451080 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 switch (HEAP32[i2 + 12 >> 2] | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 1 : 2;
   } else i1 = 1;
   break;
  }
 case 6:
 case 5:
 case 4:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) {
    i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
    i1 = i1 ? 0 : 2;
   } else i1 = 0;
   break;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   break;
  }
 default:
  i1 = -559030611;
 }
 __ZN7ApiGLES11UnmapBufferEjN2gl12BufferTargetE(i3, i4, i1);
 if (HEAP8[i2 + 21 >> 0] | 0) return;
 HEAP32[i2 + 28 >> 2] = HEAP32[HEAP32[i2 >> 2] >> 2];
 return;
}

function __ZN12_GLOBAL__N_115StringTableImpl11handleToStrEj(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!i4) {
  i6 = gb + 1576256 | 0;
  return i6 | 0;
 }
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if (!i1) {
  i6 = gb + 1576256 | 0;
  return i6 | 0;
 }
 i5 = ~(i4 << 15) + i4 | 0;
 i5 = (i5 >>> 10 ^ i5) * 9 | 0;
 i5 = i5 >>> 6 ^ i5;
 i5 = i5 + ~(i5 << 11) | 0;
 i1 = HEAP32[(HEAP32[i2 + 88 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = gb + 1576256 | 0;
  return i6 | 0;
 }
 i5 = HEAP32[i2 + 80 >> 2] | 0;
 i3 = i2 + 84 | 0;
 while (1) {
  i2 = i5 + (i1 << 3) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = gb + 1576256 | 0;
   i6 = 9;
   break;
  }
 }
 if ((i6 | 0) == 9) return i1 | 0;
 if (!i2) {
  i6 = gb + 1576256 | 0;
  return i6 | 0;
 }
 i6 = HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0;
 return i6 | 0;
}

function __ZN12WheelJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 807113 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 158312 + 8;
 HEAPF32[i4 + 96 >> 2] = Math_fround(.699999988);
 HEAPF32[i4 + 100 >> 2] = Math_fround(2.0);
 HEAPF32[i4 + 104 >> 2] = Math_fround(90.0);
 HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 112 >> 2] = Math_fround(1.0e4);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z7md5hashPKvij(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 16 | 0;
 i8 = i9;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 1732584193;
 HEAP32[i7 + 12 >> 2] = -271733879;
 HEAP32[i7 + 16 >> 2] = -1732584194;
 HEAP32[i7 + 20 >> 2] = 271733878;
 do if ((i5 | 0) >= 1) {
  HEAP32[i7 >> 2] = i5;
  if ((i5 | 0) > 63) {
   i4 = i5 + -64 | 0;
   i6 = i4 & -64;
   i3 = i2;
   i1 = i5;
   while (1) {
    __ZL11md5_processP11md5_contextPh(i7, i3);
    i1 = i1 + -64 | 0;
    if ((i1 | 0) <= 63) break; else i3 = i3 + 64 | 0;
   }
   i1 = i4 - i6 | 0;
   if ((i1 | 0) > 0) i2 = i2 + (i6 + 64) | 0; else break;
  } else i1 = i5;
  _memcpy(i7 + 24 | 0, i2 | 0, i1 | 0) | 0;
 } while (0);
 __Z10md5_finishP11md5_contextPh(i7, i8);
 STACKTOP = i9;
 return HEAP32[i8 >> 2] | 0;
}

function __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 896 >> 2] | 0) + 800 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 876 >> 2] | 0) + 800 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetRandomizedP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 876 >> 2] | 0) + 801 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z28TestAssetBundleCompatibilityR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERS7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (HEAP32[i1 + 32 >> 2] | 0) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 __Z6FormatPKcz(i4, gb + 366169 | 0, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__26vectorIP5CacheNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN4Mesh17RecalculateBoundsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 __ZN4Mesh25RecalculateBoundsInternalEv(i5);
 HEAP32[i3 >> 2] = gb + 30832;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = i5;
 i2 = HEAP32[i5 + 236 >> 2] | 0;
 i4 = i5 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) != (i4 | 0)) do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, gb + 1105176 | 0, i3);
  i1 = i2;
 } while ((i1 | 0) != (i4 | 0));
 i3 = i5 + 240 | 0;
 i1 = HEAP32[i5 + 244 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN4FMOD5Sound11getDefaultsEPfS1_S1_Pi(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (i3 | 0) HEAPF32[i3 >> 2] = Math_fround(44100.0);
   if (i4 | 0) HEAPF32[i4 >> 2] = Math_fround(1.0);
   if (i5 | 0) HEAPF32[i5 >> 2] = Math_fround(1.0);
   if (!i6) {
    i7 = 0;
    STACKTOP = i8;
    return i7 | 0;
   }
   HEAP32[i6 >> 2] = 128;
   i7 = 0;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 868772;
 _printf(gb + 853184 | 0, i7) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN12MeshRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 1, i5, i3);
 HEAP32[i1 >> 2] = gb + 58344 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 58344 + 188;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 344 >> 2] = 0;
 HEAP8[i1 + 348 >> 0] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 360 >> 2] = i1;
 HEAP32[i1 + 364 >> 2] = 0;
 HEAP32[i1 + 368 >> 2] = 0;
 HEAP32[i1 + 372 >> 2] = i1;
 HEAP32[i1 + 376 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 864 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_LightsModule_CUSTOM_SetUseRandomDistributionP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 920 >> 2] | 0) + 12 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_LightsModule_CUSTOM_SetAlphaAffectsIntensityP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 920 >> 2] | 0) + 22 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  __ZN14ParticleSystem13SetStartColorE10ColorRGBAf(i4, i1);
  STACKTOP = i5;
  return;
 }
}

function __Z27Mesh_CUSTOM_Internal_CreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i5 = i2;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 546865 | 0, 29) | 0;
 i8 = gb + 63520 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i3, i4, 0);
 __Z19pop_allocation_rootv();
 i3 = __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i3) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 4);
 STACKTOP = i2;
 return;
}

function __GLOBAL__sub_I_runtime_virtualfilesystem_archivefilesystem_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178992 | 0, gb + 489860 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179004 | 0, gb + 489891 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178980 | 0, gb + 489932 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178944 | 0, gb + 489962 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178932 | 0, gb + 489993 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178968 | 0, gb + 490023 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1178956 | 0, gb + 490053 | 0, 10, 0);
 return;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0;
 i15 = HEAP32[i4 + 48 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i13 = f14 > Math_fround(0.0);
 i1 = f10 > Math_fround(0.0);
 i4 = f7 > Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i15 + 144 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 148 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 152 >> 2]);
 f11 = Math_fround(-f12);
 f8 = Math_fround(-f9);
 f5 = Math_fround(-f6);
 f5 = Math_fround(Math_fround(Math_fround(f14 * (i13 ? f12 : f11)) + Math_fround(f10 * (i1 ? f9 : f8))) + Math_fround(f7 * (i4 ? f6 : f5)));
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = Math_fround(-f5);
 return;
}

function __ZN5physx15PxSerialization21createSerialObjectIdsERNS_12PxCollectionEy(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 28 >> 2] | 0, i8 | 0) | 0;
 if (!i7) return;
 i6 = 0;
 do {
  while (1) {
   i4 = (mftCall_iiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, i1 | 0, i2 | 0) | 0) == 0;
   i3 = _i64Add(i1 | 0, i2 | 0, 1, 0) | 0;
   i5 = getTempRet0() | 0;
   if (i4) {
    i4 = i3;
    break;
   } else {
    i1 = i3;
    i2 = i5;
   }
  }
  i3 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 32 >> 2] | 0, i8 | 0, i6 | 0) | 0;
  i9 = mftCall_iii(HEAP32[(HEAP32[i8 >> 2] | 0) + 52 >> 2] | 0, i8 | 0, i3 | 0) | 0;
  if ((i9 | 0) == 0 & (getTempRet0() | 0) == 0) {
   mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i3 | 0, i1 | 0, i2 | 0);
   i1 = i4;
   i2 = i5;
  }
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i7 | 0));
 return;
}

function __ZN4FMOD5Sound6unlockEPvS1_jj(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i1 = __ZN4FMOD6SoundI6unlockEPvS1_jj(i2, i3, i4, i5, i6) | 0;
   if (!i1) {
    i8 = 0;
    STACKTOP = i9;
    return i8 | 0;
   }
   HEAP32[i8 >> 2] = i1;
   HEAP32[i8 + 4 >> 2] = gb + 1082369;
   _printf(gb + 853343 | 0, i8) | 0;
   i8 = i1;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 1082369;
 _printf(gb + 853184 | 0, i7) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN4FMOD5Sound12addSyncPointEjjPKcPP14FMOD_SYNCPOINT(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868923;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868923;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868923;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN15LODGroupManager19ClearInternalArraysEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 4 | 0;
 i2 = i5 + 16 | 0;
 HEAP32[i2 >> 2] = 1;
 i3 = i5 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if (!(i4 & 2147483647)) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, 96, 4, i5 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
  break;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(96, 4, i5 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i1 >> 2] | 0, (HEAP32[i2 >> 2] | 0) * 96 | 0) | 0;
  HEAP32[i3 >> 2] = 1;
  HEAP32[i1 >> 2] = i4;
  break;
 } while (0);
 i3 = i5 + 48 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i5 + 36 | 0;
 i1 = 0;
 do {
  __ZN13CameraLODData5ClearEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN14MessageHandler17WillHandleMessageEPvji(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = HEAP32[i1 + 52 >> 2] | 0;
 i1 = HEAP32[i3 + (i6 * 20 | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i8 + (i5 << 5) >> 2] | 0;
 if ((i1 | 0) < ((HEAP32[i8 + (i5 << 5) + 4 >> 2] | 0) - i2 >> 2 | 0)) if (HEAP32[i2 + (i1 << 2) >> 2] | 0) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP32[i8 + (i5 << 5) + 24 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!(HEAP32[i3 + (i6 * 20 | 0) + 16 >> 2] & 1)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 i8 = mftCall_iiii(HEAP32[i8 + (i5 << 5) + 28 >> 2] | 0, i4 | 0, i1 | 0, i7 | 0) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN14EmissionModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAPF32[i1 + 88 >> 2] = Math_fround(10.0);
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, Math_fround(10.0), HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, Math_fround(0.0), HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 HEAP32[i1 + 584 >> 2] = 0;
 HEAP32[i1 + 552 >> 2] = 30;
 HEAP32[i1 + 568 >> 2] = 30;
 HEAPF32[i1 + 536 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 556 >> 2] = 30;
 HEAP32[i1 + 572 >> 2] = 30;
 HEAPF32[i1 + 540 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 560 >> 2] = 30;
 HEAP32[i1 + 576 >> 2] = 30;
 HEAPF32[i1 + 544 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 564 >> 2] = 30;
 HEAP32[i1 + 580 >> 2] = 30;
 HEAPF32[i1 + 548 >> 2] = Math_fround(0.0);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager37OnTimerExpiredPerformArchiveJobStaticEPv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!i4) return;
 i5 = HEAP32[i4 + 32 >> 2] | 0;
 i2 = i4 + 91 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 i3 = i4 + 92 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 if ((HEAP32[i5 >> 2] | 0) != 1) if ((HEAP32[i5 >> 2] | 0) != 2) return;
 i1 = i5 + 552 | 0;
 if ((HEAPU16[i4 + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 if (HEAP8[i4 + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i4) | 0;
 i1 = HEAP32[i5 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i5 >> 2] | 0) != 1) if ((HEAP32[i5 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i4 | 0);
 } while (0);
 if (HEAP8[i4 + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
 return;
}

function __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 868 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 856 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z57ParticleSystem_TrailModule_CUSTOM_SetInheritParticleColorP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 288 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleAnimator_Get_Custom_PropColorAnimationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK16ParticleAnimator17GetColorAnimationEP10ColorRGBAf(i2, i3);
  i4 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, 5) | 0;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 16) | 0;
  i1 = i3;
  i2 = i5 + 80 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  STACKTOP = i6;
  return i4 | 0;
 }
 return 0;
}

function __Z44UnityWebRequest_Set_Custom_PropRedirectLimitP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 24 | 0;
 i4 = i6 + 16 | 0;
 i3 = i6;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if ((HEAP32[i1 + 108 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031331 | 0, i6 + 8 | 0);
 if ((i2 | 0) > 128) {
  HEAP32[i4 >> 2] = 128;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 1031410 | 0, i4);
 }
 i1 = __ZN14RedirectHelper16SetRedirectLimitEj(i1 + 36 | 0, i2) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = __Z17GetWebErrorString8WebError(i1) | 0;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1074693 | 0, i5);
 }
}

function __Z34Material_CUSTOM_GetMatrixArrayImplP12Il2CppObjecti(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i7 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i7 = 6;
 if ((i7 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i7 = __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i1 + 12 | 0, i4) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNSt3__26vectorIPFvjENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EERKS9_PKS6_(i3, i2, gb + 1084437 | 0);
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4500 | 0, i1 | 0, i3 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  i1 = i2;
 } else {
  HEAP32[i1 >> 2] = gb + 216384 + 8;
  __THREW__ = 0;
  invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13192 | 0, fb + 3222 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 ___resumeException(i1 | 0);
}

function __ZNK14TerrainManager27CreateSharedMeshDataPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB(i1, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 248 | 0;
 i2 = i4 + 8 | 0;
 i3 = i4;
 if (!i5) {
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 if ((((HEAP32[i5 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 66968 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 66968 + 28 >> 2] | 0) >>> 0) {
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f(i2, 0, i1, i6);
 __ZNK15TerrainRenderer27CreateSharedMeshDataPatchesER13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB(i2, i7, i8);
 __ZN15TerrainRendererD2Ev(i2);
 i8 = 1;
 STACKTOP = i4;
 return i8 | 0;
}

function __ZN8Animator15IsBoneTransformEP9Transform(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 144 >> 2] | 0;
 if (HEAP8[i1 + 561 >> 0] | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = i2 + 4 | 0;
  i2 = 0;
  i1 = 0;
  while (1) {
   if (i2 >>> 0 >= i4 >>> 0) break;
   i6 = (HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0) == (i5 | 0);
   i1 = i6 & 1;
   if (i6) break; else i2 = i2 + 1 | 0;
  }
  i6 = i1 << 24 >> 24 != 0;
  return i6 | 0;
 }
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) != -1) {
   i1 = 1;
   i2 = 12;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i2 = 12;
   break;
  }
 }
 if ((i2 | 0) == 12) return i1 | 0;
 return 0;
}

function __ZN7dtCrowd19UpdateProximityGridEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1459272 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459272 | 0, i1);
  i1 = gb + 1459272 | 0;
 } else i1 = 0;
 i5 = HEAP32[i3 + 400 >> 2] | 0;
 i5 = (i5 | 0) > 65535 ? 65535 : i5;
 i6 = 65535 - i5 | 0;
 i2 = HEAP32[i3 + 404 >> 2] | 0;
 i2 = (i6 | 0) < (i2 | 0) ? i6 : i2;
 i6 = i3 + 368 | 0;
 __ZNK7dtCrowd27UpdateProximityGridCellSizeEP15dtProximityGridii(i3, HEAP32[i6 >> 2] | 0, i5, i2);
 __ZNK7dtCrowd35InsertActiveAgentsIntoProximityGridEP15dtProximityGridii(i3, HEAP32[i6 >> 2] | 0, i5, i2);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN17ArchiveFileSystem10ToAbsoluteEPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 i1 = i1 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i1, _strlen(i1) | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, _strlen(i3) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN16MemoryFileSystem10ToAbsoluteEPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 i1 = i1 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i1, _strlen(i1) | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, _strlen(i3) | 0);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i2, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN14dtPathCorridor5resetEyPKf(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + 56 >> 2] | 0;
 if ((i2 | 0) == 0 & (i4 | 0) == 0) {
  i5 = i6;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = 0;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = 1;
  i6 = i1 + 44 | 0;
  HEAP8[i6 >> 0] = i5;
  i6 = i1 + 48 | 0;
  HEAP32[i6 >> 2] = i3;
  return;
 } else {
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i4 = i5 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  i6 = i5 + 8 | 0;
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i6 >> 2];
  i5 = 1;
  i6 = i1 + 32 | 0;
  HEAP32[i6 >> 2] = 1;
  i6 = i1 + 44 | 0;
  HEAP8[i6 >> 0] = i5;
  i6 = i1 + 48 | 0;
  HEAP32[i6 >> 2] = i3;
  return;
 }
}

function __ZN12b2EPCollider21ComputeEdgeSeparationEv(i1, i10) {
 i1 = i1 | 0;
 i10 = i10 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, i9 = 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = (HEAP8[i10 + 248 >> 0] ^ 1) & 255;
 i8 = i1 + 8 | 0;
 HEAPF32[i8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 i9 = HEAP32[i10 + 128 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 f4 = Math_fround(HEAPF32[i10 + 164 >> 2]);
 f5 = Math_fround(HEAPF32[i10 + 168 >> 2]);
 f6 = Math_fround(HEAPF32[i10 + 212 >> 2]);
 f7 = Math_fround(HEAPF32[i10 + 216 >> 2]);
 i1 = 0;
 f3 = Math_fround(3402823469999999843913219.0e14);
 while (1) {
  f2 = Math_fround(Math_fround(HEAPF32[i10 + (i1 << 3) >> 2]) - f4);
  f2 = Math_fround(Math_fround(f2 * f6) + Math_fround(Math_fround(Math_fround(HEAPF32[i10 + (i1 << 3) + 4 >> 2]) - f5) * f7));
  if (f2 < f3) HEAPF32[i8 >> 2] = f2; else f2 = f3;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i9 | 0)) break; else f3 = f2;
 }
 return;
}

function __Z56ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsLifetimeP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 287 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z38Material_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectiR10ColorRGBAf(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 24 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 if (!i2) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i7) {
  i8 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  HEAP32[i6 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE(i5, i7, i1);
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = HEAP32[i5 + 8 >> 2] | 0;
  i7 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i4 + 8 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function __ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EERKS9_PKS6_(i3, i2, gb + 1084421 | 0);
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4500 | 0, i1 | 0, i3 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  i1 = i2;
 } else {
  HEAP32[i1 >> 2] = gb + 216344 + 8;
  __THREW__ = 0;
  invoke_viii(fb + 1035 | 0, i1 | 0, gb + 13160 | 0, fb + 3222 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 ___resumeException(i1 | 0);
}

function __ZN8Collider10SetupLayerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i5 | 0);
 i7 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i7 | 0);
 i7 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] | HEAP32[i2 >> 2] & -256;
 HEAP32[i2 >> 2] = i7;
 i5 = i1;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = i7;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 12 >> 2] = 0;
 i5 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 76 >> 2] | 0, i5 | 0, i2 | 0);
 i5 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 88 >> 2] | 0, i5 | 0, i3 | 0);
 STACKTOP = i6;
 return;
}

function __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = HEAP32[i2 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i6 | 0)) {
  i7 = HEAP32[i2 + 32 >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((HEAP32[i7 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i6 | 0)) break L1;
  }
  if ((i1 | 0) > -1) {
   i7 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i2, i7, i3, i5, 1);
   return;
  }
 } while (0);
 i7 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i2, i3, 0) | 0;
 __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb(i2, i7, i3, i5, 1);
 return;
}

function __ZN13ComputeShader28DestroyRuntimeDataMainThreadEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i4 = i2 + 48 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i9 = i2 + 44 | 0;
  i1 = 0;
  i5 = HEAP32[i9 >> 2] | 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 788 >> 2] | 0, i3 | 0, i5 + (i1 * 976 | 0) | 0);
   i5 = HEAP32[i9 >> 2] | 0;
   i6 = HEAP32[i5 + (i1 * 976 | 0) + 964 >> 2] | 0;
   i7 = i5 + (i1 * 976 | 0) + 968 | 0;
   i8 = HEAP32[i7 >> 2] | 0;
   if ((i8 | 0) != (i6 | 0)) HEAP32[i7 >> 2] = i8 + (~(((i8 + -24 - i6 | 0) >>> 0) / 24 | 0) * 24 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 i9 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i2, 22, 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 800 >> 2] | 0, i3 | 0, ((HEAP32[i9 + 24 >> 2] | 0) - (HEAP32[i9 + 20 >> 2] | 0) | 0) / 20 | 0 | 0, i2 + 192 | 0);
 return;
}

function __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 892 >> 2] | 0) + 808 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z33Sprite_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  HEAPF32[i4 + 4 >> 2] = Math_fround(0.0);
  __ZNK6Sprite9GetBoundsE8Vector2fbb(i3, i5, i4, 0, 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z33Material_CUSTOM_GetFloatArrayImplP12Il2CppObjecti(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = i3 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i7 = 6; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i7 = 6;
 if ((i7 | 0) == 6) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i5;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 i7 = __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i1 + 12 | 0, i4) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z25EstimateRenderTextureSizeiii19RenderTextureFormat17DepthBufferFormat16TextureDimensionb(i2, i3, i5, i1, i8, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i4 = 0;
 switch (i1 | 0) {
 case 1:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 505 >> 0] | 0)) i4 = 4; else i1 = 0;
   break;
  }
 case 3:
  {
   if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0)) i4 = 4; else i1 = 0;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) i1 = HEAP32[gb + 44480 + (i1 << 2) >> 2] | 0;
 i2 = Math_imul(i3, i2) | 0;
 i1 = Math_imul(i1, i2) | 0;
 switch (i6 | 0) {
 case 3:
 case 5:
 case 6:
  {
   i1 = Math_imul(i1, i5) | 0;
   break;
  }
 case 4:
  {
   i1 = i1 * 6 | 0;
   break;
  }
 default:
  {}
 }
 if (i7) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 170 >> 0] | 0) i1 = ((i1 | 0) / 3 | 0) + i1 | 0;
 return (Math_imul(HEAP32[gb + 44572 + (i8 << 2) >> 2] | 0, i2) | 0) + i1 | 0;
}

function __ZZN15DirectorManager15InitializeClassEvEN36EarlyUpdateDirectorAdvanceTimestruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1188524 >> 2] | 0;
 __ZN15DirectorManager14ConnectionPool16GrowEmptyBucketsEv(gb + 1188456 | 0);
 i3 = i2 + 376 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i6 = __Z14GetTimeManagerv() | 0;
 i7 = HEAP32[i6 + 112 >> 2] | 0;
 HEAP32[gb + 1188440 >> 2] = i7;
 HEAP32[gb + 1188448 >> 2] = i7;
 f5 = Math_fround(+HEAPF64[i6 + 184 >> 3]);
 HEAPF32[gb + 1188452 >> 2] = f5;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i1, fb + 3162 | 0, HEAP32[i2 + 364 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 STACKTOP = i4;
 return;
}

function __ZN6Camera24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture(i10, i2, i1) {
 i10 = i10 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i1) i8 = 0; else i8 = (HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[i10 + 744 >> 2] | 0);
 i9 = i10 + 784 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = (i3 | 0) == (HEAP32[i9 >> 2] | 0);
 i6 = i10 + 748 | 0;
 i7 = i10 + 780 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 if (!i4) i1 = 0; else {
  i2 = 0;
  do {
   i1 = (i3 | 0) == (HEAP32[i10 + 748 + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
  } while (!(i2 >>> 0 >= i4 >>> 0 | i1));
 }
 if (i5 | (i8 | i1)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i7 >> 2] = 1;
 }
 if (!((i5 | i1) & (HEAP32[i10 + 744 >> 2] | 0) == 0)) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 377537 | 0, 0, gb + 375437 | 0, 3261, 1, HEAP32[i10 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj(i2, i4, i1, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i3 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i1 = __ZN4FMOD8ChannelI8setDelayE14FMOD_DELAYTYPEjj(i1, i4, 0, i5) | 0;
   if (!i1) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 4 >> 2] = gb + 859018;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = i1;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859018;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN20SoundChannelInstance16UpdatePauseStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 i2 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 i1 = HEAP16[i1 + 236 >> 1] | 0;
 i1 = __ZN4FMOD7Channel9setPausedEb(i2, (i1 & 65535) > 255 | (i1 & 255) << 24 >> 24 != 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 484;
 HEAP32[i4 + 8 >> 2] = gb + 857763;
 HEAP32[i4 + 12 >> 2] = i2;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE6AddKeyERK11KeyframeTplIS0_E(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i8 = 0, i9 = 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 64 >> 2] = Math_fround(inf);
 HEAP32[i1 + 60 >> 2] = 0;
 i8 = i1 + 120 | 0;
 i9 = HEAP32[i8 >> 2] | 0;
 i6 = HEAP32[i1 + 132 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 i4 = i9;
 i1 = (i6 * 40 | 0) / 40 | 0;
 L1 : while (1) {
  while (1) {
   if (!i1) break L1;
   i2 = (i1 | 0) / 2 | 0;
   i3 = i4 + (i2 * 40 | 0) | 0;
   if (Math_fround(HEAPF32[i3 >> 2]) < f5) break; else i1 = i2;
  }
  i4 = i3 + 40 | 0;
  i1 = i1 + -1 - i2 | 0;
 }
 if ((i4 | 0) != (i9 + (i6 * 40 | 0) | 0)) if (!(f5 < Math_fround(HEAPF32[i4 >> 2]))) {
  i9 = -1;
  return i9 | 0;
 }
 i9 = __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_(i8, i4, 1, i7) | 0;
 i9 = (i9 - (HEAP32[i8 >> 2] | 0) | 0) / 40 | 0;
 return i9 | 0;
}

function __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 240 | 0;
 i1 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc(i3, i1, gb + 581865 | 0);
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
 __ZN18ScriptingArguments9AddStringEPKc(i3, i1);
 __ZN18ScriptingArguments10AddBooleanEb(i3, (HEAP8[i2 + 16 >> 0] | 0) != 0);
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 __ZN18ScriptingArguments9AddStringEPKc(i3, i1);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i4, 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i1, 0, 0);
 STACKTOP = i5;
 return;
}

function __ZL18ActiveSceneChangedP10UnitySceneS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 256 | 0;
 i3 = i8 + 252 | 0;
 i4 = i8 + 248 | 0;
 i5 = i8;
 i6 = i8 + 240 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i2 + 8 >> 2];
 i9 = (__Z23GetCoreScriptingClassesv() | 0) + 332 | 0;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i7);
 __ZN18ScriptingArguments9AddStructEPKv(i5, i3);
 __ZN18ScriptingArguments9AddStructEPKv(i5, i4);
 HEAP32[i7 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i7, 0) | 0;
 STACKTOP = i8;
 return;
}

function __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetDampenP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 884 >> 2] | 0) + 1068 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 876 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 860 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_S7_S5_(i5, i1, i2, i6, i7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0;
 while (1) {
  i2 = _bitshift64Lshr(i1 | 0, i2 | 0, 21) | 0;
  getTempRet0() | 0;
  i2 = i2 & 524287;
  i3 = (i2 | 0) != 0;
  i4 = i3 ? i5 + ((i2 + 1 | 0) * 24 | 0) | 0 : i5;
  if (i3) if (!(mftCall_iiii(i6 | 0, i5 + (i2 * 24 | 0) | 0, 0, i7 | 0) | 0)) {
   i1 = 10;
   break;
  }
  i1 = (i4 | 0) != (i5 | 0);
  if (i1) if (!(mftCall_iiii(i6 | 0, i4 | 0, 0, i7 | 0) | 0)) {
   i1 = 10;
   break;
  }
  if (i3) {
   i3 = i5 + (i2 * 24 | 0) + 16 | 0;
   __ZZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_S7_S5_(i5, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i6, i7);
  }
  if (!i1) {
   i1 = 10;
   break;
  }
  i2 = i4 + 16 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 if ((i1 | 0) == 10) return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i1 + -116 | 0;
 i7 = i6 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i4 = i6 + 268 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i5 = i6 + 264 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i8 | 0)) {
    i1 = i3;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break L1;
  }
  mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0);
  i8 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i8;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i8 << 2) >> 2];
  i1 = i8;
 } while (0);
 HEAP8[i6 + 276 >> 0] = (i1 | 0) != 0 & 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __ZNSt3__227__num_get_unsigned_integralImEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 do if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i1 = 0;
 } else {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
   break;
  }
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoull_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  do if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 4294967295 | (i3 | 0) == 34) {
   HEAP32[i5 >> 2] = 4;
   i1 = -1;
   break;
  } else break; else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
  } while (0);
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__227__num_get_unsigned_integralIjEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 do if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i1 = 0;
 } else {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
   break;
  }
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoull_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  do if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i1 >>> 0 > 4294967295 | (i3 | 0) == 34) {
   HEAP32[i5 >> 2] = 4;
   i1 = -1;
   break;
  } else break; else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
  } while (0);
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN9Animation15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 HEAP32[gb + 1466576 >> 2] = fb + 4079;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(16, gb + 63320 | 0, 16, gb + 906919 | 0, gb + 1576256 | 0, gb + 906936 | 0, 34) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i2;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1465160 >> 2] = i1;
 HEAP32[gb + 1115296 + 148 >> 2] = fb + 300;
 HEAP32[gb + 1115296 + 220 >> 2] = fb + 301;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 907015 | 0, gb + 1576256 | 0, gb + 907046 | 0, 43) | 0;
 HEAP32[i1 >> 2] = gb + 179088 + 8;
 __Z19pop_allocation_rootv();
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(i1);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 896226 | 0, gb + 907138 | 0, gb + 896315 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 896226 | 0, gb + 907159 | 0, gb + 896272 | 0);
 return;
}

function __ZN8Animator30FindAnimatorControllerPlayableEP18AnimatorController(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 }
 i2 = i1 + 584 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((__ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0) | 0) == (i3 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == ((HEAP32[i2 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0)) {
   i1 = 0;
   i5 = 10;
   break;
  }
 }
 if ((i5 | 0) == 10) return i1 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 return i5 | 0;
}

function __ZN5physx23PxcGetMaterialShapeMeshEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i2, i4, i6, i8) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i7 = 0;
 i7 = HEAP32[i6 + 4480 >> 2] | 0;
 i1 = (i7 | 0) == 0;
 if ((HEAPU16[i4 + 88 >> 1] | 0) < 2) {
  if (i1) return 1;
  i3 = HEAP16[i2 + 34 >> 1] | 0;
  i1 = HEAP16[i4 + 34 >> 1] | 0;
  i2 = 0;
  do {
   HEAP16[i8 + (i2 << 2) >> 1] = i3;
   HEAP16[i8 + (i2 << 2) + 2 >> 1] = i1;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  return 1;
 } else {
  if (i1) return 1;
  i5 = HEAP32[i4 + 80 >> 2] | 0;
  i3 = HEAP32[i4 + 84 >> 2] | 0;
  i1 = HEAP16[i2 + 34 >> 1] | 0;
  i2 = 0;
  do {
   HEAP16[i8 + (i2 << 2) >> 1] = i1;
   HEAP16[i8 + (i2 << 2) + 2 >> 1] = HEAP16[i3 + ((HEAPU16[i5 + (HEAP32[i6 + 384 + (i2 << 6) + 52 >> 2] << 1) >> 1] | 0) << 1) >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i7 >>> 0);
  return 1;
 }
 return 0;
}

function __ZN19TouchPhaseEmulation19UpdateActiveTouchesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 4 | 0;
 i4 = i1 + 12 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i7 >> 2] | 0;
  do if ((HEAP32[i5 + (i1 * 96 | 0) >> 2] | 0) != -1) {
   i6 = i5 + (i1 * 96 | 0) + 36 | 0;
   if (((HEAP32[i6 >> 2] | 0) + -3 | 0) >>> 0 >= 2) {
    i2 = i5 + (i1 * 96 | 0) + 92 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 + -3 | 0) >>> 0 < 2) {
     HEAP32[i5 + (i1 * 96 | 0) + 20 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 24 >> 2] = 0;
     HEAP32[i6 >> 2] = i3;
     HEAP32[i2 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 84 >> 2] = HEAP32[i4 >> 2];
     break;
    } else {
     HEAP32[i6 >> 2] = 2;
     HEAP32[i5 + (i1 * 96 | 0) + 20 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 24 >> 2] = 0;
     HEAP32[i5 + (i1 * 96 | 0) + 84 >> 2] = HEAP32[i4 >> 2];
     break;
    }
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 return;
}

function __ZN15TerrainRenderer23FindNeighborAndRendererER12QuadTreeNodeiRPS_(i2, i1, i3, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i4 = 0, i5 = 0;
 switch (i3 | 0) {
 case 2:
  {
   i6 = __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_(i2, HEAP32[i1 + 24 >> 2] | 0, (HEAP32[i1 + 28 >> 2] | 0) + 1 | 0, HEAP32[i1 + 32 >> 2] | 0, i6) | 0;
   return i6 | 0;
  }
 case 3:
  {
   i6 = __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_(i2, HEAP32[i1 + 24 >> 2] | 0, (HEAP32[i1 + 28 >> 2] | 0) + -1 | 0, HEAP32[i1 + 32 >> 2] | 0, i6) | 0;
   return i6 | 0;
  }
 default:
  {
   i4 = HEAP32[i1 + 24 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i3) {
    i6 = __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_(i2, i4 + -1 | 0, i5, i1, i6) | 0;
    return i6 | 0;
   } else {
    i6 = __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_(i2, i4 + 1 | 0, i5, i1, i6) | 0;
    return i6 | 0;
   }
  }
 }
 return 0;
}

function __ZN11TrailModule17UpdateStripLengthER23ParticleSystemParticles(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1451728 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1451728 | 0, i1);
  i7 = gb + 1451728 | 0;
 } else i7 = 0;
 i5 = i3 + 872 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 if (i6 | 0) {
  i2 = HEAP32[i4 + 800 >> 2] | 0;
  i1 = 0;
  i3 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   i3 = ((i4 | 0) == 0 ? 0 : (i4 << 1) + 4 | 0) + i3 | 0;
   HEAP32[i5 >> 2] = i3;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i7);
 STACKTOP = i8;
 return;
}

function __ZN10SampleClip15UnloadAudioDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return 1;
 i2 = i3 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i1 + 16 >> 2] | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  if ((__ZNK14SoundHandleAPI12GetLoadStateEv(i1) | 0) != 3) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   if ((__ZNK14SoundHandleAPI12GetLoadStateEv(i1) | 0) != 4) {
    if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
    __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 859522 | 0, 0, gb + 854464 | 0, 101, 512, i1, 0, 0);
   }
  }
 }
 __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i3);
 if (!(HEAP8[i3 + 64 >> 0] | 0)) return 1;
 __ZN12SoundManager20RegisterModifiedClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i3);
 return 1;
}

function __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 852 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_LightsModule_CUSTOM_SetUseParticleColorP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 920 >> 2] | 0) + 20 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_LightsModule_CUSTOM_SetSizeAffectsRangeP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 920 >> 2] | 0) + 21 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsWidthP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 286 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_TrailModule_CUSTOM_SetDieWithParticlesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 285 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem18SetSimulationSpaceE29ParticleSystemSimulationSpace(i1, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29Material_CUSTOM_SetBufferImplP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i10 + 12 | 0;
 i4 = i10 + 8 | 0;
 i6 = i10 + 4 | 0;
 i7 = i10;
 if (!i1) {
  i8 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i8) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 HEAP32[i6 >> 2] = i2;
 if (!i3) i9 = 7; else {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if (!i1) i9 = 7; else HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 if ((i9 | 0) == 7) HEAP32[i7 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material16SetComputeBufferEN9ShaderLab16FastPropertyNameE15ComputeBufferID(i8, i4, i5);
 STACKTOP = i10;
 return;
}

function __ZN9Heightmap13CreatePhysicsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = __Z11GetIPhysicsv() | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 i5 = i2 + 100 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 1;
 HEAPF32[i3 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 HEAP16[i3 + 28 >> 1] = 0;
 if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i2, i3) | 0) {
  HEAP32[i5 >> 2] = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 64 >> 2] | 0, i4 | 0, i3 | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
 }
 STACKTOP = i6;
 return;
}

function __ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_(i6, i3, i4, i7, i5, i8) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, f9 = f0, f10 = f0, f11 = f0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) <= (i2 | 0)) {
  i8 = mftCall_iiiiiii(HEAP32[gb + 83940 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0, i6 | 0, i3 | 0, i4 | 0, i7 | 0, i5 | 0, i8 | 0) | 0;
  return i8 | 0;
 }
 if (!(mftCall_iiiiiii(HEAP32[gb + 83940 + (i2 * 28 | 0) + (i1 << 2) >> 2] | 0, i6 | 0, i3 | 0, i5 | 0, i8 | 0, i4 | 0, i7 | 0) | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 f11 = Math_fround(-Math_fround(HEAPF32[i6 >> 2]));
 i7 = i6 + 4 | 0;
 f10 = Math_fround(-Math_fround(HEAPF32[i7 >> 2]));
 i8 = i6 + 8 | 0;
 f9 = Math_fround(-Math_fround(HEAPF32[i8 >> 2]));
 HEAPF32[i6 >> 2] = f11;
 HEAPF32[i7 >> 2] = f10;
 HEAPF32[i8 >> 2] = f9;
 i8 = 1;
 return i8 | 0;
}

function __ZN4FMOD7Channel19set3DDistanceFilterEbff(i4, i1, f2, f3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i5 = i8;
 i1 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868659;
   _printf(gb + 857490 | 0, i6) | 0;
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 868659;
   _printf(gb + 853343 | 0, i7) | 0;
   i7 = 78;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 868659;
 _printf(gb + 853184 | 0, i5) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN4FMOD12ChannelGroup14set3DOcclusionEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i5 = i8;
 i4 = i3;
 i3 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868364;
   _printf(gb + 857490 | 0, i6) | 0;
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 868364;
   _printf(gb + 853343 | 0, i7) | 0;
   i7 = 78;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 868364;
 _printf(gb + 853184 | 0, i5) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN20SoundChannelInstance9isVirtualEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) {
  HEAP8[i2 >> 0] = 1;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = __ZN4FMOD7Channel9isVirtualEPb(i1, i2) | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 324;
 HEAP32[i4 + 8 >> 2] = gb + 856174;
 HEAP32[i4 + 12 >> 2] = i2;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = i1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN20SoundChannelInstance9isPlayingEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) {
  HEAP8[i2 >> 0] = 0;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = __ZN4FMOD7Channel9isPlayingEPb(i1, i2) | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 160;
 HEAP32[i4 + 8 >> 2] = gb + 866418;
 HEAP32[i4 + 12 >> 2] = i2;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i4 = i1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN19RenderEventsContextC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = i2 * 20 | 0;
 i4 = __Znaj(i2 >>> 0 > 214748364 | i4 >>> 0 > 4294967291 ? -1 : i4 + 4 | 0) | 0;
 HEAP32[i4 >> 2] = i2;
 i4 = i4 + 4 | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = i4;
  i6 = i1 + 4 | 0;
  HEAP32[i6 >> 2] = i2;
  STACKTOP = i7;
  return;
 }
 i5 = i4 + (i2 * 20 | 0) | 0;
 i6 = i4;
 do {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 12 >> 2] = 0;
  HEAP32[i6 + 16 >> 2] = 0;
  __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
  i10 = i3;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  i8 = i6 + 4 | 0;
  HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
  HEAP32[i8 + 4 >> 2] = i9;
  i6 = i6 + 20 | 0;
 } while ((i6 | 0) != (i5 | 0));
 HEAP32[i1 >> 2] = i4;
 i10 = i1 + 4 | 0;
 HEAP32[i10 >> 2] = i2;
 STACKTOP = i7;
 return;
}

function __ZN19CharacterController10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (i3 | 0) if (__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i2) | 0) {
  f6 = Math_fround(HEAPF32[i2 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 + 12 >> 2]));
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 + 16 >> 2]));
  f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f7 = Math_fround(f7 + Math_fround(HEAPF32[i2 + 20 >> 2]));
  __ZN19CharacterController9SetRadiusEf(i1, f6 < f7 ? f7 : f6);
  __ZN19CharacterController9SetHeightEf(i1, Math_fround(f5 * Math_fround(2.0)));
  STACKTOP = i4;
  return;
 }
 __ZN19CharacterController9SetRadiusEf(i1, Math_fround(.5));
 __ZN19CharacterController9SetHeightEf(i1, Math_fround(2.0));
 STACKTOP = i4;
 return;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 379423 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 379439 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 72 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 44 | 0, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 842535 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13GfxDeviceGLES24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj(i6, i7, i1, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 i5 = i6 + 8456 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return; else {
  i1 = i5;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) return;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) return;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) return;
 HEAP32[i6 + 7380 >> 2] = 15471;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 608 >> 2] | 0, i6 | 0);
 __ZN7ApiGLES18DrawArraysIndirectE16GfxPrimitiveTypejj(i6 + 4620 | 0, i7, HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i8);
 return;
}

function __Z62ParticleSystem_MainModule_CUSTOM_SetRandomizeRotationDirectionP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 2540 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 896 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_InheritVelocityModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 872 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _UNITY_png_write_IEND(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  i2 = i1 + 204 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = i1 | 16;
  HEAP32[i2 >> 2] = i1;
  STACKTOP = i3;
  return;
 }
 i4 = i1 + 656 | 0;
 HEAP32[i4 >> 2] = 34;
 i5 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i5 >> 0] = 73;
 HEAP8[i2 + 5 >> 0] = 69;
 HEAP8[i2 + 6 >> 0] = 78;
 HEAP8[i2 + 7 >> 0] = 68;
 _UNITY_png_write_data(i1, i2, 8);
 HEAP32[i1 + 372 >> 2] = 1229278788;
 _UNITY_png_reset_crc(i1);
 _UNITY_png_calculate_crc(i1, i5, 4);
 HEAP32[i4 >> 2] = 130;
 i4 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i2 >> 0] = i4 >>> 24;
 HEAP8[i2 + 1 >> 0] = i4 >>> 16;
 HEAP8[i2 + 2 >> 0] = i4 >>> 8;
 HEAP8[i2 + 3 >> 0] = i4;
 _UNITY_png_write_data(i1, i2, 4);
 i2 = i1 + 204 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = i1 | 16;
 HEAP32[i2 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function _jpeg_suppress_tables(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 128 >> 0] = i3;
 i1 = HEAP32[i2 + 76 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 128 >> 0] = i3;
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 128 >> 0] = i3;
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 128 >> 0] = i3;
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 108 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if (i1 | 0) HEAP8[i1 + 273 >> 0] = i3;
 i1 = HEAP32[i2 + 116 >> 2] | 0;
 if (!i1) return;
 HEAP8[i1 + 273 >> 0] = i3;
 return;
}

function __ZNK14NavMeshManager24GetNavMeshDataInstanceIDEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 if ((i3 | 0) > -1) {
  if (i3) {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i3 | 0) > 1) {
     i3 = i3 + -1 | 0;
     i2 = i1;
    } else break;
   }
  }
 } else {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) i2 = i1; else break;
   } else while (1) {
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i3 | 0) < -1) {
    i2 = i1;
    i3 = i3 + 1 | 0;
   } else break;
  }
 }
 return HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + 4 >> 2] | 0;
}

function __ZN9GfxDevice19EndGeometryJobFrameEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 i5 = i4 + 4412 | 0;
 if ((HEAP16[gb + 1157644 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157644 | 0, i1);
  i2 = gb + 1157644 | 0;
 } else i2 = 0;
 i3 = i4 + 4424 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i5, i4, i1);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (!i2) {
  i5 = i4 + 4448 | 0;
  __ZN17UniqueIDGenerator17DestroyAllIndicesEv(i5);
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 i5 = i4 + 4448 | 0;
 __ZN17UniqueIDGenerator17DestroyAllIndicesEv(i5);
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd6Socket4readEPhj(i1, i3, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i7 = i1 + 14 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = i1 + 4 | 0;
 while (1) {
  i1 = _recv(HEAP32[i2 >> 2] | 0, i3, i5, 0) | 0;
  if ((i1 | 0) >= 0) {
   i2 = 6;
   break;
  }
  if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 105) {
   i2 = 7;
   break;
  }
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 4;
  _getsockopt(HEAP32[i2 >> 2] | 0, 1, 8, i4, i6) | 0;
  HEAP32[i4 >> 2] = i5;
  if (_setsockopt(HEAP32[i2 >> 2] | 0, 1, 8, i4, 4) | 0) {
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 6) if ((i1 | 0) < 1) i2 = 7;
 if ((i2 | 0) == 7) {
  HEAP8[i7 >> 0] = 0;
  i1 = 0;
 }
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx13GuMeshFactory7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 44 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i3 + 12 | 0;
  do {
   i4 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  } while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i1 = i3 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i3 + 52 | 0;
  do {
   i4 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  } while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i1 = i3 + 124 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = i4 + 4 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(i4 | 0, i3 | 0);
  return;
 }
 i2 = i3 + 92 | 0;
 do {
  i4 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 } while ((HEAP32[i1 >> 2] | 0) != 0);
 i4 = HEAP32[i3 >> 2] | 0;
 i4 = i4 + 4 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(i4 | 0, i3 | 0);
 return;
}

function __ZN16LightmapSettingsD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 43312 + 8;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63160 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 __ZN21EnlightenSceneMappingD2Ev(i3 + 100 | 0);
 i1 = i3 + 56 | 0;
 if ((HEAP32[i3 + 72 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 60 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 36 | 0;
 if ((HEAP32[i3 + 52 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 28344 + 8;
  HEAP32[i3 >> 2] = gb + 28496 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 40 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 28344 + 8;
 HEAP32[i3 >> 2] = gb + 28496 + 8;
 return;
}

function __ZL22Transfer_ManagedObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 20 | 0;
 i6 = i3;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 i9 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 i2 = i8 + (i7 << 6) | 0;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 8 >> 2] = i2;
 i2 = i7 << 6 >> 6;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN9JSONWrite8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags(i5, i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __Z53ParticleSystem_ExternalForcesModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 880 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_MainModule_CUSTOM_SetStartRotation3DP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 44 >> 2] | 0) + 2553 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z36GameObject_CUSTOM_GetComponentByNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = __ZN9Scripting42GetScriptingWrapperOfComponentOfGameObjectER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i1, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z27Graphics_CUSTOM_DrawTextureR32MonoInternalDrawTextureArguments(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 4 | 0;
 i8 = i10;
 i1 = HEAP32[i7 + 16 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i6 = HEAP32[i7 + 36 >> 2] | 0;
 i3 = HEAP32[i7 + 40 >> 2] | 0;
 i4 = HEAP32[i7 + 44 >> 2] | 0;
 i5 = HEAP32[i7 + 48 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i7 + 52 >> 2];
 i1 = HEAP32[i7 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i11 = HEAP32[i7 + 60 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiii11ColorRGBA32P8Materiali(i7, i2, i7 + 20 | 0, i6, i3, i4, i5, i9, i1, i11);
 STACKTOP = i10;
 return;
}

function __Z26Animator_CUSTOM_GetFloatIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, f7 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator8GetFloatEiRfb(i1, i4, i5, 0) | 0;
 if ((i1 | 0) == 1) {
  f7 = Math_fround(HEAPF32[i5 >> 2]);
  STACKTOP = i6;
  return Math_fround(f7);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 f7 = Math_fround(HEAPF32[i5 >> 2]);
 STACKTOP = i6;
 return Math_fround(f7);
}

function _UNITY_tt_face_load_maxp(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i2 + 260 | 0;
 i1 = mftCall_iiiii(HEAP32[i2 + 508 >> 2] | 0, i2 | 0, 1835104368, i6 | 0, 0) | 0;
 if (i1 | 0) {
  i7 = i1;
  return i7 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadFields(i6, gb + 223744 | 0, i7) | 0;
 if (i1 | 0) {
  i7 = i1;
  return i7 | 0;
 }
 i3 = i2 + 276 | 0;
 i4 = i2 + 280 | 0;
 i5 = i2 + 290 | 0;
 i1 = i2 + 266 | 0;
 i2 = i1 + 26 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if ((HEAP32[i7 >> 2] | 0) <= 65535) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = _UNITY_FT_Stream_ReadFields(i6, gb + 223760 | 0, i7) | 0;
 if (i1 | 0) {
  i7 = i1;
  return i7 | 0;
 }
 if ((HEAPU16[i4 >> 1] | 0) < 64) HEAP16[i4 >> 1] = 64;
 if ((HEAPU16[i3 >> 1] | 0) > 65531) HEAP16[i3 >> 1] = -5;
 if ((HEAPU16[i5 >> 1] | 0) <= 100) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP16[i5 >> 1] = 100;
 i7 = 0;
 return i7 | 0;
}

function _UNITY_png_set_background_fixed(i5, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i10 = 0;
 if (!i5) return;
 i10 = i5 + 208 | 0;
 i1 = HEAP32[i10 >> 2] | 0;
 if (i1 & 64 | 0) {
  _UNITY_png_app_error(i5, gb + 353836 | 0);
  return;
 }
 i1 = i1 | 16384;
 HEAP32[i10 >> 2] = i1;
 if ((i6 | 0) == 0 | (i7 | 0) == 0) return;
 i2 = i5 + 212 | 0;
 i3 = HEAP32[i2 >> 2] & -8650881;
 i4 = i3 | 262272;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i10 >> 2] = i1 & -8193;
 i10 = i5 + 448 | 0;
 HEAP16[i10 >> 1] = HEAP16[i6 >> 1] | 0;
 HEAP16[i10 + 2 >> 1] = HEAP16[i6 + 2 >> 1] | 0;
 HEAP16[i10 + 4 >> 1] = HEAP16[i6 + 4 >> 1] | 0;
 HEAP16[i10 + 6 >> 1] = HEAP16[i6 + 6 >> 1] | 0;
 HEAP16[i10 + 8 >> 1] = HEAP16[i6 + 8 >> 1] | 0;
 HEAP32[i5 + 444 >> 2] = i9;
 HEAP8[i5 + 442 >> 0] = i7;
 if (!i8) {
  HEAP32[i2 >> 2] = i4 & -8388865;
  return;
 } else {
  HEAP32[i2 >> 2] = i3 | 262528;
  return;
 }
}

function _alloc_large(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 7 & -8;
 i3 = i2 + 19 | 0;
 if (i3 >>> 0 > 1e9) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 54;
  HEAP32[i1 + 24 >> 2] = 3;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
 }
 if (i5 >>> 0 > 1) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 14;
  HEAP32[i1 + 24 >> 2] = i5;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
 }
 i1 = _jpeg_get_large(i4, i3) | 0;
 if (!i1) {
  i7 = HEAP32[i4 >> 2] | 0;
  HEAP32[i7 + 20 >> 2] = 54;
  HEAP32[i7 + 24 >> 2] = 4;
  mftCall_vi(HEAP32[i7 >> 2] | 0, i4 | 0);
 }
 i7 = i6 + 76 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i3;
 i6 = i6 + 60 + (i5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = i1;
 i6 = i1 + 12 | 0;
 i7 = i6 & 7;
 return ((i7 | 0) == 0 ? i6 : i6 + (8 - i7) | 0) | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) < (i2 | 0)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) < (i2 | 0)) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if (i1 >>> 0 < i2 >>> 0) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) < (i2 | 0)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) < (i2 | 0)) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if (i1 >>> 0 < i2 >>> 0) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) < (i2 | 0)) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i5 >> 2] = i2;
   HEAP32[i4 >> 2] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP32[i5 >> 2] | 0;
   i3 = HEAP32[i8 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i8 >> 2] = i2;
    HEAP32[i5 >> 2] = i3;
    i1 = HEAP32[i8 >> 2] | 0;
    i2 = HEAP32[i7 >> 2] | 0;
    if ((i1 | 0) < (i2 | 0)) {
     HEAP32[i7 >> 2] = i1;
     HEAP32[i8 >> 2] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_(i7, i8, i5, i4, i3, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0;
 i6 = __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_(i7, i8, i5, i4, i1) | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 if ((i1 & 255) < (i2 & 255)) {
  HEAP8[i4 >> 0] = i1;
  HEAP8[i3 >> 0] = i2;
  i1 = i6 + 1 | 0;
  i2 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i5 >> 0] | 0;
  if ((i2 & 255) < (i3 & 255)) {
   HEAP8[i5 >> 0] = i2;
   HEAP8[i4 >> 0] = i3;
   i1 = i6 + 2 | 0;
   i2 = HEAP8[i5 >> 0] | 0;
   i3 = HEAP8[i8 >> 0] | 0;
   if ((i2 & 255) < (i3 & 255)) {
    HEAP8[i8 >> 0] = i2;
    HEAP8[i5 >> 0] = i3;
    i1 = HEAP8[i8 >> 0] | 0;
    i2 = HEAP8[i7 >> 0] | 0;
    if ((i1 & 255) < (i2 & 255)) {
     HEAP8[i7 >> 0] = i1;
     HEAP8[i8 >> 0] = i2;
     i1 = i6 + 4 | 0;
    } else i1 = i6 + 3 | 0;
   }
  }
 } else i1 = i6;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 83;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN9b2Fixture13SetFilterDataERK8b2Filter(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i5 + 52 | 0;
 HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
 HEAP16[i3 + 2 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
 HEAP16[i3 + 4 >> 1] = HEAP16[i1 + 4 >> 1] | 0;
 i3 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 if (i1 | 0) do {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if ((HEAP32[i2 + 48 >> 2] | 0) == (i5 | 0) ? 1 : (HEAP32[i2 + 52 >> 2] | 0) == (i5 | 0)) {
   i4 = i2 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 8;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 102872 | 0;
 i4 = i5 + 48 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i2 = i5 + 44 | 0;
 i1 = 0;
 do {
  __ZN12b2BroadPhase10TouchProxyEi(i3, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 28 | 0) + 24 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 return;
}

function __ZN7mecanim9animation23CreateBlendTreeConstantEjRNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
 i6 = i3 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = 1;
 i5 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 4, 4) | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i6;
 i5 = i5 | 0 ? i5 - i4 | 0 : 0;
 HEAP32[i6 >> 2] = i5;
 i4 = i5 + i4 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 i5 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = i1;
 HEAPF32[i2 + 36 >> 2] = Math_fround(1.0);
 HEAP8[i2 + 44 >> 0] = 0;
 HEAPF32[i2 + 40 >> 2] = Math_fround(0.0);
 HEAP32[i4 >> 2] = i2 | 0 ? i2 - i4 | 0 : 0;
 return i3 | 0;
}

function __ZN13RuntimeStaticI14dynamic_bitsetE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(20, i3, i4, gb + 1041912 | 0, 65) | 0;
  i5 = gb + 63160 | 0;
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = i4;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i5 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(20, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i2 = gb + 63160 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i5;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i5;
  return;
 }
}

function __Z49ParticleSystem_NoiseModule_CUSTOM_SetRemapEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 888 >> 2] | 0) + 1884 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function mftCall_vifiiiiiiiiiiiiiiiiii(i21, i1, d2, i13, i14, i15, i16, i17, i18, i19, i20, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12) {
 i21 = i21 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 if ((i21 | 0) >= (fb | 0) & (i21 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiii[i21 - fb & 7](i1 | 0, Math_fround(d2), i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
  return;
 }
 ftCall_vifiiiiiiiiiiiiiiiiii(i21 | 0, i1 | 0, +d2, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i18 | 0, i19 | 0, i20 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0);
}

function _atoll(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 while (1) {
  i2 = HEAP8[i1 >> 0] | 0;
  i3 = i2 << 24 >> 24;
  i4 = i1 + 1 | 0;
  if (!(_isspace(i3) | 0)) break; else i1 = i4;
 }
 switch (i3 | 0) {
 case 45:
  {
   i1 = 1;
   i5 = 5;
   break;
  }
 case 43:
  {
   i1 = 0;
   i5 = 5;
   break;
  }
 default:
  i6 = 0;
 }
 if ((i5 | 0) == 5) {
  i6 = i1;
  i1 = i4;
  i2 = HEAP8[i4 >> 0] | 0;
 }
 i4 = (i2 << 24 >> 24) + -48 | 0;
 if (i4 >>> 0 < 10) {
  i2 = 0;
  i3 = 0;
  do {
   i2 = ___muldi3(i2 | 0, i3 | 0, 10, 0) | 0;
   i1 = i1 + 1 | 0;
   i2 = _i64Subtract(i2 | 0, getTempRet0() | 0, i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0) | 0;
   i3 = getTempRet0() | 0;
   i4 = (HEAP8[i1 >> 0] | 0) + -48 | 0;
  } while (i4 >>> 0 < 10);
  i1 = i3;
 } else {
  i2 = 0;
  i1 = 0;
 }
 i5 = (i6 | 0) != 0;
 i6 = _i64Subtract(0, 0, i2 | 0, i1 | 0) | 0;
 i4 = getTempRet0() | 0;
 setTempRet0((i5 ? i1 : i4) | 0);
 return (i5 ? i2 : i6) | 0;
}

function __ZNK14SerializedFile11IsAvailableEx(i1, i7, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = i6 - i2 | 0;
 if (!i1) i1 = i2; else {
  i5 = (i1 | 0) / 24 | 0;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 * 24 | 0) | 0;
   i3 = i4;
   i10 = HEAP32[i3 + 4 >> 2] | 0;
   i3 = (i10 | 0) < (i8 | 0) | ((i10 | 0) == (i8 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i7 >>> 0 : 0);
   i4 = i4 + 24 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) {
  i10 = i1;
  i9 = HEAP32[i10 + 4 >> 2] | 0;
  if (!((i9 | 0) > (i8 | 0) | ((i9 | 0) == (i8 | 0) ? (HEAP32[i10 >> 2] | 0) >>> 0 > i7 >>> 0 : 0))) {
   i10 = i1;
   i10 = (i10 | 0) != (i6 | 0);
   return i10 | 0;
  }
 }
 i10 = i6;
 i10 = (i10 | 0) != (i6 | 0);
 return i10 | 0;
}

function __ZN8VRDevice17SetShowDeviceViewEb(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 4 | 0;
 i5 = i7;
 i2 = i6 + 302 | 0;
 if ((HEAPU8[i2 >> 0] | 0) == (i1 & 1 | 0)) {
  STACKTOP = i7;
  return;
 }
 HEAP8[i2 >> 0] = i1 & 1;
 HEAP8[i6 + 301 >> 0] = 1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = HEAPU8[i2 >> 0] | 0;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i3);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i6 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 12, i4 | 0);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return;
}

function __ZN8LODGroup18UpdateEnabledStateEb(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 68 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i8 = i5 + 88 | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  if (i2) {
   i4 = i5 + 76 | 0;
   i3 = 0;
   i1 = i2;
   do {
    i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
    HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
    i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
    if ((i2 | 0) != -1) {
     i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i1 + 4 >> 2] = 0;
     i1 = HEAP32[i8 >> 2] | 0;
    }
    i3 = i3 + 1 | 0;
   } while (i3 >>> 0 < i1 >>> 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i8 >> 2] = 0;
  if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
  HEAP32[i7 >> 2] = -1;
 }
 if (!i6) return;
 __ZN8LODGroup6CreateEv(i5);
 return;
}

function __ZN4FMOD5Sound19set3DMinMaxDistanceEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i5 = i8;
 i4 = i3;
 i3 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 212 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 858934;
   _printf(gb + 857490 | 0, i6) | 0;
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 858934;
   _printf(gb + 853343 | 0, i7) | 0;
   i7 = 78;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 858934;
 _printf(gb + 853184 | 0, i5) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 900 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z49ParticleSystem_NoiseModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 888 >> 2] | 0) + 804 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function ___ldexp_cexpf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(+Math_exp(+Math_fround(f7 + Math_fround(-162.889587))));
 i2 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 f7 = (HEAP32[tempDoublePtr >> 2] = i2 & 8388607 | 2130706432, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i2 = i3 + -19 + (i2 >>> 23) | 0;
 i3 = (i2 | 0) / 2 | 0;
 f6 = (HEAP32[tempDoublePtr >> 2] = (i3 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f5 = (HEAP32[tempDoublePtr >> 2] = (i2 - i3 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(+Math_sin(+f8)) * f7) * f6) * f5);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(Math_fround(Math_fround(+Math_cos(+f8)) * f7) * f6) * f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIKfEEvRT_(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i10 = 0;
 i10 = i9 + 4 | 0;
 i2 = HEAP32[i10 >> 2] | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 i3 = (i2 - i1 >> 2) + 1 | 0;
 if (i3 >>> 0 > 1073741823) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i9);
  i1 = HEAP32[i9 >> 2] | 0;
  i2 = HEAP32[i10 >> 2] | 0;
 }
 i8 = i9 + 8 | 0;
 i6 = (HEAP32[i8 >> 2] | 0) - i1 | 0;
 i4 = i6 >> 1;
 i4 = i6 >> 2 >>> 0 < 536870911 ? (i4 >>> 0 < i3 >>> 0 ? i3 : i4) : 1073741823;
 if (!i4) i6 = 0; else i6 = __Znwj(i4 << 2) | 0;
 i5 = i6 + (i2 - i1 >> 2 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 i2 = i2 - i1 | 0;
 i3 = i5 + (0 - (i2 >> 2) << 2) | 0;
 if ((i2 | 0) > 0) _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i5 + 4;
 HEAP32[i8 >> 2] = i6 + (i4 << 2);
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN6Avatar16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i5) return;
 i6 = i5 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i7 = i6;
 i4 = i1 + i7 + 40 | 0;
 i4 = HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0;
 if (!i4) return;
 i1 = i5 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 i3 = i5 + 28 | 0;
 i2 = i2 + 32 | 0;
 i1 = i4 << 2;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
 if ((i2 | 0) != (i2 + (i4 << 2) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 i1 = i3;
 i2 = i2 | 0 ? i2 - i1 | 0 : 0;
 HEAP32[i3 >> 2] = i2;
 i4 = (HEAP32[i6 >> 2] | 0) + i7 + 40 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_((i2 | 0) == 0 ? 0 : i2 + i1 | 0, (i6 | 0) == 0 ? 0 : i4 + i6 | 0, (i7 | 0) == 0 ? 0 : i7 + i5 | 0);
 return;
}

function __ZN5physx13GuMeshFactoryD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 93264 + 8;
 i2 = HEAP32[i3 + 136 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 128 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = i3 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 4 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_(i7, i1, i2, i3, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 857570;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 857570;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857570;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN12ScriptMapper23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 if (HEAP32[i3 >> 2] & 33554432 | 0) if (!(HEAP8[i1 + 28 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i5 = i1 + 36 | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 i6 = i3 + 16 | 0;
 i7 = i3 + 36 | 0;
 i4 = i3 + 40 | 0;
 while (1) {
  i1 = i2 + 16 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i1 >> 2] = i3;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i2 = i1 + 80 | 0;
 i6 = i5 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i7 = i5 + 24 | 0;
 if (i4 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i4;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i2, 4);
 __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 88 | 0, i5);
 __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 176 | 0, i5);
 i1 = i1 + 84 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 2 | 0;
 if (i3 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
  HEAP16[i2 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i6 >> 2] = i3;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 }
}

function __Z64ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsDeprecatedP12Il2CppObjectS0_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 40) | 0;
  return __ZNK14ParticleSystem26GetCollisionEventsExternalEiP26MonoParticleCollisionEventi(i4, i1, i2, __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0) | 0;
 }
 return 0;
}

function __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipVP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 864 >> 2] | 0) + 568 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipUP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 864 >> 2] | 0) + 564 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_SubEmittersModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 916 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 892 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29ConvertDXT5nmNormalMapToPlainR14ImageReference(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 i3 = Math_imul(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
 if ((i3 | 0) <= 0) return;
 i2 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 while (1) {
  i4 = i1 + 3 | 0;
  i6 = HEAP8[i4 >> 0] | 0;
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(i6 & 255) / Math_fround(255.0)) * Math_fround(2.0)) + Math_fround(-1.0));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0)) * Math_fround(2.0)) + Math_fround(-1.0));
  i5 = ~~Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f8 * f8)) - Math_fround(f7 * f7)))) * Math_fround(255.0)) >>> 0;
  HEAP8[i1 >> 0] = i6;
  HEAP8[i1 + 2 >> 0] = i5 >>> 0 > 255 ? 255 : i5;
  HEAP8[i4 >> 0] = -1;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  i7 = _llvm_bswap_i32(i7 | 0) | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function _UNITY_FT_GlyphLoader_Done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 24 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 28 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 32 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 40 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 52 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = i1 + 20 | 0;
 HEAP16[i1 + 22 >> 1] = 0;
 HEAP16[i4 >> 1] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 i3 = i1 + 56 | 0;
 i5 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 _UNITY_ft_mem_free(i2, i1);
 return;
}

function _UNITY_FT_Get_Name_Index(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(i6 | 0 ? (HEAP32[i5 + 8 >> 2] & 512 | 0) != 0 : 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = i5 + 128 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 switch (i1 | 0) {
 case 0:
  {
   i2 = 4;
   break;
  }
 case -2:
  {
   i6 = 0;
   return i6 | 0;
  }
 default:
  {}
 }
 do if ((i2 | 0) == 4) {
  i1 = HEAP32[i5 + 96 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
  if (!i2) {
   HEAP32[i3 >> 2] = -2;
   i6 = 0;
   return i6 | 0;
  } else {
   i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1007761 | 0) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] = i1 | 0 ? i1 : -2;
   if (!i1) i1 = 0; else break;
   return i1 | 0;
  }
 } while (0);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
 return i6 | 0;
}

function __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = i1 + -128 | 0;
 i8 = HEAP32[i7 + 72 >> 2] | 0;
 i9 = (i8 | 0) == 0;
 if (!i9) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i8 + 4 >> 2] | 0);
 i5 = i7 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i10 = i7 + 20 | 0;
 i1 = i6;
 i3 = (HEAP32[i10 >> 2] | 0) - i1 | 0;
 i4 = HEAP32[i7 + 36 >> 2] | 0;
 if (i4) {
  i1 = i7 + 32 | 0;
  i2 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i6 | 0, i3 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i10 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0);
 if (i9) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i8 + 4 >> 2] | 0);
 return;
}

function __ZNK5Umbra9Matrix4x38getScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5))));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f4 * f4))));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f3 * f3))));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZNK5Umbra9Matrix3x38getScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5))));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f7 * f7)) + Math_fround(f4 * f4))));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f3 * f3))));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN9Rigidbody15SetCenterOfMassERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i2 + 52 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 124 >> 2] | 0, i4 | 0, i7 | 0);
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 20 >> 2] = i7;
 HEAP32[i4 + 24 >> 2] = i6;
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP8[i2 + 82 >> 0] = 0;
 __ZN9Rigidbody22UpdateMassDistributionEv(i2);
 i1 = i2 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 i7 = __Z12GetIVehiclesv() | 0;
 mftCall_viif(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i2 + 68 >> 2]));
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation17ComputeRootMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKNS0_12MotionOutputERNS_10ValueArrayESB_SB_RNS_8skeleton13SkeletonPoseTIN4math4trsXEEESH_b(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if (i9) {
  __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i1, i2, i3 + 108 | 0, i5, i7, i8);
  __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i1, i2, i3 + 148 | 0, i6, i7, i8);
 }
 __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_(i1, i2, i3 + 68 | 0, i4, i7, i8);
 return;
}

function __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0, gb + 766896 | 0, gb + 838004 | 0, 543) | 0;
 }
 i1 = HEAP32[i7 + 8 >> 2] | 0;
 i3 = i4 + i1 | 0;
 i5 = i7 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i1 = i4;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i7 + 12 | 0;
 if ((i2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) < 0) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[HEAP32[i7 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, i2 | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 * 20 | 0, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 20 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
   i1 = i1 + 20 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 20 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN4FMOD7Channel16setSpeakerLevelsE12FMOD_SPEAKERPfi(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868726;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868726;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868726;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD7Channel16getSpeakerLevelsE12FMOD_SPEAKERPfi(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868599;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868599;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868599;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD6Reverb15get3DAttributesEP11FMOD_VECTORPfS3_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868379;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868379;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868379;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z47ParticleSystem_TrailModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 284 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_MainModule_CUSTOM_SetStartSize3DP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 44 >> 2] | 0) + 2552 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ComputeShader_CUSTOM_Internal_DispatchIndirectP12Il2CppObjectiS0_j(i1, i4, i2, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 8 | 0;
 i8 = i9;
 i6 = i9 + 4 | 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i8); else {
  HEAP32[i6 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  __ZN13ComputeShader21DispatchComputeShaderEj15ComputeBufferIDj(i7, i4, i3, i5) | 0;
  STACKTOP = i9;
  return;
 }
}

function __Z10DestripifyItjEvPKT_iPT0_i(i8, i2, i9, i1) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i2 + -2 | 0;
 if ((i2 | 0) <= 2) return;
 i6 = 0;
 i1 = 0;
 i2 = HEAP16[i8 >> 1] | 0;
 L4 : while (1) {
  while (1) {
   i4 = i1 + 1 | 0;
   i5 = HEAP16[i8 + (i4 << 1) >> 1] | 0;
   if (i2 << 16 >> 16 != i5 << 16 >> 16) {
    i3 = HEAP16[i8 + (i1 + 2 << 1) >> 1] | 0;
    if (!(i2 << 16 >> 16 == i3 << 16 >> 16 ? 1 : i5 << 16 >> 16 == i3 << 16 >> 16)) break;
   }
   if ((i4 | 0) < (i7 | 0)) {
    i1 = i4;
    i2 = i5;
   } else {
    i1 = 4;
    break L4;
   }
  }
  i1 = (i1 & 1 | 0) == 0;
  HEAP32[i9 + (i6 << 2) >> 2] = (i1 ? i2 : i5) & 65535;
  HEAP32[i9 + (i6 + 1 << 2) >> 2] = (i1 ? i5 : i2) & 65535;
  HEAP32[i9 + (i6 + 2 << 2) >> 2] = i3 & 65535;
  if ((i4 | 0) < (i7 | 0)) {
   i6 = i6 + 3 | 0;
   i1 = i4;
   i2 = i5;
  } else {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return;
}

function _UNITY_FT_Stroker_New(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (!i2) {
  i5 = 33;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!i3) {
  i5 = 6;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 132, i1) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 + 128 >> 2] = i2;
  i2 = i5 + 64 | 0;
  HEAP32[i5 + 88 >> 2] = i4;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i5 + 84 >> 2] = -1;
  HEAP8[i5 + 92 >> 0] = 0;
  i2 = i5 + 96 | 0;
  HEAP32[i5 + 120 >> 2] = i4;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i5 + 116 >> 2] = -1;
  HEAP8[i5 + 124 >> 0] = 0;
 }
 HEAP32[i3 >> 2] = i5;
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK22GenericPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i5, i1, i4, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i3 = ~i2;
 } else i3 = 0;
 if (i4) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = HEAP32[i5 + 260 >> 2] | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 } else i1 = 0;
 while (1) {
  if ((HEAP32[i5 + 4 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i7 = 10;
   break;
  }
 }
 if ((i7 | 0) == 10) return i1 | 0;
 if ((i1 | 0) == -1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i6 + 4 >> 2] = i3;
 i7 = 1;
 return i7 | 0;
}

function __ZN5audio5mixer25FindAudioEffectDefinitionERKNS0_18AudioMixerConstantEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i1 + -1e3 | 0;
 i1 = i2 + 64 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 if (!i3) i4 = i1; else {
  do {
   i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
  i4 = i1;
 }
 HEAP32[i6 >> 2] = 0;
 i5 = __Z25GetAudioEffectDefinitionsPi(i6) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) > 0) i2 = 0; else {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 while (1) {
  i1 = HEAP32[i5 + (i2 << 2) >> 2] | 0;
  i2 = i2 + 1 | 0;
  if (!(_strcmp((HEAP32[i1 >> 2] | 0) + 128 | 0, i4) | 0)) {
   i2 = 6;
   break;
  }
  if ((i2 | 0) >= (i3 | 0)) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZN5Umbra9Matrix3x39transposeERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i2 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i4 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i4 >> 2] = i1;
  i4 = i2 + 8 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i3 = i2 + 24 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i1;
  i3 = i2 + 20 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 28 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 24 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 20 >> 2];
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
  return;
 }
}

function __ZN4FMOD7Channel14set3DOcclusionEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i5 = i8;
 i4 = i3;
 i3 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868364;
   _printf(gb + 857490 | 0, i6) | 0;
   HEAP32[i7 >> 2] = 78;
   HEAP32[i7 + 4 >> 2] = gb + 868364;
   _printf(gb + 853343 | 0, i7) | 0;
   i7 = 78;
   STACKTOP = i8;
   return i7 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 868364;
 _printf(gb + 853184 | 0, i5) | 0;
 i7 = 36;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN19AudioHighPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, i1, 16, gb + 1048932 | 0, 0, gb + 873141 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 171092 + 8;
 HEAPF32[i4 + 44 >> 2] = Math_fround(5.0e3);
 HEAPF32[i4 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i4 + 36 >> 2] = 5;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12CullingGroup10SendEventsEPK17CullingGroupEventj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 248 | 0;
 i6 = i4;
 i7 = i4 + 240 | 0;
 i10 = (__Z23GetCoreScriptingClassesv() | 0) + 136 | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i6, i5);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i6, __Z29scripting_gchandle_get_targetj(HEAP32[i1 >> 2] | 0) | 0);
 __ZN18ScriptingArguments9AddIntPtrEPv(i6, i2);
 __ZN18ScriptingArguments6AddIntEi(i6, i3);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i6, i5, 0) | 0;
 STACKTOP = i4;
 return;
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUVChannelMaskP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 864 >> 2] | 0) + 560 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetAnimationTypeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 864 >> 2] | 0) + 544 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_CollisionModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 904 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z12ReadFromFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvyj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 1076 | 0;
 i7 = i9 + 8 | 0;
 i8 = i9;
 __ZN15FileSystemEntryC2EPKc(i6, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN12FileAccessorC2Ev(i7);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i7, i6, 0, 0) | 0)) {
  i8 = 0;
  __ZN12FileAccessorD2Ev(i7);
  __ZN13FileEntryDataD2Ev(i6);
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = i8;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i8 = __ZN12FileAccessor4ReadEyyPvPy(i7, i3, i4, i5, 0, i2, i8) | 0;
 __ZN12FileAccessor5CloseEv(i7) | 0;
 __ZN12FileAccessorD2Ev(i7);
 __ZN13FileEntryDataD2Ev(i6);
 STACKTOP = i9;
 return i8 | 0;
}

function _UNITY_FT_Stream_ReadULongLE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i4 >> 2] = 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 + 3 | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  if (!i5) {
   i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i7 = 6;
  } else {
   if ((mftCall_iiiii(i5 | 0, i3 | 0, i2 | 0, i1 | 0, 4) | 0) != 4) break;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = 6;
  }
  if ((i7 | 0) == 6) {
   i3 = (HEAPU8[i1 + 2 >> 0] | 0) << 16 | (HEAPU8[i1 + 3 >> 0] | 0) << 24 | (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0);
   i1 = i2;
  }
  HEAP32[i6 >> 2] = i1 + 4;
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 85;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function _UNITY_FT_Create_Class_pshinter_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 36, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _pshinter_module_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 168;
  HEAP32[i5 + 8 >> 2] = gb + 1006904;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = HEAP32[i1 + 200 >> 2];
  HEAP32[i5 + 24 >> 2] = fb + 2628;
  HEAP32[i5 + 28 >> 2] = fb + 3846;
  HEAP32[i5 + 32 >> 2] = 0;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _open_wmemstream(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = _malloc(144) | 0;
 if (!i1) i1 = 0; else {
  _memset(i1 + 4 | 0, 0, 140) | 0;
  i4 = i1 + 112 | 0;
  HEAP32[i1 + 84 >> 2] = i4;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 + 116 >> 2] = i3;
  i3 = i1 + 120 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i1 >> 2] = 4;
  HEAP32[i1 + 60 >> 2] = -1;
  HEAP32[i1 + 44 >> 2] = i1 + 144;
  HEAP32[i1 + 48 >> 2] = 0;
  HEAP8[i1 + 75 >> 0] = -1;
  HEAP32[i1 + 36 >> 2] = fb + 495;
  HEAP32[i1 + 40 >> 2] = fb + 496;
  HEAP32[i1 + 12 >> 2] = fb + 2794;
  if (!(HEAP32[gb + 1469464 + 4 >> 2] | 0)) HEAP32[i1 + 76 >> 2] = -1;
  ___lock(gb + 1469464 + 28 | 0);
  i2 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
  HEAP32[i1 + 56 >> 2] = i2;
  if (i2 | 0) HEAP32[i2 + 52 >> 2] = i1;
  HEAP32[gb + 1469464 + 24 >> 2] = i1;
  ___unlock(gb + 1469464 + 28 | 0);
 }
 return i1 | 0;
}

function _bulk_free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + (i2 << 2) | 0;
 if (!i2) return 0;
 L3 : while (1) {
  i3 = HEAP32[i1 >> 2] | 0;
  do if (!i3) i1 = i1 + 4 | 0; else {
   i4 = i3 + -8 | 0;
   i5 = i3 + -4 | 0;
   i6 = HEAP32[i5 >> 2] | 0;
   i7 = i6 & -8;
   HEAP32[i1 >> 2] = 0;
   if ((i6 & 3 | 0) == 1 ? 1 : i4 >>> 0 < (HEAP32[gb + 1470404 + 16 >> 2] | 0) >>> 0) {
    i1 = 9;
    break L3;
   }
   i1 = i1 + 4 | 0;
   i2 = i4 + i7 | 0;
   if ((i1 | 0) != (i8 | 0)) if ((HEAP32[i1 >> 2] | 0) == (i2 + 8 | 0)) {
    i7 = (HEAP32[i2 + 4 >> 2] & -8) + i7 | 0;
    HEAP32[i5 >> 2] = i6 & 1 | i7 | 2;
    i7 = i4 + i7 + 4 | 0;
    HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1;
    HEAP32[i1 >> 2] = i3;
    break;
   }
   _dispose_chunk(i4, i7);
  } while (0);
  if ((i1 | 0) == (i8 | 0)) {
   i1 = 11;
   break;
  }
 }
 if ((i1 | 0) == 9) _abort(); else if ((i1 | 0) == 11) return 0;
 return 0;
}

function __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_(i7, i4, i5) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) i6 = 0; else i6 = __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_(i7, i1, i5) | 0;
 i2 = __ZN5physx19CVariableMemoryPool8allocateEj(i7 + 4 | 0, 24) | 0;
 i1 = i2 + 4 | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 1576256;
 HEAP32[i1 >> 2] = gb + 1576256;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 20 >> 2] = i5;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 | 0) HEAP32[i2 + 16 >> 2] = __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_(i7, i1, i2) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) return i2 | 0;
 HEAP32[i6 + 12 >> 2] = i2;
 return i2 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i6 + 32 | 0;
 i1 = __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i5) | 0;
 if (i3) i1 = (i1 & 65535 | i2) & 65535; else i1 = i1 & ((i2 ^ 65535) & 65535);
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i7 = 5;
   break;
  }
 case 3:
  {
   STACKTOP = i8;
   return;
  }
 default:
  {}
 }
 if ((i7 | 0) == 5) if (HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP16[i4 >> 1] = i1;
 __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE(i5, i4);
 STACKTOP = i8;
 return;
}

function __ZN4FMOD3DSP9getOutputEiPPS0_PPNS_13DSPConnectionE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 857600;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 857600;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857600;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17PersistentManager13UnloadStreamsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i1 + 16 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i7 = i1 + 4 | 0;
 i8 = i1 + 24 | 0;
 i5 = i1 + 40 | 0;
 i4 = 0;
 do {
  i1 = (HEAP32[i7 >> 2] | 0) + (i4 * 24 | 0) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   __ZN14SerializedFile7ReleaseEv(i2);
   HEAP32[i1 >> 2] = 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i2 + (i4 * 20 | 0) + 4 >> 2] | 0;
   i2 = i2 + (i4 * 20 | 0) + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = HEAP32[i2 + (i4 * 20 | 0) + 4 >> 2] | 0;
   i2 = i2 + (i4 * 20 | 0) + 8 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 return;
}

function __ZN14BatchedOverlapC2ERK13dynamic_arrayI15BatchedOverlapsLj4EEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 >>> 2;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 & 3;
 HEAP32[i1 >> 2] = HEAP32[i2 + (i4 * 144 | 0) + (i3 << 2) >> 2];
 i5 = HEAP32[i2 + (i4 * 144 | 0) + 32 + (i3 << 2) >> 2] | 0;
 i6 = HEAP32[i2 + (i4 * 144 | 0) + 48 + (i3 << 2) >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + (i4 * 144 | 0) + 16 + (i3 << 2) >> 2];
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i6;
 i6 = HEAP32[i2 + (i4 * 144 | 0) + 80 + (i3 << 2) >> 2] | 0;
 i5 = HEAP32[i2 + (i4 * 144 | 0) + 96 + (i3 << 2) >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + (i4 * 144 | 0) + 64 + (i3 << 2) >> 2];
 HEAP32[i1 + 20 >> 2] = i6;
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + (i4 * 144 | 0) + 112 + (i3 << 2) >> 2];
 HEAP8[i1 + 32 >> 0] = (HEAP32[i2 + (i4 * 144 | 0) + 128 + (i3 << 2) >> 2] | 0) != 0 & 1;
 return;
}

function __Z31ScriptingToNativeVertexDataType23ScriptingVertexDataType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 0;
   return;
  }
 case 1:
  {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 1;
   return;
  }
 case 2:
  {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 2;
   return;
  }
 case 3:
  {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 3;
   return;
  }
 case 4:
  {
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 4;
   return;
  }
 case 5:
  {
   HEAP8[i1 >> 0] = 1;
   HEAP8[i1 + 1 >> 0] = 2;
   return;
  }
 case 6:
  {
   HEAP8[i1 >> 0] = 1;
   HEAP8[i1 + 1 >> 0] = 4;
   return;
  }
 case 7:
  {
   HEAP8[i1 >> 0] = 2;
   HEAP8[i1 + 1 >> 0] = 4;
   return;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429881 | 0, 0, gb + 429904 | 0, 24, 1, 0, 0, 0);
   HEAP8[i1 >> 0] = 0;
   HEAP8[i1 + 1 >> 0] = 0;
   return;
  }
 }
}

function __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EERKS9_PKS6_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 i5 = i6 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255;
 i1 = _strlen(i4) | 0;
 __THREW__ = 0;
 invoke_viiii(fb + 359 | 0, i2 | 0, (i6 ? HEAP32[i3 >> 2] | 0 : i3) | 0, i5 | 0, i5 + i1 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (!(i3 & 1)) {
  __THREW__ = 0;
  invoke_iiii(fb + 512 | 0, i2 | 0, i4 | 0, i1 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) return;
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 ___resumeException(i6 | 0);
}

function __ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b(f1, f2, f3, f4, i5, f6, i7, i8, i9) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var f10 = f0;
 f10 = (HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), f1))));
 f4 = Math_fround(_modff(Math_fround(f1 + f4), i8));
 f4 = i5 ? f4 : f6;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 HEAPF32[i8 >> 2] = i5 ? f6 : Math_fround(0.0);
 f6 = Math_fround(f4 + Math_fround(1.0));
 f4 = i5 & i9 ? f6 : f4;
 f6 = Math_fround(Math_fround(1.0) - f4);
 i9 = !(f10 < Math_fround(0.0));
 f6 = i9 ? f4 : f6;
 HEAPF32[i7 >> 2] = f6;
 return Math_fround(Math_fround(Math_fround(f3 - f2) * f6) + f2);
}

function __ZN5physx7NpScene12createClientEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = i5 + 3704 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = i5 + 3376 | 0;
 HEAP8[i1 >> 0] = -1;
 i3 = i5 + 3380 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i5 + 3384 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP8[(HEAP32[i2 >> 2] | 0) + i4 >> 0] = -1;
  HEAP32[i3 >> 2] = i4 + 1;
 } else __ZN5physx6shdfnd5ArrayINS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i2, i1) | 0;
 if (!(HEAP8[i5 + 2449 >> 0] | 0)) {
  i5 = __ZN5physx2Sc5Scene12createClientEv(i5 + 32 | 0) | 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  i5 = i5 + 3372 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
  i5 = (HEAP32[i3 >> 2] | 0) + 255 & 255;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZN4FMOD7Channel13getLoopPointsEPjjS1_j(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868539;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868539;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868539;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 857591;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 857591;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857591;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN26ProbeSetTetrahedralization11SetHullRaysEPK8Vector3fS2_(i5, i7, i1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i6 = i5 + 20 | 0;
 i8 = i5 + 32 | 0;
 i2 = i1 - i7 | 0;
 i3 = (i2 | 0) / 12 | 0;
 HEAP32[i8 >> 2] = i3;
 i4 = i5 + 36 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 & 2147483647) >>> 0 < i3 >>> 0) if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i3;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i2, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i5 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, (HEAP32[i8 >> 2] | 0) * 12 | 0) | 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, (HEAP32[i8 >> 2] | 0) * 12 | 0) | 0;
 return;
}

function __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = i4 & 1;
 HEAP32[i1 + 4 >> 2] = (HEAP8[i3 + 7 >> 0] | 0 ? 2 : 0) | (HEAP8[i3 + 3 >> 0] | 0) != 0 | (HEAP8[i3 + 11 >> 0] | 0 ? 4 : 0) | (HEAP8[i3 + 15 >> 0] | 0 ? 8 : 0) | (HEAP8[i3 + 19 >> 0] | 0 ? 16 : 0) | (HEAP8[i3 + 23 >> 0] | 0 ? 32 : 0) | (HEAP8[i3 + 27 >> 0] | 0 ? 64 : 0) | (HEAP8[i3 + 31 >> 0] | 0 ? 128 : 0);
 return;
}

function __ZN14BillboardAsset17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 40 | 0;
 i5 = i3 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i4 | 0)) {
  do {
   i6 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) do {
   i6 = i1 + 4 | 0;
   i2 = i1;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i5 >> 2] = i4;
 HEAP32[i4 >> 2] = i4;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i6 = i2 + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (!(HEAP32[i6 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13ComputeShader17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i8 = i2 + 48 | 0;
 if ((HEAP32[i8 >> 2] | 0) > 0) {
  i9 = i2 + 44 | 0;
  i1 = 0;
  i4 = HEAP32[i9 >> 2] | 0;
  do {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 788 >> 2] | 0, i3 | 0, i4 + (i1 * 976 | 0) | 0);
   i4 = HEAP32[i9 >> 2] | 0;
   i5 = HEAP32[i4 + (i1 * 976 | 0) + 964 >> 2] | 0;
   i6 = i4 + (i1 * 976 | 0) + 968 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i5 | 0)) HEAP32[i6 >> 2] = i7 + (~(((i7 + -24 - i5 | 0) >>> 0) / 24 | 0) * 24 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i8 >> 2] | 0));
 }
 i9 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i2, 22, 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 800 >> 2] | 0, i3 | 0, ((HEAP32[i9 + 24 >> 2] | 0) - (HEAP32[i9 + 20 >> 2] | 0) | 0) / 20 | 0 | 0, i2 + 192 | 0);
 return;
}

function __Z56ParticleSystem_ExternalForcesModule_CUSTOM_SetMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 880 >> 2] | 0) + 8 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z54ParticleSystem_TrailModule_CUSTOM_SetMinVertexDistanceP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 908 >> 2] | 0) + 276 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_TriggerModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 912 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_SetDampingP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 888 >> 2] | 0) + 805 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z37TrailRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i3 = HEAP32[i3 + 384 >> 2] | 0;
 f2 = Math_fround(f2 / Math_fround(HEAPF32[i3 + 16 >> 2]));
 HEAPF32[i4 >> 2] = f2;
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 if ((i1 | 0) < 2) {
  __ZN11KeyframeTplIfEC2EfRKf(i5, Math_fround(1.0), i4);
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3 + 20 | 0, i5) | 0;
  STACKTOP = i6;
  return;
 } else {
  HEAPF32[(HEAP32[i3 + 76 >> 2] | 0) + (i1 + -1 << 4) + 4 >> 2] = f2;
  STACKTOP = i6;
  return;
 }
}

function _UNITY_FT_Stream_ReadULong(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i4 >> 2] = 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 + 3 | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  if (!i5) {
   i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i7 = 6;
  } else {
   if ((mftCall_iiiii(i5 | 0, i3 | 0, i2 | 0, i1 | 0, 4) | 0) != 4) break;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = 6;
  }
  if ((i7 | 0) == 6) {
   i3 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
   i1 = i2;
  }
  HEAP32[i6 >> 2] = i1 + 4;
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 85;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function _UNITY_FT_Create_Class_psnames_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 36, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _psnames_module_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 12;
  HEAP32[i5 + 8 >> 2] = gb + 947114;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = (HEAP32[i1 + 204 >> 2] | 0) + 4;
  HEAP32[i5 + 24 >> 2] = 0;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = fb + 1015;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _BF_encrypt(i6, i3, i2, i1, i7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i8 = 0;
 i8 = i6 + 68 | 0;
 while (1) {
  i5 = 0;
  i4 = HEAP32[i6 >> 2] ^ i3;
  do {
   i3 = i5 | 1;
   i2 = HEAP32[i6 + (i3 << 2) >> 2] ^ i2 ^ ((HEAP32[i6 + 72 + (i4 >>> 24 << 2) >> 2] | 0) + (HEAP32[i6 + 1096 + ((i4 >>> 16 & 255) << 2) >> 2] | 0) ^ HEAP32[i6 + 2120 + ((i4 >>> 8 & 255) << 2) >> 2]) + (HEAP32[i6 + 3144 + ((i4 & 255) << 2) >> 2] | 0);
   i4 = HEAP32[i6 + (i3 + 1 << 2) >> 2] ^ i4 ^ ((HEAP32[i6 + 72 + (i2 >>> 24 << 2) >> 2] | 0) + (HEAP32[i6 + 1096 + ((i2 >>> 16 & 255) << 2) >> 2] | 0) ^ HEAP32[i6 + 2120 + ((i2 >>> 8 & 255) << 2) >> 2]) + (HEAP32[i6 + 3144 + ((i2 & 255) << 2) >> 2] | 0);
   i5 = i5 + 2 | 0;
  } while ((i5 | 0) < 16);
  i3 = HEAP32[i8 >> 2] ^ i2;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i1 + 8 | 0;
  if (i1 >>> 0 >= i7 >>> 0) break; else i2 = i4;
 }
 return i3 | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 2 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx3Ext23DefaultBufferedProfiler27addBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i7 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i7 + 88 | 0;
 HEAP32[i1 >> 2] = i6;
 i4 = i7 + 92 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i7 + 96 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i6;
  HEAP32[i4 >> 2] = i5 + 1;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i1) | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx2Sc9ClothCoreC2ERKNS_11PxTransformERNS0_15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i5, i3, i1, i4, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh(i5, 5, 1, 0, 0, 0);
 HEAPF32[i5 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i5 + 32 >> 2] = i1;
 HEAP32[i5 + 36 >> 2] = 0;
 i1 = i5 + 44 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i5 + 60 >> 1] = HEAP16[i2 >> 1] | 0;
 i2 = i5 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 __ZN5physx2Sc9ClothCore12initLowLevelERKNS_11PxTransformEPKNS_15PxClothParticleE(i5, i3, i4);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i6 + 32 | 0;
 i1 = __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i5) | 0;
 if (i3) i1 = (i1 & 65535 | i2) & 65535; else i1 = i1 & ((i2 ^ 65535) & 65535);
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i7 = 5;
   break;
  }
 case 3:
  {
   STACKTOP = i8;
   return;
  }
 default:
  {}
 }
 if ((i7 | 0) == 5) if (HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP16[i4 >> 1] = i1;
 __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE(i5, i4);
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine9Animation28RegisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = i2 + (i1 << 2) | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if (i5 | 0) if (!(__ZNK6Object8HasEventEPFvPvS0_iEPKv(i5, fb + 914 | 0, i6) | 0)) __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[i4 >> 2] | 0, fb + 914 | 0, i6);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i2 = i6 + 16 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = i6 + 20 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0;
  if (i4 | 0) if (!(__ZNK6Object8HasEventEPFvPvS0_iEPKv(i4, fb + 914 | 0, i6) | 0)) __ZN6Object8AddEventEPFvPvS0_iES0_(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, fb + 914 | 0, i6);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return;
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_SetOctaveMultiplierP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 888 >> 2] | 0) + 812 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_SetMinKillSpeedP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 904 >> 2] | 0) + 936 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_SetMaxKillSpeedP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 904 >> 2] | 0) + 940 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_LightsModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 920 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z36LineRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i3 = HEAP32[i3 + 344 >> 2] | 0;
 f2 = Math_fround(f2 / Math_fround(HEAPF32[i3 + 16 >> 2]));
 HEAPF32[i4 >> 2] = f2;
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 if ((i1 | 0) < 2) {
  __ZN11KeyframeTplIfEC2EfRKf(i5, Math_fround(1.0), i4);
  __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i3 + 20 | 0, i5) | 0;
  STACKTOP = i6;
  return;
 } else {
  HEAPF32[(HEAP32[i3 + 76 >> 2] | 0) + (i1 + -1 << 4) + 4 >> 2] = f2;
  STACKTOP = i6;
  return;
 }
}

function __Z26ShaderFromSerializedShaderPKN9ShaderLab16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS3_9allocatorIS7_EEEEbPS6_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i1 = __ZN9ShaderLab9IntShader26CreateFromSerializedShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_(i4, i1, i2, i3) | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!(HEAP8[i4 + 84 >> 0] | 0)) {
  _printf_console(gb + 471981 | 0, i6);
  HEAP32[i5 >> 2] = gb + 471996;
  _printf_console(gb + 1074693 | 0, i5);
 }
 __ZN9ShaderLab9IntShaderD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z21IsValidRenderingLightRK5Light9LightTypej(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if ((i2 | 0) == 3) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 88 >> 2] | 0) > -1) if ((HEAP32[i1 + 80 >> 2] | 0) != 1) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 36 >> 2] & i3)) {
  i3 = 0;
  return i3 | 0;
 }
 if (Math_fround(HEAPF32[i1 + 44 >> 2]) < Math_fround(.00100000005)) {
  i3 = 0;
  return i3 | 0;
 }
 switch (i2 | 0) {
 case 0:
  {
   if (Math_fround(HEAPF32[i1 + 48 >> 2]) < Math_fround(.00100000005)) {
    i3 = 0;
    return i3 | 0;
   }
   if (Math_fround(HEAPF32[i1 + 60 >> 2]) < Math_fround(.00100000005)) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = 1;
   return i3 | 0;
  }
 case 2:
  {
   i3 = !(Math_fround(HEAPF32[i1 + 48 >> 2]) < Math_fround(9.99999993e-09));
   return i3 | 0;
  }
 default:
  {
   i3 = 1;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZNSt3__220__get_collation_nameEPKc(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = gb + 214292 | 0;
 i1 = 111;
 while (1) {
  if (!i1) break;
  i5 = (i1 | 0) / 2 | 0;
  i7 = i2 + (i5 << 3) | 0;
  i6 = (_strcmp(HEAP32[i7 >> 2] | 0, i4) | 0) < 0;
  i2 = i6 ? i7 + 8 | 0 : i2;
  i1 = i6 ? i1 + -1 - i5 | 0 : i5;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 if ((i2 | 0) != (gb + 214292 + 888 | 0)) if (!(_strcmp(i4, HEAP32[i2 >> 2] | 0) | 0)) {
  __THREW__ = 0;
  invoke_iii(fb + 1151 | 0, i3 | 0, HEAP8[i2 + 4 >> 0] | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   ___resumeException(i7 | 0);
  }
 }
 return;
}

function __ZNK26AnimatorOverrideController15GetOriginalClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i6 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i1) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = i6 + 12 | 0;
 i8 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + (i8 << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 if (!i8) i2 = 0; else {
  while (1) {
   if (__ZN8FindClipclERK4PPtrI13AnimationClipE(i4, i1) | 0) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i3 | 0)) {
    i1 = i3;
    break;
   }
  }
  i2 = HEAP32[i5 >> 2] | 0;
 }
 if ((i1 | 0) == ((HEAP32[i6 >> 2] | 0) + (i2 << 2) | 0)) {
  i8 = 0;
  STACKTOP = i7;
  return i8 | 0;
 }
 i8 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 2 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd13createFastXmlEPNS0_7FastXml8CallbackE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 11316) | 0;
 if (!i2) return i2 | 0;
 HEAP32[i2 >> 2] = gb + 146688 + 8;
 HEAP8[i2 + 9260 >> 0] = 1;
 HEAP32[i2 + 11312 >> 2] = i1;
 i1 = i2 + 4 | 0;
 _memset(i1 | 0, 0, 1024) | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i2 + 40 >> 2] = 2;
 HEAP32[i2 + 132 >> 2] = 2;
 HEAP32[i2 + 256 >> 2] = 3;
 HEAP32[i2 + 252 >> 2] = 3;
 HEAP32[i2 + 192 >> 2] = 3;
 HEAP32[i2 + 56 >> 2] = 4;
 HEAP32[i2 + 44 >> 2] = 4;
 HEAP32[i2 + 1056 >> 2] = 0;
 HEAP32[i2 + 1060 >> 2] = 0;
 HEAP32[i2 + 1028 >> 2] = 0;
 HEAP32[i2 + 1036 >> 2] = 0;
 HEAP32[i2 + 1032 >> 2] = 0;
 HEAP32[i2 + 1044 >> 2] = 16384;
 HEAP32[i2 + 1040 >> 2] = 0;
 HEAP32[i2 + 1048 >> 2] = 0;
 i1 = 0;
 do {
  HEAP32[i2 + 1064 + (i1 << 2) >> 2] = 0;
  HEAP8[i2 + 9261 + i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 2049);
 return i2 | 0;
}

function __ZN5physx36PxVehicleDriveSimDataGeneratedValuesC2EPKNS_21PxVehicleDriveSimDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 _memcpy(i2 | 0, i1 | 0, i3 << 3 | 0) | 0;
 HEAP32[i2 + 64 >> 2] = i3;
 i3 = i2 + 80 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 112 | 0, i1 + 112 | 0, 144) | 0;
 i3 = i2 + 256 | 0;
 i4 = i1 + 256 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 _memcpy(i2 + 272 | 0, i1 + 272 | 0, 256) | 0;
 return;
}

function __ZN5Unity5Cloth19SetBendingStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (f1 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 722, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 } else if (f1 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 723, 1, 0, 0, 0);
  f1 = Math_fround(1.0);
 }
 HEAPF32[i2 + 36 >> 2] = f1;
 i2 = i2 + 228 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 264 >> 2] | 0, i4 | 0, i3 | 0, 3);
 HEAPF32[i4 >> 2] = f1;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i3 | 0, 3, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN4gles18CreateDummySurfaceEbRK17RenderSurfaceDesc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = __Z16GetRealGfxDevicev() | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 384 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (HEAP32[i2 + 16 >> 2] | 0) != 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 1;
 HEAP32[i3 + 24 >> 2] = 2;
 HEAP8[i3 + 30 >> 0] = i1 & 1;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP8[i3 + 31 >> 0] = i2 & 1;
 HEAP32[i3 + 20 >> 2] = 64;
 i1 = i3 + 32 | 0;
 if (HEAP32[i1 >> 2] | 0) return i3 | 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 118) | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i1 >> 2] = i5;
 return i3 | 0;
}

function __ZN4FMOD5Sound13getLoopPointsEPjjS1_j(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868539;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868539;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868539;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP32[i5 + 132 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 44 | 0, i6);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN13ComputeShaderC2E10MemLabelId18ObjectCreationMode(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i6 = i5;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i3, i4, i2);
 HEAP32[i3 >> 2] = gb + 67412 + 8;
 i4 = i3 + 32 | 0;
 i1 = i3 + 192 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesYP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 864 >> 2] | 0) + 540 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesXP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 864 >> 2] | 0) + 536 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z52ParticleSystem_CollisionModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 904 >> 2] | 0) + 944 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_TrailModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 908 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 888 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _UNITY_png_realloc_array(i3, i6, i4, i7, i8) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i9 = 0;
 if ((i4 | 0) < 0 | ((i7 | 0) < 1 | (i8 | 0) == 0)) _UNITY_png_error(i3, gb + 352066 | 0);
 i9 = (i4 | 0) > 0;
 if ((i6 | 0) == 0 & i9) _UNITY_png_error(i3, gb + 352066 | 0);
 if ((2147483647 - i4 | 0) < (i7 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = i7 + i4 | 0;
 if ((4294967295 / (i8 >>> 0) | 0) >>> 0 < i1 >>> 0) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = Math_imul(i1, i8) | 0;
 if (!i1) {
  i9 = 0;
  return i9 | 0;
 }
 if (!i3) i5 = 10; else {
  i2 = HEAP32[i3 + 608 >> 2] | 0;
  if (!i2) i5 = 10; else i2 = mftCall_iii(i2 | 0, i3 | 0, i1 | 0) | 0;
 }
 if ((i5 | 0) == 10) i2 = _malloc(i1) | 0;
 if (!i2) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = Math_imul(i8, i4) | 0;
 if (i9) _memcpy(i2 | 0, i6 | 0, i1 | 0) | 0;
 _memset(i2 + i1 | 0, 0, Math_imul(i8, i7) | 0) | 0;
 i9 = i2;
 return i9 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = i2 + 204 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i5 >> 2]));
 i5 = i1 + 4 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i2 + 208 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = i2 + 212 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i6 >> 2]));
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i2 + 176 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i2 + 180 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i2 + 184 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZNSt3__227__num_get_unsigned_integralIyEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 do if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i2 = 0;
  i1 = 0;
 } else {
  if ((HEAP8[i1 >> 0] | 0) == 45) {
   HEAP32[i5 >> 2] = 4;
   i2 = 0;
   i1 = 0;
   break;
  }
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoull_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   if ((i3 | 0) == 34) {
    HEAP32[i5 >> 2] = 4;
    i1 = -1;
    i2 = -1;
   }
  } else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
   i2 = 0;
  }
 } while (0);
 setTempRet0(i2 | 0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EOS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 8 >> 2];
 i4 = i3 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i4, i3);
 i5 = i3 + 72 | 0;
 HEAP32[i4 + 72 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 16 >> 2];
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK12AudioManager13GetNumDevicesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 20 | 0;
 i3 = i5 + 16 | 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN4FMOD6System13getNumDriversEPi(i1, i3) | 0;
 if (i1 | 0) {
  i1 = __ZL16FMOD_ErrorString11FMOD_RESULT(i1) | 0;
  HEAP32[i4 >> 2] = gb + 856220;
  HEAP32[i4 + 4 >> 2] = 812;
  HEAP32[i4 + 8 >> 2] = gb + 873439;
  HEAP32[i4 + 12 >> 2] = i1;
  __Z6FormatPKcz(i2, gb + 883334 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN8Playable7DestroyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 i1 = i2 + 24 | 0;
 if ((HEAP16[i1 >> 1] | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i7 = __Z18GetDirectorManagerv() | 0;
 i1 = (__ZNK15DirectorManager16GetScriptMethodsEs(i7, HEAP16[i1 >> 1] | 0) | 0) + 32 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i8 = i1;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i7, i5);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx7NpCloth12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 94588 + 8;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i4 = i3 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 251658240;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP8[i3 + 43 >> 0] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = 0;
 i4 = i3 + 76 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP16[i4 + 16 >> 1] = 0;
 HEAP32[i3 + 128 >> 2] = gb + 95092 + 8;
 HEAP32[i3 + 140 >> 2] = i3;
 HEAP32[i3 + 144 >> 2] = 0;
 HEAP8[i3 + 148 >> 0] = 1;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 152;
 __ZN5physx2Sc9ClothCore15importExtraDataERNS_24PxDeserializationContextE(i3 + 32 | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 484 >> 2] | 0, i3 | 0, i2 | 0);
 return i3 | 0;
}

function __ZN4FMOD7Channel13setLoopPointsEjjjj(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854586;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854586;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854586;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD3DSP11getDefaultsEPfS1_S1_Pi(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = i7;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868772;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868772;
   _printf(gb + 853343 | 0, i5) | 0;
   i7 = 78;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868772;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN2UI14CanvasRenderer13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if (!(__ZNK10GameObject8IsActiveEv(i3) | 0)) return;
 if (!((i1 & 1 | 0) == 0 & (HEAP32[i4 + 204 >> 2] | 0) == 0)) return;
 i1 = __Z34FindAncestorComponentExactTypeImplR10GameObjecti(HEAP32[i2 >> 2] | 0, 223) | 0;
 i2 = i4 + 188 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i3, i4);
 HEAP32[i2 >> 2] = i1;
 if (!i1) return;
 i4 = i1 + 112 + 112 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
 while (1) {
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i1) {
   i1 = 10;
   break;
  }
  i4 = i1 + 224 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
  if (HEAP32[i1 + 208 >> 2] | 0) {
   i1 = 10;
   break;
  }
 }
 if ((i1 | 0) == 10) return;
}

function __ZN28LightsModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 920 >> 2] | 0) + 8 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 920 >> 2] | 0) + 12 >> 0] | 0) != 0 & 1);
   break;
  }
 case 2:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 920 >> 2] | 0) + 20 >> 0] | 0) != 0 & 1);
   break;
  }
 case 3:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 920 >> 2] | 0) + 21 >> 0] | 0) != 0 & 1);
   break;
  }
 case 4:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 920 >> 2] | 0) + 22 >> 0] | 0) != 0 & 1);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 920 >> 2] | 0) + 104 >> 2]);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 920 >> 2] | 0) + 368 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN13ModuleManager15AddInitCallbackEPFvRS_E(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i3 = i4 + 3084 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 i2 = i4 + 2316 + (i1 * 12 | 0) | 0;
 HEAP32[i4 + 2316 + (i1 * 12 | 0) + 4 >> 2] = 0;
 i1 = i4 + 2316 + (i1 * 12 | 0) + 8 | 0;
 if (!i5) {
  HEAP8[i1 >> 0] = 1;
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i6;
  return;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP32[i2 >> 2] = i5;
  STACKTOP = i6;
  return;
 }
}

function __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetRowIndexP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 864 >> 2] | 0) + 548 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z26CleanupActiveLightsContextR21ActiveLightingContext(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) {
  i2 = i4 + 4 | 0;
  i1 = 0;
  do {
   i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 12 | 0) + 4 >> 2] | 0;
   if (i3 | 0) {
    i5 = i3 + 4 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
    if (!(HEAP32[i5 >> 2] | 0)) {
     mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
     __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
    }
   }
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 }
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 + 4 >> 2] | 0, gb + 64016 | 0);
 return;
}

function _UNITY_ft_destroy_default_module_classes(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i2 + 188 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i5 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_tt_driver_class(i2, i1);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_cff_driver_class(i2, i1);
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_psnames_module_class(i2, i1);
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_pshinter_module_class(i2, i1);
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_ft_raster1_renderer_class(i2, i1);
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_sfnt_module_class(i2, i1);
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_ft_smooth_renderer_class(i2, i1);
 _UNITY_ft_mem_free(i5, i4);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i5 | 0, gb + 1474588 | 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 if (!(i7 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 10) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   __ZNSt3__26localeD2Ev(i5);
   i7 = __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwiw(i2, i3, i4, i1) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i5);
 ___resumeException(i7 | 0);
 return 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPci(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i5 | 0, gb + 1474556 | 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 if (!(i7 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 10) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   __ZNSt3__26localeD2Ev(i5);
   i7 = __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPcic(i2, i3, i4, i1) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i5);
 ___resumeException(i7 | 0);
 return 0;
}

function __ZN9HumanBoneC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i4 + 11 >> 0] = 0;
 HEAP8[i4 >> 0] = 0;
 i4 = HEAP32[gb + 1162364 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = i4;
 i3 = HEAP32[gb + 1162364 + 4 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = i3;
 i2 = HEAP32[gb + 1162364 + 8 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i4;
 HEAP32[i1 + 48 >> 2] = i3;
 HEAP32[i1 + 52 >> 2] = i2;
 HEAP32[i1 + 56 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = i3;
 HEAP32[i1 + 64 >> 2] = i2;
 HEAPF32[i1 + 68 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 72 >> 0] = 0;
 return;
}

function __ZN8Animator12GetLayerNameEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i2 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
  return;
 }
 i5 = i2 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i2 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
  return;
 } else {
  __ZN26AnimatorControllerPlayable12GetLayerNameEi(i1, HEAP32[HEAP32[i2 + 584 >> 2] >> 2] | 0, i3);
  return;
 }
}

function __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i3 + 16 | 0;
 i6 = i3 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = (HEAP32[i5 >> 2] | 0) - i1 | 0;
 if (!i2) return;
 i8 = i3 + 20 | 0;
 if (((HEAP32[i8 >> 2] | 0) - i1 | 0) >>> 0 > i2 >>> 0) return;
 i1 = i2 << 1;
 if (i1 >>> 0 > 8192) i1 = ~~Math_fround(Math_fround(i2 >>> 0) * Math_fround(1.20000005)) >>> 0;
 i4 = i3 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, HEAP32[i3 + 8 >> 2] | 0, gb + 776765 | 0, 228) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (i3 | 0) {
  _memcpy(i2 | 0, i3 | 0, i7 | 0) | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[i6 >> 2] | 0);
 }
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = i2 + i7;
 HEAP32[i8 >> 2] = i2 + i1;
 return;
}

function __ZN5physx7NpScene7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (HEAP16[((HEAP32[i1 + 3388 >> 2] & 4 | 0) == 0 ? i1 + 1224 | 0 : i1 + 3364 | 0) >> 1] & 4096) mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 400 >> 2] | 0, i1 | 0, gb + 678666 | 0, 210);
 if (!(HEAP8[i1 + 3696 >> 0] | 0)) if (!(HEAP8[i1 + 3697 >> 0] | 0)) {
  i2 = HEAP32[gb + 1457324 >> 2] | 0;
  __ZN5physx9NpPhysics20releaseSceneInternalERNS_7PxSceneE(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 218, gb + 709860 | 0, i2);
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, 1, 0) | 0;
 i2 = HEAP32[gb + 1457324 >> 2] | 0;
 __ZN5physx9NpPhysics20releaseSceneInternalERNS_7PxSceneE(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpCloth12setClothFlagENS_11PxClothFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i2 + 32 | 0, i1, i3);
  __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 936, gb + 698357 | 0, i4);
  __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN4FMOD7Channel19get3DDistanceFilterEPbPfS2_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868432;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868432;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868432;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 20 | 0;
 i6 = i3;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i2 = i7 + (i1 << 6) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i2;
 i2 = i1 << 6 >> 6;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i5, i4, 0);
 STACKTOP = i3;
 return;
}

function __Z50ParticleSystem_CollisionModule_CUSTOM_SetVoxelSizeP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 904 >> 2] | 0) + 964 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_MainModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[(HEAP32[i1 + 44 >> 2] | 0) + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _UNITY_FT_Create_Class_sfnt_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = _UNITY_ft_mem_alloc(i4, 36, i3) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 if (i6 | 0) {
  STACKTOP = i7;
  return i6 | 0;
 }
 i6 = _sfnt_module_class_pic_init(i1) | 0;
 HEAP32[i3 >> 2] = i6;
 if (!i6) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 12;
  HEAP32[i5 + 8 >> 2] = gb + 1007772;
  HEAP32[i5 + 12 >> 2] = 65536;
  HEAP32[i5 + 16 >> 2] = 131072;
  HEAP32[i5 + 20 >> 2] = (HEAP32[i1 + 212 >> 2] | 0) + 36;
  HEAP32[i5 + 24 >> 2] = 0;
  HEAP32[i5 + 28 >> 2] = 0;
  HEAP32[i5 + 32 >> 2] = fb + 1016;
  HEAP32[i2 >> 2] = i5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _UNITY_ft_mem_free(i4, i5);
  i6 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZNK9Transform21InverseTransformPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 24 | 0;
 i7 = i4;
 i5 = i4 + 8 | 0;
 i9 = i2 + 32 | 0;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i11 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 i2 = i5 + 4 | 0;
 HEAP32[i2 >> 2] = i11;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = i8;
 i8 = i7;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E(i6, i5);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx14SapPairManager8FindPairEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP32[i3 + 8 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = i1 >>> 0 > i2 >>> 0;
 i6 = i5 ? i2 : i1;
 i5 = i5 ? i1 : i2;
 i1 = i5 << 16 | i6;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >> 10 ^ i1) * 9 | 0;
 i1 = i1 >> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i3 + 36 >> 2] & (i1 >> 16 ^ i1)) << 2) >> 2] | 0;
 if ((i1 | 0) == 1073741823) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = i3 + 4 | 0;
 i2 = i1;
 while (1) {
  i1 = i4 + (i2 << 3) | 0;
  if (!((HEAP32[i1 >> 2] | 0) != (i6 | 0) ? 1 : (HEAP32[i4 + (i2 << 3) + 4 >> 2] | 0) != (i5 | 0))) {
   i2 = 6;
   break;
  }
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == 1073741823) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = i5 + 40 | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i4 | 0)) {
  while (1) {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i6 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i6 >>> 0) break;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i4 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 i1 = HEAP32[i5 + 52 >> 2] | 0;
 i4 = i5 + 48 | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 while (1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if (i3 >>> 0 <= i6 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i6 >>> 0) {
   i2 = 9;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN4FMOD7Channel17get3DConeSettingsEPfS1_S1_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868395;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868395;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868395;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD12ChannelGroup24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868297;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868297;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868297;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z59ParticleSystem_CollisionModule_CUSTOM_SetMaxCollisionShapesP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 904 >> 2] | 0) + 952 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_TriggerModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 912 >> 2] | 0) + 24 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_TrailModule_CUSTOM_SetTextureModeP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 908 >> 2] | 0) + 280 >> 2] = ~~f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = (HEAP8[i2 >> 0] | 0) == 0 ? i5 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i5;
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i4 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i2;
  i6 = i2;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i5, 4);
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 }
 i1 = i5 + 4 | 0;
 i2 = i6 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function _UNITY_FT_Done_Size(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (!i5) {
  i6 = 36;
  return i6 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  i6 = 35;
  return i6 | 0;
 }
 i4 = HEAP32[i2 + 96 >> 2] | 0;
 if (!i4) {
  i6 = 34;
  return i6 | 0;
 }
 i6 = HEAP32[i4 + 8 >> 2] | 0;
 i3 = i2 + 108 | 0;
 i1 = _UNITY_FT_List_Find(i3, i5) | 0;
 if (!i1) {
  i6 = 36;
  return i6 | 0;
 }
 _UNITY_FT_List_Remove(i3, i1);
 _UNITY_ft_mem_free(i6, i1);
 i2 = i2 + 88 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
  HEAP32[i2 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) HEAP32[i2 >> 2] = HEAP32[i1 + 8 >> 2];
 }
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i5 | 0);
 i1 = HEAP32[(HEAP32[i4 + 12 >> 2] | 0) + 60 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i5 | 0);
 i4 = i5 + 40 | 0;
 _UNITY_ft_mem_free(i6, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 _UNITY_ft_mem_free(i6, i5);
 i6 = 0;
 return i6 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i2 + 24 | 0, HEAP32[i2 + 28 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK15MBP_PairManager8findPairEjj(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i3) {
  i8 = 0;
  return i8 | 0;
 }
 i7 = i1 >>> 0 > i2 >>> 0;
 i8 = i7 ? i2 : i1;
 i7 = i7 ? i1 : i2;
 i1 = i7 << 16 | i8 & 65535;
 i1 = i1 + ~(i1 << 15) | 0;
 i1 = (i1 >> 10 ^ i1) * 9 | 0;
 i1 = i1 >> 6 ^ i1;
 i1 = i1 + ~(i1 << 11) | 0;
 i5 = HEAP32[i4 + 20 >> 2] | 0;
 i6 = HEAP32[i4 + 16 >> 2] | 0;
 i1 = HEAP32[i3 + ((HEAP32[i4 + 4 >> 2] & (i1 >> 16 ^ i1)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i8 = 0;
  return i8 | 0;
 } else i2 = i1;
 while (1) {
  i1 = i5 + (i2 * 12 | 0) | 0;
  if (!((HEAP32[i1 >> 2] | 0) != (i8 | 0) ? 1 : (HEAP32[i5 + (i2 * 12 | 0) + 4 >> 2] | 0) != (i7 | 0))) {
   i2 = 5;
   break;
  }
  i2 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 44 >> 2] | 0;
 i4 = i5 + 40 | 0;
 i2 = i1;
 L1 : do if ((i2 | 0) != (i4 | 0)) {
  while (1) {
   i3 = HEAP32[i1 + 12 >> 2] | 0;
   if (i3 >>> 0 <= i6 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i6 >>> 0) break;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
   if ((i2 | 0) == (i4 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 i1 = HEAP32[i5 + 52 >> 2] | 0;
 i4 = i5 + 48 | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 while (1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  if (i3 >>> 0 <= i6 >>> 0) if ((i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i6 >>> 0) {
   i2 = 9;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN18ProceduralMaterialD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 59244 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + 272 | 0, HEAP32[i1 + 276 >> 2] | 0);
 __ZN22ProceduralMaterialDataD2Ev(i1 + 144 | 0);
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i5) {
  __ZN8MaterialD2Ev(i1);
  __ZdlPv(i1);
  STACKTOP = i6;
  return;
 }
 i3 = i1 + 128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i5 | 0) >>> 2) << 2);
 i4 = HEAP32[i1 + 136 >> 2] | 0;
 HEAP32[i2 >> 2] = 77;
 HEAP32[i2 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 __ZN8MaterialD2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN14ParticleSystem18SetStartRotation3DERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 i1 = i1 + 44 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i4 + 1564 >> 2] = f3;
 HEAP8[i4 + 1570 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i4 + 1484 | 0, i4 + 1572 | 0, f3, HEAP16[i4 + 1568 >> 1] | 0) | 0) & 1;
 i4 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 HEAPF32[i4 + 1828 >> 2] = f3;
 HEAP8[i4 + 1834 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i4 + 1748 | 0, i4 + 1836 | 0, f3, HEAP16[i4 + 1832 >> 1] | 0) | 0) & 1;
 i1 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 HEAPF32[i1 + 2092 >> 2] = f3;
 HEAP8[i1 + 2098 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2012 | 0, i1 + 2100 | 0, f3, HEAP16[i1 + 2096 >> 1] | 0) | 0) & 1;
 return;
}

function __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 20 | 0;
 i6 = i3;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i2 = i7 + (i1 << 6) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i2;
 i2 = i1 << 6 >> 6;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i5, i4, 0);
 STACKTOP = i3;
 return;
}

function __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 20 | 0;
 i6 = i3;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = (HEAP32[i2 + 16 >> 2] | 0) + 4 | 0;
 i7 = HEAP32[i8 >> 2] | 0;
 i2 = i7 + (i1 << 6) | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i2;
 i2 = i1 << 6 >> 6;
 HEAP32[i6 + 16 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i6;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i5, i4, 0);
 STACKTOP = i3;
 return;
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveScaleP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 888 >> 2] | 0) + 816 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 36980 >> 2] | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048334 | 0, HEAP32[gb + 37304 >> 2] | 0, i2, 1);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __GLOBAL__sub_I_runtime_particlesystem_modules_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451776 | 0, gb + 616058 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451752 | 0, gb + 616093 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452316 | 0, gb + 616124 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452328 | 0, gb + 616161 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451788 | 0, gb + 616200 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451800 | 0, gb + 616236 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451812 | 0, gb + 616263 | 0, 7, 0);
 return;
}

function __ZN8LODGroup7SetSizeEf(i8, f1) {
 i8 = i8 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAPF32[i8 + 44 >> 2] = f1;
 i6 = i8 + 68 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) == -1) return;
 i7 = i8 + 88 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i3) {
  i5 = i8 + 76 | 0;
  i4 = 0;
  i2 = i3;
  do {
   i3 = (HEAP32[i5 >> 2] | 0) + (i4 << 2) | 0;
   HEAP32[(HEAP32[i3 >> 2] | 0) + 312 >> 2] = 0;
   i3 = HEAP32[(HEAP32[i3 >> 2] | 0) + 284 >> 2] | 0;
   if ((i3 | 0) != -1) {
    i2 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i3 * 24 | 0) + 12 | 0;
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 0;
    i2 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i2 >>> 0);
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 if (i2 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i2);
 HEAP32[i6 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i8);
 return;
}

function __ZN5physx18PxVehicleDriveTank5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj(i4, i3, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i4, i3, i5, i6, i2, 0);
 i6 = i1 + 64 | 0;
 _memcpy(i4 + 224 | 0, i1 | 0, HEAP32[i6 >> 2] << 3 | 0) | 0;
 HEAP32[i4 + 288 >> 2] = HEAP32[i6 >> 2];
 i6 = i4 + 304 | 0;
 i5 = i1 + 80 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i5 + 28 >> 2];
 _memcpy(i4 + 336 | 0, i1 + 112 | 0, 416) | 0;
 return;
}

function __ZN4FMOD5Sound17get3DConeSettingsEPfS1_S1_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868395;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868395;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868395;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i1);
 __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6 + 60 | 0, i1);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 1 | 0;
 if (i5 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i2, 1);
  i1 = HEAP8[i2 >> 0] | 0;
 } else {
  i1 = HEAP8[i4 >> 0] | 0;
  HEAP8[i2 >> 0] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 HEAP8[i6 + 64 >> 0] = i1;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN14ConstantString6assignERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4 | 0) if (i4 >>> 0 < (gb + 388687 | 0) >>> 0 | i4 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i5 = i4 + -8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i3, HEAP32[i4 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
  }
 }
 HEAP32[i1 >> 2] = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i1 = i5;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 if (!(i1 >>> 0 < (gb + 388687 | 0) >>> 0 | i1 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = i1 + -8 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 STACKTOP = i6;
 return;
}

function __Z57ParticleSystem_ShapeModule_CUSTOM_SetUseMeshMaterialIndexP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[i1 + 48 + 213 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_MainModule_CUSTOM_SetScalingModeP12Il2CppObject25ParticleSystemScalingMode(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem14SetScalingModeE25ParticleSystemScalingMode(i1, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i6 = i9;
 HEAP32[i5 >> 2] = 0;
 i1 = _il2cpp_class_get_nested_types(i3 | 0, i5 | 0) | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i7 = i4 + 4 | 0;
 i8 = i4 + 8 | 0;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i8 >> 2] | 0)) __ZNSt3__26vectorIP11Il2CppClass13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i6); else {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
  }
  i1 = _il2cpp_class_get_nested_types(i3 | 0, i5 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
 } while ((i1 | 0) != 0);
 STACKTOP = i9;
 return;
}

function _initstate(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (i2 >>> 0 < 8) i1 = 0; else {
  ___lock(gb + 1470376 | 0);
  i1 = (HEAP32[gb + 207772 >> 2] | 0) + -4 | 0;
  HEAP32[i1 >> 2] = HEAP32[gb + 207776 >> 2] << 8 | HEAP32[gb + 207768 >> 2] << 16 | HEAP32[gb + 1470384 >> 2];
  do if (i2 >>> 0 < 32) {
   HEAP32[gb + 207768 >> 2] = 0;
   i2 = 0;
  } else {
   if (i2 >>> 0 < 64) {
    HEAP32[gb + 207768 >> 2] = 7;
    i2 = 458752;
    break;
   }
   if (i2 >>> 0 < 128) {
    HEAP32[gb + 207768 >> 2] = 15;
    i2 = 983040;
    break;
   }
   if (i2 >>> 0 < 256) {
    HEAP32[gb + 207768 >> 2] = 31;
    i2 = 2031616;
    break;
   } else {
    HEAP32[gb + 207768 >> 2] = 63;
    i2 = 4128768;
    break;
   }
  } while (0);
  HEAP32[gb + 207772 >> 2] = i4 + 4;
  ___srandom(i3);
  HEAP32[i4 >> 2] = HEAP32[gb + 207776 >> 2] << 8 | i2 | HEAP32[gb + 1470384 >> 2];
  ___unlock(gb + 1470376 | 0);
 }
 return i1 | 0;
}

function __ZNK5Umbra15CameraTransform16getCameraToWorldERNS_9Matrix4x4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i2 >> 2] = HEAP32[i1 + 340 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 344 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 356 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 360 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 364 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 368 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 372 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 376 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 380 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 384 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 388 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 392 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 396 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 400 >> 2];
 __ZN5Umbra9Matrix4x46invertERKS0_(i2, i2) | 0;
 return;
}

function __ZN6Camera27SetSurfaceUseResolvedBufferER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES5_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 8 | 0;
 i3 = i8 + 4 | 0;
 i7 = i8;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 <= 1) {
  STACKTOP = i8;
  return;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 416 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 mftCall_viiii(i1 | 0, i2 | 0, i4 | 0, 4, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 416 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 mftCall_viiii(i6 | 0, i2 | 0, i4 | 0, 4, 0);
 STACKTOP = i8;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = i2 + 208 | 0;
 HEAPF32[i5 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i5 >> 2]));
 i5 = i1 + 4 | 0;
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = i2 + 212 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 i4 = i1 + 8 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i6 = i2 + 216 | 0;
 HEAPF32[i6 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i6 >> 2]));
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i1 = i2 + 180 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = i2 + 184 | 0;
 HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i2 + 188 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZN13RuntimeStaticI22VirtualJoystickManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(32, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAPF64[i4 >> 3] = -2.0;
  i3 = i4 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(32, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAPF64[i4 >> 3] = -2.0;
  i3 = i4 + 8 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_SetFrequencyP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 888 >> 2] | 0) + 800 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z41Quaternion_CUSTOM_INTERNAL_CALL_AxisAngleRK8Vector3ffR11Quaternionf(i2, f3, i8) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i8 = i8 | 0;
 var f1 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f1 = Math_fround(f7 * f7);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(f1 + Math_fround(f6 * f6));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f1 = Math_fround(Math_sqrt(Math_fround(f1 + Math_fround(f4 * f4))));
 if (f1 > Math_fround(9.99999997e-07)) {
  f5 = Math_fround(f3 * Math_fround(.5));
  f1 = Math_fround(Math_fround(+Math_sin(+f5)) / f1);
  f5 = Math_fround(+Math_cos(+f5));
  f4 = Math_fround(f4 * f1);
  f3 = Math_fround(f6 * f1);
  f1 = Math_fround(f7 * f1);
 } else {
  f5 = Math_fround(1.0);
  f4 = Math_fround(0.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i8 >> 2] = f1;
 HEAPF32[i8 + 4 >> 2] = f3;
 HEAPF32[i8 + 8 >> 2] = f4;
 HEAPF32[i8 + 12 >> 2] = f5;
 return;
}

function __Z33Cloth_Set_Custom_PropCoefficientsP12Il2CppObjectP11Il2CppArray(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if ((i1 | 0) != (HEAP32[i2 + 128 + 12 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 839844 | 0, 0, gb + 839898 | 0, 451, 1, 0, 0, 0);
  return;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN5Unity5Cloth15SetCoefficientsEPNS0_26ClothConstrainCoefficientsE(i1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 8) | 0);
 return;
}

function __Z26ExtractProjectionNearPlaneRK10Matrix4x4fP5Plane(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 44 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 60 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f7 = Math_fround(f9 + f7);
 f6 = Math_fround(f8 + f6);
 f5 = Math_fround(f4 + f5);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i1 + 56 >> 2]));
 f4 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5)))));
 HEAPF32[i2 >> 2] = Math_fround(f7 * f4);
 HEAPF32[i2 + 4 >> 2] = Math_fround(f6 * f4);
 HEAPF32[i2 + 8 >> 2] = Math_fround(f5 * f4);
 HEAPF32[i2 + 12 >> 2] = Math_fround(f4 * f3);
 return;
}

function __ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = HEAP16[i1 + 2 >> 1] | 0;
 i9 = i1 + (i8 & 65535) | 0;
 if (!(i8 << 16 >> 16)) return;
 do {
  i3 = i1 + 48 | 0;
  i2 = HEAP8[i1 + 1 >> 0] | 0;
  i8 = (HEAP8[i1 >> 0] | 0) == 3 ? 112 : 80;
  if (!(i2 << 24 >> 24)) i1 = i3; else {
   i6 = i2 & 255;
   i7 = Math_imul(i8, i6) | 0;
   i5 = 0;
   while (1) {
    i2 = i3 + 32 | 0;
    f4 = Math_fround(HEAPF32[i2 >> 2]);
    i10 = f4 > Math_fround(0.0);
    HEAP32[i2 >> 2] = i10 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
    HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
    i5 = i5 + 1 | 0;
    if ((i5 | 0) == (i6 | 0)) break; else i3 = i3 + i8 | 0;
   }
   i1 = i1 + (i7 + 48) | 0;
  }
 } while (i1 >>> 0 < i9 >>> 0);
 return;
}

function __ZN19RuntimeSceneManager16UnloadSceneAsyncEP10UnityScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (!(__ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene(i1, i2) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __Znwj(80) | 0;
 __ZN20UnloadSceneOperationC2EP10UnityScene(i3, i2);
 HEAP32[i2 + 80 >> 2] = 3;
 i1 = i2 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 __Z6FormatPKcz(i4, gb + 463481 | 0, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i3 + 68 | 0, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i3);
 i5 = i3;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN18AwakeFromLoadQueue7ReserveEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i3 * 12 | 0;
 i1 = 0;
 while (1) {
  if (!i1) {
   i1 = 1;
   continue;
  }
  i5 = i2 + (i1 * 20 | 0) | 0;
  i6 = i2 + (i1 * 20 | 0) + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  do if ((i7 & 2147483647) >>> 0 < i3 >>> 0) if ((i7 | 0) > -1) {
   HEAP32[i6 >> 2] = i3;
   HEAP32[i5 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i4, 4, i2 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
   break;
  } else {
   i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 4, i2 + (i1 * 20 | 0) + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
   _memcpy(i7 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] | 0) * 12 | 0) | 0;
   HEAP32[i6 >> 2] = i3;
   HEAP32[i5 >> 2] = i7;
   break;
  } while (0);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 14) break;
 }
 return;
}

function __ZN14dtNavMeshQueryD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 72 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i3 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 }
 i1 = i2 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN13UnityProfiler18StartProfilingModeE12ProfilerMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, d5 = 0.0;
 if (!(HEAP32[i2 + 24 >> 2] & i1)) return;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 i3 = i1 + 248 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 if (!((HEAP32[i2 >> 2] & 255) << 24 >> 24)) return;
 i4 = i2 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 1;
 if (i3 | 0) return;
 i4 = i2 + 2 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZN22UnityProfilerPerThread11SetIsActiveEb(i1, 1);
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 656 >> 2] | 0, i3 | 0, 2, 1);
 if (!(HEAP8[i4 >> 0] | 0)) return;
 d5 = +_emscripten_get_now() * 1.0e6;
 i3 = +Math_abs(d5) >= 1.0 ? (d5 > 0.0 ? ~~+Math_min(+Math_floor(d5 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d5 - +(~~d5 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i4 = i2 + 48 | 0;
 HEAP32[i4 >> 2] = ~~d5 >>> 0;
 HEAP32[i4 + 4 >> 2] = i3;
 return;
}

function __ZN13ComputeBufferD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i8 = i4 + 4 | 0;
 i7 = i4;
 i5 = __Z12GetGfxDevicev() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 808 >> 2] | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i6 | 0, i5 | 0, i3 | 0);
 i5 = __Z25GetUncheckedRealGfxDevicev() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 748 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 mftCall_vii(i6 | 0, i5 | 0, i3 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i8 = i1 + 20 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[HEAP32[i8 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12GUIClipState6UnclipERK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) {
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  HEAPF32[i1 >> 2] = f6;
  i4 = i1 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 } else {
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + -24 >> 2]));
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + -56 >> 2]));
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i4 + -20 >> 2]));
  f6 = Math_fround(f6 + Math_fround(HEAPF32[i4 + -52 >> 2]));
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = i4;
  HEAPF32[i1 >> 2] = f5;
  i4 = i1 + 4 | 0;
  HEAPF32[i4 >> 2] = f6;
  return;
 }
}

function __Z15StringToHash128PKcj(i7, i8, i1) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i5 = i1 >>> 0 > 32 ? 16 : i1 >>> 1;
 if (!i5) return;
 i6 = 0;
 do {
  i4 = i6 << 1;
  i1 = HEAP8[i8 + i4 >> 0] | 0;
  i2 = i1 << 24 >> 24;
  do if ((i1 + -48 & 255) < 10) i1 = i2 + -48 | 0; else if ((i1 + -97 & 255) < 6) {
   i1 = i2 + -87 | 0;
   break;
  } else {
   i1 = (i1 + -65 & 255) < 6 ? i2 + -55 | 0 : 0;
   break;
  } while (0);
  i3 = i1 << 4;
  i1 = HEAP8[i8 + (i4 | 1) >> 0] | 0;
  i2 = i1 << 24 >> 24;
  do if ((i1 + -48 & 255) < 10) i1 = i2 + -48 | 0; else if ((i1 + -97 & 255) < 6) {
   i1 = i2 + -87 | 0;
   break;
  } else {
   i1 = (i1 + -65 & 255) < 6 ? i2 + -55 | 0 : 0;
   break;
  } while (0);
  HEAP8[i7 + i6 >> 0] = i1 + i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i5 | 0));
 return;
}

function _UNITY_FT_GlyphLoader_Prepare(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP16[i1 + 58 >> 1] = 0;
 HEAP16[i1 + 56 >> 1] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 i2 = HEAP16[i1 + 22 >> 1] | 0;
 HEAP32[i1 + 60 >> 2] = (HEAP32[i1 + 24 >> 2] | 0) + (i2 << 3);
 HEAP32[i1 + 64 >> 2] = (HEAP32[i1 + 28 >> 2] | 0) + i2;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i1 + 68 >> 2] = (HEAP32[i1 + 32 >> 2] | 0) + (i2 << 16 >> 16 << 1);
 if (!(HEAP8[i1 + 16 >> 0] | 0)) {
  i2 = i1 + 52 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = i1 + 48 | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i3 = i2 + (i3 << 5) | 0;
  i2 = i1 + 88 | 0;
  HEAP32[i2 >> 2] = i3;
  return;
 }
 i3 = i2 >> 16;
 HEAP32[i1 + 76 >> 2] = (HEAP32[i1 + 40 >> 2] | 0) + (i3 << 3);
 HEAP32[i1 + 80 >> 2] = (HEAP32[i1 + 44 >> 2] | 0) + (i3 << 3);
 i3 = i1 + 52 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = i1 + 48 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i2 = i3 + (i2 << 5) | 0;
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZNK6Camera22GetCameraToWorldMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i2 + 36 | 0;
 i5 = i2 + 1076 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  __Z20InvertMatrix4x4_FullPKfPf(i4, i1) | 0;
  STACKTOP = i6;
  return;
 }
 if (!(HEAP8[i2 + 1080 >> 0] | 0)) {
  __Z20InvertMatrix4x4_FullPKfPf(i4, i1) | 0;
  STACKTOP = i6;
  return;
 }
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i4, i3) | 0;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN10Matrix4x4fmLERKS_(i4, i3) | 0;
 HEAP8[i5 >> 0] = 0;
 __Z20InvertMatrix4x4_FullPKfPf(i4, i1) | 0;
 STACKTOP = i6;
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, i13 = 0, f14 = f0, i15 = 0;
 i15 = HEAP32[i4 + 48 >> 2] | 0;
 f14 = Math_fround(HEAPF32[i1 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i13 = f14 > Math_fround(0.0);
 i1 = f10 > Math_fround(0.0);
 i4 = f7 > Math_fround(0.0);
 f12 = Math_fround(HEAPF32[i15 + 144 >> 2]);
 f9 = Math_fround(HEAPF32[i15 + 148 >> 2]);
 f6 = Math_fround(HEAPF32[i15 + 152 >> 2]);
 f11 = Math_fround(-f12);
 f8 = Math_fround(-f9);
 f5 = Math_fround(-f6);
 f5 = Math_fround(Math_fround(Math_fround(f14 * (i13 ? f12 : f11)) + Math_fround(f10 * (i1 ? f9 : f8))) + Math_fround(f7 * (i4 ? f6 : f5)));
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i3 >> 2] = Math_fround(-f5);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i7, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i7 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + (i7 << 4) | 0;
 if ((i1 | 0) >= (i7 | 0)) {
  HEAP32[i4 >> 2] = i7;
  return;
 }
 i2 = i6 + 8 | 0;
 i1 = i3 + (i1 << 4) | 0;
 do {
  i3 = i6;
  i8 = HEAP32[i3 + 4 >> 2] | 0;
  i9 = i1;
  HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i9 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
  i9 = i6;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = i8;
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 HEAP32[i4 >> 2] = i7;
 return;
}

function __ZN15MulticastSocket4JoinEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 17 | 0;
 do if (!(HEAP8[i3 >> 0] | 0)) {
  i6 = _htonl(0) | 0;
  i5 = HEAP16[i1 + 22 >> 1] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP16[i2 >> 1] = 2;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP16[i2 + 2 >> 1] = i5;
  if (!(__ZN6Socket10CheckErrorEiPKcii(_bind(HEAP32[i1 + 4 >> 2] | 0, i2, 16) | 0, gb + 584715 | 0, 0, 0) | 0)) {
   HEAP8[i3 >> 0] = 1;
   break;
  }
  i6 = 0;
  STACKTOP = i4;
  return i6 | 0;
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 4 >> 2] = _htonl(0) | 0;
 i6 = (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket15SetSocketOptionEiiPvj(i1, 0, 35, i2, 8) | 0, gb + 584579 | 0, 0, 0) | 0) ^ 1;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN10MemoryPool8AllocateEj(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = i6 + 8 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i3;
  __Z6FormatPKcz(i2, gb + 488742 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 488467 | 0, 146, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = i5 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN10MemoryPool14AllocNewBubbleEv(i5);
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i5 = i1;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z34GetBlendShapeFrameWeightFromScriptRK4Meshii(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 if ((i2 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i5);
 i8 = HEAP32[i1 + 112 >> 2] | 0;
 i3 = i8;
 if (((HEAP32[i1 + 116 >> 2] | 0) - i8 >> 4 | 0) <= (i2 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i5);
 if ((i4 | 0) < 0) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404154 | 0, i6);
 if ((HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0) > (i4 | 0)) {
  f9 = Math_fround(HEAPF32[(HEAP32[i1 + 124 >> 2] | 0) + ((HEAP32[i3 + (i2 << 4) + 8 >> 2] | 0) + i4 << 2) >> 2]);
  STACKTOP = i7;
  return Math_fround(f9);
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404154 | 0, i6);
 return Math_fround(0.0);
}

function __Z30Caching_CUSTOM_CleanNamedCacheP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if ((__ZN14CachingManager21GetAuthorizationLevelEv(__Z17GetCachingManagerv() | 0) | 0) > 1) {
  i1 = __Z17GetCachingManagerv() | 0;
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i2);
  i2 = (__ZN14CachingManager10CleanCacheENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 501688 | 0, 0, gb + 501721 | 0, 66, 1, 0, 0, 0);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i5 = (HEAP8[i2 >> 0] | 0) == 0 ? i5 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i5;
 i7 = i4 + 16 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i4 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i5, 4);
  i6 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  i6 = i2;
 }
 i1 = i5 + 4 | 0;
 i2 = i6 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __ZNSt3__28ios_base5clearEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = (HEAP32[i1 + 24 >> 2] | 0) == 0;
 HEAP32[i1 + 16 >> 2] = i5 & 1 | i2;
 if (!((i5 & 1 | i2) & HEAP32[i1 + 20 >> 2])) {
  STACKTOP = i3;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__217iostream_categoryEv() | 0;
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = gb + 1473496;
 __THREW__ = 0;
 invoke_viii(fb + 1036 | 0, i1 | 0, gb + 1077776 | 0, i4 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  i1 = i5;
 } else {
  __THREW__ = 0;
  invoke_viii(fb + 1035 | 0, i1 | 0, gb + 10904 | 0, fb + 3059 | 0);
  __THREW__ = 0;
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
 }
 ___resumeException(i1 | 0);
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofERKS5_j(i2, i3, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i4 = i1 & 255;
 i1 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i5 = i1 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
 i1 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i1 & 255;
 if (i4 >>> 0 <= i7 >>> 0 | (i1 | 0) == 0) i1 = -1; else {
  i5 = i2 + (i4 << 2) | 0;
  i4 = i6 + (i1 << 2) | 0;
  i1 = i2 + (i7 << 2) | 0;
  L7 : while (1) {
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i5;
    break;
   } else i3 = i6;
   while (1) {
    if ((i3 | 0) == (i4 | 0)) break;
    if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) break L7; else i3 = i3 + 4 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = (i1 | 0) == (i5 | 0) ? -1 : i1 - i2 >> 2;
 }
 return i1 | 0;
}

function __ZN4FMOD5Sound13getVariationsEPfS1_S1_(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869077;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 869077;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869077;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17MessageIdentifier13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[gb + 1104732 >> 2] | 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i1 = i6 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i3 = (HEAP32[i6 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  if ((i4 | 0) != (i6 | 0)) {
   i2 = i6 + 12 | 0;
   i3 = i5 + 4 | 0;
   i1 = i4;
   do {
    i4 = i1;
    i1 = HEAP32[i1 + 4 >> 2] | 0;
    i8 = HEAP32[i2 >> 2] | 0;
    HEAP32[i5 >> 2] = 6;
    HEAP32[i3 >> 2] = i8;
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i5);
   } while ((i1 | 0) != (i6 | 0));
  }
 }
 __ZdlPv(i6);
 HEAP32[gb + 1104732 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXmlD0Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 >> 2] = gb + 146688 + 8;
 HEAP32[i5 + 1028 >> 2] = 0;
 i2 = i5 + 11312 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i5 + 1032 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i5 + 1060 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 1036 >> 2] = 0;
 HEAP32[i5 + 1040 >> 2] = 0;
 HEAP32[i5 + 1048 >> 2] = 0;
 HEAP32[i5 + 1056 >> 2] = 0;
 i4 = 0;
 do {
  i1 = i5 + 9261 + i4 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) i1 = i5 + 1064 + (i4 << 2) | 0; else {
   i7 = HEAP32[i2 >> 2] | 0;
   i6 = i5 + 1064 + (i4 << 2) | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, HEAP32[i6 >> 2] | 0);
   HEAP8[i1 >> 0] = 0;
   i1 = i6;
  }
  HEAP32[i1 >> 2] = 0;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < ((HEAP32[i3 >> 2] | 0) + 1 | 0) >>> 0);
 __ZdlPv(i5);
 return;
}

function __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148800 + 8;
 HEAP32[i1 + 100 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 120 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 104 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 112 >> 2] | 0);
 }
 HEAP32[i1 + 76 >> 2] = gb + 148896 + 8;
 i2 = HEAP32[i1 + 96 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 80 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 88 >> 2] | 0);
 }
 HEAP32[i1 + 52 >> 2] = gb + 148912 + 8;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 64 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12GUIClipState4ClipERK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) {
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
  f5 = Math_fround(0.0);
  f6 = Math_fround(0.0);
  HEAPF32[i1 >> 2] = f6;
  i4 = i1 + 4 | 0;
  HEAPF32[i4 >> 2] = f5;
  return;
 } else {
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + -16 >> 2]));
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + -56 >> 2]));
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i4 + -12 >> 2]));
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i4 + -52 >> 2]));
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = i4;
  HEAPF32[i1 >> 2] = f5;
  i4 = i1 + 4 | 0;
  HEAPF32[i4 >> 2] = f6;
  return;
 }
}

function __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsUInt64ERK8UnityStry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 12 | 0;
 i6 = i4;
 i8 = HEAP8[i1 + 11 >> 0] | 0;
 i9 = i8 << 24 >> 24 < 0;
 i7 = i9 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = i9 ? HEAP32[i1 + 4 >> 2] | 0 : i8 & 255;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i7, i1);
 __Z21UnsignedInt64ToStringy(i6, i2, i3);
 __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i5, i6) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager31OnTimerExpiredPerformArchiveJobERNS0_16SessionContainerE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i5 + 91 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 i3 = i5 + 92 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 if ((HEAP32[i4 >> 2] | 0) != 1) if ((HEAP32[i4 >> 2] | 0) != 2) return;
 i1 = i4 + 552 | 0;
 if ((HEAPU16[i5 + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i2 >> 0] = 0;
 if (HEAP8[i5 + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i5) | 0;
 i1 = HEAP32[i4 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i4 >> 2] | 0) != 1) if ((HEAP32[i4 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i5 | 0);
 } while (0);
 if (HEAP8[i5 + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i5);
 return;
}

function __Z53ParticleSystem_ShapeModule_CUSTOM_SetAlignToDirectionP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[i1 + 48 + 212 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_SetCollidesWithP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 904 >> 2] | 0) + 956 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z33InitializeMeshVertexFormatManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(HEAP32[gb + 1161832 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 i1 = 0;
 do {
  i4 = HEAP32[gb + 1161836 + (i1 << 2) >> 2] | 0;
  i5 = HEAP32[gb + 1161716 >> 2] | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  HEAP32[i2 + 16 >> 2] = 0;
  HEAP32[i2 + 20 >> 2] = 0;
  HEAP32[i2 + 24 >> 2] = 0;
  HEAP32[i2 + 28 >> 2] = 0;
  __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(i6, gb + 1546313 | 0, i2) | 0;
  HEAP32[i4 + 4 >> 2] = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i5, i2) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (HEAP32[gb + 1161832 >> 2] | 0));
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 58;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 77;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i5 | 0, gb + 1474588 | 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 if (!(i7 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 10) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   __ZNSt3__26localeD2Ev(i5);
   i7 = __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwiw(i2, i3, i4, i1) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i5);
 ___resumeException(i7 | 0);
 return 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPci(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i5 | 0, gb + 1474556 | 0) | 0;
 i7 = __THREW__;
 __THREW__ = 0;
 if (!(i7 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 10) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (!(i7 & 1)) {
   __ZNSt3__26localeD2Ev(i5);
   i7 = __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPcic(i2, i3, i4, i1) | 0;
   STACKTOP = i6;
   return i7 | 0;
  }
 }
 i7 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i5);
 ___resumeException(i7 | 0);
 return 0;
}

function __ZNK4Mesh22CalculateStreamsLayoutEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[i2 + 32 >> 2] | 0;
 if (!(HEAP32[i4 + 176 >> 2] | 0)) if ((HEAP32[i2 + 116 >> 2] | 0) == (HEAP32[i2 + 112 >> 2] | 0)) {
  __ZNK14VertexDataInfo16GetStreamsLayoutEv(i3, i4 + 8 | 0);
  HEAP32[i3 >> 2] = (HEAP32[i3 + 4 >> 2] & 255 ^ 255) & ~HEAP32[i3 + 8 >> 2] & ~HEAP32[i3 + 12 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[gb + 59228 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 59228 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 59228 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[gb + 59228 + 12 >> 2];
 STACKTOP = i5;
 return;
}

function __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEiiRiS8_(i1, i2, i9, i10, i11, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i13 = 0;
 HEAP32[i12 >> 2] = 0;
 HEAP32[i11 >> 2] = 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i8 | 0) == (i1 | 0)) {
  i12 = -1;
  return i12 | 0;
 }
 i7 = (i1 - i8 | 0) / 12 | 0;
 i2 = 2147483647;
 i1 = 0;
 i6 = 0;
 do {
  i3 = HEAP32[i8 + (i6 * 12 | 0) >> 2] | 0;
  i4 = i8 + (i6 * 12 | 0) + 4 | 0;
  i5 = i9 - i3 | 0;
  i13 = i10 - (HEAP32[i4 >> 2] | 0) | 0;
  i5 = ((i13 | 0) < 0 ? 0 - i13 | 0 : i13) + ((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0;
  if ((i5 | 0) < (i2 | 0)) {
   HEAP32[i11 >> 2] = i3;
   HEAP32[i12 >> 2] = HEAP32[i4 >> 2];
   i2 = i5;
   i1 = i6;
  }
  i6 = i6 + 1 | 0;
 } while (i6 >>> 0 < i7 >>> 0);
 return i1 | 0;
}

function __ZN8LODGroupD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = gb + 57764 + 8;
 i1 = i7 + 76 | 0;
 if ((HEAP32[i7 + 92 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i7 + 80 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i6 = i7 + 56 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i7 >> 2] = gb + 29060 + 8;
  HEAP32[i7 >> 2] = gb + 26392 + 8;
  return;
 }
 i5 = i7 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  do {
   i3 = i2 + -28 | 0;
   HEAP32[i5 >> 2] = i3;
   i4 = i2 + -20 | 0;
   if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i2 + -16 | 0);
    HEAP32[i4 >> 2] = 0;
    i2 = HEAP32[i5 >> 2] | 0;
   } else i2 = i3;
  } while ((i2 | 0) != (i1 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 __ZdlPv(i1);
 HEAP32[i7 >> 2] = gb + 29060 + 8;
 HEAP32[i7 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i6 >> 2] = i1;
 i5 = i1 & 1;
 i3 = (HEAP32[i7 + 28 + (i5 * 12 | 0) >> 2] | 0) + (i1 >>> 7 << 2) | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = 1 << (i1 >>> 2 & 31);
 if (i4 & i2 | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = i4 | i2;
 i2 = i7 + 52 | 0;
 i3 = i7 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i7 + 60 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i1;
  HEAP32[i3 >> 2] = i4 + 1;
 } else __ZN5physx6shdfnd5ArrayIPNS_2Sq10ActorShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i6) | 0;
 i7 = i7 + 20 + (i5 << 2) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 STACKTOP = i8;
 return;
}

function __ZN5physx19TriangleMeshBuilder18computeLocalBoundsEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 144 | 0;
 __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E(i5, HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 i6 = i1 + 156 | 0;
 f2 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 >> 2])));
 f4 = Math_fround(Math_abs(Math_fround(HEAPF32[i5 >> 2])));
 f4 = f2 > f4 ? f2 : f4;
 i7 = f4 < Math_fround(0.0);
 f4 = i7 ? Math_fround(0.0) : f4;
 f2 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 + 4 >> 2])));
 f3 = Math_fround(Math_abs(Math_fround(HEAPF32[i5 + 4 >> 2])));
 f3 = f2 > f3 ? f2 : f3;
 f3 = f4 > f3 ? f4 : f3;
 f4 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 + 8 >> 2])));
 f2 = Math_fround(Math_abs(Math_fround(HEAPF32[i5 + 8 >> 2])));
 f2 = f4 > f2 ? f4 : f2;
 HEAPF32[i1 + 36 >> 2] = Math_fround((f3 > f2 ? f3 : f2) * Math_fround(2.38418579e-07));
 return;
}

function __ZN5physx15PxsParticleData6createERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i4 = (i4 << 5) + 99 + (HEAP32[i3 + 40 >> 2] | 0 ? i4 << 2 : 0) + (((i4 + 31 | 0) >>> 5 << 2) + 15 & 1073741808) | 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i6 | 0, i5 | 0, i4 | 0, (i1 ? gb + 698983 | 0 : gb + 837976 | 0) | 0, gb + 699101 | 0, 214) | 0;
 if (!i1) {
  i6 = 0;
  __ZN5physx15PxsParticleDataC2ERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E(i6, i3, i2);
  return i6 | 0;
 }
 i6 = i1 + 19 & -16;
 HEAP32[i6 + -4 >> 2] = i6 - i1;
 __ZN5physx15PxsParticleDataC2ERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E(i6, i3, i2);
 return i6 | 0;
}

function __ZN14ConstantStringaSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = HEAP32[i1 >> 2] | 0;
 if (i4 | 0) if (i4 >>> 0 < (gb + 388687 | 0) >>> 0 | i4 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i5 = i4 + -8 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i3, HEAP32[i4 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
  }
 }
 HEAP32[i1 >> 2] = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 i1 = i5;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 if (!(i1 >>> 0 < (gb + 388687 | 0) >>> 0 | i1 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0)) {
  STACKTOP = i6;
  return;
 }
 i5 = i1 + -8 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 STACKTOP = i6;
 return;
}

function __ZN12HandlerChain10PopHandlerEP17FileSystemHandler(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i1 + 4 | 0;
 i7 = i1 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return; else i6 = 0;
 L3 : while (1) {
  while (1) {
   i5 = i2 + (i6 << 2) | 0;
   if ((HEAP32[i5 >> 2] | 0) != (i8 | 0)) break;
   i2 = i5 + 4 | 0;
   i3 = i1 - i2 | 0;
   i4 = i3 >> 2;
   if (!i4) i3 = i1; else {
    _memmove(i5 | 0, i2 | 0, i3 | 0) | 0;
    i1 = HEAP32[i7 >> 2] | 0;
    i3 = i1;
   }
   i2 = i5 + (i4 << 2) | 0;
   if ((i3 | 0) != (i2 | 0)) {
    i1 = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2) | 0;
    HEAP32[i7 >> 2] = i1;
   }
   i2 = HEAP32[i9 >> 2] | 0;
   if (i6 >>> 0 >= i1 - i2 >> 2 >>> 0) {
    i1 = 3;
    break L3;
   }
  }
  i6 = i6 + 1 | 0;
  if (i6 >>> 0 >= i1 - i2 >> 2 >>> 0) {
   i1 = 3;
   break;
  }
 }
 if ((i1 | 0) == 3) return;
}

function __ZL26AssertOptimizeTransferImplRK16TypeTreeIteratoriPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 __ZNK16TypeTreeIterator8ChildrenEv(i3, i1);
 if (!(HEAP32[i3 >> 2] | 0)) if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) + 12 >> 2] | 0) > 0) {
  i4 = HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i4;
  STACKTOP = i5;
  return;
 }
 __ZNK16TypeTreeIterator8ChildrenEv(i3, i1);
 if (HEAP32[i3 >> 2] | 0) do {
  __ZL26AssertOptimizeTransferImplRK16TypeTreeIteratoriPi(i3, i2);
  __ZNK16TypeTreeIterator4NextEv(i4, i3);
  i7 = i4;
  i1 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = i7;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) != (i4 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i4 | 0) >>> 2) << 2);
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i2, i3, i6 + 128 | 0, i6) | 0) {
 case 1:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   return;
  }
 case 4:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Gu21intersectPlaneCapsuleERKNS0_7CapsuleERKNS_7PxPlaneE(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f8 = Math_fround(f8 * f4);
 f2 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f8 + Math_fround(f2 * f6));
 f8 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(f2 + Math_fround(f8 * f5));
 f2 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(f2 + f8);
 f3 = Math_fround(HEAPF32[i7 + 24 >> 2]);
 if (f8 <= f3) {
  i7 = 1;
  return i7 | 0;
 }
 f8 = Math_fround(f4 * Math_fround(HEAPF32[i7 + 12 >> 2]));
 f8 = Math_fround(f8 + Math_fround(f6 * Math_fround(HEAPF32[i7 + 16 >> 2])));
 i7 = Math_fround(f2 + Math_fround(f8 + Math_fround(f5 * Math_fround(HEAPF32[i7 + 20 >> 2])))) <= f3;
 return i7 | 0;
}

function __ZN5physx2Gu12TriangleMesh20checkMeshIndicesSizeEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i7 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 >= 65536) {
  STACKTOP = i8;
  return;
 }
 if (HEAP8[i7 + 172 >> 0] & 2) {
  STACKTOP = i8;
  return;
 }
 i5 = HEAP32[i7 + 20 >> 2] | 0;
 i4 = i7 + 28 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb(i2, i5, 0) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 i5 = i5 * 3 | 0;
 if (i5 | 0) {
  i6 = 0;
  do {
   HEAP16[i4 + (i6 << 1) >> 1] = HEAP32[i3 + (i6 << 2) >> 2];
   i6 = i6 + 1 | 0;
  } while ((i6 | 0) != (i5 | 0));
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv(i2);
 HEAP32[i7 + 32 >> 2] = i7 + 196;
 STACKTOP = i8;
 return;
}

function __ZN4FMOD5Sound6getTagEPKciP8FMOD_TAG(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i3 = i7;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869070;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 869070;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869070;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2UI6Canvas13SetRenderModeENS0_10RenderModeE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i2 + 344 >> 2] | 0;
 if (i1 | 0) {
  __ZN2UI6Canvas13SetRenderModeENS0_10RenderModeE(i1, i3);
  STACKTOP = i5;
  return;
 }
 i1 = i2 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1012705 | 0, 7);
  __ZN2UI6Canvas19SetSortingLayerNameERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 }
 __ZN2UI6Canvas25UpdateCanvasRectTransformEb(i2, 1);
 STACKTOP = i5;
 return;
}

function __ZN13b2DynamicTree11CreateProxyERK6b2AABBPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 i4 = __ZN13b2DynamicTree12AllocateNodeEv(i1) | 0;
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + Math_fround(-.100000001));
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) + Math_fround(-.100000001));
 HEAPF32[i6 + (i4 * 36 | 0) >> 2] = f7;
 HEAPF32[i6 + (i4 * 36 | 0) + 4 >> 2] = f8;
 i6 = HEAP32[i5 >> 2] | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) + Math_fround(.100000001));
 f7 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + Math_fround(.100000001));
 HEAPF32[i6 + (i4 * 36 | 0) + 8 >> 2] = f8;
 HEAPF32[i6 + (i4 * 36 | 0) + 12 >> 2] = f7;
 i2 = HEAP32[i5 >> 2] | 0;
 HEAP32[i2 + (i4 * 36 | 0) + 16 >> 2] = i3;
 HEAP32[i2 + (i4 * 36 | 0) + 32 >> 2] = 0;
 __ZN13b2DynamicTree10InsertLeafEi(i1, i4);
 return i4 | 0;
}

function __ZN13MonoBehaviour18CallMethodInactiveE21ScriptingMethodIl2Cpp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 256 | 0;
 i4 = i3 + 248 | 0;
 i5 = i3 + 8 | 0;
 i8 = i3;
 HEAP32[i4 >> 2] = 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 i10 = i2;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i2 = i8;
 HEAP32[i2 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i2 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i7, i6);
 HEAP8[i5 + 233 >> 0] = 1;
 HEAP32[i5 + 216 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i5);
 __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i5, i4) | 0;
 STACKTOP = i3;
 return (HEAP32[i4 >> 2] | 0) == 0 | 0;
}

function __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!i2) return;
 __ZN11UnityEngine9Animation31UnregisterGenericBindingObjectsEPNS0_30AnimatorGenericBindingConstantE(i2);
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) i1 = i3; else {
  __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(HEAP32[i1 + 4 >> 2] | 0, i3);
  __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i3);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i1 + 8 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i1 + 12 >> 2] | 0);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i1 | 0);
  i1 = i3;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 | 0);
 return;
}

function __Z61ParticleSystem_ShapeModule_CUSTOM_SetSphericalDirectionAmountP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 208 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z55AvatarBuilder_CUSTOM_INTERNAL_CALL_BuildHumanAvatarMonoP12Il2CppObjectRK20MonoHumanDescription(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i3 + 52 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 64 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __Z24HumanDescriptionFromMonoRK20MonoHumanDescriptionR16HumanDescription(i2, i3);
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i5 = __Z24BuildHumanAvatarInternalP10GameObjectRK16HumanDescription(i1, i3) | 0;
 __ZN16HumanDescriptionD2Ev(i3);
 STACKTOP = i4;
 return i5 | 0;
}

function __Z43ParticleSystem_LightsModule_CUSTOM_SetRatioP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 920 >> 2] | 0) + 8 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __GLOBAL__sub_I_runtime_gamecode_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155120 | 0, gb + 391104 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155132 | 0, gb + 391120 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155144 | 0, gb + 391141 | 0, 15, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155156 | 0, gb + 391161 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155168 | 0, gb + 391173 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155180 | 0, gb + 391191 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155192 | 0, gb + 391211 | 0, 11, 0);
 return;
}

function __ZN5physx10PxsContext21addParticleSystemImplEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb(i5, i4, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i5 + 252 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) if (__ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE6extendEv(i5 + 232 | 0) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i5 = 0;
  __ZN5physx20PxsParticleSystemSim4initERNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterE(i5, i4, i3);
  return i5 | 0;
 } while (0);
 i1 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = HEAP32[(HEAP32[i5 + 248 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i1 = HEAP32[i2 + 1124 >> 2] | 0;
 i5 = (HEAP32[i5 + 264 >> 2] | 0) + (i1 >>> 5 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1 << (i1 & 31);
 i5 = i2;
 __ZN5physx20PxsParticleSystemSim4initERNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterE(i5, i4, i3);
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup20override3DAttributesEPK11FMOD_VECTORS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868246;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868246;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868246;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN15DirectorManager14ConnectionPool16GrowEmptyBucketsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0, i9 = 0;
 i5 = i4 + 4 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i3 = 0;
 do {
  i1 = HEAP32[i4 + 8 + (i3 << 2) >> 2] | 0;
  if ((i1 | 0) > 0) if (!(HEAP32[HEAP32[i4 + 48 + (i3 << 2) >> 2] >> 2] | 0)) {
   f6 = Math_fround(i1 | 0);
   i2 = ~~Math_fround(f6 * Math_fround(HEAPF32[i4 >> 2]));
   if (i2 | 0) {
    i1 = 0;
    do {
     i8 = __ZN15DirectorManager14ConnectionPool10CreateItemEi(i4, i3) | 0;
     i7 = i8 + 56 | 0;
     i9 = i4 + 28 + (HEAP32[i7 >> 2] << 2) | 0;
     HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
     i7 = HEAP32[i4 + 48 + (HEAP32[i7 >> 2] << 2) >> 2] | 0;
     HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
     HEAP32[i7 >> 2] = i8;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) != (i2 | 0));
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __Z50ParticleSystem_ShapeModule_CUSTOM_SetUseMeshColorsP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[i1 + 48 + 214 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45Component_CUSTOM_GetComponentsForListInternalP12Il2CppObjectS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i5 + 28 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP8[i4 + 21 >> 0] = 1;
  HEAP8[i4 + 22 >> 0] = 1;
  HEAP8[i4 + 20 >> 0] = 0;
  HEAP8[i4 + 12 >> 0] = 0;
  HEAP8[i4 + 14 >> 0] = 1;
  HEAP32[i4 + 8 >> 2] = i3;
  HEAP8[i4 + 13 >> 0] = 0;
  __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i4) | 0;
  STACKTOP = i6;
  return;
 }
}

function __Z42ParticleSystem_TrailModule_CUSTOM_SetRatioP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i1 + 908 >> 2] | 0) + 8 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIhbEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24 != 0;
   i6 = i6 & 1;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24 != 0;
 i6 = i6 & 1;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIabEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24 != 0;
   i6 = i6 & 1;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24 != 0;
 i6 = i6 & 1;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z18IntersectRaySphereRK3RayRK6Sphere(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 >> 2]));
 f2 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f4 = Math_fround(f6 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f4 = Math_fround(f4 + Math_fround(f2 * Math_fround(HEAPF32[i1 + 16 >> 2])));
 f4 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 20 >> 2])));
 f5 = Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f2 * f2)) + Math_fround(f5 * f5));
 f2 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f2 = Math_fround(f2 * f2);
 if (f4 < Math_fround(0.0) & f5 > f2) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = !(Math_fround(f5 - Math_fround(f4 * f4)) > f2);
 return i3 | 0;
}

function _fgetln(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9;
 if ((HEAP32[i7 + 76 >> 2] | 0) > -1) i8 = ___lockfile(i7) | 0; else i8 = 0;
 i4 = i7 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i7 + 8 | 0;
 if (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i1 + 1;
  i1 = HEAPU8[i1 >> 0] | 0;
 } else i1 = ___uflow(i7) | 0;
 _ungetc(i1, i7) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1;
 i2 = _memchr(i1, 10, (HEAP32[i2 >> 2] | 0) - i3 | 0) | 0;
 if (!i2) {
  i2 = i7 + 92 | 0;
  HEAP32[i5 >> 2] = 0;
  i1 = _getline(i2, i5, i7) | 0;
  if ((i1 | 0) > 0) {
   HEAP32[i6 >> 2] = i1;
   i1 = HEAP32[i2 >> 2] | 0;
  } else i1 = 0;
 } else {
  i5 = i2 + 1 | 0;
  HEAP32[i6 >> 2] = i5 - i3;
  HEAP32[i4 >> 2] = i5;
 }
 if (i8 | 0) ___unlockfile(i7);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN20ArchiveStorageReader15MakeStorageUsedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 4 | 0;
 i6 = i1 + 2336 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i3 + 1;
 if (i3 | 0) {
  i6 = 1;
  STACKTOP = i5;
  return i6 | 0;
 }
 i3 = i1 + 188 | 0;
 if (__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i1 + 1248 | 0, i3, 0, 0) | 0) {
  i6 = 1;
  STACKTOP = i5;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = __ZNK15FileSystemEntry4PathEv(i3) | 0;
 __Z6FormatPKcz(i2, gb + 489660 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 489692 | 0, 483, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i6 = 0;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN12_GLOBAL__N_112UserRendererD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150452 + 8;
 i1 = i4 + 56 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 52 | 0;
  i3 = 0;
  do {
   i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = gb + 150548 + 8;
 i5 = HEAP32[i4 + 60 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i5 = HEAP32[i4 + 44 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i4 + 52 >> 2] | 0);
 }
 HEAP32[i4 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i4);
  return;
 }
 i5 = HEAP32[i4 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 __ZdlPv(i4);
 return;
}

function __ZN12_GLOBAL__N_110DataStream14createInstanceERKN5physx8debugger14NamespacedNameEPKv(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i7 = HEAP32[i3 + 64 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i1 | 0, i2 | 0) | 0;
 i7 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 >> 2] | 0) | 0;
 i6 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = gb + 150260 + 8;
 i1 = i5 + 4 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i6;
 i1 = i5 + 16 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 6);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN11UnityEngine7Connect20BasePersistentValuesC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 189084 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 190224 + 8;
 i1 = i2 + 2256 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 2268 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 2236 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 2248 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev(i2 + 2168 | 0);
 __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev(i2);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11LightProbes22SetBakedLightOcclusionEPK19LightProbeOcclusioni(i5, i7, i1) {
 i5 = i5 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i8 = 0;
 i6 = i5 + 168 | 0;
 i8 = i5 + 180 | 0;
 i1 = i1 << 3;
 i2 = i1 >> 3;
 HEAP32[i8 >> 2] = i2;
 i3 = i5 + 184 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, i1, 4, i5 + 172 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i6 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 172 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i6 >> 2] = i1;
  break;
 } else i1 = HEAP32[i6 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i7 | 0, HEAP32[i8 >> 2] << 3 | 0) | 0;
 return;
}

function __Z51ParticleSystem_InheritVelocityModule_CUSTOM_SetModeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 872 >> 2] | 0) + 8 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z32setPxVehicleDriveNWMDriveSimDataPN5physx16PxVehicleDriveNWENS_23PxVehicleDriveSimDataNWE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 64 | 0;
 _memcpy(i2 + 224 | 0, i1 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 288 >> 2] = HEAP32[i3 >> 2];
 i3 = i2 + 304 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 336 | 0, i1 + 112 | 0, 416) | 0;
 i2 = i2 + 752 | 0;
 i1 = i1 + 528 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __Z19GetGlobalPreferencePKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 24 | 0;
 i5 = i3 + 12 | 0;
 i6 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i2, _strlen(i2) | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i1, i5, i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, gb + 1048681 | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i3, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, gb + 1048690 | 0, HEAP32[gb + 37304 >> 2] | 0, i2, 4194305);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __ZN5physx19NpArticulationJoint12setDriveTypeENS_28PxArticulationJointDriveType4EnumE(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE(i1, i8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 124 >> 2] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16384;
 return;
}

function __ZN23ManagedAttributeManager52CallManagedGetParentTypeDisallowingMultipleInclusionEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 248 | 0;
 i4 = i2;
 i5 = i2 + 240 | 0;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 56 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i1) | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(__ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN13MonoBehaviour25TransferEngineAndInstanceI17RemapPPtrTransferEEvRT_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i3);
 i7 = HEAP32[i2 + 36 >> 2] | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i7 | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 i5 = (HEAP8[i3 + 40 >> 0] | 0) == 0;
 HEAP32[i1 >> 2] = i5 ? i7 : i6;
 if (!i5) __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i2, i1, 0);
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i7 = __ZNK13MonoBehaviour8GetClassEv(i2) | 0;
 __Z23TransferScriptingObjectI17RemapPPtrTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i3, i1, i7, HEAP32[i2 + 56 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager27ProcessFlushEventsJobStaticEPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 552 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 4) return;
 HEAP32[i2 + 560 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 40 + (i3 << 7) | 0;
 if ((HEAPU16[i2 + 40 + (i3 << 7) + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i2 + 40 + (i3 << 7) + 92 >> 0] = 0;
 HEAP8[i2 + 40 + (i3 << 7) + 91 >> 0] = 0;
 if (HEAP8[i2 + 40 + (i3 << 7) + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i4) | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i2 >> 2] | 0) != 1) if ((HEAP32[i2 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i4 | 0);
 } while (0);
 if (HEAP8[i2 + 40 + (i3 << 7) + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
 return;
}

function __Z58ParticleSystem_ShapeModule_CUSTOM_SetRandomDirectionAmountP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 204 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveCountP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 888 >> 2] | 0) + 808 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_CollisionModule_CUSTOM_SetQualityP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 904 >> 2] | 0) + 960 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _wcstox(i7, i8, i6) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 var d1 = 0.0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i12;
 i10 = i9 + 8 | 0;
 i11 = i9 + 4 | 0;
 i2 = i12 + 112 + 4 | 0;
 i3 = i9 + 44 | 0;
 i4 = i9;
 i5 = i4 + 112 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i9 + 48 >> 2] = 60;
 HEAP32[i9 + 76 >> 2] = -1;
 HEAP32[i9 + 32 >> 2] = fb + 499;
 i2 = i7;
 while (1) if (!(_iswspace(HEAP32[i2 >> 2] | 0) | 0)) break; else i2 = i2 + 4 | 0;
 HEAP32[i9 + 84 >> 2] = i2;
 ___shlim(i9, 0);
 d1 = +___floatscan(i9, i6, 1);
 if (i8 | 0) {
  i11 = (HEAP32[i11 >> 2] | 0) - (HEAP32[i10 >> 2] | 0) + (HEAP32[i9 + 108 >> 2] | 0) | 0;
  HEAP32[i8 >> 2] = (i11 | 0) == 0 ? i7 : i2 + (i11 << 2) | 0;
 }
 STACKTOP = i12;
 return +d1;
}

function __ZNKSt3__212ctype_bynameIwE5do_isEtw(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i1 & 65535;
 if (!(i2 & 8192)) i1 = 0; else i1 = (_iswspace_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 16384) i1 = i1 | (_iswprint_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 2) i1 = i1 | (_iswcntrl_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 256) i1 = i1 | (_iswupper_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 512) i1 = i1 | (_iswlower_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 1024) i1 = i1 | (_iswalpha_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 2048) i1 = i1 | (_iswdigit_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 4) i1 = i1 | (_iswpunct_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 4096) i1 = i1 | (_iswxdigit_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 if (i2 & 1) i1 = i1 | (_iswblank_l(i4, HEAP32[i3 + 8 >> 2] | 0) | 0) != 0;
 return i1 | 0;
}

function __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 32 | 0;
 i5 = i4 + 20 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2 + 32 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z25InverseTransformDirection23TransformAccessReadOnlyRKN4math7_float3Eb(i5, i7, i6, 0);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx9NpPhysics12getMaterialsEPPNS_10PxMaterialEjj(i2, i10, i1, i9) {
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i11 = 0;
 i11 = i2 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i11 >> 2] | 0);
 i8 = HEAP32[i2 + 56 >> 2] | 0;
 i6 = i2 + 52 | 0;
 i2 = 0;
 i3 = 0;
 i7 = 0;
 L1 : while (1) {
  i5 = i3;
  while (1) {
   if (i2 >>> 0 >= i8 >>> 0) {
    i1 = i7;
    break L1;
   }
   i4 = HEAP32[i6 >> 2] | 0;
   while (1) {
    i3 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
    i2 = i2 + 1 | 0;
    if (i3 | 0) {
     i4 = i3;
     break;
    }
    if (i2 >>> 0 >= i8 >>> 0) {
     i1 = i7;
     break L1;
    }
   }
   i3 = i5 + 1 | 0;
   if (i5 >>> 0 < i9 >>> 0) i5 = i3; else break;
  }
  if ((i7 | 0) == (i1 | 0)) break;
  HEAP32[i10 + (i7 << 2) >> 2] = i4;
  i7 = i7 + 1 | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i11 >> 2] | 0);
 return i1 | 0;
}

function __ZNK14ParticleSystem27GetSafeTriggerParticlesSizeEN13TriggerEvents9EventTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 switch (i2 | 0) {
 case 0:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 8 >> 2] | 0) != 2) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[i3 + 652 >> 2] | 0;
   return i3 | 0;
  }
 case 1:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 12 >> 2] | 0) != 2) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[i3 + 672 >> 2] | 0;
   return i3 | 0;
  }
 case 2:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 16 >> 2] | 0) != 2) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[i3 + 692 >> 2] | 0;
   return i3 | 0;
  }
 case 3:
  {
   if ((HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 20 >> 2] | 0) != 2) {
    i3 = 0;
    return i3 | 0;
   }
   i3 = HEAP32[i3 + 712 >> 2] | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i9 = gb + 1164176 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 while (1) {
  __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i5, i1, i3, -1, 8);
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP8[i2 + 4 >> 0] = HEAP8[i5 + 4 >> 0] | 0;
  if (HEAP32[i2 >> 2] | 0) {
   i1 = 5;
   break;
  }
  i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
  if (!((i1 | 0) != (i4 | 0) & (i1 | 0) != 0)) {
   i1 = 5;
   break;
  }
 }
 if ((i1 | 0) == 5) {
  STACKTOP = i6;
  return;
 }
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  HEAP16[i6 + 2 >> 1] = 15360;
  HEAP16[i6 + 4 >> 1] = 15360;
  HEAP16[i6 + 6 >> 1] = 15360;
  if (!i1) break; else {
   i6 = i6 + 8 | 0;
   i5 = i5 + 4 | 0;
  }
 }
 return;
}

function __ZN14TerrainManager13RemoveTerrainEP7Terrain(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 i6 = i4 + 4 | 0;
 L1 : do if ((i2 | 0) == (i6 | 0)) i1 = i2; else {
  i1 = i2;
  do {
   if ((HEAP32[i2 + 8 >> 2] | 0) == (i3 | 0)) break L1;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
  } while ((i1 | 0) != (i6 | 0));
  STACKTOP = i7;
  return;
 } while (0);
 if ((i1 | 0) == (i6 | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[HEAP32[i6 >> 2] >> 2] = i3;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 i6 = HEAP32[i4 + 16 >> 2] | 0;
 HEAP32[i5 >> 2] = 52;
 HEAP32[i5 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i5);
 STACKTOP = i7;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager22setIsTopLevelUIElementEPKvb(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv(i1, i4) | 0;
 HEAP8[i2 + 7 >> 0] = i5 & 1;
 HEAP8[i2 + 8 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __Z47ParticleSystem_LightsModule_CUSTOM_SetMaxLightsP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 920 >> 2] | 0) + 552 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __ZNK5Umbra4Tome15getObjectBoundsEiRNS_7Vector3ES2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 i2 = i1 + (HEAP32[i1 + 68 >> 2] | 0) + (i2 * 24 | 0) | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 _memmove(i3 | 0, i2 | 0, 12) | 0;
 i3 = i6 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZNK12NavMeshAgent17GetGroundPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 68 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) {
  i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
  f6 = Math_fround(-Math_fround(HEAPF32[i2 + 44 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = f6;
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  __ZNK9Transform14TransformPointERK8Vector3f(i1, i4, i3);
  STACKTOP = i5;
  return;
 } else {
  i4 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i4) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 + 480 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 484 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 488 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __ZN9BoxPruner17prepareOverlapsMTEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 116 | 0;
 i2 = (HEAP8[i4 + 168 >> 0] | 0) == 0;
 if (!(HEAP32[i1 >> 2] | 0)) if (i2) return; else i3 = 4; else if (!i2) i3 = 4;
 if ((i3 | 0) == 4) {
  __ZN9BoxPruner10staticSortEv(i4);
  HEAP32[i1 >> 2] = HEAP32[i4 + 92 >> 2];
  HEAP32[i4 + 120 >> 2] = 0;
  HEAP8[i4 + 169 >> 0] = 1;
 }
 __ZN9BoxPruner14preparePruningER16MBPOS_TmpBuffers(i4, i4 + 176 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 84 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i4 + 32 >> 2] = HEAP32[i4 + 76 >> 2];
   HEAP32[i4 + 36 >> 2] = i1;
   HEAP32[i4 + 40 >> 2] = i2;
   HEAP32[i4 + 44 >> 2] = HEAP32[i4 + 12992 >> 2];
   HEAP32[i4 + 48 >> 2] = HEAP32[i4 + 96 >> 2];
   HEAP32[i4 + 52 >> 2] = HEAP32[i4 + 104 >> 2];
   HEAP32[i4 + 56 >> 2] = HEAP32[i4 + 144 >> 2];
   HEAP8[i4 + 60 >> 0] = 1;
   return;
  }
 }
 HEAP8[i4 + 60 >> 0] = 0;
 return;
}

function __ZN8LODGroup17GetWorldSpaceSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2 + 4 | 0;
 i7 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 i8 = f5 < Math_fround(0.0);
 f4 = Math_fround(-f5);
 f5 = i8 ? f4 : f5;
 HEAPF32[i7 >> 2] = f5;
 f4 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i8 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 f4 = i8 ? f3 : f4;
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = f5 < f4 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i6 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f4 = i6 ? f5 : f4;
 f3 = Math_fround((f3 < f4 ? f4 : f3) * Math_fround(HEAPF32[i1 + 44 >> 2]));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN5physx7NpScene9lockWriteEPKcj(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 3876 | 0;
 i2 = __ZN5physx6shdfnd6TlsGetEj(HEAP32[i1 >> 2] | 0) | 0;
 i3 = i2 >>> 24;
 i4 = i3 & 255;
 if (!((i2 & 16711680 | 0) == 0 | i4 << 24 >> 24 != 0)) {
  i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i7 = (i5 | 0) != 0;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 8, i7 ? i5 : gb + 678666 | 0, i7 ? i6 : 2951, gb + 703688 | 0, i8);
  STACKTOP = i8;
  return;
 }
 __ZN5physx6shdfnd6TlsSetEjPv(HEAP32[i1 >> 2] | 0, i2 & 16777215 | (i3 << 24) + 16777216) | 0;
 if (!(i4 << 24 >> 24)) __ZN5physx6shdfnd13ReadWriteLock10lockWriterEv(i7 + 3884 | 0);
 HEAP32[i7 + 3880 >> 2] = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Sc10NPhaseCore11narrowPhaseEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = (HEAP32[i8 >> 2] | 0) + 1204 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if (!i1) return;
 i6 = i1 << 2 >> 2;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 i5 = 0;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 0 : i2 + -8 | 0;
  __ZN5physx2Sc10NPhaseCore19findTriggerContactsEPNS0_18TriggerInteractionEbb(i8, i2, 0, 0);
  i3 = i2 + 56 | 0;
  i4 = HEAPU16[i3 >> 1] | 0;
  do if (!(i4 & 32)) i1 = i1 + 4 | 0; else {
   HEAP16[i3 >> 1] = i4 & 65503;
   if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, 0) | 0) {
    i1 = i1 + 4 | 0;
    break;
   } else {
    __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE(HEAP32[i7 >> 2] | 0, i2 + 8 | 0);
    break;
   }
  } while (0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i6 | 0));
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE16StripInvalidKeysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 120 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + 132 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i2;
 i4 = i2 + (i3 * 40 | 0) | 0;
 L4 : while (1) {
  while (1) {
   if (!(((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 8 >> 2] & 2139095040 | 0) != 2139095040 : 0) & (HEAP32[i1 + 12 >> 2] & 2139095040 | 0) != 2139095040)) break;
   if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
   i1 = i1 + 40 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 8;
    break L4;
   }
  }
  i4 = i1 + 40 | 0;
  _memmove(i1 | 0, i4 | 0, i2 + (i3 * 40 | 0) - i4 | 0) | 0;
  i3 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i3;
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i2 + (i3 * 40 | 0) | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZN14DirectorPlayer14OnProcessStageERK13dynamic_arrayI11DirectorJobLj8EE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = i2 + 12 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i5 = i3 + 24 | 0;
 i6 = i3 + 16 | 0;
 i7 = i3 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do {
  HEAP32[i3 >> 2] = fb + 153;
  HEAP8[i5 >> 0] = 0;
  i9 = i6;
  HEAP32[i9 >> 2] = 0;
  HEAP32[i9 + 4 >> 2] = 0;
  HEAP8[i7 >> 0] = 1;
  __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf(i3, (HEAP32[i1 >> 2] | 0) + 88 | 0, HEAP32[i1 + 12 >> 2] | 0, 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0, Math_fround(1.0));
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 24 | 0) | 0));
 STACKTOP = i8;
 return;
}

function __Z47ParticleSystem_EmissionModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[i1 + 264 + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _ether_aton_r(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 4 | 0;
 i6 = i8;
 i4 = 0;
 while (1) {
  if (i4) {
   if ((HEAP8[i2 >> 0] | 0) != 58) {
    i1 = 0;
    break;
   }
   i2 = i2 + 1 | 0;
  }
  i3 = _strtoul(i2, i6, 16) | 0;
  if (i3 >>> 0 > 255) {
   i1 = 0;
   break;
  }
  i2 = HEAP32[i6 >> 2] | 0;
  HEAP8[i5 + i4 >> 0] = i3;
  i4 = i4 + 1 | 0;
  if ((i4 | 0) >= 6) {
   i7 = 7;
   break;
  }
 }
 if ((i7 | 0) == 7) if (!(HEAP8[i2 >> 0] | 0)) {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
  HEAP8[i1 + 2 >> 0] = HEAP8[i5 + 2 >> 0] | 0;
  HEAP8[i1 + 3 >> 0] = HEAP8[i5 + 3 >> 0] | 0;
  HEAP8[i1 + 4 >> 0] = HEAP8[i5 + 4 >> 0] | 0;
  HEAP8[i1 + 5 >> 0] = HEAP8[i5 + 5 >> 0] | 0;
 } else i1 = 0;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if ((i4 | 0) == (i1 | 0)) i1 = 1; else if (!i1) i1 = 0; else {
  i1 = ___dynamic_cast(i1, gb + 13008 | 0, gb + 12992 | 0, 0) | 0;
  if (!i1) i1 = 0; else {
   i2 = i6 + 4 | 0;
   i3 = i2 + 52 | 0;
   do {
    HEAP32[i2 >> 2] = 0;
    i2 = i2 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 8 >> 2] = i4;
   HEAP32[i6 + 12 >> 2] = -1;
   HEAP32[i6 + 48 >> 2] = 1;
   mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i6 | 0, HEAP32[i5 >> 2] | 0, 1);
   if ((HEAP32[i6 + 24 >> 2] | 0) == 1) {
    HEAP32[i5 >> 2] = HEAP32[i6 + 16 >> 2];
    i1 = 1;
   } else i1 = 0;
  }
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN9Heightmap13UpdatePhysicsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 1;
 HEAPF32[i3 + 20 >> 2] = Math_fround(-1.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 HEAP16[i3 + 28 >> 1] = 0;
 if (__ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE(i2, i3) | 0) {
  i2 = __Z11GetIPhysicsv() | 0;
  HEAP32[i4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i3 | 0) | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64016 | 0);
 }
 STACKTOP = i5;
 return;
}

function __ZN8Collider22FetchPoseFromTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 40 | 0;
 i4 = i2 + 28 | 0;
 i3 = i2;
 __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i4, i5);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i3 | 0, 1);
 STACKTOP = i2;
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI16TexFormatRGFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f9 = Math_fround(HEAPF32[i1 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
  i7 = f9 < Math_fround(0.0);
  i6 = f9 > Math_fround(1.0);
  i6 = ~~Math_fround(Math_fround((i6 ? Math_fround(1.0) : f9) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8;
  i5 = f8 < Math_fround(0.0);
  i3 = f8 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f8) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 16;
  HEAP32[i4 >> 2] = (i7 ? -16776961 : i6 & 65280 | -16776961) | (i5 ? 0 : i3);
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv(i10) {
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i11 = 0;
 i7 = HEAP32[i10 + 72 >> 2] | 0;
 i8 = (i7 | 0) == 0;
 if (!i8) __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 + 4 >> 2] | 0);
 i5 = i10 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i9 = i10 + 20 | 0;
 i1 = i6;
 i3 = (HEAP32[i9 >> 2] | 0) - i1 | 0;
 i4 = HEAP32[i10 + 36 >> 2] | 0;
 if (i4) {
  i1 = i10 + 32 | 0;
  i2 = 0;
  do {
   i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i11 >> 2] | 0) + 8 >> 2] | 0, i11 | 0, i6 | 0, i3 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i4 | 0));
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0);
 if (i8) return;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 + 4 >> 2] | 0);
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE(i8, i6) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i8 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i4 = i8 + 268 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i5 = i8 + 264 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i6 | 0)) {
    i1 = i3;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break L1;
  }
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0);
  i6 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i6;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i6 << 2) >> 2];
  i1 = i6;
 } while (0);
 HEAP8[i8 + 276 >> 0] = (i1 | 0) != 0 & 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __ZN5physx13NpRigidStatic11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 if ((mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 104 >> 2] | 0, i6 | 0) | 0) == 65535) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = HEAP32[gb + 1457324 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
 i1 = mftCall_iiiiiii(i9 | 0, i8 | 0, i2 | 0, i4 | 0, i3 | 0, 1, i1 | 0) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i6 + 20 | 0, i1, i6);
 __ZN5physx7NpShape15releaseInternalEv(i1);
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN5Unity17ConfigurableJoint23SetAngularYZLimitSpringERK20SoftJointLimitSpring(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i5 = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 i3 = i3 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f2 < Math_fround(0.0);
 i1 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i1 ? Math_fround(340282326000000008404918.0e15) : f2;
 i1 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 + 172 >> 2] = i3;
 HEAP32[i4 + 176 >> 2] = i1;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i4);
 return;
}

function __ZN23ManagedAttributeManager41GetParentTypeDisallowingMultipleInclusionEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 248 | 0;
 i4 = i1 + 8 | 0;
 i5 = i1;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 56 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i2) | 0);
 HEAP32[i3 >> 2] = 0;
 i2 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(__ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN15ReflectionProbeC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 35464 + 8;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP8[i1 + 144 >> 0] = 0;
 HEAP32[i1 + 148 >> 2] = -9999;
 HEAP32[i1 + 156 >> 2] = -1;
 HEAP8[i1 + 160 >> 0] = 1;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 168 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN10Matrix4x4f19SetPerspectiveCotanEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var f5 = f0;
 f5 = Math_fround(f3 - f4);
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(f3 + f4) / f5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(Math_fround(Math_fround(f3 * Math_fround(2.0)) * f4) / f5);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return i1 | 0;
}

function __Z50Mesh_CUSTOM_INTERNAL_CALL_GetNativeVertexBufferPtrP12Il2CppObjectiRPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i1, i4, HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 96 >> 2] | 0, 0, 0) | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) > -1 & i1 >>> 0 > i2 >>> 0) {
  i5 = __Z12GetGfxDevicev() | 0;
  HEAP32[i3 >> 2] = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 720 >> 2] | 0, i5 | 0, HEAP32[i4 + 8 + (i2 << 3) >> 2] | 0) | 0;
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i1;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 547165 | 0, i5);
 }
}

function __Z46ParticleSystem_TriggerModule_CUSTOM_SetOutsideP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 12 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_CollisionModule_CUSTOM_SetTypeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 904 >> 2] | 0) + 136 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_CollisionModule_CUSTOM_SetModeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 904 >> 2] | 0) + 140 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z42TrailRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 384 >> 2] | 0;
  i3 = HEAP32[i3 + 108 + ((HEAPU8[i3 + 172 >> 0] | 0) + -1 << 2) >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z41CommandBuffer_CUSTOM_SetGlobalMatrixArrayP12Il2CppObjectiP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7 + 12 | 0;
 if (!i3) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1041262 | 0);
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if (!i5) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 558494 | 0, i7);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6); else {
  HEAP32[i4 >> 2] = i2;
  __ZN22RenderingCommandBuffer23AddSetGlobalMatrixArrayERKN9ShaderLab16FastPropertyNameEPK10Matrix4x4fi(i1, i4, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 64) | 0, i5);
  STACKTOP = i7;
  return;
 }
}

function __Z22Animation_CUSTOM_BlendP12Il2CppObjectP12Il2CppStringff(i2, i1, f3, f4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Animation5BlendERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEff(i1, i6, f3, f4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 36 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi(i1, i2, i3, i4, f5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var f7 = f0, f8 = f0, f9 = f0;
 if (!i2) return;
 if (i4) mftCall_viiii(HEAP32[i1 + 28 >> 2] | 0, 0, 0, 0, 1);
 if (i2 & 16384 | 0) {
  f9 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
  mftCall_vffff(HEAP32[i1 + 456 >> 2] | 0, +f9, +f8, +f7, +Math_fround(HEAPF32[i3 + 12 >> 2]));
 }
 do if (i2 & 256 | 0) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 719 >> 0] | 0)) {
  mftCall_vd(HEAP32[i1 + 568 >> 2] | 0, +(+f5));
  break;
 } else {
  mftCall_vf(HEAP32[i1 + 460 >> 2] | 0, +f5);
  break;
 } while (0);
 if (i2 & 1024 | 0) mftCall_vi(HEAP32[i1 + 464 >> 2] | 0, i6 | 0);
 mftCall_vi(HEAP32[i1 + 452 >> 2] | 0, i2 | 0);
 if (!i4) return;
 mftCall_viiii(HEAP32[i1 + 28 >> 2] | 0, 1, 1, 1, 1);
 return;
}

function __ZN5Unity17ConfigurableJoint22SetAngularXLimitSpringERK20SoftJointLimitSpring(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i5 = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 i3 = i3 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f2 < Math_fround(0.0);
 i1 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i1 ? Math_fround(340282326000000008404918.0e15) : f2;
 i1 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 + 140 >> 2] = i3;
 HEAP32[i4 + 144 >> 2] = i1;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i4);
 return;
}

function __ZN4FMOD5Sound21setMusicChannelVolumeEif(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869091;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 869091;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869091;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN21AssetBundleFileSystem10ToAbsoluteEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i3 | 0) | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3, _strlen(i3) | 0);
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i3, _strlen(i3) | 0);
  __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2 + 96 | 0, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN16ReflectionProbes15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __Znwj(316) | 0;
 __ZN16ReflectionProbesC2Ev(i3);
 HEAP32[gb + 1112272 >> 2] = i3;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 37052 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 36284 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 36284 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 36284 + (i1 * 12 | 0) >> 2] = fb + 2381;
 STACKTOP = i5;
 return;
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_SetQualityP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 888 >> 2] | 0) + 820 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z41LineRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 344 >> 2] | 0;
  i3 = HEAP32[i3 + 108 + ((HEAPU8[i3 + 172 >> 0] | 0) + -1 << 2) >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z36AnimationClip_CUSTOM_SampleAnimationP12Il2CppObjectS0_f(i3, i1, f4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i1 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __Z15SampleAnimationR10GameObjectR13AnimationClipfi(i5, i2, f4, HEAP32[i1 + 96 >> 2] | 0);
  return;
 }
}

function __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 4 | 0;
 i6 = i9;
 HEAP32[i5 >> 2] = 0;
 i1 = _il2cpp_class_get_fields(i3 | 0, i5 | 0) | 0;
 HEAP32[i6 >> 2] = i1;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i7 = i4 + 4 | 0;
 i8 = i4 + 8 | 0;
 do {
  i2 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) == (HEAP32[i8 >> 2] | 0)) __ZNSt3__26vectorIP9FieldInfo13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i4, i6); else {
   HEAP32[i2 >> 2] = i1;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
  }
  i1 = _il2cpp_class_get_fields(i3 | 0, i5 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
 } while ((i1 | 0) != 0);
 STACKTOP = i9;
 return;
}

function __Z26Animation_CUSTOM_CrossFadeP12Il2CppObjectP12Il2CppStringfi(i2, i1, f3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 12 | 0;
 i6 = i7;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i6, i5);
  __ZN9Animation9CrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfi(i1, i6, f3, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i7;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2 + 20 | 0, HEAP32[i2 + 24 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN8Material13AwakeFromLoadE17AwakeFromLoadMode(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i6 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(228, gb + 63288 | 0, 16, gb + 469775 | 0, 390) | 0;
  __ZN18SharedMaterialDataC2Ev(i1);
  HEAP32[i2 >> 2] = i1;
 }
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i6 + 80 | 0, i1 + 124 | 0);
 i5 = HEAP32[i2 >> 2] | 0;
 __ZN19ShaderPropertySheet5ClearEb(i5 + 12 | 0, 0);
 i2 = i5 + 220 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i5 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i4 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 HEAP32[i5 + 200 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i5 + 164 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2;
 __ZN8Material15BuildPropertiesEv(i6);
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE8recreateEj(i9, i8) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i8) i7 = 0; else i7 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i9, i8 * 104 | 0, gb + 838004 | 0, 543) | 0;
 i6 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7 + (i6 * 104 | 0) | 0;
 if ((i6 | 0) > 0) {
  i1 = i7;
  i2 = HEAP32[i9 >> 2] | 0;
  while (1) {
   i4 = i1;
   i5 = i2;
   i6 = i4 + 104 | 0;
   do {
    HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
    i4 = i4 + 4 | 0;
    i5 = i5 + 4 | 0;
   } while ((i4 | 0) < (i6 | 0));
   i1 = i1 + 104 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 104 | 0;
  }
 }
 i1 = i9 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i9 >> 2] = i7;
  HEAP32[i1 >> 2] = i8;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = i7;
 HEAP32[i1 >> 2] = i8;
 return;
}

function __ZN5Umbra10QueryStateC2EPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 i4 = i1 + 36 | 0;
 i5 = i2;
 i2 = i5 + 15 & -16;
 i6 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i6;
 i3 = i6 + (i5 + i3 - i2) | 0;
 HEAP32[i1 + 44 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = i2;
 HEAP32[i1 + 52 >> 2] = i3 - i2;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = i4;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 1;
 HEAP32[i1 + 88 >> 2] = 1;
 HEAP32[i1 + 92 >> 2] = -1;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 return;
}

function __ZN13RuntimeStaticI15GUIEventManagerE13StaticDestroyEPv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 if (!i6) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 __ZNSt3__212__deque_baseI10InputEventNS_9allocatorIS1_EEE5clearEv(i6);
 i2 = i6 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i6 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) {
  do {
   __ZdlPv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
  HEAP32[i5 >> 2] = 0;
  return;
 }
 __ZdlPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i7);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN11UnityEngine7Connect15AppRunningEvent12ToJsonStringER9JSONWrite(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i2, i3);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i3, i2 + 32 | 0, gb + 1040045 | 0, 0);
 i1 = i2 + 36 | 0;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i3, i1, gb + 1040054 | 0, 0);
 i1 = i2 + 40 | 0;
 if (HEAP32[i1 >> 2] | 0) __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i3, i1, gb + 1040069 | 0, 0);
 i1 = i2 + 44 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = i2 + 48 | 0;
  __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i3, i2, gb + 1040097 | 0, 0);
  return;
 }
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i3, i1, gb + 1040083 | 0, 0);
 i2 = i2 + 48 | 0;
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i3, i2, gb + 1040097 | 0, 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_119parse_discriminatorEPKcS2_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 L1 : do if ((i1 | 0) != (i4 | 0)) {
  i2 = HEAP8[i1 >> 0] | 0;
  if (i2 << 24 >> 24 != 95) {
   if (((i2 << 24 >> 24) + -48 | 0) >>> 0 >= 10) break;
   while (1) {
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i4;
     break L1;
    }
    if (((HEAP8[i1 >> 0] | 0) + -48 | 0) >>> 0 >= 10) break L1;
   }
  }
  i2 = i1 + 1 | 0;
  if ((i2 | 0) != (i4 | 0)) {
   i2 = HEAP8[i2 >> 0] | 0;
   if (((i2 << 24 >> 24) + -48 | 0) >>> 0 < 10) {
    i1 = i1 + 2 | 0;
    break;
   }
   if (i2 << 24 >> 24 == 95) {
    i2 = i1 + 2 | 0;
    while (1) {
     if ((i2 | 0) == (i4 | 0)) break L1;
     i3 = HEAP8[i2 >> 0] | 0;
     if (((i3 << 24 >> 24) + -48 | 0) >>> 0 >= 10) break;
     i2 = i2 + 1 | 0;
    }
    return (i3 << 24 >> 24 == 95 ? i2 + 1 | 0 : i1) | 0;
   }
  }
 } while (0);
 return i1 | 0;
}

function __Z45ParticleSystem_TriggerModule_CUSTOM_SetInsideP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 8 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_TriggerModule_CUSTOM_SetEnterP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 16 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z38GameObject_CUSTOM_GetComponentInParentP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 8 >> 2] = 0;
  i4 = i3 + 20 | 0;
  HEAP16[i4 >> 1] = 257;
  HEAP8[i4 + 2 >> 0] = 1;
  HEAP8[i3 + 22 >> 0] = 0;
  HEAP32[i3 + 4 >> 2] = i2;
  HEAP8[i3 + 13 >> 0] = 1;
  HEAP8[i3 + 12 >> 0] = 1;
  HEAP8[i3 + 14 >> 0] = 0;
  HEAP32[i3 + 16 >> 2] = 1;
  i4 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i3) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK4Mesh27GetPreferredTexCoordChannelE13ShaderChannel(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = i1 + -3 | 0;
 i1 = (i1 | 0) < 3 ? i1 : 3;
 if ((i1 | 0) < 0) {
  i6 = -1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i4 = (HEAP32[i2 + 32 >> 2] | 0) + 8 | 0;
 i2 = 0;
 i3 = 0;
 while (1) {
  i8 = (HEAP8[i4 + (i2 + 3 << 2) + 3 >> 0] | 0) != 0;
  HEAP8[i5 + i2 >> 0] = i8 & 1;
  i3 = i3 | i8;
  if ((i2 | 0) >= (i1 | 0)) break; else i2 = i2 + 1 | 0;
 }
 if (!(i3 & (i1 | 0) > -1)) {
  i8 = -1;
  STACKTOP = i7;
  return i8 | 0;
 }
 while (1) {
  if (HEAP8[i5 + i1 >> 0] | 0) break;
  if ((i1 | 0) > 0) i1 = i1 + -1 | 0; else {
   i1 = -1;
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) {
  STACKTOP = i7;
  return i1 | 0;
 }
 i8 = i1 + 3 | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNK11Rigidbody2D11GetRotationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) {
  __ZNK9Transform11GetRotationEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  i3 = f5 < Math_fround(0.0);
  f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  f8 = Math_fround(-f7);
  f6 = Math_fround(-f5);
  f5 = Math_fround(Math_fround(+Math_atan2(+(i3 ? f8 : f7), +(i3 ? f6 : f5))) * Math_fround(2.0));
  f5 = Math_fround(f5 * Math_fround(57.2957802));
  STACKTOP = i4;
  return Math_fround(f5);
 } else {
  f8 = Math_fround(HEAPF32[i3 + 56 >> 2]);
  f8 = Math_fround(f8 * Math_fround(57.2957802));
  STACKTOP = i4;
  return Math_fround(f8);
 }
 return f0;
}

function __ZN9BoxPruner9setBoundsEtRK5IAABB(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 & 65535;
 i5 = HEAP32[i3 + 76 >> 2] | 0;
 i1 = HEAP32[i5 + (i4 << 3) >> 2] | 0;
 if (!(HEAP32[i5 + (i4 << 3) + 4 >> 2] & 1)) {
  i5 = (HEAP32[i3 + 100 >> 2] | 0) + (i1 * 24 | 0) | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  return;
 } else {
  i5 = (HEAP32[i3 + 96 >> 2] | 0) + (i1 * 24 | 0) | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  return;
 }
}

function __ZN5Unity17ConfigurableJoint20SetLinearLimitSpringERK20SoftJointLimitSpring(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i5 = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i5 ? Math_fround(340282326000000008404918.0e15) : f2;
 i3 = i3 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f2 < Math_fround(0.0);
 i1 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i1 ? Math_fround(340282326000000008404918.0e15) : f2;
 i1 = i5 ? 0 : (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 HEAP32[i4 + 120 >> 2] = i3;
 HEAP32[i4 + 124 >> 2] = i1;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i4);
 return;
}

function __ZN2UI11CanvasGroup7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(44, i1, 16, gb + 1048932 | 0, 0, gb + 1012776 | 0, 15) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 186704 + 8;
 HEAPF32[i4 + 36 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 40 >> 0] = 1;
 HEAP8[i4 + 41 >> 0] = 1;
 HEAP8[i4 + 42 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z44ParticleSystem_ShapeModule_CUSTOM_SetEnabledP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP8[i1 + 48 + 4 >> 0] = i2 << 24 >> 24 != 0 & 1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_TriggerModule_CUSTOM_SetExitP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[(HEAP32[i1 + 912 >> 2] | 0) + 20 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z41CommandBuffer_CUSTOM_SetGlobalVectorArrayP12Il2CppObjectiP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7 + 12 | 0;
 if (!i3) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1041262 | 0);
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if (!i5) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 558494 | 0, i7);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6); else {
  HEAP32[i4 >> 2] = i2;
  __ZN22RenderingCommandBuffer23AddSetGlobalVectorArrayERKN9ShaderLab16FastPropertyNameEPK8Vector4fi(i1, i4, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 16) | 0, i5);
  STACKTOP = i7;
  return;
 }
}

function __Z34AudioClip_Get_Custom_PropLoadStateP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 if (i1 | 0) {
  i3 = __ZN9AudioClip11ReadyToPlayEv(i2) | 0;
  i3 = i3 ? 2 : 0;
  return i3 | 0;
 }
 switch (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0) | 0) {
 case 4:
  {
   i3 = 3;
   return i3 | 0;
  }
 case 2:
 case 1:
  {
   i3 = 1;
   return i3 | 0;
  }
 case 3:
  {
   i3 = 2;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5Unity5Cloth18ResetConfigurationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 44 >> 0] = 1;
 HEAP8[i1 + 45 >> 0] = 1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 92 >> 0] = 1;
 HEAP8[i1 + 93 >> 0] = 1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(120.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.100000001);
 return;
}

function __ZN4FMOD7Channel6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 855848;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 855848;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 855848;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel18get3DCustomRolloffEPP11FMOD_VECTORPi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868413;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868413;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868413;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN26ProbeSetTetrahedralization13SetTetrahedraEPK11TetrahedronS2_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = i5 + 12 | 0;
 i1 = i1 - i6 | 0;
 i2 = (i1 | 0) / 80 | 0;
 HEAP32[i7 >> 2] = i2;
 i3 = i5 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 & 2147483647) >>> 0 < i2 >>> 0) if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i2;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i5 >> 2] | 0, i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i5 >> 2] = i1;
  break;
 } else {
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, i5 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 80 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  break;
 } else i1 = HEAP32[i5 >> 2] | 0; while (0);
 _memcpy(i1 | 0, i6 | 0, (HEAP32[i7 >> 2] | 0) * 80 | 0) | 0;
 return;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i3);
 i7 = HEAP32[i2 + 36 >> 2] | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i7 | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 i5 = (HEAP8[i3 + 40 >> 0] | 0) == 0;
 HEAP32[i1 >> 2] = i5 ? i7 : i6;
 if (!i5) __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i2, i1, 0);
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i7 = __ZNK13MonoBehaviour8GetClassEv(i2) | 0;
 __Z23TransferScriptingObjectI17RemapPPtrTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i3, i1, i7, HEAP32[i2 + 56 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStream9readBytesEPhj(i6, i5, i1) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((i5 | 0) == 0 | (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0) | 0) ^ 1) {
  i6 = 1;
  return i6 | 0;
 }
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = i6 + 8 | 0;
 i3 = i1;
 i1 = 0;
 while (1) {
  i2 = __ZN5physx6shdfnd6Socket4readEPhj((HEAP32[i4 >> 2] | 0) + 4 | 0, i5, i3) | 0;
  i1 = i2 + i1 | 0;
  if ((i3 | 0) != (i2 | 0) & (i2 | 0) != 0) i3 = i3 - i2 | 0; else break;
 }
 if (!i2) {
  i6 = 1;
  return i6 | 0;
 }
 i5 = i6 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i6 + 32 | 0;
 i3 = i6;
 i3 = _i64Add(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i1 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 i6 = 0;
 return i6 | 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager21ProcessFlushEventsJobEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 552 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 4) return;
 HEAP32[i2 + 560 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 40 + (i3 << 7) | 0;
 if ((HEAPU16[i2 + 40 + (i3 << 7) + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i2 + 40 + (i3 << 7) + 92 >> 0] = 0;
 HEAP8[i2 + 40 + (i3 << 7) + 91 >> 0] = 0;
 if (HEAP8[i2 + 40 + (i3 << 7) + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i4) | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i2 >> 2] | 0) != 1) if ((HEAP32[i2 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i4 | 0);
 } while (0);
 if (HEAP8[i2 + 40 + (i3 << 7) + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
 return;
}

function __Z40Camera_Set_Custom_PropLayerCullDistancesP12Il2CppObjectP11Il2CppArray(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN9Scripting11RaiseIfNullEPv(i3);
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0) != 32) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 503017 | 0, i5);
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i4 = i2 + 932 | 0;
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  i2 = i4 + 128 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z32DeveloperConsole_OpenConsoleFilev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 i2 = i1;
 i4 = HEAP32[gb + 1450760 >> 2] | 0;
 i4 = (i4 | 0) == 0 ? gb + 1576256 | 0 : i4;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i4, _strlen(i4) | 0);
 HEAP32[i3 + 4 >> 2] = gb + 1576256;
 HEAP32[i3 + 8 >> 2] = gb + 1576256;
 HEAP32[i3 >> 2] = gb + 583076;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = gb + 582853;
 HEAP32[i3 + 20 >> 2] = 1458;
 HEAP32[i3 + 24 >> 2] = 1;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 __Z17DebugStringToFileRK21DebugStringToFileData(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __Z18UploadTextureAtlasP9Texture2Db(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
  i2 = i1 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break;
  } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 200 >> 2] | 0, i3 | 0);
 } while (0);
 if (!i4) {
  i4 = HEAP32[i3 >> 2] | 0;
  i4 = i4 + 12 | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(i4 | 0, i3 | 0, 0);
  return;
 }
 HEAP8[i3 + 111 >> 0] = 0;
 HEAP8[i3 + 112 >> 0] = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i4 = i4 + 12 | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(i4 | 0, i3 | 0, 0);
 return;
}

function __ZNK7dtCrowd14getSteerTargetERK13dtCrowdHandlePf(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if ((HEAP8[i2 + (i1 * 608 | 0) + 601 >> 0] | 0) == 2) {
  i3 = HEAP32[i3 + 20 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 + (i1 * 56 | 0) + 24 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + (i1 * 56 | 0) + 28 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + (i1 * 56 | 0) + 32 >> 2];
  return;
 }
 if ((HEAP32[i2 + (i1 * 608 | 0) + 476 >> 2] | 0) > 0) {
  HEAP32[i4 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 424 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 428 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 432 >> 2];
  return;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 12 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 16 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + (i1 * 608 | 0) + 20 >> 2];
  return;
 }
}

function __ZNK5Umbra10Sha1Digest3strEPc(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = 0;
 i2 = i4;
 while (1) {
  i5 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  i6 = i5 >>> 24 & 15;
  HEAP8[i2 >> 0] = (i5 >>> 0 < 2684354560 ? 48 : 87) + (i5 >>> 28);
  HEAP8[i2 + 1 >> 0] = i6 >>> 0 < 10 ? i6 | 48 : i6 + 87 | 0;
  i6 = i5 >>> 20 & 15;
  i7 = i5 >>> 16 & 15;
  HEAP8[i2 + 2 >> 0] = (i6 >>> 0 < 10 ? 48 : 87) + i6;
  HEAP8[i2 + 3 >> 0] = i7 >>> 0 < 10 ? i7 | 48 : i7 + 87 | 0;
  i7 = i5 >>> 12 & 15;
  i6 = i5 >>> 8 & 15;
  HEAP8[i2 + 4 >> 0] = (i7 >>> 0 < 10 ? 48 : 87) + i7;
  HEAP8[i2 + 5 >> 0] = i6 >>> 0 < 10 ? i6 | 48 : i6 + 87 | 0;
  i6 = i5 >>> 4 & 15;
  i5 = i5 & 15;
  HEAP8[i2 + 6 >> 0] = (i6 >>> 0 < 10 ? 48 : 87) + i6;
  HEAP8[i2 + 7 >> 0] = i5 >>> 0 < 10 ? i5 | 48 : i5 + 87 | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 5) break; else i2 = i2 + 8 | 0;
 }
 HEAP8[i4 + 40 >> 0] = 0;
 return;
}

function __ZNK12TreeDatabase9Prototype31GetTreeInstanceMatrixNoRotationER10Matrix4x4fRK8Vector3fRK12TreeInstance(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 f8 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 f9 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) * f8);
 HEAPF32[i6 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) * f9);
 HEAPF32[i6 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 52 >> 2]) * f8);
 HEAPF32[i7 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(1.0);
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i2, i3, i7, i6);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc9ClothCore21removeCollisionSphereEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i9 = i3;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 176 >> 2] | 0, i4 | 0) | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 mftCall_viiii(i8 | 0, i7 | 0, i6 | 0, i1 | 0, i1 + 1 | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 176 >> 2] | 0, i5 | 0) | 0;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = i5 - i4 + (HEAP32[i1 >> 2] | 0);
 i2 = i2 + 72 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 STACKTOP = i3;
 return;
}

function __ZN22UnityProfilerPerThread8EndFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 48 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 > 1) {
  i3 = i1 + 157 | 0;
  if (!(HEAP8[i3 >> 0] | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 462302 | 0, 0, gb + 461711 | 0, 155, 1, 0, 0, 0);
  HEAP8[i3 >> 0] = 1;
 }
 if (HEAP32[i1 + 4 >> 2] | 0) if (HEAP32[(HEAP32[HEAP32[HEAP32[i1 + 16 >> 2] >> 2] >> 2] | 0) + 12 >> 2] | 0) if (!(HEAP8[i1 + 157 >> 0] | 0)) return;
 __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE(i1 + 56 | 0);
 __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj(i1 + 4 | 0, 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 156 >> 0] = 0;
 HEAP8[i1 + 157 >> 0] = 0;
 return;
}

function __ZN18AsyncUploadManager15AcquireWritePtrEj(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i4 = HEAP32[i1 + 1324 >> 2] | 0;
 i5 = i4 + 24 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 i6 = i4 + 28 | 0;
 i1 = i2 >>> 0 > i3 >>> 0;
 if ((HEAP32[i6 >> 2] | 0) == 1) i1 = i1 ? i2 + ~i3 | 0 : 0; else if (i1) i1 = 0; else {
  i1 = HEAP32[i4 + 16 >> 2] | 0;
  i8 = i1 - i3 | 0;
  i1 = i2 >>> 0 < i3 >>> 0 ? i2 : i1;
  i2 = i8 >>> 0 >= i7 >>> 0 | i1 >>> 0 < i7 >>> 0;
  i1 = i2 ? i8 : i1;
  i3 = i2 ? i3 : 0;
 }
 i1 = i1 >>> 0 > i7 >>> 0 ? i7 : i1;
 i2 = (HEAP32[i4 >> 2] | 0) + i3 | 0;
 if (i1 >>> 0 < i7 >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 if (!i3) if (HEAP32[i5 >> 2] | 0) {
  HEAP32[i4 + 32 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
 i8 = i2;
 return i8 | 0;
}

function __Z36LightProbes_Get_Custom_PropPositionsP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 32 + 60 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i2 = __ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2 + 32 | 0) | 0;
  i3 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0;
  i2 = (i1 | 0) == 0 ? 0 : i2;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 12, i2) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 12) | 0, i1 | 0, i2 * 12 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z29StdTemplateConversionFunctionIayEbPvR14SafeBinaryRead(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i1 + 16 | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = i3 + (HEAP32[(HEAP32[i1 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i1 + 36 >> 2] | 0, 0 - (HEAP32[i1 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 if (i2 >>> 0 < i3 >>> 0) i7 = 4; else {
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i1 = HEAP8[i2 >> 0] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP32[i5 >> 2] = i3;
  }
 }
 if ((i7 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 1);
  i1 = HEAP8[i4 >> 0] | 0;
 }
 i5 = i1 << 24 >> 24;
 i7 = i6;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = ((i5 | 0) < 0) << 31 >> 31;
 STACKTOP = i8;
 return 1;
}

function __Z29StdTemplateConversionFunctionIaxEbPvR14SafeBinaryRead(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i1 + 16 | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = i3 + (HEAP32[(HEAP32[i1 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i1 + 36 >> 2] | 0, 0 - (HEAP32[i1 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 if (i2 >>> 0 < i3 >>> 0) i7 = 4; else {
  i3 = i2 + 1 | 0;
  if (i3 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) i7 = 4; else {
   i1 = HEAP8[i2 >> 0] | 0;
   HEAP8[i4 >> 0] = i1;
   HEAP32[i5 >> 2] = i3;
  }
 }
 if ((i7 | 0) == 4) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 1);
  i1 = HEAP8[i4 >> 0] | 0;
 }
 i5 = i1 << 24 >> 24;
 i7 = i6;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i7 + 4 >> 2] = ((i5 | 0) < 0) << 31 >> 31;
 STACKTOP = i8;
 return 1;
}

function __Z17pqDeletePriorityQP9TESSallocP9PriorityQ(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i5 = i3 + 8 | 0;
  i2 = i3 + 12 | 0;
  mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
  mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1 | 0);
 }
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[i3 + 8 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, i1 | 0);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i3 + 8 | 0;
 if (!i2) {
  i5 = i3 + 12 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(i3 | 0, i5 | 0, i4 | 0);
  return;
 } else {
  i5 = i3 + 12 | 0;
  mftCall_vii(HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0, i2 | 0);
  i3 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(i3 | 0, i5 | 0, i4 | 0);
  return;
 }
}

function _UNITY_ft_corner_is_flat(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = i4 + i1 | 0;
 i8 = i5 + i2 | 0;
 i3 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i1 = (i2 | 0) < 0 ? 0 - i2 | 0 : i2;
 if ((i3 | 0) > (i1 | 0)) i6 = (i1 * 3 >> 3) + i3 | 0; else i6 = (i3 * 3 >> 3) + i1 | 0;
 i2 = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
 i1 = (i5 | 0) < 0 ? 0 - i5 | 0 : i5;
 if ((i2 | 0) > (i1 | 0)) i3 = (i1 * 3 >> 3) + i2 | 0; else i3 = (i2 * 3 >> 3) + i1 | 0;
 i2 = (i7 | 0) < 0 ? 0 - i7 | 0 : i7;
 i1 = (i8 | 0) < 0 ? 0 - i8 | 0 : i8;
 if ((i2 | 0) > (i1 | 0)) {
  i8 = (i1 * 3 >> 3) + i2 | 0;
  i7 = i3 + i6 | 0;
  i7 = i7 - i8 | 0;
  i8 = i8 >> 4;
  i8 = (i7 | 0) < (i8 | 0);
  i8 = i8 & 1;
  return i8 | 0;
 } else {
  i8 = (i2 * 3 >> 3) + i1 | 0;
  i7 = i3 + i6 | 0;
  i7 = i7 - i8 | 0;
  i8 = i8 >> 4;
  i8 = (i7 | 0) < (i8 | 0);
  i8 = i8 & 1;
  return i8 | 0;
 }
 return 0;
}

function _readdir(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i5 = i4 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 12 | 0;
 L1 : do if ((i1 | 0) < (HEAP32[i3 >> 2] | 0)) i6 = 6; else {
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i4 + 24;
  HEAP32[i2 + 8 >> 2] = 2048;
  i1 = ___syscall220(220, i2 | 0) | 0;
  if ((i1 | 0) >= 1) {
   HEAP32[i3 >> 2] = i1;
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   i6 = 6;
   break;
  }
  switch (i1 | 0) {
  case 0:
  case -2:
   {
    i1 = 0;
    break L1;
   }
  default:
   {}
  }
  HEAP32[(___errno_location() | 0) >> 2] = 0 - i1;
  i1 = 0;
 } while (0);
 if ((i6 | 0) == 6) {
  i6 = i4 + 24 + i1 | 0;
  HEAP32[i5 >> 2] = (HEAPU16[i6 + 8 >> 1] | 0) + i1;
  HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  i1 = i6;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function _do_setxid(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 16 | 0;
 i3 = i6;
 i4 = i1 + 20 | 0;
 do if (!(HEAP32[i4 >> 2] | 0)) {
  if (HEAP32[i1 + 16 >> 2] | 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) > -1) if ((i1 | 0) != (_getuid() | 0)) {
    HEAP32[i2 >> 2] = HEAP32[gb + 10624 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[gb + 10624 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[gb + 10624 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[gb + 10624 + 12 >> 2];
    _getrlimit(6, i3) | 0;
    i2 = ___setrlimit(6, i2) | 0;
    HEAP32[i4 >> 2] = 0 - i2;
    if (!i2) i5 = 7; else if (!(HEAP32[gb + 1469464 + 16 >> 2] | 0)) i5 = 7;
    if ((i5 | 0) == 7) {
     HEAP32[i4 >> 2] = 1;
     ___setrlimit(6, i3) | 0;
    }
    break;
   }
  }
  HEAP32[i4 >> 2] = 1;
 } while (0);
 STACKTOP = i6;
 return;
}

function __ZNK10Matrix3x3f14GetDeterminantEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0, f13 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f9 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f13 = Math_fround(f4 * f9);
 f7 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f13 = Math_fround(f13 * f7);
 f6 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f12 = Math_fround(f6 * f3);
 f10 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f12 = Math_fround(f12 * f10);
 f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f11 = Math_fround(f8 * f5);
 f2 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 return Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f13 + f12) + Math_fround(f11 * f2)) - Math_fround(f10 * Math_fround(f9 * f8))) - Math_fround(f7 * Math_fround(f6 * f5))) - Math_fround(Math_fround(f4 * f3) * f2));
}

function __ZN6Shader10GetDefaultEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1166240 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 469921 | 0, 27);
 i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i1) | 0;
 HEAP32[gb + 1166240 >> 2] = i2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
 i2 = i1;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx6shdfnd10checkValidERKNS_7PxMat33E(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if ((HEAP32[i2 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i2 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i2 + 8 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i2 + 12 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i2 + 36 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 8 >> 2] & 2139095040) >>> 0 < 2139095040;
 return i2 | 0;
}

function __ZN5physx2Sc9ClothCore20removeCollisionPlaneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i9 = i3;
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 192 >> 2] | 0, i4 | 0) | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 mftCall_viiii(i8 | 0, i7 | 0, i6 | 0, i1 | 0, i1 + 1 | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 192 >> 2] | 0, i5 | 0) | 0;
 i1 = i2 + 84 | 0;
 HEAP32[i1 >> 2] = i5 - i4 + (HEAP32[i1 >> 2] | 0);
 i2 = i2 + 80 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = i2 + 32 | 0;
 i4 = HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0) + 1204 >> 2] | 0;
 __ZN5physx16PxsIslandManager16clearEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(i4) | 0, i2 + 60 | 0);
 __ZN5physx10PxsContext21destroyContactManagerEPNS_17PxsContactManagerE(HEAP32[i4 + 1e3 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = (HEAP32[(HEAP32[(__ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i3 >> 2] | 0) | 0) + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 7612 | 0;
 __ZN5physx2Sc8ShapeSim21destroyTransformCacheERNS_17PxsTransformCacheE(HEAP32[i3 >> 2] | 0, i1);
 __ZN5physx2Sc8ShapeSim21destroyTransformCacheERNS_17PxsTransformCacheE(HEAP32[i2 + 36 >> 2] | 0, i1);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setDynamicFrictionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 52 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4096;
 return;
}

function __ZN4crnd34crnd_get_crn_format_bits_per_texelE10crn_format(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 do switch (i1 | 0) {
 case 0:
  {
   if (!i2) i1 = 4; else i3 = 14;
   break;
  }
 case 1:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 2:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 3:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 4:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 5:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 6:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 7:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 8:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 9:
  {
   if (!i2) i1 = 4; else i3 = 14;
   break;
  }
 case 10:
  {
   if (!i2) i1 = 4; else i3 = 14;
   break;
  }
 default:
  i3 = 14;
 } while (0);
 if ((i3 | 0) == 13) i1 = 8; else if ((i3 | 0) == 14) i1 = 0;
 return i1 | 0;
}

function __ZN4FMOD7Channel18set3DCustomRolloffEP11FMOD_VECTORi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868640;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868640;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868640;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound18get3DCustomRolloffEPP11FMOD_VECTORPi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868413;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868413;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868413;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI13CanvasManager18WillRenderCanvasesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 248 | 0;
 i4 = i3;
 i5 = i3 + 240 | 0;
 i8 = __Z21GetUIScriptingClassesv() | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i1);
 HEAP32[i1 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i1, 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 do {
  __ZN2UI6Canvas13UpdateBatchesEb(HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 STACKTOP = i3;
 return;
}

function __ZN17Physics2DSettings18UpdateBox2DGravityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0, i6 = 0;
 i2 = (HEAP32[gb + 1458412 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 32 | 0;
 i1 = i1 + 36 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 102972 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 102976 >> 2] = i6;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 if (f4 == Math_fround(HEAPF32[gb + 1162356 >> 2])) {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  if (f4 == Math_fround(HEAPF32[gb + 1162356 + 4 >> 2])) return;
 }
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 102956 >> 2] | 0;
 if (!i1) return;
 do {
  if ((HEAP32[i1 >> 2] | 0) == 2) if (Math_fround(HEAPF32[i1 + 140 >> 2]) != Math_fround(0.0)) {
   i2 = i1 + 4 | 0;
   i3 = HEAPU16[i2 >> 1] | 0;
   if (!(i3 & 2)) {
    HEAP16[i2 >> 1] = i3 | 2;
    HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   }
  }
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN12_GLOBAL__N_19MyFastXmlD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 >> 2] = gb + 146688 + 8;
 HEAP32[i5 + 1028 >> 2] = 0;
 i2 = i5 + 11312 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i5 + 1032 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i5 + 1060 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 + 1036 >> 2] = 0;
 HEAP32[i5 + 1040 >> 2] = 0;
 HEAP32[i5 + 1048 >> 2] = 0;
 HEAP32[i5 + 1056 >> 2] = 0;
 i4 = 0;
 do {
  i1 = i5 + 9261 + i4 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) i1 = i5 + 1064 + (i4 << 2) | 0; else {
   i7 = HEAP32[i2 >> 2] | 0;
   i6 = i5 + 1064 + (i4 << 2) | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0, HEAP32[i6 >> 2] | 0);
   HEAP8[i1 >> 0] = 0;
   i1 = i6;
  }
  HEAP32[i1 >> 2] = 0;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < ((HEAP32[i3 >> 2] | 0) + 1 | 0) >>> 0);
 return;
}

function __ZN12_GLOBAL__N_113ClassDescImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148256 + 8;
 HEAP32[i1 + 120 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 140 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 124 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 132 >> 2] | 0);
 }
 HEAP32[i1 + 96 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 108 >> 2] | 0);
 }
 HEAP32[i1 + 72 >> 2] = gb + 148320 + 8;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 84 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __Z26AudioMixer_CUSTOM_SetFloatP12Il2CppObjectP12Il2CppStringf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0;
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i4 = (mftCall_iiif(i2 | 0, i1 | 0, ((HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) | 0, +f3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return i4 | 0;
 }
 return 0;
}

function __ZNSt3__225__num_get_signed_integralIxEET_PKcS3_Rji(i1, i4, i5, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  i2 = 0;
  i1 = 0;
 } else {
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  i1 = _strtoll_l(i1, i6, i2, __ZNSt3__26__clocEv() | 0) | 0;
  i2 = getTempRet0() | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (!i3) HEAP32[i7 >> 2] = i8;
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   if ((i3 | 0) == 34) {
    HEAP32[i5 >> 2] = 4;
    i2 = (i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 0;
    i1 = i2 ? -1 : 0;
    i2 = i2 ? 2147483647 : -2147483648;
   }
  } else {
   HEAP32[i5 >> 2] = 4;
   i1 = 0;
   i2 = 0;
  }
 }
 setTempRet0(i2 | 0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration18generateEEContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj(i10, i1, i2, i3, i5, i11, i7, i8, i9, i4, i6) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i11 = i11 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i7, i8, i9, i5, i11, i1, i2, i4, i6);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i7, i8, i9, i5, i11, i2, i3, i4, i6);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(0, i7, i8, i9, i5, i11, i1, i3, i4, i6);
 return;
}

function __ZN5physx14NpArticulation24setSolverIterationCountsEjj(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i5 + 12 | 0;
 i7 = (i2 << 8 | i1 & 255) & 65535;
 i1 = i5 + 24 | 0;
 i8 = i5 + 16 | 0;
 i4 = HEAP32[i8 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i9;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i9 >> 2] | 0) + 2433 >> 0] | 0)) i6 = 4; else i3 = i9;
   break;
  }
 default:
  i6 = 4;
 }
 if ((i6 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore24setSolverIterationCountsEt(i1, i7);
  return;
 }
 i2 = i5 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 + 20 >> 1] = i7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i9);
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 32;
 return;
}

function __ZN4FMOD7Channel15get3DAttributesEP11FMOD_VECTORS2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868379;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868379;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868379;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24GenerateTypeTreeTransfer5AlignEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i3 = i6 + 16 | 0;
 i4 = i6;
 i5 = i1 + 48 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 3 & -4;
 i5 = i1 + 20 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK16TypeTreeIterator8ChildrenEv(i2, i5);
 if (!(HEAP32[i2 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 i2 = i1 + 16 | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i4, i5);
 __ZNK16TypeTreeIterator4LastEv(i3, i4);
 i5 = (HEAP32[i7 >> 2] | 0) + ((HEAP32[i3 + 4 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 16384;
 i5 = (HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 32768;
 STACKTOP = i6;
 return;
}

function __ZN22RenderingCommandBuffer19AddIssuePluginEventEPFviEi(i5, i1, i10) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = i5 + 8 | 0;
 i9 = i5 + 24 | 0;
 i7 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i4 = i7 + 4 | 0;
 i2 = i5 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i7, i4);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i4;
 i5 = i5 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + i7 >> 2] = 20;
 i2 = i7 + 7 & -4;
 i4 = i2 + 8 | 0;
 if (i4 >>> 0 <= i3 >>> 0) {
  i8 = i6;
  HEAP32[i9 >> 2] = i4;
  i9 = i8 + i2 | 0;
  HEAP32[i9 >> 2] = i1;
  i9 = i9 + 4 | 0;
  HEAP32[i9 >> 2] = i10;
  return;
 }
 __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i2, i4);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i9 >> 2] = i4;
 i9 = i8 + i2 | 0;
 HEAP32[i9 >> 2] = i1;
 i9 = i9 + 4 | 0;
 HEAP32[i9 >> 2] = i10;
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP17RODataReplacementi19ROSorterReplacementE7SortJobEPS4_(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i2 = i5;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i3);
 } else i1 = 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP8[i3 >> 0] = HEAP8[i5 + 8 >> 0] | 0;
 __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_(i7, i6, i2, i3);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i3 = i7 + 36 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i7 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 if ((HEAP32[i5 + 16 >> 2] | 0) != 3) return;
 i8 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i5, gb + 1042554 | 0) | 0;
 HEAP32[i4 >> 2] = i8;
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1040818;
 if (i8 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, 0);
  __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue8TransferI8JSONReadEEvRT_(i6 + 4 | 0, i7);
  HEAP8[i3 >> 0] = 1;
  i8 = i7 + 56 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z49ParticleSystem_ShapeModule_CUSTOM_SetNormalOffsetP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 60 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function _jinit_compress_master(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 _jinit_c_master_control(i1, 0);
 if (!(HEAP8[i1 + 176 >> 0] | 0)) {
  _jinit_color_converter(i1);
  _jinit_downsampler(i1);
  _jinit_c_prep_controller(i1, 0);
 }
 _jinit_forward_dct(i1);
 do if (!(HEAP8[i1 + 177 >> 0] | 0)) if (!(HEAP8[i1 + 212 >> 0] | 0)) {
  _jinit_huff_encoder(i1);
  break;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 48;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i1 | 0);
  break;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 1;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i1 | 0);
 } while (0);
 if ((HEAP32[i1 + 168 >> 2] | 0) > 1) i2 = 1; else i2 = (HEAP8[i1 + 178 >> 0] | 0) != 0 & 1;
 _jinit_c_coef_controller(i1, i2);
 _jinit_c_main_controller(i1, 0);
 _jinit_marker_writer(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[HEAP32[i1 + 332 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__26chrono12system_clock3nowEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1142 | 0, 0, i1 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (!(i4 & 1)) {
  if (i2 | 0) {
   i4 = HEAP32[(___errno_location() | 0) >> 2] | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4496 | 0, i4 | 0, gb + 1076178 | 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) break;
  }
  i4 = HEAP32[i1 >> 2] | 0;
  i2 = (HEAP32[i1 + 4 >> 2] | 0) / 1e3 | 0;
  i4 = ___muldi3(i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0, 1e6, 0) | 0;
  i4 = _i64Add(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, i4 | 0, getTempRet0() | 0) | 0;
  setTempRet0(getTempRet0() | 0);
  STACKTOP = i3;
  return i4 | 0;
 } while (0);
 i4 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___clang_call_terminate(i4);
 return 0;
}

function __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 34;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK9Transform22InverseTransformVectorERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 32 | 0;
 i5 = i4 + 20 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2 + 32 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z22InverseTransformVector23TransformAccessReadOnlyRKN4math7_float3E(i5, i7, i6);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17setStaticFrictionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 56 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8192;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setDynamicFrictionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 52 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4096;
 return;
}

function __ZN4FMOD7Channel11setPositionEjj(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i1 = __ZN4FMOD8ChannelI11setPositionEjj(i2, i3, i4) | 0;
   if (!i1) {
    i6 = 0;
    STACKTOP = i7;
    return i6 | 0;
   }
   HEAP32[i6 >> 2] = i1;
   HEAP32[i6 + 4 >> 2] = gb + 859510;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = i1;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 859510;
 _printf(gb + 853184 | 0, i5) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD5Sound18set3DCustomRolloffEP11FMOD_VECTORi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868640;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868640;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868640;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup17overrideFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868267;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868267;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868267;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD12ChannelGroup10getChannelEiPPNS_7ChannelE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862521;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862521;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 862521;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI11CanvasGroup21SetIgnoreParentGroupsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 + 42 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i3 >> 0] = i2 & 1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN19TouchPhaseEmulation13AddTouchEventEiffNS_10TouchPhaseExNS_8TimeUnitE(i4, i5, f6, f7, i8, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10;
 if ((i5 | 0) > 0 & (HEAP8[i4 + 22 >> 0] | 0) == 0) {
  STACKTOP = i10;
  return;
 }
 if ((i3 | 0) < 1000001) {
  i3 = 1e6 / (i3 | 0) | 0;
  i1 = ___muldi3(i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0, i1 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
 } else {
  i1 = ___divdi3(i1 | 0, i2 | 0, (i3 >>> 0) / 1e6 | 0 | 0, 0) | 0;
  i2 = getTempRet0() | 0;
 }
 HEAPF32[i9 >> 2] = f6;
 HEAPF32[i9 + 4 >> 2] = f7;
 __ZN19TouchPhaseEmulation18DispatchTouchEventEj8Vector2fNS_10TouchPhaseExj(i4, i5, i9, i8, i1, i2, HEAP32[i4 + 12 >> 2] | 0);
 STACKTOP = i10;
 return;
}

function __ZN11IMGUIModule18MonoBehaviourDoGUIEiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS2_E(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1 + 24 | 0;
 i9 = i1 + 16 | 0;
 i11 = i1;
 i10 = i1 + 8 | 0;
 i13 = i6;
 i12 = HEAP32[i13 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i6 + 4 >> 2] = i12;
 HEAP32[i10 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i7 = __Z18MonoBehaviourDoGUIiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS1_E(i2, i3, i4, i5, i9, i8) | 0;
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN10systeminfo24GetOperatingSystemFamilyEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = HEAP32[gb + 65028 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i2 = i1;
  STACKTOP = i3;
  return i2 | 0;
 }
 __ZN10systeminfo18GetOperatingSystemEv(i2);
 if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i2, 0, 3, gb + 454750 | 0) | 0)) i1 = 1; else if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i2, 0, 7, gb + 597825 | 0) | 0)) i1 = 2; else {
  i1 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i2, 0, 5, gb + 454754 | 0) | 0) == 0;
  i1 = i1 ? 3 : 0;
 }
 HEAP32[gb + 65028 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i2 = HEAP32[gb + 65028 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN10MemoryFile4SeekEx10FileOrigin(i6, i1, i2, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = i6 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  return i6 | 0;
 }
 switch (i4 | 0) {
 case 3:
  {
   i1 = _i64Subtract(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0, getTempRet0() | 0, i1 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   i3 = HEAP32[i5 >> 2] | 0;
   break;
  }
 case 2:
  {
   i5 = i6 + 24 | 0;
   i1 = _i64Add(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
   i2 = getTempRet0() | 0;
   break;
  }
 default:
  {}
 }
 i5 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0;
 i4 = getTempRet0() | 0;
 if (i2 >>> 0 > i4 >>> 0 | (i2 | 0) == (i4 | 0) & i1 >>> 0 > i5 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i6 + 24 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 i6 = 1;
 return i6 | 0;
}

function __Z40NavMeshObstacle_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  f8 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * Math_fround(.5));
  f7 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) * Math_fround(.5));
  f6 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) * Math_fround(.5));
  HEAPF32[i3 >> 2] = f8;
  HEAPF32[i3 + 4 >> 2] = f7;
  HEAPF32[i3 + 8 >> 2] = f6;
  __ZN15NavMeshObstacle10SetExtentsERK8Vector3f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sc9ClothCore14setWakeCounterEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (f2 > Math_fround(4294967.0)) {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0, -1);
  return;
 }
 i5 = ~~Math_fround(f2 * Math_fround(1.0e3)) >>> 0;
 i4 = (i5 >>> 0) / 5 | 0;
 i4 = i4 >>> 0 < 200 ? i4 : 200;
 i4 = i4 >>> 0 > 1 ? i4 : 1;
 i1 = i1 + 28 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 388 >> 2] | 0, i3 | 0) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 368 >> 2] | 0, i6 | 0, i4 | 0);
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 376 >> 2] | 0, i6 | 0, (i5 >>> 0) / (i4 >>> 0) | 0 | 0);
 if (!(f2 == Math_fround(0.0) & i3)) return;
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 392 >> 2] | 0, i6 | 0);
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i7, i6);
 if (mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 120 >> 2] | 0, i7 | 0) | 0) {
  i4 = i7 + 32 | 0;
  i5 = i6 + 16 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i6 + 36 | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
  i3 = i6 + 40 | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i4 >> 2] = i2;
 } else {
  i5 = i6 + 16 | 0;
  i3 = i6 + 40 | 0;
  i1 = i6 + 36 | 0;
 }
 mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 124 >> 2] | 0, i7 | 0) | 0;
 i2 = i7 + 64 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z20HandleSteppedTangentRK11KeyframeTplI11QuaternionfES3_RS0_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i3 = i1 + 36 | 0;
 i1 = i2 + 20 | 0;
 i2 = Math_fround(HEAPF32[i3 >> 2]) == Math_fround(inf);
 if (i2 | Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) HEAPF32[i4 >> 2] = Math_fround(inf);
 if (Math_fround(HEAPF32[i3 + 4 >> 2]) == Math_fround(inf)) i5 = 5; else if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf)) i5 = 5;
 if ((i5 | 0) == 5) HEAPF32[i4 + 4 >> 2] = Math_fround(inf);
 if (Math_fround(HEAPF32[i3 + 8 >> 2]) == Math_fround(inf)) i5 = 8; else if (Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf)) i5 = 8;
 if ((i5 | 0) == 8) HEAPF32[i4 + 8 >> 2] = Math_fround(inf);
 if (!(Math_fround(HEAPF32[i3 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf))) return;
 HEAPF32[i4 + 12 >> 2] = Math_fround(inf);
 return;
}

function _UNITY_png_write_chunk_start(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP8[i1 >> 0] | 0;
 i6 = HEAP8[i1 + 1 >> 0] | 0;
 i7 = HEAP8[i1 + 2 >> 0] | 0;
 i1 = HEAP8[i1 + 3 >> 0] | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 i9 = i2 + 656 | 0;
 HEAP32[i9 >> 2] = 34;
 HEAP8[i4 >> 0] = i3 >>> 24;
 HEAP8[i4 + 1 >> 0] = i3 >>> 16;
 HEAP8[i4 + 2 >> 0] = i3 >>> 8;
 HEAP8[i4 + 3 >> 0] = i3;
 i3 = i4 + 4 | 0;
 HEAP8[i3 >> 0] = i5;
 HEAP8[i4 + 5 >> 0] = i6;
 HEAP8[i4 + 6 >> 0] = i7;
 HEAP8[i4 + 7 >> 0] = i1;
 _UNITY_png_write_data(i2, i4, 8);
 HEAP32[i2 + 372 >> 2] = (i6 & 255) << 16 | (i5 & 255) << 24 | (i7 & 255) << 8 | i1 & 255;
 _UNITY_png_reset_crc(i2);
 _UNITY_png_calculate_crc(i2, i3, 4);
 HEAP32[i9 >> 2] = 66;
 STACKTOP = i8;
 return;
}

function _UNITY_png_get_IHDR(i11, i7, i1, i2, i3, i4, i13, i9, i10) {
 i11 = i11 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i13 = i13 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i12 = 0;
 if ((i11 | 0) == 0 | (i7 | 0) == 0 | (i1 | 0) == 0 | (i2 | 0) == 0 | (i3 | 0) == 0 | (i4 | 0) == 0) {
  i13 = 0;
  return i13 | 0;
 }
 i12 = HEAP32[i7 >> 2] | 0;
 HEAP32[i1 >> 2] = i12;
 i8 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i8;
 i6 = i7 + 24 | 0;
 i5 = HEAP16[i6 >> 1] | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i3 >> 2] = i6 & 255;
 HEAP32[i4 >> 2] = i6 >>> 8 & 255;
 i2 = i6 >>> 16;
 i3 = i6 >>> 24;
 if (i9 | 0) HEAP32[i9 >> 2] = i2 & 255;
 if (i10 | 0) HEAP32[i10 >> 2] = i3;
 i1 = HEAP8[i7 + 28 >> 0] | 0;
 if (i13 | 0) HEAP32[i13 >> 2] = i1 & 255;
 _UNITY_png_check_IHDR(i11, i12, i8, i6 & 255, (i5 & 65535) >>> 8 & 65535, i1 & 255, i2 & 255, i3);
 i13 = 1;
 return i13 | 0;
}

function __ZN6prcoreL25inner_stretch_i8_bilinearEPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = (HEAP32[i3 + 24 >> 2] | 0) >>> 8;
 i7 = 256 - i6 | 0;
 i8 = HEAP32[i3 + 4 >> 2] | 0;
 i9 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = i3 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i10 = i1 >>> 16;
  i3 = i1 >>> 8 & 255;
  i11 = i10 + 1 | 0;
  i3 = (Math_imul((HEAPU8[i8 + i11 >> 0] | 0) << 16 | (HEAPU8[i9 + i11 >> 0] | 0), i3) | 0) + (Math_imul((HEAPU8[i8 + i10 >> 0] | 0) << 16 | (HEAPU8[i9 + i10 >> 0] | 0), 256 - i3 | 0) | 0) | 0;
  HEAP8[i4 >> 0] = ((Math_imul(i3 >>> 16 & 65280, i7) | 0) + (Math_imul(i3 & 65280, i6) | 0) | 0) >>> 16;
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
  }
 }
 return;
}

function __ZN6Avatar12SetParameterEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) return;
 switch (i2 | 0) {
 case 0:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 364 >> 2] = f3;
   return;
  }
 case 1:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 368 >> 2] = f3;
   return;
  }
 case 2:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 372 >> 2] = f3;
   return;
  }
 case 3:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 376 >> 2] = f3;
   return;
  }
 case 4:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 380 >> 2] = f3;
   return;
  }
 case 5:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 384 >> 2] = f3;
   return;
  }
 case 6:
  {
   i2 = i1 + 20 | 0;
   HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + 388 >> 2] = f3;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Gu22computeMTD_SpherePlaneERNS_6PxVec3ERfRKNS0_6SphereERKNS_7PxPlaneE(i9, i8, i4, i2) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f1 = f0, f3 = f0, f5 = f0, f6 = f0, f7 = f0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f3 * f5);
 f1 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f1 = Math_fround(f3 + Math_fround(f1 * f7));
 f3 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(f1 + Math_fround(f3 * f6));
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f3);
 f1 = Math_fround(HEAPF32[i4 + 12 >> 2]);
 if (f3 > f1) {
  i9 = 0;
  return i9 | 0;
 }
 HEAPF32[i9 >> 2] = f5;
 HEAPF32[i9 + 4 >> 2] = f7;
 HEAPF32[i9 + 8 >> 2] = f6;
 f7 = Math_fround(f1 - f3);
 i9 = f7 > Math_fround(0.0);
 HEAPF32[i8 >> 2] = i9 ? f7 : Math_fround(0.0);
 i9 = 1;
 return i9 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17setStaticFrictionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 56 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8192;
 return;
}

function __ZN5Umbra15CameraTransform16setWorldToCameraERKNS_9Matrix4x4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 + 340 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 344 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 348 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 352 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 356 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 360 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 364 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 368 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 372 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 376 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 380 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 384 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 388 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 392 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 396 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 400 >> 2] = HEAP32[i2 + 60 >> 2];
 HEAP8[i1 + 436 >> 0] = 1;
 return;
}

function __ZN4FMOD5Sound12getSyncPointEiPP14FMOD_SYNCPOINT(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869040;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869040;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 869040;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN16b2StackAllocator8AllocateEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = i5 + 102796 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i1 = i5 + 102412 + (i2 * 12 | 0) | 0;
 HEAP32[i5 + 102412 + (i2 * 12 | 0) + 4 >> 2] = i6;
 i3 = i5 + 102400 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 + i6 | 0) > 102400) {
  HEAP32[i1 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
  HEAP8[i5 + 102412 + (i2 * 12 | 0) + 8 >> 0] = 1;
 } else {
  HEAP32[i1 >> 2] = i5 + i4;
  HEAP8[i5 + 102412 + (i2 * 12 | 0) + 8 >> 0] = 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 }
 i3 = i5 + 102404 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + i6 | 0;
 HEAP32[i3 >> 2] = i4;
 i6 = i5 + 102408 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = (i5 | 0) > (i4 | 0) ? i5 : i4;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 1;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 190224 + 8;
 i1 = i2 + 2256 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 2268 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 2236 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 2248 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev(i2 + 2168 | 0);
 __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev(i2);
 STACKTOP = i4;
 return;
}

function __Z50Physics2D_CUSTOM_INTERNAL_CALL_Internal_CircleCastRK13Vector2fIcallfS1_fiffP12RaycastHit2D(i1, f2, i3, f4, i5, f6, f7, i8) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 8 | 0;
 i10 = i9;
 i12 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i11 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 if ((__ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di(i12, i11, f2, i10, f4, i5, f6, f7, 0, 0, i8, 1) | 0) != 1) {
  STACKTOP = i9;
  return;
 }
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i8);
 STACKTOP = i9;
 return;
}

function __Z46ParticleSystem_ShapeModule_CUSTOM_SetMeshScaleP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 64 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i6 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = (Math_imul(HEAP32[gb + 1104584 + 44 >> 2] | 0, i3) | 0) + i5 | 0;
 if (!(1 << (i4 & 31) & HEAP32[(HEAP32[gb + 1104584 + 16 >> 2] | 0) + (i4 >>> 5 << 2) >> 2])) return;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(0, 0, 0) | 0;
 i8 = HEAP32[gb + 1104584 + 28 >> 2] | 0;
 i1 = HEAP32[i8 + (i5 << 5) + 24 >> 2] | 0;
 i2 = HEAP32[i8 + (i5 << 5) >> 2] | 0;
 if (((HEAP32[i8 + (i5 << 5) + 4 >> 2] | 0) - i2 >> 2 | 0) > (i3 | 0)) {
  i8 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
  i1 = (i8 | 0) == 0 ? i1 : i8;
 }
 mftCall_viii(i1 | 0, i6 | 0, i3 | 0, i7 | 0);
 if (!i4) return;
 __Z19pop_allocation_rootv();
 return;
}

function _UNITY_png_get_cHRM_XYZ_fixed(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i11 = 0;
  return i11 | 0;
 }
 if (!(HEAP16[i2 + 114 >> 1] & 2)) {
  i11 = 0;
  return i11 | 0;
 }
 if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i2 + 76 >> 2];
 if (i5 | 0) HEAP32[i5 >> 2] = HEAP32[i2 + 80 >> 2];
 if (i6 | 0) HEAP32[i6 >> 2] = HEAP32[i2 + 84 >> 2];
 if (i7 | 0) HEAP32[i7 >> 2] = HEAP32[i2 + 88 >> 2];
 if (i8 | 0) HEAP32[i8 >> 2] = HEAP32[i2 + 92 >> 2];
 if (i9 | 0) HEAP32[i9 >> 2] = HEAP32[i2 + 96 >> 2];
 if (i10 | 0) HEAP32[i10 >> 2] = HEAP32[i2 + 100 >> 2];
 if (i11 | 0) HEAP32[i11 >> 2] = HEAP32[i2 + 104 >> 2];
 if (!i3) {
  i11 = 4;
  return i11 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 108 >> 2];
 i11 = 4;
 return i11 | 0;
}

function _alloc_barray(i7, i8, i9, i10) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i11 = 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i11 = i9 << 7;
 i1 = 999999988 / (i11 >>> 0) | 0;
 if (i11 >>> 0 > 999999988) {
  i6 = HEAP32[i7 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 70;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i7 | 0);
 }
 i3 = (i1 | 0) < (i10 | 0) ? i1 : i10;
 HEAP32[i2 + 80 >> 2] = i3;
 i6 = _alloc_small(i7, i8, i10 << 2) | 0;
 if (!i10) return i6 | 0; else i1 = 0;
 do {
  i2 = i10 - i1 | 0;
  i3 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
  i2 = _alloc_large(i7, i8, Math_imul(i11, i3) | 0) | 0;
  if (i3) {
   i5 = i3;
   while (1) {
    i4 = i1 + 1 | 0;
    HEAP32[i6 + (i1 << 2) >> 2] = i2;
    i5 = i5 + -1 | 0;
    if (!i5) {
     i1 = i4;
     break;
    } else {
     i2 = i2 + (i9 << 7) | 0;
     i1 = i4;
    }
   }
  }
 } while (i1 >>> 0 < i10 >>> 0);
 return i6 | 0;
}

function __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 70;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx25PxMaterialGeneratedValuesC2EPKNS_10PxMaterialE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 4 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 8 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 12 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0));
 HEAP16[i2 + 16 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 24 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 28 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN4crnd28crnd_get_bytes_per_dxt_blockE10crn_format(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 do switch (i1 | 0) {
 case 0:
  {
   if (!i2) i1 = 8; else i3 = 14;
   break;
  }
 case 1:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 2:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 3:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 4:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 5:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 6:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 7:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 8:
  {
   if (!i2) i3 = 13; else i3 = 14;
   break;
  }
 case 9:
  {
   if (!i2) i1 = 8; else i3 = 14;
   break;
  }
 case 10:
  {
   if (!i2) i1 = 8; else i3 = 14;
   break;
  }
 default:
  i3 = 14;
 } while (0);
 if ((i3 | 0) == 13) i1 = 16; else if ((i3 | 0) == 14) i1 = 0;
 return i1 | 0;
}

function __ZN4FMOD3DSP8addInputEPS0_PPNS_13DSPConnectionE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 857481;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 857481;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 857481;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP16getSpeakerActiveE12FMOD_SPEAKERPb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868832;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868832;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868832;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup14overrideVolumeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868341;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868341;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868341;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN18AnimatorController23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 902391 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) {
   __ZN25RuntimeAnimatorController8TransferI14SafeBinaryReadEEvRT_(i3, i4);
   __ZN14SafeBinaryRead10SetVersionEi(i4, 5);
   __ZN18AnimatorController19TransferRuntimeDataI14SafeBinaryReadEEvRT_(i3, i4);
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14AvatarPlaybackD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i2 >> 2] = gb + 178100 + 8;
 i5 = i2 + 4 | 0;
 i6 = i2 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = i4;
 if ((i1 | 0) != (i4 | 0)) {
  i4 = i2 + 36 | 0;
  i2 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0, i4);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 * 12 | 0) + 4 >> 2] | 0, i4);
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i3 = i7;
  } while (i2 >>> 0 < ((i1 - i7 | 0) / 12 | 0) >>> 0);
 }
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) {
  i1 = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 if (!i3) return;
 if ((i1 | 0) != (i3 | 0)) HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN13TrailRenderer5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i2 = HEAP32[i1 + 344 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i4 = i2 + 24 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 348 >> 2] = 0;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 356 >> 2] = 0;
 i4 = i1 + 360 | 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 f7 = Math_fround(-Math_fround(HEAPF32[gb + 62500 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 4 >> 2]));
 f5 = Math_fround(-Math_fround(HEAPF32[gb + 62500 + 8 >> 2]));
 HEAPF32[i1 + 372 >> 2] = f7;
 HEAPF32[i1 + 376 >> 2] = f6;
 HEAPF32[i1 + 380 >> 2] = f5;
 return;
}

function __ZN11AudioSource15SetDopplerLevelEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0;
 i2 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(5.0);
 f1 = i3 ? Math_fround(5.0) : f1;
 f1 = i2 ? Math_fround(0.0) : f1;
 i2 = i4 + 392 | 0;
 if (f1 != Math_fround(HEAPF32[i2 >> 2])) HEAPF32[i2 >> 2] = f1;
 i2 = i4 + 456 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance17set3DDopplerLevelEf(i2, f1) | 0;
 }
 i2 = HEAP32[i4 + 432 >> 2] | 0;
 i4 = i4 + 428 | 0;
 i3 = i2;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i2 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance17set3DDopplerLevelEf(i2, f1) | 0;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __Z21Animation_CUSTOM_PlayP12Il2CppObjectP12Il2CppStringi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i4);
  i4 = (__ZN9Animation4PlayERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i1, i5, i3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return i4 | 0;
 }
 return 0;
}

function _UNITY_png_destroy_read_struct(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) return;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) return;
 _UNITY_png_destroy_info_struct(i4, i3);
 _UNITY_png_destroy_info_struct(i4, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_png_destroy_gamma_table(i4);
 _UNITY_png_free(i4, HEAP32[i4 + 616 >> 2] | 0);
 _UNITY_png_free(i4, HEAP32[i4 + 660 >> 2] | 0);
 _UNITY_png_free(i4, HEAP32[i4 + 644 >> 2] | 0);
 i3 = i4 + 580 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 & 4096) {
  _UNITY_png_zfree(i4, HEAP32[i4 + 412 >> 2] | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = i1 & -4097;
 HEAP32[i3 >> 2] = i2;
 if (!(i1 & 8192)) i1 = i2; else {
  _UNITY_png_free(i4, HEAP32[i4 + 524 >> 2] | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 & -8193;
 _unity_z_inflateEnd(i4 + 220 | 0) | 0;
 _UNITY_png_free(i4, HEAP32[i4 + 592 >> 2] | 0);
 _UNITY_png_destroy_png_struct(i4);
 return;
}

function _UNITY_LZ4_loadDict(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = i1 + i2 | 0;
 if (HEAP32[i6 + 16388 >> 2] | 0) _memset(i6 | 0, 0, 16416) | 0;
 if ((i2 | 0) < 4) {
  HEAP32[i6 + 16392 >> 2] = 0;
  HEAP32[i6 + 16400 >> 2] = 0;
  i6 = 0;
  return i6 | 0;
 }
 i7 = i4 + -65536 | 0;
 i1 = i7 >>> 0 < i1 >>> 0 ? i1 : i7;
 i7 = i6 + 16384 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 + 16392 >> 2] = i1;
 i3 = i4 - i1 | 0;
 i5 = i6 + 16400 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i7 >> 2] = i2 + i3;
 i4 = i4 + -4 | 0;
 if (i1 >>> 0 > i4 >>> 0) {
  i7 = i3;
  return i7 | 0;
 }
 i2 = i1 + (0 - i2) | 0;
 do {
  HEAP32[i6 + ((Math_imul(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24, -1640531535) | 0) >>> 20 << 2) >> 2] = i1 - i2;
  i1 = i1 + 3 | 0;
 } while (i1 >>> 0 <= i4 >>> 0);
 i7 = HEAP32[i5 >> 2] | 0;
 return i7 | 0;
}

function _asinhf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 & 2147483647;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (i2 >>> 0 > 1166016511) f1 = Math_fround(Math_fround(+Math_log(+f1)) + Math_fround(.693147182)); else {
  if (i2 >>> 0 > 1073741823) {
   f1 = Math_fround(+Math_log(+Math_fround(Math_fround(f1 * Math_fround(2.0)) + Math_fround(Math_fround(1.0) / Math_fround(f1 + Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(1.0)))))))));
   break;
  }
  if (i2 >>> 0 > 964689919) {
   f4 = Math_fround(f1 * f1);
   f1 = Math_fround(_log1pf(Math_fround(f1 + Math_fround(f4 / Math_fround(Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(1.0)))) + Math_fround(1.0))))));
  }
 } while (0);
 f4 = Math_fround(-f1);
 return Math_fround((i3 | 0) < 0 ? f4 : f1);
}

function __ZNK5physx7NpCloth26getCentrifugalInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore26getCentrifugalInertiaScaleEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 644, gb + 697320 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexEf(i1, f8) {
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i9) {
  f2 = Math_fround(inf);
  f3 = Math_fround(-inf);
 } else {
  i7 = HEAP32[i1 + 152 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f3 = Math_fround(HEAPF32[i7 + ((i9 + -1 | 0) * 52 | 0) >> 2]);
 }
 if (!(!(f2 >= f8) & !(f3 <= f8))) {
  i9 = -1;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 152 >> 2] | 0;
 i7 = i6;
 i1 = (i9 * 52 | 0) / 52 | 0;
 L7 : while (1) {
  while (1) {
   if (!i1) break L7;
   i4 = (i1 | 0) / 2 | 0;
   i5 = i6 + (i4 * 52 | 0) | 0;
   if (Math_fround(HEAPF32[i5 >> 2]) < f8) break; else i1 = i4;
  }
  i6 = i5 + 52 | 0;
  i1 = i1 + -1 - i4 | 0;
 }
 i7 = ((i6 - i7 | 0) / 52 | 0) + -1 | 0;
 i9 = i9 + -2 | 0;
 i9 = (i7 | 0) < (i9 | 0) ? i7 : i9;
 i9 = (i9 | 0) > 0 ? i9 : 0;
 return i9 | 0;
}

function __ZN5physx2Sn13XmlNodeReader4readEPKcRy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 16 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 while (1) {
  if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, i2) | 0)) break;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) {
  STACKTOP = i6;
  return i1 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 i1 = i5;
 if (!i5) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 if (!(HEAP8[i1 >> 0] | 0)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = _strtoull(i1, i4, 10) | 0;
 i4 = getTempRet0() | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15setParticleMassEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 44 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function __ZN5physx18NpArticulationLinkD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 92380 + 8;
 i2 = HEAP32[i3 + 328 >> 2] | 0;
 do if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i3 + 320 >> 2] | 0;
  if ((i3 + 300 | 0) == (i2 | 0)) {
   HEAP8[i3 + 316 >> 0] = 0;
   break;
  }
  if (i2 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
  }
 } while (0);
 HEAP32[i3 >> 2] = gb + 92112 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i3 + 64 | 0);
 HEAP32[i3 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i3 + 20 | 0);
 HEAP32[i3 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i3);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN4crnd25static_huffman_data_model5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = i6 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  if (!(i4 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i4 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
   HEAP32[i5 >> 2] = gb + 401209;
   HEAP32[i5 + 4 >> 2] = 2513;
   HEAP32[i5 + 8 >> 2] = gb + 401349;
   _sprintf(i2, gb + 401176 | 0, i5) | 0;
   _puts(i2) | 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 }
 HEAP8[i1 + 16 >> 0] = 0;
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4FMOD6Reverb13getPropertiesEP22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868909;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868909;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868909;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP16setSpeakerActiveE12FMOD_SPEAKERb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868875;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868875;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868875;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI11CanvasGroup17SetBlocksRaycastsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 + 41 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i3 >> 0] = i2 & 1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN21DownloadHandlerScript22OnReceiveContentLengthEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 248 | 0;
 i5 = i8 + 8 | 0;
 i6 = i8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 i1 = i3 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i9 = i1;
 i1 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i5, i2, i7);
 __ZN18ScriptingArguments6AddIntEi(i5, i4);
 HEAP32[i7 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i7, 0) | 0;
 STACKTOP = i8;
 return;
}

function __ZN15ResourceManager19ClearDependencyInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10;
 i9 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = i1 + 32 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i9 | 0)) {
  STACKTOP = i10;
  return;
 }
 i7 = i8 + 4 | 0;
 i5 = i1;
 while (1) {
  i1 = i5 + -20 | 0;
  HEAP32[i6 >> 2] = i1;
  i3 = HEAP32[i5 + -16 >> 2] | 0;
  i4 = i3;
  if (i3) {
   i1 = i5 + -12 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
   i1 = HEAP32[i5 + -4 >> 2] | 0;
   HEAP32[i8 >> 2] = 51;
   HEAP32[i7 >> 2] = i1;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i8);
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) == (i9 | 0)) break; else i5 = i1;
 }
 STACKTOP = i10;
 return;
}

function __Z54ParticleSystem_ShapeModule_CUSTOM_SetMeshMaterialIndexP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[i1 + 48 + 56 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z46ComputeShader_CUSTOM_GetKernelThreadGroupSizesP12Il2CppObjectiPjS1_S1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 4 | 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (__ZN13ComputeShader25GetKernelThreadGroupSizesEjPj(i7, i2, i6) | 0) {
  HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i6 + 8 >> 2];
  STACKTOP = i8;
  return;
 } else {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509133 | 0, i8);
 }
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 28 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5Umbra9Matrix4x411getMaxScaleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f2);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(f2 + Math_fround(f4 * f4));
 f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(f4 + Math_fround(f2 * f2));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 * f3);
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * f5));
 f3 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * f3));
 f2 = f4 > f2 ? f4 : f2;
 return Math_fround(Math_sqrt(Math_fround(f3 > f2 ? f3 : f2)));
}

function __ZNK5Umbra9Matrix4x311getMaxScaleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f2);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(f2 + Math_fround(f4 * f4));
 f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(f4 + Math_fround(f2 * f2));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 * f3);
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * f5));
 f3 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * f3));
 f2 = f4 > f2 ? f4 : f2;
 return Math_fround(Math_sqrt(Math_fround(f3 > f2 ? f3 : f2)));
}

function __ZNK5Umbra9Matrix3x311getMaxScaleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(f2 * f2);
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f2 + Math_fround(f4 * f4));
 f2 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f2 = Math_fround(f4 + Math_fround(f2 * f2));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 * f3);
 f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(f3 + Math_fround(f5 * f5));
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f3 = Math_fround(f5 + Math_fround(f3 * f3));
 f2 = f4 > f2 ? f4 : f2;
 return Math_fround(Math_sqrt(Math_fround(f3 > f2 ? f3 : f2)));
}

function __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 << 2 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialES4_(i3, i5, i1, i2, i4) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6;
 i7 = i6 + 4 | 0;
 HEAP32[i8 >> 2] = i2;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i7 >> 0] = 11;
 i2 = mftCall_iiiiiii(i2 | 0, i3 | 0, i1 | 0, i8 | 0, 1, 1, i7 | 0) | 0;
 if (!i2) {
  i8 = 0;
  STACKTOP = i6;
  return i8 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i4 | 0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0, i3 | 0, i5 | 0) | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 i8 = i1;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN20GlobalCachingManager21ClearAllExpiredCachesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 >> 2] = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN20GlobalCachingManager16ReadCacheIndicesERNSt3__26vectorIP5CacheNS0_9allocatorIS3_EEEEb(0, i4, 0);
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) {
  i2 = i3;
  i1 = i3;
 } else {
  do {
   i2 = HEAP32[i3 >> 2] | 0;
   if (i2) {
    __ZN5CacheD2Ev(i2);
    __ZdlPv(i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) != (i1 | 0));
  i2 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(16, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(16, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13ComputeBuffer9CopyCountEPS_S0_j(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9 + 12 | 0;
 i2 = i9 + 8 | 0;
 i6 = i9 + 4 | 0;
 i7 = i9;
 if (!i4) {
  STACKTOP = i9;
  return;
 }
 i8 = i4 + 12 | 0;
 if (!((i1 | 0) != 0 & (HEAP32[i8 >> 2] | 0) != 0)) {
  STACKTOP = i9;
  return;
 }
 i1 = i1 + 12 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i9;
  return;
 }
 if (!(HEAP32[i4 + 8 >> 2] & 6)) {
  STACKTOP = i9;
  return;
 }
 i4 = __Z12GetGfxDevicev() | 0;
 i10 = HEAP32[(HEAP32[i4 >> 2] | 0) + 764 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 mftCall_viiii(i10 | 0, i4 | 0, i2 | 0, i3 | 0, i5 | 0);
 STACKTOP = i9;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager11setPickableEPKvb(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv(i1, i4) | 0;
 HEAP8[i2 >> 0] = i5 & 1;
 HEAP8[i2 + 1 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider15isInstanceValidEPKv(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i2 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i1 = HEAP32[i2 + 64 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i4 = i5;
  i4 = i4 + ~(i4 << 15) | 0;
  i4 = (i4 >>> 10 ^ i4) * 9 | 0;
  i4 = i4 >>> 6 ^ i4;
  i4 = i4 + ~(i4 << 11) | 0;
  i1 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = 0; else {
   i4 = HEAP32[i2 + 48 >> 2] | 0;
   i3 = i2 + 52 | 0;
   i2 = i1;
   while (1) {
    i1 = i4 + (i2 << 3) | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break L1;
    i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
    if ((i2 | 0) == -1) {
     i1 = 0;
     break;
    }
   }
  }
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 return (i1 | 0) != 0 | 0;
}

function __Z46Mesh_CUSTOM_PrintErrorCantAccessMeshForIndicesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 4 | 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 546998 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 546865 | 0, 93, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i5;
  return;
 }
}

function __Z43ParticleSystem_ShapeModule_CUSTOM_SetRadiusP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 12 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_ShapeModule_CUSTOM_SetLengthP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 20 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 36980 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function _UNITY_FT_Stream_ReadUOffset(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i4 >> 2] = 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 + 2 | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  if (!i5) {
   i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i7 = 6;
  } else {
   if ((mftCall_iiiii(i5 | 0, i3 | 0, i2 | 0, i1 | 0, 3) | 0) != 3) break;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = 6;
  }
  if ((i7 | 0) == 6) {
   i3 = (HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0);
   i1 = i2;
  }
  HEAP32[i6 >> 2] = i1 + 3;
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 85;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK5physx7NpCloth25getMotionConstraintConfigEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore25getMotionConstraintConfigEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 271, gb + 695974 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK5physx7NpCloth25getAngularDragCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore25getAngularDragCoefficientEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 724, gb + 696649 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK24RendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i3 = i5 + 11 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i1 = i4 ? HEAP32[i5 >> 2] | 0 : i5;
 i2 = i4 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = _memchr(i1, 91, i2) | 0;
 i8 = i1;
 i4 = (i4 | 0) == 0 ? 0 : 1 - i8 + i4 | 0;
 i2 = _memchr(i1, 93, i2) | 0;
 if ((i4 | 0) == -1 | ((i2 | 0) == 0 | (i2 - i8 | 0) == -1)) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(__Z10BeginsWithPKcS0_(i1, gb + 410284 | 0) | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = __Z11StringToIntPKc(((HEAP8[i3 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5) + i4 | 0) | 0;
 if ((i1 | 0) == -1 | i6 ^ 1) {
  i8 = 0;
  return i8 | 0;
 }
 HEAP32[i7 + 4 >> 2] = i1;
 i8 = 1;
 return i8 | 0;
}

function __ZN8Animator14StartRecordingEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[i6 + 153 >> 0] | 0)) return;
 if (HEAP32[i6 + 108 >> 2] | 0) {
  i5 = i6 + 624 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 | 0) {
   i2 = i6 + 136 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    i4 = i6 + 148 | 0;
    if (!(HEAP32[i4 >> 2] | 0)) {
     i1 = i6 + 112 | 0;
     HEAP32[i2 >> 2] = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i3, i1, i4) | 0;
     __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(i3, i1);
     i1 = HEAP32[i5 >> 2] | 0;
    }
   }
   __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE(i1, i6 + 112 | 0);
  }
 }
 i1 = i6 + 548 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 1) return;
 __ZN14AvatarPlayback4InitEi(i6 + 504 | 0, i7);
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj(i3, i1, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0;
 if (!(HEAP32[i3 + 872 >> 2] | 0)) i1 = __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i3 + 860 >> 2] | 0, i1) | 0; else i1 = 14;
 i8 = (i6 | 0) != 0 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 698 >> 0] | 0) != 0;
 i2 = i7 >>> 0 > 1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0) != 0;
 if (i8) if (i2) {
  mftCall_viiiiii(HEAP32[i3 + 448 >> 2] | 0, i1 | 0, i5 | 0, 5123, i4 | 0, i7 | 0, i6 | 0);
  return;
 } else {
  mftCall_viiiii(HEAP32[i3 + 440 >> 2] | 0, i1 | 0, i5 | 0, 5123, i4 | 0, i6 | 0);
  return;
 } else if (i2) {
  mftCall_viiiii(HEAP32[i3 + 444 >> 2] | 0, i1 | 0, i5 | 0, 5123, i4 | 0, i7 | 0);
  return;
 } else {
  mftCall_viiii(HEAP32[i3 + 436 >> 2] | 0, i1 | 0, i5 | 0, 5123, i4 | 0);
  return;
 }
}

function __ZN6Camera13CopiableState5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 828 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 832 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 836 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 840 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 812 >> 2] = 1044694213;
 HEAP32[i1 + 816 >> 2] = 1050319515;
 HEAP32[i1 + 820 >> 2] = 1056109299;
 HEAP32[i1 + 824 >> 2] = 0;
 HEAPF32[i1 + 852 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 884 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 888 >> 2] = Math_fround(1.0e3);
 HEAP32[i1 + 892 >> 2] = -1;
 HEAPF32[i1 + 1024 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 1052 >> 0] = 0;
 HEAP8[i1 + 1055 >> 0] = 0;
 HEAP32[i1 + 1028 >> 2] = 0;
 HEAP32[i1 + 1032 >> 2] = 0;
 HEAPF32[i1 + 880 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 256 >> 2] = Math_fround(60.0);
 HEAP32[i1 + 808 >> 2] = 1;
 HEAP32[i1 + 1040 >> 2] = 16843009;
 HEAP32[i1 + 784 >> 2] = 0;
 HEAP32[i1 + 788 >> 2] = 3;
 return;
}

function __ZN5physx5cloth16TripletSchedulerC2ENS0_5RangeIA4_KjEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i5 + 4 | 0;
 i1 = i1 >>> 0 < i4 >>> 0 ? 0 : i1 - i4 >> 4;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i1;
 if (!i1) HEAP32[i5 >> 2] = 0; else {
  i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i1 << 4, gb + 838004 | 0, 543) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i2;
  i3 = i2 + (i1 << 4) | 0;
  if ((i1 | 0) > 0) {
   i1 = i4;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
    HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
    HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
    i2 = i2 + 16 | 0;
    if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 16 | 0;
   }
  }
 }
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 return;
}

function __ZN5physx3Ext14SphericalJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 88796 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 88796 + 200;
 HEAP32[i1 >> 2] = i4 + 84;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 120 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 88776 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx3Ext14PrismaticJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 88228 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 88228 + 216;
 HEAP32[i1 >> 2] = i4 + 84;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 112 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 88208 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestitutionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 48 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2048;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15setParticleMassEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 44 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function __ZN5physx13GuMeshFactory18addFactoryListenerERNS_21GuMeshFactoryListenerE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = i7 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i7 + 128 | 0;
 HEAP32[i1 >> 2] = i6;
 i4 = i7 + 132 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i7 + 136 >> 2] & 2147483647) >>> 0 > i5 >>> 0) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] = i6;
  HEAP32[i4 >> 2] = i5 + 1;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_21GuMeshFactoryListenerENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i3, i1) | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx12_GLOBAL__N_116LocationCallback6invokeERfPKNS_2Sq13PrunerPayloadEj(i3, i6, i4, i1) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, i5 = 0, f7 = f0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i5 + 4 | 0;
 f2 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i8 >> 2] = f2;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = mftCall_iiifi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i4 >> 2] | 0, +f2, i8 | 0) | 0;
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 if (f7 > Math_fround(HEAPF32[i6 >> 2])) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 726270 | 0, 96, gb + 726346 | 0, i5);
 if (!i1) {
  i8 = 0;
  STACKTOP = i5;
  return i8 | 0;
 }
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 HEAPF32[i6 >> 2] = f2 < f7 ? f2 : f7;
 i8 = 1;
 STACKTOP = i5;
 return i8 | 0;
}

function __ZN4Mesh19UnloadFromGfxDeviceEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 __ZN23SharedMeshRenderingData6UnloadEv(HEAP32[i2 + 36 >> 2] | 0);
 i1 = i2 + 192 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 196 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 200 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i3 = i2 + 44 | 0;
  i2 = HEAP8[i3 >> 0] | 0;
  i2 = i2 | 3;
  HEAP8[i3 >> 0] = i2;
  return;
 }
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i3 = i2 + 44 | 0;
 i2 = HEAP8[i3 >> 0] | 0;
 i2 = i2 | 3;
 HEAP8[i3 >> 0] = i2;
 return;
}

function __ZN4FMOD12ChannelGroup14get3DOcclusionEPfS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868182;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868182;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868182;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup11overridePanEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868285;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868285;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868285;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2UI11CanvasGroup15SetInteractableEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 + 40 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP8[i3 >> 0] = i2 & 1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEi17AwakeFromLoadMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i4 = HEAP32[i1 + (i2 * 20 | 0) >> 2] | 0;
 i1 = HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2] | 0;
 HEAP32[i6 >> 2] = fb + 599;
 __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_(i4, i4 + (i1 * 12 | 0) | 0, i6);
 if ((i2 | 0) == 1) {
  i6 = __Z24SetExecutionRestrictions21ExecutionRestrictions(4) | 0;
  __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i4, i1, i3);
  __Z24SetExecutionRestrictions21ExecutionRestrictions(i6) | 0;
  STACKTOP = i5;
  return;
 } else {
  __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode(i4, i1, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZL12InbetweenJobP16InbetweenJobData(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1162192 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162192 | 0, i1);
  i4 = gb + 1162192 | 0;
 } else i4 = 0;
 i5 = i6 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = (HEAP32[i6 >> 2] | 0) + (i3 << 3) | 0;
   if (HEAP32[i2 >> 2] | 0) {
    HEAP32[i2 >> 2] = 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i6, gb + 64024 | 0);
 if (!i4) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i7;
 return;
}

function __Z42ParticleSystem_ShapeModule_CUSTOM_SetAngleP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 16 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z40CommandBuffer_CUSTOM_SetGlobalFloatArrayP12Il2CppObjectiP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i4 = i7 + 12 | 0;
 if (!i3) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 1041262 | 0);
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 if (!i5) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 558494 | 0, i7);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6); else {
  HEAP32[i4 >> 2] = i2;
  __ZN22RenderingCommandBuffer22AddSetGlobalFloatArrayERKN9ShaderLab16FastPropertyNameEPKfi(i1, i4, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0, i5);
  STACKTOP = i7;
  return;
 }
}

function _XXH64_reset(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = _i64Add(i2 | 0, i3 | 0, -1379879466, 1625958382) | 0;
 i9 = getTempRet0() | 0;
 i8 = _i64Add(i2 | 0, i3 | 0, 668265295, -1028477379) | 0;
 i7 = getTempRet0() | 0;
 i5 = _i64Add(i2 | 0, i3 | 0, 2048144761, 1640531534) | 0;
 i4 = getTempRet0() | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = i10;
 HEAP32[i6 + 4 >> 2] = i9;
 i6 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 i6 = i1 + 32 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i4;
 i1 = i1 + 48 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return 0;
}

function __ZNK5physx7NpCloth24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i4 = __ZNK5physx2Sc9ClothCore24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE(i2 + 32 | 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 300, gb + 695804 | 0, i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK5physx14NpSceneQueries7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE(i6, i3, i5, i4, i2, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7;
 i8 = i7 + 24 | 0;
 HEAP32[i9 + 12 >> 2] = i3;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP16[i8 >> 1] = 0;
 i6 = __ZNK5physx14NpSceneQueries10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE(i6, i9, i4, i8, 0, i2, i1, 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx3Ext13RevoluteJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 88500 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 88500 + 240;
 HEAP32[i1 >> 2] = i4 + 84;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 136 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 88480 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx21PxsBodyTransformVault12teleportBodyERKNS_11PxsBodyCoreE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i1 = HEAP32[i1 + (((i2 >>> 16 ^ i2) & 1023) << 2) >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i2 = HEAP32[i1 + 32 >> 2] | 0;
  if (i2) while (1) {
   if ((HEAP32[i1 + 28 >> 2] | 0) == (i3 | 0)) break L1;
   i1 = HEAP32[i2 + 32 >> 2] | 0;
   if (!i1) {
    i1 = i2;
    break;
   } else {
    i4 = i2;
    i2 = i1;
    i1 = i4;
   }
  }
 } while (0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 if ((HEAP16[i6 + 24 >> 1] | 0) == -1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = HEAP32[gb + 1457324 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
 i1 = mftCall_iiiiiii(i9 | 0, i8 | 0, i2 | 0, i4 | 0, i3 | 0, 1, i1 | 0) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i6 + 20 | 0, i1, i6);
 __ZN5physx7NpShape15releaseInternalEv(i1);
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN4FMOD7Channel20get3DConeOrientationEP11FMOD_VECTOR(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 865684;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 865684;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 865684;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel19get3DMinMaxDistanceEPfS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868452;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868452;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868452;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup15getSystemObjectEPPNS_6SystemE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862473;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862473;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862473;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21LightProbeProxyVolumeC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 34500 + 8;
 HEAP32[i1 + 140 >> 2] = 1;
 HEAP32[i1 + 144 >> 2] = 1;
 HEAP32[i1 + 148 >> 2] = 1;
 HEAP16[i1 + 152 >> 1] = -1;
 HEAP8[i1 + 154 >> 0] = 1;
 i3 = i1 + 156 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN20ArchiveStorageHeader41GetSizeRequiredToParseHeaderAndBlocksInfoERKNS_6HeaderE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP32[i1 + 72 >> 2] & 128 | 0) {
  i2 = i1 + 56 | 0;
  if ((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0) {
   i1 = 0;
   i2 = 0;
   setTempRet0(i1 | 0);
   return i2 | 0;
  }
 }
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 do if (((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0) == 8) {
  if (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489810 | 0, 8) | 0) if (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489801 | 0, 8) | 0) break;
  i2 = 0;
  i3 = HEAP32[i1 + 64 >> 2] | 0;
  setTempRet0(i2 | 0);
  return i3 | 0;
 } while (0);
 i2 = __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE(i1) | 0;
 i3 = getTempRet0() | 0;
 i3 = _i64Add(HEAP32[i1 + 64 >> 2] | 0, 0, i2 | 0, i3 | 0) | 0;
 i2 = getTempRet0() | 0;
 setTempRet0(i2 | 0);
 return i3 | 0;
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802541 | 0, i1, 0);
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i1 = i1 + 160 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802559 | 0, gb + 802568 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 802578 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags(i2, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15QualitySettings22SetShadowCascade4SplitE8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(0.0);
 i5 = f4 > Math_fround(1.0);
 f4 = i5 ? Math_fround(1.0) : f4;
 HEAPF32[i2 >> 2] = i3 ? Math_fround(0.0) : f4;
 i3 = i2 + 4 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = f4 < Math_fround(0.0);
 i6 = f4 > Math_fround(1.0);
 f4 = i6 ? Math_fround(1.0) : f4;
 HEAPF32[i3 >> 2] = i5 ? Math_fround(0.0) : f4;
 i3 = i2 + 8 | 0;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i5 = f4 < Math_fround(0.0);
 i6 = f4 > Math_fround(1.0);
 f4 = i6 ? Math_fround(1.0) : f4;
 HEAPF32[i3 >> 2] = i5 ? Math_fround(0.0) : f4;
 i1 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN14qsort_internal18QSortSingleJobDataIP15RODataDepthPassi17ROSorterDepthPassE7SortJobEPS4_(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i2 = i5;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i1, i3);
 } else i1 = 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 HEAP8[i3 >> 0] = HEAP8[i5 + 8 >> 0] | 0;
 __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_(i7, i6, i2, i3);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i3 = i7 + 36 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i7 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 if ((HEAP32[i5 + 16 >> 2] | 0) != 3) return;
 i8 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i5, gb + 1040810 | 0) | 0;
 HEAP32[i4 >> 2] = i8;
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1040818;
 if (i8 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, 0);
  __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue8TransferI8JSONReadEEvRT_(i6 + 4 | 0, i7);
  HEAP8[i3 >> 0] = 1;
  i8 = i7 + 56 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN11TrailModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAP16[i1 + 96 >> 1] = 0;
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, Math_fround(1.0), 0) | 0) & 1;
 HEAPF32[i1 + 276 >> 2] = Math_fround(.200000003);
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP8[i1 + 284 >> 0] = 0;
 HEAP8[i1 + 285 >> 0] = 1;
 HEAP8[i1 + 286 >> 0] = 1;
 HEAP8[i1 + 287 >> 0] = 0;
 HEAP8[i1 + 288 >> 0] = 1;
 HEAP16[i1 + 444 >> 1] = 0;
 HEAP16[i1 + 532 >> 1] = 0;
 HEAPF32[i1 + 528 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 534 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 448 | 0, i1 + 536 | 0, Math_fround(1.0), 0) | 0) & 1;
 HEAP16[i1 + 864 >> 1] = 0;
 HEAPF32[i1 + 868 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 872 >> 2] = 0;
 return;
}

function __Z58CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeiiS0_(i1, i6, i2, i7, i8, i9, i10, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i11;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 if (!i2) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) i1 = 0; else i1 = HEAP32[i5 + 8 >> 2] | 0;
 __ZN22RenderingCommandBuffer17AddDrawProceduralERK10Matrix4x4fP8Materiali16GfxPrimitiveTypeiiP19ShaderPropertySheet(i4, i6, i2, i7, i8, i9, i10, i1);
 STACKTOP = i11;
 return;
}

function __Z20CalculateRangeBoundsfPfPKfS1_S1_(f1, i2, i3, i4, i5) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, i7 = 0, f8 = f0, f9 = f0;
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f8 + Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f1));
 i7 = i3 + 8 | 0;
 f9 = Math_fround(HEAPF32[i7 >> 2]);
 f1 = Math_fround(f9 + Math_fround(Math_fround(HEAPF32[i4 + 8 >> 2]) * f1));
 HEAPF32[i2 >> 2] = Math_fround((f8 < f6 ? f8 : f6) - Math_fround(HEAPF32[i5 >> 2]));
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 i4 = i5 + 8 | 0;
 HEAPF32[i2 + 4 >> 2] = Math_fround((f8 < f1 ? f8 : f1) - Math_fround(HEAPF32[i4 >> 2]));
 f8 = Math_fround(HEAPF32[i3 >> 2]);
 HEAPF32[i2 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + (f8 > f6 ? f8 : f6));
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 HEAPF32[i2 + 12 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) + (f6 > f1 ? f6 : f1));
 return;
}

function _UNITY_png_set_tRNS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 if (i3 | 0) {
  _UNITY_png_free_data(i1, i2, 8192, 0);
  i6 = _UNITY_png_malloc(i1, 256) | 0;
  HEAP32[i2 + 148 >> 2] = i6;
  HEAP32[i1 + 524 >> 2] = i6;
  if ((i4 + -1 | 0) >>> 0 < 256) _memcpy(i6 | 0, i3 | 0, i4 | 0) | 0;
 }
 if (!i5) {
  HEAP16[i2 + 22 >> 1] = i4;
  if (!i4) return;
 } else {
  i6 = i2 + 152 | 0;
  HEAP16[i6 >> 1] = HEAP16[i5 >> 1] | 0;
  HEAP16[i6 + 2 >> 1] = HEAP16[i5 + 2 >> 1] | 0;
  HEAP16[i6 + 4 >> 1] = HEAP16[i5 + 4 >> 1] | 0;
  HEAP16[i6 + 6 >> 1] = HEAP16[i5 + 6 >> 1] | 0;
  HEAP16[i6 + 8 >> 1] = HEAP16[i5 + 8 >> 1] | 0;
  HEAP16[i2 + 22 >> 1] = (i4 | 0) == 0 ? 1 : i4 & 65535;
 }
 i6 = i2 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 16;
 i6 = i2 + 220 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 8192;
 return;
}

function _vfwprintf(i8, i4, i1) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 112 | 0;
 i6 = i9 + 72 | 0;
 i7 = i9;
 i2 = i6;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 if ((_wprintf_core(0, i4, i5, i7, i6) | 0) < 0) i1 = -1; else {
  if ((HEAP32[i8 + 76 >> 2] | 0) > -1) i3 = (___lockfile(i8) | 0) != 0; else i3 = 0;
  i10 = i8 + 74 | 0;
  i1 = HEAP8[i10 >> 0] | 0;
  HEAP8[i10 >> 0] = i1 + 1 | i1;
  i10 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i10 & -33;
  i1 = _wprintf_core(i8, i4, i5, i7, i6) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i8 >> 2] = i2 | i10 & 32;
  if (i3) ___unlockfile(i8);
  i1 = i2 & 32 | 0 ? -1 : i1;
 }
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK9Transform18TransformDirectionERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 32 | 0;
 i5 = i4 + 20 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2 + 32 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z18TransformDirection23TransformAccessReadOnlyRKN4math7_float3E(i5, i7, i6);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx7NpCloth24getLinearDragCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore24getLinearDragCoefficientEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 704, gb + 696821 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK19TextRenderingModule8TMGenGetERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i1, i2, i7, i8, i9, f10, f11, f12, i13, i14, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i15 = 0, i16 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i15 = i1 + 4 | 0;
 i16 = i1;
 i7 = HEAP32[i7 + 48 >> 2] | 0;
 HEAP32[i16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i15 >> 2] = HEAP32[i16 >> 2];
 i14 = __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii(i2, i7, i8, i9, f10, f11, f12, i13, i14, i15, f4, i5, i6) | 0;
 STACKTOP = i1;
 return i14 | 0;
}

function __ZNK17AnimationCurveTplI8Vector3fE9FindIndexEf(i1, f8) {
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i9) {
  f2 = Math_fround(inf);
  f3 = Math_fround(-inf);
 } else {
  i7 = HEAP32[i1 + 120 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f3 = Math_fround(HEAPF32[i7 + ((i9 + -1 | 0) * 40 | 0) >> 2]);
 }
 if (!(!(f2 >= f8) & !(f3 <= f8))) {
  i9 = -1;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 120 >> 2] | 0;
 i7 = i6;
 i1 = (i9 * 40 | 0) / 40 | 0;
 L7 : while (1) {
  while (1) {
   if (!i1) break L7;
   i4 = (i1 | 0) / 2 | 0;
   i5 = i6 + (i4 * 40 | 0) | 0;
   if (Math_fround(HEAPF32[i5 >> 2]) < f8) break; else i1 = i4;
  }
  i6 = i5 + 40 | 0;
  i1 = i1 + -1 - i4 | 0;
 }
 i7 = ((i6 - i7 | 0) / 40 | 0) + -1 | 0;
 i9 = i9 + -2 | 0;
 i9 = (i7 | 0) < (i9 | 0) ? i7 : i9;
 i9 = (i9 | 0) > 0 ? i9 : 0;
 return i9 | 0;
}

function __ZNK16TypeTreeIterator4LastEv(i11, i1) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i11;
 HEAP32[i6 >> 2] = i10;
 HEAP32[i6 + 4 >> 2] = i1;
 i6 = i11 + 4 | 0;
 i7 = i10;
 i8 = i7 + 12 | 0;
 i9 = (i10 | 0) == 0;
 L1 : while (1) {
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0;
  i4 = i2 + ((HEAP32[i8 >> 2] | 0) * 24 | 0) | 0;
  i5 = i2;
  i2 = i2 + (i1 * 24 | 0) | 0;
  do {
   i1 = i2;
   i2 = i2 + 24 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i1 = 8;
    break L1;
   }
   i1 = HEAP8[i1 + 26 >> 0] | 0;
  } while ((i1 & 255) > (i3 & 255));
  if (i1 << 24 >> 24 != i3 << 24 >> 24) {
   i1 = 8;
   break;
  }
  i1 = (i2 - i5 | 0) / 24 | 0;
  if (i9) {
   i1 = 8;
   break;
  }
  HEAP32[i11 >> 2] = i10;
  HEAP32[i6 >> 2] = i1;
 }
 if ((i1 | 0) == 8) return;
}

function __ZNK14ParticleSystem7IsAliveEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, f6 = f0, d7 = 0.0;
 i2 = i5 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 30 >> 0] | 0) {
  d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i2 >> 2] | 0;
  d3 = +HEAPF64[i1 + 40 >> 3];
  i2 = HEAP32[i5 + 36 >> 2] | 0;
  if (!(HEAP8[i2 + 277 >> 0] | 0)) {
   d7 = d4 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 264 >> 2]);
   if (d7 > +Math_fround(f6 + Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2]))) {
    i5 = 0;
    return i5 | 0;
   }
  }
  if (HEAP8[i1 + 13 >> 0] | 0) if (d4 - d3 > +Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2])) {
   i5 = 0;
   return i5 | 0;
  }
 }
 if (HEAP32[i1 + 8 >> 2] | 0) {
  i5 = 1;
  return i5 | 0;
 }
 i5 = (HEAP32[(HEAP32[i5 + 32 >> 2] | 0) + 12 >> 2] | 0) != 0;
 return i5 | 0;
}

function __ZN7CubemapD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i5 >> 2] = gb + 41748 + 8;
 i1 = HEAP32[i5 + 152 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 156 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 HEAP32[i5 >> 2] = gb + 45572 + 8;
 __ZN9Texture2D15ThreadedCleanupEv(i5);
 i1 = i5 + 128 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i5 + 140 >> 2] | 0;
  HEAP32[i6 >> 2] = 66;
  HEAP32[i6 + 4 >> 2] = i3;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i6);
 }
 HEAP32[i5 >> 2] = gb + 45392 + 8;
 HEAP32[i5 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i5 + 28 | 0);
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 STACKTOP = i7;
 return;
}

function __ZN5physx3Ext13DistanceJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 87668 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 87668 + 228;
 HEAP32[i1 >> 2] = i4 + 84;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 96 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 87648 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestitutionEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 48 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2048;
 return;
}

function __ZN19VREyeTextureManager22SetDeviceTextureFormatERK30UnityVREyeTextureConfiguration(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 48 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 i3 = i2 + 56 | 0;
 i1 = i2 + 60 | 0;
 if (HEAP32[i3 >> 2] | 0) if (HEAP32[i1 >> 2] | 0) return;
 i2 = __Z16GetScreenManagerv() | 0;
 HEAP32[i3 >> 2] = ~~Math_fround(Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0) * Math_fround(.5)) >>> 0;
 i3 = __Z16GetScreenManagerv() | 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
 return;
}

function __ZN19RuntimeSceneManager14SetActiveSceneER10UnityScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i2 + 80 >> 2] | 0) != 2) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = i1 + 44 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) == (i2 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(i2);
 i5 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + 37052 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i6 = 1;
  return i6 | 0;
 } else i1 = 0;
 do {
  i3 = i5 + 36284 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i5 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i3 >> 2] | 0, i6 | 0, i4 | 0); else mftCall_viii(HEAP32[i3 >> 2] | 0, HEAP32[i5 + 36284 + (i1 * 12 | 0) + 4 >> 2] | 0, i6 | 0, i4 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN18ProceduralMaterialD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 59244 + 8;
 __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + 272 | 0, HEAP32[i1 + 276 >> 2] | 0);
 __ZN22ProceduralMaterialDataD2Ev(i1 + 144 | 0);
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i5) {
  __ZN8MaterialD2Ev(i1);
  STACKTOP = i6;
  return;
 }
 i3 = i1 + 128 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i5 | 0) >>> 2) << 2);
 i4 = HEAP32[i1 + 136 >> 2] | 0;
 HEAP32[i2 >> 2] = 77;
 HEAP32[i2 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 __ZN8MaterialD2Ev(i1);
 STACKTOP = i6;
 return;
}

function __ZN18ProceduralMaterial19FixAlphaSourcesUIDsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[i1 + 204 >> 2] | 0;
 i7 = HEAP32[i1 + 208 >> 2] | 0;
 if ((i8 | 0) == (i7 | 0)) return; else {
  i6 = i8;
  i1 = i7;
 }
 do {
  i4 = HEAP32[i6 + 12 >> 2] | 0;
  L5 : do if (i4) {
   i5 = i6 + 48 | 0;
   i2 = i5;
   i3 = HEAP32[i2 >> 2] | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (i2 >>> 0 < 1 | (i2 | 0) == 1 & i3 >>> 0 < 0) if ((i8 | 0) == (i1 | 0)) i1 = i8; else {
    i2 = i8;
    while (1) {
     if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) break;
     i1 = i2 + 72 | 0;
     if ((i1 | 0) == (i7 | 0)) {
      i1 = i7;
      break L5;
     } else {
      i2 = i1;
      i1 = i7;
     }
    }
    i4 = HEAP32[i2 + 40 + 4 >> 2] | 0;
    HEAP32[i5 >> 2] = i3;
    HEAP32[i5 + 4 >> 2] = i4;
   }
  } while (0);
  i6 = i6 + 72 | 0;
 } while ((i6 | 0) != (i7 | 0));
 return;
}

function __ZN11BoxColliderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 110728 + 8;
 i1 = i4 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 112 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 i2 = i4 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i3 = i4 + 88 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = gb + 29060 + 8;
  HEAP32[i4 >> 2] = gb + 26392 + 8;
  return;
 }
 i2 = i4 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 HEAP32[i4 >> 2] = gb + 29060 + 8;
 HEAP32[i4 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10GUIManager17CleanupGUIManagerEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 __Z23CleanupDeveloperConsolev();
 i2 = 0;
 do {
  i3 = gb + 1468832 + (i2 << 2) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (HEAP8[i1 + 284 >> 0] | 0) {
   i1 = HEAP32[i1 + 280 >> 2] | 0;
   if (i1 | 0) __ZN10InputEventD2Ev(i1);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
   i1 = HEAP32[i3 >> 2] | 0;
   HEAP32[i1 + 280 >> 2] = 0;
  }
  if (i1 | 0) __ZN8GUIStateD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
  HEAP32[i3 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 8);
 i1 = HEAP32[gb + 1468156 >> 2] | 0;
 if (i1 | 0) {
  __ZN10GUIManagerD2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[gb + 1468156 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1468876 >> 2] | 0, gb + 63864 | 0);
 HEAP32[gb + 1468876 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, gb + 63864 | 0);
 return;
}

function __Z50ParticleSystem_ShapeModule_CUSTOM_SetMeshShapeTypeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[i1 + 48 + 40 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z40ParticleSystem_ShapeModule_CUSTOM_SetArcP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[i1 + 48 + 36 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z23CleanupAsyncReadManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155100 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63216 | 0);
  HEAP32[gb + 1155100 >> 2] = 0;
  return;
 }
 __ZN13OpenFileCache13ForceCloseAllEv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 208 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 196 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 184 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 172 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 160 | 0);
 __ZN4FileD2Ev(i1 + 128 | 0);
 __ZN4FileD2Ev(i1 + 96 | 0);
 __ZN4FileD2Ev(i1 + 64 | 0);
 __ZN4FileD2Ev(i1 + 32 | 0);
 __ZN4FileD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63216 | 0);
 HEAP32[gb + 1155100 >> 2] = 0;
 return;
}

function __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i5 = i4 ? HEAP32[i1 >> 2] | 0 : i1;
 i3 = i4 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255;
 L1 : do if (!i3) i1 = gb + 1576256 | 0; else {
  i4 = i3 + -1 | 0;
  i2 = 0;
  i1 = 0;
  L3 : while (1) {
   switch (HEAP8[i5 + (i4 + i1) >> 0] | 0) {
   case 47:
    {
     i1 = gb + 1576256 | 0;
     break L1;
    }
   case 46:
    break L3;
   default:
    {}
   }
   i1 = ~i2;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i3 >>> 0) {
    i1 = gb + 1576256 | 0;
    break L1;
   }
  }
  i1 = i5 + i3 + i1 | 0;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, _strlen(i1) | 0);
 return;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 76 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  HEAP32[i3 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, 32) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __ZNSt3__26localeD2Ev(i3);
    i1 = i1 << 24 >> 24;
    HEAP32[i4 >> 2] = i1;
    break;
   }
  }
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i3);
  ___resumeException(i5 | 0);
 } while (0);
 STACKTOP = i5;
 return i1 & 255 | 0;
}

function __ZNK5physx3Ext7D6Joint8getTwistEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, i2 | 0);
 f1 = Math_fround(HEAPF32[i3 >> 2]);
 if (f1 != Math_fround(0.0)) {
  f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
  f1 = Math_fround(f5 * Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f1 * f1) + Math_fround(0.0)) + Math_fround(f5 * f5))))));
 } else f1 = Math_fround(1.0);
 i3 = f1 < Math_fround(-1.0);
 f1 = i3 ? Math_fround(-1.0) : f1;
 i3 = f1 > Math_fround(1.0);
 f1 = Math_fround(Math_fround(+Math_acos(+(i3 ? Math_fround(1.0) : f1))) * Math_fround(2.0));
 i3 = f1 <= Math_fround(3.14159274);
 f5 = Math_fround(f1 + Math_fround(-6.28318548));
 STACKTOP = i4;
 return Math_fround(i3 ? f1 : f5);
}

function __ZN7Joint2D20AddBreakLimitsUpdateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (Math_fround(HEAPF32[i4 + 44 >> 2]) == Math_fround(inf)) if (Math_fround(HEAPF32[i4 + 48 >> 2]) == Math_fround(inf)) {
  i1 = i4 + 64 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return;
  i4 = i4 + 68 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i2 = (HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0) + 588 | 0;
 i3 = i4 + 64 | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i4 + 68 | 0; else {
  i4 = i4 + 68 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __ZN5physx8debugger4comm9SetCamera9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 32 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 36 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 40 | 0);
 return;
}

function __ZN5physx7NpCloth16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE(i2 + 32 | 0, i3, i1);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 886, gb + 695727 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN4FMOD7Channel14setLowPassGainEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868711;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 868711;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868711;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD5Sound21getMusicChannelVolumeEiPf(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868962;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868962;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868962;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound19get3DMinMaxDistanceEPfS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868452;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868452;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868452;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN29AssetBundleLoadAssetOperation9LoadAssetER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1104136 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1104136 | 0, i1);
  i1 = gb + 1104136 | 0;
 } else i1 = 0;
 i2 = __Znwj(240) | 0;
 __ZN29AssetBundleLoadAssetOperationC2ER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb(i2, i3, i4, i5, i6);
 if (!i1) {
  STACKTOP = i7;
  return i2 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i7;
 return i2 | 0;
}

function __ZN26AnimatorControllerPlayable13ClearBindingsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 if (i1 | 0) {
  i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 0) | 0;
  if ((i4 | 0) != (HEAP32[i5 + 92 >> 2] | 0)) __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i5);
 }
 i4 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i5;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i6 = 10;
    break;
   } else i3 = 0;
  }
  if ((i6 | 0) == 10) {
   i6 = 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN20IntermediateRendererD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 33532 + 8;
 i1 = i3 + 236 | 0;
 i2 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 i1 = i3 + 256 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 + 192 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  __ZdlPv(i3);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig13ConfigChangedERK8UnityStrR8JSONRead(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i3 = i7 + 36 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i7 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 if ((HEAP32[i5 + 16 >> 2] | 0) != 3) return;
 i8 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i5, gb + 1042554 | 0) | 0;
 HEAP32[i4 >> 2] = i8;
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1040818;
 if (i8 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, 0);
  __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue8TransferI8JSONReadEEvRT_(i6 + 4 | 0, i7);
  HEAP8[i3 >> 0] = 1;
  i8 = i7 + 56 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z16MonoAddComponentR10GameObjectPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = __Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i2, i1, i3) | 0;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 390571 | 0, 37, 4, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  i2 = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i4;
  return i2 | 0;
 } else {
  i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i4;
  return i2 | 0;
 }
 return 0;
}

function __Z13jpeg_user_srcP22jpeg_decompress_structPN12ImageDecoder11UserContextE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 0, 65572) | 0;
  HEAP32[i2 >> 2] = i3;
 }
 HEAP32[i3 + 28 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = fb + 3371;
 HEAP32[i3 + 12 >> 2] = fb + 1572;
 HEAP32[i3 + 16 >> 2] = fb + 2401;
 HEAP32[i3 + 20 >> 2] = fb + 512;
 HEAP32[i3 + 24 >> 2] = fb + 3372;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 i1 = i3 + 32 | 0;
 i2 = mftCall_iiii(HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, i1 | 0, 65536) | 0;
 if (i2 >>> 0 >= 65536) {
  HEAP32[i3 >> 2] = i1;
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  return;
 }
 HEAP8[i3 + 32 + i2 >> 0] = -1;
 HEAP8[i2 + 1 + (i3 + 32) >> 0] = -39;
 i2 = i2 + 2 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 return;
}

function _unity_z_uncompress(i2, i5, i1, i3) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i1;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 i1 = _unity_z_inflateInit_(i6, gb + 362978 | 0, 56) | 0;
 L1 : do if (!i1) {
  i1 = _unity_z_inflate(i6, 4) | 0;
  if ((i1 | 0) == 1) {
   HEAP32[i5 >> 2] = HEAP32[i6 + 20 >> 2];
   i1 = _unity_z_inflateEnd(i6) | 0;
   break;
  }
  _unity_z_inflateEnd(i6) | 0;
  switch (i1 | 0) {
  case 2:
   {
    i1 = -3;
    break L1;
   }
  case -5:
   {
    if (!(HEAP32[i4 >> 2] | 0)) {
     i1 = -3;
     break L1;
    }
    break;
   }
  default:
   {}
  }
 } while (0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__211__stdoutbufIwE4syncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i4 = i10;
 i5 = i1 + 36 | 0;
 i6 = i1 + 40 | 0;
 i7 = i3 + 8 | 0;
 i8 = i3;
 i2 = i1 + 32 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i6 >> 2] | 0, i3 | 0, i7 | 0, i4 | 0) | 0;
  i11 = (HEAP32[i4 >> 2] | 0) - i8 | 0;
  if ((_fwrite(i3, 1, i11, HEAP32[i2 >> 2] | 0) | 0) != (i11 | 0)) {
   i1 = -1;
   break;
  }
  switch (i1 | 0) {
  case 1:
   break;
  case 2:
   {
    i1 = -1;
    break L1;
   }
  default:
   {
    i9 = 4;
    break L1;
   }
  }
 }
 if ((i9 | 0) == 4) i1 = ((_fflush(HEAP32[i2 >> 2] | 0) | 0) != 0) << 31 >> 31;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNSt3__211__stdoutbufIcE4syncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i10 + 8 | 0;
 i4 = i10;
 i5 = i1 + 36 | 0;
 i6 = i1 + 40 | 0;
 i7 = i3 + 8 | 0;
 i8 = i3;
 i2 = i1 + 32 | 0;
 L1 : while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, HEAP32[i6 >> 2] | 0, i3 | 0, i7 | 0, i4 | 0) | 0;
  i11 = (HEAP32[i4 >> 2] | 0) - i8 | 0;
  if ((_fwrite(i3, 1, i11, HEAP32[i2 >> 2] | 0) | 0) != (i11 | 0)) {
   i1 = -1;
   break;
  }
  switch (i1 | 0) {
  case 1:
   break;
  case 2:
   {
    i1 = -1;
    break L1;
   }
  default:
   {
    i9 = 4;
    break L1;
   }
  }
 }
 if ((i9 | 0) == 4) i1 = ((_fflush(HEAP32[i2 >> 2] | 0) | 0) != 0) << 31 >> 31;
 STACKTOP = i10;
 return i1 | 0;
}

function __ZNK5physx7NpCloth23getExternalAccelerationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 584, gb + 696481 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(i1, i5, i3, i2, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP8[i5 + 53 >> 0] = 1;
 do if ((HEAP32[i5 + 4 >> 2] | 0) == (i2 | 0)) {
  HEAP8[i5 + 52 >> 0] = 1;
  i1 = i5 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i5 + 24 >> 2] = i4;
   HEAP32[i5 + 36 >> 2] = 1;
   if (!((i4 | 0) == 1 ? (HEAP32[i5 + 48 >> 2] | 0) == 1 : 0)) break;
   HEAP8[i5 + 54 >> 0] = 1;
   break;
  }
  if ((i2 | 0) != (i3 | 0)) {
   i4 = i5 + 36 | 0;
   HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
   HEAP8[i5 + 54 >> 0] = 1;
   break;
  }
  i2 = i5 + 24 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == 2) {
   HEAP32[i2 >> 2] = i4;
   i1 = i4;
  }
  if ((i1 | 0) == 1 ? (HEAP32[i5 + 48 >> 2] | 0) == 1 : 0) HEAP8[i5 + 54 >> 0] = 1;
 } while (0);
 return;
}

function __ZN8b2IslandC2EiiiP16b2StackAllocatorP17b2ContactListener(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = i1 + 40 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i1 + 8 >> 2] = __ZN16b2StackAllocator8AllocateEi(i5, i2 << 2) | 0;
 HEAP32[i1 + 12 >> 2] = __ZN16b2StackAllocator8AllocateEi(HEAP32[i1 >> 2] | 0, i3 << 2) | 0;
 HEAP32[i1 + 16 >> 2] = __ZN16b2StackAllocator8AllocateEi(HEAP32[i1 >> 2] | 0, i4 << 2) | 0;
 HEAP32[i1 + 24 >> 2] = __ZN16b2StackAllocator8AllocateEi(HEAP32[i1 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 HEAP32[i1 + 20 >> 2] = __ZN16b2StackAllocator8AllocateEi(HEAP32[i1 >> 2] | 0, (HEAP32[i7 >> 2] | 0) * 12 | 0) | 0;
 return;
}
function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888814TexFormatRHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(Math_fround(((HEAP32[i5 >> 2] | 0) >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i4 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i2 >>> 23 << 1) >> 1] | 0;
   if (!(i4 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i2) | 0;
    break;
   } else {
    i2 = (i4 & 65535) + (((i2 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc9ClothCore6wakeUpEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (f2 > Math_fround(4294967.0)) {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0, -1);
  return;
 }
 i5 = ~~Math_fround(f2 * Math_fround(1.0e3)) >>> 0;
 i4 = (i5 >>> 0) / 5 | 0;
 i4 = i4 >>> 0 < 200 ? i4 : 200;
 i4 = i4 >>> 0 > 1 ? i4 : 1;
 i1 = i1 + 28 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 388 >> 2] | 0, i3 | 0) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 368 >> 2] | 0, i6 | 0, i4 | 0);
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 376 >> 2] | 0, i6 | 0, (i5 >>> 0) / (i4 >>> 0) | 0 | 0);
 if (!(f2 == Math_fround(0.0) & i3)) return;
 i6 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 392 >> 2] | 0, i6 | 0);
 return;
}

function __ZN5physx18PxsSolverStartTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 __ZN5physx18PxsSolverStartTask10startTasksEv(i1);
 __ZN5physx18PxsSolverStartTask16articulationTaskEv(i1);
 i2 = HEAP32[HEAP32[i1 + 24 >> 2] >> 2] | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i4 + 124 >> 2]);
 __ZN5physx18PxsDynamicsContext23atomIntegrationParallelEfPKPNS_11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPSA_RjSI_RNS_10PxBaseTaskE(i4, f5, HEAP32[i2 + 8856 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i2 + 8868 >> 2] | 0, (HEAP32[i4 + 100 >> 2] | 0) + (i3 << 5) | 0, (HEAP32[i4 + 112 >> 2] | 0) + (i3 << 6) | 0, HEAP32[i2 + 8880 >> 2] | 0, i2 + 9052 | 0, i2 + 9056 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZN5physx18PxsSolverStartTask13setupDescTaskEv(i1);
 return;
}

function __ZN5physx15writeWordBufferEPKtjbRNS_14PxOutputStreamE(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i3 + -1 | 0;
 if (!i3) {
  STACKTOP = i7;
  return;
 }
 i3 = i6 + 1 | 0;
 if (i4) {
  while (1) {
   i4 = HEAP16[i2 >> 1] | 0;
   HEAP16[i6 >> 1] = i4;
   HEAP8[i6 >> 0] = (i4 & 65535) >>> 8;
   HEAP8[i3 >> 0] = i4;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i6 | 0, 2) | 0;
   if (!i1) break; else {
    i2 = i2 + 2 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  STACKTOP = i7;
  return;
 } else {
  while (1) {
   HEAP16[i6 >> 1] = HEAP16[i2 >> 1] | 0;
   mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i6 | 0, 2) | 0;
   if (!i1) break; else {
    i2 = i2 + 2 | 0;
    i1 = i1 + -1 | 0;
   }
  }
  STACKTOP = i7;
  return;
 }
}

function __ZN5Unity5Cloth5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 44 >> 0] = 1;
 HEAP8[i1 + 45 >> 0] = 1;
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 92 >> 0] = 1;
 HEAP8[i1 + 93 >> 0] = 1;
 HEAPF32[i1 + 120 >> 2] = Math_fround(120.0);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.100000001);
 return;
}

function __ZN4crnd10dxt1_block17get_block_colors3EPNS_10color_quadIhiEEtt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 & 65535;
 i2 = i6 >>> 2 & 7 | i6 << 3;
 i4 = i6 >>> 5 << 2 | i6 >>> 9 & 3;
 i6 = i6 >>> 11 << 3 | i6 >>> 13;
 i7 = i3 & 65535;
 i3 = i7 >>> 2 & 7 | i7 << 3;
 i5 = i7 >>> 5 << 2 | i7 >>> 9 & 3;
 i7 = i7 >>> 11 << 3 | i7 >>> 13;
 HEAP8[i1 >> 0] = i6;
 HEAP8[i1 + 1 >> 0] = i4;
 HEAP8[i1 + 2 >> 0] = i2;
 HEAP8[i1 + 3 >> 0] = -1;
 HEAP8[i1 + 4 >> 0] = i7;
 HEAP8[i1 + 5 >> 0] = i5;
 HEAP8[i1 + 6 >> 0] = i3;
 HEAP8[i1 + 7 >> 0] = -1;
 HEAP8[i1 + 8 >> 0] = (i7 + i6 | 0) >>> 1;
 HEAP8[i1 + 9 >> 0] = ((i5 & 255) + (i4 & 255) | 0) >>> 1;
 HEAP8[i1 + 10 >> 0] = ((i3 & 255) + (i2 & 255) | 0) >>> 1;
 HEAP8[i1 + 11 >> 0] = -1;
 i3 = i1 + 12 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 return 3;
}

function __ZN4FMOD7Channel18setInputChannelMixEPfi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868679;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868679;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868679;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel18getInputChannelMixEPfi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868507;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868507;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868507;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i5 = 3; else if ((HEAP32[i1 + 92 >> 2] | 0) != (HEAP32[i3 + 92 >> 2] | 0)) i5 = 3;
 if ((i5 | 0) == 3) {
  __ZN19ShaderPropertySheet8CopyFromERKS_(__ZN20IntermediateRenderer27GetWritableSharedPropertiesEv(i4) | 0, i1);
  i3 = HEAP32[i2 >> 2] | 0;
 }
 i1 = i4 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 if (i2 | 0) {
  i5 = i2 + 4 | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  if (!(HEAP32[i5 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) return;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return;
}

function __ZN15DistanceJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 __ZN7Joint2D16CheckConsistencyEv(i2);
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 84 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i5 = gb + 1162356 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i5 = i2 + 96 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f6 < Math_fround(.00499999989);
 i3 = f6 > Math_fround(1.0e6);
 f6 = i3 ? Math_fround(1.0e6) : f6;
 HEAPF32[i5 >> 2] = i4 ? Math_fround(.00499999989) : f6;
 return;
}

function __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv() {
 var i1 = 0, i2 = 0;
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 183 >> 0] | 0) == 0;
 i1 = i1 ? 1 : 3;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 204 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 4;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 205 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 8;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 207 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 16;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 218 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 32;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 228 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 64;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 191 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 128;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 188 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 256;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 189 >> 0] | 0) == 0;
 return (i2 ? i1 : i1 | 512) | 0;
}

function __Z9transposeR8Scalar4fS0_S0_S0_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0, i15 = 0;
 i15 = i2 + 4 | 0;
 i8 = HEAP32[i15 >> 2] | 0;
 i14 = i2 + 8 | 0;
 i10 = HEAP32[i14 >> 2] | 0;
 i13 = i2 + 12 | 0;
 i6 = HEAP32[i13 >> 2] | 0;
 i12 = i3 + 8 | 0;
 i9 = HEAP32[i12 >> 2] | 0;
 i11 = i3 + 12 | 0;
 i5 = HEAP32[i11 >> 2] | 0;
 i7 = i4 + 12 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 HEAP32[i15 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i14 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 >> 2] = i8;
 i8 = i4 + 4 | 0;
 HEAP32[i12 >> 2] = HEAP32[i8 >> 2];
 i3 = i1 + 4 | 0;
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 >> 2] = i10;
 HEAP32[i8 >> 2] = i9;
 i4 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = i6;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i4 >> 2] = i2;
 return;
}

function __Z50ParticleSystem_CUSTOM_INTERNAL_get_startRotation3DP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZNK14ParticleSystem18GetStartRotation3DEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z35CommandBuffer_CUSTOM_GetTemporaryRTP12Il2CppObjectiiiii19RenderTextureFormat22RenderTextureReadWritei(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i12;
 i10 = i12 + 4 | 0;
 HEAP32[i10 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i11);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i11); else {
  __ZN22RenderingCommandBuffer12AddGetTempRTERKN9ShaderLab16FastPropertyNameEii19RenderTextureFormat17DepthBufferFormat17TextureFilterMode22RenderTextureReadWritei(i1, i10, i3, i4, i7, (i5 | 0) < 1 ? 0 : (i5 | 0) < 17 ? 1 : 2, i6, i8, i9);
  STACKTOP = i12;
  return;
 }
}

function __ZNSt3__27promiseIvE10get_futureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i2 = i3 + 8 | 0;
 i5 = i3;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__26futureIvEC2EPNS_17__assoc_sub_stateE(i2, i1);
  STACKTOP = i3;
  return HEAP32[i2 >> 2] | 0;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i5 >> 2] = 3;
 HEAP32[i5 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i4 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
 return 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_(i8, i9, i6, i5, i4, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, i7 = 0;
 i7 = __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) | 0;
 d2 = +HEAPF64[i4 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 if (d2 < d3) {
  HEAPF64[i5 >> 3] = d2;
  HEAPF64[i4 >> 3] = d3;
  i1 = i7 + 1 | 0;
  d2 = +HEAPF64[i5 >> 3];
  d3 = +HEAPF64[i6 >> 3];
  if (d2 < d3) {
   HEAPF64[i6 >> 3] = d2;
   HEAPF64[i5 >> 3] = d3;
   i1 = i7 + 2 | 0;
   d2 = +HEAPF64[i6 >> 3];
   d3 = +HEAPF64[i9 >> 3];
   if (d2 < d3) {
    HEAPF64[i9 >> 3] = d2;
    HEAPF64[i6 >> 3] = d3;
    d2 = +HEAPF64[i9 >> 3];
    d3 = +HEAPF64[i8 >> 3];
    if (d2 < d3) {
     HEAPF64[i8 >> 3] = d2;
     HEAPF64[i9 >> 3] = d3;
     i1 = i7 + 4 | 0;
    } else i1 = i7 + 3 | 0;
   }
  }
 } else i1 = i7;
 return i1 | 0;
}

function __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_(i8, i9, i6, i5, i4, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, i7 = 0;
 i7 = __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_(i8, i9, i6, i5, i1) | 0;
 d2 = +HEAPF64[i4 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 if (d2 < d3) {
  HEAPF64[i5 >> 3] = d2;
  HEAPF64[i4 >> 3] = d3;
  i1 = i7 + 1 | 0;
  d2 = +HEAPF64[i5 >> 3];
  d3 = +HEAPF64[i6 >> 3];
  if (d2 < d3) {
   HEAPF64[i6 >> 3] = d2;
   HEAPF64[i5 >> 3] = d3;
   i1 = i7 + 2 | 0;
   d2 = +HEAPF64[i6 >> 3];
   d3 = +HEAPF64[i9 >> 3];
   if (d2 < d3) {
    HEAPF64[i9 >> 3] = d2;
    HEAPF64[i6 >> 3] = d3;
    d2 = +HEAPF64[i9 >> 3];
    d3 = +HEAPF64[i8 >> 3];
    if (d2 < d3) {
     HEAPF64[i8 >> 3] = d2;
     HEAPF64[i9 >> 3] = d3;
     i1 = i7 + 4 | 0;
    } else i1 = i7 + 3 | 0;
   }
  }
 } else i1 = i7;
 return i1 | 0;
}

function __ZNK21EnlightenSceneMapping36GetEnlightenSystemForInputSystemHashERK7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i7) return 0;
 i8 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = i2;
 i6 = HEAP32[i5 >> 2] | 0;
 i5 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i2 + 8 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = 0;
 while (1) {
  i1 = i8 + (i2 * 56 | 0) + 24 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i6 | 0) ? (HEAP32[i1 + 4 >> 2] | 0) == (i5 | 0) : 0) {
   i1 = i8 + (i2 * 56 | 0) + 32 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i3 | 0) ? (HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0) : 0) {
    i1 = 6;
    break;
   }
  }
  i1 = i2 + 1 | 0;
  if (i1 >>> 0 < i7 >>> 0) i2 = i1; else {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 6) return ((i2 | 0) == -1 ? 0 : i8 + (i2 * 56 | 0) | 0) | 0; else if ((i1 | 0) == 7) return 0;
 return 0;
}

function __ZN5physx3Ext10FixedJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 87952 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 87952 + 188;
 HEAP32[i1 >> 2] = i4 + 84;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 80 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 87932 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i6, i2, i4, i3, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 if ((HEAP16[i6 + 24 >> 1] | 0) == -1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 i8 = HEAP32[gb + 1457324 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 124 >> 2] | 0;
 HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
 i1 = mftCall_iiiiiii(i9 | 0, i8 | 0, i2 | 0, i4 | 0, i3 | 0, 1, i1 | 0) | 0;
 if (!i1) {
  i9 = 0;
  STACKTOP = i7;
  return i9 | 0;
 }
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i6 + 20 | 0, i1, i6);
 __ZN5physx7NpShape15releaseInternalEv(i1);
 i9 = i1;
 STACKTOP = i7;
 return i9 | 0;
}

function __ZN4FMOD5Sound19setSubSoundSentenceEPii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869153;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869153;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 869153;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound15deleteSyncPointEP14FMOD_SYNCPOINT(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868936;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868936;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868936;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z31NativeToScriptingVertexDataType22ChannelFormatDimension(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do switch (HEAP8[i1 >> 0] | 0) {
 case 0:
  switch (HEAP8[i1 + 1 >> 0] | 0) {
  case 0:
   {
    i1 = 0;
    break L1;
   }
  case 1:
   {
    i1 = 1;
    break L1;
   }
  case 2:
   {
    i1 = 2;
    break L1;
   }
  case 3:
   {
    i1 = 3;
    break L1;
   }
  case 4:
   {
    i1 = 4;
    break L1;
   }
  default:
   {
    i2 = 9;
    break L1;
   }
  }
 case 1:
  {
   switch (HEAP8[i1 + 1 >> 0] | 0) {
   case 2:
    {
     i1 = 5;
     break L1;
    }
   case 4:
    break;
   default:
    {
     i2 = 9;
     break L1;
    }
   }
   i1 = 6;
   break;
  }
 case 2:
  {
   i1 = 7;
   break;
  }
 default:
  i2 = 9;
 } while (0);
 if ((i2 | 0) == 9) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 429989 | 0, 0, gb + 429904 | 0, 59, 1, 0, 0, 0);
  i1 = 0;
 }
 return i1 | 0;
}

function __Z23CalcCapsuleWorldExtentsPfPKfS1_S1_S1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = f9 < f8 ? f8 : f9;
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) - f9);
 i5 = f8 > Math_fround(0.0);
 f8 = i5 ? f8 : Math_fround(0.0);
 f6 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 HEAPF32[i1 >> 2] = Math_fround(f9 + Math_fround((i5 ? f7 : f6) * f8));
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 i5 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 HEAPF32[i1 + 4 >> 2] = Math_fround(f9 + Math_fround(f8 * (i5 ? f7 : f6)));
 f6 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i5 = f6 < Math_fround(0.0);
 f7 = Math_fround(-f6);
 HEAPF32[i1 + 8 >> 2] = Math_fround(f9 + Math_fround(f8 * (i5 ? f7 : f6)));
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37212 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __ZNSt3__26chrono12steady_clock3nowEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 __THREW__ = 0;
 i2 = invoke_iii(fb + 1142 | 0, 1, i1 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (!(i4 & 1)) {
  if (i2 | 0) {
   i4 = HEAP32[(___errno_location() | 0) >> 2] | 0;
   __THREW__ = 0;
   invoke_vii(fb + 4496 | 0, i4 | 0, gb + 1076215 | 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) break;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = ___muldi3(i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, 1e9, 0) | 0;
  i4 = _i64Add(i2 | 0, getTempRet0() | 0, i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0) | 0;
  setTempRet0(getTempRet0() | 0);
  STACKTOP = i3;
  return i4 | 0;
 } while (0);
 i4 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___clang_call_terminate(i4);
 return 0;
}

function __ZNSt3__210__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i4 = i5;
 __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 209444 + 8;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = -1;
 HEAP8[i1 + 52 >> 0] = 0;
 __ZNSt3__26localeC2ERKS0_(i6, i1 + 4 | 0);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __THREW__ = 0;
 invoke_vii(fb + 2298 | 0, i1 | 0, i4 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i6 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i4);
  __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
  ___resumeException(i6 | 0);
 } else {
  __ZNSt3__26localeD2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZNSt3__210__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i4 = i5;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 209508 + 8;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = -1;
 HEAP8[i1 + 52 >> 0] = 0;
 __ZNSt3__26localeC2ERKS0_(i6, i1 + 4 | 0);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __THREW__ = 0;
 invoke_vii(fb + 2299 | 0, i1 | 0, i4 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i6 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i4);
  __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
  ___resumeException(i6 | 0);
 } else {
  __ZNSt3__26localeD2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__212ctype_bynameIwE9do_narrowEwc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _uselocale(HEAP32[i1 + 8 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2808 | 0, i2 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   }
  }
  ___resumeException(i1 | 0);
 } else {
  if (i4 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i4 | 0) | 0;
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) {
    i4 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i4);
   }
  }
  return ((i1 | 0) != -1 ? i1 & 255 : i3) | 0;
 }
 return 0;
}

function __ZNK5physx7NpCloth22getAngularInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore22getAngularInertiaScaleEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 624, gb + 697494 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZN9WWWCached23HasDownloadedOrMayBlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 4 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) {
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  __Z6FormatPKcz(i2, gb + 454555 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 454652 | 0, 278, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9Texture2D5ApplyEbb(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 if (i1) {
  HEAP8[i4 + 111 >> 0] = 0;
  HEAP8[i4 + 112 >> 0] = 1;
 }
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 do if ((i1 + -10 | 0) >>> 0 < 3) i5 = 11; else if (((i1 | 1) + -25 | 0) >>> 0 < 5) i5 = 11; else {
  i2 = i1 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
    i5 = 11;
    break;
   }
  } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) {
   i5 = 11;
   break;
  }
  i1 = HEAP32[i4 >> 2] | 0;
  if (i3) {
   mftCall_vi(HEAP32[i1 + 192 >> 2] | 0, i4 | 0);
   return;
  }
 } while (0);
 if ((i5 | 0) == 11) i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[i1 + 196 >> 2] | 0, i4 | 0);
 return;
}

function __ZN8Collider26SupportedMessagesDidChangeEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i2 + 36 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 if (!(i3 & 1)) i1 = (i3 & 3 | 0) == 0 ? 0 : 136192; else i1 = 138240;
 if (i3 & 512 | 0) __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK8Collider(__Z17GetPhysicsManagerv() | 0, i2);
 i3 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i4 | 0, i3 | 0);
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 255 | i1;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 76 >> 2] | 0, i5 | 0, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZN7mecanim12statemachine22ResetTriggerConditionsERK9OffsetPtrIS1_INS0_17ConditionConstantEEEjPKNS_18ValueArrayConstantEPNS0_21StateMachineWorkspaceE(i5, i6, i7, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0;
 if (!i6) return;
 i8 = i5;
 i9 = i7 + 4 | 0;
 i10 = i9;
 i4 = i1 + 8 | 0;
 i3 = 0;
 do {
  i2 = (HEAP32[i5 >> 2] | 0) + i8 + (i3 << 2) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = (i1 | 0) == 0 ? 0 : i2 + i1 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 1) {
   i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i7, HEAP32[i1 + 4 >> 2] | 0) | 0;
   if ((i1 | 0) > -1) {
    i2 = (HEAP32[i9 >> 2] | 0) + i10 | 0;
    if ((HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0) == 9) HEAP8[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + (HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) >> 0] = 1;
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 return;
}

function __ZN5physx2Sc9ClothCore11switchClothEPNS_5cloth5ClothE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i6 + 28 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0) + 4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 HEAP32[i1 >> 2] = i5;
 if (!(HEAP16[i4 + 4 >> 1] | 0)) {
  if (i2 | 0) HEAP32[(HEAP32[i6 + 32 >> 2] | 0) + 4 >> 2] = 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
 }
 if (!(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0) + 4 >> 2] | 0)) return;
 i6 = HEAP32[i6 + 32 >> 2] | 0;
 HEAP32[i6 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0) | 0;
 return;
}

function __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiPNS_9AllocatorEPKS0_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAPF32[i7 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i7 + 12 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i7 + 16 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[i7 + 20 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 i5 = __ZN5Umbra17ImpTomeCollection5buildEPPKNS_7ImpTomeEiRKNS_4AABBEPNS_9AllocatorEPKS0_((i1 | 0) == 0 ? 0 : i1 + 3 & -4, i2, i3, i7, i4, (i5 | 0) == 0 ? 0 : i5 + 3 & -4) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel14get3DOcclusionEPfS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868182;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868182;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868182;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound13setMusicSpeedEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869113;
   _printf(gb + 857490 | 0, i5) | 0;
   HEAP32[i6 >> 2] = 78;
   HEAP32[i6 + 4 >> 2] = gb + 869113;
   _printf(gb + 853343 | 0, i6) | 0;
   i6 = 78;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869113;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD5Sound13getSoundGroupEPPNS_10SoundGroupE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869026;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869026;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869026;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup8getGroupEiPPS0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862489;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862489;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 862489;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI6Canvas9SyncDepthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 12 | 0;
 i3 = i5;
 i4 = HEAP32[i1 + 344 >> 2] | 0;
 if (i4 | 0) {
  i4 = i4 + 224 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 6;
  STACKTOP = i5;
  return;
 }
 __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 if (!(Math_fround(Math_abs(Math_fround(Math_fround(HEAPF32[i1 + 348 >> 2]) - f6))) > Math_fround(.0000999999974))) {
  STACKTOP = i5;
  return;
 }
 i4 = HEAP32[gb + 1467948 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = fb + 1103;
 __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i3, i4, i2);
 STACKTOP = i5;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl32InvokeFontTextureRebuiltCallbackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 248 | 0;
 i2 = i5;
 i3 = i5 + 240 | 0;
 i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 76 >> 2] | 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i8 = (__Z32GetTextRenderingScriptingClassesv() | 0) + 4 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i2, i4);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i2, i1);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i2, i4, 0) | 0;
 STACKTOP = i5;
 return;
}

function __Z46UnityWebRequest_Get_Custom_PropDownloadHandlerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i2 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027689 | 0, i3);
 if (!(__Z29scripting_gchandle_get_targetj(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027689 | 0, i3);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z28Animator_CUSTOM_GetIntegerIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator10GetIntegerEiRi(i1, i4, i5) | 0;
 if ((i1 | 0) == 1) {
  i5 = HEAP32[i5 >> 2] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 i5 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z20PlayerLoadFirstSceneb(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN19RuntimeSceneManager24PrepareNewBootstrapSceneEv(__Z15GetSceneManagerv() | 0);
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 25472 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i5 = i3 + 24704 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i3 + 24704 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i5 >> 2] | 0); else mftCall_vi(HEAP32[i5 >> 2] | 0, HEAP32[i3 + 24704 + (i1 * 12 | 0) + 4 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if (__Z12GetIVRDevicev() | 0) {
  i5 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 160 >> 2] | 0, i5 | 0) | 0) {
   i5 = __Z12GetIVRDevicev() | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0, i5 | 0);
   i5 = 0;
   return i5 | 0;
  }
 }
 i5 = __Z21PlayerStartFirstSceneb(i2) | 0;
 return i5 | 0;
}

function __Z18CalculateWorldAABBR10GameObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31312 | 0) | 0;
 if (i1 | 0) {
  __ZN12BaseRenderer12GetWorldAABBER4AABB(i1 + 32 | 0, i2);
  f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 >> 2])) return;
  f3 = Math_fround(HEAPF32[i2 + 16 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 + 4 >> 2])) return;
  f3 = Math_fround(HEAPF32[i2 + 20 >> 2]);
  if (f3 != Math_fround(HEAPF32[gb + 1162364 + 8 >> 2])) return;
 };
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __Z17CommitBatchDeleteR11BatchDelete(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 if ((HEAP16[gb + 1162508 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1162508 | 0, i1);
  i4 = gb + 1162508 | 0;
 } else i4 = 0;
 i5 = i6 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = 0;
  do {
   i2 = HEAP32[i6 + 8 + (i3 << 2) >> 2] | 0;
   if (i2) {
    __Z28delete_object_internal_step1P6Object(i2);
    __Z28delete_object_internal_step2P6Object(i2);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
 }
 if (!i4) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i4);
 STACKTOP = i7;
 return;
}

function __ZN4FMOD7Channel15getSystemObjectEPPNS_6SystemE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862473;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862473;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862473;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound13setSoundGroupEPNS_10SoundGroupE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869127;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869127;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869127;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN15QualitySettings15SetCurrentIndexEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i8 = (((HEAP32[i1 + 32 >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) | 0) / 108 | 0) + -1 | 0;
 i7 = i1 + 44 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = (i2 | 0) < 0 ? 0 : (i8 | 0) < (i2 | 0) ? i8 : i2;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, gb + 405977 | 0, 20);
 __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i6, HEAP32[i7 >> 2] | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 __ZN15QualitySettings13ApplySettingsEib(i1, i5, i3);
 STACKTOP = i4;
 return;
}

function __Z46ParticleSystem_ShapeModule_CUSTOM_SetShapeTypeP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[i1 + 48 + 8 >> 2] = i2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z30Mesh_CUSTOM_AddBlendShapeFrameP12Il2CppObjectP12Il2CppStringfP11Il2CppArrayS4_S4_(i3, i1, f4, i5, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10 + 8 | 0;
 i8 = i10 + 4 | 0;
 i9 = i10;
 __ZN11ICallStringC2EP12Il2CppString(i8, i1);
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i10 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i10);
 } else {
  HEAP32[i9 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  __Z28AddBlendShapeFrameFromScriptR4Mesh11ICallStringfP11Il2CppArrayS3_S3_(i1, i2, f4, i5, i6, i7);
  STACKTOP = i10;
  return;
 }
}

function _inflateBackInit_(i3, i4, i5, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i5 = -6;
  return i5 | 0;
 }
 if ((i2 | 0) != 56 | (HEAP8[i1 >> 0] | 0) != 49) {
  i5 = -6;
  return i5 | 0;
 }
 if ((i4 & -8 | 0) != 8 | ((i3 | 0) == 0 | (i5 | 0) == 0)) {
  i5 = -2;
  return i5 | 0;
 }
 HEAP32[i3 + 24 >> 2] = 0;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = fb + 334;
  HEAP32[i3 + 40 >> 2] = 0;
  i2 = fb + 334 | 0;
 }
 i1 = i3 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = fb + 2370;
 i1 = mftCall_iiii(i2 | 0, HEAP32[i3 + 40 >> 2] | 0, 1, 9520) | 0;
 if (!i1) {
  i5 = -4;
  return i5 | 0;
 }
 HEAP32[i3 + 28 >> 2] = i1;
 HEAP32[i1 + 20 >> 2] = 32768;
 HEAP32[i1 + 36 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = 1 << i4;
 HEAP32[i1 + 52 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i5 = 0;
 return i5 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 28 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofERKS5_j(i2, i3, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i4 = i1 & 255;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 i5 = i1 << 24 >> 24 < 0;
 i6 = i5 ? HEAP32[i3 >> 2] | 0 : i3;
 i1 = i5 ? HEAP32[i3 + 4 >> 2] | 0 : i1 & 255;
 if (i4 >>> 0 <= i7 >>> 0 | (i1 | 0) == 0) i1 = -1; else {
  i5 = i2 + i4 | 0;
  i4 = i6 + i1 | 0;
  i1 = i2 + i7 | 0;
  L7 : while (1) {
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i5;
    break;
   } else i3 = i6;
   while (1) {
    if ((i3 | 0) == (i4 | 0)) break;
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0)) break L7; else i3 = i3 + 1 | 0;
   }
   i1 = i1 + 1 | 0;
  }
  i1 = (i1 | 0) == (i5 | 0) ? -1 : i1 - i2 | 0;
 }
 return i1 | 0;
}

function __ZNK9Transform15TransformVectorERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 32 | 0;
 i5 = i4 + 20 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2 + 32 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z15TransformVector23TransformAccessReadOnlyRKN4math7_float3E(i5, i7, i6);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx7NpCloth21getLinearInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore21getLinearInertiaScaleEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 604, gb + 697577 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZNK5physx7NpCloth21getDampingCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore21getDampingCoefficientEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 664, gb + 696991 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  STACKTOP = i5;
  return;
 }
}

function __ZN8GUIState10BeginOnGUIER14ObjectGUIState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 92 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = 1065353216;
 HEAP32[i1 + 48 >> 2] = 1065353216;
 HEAP32[i1 + 52 >> 2] = 1065353216;
 HEAP32[i1 + 56 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = 1065353216;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 60 >> 2] = 1;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 1;
 HEAP32[i2 + 44 >> 2] = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = -1;
 HEAP32[i3 + 4 >> 2] = -1;
 HEAP32[i3 + 8 >> 2] = -1;
 HEAP32[i3 + 12 >> 2] = -1;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP32[i2 >> 2] = 1;
 i2 = i1 + 340 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 8 >> 2] = i1;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 * 20 | 0, gb + 838004 | 0, 543) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i2 + ((HEAP32[i5 >> 2] | 0) * 20 | 0) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
  i2 = i2 + 20 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 20 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i7, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i7 >>> 0) __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + (i7 * 24 | 0) | 0;
 if ((i1 | 0) >= (i7 | 0)) {
  HEAP32[i4 >> 2] = i7;
  return;
 }
 i2 = i6 + 20 | 0;
 i1 = i3 + (i1 * 24 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP8[i1 + 20 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 24 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 HEAP32[i4 >> 2] = i7;
 return;
}

function __ZN5physx3Ext7D6Joint12createObjectERPhRNS_24PxDeserializationContextE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 86848 + 8;
 HEAP32[i4 + 12 >> 2] = gb + 86848 + 256;
 HEAP32[i1 >> 2] = i4 + 88;
 i2 = i4 + 80 | 0;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i6 = i1 + 15 & -16;
  i1 = i6 + 384 | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i6;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 16 >> 2] = (i6 | 0) == 0 ? 0 : i2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
 i6 = i4 + 76 | 0;
 HEAP32[i6 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i5, HEAP32[i6 >> 2] | 0, i4 + 12 | 0, gb + 87140 | 0) | 0;
 return i4 | 0;
}

function __Z44UnityWebRequest_Get_Custom_PropUploadHandlerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i2 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1031641 | 0, i3);
 if (!(__Z29scripting_gchandle_get_targetj(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1031641 | 0, i3);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN7Texture25ReloadFromStorageIfNeededEPvb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!((i1 | 0) == 0 & (i2 ^ 1))) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i3 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 if (HEAP32[i3 + 8 >> 2] & 1048576 | 0) __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0);
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + i2 | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE8recreateEj(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) i4 = 0; else {
  i4 = HEAP32[i7 + 4 >> 2] | 0;
  i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i6 | 0, HEAP32[i7 + 8 >> 2] | 0, gb + 838004 | 0, 543) | 0;
 }
 i2 = HEAP32[i7 + 16 >> 2] | 0;
 i3 = i4 + i2 | 0;
 i5 = i7 + 12 | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i5 >> 2] | 0;
  while (1) {
   HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i3 | 0)) break; else i2 = i2 + 1 | 0;
  }
 }
 i1 = i7 + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i1 >> 2] = i6;
  return;
 }
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i4;
 HEAP32[i1 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i7 = i5;
  i9 = i7;
  i9 = HEAPU16[i9 >> 1] | HEAPU16[i9 + 2 >> 1] << 16;
  i7 = i7 + 4 | 0;
  i7 = HEAPU16[i7 >> 1] | HEAPU16[i7 + 2 >> 1] << 16;
  i2 = i1;
  i8 = i2;
  HEAP16[i8 >> 1] = i9;
  HEAP16[i8 + 2 >> 1] = i9 >>> 16;
  i2 = i2 + 4 | 0;
  HEAP16[i2 >> 1] = i7;
  HEAP16[i2 + 2 >> 1] = i7 >>> 16;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i3 + 60 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 switch (i2 | 0) {
 case 2:
  {
   i3 = HEAP32[i3 + 28 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 212 >> 2] | 0, i3 | 0, i4 | 0);
   return;
  }
 case 1:
  {
   i1 = i3 + 4 | 0;
   if (!(HEAP32[i1 >> 2] | 0)) return;
   i3 = HEAP32[i3 + 28 >> 2] | 0;
   if (!((HEAP32[(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0) + 4 >> 2] | 0) != 0 ^ i4)) return;
   __ZN5physx2Sc8ClothSim8reinsertEv(HEAP32[i1 >> 2] | 0);
   return;
  }
 case 4:
  {
   if (i4) return;
   i1 = HEAP32[i3 + 4 >> 2] | 0;
   if (!i1) return;
   __ZN5physx2Sc8ClothSim20clearCollisionShapesEv(i1);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx26PxClothFabricGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 674663;
 HEAP32[i1 + 4 >> 2] = 129;
 HEAP32[i1 + 8 >> 2] = fb + 2147;
 HEAP32[i1 + 12 >> 2] = gb + 674675;
 HEAP32[i1 + 16 >> 2] = 130;
 HEAP32[i1 + 20 >> 2] = fb + 403;
 HEAP32[i1 + 24 >> 2] = fb + 2148;
 HEAP32[i1 + 28 >> 2] = gb + 674682;
 HEAP32[i1 + 32 >> 2] = 131;
 HEAP32[i1 + 36 >> 2] = fb + 404;
 HEAP32[i1 + 40 >> 2] = fb + 2149;
 HEAP32[i1 + 44 >> 2] = gb + 674687;
 HEAP32[i1 + 48 >> 2] = 132;
 HEAP32[i1 + 52 >> 2] = fb + 405;
 HEAP32[i1 + 56 >> 2] = fb + 2150;
 HEAP32[i1 + 60 >> 2] = gb + 773316;
 HEAP32[i1 + 64 >> 2] = 133;
 HEAP32[i1 + 68 >> 2] = fb + 406;
 HEAP32[i1 + 72 >> 2] = fb + 2151;
 HEAP32[i1 + 76 >> 2] = gb + 672678;
 HEAP32[i1 + 80 >> 2] = 134;
 HEAP32[i1 + 84 >> 2] = fb + 2152;
 HEAP32[i1 + 88 >> 2] = gb + 831985;
 HEAP32[i1 + 92 >> 2] = 135;
 HEAP32[i1 + 96 >> 2] = fb + 2153;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10setDampingEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore10setDampingEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 12 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 128;
 return;
}

function __ZN4FMOD5Sound15getSystemObjectEPPNS_6SystemE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862473;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862473;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862473;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21AudioDistortionFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 872932 | 0, 8) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 170716 + 8;
 HEAPF32[i4 + 44 >> 2] = Math_fround(.5);
 HEAP32[i4 + 36 >> 2] = 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN17AnimationPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE(i4, f5, i6) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i4 + 8 | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0;
 if ((i8 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i9 = 8;
    break;
   } else i3 = 0;
  }
  if ((i9 | 0) == 8) {
   i9 = 0;
   mftCall_vifi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, +Math_fround(Math_fround(HEAPF32[(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0) + (i2 << 3) >> 2]) * f5), i6 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 return;
}

function __ZN12_GLOBAL__N_110DataStream5flushEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i10;
 i8 = i9 + 228 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i6 = i9 + 224 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i2 = i7;
 i3 = i9 + 392 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if ((i5 | 0) != (i7 | 0)) if (!(i1 << 24 >> 24)) i1 = 0; else {
  i2 = HEAP32[i9 + 388 >> 2] | 0;
  i11 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
  HEAP32[i4 >> 2] = i7;
  HEAP32[i4 + 4 >> 2] = i5;
  i1 = i9 + 400 | 0;
  i1 = (mftCall_iiiiii(i11 | 0, i2 | 0, i4 | 0, HEAP32[i9 + 380 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0) & 1;
  HEAP8[i3 >> 0] = i1;
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i2;
 HEAP32[i9 + 380 >> 2] = 0;
 STACKTOP = i10;
 return i1 & 255 ^ 1 | 0;
}

function __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpeedP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem18SetSimulationSpeedEf(i1, f2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z48SceneManager_CUSTOM_INTERNAL_CALL_SetActiveSceneRKi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0) | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561522 | 0, i2);
 if (HEAP32[i1 + 80 >> 2] | 0) {
  i4 = (__ZN19RuntimeSceneManager14SetActiveSceneER10UnityScene(__Z15GetSceneManagerv() | 0, i1) | 0) & 1;
  STACKTOP = i2;
  return i4 | 0;
 }
 i1 = i1 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561572 | 0, i3);
 } else {
  i4 = i1;
  HEAP32[i3 >> 2] = i4;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561572 | 0, i3);
 }
 return 0;
}

function __Z47ParticleSystem_MainModule_CUSTOM_SetPlayOnAwakeP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem14SetPlayOnAwakeEb(i1, i2 << 24 >> 24 != 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z24GetActualTargetFrameRatev() {
 var f1 = f0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = __Z21GetQualitySettingsPtrv() | 0;
 if (!i2) i4 = 4; else {
  i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 44 >> 2] | 0) * 108 | 0) + 76 >> 2] | 0;
  if ((i2 | 0) < 1) i4 = 4; else {
   i6 = __Z16GetScreenManagerv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i6 | 0);
   i3 = HEAP32[i3 + 8 >> 2] | 0;
   f1 = Math_fround(i3 | 0);
   f1 = Math_fround(((i3 | 0) > 0 ? f1 : Math_fround(60.0)) / Math_fround(i2 | 0));
  }
 }
 if ((i4 | 0) == 4) f1 = Math_fround(__Z18GetTargetFrameRatev() | 0);
 i6 = !(f1 <= Math_fround(0.0));
 i4 = f1 > Math_fround(1.0e3);
 f1 = i4 ? Math_fround(1.0e3) : f1;
 f1 = i6 ? f1 : Math_fround(-1.0);
 STACKTOP = i5;
 return Math_fround(f1);
}

function _UNITY_FT_New_Library(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 6;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = _UNITY_ft_mem_alloc(i1, 228, i3) | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 if (i5 | 0) {
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i5 = _UNITY_ft_pic_container_init(i4) | 0;
 HEAP32[i3 >> 2] = i5;
 if (!i5) {
  HEAP32[i4 + 168 >> 2] = 0;
  HEAP32[i4 + 164 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 2;
  HEAP32[i4 + 8 >> 2] = 6;
  HEAP32[i4 + 12 >> 2] = 1;
  HEAP32[i4 + 224 >> 2] = 1;
  HEAP32[i2 >> 2] = i4;
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  _UNITY_ft_pic_container_destroy(i4);
  _UNITY_ft_mem_free(i1, i4);
  i5 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function ___strchrnul(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 & 255;
 L1 : do if (!i3) i1 = i1 + (_strlen(i1) | 0) | 0; else {
  if (i1 & 3) {
   i2 = i4 & 255;
   do {
    i5 = HEAP8[i1 >> 0] | 0;
    if (i5 << 24 >> 24 == 0 ? 1 : i5 << 24 >> 24 == i2 << 24 >> 24) break L1;
    i1 = i1 + 1 | 0;
   } while ((i1 & 3 | 0) != 0);
  }
  i3 = Math_imul(i3, 16843009) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  L10 : do if (!((i2 & -2139062144 ^ -2139062144) & i2 + -16843009)) do {
   i5 = i2 ^ i3;
   if ((i5 & -2139062144 ^ -2139062144) & i5 + -16843009 | 0) break L10;
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while (!((i2 & -2139062144 ^ -2139062144) & i2 + -16843009 | 0)); while (0);
  i2 = i4 & 255;
  while (1) {
   i5 = HEAP8[i1 >> 0] | 0;
   if (i5 << 24 >> 24 == 0 ? 1 : i5 << 24 >> 24 == i2 << 24 >> 24) break; else i1 = i1 + 1 | 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_(i2, i1, i3, i7, i9, i4, i8, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i3;
 if (HEAP32[i2 + 12 >> 2] & 4) if ((i7 - i1 | 0) > 1) if ((HEAP8[i3 >> 0] | 0) == -1) if ((HEAP8[i3 + 1 >> 0] | 0) == -2) i1 = i3 + 2 | 0;
 i5 = i7 + -1 | 0;
 i3 = i1;
 while (1) {
  i1 = i3;
  if (!(i1 >>> 0 < i5 >>> 0 & i4 >>> 0 < i8 >>> 0)) {
   i11 = 10;
   break;
  }
  i12 = HEAPU8[i1 + 1 >> 0] << 8;
  i2 = i12 | HEAPU8[i1 >> 0];
  if ((i12 & 63488 | 0) == 55296 | i2 >>> 0 > i6 >>> 0) {
   i1 = 2;
   break;
  }
  HEAP16[i4 >> 1] = i2;
  i4 = i4 + 2 | 0;
  i3 = i1 + 2 | 0;
 }
 if ((i11 | 0) == 10) i1 = i1 >>> 0 < i7 >>> 0 & 1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i4;
 return i1 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_(i2, i1, i3, i7, i9, i4, i8, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i5 = 0, i6 = 0, i11 = 0, i12 = 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i3;
 if (HEAP32[i2 + 12 >> 2] & 4) if ((i7 - i1 | 0) > 1) if ((HEAP8[i3 >> 0] | 0) == -2) if ((HEAP8[i3 + 1 >> 0] | 0) == -1) i1 = i3 + 2 | 0;
 i5 = i7 + -1 | 0;
 i3 = i1;
 while (1) {
  i1 = i3;
  if (!(i1 >>> 0 < i5 >>> 0 & i4 >>> 0 < i8 >>> 0)) {
   i11 = 10;
   break;
  }
  i12 = HEAPU8[i1 >> 0] << 8;
  i2 = i12 | HEAPU8[i1 + 1 >> 0];
  if ((i12 & 63488 | 0) == 55296 | i2 >>> 0 > i6 >>> 0) {
   i1 = 2;
   break;
  }
  HEAP16[i4 >> 1] = i2;
  i4 = i4 + 2 | 0;
  i3 = i1 + 2 | 0;
 }
 if ((i11 | 0) == 10) i1 = i1 >>> 0 < i7 >>> 0 & 1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i10 >> 2] = i4;
 return i1 | 0;
}

function __ZNK9Transform14TransformPointERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4 + 32 | 0;
 i5 = i4 + 20 | 0;
 i8 = i4;
 i6 = i4 + 8 | 0;
 i10 = i2 + 32 | 0;
 i2 = HEAP32[i10 + 4 >> 2] | 0;
 i9 = i8;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = i2;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = i9;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E(i5, i7, i6);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK4Mesh26GetSubMeshDrawBuffersRangeEib(i5, i1, i6, i7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 128 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i3 + (i6 * 52 | 0) + 32 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 + (i6 * 52 | 0) + 44 >> 2];
 i1 = i5 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + (i6 * 52 | 0) + 36 >> 2];
 i2 = HEAP32[i3 + (i6 * 52 | 0) + 40 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 20 >> 2] = HEAP32[i3 + (i6 * 52 | 0) + 48 >> 2];
 if (i7) {
  if ((i2 | 0) != 1) return;
 } else if ((i2 | 0) != 2) return;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i3 + (i6 * 52 | 0) >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 + (i6 * 52 | 0) + 4 >> 2];
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, f6 = f0;
 HEAP32[i3 + 48 >> 2] = i2;
 HEAP32[i3 + 52 >> 2] = i1;
 i5 = HEAP32[i2 + 224 >> 2] | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i3 + 12 >> 2] = i5;
 f6 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 f6 = Math_fround(f6 * f6);
 HEAPF32[i3 + 16 >> 2] = f6;
 HEAPF32[i3 + 20 >> 2] = f6;
 HEAPF32[i3 + 24 >> 2] = f6;
 HEAPF32[i3 + 28 >> 2] = f6;
 i5 = HEAP32[i2 + 228 >> 2] | 0;
 i4 = i5 & HEAP32[gb + 1097568 + 4 >> 2];
 i1 = i5 & HEAP32[gb + 1097568 + 8 >> 2];
 i2 = i5 & HEAP32[gb + 1097568 + 12 >> 2];
 HEAP32[i3 + 32 >> 2] = i5 & HEAP32[gb + 1097568 >> 2];
 HEAP32[i3 + 36 >> 2] = i4;
 HEAP32[i3 + 40 >> 2] = i1;
 HEAP32[i3 + 44 >> 2] = i2;
 return;
}

function __ZN4FMOD5Sound11getSubSoundEiPPS0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 859469;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 859469;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 859469;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP16showConfigDialogEPvb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868892;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868892;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868892;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup7getNameEPci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868219;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868219;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868219;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21ComponentRequirements16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63528 | 0, 16, gb + 443848 | 0, 22) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1162544 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63528 | 0, 16, gb + 443848 | 0, 23) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1162548 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63528 | 0, 16, gb + 443848 | 0, 24) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1162552 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63528 | 0, 16, gb + 443848 | 0, 25) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1162556 >> 2] = i1;
 return;
}

function __ZN14PhysicMaterial18SetDynamicFrictionEf(i4, f2) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = i5 + 16 | 0;
 if (f2 < Math_fround(0.0)) {
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  HEAPF64[i3 + 8 >> 3] = +f2;
  __Z6FormatPKcz(i1, gb + 781263 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 737252 | 0, 144, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i4 + 40 >> 2] = f2;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +f2);
 STACKTOP = i5;
 return;
}

function __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i3 = i1 + 56 | 0;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i7 = i2 + 24 | 0;
 if ((i4 + 1 | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i3, 1); else {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i1 = i1 + 60 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i6 >> 2] = i3;
 }
 if (!i5) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z29Animator_CUSTOM_GetLayerIndexP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = __ZN8Animator13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function _tt_cmap6_char_next(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = (HEAP32[i6 >> 2] | 0) + 1 | 0;
 i3 = (HEAPU8[i4 + 6 >> 0] | 0) << 8 | (HEAPU8[i4 + 7 >> 0] | 0);
 i5 = (HEAPU8[i4 + 8 >> 0] | 0) << 8 | (HEAPU8[i4 + 9 >> 0] | 0);
 if (i1 >>> 0 > 65535) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = i1 >>> 0 < i3 >>> 0 ? i3 : i1;
 i1 = i2 - i3 | 0;
 L4 : do if (i1 >>> 0 < i5 >>> 0) {
  i4 = i4 + 10 + (i1 << 1) | 0;
  i3 = i1;
  while (1) {
   i1 = (HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i4 + 1 >> 0] | 0);
   if (i1 | 0) break L4;
   if (i2 >>> 0 > 65534) {
    i1 = 0;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i5 >>> 0) {
    i2 = 0;
    i1 = 0;
    break L4;
   } else {
    i4 = i4 + 2 | 0;
    i2 = i2 + 1 | 0;
   }
  }
  return i1 | 0;
 } else {
  i2 = 0;
  i1 = 0;
 } while (0);
 HEAP32[i6 >> 2] = i2;
 i6 = i1;
 return i6 | 0;
}

function _alloc_sarray(i8, i9, i1, i10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i1 + 15 & -16;
 i1 = 999999988 / (i7 >>> 0) | 0;
 if (i7 >>> 0 > 999999988) {
  i6 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 70;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i8 | 0);
 }
 i2 = (i1 | 0) < (i10 | 0) ? i1 : i10;
 HEAP32[i3 + 80 >> 2] = i2;
 i6 = _alloc_small(i8, i9, i10 << 2) | 0;
 if (!i10) return i6 | 0; else i1 = 0;
 do {
  i3 = i10 - i1 | 0;
  i2 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
  i3 = _alloc_large(i8, i9, Math_imul(i2, i7) | 0) | 0;
  if (i2) {
   i5 = i2;
   while (1) {
    i4 = i1 + 1 | 0;
    HEAP32[i6 + (i1 << 2) >> 2] = i3;
    i5 = i5 + -1 | 0;
    if (!i5) {
     i1 = i4;
     break;
    } else {
     i3 = i3 + i7 | 0;
     i1 = i4;
    }
   }
  }
 } while (i1 >>> 0 < i10 >>> 0);
 return i6 | 0;
}

function __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = i1 + -8 | 0;
 i3 = i1 + 16 | 0;
 i5 = i1 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = i6;
 i8 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i4) {
  i8 = i2;
  HEAP32[i7 >> 2] = i8;
  i8 = HEAP32[i3 >> 2] | 0;
  i8 = i8 + 16 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vi(i8 | 0, i3 | 0);
  return;
 }
 i1 = i1 + 48 | 0;
 i2 = 0;
 do {
  i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i6 | 0, i8 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i9 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i9 = i9 + 16 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_vi(i9 | 0, i3 | 0);
 return;
}

function __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration21generateEEContactsMTDERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj(i1, i2, i3, i6, i10, i8, i9, i4, i5, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i8, i9, i4, i6, i10, i1, i2, i5, i7);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i8, i9, i4, i6, i10, i2, i3, i5, i7);
 __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj(i8, i9, i4, i6, i10, i1, i3, i5, i7);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10setDampingEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore10setDampingEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 12 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 128;
 return;
}

function __ZN5physx16PxVehicleNoDrive12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 158796 + 8;
 HEAP32[i1 >> 2] = i3 + 144;
 i1 = i3 + 44 | 0;
 i4 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i1 >> 2] | 0) | 0;
 i5 = i2 + 4 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 HEAP32[i5 >> 2] = i6 + i4;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i3, i6, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 48 >> 2] | 0, 0) | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 i4 = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 128 >> 2] = i6;
 HEAP32[i3 + 132 >> 2] = i4 + (i1 << 4);
 HEAP32[i5 >> 2] = i4 + (i1 * 48 | 0);
 HEAP32[i3 + 136 >> 2] = i4 + (i1 << 5);
 __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE(i3, i2);
 return i3 | 0;
}

function __ZN4FMOD5Sound11setSubSoundEiPS0_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869141;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869141;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 869141;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP15getSystemObjectEPPNS_6SystemE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862473;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862473;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862473;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14PhysicMaterial17SetStaticFrictionEf(i4, f2) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = i5 + 16 | 0;
 if (f2 < Math_fround(0.0)) {
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
  HEAPF64[i3 + 8 >> 3] = +f2;
  __Z6FormatPKcz(i1, gb + 781316 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 737252 | 0, 163, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  f2 = Math_fround(0.0);
 }
 HEAPF32[i4 + 44 >> 2] = f2;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +f2);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig13ConfigChangedERK8UnityStrR8JSONRead(i6, i1, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i3 = i7 + 36 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i7 + 40 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 if ((HEAP32[i5 + 16 >> 2] | 0) != 3) return;
 i8 = __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc(i7, i5, gb + 1040810 | 0) | 0;
 HEAP32[i4 >> 2] = i8;
 i1 = i7 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 1040818;
 if (i8 | 0) {
  __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi(i7, 0);
  __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue8TransferI8JSONReadEEvRT_(i6 + 4 | 0, i7);
  HEAP8[i3 >> 0] = 1;
  i8 = i7 + 56 | 0;
  HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z29Input_CUSTOM_GetKeyDownStringP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i2, i5);
 i1 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536702 | 0, i3);
 } else {
  i5 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 68 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function __Z26Animation_CUSTOM_IsPlayingP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = (__ZN9Animation9IsPlayingERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z16GetDefaultMetricRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2))));
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(f2 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f3 * f3) + Math_fround(f4 * f4)) + Math_fround(f5 * f5)))));
 f4 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 40 >> 2]);
 f2 = Math_fround(f5 * Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2)))));
 return Math_fround(f2 * f2);
}

function __ZN5physx3Ext23DefaultBufferedProfiler7releaseEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = i5 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 68 | 0;
  do {
   i1 = i1 + -1 | 0;
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   i6 = HEAP32[i2 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i2 | 0);
   i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  } while ((i1 | 0) != 0);
 }
 HEAP32[i3 >> 2] = 0;
 i6 = i5 + 4 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i5 + 60 | 0);
 HEAP32[i5 + 92 >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0, i6 | 0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0);
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl14createRepXNodeEPKc(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) + 12 | 0;
 i5 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, 24) | 0;
 HEAP32[i5 >> 2] = gb + 1576256;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = gb + 1576256;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i7) i1 = gb + 1576256 | 0; else if (!(HEAP8[i7 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i7;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i4, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i7 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 >> 2] = gb + 1576256;
 return i5 | 0;
}

function __ZN4FMOD5Sound10getNumTagsEPiS1_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 869015;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 869015;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 869015;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN23ManagedAttributeManager32CallManagedGetRequiredComponentsEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 248 | 0;
 i4 = i2;
 i5 = i2 + 240 | 0;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 64 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i1) | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = __Z30scripting_cast_object_to_arrayP12Il2CppObject(__ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN19SkinnedMeshRenderer5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 + 460 >> 2] = 0;
 HEAP8[i1 + 464 >> 0] = 0;
 HEAP8[i1 + 465 >> 0] = 1;
 i1 = i1 + 436 | 0;
 i4 = i3 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN18StreamedBinaryReadILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i7, i1, i2, i8, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = i7 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i4 = i7 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i6, i8, 4);
  i5 = HEAP32[i6 >> 2] | 0;
  i3 = HEAP32[i4 >> 2] | 0;
 } else {
  HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i6 >> 2] = i2;
  i5 = i2;
 }
 i1 = i8 + 4 | 0;
 i2 = i5 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i6, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 >> 2] = i2;
 }
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i7, i8 + 8 | 0, 1);
 __ZN12CachedReader10Align4ReadEv(i6);
 return;
}

function __Z37GeomOverlapCallback_ConvexHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i6 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i7 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 16 >> 2] = i3;
 HEAPF32[i7 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i7 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 i5 = __ZN5physx2Gu26intersectHeightFieldConvexERKNS0_15HeightFieldUtilERKNS_11PxTransformERKNS0_10ConvexMeshES6_RKNS_11PxMeshScaleE(i7, i5, i6, i4, i2 + 4 | 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __Z29AnimationCurve_CUSTOM_GetKeysP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i1 | 0) < 1) {
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 244 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i2 = HEAP32[i2 + 56 >> 2] | 0;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 244 >> 2] | 0, 16, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 16) | 0, i2 | 0, i1 << 4 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z28GetSpriteMeshRectPixelBoundsiiRK5RectTIfERiS3_S3_S3_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, f9 = f0, f10 = f0;
 f10 = Math_fround(HEAPF32[i3 >> 2]);
 HEAP32[i4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f10)));
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 HEAP32[i5 >> 2] = ~~Math_fround(Math_floor(Math_fround(f9)));
 HEAP32[i6 >> 2] = ~~Math_fround(Math_ceil(Math_fround(f10 + Math_fround(HEAPF32[i3 + 8 >> 2]))));
 i8 = ~~Math_fround(Math_ceil(Math_fround(f9 + Math_fround(HEAPF32[i3 + 12 >> 2]))));
 HEAP32[i7 >> 2] = i8;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = (i8 | 0) > (i2 + 1 | 0) | (i3 | 0) > (i1 + 1 | 0) | (HEAP32[i5 >> 2] | HEAP32[i4 >> 2] | 0) < 0;
 HEAP32[i6 >> 2] = (i3 | 0) > (i1 | 0) ? i1 : i3;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = (i6 | 0) > (i2 | 0) ? i2 : i6;
 return i5 | 0;
}

function __Z14IsStringNumberRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = HEAP8[i5 >> 0] | 0;
 L1 : do if (!(i2 << 24 >> 24)) i1 = 0; else {
  i1 = 0;
  i4 = 0;
  i3 = 0;
  while (1) {
   switch (i2 << 24 >> 24 | 0) {
   case 57:
   case 56:
   case 55:
   case 54:
   case 53:
   case 52:
   case 51:
   case 50:
   case 49:
   case 48:
    {
     i1 = 1;
     break;
    }
   case 44:
   case 46:
    {
     if (i3) {
      i1 = 0;
      break L1;
     } else i3 = 1;
     break;
    }
   case 45:
   case 43:
    {
     if (i4) {
      i1 = 0;
      break L1;
     }
     break;
    }
   default:
    {
     i1 = 0;
     break L1;
    }
   }
   i4 = i4 + 1 | 0;
   i2 = HEAP8[i5 + i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L1;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i5 = i2 + 4 | 0;
 i6 = i3 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  i7 = i1 + -24 | 0;
  __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_((HEAP32[i6 >> 2] | 0) + -24 | 0, i7);
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -24;
  i1 = i7;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i4;
 i4 = i3 + 8 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i7;
 i4 = i2 + 8 | 0;
 i7 = i3 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 return;
}

function __ZN5physx17PxsContactManager16resetCachedStateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP16[i3 + 36 >> 1] = 0;
 i2 = i3 + 40 | 0;
 HEAP32[i3 + 64 >> 2] = 0;
 HEAP16[i3 + 72 >> 1] = 0;
 HEAP32[i3 + 68 >> 2] = 0;
 i1 = i3 + 60 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2 | 0) if (!(i2 & 1)) {
  i1 = i2;
  HEAP8[i1 + 33 >> 0] = 0;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP32[i1 + 16 >> 2] = 2139095039;
  HEAP32[i1 + 20 >> 2] = 2139095039;
  HEAP32[i1 + 24 >> 2] = 2139095039;
  HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 1065353216;
  break;
 } else {
  HEAP32[i1 >> 2] = 1;
  break;
 } while (0);
 i3 = i3 + 114 | 0;
 HEAP16[i3 >> 1] = (HEAPU16[i3 >> 1] | 0) & 65531;
 return;
}

function __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var f1 = f0, f2 = f0, i3 = 0, i4 = 0, i5 = 0, f9 = f0, i10 = 0;
 f1 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 >> 2])));
 f9 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 + 4 >> 2])));
 f2 = Math_fround(Math_abs(Math_fround(HEAPF32[i6 + 8 >> 2])));
 if (f9 > f1 & f9 > f2) {
  i3 = 1;
  i4 = 2;
  i5 = 0;
 } else if (f2 > f1) {
  i3 = 2;
  i4 = 0;
  i5 = 1;
 } else {
  i3 = 0;
  i4 = 1;
  i5 = 2;
 }
 f2 = Math_fround(HEAPF32[i6 + (i3 << 2) >> 2]);
 f9 = Math_fround(Math_fround(1.0) / Math_fround(Math_abs(Math_fround(f2))));
 i10 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) >>> 31;
 HEAPF32[i7 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i6 + (i4 << 2) >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(f9 * Math_fround(HEAPF32[i6 + (i5 << 2) >> 2]));
 return i10 | i3 << 1 | 0;
}

function __ZN22RenderingCommandBuffer18AddSetGlobalBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferID(i10, i1, i2) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i6 = i10 + 8 | 0;
 i8 = i10 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i10 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i10 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 15;
 i4 = i4 + 7 & -4;
 i5 = i4 + 8 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i8 = i1 + i4 | 0;
 HEAP32[i8 >> 2] = i9;
 HEAP32[i8 + 4 >> 2] = i7;
 HEAP8[i10 + 36 >> 0] = 1;
 return;
}

function __ZN22BaseUnityConnectClient17StartEventHandlerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 16 | 0;
 i3 = i4;
 HEAP32[i3 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN11UnityEngine7Connect18ConnectSessionInfo12ToJsonStringER8UnityStr(i1 + 352 | 0, i3);
 i1 = __ZN19CloudServiceHandler17StartEventHandlerERK8UnityStrii(HEAP32[i1 + 280 >> 2] | 0, i3, HEAP32[i1 + 632 >> 2] | 0, HEAP32[i1 + 644 >> 2] | 0) | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return i1 | 0;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[gb + 1467756 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = i1 - i3 >> 2;
 if (!i2) i2 = i4; else {
  i1 = i4;
  do {
   i2 = i2 + -1 | 0;
   i3 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
   if (i3) {
    i1 = HEAP32[i3 >> 2] | 0;
    if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
    i1 = i3 + 88 | 0;
    if ((HEAP32[i3 + 104 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 92 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __ZN11UTF16StringD2Ev(i3 + 68 | 0);
    __ZdlPv(i3);
    i1 = HEAP32[gb + 1467756 >> 2] | 0;
   }
   i3 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != 0);
  i2 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if ((i1 | 0) == (i3 | 0)) return;
 HEAP32[i2 + 4 >> 2] = i1 + (~((i1 + -4 - i3 | 0) >>> 2) << 2);
 return;
}

function __ZN13GfxDeviceGLES29GetNativeComputeBufferPointerE15ComputeBufferID(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = i2 + 8456 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = i4;
  i3 = i2;
 }
 L6 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L6;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i5 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 return i5 | 0;
}

function __Z27Input_CUSTOM_GetKeyUpStringP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i4 + 16 | 0;
 i2 = i4 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i2, i5);
 i1 = __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536702 | 0, i3);
 } else {
  i5 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 88 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function ___setrlimit(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i1 = i6;
 i4 = i6 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = 0;
 i1 = ___syscall340(340, i1 | 0) | 0;
 if ((i1 | 0) == -38) {
  i7 = i3;
  i1 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i8 = i7 >>> 0 < 0 | (i7 | 0) == 0 & i1 >>> 0 < 4294967295;
  i1 = i8 ? i1 : -1;
  HEAP32[i4 >> 2] = i1;
  i3 = i3 + 8 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  i7 = i3 >>> 0 < 0 | (i3 | 0) == 0 & i1 >>> 0 < 4294967295;
  i1 = i7 ? i1 : -1;
  HEAP32[i4 + 4 >> 2] = i1;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i4;
  i1 = ___syscall75(75, i5 | 0) | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK7ApiGLES18GetFramebufferInfoEv(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i1 = i1 + 88 | 0;
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3410, i4 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3411, i4 + 4 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3412, i4 + 8 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3413, i4 + 12 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3414, i4 + 16 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 3415, i4 + 20 | 0);
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 156 >> 0] | 0) {
  mftCall_vii(HEAP32[i1 >> 2] | 0, 32937, i4 + 24 | 0);
  mftCall_vii(HEAP32[i1 >> 2] | 0, 32936, i4 + 28 | 0);
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 725 >> 0] | 0)) return;
 mftCall_vii(HEAP32[i1 >> 2] | 0, 36564, i4 + 32 | 0);
 mftCall_vii(HEAP32[i1 >> 2] | 0, 36563, i4 + 36 | 0);
 return;
}

function __ZN5physx6shdfnd6SocketC2Eb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 110712 + 8;
 if (i1) {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 1 | 0, 32788, gb + 777345 | 0, 333) | 0;
  HEAP32[i1 + 4 >> 2] = -1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP16[i1 + 12 >> 1] = 0;
  HEAP8[i1 + 14 >> 0] = 0;
  HEAP8[i1 + 15 >> 0] = 1;
  HEAP32[i1 >> 2] = gb + 110664 + 8;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = i1;
  STACKTOP = i3;
  return;
 } else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, 16, gb + 777345 | 0, 338) | 0;
  HEAP32[i1 >> 2] = gb + 110688 + 8;
  HEAP32[i1 + 4 >> 2] = -1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP16[i1 + 12 >> 1] = 0;
  HEAP8[i1 + 14 >> 0] = 0;
  HEAP8[i1 + 15 >> 0] = 1;
  HEAP32[i2 + 4 >> 2] = i1;
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 * 24 | 0) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 * 24 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
  i1 = i1 + 24 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd13createFastIPCERNS0_5PxIPC9ErrorCodeENS1_14ConnectionTypeEPKcjjbbj(i6, i5, i7, i9, i4, i2, i3, i8) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i1 = 0, i10 = 0, i11 = 0;
 i10 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i11 = HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i11 | 0, i10 | 0, 136, (i1 ? gb + 777516 | 0 : gb + 837976 | 0) | 0, gb + 777634 | 0, 359) | 0;
 __ZN5physx6shdfnd7FastIPCC2ERNS0_5PxIPC9ErrorCodeENS2_14ConnectionTypeEPKcjjbbj(i1, i6, i5, i7, i9, i4, i2, i3, i8);
 if (!(HEAP32[i6 >> 2] | 0)) {
  i11 = i1;
  return i11 | 0;
 }
 if (!i1) {
  i11 = 0;
  return i11 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 i11 = 0;
 return i11 | 0;
}

function __ZN5physx6shdfnd13ReadWriteLockC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2 + 4 | 0, 8, gb + 701722 | 0, 111) | 0;
 HEAP32[i1 >> 2] = i5;
 i6 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i7 | 0, i6 | 0, 32, (i4 ? gb + 778341 | 0 : gb + 837976 | 0) | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i5 >> 2] = i4;
 _pthread_mutexattr_init(i3 | 0) | 0;
 _pthread_mutexattr_settype(i3 | 0, 1) | 0;
 _pthread_mutex_init(i4 | 0, i3 | 0) | 0;
 _pthread_mutexattr_destroy(i3 | 0) | 0;
 HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx36PxVehicleDriveDynDataGeneratedValuesC2EPKNS_21PxVehicleDriveDynDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP8[i1 + 65 >> 0] | 0;
 HEAP8[i2 >> 0] = i8;
 i7 = HEAP8[i1 + 66 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = i7;
 i9 = HEAP8[i1 + 64 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = i9;
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i6;
 i5 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i5;
 i4 = HEAP32[i1 + 76 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = i4;
 HEAP32[i2 + 16 >> 2] = i5;
 i3 = HEAP32[i1 + 80 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = i3;
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP8[i2 + 28 >> 0] = i9;
 HEAP8[i2 + 29 >> 0] = i8;
 HEAP8[i2 + 30 >> 0] = i7;
 HEAP32[i2 + 32 >> 2] = i6;
 HEAP32[i2 + 36 >> 2] = i5;
 HEAP32[i2 + 40 >> 2] = i4;
 HEAP32[i2 + 44 >> 2] = i3;
 HEAP32[i2 + 48 >> 2] = i1;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMinCCDAdvanceCoefficientEf(i7, f6) {
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 48 | 0;
 i1 = i7 + 64 | 0;
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i3 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore24setCCDAdvanceCoefficientEf(i1, f6);
  return;
 }
 i2 = i7 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 124 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 64;
 return;
}

function __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcRNS_21PxProfileNameProviderEj(i4, i7, i1, i6) {
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i3 = i8;
 mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i3 | 0, i1 | 0);
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i4) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 288, gb + 766896 | 0, gb + 740601 | 0, 138) | 0;
 i9 = i5;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i3;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i4, i1, i7, i6, i5);
 STACKTOP = i8;
 return i4 + 116 | 0;
}

function __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148800 + 8;
 HEAP32[i1 + 100 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 120 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 104 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 112 >> 2] | 0);
 }
 HEAP32[i1 + 76 >> 2] = gb + 148896 + 8;
 i2 = HEAP32[i1 + 96 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 80 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 88 >> 2] | 0);
 }
 HEAP32[i1 + 52 >> 2] = gb + 148912 + 8;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 64 >> 2] | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer17ResetArchivedFileERK8UnityStr(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 2144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 1076 | 0;
 i2 = i5 + 8 | 0;
 i3 = i5;
 i4 = i5 + 2136 | 0;
 __ZN15FileSystemEntryC2EPKc(i1, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZN12FileAccessorC2Ev(i2);
 if (!(__ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior(i2, i1, 2, 1) | 0)) {
  __ZN12FileAccessorD2Ev(i2);
  __ZN13FileEntryDataD2Ev(i1);
  STACKTOP = i5;
  return;
 }
 i6 = i3;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP16[i4 >> 1] = 10;
 __ZN12FileAccessor5WriteEyPKvPy(i2, 1, 0, i4, i3) | 0;
 __ZN12FileAccessor5CloseEv(i2) | 0;
 __ZN12FileAccessorD2Ev(i2);
 __ZN13FileEntryDataD2Ev(i1);
 STACKTOP = i5;
 return;
}

function __Z40TerrainData_Get_Custom_PropTreeInstancesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i2 = i2 + 100 | 0;
  i2 = (HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z26GetTerrainScriptingClassesv() | 0) + 20 >> 2] | 0, 40, (i2 | 0) / 40 | 0) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 40) | 0, i1 | 0, i2 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z38TerrainData_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i4 = i4 + 248 | 0;
  __ZNK9Heightmap15CalculateBoundsEiii(i3, i4, 0, 0, HEAP32[i4 + 80 >> 2] | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __ZN7mecanim14SetValueWeightEPNS_16ValueArrayWeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 255;
 _memset(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, i3 | 0, HEAP32[i1 >> 2] << 2 | 0) | 0;
 i4 = i1 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memset(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, i3 | 0, HEAP32[i1 + 8 >> 2] << 2 | 0) | 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memset(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, i3 | 0, HEAP32[i1 + 16 >> 2] << 2 | 0) | 0;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memset(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, i3 | 0, HEAP32[i1 + 32 >> 2] << 2 | 0) | 0;
 i4 = i1 + 28 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 _memset(((i5 | 0) == 0 ? 0 : i5 + i4 | 0) | 0, i3 | 0, HEAP32[i1 + 24 >> 2] << 2 | 0) | 0;
 return;
}

function __ZN6Camera5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 864 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 868 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 872 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 876 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 848 >> 2] = 1044694213;
 HEAP32[i1 + 852 >> 2] = 1050319515;
 HEAP32[i1 + 856 >> 2] = 1056109299;
 HEAP32[i1 + 860 >> 2] = 0;
 HEAPF32[i1 + 888 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 920 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 924 >> 2] = Math_fround(1.0e3);
 HEAP32[i1 + 928 >> 2] = -1;
 HEAPF32[i1 + 1060 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 1088 >> 0] = 0;
 HEAP8[i1 + 1091 >> 0] = 0;
 HEAP32[i1 + 1064 >> 2] = 0;
 HEAP32[i1 + 1068 >> 2] = 0;
 HEAPF32[i1 + 916 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 292 >> 2] = Math_fround(60.0);
 HEAP32[i1 + 844 >> 2] = 1;
 HEAP32[i1 + 1076 >> 2] = 16843009;
 HEAP32[i1 + 820 >> 2] = 0;
 HEAP32[i1 + 824 >> 2] = 3;
 return;
}

function __ZN4FMOD12ChannelGroup11getUserDataEPPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854979;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854979;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN23ManagedAttributeManager21GetRequiredComponentsEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 248 | 0;
 i4 = i1 + 8 | 0;
 i5 = i1;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 64 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i2) | 0);
 HEAP32[i3 >> 2] = 0;
 i2 = __Z30scripting_cast_object_to_arrayP12Il2CppObject(__ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN21DownloadHandlerScript26InvokeReceiveContentLengthEP12Il2CppObjecti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = i1 + 36 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i9 = i1;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i1 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i2, i6);
 __ZN18ScriptingArguments6AddIntEi(i4, i3);
 HEAP32[i6 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 i6 = (HEAP32[i6 >> 2] | 0) == 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z85Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D24GetRelativePointVelocityERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __Z27Camera_CUSTOM_GetAllCamerasP11Il2CppArray(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN9Scripting11RaiseIfNullEPv(i1);
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i3 = HEAP32[(__Z16GetRenderManagerv() | 0) + 24 >> 2] | 0;
 if ((i4 | 0) < ((HEAP32[(__Z16GetRenderManagerv() | 0) + 12 >> 2] | 0) + i3 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 502861 | 0, i2); else {
  i4 = __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i1, (__Z16GetRenderManagerv() | 0) + 4 | 0, 0) | 0;
  i4 = (__Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i1, (__Z16GetRenderManagerv() | 0) + 16 | 0, i4) | 0) + i4 | 0;
  STACKTOP = i2;
  return i4 | 0;
 }
 return 0;
}

function __Z25Animator_CUSTOM_GetBoolIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator7GetBoolEiRb(i1, i4, i5) | 0;
 if ((i1 | 0) == 1) {
  i5 = HEAP8[i5 >> 0] | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 i5 = HEAP8[i5 >> 0] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i5 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i5 + 4 >> 2] | 0);
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i1 = i5 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
  __ZdlPv(i3);
 }
 __ZdlPv(i5);
 return;
}

function __ZN4Mesh13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1161332 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161332 | 0, i1);
  i2 = gb + 1161332 | 0;
 } else i2 = 0;
 i1 = i3 + 41 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) HEAP8[i1 >> 0] = 0;
 __ZN4Mesh14ClearSkinCacheEv(i3);
 __ZN4Mesh18UpdateVertexFormatEv(i3);
 __ZN4Mesh18CreateMeshIfNeededEv(i3);
 i1 = i3 + 228 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = __ZN17UniqueIDGenerator15CreatePureIndexEv(HEAP32[gb + 1161344 >> 2] | 0) | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD12ChannelGroup11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854655;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854655;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZL24QueryPortalVisibilityJobP28QueryPortalVisibilityJobDataj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1112792 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112792 | 0, i1);
  i1 = gb + 1112792 | 0;
 } else i1 = 0;
 i6 = HEAP32[i3 + 8 + (i4 << 2) >> 2] | 0;
 i7 = __Z9GetIUmbrav() | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP8[i3 + 32 + i4 >> 0] = (mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 60 >> 2] | 0, i7 | 0, i6 | 0, i2 | 0, HEAP32[i2 + 848 >> 2] | 0, i4 | 0, HEAP32[i3 + 4 >> 2] | 0) | 0) & 1;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __Z21Transform_CUSTOM_FindP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(__Z29FindRelativeTransformWithPathR9TransformPKcb(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0) | 0) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, gb + 1048681 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z10md5_updateP11md5_contextPhi(i7, i3, i1) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((i1 | 0) < 1) return;
 i6 = HEAP32[i7 >> 2] | 0;
 i2 = i6 & 63;
 i4 = 64 - i2 | 0;
 i6 = i6 + i1 | 0;
 HEAP32[i7 >> 2] = i6;
 if (i6 >>> 0 < i1 >>> 0) {
  i6 = i7 + 4 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 }
 if (!((i2 | 0) == 0 | (i4 | 0) > (i1 | 0))) {
  _memcpy(i7 + 24 + i2 | 0, i3 | 0, i4 | 0) | 0;
  __ZL11md5_processP11md5_contextPh(i7, i7 + 24 | 0);
  i2 = 0;
  i3 = i3 + i4 | 0;
  i1 = i1 - i4 | 0;
 }
 if ((i1 | 0) > 63) {
  i5 = i1 + -64 | 0;
  i6 = i5 & -64;
  i4 = i3 + (i6 + 64) | 0;
  while (1) {
   __ZL11md5_processP11md5_contextPh(i7, i3);
   i1 = i1 + -64 | 0;
   if ((i1 | 0) <= 63) break; else i3 = i3 + 64 | 0;
  }
  i3 = i4;
  i1 = i5 - i6 | 0;
 }
 if ((i1 | 0) <= 0) return;
 _memcpy(i7 + 24 + i2 | 0, i3 | 0, i1 | 0) | 0;
 return;
}

function _UNITY_FT_GlyphLoader_CreateExtra(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i1 + 4 | 0;
 i3 = _UNITY_ft_mem_realloc(HEAP32[i1 >> 2] | 0, 8, 0, HEAP32[i2 >> 2] << 1, 0, i4) | 0;
 HEAP32[i1 + 40 >> 2] = i3;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP8[i1 + 16 >> 0] = 1;
 i6 = i3 + (HEAP32[i2 >> 2] << 3) | 0;
 HEAP32[i1 + 44 >> 2] = i6;
 i2 = HEAP16[i1 + 22 >> 1] | 0;
 HEAP32[i1 + 60 >> 2] = (HEAP32[i1 + 24 >> 2] | 0) + (i2 << 3);
 HEAP32[i1 + 64 >> 2] = (HEAP32[i1 + 28 >> 2] | 0) + i2;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i1 + 68 >> 2] = (HEAP32[i1 + 32 >> 2] | 0) + (i2 << 16 >> 16 << 1);
 i2 = i2 >> 16;
 HEAP32[i1 + 76 >> 2] = i3 + (i2 << 3);
 HEAP32[i1 + 80 >> 2] = i6 + (i2 << 3);
 STACKTOP = i5;
 return i4 | 0;
}

function _raccess_guess_darwin_ufs_export(i3, i1, i2, i7, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i5 = i9;
 i8 = HEAP32[i3 >> 2] | 0;
 i6 = _raccess_make_file_name(i8, i2, gb + 947096 | 0) | 0;
 if (!i6) {
  i8 = 64;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 12 >> 2] = i6;
 i1 = _UNITY_FT_Stream_New(i3, i1, i5) | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i1 = 81;
   i2 = 0;
  } else {
   i1 = _raccess_guess_apple_generic(i1, 333319, i4) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  _UNITY_FT_Stream_Free(i2, 0);
  if (!i1) {
   HEAP32[i7 >> 2] = i6;
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 _UNITY_ft_mem_free(i8, i6);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK5physx7NpCloth20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i4 = __ZNK5physx2Sc9ClothCore20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE(i2 + 32 | 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 256, gb + 696149 | 0, i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK5physx2Sc9ClothCore24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 300 >> 2] | 0, i2 | 0) | 0;
 if (!i2) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4 + (i2 << 4);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 mftCall_viii(i8 | 0, i7 | 0, i1 | 0, i5 | 0);
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN8LODGroup19SyncLODGroupManagerEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i7 = i5 + 88 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (i2) {
  i4 = i5 + 76 | 0;
  i3 = 0;
  i1 = i2;
  do {
   i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i6 >> 2] = -1;
 __ZN8LODGroup6CreateEv(i5);
 return;
}

function __ZN5physx2Sn20SerializationContextD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 89224 + 8;
 __ZN5physx27PxDefaultMemoryOutputStreamD2Ev(i3 + 184 | 0);
 i1 = i3 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i3 + 44 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  }
 }
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN4FMOD6System9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE(i3, i1, i7, i2, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i1 = __ZN4FMOD7SystemI9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE(i2, 0, i7, 0, i8) | 0;
  if (!i1) {
   i8 = 0;
   STACKTOP = i6;
   return i8 | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = gb + 859320;
  _printf(gb + 853343 | 0, i5) | 0;
  i8 = i1;
  STACKTOP = i6;
  return i8 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859320;
 _printf(gb + 853184 | 0, i4) | 0;
 i8 = 36;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN4FMOD3DSP7getTypeEP13FMOD_DSP_TYPE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868849;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868849;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868849;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN13RuntimeStaticI23MeshVertexFormatManagerE10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(20, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(20, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 16 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13BuildSettings16GetScenePathNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) | 0;
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 i4 = i3;
 if (!((i5 | 0) > -1 ? ((HEAP32[i2 + 44 >> 2] | 0) - i3 >> 4 | 0) > (i5 | 0) : 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  return;
 }
 i1 = i4 + (i5 << 4) | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + (i5 << 4) + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i1);
 return;
}

function __Z43ParticleSystem_MainModule_CUSTOM_SetPrewarmP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem10SetPrewarmEb(i1, i2 << 24 >> 24 != 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z31Camera_CUSTOM_RenderDontRestoreP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
  __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, 20, 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 }
}

function _UNITY_png_set_cHRM_XYZ_fixed(i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 var i4 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i13;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  STACKTOP = i13;
  return;
 }
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i6;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i8;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = i10;
 HEAP32[i4 + 24 >> 2] = i11;
 HEAP32[i4 + 28 >> 2] = i12;
 HEAP32[i4 + 32 >> 2] = i3;
 if (_UNITY_png_colorspace_set_endpoints(i1, i2 + 40 | 0, i4, 2) | 0) {
  i12 = i2 + 114 | 0;
  HEAP16[i12 >> 1] = HEAPU16[i12 >> 1] | 0 | 16;
 }
 _UNITY_png_colorspace_sync_info(i1, i2);
 STACKTOP = i13;
 return;
}

function __ZNSt3__26thread6detachEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 22; else {
  i1 = _pthread_detach(i1 | 0) | 0;
  if (!i1) {
   HEAP32[i2 >> 2] = 0;
   STACKTOP = i3;
   return;
  }
 }
 i2 = ___cxa_allocate_exception(16) | 0;
 i3 = __ZNSt3__215system_categoryEv() | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i3;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_viii(fb + 1062 | 0, i2 | 0, i4 | 0, gb + 1084785 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i2 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i2 | 0, gb + 12920 | 0, fb + 3205 | 0);
}

function __ZNK5physx11HullLibrary10extrudableEf(i1, f7) {
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, f9 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = 0;
 i6 = 0;
 i3 = 0;
 while (1) {
  if (i2) {
   i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0;
   if (!i1) i1 = i3; else {
    f9 = Math_fround(HEAPF32[i3 + 32 >> 2]);
    if (f9 < Math_fround(HEAPF32[i1 + 32 >> 2])) {
     i1 = i4;
     i8 = 6;
    } else i1 = i3;
   }
  } else {
   i1 = i4;
   i8 = 6;
  }
  if ((i8 | 0) == 6) {
   i8 = 0;
   i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] | 0;
  }
  i6 = i6 + 1 | 0;
  i2 = (i1 | 0) != 0;
  if ((i6 | 0) >= (i5 | 0)) break; else i3 = i1;
 }
 if (!i2) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = Math_fround(HEAPF32[i1 + 32 >> 2]) > f7;
 i8 = i8 ? i1 : 0;
 return i8 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMinCCDAdvanceCoefficientEf(i7, f6) {
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 48 | 0;
 i1 = i7 + 64 | 0;
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i3 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore24setCCDAdvanceCoefficientEf(i1, f6);
  return;
 }
 i2 = i7 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 124 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 64;
 return;
}

function __ZN5physx19NpArticulationJoint28setTwistLimitContactDistanceEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore28setTwistLimitContactDistanceEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 116 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4096;
 return;
}

function __ZN5physx16NpParticleSystem23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = i6 + 32 | 0;
 i1 = __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i5) | 0;
 if (i3) i1 = (i1 & 65535 | i2) & 65535; else i1 = i1 & ((i2 ^ 65535) & 65535);
 switch ((HEAP32[i6 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i7 = 5;
   break;
  }
 case 3:
  {
   STACKTOP = i8;
   return;
  }
 default:
  {}
 }
 if ((i7 | 0) == 5) if (HEAP8[(HEAP32[i6 + 20 >> 2] | 0) + 2433 >> 0] | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP16[i4 >> 1] = i1;
 __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE(i5, i4);
 STACKTOP = i8;
 return;
}

function __ZN5Umbra9RasterOps4blitERNS_17BlockRasterBufferERKS1_(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i10 = HEAPU8[i2 >> 0] | 0;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 i9 = HEAP8[i2 + 3 >> 0] | 0;
 i11 = i9 & 255;
 if ((i1 & 255) >= (i9 & 255)) return;
 i7 = HEAPU8[i6 + 2 >> 0] | 0;
 i8 = HEAP32[i6 + 4 >> 2] | 0;
 i9 = (HEAPU8[i2 + 2 >> 0] | 0) - i10 | 0;
 i5 = i1 & 255;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i4 = HEAP16[i6 >> 1] | 0;
  i2 = i4 & 255;
  i1 = i9;
  i2 = i8 + (i10 - i2 + (Math_imul(i5 - ((i4 & 65535) >>> 8 & 65535) | 0, i7 - i2 | 0) | 0) << 2) | 0;
  i4 = i3;
  while (1) {
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i1 = i1 + -1 | 0;
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i4 = i4 + 4 | 0;
   }
  }
  i5 = i5 + 1 | 0;
  if ((i5 | 0) == (i11 | 0)) break; else i3 = i3 + (i9 << 2) | 0;
 }
 return;
}

function __ZN4FMOD5Sound7getNameEPci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i2 = i6;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868219;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868219;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 868219;
 _printf(gb + 853184 | 0, i2) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN16ScriptingManager33GetAssemblyNameForCSharpFirstPassEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 12 | 0;
 i4 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 465909 | 0, 6);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 465916 | 0, 10);
 __ZN16ScriptingManager15GetAssemblyNameENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_(i2, 0, i3, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return;
}

function __ZN14PhysicsManager22ProcessRecordedReportsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1452500 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452500 | 0, i1);
  i1 = gb + 1452500 | 0;
 } else i1 = 0;
 i2 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 __ZN14PhysicsManager24ProcessTriggerEnterExitsEv(i3);
 __ZN14PhysicsManager19ProcessTriggerStaysEv(i3);
 __ZN14PhysicsManager15ProcessContactsEv(i3);
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i2) | 0;
 __ZN14PhysicsManager18ProcessJointBreaksEv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN13UnityProfiler20AddPerThreadProfilerEP22UnityProfilerPerThread(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = i3 + 56 | 0;
 i4 = i1 + 256 | 0;
 if ((i4 | 0) != (i5 | 0)) {
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) i1 = i1 + 260 | 0; else {
   i1 = i1 + 260 | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
  }
  i2 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i5;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 }
 i1 = i3 + 68 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i3 + 60 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i5 | 0)) return; else i3 = 0;
 while (1) {
  HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 276 >> 2] = i3;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
 }
 return;
}

function __ZN12_GLOBAL__N_112UserRendererD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150452 + 8;
 i1 = i4 + 56 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 52 | 0;
  i3 = 0;
  do {
   i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = gb + 150548 + 8;
 i5 = HEAP32[i4 + 60 >> 2] | 0;
 if ((i5 | 0) > -1 & (i5 & 2147483647 | 0) != 0) {
  i5 = HEAP32[i4 + 44 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i4 + 52 >> 2] | 0);
 }
 HEAP32[i4 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i4 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 return;
}

function __ZL20InternalGetByteArrayPK15DownloadHandler(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027689 | 0, i3);
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 if (!i2) {
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0, 4, 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
  i1 = (i4 | 0) == 0 ? 0 : i2;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i5, 1, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0, i4 | 0, i1 | 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z23SetGlobalBoolPreferencePKcb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i2 ? gb + 488713 | 0 : gb + 488717 | 0, i2 ? 3 : 2);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i1, _strlen(i1) | 0);
 __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i5, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEjw(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 if (i4 | 0) {
  i2 = i6 + 8 | 0;
  i7 = i2 + 3 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = (HEAP32[i2 >> 2] & 2147483647) + -1 | 0;
   i3 = HEAP32[i6 + 4 >> 2] | 0;
  } else {
   i2 = 1;
   i3 = i1 & 255;
  }
  if ((i2 - i3 | 0) >>> 0 < i4 >>> 0) {
   __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i6, i2, i4 - i2 + i3 | 0, i3, i3, 0, 0);
   i1 = HEAP8[i7 >> 0] | 0;
  }
  if (i1 << 24 >> 24 < 0) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
  __ZNSt3__211char_traitsIwE6assignEPwjw(i2 + (i3 << 2) | 0, i4, i5) | 0;
  i1 = i3 + i4 | 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i6 + 4 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
 }
 return i6 | 0;
}

function __ZNK29ParticleSystemPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i7, f8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i10 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i10 << 4) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i9 | 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i10 | 0 : i10;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) return;
 if ((i1 | 0) == (i6 | 0) ? 1 : (i9 | 0) < (HEAP32[i1 >> 2] | 0)) return;
 i10 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_viiif(HEAP32[(HEAP32[i10 >> 2] | 0) + 8 >> 2] | 0, i10 | 0, HEAP32[i7 + 12 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, +f8);
 return;
}

function __ZN9Texture2D11SetPixels32EiiiiiPK11ColorRGBA32(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i10 + 20 | 0;
 i9 = i10;
 if ((i4 | 0) < 1 | (i5 | 0) < 1) {
  STACKTOP = i10;
  return;
 };
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP32[i8 + 16 >> 2] = 0;
 if (__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i1, i8, 0, i6) | 0) if (!(((i3 | i2 | 0) < 0 ? 1 : (HEAP32[i8 + 4 >> 2] | 0) < (i4 + i2 | 0)) | (HEAP32[i8 + 8 >> 2] | 0) < (i5 + i3 | 0))) {
  __ZN14ImageReferenceC2Eiii13TextureFormatPv(i9, i4, i5, i4 << 2, 4, i7);
  __ZN14ImageReference9BlitImageEiiRKS_(i8, i2, i3, i9);
 }
 STACKTOP = i10;
 return;
}

function __ZN9LensFlare7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(76, i1, 16, gb + 1048932 | 0, 0, gb + 377820 | 0, 137) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 32976 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 68 >> 2] = -1;
 HEAPF32[i4 + 60 >> 2] = Math_fround(3.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN7mecanim5human16DeltaPoseQualityERNS0_9HumanPoseEf(i4, f5) {
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var f1 = f0, i2 = 0, f3 = f0, i6 = 0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 Math_fround(__ZN7mecanim5human21ComputeHierarchicMassEiPf(0, i6));
 f1 = Math_fround(0.0);
 i2 = 0;
 f3 = Math_fround(0.0);
 do {
  i10 = HEAP32[gb + 179672 + (i2 << 2) >> 2] | 0;
  f9 = Math_fround(_fminf(Math_fround(1.0), Math_fround(_fmaxf(Math_fround(0.0), Math_fround(Math_fround(f5 - Math_fround(Math_abs(Math_fround(HEAPF32[i4 + 596 + (i2 << 2) >> 2])))) / f5)))));
  f8 = Math_fround(HEAPF32[i6 + (i10 << 2) >> 2]);
  f3 = Math_fround(f3 + Math_fround(f9 * f8));
  f1 = Math_fround(f1 + f8);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 52);
 f9 = Math_fround(f3 / f1);
 STACKTOP = i7;
 return Math_fround(f9);
}

function __ZN5physx2Sn18RepXCollectionImpl11saveXmlNodeEPNS0_7XmlNodeERNS0_15SimpleXmlWriterE(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP8[i2 >> 0] | 0) if (!(HEAP32[i3 + 16 >> 2] | 0)) {
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0, i2 | 0);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 >> 0] | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i1 | 0);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 | 0) do {
  __ZN5physx2Sn18RepXCollectionImpl11saveXmlNodeEPNS0_7XmlNodeERNS0_15SimpleXmlWriterE(i5, i1, i4);
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx19NpArticulationJoint28setSwingLimitContactDistanceEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore28setSwingLimitContactDistanceEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 100 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 256;
 return;
}

function __ZN4FMOD7Channel14getLowPassGainEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868553;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868553;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868553;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9 + 8 | 0;
 i7 = i9;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i1 = __ZN4FMOD7SystemI11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(i2, i3, i4, i5, i6) | 0;
  if (!i1) {
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
  HEAP32[i8 >> 2] = i1;
  HEAP32[i8 + 4 >> 2] = gb + 854022;
  _printf(gb + 853343 | 0, i8) | 0;
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i7 >> 2] = 36;
 HEAP32[i7 + 4 >> 2] = gb + 854022;
 _printf(gb + 853184 | 0, i7) | 0;
 i8 = 36;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN4FMOD5Sound16getNumSyncPointsEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868998;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868998;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868998;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup9getPausedEPb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868227;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868227;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868227;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN17ArchiveFileSystem5WriteER13FileEntryDatayyPvPy(i1, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1178956 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178956 | 0, i1);
  i2 = gb + 1178956 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN15ArchiveReadFile5CloseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return 1;
 i2 = i3 + 2336 | 0;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (!i4) {
  __ZN12FileAccessor5CloseEv(i3 + 1248 | 0) | 0;
  i4 = i3 + 2376 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i2 = i3 + 2364 | 0;
   i1 = 0;
   do {
    __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i3, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  HEAP32[i4 >> 2] = 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 }
 HEAP32[i5 >> 2] = 0;
 return 1;
}

function __ZN13RenderTexture15DiscardContentsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i6 = i8 + 4 | 0;
 i7 = i8;
 i2 = i1 + 128 | 0;
 i4 = i1 + 136 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) if (!(HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i5 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i1 + 132 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 if (i2) {
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 336 >> 2] | 0, i5 | 0, i3 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 336 >> 2] | 0, i5 | 0, i6 | 0);
 if (HEAP32[i7 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 336 >> 2] | 0, i5 | 0, i7 | 0);
 STACKTOP = i8;
 return;
}

function __Z51Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK13Vector2fIcallS3_N11Rigidbody2D9ForceModeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i6 = i8;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  __ZN11Rigidbody2D18AddForceAtPositionERK8Vector2fS2_NS_9ForceModeE(i7, i5, i6, i4);
  STACKTOP = i8;
  return;
 }
}

function __Z47Playable_CUSTOM_INTERNAL_CALL_GetOutputInternalR9HPlayableiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if ((i2 | 0) > -1 & (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0;
  if ((HEAP32[i1 + 48 >> 2] | 0) >>> 0 > i2 >>> 0) {
   i1 = HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if (i1 | 0) {
    __ZN8Playable6HandleEv(i4, i1);
    i1 = i4;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = i3;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + 4 >> 2] = i2;
    STACKTOP = i5;
    return;
   }
  }
 }
 i1 = gb + 37528 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 STACKTOP = i5;
 return;
}

function __Z29StdTemplateConversionFunctionIatEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIasEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIajEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIaiEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 << 24 >> 24;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 << 24 >> 24;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z22Check4MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_S1_P6ObjectR11MonoManager(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i9 + 24 | 0;
 i10 = i9 + 8 | 0;
 i12 = i9;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i10 + 4 >> 2] = i4;
 HEAP32[i10 + 8 >> 2] = i5;
 HEAP32[i10 + 12 >> 2] = i6;
 i4 = i1;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i12;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i11 + 4 >> 2] = HEAP32[i12 + 4 >> 2];
 i8 = __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i11, i2, i10, 4, i7, i8) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_ItLj2EES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i6;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i7 = i4 + 16 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i4 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i10, gb + 63664 | 0);
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 i1 = __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_I13BoneInfluenceLj16EERS_ItLj2EES7_(i1, i4, i2, i3) | 0;
 if ((HEAP32[i7 >> 2] | 0) <= -1) {
  STACKTOP = i6;
  return i1 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i5);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __Z10IsInvokingR13MonoBehaviourR11ICallString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 4 | 0;
 i6 = i3;
 __Z24scripting_cpp_string_forP12Il2CppString(i5, HEAP32[i2 >> 2] | 0);
 i2 = HEAP8[i5 + 11 >> 0] | 0;
 i7 = i2 << 24 >> 24 < 0;
 i2 = (i7 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255) + 1 | 0;
 i4 = _malloc(i2) | 0;
 _strncpy(i4, i7 ? HEAP32[i5 >> 2] | 0 : i5, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i2 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i2 = __ZN18DelayedCallManager14HasDelayedCallE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i2, i5, fb + 595 | 0, fb + 596 | 0, i4) | 0;
 _free(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function _raccess_guess_linux_netatalk(i3, i1, i2, i7, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i5 = i9;
 i8 = HEAP32[i3 >> 2] | 0;
 i6 = _raccess_make_file_name(i8, i2, gb + 947033 | 0) | 0;
 if (!i6) {
  i8 = 64;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 12 >> 2] = i6;
 i1 = _UNITY_FT_Stream_New(i3, i1, i5) | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i1 = 81;
   i2 = 0;
  } else {
   i1 = _raccess_guess_apple_generic(i1, 333319, i4) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  _UNITY_FT_Stream_Free(i2, 0);
  if (!i1) {
   HEAP32[i7 >> 2] = i6;
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 _UNITY_ft_mem_free(i8, i6);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN8Animator6RebindEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (i1) __ZN8Animator25WriteDefaultValuesNoDirtyEv(i3);
 if (HEAP32[i3 + 100 >> 2] & 16 | 0) return;
 __ZN8Animator11ClearObjectEv(i3);
 i4 = gb + 37528 | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i3 + 628 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 __ZN8Animator12CreateObjectEv(i3);
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 __ZN8Animator23ClearContainedRenderersEv(i3);
 if (!(HEAP32[i3 + 92 >> 2] | 0)) {
  HEAP8[i3 + 88 >> 0] = 1;
  return;
 } else {
  __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP8[i3 + 88 >> 0] = (__ZNK8Animator20IsAnyRendererVisibleEv(i3) | 0) & 1;
  return;
 }
}

function __ZN6Camera15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 1132 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZNK6Object14GetMemoryLabelEv(i2, i1);
 if (i4 | 0) {
  i5 = i4 + 20 | 0;
  if ((HEAP32[i4 + 36 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 24 | 0);
   HEAP32[i5 >> 2] = 0;
  }
  if ((HEAP32[i4 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i4 + 4 | 0);
   HEAP32[i4 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 HEAP32[i3 >> 2] = 0;
 __Z16DeleteRenderLoopP10RenderLoop(HEAP32[i1 + 1124 >> 2] | 0);
 i5 = i1 + 1128 | 0;
 __Z21DestroyShadowMapCacheP14ShadowMapCache(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx24solveExt1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i9, i8, i7, i1, i2, i3) {
 i9 = i9 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!i8) return;
 i4 = i7 + 16 | 0;
 i6 = 0;
 do {
  i5 = i9 + (i6 << 5) | 0;
  if ((HEAP16[i9 + (i6 << 5) + 8 >> 1] | 0) == -1) i2 = HEAPU16[i9 + (i6 << 5) + 10 >> 1] | 0; else i2 = 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP16[i9 + (i6 << 5) + 12 >> 1] | 0) == -1) i3 = HEAPU16[i9 + (i6 << 5) + 14 >> 1] | 0; else i3 = 0;
  __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, 0);
  __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i5, i7, i1 + (i2 << 6) | 0, i1 + (i3 << 6) | 0);
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 return;
}

function __ZN4crnd25static_huffman_data_modelD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 16 | 0;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_(i1);
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = i3 + 16 | 0;
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 if (!(i2 & 7)) mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i2 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0; else {
  HEAP32[i5 >> 2] = gb + 401209;
  HEAP32[i5 + 4 >> 2] = 2513;
  HEAP32[i5 + 8 >> 2] = gb + 401349;
  _sprintf(i4, gb + 401176 | 0, i5) | 0;
  _puts(i4) | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i5 = i3 + 16 | 0;
 HEAP8[i5 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN4FMOD7Channel13get3DPanLevelEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868472;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868472;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868472;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup8getPitchEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868237;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868237;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868237;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN17ArchiveFileSystem4ReadER13FileEntryDatayyPvPy(i1, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1178968 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178968 | 0, i1);
  i2 = gb + 1178968 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN16MemoryFileSystem5WriteER13FileEntryDatayyPvPy(i1, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1179044 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179044 | 0, i1);
  i2 = gb + 1179044 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN11UTF16StringC2EPKc10MemLabelId(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i3 = i1;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i4 + 12 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = _strlen(i5) | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  i5 = 0;
  i6 = i4 + 8 | 0;
  HEAP8[i6 >> 0] = i5;
  STACKTOP = i7;
  return;
 } else {
  i8 = i6;
  HEAP32[i8 >> 2] = i2;
  HEAP32[i8 + 4 >> 2] = i3;
  i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 16, i6, 0, gb + 489101 | 0, 14) | 0;
  HEAP32[i4 >> 2] = i6;
  __Z18ConvertUTF8toUTF16PKhiPtRi(i5, i1, i6, i4 + 4 | 0) | 0;
  i5 = 1;
  i6 = i4 + 8 | 0;
  HEAP8[i6 >> 0] = i5;
  STACKTOP = i7;
  return;
 }
}

function __Z46Playable_CUSTOM_INTERNAL_CALL_GetInputInternalR9HPlayableiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if ((i2 | 0) > -1 & (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0;
  if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 > i2 >>> 0) {
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
   if (i1 | 0) {
    __ZN8Playable6HandleEv(i4, i1);
    i1 = i4;
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i4 = i3;
    HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
    HEAP32[i4 + 4 >> 2] = i2;
    STACKTOP = i5;
    return;
   }
  }
 }
 i1 = gb + 37528 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 STACKTOP = i5;
 return;
}

function __Z44ParticleSystem_MainModule_CUSTOM_SetDurationP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem14SetLengthInSecEf(i1, f2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z40Renderer_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN8Renderer19SetSortingLayerNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z32setPxVehicleDrive4WMDriveSimDataPN5physx16PxVehicleDrive4WENS_23PxVehicleDriveSimData4WE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 64 | 0;
 _memcpy(i1 + 224 | 0, i2 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i1 + 288 >> 2] = HEAP32[i3 >> 2];
 i3 = i1 + 304 | 0;
 i4 = i2 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i1 + 336 | 0, i2 + 112 | 0, 416) | 0;
 i3 = i1 + 752 | 0;
 i1 = i2 + 528 | 0;
 i2 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __Z31GetRelaunchApplicationArgumentsv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = HEAP32[gb + 1170780 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1170780 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i6 = (i3 | 0) / 12 | 0;
 if (!i3) return;
 if (i6 >>> 0 > 357913941) {
  __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i4);
  i2 = HEAP32[gb + 1170780 >> 2] | 0;
  i5 = HEAP32[gb + 1170780 + 4 >> 2] | 0;
 } else i5 = i1;
 i1 = __Znwj(i3) | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i1 + (i6 * 12 | 0);
 if ((i2 | 0) == (i5 | 0)) return;
 do {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  i2 = i2 + 12 | 0;
  i1 = (HEAP32[i7 >> 2] | 0) + 12 | 0;
  HEAP32[i7 >> 2] = i1;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __Z24Material_CUSTOM_FindPassP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  i3 = __ZNK8Material8FindPassERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37208 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 36980 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function _raccess_guess_linux_double(i3, i1, i2, i7, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i9 + 8 | 0;
 i5 = i9;
 i8 = HEAP32[i3 >> 2] | 0;
 i6 = _raccess_make_file_name(i8, i2, gb + 1087751 | 0) | 0;
 if (!i6) {
  i8 = 64;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i1 >> 2] = 4;
 HEAP32[i1 + 12 >> 2] = i6;
 i1 = _UNITY_FT_Stream_New(i3, i1, i5) | 0;
 if (!i1) {
  i1 = HEAP32[i5 >> 2] | 0;
  if (!i1) {
   i1 = 81;
   i2 = 0;
  } else {
   i1 = _raccess_guess_apple_generic(i1, 333319, i4) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  _UNITY_FT_Stream_Free(i2, 0);
  if (!i1) {
   HEAP32[i7 >> 2] = i6;
   i8 = 0;
   STACKTOP = i9;
   return i8 | 0;
  }
 }
 _UNITY_ft_mem_free(i8, i6);
 i8 = i1;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNK5physx2Sc9ActorPair23createContactReportDataEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = __ZN5physx2Sc10NPhaseCore32createActorPairContactReportDataEv(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 1104 >> 2] | 0) | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 if (!i1) return;
 HEAP32[i1 + 16 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2];
 i4 = i2 + 4 | 0;
 HEAP32[i1 + 20 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2];
 HEAP32[i1 + 24 >> 2] = __ZN5physx2Sc8RigidSim10getPxActorEv(HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i1 + 28 >> 2] = __ZN5physx2Sc8RigidSim10getPxActorEv(HEAP32[i4 >> 2] | 0) | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0;
 HEAP8[i1 + 32 >> 0] = HEAP8[i3 + 13 >> 0] | 0;
 HEAP8[i1 + 33 >> 0] = HEAP8[i2 + 13 >> 0] | 0;
 HEAP8[i1 + 34 >> 0] = HEAP8[i3 + 11 >> 0] | 0;
 HEAP8[i1 + 35 >> 0] = HEAP8[i2 + 11 >> 0] | 0;
 return;
}

function __ZNK25ThreadsafeLinearAllocator8ContainsEPKv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i2 + 40 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2];
 i5 = HEAP32[i5 >> 2] | 0;
 L1 : do if ((i5 | 0) > 0) {
  i6 = HEAP32[i2 + 32 >> 2] | 0;
  i7 = i2 + 48 | 0;
  i1 = 0;
  while (1) {
   i4 = HEAP32[i6 + (i1 * 12 | 0) >> 2] | 0;
   if (i4 >>> 0 <= i3 >>> 0) if ((i4 + (HEAP32[i7 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
    i1 = 1;
    break;
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i5 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 i7 = i2 + 44 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2];
 if ((HEAP32[i7 >> 2] | 0) <= 0) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 64032 | 0) | 0;
 i7 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i3 | 0) | 0;
 return i7 | 0;
}

function __ZN5physx9PxTaskMgr17resetDependenciesEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i8 + 80 >> 2] = 0;
 HEAP32[i8 + 68 >> 2] = 0;
 i1 = HEAP32[i8 + 36 >> 2] | 0;
 if (!i1) {
  i8 = i8 + 56 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 i7 = i8 + 52 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  i8 = i8 + 56 | 0;
  HEAP32[i8 >> 2] = 0;
  return;
 }
 _memset(HEAP32[i8 + 28 >> 2] | 0, -1, i1 << 2 | 0) | 0;
 i6 = i8 + 32 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i2 + -1 | 0;
 i4 = i8 + 24 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i5) {
  i3 = 0;
  while (1) {
   i2 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   HEAP32[i1 + (i3 << 2) >> 2] = i2;
   if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
  }
  i2 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
 HEAP32[i8 + 44 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 i8 = i8 + 56 | 0;
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZN4FMOD7Channel12getLoopCountEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868526;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868526;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868526;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP16getNumParametersEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868798;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868798;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868798;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP14disconnectFromEPS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868757;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868757;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868757;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup7getMuteEPb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868211;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868211;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868211;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21UnityAnalyticsManager23RegisterGlobalCallbacksEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 HEAP8[i3 + 32 >> 0] = 1;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = i4 + 18524 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i1 + 1;
 HEAP32[i4 + 17756 + (i1 * 12 | 0) + 4 >> 2] = i3;
 HEAP8[i4 + 17756 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i4 + 17756 + (i1 * 12 | 0) >> 2] = fb + 199;
 STACKTOP = i6;
 return;
}

function __ZN16SpriteRenderDataC2ERKS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i3 = i2 + 8 | 0;
 i4 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP8[i2 + 52 >> 0] = HEAP8[i1 + 52 >> 0] | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i2 + 56 >> 2] = i1;
 if (!i1) return;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZN16MemoryFileSystem4ReadER13FileEntryDatayyPvPy(i1, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i10 + 4 | 0;
 i2 = i10;
 if ((HEAP16[gb + 1179056 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179056 | 0, i1);
  i2 = gb + 1179056 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 if (!i2) {
  STACKTOP = i10;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i10;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallback7onEventEjPj(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i11;
 i9 = i11 + 12 | 0;
 if (!i6) {
  STACKTOP = i11;
  return 1;
 }
 i7 = i1 + 3364 | 0;
 i8 = i1 + 4 | 0;
 i3 = i1 + 12 | 0;
 i4 = i9 + 12 | 0;
 i5 = i9 + 24 | 0;
 i1 = i6;
 while (1) {
  i1 = i1 + -1 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(HEAP32[i7 >> 2] | 0, HEAP32[i3 >> 2] | 0, i9, i10, 0, i6, 0, 0) | 0;
  __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj(i8, i6, i9, i4, i5, i10);
  if (!i1) break; else i2 = i2 + 4 | 0;
 }
 STACKTOP = i11;
 return 1;
}

function __ZN10Collider2D11SetMaterialE4PPtrI17PhysicsMaterial2DE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 4 | 0;
 i5 = i6;
 i2 = i3 + 36 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = i1;
 i1 = i3 + 72 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i3, i4, i5);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i3 + 60 >> 2] | 0;
  i4 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i7 + (i1 << 2) | 0;
  i1 = i7;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 + 36 >> 2] = i4;
   HEAP32[i7 + 40 >> 2] = i3;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 STACKTOP = i6;
 return;
}

function __Z48ParticleSystem_MainModule_CUSTOM_SetMaxParticlesP12Il2CppObjecti(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem18SetMaxNumParticlesEi(i1, i2);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z38Canvas_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN2UI6Canvas19SetSortingLayerNameERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function _raccess_guess_darwin_hfsplus(i2, i1, i5, i6, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i3 = _strlen(i5) | 0;
 i2 = _UNITY_ft_mem_alloc(HEAP32[i2 >> 2] | 0, i3 + 6 | 0, i1) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i7 = i1;
  STACKTOP = i4;
  return i7 | 0;
 }
 _memcpy(i2 | 0, i5 | 0, i3 | 0) | 0;
 i5 = i2 + i3 | 0;
 HEAP8[i5 >> 0] = HEAP8[gb + 947072 >> 0] | 0;
 HEAP8[i5 + 1 >> 0] = HEAP8[gb + 947072 + 1 >> 0] | 0;
 HEAP8[i5 + 2 >> 0] = HEAP8[gb + 947072 + 2 >> 0] | 0;
 HEAP8[i5 + 3 >> 0] = HEAP8[gb + 947072 + 3 >> 0] | 0;
 HEAP8[i5 + 4 >> 0] = HEAP8[gb + 947072 + 4 >> 0] | 0;
 HEAP8[i5 + 5 >> 0] = HEAP8[gb + 947072 + 5 >> 0] | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i7 >> 2] = 0;
 i7 = 0;
 STACKTOP = i4;
 return i7 | 0;
}

function _ft_bitmap_glyph_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != 1651078259) {
  i4 = 18;
  return i4 | 0;
 }
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 100 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 104 >> 2];
 i3 = i2 + 156 | 0;
 i1 = i1 + 28 | 0;
 if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] & 1)) {
  _UNITY_FT_Bitmap_Init(i1);
  i4 = _UNITY_FT_Bitmap_Copy(i4, i2 + 76 | 0, i1) | 0;
  return i4 | 0;
 } else {
  i4 = i2 + 76 | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
  HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
  i4 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -2;
  i4 = 0;
  return i4 | 0;
 }
 return 0;
}

function __ZNK21EnlightenSceneMapping27GetTerrainMainChunkSystemIdERiiPiS1_(i1, i4, i6, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i9 = 0, i10 = 0, i11 = 0;
 i9 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i9) {
  i11 = 0;
  return i11 | 0;
 }
 i10 = HEAP32[i1 + 100 >> 2] | 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i10 + (i1 * 12 | 0) >> 2] | 0;
  if ((HEAP32[i3 + ((HEAP32[i5 + (i2 * 56 | 0) >> 2] | 0) * 40 | 0) >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i9 >>> 0) {
   i1 = 0;
   i11 = 9;
   break;
  }
 }
 if ((i11 | 0) == 9) return i1 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i7 | 0) HEAP32[i7 >> 2] = HEAP32[i10 + (i1 * 12 | 0) + 4 >> 2];
 if (!i8) {
  i11 = 1;
  return i11 | 0;
 }
 HEAP32[i8 >> 2] = HEAP32[i10 + (i1 * 12 | 0) + 8 >> 2];
 i11 = 1;
 return i11 | 0;
}

function __ZN7Cubemap7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(164, i1, 16, gb + 1048932 | 0, 0, gb + 400863 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 41748 + 8;
 i2 = i4 + 152 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 156 >> 2] = 0;
 HEAP32[i4 + 160 >> 2] = 0;
 __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i2, 6);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx12NpConstraint13setBreakForceEff(i1, f8, f7) {
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 16 | 0;
 i6 = i1 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i4 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc14ConstraintCore13setBreakForceEff(i1 + 28 | 0, f8, f7);
  return;
 }
 i2 = i1 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 8 >> 2] = f8;
 HEAPF32[i1 + 12 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2;
 return;
}

function __ZN4FMOD7Channel12setLoopCountEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868698;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868698;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868698;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel11getPriorityEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868587;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868587;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868587;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD7Channel11get3DSpreadEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868486;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868486;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868486;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6Reverb11getUserDataEPPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854979;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854979;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound13getMusicSpeedEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868984;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868984;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868984;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN12LightsModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 83592 + 8;
 i3 = i2 + 576 | 0;
 i1 = i2 + 520 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if ((HEAP32[i2 + 536 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 524 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 432 | 0;
 if ((HEAP32[i2 + 448 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 436 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 256 | 0;
 if ((HEAP32[i2 + 272 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 260 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 168 | 0;
 if ((HEAP32[i2 + 184 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 172 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12LightsModuleD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 83592 + 8;
 i3 = i2 + 576 | 0;
 i1 = i2 + 520 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if ((HEAP32[i2 + 536 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 524 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 432 | 0;
 if ((HEAP32[i2 + 448 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 436 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 256 | 0;
 if ((HEAP32[i2 + 272 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 260 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 184 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 168 >> 2] | 0, i2 + 172 | 0);
 __ZdlPv(i2);
 return;
}

function __Z34PlayerPrefs_CUSTOM_TrySetSetStringP12Il2CppStringS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 28 | 0;
 i6 = i3 + 24 | 0;
 i4 = i3 + 12 | 0;
 i5 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 __ZN11ICallStringC2EP12Il2CppString(i6, i2);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i7);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i6);
 i2 = (__ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i4, i5) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z29AudioMixerSendProcessCallbackP21UnityAudioEffectStatePfS1_jii(i5, i8, i9, i2, i3, i4) {
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f6 = f0, i7 = 0, i10 = 0, f11 = f0;
 i10 = HEAP32[i5 + 28 >> 2] | 0;
 i4 = Math_imul(i3, i2) | 0;
 i7 = i10 + 16 | 0;
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(Math_fround(Math_fround(HEAPF32[i10 + 12 >> 2]) - f1) / Math_fround(i4 >>> 0));
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 if (!i4) {
  f6 = f1;
  HEAPF32[i7 >> 2] = f6;
  return 0;
 } else i2 = 0;
 do {
  f11 = Math_fround(HEAPF32[i8 + (i2 << 2) >> 2]);
  HEAPF32[i9 + (i2 << 2) >> 2] = f11;
  f11 = Math_fround(f1 * f11);
  i10 = i3 + (i2 << 2) | 0;
  HEAPF32[i10 >> 2] = Math_fround(f11 + Math_fround(HEAPF32[i10 >> 2]));
  f1 = Math_fround(f6 + f1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 HEAPF32[i7 >> 2] = f1;
 return 0;
}

function _UNITY_FT_Stream_ReadUShortLE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i4 >> 2] = 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 + 1 | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  if (!i5) {
   i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i7 = 6;
  } else {
   if ((mftCall_iiiii(i5 | 0, i3 | 0, i2 | 0, i1 | 0, 2) | 0) != 2) break;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = 6;
  }
  if ((i7 | 0) == 6) {
   i3 = ((HEAPU8[i1 + 1 >> 0] | 0) << 8 | (HEAPU8[i1 >> 0] | 0)) & 65535;
   i1 = i2;
  }
  HEAP32[i6 >> 2] = i1 + 2;
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 85;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function _vswprintf(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 384 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 8 | 0;
 i7 = i9 + 120 | 0;
 i8 = i9;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i3 + -1;
 i1 = i6;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i6 + 75 >> 0] = -1;
 HEAP32[i6 + 36 >> 2] = fb + 497;
 HEAP32[i6 + 48 >> 2] = 256;
 HEAP32[i6 + 44 >> 2] = i7;
 HEAP32[i6 + 76 >> 2] = -1;
 HEAP32[i6 + 84 >> 2] = i8;
 do if (!i3) i1 = -1; else if ((i3 | 0) < 0) {
  HEAP32[(___errno_location() | 0) >> 2] = 75;
  i1 = -1;
  break;
 } else {
  i1 = _vfwprintf(i6, i4, i5) | 0;
  _sw_write(i6, 0, 0) | 0;
  i1 = i1 >>> 0 >= i3 >>> 0 ? -1 : i1;
  break;
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function _do_read_529(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = i6 + 84 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0 ? i5 : gb + 208020 | 0;
 i3 = i6 + 48 | 0;
 i4 = i6 + 44 | 0;
 L1 : do if (!(HEAP32[i3 >> 2] | 0)) i3 = 0; else {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break L1;
   }
   HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = (i2 | 0) < 128 ? i2 & 255 : 64;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
    i3 = i1;
    break;
   }
  }
 } while (0);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i1 + i3;
 HEAP32[i9 >> 2] = i5 + (i3 << 2);
 if ((i8 | 0) != 0 & (i3 | 0) != 0) {
  HEAP32[i2 >> 2] = i1 + 1;
  HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = 1;
 } else i1 = 0;
 return i1 | 0;
}

function _do_read_526(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i9 = i6 + 84 | 0;
 i5 = HEAP32[i9 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0 ? i5 : gb + 208020 | 0;
 i3 = i6 + 48 | 0;
 i4 = i6 + 44 | 0;
 L1 : do if (!(HEAP32[i3 >> 2] | 0)) i3 = 0; else {
  i1 = 0;
  while (1) {
   i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   if (!i2) {
    i3 = i1;
    break L1;
   }
   HEAP8[(HEAP32[i4 >> 2] | 0) + i1 >> 0] = (i2 | 0) < 128 ? i2 & 255 : 64;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) {
    i3 = i1;
    break;
   }
  }
 } while (0);
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i1 + i3;
 HEAP32[i9 >> 2] = i5 + (i3 << 2);
 if ((i8 | 0) != 0 & (i3 | 0) != 0) {
  HEAP32[i2 >> 2] = i1 + 1;
  HEAP8[i7 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = 1;
 } else i1 = 0;
 return i1 | 0;
}

function __ZNK5physx7NpCloth23getSimulationFilterDataEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore23getSimulationFilterDataEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1065, gb + 692380 | 0, i3);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  STACKTOP = i5;
  return;
 }
}

function __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0, f9 = f0, f10 = f0, f11 = f0;
 d8 = +HEAPF64[i2 + 416 >> 3];
 d6 = +HEAPF64[i2 + 424 >> 3];
 d4 = +HEAPF64[i2 + 432 >> 3];
 f9 = Math_fround(HEAPF32[i2 + 500 >> 2]);
 f11 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 36 >> 2]));
 f10 = Math_fround(f9 * Math_fround(HEAPF32[i2 + 40 >> 2]));
 d7 = +Math_fround(f11 * Math_fround(.5));
 d5 = +Math_fround(f10 * Math_fround(.5));
 d3 = +Math_fround(Math_fround(f9 * Math_fround(HEAPF32[i2 + 44 >> 2])) * Math_fround(.5));
 HEAPF64[i1 >> 3] = d8 - d7;
 HEAPF64[i1 + 8 >> 3] = d6 - d5;
 HEAPF64[i1 + 16 >> 3] = d4 - d3;
 HEAPF64[i1 + 24 >> 3] = d8 + d7;
 HEAPF64[i1 + 32 >> 3] = d6 + d5;
 HEAPF64[i1 + 40 >> 3] = d4 + d3;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 496 >> 2];
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj(i5, i3, i2, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE(HEAP32[i5 + 12 >> 2] | 0, i3, i2, i1, i4) | 0;
 if (!i2) {
  i5 = -1;
  STACKTOP = i6;
  return i5 | 0;
 } else i3 = 0;
 while (1) {
  i1 = __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj(i5, HEAP32[i4 + (i3 << 4) >> 2] | 0, HEAP32[i4 + (i3 << 4) + 4 >> 2] | 0, HEAP32[i4 + (i3 << 4) + 8 >> 2] | 0, HEAP32[i4 + (i3 << 4) + 12 >> 2] | 0) | 0;
  i3 = i3 + 2 | 0;
  if ((i1 | 0) != -1) {
   i2 = 4;
   break;
  }
  if (i3 >>> 0 >= i2 >>> 0) {
   i1 = -1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5Umbra15CameraTransform16getWorldToCameraERNS_9Matrix4x4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i2 >> 2] = HEAP32[i1 + 340 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 344 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 348 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 352 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 356 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 360 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 364 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 368 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 372 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 376 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 380 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 384 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 388 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 392 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 396 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 + 400 >> 2];
 return;
}

function __ZNK29ParticleSystemPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (HEAP8[i2 + 15 >> 0] | 0) {
  i7 = -1;
  return i7 | 0;
 }
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i7;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 4) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 return i8 | 0;
}

function __ZNK14ParticleSystem10IsEmittingEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, f6 = f0, d7 = 0.0;
 i2 = i5 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 13 >> 0] | 0) {
  i5 = 0;
  return i5 | 0;
 }
 if (HEAP8[i1 + 30 >> 0] | 0) {
  d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i2 >> 2] | 0;
  d3 = +HEAPF64[i1 + 40 >> 3];
  i2 = HEAP32[i5 + 36 >> 2] | 0;
  if (!(HEAP8[i2 + 277 >> 0] | 0)) {
   d7 = d4 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 264 >> 2]);
   if (d7 > +Math_fround(f6 + Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2]))) {
    i5 = 0;
    return i5 | 0;
   }
  }
  if (HEAP8[i1 + 13 >> 0] | 0) if (d4 - d3 > +Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2])) {
   i5 = 0;
   return i5 | 0;
  }
 }
 i5 = (HEAP32[i1 + 8 >> 2] | 0) == 1;
 return i5 | 0;
}

function __ZN5physx3Tri4neibEii(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = (i1 | 0) == (i5 | 0);
 if (i4) if ((HEAP32[i7 + 4 >> 2] | 0) == (i6 | 0)) i1 = 2; else i2 = 4; else i2 = 4;
 do if ((i2 | 0) == 4) {
  i2 = (i1 | 0) == (i6 | 0);
  i3 = HEAP32[i7 + 4 >> 2] | 0;
  if (i2 & (i3 | 0) == (i5 | 0)) i1 = 2; else {
   if ((i3 | 0) == (i5 | 0)) if ((HEAP32[i7 + 8 >> 2] | 0) == (i6 | 0)) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i7 + 8 >> 2] | 0;
   if ((i3 | 0) == (i6 | 0) & (i1 | 0) == (i5 | 0)) i1 = 0; else {
    if (!((i1 | 0) != (i5 | 0) | i2 ^ 1)) {
     i1 = 1;
     break;
    }
    if ((i1 | 0) != (i6 | 0) | i4 ^ 1) {
     i7 = gb + 110160 | 0;
     return i7 | 0;
    } else i1 = 1;
   }
  }
  i7 = i7 + 12 + (i1 << 2) | 0;
  return i7 | 0;
 } while (0);
 i7 = i7 + 12 + (i1 << 2) | 0;
 return i7 | 0;
}

function __ZN5physx3Ext20ProfileZoneInterfaceD2Ev(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 HEAP32[i8 >> 2] = gb + 87192 + 8;
 i9 = i8 + 8 | 0;
 i1 = HEAP32[i8 + 28 >> 2] | 0;
 if (i1 | 0) {
  i7 = i8 + 44 | 0;
  if (HEAP32[i7 >> 2] | 0) {
   _memset(HEAP32[i8 + 20 >> 2] | 0, -1, i1 << 2 | 0) | 0;
   i6 = i8 + 24 | 0;
   i2 = HEAP32[i6 >> 2] | 0;
   i5 = i2 + -1 | 0;
   i4 = i8 + 16 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
   if (i5) {
    i3 = 0;
    while (1) {
     i2 = i3 + 1 | 0;
     i1 = HEAP32[i4 >> 2] | 0;
     HEAP32[i1 + (i3 << 2) >> 2] = i2;
     if ((i2 | 0) == (i5 | 0)) break; else i3 = i2;
    }
    i2 = HEAP32[i6 >> 2] | 0;
   }
   HEAP32[i1 + (i2 + -1 << 2) >> 2] = -1;
   HEAP32[i8 + 36 >> 2] = 0;
   HEAP32[i7 >> 2] = 0;
  }
 }
 i1 = HEAP32[i9 >> 2] | 0;
 if (!i1) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i9, i1);
 return;
}

function __ZN5physx23PxCapsuleControllerDesc12setToDefaultEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 1060437492;
 HEAP32[i1 + 56 >> 2] = 1036831949;
 HEAP32[i1 + 60 >> 2] = 1056964608;
 HEAP32[i1 + 64 >> 2] = 1092616192;
 HEAP32[i1 + 68 >> 2] = 1061997773;
 HEAP32[i1 + 72 >> 2] = 1069547520;
 i2 = i1 + 76 | 0;
 HEAP32[i1 + 100 >> 2] = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN4FMOD6Reverb11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854655;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854655;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound12getLoopCountEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868526;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868526;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868526;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN20IntermediateRendererD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 33532 + 8;
 i2 = i1 + 236 | 0;
 i3 = (HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i2 >> 1] = i3;
 HEAP8[i2 + 2 >> 0] = i3 >>> 16;
 i2 = i1 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z32getPxVehicleDriveNWMDriveSimDataPKN5physx16PxVehicleDriveNWE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 288 >> 2] | 0;
 _memcpy(i1 | 0, i2 + 224 | 0, i3 << 3 | 0) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 i3 = i1 + 80 | 0;
 i4 = i2 + 304 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i1 + 112 | 0, i2 + 336 | 0, 416) | 0;
 i1 = i1 + 528 | 0;
 i2 = i2 + 752 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z30GameObject_CUSTOM_GetComponentP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP8[i3 + 12 >> 0] = 0;
  HEAP8[i3 + 13 >> 0] = 1;
  HEAP8[i3 + 14 >> 0] = 1;
  HEAP32[i3 + 16 >> 2] = 0;
  i4 = i3 + 20 | 0;
  HEAP16[i4 >> 1] = 257;
  HEAP8[i4 + 2 >> 0] = 1;
  HEAP32[i3 + 4 >> 2] = i2;
  i4 = __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs(i3) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z28TextMesh_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN20TextRenderingPrivate8TextMesh7SetTextERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z28AudioMixer_CUSTOM_ClearFloatP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  i3 = (mftCall_iii(i2 | 0, i1 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i5, 4);
  i7 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 } else {
  i7 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i7;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i1 >> 2] = i7;
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 4, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   i1 = i1 + 16 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 16 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5Umbra13MatrixFactory10frustumInfEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i5 = i1 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i5 = i1 + 48 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 f2 = Math_fround(Math_fround(1.0) / Math_fround(+Math_tan(+Math_fround(Math_fround(f2 * Math_fround(3.14159274)) / Math_fround(360.0)))));
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAPF32[i1 + 40 >> 2] = Math_fround(f4 + Math_fround(-1.0));
 HEAPF32[i1 + 44 >> 2] = Math_fround(Math_fround(f4 + Math_fround(-2.0)) * f3);
 HEAPF32[i1 + 56 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(0.0);
 return;
}

function __ZN4Mesh19GetVertexBufferDataER16VertexBufferData(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i1 + 32 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 i2 = i5 + 32 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 40 | 0;
 i4 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 80 >> 2] = HEAP32[i4 + 92 >> 2];
 HEAP32[i5 + 84 >> 2] = HEAP32[i4 + 104 >> 2];
 HEAP32[i5 + 88 >> 2] = HEAP32[i4 + 100 >> 2];
 return;
}

function __ZN4FMOD5Sound12setLoopCountEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868698;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868698;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868698;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP13getNumOutputsEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868784;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868784;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868784;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN18DelayedCallManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 391247 | 0, 23) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 37632 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = i2;
 HEAP32[i4 + 44 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = i2;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE12EnsureBufferEj(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = i2 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) i4 = 7; else {
  if ((HEAP32[i1 + 8 >> 2] | 0) >>> 0 >= i5 >>> 0) {
   i6 = __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i1) | 0;
   i1 = HEAP32[i3 >> 2] | 0;
   if (!i6) {
    if (!i1) {
     i4 = 7;
     break;
    }
    i2 = i2 + 32 | 0;
    break;
   }
  }
  __ZN14DataBufferGLES7ReleaseEv(i1);
  HEAP32[i3 >> 2] = 0;
  i4 = 7;
 } while (0);
 if ((i4 | 0) == 7) {
  i1 = __Z20GetBufferManagerGLESv() | 0;
  i2 = i2 + 32 | 0;
  i1 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(i1, i5, HEAP32[i2 >> 2] | 0, 0) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 if ((HEAP32[i2 >> 2] | 0) != 3) return;
 __ZN14DataBufferGLES13EnsureStorageEi(i1, i5);
 return;
}

function __Z8pqInsertP9TESSallocP9PriorityQPv(i2, i1, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 if (HEAP32[i1 + 20 >> 2] | 0) {
  i9 = __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv(i2, HEAP32[i1 >> 2] | 0, i8) | 0;
  return i9 | 0;
 }
 i3 = i1 + 12 | 0;
 i9 = HEAP32[i3 >> 2] | 0;
 i7 = i9 + 1 | 0;
 HEAP32[i3 >> 2] = i7;
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i7 | 0) < (i4 | 0)) i1 = HEAP32[i1 + 4 >> 2] | 0; else {
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i5) {
   i9 = 268435455;
   return i9 | 0;
  }
  i6 = i1 + 4 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i3 >> 2] = i4 << 1;
  i1 = mftCall_iiii(i5 | 0, HEAP32[i2 + 12 >> 2] | 0, i7 | 0, i4 << 3 | 0) | 0;
  HEAP32[i6 >> 2] = i1;
  if (!i1) {
   HEAP32[i6 >> 2] = i7;
   i9 = 268435455;
   return i9 | 0;
  }
 }
 HEAP32[i1 + (i9 << 2) >> 2] = i8;
 i9 = ~i9;
 return i9 | 0;
}

function __Z8memset32Pvjy(i5, i3, i6, i7) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 HEAP32[i8 >> 2] = i3;
 i4 = i6 & -4;
 if ((i4 | 0) == 0 & (i7 | 0) == 0) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = 0;
  i2 = 0;
  do {
   HEAP32[i5 + i1 >> 2] = i3;
   i1 = _i64Add(i1 | 0, i2 | 0, 4, 0) | 0;
   i2 = getTempRet0() | 0;
  } while (i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i4 >>> 0);
 }
 if (!(i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i6 >>> 0)) {
  STACKTOP = i9;
  return;
 }
 do {
  HEAP8[i5 + i1 >> 0] = HEAP8[i8 + (i1 & 4) >> 0] | 0;
  i1 = _i64Add(i1 | 0, i2 | 0, 1, 0) | 0;
  i2 = getTempRet0() | 0;
 } while (i2 >>> 0 < i7 >>> 0 | (i2 | 0) == (i7 | 0) & i1 >>> 0 < i6 >>> 0);
 STACKTOP = i9;
 return;
}

function __Z40ParticleSystem_MainModule_CUSTOM_SetLoopP12Il2CppObjecth(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN14ParticleSystem7SetLoopEb(i1, i2 << 24 >> 24 != 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  STACKTOP = i4;
  return;
 }
}

function __Z18ConvertUTF16toUTF8RK13dynamic_arrayItLj2EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 4 | 0;
 i7 = i3;
 i4 = i1 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i2, HEAP32[i4 >> 2] << 2, 0);
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i7 >> 2] = i6;
 i1 = (__Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags(i7, i6 + (i1 << 1) | 0, i5, i4 + (i1 << 2) | 0, 1) | 0) == 3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i2, i1 ? 0 : (HEAP32[i5 >> 2] | 0) - i4 | 0, 0);
 STACKTOP = i3;
 return i1 ^ 1 | 0;
}

function __Z14SetReflectionsR13BatchRendererRK16ReflectionSample(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i4 = i6 + 4 | 0;
 i5 = i6;
 if (HEAP32[i2 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i2);
 __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample(i2, i3);
 HEAP32[i4 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i2, 19, 4, 0, i1);
 HEAP32[i5 >> 2] = HEAP32[i3 + 84 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID(i2, 20, 4, 0, i1);
 STACKTOP = i6;
 return;
}

function _UNITY_FT_Stream_ReadUShort(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 HEAP32[i4 >> 2] = 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 do if ((i2 + 1 | 0) >>> 0 < (HEAP32[i3 + 4 >> 2] | 0) >>> 0) {
  i5 = HEAP32[i3 + 20 >> 2] | 0;
  if (!i5) {
   i1 = (HEAP32[i3 >> 2] | 0) + i2 | 0;
   if (!i1) {
    i3 = 0;
    i1 = i2;
   } else i7 = 6;
  } else {
   if ((mftCall_iiiii(i5 | 0, i3 | 0, i2 | 0, i1 | 0, 2) | 0) != 2) break;
   i2 = HEAP32[i6 >> 2] | 0;
   i7 = 6;
  }
  if ((i7 | 0) == 6) {
   i3 = ((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0)) & 65535;
   i1 = i2;
  }
  HEAP32[i6 >> 2] = i1 + 2;
  i7 = i3;
  STACKTOP = i8;
  return i7 | 0;
 } while (0);
 HEAP32[i4 >> 2] = 85;
 i7 = 0;
 STACKTOP = i8;
 return i7 | 0;
}

function _sw_write(i1, i3, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 84 >> 2] | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i4 = 3; else if ((_sw_write(i1, i2, (HEAP32[i1 + 20 >> 2] | 0) - i2 | 0) | 0) == -1) i1 = -1; else i4 = 3;
 if ((i4 | 0) == 3) {
  i5 = i7 + 4 | 0;
  L5 : do if ((i6 | 0) != 0 & (HEAP32[i5 >> 2] | 0) != 0) {
   i2 = i3;
   i3 = i6;
   i4 = HEAP32[i7 >> 2] | 0;
   while (1) {
    i1 = _mbtowc(i4, i2, i3) | 0;
    if ((i1 | 0) <= -1) break L5;
    i3 = i3 - i1 | 0;
    i8 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
    HEAP32[i5 >> 2] = i8;
    i4 = (HEAP32[i7 >> 2] | 0) + 4 | 0;
    HEAP32[i7 >> 2] = i4;
    if (!((i3 | 0) != 0 & (i8 | 0) != 0)) break; else i2 = i2 + i1 | 0;
   }
  } else i1 = 0; while (0);
  HEAP32[HEAP32[i7 >> 2] >> 2] = 0;
  i1 = (i1 | 0) < 0 ? i1 : i6;
 }
 return i1 | 0;
}

function _modff(f1, i4) {
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i5 >>> 23 & 255;
 i3 = i2 + -127 | 0;
 do if ((i3 | 0) > 22) {
  HEAPF32[i4 >> 2] = f1;
  if ((i5 & 8388607 | 0) == 0 | (i3 | 0) != 128) f1 = (HEAP32[tempDoublePtr >> 2] = i5 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 } else {
  if (i2 >>> 0 < 127) {
   HEAP32[i4 >> 2] = i5 & -2147483648;
   break;
  }
  i2 = 8388607 >>> i3;
  if (!(i2 & i5)) {
   HEAPF32[i4 >> 2] = f1;
   f1 = (HEAP32[tempDoublePtr >> 2] = i5 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   break;
  } else {
   i5 = i5 & ~i2;
   f6 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   HEAP32[i4 >> 2] = i5;
   f1 = Math_fround(f1 - f6);
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZNK5physx2Sc9ClothCore20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 268 >> 2] | 0, i2 | 0) | 0;
 if (!i2) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4 + (i2 << 4);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 mftCall_viii(i8 | 0, i7 | 0, i1 | 0, i5 | 0);
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN8LODGroup10DeactivateE19DeactivateOperation(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i7 = i2 + 88 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i3) {
  i5 = i2 + 76 | 0;
  i4 = 0;
  i1 = i3;
  do {
   i2 = (HEAP32[i5 >> 2] | 0) + (i4 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i6 >> 2] = -1;
 return;
}

function __ZN4FMOD7Channel9getVolumeEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868630;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868630;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868630;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE(i3, i1, i7, i2, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i1 = __ZN4FMOD7SystemI7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE(i2, 0, i7, 0, i8) | 0;
  if (!i1) {
   i8 = 0;
   STACKTOP = i6;
   return i8 | 0;
  }
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = gb + 865085;
  _printf(gb + 853343 | 0, i5) | 0;
  i8 = i1;
  STACKTOP = i6;
  return i8 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 865085;
 _printf(gb + 853184 | 0, i4) | 0;
 i8 = 36;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN4FMOD6System11getDSPClockEPjS1_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i3 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  d2 = +__Z19GetTimeSinceStartupv() * 44100.0;
  i1 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
  if (i5 | 0) HEAP32[i5 >> 2] = i1;
  if (!i6) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  HEAP32[i6 >> 2] = ~~d2 >>> 0;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 860458;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD3DSP12getNumInputsEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 857578;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 857578;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857578;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI13RectTransform27SendReapplyDrivenPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 248 | 0;
 i2 = i5;
 i3 = i5 + 240 | 0;
 if (!(__Z25IsManagerContextAvailablei(5) | 0)) {
  STACKTOP = i5;
  return;
 }
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 292 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i2, i4);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i2, __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i2, i4, 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN20OcclusionCullingDataC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 34876 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN19ParticleSystemState4TickERK27ParticleSystemReadOnlyStatef(i5, i6, f2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i4 = 0, i7 = 0, f8 = f0, i9 = 0;
 i7 = i5 + 396 | 0;
 f8 = Math_fround(Math_fround(HEAPF32[i7 >> 2]) + f2);
 HEAPF32[i7 >> 2] = f8;
 i4 = HEAP32[i5 + 460 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i3 = HEAP32[i5 + 456 >> 2] | 0;
  i1 = 0;
  do {
   i9 = i3 + (i1 * 112 | 0) + 108 | 0;
   HEAPF32[i9 >> 2] = Math_fround(Math_fround(HEAPF32[i9 >> 2]) + f2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 i1 = i6 + 264 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(HEAP8[i6 + 277 >> 0] | 0)) {
  i9 = f2 < Math_fround(HEAPF32[i7 >> 2]);
  HEAP32[i7 >> 2] = HEAP32[(i9 ? i1 : i7) >> 2];
  return;
 }
 if (!(f8 > f2)) return;
 HEAPF32[i7 >> 2] = Math_fround(f8 - f2);
 i9 = i5 + 48 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + 1;
 return;
}

function __ZN18GlslGpuProgramGLES10FillParamsEjR20GpuProgramParametersP16PropertyNamesSet(i1, i2, i5, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if (!i2) return;
 if (!(HEAP8[i1 + 84 >> 0] | 0)) i3 = (HEAP8[i1 + 85 >> 0] | 0) != 0; else i3 = 1;
 __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(HEAP32[gb + 1451096 >> 2] | 0, i2, i3, HEAP32[i1 + 96 >> 2] | 0);
 __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet(i2, i5, i4);
 i3 = i5 + 80 | 0;
 i5 = (HEAP32[i5 + 84 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i2 = (i5 | 0) / 52 | 0;
 if ((i5 | 0) <= 0) return;
 i1 = 0;
 do {
  i4 = __Z16GetRealGfxDevicev() | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 212 >> 2] | 0, i4 | 0, HEAP32[i5 + (i1 * 52 | 0) >> 2] | 0, HEAP32[i5 + (i1 * 52 | 0) + 24 >> 2] | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN18CapsuleCast2DQuery19InitializeCastShapeEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, i4 = 0;
 f2 = Math_fround(HEAPF32[i3 + 552 >> 2]);
 i4 = f2 > Math_fround(.0000999999974);
 f2 = i4 ? f2 : Math_fround(.0000999999974);
 f1 = Math_fround(HEAPF32[i3 + 556 >> 2]);
 i4 = f1 > Math_fround(.0000999999974);
 f1 = i4 ? f1 : Math_fround(.0000999999974);
 if (!(HEAP32[i3 + 560 >> 2] | 0)) {
  f1 = Math_fround(f1 - f2);
  i4 = f1 > Math_fround(.0000999999974);
  __ZN14b2CapsuleShape13SetByExtentsYEff(i3 + 372 | 0, Math_fround(f2 * Math_fround(.5)), i4 ? f1 : Math_fround(.0000999999974));
  i4 = i3 + 372 | 0;
  return i4 | 0;
 } else {
  f2 = Math_fround(f2 - f1);
  i4 = f2 > Math_fround(.0000999999974);
  __ZN14b2CapsuleShape13SetByExtentsYEff(i3 + 372 | 0, Math_fround(f1 * Math_fround(.5)), i4 ? f2 : Math_fround(.0000999999974));
  i4 = i3 + 372 | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN11BoxCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 16 | 0;
 i8 = i2;
 HEAP32[i3 >> 2] = 3;
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 i6 = i3 + 8 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i5 = i3 + 12 | 0;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i4 = i1 + 36 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, i3 | 0) | 0;
 __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i8, i1, gb + 62512 | 0);
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = HEAP32[i8 + 8 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 >> 2] = i7;
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[i4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN10DynamicVBO12ReleaseChunkER21DynamicVBOChunkHandlejj(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 i7 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i5 | 0, 0) | 0;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 i3 = i7 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((HEAP32[i7 + 16 >> 2] | 0) == 2) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 480 >> 0] | 0)) {
  __ZN10DynamicVBO19FillQuadIndexBufferER21DynamicVBOChunkHandle(i4, i5);
  i1 = i4 + 4 | 0;
  i2 = i4 + 20 | 0;
  if ((HEAP32[i2 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 8 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i5 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 return;
}

function __Z39MaterialPropertyBlock_CUSTOM_SetTextureP12Il2CppObjectiS0_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i5 = i8;
 i6 = i8 + 12 | 0;
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517805 | 0, i5);
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517805 | 0, i5);
 HEAP32[i6 >> 2] = i3;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7); else {
  __ZN19ShaderPropertySheet30SetTextureWithNoScaleAndOffsetERKN9ShaderLab16FastPropertyNameEP7Texture(i1, i6, i4);
  STACKTOP = i8;
  return;
 }
}

function _UNITY_FT_GlyphLoader_Reset(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 24 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 28 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 32 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 40 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 52 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i2 = i1 + 20 | 0;
 HEAP16[i1 + 22 >> 1] = 0;
 HEAP16[i2 >> 1] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 i1 = i1 + 56 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwjj(i2, i5, i4, i7) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i6 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = i1 & 255;
  i3 = i2;
 }
 i1 = i3 + ((i1 >>> 0 > i4 >>> 0 ? i4 + 1 | 0 : i1) << 2) | 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) {
   i6 = -1;
   break;
  }
  i1 = i1 + -4 | 0;
  __THREW__ = 0;
  i2 = invoke_iiii(fb + 514 | 0, i5 | 0, i7 | 0, i1 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i8 = 8;
   break;
  }
  if (!i2) {
   i8 = 9;
   break;
  }
 }
 if ((i8 | 0) == 8) {
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 } else if ((i8 | 0) == 9) i6 = i1 - i3 >> 2;
 return i6 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i6, i5 << 3, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834127;
 HEAP32[i1 + 4 >> 2] = 663;
 HEAP32[i1 + 8 >> 2] = fb + 3940;
 HEAP32[i1 + 12 >> 2] = fb + 3941;
 HEAP32[i1 + 16 >> 2] = gb + 834138;
 HEAP32[i1 + 20 >> 2] = 664;
 HEAP32[i1 + 24 >> 2] = fb + 3942;
 HEAP32[i1 + 28 >> 2] = fb + 3943;
 HEAP32[i1 + 32 >> 2] = gb + 834148;
 HEAP32[i1 + 36 >> 2] = 665;
 HEAP32[i1 + 40 >> 2] = fb + 3944;
 HEAP32[i1 + 44 >> 2] = fb + 3945;
 HEAP32[i1 + 48 >> 2] = gb + 834159;
 HEAP32[i1 + 52 >> 2] = 666;
 HEAP32[i1 + 56 >> 2] = fb + 3946;
 HEAP32[i1 + 60 >> 2] = fb + 3947;
 HEAP32[i1 + 64 >> 2] = gb + 834171;
 HEAP32[i1 + 68 >> 2] = 669;
 HEAP32[i1 + 72 >> 2] = fb + 3948;
 HEAP32[i1 + 76 >> 2] = fb + 3949;
 HEAP32[i1 + 80 >> 2] = gb + 834180;
 HEAP32[i1 + 84 >> 2] = 670;
 HEAP32[i1 + 88 >> 2] = fb + 3950;
 HEAP32[i1 + 92 >> 2] = fb + 3951;
 return;
}

function __ZN4FMOD7Channel8getIndexEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868498;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868498;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868498;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6Reverb9getActiveEPb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 862463;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 862463;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862463;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854655;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854655;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE16FrameMaintenanceEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i2 + 44 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 HEAP32[i5 + 12 >> 2] = 0;
 i6 = i5 + 4 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i7 = i5 + 16 | 0;
  i1 = 0;
  do {
   i8 = HEAP32[i7 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 HEAP32[i6 >> 2] = 0;
 if (!i3) return;
 i8 = HEAP32[i4 >> 2] | 0;
 i7 = HEAP32[i8 + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0);
 return;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 96 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15DirectorManager14OnExitPlayModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN15DirectorManager32StopScheduledPlayableControllersEv(i1);
 __ZN15DirectorManager23DestroyPendingPlayablesEv(0);
 i3 = i1 + 404 | 0;
 i2 = i1 + 408 | 0;
 __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 416 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 420 | 0;
 i3 = i1 + 436 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  i2 = i1 + 432 | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 424 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 432 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags(i5, i2, i3, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri(i5, i3, gb + 469135 | 0, i1) | 0)) {
  HEAP32[i2 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i5 + 120 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i3;
 if (!i3) i1 = 0; else i1 = (HEAP32[i5 + 108 >> 2] | 0) + ((i1 + -2 | 0) * 12 | 0) | 0;
 HEAP32[i5 + 84 >> 2] = i1;
 i2 = i5 + 100 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + -1 | 0;
 HEAP32[i2 >> 2] = i3;
 if (!i3) i1 = 0; else i1 = (HEAP32[i5 + 88 >> 2] | 0) + (i1 + -2 << 5) | 0;
 HEAP32[i5 + 80 >> 2] = i1;
 HEAP8[i5 + 128 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZN14PlayerSettings22SetAutoRotationAllowedEib(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i1 | 0) {
 case 0:
  {
   HEAP8[i3 + 377 >> 0] = i2 & 1;
   break;
  }
 case 1:
  {
   HEAP8[i3 + 378 >> 0] = i2 & 1;
   break;
  }
 case 2:
  {
   HEAP8[i3 + 379 >> 0] = i2 & 1;
   break;
  }
 case 3:
  {
   HEAP8[i3 + 380 >> 0] = i2 & 1;
   break;
  }
 default:
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 452971 | 0, 0, gb + 452899 | 0, 338, 1, 0, 0, 0);
 }
 i1 = i3 + 377 | 0;
 if (HEAP8[i1 >> 0] | 0) return;
 i2 = HEAP16[i3 + 378 >> 1] | 0;
 if (!((i2 & 255) << 24 >> 24 == 0 & (i2 & 65535) < 256)) return;
 if (HEAP8[i3 + 380 >> 0] | 0 ? 1 : (HEAP32[i3 + 284 >> 2] | 0) != 4) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 453006 | 0, 0, gb + 452899 | 0, 349, 1, 0, 0, 0);
 HEAP8[i1 >> 0] = 1;
 return;
}

function __GLOBAL__sub_I_UnityAdsSettings_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[gb + 1468928 >> 2] = 0;
 HEAP32[gb + 1468928 + 4 >> 2] = 0;
 HEAP32[gb + 1468928 + 8 >> 2] = 0;
 i2 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1468928 + 12 >> 2] = i2;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(16, 16, i1, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[gb + 1468928 >> 2] = i1;
 HEAP32[gb + 1468928 + 8 >> 2] = -2147483632;
 HEAP32[gb + 1468928 + 4 >> 2] = 15;
 i2 = i1;
 i4 = gb + 1041896 | 0;
 i5 = i2 + 15 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i4 = i4 + 1 | 0;
 } while ((i2 | 0) < (i5 | 0));
 HEAP8[i1 + 15 >> 0] = 0;
 STACKTOP = i3;
 return;
}

function _UNITY_png_read_rows(i6, i1, i2, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i6) return;
 i3 = (i1 | 0) != 0;
 i4 = (i2 | 0) != 0;
 i5 = (i7 | 0) != 0;
 if (i3 & i4) {
  if (i5) i3 = 0; else return;
  while (1) {
   _UNITY_png_read_row(i6, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i7 | 0)) break; else {
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   }
  }
  return;
 }
 if (i3) {
  if (i5) i2 = 0; else return;
  while (1) {
   _UNITY_png_read_row(i6, HEAP32[i1 >> 2] | 0, 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 4 | 0;
  }
  return;
 } else {
  if (i4 & i5) {
   i1 = i2;
   i2 = 0;
  } else return;
  while (1) {
   _UNITY_png_read_row(i6, 0, HEAP32[i1 >> 2] | 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + 4 | 0;
  }
  return;
 }
}

function _jpeg_save_markers(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = HEAP32[i4 + 404 >> 2] | 0;
 i2 = (HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 48 >> 2] | 0) + -20 | 0;
 i2 = (i2 | 0) < (i1 | 0) ? i2 : i1;
 i1 = (i5 | 0) == 224;
 if (!i2) {
  i3 = i1 | (i5 | 0) == 238 ? fb + 1557 | 0 : fb + 1556 | 0;
  i1 = 0;
 } else if (i1 & i2 >>> 0 < 14) {
  i3 = fb + 1565 | 0;
  i1 = 14;
 } else {
  i3 = fb + 1565 | 0;
  i1 = (i5 | 0) == 238 & i2 >>> 0 < 12 ? 12 : i2;
 }
 if ((i5 | 0) == 254) {
  HEAP32[i6 + 24 >> 2] = i3;
  HEAP32[i6 + 92 >> 2] = i1;
  return;
 }
 if ((i5 & -16 | 0) == 224) {
  i5 = i5 + -224 | 0;
  HEAP32[i6 + 28 + (i5 << 2) >> 2] = i3;
  HEAP32[i6 + 96 + (i5 << 2) >> 2] = i1;
  return;
 } else {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 68;
  HEAP32[i6 + 24 >> 2] = i5;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i4 | 0);
  return;
 }
}

function __ZN5physx10NpMaterialC2ERKNS_2Sc12MaterialCoreE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP16[i2 + 4 >> 1] = 8;
 HEAP16[i2 + 6 >> 1] = 3;
 HEAP32[i2 >> 2] = gb + 93588 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = gb + 93676 + 8;
 HEAP32[i2 + 16 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 93280 + 8;
 HEAP32[i3 >> 2] = gb + 93280 + 108;
 i3 = i2 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP16[i2 + 44 >> 1] = HEAP16[i1 + 12 >> 1] | 0;
 i3 = i2 + 46 | 0;
 i5 = i1 + 14 | 0;
 i5 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 HEAP8[i3 >> 0] = i5;
 HEAP8[i3 + 1 >> 0] = i5 >> 8;
 i3 = i2 + 48 | 0;
 i5 = i1 + 16 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 44 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18ProceduralMaterial7SetSizeEii(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i5 = i2 + 112 | 0;
 HEAP32[i5 >> 2] = i1;
 i4 = i2 + 116 | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i7, gb + 432369 | 0, 11);
 i1 = __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i7) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 HEAPF32[i1 + 68 >> 2] = Math_fround(HEAP32[i5 >> 2] | 0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(HEAP32[i4 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZN16ScriptingManager24GetAssemblyNameForCSharpEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 12 | 0;
 i4 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 465909 | 0, 6);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
 __ZN16ScriptingManager15GetAssemblyNameENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_(i2, 0, i3, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return;
}

function __ZN12UserListNode5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 i7 = i1 + 4 | 0;
 i5 = i1 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + -1 | 0;
 if ((i3 | 0) != (i4 | 0)) {
  i1 = i2 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i9 = i2 + (i3 << 3) | 0;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i2 = i2 + (i4 << 3) | 0;
  HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i2 + 4 >> 2] = i8;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i1 + (i3 << 3) | 0;
  i1 = HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0;
  if ((i1 | 0) == -1) i1 = (HEAP32[i2 >> 2] | 0) + 4 | 0; else i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i6 >> 2] = i1 + -1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 L1 : do if ((i1 | 0) != (i3 | 0)) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 104:
   {
    i4 = i1 + 1 | 0;
    i2 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i4, i3) | 0;
    if ((i2 | 0) == (i4 | 0) | (i2 | 0) == (i3 | 0)) break L1;
    return ((HEAP8[i2 >> 0] | 0) == 95 ? i2 + 1 | 0 : i1) | 0;
   }
  case 118:
   break;
  default:
   break L1;
  }
  i4 = i1 + 1 | 0;
  i2 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i4, i3) | 0;
  if (!((i2 | 0) == (i4 | 0) | (i2 | 0) == (i3 | 0))) if ((HEAP8[i2 >> 0] | 0) == 95) {
   i4 = i2 + 1 | 0;
   i2 = __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i4, i3) | 0;
   if (!((i2 | 0) == (i4 | 0) | (i2 | 0) == (i3 | 0))) i1 = (HEAP8[i2 >> 0] | 0) == 95 ? i2 + 1 | 0 : i1;
  }
 } while (0);
 return i1 | 0;
}

function __Z17GetCachingManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1162488 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __Znwj(12) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 8 | 0;
 HEAP8[i5 >> 0] = 0;
 i4 = i2 + 9 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZN14CachingManager7DisposeEv(i2);
 __Z39GetDefaultApplicationIdentifierForCachev(i1);
 HEAP32[i2 >> 2] = 1;
 __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb(i2, i1, -1, 2147483647, 0);
 __ZN14CachingManager15ClearTempFolderEv(0);
 HEAP8[i5 >> 0] = 1;
 HEAP8[i4 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 HEAP32[gb + 1162488 >> 2] = i2;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5Unity11AdjTriangle14OppositeVertexEjj(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i2 = (i6 | 0) == (i4 | 0);
 if (i2) if ((HEAP32[i3 + 4 >> 2] | 0) == (i5 | 0)) {
  i6 = HEAP32[i3 + 8 >> 2] | 0;
  return i6 | 0;
 }
 i1 = (i6 | 0) == (i5 | 0);
 if (i1) if ((HEAP32[i3 + 4 >> 2] | 0) == (i4 | 0)) {
  i6 = HEAP32[i3 + 8 >> 2] | 0;
  return i6 | 0;
 }
 if (i2) if ((HEAP32[i3 + 8 >> 2] | 0) == (i5 | 0)) {
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  return i6 | 0;
 }
 if (i1) if ((HEAP32[i3 + 8 >> 2] | 0) == (i4 | 0)) {
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  return i6 | 0;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) if ((HEAP32[i3 + 8 >> 2] | 0) == (i5 | 0)) return i6 | 0;
 if ((i1 | 0) == (i5 | 0)) return ((HEAP32[i3 + 8 >> 2] | 0) == (i4 | 0) ? i6 : -1) | 0; else {
  i6 = -1;
  return i6 | 0;
 }
 return 0;
}

function __ZN4FMOD7Channel6getPanEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868568;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868568;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868568;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN25ThreadsafeLinearAllocator16FrameMaintenanceEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = i4 + 60 | 0;
 i3 = ((HEAP32[i2 >> 2] | 0) + 1 | 0) % 4 | 0;
 i7 = i4 + 64 + (i3 << 2) | 0;
 i6 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 if ((i6 | 0) > 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 364904 | 0, 0, gb + 365015 | 0, 370, 512, 0, 0, 0);
 HEAP32[i2 >> 2] = i3;
 if (!i1) return;
 i3 = i4 + 40 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) return;
 i2 = HEAP32[i4 + 32 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i3 >> 2] | 0)) {
   i5 = 9;
   break;
  }
 }
 if ((i5 | 0) == 9) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 365103 | 0, 0, gb + 365015 | 0, 382, 512, 0, 0, 0);
 return;
}

function __ZN14NavMeshManager16UpdatePostScriptEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1459200 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459200 | 0, i1);
  i3 = gb + 1459200 | 0;
 } else i3 = 0;
 __ZN14NavMeshManager22UpdateNavMeshObstaclesEv(i4);
 i1 = i4 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN14NavMeshCarving14PrepareCarvingEv(i2);
  __ZN14NavMeshCarving5CarveEv(HEAP32[i1 >> 2] | 0);
  if (!(__Z14IsWorldPlayingv() | 0)) __ZN14NavMeshCarving17ApplyCarveResultsEv(HEAP32[i1 >> 2] | 0);
 }
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i5;
 return;
}

function __ZN14DetailDatabase16CleanupPrototypeER15DetailPrototypeRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i4 + 76 >> 2] | 0;
 i2 = i4 + 80 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~(((i3 + -12 - i1 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i1 = HEAP32[i4 + 100 >> 2] | 0;
 i2 = i4 + 104 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -8 - i1 | 0) >>> 3) << 3);
 i1 = HEAP32[i4 + 112 >> 2] | 0;
 i2 = i4 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 i3 = HEAP32[i4 + 124 >> 2] | 0;
 i1 = i4 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i2 + (~((i2 + -2 - i3 | 0) >>> 1) << 1);
 return;
}

function __ZN12_GLOBAL__N_113ClassDescImplD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148256 + 8;
 HEAP32[i1 + 120 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 140 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 124 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 132 >> 2] | 0);
 }
 HEAP32[i1 + 96 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 108 >> 2] | 0);
 }
 HEAP32[i1 + 72 >> 2] = gb + 148320 + 8;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 84 >> 2] | 0);
 return;
}

function __ZN12CachedReader11SetPositionEj(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i6, i7, 0);
 if (HEAP8[i6 + 32 >> 0] | 0) return;
 i4 = i6 + 20 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = (i7 >>> 0) / (i2 >>> 0) | 0;
 i5 = i6 + 16 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) i3 = i6 + 4 | 0; else {
  i1 = i6 + 12 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0);
  i2 = (i7 >>> 0) / ((HEAP32[i4 >> 2] | 0) >>> 0) | 0;
  HEAP32[i5 >> 2] = i2;
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = i6 + 4 | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i6 + 8 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i7 = i7 - (Math_imul(i2, i1) | 0) | 0;
 HEAP32[i6 >> 2] = (HEAP32[i3 >> 2] | 0) + i7;
 return;
}

function __ZL14SceneWasLoadediR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 256 | 0;
 i6 = i1 + 248 | 0;
 i5 = i1 + 8 | 0;
 i7 = i1;
 HEAP32[i6 >> 2] = i2;
 i9 = (__Z23GetCoreScriptingClassesv() | 0) + 340 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i4);
 __ZN18ScriptingArguments9AddStructEPKv(i5, i6);
 __ZN18ScriptingArguments7AddEnumEi(i5, i3);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i4, 0) | 0;
 STACKTOP = i1;
 return;
}

function __Z40UnityWebRequest_CUSTOM_InternalSetMethodP12Il2CppObject21UnityWebRequestMethod(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 if ((HEAP32[i3 + 108 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031092 | 0, i5 + 8 | 0);
 i2 = i3 + 92 | 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i3 + 96 >> 2] = 0;
  i3 = i3 + 88 | 0;
  HEAP32[i3 >> 2] = i4;
  STACKTOP = i5;
  return;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
  i3 = i3 + 88 | 0;
  HEAP32[i3 >> 2] = i4;
  STACKTOP = i5;
  return;
 }
}

function __Z33EvaluateQuaternionFromEulerCurvesRK17AnimationCurveTplIfES2_S2_f(i1, i2, i3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 f9 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i2, f5, 0));
 f8 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i3, f5, 0));
 f8 = Math_fround(f8 * Math_fround(.0174532942));
 f5 = Math_fround(Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i4, f5, 0)) * Math_fround(.0174532942));
 HEAPF32[i7 >> 2] = Math_fround(f9 * Math_fround(.0174532942));
 HEAPF32[i7 + 4 >> 2] = f8;
 HEAPF32[i7 + 8 >> 2] = f5;
 __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i1, i7, HEAP32[i2 + 84 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37328 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37324 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, HEAP32[gb + 37320 >> 2] | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i10 = HEAP32[i1 + 16 >> 2] | 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 i12 = HEAP32[i1 + 4 >> 2] | 0;
 i9 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i11 = HEAP32[i1 + 8 >> 2] | 0;
 i8 = HEAP32[i1 + 24 >> 2] | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i12;
 HEAP32[i4 + 8 >> 2] = i11;
 HEAP32[i4 + 12 >> 2] = i10;
 HEAP32[i4 + 16 >> 2] = i9;
 HEAP32[i4 + 20 >> 2] = i8;
 HEAP32[i4 + 24 >> 2] = i7;
 HEAP32[i4 + 28 >> 2] = i6;
 HEAP32[i4 + 32 >> 2] = i5;
 __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i4, i2);
 STACKTOP = i3;
 return;
}

function __Z18CreateDecompressor15CompressionType10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 switch (i1 | 0) {
 case 3:
 case 2:
  {
   i4 = __ZnwjRK10MemLabelIdiPKci(4, i2, 16, gb + 489330 | 0, 43) | 0;
   HEAP32[i4 >> 2] = gb + 70456 + 8;
   STACKTOP = i5;
   return i4 | 0;
  }
 case 0:
  {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 default:
  {
   HEAP32[i4 >> 2] = i1;
   __Z6FormatPKcz(i3, gb + 489480 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 489330 | 0, 51, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 return 0;
}

function __Z12DestroyWorldb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i1 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE(i1);
 __Z19DestroyWorldObjectsRK13dynamic_arrayIiLj4EE(i1);
 __ZN19RuntimeSceneManager43UnloadAllScenesWithoutDestroyingGameObjectsEv(__Z15GetSceneManagerv() | 0);
 if ((HEAP32[i4 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLL26onPoseChangedWhileSleepingEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 if (HEAP32[i3 + 56 >> 2] | 0) return;
 i2 = i3 + 32 | 0;
 i4 = __ZNK5physx2Sc8ShapeSim8getSceneEv(HEAP32[i2 >> 2] | 0) | 0;
 i5 = i3 + 44 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!(i1 & 262144)) {
  __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i4 + 1204 >> 2] | 0) | 0, i3 + 60 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 if (i1 & 98304 | 0) return;
 i2 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i2 >> 2] | 0) | 0;
 i1 = __ZNK5physx2Sc8ShapeSim10getBodySimEv(HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!((i2 | 0) != 0 & (i1 | 0) != 0)) return;
 if (HEAP32[i5 >> 2] & 262144 | 0) return;
 __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_(i4, i2, i1);
 return;
}

function __ZN5Umbra9BitVectorC2ERKS0_(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 HEAP32[i1 >> 2] = 0;
 if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
 }
 HEAP32[i1 >> 2] = gb + 1451688;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? gb + 1451688 | 0 : i3;
 HEAP32[i1 >> 2] = i3;
 if ((i6 | 0) == (i1 | 0)) return;
 i5 = HEAP32[i6 + 8 >> 2] & 134217727;
 if (!i5) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = i5 << 2;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 + 16 | 0, 0) | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = i5;
   i1 = i1 + 16 | 0;
  }
  HEAP32[i4 >> 2] = i1;
 }
 HEAP32[i7 >> 2] = i5;
 _memcpy(i1 | 0, HEAP32[i6 + 4 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __ZN20TextRenderingPrivate15DynamicFontDataD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   _UNITY_FT_Done_Face(HEAP32[i2 + 32 >> 2] | 0) | 0;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i1) while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
   } else while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
  }
 }
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i3, HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 32 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15LightProbeGroup7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 404923 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 43164 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 44 >> 2] = i4;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15AudioEchoFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 170904 + 8;
 HEAP32[i1 + 44 >> 2] = 500;
 HEAPF32[i1 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 6;
 STACKTOP = i4;
 return;
}

function __ZN13RendererScene27CleanupPVSAndRequestRebuildEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 HEAP32[i5 + 144 >> 2] = 0;
 i6 = i5 + 140 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, gb + 63600 | 0);
 HEAP32[i6 >> 2] = 0;
 i6 = i5 + 60 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + 72 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i3 = i4 + (i2 * 24 | 0) | 0;
 if (!i2) {
  i7 = i5 + 152 | 0;
  HEAP8[i7 >> 0] = 1;
  return;
 } else i1 = i4;
 do {
  HEAP32[i1 + 8 >> 2] = -1;
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = 0;
 i3 = i4;
 while (1) {
  if (!(HEAP32[i3 + (i1 * 24 | 0) >> 2] | 0)) {
   __ZN13RendererScene14RemoveRendererEi(i5, i1) | 0;
   i1 = i1 + -1 | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) break;
  i3 = HEAP32[i6 >> 2] | 0;
 }
 i7 = i5 + 152 | 0;
 HEAP8[i7 >> 0] = 1;
 return;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 96 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z78Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D17GetRelativeVectorERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __Z20Camera_CUSTOM_RenderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
  __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i3, 4, 0, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 }
}

function _UNITY_png_read_image(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i6) return;
 i1 = i6 + 208 | 0;
 do if (!(HEAP32[i1 >> 2] & 64)) {
  i2 = _UNITY_png_set_interlace_handling(i6) | 0;
  if (!(HEAP32[i1 >> 2] & 64)) {
   _UNITY_png_read_start_row(i6);
   break;
  } else {
   _UNITY_png_app_error(i6, gb + 353340 | 0);
   break;
  }
 } else {
  if (HEAP8[i6 + 428 >> 0] | 0) if (!(HEAP32[i6 + 212 >> 2] & 2)) HEAP32[i6 + 352 >> 2] = HEAP32[i6 + 348 >> 2];
  i2 = _UNITY_png_set_interlace_handling(i6) | 0;
 } while (0);
 i5 = HEAP32[i6 + 348 >> 2] | 0;
 if ((i2 | 0) < 1 | (i5 | 0) == 0) return; else i1 = 0;
 do {
  i3 = 0;
  i4 = i7;
  while (1) {
   _UNITY_png_read_row(i6, HEAP32[i4 >> 2] | 0, 0);
   i3 = i3 + 1 | 0;
   if ((i3 | 0) == (i5 | 0)) break; else i4 = i4 + 4 | 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function ___mmap(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 do if ((i6 & 4095 | 0) == 0 & (((i6 | 0) < 0) << 31 >> 31 & -4096 | 0) == 0) {
  if (i2 >>> 0 > 2147483646) {
   HEAP32[(___errno_location() | 0) >> 2] = 12;
   i1 = -1;
   break;
  }
  i8 = (i4 & 16 | 0) != 0;
  if (i8) mftCall_vi(fb + 3993 | 0, -1);
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  HEAP32[i7 + 8 >> 2] = i3;
  HEAP32[i7 + 12 >> 2] = i4;
  HEAP32[i7 + 16 >> 2] = i5;
  HEAP32[i7 + 20 >> 2] = i6 >> 12;
  i1 = ___syscall_ret(___syscall192(192, i7 | 0) | 0) | 0;
  if (i8) mftCall_v(fb + 455 | 0);
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 108 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZNK7dtCrowd13IsRefOccupiedEy(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i4 = i1 + 384 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  i1 = i4;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    i3 = i2 + 16 | 0;
    i7 = HEAP32[i3 + 4 >> 2] | 0;
    if (!(i7 >>> 0 < i6 >>> 0 | ((i7 | 0) == (i6 | 0) ? (HEAP32[i3 >> 2] | 0) >>> 0 < i5 >>> 0 : 0))) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i4 | 0)) {
   i7 = i1 + 16 | 0;
   i3 = HEAP32[i7 + 4 >> 2] | 0;
   if (!(i3 >>> 0 > i6 >>> 0 | ((i3 | 0) == (i6 | 0) ? (HEAP32[i7 >> 2] | 0) >>> 0 > i5 >>> 0 : 0))) {
    i7 = i1;
    i7 = (i7 | 0) != (i4 | 0);
    return i7 | 0;
   }
  }
 }
 i7 = i4;
 i7 = (i7 | 0) != (i4 | 0);
 return i7 | 0;
}

function __ZN5physx2Sc9ActorCore14reinsertShapesEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i3 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 switch (HEAPU8[i3 + 10 >> 0] | 0 | 0) {
 case 4:
 case 1:
  {
   i1 = __ZNK5physx2Sc8BodyCore6getSimEv(i3) | 0;
   HEAP32[i1 + 132 >> 2] = 1073741823;
   HEAP32[i1 + 136 >> 2] = 1073741823;
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  }
 default:
  {}
 }
 HEAP32[i4 >> 2] = 0;
 __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i4, i1);
 i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i4) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 do {
  __ZN5physx2Sc8ShapeSim18reinsertBroadPhaseEv(i1);
  i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i4) | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx19NpArticulationJoint22setTangentialStiffnessEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore22setTangentialStiffnessEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 108 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function __ZN5UmbramlERKNS_9Matrix4x4ERKNS_9Matrix4x3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
 __ZN5Umbra9Matrix4x4mLERKNS_9Matrix4x3E(i1, i3) | 0;
 return;
}

function __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if (!i5) {
  i6 = HEAP32[i4 >> 2] | 0;
  i6 = i6 + 56 | 0;
  i6 = HEAP32[i6 >> 2] | 0;
  mftCall_vi(i6 | 0, i4 | 0);
  return;
 }
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i6 = 8;
    break;
   } else i3 = 0;
  }
  if ((i6 | 0) == 8) {
   i6 = 0;
   __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv(i1);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 i6 = HEAP32[i4 >> 2] | 0;
 i6 = i6 + 56 | 0;
 i6 = HEAP32[i6 >> 2] | 0;
 mftCall_vi(i6 | 0, i4 | 0);
 return;
}

function __ZN16BaseVideoTexture29CreateGfxTextureAndUploadDataEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i3 = i6;
 if (HEAP8[i2 + 94 >> 0] | 0) {
  __ZN16BaseVideoTexture22UploadGfxTextureBufferEPj(i2, HEAP32[i2 + 80 >> 2] | 0);
  HEAP8[i2 + 93 >> 0] = 1;
 }
 i5 = __Z12GetGfxDevicev() | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 if ((__Z19GetActiveColorSpacev() | 0) != 1) {
  i2 = 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  mftCall_viiiiiifiii(i4 | 0, i5 | 0, i1 | 0, 2, 1, 1, 1, 0.0, 0, i2 | 0, 2);
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_viiiiiifiii(i4 | 0, i5 | 0, i1 | 0, 2, 1, 1, 1, 0.0, 0, i2 | 0, 2);
 STACKTOP = i6;
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 737689 | 0, i1, 0);
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 60 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13ConstantForce7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(96, i1, 16, gb + 1048932 | 0, 0, gb + 779787 | 0, 10) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 111996 + 8;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = i4;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11Rigidbody2D16SetInterpolationENS_13InterpolationE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP8[i1 + 225 >> 0] = 0;
 i2 = i1 + 128 | 0;
 i4 = i1 + 184 | 0;
 i3 = i1 + 156 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i1 + 140 | 0;
 i3 = i1 + 196 | 0;
 i1 = i1 + 168 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __Z12CancelInvokeR13MonoBehaviourR11ICallString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 __Z24scripting_cpp_string_forP12Il2CppString(i4, HEAP32[i2 >> 2] | 0);
 i5 = HEAP8[i4 + 11 >> 0] | 0;
 i7 = i5 << 24 >> 24 < 0;
 i5 = (i7 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) + 1 | 0;
 i2 = _malloc(i5) | 0;
 _strncpy(i2, i7 ? HEAP32[i4 >> 2] | 0 : i4, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i5, i4, fb + 595 | 0, fb + 596 | 0, i2);
 _free(i2);
 STACKTOP = i3;
 return;
}

function _jpeg_finish_output(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 20 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 + -205 | 0) >>> 0 < 2) if (!(HEAP8[i5 + 64 >> 0] | 0)) i7 = 5; else {
  mftCall_vi(HEAP32[(HEAP32[i5 + 384 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
  HEAP32[i6 >> 2] = 208;
 } else if ((i1 | 0) != 208) i7 = 5;
 if ((i7 | 0) == 5) {
  i4 = HEAP32[i5 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i5 | 0);
 }
 i1 = i5 + 124 | 0;
 i2 = i5 + 132 | 0;
 i3 = i5 + 400 | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) > (HEAP32[i2 >> 2] | 0)) break;
  i4 = HEAP32[i3 >> 2] | 0;
  if (HEAP8[i4 + 17 >> 0] | 0) break;
  if (!(mftCall_ii(HEAP32[i4 >> 2] | 0, i5 | 0) | 0)) {
   i1 = 0;
   i7 = 11;
   break;
  }
 }
 if ((i7 | 0) == 11) return i1 | 0;
 HEAP32[i6 >> 2] = 207;
 i7 = 1;
 return i7 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i5 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i3 >>> 0 < i7 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc(i5, i3, i7 - i3 | 0, i1, 0, i1, i7, i6);
 } else {
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i5 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 return;
}

function __ZN5physx7NpScene10unlockReadEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 3876 | 0;
 i2 = __ZN5physx6shdfnd6TlsGetEj(HEAP32[i1 >> 2] | 0) | 0;
 i3 = i2 >>> 16 & 255;
 if (!(i3 << 24 >> 24)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 2930, gb + 703809 | 0, i5);
  STACKTOP = i5;
  return;
 }
 i6 = i3 + -1 << 24 >> 24;
 __ZN5physx6shdfnd6TlsSetEjPv(HEAP32[i1 >> 2] | 0, i2 & -16711681 | (i6 & 255) << 16) | 0;
 i3 = HEAP32[i4 + 3880 >> 2] | 0;
 if (!(i6 << 24 >> 24 == 0 & (i3 | 0) != (__ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0))) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd13ReadWriteLock12unlockReaderEv(i4 + 3884 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i7 + 4 | 0, i1, gb + 703366 | 0, 234) | 0;
 HEAP32[i5 >> 2] = i1;
 if (!i1) {
  STACKTOP = i7;
  return i1 | 0;
 }
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i3 = i6 + 100 | 0;
 i4 = i6 + 104 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i6 + 108 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] = i1;
  HEAP32[i4 >> 2] = i2 + 1;
 } else __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i3, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i6 >> 2] | 0);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN21LightProbeProxyVolume16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 48 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) == 0 ? 1 : i4 >>> 0 > 32 ? 32 : i4;
 i2 = i1 + 52 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) == 0 ? 1 : i4 >>> 0 > 32 ? 32 : i4;
 i2 = i1 + 56 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) == 0 ? 1 : i4 >>> 0 > 32 ? 32 : i4;
 i2 = i1 + 60 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 > Math_fround(.00999999977);
 i4 = i4 ? (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) : 1008981770;
 i5 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2])) < Math_fround(1.0);
 HEAP32[i2 >> 2] = i5 ? i4 : 1065353216;
 __ZN21LightProbeProxyVolume27ValidateBoundingBoxSettingsEv(i1);
 return;
}

function __ZL19PreDestroyRecursiveR10GameObjectPj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP32[i1 + 56 >> 2] & 15 | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 447028 | 0, 0, gb + 444974 | 0, 1327, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 __ZN10GameObject23InvokeDestroyedCallbackEPS_(i1);
 __ZN10GameObject21WillDestroyGameObjectEv(i1);
 HEAP32[i4 >> 2] = (HEAP32[i1 + 40 >> 2] | 0) + 1 + (HEAP32[i4 >> 2] | 0);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if (!i1) return;
 i3 = i1 + 80 | 0;
 i2 = i1 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 do {
  __ZL19PreDestroyRecursiveR10GameObjectPj(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i2 >> 2] << 2) | 0));
 return;
}

function __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D16GetRelativePointERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D16GetPointVelocityERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __Z32Light_CUSTOM_RemoveCommandBufferP12Il2CppObject20RenderLightEventTypeS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  __ZNK5Light16UnshareLightDataEv(i4);
  __ZN19RenderEventsContext19RemoveCommandBufferEiP22RenderingCommandBuffer((HEAP32[i4 + 44 >> 2] | 0) + 208 | 0, i3, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z29StdTemplateConversionFunctionIhtEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIhsEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIhjEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIhiEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbtEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbsEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP16[i1 >> 1] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP16[i1 >> 1] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbjEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbiEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   i6 = i6 & 255;
   HEAP32[i1 >> 2] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 i6 = i6 & 255;
 HEAP32[i1 >> 2] = i6;
 STACKTOP = i7;
 return 1;
}

function _tre_stack_push(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i1 = i5 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) < (i3 | 0)) {
  HEAP32[(HEAP32[i5 + 16 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i6 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = 0;
 } else {
  i1 = HEAP32[i5 + 4 >> 2] | 0;
  if ((i3 | 0) < (i1 | 0)) {
   i2 = (HEAP32[i5 + 8 >> 2] | 0) + i3 | 0;
   i1 = (i2 | 0) > (i1 | 0) ? i1 : i2;
   i2 = i5 + 16 | 0;
   i3 = _realloc(HEAP32[i2 >> 2] | 0, i1 << 2) | 0;
   if (!i3) i1 = 12; else {
    HEAP32[i5 >> 2] = i1;
    HEAP32[i2 >> 2] = i3;
    HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
    _tre_stack_push(i5, i4) | 0;
    i1 = 0;
   }
  } else i1 = 12;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 32 | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__211this_thread9sleep_forERKNS_6chrono8durationIxNS_5ratioILx1ELx1000000000EEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i1;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 0) {
  i6 = ___udivdi3(i1 | 0, i2 | 0, 1e9, 0) | 0;
  i5 = (i2 | 0) < 499999999 | (i2 | 0) == 499999999 & i1 >>> 0 < 3294967296;
  i7 = ___muldi3(i6 | 0, getTempRet0() | 0, -1e9, -1) | 0;
  i2 = _i64Add(i1 | 0, i2 | 0, i7 | 0, getTempRet0() | 0) | 0;
  getTempRet0() | 0;
  HEAP32[i3 >> 2] = i5 ? i6 : 2147483647;
  HEAP32[i3 + 4 >> 2] = i5 ? i2 : 999999999;
  do if ((_nanosleep(i3 | 0, i3 | 0) | 0) != -1) break; while ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 4);
 }
 STACKTOP = i4;
 return;
}

function __ZN9ShaderLab7Program27CreateFromSerializedProgramERKNS_17SerializedProgramE10ShaderTypeiP16PropertyNamesSetPK6Shader(i4, i1, i2, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i5 = 0, i8 = 0;
 i3 = (HEAP32[i4 + 4 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) | 0;
 i8 = (i3 | 0) / 192 | 0;
 i5 = __Znwj(208) | 0;
 __ZN9ShaderLab7ProgramC2Ei10ShaderType(i5, i8, i1);
 HEAP32[i5 + 196 >> 2] = i2;
 if (!i3) return i5 | 0;
 i1 = 1;
 i3 = 0;
 do {
  i2 = __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader((HEAP32[i4 >> 2] | 0) + (i3 * 192 | 0) | 0, i6, i7) | 0;
  if (i2) {
   if (i1) __ZNK9ShaderLab10SubProgram14EnsureCompiledEv(i2);
   __ZN9ShaderLab7Program13AddSubProgramEPNS_10SubProgramE(i5, i2);
   i1 = 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i8 >>> 0);
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx30PxVehicleWheelsGeneratedValuesC2EPKNS_15PxVehicleWheelsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 113 >> 0];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 i3 = i2 + 12 | 0;
 i4 = i1 + 8 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i5 = i2 + 76 | 0;
 i4 = i1 + 72 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i7 + 20 | 0;
 i2 = HEAP16[i7 + 24 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i2 << 16 >> 16)) {
   i7 = i7 + 12 | 0;
   __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
   return;
  }
 }
 i4 = i2 & 65535;
 i5 = 0;
 do {
  i3 = i1 + (i5 << 2) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i2 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, -2147483648, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
  }
  __ZN5physx6shdfnd15atomicIncrementEPVi(i2 + 16 | 0) | 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i4 | 0));
 i7 = i7 + 12 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
 return;
}

function __ZN4Tree7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(88, i1, 16, gb + 1048932 | 0, 0, gb + 937065 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 185092 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAPF32[i4 + 36 >> 2] = Math_fround(-1.0);
 HEAP32[i4 + 40 >> 2] = 0;
 __ZN18SpeedTreeWindTimesC2Ev(i4 + 44 | 0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 switch (i3 | 0) {
 case 0:
  {
   i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, HEAP32[i1 + 24 >> 2] << 1, HEAP32[i1 + 28 >> 2] << 1, (HEAP32[i1 + 32 >> 2] | 0) + -1 | 0) | 0;
   return i5 | 0;
  }
 case 1:
  {
   i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, HEAP32[i1 + 24 >> 2] << 1 | 1, HEAP32[i1 + 28 >> 2] << 1, (HEAP32[i1 + 32 >> 2] | 0) + -1 | 0) | 0;
   return i5 | 0;
  }
 default:
  {
   i4 = HEAP32[i1 + 24 >> 2] << 1;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if ((i3 | 0) == 2) {
    i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, i4, i5 << 1 | 1, i1 + -1 | 0) | 0;
    return i5 | 0;
   } else {
    i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, i4 | 1, i5 << 1 | 1, i1 + -1 | 0) | 0;
    return i5 | 0;
   }
  }
 }
 return 0;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 160 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 164 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z44Caching_CUSTOM_INTERNAL_CALL_IsVersionCachedP12Il2CppStringRK7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i6 = i3 + 28 | 0;
 i4 = i3 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 i1 = __Z17GetCachingManagerv() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i6);
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = (__ZN14CachingManager8IsCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i1, i4, i5) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 92 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP16[i7 >> 1] | 0;
 i4 = HEAP16[i6 >> 1] | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 i3 = i2 << 16 >> 16 < i1 << 16 >> 16;
 do if (i1 << 16 >> 16 < i4 << 16 >> 16) {
  if (i3) {
   HEAP16[i6 >> 1] = i2;
   HEAP16[i5 >> 1] = i4;
   i1 = 1;
   break;
  }
  HEAP16[i6 >> 1] = i1;
  HEAP16[i7 >> 1] = i4;
  i1 = HEAP16[i5 >> 1] | 0;
  if (i1 << 16 >> 16 < i4 << 16 >> 16) {
   HEAP16[i7 >> 1] = i1;
   HEAP16[i5 >> 1] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP16[i7 >> 1] = i2;
  HEAP16[i5 >> 1] = i1;
  i2 = HEAP16[i7 >> 1] | 0;
  i1 = HEAP16[i6 >> 1] | 0;
  if (i2 << 16 >> 16 < i1 << 16 >> 16) {
   HEAP16[i6 >> 1] = i2;
   HEAP16[i7 >> 1] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNK14TerrainManager17CreateMeshPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP4MeshLj4EE(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 248 | 0;
 i2 = i4 + 8 | 0;
 i3 = i4;
 if (!i5) {
  i7 = 0;
  STACKTOP = i4;
  return i7 | 0;
 }
 if ((((HEAP32[i5 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 66968 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 66968 + 28 >> 2] | 0) >>> 0) {
  i7 = 0;
  STACKTOP = i4;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f(i2, 0, i1, i6);
 __ZNK15TerrainRenderer17CreateMeshPatchesER13dynamic_arrayIP4MeshLj4EE(i2, i7);
 __ZN15TerrainRendererD2Ev(i2);
 i7 = 1;
 STACKTOP = i4;
 return i7 | 0;
}

function __ZN6Camera16SetTargetTextureEP13RenderTexture(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 12 | 0;
 i5 = i8 + 4 | 0;
 i6 = i8 + 8 | 0;
 i7 = i8;
 HEAP32[i5 >> 2] = i4;
 if (!i4) {
  i2 = __Z12GetGfxDevicev() | 0;
  HEAP32[i6 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 368 >> 2] | 0, i2 | 0) | 0;
  i2 = __Z12GetGfxDevicev() | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 372 >> 2] | 0, i2 | 0) | 0;
 } else {
  HEAP32[i6 >> 2] = HEAP32[i4 + 128 >> 2];
  i2 = HEAP32[i4 + 136 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i2;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i3, i4, 1, i6, i1, i5);
 STACKTOP = i8;
 return;
}

function __ZN6AvatarD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 178664 + 8;
 i1 = i3 + 80 | 0;
 if ((HEAP32[i3 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i3 + 60 | 0, HEAP32[i3 + 64 >> 2] | 0);
 HEAP32[i3 + 32 >> 2] = gb + 176376 + 8;
 i2 = i3 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63320 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i3 + 28 | 0);
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx14NpRigidDynamic25setContactReportThresholdEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 i4 = f1 < Math_fround(0.0);
 f1 = i4 ? Math_fround(0.0) : f1;
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i5 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i5 = i6;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAPF32[i7 + 172 >> 2] = f1;
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 128 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 128;
 return;
}

function __ZN5physx14NpRigidDynamic21setMaxAngularVelocityEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 f1 = Math_fround(f1 * f1);
 i2 = i7 + 64 | 0;
 i5 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc8BodyCore14setMaxAngVelSqEf(i2, f1);
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 116 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
 return;
}

function __ZN5Unity5Cloth10SetDampingEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (f1 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 765, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 } else if (f1 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 766, 1, 0, 0, 0);
  f1 = Math_fround(1.0);
 }
 HEAPF32[i2 + 48 >> 2] = f1;
 i2 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0;
 HEAPF32[i3 >> 2] = f1;
 HEAPF32[i3 + 4 >> 2] = f1;
 HEAPF32[i3 + 8 >> 2] = f1;
 mftCall_vii(i5 | 0, i2 | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN20SoundChannelInstance15getCurrentSoundEPPN4FMOD5SoundE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 16 | 0;
 i1 = __ZN4FMOD7Channel15getCurrentSoundEPPNS_5SoundE(HEAP32[i1 + 164 >> 2] | 0, i2) | 0;
 if (!i1) {
  STACKTOP = i5;
  return i1 | 0;
 }
 i2 = __ZL16FMOD_ErrorString11FMOD_RESULT_486(i1) | 0;
 HEAP32[i4 >> 2] = gb + 853918;
 HEAP32[i4 + 4 >> 2] = 141;
 HEAP32[i4 + 8 >> 2] = gb + 874737;
 HEAP32[i4 + 12 >> 2] = i2;
 __Z6FormatPKcz(i3, gb + 883334 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 883367 | 0, 16, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN18AudioMixerSnapshot7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, i1, 16, gb + 1048932 | 0, 0, gb + 873916 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 174840 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15GUIEventManager8PopEventER10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 4 | 0;
 i1 = i1 + 16 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 __ZN10InputEventaSERKS_(i2, (HEAP32[(HEAP32[i4 >> 2] | 0) + (((i5 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i5 >>> 0) % 78 | 0) * 52 | 0) | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN10InputEventD2Ev((HEAP32[(HEAP32[i4 >> 2] | 0) + (((i2 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i2 >>> 0) % 78 | 0) * 52 | 0) | 0);
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
 HEAP32[i1 >> 2] = i3;
 if (i3 >>> 0 <= 155) {
  i5 = 1;
  return i5 | 0;
 }
 __ZdlPv(HEAP32[HEAP32[i4 >> 2] >> 2] | 0);
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -78;
 i5 = 1;
 return i5 | 0;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16GetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
 i2 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return ((i2 | 0) == (i1 + 4 | 0) ? 0 : i2 + 28 | 0) | 0;
}

function __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN19SkinnedMeshRenderer23GetSkinnedMeshLocalAABBER4AABB(i4, i3);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z39GUIElement_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3fS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 16 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __Z21GetCameraOrWindowRectPK6Camera(i5, i1);
 i6 = (__ZN10GUIElement7HitTestERK8Vector2fRK5RectTIfE(i6, i4, i5) | 0) & 1;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, gb + 1034429 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z16dtDistancePtAABBPKfS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 f6 = Math_fround(HEAPF32[i1 >> 2]);
 f12 = Math_fround(HEAPF32[i2 >> 2]);
 f12 = f6 > f12 ? f6 : f12;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = f5 > f10 ? f5 : f10;
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f8 = f4 > f8 ? f4 : f8;
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround((f12 < f11 ? f12 : f11) - f6);
 f5 = Math_fround((f10 < f9 ? f10 : f9) - f5);
 f4 = Math_fround((f8 < f7 ? f8 : f7) - f4);
 return Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f5 * f5)) + Math_fround(f4 * f4))));
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 76 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 do if ((i1 | 0) == -1) {
  HEAP32[i3 >> 2] = __ZNKSt3__28ios_base6getlocEv(i2) | 0;
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 32) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) {
    __ZNSt3__26localeD2Ev(i3);
    HEAP32[i4 >> 2] = i1;
    break;
   }
  }
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i3);
  ___resumeException(i5 | 0);
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 252 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 + 244 >> 2] | 0;
 i5 = i1 + 248 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 48 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 48 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 48 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_2Cm8Matrix34E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = i4;
 HEAP32[i2 + 24 >> 2] = i3;
 HEAP32[i2 + 28 >> 2] = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 36 >> 2] = i3;
 HEAP32[i2 + 40 >> 2] = i4;
 HEAP32[i2 + 44 >> 2] = 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 52 >> 2] = i4;
 HEAP32[i2 + 56 >> 2] = i3;
 HEAP32[i2 + 60 >> 2] = 0;
 return;
}

function __ZN5physx19NpArticulationJoint21setExternalComplianceEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore21setExternalComplianceEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 96 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 128;
 return;
}

function __ZN5physx19NpArticulationJoint20setTangentialDampingEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore20setTangentialDampingEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 112 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2048;
 return;
}

function __ZN27AnimationLayerMixerPlayable19DeallocateResourcesEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 72 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  HEAP8[i4 >> 0] = 0;
  __ZN8Playable19DeallocateResourcesEv(i3);
  return;
 }
 i5 = i3 + 80 | 0;
 i2 = i3 + 60 | 0;
 i6 = i3 + 92 | 0;
 if (HEAP32[i6 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0, i2);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 }
 i1 = i3 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i3 + 84 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i4 >> 0] = 0;
 __ZN8Playable19DeallocateResourcesEv(i3);
 return;
}

function __ZN17PersistentManager21RemoveObjectsFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 0) | 0;
 if ((i1 | 0) == -1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN8Remapper33RemoveCompleteSerializedFileIndexEiRNSt3__26vectorIiNS0_9allocatorIiEEEE(HEAP32[i2 + 56 >> 2] | 0, i1, i3);
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((i3 | 0) != (i1 | 0)) HEAP32[i4 >> 2] = i3 + (~((i3 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 20 | 0;
 switch (HEAP32[i3 >> 2] | 0) {
 case 2:
  {
   __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i1, i2);
   break;
  }
 case 1:
  {
   __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 0) | 0);
   __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 1) | 0);
   __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 2) | 0);
   __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode(i1, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei(i1, i2, 3) | 0);
   break;
  }
 case 0:
  return;
 default:
  {}
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14b2PolygonShape8SetAsBoxEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 HEAP32[i1 + 148 >> 2] = 4;
 f4 = Math_fround(-f2);
 f5 = Math_fround(-f3);
 HEAPF32[i1 + 20 >> 2] = f4;
 HEAPF32[i1 + 24 >> 2] = f5;
 HEAPF32[i1 + 28 >> 2] = f2;
 HEAPF32[i1 + 32 >> 2] = f5;
 HEAPF32[i1 + 36 >> 2] = f2;
 HEAPF32[i1 + 40 >> 2] = f3;
 HEAPF32[i1 + 44 >> 2] = f4;
 HEAPF32[i1 + 48 >> 2] = f3;
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(-1.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 return;
}

function __ZN12TreeRenderer22CleanupBillboardMeshesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 176 | 0;
 i7 = i5 + 188 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (i1 | 0) {
  i4 = 0;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0;
   i3 = i2 + 60 | 0;
   if (HEAP32[i3 >> 2] | 0) {
    i1 = i2 + 48 | 0;
    __Z19DestroySingleObjectP6Object(HEAP32[i1 >> 2] | 0);
    HEAP32[i1 >> 2] = 0;
    HEAP32[i3 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
 }
 i1 = i5 + 192 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i5 + 180 | 0);
  HEAP32[i6 >> 2] = 0;
 }
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i5 + 152 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 return;
}

function __Z52ParticleSystem_SubEmittersModule_CUSTOM_SetCollisionP12Il2CppObjectiS0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZN14ParticleSystem8SyncJobsEb(1);
  i6 = HEAP32[i6 + 916 >> 2] | 0;
  HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE(i6, 1, i3, i1);
  STACKTOP = i7;
  return;
 }
}

function __Z39ParticleRenderer_Get_Custom_PropUvTilesP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 376 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i2 = HEAP32[i2 + 372 >> 2] | 0;
  i3 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 284 >> 2] | 0;
  i2 = (i1 | 0) == 0 ? 0 : i2;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 16, i2) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 16) | 0, i1 | 0, i2 << 4 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z39Caching_CUSTOM_INTERNAL_CALL_MarkAsUsedP12Il2CppStringRK7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i6 = i3 + 28 | 0;
 i4 = i3 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 i1 = __Z17GetCachingManagerv() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i6);
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 i2 = (__ZN14CachingManager10MarkAsUsedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128(i1, i4, i5) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z38MaterialPropertyBlock_CUSTOM_SetBufferP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 12 | 0;
 i4 = i9;
 i6 = i9 + 8 | 0;
 i7 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 if (!i3) i8 = 7; else {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if (!i1) i8 = 7; else HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 if ((i8 | 0) == 7) HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i2, i6, i5, 0);
 STACKTOP = i9;
 return;
}

function __Z14DecompressDXT1iiiPKjPj(i4, i5, i7, i8, i9) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i13 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i13;
 if ((i5 | 0) <= 0) {
  STACKTOP = i13;
  return;
 }
 i11 = i4 << 1;
 i12 = i7 << 2;
 if ((i4 | 0) > 0) i3 = 0; else {
  STACKTOP = i13;
  return;
 }
 do {
  i6 = Math_imul(i12, i3) | 0;
  i1 = 0;
  i2 = i8 + ((Math_imul(i11, i3) | 0) << 2) | 0;
  while (1) {
   __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888(i2, i10);
   __Z16DecodeColorBlockPjRK11DXTColBlockiPKj(i9 + (i1 << 2 << 2) + (i6 << 2) | 0, i2, i7, i10);
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i4 | 0)) break; else i2 = i2 + 8 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 STACKTOP = i13;
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 108 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 112 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 116 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i2 + 16 | 0;
 i4 = i2 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i2 + 36 | 0;
 i1 = i5;
 i7 = (HEAP32[i6 >> 2] | 0) - i1 | 0;
 i8 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i8) {
  i8 = i1;
  HEAP32[i6 >> 2] = i8;
  i8 = HEAP32[i3 >> 2] | 0;
  i8 = i8 + 16 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  mftCall_vi(i8 | 0, i3 | 0);
  return;
 }
 i1 = i2 + 48 | 0;
 i2 = 0;
 do {
  i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i5 | 0, i7 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 i9 = HEAP32[i4 >> 2] | 0;
 HEAP32[i6 >> 2] = i9;
 i9 = HEAP32[i3 >> 2] | 0;
 i9 = i9 + 16 | 0;
 i9 = HEAP32[i9 >> 2] | 0;
 mftCall_vi(i9 | 0, i3 | 0);
 return;
}

function __ZN5physx19NpArticulationJoint21setInternalComplianceEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore21setInternalComplianceEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 92 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 64;
 return;
}

function __ZN4FMOD12ChannelGroup4stopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 854017;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 854017;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854017;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i5 = i1 + 36 | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 i6 = i3 + 16 | 0;
 i7 = i3 + 36 | 0;
 i4 = i3 + 40 | 0;
 while (1) {
  i3 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN23AllocationRootReference13SetObjectNameEPKc(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 12 | 0;
 i7 = i1 | 0 ? i1 : gb + 1576256 | 0;
 i8 = _strlen(i7) | 0;
 i4 = i6 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i5 + 20 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 if (i8 >>> 0 > i3 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 16 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc(i6, i3, i8 - i3 | 0, i1, 0, i1, i8, i7);
  return;
 }
 if (i2) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
 if (i8 | 0) _memmove(i1 | 0, i7 | 0, i8 | 0) | 0;
 HEAP8[i1 + i8 >> 0] = 0;
 if ((HEAP8[i4 >> 0] | 0) < 0) {
  HEAP32[i5 + 16 >> 2] = i8;
  return;
 } else {
  HEAP8[i4 >> 0] = i8;
  return;
 }
}

function __ZN18DeferredRenderLoopD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 36776 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
  }
 }
 i1 = i2 + 88 | 0;
 if ((HEAP32[i2 + 104 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 92 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 52 >> 2] | 0) > -1) {
  i3 = i2 + 36 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 40 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 i1 = i2 + 16 | 0;
 if ((HEAP32[i2 + 32 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 20 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15DirectorManager14ConnectionPool11ClearUnsafeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = 0;
 do {
  i5 = i4 + 48 + (i3 << 2) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   while (1) {
    i1 = i2 + 36 | 0;
    if ((HEAP32[i2 + 52 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 40 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    i1 = i2 + 16 | 0;
    if ((HEAP32[i2 + 32 >> 2] | 0) > -1) {
     __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 20 | 0);
     HEAP32[i1 >> 2] = 0;
    }
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
    i1 = HEAP32[i5 >> 2] | 0;
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) break;
    HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   }
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 5);
 return;
}

function __ZN13UnityProfilerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 1 >> 0] = 0;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = i2;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 1;
 i2 = i1 + 88 | 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(116, gb + 63576 | 0, 16, gb + 585151 | 0, 117) | 0;
 __ZN9profiling14SamplerManagerC2Ev(i2);
 HEAP32[i1 + 76 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = 2;
 HEAP32[i1 + 24 >> 2] = 2;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Animation23SetBoundCurveFloatValueERKNS0_10BoundCurveEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 5:
  {
   i3 = HEAP32[i1 >> 2] | 0;
   i1 = Math_fround(HEAPF32[i3 >> 2]) != f2;
   HEAPF32[i3 >> 2] = f2;
   return i1 | 0;
  }
 case 6:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   i4 = f2 > Math_fround(.00100000005) | f2 < Math_fround(-.00100000005);
   i3 = (HEAPU8[i1 >> 0] | 0 | 0) != (i4 & 1 | 0);
   HEAP8[i1 >> 0] = i4 & 1;
   return i3 | 0;
  }
 case 7:
  {
   __ZN10GameObject13SetSelfActiveEb(HEAP32[i1 + 12 >> 2] | 0, f2 > Math_fround(.00100000005) | f2 < Math_fround(-.00100000005));
   i4 = 0;
   return i4 | 0;
  }
 default:
  {
   i4 = HEAP32[i1 + 8 >> 2] | 0;
   mftCall_viif(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i1 | 0, +f2);
   i4 = 0;
   return i4 | 0;
  }
 }
 return 0;
}

function __Z44TrailRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 108 >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z38Animation_CUSTOM_Internal_RewindByNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN9Animation6RewindERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z30Material_CUSTOM_DisableKeywordP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN8Material14DisableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function _UNITY_ft_raster1_renderer_class_pic_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 208 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i4 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 28, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i2 >> 2] = 1;
 _UNITY_FT_Init_Class_ft_standard_raster(i2 + 4 | 0);
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _ecvt(d2, i1, i6, i3) {
 d2 = +d2;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i7 = i8 + 16 | 0;
 i1 = i1 + -1 | 0;
 HEAP32[i5 >> 2] = i1 >>> 0 > 15 ? 14 : i1;
 HEAPF64[i5 + 8 >> 3] = d2;
 _sprintf(i7, gb + 1075308 | 0, i5) | 0;
 i1 = (HEAP8[i7 >> 0] | 0) == 45 & 1;
 HEAP32[i3 >> 2] = i1;
 i3 = HEAP8[i7 + i1 >> 0] | 0;
 if (i3 << 24 >> 24 == 101) i3 = gb + 1576168 | 0; else {
  i5 = 0;
  i4 = i3;
  i3 = gb + 1576168 | 0;
  do {
   HEAP8[i3 >> 0] = i4;
   i1 = i1 + 1 | 0;
   i5 = (i4 << 24 >> 24 != 46 & 1) + i5 | 0;
   i4 = HEAP8[i7 + i1 >> 0] | 0;
   i3 = gb + 1576168 + i5 | 0;
  } while (i4 << 24 >> 24 != 101);
 }
 HEAP8[i3 >> 0] = 0;
 HEAP32[i6 >> 2] = (_atoi(i7 + i1 + 1 | 0) | 0) + 1;
 STACKTOP = i8;
 return gb + 1576168 | 0;
}

function __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsAlignCanvasRectTransformWithCamerastruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i5 = i5 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((__ZNK2UI6Canvas13GetRenderModeEv(i2) | 0) == 1) {
   HEAP32[i4 >> 2] = 0;
   __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi(i2, i4);
   i3 = HEAP32[i4 >> 2] | 0;
   if (i3 | 0) __ZN9Transform20SendTransformChangedEi(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28980 | 0) | 0, i3);
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i5 >> 2] | 0));
 STACKTOP = i6;
 return;
}

function __ZThn680_N18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i1 + -680 | 0;
 i7 = HEAP8[i4 + 11 >> 0] | 0;
 if ((i7 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i7 & 255) | 0) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i7 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255) | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZN11UnityEngine7Connect15DeviceInfoEventC2ERK8UnityStrb(i5, i2, i3);
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE15writeContentTagEPKcS5_(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i1 | 0);
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, gb + 766880 | 0, 2) | 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) + -1 << 2) >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i3 | 0, i1 | 0, _strlen(i1) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, gb + 1086447 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, gb + 1074320 | 0, 1) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i4 = 1;
  while (1) {
   i3 = HEAP32[i2 + 4 >> 2] | 0;
   if ((i2 | 0) == (i3 | 0)) {
    i3 = i4;
    i4 = i2;
    break;
   } else {
    i4 = i4 + 1 | 0;
    i2 = i3;
   }
  }
  if (!i3) i1 = i4; else {
   HEAP32[i5 >> 2] = i4;
   i2 = i3 + -1 | 0;
   if (!i2) i1 = i4; else {
    do {
     i5 = i1 + 4 | 0;
     i1 = HEAP32[i5 >> 2] | 0;
     HEAP32[i5 >> 2] = i4;
     i2 = i2 + -1 | 0;
    } while ((i2 | 0) != 0);
    i1 = i4;
   }
  }
 }
 if (HEAP8[i1 + 44 >> 0] & 4) return;
 __ZN5physx2Sc27ConstraintProjectionManager23addToPendingTreeUpdatesERNS0_19ConstraintGroupNodeE(i6, i1);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i7 + 20 | 0;
 i2 = HEAP16[i7 + 24 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i2 << 16 >> 16)) {
   i7 = i7 + 12 | 0;
   __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
   return;
  }
 }
 i4 = i2 & 65535;
 i5 = 0;
 do {
  i3 = i1 + (i5 << 2) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i2 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, -2147483648, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
  }
  __ZN5physx6shdfnd15atomicIncrementEPVi(i2 + 16 | 0) | 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i4 | 0));
 i7 = i7 + 12 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
 return;
}

function __ZN4Mesh19ValidateVertexCountEjPKvj(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i2) {
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  i2 = HEAP32[i3 + 112 >> 2] | 0;
  i3 = ((HEAP32[i3 + 116 >> 2] | 0) - i2 | 0) >>> 1;
  if (!i3) {
   i4 = 1;
   return i4 | 0;
  } else i1 = 0;
  while (1) {
   if ((HEAPU16[i2 + (i1 << 1) >> 1] | 0) >>> 0 >= i4 >>> 0) {
    i1 = 0;
    i2 = 8;
    break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = 1;
    i2 = 8;
    break;
   }
  }
  if ((i2 | 0) == 8) return i1 | 0;
 } else {
  if (!i3) {
   i4 = 1;
   return i4 | 0;
  } else i1 = 0;
  while (1) {
   if ((HEAPU16[i2 + (i1 << 1) >> 1] | 0) >>> 0 >= i4 >>> 0) {
    i1 = 0;
    i2 = 8;
    break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = 1;
    i2 = 8;
    break;
   }
  }
  if ((i2 | 0) == 8) return i1 | 0;
 }
 return 0;
}

function __ZN29AudioEffectInternalDefinitionD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (!i8) {
  HEAP32[i7 >> 2] = 0;
  return;
 }
 i5 = i8 + 200 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (i6 | 0) {
  HEAP32[i7 >> 2] = 0;
  return;
 }
 i6 = i8 + 60 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = i8 + 64 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i4 = 0;
  while (1) {
   i2 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
   if (!i2) i2 = i3; else {
    __ZdaPv(i2);
    i2 = HEAP32[i6 >> 2] | 0;
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
   if ((i4 | 0) >= (i2 | 0)) break; else i3 = i2;
  }
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = HEAP32[i8 + 180 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i8, gb + 63328 | 0);
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN19TouchPhaseEmulation11AllocateNewEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = 0;
 while (1) {
  i4 = 1 << i6;
  if (!(i3 & i4)) break;
  i5 = i6 + 1 | 0;
  if ((i5 | 0) < 32) i6 = i5; else {
   i7 = 0;
   i8 = 8;
   break;
  }
 }
 if ((i8 | 0) == 8) return i7 | 0;
 HEAP32[i2 >> 2] = i3 | i4;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = i2 + (i1 * 96 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == -1) break;
  i4 = i1 + 1 | 0;
  if (i4 >>> 0 < 32) i1 = i4; else {
   i7 = 0;
   i8 = 8;
   break;
  }
 }
 if ((i8 | 0) == 8) return i7 | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i2 + (i1 * 96 | 0) + 20 >> 2] = 0;
 HEAP32[i2 + (i1 * 96 | 0) + 24 >> 2] = 0;
 HEAPF32[i2 + (i1 * 96 | 0) + 28 >> 2] = Math_fround(0.0);
 HEAP32[i2 + (i1 * 96 | 0) + 92 >> 2] = 0;
 i8 = i3;
 return i8 | 0;
}

function __Z43LineRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[(HEAP32[i3 + 344 >> 2] | 0) + 108 >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z39WebCamTexture_Set_Custom_PropDeviceNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 108 | 0, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z26SetPolynomialCurveToLinearR17AnimationCurveTplIfER24OptimizedPolynomialCurve(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i5 = i3;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i6);
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 __ZN11KeyframeTplIfEC2EfRKf(i4 + 16 | 0, Math_fround(1.0), i5);
 HEAPF32[i4 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i4 + 28 >> 2] = Math_fround(0.0);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1, i4, i4 + 32 | 0);
 __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i2, i1, Math_fround(1.0)) | 0;
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Get_SubGlyph_Info(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0;
 if (!i1) {
  i8 = 6;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i8) {
  i8 = 6;
  return i8 | 0;
 }
 if ((HEAP32[i1 + 72 >> 2] | 0) != 1668246896) {
  i8 = 6;
  return i8 | 0;
 }
 if ((HEAP32[i1 + 128 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i8 = 6;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i8 + (i2 << 5) >> 2];
 HEAP32[i4 >> 2] = HEAPU16[i8 + (i2 << 5) + 4 >> 1];
 HEAP32[i5 >> 2] = HEAP32[i8 + (i2 << 5) + 8 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 + (i2 << 5) + 12 >> 2];
 i8 = i8 + (i2 << 5) + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i8 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i8 + 12 >> 2];
 i8 = 0;
 return i8 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 80 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZNK5physx7NpCloth25getSelfCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore25getSelfCollisionStiffnessEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 779, gb + 692870 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 100 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 104 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZNK5physx13NpVolumeCache7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE(i5, i3, i6, i4, i2, i1) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7;
 i8 = i7 + 24 | 0;
 HEAP32[i9 + 12 >> 2] = i3;
 HEAP32[i9 + 16 >> 2] = i6;
 HEAPF32[i9 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i9 + 4 >> 2] = 0;
 HEAP32[i9 >> 2] = 0;
 HEAP16[i8 >> 1] = 0;
 i6 = __ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf(i5, i9, i4, i8, i2, i1, Math_fround(0.0)) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9Behaviour10SetEnabledEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP16[i2 >> 1] | 0;
 if (!((i3 & 255) << 24 >> 24 != 0 ^ i1)) return;
 HEAP8[i2 >> 0] = i1 & 1;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 do if (!i1) {
  i1 = i4 + 33 | 0;
  i2 = (i3 & 65535) >>> 8 & 255;
  i5 = 6;
 } else {
  if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) {
   i2 = i4 + 33 | 0;
   i1 = i2;
   i2 = HEAP8[i2 >> 0] | 0;
   i5 = 6;
   break;
  }
  i3 = HEAP16[i2 >> 1] | 0;
  i2 = (i3 & 255) << 24 >> 24 != 0;
  i1 = i4 + 33 | 0;
  if (!((i3 & 65535) > 255 ^ i2)) return;
  if (i2) {
   HEAP8[i1 >> 0] = 1;
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0);
   return;
  }
 } while (0);
 if ((i5 | 0) == 6) if (!(i2 << 24 >> 24)) return;
 HEAP8[i1 >> 0] = 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx6shdfnd7FastIPC16pumpPendingSendsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i3) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = i3 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i1 = (__ZN5physx6shdfnd12PxRingBuffer15MultiPartPacket7processEv(i1) | 0) == 2;
  i2 = HEAP32[i4 >> 2] | 0;
  if (i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i3 = i3 + 44 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - (HEAP32[i2 + 20 >> 2] | 0);
   if (i2 | 0) {
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i2 + 28 >> 2] | 0);
    __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i2);
   }
   HEAP32[i4 >> 2] = i1;
  } else i1 = i2;
 }
 i5 = (i1 | 0) != 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx2Sc17ParticleSystemSim24visualizeParticlesBoundsERNS_2Cm12RenderOutputE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 32 | 0;
 i4 = i3;
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i2 | 0);
 i2 = __ZN5physx2Cm12RenderOutputlsEj(i1, -65536) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP8[i4 + 24 >> 0] = 1;
 __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE(i2, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i7 + 20 | 0;
 i2 = HEAP16[i7 + 24 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(i2 << 16 >> 16)) {
   i7 = i7 + 12 | 0;
   __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
   return;
  }
 }
 i4 = i2 & 65535;
 i5 = 0;
 do {
  i3 = i1 + (i5 << 2) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if (i2) {
   i2 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, -2147483648, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i2;
  }
  __ZN5physx6shdfnd15atomicIncrementEPVi(i2 + 16 | 0) | 0;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i4 | 0));
 i7 = i7 + 12 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i7, i6);
 return;
}

function __ZN26AnimatorControllerPlayable6Memory5ResetERN7mecanim6memory16MecanimAllocatorE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 8 | 0;
 __ZN7mecanim9animation22DestroyControllerInputEPNS0_15ControllerInputERNS_6memory9AllocatorE(HEAP32[i4 >> 2] | 0, i3);
 i5 = i2 + 20 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i1 = i2 + 12 | 0;
  __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i3);
 } else {
  i1 = i2 + 12 | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 }
 i6 = i2 + 16 | 0;
 __ZN7mecanim9animation26DestroyControllerWorkspaceEPNS0_19ControllerWorkspaceERNS_6memory9AllocatorE(HEAP32[i6 >> 2] | 0, i3);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN20SpeedTreeWindManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63616 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAP32[gb + 1115296 + 196 >> 2] = fb + 83;
 STACKTOP = i2;
 return;
}

function __ZN20BaseBehaviourManager14IntegrateListsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 if ((i2 | 0) == (i6 | 0)) return;
 while (1) {
  i3 = HEAP32[i2 + 20 >> 2] | 0;
  i4 = HEAP32[i2 + 24 >> 2] | 0;
  i5 = i4 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i4 | 0)) {
   i7 = HEAP32[i3 >> 2] | 0;
   HEAP32[i7 + 4 >> 2] = i1;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 >> 2] = i7;
   HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i3;
   HEAP32[i5 >> 2] = i4;
   HEAP32[i4 >> 2] = i4;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i6 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN13b2DynamicTree11ShiftOriginERK6b2Vec2(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, f7 = f0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i5 | 0) <= 0) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i1 = 0;
 do {
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i2 + (i1 * 36 | 0) | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  i6 = i2 + (i1 * 36 | 0) + 4 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  f7 = Math_fround(HEAPF32[i4 >> 2]);
  i6 = i2 + (i1 * 36 | 0) + 8 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  f7 = Math_fround(HEAPF32[i3 >> 2]);
  i6 = i2 + (i1 * 36 | 0) + 12 | 0;
  HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) - f7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i5 | 0));
 return;
}

function __Z29Material_CUSTOM_EnableKeywordP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN8Material13EnableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z29Light_CUSTOM_AddCommandBufferP12Il2CppObject20RenderLightEventTypeS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  __ZNK5Light16UnshareLightDataEv(i4);
  __ZN19RenderEventsContext16AddCommandBufferEiP22RenderingCommandBuffer((HEAP32[i4 + 44 >> 2] | 0) + 208 | 0, i3, i1);
  STACKTOP = i6;
  return;
 }
}

function __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS8_EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 i4 = i6 + 4 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + (0 - (i3 >> 3) << 3) | 0;
 HEAP32[i4 >> 2] = i1;
 if ((i3 | 0) > 0) {
  _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i4;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i2 = i4;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i4;
 i4 = i6 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 8 | 0;
 i7 = i6 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZNSt3__24stolERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1084452 | 0, 4);
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 214 | 0, i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__24stolERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1084452 | 0, 4);
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 213 | 0, i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__24stoiERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1084416 | 0, 4);
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 214 | 0, i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__24stoiERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1084416 | 0, 4);
 __THREW__ = 0;
 i1 = invoke_iiiii(fb + 213 | 0, i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i7, i5, i6) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i1 = i7 + 8 | 0;
 i8 = i1 + 3 | 0;
 i2 = HEAP8[i8 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) {
  i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0;
  i3 = HEAP32[i7 + 4 >> 2] | 0;
 } else {
  i1 = 1;
  i3 = i2 & 255;
 }
 if ((i1 - i3 | 0) >>> 0 < i6 >>> 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i7, i1, i6 - i1 + i3 | 0, i3, i3, 0, i6, i5); else if (i6 | 0) {
  if (i4) i2 = HEAP32[i7 >> 2] | 0; else i2 = i7;
  __ZNSt3__211char_traitsIwE4copyEPwPKwj(i2 + (i3 << 2) | 0, i5, i6) | 0;
  i1 = i3 + i6 | 0;
  if ((HEAP8[i8 >> 0] | 0) < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
 }
 return i7 | 0;
}

function __ZNK5physx2Sn9MetaClass14getFieldByNameEPKcRNS0_15PxMetaDataEntryE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (!(_strcmp(HEAP32[i3 + (i1 << 5) + 4 >> 2] | 0, i4) | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 i6 = i3 + (i1 << 5) | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i6 + 24 >> 2];
 HEAP32[i5 + 28 >> 2] = HEAP32[i6 + 28 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN6MotionC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 176392 + 8;
 HEAP32[i1 + 32 >> 2] = i1;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMaxDepenetrationVelocityEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 f1 = Math_fround(-f1);
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i5 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i5 = i6;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAPF32[i7 + 156 >> 2] = f1;
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 172 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function __ZN14VehiclesModule17InvalidateVehicleEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i5;
 i1 = HEAP32[gb + 1458780 >> 2] | 0;
 if (HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i5 >>> 5 << 2) >> 2] & 1 << (i5 & 31) | 0) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[gb + 1458700 >> 2] | 0;
 i3 = i2 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i2, i6);
  i1 = HEAP32[gb + 1458780 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 4;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = (HEAP32[i1 + 8 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i5 & 31);
 STACKTOP = i7;
 return;
}

function __ZN14RenderSettings17ApplyLightChangesENS_16LightsUpdateTypeE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = __Z15GetLightManagerv() | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i2;
 if ((i1 | 0) == (i4 | 0)) return;
 switch (i3 | 0) {
 case 0:
  {
   do {
    i3 = i2 + -36 | 0;
    __ZN5Light9SetupHaloEv(i3);
    __ZN5Light10SetupFlareEv(i3);
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   return;
  }
 case 1:
  {
   do {
    __ZN5Light9SetupHaloEv(i2 + -36 | 0);
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   return;
  }
 case 2:
  {
   do {
    __ZN5Light10SetupFlareEv(i2 + -36 | 0);
    i2 = HEAP32[i1 + 4 >> 2] | 0;
    i1 = i2;
   } while ((i1 | 0) != (i4 | 0));
   return;
  }
 default:
  {
   do i1 = HEAP32[i1 + 4 >> 2] | 0; while ((i1 | 0) != (i4 | 0));
   return;
  }
 }
}

function __ZL32InitializeModule_ParticlesLegacyv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 HEAP32[gb + 1115296 + 276 >> 2] = fb + 447;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 6944 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 6176 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 6176 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 6176 + (i1 * 12 | 0) >> 2] = fb + 448;
 STACKTOP = i5;
 return;
}

function __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetDeathP12Il2CppObjectiS0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZN14ParticleSystem8SyncJobsEb(1);
  i6 = HEAP32[i6 + 916 >> 2] | 0;
  HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE(i6, 2, i3, i1);
  STACKTOP = i7;
  return;
 }
}

function __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetBirthP12Il2CppObjectiS0_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZN14ParticleSystem8SyncJobsEb(1);
  i6 = HEAP32[i6 + 916 >> 2] | 0;
  HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i4) | 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE(i6, 0, i3, i1);
  STACKTOP = i7;
  return;
 }
}

function _clog(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, d5 = 0.0, i6 = 0, i7 = 0, d8 = 0.0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i9 = i3 + 16 | 0;
 i7 = i3;
 d8 = +HEAPF64[i2 >> 3];
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i9 >> 3] = d8;
 HEAPF64[i9 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 d5 = +_cabs(i6);
 HEAPF64[i7 >> 3] = d8;
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 d4 = +_carg(i6);
 HEAPF64[i1 >> 3] = +Math_log(+d5);
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function ___stpcpy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2;
 L1 : do if (!((i3 ^ i1) & 3)) {
  if (i3 & 3) do {
   i3 = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 >> 0] = i3;
   if (!(i3 << 24 >> 24)) break L1;
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  } while ((i2 & 3 | 0) != 0);
  i3 = HEAP32[i2 >> 2] | 0;
  if (!((i3 & -2139062144 ^ -2139062144) & i3 + -16843009)) {
   i4 = i1;
   while (1) {
    i2 = i2 + 4 | 0;
    i1 = i4 + 4 | 0;
    HEAP32[i4 >> 2] = i3;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i3 & -2139062144 ^ -2139062144) & i3 + -16843009 | 0) break; else i4 = i1;
   }
  }
  i4 = 8;
 } else i4 = 8; while (0);
 if ((i4 | 0) == 8) {
  i4 = HEAP8[i2 >> 0] | 0;
  HEAP8[i1 >> 0] = i4;
  if (i4 << 24 >> 24) do {
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
   i4 = HEAP8[i2 >> 0] | 0;
   HEAP8[i1 >> 0] = i4;
  } while (i4 << 24 >> 24 != 0);
 }
 return i1 | 0;
}

function __ZZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPiiEN12PolygonQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi(i2, i1, i7, i8, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i10 = 0, i11 = 0;
 if ((i9 | 0) <= 0) return;
 i6 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 128 >> 2] | 0;
 i4 = i2 + 20 | 0;
 i5 = i2 + 16 | 0;
 i2 = i2 + 12 | 0;
 i1 = 0;
 do {
  if (i6 & HEAP32[(HEAP32[i8 + (i1 << 2) >> 2] | 0) + 24 >> 2] | 0) {
   i3 = HEAP32[i4 >> 2] | 0;
   if ((i3 | 0) < (HEAP32[i5 >> 2] | 0)) {
    i10 = i7 + (i1 << 3) | 0;
    i11 = HEAP32[i10 >> 2] | 0;
    i10 = HEAP32[i10 + 4 >> 2] | 0;
    HEAP32[i4 >> 2] = i3 + 1;
    i3 = (HEAP32[i2 >> 2] | 0) + (i3 << 3) | 0;
    HEAP32[i3 >> 2] = i11;
    HEAP32[i3 + 4 >> 2] = i10;
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i9 | 0));
 return;
}

function __ZNK5physx7NpCloth24getSelfCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore24getSelfCollisionDistanceEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 762, gb + 693042 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN7dtCrowd16ReserveObstaclesEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = i5 + 408 | 0;
 if ((HEAP32[i7 >> 2] | 0) >= (i6 | 0)) {
  i7 = 1;
  return i7 | 0;
 }
 i4 = i5 + 416 | 0;
 i1 = __Z9dtReallocPvi(HEAP32[i4 >> 2] | 0, i6 * 92 | 0) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i1 = i5 + 396 | 0;
 i2 = __Z9dtReallocPvi(HEAP32[i1 >> 2] | 0, i6 << 2) | 0;
 if (!i2) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 i3 = HEAP32[i7 >> 2] | 0;
 if ((i3 | 0) < (i6 | 0)) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i3;
  do {
   HEAP32[i2 + (i1 * 92 | 0) + 84 >> 2] = 0;
   i4 = i1;
   i1 = i1 + 1 | 0;
   HEAP32[i2 + (i4 * 92 | 0) + 88 >> 2] = i1;
  } while ((i1 | 0) != (i6 | 0));
 }
 HEAP32[i5 + 412 >> 2] = i3;
 HEAP32[i7 >> 2] = i6;
 __ZN7dtCrowd19ResizeProximityGridEv(i5);
 i7 = 1;
 return i7 | 0;
}

function __ZN6Shader18LoadDefaultShadersEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (HEAP32[gb + 1166240 >> 2] | 0) {
  STACKTOP = i2;
  return;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 469921 | 0, 27);
 i3 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i1) | 0;
 HEAP32[gb + 1166240 >> 2] = i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 HEAP32[gb + 1166244 >> 2] = HEAP32[i1 + 32 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN5physx7NpCloth19setVirtualParticlesEjPKjjPKNS_6PxVec3E(i4, i2, i1, i3, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 switch ((HEAP32[i4 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i7 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i4 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i7 = 3; else i7 = 4;
   break;
  }
 default:
  i7 = 3;
 }
 if ((i7 | 0) == 3) {
  __ZN5physx2Sc9ClothCore19setVirtualParticlesEjPKjjPKNS_6PxVec3E(i4 + 32 | 0, i2, i1, i3, i6);
  STACKTOP = i8;
  return;
 } else if ((i7 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 502, gb + 693878 | 0, i5);
  STACKTOP = i8;
  return;
 }
}

function __ZN5physx27PxVehicleDriveGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 HEAP32[i1 + 68 >> 2] = gb + 831985;
 HEAP32[i1 + 72 >> 2] = 673;
 HEAP32[i1 + 76 >> 2] = fb + 2423;
 HEAP32[i1 + 80 >> 2] = gb + 834551;
 HEAP32[i1 + 84 >> 2] = 674;
 HEAP32[i1 + 88 >> 2] = fb + 3966;
 HEAP32[i1 + 92 >> 2] = fb + 3967;
 return;
}

function __ZN15RelativeJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 HEAP32[i1 >> 2] = gb + 157128 + 8;
 STACKTOP = i4;
 return;
}

function __ZN15DirectorManager13OnAdvanceTimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN15DirectorManager14ConnectionPool16GrowEmptyBucketsEv(gb + 1188456 | 0);
 i3 = i1 + 376 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i6 = __Z14GetTimeManagerv() | 0;
 i7 = HEAP32[i6 + 112 >> 2] | 0;
 HEAP32[gb + 1188440 >> 2] = i7;
 HEAP32[gb + 1188448 >> 2] = i7;
 f5 = Math_fround(+HEAPF64[i6 + 184 >> 3]);
 HEAPF32[gb + 1188452 >> 2] = f5;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i2, fb + 3162 | 0, HEAP32[i1 + 364 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
 if (HEAP32[i2 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i2);
 STACKTOP = i4;
 return;
}

function __ZN10AudioMixer6UpdateEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return;
 if (__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0) {
  f3 = Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) * Math_fround(.100000001));
  f3 = Math_fround(_exp2f(Math_fround(Math_fround(_log2f(Math_fround(10.0))) * f3)));
  i6 = HEAP32[i1 + 72 >> 2] | 0;
  i5 = HEAP32[i1 + 76 >> 2] | 0;
  i4 = HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0;
  __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf(i6, i5, f2, i4, HEAP8[i1 + 100 >> 0] | 0 ? f3 : Math_fround(0.0));
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 339, 1, 0, 0, 0);
  return;
 }
}

function __Z36Animation_CUSTOM_Internal_StopByNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN9Animation4StopERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i7);
 i4 = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[i6 >> 2] | 0, i5, 0, i4) | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i7 = HEAP32[i2 + 20 >> 2] | 0;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i7);
 i4 = __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(HEAP32[i6 >> 2] | 0, i5, 0, i4) | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __Z16dtPointInPolygonPKfS0_i(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, f11 = f0;
 if ((i6 | 0) <= 0) {
  i6 = 1;
  return i6 | 0;
 }
 i8 = i2 + ((i6 * 3 | 0) + -3 << 2) | 0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(HEAPF32[i8 >> 2]);
 i1 = 0;
 f4 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 while (1) {
  i8 = i2 + (i1 * 3 << 2) | 0;
  f11 = f3;
  f3 = Math_fround(HEAPF32[i8 >> 2]);
  f10 = Math_fround(f3 - f11);
  f9 = f4;
  f4 = Math_fround(HEAPF32[i8 + 8 >> 2]);
  if (Math_fround(Math_fround(f4 - f9) * Math_fround(f7 - f11)) < Math_fround(f10 * Math_fround(f5 - f9))) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i6 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z16CreateCompressor15CompressionType10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i4 = __ZnwjRK10MemLabelIdiPKci(4, i2, 16, gb + 489330 | 0, 18) | 0;
   HEAP32[i4 >> 2] = gb + 70416 + 8;
   STACKTOP = i5;
   return i4 | 0;
  }
 case 0:
  {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 default:
  {
   HEAP32[i4 >> 2] = i1;
   __Z6FormatPKcz(i3, gb + 489416 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 489330 | 0, 30, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 return 0;
}

function _UNITY_ft_smooth_renderer_class_pic_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 216 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i4 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 28, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i2 >> 2] = 1;
 _UNITY_FT_Init_Class_ft_grays_raster(i2 + 4 | 0);
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i5 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i5 + 4 >> 2] | 0);
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i1 = i5 + 24 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i4 | 0) >>> 2) << 2);
  __ZdlPv(i3);
 }
 __ZdlPv(i5);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i6 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) {
  i2 = (HEAP32[i6 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i1 = i1 & 255;
 }
 if ((i2 - i1 | 0) >>> 0 < i5 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i2, i5 - i2 + i1 | 0, i1, i1, 0, i5, i4); else if (i5 | 0) {
  if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
  _memcpy(i2 + i1 | 0, i4 | 0, i5 | 0) | 0;
  i1 = i1 + i5 | 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i6 + 4 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
 }
 return i6 | 0;
}

function __ZN8Animator19ClearPlayableMemoryEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 624 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
  __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(HEAP32[i1 >> 2] | 0, 0);
 }
 if (__ZNK9HPlayable7IsValidEv(i3 + 628 | 0) | 0) {
  i2 = HEAP32[(HEAP32[i3 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0);
 }
 i1 = i3 + 584 | 0;
 i2 = i3 + 600 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i3 = i3 + 596 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 588 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i3 + 596 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN24GenerateTypeTreeTransfer22AssertOptimizeTransferEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i5 = i6;
 i1 = i2 + 20 | 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i3, i1);
 if (!(HEAP32[i3 >> 2] | 0)) if ((HEAP32[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) + 12 >> 2] | 0) > 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 __ZNK16TypeTreeIterator8ChildrenEv(i4, i1);
 if (HEAP32[i4 >> 2] | 0) do {
  __ZL26AssertOptimizeTransferImplRK16TypeTreeIteratoriPi(i4, i3);
  __ZNK16TypeTreeIterator4NextEv(i5, i4);
  i7 = i5;
  i2 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i1 = i4;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i7;
 } while ((i2 | 0) != 0);
 STACKTOP = i6;
 return;
}

function __ZN15ReflectionProbe21SetCustomBakedTextureE4PPtrI7TextureE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 128 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 HEAP8[i4 + 160 >> 0] = 1;
 L4 : do if ((HEAP32[i4 + 40 >> 2] | 0) == 1) if ((HEAP32[i4 + 44 >> 2] | 0) == 1) {
  i3 = HEAP32[gb + 1112272 >> 2] | 0;
  i1 = HEAP32[i3 + 12 >> 2] | 0;
  i2 = HEAP32[i3 + 24 >> 2] | 0;
  if (i2 | 0) {
   i2 = i1 + (i2 << 2) | 0;
   while (1) {
    if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) break L4;
   }
   __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i3, 3, i4, 63);
  }
 } while (0);
 __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(HEAP32[gb + 1112272 >> 2] | 0, i4, HEAP32[i4 + 156 >> 2] | 0);
 return;
}

function __ZN12CubemapArrayD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 HEAP32[i2 >> 2] = gb + 41156 + 8;
 i4 = i2 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
  HEAP8[i4 >> 0] = 0;
 }
 HEAP32[i2 >> 2] = gb + 45392 + 8;
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i2 + 28 | 0);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine7Connect17DeviceInfoUpdaterC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 0;
 HEAP8[i1 + 49 >> 0] = 0;
 return;
}

function __Z28Animation_CUSTOM_RemoveClip2P12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZN9Animation10RemoveClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z26CstToAnimationClipSettingsPKN7mecanim9animation18ClipMuscleConstantER21AnimationClipSettings(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 1064 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 1068 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 1072 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 1076 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 1080 >> 2];
 HEAP8[i2 + 29 >> 0] = HEAP8[i1 + 1725 >> 0] | 0;
 i3 = HEAP16[i1 + 1726 >> 1] | 0;
 HEAP8[i2 + 30 >> 0] = i3;
 HEAP8[i2 + 31 >> 0] = (i3 & 65535) >>> 8;
 i3 = HEAP32[i1 + 1728 >> 2] | 0;
 HEAP8[i2 + 32 >> 0] = i3;
 HEAP8[i2 + 33 >> 0] = (i3 & 65535) >>> 8;
 HEAP8[i2 + 34 >> 0] = i3 >>> 24;
 i3 = HEAP32[i1 + 1732 >> 2] | 0;
 HEAP8[i2 + 35 >> 0] = i3;
 HEAP8[i2 + 36 >> 0] = (i3 & 65535) >>> 8;
 HEAP8[i2 + 37 >> 0] = i3 >>> 16;
 HEAP8[i2 + 38 >> 0] = HEAP8[i1 + 1724 >> 0] | 0;
 return;
}

function _UNITY_FT_Set_Renderer(i1, i7, i2, i3) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i7 = 33;
  return i7 | 0;
 }
 if (!i7) {
  i7 = 6;
  return i7 | 0;
 }
 i6 = (i2 | 0) == 0;
 if (!(i6 | (i3 | 0) != 0)) {
  i7 = 6;
  return i7 | 0;
 }
 i4 = i1 + 148 | 0;
 i5 = _UNITY_FT_List_Find(i4, i7) | 0;
 if (!i5) {
  i7 = 6;
  return i7 | 0;
 }
 _UNITY_FT_List_Up(i4, i5);
 if ((HEAP32[i7 + 16 >> 2] | 0) == 1869968492) HEAP32[i1 + 156 >> 2] = i7;
 i4 = HEAP32[(HEAP32[i7 + 12 >> 2] | 0) + 52 >> 2] | 0;
 if (i6) {
  i7 = 0;
  return i7 | 0;
 }
 while (1) {
  i1 = mftCall_iiii(i4 | 0, i7 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0) | 0;
  if (i1 | 0) {
   i2 = 10;
   break;
  }
  i2 = i2 + -1 | 0;
  if (!i2) {
   i1 = 0;
   i2 = 10;
   break;
  } else i3 = i3 + 8 | 0;
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZNK5physx2Sn21SerializationRegistry13getSerializerEt(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = i4 & 65535;
 i5 = i5 + ~(i5 << 15) | 0;
 i5 = (i5 >>> 10 ^ i5) * 9 | 0;
 i5 = i5 >>> 6 ^ i5;
 i5 = i5 + ~(i5 << 11) | 0;
 i1 = HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + ((i1 + -1 & (i5 >>> 16 ^ i5)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = i2 + 16 | 0;
 while (1) {
  i2 = i5 + (i1 << 3) | 0;
  if ((HEAP16[i2 >> 1] | 0) == i4 << 16 >> 16) break;
  i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = 0;
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return i1 | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0;
 return i6 | 0;
}

function __ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f7 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f10 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(f7 * f10);
 f9 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f8 = Math_fround(f8 - Math_fround(f9 * f6));
 f6 = Math_fround(Math_fround(f10 * f9) + Math_fround(f7 * f6));
 f8 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f8);
 f6 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) + f6);
 f7 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f9 = Math_fround(f6 - f7);
 HEAPF32[i2 >> 2] = Math_fround(f8 - f7);
 HEAPF32[i2 + 4 >> 2] = f9;
 f6 = Math_fround(f6 + f7);
 HEAPF32[i2 + 8 >> 2] = Math_fround(f8 + f7);
 HEAPF32[i2 + 12 >> 2] = f6;
 return;
}

function __ZN9DebugGLES4InitER7ApiGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 662 >> 0] | 0)) return;
 __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i2, 2);
 __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i2, 3);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 408 >> 2] | 0, fb + 31 | 0, i2 | 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, 4352, 4352, 4352, 0, 0, 1);
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, 4352, 33361, 37192, 0, 0, 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, 4352, 33361, 33387, 0, 0, 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, 4352, 33385, 33387, 0, 0, 0);
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, 4352, 33386, 33387, 0, 0, 0);
 return;
}

function __ZN5physx27PxRigidActorGeneratedValuesC2EPKNS_12PxRigidActorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i2 + 24 | 0, i1 | 0);
 return;
}

function __ZN5physx19NpArticulationJoint20setTwistLimitEnabledEb(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore20setTwistLimitEnabledEb(i1, i8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 120 >> 0] = i8 & 1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8192;
 return;
}

function __ZN15QualitySettings13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 405977 | 0, 20);
 i4 = i2 + 44 | 0;
 i5 = __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i3, HEAP32[i4 >> 2] | 0) | 0;
 i6 = (((HEAP32[i2 + 32 >> 2] | 0) - (HEAP32[i2 + 28 >> 2] | 0) | 0) / 108 | 0) + -1 | 0;
 HEAP32[i4 >> 2] = (i5 | 0) < 0 ? 0 : (i5 | 0) > (i6 | 0) ? i6 : i5;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZN15QualitySettings13ApplySettingsEib(i2, -1, 0);
 STACKTOP = i1;
 return;
}

function __ZN13TargetJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 HEAP32[i1 >> 2] = gb + 158108 + 8;
 STACKTOP = i4;
 return;
}

function __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_RaycastRK13Vector2fIcallS1_fiffP12RaycastHit2D(i1, i2, f3, i4, f5, f6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i11 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 if ((__ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di(i11, i10, i9, f3, i4, f5, f6, 0, 0, i7, 1) | 0) != 1) {
  STACKTOP = i8;
  return;
 }
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i7);
 STACKTOP = i8;
 return;
}

function __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff(i1, i2, i3, f4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 8 | 0;
 i9 = i8;
 i11 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i10 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16Physics2DManager14OverlapCapsuleERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2D(i11, i10, i9, i3, f4, i5, f6, f7, 0) | 0) | 0;
 STACKTOP = i8;
 return i5 | 0;
}

function __Z35Collider_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, i4 | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var f1 = f0, f2 = f0, f4 = f0, f6 = f0;
 f1 = Math_fround(HEAPF32[i3 + 84 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f4 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f4 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f2 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f2 = Math_fround(0.0);
 f1 = Math_fround(HEAPF32[i3 + 92 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 f6 = Math_fround(Math_fround(1.0) - f2);
 f2 = Math_fround(Math_fround(1.0) - f1);
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(1.0) - f4);
 HEAPF32[i5 + 4 >> 2] = f6;
 HEAPF32[i5 + 8 >> 2] = f2;
 return;
}

function __ZN8Animator8InitStepEf(i4, f2) {
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 548 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == 2) if (Math_fround(HEAPF32[i4 + 420 >> 2]) < Math_fround(0.0)) {
  __ZN8Animator23SetPlaybackTimeInternalEf(i4, Math_fround(Math_fround(__ZN14AvatarPlayback10CursorTimeEv(i4 + 504 | 0)) + f2));
  i1 = HEAP32[i3 >> 2] | 0;
 } else i5 = 4; else i5 = 4;
 if ((i5 | 0) == 4) HEAPF32[HEAP32[i4 + 128 >> 2] >> 2] = f2;
 switch (i1 | 0) {
 case 1:
  {
   i5 = 7;
   break;
  }
 case 2:
  {
   if (Math_fround(HEAPF32[i4 + 420 >> 2]) < Math_fround(0.0)) i5 = 7;
   break;
  }
 default:
  {}
 }
 if ((i5 | 0) == 7) {
  i5 = i4 + 552 | 0;
  HEAP32[HEAP32[i4 + 128 >> 2] >> 2] = HEAP32[i5 >> 2];
  HEAPF32[i5 >> 2] = Math_fround(0.0);
 }
 HEAP8[(HEAP32[i4 + 128 >> 2] | 0) + 18 >> 0] = HEAP8[i4 + 418 >> 0] | 0;
 return;
}

function __ZN5physx9NpFactory30releaseArticulationJointToPoolERNS_19NpArticulationJointE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 3340 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 3324 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 3336 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 3328 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 3320 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 3044 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 3, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMaxDepenetrationVelocityEf(i7, f1) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i7 + 48 | 0;
 f1 = Math_fround(-f1);
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i5 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i5 = i6;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  HEAPF32[i7 + 156 >> 2] = f1;
  return;
 }
 i3 = i7 + 56 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i2 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i3 >> 2] = i2;
 }
 HEAPF32[i2 + 172 >> 2] = f1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i6);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1024;
 return;
}

function __ZN5physx19NpArticulationJoint20setSwingLimitEnabledEb(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore20setSwingLimitEnabledEb(i1, i8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP8[i1 + 104 >> 0] = i8 & 1;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 512;
 return;
}

function __ZN4FMOD6System16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869187;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869187;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869187;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i2 + 44 | 0;
 i5 = i2 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do i1 = HEAP32[i1 + 4 >> 2] | 0; while ((i1 | 0) != (i5 | 0));
 i4 = i2 + 52 | 0;
 i6 = i2 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) != (i6 | 0)) do i1 = HEAP32[i1 + 4 >> 2] | 0; while ((i1 | 0) != (i6 | 0));
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i5 | 0)) do {
  _tlsf_walk_heap(HEAP32[i1 + 8 >> 2] | 0, fb + 210 | 0, 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i5 | 0));
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i6 | 0)) return 1;
 do {
  _tlsf_walk_heap(HEAP32[i1 + 8 >> 2] | 0, fb + 210 | 0, 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i6 | 0));
 return 1;
}

function __ZN14DetailDatabase21RemoveLocalLayerIndexEiR11DetailPatch(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = Math_imul(Math_imul(i5, i6) | 0, i5) | 0;
 i4 = (HEAP32[i7 + 40 >> 2] | 0) + i4 | 0;
 i5 = Math_imul(i5, i5) | 0;
 i1 = i4 + i5 | 0;
 if (i5 | 0) {
  i5 = i7 + 44 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = i2 - i1 | 0;
  if (i3) {
   _memmove(i4 | 0, i1 | 0, i3 | 0) | 0;
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i4 + i3 | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i1;
 }
 i4 = (HEAP32[i7 + 28 >> 2] | 0) + i6 | 0;
 i2 = i4 + 1 | 0;
 i5 = i7 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i1 - i2 | 0;
 if (!i3) i2 = i1; else {
  _memmove(i4 | 0, i2 | 0, i3 | 0) | 0;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 i1 = i4 + i3 | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i5 >> 2] = i1;
 return;
}

function __Z33Cloth_Get_Custom_PropCoefficientsP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  i2 = HEAP32[i2 + 128 + 12 >> 2] | 0;
  i3 = HEAP32[(__Z24GetClothScriptingClassesv() | 0) >> 2] | 0;
  i2 = (i1 | 0) == 0 ? 0 : i2;
  i3 = __Z19scripting_array_newP11Il2CppClassjj(i3, 8, i2) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 8) | 0, i1 | 0, i2 << 3 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __Z32GUIStyle_CUSTOM_AssignStyleStateP12Il2CppObjecti13Il2Cpp_IntPtr(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  i5 = i1 + 16 | 0;
  HEAP32[i5 + (i4 * 20 | 0) >> 2] = HEAP32[i3 >> 2];
  i7 = HEAP32[i3 + 8 >> 2] | 0;
  i1 = HEAP32[i3 + 12 >> 2] | 0;
  i2 = HEAP32[i3 + 16 >> 2] | 0;
  HEAP32[i5 + (i4 * 20 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i5 + (i4 * 20 | 0) + 8 >> 2] = i7;
  HEAP32[i5 + (i4 * 20 | 0) + 12 >> 2] = i1;
  HEAP32[i5 + (i4 * 20 | 0) + 16 >> 2] = i2;
  STACKTOP = i6;
  return;
 }
}

function _UNITY_ft_smooth_lcdv_renderer_class_pic_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 216 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i4 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 28, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i2 >> 2] = 1;
 _UNITY_FT_Init_Class_ft_grays_raster(i1);
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_FT_Glyph_Get_CBox(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i4) return;
 i5 = i4 + 12 | 0;
 i6 = i4 + 8 | 0;
 i7 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if (!i2) return;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(i1 | 0, i2 | 0, i4 | 0);
 if ((i3 | 2 | 0) == 3) {
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -64;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -64;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 63 & -64;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 63 & -64;
 }
 if ((i3 | 1 | 0) != 3) return;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] >> 6;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] >> 6;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] >> 6;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] >> 6;
 return;
}

function __ZNSt3__27promiseIvE24set_value_at_thread_exitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__217__assoc_sub_state24set_value_at_thread_exitEv(i1);
  STACKTOP = i2;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i4 >> 2] = 3;
 HEAP32[i4 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i3 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i4 | 0);
 } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
}

function __ZNK8VRDevice13GetDeviceNameEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 24 | 0;
 i7 = gb + 63648 | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i6 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = _strlen(i3) | 0;
 if (i2 >>> 0 <= 15) {
  i7 = i1;
  _memcpy(i7 | 0, i3 | 0, i2 | 0) | 0;
  i7 = i7 + i2 | 0;
  HEAP8[i7 >> 0] = 0;
  HEAP32[i4 >> 2] = i2;
  return;
 }
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i5, 0, gb + 1047486 | 0, 251) | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i2;
 i7 = (i7 | 0) == 0 ? i1 : i7;
 _memcpy(i7 | 0, i3 | 0, i2 | 0) | 0;
 i7 = i7 + i2 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i4 >> 2] = i2;
 return;
}

function __ZNK5physx7NpCloth22getSleepLinearVelocityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore22getSleepLinearVelocityEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 958, gb + 691912 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZNK5physx7NpCloth22getFrictionCoefficientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore22getFrictionCoefficientEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 684, gb + 693376 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZNK5physx3Cct13BoxController15getFootPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0;
 i6 = i2 + 416 | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i6 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i6 + 20 >> 2];
 f3 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 + 52 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) * f3);
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 40 >> 2]));
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 44 >> 2]));
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - +f5;
 i2 = i1 + 8 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - +f4;
 i2 = i1 + 16 | 0;
 HEAPF64[i2 >> 3] = +HEAPF64[i2 >> 3] - +f3;
 return;
}

function __ZN5physx31PxPrismaticJointGeneratedValuesC2EPKNS_16PxPrismaticJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 HEAPF32[i2 + 160 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i2 + 168 | 0, i1 | 0);
 HEAP16[i2 + 196 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 200 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 204 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 208 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741375;
 HEAP32[i1 + 4 >> 2] = 483;
 HEAP32[i1 + 8 >> 2] = fb + 416;
 HEAP32[i1 + 12 >> 2] = fb + 359;
 HEAP32[i1 + 16 >> 2] = gb + 741387;
 HEAP32[i1 + 20 >> 2] = 484;
 HEAP32[i1 + 24 >> 2] = fb + 417;
 HEAP32[i1 + 28 >> 2] = fb + 360;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 485;
 HEAP32[i1 + 40 >> 2] = fb + 418;
 HEAP32[i1 + 44 >> 2] = fb + 361;
 HEAP32[i1 + 48 >> 2] = gb + 741403;
 HEAP32[i1 + 52 >> 2] = 486;
 HEAP32[i1 + 56 >> 2] = fb + 419;
 HEAP32[i1 + 60 >> 2] = fb + 362;
 HEAP32[i1 + 64 >> 2] = gb + 741411;
 HEAP32[i1 + 68 >> 2] = 487;
 HEAP32[i1 + 72 >> 2] = fb + 420;
 HEAP32[i1 + 76 >> 2] = fb + 363;
 HEAP32[i1 + 80 >> 2] = gb + 900348;
 HEAP32[i1 + 84 >> 2] = 490;
 HEAP32[i1 + 88 >> 2] = fb + 446;
 HEAP32[i1 + 92 >> 2] = fb + 385;
 return;
}

function __ZN5physx2Sc5Scene18removeArticulationERNS0_16ArticulationCoreE(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx2Sc15ArticulationSimD2Ev(i1);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i7, i1);
 }
 i5 = i2 + 120 | 0;
 i3 = i2 + 124 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L4 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L4;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  STACKTOP = i7;
  return;
 }
 i4 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i4 << 2) >> 2];
 STACKTOP = i7;
 return;
}

function __ZN5physx2Sc14ConstraintCoreC2ERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 HEAP16[i4 >> 1] = 64;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 + 20 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = i1;
 HEAP32[i4 + 32 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 48 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 52 >> 2] = i2;
 HEAPF32[i4 + 56 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 60 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i4 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i4 + 68 >> 2] = 0;
 return;
}

function __ZN5physx17clothSphereWriterERNS_14PxOutputStreamERKNS_22PxClothCollisionSphereE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 i4 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2) | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +Math_fround(HEAPF32[i2 + 12 >> 2]);
 i1 = i5;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i6 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i6) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i4 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx14NpArticulation22setSeparationToleranceEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore22setSeparationToleranceEf(i1, f8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 12 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
 return;
}

function __ZN4PPtrI6ObjectE8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i3 + 8 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 if (!(HEAP32[i2 >> 2] & 1)) {
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1, gb + 1048093 | 0, 1, 0);
  __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb(i2, i4, gb + 1048102 | 0, 1, 0);
  STACKTOP = i5;
  return;
 } else {
  __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i3, gb + 1048093 | 0, 1, 0);
  __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb(i2, i4, gb + 1048102 | 0, 1, 0);
  __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i3, i1);
  STACKTOP = i5;
  return;
 }
}

function __ZN22ParticleSystemRendererD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83088 + 8;
 HEAP32[i2 + 32 >> 2] = gb + 83088 + 196;
 i1 = i2 + 532 | 0;
 if ((HEAP32[i2 + 548 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 536 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 512 | 0;
 if ((HEAP32[i2 + 528 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 516 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 492 | 0;
 if ((HEAP32[i2 + 508 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 496 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 472 | 0;
 if ((HEAP32[i2 + 488 >> 2] | 0) <= -1) {
  __ZN8RendererD2Ev(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 476 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN8RendererD2Ev(i2);
 return;
}

function __ZN13MonoBehaviour40AddExternalDependencyCallbacksToManagersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN13MonoBehaviour33AddImageEffectCallbacksToManagersEv(i2);
 i5 = __Z9GetIAudiov() | 0;
 if (!i5) return;
 i4 = __Z9GetIAudiov() | 0;
 if (!i4) return;
 i3 = i2 + 144 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  if (!i1) return;
  if (!(HEAP32[i1 + 144 >> 2] | 0)) return;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i1) return;
  if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   break;
  } else return;
 } while (0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 60 >> 2] | 0, i5 | 0, i1 | 0, 0);
 return;
}

function __Z55RuntimeAnimatorController_Get_Custom_PropAnimationClipsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0) | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(74) | 0;
  i3 = __Z19GetScriptingManagerv() | 0;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i1 + 12 >> 2] | 0) | 0;
  __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i(i2, i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function _UNITY_ft_smooth_lcd_renderer_class_pic_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 216 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  i4 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 28, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i2 >> 2] = 1;
 _UNITY_FT_Init_Class_ft_grays_raster(i1);
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNKSt3__212ctype_bynameIwE8do_widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _uselocale(HEAP32[i1 + 8 >> 2] | 0) | 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2807 | 0, i2 << 24 >> 24 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i3 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i3);
   }
  }
  ___resumeException(i1 | 0);
 } else {
  if (i3 | 0) {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i3 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i3 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i3);
   }
  }
  return i1 | 0;
 }
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwjj(i2, i6, i3, i7) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i8 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (!i7) i5 = -1; else {
  i4 = i2;
  i1 = i2 + ((i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) << 2) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i5 = -1;
    break L5;
   }
   i1 = i1 + -4 | 0;
   __THREW__ = 0;
   i3 = invoke_iiii(fb + 514 | 0, i6 | 0, i7 | 0, i1 | 0) | 0;
   i8 = __THREW__;
   __THREW__ = 0;
   if (i8 & 1) break;
   if (i3) {
    i5 = i1 - i4 >> 2;
    break L5;
   }
  }
  i8 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i8);
 } while (0);
 return i5 | 0;
}

function __ZNK5physx7NpCloth21getStiffnessFrequencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore21getStiffnessFrequencyEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 866, gb + 697659 | 0, i2);
  f5 = Math_fround(60.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 252 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 + 244 >> 2] | 0;
 i5 = i1 + 248 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 48 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 48 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 48 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx14NpArticulation25setStabilizationThresholdEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf(i1, f8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 16 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
 return;
}

function __ZN5Unity10HingeJoint24WriteTwistLimitAsLimitedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, f6 = f0;
 f6 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f3 = Math_fround(-f6);
 i4 = f6 > Math_fround(177.0);
 i5 = f3 > Math_fround(177.0);
 f3 = Math_fround(Math_fround(Math_fround((i5 ? Math_fround(177.0) : f3) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f3 = i4 ? Math_fround(-3.08923292) : f3;
 f6 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f2 = Math_fround(-f6);
 i4 = f6 > Math_fround(177.0);
 i5 = f2 > Math_fround(177.0);
 f2 = Math_fround(Math_fround(Math_fround((i5 ? Math_fround(177.0) : f2) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f2 = i4 ? Math_fround(-3.08923292) : f2;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, 3, f3 != f2 | 0);
 return;
}

function __ZN4FMOD3DSP5resetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i4 >> 2] = 78;
   HEAP32[i4 + 4 >> 2] = gb + 868857;
   _printf(gb + 857490 | 0, i4) | 0;
   HEAP32[i5 >> 2] = 78;
   HEAP32[i5 + 4 >> 2] = gb + 868857;
   _printf(gb + 853343 | 0, i5) | 0;
   i5 = 78;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868857;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI6Canvas15AddNestedCanvasEPS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 HEAP32[i4 >> 2] = i3;
 i1 = HEAP32[i2 + 424 >> 2] | 0;
 i5 = i2 + 428 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i3;
 L1 : do if ((i1 | 0) != (i6 | 0)) {
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i6 | 0)) break L1;
  }
  STACKTOP = i8;
  return;
 } while (0);
 if ((i6 | 0) == (HEAP32[i2 + 432 >> 2] | 0)) __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_(i2 + 424 | 0, i4); else {
  HEAP32[i6 >> 2] = i7;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 }
 i7 = i2 + 224 | 0;
 HEAP16[i7 >> 1] = HEAPU16[i7 >> 1] | 0 | 4;
 STACKTOP = i8;
 return;
}

function __ZN24RigidbodyMovementState2D23ResetInterpolationStateEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 if (!i2) return;
 i2 = i1 + 12 | 0;
 i4 = i1 + 68 | 0;
 i3 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i1 + 24 | 0;
 i3 = i1 + 80 | 0;
 i1 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN18CrashReportHandler27DidReloadMonoDomainCallbackEPS_(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i5 = i4 + 36280 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i6);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i1 + 1;
 HEAP32[i4 + 35512 + (i1 * 12 | 0) + 4 >> 2] = i3;
 HEAP8[i4 + 35512 + (i1 * 12 | 0) + 8 >> 0] = 1;
 HEAP32[i4 + 35512 + (i1 * 12 | 0) >> 2] = fb + 168;
 STACKTOP = i6;
 return;
}

function __ZN18ColorBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6 + 8 | 0, i1);
 i2 = i6 + 164 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN16ReflectionProbes24ScheduleAutomaticRefreshEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i7 = i9;
 i8 = i1 + 12 | 0;
 i5 = i1 + 24 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  STACKTOP = i9;
  return;
 }
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2;
 do {
  i3 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i3 + 44 >> 2] | 0) == 1) if ((HEAP32[i3 + 40 >> 2] | 0) == 1) {
   i2 = HEAP32[i3 + 48 >> 2] | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
   __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb(i3, i2, i6, 0) | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) != (i2 + (i1 << 2) | 0));
 STACKTOP = i9;
 return;
}

function __ZN13BuildSettings20GetSceneIndexCheckedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 i1 = __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if ((i1 | 0) != -1) {
  STACKTOP = i5;
  return i1 | 0;
 }
 HEAP32[i4 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 __Z6FormatPKcz(i3, gb + 443947 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 443603 | 0, 138, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return i1 | 0;
}

function __Z34Hash128_CUSTOM_INTERNAL_CALL_ParseP12Il2CppStringR7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 28 | 0;
 i5 = i3;
 i4 = i3 + 16 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i7, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i7);
 __Z15StringToHash128RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i4);
 i7 = i5;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 i5 = i5 + 8 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function _tre_add_tag_right(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = ___tre_mem_alloc_impl(i1, 0, 0, 0, 8) | 0;
 do if (!i5) i1 = 12; else {
  i3 = _tre_ast_new_node(i1, 0, 20) | 0;
  if (!i3) {
   HEAP32[i5 + 4 >> 2] = 0;
   i1 = 12;
   break;
  }
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = -3;
  HEAP32[i6 + 4 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = -1;
  HEAP32[i5 + 4 >> 2] = i3;
  i1 = ___tre_mem_alloc_impl(i1, 0, 0, 0, 32) | 0;
  HEAP32[i5 >> 2] = i1;
  if (!i1) i1 = 12; else {
   i6 = i4 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 8 >> 2] = -1;
   HEAP32[i1 + 12 >> 2] = -1;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i4 >> 2] = 1;
   i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function _mkdtemp(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = _strlen(i1) | 0;
 L1 : do if (i2 >>> 0 < 6) i4 = 3; else {
  i3 = i1 + i2 + -6 | 0;
  if (!(_memcmp(i3, gb + 1076012 | 0, 6) | 0)) {
   i2 = 100;
   do {
    ___randname(i3) | 0;
    if (!(_mkdir(i1, 448) | 0)) break L1;
    i2 = i2 + -1 | 0;
    if (!i2) break;
   } while ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 17);
   HEAP8[i3 >> 0] = HEAP8[gb + 1076012 >> 0] | 0;
   HEAP8[i3 + 1 >> 0] = HEAP8[gb + 1076012 + 1 >> 0] | 0;
   HEAP8[i3 + 2 >> 0] = HEAP8[gb + 1076012 + 2 >> 0] | 0;
   HEAP8[i3 + 3 >> 0] = HEAP8[gb + 1076012 + 3 >> 0] | 0;
   HEAP8[i3 + 4 >> 0] = HEAP8[gb + 1076012 + 4 >> 0] | 0;
   HEAP8[i3 + 5 >> 0] = HEAP8[gb + 1076012 + 5 >> 0] | 0;
   i1 = 0;
  } else i4 = 3;
 } while (0);
 if ((i4 | 0) == 3) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZThn8_N5physx13NpClothFabric14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 if (!(__ZN5physx9NpFactory17removeClothFabricERNS_13PxClothFabricE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 723768 | 0, 84, gb + 723849 | 0, i2);
  STACKTOP = i2;
  return;
 }
 if (!(HEAP16[i1 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0); else __ZN5physx9NpFactory24releaseClothFabricToPoolERNS_13NpClothFabricE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i1, 0, 2);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx7NpCloth21getCollisionMassScaleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore21getCollisionMassScaleEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 744, gb + 693212 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZNK5physx2Sn9MetaClass14getFieldByTypeEPKcRNS0_15PxMetaDataEntryE(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i4) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = 0;
 while (1) {
  i1 = i2 + (i3 << 5) | 0;
  i3 = i3 + 1 | 0;
  if (!(_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0)) break;
  if (i3 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return i1 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i6 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i6 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i6 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 i7 = 1;
 return i7 | 0;
}

function __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE(i4, i1, i2, i3, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_(HEAP32[i4 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 __ZN7mecanim13CopyValueMaskEPNS_14ValueArrayMaskEPKS0_(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
 __ZN7mecanim9animation16MotionOutputCopyEPNS0_12MotionOutputEPKS1_bbRKNS_6bitsetILj66EEE(HEAP32[i1 + 8 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, i2, i3, i5);
 if (!i3) return;
 __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_RKNS_6bitsetILj66EEE(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0, i5);
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) return;
 __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_RKNS_6bitsetILj66EEE(i1, HEAP32[i4 + 16 >> 2] | 0, i5);
 return;
}

function __ZN5physx9NpFactory29releaseArticulationLinkToPoolERNS_18NpArticulationLinkE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 3040 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 3024 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 3036 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 3028 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 3020 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 2744 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx7NpCloth24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 290, gb + 695889 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx3Cct9SweepTestD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 28 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 20 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP16[i3 >> 1] | 0;
 if (!i1) {
  i5 = i4 + 72 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -65536 | i2 & 65535;
  return;
 }
 if (!(i2 & 99)) {
  i5 = i4 + 72 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -65536 | i2 & 65535;
 } else {
  i2 = __ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0;
  __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb(i2, i4, 0);
  i1 = i4 + 72 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -65536 | (HEAPU16[i3 >> 1] | 0);
  __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE(i2, i4);
  i2 = HEAP16[i3 >> 1] | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 __ZN5physx2Sc17ParticleSystemSim8setFlagsEj(i1, i2 & 65535);
 return;
}

function __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 + 4 >> 2] = i3;
 if (i1 >>> 0 > 65535 | i2) {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i3 * 12 | 0, gb + 724949 | 0, 188) | 0;
  HEAP32[i4 + 12 >> 2] = i3;
  i4 = i4 + 156 | 0;
  HEAP8[i4 >> 0] = (HEAPU8[i4 >> 0] | 0) & 253;
  i4 = i3;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5 + 1 | 0, i3 * 6 | 0, gb + 724949 | 0, 183) | 0;
  HEAP32[i4 + 12 >> 2] = i3;
  i4 = i4 + 156 | 0;
  HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 2;
  i4 = i3;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx16clothPlaneWriterERNS_14PxOutputStreamERKNS_21PxClothCollisionPlaneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 i4 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2) | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +Math_fround(HEAPF32[i2 + 12 >> 2]);
 i1 = i5;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i6 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i6) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i4 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5Umbra9Matrix3x3mLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 28 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 return i1 | 0;
}

function __ZN29DelayedPointerDeletionManager29AddPointerToMainThreadDeallocEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 4 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i4;
 i5 = i1 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i4 >>> 0 > i6 >>> 0) {
  i6 = i6 << 1;
  i6 = i6 >>> 0 < 128 ? 128 : i6;
  HEAP32[i5 >> 2] = i6;
  i5 = HEAP32[i1 + 20 >> 2] | 0;
  i5 = mftCall_iiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i1 >> 2] | 0, i6 << 2 | 0, 16) | 0;
  HEAP32[i1 >> 2] = i5;
  i6 = HEAP32[i3 >> 2] | 0;
  i6 = i6 + -1 | 0;
  i6 = i5 + (i6 << 2) | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i1 + 12 | 0;
  HEAP32[i6 >> 2] = 1;
  return;
 } else {
  i6 = i4;
  i5 = HEAP32[i1 >> 2] | 0;
  i6 = i6 + -1 | 0;
  i6 = i5 + (i6 << 2) | 0;
  HEAP32[i6 >> 2] = i2;
  i6 = i1 + 12 | 0;
  HEAP32[i6 >> 2] = 1;
  return;
 }
}

function __ZN23b2ChainAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i6 >> 2] = gb + 151648 + 8;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP32[i6 + 8 >> 2] = HEAP32[gb + 151644 >> 2];
 i8 = i6 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 + 8 >> 2] = 0;
 HEAP32[i8 + 12 >> 2] = 0;
 HEAP16[i8 + 16 >> 1] = 0;
 __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei(i7, i6, HEAP32[i1 + 56 >> 2] | 0);
 __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_(i2, i6, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_119PvdConnectionReaderD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 148220 + 8;
 HEAP8[i3 + 20 >> 0] = 0;
 i2 = i3 + 4 | 0;
 __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv(HEAP32[i2 >> 2] | 0) | 0;
 i5 = HEAP32[i3 + 16 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
 HEAP32[i3 >> 2] = gb + 86828 + 8;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i2 >> 2] | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
  STACKTOP = i4;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z18HandleSteppedCurveRK11KeyframeTplI11QuaternionfES3_RS0_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i2 + 36 | 0;
 if (!(Math_fround(HEAPF32[i4 >> 2]) == Math_fround(inf))) {
  i1 = i1 + 20 | 0;
  if (!(Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i4 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf))) return;
 }
 i4 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 8 | 0;
 i5 = i1 + 3 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 if (i4) i2 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i2 = 1;
 do if (i2 >>> 0 < i8 >>> 0) {
  if (i4) i1 = HEAP32[i6 + 4 >> 2] | 0; else i1 = i3 & 255;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw(i6, i2, i8 - i2 | 0, i1, 0, i1, i8, i7);
 } else {
  if (i4) i1 = HEAP32[i6 >> 2] | 0; else i1 = i6;
  __ZNSt3__211char_traitsIwE4moveEPwPKwj(i1, i7, i8) | 0;
  HEAP32[i1 + (i8 << 2) >> 2] = 0;
  if ((HEAP8[i5 >> 0] | 0) < 0) {
   HEAP32[i6 + 4 >> 2] = i8;
   break;
  } else {
   HEAP8[i5 >> 0] = i8;
   break;
  }
 } while (0);
 return i6 | 0;
}

function __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 L1 : do if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i5, i6); else {
  i4 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = i1 + 16 + (i4 << 3) | 0;
  __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1 + 16 | 0, i2, i5, i6);
  if ((i4 | 0) > 1) {
   i4 = i2 + 54 | 0;
   i1 = i1 + 24 | 0;
   do {
    __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i5, i6);
    if (HEAP8[i4 >> 0] | 0) break L1;
    i1 = i1 + 8 | 0;
   } while (i1 >>> 0 < i3 >>> 0);
  }
 } while (0);
 return;
}

function __ZN5physx16PxsIslandManager28clearDeletedNodeStateChangesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i1 + 320 >> 2] | 0;
 i6 = HEAP32[i1 + 316 >> 2] | 0;
 if (!i3) return;
 i7 = HEAP32[HEAP32[i1 + 264 >> 2] >> 2] | 0;
 i4 = HEAP32[HEAP32[i1 + 268 >> 2] >> 2] | 0;
 i5 = HEAP32[HEAP32[i1 + 272 >> 2] >> 2] | 0;
 i1 = HEAP32[HEAP32[i1 + 276 >> 2] >> 2] | 0;
 i2 = 0;
 do {
  i8 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  i9 = ~(1 << (i8 & 31));
  i8 = i8 >>> 5;
  i10 = i7 + (i8 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & i9;
  i10 = i4 + (i8 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & i9;
  i10 = i5 + (i8 << 2) | 0;
  HEAP32[i10 >> 2] = HEAP32[i10 >> 2] & i9;
  i8 = i1 + (i8 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & i9;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN5physx14NpArticulation26setMaxProjectionIterationsEj(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore26setMaxProjectionIterationsEj(i1, i8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 8 >> 2] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4;
 return;
}

function __ZN5physx14NpArticulation26setExternalDriveIterationsEj(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore26setExternalDriveIterationsEj(i1, i8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 + 4 >> 2] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2;
 return;
}

function __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 i2 = i6 + 36 | 0;
 i8 = i1 + 16 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i8, i2, 4);
  i4 = HEAP32[i8 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i8 >> 2] = i4;
 }
 i1 = i6 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i8, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i8 >> 2] = i2;
 }
 if (!i7) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN23ShaderVariantCollection8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i5 = i1 + 36 | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 i6 = i3 + 16 | 0;
 i7 = i3 + 36 | 0;
 i4 = i3 + 40 | 0;
 while (1) {
  i3 = i2 + 16 | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i3 >> 2] = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN19RuntimeSceneManager24PrepareNewBootstrapSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = __ZN19RuntimeSceneManager11CreateSceneEv(i1) | 0;
 if ((HEAP32[i2 + 80 >> 2] | 0) != 2) return;
 i1 = i1 + 44 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i6 | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv(i2);
 i5 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + 37052 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return; else i1 = 0;
 do {
  i3 = i5 + 36284 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i5 + 36284 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vii(HEAP32[i3 >> 2] | 0, i6 | 0, i4 | 0); else mftCall_viii(HEAP32[i3 >> 2] | 0, HEAP32[i5 + 36284 + (i1 * 12 | 0) + 4 >> 2] | 0, i6 | 0, i4 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return;
}

function __ZN17GenericDynamicVBO20ReleaseChunkInternalERK21DynamicVBOChunkHandlejj(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0, i1 | 0, 0) | 0;
 i2 = Math_imul(HEAP32[i4 + 4 >> 2] | 0, i2) | 0;
 i3 = i3 << 1;
 i1 = i5 + 76 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i6 + i2;
 HEAP32[i4 + 28 >> 2] = i6;
 i6 = i5 + 80 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i1 + i3;
 HEAP32[i4 + 32 >> 2] = i1;
 i1 = HEAP32[i4 + 20 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[i5 + 28 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 232 >> 2] | 0, i6 | 0, i1 | 0, i2 | 0);
 }
 i1 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i5 + 28 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 232 >> 2] | 0, i6 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN15ReflectionProbe15SetBakedTextureE4PPtrI7TextureE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 124 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 HEAP8[i4 + 160 >> 0] = 1;
 L4 : do if ((HEAP32[i4 + 40 >> 2] | 0) == 1) if ((HEAP32[i4 + 44 >> 2] | 0) == 1) {
  i3 = HEAP32[gb + 1112272 >> 2] | 0;
  i1 = HEAP32[i3 + 12 >> 2] | 0;
  i2 = HEAP32[i3 + 24 >> 2] | 0;
  if (i2 | 0) {
   i2 = i1 + (i2 << 2) | 0;
   while (1) {
    if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
    i1 = i1 + 4 | 0;
    if ((i1 | 0) == (i2 | 0)) break L4;
   }
   __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i3, 3, i4, 63);
  }
 } while (0);
 __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(HEAP32[gb + 1112272 >> 2] | 0, i4, HEAP32[i4 + 156 >> 2] | 0);
 return;
}

function __ZN13RendererScene15EndCameraRenderEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 40 | 0;
 i4 = i2 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i3 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_(i6, i6 + (i1 << 2) | 0, i5);
 i1 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 if ((i1 | 0) > -1) do {
  __ZN13RendererScene14RemoveRendererEi(i2, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) | 0;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) > -1);
 i1 = i2 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_120createParticleSystemEjb(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 3640 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 3636 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 3344 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i4 = i2 + 3624 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i2 + 3628 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  i6 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 __ZN5physx16NpParticleSystemC2Ejb(i1, i5, i6);
 i6 = i1;
 i5 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __Z70Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D9GetVectorERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __ZZN2UI11CanvasGroup15InitializeClassEvEN40FunctorImpl_119kTransformChildrenChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZNK5physx2Sc9ClothCore24getParticleAccelerationsEPNS_6PxVec4E(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 316 >> 2] | 0, i2 | 0) | 0;
 if (!i2) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i7 = mftCall_ii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0) | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 40 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4 + (i2 << 4);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 mftCall_viii(i8 | 0, i7 | 0, i1 | 0, i5 | 0);
 i5 = 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK17AnimationCurveTplIfE9FindIndexEf(i1, f8) {
 i1 = i1 | 0;
 f8 = Math_fround(f8);
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i9) {
  f2 = Math_fround(inf);
  f3 = Math_fround(-inf);
 } else {
  i7 = HEAP32[i1 + 56 >> 2] | 0;
  f2 = Math_fround(HEAPF32[i7 >> 2]);
  f3 = Math_fround(HEAPF32[i7 + (i9 + -1 << 4) >> 2]);
 }
 if (!(!(f2 >= f8) & !(f3 <= f8))) {
  i9 = -1;
  return i9 | 0;
 }
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 i7 = i6;
 i1 = i9 << 4 >> 4;
 L7 : while (1) {
  while (1) {
   if (!i1) break L7;
   i4 = (i1 | 0) / 2 | 0;
   i5 = i6 + (i4 << 4) | 0;
   if (Math_fround(HEAPF32[i5 >> 2]) < f8) break; else i1 = i4;
  }
  i6 = i5 + 16 | 0;
  i1 = i1 + -1 - i4 | 0;
 }
 i7 = (i6 - i7 >> 4) + -1 | 0;
 i9 = i9 + -2 | 0;
 i9 = (i7 | 0) < (i9 | 0) ? i7 : i9;
 i9 = (i9 | 0) > 0 ? i9 : 0;
 return i9 | 0;
}

function __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 do if ((i1 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  if ((HEAP32[i3 + 4 >> 2] | 0) == (i4 | 0)) {
   i1 = i3 + 28 | 0;
   if ((HEAP32[i1 >> 2] | 0) != 1) HEAP32[i1 >> 2] = i5;
  }
 } else if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  if ((HEAP32[i3 + 16 >> 2] | 0) != (i4 | 0)) {
   i1 = i3 + 20 | 0;
   if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) {
    HEAP32[i3 + 32 >> 2] = i5;
    HEAP32[i1 >> 2] = i4;
    i5 = i3 + 40 | 0;
    HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
    if ((HEAP32[i3 + 36 >> 2] | 0) == 1) if ((HEAP32[i3 + 24 >> 2] | 0) == 2) HEAP8[i3 + 54 >> 0] = 1;
    HEAP32[i3 + 44 >> 2] = 4;
    break;
   }
  }
  if ((i5 | 0) == 1) HEAP32[i3 + 32 >> 2] = 1;
 } while (0);
 return;
}

function __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[gb + 1104268 >> 2] | 0;
 i8 = i1 + 12 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) {
  i9 = 0;
  HEAP32[i8 >> 2] = i9;
  return;
 } else {
  i4 = i1;
  i3 = 0;
 }
 while (1) {
  if ((HEAP32[i4 + 8 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) break;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  if (!i2) {
   i9 = 10;
   break;
  } else {
   i3 = i4;
   i4 = i2;
  }
 }
 if ((i9 | 0) == 10) {
  HEAP32[i8 >> 2] = i1;
  return;
 }
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i4 + 12 | 0;
 HEAP32[i9 >> 2] = (HEAP32[i9 >> 2] | 0) + -1;
 if (!(HEAP32[i9 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i7, i4);
 if (i3 | 0) HEAP32[i3 + 4 >> 2] = i2;
 i9 = (i4 | 0) == (i1 | 0) ? i2 : i1;
 HEAP32[i8 >> 2] = i9;
 return;
}

function __ZN5Umbra18testAndSetBitRangeEPjii(i1, i3, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = i3 >> 5;
 i1 = i1 + (i6 << 2) | 0;
 i2 = i7 - i3 | 0;
 i5 = i3 & 31;
 i4 = -1 << i5;
 if ((i5 | 0) == 0 | (i6 | 0) == (i7 >> 5 | 0)) {
  i6 = i1;
  i5 = i4;
  i1 = 0;
 } else {
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i8 | i4;
  i6 = i1 + 4 | 0;
  i2 = i2 + (i3 | -32) | 0;
  i5 = -1;
  i1 = i8 & i4;
 }
 if ((i2 | 0) > 31) {
  i4 = i2;
  i3 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i1 = i3 | i1;
   i4 = i4 + -32 | 0;
   if ((i4 | 0) <= 31) break; else i3 = -1;
  }
  HEAP32[i6 >> 2] = -1;
  i2 = i2 & 31;
 }
 if (!i2) {
  i8 = i1;
  i8 = (i8 | 0) != 0;
  return i8 | 0;
 }
 i4 = HEAP32[i6 >> 2] | 0;
 i8 = i5 & (1 << (i7 & 31)) + -1;
 HEAP32[i6 >> 2] = i4 | i8;
 i8 = i4 & i8 | i1;
 i8 = (i8 | 0) != 0;
 return i8 | 0;
}

function __ZN2UI6Canvas17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN2UI15ClearCanvasDataER8JobFenceRNS_10CanvasDataE(i1 + 332 | 0, i1 + 112 | 0);
 __ZN2UI7Batches7DestroyEv(i1 + 228 | 0);
 i4 = i1 + 436 | 0;
 i3 = i1 + 440 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i4 >> 2] = i4;
  return;
 }
 do {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i4 | 0));
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i4 >> 2] = i4;
  return;
 }
 do {
  i5 = i1 + 4 | 0;
  i2 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i4;
 HEAP32[i4 >> 2] = i4;
 return;
}

function __ZN11AudioSource6UpdateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1459980 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459980 | 0, i1);
  i3 = gb + 1459980 | 0;
 } else i3 = 0;
 i2 = i4 + 500 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetAudioManagerv() | 0;
  i1 = __ZN12AudioManager22GetAutomaticUpdateModeEP10GameObject(i1, HEAP32[i4 + 28 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 if ((i1 | 0) == 2) if (HEAP8[i4 + 33 >> 0] | 0) __ZN11AudioSource16UpdateParametersEv(i4);
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i5;
 return;
}

function __Z41Application_Get_Custom_PropCloudProjectIdv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i1 = i2 + 44 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 48 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i5 >> 2] | 0 : i5, i3 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return i4 | 0;
}

function __Z36CommandBuffer_CUSTOM_SetGlobalBufferP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i9 + 12 | 0;
 i4 = i9;
 i6 = i9 + 8 | 0;
 i7 = i9 + 4 | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 if (!i3) i8 = 7; else {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if (!i1) i8 = 7; else HEAP32[i7 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 if ((i8 | 0) == 7) HEAP32[i7 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 __ZN22RenderingCommandBuffer18AddSetGlobalBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferID(i2, i6, i5);
 STACKTOP = i9;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 0 ? i3 + (HEAP32[i1 + 12 >> 2] | 0) + -8 | 0 : i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i5, HEAP32[i2 + 4 >> 2] | 0, gb + 1034406 | 0, i4, 1) | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 if ((i1 | 0) > 0) __ZN4AABB8TransferI14SafeBinaryReadEEvRT_(i3, i5); else {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i5 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i5);
 STACKTOP = i6;
 return;
}

function __Z11bucketAllocP11BucketAlloc(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) i2 = 3; else if (!(HEAP32[i1 >> 2] | 0)) i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i5 + 8 | 0;
  i2 = i5 + 12 | 0;
  i4 = (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) + 4 | 0;
  i3 = HEAP32[i5 + 20 >> 2] | 0;
  i4 = mftCall_iii(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0, i4 | 0) | 0;
  if (!i4) {
   i5 = 0;
   return i5 | 0;
  }
  i3 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i4;
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = (Math_imul(HEAP32[i2 >> 2] | 0, i3) | 0) + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  do {
   i2 = i2 - i3 | 0;
   i6 = i1;
   i1 = i4 + i2 | 0;
   HEAP32[i1 >> 2] = i6;
  } while ((i2 | 0) != 4);
  HEAP32[i5 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 i6 = i1;
 return i6 | 0;
}

function _cbrtf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0, d5 = 0.0, d6 = 0.0, d7 = 0.0, d8 = 0.0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i2 & 2147483647;
 do if (i3 >>> 0 > 2139095039) f1 = Math_fround(f1 + f1); else {
  if (i3 >>> 0 < 8388608) {
   if (!i3) break;
   f4 = Math_fround(f1 * Math_fround(16777216.0));
   i2 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = (((i2 & 2147483647) >>> 0) / 3 | 0) + 642849266 | 0;
  } else i3 = ((i3 >>> 0) / 3 | 0) + 709958130 | 0;
  d5 = +(HEAP32[tempDoublePtr >> 2] = i2 & -2147483648 | i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  d8 = d5 * (d5 * d5);
  d6 = +f1;
  d7 = d6 + d6;
  d8 = d5 * (d7 + d8) / (d8 + (d6 + d8));
  d5 = d8 * (d8 * d8);
  f1 = Math_fround(d8 * (d7 + d5) / (d5 + (d6 + d5)));
 } while (0);
 return Math_fround(f1);
}

function __ZThn4_N5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE(i1, f3, i2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i1 = i1 + -4 | 0;
 if (!(HEAP32[i1 + 36 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  return i2 | 0;
 } else {
  i4 = i1 + 44 | 0;
  HEAP32[i1 + 60 >> 2] = 1;
  i5 = i1 + 56 | 0;
  HEAP32[i5 >> 2] = i2;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
  HEAP32[i1 + 52 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
  HEAPF32[i1 + 68 >> 2] = f3;
  HEAP32[i1 + 24 >> 2] = 1;
  i2 = i1 + 20 | 0;
  HEAP32[i2 >> 2] = i4;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  HEAP32[i1 + 16 >> 2] = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  i2 = i1 + 8 | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx7NpCloth19getPreviousTimeStepEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore19getPreviousTimeStepEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1034, gb + 697823 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  HEAP16[i6 + 2 >> 1] = 15360;
  if (!i1) break; else {
   i6 = i6 + 4 | 0;
   i5 = i5 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx2Sn5ConvX14exportIntAsPtrEi(i7, i2) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i1 = i8 + 8 | 0;
 i3 = i8;
 i4 = HEAP32[i7 + 316 >> 2] | 0;
 i5 = HEAP32[i7 + 320 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i6 + 24 >> 2] = 0;
 HEAP32[i6 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 i9 = i3;
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = 0;
 switch (i4 | 0) {
 case 4:
  break;
 case 8:
  {
   i1 = i3;
   break;
  }
 default:
  i1 = 0;
 }
 __ZN5physx2Sn5ConvX20convertExtraData_PtrEPKcS3_RKNS0_15PxMetaDataEntryEiii(i7, i1, 0, i6, 1, i4, i5) | 0;
 STACKTOP = i8;
 return;
}

function __ZN5physx2Cm17FreeListAllocatorD0Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = gb + 110628 + 8;
 i5 = i7 + 4240 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = i2;
   i3 = i1 + 4 | 0;
   if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) HEAP32[i5 >> 2] = i4; else HEAP32[i2 >> 2] = i4;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i4 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i6 = i7 + 12 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i6 >> 2] | 0);
 i5 = HEAP32[i7 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i6 >> 2] | 0);
 __ZdlPv(i7);
 return;
}

function __ZN5physx19clothParticleWriterERNS_14PxOutputStreamERKNS_15PxClothParticleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 8 | 0;
 i4 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2) | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, gb + 1086395 | 0, 1) | 0;
 d3 = +Math_fround(HEAPF32[i2 + 12 >> 2]);
 i1 = i5;
 i2 = i1 + 128 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAPF64[i6 >> 3] = d3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i5, 128, gb + 832323 | 0, i6) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[HEAP32[i4 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i4 | 0, i5 | 0, _strlen(i5) | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx14PxsAABBManager31updateAggregateBPOverlapRecordsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 _memset(HEAP32[i1 + 232 >> 2] | 0, 0, HEAP32[i1 + 236 >> 2] << 2 | 0) | 0;
 i5 = i1 + 49860 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i6 = HEAP32[i1 + 49856 >> 2] | 0;
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = i1 + 232 | 0;
 i3 = 0;
 do {
  i1 = HEAP32[i4 + (HEAP32[i6 + (i3 * 12 | 0) >> 2] << 2) >> 2] | 0;
  if (i1 & 1 | 0) {
   i7 = (HEAP32[i2 >> 2] | 0) + (i1 >>> 6 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i1 >>> 1 & 31);
  }
  i1 = HEAP32[i4 + (HEAP32[i6 + (i3 * 12 | 0) + 4 >> 2] << 2) >> 2] | 0;
  if (i1 & 1 | 0) {
   i7 = (HEAP32[i2 >> 2] | 0) + (i1 >>> 6 << 2) | 0;
   HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1 << (i1 >>> 1 & 31);
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 return;
}

function __ZN4FMOD7Channel7setModeEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i1 = i4 & 3;
   if (!i1) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i3 = i2 + 72 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -4 | i1;
   _JS_Sound_SetLoop(HEAP32[i2 + 164 >> 2] | 0, (i4 & 2 | 0) != 0 | 0);
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859075;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN22ParticleSystemRenderer23RendererBecameInvisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, d4 = 0.0;
 __ZN8Renderer23RendererBecameInvisibleEv(i1);
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 80300 | 0) | 0;
 if (!i3) return;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 284 >> 2] | 0) == -1) return;
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i2 + 30 >> 0] | 0) return;
 if (!(HEAP8[i2 + 25 >> 0] | 0)) return;
 if (HEAP8[i2 + 26 >> 0] | 0) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 HEAP8[(HEAP32[i1 >> 2] | 0) + 30 >> 0] = 1;
 d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i1 >> 2] | 0) + 32 >> 3] = d4;
 __ZN14ParticleSystem17RemoveFromManagerEv(i3);
 return;
}

function __Z69Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointP12Il2CppObjectRK13Vector2fIcallPS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 8 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZNK11Rigidbody2D8GetPointERK8Vector2f(i5, i6, i4);
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i6 + 4 >> 2] = i4;
  STACKTOP = i7;
  return;
 }
}

function __Z38Application_Get_Custom_PropProductNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i1 = i2 + 112 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 116 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i5 >> 2] | 0 : i5, i3 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return i4 | 0;
}

function __Z35Renderer_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __Z18CalculateWorldAABBR10GameObject(i3, HEAP32[i4 + 28 >> 2] | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function _UNITY_tt_done_blend(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 if (!i4) return;
 i5 = i4 + 4 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i4 + 8 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i4 + 20 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP32[i4 >> 2] | 0) {
   i2 = 0;
   do {
    _UNITY_ft_mem_free(i3, HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0);
    i1 = HEAP32[i5 >> 2] | 0;
    HEAP32[i1 + (i2 << 3) + 4 >> 2] = 0;
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  _UNITY_ft_mem_free(i3, i1);
  HEAP32[i5 >> 2] = 0;
 }
 i5 = i4 + 28 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i4 + 36 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 _UNITY_ft_mem_free(i3, i4);
 return;
}

function _UNITY_png_colorspace_sync_info(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i3 = HEAP16[i6 + 114 >> 1] | 0;
 i1 = i3 & 65535;
 if (!(i1 & 32768)) {
  i2 = i6 + 8 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = (i1 & 128 | 0) == 0 ? i6 & -2049 : i6 | 2048;
  i1 = (i3 & 2) == 0 ? i1 & -5 : i1 | 4;
  HEAP32[i2 >> 2] = i1;
  if (!(i3 & 1)) {
   HEAP32[i2 >> 2] = i1 & -2;
   return;
  } else {
   HEAP32[i2 >> 2] = i1 | 1;
   return;
  }
 }
 i3 = i6 + 8 | 0;
 i4 = HEAP32[i3 >> 2] & -6150;
 HEAP32[i3 >> 2] = i4;
 if (!i5) return;
 i1 = i6 + 220 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 & 16 | 0) {
  i7 = i6 + 116 | 0;
  _UNITY_png_free(i5, HEAP32[i7 >> 2] | 0);
  i6 = i6 + 120 | 0;
  _UNITY_png_free(i5, HEAP32[i6 >> 2] | 0);
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i3 >> 2] = i4;
 }
 HEAP32[i1 >> 2] = i2 & -17;
 return;
}

function __ZZN2UI11CanvasGroup15InitializeClassEvEN38FunctorImpl_118kTransformParentChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106076 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + 512 | 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i2, (HEAP32[i1 + 4 >> 2] | 0) - i3 >> 4);
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i5 + 516 >> 2] | 0;
 i4 = i1 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i1 = i3;
 } else {
  i5 = i5 + 536 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 16 | 0;
 }
 i5 = i5 + 536 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP16[i7 >> 1] | 0;
 i4 = HEAP16[i6 >> 1] | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 i3 = (i2 & 65535) < (i1 & 65535);
 do if ((i1 & 65535) < (i4 & 65535)) {
  if (i3) {
   HEAP16[i6 >> 1] = i2;
   HEAP16[i5 >> 1] = i4;
   i1 = 1;
   break;
  }
  HEAP16[i6 >> 1] = i1;
  HEAP16[i7 >> 1] = i4;
  i1 = HEAP16[i5 >> 1] | 0;
  if ((i1 & 65535) < (i4 & 65535)) {
   HEAP16[i7 >> 1] = i1;
   HEAP16[i5 >> 1] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP16[i7 >> 1] = i2;
  HEAP16[i5 >> 1] = i1;
  i2 = HEAP16[i7 >> 1] | 0;
  i1 = HEAP16[i6 >> 1] | 0;
  if ((i2 & 65535) < (i1 & 65535)) {
   HEAP16[i6 >> 1] = i2;
   HEAP16[i7 >> 1] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i4 = HEAP8[i6 >> 0] | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < i1 << 24 >> 24;
 do if (i1 << 24 >> 24 < i4 << 24 >> 24) {
  if (i3) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i5 >> 0] = i4;
   i1 = 1;
   break;
  }
  HEAP8[i6 >> 0] = i1;
  HEAP8[i7 >> 0] = i4;
  i1 = HEAP8[i5 >> 0] | 0;
  if (i1 << 24 >> 24 < i4 << 24 >> 24) {
   HEAP8[i7 >> 0] = i1;
   HEAP8[i5 >> 0] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP8[i7 >> 0] = i2;
  HEAP8[i5 >> 0] = i1;
  i2 = HEAP8[i7 >> 0] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (i2 << 24 >> 24 < i1 << 24 >> 24) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i7 >> 0] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i4 = HEAP8[i6 >> 0] | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < i1 << 24 >> 24;
 do if (i1 << 24 >> 24 < i4 << 24 >> 24) {
  if (i3) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i5 >> 0] = i4;
   i1 = 1;
   break;
  }
  HEAP8[i6 >> 0] = i1;
  HEAP8[i7 >> 0] = i4;
  i1 = HEAP8[i5 >> 0] | 0;
  if (i1 << 24 >> 24 < i4 << 24 >> 24) {
   HEAP8[i7 >> 0] = i1;
   HEAP8[i5 >> 0] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP8[i7 >> 0] = i2;
  HEAP8[i5 >> 0] = i1;
  i2 = HEAP8[i7 >> 0] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (i2 << 24 >> 24 < i1 << 24 >> 24) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i7 >> 0] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNK13WheelCollider24FindNewAttachedRigidbodyEPK9Rigidbodyb(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 + 28 | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 67048 | 0) | 0;
 if (!((i2 | 0) == 0 | (i2 | 0) == (i3 | 0))) {
  i3 = i2;
  return i3 | 0;
 }
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) {
   i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0;
   if (!((i2 | 0) == 0 | (i2 | 0) == (i3 | 0))) {
    i1 = i2;
    i2 = 6;
    break;
   }
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 32 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN5physx7NpCloth21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj(i2 + 32 | 0, i3, i1);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 426, gb + 694119 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN3WWW12CallWhenDoneEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9 + 4 | 0;
 i7 = i9;
 i8 = __Znwj(20) | 0;
 HEAP32[i8 >> 2] = i1;
 i1 = i1 + 76 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 691 | 0, i6, Math_fround(0.0), i8, Math_fround(-1.0), fb + 1951 | 0, 10);
 STACKTOP = i9;
 return;
}

function __ZN22AnimationMixerPlayableC2E18DirectorPlayerType(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i2, 0, 0);
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i2 + 72 >> 0] = 0;
 HEAP8[i2 + 73 >> 0] = 0;
 HEAP8[i2 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i2 + 76 | 0);
 HEAP32[i2 >> 2] = gb + 177060 + 8;
 STACKTOP = i1;
 return;
}

function __ZN12_GLOBAL__N_119createParticleFluidEjb(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1457204 >> 2] | 0;
 i3 = i2 + 3940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i2 + 3936 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i2 + 3644 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i4 = i2 + 3924 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i2 + 3928 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  i6 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 __ZN5physx15NpParticleFluidC2Ejb(i1, i5, i6);
 i6 = i1;
 i5 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __ZN10Matrix3x3fmLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 16 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 20 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 28 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 32 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 return i1 | 0;
}

function __ZN10Effector2D15WakeAllContactsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + 36 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i7 = i1 + 48 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!i1) return; else i6 = i2;
 do {
  i5 = HEAP32[i6 + 16 >> 2] | 0;
  i3 = i5 + 4 | 0;
  i4 = HEAPU16[i3 >> 1] | 0;
  if (!(HEAP32[i5 >> 2] | 0)) {
   HEAP16[i3 >> 1] = i4 & 65533;
   HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
   i2 = i5 + 64 | 0;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   HEAP32[i2 + 12 >> 2] = 0;
   HEAP32[i2 + 16 >> 2] = 0;
   HEAP32[i2 + 20 >> 2] = 0;
   i2 = HEAP32[i8 >> 2] | 0;
   i1 = HEAP32[i7 >> 2] | 0;
  } else if (!(i4 & 2)) {
   HEAP16[i3 >> 1] = i4 | 2;
   HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
  }
  i6 = i6 + 40 | 0;
 } while ((i6 | 0) != (i2 + (i1 * 40 | 0) | 0));
 return;
}

function __Z38Application_Get_Custom_PropCompanyNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i1 = i2 + 96 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 100 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 };
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, i3, i1);
 i4 = HEAP8[i5 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i5 >> 2] | 0 : i5, i3 ? HEAP32[i5 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i6;
 return i4 | 0;
}

function _tre_add_tag_left(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = ___tre_mem_alloc_impl(i1, 0, 0, 0, 8) | 0;
 do if (!i5) i1 = 12; else {
  i3 = _tre_ast_new_node(i1, 0, 20) | 0;
  if (!i3) {
   HEAP32[i5 >> 2] = 0;
   i1 = 12;
   break;
  }
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = -3;
  HEAP32[i6 + 4 >> 2] = i2;
  HEAP32[i6 + 8 >> 2] = -1;
  HEAP32[i5 >> 2] = i3;
  i1 = ___tre_mem_alloc_impl(i1, 0, 0, 0, 32) | 0;
  HEAP32[i5 + 4 >> 2] = i1;
  if (!i1) i1 = 12; else {
   i6 = i4 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 8 >> 2] = -1;
   HEAP32[i1 + 12 >> 2] = -1;
   HEAP32[i1 + 24 >> 2] = 0;
   HEAP32[i1 + 28 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   HEAP32[i6 >> 2] = i5;
   HEAP32[i4 >> 2] = 1;
   i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function _ilogb(d2) {
 d2 = +d2;
 var i1 = 0, i3 = 0, i4 = 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i1 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Lshr(i1 | 0, i3 | 0, 52) | 0;
 getTempRet0() | 0;
 switch (i4 & 2047) {
 case 0:
  {
   i3 = _bitshift64Shl(i1 | 0, i3 | 0, 12) | 0;
   i4 = getTempRet0() | 0;
   if ((i3 | 0) == 0 & (i4 | 0) == 0) i1 = -2147483648; else if ((i4 | 0) > -1 | (i4 | 0) == -1 & i3 >>> 0 > 4294967295) {
    i1 = -1023;
    do {
     i1 = i1 + -1 | 0;
     i3 = _bitshift64Shl(i3 | 0, i4 | 0, 1) | 0;
     i4 = getTempRet0() | 0;
    } while ((i4 | 0) > -1 | (i4 | 0) == -1 & i3 >>> 0 > 4294967295);
   } else i1 = -1023;
   break;
  }
 case 2047:
  {
   i1 = (i1 | 0) != 0 | (i3 & 1048575 | 0) != 0 ? -2147483648 : 2147483647;
   break;
  }
 default:
  i1 = (i4 & 2047) + -1023 | 0;
 }
 return i1 | 0;
}

function __ZNSt3__221__thread_specific_ptrINS_15__thread_structEEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i2 = _pthread_key_create(i1 | 0, fb + 4011 | 0) | 0;
 if (!i2) {
  STACKTOP = i3;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 i3 = __ZNSt3__215system_categoryEv() | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_viii(fb + 1062 | 0, i1 | 0, i4 | 0, gb + 1084807 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i1 | 0, gb + 12920 | 0, fb + 3205 | 0);
}

function __ZNK5physx7NpCloth18getSolverFrequencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore18getSolverFrequencyEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 846, gb + 697903 | 0, i2);
  f5 = Math_fround(60.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN7mecanim23SetupValueArrayConstantEPNS_18ValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE(i1, i6, i7, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = i7;
 i4 = i1 + 4 | 0;
 i5 = (i7 | 0) == 0;
 if (i5) i1 = 0; else {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i7 * 12 | 0, 4) | 0;
  i3 = i1 + (i7 * 12 | 0) | 0;
  if ((i1 | 0) != (i3 | 0)) {
   i2 = i1;
   do {
    HEAP32[i2 >> 2] = 0;
    HEAP32[i2 + 4 >> 2] = 10;
    HEAP32[i2 + 8 >> 2] = 0;
    i2 = i2 + 12 | 0;
   } while ((i2 | 0) != (i3 | 0));
  }
 }
 i2 = i4;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i4 >> 2] = i1;
 if (i5) return;
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = i6;
  HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx2Sn5ConvX23convertImportReferencesEPKvRi(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i7, i1, 16) | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - (0 - i1 & 15);
 i1 = i5 + 4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i7, i5);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -4;
 if (!i5) {
  i7 = i1;
  return i7 | 0;
 }
 i3 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i7, gb + 744903 | 0, 1) | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = i3 + 16 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i7, i1, i3, 0) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i1 = i1 + i8 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZN5physx2Sn5ConvX23convertExportReferencesEPKvRi(i7, i1, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i7, i1, 16) | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - (0 - i1 & 15);
 i1 = i5 + 4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i7, i5);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -4;
 if (!i5) {
  i7 = i1;
  return i7 | 0;
 }
 i3 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i7, gb + 744866 | 0, 1) | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = i3 + 16 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i7, i1, i3, 0) | 0;
  i8 = HEAP32[i4 >> 2] | 0;
  i1 = i1 + i8 | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) - i8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZN5physx23NpVolumeCacheSqCallback14processTouchesEPKNS_12PxOverlapHitEj(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i6 + 52 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i6 + 44 >> 2] | 0;
  i2 = HEAP32[i6 + 36 >> 2] | 0;
  if ((HEAP32[i2 + 72 + (i1 << 2) >> 2] | 0) >>> 0 >= i5 >>> 0) {
   __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi(i2, i1, i4, i5) | 0;
   i6 = 0;
   return i6 | 0;
  }
 }
 i1 = HEAP32[i6 + 48 >> 2] | 0;
 if (i5 | 0) {
  i2 = 0;
  do {
   HEAP32[i1 + (i2 << 3) >> 2] = HEAP32[i4 + (i2 << 4) >> 2];
   HEAP32[i1 + (i2 << 3) + 4 >> 2] = HEAP32[i4 + (i2 << 4) + 4 >> 2];
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i5 | 0));
 }
 i6 = HEAP32[i6 + 40 >> 2] | 0;
 mftCall_viii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i5 | 0, i1 | 0);
 HEAP8[i3 >> 0] = 1;
 i6 = 1;
 return i6 | 0;
}

function __ZN5physx17PxcNpMemBlockPool19releaseUnusedBlocksEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i3 = i6 + 116 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i6 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  STACKTOP = i7;
  return;
 }
 i4 = i6 + 112 | 0;
 i5 = i6 + 140 | 0;
 do {
  i9 = i1 + -1 | 0;
  i8 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i9 << 2) >> 2] | 0;
  HEAP32[i3 >> 2] = i9;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i8);
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
  i1 = HEAP32[i3 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i9 = HEAP32[i6 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
 STACKTOP = i7;
 return;
}

function __ZN5physx14NpArticulation26setInternalDriveIterationsEj(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore26setInternalDriveIterationsEj(i1, i8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 >> 2] = i8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 1;
 return;
}

function __ZN22RenderingCommandBuffer16AddReleaseTempRTERKN9ShaderLab16FastPropertyNameE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = i4 + 8 | 0;
 i9 = i4 + 24 | 0;
 i6 = (HEAP32[i9 >> 2] | 0) + 3 & -4;
 i3 = i6 + 4 | 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 > i1 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i6, i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i9 >> 2] = i3;
 i4 = i4 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 + i6 >> 2] = 10;
 i2 = i6 + 7 & -4;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 <= i1 >>> 0) {
  i8 = i5;
  HEAP32[i9 >> 2] = i3;
  i9 = i8 + i2 | 0;
  HEAP32[i9 >> 2] = i7;
  return;
 }
 __ZN14GrowableBuffer13EnlargeBufferEjj(i8, i2, i3);
 i8 = HEAP32[i4 >> 2] | 0;
 HEAP32[i9 >> 2] = i3;
 i9 = i8 + i2 | 0;
 HEAP32[i9 >> 2] = i7;
 return;
}

function __ZN20TextRenderingPrivate17TextMeshGenerator17GetCursorPositionERK5RectTIfEi(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0, f9 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if ((i1 | 0) < 0) i1 = 0; else {
  i7 = HEAP32[i3 + 72 >> 2] | 0;
  i1 = (i7 | 0) < (i1 | 0) ? i7 : i1;
  i1 = ((i1 << 2) + 4 | 0) > 65535 ? 16382 : i1;
 }
 i7 = HEAP32[i3 + 88 >> 2] | 0;
 __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE(i5, i3, i4);
 f9 = Math_fround(HEAPF32[i7 + (i1 << 3) >> 2]);
 f9 = Math_fround(f9 + Math_fround(HEAPF32[i5 >> 2]));
 f8 = Math_fround(HEAPF32[i7 + (i1 << 3) + 4 >> 2]);
 f8 = Math_fround(f8 + Math_fround(HEAPF32[i5 + 4 >> 2]));
 HEAPF32[i2 >> 2] = f9;
 HEAPF32[i2 + 4 >> 2] = f8;
 STACKTOP = i6;
 return;
}

function __ZN10Matrix4x4f30SetPositionAndOrthoNormalBasisERK8Vector3fS2_S2_S2_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z14SetPlayerFocusb(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 32 | 0;
 i4 = i5 + 12 | 0;
 i3 = i5;
 if (!(__Z19GetBuildSettingsPtrv() | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i3 >> 2] = gb + 29232;
 HEAP32[i3 + 4 >> 2] = i2 & 1;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1105736 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1105736 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1105736 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[gb + 1105736 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[gb + 1105736 + 16 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 __Z21SendMessageToEveryone17MessageIdentifier11MessageData(i4, i1);
 STACKTOP = i5;
 return;
}

function _fputws(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = i7 + 8 | 0;
 HEAP32[i2 >> 2] = i1;
 if ((HEAP32[i4 + 76 >> 2] | 0) > -1) i5 = ___lockfile(i4) | 0; else i5 = 0;
 i8 = i4 + 74 | 0;
 i9 = HEAP8[i8 >> 0] | 0;
 HEAP8[i8 >> 0] = i9 + 1 | i9;
 L4 : do if (!i1) {
  i1 = 0;
  i6 = 9;
 } else {
  while (1) {
   i1 = _wcsrtombs(i3, i2, 1024, 0) | 0;
   if ((i1 + 1 | 0) >>> 0 <= 1) {
    i6 = 9;
    break L4;
   }
   if ((___fwritex(i3, i1, i4) | 0) >>> 0 < i1 >>> 0) break;
   if (!(HEAP32[i2 >> 2] | 0)) {
    i6 = 9;
    break L4;
   }
  }
  if (!i5) i1 = -1; else {
   ___unlockfile(i4);
   i1 = -1;
  }
 } while (0);
 if ((i6 | 0) == 9) if (i5) ___unlockfile(i4);
 STACKTOP = i7;
 return i1 | 0;
}

function __ZN9Transform24UpdateTransformAccessorsER18TransformHierarchyj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[(HEAP32[i5 + 16 >> 2] | 0) + (i4 << 2) >> 2] | 0;
 i7 = HEAP32[i5 + 24 >> 2] | 0;
 i8 = HEAP32[i5 + 12 >> 2] | 0;
 i1 = HEAP32[i7 + (i4 << 2) >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i1 + 36 >> 2] = i4;
 if (!i4) i1 = -1; else i1 = HEAP32[(HEAP32[i1 + 100 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i8 + (i4 << 2) >> 2] = i1;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 if (i6 >>> 0 > 1) {
  i2 = 1;
  i1 = i4;
 } else return;
 do {
  i1 = HEAP32[i3 + (i1 << 2) >> 2] | 0;
  i4 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  HEAP32[i4 + 32 >> 2] = i5;
  HEAP32[i4 + 36 >> 2] = i1;
  HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[(HEAP32[i4 + 100 >> 2] | 0) + 36 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZN9AudioClip10ClearQueueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 124 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP32[i4 >> 2] = gb + 872444;
  __Z6FormatPKcz(i2, gb + 854751 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 854464 | 0, 712, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i2 + 12 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
 STACKTOP = i5;
 return;
}

function __ZN5physx9NpFactory27releaseParticleSystemToPoolERNS_16NpParticleSystemE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 3640 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 3624 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 3636 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 3628 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 3620 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 3344 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN22RenderingCommandBuffer17AddSetGlobalFloatERKN9ShaderLab16FastPropertyNameEf(i9, i1, f10) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 f10 = Math_fround(f10);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i6 = i9 + 8 | 0;
 i8 = i9 + 24 | 0;
 i4 = (HEAP32[i8 >> 2] | 0) + 3 & -4;
 i3 = i4 + 4 | 0;
 i1 = i9 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i3);
  i2 = HEAP32[i1 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i3;
 i3 = i9 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + i4 >> 2] = 11;
 i4 = i4 + 7 & -4;
 i5 = i4 + 8 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  __ZN14GrowableBuffer13EnlargeBufferEjj(i6, i4, i5);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i8 >> 2] = i5;
 i8 = i1 + i4 | 0;
 HEAP32[i8 >> 2] = i7;
 HEAPF32[i8 + 4 >> 2] = f10;
 HEAP8[i9 + 36 >> 0] = 1;
 return;
}

function __ZN21ArchiveStorageCreator10AppendDataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEPKvj(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 i2 = HEAP32[i3 + 1212 >> 2] | 0;
 i1 = i2;
 if ((i2 | 0) == (HEAP32[i3 + 1208 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i1 + -40 | 0;
  i1 = i1 + -32 | 0;
  i1 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i2 = getTempRet0() | 0;
 }
 if (!(__ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy(i3, i4, i5, i1, i2, i7, 0) | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = __ZN21ArchiveStorageCreator10AppendDataEPKvj(i3, i6, i7) | 0;
 return i7 | 0;
}

function __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6, i1);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i6 + 8 | 0, i1);
 i2 = i6 + 164 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i7 >> 2] = i4;
 }
 i1 = i6 + 168 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i7, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 }
}

function __Z51SpriteRenderer_CUSTOM_INTERNAL_CALL_GetSpriteBoundsP12Il2CppObjectR4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN14SpriteRenderer15GetSpriteBoundsEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z21WriteImageAsyncThreadPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 12 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN5Image13ReformatImageEii13TextureFormatN14ImageReference8BlitModeE(i3, HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, 3, 0);
 if (!(__Z21ConvertImageToPNGFileRK14ImageReferenceRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(HEAP32[i1 >> 2] | 0, i2) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 444806 | 0, 0, gb + 444834 | 0, 130, 1, 0, 0, 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZdlPv(i2);
  return 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, gb + 63184 | 0);
 __ZdlPv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZdlPv(i2);
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i5, i6, i1, i4, i8, i9, i10) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 if ((-17 - i6 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) i7 = HEAP32[i5 >> 2] | 0; else i7 = i5;
 if (i6 >>> 0 < 2147483623) {
  i2 = i1 + i6 | 0;
  i3 = i6 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i2 = i2 >>> 0 < 11 ? 11 : i2 + 16 & -16;
 } else i2 = -17;
 i3 = __Znwj(i2) | 0;
 if (i8 | 0) _memcpy(i3 | 0, i7 | 0, i8 | 0) | 0;
 i1 = i4 - i9 - i8 | 0;
 if (i1 | 0) _memcpy(i3 + i8 + i10 | 0, i7 + i8 + i9 | 0, i1 | 0) | 0;
 if ((i6 | 0) != 10) __ZdlPv(i7);
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i2 | -2147483648;
 return;
}

function __ZNK27StateMachineBehaviourPlayer18FireStateBehaviourER17AnimatorStateInfoiN7mecanim12statemachine19StateMachineMessageE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = i5 + 200 | 0;
 __ZN18ScriptingArgumentsC2Ev(i6);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i6, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 >> 2] | 0) | 0);
 __ZN18ScriptingArguments9AddStructEPKv(i6, i2);
 __ZN18ScriptingArguments6AddIntEi(i6, i3);
 HEAP32[i7 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 + 4 >> 2] = i3;
 i4 = __ZNK27StateMachineBehaviourPlayer13FireBehaviourER8StateKeyR18ScriptingArgumentsN7mecanim12statemachine19StateMachineMessageEb(i1, i7, i6, i4, 1) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx9NpFactory21acquireConnectorArrayEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 436 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i4 + 432 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4 + 140 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i4 + 420 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i4 = i4 + 424 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  i4 = 0;
  i3 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
  return i4 | 0;
 }
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP32[i1 + 36 >> 2] = i1;
 HEAP32[i1 + 44 >> 2] = 4;
 i4 = i1;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx14NpArticulation17setSleepThresholdEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 12 | 0;
 i1 = i2 + 24 | 0;
 i7 = i2 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf(i1, f8);
  return;
 }
 i2 = i2 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 16 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
 return;
}

function __ZN21AnimationPosePlayableC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i1, 0, 0);
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 i7 = gb + 63320 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 60 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i1 + 73 >> 0] = 0;
 HEAP8[i1 + 74 >> 0] = 0;
 __ZN14AssetReferenceC2Ev(i1 + 76 | 0);
 HEAP32[i1 >> 2] = gb + 177204 + 8;
 HEAP32[i1 + 84 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN13UnityProfiler20DeserializeFrameDataEP17ProfilerFrameDataPKvi(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i2 = i6 + (i1 >>> 2 << 2) | 0;
 i3 = i6 + 4 | 0;
 HEAP32[i7 >> 2] = i3;
 i4 = (HEAP32[i6 >> 2] | 0) == 0;
 if (i4) if (i3 >>> 0 < i2 >>> 0) {
  i1 = i3;
  do {
   HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
   i1 = i1 + 4 | 0;
  } while (i1 >>> 0 < i2 >>> 0);
 }
 HEAP32[i7 >> 2] = i6 + 8;
 if ((HEAP32[i3 >> 2] | 0) != 538314274) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if ((HEAP32[i2 + -4 >> 2] | 0) != -1347440721) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 __ZN17ProfilerFrameData11DeserializeEPPib(i5, i7, i4);
 i7 = 1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue8AddEventEPNS0_14CloudEventInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = i2 + 44 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i1, i3); else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 }
 if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] & 1)) {
  STACKTOP = i6;
  return 1;
 }
 i5 = i1 + 16 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 STACKTOP = i6;
 return 1;
}

function __Z26AudioMixer_CUSTOM_GetFloatP12Il2CppObjectP12Il2CppStringPf(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 12 | 0;
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i4 = (__ZN10AudioMixer8GetFloatEPKcPf(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i6;
  return i4 | 0;
 }
 return 0;
}

function __Z24HumanDescriptionFromMonoRK20MonoHumanDescriptionR16HumanDescription(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z28ScriptingStructArrayToVectorI12SkeletonBone16MonoSkeletonBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_(HEAP32[i1 + 4 >> 2] | 0, i2 + 12 | 0, fb + 4080 | 0);
 __Z28ScriptingStructArrayToVectorI9HumanBone13MonoHumanBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_(HEAP32[i1 >> 2] | 0, i2, fb + 4081 | 0);
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP8[i2 + 84 >> 0] = HEAP8[i1 + 36 >> 0] | 0;
 return;
}

function __ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (i2 | 0) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
  return i3 | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 i2 = i3 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i2);
  i3 = i1 & i3;
  return i3 | 0;
 }
 i3 = 1;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i2);
 i3 = i1 & i3;
 return i3 | 0;
}

function __ZN9Transform17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!(HEAP32[i1 + 100 >> 2] | 0)) __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i1, 0);
 i5 = i1 + 32 | 0;
 if (HEAP32[i1 + 36 >> 2] | 0) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i5 >> 2] | 0;
 if (!i4) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i1 = HEAP32[gb + 1158396 >> 2] | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != -1) {
  i6 = i1 + 12 | 0;
  i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  i8 = HEAP32[i1 >> 2] | 0;
  i1 = i8 + (i7 << 2) | 0;
  HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] = i3;
  i3 = i8 + (HEAP32[i2 >> 2] << 2) | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = -1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63160 | 0);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN5physx19NpArticulationJoint12setStiffnessEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore12setStiffnessEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 84 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 16;
 return;
}

function __ZN5physx14NpRigidDynamic24setSolverIterationCountsEjj(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i8 + 48 | 0;
 i6 = (i2 << 8 | i1 & 255) & 65535;
 i3 = HEAP32[i8 + 52 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i5 = i7;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i7 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 4; else i5 = i7;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 4) {
  HEAP16[i8 + 110 >> 1] = i6;
  return;
 }
 i2 = i8 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i5 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP16[i1 + 132 >> 1] = i6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i5 >> 2] | 0, i7);
 i8 = i8 + 284 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | 256;
 return;
}

function __ZN5UmbramlERKNS_9Matrix4x3ERKNS_9Matrix4x4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 __ZN5Umbra9Matrix4x4mLERKS0_(i1, i3) | 0;
 return;
}

function __ZN22BaseUnityConnectClient18DetermineNextStateENS_5StateEPS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 L4 : do switch (HEAP32[i4 >> 2] | 0) {
 case 5:
 case 0:
  {
   if ((i2 | 0) != 1) {
    i4 = 0;
    return i4 | 0;
   }
   break;
  }
 case 1:
  switch (i2 | 0) {
  case 3:
   {
    HEAP32[i3 >> 2] = 2;
    break L4;
   }
  case 4:
   {
    i4 = 0;
    return i4 | 0;
   }
  default:
   break L4;
  }
 case 2:
  {
   if ((i2 | 0) == 3) if (!(HEAP8[i1 + 112 >> 0] | 0)) HEAP32[i3 >> 2] = 4;
   break;
  }
 case 4:
  {
   if ((i2 | 0) == 3) {
    if (HEAP8[i1 + 110 >> 0] | 0) if (!(HEAP8[i1 + 108 >> 0] | 0)) break L4;
    HEAP32[i3 >> 2] = 2;
   }
   break;
  }
 default:
  {}
 } while (0);
 i4 = 1;
 return i4 | 0;
}

function __ZN14RenderSettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 35612 + 8;
 i3 = i1 + 348 | 0;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP32[i1 + 384 >> 2] = 0;
 HEAP32[i1 + 388 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 __ZN20SphericalHarmonicsL27SetZeroEv(i1 + 76 | 0);
 STACKTOP = i4;
 return;
}

function __ZN14GfxContextGLES8InstanceD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 695 >> 0] | 0) {
  i1 = i2 + 532 | 0;
  if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES17DeleteVertexArrayERN2gl6HandleILNS0_10ObjectTypeE3EEE(HEAP32[gb + 1451080 >> 2] | 0, i1);
 }
 i1 = i2 + 508 | 0;
 if ((HEAP32[i2 + 524 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 512 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 488 | 0;
 if ((HEAP32[i2 + 504 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 492 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2 + 8 | 0, HEAP32[i2 + 12 >> 2] | 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper33GetCurrentMillisecondsInLocalTimeEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(_gettimeofday(i1 | 0, 0) | 0)) {
  i3 = HEAP32[i1 >> 2] | 0;
  i3 = ___muldi3(i3 | 0, ((i3 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
  i2 = getTempRet0() | 0;
  i5 = (HEAP32[i1 + 4 >> 2] | 0) / 1e3 | 0;
  i2 = _i64Add(i5 | 0, ((i5 | 0) < 0) << 31 >> 31 | 0, i3 | 0, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
 } else {
  i2 = 0;
  i3 = 0;
 }
 _time(i1 | 0) | 0;
 i5 = _localtime(i1 | 0) | 0;
 i1 = _mktime(_gmtime(i1 | 0) | 0) | 0;
 i5 = ~~(+_difftime(i1 | 0, _mktime(i5 | 0) | 0) * 1.0e3);
 i5 = _i64Subtract(i2 | 0, i3 | 0, i5 | 0, ((i5 | 0) < 0) << 31 >> 31 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 STACKTOP = i4;
 return i5 | 0;
}

function __Z31ComputeShader_CUSTOM_FindKernelP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i3 = i4 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 HEAP32[i3 >> 2] = __Z25ScriptingStringToPropertyR11ICallString(i5) | 0;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN13ComputeShader10FindKernelERKN9ShaderLab16FastPropertyNameE(i1, i3) | 0;
 if ((i1 | 0) < 0) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 509115 | 0, i4); else {
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_ft_module_get_service(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0;
 if (i1 | 0) {
  i1 = mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
  if (i1 | 0) {
   i6 = i1;
   return i6 | 0;
  }
 }
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = i1 + 20 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = i1 + 20 | 0;
 while (1) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((i1 | 0) != (i5 | 0)) {
   i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
   if (i2 | 0) {
    i1 = mftCall_iii(i2 | 0, i1 | 0, i6 | 0) | 0;
    if (i1 | 0) {
     i2 = 10;
     break;
    }
   }
  }
  i3 = i3 + 4 | 0;
  if (i3 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZNK5physx7NpCloth16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore16getContactOffsetEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1084, gb + 692226 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN5physx9NpFactory26releaseParticleFluidToPoolERNS_15NpParticleFluidE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 3940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 3924 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 3936 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 3928 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 3920 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 3644 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 332 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 + 324 >> 2] | 0;
 i5 = i1 + 328 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 << 6) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 << 6) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 64 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 516 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i2, (HEAP32[i1 + 4 >> 2] | 0) - i3 >> 4);
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i5 + 520 >> 2] | 0;
 i4 = i1 + (i2 << 4) | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i1 = i3;
 } else {
  i5 = i5 + 540 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
  i2 = i2 + 16 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 16 | 0;
 }
 i5 = i5 + 540 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN5physx16PxVehicleNoDrive8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = (i1 + 3 | 0) >>> 2;
 i4 = i7 << 4;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, (i7 * 48 | 0) + 144 + (__ZN5physx15PxVehicleWheels15computeByteSizeEj(i7) | 0) | 0, gb + 827083 | 0, 47) | 0;
 __ZN5physx16PxVehicleNoDriveC2Ev(i3);
 i6 = __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i3, i3 + 144 | 0, i7, i1, 1) | 0;
 HEAP32[i3 + 128 >> 2] = i6;
 i5 = i3 + 132 | 0;
 HEAP32[i5 >> 2] = i6 + i4;
 i1 = i3 + 136 | 0;
 HEAP32[i1 >> 2] = i6 + (i7 << 5);
 _memset(i6 | 0, 0, i4 | 0) | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, i4 | 0) | 0;
 _memset(HEAP32[i1 >> 2] | 0, 0, i4 | 0) | 0;
 HEAP8[i3 + 113 >> 0] = 3;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN5UmbramlERKNS_9Matrix4x4ES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
 __ZN5Umbra9Matrix4x4mLERKS0_(i1, i3) | 0;
 return;
}

function __ZN23ShaderVariantCollection7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 479513 | 0, 50) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 68748 + 8;
 i2 = i4 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = i2;
 HEAP8[i4 + 44 >> 0] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN17AnimationPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i8 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i9 = 8;
    break;
   } else i3 = 0;
  }
  if ((i9 | 0) == 8) {
   i9 = 0;
   mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i5 | 0, i6 | 0, i7 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 return;
}

function __ZN16CircleCollider2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 48 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(0.0) : f3;
 i2 = i1 + 40 | 0;
 if (!((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i6 = gb + 1162356 | 0;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
 }
 i6 = i1 + 160 | 0;
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i5 = f3 < Math_fround(.0000999999974);
 i4 = f3 > Math_fround(1.0e6);
 f3 = i4 ? Math_fround(1.0e6) : f3;
 HEAPF32[i6 >> 2] = i5 ? Math_fround(.0000999999974) : f3;
 return;
}

function __ZN15ResourceManager19PreloadDependenciesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb(i1, i2, i5, 1);
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i5, HEAP32[i4 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i4 >> 2] = 0;
 __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb(i1, i2, i5, 0);
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i5, HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN13InitialModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 692 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 956 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1220 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1484 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1748 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 2012 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 2276 | 0, i2);
 return;
}

function __Z64Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleWithParentP12Il2CppObjectS0_RK8Vector3fRK11Quaternionf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z17InstantiateObjectR6ObjectR9TransformRK8Vector3fRK11Quaternionf(i5, i1, i3, i4) | 0) | 0;
 return 0;
}

function __Z37RegisterStaticallyLinkedModuleClassesv() {
 __Z24RegisterModuleClasses_UIv();
 __Z31RegisterModuleClasses_Animationv();
 __Z36RegisterModuleClasses_ParticleSystemv();
 __Z37RegisterModuleClasses_ParticlesLegacyv();
 __Z29RegisterModuleClasses_Terrainv();
 __Z24RegisterModuleClasses_AIv();
 __Z36RegisterModuleClasses_TerrainPhysicsv();
 __Z29RegisterModuleClasses_Physicsv();
 __Z31RegisterModuleClasses_Physics2Dv();
 __Z34RegisterModuleClasses_UnityConnectv();
 __Z30RegisterModuleClasses_UnityAdsv();
 __Z38RegisterModuleClasses_CloudWebServicesv();
 __Z36RegisterModuleClasses_UnityAnalyticsv();
 __Z36RegisterModuleClasses_CrashReportingv();
 __Z27RegisterModuleClasses_Audiov();
 __Z35RegisterModuleClasses_TextRenderingv();
 __Z27RegisterModuleClasses_Umbrav();
 __Z30RegisterModuleClasses_Vehiclesv();
 __Z27RegisterModuleClasses_Clothv();
 return;
}

function __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i6, i1, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var f2 = f0, f3 = f0, f5 = f0;
 switch (i1 | 0) {
 case 4:
  {
   f5 = Math_fround(-1.0);
   f2 = Math_fround(2.0);
   f3 = Math_fround(1.0);
   break;
  }
 case 1:
 case 7:
  {
   f5 = Math_fround(0.0);
   f2 = (i4 | 0) == 0 ? Math_fround(2.0) : Math_fround(4.5947938);
   f3 = Math_fround(1.0);
   break;
  }
 case 5:
 case 2:
  {
   i4 = (i4 | 0) == 0;
   f3 = i4 ? Math_fround(1.0) : Math_fround(2.20000005);
   f5 = Math_fround(0.0);
   f2 = i4 ? Math_fround(5.0) : Math_fround(34.4932442);
   break;
  }
 default:
  {
   f5 = Math_fround(0.0);
   f2 = Math_fround(1.0);
   f3 = Math_fround(1.0);
  }
 }
 HEAPF32[i6 >> 2] = f2;
 HEAPF32[i6 + 4 >> 2] = f3;
 HEAPF32[i6 + 8 >> 2] = f5;
 HEAPF32[i6 + 12 >> 2] = Math_fround(1.0);
 return;
}

function mftCall_viffffffffffffiiii(i18, i1, d2, d10, d11, d12, d13, d14, d15, d16, d17, d3, d4, d5, i6, i7, i8, i9) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d10 = +d10;
 d11 = +d11;
 d12 = +d12;
 d13 = +d13;
 d14 = +d14;
 d15 = +d15;
 d16 = +d16;
 d17 = +d17;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i18 | 0) >= (fb | 0) & (i18 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viffffffffffffiiii[i18 - fb & 3](i1 | 0, Math_fround(d2), Math_fround(d10), Math_fround(d11), Math_fround(d12), Math_fround(d13), Math_fround(d14), Math_fround(d15), Math_fround(d16), Math_fround(d17), Math_fround(d3), Math_fround(d4), Math_fround(d5), i6 | 0, i7 | 0, i8 | 0, i9 | 0);
  return;
 }
 ftCall_viffffffffffffiiii(i18 | 0, i1 | 0, +d2, +d10, +d11, +d12, +d13, +d14, +d15, +d16, +d17, +d3, +d4, +d5, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function _post_process_1pass(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 i12 = HEAP32[i1 + 396 >> 2] | 0;
 i10 = i7 - (HEAP32[i6 >> 2] | 0) | 0;
 i11 = HEAP32[i12 + 16 >> 2] | 0;
 HEAP32[i9 >> 2] = 0;
 i7 = i12 + 12 | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i1 + 416 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, HEAP32[i7 >> 2] | 0, i9 | 0, (i10 >>> 0 > i11 >>> 0 ? i11 : i10) | 0);
 mftCall_viiii(HEAP32[(HEAP32[i1 + 424 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, HEAP32[i7 >> 2] | 0, i5 + (HEAP32[i6 >> 2] << 2) | 0, HEAP32[i9 >> 2] | 0);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + (HEAP32[i9 >> 2] | 0);
 STACKTOP = i8;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i4 = i2 & 255;
  i2 = 10;
 }
 if ((i4 | 0) == (i2 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj(i1, i2, 1, i2, i2, 0);
  if ((HEAP8[i5 >> 0] | 0) > -1) i2 = 7; else i2 = 8;
 } else if (i3) i2 = 8; else i2 = 7;
 if ((i2 | 0) == 7) HEAP8[i5 >> 0] = i4 + 1; else if ((i2 | 0) == 8) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i4 + 1;
  i1 = i5;
 }
 i5 = i1 + i4 | 0;
 HEAP8[i5 >> 0] = i6;
 HEAP8[i5 + 1 >> 0] = 0;
 return;
}

function __ZNK8VRDevice14GetDeviceModelEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i6 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i6 + 24 | 0;
 i7 = gb + 63648 | 0;
 i2 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = i6 + 4 | 0;
 HEAP8[i1 >> 0] = 0;
 i2 = _strlen(i3) | 0;
 if (i2 >>> 0 <= 15) {
  i7 = i1;
  _memcpy(i7 | 0, i3 | 0, i2 | 0) | 0;
  i7 = i7 + i2 | 0;
  HEAP8[i7 >> 0] = 0;
  HEAP32[i4 >> 2] = i2;
  return;
 }
 i7 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, i5, 0, gb + 1047486 | 0, 251) | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i2;
 i7 = (i7 | 0) == 0 ? i1 : i7;
 _memcpy(i7 | 0, i3 | 0, i2 | 0) | 0;
 i7 = i7 + i2 | 0;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i4 >> 2] = i2;
 return;
}

function __ZN8BitArray6resizeEj(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 128 | 0;
 i3 = ((i3 & 31 | 0) != 0 & 1) + (i3 >>> 5) | 0;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6 + 1 | 0, i3 << 2, gb + 717183 | 0, 412) | 0;
 i2 = i5 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else {
  _memcpy(i4 | 0, HEAP32[i5 >> 2] | 0, i1 << 2 | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i3 | 0) != (i1 | 0)) _memset(i4 + (i1 << 2) | 0, 0, i3 - i1 << 2 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = i4;
  HEAP32[i2 >> 2] = i3;
  STACKTOP = i6;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, i1);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i2 >> 2] = i3;
 STACKTOP = i6;
 return;
}

function __ZN5physx7NpCloth25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 282, gb + 696063 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 3, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN2UI13RectTransform15GetLocalCornersERA4_8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0;
 if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
 f6 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 124 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 128 >> 2]);
 f4 = Math_fround(f6 + f4);
 f5 = Math_fround(f3 + Math_fround(HEAPF32[i1 + 132 >> 2]));
 HEAPF32[i2 >> 2] = f6;
 HEAPF32[i2 + 4 >> 2] = f3;
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = f6;
 HEAPF32[i2 + 16 >> 2] = f5;
 HEAPF32[i2 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 24 >> 2] = f4;
 HEAPF32[i2 + 28 >> 2] = f5;
 HEAPF32[i2 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 36 >> 2] = f4;
 HEAPF32[i2 + 40 >> 2] = f3;
 HEAPF32[i2 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __ZN22BaseUnityConnectClient12CloseServiceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 4 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 280 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = i1 + 113 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP8[i3 >> 0] = 1;
 L10 : do if ((HEAP32[i2 >> 2] | 0) != 5) {
  switch (HEAP32[i2 >> 2] | 0) {
  case 5:
  case 0:
   break L10;
  default:
   {}
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 } while (0);
 HEAP8[i3 >> 0] = 0;
 __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE(i1 + 548 | 0, HEAP32[i1 + 544 >> 2] | 0);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i4 = 1;
  return i4 | 0;
 }
 __ZN19CloudServiceHandler7ReleaseEv(i1);
 HEAP32[i4 >> 2] = 0;
 i4 = 1;
 return i4 | 0;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags(i2, i1 + 48 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS3_9allocatorIiEEEEEvRT_17TransferMetaFlags(i2, i1 + 64 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17SurfaceEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(108, i1, 16, gb + 1048932 | 0, 0, gb + 806823 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 157884 + 8;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 1;
 HEAP32[i4 + 84 >> 2] = 1812433254;
 HEAP32[i4 + 88 >> 2] = 1900727103;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14SafeBinaryRead21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj(i6, i1, i4, i5, i2, i3) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i6, i4, gb + 469148 | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 if ((i1 | 0) > 0) __ZN13StreamingInfo8TransferI14SafeBinaryReadEEvRT_(i5, i6); else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i5 | 0, i6 | 0) | 0;
 }
 i4 = i6 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (!i5) i1 = 0; else i1 = (HEAP32[i6 + 88 >> 2] | 0) + (i1 + -2 << 5) | 0;
 HEAP32[i6 + 80 >> 2] = i1;
 HEAP8[i6 + 128 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __Z50AnimatorOverrideController_CUSTOM_GetOriginalClipsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = __ZNK26AnimatorOverrideController16GetOriginalClipsEv(i2) | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(74) | 0;
  i3 = __Z19GetScriptingManagerv() | 0;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i1 + 12 >> 2] | 0) | 0;
  __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i(i2, i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z45LightmapSettings_Set_Custom_PropLightmapsModei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 >>> 0 > 2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 518115 | 0, i4);
 i2 = (__Z19GetLightmapSettingsv() | 0) + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i3 = i3 + 12 | 0;
  HEAP32[i3 >> 2] = i1;
  STACKTOP = i4;
  return;
 }
 i3 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
 HEAP32[i3 + 4 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 43424 + 8;
 HEAP32[i3 + 8 >> 2] = 1;
 HEAP32[i3 + 12 >> 2] = 1;
 i5 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i3 = i3 + 12 | 0;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutjS1_P11ChannelInfo(i5, i6, i1, i7, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0, i10 = 0;
 i4 = i1 | i5;
 if (!i4) {
  i8 = 0;
  return i8 | 0;
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 1;
 }
 do {
  if (i3 & i4) {
   i10 = i3 & i5 | 0 ? i6 : i7;
   i9 = i10 + (i2 << 1) | 0;
   HEAP8[i8 + (i2 << 2) >> 0] = 0;
   HEAP8[i8 + (i2 << 2) + 1 >> 0] = i1;
   HEAP8[i8 + (i2 << 2) + 2 >> 0] = HEAP8[i9 >> 0] | 0;
   HEAP8[i8 + (i2 << 2) + 3 >> 0] = HEAP8[i10 + (i2 << 1) + 1 >> 0] | 0;
   i9 = HEAPU8[i9 >> 0] | HEAPU8[i9 + 1 >> 0] << 8;
   i1 = (Math_imul((i9 & 65535) >>> 8 & 65535, HEAPU8[(i9 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  i2 = i2 + 1 | 0;
  i3 = i3 << 1;
 } while ((i2 | 0) < 8 & i3 >>> 0 <= i4 >>> 0);
 return i1 | 0;
}

function __Z23Gradient_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArrayS2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 240 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 72 | 0;
 i6 = i8 + 8 | 0;
 i4 = __Z20ConvertColorKeyArrayP11Il2CppArrayPN8Gradient8ColorKeyE(i1, i5) | 0;
 if ((i4 | 0) == -1) {
  STACKTOP = i8;
  return;
 }
 i2 = __Z20ConvertAlphaKeyArrayP11Il2CppArrayPN8Gradient8AlphaKeyE(i2, i6) | 0;
 do if ((i2 | 0) != -1) {
  if (!i3) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7);
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7); else {
   __ZN8Gradient7SetKeysEPNS_8ColorKeyEjPNS_8AlphaKeyEj(i1, i5, i4, i6, i2);
   break;
  }
 } while (0);
 STACKTOP = i8;
 return;
}

function __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) return 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return 0; else {
  i3 = i5;
  i2 = i1;
 }
 L6 : while (1) {
  i1 = i2;
  while (1) {
   i4 = HEAP32[i1 + 20 >> 2] | 0;
   i2 = __Z6StrCmpPKcS0_(HEAP32[i1 + 16 >> 2] | 0, i6) | 0;
   if (!i2) i2 = __Z6StrCmpPKcS0_(i4, i7) | 0;
   if ((i2 | 0) >= 0) break;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) break L6;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = i1;
   break;
  } else i3 = i1;
 }
 if ((i3 | 0) == (i5 | 0)) return 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 i1 = __Z6StrCmpPKcS0_(i6, HEAP32[i3 + 16 >> 2] | 0) | 0;
 if (!i1) i1 = __Z6StrCmpPKcS0_(i7, i2) | 0;
 if ((i1 | 0) < 0) return 0; else return i3 + 24 | 0;
 return 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0;
 f2 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(HEAPF32[i6 >> 2]);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 i1 = f3 < f2;
 do if (f2 < f4) {
  if (i1) {
   HEAPF32[i6 >> 2] = f3;
   HEAPF32[i5 >> 2] = f4;
   i1 = 1;
   break;
  }
  HEAPF32[i6 >> 2] = f2;
  HEAPF32[i7 >> 2] = f4;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  if (f2 < f4) {
   HEAPF32[i7 >> 2] = f2;
   HEAPF32[i5 >> 2] = f4;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAPF32[i7 >> 2] = f3;
  HEAPF32[i5 >> 2] = f2;
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  f2 = Math_fround(HEAPF32[i6 >> 2]);
  if (f3 < f2) {
   HEAPF32[i6 >> 2] = f3;
   HEAPF32[i7 >> 2] = f2;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNK5physx2Cm10Collection8containsERNS_6PxBaseE(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 + 64 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  i5 = (i5 | 0) != 0;
  return i5 | 0;
 }
 i4 = i5;
 i4 = i4 + ~(i4 << 15) | 0;
 i4 = (i4 >>> 10 ^ i4) * 9 | 0;
 i4 = i4 >>> 6 ^ i4;
 i4 = i4 + ~(i4 << 11) | 0;
 i1 = HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + ((i1 + -1 & (i4 >>> 16 ^ i4)) << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i5 = 0;
  i5 = (i5 | 0) != 0;
  return i5 | 0;
 }
 i4 = HEAP32[i2 + 48 >> 2] | 0;
 i3 = i2 + 52 | 0;
 i2 = i1;
 while (1) {
  i1 = i4 + (i2 << 4) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
   i2 = 6;
   break;
  }
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  i5 = (i1 | 0) != 0;
  return i5 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 3, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 3) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   i9 = i2;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i1;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 8 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 8 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx23PxVehicleWheels4SimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, f7 = f0;
 i3 = i5 + 192 + (i4 * 48 | 0) | 0;
 i6 = i3;
 i2 = i6 + 48 | 0;
 do {
  HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
  i6 = i6 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i6 | 0) < (i2 | 0));
 HEAPF32[i5 + 192 + (i4 * 48 | 0) + 36 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i5 + 192 + (i4 * 48 | 0) + 40 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i5 + 192 + (i4 * 48 | 0) + 12 >> 2]));
 f7 = Math_fround(HEAPF32[i5 + 192 + (i4 * 48 | 0) + 8 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i5 + (i4 * 48 | 0) + 16 >> 2]));
 HEAPF32[i5 + 832 + (i4 << 2) >> 2] = f7;
 HEAPF32[i5 + 848 + (i4 << 2) >> 2] = Math_fround(Math_fround(1.0) / f7);
 return;
}

function __Z39Material_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 4 | 0;
 i4 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  i1 = __ZN8Material9GetMatrixEN9ShaderLab16FastPropertyNameE(i6, i5) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i7;
  return;
 }
}

function __Z15CreateDenseClipRN7mecanim9animation9DenseClipEjfffRNS_6memory9AllocatorE(i2, i1, f5, f6, f7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, f9 = f0;
 f6 = Math_fround(Math_fround(f6 - f5) * f7);
 i3 = f6 >= Math_fround(0.0);
 f9 = Math_fround(f6 + Math_fround(.99999994));
 i3 = ~~(i3 ? f9 : f6) + 1 | 0;
 i3 = (i3 | 0) < 2 ? 2 : i3;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAPF32[i2 + 8 >> 2] = f7;
 HEAPF32[i2 + 12 >> 2] = f5;
 i3 = Math_imul(i3, i1) | 0;
 HEAP32[i2 + 16 >> 2] = i3;
 i4 = i2 + 20 | 0;
 if (!i3) i1 = 0; else {
  i2 = i3 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i8 | 0, i2 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i3 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1 | 0 ? i1 - i4 | 0 : 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj(i5, i6, i1, i4, i8, i9) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 if ((-17 - i6 | 0) >>> 0 < i1 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i5);
 if ((HEAP8[i5 + 11 >> 0] | 0) < 0) i7 = HEAP32[i5 >> 2] | 0; else i7 = i5;
 if (i6 >>> 0 < 2147483623) {
  i2 = i1 + i6 | 0;
  i3 = i6 << 1;
  i2 = i2 >>> 0 < i3 >>> 0 ? i3 : i2;
  i2 = i2 >>> 0 < 11 ? 11 : i2 + 16 & -16;
 } else i2 = -17;
 i3 = _malloc(i2) | 0;
 if (i8 | 0) _memcpy(i3 | 0, i7 | 0, i8 | 0) | 0;
 i1 = i4 - i8 | 0;
 if (i1 | 0) _memcpy(i3 + i8 + i9 | 0, i7 + i8 | 0, i1 | 0) | 0;
 if ((i6 | 0) != 10) _free(i7);
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i2 | -2147483648;
 return;
}

function __ZN5physx9NpFactory25releaseArticulationToPoolERNS_14NpArticulationE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 2740 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 2724 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 2736 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 2728 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 2720 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 2444 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx7NpCloth19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj(i3 + 32 | 0, i2, i1);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 359, gb + 695257 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx2Sc5Scene16finishBroadPhaseEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0;
 i2 = HEAP32[i4 + 49848 >> 2] | 0;
 i3 = i1 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj(HEAP32[i3 >> 2] | 0, HEAP32[i4 + 49832 >> 2] | 0, HEAP32[i4 + 49836 >> 2] | 0, i5);
 __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv(i4);
 if (!i2) {
  __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i4);
  return;
 }
 i1 = HEAP32[i4 + 49844 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i5);
  if (!i2) break; else i1 = i1 + 8 | 0;
 }
 __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i4);
 return;
}

function __ZN5physx19NpArticulationJoint10setDampingEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 8 | 0;
 i1 = i2 + 20 | 0;
 i7 = i2 + 12 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc21ArticulationJointCore10setDampingEf(i1, f8);
  return;
 }
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 88 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 32;
 return;
}

function __ZN17ArchiveFileSystem5CloseER13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1178944 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178944 | 0, i1);
  i3 = gb + 1178944 | 0;
 } else i3 = 0;
 i1 = i4 + 1052 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i1 = 0; else {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i4 + 1056 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = 1;
 }
 if (!i3) {
  STACKTOP = i5;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i3);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN15PointEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(124, i1, 16, gb + 1048932 | 0, 0, gb + 807037 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 156704 + 8;
 HEAP32[i4 + 76 >> 2] = 0;
 HEAP32[i4 + 80 >> 2] = 1;
 HEAP32[i4 + 84 >> 2] = 1812433254;
 HEAP32[i4 + 88 >> 2] = 1900727103;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN10AudioMixer7CleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i4 + 72 | 0;
 if (i2 | 0) {
  i5 = HEAP32[i3 >> 2] | 0;
  __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i2, i5, HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i4 + 32 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = __Z21GetManagerFromContexti(3) | 0;
  __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer(i5, i4);
  return;
 }
 __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE(i1, i4 + 32 | 0);
 HEAP32[i3 >> 2] = 0;
 i5 = __Z21GetManagerFromContexti(3) | 0;
 __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer(i5, i4);
 return;
}

function __Z30IsComponentSubclassOfMonoClassRN5Unity9ComponentEP11Il2CppClass(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
 if ((i2 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0) i1 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0; else {
  i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[gb + 1110260 >> 2] | 0) + 44 >> 2] | 0) + 4 + (i2 << 2) >> 2] | 0) + 16 >> 2] | 0;
  i2 = __Z14GetMonoManagerv() | 0;
  i1 = HEAP32[(__ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0) + 24 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 }
 if ((i3 | 0) != 0 & (i1 | 0) != 0) {
  if ((i1 | 0) == (i3 | 0)) {
   i3 = 1;
   return i3 | 0;
  }
  if (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i3) | 0) {
   i3 = 1;
   return i3 | 0;
  }
 }
 i3 = 0;
 return i3 | 0;
}

function __Z19GetGUIBlendMaterialv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1468864 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __Z15GetScriptMapperv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1017441 | 0, 30);
 i2 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i2, 61, 0) | 0;
 HEAP32[gb + 1468864 >> 2] = i2;
 __Z24InitializeGUIClipTexturev();
 i2 = HEAP32[gb + 1468864 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx2Sc10NPhaseCore32createActorPairContactReportDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 1620 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv(i3 + 1328 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i2 = i3 + 1608 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i3 = i3 + 1612 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP16[i1 + 4 >> 1] = 0;
 HEAP16[i1 + 10 >> 1] = 0;
 HEAP32[i1 + 12 >> 2] = -1;
 HEAP32[i1 + 16 >> 2] = -1;
 HEAP32[i1 + 20 >> 2] = -1;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = -1;
 HEAP8[i1 + 33 >> 0] = -1;
 HEAP8[i1 + 34 >> 0] = 0;
 HEAP8[i1 + 35 >> 0] = 0;
 i3 = i1;
 return i3 | 0;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation20ExecuteSynchronouslyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 208 | 0;
 if ((__ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i1, i1 + 192 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0) == 1) __ZN37AssetBundleLoadFromFileAsyncOperation14ConvertArchiveEv(i1) | 0;
 if (!(__ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i1) | 0)) {
  i2 = i1 + 92 | 0;
  if (HEAP32[i2 >> 2] | 0) if ((HEAP32[i2 >> 2] | 0) != 1) {
   i2 = i1 + 96 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN20HardwareInfoReporterC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 10804 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 10036 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 10036 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 10036 + (i1 * 12 | 0) >> 2] = fb + 403;
 STACKTOP = i5;
 return;
}

function __ZN15QualitySettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 407158 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 44056 + 8;
 i2 = i4 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL21NavMeshGarbageCollectR27GarbageCollectorThreadState(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = HEAP32[gb + 1459032 >> 2] | 0;
 i7 = HEAP32[i1 + 132 >> 2] | 0;
 if ((i7 | 0) <= 0) return;
 i5 = i1 + 124 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[i5 >> 2] | 0;
  if (i4) {
   i3 = i4;
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i1) while (1) {
     i1 = HEAP32[i2 + 8 >> 2] | 0;
     if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
    } else while (1) {
     i2 = HEAP32[i1 >> 2] | 0;
     if (!i2) break; else i1 = i2;
    }
    if ((i3 | 0) > 1) {
     i3 = i3 + -1 | 0;
     i2 = i1;
    } else break;
   }
  }
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + 4 >> 2] | 0, i6);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i7 | 0));
 return;
}

function __Z43WebCamTexture_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK17BaseWebCamTexture8GetPixelEii(i5, i6, i2, i3);
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = HEAP32[i5 + 8 >> 2] | 0;
  i6 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i3;
  HEAP32[i4 + 12 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
}

function __Z18GetGUIBlitMaterialv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1468888 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __Z15GetScriptMapperv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1018544 | 0, 30);
 i2 = __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i2 = __ZN8Material14CreateMaterialER6Shaderib(i2, 61, 0) | 0;
 HEAP32[gb + 1468888 >> 2] = i2;
 __Z24InitializeGUIClipTexturev();
 i2 = HEAP32[gb + 1468888 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _UNITY_png_get_pHYs_dpi(i1, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0;
 if (!((i1 | 0) != 0 & (i4 | 0) != 0)) {
  i7 = 0;
  return i7 | 0;
 }
 if (!(HEAP32[i4 + 8 >> 2] & 128)) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = (i5 | 0) != 0;
 if (i2) {
  HEAP32[i5 >> 2] = HEAP32[i4 + 184 >> 2];
  i1 = 128;
 } else i1 = 0;
 i3 = (i6 | 0) != 0;
 if (i3) {
  HEAP32[i6 >> 2] = HEAP32[i4 + 188 >> 2];
  i1 = 128;
 }
 if (!i7) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = HEAP8[i4 + 192 >> 0] | 0;
 HEAP32[i7 >> 2] = i4 & 255;
 if (i4 << 24 >> 24 != 1) {
  i7 = 128;
  return i7 | 0;
 }
 if (i2) HEAP32[i5 >> 2] = ~~(+((HEAP32[i5 >> 2] | 0) >>> 0) * .0254 + .5) >>> 0;
 if (!i3) {
  i7 = 128;
  return i7 | 0;
 }
 HEAP32[i6 >> 2] = ~~(+((HEAP32[i6 >> 2] | 0) >>> 0) * .0254 + .5) >>> 0;
 i7 = 128;
 return i7 | 0;
}

function __ZNK5physx7NpCloth14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore14getWakeCounterEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 988, gb + 691762 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZNK5Umbra10PortalInfo11getTriangleEiRNS_7Vector3ES2_S2_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 76 | 0;
 i6 = i6 + (HEAP32[i6 + 112 >> 2] | 0) | 0;
 i7 = i6 + ((HEAP32[i1 >> 2] | 0) * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 i3 = i6 + ((i2 + 1 + (HEAP32[i1 >> 2] | 0) | 0) * 12 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i4 = i6 + ((i2 + 2 + (HEAP32[i1 >> 2] | 0) | 0) * 12 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 return;
}

function __ZNK16Physics2DManager23GetIgnoreLayerCollisionEii(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i4 + 4 | 0;
 i2 = __Z21GetManagerFromContexti(16) | 0;
 if ((i6 | 0) > 31 | ((i5 | 0) > 31 | (i6 | i5 | 0) < 0)) {
  HEAP32[i3 >> 2] = 31;
  __Z6FormatPKcz(i1, gb + 806509 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 805767 | 0, 427, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i6 = 0;
  STACKTOP = i4;
  return i6 | 0;
 } else {
  i6 = (HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (i5 << 2) >> 2] & 1 << i6 | 0) == 0;
  STACKTOP = i4;
  return i6 | 0;
 }
 return 0;
}

function __ZN8LODGroup7CleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 68 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i7 = i2 + 88 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (i3) {
  i5 = i2 + 76 | 0;
  i4 = 0;
  i1 = i3;
  do {
   i2 = (HEAP32[i5 >> 2] | 0) + (i4 << 2) | 0;
   HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
   i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
   if ((i2 | 0) != -1) {
    i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
    HEAP32[i1 >> 2] = 0;
    HEAP32[i1 + 4 >> 2] = 0;
    i1 = HEAP32[i7 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < i1 >>> 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = 0;
 if (i1 | 0) __ZN15LODGroupManager14RemoveLODGroupEi(HEAP32[gb + 1161200 >> 2] | 0, i1);
 HEAP32[i6 >> 2] = -1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i5 + 264 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, (i1 << 2) + 67 | 0, gb + 838004 | 0, 543) | 0;
 if (!i1) i2 = 0; else {
  i2 = i1 + 67 & -64;
  HEAP32[i2 + -4 >> 2] = i2 - i1;
 }
 HEAP32[i4 >> 2] = i2;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (i4 << 2) | 0;
 if ((i4 | 0) <= 0) return;
 i1 = HEAP32[i5 + 260 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 96 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i6 + 80 | 0;
 i13 = i6 + 64 | 0;
 i9 = i6 + 48 | 0;
 i10 = i6 + 32 | 0;
 i7 = i6 + 16 | 0;
 i8 = i6;
 i12 = i2 + 48 | 0;
 __ZanRK8Scalar4fS1_(i13, i3, i1);
 __ZplRK8Scalar4fS1_(i11, i12, i13);
 __ZN8Scalar4faSERKS_(i12, i11) | 0;
 i3 = i2 + 64 | 0;
 __ZanRK8Scalar4fS1_(i10, i4, i1);
 __ZplRK8Scalar4fS1_(i9, i3, i10);
 __ZN8Scalar4faSERKS_(i3, i9) | 0;
 i4 = i2 + 80 | 0;
 __ZanRK8Scalar4fS1_(i8, i5, i1);
 __ZplRK8Scalar4fS1_(i7, i4, i8);
 __ZN8Scalar4faSERKS_(i4, i7) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5Umbra13MatrixFactory5orthoEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var f5 = f0, f6 = f0, i7 = 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i1 + 24 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 i7 = i1 + 48 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 f6 = Math_fround(f4 - f3);
 f5 = Math_fround(Math_fround(1.0) / f6);
 f2 = Math_fround(Math_fround(2.0) / f2);
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAPF32[i1 + 40 >> 2] = Math_fround(Math_fround(-2.0) / f6);
 HEAPF32[i1 + 44 >> 2] = Math_fround(-Math_fround(Math_fround(f3 + f4) * f5));
 return;
}

function __ZN4FMOD6System20set3DSpeakerPositionE12FMOD_SPEAKERffb(i9, i1, f2, f3, i4) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8 + 8 | 0;
 i5 = i8;
 i1 = i9;
 i4 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i4 | 0) if ((HEAP32[i4 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869795;
  _printf(gb + 857490 | 0, i6) | 0;
  HEAP32[i7 >> 2] = 78;
  HEAP32[i7 + 4 >> 2] = gb + 869795;
  _printf(gb + 853343 | 0, i7) | 0;
  i9 = 78;
  STACKTOP = i8;
  return i9 | 0;
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 869795;
 _printf(gb + 853184 | 0, i5) | 0;
 i9 = 36;
 STACKTOP = i8;
 return i9 | 0;
}

function __ZN23ForwardShaderRenderLoop23CleanupShadowJobHeadersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i2 + 332 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
  }
 }
 i4 = HEAP32[i2 + 352 >> 2] | 0;
 if (!i4) return;
 i2 = i2 + 340 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 152 | 0) + 144 >> 2] | 0;
  if (i3 | 0) {
   i5 = i3 + 4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   if (!(HEAP32[i5 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
   }
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN16ParticleRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(380, i1, 16, gb + 1048932 | 0, 0, gb + 1049462 | 0, 33) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i4, 4, i5, i2);
 HEAP32[i4 >> 2] = gb + 190956 + 8;
 HEAP32[i4 + 32 >> 2] = gb + 190956 + 184;
 __ZN8Renderer10SetVisibleEb(i4, 0);
 HEAP32[i4 + 376 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13b2DynamicTreeC2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = -1;
 i5 = i4 + 12 | 0;
 HEAP32[i5 >> 2] = 16;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __Z7b2Alloci(576) | 0;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = i1;
 _memset(i1 | 0, 0, (HEAP32[i5 >> 2] | 0) * 36 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) > 1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = 0;
  do {
   i3 = i2;
   i2 = i2 + 1 | 0;
   HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] = i2;
   HEAP32[i1 + (i3 * 36 | 0) + 32 >> 2] = -1;
   i3 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } else {
  i3 = i1 + -1 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i1 + (i3 * 36 | 0) + 20 >> 2] = -1;
 HEAP32[i1 + (((HEAP32[i5 >> 2] | 0) + -1 | 0) * 36 | 0) + 32 >> 2] = -1;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 return;
}

function __Z51AudioLowPassFilter_Set_Custom_PropCustomCutoffCurveP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = (i3 | 0) == 0;
 if (!(HEAP32[i2 + 68 >> 2] | 0)) {
  if (i1) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884782 | 0, 0, gb + 875076 | 0, 2207, 1, i1, 0, 0);
  return;
 }
 if (i1) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN18AudioLowPassFilter26SetCustomLowpassLevelCurveERK17AnimationCurveTplIfE(i1, i2);
 return;
}

function __Z32CustomEventData_CUSTOM_AddUInt64P12Il2CppObjectP12Il2CppStringy(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 16 | 0;
 i6 = i8 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i7);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i7); else {
  __ZNK11ICallString6ToUTF8Ev(i6, i5);
  i7 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcy(i1, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i3, i4) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function __Z30Mesh_CUSTOM_GetBlendShapeIndexP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  i3 = __Z15GetChannelIndexRK14BlendShapeDataPKc(i1 + 72 | 0, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __Z26Object_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  mftCall_vii(i2 | 0, i1 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z15CanAddComponentR10GameObjecti(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 if (__ZNK10GameObject22CountDerivedComponentsEi(i4, i5) | 0) {
  __Z25InitComponentRequirementsv();
  i6 = (HEAP32[gb + 1162552 >> 2] | 0) + 4 | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) {
   i6 = 0;
   return i6 | 0;
  } else {
   i1 = i6;
   i3 = i2;
  }
  L5 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L5;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i6 | 0)) {
   i6 = 0;
   return i6 | 0;
  }
  if ((HEAP32[i1 + 16 >> 2] | 0) > (i5 | 0)) {
   i6 = 0;
   return i6 | 0;
  }
 }
 i6 = (__ZNK10GameObject27FindConflictingComponentPtrEi(i4, i5) | 0) == 0;
 return i6 | 0;
}

function ___shm_mapname(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 while (1) if ((HEAP8[i2 >> 0] | 0) == 47) i2 = i2 + 1 | 0; else break;
 i3 = ___strchrnul(i2, 47) | 0;
 do if ((i3 | 0) == (i2 | 0) | (HEAP8[i3 >> 0] | 0) != 0) i7 = 7; else {
  i6 = i3 - i2 | 0;
  if ((i6 | 0) < 3) {
   if ((HEAP8[i2 >> 0] | 0) == 46) if ((HEAP8[i3 + -1 >> 0] | 0) == 46) {
    i7 = 7;
    break;
   }
  } else if ((i6 | 0) > 255) {
   HEAP32[(___errno_location() | 0) >> 2] = 36;
   i1 = 0;
   break;
  }
  i3 = i1;
  i4 = gb + 1073999 | 0;
  i5 = i3 + 9 | 0;
  do {
   HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
   i3 = i3 + 1 | 0;
   i4 = i4 + 1 | 0;
  } while ((i3 | 0) < (i5 | 0));
  _memcpy(i1 + 9 | 0, i2 | 0, i6 + 1 | 0) | 0;
 } while (0);
 if ((i7 | 0) == 7) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i9 = i7;
 i1 = i1 + 8 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i2, i8, i1, i1 + 288 | 0, i5, i4, 0) | 0) - i1 | 0;
 if ((i1 | 0) < 288) HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i9 = i7;
 i1 = i1 + 8 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i2, i8, i1, i1 + 288 | 0, i5, i4, 0) | 0) - i1 | 0;
 if ((i1 | 0) < 288) HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 12 | 0;
 STACKTOP = i7;
 return;
}

function __ZNK5physx7NpCloth13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  f5 = Math_fround(__ZNK5physx2Sc9ClothCore13getRestOffsetEv(i1 + 32 | 0));
  STACKTOP = i4;
  return Math_fround(f5);
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1103, gb + 692078 | 0, i2);
  f5 = Math_fround(0.0);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 return Math_fround(0.0);
}

function __ZN9b2Fixture13CreateProxiesEP12b2BroadPhaseRK11b2Transform(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = i2 + 32 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0;
 i7 = i2 + 48 | 0;
 HEAP32[i7 >> 2] = i4;
 if ((i4 | 0) <= 0) return;
 i4 = i2 + 44 | 0;
 i1 = 0;
 do {
  i8 = HEAP32[i4 >> 2] | 0;
  i9 = i8 + (i1 * 28 | 0) | 0;
  i10 = HEAP32[i6 >> 2] | 0;
  mftCall_viiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 24 >> 2] | 0, i10 | 0, i9 | 0, i5 | 0, i1 | 0, 1);
  HEAP32[i8 + (i1 * 28 | 0) + 24 >> 2] = __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv(i3, i9, i9) | 0;
  HEAP32[i8 + (i1 * 28 | 0) + 16 >> 2] = i2;
  HEAP32[i8 + (i1 * 28 | 0) + 20 >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i7 >> 2] | 0));
 return;
}

function __ZN5physx9NpFactory24releaseClothFabricToPoolERNS_13NpClothFabricE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 4552 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 4536 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 4548 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 4540 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 4532 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 4256 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx15NpParticleFluid12setViscosityEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore12setViscosityEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 8 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 64;
 return;
}

function __ZN5physx15NpParticleFluid12setStiffnessEf(i2, f8) {
 i2 = i2 | 0;
 f8 = Math_fround(f8);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 20 | 0;
 i1 = i2 + 32 | 0;
 i7 = i2 + 24 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 switch (i5 >>> 30 | 0) {
 case 3:
  {
   i4 = i6;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i6 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 4; else i4 = i6;
   break;
  }
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) {
  __ZN5physx2Sc18ParticleSystemCore12setStiffnessEf(i1, f8);
  return;
 }
 i2 = i2 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i5 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 4 >> 2] = f8;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i6);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 32;
 return;
}

function __ZN23ManagedAttributeManager35CallManagedGetDefaultExecutionOrderEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 248 | 0;
 i4 = i2;
 i5 = i2 + 240 | 0;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 48 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i1) | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb(i4, i3, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN15ParticleEmitter15ResetEmitterPosEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = i3 + 32 | 0;
 if (!(HEAP8[i3 + 192 >> 0] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 } else {
  __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 i3 = i3 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN15AudioEchoFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 10 ? 10 : (i4 | 0) > 5e3 ? 5e3 : i4;
 i3 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i3 = i1 + 52 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 56 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZL15skip_input_dataP22jpeg_decompress_structl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 24 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 L4 : do if ((i1 | 0) < (i2 | 0)) {
  i4 = i6;
  while (1) {
   i2 = i2 - i1 | 0;
   i1 = HEAP32[i4 + 28 >> 2] | 0;
   i3 = i4 + 32 | 0;
   i1 = mftCall_iiii(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3 | 0, 65536) | 0;
   if (i1 >>> 0 < 65536) {
    HEAP8[i4 + 32 + i1 >> 0] = -1;
    HEAP8[i1 + 1 + (i4 + 32) >> 0] = -39;
    i1 = i1 + 2 | 0;
   }
   HEAP32[i4 >> 2] = i3;
   HEAP32[i4 + 4 >> 2] = i1;
   i1 = HEAP32[i7 >> 2] | 0;
   if ((i2 | 0) <= (i1 | 0)) break L4;
   i4 = HEAP32[i5 >> 2] | 0;
  }
 } while (0);
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
 HEAP32[i7 >> 2] = i1 - i2;
 return;
}

function __Z6cross3RK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0, f12 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f7 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f12 = Math_fround(f7 * f10);
 f11 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f12 = Math_fround(f12 - Math_fround(f11 * f9));
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f11 = Math_fround(f11 * f6);
 f8 = Math_fround(HEAPF32[i2 >> 2]);
 __Z6simd4fffff(i5, f12, Math_fround(f11 - Math_fround(f10 * f8)), Math_fround(Math_fround(f9 * f8) - Math_fround(f7 * f6)), Math_fround(0.0));
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i1, i5);
 STACKTOP = i4;
 return;
}

function __Z42ReflectionProbe_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK15ReflectionProbe13GetGlobalAABBEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z31CustomEventData_CUSTOM_AddInt64P12Il2CppObjectP12Il2CppStringx(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i5 = i8 + 16 | 0;
 i6 = i8 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i7);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i7); else {
  __ZNK11ICallString6ToUTF8Ev(i6, i5);
  i7 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcy(i1, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6, i3, i4) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
  STACKTOP = i8;
  return i7 | 0;
 }
 return 0;
}

function _fill_input_buffer(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i2 + 24 >> 2] | 0;
 i4 = i3 + 32 | 0;
 i1 = _fread(HEAP32[i4 >> 2] | 0, 1, 4096, HEAP32[i3 + 28 >> 2] | 0) | 0;
 i5 = i3 + 36 | 0;
 if (i1 | 0) {
  i2 = i1;
  i4 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i4;
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP8[i5 >> 0] = 0;
  return 1;
 }
 if (!(HEAP8[i5 >> 0] | 0)) i1 = i2; else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 42;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i2 | 0);
  i1 = i2;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = 120;
 mftCall_vii(HEAP32[i2 + 4 >> 2] | 0, i1 | 0, -1);
 HEAP8[HEAP32[i4 >> 2] >> 0] = -1;
 HEAP8[(HEAP32[i4 >> 2] | 0) + 1 >> 0] = -39;
 i2 = 2;
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP8[i5 >> 0] = 0;
 return 1;
}

function __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 i4 = i6 + 4 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + (0 - (i3 >> 2) << 2) | 0;
 HEAP32[i4 >> 2] = i1;
 if ((i3 | 0) > 0) {
  _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i4;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i2 = i4;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i4;
 i4 = i6 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 8 | 0;
 i7 = i6 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZNK5physx7NpCloth24getParticleAccelerationsEPNS_6PxVec4E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i4 = __ZNK5physx2Sc9ClothCore24getParticleAccelerationsEPNS_6PxVec4E(i2 + 32 | 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 330, gb + 696311 | 0, i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK10Collider2D12OverlapPointERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 72 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 i2 = i1 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 while (1) {
  i6 = HEAP32[i1 >> 2] | 0;
  i7 = HEAP32[i6 + 32 >> 2] | 0;
  i1 = i1 + 4 | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0, i7 | 0, (HEAP32[i6 + 28 >> 2] | 0) + 12 | 0, i3 | 0) | 0) {
   i1 = 1;
   break;
  }
  if ((i1 | 0) == ((HEAP32[i2 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0)) {
   i1 = 0;
   break;
  }
 }
 i7 = i1;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN5physx9NpFactory24releaseRigidStaticToPoolERNS_13NpRigidStaticE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 1240 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 1224 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 1236 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 1228 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 1220 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 944 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx7NpCloth20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 246, gb + 696230 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj(i3 + 32 | 0, i2, i1);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 458, gb + 694691 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE(i3, f2, i1) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 if (!(HEAP32[i3 + 36 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i3 = i1;
  return i3 | 0;
 } else {
  i4 = i3 + 44 | 0;
  HEAP32[i3 + 60 >> 2] = 1;
  i5 = i3 + 56 | 0;
  HEAP32[i5 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  HEAP32[i3 + 52 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
  HEAPF32[i3 + 68 >> 2] = f2;
  HEAP32[i3 + 24 >> 2] = 1;
  i1 = i3 + 20 | 0;
  HEAP32[i1 >> 2] = i4;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  HEAP32[i3 + 16 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
  i3 = i3 + 8 | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZN21DownloadHandlerScript21InvokeCompleteContentEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 i1 = i3 + 44 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = i1;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i2, i6);
 HEAP32[i6 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 + 20 | 0;
 if ((HEAP16[i2 + 2 >> 1] | 0) == 32) if (!(__ZN20BufferedSocketStream18CanSendNonblockingEj(i1, (HEAP32[i2 + 4 >> 2] | 0) + 8 | 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459320 | 0, 0, gb + 459188 | 0, 340, 512, 0, 0, 0);
  return;
 }
 if (!(__ZN12SocketStream7SendAllEPKvjl(i1, i2, 8, 0) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459398 | 0, 0, gb + 459188 | 0, 346, 512, 0, 0, 0);
  return;
 }
 if (__ZN12SocketStream7SendAllEPKvjl(i1, i3, HEAP32[i2 + 4 >> 2] | 0, 0) | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 459428 | 0, 0, gb + 459188 | 0, 352, 512, 0, 0, 0);
 return;
}

function __ZN11AudioSource19UpdateLowpassFilterEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f1 = f0, i4 = 0, i5 = 0;
 i5 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 171428 | 0) | 0;
 if (!i5) return;
 i4 = __ZNK18AudioLowPassFilter26GetCustomLowpassLevelCurveEv(i5) | 0;
 f1 = Math_fround(HEAPF32[i2 + 400 >> 2]);
 if (f1 > Math_fround(0.0) ? (HEAP32[i4 + 68 >> 2] | 0) != 1 : 0) f1 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i4, Math_fround(f3 / f1), 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i4 + 56 >> 2] | 0) + 4 >> 2]);
 i4 = f1 < Math_fround(0.0);
 i2 = f1 > Math_fround(1.0);
 f3 = Math_fround(Math_fround((i2 ? Math_fround(1.0) : f1) * Math_fround(21990.0)) + Math_fround(10.0));
 __ZN18AudioLowPassFilter26SetCutoffFrequencyInternalEf(i5, i4 ? Math_fround(10.0) : f3);
 return;
}

function __Z32getPxVehicleDrive4WMDriveSimDataPKN5physx16PxVehicleDrive4WE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 288 >> 2] | 0;
 _memcpy(i1 | 0, i2 + 224 | 0, i3 << 3 | 0) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 i3 = i1 + 80 | 0;
 i4 = i2 + 304 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i1 + 112 | 0, i2 + 336 | 0, 416) | 0;
 i3 = i1 + 528 | 0;
 i1 = i2 + 752 | 0;
 i2 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __Z14dtAllocNavMeshv() {
 var i1 = 0, i2 = 0;
 i1 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 96) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = -1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = -1;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = -1;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = -1;
 HEAP32[i1 + 56 >> 2] = 1;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 2147483647;
 HEAP32[i1 + 64 >> 2] = 2147483647;
 HEAP32[i1 + 68 >> 2] = -2147483648;
 HEAP32[i1 + 72 >> 2] = -2147483648;
 return i1 | 0;
}

function __ZThn4_N5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i7 = i4;
 i9 = i2;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i5 = __ZN5physx5cloth8allocateEj(560) | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = gb + 167452 + 8;
 HEAP32[i2 >> 2] = gb + 167452 + 424;
 i8 = i7;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERNS0_8SwFabricENS0_5RangeIKNS_6PxVec4EEE(i5 + 16 | 0, i3 + -4 | 0, i1 + -4 | 0, i6);
 STACKTOP = i4;
 return ((i5 | 0) == 0 ? 0 : i2) | 0;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Cm17FreeListAllocatorD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i7 >> 2] = gb + 110628 + 8;
 i5 = i7 + 4240 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = i7 + 4 | 0;
  do {
   i2 = HEAP32[i1 >> 2] | 0;
   i4 = i2;
   i3 = i1 + 4 | 0;
   if (i2 | 0) HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
   i2 = HEAP32[i3 >> 2] | 0;
   if (!i2) HEAP32[i5 >> 2] = i4; else HEAP32[i2 >> 2] = i4;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i4 = HEAP32[i6 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
  } while ((i1 | 0) != 0);
 }
 i6 = i7 + 12 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i6 >> 2] | 0);
 i7 = HEAP32[i7 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i6 >> 2] | 0);
 return;
}

function __ZN5physx16PxStringTableExt17createStringTableERNS_19PxAllocatorCallbackE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 52, gb + 766896 | 0, gb + 745255 | 0, 80) | 0;
 HEAP32[i2 >> 2] = gb + 120016 + 8;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = i3;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAPF32[i2 + 36 >> 2] = Math_fround(.75);
 HEAP32[i2 + 40 >> 2] = -1;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj(i1, 64);
 return i2 | 0;
}

function __ZN4FMOD7Channel15getChannelGroupEPPNS_12ChannelGroupE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i4) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = HEAP32[i2 + 68 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870001;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1047658 | 0, i1, 0);
 __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 220 | 0, gb + 1047683 | 0, 0);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047695 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 232 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN23ShaderVariantCollection8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 i3 = i1 + 32 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 479375 | 0, HEAP32[gb + 37052 >> 2] | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags(i4, i3, 0); else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 68 >> 2] | 0, i4 | 0, i5 | 0);
 i6 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if (!i6) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i7 = 8;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 8) {
   i7 = 0;
   __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(i1, i5);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZN12_GLOBAL__N_110Connection5flushEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 if (!(HEAP8[i4 + 132 >> 0] | 0)) return;
 i1 = i4 + 52 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 48 | 0;
  i3 = 0;
  do {
   i5 = (HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 4 >> 2] | 0) + 12 | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 if (!(HEAP32[i4 + 112 >> 2] & 4)) return;
 i2 = i4 + 124 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0);
 i1 = HEAP32[i4 + 120 >> 2] | 0;
 if (i1 | 0) {
  i5 = (HEAP32[i1 + 4 >> 2] | 0) + 8 | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0);
 return;
}

function __ZL31GeomOverlapCallback_SpherePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i3, i4, i2, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f6 = f0, f7 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i2, i5);
 f6 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 >> 2]));
 f7 = Math_fround(HEAPF32[i4 + 20 >> 2]);
 f7 = Math_fround(f6 + Math_fround(f7 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f6 = Math_fround(HEAPF32[i4 + 24 >> 2]);
 f6 = Math_fround(f7 + Math_fround(f6 * Math_fround(HEAPF32[i2 + 8 >> 2])));
 f6 = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) + f6);
 i5 = f6 <= Math_fround(HEAPF32[i3 + 4 >> 2]);
 STACKTOP = i1;
 return i5 | 0;
}

function __Z42Terrain_CUSTOM_INTERNAL_get_legacySpecularP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 100 >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z38Sprite_CUSTOM_INTERNAL_get_textureRectP12Il2CppObjectP5RectTIfE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0;
 if ((HEAP32[i1 + 32 >> 2] & 3 | 0) == 1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 568438 | 0, i4); else {
  i2 = i1 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  STACKTOP = i4;
  return;
 }
}

function __Z20CollectProfilerStatsR16AllProfilerStats(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __Z28CollectMemoryAllocationStatsR11MemoryStats(i2);
 __Z16CollectDrawStatsR9DrawStats(i2 + 224 | 0);
 __ZN13UnityProfiler13GetDebugStatsER10DebugStats(HEAP32[gb + 1451e3 >> 2] | 0, i2 + 764 | 0);
 i1 = __Z9GetIAudiov() | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 + 808 | 0);
 i1 = __Z11GetIPhysicsv() | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i2 + 432 | 0);
 i1 = __Z13GetIPhysics2Dv() | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 + 492 | 0);
 i1 = __Z11GetINetworkv() | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 + 608 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i2 + 684 | 0);
 return;
}

function _UNITY_png_set_crc_action(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 switch (i2 | 0) {
 case 5:
  break;
 case 3:
  {
   i2 = i1 + 208 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -3073 | 1024;
   break;
  }
 case 4:
  {
   i2 = i1 + 208 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 3072;
   break;
  }
 default:
  {
   i2 = i1 + 208 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -3073;
  }
 }
 switch (i3 | 0) {
 case 3:
  {
   i3 = i1 + 208 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -769 | 256;
   return;
  }
 case 4:
  {
   i3 = i1 + 208 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 768;
   return;
  }
 case 1:
  {
   i3 = i1 + 208 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -769 | 512;
   return;
  }
 case 5:
  return;
 default:
  {
   i3 = i1 + 208 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -769;
   return;
  }
 }
}

function __ZNK5physx7NpCloth15getTetherConfigEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore15getTetherConfigEv(i1, i2 + 32 | 0);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 914, gb + 695498 | 0, i3);
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx9NpFactory25releaseRigidDynamicToPoolERNS_14NpRigidDynamicE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 924 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 936 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 928 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 920 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 644 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx9NpFactory23releaseConstraintToPoolERNS_12NpConstraintE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 2140 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 2124 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 2136 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 2128 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 2120 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 1844 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i7 = i4;
 i5 = __ZN5physx5cloth8allocateEj(560) | 0;
 i9 = i2;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = gb + 167452 + 8;
 HEAP32[i2 >> 2] = gb + 167452 + 424;
 i8 = i7;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERNS0_8SwFabricENS0_5RangeIKNS_6PxVec4EEE(i5 + 16 | 0, i3 + 4 + -4 | 0, i1 + -4 | 0, i6);
 STACKTOP = i4;
 return ((i5 | 0) == 0 ? 0 : i2) | 0;
}

function __ZN5physx14NpRigidDynamic17setAngularDampingEf(i7, f6) {
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 48 | 0;
 i1 = i7 + 64 | 0;
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i3 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore17setAngularDampingEf(i1, f6);
  return;
 }
 i2 = i7 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 112 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 8;
 return;
}

function __ZN5physx12NpConstraint23setMinResponseThresholdEf(i1, f7) {
 i1 = i1 | 0;
 f7 = Math_fround(f7);
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 16 | 0;
 i6 = i1 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i4 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc14ConstraintCore23setMinResponseThresholdEf(i1 + 28 | 0, f7);
  return;
 }
 i2 = i1 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 20 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i5);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 8;
 return;
}

function __ZN23ManagedAttributeManager24GetDefaultExecutionOrderEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 248 | 0;
 i4 = i1 + 8 | 0;
 i5 = i1;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 48 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i4, __Z26scripting_class_get_objectP11Il2CppClass(i2) | 0);
 HEAP32[i3 >> 2] = 0;
 i2 = __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb(i4, i3, 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN15FrictionJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i5 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i4, i2);
 if (!(i2 & 16)) return;
 i2 = i4 + 96 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f1 < Math_fround(0.0);
 i5 = f1 > Math_fround(1.0e6);
 f1 = i5 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 >> 2] = f1;
 i2 = i4 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i2 = 0; else {
  __ZN15b2FrictionJoint11SetMaxForceEf(i3, f1);
  i2 = HEAP32[i2 >> 2] | 0;
 }
 i5 = i4 + 100 | 0;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 i4 = f1 < Math_fround(0.0);
 i3 = f1 > Math_fround(1.0e6);
 f1 = i3 ? Math_fround(1.0e6) : f1;
 f1 = i4 ? Math_fround(0.0) : f1;
 HEAPF32[i5 >> 2] = f1;
 if (!i2) return;
 __ZN15b2FrictionJoint12SetMaxTorqueEf(i2, f1);
 return;
}

function __Z56Renderer_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i6;
 HEAP32[i3 + 12 >> 2] = i5;
 if (!i2) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZN8Renderer13SetLightmapSTERK8Vector4f12LightmapType(i1, i3, 1);
  STACKTOP = i4;
  return;
 }
}

function _UNITY_FT_Stream_ReadChar(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i6 = i1 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i3) if (i2 >>> 0 < (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
  i1 = HEAP8[(HEAP32[i1 >> 2] | 0) + i2 >> 0] | 0;
  HEAP8[i5 >> 0] = i1;
  i3 = 6;
 } else i3 = 7; else if ((mftCall_iiiii(i3 | 0, i1 | 0, i2 | 0, i5 | 0, 1) | 0) == 1) {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP8[i5 >> 0] | 0;
  i3 = 6;
 } else i3 = 7;
 if ((i3 | 0) == 6) {
  HEAP32[i6 >> 2] = i2 + 1;
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 } else if ((i3 | 0) == 7) {
  HEAP32[i4 >> 2] = 85;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _UNITY_FT_Create_Class_tt_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 48, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = gb + 1007777;
 HEAP32[i3 + 4 >> 2] = gb + 1007789;
 HEAP32[i3 + 8 >> 2] = gb + 1007798;
 i4 = HEAP32[i1 + 220 >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = i4 + 4;
 HEAP32[i3 + 16 >> 2] = gb + 1008173;
 HEAP32[i3 + 20 >> 2] = gb + 186460;
 HEAP32[i3 + 24 >> 2] = gb + 1007812;
 HEAP32[i3 + 28 >> 2] = i4 + 24;
 HEAP32[i3 + 32 >> 2] = gb + 1008162;
 HEAP32[i3 + 36 >> 2] = i4 + 28;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _unity_z_compress2(i1, i5, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i1;
 HEAP32[i6 + 16 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 32 >> 2] = 0;
 HEAP32[i6 + 36 >> 2] = 0;
 HEAP32[i6 + 40 >> 2] = 0;
 i1 = _unity_z_deflateInit_(i6, i4, gb + 362978 | 0, 56) | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = _unity_z_deflate(i6, 4) | 0;
 if ((i1 | 0) == 1) {
  HEAP32[i5 >> 2] = HEAP32[i6 + 20 >> 2];
  i6 = _unity_z_deflateEnd(i6) | 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  _unity_z_deflateEnd(i6) | 0;
  i6 = (i1 | 0) == 0 ? -5 : i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i8, i5, i3) {
 i8 = i8 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i8 + 8 + 3 | 0;
 i2 = HEAP8[i9 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 if (i1) i6 = HEAP32[i8 + 4 >> 2] | 0; else i6 = i2 & 255;
 if (i6 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i8);
 if (i3 | 0) {
  if (i1) i7 = HEAP32[i8 >> 2] | 0; else i7 = i8;
  i1 = i6 - i5 | 0;
  i4 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
  i3 = i1 - i4 | 0;
  i1 = i7 + (i5 << 2) | 0;
  if (i3) {
   __ZNSt3__211char_traitsIwE4moveEPwPKwj(i1, i1 + (i4 << 2) | 0, i3) | 0;
   i2 = HEAP8[i9 >> 0] | 0;
  }
  i1 = i6 - i4 | 0;
  if (i2 << 24 >> 24 < 0) HEAP32[i8 + 4 >> 2] = i1; else HEAP8[i9 >> 0] = i1;
  HEAP32[i7 + (i1 << 2) >> 2] = 0;
 }
 return i8 | 0;
}

function __ZN7mecanim9animation14WeightForIndexEPKfjjf(i4, i5, i3, f6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 f6 = Math_fround(f6);
 var f1 = f0, f2 = f0;
 f1 = Math_fround(HEAPF32[i4 + (i3 << 2) >> 2]);
 if (!(f1 <= f6)) if (!i3) f1 = Math_fround(1.0); else {
  f2 = Math_fround(HEAPF32[i4 + (i3 + -1 << 2) >> 2]);
  if (f2 > f6) f1 = Math_fround(0.0); else {
   f1 = Math_fround(f1 - f2);
   if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(f6 - f2) / f1); else f1 = Math_fround(1.0);
  }
 } else {
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i5 | 0)) f1 = Math_fround(1.0); else {
   f2 = Math_fround(HEAPF32[i4 + (i3 << 2) >> 2]);
   if (f2 < f6) f1 = Math_fround(0.0); else {
    f1 = Math_fround(f1 - f2);
    if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(f6 - f2) / f1); else f1 = Math_fround(1.0);
   }
  }
 }
 return Math_fround(f1);
}

function __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc5Scene28addActiveBreakableConstraintEPNS0_13ConstraintSimE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = i5;
 i2 = i6 + 204 | 0;
 i3 = i6 + 208 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 212 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  i6 = i5 + 116 | 0;
  i5 = HEAP8[i6 >> 0] | 0;
  i5 = i5 | 4;
  HEAP8[i6 >> 0] = i5;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  i6 = i5 + 116 | 0;
  i5 = HEAP8[i6 >> 0] | 0;
  i5 = i5 | 4;
  HEAP8[i6 >> 0] = i5;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx2Gu22findOverlapCapsuleMeshERKNS0_7CapsuleERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i8, i2, i3, i6, i5, i1, i7, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 8 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i7;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 i5 = i10 + 20 | 0;
 HEAP8[i5 >> 0] = 0;
 __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i8, i2, i3, i6, i10) | 0;
 HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
 STACKTOP = i9;
 return HEAP32[i7 >> 2] | 0;
}

function __ZN18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 496 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i7 = HEAP8[i4 + 11 >> 0] | 0;
 if ((i7 << 24 >> 24 < 0 ? HEAP32[i4 + 4 >> 2] | 0 : i7 & 255) | 0) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP8[i2 + 11 >> 0] | 0;
 if (!((i7 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i7 & 255) | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZN11UnityEngine7Connect15DeviceInfoEventC2ERK8UnityStrb(i5, i2, i3);
 __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
 __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev(i5);
 STACKTOP = i6;
 return;
}

function __ZN17PrecomputeContextC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 100 >> 2] = 4096;
 HEAP32[i1 + 96 >> 2] = __Znaj(16384) | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i2 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 return;
}

function __Z42CommandBuffer_CUSTOM_SetGlobalTexture_ImplP12Il2CppObjectiR26MonoRenderTargetIdentifier(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 8 | 0;
 i5 = i7 + 4 | 0;
 i9 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i9;
 HEAP32[i4 + 8 >> 2] = i8;
 HEAP32[i5 >> 2] = i2;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6); else {
  __ZN22RenderingCommandBuffer19AddSetGlobalTextureERKN9ShaderLab16FastPropertyNameERK18RenderTextureParam(i1, i5, i4);
  STACKTOP = i7;
  return;
 }
}

function __Z38GameObject_CUSTOM_AddComponentInternalP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  i3 = __Z16MonoAddComponentR10GameObjectPKc(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i7 = i5 + 4 | 0;
 i4 = i6 + 4 | 0;
 i3 = (HEAP32[i7 >> 2] | 0) - i2 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + (0 - (i3 >> 2) << 2) | 0;
 HEAP32[i4 >> 2] = i1;
 if ((i3 | 0) > 0) {
  _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
  i2 = i4;
  i1 = HEAP32[i4 >> 2] | 0;
 } else i2 = i4;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = i4;
 i4 = i6 + 8 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i3;
 i4 = i5 + 8 | 0;
 i7 = i6 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i5;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZNK21EnlightenSceneMapping21RadiositySystemExistsERK7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i7) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = i2;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i8 = i5 + (i1 * 56 | 0) + 40 | 0;
  if ((HEAP32[i8 >> 2] | 0) == (i6 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i4 | 0) : 0) {
   i8 = i5 + (i1 * 56 | 0) + 48 | 0;
   if ((HEAP32[i8 >> 2] | 0) == (i2 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i3 | 0) : 0) {
    i1 = 1;
    i2 = 6;
    break;
   }
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN9GfxDevice15ResetFrameStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 3736 | 0;
 i3 = i1 + 3740 | 0;
 i4 = i1 + 3620 | 0;
 i5 = i4 + 116 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 3748 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 3752 >> 2] = 0;
 i4 = i1 + 3760 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i1 + 3888 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 3892 >> 2] = Math_fround(0.0);
 i4 = i1 + 3816 | 0;
 i5 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 return;
}

function __ZN5physx2Gu33MultiplePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_(i7, i6, i8, i9) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 52 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return; else i4 = 0;
 do {
  i2 = HEAPU8[i7 + 48 + i4 >> 0] | 0;
  i3 = i7 + 64 + (i2 * 400 | 0) + 384 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i1 = 0;
   do {
    __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj(i7 + 64 + (i2 * 400 | 0) + (i1 << 6) | 0, i8, i9, i6, HEAP32[gb + 151272 + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   i1 = HEAP8[i5 >> 0] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (i1 & 255) >>> 0);
 return;
}

function __ZN5physx20PxCreateSpatialIndexEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i4 | 0, i3 | 0, 12, (i1 ? gb + 770713 | 0 : gb + 837976 | 0) | 0, gb + 726270 | 0, 198) | 0;
 HEAP32[i1 >> 2] = gb + 107520 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i4 | 0, i3 | 0, 7824, (i2 ? gb + 770597 | 0 : gb + 837976 | 0) | 0, gb + 726270 | 0, 23) | 0;
 __ZN5physx2Sq10AABBPrunerC2Eb(i2, 1);
 HEAP32[i1 + 8 >> 2] = i2;
 return i1 | 0;
}

function __ZN5physx14NpRigidDynamic16setLinearDampingEf(i7, f6) {
 i7 = i7 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i7 + 48 | 0;
 i1 = i7 + 64 | 0;
 i4 = HEAP32[i7 + 52 >> 2] | 0;
 switch (i4 >>> 30 | 0) {
 case 3:
  {
   i3 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i2 = 4; else i3 = i5;
   break;
  }
 default:
  i2 = 4;
 }
 if ((i2 | 0) == 4) {
  __ZN5physx2Sc8BodyCore16setLinearDampingEf(i1, f6);
  return;
 }
 i2 = i7 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i3 >> 2] | 0, i4 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 108 >> 2] = f6;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i3 >> 2] | 0, i5);
 i7 = i7 + 284 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 4;
 return;
}

function __ZN4gles27RenderSurfaceGLES_InitDummyER17RenderSurfaceGLESbRK17RenderSurfaceDesc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = (HEAP32[i3 + 16 >> 2] | 0) != 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 24 >> 2] = 2;
 HEAP8[i1 + 30 >> 0] = i2 & 1;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP8[i1 + 31 >> 0] = i3 & 1;
 HEAP32[i1 + 20 >> 2] = 64;
 i1 = i1 + 32 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i5 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 118) | 0;
 HEAP32[i5 >> 2] = 1;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN22ParticleSystemRenderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 __ZN8Renderer16CheckConsistencyEv(i1);
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 i5 = i1 + 344 | 0;
 i4 = Math_fround(HEAPF32[i5 >> 2]) > Math_fround(0.0);
 i6 = HEAP32[(i4 ? i5 : i6) >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 i4 = i1 + 348 | 0;
 f3 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i6 = f3 < Math_fround(HEAPF32[i4 >> 2]);
 HEAP32[i4 >> 2] = HEAP32[(i6 ? i4 : i5) >> 2];
 i1 = i1 + 368 | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0);
 f3 = i5 ? Math_fround(1.0) : f3;
 HEAPF32[i1 >> 2] = i4 ? Math_fround(0.0) : f3;
 STACKTOP = i2;
 return;
}

function __ZN21DownloadHandlerScript17OnCompleteContentEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 248 | 0;
 i4 = i7 + 8 | 0;
 i5 = i7;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 i1 = i3 + 44 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i7;
  return;
 }
 i8 = i1;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i5;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i4, i2, i6);
 HEAP32[i6 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i6, 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN20HardwareInfoReporter15InitializeClassEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 10804 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 10036 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 10036 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 10036 + (i1 * 12 | 0) >> 2] = fb + 403;
 STACKTOP = i5;
 return;
}

function __ZN19SpriteMeshGenerator4path17find_max_distanceEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, f9 = f0, f10 = f0;
 i7 = HEAP32[i1 >> 2] | 0;
 i6 = (HEAP32[i1 + 4 >> 2] | 0) - i7 | 0;
 i8 = i6 >> 5;
 f9 = Math_fround(HEAPF32[i7 + (i2 << 5) >> 2]);
 f4 = Math_fround(HEAPF32[i7 + (i2 << 5) + 4 >> 2]);
 if ((i6 | 0) > 0) {
  i2 = 0;
  i1 = -1;
  f3 = Math_fround(-1.0);
 } else {
  i8 = -1;
  return i8 | 0;
 }
 while (1) {
  f10 = Math_fround(HEAPF32[i7 + (i2 << 5) >> 2]);
  f10 = Math_fround(f10 - f9);
  f5 = Math_fround(Math_fround(HEAPF32[i7 + (i2 << 5) + 4 >> 2]) - f4);
  f5 = Math_fround(Math_sqrt(Math_fround(Math_fround(f10 * f10) + Math_fround(f5 * f5))));
  i6 = f5 < f3;
  i1 = i6 ? i1 : i2;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i8 | 0)) break; else f3 = i6 ? f3 : f5;
 }
 return i1 | 0;
}

function __ZN18AssetBundleManager32AddAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 16 | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = i2;
 HEAP8[i3 + 4 >> 0] = 1;
 i2 = i1 + 16 | 0;
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12resize_deltaEjj(i2, 1, 0);
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E15insert_noresizeERKS5_(i4, i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN13UnityProfiler7CleanupEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE((HEAP32[i2 + 1124 >> 2] | 0) + 20 | 0);
  i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (i1 | 0) __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE((HEAP32[i1 + 1124 >> 2] | 0) + 20 | 0);
 __ZN17ProfilerFrameData19FreeAllTimerQueriesEv();
 __ZN22UnityProfilerPerThread7CleanupEv();
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
  HEAP32[gb + 1451e3 >> 2] = 0;
  return;
 }
 __ZN13UnityProfilerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
 HEAP32[gb + 1451e3 >> 2] = 0;
 return;
}

function __ZN12b2ChainShape10CreateLoopEPK6b2Vec2i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i3 + 1 | 0;
 i5 = i1 + 16 | 0;
 HEAP32[i5 >> 2] = i7;
 i7 = __Z7b2Alloci(i7 << 3) | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = i7;
 _memcpy(i7 | 0, i2 | 0, i3 << 3 | 0) | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i6 = i7;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i7 + (i3 << 3) | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i4 = HEAP32[i4 >> 2] | 0;
 i5 = i4 + ((HEAP32[i5 >> 2] | 0) + -2 << 3) | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i4 = i4 + 8 | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 36 >> 0] = 1;
 HEAP8[i1 + 37 >> 0] = 1;
 return;
}

function __Z34ParticleSystem_CUSTOM_SetParticlesP12Il2CppObjectP11Il2CppArrayi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem20SetParticlesExternalEP22ParticleSystemParticlei(i5, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 120) | 0, (i3 | 0) < 0 | i4 >>> 0 < i3 >>> 0 ? i4 : i3);
  return;
 }
}

function __Z32Material_CUSTOM_IsKeywordEnabledP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  i3 = (__ZNK8Material16IsKeywordEnabledEPKc(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 return 0;
}

function _UNITY_FT_Stroker_Done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) return;
 i3 = i1 + 128 | 0;
 i2 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
 i4 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = i1 + 72 | 0;
 _UNITY_ft_mem_free(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i5 = i1 + 76 | 0;
 _UNITY_ft_mem_free(i4, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = -1;
 HEAP8[i1 + 92 >> 0] = 0;
 i5 = HEAP32[i1 + 120 >> 2] | 0;
 i4 = i1 + 104 | 0;
 _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 108 | 0;
 _UNITY_ft_mem_free(i5, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = -1;
 HEAP8[i1 + 124 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i1);
 return;
}

function _wstring_read(i3, i4, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i3 + 84 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 do if (!i5) i1 = 0; else {
  i1 = i3 + 44 | 0;
  i5 = _wcsrtombs(HEAP32[i1 >> 2] | 0, i7, HEAP32[i3 + 48 >> 2] | 0, 0) | 0;
  if ((i5 | 0) == -1) {
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   i1 = 0;
   break;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = i3 + 4 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 + 8 >> 2] = i1 + i5;
  HEAP32[i8 >> 2] = HEAP32[i7 >> 2];
  if ((i6 | 0) != 0 & (i5 | 0) != 0) {
   HEAP32[i2 >> 2] = i1 + 1;
   HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
   i1 = 1;
  } else i1 = 0;
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function _write_file_trailer(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i5 + 1;
 HEAP8[i5 >> 0] = -1;
 i5 = i2 + 4 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i4;
 if (!i4) if (!((mftCall_ii(HEAP32[i2 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24)) {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 24;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = -39;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (i5 | 0) return;
 if ((mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i3 | 0) | 0) << 24 >> 24) return;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 20 >> 2] = 24;
 mftCall_vi(HEAP32[i5 >> 2] | 0, i3 | 0);
 return;
}

function __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 58;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK21EnlightenSceneMapping30GetSystemIdFromInputSystemHashERK7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i7) {
  i7 = -1;
  return i7 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = i2;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i2 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  i8 = i5 + (i1 * 56 | 0) + 24 | 0;
  if ((HEAP32[i8 >> 2] | 0) == (i6 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i4 | 0) : 0) {
   i8 = i5 + (i1 * 56 | 0) + 32 | 0;
   if ((HEAP32[i8 >> 2] | 0) == (i2 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i3 | 0) : 0) {
    i2 = 6;
    break;
   }
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = -1;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZNK19VREyeTextureManager43EstimateEyeTextureMemorySizeWithRenderScaleEP13RenderTexturef(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i9 = ~~Math_fround(Math_fround((HEAP32[i3 + 56 >> 2] | 0) >>> 0) * f2);
 i8 = ~~Math_fround(Math_fround((HEAP32[i3 + 60 >> 2] | 0) >>> 0) * f2);
 i7 = HEAP32[i1 + 92 >> 2] | 0;
 i6 = HEAP32[i1 + 96 >> 2] | 0;
 i5 = HEAP32[i1 + 100 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
 i1 = __Z25EstimateRenderTextureSizeiii19RenderTextureFormat17DepthBufferFormat16TextureDimensionb(i9, i8, i7, i6, i5, i4, (HEAP8[i1 + 116 >> 0] | 0) != 0) | 0;
 if ((i1 | 0) <= 0) {
  i9 = i1;
  return i9 | 0;
 }
 i9 = Math_imul(HEAP32[i3 + 100 >> 2] | 0, i1) | 0;
 return i9 | 0;
}

function __ZN5physx9NpFactory22releaseAggregateToPoolERNS_11NpAggregateE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 1840 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 1824 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 1836 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 1828 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 1820 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 1544 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx3Cct26CharacterControllerManagerC2ERNS_7PxSceneE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 86304 + 8;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i4 + 100 | 0;
 i2 = i4 + 8 | 0;
 i3 = i2 + 92 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 >> 2] = Math_fround(.75);
 HEAP32[i4 + 104 >> 2] = -1;
 HEAP32[i4 + 108 >> 2] = 0;
 HEAP32[i4 + 112 >> 2] = 0;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj(i4 + 76 | 0, 64);
 HEAP32[i4 + 116 >> 2] = 0;
 HEAP32[i4 + 120 >> 2] = 0;
 HEAP32[i4 + 124 >> 2] = 0;
 HEAPF32[i4 + 128 >> 2] = Math_fround(1.0);
 HEAP8[i4 + 132 >> 0] = 0;
 HEAP8[i4 + 133 >> 0] = 1;
 HEAP8[i4 + 134 >> 0] = 1;
 HEAP8[i4 + 135 >> 0] = 0;
 return;
}

function __ZN5physx2Gu21findOverlapSphereMeshERKNS0_6SphereERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i8, i2, i3, i6, i5, i1, i7, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 8 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i7;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 i5 = i10 + 20 | 0;
 HEAP8[i5 >> 0] = 0;
 __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i8, i2, i3, i6, i10) | 0;
 HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
 STACKTOP = i9;
 return HEAP32[i7 >> 2] | 0;
}

function __ZN4FMOD7SystemI23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if (i3 | 0) {
  i2 = i1 + 320 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 if (i4 | 0) {
  i3 = i1 + 332 | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 }
 if (i5 | 0) {
  i4 = i1 + 344 | 0;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 }
 if (!i6) return 0;
 i5 = i1 + 356 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 return 0;
}

function __ZN22DeviceMVPMatricesStateC2ER9GfxDevice(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 HEAP32[i1 >> 2] = i4;
 i5 = i1 + 4 | 0;
 i6 = i1 + 132 | 0;
 i1 = i1 + 68 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i5;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 128 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i6;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i2, 4);
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 HEAP32[i6 + 44 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN19VREyeTextureManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 100 >> 2] = 1;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 0;
 i1 = i1 + 48 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN16BaseVideoTextureC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 175688 + 8;
 HEAP32[i1 + 88 >> 2] = 16;
 HEAP32[i1 + 84 >> 2] = 16;
 HEAPF32[i1 + 68 >> 2] = Math_fround(.0625);
 HEAPF32[i1 + 72 >> 2] = Math_fround(.0625);
 HEAP8[i1 + 93 >> 0] = 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP8[i1 + 92 >> 0] = 0;
 HEAP8[i1 + 94 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __Z30CustomEventData_CUSTOM_AddBoolP12Il2CppObjectP12Il2CppStringh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcb(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 << 24 >> 24 != 0) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z17InvalidateVehiclej(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i6 >> 2] = i2;
 i1 = HEAP32[gb + 1458780 >> 2] | 0;
 if (HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31) | 0) {
  STACKTOP = i7;
  return;
 }
 i3 = HEAP32[gb + 1458700 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_(i3, i6);
  i1 = HEAP32[gb + 1458780 >> 2] | 0;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i5 + 4;
 }
 i5 = HEAP32[i6 >> 2] | 0;
 i6 = (HEAP32[i1 + 8 >> 2] | 0) + (i5 >>> 5 << 2) | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 1 << (i5 & 31);
 STACKTOP = i7;
 return;
}

function _UNITY_png_set_cHRM_fixed(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 var i3 = 0, i12 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i12;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  STACKTOP = i12;
  return;
 }
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i3 + 8 >> 2] = i8;
 HEAP32[i3 + 12 >> 2] = i9;
 HEAP32[i3 + 16 >> 2] = i10;
 HEAP32[i3 + 20 >> 2] = i11;
 HEAP32[i3 + 24 >> 2] = i4;
 HEAP32[i3 + 28 >> 2] = i5;
 if (_UNITY_png_colorspace_set_chromaticities(i1, i2 + 40 | 0, i3, 2) | 0) {
  i11 = i2 + 114 | 0;
  HEAP16[i11 >> 1] = HEAPU16[i11 >> 1] | 0 | 16;
 }
 _UNITY_png_colorspace_sync_info(i1, i2);
 STACKTOP = i12;
 return;
}

function _UNITY_png_chunk_unknown_handling(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i4 >> 0] = i1 >>> 24;
 HEAP8[i4 + 1 >> 0] = i1 >>> 16;
 HEAP8[i4 + 2 >> 0] = i1 >>> 8;
 HEAP8[i4 + 3 >> 0] = i1;
 HEAP8[i4 + 4 >> 0] = 0;
 if (!i2) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP32[i2 + 588 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = HEAP32[i2 + 592 >> 2] | 0;
 i1 = i3 + (i1 * 5 | 0) | 0;
 while (1) {
  i2 = i1 + -5 | 0;
  if (!(_memcmp(i4, i2, 4) | 0)) break;
  if (i2 >>> 0 > i3 >>> 0) i1 = i2; else {
   i1 = 0;
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) {
  STACKTOP = i6;
  return i1 | 0;
 }
 i5 = HEAPU8[i1 + -1 >> 0] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_St16initializer_listIwE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 12 | 0;
 i7 = i5 + 8 | 0;
 i9 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i3 + (HEAP32[i4 + 4 >> 2] << 2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 i4 = __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceIPKwEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_(i1, i7, i6, i3, i4) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK13b2CircleShape11ComputeMassEP10b2MassDataf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = i1 + 8 | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f6 = Math_fround(f6 * Math_fround(f6 * Math_fround(3.14159274)));
 HEAPF32[i2 + 16 >> 2] = f6;
 f6 = Math_fround(f6 * f3);
 HEAPF32[i2 >> 2] = f6;
 i7 = i1 + 12 | 0;
 i11 = i7;
 i10 = HEAP32[i11 + 4 >> 2] | 0;
 i9 = i2 + 4 | 0;
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i9 + 4 >> 2] = i10;
 f5 = Math_fround(HEAPF32[i8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f5 * Math_fround(.5)));
 f4 = Math_fround(HEAPF32[i7 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 HEAPF32[i2 + 12 >> 2] = Math_fround(f6 * Math_fround(f5 + Math_fround(f4 + Math_fround(f3 * f3))));
 return;
}

function __ZN9dtNavMesh26unconnectOffMeshConnectionEj(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = HEAP32[i6 + 48 >> 2] | 0;
 i8 = _bitshift64Shl(HEAP32[i3 + (i1 * 104 | 0) + 92 >> 2] | 0, 0, 48) | 0;
 i7 = getTempRet0() | 0;
 i8 = i1 | i8 | 65536;
 i3 = i3 + (i1 * 104 | 0) + 88 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == -1) {
  HEAP32[i3 >> 2] = -1;
  return;
 }
 i4 = i6 + 36 | 0;
 i5 = i6 + 28 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do {
  i9 = i1;
  i1 = HEAP32[i2 + (i1 << 4) + 8 >> 2] | 0;
  i10 = i2 + (i9 << 4) | 0;
  __ZN9dtNavMesh17removeLinkBetweenEyy(i6, HEAP32[i10 >> 2] | 0, HEAP32[i10 + 4 >> 2] | 0, i8, i7);
  i2 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 + (i9 << 4) + 8 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i5 >> 2] = i9;
 } while ((i1 | 0) != -1);
 HEAP32[i3 >> 2] = -1;
 return;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 151188 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 151216 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN4FMOD6System10getVersionEPj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) if (!i3) {
  HEAP32[i5 >> 2] = 37;
  HEAP32[i5 + 4 >> 2] = gb + 861528;
  _printf(gb + 853277 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 37;
  HEAP32[i6 + 4 >> 2] = gb + 861528;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 37;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  HEAP32[i3 >> 2] = 279047;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861528;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z46Animator_CUSTOM_IsParameterControlledByCurveIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator26ParameterControlledByCurveEi(i1, i4) | 0;
 switch (i1 | 0) {
 case 1:
  {
   i4 = 0;
   return i4 | 0;
  }
 case 16:
  {
   i4 = 1;
   return i4 | 0;
  }
 default:
  {
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
   i4 = 0;
   return i4 | 0;
  }
 }
 return 0;
}

function __Z29StdTemplateConversionFunctionIhhEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIhaEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbhEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbbEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIbaEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIahEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29StdTemplateConversionFunctionIaaEbPvR14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i2 + 16 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + (HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 12 >> 2] | 0) + (Math_imul(HEAP32[i2 + 36 >> 2] | 0, 0 - (HEAP32[i2 + 32 >> 2] | 0) | 0) | 0) | 0;
 HEAP32[i6 >> 2] = i3;
 if (i3 >>> 0 >= i4 >>> 0) {
  i4 = i3 + 1 | 0;
  if (i4 >>> 0 <= (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
   i3 = HEAP8[i3 >> 0] | 0;
   HEAP8[i5 >> 0] = i3;
   HEAP32[i6 >> 2] = i4;
   i6 = i3;
   HEAP8[i1 >> 0] = i6;
   STACKTOP = i7;
   return 1;
  }
 }
 __ZN12CachedReader15UpdateReadCacheEPvj(i6, i5, 1);
 i6 = HEAP8[i5 >> 0] | 0;
 HEAP8[i1 >> 0] = i6;
 STACKTOP = i7;
 return 1;
}

function __Z29ConvertDXT5nmNormalMapToPlainPhi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 if ((i3 | 0) > 0) i2 = 0; else return;
 while (1) {
  i4 = i1 + 3 | 0;
  i6 = HEAP8[i4 >> 0] | 0;
  f8 = Math_fround(Math_fround(Math_fround(Math_fround(i6 & 255) / Math_fround(255.0)) * Math_fround(2.0)) + Math_fround(-1.0));
  f7 = Math_fround(Math_fround(Math_fround(Math_fround(HEAPU8[i1 + 1 >> 0] | 0) / Math_fround(255.0)) * Math_fround(2.0)) + Math_fround(-1.0));
  i5 = ~~Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(1.0) - Math_fround(f8 * f8)) - Math_fround(f7 * f7)))) * Math_fround(255.0)) >>> 0;
  HEAP8[i1 >> 0] = i6;
  HEAP8[i1 + 2 >> 0] = i5 >>> 0 > 255 ? 255 : i5;
  HEAP8[i4 >> 0] = -1;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __Z23Mesh_CUSTOM_GetTopologyP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if ((__ZNK4Mesh15GetSubMeshCountEv(i1) | 0) >>> 0 <= i3 >>> 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547320 | 0, 0, gb + 546865 | 0, 497, 1, 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i4 = HEAP32[(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 128 >> 2] | 0) + (i3 * 52 | 0) + 40 >> 2] | 0;
 return i4 | 0;
}

function __Z12testransEvalP10TESSvertexS0_S0_(i3, i1, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0;
 f7 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 28 >> 2]));
 f7 = Math_fround(Math_fround(HEAPF32[i6 + 28 >> 2]) - f7);
 f8 = Math_fround(f9 + f7);
 if (!(f8 > Math_fround(0.0))) {
  f9 = Math_fround(0.0);
  return Math_fround(f9);
 }
 f5 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 24 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 24 >> 2]);
 if (f9 < f7) {
  f9 = Math_fround(Math_fround(f5 - f4) + Math_fround(Math_fround(f9 / f8) * Math_fround(f4 - f2)));
  return Math_fround(f9);
 } else {
  f9 = Math_fround(Math_fround(f5 - f2) + Math_fround(Math_fround(f7 / f8) * Math_fround(f2 - f4)));
  return Math_fround(f9);
 }
 return f0;
}

function __ZNSt3__26thread4joinEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i5 = _pthread_join(HEAP32[i1 >> 2] | 0, 0) | 0;
 if (!i5) {
  HEAP32[i1 >> 2] = 0;
  STACKTOP = i2;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 i2 = __ZNSt3__215system_categoryEv() | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i2;
 __THREW__ = 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 invoke_viii(fb + 1062 | 0, i1 | 0, i3 | 0, gb + 1084765 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i1 | 0, gb + 12920 | 0, fb + 3205 | 0);
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_St16initializer_listIcE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 12 | 0;
 i7 = i5 + 8 | 0;
 i9 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i3 + (HEAP32[i4 + 4 >> 2] | 0) | 0;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 i4 = __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceIPKcEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_(i1, i7, i6, i3, i4) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK14MemoryProfiler22GetIgnoredMemoryLabelsER13dynamic_arrayIiLj4EE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = 6;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if ((i2 & 2147483646) >>> 0 < 6) if ((i2 | 0) > -1) {
  HEAP32[i1 >> 2] = 6;
  i1 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, 24, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 464) | 0;
  HEAP32[i3 >> 2] = i1;
  break;
 } else {
  i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(24, 4, i3 + 4 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
  HEAP32[i1 >> 2] = 6;
  HEAP32[i3 >> 2] = i2;
  i1 = i2;
  break;
 } else i1 = HEAP32[i3 >> 2] | 0; while (0);
 _memcpy(i1 | 0, gb + 66288 | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 return;
}

function __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i4, i3, i6, i5, i9, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i1 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 i8 = i10 + 8 | 0;
 i1 = HEAP32[i4 + 36 >> 2] | 0;
 if (i2 | 0) if (!(HEAP32[i1 + 184 >> 2] | 0)) __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 656850 | 0, 142, gb + 656932 | 0, i7);
 __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE(i8, i3, i4 + 4 | 0);
 __ZNK5physx2Gu12TriangleMesh20computeWorldTriangleERNS_10PxTriangleEjRKNS_2Cm8Matrix34EPjS8_(i1, i5, i6, i8, i9, i2);
 STACKTOP = i10;
 return;
}

function __ZN15TerrainRenderer17CalculateEdgeMaskER12QuadTreeNode(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei(i4, i5, 0) | 0;
 if (!i1) i3 = 1; else i3 = ((HEAP32[i1 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2 & 1;
 i1 = __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei(i4, i5, 1) | 0;
 if (!i1) i2 = 2; else i2 = ((HEAP32[i1 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2 ? 2 : 0;
 i1 = __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei(i4, i5, 2) | 0;
 if (!i1) i1 = 4; else i1 = ((HEAP32[i1 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2 ? 4 : 0;
 i2 = i1 | (i2 | i3);
 i1 = __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei(i4, i5, 3) | 0;
 if (!i1) {
  i5 = 8;
  i5 = i5 | i2;
  return i5 | 0;
 }
 i5 = ((HEAP32[i1 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2 ? 8 : 0;
 i5 = i5 | i2;
 return i5 | 0;
}

function __ZN12CubemapArrayC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7TextureC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 41156 + 8;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 5;
 i3 = i1 + 92 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 1;
 HEAP8[i1 + 106 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN11SoundHandle8Instance22ReleaseIfNotReferencedEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 120 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 4 >> 2] | 0) != 1) return;
 if (((HEAP32[i4 + 44 >> 2] | 0) + -3 | 0) >>> 0 >= 2) return;
 i1 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
 i3 = i4 + 116 | 0;
 if (HEAP8[i3 >> 0] | 0) return;
 i2 = i1 + 24 | 0;
 if ((i4 | 0) != (i2 | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i4 + 4 | 0; else {
   i5 = i4 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i5;
  }
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 >> 2] = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 }
 HEAP8[i3 >> 0] = 1;
 return;
}

function __Z11tesedgeEvalP10TESSvertexS0_S0_(i3, i1, i6) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var f2 = f0, f4 = f0, f5 = f0, f7 = f0, f8 = f0, f9 = f0;
 f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f9 = Math_fround(f7 - Math_fround(HEAPF32[i3 + 24 >> 2]));
 f7 = Math_fround(Math_fround(HEAPF32[i6 + 24 >> 2]) - f7);
 f8 = Math_fround(f9 + f7);
 if (!(f8 > Math_fround(0.0))) {
  f9 = Math_fround(0.0);
  return Math_fround(f9);
 }
 f5 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 28 >> 2]);
 if (f9 < f7) {
  f9 = Math_fround(Math_fround(f5 - f4) + Math_fround(Math_fround(f9 / f8) * Math_fround(f4 - f2)));
  return Math_fround(f9);
 } else {
  f9 = Math_fround(Math_fround(f5 - f2) + Math_fround(Math_fround(f7 / f8) * Math_fround(f2 - f4)));
  return Math_fround(f9);
 }
 return f0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i9 = i7;
 i1 = i1 + 8 | 0;
 i1 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb(i2, i8, i1, i1 + 168 | 0, i5, i4, 0) | 0) - i1 | 0;
 if ((i1 | 0) < 168) HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i9 = i7;
 i1 = i1 + 8 | 0;
 i1 = mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
 HEAP32[i9 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 i1 = (__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb(i2, i8, i1, i1 + 168 | 0, i5, i4, 0) | 0) - i1 | 0;
 if ((i1 | 0) < 168) HEAP32[i6 >> 2] = ((i1 | 0) / 12 | 0 | 0) % 7 | 0;
 STACKTOP = i7;
 return;
}

function __ZN9Rigidbody17SetFreezeRotationEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 88 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i1) {
  i1 = i3 | 112;
  if ((i3 | 0) == (i1 | 0)) return;
  HEAP32[i5 >> 2] = i1;
  __ZN9Rigidbody22UpdateMassDistributionEv(i4);
  return;
 }
 i2 = i3 & -113;
 if ((i3 | 0) == (i2 | 0)) return;
 if (((i3 | 112) ^ -113) & i3 | 0) {
  i1 = HEAP32[i4 + 52 >> 2] | 0;
  if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 }
 HEAP32[i5 >> 2] = i2;
 __ZN9Rigidbody22UpdateMassDistributionEv(i4);
 return;
}

function __ZN5physx9NpFactory22createNpParticleSystemEjb(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i6 + 3640 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i6 + 3636 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i6 + 3344 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i6 + 3624 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i6 = i6 + 3628 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (!i1) {
  i6 = 0;
  i5 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 __ZN5physx16NpParticleSystemC2Ejb(i1, i4, i5);
 i6 = i1;
 i5 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __ZN5physx9NpFactory21releaseMaterialToPoolERNS_10NpMaterialE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 2440 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 2424 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 2436 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 2428 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 2420 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 2144 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcNS_14PxProfileNamesEj(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = i2;
 i10 = HEAP32[i9 >> 2] | 0;
 i9 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, 288, gb + 766896 | 0, gb + 740601 | 0, 138) | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = i10;
 HEAP32[i8 + 4 >> 2] = i9;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i2, i7, i3, i1, i6);
 i3 = i2 + 116 | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i3 | 0);
 STACKTOP = i5;
 return i3 | 0;
}

function __ZN5physx13NpClothFabric14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(__ZN5physx9NpFactory17removeClothFabricERNS_13PxClothFabricE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 723768 | 0, 84, gb + 723849 | 0, i2);
  STACKTOP = i2;
  return;
 }
 if (!(HEAP16[i1 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0); else __ZN5physx9NpFactory24releaseClothFabricToPoolERNS_13NpClothFabricE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i1, 0, 2);
 STACKTOP = i2;
 return;
}

function __ZN35RegisterRuntimeInitializeAndCleanup22ExecuteInitializationsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_(gb + 1170892 | 0, gb + 1170892 + ((HEAP32[gb + 1170888 >> 2] | 0) * 20 | 0) | 0, i5);
 i1 = HEAP32[gb + 1170888 >> 2] | 0;
 if ((i1 | 0) > 0) i4 = 0; else {
  STACKTOP = i5;
  return;
 }
 do {
  i2 = HEAP32[gb + 1170892 + (i4 * 20 | 0) + 8 >> 2] | 0;
  if (i2) {
   i3 = gb + 1170892 + (i4 * 20 | 0) + 16 | 0;
   if (!(HEAP8[i3 >> 0] | 0)) {
    mftCall_vi(i2 | 0, HEAP32[gb + 1170892 + (i4 * 20 | 0) + 4 >> 2] | 0);
    HEAP8[i3 >> 0] = 1;
    i1 = HEAP32[gb + 1170888 >> 2] | 0;
   }
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 STACKTOP = i5;
 return;
}

function __ZN29AnimationStateNetworkProvider24SetNetworkAnimationStateER9AnimationPK24AnimationStateForNetworki(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if ((i8 | 0) <= 0) return;
 i4 = i6 + 104 | 0;
 i1 = 0;
 do {
  __ZN9Animation20BuildAnimationStatesEv(i6);
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i2 = HEAP8[i7 + (i1 * 12 | 0) >> 0] | 0;
  i3 = i5 + 56 | 0;
  if (i2 << 24 >> 24) if (!(HEAP16[i3 >> 1] & 2)) HEAPF64[i5 + 24 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -3 | (i2 & 255) << 1 & 65535;
  HEAP32[i5 + 8 >> 2] = HEAP32[i7 + (i1 * 12 | 0) + 4 >> 2];
  __ZN14AnimationState7SetTimeEf(i5, Math_fround(HEAPF32[i7 + (i1 * 12 | 0) + 8 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i8 | 0));
 return;
}

function __ZN19SkinnedMeshRenderer30CalculateAnimatedPosesWithRootERK10Matrix4x4fPS0_j(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i9;
 if (!(__ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj(i1, i6, i7) | 0)) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 if (!i7) {
  i8 = 1;
  STACKTOP = i9;
  return i8 | 0;
 }
 i1 = 0;
 do {
  i2 = i6 + (i1 << 6) | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i5, i2, i8);
  i3 = i8;
  i4 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 i1 = 1;
 STACKTOP = i9;
 return i1 | 0;
}

function __ZN15ArchiveReadFile4SeekEx10FileOrigin(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 switch (i1 | 0) {
 case 3:
  {
   i2 = (HEAP32[i3 + 8 >> 2] | 0) + 8 | 0;
   i2 = _i64Subtract(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i4 | 0, i5 | 0) | 0;
   i1 = getTempRet0() | 0;
   break;
  }
 case 2:
  {
   i2 = i3 + 16 | 0;
   i2 = _i64Add(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, i4 | 0, i5 | 0) | 0;
   i1 = getTempRet0() | 0;
   break;
  }
 default:
  {
   i1 = i5;
   i2 = i4;
  }
 }
 i6 = (HEAP32[i3 + 8 >> 2] | 0) + 8 | 0;
 i7 = HEAP32[i6 + 4 >> 2] | 0;
 if (!(i1 >>> 0 < i7 >>> 0 | ((i1 | 0) == (i7 | 0) ? i2 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0 : 0))) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = i3 + 16 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i5;
 i7 = 1;
 return i7 | 0;
}

function __ZN14PreloadManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i6 = i5;
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = 0;
 HEAP32[i1 + 52 >> 2] = -1;
 HEAP32[i1 + 48 >> 2] = -1;
 STACKTOP = i2;
 return;
}

function __ZN13SplatDatabase13UploadBasemapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
  __ZN7Texture11SetWrapModeEi(HEAP32[i3 >> 2] | 0, 1);
  i2 = i2 + 28 | 0;
  __ZN6Object27AllocateAndAssignInstanceIDEPS_(HEAP32[i2 >> 2] | 0) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
  __ZN7Texture11SetWrapModeEi(HEAP32[i2 >> 2] | 0, 1);
  i1 = HEAP32[i3 >> 2] | 0;
 } else i2 = i2 + 28 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, 0);
 return;
}

function __ZN13RenderTexture12GenerateMipsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 128 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409216 | 0, 0, gb + 406201 | 0, 697, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i3 = HEAP16[i1 + 116 >> 1] | 0;
 if (!((i3 & 255) << 24 >> 24)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409326 | 0, 0, gb + 406201 | 0, 702, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 if ((i3 & 65535) < 256) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 464 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409424 | 0, 0, gb + 406201 | 0, 707, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
}

function __ZN11CullResults4InitEPKN5Umbra4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 336 | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 if (!i2) {
  i3 = 0;
  i4 = i1 + 80 | 0;
  HEAP32[i4 >> 2] = i3;
  return;
 }
 i4 = __Z9GetIUmbrav() | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i2 | 0) | 0;
 HEAP32[i3 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = i4;
 i4 = __Z9GetIUmbrav() | 0;
 i3 = mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0, i2 | 0, HEAP32[i3 >> 2] | 0, gb + 64024 | 0) | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i4 >> 2] = i3;
 return;
}

function __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByPathP12Il2CppStringRi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 24 | 0;
 i6 = i5 + 16 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 i1 = __Z15GetSceneManagerv() | 0;
 __ZNK11ICallStringcv8UnityStrEv(i4, i6);
 i1 = __ZN19RuntimeSceneManager15FindSceneByPathERK8UnityStr(i1, i4) | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if (!i1) {
  i6 = 0;
  HEAP32[i2 >> 2] = i6;
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 STACKTOP = i5;
 return;
}

function __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByNameP12Il2CppStringRi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 24 | 0;
 i6 = i5 + 16 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 i1 = __Z15GetSceneManagerv() | 0;
 __ZNK11ICallStringcv8UnityStrEv(i4, i6);
 i1 = __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr(i1, i4) | 0;
 if ((HEAP8[i4 + 11 >> 0] | 0) < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i4 = HEAP32[i4 + 12 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i4;
  __Z19free_alloc_internalPvRK10MemLabelId(i6, i3);
 }
 if (!i1) {
  i6 = 0;
  HEAP32[i2 >> 2] = i6;
  STACKTOP = i5;
  return;
 }
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = i6;
 STACKTOP = i5;
 return;
}

function _null_convert_24(i1, i11, i2, i3, i4) {
 i1 = i1 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = HEAP32[i1 + 36 >> 2] | 0;
 i10 = HEAP32[i1 + 92 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i9 = (i10 | 0) == 0;
 if ((i12 | 0) <= 0) return;
 while (1) {
  i8 = i4;
  i4 = i4 + -1 | 0;
  if (!i9) {
   i7 = 0;
   do {
    i1 = i10;
    i5 = (HEAP32[i3 >> 2] | 0) + i7 | 0;
    i6 = HEAP32[(HEAP32[i11 + (i7 << 2) >> 2] | 0) + (i2 << 2) >> 2] | 0;
    while (1) {
     HEAP8[i5 >> 0] = HEAP8[i6 >> 0] | 0;
     i1 = i1 + -1 | 0;
     if (!i1) break; else {
      i5 = i5 + i12 | 0;
      i6 = i6 + 1 | 0;
     }
    }
    i7 = i7 + 1 | 0;
   } while ((i7 | 0) != (i12 | 0));
  }
  if ((i8 | 0) <= 1) break; else {
   i2 = i2 + 1 | 0;
   i3 = i3 + 4 | 0;
  }
 }
 return;
}

function _cff_get_name_index(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 656 >> 2] | 0;
 i1 = _UNITY_ft_module_get_service(HEAP32[i1 + 96 >> 2] | 0, gb + 1006980 | 0) | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = i7 + 12 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = i7 + 1160 | 0;
 i3 = i1 + 20 | 0;
 i1 = 0;
 while (1) {
  i8 = HEAP16[(HEAP32[i4 >> 2] | 0) + (i1 << 1) >> 1] | 0;
  i2 = i8 & 65535;
  if ((i8 & 65535) > 390) i2 = _cff_index_get_string(i7, i2 + -391 | 0) | 0; else i2 = mftCall_ii(HEAP32[i3 >> 2] | 0, i2 | 0) | 0;
  if (i2 | 0) if (!(_strcmp(i6, i2) | 0)) {
   i2 = 10;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= (HEAP32[i5 >> 2] | 0) >>> 0) {
   i1 = 0;
   i2 = 10;
   break;
  }
 }
 if ((i2 | 0) == 10) return i1 | 0;
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i6, i3, i5) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i7 = 0;
 if (i3 | 0) {
  i7 = i6 + 11 | 0;
  i1 = HEAP8[i7 >> 0] | 0;
  if (i1 << 24 >> 24 < 0) {
   i2 = (HEAP32[i6 + 8 >> 2] & 2147483647) + -1 | 0;
   i4 = HEAP32[i6 + 4 >> 2] | 0;
  } else {
   i2 = 10;
   i4 = i1 & 255;
  }
  if ((i2 - i4 | 0) >>> 0 < i3 >>> 0) {
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i6, i2, i3 - i2 + i4 | 0, i4, i4, 0, 0);
   i1 = HEAP8[i7 >> 0] | 0;
  }
  if (i1 << 24 >> 24 < 0) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
  _memset(i2 + i4 | 0, i5 | 0, i3 | 0) | 0;
  i1 = i4 + i3 | 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i6 + 4 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
 }
 return i6 | 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc20ArticulationJointSimD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 90892 + 8;
 HEAP32[i2 + 24 >> 2] = gb + 90892 + 44;
 i1 = i2 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i2 + 4 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, 2, i1);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE(HEAP32[i1 + 152 >> 2] | 0, i1);
 HEAP32[HEAP32[i2 + 36 >> 2] >> 2] = 0;
 __ZN5physx2Sc16ActorInteractionD2Ev(i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx14PxVehicleGraph5setupERKNS_18PxVehicleGraphDescENS_18PxVehicleGraphType4EnumE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(.5));
 HEAPF32[i3 + 15808 >> 2] = Math_fround(f4 - f5);
 HEAPF32[i3 + 15812 >> 2] = Math_fround(f4 + f5);
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) * Math_fround(.5));
 HEAPF32[i3 + 15816 >> 2] = Math_fround(f5 - f4);
 HEAPF32[i3 + 15820 >> 2] = Math_fround(f5 + f4);
 HEAP32[i3 + 15792 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 15796 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 15800 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 15804 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i3 + 15828 >> 2] = (i2 | 0) == 0 ? 11 : 9;
 return;
}

function __ZN4FMOD7Channel15getCurrentSoundEPPNS_5SoundE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i4) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = HEAP32[i2 + 64 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870049;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System11getCPUUsageEPfS1_S1_S1_S1_(i2, i5, i6, i7, i8, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  if (i5 | 0) HEAPF32[i5 >> 2] = Math_fround(60.0);
  if (i6 | 0) HEAPF32[i6 >> 2] = Math_fround(30.0);
  if (i7 | 0) HEAPF32[i7 >> 2] = Math_fround(0.0);
  if (!i8) {
   i8 = 0;
   STACKTOP = i4;
   return i8 | 0;
  }
  HEAPF32[i8 >> 2] = Math_fround(10.0);
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870236;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i4;
 return i8 | 0;
}

function __ZN15TerrainCollider7CleanupEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN8Collider7CleanupEv(i6);
 i4 = i6 + 80 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i6 + 92 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = i6 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, i6 + 84 | 0);
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i6 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i6 = i6 + 72 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[HEAP32[i6 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 48 | 0;
 i4 = i8 + 32 | 0;
 i5 = i8 + 16 | 0;
 i6 = i8;
 __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ERKS5_(i7, i3);
 if (!i1) {
  STACKTOP = i8;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i5, gb + 1097664 | 0);
  __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EdeEv(i6, i7);
  __Z3maxRK8Scalar4fS1_(i4, i5, i6);
  __ZN8Scalar4faSERKS_(i2, i4) | 0;
  __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EppEv(i7) | 0;
  if (!i1) break; else i2 = i2 + 16 | 0;
 }
 STACKTOP = i8;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 8;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i4 = i2 + 7 | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i2 + 1 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i5 = i2 + 6 | 0;
 HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = i1;
 i5 = i2 + 2 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i4 = i2 + 5 | 0;
 HEAP8[i5 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i2 + 3 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i2 + 4 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i1;
 STACKTOP = i3;
 return;
}

function __ZN11UmbraModule14FreeVisibilityEPN5Umbra10VisibilityEbRK10MemLabelId(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i2) return;
 if (i3) __Z19free_alloc_internalPvRK10MemLabelId(__ZNK5Umbra9IndexList6getPtrEv(__ZNK5Umbra10Visibility16getOutputObjectsEv(i2) | 0) | 0, i4);
 __Z19free_alloc_internalPvRK10MemLabelId(__ZNK5Umbra9IndexList6getPtrEv(__ZNK5Umbra10Visibility17getOutputClustersEv(i2) | 0) | 0, i4);
 i5 = __ZNK5Umbra10Visibility16getOutputObjectsEv(i2) | 0;
 i1 = __ZNK5Umbra10Visibility15getOutputBufferEv(i2) | 0;
 i3 = __ZNK5Umbra10Visibility17getOutputClustersEv(i2) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 return;
}

function __Z38Avatar_CUSTOM_INTERNAL_CALL_GetZYPostQP12Il2CppObjectiRK11QuaternionfS3_RS1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK6Avatar10GetZYPostQEiRK11QuaternionfS2_(i6, i7, i2, i3, i4);
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  STACKTOP = i8;
  return;
 }
}

function __Z31CustomEventData_CUSTOM_AddSByteP12Il2CppObjectP12Il2CppStringa(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 << 24 >> 24) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z31CustomEventData_CUSTOM_AddInt16P12Il2CppObjectP12Il2CppStrings(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 << 16 >> 16) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _destroy(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!i4) {
  i4 = -2;
  return i4 | 0;
 }
 i1 = HEAP32[i4 + 80 >> 2] | 0;
 if (i1 | 0) _free(i1);
 L7 : do if (!(HEAP32[i4 + 28 >> 2] | 0)) i1 = 0; else switch (HEAP8[i4 + 92 >> 0] | 0) {
 case 119:
  {
   i1 = _unity_z_deflateEnd(i4) | 0;
   break L7;
  }
 case 114:
  {
   i1 = _unity_z_inflateEnd(i4) | 0;
   break L7;
  }
 default:
  {
   i1 = 0;
   break L7;
  }
 } while (0);
 i2 = HEAP32[i4 + 64 >> 2] | 0;
 if (i2) if (_fclose(i2) | 0) {
  i3 = (HEAP32[(___errno_location() | 0) >> 2] | 0) == 29;
  i1 = i3 ? i1 : -1;
 }
 i3 = HEAP32[i4 + 56 >> 2] | 0;
 i2 = HEAP32[i4 + 68 >> 2] | 0;
 if (i2 | 0) _free(i2);
 i2 = HEAP32[i4 + 72 >> 2] | 0;
 if (i2 | 0) _free(i2);
 i2 = HEAP32[i4 + 84 >> 2] | 0;
 if (i2 | 0) _free(i2);
 _free(i4);
 i4 = (i3 | 0) < 0 ? i3 : i1;
 return i4 | 0;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 i12 = HEAP32[i3 + 48 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i11 = f7 > Math_fround(0.0);
 i8 = f10 > Math_fround(0.0);
 i3 = Math_fround(HEAPF32[i2 + 8 >> 2]) > Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i12 + 144 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 148 >> 2]);
 f5 = Math_fround(HEAPF32[i12 + 152 >> 2]);
 f9 = Math_fround(-f10);
 f6 = Math_fround(-f7);
 f4 = Math_fround(-f5);
 HEAPF32[i1 >> 2] = i11 ? f10 : f9;
 HEAPF32[i1 + 4 >> 2] = i8 ? f7 : f6;
 HEAPF32[i1 + 8 >> 2] = i3 ? f5 : f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 92 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 84 >> 2] | 0;
 i3 = i1 + 88 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 4) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN22BaseUnityConnectClient9InitStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP8[i1 + 113 >> 0] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 112 >> 0] = 1;
 HEAP8[i1 + 111 >> 0] = 0;
 HEAP8[i1 + 109 >> 0] = 0;
 HEAP8[i1 + 110 >> 0] = 0;
 i2 = i1 + 64 | 0;
 HEAP32[i1 + 292 >> 2] = 0;
 i3 = i2;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i2 + 44 >> 0] = 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63160 | 0, 16, gb + 1042345 | 0, 56) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = i4 + 4;
 HEAP32[i4 + 16 >> 2] = 1;
 HEAP32[i1 + 544 >> 2] = i4;
 return;
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb(i6, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i6, i1);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 > (HEAP32[i1 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i3, i2, 4);
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 HEAP32[i6 + 160 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 if (!i7) {
  STACKTOP = i8;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i8;
 return;
}

function __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 switch (i3 | 0) {
 case 2:
  {
   i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, HEAP32[i1 + 24 >> 2] | 0, (HEAP32[i1 + 28 >> 2] | 0) + 1 | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
   return i5 | 0;
  }
 case 3:
  {
   i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, HEAP32[i1 + 24 >> 2] | 0, (HEAP32[i1 + 28 >> 2] | 0) + -1 | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
   return i5 | 0;
  }
 default:
  {
   i4 = HEAP32[i1 + 24 >> 2] | 0;
   i5 = HEAP32[i1 + 28 >> 2] | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i3) {
    i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, i4 + -1 | 0, i5, i1) | 0;
    return i5 | 0;
   } else {
    i5 = __ZN15TerrainRenderer7GetNodeEiii(i2, i4 + 1 | 0, i5, i1) | 0;
    return i5 | 0;
   }
  }
 }
 return 0;
}

function __ZN13RenderTexture19MarkRestoreExpectedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 12 | 0;
 i8 = i2 + 8 | 0;
 i7 = i2 + 4 | 0;
 i6 = i2;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 344 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 344 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 + 136 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 344 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 132 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN11LightProbesD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = gb + 34648 + 8;
 i1 = i5 + 168 | 0;
 if ((HEAP32[i5 + 184 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 172 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 148 | 0;
 if ((HEAP32[i5 + 164 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 152 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i5 + 136 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 140 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -40 - i2 | 0) >>> 0) / 40 | 0) * 40 | 0);
  __ZdlPv(i1);
 }
 __ZN11LightProbes14LightProbeDataD2Ev(i5 + 32 | 0);
 HEAP32[i5 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i5 + 28 | 0);
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 return;
}

function __Z47Physics_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK8Vector3fS1_P11Il2CppArrayRK11Quaternionfi23QueryTriggerInteraction(i1, i2, i6, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0;
 i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0;
 i8 = __Z17GetPhysicsManagerv() | 0;
 i2 = __ZN14PhysicsManager18OverlapBoxNonAllocERK8Vector3fS2_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction(i8, i1, i2, i3, i7, __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0, i4, i5) | 0;
 if (!i2) return i2 | 0; else i1 = 0;
 do {
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i7 + (i1 << 2) >> 2] | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return i2 | 0;
}

function __Z34TextMesh_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 80 >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z29RegisterVRDeviceStereoDisplayv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 1344 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i4 = i1 + 668 | 0;
 i3 = __Z18GetUnityInterfacesv() | 0;
 _memset(i4 | 0, 0, 668) | 0;
 _strncpy(i4, gb + 1046398 | 0, 64) | 0;
 _strncpy(i4 + 64 | 0, gb + 1046405 | 0, 64) | 0;
 HEAP8[i4 + 262 >> 0] = 1;
 HEAP8[i4 + 260 >> 0] = 0;
 HEAP32[i4 + 264 >> 2] = fb + 2767;
 HEAP32[i4 + 268 >> 2] = fb + 309;
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = 586239589;
 HEAP32[i5 + 4 >> 2] = 1008725759;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = 426257907;
 HEAP32[i5 + 4 >> 2] = -2134066609;
 i3 = HEAP32[(mftCall_ii(i3 | 0, i2 | 0) | 0) >> 2] | 0;
 _memcpy(i2 | 0, i4 | 0, 668) | 0;
 mftCall_vi(i3 | 0, i2 | 0);
 STACKTOP = i1;
 return gb + 1046398 | 0;
}

function __Z13IsPathCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 12 | 0;
 i3 = i5;
 i4 = i1 + 11 | 0;
 i6 = HEAP8[i4 >> 0] | 0;
 if (!((i6 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 i6 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i3, i6, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i2, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i6 = __ZNK15FileSystemEntry6ExistsEv(i2) | 0;
 __ZN13FileEntryDataD2Ev(i2);
 STACKTOP = i5;
 return i6 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEwj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 HEAP32[i5 >> 2] = i3;
 do if (i1 >>> 0 > i4 >>> 0) {
  __THREW__ = 0;
  i1 = invoke_iiii(fb + 514 | 0, i2 + (i4 << 2) | 0, i1 - i4 | 0, i5 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i5);
  } else {
   i6 = (i1 | 0) == 0 ? -1 : i1 - i2 >> 2;
   break;
  }
 } else i6 = -1; while (0);
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__211__libcpp_db15__find_c_from_iEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i2) | 0;
 if (!i1) {
  i4 = HEAP32[gb + 191628 >> 2] | 0;
  HEAP32[i3 >> 2] = gb + 1076435;
  _fprintf(i4, gb + 1076431 | 0, i3) | 0;
  __THREW__ = 0;
  invoke_v(fb + 457 | 0);
  __THREW__ = 0;
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  ___resumeException(i4 | 0);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, f2 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f2 = Math_fround(HEAPF32[i5 + 4 >> 2]);
  do if (f2 == Math_fround(0.0)) i3 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
   i3 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i3 << 16 >> 16)) {
    i3 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i3 = (i3 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i3;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx9NpFactory21createNpParticleFluidEjb(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i6 + 3940 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i6 + 3936 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i6 + 3644 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i6 + 3924 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i6 = i6 + 3928 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 if (!i1) {
  i6 = 0;
  i5 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 __ZN5physx15NpParticleFluidC2Ejb(i1, i4, i5);
 i6 = i1;
 i5 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __ZN5physx8debugger14PvdMarshallingIjdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24) >>> 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 * 12 | 0, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 * 12 | 0) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   i1 = i1 + 12 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 12 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx3Ext18ProfileZoneHandler13onZoneRemovedERNS_13PxProfileZoneE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 12 | 0;
 i6 = i1 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 while (1) {
  i2 = i1 + -1 | 0;
  if (!i1) {
   i5 = 7;
   break;
  }
  i1 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) {
   i3 = i2;
   break;
  } else i1 = i2;
 }
 if ((i5 | 0) == 7) return;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
 if (i2) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i6 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
 HEAP32[i7 >> 2] = i6;
 HEAP32[i1 + (i3 << 2) >> 2] = HEAP32[i1 + (i6 << 2) >> 2];
 return;
}

function __ZN5physx2Gu18findOverlapOBBMeshERKNS0_3BoxERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb(i8, i2, i3, i6, i5, i1, i7, i4) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 8 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i7;
 i7 = i10 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i10 + 16 >> 2] = 0;
 i5 = i10 + 20 | 0;
 HEAP8[i5 >> 0] = 0;
 __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i8, i2, i3, i6, i10) | 0;
 HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
 STACKTOP = i9;
 return HEAP32[i7 >> 2] | 0;
}

function __ZN5physx2Gu10ConvexMesh15exportExtraDataERNS_22PxSerializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 i3 = ((HEAPU8[i1 + 55 >> 0] | 0) * 20 | 0) + (HEAP32[i1 + 80 >> 2] & 2147483647) + ((HEAPU8[i1 + 54 >> 0] | 0) * 15 | 0) + ((HEAPU16[i1 + 52 >> 1] | 0) << 1) | 0;
 i4 = i3 & 3;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 + 56 >> 2] | 0, ((i4 | 0) == 0 ? 0 : 4 - i4 | 0) + i3 | 0);
 i1 = i1 + 84 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 28);
 __ZN5physx13BigConvexData15exportExtraDataERNS_22PxSerializationContextE(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i4) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = HEAP32[i2 + 48 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
   HEAP32[i4 >> 2] = i1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862092;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN19ConstantBuffersGLES5ClearEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i7 + 12 | 0;
 i6 = i7 + 16 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 - i2 | 0;
 i5 = (i3 | 0) / 12 | 0;
 if ((i3 | 0) > 0) {
  i3 = 0;
  do {
   i1 = HEAP32[i2 + (i3 * 12 | 0) >> 2] | 0;
   if (i1 | 0) __ZdaPv(i1);
   i1 = HEAP32[i2 + (i3 * 12 | 0) + 4 >> 2] | 0;
   if (i1 | 0) __ZN14DataBufferGLES7ReleaseEv(i1);
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  } while ((i3 | 0) < (i5 | 0));
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if ((i1 | 0) != (i2 | 0)) HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
 i3 = HEAP32[i7 >> 2] | 0;
 i1 = i7 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 return;
}

function __ZN10GUIElement7HitTestERK8Vector2fRK5RectTIfE(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var f1 = f0, f5 = f0, f6 = f0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, i2 | 0, i3 | 0);
 f5 = Math_fround(HEAPF32[i4 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 f1 = Math_fround(HEAPF32[i7 >> 2]);
 if (!(f1 <= f5)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 if (!(Math_fround(f1 + Math_fround(HEAPF32[i7 + 8 >> 2])) > f5)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 f1 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 if (!(f1 <= f6)) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i7 = Math_fround(f1 + Math_fround(HEAPF32[i7 + 12 >> 2])) > f6;
 STACKTOP = i8;
 return i7 | 0;
}

function __Z33GUIText_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 84 >> 2] | 0;
  f6 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i3 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i3 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i2 >> 2] = Math_fround(Math_fround(i3 & 255) / Math_fround(255.0));
  HEAPF32[i2 + 4 >> 2] = f6;
  HEAPF32[i2 + 8 >> 2] = f5;
  HEAPF32[i2 + 12 >> 2] = f4;
  return;
 }
}

function __Z14DrawGUITextureRK5RectTIfEP7Textureiiiif11ColorRGBA32P8Materiali(i1, i2, i3, i4, i5, i6, f7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11 + 24 | 0;
 i13 = i11 + 8 | 0;
 i14 = i11;
 HEAPF32[i13 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i13 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i13 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i14 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i14 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali(i1, i2, i13, i3, i4, i5, i6, f7, i12, i9, i10);
 STACKTOP = i11;
 return;
}

function __ZN5physx16NpParticleSystem12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i4 = i3 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 251658240;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP8[i3 + 43 >> 0] = 0;
 HEAP32[i3 + 188 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = 0;
 HEAP8[i3 + 196 >> 0] = 0;
 i4 = i3 + 172 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 >> 2] = gb + 97380 + 8;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 200;
 __ZN5physx2Sc18ParticleSystemCore15importExtraDataERNS_24PxDeserializationContextE(i3 + 32 | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 244 >> 2] | 0, i3 | 0, i2 | 0);
 return i3 | 0;
}

function __Z32CustomEventData_CUSTOM_AddUInt16P12Il2CppObjectP12Il2CppStringt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 & 65535) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function mftCall_iiiiiiiiiiiiffffii(i18, i1, i2, i10, i11, i12, i13, i14, i15, i16, i17, i3, d4, d5, d6, d7, i8, i9) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 d7 = +d7;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i18 | 0) >= (fb | 0) & (i18 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiiiiiiiiffffii[i18 - fb & 3](i1 | 0, i2 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i3 | 0, Math_fround(d4), Math_fround(d5), Math_fround(d6), Math_fround(d7), i8 | 0, i9 | 0) | 0;
 return ftCall_iiiiiiiiiiiiffffii(i18 | 0, i1 | 0, i2 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i3 | 0, +d4, +d5, +d6, +d7, i8 | 0, i9 | 0) | 0;
}

function _pshinter_module_class_pic_init(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = 0;
 i2 = _UNITY_ft_mem_alloc(HEAP32[i4 >> 2] | 0, 12, i5) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i3 = i4 + 200 | 0;
 HEAP32[i3 >> 2] = i2;
 _UNITY_FT_Init_Class_pshinter_interface(i4, i2);
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 _UNITY_ft_mem_free(HEAP32[i4 >> 2] | 0, i2);
 HEAP32[i3 >> 2] = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK5physx7NpScene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 | 0) >= 37) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 678666 | 0, 2653, gb + 705497 | 0, i3);
  f4 = Math_fround(0.0);
  STACKTOP = i3;
  return Math_fround(f4);
 }
 if (HEAP32[i2 + 3388 >> 2] & 64 | 0) if (HEAP8[i2 + 3028 + i1 >> 0] | 0) {
  f4 = Math_fround(HEAPF32[i2 + 2880 + (i1 << 2) >> 2]);
  STACKTOP = i3;
  return Math_fround(f4);
 }
 f4 = Math_fround(__ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i2 + 32 | 0, i1));
 STACKTOP = i3;
 return Math_fround(f4);
}

function __ZNK5physx7NpCloth10isSleepingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore10isSleepingEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 946, gb + 691553 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx14PxsAABBManager11getBPBoundsEj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i8 = HEAP32[i3 + (i2 * 24 | 0) >> 2] | 0;
 i7 = HEAP32[i3 + (i2 * 24 | 0) + 4 >> 2] | 0;
 i6 = HEAP32[i3 + (i2 * 24 | 0) + 8 >> 2] | 0;
 i5 = HEAP32[i3 + (i2 * 24 | 0) + 12 >> 2] | 0;
 i4 = HEAP32[i3 + (i2 * 24 | 0) + 16 >> 2] | 0;
 i2 = HEAP32[i3 + (i2 * 24 | 0) + 20 >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (i8 | 0) < 0 ? i8 & 2147483647 : ~i8;
 HEAP32[i1 + 4 >> 2] = (i7 | 0) < 0 ? i7 & 2147483647 : ~i7;
 HEAP32[i1 + 8 >> 2] = (i6 | 0) < 0 ? i6 & 2147483647 : ~i6;
 HEAP32[i3 >> 2] = (i5 | 0) < 0 ? i5 & 2147483647 : ~i5;
 HEAP32[i3 + 4 >> 2] = (i4 | 0) < 0 ? i4 & 2147483647 : ~i4;
 HEAP32[i3 + 8 >> 2] = (i2 | 0) < 0 ? i2 & 2147483647 : ~i2;
 return;
}

function __ZN5physx15NpParticleFluid12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 i4 = i3 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 251658240;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP8[i3 + 43 >> 0] = 0;
 HEAP32[i3 + 188 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = 0;
 HEAP8[i3 + 196 >> 0] = 0;
 i4 = i3 + 172 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP8[i4 + 12 >> 0] = 0;
 HEAP32[i3 >> 2] = gb + 96200 + 8;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 200;
 __ZN5physx2Sc18ParticleSystemCore15importExtraDataERNS_24PxDeserializationContextE(i3 + 32 | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 276 >> 2] | 0, i3 | 0, i2 | 0);
 return i3 | 0;
}

function __ZN5physx12NpConstraint12createObjectERPhRNS_24PxDeserializationContextE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP32[i3 >> 2] = gb + 93148 + 8;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 i2 = i3 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 251658240;
 HEAP16[i3 + 28 >> 1] = 0;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 96 >> 2] = 0;
 HEAP16[i3 + 124 >> 1] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 132;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i2 | 0) | 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return i3 | 0;
 HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i2 | 0) | 0;
 return i3 | 0;
}

function __ZN22DownloadHandlerTextureC2Eb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187656 + 8;
 i8 = gb + 63808 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = i2 & 1;
 STACKTOP = i3;
 return;
}

function __ZN13RuntimeStaticI15GUIEventManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(24, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(24, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i4 + 20 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader13OnReceiveDataEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP8[i1 + 14 >> 0] | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP8[i1 + 13 >> 0] | 0)) if (!(__ZN11UnityEngine15CloudWebService18RestFileDownloader7OpenVFSEv(i1) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i6 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 __ZN12FileAccessor5WriteEyPKvPy(i1 + 1092 | 0, i3, 0, i2, i4) | 0;
 i2 = i4;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 2164 | 0;
 i2 = _i64Add(HEAP32[i3 >> 2] | 0, 0, i4 | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 getTempRet0() | 0;
 HEAP32[i3 >> 2] = i2;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__27promiseIvE9set_valueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__217__assoc_sub_state9set_valueEv(i1);
  STACKTOP = i2;
  return;
 }
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i4 >> 2] = 3;
 HEAP32[i4 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i3 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i4 | 0);
 } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
}

function __ZN8Animator13SetUpdateModeENS_10UpdateModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i3 = i6;
 i4 = i1 + 96 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 >> 2] = i2;
 if (__Z14IsWorldPlayingv() | 0) if (HEAP8[i1 + 33 >> 0] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0);
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
  i8 = i1 + 628 | 0;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i3;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  mftCall_viii(i4 | 0, i1 | 0, i5 | 0, 0);
 }
 STACKTOP = i6;
 return;
}

function __ZN5physx7NpCloth6wakeUpEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[i1 + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore6wakeUpEf(i2 + 32 | 0, Math_fround(HEAPF32[i1 + 2860 >> 2]));
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1002, gb + 691695 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth20addCollisionTriangleERKNS_24PxClothCollisionTriangleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore20addCollisionTriangleERKNS_24PxClothCollisionTriangleE(i1 + 32 | 0, i2);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 412, gb + 694285 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Gu28checkOverlapSphere_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, f6 = f0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i5, i2);
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i5 >> 2]));
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(f4 + Math_fround(f6 * Math_fround(HEAPF32[i5 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i5 + 8 >> 2])));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 i3 = Math_fround(f4 - Math_fround(HEAPF32[i3 + 12 >> 2])) <= Math_fround(0.0);
 STACKTOP = i1;
 return i3 | 0;
}

function __ZN5Flare7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, i1, 16, gb + 1048932 | 0, 0, gb + 377820 | 0, 25) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 32876 + 8;
 i2 = i4 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14GfxDeviceStats10ResetFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 120 | 0;
 i3 = i1 + 124 | 0;
 i4 = i1 + 4 | 0;
 i5 = i4 + 116 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i4 = i1 + 144 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i1 + 272 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 276 >> 2] = Math_fround(0.0);
 i4 = i1 + 200 | 0;
 i5 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 return;
}

function __ZN13GfxDeviceGLES26SetRandomWriteTargetBufferEi15ComputeBufferID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 if (i2 >>> 0 < 8) {
  i4 = i1 + 7196 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = (i6 | 0) < (i2 | 0) ? i2 : i6;
  HEAP32[i1 + 7232 + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 7200 + (i2 << 2) >> 2] = 0;
  STACKTOP = i5;
  return;
 } else {
  __Z6FormatPKcz(i4, gb + 603741 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 603515 | 0, 2034, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN12_GLOBAL__N_110Connection16createDataStreamEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = HEAP32[i1 + 60 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i7 = i1 + 24 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0) | 0;
 i8 = i1 + 64 | 0;
 i2 = i8;
 i2 = _i64Add(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 1, 0) | 0;
 i1 = getTempRet0() | 0;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i8 + 4 >> 2] = i1;
 i7 = HEAP32[i7 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 20 >> 2] | 0, i7 | 0);
 return __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy(i6, i5, i4, i3, i2, i1) | 0;
}

function __Z30CustomEventData_CUSTOM_AddCharP12Il2CppObjectP12Il2CppStringt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 & 65535) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z24Mathf_CUSTOM_HalfToFloatt(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = i1 & 65535;
 i1 = i3 & 32767;
 L1 : do if (!i1) i1 = 0; else {
  i1 = i1 << 13;
  i2 = i1 & 260046848;
  L3 : do if ((i2 | 0) < 260046848) {
   switch (i2 | 0) {
   case 0:
    break;
   default:
    break L3;
   }
   f4 = Math_fround((HEAP32[tempDoublePtr >> 2] = i1 + 947912704, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-.0000610351563));
   i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
   break L1;
  } else {
   switch (i2 | 0) {
   case 260046848:
    break;
   default:
    break L3;
   }
   i1 = i1 | 1879048192;
   break L1;
  } while (0);
  i1 = i1 + 939524096 | 0;
 } while (0);
 return Math_fround((HEAP32[tempDoublePtr >> 2] = i1 | i3 << 16 & -2147483648, Math_fround(HEAPF32[tempDoublePtr >> 2])));
}

function __Z22Check3MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_P6ObjectR11MonoManager(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i8 + 24 | 0;
 i9 = i8 + 8 | 0;
 i11 = i8;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i9 + 8 >> 2] = i5;
 i3 = i1;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i11;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i10 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i10 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 i7 = __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i10, i2, i9, 3, i6, i7) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN9Transform15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63160 | 0, 16, gb + 421957 | 0, 451) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i2 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[gb + 1158396 >> 2] = i2;
 HEAP32[i2 + 44 >> 2] = 1;
 HEAP32[i2 + 20 >> 2] = 1;
 HEAP32[i2 + 24 >> 2] = 1;
 HEAP32[i2 + 28 >> 2] = 1;
 HEAP32[gb + 1477024 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 1;
 STACKTOP = i1;
 return;
}

function __ZN8Animator27FreeGlobalSpaceSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 8 | 0;
 i4 = i5;
 i3 = i5 + 16 | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i2, i4);
 i6 = i2;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math7affineXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i1, i3);
 STACKTOP = i5;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat14TexFormatRHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIidE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE(i5, i4, i3, i1, i2) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(__ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i5) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 700312 | 0, 428, gb + 700558 | 0, i6);
  STACKTOP = i6;
  return;
 }
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx3Scb14ParticleSystem9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEENS_11PxForceMode4EnumE(i5 + 20 | 0, i4, i3, i1, i2);
 STACKTOP = i6;
 return;
}

function __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_(i3, i2, i5, i4, i6, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 HEAP32[i8 + 12 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 16 >> 2] = i3;
 HEAPF32[i8 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 12 >> 2]));
 HEAPF32[i8 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 + 16 >> 2]));
 __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb(i8, i2, i4, i6, i1, i5, 1, 1) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5physx11NpReadCheckD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if ((HEAP32[i1 + 3872 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) if (!(HEAP16[((HEAP32[i1 + 3388 >> 2] & 4 | 0) == 0 ? i1 + 1224 | 0 : i1 + 3364 | 0) >> 1] & 4096)) {
  i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i3 + 4 >> 2] = i5;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 8, gb + 769897 | 0, 60, gb + 770376 | 0, i3);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZNK5physx7NpScene8stopReadEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN14VelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z37Collider2D_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN10Collider2D9GetBoundsEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  STACKTOP = i5;
  return;
 }
}

function _UNITY_FT_GlyphLoader_CheckSubGlyphs(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = 0;
 i8 = i7 + 48 | 0;
 i1 = (HEAP32[i8 >> 2] | 0) + i1 + (HEAP32[i7 + 84 >> 2] | 0) | 0;
 i5 = i7 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i1 >>> 0 <= i2 >>> 0) {
  i8 = 0;
  STACKTOP = i9;
  return i8 | 0;
 }
 i3 = i1 + 1 & -2;
 i1 = i7 + 52 | 0;
 i2 = _UNITY_ft_mem_realloc(i4, 32, i2, i3, HEAP32[i1 >> 2] | 0, i6) | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP32[i5 >> 2] = i3;
 HEAP32[i7 + 88 >> 2] = i2 + (HEAP32[i8 >> 2] << 5);
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 140 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 144 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 148 >> 2])) return;
  }
 } else i1 = i6 + 144 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 148 >> 2] = i2;
 HEAP32[i6 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i2, i6, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 __ZNSt3__214__shared_count12__add_sharedEv(i6);
 i3 = i2 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if ((HEAP32[i2 + 12 >> 2] | 0) - i1 >> 2 >>> 0 > i5 >>> 0) i4 = i3; else {
  __THREW__ = 0;
  invoke_vii(fb + 4566 | 0, i3 | 0, i5 + 1 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   i4 = i3;
   i1 = HEAP32[i3 >> 2] | 0;
   break;
  }
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i6 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i6) | 0;
  ___resumeException(i1 | 0);
 } while (0);
 i2 = HEAP32[i1 + (i5 << 2) >> 2] | 0;
 if (i2) {
  __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i1 + (i5 << 2) >> 2] = i6;
 return;
}

function __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i2 + 4 >> 0] | 0)) {
  __THREW__ = 0;
  invoke_vii(fb + 4496 | 0, 1, gb + 1076253 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) i3 = 3;
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  __THREW__ = 0;
  i1 = invoke_iii(fb + 1143 | 0, i1 | 0, HEAP32[i2 >> 2] | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) {
   if (i1 | 0) {
    __THREW__ = 0;
    invoke_vii(fb + 4496 | 0, i1 | 0, gb + 1076296 | 0);
    i4 = __THREW__;
    __THREW__ = 0;
    if (i4 & 1) {
     i4 = ___cxa_find_matching_catch_3(0) | 0;
     getTempRet0() | 0;
     ___clang_call_terminate(i4);
    }
   }
   return;
  }
 }
 i4 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___clang_call_terminate(i4);
}

function __ZNK5physx7NpCloth16getRestPositionsEPNS_6PxVec4E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i4 = __ZNK5physx2Sc9ClothCore16getRestPositionsEPNS_6PxVec4E(i2 + 32 | 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 830, gb + 692548 | 0, i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK13b2CircleShape9TestPointERK11b2TransformRK6b2Vec2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f6 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f5));
 f5 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f5));
 f4 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f4);
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 4 >> 2]) + f5);
 f4 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) - f4);
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) - f5);
 f5 = Math_fround(Math_fround(f4 * f4) + Math_fround(f5 * f5));
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 return f5 <= Math_fround(f4 * f4) | 0;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 12 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i2 = i4;
 i1 = i1 + 76 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i5 | 0, i2 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD6System13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i(i5, i6, i7, i8, i9, i1, i2, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i1 + 376 >> 2] = i6;
  HEAP32[i1 + 380 >> 2] = i7;
  HEAP32[i1 + 384 >> 2] = i8;
  HEAP32[i1 + 388 >> 2] = i9;
  i9 = 0;
  STACKTOP = i4;
  return i9 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861539;
 _printf(gb + 853184 | 0, i3) | 0;
 i9 = 36;
 STACKTOP = i4;
 return i9 | 0;
}

function __ZN4FMOD6System12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869254;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869254;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869254;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN13ConstantForce23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 735691 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 801108 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 801116 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 801132 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 735705 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z48Physics2D_CUSTOM_INTERNAL_CALL_Internal_LinecastRK13Vector2fIcallS1_iffP12RaycastHit2D(i1, i2, i3, f4, f5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 i10 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 if ((__ZN16Physics2DManager8LinecastERK8Vector2fS2_iffPK10Collider2DbP12RaycastHit2Di(i10, i9, i8, i3, f4, f5, 0, 0, i6, 1) | 0) != 1) {
  STACKTOP = i7;
  return;
 }
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i6);
 STACKTOP = i7;
 return;
}

function __Z46UnityWebRequest_Set_Custom_PropDownloadHandlerP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if ((HEAP32[i1 + 108 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031754 | 0, i4 + 8 | 0);
 if (!i2) i3 = 0; else i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i1 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN15DownloadHandler7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __ZN15DownloadHandler6RetainEv(i3);
 STACKTOP = i4;
 return;
}

function __Z30CustomEventData_CUSTOM_AddByteP12Il2CppObjectP12Il2CppStringh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3 & 255) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _tt_get_advances(i3, i4, i5, i1, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 2 | 0;
 i8 = i9;
 i2 = (i5 | 0) != 0;
 if (!(i1 & 16)) {
  if (!i2) {
   STACKTOP = i9;
   return 0;
  }
  i1 = 0;
  do {
   _UNITY_TT_Get_HMetrics(i3, i1 + i4 | 0, i7, i8);
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU16[i8 >> 1];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  STACKTOP = i9;
  return 0;
 } else {
  if (!i2) {
   STACKTOP = i9;
   return 0;
  }
  i1 = 0;
  do {
   _UNITY_TT_Get_VMetrics(i3, i1 + i4 | 0, 0, i7, i8);
   HEAP32[i6 + (i1 << 2) >> 2] = HEAPU16[i8 >> 1];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
  STACKTOP = i9;
  return 0;
 }
 return 0;
}

function __ZThn8_N5physx2Gu12TriangleMesh14onRefCountZeroEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + -8 | 0;
 i1 = i4 + 216 | 0;
 if (!(__ZN5physx13GuMeshFactory18removeTriangleMeshERNS_14PxTriangleMeshE(HEAP32[i1 >> 2] | 0, i3) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 689458 | 0, 81, gb + 725367 | 0, i5);
  STACKTOP = i5;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP16[i4 + -2 >> 1] & 1)) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i3 | 0);
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i3, 3, 1);
 STACKTOP = i5;
 return;
}

function __ZNK13WheelCollider13GetSteerAngleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(Math_fround(Math_fround(Math_fround(__ZNK5physx16PxVehicleNoDrive13getSteerAngleEj(HEAP32[i2 + 56 >> 2] | 0, HEAP32[i3 >> 2] | 0)) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0));
 return Math_fround(f4);
}

function __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i7, i6) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i7 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i7);
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i3 + (i7 * 12 | 0) | 0;
 if ((i1 | 0) >= (i7 | 0)) {
  HEAP32[i4 >> 2] = i7;
  return;
 }
 i2 = i6 + 8 | 0;
 i1 = i3 + (i1 * 12 | 0) | 0;
 do {
  i9 = i6;
  i8 = HEAP32[i9 + 4 >> 2] | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
  HEAP32[i3 + 4 >> 2] = i8;
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 12 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 HEAP32[i4 >> 2] = i7;
 return;
}

function __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_19ParticlePacketShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i4 = i3;
 i5 = HEAP32[i1 + 44 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i5 | 0);
 i5 = HEAP32[(__ZNK5physx2Sc17ParticleSystemSim7getCoreEv(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i1) | 0) | 0) >> 2] | 0;
 HEAP32[i4 >> 2] = 1073741823;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 __ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE(i1, 1, i6, i5, i4) | 0;
 i2 = (HEAP32[(HEAP32[HEAP32[i2 + 1104 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 28 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu5Facet10silhouetteERKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(i5, i6, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP8[i5 + 38 >> 0] = 1;
 __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i5 + 20 >> 2] | 0, HEAP8[i5 + 32 >> 0] | 0, i6, i1, i2, i3, i4);
 __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i5 + 24 >> 2] | 0, HEAP8[i5 + 33 >> 0] | 0, i6, i1, i2, i3, i4);
 __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE(HEAP32[i5 + 28 >> 2] | 0, HEAP8[i5 + 34 >> 0] | 0, i6, i1, i2, i3, i4);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE(i5, i4, i3, i1, i2) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(__ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i5) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 700312 | 0, 428, gb + 700558 | 0, i6);
  STACKTOP = i6;
  return;
 }
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 __ZN5physx3Scb14ParticleSystem9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEENS_11PxForceMode4EnumE(i5 + 20 | 0, i4, i3, i1, i2);
 STACKTOP = i6;
 return;
}

function __ZN4FMOD6System17getCDROMDriveNameEiPciS1_iS1_i(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869326;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869326;
  _printf(gb + 853343 | 0, i5) | 0;
  i8 = 78;
  STACKTOP = i6;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869326;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i6;
 return i8 | 0;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStream5writeEPKhj(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = i6 + 8 | 0;
 i4 = i1;
 i3 = i2;
 i1 = 0;
 while (1) {
  i2 = __ZN5physx6shdfnd6Socket5writeEPKhj((HEAP32[i5 >> 2] | 0) + 4 | 0, i3, i4) | 0;
  i1 = i2 + i1 | 0;
  if ((i4 | 0) != (i2 | 0) & (i2 | 0) != 0) {
   i4 = i4 - i2 | 0;
   i3 = i3 + i2 | 0;
  } else break;
 }
 if (!i2) {
  i6 = 1;
  return i6 | 0;
 }
 i5 = i6 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i6 + 32 | 0;
 i3 = i6;
 i3 = _i64Add(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i1 | 0, 0) | 0;
 i4 = getTempRet0() | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 i6 = 0;
 return i6 | 0;
}

function __Z42ParticleSystemRenderer_Set_Custom_PropMeshP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 HEAP32[i2 + 552 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i1) | 0;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN22ParticleSystemRenderer16UpdateCachedMeshEv(i1);
  return;
 }
}

function _UNITY_FT_Outline_Transform(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!((i1 | 0) != 0 & (i7 | 0) != 0)) return;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP16[i1 + 2 >> 1] | 0;
 i6 = i5 + (i4 << 16 >> 16 << 3) | 0;
 if (i4 << 16 >> 16 <= 0) return;
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i4 = i7 + 12 | 0;
 i1 = i5;
 do {
  if (i1 | 0) {
   i9 = _UNITY_FT_MulFix(HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
   i5 = i1 + 4 | 0;
   i9 = (_UNITY_FT_MulFix(HEAP32[i5 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0) + i9 | 0;
   i8 = _UNITY_FT_MulFix(HEAP32[i1 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
   i8 = (_UNITY_FT_MulFix(HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0) | 0) + i8 | 0;
   HEAP32[i1 >> 2] = i9;
   HEAP32[i5 >> 2] = i8;
  }
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 return;
}

function __ZThn32_N22ParticleSystemRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + -32 | 0;
 i1 = HEAP16[i2 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = __ZN8Renderer12GetTransformEv(i2) | 0;
  HEAP32[i2 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i2 + 36 | 0);
  i1 = HEAP8[i2 + 273 >> 0] | 0;
 }
 if (i1 << 24 >> 24) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0);
 i1 = i2 + 164 | 0;
 i2 = i2 + 568 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 8 | 0;
 i6 = i3 + 3 | 0;
 i2 = HEAP8[i6 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) {
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = (HEAP32[i3 >> 2] & 2147483647) + -1 | 0;
 } else {
  i5 = i2 & 255;
  i2 = 1;
 }
 if ((i5 | 0) == (i2 | 0)) {
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i1, i2, 1, i2, i2, 0, 0);
  if ((HEAP8[i6 >> 0] | 0) > -1) i2 = 7; else i2 = 8;
 } else if (i4) i2 = 8; else i2 = 7;
 if ((i2 | 0) == 7) HEAP8[i6 >> 0] = i5 + 1; else if ((i2 | 0) == 8) {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i5 + 1;
  i1 = i6;
 }
 i6 = i1 + (i5 << 2) | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = 0;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl15getNbPropertiesEN5physx8debugger18NonNegativeIntegerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  i4 = 0;
  return i4 | 0;
 }
 if ((HEAP32[i2 + 128 >> 2] | 0) <= (i1 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i2 + 128 | 0;
 i3 = i2 + 124 | 0;
 i2 = i1;
 i1 = 0;
 while (1) {
  i1 = (HEAP32[i2 + 88 >> 2] | 0) + i1 | 0;
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  if ((i2 | 0) <= -1) {
   i2 = 8;
   break;
  }
  if ((HEAP32[i4 >> 2] | 0) <= (i2 | 0)) {
   i2 = 8;
   break;
  }
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (!i2) {
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat14TexFormatRHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc24ConstraintProjectionTree18projectPoseForTreeERNS0_19ConstraintGroupNodeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 36 >> 2] = i1;
 while (1) {
  if (!i1) {
   i1 = HEAP32[i2 + 28 >> 2] | 0;
   if (!i1) break;
  } else while (1) {
   i2 = HEAP32[i1 + 40 >> 2] | 0;
   if (i2 | 0) if (__ZN5physx2Sc13ConstraintSim14hasDynamicBodyEv(i2) | 0) if (__ZN5physx2Sc13ConstraintSim15needsProjectionEv(i2) | 0) __ZN5physx2Sc13ConstraintSim11projectPoseEPNS0_7BodySimE(i2, HEAP32[i1 >> 2] | 0);
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  i2 = i1;
  i1 = HEAP32[i1 + 36 >> 2] | 0;
 }
 STACKTOP = i3;
 return;
}

function __ZN20LocalFileSystemPosix4LockER13FileEntryData12FileLockMode(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i5 + 1052 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = (i1 | 0) == 0;
 if ((i6 | 0) == 8) {
  if (i3) {
   i6 = 0;
   return i6 | 0;
  }
  if (_flock(_fileno(i1) | 0, 8) | 0) {
   i6 = 0;
   return i6 | 0;
  }
  i6 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0, i5 | 0) | 0;
  return i6 | 0;
 }
 do if (i3) if (mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i5 | 0, 2, 1) | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  break;
 } else {
  i6 = 0;
  return i6 | 0;
 } while (0);
 if (!(_flock(_fileno(i1) | 0, i6 | 4 | 0) | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0, i5 | 0) | 0;
 i6 = 0;
 return i6 | 0;
}

function __ZN10GameObject25TransformParentHasChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 288 | 0;
 i2 = i5 + 8 | 0;
 i3 = i5;
 if ((HEAP8[i1 + 55 >> 0] | 0) == -1) {
  STACKTOP = i5;
  return;
 }
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i2, i4);
 __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i1, 0, i2);
 __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i2, 8, 0);
 __ZN18AwakeFromLoadQueueD2Ev(i2);
 STACKTOP = i5;
 return;
}

function __Z27CancelAndStopPreloadManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP8[(__Z20GetPersistentManagerv() | 0) + 192 >> 0] = 1;
 i2 = HEAP32[gb + 1163176 >> 2] | 0;
 if (!i2) return;
 HEAP8[i2 + 44 >> 0] = 1;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN14AsyncOperation16CleanupCoroutineEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 return;
}

function _UNITY_png_get_cHRM_fixed(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i10 = 0;
  return i10 | 0;
 }
 if (!(HEAP16[i2 + 114 >> 1] & 2)) {
  i10 = 0;
  return i10 | 0;
 }
 if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i2 + 68 >> 2];
 if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i2 + 72 >> 2];
 if (i5 | 0) HEAP32[i5 >> 2] = HEAP32[i2 + 44 >> 2];
 if (i6 | 0) HEAP32[i6 >> 2] = HEAP32[i2 + 48 >> 2];
 if (i7 | 0) HEAP32[i7 >> 2] = HEAP32[i2 + 52 >> 2];
 if (i8 | 0) HEAP32[i8 >> 2] = HEAP32[i2 + 56 >> 2];
 if (i9 | 0) HEAP32[i9 >> 2] = HEAP32[i2 + 60 >> 2];
 if (!i10) {
  i10 = 4;
  return i10 | 0;
 }
 HEAP32[i10 >> 2] = HEAP32[i2 + 64 >> 2];
 i10 = 4;
 return i10 | 0;
}

function _wcrtomb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 do if (!i1) i1 = 1; else {
  if (i2 >>> 0 < 128) {
   HEAP8[i1 >> 0] = i2;
   i1 = 1;
   break;
  }
  if (i2 >>> 0 < 2048) {
   HEAP8[i1 >> 0] = i2 >>> 6 | 192;
   HEAP8[i1 + 1 >> 0] = i2 & 63 | 128;
   i1 = 2;
   break;
  }
  if (i2 >>> 0 < 55296 | (i2 & -8192 | 0) == 57344) {
   HEAP8[i1 >> 0] = i2 >>> 12 | 224;
   HEAP8[i1 + 1 >> 0] = i2 >>> 6 & 63 | 128;
   HEAP8[i1 + 2 >> 0] = i2 & 63 | 128;
   i1 = 3;
   break;
  }
  if ((i2 + -65536 | 0) >>> 0 < 1048576) {
   HEAP8[i1 >> 0] = i2 >>> 18 | 240;
   HEAP8[i1 + 1 >> 0] = i2 >>> 12 & 63 | 128;
   HEAP8[i1 + 2 >> 0] = i2 >>> 6 & 63 | 128;
   HEAP8[i1 + 3 >> 0] = i2 & 63 | 128;
   i1 = 4;
   break;
  } else {
   HEAP32[(___errno_location() | 0) >> 2] = 84;
   i1 = -1;
   break;
  }
 } while (0);
 return i1 | 0;
}

function _fputc(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if ((HEAP32[i5 + 76 >> 2] | 0) < 0) i4 = 3; else if (!(___lockfile(i5) | 0)) i4 = 3; else {
  if ((HEAP8[i5 + 75 >> 0] | 0) == (i3 | 0)) i4 = 10; else {
   i1 = i5 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3;
    i1 = i3 & 255;
   } else i4 = 10;
  }
  if ((i4 | 0) == 10) i1 = ___overflow(i5, i3) | 0;
  ___unlockfile(i5);
 }
 do if ((i4 | 0) == 3) {
  if ((HEAP8[i5 + 75 >> 0] | 0) != (i3 | 0)) {
   i1 = i5 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3;
    i1 = i3 & 255;
    break;
   }
  }
  i1 = ___overflow(i5, i3) | 0;
 } while (0);
 return i1 | 0;
}

function __ZZN10MeshFilter15InitializeClassEvEN30FunctorImpl_84kDidAddComponent4CallEPviR11MessageData(i6, i1, i2) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
 if (i2 | 0) {
  i3 = i2 + 376 | 0;
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) {
   HEAP32[i3 >> 2] = i1;
   __ZN12MeshRenderer16UpdateCachedMeshEv(i2);
  }
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i6, gb + 1106136 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = i5 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i5 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 do if (i3 >>> 0 < i7 >>> 0) {
  if (i2) i1 = HEAP32[i5 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i5, i3, i7 - i3 | 0, i1, 0, i1, i7, i6);
 } else {
  if (i2) i1 = HEAP32[i5 >> 2] | 0; else i1 = i5;
  if (i7 | 0) _memmove(i1 | 0, i6 | 0, i7 | 0) | 0;
  HEAP8[i1 + i7 >> 0] = 0;
  if ((HEAP8[i4 >> 0] | 0) < 0) {
   HEAP32[i5 + 4 >> 2] = i7;
   break;
  } else {
   HEAP8[i4 >> 0] = i7;
   break;
  }
 } while (0);
 return i5 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat14TexFormatRHalfEEvPKNS_9InnerInfoE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  f3 = Math_fround(HEAPF32[i5 >> 2]);
  do if (f3 == Math_fround(0.0)) i2 = 0; else {
   i4 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
   i2 = HEAP16[(HEAP32[gb + 73460 >> 2] | 0) + (i4 >>> 23 << 1) >> 1] | 0;
   if (!(i2 << 16 >> 16)) {
    i2 = __ZN11prophecysdk4half7convertEi(i4) | 0;
    break;
   } else {
    i2 = (i2 & 65535) + (((i4 & 8388607) + 4096 | 0) >>> 13) & 65535;
    break;
   }
  } while (0);
  HEAP16[i6 >> 1] = i2;
  if (!i1) break; else {
   i6 = i6 + 2 | 0;
   i5 = i5 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx9NpFactory18releaseShapeToPoolERNS_7NpShapeE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 1540 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 1524 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 1536 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 1528 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 1520 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 1244 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx9NpFactory18releaseClothToPoolERNS_7NpClothE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 4252 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 i4 = i3 + 4236 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i4 = i3 + 4248 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i1;
 i1 = i3 + 4240 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 1;
 if ((i4 | 0) < ((HEAP32[i3 + 4232 >> 2] | 0) * 50 | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv(i3 + 3956 | 0);
 HEAP32[i1 >> 2] = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 72 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i1, i8);
 i4 = HEAP32[i1 + 64 >> 2] | 0;
 i5 = i1 + 68 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + (i8 * 12 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i1 = i4 + (i1 * 12 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 12 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx20PxsParticleSystemSim26schedulePacketShapesUpdateERKNS_28PxvParticleShapesUpdateInputERNS_10PxBaseTaskE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = i3 + 1156 | 0;
 HEAP32[i3 + 1172 >> 2] = 1;
 i5 = i3 + 1168 | 0;
 HEAP32[i5 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 HEAP32[i3 + 1164 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2];
 HEAP32[i3 + 1144 >> 2] = 1;
 i1 = i3 + 1140 | 0;
 HEAP32[i1 >> 2] = i4;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 HEAP32[i3 + 1136 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0);
 i4 = i2;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i3 + 1296 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return i3 + 1128 | 0;
}

function __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESb16TextureDimension9TextureIDjjjRK17RenderSurfaceDesc(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10 + 4 | 0;
 i12 = i10;
 i7 = __ZNK13TranslateGLES13GetFormatGLESEj(HEAP32[i1 + 860 >> 2] | 0, i7) | 0;
 HEAP32[i12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i12 >> 2];
 i9 = __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES17RenderSurfaceType16TextureDimension9TextureIDjN2gl9TexFormatEjRK17RenderSurfaceDesc(i1, i2, i3 & 1, i4, i11, i6, i7, i8, i9) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN19TouchPhaseEmulation15IsExistingTouchEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i4 + (i2 * 96 | 0) + 80 >> 2] | 0) == (i5 | 0)) {
   HEAP32[i6 + (i1 << 2) >> 2] = i4 + (i2 * 96 | 0);
   i3 = i1 + 1 | 0;
  } else i3 = i1;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 32) break; else i1 = i3;
 }
 if (!i3) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 } else i1 = 0;
 while (1) {
  if (HEAP32[i6 + (i1 << 2) >> 2] | 0) {
   i1 = 1;
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) {
  STACKTOP = i7;
  return i1 | 0;
 }
 return 0;
}

function __ZN17ArchiveFileSystem5WriteER13FileEntryDatayPvPy(i1, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1178956 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178956 | 0, i1);
  i2 = gb + 1178956 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN17AnimationPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 HEAP8[i4 + 56 >> 0] = 0;
 i7 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i7 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i8 = 8;
    break;
   } else i3 = 0;
  }
  if ((i8 | 0) == 8) {
   i8 = 0;
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i5 | 0, i6 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i7 | 0));
 return;
}

function __ZN12CullingGroup13EraseSwapBackEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 >>> 0 > i2 >>> 0) {
  i5 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i5;
  i4 = HEAP32[i1 + 28 >> 2] | 0;
  HEAP8[i4 + i2 >> 0] = HEAP8[i4 + i5 >> 0] | 0;
  i4 = HEAP32[i1 + 48 >> 2] | 0;
  HEAP8[i4 + i2 >> 0] = HEAP8[i4 + (HEAP32[i3 >> 2] | 0) >> 0] | 0;
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  i4 = i1 + (i2 << 4) | 0;
  i3 = i1 + (HEAP32[i3 >> 2] << 4) | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 385168 | 0, 0, gb + 385204 | 0, 113, 1, 0, 0, 0);
  return;
 }
}

function __ZN10SizeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z58Animator_CUSTOM_INTERNAL_CALL_SetBoneLocalRotationInternalP12Il2CppObject14HumanBodyBonesRK11Quaternionf(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  __ZN8Animator20SetBoneLocalRotationEi11Quaternionf(i5, i3, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z38TerrainData_CUSTOM_Internal_SetHeightsP12Il2CppObjectiiiiP11Il2CppArray(i7, i1, i2, i3, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i8 = 0;
 if (!i7) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i6) {
  i8 = i7;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 }
 __ZN9Heightmap10SetHeightsEiiiiPKfb(i6 + 248 | 0, i1, i2, i3, i4, __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 4) | 0, 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i7) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7); else {
  __ZN12TreeDatabase24RecalculateTreePositionsEv(i1 + 84 | 0);
  return;
 }
}

function _UNITY_FT_Get_Postscript_Name(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = i5 + 128 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 switch (i1 | 0) {
 case 0:
  {
   i2 = 3;
   break;
  }
 case -2:
  {
   i5 = 0;
   return i5 | 0;
  }
 default:
  {}
 }
 do if ((i2 | 0) == 3) {
  i2 = HEAP32[i5 + 96 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
  if (!i1) {
   HEAP32[i3 >> 2] = -2;
   i5 = 0;
   return i5 | 0;
  } else {
   i1 = mftCall_iii(i1 | 0, i2 | 0, gb + 1008130 | 0) | 0;
   HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] = i1 | 0 ? i1 : -2;
   if (!i1) i1 = 0; else break;
   return i1 | 0;
  }
 } while (0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = mftCall_ii(i1 | 0, i5 | 0) | 0;
 return i5 | 0;
}

function _putc(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if ((HEAP32[i5 + 76 >> 2] | 0) < 0) i4 = 3; else if (!(___lockfile(i5) | 0)) i4 = 3; else {
  if ((HEAP8[i5 + 75 >> 0] | 0) == (i3 | 0)) i4 = 10; else {
   i1 = i5 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3;
    i1 = i3 & 255;
   } else i4 = 10;
  }
  if ((i4 | 0) == 10) i1 = ___overflow(i5, i3) | 0;
  ___unlockfile(i5);
 }
 do if ((i4 | 0) == 3) {
  if ((HEAP8[i5 + 75 >> 0] | 0) != (i3 | 0)) {
   i1 = i5 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i5 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = i3;
    i1 = i3 & 255;
    break;
   }
  }
  i1 = ___overflow(i5, i3) | 0;
 } while (0);
 return i1 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 128 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 132 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 136 >> 2])) return;
  }
 } else i1 = i6 + 132 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 136 >> 2] = i2;
 HEAP32[i6 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (i2 | 0) < (i1 | 0);
 do if ((i1 | 0) < (i4 | 0)) {
  if (i3) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i1 = 1;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) < (i4 | 0)) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) < (i1 | 0)) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 >>> 0 < i1 >>> 0;
 do if (i1 >>> 0 < i4 >>> 0) {
  if (i3) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i1 = 1;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 < i4 >>> 0) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (i2 | 0) < (i1 | 0);
 do if ((i1 | 0) < (i4 | 0)) {
  if (i3) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i1 = 1;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) < (i4 | 0)) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) < (i1 | 0)) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 >>> 0 < i1 >>> 0;
 do if (i1 >>> 0 < i4 >>> 0) {
  if (i3) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i1 = 1;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[i5 >> 2] | 0;
  if (i1 >>> 0 < i4 >>> 0) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (i2 | 0) < (i1 | 0);
 do if ((i1 | 0) < (i4 | 0)) {
  if (i3) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i5 >> 2] = i4;
   i1 = 1;
   break;
  }
  HEAP32[i6 >> 2] = i1;
  HEAP32[i7 >> 2] = i4;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) < (i4 | 0)) {
   HEAP32[i7 >> 2] = i1;
   HEAP32[i5 >> 2] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP32[i7 >> 2] = i2;
  HEAP32[i5 >> 2] = i1;
  i2 = HEAP32[i7 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
  if ((i2 | 0) < (i1 | 0)) {
   HEAP32[i6 >> 2] = i2;
   HEAP32[i7 >> 2] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i4 = HEAP8[i6 >> 0] | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = (i2 & 255) < (i1 & 255);
 do if ((i1 & 255) < (i4 & 255)) {
  if (i3) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i5 >> 0] = i4;
   i1 = 1;
   break;
  }
  HEAP8[i6 >> 0] = i1;
  HEAP8[i7 >> 0] = i4;
  i1 = HEAP8[i5 >> 0] | 0;
  if ((i1 & 255) < (i4 & 255)) {
   HEAP8[i7 >> 0] = i1;
   HEAP8[i5 >> 0] = i4;
   i1 = 2;
  } else i1 = 1;
 } else if (i3) {
  HEAP8[i7 >> 0] = i2;
  HEAP8[i5 >> 0] = i1;
  i2 = HEAP8[i7 >> 0] | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if ((i2 & 255) < (i1 & 255)) {
   HEAP8[i6 >> 0] = i2;
   HEAP8[i7 >> 0] = i1;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZN7Cubemap11InitTextureEii13TextureFormatN9Texture2D10EInitFlagsEiii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if (!(i2 + -1 & i2)) if (!(i3 + -1 & i3)) {
  if ((i2 | 0) == (i3 | 0)) {
   i8 = __ZN9Texture2D11InitTextureEii13TextureFormatNS_10EInitFlagsEiii(i1, i2, i2, i4, i5, 6, i7, i8) | 0;
   return i8 | 0;
  }
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397349 | 0, 0, gb + 397213 | 0, 34, 1, i1, 0, 0);
  i8 = 0;
  return i8 | 0;
 }
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 397315 | 0, 0, gb + 397213 | 0, 29, 1, i1, 0, 0);
 i8 = 0;
 return i8 | 0;
}

function __ZN5physx7NpCloth12setParticlesEPKNS_15PxClothParticleES3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore12setParticlesEPKNS_15PxClothParticleES4_(i3 + 32 | 0, i1, i2);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 233, gb + 698430 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx2Gu12TriangleMesh12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 107352 + 8;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = gb + 93676 + 8;
 HEAP32[i4 + 12 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 107420 + 8;
 HEAP32[i6 >> 2] = gb + 107420 + 88;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Gu5RTreeC2ERKNS_7PxEMPTYE(i4 + 48 | 0, i5);
 __ZN5physx2Gu13MeshInterfaceC2Ev(i4 + 196 | 0);
 HEAP32[i4 + 216 >> 2] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 240;
 __ZN5physx20InternalTriangleMesh15importExtraDataERNS_24PxDeserializationContextE(i4 + 16 | 0, i2);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx18PxcGetMaterialMeshEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i2, i6, i4, i7) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i4 + 4480 >> 2] | 0;
 i1 = (i5 | 0) == 0;
 if ((HEAPU16[i2 + 88 >> 1] | 0) < 2) {
  if (i1) return 1;
  i1 = i2 + 34 | 0;
  i2 = 0;
  do {
   HEAP16[i7 + (i2 << 2) + (i6 << 1) >> 1] = HEAP16[i1 >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i5 >>> 0);
  return 1;
 } else {
  if (i1) return 1;
  i3 = HEAP32[i2 + 80 >> 2] | 0;
  i1 = HEAP32[i2 + 84 >> 2] | 0;
  i2 = 0;
  do {
   HEAP16[i7 + (i2 << 2) + (i6 << 1) >> 1] = HEAP16[i1 + ((HEAPU16[i3 + (HEAP32[i4 + 384 + (i2 << 6) + 48 + (i6 << 2) >> 2] << 1) >> 1] | 0) << 1) >> 1] | 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i5 >>> 0);
  return 1;
 }
 return 0;
}

function __ZN17ArchiveFileSystem4ReadER13FileEntryDatayPvPy(i1, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1178968 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178968 | 0, i1);
  i2 = gb + 1178968 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN16MemoryFileSystem5WriteER13FileEntryDatayPvPy(i1, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1179044 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179044 | 0, i1);
  i2 = gb + 1179044 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN13GfxDeviceGLES27SetRandomWriteTargetTextureEi9TextureID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 if (i2 >>> 0 < 8) {
  i4 = i1 + 7196 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = (i6 | 0) < (i2 | 0) ? i2 : i6;
  HEAP32[i1 + 7200 + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 7232 + (i2 << 2) >> 2] = 0;
  STACKTOP = i5;
  return;
 } else {
  __Z6FormatPKcz(i4, gb + 603741 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 603515 | 0, 2019, 512, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN13ComputeBuffer7SetDataEPKvj(i1, i5, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!((i5 | 0) != 0 & (i3 | 0) != 0)) {
  STACKTOP = i8;
  return;
 }
 i7 = i1 + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = Math_imul(i2, HEAP32[i1 >> 2] | 0) | 0;
 if (!i2) i1 = 0; else {
  i1 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
  i1 = i1 - ((i1 >>> 0) % (i2 >>> 0) | 0) | 0;
 }
 i3 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 752 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 mftCall_viiii(i2 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 STACKTOP = i8;
 return;
}

function __ZN10Matrix4x4f9TransposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 32 | 0;
 i4 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 48 | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 i2 = i1 + 36 | 0;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 52 | 0;
 i4 = i1 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 56 | 0;
 i2 = i1 + 44 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __Z43CommandBuffer_CUSTOM_SetRenderTarget_SingleP12Il2CppObjectR26MonoRenderTargetIdentifieriii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 4 | 0;
 i10 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i10;
 HEAP32[i6 + 8 >> 2] = i9;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i7); else {
  __ZN22RenderingCommandBuffer18AddSetRenderTargetERK18RenderTextureParami11CubemapFacei(i1, i6, i3, i4, i5);
  STACKTOP = i8;
  return;
 }
}

function __Z32CustomEventData_CUSTOM_AddUInt32P12Il2CppObjectP12Il2CppStringj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcj(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _unzGetGlobalComment(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i7 = -102;
  return i7 | 0;
 }
 i3 = i1 + 40 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i5 = i5 >>> 0 < i7 >>> 0 ? i5 : i7;
 i4 = i1 + 28 | 0;
 i2 = i1 + 32 | 0;
 if (mftCall_iiiii(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, (HEAP32[i1 + 60 >> 2] | 0) + 22 | 0, 0) | 0) {
  i7 = -1;
  return i7 | 0;
 }
 if (!i5) {
  if (!i6) {
   i7 = 0;
   return i7 | 0;
  }
 } else {
  HEAP8[i6 >> 0] = 0;
  if ((mftCall_iiiii(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0, i6 | 0, i5 | 0) | 0) != (i5 | 0)) {
   i7 = -1;
   return i7 | 0;
  }
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 >= i7 >>> 0) {
  i7 = i5;
  return i7 | 0;
 }
 HEAP8[i6 + i1 >> 0] = 0;
 i7 = i5;
 return i7 | 0;
}

function _tt_name_entry_ascii_from_utf16(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = (HEAPU16[i1 + 8 >> 1] | 0) >>> 1;
 i5 = i1 & 65535;
 i6 = _UNITY_ft_mem_realloc(i2, 1, 0, i5 + 1 | 0, 0, i3) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 L4 : do if (!(i1 << 16 >> 16)) i1 = 0; else {
  i1 = 0;
  while (1) {
   i2 = HEAP8[i4 + 1 >> 0] | 0;
   i3 = (HEAPU8[i4 >> 0] | 0) << 8 | i2 & 255;
   if (!i3) break L4;
   HEAP8[i6 + i1 >> 0] = (i3 + -32 | 0) >>> 0 > 95 ? 63 : i2;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i5 >>> 0) i4 = i4 + 2 | 0; else break;
  }
 } while (0);
 HEAP8[i6 + i1 >> 0] = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 116 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 120 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 124 >> 2])) return;
  }
 } else i1 = i6 + 120 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 124 >> 2] = i2;
 HEAP32[i6 + 536 >> 2] = 0;
 return;
}

function __ZNK5physx2Sc8ShapeSim13getFilterInfoERjRNS_12PxFilterDataE(i2, i5, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i2 + 28 | 0;
 i1 = (HEAP8[(HEAP32[i4 >> 2] | 0) + 64 >> 0] & 4) << 3;
 HEAP32[i5 >> 2] = i1;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP8[i2 + 50 >> 0] | 0;
 do if (!((i2 | 0) == 0 | i3 << 24 >> 24 != 4 & i3 << 24 >> 24 != 1)) {
  if (i3 << 24 >> 24 == 4) {
   HEAP32[i5 >> 2] = i1 | 4;
   break;
  }
  if (HEAP8[(HEAP32[i2 + 52 >> 2] | 0) + 44 >> 0] & 1) {
   i1 = i1 | 16;
   HEAP32[i5 >> 2] = i1;
  }
  HEAP32[i5 >> 2] = i1 | 1;
 } while (0);
 i5 = (HEAP32[i4 >> 2] | 0) + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 return;
}

function __ZN8GUIState8SetEventERK10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 248 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 i6 = HEAP32[i2 + 40 >> 2] | 0;
 i10 = __Z24GetIMGUIScriptingClassesv() | 0;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i5, i4);
 __ZN18ScriptingArguments6AddIntEi(i5, i6);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i4, 0) | 0;
 __ZN10InputEventaSERKS_(HEAP32[i1 + 280 >> 2] | 0, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx8debugger17MemPvdInputStream4readEPhRj(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  i7 = 1;
  return i7 | 0;
 }
 i7 = i1 + 12 | 0;
 if (!(HEAP8[i7 >> 0] | 0)) {
  i2 = i1 + 4 | 0;
  i3 = i2;
  i1 = 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 + 4 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = (HEAP32[i1 + 8 >> 2] | 0) - i2 | 0;
 }
 i1 = i6 >>> 0 < i1 >>> 0 ? i6 : i1;
 HEAP32[i5 >> 2] = i1;
 _memcpy(i4 | 0, i2 | 0, i1 | 0) | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 if (i6 >>> 0 > i1 >>> 0) {
  _memset(i4 + i1 | 0, 0, i6 - i1 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i6 = (HEAP8[i7 >> 0] | 0) == 0 ? 0 : (i1 | 0) == (i6 | 0) & 1;
 HEAP8[i7 >> 0] = i6;
 i7 = i6 << 24 >> 24 != 0;
 return i7 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 144 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 148 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 152 >> 2])) return;
  }
 } else i1 = i6 + 148 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 152 >> 2] = i2;
 HEAP32[i6 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Actor9setActiveEbj(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = (i5 & 1 | 0) != 0;
 i2 = i6 + 51 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (!i3) if (!((i1 & 1) != 0 ^ i4)) return;
 i1 = i1 & 255;
 if (i4) {
  HEAP8[i2 >> 0] = i1 | 1;
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0);
  __ZN5physx2Sc5Actor20activateInteractionsEj(i6, i5);
  if (i3) return;
  __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE(HEAP32[i6 + 36 >> 2] | 0, i6);
  return;
 } else {
  HEAP8[i2 >> 0] = i1 & 254;
  __ZN5physx2Sc5Actor22deactivateInteractionsEj(i6, i5);
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0);
  if (i3) return;
  __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE(HEAP32[i6 + 36 >> 2] | 0, i6);
  return;
 }
}

function __ZN16MemoryFileSystem4ReadER13FileEntryDatayPvPy(i1, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8 + 4 | 0;
 i2 = i8;
 if ((HEAP16[gb + 1179056 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1179056 | 0, i1);
  i2 = gb + 1179056 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 if (!i2) {
  STACKTOP = i8;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i8;
 return i1 | 0;
}

function __ZN14UnityWebStream7ReleaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + -1;
 if ((i2 | 0) >= 2) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (i1 | 0) __ZN3WWW7ReleaseEv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 24 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
 return;
}

function __ZN14PreloadManager4StopEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN14AsyncOperation16CleanupCoroutineEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i4 = i2 + 40 | 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i4 = i2 + 40 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN14PlayerSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 + -1 | 0) >>> 0 < 2) if (__Z11IsGfxDevicev() | 0) __ZN14PlayerSettings18InitDefaultCursorsEv(i1);
 i2 = i1 + 340 | 0;
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(0, HEAP32[HEAP32[i2 >> 2] >> 2] | 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(1, HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(2, HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(3, HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(4, HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0);
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(5, HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0);
 return;
}

function __ZN14PhysicsManager18ReleasePxMaterialsER13dynamic_arrayIP14PhysicMaterialLj4EE(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = i5 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i5 + 4 | 0);
  HEAP32[i5 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb(gb + 113108 | 0, i5, 0);
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return; else i4 = 0;
 do {
  i2 = (HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 52 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   HEAP32[i2 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 return;
}

function __ZN13GfxDeviceGLES17CaptureScreenshotEiiiiPh(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 8 | 0;
 i10 = i7;
 __ZN18GfxFramebufferGLES7PrepareEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0);
 i9 = i1 + 4620 | 0;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i10, i9, 0);
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE(i9, 1, i8);
 mftCall_viiiiiii(HEAP32[i1 + 4736 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, 6408, 5121, i6 | 0);
 STACKTOP = i7;
 return 1;
}

function __ZN13ComputeBuffer7GetDataEPvj(i1, i5, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8 + 4 | 0;
 i6 = i8;
 if (!((i5 | 0) != 0 & (i3 | 0) != 0)) {
  STACKTOP = i8;
  return;
 }
 i7 = i1 + 12 | 0;
 if (!(HEAP32[i7 >> 2] | 0)) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = Math_imul(i2, HEAP32[i1 >> 2] | 0) | 0;
 if (!i2) i1 = 0; else {
  i1 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
  i1 = i1 - ((i1 >>> 0) % (i2 >>> 0) | 0) | 0;
 }
 i3 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + 756 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 mftCall_viiii(i2 | 0, i3 | 0, i4 | 0, i5 | 0, i1 | 0);
 STACKTOP = i8;
 return;
}

function __ZN11UnityEngine7Connect17DeviceInfoUpdater5ResetEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i3 >> 2] >> 0] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 } else {
  HEAP8[i3 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 i1 = i3 + 16 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 i1 = i3 + 32 | 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i3 + 36 >> 2] = 0;
  i2 = i3 + 48 | 0;
  HEAP8[i2 >> 0] = 0;
  i3 = i3 + 49 | 0;
  HEAP8[i3 >> 0] = 0;
  return;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
  i2 = i3 + 48 | 0;
  HEAP8[i2 >> 0] = 0;
  i3 = i3 + 49 | 0;
  HEAP8[i3 >> 0] = 0;
  return;
 }
}

function __ZN11TerrainData15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 13120 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 12352 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 12352 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 12352 + (i1 * 12 | 0) >> 2] = fb + 318;
 STACKTOP = i5;
 return;
}

function __ZN10GameObject30SetActiveRecursivelyDeprecatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 288 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 __ZN10GameObject21MarkActiveRecursivelyEb(i1, i2);
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i4, i5);
 __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i1, 0, i4);
 __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i4, 8, 0);
 __ZN18AwakeFromLoadQueueD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z51Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK8Vector3fS1_fP11Il2CppArrayi23QueryTriggerInteraction(i1, i2, f3, i6, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i7 = 0, i8 = 0;
 i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0;
 i8 = __Z17GetPhysicsManagerv() | 0;
 i2 = __ZN14PhysicsManager22OverlapCapsuleNonAllocERK8Vector3fS2_fPP8Colliderii23QueryTriggerInteraction(i8, i1, i2, f3, i7, __Z21GetScriptingArraySizeP11Il2CppArray(i6) | 0, i4, i5) | 0;
 if (!i2) return i2 | 0; else i1 = 0;
 do {
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i6, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i7 + (i1 << 2) >> 2] | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return i2 | 0;
}

function __Z46ParticleSystem_CollisionModule_CUSTOM_SetPlaneP12Il2CppObjectiS0_(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = HEAP32[i3 + 904 >> 2] | 0;
 HEAP32[i5 + 972 + (((i1 | 0) < 0 ? 0 : (i1 | 0) > 5 ? 5 : i1) << 2) >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4); else {
  HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
  return;
 }
}

function __Z31CustomEventData_CUSTOM_AddInt32P12Il2CppObjectP12Il2CppStringi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, i3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function __Z23AudioSource_CUSTOM_PlayP12Il2CppObjecty(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 if (!((i3 | 0) == 0 & (i4 | 0) == 0)) {
  if (!i2) i1 = 0; else {
   i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884219 | 0, 0, gb + 875076 | 0, 916, 512, i1, 0, 0);
 }
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZN11AudioSource4PlayEd(i1, (+(i3 >>> 0) + 4294967296.0 * +(i4 >>> 0)) * -2.2675736961451248e-05);
  return;
 }
}

function _unity_z_compress(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i5 + 16 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = 0;
 HEAP32[i5 + 40 >> 2] = 0;
 i1 = _unity_z_deflateInit_(i5, -1, gb + 362978 | 0, 56) | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = _unity_z_deflate(i5, 4) | 0;
 if ((i1 | 0) == 1) {
  HEAP32[i4 >> 2] = HEAP32[i5 + 20 >> 2];
  i5 = _unity_z_deflateEnd(i5) | 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  _unity_z_deflateEnd(i5) | 0;
  i5 = (i1 | 0) == 0 ? -5 : i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i5 + 24 >> 2] | 0;
 if (i1 >>> 0 < i3 >>> 0) {
  HEAP32[i2 >> 2] = i3;
  i1 = i3;
 }
 i4 = i5 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i5 + 8 >> 2] | 0) >>> 0 >= i2 >>> 0) {
  i6 = -1;
  return i6 | 0;
 }
 if ((i6 | 0) == -1) {
  HEAP32[i4 >> 2] = i2 + -1;
  HEAP32[i5 + 16 >> 2] = i1;
  i6 = 0;
  return i6 | 0;
 }
 if (!(HEAP32[i5 + 48 >> 2] & 16)) {
  i3 = i6 & 255;
  i2 = i2 + -1 | 0;
  if (i3 << 24 >> 24 != (HEAP8[i2 >> 0] | 0)) {
   i6 = -1;
   return i6 | 0;
  }
 } else {
  i3 = i6 & 255;
  i2 = i2 + -1 | 0;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i5 + 16 >> 2] = i1;
 HEAP8[i2 >> 0] = i3;
 return i6 | 0;
}

function __ZNK9AudioClip16GetMoviePlaybackEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = i2 + 124 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = gb + 872329;
  __Z6FormatPKcz(i3, gb + 854751 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 854464 | 0, 653, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i5 = HEAP32[i1 + 44 >> 2] | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK5physx7NpCloth23getSelfCollisionIndicesEPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  i4 = __ZNK5physx2Sc9ClothCore23getSelfCollisionIndicesEPj(i2 + 32 | 0, i1) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 805, gb + 692702 | 0, i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25getMassSpaceInertiaTensorEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 2)) i1 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i1 + 64 | 0) | 0; else i1 = (HEAP32[i1 + 56 >> 2] | 0) + 96 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f5 == Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f5);
 f5 = i1 ? Math_fround(0.0) : f5;
 i1 = f4 == Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i1 ? Math_fround(0.0) : f4;
 i1 = f3 == Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f3);
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f3;
 return;
}

function __ZN9AudioClip7WWWOpenEPKciPjPPvS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!i1) {
  i5 = 37;
  return i5 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i5 = 54;
  return i5 | 0;
 } else {
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  i3 = __Znwj(16) | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = i2;
  HEAP32[i3 + 4 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i5 = 0;
  return i5 | 0;
 }
 return 0;
}

function __ZN5physx7NpCloth18addCollisionSphereERKNS_22PxClothCollisionSphereE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore18addCollisionSphereERKNS_22PxClothCollisionSphereE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 345, gb + 695419 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sq12BucketPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj(i8, i6, i4, i5, i7) {
 i8 = i8 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i9 = 0;
 i2 = i8 + 7616 | 0;
 L1 : do if (!i7) i1 = 0; else {
  i3 = i8 + 7600 | 0;
  i1 = 0;
  do {
   i9 = __ZN5physx2Sq11PruningPool9addObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE(i2, i4 + (i1 * 24 | 0) | 0, i5 + (i1 << 3) | 0) | 0;
   HEAP32[i6 + (i1 << 2) >> 2] = i9;
   if ((i9 | 0) == -1) break L1;
   HEAP8[i3 >> 0] = 1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i7 >>> 0);
 } while (0);
 i6 = HEAP32[i8 + 7628 >> 2] | 0;
 i9 = HEAP32[i8 + 7632 >> 2] | 0;
 HEAP32[i8 + 16 >> 2] = HEAP32[i8 + 7620 >> 2];
 HEAP32[i8 + 24 >> 2] = i6;
 HEAP32[i8 + 28 >> 2] = i9;
 HEAP32[i8 + 32 >> 2] = 0;
 return (i1 | 0) == (i7 | 0) | 0;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 85484 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5Unity9Component10SetEnabledEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i1, HEAP32[(HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) i1 = gb + 1576256 | 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 __Z6FormatPKcz(i3, gb + 369305 | 0, i4);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 368833 | 0, 1194, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN4FMOD6System13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj(i7, i1, i2, i3, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869556;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869556;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869556;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN21DownloadHandlerScript21InvokeCompleteContentEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 248 | 0;
 i3 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 44 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i3, i2, i5);
 HEAP32[i5 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i5, 0) | 0;
 i5 = (HEAP32[i5 >> 2] | 0) == 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN19UnityConnectService27OnPlayerSessionStateChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = __ZN15GlobalCallbacks3GetEv() | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = i1 + 16 | 0;
 i9 = HEAP32[i7 >> 2] | 0;
 i7 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i6 + 18524 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return; else i1 = 0;
 do {
  i5 = i6 + 17756 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i6 + 17756 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_viiiii(HEAP32[i5 >> 2] | 0, i8 | 0, i9 | 0, i7 | 0, i2 | 0, i3 | 0); else mftCall_viiiiii(HEAP32[i5 >> 2] | 0, HEAP32[i6 + 17756 + (i1 * 12 | 0) + 4 >> 2] | 0, i8 | 0, i9 | 0, i7 | 0, i2 | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10ReallocateEPvji(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv(i2, i4) | 0) {
  i6 = __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10ReallocateEPvji(i2, i4, i5, i6) | 0;
  return i6 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i1 = HEAP32[i3 + 40 >> 2] | 0;
 i1 = __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv(i1, i4) | 0;
 i6 = __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji(i2, i5, i6) | 0;
 _memcpy(i6 | 0, i4 | 0, (i1 >>> 0 < i5 >>> 0 ? i1 : i5) | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i4 | 0);
 return i6 | 0;
}

function __ZN12WheelJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 158312 + 8;
 HEAPF32[i1 + 96 >> 2] = Math_fround(.699999988);
 HEAPF32[i1 + 100 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(90.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(1.0e4);
 STACKTOP = i4;
 return;
}

function __ZN12ScriptMapperC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 68492 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i1 + 36;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1 + 48;
 HEAP32[i1 + 56 >> 2] = i1;
 HEAP8[i1 + 28 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = i1 + 228 + (i2 << 1) | 0;
 if ((i3 | 0) == -1) {
  HEAP16[i1 >> 1] = -1;
  STACKTOP = i6;
  return;
 }
 if (i3 >>> 0 > 65535) {
  HEAP16[i1 >> 1] = -1;
  HEAP32[i5 >> 2] = 65535;
  __Z6FormatPKcz(i4, gb + 936733 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 936769 | 0, 104, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP16[i1 >> 1] = i3;
  STACKTOP = i6;
  return;
 }
}

function __ZN11OffMeshLink20UpdateMovedPositionsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 97 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  if (!(HEAP8[i2 + 96 >> 0] | 0)) return;
  if (!(__ZNK11OffMeshLink17HasEndpointsMovedEv(i2) | 0)) return;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 i1 = i2 + 40 | 0;
 i4 = i1;
 if (!((HEAP32[i4 >> 2] | 0) == 0 & (HEAP32[i4 + 4 >> 2] | 0) == 0)) {
  i5 = __Z17GetNavMeshManagerv() | 0;
  i4 = i1;
  __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i5, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
  i4 = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
 }
 __ZN11OffMeshLink13AddConnectionEv(i2);
 HEAP8[i3 >> 0] = 0;
 return;
}

function __ZN10HttpHelper17IsHeaderNameValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = i3 ? HEAP32[i1 + 4 >> 2] | 0 : i4 & 255;
 i3 = i3 ? HEAP32[i1 >> 2] | 0 : i1;
 if (!i4) {
  i4 = 1;
  return i4 | 0;
 } else i1 = 0;
 L3 : while (1) {
  i2 = HEAP8[i3 + i1 >> 0] | 0;
  if (i2 << 24 >> 24 < 32 | i2 << 24 >> 24 == 127) {
   i1 = 0;
   i2 = 6;
   break;
  }
  switch (i2 << 24 >> 24) {
  case 9:
  case 32:
   {
    i1 = 0;
    i2 = 6;
    break L3;
   }
  default:
   {}
  }
  i1 = i1 + 1 | 0;
  if (_memchr(gb + 1026921 | 0, i2 << 24 >> 24, 18) | 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 1;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __Z44UnityWebRequest_Set_Custom_PropUploadHandlerP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if ((HEAP32[i1 + 108 >> 2] | 0) != 1) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031682 | 0, i4 + 8 | 0);
 if (!i2) i3 = 0; else i3 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = i1 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN13UploadHandler7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __ZN13UploadHandler6RetainEv(i3);
 STACKTOP = i4;
 return;
}

function _sinhf(f1) {
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, i4 = 0;
 i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 f3 = (i4 | 0) < 0 ? Math_fround(-.5) : Math_fround(.5);
 i4 = i4 & 2147483647;
 f2 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (i4 >>> 0 < 1118925335) {
  f2 = Math_fround(_expm1f(f2));
  if (i4 >>> 0 >= 1065353216) {
   f1 = Math_fround(f3 * Math_fround(f2 + Math_fround(f2 / Math_fround(f2 + Math_fround(1.0)))));
   break;
  }
  if (i4 >>> 0 >= 964689920) f1 = Math_fround(f3 * Math_fround(Math_fround(f2 * Math_fround(2.0)) - Math_fround(Math_fround(f2 * f2) / Math_fround(f2 + Math_fround(1.0)))));
 } else {
  f1 = Math_fround(f3 * Math_fround(2.0));
  f1 = Math_fround(f1 * Math_fround(___expo2f(f2)));
 } while (0);
 return Math_fround(f1);
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 176 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 180 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 184 >> 2])) return;
  }
 } else i1 = i6 + 180 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 184 >> 2] = i2;
 HEAP32[i6 + 536 >> 2] = 0;
 return;
}

function __ZThn32_N12LineRendererD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + -32 | 0;
 HEAP32[i4 >> 2] = gb + 43492 + 8;
 HEAP32[i1 >> 2] = gb + 43492 + 184;
 i2 = i1 + 312 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (!(HEAP32[i5 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i3 + 8 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 316 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 if (HEAP32[i5 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN8RendererD2Ev(i4);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN8RendererD2Ev(i4);
 return;
}

function __ZNK4Mesh17GetPrimitiveCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = HEAP32[i3 + 128 >> 2] | 0;
 i3 = (HEAP32[i3 + 132 >> 2] | 0) - i4 | 0;
 i5 = (i3 | 0) / 52 | 0;
 if ((i3 | 0) > 0) {
  i3 = 0;
  i1 = 0;
 } else {
  i5 = 0;
  return i5 | 0;
 }
 do {
  i2 = HEAP32[i4 + (i3 * 52 | 0) + 36 >> 2] | 0;
  switch (HEAP32[i4 + (i3 * 52 | 0) + 40 >> 2] | 0) {
  case 0:
   {
    i2 = (i2 | 0) / 3 | 0;
    break;
   }
  case 1:
   {
    i2 = i2 + -2 | 0;
    break;
   }
  case 2:
   {
    i2 = ((i2 | 0) / 4 | 0) << 1;
    break;
   }
  case 3:
   {
    i2 = (i2 | 0) / 2 | 0;
    break;
   }
  case 4:
   {
    i2 = i2 + -1 | 0;
    break;
   }
  case 5:
   break;
  default:
   i2 = 0;
  }
  i1 = i2 + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i5 | 0));
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i9, i8) {
 i1 = i1 | 0;
 i9 = i9 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i9 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i9);
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = i5 + (i9 << 4) | 0;
 if ((i1 | 0) >= (i9 | 0)) {
  HEAP32[i6 >> 2] = i9;
  return;
 }
 i2 = i8 + 4 | 0;
 i3 = i8 + 8 | 0;
 i4 = i8 + 12 | 0;
 i1 = i5 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i7 >>> 0);
 HEAP32[i6 >> 2] = i9;
 return;
}

function __ZN5physx2Sn5ConvXC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 89080 + 8;
 i4 = i1 + 4 | 0;
 i3 = i1 + 292 | 0;
 i2 = i1 + 312 | 0;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP16[i2 + 12 >> 1] = 0;
 HEAP8[i2 + 14 >> 0] = 0;
 HEAP32[i1 + 336 >> 2] = 1;
 HEAP8[i1 + 340 >> 0] = 1;
 __ZN5physx2Sn12PointerRemapC2Ev(i1 + 344 | 0);
 _memset(i1 + 36 | 0, 66, 256) | 0;
 return;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 151160 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5Umbra9Matrix4x49transposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i1 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 28 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 52 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i1 + 44 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN4crnd12symbol_codec8get_bitsEj(i2, i8) {
 i2 = i2 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = i2 + 20 | 0;
 i1 = HEAP32[i9 >> 2] | 0;
 if ((i1 | 0) < (i8 | 0)) {
  i7 = i2 + 4 | 0;
  i3 = i2 + 16 | 0;
  i6 = HEAP32[i2 + 8 >> 2] | 0;
  i4 = i1;
  i1 = HEAP32[i7 >> 2] | 0;
  while (1) {
   if ((i1 | 0) == (i6 | 0)) {
    i2 = 0;
    i5 = i6;
   } else {
    i5 = i1 + 1 | 0;
    HEAP32[i7 >> 2] = i5;
    i2 = HEAPU8[i1 >> 0] | 0;
   }
   i1 = i4 + 8 | 0;
   HEAP32[i9 >> 2] = i1;
   i2 = HEAP32[i3 >> 2] | i2 << 24 - i4;
   HEAP32[i3 >> 2] = i2;
   if ((i1 | 0) < (i8 | 0)) {
    i4 = i1;
    i1 = i5;
   } else break;
  }
 } else {
  i2 = i2 + 16 | 0;
  i3 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2 << i8;
 HEAP32[i9 >> 2] = i1 - i8;
 return i2 >>> (32 - i8 | 0) | 0;
}

function __ZN29UnityWebRequestAsyncOperation11GetProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
  f4 = Math_fround(1.0);
  return Math_fround(f4);
 }
 i2 = i1 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = ((HEAP32[i3 + 72 >> 2] | 0) != 0 & 1) + ((HEAP32[i3 + 68 >> 2] | 0) != 0 & 1) | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i2 >> 2] | 0;
 f4 = Math_fround(Math_fround(f4 + Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0))) / Math_fround(i1 >>> 0));
 i3 = f4 < Math_fround(0.0);
 i2 = f4 > Math_fround(1.0);
 f4 = i2 ? Math_fround(1.0) : f4;
 f4 = i3 ? Math_fround(0.0) : f4;
 return Math_fround(f4);
}

function __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i7 = i8 + 4 | 0;
 i1 = i1 + 108 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP8[i7 >> 0] = 0;
 __ZN9dtNavMesh19getPolyFlagsAndAreaEyPjPh(i2, i4, i5, i3, i7);
 i3 = (HEAP32[i3 >> 2] | 0) == 0;
 do if ((i6 | i3 ^ 1) & (i3 | i6 ^ 1)) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i6) {
   __ZN9dtNavMesh25setOffMeshConnectionFlagsEyj(i1, i4, i5, 1 << (HEAPU8[i7 >> 0] | 0)) | 0;
   break;
  } else {
   __ZN9dtNavMesh25setOffMeshConnectionFlagsEyj(i1, i4, i5, 0) | 0;
   break;
  }
 } while (0);
 STACKTOP = i8;
 return;
}

function __ZN13RenderManager18UpdateAllRenderersEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if (__Z18GetIParticleSystemv() | 0) {
  i4 = __Z18GetIParticleSystemv() | 0;
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 }
 __ZN28LightProbeProxyVolumeManager6UpdateEv(__Z31GetLightProbeProxyVolumeManagerv() | 0);
 if ((HEAP16[gb + 1112352 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1112352 | 0, i1);
  i1 = gb + 1112352 | 0;
 } else i1 = 0;
 __ZN8Renderer26UpdateAllRenderersInternalEb(1);
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZN12LineRendererD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 43492 + 8;
 HEAP32[i3 + 32 >> 2] = gb + 43492 + 184;
 i1 = i3 + 344 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 348 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN8RendererD2Ev(i3);
  __ZdlPv(i3);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN8RendererD2Ev(i3);
 __ZdlPv(i3);
 return;
}

function __Z69SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddDirectionalLightInternalRK8Vector3fRK10ColorRGBAfR20SphericalHarmonicsL2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i6 + 8 >> 2] = i8;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i8;
 HEAP32[i5 + 8 >> 2] = i7;
 HEAP32[i5 + 12 >> 2] = i1;
 __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E(i3, i6, i5);
 STACKTOP = i4;
 return;
}

function __Z32CustomEventData_CUSTOM_AddDoubleP12Il2CppObjectP12Il2CppStringd(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 16 | 0;
 i5 = i7 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038111 | 0, i6); else {
  __ZNK11ICallString6ToUTF8Ev(i5, i4);
  i6 = (__ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcd(i1, (HEAP8[i5 + 11 >> 0] | 0) < 0 ? HEAP32[i5 >> 2] | 0 : i5, d3) | 0) & 1;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _cff_index_get_name(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 8 | 0;
 i2 = i8 + 4 | 0;
 i6 = i8;
 i7 = i4 + 20 | 0;
 i3 = HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0;
 i1 = _cff_index_access_element(i7, i1, i5, i2) | 0;
 HEAP32[i6 >> 2] = i1;
 if (i1 | 0) {
  i7 = 0;
  STACKTOP = i8;
  return i7 | 0;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = _UNITY_ft_mem_alloc(i3, i2 + 1 | 0, i6) | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 if (HEAP32[i4 + 48 >> 2] | 0) {
  i7 = i1;
  STACKTOP = i8;
  return i7 | 0;
 }
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i7 >> 2] | 0, i5);
 i7 = i1;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK6Camera22CalculateRenderingPathEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0;
 i1 = HEAP32[i2 + 928 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i1 = __Z21GetManagerFromContexti(6) | 0;
  i1 = HEAP32[i1 + 128 + (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] << 3) >> 2] | 0;
 }
 if ((i1 | 1 | 0) != 3) {
  i2 = i1;
  return i2 | 0;
 }
 if (!((i1 | 0) == 2 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 517 >> 0] | 0) != 0)) if (!((HEAP8[(__Z15GetGraphicsCapsv() | 0) + 518 >> 0] | 0) != 0 & (i1 | 0) == 3)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP8[i2 + 1088 >> 0] | 0)) {
  i2 = __ZNK6Camera19GetProjectionMatrixEv(i2) | 0;
  f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
  i2 = f3 == Math_fround(0.0) ? Math_fround(HEAPF32[i2 + 24 >> 2]) == Math_fround(0.0) : 0;
  return (i2 ? i1 : 1) | 0;
 } else {
  i2 = 1;
  return i2 | 0;
 }
 return 0;
}

function __ZN9Scripting35GetComponentObjectToScriptingObjectEPN5Unity9ComponentER10GameObjectPKNS0_4TypeE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
 if ((i1 | 0) == (gb + 27592 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = __Z21GetManagerFromContexti(5) | 0;
  i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
  if (i2 | 0) break;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i4 = 7;
   break;
  }
 }
 if ((i4 | 0) == 7) return i1 | 0;
 i4 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
 return i4 | 0;
}

function __ZN8Animator15GetBodyPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 }
 i3 = (HEAP32[i2 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i4 = i3 + i4 + 40 | 0;
  if (HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0) {
   i4 = HEAP32[(HEAP32[i2 + 132 >> 2] | 0) + 24 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   return;
  }
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN5physx2Sc5Scene7collideEfPNS_10PxBaseTaskE(i5, f1, i4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 HEAPF32[i5 + 64 >> 2] = f1;
 __ZN5physx2Sc5Scene15prepareSimulateEv(i5);
 __ZN5physx2Sc8SimStats8simStartEv(HEAP32[i5 + 1184 >> 2] | 0);
 __ZN5physx10PxsContext11beginUpdateEv(HEAP32[(HEAP32[i5 + 1204 >> 2] | 0) + 1e3 >> 2] | 0);
 i2 = i5 + 2332 | 0;
 HEAP32[i5 + 2348 >> 2] = 1;
 i3 = i5 + 2344 | 0;
 HEAP32[i3 >> 2] = i4;
 if (!i4) {
  i5 = HEAP32[i2 >> 2] | 0;
  i5 = i5 + 20 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(i5 | 0, i2 | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 HEAP32[i5 + 2340 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = i5 + 20 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(i5 | 0, i2 | 0);
 return;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER17RemapPPtrTransfer(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 52 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 i4 = HEAP32[i4 + 44 >> 2] | 0;
 i3 = i1 + (i4 << 2) | 0;
 if (!i4) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN14VelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN14BillboardAsset8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 __ZN14SafeBinaryRead10SetVersionEi(i4, 2);
 __ZN19SharedBillboardData8TransferI14SafeBinaryReadEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i4);
 i3 = i1 + 36 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 945676 | 0, gb + 946436 | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11MonoManager19GetBuiltinMonoClassEPKcb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[HEAP32[i1 + 224 >> 2] >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __Z25scripting_class_from_namePK11Il2CppImagePKcS3_(i1, gb + 1049797 | 0, i2) | 0;
 if ((i1 | 0) != 0 | i3) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i2;
 __Z6FormatPKcz(i4, gb + 464842 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 464919 | 0, 180, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z13RegisterClassI15ParticleEmitterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1134;
 HEAP32[i2 + 8 >> 2] = gb + 1047963;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 88;
 HEAP32[i2 + 20 >> 2] = 220;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190576;
 HEAP32[i2 + 44 >> 2] = fb + 442;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 443;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 132 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 136 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 140 >> 2])) return;
  }
 } else i1 = i6 + 136 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 140 >> 2] = i2;
 HEAP32[i6 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Sc21ConstraintInteractionC2EPNS0_13ConstraintSimERNS0_8RigidSimES5_(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i3, i1, i2, 1, 2);
 HEAP16[i3 + 28 >> 1] = -1;
 HEAP16[i3 + 30 >> 1] = 0;
 HEAP32[i3 >> 2] = gb + 90796 + 8;
 HEAP32[i3 + 24 >> 2] = gb + 90796 + 48;
 HEAP32[i3 + 32 >> 2] = i4;
 HEAP32[i3 + 36 >> 2] = -1;
 i2 = HEAP32[i4 + 108 >> 2] | 0;
 i1 = HEAP32[i4 + 112 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 144 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 256;
  i4 = i2 + 46 | 0;
  HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
 }
 if (!i1) return;
 i4 = i1 + 144 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 256;
 i4 = i1 + 46 | 0;
 HEAP16[i4 >> 1] = (HEAP16[i4 >> 1] | 0) + 1 << 16 >> 16;
 return;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation14LoadArchiveJobEPv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if ((HEAP32[i2 + 92 >> 2] | 0) != 1) {
  i1 = i2 + 208 | 0;
  if ((__ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i2, i2 + 192 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0) == 1) {
   i1 = HEAP32[gb + 1104184 >> 2] | 0;
   if (!i1) {
    __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(gb + 1104184 | 0);
    i1 = HEAP32[gb + 1104184 >> 2] | 0;
   }
   __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i1, fb + 3307 | 0, i2);
   return;
  }
 }
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i2);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
 return;
}

function __Z55AnimatorControllerPlayable_CUSTOM_GetLayerIndexInternalR9HPlayableP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i4 = -1;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
 i3 = __ZN26AnimatorControllerPlayable13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = i3;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z46UploadHandlerRaw_CUSTOM_InternalSetContentTypeP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 16 | 0;
 i4 = i6 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i5); else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 12 | 0, i4) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 }
}

function __Z28Animator_CUSTOM_GetLayerNameP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator12GetLayerNameEi(i3, i4, i2);
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i4 = __Z20scripting_string_newPKcj(i2 ? HEAP32[i3 >> 2] | 0 : i3, i2 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function _tt_cmap6_validate(i3, i7) {
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i3 + 10 | 0;
 i5 = i7 + 8 | 0;
 if (i1 >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i7, 8);
 i4 = (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0);
 i2 = (HEAPU8[i3 + 8 >> 0] | 0) << 8 | (HEAPU8[i3 + 9 >> 0] | 0);
 if ((i3 + i4 | 0) >>> 0 > (HEAP32[i5 >> 2] | 0) >>> 0) i6 = 5; else if (i4 >>> 0 < ((i2 << 1) + 10 | 0) >>> 0) i6 = 5;
 if ((i6 | 0) == 5) _UNITY_ft_validator_error(i7, 8);
 if ((HEAP32[i7 + 12 >> 2] | 0) == 0 | (i2 | 0) == 0) return 0;
 i3 = i7 + 20 | 0;
 while (1) {
  if (((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0)) >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i7, 16);
  i2 = i2 + -1 | 0;
  if (!i2) break; else i1 = i1 + 2 | 0;
 }
 return 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25getMassSpaceInertiaTensorEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 2)) i1 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i1 + 64 | 0) | 0; else i1 = (HEAP32[i1 + 56 >> 2] | 0) + 96 | 0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f5 == Math_fround(0.0);
 f5 = Math_fround(Math_fround(1.0) / f5);
 f5 = i1 ? Math_fround(0.0) : f5;
 i1 = f4 == Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f4);
 f4 = i1 ? Math_fround(0.0) : f4;
 i1 = f3 == Math_fround(0.0);
 f3 = Math_fround(Math_fround(1.0) / f3);
 f3 = i1 ? Math_fround(0.0) : f3;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f3;
 return;
}

function __ZNK14PhysicMaterial14InitPxMaterialEPN5physx10PxMaterialE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0;
 if (!i1) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (!i1) return;
 }
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 40 >> 2]));
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, +Math_fround(HEAPF32[i2 + 44 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0);
 f3 = i5 ? Math_fround(1.0) : f3;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, +(i4 ? Math_fround(0.0) : f3));
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i2 + 32 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0);
 return;
}

function __ZNK14ParticleSystem9IsStoppedEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, f6 = f0, d7 = 0.0;
 i2 = i5 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 30 >> 0] | 0) {
  d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i2 >> 2] | 0;
  d3 = +HEAPF64[i1 + 40 >> 3];
  i2 = HEAP32[i5 + 36 >> 2] | 0;
  if (!(HEAP8[i2 + 277 >> 0] | 0)) {
   d7 = d4 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 264 >> 2]);
   if (d7 > +Math_fround(f6 + Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2]))) {
    i5 = 1;
    return i5 | 0;
   }
  }
  if (HEAP8[i1 + 13 >> 0] | 0) if (d4 - d3 > +Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2])) {
   i5 = 1;
   return i5 | 0;
  }
 }
 i5 = (HEAP32[i1 + 8 >> 2] | 0) == 0;
 return i5 | 0;
}

function __ZNK14ParticleSystem9IsPlayingEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, d3 = 0.0, d4 = 0.0, f6 = f0, d7 = 0.0;
 i2 = i5 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 30 >> 0] | 0) {
  d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
  i1 = HEAP32[i2 >> 2] | 0;
  d3 = +HEAPF64[i1 + 40 >> 3];
  i2 = HEAP32[i5 + 36 >> 2] | 0;
  if (!(HEAP8[i2 + 277 >> 0] | 0)) {
   d7 = d4 - +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 396 >> 2]);
   f6 = Math_fround(HEAPF32[i2 + 264 >> 2]);
   if (d7 > +Math_fround(f6 + Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2]))) {
    i5 = 0;
    return i5 | 0;
   }
  }
  if (HEAP8[i1 + 13 >> 0] | 0) if (d4 - d3 > +Math_fround(HEAPF32[(HEAP32[i5 + 44 >> 2] | 0) + 88 >> 2])) {
   i5 = 0;
   return i5 | 0;
  }
 }
 i5 = (HEAP32[i1 + 8 >> 2] | 0) == 1;
 return i5 | 0;
}

function __ZN8Playable6CastToEP11Il2CppClass(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!(mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 52 >> 2] | 0, i4 | 0, i1 | 0) | 0)) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i3 = __Z20scripting_object_newP11Il2CppClass(i1) | 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __Z18GetDirectorManagerv() | 0;
  i1 = __ZN15DirectorManager11AcquireNodeEv() | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = i4;
 __ZN15DirectorManager18FinishConstructionEP12Il2CppObjectR9HPlayable(__Z18GetDirectorManagerv() | 0, i3, i5) | 0;
 i5 = i3;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx7NpScene15addArticulationERNS_14PxArticulationE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i1 + 16 >> 2] | 0) >>> 30 | 0) {
 case 0:
  {
   i4 = 3;
   break;
  }
 case 3:
  {
   if ((__ZN5physx3Scb5Scene10getPxSceneEv(HEAP32[i1 + 12 >> 2] | 0) | 0) == (i2 | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 4;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE(i2, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 850, gb + 709768 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth17addCollisionPlaneERKNS_21PxClothCollisionPlaneE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore17addCollisionPlaneERKNS_21PxClothCollisionPlaneE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 444, gb + 694851 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 120 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 124 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 128 >> 2])) return;
  }
 } else i1 = i6 + 124 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 128 >> 2] = i2;
 HEAP32[i6 + 540 >> 2] = 0;
 return;
}

function __ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 12 | 0;
 i7 = i5;
 i8 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i7, i8, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZN15FileSystemEntryC2EPKc(i6, (HEAP8[i7 + 11 >> 0] | 0) < 0 ? HEAP32[i7 >> 2] | 0 : i7);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
 i4 = __ZN4File19OpenFileSystemEntryERK15FileSystemEntryNS_10PermissionENS_12AutoBehaviorE(i1, i6, i3, i4) | 0;
 __ZN13FileEntryDataD2Ev(i6);
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869359;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869359;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869359;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN21SystemInfoStringCache13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1103748 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 16 | 0;
  if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
   i3 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i2 + 28 >> 2] | 0;
   HEAP32[i1 >> 2] = 66;
   HEAP32[i1 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
  if ((HEAP8[i2 + 11 >> 0] | 0) < 0) {
   i5 = HEAP32[i2 >> 2] | 0;
   i3 = HEAP32[i2 + 12 >> 2] | 0;
   HEAP32[i1 >> 2] = 66;
   HEAP32[i1 + 4 >> 2] = i3;
   __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63216 | 0);
 HEAP32[gb + 1103748 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN16Physics2DManager19AddRigidbodyUpdatesEP11Rigidbody2D(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = __Z17GetTransformDepthR9Transform(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0) | 0;
 i4 = i3 + 68 + (((i4 | 0) < 63 ? i4 : 63) << 3) | 0;
 i5 = i1 + 104 | 0;
 if ((i5 | 0) == (i4 | 0)) {
  i5 = i3 + 625 | 0;
  HEAP8[i5 >> 0] = 1;
  return;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i1 = i1 + 108 | 0; else {
  i1 = i1 + 108 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i5;
 i5 = i3 + 625 | 0;
 HEAP8[i5 >> 0] = 1;
 return;
}

function __ZN14MemoryProfilerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 160 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i3, HEAP32[i3 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63584 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63584 | 0);
 HEAP32[i1 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1163240 >> 2] | 0, gb + 63584 | 0);
 return;
}

function __ZN12SoundManager14UpdateChannelsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i7 | 0)) return;
 do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  i5 = i4 + 164 | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  if (i3 | 0) {
   i6 = i4 + 148 | 0;
   i2 = HEAP16[i6 >> 1] | 0;
   if (i2 & 512) {
    i8 = (__ZN4FMOD7Channel11setPositionEjj(i3, HEAP32[i4 + 116 >> 2] | 0, 2) | 0) == 0;
    i2 = HEAP16[i6 >> 1] | 0;
    i3 = i2 & -513;
    if (i8) {
     HEAP16[i6 >> 1] = i3;
     i2 = i3;
    }
   }
   if (i2 & 1024) if (!(__ZN4FMOD7Channel11setPositionEjj(HEAP32[i5 >> 2] | 0, HEAP32[i4 + 120 >> 2] | 0, 1) | 0)) HEAP16[i6 >> 1] = HEAP16[i6 >> 1] & -1025;
  }
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 return;
}

function __ZN11UnityEngine9Analytics13UserInfoEvent12ToJsonStringER9JSONWrite(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i3, i4);
 i2 = i3 + 32 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 36 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1037853 | 0, 0);
 i2 = i3 + 48 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 52 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1037867 | 0, 0);
 i1 = i3 + 64 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i4, i1, gb + 1037871 | 0, 0);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 344 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 348 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 352 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 i2 = i6;
 if ((i6 | 0) == 0 | ((i5 | 0) < 0 | (i5 & 2147483647 | 0) == 0)) {
  i6 = i3 + 536 | 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 i6 = i3 + 536 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN8Animator20GotoStateInFixedTimeEiifff(i1, i3, i5, f6, f7, f8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 var i2 = 0, i4 = 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 624 >> 2] | 0)) return;
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 }
 i2 = i1 + 584 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 do {
  __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff(HEAP32[i1 >> 2] | 0, i3, i5, f6, f7, f8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation9SetResultENS_21AssetBundleLoadResultEPKc(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i2 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i1 = i2 + 96 | 0;
 if (!i4) {
  __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrENS_21AssetBundleLoadResultE(i5, i2, i3);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i5) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 } else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i1, i4) | 0;
 STACKTOP = i6;
 return;
}

function __ZN12WheelJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1);
 if (!(i1 & 16)) return;
 i4 = i3 + 116 | 0;
 i5 = HEAP8[i4 >> 0] | 0;
 i6 = i5 << 24 >> 24 != 0;
 HEAP8[i4 >> 0] = 1;
 i2 = i3 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN12b2WheelJoint11EnableMotorEb(i1, 1);
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   __ZN12b2WheelJoint13SetMotorSpeedEf(i1, Math_fround(Math_fround(HEAPF32[i3 + 108 >> 2]) * Math_fround(.0174532924)));
   __ZN12b2WheelJoint17SetMaxMotorTorqueEf(i1, Math_fround(HEAPF32[i3 + 112 >> 2]));
   i1 = HEAP32[i2 >> 2] | 0;
   HEAP8[i4 >> 0] = i5;
   if (!i1) return;
   __ZN12b2WheelJoint11EnableMotorEb(i1, i6);
   return;
  }
 }
 HEAP8[i4 >> 0] = i5;
 return;
}

function __Z46GL_CUSTOM_INTERNAL_CALL_GetGPUProjectionMatrixRK10Matrix4x4fhRS_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
 i7 = i5;
 i2 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i2 | 0));
 i7 = __Z25GetUncheckedRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 144 >> 2] | 0, i7 | 0, i5 | 0, i6 | 0, i3 << 24 >> 24 != 0 & (i6 ^ 1) | 0);
 i7 = i4;
 i1 = i5;
 i2 = i7 + 64 | 0;
 do {
  HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
  i7 = i7 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i7 | 0) < (i2 | 0));
 STACKTOP = i8;
 return;
}

function __Z27Animator_CUSTOM_ResolveHashP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator11ResolveHashEi(i3, i4, i2);
  i4 = HEAP8[i3 + 11 >> 0] | 0;
  i2 = i4 << 24 >> 24 < 0;
  i4 = __Z20scripting_string_newPKcj(i2 ? HEAP32[i3 >> 2] | 0 : i3, i2 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function _fmin(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i5 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = i6 & 2147483647;
 do if (i4 >>> 0 > 2146435072 | (i4 | 0) == 2146435072 & i5 >>> 0 > 0) d1 = d2; else {
  HEAPF64[tempDoublePtr >> 3] = d2;
  i3 = HEAP32[tempDoublePtr >> 2] | 0;
  i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i7 = i4 & 2147483647;
  if (!(i7 >>> 0 > 2146435072 | (i7 | 0) == 2146435072 & i3 >>> 0 > 0)) {
   i5 = _bitshift64Lshr(i5 | 0, i6 | 0, 63) | 0;
   getTempRet0() | 0;
   i7 = _bitshift64Lshr(i3 | 0, i4 | 0, 63) | 0;
   getTempRet0() | 0;
   if ((i5 | 0) == (i7 | 0)) {
    d1 = d1 < d2 ? d1 : d2;
    break;
   } else {
    d1 = (i6 | 0) < 0 ? d1 : d2;
    break;
   }
  }
 } while (0);
 return +d1;
}

function _fmax(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i5 = HEAP32[tempDoublePtr >> 2] | 0;
 i6 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = i6 & 2147483647;
 do if (i4 >>> 0 > 2146435072 | (i4 | 0) == 2146435072 & i5 >>> 0 > 0) d1 = d2; else {
  HEAPF64[tempDoublePtr >> 3] = d2;
  i3 = HEAP32[tempDoublePtr >> 2] | 0;
  i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
  i7 = i4 & 2147483647;
  if (!(i7 >>> 0 > 2146435072 | (i7 | 0) == 2146435072 & i3 >>> 0 > 0)) {
   i5 = _bitshift64Lshr(i5 | 0, i6 | 0, 63) | 0;
   getTempRet0() | 0;
   i7 = _bitshift64Lshr(i3 | 0, i4 | 0, 63) | 0;
   getTempRet0() | 0;
   if ((i5 | 0) == (i7 | 0)) {
    d1 = d1 < d2 ? d2 : d1;
    break;
   } else {
    d1 = (i6 | 0) < 0 ? d2 : d1;
    break;
   }
  }
 } while (0);
 return +d1;
}

function __ZNSt3__219__shared_mutex_base4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 HEAP32[i4 >> 2] = i1;
 i5 = i4 + 4 | 0;
 HEAP8[i5 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i1);
 i6 = i1 + 124 | 0;
 i2 = i1 + 28 | 0;
 while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  if ((i3 | 0) >= 0) break;
  __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i2, i4);
 }
 i3 = i3 | -2147483648;
 HEAP32[i6 >> 2] = i3;
 i2 = i1 + 76 | 0;
 i1 = i3;
 while (1) {
  if (!(i1 & 2147483647)) break;
  __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i2, i4);
  i1 = HEAP32[i6 >> 2] | 0;
 }
 if (HEAP8[i5 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i7;
 return;
}

function __ZN7mecanim9animation23CreateBlendTreeConstantEPPNS0_21BlendTreeNodeConstantEjRNS_6memory9AllocatorE(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
 i3 = i6 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i6 >> 2] = i5;
 if (!i5) {
  HEAP32[i3 >> 2] = 0;
  return i6 | 0;
 }
 i2 = i5 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
 if ((i1 | 0) != (i1 + (i5 << 2) | 0)) _memset(i1 | 0, 0, i2 | 0) | 0;
 i2 = i3;
 i1 = i1 | 0 ? i1 - i2 | 0 : 0;
 HEAP32[i3 >> 2] = i1;
 i2 = i1 + i2 | 0;
 i1 = 0;
 do {
  i3 = i2 + (i1 << 2) | 0;
  i7 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
  HEAP32[i3 >> 2] = i7 | 0 ? i7 - i3 | 0 : 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return i6 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 180 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 184 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 188 >> 2])) return;
  }
 } else i1 = i6 + 184 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 188 >> 2] = i2;
 HEAP32[i6 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager22releaseObstacleContextERNS0_15ObstacleContextE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 116 | 0;
 i3 = i1 + 120 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 + 4 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  mftCall_vi(i5 | 0, i6 | 0);
  return;
 }
 i4 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
 i5 = HEAP32[i6 >> 2] | 0;
 i5 = i5 + 4 | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_vi(i5 | 0, i6 | 0);
 return;
}

function __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 80 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 88 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 92 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 96 >> 2] = HEAP32[i2 + 60 >> 2];
 return i1 | 0;
}

function __ZN5physx22PxVehicleTelemetryData5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 15824 >> 2] = 0;
 _memset(i3 + 3504 | 0, 0, 12288) | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i3) return;
 i4 = i1 + 4 | 0;
 i5 = i1 + 8 | 0;
 i1 = i1 + 12 | 0;
 i2 = 0;
 do {
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i6 + (i2 * 15840 | 0) + 15824 >> 2] = 0;
  _memset(i6 + (i2 * 15840 | 0) + 3504 | 0, 0, 12288) | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + (i2 * 12 | 0) >> 2] = 0;
  HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] = 0;
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 + (i2 * 12 | 0) >> 2] = 0;
  HEAP32[i6 + (i2 * 12 | 0) + 4 >> 2] = 0;
  HEAP32[i6 + (i2 * 12 | 0) + 8 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN5physx13NpVolumeCacheC2EPNS_2Sq17SceneQueryManagerEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i4 >> 2] = gb + 101476 + 8;
 HEAP32[i4 + 80 >> 2] = i1;
 i1 = i4 + 84 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 100 >> 2] = 0;
 HEAP32[i4 + 104 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = -1;
 HEAP32[i4 + 72 >> 2] = i2;
 HEAP32[i4 + 76 >> 2] = i3;
 HEAP8[i4 + 117 >> 0] = 1;
 HEAP8[i4 + 116 >> 0] = 1;
 if (!i2) i1 = 0; else {
  __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i2);
  i1 = HEAP32[i4 + 104 >> 2] & 2147483647;
 }
 if (i1 >>> 0 >= i3 >>> 0) return;
 __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i4 + 96 | 0, i3);
 return;
}

function __ZN5Umbra17BasePoolAllocator12allocatePageEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = i1 >>> 0 < 32 ? 32 : i1;
 i2 = HEAP32[i4 + 20 >> 2] | 0;
 if ((Math_imul(i1, i2) | 0) >>> 0 > 8160) i1 = i2 >>> 0 > 8160 ? 1 : 8160 / (i2 >>> 0) | 0;
 i2 = Math_imul(i2, i1) | 0;
 i3 = i2 + 43 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i2 + 59 | 0, 0) | 0;
 if (!i2) i2 = 0; else {
  HEAP32[i2 >> 2] = i3;
  i2 = i2 + 16 | 0;
 }
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i2 + 12 + 31 & -32;
 i6 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i1;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i3;
 return i2 | 0;
}

function __ZN4FMOD6System20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869285;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869285;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869285;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN10SizeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 272 | 0, i4);
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 536 | 0, i4);
 i1 = i1 + 800 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN10FileSystemD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 16 | 0;
 if ((HEAP32[i3 + 32 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 20 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z40Renderer_Get_Custom_PropSortingLayerNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK8Renderer19GetSortingLayerNameEv(i2, i3);
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i3 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i2 >> 2] | 0 : i2, i1 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z33SetCaptureAllKeyboardInputEnabledb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 ? 1 : 2;
 i3 = HEAP32[gb + 1103744 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 if (i3 | 0) {
  _emscripten_set_keydown_callback(0, 0, 0, 0) | 0;
  _emscripten_set_keyup_callback(0, 0, 0, 0) | 0;
  _emscripten_set_keypress_callback(0, 0, 0, 0) | 0;
 }
 if (i1) {
  _emscripten_set_keydown_callback(0, 0, 0, fb + 337 | 0) | 0;
  _emscripten_set_keyup_callback(0, 0, 0, fb + 337 | 0) | 0;
  _emscripten_set_keypress_callback(0, 0, 1, fb + 338 | 0) | 0;
 } else {
  _emscripten_set_keydown_callback(gb + 363711 | 0, 0, 0, fb + 337 | 0) | 0;
  _emscripten_set_keyup_callback(gb + 363711 | 0, 0, 0, fb + 337 | 0) | 0;
  _emscripten_set_keypress_callback(gb + 363711 | 0, 0, 1, fb + 338 | 0) | 0;
 }
 HEAP32[gb + 1103744 >> 2] = i2;
 return;
}

function __Z14DrawGUITextureRK5RectTIfEP7Textureiiii11ColorRGBA32P8Materiali(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10 + 20 | 0;
 i13 = i10 + 16 | 0;
 i12 = i10;
 HEAPF32[i12 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i12 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i12 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i13 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i13 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali(i1, i2, i12, i3, i4, i5, i6, Math_fround(1.0), i11, i8, i9);
 STACKTOP = i10;
 return;
}

function _jinit_c_main_controller(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i5 + 4 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i5 | 0, 1, 64) | 0;
 HEAP32[i5 + 320 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 2364;
 if (HEAP8[i5 + 176 >> 0] | 0) return;
 if (i1 << 24 >> 24) {
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i5 | 0);
  return;
 }
 i4 = i5 + 60 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i3 = i2 + 24 | 0;
 i1 = 0;
 i2 = HEAP32[i5 + 68 >> 2] | 0;
 while (1) {
  HEAP32[i3 + (i1 << 2) >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, 1, HEAP32[i2 + 28 >> 2] << 3 | 0, HEAP32[i2 + 12 >> 2] << 3 | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i4 >> 2] | 0)) break; else i2 = i2 + 84 | 0;
 }
 return;
}

function __ZZN15DirectorManager15InitializeClassEvEN41FixedUpdateDirectorFixedAdvanceTimestruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[gb + 1188524 >> 2] | 0;
 i3 = i2 + 396 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i5 = HEAP32[(__Z14GetTimeManagerv() | 0) + 48 >> 2] | 0;
 HEAP32[gb + 1188444 >> 2] = i5;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i1, fb + 3163 | 0, HEAP32[i2 + 384 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 STACKTOP = i4;
 return;
}

function __ZThn8_N5physx2Gu11HeightField14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + -8 | 0;
 i1 = i3 + 112 | 0;
 if (!(__ZN5physx13GuMeshFactory17removeHeightFieldERNS_13PxHeightFieldE(HEAP32[i1 >> 2] | 0, i3) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 724537 | 0, 79, gb + 724659 | 0, i4);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP16[i3 + 6 >> 1] & 1)) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i3 | 0);
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i3, 1, 1);
 STACKTOP = i4;
 return;
}

function __ZN8Material15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 10032 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + 9264 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + 9264 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + 9264 + (i1 * 12 | 0) >> 2] = fb + 80;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc9ClothCore19setVirtualParticlesEjPKjjPKNS_6PxVec3E(i4, i2, i1, i3, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 24 | 0;
 i8 = i6 + 16 | 0;
 i11 = i6 + 8 | 0;
 i10 = i6;
 i4 = HEAP32[i4 + 28 >> 2] | 0;
 i9 = HEAP32[(HEAP32[i4 >> 2] | 0) + 232 >> 2] | 0;
 HEAP32[i11 >> 2] = i1;
 HEAP32[i11 + 4 >> 2] = i1 + (i2 << 4);
 HEAP32[i10 >> 2] = i5;
 HEAP32[i10 + 4 >> 2] = i5 + (i3 * 12 | 0);
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i11 + 4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 mftCall_viii(i9 | 0, i4 | 0, i8 | 0, i7 | 0);
 STACKTOP = i6;
 return;
}

function __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
 i1 = i1 + 8 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 4);
  i6 = HEAP32[i6 >> 2] | 0;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i7;
  return;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  HEAP32[i6 >> 2] = i5;
  HEAP32[i2 >> 2] = i4;
  i6 = i5;
  i6 = _llvm_bswap_i32(i6 | 0) | 0;
  HEAP32[i1 >> 2] = i6;
  STACKTOP = i7;
  return;
 }
}

function __ZN16TimerQueriesGLESD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 544 | 0;
 i2 = i3 + 548 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i5 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i2 >> 2] = i4;
 HEAP32[i4 >> 2] = i4;
 i2 = i3 + 552 | 0;
 i1 = HEAP32[i3 + 556 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  return;
 }
 do {
  i6 = i1 + 4 | 0;
  i5 = i1;
  i1 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 return;
}

function __ZN14NavMeshManager16CleanupWithErrorEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 if (!i2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 846404 | 0, 0, gb + 842172 | 0, 1262, 1, 0, 0, 0);
  __ZN14NavMeshManager7CleanupEv(i1);
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i4 >> 2] = i2;
  __Z6FormatPKcz(i3, gb + 846297 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 842172 | 0, 1260, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  __ZN14NavMeshManager7CleanupEv(i1);
  STACKTOP = i5;
  return;
 }
}

function __Z38Texture2D_CUSTOM_UpdateExternalTextureP12Il2CppObject13Il2Cpp_IntPtr(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8 + 4 | 0;
 i7 = i8;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 428 >> 2] | 0;
 if (!i6) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i4) {
  i8 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  HEAP32[i7 >> 2] = HEAP32[i4 + 48 >> 2];
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  mftCall_viiii(i3 | 0, i2 | 0, i5 | 0, i1 | 0, 2);
  STACKTOP = i8;
  return;
 }
}

function __Z38Canvas_Get_Custom_PropSortingLayerNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK2UI6Canvas19GetSortingLayerNameEv(i2, i3);
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i3 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i2 >> 2] | 0 : i2, i1 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function _UNITY_png_read_filter_row_paeth_1byte_pixel(i1, i5, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = i5 + i4 | 0;
 i2 = HEAPU8[i3 >> 0] | 0;
 i1 = (HEAPU8[i5 >> 0] | 0) + i2 | 0;
 HEAP8[i5 >> 0] = i1;
 if ((i4 | 0) <= 1) return;
 i4 = i1;
 i1 = i5 + 1 | 0;
 do {
  i3 = i3 + 1 | 0;
  i5 = i4 & 255;
  i8 = i2;
  i2 = HEAPU8[i3 >> 0] | 0;
  i7 = i2 - i8 | 0;
  i11 = i5 - i8 | 0;
  i9 = (i7 | 0) < 0 ? 0 - i7 | 0 : i7;
  i10 = (i11 | 0) < 0 ? 0 - i11 | 0 : i11;
  i11 = i7 + i11 | 0;
  i7 = (i10 | 0) < (i9 | 0);
  i4 = ((((i11 | 0) < 0 ? 0 - i11 | 0 : i11) | 0) < ((i7 ? i10 : i9) | 0) ? i8 : i7 ? i2 : i5) + (HEAPU8[i1 >> 0] | 0) | 0;
  HEAP8[i1 >> 0] = i4;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 return;
}

function mftCall_viiiiiiiiiiiiiiiii(i18, i1, i2, i10, i11, i12, i13, i14, i15, i16, i17, i3, i4, i5, i6, i7, i8, i9) {
 i18 = i18 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i18 | 0) >= (fb | 0) & (i18 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiiiiiiiiiiiiiiii[i18 - fb & 3](i1 | 0, i2 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
  return;
 }
 ftCall_viiiiiiiiiiiiiiiii(i18 | 0, i1 | 0, i2 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i16 | 0, i17 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZN9Projector7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(68, i1, 16, gb + 1048932 | 0, 0, gb + 383272 | 0, 17) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 35316 + 8;
 HEAP32[i4 + 64 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5Unity17ConfigurableJoint16FinalizeCreateD6Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 28 | 0;
 i3 = i4;
 i5 = (HEAP8[i1 + 293 >> 0] | 0) != 0;
 __ZN5Unity5Joint14FinalizeCreateEb(i1, i5);
 if (!i5) {
  STACKTOP = i4;
  return;
 }
 i5 = i1 + 32 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 | 0, 0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i1 | 0, 1);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, 0, i3 | 0);
 i5 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, 1, i2 | 0);
 STACKTOP = i4;
 return;
}

function __ZN25PathNamePersistentManager28InsertFileIdentifierInternalE14FileIdentifierb(i3, i1, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i4, i1);
 i7 = mftCall_iiii(i7 | 0, i3 | 0, i6 | 0, i5 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN14AvatarPlaybackC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i1 >> 2] = gb + 178100 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i7 = i1 + 16 | 0;
 HEAP32[i7 >> 2] = -1;
 HEAP32[i7 + 4 >> 2] = -1;
 HEAP32[i7 + 8 >> 2] = -1;
 HEAP32[i7 + 12 >> 2] = -1;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 32 >> 2] = gb + 175924 + 8;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __Z39WebCamTexture_Get_Custom_PropDeviceNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK17BaseWebCamTexture9GetDeviceEv(i2, i3);
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i3 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i2 >> 2] | 0 : i2, i1 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z33Camera_CUSTOM_RemoveCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  __ZN19RenderEventsContext19RemoveCommandBufferEiP22RenderingCommandBuffer(i4 + 1136 | 0, i3, i1);
  STACKTOP = i6;
  return;
 }
}

function _UNITY_png_set_PLTE(i1, i2, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 if (i6 >>> 0 > 256) if ((HEAP8[i2 + 25 >> 0] | 0) == 3) _UNITY_png_error(i1, gb + 352989 | 0); else return;
 i3 = (i6 | 0) != 0;
 if ((i5 | 0) == 0 & i3) _UNITY_png_error(i1, gb + 353012 | 0);
 if (!i6) if (!(HEAP32[i1 + 596 >> 2] & 1)) _UNITY_png_error(i1, gb + 353012 | 0);
 _UNITY_png_free_data(i1, i2, 4096, 0);
 i4 = _UNITY_png_calloc(i1, 768) | 0;
 HEAP32[i1 + 412 >> 2] = i4;
 if (i3) _memcpy(i4 | 0, i5 | 0, i6 * 3 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = i4;
 i6 = i6 & 65535;
 HEAP16[i1 + 416 >> 1] = i6;
 HEAP16[i2 + 20 >> 1] = i6;
 i6 = i2 + 220 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4096;
 i6 = i2 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 8;
 return;
}

function _nextafterf(f3, f1) {
 f3 = Math_fround(f3);
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 i4 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i5 = i2 & 2147483647;
 L1 : do if (i5 >>> 0 > 2139095040) i7 = 3; else {
  i6 = i4 & 2147483647;
  if (i6 >>> 0 > 2139095040) i7 = 3; else if ((i2 | 0) != (i4 | 0)) {
   do if (!i5) {
    if (!i6) break L1;
    i2 = i4 & -2147483648 | 1;
   } else if (i5 >>> 0 > i6 >>> 0 | (i4 ^ i2 | 0) < 0) {
    i2 = i2 + -1 | 0;
    break;
   } else {
    i2 = i2 + 1 | 0;
    break;
   } while (0);
   f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
 } while (0);
 if ((i7 | 0) == 3) f1 = Math_fround(f3 + f1);
 return Math_fround(f1);
}

function __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 28 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZNK12NavMeshAgent24CalculateDimensionScalesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i3;
 __ZNK9Transform18GetWorldScaleLossyEv(i9, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i9 >> 2]);
 i2 = f6 < Math_fround(0.0);
 f4 = Math_fround(-f6);
 f6 = i2 ? f4 : f6;
 f4 = Math_fround(HEAPF32[i9 + 4 >> 2]);
 i2 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f7 = Math_fround(HEAPF32[i9 + 8 >> 2]);
 i9 = f7 < Math_fround(0.0);
 f8 = Math_fround(-f7);
 f7 = i9 ? f8 : f7;
 HEAPF32[i1 >> 2] = f6 < f7 ? f7 : f6;
 HEAPF32[i1 + 4 >> 2] = i2 ? f5 : f4;
 STACKTOP = i3;
 return;
}

function __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i5);
 i1 = i1 + 32 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i6, 1);
  i6 = HEAP8[i6 >> 0] | 0;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i6 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i6 = i3;
  HEAP8[i1 >> 0] = i6;
  __ZN18StreamedBinaryReadILb1EE5AlignEv(i5);
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx7NpCloth23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore23setSimulationFilterDataERKNS_12PxFilterDataE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1056, gb + 692464 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx3Cct13HandleManager10SetupListsEPPvPtS4_S4_(i5, i2, i3, i1, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 3 | 0, HEAP32[i7 >> 2] | 0);
 HEAP32[i7 >> 2] = 0;
 i8 = i5 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 2 | 0, HEAP32[i8 >> 2] | 0);
 HEAP32[i8 >> 2] = 0;
 i9 = i5 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6 + 1 | 0, HEAP32[i9 >> 2] | 0);
 HEAP32[i9 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = i2;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i7 >> 2] = i4;
 STACKTOP = i6;
 return 1;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 84804 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN20FloatToHalfConverter26InitializePrecomputeTablesEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = 0;
 do {
  i2 = i1 + -127 | 0;
  do if ((i2 | 0) < -24) {
   HEAP16[gb + 1477124 + (i1 << 1) >> 1] = 0;
   HEAP8[gb + 1546331 + i1 >> 0] = 24;
  } else {
   if ((i2 | 0) < -14) {
    HEAP16[gb + 1477124 + (i1 << 1) >> 1] = 1024 >>> (113 - i1 | 0);
    HEAP8[gb + 1546331 + i1 >> 0] = 126 - i1;
    break;
   }
   if ((i2 | 0) < 16) {
    HEAP16[gb + 1477124 + (i1 << 1) >> 1] = (i1 << 10) + 16384;
    HEAP8[gb + 1546331 + i1 >> 0] = 13;
    break;
   }
   HEAP16[gb + 1477124 + (i1 << 1) >> 1] = 31744;
   i3 = gb + 1546331 + i1 | 0;
   if ((i2 | 0) < 128) {
    HEAP8[i3 >> 0] = 24;
    break;
   } else {
    HEAP8[i3 >> 0] = 13;
    break;
   }
  } while (0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 return;
}

function __ZN17SharedTextureDataC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 41960 + 8;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager16sendErrorMessageEN5physx11PxErrorCode4EnumEPKcS5_j(i1, i4, i7, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 if (!i1) return;
 mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i4 | 0, i7 | 0, i5 | 0, i6 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __Z25UnloadGameObjectHierarchyR10GameObject(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
 i3 = i1 + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = i1 + 80 | 0;
  i1 = 0;
  do {
   __Z25UnloadGameObjectHierarchyR10GameObject(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0) | 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = i4 + 40 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  __Z22delete_object_internalP6Object(i4);
  return 1;
 }
 i2 = i4 + 28 | 0;
 i1 = 0;
 do {
  __Z22delete_object_internalP6Object(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 __Z22delete_object_internalP6Object(i4);
 return 1;
}

function __Z13RegisterClassI8RendererEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 565;
 HEAP32[i2 + 8 >> 2] = gb + 442476;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 25;
 HEAP32[i2 + 20 >> 2] = 340;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31312;
 HEAP32[i2 + 44 >> 2] = fb + 46;
 HEAP32[i2 + 48 >> 2] = fb + 47;
 HEAP32[i2 + 52 >> 2] = fb + 48;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI25RuntimeAnimatorControllerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 950;
 HEAP32[i2 + 8 >> 2] = gb + 904313;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 93;
 HEAP32[i2 + 20 >> 2] = 80;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 178436;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI24PhysicsUpdateBehaviour2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 883;
 HEAP32[i2 + 8 >> 2] = gb + 806798;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 246;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154956;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13FloatToStringfPKc(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 do if (f2 != f2 | Math_fround(0.0) != Math_fround(0.0)) _strncpy(i4, gb + 585577 | 0, 255) | 0; else {
  if (f2 == Math_fround(-inf)) {
   _strncpy(i4, gb + 585581 | 0, 255) | 0;
   break;
  }
  if (f2 == Math_fround(inf)) {
   _strncpy(i4, gb + 585591 | 0, 255) | 0;
   break;
  } else {
   HEAPF64[i5 >> 3] = +f2;
   _snprintf(i4, 255, i3, i5) | 0;
   break;
  }
 } while (0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i6;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 68 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 72 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 76 >> 2])) return;
  }
 } else i1 = i6 + 72 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 76 >> 2] = i2;
 HEAP32[i6 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK7b2Mat3312GetInverse22EPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(Math_fround(f4 * f5) - Math_fround(f7 * f6));
 i1 = f3 != Math_fround(0.0);
 f8 = Math_fround(Math_fround(1.0) / f3);
 f3 = i1 ? f8 : f3;
 HEAPF32[i2 >> 2] = Math_fround(f5 * f3);
 f5 = Math_fround(-f3);
 HEAPF32[i2 + 12 >> 2] = Math_fround(f7 * f5);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(f6 * f5);
 HEAPF32[i2 + 16 >> 2] = Math_fround(f4 * f3);
 i2 = i2 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN9Scripting35GetComponentObjectToScriptingObjectEP6ObjectR10GameObjectPKN5Unity4TypeE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
 if ((i1 | 0) == (gb + 27592 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = __Z21GetManagerFromContexti(5) | 0;
  i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
  if (i2 | 0) break;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i4 = 7;
   break;
  }
 }
 if ((i4 | 0) == 7) return i1 | 0;
 i4 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
 return i4 | 0;
}

function __ZN8GradientC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP8[i1 + 64 >> 0] = 2;
 HEAP8[i1 + 65 >> 0] = 2;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 HEAP16[i1 + 48 >> 1] = 0;
 HEAP16[i1 + 32 >> 1] = 0;
 HEAP16[i1 + 50 >> 1] = -1;
 HEAP16[i1 + 34 >> 1] = -1;
 i3 = i1 + 36 | 0;
 i2 = i1 + 52 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP16[i3 >> 1] = 0;
 HEAP16[i3 + 2 >> 1] = 0;
 HEAP16[i3 + 4 >> 1] = 0;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP16[i3 + 8 >> 1] = 0;
 HEAP16[i3 + 10 >> 1] = 0;
 HEAP16[i2 >> 1] = 0;
 HEAP16[i2 + 2 >> 1] = 0;
 HEAP16[i2 + 4 >> 1] = 0;
 HEAP16[i2 + 6 >> 1] = 0;
 HEAP16[i2 + 8 >> 1] = 0;
 HEAP16[i2 + 10 >> 1] = 0;
 return;
}

function __ZN5physx2Sc19ParticlePacketShapeC2ERNS0_17ParticleSystemSimEjPNS_16PxvParticleShapeE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i4 >> 2] = gb + 90952 + 8;
 HEAP32[i4 + 4 >> 2] = 0;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = i3;
 i6 = i4 + 12 | 0;
 HEAP32[i6 >> 2] = 2147483647;
 HEAP32[i6 + 4 >> 2] = 1073741823;
 __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE(i3, i4);
 HEAP32[i4 >> 2] = gb + 106748 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP16[i4 + 40 >> 1] = 0;
 HEAP16[i4 + 42 >> 1] = 0;
 HEAP32[i4 + 44 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i4 | 0);
 HEAP16[i4 + 48 >> 1] = i1;
 __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_19ParticlePacketShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i5 >> 2] | 0) | 0, i4);
 return;
}

function __ZN5Umbra9BitVectoraSERKS0_(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 if ((i5 | 0) == (i4 | 0)) return i4 | 0;
 i6 = HEAP32[i5 + 8 >> 2] & 134217727;
 i7 = i4 + 8 | 0;
 i3 = i4 + 4 | 0;
 if (i6 >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i4 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + -16 | 0);
  }
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = i6 << 2;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 16 | 0, 0) | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i1 >> 2] = i6;
   i1 = i1 + 16 | 0;
  }
  HEAP32[i3 >> 2] = i1;
 } else {
  i2 = i6 << 2;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i6;
 _memcpy(i1 | 0, HEAP32[i5 + 4 >> 2] | 0, i2 | 0) | 0;
 return i4 | 0;
}

function __Z23EndsWithCaseInsensitivePKcjS0_j(i1, i2, i5, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i4 = 0, i6 = 0, i7 = 0;
 if (i2 >>> 0 < i3 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 L4 : do if (!i3) i1 = 0; else {
  i6 = i1 + i2 + (0 - i3) | 0;
  i4 = i3;
  i1 = i5;
  while (1) {
   i5 = HEAP8[i6 >> 0] | 0;
   i2 = i5 << 24 >> 24;
   i2 = (i5 + -65 & 255) < 26 ? i2 + 32 | 0 : i2;
   i5 = i2 & 255;
   i7 = HEAP8[i1 >> 0] | 0;
   i3 = i7 << 24 >> 24;
   i3 = (i7 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
   if (!(i5 << 24 >> 24 ? i5 << 24 >> 24 == (i3 & 255) << 24 >> 24 : 0)) {
    i1 = (i2 & 255) - (i3 & 255) | 0;
    break L4;
   }
   i4 = i4 + -1 | 0;
   if (!i4) {
    i1 = 0;
    break;
   } else {
    i6 = i6 + 1 | 0;
    i1 = i1 + 1 | 0;
   }
  }
 } while (0);
 i7 = (i1 | 0) == 0;
 return i7 | 0;
}

function __Z13RegisterClassI10Collider2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 866;
 HEAP32[i2 + 8 >> 2] = gb + 800956;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 53;
 HEAP32[i2 + 20 >> 2] = 160;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32588;
 HEAP32[i2 + 44 >> 2] = fb + 232;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 233;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0, f9 = f0, f10 = f0, i11 = 0, i12 = 0;
 i12 = HEAP32[i3 + 48 >> 2] | 0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i11 = f7 > Math_fround(0.0);
 i8 = f10 > Math_fround(0.0);
 i3 = Math_fround(HEAPF32[i2 + 8 >> 2]) > Math_fround(0.0);
 f10 = Math_fround(HEAPF32[i12 + 144 >> 2]);
 f7 = Math_fround(HEAPF32[i12 + 148 >> 2]);
 f5 = Math_fround(HEAPF32[i12 + 152 >> 2]);
 f9 = Math_fround(-f10);
 f6 = Math_fround(-f7);
 f4 = Math_fround(-f5);
 HEAPF32[i1 >> 2] = i11 ? f10 : f9;
 HEAPF32[i1 + 4 >> 2] = i8 ? f7 : f6;
 HEAPF32[i1 + 8 >> 2] = i3 ? f5 : f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN6Skybox7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(40, i1, 16, gb + 1048932 | 0, 0, gb + 384727 | 0, 29) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 35844 + 8;
 HEAP32[i4 + 36 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcNS_14PxProfileNamesEj(i1, i5, i4, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i8 = i4;
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 288, gb + 766896 | 0, gb + 740601 | 0, 138) | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = i8;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i4, i1, i5, i3, i2);
 STACKTOP = i6;
 return i4 + 116 | 0;
}

function __ZN4FMOD6System11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869672;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869672;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869672;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN19AudioHighPassFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 171092 + 8;
 HEAPF32[i1 + 44 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 5;
 STACKTOP = i4;
 return;
}

function __ZN12TextureInput8CopyFromERKS_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i3 = i3 + 4 | 0;
 i4 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 return;
}

function __Z9pqMinimumP9PriorityQ(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, f4 = f0, i5 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  i5 = HEAP32[i2 >> 2] | 0;
  i5 = HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
  return i5 | 0;
 }
 i5 = HEAP32[HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + (i1 + -1 << 2) >> 2] >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i1 + 8 >> 2] | 0) {
  i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] << 3) >> 2] | 0;
  f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f4 = Math_fround(HEAPF32[i5 + 24 >> 2]);
  if (f3 < f4) {
   i5 = i1;
   return i5 | 0;
  }
  if (f3 == f4) {
   f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   if (f4 <= Math_fround(HEAPF32[i5 + 28 >> 2])) {
    i5 = i1;
    return i5 | 0;
   }
  }
 }
 return i5 | 0;
}

function __Z34MonoBehaviour_CUSTOM_StopCoroutineP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11ICallString6ToUTF8Ev(i4, i3);
  __ZN13MonoBehaviour13StopCoroutineEPKc(i1, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i5;
  return;
 }
}

function __Z30CanvasRenderer_CUSTOM_SetAlphaP12Il2CppObjectf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i6 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 __ZN2UI14CanvasRenderer8GetColorEv(i4, i1);
 HEAPF32[i4 + 12 >> 2] = f2;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN2UI14CanvasRenderer8SetColorERK10ColorRGBAf(i1, i4);
  STACKTOP = i5;
  return;
 }
}

function __Z20GetShaderGlobalFloatN9ShaderLab16FastPropertyNameE(i3) {
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[gb + 1166248 >> 2] | 0;
 i2 = HEAP32[i4 + 44 >> 2] | 0;
 i5 = HEAP32[i4 + 48 >> 2] | 0;
 if ((i2 | 0) >= (i5 | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 i6 = HEAP32[i4 + 68 >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((HEAP32[i6 + (i2 << 2) >> 2] | 0) == (i3 | 0)) break;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i5 | 0)) {
   f1 = Math_fround(0.0);
   i7 = 7;
   break;
  }
 }
 if ((i7 | 0) == 7) return Math_fround(f1);
 if ((i2 | 0) <= -1) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 f1 = Math_fround(HEAPF32[(HEAP32[i4 + 108 >> 2] | 0) + (HEAP32[(HEAP32[i4 + 88 >> 2] | 0) + (i2 << 2) >> 2] & 1048575) >> 2]);
 return Math_fround(f1);
}

function __Z13RegisterClassIN5Unity17ConfigurableJointEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 845;
 HEAP32[i2 + 8 >> 2] = gb + 734920;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 153;
 HEAP32[i2 + 20 >> 2] = 360;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 111956;
 HEAP32[i2 + 44 >> 2] = fb + 211;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 212;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _unzStringFileNameCompare(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 if ((i2 | 1 | 0) == 1) {
  i5 = _strcmp(i3, i1) | 0;
  return i5 | 0;
 }
 while (1) {
  i4 = HEAP8[i3 >> 0] | 0;
  i2 = HEAP8[i1 >> 0] | 0;
  i4 = (i4 + -97 & 255) < 26 ? (i4 & 255) + 224 & 255 : i4;
  i2 = (i2 + -97 & 255) < 26 ? (i2 & 255) + 224 & 255 : i2;
  i5 = i2 << 24 >> 24 == 0;
  if (!(i4 << 24 >> 24)) {
   i2 = 4;
   break;
  }
  if (i5) {
   i1 = 1;
   i2 = 8;
   break;
  }
  if (i4 << 24 >> 24 < i2 << 24 >> 24) {
   i1 = -1;
   i2 = 8;
   break;
  }
  if (i4 << 24 >> 24 > i2 << 24 >> 24) {
   i1 = 1;
   i2 = 8;
   break;
  } else {
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  }
 }
 if ((i2 | 0) == 4) {
  i5 = (i5 ^ 1) << 31 >> 31;
  return i5 | 0;
 } else if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwjj(i2, i7, i5, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = i1 & 255;
  i6 = i2;
 }
 if ((i3 | 0) == 0 | i1 >>> 0 <= i5 >>> 0) i1 = -1; else {
  i4 = i6 + (i1 << 2) | 0;
  i3 = i7 + (i3 << 2) | 0;
  i1 = i6 + (i5 << 2) | 0;
  L7 : while (1) {
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i4;
    break;
   } else i2 = i7;
   while (1) {
    if ((i2 | 0) == (i3 | 0)) break;
    if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) break L7; else i2 = i2 + 4 | 0;
   }
   i1 = i1 + 4 | 0;
  }
  i1 = (i1 | 0) == (i4 | 0) ? -1 : i1 - i6 >> 2;
 }
 return i1 | 0;
}

function __ZNK5physx7NpShape22getHeightFieldGeometryERNS_21PxHeightFieldGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 6) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i2 + 36 >> 2] & 1)) i2 = 6; else {
  i2 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 i2 = i3 + 4 | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP8[i3 + 20 >> 0] = HEAP8[i1 + 20 >> 0] | 0;
 i3 = i3 + 21 | 0;
 i2 = i1 + 21 | 0;
 HEAP8[i3 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
 i3 = 1;
 return i3 | 0;
}

function __ZN9dtNavMesh32setOffMeshConnectionCostModifierEyf(i3, i1, i2, f4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 var i5 = 0;
 if (!((i1 & 983040 | 0) == 65536 & 0 == 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i5 = i1 & 65535;
 if (i5 >>> 0 > (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i2 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i3 + 48 >> 2] | 0;
 if ((i1 + (i5 * 104 | 0) | 0) == 0 ? 1 : (i2 | 0) != (HEAP32[i1 + (i5 * 104 | 0) + 92 >> 2] | 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i2 = !(f4 >= Math_fround(0.0));
 HEAPF32[i1 + (i5 * 104 | 0) + 68 >> 2] = i2 ? Math_fround(-1.0) : f4;
 i5 = i3 + 56 | 0;
 i3 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
 HEAP32[i5 >> 2] = (i3 | 0) == 0 ? 1 : i3;
 i5 = 1073741824;
 return i5 | 0;
}

function __ZN8Renderer19SetLightmapIndexIntEi12LightmapType(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = i1 + 260 + (i2 << 1) | 0;
 if ((i3 | 0) == -1) {
  HEAP16[i1 >> 1] = -1;
  STACKTOP = i6;
  return;
 }
 if (i3 >>> 0 > 65535) {
  HEAP16[i1 >> 1] = -1;
  HEAP32[i5 >> 2] = 65535;
  __Z6FormatPKcz(i4, gb + 936733 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 936769 | 0, 104, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP16[i1 >> 1] = i3;
  STACKTOP = i6;
  return;
 }
}

function __ZN8Renderer14UpdateLODGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7 + 4 | 0;
 i4 = i7;
 i5 = i1 + 284 | 0;
 if ((HEAP32[i5 >> 2] | 0) == -1) {
  STACKTOP = i7;
  return;
 }
 i6 = __Z16GetRendererScenev() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i1 + 312 >> 2] | 0;
 if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  __ZN8LODGroup23GetLODGroupIndexAndMaskEP8RendererPjS2_(i3, i1, i2, i4);
  i2 = HEAP32[i2 >> 2] & 65535;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = HEAP32[i6 + 60 >> 2] | 0;
 HEAP16[i6 + (i5 * 24 | 0) + 12 >> 1] = 0;
 HEAP16[i6 + (i5 * 24 | 0) + 14 >> 1] = i2;
 HEAP32[i6 + (i5 * 24 | 0) + 16 >> 2] = i1;
 STACKTOP = i7;
 return;
}

function __ZN8GUIState20FocusKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (i2 | 0) {
  i1 = __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1) | 0;
  if (i1 | 0) {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i3 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = HEAP32[i4 + 8 >> 2] | 0;
   if (!i1) return;
   i2 = HEAP32[i1 + 24 >> 2] | 0;
   if (i2 | 0) if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) return;
   HEAP32[i1 + 12 >> 2] = i3;
   return;
  }
 }
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 >> 2] | 0) != -1) return;
 HEAP32[i1 + 12 >> 2] = -1;
 return;
}

function __ZN5physx7NpShape15decMeshRefCountEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 case 6:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 case 5:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 default:
  return;
 }
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i1 + 4 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx7NpCloth15setTetherConfigERKNS_19PxClothTetherConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore15setTetherConfigERKNS_19PxClothTetherConfigE(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 894, gb + 695574 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = i3 + 348 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 352 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 i2 = i3 + 356 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 i2 = i5;
 if ((i6 & 2147483647 | 0) == 0 | (i6 | 0) < 0 | (i5 | 0) == 0) {
  i6 = i3 + 540 | 0;
  HEAP32[i6 >> 2] = 0;
  STACKTOP = i4;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 i6 = i3 + 540 | 0;
 HEAP32[i6 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc8BodyCore6backupERNS0_12SimStateDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 120 | 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 124 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 128 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 132 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 136 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 140 >> 2];
 i3 = i2 + 112 | 0;
 HEAP32[i1 + 56 >> 2] = HEAP32[i3 >> 2];
 i2 = i2 + 116 | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i2 >> 2] = Math_fround(3402823469999999843913219.0e14);
 return;
}

function __ZN5physx14NpRigidDynamic25setStabilizationThresholdEf(i6, f7) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i6 + 48 | 0;
 i3 = HEAP32[i6 + 52 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 4; else i4 = i5;
   break;
  }
 default:
  i1 = 4;
 }
 if ((i1 | 0) == 4) {
  HEAPF32[i6 + 212 >> 2] = f7;
  return;
 }
 i2 = i6 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 176 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i5);
 i6 = i6 + 284 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 2048;
 return;
}

function __ZN4FMOD6System20getRecordDriverInfoWEiPsiP9FMOD_GUID(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869577;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869577;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869577;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN25PathNamePersistentManagerD0Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 66936 + 8;
 i3 = i5 + 208 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 212 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i6 = i2 + -12 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5 + 196 | 0, HEAP32[i5 + 200 >> 2] | 0);
 __ZN17PersistentManagerD2Ev(i5);
 __ZdlPv(i5);
 return;
}

function __ZN24EllipsoidParticleEmitter15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 768 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + (i1 * 12 | 0) >> 2] = fb + 432;
 STACKTOP = i5;
 return;
}

function __ZN12GraphicsCaps24SharedCapsPostInitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN10systeminfo19GetPhysicalMemoryMBEv() | 0;
 if ((HEAP32[i1 + 88 >> 2] | 0) > 29) if (!(HEAP8[i1 + 234 >> 0] | 0)) i3 = 3; else {
  HEAP8[i1 + 517 >> 0] = 1;
  i2 = (HEAP32[i1 + 140 >> 2] | 0) > 3 & 1;
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  HEAP8[i1 + 517 >> 0] = 0;
  i2 = 0;
 }
 HEAP8[i1 + 518 >> 0] = i2;
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 11576 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return; else i1 = 0;
 do {
  i4 = i2 + 10808 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 10808 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 10808 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN10TagManager19GetSortingLayerNameEi(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 if ((i4 | 0) >= 0) {
  i5 = HEAP32[i2 + 1068 >> 2] | 0;
  i3 = i5;
  if ((((HEAP32[i2 + 1072 >> 2] | 0) - i5 | 0) / 40 | 0 | 0) > (i4 | 0)) {
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 20 >> 2] = 0;
   i6 = i3 + (i4 * 40 | 0) + 24 | 0;
   i2 = HEAP32[i6 + 4 >> 2] | 0;
   i5 = i1 + 24 | 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = i2;
   HEAP8[i1 + 4 >> 0] = 0;
   __ZN4core20StringStorageDefaultIcE6assignERKS1_(i1, i3 + (i4 * 40 | 0) | 0);
   return;
  }
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i4 = gb + 63648 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 24 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP8[i1 + 4 >> 0] = 0;
 return;
}

function __Z46ParticleAnimator_Set_Custom_PropColorAnimationP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN9Scripting11RaiseIfNullEPv(i2);
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0) != 5) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 1049842 | 0, i4);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZN16ParticleAnimator17SetColorAnimationEP10ColorRGBAf(i3, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(_fminf(f9, f7));
 f6 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 HEAPF32[i2 >> 2] = Math_fround(_fminf(f10, Math_fround(_fminf(f8, Math_fround(_fminf(f6, f5))))));
 i4 = i2 + 4 | 0;
 f8 = Math_fround(HEAPF32[i4 >> 2]);
 f7 = Math_fround(_fmaxf(f9, f7));
 HEAPF32[i4 >> 2] = Math_fround(_fmaxf(f8, Math_fround(_fmaxf(f7, Math_fround(_fmaxf(f6, f5))))));
 i4 = i2;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 return;
}

function _UNITY_FT_Outline_Check(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 L1 : do if (i1 | 0) {
  i5 = HEAP16[i1 + 2 >> 1] | 0;
  i7 = i5 << 16 >> 16;
  i2 = HEAP16[i1 >> 1] | 0;
  i6 = i2 << 16 >> 16;
  if (!((i2 | i5) << 16 >> 16)) {
   i7 = 0;
   return i7 | 0;
  }
  if (!(i5 << 16 >> 16 < 1 | i2 << 16 >> 16 < 1)) {
   if (i2 << 16 >> 16 > 0) {
    i4 = HEAP32[i1 + 12 >> 2] | 0;
    i2 = 0;
    i3 = -1;
    while (1) {
     i8 = HEAP16[i4 + (i2 << 1) >> 1] | 0;
     i1 = i8 << 16 >> 16;
     i2 = i2 + 1 | 0;
     if (!((i1 | 0) > (i3 | 0) ? i8 << 16 >> 16 < i5 << 16 >> 16 : 0)) break L1;
     if ((i2 | 0) >= (i6 | 0)) break; else i3 = i1;
    }
   } else i1 = -1;
   if ((i1 | 0) == (i7 + -1 | 0)) {
    i8 = 0;
    return i8 | 0;
   }
  }
 } while (0);
 i8 = 6;
 return i8 | 0;
}

function _mktemp(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = _strlen(i3) | 0;
 do if (i1 >>> 0 < 6) i5 = 3; else {
  i2 = i3 + i1 + -6 | 0;
  if (!(_memcmp(i2, gb + 1076012 | 0, 6) | 0)) {
   i1 = 100;
   while (1) {
    ___randname(i2) | 0;
    if (_stat(i3, i4) | 0) break;
    i1 = i1 + -1 | 0;
    if (!i1) {
     i5 = 8;
     break;
    }
   }
   if ((i5 | 0) == 8) {
    HEAP8[i3 >> 0] = 0;
    HEAP32[(___errno_location() | 0) >> 2] = 17;
    break;
   }
   if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 2) HEAP8[i3 >> 0] = 0;
  } else i5 = 3;
 } while (0);
 if ((i5 | 0) == 3) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  HEAP8[i3 >> 0] = 0;
 }
 STACKTOP = i6;
 return i3 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i6 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) {
  i2 = (HEAP32[i6 + 8 >> 2] & 2147483647) + -1 | 0;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
 } else {
  i2 = 10;
  i1 = i1 & 255;
 }
 if ((i2 - i1 | 0) >>> 0 < i5 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc(i6, i2, i5 - i2 + i1 | 0, i1, i1, 0, i5, i4); else if (i5 | 0) {
  if (i3) i2 = HEAP32[i6 >> 2] | 0; else i2 = i6;
  _memcpy(i2 + i1 | 0, i4 | 0, i5 | 0) | 0;
  i1 = i1 + i5 | 0;
  if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i6 + 4 >> 2] = i1; else HEAP8[i7 >> 0] = i1;
  HEAP8[i2 + i1 >> 0] = 0;
 }
 return i6 | 0;
}

function __ZN4Halo7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 377968 | 0, 15) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 33384 + 8;
 HEAP32[i4 + 44 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN4FMOD7Channel8getDelayE14FMOD_DELAYTYPEPjS2_(i2, i1, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   if (i5 | 0) HEAP32[i5 >> 2] = 0;
   if (!i6) {
    i6 = 0;
    STACKTOP = i4;
    return i6 | 0;
   }
   HEAP32[i6 >> 2] = 0;
   i6 = 0;
   STACKTOP = i4;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869992;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN15AudioMixerGroup8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 52 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i4 + 32 >> 2] | 0;
 i4 = HEAP32[i4 + 44 >> 2] | 0;
 i3 = i1 + (i4 << 2) | 0;
 if (!i4) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN13RendererScene12CleanupUmbraEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 HEAP32[i6 + 144 >> 2] = 0;
 i7 = i6 + 140 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i7 >> 2] | 0, gb + 63600 | 0);
 HEAP32[i7 >> 2] = 0;
 i7 = i6 + 60 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 72 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i3 + (i2 * 24 | 0) | 0;
 i5 = (i2 | 0) == 0;
 if (i5) return; else i1 = i3;
 do {
  HEAP32[i1 + 8 >> 2] = -1;
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i4 | 0));
 if (i5) return; else i1 = 0;
 while (1) {
  if (!(HEAP32[i3 + (i1 * 24 | 0) >> 2] | 0)) {
   __ZN13RendererScene14RemoveRendererEi(i6, i1) | 0;
   i1 = i1 + -1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) break;
  i3 = HEAP32[i7 >> 2] | 0;
 }
 return;
}

function __ZN10Matrix4x4f8SetBasisERK8Vector3fS2_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z58RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustPointRK13Vector2fIcallP12Il2CppObjectS3_RS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 8 | 0;
 i6 = i7;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 if (!i2) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZN2UI16PixelAdjustPointERK8Vector2fP9TransformPNS_6CanvasE(i6, i5, i2, i1);
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 STACKTOP = i7;
 return;
}

function __Z47CommandBuffer_CUSTOM_SetShadowSamplingMode_ImplP12Il2CppObjectR26MonoRenderTargetIdentifier18ShadowSamplingMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  __ZN22RenderingCommandBuffer24AddSetShadowSamplingModeERK18RenderTextureParam18ShadowSamplingMode(i1, i4, i3);
  STACKTOP = i6;
  return;
 }
}

function __Z44RenderTexture_CUSTOM_SetGlobalShaderPropertyP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i4 >> 2] = __Z25ScriptingStringToPropertyR11ICallString(i3) | 0;
  __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i1, i4, HEAP32[gb + 1166248 >> 2] | 0);
  STACKTOP = i5;
  return;
 }
}

function _null_convert(i1, i3, i11, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i12 = 0;
 i12 = HEAP32[i1 + 60 >> 2] | 0;
 i10 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i9 = (i10 | 0) == 0;
 if ((i12 | 0) <= 0) return;
 while (1) {
  i7 = i4;
  i4 = i4 + -1 | 0;
  if (!i9) {
   i1 = 0;
   do {
    i8 = HEAP32[(HEAP32[i11 + (i1 << 2) >> 2] | 0) + (i2 << 2) >> 2] | 0;
    i5 = 0;
    i6 = HEAP32[i3 >> 2] | 0;
    while (1) {
     HEAP8[i8 + i5 >> 0] = HEAP8[i6 + i1 >> 0] | 0;
     i5 = i5 + 1 | 0;
     if ((i5 | 0) == (i10 | 0)) break; else i6 = i6 + i12 | 0;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i12 | 0));
  }
  if ((i7 | 0) <= 1) break; else {
   i2 = i2 + 1 | 0;
   i3 = i3 + 4 | 0;
  }
 }
 return;
}

function __ZNK9dtNavMesh10getTilesAtEiiPPK10dtMeshTilei(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 4 >> 2] & (Math_imul(i8, -669632447) | 0) + (Math_imul(i7, -1918454973) | 0);
 i2 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i6 = i1 + 20 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i6 >> 2] | 0;
  i3 = i5 + (i2 * 56 | 0) | 0;
  i4 = HEAP32[i5 + (i2 * 56 | 0) + 8 >> 2] | 0;
  if (i4) if ((HEAP32[i4 + 8 >> 2] | 0) == (i7 | 0)) if ((i1 | 0) < (i10 | 0) ? (HEAP32[i4 + 12 >> 2] | 0) == (i8 | 0) : 0) {
   HEAP32[i9 + (i1 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
  }
  i2 = HEAP32[i5 + (i2 * 56 | 0) + 52 >> 2] | 0;
 } while ((i2 | 0) != -1);
 return i1 | 0;
}

function __ZN9JSONWrite27TransferStringToCurrentNodeEPKc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 i1 = i4;
 while (1) if (!(HEAP8[i1 >> 0] | 0)) break; else i1 = i1 + 1 | 0;
 i2 = i1 - i4 | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i3);
 i1 = i3 + 16 | 0;
 if (i2 >>> 0 < 12) {
  HEAP32[i1 >> 2] = 7340037;
  HEAP8[i3 + 11 >> 0] = 11 - i2;
  _memcpy(i3 | 0, i4 | 0, i2 | 0) | 0;
  i4 = i3 + i2 | 0;
  HEAP8[i4 >> 0] = 0;
  return;
 } else {
  HEAP32[i1 >> 2] = 3145733;
  HEAP32[i3 + 4 >> 2] = i2;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 + 1 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 13) | 0;
  HEAP32[i3 >> 2] = i1;
  i3 = i1;
  _memcpy(i3 | 0, i4 | 0, i2 | 0) | 0;
  i4 = i3 + i2 | 0;
  HEAP8[i4 >> 0] = 0;
  return;
 }
}

function __ZN5physx2Sc7BodySim19updateKinematicPoseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = i1 + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 144 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(i2 & 4)) return;
 HEAP16[i1 >> 1] = i2 & 65023;
 __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i4, 1) | 0;
 i9 = HEAP32[i4 + 156 >> 2] | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = HEAP32[i9 + 8 >> 2] | 0;
 i6 = HEAP32[i9 + 12 >> 2] | 0;
 i5 = HEAP32[i9 + 16 >> 2] | 0;
 i1 = HEAP32[i9 + 20 >> 2] | 0;
 i2 = HEAP32[i9 + 24 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 + 16 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i4 + 20 >> 2] = i8;
 HEAP32[i4 + 24 >> 2] = i7;
 HEAP32[i4 + 28 >> 2] = i6;
 HEAP32[i4 + 32 >> 2] = i5;
 HEAP32[i4 + 36 >> 2] = i1;
 HEAP32[i4 + 40 >> 2] = i2;
 return;
}

function __ZN4FMOD5Sound13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i4, i1, i2, i6, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   if (!i6) {
    i6 = 0;
    STACKTOP = i5;
    return i6 | 0;
   }
   HEAP32[i6 >> 2] = 0;
   i6 = 0;
   STACKTOP = i5;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZN22DownloadHandlerTextureC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187656 + 8;
 i7 = gb + 63808 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i5 + 32 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i8 = i4 + 184 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 if (i2 | 0) {
  i1 = i8;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i7 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i8 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i7 | 0)) if (HEAP32[i1 + 20 >> 2] | 0) return;
 }
 HEAP32[(__ZNSt3__23mapIiP15MonoScriptCacheNS_4lessIiEE13stl_allocatorINS_4pairIKiS2_EEL18MemLabelIdentifier76ELi16EEEixERS7_(i4 + 180 | 0, i6) | 0) >> 2] = i5;
 return;
}

function __ZN13MemoryManager17LowLevelCAllocateEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 if (i1 | 0) if ((4294967295 / (i1 >>> 0) | 0) >>> 0 < i2 >>> 0) {
  __Z6FormatPKcz(i3, gb + 581944 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 581974 | 0, 780, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = Math_imul(i2, i1) | 0;
 i2 = _malloc(i1) | 0;
 if (!i2) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 _memset(i2 | 0, 0, i1 | 0) | 0;
 i4 = i2;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectR10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN2UI14CanvasRenderer8GetColorEv(i3, i4);
  i6 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  i4 = HEAP32[i3 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i4;
  STACKTOP = i5;
  return;
 }
}

function __Z39ComputeShader_CUSTOM_Internal_SetFloatsP12Il2CppObjectiP11Il2CppArray(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = i4;
  __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i2, i5, i6 << 2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __Z30Camera_CUSTOM_AddCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  __ZN19RenderEventsContext16AddCommandBufferEiP22RenderingCommandBuffer(i4 + 1136 | 0, i3, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z17IsPathNameVisibleRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 11 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i5 = i3 + 4 | 0;
 if (!((i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i1 & 255) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = 0;
 while (1) {
  if ((HEAP8[(i1 << 24 >> 24 < 0 ? HEAP32[i3 >> 2] | 0 : i3) + i2 >> 0] | 0) == 46) {
   i1 = 0;
   i2 = 6;
   break;
  }
  i1 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i3, 47, i2) | 0;
  i2 = i1 + 1 | 0;
  if ((i1 | 0) == -1) {
   i1 = 1;
   i2 = 6;
   break;
  }
  i1 = HEAP8[i4 >> 0] | 0;
  if (i2 >>> 0 >= (i1 << 24 >> 24 < 0 ? HEAP32[i5 >> 2] | 0 : i1 & 255) >>> 0) {
   i1 = 1;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __Z13RegisterClassI8ColliderEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 844;
 HEAP32[i2 + 8 >> 2] = gb + 906336;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 56;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32548;
 HEAP32[i2 + 44 >> 2] = fb + 209;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 210;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI7Joint2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 874;
 HEAP32[i2 + 8 >> 2] = gb + 800807;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 230;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32628;
 HEAP32[i2 + 44 >> 2] = fb + 234;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 235;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _catan(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0, i8 = 0;
 d3 = +HEAPF64[i1 >> 3];
 d5 = +HEAPF64[i1 + 8 >> 3];
 if (d3 == 0.0 & d5 > 1.0) i8 = 5; else {
  d6 = d3 * d3;
  d2 = 1.0 - d6 - d5 * d5;
  if (d2 == 0.0) i8 = 5; else {
   d2 = +Math_atan2(+(d3 * 2.0), +d2) * .5;
   d3 = d2 / 3.141592653589793;
   d3 = +(~~(d3 + (!(d3 >= 0.0) ? -.5 : .5)) | 0);
   d4 = d5 + -1.0;
   d4 = d6 + d4 * d4;
   if (d4 == 0.0) i8 = 5; else {
    d5 = d5 + 1.0;
    d6 = +Math_log(+((d6 + d5 * d5) / d4)) * .25;
    HEAPF64[i7 >> 3] = d2 - d3 * 3.141592651605606 - d3 * 1.9841871479187034e-09 - d3 * 1.1442377452219664e-17 + d6 * 0.0;
    HEAPF64[i7 + 8 >> 3] = d6 + 0.0;
   }
  }
 }
 if ((i8 | 0) == 5) {
  HEAPF64[i7 >> 3] = 1.e+308;
  HEAPF64[i7 + 8 >> 3] = 1.e+308;
 }
 return;
}

function __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i13 = i8 + 4 | 0;
 i12 = i8;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 i7 = mftCall_iiiiiiii(i11 | 0, i1 | 0, i10 | 0, i9 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i13 = i8 + 4 | 0;
 i12 = i8;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 i7 = mftCall_iiiiiiii(i11 | 0, i1 | 0, i10 | 0, i9 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareERKS5_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i7 = HEAP32[i2 + 4 >> 2] | 0; else i7 = i1 & 255;
 i6 = HEAP8[i5 + 8 + 3 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255;
 if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
 i2 = i6 >>> 0 < i7 >>> 0;
 __THREW__ = 0;
 i1 = invoke_iiii(fb + 515 | 0, i1 | 0, (i4 ? HEAP32[i5 >> 2] | 0 : i5) | 0, (i2 ? i6 : i7) | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i5);
 }
 if (!i1) return (i7 >>> 0 < i6 >>> 0 ? -1 : i2 & 1) | 0; else return i1 | 0;
 return 0;
}

function __ZNK11Rigidbody2D16GetPointVelocityERK8Vector2f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 if (i4 | 0) if ((HEAP32[i2 + 68 >> 2] | 0) != 2) {
  f5 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i4 + 72 >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 44 >> 2]));
  f6 = Math_fround(f7 * Math_fround(f6 - Math_fround(HEAPF32[i4 + 48 >> 2])));
  f5 = Math_fround(f7 * f5);
  f6 = Math_fround(Math_fround(HEAPF32[i4 + 64 >> 2]) - f6);
  f5 = Math_fround(f5 + Math_fround(HEAPF32[i4 + 68 >> 2]));
  HEAPF32[i1 >> 2] = f6;
  HEAPF32[i1 + 4 >> 2] = f5;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN7Terrain18SetLightmapIndicesE15LightmapIndices(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 152 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i4 >> 2] = i1;
 i3 = i2 + 228 | 0;
 i2 = i2 + 240 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[(HEAP32[i5 + 4 >> 2] | 0) + 108 >> 2] = i1;
 HEAP32[(HEAP32[i5 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
 i1 = i5 + 20 | 0;
 if ((i1 | 0) == ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0)) return;
 do {
  HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 108 >> 2] = HEAP32[i4 >> 2];
  HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 28 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f7 = f0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i6 + 72 | 0;
 f7 = (HEAP32[tempDoublePtr >> 2] = i4, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (f7 == Math_fround(HEAPF32[i3 >> 2])) {
  f7 = (HEAP32[tempDoublePtr >> 2] = i5, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  i1 = i6 + 76 | 0;
  if (f7 == Math_fround(HEAPF32[i1 >> 2])) {
   f7 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
   if (f7 == Math_fround(HEAPF32[i6 + 80 >> 2])) return;
  }
 } else i1 = i6 + 76 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i6 + 80 >> 2] = i2;
 HEAP32[i6 + 540 >> 2] = 0;
 return;
}

function __ZN5physx27PxVehicleDifferentialNWData20setDrivenWheelStatusEj(i10, i9) {
 i10 = i10 | 0;
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f11 = f0;
 i6 = i10 + 4 | 0;
 i7 = i10 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i8 = 0;
 do {
  i2 = 1 << i8;
  i3 = i10 + (i8 >>> 5 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i5 = (i4 & i2 | 0) != 0;
  if (!(i2 & i9)) {
   if (i5) {
    i1 = i1 + -1 | 0;
    HEAP32[i3 >> 2] = i4 & ~i2;
    f11 = Math_fround(Math_fround(1.0) / Math_fround(i1 >>> 0));
    HEAPF32[i7 >> 2] = (i1 | 0) == 0 ? Math_fround(0.0) : f11;
   }
  } else if (!i5) {
   i1 = i1 + 1 | 0;
   HEAP32[i3 >> 2] = i4 | i2;
   HEAPF32[i7 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i1 >>> 0));
  }
  HEAP32[i6 >> 2] = i1;
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != 20);
 return;
}

function __ZN5physx16PxVehicleNoDrive15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 44 | 0;
 i4 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i3 >> 2] | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 40 >> 2] | 0, i4 | 0);
 i3 = HEAP32[i3 >> 2] << 4;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 128 >> 2] | 0, i3 | 0);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 132 >> 2] | 0, i3 | 0);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 136 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5Umbra7FrustumC2Effff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0;
 i6 = f4 > Math_fround(0.0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 if (!i6) return;
 if (!(f3 > Math_fround(0.0) & (f2 < Math_fround(3.1415925) & (f2 > Math_fround(0.0) & f5 > f4)))) return;
 f2 = Math_fround(Math_fround(+Math_tan(+Math_fround(f2 * Math_fround(.5)))) * f4);
 HEAPF32[i1 + 8 >> 2] = f2;
 HEAPF32[i1 + 12 >> 2] = Math_fround(-f2);
 f3 = Math_fround(f2 * f3);
 HEAPF32[i1 + 4 >> 2] = f3;
 HEAPF32[i1 >> 2] = Math_fround(-f3);
 HEAPF32[i1 + 16 >> 2] = f4;
 HEAPF32[i1 + 20 >> 2] = f5;
 return;
}

function __ZN4FMOD7Channel9isPlayingEPb(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i4) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   if (!(HEAP32[i2 + 64 >> 2] | 0)) i1 = 0; else i1 = HEAP8[i2 + 161 >> 0] ^ 1;
   HEAP8[i4 >> 0] = i1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 862511;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13WebCamTextureD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 25856 + 8;
 i1 = i3 + 120 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i1 = i3 + 124 | 0; else {
  HEAP8[i1 >> 0] = 0;
  i1 = i3 + 124 | 0;
  _JS_WebCamVideo_Stop(HEAP32[HEAP32[i1 >> 2] >> 2] | 0);
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 176 >> 2] | 0, i3 | 0);
 }
 HEAP8[i3 + 92 >> 0] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 26152 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 108 | 0);
 HEAP32[i3 >> 2] = gb + 175688 + 8;
 __ZN16BaseVideoTexture15ThreadedCleanupEv(i3);
 HEAP32[i3 >> 2] = gb + 45392 + 8;
 HEAP32[i3 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i3 + 28 | 0);
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 __ZdlPv(i3);
 return;
}

function __Z25Transform_CUSTOM_GetChildP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if ((i2 | 0) <= -1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 577264 | 0, i4);
 if ((HEAP32[i3 + 92 >> 2] | 0) > (i2 | 0)) {
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[i3 + 80 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 577264 | 0, i4);
 return 0;
}

function __Z19GetVertexBufferDataP14SharedMeshDataR16VertexBufferDatai(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 i4 = i2 + 32 | 0;
 i5 = i1 + 40 | 0;
 i6 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i2 + 80 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 88 >> 2] = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i2, i1, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1;
 i3 = i7 - i4 | 0;
 if (i3 >>> 0 > 4294967279) {
  __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i2);
  i5 = 5;
 } else if (i3 >>> 0 < 11) {
  HEAP8[i2 + 11 >> 0] = i3;
  i6 = i2;
 } else i5 = 5;
 if ((i5 | 0) == 5) {
  i5 = i3 + 16 & -16;
  i6 = __Znwj(i5) | 0;
  HEAP32[i2 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i2 + 4 >> 2] = i3;
 }
 i3 = i7 - i4 | 0;
 i2 = i6;
 while (1) {
  if ((i1 | 0) == (i7 | 0)) break;
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 }
 HEAP8[i6 + i3 >> 0] = 0;
 return;
}

function __ZNK5physx7NpCloth27getNbVirtualParticleWeightsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore27getNbVirtualParticleWeightsEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 533, gb + 693628 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN9dtNavMesh10getTilesAtEiiPP10dtMeshTilei(i1, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 4 >> 2] & (Math_imul(i8, -669632447) | 0) + (Math_imul(i7, -1918454973) | 0);
 i2 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  i10 = 0;
  return i10 | 0;
 }
 i6 = i1 + 20 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i6 >> 2] | 0;
  i3 = i5 + (i2 * 56 | 0) | 0;
  i4 = HEAP32[i5 + (i2 * 56 | 0) + 8 >> 2] | 0;
  if (i4) if ((HEAP32[i4 + 8 >> 2] | 0) == (i7 | 0)) if ((i1 | 0) < (i10 | 0) ? (HEAP32[i4 + 12 >> 2] | 0) == (i8 | 0) : 0) {
   HEAP32[i9 + (i1 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
  }
  i2 = HEAP32[i5 + (i2 * 56 | 0) + 52 >> 2] | 0;
 } while ((i2 | 0) != -1);
 return i1 | 0;
}

function __ZN9Texture2D11SetPixels32EiPK11ColorRGBA32i(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 20 | 0;
 i6 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 if (!(__ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii(i1, i5, 0, i2) | 0)) {
  STACKTOP = i7;
  return;
 }
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i5 + 8 >> 2] | 0;
 if ((Math_imul(i1, i2) | 0) != (i4 | 0)) {
  STACKTOP = i7;
  return;
 }
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i6, i2, i1, i2 << 2, 4, i3);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i6, 0);
 STACKTOP = i7;
 return;
}

function __ZN5Light13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i3, i1);
 __ZNK5Light16UnshareLightDataEv(i3);
 i4 = i3 + 44 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
 if (!(i1 & 1)) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) {
  i1 = i3 + 28 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject8IsActiveEv(i2) | 0) __ZN15SharedLightData15UpdateTransformERK9Transform(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0);
 }
 __ZNK5Light16UnshareLightDataEv(i3);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i4 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i3);
 __ZN5Light10SetupFlareEv(i3);
 return;
}

function __ZN4FMOD6System13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869751;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869751;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869751;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN14MemoryProfiler18RegisterAllocationEPvRK10MemLabelIdPKcij(i1, i4, i5, i2, i3, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i5) | 0;
 if (!i1) return;
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i4 | 0) | 0;
 if (!i3) return;
 HEAP32[i3 >> 2] = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == 58) return;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 do if ((i2 | 0) > 3 & (i1 | 0) == 0) {
  i1 = HEAP32[gb + 1163244 >> 2] | 0;
  if (!i1) return; else {
   i1 = HEAP32[i1 >> 2] | 0;
   break;
  }
 } while (0);
 if (!i1) return;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i3 >> 2] = i1;
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i6;
 return;
}

function __ZN11AudioSource11SetPriorityEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = (i1 | 0) < 0 ? 0 : (i1 | 0) > 256 ? 256 : i1;
 i1 = i3 + 388 | 0;
 if ((i4 | 0) != (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i4;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance11setPriorityEi(i1, i4) | 0;
 }
 i1 = HEAP32[i3 + 432 >> 2] | 0;
 i3 = i3 + 428 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance11setPriorityEi(i1, i4) | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __Z37ComputeShader_CUSTOM_Internal_SetIntsP12Il2CppObjectiP11Il2CppArray(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i7 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = i4;
  __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i2, i5, i6 << 2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __Z37Avatar_CUSTOM_INTERNAL_CALL_GetZYRollP12Il2CppObjectiRK8Vector3fR11Quaternionf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK6Avatar9GetZYRollEiRK8Vector3f(i5, i6, i2, i3);
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  STACKTOP = i7;
  return;
 }
}

function __Z15Hash128ToStringjjjj(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 16 | 0;
 i6 = i8;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i5, 32, 0);
 i3 = i5 + 11 | 0;
 i1 = 0;
 do {
  if ((HEAP8[i3 >> 0] | 0) < 0) i2 = HEAP32[i5 >> 2] | 0; else i2 = i5;
  HEAP32[i7 >> 2] = HEAPU8[i6 + i1 >> 0];
  _snprintf(i2 + (i1 << 1) | 0, 3, gb + 488720 | 0, i7) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 STACKTOP = i8;
 return;
}

function __Z13RegisterClassIN2UI14CanvasRendererEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1107;
 HEAP32[i2 + 8 >> 2] = gb + 1011618;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 222;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 187020;
 HEAP32[i2 + 44 >> 2] = fb + 352;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 353;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9BehaviourEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 552;
 HEAP32[i2 + 8 >> 2] = gb + 391094;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 8;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29672;
 HEAP32[i2 + 44 >> 2] = fb + 37;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 38;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEjw(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i2 = i4 + 8 | 0;
 i7 = i2 + 3 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i2 = (HEAP32[i2 >> 2] & 2147483647) + -1 | 0; else i2 = 1;
 if (i2 >>> 0 < i5 >>> 0) {
  if (i3) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj(i4, i2, i5 - i2 | 0, i1, 0, i1, 0);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
 __ZNSt3__211char_traitsIwE6assignEPwjw(i1, i5, i6) | 0;
 HEAP32[i1 + (i5 << 2) >> 2] = 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i4 + 4 >> 2] = i5; else HEAP8[i7 >> 0] = i5;
 return i4 | 0;
}

function __ZNK11Rigidbody2D16GetRelativePointERK8Vector2f(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 } else {
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  f8 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f5 = Math_fround(f6 * f7);
  f4 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f5 = Math_fround(f5 - Math_fround(f8 * f4));
  f5 = Math_fround(Math_fround(HEAPF32[i1 + 12 >> 2]) + f5);
  f4 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f4));
  f4 = Math_fround(f4 + Math_fround(HEAPF32[i1 + 16 >> 2]));
  HEAPF32[i2 >> 2] = f5;
  HEAPF32[i2 + 4 >> 2] = f4;
  return;
 }
}

function __ZNK10FileSystem6DeleteEPKcb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i5 + 1040 | 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 __ZN15FileSystemEntry3SetEPKc(i5, i2);
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i5 | 0, i3 | 0) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i5 = i2;
  STACKTOP = i6;
  return i5 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i5 | 0);
 i5 = i2;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 40 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 40 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 40 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 40 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx2Sn5ConvX15getConcreteTypeEPKc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i3, gb + 827530 | 0, 1) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 if (!(__ZNK5physx2Sn9MetaClass14getFieldByTypeEPKcRNS0_15PxMetaDataEntryE(i3, gb + 754342 | 0, i2) | 0)) {
  i3 = -1;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = __ZN5physx2Sn4peekEiPKci(HEAP32[i2 + 12 >> 2] | 0, i1 + (HEAP32[i2 + 8 >> 2] | 0) | 0, 0) | 0;
 getTempRet0() | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb(i2, i5, i4, i7, i8, i9, i10, i3, i6, i1, i11) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 var i12 = 0, i13 = 0;
 i12 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i13 = i12;
 HEAP32[i13 >> 2] = gb + 85512 + 8;
 HEAP32[i13 + 4 >> 2] = i2;
 HEAP32[i13 + 8 >> 2] = i5;
 HEAP32[i13 + 12 >> 2] = i4;
 i11 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i5, i13, i3, i6, HEAP8[i1 >> 0] | 0, i7, i8, i9, i10, i11) | 0;
 STACKTOP = i12;
 return i11 | 0;
}

function __ZN5physx23PxVehicleWheels4SimData11setTireDataEjRKNS_17PxVehicleTireDataE(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, f6 = f0;
 i5 = i4 + 384 + (i3 << 6) | 0;
 i2 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 HEAPF32[i4 + 384 + (i3 << 6) + 44 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i4 + 384 + (i3 << 6) + 8 >> 2]));
 f6 = Math_fround(HEAPF32[i4 + 384 + (i3 << 6) + 24 >> 2]);
 HEAPF32[i4 + 384 + (i3 << 6) + 48 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(f6 - Math_fround(HEAPF32[i4 + 384 + (i3 << 6) + 16 >> 2])));
 HEAPF32[i4 + 384 + (i3 << 6) + 52 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(HEAPF32[i4 + 384 + (i3 << 6) + 32 >> 2]) - f6));
 return;
}

function __ZN5physx21solve1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i5, i4, i1, i2, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i5 >>> 0 > 1) {
  i1 = 1;
  do {
   i3 = i6 + (i1 + -1 << 5) | 0;
   __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i4);
   __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i3, 0, 0, 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 i6 = i6 + (i5 + -1 << 5) | 0;
 __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6, i4);
 __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i6, 0, 0, 0);
 return;
}

function __ZN2UI14CanvasRenderer14AttachToCanvasER8JobFencePNS_6CanvasENS0_15InstructionTypeE(i3, i1, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 if (!i4) return;
 i1 = i3 + 188 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i4 | 0)) __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i2, i3);
 HEAP32[i1 >> 2] = i4;
 __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE(0, (i5 | 0) == 0 ? i3 + 204 | 0 : i3 + 220 | 0, i4 + 112 | 0);
 HEAP32[i3 + 196 >> 2] = 0;
 HEAP32[i3 + 192 >> 2] = 0;
 i5 = i3 + 162 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 3071;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 >> 2] | 0, i3);
 return;
}

function __ZN11ShapeModule8TransferI17RemapPPtrTransferEEvRT_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = i4 + 44 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = i4 + 48 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 i2 = i4 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z41Animation_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i6 = HEAP32[gb + 1155204 + 4 >> 2] | 0;
  i5 = HEAP32[gb + 1155204 + 8 >> 2] | 0;
  i4 = HEAP32[gb + 1155204 + 12 >> 2] | 0;
  i1 = HEAP32[gb + 1155204 + 16 >> 2] | 0;
  i3 = HEAP32[gb + 1155204 + 20 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[gb + 1155204 >> 2];
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = i5;
  HEAP32[i2 + 12 >> 2] = i4;
  HEAP32[i2 + 16 >> 2] = i1;
  HEAP32[i2 + 20 >> 2] = i3;
  return;
 }
}

function __Z32LineRenderer_CUSTOM_GetPositionsP12Il2CppObjectP11Il2CppArray(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517787 | 0, i5);
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i4 = __ZNK12LineRenderer12GetPositionsEP8Vector3fj(i2, i1, i4) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z13RegisterClassI7TextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 568;
 HEAP32[i2 + 8 >> 2] = gb + 609266;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 27;
 HEAP32[i2 + 20 >> 2] = 80;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 26572;
 HEAP32[i2 + 44 >> 2] = fb + 50;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 51;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_runtime_preloadmanager_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163152 | 0, gb + 461136 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163164 | 0, gb + 461172 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163180 | 0, gb + 461209 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163192 | 0, gb + 461236 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163204 | 0, gb + 461269 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1163216 | 0, gb + 461312 | 0, 10, 0);
 return;
}

function __ZNK17Physics2DSettings23GetIgnoreLayerCollisionEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if ((i3 | 0) > 31 | ((i2 | 0) > 31 | (i3 | i2 | 0) < 0)) {
  HEAP32[i5 >> 2] = 31;
  __Z6FormatPKcz(i4, gb + 806509 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 805767 | 0, 427, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  i5 = (HEAP32[(HEAP32[i1 + 168 >> 2] | 0) + (i2 << 2) >> 2] & 1 << i3 | 0) == 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZN9Animation23VirtualRedirectTransferER17RemapPPtrTransfer(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i4, i1);
 i3 = i4 + 280 | 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i3 >> 2] = i2;
 i1 = HEAP32[i4 + 284 >> 2] | 0;
 i3 = HEAP32[i4 + 288 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx2Sc5Scene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE(i6, i1, i2, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 & 255;
 i3 = i6 + 1280 + (i4 << 2) | 0;
 i2 = i2 & 255;
 i1 = 1 << i2;
 if (Math_fround(HEAPF32[i5 >> 2]) != Math_fround(0.0)) i1 = HEAP32[i3 >> 2] | i1; else i1 = HEAP32[i3 >> 2] & ~i1;
 HEAP32[i3 >> 2] = i1;
 i2 = i6 + 1280 + (i2 << 2) | 0;
 i1 = 1 << i4;
 if (Math_fround(HEAPF32[i5 + 4 >> 2]) != Math_fround(0.0)) {
  i5 = HEAP32[i2 >> 2] | i1;
  HEAP32[i2 >> 2] = i5;
  i6 = i6 + 1188 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 | 2;
  HEAP32[i6 >> 2] = i5;
  return;
 } else {
  i5 = HEAP32[i2 >> 2] & ~i1;
  HEAP32[i2 >> 2] = i5;
  i6 = i6 + 1188 | 0;
  i5 = HEAP32[i6 >> 2] | 0;
  i5 = i5 | 2;
  HEAP32[i6 >> 2] = i5;
  return;
 }
}

function __ZN4FMOD6System14getDriverInfoWEiPsiP9FMOD_GUID(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869344;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869344;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869344;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN17ProfilerFrameData19FreeAllTimerQueriesEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1163260 >> 2] | 0;
 i1 = i2 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = 0;
  do {
   i3 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 664 >> 2] | 0, i3 | 0, HEAP32[(HEAP32[HEAP32[gb + 1163260 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
   i3 = HEAP32[gb + 1163260 >> 2] | 0;
   i1 = i3 + 12 | 0;
  } while (i2 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
  i2 = i3;
 }
 i3 = i2 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN16GeometryJobTasks19EndGeometryJobFrameER9GfxDevice(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if ((HEAP16[gb + 1157644 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1157644 | 0, i1);
  i2 = gb + 1157644 | 0;
 } else i2 = 0;
 i3 = i4 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i4, i5, i1);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN14VehiclesModule33ResetWheelQueriesTouchingColliderEP8Collider(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i2 + 36 >> 2] | 0;
 i2 = HEAP32[gb + 1458620 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = i2;
 if ((i1 | 0) == (i2 | 0)) return;
 i3 = i1 - i2 >> 3;
 i2 = 0;
 do {
  i4 = HEAP32[i8 + (i2 << 3) + 4 >> 2] | 0;
  if (i4 | 0) {
   i5 = HEAP32[i8 + (i2 << 3) >> 2] | 0;
   i1 = 0;
   do {
    i6 = i5 + (i1 * 148 | 0) + 36 | 0;
    if ((HEAP32[i6 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i5 + (i1 * 148 | 0) + 32 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP8[i5 + (i1 * 148 | 0) + 28 >> 0] = 1;
    }
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i4 | 0));
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return;
}

function __Z43UnityWebRequest_Get_Custom_PropResponseCodeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if (((HEAP32[i2 + 108 >> 2] | 0) + -3 | 0) >>> 0 >= 2) {
  i2 = -1;
  i3 = -1;
  setTempRet0(i2 | 0);
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) == (i1 | 0)) {
  i2 = 0;
  i3 = 0;
  setTempRet0(i2 | 0);
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + -28 >> 2] | 0;
 i2 = ((i3 | 0) < 0) << 31 >> 31;
 setTempRet0(i2 | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z42Material_CUSTOM_CopyPropertiesFromMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 | 0) if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0) {
  if (!i1) {
   i3 = 0;
   __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
  }
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
  if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
  __ZN8Material26CopyPropertiesFromMaterialERS_(i3, i1);
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 563527 | 0, 0, gb + 563359 | 0, 1124, 1, 0, 0, 0);
 return;
}

function __Z39ColorUtility_CUSTOM_DoTryParseHtmlColorP12Il2CppStringP16ColorRGBA32Icall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i4 = i3 + 12 | 0;
 i5 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i6, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i5, i6);
 i1 = __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32(i5, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP8[i2 >> 0] = i4;
 HEAP8[i2 + 1 >> 0] = i4 >> 8;
 HEAP8[i2 + 2 >> 0] = i4 >> 16;
 HEAP8[i2 + 3 >> 0] = i4 >> 24;
 STACKTOP = i3;
 return i1 & 1 | 0;
}

function __Z13RegisterClassI19CharacterControllerEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 842;
 HEAP32[i2 + 8 >> 2] = gb + 734401;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 143;
 HEAP32[i2 + 20 >> 2] = 160;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 111552;
 HEAP32[i2 + 44 >> 2] = fb + 207;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 208;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI16BaseVideoTextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 940;
 HEAP32[i2 + 8 >> 2] = gb + 874082;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 237;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 26532;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15AnchoredJoint2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32628;
 HEAP32[i2 + 4 >> 2] = fb + 860;
 HEAP32[i2 + 8 >> 2] = gb + 800658;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 229;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 152968;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK13AnimationClip17GetAnimationClipsEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i6;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i9, gb + 63664 | 0);
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = 1;
 i9 = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(0, 4, 4, i5, 0, gb + 1047584 | 0, 464) | 0;
 HEAP32[i2 >> 2] = i9;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i9 >> 2] = i1;
 STACKTOP = i6;
 return;
}

function __ZN6Shader20GetScreenClearShaderEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1166364 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 478044 | 0, 21);
 i2 = __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i1) | 0;
 HEAP32[gb + 1166364 >> 2] = i2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 i2 = HEAP32[gb + 1166364 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN4FMOD6System13getDriverInfoEiPciP9FMOD_GUID(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 861484;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 861484;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861484;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN2UI13CanvasManager34AlignCanvasRectTransformWithCameraEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i4 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((__ZNK2UI6Canvas13GetRenderModeEv(i1) | 0) == 1) {
   HEAP32[i5 >> 2] = 0;
   __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi(i1, i5);
   i3 = HEAP32[i5 >> 2] | 0;
   if (i3 | 0) __ZN9Transform20SendTransformChangedEi(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28980 | 0) | 0, i3);
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (HEAP32[i4 >> 2] | 0));
 STACKTOP = i6;
 return;
}

function __ZN11AudioSource5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 408 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 412 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 388 >> 2] = 128;
 HEAP8[i1 + 420 >> 0] = 0;
 HEAPF32[i1 + 404 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 392 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 396 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 400 >> 2] = Math_fround(500.0);
 i2 = i1 + 421 | 0;
 HEAP32[i1 + 416 >> 2] = 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 HEAP8[i2 + 4 >> 0] = 0;
 HEAP8[i2 + 5 >> 0] = 0;
 HEAP8[i2 + 6 >> 0] = 0;
 HEAP8[i1 + 497 >> 0] = 1;
 HEAP32[i1 + 368 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 192 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetRotationR9HPlayableR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  __ZN23AnimationOffsetPlayable11GetRotationEv(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i4;
  return;
 } else {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
  STACKTOP = i4;
  return;
 }
}

function __Z40AnimationState_CUSTOM_AddMixingTransformP12Il2CppObjectS0_h(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i6 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZN14AnimationState18AddMixingTransformER9Transformb(i2, i1, i5 << 24 >> 24 != 0);
  STACKTOP = i6;
  return;
 }
}

function __Z13RegisterClassI18PlatformEffector2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 885;
 HEAP32[i2 + 8 >> 2] = gb + 802207;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 251;
 HEAP32[i2 + 20 >> 2] = 92;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156664;
 HEAP32[i2 + 44 >> 2] = fb + 243;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 244;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17GlobalGameManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28608;
 HEAP32[i2 + 4 >> 2] = fb + 524;
 HEAP32[i2 + 8 >> 2] = gb + 368671;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 6;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28760;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14AudioBehaviourEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 923;
 HEAP32[i2 + 8 >> 2] = gb + 870338;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 180;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 175648;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK5physx7NpCloth25getVirtualParticleWeightsEPNS_6PxVec3E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore25getVirtualParticleWeightsEPNS_6PxVec3E(i1 + 32 | 0, i3);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 544, gb + 693542 | 0, i2);
  STACKTOP = i5;
  return;
 }
}

function __ZNK5Umbra18ImpOcclusionBuffer15dumpDebugBufferEPvRKNS_15OcclusionBuffer10BufferDescE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i2) {
  i4 = 4;
  return i4 | 0;
 }
 if ((HEAP32[i3 >> 2] | 0) != 64) {
  i4 = 1;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 4 >> 2] | 0) != 64) {
  i4 = 1;
  return i4 | 0;
 }
 if ((HEAP32[i3 + 8 >> 2] | 0) < (i4 << 3 & 2040 | 0)) {
  i4 = 2;
  return i4 | 0;
 }
 switch (i4 | 0) {
 case 8:
  {
   i4 = __ZNK5Umbra18ImpOcclusionBuffer8dump8bppEPhRKNS_15OcclusionBuffer10BufferDescE(i1, i2, i3) | 0;
   return i4 | 0;
  }
 case 288:
  {
   i4 = __ZNK5Umbra18ImpOcclusionBuffer9dumpFloatEPfRKNS_15OcclusionBuffer10BufferDescE(i1, i2, i3) | 0;
   return i4 | 0;
  }
 default:
  {
   i4 = 3;
   return i4 | 0;
  }
 }
 return 0;
}

function __ZN9Texture3D13RebuildMipMapEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) == 1) return;
 i2 = HEAP32[i1 + 96 >> 2] | 0;
 if (!i2) return;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 do if ((i3 + -10 | 0) >>> 0 >= 3) if (((i3 | 1) + -25 | 0) >>> 0 >= 5) {
  i4 = i3 + -30 | 0;
  if (i4 >>> 0 < 15) {
   if ((i3 + -48 | 0) >>> 0 < 12 | ((i3 + -45 | 0) >>> 0 < 3 | (30847 >>> (i4 & 65535) & 1) != 0)) break;
  } else if ((i3 + -45 | 0) >>> 0 < 3 | (i3 + -48 | 0) >>> 0 < 12) break;
  __Z12CreateMipMapPhiii13TextureFormat(i2, HEAP32[i1 + 80 >> 2] | 0, HEAP32[i1 + 84 >> 2] | 0, HEAP32[i1 + 88 >> 2] | 0, i3);
  return;
 } while (0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410623 | 0, 0, gb + 411375 | 0, 208, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN5physx7NpCloth23setSelfCollisionIndicesEPKjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore23setSelfCollisionIndicesEPKjj(i3 + 32 | 0, i1, i2);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 796, gb + 692786 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 * 20 | 0) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 * 20 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  HEAP32[i1 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
  i1 = i1 + 20 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 44 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = i1 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN16ParticleAnimator15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 768 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + (i1 * 12 | 0) >> 2] = fb + 440;
 STACKTOP = i5;
 return;
}

function __ZN16MessageForwarder17WillHandleMessageEPvRK17MessageIdentifier(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) < ((HEAP32[i1 + 4 >> 2] | 0) - i6 >> 2 | 0)) if (HEAP32[i6 + (i5 << 2) >> 2] | 0) {
  i6 = 1;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP32[i1 + 24 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (!(HEAP32[i3 + 16 >> 2] & 1)) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i6 = mftCall_iiii(HEAP32[i1 + 28 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN15ConstantForce2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i2);
 i1 = i2 + 48 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 52 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 56 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 60 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i5 = gb + 1162356 | 0;
  i3 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
 }
 i1 = i2 + 64 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13RenderTexture9SetHeightEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i1 + 84 >> 2] = i2;
  i3 = HEAP8[i1 + 116 >> 0] | 0;
  i5 = i1 + 76 | 0;
  HEAP32[i5 >> 2] = 1;
  i4 = HEAP32[i1 + 80 >> 2] | 0;
  if ((i4 | 0) == 0 | (i2 | 0) == 0) return;
  f6 = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
  HEAPF32[i1 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i4 | 0));
  HEAPF32[i1 + 72 >> 2] = f6;
  if (!(i3 << 24 >> 24)) i1 = 1; else i1 = __Z22CalculateMipMapCount3Diii(i4, i2, 1) | 0;
  HEAP32[i5 >> 2] = i1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407575 | 0, 0, gb + 406201 | 0, 921, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13AudioListener11FixedUpdateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  L3 : do if (!(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 67048 | 0) | 0)) {
   i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
   if (!i1) i1 = 2; else while (1) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    if (i2 | 0) if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0) {
     i1 = 1;
     break L3;
    }
    i1 = HEAP32[i1 + 100 >> 2] | 0;
    if (!i1) {
     i1 = 2;
     break;
    }
   }
  } else i1 = 1; while (0);
  HEAP32[i3 >> 2] = i1;
 }
 if ((i1 | 0) != 1) return;
 __ZN13AudioListener8DoUpdateEv(i4);
 return;
}

function __ZN12GUIClipState15LoadPixelMatrixEffffRK10Matrix4x4f(f1, f2, f3, f4, i5) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 64 | 0;
 i8 = i6;
 f2 = Math_fround(f2 - f1);
 f4 = Math_fround(f4 - f3);
 HEAPF32[i7 >> 2] = f1;
 HEAPF32[i7 + 8 >> 2] = f2;
 HEAPF32[i7 + 4 >> 2] = f3;
 HEAPF32[i7 + 12 >> 2] = f4;
 __Z15CalcPixelMatrixRK5RectTIfER10Matrix4x4f(i7, i8);
 i7 = __Z12GetGfxDevicev() | 0;
 __ZN10Matrix4x4fmLERKS_(i8, i5) | 0;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 116 >> 2] | 0, i7 | 0, i8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 112 >> 2] | 0, i7 | 0, gb + 1162292 | 0);
 STACKTOP = i6;
 return;
}

function __Z16SanitizeKeyEventR10InputEvent(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 & 2 | 0) HEAP16[i2 + 36 >> 1] = 0;
 if (i1 & 8 | 0) HEAP16[i2 + 36 >> 1] = 0;
 i4 = HEAP16[i2 + 38 >> 1] | 0;
 if ((i4 + -256 & 65535) < 17) {
  i1 = i1 & -65;
  HEAP32[i3 >> 2] = i1;
 }
 switch (i4 << 16 >> 16) {
 case 296:
 case 295:
 case 294:
 case 293:
 case 292:
 case 291:
 case 290:
 case 289:
 case 288:
 case 287:
 case 286:
 case 285:
 case 284:
 case 283:
 case 282:
 case 8:
 case 127:
 case 281:
 case 280:
 case 279:
 case 278:
 case 275:
 case 276:
 case 274:
 case 273:
  {
   HEAP32[i3 >> 2] = i1 | 64;
   HEAP16[i2 + 36 >> 1] = 0;
   return;
  }
 default:
  {}
 }
 i1 = i2 + 36 | 0;
 if ((HEAP16[i1 >> 1] | 0) != 13) return;
 HEAP16[i1 >> 1] = 10;
 return;
}

function __Z13RegisterClassIN2UI11CanvasGroupEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 1106;
 HEAP32[i2 + 8 >> 2] = gb + 1011545;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 225;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 186852;
 HEAP32[i2 + 44 >> 2] = fb + 350;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 351;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI16LevelGameManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28608;
 HEAP32[i2 + 4 >> 2] = fb + 525;
 HEAP32[i2 + 8 >> 2] = gb + 368654;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 3;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28456;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15EditorExtensionEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28304;
 HEAP32[i2 + 4 >> 2] = fb + 521;
 HEAP32[i2 + 8 >> 2] = gb + 369788;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 18;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 26492;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14DirectorPlayerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 551;
 HEAP32[i2 + 8 >> 2] = gb + 390244;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 320;
 HEAP32[i2 + 20 >> 2] = 40;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30072;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _h2v2_upsample(i3, i1, i10, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i9 = i3 + 276 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) return;
 i7 = i3 + 92 | 0;
 i5 = 0;
 i6 = 0;
 while (1) {
  i3 = HEAP32[i8 + (i6 << 2) >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
  i4 = i3 + i1 | 0;
  if ((i1 | 0) > 0) {
   i2 = HEAP32[i10 + (i5 << 2) >> 2] | 0;
   i1 = i3;
   while (1) {
    i3 = HEAP8[i2 >> 0] | 0;
    HEAP8[i1 >> 0] = i3;
    HEAP8[i1 + 1 >> 0] = i3;
    i1 = i1 + 2 | 0;
    if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 1 | 0;
   }
   i1 = HEAP32[i7 >> 2] | 0;
  }
  _jcopy_sample_rows(i8, i6, i8, i6 | 1, 1, i1);
  i6 = i6 + 2 | 0;
  if ((i6 | 0) >= (HEAP32[i9 >> 2] | 0)) break; else i5 = i5 + 1 | 0;
 }
 return;
}

function ___overflow(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 i8 = i5 & 255;
 HEAP8[i7 >> 0] = i8;
 i1 = i6 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) if (!(___towrite(i6) | 0)) {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = 4;
 } else i1 = -1; else i3 = 4;
 do if ((i3 | 0) == 4) {
  i4 = i6 + 20 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  if (i3 >>> 0 < i2 >>> 0) {
   i1 = i5 & 255;
   if ((i1 | 0) != (HEAP8[i6 + 75 >> 0] | 0)) {
    HEAP32[i4 >> 2] = i3 + 1;
    HEAP8[i3 >> 0] = i8;
    break;
   }
  }
  if ((mftCall_iiii(HEAP32[i6 + 36 >> 2] | 0, i6 | 0, i7 | 0, 1) | 0) == 1) i1 = HEAPU8[i7 >> 0] | 0; else i1 = -1;
 } while (0);
 STACKTOP = i9;
 return i1 | 0;
}

function ___nl_langinfo_l(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 & 65535;
 L1 : do if ((i2 | 0) == 14) i1 = gb + 1073753 | 0; else {
  switch (i2 >> 16 | 0) {
  case 1:
   {
    if (i3 >>> 0 > 1) {
     i1 = 0;
     break L1;
    } else i1 = gb + 1073750 | 0;
    break;
   }
  case 2:
   {
    if (i3 >>> 0 > 49) {
     i1 = 0;
     break L1;
    } else i1 = gb + 1073434 | 0;
    break;
   }
  case 4:
   return ((i3 | 0) == 0 ? gb + 1576256 | 0 : 0) | 0;
  case 5:
   {
    if (i3 >>> 0 > 3) {
     i1 = 0;
     break L1;
    } else i1 = gb + 1073415 | 0;
    break;
   }
  default:
   {
    i1 = 0;
    break L1;
   }
  }
  if (i3) do {
   do {
    i2 = i1;
    i1 = i1 + 1 | 0;
   } while ((HEAP8[i2 >> 0] | 0) != 0);
   i3 = i3 + -1 | 0;
  } while ((i3 | 0) != 0);
 } while (0);
 return i1 | 0;
}

function __ZN8keywords14GetKeywordNameEi(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[gb + 1166252 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i2 + 4 | 0)) {
  i6 = gb + 1576256 | 0;
  return i6 | 0;
 }
 i4 = i2 + 4 | 0;
 i2 = i3;
 while (1) {
  if ((HEAP32[i2 + 20 >> 2] | 0) == (i5 | 0)) break;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) while (1) {
   i2 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) break; else i1 = i2;
  } else {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 >> 2] | 0;
    if (!i2) {
     i2 = i1;
     break;
    } else i1 = i2;
   }
  }
  if ((i2 | 0) == (i4 | 0)) {
   i1 = gb + 1576256 | 0;
   i6 = 9;
   break;
  } else i1 = i2;
 }
 if ((i6 | 0) == 9) return i1 | 0;
 i6 = HEAP32[i2 + 16 >> 2] | 0;
 return i6 | 0;
}

function __ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i3 = i5 + 12 | 0;
 i6 = HEAP32[i3 >> 2] & 2147483647 ^ 2147483647;
 i6 = (Math_imul(i6 & 0 - i6, 125613361) | 0) >>> 27;
 i2 = HEAP32[gb + 90668 + (i6 << 2) >> 2] | 0;
 if (i6 & 30 | 0) {
  i6 = -1;
  i5 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
  return i6 | 0;
 }
 HEAP32[i5 + (i2 << 2) >> 2] = i4;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << i2;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 i6 = i2;
 i5 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i5);
 return i6 | 0;
}

function __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcRNS_21PxProfileNameProviderEj(i1, i4, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i8 = i5;
 mftCall_vii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i8 | 0, i3 | 0);
 i9 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 288, gb + 766896 | 0, gb + 740601 | 0, 138) | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i7 + 4 >> 2] = i8;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i3, i1, i4, i2, i6);
 STACKTOP = i5;
 return i3 + 116 | 0;
}

function __ZN5audio5mixer15FindEffectIndexERKNS0_18AudioMixerConstantERK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i7) {
  i7 = -1;
  return i7 | 0;
 }
 i6 = i1 + 20 | 0;
 i6 = (HEAP32[i6 >> 2] | 0) + i6 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i6 + (i1 << 4) >> 2] | 0) == (i3 | 0)) if ((HEAP32[i6 + (i1 << 4) + 4 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i6 + (i1 << 4) + 8 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i6 + (i1 << 4) + 12 >> 2] | 0) == (i2 | 0)) {
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = -1;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i5, i6, i1, i7, i8, i2, i3) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  if (i6 | 0) HEAP32[i6 >> 2] = 44100;
  if (i7 | 0) HEAP32[i7 >> 2] = 2;
  if (!i8) {
   i8 = 0;
   STACKTOP = i4;
   return i8 | 0;
  }
  HEAP32[i8 >> 2] = 2;
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 855079;
 _printf(gb + 853184 | 0, i3) | 0;
 i8 = 36;
 STACKTOP = i4;
 return i8 | 0;
}

function __ZN2UI13RectTransform5ResetEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0;
 __ZN9Transform5ResetEv(i1);
 f5 = Math_fround(HEAPF32[gb + 62472 >> 2]);
 f3 = Math_fround(f5 * Math_fround(.5));
 f4 = Math_fround(HEAPF32[gb + 62472 + 4 >> 2]);
 f2 = Math_fround(f4 * Math_fround(.5));
 HEAPF32[i1 + 136 >> 2] = f3;
 HEAPF32[i1 + 140 >> 2] = f2;
 HEAPF32[i1 + 144 >> 2] = f3;
 HEAPF32[i1 + 148 >> 2] = f2;
 i8 = gb + 1162356 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i1 + 152 | 0;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 f4 = Math_fround(f4 * Math_fround(100.0));
 HEAPF32[i1 + 160 >> 2] = Math_fround(f5 * Math_fround(100.0));
 HEAPF32[i1 + 164 >> 2] = f4;
 HEAPF32[i1 + 168 >> 2] = f3;
 HEAPF32[i1 + 172 >> 2] = f2;
 HEAP8[i1 + 177 >> 0] = 1;
 return;
}

function __ZN15ParticleEmitter15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 768 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 >>> 0 > 63) {
  __Z6FormatPKcz(i2, gb + 1048800 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1048853 | 0, 99, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] = 0;
 HEAP8[i3 + (i1 * 12 | 0) + 8 >> 0] = 0;
 HEAP32[i3 + (i1 * 12 | 0) >> 2] = fb + 441;
 STACKTOP = i5;
 return;
}

function __ZN14PreloadManager35WaitForAllAsyncOperationsToCompleteEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1163216 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1163216 | 0, i1);
  i1 = gb + 1163216 | 0;
 } else i1 = 0;
 i2 = i4 + 32 | 0;
 i3 = i4 + 12 | 0;
 while (1) {
  if (!(HEAP32[i3 >> 2] | 0)) if (!(HEAP32[i2 >> 2] | 0)) break;
  __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi(i4, 2, 2147483647) | 0;
 }
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN13MonoBehaviour19SetupScriptingCacheEP11Il2CppClassP10MonoScript(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 56 | 0;
 if (HEAP32[i4 >> 2] | 0) return;
 do if (!i3) if (!i2) {
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(0, 2, i1, 0) | 0;
  HEAP32[i4 >> 2] = i1;
  break;
 } else {
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i2, 2, i1, 0) | 0;
  HEAP32[i4 >> 2] = i1;
  break;
 } else {
  i2 = HEAPU8[i3 + 140 >> 0] | 0;
  i5 = __ZN10MonoScript8GetClassEv(i3) | 0;
  i1 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i5, i2, i1, HEAP32[i3 + 64 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
 } while (0);
 __ZNK15MonoScriptCache6RetainEv(i1);
 return;
}

function __Z22GetGfxDeviceLevelNamesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 if (!i2) {
  i2 = gb + 602665 | 0;
  STACKTOP = i3;
  return i2 | 0;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 606220 | 0, 13);
 i4 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 i2 = HEAP32[(i4 ? gb + 75764 | 0 : gb + 75812 | 0) + (i2 + -1 << 2) >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z14FindSceneRangeRK13dynamic_arrayI10SceneRangeLj4EERK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i7) {
  i8 = 0;
  return i8 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 * 28 | 0) >> 2] | 0) == (i5 | 0)) if ((HEAP32[i4 + (i1 * 28 | 0) + 4 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i4 + (i1 * 28 | 0) + 8 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i4 + (i1 * 28 | 0) + 12 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i7 | 0)) {
   i1 = 0;
   i8 = 9;
   break;
  }
 }
 if ((i8 | 0) == 9) return i1 | 0;
 i8 = i4 + (i1 * 28 | 0) | 0;
 return i8 | 0;
}

function __Z13RegisterClassI17PolygonCollider2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 878;
 HEAP32[i2 + 8 >> 2] = gb + 802541;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 60;
 HEAP32[i2 + 20 >> 2] = 172;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157088;
 HEAP32[i2 + 44 >> 2] = fb + 242;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 233;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_runtime_geometry_lump_cpp() {
 HEAP32[gb + 1155204 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[gb + 1155204 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[gb + 1155204 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[gb + 1155204 + 12 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[gb + 1155204 + 12 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[gb + 1155204 + 12 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155228 | 0, gb + 391503 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155240 | 0, gb + 391533 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1155252 | 0, gb + 391564 | 0, 0, 0);
 return;
}

function _fflush(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 do if (!i2) {
  if (!(HEAP32[gb + 191984 >> 2] | 0)) i1 = 0; else i1 = _fflush(HEAP32[gb + 191984 >> 2] | 0) | 0;
  ___lock(gb + 1469464 + 28 | 0);
  i2 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
  if (i2) do {
   if ((HEAP32[i2 + 76 >> 2] | 0) > -1) i3 = ___lockfile(i2) | 0; else i3 = 0;
   if ((HEAP32[i2 + 20 >> 2] | 0) >>> 0 > (HEAP32[i2 + 28 >> 2] | 0) >>> 0) i1 = ___fflush_unlocked(i2) | 0 | i1;
   if (i3 | 0) ___unlockfile(i2);
   i2 = HEAP32[i2 + 56 >> 2] | 0;
  } while ((i2 | 0) != 0);
  ___unlock(gb + 1469464 + 28 | 0);
 } else {
  if ((HEAP32[i2 + 76 >> 2] | 0) <= -1) {
   i1 = ___fflush_unlocked(i2) | 0;
   break;
  }
  i3 = (___lockfile(i2) | 0) == 0;
  i1 = ___fflush_unlocked(i2) | 0;
  if (!i3) ___unlockfile(i2);
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 12 | 0;
 i11 = i9 + 8 | 0;
 i14 = i9 + 4 | 0;
 i13 = i9;
 i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 i8 = mftCall_iiiiiiiii(i12 | 0, i1 | 0, i11 | 0, i10 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0, i14 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9 + 12 | 0;
 i11 = i9 + 8 | 0;
 i14 = i9 + 4 | 0;
 i13 = i9;
 i12 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i14 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i13 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i14 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 i8 = mftCall_iiiiiiiii(i12 | 0, i1 | 0, i11 | 0, i10 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx7NpCloth24setParticleAccelerationsEPKNS_6PxVec4E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore24setParticleAccelerationsEPKNS_6PxVec4E(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 320, gb + 696396 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx14NpRigidDynamic17setSleepThresholdEf(i6, f7) {
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i6 + 48 | 0;
 i3 = HEAP32[i6 + 52 >> 2] | 0;
 switch (i3 >>> 30 | 0) {
 case 3:
  {
   i4 = i5;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i5 >> 2] | 0) + 2433 >> 0] | 0)) i1 = 4; else i4 = i5;
   break;
  }
 default:
  i1 = 4;
 }
 if ((i1 | 0) == 4) {
  HEAPF32[i6 + 208 >> 2] = f7;
  return;
 }
 i2 = i6 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE(HEAP32[i4 >> 2] | 0, i3 >>> 24 & 15) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAPF32[i1 + 120 >> 2] = f7;
 __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(HEAP32[i4 >> 2] | 0, i5);
 i6 = i6 + 284 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 32;
 return;
}

function __ZN4FMOD6System15getPluginHandleE15FMOD_PLUGINTYPEiPj(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869540;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869540;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869540;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN22ParticleSystemRenderer19UpdateTransformInfoEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP16[i2 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = __ZN8Renderer12GetTransformEv(i2) | 0;
  HEAP32[i2 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i2 + 36 | 0);
  i1 = HEAP8[i2 + 273 >> 0] | 0;
 }
 if (i1 << 24 >> 24) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0);
 i1 = i2 + 164 | 0;
 i2 = i2 + 568 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 i6 = i3 + 16 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i7 = gb + 64016 | 0;
 i1 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 i2 = i6 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i2;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i3;
 return;
}

function __ZN18ProceduralMaterial15UpdateAnimationEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i1 + 264 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = i1 + 268 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f2 > f3)) if (!(Math_fround(Math_fround(Math_fround(i5 | 0) / Math_fround(1.0e3)) + f2) < f3)) {
  STACKTOP = i6;
  return;
 }
 HEAPF32[i1 >> 2] = f3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 432381 | 0, 5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i6;
 return;
}

function __ZN13UnityProfiler13GetDebugStatsER10DebugStats(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i8 = i1 + 4 | 0;
 HEAP32[i8 >> 2] = 0;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 i7 = i2 + 56 | 0;
 i2 = i1;
 if ((i2 | 0) == (i7 | 0)) return; else i6 = 0;
 do {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = HEAP32[i5 + 164 >> 2] | 0;
  i5 = i5 + 160 | 0;
  i4 = i3;
  if ((i4 | 0) == (i5 | 0)) i1 = 0; else {
   i1 = 0;
   do {
    i9 = i3;
    i1 = (HEAP32[i9 + 12 >> 2] | 0) + i1 - (HEAP32[i9 + 8 >> 2] | 0) | 0;
    i3 = HEAP32[i4 + 4 >> 2] | 0;
    i4 = i3;
   } while ((i4 | 0) != (i5 | 0));
  }
  i6 = i6 + i1 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i7 | 0));
 HEAP32[i8 >> 2] = i6;
 return;
}

function __ZN13TranslateGLES14InitObjectTypeERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = (HEAP8[i2 + 662 >> 0] | 0) != 0;
 HEAP32[i3 >> 2] = i2 ? 33504 : 37201;
 HEAP32[i3 + 4 >> 2] = i2 ? 33505 : 35656;
 HEAP32[i3 + 8 >> 2] = i2 ? 33506 : 35648;
 HEAP32[i3 + 12 >> 2] = i2 ? 32884 : 37204;
 HEAP32[i3 + 16 >> 2] = i2 ? 33507 : 37203;
 HEAP32[i3 + 20 >> 2] = 36386;
 HEAP32[i3 + 24 >> 2] = 33510;
 HEAP32[i3 + 28 >> 2] = 5890;
 HEAP32[i3 + 32 >> 2] = 36161;
 HEAP32[i3 + 36 >> 2] = 36160;
 i1 = i1 + 2336 | 0;
 i2 = i3;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __Z47TerrainData_CUSTOM_INTERNAL_set_wavingGrassTintP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = i3 + 128 | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 + 60 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 64 >> 2] = i6;
 HEAP32[i4 + 68 >> 2] = i5;
 HEAP32[i4 + 72 >> 2] = i3;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return;
}

function __Z13RegisterClassIN5Unity5JointEEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 849;
 HEAP32[i2 + 8 >> 2] = gb + 780838;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 57;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 112744;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassIN2UI13RectTransformEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28940;
 HEAP32[i2 + 4 >> 2] = fb + 563;
 HEAP32[i2 + 8 >> 2] = gb + 590196;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 224;
 HEAP32[i2 + 20 >> 2] = 180;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28980;
 HEAP32[i2 + 44 >> 2] = fb + 44;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 45;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI22ParticleSystemRendererEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 810;
 HEAP32[i2 + 8 >> 2] = gb + 621574;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 199;
 HEAP32[i2 + 20 >> 2] = 1036;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 80260;
 HEAP32[i2 + 44 >> 2] = fb + 199;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14AreaEffector2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 861;
 HEAP32[i2 + 8 >> 2] = gb + 800815;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 249;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 153356;
 HEAP32[i2 + 44 >> 2] = fb + 230;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 231;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11AudioFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 939;
 HEAP32[i2 + 8 >> 2] = gb + 853489;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 181;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170352;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _Direct_Move(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0;
 i1 = HEAP16[i2 + 298 >> 1] | 0;
 if (i1 << 16 >> 16) {
  i7 = _UNITY_FT_MulDiv(i5, i1 << 16 >> 16, HEAP32[i2 + 564 >> 2] | 0) | 0;
  i1 = i4 & 65535;
  i6 = (HEAP32[i3 + 16 >> 2] | 0) + (i1 << 3) | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i7;
  i1 = (HEAP32[i3 + 24 >> 2] | 0) + i1 | 0;
  HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | 8;
 }
 i1 = HEAP16[i2 + 300 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i5 = _UNITY_FT_MulDiv(i5, i1 << 16 >> 16, HEAP32[i2 + 564 >> 2] | 0) | 0;
 i7 = i4 & 65535;
 i6 = (HEAP32[i3 + 16 >> 2] | 0) + (i7 << 3) + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
 i7 = (HEAP32[i3 + 24 >> 2] | 0) + i7 | 0;
 HEAP8[i7 >> 0] = HEAPU8[i7 >> 0] | 0 | 16;
 return;
}

function __ZNSt3__28__c_node5__addEPNS_8__i_nodeE(i2, i7) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i2 + 16 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i6 = i2 + 20 | 0;
 if ((i1 | 0) == (HEAP32[i6 >> 2] | 0)) {
  i5 = i2 + 12 | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  i1 = i1 - i4 >> 1;
  i1 = (i1 | 0) == 0 ? 1 : i1;
  i3 = _malloc(i1 << 2) | 0;
  if (!i3) {
   i8 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i8);
   ___cxa_throw(i8 | 0, gb + 13048 | 0, fb + 3215 | 0);
  }
  if (i1 >>> 0 > 1) {
   i2 = i1 >>> 1;
   _memcpy(i3 | 0, i4 | 0, i2 << 2 | 0) | 0;
  } else i2 = 0;
  _free(i4);
  HEAP32[i5 >> 2] = i3;
  i5 = i3 + (i2 << 2) | 0;
  HEAP32[i8 >> 2] = i5;
  HEAP32[i6 >> 2] = i3 + (i1 << 2);
  i1 = i5;
 }
 HEAP32[i8 >> 2] = i1 + 4;
 HEAP32[i1 >> 2] = i7;
 return;
}

function __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 36 | 0;
 i4 = i2;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i1 + 100 | 0;
 i4 = i2 + 64 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i1 + 228 | 0;
 i4 = i2 + 128 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i5 = HEAP32[i2 + 192 >> 2] | 0;
 HEAP8[i1 + 1080 >> 0] = i5;
 HEAP8[i1 + 1081 >> 0] = (i5 & 65535) >>> 8;
 HEAP8[i1 + 1082 >> 0] = i5 >>> 16;
 HEAP32[i1 + 1076 >> 2] = 16843009;
 return;
}

function __ZN5physx16PxsFluidDynamicsC2ERNS_20PxsParticleSystemSimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 80 >> 2] = i1;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 i1 = i2 + 92 | 0;
 HEAP16[i2 + 96 >> 1] = -1;
 HEAP16[i2 + 98 >> 1] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 108 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 147584 + 8;
 HEAP32[i2 + 112 >> 2] = i2;
 HEAP32[i2 + 116 >> 2] = gb + 769839;
 i1 = i2 + 120 | 0;
 HEAP16[i2 + 124 >> 1] = -1;
 HEAP16[i2 + 126 >> 1] = 0;
 HEAP32[i2 + 128 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i2 + 132 >> 2] = 0;
 HEAP32[i2 + 136 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 147628 + 8;
 HEAP32[i2 + 140 >> 2] = i2;
 HEAP32[i2 + 144 >> 2] = gb + 769869;
 HEAP32[i2 + 156 >> 2] = 0;
 return;
}

function __ZN5physx14PxVehicleGraph10setChannelERNS_25PxVehicleGraphChannelDescEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 48 + (i1 << 2) >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 96 + (i1 << 2) >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 144 + (i1 * 12 | 0) >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 144 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 144 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 288 + (i1 * 12 | 0) >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 288 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i3 + 288 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + 32 >> 2];
 _strncpy(i3 + 432 + (i1 << 8) | 0, HEAP32[i2 + 36 >> 2] | 0, 256) | 0;
 HEAP8[i3 + 432 + (i1 << 8) + 255 >> 0] = 0;
 return;
}

function __ZN5Unity5Cloth20ClearTransformMotionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 12 | 0;
 i3 = i6;
 i4 = __ZN19SkinnedMeshRenderer17GetActualRootBoneEv(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 31632 | 0) | 0) | 0;
 __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf(i4, i2 + 16 | 0, i2);
 i5 = HEAP32[i1 + 228 >> 2] | 0;
 if (i5 | 0) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 120 >> 2] | 0, i5 | 0, i2 | 0);
 i5 = i1 + 360 | 0;
 __ZNK9Transform11GetPositionEv(i3, i4);
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN15b2MotorJointDef10InitializeEP6b2BodyS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f6 = Math_fround(HEAPF32[i3 + 16 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 12 >> 2]));
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 16 >> 2]));
 f8 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f7 = Math_fround(f4 * f8);
 f5 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f4 = Math_fround(Math_fround(f8 * f6) - Math_fround(f4 * f5));
 HEAPF32[i1 + 20 >> 2] = Math_fround(f7 + Math_fround(f6 * f5));
 HEAPF32[i1 + 24 >> 2] = f4;
 f4 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 HEAPF32[i1 + 28 >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 56 >> 2]) - f4);
 return;
}

function __ZL31FindActiveTransformWithPathImplPKcR10GameObjectb(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0) | 0;
 i2 = _strlen(i3) | 0;
 if (_strncmp(i3, i1, i2) | 0) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = i1 + i2 | 0;
 i3 = (HEAP8[i3 >> 0] | 0) == 47 ? i3 + 1 | 0 : i3;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i4, gb + 28940 | 0) | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 if (i5) if (HEAP32[i2 + 100 >> 2] | 0) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP8[i3 >> 0] | 0)) {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i5 = i2;
   return i5 | 0;
  }
 }
 i5 = __Z29FindRelativeTransformWithPathR9TransformPKcb(i2, i3, 1) | 0;
 return i5 | 0;
}

function __Z21RegisterVRDeviceDebugv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 1344 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i4 = i1 + 668 | 0;
 i3 = __Z18GetUnityInterfacesv() | 0;
 _memset(i4 | 0, 0, 668) | 0;
 _strncpy(i4, gb + 1046439 | 0, 64) | 0;
 _strncpy(i4 + 64 | 0, gb + 1046445 | 0, 64) | 0;
 HEAP8[i4 + 260 >> 0] = 1;
 HEAP32[i4 + 264 >> 2] = fb + 2768;
 HEAP32[i4 + 268 >> 2] = fb + 310;
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = 586239589;
 HEAP32[i5 + 4 >> 2] = 1008725759;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = 426257907;
 HEAP32[i5 + 4 >> 2] = -2134066609;
 i3 = HEAP32[(mftCall_ii(i3 | 0, i2 | 0) | 0) >> 2] | 0;
 _memcpy(i2 | 0, i4 | 0, 668) | 0;
 mftCall_vi(i3 | 0, i2 | 0);
 STACKTOP = i1;
 return gb + 1046439 | 0;
}

function __Z13RegisterClassI11NamedObjectEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26492;
 HEAP32[i2 + 4 >> 2] = fb + 527;
 HEAP32[i2 + 8 >> 2] = gb + 370829;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 130;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28068;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10Effector2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 870;
 HEAP32[i2 + 8 >> 2] = gb + 800893;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 248;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 153580;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _tt_name_entry_ascii_from_other(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = HEAP16[i1 + 8 >> 1] | 0;
 i4 = i1 & 65535;
 i5 = _UNITY_ft_mem_realloc(i2, 1, 0, i4 + 1 | 0, 0, i7) | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 L4 : do if (!(i1 << 16 >> 16)) i1 = 0; else {
  i1 = 0;
  while (1) {
   i2 = HEAP8[i3 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L4;
   HEAP8[i5 + i1 >> 0] = (i2 & 255) < 32 | i2 << 24 >> 24 < 0 ? 63 : i2;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 < i4 >>> 0) i3 = i3 + 1 | 0; else break;
  }
 } while (0);
 HEAP8[i5 + i1 >> 0] = 0;
 i7 = i5;
 STACKTOP = i6;
 return i7 | 0;
}

function ___remdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i8 = i5 | 0;
 i7 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i6 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i10 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i9 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i1 = _i64Subtract(i7 ^ i1 | 0, i6 ^ i2 | 0, i7 | 0, i6 | 0) | 0;
 i2 = getTempRet0() | 0;
 ___udivmoddi4(i1, i2, _i64Subtract(i10 ^ i3 | 0, i9 ^ i4 | 0, i10 | 0, i9 | 0) | 0, getTempRet0() | 0, i8) | 0;
 i4 = _i64Subtract(HEAP32[i8 >> 2] ^ i7 | 0, HEAP32[i8 + 4 >> 2] ^ i6 | 0, i7 | 0, i6 | 0) | 0;
 i3 = getTempRet0() | 0;
 STACKTOP = i5;
 return (setTempRet0(i3 | 0), i4) | 0;
}

function __ZNK5physx7NpCloth23getNbCollisionTrianglesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore23getNbCollisionTrianglesEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 434, gb + 694035 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, f5 = f0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP32[i2 + 40 >> 2] | 0)) return;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(.100000001));
 f4 = Math_fround(f4 * f4);
 f4 = Math_fround(f4 * Math_fround(f4 * f4));
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i2 + 120 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 84 >> 2]) * Math_fround(f5 * Math_fround(Math_fround(45.0) / Math_fround(f4 * Math_fround(3.14159274)))));
 if (!(HEAP32[i3 + 20 >> 2] & 65536)) return;
 __ZN5physx16PxsFluidDynamics9updateSphERNS_10PxBaseTaskE(i2 + 80 | 0, i1);
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper13addNamedValueEPKcj(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 i1 = i4 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 80 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i6 = i3;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = (HEAP32[i4 + 72 >> 2] | 0) + (i2 << 3) | 0;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  STACKTOP = i5;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_(i4 + 60 | 0, i3) | 0;
  STACKTOP = i5;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher37PrepareSessionContainerForDispatchingERNS0_16SessionContainerE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i3 + 52 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i4 + 88 >> 0] = 1;
 HEAP8[i4 + 90 >> 0] = 1;
 i1 = i3 + 128 | 0;
 HEAP32[i1 >> 2] = i4;
 if (__ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE(i3, i4) | 0) {
  i4 = 1;
  return i4 | 0;
 }
 __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i4, i4 + 16 | 0) | 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i4);
 HEAP32[i1 >> 2] = 0;
 HEAP8[i2 >> 0] = 1;
 i4 = 0;
 return i4 | 0;
}

function __ZN10Effector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 i3 = i1 + 56 | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 24 | 0;
 if ((i4 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i3, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i2);
 i1 = i1 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 4);
  return;
 }
}

function __Z13RegisterClassI14ParticleSystemEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 809;
 HEAP32[i2 + 8 >> 2] = gb + 618922;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 198;
 HEAP32[i2 + 20 >> 2] = 948;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 80300;
 HEAP32[i2 + 44 >> 2] = fb + 197;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 198;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13WheelColliderEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 901;
 HEAP32[i2 + 8 >> 2] = gb + 827168;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 146;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 159176;
 HEAP32[i2 + 44 >> 2] = fb + 249;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 250;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10GUIElementEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 547;
 HEAP32[i2 + 8 >> 2] = gb + 385776;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 133;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30232;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 11 | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i4 = i2 & 255;
  i2 = 10;
 }
 if ((i4 | 0) == (i2 | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i1, i2, 1, i2, i2, 0, 0);
  if ((HEAP8[i5 >> 0] | 0) > -1) i2 = 7; else i2 = 8;
 } else if (i3) i2 = 8; else i2 = 7;
 if ((i2 | 0) == 7) HEAP8[i5 >> 0] = i4 + 1; else if ((i2 | 0) == 8) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = i4 + 1;
  i1 = i5;
 }
 i5 = i1 + i4 | 0;
 HEAP8[i5 >> 0] = i6;
 HEAP8[i5 + 1 >> 0] = 0;
 return;
}

function __ZN8Collider9GetBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i4) {
  __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  i4 = i1 + 12 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i5;
  return;
 } else {
  __Z19getShapeWorldBoundsRKN5physx7PxShapeE(i1, i4);
  STACKTOP = i5;
  return;
 }
}

function __ZN8Animator17ApplyOnAnimatorIKEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 100 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 4;
 if (HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 60 >> 2] & 128 | 0) {
  HEAP32[i3 >> 2] = gb + 29192;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = i2;
  __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105476 | 0, i3);
 }
 i3 = __Z24SetExecutionRestrictions21ExecutionRestrictions(1) | 0;
 __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE(i1, 16) | 0;
 __Z24SetExecutionRestrictions21ExecutionRestrictions(i3) | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -5;
 STACKTOP = i5;
 return;
}

function __ZN5physx3Cct17CapsuleController9setHeightEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAPF32[i3 + 500 >> 2] = f2;
 if (!(HEAP32[i3 + 408 >> 2] | 0)) {
  STACKTOP = i4;
  return 1;
 }
 i5 = __ZNK5physx3Cct10Controller12getKineShapeEv(i3 + 8 | 0) | 0;
 HEAP32[i1 >> 2] = 2;
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 i6 = i1 + 8 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(f2 * Math_fround(.5)) * Math_fround(HEAPF32[i3 + 488 >> 2]));
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i1 | 0);
 STACKTOP = i4;
 return 1;
}

function __ZN5physx2Sn18RecursiveTraversal8traverseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0);
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0)) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 48 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(i2 | 0, i3 | 0);
  return;
 }
 do {
  __ZN5physx2Sn18RecursiveTraversal8traverseEv(i2);
  i3 = HEAP32[i1 >> 2] | 0;
 } while (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = i2 + 48 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(i2 | 0, i3 | 0);
 return;
}

function __ZN25ThreadsafeLinearAllocator10ReallocateEPvji(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i5 >> 2] = i4;
 i6 = i3 + -12 | 0;
 if ((HEAP32[i6 >> 2] | 0) >>> 0 >= i4 >>> 0) if ((i3 + -1 + i1 & 0 - i1 | 0) == (i3 | 0)) {
  i6 = i3;
  STACKTOP = i7;
  return i6 | 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, i1 | 0) | 0;
 if (!i1) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 _memcpy(i1 | 0, i3 | 0, HEAP32[((HEAP32[i6 >> 2] | 0) >>> 0 > i4 >>> 0 ? i5 : i6) >> 2] | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0);
 i6 = i1;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17AudioChorusFilter6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 __ZN4FMOD3DSP12setParameterEif(i3, 0, Math_fround(HEAPF32[i1 + 44 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 1, Math_fround(HEAPF32[i1 + 48 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 2, Math_fround(HEAPF32[i1 + 52 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 3, Math_fround(HEAPF32[i1 + 56 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 4, Math_fround(HEAPF32[i1 + 60 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 5, Math_fround(HEAPF32[i1 + 64 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 6, Math_fround(HEAPF32[i1 + 68 >> 2])) | 0;
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE16StaticInitializeES8_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __Z54AnimatorControllerPlayable_CUSTOM_GetLayerNameInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  __ZN26AnimatorControllerPlayable12GetLayerNameEi(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2);
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i3 >> 2] | 0 : i3, i1 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i3 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z30RegisterModuleClasses_Vehiclesv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 901;
 HEAP32[i2 + 8 >> 2] = gb + 827168;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 146;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 159176;
 HEAP32[i2 + 44 >> 2] = fb + 249;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 250;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z28GetNonInterpolatedLightProbeRK17LightProbeContextjR20SphericalHarmonicsL2(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i8 = i5 + 124 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if (!i1) i3 = 0; else i3 = (HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i6 >>> 0;
 i1 = HEAP32[i5 + 116 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i6 >>> 0) {
  i4 = i7;
  i1 = (HEAP32[i1 >> 2] | 0) + (i6 * 108 | 0) | 0;
  i2 = i4 + 108 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
 } else __ZN20SphericalHarmonicsL27SetZeroEv(i7);
 if (!i3) return;
 __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i7, (HEAP32[HEAP32[i8 >> 2] >> 2] | 0) + (i6 * 108 | 0) | 0, Math_fround(HEAPF32[i5 + 108 >> 2]));
 return;
}

function __Z24GetAudioEffectDefinitionPKcPP29AudioEffectInternalDefinitioni(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i4 = __Z25GetAudioEffectDefinitionsPi(i3) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
 } else {
  i4 = i1;
  i3 = i2;
 }
 if ((i3 | 0) > 0) i2 = 0; else {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 while (1) {
  i1 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  i2 = i2 + 1 | 0;
  if (!(_strcmp((HEAP32[i1 >> 2] | 0) + 128 | 0, i5) | 0)) {
   i2 = 6;
   break;
  }
  if ((i2 | 0) >= (i3 | 0)) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __Z13RegisterClassI15ReflectionProbeEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 544;
 HEAP32[i2 + 8 >> 2] = gb + 380928;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 215;
 HEAP32[i2 + 20 >> 2] = 180;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31272;
 HEAP32[i2 + 44 >> 2] = fb + 27;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 28;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13MonoBehaviourEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 693;
 HEAP32[i2 + 8 >> 2] = gb + 590111;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 114;
 HEAP32[i2 + 20 >> 2] = 148;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 27592;
 HEAP32[i2 + 44 >> 2] = fb + 179;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 180;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11GameManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28304;
 HEAP32[i2 + 4 >> 2] = fb + 523;
 HEAP32[i2 + 8 >> 2] = gb + 369804;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 9;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28608;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212future_errorC2ENS_10error_codeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZNKSt3__210error_code7messageEv(i3, i2);
 __THREW__ = 0;
 invoke_vii(fb + 4500 | 0, i1 | 0, i3 | 0);
 i5 = __THREW__;
 __THREW__ = 0;
 if (i5 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  ___resumeException(i5 | 0);
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  HEAP32[i1 >> 2] = gb + 208152 + 8;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i1 + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __ZNK9GfxDevice19GetTotalBufferBytesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i5 + 4516 >> 2] | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) i6 = 0; else {
  i1 = 0;
  do {
   i3 = (i2 | 0) == 0 ? 0 : i2 + -4 | 0;
   if (!(HEAP32[i3 + 20 >> 2] | 0)) i1 = (HEAP32[i3 + 24 >> 2] | 0) + i1 | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  } while ((i2 | 0) != (i4 | 0));
  i6 = i1;
 }
 i4 = HEAP32[i5 + 4520 >> 2] | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i5 = 0;
  i6 = i5 + i6 | 0;
  return i6 | 0;
 } else i1 = 0;
 do {
  i3 = (i2 | 0) == 0 ? 0 : i2 + -4 | 0;
  if (!(HEAP32[i3 + 20 >> 2] | 0)) i1 = (HEAP32[i3 + 24 >> 2] | 0) + i1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i4 | 0));
 i6 = i1 + i6 | 0;
 return i6 | 0;
}

function __ZNK5physx7NpCloth22getNbCollisionConvexesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore22getNbCollisionConvexesEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 491, gb + 694366 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx7NpCloth22getNbCollisionCapsulesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore22getNbCollisionCapsulesEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 402, gb + 694929 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN4FMOD6System14createGeometryEiiPPNS_8GeometryE(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869222;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869222;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869222;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD6System12loadGeometryEPKviPPNS_8GeometryE(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869696;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869696;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869696;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN25PathNamePersistentManagerD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 66936 + 8;
 i3 = i5 + 208 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 212 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i6 = i2 + -12 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i5 + 196 | 0, HEAP32[i5 + 200 >> 2] | 0);
 __ZN17PersistentManagerD2Ev(i5);
 return;
}

function __ZN14PhysicsManager18GetIgnoreCollisionEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if ((i3 | 0) > 31 | ((i2 | 0) > 31 | (i3 | i2 | 0) < 0)) {
  HEAP32[i5 >> 2] = 31;
  __Z6FormatPKcz(i4, gb + 662636 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 662472 | 0, 1440, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  i5 = (HEAP32[(HEAP32[i1 + 724 >> 2] | 0) + (i2 << 2) >> 2] & 1 << i3 | 0) == 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __ZN13SliderJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(124, i1, 16, gb + 1048932 | 0, 0, gb + 807334 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 157460 + 8;
 HEAP8[i4 + 119 >> 0] = 0;
 HEAPF32[i4 + 120 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13MonoBehaviour14SetByPassOnDSPEb(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = __Z9GetIAudiov() | 0;
 if (!i6) return;
 i4 = __Z9GetIAudiov() | 0;
 if (!i4) return;
 i3 = i2 + 144 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  if (!i1) return;
  if (!(HEAP32[i1 + 144 >> 2] | 0)) return;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i1) return;
  if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   break;
  } else return;
 } while (0);
 i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 60 >> 2] | 0, i6 | 0, i1 | 0, i5 | 0);
 return;
}

function __ZN13AudioListener6UpdateEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 60 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i4 + 28 >> 2] | 0;
  L3 : do if (!(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 67048 | 0) | 0)) {
   i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
   if (!i1) i1 = 2; else while (1) {
    i2 = HEAP32[i1 + 28 >> 2] | 0;
    if (i2 | 0) if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0) {
     i1 = 1;
     break L3;
    }
    i1 = HEAP32[i1 + 100 >> 2] | 0;
    if (!i1) {
     i1 = 2;
     break;
    }
   }
  } else i1 = 1; while (0);
  HEAP32[i3 >> 2] = i1;
 }
 if ((i1 | 0) != 2) return;
 __ZN13AudioListener8DoUpdateEv(i4);
 return;
}

function __ZN12TreeDatabase7SetTreeEiRK12TreeInstance(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = i6 + (i2 * 40 | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i6 + (i2 * 40 | 0) + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i6 + (i2 * 40 | 0) + 28 >> 2] = HEAP32[i3 + 28 >> 2];
 i5 = i3 + 32 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i6 + (i2 * 40 | 0) + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN11TerrainData24NotifyUsersOnTreeUpdatedEi(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function __ZN12MeshCollider17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 76 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i3 + 88 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN8Collider17MainThreadCleanupEv(i3);
  return;
 }
 i4 = i3 + 100 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Collider17MainThreadCleanupEv(i3);
 return;
}

function __Z54TerrainData_CUSTOM_INTERNAL_CALL_GetInterpolatedNormalP12Il2CppObjectffR8Vector3f(i1, f2, f3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK9Heightmap21GetInterpolatedNormalEff(i5, i6 + 248 | 0, f2, f3);
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  STACKTOP = i7;
  return;
 }
}

function __Z26DestroyGameObjectHierarchyR10GameObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 1032 | 0;
 i4 = i5;
 __ZN10GameObject10DeactivateE19DeactivateOperation(i3, 2);
 HEAP32[i1 >> 2] = 0;
 __ZL19PreDestroyRecursiveR10GameObjectPj(i3, i1);
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 28940 | 0) | 0;
 if (i2 | 0) __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = i1 >>> 0 > 256 ? 256 : i1;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete(i3, i4);
 __Z17CommitBatchDeleteR11BatchDelete(i4);
 STACKTOP = i5;
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, gb + 1034406 | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i3, i2, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i3, i2 + 12 | 0, gb + 1034420 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18ConvertUTF16toUTF8PKtiRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i8 = i4;
 i7 = i2 << 2;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i3, i7, 0);
 i5 = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i8 >> 2] = i1;
 i2 = (__Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags(i8, i1 + (i2 << 1) | 0, i6, i5 + i7 | 0, 1) | 0) == 3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i3, i2 ? 0 : (HEAP32[i6 >> 2] | 0) - i5 | 0, 0);
 STACKTOP = i4;
 return i2 ^ 1 | 0;
}

function __Z13RegisterClassIN2UI6CanvasEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 1105;
 HEAP32[i2 + 8 >> 2] = gb + 1012675;
 HEAP32[i2 + 12 >> 2] = gb + 1012713;
 HEAP32[i2 + 16 >> 2] = 223;
 HEAP32[i2 + 20 >> 2] = 444;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67128;
 HEAP32[i2 + 44 >> 2] = fb + 348;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 349;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14SpriteRendererEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 582;
 HEAP32[i2 + 8 >> 2] = gb + 429490;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 212;
 HEAP32[i2 + 20 >> 2] = 380;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31792;
 HEAP32[i2 + 44 >> 2] = fb + 65;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 66;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12MeshColliderEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 850;
 HEAP32[i2 + 8 >> 2] = gb + 737071;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 64;
 HEAP32[i2 + 20 >> 2] = 132;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 112968;
 HEAP32[i2 + 44 >> 2] = fb + 213;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 214;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_runtime_ai_internal_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459200 | 0, gb + 843083 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459212 | 0, gb + 843098 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459224 | 0, gb + 843128 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459236 | 0, gb + 843162 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459248 | 0, gb + 843199 | 0, 5, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459260 | 0, gb + 843231 | 0, 5, 0);
 return;
}

function __ZNKSt3__223__match_any_but_newlineIwE6__execERNS_7__stateIwEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 do if ((i5 | 0) == (HEAP32[i3 + 12 >> 2] | 0)) {
  HEAP32[i3 >> 2] = -993;
  HEAP32[i3 + 40 >> 2] = 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) < 8232) switch (i1 | 0) {
  case 10:
  case 13:
   {
    i1 = 3;
    break;
   }
  default:
   i1 = 4;
  } else switch (i1 | 0) {
  case 8233:
  case 8232:
   {
    i1 = 3;
    break;
   }
  default:
   i1 = 4;
  }
  if ((i1 | 0) == 3) {
   HEAP32[i3 >> 2] = -993;
   HEAP32[i3 + 40 >> 2] = 0;
   break;
  } else if ((i1 | 0) == 4) {
   HEAP32[i3 >> 2] = -995;
   HEAP32[i4 >> 2] = i5 + 4;
   HEAP32[i3 + 40 >> 2] = HEAP32[i2 + 4 >> 2];
   break;
  }
 } while (0);
 return;
}

function __ZNK5Unity10HingeJoint16GetClampedLimitsERfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f5 = Math_fround(-f4);
 i6 = f4 > Math_fround(177.0);
 i7 = f5 > Math_fround(177.0);
 f5 = Math_fround(Math_fround(Math_fround((i7 ? Math_fround(177.0) : f5) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i2 >> 2] = i6 ? Math_fround(-3.08923292) : f5;
 f5 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f4 = Math_fround(-f5);
 i2 = f5 > Math_fround(177.0);
 i1 = f4 > Math_fround(177.0);
 f4 = Math_fround(Math_fround(Math_fround((i1 ? Math_fround(177.0) : f4) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 HEAPF32[i3 >> 2] = i2 ? Math_fround(-3.08923292) : f4;
 return;
}

function __ZNK2UI13RectTransform23CalculateLocalPosition3Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i6, i2);
 f7 = Math_fround(HEAPF32[i6 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 f5 = Math_fround(f7 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 168 >> 2])));
 f7 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i6 + 12 >> 2]);
 f4 = Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 172 >> 2])));
 __ZNK9Transform16GetLocalPositionEv(i6, i2);
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN7mecanim12statemachine26EvaluateSelectorTransitionEPKNS0_26SelectorTransitionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = i1 + 4 | 0;
 if (!(HEAP32[i6 >> 2] | 0)) {
  i6 = 1;
  return i6 | 0;
 }
 i2 = i1 + 8 | 0;
 i3 = i2;
 i1 = 0;
 while (1) {
  i8 = (HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) | 0;
  i7 = HEAP32[i8 >> 2] | 0;
  i1 = i1 + 1 | 0;
  if (!(__ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE((i7 | 0) == 0 ? 0 : i8 + i7 | 0, i4, i5) | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  if (i1 >>> 0 >= (HEAP32[i6 >> 2] | 0) >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround((i3 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround((i3 >>> 16 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(i3 >>> 24 >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 12 >> 2] = Math_fround(Math_fround((i3 & 255) >>> 0) * Math_fround(.00392156886));
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround((i3 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround((i3 >>> 16 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 12 >> 2] = Math_fround(Math_fround(i3 >>> 24 >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 >> 2] = Math_fround(Math_fround((i3 & 255) >>> 0) * Math_fround(.00392156886));
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 4) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu3EPA14expandTriangleERiRKNS_6shdfnd3aos6FloatVES7_(i5, i1, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 3;
 i2 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i5, 0, 1, 2, i3, i4) | 0;
 i1 = __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_(i5, 1, 0, 2, i3, i4) | 0;
 if ((i2 | 0) == 0 | (i1 | 0) == 0) return 0;
 if (!(HEAP32[i5 >> 2] | 0)) return 0; else {
  HEAP32[i2 + 20 >> 2] = i1;
  HEAP8[i2 + 32 >> 0] = 0;
  HEAP32[i1 + 20 >> 2] = i2;
  HEAP8[i1 + 32 >> 0] = 0;
  HEAP32[i2 + 24 >> 2] = i1;
  HEAP8[i2 + 33 >> 0] = 2;
  HEAP32[i1 + 28 >> 2] = i2;
  HEAP8[i1 + 34 >> 0] = 1;
  HEAP32[i2 + 28 >> 2] = i1;
  HEAP8[i2 + 34 >> 0] = 1;
  HEAP32[i1 + 24 >> 2] = i2;
  HEAP8[i1 + 33 >> 0] = 2;
  return 1;
 }
 return 0;
}

function __ZN16ScriptingManager43AddOutOfHierarchyNativeTypeToScriptingClassEPKN5Unity4TypeEP11Il2CppClass(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i3 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i3 + 208 >> 2] | 0)) __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_(i3 + 200 | 0, i4); else {
  i6 = i4;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
 }
 STACKTOP = i5;
 return;
}

function __Z53AnimatorControllerPlayable_CUSTOM_ResolveHashInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  __ZN26AnimatorControllerPlayable11ResolveHashEi(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2);
  i2 = HEAP8[i3 + 11 >> 0] | 0;
  i1 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i3 >> 2] | 0 : i3, i1 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i3 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z23translateToBufferTargetN14DataBufferGLES11BufferUsageE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
 case 1:
 case 0:
  {
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0) {
    i1 = 1;
    return i1 | 0;
   }
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   return i1 | 0;
  }
 case 6:
 case 5:
 case 4:
  {
   if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0) {
    i1 = 0;
    return i1 | 0;
   }
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 0 : 2;
   return i1 | 0;
  }
 case 10:
 case 9:
 case 3:
 case 8:
 case 7:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 693 >> 0] | 0) == 0;
   i1 = i1 ? 1 : 2;
   return i1 | 0;
  }
 default:
  {
   i1 = -559030611;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK6Camera22GetWorldToCameraMatrixEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 36 | 0;
 i4 = i1 + 1076 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 if (!(HEAP8[i1 + 1080 >> 0] | 0)) {
  STACKTOP = i5;
  return i3 | 0;
 }
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i3, i2) | 0;
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN10Matrix4x4fmLERKS_(i3, i2) | 0;
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return i3 | 0;
}

function __ZNK5physx7NpCloth21getNbVirtualParticlesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore21getNbVirtualParticlesEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 512, gb + 693796 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx7NpCloth21getNbCollisionSpheresEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore21getNbCollisionSpheresEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 367, gb + 695175 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK2UI6Canvas19GetSortingLayerNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = __Z13GetTagManagerv() | 0;
 __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi(i3, i5, HEAP32[i2 + 368 >> 2] | 0);
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, (i5 | 0) == 0 ? i3 + 4 | 0 : i5, i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i3 + 4 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 24 | 0);
 STACKTOP = i4;
 return;
}

function __ZNK25BlendshapePropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i3, i2, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = __ZN19SkinnedMeshRenderer7GetMeshEv(i3) | 0;
 if (!i1) {
  i6 = -1;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i6 = -1;
  return i6 | 0;
 }
 i2 = i2 - i1 >> 4;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = -1;
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return i1 | 0;
 if ((i1 | 0) == -1) {
  i6 = -1;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i6 = 100002;
 return i6 | 0;
}

function __ZN5physx2Gu12TriangleMesh14onRefCountZeroEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 224 | 0;
 if (!(__ZN5physx13GuMeshFactory18removeTriangleMeshERNS_14PxTriangleMeshE(HEAP32[i1 >> 2] | 0, i3) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 689458 | 0, 81, gb + 725367 | 0, i4);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP16[i3 + 6 >> 1] & 1)) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i3 | 0);
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i3, 3, 1);
 STACKTOP = i4;
 return;
}

function __ZN5audio5mixer14FindGroupIndexERKNS0_18AudioMixerConstantERK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 if (!i7) {
  i7 = -1;
  return i7 | 0;
 }
 i5 = i1 + 8 | 0;
 i5 = (HEAP32[i5 >> 2] | 0) + i5 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i5 + (i1 << 4) >> 2] | 0) == (i6 | 0)) if ((HEAP32[i5 + (i1 << 4) + 4 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i5 + (i1 << 4) + 8 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i5 + (i1 << 4) + 12 >> 2] | 0) == (i2 | 0)) {
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = -1;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN2UI11CanvasGroup13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 if ((i2 & 5 | 0) == 5) {
  STACKTOP = i4;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106076 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN26AnimatorControllerPlayable13AddObjectUserER8UserList(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i1 = HEAP32[i5 + 84 >> 2] | 0;
 if (i1 | 0) __ZN8UserList7AddUserERS_(i1 + 32 | 0, i6);
 i4 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i4 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i5;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i7 = 9;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 9) {
   i7 = 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i6 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN14StackAllocatorC2Ej10MemLabelIdPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 HEAP32[i1 + 4 >> 2] = i4;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[gb + 27044 >> 2] = (HEAP32[gb + 27044 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 27044 >> 2];
 HEAP32[i1 >> 2] = gb + 26936 + 8;
 i4 = i1 + 32 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i2;
 i6 = i3;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i4 >> 2] = __ZN13MemoryManager16LowLevelAllocateEj(i2) | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 return;
}

function __ZN10GameObject24ActivateAwakeRecursivelyE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 288 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 i9 = gb + 64016 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i4, i5);
 __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue(i1, i2, i4);
 __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb(i4, 8, 0);
 __ZN18AwakeFromLoadQueueD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZL31stbir__filter_mitchell_modifiedff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 if (f1 < Math_fround(1.0)) {
  f2 = Math_fround((+Math_fround(Math_fround(Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(f1 * Math_fround(21.0)) + Math_fround(-36.0))) + Math_fround(16.0)) / Math_fround(18.0)) + .07407407407407407) * 27.0 / 35.0);
  return Math_fround(f2);
 }
 if (!(f1 < Math_fround(2.0))) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround((+Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(36.0) - Math_fround(f1 * Math_fround(7.0)))) + Math_fround(-60.0))) + Math_fround(32.0)) / Math_fround(18.0)) + .07407407407407407) * 27.0 / 35.0);
 return Math_fround(f2);
}

function __Z45Camera_CUSTOM_Internal_RenderToCubemapTextureP12Il2CppObjectS0_i(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if (i1 | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i1 | 0) {
   if (!i3) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   i4 = (__ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_(i2, i1, i4, 0, 0) | 0) & 1;
   return i4 | 0;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 502992 | 0, 0, gb + 502764 | 0, 1385, 1, 0, 0, 0);
 i4 = 0;
 return i4 | 0;
}

function __Z26Light_Set_Custom_PropRangeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 > Math_fround(0.0);
  i4 = HEAP32[(i1 ? i3 : i4) >> 2] | 0;
  __ZNK5Light16UnshareLightDataEv(i5);
  HEAP32[(HEAP32[i5 + 44 >> 2] | 0) + 48 >> 2] = i4;
  __ZN5Light7PrecalcEv(i5);
  STACKTOP = i6;
  return;
 }
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassIN5Unity14CharacterJointEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 843;
 HEAP32[i2 + 8 >> 2] = gb + 734671;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 144;
 HEAP32[i2 + 20 >> 2] = 184;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 111756;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI6MotionEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 952;
 HEAP32[i2 + 8 >> 2] = gb + 908242;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 207;
 HEAP32[i2 + 20 >> 2] = 56;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 1;
 i3 = i2 + 33 | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i3 + 1 >> 0] = 0;
 HEAP8[i3 + 2 >> 0] = 0;
 HEAP8[i3 + 3 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 176524;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11Rigidbody2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 877;
 HEAP32[i2 + 8 >> 2] = gb + 802696;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 50;
 HEAP32[i2 + 20 >> 2] = 228;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67088;
 HEAP32[i2 + 44 >> 2] = fb + 240;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 241;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__213random_deviceclEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i2 = 4;
 i3 = i5;
 while (1) {
  if (!i2) break;
  L3 : while (1) {
   i1 = _read(HEAP32[i4 >> 2] | 0, i3, i2) | 0;
   switch (i1 | 0) {
   case 0:
    {
     i6 = 4;
     break L3;
    }
   case -1:
    break;
   default:
    break L3;
   }
   i1 = HEAP32[(___errno_location() | 0) >> 2] | 0;
   if ((i1 | 0) == 4) continue;
   __ZNSt3__220__throw_system_errorEiPKc(i1, gb + 1082596 | 0);
  }
  if ((i6 | 0) == 4) {
   i6 = 0;
   __ZNSt3__220__throw_system_errorEiPKc(61, gb + 1082574 | 0);
   i1 = 0;
  }
  i2 = i2 - i1 | 0;
  i3 = i3 + i1 | 0;
 }
 STACKTOP = i7;
 return HEAP32[i5 >> 2] | 0;
}

function __ZNK8Renderer19GetSortingLayerNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = __Z13GetTagManagerv() | 0;
 __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi(i3, i5, HEAP32[i2 + 332 >> 2] | 0);
 i5 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, (i5 | 0) == 0 ? i3 + 4 | 0 : i5, i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP32[i3 + 4 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 24 | 0);
 STACKTOP = i4;
 return;
}

function __ZN8Animator9GotoStateEiifff(i1, i3, i5, f6, f7, f8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 var i2 = 0, i4 = 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 624 >> 2] | 0)) return;
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 }
 i2 = i1 + 584 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 do {
  __ZN26AnimatorControllerPlayable9GotoStateEiifff(HEAP32[i1 >> 2] | 0, i3, i5, f6, f7, f8);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 return;
}

function __ZN5physx7NpScene11unlockWriteEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 3876 | 0;
 i2 = __ZN5physx6shdfnd6TlsGetEj(HEAP32[i1 >> 2] | 0) | 0;
 i3 = i2 >>> 24 & 255;
 if (!(i3 << 24 >> 24)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 678666 | 0, 2973, gb + 703582 | 0, i5);
  STACKTOP = i5;
  return;
 }
 i3 = i3 + -1 << 24 >> 24;
 __ZN5physx6shdfnd6TlsSetEjPv(HEAP32[i1 >> 2] | 0, (i3 & 255) << 24 | i2 & 16777215) | 0;
 if (i3 << 24 >> 24) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i4 + 3880 >> 2] = 0;
 __ZN5physx6shdfnd13ReadWriteLock12unlockWriterEv(i4 + 3884 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd10SocketImpl4readEPhj(i7, i3, i5) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 4 | 0;
 i6 = i9;
 i2 = i7 + 4 | 0;
 do {
  i1 = _recv(HEAP32[i2 >> 2] | 0, i3, i5, 0) | 0;
  if ((i1 | 0) >= 0) {
   i8 = 5;
   break;
  }
  if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 105) break;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i6 >> 2] = 4;
  _getsockopt(HEAP32[i2 >> 2] | 0, 1, 8, i4, i6) | 0;
  HEAP32[i4 >> 2] = i5;
 } while (!(_setsockopt(HEAP32[i2 >> 2] | 0, 1, 8, i4, 4) | 0));
 if ((i8 | 0) == 5) if ((i1 | 0) >= 1) {
  i8 = i1;
  STACKTOP = i9;
  return i8 | 0;
 }
 HEAP8[i7 + 14 >> 0] = 0;
 i8 = 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx2Sn5ConvX22convertExtraData_ArrayEPKcS3_S3_RKNS0_14ExtraDataEntryE(i7, i1, i2, i3, i4) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE(i7, HEAP32[i4 >> 2] | 0, 1) | 0;
 i5 = __ZN5physx2Sn4peekEiPKci(HEAP32[i4 + 12 >> 2] | 0, i3 + (HEAP32[i4 + 32 >> 2] | 0) | 0, HEAP32[i4 + 24 >> 2] | 0) | 0;
 getTempRet0() | 0;
 i2 = HEAP32[i4 + 28 >> 2] | 0;
 if (i2) i1 = __ZN5physx2Sn5ConvX11alignStreamEPKci(i7, i1, i2) | 0;
 if ((i5 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i3 = i6 + 16 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi(i7, i1, i6, 0) | 0;
  i1 = i1 + (HEAP32[i3 >> 2] | 0) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueue16InternalAddEventEPNS0_14CloudEventInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_(i1, i3); else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 }
 if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] & 1)) {
  STACKTOP = i6;
  return;
 }
 i5 = i1 + 16 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 STACKTOP = i6;
 return;
}

function __Z50Physics_CUSTOM_INTERNAL_CALL_OverlapSphereNonAllocRK8Vector3ffP11Il2CppArrayi23QueryTriggerInteraction(i1, f3, i5, i2, i4) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0;
 i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 4) | 0;
 i7 = __Z17GetPhysicsManagerv() | 0;
 i2 = __ZN14PhysicsManager21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction(i7, i1, f3, i6, __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0, i2, i4) | 0;
 if (!i2) return i2 | 0; else i1 = 0;
 do {
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i5, i1, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i6 + (i1 << 2) >> 2] | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return i2 | 0;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9AnimationEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 946;
 HEAP32[i2 + 8 >> 2] = gb + 896226;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 111;
 HEAP32[i2 + 20 >> 2] = 332;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 176192;
 HEAP32[i2 + 44 >> 2] = fb + 298;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 299;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _SendMessageFloat(i3, i4, f1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8 + 8 | 0;
 i6 = i8;
 i5 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0) | 0;
 HEAPF32[i5 + 8 >> 2] = f1;
 i2 = __Z27FindActiveTransformWithPathPKc(i3) | 0;
 if (!i2) {
  HEAP32[i7 >> 2] = i3;
  _printf_console(gb + 363594 | 0, i7);
  STACKTOP = i8;
  return;
 }
 if (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i2 + 28 >> 2] | 0, i4, i5) | 0) {
  STACKTOP = i8;
  return;
 }
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 _printf_console(gb + 363530 | 0, i6);
 STACKTOP = i8;
 return;
}

function __ZNK5physx7NpCloth20getNbCollisionPlanesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore20getNbCollisionPlanesEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 466, gb + 694610 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx13GuMeshFactory17getTriangleMeshesEPPNS_14PxTriangleMeshEjj(i1, i8, i3, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i2 = (HEAP32[i1 + 44 >> 2] | 0) - i7 | 0;
 i6 = (i2 | 0) < 0 ? 0 : i2;
 i6 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i6) {
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return i6 | 0;
 }
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return i6 | 0;
}

function __ZN9Behaviour15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37896 + 8;
 HEAP32[gb + 1155104 >> 2] = i1;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37916 + 8;
 HEAP32[gb + 1155108 >> 2] = i1;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37936 + 8;
 HEAP32[gb + 1155112 >> 2] = i1;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37956 + 8;
 HEAP32[gb + 1155116 >> 2] = i1;
 return;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI9BlobWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 902127 | 0, 0);
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i2, i1 + 40 | 0, gb + 902137 | 0, 0);
 __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags(i2, i1 + 80 | 0, gb + 902149 | 0, 0);
 __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags(i2, i1 + 120 | 0, gb + 902162 | 0, 0);
 __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags(i2, i1 + 132 | 0, gb + 902170 | 0, 0);
 __ZN9BlobWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i2, i1 + 136 | 0, gb + 901500 | 0, 0);
 __ZN9BlobWrite8TransferIhEEvRT_PKc17TransferMetaFlags(i2, i1 + 137 | 0, gb + 902184 | 0, 0);
 return;
}

function __ZN5physx2Sc17ParticleSystemSim16visualizeEndStepERNS_2Cm12RenderOutputE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(HEAP16[(HEAP32[i3 + 52 >> 2] | 0) + 8 >> 1] & 1)) {
  STACKTOP = i4;
  return;
 }
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE(i2, i1) | 0;
 __ZN5physx2Sc17ParticleSystemSim25visualizeCollisionNormalsERNS_2Cm12RenderOutputE(i3, i2);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = HEAP32[i3 + 112 >> 2] | 0;
 i1 = i2 << 7;
 i4 = HEAP32[i3 + 100 >> 2] | 0;
 i2 = HEAP32[i4 + (i2 << 3) + 4 >> 2] | 0;
 if ((i2 | 0) != (0 - i1 | 0)) {
  i1 = i2 + i1 | 0;
  i2 = 0;
  do {
   HEAP32[(HEAP32[i4 + (i2 >>> 7 << 3) >> 2] | 0) + ((i2 & 127) * 20 | 0) + 12 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 HEAP32[i3 + 128 >> 2] = 0;
 HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + 4 >> 2] = 0;
 __ZN5physx13PxsCCDContext12updateCCDEndEv(i3);
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[(HEAP32[i3 + 264 >> 2] | 0) + 224 >> 2] | 0, HEAP32[i3 + 252 >> 2] | 0);
 return;
}

function __ZN4FMOD6System16createSoundGroupEPKcPPNS_10SoundGroupE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869237;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869237;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869237;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN14FileCacherReadD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 67232 + 8;
 i2 = i1 + 24 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 12 | 0;
 __Z23AsyncReadForceCloseFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 128 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 88 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZdlPv(i1);
 return;
}

function __ZN13ScreenManager14GetBlitTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 i1 = i1 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i7 = gb + 63520 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i3;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i4 = __Z20CreateObjectFromCodeI19LowerResBlitTextureEPT_17AwakeFromLoadMode10MemLabelId(4, i4) | 0;
 HEAP32[i1 >> 2] = i4;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, 61);
 i4 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_110DataStream12beginSectionEPKvPKc(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i2 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, i2) | 0;
 i7 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i5 >> 2] = gb + 150020 + 8;
 i8 = i5 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = i2;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i6;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 18);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN12LineRendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 43492 + 8;
 HEAP32[i3 + 32 >> 2] = gb + 43492 + 184;
 i1 = i3 + 344 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 348 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  __ZN8RendererD2Ev(i3);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN8RendererD2Ev(i3);
 return;
}

function __GLOBAL__sub_I_VRDevice_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469192 | 0, gb + 1044669 | 0, 13, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469372 | 0, gb + 1044683 | 0, 17, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469216 | 0, gb + 1044701 | 0, 17, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469320 | 0, gb + 1044716 | 0, 17, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469336 | 0, gb + 1044724 | 0, 17, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1469204 | 0, gb + 1044743 | 0, 17, 0);
 return;
}

function _UNITY_FT_Attach_Stream(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 if (!i5) i1 = 35; else {
  i2 = HEAP32[i5 + 96 >> 2] | 0;
  if (!i2) i1 = 34; else {
   i1 = _UNITY_FT_Stream_New(HEAP32[i2 + 4 >> 2] | 0, i6, i3) | 0;
   if (!i1) {
    i1 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 80 >> 2] | 0;
    i4 = HEAP32[i3 >> 2] | 0;
    if (!i1) i1 = 7; else i1 = mftCall_iii(i1 | 0, i5 | 0, i4 | 0) | 0;
    if (!(HEAP32[i6 + 16 >> 2] | 0)) i3 = 0; else i3 = (HEAP32[i6 >> 2] | 0) >>> 1 & 1;
    if (i4) {
     i2 = HEAP32[i4 + 28 >> 2] | 0;
     _UNITY_FT_Stream_Close(i4);
     if (!i3) _UNITY_ft_mem_free(i2, i4);
    }
   }
  }
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 57;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNK18GfxFramebufferGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!(HEAP8[i6 + 30 >> 0] | 0)) i1 = (i6 | 0) == (HEAP32[i3 + 244 >> 2] | 0); else {
  i4 = HEAP32[i3 + 248 >> 2] | 0;
  if ((i4 | 0) > 0) {
   i2 = 0;
   i1 = 0;
   while (1) {
    if (!(i1 << 24 >> 24)) i1 = (i6 | 0) == (HEAP32[i3 + 212 + (i2 << 2) >> 2] | 0); else i1 = 1;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 & 1;
   }
  } else i1 = 0;
 }
 HEAP8[i6 + 29 >> 0] = i1 & (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 133 >> 0] | 0) != 0 & 1;
 i6 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 508 >> 0] | 0) != 0;
 HEAP8[(HEAP32[i5 >> 2] | 0) + 28 >> 0] = i6 ? 2 : 0;
 return;
}

function __ZN7mecanim9animation24DestroyBlendTreeConstantEPNS0_17BlendTreeConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i3) return;
 i5 = i3 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) i1 = i5; else {
  i2 = i5;
  i1 = 0;
  do {
   i7 = (HEAP32[i5 >> 2] | 0) + i2 + (i1 << 2) | 0;
   i6 = HEAP32[i7 >> 2] | 0;
   __ZN7mecanim9animation28DestroyBlendTreeNodeConstantEPNS0_21BlendTreeNodeConstantERNS_6memory9AllocatorE((i6 | 0) == 0 ? 0 : i7 + i6 | 0, i4);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  i1 = i5;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i1 + i5 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4copyIS3_EEvRKNS1_IS2_T_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 8 >> 2] = i1;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 * 12 | 0, gb + 838004 | 0, 543) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i2 + ((HEAP32[i5 >> 2] | 0) * 12 | 0) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
  i2 = i2 + 12 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 12 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 4) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd10ThreadImpl18getNbPhysicalCoresEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 12 | 0;
 i2 = i5 + 8 | 0;
 i1 = _fopen(gb + 778998 | 0, gb + 1084155 | 0) | 0;
 L1 : do if (i1 | 0) {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = i2;
  i4 = _fscanf(i1, gb + 779031 | 0, i4) | 0;
  _fclose(i1) | 0;
  switch (i4 | 0) {
  case 2:
   {
    i4 = (HEAP32[i2 >> 2] | 0) + 1 - (HEAP32[i3 >> 2] | 0) | 0;
    STACKTOP = i5;
    return i4 | 0;
   }
  case 1:
   {
    i4 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
    STACKTOP = i5;
    return i4 | 0;
   }
  default:
   break L1;
  }
 } while (0);
 i4 = _sysconf(83) | 0;
 i4 = (i4 | 0) < 0 ? 0 : i4;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE12addAttributeEPKcS5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
 if (i2 | 0) if (HEAP8[i2 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i1 | 0, i2 | 0, _strlen(i2) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1087558 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1046779 | 0, 1) | 0;
 if (i3 | 0) if (HEAP8[i3 >> 0] | 0) {
  i4 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
  mftCall_iiii(i4 | 0, i1 | 0, i3 | 0, _strlen(i3) | 0) | 0;
 }
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1046779 | 0, 1) | 0;
 return;
}

function __ZN5physx2Gu11HeightField14onRefCountZeroEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 112 | 0;
 if (!(__ZN5physx13GuMeshFactory17removeHeightFieldERNS_13PxHeightFieldE(HEAP32[i1 >> 2] | 0, i3) | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 724537 | 0, 79, gb + 724659 | 0, i4);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP16[i3 + 6 >> 1] & 1)) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i3 | 0); else mftCall_vi(HEAP32[i2 + 16 >> 2] | 0, i3 | 0);
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i3, 1, 1);
 STACKTOP = i4;
 return;
}

function __ZN5physx20PxsParticleSystemSim16onRbShapeChangeVERKNS_16PxvParticleShapeEjj(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i4 + 60 >> 2] | 0;
 if (!i9) return;
 i8 = i2 + 36 | 0;
 if ((HEAP32[i8 >> 2] | 0) != 5) return;
 i7 = HEAP32[i3 + 44 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 48 >> 2] | 0;
 i1 = HEAP32[i7 + 12 >> 2] | 0;
 i7 = (HEAP32[i7 + 8 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= i7 >>> 0) return;
 i5 = HEAP32[i4 + 36 >> 2] | 0;
 do {
  i2 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  i3 = i6 + (i2 << 5) + 30 | 0;
  i4 = HEAP16[i3 >> 1] | 0;
  if (i4 & 48) if ((HEAP32[i9 + (i2 << 5) + 28 >> 2] | 0) == (i8 | 0)) HEAP16[i3 >> 1] = i4 & 65487;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN4FMOD6System11registerDSPEP20FMOD_DSP_DESCRIPTIONPj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869765;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869765;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869765;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17AnimationPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = i5 + 8 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) return;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i8 = 8;
    break;
   } else i3 = 0;
  }
  if ((i8 | 0) == 8) {
   i8 = 0;
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i6 | 0);
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i1 + 28 >> 2] | 0) >>> 0);
 return;
}

function __ZN14ParticleSystem15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType(i2, i3, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i8 = 0, i9 = 0;
 i8 = i3 + 264 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) return;
 i9 = i3 + 252 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i4 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[((i4 | 0) == 0 ? 0 : i4 + -32 | 0) + 28 >> 2] | 0, gb + 80300 | 0) | 0) + 920 >> 2] | 0;
  if (HEAP8[i4 + 4 >> 0] | 0) __ZN12LightsModule15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType(i4, i2, i3, i5, i6, i7);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i8 >> 2] | 0) >>> 0);
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE16StaticInitializeES5_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11UnityEngine9Analytics9PerfEventD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188436 + 8;
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __Z67AnimatorOverrideController_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN26AnimatorOverrideController21SetAnimatorControllerE4PPtrI25RuntimeAnimatorControllerE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z44Terrain_Set_Custom_PropTreeLODBiasMultiplierP12Il2CppObjectf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 if (f1 <= Math_fround(0.0)) {
  if (!i3) i2 = 0; else {
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
  }
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 941474 | 0, 0, gb + 941536 | 0, 649, 512, i2, 0, 0);
  f1 = Math_fround(.00100000005);
 }
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN7Terrain24SetTreeLODBiasMultiplierEf(i2, f1);
  return;
 }
}

function __Z13RegisterClassIN5Unity11SpringJointEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 855;
 HEAP32[i2 + 8 >> 2] = gb + 738002;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 145;
 HEAP32[i2 + 20 >> 2] = 116;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113868;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9RigidbodyEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 853;
 HEAP32[i2 + 8 >> 2] = gb + 737574;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 54;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67048;
 HEAP32[i2 + 44 >> 2] = fb + 223;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 224;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI21LightProbeProxyVolumeEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 537;
 HEAP32[i2 + 8 >> 2] = gb + 378221;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 259;
 HEAP32[i2 + 20 >> 2] = 168;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30592;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 12 | 0;
 i4 = i3;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i4, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i2, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 if (__ZNK15FileSystemEntry5IsDirEv(i2) | 0) {
  i5 = 0;
  __ZN13FileEntryDataD2Ev(i2);
  STACKTOP = i3;
  return i5 | 0;
 }
 i5 = __ZNK15FileSystemEntry6ExistsEv(i2) | 0;
 __ZN13FileEntryDataD2Ev(i2);
 STACKTOP = i3;
 return i5 | 0;
}

function _UNITY_FT_Outline_Copy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i4 = 20;
  return i4 | 0;
 }
 i3 = i1 + 2 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 if (i4 << 16 >> 16 != (HEAP16[i2 + 2 >> 1] | 0)) {
  i4 = 6;
  return i4 | 0;
 }
 if ((HEAP16[i1 >> 1] | 0) != (HEAP16[i2 >> 1] | 0)) {
  i4 = 6;
  return i4 | 0;
 }
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 _memcpy(HEAP32[i2 + 4 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i4 << 16 >> 16 << 3 | 0) | 0;
 _memcpy(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, HEAP16[i3 >> 1] | 0) | 0;
 _memcpy(HEAP32[i2 + 12 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0, HEAP16[i1 >> 1] << 1 | 0) | 0;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 16 >> 2] & -2 | HEAP32[i4 >> 2] & 1;
 i4 = 0;
 return i4 | 0;
}

function __ZSt11__terminatePFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __THREW__ = 0;
 invoke_v(i1 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (!(i1 & 1)) {
  __THREW__ = 0;
  invoke_vii(fb + 4618 | 0, gb + 1085287 | 0, i2 | 0);
  __THREW__ = 0;
 }
 i1 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4618 | 0, gb + 1085327 | 0, i2 + 8 | 0);
 __THREW__ = 0;
 i1 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 __THREW__ = 0;
 invoke_v(fb + 458 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else ___clang_call_terminate(i1);
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE8readsomeEPwi(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) i1 = i2 - i1 >> 2; else i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0;
 switch (i1 | 0) {
 case -1:
  {
   i6 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __ZNSt3__28ios_base5clearEj(i6, HEAP32[i6 + 16 >> 2] | 2);
   break;
  }
 case 0:
  break;
 default:
  __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4readEPwi(i4, i5, (i1 | 0) > (i6 | 0) ? i6 : i1) | 0;
 }
 return HEAP32[i7 >> 2] | 0;
}

function __ZNK5physx2Sc9ClothCore23getSelfCollisionIndicesEPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i8 = i3;
 i5 = i2 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 340 >> 2] | 0, i2 | 0) | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i1 + (i2 << 2);
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 mftCall_viii(i7 | 0, i6 | 0, i5 | 0, i4 | 0);
 STACKTOP = i3;
 return (i2 | 0) != 0 | 0;
}

function __ZNK5physx13GuMeshFactory15getHeightFieldsEPPNS_13PxHeightFieldEjj(i1, i8, i3, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i2 = (HEAP32[i1 + 124 >> 2] | 0) - i7 | 0;
 i6 = (i2 | 0) < 0 ? 0 : i2;
 i6 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i6) {
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return i6 | 0;
 }
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return i6 | 0;
}

function __ZNK18PlatformEffector2D18GroupOneWayContactERN10Effector2D15EffectorContactE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = HEAP32[(HEAP32[i5 + 16 >> 2] | 0) + 112 >> 2] | 0;
 if (!i1) return;
 while (1) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (HEAP32[i2 + 4 >> 2] & 64 | 0) {
   i3 = HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + 60 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + 60 >> 2] | 0;
   if (HEAP8[i3 + 53 >> 0] | 0) if ((HEAP32[i3 + 156 >> 2] | 0) == (i4 | 0)) break;
   if (HEAP8[i2 + 53 >> 0] | 0) if ((HEAP32[i2 + 156 >> 2] | 0) == (i4 | 0)) break;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if (!i1) {
   i6 = 10;
   break;
  }
 }
 if ((i6 | 0) == 10) return;
 i6 = (HEAP32[i5 + 32 >> 2] | 0) + 4 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -69 | 64;
 return;
}

function __ZN9TextAssetD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 66792 + 8;
 i1 = i2 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 60 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i5 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i1;
  __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 }
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i2 + 28 | 0);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __ZN8Animator18EvaluateControllerEf(i3, f4) {
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i3 + 624 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + 100 >> 2] | 0;
 do if (!(HEAP32[i2 + 20 >> 2] | 0)) {
  if (f4 == Math_fround(0.0)) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
   if (i2) break;
   i2 = HEAP32[i1 + 100 >> 2] | 0;
  }
  HEAP32[i2 + 20 >> 2] = 1;
 } while (0);
 __ZN26AnimatorControllerPlayable11UpdateGraphEf(i1, f4);
 __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[i5 >> 2] | 0, i3 + 40 | 0);
 return;
}

function __ZN5physx7NpCloth19addCollisionCapsuleEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 switch ((HEAP32[i3 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  __ZN5physx2Sc9ClothCore19addCollisionCapsuleEjj(i3 + 32 | 0, i1, i2);
  STACKTOP = i6;
  return;
 } else if ((i5 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 387, gb + 695095 | 0, i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx20InternalTriangleMesh19allocateAdjacenciesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 * 3 | 0;
 i2 = i2 >>> 0 > 1073741823 ? -1 : i2 << 2;
 if (!i2) i2 = 0; else {
  i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
  i1 = _PxGetFoundation() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_iiiiii(i6 | 0, i5 | 0, i2 | 0, (i1 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 724949 | 0, 222) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i4 + 168 >> 2] = i2;
 i6 = i4 + 156 | 0;
 HEAP8[i6 >> 0] = HEAPU8[i6 >> 0] | 0 | 4;
 HEAP32[i4 + 172 >> 2] = i1 * 3;
 i6 = i2;
 return i6 | 0;
}

function __ZN5Unity11AdjTriangle8FindEdgeEjj(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = (i1 | 0) == (i4 | 0);
 if (i2) if ((HEAP32[i3 + 4 >> 2] | 0) == (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = (i1 | 0) == (i5 | 0);
 if (i1) if ((HEAP32[i3 + 4 >> 2] | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (i2) if ((HEAP32[i3 + 8 >> 2] | 0) == (i5 | 0)) {
  i5 = 1;
  return i5 | 0;
 }
 if (i1) if ((HEAP32[i3 + 8 >> 2] | 0) == (i4 | 0)) {
  i5 = 1;
  return i5 | 0;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) if ((HEAP32[i3 + 8 >> 2] | 0) == (i5 | 0)) {
  i5 = 2;
  return i5 | 0;
 }
 if ((i1 | 0) == (i5 | 0)) return ((HEAP32[i3 + 8 >> 2] | 0) == (i4 | 0) ? 2 : -1) | 0; else {
  i5 = -1;
  return i5 | 0;
 }
 return 0;
}

function __ZN4FMOD6System6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 855848;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 855848;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 855848;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN13AudioListener7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return;
 i6 = i1 + 40 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= 0) return;
 i5 = i1 + 28 | 0;
 i4 = 0;
 do {
  i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i4 << 3) + 4 >> 2] | 0;
  i2 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
  i3 = (i1 | 0) == 0;
  if (i3 | (i2 - (HEAP32[gb + 170352 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 170352 + 28 >> 2] | 0) >>> 0) {
   if (!(i3 | (i2 - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0)) {
    i1 = HEAP32[i1 + 144 >> 2] | 0;
    if (i1 | 0) __ZN17AudioCustomFilter7CleanupEv(i1);
   }
  } else __ZN11AudioFilter7CleanupEv(i1);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (HEAP32[i6 >> 2] | 0));
 return;
}

function __ZN10FlareLayer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(36, i1, 16, gb + 1048932 | 0, 0, gb + 377820 | 0, 178) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 33124 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18BuoyancyEffector2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 863;
 HEAP32[i2 + 8 >> 2] = gb + 800967;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 253;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154156;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UNITY_png_get_pCAL(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if (!((i9 | 0) != 0 & ((i8 | 0) != 0 & ((i7 | 0) != 0 & ((i6 | 0) != 0 & ((i5 | 0) != 0 & ((i4 | 0) != 0 & (i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 1024 | 0) != 0 : 0)))))))) {
  i9 = 0;
  return i9 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 196 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i2 + 200 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 + 204 >> 2];
 i5 = HEAP16[i2 + 216 >> 1] | 0;
 HEAP32[i6 >> 2] = i5 & 255;
 HEAP32[i7 >> 2] = (i5 & 65535) >>> 8 & 65535;
 HEAP32[i8 >> 2] = HEAP32[i2 + 208 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i2 + 212 >> 2];
 i9 = 1024;
 return i9 | 0;
}

function _convsamp(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i2 = 0;
 while (1) {
  i5 = (HEAP32[i3 + (i2 << 2) >> 2] | 0) + i4 | 0;
  i6 = i5 + 1 | 0;
  HEAP32[i1 >> 2] = (HEAPU8[i5 >> 0] | 0) + -128;
  i5 = i6 + 1 | 0;
  HEAP32[i1 + 4 >> 2] = (HEAPU8[i6 >> 0] | 0) + -128;
  i6 = i5 + 1 | 0;
  HEAP32[i1 + 8 >> 2] = (HEAPU8[i5 >> 0] | 0) + -128;
  i5 = i6 + 1 | 0;
  HEAP32[i1 + 12 >> 2] = (HEAPU8[i6 >> 0] | 0) + -128;
  i6 = i5 + 1 | 0;
  HEAP32[i1 + 16 >> 2] = (HEAPU8[i5 >> 0] | 0) + -128;
  i5 = i6 + 1 | 0;
  HEAP32[i1 + 20 >> 2] = (HEAPU8[i6 >> 0] | 0) + -128;
  HEAP32[i1 + 24 >> 2] = (HEAPU8[i5 >> 0] | 0) + -128;
  HEAP32[i1 + 28 >> 2] = (HEAPU8[i5 + 1 >> 0] | 0) + -128;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 8) break; else i1 = i1 + 32 | 0;
 }
 return;
}

function __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAP32[i1 >> 2] = i4;
 i2 = i5 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 + 52 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i5 + 44 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  i5 = i5 + 88 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5 + 40 | 0, i1) | 0;
  i5 = i5 + 88 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE8readsomeEPci(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i4 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i3 = HEAP32[i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (i1 >>> 0 < i2 >>> 0) i1 = i2 - i1 | 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0;
 switch (i1 | 0) {
 case -1:
  {
   i6 = i4 + (HEAP32[(HEAP32[i4 >> 2] | 0) + -12 >> 2] | 0) | 0;
   __ZNSt3__28ios_base5clearEj(i6, HEAP32[i6 + 16 >> 2] | 2);
   break;
  }
 case 0:
  break;
 default:
  __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4readEPci(i4, i5, (i1 | 0) > (i6 | 0) ? i6 : i1) | 0;
 }
 return HEAP32[i7 >> 2] | 0;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE6narrowEwc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474588 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (!(i6 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   __ZNSt3__26localeD2Ev(i4);
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i4);
 ___resumeException(i6 | 0);
 return 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE6narrowEcc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i4 | 0, gb + 1474556 | 0) | 0;
 i6 = __THREW__;
 __THREW__ = 0;
 if (!(i6 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (!(i6 & 1)) {
   __ZNSt3__26localeD2Ev(i4);
   STACKTOP = i5;
   return i1 | 0;
  }
 }
 i6 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i4);
 ___resumeException(i6 | 0);
 return 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofERKS5_j(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i7 = i4 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i7 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 L5 : do if (!i3) i1 = -1; else {
  i4 = i2;
  i1 = i2 + (i1 >>> 0 > i6 >>> 0 ? i6 + 1 | 0 : i1) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i1 = -1;
    break L5;
   }
   i1 = i1 + -1 | 0;
   if (__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i5, i3, i1) | 0) {
    i1 = i1 - i4 | 0;
    break;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZNK19ShaderPropertySheet24GetFloatValueInsRGBSpaceEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 i3 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 f1 = Math_fround(HEAPF32[(HEAP32[i2 + 72 >> 2] | 0) + (i3 & 1048575) >> 2]);
 do if (i3 & 1073741824) if ((__Z19GetActiveColorSpacev() | 0) == 1) if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 return Math_fround(f1);
}

function __ZN9Transform30SetRotationWithoutNotificationERK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i6 = i3;
 i4 = i3 + 8 | 0;
 i1 = i1 + 32 | 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = i7;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z10SetGlobalR15TransformAccessRKN4math7_float4E(i5, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 56 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 56 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 56 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 56 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN4FMOD6System11recordStartEiPNS_5SoundEb(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869728;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869728;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869728;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 450783 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN30RuntimeInitializeOnLoadManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN20DynamicPropertySheetD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 35824 + 8;
 i1 = i2 + 112 | 0;
 if ((HEAP32[i2 + 128 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 116 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 88 >> 2] | 0) > -1) {
  i1 = i2 + 72 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 76 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 52 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN20DynamicPropertySheetD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 35824 + 8;
 i1 = i2 + 112 | 0;
 if ((HEAP32[i2 + 128 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 116 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 88 >> 2] | 0) > -1) {
  i1 = i2 + 72 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 76 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 52 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 48 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 32 >> 2] | 0, i2 + 36 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN10InputEvent18CommandStringEventERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i4 = i1 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP8[i4 + 28 >> 0] = 0;
 HEAP32[i1 >> 2] = i3 ? 14 : 13;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i3 = (i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) + 1 | 0;
 i5 = __Znaj(i3) | 0;
 HEAP32[i1 + 44 >> 2] = i5;
 _memcpy(i5 | 0, (i4 ? HEAP32[i2 >> 2] | 0 : i2) | 0, i3 | 0) | 0;
 return;
}

function __Z40Camera_CUSTOM_Internal_RenderToCubemapRTP12Il2CppObjectS0_i(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if (i1 | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i1 | 0) {
   if (!i3) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   i4 = (__ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_(i2, i1, i4, 0, 0) | 0) & 1;
   return i4 | 0;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 502992 | 0, 0, gb + 502764 | 0, 1364, 1, 0, 0, 0);
 i4 = 0;
 return i4 | 0;
}

function __Z13RegisterClassIN5Unity10HingeJointEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 848;
 HEAP32[i2 + 8 >> 2] = gb + 736306;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 59;
 HEAP32[i2 + 20 >> 2] = 160;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 112544;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassIN5Unity10FixedJointEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 112744;
 HEAP32[i2 + 4 >> 2] = fb + 847;
 HEAP32[i2 + 8 >> 2] = gb + 744763;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 138;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 112344;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17SurfaceEffector2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 886;
 HEAP32[i2 + 8 >> 2] = gb + 803070;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 252;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 158068;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z12ReadTypeTreeR8TypeTreeRPKhS2_ib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if ((i4 | 0) > 11 | (i4 | 0) == 10) {
  i6 = __ZN8TypeTree8BlobReadERPKhS1_ib(i1, i2, i3, 0, i5) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 if (i5) {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = __ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i1, i6, i2, i3, i4) | 0;
  STACKTOP = i7;
  return i6 | 0;
 } else {
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = 0;
  i6 = __ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i(i1, i6, i2, i3, i4) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _strncasecmp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!i3) i1 = 0; else {
  i4 = HEAP8[i1 >> 0] | 0;
  L3 : do if (!(i4 << 24 >> 24)) i1 = 0; else {
   i6 = i1;
   i1 = i4;
   i4 = i4 & 255;
   while (1) {
    i3 = i3 + -1 | 0;
    i5 = HEAP8[i2 >> 0] | 0;
    if (!((i3 | 0) != 0 & i5 << 24 >> 24 != 0)) break L3;
    if (i1 << 24 >> 24 != i5 << 24 >> 24) {
     i4 = _tolower(i4) | 0;
     if ((i4 | 0) != (_tolower(i5 & 255) | 0)) break L3;
    }
    i6 = i6 + 1 | 0;
    i2 = i2 + 1 | 0;
    i4 = HEAP8[i6 >> 0] | 0;
    if (!(i4 << 24 >> 24)) {
     i1 = 0;
     break;
    } else {
     i1 = i4;
     i4 = i4 & 255;
    }
   }
  } while (0);
  i1 = _tolower(i1 & 255) | 0;
  i1 = i1 - (_tolower(HEAPU8[i2 >> 0] | 0) | 0) | 0;
 }
 return i1 | 0;
}

function __ZNK5physx2Sc15ArticulationSim16createDriveCacheEfj(i3, f1, i2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 __ZNK5physx2Sc15ArticulationSim11checkResizeEv(i3);
 i6 = i3 + 16 | 0;
 __ZN5physx21PxcArticulationHelper12getDataSizesEjRjS1_S1_(HEAP32[i6 >> 2] | 0, i4 + 8 | 0, i5, i4);
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4 + 12 | 0, HEAP32[i5 >> 2] | 0, gb + 681221 | 0, 408) | 0;
 __ZN5physx21PxcArticulationHelper20initializeDriveCacheERNS_9PxcFsDataEtPKNS_19PxsArticulationLinkEfjPcj(i5, HEAP32[i6 >> 2] & 65535, HEAP32[i3 + 12 >> 2] | 0, f1, i2, HEAP32[i3 + 148 >> 2] | 0, HEAP32[i3 + 152 >> 2] | 0);
 STACKTOP = i4;
 return i5 | 0;
}

function __ZNK5physx19PxClothFabricCooker13getDescriptorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 12 >> 2] = (HEAP32[i2 + 20 >> 2] | 0) + -1;
 HEAP32[i1 + 16 >> 2] = (HEAP32[i2 + 16 >> 2] | 0) + 4;
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 64 >> 2];
 return;
}

function __ZNK5physx13GuMeshFactory15getConvexMeshesEPPNS_12PxConvexMeshEjj(i1, i8, i3, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i2 = (HEAP32[i1 + 84 >> 2] | 0) - i7 | 0;
 i6 = (i2 | 0) < 0 ? 0 : i2;
 i6 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i6) {
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return i6 | 0;
 }
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[i4 + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return i6 | 0;
}

function __ZNK13b2PulleyJoint17GetCurrentLengthBEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 100 >> 2]);
 f4 = Math_fround(f3 * f7);
 f6 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 104 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f6 * f2));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f2 = Math_fround(Math_fround(f7 * f6) + Math_fround(f3 * f2));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f3 = Math_fround(f4 - f3);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 80 >> 2]));
 return Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
}

function __ZN8Animator12AddToManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 i3 = i5;
 if (HEAP8[i2 + 33 >> 0] | 0) {
  i4 = HEAP32[i2 + 624 >> 2] | 0;
  if (i4 | 0) {
   i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0;
   __ZN8Playable6HandleEv(i3, i4);
   HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   mftCall_viii(i6 | 0, i2 | 0, i1 | 0, 0);
  }
 }
 if (!(__ZNK9HPlayable7IsValidEv(i2 + 628 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant(HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0, i2 + 40 | 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sq17SceneQueryManager23forceDynamicTreeRebuildEbb(i5, i1, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = i5 + 80 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 if (i1) {
  i1 = i5 + 12 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i5 + 64 >> 2] | 0) == 1) {
   __ZN5physx2Sq10AABBPruner5purgeEv(i2);
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
  }
 }
 if (i3) {
  i1 = i5 + 16 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) if ((HEAP32[i5 + 68 >> 2] | 0) == 1) {
   __ZN5physx2Sq10AABBPruner5purgeEv(i2);
   i5 = HEAP32[i1 >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
  }
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN5physx2Sc13ConstraintSim17updateRelatedSIPsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) >>> 0 < (HEAP32[i3 + 28 >> 2] | 0) >>> 0 ? i1 : i3;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i3 = HEAP32[i3 + 28 >> 2] | 0;
 i4 = i1 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (HEAP8[i2 + 21 >> 0] & 1) {
   i2 = (i2 | 0) == 0 ? 0 : i2 + -8 | 0;
   i3 = i2 + 4 | 0;
   HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 1;
   i3 = i2 + 6 | 0;
   if (!(HEAP16[i3 >> 1] & 2)) {
    __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i2);
    HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
   }
  }
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN5physx2Sc10NPhaseCore39addToPersistentContactEventPairsDelayedEPNS0_19ShapeInstancePairLLE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = i5;
 i2 = i5 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 2097152;
 i2 = i6 + 16 | 0;
 i3 = i6 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 52 >> 2] = i4;
 if ((HEAP32[i6 + 24 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5Umbra9intersectERKNS_4AABBES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f3 <= Math_fround(HEAPF32[i2 + 12 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!(f3 <= Math_fround(HEAPF32[i2 + 16 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f3 <= Math_fround(HEAPF32[i2 + 20 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (!(f3 >= Math_fround(HEAPF32[i2 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (!(f3 >= Math_fround(HEAPF32[i2 + 4 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i2 = f3 >= Math_fround(HEAPF32[i2 + 8 >> 2]);
 return i2 | 0;
}

function __ZN5Umbra9Matrix4x44makeERKNS_9Matrix4x3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZN4UNET16ScriptingUpdater3GetEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1468924 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63760 | 0, 16, gb + 1037140 | 0, 24) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1468924 >> 2] = i2;
 i2 = __ZN4UNET16ScriptingUpdater3GetEv() | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i1, HEAP32[gb + 66748 >> 2] | 0, HEAP32[gb + 66756 >> 2] | 0, gb + 1037228 | 0, gb + 1037244 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 389 | 0, fb + 390 | 0);
 i2 = HEAP32[gb + 1468924 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN12_GLOBAL__N_110DataStream10endSectionEPKvPKc(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i2 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i3, i2) | 0;
 i7 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 i6 = getTempRet0() | 0;
 HEAP32[i5 >> 2] = gb + 15e4 + 8;
 i8 = i5 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = i2;
 i2 = i5 + 24 | 0;
 HEAP32[i2 >> 2] = i7;
 HEAP32[i2 + 4 >> 2] = i6;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 19);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __Z13RegisterClassI12MeshRendererEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 580;
 HEAP32[i2 + 8 >> 2] = gb + 1046296;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 23;
 HEAP32[i2 + 20 >> 2] = 384;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30912;
 HEAP32[i2 + 44 >> 2] = fb + 62;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i7, i4, i3) {
 i7 = i7 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i7 + 11 | 0;
 i2 = HEAP8[i8 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 if (i1) i5 = HEAP32[i7 + 4 >> 2] | 0; else i5 = i2 & 255;
 if (i5 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i7);
 if (i3 | 0) {
  if (i1) i6 = HEAP32[i7 >> 2] | 0; else i6 = i7;
  i1 = i5 - i4 | 0;
  i3 = i1 >>> 0 < i3 >>> 0 ? i1 : i3;
  i1 = i1 - i3 | 0;
  if (i1) {
   i2 = i6 + i4 | 0;
   _memmove(i2 | 0, i2 + i3 | 0, i1 | 0) | 0;
   i2 = HEAP8[i8 >> 0] | 0;
  }
  i1 = i5 - i3 | 0;
  if (i2 << 24 >> 24 < 0) HEAP32[i7 + 4 >> 2] = i1; else HEAP8[i8 >> 0] = i1;
  HEAP8[i6 + i1 >> 0] = 0;
 }
 return i7 | 0;
}

function __ZN9HaloLayer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(36, i1, 16, gb + 1048932 | 0, 0, gb + 377968 | 0, 76) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 34348 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i6;
 HEAP32[i3 >> 2] = ((HEAP32[i1 + 4 >> 2] | 0) - i6 | 0) / 24 | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0, 4) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = 0;
 do {
  i6 = i2 + (i1 * 24 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx7NpCloth25setSelfCollisionStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore25setSelfCollisionStiffnessEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 788, gb + 692956 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx3Ext23DefaultBufferedProfiler30removeBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i7 = i1 + 92 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 i3 = i1 + 88 | 0;
 i4 = i8;
 do {
  if (!i4) {
   i9 = 5;
   break;
  }
  i4 = i4 + -1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = i2 + (i4 << 2) | 0;
 } while ((HEAP32[i1 >> 2] | 0) != (i5 | 0));
 if ((i9 | 0) == 5) {
  i9 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
  return;
 }
 i9 = i8 + -1 | 0;
 HEAP32[i7 >> 2] = i9;
 HEAP32[i1 >> 2] = HEAP32[i2 + (i9 << 2) >> 2];
 i9 = HEAP32[i6 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i9);
 return;
}

function __ZN5Unity9Component23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP32[i3 >> 2] & 16384 | 0) {
  STACKTOP = i5;
  return;
 }
 i2 = i1 + 28 | 0;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, 65);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i1 | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i4) | 0;
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 STACKTOP = i5;
 return;
}

function __ZN4FMOD6System13getNumPluginsE15FMOD_PLUGINTYPEPi(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869492;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869492;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869492;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 946466 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN20TextRenderingPrivate8TextMesh8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17CollisionMeshData21AwakeFromLoadThreadedER4Mesh(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = HEAP32[i3 + 224 >> 2] | 0;
 i6 = __Z11GetIPhysicsv() | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i4) | 0;
 i2 = i1 + 12 | 0;
 if (!((i5 & 4 | 0) == 0 | (HEAP32[i2 >> 2] | 0) != 0)) HEAP32[i2 >> 2] = mftCall_iiiiiiif(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, i3 | 0, 0, 0, i4 | 0, 0, 0.0) | 0;
 i1 = i1 + 8 | 0;
 if ((i5 & 2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) != 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = mftCall_iiiiiiif(HEAP32[(HEAP32[i6 >> 2] | 0) + 48 >> 2] | 0, i6 | 0, i3 | 0, 1, 0, i4 | 0, 0, 0.0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN14FileCacherRead7RequestEiR16AsyncReadCommandRNS_10CacheBlockE(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = Math_imul(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0, i2) | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (i3 >>> 0 <= i6 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i3 - i6 | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i4, i1 + 12 | 0) | 0;
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 16 >> 2] = i3 >>> 0 < i6 >>> 0 ? i3 : i6;
 HEAP32[i4 + 20 >> 2] = Math_imul(HEAP32[i1 + 4 >> 2] | 0, i2) | 0;
 HEAP32[i5 + 4 >> 2] = i2;
 __Z16AsyncReadRequestP16AsyncReadCommand(i4);
 i6 = 1;
 return i6 | 0;
}

function __ZN13SpeedTreeWind30SetInitialDirectionAndStrengthERK8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0, i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 1380 >> 2] = i4;
 HEAP32[i1 + 1496 >> 2] = i4;
 HEAP32[i1 + 1528 >> 2] = i4;
 HEAP32[i1 + 1484 >> 2] = i4;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 1384 >> 2] = i4;
 HEAP32[i1 + 1500 >> 2] = i4;
 HEAP32[i1 + 1532 >> 2] = i4;
 HEAP32[i1 + 1488 >> 2] = i4;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 1388 >> 2] = i4;
 HEAP32[i1 + 1504 >> 2] = i4;
 HEAP32[i1 + 1536 >> 2] = i4;
 HEAP32[i1 + 1492 >> 2] = i4;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 1456 >> 2] = i2;
 HEAP32[i1 + 1480 >> 2] = i2;
 HEAP32[i1 + 1376 >> 2] = i2;
 d3 = +HEAPF64[i1 + 1392 >> 3];
 HEAPF64[i1 + 1464 >> 3] = d3;
 HEAPF64[i1 + 1472 >> 3] = d3;
 return;
}

function __ZN12InputManager11SetKeyStateEib(i4, i3, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i3 >>> 5;
 i6 = i4 + 48 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
 i7 = 1 << (i3 & 31);
 i3 = (i1 & i7 | 0) != 0;
 if (i5) {
  if (!i3) {
   i1 = (HEAP32[i4 + 68 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
  }
  HEAP32[i2 + (i8 << 2) >> 2] = i1 | i7;
  return;
 } else {
  if (i3) {
   i1 = (HEAP32[i4 + 88 >> 2] | 0) + (i8 << 2) | 0;
   HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i7;
   i1 = HEAP32[i6 >> 2] | 0;
   i2 = i1;
   i1 = HEAP32[i1 + (i8 << 2) >> 2] | 0;
  }
  HEAP32[i2 + (i8 << 2) >> 2] = i1 & ~i7;
  return;
 }
}

function __ZN11Rigidbody2D18SetAngularVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808161 | 0, 0, gb + 807613 | 0, 1046, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i4) return;
 if (HEAP8[i1 + 227 >> 0] | 0) {
  HEAPF32[i1 + 220 >> 2] = f2;
  return;
 }
 f2 = Math_fround(f2 * Math_fround(.0174532924));
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = i4 + 4 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (i1 & 16) return;
 if (Math_fround(f2 * f2) > Math_fround(0.0)) {
  i1 = i1 & 65535;
  if (!(i1 & 2)) {
   HEAP16[i3 >> 1] = i1 | 2;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  }
 }
 HEAPF32[i4 + 72 >> 2] = f2;
 return;
}

function __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 i3 = i1 + 56 | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 24 | 0;
 if ((i4 + 1 | 0) >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP8[i4 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i3, 1);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i2);
 i1 = i1 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i5 >> 2] = i3;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i5, i1, 4);
  return;
 }
}

function __Z24Animator_CUSTOM_GetStatsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZN8Animator8GetStatsEv(i2, i3);
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i1 = i3 << 24 >> 24 < 0;
  i3 = __Z20scripting_string_newPKcj(i1 ? HEAP32[i2 >> 2] | 0 : i2, i1 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z19AddCurveToDenseClipIfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, f11 = f0, f12 = f0;
 if ((HEAP32[i2 >> 2] | 0) <= 0) return;
 i5 = i2 + 12 | 0;
 i6 = i2 + 8 | 0;
 i7 = i2 + 20 | 0;
 i8 = i2 + 4 | 0;
 i9 = i7;
 i1 = 0;
 do {
  f12 = Math_fround(HEAPF32[i5 >> 2]);
  f11 = Math_fround(i1 | 0);
  f11 = Math_fround(f12 + Math_fround(f11 / Math_fround(HEAPF32[i6 >> 2])));
  i10 = (Math_imul(HEAP32[i8 >> 2] | 0, i1) | 0) + i3 | 0;
  i10 = (HEAP32[i7 >> 2] | 0) + i9 + (i10 << 2) | 0;
  HEAPF32[i10 >> 2] = Math_fround(__ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE(i4, f11, 0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 return;
}

function __Z13RegisterClassI4TreeEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 996;
 HEAP32[i2 + 8 >> 2] = gb + 935475;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 193;
 HEAP32[i2 + 20 >> 2] = 88;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 184796;
 HEAP32[i2 + 44 >> 2] = fb + 319;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 320;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17CapsuleCollider2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 864;
 HEAP32[i2 + 8 >> 2] = gb + 801045;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 70;
 HEAP32[i2 + 20 >> 2] = 172;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154352;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17BillboardRendererEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 575;
 HEAP32[i2 + 8 >> 2] = gb + 422379;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 227;
 HEAP32[i2 + 20 >> 2] = 380;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29752;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15PointEffector2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 153580;
 HEAP32[i2 + 4 >> 2] = fb + 884;
 HEAP32[i2 + 8 >> 2] = gb + 802334;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 250;
 HEAP32[i2 + 20 >> 2] = 124;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156888;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15FrictionJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 872;
 HEAP32[i2 + 8 >> 2] = gb + 801408;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 256;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 155788;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15DistanceJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 868;
 HEAP32[i2 + 8 >> 2] = gb + 801269;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 232;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 155168;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UNITY_tt_face_done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i1) return;
 i3 = HEAP32[i1 + 100 >> 2] | 0;
 i4 = HEAP32[i1 + 104 >> 2] | 0;
 i5 = HEAP32[i1 + 532 >> 2] | 0;
 i6 = i1 + 656 | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 if (i2 | 0) mftCall_vi(i2 | 0, HEAP32[i6 >> 2] | 0);
 if (i5 | 0) mftCall_vi(HEAP32[i5 + 12 >> 2] | 0, i1 | 0);
 _UNITY_tt_face_done_loca(i1);
 _UNITY_tt_face_free_hdmx(i1);
 i6 = i1 + 648 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 + 644 >> 2] = 0;
 _UNITY_FT_Stream_ReleaseFrame(i4, i1 + 632 | 0);
 _UNITY_FT_Stream_ReleaseFrame(i4, i1 + 640 | 0);
 HEAP32[i1 + 628 >> 2] = 0;
 HEAP32[i1 + 636 >> 2] = 0;
 i6 = i1 + 676 | 0;
 _UNITY_tt_done_blend(i3, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 return;
}

function _UNITY_png_read_filter_row_avg(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = ((HEAPU8[i1 + 11 >> 0] | 0) + 7 | 0) >>> 3;
 i7 = (HEAP32[i1 + 4 >> 2] | 0) - i6 | 0;
 if (!i6) i1 = i2; else {
  i1 = i2 + i6 | 0;
  i5 = i3;
  i4 = 0;
  while (1) {
   HEAP8[i5 >> 0] = ((HEAPU8[i2 >> 0] | 0) >>> 1 & 255) + (HEAPU8[i5 >> 0] | 0);
   i4 = i4 + 1 | 0;
   if ((i4 | 0) == (i6 | 0)) break; else {
    i5 = i5 + 1 | 0;
    i2 = i2 + 1 | 0;
   }
  }
  i3 = i3 + i6 | 0;
 }
 if (!i7) return;
 i4 = 0 - i6 | 0;
 i2 = 0;
 while (1) {
  HEAP8[i3 >> 0] = (((HEAPU8[i3 + i4 >> 0] | 0) + (HEAPU8[i1 >> 0] | 0) | 0) >>> 1) + (HEAPU8[i3 >> 0] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i3 = i3 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function ___fopen_rb_ca(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i1;
 i7 = i6 + 112 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i7 | 0));
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = 557056;
 HEAP32[i5 + 8 >> 2] = 0;
 i7 = ___syscall_ret(___syscall5(5, i5 | 0) | 0) | 0;
 HEAP32[i1 + 60 >> 2] = i7;
 if ((i7 | 0) < 0) i1 = 0; else {
  HEAP32[i1 >> 2] = 9;
  HEAP32[i1 + 44 >> 2] = i3 + 8;
  HEAP32[i1 + 48 >> 2] = i4 + -8;
  HEAP32[i1 + 32 >> 2] = fb + 297;
  HEAP32[i1 + 40 >> 2] = fb + 296;
  HEAP32[i1 + 12 >> 2] = fb + 1404;
  HEAP32[i1 + 76 >> 2] = -1;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK13b2PulleyJoint17GetCurrentLengthAEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f4 = Math_fround(f3 * f7);
 f6 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 96 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f6 * f2));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f2 = Math_fround(Math_fround(f7 * f6) + Math_fround(f3 * f2));
 f2 = Math_fround(f2 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 f3 = Math_fround(f4 - f3);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 72 >> 2]));
 return Math_fround(Math_sqrt(Math_fround(Math_fround(f3 * f3) + Math_fround(f2 * f2))));
}

function __ZN8GUILayer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(36, i1, 16, gb + 1048932 | 0, 0, gb + 385796 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP8[i4 + 32 >> 0] = 1;
 HEAP8[i4 + 33 >> 0] = 0;
 HEAP32[i4 >> 2] = gb + 36592 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx7NpCloth10putToSleepEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  __ZN5physx2Sc9ClothCore10putToSleepEv(i1 + 32 | 0);
  STACKTOP = i4;
  return;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1011, gb + 691624 | 0, i2);
  STACKTOP = i4;
  return;
 }
}

function __ZN31CanvasBatchIntermediateRenderer16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 8 | 0;
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63696 | 0, 16, gb + 936496 | 0, gb + 375248 | 0, gb + 375269 | 0, 231) | 0;
 i4 = HEAP32[gb + 33696 >> 2] | 0;
 i8 = gb + 63696 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 375349 | 0, 320, i4, i3, 16);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1110384 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN13RenderTexture8SetWidthEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i1 + 80 >> 2] = i2;
  i3 = (HEAP8[i1 + 116 >> 0] | 0) == 0;
  i5 = i1 + 76 | 0;
  HEAP32[i5 >> 2] = 1;
  if (!i2) return;
  i4 = HEAP32[i1 + 84 >> 2] | 0;
  if (!i4) return;
  f6 = Math_fround(Math_fround(1.0) / Math_fround(i4 | 0));
  HEAPF32[i1 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i2 | 0));
  HEAPF32[i1 + 72 >> 2] = f6;
  if (i3) i1 = 1; else i1 = __Z22CalculateMipMapCount3Diii(i2, i4, 1) | 0;
  HEAP32[i5 >> 2] = i1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407509 | 0, 0, gb + 406201 | 0, 911, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN12HingeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(120, i1, 16, gb + 1048932 | 0, 0, gb + 806223 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 155828 + 8;
 HEAP8[i4 + 114 >> 0] = 0;
 HEAPF32[i4 + 116 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12FixedJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 806074 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 155404 + 8;
 HEAP8[i4 + 104 >> 0] = 0;
 HEAPF32[i4 + 108 >> 2] = Math_fround(0.0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI6CameraEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 529;
 HEAP32[i2 + 8 >> 2] = gb + 1044265;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 20;
 HEAP32[i2 + 20 >> 2] = 1304;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29832;
 HEAP32[i2 + 44 >> 2] = fb + 8;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 9;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI16CircleCollider2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 865;
 HEAP32[i2 + 8 >> 2] = gb + 801075;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 58;
 HEAP32[i2 + 20 >> 2] = 164;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154548;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15RelativeJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32628;
 HEAP32[i2 + 4 >> 2] = fb + 879;
 HEAP32[i2 + 8 >> 2] = gb + 802586;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 254;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157292;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15ConstantForce2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 154956;
 HEAP32[i2 + 4 >> 2] = fb + 867;
 HEAP32[i2 + 8 >> 2] = gb + 801092;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 247;
 HEAP32[i2 + 20 >> 2] = 68;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 154768;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_SwInterCollision_cpp() {
 HEAP32[gb + 1097600 >> 2] = -1;
 HEAP32[gb + 1097600 + 4 >> 2] = -1;
 HEAP32[gb + 1097600 + 8 >> 2] = -1;
 HEAP32[gb + 1097600 + 12 >> 2] = 0;
 HEAP32[gb + 1097616 >> 2] = 0;
 HEAP32[gb + 1097616 + 4 >> 2] = 0;
 HEAP32[gb + 1097616 + 8 >> 2] = 0;
 HEAP32[gb + 1097616 + 12 >> 2] = -1;
 HEAP32[gb + 1097632 >> 2] = 872415232;
 HEAP32[gb + 1097632 + 4 >> 2] = 872415232;
 HEAP32[gb + 1097632 + 8 >> 2] = 872415232;
 HEAP32[gb + 1097632 + 12 >> 2] = 872415232;
 HEAPF32[gb + 1097648 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097648 + 4 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097648 + 8 >> 2] = Math_fround(-3402823469999999843913219.0e14);
 HEAPF32[gb + 1097648 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZThn32_N14SpriteRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + -32 | 0;
 i1 = __ZN8Renderer12GetTransformEv(i3) | 0;
 i4 = i3 + 36 | 0;
 i2 = HEAP16[i3 + 272 >> 1] | 0;
 if (!((i2 & 255) << 24 >> 24)) i1 = (i2 & 65535) >>> 8 & 255; else {
  i2 = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i4);
  HEAP32[i3 + 212 >> 2] = i2 & -8 | 2;
  i1 = HEAP8[i3 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  i2 = i3 + 188 | 0;
  i3 = i3 + 164 | 0;
  __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i2, i4, i3);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0);
 i2 = i3 + 188 | 0;
 i3 = i3 + 164 | 0;
 __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i2, i4, i3);
 return;
}

function __ZNK11Rigidbody2D8GetPointERK8Vector2f(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 } else {
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 12 >> 2]));
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i1 + 16 >> 2]));
  f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f7 = Math_fround(f4 * f8);
  f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f4 = Math_fround(Math_fround(f8 * f6) - Math_fround(f4 * f5));
  HEAPF32[i2 >> 2] = Math_fround(f7 + Math_fround(f6 * f5));
  HEAPF32[i2 + 4 >> 2] = f4;
  return;
 }
}

function __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i3;
 HEAP8[i4 + 24 >> 0] = 1;
 HEAP8[i4 + 25 >> 0] = 0;
 i1 = i4 + 28 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP8[i4 + 27 >> 0] = i2 >>> 9 & 1;
 i1 = i3 + -19 | 0;
 if (i1 >>> 0 >= 7) {
  i3 = 0;
  i5 = i4 + 26 | 0;
  HEAP8[i5 >> 0] = i3;
  return;
 }
 i3 = 97 >>> (i1 & 127) & 1;
 i5 = i4 + 26 | 0;
 HEAP8[i5 >> 0] = i3;
 return;
}

function __ZN5physx7NpCloth24setSelfCollisionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore24setSelfCollisionDistanceEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 771, gb + 693127 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sc10NPhaseCore36addToForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = i5;
 i2 = i5 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8388608;
 i2 = i6 + 32 | 0;
 i3 = i6 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 52 >> 2] = i4;
 if ((HEAP32[i6 + 40 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5Umbra16VisibilityResultD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if (i1 | 0) {
  i3 = i2 + 24 | 0;
  _memcpy(i1 | 0, HEAP32[i3 >> 2] | 0, 1424) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
 }
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 4 >> 2] | 0)) HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] = 2;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 8 >> 2] | 0) <= (HEAP32[i1 + 4 >> 2] | 0)) return;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] = 2;
 return;
}

function __ZN2UI11CanvasGroupC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 186704 + 8;
 HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 40 >> 0] = 1;
 HEAP8[i1 + 41 >> 0] = 1;
 HEAP8[i1 + 42 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN28LightProbeProxyVolumeManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i5 = i3;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 i7 = gb + 63536 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN28LightProbeProxyVolumeContextC2E10MemLabelId(i1 + 20 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN23TransformChangeDispatch15InitializeClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63160 | 0, 16, gb + 421957 | 0, 451) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i2 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[gb + 1158396 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 946403 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN20TextRenderingPrivate7GUIText8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19ShaderPropertySheet26SetTextureScaleOffsetValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f(i6, i3, i4, i7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i6 + 72 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + i3 + 20 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i6, i4, gb + 478716 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 + i3 + 20 >> 2] = i2;
 }
 i6 = i1 + (HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + ((HEAP32[i6 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 return;
}

function __ZN13WheelCollider24ConfigureVehicleSubstepsEfii(i2, f3, i4, i5) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 if ((HEAP32[i2 + 148 >> 2] | 0) == -1) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 56 >> 2] | 0)) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 if (f3 > Math_fround(0.0) & (i4 | 0) > 0 & (i5 | 0) > 0) {
  __ZN5physx22PxVehicleWheelsSimData15setSubStepCountEfjj((HEAP32[i1 + 56 >> 2] | 0) + 8 | 0, f3, i4, i5);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 836049 | 0, 0, gb + 826839 | 0, 1234, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
}

function __ZN10GUIElement17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[gb + 1114500 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 20 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIb4PPtrI10GUIElementEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i4 + 12 | 0, i3);
  STACKTOP = i5;
  return;
 } else {
  i6 = i3;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
  STACKTOP = i5;
  return;
 }
}

function __Z40SkinnedMeshRenderer_Get_Custom_PropBonesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = i2 + 360 | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(4) | 0;
  i3 = __Z19GetScriptingManagerv() | 0;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i1 + 12 >> 2] | 0) | 0;
  __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI9TransformELj4EEEiP11Il2CppArrayRKT_i(i2, i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z36GetParticleSystemScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1452344 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63728 | 0, 16, gb + 622695 | 0, 16) | 0;
 HEAP32[gb + 1452344 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049809 | 0) | 0;
 HEAP32[HEAP32[gb + 1452344 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 622826 | 0) | 0;
 HEAP32[(HEAP32[gb + 1452344 >> 2] | 0) + 4 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049818 | 0) | 0;
 HEAP32[(HEAP32[gb + 1452344 >> 2] | 0) + 8 >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 203 | 0, fb + 204 | 0);
 i1 = HEAP32[gb + 1452344 >> 2] | 0;
 return i1 | 0;
}

function __Z14RectfToRectIntRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f6 + Math_fround(.5));
 i5 = f8 >= Math_fround(0.0);
 f4 = Math_fround(f8 + Math_fround(-.99999994));
 i5 = ~~(i5 ? f8 : f4);
 HEAP32[i1 >> 2] = i5;
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f4 + Math_fround(.5));
 i3 = f8 >= Math_fround(0.0);
 f7 = Math_fround(f8 + Math_fround(-.99999994));
 i3 = ~~(i3 ? f8 : f7);
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = (~~Math_fround(Math_fround(f6 + Math_fround(HEAPF32[i2 + 8 >> 2])) + Math_fround(.5)) >>> 0) - i5;
 HEAP32[i1 + 12 >> 2] = (~~Math_fround(Math_fround(f4 + Math_fround(HEAPF32[i2 + 12 >> 2])) + Math_fround(.5)) >>> 0) - i3;
 return;
}

function __Z13RegisterClassI5LightEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 536;
 HEAP32[i2 + 8 >> 2] = gb + 374193;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 108;
 HEAP32[i2 + 20 >> 2] = 64;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30512;
 HEAP32[i2 + 44 >> 2] = fb + 16;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 17;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13SpringJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 881;
 HEAP32[i2 + 8 >> 2] = gb + 803021;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 231;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157844;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13SliderJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 880;
 HEAP32[i2 + 8 >> 2] = gb + 802891;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 234;
 HEAP32[i2 + 20 >> 2] = 124;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 157632;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_(i1, i9, i8, i4, i5, i6, gb + 1078761 | 0, gb + 1078761 + 8 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN5physx9NpFactory20createNpArticulationEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 2740 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i4 + 2736 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4 + 2444 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i4 + 2724 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i4 = i4 + 2728 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  i4 = 0;
  i3 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
  return i4 | 0;
 }
 __ZN5physx14NpArticulationC2Ev(i1);
 i4 = i1;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
 return i4 | 0;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAP32[i1 >> 2] = i4;
 i2 = i5 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 + 56 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i5 + 48 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  i5 = i5 + 92 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i5 + 44 | 0, i1) | 0;
  i5 = i5 + 92 | 0;
  HEAP8[i5 >> 0] = 1;
  STACKTOP = i6;
  return;
 }
}

function __ZN5physx7NpCloth16setRestPositionsEPKNS_6PxVec4E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore16setRestPositionsEPKNS_6PxVec4E(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 821, gb + 692625 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 8 >> 2] = i1;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 << 3, gb + 838004 | 0, 543) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i2 + (HEAP32[i5 >> 2] << 3) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  i6 = i1;
  i4 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i2;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i4;
  i2 = i2 + 8 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function __ZN4FMOD6System11getSoundRAMEPiS1_S1_(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869645;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869645;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869645;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN14DetailDatabase18CreateTextureAtlasEPP9Texture2DP5RectTIfEjb(i1, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i2 = i1 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 L1 : do if ((i7 | 0) > 0) {
  i1 = 0;
  while (1) {
   i4 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   if (i4 | 0) if (HEAP32[i4 + 60 >> 2] | 0) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i7 | 0)) {
    i9 = 6;
    break L1;
   }
  }
  __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 1);
 } else i9 = 6; while (0);
 if ((i9 | 0) == 6) __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i3, 0);
 __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb(HEAP32[i2 >> 2] | 0, 2048, i7, i5, i6, 0, i8, 0) | 0;
 return;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStreamD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150892 + 8;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i5 = 3; else {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  if (!i3) i5 = 3;
 }
 if ((i5 | 0) == 3) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  __ZN5physx6shdfnd6Socket10disconnectEv(i3);
  __ZN5physx6shdfnd6SocketD2Ev(i3);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 HEAP32[i4 + 12 >> 2] = gb + 148172 + 8;
 i5 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i5 >> 2] | 0);
 __ZdlPv(i4);
 return;
}

function __ZN11UnityEngine7Connect16PersistentValues10SaveValuesER9JSONWrite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 1041356 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 1041368 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1041382 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 1041396 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 1041407 | 0, 0);
 __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 1042308 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 1042326 | 0, 0);
 return;
}

function __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKRotationInternalP12Il2CppObjectiR11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZN8Animator15GetGoalRotationEi(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z39Renderer_Get_Custom_PropSharedMaterialsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = i2 + 288 | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(21) | 0;
  i3 = __Z19GetScriptingManagerv() | 0;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(HEAP32[i3 + 168 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] | 0, 4, HEAP32[i1 + 12 >> 2] | 0) | 0;
  __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI8MaterialELj4EEEiP11Il2CppArrayRKT_i(i2, i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z30Playable_CUSTOM_InternalCreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i3 = __Z18GetDirectorManagerv() | 0;
 if (!i1) i1 = 0; else i1 = __Z20scripting_object_newP11Il2CppClass(__Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0) | 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63784 | 0, 16, gb + 913955 | 0, 41) | 0;
 __ZN8PlayableC2EP12Il2CppObject18DirectorPlayerType(i5, i1, 3);
 __ZN8Playable6HandleEv(i2, i5);
 i3 = __ZN15DirectorManager18FinishConstructionEP12Il2CppObjectR9HPlayable(i3, i1, i2) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i4 << 24 >> 24 < 0;
 i4 = i1 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 if (!i4) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i3);
  return;
 }
 i1 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 if ((HEAP8[i1 >> 0] | 0) == 47 & (i4 | 0) != 1) {
  i1 = i1 + 1 | 0;
  if ((HEAP8[i1 >> 0] | 0) != 47) {
   HEAP32[i2 >> 2] = 0;
   HEAP32[i2 + 4 >> 2] = 0;
   HEAP32[i2 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i1, i4 + -1 | 0);
   return;
  }
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i3);
 return;
}

function __Z13RegisterClassI15CapsuleColliderEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 841;
 HEAP32[i2 + 8 >> 2] = gb + 733808;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 136;
 HEAP32[i2 + 20 >> 2] = 84;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 64328;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14SphereColliderEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 854;
 HEAP32[i2 + 8 >> 2] = gb + 737689;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 135;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113668;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14EdgeCollider2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 869;
 HEAP32[i2 + 8 >> 2] = gb + 801380;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 68;
 HEAP32[i2 + 20 >> 2] = 180;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 155364;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13TargetJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32628;
 HEAP32[i2 + 4 >> 2] = fb + 882;
 HEAP32[i2 + 8 >> 2] = gb + 803162;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 257;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 158272;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12WheelJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 887;
 HEAP32[i2 + 8 >> 2] = gb + 803207;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 235;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 158484;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12FixedJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 871;
 HEAP32[i2 + 8 >> 2] = gb + 801395;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 255;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 155576;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 120080 + 8;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) {
  __ZdlPv(i2);
  return;
 }
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_(i1, i9, i8, i4, i5, i6, gb + 211284 | 0, gb + 211284 + 32 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcjj(i2, i7, i5, i3) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i6 = HEAP32[i2 >> 2] | 0;
 } else {
  i1 = i1 & 255;
  i6 = i2;
 }
 if ((i3 | 0) == 0 | i1 >>> 0 <= i5 >>> 0) i1 = -1; else {
  i4 = i6 + i1 | 0;
  i3 = i7 + i3 | 0;
  i1 = i6 + i5 | 0;
  L7 : while (1) {
   if ((i1 | 0) == (i4 | 0)) {
    i1 = i4;
    break;
   } else i2 = i7;
   while (1) {
    if ((i2 | 0) == (i3 | 0)) break;
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i2 >> 0] | 0)) break L7; else i2 = i2 + 1 | 0;
   }
   i1 = i1 + 1 | 0;
  }
  i1 = (i1 | 0) == (i4 | 0) ? -1 : i1 - i6 | 0;
 }
 return i1 | 0;
}

function __ZNK10FileSystem11MoveToTrashEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i4 + 1040 | 0;
 HEAP8[i4 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __ZN15FileSystemEntry3SetEPKc(i4, i2);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i4 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i4 | 0);
 i4 = i2;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN9Transform23SetIsDispatchInterestedERK27TransformChangeSystemHandleb(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 1158396 >> 2] | 0;
 i1 = i1 + 32 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i3 + 28 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i3 + 40 >> 2];
 i2 = 1 << i2;
 i3 = (HEAP32[i1 + 60 >> 2] | 0) + (i4 << 2) | 0;
 if (i5) {
  i5 = HEAP32[i3 >> 2] | i2;
  HEAP32[i3 >> 2] = i5;
  return;
 } else {
  i5 = ~i2;
  i4 = (HEAP32[i1 + 56 >> 2] | 0) + (i4 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & i5;
  i5 = HEAP32[i3 >> 2] & i5;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN9CGProgramD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 68632 + 8;
 i1 = i2 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 92 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN9TextAssetD2Ev(i2);
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 76 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZN9TextAssetD2Ev(i2);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN9Animation23RemoveContainedRendererEP8Renderer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 68 | 0;
 i6 = i1 + 72 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i4 = 8;
   break;
  }
 }
 if ((i4 | 0) == 8) return;
 HEAP32[i1 >> 2] = HEAP32[i2 + -4 >> 2];
 i3 = HEAP32[i6 >> 2] | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 - i1 >> 2;
 if (!i2) {
  __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj(i5, -1);
  return;
 }
 i1 = i1 + (i2 + -1 << 2) | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 HEAP32[i6 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN8UserList11RemoveIndexEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + -1 | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i4 = i2;
  i4 = i4 + -1 | 0;
  HEAP32[i5 >> 2] = i4;
  return;
 }
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i7 = i2 + (i3 << 3) | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i2 + (i4 << 3) | 0;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + (i3 << 3) | 0;
 i1 = HEAP32[i1 + (i3 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = (HEAP32[i2 >> 2] | 0) + 4 | 0; else i1 = (HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0) + (i1 << 3) | 0;
 HEAP32[i1 + 4 >> 2] = i4;
 i7 = HEAP32[i5 >> 2] | 0;
 i7 = i7 + -1 | 0;
 HEAP32[i5 >> 2] = i7;
 return;
}

function __ZN7ApiGLES11BindTextureEjj16TextureDimension(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 1992 | 0;
 i1 = i2 + 1600 | 0;
 if (!(HEAP8[i6 >> 0] | 0)) i7 = 3; else if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) i7 = 4; else i7 = 3;
 if ((i7 | 0) == 3) {
  mftCall_vi(HEAP32[i2 + 808 >> 2] | 0, i3 + 33984 | 0);
  HEAP32[i1 >> 2] = i3;
  if (HEAP8[i6 >> 0] | 0) i7 = 4;
 }
 if ((i7 | 0) == 4) if ((HEAP32[i2 + 1604 + (i3 << 2) >> 2] | 0) == (i4 | 0)) return;
 i7 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i2 + 860 >> 2] | 0, i5) | 0;
 mftCall_vii(HEAP32[i2 + 812 >> 2] | 0, i7 | 0, i4 | 0);
 HEAP32[i2 + 1604 + (HEAP32[i1 >> 2] << 2) >> 2] = i4;
 HEAP32[i2 + 1732 + (HEAP32[i1 >> 2] << 2) >> 2] = i5;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIsdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN4FMOD6System17createDSPByPluginEjPPNS_3DSPE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869204;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869204;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869204;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1011545 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15SerializeTraitsIN2UI11CanvasGroupEE8TransferI14SafeBinaryReadEEvRS1_RT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorEC2EjjbP15BucketAllocatorPKc(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i1 + 4 >> 2] = i6;
 i6 = i1 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[gb + 27044 >> 2] = (HEAP32[gb + 27044 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 27044 >> 2];
 HEAP32[i1 >> 2] = gb + 26828 + 8;
 HEAP32[i1 + 32 >> 2] = i5;
 i6 = i1 + 40 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 44 >> 2] = i6;
 i6 = i1 + 48 | 0;
 HEAP32[i6 >> 2] = i6;
 HEAP32[i1 + 52 >> 2] = i6;
 HEAP8[i1 + 57 >> 0] = i4 & 1;
 HEAP32[i1 + 36 >> 2] = i3;
 HEAP32[i1 + 60 >> 2] = i2;
 HEAP32[i1 + 64 >> 2] = 0;
 return;
}

function __ZN19ShaderPropertySheet24SetTextureTexelSizeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f(i6, i3, i4, i7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i6 + 72 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + i3 + 24 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i6, i4, gb + 478720 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 + i3 + 24 >> 2] = i2;
 }
 i6 = i1 + (HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + ((HEAP32[i6 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 return;
}

function __ZN19ShaderPropertySheet24SetTextureHDRDecodeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f(i6, i3, i4, i7) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i6 + 72 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i1 + i3 + 28 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i2 = __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc(i6, i4, gb + 478731 | 0) | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i1 + i3 + 28 >> 2] = i2;
 }
 i6 = i1 + (HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + ((HEAP32[i6 + 12 >> 2] | 0) + i2 << 2) >> 2] & 1048575) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 return;
}

function __ZN15TextureTFMethod15UnmapBoneBufferEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 i4 = i2 + 32 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 40 + (i1 << 2) >> 2] | 0) >>> 0 < i3 >>> 0) {
  __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i2 + 20 + (i1 << 2) | 0);
  i1 = __ZN7ApiGLES13CreateTextureE16TextureDimensionN2gl9TexFormatEiiiii(HEAP32[gb + 1451080 >> 2] | 0, 2, 25, 1, 1, 3, i3, 1) | 0;
  HEAP32[i2 + 20 + (HEAP32[i4 >> 2] << 2) >> 2] = i1;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i2 + 20 + (i1 << 2) >> 2] | 0, 2, 0, 25, 0, 3, i3, 1, 0, HEAP32[i2 + 8 >> 2] | 0);
 HEAP32[i2 + 40 + (HEAP32[i4 >> 2] << 2) >> 2] = i3;
 return;
}

function __ZN14TerrainManager23AfterCullingOutputReadyEPK9IndexListPK16RendererCullData(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1467660 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1467660 | 0, i1);
  i1 = gb + 1467660 | 0;
 } else i1 = 0;
 i2 = __Z18GetITerrainManagerv() | 0;
 __ZN12TreeRenderer15WillRenderTreesERK9IndexListPK9SceneNodeR13dynamic_arrayIbLj1EE(i3 + 48 | 0, HEAP32[i4 + 52 >> 2] | 0, i2 + 20 | 0);
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStreamD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150856 + 8;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i5 = 3; else {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  if (!i3) i5 = 3;
 }
 if ((i5 | 0) == 3) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  __ZN5physx6shdfnd6Socket10disconnectEv(i3);
  __ZN5physx6shdfnd6SocketD2Ev(i3);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 HEAP32[i4 + 12 >> 2] = gb + 148172 + 8;
 i5 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i5 >> 2] | 0);
 __ZdlPv(i4);
 return;
}

function __Z37Camera_CUSTOM_SetTargetBuffersMRTImplP12Il2CppObjectP11Il2CppArrayP21ScriptingRenderBuffer(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 if ((i4 + -1 | 0) >>> 0 > 7) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 502716 | 0, 0, gb + 502764 | 0, 493, 1, 0, 0, 0);
  return;
 }
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 __ZN6Camera22SetTargetBuffersScriptEiPK21ScriptingRenderBufferPS0_(i5, i4, __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0, i3);
 return;
}

function __Z13classifyPointPKfS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f7 >= Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i5 = f6 >= Math_fround(HEAPF32[i3 + 8 >> 2]);
 i1 = f7 < Math_fround(HEAPF32[i2 >> 2]);
 i3 = f6 < Math_fround(HEAPF32[i2 + 8 >> 2]);
 switch (((i5 ? 2 : 0) | i4 & 1 | (i1 ? 4 : 0) | (i3 ? 8 : 0)) & 15) {
 case 1:
  {
   i1 = 0;
   break;
  }
 case 3:
  {
   i1 = 1;
   break;
  }
 case 2:
  {
   i1 = 2;
   break;
  }
 case 6:
  {
   i1 = 3;
   break;
  }
 case 4:
  {
   i1 = 4;
   break;
  }
 case 12:
  {
   i1 = 5;
   break;
  }
 case 8:
  {
   i1 = 6;
   break;
  }
 case 9:
  {
   i1 = 7;
   break;
  }
 default:
  i1 = -1;
 }
 return i1 | 0;
}

function __Z13RegisterClassIN5Unity5ClothEEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 904;
 HEAP32[i2 + 8 >> 2] = gb + 839010;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 183;
 HEAP32[i2 + 20 >> 2] = 384;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 168704;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14BillboardAssetEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 574;
 HEAP32[i2 + 8 >> 2] = gb + 422256;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 226;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29712;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13BoxCollider2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32588;
 HEAP32[i2 + 4 >> 2] = fb + 862;
 HEAP32[i2 + 8 >> 2] = gb + 800904;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 61;
 HEAP32[i2 + 20 >> 2] = 168;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 153776;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12HingeJoint2DEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 152968;
 HEAP32[i2 + 4 >> 2] = fb + 873;
 HEAP32[i2 + 8 >> 2] = gb + 801424;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 233;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156e3;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _unzGetLocalExtrafield(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i6 = -102;
  return i6 | 0;
 }
 i5 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i5) {
  i6 = -102;
  return i6 | 0;
 }
 i4 = HEAP32[i5 + 76 >> 2] | 0;
 i1 = (HEAP32[i5 + 72 >> 2] | 0) - i4 | 0;
 if (!i6) {
  i6 = i1;
  return i6 | 0;
 }
 i1 = i1 >>> 0 < i2 >>> 0 ? i1 : i2;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = i5 + 124 | 0;
 i3 = i5 + 128 | 0;
 if (mftCall_iiiii(HEAP32[i5 + 112 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, (HEAP32[i5 + 68 >> 2] | 0) + i4 | 0, 0) | 0) {
  i6 = -1;
  return i6 | 0;
 }
 i6 = (mftCall_iiiii(HEAP32[i5 + 100 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6 | 0, i1 | 0) | 0) == (i1 | 0);
 i6 = i6 ? i1 : -1;
 return i6 | 0;
}

function _read_restart_marker(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 380 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do if (!i1) if (!((_next_marker(i4) | 0) << 24 >> 24)) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = HEAP32[i5 >> 2] | 0;
  break;
 } while (0);
 i2 = i4 + 404 | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if ((i1 | 0) == (i3 + 208 | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 98;
  HEAP32[i1 + 24 >> 2] = i3;
  mftCall_vii(HEAP32[i1 + 4 >> 2] | 0, i4 | 0, 3);
  HEAP32[i5 >> 2] = 0;
 } else if (!((mftCall_iii(HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i3 | 0) | 0) << 24 >> 24)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (HEAP32[i2 >> 2] | 0) + 16 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1 & 7;
 i5 = 1;
 return i5 | 0;
}

function __ZNK9AudioClip10GetBitRateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) if (HEAP32[i1 + 124 >> 2] | 0) {
  i4 = i1 + 56 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i2 = __ZNK14SoundHandleAPI14GetNumChannelsEv(i1) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  f3 = Math_fround(Math_imul(__ZNK14SoundHandleAPI16GetBitsPerSampleEv(i1) | 0, i2) | 0);
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i4 = ~~Math_fround(f3 * Math_fround(__ZNK14SoundHandleAPI12GetFrequencyEv(i1))) >>> 0;
  return i4 | 0;
 }
 i4 = Math_imul(HEAP32[i1 + 40 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
 return i4 | 0;
}

function __ZNK13WheelCollider6GetRpmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(+Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj((HEAP32[i2 + 56 >> 2] | 0) + 72 | 0, HEAP32[i3 >> 2] | 0)) / 6.2831854820251465 * 60.0);
 return Math_fround(f4);
}

function __ZN8LODGroup23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 if ((i3 | 0) == (i6 | 0)) return;
 i7 = i2 + 16 | 0;
 i8 = i2 + 36 | 0;
 i5 = i2 + 40 | 0;
 do {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  i2 = HEAP32[i3 + 20 >> 2] | 0;
  i4 = i1 + (i2 << 2) | 0;
  if (i2 | 0) do {
   i2 = HEAP32[i7 >> 2] | 0;
   i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i8 >> 2] | 0) | 0;
   if (HEAP8[i5 >> 0] | 0) HEAP32[i1 >> 2] = i2;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  i3 = i3 + 28 | 0;
 } while ((i3 | 0) != (i6 | 0));
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i6;
 HEAP32[i3 >> 2] = ((HEAP32[i1 + 4 >> 2] | 0) - i6 | 0) / 12 | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0, 4) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = 0;
 do {
  i6 = i2 + (i1 * 12 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, i4 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx15PxsParticleDataC2Ejb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 HEAP32[i3 >> 2] = gb + 96500 + 8;
 HEAP8[i3 + 4 >> 0] = 1;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP8[i3 + 12 >> 0] = i2 & 1;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 2122317823;
 HEAP32[i3 + 28 >> 2] = 2122317823;
 HEAP32[i3 + 32 >> 2] = 2122317823;
 HEAP32[i3 + 36 >> 2] = -25165825;
 HEAP32[i3 + 40 >> 2] = -25165825;
 HEAP32[i3 + 44 >> 2] = -25165825;
 i5 = i3 + 80 | 0;
 i4 = (i1 + 31 | 0) >>> 5;
 HEAP32[i3 + 56 >> 2] = i5;
 HEAP32[i3 + 60 >> 2] = i4 | -2147483648;
 i6 = (i4 << 2) + 15 & 1073741808;
 HEAP32[i3 + 48 >> 2] = i5 + i6;
 HEAP32[i3 + 52 >> 2] = i2 ? i5 + (i6 + (i1 << 5)) | 0 : 0;
 _memset(i5 | 0, 0, i4 << 2 | 0) | 0;
 return;
}

function __ZN13ScreenManager36EnableOrientationsFromPlayerSettingsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0;
 mftCall_viii(i2 | 0, i1 | 0, 1, __ZNK14PlayerSettings22GetAutoRotationAllowedEi(__Z17GetPlayerSettingsv() | 0, 0) | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0;
 mftCall_viii(i2 | 0, i1 | 0, 2, __ZNK14PlayerSettings22GetAutoRotationAllowedEi(__Z17GetPlayerSettingsv() | 0, 1) | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0;
 mftCall_viii(i2 | 0, i1 | 0, 8, __ZNK14PlayerSettings22GetAutoRotationAllowedEi(__Z17GetPlayerSettingsv() | 0, 2) | 0);
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0;
 mftCall_viii(i2 | 0, i1 | 0, 4, __ZNK14PlayerSettings22GetAutoRotationAllowedEi(__Z17GetPlayerSettingsv() | 0, 3) | 0);
 return;
}

function __ZN12TreeDatabase17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = i1 + 32 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) return;
 do {
  i3 = i2 + 128 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = i2 + 116 | 0;
   i1 = 0;
   do {
    __Z19DestroySingleObjectP6Object(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
  i3 = i2 + 88 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   i4 = i2 + 76 | 0;
   i1 = 0;
   do {
    __Z19DestroySingleObjectP6Object(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
  }
  i2 = i2 + 156 | 0;
 } while ((i2 | 0) != (HEAP32[i5 >> 2] | 0));
 return;
}

function __Z54CanvasRenderer_CUSTOM_INTERNAL_CALL_EnableRectClippingP12Il2CppObjectRK5RectTIfE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  __ZN2UI14CanvasRenderer18EnableRectClippingE5RectTIfE(i4, i1);
  STACKTOP = i5;
  return;
 }
}

function __Z31AnimationCurve_CUSTOM_RemoveKeyP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if ((i2 | 0) <= -1) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544428 | 0, i4);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 if ((HEAP32[i1 + 68 >> 2] | 0) > (i2 | 0)) {
  i4 = (HEAP32[i1 + 56 >> 2] | 0) + (i2 << 4) | 0;
  __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_(i1, i4, i4 + 16 | 0);
  STACKTOP = i5;
  return;
 } else __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544428 | 0, i4);
}

function __Z29Avatar_Get_Custom_PropIsHumanP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZNK6Avatar7IsValidEv(i1) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 i2 = (__ZN6Avatar8GetAssetEv(i1) | 0) + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = i2 + i1 + 40 | 0;
 i3 = (HEAP32[(HEAP32[i3 >> 2] | 0) + i3 >> 2] | 0) != 0 & 1;
 return i3 | 0;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 8 | 0;
 i4 = i1;
 i2 = i1 + 16 | 0;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function _pselect(i2, i3, i4, i5, i6, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i10 + 8 | 0;
 i7 = i10 + 32 | 0;
 i8 = i10;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = 8;
 i1 = (i6 | 0) != 0;
 if (i1) {
  i12 = i6;
  i11 = HEAP32[i12 + 4 >> 2] | 0;
  i6 = i8;
  HEAP32[i6 >> 2] = HEAP32[i12 >> 2];
  HEAP32[i6 + 4 >> 2] = i11;
 }
 HEAP32[i9 >> 2] = i2;
 HEAP32[i9 + 4 >> 2] = i3;
 HEAP32[i9 + 8 >> 2] = i4;
 HEAP32[i9 + 12 >> 2] = i5;
 HEAP32[i9 + 16 >> 2] = i1 ? i8 : 0;
 HEAP32[i9 + 20 >> 2] = i7;
 i12 = ___syscall_ret(___syscall308(308, i9 | 0) | 0) | 0;
 STACKTOP = i10;
 return i12 | 0;
}

function __ZNK9dtNavMesh9getTileAtEiii(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 4 >> 2] & (Math_imul(i7, -669632447) | 0) + (Math_imul(i6, -1918454973) | 0);
 i2 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 while (1) {
  i1 = i4 + (i2 * 56 | 0) | 0;
  i3 = HEAP32[i4 + (i2 * 56 | 0) + 8 >> 2] | 0;
  if (i3 | 0) if ((HEAP32[i3 + 8 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i7 | 0)) if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
   i2 = 8;
   break;
  }
  i2 = HEAP32[i4 + (i2 * 56 | 0) + 52 >> 2] | 0;
  if ((i2 | 0) == -1) {
   i1 = 0;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i3, i1, i5, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(i3, i4, i5) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i3, gb + 28940 | 0) | 0;
 if (!i2) {
  i5 = i1;
  return i5 | 0;
 }
 i2 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i2) {
  i5 = i1;
  return i5 | 0;
 }
 do {
  i1 = i1 | (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i2 + 28 >> 2] | 0, i4, i5) | 0);
  i2 = HEAP32[i2 + 100 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __ZN9Animation17SetAnimatePhysicsEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 HEAP8[i1 + 41 >> 0] = i3 & 1;
 i5 = i1 + 256 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i4 = i1 + 260 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[gb + 1465160 >> 2] | 0;
 if (i3) {
  i1 = i1 + 8 | 0;
  if ((i5 | 0) == (i1 | 0)) return;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
  return;
 } else {
  if ((i5 | 0) == (i1 | 0)) return;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 >> 2] = i3;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = i5;
  HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
  return;
 }
}

function __ZN5physx9NpFactory19createNpClothFabricEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 4552 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i4 + 4548 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv(i4 + 4256 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i4 + 4536 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i4 = i4 + 4540 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!i1) {
  i4 = 0;
  i3 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
  return i4 | 0;
 }
 __ZN5physx13NpClothFabricC2Ev(i1);
 i4 = i1;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
 return i4 | 0;
}

function __ZN5physx7NpCloth22setSleepLinearVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore22setSleepLinearVelocityEf(i1 + 32 | 0, f2);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 969, gb + 691995 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth22setFrictionCoefficientEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore22setFrictionCoefficientEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 695, gb + 693459 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sn18RepXCollectionImpl17addCollectionItemENS0_18RepXCollectionItemE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i4 + 28 >> 2] & 2147483647) >>> 0 > i2 >>> 0) {
  i4 = (HEAP32[i4 + 20 >> 2] | 0) + (i2 * 24 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i4 + 16 | 0, i3) | 0;
  return;
 }
}

function __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3EjRKNS_9AABBMgrIdERNS0_8ShapeSimE(i5, i3, i2, i1, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = HEAP32[HEAP32[(__ZNK5physx2Sc8ShapeSim8getRbSimEv(i4) | 0) + 52 >> 2] >> 2] | 0;
 i10 = i1;
 i9 = HEAP32[i10 + 4 >> 2] | 0;
 i1 = i7;
 HEAP32[i1 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i1 + 4 >> 2] = i9;
 __ZN5physx2Sc8ShapeSim20createLowLevelVolumeEjRKNS_9PxBounds3EjNS_9AABBMgrIdE(i4, i2, i3, i8, i7);
 i5 = (HEAP32[(HEAP32[HEAP32[i5 + 1104 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 24 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 STACKTOP = i6;
 return;
}

function __ZN4FMOD6System10loadPluginEPKcPjj(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869709;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869709;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869709;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 905605 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN26AnimatorOverrideController8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN24EllipsoidParticleEmitterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  __ZdlPv(i1);
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 96 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN14Texture2DArray9SetPixelsEiPK10ColorRGBAfii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 if (!(__ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii(i1, i2, i3, i4, i5) | 0)) return;
 i6 = (HEAP32[i1 + 96 >> 2] | 0) + (Math_imul(HEAP32[i1 + 104 >> 2] | 0, i4) | 0) | 0;
 i4 = i1 + 80 | 0;
 i7 = i1 + 84 | 0;
 i1 = i1 + 92 | 0;
 i6 = i6 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0, HEAP32[i1 >> 2] | 0, i5) | 0) | 0;
 i4 = HEAP32[i4 >> 2] >> i5;
 i4 = (i4 | 0) < 1 ? 1 : i4;
 i5 = HEAP32[i7 >> 2] >> i5;
 i5 = (i5 | 0) < 1 ? 1 : i5;
 __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf(i6, i4, i5, HEAP32[i1 >> 2] | 0, 0, 0, i4, i5, i2, i3) | 0;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper14createPropertyERKN5physx8debugger14NamespacedNameEPKcS5_NS2_12PropertyType4EnumE(i5, i1, i3, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i9 = (HEAP32[i5 + 4 >> 2] | 0) + 4 | 0;
 i10 = HEAP32[(HEAP32[i9 >> 2] | 0) + 16 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, i5 | 0);
 mftCall_iiiiiiii(i10 | 0, i9 | 0, i1 | 0, i8 | 0, i3 | 0, i2 | 0, i4 | 0, i7 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0);
 STACKTOP = i6;
 return;
}

function __Z13RegisterClassI11BoxColliderEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 840;
 HEAP32[i2 + 8 >> 2] = gb + 733457;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 65;
 HEAP32[i2 + 20 >> 2] = 132;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 110912;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UNITY_tt_face_free_name(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[(HEAP32[i3 + 96 >> 2] | 0) + 8 >> 2] | 0;
 i5 = i3 + 356 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i3 + 348 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = 0;
  i6 = i3 + 344 | 0;
  HEAP16[i6 >> 1] = 0;
  i6 = i3 + 352 | 0;
  HEAP32[i6 >> 2] = 0;
  return;
 }
 if (i2) {
  while (1) {
   i7 = i1 + 16 | 0;
   _UNITY_ft_mem_free(i4, HEAP32[i7 >> 2] | 0);
   HEAP32[i7 >> 2] = 0;
   HEAP16[i1 + 8 >> 1] = 0;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i1 = i1 + 20 | 0;
  }
  i1 = HEAP32[i5 >> 2] | 0;
 }
 _UNITY_ft_mem_free(i4, i1);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i3 + 344 | 0;
 HEAP16[i7 >> 1] = 0;
 i7 = i3 + 352 | 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function _tre_new_item(i5, i6, i7, i9, i1, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i9 >> 2] | 0) < (i3 | 0)) i8 = 5; else if ((i3 | 0) > 1024) i1 = 12; else {
  HEAP32[i1 >> 2] = i3 << 1;
  i1 = _realloc(i2, i3 << 3) | 0;
  if (!i1) i1 = 12; else {
   HEAP32[i4 >> 2] = i1;
   i2 = i1;
   i8 = 5;
  }
 }
 if ((i8 | 0) == 5) {
  i1 = _tre_ast_new_node(i5, 0, 20) | 0;
  if (!i1) i1 = 0; else {
   i8 = HEAP32[i1 + 4 >> 2] | 0;
   HEAP32[i8 >> 2] = i6;
   HEAP32[i8 + 4 >> 2] = i7;
   HEAP32[i8 + 8 >> 2] = -1;
  }
  i8 = HEAP32[i9 >> 2] | 0;
  HEAP32[i2 + (i8 << 2) >> 2] = i1;
  HEAP32[i9 >> 2] = i8 + 1;
  i1 = (i1 | 0) == 0 ? 12 : 0;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP16[i4 >> 1] | 0;
 i3 = HEAP16[i5 >> 1] | 0;
 if (i2 << 16 >> 16 < i3 << 16 >> 16) {
  HEAP16[i5 >> 1] = i2;
  HEAP16[i4 >> 1] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP16[i5 >> 1] | 0;
  i3 = HEAP16[i7 >> 1] | 0;
  if (i2 << 16 >> 16 < i3 << 16 >> 16) {
   HEAP16[i7 >> 1] = i2;
   HEAP16[i5 >> 1] = i3;
   i2 = HEAP16[i7 >> 1] | 0;
   i3 = HEAP16[i6 >> 1] | 0;
   if (i2 << 16 >> 16 < i3 << 16 >> 16) {
    HEAP16[i6 >> 1] = i2;
    HEAP16[i7 >> 1] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, d4 = 0.0;
 d2 = +HEAPF64[i7 >> 3];
 d4 = +HEAPF64[i6 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 i1 = d3 < d2;
 do if (d2 < d4) {
  if (i1) {
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i5 >> 3] = d4;
   i1 = 1;
   break;
  }
  HEAPF64[i6 >> 3] = d2;
  HEAPF64[i7 >> 3] = d4;
  d2 = +HEAPF64[i5 >> 3];
  if (d2 < d4) {
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i5 >> 3] = d4;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAPF64[i7 >> 3] = d3;
  HEAPF64[i5 >> 3] = d2;
  d3 = +HEAPF64[i7 >> 3];
  d2 = +HEAPF64[i6 >> 3];
  if (d3 < d2) {
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i7 >> 3] = d2;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i6, i7, i5, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0, d4 = 0.0;
 d2 = +HEAPF64[i7 >> 3];
 d4 = +HEAPF64[i6 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 i1 = d3 < d2;
 do if (d2 < d4) {
  if (i1) {
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i5 >> 3] = d4;
   i1 = 1;
   break;
  }
  HEAPF64[i6 >> 3] = d2;
  HEAPF64[i7 >> 3] = d4;
  d2 = +HEAPF64[i5 >> 3];
  if (d2 < d4) {
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i5 >> 3] = d4;
   i1 = 2;
  } else i1 = 1;
 } else if (i1) {
  HEAPF64[i7 >> 3] = d3;
  HEAPF64[i5 >> 3] = d2;
  d3 = +HEAPF64[i7 >> 3];
  d2 = +HEAPF64[i6 >> 3];
  if (d3 < d2) {
   HEAPF64[i6 >> 3] = d3;
   HEAPF64[i7 >> 3] = d2;
   i1 = 2;
  } else i1 = 1;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZN5physx2Sc19ShapeInstancePairLLC2ERNS0_8ShapeSimES3_RNS0_9ActorPairENS_7PxFlagsINS_10PxPairFlag4EnumEtEE(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i5 >> 2] = gb + 101220 + 8;
 HEAP16[i5 + 4 >> 1] = -1;
 HEAP16[i5 + 6 >> 1] = 1;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i5 + 8 | 0, HEAP32[i3 + 8 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0, 0, 21);
 HEAP32[i5 + 32 >> 2] = i3;
 HEAP32[i5 + 36 >> 2] = i4;
 HEAP32[i5 >> 2] = gb + 101396 + 8;
 HEAP32[i5 + 8 >> 2] = gb + 101396 + 52;
 HEAP32[i5 + 40 >> 2] = -1;
 HEAP32[i5 + 48 >> 2] = i1;
 HEAP32[i5 + 52 >> 2] = -1;
 HEAP32[i5 + 56 >> 2] = 0;
 HEAP32[i5 + 60 >> 2] = -1;
 HEAP16[i5 + 64 >> 1] = 0;
 HEAP32[i5 + 44 >> 2] = (HEAPU16[i2 >> 1] | 0) & 32767;
 return;
}

function __ZN5physx10PxsContext19resetThreadContextsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i2 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl5flushEv(HEAP32[i8 >> 2] | 0) | 0;
 i6 = (i1 | 0) == 0;
 if (i6) {
  i3 = i1;
  i4 = 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i1;
 }
 i7 = i2 + 5916 | 0;
 i5 = i2 + 1348 | 0;
 i2 = i4;
 L4 : while (1) {
  i4 = (i3 | 0) == 0;
  while (1) {
   if (!i2) break L4;
   __ZN5physx16PxsThreadContext5resetEjj(i2, HEAP32[i7 >> 2] << 5, HEAP32[i5 >> 2] << 5);
   if (i4) i2 = 0; else break;
  }
  i2 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
 }
 if (i6) return;
 do {
  i7 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i8 >> 2] | 0, i7);
 } while ((i1 | 0) != 0);
 return;
}

function __ZN4FMOD6System11getWaveDataEPfii(i7, i1, i2, i3) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869684;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869684;
  _printf(gb + 853343 | 0, i5) | 0;
  i7 = 78;
  STACKTOP = i6;
  return i7 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869684;
 _printf(gb + 853184 | 0, i3) | 0;
 i7 = 36;
 STACKTOP = i6;
 return i7 | 0;
}

function __ZN4FMOD6System10getChannelEiPPNS_7ChannelE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 862521;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 862521;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862521;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD13ChannelGroupI8addGroupEPNS_12ChannelGroupE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (!i2) return 0;
 i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i2) return 0;
 if (HEAP8[i2 + 16 >> 0] | 0) return 0;
 if ((HEAP32[i2 + 12 >> 2] | 0) != (i1 & 65535 | 0)) return 0;
 i4 = i2 + 52 | 0;
 i5 = i2 + 60 | 0;
 i6 = i2 + 56 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 >> 2];
 HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] = i1;
 HEAP32[i6 >> 2] = i4;
 i1 = i3 + 68 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 >> 2] = i3 + 64;
 HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 + 48 >> 2] = i3;
 return 0;
}

function __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6);
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP32[i5 + 8 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5 + 12 | 0, i6);
 STACKTOP = i7;
 return;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 44 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 48 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN10Matrix4x4fC2EPKf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 + 60 >> 2];
 return;
}

function __ZN10GUIElement12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[gb + 1114500 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP8[i3 >> 0] = 1;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i4 + 20 >> 2] | 0)) {
  __ZNSt3__26vectorINS_4pairIb4PPtrI10GUIElementEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_(i4 + 12 | 0, i3);
  STACKTOP = i5;
  return;
 } else {
  i6 = i3;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
  STACKTOP = i5;
  return;
 }
}

function __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i3 = i1 + 56 | 0;
 i5 = i2 + 16 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + 24 | 0;
 if ((i4 + 1 | 0) >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i3, 1); else {
  HEAP8[i3 >> 0] = HEAP8[i4 >> 0] | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 i1 = i1 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 4 | 0;
 if (i3 >>> 0 > (HEAP32[i6 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i5, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 >> 2] = i3;
  return;
 }
}

function __Z27RegisterModuleClasses_Clothv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 904;
 HEAP32[i2 + 8 >> 2] = gb + 839010;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 183;
 HEAP32[i2 + 20 >> 2] = 384;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 168704;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z23ShutdownVehiclesManagerv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1458540 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 if (i1 | 0) __ZdlPv(i1);
 i3 = HEAP32[gb + 1458620 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 if (i1 | 0) __ZdlPv(i1);
 i3 = HEAP32[gb + 1458700 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 if (i1 | 0) __ZdlPv(i1);
 _PxCloseVehicleSDK(0);
 i2 = HEAP32[gb + 1458700 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __Z13RegisterClassI10TagManagerEvv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 528;
 HEAP32[i2 + 8 >> 2] = gb + 370841;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 78;
 HEAP32[i2 + 20 >> 2] = 1084;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 HEAP8[i2 + 33 >> 0] = 1;
 HEAP8[i2 + 34 >> 0] = 0;
 HEAP8[i2 + 35 >> 0] = 0;
 HEAP8[i2 + 36 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31912;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZN5physx8debugger14PvdMarshallingItdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx7NpCloth21setStiffnessFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore21setStiffnessFrequencyEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 877, gb + 697741 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth21setCollisionMassScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore21setCollisionMassScaleEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 753, gb + 693294 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sn22writeHeightFieldSampleERNS_14PxOutputStreamERKNS_19PxHeightFieldSampleE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 8 | 0;
 i1 = HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 >> 0];
 i2 = i4;
 i3 = i2 + 128 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i6 >> 2] = i1;
 __ZN5physx6string9sprintf_sEPcjPKcz(i4, 128, gb + 1084495 | 0, i6) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i7;
  return;
 }
 i6 = HEAP32[HEAP32[i5 >> 2] >> 2] | 0;
 mftCall_iiii(i6 | 0, i5 | 0, i4 | 0, _strlen(i4) | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN24MeshIntermediateRenderer16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 8 | 0;
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63696 | 0, 16, gb + 936496 | 0, gb + 375381 | 0, gb + 375269 | 0, 118) | 0;
 i4 = HEAP32[gb + 33600 >> 2] | 0;
 i8 = gb + 63696 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 375395 | 0, 288, i4, i3, 16);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1110380 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE28CreateDelayedDeletionManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 44 | 0;
 if (HEAP32[i3 >> 2] | 0) return;
 i1 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!i1) i1 = 1; else i1 = (__ZN14MemoryProfiler18PushAllocationRootEPvP13BaseAllocatorb(i1, 0, 0, 0) | 0) ^ 1;
 i4 = __ZnwjRK10MemLabelIdiPKci(28, gb + 63216 | 0, 16, gb + 364187 | 0, 331) | 0;
 i5 = HEAP32[i2 + 36 >> 2] | 0;
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = i5;
 HEAP32[i4 + 20 >> 2] = i2;
 HEAP32[i3 >> 2] = i4;
 if (i1) return;
 __ZN14MemoryProfiler17PopAllocationRootEv(HEAP32[gb + 1163236 >> 2] | 0);
 return;
}

function __ZN14RenderSettings15SetAmbientProbeERK20SphericalHarmonicsL2(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f6 = f0, f7 = f0, i8 = 0;
 i3 = i5 + 76 | 0;
 i2 = 0;
 while (1) {
  f6 = Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i5 + 76 + (i2 << 2) >> 2]));
  i8 = f6 < Math_fround(0.0);
  f7 = Math_fround(-f6);
  i2 = i2 + 1 | 0;
  if (!((i8 ? f7 : f6) <= Math_fround(9.99999974e-06))) break;
  if ((i2 | 0) >= 27) {
   i4 = 5;
   break;
  }
 }
 if ((i4 | 0) == 5) return;
 i2 = i3 + 108 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i5);
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i5);
 return;
}

function __ZN10systeminfo17GetSystemLanguageEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = _JS_SystemInfo_GetLanguage(0, 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i3, i2, 0);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 _JS_SystemInfo_GetLanguage((i4 ? HEAP32[i3 >> 2] | 0 : i3) | 0, (i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0) | 0;
 i2 = __ZN10systeminfo19ISOToSystemLanguageERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z50Transform_CUSTOM_INTERNAL_CALL_GetLocalEulerAnglesP12Il2CppObjectN4math13RotationOrderER8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZN9Transform19GetLocalEulerAnglesEN4math13RotationOrderE(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 8 + 3 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4514 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 8 + 3 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4514 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEjc(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i7 = i4 + 11 | 0;
 i1 = HEAP8[i7 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 if (i2) i3 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0; else i3 = 10;
 if (i3 >>> 0 < i5 >>> 0) {
  if (i2) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = i1 & 255;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj(i4, i3, i5 - i3 | 0, i1, 0, i1, 0);
  i1 = HEAP8[i7 >> 0] | 0;
 }
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i4 >> 2] | 0; else i1 = i4;
 if (i5 | 0) _memset(i1 | 0, i6 | 0, i5 | 0) | 0;
 HEAP8[i1 + i5 >> 0] = 0;
 if ((HEAP8[i7 >> 0] | 0) < 0) HEAP32[i4 + 4 >> 2] = i5; else HEAP8[i7 >> 0] = i5;
 return i4 | 0;
}

function __ZNK5physx7NpCloth13getClothFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i3 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i3 = 3; else i3 = 4;
   break;
  }
 default:
  i3 = 3;
 }
 if ((i3 | 0) == 3) {
  i3 = __ZNK5physx2Sc9ClothCore13getClothFlagsEv(i1 + 32 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else if ((i3 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 925, gb + 698283 | 0, i2);
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx14NpSpatialIndex7raycastERKNS_6PxVec3ES3_fRNS_25PxSpatialLocationCallbackE(i1, i7, i8, f2, i5) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 f2 = Math_fround(f2);
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i9 + 8 | 0;
 i6 = i9;
 HEAPF32[i4 >> 2] = f2;
 i3 = i1 + 4 | 0;
 i1 = i1 + 8 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i10 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i10 >> 2] | 0) + 12 >> 2] | 0, i10 | 0);
 }
 HEAP8[i3 >> 0] = 0;
 HEAP32[i6 >> 2] = gb + 107584 + 8;
 HEAP32[i6 + 4 >> 2] = i5;
 i10 = HEAP32[i1 >> 2] | 0;
 mftCall_iiiiii(HEAP32[(HEAP32[i10 >> 2] | 0) + 16 >> 2] | 0, i10 | 0, i7 | 0, i8 | 0, i4 | 0, i6 | 0) | 0;
 STACKTOP = i9;
 return;
}

function __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i2 = i2 & 1;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, i2 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, i2 | 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
 i3 = i1 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, i2 | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
 i3 = i1 + 28 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, i2 | 0, HEAP32[i1 + 24 >> 2] | 0) | 0;
 i3 = i1 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 _memset(((i4 | 0) == 0 ? 0 : i4 + i3 | 0) | 0, i2 | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
 return;
}

function __ZN7Terrain18SetLegacyShininessEf(i2, f6) {
 i2 = i2 | 0;
 f6 = Math_fround(f6);
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i2 + 104 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f6)) return;
 HEAPF32[i1 >> 2] = f6;
 i4 = HEAP32[i2 + 112 >> 2] | 0;
 if (!i4) return;
 i5 = i4 + 20 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if ((i3 & 255) << 24 >> 24 == (i1 & 255) << 24 >> 24) if (!((i3 >>> 24 & 255) << 24 >> 24 != (i1 >>> 24 & 255) << 24 >> 24 | ((i3 >>> 16 & 255) << 24 >> 24 != (i1 >>> 16 & 255) << 24 >> 24 ? 1 : ((i3 & 65535) >>> 8 & 255) << 24 >> 24 != ((i1 & 65535) >>> 8 & 255) << 24 >> 24))) if (!(Math_fround(HEAPF32[i4 + 24 >> 2]) != f6)) return;
 HEAP32[i5 >> 2] = i1;
 HEAPF32[i4 + 24 >> 2] = f6;
 __ZN14SplatMaterials15UpdateMaterialsEv(i4);
 return;
}

function __ZN5physx21PxVehicleDriveSimData13setEngineDataERKNS_19PxVehicleEngineDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 64 | 0;
 _memcpy(i2 | 0, i1 | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 64 >> 2] = HEAP32[i4 >> 2];
 i4 = i2 + 80 | 0;
 i3 = i1 + 80 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAPF32[i2 + 104 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i2 + 108 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 88 >> 2]));
 return;
}

function __ZN5physx10PxsContext22setCreateContactStreamEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 & 1;
 HEAP8[i2 + 1440 >> 0] = i5;
 i6 = i2 + 224 | 0;
 i1 = __ZN5physx6shdfnd9SListImpl5flushEv(HEAP32[i6 >> 2] | 0) | 0;
 i4 = (i1 | 0) == 0;
 if (i4) {
  i3 = i1;
  i2 = 0;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = i1;
 }
 L4 : do if (!i3) i7 = 4; else while (1) {
  if (!i2) break L4;
  HEAP8[i2 + 8774 >> 0] = i5;
  i2 = i3;
  i3 = HEAP32[i3 >> 2] | 0;
  if (!i3) {
   i7 = 4;
   break;
  }
 } while (0);
 if ((i7 | 0) == 4) if (i2 | 0) HEAP8[i2 + 8774 >> 0] = i5;
 if (i4) return;
 do {
  i7 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i6 >> 2] | 0, i7);
 } while ((i1 | 0) != 0);
 return;
}

function __ZN4FMOD6System26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869942;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869942;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869942;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869598;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869598;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869598;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 72 | 0, i2);
 __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 28 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 52 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 72 | 0, i2);
 __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 28 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 52 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1047658 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN24EllipsoidParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 32 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 36 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN17AnimationCurveTplIfE16StripInvalidKeysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 56 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + 68 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i2;
 i4 = i2 + (i3 << 4) | 0;
 L4 : while (1) {
  while (1) {
   if ((HEAP32[i1 + 4 >> 2] & 2139095040 | 0) == 2139095040) break;
   if ((HEAP32[i1 >> 2] & 2139095040 | 0) == 2139095040) break;
   i1 = i1 + 16 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 8;
    break L4;
   }
  }
  i4 = i1 + 16 | 0;
  _memmove(i1 | 0, i4 | 0, i2 + (i3 << 4) - i4 | 0) | 0;
  i3 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  HEAP32[i5 >> 2] = i3;
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i2 + (i3 << 4) | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 8;
   break;
  }
 }
 if ((i1 | 0) == 8) return;
}

function __ZN16AllProfilerStats9SerializeER13dynamic_arrayIiLj4EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11MemoryStats9SerializeER13dynamic_arrayIiLj4EE(i1, i2);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 224 | 0, 52);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 432 | 0, 15);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 492 | 0, 29);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 608 | 0, 19);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 684 | 0, 20);
 __ZN10DebugStats9SerializeER13dynamic_arrayIiLj4EE(i1 + 764 | 0, i2);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 808 | 0, 43);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 980 | 0, 16);
 __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii(i2, i1 + 1044 | 0, 16);
 return;
}

function __ZN14FileCacherReadD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 67232 + 8;
 i2 = i1 + 24 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 12 | 0;
 __Z23AsyncReadForceCloseFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 128 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 88 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 return;
}

function __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) == 7) {
  i1 = __Z12GetGfxDevicev() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 704 >> 2] | 0, i1 | 0) | 0;
 }
 if (i1 >>> 0 > 22) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409040 | 0, 0, gb + 406201 | 0, 952, 1, 0, 0, 0);
  return;
 }
 if (!(HEAP32[i2 + 128 >> 2] | 0)) if (!(HEAP32[i2 + 136 >> 2] | 0)) {
  HEAP32[i2 + 96 >> 2] = i1;
  if (!(__Z15IsDepthRTFormat19RenderTextureFormat(i1) | 0)) if (!(HEAP8[i2 + 119 >> 0] | 0)) return;
  HEAP32[i2 + 36 >> 2] = 0;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409069 | 0, 0, gb + 406201 | 0, 961, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13GfxDeviceGLES16SetActiveContextEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 4 | 0;
 i7 = i3;
 i4 = i1 + 4616 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 __ZN14GfxContextGLES11MakeCurrentER7ApiGLESN2gl13ContextHandleE(i6, i1 + 4620 | 0, i5) | 0;
 __ZN4gles10InvalidateERK14GfxContextGLESR15DeviceStateGLES(HEAP32[i4 >> 2] | 0, i1 + 6616 | 0);
 __ZN13GfxDeviceGLES21ProcessPendingMipGensEv(i1);
 __ZN18GfxFramebufferGLES20ActiveContextChangedEPP17RenderSurfaceBaseS2_(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i4 >> 2] | 0) | 0, i1 + 4400 | 0, i1 + 4404 | 0);
 STACKTOP = i3;
 return;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 96 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 100 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN10AudioMixer20GetGroupNameFromGUIDERK9UnityGUID(i4, i2, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (!i1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
   return;
  }
 }
 i5 = __ZN5audio5mixer20GetGroupNameFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID(i1, i5) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, _strlen(i5) | 0);
 return;
}

function __Z32LineRenderer_CUSTOM_SetPositionsP12Il2CppObjectP11Il2CppArray(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 517787 | 0, i5);
 i4 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 12) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN12LineRenderer12SetPositionsEPK8Vector3fj(i2, i1, i4);
  STACKTOP = i5;
  return;
 }
}

function _j1(d4) {
 d4 = +d4;
 var d1 = 0.0, i2 = 0, i3 = 0;
 HEAPF64[tempDoublePtr >> 3] = d4;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, i3 | 0, 63) | 0;
 getTempRet0() | 0;
 i3 = i3 & 2147483647;
 do if (i3 >>> 0 > 2146435071) d1 = 1.0 / (d4 * d4); else {
  if (i3 >>> 0 > 1073741823) {
   d1 = +_common_180(i3, +Math_abs(+d4), 0, i2);
   break;
  }
  if (i3 >>> 0 > 939524095) {
   d1 = d4 * d4;
   d1 = d1 * (d1 * (d1 * (d1 * 4.9672799960958445e-08 + -1.599556310840356e-05) + .001407056669551897) + -.0625) / (d1 * (d1 * (d1 * (d1 * (d1 * 1.2354227442613791e-11 + 5.0463625707621704e-09) + 1.1771846404262368e-06) + 1.8594678558863092e-04) + .019153759953836346) + 1.0);
  } else d1 = d4;
  d1 = (d1 + .5) * d4;
 } while (0);
 return +d1;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwner10disconnectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + -8 | 0;
 i1 = i3 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i4 = i3 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 i2 = i3 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (!i1) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwner10disconnectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + -4 | 0;
 i1 = i3 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i4 = i3 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 i2 = i3 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (!i1) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcj(i2, i7, i6) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i3 = i1 & 255;
 i1 = _strlen(i7) | 0;
 if (i3 >>> 0 <= i6 >>> 0 | (i1 | 0) == 0) i1 = -1; else {
  i5 = i2 + i3 | 0;
  i4 = i7 + i1 | 0;
  i1 = i2 + i6 | 0;
  L7 : while (1) {
   if ((i1 | 0) == (i5 | 0)) {
    i1 = i5;
    break;
   } else i3 = i7;
   while (1) {
    if ((i3 | 0) == (i4 | 0)) break;
    if ((HEAP8[i1 >> 0] | 0) == (HEAP8[i3 >> 0] | 0)) break L7; else i3 = i3 + 1 | 0;
   }
   i1 = i1 + 1 | 0;
  }
  i1 = (i1 | 0) == (i5 | 0) ? -1 : i1 - i2 | 0;
 }
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore16getRestPositionsEPNS_6PxVec4E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i2 = i2 + 28 | 0;
 i8 = HEAP32[i2 >> 2] | 0;
 i8 = mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 348 >> 2] | 0, i8 | 0) | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0) | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i1 + (i8 << 4);
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viii(i6 | 0, i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return 1;
}

function __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAPU8[i4 + 20 >> 0] | 0;
 i2 = i5 + 88 + (i1 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i5 + 16 + (i1 * 12 | 0) + 4 >> 2] | 0) >>> 0) {
  i5 = i3;
  i5 = i5 + 1 | 0;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = i5 + 16 + (i1 * 12 | 0) | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i7 = i5 + (i3 << 2) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] = i4;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i5 + 12 >> 2] = i3;
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = i5 + 1 | 0;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN5Umbra9Matrix3x33detEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f9 = Math_fround(f4 * f2);
 f6 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f7 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 f9 = Math_fround(f8 * Math_fround(f9 - Math_fround(f6 * f7)));
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f7 = Math_fround(f7 * f3);
 f5 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f2 = Math_fround(f9 + Math_fround(f8 * Math_fround(f7 - Math_fround(f2 * f5))));
 return Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) * Math_fround(Math_fround(f6 * f5) - Math_fround(f4 * f3))) + f2);
}

function __ZN24UVModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 switch (i3 | 0) {
 case 0:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 864 >> 2] | 0;
   HEAPF32[i3 + 88 >> 2] = f4;
   HEAP8[i3 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 8 | 0, i3 + 96 | 0, f4, HEAP16[i3 + 92 >> 1] | 0) | 0) & 1;
   return;
  }
 case 1:
  {
   __ZN14ParticleSystem8SyncJobsEb(1);
   i3 = HEAP32[i2 + 864 >> 2] | 0;
   HEAPF32[i3 + 352 >> 2] = f4;
   HEAP8[i3 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 272 | 0, i3 + 360 | 0, f4, HEAP16[i3 + 356 >> 1] | 0) | 0) & 1;
   return;
  }
 default:
  return;
 }
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 379149 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN24OcclusionCullingSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4 + 4 | 0;
 i7 = i5 + 72 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 32 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = (i3 | 0) != 0 & 1;
 HEAP8[i4 + 56 >> 0] = 0;
 HEAP8[i4 + 64 >> 0] = 0;
 HEAP8[i4 + 72 >> 0] = 0;
 HEAP8[i4 + 73 >> 0] = 0;
 HEAP32[i4 + 44 >> 2] = -1;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup(i1, i2, i4);
 STACKTOP = i6;
 return;
}

function __ZN16b2BlockAllocatorC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 128;
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(1024, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
 HEAP32[i1 >> 2] = i4;
 _memset(i4 | 0, 0, HEAP32[i2 >> 2] << 3 | 0) | 0;
 i1 = i1 + 12 | 0;
 i2 = i1 + 56 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!(HEAP8[gb + 1552702 >> 0] | 0)) {
  i1 = 0;
  i2 = 1;
 } else return;
 while (1) {
  i3 = (i2 | 0) > (HEAP32[gb + 151768 + (i1 << 2) >> 2] | 0);
  i4 = i1 + 1 | 0;
  HEAP8[gb + 1552061 + i2 >> 0] = i3 ? i4 : i1;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 641) break; else i1 = i3 ? i4 : i1;
 }
 HEAP8[gb + 1552702 >> 0] = 1;
 return;
}

function __Z6AppendPKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i6 = _strlen(i2) | 0;
 i5 = i3 + 11 | 0;
 i7 = HEAP8[i5 >> 0] | 0;
 i4 = i3 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i1, (i7 << 24 >> 24 < 0 ? HEAP32[i4 >> 2] | 0 : i7 & 255) + i6 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i2, i6) | 0;
 i2 = HEAP8[i5 >> 0] | 0;
 i5 = i2 << 24 >> 24 < 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i5 ? HEAP32[i3 >> 2] | 0 : i3, i5 ? HEAP32[i4 >> 2] | 0 : i2 & 255) | 0;
 return;
}

function __Z34GetNonJitteredViewProjectionMatrixR6Camera(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i4 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
 i5 = i3;
 i7 = __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i2) | 0;
 i8 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
  i5 = i5 + 4 | 0;
  i7 = i7 + 4 | 0;
 } while ((i5 | 0) < (i8 | 0));
 i8 = __Z25GetUncheckedRealGfxDevicev() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 144 >> 2] | 0, i8 | 0, i3 | 0, i4 | 0, i4 ^ 1 | 0);
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i3, __ZNK6Camera22GetWorldToCameraMatrixEv(i2) | 0, i1);
 STACKTOP = i6;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 if (f2 < f3) {
  HEAPF32[i5 >> 2] = f2;
  HEAPF32[i4 >> 2] = f3;
  i4 = i1 + 1 | 0;
  f2 = Math_fround(HEAPF32[i5 >> 2]);
  f3 = Math_fround(HEAPF32[i7 >> 2]);
  if (f2 < f3) {
   HEAPF32[i7 >> 2] = f2;
   HEAPF32[i5 >> 2] = f3;
   f2 = Math_fround(HEAPF32[i7 >> 2]);
   f3 = Math_fround(HEAPF32[i6 >> 2]);
   if (f2 < f3) {
    HEAPF32[i6 >> 2] = f2;
    HEAPF32[i7 >> 2] = f3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNK5physx9NpPhysics9getScenesEPPNS_7PxSceneEjj(i1, i8, i3, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i2 = (HEAP32[i1 + 8 >> 2] | 0) - i7 | 0;
 i6 = (i2 | 0) < 0 ? 0 : i2;
 i6 = i6 >>> 0 < i3 >>> 0 ? i6 : i3;
 if (!i6) {
  i8 = HEAP32[i5 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return i6 | 0;
 }
 i4 = i1 + 4 | 0;
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i8 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 i8 = HEAP32[i5 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return i6 | 0;
}

function __ZNK20OcclusionCullingData8GetSceneERK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i7) {
  i8 = 0;
  return i8 | 0;
 }
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 << 5) + 16 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i4 + (i1 << 5) + 20 >> 2] | 0) == (i6 | 0)) if ((HEAP32[i4 + (i1 << 5) + 24 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i4 + (i1 << 5) + 28 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i7 >>> 0) {
   i1 = 0;
   i8 = 9;
   break;
  }
 }
 if ((i8 | 0) == 9) return i1 | 0;
 i8 = i4 + (i1 << 5) | 0;
 return i8 | 0;
}

function __ZNK16TypeTreeIterator4NextEv(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP8[i1 + (i2 * 24 | 0) + 2 >> 0] | 0;
 i3 = i1 + ((HEAP32[i7 + 12 >> 2] | 0) * 24 | 0) | 0;
 i4 = i1;
 i2 = i1 + (i2 * 24 | 0) | 0;
 do {
  i1 = i2;
  i2 = i2 + 24 | 0;
  if (i2 >>> 0 >= i3 >>> 0) {
   i8 = 7;
   break;
  }
  i1 = HEAP8[i1 + 26 >> 0] | 0;
 } while ((i1 & 255) > (i5 & 255));
 if ((i8 | 0) == 7) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  return;
 }
 if (i1 << 24 >> 24 == i5 << 24 >> 24) {
  HEAP32[i6 >> 2] = i7;
  HEAP32[i6 + 4 >> 2] = (i2 - i4 | 0) / 24 | 0;
  return;
 } else {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  return;
 }
}

function __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = __Z25scripting_class_from_typePK10Il2CppType(__Z24scripting_field_get_typeP9FieldInfo(i2) | 0) | 0;
 i6 = __Z24scripting_class_get_nameP11Il2CppClass(__Z26scripting_field_get_parentP9FieldInfo(i2) | 0) | 0;
 i4 = __Z23scripting_type_get_namePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i4) | 0) | 0;
 i2 = __Z24scripting_field_get_nameP9FieldInfo(i2) | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i6;
 __Z6FormatPKcz(i1, gb + 466157 | 0, i5);
 _il2cpp_free(i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN8Animator12ResetTriggerEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 i3 = i1 + 584 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 160 >> 2] | 0, i6 | 0, i4 | 0) | 0 | i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
 return i1 | 0;
}

function __ZN5physx6shdfnd10ThreadImpl11setPriorityENS0_14ThreadPriority4EnumE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 28 | 0;
 i6 = i7;
 i3 = i1 + 20 | 0;
 _pthread_getschedparam(HEAP32[i3 >> 2] | 0, i5 | 0, i6 | 0) | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i1 = _sched_get_priority_max(i2 | 0) | 0;
 i2 = _sched_get_priority_min(i2 | 0) | 0;
 if ((i1 | 0) == (i2 | 0)) i1 = 0; else i1 = ~~Math_fround(+_roundf(+Math_fround(Math_fround(Math_fround((4 - i4 | 0) >>> 0) * Math_fround(i1 - i2 | 0)) * Math_fround(.25)))) + i2 | 0;
 HEAP32[i6 >> 2] = i1;
 _pthread_setschedparam(HEAP32[i3 >> 2] | 0, HEAP32[i5 >> 2] | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP32[i3 >> 2] & 16384 | 0) {
  STACKTOP = i5;
  return;
 }
 i2 = i1 + 28 | 0;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, 65);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i6 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i1 | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i2 >> 2] = __ZNK4PPtrI6ObjectEcvPS0_Ev(i4) | 0;
 }
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 STACKTOP = i5;
 return;
}

function __ZN19MeshParticleEmitterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  __ZdlPv(i1);
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN11AssetBundle18DebugPrintContentsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i3 = i1 + 72 | 0;
 if ((i2 | 0) == (i3 | 0)) {
  STACKTOP = i5;
  return;
 }
 while (1) {
  i1 = i2 + 16 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i1;
  _printf_console(gb + 367733 | 0, i4);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 STACKTOP = i5;
 return;
}

function __Z39PolygonCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 __ZN9Polygon2D9SetPointsEPK8Vector2fj(i2 + 160 | 0, i4, __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN17PolygonCollider2D11RefreshPolyEv(i1);
  return;
 }
}

function _fcvt(d3, i4, i5, i6) {
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 1520 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i1 = i8 + 16 | 0;
 i2 = i4 >>> 0 > 1400 ? 1400 : i4;
 HEAP32[i7 >> 2] = i2;
 HEAPF64[i7 + 8 >> 3] = d3;
 _sprintf(i1, gb + 1075313 | 0, i7) | 0;
 i7 = (HEAP8[i1 >> 0] | 0) == 45 & 1;
 i1 = i1 + i7 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 48) i1 = _strspn(i1 + 2 | 0, gb + 1075318 | 0) | 0; else i1 = 0 - (_strcspn(i1, gb + 1087625 | 0) | 0) | 0;
 if ((i2 | 0) > (i1 | 0)) i1 = _ecvt(d3, i2 - i1 | 0, i5, i6) | 0; else {
  HEAP32[i6 >> 2] = i7;
  HEAP32[i5 >> 2] = 1;
  i1 = (i2 >>> 0 > 14 ? -14 : 0 - i4 | 0) + (gb + 1075320 + 14) | 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZThn8_N5physx2Gu10ConvexMeshD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 1 | 0;
 i3 = i1 + -8 | 0;
 HEAP32[i3 >> 2] = gb + 107052 + 8;
 HEAP32[i3 + 8 >> 2] = gb + 107052 + 84;
 if (!(HEAP16[i3 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 56 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx13BigConvexDataD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
 }
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
 STACKTOP = i5;
 return;
}

function __ZNK5physx13BigConvexData20ComputeNearestOffsetERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 4 | 0;
 i4 = i3;
 i2 = HEAPU16[i2 >> 1] | 0;
 i1 = __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_(i1, i7, i4) | 0;
 f5 = Math_fround(Math_fround((i2 + -1 | 0) >>> 0) * Math_fround(.5));
 f6 = Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i7 >> 2]) + Math_fround(1.0)));
 i2 = (Math_imul((~~Math_fround(f6 + Math_fround(.5)) >>> 0) + (Math_imul(i1, i2) | 0) | 0, i2) | 0) + (~~Math_fround(Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(1.0))) + Math_fround(.5)) >>> 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK27StateMachineBehaviourPlayer25FireStateMachineBehaviourEiiN7mecanim12statemachine19StateMachineMessageE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = i5 + 200 | 0;
 __ZN18ScriptingArgumentsC2Ev(i6);
 __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i6, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 >> 2] | 0) | 0);
 __ZN18ScriptingArguments6AddIntEi(i6, i2);
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 i4 = __ZNK27StateMachineBehaviourPlayer13FireBehaviourER8StateKeyR18ScriptingArgumentsN7mecanim12statemachine19StateMachineMessageEb(i1, i7, i6, i4, 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK10FileSystem10ToAbsoluteEPKc(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i2 = i4 + 16 | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 while (1) {
  if (!i1) {
   i1 = 5;
   break;
  }
  i1 = i1 + -1 | 0;
  i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i6 | 0, i5 | 0) | 0) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i5, _strlen(i5) | 0);
  return;
 } else if ((i1 | 0) == 5) {
  i6 = HEAP32[i4 + 4 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i6 | 0, i5 | 0);
  return;
 }
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i7 = HEAP16[i1 + 2 >> 1] | 0;
  i6 = HEAP16[i1 + 4 >> 1] | 0;
  i3 = HEAP16[i1 + 6 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i7 & 65535) << 2) >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + ((i6 & 65535) << 2) >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i7 = HEAP16[i1 + 2 >> 1] | 0;
  i6 = HEAP16[i1 + 4 >> 1] | 0;
  i3 = HEAP16[i1 + 6 >> 1] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + ((i7 & 65535) << 2) >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i5 + ((i6 & 65535) << 2) >> 2];
  HEAP32[i4 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 48 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 48 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 48 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 48 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 734920 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity17ConfigurableJoint8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN20QuadTreeNodeRenderer16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 8 | 0;
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, gb + 63696 | 0, 16, gb + 936496 | 0, gb + 936507 | 0, gb + 936525 | 0, 31) | 0;
 i4 = HEAP32[gb + 184120 >> 2] | 0;
 i8 = gb + 63616 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i2, 1, gb + 936606 | 0, 272, i4, i3, 16);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1467168 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN14PhysicMaterial7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, i1, 16, gb + 1048932 | 0, 0, gb + 781447 | 0, 26) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 113008 + 8;
 HEAP32[i4 + 56 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES17DestroyGpuProgramEPK10GpuProgram(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (i3 | 0) mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 i4 = i1 + 7060 | 0;
 i2 = i1 + 7064 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = 0;
 }
 if ((i1 | 0) != (i3 | 0)) return;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 160 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 164 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN12SocketStreamC2Eib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 __ZN6SocketC2Ei(i1, i2);
 HEAP32[i1 >> 2] = gb + 73556 + 8;
 HEAP8[i1 + 17 >> 0] = i3 & 1;
 HEAP8[i1 + 18 >> 0] = 1;
 if (__ZN6Socket11SetBlockingEb(i1, i3) | 0) {
  STACKTOP = i5;
  return;
 }
 __Z6FormatPKcz(i4, gb + 584944 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 585013 | 0, 25, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 STACKTOP = i5;
 return;
}

function __Z43Avatar_CUSTOM_INTERNAL_CALL_GetPostRotationP12Il2CppObjectiR11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK6Avatar15GetPostRotationEi(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z41Terrain_CUSTOM_INTERNAL_CALL_SampleHeightP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  f6 = Math_fround(__ZNK7Terrain12SampleHeightE8Vector3f(i4, i3));
  STACKTOP = i5;
  return Math_fround(f6);
 }
 return Math_fround(0.0);
}

function __Z33ResetWheelQueriesTouchingColliderP8Collider(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = HEAP32[gb + 1458620 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i8 = i2;
 if ((i1 | 0) == (i2 | 0)) return;
 i3 = i1 - i2 >> 3;
 i2 = 0;
 do {
  i4 = HEAP32[i8 + (i2 << 3) + 4 >> 2] | 0;
  if (i4 | 0) {
   i5 = HEAP32[i8 + (i2 << 3) >> 2] | 0;
   i1 = 0;
   do {
    i6 = i5 + (i1 * 148 | 0) + 36 | 0;
    if ((HEAP32[i6 >> 2] | 0) == (i7 | 0)) {
     HEAP32[i5 + (i1 * 148 | 0) + 32 >> 2] = 0;
     HEAP32[i6 >> 2] = 0;
     HEAP8[i5 + (i1 * 148 | 0) + 28 >> 0] = 1;
    }
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i4 >>> 0);
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return;
}

function _UNITY_FT_Get_Next_Char(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i5 = HEAP32[i1 + 92 >> 2] | 0;
  if (!i5) {
   i2 = 0;
   i1 = 0;
  } else {
   i3 = i1 + 16 | 0;
   if (!(HEAP32[i3 >> 2] | 0)) {
    i2 = 0;
    i1 = 0;
   } else {
    HEAP32[i4 >> 2] = i2;
    i2 = i5 + 12 | 0;
    do i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, i4 | 0) | 0; while (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0);
    i2 = (i1 | 0) == 0 ? 0 : HEAP32[i4 >> 2] | 0;
   }
  }
 }
 if (!i6) {
  STACKTOP = i7;
  return i2 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 STACKTOP = i7;
 return i2 | 0;
}

function __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypef(i4, i6, f3) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i2 = i7;
 i5 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i4 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, i6 | 0, i5 | 0);
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i7;
 return;
}

function __ZNK4AABB8IsInsideERK8Vector3f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f2 = f0, f4 = f0, f5 = f0, i6 = 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 i6 = i3 + 12 | 0;
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 if (f2 < Math_fround(f4 - f5) | f2 > Math_fround(f4 + f5)) {
  i6 = 0;
  return i6 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 if (f2 < Math_fround(f4 - f5) | f2 > Math_fround(f4 + f5)) {
  i6 = 0;
  return i6 | 0;
 }
 f5 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 if (f5 < Math_fround(f4 - f2)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = !(f5 > Math_fround(f4 + f2));
 return i6 | 0;
}

function __ZN9WWWCached6CancelEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 i1 = i3 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (!(HEAP8[i3 + 96 >> 0] | 0)) {
  if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0)) do {
   __ZN14PreloadManager16UpdatePreloadingEv(__Z17GetPreloadManagerv() | 0);
   i2 = HEAP32[i1 >> 2] | 0;
  } while (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0) | 0));
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP32[i1 + 92 >> 2] | 0)) if (HEAP32[i1 + 84 >> 2] | 0) {
   i1 = __ZN9WWWCached14GetAssetBundleEv(i3) | 0;
   if (i1 | 0) __Z17UnloadAssetBundleR11AssetBundleb(i1, 1);
  }
 }
 HEAP8[i3 + 85 >> 0] = 1;
 return;
}

function __ZN8Animator10SetTriggerEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 i3 = i1 + 584 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i6 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, i4 | 0) | 0 | i1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
 return i1 | 0;
}

function __ZN7mecanim9animation28MotionOutputSetDeltaPositionEPNS0_12MotionOutputERKN4math7_float3E(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, f5 = f0, i6 = 0, f8 = f0;
 f8 = Math_fround(HEAPF32[i7 >> 2]);
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(f2 / f8);
 f4 = Math_fround(f4 / f8);
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 8 >> 2]) / f8);
 i6 = f8 != Math_fround(0.0);
 i3 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i1 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 i6 = i6 ? (HEAPF32[tempDoublePtr >> 2] = f5, HEAP32[tempDoublePtr >> 2] | 0) : 0;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i1;
 HEAP32[i7 + 12 >> 2] = i6;
 return;
}

function __ZN7b2World16SetAllowSleepingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 102980 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i3 >> 0] | 0 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 if (i2) return;
 i1 = HEAP32[i1 + 102956 >> 2] | 0;
 if (!i1) return;
 do {
  i2 = i1 + 4 | 0;
  i3 = HEAPU16[i2 >> 1] | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   HEAP16[i2 >> 1] = i3 & 65533;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
   i3 = i1 + 64 | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i3 + 4 >> 2] = 0;
   HEAP32[i3 + 8 >> 2] = 0;
   HEAP32[i3 + 12 >> 2] = 0;
   HEAP32[i3 + 16 >> 2] = 0;
   HEAP32[i3 + 20 >> 2] = 0;
  } else if (!(i3 & 2)) {
   HEAP16[i2 >> 1] = i3 | 2;
   HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
  }
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx7NpCloth23removeCollisionTriangleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore23removeCollisionTriangleEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 419, gb + 694201 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx11NpAggregate12createObjectERPhRNS_24PxDeserializationContextE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP16[i2 + 6 >> 1] = 2;
 HEAP32[i2 >> 2] = gb + 90184 + 8;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i4 = i2 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 251658240;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 44;
 i1 = i2 + 40 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  __ZN5physx11NpAggregate17resolveReferencesERNS_24PxDeserializationContextE(i2, i3);
  return i2 | 0;
 }
 i5 = i3 + 4 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 HEAP32[i5 >> 2] = i4 + (HEAP32[i2 + 36 >> 2] << 2);
 HEAP32[i1 >> 2] = i4;
 __ZN5physx11NpAggregate17resolveReferencesERNS_24PxDeserializationContextE(i2, i3);
 return i2 | 0;
}

function __ZN28LightProbeProxyVolumeManager17UpdateProxyVolumeER21LightProbeProxyVolumej(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP16[i3 + 152 >> 1] = i1;
 __ZN28LightProbeProxyVolumeManager17UpdateBoundingBoxER21LightProbeProxyVolume(0, i3);
 __ZN28LightProbeProxyVolumeManager16UpdateResolutionER21LightProbeProxyVolume(0, i3);
 if (!(HEAP8[i2 + 40 >> 0] | 0)) return;
 i1 = i3 + 154 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 0 ? (HEAP32[i3 + 44 >> 2] | 0) != 1 : 0) return;
 __ZN28LightProbeProxyVolumeManager22AllocateVolumeTexturesER21LightProbeProxyVolume(0, i3);
 __ZN28LightProbeProxyVolumeManager16BlendLightProbesER21LightProbeProxyVolume(i2, i3);
 __ZN28LightProbeProxyVolumeManager25UpdateSHCoeffsTextureDataER21LightProbeProxyVolume(0, i3);
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN20TextRenderingPrivate18InitializeFreeTypeEv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __ZN20TextRenderingPrivate15GetFontsManager16StaticInitializeEv();
 HEAP32[i2 >> 2] = HEAP32[gb + 185864 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 185864 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 185864 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[gb + 185864 + 12 >> 2];
 if (_Unity_FT_Init_FreeType(gb + 1467876 | 0, i2) | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 946851 | 0, 0, gb + 945383 | 0, 856, 1, 0, 0, 0);
 HEAP8[gb + 1573586 >> 0] = 1;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 946881 | 0, gb + 1034504 | 0, gb + 946895 | 0);
 STACKTOP = i1;
 return;
}

function __ZN13RuntimeStaticI12FlareManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 i5 = i4;
 if (i4 | 0) {
  i6 = i2 + 16 | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~(((i7 + -52 - i5 | 0) >>> 0) / 52 | 0) * 52 | 0);
  __ZdlPv(i4);
 }
 __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11UnityEngine7Connect15AppInstallEventC2EPKcNS_15CloudWebService15CloudEventFlagsE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, i2, i3);
 HEAP32[i1 >> 2] = gb + 188916 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i1 + 48 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 return;
}

function __Z33GUI_CUSTOM_INTERNAL_CALL_DoWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_hRS0_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0, i11 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 i11 = __Z11GetGUIStatev() | 0;
 __ZN5IMGUI8DoWindowER8GUIStateiRK5RectTIfEP12Il2CppObjectR10GUIContentS7_S7_bb(i10, i11, i1, i2, i3, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i4) | 0, i5, i6, i7 << 24 >> 24 != 0, 0);
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i10 + 8 >> 2];
 HEAP32[i8 + 12 >> 2] = HEAP32[i10 + 12 >> 2];
 STACKTOP = i9;
 return;
}

function __Z17IntersectAABBAABBRK10MinMaxAABBS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (f3 > Math_fround(HEAPF32[i2 + 12 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (f3 < Math_fround(HEAPF32[i2 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f3 > Math_fround(HEAPF32[i2 + 16 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 if (f3 < Math_fround(HEAPF32[i2 + 4 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (f3 > Math_fround(HEAPF32[i2 + 20 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i2 = !(f3 < Math_fround(HEAPF32[i2 + 8 >> 2]));
 return i2 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN7dtCrowd21updateAgentFilterCostEiif(i3, i4, i1, f2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i5 = 0;
 i1 = (HEAP32[i3 + 24 >> 2] | 0) + (i4 * 132 | 0) + (i1 << 2) | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f2)) return;
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if ((HEAP32[i1 + (i4 * 608 | 0) + 476 >> 2] | 0) > 0) i5 = 5; else if ((HEAP32[i1 + (i4 * 608 | 0) + 32 >> 2] | 0) > 1) i5 = 5; else if (HEAP8[i1 + (i4 * 608 | 0) + 44 >> 0] & 2) i5 = 5;
 if ((i5 | 0) == 5) HEAP32[i1 + (i4 * 608 | 0) + 48 >> 2] = 0;
 if ((HEAP8[i1 + (i4 * 608 | 0) + 600 >> 0] | 0) != 2) return;
 if ((HEAP32[i3 + 32 >> 2] | 0) != (HEAP32[i3 + 452 >> 2] | 0)) return;
 if (!(HEAP32[i3 + 92 >> 2] & 536870912)) return;
 HEAP32[i3 + 100 >> 2] = 0;
 return;
}

function __ZN5physx7NpCloth18setSolverFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore18setSolverFrequencyEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 857, gb + 697982 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx22PxActorGeneratedValuesC2EPKNS_7PxActorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 8 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 10 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 11 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 12 >> 0] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 16 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx19ext1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i8, i7, i6, i1, i2, i3) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!i7) return;
 i4 = i6 + 16 | 0;
 i5 = 0;
 do {
  if ((HEAP16[i8 + (i5 << 5) + 8 >> 1] | 0) == -1) i2 = HEAPU16[i8 + (i5 << 5) + 10 >> 1] | 0; else i2 = 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if ((HEAP16[i8 + (i5 << 5) + 12 >> 1] | 0) == -1) i3 = HEAPU16[i8 + (i5 << 5) + 14 >> 1] | 0; else i3 = 0;
  __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i8 + (i5 << 5) | 0, i6, i1 + (i2 << 6) | 0, i1 + (i3 << 6) | 0);
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 return;
}

function __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorERKNS_7NpShapeE(i6, i4, i3, i1) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = __ZNK5physx2Cm8PtrTable4findEPKv(i6, i1) | 0;
 i2 = HEAP16[i3 + 4 >> 1] | 0;
 if ((HEAP16[i6 + 4 >> 1] | 0) == 1) i1 = i6; else i1 = HEAP32[i6 >> 2] | 0;
 i1 = __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i4, HEAP32[i1 + (i5 << 2) >> 2] | 0, i3, i2 << 16 >> 16 == 5 | i2 << 16 >> 16 == 15, 0) | 0;
 i2 = i6 + 8 | 0;
 if ((HEAP16[i6 + 12 >> 1] | 0) == 1) {
  i6 = i2;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i1;
  return;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i1;
  return;
 }
}

function __ZN5Umbra15bitPackIntArrayEPKjiPji(i6, i7, i9, i10) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i11 = 0, i12 = 0;
 if ((i7 | 0) < 1 | (i10 | 0) == 0) return; else {
  i1 = 0;
  i2 = 0;
 }
 while (1) {
  i11 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  i3 = 0;
  i4 = i1;
  i5 = i10;
  while (1) {
   i5 = i5 + -1 | 0;
   i8 = 1 << (i4 & 31);
   if (!(i11 & 1 << (i3 & 31))) {
    i12 = i9 + (i4 >> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] & ~i8;
   } else {
    i12 = i9 + (i4 >> 5 << 2) | 0;
    HEAP32[i12 >> 2] = HEAP32[i12 >> 2] | i8;
   }
   if (!i5) break; else {
    i3 = i3 + 1 | 0;
    i4 = i4 + 1 | 0;
   }
  }
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else i1 = i1 + i10 | 0;
 }
 return;
}

function __ZN4FMOD6System15getNetworkProxyEPci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869440;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869440;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869440;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 621574 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN22ParticleSystemRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 844212 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN22NavMeshProjectSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12WWWDelayCall8CallbackEP6ObjectPv(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i6;
  return 1;
 }
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 mftCall_iii(HEAP32[i4 + 4 >> 2] | 0, i3 | 0, HEAP32[i4 + 12 >> 2] | 0) | 0;
 i3 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i3, i2, fb + 691 | 0, fb + 692 | 0, i4);
 STACKTOP = i6;
 return 1;
}

function __ZN11MonoManager17GetScriptingClassEPKcS1_S1_(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 if (__ZL41AssemblyNameMatchesWithOrWithoutExtensionPKcS0_(i4, gb + 463968 | 0) | 0) {
  i6 = _il2cpp_class_from_name(_il2cpp_get_corlib() | 0, i5 | 0, i6 | 0) | 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 224 >> 2] | 0;
 i3 = i1 + 228 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else if (__ZL41AssemblyNameMatchesWithOrWithoutExtensionPKcS0_(i4, _il2cpp_image_get_name(i1 | 0) | 0) | 0) i1 = _il2cpp_class_from_name(i1 | 0, i5 | 0, i6 | 0) | 0; else i1 = 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) == 0 ? (i2 | 0) != (HEAP32[i3 >> 2] | 0) : 0);
 return i1 | 0;
}

function __ZN10MeshFilter13AwakeFromLoadE17AwakeFromLoadMode(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
 if (i2 | 0) {
  i3 = i2 + 376 | 0;
  i1 = HEAP32[i6 + 32 >> 2] | 0;
  if ((HEAP32[i3 >> 2] | 0) != (i1 | 0)) {
   HEAP32[i3 >> 2] = i1;
   __ZN12MeshRenderer16UpdateCachedMeshEv(i2);
  }
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i6, gb + 1106136 | 0, i4);
 STACKTOP = i5;
 return;
}

function __Z51Rigidbody_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i5, i2, i4, i6 + 12 | 0);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z46Playables_CUSTOM_INTERNAL_CALL_ConnectInternalR9HPlayableS0_ii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(__Z23ParameterValidityChecksRK9HPlayableb(i1, 1) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] & 1 | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 550470 | 0, 0, gb + 550266 | 0, 394, 1, 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 }
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0; else i1 = 0;
 i4 = (__ZN8Playable7ConnectEPS_S0_ii(i1, HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, i4) | 0) & 1;
 return i4 | 0;
}

function __Z42Avatar_CUSTOM_INTERNAL_CALL_GetPreRotationP12Il2CppObjectiR11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK6Avatar14GetPreRotationEi(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z16HexStringToBytesPKcjPv(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i7) return; else i5 = 0;
 do {
  i4 = i5 << 1;
  i2 = HEAP8[i6 + i4 >> 0] | 0;
  i1 = i2 << 24 >> 24;
  do if (i2 << 24 >> 24 < 58) i3 = (i1 << 4) + -768 | 0; else {
   i1 = i1 << 4;
   if (i2 << 24 >> 24 < 91) {
    i3 = i1 + -880 | 0;
    break;
   } else {
    i3 = i1 + 144 | 0;
    break;
   }
  } while (0);
  i1 = HEAP8[i6 + (i4 | 1) >> 0] | 0;
  i2 = i1 << 24 >> 24;
  do if (i1 << 24 >> 24 < 58) i1 = i2 + -48 | i3 & 255; else if (i1 << 24 >> 24 < 91) {
   i1 = i2 + -55 | i3 & 255;
   break;
  } else {
   i1 = i2 + 169 | i3;
   break;
  } while (0);
  HEAP8[i8 + i5 >> 0] = i1;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i7 | 0));
 return;
}

function __ZThn4_N12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i5 = i8 + 48 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i7 = HEAP32[i8 + 44 >> 2] | 0;
 i3 = 0;
 while (1) {
  i1 = i7 + (i3 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) break;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i6 >>> 0) {
   i9 = 7;
   break;
  }
 }
 if ((i9 | 0) == 7) return;
 i9 = i6 + -1 | 0;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i1 >> 2] = HEAP32[i7 + (i9 << 2) >> 2];
 i1 = HEAP32[i8 + 12 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIssEEPsEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 4 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_(i6, i6 + 2 | 0, i5, i1) | 0;
 i4 = i6 + 6 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP16[i4 >> 1] | 0;
  i3 = HEAP16[i1 >> 1] | 0;
  if (i5 << 16 >> 16 < i3 << 16 >> 16) {
   i2 = i4;
   while (1) {
    HEAP16[i2 >> 1] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -2 | 0;
    i3 = HEAP16[i2 >> 1] | 0;
    if (i5 << 16 >> 16 >= i3 << 16 >> 16) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP16[i1 >> 1] = i5;
  }
  i1 = i4;
  i4 = i4 + 2 | 0;
 }
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i5 + 24 | 0;
 i8 = i5 + 28 | 0;
 i2 = 0;
 while (1) {
  if ((i2 | 0) >= (i6 | 0)) break;
  i3 = HEAP32[i7 >> 2] | 0;
  i4 = HEAP32[i8 >> 2] | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   i4 = i4 - i3 >> 2;
   i9 = i6 - i2 | 0;
   i4 = (i9 | 0) < (i4 | 0) ? i9 : i4;
   __ZNSt3__211char_traitsIwE4copyEPwPKwj(i3, i1, i4) | 0;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + (i4 << 2);
   i1 = i1 + (i4 << 2) | 0;
   i2 = i4 + i2 | 0;
   continue;
  }
  if ((mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, HEAP32[i1 >> 2] | 0) | 0) == -1) break;
  i1 = i1 + 4 | 0;
  i2 = i2 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNK26ProbeSetTetrahedralization7GetHashEv(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 i2 = i4 + 12 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i6 + 8 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  do {
   __ZN10SpookyHash7Hash128EPKvjPyS2_(i1, 80, i6, i3);
   i1 = i1 + 80 | 0;
  } while (((HEAP32[i4 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 80 | 0) | 0) != (i1 | 0));
 }
 i5 = i4 + 20 | 0;
 i3 = i4 + 32 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i6 + 8 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 do {
  __ZN10SpookyHash7Hash128EPKvjPyS2_(i1, 12, i6, i2);
  i1 = i1 + 12 | 0;
 } while (((HEAP32[i5 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 12 | 0) | 0) != (i1 | 0));
 return;
}

function __ZN9GfxDevice8OnDeleteEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i3 | 0);
 i1 = i3 + 4512 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 4516 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 4520 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN9Animation10RemoveClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i5 = i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i5, i2);
 HEAP32[i4 >> 2] = gb + 179108 + 8;
 i2 = i4 + 4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZN9Animation10RemoveClipERK19ShouldRemoveFunctorPKc(i1, i4, 0);
 HEAP32[i4 >> 2] = gb + 179108 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpCloth22removeCollisionCapsuleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore22removeCollisionCapsuleEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 394, gb + 695012 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN4gles24CreateColorRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 40 | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 150) | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i3 + 32 >> 2] = i1;
 i1 = i3 + 16 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = i5 >>> 0 > i6 >>> 0 ? i6 : i5;
 i1 = __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES(i2, i3) | 0;
 if (i1 | 0) HEAP32[i1 + 20 >> 2] = HEAP32[i4 >> 2];
 if (HEAP32[i3 + 20 >> 2] & 64 | 0) return;
 __ZN4gles21InitRenderSurfaceGLESEP7ApiGLESR17RenderSurfaceGLESN2gl17TextureSrgbDecodeE(i2, i3, 0);
 return;
}

function __ZN4FMOD6System19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 859027;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 859027;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859027;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1048607 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN21WorldParticleCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN20TextRenderingPrivate15CleanupFreeTypeEv() {
 var i1 = 0;
 if (HEAP8[gb + 1573585 >> 0] | 0) {
  _UNITY_FT_Bitmap_Done(HEAP32[gb + 1467876 >> 2] | 0, gb + 1467852 | 0) | 0;
  HEAP8[gb + 1573585 >> 0] = 0;
 }
 if (HEAP8[gb + 1573586 >> 0] | 0) {
  _Unity_FT_Done_FreeType(HEAP32[gb + 1467876 >> 2] | 0) | 0;
  HEAP8[gb + 1573586 >> 0] = 0;
 }
 i1 = HEAP32[gb + 1467884 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63392 | 0);
 HEAP32[gb + 1467884 >> 2] = 0;
 __ZN20TextRenderingPrivate15GetFontsManager13StaticDestroyEv();
 return;
}

function __ZN17AnimationPlayable27SetupStateMachineBehavioursEP6Object(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i7 | 0) <= 0) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = 0;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i8 = 8;
    break;
   } else i3 = 0;
  }
  if ((i8 | 0) == 8) {
   i8 = 0;
   i1 = i1 | (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i6 | 0) | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i7 | 0));
 return i1 | 0;
}

function __ZN15ParticleEmitterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  __ZdlPv(i1);
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i6;
 return;
}

function __ZN14CellVisualizer21containsCellRecursiveEii(i4, i1, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 1640 | 0;
 while (1) {
  i3 = HEAP32[i5 >> 2] | 0;
  i1 = i3 + (HEAP32[i3 + 64 >> 2] | 0) + (i1 << 3) | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = _bitshift64Lshr(i3 | 0, i1 | 0, 48) | 0;
  getTempRet0() | 0;
  if ((i3 | 0) < 0) {
   if ((i2 | 0) == (i6 | 0)) {
    i1 = 1;
    i2 = 7;
    break;
   }
  } else if (__ZN14CellVisualizer21containsCellRecursiveEii(i4, i2, i6) | 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
  i1 = i1 & 65535;
  if (i3 & 1073741824 | 0) {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  i6 = (i1 | 0) == (i6 | 0);
  return i6 | 0;
 } else if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __Z51Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Rigidbody24GetInertiaTensorRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofERKS5_j(i2, i3, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i7 = i4 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i3 >> 2] | 0 : i3;
 i4 = i7 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255;
 L5 : do if (i1 >>> 0 > i6 >>> 0) {
  i3 = i2 + i1 | 0;
  i1 = i2 + i6 | 0;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) {
    i1 = -1;
    break L5;
   }
   if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i5, i4, i1) | 0)) break;
   i1 = i1 + 1 | 0;
  }
  i1 = i1 - i2 | 0;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZNK12UnityVersioneqERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) if ((i8 | 0) == (i4 | 0)) if ((i9 | 0) == (i5 | 0)) if ((i10 | 0) == (i6 | 0)) if ((i7 | 0) == (i3 | 0)) {
  i10 = 1;
  return i10 | 0;
 } else {
  i2 = i3;
  i1 = i7;
 } else {
  i2 = i6;
  i1 = i10;
 } else {
  i2 = i5;
  i1 = i9;
 } else {
  i2 = i4;
  i1 = i8;
 }
 i10 = (i1 | 0) == (i2 | 0);
 return i10 | 0;
}

function __ZN8RendererD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 43728 + 8;
 HEAP32[i3 + 32 >> 2] = gb + 43728 + 180;
 i1 = i3 + 224 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 288 | 0;
 if ((HEAP32[i3 + 304 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 292 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE6resizeEjRKS3_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE8recreateEj(i1, i8);
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i2 + (i8 * 104 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i1 = i2 + (i1 * 104 | 0) | 0;
 do {
  i2 = i1;
  i3 = i7;
  i4 = i2 + 104 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
  } while ((i2 | 0) < (i4 | 0));
  i1 = i1 + 104 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN5physx14NpRigidDynamic6wakeUpEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, f3 = f0, i5 = 0;
 i1 = i4 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 2860 >> 2]);
 switch ((HEAP32[i4 + 52 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i5 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[i2 + 2432 >> 0] | 0)) i5 = 3; else i5 = 4;
   break;
  }
 default:
  i5 = 3;
 }
 if ((i5 | 0) == 3) {
  HEAP32[i4 + 280 >> 2] = 0;
  HEAPF32[i4 + 276 >> 2] = f3;
  __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i4 + 64 | 0, f3, 1);
  return;
 } else if ((i5 | 0) == 4) {
  HEAP32[i4 + 280 >> 2] = 0;
  HEAPF32[i4 + 276 >> 2] = f3;
  __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE(i2, i1);
  i5 = i4 + 284 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -29360129 | 20971520;
  return;
 }
}

function __ZN4FMOD6System19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 866098;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 866098;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 866098;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN24OptimizedPolynomialCurve9IntegrateEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, f4 = f0, i5 = 0, f6 = f0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.25));
 i3 = i1 + 4 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.333333343));
 i5 = i1 + 8 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.5));
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i5 >> 2] = f6;
 i5 = i1 + 16 | 0;
 f6 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(.25));
 i3 = i1 + 20 | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.333333343));
 i1 = i1 + 24 | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.5));
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i3 >> 2] = f4;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 378221 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN21LightProbeProxyVolume8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 855533 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN21AudioDistortionFilter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i5 = i4;
 i8 = i1 + 200 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i5 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i3) | 0;
 if ((i5 | 0) != (HEAP32[i1 + 192 >> 2] | 0)) {
  i8 = 0;
  STACKTOP = i4;
  return i8 | 0;
 }
 i8 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, (i2 | 0) == 0 ? i3 : i2, 0) | 0;
 STACKTOP = i4;
 return i8 | 0;
}

function __ZN18AudioLowPassFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 16 | 0;
 i3 = i4;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i5 = i1 + 132 | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i7 = f6 < Math_fround(1.0);
 i8 = f6 > Math_fround(10.0);
 f6 = i8 ? Math_fround(10.0) : f6;
 HEAPF32[i5 >> 2] = i7 ? Math_fround(1.0) : f6;
 if ((HEAP32[i1 + 112 >> 2] | 0) >= 1) {
  STACKTOP = i4;
  return;
 }
 HEAPF32[i2 >> 2] = Math_fround(.227272734);
 __ZN11KeyframeTplIfEC2EfRKf(i3, Math_fround(0.0), i2);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1 + 44 | 0, i3, i3 + 16 | 0);
 STACKTOP = i4;
 return;
}

function __ZN12SoundManager27OnCreateSoundPushAllocationEPv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[gb + 1098880 >> 0] | 0)) {
  i1 = gb + 874396 | 0;
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (gb + 874396 + 88 | 0));
  i1 = ~i2;
  HEAP32[gb + 1459916 >> 2] = i1;
  i2 = gb + 1098880 | 0;
  HEAP32[i2 >> 2] = 1;
  HEAP32[i2 + 4 >> 2] = 0;
 } else i1 = HEAP32[gb + 1459916 >> 2] | 0;
 if ((i4 | 0) != (i1 | 0)) {
  i4 = 37;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i4 = 37;
  return i4 | 0;
 }
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[i1 + 52 >> 2] | 0, 0, 0) | 0;
 i4 = i4 ? 0 : 37;
 return i4 | 0;
}

function __Z41Physics_CUSTOM_INTERNAL_CALL_CheckCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 12 | 0;
 i7 = i6;
 i9 = __Z17GetPhysicsManagerv() | 0;
 HEAP32[i8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i5 = (__ZN14PhysicsManager11CapsuleTestE8Vector3fS0_fi23QueryTriggerInteraction(i9, i8, i7, f3, i4, i5) | 0) & 1;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z35AudioClip_CUSTOM_Construct_Internalv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 8 | 0;
 i4 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(136, gb + 63520 | 0, 16, gb + 1048932 | 0, 0, gb + 875076 | 0, 418) | 0;
 i7 = gb + 63520 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN9AudioClipC2E10MemLabelId18ObjectCreationMode(i2, i3, 0);
 __Z19pop_allocation_rootv();
 i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN6Object27AllocateAndAssignInstanceIDEPS_(i2) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _cff_builder_add_point1(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (((HEAP16[i1 + 22 >> 1] | 0) + 1 + (HEAP16[i1 + 58 >> 1] | 0) | 0) >>> 0 > (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
  i1 = _UNITY_FT_GlyphLoader_CheckPoints(i1, 1, 0) | 0;
  if (i1 | 0) {
   i4 = i1;
   return i4 | 0;
  }
 }
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!(HEAP8[i2 + 65 >> 0] | 0)) i1 = i1 + 2 | 0; else {
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = i1 + 2 | 0;
  i5 = HEAP16[i2 >> 1] | 0;
  i1 = (HEAP32[i1 + 8 >> 2] | 0) + i5 | 0;
  HEAP32[i6 + (i5 << 3) >> 2] = i3 >> 10;
  HEAP32[i6 + (i5 << 3) + 4 >> 2] = i4 >> 10;
  HEAP8[i1 >> 0] = 1;
  i1 = i2;
 }
 HEAP16[i1 >> 1] = (HEAP16[i1 >> 1] | 0) + 1 << 16 >> 16;
 i6 = 0;
 return i6 | 0;
}

function __ZNK5physx7NpCloth19getVirtualParticlesEPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZNK5physx2Sc9ClothCore19getVirtualParticlesEPj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 523, gb + 693716 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZNK13WheelCollider13GetSprungMassEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = i1 + 148 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i3) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i3 + 52 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i3 + 56 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i3 = (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) + 56 >> 2] | 0) + 8 | 0;
 f4 = Math_fround(HEAPF32[(__ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i3, HEAP32[i2 >> 2] | 0) | 0) + 16 >> 2]);
 return Math_fround(f4);
}

function __ZN9Polygon2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i8 = i1;
 if ((i2 | 0) == (i1 | 0)) return;
 i6 = (i2 - i1 | 0) / 20 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i8 + (i1 * 20 | 0) + 12 >> 2] | 0;
  if (i7 | 0) {
   i3 = HEAP32[i8 + (i1 * 20 | 0) >> 2] | 0;
   i2 = 0;
   do {
    i4 = i3 + (i2 << 3) | 0;
    i5 = i3 + (i2 << 3) + 4 | 0;
    if (!((HEAP32[i4 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i5 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
     HEAPF32[i4 >> 2] = Math_fround(0.0);
     HEAPF32[i5 >> 2] = Math_fround(0.0);
    }
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < i7 >>> 0);
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 return;
}

function __ZN5physx7NpCloth21removeCollisionSphereEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore21removeCollisionSphereEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 352, gb + 695337 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth21removeCollisionConvexEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore21removeCollisionConvexEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 483, gb + 694449 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore16setContactOffsetEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1075, gb + 692303 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN4FMOD6System19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869816;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869816;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869816;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869306;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869306;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869306;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1046572 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1041655 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN20UnityConnectSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN16Physics2DManager21GetLayerCollisionMaskEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i4 + 4 | 0;
 i2 = __Z21GetManagerFromContexti(16) | 0;
 if (i5 >>> 0 > 31) {
  HEAP32[i3 >> 2] = 31;
  __Z6FormatPKcz(i1, gb + 805697 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 805767 | 0, 452, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  i5 = -1;
  STACKTOP = i4;
  return i5 | 0;
 } else {
  i5 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 801108 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 801116 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 801132 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 735705 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12b2BroadPhase12DestroyProxyEi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i4 + 40 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i7 = HEAP32[i4 + 32 >> 2] | 0;
  i3 = 0;
  do {
   i2 = i7 + (i3 << 2) | 0;
   if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
    HEAP32[i2 >> 2] = -1;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 i7 = i4 + 28 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 __ZN13b2DynamicTree10RemoveLeafEi(i4, i5);
 i7 = i4 + 16 | 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i6 + (i5 * 36 | 0) + 20 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + (i5 * 36 | 0) + 32 >> 2] = -1;
 HEAP32[i7 >> 2] = i5;
 i7 = i4 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 return;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStreamD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150892 + 8;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i5 = 3; else {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  if (!i3) i5 = 3;
 }
 if ((i5 | 0) == 3) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  __ZN5physx6shdfnd6Socket10disconnectEv(i3);
  __ZN5physx6shdfnd6SocketD2Ev(i3);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 HEAP32[i4 + 12 >> 2] = gb + 148172 + 8;
 i5 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[i5 >> 2] | 0);
 return;
}

function __ZL34GetComponentsImplementationRecurseILb0ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) | 0;
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = i5;
  i5 = 0;
  i5 = i4 & i5;
  return i5 | 0;
 }
 i4 = i5 | (__ZL34GetComponentsImplementationRecurseILb0ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i2, i3, i4) | 0);
 i5 = 1;
 i5 = i4 & i5;
 return i5 | 0;
}

function __ZL34GetComponentsImplementationRecurseILb0ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) | 0;
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = i5;
  i5 = 0;
  i5 = i4 & i5;
  return i5 | 0;
 }
 i4 = i5 | (__ZL34GetComponentsImplementationRecurseILb0ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i2, i3, i4) | 0);
 i5 = 1;
 i5 = i4 & i5;
 return i5 | 0;
}

function __ZL34GetComponentsImplementationRecurseILb0ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(i1, i2, i3, i4) | 0;
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i4 = i5;
  i5 = 0;
  i5 = i4 & i5;
  return i5 | 0;
 }
 i4 = i5 | (__ZL34GetComponentsImplementationRecurseILb0ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue(HEAP32[i1 + 28 >> 2] | 0, i2, i3, i4) | 0);
 i5 = 1;
 i5 = i4 & i5;
 return i5 | 0;
}

function __Z44Object_CUSTOM_Internal_CloneSingleWithParentP12Il2CppObjectS0_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z11CloneObjectR6ObjectR9Transformb(i4, i1, i3 << 24 >> 24 != 0) | 0) | 0;
 return 0;
}

function __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i7 + 48 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i5 = i7 + 44 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i6 | 0)) {
    i1 = i3;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break L1;
  }
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0);
  i6 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i6;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i6 << 2) >> 2];
  i1 = i6;
 } while (0);
 HEAP8[i7 + 88 >> 0] = (i1 | 0) != 0 & 1;
 return;
}

function __ZNSt3__28ios_base4InitD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 invoke_ii(fb + 2802 | 0, gb + 1473684 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) i2 = 6; else {
  __THREW__ = 0;
  invoke_ii(fb + 2803 | 0, gb + 1473768 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) i2 = 6; else {
   __THREW__ = 0;
   invoke_ii(fb + 2802 | 0, gb + 1474020 | 0) | 0;
   i1 = __THREW__;
   __THREW__ = 0;
   if (!(i1 & 1)) {
    __THREW__ = 0;
    invoke_ii(fb + 2803 | 0, gb + 1474104 | 0) | 0;
    i1 = __THREW__;
    __THREW__ = 0;
    if (!(i1 & 1)) return;
   }
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
  }
 }
 if ((i2 | 0) == 6) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
 }
 ___clang_call_terminate(i1);
}

function __ZNSt3__219__thread_struct_imp25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 < (HEAP32[i3 + 20 >> 2] | 0) >>> 0) {
  i6 = i4;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 8;
 } else __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE21__push_back_slow_pathIS6_EEvOT_(i3 + 12 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZNK28RectTransformPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 8 | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) i6 = 3; else if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 28980 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28980 + 28 >> 2] | 0) >>> 0) i6 = 3;
 if ((i6 | 0) == 3) i1 = 0;
 __ZN9Transform18GetTransformAccessEv(i3, i1);
 if (!i1) {
  f7 = Math_fround(0.0);
  STACKTOP = i5;
  return Math_fround(f7);
 }
 __ZNK9Transform16GetLocalPositionEv(i4, i1);
 f7 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 STACKTOP = i5;
 return Math_fround(f7);
}

function __ZN5physx2Sc17ParticleSystemSim22createShapeUpdateInputERNS_28PxvParticleShapesUpdateInputE(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 360 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i1 << 2, gb + 683965 | 0, 792) | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i2 = 0; else {
   i3 = i3 + 356 | 0;
   i4 = 0;
   do {
    HEAP32[i1 + (i4 << 2) >> 2] = HEAP32[(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 44 >> 2];
    i4 = i4 + 1 | 0;
   } while (i4 >>> 0 < i2 >>> 0);
  }
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 734671 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity14CharacterJoint8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN2UI11CanvasGroup22SendCanvasGroupChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106076 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 379002 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN20OcclusionCullingData8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19RuntimeSceneManager20RemoveAndDeleteSceneEP10UnityScene(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i1 << 2) | 0;
 L1 : do if (!i1) i1 = i2; else {
  i1 = i2;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i4 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 i5 = i1 + 4 | 0;
 _memmove(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) - i5 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i6 = 1;
 return i6 | 0;
}

function __ZN17AnimationPlayable28ComputeNeedsBindingRebuildedEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 i1 = (HEAP8[i5 + 56 >> 0] | 0) != 0;
 if ((i6 | 0) <= 0) {
  i7 = i1;
  return i7 | 0;
 }
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i7 = 8;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 8) {
   i7 = 0;
   i1 = i1 | (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0) | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i6 | 0));
 return i1 | 0;
}

function __ZN16CircleCollider2D10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0, i6 = 0, f7 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 if (!(__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f5 = f5 < f7 ? f7 : f5;
 i3 = f5 < Math_fround(.0000999999974);
 i6 = f5 > Math_fround(1.0e6);
 f5 = i6 ? Math_fround(1.0e6) : f5;
 HEAPF32[i1 + 160 >> 2] = i3 ? Math_fround(.0000999999974) : f5;
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 4 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 HEAP32[i1 + 84 >> 2] = i2;
 HEAP32[i1 + 92 >> 2] = i3;
 i2 = HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8;
 i6 = Math_imul((i2 & 65535) >>> 8 & 65535, HEAPU8[(i2 & 255) + (gb + 430676) >> 0] | 0) | 0;
 HEAP32[i1 + 80 >> 2] = i6;
 HEAP32[i1 + 96 >> 2] = Math_imul(i6, i3) | 0;
 i3 = 1 << i4 & 255;
 HEAP32[i1 + 88 >> 2] = i3;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP8[i1 + 42 >> 0] = i6;
 HEAP8[i1 + (i4 << 2) + 2 >> 0] = i2;
 HEAP8[i1 + (i4 << 2) + 3 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
 HEAP8[i1 + 100 >> 0] = (__Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo(i1) | 0) & 1;
 return;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStreamD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 150856 + 8;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) i5 = 3; else {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  if (!i3) i5 = 3;
 }
 if ((i5 | 0) == 3) {
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i1 + 4 | 0;
  __ZN5physx6shdfnd6Socket10disconnectEv(i3);
  __ZN5physx6shdfnd6SocketD2Ev(i3);
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i1 | 0);
 }
 HEAP32[i4 + 12 >> 2] = gb + 148172 + 8;
 i5 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i5 >> 2] | 0);
 i4 = HEAP32[i4 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, HEAP32[i5 >> 2] | 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper17GetPlayerPrefsIntERK8UnityStri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, i1);
 i2 = __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN10MemoryPool13DeallocateAllEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) {
  i3 = i4 + 44 | 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i1 = i4 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i6 = i4 + 32 | 0;
  HEAP32[i6 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 16 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i6 = i4 + 32 | 0;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __Z53Terrain_CUSTOM_Internal_GetSplatMaterialPropertyBlockP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4); else {
  __ZN7Terrain27GetSplatMaterialCustomPropsER19ShaderPropertySheet(i3, i1);
  STACKTOP = i5;
  return;
 }
}
function __Z50Collider_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZN8Collider20ClosestPointOnBoundsERK8Vector3fRS0_Rf(i5, i2, i4, i6 + 12 | 0);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z44TerrainData_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i6 = __ZN12TreeDatabase11RemoveTreesERK8Vector2ffi(i6 + 84 | 0, i5, f3, i4) | 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 return 0;
}

function _UNITY_png_zstream_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 244 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 do switch (i2 | 0) {
 case -7:
  {
   HEAP32[i1 >> 2] = gb + 350859;
   return;
  }
 case 1:
  {
   HEAP32[i1 >> 2] = gb + 350729;
   return;
  }
 case 2:
  {
   HEAP32[i1 >> 2] = gb + 350757;
   return;
  }
 case -1:
  {
   HEAP32[i1 >> 2] = gb + 350779;
   return;
  }
 case -2:
  {
   HEAP32[i1 >> 2] = gb + 350793;
   return;
  }
 case -3:
  {
   HEAP32[i1 >> 2] = gb + 350816;
   return;
  }
 case -4:
  {
   HEAP32[i1 >> 2] = gb + 362452;
   return;
  }
 case -5:
  {
   HEAP32[i1 >> 2] = gb + 352279;
   return;
  }
 case -6:
  {
   HEAP32[i1 >> 2] = gb + 350834;
   return;
  }
 default:
  {
   HEAP32[i1 >> 2] = gb + 350701;
   return;
  }
 } while (0);
}

function _cf2_getSeacComponent(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 4 | 0;
 i5 = i6;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = _cff_lookup_glyph_by_stdcharcode(HEAP32[i2 + 76 >> 2] | 0, i1) | 0;
 if ((i1 | 0) < 0) {
  i5 = 18;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = _cff_get_glyph_data(HEAP32[i2 + 4 >> 2] | 0, i1, i4, i5) | 0;
 if (i1 | 0) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i4 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = i4 + (HEAP32[i5 >> 2] | 0);
 HEAP32[i3 + 12 >> 2] = i4;
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP16[i4 >> 1] | 0;
 i3 = HEAP16[i5 >> 1] | 0;
 if ((i2 & 65535) < (i3 & 65535)) {
  HEAP16[i5 >> 1] = i2;
  HEAP16[i4 >> 1] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP16[i5 >> 1] | 0;
  i3 = HEAP16[i7 >> 1] | 0;
  if ((i2 & 65535) < (i3 & 65535)) {
   HEAP16[i7 >> 1] = i2;
   HEAP16[i5 >> 1] = i3;
   i2 = HEAP16[i7 >> 1] | 0;
   i3 = HEAP16[i6 >> 1] | 0;
   if ((i2 & 65535) < (i3 & 65535)) {
    HEAP16[i6 >> 1] = i2;
    HEAP16[i7 >> 1] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i2 << 24 >> 24 < i3 << 24 >> 24) {
  HEAP8[i5 >> 0] = i2;
  HEAP8[i4 >> 0] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  i3 = HEAP8[i7 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i7 >> 0] = i2;
   HEAP8[i5 >> 0] = i3;
   i2 = HEAP8[i7 >> 0] | 0;
   i3 = HEAP8[i6 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i6 >> 0] = i2;
    HEAP8[i7 >> 0] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if (i2 << 24 >> 24 < i3 << 24 >> 24) {
  HEAP8[i5 >> 0] = i2;
  HEAP8[i4 >> 0] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  i3 = HEAP8[i7 >> 0] | 0;
  if (i2 << 24 >> 24 < i3 << 24 >> 24) {
   HEAP8[i7 >> 0] = i2;
   HEAP8[i5 >> 0] = i3;
   i2 = HEAP8[i7 >> 0] | 0;
   i3 = HEAP8[i6 >> 0] | 0;
   if (i2 << 24 >> 24 < i3 << 24 >> 24) {
    HEAP8[i6 >> 0] = i2;
    HEAP8[i7 >> 0] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNK12UnityVersionltERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) if ((i8 | 0) == (i4 | 0)) if ((i9 | 0) == (i5 | 0)) if ((i10 | 0) == (i6 | 0)) if ((i7 | 0) == (i3 | 0)) {
  i10 = 0;
  return i10 | 0;
 } else {
  i2 = i3;
  i1 = i7;
 } else {
  i2 = i6;
  i1 = i10;
 } else {
  i2 = i5;
  i1 = i9;
 } else {
  i2 = i4;
  i1 = i8;
 }
 i10 = (i1 - i2 | 0) < 0;
 return i10 | 0;
}

function __ZNK12UnityVersiongtERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i9 = HEAP32[i2 + 8 >> 2] | 0;
 i10 = HEAP32[i2 + 12 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) if ((i8 | 0) == (i4 | 0)) if ((i9 | 0) == (i5 | 0)) if ((i10 | 0) == (i6 | 0)) if ((i7 | 0) == (i3 | 0)) {
  i10 = 0;
  return i10 | 0;
 } else {
  i2 = i3;
  i1 = i7;
 } else {
  i2 = i6;
  i1 = i10;
 } else {
  i2 = i5;
  i1 = i9;
 } else {
  i2 = i4;
  i1 = i8;
 }
 i10 = (i1 - i2 | 0) > 0;
 return i10 | 0;
}

function __ZN8Renderer18UpdateManagerStateEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i2 + 316 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!((i3 | 0) != 0 ^ i1)) return;
 if (!i1) {
  if (!i3) return;
  i4 = i2 + 320 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i4 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
 if ((i5 | 0) == (i4 | 0)) return;
 if (!i3) i1 = i2 + 320 | 0; else {
  i1 = i2 + 320 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i5;
 return;
}

function __ZN5physx7NpCloth20removeCollisionPlaneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore20removeCollisionPlaneEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 451, gb + 694770 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN26RemapFunctorTempRemapTable18GenerateInstanceIDEi17TransferMetaFlags(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = i7;
  return i8 | 0;
 }
 if ((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i8 = i7;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 return i8 | 0;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1037672 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19SpriteMeshGenerator11evaluateLODEff(i1, f5, f6) {
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = (HEAP32[i1 + 4 >> 2] | 0) - i4 | 0;
 i3 = (i2 | 0) / 68 | 0;
 if ((i2 | 0) > 0) {
  i2 = 0;
  i1 = 0;
  do {
   if ((HEAP32[i4 + (i2 * 68 | 0) + 20 >> 2] | 0) == 45) i1 = i1 + 2 | 0; else i1 = i1 + -2 + ((HEAP32[i4 + (i2 * 68 | 0) + 4 >> 2] | 0) - (HEAP32[i4 + (i2 * 68 | 0) >> 2] | 0) >> 5) | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (i3 | 0));
 } else i1 = 0;
 f6 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f5 * f6) / Math_fround(i1 | 0)));
 i4 = f6 < Math_fround(0.0);
 i3 = f6 > Math_fround(1.0);
 f6 = i3 ? Math_fround(1.0) : f6;
 return Math_fround(i4 ? Math_fround(0.0) : f6);
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1047979 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19MeshParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8AllocateEji(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 if (i4 | 0) {
  i1 = i4 + 12 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   HEAP32[i1 >> 2] = 0;
   i2 = i4 + 4 | 0;
   if (HEAP32[i2 >> 2] | 0) {
    i3 = i4 + 16 | 0;
    i1 = 0;
    do {
     i8 = HEAP32[i3 >> 2] | 0;
     mftCall_vii(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
   }
   HEAP32[i2 >> 2] = 0;
  }
 }
 return __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji(i5, i6, i7) | 0;
}

function __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i4 + 8 >> 2];
 i4 = i1 + 44 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __ZN10Matrix4x4f12SetTranslateERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z43AnimationState_CUSTOM_RemoveMixingTransformP12Il2CppObjectS0_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN14AnimationState21RemoveMixingTransformER9Transform(i2, i1);
  STACKTOP = i5;
  return;
 }
}

function __Z14IsStringNumberPKc(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP8[i5 >> 0] | 0;
 L1 : do if (!(i2 << 24 >> 24)) i1 = 0; else {
  i1 = 0;
  i4 = 0;
  i3 = 0;
  while (1) {
   switch (i2 << 24 >> 24 | 0) {
   case 57:
   case 56:
   case 55:
   case 54:
   case 53:
   case 52:
   case 51:
   case 50:
   case 49:
   case 48:
    {
     i1 = 1;
     break;
    }
   case 44:
   case 46:
    {
     if (i3) {
      i1 = 0;
      break L1;
     } else i3 = 1;
     break;
    }
   case 45:
   case 43:
    {
     if (i4) {
      i1 = 0;
      break L1;
     }
     break;
    }
   default:
    {
     i1 = 0;
     break L1;
    }
   }
   i4 = i4 + 1 | 0;
   i2 = HEAP8[i5 + i4 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L1;
  }
 } while (0);
 return i1 | 0;
}

function _pad(i6, i2, i4, i5, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 do if ((i4 | 0) > (i5 | 0) & (i1 & 73728 | 0) == 0) {
  i1 = i4 - i5 | 0;
  _memset(i7 | 0, i2 | 0, (i1 >>> 0 > 256 ? 256 : i1) | 0) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i3 = (i2 & 32 | 0) == 0;
  if (i1 >>> 0 > 255) {
   i4 = i4 - i5 | 0;
   do {
    if (i3) {
     ___fwritex(i7, 256, i6) | 0;
     i2 = HEAP32[i6 >> 2] | 0;
    }
    i1 = i1 + -256 | 0;
    i3 = (i2 & 32 | 0) == 0;
   } while (i1 >>> 0 > 255);
   if (i3) i1 = i4 & 255; else break;
  } else if (!i3) break;
  ___fwritex(i7, i1, i6) | 0;
 } while (0);
 STACKTOP = i8;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIccEEPcEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 2 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_(i6, i6 + 1 | 0, i5, i1) | 0;
 i4 = i6 + 3 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if (i5 << 24 >> 24 < i3 << 24 >> 24) {
   i2 = i4;
   while (1) {
    HEAP8[i2 >> 0] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
    if (i5 << 24 >> 24 >= i3 << 24 >> 24) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP8[i1 >> 0] = i5;
  }
  i1 = i4;
  i4 = i4 + 1 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIaaEEPaEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 2 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_(i6, i6 + 1 | 0, i5, i1) | 0;
 i4 = i6 + 3 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if (i5 << 24 >> 24 < i3 << 24 >> 24) {
   i2 = i4;
   while (1) {
    HEAP8[i2 >> 0] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
    if (i5 << 24 >> 24 >= i3 << 24 >> 24) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP8[i1 >> 0] = i5;
  }
  i1 = i4;
  i4 = i4 + 1 | 0;
 }
 return;
}

function __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i13 = i8 + 4 | 0;
 i12 = i8;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 i7 = mftCall_iiiiiiii(i11 | 0, i1 | 0, i10 | 0, i9 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0, i13 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 12 | 0;
 i10 = i8 + 8 | 0;
 i13 = i8 + 4 | 0;
 i12 = i8;
 i11 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i13 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i13 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 i7 = mftCall_iiiiiiii(i11 | 0, i1 | 0, i10 | 0, i9 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK20LocalFileSystemPosix26GetApplicationContentsPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i4 | 0, i2 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 752967 | 0, 4);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj(i7, i6, i1, i5, i4) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i2 = (HEAP32[i1 + 28 >> 2] | 0) + 32 | 0;
 i3 = __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv(i1) | 0;
 i1 = __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv(i1) | 0;
 if (i3) __ZN5physx21PxsBodyTransformVault10removeBodyERKNS_11PxsBodyCoreE((HEAP32[(HEAP32[i7 + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 1444 | 0, i1);
 i8 = HEAP32[i7 + 56 >> 2] | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 40 >> 2] | 0, i8 | 0, HEAP32[i6 + 44 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0, i5 | 0, (i4 | 0) != 0 | 0);
 i7 = i7 + 368 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
 return;
}

function __ZN21AudioDistortionFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 170716 + 8;
 HEAPF32[i1 + 44 >> 2] = Math_fround(.5);
 HEAP32[i1 + 36 >> 2] = 8;
 STACKTOP = i4;
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 429151 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19SkinnedMeshRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 734401 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19CharacterController8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 855611 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19AudioHighPassFilter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 367172 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN19AssetBundleManifest8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE(i8, i4) {
 i8 = i8 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i5 = i8 + 52 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i7 = HEAP32[i8 + 48 >> 2] | 0;
 i3 = 0;
 while (1) {
  i1 = i7 + (i3 << 2) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 + 4 >> 2] | 0) == (i4 | 0)) break;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i6 >>> 0) {
   i9 = 7;
   break;
  }
 }
 if ((i9 | 0) == 7) return;
 i9 = i6 + -1 | 0;
 HEAP32[i5 >> 2] = i9;
 HEAP32[i1 >> 2] = HEAP32[i7 + (i9 << 2) >> 2];
 i1 = HEAP32[i8 + 16 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i1 + 424 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i1 + 296 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i1 + 168 | 0);
 __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev(i1 + 40 | 0);
 i3 = i1 + 12 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 STACKTOP = i4;
 return;
}

function __Z30ComputeShader_CUSTOM_HasKernelP12Il2CppObjectP12Il2CppString(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 HEAP32[i3 >> 2] = __Z25ScriptingStringToPropertyR11ICallString(i5) | 0;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i5 = (__ZN13ComputeShader9HasKernelERKN9ShaderLab16FastPropertyNameE(i1, i3) | 0) & 1;
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function __Z22Check2MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_P6ObjectR11MonoManager(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 16 | 0;
 i8 = i7 + 8 | 0;
 i10 = i7;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i4;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i10;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i10 + 4 >> 2];
 i6 = __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i9, i2, i8, 2, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = i5 + 24 | 0;
 i8 = i5 + 28 | 0;
 i4 = 0;
 while (1) {
  if ((i4 | 0) >= (i6 | 0)) break;
  i2 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i8 >> 2] | 0;
  if (i2 >>> 0 >= i3 >>> 0) {
   if ((mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 52 >> 2] | 0, i5 | 0, HEAPU8[i1 >> 0] | 0 | 0) | 0) == -1) break;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
   continue;
  }
  i3 = i3 - i2 | 0;
  i9 = i6 - i4 | 0;
  i3 = (i9 | 0) < (i3 | 0) ? i9 : i3;
  if (i3) {
   _memcpy(i2 | 0, i1 | 0, i3 | 0) | 0;
   i2 = HEAP32[i7 >> 2] | 0;
  }
  HEAP32[i7 >> 2] = i2 + i3;
  i1 = i1 + i3 | 0;
  i4 = i3 + i4 | 0;
 }
 return i4 | 0;
}

function __ZNK20LocalFileSystemPosix25GetApplicationManagedPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 12 | 0;
 i5 = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i4 | 0, i2 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i5, gb + 491564 | 0, 7);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i4, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZNK15ReflectionProbe15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZNK9Transform11GetPositionEv(i7, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 + 76 >> 2]));
 f5 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 + 80 >> 2]));
 f4 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 84 >> 2]));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN9Transform25CleanupTransformHierarchyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = i1 + 32 | 0;
 if (HEAP32[i1 + 36 >> 2] | 0) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i2 = HEAP32[gb + 1158396 >> 2] | 0;
 i3 = i1 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != -1) {
  i6 = i2 + 12 | 0;
  i7 = (HEAP32[i6 >> 2] | 0) + -1 | 0;
  i8 = HEAP32[i2 >> 2] | 0;
  i2 = i8 + (i7 << 2) | 0;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] = i4;
  i4 = i8 + (HEAP32[i3 >> 2] << 2) | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 >> 2] = -1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN9GfxDevice24CreateRenderColorSurfaceE9TextureIDiiii16TextureDimension19RenderTextureFormatj(i6, i1, i3, i4, i7, i5, i8, i9, i10) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 384 >> 2] | 0, i6 | 0, 1) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i5;
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = i10;
 HEAP32[i2 + 24 >> 2] = i8;
 HEAP32[i2 + 16 >> 2] = i7;
 HEAP8[i2 + 31 >> 0] = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 392 >> 2] | 0, i6 | 0, i2 | 0, i9 | 0) | 0) return i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 64;
 return i2 | 0;
}

function __ZN5physx3Cct17CapsuleController9setRadiusEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAPF32[i3 + 496 >> 2] = f2;
 if (!(HEAP32[i3 + 408 >> 2] | 0)) {
  STACKTOP = i4;
  return 1;
 }
 i5 = __ZNK5physx3Cct10Controller12getKineShapeEv(i3 + 8 | 0) | 0;
 HEAP32[i1 >> 2] = 2;
 i6 = i1 + 4 | 0;
 HEAPF32[i6 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i1 | 0) | 0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 488 >> 2]) * f2);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0, i1 | 0);
 STACKTOP = i4;
 return 1;
}

function __ZN5Cache18SetExpirationDelayEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = i6 + 4 | 0;
 i4 = i1 + 48 | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i2 | 0) <= 1296e4) {
  __ZN5Cache18WriteCacheInfoFileEb(i1, 1);
  STACKTOP = i6;
  return;
 }
 HEAP32[i5 >> 2] = 1296e4;
 __Z6FormatPKcz(i3, gb + 444405 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 444242 | 0, 315, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 HEAP32[i4 >> 2] = 1296e4;
 __ZN5Cache18WriteCacheInfoFileEb(i1, 1);
 STACKTOP = i6;
 return;
}

function __ZN13DrawImmediate11BeginBufferEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 4512 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 896 >> 2] | 0, i1 | 0) | 0;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 i1 = i4 + 20 | 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = -1;
 HEAP32[i4 + 32 >> 2] = 0;
 if (mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 88, 768, 0, HEAP32[i4 + 212 >> 2] | 0, i1 | 0) | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + 16 >> 2] = i3;
  i4 = i3;
  i4 = (i4 | 0) != 0;
  return i4 | 0;
 } else {
  i4 = HEAP32[i4 + 16 >> 2] | 0;
  i4 = (i4 | 0) != 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN12InputManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 434516 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 i1 = i1 + 28 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 434529 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZL32GeomOverlapCallback_SphereSphereRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f8 = Math_fround(f8 - Math_fround(HEAPF32[i4 + 16 >> 2]));
 f6 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i4 + 20 >> 2]));
 f7 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i4 + 24 >> 2]));
 f7 = Math_fround(Math_fround(Math_fround(f8 * f8) + Math_fround(f6 * f6)) + Math_fround(f7 * f7));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 return f7 <= Math_fround(f6 * f6) | 0;
}

function __Z30Physics_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = __Z17GetPhysicsManagerv() | 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN14PhysicsManager15IgnoreCollisionER8ColliderS1_b(i4, i5, i1, i3 << 24 >> 24 != 0);
  return;
 }
}

function __Z22ApplyPerspectiveMatrixRK6Camerab(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = __Z12GetGfxDevicev() | 0;
 __ZNK6Camera28ExtractCameraRenderingParamsEv(i4, i1);
 i6 = i4 + 64 | 0;
 if (i2) i1 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0; else i1 = __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i1) | 0;
 i3 = i6;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 116 >> 2] | 0, i5 | 0, i6 | 0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0, i4 | 0);
 STACKTOP = i7;
 return;
}

function _cff_get_ros(i1, i4, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 656 >> 2] | 0;
 if (!i5) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i5 + 1456 >> 2] | 0;
 if ((i3 | 0) == 65535) {
  i7 = 6;
  return i7 | 0;
 }
 if (i4 | 0) {
  i2 = i5 + 2964 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = _cff_index_get_sid_string(i5, i3) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP32[i4 >> 2] = i1;
 }
 if (i6 | 0) {
  i2 = i5 + 2968 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = _cff_index_get_sid_string(i5, HEAP32[i5 + 1460 >> 2] | 0) | 0;
   HEAP32[i2 >> 2] = i1;
  }
  HEAP32[i6 >> 2] = i1;
 }
 if (!i7) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[i7 >> 2] = HEAP32[i5 + 1464 >> 2];
 i7 = 0;
 return i7 | 0;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwner9readBytesEPhj(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + -4 | 0;
 i4 = i3 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i6 | 0, i5 | 0) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0);
  i6 = i1;
  return i6 | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 i6 = 1;
 return i6 | 0;
}

function __ZN5physx7NpCloth14setWakeCounterEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 switch ((HEAP32[i1 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i1 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore14setWakeCounterEf(i1 + 32 | 0, f3);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 978, gb + 691837 | 0, i2);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx14SapPairManager4initEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = (i1 << 2) + 15 & -16;
 HEAP32[i2 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 3 | 0, i4, gb + 716761 | 0, 88) | 0;
 HEAP32[i2 + 4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 2 | 0, i4, gb + 716761 | 0, 89) | 0;
 HEAP32[i2 + 20 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 1 | 0, (i1 << 3) + 15 & -16, gb + 716761 | 0, 90) | 0;
 HEAP32[i2 + 24 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 + 15 & -16, gb + 716761 | 0, 91) | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 HEAP32[i2 + 16 >> 2] = i1;
 HEAP32[i2 + 32 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 904313 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 430974 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18ProceduralMaterial8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802207 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18PlatformEffector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1039541 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800967 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18BuoyancyEffector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 863942 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18AudioMixerSnapshot8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 855869 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN18AudioLowPassFilter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14UnityWebStream24UpdateAllUnityWebStreamsEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[gb + 1451260 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (i1 | 0)) return;
 do {
  i4 = i2;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  if (!(HEAP8[i4 + 20 >> 0] | 0)) if (HEAP32[i4 + 40 >> 2] | 0) if (HEAP8[i4 + 19 >> 0] | 0) {
   HEAP8[i4 + 16 >> 0] = 1;
   if (HEAP32[i4 >> 2] | 0) {
    i1 = HEAP32[i4 >> 2] | 0;
    if (i1 | 0) {
     i3 = i4 + 4 | 0;
     HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
     HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
     HEAP32[i4 >> 2] = 0;
     HEAP32[i3 >> 2] = 0;
    }
    __ZN14UnityWebStream7ReleaseEv(i4);
    i1 = HEAP32[gb + 1451260 >> 2] | 0;
   }
  }
  i3 = i2;
 } while ((i3 | 0) != (i1 | 0));
 return;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 945895 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13TextRendering4Font8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_110Connection13sendStreamEndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = i1 + 28 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, 15, 1, 0, 0) | 0;
 HEAP8[i3 >> 0] = 26;
 mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, 1) | 0;
 HEAP32[i3 >> 2] = 10;
 mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
 mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, gb + 776590 | 0, HEAP32[i3 >> 2] | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __Z30Animator_CUSTOM_SetFloatIDDampP12Il2CppObjectifff(i6, i7, f3, f4, f5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i1 = 0, i2 = 0;
 if (!i6) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) {
  i2 = i6;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN8Animator12SetFloatDampEifff(i1, i7, f3, f4, f5) | 0;
 if ((i2 | 0) == 1) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i6) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i1, i2, i7);
 return;
}

function _cff_property_get(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(_strcmp(i2, gb + 1008189 | 0) | 0)) {
  HEAP32[i3 >> 2] = HEAP32[i1 + 36 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 40 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 44 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 48 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 52 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 56 >> 2];
  HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 64 >> 2];
  i3 = 0;
  return i3 | 0;
 }
 if (!(_strcmp(i2, gb + 1008210 | 0) | 0)) {
  HEAP32[i3 >> 2] = HEAP32[i1 + 28 >> 2];
  i3 = 0;
  return i3 | 0;
 }
 if (_strcmp(i2, gb + 1008225 | 0) | 0) {
  i3 = 12;
  return i3 | 0;
 }
 HEAP8[i3 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
 i3 = 0;
 return i3 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdateProcessMouseInWindowstruct7ForwardEv() {
 var i1 = 0, f2 = f0, f3 = f0, i4 = 0;
 if (__Z11IsBatchmodev() | 0) return;
 i1 = __Z15GetInputManagerv() | 0;
 f2 = Math_fround(HEAPF32[i1 + 116 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 120 >> 2]);
 if (f2 < Math_fround(0.0)) i1 = 0; else {
  i1 = __Z16GetScreenManagerv() | 0;
  if (f3 < Math_fround(0.0) | f2 > Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0)) i1 = 0; else {
   i1 = __Z16GetScreenManagerv() | 0;
   if (f3 > Math_fround(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0)) i1 = 0; else i1 = 1;
  }
 }
 i4 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 76 >> 2] | 0, i4 | 0, i1 | 0);
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIttEEPtEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 4 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_(i6, i6 + 2 | 0, i5, i1) | 0;
 i4 = i6 + 6 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP16[i4 >> 1] | 0;
  i3 = HEAP16[i1 >> 1] | 0;
  if ((i5 & 65535) < (i3 & 65535)) {
   i2 = i4;
   while (1) {
    HEAP16[i2 >> 1] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -2 | 0;
    i3 = HEAP16[i2 >> 1] | 0;
    if ((i5 & 65535) >= (i3 & 65535)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP16[i1 >> 1] = i5;
  }
  i1 = i4;
  i4 = i4 + 2 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwjj(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 if (i2 >>> 0 > 1073741807) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 do if (i2 >>> 0 < 2) HEAP8[i1 + 8 + 3 >> 0] = i4; else {
  i2 = i2 + 4 & -4;
  if (i2 >>> 0 > 1073741823) {
   i4 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i4);
   ___cxa_throw(i4 | 0, gb + 13048 | 0, fb + 3215 | 0);
  } else {
   i5 = __Znwj(i2 << 2) | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i5;
   break;
  }
 } while (0);
 __ZNSt3__211char_traitsIwE4copyEPwPKwj(i1, i3, i4) | 0;
 HEAP32[i1 + (i4 << 2) >> 2] = 0;
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE(i7, i6) {
 i7 = i7 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i7 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i1) i1 = 0; else {
  i5 = i7 + 48 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = 0;
  while (1) {
   if ((HEAP32[i2 + (i3 << 2) >> 2] | 0) == (i6 | 0)) {
    i1 = i3;
    break;
   }
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i1 >>> 0) break L1;
  }
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0);
  i6 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
  HEAP32[i4 >> 2] = i6;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i6 << 2) >> 2];
  i1 = i6;
 } while (0);
 HEAP8[i7 + 92 >> 0] = (i1 | 0) != 0 & 1;
 return;
}

function __ZN5physx7NpCloth18addCollisionConvexEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore18addCollisionConvexEj(i2 + 32 | 0, i1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 476, gb + 694531 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpCloth13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx2Sc9ClothCore13setRestOffsetEf(i2 + 32 | 0, f1);
  STACKTOP = i5;
  return;
 } else if ((i4 | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 691475 | 0, 1094, gb + 692152 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_10ClothShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i4 = i3;
 i5 = i1 + 20 | 0;
 __ZNK5physx2Sc9ClothCore14getWorldBoundsEv(i6, HEAP32[i5 >> 2] | 0);
 i5 = HEAP32[HEAP32[(__ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[i5 >> 2] | 0) | 0) + 52 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = 1073741823;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 __ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE(i1, 1, i6, i5, i4) | 0;
 i2 = (HEAP32[(HEAP32[HEAP32[i2 + 1104 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 32 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN4FMOD6System19setGeometrySettingsEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i5 = i7 + 8 | 0;
 i4 = i7;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869836;
  _printf(gb + 857490 | 0, i5) | 0;
  HEAP32[i6 >> 2] = 78;
  HEAP32[i6 + 4 >> 2] = gb + 869836;
  _printf(gb + 853343 | 0, i6) | 0;
  i6 = 78;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 869836;
 _printf(gb + 853184 | 0, i4) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN4FMOD6System19getMasterSoundGroupEPPNS_10SoundGroupE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869420;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869420;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869420;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14VelocityModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP8[i1 + 800 >> 0] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, Math_fround(0.0), HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, Math_fround(0.0), HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 616 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, Math_fround(0.0), HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN12FixedJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i5 = 0, i6 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1);
 if (!(i1 & 16)) return;
 i4 = i3 + 96 | 0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0);
 f2 = i5 ? Math_fround(1.0) : f2;
 f2 = i1 ? Math_fround(0.0) : f2;
 HEAPF32[i4 >> 2] = f2;
 i4 = HEAP32[i3 + 60 >> 2] | 0;
 i1 = (i4 | 0) == 0;
 if (!i1) HEAPF32[i4 + 72 >> 2] = f2;
 i5 = i3 + 100 | 0;
 f2 = Math_fround(HEAPF32[i5 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i6 = f2 > Math_fround(1.0e6);
 f2 = i6 ? Math_fround(1.0e6) : f2;
 f2 = i3 ? Math_fround(0.0) : f2;
 HEAPF32[i5 >> 2] = f2;
 if (i1) return;
 HEAPF32[i4 + 68 >> 2] = f2;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager29SessionContainerDoneArchiveItERNS0_16SessionContainerE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 HEAP32[i2 + 560 >> 2] = 0;
 i1 = i2 + 552 | 0;
 if ((HEAPU16[i3 + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i3 + 92 >> 0] = 0;
 HEAP8[i3 + 91 >> 0] = 0;
 if (HEAP8[i3 + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i3) | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i2 >> 2] | 0) != 1) if ((HEAP32[i2 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i3 | 0);
 } while (0);
 if (HEAP8[i3 + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i3);
 return;
}

function __ZN10MeshFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(36, i1, 16, gb + 1048932 | 0, 0, gb + 428715 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 58216 + 8;
 HEAP32[i4 + 32 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 884 >> 2] | 0) + 800 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z56Transform_CUSTOM_INTERNAL_CALL_InverseTransformDirectionP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK9Transform25InverseTransformDirectionERK8Vector3f(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z54ParticleSystem_TrailModule_CUSTOM_GetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, (HEAP32[i1 + 908 >> 2] | 0) + 292 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z14GetTemporaryRTbbibb(i4, i1, i5, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i8 = __Z22GetRenderBufferManagerv() | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i1) i1 = mftCall_ii(HEAP32[i2 + 708 >> 2] | 0, i3 | 0) | 0; else i1 = mftCall_ii(HEAP32[i2 + 704 >> 2] | 0, i3 | 0) | 0;
 i1 = __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i8, i6 ? -2 : -1, i7 ? -2 : -1, i4 ? 2 : 0, i1, 0, 0, HEAP32[i8 + 24 >> 2] | 0, i5) | 0;
 if (!i1) return i1 | 0;
 __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, 1);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, gb + 375803 | 0);
 return i1 | 0;
}

function _UNITY_FT_Create_Class_sfnt_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 40, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = gb + 1008151;
 i4 = HEAP32[i1 + 212 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i4 + 24;
 HEAP32[i3 + 8 >> 2] = gb + 1008130;
 HEAP32[i3 + 12 >> 2] = i4 + 12;
 HEAP32[i3 + 16 >> 2] = gb + 1007761;
 HEAP32[i3 + 20 >> 2] = i4 + 4;
 HEAP32[i3 + 24 >> 2] = gb + 1008121;
 HEAP32[i3 + 28 >> 2] = i4 + 16;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _cf2_builder_cubeTo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 if (!(HEAP8[i4 + 64 >> 0] | 0)) {
  i3 = _cff_builder_start_point(i4, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  if (i3 | 0) {
   i1 = HEAP32[i1 + 24 >> 2] | 0;
   if (HEAP32[i1 >> 2] | 0) return;
   HEAP32[i1 >> 2] = i3;
   return;
  }
 }
 i3 = _cff_check_points(i4, 3) | 0;
 if (!i3) {
  _cff_builder_add_point(i4, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, 0);
  _cff_builder_add_point(i4, HEAP32[i2 + 16 >> 2] | 0, HEAP32[i2 + 20 >> 2] | 0, 0);
  _cff_builder_add_point(i4, HEAP32[i2 + 24 >> 2] | 0, HEAP32[i2 + 28 >> 2] | 0, 1);
  return;
 }
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i1 >> 2] = i3;
 return;
}

function __ZNSt3__28__c_node8__removeEPNS_8__i_nodeE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i7 = i1 + 16 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == (i4 | 0)) break;
  if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
   i6 = 5;
   break;
  }
  i2 = i2 + 4 | 0;
 }
 if ((i6 | 0) == 5) if ((i2 | 0) != (i4 | 0)) {
  i1 = i4 + -4 | 0;
  HEAP32[i7 >> 2] = i1;
  if ((i1 | 0) != (i2 | 0)) _memmove(i2 | 0, i2 + 4 | 0, i1 - i2 | 0) | 0;
  STACKTOP = i8;
  return;
 }
 i8 = HEAP32[gb + 191628 >> 2] | 0;
 HEAP32[i5 >> 2] = gb + 1076473;
 _fprintf(i8, gb + 1076431 | 0, i5) | 0;
 _abort();
}

function __ZNK29BillboardTreeInstanceRenderer14RenderInstanceERK14ChannelAssigns(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i8 = HEAP32[i1 + 284 >> 2] | 0;
 i7 = HEAP32[i1 + 288 >> 2] | 0;
 i6 = HEAP32[i1 + 292 >> 2] | 0;
 i5 = HEAP32[i1 + 296 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[(HEAP32[i1 + 276 >> 2] | 0) + 32 >> 2];
 HEAP32[i4 + 4 >> 2] = i8;
 HEAP32[i4 + 8 >> 2] = i7;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i4 + 16 >> 2] = i5;
 HEAP32[i4 + 20 >> 2] = 0;
 __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns(__ZN21BillboardBatchManager3GetEv() | 0, i4, i2);
 STACKTOP = i3;
 return;
}

function __ZN9b2Fixture8RefilterEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i3) return;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 if (i1 | 0) do {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if ((HEAP32[i2 + 48 >> 2] | 0) == (i5 | 0) ? 1 : (HEAP32[i2 + 52 >> 2] | 0) == (i5 | 0)) {
   i4 = i2 + 4 | 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 8;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i1 = HEAP32[i3 + 88 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 102872 | 0;
 i4 = i5 + 48 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i2 = i5 + 44 | 0;
 i1 = 0;
 do {
  __ZN12b2BroadPhase10TouchProxyEi(i3, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 28 | 0) + 24 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i2, i7, i6, i3, i4, i5) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i4 | 0) | 0;
 if (i1 | 0) if (mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i1 | 0, i6 | 0, i3 | 0, i4 | 0, i5 | 0) | 0) {
  HEAP32[i2 >> 2] = gb + 832257;
  HEAP32[i2 + 4 >> 2] = i1;
  i7 = i2 + 8 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
 HEAP32[i2 >> 2] = gb + 1576256;
 HEAP32[i2 + 4 >> 2] = 0;
 i7 = i2 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i2, i7, i6, i3, i4, i5) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i4 | 0) | 0;
 if (i1 | 0) if (mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i1 | 0, i6 | 0, i3 | 0, i4 | 0, i5 | 0) | 0) {
  HEAP32[i2 >> 2] = gb + 765118;
  HEAP32[i2 + 4 >> 2] = i1;
  i7 = i2 + 8 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
 HEAP32[i2 >> 2] = gb + 1576256;
 HEAP32[i2 + 4 >> 2] = 0;
 i7 = i2 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 return;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 738002 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity11SpringJoint8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN4crnd15crnd_unpack_endEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 16 | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != 519686845) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZN4crnd12crn_unpackerD2Ev(i1);
 if (!(i1 & 7)) {
  mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i3 >> 2] = gb + 401209;
  HEAP32[i3 + 4 >> 2] = 2513;
  HEAP32[i3 + 8 >> 2] = gb + 401349;
  _sprintf(i2, gb + 401176 | 0, i3) | 0;
  _puts(i2) | 0;
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN4FMOD12ChannelGroup19getAudibilityFactorEPf(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 40 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870073;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN3MBPC2EPN5physx14PxsAABBManagerE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i6 >> 2] = gb + 104132 + 8;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = -1;
 HEAP32[i6 + 16 >> 2] = -1;
 __ZN5physx2Gu9ContainerC2Ev(i6 + 20 | 0);
 __ZN5physx2Gu9ContainerC2Ev(i6 + 36 | 0);
 i1 = i6 + 96 | 0;
 i4 = i6 + 4208 | 0;
 i2 = i6 + 52 | 0;
 i3 = i2 + 44 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 do {
  __ZN5physx2Gu9ContainerC2Ev(i1);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i4 | 0));
 __ZN5physx2Gu9ContainerC2Ev(i6 + 5236 | 0);
 HEAP32[i6 + 5252 >> 2] = 0;
 HEAP32[i6 + 5256 >> 2] = 0;
 HEAP32[i6 + 5260 >> 2] = i5;
 _memset(i6 + 4208 | 0, -1, 1028) | 0;
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 803070 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17SurfaceEffector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17RenderLoopContextD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 36864 + 8;
 i1 = i3 + 1828 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1860 | 0;
 if ((HEAP32[i3 + 1876 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1864 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1840 | 0;
 if ((HEAP32[i3 + 1856 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1844 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN17RenderLoopContextD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 36864 + 8;
 i1 = i3 + 1828 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 1860 | 0;
 if ((HEAP32[i3 + 1876 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 1864 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i3 + 1856 >> 2] | 0) <= -1) {
  __ZdlPv(i3);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 + 1840 >> 2] | 0, i3 + 1844 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 431704 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17ProceduralTexture8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802541 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17PolygonCollider2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801702 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17PhysicsMaterial2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801731 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17Physics2DSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 863974 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17AudioReverbFilter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 853401 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17AudioChorusFilter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13TranslateGLES17InitTextureTargetERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 3553;
 HEAP32[i4 + 4 >> 2] = HEAP8[i2 + 481 >> 0] | 0 ? 32879 : -1091584273;
 HEAP32[i4 + 8 >> 2] = 34067;
 i2 = HEAP16[i2 + 482 >> 1] | 0;
 HEAP32[i4 + 12 >> 2] = (i2 & 255) << 24 >> 24 ? 35866 : -1091584273;
 HEAP32[i4 + 16 >> 2] = (i2 & 65535) > 255 ? 36873 : -1091584273;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = -2147483648;
 i8 = i7 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = i3;
 HEAP32[i7 + 44 >> 2] = 0;
 HEAP32[i7 + 48 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i7 + 12 >> 2] = i5;
 HEAP8[i7 + 36 >> 0] = 1;
 HEAP32[i7 + 20 >> 2] = -1;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(i1, i7);
 STACKTOP = i6;
 return;
}

function __ZN11ForceModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 800 >> 0] = 0;
 HEAP8[i1 + 801 >> 0] = 0;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, Math_fround(0.0), HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 352 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, Math_fround(0.0), HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 HEAPF32[i1 + 616 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 622 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 536 | 0, i1 + 624 | 0, Math_fround(0.0), HEAP16[i1 + 620 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN10Matrix4x4f8SetScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyRotationInternalP12Il2CppObjectR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator15GetBodyRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z26Material_CUSTOM_SetTextureP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 4 | 0;
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 HEAP32[i5 >> 2] = i2;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture(i6, i4, i1);
 STACKTOP = i7;
 return;
}

function _UNITY_png_set_longjmp_fn(i6, i7, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i6) {
  i7 = 0;
  return i7 | 0;
 }
 i2 = i6 + 160 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i6 + 164 | 0;
 do if (!i1) {
  HEAP32[i4 >> 2] = 0;
  if (i5 >>> 0 < 157) {
   HEAP32[i2 >> 2] = i6;
   i1 = i6;
   break;
  }
  i1 = _UNITY_png_malloc_warn(i6, i5) | 0;
  HEAP32[i2 >> 2] = i1;
  if (!i1) {
   i7 = 0;
   return i7 | 0;
  } else {
   HEAP32[i4 >> 2] = i5;
   break;
  }
 } else {
  i2 = HEAP32[i4 >> 2] | 0;
  if (!i2) if ((i1 | 0) == (i6 | 0)) i3 = 156; else _UNITY_png_error(i6, gb + 351984 | 0); else i3 = i2;
  if ((i3 | 0) != (i5 | 0)) {
   i7 = 0;
   return i7 | 0;
  }
 } while (0);
 HEAP32[i6 + 156 >> 2] = i7;
 i7 = i1;
 return i7 | 0;
}

function __ZNK5physx7NpScene21getDominanceGroupPairEhh(i4, i8, i5, i6) {
 i4 = i4 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 if (HEAP32[i8 + 3388 >> 2] & 8 | 0) {
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = i4 + 4 | 0;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  i2 = i5 & 255;
  i3 = i6 & 255;
  if ((i5 & 255) < (i6 & 255)) i7 = HEAP32[i8 + 3096 + (i2 << 2) >> 2] & 1 << i3; else i7 = HEAP32[i8 + 3096 + (i3 << 2) >> 2] & 1 << i2;
  if (i7 | 0) {
   HEAPF32[i4 >> 2] = Math_fround((HEAP32[i8 + 3220 + (i2 << 2) >> 2] & 1 << i3) >>> i3 >>> 0);
   HEAPF32[i1 >> 2] = Math_fround((HEAP32[i8 + 3220 + (i3 << 2) >> 2] & 1 << i2) >>> i2 >>> 0);
   return;
  }
 }
 __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh(i4, i8 + 32 | 0, i5, i6);
 return;
}

function __ZN9Transform8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 40 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 896797 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 68 | 0, gb + 896813 | 0, 0);
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 80 | 0, 0);
 __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 100 | 0, i2);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i6, i5 << 2, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx2Sc8ClothSimD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 91096 + 8;
 HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + 4 >> 2] = 0;
 i1 = HEAP32[i2 + 136 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 128 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 124 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 116 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 __ZN5physx2Sc10ClothShapeD2Ev(i2 + 56 | 0);
 __ZN5physx2Sc8ActorSimD2Ev(i2);
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i2, i7, i6, i3, i4, i5) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i4 | 0) | 0;
 if (i1 | 0) if (mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i1 | 0, i6 | 0, i3 | 0, i4 | 0, i5 | 0) | 0) {
  HEAP32[i2 >> 2] = gb + 701374;
  HEAP32[i2 + 4 >> 2] = i1;
  i7 = i2 + 8 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
 HEAP32[i2 >> 2] = gb + 1576256;
 HEAP32[i2 + 4 >> 2] = 0;
 i7 = i2 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1048432 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN16ParticleRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1048111 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN16ParticleAnimator8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1037316 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15RenderNodeQueueC2ERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 8 | 0;
 i5 = i3;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId(i1 + 20 | 0, gb + 383829 | 0, i2);
 HEAP32[i1 + 32804 >> 2] = 0;
 HEAP32[i1 + 32808 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine9Analytics9PerfEventD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 188436 + 8;
 i1 = i2 + 32 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 44 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 HEAP32[i2 >> 2] = gb + 190148 + 8;
 i1 = i2 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN10GameObject21MarkActiveRecursivelyEb(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 28940 + 24 >> 2] | 0;
 i3 = HEAP32[gb + 28940 + 28 >> 2] | 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 while (1) if (((HEAP32[i1 >> 2] | 0) - i2 | 0) >>> 0 < i3 >>> 0) break; else i1 = i1 + 8 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i3 + 80 | 0;
 i3 = i3 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = i4 + 54 | 0;
  i5 = i5 & 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 do {
  __ZN10GameObject21MarkActiveRecursivelyEb(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i5);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 i4 = i4 + 54 | 0;
 i5 = i5 & 1;
 HEAP8[i4 >> 0] = i5;
 return;
}

function __ZN10GUITexture10SetTextureEP7Texture(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 52 | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 + 100 >> 2] = __ZN7Texture21GetMasterTextureLimitEv() | 0;
  __ZN10GUITexture10BuildSheetEv(i2);
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 92 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i2 + 96 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0;
 i1 = i2 + 100 | 0;
 HEAP32[i1 >> 2] = __ZN7Texture21GetMasterTextureLimitEv() | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) {
  __ZN10GUITexture10BuildSheetEv(i2);
  return;
 }
 HEAP32[i1 >> 2] = 0;
 __ZN10GUITexture10BuildSheetEv(i2);
 return;
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 864 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z56RaycastHit_CUSTOM_INTERNAL_CALL_CalculateRaycastTexCoordP13Vector2fIcallP12Il2CppObjectRKS_RK8Vector3fii(i2, i1, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9 + 8 | 0;
 i8 = i9;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __Z24CalculateRaycastTexcoordP8ColliderRK8Vector2fRK8Vector3fji(i8, i1, i7, i4, i5, i6);
 i6 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i2;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 STACKTOP = i9;
 return;
}

function __Z55Rigidbody_CUSTOM_INTERNAL_CALL_GetRelativePointVelocityP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK9Rigidbody24GetRelativePointVelocityERK8Vector3f(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, (HEAP32[i1 + 860 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function _wms_seek(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8;
 i4 = HEAP32[i1 + 84 >> 2] | 0;
 if (i2 >>> 0 > 2) i7 = 2; else {
  HEAP32[i3 >> 2] = 0;
  i5 = i4 + 8 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 16 >> 2];
  i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  if ((i6 | 0) < (0 - i1 | 0) | (536870911 - i1 | 0) < (i6 | 0)) i7 = 2; else {
   i4 = i4 + 24 | 0;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   i1 = i1 + i6 | 0;
   HEAP32[i5 >> 2] = i1;
  }
 }
 if ((i7 | 0) == 2) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function __ZNK7b2Mat337Solve22ERK6b2Vec2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f10 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f8 = Math_fround(Math_fround(f7 * f10) - Math_fround(f9 * f5));
 i2 = f8 != Math_fround(0.0);
 f4 = Math_fround(Math_fround(1.0) / f8);
 f8 = i2 ? f4 : f8;
 f4 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(f10 * f4);
 f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f8 * Math_fround(f10 - Math_fround(f9 * f6)));
 HEAPF32[i1 + 4 >> 2] = Math_fround(f8 * Math_fround(Math_fround(f7 * f6) - Math_fround(f5 * f4)));
 return;
}

function __ZN9GfxDevice19SetProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 1764 | 0;
 i4 = i3;
 i5 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i4 = i1 + 3484 | 0;
 i5 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 i5 = HEAP32[gb + 1157628 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0;
 i6 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) != 0;
 mftCall_viiii(i4 | 0, i5 | 0, i3 | 0, i6 | 0, (HEAP8[i1 + 4380 >> 0] | 0) != 0 | 0);
 i6 = i1 + 3612 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4;
 return;
}

function __ZN8VRDevice7PreCullEP6Camerab(i3, i1, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 6, i5 & 1 | 0);
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (__ZNK11ICallString6IsNullEv(i1) | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i4, i1);
 i1 = (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i4 = i1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx13GuMeshFactory21removeFactoryListenerERNS_21GuMeshFactoryListenerE(i1, i8) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i6 >> 2] | 0);
 i7 = i1 + 132 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) {
  i8 = HEAP32[i6 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
  return;
 }
 i5 = i1 + 128 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3 + (i1 << 2) | 0;
  if ((HEAP32[i4 >> 2] | 0) == (i8 | 0)) {
   i2 = i2 + -1 | 0;
   HEAP32[i7 >> 2] = i2;
   HEAP32[i4 >> 2] = HEAP32[i3 + (i2 << 2) >> 2];
   i1 = i1 + -1 | 0;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 i8 = HEAP32[i6 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i8);
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 736306 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity10HingeJoint8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN4Halo23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i6, i1);
 i2 = i6 + 36 | 0;
 i7 = i1 + 16 | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 i4 = i5 + 4 | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i4 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i7 >> 2] = i4;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i2, 4);
  i4 = HEAP32[i7 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
 }
 i1 = i6 + 40 | 0;
 i2 = i4 + 4 | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i7 >> 2] = i2;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i7, i1, 4);
  return;
 }
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1011618 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 590196 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN2UI13RectTransform8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN16ParticleRenderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN8Renderer16CheckConsistencyEv(i1);
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i4 = i1 + 352 | 0;
 i5 = Math_fround(HEAPF32[i4 >> 2]) > Math_fround(0.0);
 HEAP32[i4 >> 2] = HEAP32[(i5 ? i4 : i3) >> 2];
 i4 = i1 + 356 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = (i5 | 0) > 1 ? i5 : 1;
 i4 = i1 + 360 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = (i5 | 0) > 1 ? i5 : 1;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i1 = i1 + 364 | 0;
 i4 = Math_fround(HEAPF32[i1 >> 2]) > Math_fround(0.0);
 HEAP32[i1 >> 2] = HEAP32[(i4 ? i1 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 402133 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN16LightmapSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 373756 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN16GraphicsSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801075 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN16CircleCollider2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13MonoBehaviour14GetOrCreateDSPEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = __Z9GetIAudiov() | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = i2 + 144 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[i2 + 60 >> 2] | 0;
  if (!i1) {
   i4 = 0;
   return i4 | 0;
  }
  if (!(HEAP32[i1 + 144 >> 2] | 0)) {
   i4 = 0;
   return i4 | 0;
  }
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i1) {
   i4 = 0;
   return i4 | 0;
  }
  if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
   i1 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, i2 | 0) | 0;
   HEAP32[i3 >> 2] = i1;
   break;
  } else {
   i4 = 0;
   return i4 | 0;
  }
 } while (0);
 i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_110DataStream15flushPvdCommandEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i6 + 428 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  i5 = i6 + 464 | 0;
  HEAP32[i5 >> 2] = 0;
  i6 = i6 + 468 | 0;
  HEAP32[i6 >> 2] = 0;
  return;
 }
 i3 = i6 + 424 | 0;
 i5 = 0;
 do {
  i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  if (i4 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i6 | 0);
   i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i5 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != (i2 | 0));
 HEAP32[i1 >> 2] = 0;
 i5 = i6 + 464 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = i6 + 468 | 0;
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN12MeshRenderer15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30912 | 0, gb + 1105176 | 0, fb + 524 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30912 | 0, gb + 1105156 | 0, fb + 525 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30912 | 0, gb + 1105196 | 0, fb + 526 | 0, 0);
 __Z34RegisterPrepareRenderNodesCallbackiPFvR35RenderNodeQueuePrepareThreadContextES2_PFPvvEPFvS3_E(1, fb + 3389 | 0, fb + 3390 | 0, 0, 0);
 return;
}

function __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 864 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_TrailModule_CUSTOM_GetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, (HEAP32[i1 + 908 >> 2] | 0) + 712 | 0);
  STACKTOP = i4;
  return;
 }
}

function _iswctype(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do switch (i2 | 0) {
 case 1:
  {
   i1 = _iswalnum(i1) | 0;
   break;
  }
 case 2:
  {
   i1 = _iswalpha(i1) | 0;
   break;
  }
 case 3:
  {
   i1 = _iswblank(i1) | 0;
   break;
  }
 case 4:
  {
   i1 = _iswcntrl(i1) | 0;
   break;
  }
 case 5:
  {
   i1 = _iswdigit(i1) | 0;
   break;
  }
 case 6:
  {
   i1 = _iswgraph(i1) | 0;
   break;
  }
 case 7:
  {
   i1 = _iswlower(i1) | 0;
   break;
  }
 case 8:
  {
   i1 = _iswprint(i1) | 0;
   break;
  }
 case 9:
  {
   i1 = _iswpunct(i1) | 0;
   break;
  }
 case 10:
  {
   i1 = _iswspace(i1) | 0;
   break;
  }
 case 11:
  {
   i1 = _iswupper(i1) | 0;
   break;
  }
 case 12:
  {
   i1 = _iswxdigit(i1) | 0;
   break;
  }
 default:
  i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474588 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (!(i5 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   __ZNSt3__26localeD2Ev(i3);
   STACKTOP = i4;
   return i1 | 0;
  }
 }
 i5 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i3);
 ___resumeException(i5 | 0);
 return 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = __ZNKSt3__28ios_base6getlocEv(i1) | 0;
 __THREW__ = 0;
 i1 = invoke_iii(fb + 1145 | 0, i3 | 0, gb + 1474556 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 if (!(i5 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  i5 = __THREW__;
  __THREW__ = 0;
  if (!(i5 & 1)) {
   __ZNSt3__26localeD2Ev(i3);
   STACKTOP = i4;
   return i1 | 0;
  }
 }
 i5 = ___cxa_find_matching_catch_2() | 0;
 getTempRet0() | 0;
 __ZNSt3__26localeD2Ev(i3);
 ___resumeException(i5 | 0);
 return 0;
}

function __ZN9GfxDevice24CreateRenderDepthSurfaceE9TextureIDiii16TextureDimension17DepthBufferFormatj(i5, i1, i3, i4, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 384 >> 2] | 0, i5 | 0, 0) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = (i7 | 0) == 5 ? 2 : 1;
 i1 = i2 + 20 | 0;
 HEAP32[i1 >> 2] = i9;
 HEAP32[i2 + 24 >> 2] = i7;
 HEAP32[i2 + 16 >> 2] = i6;
 HEAP8[i2 + 31 >> 0] = 0;
 if (mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 396 >> 2] | 0, i5 | 0, i2 | 0, i8 | 0) | 0) return i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 64;
 return i2 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i8);
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + (i8 * 12 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i1 = i4 + (i1 * 12 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 12 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN4FMOD6System14getSpeakerModeEP16FMOD_SPEAKERMODE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869657;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869657;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869657;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1016757 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15TerrainCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1047963 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13SplatDatabase14CheckAlphamapsEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i2 + 12 | 0;
 i3 = i2 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) {
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i2 = 0;
 while (1) {
  HEAP32[i4 >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
  if (!(__Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E(i4) | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i1 = HEAP32[i5 >> 2] | 0;
  if (i2 >>> 0 >= (HEAP32[i3 >> 2] | 0) - i1 >> 2 >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) {
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function __ZN12b2BroadPhase13QueryCallbackEi(i3, i6) {
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = i3 + 56 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (i6 | 0)) return 1;
 i7 = i3 + 52 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i5 = i3 + 48 | 0;
 i3 = i3 + 44 | 0;
 if ((i1 | 0) == (HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i5 >> 2] = i1 << 1;
  i1 = __Z7b2Alloci(i1 << 4) | 0;
  HEAP32[i3 >> 2] = i1;
  _memcpy(i1 | 0, i2 | 0, HEAP32[i7 >> 2] << 3 | 0) | 0;
  __Z6b2FreePv(i2);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + (i1 << 3) >> 2] = (i2 | 0) > (i6 | 0) ? i6 : i2;
 HEAP32[i5 + (i1 << 3) + 4 >> 2] = (i2 | 0) < (i6 | 0) ? i6 : i2;
 HEAP32[i7 >> 2] = i1 + 1;
 return 1;
}

function _fchown(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 48 | 0;
 i5 = i8 + 16 | 0;
 i4 = i8;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 i4 = ___syscall207(207, i4 | 0) | 0;
 if ((i4 | 0) == -9) {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i5 + 4 >> 2] = 1;
  if ((___syscall221(221, i5 | 0) | 0) < 0) i7 = 3; else {
   ___procfdname(i5, i1);
   HEAP32[i6 >> 2] = i5;
   HEAP32[i6 + 4 >> 2] = i2;
   HEAP32[i6 + 8 >> 2] = i3;
   i1 = ___syscall_ret(___syscall212(212, i6 | 0) | 0) | 0;
  }
 } else i7 = 3;
 if ((i7 | 0) == 3) i1 = ___syscall_ret(i4) | 0;
 STACKTOP = i8;
 return i1 | 0;
}

function __ZZN4UNET16ScriptingUpdater4InitEvEN29PreLateUpdateUNetUpdatestruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 248 | 0;
 i1 = i5 + 8 | 0;
 i2 = i5;
 i3 = __ZN4UNET16ScriptingUpdater3GetEv() | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i7 = i3;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i1, i4);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i4, 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4initEPv(i4, i3);
 HEAP32[i4 + 72 >> 2] = 0;
 HEAP32[i4 + 76 >> 2] = -1;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 16 >> 2];
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK8VRDevice16GetLocalRotationERK8UnityStr(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 i6 = i3 + 280 | 0;
 if (HEAP32[i6 >> 2] | 0) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZNK7VRInput16GetLocalRotationERK8UnityStr4PPtrI9TransformE(i2, i6, i4, i1);
  STACKTOP = i7;
  return;
 }
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 STACKTOP = i7;
 return;
}

function __ZNK21EnlightenSceneMapping22GetRendererInformationEi(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i2 = HEAP32[i6 + 124 >> 2] | 0;
 i8 = HEAP32[i6 + 128 >> 2] | 0;
 i1 = i8 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i9 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i9 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i9 | 0 : i9;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i8 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if ((i1 | 0) == (i8 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i9 = (HEAP32[i6 >> 2] | 0) + ((HEAP32[i1 + 4 >> 2] | 0) * 40 | 0) | 0;
 return i9 | 0;
}

function __ZN5physx27PxConstraintGeneratedValuesC2EPKNS_12PxConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 HEAP16[i2 + 12 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 14 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAPF32[i2 + 24 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 28 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 4 | 0, i2 + 8 | 0);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 + 16 | 0, i2 + 20 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i2, i7, i6, i3, i4, i5) {
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i7 >> 2] | 0) + 28 >> 2] | 0, i7 | 0, i4 | 0) | 0;
 if (i1 | 0) if (mftCall_iiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 24 >> 2] | 0, i7 | 0, i1 | 0, i6 | 0, i3 | 0, i4 | 0, i5 | 0) | 0) {
  HEAP32[i2 >> 2] = gb + 763461;
  HEAP32[i2 + 4 >> 2] = i1;
  i7 = i2 + 8 | 0;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = 0;
  return;
 }
 HEAP32[i2 >> 2] = gb + 1576256;
 HEAP32[i2 + 4 >> 2] = 0;
 i7 = i2 + 8 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 return;
}

function __ZN17PolygonCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(172, i1, 16, gb + 1048932 | 0, 0, gb + 807491 | 0, 16) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Collider2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 156928 + 8;
 __ZN9Polygon2DC2Ev(i4 + 160 | 0);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15SkyboxGenerator18GetSixFaceSkyboxVBEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1114336 >> 2] | 0;
 do if (i1 | 0) {
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) {
   i1 = __Z12GetGfxDevicev() | 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, HEAP32[gb + 1114336 >> 2] | 0);
   HEAP32[gb + 1114336 >> 2] = 0;
   break;
  }
  i1 = HEAP32[gb + 1114336 >> 2] | 0;
  if (i1 | 0) return i1 | 0;
 } while (0);
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 220 >> 2] | 0, i2 | 0) | 0;
 HEAP32[gb + 1114336 >> 2] = i1;
 mftCall_viiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0, i1 | 0, 0, 0, 864, gb + 1113472 | 0, 0);
 i1 = HEAP32[gb + 1114336 >> 2] | 0;
 return i1 | 0;
}

function __ZN15ResourceManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 450701 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15ResourceManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802586 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15RelativeJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 380928 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15ReflectionProbe8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 405349 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15QualitySettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802334 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15PointEffector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 379423 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15OcclusionPortal8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 842436 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15NavMeshObstacle8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801408 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15FrictionJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801269 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15DistanceJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801092 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15ConstantForce2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 733808 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15CapsuleCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 864200 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15AudioReverbZone8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 863848 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15AudioMixerGroup8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800658 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14SpriteRenderer19UpdateTransformInfoEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = __ZN8Renderer12GetTransformEv(i3) | 0;
 i4 = i3 + 36 | 0;
 i2 = HEAP16[i3 + 272 >> 1] | 0;
 if (!((i2 & 255) << 24 >> 24)) i1 = (i2 & 65535) >>> 8 & 255; else {
  i2 = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i4);
  HEAP32[i3 + 212 >> 2] = i2 & -8 | 2;
  i1 = HEAP8[i3 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  i2 = i3 + 188 | 0;
  i3 = i3 + 164 | 0;
  __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i2, i4, i3);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0);
 i2 = i3 + 188 | 0;
 i3 = i3 + 164 | 0;
 __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i2, i4, i3);
 return;
}

function __ZN13SpringJoint2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN15AnchoredJoint2D16CheckConsistencyEv(i1);
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(.00499999989);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(.00499999989) : f2;
 i3 = i1 + 104 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN11UnityEngine7Connect14AppUpdateEventC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1040502 | 0, 1);
 HEAP32[i1 >> 2] = gb + 188916 + 8;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 188956 + 8;
 return;
}

function __Z22CullDirectionalShadowsR9IndexListPK9SceneNodePK4AABBR22DirectionalCullContext(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i7 = i3 + 4 | 0;
 if ((HEAP32[i7 >> 2] | 0) <= 0) {
  i6 = 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i2 = 0;
 i1 = 0;
 do {
  i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (__ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB(i6, HEAP32[i4 + (i8 * 24 | 0) >> 2] | 0, HEAP32[i4 + (i8 * 24 | 0) + 4 >> 2] | 0, i5 + (i8 * 24 | 0) | 0) | 0) {
   i8 = HEAP32[i3 >> 2] | 0;
   HEAP32[i8 + (i1 << 2) >> 2] = HEAP32[i8 + (i2 << 2) >> 2];
   i1 = i1 + 1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i7 >> 2] | 0));
 HEAP32[i7 >> 2] = i1;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofERKS5_j(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i7 = HEAP8[i3 + 11 >> 0] | 0;
 i8 = i7 << 24 >> 24 < 0;
 i4 = i8 ? HEAP32[i3 >> 2] | 0 : i3;
 i3 = i8 ? HEAP32[i3 + 4 >> 2] | 0 : i7 & 255;
 i1 = i2 + (i1 >>> 0 > i5 >>> 0 ? i5 + 1 | 0 : i1) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   break;
  }
  i1 = i1 + -1 | 0;
  if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i4, i3, i1) | 0)) {
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) i1 = i1 - i2 | 0;
 return i1 | 0;
}

function __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2;
 i4 = i1 + 36 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 64 | 0;
 i4 = i1 + 100 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i3 = i2 + 128 | 0;
 i4 = i1 + 228 | 0;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 i5 = HEAP32[i1 + 1080 >> 2] | 0;
 HEAP8[i2 + 192 >> 0] = i5;
 HEAP8[i2 + 193 >> 0] = (i5 & 65535) >>> 8;
 HEAP8[i2 + 194 >> 0] = i5 >>> 16;
 return;
}

function __ZN5physx12NpWriteCheckD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if ((HEAP32[i1 + 3872 >> 2] | 0) != (HEAP32[i2 + 12 >> 2] | 0)) if (!(HEAP16[((HEAP32[i1 + 3388 >> 2] & 4 | 0) == 0 ? i1 + 1224 | 0 : i1 + 3364 | 0) >> 1] & 4096)) {
  i1 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i3 + 4 >> 2] = i2;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 8, gb + 770829 | 0, 62, gb + 771441 | 0, i3);
 }
 STACKTOP = i4;
 return;
}

function __ZN4FMOD6System13get3DSettingsEPfS1_S1_(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i2 + 52 >> 2];
  if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i2 + 56 >> 2];
  if (!i5) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
  HEAP32[i5 >> 2] = HEAP32[i2 + 60 >> 2];
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 870159;
 _printf(gb + 853184 | 0, i6) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN14CachingManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i5 = i1 + 8 | 0;
 HEAP8[i5 >> 0] = 0;
 i4 = i1 + 9 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZN14CachingManager7DisposeEv(i1);
 HEAP32[i1 >> 2] = 0;
 __Z39GetDefaultApplicationIdentifierForCachev(i3);
 HEAP32[i1 >> 2] = 1;
 __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb(i1, i3, -1, 2147483647, 0);
 __ZN14CachingManager15ClearTempFolderEv(0);
 HEAP8[i5 >> 0] = 1;
 HEAP8[i4 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN12b2MouseJoint9SetTargetERK6b2Vec2(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP16[i5 >> 1] | 0;
 do if (!(i1 & 2)) {
  i1 = i1 & 65535;
  if (!(HEAP32[i4 >> 2] | 0)) {
   HEAP16[i5 >> 1] = i1 & 65533;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
   i5 = i4 + 64 | 0;
   HEAP32[i5 >> 2] = 0;
   HEAP32[i5 + 4 >> 2] = 0;
   HEAP32[i5 + 8 >> 2] = 0;
   HEAP32[i5 + 12 >> 2] = 0;
   HEAP32[i5 + 16 >> 2] = 0;
   HEAP32[i5 + 20 >> 2] = 0;
   break;
  }
  if (!(i1 & 2)) {
   HEAP16[i5 >> 1] = i1 | 2;
   HEAPF32[i4 + 144 >> 2] = Math_fround(0.0);
  }
 } while (0);
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 76 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 return;
}

function __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 24 >> 2] = -2147483648;
 i8 = i7 + 28 | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 + 40 >> 2] = i3;
 HEAP32[i7 + 44 >> 2] = 0;
 HEAP32[i7 + 48 >> 2] = 0;
 HEAP32[i7 + 52 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i7 + 12 >> 2] = i5;
 HEAP8[i7 + 36 >> 0] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(i1, i7);
 STACKTOP = i6;
 return;
}

function __Z55Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatricesP12Il2CppObjectRK10Matrix4x4fS3_(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f(i2, 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f(i1, 1, i4);
  return;
 }
}

function __Z53Transform_CUSTOM_INTERNAL_CALL_InverseTransformVectorP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK9Transform22InverseTransformVectorERK8Vector3f(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z24RegisterBuiltinVRDevicesv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 1344 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = i3 + 668 | 0;
 if (__Z20IsRunningNativeTestsv() | 0) {
  STACKTOP = i3;
  return;
 }
 i4 = HEAP32[gb + 189476 >> 2] | 0;
 _memset(i2 | 0, 0, 668) | 0;
 _strncpy(i2, i4, 64) | 0;
 _strncpy(i2 + 64 | 0, i4, 64) | 0;
 i4 = HEAP32[(__Z18GetUnityInterfacesv() | 0) >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = 586239589;
 HEAP32[i5 + 4 >> 2] = 1008725759;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = 426257907;
 HEAP32[i5 + 4 >> 2] = -2134066609;
 i4 = HEAP32[(mftCall_ii(i4 | 0, i1 | 0) | 0) >> 2] | 0;
 _memcpy(i1 | 0, i2 | 0, 668) | 0;
 mftCall_vi(i4 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __Z13RegisterClassIN20TextRenderingPrivate8TextMeshEEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1003;
 HEAP32[i2 + 8 >> 2] = gb + 946466;
 HEAP32[i2 + 12 >> 2] = gb + 946737;
 HEAP32[i2 + 16 >> 2] = 102;
 HEAP32[i2 + 20 >> 2] = 92;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 185320;
 HEAP32[i2 + 44 >> 2] = fb + 334;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 335;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK25BlendshapePropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = HEAP32[gb + 57892 >> 2] | 0;
 if (!(__Z10BeginsWithPKcS0_(i1, i2) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = i1 + (_strlen(i2) | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 HEAP32[i4 + 4 >> 2] = i1;
 i4 = 1;
 return i4 | 0;
}

function __ZN23TransformChangeDispatch19SetSystemInterestedE15TransformAccess27TransformChangeSystemHandleb(i1, i3, i2, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i4 = 0, i6 = 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 + 40 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i6 + 44 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i6 + 48 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i6 + 52 >> 2] = HEAP32[i1 + 40 >> 2];
 i4 = 1 << HEAP32[i2 >> 2];
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = (HEAP32[i6 + 60 >> 2] | 0) + (i1 << 2) | 0;
 if (i5) {
  i6 = HEAP32[i2 >> 2] | i4;
  HEAP32[i2 >> 2] = i6;
  return;
 } else {
  i5 = ~i4;
  i6 = (HEAP32[i6 + 56 >> 2] | 0) + (i1 << 2) | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & i5;
  i6 = HEAP32[i2 >> 2] & i5;
  HEAP32[i2 >> 2] = i6;
  return;
 }
}

function __ZN20ExternalForcesModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = __ZN11WindManager7GetListEv(__ZN11WindManager11GetInstanceEv() | 0) | 0;
 i4 = i5 + 436 | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) i1 = 0; else {
  i2 = 0;
  do {
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
  } while ((i1 | 0) != (i3 | 0));
  HEAP32[i4 >> 2] = i2;
  i1 = i2 * 40 | 0;
 }
 HEAP32[i5 + 432 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 4, gb + 64016 | 0, 0, gb + 621367 | 0, 93) | 0;
 i4 = __Z14GetTimeManagerv() | 0;
 HEAPF32[i5 + 440 >> 2] = Math_fround(+HEAPF64[i4 + 96 >> 3] + +HEAPF64[i4 + 168 >> 3]);
 return;
}

function __ZN17AnimationPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIP26AnimatorControllerPlayableLj4EE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i6 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i7 = 8;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 8) {
   i7 = 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i5 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZN15ParticleEmitter18UpdateManagerStateEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 208 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 if (!((i3 | 0) != 0 ^ i2)) return;
 if (!i2) {
  if (!i3) return;
  i2 = i1 + 212 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i3;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 if ((i4 | 0) == (gb + 1469400 | 0)) return;
 if (!i3) i1 = i1 + 212 | 0; else {
  i1 = i1 + 212 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i3 = HEAP32[gb + 1469400 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i1 >> 2] = gb + 1469400;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 411274 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14Texture2DArray8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 429490 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SpriteRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 737689 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14SphereCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14RenderSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 381335 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14RenderSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 448085 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14PlayerSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 737328 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14PhysicsManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 618922 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14ParticleSystem8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14BillboardAsset23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 422256 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14BillboardAsset8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800815 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN14AreaEffector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12CubemapArray9SetPixelsEiPK10ColorRGBAf11CubemapFaceii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 if (!(__ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii(i1, i2, i3, i4, i5, i6) | 0)) return;
 i8 = (HEAP32[i1 + 92 >> 2] | 0) + (Math_imul(HEAP32[i1 + 100 >> 2] | 0, (i5 * 6 | 0) + i4 | 0) | 0) | 0;
 i7 = i1 + 80 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 88 | 0;
 i4 = i8 + (__Z21CalculateMipMapOffsetii13TextureFormati(i4, i4, HEAP32[i5 >> 2] | 0, i6) | 0) | 0;
 i6 = HEAP32[i7 >> 2] >> i6;
 i6 = (i6 | 0) < 1 ? 1 : i6;
 __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf(i4, i6, i6, HEAP32[i5 >> 2] | 0, 0, 0, i6, i6, i2, i3) | 0;
 return;
}

function __ZN11UnityEngine15PlatformWrapper17SetPlayerPrefsIntERK8UnityStri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = HEAP8[i1 + 11 >> 0] | 0;
 i7 = i6 << 24 >> 24 < 0;
 i5 = i7 ? HEAP32[i1 >> 2] | 0 : i1;
 i1 = i7 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, i1);
 __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, (HEAP32[i1 + 900 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartDelayP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, __ZN14ParticleSystem18GetStartDelayCurveEv(i1) | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z42TrailRenderer_Get_Custom_PropColorGradientP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  i3 = __Znwj(72) | 0;
  i4 = i3;
  i1 = (HEAP32[i2 + 384 >> 2] | 0) + 108 | 0;
  i2 = i4 + 72 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 200 >> 2] | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i3;
  return i4 | 0;
 }
 return 0;
}

function _getsubopt(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = 0;
 i2 = _strchr(i6, 44) | 0;
 HEAP32[i1 >> 2] = i2;
 if (!i2) HEAP32[i1 >> 2] = i6 + (_strlen(i6) | 0); else {
  HEAP32[i1 >> 2] = i2 + 1;
  HEAP8[i2 >> 0] = 0;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 L5 : do if (!i2) i1 = -1; else {
  i1 = 0;
  L6 : while (1) {
   i3 = _strlen(i2) | 0;
   if (!(_strncmp(i2, i6, i3) | 0)) {
    i2 = i6 + i3 | 0;
    switch (HEAP8[i2 >> 0] | 0) {
    case 0:
     break L5;
    case 61:
     break L6;
    default:
     {}
    }
   }
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (!i2) {
    i1 = -1;
    break L5;
   }
  }
  HEAP32[i5 >> 2] = i2;
 } while (0);
 return i1 | 0;
}

function __ZN8Animator15GetHintPositionEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i3 >>> 0 < 4) if (HEAP8[i2 + 153 >> 0] | 0) {
  i4 = (HEAP32[i2 + 124 >> 2] | 0) + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i5 = i4 + i5 + 40 | 0;
   if (HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0) {
    i5 = HEAP32[(HEAP32[i2 + 132 >> 2] | 0) + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 + 68 + (i3 << 6) + 48 >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 68 + (i3 << 6) + 52 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 68 + (i3 << 6) + 56 >> 2];
    return;
   }
  }
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd13TempAllocator8allocateEjPKci(i6, i5 << 2, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd13TempAllocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx10PxsContext15setScratchBlockEPvj(i8, i1, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i9;
 i4 = i8 + 24 | 0;
 i5 = i8 + 28 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + -1 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i8 + 36 >> 2] = i1;
 HEAP32[i8 + 40 >> 2] = i2;
 i1 = i1 + i2 | 0;
 HEAP32[i3 >> 2] = i1;
 if ((HEAP32[i8 + 32 >> 2] & 2147483647) >>> 0 > i7 >>> 0) {
  HEAP32[(HEAP32[i4 >> 2] | 0) + (i7 << 2) >> 2] = i1;
  HEAP32[i5 >> 2] = i6;
  STACKTOP = i9;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_(i4, i3) | 0;
  STACKTOP = i9;
  return;
 }
}

function __ZN4FMOD7Channel17get3DDopplerLevelEPf(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 148 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870017;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN24PhysicsUpdateBehaviour2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 154808 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN18StreamedBinaryReadILb1EE8TransferI15NavMeshTileDataEEvRT_PKc17TransferMetaFlags(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i1, i4, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i1);
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) return;
 if (!(__Z23dtNavMeshDataSwapEndianPhi(HEAP32[i4 >> 2] | 0, i1) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 843910 | 0, 0, gb + 843960 | 0, 27, 1, 0, 0, 0);
 if (__Z25dtNavMeshHeaderSwapEndianPh(HEAP32[i4 >> 2] | 0) | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844036 | 0, 0, gb + 843960 | 0, 28, 1, 0, 0, 0);
 return;
}

function __ZN18DelayedCallManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 37632 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 i3 = i1 + 32 | 0;
 HEAP32[i1 + 28 >> 2] = i3;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN14EmissionModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83016 + 8;
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14EmissionModuleD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83016 + 8;
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 152 >> 2] | 0, i2 + 156 | 0);
 __ZdlPv(i2);
 return;
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 884 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 884 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z52Transform_CUSTOM_INTERNAL_CALL_InverseTransformPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK9Transform21InverseTransformPointERK8Vector3f(i4, i5, i2);
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z43Transform_CUSTOM_INTERNAL_get_localRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Transform16GetLocalRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z41LineRenderer_Get_Custom_PropColorGradientP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  i3 = __Znwj(72) | 0;
  i4 = i3;
  i1 = (HEAP32[i2 + 344 >> 2] | 0) + 108 | 0;
  i2 = i4 + 72 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  i4 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 200 >> 2] | 0) | 0;
  HEAP32[i4 + 8 >> 2] = i3;
  return i4 | 0;
 }
 return 0;
}

function __Z34Component_Get_Custom_PropTransformP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 508707 | 0, i3);
 i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 4 >> 2] | 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z25CheckBatchModeErrorStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i1 + 11 | 0;
 i6 = HEAP8[i2 >> 0] | 0;
 i3 = i6 << 24 >> 24 < 0;
 if (!((i3 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  STACKTOP = i5;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i3 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 488048 | 0, 171, 1, 0, 0, 0);
 if (!(HEAP8[gb + 1546618 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 } else {
  HEAP32[i4 >> 2] = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
  _printf_console(gb + 488115 | 0, i4);
  _exit(1);
 }
}

function __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f8 + Math_fround(HEAPF32[i1 + 8 >> 2]));
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 __ZN10Matrix4x4f8SetOrthoEffffff(i5, f8, f7, f6, Math_fround(f6 + Math_fround(HEAPF32[i1 + 12 >> 2])), Math_fround(-1.0), Math_fround(100.0)) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i5 | 0);
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, gb + 1162292 | 0);
 STACKTOP = i4;
 return;
}

function __Z13InputShutdownv() {
 _emscripten_set_keydown_callback(0, 0, 0, 0) | 0;
 _emscripten_set_keyup_callback(0, 0, 0, 0) | 0;
 _emscripten_set_keypress_callback(0, 0, 0, 0) | 0;
 _emscripten_set_mouseup_callback(0, 0, 0, 0) | 0;
 _emscripten_set_mousedown_callback(0, 0, 0, 0) | 0;
 _emscripten_set_dblclick_callback(0, 0, 0, 0) | 0;
 _emscripten_set_mousemove_callback(0, 0, 0, 0) | 0;
 _emscripten_set_wheel_callback(0, 0, 0, 0) | 0;
 _emscripten_set_touchstart_callback(0, 0, 0, 0) | 0;
 _emscripten_set_touchend_callback(0, 0, 0, 0) | 0;
 _emscripten_set_touchmove_callback(0, 0, 0, 0) | 0;
 _emscripten_set_touchcancel_callback(0, 0, 0, 0) | 0;
 _emscripten_set_devicemotion_callback(0, 0, 0) | 0;
 _emscripten_set_deviceorientation_callback(0, 0, 0) | 0;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN36InitializationPlayerUpdateTimestruct7ForwardEv() {
 var i1 = 0;
 if (__Z19GetIClusterRendererv() | 0) {
  i1 = __Z19GetIClusterRendererv() | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) {
   i1 = __Z19GetIClusterRendererv() | 0;
   if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) return;
  }
 }
 if (__ZN13RenderManager28AreCamerasUsingMotionVectorsEv(__Z16GetRenderManagerv() | 0) | 0) {
  __ZN13RendererScene27UpdatePreviousFrameMatricesEv(__Z16GetRendererScenev() | 0);
  __ZN13RenderManager27UpdatePreviousFrameMatricesEv(__Z16GetRenderManagerv() | 0);
 }
 i1 = __Z14GetTimeManagerv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__215__num_get_floatIfEET_PKcS3_Rj(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, d3 = 0.0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i9;
 if ((i2 | 0) == (i4 | 0)) {
  HEAP32[i5 >> 2] = 4;
  f1 = Math_fround(0.0);
 } else {
  i7 = ___errno_location() | 0;
  i8 = HEAP32[i7 >> 2] | 0;
  HEAP32[i7 >> 2] = 0;
  d3 = +_strtold_l(i2, i6, __ZNSt3__26__clocEv() | 0);
  i2 = HEAP32[i7 >> 2] | 0;
  if (!i2) HEAP32[i7 >> 2] = i8;
  if ((HEAP32[i6 >> 2] | 0) == (i4 | 0)) {
   if ((i2 | 0) == 34) HEAP32[i5 >> 2] = 4;
   f1 = Math_fround(d3);
  } else {
   HEAP32[i5 >> 2] = 4;
   f1 = Math_fround(0.0);
  }
 }
 STACKTOP = i9;
 return Math_fround(f1);
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12__invariantsEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = i5 + 8 | 0;
 i6 = HEAP8[i1 + 3 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 if (i4) {
  i2 = HEAP32[i5 + 4 >> 2] | 0;
  i3 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0;
 } else {
  i2 = i6 & 255;
  i3 = 1;
 }
 do if (i2 >>> 0 > i3 >>> 0) i1 = 0; else {
  if (i4) {
   if ((HEAP32[i1 >> 2] & 2147483647 | 0) == 1) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i5 >> 2] | 0;
  } else i1 = i5;
  if (!i1) i1 = 0; else {
   if (i4) {
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i5 + 4 >> 2] | 0;
   } else {
    i2 = i5;
    i1 = i6 & 255;
   }
   i1 = (HEAP32[i2 + (i1 << 2) >> 2] | 0) == 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZN9LensFlareC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 32976 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = -1;
 HEAPF32[i1 + 60 >> 2] = Math_fround(3.0);
 STACKTOP = i4;
 return;
}

function __ZN9GfxDevice20CleanupSharedBuffersEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 4408 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 12 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) __ZN16MeshVertexFormatD2Ev(i4);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63304 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i5 + 4216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 236 >> 2] | 0, i5 | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i5 + 4220 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 236 >> 2] | 0, i5 | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8Animator14OnAddComponentEPN5Unity9ComponentE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 31312 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 31312 + 28 >> 2] | 0) >>> 0) return;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 __ZN8Animator23ClearContainedRenderersEv(i3);
 if (!(HEAP32[i3 + 92 >> 2] | 0)) {
  HEAP8[i3 + 88 >> 0] = 1;
  return;
 } else {
  __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP8[i3 + 88 >> 0] = (__ZNK8Animator20IsAnyRendererVisibleEv(i3) | 0) & 1;
  return;
 }
}

function __ZN7CurveID13CalculateHashEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i4 = 4; else {
  i3 = 0;
  do {
   i4 = (i3 << 4) + (i2 << 24 >> 24) | 0;
   i6 = i4 & -268435456;
   i3 = (i6 >>> 24 | i6) ^ i4;
   i1 = i1 + 1 | 0;
   i2 = HEAP8[i1 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i4 = i3 ^ 4;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (!(i3 << 24 >> 24)) i1 = 0; else {
  i1 = 0;
  do {
   i1 = (i1 << 4) + (i3 << 24 >> 24) | 0;
   i6 = i1 & -268435456;
   i1 = (i6 >>> 24 | i6) ^ i1;
   i2 = i2 + 1 | 0;
   i3 = HEAP8[i2 >> 0] | 0;
  } while (i3 << 24 >> 24 != 0);
 }
 i6 = i4 ^ i1;
 HEAP32[i5 + 16 >> 2] = i6 >>> 0 < 2 ? 2 : i6;
 return;
}

function __ZN5physx13NpClothFabric12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP16[i4 + 6 >> 1] = 2;
 HEAP32[i4 >> 2] = gb + 106772 + 8;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = gb + 93676 + 8;
 HEAP32[i4 + 12 >> 2] = 1;
 HEAP32[i4 >> 2] = gb + 106864 + 8;
 HEAP32[i5 >> 2] = gb + 106864 + 112;
 i5 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sc15ClothFabricCoreC2ERKNS_7PxEMPTYE(i5, i6);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 36;
 __ZN5physx2Sc15ClothFabricCore15importExtraDataERNS_24PxDeserializationContextE(i5, i2);
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN22ProceduralMaterialData5CleanEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   if (!(HEAP8[i3 + 16 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, gb + 63736 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN17SurfaceEffector2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 92 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e6) : f2;
 i3 = i1 + 96 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e6);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(-1.0e6) : f2;
 i1 = i1 + 100 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 827168 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13WheelCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 421148 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13TrailRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 803162 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13TargetJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 803021 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13SpringJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 410430 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13SparseTexture8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802891 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13SliderJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 590339 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13RenderTexture8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 378973 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13OcclusionArea8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13ConstantForce23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 735691 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13ConstantForce8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 443248 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13BuildSettings8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800904 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13BoxCollider2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 897916 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN13AnimationClip8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11LightProbes23SetRealtimeCoefficientsEPK13dynamic_arrayI20SphericalHarmonicsL2Lj4EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 104 >> 2] | 0;
 if (!i2) {
  if (i3 | 0) return;
 } else if ((HEAP32[i2 + 12 >> 2] | 0) != (i3 | 0)) return;
 __Z39GfxDeviceWaitForAllRenderJobsToCompletev();
 HEAP32[i1 + 188 >> 2] = i2;
 i4 = __ZN15GlobalCallbacks3GetEv() | 0;
 i2 = i4 + 38596 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return; else i1 = 0;
 do {
  i3 = i4 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i4 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i3 >> 2] | 0); else mftCall_vi(HEAP32[i3 >> 2] | 0, HEAP32[i4 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 return;
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartColorP12Il2CppObjectR18MonoMinMaxGradient(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient(i3, (HEAP32[i1 + 44 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43Animator_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator17GetTargetRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z13RegisterClassI30RuntimeInitializeOnLoadManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 591;
 HEAP32[i2 + 8 >> 2] = gb + 450783;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 300;
 HEAP32[i2 + 20 >> 2] = 172;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31472;
 HEAP32[i2 + 44 >> 2] = fb + 78;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 79;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI26AnimatorOverrideControllerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 178436;
 HEAP32[i2 + 4 >> 2] = fb + 953;
 HEAP32[i2 + 8 >> 2] = gb + 905605;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 221;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 178624;
 HEAP32[i2 + 44 >> 2] = fb + 309;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 310;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 switch (__ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData(i2, i3, i4 + 128 | 0, i4) | 0) {
 case 1:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 425656 | 0, 1048, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   return;
  }
 case 4:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 427680 | 0, 0, gb + 425656 | 0, 1051, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
   return;
  }
 default:
  return;
 }
}

function __ZN9ShaderLab15PushParserStateEPNS_21SerializedShaderStateE(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1166560 >> 2] | 0;
 i6 = i4 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i9 = (HEAP32[i4 + 8 >> 2] | 0) - i1 | 0;
 i5 = i4 + 16 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i8 = i4 + 20 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if ((((i9 | 0) == 0 ? 0 : (i9 << 8) + -1 | 0) | 0) == (i3 + i2 | 0)) {
  __ZNSt3__25dequeIPN9ShaderLab21SerializedShaderStateENS_9allocatorIS3_EEE19__add_back_capacityEv(i4);
  i3 = HEAP32[i8 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 i9 = i3 + i2 | 0;
 HEAP32[(HEAP32[i1 + (i9 >>> 10 << 2) >> 2] | 0) + ((i9 & 1023) << 2) >> 2] = i7;
 HEAP32[i8 >> 2] = i3 + 1;
 return;
}

function __ZN9CGProgramD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 68632 + 8;
 i1 = i2 + 80 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 92 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 64 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN9TextAssetD2Ev(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 76 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZN9TextAssetD2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Gu10ConvexMesh15importExtraDataERNS_24PxDeserializationContextE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i2 = ((HEAPU8[i5 + 55 >> 0] | 0) * 20 | 0) + (HEAP32[i5 + 80 >> 2] & 2147483647) + ((HEAPU8[i5 + 54 >> 0] | 0) * 15 | 0) + ((HEAPU16[i5 + 52 >> 1] | 0) << 1) | 0;
 i6 = i2 & 3;
 i1 = i4 + 4 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 15 & -16;
 i2 = i3 + (((i6 | 0) == 0 ? 0 : 4 - i6 | 0) + i2) | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i5 + 56 >> 2] = i3;
 i3 = i5 + 84 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i2 + 15 & -16;
 i6 = i2;
 HEAP32[i1 >> 2] = i2 + 28;
 HEAP32[i3 >> 2] = i6;
 __ZN5physx13BigConvexData15importExtraDataERNS_24PxDeserializationContextE(i6, i4);
 HEAP32[i5 + 60 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __ZN5physx14NpArticulationD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 91248 + 8;
 __ZN5physx9NpFactory21onArticulationReleaseEPNS_14PxArticulationE(HEAP32[gb + 1457204 >> 2] | 0, i3);
 i2 = HEAP32[i3 + 96 >> 2] | 0;
 do if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i3 + 88 >> 2] | 0;
  if ((i3 + 68 | 0) == (i2 | 0)) {
   HEAP8[i3 + 84 >> 0] = 0;
   break;
  }
  if (i2 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
  }
 } while (0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN5Light23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 40 | 0;
 if (HEAP8[i6 >> 0] | 0) __ZNK5Light16UnshareLightDataEv(i2);
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = (HEAP32[i2 + 44 >> 2] | 0) + 92 | 0;
 i5 = i1 + 16 | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i3 = i1 + 36 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i7 >> 2] >> 2] | 0, i7 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 if (HEAP8[i6 >> 0] | 0) HEAP32[i4 >> 2] = i1;
 i2 = i2 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN21DownloadHandlerBufferC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i3 = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187512 + 8;
 i7 = gb + 63808 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN15NavMeshSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(32, i1, 16, gb + 1048932 | 0, 0, gb + 846606 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 169704 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 884 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z30GeomOverlapCallback_SphereMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i6 + 12 >> 2] = i2;
 i5 = __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i6, (HEAP32[i3 + 36 >> 2] | 0) + 32 | 0, i5, i3 + 4 | 0, 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __Z28getPxHeightFieldDesc_IsValidPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < 2) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) >>> 0 < 2) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] | 0) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 < 4) {
  i1 = 0;
  return i1 | 0;
 }
 if (Math_fround(HEAPF32[i1 + 24 >> 2]) < Math_fround(0.0)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = HEAP16[i1 + 28 >> 1] | 0;
 if ((i2 & 1) << 16 >> 16 != i2 << 16 >> 16) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 20 >> 2]);
 i2 = !(f3 > Math_fround(8507058669999999534545717.0e13)) & !(f3 < Math_fround(-8507058669999999534545717.0e13));
 return i2 | 0;
}

function __Z13RegisterClassI24EllipsoidParticleEmitterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 190576;
 HEAP32[i2 + 4 >> 2] = fb + 1131;
 HEAP32[i2 + 8 >> 2] = gb + 1047658;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 15;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190404;
 HEAP32[i2 + 44 >> 2] = fb + 433;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 434;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _mread(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i3 + 84 >> 2] | 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i2 >>> 0 < i6 >>> 0 ? 0 : i2 - i6 | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 16;
  i1 = i2;
 }
 i7 = i5 + 12 | 0;
 _memcpy(i4 | 0, (HEAP32[i7 >> 2] | 0) + i6 | 0, i1 | 0) | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
 HEAP32[i5 >> 2] = i4;
 i6 = i2 - i1 | 0;
 i2 = HEAP32[i3 + 48 >> 2] | 0;
 i6 = i6 >>> 0 > i2 >>> 0 ? i2 : i6;
 i2 = HEAP32[i3 + 44 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i2 + i6;
 _memcpy(i2 | 0, (HEAP32[i7 >> 2] | 0) + i4 | 0, i6 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i6;
 return i1 | 0;
}

function _j0(d1) {
 d1 = +d1;
 var i2 = 0, d3 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 do if (i2 >>> 0 > 2146435071) d1 = 1.0 / (d1 * d1); else {
  d1 = +Math_abs(+d1);
  if (i2 >>> 0 > 1073741823) {
   d1 = +_common(i2, d1, 0);
   break;
  }
  if (i2 >>> 0 > 1059061759) {
   d3 = d1 * d1;
   d1 = d1 * .5;
   d1 = (d1 + 1.0) * (1.0 - d1) + d3 * (d3 * (d3 * (d3 * (1.8295404953270067e-06 - d3 * 4.618326885321032e-09) + -1.8997929423885472e-04) + .015624999999999995) / (d3 * (d3 * (d3 * (d3 * 1.1661400333379e-09 + 5.135465502073181e-07) + 1.1692678466333745e-04) + .015619102946489001) + 1.0));
   break;
  } else {
   d1 = 1.0 - (i2 >>> 0 > 939524095 ? d1 * (d1 * .25) : d1);
   break;
  }
 } while (0);
 return +d1;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i4 = i6 + 344 | 0;
 i3 = i6 + 348 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i4, i1, i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i6 + 536 >> 2] = 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i6 + (i1 << 4);
 STACKTOP = i7;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 if (i4 >>> 0 > 1073741807) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 do if (i4 >>> 0 < 2) HEAP8[i1 + 8 + 3 >> 0] = i4; else {
  i2 = i4 + 4 & -4;
  if (i2 >>> 0 > 1073741823) {
   i4 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i4);
   ___cxa_throw(i4 | 0, gb + 13048 | 0, fb + 3215 | 0);
  } else {
   i5 = __Znwj(i2 << 2) | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i4;
   i1 = i5;
   break;
  }
 } while (0);
 __ZNSt3__211char_traitsIwE4copyEPwPKwj(i1, i3, i4) | 0;
 HEAP32[i1 + (i4 << 2) >> 2] = 0;
 return;
}

function __ZNK13AnimationClip16GetApparentSpeedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, d4 = 0.0, d5 = 0.0, f6 = f0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i7 | 0, i1 | 0);
 f3 = Math_fround(HEAPF32[i7 >> 2]);
 f3 = Math_fround(f3 * f3);
 f6 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f6 = Math_fround(f3 + Math_fround(f6 * f6));
 f3 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 d5 = +Math_fround(Math_sqrt(Math_fround(f6 + Math_fround(f3 * f3))));
 d4 = +Math_fround(Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0)) * Math_fround(.5));
 f3 = Math_fround(d5 * (d4 * d4 + 1.0));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN8Animator19OnUpdateModeChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i2 = i4;
 if (!(__Z14IsWorldPlayingv() | 0)) {
  STACKTOP = i4;
  return;
 }
 if (!(HEAP8[i1 + 33 >> 0] | 0)) {
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0);
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0;
 i8 = i1 + 628 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i2;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 mftCall_viii(i5 | 0, i1 | 0, i3 | 0, 0);
 STACKTOP = i4;
 return;
}

function __ZN7CubemapC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 41748 + 8;
 i3 = i1 + 152 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj(i3, 6);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD7Channel13set3DPanLevelEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   _JS_Sound_Set3D(HEAP32[i2 + 164 >> 2] | 0, f3 > Math_fround(0.0) | 0);
   HEAPF32[i2 + 144 >> 2] = f3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 858920;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System9getOutputEP15FMOD_OUTPUTTYPE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 857600;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 857600;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857600;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN18GfxFramebufferGLES37GetFramebufferNameFromDepthAttachmentEP17RenderSurfaceBase(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i4 + 32 | 0;
 i6 = i4;
 i8 = i6 + 76 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i5 >> 2] = i3;
 HEAP32[i4 + 36 >> 2] = 0;
 HEAP8[i4 + 56 >> 0] = 0;
 HEAP8[i4 + 64 >> 0] = 0;
 HEAP8[i4 + 72 >> 0] = 0;
 HEAP8[i4 + 73 >> 0] = 0;
 HEAP32[i4 + 44 >> 2] = -1;
 HEAP32[i4 + 40 >> 2] = 0;
 HEAP32[i4 + 52 >> 2] = 0;
 __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup(i1, i2, i4);
 STACKTOP = i7;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner10disconnectEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i4 = i3 + 16 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 i2 = i3 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i4 = i3 + 20 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (!i1) {
  i4 = HEAP32[i2 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i4 = HEAP32[i2 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 803207 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12WheelJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12ScriptMapper23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 476527 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12ScriptMapper8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 842251 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12NavMeshAgent8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 737071 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12MeshCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 405180 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12LineRenderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12InputManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 434516 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12InputManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801424 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12HingeJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 801395 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12FixedJoint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 397025 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12CubemapArray8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 855932 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN12AudioManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11TrailModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83608 + 8;
 i1 = i2 + 680 | 0;
 if ((HEAP32[i2 + 696 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 684 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 592 | 0;
 if ((HEAP32[i2 + 608 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 596 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 244 | 0;
 if ((HEAP32[i2 + 260 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 248 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 156 | 0;
 if ((HEAP32[i2 + 172 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 160 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z42Animator_CUSTOM_INTERNAL_get_deltaRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator16GetDeltaRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z41Animator_CUSTOM_INTERNAL_get_rootRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZN8Animator17GetAvatarRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z24ShaderPassContextCleanupv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 1166248 >> 2] | 0;
 if (i2 | 0) {
  HEAP32[i2 + 36 >> 2] = gb + 33952 + 8;
  if ((HEAP32[i2 + 124 >> 2] | 0) > -1) {
   i1 = i2 + 108 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 112 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i2 + 88 | 0;
  if ((HEAP32[i2 + 104 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 92 | 0);
   HEAP32[i1 >> 2] = 0;
  }
  i1 = i2 + 68 | 0;
  if ((HEAP32[i2 + 84 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 72 | 0);
   HEAP32[i1 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 HEAP32[gb + 1166248 >> 2] = 0;
 return;
}

function __Z13GetStacktracei(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 8208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 8 | 0;
 _printf_console(gb + 363868 | 0, i7);
 _JS_Log_StackTrace(i3 | 0, 8192);
 i5 = i3 + 8192 | 0;
 if ((i2 | 0) > -4) {
  i1 = i3;
  i4 = i2 + 4 | 0;
  i2 = i3;
  do {
   i3 = (HEAP8[i2 >> 0] | 0) == 10;
   i2 = i2 + 1 | 0;
   i4 = (i3 << 31 >> 31) + i4 | 0;
   i1 = i3 ? i2 : i1;
  } while ((i4 | 0) > 0 & i2 >>> 0 < i5 >>> 0);
 } else i1 = i3;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, _strlen(i1) | 0);
 STACKTOP = i7;
 return;
}

function __ZNK12LineRenderer11GetPositionEi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = HEAP32[i1 + 348 >> 2] | 0;
 if ((i3 | 0) > -1 ? (HEAP32[i1 + 20 >> 2] | 0) > (i3 | 0) : 0) {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i4 = HEAP32[i5 + (i3 * 12 | 0) + 4 >> 2] | 0;
  i1 = HEAP32[i5 + (i3 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + (i3 * 12 | 0) >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406942 | 0, 0, gb + 406663 | 0, 131, 1, 0, 0, 0);
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 }
}

function __ZN8Animator22SetLayerParametersMaskEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i2 + 624 >> 2] | 0;
 if (!i1) return;
 if (!(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0)) return;
 i1 = HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 16 >> 2] | 0) + 4 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if (!i5) return;
 i4 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + 32 >> 2] | 0;
 i2 = HEAP32[i1 + 100 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + 24 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = 0;
 do {
  HEAP8[i2 + (i1 * 12 | 0) >> 0] = HEAP8[i4 + i1 >> 0] | 0;
  HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 * 12 | 0) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 * 12 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  i1 = i1 + 12 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, i1, i2, i3, i4, i7) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 HEAP32[i6 >> 2] = i7;
 if (!(HEAP32[i5 + 44 >> 2] & i1)) {
  STACKTOP = i8;
  return;
 }
 i7 = i5 + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 _vsnprintf(gb + 1548984 | 0, 1024, i4, i6) | 0;
 HEAP8[gb + 1548984 + 1024 >> 0] = 0;
 __ZN5physx6shdfnd12ErrorHandler11reportErrorENS_11PxErrorCode4EnumEPKcS5_i(i5 + 116 | 0, i1, gb + 1548984 | 0, i2, i3);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 STACKTOP = i8;
 return;
}

function __ZN4FMOD12ChannelGroup9getVolumeEPf(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 44 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868630;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN24EllipsoidParticleEmitterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i6;
 return;
}

function __ZN16ParticleRenderer11SetUVFramesEPK5RectTIfEi(i2, i6, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 376 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 i1 = i2 + 372 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 if (!i3) return;
 i5 = i3 << 4;
 if (i5 >>> 0 <= i3 >>> 0) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] << 4, 16, gb + 63264 | 0, 0, gb + 1048339 | 0, 71) | 0;
 HEAP32[i4 >> 2] = i1;
 if (i3) {
  __Z19pop_allocation_rootv();
  i1 = HEAP32[i4 >> 2] | 0;
 }
 _memcpy(i1 | 0, i6 | 0, i5 | 0) | 0;
 return;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 402117 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN12HandlerChain5FirstEP17FileSystemHandler(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i3 + 8 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) {
  i1 = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2) | 0;
  HEAP32[i6 >> 2] = i1;
 }
 HEAP32[i5 >> 2] = i4;
 if ((i1 | 0) == (HEAP32[i3 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i3 + 4 | 0, i5);
  STACKTOP = i7;
  return i3 | 0;
 } else {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 4;
  STACKTOP = i7;
  return i3 | 0;
 }
 return 0;
}

function __ZN10MeshFilter20AssignMeshToRendererEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  i2 = i1 + 376 | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
   HEAP32[i2 >> 2] = i3;
   __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
  }
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1106136 | 0, i5);
 STACKTOP = i6;
 return;
}

function __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 if (!i4) {
  i6 = 0;
  return i6 | 0;
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 1;
 }
 do {
  if (i3 & i4) {
   i7 = i5 + (i2 << 1) | 0;
   HEAP8[i6 + (i2 << 2) >> 0] = 0;
   HEAP8[i6 + (i2 << 2) + 1 >> 0] = i1;
   HEAP8[i6 + (i2 << 2) + 2 >> 0] = HEAP8[i7 >> 0] | 0;
   HEAP8[i6 + (i2 << 2) + 3 >> 0] = HEAP8[i5 + (i2 << 1) + 1 >> 0] | 0;
   i7 = HEAPU8[i7 >> 0] | HEAPU8[i7 + 1 >> 0] << 8;
   i1 = (Math_imul((i7 & 65535) >>> 8 & 65535, HEAPU8[(i7 & 255) + (gb + 430676) >> 0] | 0) | 0) + i1 | 0;
  }
  i2 = i2 + 1 | 0;
  i3 = i3 << 1;
 } while ((i2 | 0) < 8 & i3 >>> 0 <= i4 >>> 0);
 return i1 | 0;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIhhEEPhEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 2 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i6, i6 + 1 | 0, i5, i1) | 0;
 i4 = i6 + 3 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP8[i4 >> 0] | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  if ((i5 & 255) < (i3 & 255)) {
   i2 = i4;
   while (1) {
    HEAP8[i2 >> 0] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -1 | 0;
    i3 = HEAP8[i2 >> 0] | 0;
    if ((i5 & 255) >= (i3 & 255)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP8[i1 >> 0] = i5;
  }
  i1 = i4;
  i4 = i4 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 if (i3 >>> 0 > 1073741807) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 do if (i3 >>> 0 < 2) HEAP8[i1 + 8 + 3 >> 0] = i3; else {
  i2 = i3 + 4 & -4;
  if (i2 >>> 0 > 1073741823) {
   i4 = ___cxa_allocate_exception(4) | 0;
   __ZNSt9bad_allocC2Ev(i4);
   ___cxa_throw(i4 | 0, gb + 13048 | 0, fb + 3215 | 0);
  } else {
   i5 = __Znwj(i2 << 2) | 0;
   HEAP32[i1 >> 2] = i5;
   HEAP32[i1 + 8 >> 2] = i2 | -2147483648;
   HEAP32[i1 + 4 >> 2] = i3;
   i1 = i5;
   break;
  }
 } while (0);
 __ZNSt3__211char_traitsIwE6assignEPwjw(i1, i3, i4) | 0;
 HEAP32[i1 + (i3 << 2) >> 2] = 0;
 return;
}

function __ZNK12HandlerChain4SizeERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  i5 = 0;
  setTempRet0(i4 | 0);
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0) | 0) break;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 0;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) {
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 i4 = getTempRet0() | 0;
 setTempRet0(i4 | 0);
 return i5 | 0;
}

function __ZN5physx7NpScene17addParticleSystemERNS_16NpParticleSystemE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE(i6 + 16 | 0, i5 + 20 | 0);
 i2 = i6 + 3640 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 3644 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 3648 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx6shdfnd18BufferedSocketImpl5flushEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i8 = i6 + 16 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 L1 : do if (!i2) {
  i2 = 0;
  i1 = 0;
 } else {
  i5 = i6 + 4 | 0;
  i7 = i6 + 14 | 0;
  i1 = 0;
  L3 : while (1) {
   i4 = i6 + 20 + i1 | 0;
   i3 = i2 - i1 | 0;
   while (1) {
    i2 = _send(HEAP32[i5 >> 2] | 0, i4, i3, 0) | 0;
    if ((i2 | 0) >= 0) break;
    if ((HEAP32[(___errno_location() | 0) >> 2] | 0) != 11) break L3;
   }
   i4 = (i2 | 0) > 0;
   i1 = (i4 ? i2 : 0) + i1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
   if (!(i4 & i2 >>> 0 > i1 >>> 0)) break L1;
  }
  HEAP8[i7 >> 0] = 0;
  i2 = HEAP32[i8 >> 2] | 0;
 } while (0);
 HEAP32[i8 >> 2] = 0;
 return (i2 | 0) == (i1 | 0) | 0;
}

function __ZN5physx6shdfnd12ErrorHandler11reportErrorENS_11PxErrorCode4EnumEPKcS5_i(i2, i4, i7, i5, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 i3 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, i7 | 0, i5 | 0, i6 | 0);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i7 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
  return;
 }
 mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, i7 | 0, i5 | 0, i6 | 0);
 i7 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 return;
}

function __ZN5physx2Sc15ArticulationSim20saveLastCCDTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i4 = i1 + 24 | 0;
 i1 = 0;
 do {
  i3 = i1;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 < i2 >>> 0) i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  i6 = HEAP32[i3 + 128 >> 2] | 0;
  HEAP32[i3 + 96 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i3 + 100 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i3 + 104 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i3 + 108 >> 2] = HEAP32[i6 + 12 >> 2];
  HEAP32[i3 + 112 >> 2] = HEAP32[i6 + 16 >> 2];
  HEAP32[i3 + 116 >> 2] = HEAP32[i6 + 20 >> 2];
  HEAP32[i3 + 120 >> 2] = HEAP32[i6 + 24 >> 2];
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx2Gu10ConvexMeshD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 1 | 0;
 HEAP32[i4 >> 2] = gb + 107052 + 8;
 HEAP32[i4 + 8 >> 2] = gb + 107052 + 84;
 if (!(HEAP16[i4 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i4);
  STACKTOP = i5;
  return;
 }
 i3 = i4 + 56 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 84 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx13BigConvexDataD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 }
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx22solve1D4Block_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i3 = (HEAP8[i1 >> 0] | 0) == 9 ? 416 : 272;
 i4 = i1 + 4 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = i1 + 128 | 0;
 i2 = 0;
 while (1) {
  i5 = i1 + 144 | 0;
  i6 = i1 + 160 | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break; else i1 = i1 + i3 | 0;
 }
 return;
}

function __ZN4FMOD7Channel13getAudibilityEPf(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 36 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870035;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD7Channel12getFrequencyEPf(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 140 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859231;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN17PhysicsMaterial2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(44, i1, 16, gb + 1048932 | 0, 0, gb + 806720 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 156188 + 8;
 HEAP32[i4 + 40 >> 2] = 0;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 390244 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11UnityEngine9Analytics13UserInfoEventC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1037882 | 0, 2);
 HEAP32[i1 >> 2] = gb + 188648 + 8;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 return;
}

function __ZN11TerrainData23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 932069 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11TerrainData8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 802696 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11Rigidbody2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11PreloadData23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 461092 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11PreloadData8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 842663 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11OffMeshLink8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 843566 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NavMeshData8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11NamedObject23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 370829 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11MonoManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 463981 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11MonoManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11LightProbes23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 378404 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11LightProbes8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 733457 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11BoxCollider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 867588 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11AudioSource8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 365485 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11AssetBundle8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 868 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 868 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 856 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 856 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 904 >> 2] | 0) + 672 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z41Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxRK13Vector2fIcallS1_fiff(i1, i2, f3, i4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i7 + 8 | 0;
 i8 = i7;
 i10 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i9 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i9 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16Physics2DManager10OverlapBoxERK8Vector2fS2_fiffPK10Collider2D(i10, i9, i8, f3, i4, f5, f6, 0) | 0) | 0;
 STACKTOP = i7;
 return i4 | 0;
}

function __Z39BillboardAsset_CUSTOM_GetImageTexCoordsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i3 = HEAP32[i1 + 28 >> 2] | 0;
  i1 = HEAP32[i1 + 40 >> 2] | 0;
  i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 460 >> 2] | 0;
  i1 = (i3 | 0) == 0 ? 0 : i1;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 16, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0, i3 | 0, i1 << 4 | 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z30AnimationPlayableEvaluateBeginP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, 0);
 i1 = HEAP8[i2 + 34 >> 0] | 0;
 if (!((i1 | HEAP8[i2 + 33 >> 0]) << 24 >> 24)) return;
 __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0);
 if (!(i1 << 24 >> 24)) return;
 __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0);
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0;
 if (!i1) return;
 __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE(i1);
 return;
}

function __Z27IsShaderInstanceMatrixParamPKcPi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1157720 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = i4 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i9 = (i2 | 0) / 2 | 0;
   i7 = i1 + (i9 << 3) | 0;
   i8 = (_strcmp(HEAP32[i7 >> 2] | 0, i5) | 0) < 0;
   i2 = i8 ? i2 + -1 - i9 | 0 : i9;
   i1 = i8 ? i7 + 8 | 0 : i1;
  } while ((i2 | 0) != 0);
 }
 if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if (_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0) {
  i9 = 0;
  return i9 | 0;
 }
 if (!i6) {
  i9 = 1;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = 1;
 return i9 | 0;
}

function __Z20IsTexEnvBuiltinParamPKcPi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1157720 >> 2] | 0;
 i3 = HEAP32[i4 + 120 >> 2] | 0;
 i4 = HEAP32[i4 + 132 >> 2] | 0;
 i1 = i4 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i9 = (i2 | 0) / 2 | 0;
   i7 = i1 + (i9 << 3) | 0;
   i8 = (_strcmp(HEAP32[i7 >> 2] | 0, i5) | 0) < 0;
   i2 = i8 ? i2 + -1 - i9 | 0 : i9;
   i1 = i8 ? i7 + 8 | 0 : i1;
  } while ((i2 | 0) != 0);
 }
 if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if (_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0) {
  i9 = 0;
  return i9 | 0;
 }
 if (!i6) {
  i9 = 1;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = 1;
 return i9 | 0;
}

function __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci(i2, i3, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i10 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i10 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i10;
  if (i10 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i4 = i1;
   break;
  }
 } else i4 = i1; while (0);
 i2 = Math_imul(i3, i2) | 0;
 i1 = __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i4, i2, i5, i6, i7, i8, i9) | 0;
 if (!i1) return i1 | 0;
 _memset(i1 | 0, 0, i2 | 0) | 0;
 return i1 | 0;
}

function __ZNK9ShaderLab11ShaderState29GetSupportsFullForwardShadowsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (i1 | 0) if (HEAP8[i1 + 205 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = 0;
 return i2 | 0;
}

function __ZN9ShaderLab10GrabPasses23ApplyGrabPassMainThreadERKNS_16FastPropertyNameER17ShaderPassContext(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = __ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i7 = HEAP32[i1 >> 2] | 0;
 i4 = (i7 | 0) != -1 ? i1 : gb + 1166408 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb(i3, i4, (i7 | 0) == -1, 1, i2) | 0;
 if (i1 | 0) __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i1, i4, i5);
 STACKTOP = i6;
 return;
}

function __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i1, i3);
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE(i1, i3);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i2 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i2 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, HEAP32[i2 + 16 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 | 0);
 return;
}

function __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = _strlen(i1) | 0;
 i3 = i1 + i4 | 0;
 if ((i4 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i4 = ~i2;
 } else i4 = 0;
 i1 = i5 + 72 | 0;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 if (!i3) {
  i5 = -1;
  return i5 | 0;
 }
 i2 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN4FMOD7Channel15set3DAttributesEPK11FMOD_VECTORS3_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   __ZN4FMOD8ChannelI15set3DAttributesEPK11FMOD_VECTORS3_(i2, i3, i4) | 0;
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 857034;
 _printf(gb + 853184 | 0, i5) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN21WorldParticleCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(52, i1, 16, gb + 1048932 | 0, 0, gb + 1049553 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 191232 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) return;
 i4 = i2 + -8 | 0;
 if (!(HEAP32[i4 >> 2] & 1)) i3 = 0; else i3 = HEAP32[i2 + -12 >> 2] | 0;
 i6 = (HEAP32[i4 >> 2] | 0) >>> 1;
 i5 = i1 + 16 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i6;
 i5 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -23;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 i5 = i1 + 20 | 0;
 HEAP32[i5 >> 2] = -23 - i6 + (HEAP32[i5 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv(i1, i2) | 0;
 __ZN17LowLevelAllocator4FreeEPvj(i4 + (0 - i3) | 0, ((HEAP32[i4 >> 2] | 0) >>> 1) + 31 | 0);
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13ThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63216 | 0);
  HEAP32[i2 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 12 >> 2] = 0;
 i4 = i3 + 4 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i3 + 16 | 0;
  i1 = 0;
  do {
   i6 = HEAP32[i5 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 HEAP32[i4 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63216 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13ConstantForce5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i1 = i1 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 855855 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN11AudioSource7SetMuteEb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 421 | 0;
 if ((i4 & 1 | 0) != (HEAPU8[i1 >> 0] | 0 | 0)) HEAP8[i1 >> 0] = i4 & 1;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance7setMuteEb(i1, i4) | 0;
 }
 i1 = HEAP32[i3 + 432 >> 2] | 0;
 i3 = i3 + 428 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance7setMuteEb(i1, i4) | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN10SampleClip23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 853549 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_AddKey_InternalP12Il2CppObjectRK16KeyframeTplFloat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 8 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4); else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  i4 = __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE(i1, i3) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z48AudioSource_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN11AudioSource24SetOutputAudioMixerGroupE4PPtrI15AudioMixerGroupE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z43Application_Get_Custom_PropBundleIdentifierv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 16 | 0;
 i2 = i4;
 __ZN15ApplicationInfo19GetBundleIdentifierEv(i2, __Z18GetApplicationInfov() | 0);
 i5 = i2 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = __Z20scripting_string_newPKcj(i6 ? HEAP32[i2 >> 2] | 0 : i2, i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return i3 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZThn32_N16ParticleRendererD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + -32 | 0;
 HEAP32[i3 >> 2] = gb + 190956 + 8;
 i1 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = gb + 190956 + 184;
 i2 = HEAP32[i3 + 376 >> 2] | 0;
 if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i3 >> 2] = gb + 43728 + 8;
 HEAP32[i1 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i3);
 i1 = i3 + 288 | 0;
 if ((HEAP32[i3 + 304 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  __ZdlPv(i3);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 292 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 __ZdlPv(i3);
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIwwEEPwEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i6, i6 + 4 | 0, i5, i1) | 0;
 i4 = i6 + 12 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) < (i3 | 0)) {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP32[i1 >> 2] = i5;
  }
  i1 = i4;
  i4 = i4 + 4 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessImmEEPmEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i6, i6 + 4 | 0, i5, i1) | 0;
 i4 = i6 + 12 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i5 >>> 0 < i3 >>> 0) {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i5 >>> 0 >= i3 >>> 0) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP32[i1 >> 2] = i5;
  }
  i1 = i4;
  i4 = i4 + 4 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIllEEPlEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i6, i6 + 4 | 0, i5, i1) | 0;
 i4 = i6 + 12 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) < (i3 | 0)) {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP32[i1 >> 2] = i5;
  }
  i1 = i4;
  i4 = i4 + 4 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIjjEEPjEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i6, i6 + 4 | 0, i5, i1) | 0;
 i4 = i6 + 12 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i5 >>> 0 < i3 >>> 0) {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if (i5 >>> 0 >= i3 >>> 0) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP32[i1 >> 2] = i5;
  }
  i1 = i4;
  i4 = i4 + 4 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIiiEEPiEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i5 = i6 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i6, i6 + 4 | 0, i5, i1) | 0;
 i4 = i6 + 12 | 0;
 i1 = i5;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  i5 = HEAP32[i4 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if ((i5 | 0) < (i3 | 0)) {
   i2 = i4;
   while (1) {
    HEAP32[i2 >> 2] = i3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -4 | 0;
    i3 = HEAP32[i2 >> 2] | 0;
    if ((i5 | 0) >= (i3 | 0)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAP32[i1 >> 2] = i5;
  }
  i1 = i4;
  i4 = i4 + 4 | 0;
 }
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN8UVModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83384 + 8;
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 152 | 0;
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 156 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8UVModuleD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83384 + 8;
 i1 = i2 + 504 | 0;
 if ((HEAP32[i2 + 520 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 508 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 416 | 0;
 if ((HEAP32[i2 + 432 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 420 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 240 | 0;
 if ((HEAP32[i2 + 256 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 244 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 168 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 152 >> 2] | 0, i2 + 156 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN8Animator15GetGoalPositionEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i3 >>> 0 < 4) if (HEAP8[i2 + 153 >> 0] | 0) {
  i4 = (HEAP32[i2 + 124 >> 2] | 0) + 20 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if (i5 | 0) {
   i5 = i4 + i5 + 40 | 0;
   if (HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0) {
    i5 = HEAP32[(HEAP32[i2 + 132 >> 2] | 0) + 24 >> 2] | 0;
    HEAP32[i1 >> 2] = HEAP32[i5 + 68 + (i3 << 6) >> 2];
    HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 68 + (i3 << 6) + 4 >> 2];
    HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 68 + (i3 << 6) + 8 >> 2];
    return;
   }
  }
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN5physx7NpScene16addParticleFluidERNS_15NpParticleFluidE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE(i6 + 16 | 0, i5 + 20 | 0);
 i2 = i6 + 3640 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 3644 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 3648 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i1 = HEAPU8[i4 + 20 >> 0] | 0;
 i2 = i5 + 88 + (i1 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 <= 1) {
  i5 = i3;
  i5 = i5 + -1 | 0;
  HEAP32[i2 >> 2] = i5;
  return;
 }
 i3 = i3 + -1 | 0;
 i6 = HEAP32[i4 + 12 >> 2] | 0;
 i1 = i5 + 16 + (i1 * 12 | 0) | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i7 = i5 + (i3 << 2) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i5 + (i6 << 2) >> 2] | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i6 << 2) >> 2] = i4;
 HEAP32[i4 + 12 >> 2] = i6;
 HEAP32[i5 + 12 >> 2] = i3;
 i5 = HEAP32[i2 >> 2] | 0;
 i5 = i5 + -1 | 0;
 HEAP32[i2 >> 2] = i5;
 return;
}

function __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb(i2, i4, i6, i7, i8, i9, i3, i5, i1, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11;
 HEAP32[i12 >> 2] = gb + 84724 + 8;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i4;
 i10 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i4, i12, i3, i5, HEAP8[i1 >> 0] | 0, i6, i7, i8, i9, i10) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5physx28updateAtomFrictionProgressesEPNS_23PxcSolverConstraintDescEjjj(i2, i11, i9, i10) {
 i2 = i2 | 0;
 i11 = i11 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i11) return; else i1 = 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = (i3 - i9 | 0) >>> 5 >>> 0 < i10 >>> 0;
  if (i5) i6 = HEAPU16[i3 + 14 >> 1] | 0; else i6 = 65535;
  i7 = (i4 - i9 | 0) >>> 5 >>> 0 < i10 >>> 0;
  if (i7) i8 = HEAPU16[i4 + 14 >> 1] | 0; else i8 = 65535;
  HEAP16[i2 + 28 >> 1] = i6;
  HEAP16[i2 + 30 >> 1] = i8;
  if (i5) HEAP16[i3 + 14 >> 1] = i6 + 1;
  if (i7) HEAP16[i4 + 14 >> 1] = i8 + 1;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i11 | 0)) break; else i2 = i2 + 32 | 0;
 }
 return;
}

function __ZN5physx25PxDefaultFileOutputStreamC2EPKc(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i1 >> 2] = gb + 87592 + 8;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = _fopen(i3, gb + 777169 | 0) | 0;
 if (i2 | 0) {
  HEAP32[i1 >> 2] = i2;
  STACKTOP = i5;
  return;
 }
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 i2 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 i1 = HEAP32[(___errno_location() | 0) >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i1;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i2, 32, gb + 666863 | 0, 101, gb + 741254 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 839010 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Unity5Cloth8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN4FMOD7Channel9isVirtualEPb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP8[i3 >> 0] = HEAP8[i2 + 162 >> 0] | 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 856210;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD7Channel9getPausedEPb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP8[i3 >> 0] = HEAP8[i2 + 161 >> 0] | 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868227;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD7Channel11getUserDataEPPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 4 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN26AnimatorOverrideControllerD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 178476 + 8;
 i1 = i2 + 104 | 0;
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2 + 108 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i2 + 132 | 0;
 if ((HEAP32[i2 + 148 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 136 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 84 | 0;
 if ((HEAP32[i2 + 100 >> 2] | 0) <= -1) {
  __ZN25RuntimeAnimatorControllerD2Ev(i2);
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 88 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN25RuntimeAnimatorControllerD2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN18ProceduralMaterial16GetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 128 >> 2] | 0;
 i4 = HEAP32[i1 + 132 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i3 = ~~Math_fround(HEAPF32[i1 + 68 >> 2]);
 i1 = 0;
 while (1) {
  if ((i3 | 0) == (HEAP32[i2 >> 2] | 0)) {
   i2 = 6;
   break;
  }
  i2 = i2 + 20 | 0;
  if ((i2 | 0) == (i4 | 0)) {
   i1 = -1;
   i2 = 6;
   break;
  } else i1 = i1 + 1 | 0;
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN16Physics2DManager21SetLayerCollisionMaskEij(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i4 + 4 | 0;
 i2 = __Z21GetManagerFromContexti(16) | 0;
 if (i5 >>> 0 > 31) {
  HEAP32[i3 >> 2] = 31;
  __Z6FormatPKcz(i1, gb + 806650 | 0, i3);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 805767 | 0, 440, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  STACKTOP = i4;
  return;
 } else {
  HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (i5 << 2) >> 2] = i6;
  STACKTOP = i4;
  return;
 }
}

function __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11JSONUtility28DeserializeObjectOverwritingERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP12Il2CppObjectS5_24TransferInstructionFlags(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = __Z26scripting_object_get_classP12Il2CppObject(i4) | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = __ZL22CreateReaderFromStringPKcbRN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE24TransferInstructionFlags((i6 | 0) == 0 ? i1 + 4 | 0 : i6, i2, i3) | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 __Z23TransferScriptingObjectI8JSONReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i1, i4, i5, 0);
 __ZN8JSONReadD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 i6 = 1;
 return i6 | 0;
}

function __ZN11AudioSource7SetLoopEb(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i4 + 420 | 0;
 if ((i3 & 1 | 0) != (HEAPU8[i1 >> 0] | 0 | 0)) HEAP8[i1 >> 0] = i3 & 1;
 i1 = i4 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance7SetLoopEb(i1, i3) | 0;
 }
 i1 = HEAP32[i4 + 432 >> 2] | 0;
 i3 = i4 + 428 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance7SetLoopEb(i1, 0) | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN10TagManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 370841 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10TagManager8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 455653 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10MonoScript8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10GameObject23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 368689 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10GameObject8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10GUITexture23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 385664 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10GUITexture8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10Effector2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800893 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800956 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 862985 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN10AudioMixer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZL16SceneWasUnloadedi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 256 | 0;
 i5 = i2 + 248 | 0;
 i4 = i2 + 8 | 0;
 i6 = i2;
 HEAP32[i5 >> 2] = i1;
 i8 = (__Z23GetCoreScriptingClassesv() | 0) + 348 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments9AddStructEPKv(i4, i5);
 HEAP32[i3 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0;
 STACKTOP = i2;
 return;
}

function __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 868 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 856 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z52ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 872 >> 2] | 0) + 12 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 908 >> 2] | 0) + 448 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z51ParticleSystem_MainModule_CUSTOM_GetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 2276 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43Sprite_CUSTOM_Internal_GetTextureRectOffsetP12Il2CppObjectP13Vector2fIcall(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0;
 if ((HEAP32[i1 + 32 >> 2] & 3 | 0) == 1) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 568516 | 0, i4); else {
  HEAP32[i3 >> 2] = HEAP32[i1 + 24 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
  STACKTOP = i4;
  return;
 }
}

function __Z30WebCamTexture_CUSTOM_GetPixelsP12Il2CppObjectiiii(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 i7 = Math_imul(i6, i5) | 0;
 i7 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 120 >> 2] | 0, 16, i7) | 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  __ZNK17BaseWebCamTexture9GetPixelsEiiiiP10ColorRGBAf(i3, i2, i4, i5, i6, __Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 16) | 0) | 0;
  return i7 | 0;
 }
 return 0;
}

function __Z20IsVectorBuiltinParamPKcPi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1157720 >> 2] | 0;
 i3 = HEAP32[i4 + 40 >> 2] | 0;
 i4 = HEAP32[i4 + 52 >> 2] | 0;
 i1 = i4 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i9 = (i2 | 0) / 2 | 0;
   i7 = i1 + (i9 << 3) | 0;
   i8 = (_strcmp(HEAP32[i7 >> 2] | 0, i5) | 0) < 0;
   i2 = i8 ? i2 + -1 - i9 | 0 : i9;
   i1 = i8 ? i7 + 8 | 0 : i1;
  } while ((i2 | 0) != 0);
 }
 if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if (_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0) {
  i9 = 0;
  return i9 | 0;
 }
 if (!i6) {
  i9 = 1;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = 1;
 return i9 | 0;
}

function __Z20IsMatrixBuiltinParamPKcPi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[gb + 1157720 >> 2] | 0;
 i3 = HEAP32[i4 + 80 >> 2] | 0;
 i4 = HEAP32[i4 + 92 >> 2] | 0;
 i1 = i4 << 3 >> 3;
 if (!i1) i1 = i3; else {
  i2 = i1;
  i1 = i3;
  do {
   i9 = (i2 | 0) / 2 | 0;
   i7 = i1 + (i9 << 3) | 0;
   i8 = (_strcmp(HEAP32[i7 >> 2] | 0, i5) | 0) < 0;
   i2 = i8 ? i2 + -1 - i9 | 0 : i9;
   i1 = i8 ? i7 + 8 | 0 : i1;
  } while ((i2 | 0) != 0);
 }
 if ((i1 | 0) == (i3 + (i4 << 3) | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 if (_strcmp(HEAP32[i1 >> 2] | 0, i5) | 0) {
  i9 = 0;
  return i9 | 0;
 }
 if (!i6) {
  i9 = 1;
  return i9 | 0;
 }
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 i9 = 1;
 return i9 | 0;
}

function __Z13RegisterClassI19MeshParticleEmitterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 190576;
 HEAP32[i2 + 4 >> 2] = fb + 1132;
 HEAP32[i2 + 8 >> 2] = gb + 1047979;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 87;
 HEAP32[i2 + 20 >> 2] = 240;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190748;
 HEAP32[i2 + 44 >> 2] = fb + 436;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 437;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18ProceduralMaterialEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 30792;
 HEAP32[i2 + 4 >> 2] = fb + 583;
 HEAP32[i2 + 8 >> 2] = gb + 430974;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 185;
 HEAP32[i2 + 20 >> 2] = 296;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31152;
 HEAP32[i2 + 44 >> 2] = fb + 67;
 HEAP32[i2 + 48 >> 2] = fb + 68;
 HEAP32[i2 + 52 >> 2] = fb + 69;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK8VRDevice16GetLocalPositionERK8UnityStr(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 i6 = i3 + 280 | 0;
 if (HEAP32[i6 >> 2] | 0) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZNK7VRInput16GetLocalPositionERK8UnityStr4PPtrI9TransformE(i2, i6, i4, i1);
  STACKTOP = i7;
  return;
 }
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 STACKTOP = i7;
 return;
}

function __ZN9Scripting19ScriptingWrapperForEP6Object(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i1 = HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0;
 if ((i1 | 0) == (gb + 27592 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = __Z21GetManagerFromContexti(5) | 0;
  i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
  if (i2 | 0) break;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i4 = 7;
   break;
  }
 }
 if ((i4 | 0) == 7) return i1 | 0;
 i4 = __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i2, i3) | 0;
 return i4 | 0;
}

function __ZN8DateTimeC2Eiiiiii(i5, i2, i1, i6, i7, i8, i9) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i10 = 0, i11 = 0, i12 = 0;
 i10 = i2 * 365 | 0;
 i11 = (i2 | 0) / 400 | 0;
 i4 = (i2 | 0) / -100 | 0;
 i12 = (i2 | 0) / 4 | 0;
 i3 = i1 + -1 | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 if (!(i2 & 3)) if (!((i2 | 0) % 100 | 0)) i1 = ((i2 | 0) % 400 | 0 | 0) == 0; else i1 = 1; else i1 = 0;
 i11 = (i8 * 60 | 0) + (i7 * 3600 | 0) + i9 + ((i11 + -719528 + i10 + i4 + i12 + i6 + (HEAP32[gb + 73680 + ((i1 & 1) * 48 | 0) + (i3 << 2) >> 2] | 0) | 0) * 86400 | 0) | 0;
 i12 = i5;
 HEAP32[i12 >> 2] = ((i11 | 0) < 0) << 31 >> 31 & 65535;
 HEAP32[i12 + 4 >> 2] = i11;
 return;
}

function __ZN5physx8debugger8renderer15PvdUserRenderer6createERNS_19PxAllocatorCallbackEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 64, gb + 776620 | 0, gb + 776633 | 0, 343) | 0;
 HEAP32[i3 >> 2] = gb + 150452 + 8;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i3 + 16 >> 2] = gb + 776723;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = gb + 148684 + 8;
 HEAP32[i3 + 32 >> 2] = i2;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = i1;
 HEAP32[i3 + 48 >> 2] = gb + 776740;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = gb + 150532 + 8;
 return i3 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i4 = i6 + 348 | 0;
 i3 = i6 + 352 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i6 + 28 >> 2] | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i2 + 12 >> 2] = 0;
  __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_(i4, i1, i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i6 + 540 >> 2] = 0;
 i6 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = i6 + (i1 << 4);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb(i2, i4, i6, i7, i8, i9, i3, i5, i1, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11;
 HEAP32[i12 >> 2] = gb + 84832 + 8;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i4;
 i10 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i4, i12, i3, i5, HEAP8[i1 >> 0] | 0, i6, i7, i8, i9, i10) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN4FMOD6System19getSoftwareChannelsEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869625;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869625;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869625;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System19getHardwareChannelsEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869400;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869400;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869400;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System19getGeometrySettingsEPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869380;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869380;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869380;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN27AnimationLayerMixerPlayable6Memory21DestroyNodeStateArrayERN7mecanim6memory9AllocatorE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = i3 + 12 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i2);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i3 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18UnityConnectClientC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 189004 + 8;
 i3 = i1 + 680 | 0;
 HEAP32[i3 >> 2] = gb + 189004 + 68;
 i2 = i1 + 688 | 0;
 __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE(i1, i2);
 HEAP32[i1 >> 2] = gb + 189004 + 8;
 HEAP32[i3 >> 2] = gb + 189004 + 68;
 __ZN11UnityEngine7Connect16PersistentValuesC2Ev(i2);
 HEAP32[i1 + 772 >> 2] = 0;
 HEAP32[i1 + 776 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 780 >> 2] = 0;
 HEAP32[i1 + 768 >> 2] = i1 + 772;
 HEAP8[i1 + 785 >> 0] = 0;
 HEAP8[i1 + 788 >> 0] = 0;
 HEAP8[i1 + 789 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = gb + 1042554;
 __ZN18UnityConnectClient23RegisterGlobalCallbacksEv(i1);
 return;
}

function __ZN17PersistentManager38SerializedObjectIdentifierToInstanceIDERK26SerializedObjectIdentifier(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1165896 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1165896 | 0, i1);
  i2 = gb + 1165896 | 0;
 } else i2 = 0;
 i1 = __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(HEAP32[i3 + 56 >> 2] | 0, i4) | 0;
 if (!i2) {
  STACKTOP = i5;
  return i1 | 0;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN13GfxDeviceGLES12PresentFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 717 >> 0] | 0)) {
  __ZN11ContextGLES7PresentEv();
  STACKTOP = i3;
  return;
 }
 __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, 0);
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi(i1 + 4620 | 0, 16384, i2, 1, Math_fround(0.0), 0);
 __ZN11ContextGLES7PresentEv();
 STACKTOP = i3;
 return;
}

function __ZN11AudioFilter23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 853489 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 2012 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 1748 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 1484 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 876 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 876 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z36RegisterModuleClasses_TerrainPhysicsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 1110;
 HEAP32[i2 + 8 >> 2] = gb + 1016757;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 154;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 151564;
 HEAP32[i2 + 44 >> 2] = fb + 357;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 358;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_lod_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 8 | 0;
 i3 = i1;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161208 | 0, gb + 425282 | 0, 0, 0);
 i6 = gb + 63536 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN17UniqueIDGeneratorC2E10MemLabelId(gb + 1161220 | 0, i2);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546312 | 0, fb + 3385 | 0, fb + 3386 | 0, 0, 0);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_platformdependent_webgl_source_lump_cpp() {
 HEAP32[gb + 1103764 >> 2] = 0;
 HEAP32[gb + 1103764 + 4 >> 2] = 0;
 HEAP32[gb + 1103764 + 8 >> 2] = 0;
 HEAP32[gb + 1100512 >> 2] = 0;
 HEAP32[gb + 1103732 + 4 >> 2] = 0;
 HEAP32[gb + 1103732 + 8 >> 2] = 0;
 HEAP32[gb + 1103732 >> 2] = gb + 1103732 + 4;
 HEAP32[gb + 1103776 >> 2] = 0;
 HEAP32[gb + 1103776 + 4 >> 2] = 0;
 HEAP32[gb + 1103776 + 8 >> 2] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544204 | 0, fb + 3291 | 0, fb + 3292 | 0, 0, 0);
 HEAP32[gb + 1103752 >> 2] = 0;
 HEAP32[gb + 1103752 + 4 >> 2] = 0;
 HEAP32[gb + 1103752 + 8 >> 2] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544205 | 0, fb + 3293 | 0, fb + 3294 | 0, 0, 0);
 return;
}

function mftCall_iiiiiiiiiiffffii(i16, i1, i2, i8, i9, i10, i11, i12, i13, i14, d15, d3, d4, d5, i6, i7) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 d15 = +d15;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i16 | 0) >= (fb | 0) & (i16 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiiiiiiffffii[i16 - fb & 3](i1 | 0, i2 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, Math_fround(d15), Math_fround(d3), Math_fround(d4), Math_fround(d5), i6 | 0, i7 | 0) | 0;
 return ftCall_iiiiiiiiiiffffii(i16 | 0, i1 | 0, i2 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, +d15, +d3, +d4, +d5, i6 | 0, i7 | 0) | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK7b2World7RayCastEP17b2RayCastCallbackRK6b2Vec2S4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 24 | 0;
 i6 = i5;
 i1 = i1 + 102872 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAPF32[i6 + 16 >> 2] = Math_fround(1.0);
 i8 = i3;
 i3 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i4;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i6 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 __ZNK13b2DynamicTree7RayCastI21b2WorldRayCastWrapperEEvPT_RK14b2RayCastInput(i1, i7, i6);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Cm17FreeListAllocator8allocateEjPKcS3_i(i5, i4, i1, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i4) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = (i4 + 19 | 0) >>> 4;
 i1 = (i1 | 0) == 0 ? 1 : i1;
 if (i1 >>> 0 > 1023) {
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i5 = (mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 + 16 | 0, 0, gb + 732730 | 0, 82) | 0) + 16 | 0;
  i3 = i5;
  HEAP32[i3 + -4 >> 2] = 16;
  HEAP32[i3 + -8 >> 2] = i4;
  return i5 | 0;
 } else {
  i4 = i5 + 12 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
  i5 = __ZN5physx2Cm17FreeListAllocator10allocChunkEj(i5, i1) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
  return i5 | 0;
 }
 return 0;
}

function __ZN5physx14PxsAABBManager28setAggregateElemVolumeBoundsEjRKNS_11IntegerAABBE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = (HEAP32[i3 + 300 >> 2] | 0) + (i1 * 24 | 0) | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 i4 = HEAP32[(HEAP32[i3 + 260 >> 2] | 0) + ((HEAP32[(HEAP32[i3 + 312 >> 2] | 0) + (i1 << 2) >> 2] | 0) >>> 1 << 2) >> 2] | 0;
 i1 = (HEAP32[i3 + 356 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << (i4 & 31);
 if (i2 & i3 | 0) return;
 HEAP32[i1 >> 2] = i2 | i3;
 return;
}

function __ZN4FMOD7Channel7getMuteEPb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP8[i3 >> 0] = HEAP8[i2 + 160 >> 0] | 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 868211;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System19setHardwareChannelsEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869856;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869856;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869856;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System10getDSPHeadEPPNS_3DSPE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 857610;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 857610;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857610;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD5Sound11getUserDataEPPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 4 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN22UnityAnalyticsSettingsD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189312 + 8;
 i1 = i2 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 40 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN19RuntimeSceneManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 66432 + 8;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i2 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 48 | 0;
 if ((HEAP32[i2 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 24 | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 28 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 4 | 0;
 if ((HEAP32[i2 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN19RuntimeSceneManagerD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 66432 + 8;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i2 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 48 | 0;
 if ((HEAP32[i2 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 24 | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 28 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 20 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 4 >> 2] | 0, i2 + 8 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN19MeshParticleEmitterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i6;
 return;
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 852 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 852 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetOuterUVP12Il2CppObjectR8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK6Sprite11GetOuterUVsEb(i3, i4, 1);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetInnerUVP12Il2CppObjectR8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK6Sprite11GetInnerUVsEb(i3, i4, 1);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z13RegisterClassI24OcclusionCullingSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28456;
 HEAP32[i2 + 4 >> 2] = fb + 541;
 HEAP32[i2 + 8 >> 2] = gb + 379149;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 29;
 HEAP32[i2 + 20 >> 2] = 88;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 35088;
 HEAP32[i2 + 44 >> 2] = fb + 23;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 24;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _cycle(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 L1 : do if ((i5 | 0) >= 2) {
  i6 = i4 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i2;
  if (i1 | 0) while (1) {
   i3 = i1 >>> 0 > 256 ? 256 : i1;
   _memcpy(i2 | 0, HEAP32[i4 >> 2] | 0, i3 | 0) | 0;
   i2 = 0;
   do {
    i8 = i4 + (i2 << 2) | 0;
    i2 = i2 + 1 | 0;
    _memcpy(HEAP32[i8 >> 2] | 0, HEAP32[i4 + (i2 << 2) >> 2] | 0, i3 | 0) | 0;
    HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + i3;
   } while ((i2 | 0) != (i5 | 0));
   i1 = i1 - i3 | 0;
   if (!i1) break L1;
   i2 = HEAP32[i6 >> 2] | 0;
  }
 } while (0);
 STACKTOP = i7;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEESt16initializer_listIwE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (HEAP32[i3 + 4 >> 2] << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i3 = __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertIPKwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPwEEE4typeENSB_IS8_EESA_SA_(i1, i5, i2, i3) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i7, i2, i3, i5, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i5, i4, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) {
  if ((i1 | 0) < 69) i1 = i1 + 2e3 | 0; else i1 = (i1 | 0) < 100 ? i1 + 1900 | 0 : i1;
  HEAP32[i7 >> 2] = i1 + -1900;
 }
 STACKTOP = i6;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i7, i2, i3, i5, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i5, i4, 4) | 0;
 if (!(HEAP32[i5 >> 2] & 4)) {
  if ((i1 | 0) < 69) i1 = i1 + 2e3 | 0; else i1 = (i1 | 0) < 100 ? i1 + 1900 | 0 : i1;
  HEAP32[i7 >> 2] = i1 + -1900;
 }
 STACKTOP = i6;
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i11 = i7 + 4 | 0;
 i10 = i7;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_(i1, i9, i8, i4, i5, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 12 | 0;
 i1 = i1 + 16 | 0;
 L1 : do if ((HEAP32[i3 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) i1 = 0; else {
  HEAP32[i2 >> 2] = i4;
  i2 = __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj(i5 + 4 | 0, i2, 4) | 0;
  i3 = HEAP32[i3 >> 2] | 0;
  i1 = i3 + (((i2 >>> 0) % ((HEAP32[i1 >> 2] | 0) - i3 >> 2 >>> 0) | 0) << 2) | 0;
  while (1) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break L1;
   }
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break L1;
   i1 = i1 + 4 | 0;
  }
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEii(i1, i2, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i7 | 0) == (i1 | 0)) {
  i9 = -1;
  return i9 | 0;
 }
 i4 = (i1 - i7 | 0) / 12 | 0;
 i2 = 2147483647;
 i1 = 0;
 i3 = 0;
 while (1) {
  i5 = i8 - (HEAP32[i7 + (i3 * 12 | 0) >> 2] | 0) | 0;
  i6 = i9 - (HEAP32[i7 + (i3 * 12 | 0) + 4 >> 2] | 0) | 0;
  i5 = ((i6 | 0) < 0 ? 0 - i6 | 0 : i6) + ((i5 | 0) < 0 ? 0 - i5 | 0 : i5) | 0;
  i6 = (i5 | 0) < (i2 | 0);
  i1 = i6 ? i3 : i1;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i4 >>> 0) break; else i2 = i6 ? i5 : i2;
 }
 return i1 | 0;
}

function __ZN9Transform23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1044255 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Transform8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN7Texture23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 609266 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhdE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +(HEAPU8[i1 >> 0] | 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 2, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5audio5mixer16GetSnapshotIndexERNS0_18AudioMixerConstantEPKc(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = _strlen(i1) | 0;
 i3 = i1 + i4 | 0;
 if ((i4 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i4 = ~i2;
 } else i4 = 0;
 i1 = i5 + 36 | 0;
 i3 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i3) {
  i5 = -1;
  return i5 | 0;
 }
 i2 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 28 | 0) >> 2] | 0) == (i4 | 0)) {
   i2 = 8;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN4gles12AddDepthBiasER15DeviceStateGLESPK17DeviceRasterStateff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i2 = (i2 | 0) == 0 ? HEAP32[i1 + 472 >> 2] | 0 : i2;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = i6 + 4 | 0;
 HEAP32[i2 >> 2] = ~~Math_fround(Math_fround(HEAP32[i2 >> 2] | 0) + f3);
 i2 = i6 + 8 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) + f4);
 i2 = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i1, i6) | 0;
 STACKTOP = i5;
 return i2 | 0;
}

function __ZN4FMOD6System17getOutputByPluginEPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869506;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869506;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869506;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System17getNumCDROMDrivesEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869474;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869474;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869474;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System17getNetworkTimeoutEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869456;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869456;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869456;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System17get3DNumListenersEPi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869267;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869267;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869267;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1012675 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN2UI6Canvas8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15LightProbeGroupC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 43164 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN14GfxContextGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 i3 = i1 + 12 | 0;
 while (1) {
  if ((HEAP32[i2 + 16 >> 2] | 0) != (HEAP32[i3 >> 2] | 0)) __ZN18GfxFramebufferGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES((HEAP32[i2 + 20 >> 2] | 0) + 8 | 0, i4);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN12IFileAdapter5CloseER13FileEntryData(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 do if (!(HEAP8[i5 + 16 >> 0] | 0)) {
  i3 = 1;
  i2 = i6 + 1052 | 0;
  i1 = i5 + 8 | 0;
 } else {
  i2 = i6 + 1052 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0) | 0;
  i1 = i5 + 8 | 0;
  if (!i4) {
   __Z19free_alloc_internalPvRK10MemLabelId(0, i1);
   break;
  } else {
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i1);
   break;
  }
 } while (0);
 mftCall_vi(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i6 + 1044 >> 2] = 0;
 return i3 | 0;
}

function __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 876 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z49Rigidbody2D_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D16AddRelativeForceERK8Vector2fNS_9ForceModeE(i5, i4, i3);
  STACKTOP = i6;
  return;
 }
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 896 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 896 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 824 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetPaddingP12Il2CppObjectR8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK6Sprite10GetPaddingEb(i3, i4, 1);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z38Transform_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Transform11GetRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z38Rigidbody_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Rigidbody11GetRotationEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z32PlatformGetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i2, 47, -1) | 0;
 if ((i3 | 0) == -1) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
  return;
 } else {
  i5 = HEAP8[i2 + 11 >> 0] | 0;
  i6 = i5 << 24 >> 24 < 0;
  i4 = (i6 ? HEAP32[i2 >> 2] | 0 : i2) + (i3 + 1) | 0;
  i3 = (i6 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) + ~i3 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, i3);
  return;
 }
}

function __Z13RegisterClassIN13TextRendering4FontEEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 1001;
 HEAP32[i2 + 8 >> 2] = gb + 945895;
 HEAP32[i2 + 12 >> 2] = gb + 946830;
 HEAP32[i2 + 16 >> 2] = 128;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 64868;
 HEAP32[i2 + 44 >> 2] = fb + 332;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 333;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18AnimatorControllerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 178436;
 HEAP32[i2 + 4 >> 2] = fb + 948;
 HEAP32[i2 + 8 >> 2] = gb + 902391;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 91;
 HEAP32[i2 + 20 >> 2] = 212;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 178256;
 HEAP32[i2 + 44 >> 2] = fb + 304;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 305;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UNITY_png_crc_error(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 208 >> 2] | 0;
 if (!(HEAP32[i1 + 372 >> 2] & 536870912)) {
  HEAP32[i1 + 656 >> 2] = 129;
  _UNITY_png_read_data(i1, i2, 4);
  if (i3 & 2048 | 0) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 } else {
  HEAP32[i1 + 656 >> 2] = 129;
  _UNITY_png_read_data(i1, i2, 4);
  if ((i3 & 768 | 0) == 768) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 i3 = ((HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0) | 0) != (HEAP32[i1 + 408 >> 2] | 0) & 1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEESt16initializer_listIcE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = i2 + (HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 i3 = __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPcEEE4typeENSB_IS8_EESA_SA_(i1, i5, i2, i3) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9Texture3D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 411365 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Texture3D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9Texture2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 411078 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Texture2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 465927 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9TextAsset8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9ShaderLab9SubShaderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = i1 + 28;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i1 + 48 >> 0] = 1;
 HEAP32[i1 + 52 >> 2] = -1;
 HEAP32[i1 + 56 >> 2] = -1;
 STACKTOP = i2;
 return;
}

function __ZN9Rigidbody23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 737574 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Rigidbody8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9Projector23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 380711 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Projector8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 373687 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9LensFlare8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9Behaviour23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 391094 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9AudioClip23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 856797 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9AudioClip8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN9Animation23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 896226 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN9Animation8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN7dtCrowd9moveAgentERK13dtCrowdHandlePKf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = i4 + (i2 * 608 | 0) | 0;
 __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter(i5, i3, HEAP32[i1 + 464 >> 2] | 0, (HEAP32[i1 + 24 >> 2] | 0) + (i2 * 132 | 0) | 0);
 i3 = i4 + (i2 * 608 | 0) + 480 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + (i2 * 608 | 0) + 484 >> 2] = HEAP32[i4 + (i2 * 608 | 0) + 4 >> 2];
 HEAP32[i4 + (i2 * 608 | 0) + 488 >> 2] = HEAP32[i4 + (i2 * 608 | 0) + 8 >> 2];
 __ZNK15HeightMeshQuery17SetPositionHeightEPf(HEAP32[i1 + 468 >> 2] | 0, i3) | 0;
 HEAPF32[i4 + (i2 * 608 | 0) + 552 >> 2] = Math_fround(-1.0);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIadE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAPF64[tempDoublePtr >> 3] = +(HEAP8[i1 >> 0] | 0);
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  HEAP8[i2 + 4 >> 0] = HEAP8[tempDoublePtr + 4 >> 0];
  HEAP8[i2 + 5 >> 0] = HEAP8[tempDoublePtr + 5 >> 0];
  HEAP8[i2 + 6 >> 0] = HEAP8[tempDoublePtr + 6 >> 0];
  HEAP8[i2 + 7 >> 0] = HEAP8[tempDoublePtr + 7 >> 0];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN4FMOD6System17setOutputByPluginEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869910;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869910;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869910;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System17setNetworkTimeoutEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869892;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869892;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869892;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System17set3DNumListenersEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869777;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869777;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869777;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System15setNetworkProxyEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869876;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869876;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869876;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System15getOutputHandleEPPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869524;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869524;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869524;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP11getUserDataEPPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 4 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN21InheritVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034151 | 0, HEAP32[gb + 37040 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 i1 = i1 + 12 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1034203 | 0, gb + 620173 | 0, i1, 0);
 __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20BufferedSocketStreamD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 73616 + 8;
 i3 = i4 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  __ZN6SocketD2Ev(i4);
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 __ZN6SocketD2Ev(i4);
 return;
}

function __ZN14MessageHandlerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = gb + 63168 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 i2 = i1 + 44 | 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = i1 + 68;
 return;
}

function __ZN13ConstantForceC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 111996 + 8;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine9Animation30UnregisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
   if (i4 | 0) __ZN6Object11RemoveEventEPFvPvS0_iES0_(i4, fb + 914 | 0, i6);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i5 = i6 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = i6 + 20 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 * 12 | 0) >> 2] | 0;
  if (i2) {
   __ZN6Object11RemoveEventEPFvPvS0_iES0_(i2, fb + 914 | 0, i6);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper16GetApplicationIdEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc(i1, _JS_SystemInfo_GetDocumentURL(0, 0) | 0, 0);
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  _JS_SystemInfo_GetDocumentURL(i3 | 0, i2 | 0) | 0;
  return;
 } else {
  i3 = i2 & 255;
  _JS_SystemInfo_GetDocumentURL(i1 | 0, i3 | 0) | 0;
  return;
 }
}

function __ZN11OffMeshLink7SetAreaEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 88 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 i1 = i3 + 40 | 0;
 i2 = i1;
 if (!((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0)) {
  i4 = __Z17GetNavMeshManagerv() | 0;
  i2 = i1;
  __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i4, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
  i2 = i1;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 }
 __ZN11OffMeshLink13AddConnectionEv(i3);
 HEAP8[i3 + 97 >> 0] = 0;
 return;
}

function __ZN11CustomArray8StoreU32Ej(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + 12 | 0;
 if (((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  i5 = __Znwj(16) | 0;
  i4 = i5 + 4 | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
  if (!i1) {
   i3 = 0;
   i2 = 0;
  } else {
   i3 = 1;
   i2 = HEAP32[i2 >> 2] << 1;
  }
  HEAP32[i5 + 12 >> 2] = i2;
  HEAP32[i4 >> 2] = __Znaj(i2) | 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i6 >> 2] = i5;
  if (i3) {
   HEAP32[i1 >> 2] = i5;
   i1 = i5;
  } else i1 = i5;
 }
 HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) >> 2] = i7;
 i7 = i1 + 8 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + 4;
 return i6 | 0;
}

function __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 852 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z49CommandBuffer_CUSTOM_SetGlobalMatrixArrayListImplP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  HEAP32[i4 >> 2] = i2;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 64) | 0;
  __ZN22RenderingCommandBuffer23AddSetGlobalMatrixArrayERKN9ShaderLab16FastPropertyNameEPK10Matrix4x4fi(i1, i4, i5, HEAP32[i3 + 12 >> 2] | 0);
  STACKTOP = i6;
  return;
 }
}

function __Z47ParticleSystem_LightsModule_CUSTOM_GetIntensityP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 920 >> 2] | 0) + 288 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_CollisionModule_CUSTOM_GetDampenP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 904 >> 2] | 0) + 144 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z47ParticleSystem_CollisionModule_CUSTOM_GetBounceP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 904 >> 2] | 0) + 408 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z37GUILayer_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8GUILayer7HitTestERK8Vector2f(i4, i3) | 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z32PlayerConnection_CUSTOM_SendFileP12Il2CppStringP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 __Z32TransferFileOverPlayerConnectionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvjS8_j(i4, i1, i2, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z13RegisterClassI16ParticleAnimatorEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1133;
 HEAP32[i2 + 8 >> 2] = gb + 1048111;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 12;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 190916;
 HEAP32[i2 + 44 >> 2] = fb + 438;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 439;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15TerrainColliderEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32548;
 HEAP32[i2 + 4 >> 2] = fb + 1110;
 HEAP32[i2 + 8 >> 2] = gb + 1016757;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 154;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 151564;
 HEAP32[i2 + 44 >> 2] = fb + 357;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 358;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14RenderSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28456;
 HEAP32[i2 + 4 >> 2] = fb + 545;
 HEAP32[i2 + 8 >> 2] = gb + 381335;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 104;
 HEAP32[i2 + 20 >> 2] = 408;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31352;
 HEAP32[i2 + 44 >> 2] = fb + 30;
 HEAP32[i2 + 48 >> 2] = fb + 31;
 HEAP32[i2 + 52 >> 2] = fb + 32;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14PlayerSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 589;
 HEAP32[i2 + 8 >> 2] = gb + 448085;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 129;
 HEAP32[i2 + 20 >> 2] = 632;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31072;
 HEAP32[i2 + 44 >> 2] = fb + 75;
 HEAP32[i2 + 48 >> 2] = fb + 76;
 HEAP32[i2 + 52 >> 2] = fb + 77;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) < (i3 | 0)) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) < (i3 | 0)) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if (i2 >>> 0 < i3 >>> 0) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) < (i3 | 0)) {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  if ((i2 | 0) < (i3 | 0)) {
   HEAP32[i7 >> 2] = i2;
   HEAP32[i5 >> 2] = i3;
   i2 = HEAP32[i7 >> 2] | 0;
   i3 = HEAP32[i6 >> 2] | 0;
   if ((i2 | 0) < (i3 | 0)) {
    HEAP32[i6 >> 2] = i2;
    HEAP32[i7 >> 2] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 i2 = HEAP8[i4 >> 0] | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 if ((i2 & 255) < (i3 & 255)) {
  HEAP8[i5 >> 0] = i2;
  HEAP8[i4 >> 0] = i3;
  i4 = i1 + 1 | 0;
  i2 = HEAP8[i5 >> 0] | 0;
  i3 = HEAP8[i7 >> 0] | 0;
  if ((i2 & 255) < (i3 & 255)) {
   HEAP8[i7 >> 0] = i2;
   HEAP8[i5 >> 0] = i3;
   i2 = HEAP8[i7 >> 0] | 0;
   i3 = HEAP8[i6 >> 0] | 0;
   if ((i2 & 255) < (i3 & 255)) {
    HEAP8[i6 >> 0] = i2;
    HEAP8[i7 >> 0] = i3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12__invariantsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i5 << 24 >> 24 < 0;
 if (i3) {
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i2 = (HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0;
 } else {
  i1 = i5 & 255;
  i2 = 10;
 }
 do if (i1 >>> 0 > i2 >>> 0) i1 = 0; else {
  if (i3) {
   if (((HEAP32[i4 + 8 >> 2] & 2147483647) + -1 | 0) >>> 0 < 10) {
    i1 = 0;
    break;
   }
   i1 = HEAP32[i4 >> 2] | 0;
  } else i1 = i4;
  if (!i1) i1 = 0; else {
   if (i3) {
    i2 = HEAP32[i4 >> 2] | 0;
    i1 = HEAP32[i4 + 4 >> 2] | 0;
   } else {
    i2 = i4;
    i1 = i5 & 255;
   }
   i1 = (HEAP8[i2 + i1 >> 0] | 0) == 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZNK9dtNavMesh11calcTileLocEPKfPiS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, i7 = 0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i1 + 76 >> 2]);
 f6 = Math_fround(f6 / f5);
 i1 = f6 < Math_fround(-16777216.0);
 i7 = f6 > Math_fround(16777216.0);
 f6 = i7 ? Math_fround(16777216.0) : f6;
 f6 = i1 ? Math_fround(-16777216.0) : f6;
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 8 >> 2]) / f5);
 i2 = f5 < Math_fround(-16777216.0);
 i1 = f5 > Math_fround(16777216.0);
 f5 = i1 ? Math_fround(16777216.0) : f5;
 f5 = i2 ? Math_fround(-16777216.0) : f5;
 HEAP32[i3 >> 2] = ~~Math_fround(Math_floor(Math_fround(f6)));
 HEAP32[i4 >> 2] = ~~Math_fround(Math_floor(Math_fround(f5)));
 return;
}

function __ZN9dtNavMeshC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = -1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = -1;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = -1;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = -1;
 HEAP32[i1 + 56 >> 2] = 1;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 2147483647;
 HEAP32[i1 + 64 >> 2] = 2147483647;
 HEAP32[i1 + 68 >> 2] = -2147483648;
 HEAP32[i1 + 72 >> 2] = -2147483648;
 return;
}

function __ZN8Gradient13SwapColorKeysEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i6 = i1 + (i2 << 2) | 0;
 i9 = HEAP8[i6 >> 0] | 0;
 i4 = i1 + (i2 << 2) + 1 | 0;
 i7 = HEAP8[i4 >> 0] | 0;
 i11 = i1 + (i2 << 2) + 2 | 0;
 i5 = HEAP8[i11 >> 0] | 0;
 i10 = i1 + 32 + (i2 << 1) | 0;
 i2 = HEAP16[i10 >> 1] | 0;
 i8 = i1 + (i3 << 2) | 0;
 HEAP8[i6 >> 0] = HEAP8[i8 >> 0] | 0;
 i6 = i1 + (i3 << 2) + 1 | 0;
 HEAP8[i4 >> 0] = HEAP8[i6 >> 0] | 0;
 i4 = i1 + (i3 << 2) + 2 | 0;
 HEAP8[i11 >> 0] = HEAP8[i4 >> 0] | 0;
 i3 = i1 + 32 + (i3 << 1) | 0;
 HEAP16[i10 >> 1] = HEAP16[i3 >> 1] | 0;
 HEAP8[i8 >> 0] = i9;
 HEAP8[i6 >> 0] = i7;
 HEAP8[i4 >> 0] = i5;
 HEAP16[i3 >> 1] = i2;
 return;
}

function __ZN4FMOD7Channel7getModeEPj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = HEAP32[i2 + 72 >> 2];
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870065;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 28 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 187020 | 0) | 0;
 i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 >> 2] | 0, gb + 67128 | 0) | 0;
 if (!((i3 | 0) == 0 | (i3 | 0) == (i4 | 0))) return;
 if (i1 | 0) HEAP8[i1 + 200 >> 0] = 1;
 i3 = i2 + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) return;
 i2 = i2 + 80 | 0;
 i1 = 0;
 do {
  __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 return;
}

function __ZN10MeshFilter12OnDidAddMeshEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  i2 = i1 + 376 | 0;
  i3 = HEAP32[i4 + 32 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) {
   HEAP32[i2 >> 2] = i3;
   __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
  }
 }
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1106136 | 0, i5);
 STACKTOP = i6;
 return;
}

function __Z49ParticleSystem_MainModule_CUSTOM_GetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 896 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 1220 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z40Camera_Get_Custom_PropLayerCullDistancesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  i3 = __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0, 4, 32) | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  i1 = i2 + 932 | 0;
  i2 = i4 + 128 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  return i3 | 0;
 }
 return 0;
}

function __Z40Application_Get_Custom_PropInstallerNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 16 | 0;
 i2 = i4;
 __ZN15ApplicationInfo16GetInstallerNameEv(i2, __Z18GetApplicationInfov() | 0);
 i5 = i2 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = __Z20scripting_string_newPKcj(i6 ? HEAP32[i2 >> 2] | 0 : i2, i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return i3 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z31Playables_CUSTOM_CastToInternalP12Il2CppObject13Il2Cpp_IntPtri(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 if ((HEAP32[i1 + 16 >> 2] | 0) != (i3 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i1 = i1 + 20 | 0;
 __ZN9Scripting11RaiseIfNullEPv(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = __ZN8Playable6CastToEP11Il2CppClass(i1, __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i2) | 0) | 0;
 if (!i1) __ZN9Scripting25RaiseInvalidCastExceptionEPKcz(gb + 550372 | 0, i4); else {
  i3 = i1;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z26Transfer_UnityEngineObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i6 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i6) >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i5, i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __Z13RegisterClassI19SkinnedMeshRendererEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 581;
 HEAP32[i2 + 8 >> 2] = gb + 429151;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 137;
 HEAP32[i2 + 20 >> 2] = 536;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31632;
 HEAP32[i2 + 44 >> 2] = fb + 63;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 64;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18SpeedTreeWindAssetEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 611;
 HEAP32[i2 + 8 >> 2] = gb + 481702;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 228;
 HEAP32[i2 + 20 >> 2] = 1904;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31752;
 HEAP32[i2 + 44 >> 2] = fb + 84;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 85;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17Physics2DSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 876;
 HEAP32[i2 + 8 >> 2] = gb + 801731;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 19;
 HEAP32[i2 + 20 >> 2] = 188;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156440;
 HEAP32[i2 + 44 >> 2] = fb + 238;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 239;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15UnityAdsManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1118;
 HEAP32[i2 + 8 >> 2] = gb + 1037316;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 292;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188356;
 HEAP32[i2 + 44 >> 2] = fb + 392;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 393;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZThn32_N8Renderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -32 | 0;
 i3 = i2 + 36 | 0;
 i1 = HEAP16[i2 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = __ZN8Renderer12GetTransformEv(i2) | 0;
  HEAP32[i2 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i3);
  i1 = HEAP8[i2 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  i1 = i2 + 188 | 0;
  i2 = i2 + 164 | 0;
  __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i3, i2);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0);
 i1 = i2 + 188 | 0;
 i2 = i2 + 164 | 0;
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i3, i2);
 return;
}

function __ZN8WindZone23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 486986 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8WindZone8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 442476 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN8Material23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 469691 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Material8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN8LODGroup23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 425104 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8LODGroup8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN8Collider23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 906336 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Collider8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN8Animator23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 902235 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN8Animator8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN7mecanim12statemachine19GetActiveChildCountERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEjb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i4) if (HEAP8[i2 + 80 >> 0] | 0) {
  i4 = 1;
  return i4 | 0;
 }
 i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[(HEAP32[HEAP32[i1 + 12 >> 2] >> 2] | 0) + (i3 << 2) >> 2] | 0) + 8 >> 2] | 0) + 16 >> 2] | 0) + ((i4 & 1 ^ 1) << 3) + 4 >> 2] | 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 } else {
  i1 = 0;
  i2 = 0;
 }
 do {
  i1 = (Math_fround(__ZNK8Playable14GetInputWeightEi(i3, i2)) != Math_fround(0.0) & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZN5physx8debugger4comm20StreamInitialization9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 i2 = i2 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpScene9setLimitsERKNS_13PxSceneLimitsE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i3 + 3560 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i3 + 3552 | 0, i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 i6 = i3 + 32 | 0;
 i5 = i2 + 8 | 0;
 i4 = i2 + 12 | 0;
 __ZN5physx2Sc5Scene11preAllocateEjjjjj(i6, i1, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0);
 __ZN5physx2Sc5Scene9setLimitsERKNS_13PxSceneLimitsE(i6, i2);
 __ZN5physx2Sq17SceneQueryManager11preallocateEjj(i3 + 3392 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 272 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 264 >> 2] | 0;
 i3 = i1 + 268 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fEC2ERKNS0_7SwClothERNS0_11SwClothDataER14StackAllocatorILj16EERNS0_21IterationStateFactoryEPNS_13PxProfileZoneE(i6, i2, i3, i1, i4, i5) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i1;
 __ZN5physx5cloth11SwCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EEPNS_13PxProfileZoneE(i6 + 12 | 0, i3, i1, i5);
 __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EE(i6 + 460 | 0, i3, i1);
 __ZNK5physx5cloth21IterationStateFactory6createI8Scalar4fNS0_7SwClothEEENS0_14IterationStateIT_EERKT0_(i6 + 524 | 0, i4, i2);
 HEAP32[i6 + 732 >> 2] = i5;
 return;
}

function __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834127;
 HEAP32[i1 + 4 >> 2] = 663;
 HEAP32[i1 + 8 >> 2] = fb + 3940;
 HEAP32[i1 + 12 >> 2] = fb + 3941;
 HEAP32[i1 + 16 >> 2] = gb + 834138;
 HEAP32[i1 + 20 >> 2] = 664;
 HEAP32[i1 + 24 >> 2] = fb + 3942;
 HEAP32[i1 + 28 >> 2] = fb + 3943;
 HEAP32[i1 + 32 >> 2] = gb + 834148;
 HEAP32[i1 + 36 >> 2] = 665;
 HEAP32[i1 + 40 >> 2] = fb + 3944;
 HEAP32[i1 + 44 >> 2] = fb + 3945;
 HEAP32[i1 + 48 >> 2] = gb + 834159;
 HEAP32[i1 + 52 >> 2] = 666;
 HEAP32[i1 + 56 >> 2] = fb + 3946;
 HEAP32[i1 + 60 >> 2] = fb + 3947;
 HEAP32[i1 + 64 >> 2] = gb + 834171;
 HEAP32[i1 + 68 >> 2] = 686;
 HEAP32[i1 + 72 >> 2] = fb + 3953;
 HEAP32[i1 + 76 >> 2] = fb + 3954;
 return;
}

function __ZN4TreeC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 185092 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(-1.0);
 HEAP32[i1 + 40 >> 2] = 0;
 __ZN18SpeedTreeWindTimesC2Ev(i1 + 44 | 0);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD6System13setPluginPathEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869928;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869928;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869928;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 857610;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN17AudioReverbFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 68 >> 2] = Math_fround(-1.0e4);
 HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(.0399999991);
 HEAPF32[i1 + 84 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(250.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 104 >> 2] = 27;
 return;
}

function __ZN15ParticleEmitterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i1 >> 2] = gb + 190444 + 8;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 60 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -48 - i3 | 0) >>> 0) / 48 | 0) * 48 | 0);
 i5 = HEAP32[i1 + 68 >> 2] | 0;
 HEAP32[i2 >> 2] = 18;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i6;
 return;
}

function __ZN11JSONUtility17DeserializeObjectERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP11Il2CppClassS5_24TransferInstructionFlags(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = __ZL22CreateReaderFromStringPKcbRN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE24TransferInstructionFlags((i5 | 0) == 0 ? i1 + 4 | 0 : i5, i2, i3) | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = __ZN9Scripting38RuntimeCreateAndInitObjectLogExceptionEP11Il2CppClass(i4) | 0;
 __Z23TransferScriptingObjectI8JSONReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i1, i5, i4, 0);
 __ZN8JSONReadD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 return i5 | 0;
}

function __Z9PrintARGVv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if ((HEAP32[gb + 1170792 >> 2] | 0) > 0) {
  i1 = 0;
  i2 = 0;
 } else {
  STACKTOP = i5;
  return;
 }
 do {
  if (i2) _printf_console(gb + 488020 | 0, i3); else {
   HEAP32[i4 >> 2] = HEAP32[(HEAP32[gb + 1170796 >> 2] | 0) + (i1 << 2) >> 2];
   _printf_console(gb + 1076431 | 0, i4);
  }
  i2 = HEAP32[(HEAP32[gb + 1170796 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i6 = (_strcmp(i2, gb + 488030 | 0) | 0) == 0;
  i2 = i6 | (_strcmp(i2, gb + 488038 | 0) | 0) == 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[gb + 1170792 >> 2] | 0));
 STACKTOP = i5;
 return;
}

function __Z49ReflectionProbe_Set_Custom_PropCustomBakedTextureP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN15ReflectionProbe21SetCustomBakedTextureE4PPtrI7TextureE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 956 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 44 >> 2] | 0) + 692 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z37Terrain_Get_Custom_PropActiveTerrainsv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z18GetITerrainManagerv() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0) | 0;
 i4 = HEAP32[(__Z26GetTerrainScriptingClassesv() | 0) + 8 >> 2] | 0;
 i4 = __Z19scripting_array_newP11Il2CppClassjj(i4, 4, HEAP32[i5 + 8 >> 2] | 0) | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i5 | 0)) return i4 | 0; else i3 = 0;
 while (1) {
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i4, i3, __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 8 >> 2] | 0) | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i5 | 0)) break; else i3 = i3 + 1 | 0;
 }
 return i4 | 0;
}

function __Z33BillboardAsset_CUSTOM_GetVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  i1 = HEAP32[i1 + 60 >> 2] | 0;
  i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 452 >> 2] | 0;
  i1 = (i3 | 0) == 0 ? 0 : i1;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 8, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0, i3 | 0, i1 << 3 | 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z13RegisterClassIN20TextRenderingPrivate7GUITextEEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 30232;
 HEAP32[i2 + 4 >> 2] = fb + 1002;
 HEAP32[i2 + 8 >> 2] = gb + 946403;
 HEAP32[i2 + 12 >> 2] = gb + 946737;
 HEAP32[i2 + 16 >> 2] = 132;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 185592;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15NavMeshObstacleEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 906;
 HEAP32[i2 + 8 >> 2] = gb + 842436;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 208;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 168936;
 HEAP32[i2 + 44 >> 2] = fb + 262;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 263;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i2 >> 2] | 0);
 __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEOS5_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 8 + 3 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4514 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNK5physx7NpShape21getConvexMeshGeometryERNS_20PxConvexMeshGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 4) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i2 + 36 >> 2] & 1)) i2 = 4; else {
  i2 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i3 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 i3 = 1;
 return i3 | 0;
}

function __ZN18AudioMixerSnapshotC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 174840 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClientC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 190020 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 189940 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1 + 48;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = i1 + 60;
 return;
}

function __Z49CommandBuffer_CUSTOM_SetGlobalVectorArrayListImplP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  HEAP32[i4 >> 2] = i2;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 16) | 0;
  __ZN22RenderingCommandBuffer23AddSetGlobalVectorArrayERKN9ShaderLab16FastPropertyNameEPK8Vector4fi(i1, i4, i5, HEAP32[i3 + 12 >> 2] | 0);
  STACKTOP = i6;
  return;
 }
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z45ParticleSystem_TrailModule_CUSTOM_GetLifetimeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 908 >> 2] | 0) + 12 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 892 >> 2] | 0) + 536 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 892 >> 2] | 0) + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapZP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 1620 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapYP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 1356 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 888 >> 2] | 0) + 1092 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z36Camera_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK6Camera13GetCameraRectEb(i3, i4, 1);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z18IsBuiltinArrayNamePKc(i1) {
 i1 = i1 | 0;
 if (!(_strcmp(i1, HEAP32[gb + 40152 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 12 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 24 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 36 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 48 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 60 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(_strcmp(i1, HEAP32[gb + 40152 + 72 >> 2] | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (_strcmp(i1, HEAP32[gb + 40448 >> 2] | 0) | 0) == 0;
 return i1 | 0;
}

function __Z13RegisterClassI15NavMeshSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28456;
 HEAP32[i2 + 4 >> 2] = fb + 913;
 HEAP32[i2 + 8 >> 2] = gb + 844275;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 196;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 169816;
 HEAP32[i2 + 44 >> 2] = fb + 266;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 267;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__220__throw_system_errorEiPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 8 | 0;
 i5 = i1;
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215system_categoryEv() | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = gb + 1476992;
 __THREW__ = 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 invoke_viii(fb + 1062 | 0, i1 | 0, i4 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i5 | 0);
 } else ___cxa_throw(i1 | 0, gb + 12920 | 0, fb + 3205 | 0);
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK12NavMeshAgent11GetAreaCostEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 i1 = i1 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845489 | 0, 0, gb + 841797 | 0, 835, 1, 0, 0, 0);
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (i2 >>> 0 > 31) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845464 | 0, 0, gb + 841797 | 0, 839, 1, 0, 0, 0);
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 } else {
  i4 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
  f3 = Math_fround(HEAPF32[(__ZNK7dtCrowd14getAgentFilterEi(i4, HEAP32[i1 >> 2] | 0) | 0) + (i2 << 2) >> 2]);
  return Math_fround(f3);
 }
 return f0;
}

function __ZN7dtCrowd18getAgentNeighboursERK13dtCrowdHandlePS0_i(i2, i1, i9, i10) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i2 + 16 >> 2] | 0;
 i8 = i7 + (i6 * 608 | 0) + 384 | 0;
 i3 = HEAP32[i8 >> 2] | 0;
 if (!((i10 | 0) > 0 & (i3 | 0) > 0)) {
  i10 = 0;
  return i10 | 0;
 }
 i5 = HEAP32[i2 + 400 >> 2] | 0;
 i4 = 0;
 i1 = 0;
 while (1) {
  i2 = HEAP32[i7 + (i6 * 608 | 0) + 320 + (i4 << 3) >> 2] | 0;
  if ((i2 | 0) < (i5 | 0)) {
   HEAP32[i9 + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i8 >> 2] | 0;
  } else i2 = i3;
  i4 = i4 + 1 | 0;
  if (!((i4 | 0) < (i10 | 0) & (i4 | 0) < (i2 | 0))) break; else i3 = i2;
 }
 return i1 | 0;
}

function __ZN7Terrain23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 937588 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN7Terrain8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 800807 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb(i2, i4, i6, i7, i8, i9, i3, i5, i1, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11;
 HEAP32[i12 >> 2] = gb + 85340 + 8;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i4;
 i10 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i4, i12, i3, i5, HEAP8[i1 >> 0] | 0, i6, i7, i8, i9, i10) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN5Umbra9BitVector8setRangeEjj(i1, i4, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = i4 >>> 5;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) + (i6 << 2) | 0;
 i3 = i7 - i4 | 0;
 i2 = -1 << i4;
 if ((i4 | 0) == 0 | (i6 | 0) == (i7 >>> 5 | 0)) {
  i6 = i2;
  i5 = i3;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i2;
  i1 = i1 + 4 | 0;
  i6 = -1;
  i5 = i3 + (i4 | -32) | 0;
 }
 i4 = i5 >>> 5;
 if (i4 | 0) {
  i2 = i5 >>> 8;
  if (!i2) i2 = i1; else {
   _memset(i1 | 0, -1, i2 << 5 | 0) | 0;
   i2 = i1 + (i2 << 3 << 2) | 0;
  }
  i3 = i4 & 7;
  if (i3 | 0) _memset(i2 | 0, -1, i3 << 2 | 0) | 0;
 }
 i1 = i1 + (i4 << 2) | 0;
 if (!(i5 & 31)) return;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i6 & (1 << i7) + -1;
 return;
}

function __ZN4FMOD6System11getUserDataEPPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 854979;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 854979;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854979;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN19CharacterController13SetStepOffsetEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 if (f1 < Math_fround(0.0)) {
  if (!i3) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 779382 | 0, 0, gb + 734039 | 0, 652, 1, i2, 0, 0);
  f1 = Math_fround(0.0);
 }
 i2 = i3 + 88 | 0;
 if (f1 > Math_fround(HEAPF32[i2 >> 2])) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 779412 | 0, 0, gb + 734039 | 0, 658, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
  f1 = Math_fround(HEAPF32[i2 >> 2]);
 }
 HEAPF32[i3 + 84 >> 2] = f1;
 i2 = HEAP32[i3 + 60 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN16UnityAdsSettingsD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189284 + 8;
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner9readBytesEPhj(i6, i4, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = i6 + 56 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0) | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
  if (!i1) {
   i6 = 0;
   return i6 | 0;
  }
  mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 28 >> 2] | 0, i6 | 0);
  i6 = i1;
  return i6 | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 i6 = 1;
 return i6 | 0;
}

function __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i1 = i1 & 1;
 if ((i1 | 0) >= (i6 | 0)) return;
 i5 = i2 + 4 | 0;
 i3 = i3 + 4 | 0;
 i4 = i3;
 do {
  i2 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i2 | 0) {
   __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E(i2, (HEAP32[i3 >> 2] | 0) + i4 + (i1 * 40 | 0) | 0);
   __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i2, (HEAP32[i3 >> 2] | 0) + i4 + (i1 * 40 | 0) + 12 | 0);
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function __ZL19StaticDestroyShaderPv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[gb + 1166312 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1166312 >> 2] | 0, gb + 1166312 + 4 | 0);
  HEAP32[gb + 1166312 >> 2] = 0;
 }
 HEAP32[gb + 1166312 >> 2] = 0;
 HEAP32[gb + 1166312 + 12 >> 2] = 0;
 HEAP32[gb + 1166312 + 16 >> 2] = 0;
 if ((HEAP32[gb + 1166332 + 16 >> 2] | 0) <= -1) {
  HEAP32[gb + 1166332 >> 2] = 0;
  HEAP32[gb + 1166332 + 12 >> 2] = 0;
  HEAP32[gb + 1166332 + 16 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1166332 >> 2] | 0, gb + 1166332 + 4 | 0);
 HEAP32[gb + 1166332 >> 2] = 0;
 HEAP32[gb + 1166332 >> 2] = 0;
 HEAP32[gb + 1166332 + 12 >> 2] = 0;
 HEAP32[gb + 1166332 + 16 >> 2] = 0;
 return;
}

function __Z57RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustRectP12Il2CppObjectS0_R5RectTIfE(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZN2UI15PixelAdjustRectEPNS_13RectTransformEPNS_6CanvasE(i5, i2, i1);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i6;
 return;
}

function __Z36Canvas_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK2UI6Canvas12GetPixelRectEv(i3, i4);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z30RegisterModuleClasses_UnityAdsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1118;
 HEAP32[i2 + 8 >> 2] = gb + 1037316;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 292;
 HEAP32[i2 + 20 >> 2] = 28;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188356;
 HEAP32[i2 + 44 >> 2] = fb + 392;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 393;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z23CullDynamicObjectsUmbraPK4AABBPKN5Umbra15OcclusionBufferER9IndexList(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if ((HEAP16[gb + 1114428 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1114428 | 0, i1);
  i1 = gb + 1114428 | 0;
 } else i1 = 0;
 i2 = __Z9GetIUmbrav() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i6;
 return;
}

function __Z13RegisterClassI14PhysicsManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 852;
 HEAP32[i2 + 8 >> 2] = gb + 737328;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 55;
 HEAP32[i2 + 20 >> 2] = 800;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113316;
 HEAP32[i2 + 44 >> 2] = fb + 221;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 222;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14PhysicMaterialEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 851;
 HEAP32[i2 + 8 >> 2] = gb + 737107;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 134;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 113108;
 HEAP32[i2 + 44 >> 2] = fb + 215;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 216;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13AudioListenerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 175648;
 HEAP32[i2 + 4 >> 2] = fb + 930;
 HEAP32[i2 + 8 >> 2] = gb + 855855;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 81;
 HEAP32[i2 + 20 >> 2] = 144;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171468;
 HEAP32[i2 + 44 >> 2] = fb + 282;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 283;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdatePlayerCleanupCachedDatastruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1450912 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450912 | 0, i1);
  i1 = gb + 1450912 | 0;
 } else i1 = 0;
 __ZN19RenderBufferManager14GarbageCollectEi(__Z22GetRenderBufferManagerv() | 0, 15);
 i2 = HEAP32[gb + 1115296 + 428 >> 2] | 0;
 if (i2 | 0) mftCall_v(i2 | 0);
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZNK12CubemapArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i4, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = i4 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i3;
  return i6 | 0;
 }
 i8 = HEAP32[i4 + 80 >> 2] | 0;
 i4 = i4 + 88 | 0;
 i7 = Math_imul(__Z25GetBytesFromTextureFormat13TextureFormat(HEAP32[i4 >> 2] | 0) | 0, i8) | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i1, i8, i8, i7, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i1, i6);
 i6 = 1;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZN6Camera23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 1044265 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN6Camera8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb(i2, i4, i6, i7, i8, i9, i3, i5, i1, i10) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11;
 HEAP32[i12 >> 2] = gb + 85540 + 8;
 HEAP32[i12 + 4 >> 2] = i2;
 HEAP32[i12 + 8 >> 2] = i4;
 i10 = __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb(i2, i4, i12, i3, i5, HEAP8[i1 >> 0] | 0, i6, i7, i8, i9, i10) | 0;
 STACKTOP = i11;
 return i10 | 0;
}

function __ZN4FMOD6System12unloadPluginEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869969;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869969;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869969;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 854655;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 854655;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14dtPathCorridor20updateTargetPositionEyPKf(i5, i3, i4, i6) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i5 + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = (HEAP32[i5 + 28 >> 2] | 0) + (i1 + -1 << 3) | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 }
 if (!((i1 | 0) == (i3 | 0) & (i2 | 0) == (i4 | 0))) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[i5 + 48 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 if ((i1 | 0) != (HEAP32[(HEAP32[i5 + 24 >> 2] | 0) + 56 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i5 + 12 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 16 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i6 + 8 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN13OcclusionArea7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(60, i1, 16, gb + 1048932 | 0, 0, gb + 380327 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = gb + 34748 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13MonoBehaviour19GetDebugDescriptionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 8 | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 __ZN13MonoBehaviour18GetScriptClassNameEv(i3, i2);
 i2 = i3 + 11 | 0;
 i6 = (HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 HEAP32[i4 >> 2] = i7;
 HEAP32[i4 + 4 >> 2] = i6;
 __Z6FormatPKcz(i1, gb + 457426 | 0, i4);
 if ((HEAP8[i2 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i7 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i6;
 __Z19free_alloc_internalPvRK10MemLabelId(i7, i4);
 STACKTOP = i5;
 return;
}

function __ZN12EventManager11RemoveEventEP10EventEntryPFvPvS2_iES2_(i7, i1, i4, i5) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i8 = 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 } else {
  i6 = i1;
  i3 = 0;
 }
 while (1) {
  if ((HEAP32[i6 + 8 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i6 >> 2] | 0) == (i5 | 0)) break;
  i2 = HEAP32[i6 + 4 >> 2] | 0;
  if (!i2) {
   i8 = 10;
   break;
  } else {
   i3 = i6;
   i6 = i2;
  }
 }
 if ((i8 | 0) == 10) return i1 | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i8 = i6 + 12 | 0;
 HEAP32[i8 >> 2] = (HEAP32[i8 >> 2] | 0) + -1;
 if (!(HEAP32[i8 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i7, i6);
 if (i3 | 0) HEAP32[i3 + 4 >> 2] = i2;
 i8 = (i6 | 0) == (i1 | 0) ? i2 : i1;
 return i8 | 0;
}

function __ZN11OffMeshLink13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i2, i1);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 i1 = i2 + 40 | 0;
 i3 = i1;
 if (!((HEAP32[i3 >> 2] | 0) == 0 & (HEAP32[i3 + 4 >> 2] | 0) == 0)) {
  i4 = __Z17GetNavMeshManagerv() | 0;
  i3 = i1;
  __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i4, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
  i3 = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 }
 __ZN11OffMeshLink13AddConnectionEv(i2);
 HEAP8[i2 + 97 >> 0] = 0;
 return;
}

function __ZN11NavMeshPath15ReservePolygonsEi(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = (i1 + 31 | 0) / 32 | 0;
 i2 = i1 << 5;
 i3 = i6 + 8 | 0;
 i4 = i6 + 24 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i1 << 8, 8, i6 + 12 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 8, 8, i6 + 12 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i6 + 20 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetPositionR9HPlayableR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  __ZN23AnimationOffsetPlayable11GetPositionEv(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  STACKTOP = i4;
  return;
 }
}

function __Z49Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatricesP12Il2CppObjectRK10Matrix4x4fS3_(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f(i2, 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f(i1, 1, i4);
  return;
 }
}

function __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 892 >> 2] | 0) + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z43ParticleSystem_LightsModule_CUSTOM_GetRangeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, (HEAP32[i1 + 920 >> 2] | 0) + 24 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i2, 47, -1) | 0;
 i4 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i2, 46, -1) | 0;
 if ((i4 | 0) != -1) if ((i3 | 0) == -1 | i4 >>> 0 > i3 >>> 0) {
  i3 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3, i4);
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
 return;
}

function __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2) | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0, i1 | 0) | 0;
 i2 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2) | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN23AllocationRootReference15RemoveReferenceEP24ProfilerAllocationHeaderj(i2, i1, i4);
 if (!i3) return;
 __ZN23AllocationRootReference12AddReferenceEP24ProfilerAllocationHeaderj(i3, i1, i4);
 return;
}

function __Z13RegisterClassI16GraphicsSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 533;
 HEAP32[i2 + 8 >> 2] = gb + 373756;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 30;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30192;
 HEAP32[i2 + 44 >> 2] = fb + 12;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 13;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13AnimationClipEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 176524;
 HEAP32[i2 + 4 >> 2] = fb + 947;
 HEAP32[i2 + 8 >> 2] = gb + 897916;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 74;
 HEAP32[i2 + 20 >> 2] = 296;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 65780;
 HEAP32[i2 + 44 >> 2] = fb + 302;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 303;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12NavMeshAgentEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 905;
 HEAP32[i2 + 8 >> 2] = gb + 842251;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 195;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 168976;
 HEAP32[i2 + 44 >> 2] = fb + 260;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 261;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UNITY_png_set_filler(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 L4 : do if (!(HEAP32[i1 + 204 >> 2] & 32768)) switch (HEAP8[i1 + 431 >> 0] | 0) {
 case 2:
  {
   HEAP8[i1 + 436 >> 0] = 4;
   break L4;
  }
 case 0:
  {
   if ((HEAPU8[i1 + 432 >> 0] | 0) > 7) {
    HEAP8[i1 + 436 >> 0] = 2;
    break L4;
   }
   _UNITY_png_app_error(i1, gb + 354626 | 0);
   return;
  }
 default:
  {
   _UNITY_png_app_error(i1, gb + 354682 | 0);
   return;
  }
 } else HEAP16[i1 + 440 >> 1] = i2; while (0);
 i2 = i1 + 212 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 32768;
 i1 = i1 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == 1) {
  HEAP32[i1 >> 2] = i2 | 128;
  return;
 } else {
  HEAP32[i1 >> 2] = i2 & -129;
  return;
 }
}

function ___fseeko_unlocked(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if ((i5 | 0) == 1) i1 = i1 - (HEAP32[i4 + 8 >> 2] | 0) + (HEAP32[i4 + 4 >> 2] | 0) | 0;
 i2 = i4 + 20 | 0;
 i3 = i4 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) {
  mftCall_iiii(HEAP32[i4 + 36 >> 2] | 0, i4 | 0, 0, 0) | 0;
  if (!(HEAP32[i2 >> 2] | 0)) i1 = -1; else i6 = 5;
 } else i6 = 5;
 if ((i6 | 0) == 5) {
  HEAP32[i4 + 16 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  if ((mftCall_iiii(HEAP32[i4 + 40 >> 2] | 0, i4 | 0, i1 | 0, i5 | 0) | 0) < 0) i1 = -1; else {
   HEAP32[i4 + 8 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -17;
   i1 = 0;
  }
 }
 return i1 | 0;
}

function __ZNK9Heightmap10GetHeightsEiiiiPf(i1, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i11 = 0, i12 = 0;
 i11 = (HEAP32[i1 + 16 >> 2] | 0) + -1 | 0;
 if (!((i8 | 0) > 0 & (i9 | 0) > 0)) return;
 i5 = HEAP32[i1 + 76 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = 0;
 do {
  i4 = Math_imul(i5, i2 + i6 | 0) | 0;
  i1 = 0;
  do {
   i12 = i1 + i7 + i4 | 0;
   HEAPF32[i10 + ((Math_imul(i1, i8) | 0) + i2 << 2) >> 2] = Math_fround(Math_fround(HEAP16[i3 + ((i12 >>> 0 > i11 >>> 0 ? i11 : i12) << 1) >> 1] | 0) * Math_fround(.0000305194408));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i9 | 0));
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i8 | 0));
 return;
}

function __ZN6Sprite23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 410464 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN6Sprite8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN6Shader23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 609205 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN6Shader8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN6Avatar23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 905757 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN6Avatar8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 4) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 4) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu17RadixSortBuffered6ResizeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 32 >> 0] | 0)) {
  STACKTOP = i3;
  return 1;
 }
 i4 = i2 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 3 | 0, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 2 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i2 = i1 << 2;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 1 | 0, i2, gb + 657536 | 0, 53) | 0;
 HEAP32[i4 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i2, gb + 657536 | 0, 54) | 0;
 STACKTOP = i3;
 return 1;
}

function __ZN5physx20PxsParticleSystemSim24setCollisionCacheInvalidERKNS_16PxsParticleShapeERKNS_2Gu13GeometryUnionE(i2, i1, i9) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i1 + 44 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 48 >> 2] | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 i6 = (HEAP32[i6 + 8 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= i6 >>> 0) return;
 i7 = HEAP32[i2 + 36 >> 2] | 0;
 i5 = i2 + 60 | 0;
 do {
  i2 = HEAP32[i7 + (i1 << 2) >> 2] | 0;
  i3 = i8 + (i2 << 5) + 30 | 0;
  i4 = HEAP16[i3 >> 1] | 0;
  if (i4 & 48) if ((HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 5) + 28 >> 2] | 0) == (i9 | 0)) HEAP16[i3 >> 1] = i4 & 65487;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function __ZN5physx10writeChunkEaaaaRNS_14PxOutputStreamE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i6 + 3 | 0;
 i9 = i6 + 2 | 0;
 i8 = i6 + 1 | 0;
 i7 = i6;
 HEAP8[i10 >> 0] = i1;
 HEAP8[i9 >> 0] = i2;
 HEAP8[i8 >> 0] = i3;
 HEAP8[i7 >> 0] = i4;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i10 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i9 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i8 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i7 | 0, 1) | 0;
 STACKTOP = i6;
 return;
}

function __ZN4FMOD12ChannelGroup14getNumChannelsEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862532;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI14CanvasRendererD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 186892 + 8;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i2 + 132 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 120 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 96 | 0;
 if ((HEAP32[i2 + 112 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 100 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 76 | 0;
 if ((HEAP32[i2 + 92 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = gb + 29060 + 8;
  HEAP32[i2 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 80 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 29060 + 8;
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11SoundHandle20UnbindFromSampleClipEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[i3 >> 2] = i2;
 __ZN10SampleClip14ReleaseIfEqualE11SoundHandle(i1, i3);
 __ZN11SoundHandleD2Ev(i3);
 STACKTOP = i4;
 return;
}

function __Z54SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByBuildIndexiRi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if ((i1 | 0) >= 0) {
  i5 = __Z16GetBuildSettingsv() | 0;
  if (((HEAP32[i5 + 32 >> 2] | 0) - (HEAP32[i5 + 28 >> 2] | 0) >> 4 | 0) > (i1 | 0)) {
   i1 = __ZN19RuntimeSceneManager21FindSceneByBuildIndexEi(__Z15GetSceneManagerv() | 0, i1) | 0;
   if (!i1) {
    i5 = 0;
    HEAP32[i3 >> 2] = i5;
    STACKTOP = i4;
    return;
   }
   i5 = HEAP32[i1 + 8 >> 2] | 0;
   HEAP32[i3 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 }
 HEAP32[i2 >> 2] = i1;
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 561668 | 0, i2);
}

function __Z33TerrainData_CUSTOM_GetDetailLayerP12Il2CppObjectiiiii(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i8 = __Z22scripting_array_new_2dP11Il2CppClassjjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 80 >> 2] | 0, 4, i6, i5) | 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i8 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i8);
 } else {
  __ZNK14DetailDatabase8GetLayerEiiiiiPi(i3 + 128 | 0, i2, i4, i5, i6, i7, __Z27scripting_array_element_ptrP11Il2CppArrayij(i8, 0, 4) | 0);
  return i8 | 0;
 }
 return 0;
}

function __Z13RegisterClassI12AudioManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 932;
 HEAP32[i2 + 8 >> 2] = gb + 855932;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 11;
 HEAP32[i2 + 20 >> 2] = 304;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171808;
 HEAP32[i2 + 44 >> 2] = fb + 285;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 286;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11AudioSourceEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 175648;
 HEAP32[i2 + 4 >> 2] = fb + 936;
 HEAP32[i2 + 8 >> 2] = gb + 867588;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 82;
 HEAP32[i2 + 20 >> 2] = 552;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171656;
 HEAP32[i2 + 44 >> 2] = fb + 290;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 291;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z10DestripifyIttEvPKT_iPT0_i(i8, i1, i9, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + -2 | 0;
 i6 = 0;
 i1 = 0;
 L1 : while (1) {
  while (1) {
   if ((i1 | 0) >= (i7 | 0)) break L1;
   i4 = HEAP16[i8 + (i1 << 1) >> 1] | 0;
   i5 = i1 + 1 | 0;
   i2 = HEAP16[i8 + (i5 << 1) >> 1] | 0;
   i3 = HEAP16[i8 + (i1 + 2 << 1) >> 1] | 0;
   if (i2 << 16 >> 16 == i3 << 16 >> 16 | (i4 << 16 >> 16 == i2 << 16 >> 16 ? 1 : i4 << 16 >> 16 == i3 << 16 >> 16)) i1 = i5; else break;
  }
  i1 = (i1 & 1 | 0) == 0;
  HEAP16[i9 + (i6 << 1) >> 1] = i1 ? i4 : i2;
  HEAP16[i9 + (i6 + 1 << 1) >> 1] = i1 ? i2 : i4;
  HEAP16[i9 + (i6 + 2 << 1) >> 1] = i3;
  i6 = i6 + 3 | 0;
  i1 = i5;
 }
 return;
}

function __ZN4FMOD6System10recordStopEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869740;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869740;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869740;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN15DirectorManager14ConnectionPool14InitializePoolEjf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 HEAP32[i1 + 48 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = __Z22CreateMutexLockedStackv() | 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAPF32[i1 >> 2] = f3;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN13MemoryManager23GetTotalAllocatedMemoryEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 1556 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 i3 = i4 + 1544 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i5 = HEAP32[i4 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = 0;
 do {
  i2 = HEAP32[i4 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 512);
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager31ArchiveAndResetSessionContainerERNS0_16SessionContainerE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 552 | 0;
 if ((HEAPU16[i3 + 104 >> 1] | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 4;
 HEAP8[i3 + 92 >> 0] = 0;
 HEAP8[i3 + 91 >> 0] = 0;
 if (HEAP8[i3 + 89 >> 0] | 0) __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i3) | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 do if (i1 | 0) {
  if ((HEAP32[i2 >> 2] | 0) != 1) if ((HEAP32[i2 >> 2] | 0) != 2) break;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i3 | 0);
 } while (0);
 if (HEAP8[i3 + 90 >> 0] | 0) return;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i3);
 return;
}

function __Z13RegisterClassI23CloudWebServicesManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1130;
 HEAP32[i2 + 8 >> 2] = gb + 1046572;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 301;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 189852;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15QualitySettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 562;
 HEAP32[i2 + 8 >> 2] = gb + 405349;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 47;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32192;
 HEAP32[i2 + 44 >> 2] = fb + 42;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 43;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11TerrainDataEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 995;
 HEAP32[i2 + 8 >> 2] = gb + 932069;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 156;
 HEAP32[i2 + 20 >> 2] = 368;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 66968;
 HEAP32[i2 + 44 >> 2] = fb + 316;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 317;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10SampleClipEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 925;
 HEAP32[i2 + 8 >> 2] = gb + 853549;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 271;
 HEAP32[i2 + 20 >> 2] = 128;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170496;
 HEAP32[i2 + 44 >> 2] = fb + 278;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 279;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _coshf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 do if (i2 >>> 0 < 1060205079) if (i2 >>> 0 < 964689920) f1 = Math_fround(1.0); else {
  f1 = Math_fround(_expm1f(f1));
  f1 = Math_fround(Math_fround(Math_fround(f1 * f1) / Math_fround(Math_fround(f1 + Math_fround(1.0)) * Math_fround(2.0))) + Math_fround(1.0));
 } else if (i2 >>> 0 < 1118925335) {
  f1 = Math_fround(+Math_exp(+f1));
  f1 = Math_fround(Math_fround(f1 + Math_fround(Math_fround(1.0) / f1)) * Math_fround(.5));
  break;
 } else {
  f1 = Math_fround(___expo2f(f1));
  break;
 } while (0);
 return Math_fround(f1);
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEOS5_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 8 + 3 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP32[HEAP32[i2 >> 2] >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP32[i2 >> 2] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4514 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEOS5_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNK11TerrainData7HasUserEP10GameObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 if (!i1) i7 = 0; else i7 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i2 + 352 >> 2] | 0;
 i6 = HEAP32[i2 + 356 >> 2] | 0;
 i1 = i6 - i5 >> 2;
 i2 = i5;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) != (i6 | 0)) if ((i7 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  i8 = i1;
  i8 = (i8 | 0) != (i6 | 0);
  return i8 | 0;
 }
 i8 = i6;
 i8 = (i8 | 0) != (i6 | 0);
 return i8 | 0;
}

function __ZN9GfxDevice19ResetDynamicBuffersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = HEAP32[i3 + 4516 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) do {
  i2 = (i1 | 0) == 0 ? 0 : i1 + -4 | 0;
  if (((HEAP32[i2 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 i3 = HEAP32[i3 + 4520 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i2 = (i1 | 0) == 0 ? 0 : i1 + -4 | 0;
  if (((HEAP32[i2 + 16 >> 2] | 0) + -1 | 0) >>> 0 < 2) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5Light23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 374193 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Light8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN5Flare23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 373565 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN5Flare8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN4FMOD7Channel10getDSPHeadEPPNS_3DSPE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 857610;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD12ChannelGroup12getNumGroupsEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862498;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13MemoryManager22GetTotalReservedMemoryEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 1556 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 i3 = i4 + 1544 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i2 = 0;
  do {
   i5 = HEAP32[i4 + 1568 + (i2 << 2) >> 2] | 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0) | 0) + i1 | 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i3 = 0;
 do {
  i2 = HEAP32[i4 + 1764 + (i3 << 2) >> 2] | 0;
  if (i2 >>> 0 > 512 >>> 0) i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 512);
 return i1 | 0;
}

function __ZN11PreloadDataD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = gb + 66036 + 8;
 i3 = i5 + 52 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i4 = i5 + 56 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) {
   do {
    i6 = i2 + -4 | 0;
    HEAP32[i4 >> 2] = i6;
    __ZN14ConstantStringD2Ev(i6);
    i2 = HEAP32[i4 >> 2] | 0;
   } while ((i2 | 0) != (i1 | 0));
   i1 = HEAP32[i3 >> 2] | 0;
  }
  __ZdlPv(i1);
 }
 i1 = i5 + 32 | 0;
 if ((HEAP32[i5 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i5 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i5 + 28 | 0);
 HEAP32[i5 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11DynamicMesh13FindNeighborsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1459044 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1459044 | 0, i1);
  i1 = gb + 1459044 | 0;
 } else i1 = 0;
 __ZN11DynamicMesh24RemoveDegeneratePolygonsEv(i3);
 __ZN11DynamicMesh21RemoveDegenerateEdgesEv(i3);
 __ZN11DynamicMesh20RemoveUnusedVerticesEv(i3);
 __ZN11DynamicMesh15ConnectPolygonsEv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN10Matrix4x4f11SetIdentityEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_SetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 __ZN16HumanPoseHandler12SetHumanPoseER8Vector3fR11QuaternionfPf(i1, i3, i4, i2);
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_GetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 __ZN16HumanPoseHandler12GetHumanPoseER8Vector3fR11QuaternionfPf(i1, i3, i4, i2);
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z32BillboardAsset_CUSTOM_GetIndicesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  i1 = HEAP32[i1 + 80 >> 2] | 0;
  i2 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 64 >> 2] | 0;
  i1 = (i3 | 0) == 0 ? 0 : i1;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 2, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 2) | 0, i3 | 0, i1 << 1 | 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z26Material_CUSTOM_GetTextureP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE(i5, i1) | 0) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function __Z20SetAlphaToRedChanneliiPhi13TextureFormat(i8, i9, i2, i10, i1) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i11 = 0, i12 = 0;
 i1 = __Z20GetTextureFormatInfo13TextureFormat(i1) | 0;
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 if ((i9 | 0) <= 0) return;
 i5 = HEAP32[i1 + 36 >> 2] & 255;
 i6 = ~HEAP32[i1 + 28 >> 2];
 i4 = HEAP32[i1 + 24 >> 2] & 255;
 if ((i8 | 0) > 0) i3 = 0; else return;
 while (1) {
  i1 = 0;
  do {
   i11 = i2 + (i1 << 2) | 0;
   i12 = HEAP32[i11 >> 2] | 0;
   HEAP32[i11 >> 2] = (i12 & i7) >>> i5 << i4 | i12 & i6;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i8 | 0));
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i9 | 0)) break; else i2 = i2 + i10 | 0;
 }
 return;
}

function __Z13RegisterClassI13TrailRendererEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 572;
 HEAP32[i2 + 8 >> 2] = gb + 421148;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 96;
 HEAP32[i2 + 20 >> 2] = 552;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32152;
 HEAP32[i2 + 44 >> 2] = fb + 54;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 55;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13OcclusionAreaEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 539;
 HEAP32[i2 + 8 >> 2] = gb + 378973;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 192;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30952;
 HEAP32[i2 + 44 >> 2] = fb + 21;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 22;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12LineRendererEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 561;
 HEAP32[i2 + 8 >> 2] = gb + 405180;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 120;
 HEAP32[i2 + 20 >> 2] = 504;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30712;
 HEAP32[i2 + 44 >> 2] = fb + 40;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 41;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEixEj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 64 | 0;
 i5 = i4 + 48 | 0;
 i7 = i4 + 32 | 0;
 i9 = i4 + 16 | 0;
 i8 = i4;
 i10 = i3 + 16 | 0;
 __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj(i6, i10, i2);
 __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj(i9, i3 + 20 | 0, i2);
 __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj(i8, i10, i2);
 __ZmiRK8Scalar4fS1_(i7, i9, i8);
 __ZmlRK8Scalar4fS1_(i5, i7, i3);
 __ZplRK8Scalar4fS1_(i1, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN4FMOD5Sound19getMusicNumChannelsEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 2;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870139;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN33AssetBundleLoadFromAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN23PreloadManagerOperationC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 27520 + 8;
 i3 = i1 + 64 | 0;
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1 + 112 | 0, i2);
 HEAP8[i1 + 124 >> 0] = 1;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN21ArchiveStorageCreator10AppendNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEy(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 i2 = HEAP32[i3 + 1212 >> 2] | 0;
 i1 = i2;
 if ((i2 | 0) == (HEAP32[i3 + 1208 >> 2] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i1 + -40 | 0;
  i1 = i1 + -32 | 0;
  i1 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
  i2 = getTempRet0() | 0;
 }
 return __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy(i3, i4, i5, i1, i2, i6, i7) | 0;
}

function __Z55ParticleSystemExtensionsImpl_CUSTOM_SetTriggerParticlesP12Il2CppObjectiS0_ii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 120) | 0;
  i3 = HEAP32[i3 + 12 >> 2] | 0;
  __ZN14ParticleSystem27SetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticleii(i6, i2, i1, i4, (i3 | 0) < (i5 | 0) ? i3 : i5);
  return;
 }
}

function __Z39MaterialPropertyBlock_CUSTOM_GetTextureP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 8 | 0;
 i3 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 i1 = __Z24GetTextureShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i1, i4) | 0;
 if (!i1) {
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i5 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN7Texture15FindTextureByIDE9TextureID(i4) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z38LightProbes_Get_Custom_PropBakedProbesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = i2 + 148 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 312 >> 2] | 0;
  i1 = (i3 | 0) == 0 ? 0 : i1;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i2, 108, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 108) | 0, i3 | 0, i1 * 108 | 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z22Check1MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_P6ObjectR11MonoManager(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6 + 16 | 0;
 i7 = i6 + 8 | 0;
 i9 = i6;
 HEAP32[i7 >> 2] = i3;
 i10 = i1;
 i1 = HEAP32[i10 + 4 >> 2] | 0;
 i3 = i9;
 HEAP32[i3 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 i5 = __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager(i8, i2, i7, 1, i4, i5) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z13RegisterClassI9AudioClipEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170496;
 HEAP32[i2 + 4 >> 2] = fb + 926;
 HEAP32[i2 + 8 >> 2] = gb + 856797;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 83;
 HEAP32[i2 + 20 >> 2] = 136;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170640;
 HEAP32[i2 + 44 >> 2] = fb + 280;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 281;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI22NavMeshProjectSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 912;
 HEAP32[i2 + 8 >> 2] = gb + 844212;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 126;
 HEAP32[i2 + 20 >> 2] = 668;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 169664;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI21UnityAnalyticsManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1119;
 HEAP32[i2 + 8 >> 2] = gb + 1037672;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 303;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188588;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI20UnityConnectSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1126;
 HEAP32[i2 + 8 >> 2] = gb + 1041655;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 310;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 189244;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12InputManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 586;
 HEAP32[i2 + 8 >> 2] = gb + 434516;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 13;
 HEAP32[i2 + 20 >> 2] = 192;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30432;
 HEAP32[i2 + 44 >> 2] = fb + 70;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 71;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11LightProbesEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 538;
 HEAP32[i2 + 8 >> 2] = gb + 378404;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 258;
 HEAP32[i2 + 20 >> 2] = 192;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30632;
 HEAP32[i2 + 44 >> 2] = fb + 19;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 20;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_runtime_graphics_mesh3_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1161920 | 0, gb + 430514 | 0, 0, 0);
 HEAP8[gb + 1546313 >> 0] = 0;
 HEAP8[gb + 1546313 + 1 >> 0] = 3;
 HEAP8[gb + 1546313 + 2 >> 0] = 0;
 HEAP8[gb + 1546313 + 3 >> 0] = 3;
 HEAP8[gb + 1546313 + 4 >> 0] = 2;
 HEAP8[gb + 1546313 + 5 >> 0] = 4;
 HEAP8[gb + 1546313 + 6 >> 0] = 0;
 HEAP8[gb + 1546313 + 7 >> 0] = 2;
 HEAP8[gb + 1546313 + 8 >> 0] = 0;
 HEAP8[gb + 1546313 + 9 >> 0] = 2;
 HEAP8[gb + 1546313 + 10 >> 0] = 0;
 HEAP8[gb + 1546313 + 11 >> 0] = 2;
 HEAP8[gb + 1546313 + 12 >> 0] = 0;
 HEAP8[gb + 1546313 + 13 >> 0] = 2;
 HEAP8[gb + 1546313 + 14 >> 0] = 0;
 HEAP8[gb + 1546313 + 15 >> 0] = 4;
 return;
}

function _jinit_d_post_controller(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 4 | 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i1 | 0, 1, 28) | 0;
 HEAP32[i1 + 396 >> 2] = i5;
 HEAP32[i5 >> 2] = fb + 2366;
 HEAP32[i5 + 8 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 if (!(HEAP8[i1 + 74 >> 0] | 0)) return;
 i3 = HEAP32[i1 + 276 >> 2] | 0;
 HEAP32[i5 + 16 >> 2] = i3;
 if (!(i2 << 24 >> 24)) {
  HEAP32[i6 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 1, Math_imul(HEAP32[i1 + 100 >> 2] | 0, HEAP32[i1 + 92 >> 2] | 0) | 0, i3 | 0) | 0;
  return;
 } else {
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i1 | 0);
  return;
 }
}

function _acoshf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647;
 do if (i2 >>> 0 < 1073741824) {
  f1 = Math_fround(f1 + Math_fround(-1.0));
  f1 = Math_fround(_log1pf(Math_fround(f1 + Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(f1 * Math_fround(2.0))))))));
 } else if (i2 >>> 0 < 1166016512) {
  f1 = Math_fround(+Math_log(+Math_fround(Math_fround(f1 * Math_fround(2.0)) - Math_fround(Math_fround(1.0) / Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(f1 * f1) + Math_fround(-1.0)))) + f1)))));
  break;
 } else {
  f1 = Math_fround(Math_fround(+Math_log(+f1)) + Math_fround(.693147182));
  break;
 } while (0);
 return Math_fround(f1);
}

function __ZN9dtNavMesh25setOffMeshConnectionFlagsEyj(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!((i1 & 983040 | 0) == 65536 & 0 == 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i5 = i1 & 65535;
 if (i5 >>> 0 > (HEAP32[i3 + 44 >> 2] | 0) >>> 0) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i2 = _bitshift64Lshr(i1 | 0, i2 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i3 + 48 >> 2] | 0;
 if ((i1 + (i5 * 104 | 0) | 0) == 0 ? 1 : (i2 | 0) != (HEAP32[i1 + (i5 * 104 | 0) + 92 >> 2] | 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 HEAP32[i1 + (i5 * 104 | 0) + 76 >> 2] = i4;
 i5 = i3 + 56 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + 1 | 0;
 HEAP32[i5 >> 2] = (i4 | 0) == 0 ? 1 : i4;
 i5 = 1073741824;
 return i5 | 0;
}

function __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 754632;
 HEAP32[i1 + 4 >> 2] = 283;
 HEAP32[i1 + 8 >> 2] = fb + 2100;
 HEAP32[i1 + 12 >> 2] = fb + 3469;
 HEAP32[i1 + 16 >> 2] = gb + 673035;
 HEAP32[i1 + 20 >> 2] = 284;
 HEAP32[i1 + 24 >> 2] = fb + 365;
 HEAP32[i1 + 28 >> 2] = fb + 308;
 HEAP32[i1 + 32 >> 2] = gb + 673047;
 HEAP32[i1 + 36 >> 2] = 285;
 HEAP32[i1 + 40 >> 2] = fb + 366;
 HEAP32[i1 + 44 >> 2] = fb + 309;
 HEAP32[i1 + 48 >> 2] = gb + 673056;
 HEAP32[i1 + 52 >> 2] = 286;
 HEAP32[i1 + 56 >> 2] = fb + 367;
 HEAP32[i1 + 60 >> 2] = fb + 310;
 HEAP32[i1 + 64 >> 2] = gb + 673068;
 HEAP32[i1 + 68 >> 2] = 287;
 HEAP32[i1 + 72 >> 2] = fb + 2101;
 HEAP32[i1 + 76 >> 2] = fb + 3470;
 return;
}

function __ZN4Mesh23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 425651 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) > 0) __ZN4Mesh8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN25SingleBlockMemoryFileData9SetLengthEy(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i5 + 16 | 0;
 i2 = i5 + 28 | 0;
 HEAP32[i2 >> 2] = i6;
 i3 = i5 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 2147483647) >>> 0 >= i6 >>> 0) return;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i6, 1, i5 + 20 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i6, 1, i5 + 20 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i1 >> 2] = i5;
  return;
 }
}

function __ZN18LoadSceneOperationD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 65820 + 8;
 i1 = HEAP32[i2 + 160 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZN18AwakeFromLoadQueueD2Ev(i2 + 180 | 0);
 i1 = i2 + 164 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN13LoadOperationD2Ev(i2);
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 + 176 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 __ZN13LoadOperationD2Ev(i2);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11LightProbes14LightProbeData5ClearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZN26ProbeSetTetrahedralization5ClearEv(i3);
 i1 = i3 + 40 | 0;
 i2 = i3 + 56 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 60 | 0;
 i2 = i3 + 76 | 0;
 if ((HEAP32[i2 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = 0;
  i3 = i3 + 72 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 64 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i3 + 72 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z56ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, i1 + 264 + 272 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z40NavMeshObstacle_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f6 = Math_fround(HEAPF32[i3 + 56 >> 2]);
  f5 = Math_fround(HEAPF32[i3 + 60 >> 2]);
  f5 = Math_fround(f5 * Math_fround(2.0));
  f4 = Math_fround(Math_fround(HEAPF32[i3 + 64 >> 2]) * Math_fround(2.0));
  HEAPF32[i2 >> 2] = Math_fround(f6 * Math_fround(2.0));
  HEAPF32[i2 + 4 >> 2] = f5;
  HEAPF32[i2 + 8 >> 2] = f4;
  return;
 }
}

function __Z39ParticleSystem_CUSTOM_Internal_SimulateP12Il2CppObjectfhh(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i5, f2, i4 << 24 >> 24 != 0 | (i3 << 24 >> 24 == 0 ? 0 : 2));
  return 0;
 }
 return 0;
}

function __Z38RegisterModuleClasses_CloudWebServicesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1130;
 HEAP32[i2 + 8 >> 2] = gb + 1046572;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 301;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 189852;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z38GUI_CUSTOM_INTERNAL_CALL_DoModalWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_RS0_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 i10 = __Z11GetGUIStatev() | 0;
 __ZN5IMGUI8DoWindowER8GUIStateiRK5RectTIfEP12Il2CppObjectR10GUIContentS7_S7_bb(i9, i10, i1, i2, i3, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i4) | 0, i5, i6, 1, 1);
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i9 + 8 >> 2];
 HEAP32[i7 + 12 >> 2] = HEAP32[i9 + 12 >> 2];
 STACKTOP = i8;
 return;
}

function __Z28TextMesh_Set_Custom_PropFontP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN20TextRenderingPrivate8TextMesh7SetFontE4PPtrIN13TextRendering4FontEE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z24IsTimeslicableSceneAssetPKN5Unity4TypeE(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if ((i1 - (HEAP32[gb + 30792 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30792 + 28 >> 2] | 0) >>> 0) {
  i1 = 1;
  return i1 | 0;
 }
 if ((i1 - (HEAP32[gb + 31832 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 31832 + 28 >> 2] | 0) >>> 0) {
  i1 = 1;
  return i1 | 0;
 }
 if ((i1 - (HEAP32[gb + 65780 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 65780 + 28 >> 2] | 0) >>> 0) {
  i1 = 1;
  return i1 | 0;
 }
 if ((i1 - (HEAP32[gb + 26572 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 26572 + 28 >> 2] | 0) >>> 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (i1 - (HEAP32[gb + 30832 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 30832 + 28 >> 2] | 0) >>> 0;
 return i1 | 0;
}

function __Z13RegisterClassI23ShaderVariantCollectionEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 609;
 HEAP32[i2 + 8 >> 2] = gb + 479351;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 200;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31592;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI21WorldParticleColliderEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 1136;
 HEAP32[i2 + 8 >> 2] = gb + 1048607;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 76;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 191360;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI21AudioDistortionFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 927;
 HEAP32[i2 + 8 >> 2] = gb + 855533;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 170;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170864;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10GUITextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 30232;
 HEAP32[i2 + 4 >> 2] = fb + 550;
 HEAP32[i2 + 8 >> 2] = gb + 385664;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 131;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30312;
 HEAP32[i2 + 44 >> 2] = fb + 35;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 36;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _rgb_ycc_start(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 336 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 1, 8192) | 0;
 HEAP32[i3 + 8 >> 2] = i2;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 << 2) >> 2] = i1 * 19595;
  HEAP32[i2 + (i1 + 256 << 2) >> 2] = i1 * 38470;
  HEAP32[i2 + (i1 + 512 << 2) >> 2] = (i1 * 7471 | 0) + 32768;
  HEAP32[i2 + (i1 + 768 << 2) >> 2] = Math_imul(i1, -11059) | 0;
  HEAP32[i2 + (i1 + 1024 << 2) >> 2] = Math_imul(i1, -21709) | 0;
  HEAP32[i2 + (i1 + 1280 << 2) >> 2] = (i1 << 15) + 8421375;
  HEAP32[i2 + (i1 + 1536 << 2) >> 2] = Math_imul(i1, -27439) | 0;
  HEAP32[i2 + (i1 + 1792 << 2) >> 2] = Math_imul(i1, -5329) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 256);
 return;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjS8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN9Polygon2D12SetPathCountEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = (i2 - i4 | 0) / 20 | 0;
 if (i5 >>> 0 < i3 >>> 0) {
  __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj(i1, i3 - i5 | 0);
  return;
 }
 if (i5 >>> 0 <= i3 >>> 0) return;
 i3 = i4 + (i3 * 20 | 0) | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 while (1) {
  i1 = i2 + -20 | 0;
  HEAP32[i6 >> 2] = i1;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  if ((i1 | 0) == (i3 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN5physx3Scb13ObjectTracker17scheduleForUpdateERNS0_4BaseE(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 4 | 0;
 i1 = i7;
 i2 = i5 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 & 268435456 | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i2 >> 2] = i3 | 268435456;
 if ((i3 & -1073741824 | 0) != -2147483648) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i1 >> 2] = i5;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i4, i1, i6) | 0;
 if (!(HEAP8[i6 >> 0] | 0)) HEAP32[i1 >> 2] = i5;
 STACKTOP = i7;
 return;
}

function __ZN5physx2Cm17FreeListAllocator18unlinkFromFreeListEPNS0_5ChunkE(i9, i1) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = HEAP32[i1 >> 2] | 0;
 i4 = i8 & 1023;
 i5 = i9 + 148 + (i4 << 2) | 0;
 i6 = i1 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i3;
 i2 = i1 + 8 | 0;
 if (i3 | 0) HEAP32[i3 + 8 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) HEAP32[i5 >> 2] = i7; else HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 if (HEAP32[i5 >> 2] | 0) return;
 i1 = i4 >>> 5;
 i7 = i9 + 16 + (i1 << 2) | 0;
 i8 = HEAP32[i7 >> 2] & ~(1 << (i8 & 31));
 HEAP32[i7 >> 2] = i8;
 if (i8 | 0) return;
 i9 = i9 + 144 | 0;
 HEAP32[i9 >> 2] = HEAP32[i9 >> 2] & ~(1 << i1);
 return;
}

function __ZN4FMOD13ChannelGroupIC2EPNS_7SystemIE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 48 >> 2] = 0;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = i2;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i2;
 HEAP32[i1 + 72 >> 2] = i2;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = i2;
 HEAP32[i1 + 84 >> 2] = i2;
 return;
}

function __ZN16ScriptingManager27NativeTypeForScriptingClassEP11Il2CppClass(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i2 = HEAP32[i1 + 200 >> 2] | 0;
 i6 = HEAP32[i1 + 204 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i7 >>> 0;
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 if ((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) >>> 0 > i7 >>> 0) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 return i8 | 0;
}

function __ZN15ConstantForce2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(68, i1, 16, gb + 1048932 | 0, 0, gb + 805847 | 0, 9) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN24PhysicsUpdateBehaviour2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 154620 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15AudioReverbZone4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 i3 = i1 + 116 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = __ZN4FMOD6System12createReverbEPPNS_6ReverbE(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0, i3) | 0;
  if (i2 | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(__ZL16FMOD_ErrorString11FMOD_RESULT_59(i2) | 0, 0, gb + 856939 | 0, 112, 1, 0, 0, 0);
 }
 __ZN4FMOD6Reverb9setActiveEb(HEAP32[i3 >> 2] | 0, 1) | 0;
 __ZN12AudioManager21FixMasterGroupRoutingEv(__Z15GetAudioManagerv() | 0);
 __ZN15AudioReverbZone13SetFMODValuesEv(i1);
 __ZN4FMOD6System6updateEv(HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0) | 0;
 return;
}

function __Z55Joint2D_CUSTOM_Joint2D_CUSTOM_INTERNAL_GetReactionForceP12Il2CppObjectfP13Vector2fIcall(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  __ZNK7Joint2D16GetReactionForceEf(i4, i5, f2);
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  STACKTOP = i6;
  return;
 }
}

function __Z42TerrainCollider_Set_Custom_PropTerrainDataP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN15TerrainCollider14SetTerrainDataE4PPtrI11TerrainDataE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z19PluginsRenderMarkeri(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!(__Z11IsGfxDevicev() | 0)) return;
 i4 = __Z16GetRealGfxDevicev() | 0;
 i1 = HEAP32[gb + 1162584 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[i1 >> 2] | 0)) return;
 i2 = 0;
 do {
  if (HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 24 | 0) + 8 >> 2] | 0) {
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
   mftCall_vi(HEAP32[(HEAP32[HEAP32[gb + 1162584 >> 2] >> 2] | 0) + (i2 * 24 | 0) + 8 >> 2] | 0, i3 | 0);
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
   i1 = HEAP32[gb + 1162584 >> 2] | 0;
  }
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) / 24 | 0) >>> 0);
 return;
}

function __Z15AngularDistanceRK11QuaternionfS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i2 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 8 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * Math_fround(HEAPF32[i2 + 12 >> 2])));
 i2 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i2 ? f4 : f3;
 i2 = f3 < Math_fround(1.0);
 return Math_fround(Math_fround(+Math_acos(+(i2 ? f3 : Math_fround(1.0)))) * Math_fround(2.0));
}

function __Z13RegisterClassI10MeshFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 578;
 HEAP32[i2 + 8 >> 2] = gb + 1046285;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 33;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30872;
 HEAP32[i2 + 44 >> 2] = fb + 60;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 61;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function mftCall_vifiiiiiiiiiiiii(i16, i1, d2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i16 | 0) >= (fb | 0) & (i16 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_vifiiiiiiiiiiiii[i16 - fb & 7](i1 | 0, Math_fround(d2), i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
  return;
 }
 ftCall_vifiiiiiiiiiiiii(i16 | 0, i1 | 0, +d2, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRt(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRm(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRl(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRe(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRd(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 12 | 0;
 i9 = i7 + 8 | 0;
 i12 = i7 + 4 | 0;
 i11 = i7;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i11 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i12 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i11 >> 2];
 i6 = mftCall_iiiiiii(i10 | 0, i1 | 0, i9 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK19VREyeTextureManager16HasRenderSurfaceEP17RenderSurfaceBasePiS2_(i1, i5, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i8 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i3 = (i2 - i1 | 0) / 20 | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i4 + (i2 * 20 | 0) + 8 >> 2] | 0) == (i5 | 0)) {
   i1 = 0;
   break;
  }
  if ((HEAP32[i4 + (i2 * 20 | 0) + 12 >> 2] | 0) == (i5 | 0)) {
   i1 = 1;
   break;
  }
  i1 = i2 + 1 | 0;
  if (i1 >>> 0 < i3 >>> 0) i2 = i1; else {
   i1 = 0;
   i8 = 6;
   break;
  }
 }
 if ((i8 | 0) == 6) return i1 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i7 >> 2] = i2;
 i8 = 1;
 return i8 | 0;
}

function __ZN7mecanim12statemachine13GetStateIndexEPKNS0_20StateMachineConstantEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!i4) {
  i5 = -1;
  return i5 | 0;
 }
 i3 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = 0;
 while (1) {
  i6 = i3 + (i1 << 2) | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = (i2 | 0) == 0 ? 0 : i6 + i2 | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i5 | 0)) {
   i2 = 7;
   break;
  }
  if ((HEAP32[i2 + 28 >> 2] | 0) == (i5 | 0)) {
   i2 = 7;
   break;
  }
  if ((HEAP32[i2 + 24 >> 2] | 0) == (i5 | 0)) {
   i2 = 7;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN5physx7NpShape15incMeshRefCountEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 case 6:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 case 5:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i1 = HEAP32[i1 + 36 >> 2] | 0;
   if (!i1) return; else i1 = i1 + 8 | 0;
   break;
  }
 default:
  return;
 }
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 4 | 0) | 0;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE21buildConeAccelerationEv(i9) {
 i9 = i9 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i9 + 428 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i9 + 432 >> 2] | 0) + 160 >> 2] | 0;
 i6 = i1 + (i8 * 48 | 0) | 0;
 if (!i8) return;
 i7 = i9 + 192 | 0;
 i8 = i9 + 192 | 0;
 i3 = 1;
 while (1) {
  if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(0.0))) {
   i2 = HEAP32[i1 + 44 >> 2] | 0;
   i4 = i8;
   i5 = i9;
   while (1) {
    if (HEAP32[i5 >> 2] & i2 | 0) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i3;
    i5 = i5 + 4 | 0;
    if ((i5 | 0) == (i7 | 0)) break; else i4 = i4 + 4 | 0;
   }
  }
  i1 = i1 + 48 | 0;
  if ((i1 | 0) == (i6 | 0)) break; else i3 = i3 << 1;
 }
 return;
}

function __ZN5physx2Gu3EPA11expandPointEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_(i4, i3, i2, i1, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 16 | 0;
 HEAPF32[i7 >> 2] = Math_fround(1.0);
 HEAPF32[i7 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i7 + 12 >> 2] = Math_fround(0.0);
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i7 | 0, i4 + 288 | 0, i4 + 1312 | 0, i6 | 0);
 i5 = __ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_(i4, i3, i2, i1, i5) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14NavMeshManager20NotifyNavMeshCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 52 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i4 + 40 | 0;
  i1 = 0;
  do {
   __ZN12NavMeshAgent21RemoveFromCrowdSystemEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i2 = i4 + 72 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do i1 = i1 + 1 | 0; while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i3 = i4 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i4 + 80 | 0;
 i1 = 0;
 do {
  __ZN11OffMeshLink16OnNavMeshCleanupEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN14MessageHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1 + 64 | 0, HEAP32[i1 + 68 >> 2] | 0);
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 56 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -20 - i3 | 0) >>> 0) / 20 | 0) * 20 | 0);
  __ZdlPv(i2);
 }
 __ZNSt3__213__vector_baseI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEED2Ev(i1 + 28 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, i1 + 8 | 0);
 return;
}

function __ZL32MarkLevelGameManagerDependenciesR27GarbageCollectorThreadState(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[gb + 1164172 >> 2] | 0;
 i4 = i1 + 16 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i2 = i1 + 4 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i5 + 84 >> 2] | 0, i3);
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i5 + 88 >> 2] | 0, i3);
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i5 + 92 >> 2] | 0, i3);
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i5 + 96 >> 2] | 0, i3);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (HEAP32[i4 >> 2] | 0));
 return;
}

function __Z36RegisterModuleClasses_UnityAnalyticsv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1119;
 HEAP32[i2 + 8 >> 2] = gb + 1037672;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 303;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188588;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z36RegisterModuleClasses_CrashReportingv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1125;
 HEAP32[i2 + 8 >> 2] = gb + 1039541;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 304;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188780;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z28DeleteFirstPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i2, 47, 0) | 0;
 if ((i3 | 0) == -1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 } else {
  i5 = HEAP8[i2 + 11 >> 0] | 0;
  i6 = i5 << 24 >> 24 < 0;
  i4 = (i6 ? HEAP32[i2 >> 2] | 0 : i2) + (i3 + 1) | 0;
  i3 = (i6 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) + ~i3 | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, i3);
  return;
 }
}

function __Z27GUIText_Set_Custom_PropFontP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN20TextRenderingPrivate7GUIText7SetFontE4PPtrIN13TextRendering4FontEE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z13RegisterClassI8AnimatorEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 30072;
 HEAP32[i2 + 4 >> 2] = fb + 949;
 HEAP32[i2 + 8 >> 2] = gb + 902235;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 95;
 HEAP32[i2 + 20 >> 2] = 636;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 67008;
 HEAP32[i2 + 44 >> 2] = fb + 306;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 307;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI7TerrainEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 994;
 HEAP32[i2 + 8 >> 2] = gb + 937588;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 218;
 HEAP32[i2 + 20 >> 2] = 248;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 35740;
 HEAP32[i2 + 44 >> 2] = fb + 314;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 315;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI19AudioHighPassFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 929;
 HEAP32[i2 + 8 >> 2] = gb + 855611;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 165;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171240;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18CrashReportManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1125;
 HEAP32[i2 + 8 >> 2] = gb + 1039541;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 304;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 188780;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18AudioLowPassFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 931;
 HEAP32[i2 + 8 >> 2] = gb + 855869;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 169;
 HEAP32[i2 + 20 >> 2] = 140;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171428;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _Unity_FT_Init_FreeType(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63392 | 0, 16, gb + 946903 | 0, 33) | 0;
 if (!i3) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 946984 | 0, 0, gb + 946903 | 0, 40, 1, 0, 0, 0);
  i3 = 7;
  return i3 | 0;
 };
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i1 = _UNITY_FT_New_Library(i3, i2) | 0;
 if (!i1) {
  _UNITY_FT_Add_Default_Modules(HEAP32[i2 >> 2] | 0);
  i3 = 0;
  return i3 | 0;
 } else {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63392 | 0);
  i3 = i1;
  return i3 | 0;
 }
 return 0;
}

function b39(i1, i2, i13, i24, i29, i30, i31, i32, i33, i34, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18, i19, i20, i21, i22, i23, i25, i26, i27, i28) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i24 = i24 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i31 = i31 | 0;
 i32 = i32 | 0;
 i33 = i33 | 0;
 i34 = i34 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 nullFunc_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii(39);
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEOS5_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i1 >> 0] = 0;
 }
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i2 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 };
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNK5physx2Gu10ConvexMesh18getMassInformationERfRNS_7PxMat33ERNS_6PxVec3E(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 + 88 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 + 92 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 96 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 100 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 104 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 108 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 112 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i4 + 116 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i4 + 120 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i4 + 124 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 + 40 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 44 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 48 >> 2];
 return;
}

function __ZN9dtNavMesh4initEPK15dtNavMeshParams(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 >> 2] = 1024;
 HEAP32[i3 + 4 >> 2] = 1023;
 i2 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, 4096) | 0;
 HEAP32[i3 + 8 >> 2] = i2;
 if (!i2) {
  i3 = -2147483644;
  return i3 | 0;
 }
 if ((HEAP32[i3 >> 2] | 0) > 0) i1 = 0; else {
  i3 = 1073741824;
  return i3 | 0;
 }
 do {
  HEAP32[i2 + (i1 << 2) >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 i1 = 1073741824;
 return i1 | 0;
}

function __ZN9Animation27RecomputeContainedRenderersEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 72 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 68 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) {
  do {
   __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i4);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i5 >> 2] | 0;
  if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 }
 __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i4 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN9Animation25CheckRendererVisibleStateEv(i4);
 return;
}

function __ZN5physx35PxJointLimitParametersGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 741375;
 HEAP32[i1 + 4 >> 2] = 483;
 HEAP32[i1 + 8 >> 2] = fb + 416;
 HEAP32[i1 + 12 >> 2] = fb + 359;
 HEAP32[i1 + 16 >> 2] = gb + 741387;
 HEAP32[i1 + 20 >> 2] = 484;
 HEAP32[i1 + 24 >> 2] = fb + 417;
 HEAP32[i1 + 28 >> 2] = fb + 360;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 485;
 HEAP32[i1 + 40 >> 2] = fb + 418;
 HEAP32[i1 + 44 >> 2] = fb + 361;
 HEAP32[i1 + 48 >> 2] = gb + 741403;
 HEAP32[i1 + 52 >> 2] = 486;
 HEAP32[i1 + 56 >> 2] = fb + 419;
 HEAP32[i1 + 60 >> 2] = fb + 362;
 HEAP32[i1 + 64 >> 2] = gb + 741411;
 HEAP32[i1 + 68 >> 2] = 487;
 HEAP32[i1 + 72 >> 2] = fb + 420;
 HEAP32[i1 + 76 >> 2] = fb + 363;
 return;
}

function __ZN5physx2Sn5ConvX11convertPad8EPKcRKNS0_15PxMetaDataEntryES6_(i7, i2, i3, i1) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (HEAP8[i7 + 325 >> 0] | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i5 >> 0] = -51;
 i4 = i3 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > 0) {
  i2 = i7 + 304 | 0;
  i3 = 0;
  do {
   i1 = HEAP32[i2 >> 2] | 0;
   mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i5 | 0, 1) | 0;
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i4 >> 2] | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 i7 = i7 + 312 | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
 STACKTOP = i6;
 return;
}

function __ZN4FMOD5Sound15getNumSubSoundsEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859481;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z41Rigidbody2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN11Rigidbody2D11SetMaterialE4PPtrI17PhysicsMaterial2DE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z34RegisterModuleClasses_UnityConnectv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 1126;
 HEAP32[i2 + 8 >> 2] = gb + 1041655;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 310;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 189244;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z34Application_Get_Custom_PropVersionv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 16 | 0;
 i2 = i4;
 __ZN15ApplicationInfo10GetVersionEv(i2, __Z18GetApplicationInfov() | 0);
 i5 = i2 + 11 | 0;
 i3 = HEAP8[i5 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = __Z20scripting_string_newPKcj(i6 ? HEAP32[i2 >> 2] | 0 : i2, i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
 if ((HEAP8[i5 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return i3 | 0;
 }
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = 66;
 HEAP32[i1 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i6, i1);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z18StopPreloadManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1163176 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN14AsyncOperation16CleanupCoroutineEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 return;
}

function __Z13RegisterClassI9TransformEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 573;
 HEAP32[i2 + 8 >> 2] = gb + 1044255;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 4;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28940;
 HEAP32[i2 + 44 >> 2] = fb + 56;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 57;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9Texture2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 569;
 HEAP32[i2 + 8 >> 2] = gb + 411078;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 28;
 HEAP32[i2 + 20 >> 2] = 152;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32032;
 HEAP32[i2 + 44 >> 2] = fb + 52;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 53;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9ProjectorEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 543;
 HEAP32[i2 + 8 >> 2] = gb + 380711;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 119;
 HEAP32[i2 + 20 >> 2] = 68;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31232;
 HEAP32[i2 + 44 >> 2] = fb + 25;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 26;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9LensFlareEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 530;
 HEAP32[i2 + 8 >> 2] = gb + 373687;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 123;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30472;
 HEAP32[i2 + 44 >> 2] = fb + 10;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 11;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI20OcclusionCullingDataEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 540;
 HEAP32[i2 + 8 >> 2] = gb + 379002;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 363;
 HEAP32[i2 + 20 >> 2] = 56;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30992;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17AudioReverbFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 937;
 HEAP32[i2 + 8 >> 2] = gb + 863974;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 164;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 175128;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _scalbnf(f2, i1) {
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 var i3 = 0;
 if ((i1 | 0) > 127) {
  f2 = Math_fround(f2 * Math_fround(1701411830000000029203285.0e14));
  i3 = i1 + -127 | 0;
  i1 = i1 + -254 | 0;
  if ((i3 | 0) > 127) {
   f2 = Math_fround(f2 * Math_fround(1701411830000000029203285.0e14));
   i1 = (i1 | 0) > 127 ? 127 : i1;
  } else i1 = i3;
 } else if ((i1 | 0) < -126) {
  f2 = Math_fround(f2 * Math_fround(1.17549435e-38));
  i3 = i1 + 126 | 0;
  i1 = i1 + 252 | 0;
  if ((i3 | 0) < -126) {
   f2 = Math_fround(f2 * Math_fround(1.17549435e-38));
   i1 = (i1 | 0) < -126 ? -126 : i1;
  } else i1 = i3;
 }
 return Math_fround(f2 * (HEAP32[tempDoublePtr >> 2] = (i1 << 23) + 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])));
}

function __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj(i6, i5, i1, i4) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i2 = (HEAP32[i1 + 28 >> 2] | 0) + 32 | 0;
 i3 = __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv(i1) | 0;
 i1 = __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv(i1) | 0;
 if (i3) __ZN5physx21PxsBodyTransformVault7addBodyERKNS_11PxsBodyCoreE((HEAP32[(HEAP32[i6 + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 1444 | 0, i1);
 i7 = HEAP32[i6 + 56 >> 2] | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 36 >> 2] | 0, i7 | 0, HEAP32[i5 + 44 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0, (i4 | 0) != 0 | 0);
 i6 = i6 + 368 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZN17BaseObjectManager13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) {
   i5 = HEAP32[i2 + 52 >> 2] | 0;
   HEAP32[i1 >> 2] = 65;
   HEAP32[i1 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63520 | 0);
 HEAP32[gb + 1104264 >> 2] = 0;
 __ZN11TypeManager21CleanupGlobalInstanceEv();
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1104724 >> 2] | 0, gb + 63520 | 0);
 HEAP32[gb + 1104724 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN15b2ContactSolver13StoreImpulsesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 48 >> 2] | 0;
 if ((i6 | 0) <= 0) return;
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 i5 = HEAP32[i1 + 44 >> 2] | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i5 + (HEAP32[i7 + (i1 * 156 | 0) + 152 >> 2] << 2) >> 2] | 0;
  i4 = HEAP32[i7 + (i1 * 156 | 0) + 148 >> 2] | 0;
  if ((i4 | 0) > 0) {
   i2 = 0;
   do {
    HEAP32[i3 + 64 + (i2 * 20 | 0) + 8 >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 16 >> 2];
    HEAP32[i3 + 64 + (i2 * 20 | 0) + 12 >> 2] = HEAP32[i7 + (i1 * 156 | 0) + (i2 * 36 | 0) + 20 >> 2];
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) < (i4 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i6 | 0));
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValues7RestoreERK8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i6 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 if (!((i4 ? HEAP32[i2 + 4 >> 2] | 0 : i6 & 255) | 0)) {
  i6 = 0;
  STACKTOP = i5;
  return i6 | 0;
 }
 __ZN8JSONReadC2EPKc24TransferInstructionFlagsRK10MemLabelIdbPNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEi(i3, i4 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 64016 | 0, 0, 0, 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i3 | 0);
 __ZN8JSONReadD2Ev(i3);
 i6 = 1;
 STACKTOP = i5;
 return i6 | 0;
}

function __Z48CommandBuffer_CUSTOM_SetGlobalFloatArrayListImplP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5); else {
  HEAP32[i4 >> 2] = i2;
  i5 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i3 + 8 >> 2] | 0, 0, 4) | 0;
  __ZN22RenderingCommandBuffer22AddSetGlobalFloatArrayERKN9ShaderLab16FastPropertyNameEPKfi(i1, i4, i5, HEAP32[i3 + 12 >> 2] | 0);
  STACKTOP = i6;
  return;
 }
}

function __Z43ReflectionProbe_Set_Custom_PropBakedTextureP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN15ReflectionProbe15SetBakedTextureE4PPtrI7TextureE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z39Motion_CUSTOM_INTERNAL_get_averageSpeedP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 100 >> 2] | 0, i3 | 0, i4 | 0);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z13RegisterClassI8MaterialEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 602;
 HEAP32[i2 + 8 >> 2] = gb + 469691;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 21;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30792;
 HEAP32[i2 + 44 >> 2] = fb + 81;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 82;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI8LODGroupEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 576;
 HEAP32[i2 + 8 >> 2] = gb + 425104;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 205;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30752;
 HEAP32[i2 + 44 >> 2] = fb + 58;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 59;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI19AssetBundleManifestEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 520;
 HEAP32[i2 + 8 >> 2] = gb + 367172;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 290;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28028;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI18AudioMixerSnapshotEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 935;
 HEAP32[i2 + 8 >> 2] = gb + 863942;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 272;
 HEAP32[i2 + 20 >> 2] = 52;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174940;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17AudioChorusFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 924;
 HEAP32[i2 + 8 >> 2] = gb + 853401;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 166;
 HEAP32[i2 + 20 >> 2] = 72;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 170164;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI16ParticleRendererEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31312;
 HEAP32[i2 + 4 >> 2] = fb + 1135;
 HEAP32[i2 + 8 >> 2] = gb + 1048432;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 26;
 HEAP32[i2 + 20 >> 2] = 380;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 191192;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __GLOBAL__sub_I_GpuProgramParamsGLES_cpp() {
 var i1 = 0;
 i1 = __Z25GetBuiltinMatrixParamNamei(0) | 0;
 HEAP32[gb + 1451104 >> 2] = gb + 605597;
 HEAP32[gb + 1451104 + 4 >> 2] = i1;
 i1 = __Z32GetShaderInstanceMatrixParamNamei(0) | 0;
 HEAP32[gb + 1451104 + 8 >> 2] = gb + 605617;
 HEAP32[gb + 1451104 + 12 >> 2] = i1;
 i1 = __Z32GetShaderInstanceMatrixParamNamei(4) | 0;
 HEAP32[gb + 1451104 + 16 >> 2] = gb + 605646;
 HEAP32[gb + 1451104 + 20 >> 2] = i1;
 i1 = __Z32GetShaderInstanceMatrixParamNamei(5) | 0;
 HEAP32[gb + 1451104 + 24 >> 2] = gb + 605674;
 HEAP32[gb + 1451104 + 28 >> 2] = i1;
 i1 = __Z32GetShaderInstanceMatrixParamNamei(1) | 0;
 HEAP32[gb + 1451104 + 32 >> 2] = gb + 605709;
 HEAP32[gb + 1451104 + 36 >> 2] = i1;
 return;
}

function mftCall_viiiiiiiiiiiiiii(i16, i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i16 = i16 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i16 | 0) >= (fb | 0) & (i16 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viiiiiiiiiiiiiii[i16 - fb & 7](i1 | 0, i2 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
  return;
 }
 ftCall_viiiiiiiiiiiiiii(i16 | 0, i1 | 0, i2 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i13 | 0, i14 | 0, i15 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getConstraintsEPPNS_12PxConstraintEjj(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i1 + 40 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = i1;
 i4 = 0;
 i1 = 0;
 do {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  if (!(i4 >>> 0 < i8 >>> 0 | (i1 >>> 0 >= i7 >>> 0 ? 1 : (HEAP8[i3 + (i4 << 3) >> 0] | 0) != 0))) {
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i3 + (i4 << 3) + 4 >> 2];
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = i1 + 1 | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i2 + 40 >> 2] | 0) >>> 0);
 return i1 | 0;
}

function __ZN9GfxDevice18AliasRenderSurfaceE9TextureIDP17RenderSurfaceBase(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i7 = i4;
 i5 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0, (HEAP8[i3 + 30 >> 0] | 0) != 0 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, i1 | 0, i5 | 0, i3 | 0);
 i8 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 408 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 mftCall_viii(i3 | 0, i1 | 0, i5 | 0, i6 | 0);
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperationD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 27632 + 8;
 i2 = i1 + 128 | 0;
 HEAP32[i2 >> 2] = gb + 27632 + 88;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 208 | 0);
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i2 >> 2] = gb + 27732 + 88;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN23ArchiveStorageConverterD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i3 = i1 + 144 | 0;
 __ZN4File5CloseEv(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 176 | 0);
 __ZN4FileD2Ev(i3);
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 return;
}

function __ZN24DownloadHandlerAudioClip12GetAudioClipEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 56 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  return i5 | 0;
 }
 i1 = i4 + 40 | 0;
 i2 = HEAP32[i4 + 52 >> 2] | 0;
 i3 = __Z9GetIAudiov() | 0;
 if (!i3) i1 = 0; else {
  i6 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63328 | 0, 16, gb + 1026987 | 0, 62) | 0;
  HEAP32[i6 >> 2] = gb + 188088 + 8;
  HEAP32[i6 + 4 >> 2] = i4;
  i4 = i4 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
  i1 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i6 | 0, ((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0, 0, 0, i2 | 0) | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i6 = i1;
 return i6 | 0;
}

function __ZN22BaseUnityConnectClient12ProcessStateENS_5StateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i2 = 1;
   return i2 | 0;
  }
 case 2:
  {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
   i2 = 1;
   return i2 | 0;
  }
 case 3:
  {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
   i2 = 1;
   return i2 | 0;
  }
 case 4:
  {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
   i2 = 1;
   return i2 | 0;
  }
 case 5:
  {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
   i2 = 1;
   return i2 | 0;
  }
 default:
  {
   i2 = 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN19ShaderPropertySheet26GetOrCreateTexturePropertyERKN9ShaderLab16FastPropertyNameE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = HEAP32[i2 + 24 >> 2] | 0;
 L1 : do if ((i1 | 0) < (i4 | 0)) {
  i5 = HEAP32[i2 + 32 >> 2] | 0;
  i6 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i4 | 0)) break L1;
  }
  if ((i1 | 0) > -1) {
   i6 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575;
   return i6 | 0;
  }
 } while (0);
 i6 = __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE(i2, i3, 0) | 0;
 return i6 | 0;
}

function __ZN15DirectorManager31AddScheduledPlayableControllersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1188420 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 __ZN15DirectorManager12AddToManagerEP18PlayableController(i3, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
 i1 = HEAP32[gb + 1188420 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __ZN15DirectorManager12AddToManagerEP18PlayableController(i3, HEAP32[i2 + 4 >> 2] | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
  i1 = HEAP32[gb + 1188420 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return;
}

function __ZN12AdsIdHandler16AddAdsIdDelegateEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = __Z22scripting_gchandle_newP12Il2CppObject(i2) | 0;
 i2 = i1 + 48 | 0;
 i6 = HEAP32[i1 + 60 >> 2] | 0;
 HEAP32[i4 >> 2] = 5;
 HEAP32[i4 + 4 >> 2] = i6;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i4, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i4 + 8 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i2;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i2 >> 2] = i4;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN11Rigidbody2D12SetSleepModeENS_9SleepModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 60 >> 2] = i2;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 i4 = i3 + 4 | 0;
 i5 = HEAPU16[i4 >> 1] | 0;
 if (i2 | 0) {
  HEAP16[i4 >> 1] = i5 | 4;
  return;
 }
 i1 = i5 & 65531;
 HEAP16[i4 >> 1] = i1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i4 >> 1] = i5 & 65529;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i5 = i3 + 64 | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  HEAP32[i5 + 8 >> 2] = 0;
  HEAP32[i5 + 12 >> 2] = 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i5 + 20 >> 2] = 0;
  return;
 }
 if (i5 & 2 | 0) return;
 HEAP16[i4 >> 1] = i1 | 2;
 HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[i1 + 4 >> 2] | 0, gb + 1033949 | 0, i4, HEAP32[i1 + 24 >> 2] | 0);
 __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z40Collider2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN10Collider2D11SetMaterialE4PPtrI17PhysicsMaterial2DE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z35Input_CUSTOM_INTERNAL_CALL_GetTouchiR5Touch(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i6 + 12 | 0;
 if ((i2 | 0) <= -1) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536761 | 0, i5);
 if ((__Z13GetTouchCountv() | 0) <= (i2 | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536761 | 0, i5);
 if (__Z8GetTouchjR5Touch(i2, i1) | 0) {
  i2 = i3 + 68 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i6;
  return;
 } else __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 536782 | 0, i4);
}

function __Z26Transform_CUSTOM_SetParentP12Il2CppObjectS0_h(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i4, i1, i3 << 24 >> 24 ? 1 : 2) | 0;
  return;
 }
}

function __Z23GetGfxDeviceLevelString16GfxDeviceLevelGL(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  i2 = gb + 602665 | 0;
  STACKTOP = i3;
  return i2 | 0;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 606220 | 0, 13);
 i4 = __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 i1 = HEAP32[(i4 ? gb + 75764 | 0 : gb + 75812 | 0) + (i1 + -1 << 2) >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i2 = i1;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z13RegisterClassI8GUILayerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 549;
 HEAP32[i2 + 8 >> 2] = gb + 385787;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 92;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30272;
 HEAP32[i2 + 44 >> 2] = fb + 33;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 34;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17ProceduralTextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 584;
 HEAP32[i2 + 8 >> 2] = gb + 431704;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 186;
 HEAP32[i2 + 20 >> 2] = 232;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31192;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10GameObjectEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26492;
 HEAP32[i2 + 4 >> 2] = fb + 522;
 HEAP32[i2 + 8 >> 2] = gb + 368689;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 1;
 HEAP32[i2 + 20 >> 2] = 80;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 28900;
 HEAP32[i2 + 44 >> 2] = fb + 6;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 7;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__214__num_put_base12__format_intEPcPKcbj(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 if (i5 & 2048) {
  HEAP8[i1 >> 0] = 43;
  i1 = i1 + 1 | 0;
 }
 if (i5 & 512) {
  HEAP8[i1 >> 0] = 35;
  i1 = i1 + 1 | 0;
 }
 while (1) {
  i3 = HEAP8[i2 >> 0] | 0;
  if (!(i3 << 24 >> 24)) break;
  HEAP8[i1 >> 0] = i3;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 L10 : do switch (i5 & 74) {
 case 64:
  {
   HEAP8[i1 >> 0] = 111;
   break;
  }
 case 8:
  if (!(i5 & 16384)) {
   HEAP8[i1 >> 0] = 120;
   break L10;
  } else {
   HEAP8[i1 >> 0] = 88;
   break L10;
  }
 default:
  if (i4) {
   HEAP8[i1 >> 0] = 100;
   break L10;
  } else {
   HEAP8[i1 >> 0] = 117;
   break L10;
  }
 } while (0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i2 + 168 >> 2] = i3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859083;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN37AssetBundleLoadFromFileAsyncOperationD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 27828 + 8;
 i2 = i1 + 128 | 0;
 HEAP32[i2 >> 2] = gb + 27828 + 88;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 192 | 0);
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i2 >> 2] = gb + 27732 + 88;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN23ArchiveStorageConverterD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i3 = i1 + 144 | 0;
 __ZN4File5CloseEv(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 176 | 0);
 __ZN4FileD2Ev(i3);
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 return;
}

function __ZN21UnityAnalyticsManager33OnPlayerSessionStateChangedStaticEPS_jyy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i2 | 0) != 1) return;
 i1 = i1 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i6 = __ZnwjRK10MemLabelIdiPKci(44, gb + 63800 | 0, 16, gb + 1037694 | 0, 67) | 0;
 HEAP32[i6 + 4 >> 2] = __Z21GetUnityConnectClientv() | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 188416 + 8;
 HEAP8[i6 + 16 >> 0] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i6 + 24 | 0);
 HEAP32[i5 >> 2] = gb + 1042554;
 HEAP32[i1 >> 2] = i6;
 __ZN14UnityAnalytics23RegisterGlobalCallbacksEv(i6);
 return;
}

function __ZN20GlobalCachingManager16RebuildAllCachesEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i4 = i2;
  i5 = 7;
 } else {
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    __ZN5CacheD2Ev(i3);
    __ZdlPv(i3);
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i1 + 4 >> 2] | 0));
  if (i1 | 0) {
   i4 = i2;
   i5 = 7;
  }
 }
 if ((i5 | 0) == 7) {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   if ((i4 | 0) != (i2 | 0)) HEAP32[i1 + 4 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i2);
  }
  __ZdlPv(i1);
 }
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN18GfxFramebufferGLES13ApplyViewportEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 176 | 0;
 i3 = i1 + 296 | 0;
 i4 = i1 + 180 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i1 + 300 >> 2] | 0)) if ((HEAP32[i1 + 184 >> 2] | 0) == (HEAP32[i1 + 304 >> 2] | 0)) if ((HEAP32[i1 + 188 >> 2] | 0) == (HEAP32[i1 + 308 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 mftCall_viiii(HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 172 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 184 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0);
 return;
}

function __ZN15UnityAdsManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(28, i1, 16, gb + 1048932 | 0, 0, gb + 1037332 | 0, 20) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 188244 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z52ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!i2) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 622501 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve(i3, i1 + 264 + 8 | 0);
  STACKTOP = i4;
  return;
 }
}

function __Z48Transform_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Transform21GetWorldToLocalMatrixEv(i1, i4);
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z48Transform_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK9Transform21GetLocalToWorldMatrixEv(i1, i4);
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z41Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D8AddForceERK8Vector2fNS_9ForceModeE(i5, i4, i3);
  STACKTOP = i6;
  return;
 }
}

function __Z40Graphics_CUSTOM_Internal_SetMRTFullSetupP11Il2CppArrayP21ScriptingRenderBufferiiiS0_S0_ii(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0;
 i10 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0;
 i7 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 4) | 0;
 __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_(i1, i10, i2);
 __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iiiPKiS3_ii(i1, i10, i2, i3, i4, i5, i6, i7, i8, i9);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __Z15ScaleCurveValueR17AnimationCurveTplIfEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  i1 = 0;
  do {
   i6 = i5 + (i1 << 4) + 4 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f3);
   i6 = i5 + (i1 << 4) + 8 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f3);
   i6 = i5 + (i1 << 4) + 12 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 20 | 0;
 i9 = i6 + 16 | 0;
 i8 = i6;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAPF32[i8 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i8 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i8 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i9 >> 2] = i3;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali(i1, i2, i8, 0, 0, 0, 0, Math_fround(1.0), i7, i4, i5);
 STACKTOP = i6;
 return;
}

function __Z13RegisterClassI18DelayedCallManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 553;
 HEAP32[i2 + 8 >> 2] = gb + 391228;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 98;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30032;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI17PhysicsMaterial2DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 875;
 HEAP32[i2 + 8 >> 2] = gb + 801702;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 62;
 HEAP32[i2 + 20 >> 2] = 44;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 156288;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI16LightmapSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28456;
 HEAP32[i2 + 4 >> 2] = fb + 560;
 HEAP32[i2 + 8 >> 2] = gb + 402133;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 157;
 HEAP32[i2 + 20 >> 2] = 240;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30672;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15AudioReverbZoneEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 938;
 HEAP32[i2 + 8 >> 2] = gb + 864200;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 167;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174088;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15AudioEchoFilterEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 170352;
 HEAP32[i2 + 4 >> 2] = fb + 928;
 HEAP32[i2 + 8 >> 2] = gb + 855573;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 168;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 171052;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _TT_Load_Glyph_Header(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 200 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 10 | 0;
 if (i4 >>> 0 > (HEAP32[i1 + 204 >> 2] | 0) >>> 0) {
  i4 = 20;
  return i4 | 0;
 }
 HEAP16[i1 + 32 >> 1] = (HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i3 + 1 >> 0] | 0);
 HEAP32[i1 + 36 >> 2] = ((HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0)) << 16 >> 16;
 HEAP32[i1 + 40 >> 2] = ((HEAPU8[i3 + 4 >> 0] | 0) << 8 | (HEAPU8[i3 + 5 >> 0] | 0)) << 16 >> 16;
 HEAP32[i1 + 44 >> 2] = ((HEAPU8[i3 + 6 >> 0] | 0) << 8 | (HEAPU8[i3 + 7 >> 0] | 0)) << 16 >> 16;
 HEAP32[i1 + 48 >> 2] = ((HEAPU8[i3 + 8 >> 0] | 0) << 8 | (HEAPU8[i3 + 9 >> 0] | 0)) << 16 >> 16;
 HEAP32[i2 >> 2] = i4;
 i4 = 0;
 return i4 | 0;
}

function _random() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 ___lock(gb + 1470376 | 0);
 i1 = HEAP32[gb + 207768 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[gb + 207772 >> 2] | 0;
  i1 = (Math_imul(HEAP32[i2 >> 2] | 0, 1103515245) | 0) + 12345 & 2147483647;
  HEAP32[i2 >> 2] = i1;
 } else {
  i3 = HEAP32[gb + 1470384 >> 2] | 0;
  i2 = HEAP32[gb + 207772 >> 2] | 0;
  i4 = HEAP32[gb + 207776 >> 2] | 0;
  i5 = i2 + (i4 << 2) | 0;
  i2 = (HEAP32[i5 >> 2] | 0) + (HEAP32[i2 + (i3 << 2) >> 2] | 0) | 0;
  HEAP32[i5 >> 2] = i2;
  i4 = i4 + 1 | 0;
  HEAP32[gb + 207776 >> 2] = (i4 | 0) == (i1 | 0) ? 0 : i4;
  i3 = i3 + 1 | 0;
  HEAP32[gb + 1470384 >> 2] = (i3 | 0) == (i1 | 0) ? 0 : i3;
  i1 = i2 >>> 1;
 }
 ___unlock(gb + 1470376 | 0);
 return i1 | 0;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIeeEEPeEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, d5 = 0.0, i8 = 0;
 i2 = i6 + 16 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i6, i6 + 8 | 0, i2, i1) | 0;
 i4 = i6 + 24 | 0;
 i1 = i2;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  d5 = +HEAPF64[i4 >> 3];
  d3 = +HEAPF64[i1 >> 3];
  if (d5 < d3) {
   i2 = i4;
   while (1) {
    HEAPF64[i2 >> 3] = d3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -8 | 0;
    d3 = +HEAPF64[i2 >> 3];
    if (!(d5 < d3)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAPF64[i1 >> 3] = d5;
  }
  i1 = i4;
  i4 = i4 + 8 | 0;
 }
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIddEEPdEEvT0_S5_T_(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, d5 = 0.0, i8 = 0;
 i2 = i6 + 16 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i6, i6 + 8 | 0, i2, i1) | 0;
 i4 = i6 + 24 | 0;
 i1 = i2;
 while (1) {
  if ((i4 | 0) == (i7 | 0)) break;
  d5 = +HEAPF64[i4 >> 3];
  d3 = +HEAPF64[i1 >> 3];
  if (d5 < d3) {
   i2 = i4;
   while (1) {
    HEAPF64[i2 >> 3] = d3;
    if ((i1 | 0) == (i6 | 0)) {
     i1 = i6;
     break;
    }
    i2 = i1 + -8 | 0;
    d3 = +HEAPF64[i2 >> 3];
    if (!(d5 < d3)) break; else {
     i8 = i1;
     i1 = i2;
     i2 = i8;
    }
   }
   HEAPF64[i1 >> 3] = d5;
  }
  i1 = i4;
  i4 = i4 + 8 | 0;
 }
 return;
}

function __ZNK12LineRenderer12GetPositionsEP8Vector3fj(i1, i4, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = i1 + 348 | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 if (i1 >>> 0 > i3 >>> 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 406988 | 0, 0, gb + 406663 | 0, 140, 1, 0, 0, 0); else i3 = i1;
 if ((i3 | 0) <= 0) return i3 | 0;
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i4 + (i1 * 12 | 0) >> 2] = HEAP32[i2 + (i1 * 12 | 0) >> 2];
  HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2];
  HEAP32[i4 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return i3 | 0;
}

function __ZN7mecanim20ValueArrayBlendBeginERNS_14ValueArrayMaskE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, 0, HEAP32[i1 >> 2] | 0) | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
 i2 = i1 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, 0, HEAP32[i1 + 24 >> 2] | 0) | 0;
 i2 = i1 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 _memset(((i3 | 0) == 0 ? 0 : i3 + i2 | 0) | 0, 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
 return;
}

function __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = __ZNK9ShaderLab9IntShader13GetDependencyERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1) | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb(i2, i3 + 80 | 0, (HEAP8[i3 + 92 >> 0] | 0) != 0) | 0;
 return i3 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i8 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i1, i8);
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + (i8 * 12 | 0) | 0;
 if ((i1 | 0) >= (i8 | 0)) {
  HEAP32[i5 >> 2] = i8;
  return;
 }
 i2 = i7 + 4 | 0;
 i3 = i7 + 8 | 0;
 i1 = i4 + (i1 * 12 | 0) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
  i1 = i1 + 12 | 0;
 } while (i1 >>> 0 < i6 >>> 0);
 HEAP32[i5 >> 2] = i8;
 return;
}

function __ZN18GfxFramebufferGLES12ApplyScissorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 192 | 0;
 i3 = i1 + 312 | 0;
 i4 = i1 + 196 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i1 + 316 >> 2] | 0)) if ((HEAP32[i1 + 200 >> 2] | 0) == (HEAP32[i1 + 320 >> 2] | 0)) if ((HEAP32[i1 + 204 >> 2] | 0) == (HEAP32[i1 + 324 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 mftCall_viiii(HEAP32[(HEAP32[i1 + 336 >> 2] | 0) + 120 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i1 + 200 >> 2] | 0, HEAP32[i1 + 204 >> 2] | 0);
 return;
}

function __ZN17Physics2DSettings21GetLayerCollisionMaskEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 if (i2 >>> 0 > 31) {
  HEAP32[i4 >> 2] = 31;
  __Z6FormatPKcz(i3, gb + 805697 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 805767 | 0, 452, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  i4 = -1;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i4 = HEAP32[(HEAP32[i1 + 168 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN14UnityAnalytics22HandleCustomEventCountEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv() | 0;
 i2 = getTempRet0() | 0;
 i3 = i4 + 752 | 0;
 i6 = i3;
 i6 = _i64Subtract(i1 | 0, i2 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0) | 0;
 i7 = getTempRet0() | 0;
 if (i7 >>> 0 > 0 | (i7 | 0) == 0 & i6 >>> 0 > 3599999) {
  i7 = i3;
  HEAP32[i7 >> 2] = i1;
  HEAP32[i7 + 4 >> 2] = i2;
  i2 = 1;
  i1 = i4 + 760 | 0;
 } else {
  i1 = i4 + 760 | 0;
  i2 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  if (i2 >>> 0 > i5 >>> 0) {
   i7 = 0;
   return i7 | 0;
  }
 }
 HEAP32[i1 >> 2] = i2;
 i7 = 1;
 return i7 | 0;
}

function __ZN12TreeRenderer19LODTreeInstanceData21ReleaseWindPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 80 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z39Joint_CUSTOM_INTERNAL_get_currentTorqueP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_(i4, i5 + 12 | 0, i3);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z18HandleSteppedCurveRK11KeyframeTplI8Vector3fES3_RS0_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 28 | 0;
 i3 = i1 + 4 | 0;
 i1 = i2 + 16 | 0;
 i2 = Math_fround(HEAPF32[i5 >> 2]) == Math_fround(inf);
 if (i2 | Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 if (Math_fround(HEAPF32[i5 + 4 >> 2]) == Math_fround(inf)) i6 = 5; else if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf)) i6 = 5;
 if ((i6 | 0) == 5) HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 if (!(Math_fround(HEAPF32[i5 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf))) return;
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z13RegisterClassI16SubstanceArchiveEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 585;
 HEAP32[i2 + 8 >> 2] = gb + 432020;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 184;
 HEAP32[i2 + 20 >> 2] = 56;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31872;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15AudioMixerGroupEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 934;
 HEAP32[i2 + 8 >> 2] = gb + 863848;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 273;
 HEAP32[i2 + 20 >> 2] = 72;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174800;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 147756 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i1 + 8 >> 2] = gb + 147756 + 80;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = gb + 147876 + 8;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if (i3 | 0) {
  i5 = HEAP32[HEAP32[i1 + 100 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i3 | 0);
 }
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
 STACKTOP = i4;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 < 12 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 < 12 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNK17AnimationPlayable15GetApplyMotionXEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[(HEAP32[i5 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i6 | 0) <= 0) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = 0;
 i4 = 0;
 do {
  i3 = i4;
  i2 = i5;
  while (1) {
   i2 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i2 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i2 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i2) break;
   if (!(HEAP32[i2 + 16 >> 2] | 0)) {
    i7 = 8;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 8) {
   i7 = 0;
   i1 = i1 | (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i6 | 0));
 return i1 | 0;
}

function __ZN5physx7NpShape19getMeshRefCountableEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 switch (HEAP32[i1 >> 2] | 0) {
 case 4:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = (i2 | 0) == 0 ? 0 : i2 + 8 | 0;
   return i2 | 0;
  }
 case 6:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i2 = (i2 | 0) == 0 ? 0 : i2 + 8 | 0;
   return i2 | 0;
  }
 case 5:
  {
   if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
   i2 = HEAP32[i1 + 36 >> 2] | 0;
   i2 = (i2 | 0) == 0 ? 0 : i2 + 8 | 0;
   return i2 | 0;
  }
 default:
  {
   i2 = 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 1 | 0;
 i2 = i6;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  i5 = i5 + 8 | 0;
  HEAP8[i5 >> 0] = 0;
  STACKTOP = i6;
  return;
 }
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) > -1) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 8 | 0, i4);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 HEAP32[i5 >> 2] = 0;
 i4 = i5 + 4 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i5 = i5 + 8 | 0;
 HEAP8[i5 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sc13ConstraintSim8getForceERNS_6PxVec3ES3_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f4 = Math_fround(HEAPF32[(HEAP32[i3 + 96 >> 2] | 0) + 68 >> 2]);
 f7 = Math_fround(f4 * Math_fround(HEAPF32[i3 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 HEAPF32[i2 >> 2] = f7;
 HEAPF32[i2 + 4 >> 2] = f5;
 HEAPF32[i2 + 8 >> 2] = f6;
 f6 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 16 >> 2]));
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 20 >> 2]));
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 24 >> 2]));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZN5physx2Sc10ClothShapeC2ERNS0_8ClothSimE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 90952 + 8;
 HEAP32[i3 + 4 >> 2] = 0;
 i1 = i3 + 8 | 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i3 + 12 | 0;
 HEAP32[i4 >> 2] = -1073741825;
 HEAP32[i4 + 4 >> 2] = 1073741823;
 __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE(i2, i3);
 HEAP32[i3 >> 2] = gb + 91124 + 8;
 i2 = __ZNK5physx2Sc8ClothSim7getCoreEv(i2) | 0;
 HEAP32[i3 + 20 >> 2] = i2;
 i2 = (__ZNK5physx2Sc9ClothCore13getClothFlagsEv(i2) | 0) & 4;
 HEAP8[i3 + 24 >> 0] = (i2 & 65535) >>> 2;
 if (!(i2 << 16 >> 16)) return;
 __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_10ClothShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 >> 2] | 0) | 0, i3);
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 1 | 0;
 i5 = i7;
 if (!(HEAP32[i6 + 284 >> 2] & 4096)) i1 = i6 + 108 | 0; else i1 = (HEAP32[i6 + 56 >> 2] | 0) + 268 | 0;
 i1 = HEAP8[i1 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 if (i3) i1 = (i1 & 255 | i2) & 255; else i1 = i1 & ((i2 ^ 255) & 255);
 HEAP8[i5 >> 0] = i1;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i6, i4, i5);
 STACKTOP = i7;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl8TransferI17RemapPPtrTransferEEvRT_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i7, 1);
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 i3 = HEAP32[i1 + 120 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i7);
  return;
 }
 i4 = i7 + 16 | 0;
 i5 = i7 + 36 | 0;
 i6 = i7 + 40 | 0;
 i1 = i2;
 do {
  i2 = HEAP32[i4 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
  if (HEAP8[i6 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i7);
 return;
}

function __ZN18LoadSceneOperation13CleanupMemoryEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 __ZN18AwakeFromLoadQueue5ClearEv(i3 + 180 | 0);
 i4 = i3 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 i3 = i3 + 140 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14Texture2DArray15ThreadedCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i4 = i2 + 108 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12MeshCollider5ResetEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30872 | 0) | 0;
  if (i1 | 0) {
   i2 = i4 + 64 | 0;
   if (!(HEAP32[i2 >> 2] | 0)) {
    i1 = __ZN10MeshFilter13GetSharedMeshEv(i1) | 0;
    if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) {
     HEAP32[i2 >> 2] = i1;
     i1 = HEAP32[i3 >> 2] | 0;
     if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, 0);
    }
   }
  }
 }
 HEAP8[i4 + 60 >> 0] = 0;
 HEAP8[i4 + 121 >> 0] = 0;
 HEAPF32[i4 + 124 >> 2] = Math_fround(.00999999977);
 HEAP8[i4 + 120 >> 0] = 1;
 return;
}

function __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 24 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 32 >> 2] | 0);
 __ZN7mecanim9animation19DestroyAnimationSetEPNS0_12AnimationSetERNS_6memory9AllocatorE(HEAP32[i1 + 36 >> 2] | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN10MemoryPoolD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 12 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 24 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (i3 | 0) {
  i3 = i4 + 44 | 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 i2 = i4 + 28 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  i1 = i4 + 16 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i1);
  HEAP32[i5 >> 2] = 0;
 } else i1 = i4 + 16 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 + 32 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i1);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __Z47Renderer_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK8Renderer21GetWorldToLocalMatrixEv(i1, i4);
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z47Renderer_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK8Renderer21GetLocalToWorldMatrixEv(i1, i4);
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z38Joint_CUSTOM_INTERNAL_get_currentForceP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 12 | 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_(i4, i3, i5);
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i5;
  return;
 }
}

function __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i6, i2) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP8[i2 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 i1 = i5 ? HEAP32[i2 >> 2] | 0 : i2;
 i4 = i5 ? HEAP32[i2 + 4 >> 2] | 0 : i4 & 255;
 L1 : do if (i4) {
  i5 = i4 + -1 | 0;
  i3 = 0;
  i2 = 0;
  while (1) {
   if ((HEAP8[i1 + (i5 + i2) >> 0] | 0) == 47) break;
   i2 = ~i3;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i4 >>> 0) break L1;
  }
  i1 = i1 + i4 + i2 | 0;
 } while (0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i1, _strlen(i1) | 0);
 return;
}

function __Z13RegisterClassI4HaloEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 534;
 HEAP32[i2 + 8 >> 2] = gb + 374123;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 122;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30352;
 HEAP32[i2 + 44 >> 2] = fb + 14;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = fb + 15;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15ResourceManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 590;
 HEAP32[i2 + 8 >> 2] = gb + 450701;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 147;
 HEAP32[i2 + 20 >> 2] = 64;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31432;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15LightProbeGroupEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 559;
 HEAP32[i2 + 8 >> 2] = gb + 402117;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 220;
 HEAP32[i2 + 20 >> 2] = 48;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30552;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI14Texture2DArrayEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 570;
 HEAP32[i2 + 8 >> 2] = gb + 411274;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 187;
 HEAP32[i2 + 20 >> 2] = 112;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32072;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _raccess_make_file_name(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 i5 = _strlen(i1) | 0;
 i5 = (_strlen(i4) | 0) + i5 | 0;
 i3 = _UNITY_ft_mem_alloc(i2, i5 + 1 | 0, i7) | 0;
 if (HEAP32[i7 >> 2] | 0) {
  i7 = 0;
  STACKTOP = i6;
  return i7 | 0;
 }
 i2 = _strrchr(i1, 47) | 0;
 if (!i2) HEAP8[i3 >> 0] = 0; else {
  i7 = i2 - i1 + 1 | 0;
  _strncpy(i3, i1, i7) | 0;
  HEAP8[i3 + i7 >> 0] = 0;
  i1 = i2 + 1 | 0;
 }
 _strncat(i3, i4, i5 - (_strlen(i3) | 0) | 0) | 0;
 _strncat(i3, i1, i5 - (_strlen(i3) | 0) | 0) | 0;
 i7 = i3;
 STACKTOP = i6;
 return i7 | 0;
}

function _raccess_guess_darwin_newvfs(i2, i1, i4, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i3 = _strlen(i4) | 0;
 i5 = _UNITY_ft_mem_alloc(HEAP32[i2 >> 2] | 0, i3 + 18 | 0, i1) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i8 = i1;
  STACKTOP = i6;
  return i8 | 0;
 }
 _memcpy(i5 | 0, i4 | 0, i3 | 0) | 0;
 i1 = i5 + i3 | 0;
 i2 = gb + 947078 | 0;
 i3 = i1 + 18 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i7 >> 2] = i5;
 HEAP32[i8 >> 2] = 0;
 i8 = 0;
 STACKTOP = i6;
 return i8 | 0;
}

function _cff_size_done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i2 + 656 >> 2] | 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i4) return;
 i1 = HEAP32[(HEAP32[i2 + 656 >> 2] | 0) + 2952 >> 2] | 0;
 i2 = _UNITY_FT_Get_Module(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1006904 | 0) | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i1 = mftCall_ii(i1 | 0, i2 | 0) | 0;
 if (!i1) return;
 i2 = i1 + 8 | 0;
 mftCall_vi(HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0);
 i1 = HEAP32[i3 + 1896 >> 2] | 0;
 if (!i1) return;
 do {
  i1 = i1 + -1 | 0;
  mftCall_vi(HEAP32[i2 >> 2] | 0, HEAP32[i4 + 4 + (i1 << 2) >> 2] | 0);
 } while ((i1 | 0) != 0);
 return;
}

function __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getConstraintsEPPNS_12PxConstraintEjj(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i1 + 40 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = i1;
 i4 = 0;
 i1 = 0;
 do {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  if (!(i4 >>> 0 < i8 >>> 0 | (i1 >>> 0 >= i7 >>> 0 ? 1 : (HEAP8[i3 + (i4 << 3) >> 0] | 0) != 0))) {
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i3 + (i4 << 3) + 4 >> 2];
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = i1 + 1 | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i2 + 40 >> 2] | 0) >>> 0);
 return i1 | 0;
}

function __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i5) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i5) | 0) if (!(HEAP32[i6 >> 2] | 0)) {
  i5 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i5 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2, i3, i4) | 0;
 return i6 | 0;
}

function __ZN4FMOD6System9unlockDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869982;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869982;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869982;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN14Texture2DArray14DestroyTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 i4 = i2 + 108 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN10HumanTrait13GetMuscleNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[gb + 1467160 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i2 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 >> 4;
 if (!i6) return;
 if (i6 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i5 = __Znwj(i5) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i5 + (i6 << 4);
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 return;
}

function __Z7HaloTexP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0;
 i5 = i5 >> 1;
 i6 = i6 >> 1;
 f7 = Math_fround(Math_fround(Math_fround(i3 - i5 | 0) + Math_fround(.5)) / Math_fround(i5 | 0));
 f8 = Math_fround(Math_fround(Math_fround(i4 - i6 | 0) + Math_fround(.5)) / Math_fround(i6 | 0));
 f8 = Math_fround(Math_fround(f7 * f7) + Math_fround(f8 * f8));
 i6 = f8 > Math_fround(1.0);
 f8 = Math_fround(Math_fround(Math_fround(Math_fround(1.0) - (i6 ? Math_fround(1.0) : f8)) * Math_fround(255.0)) + Math_fround(.5));
 i6 = f8 >= Math_fround(0.0);
 f7 = Math_fround(f8 + Math_fround(-.99999994));
 HEAP8[i2 >> 0] = ~~(i6 ? f8 : f7);
 return;
}

function __Z20MonoCreateGameObjectPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 if (!i1) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, gb + 390555 | 0) | 0; else __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i2, i1) | 0;
 HEAP32[i3 >> 2] = 0;
 i3 = __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz(i2, gb + 1044255 | 0, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i4;
 return i3 | 0;
}

function __Z13RegisterClassIN5Unity9ComponentEEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26492;
 HEAP32[i2 + 4 >> 2] = fb + 526;
 HEAP32[i2 + 8 >> 2] = gb + 589668;
 HEAP32[i2 + 12 >> 2] = gb + 1047115;
 HEAP32[i2 + 16 >> 2] = 2;
 HEAP32[i2 + 20 >> 2] = 32;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29020;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI15OcclusionPortalEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29020;
 HEAP32[i2 + 4 >> 2] = fb + 542;
 HEAP32[i2 + 8 >> 2] = gb + 379423;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 41;
 HEAP32[i2 + 20 >> 2] = 76;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31032;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13WebCamTextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 518;
 HEAP32[i2 + 8 >> 2] = gb + 364173;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 158;
 HEAP32[i2 + 20 >> 2] = 128;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 26112;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13SparseTextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 566;
 HEAP32[i2 + 8 >> 2] = gb + 410430;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 171;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31712;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13BuildSettingsEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 588;
 HEAP32[i2 + 8 >> 2] = gb + 443248;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 141;
 HEAP32[i2 + 20 >> 2] = 176;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29792;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z11RequireTypePKcS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i4 = i7 + 12 | 0;
 i5 = __Z12OptionalTypePKcS0_S0_(i1, i2, i3) | 0;
 if (i5 | 0) {
  STACKTOP = i7;
  return i5 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 464083 | 0, i6);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 464113 | 0, 120, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i7;
 return i5 | 0;
}

function __Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i7 = i1;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i1 = __Z31scripting_method_get_returntype21ScriptingMethodIl2Cpp(i4) | 0;
 if (!i1) {
  i7 = 0;
  STACKTOP = i3;
  return i7 | 0;
 }
 i7 = __Z25scripting_class_from_typePK10Il2CppType(i1) | 0;
 i7 = (i7 | 0) == (HEAP32[i2 + 8 >> 2] | 0);
 STACKTOP = i3;
 return i7 | 0;
}

function _wcwidth(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 do if (i1 >>> 0 < 255) i1 = (i1 + 1 & 127) >>> 0 > 32 ? 1 : ((i1 | 0) != 0) << 31 >> 31; else {
  if ((i1 & -65538) >>> 0 < 65534) {
   i2 = i1 >> 8;
   i3 = i1 >>> 3 & 31;
   i1 = 1 << (i1 & 7);
   if ((HEAPU8[((HEAPU8[gb + 1066334 + i2 >> 0] | 0) << 5 | i3) + (gb + 1066334) >> 0] | 0) & i1 | 0) {
    i1 = 0;
    break;
   }
   i1 = ((HEAPU8[((HEAPU8[gb + 1068254 + i2 >> 0] | 0) << 5 | i3) + (gb + 1068254) >> 0] | 0) & i1 | 0) == 0 ? 1 : 2;
   break;
  }
  if ((i1 & 65534 | 0) == 65534) i1 = -1; else if ((i1 & -131072 | 0) == 131072) i1 = 2; else return ((i1 + -917760 | 0) < 239 | ((i1 | 0) == 917505 | (i1 + -917536 | 0) >>> 0 < 95)) & 1 ^ 1 | 0;
 } while (0);
 return i1 | 0;
}

function __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 120080 + 8;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 16 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZNK9GfxDevice19GetTotalBufferCountEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = HEAP32[i4 + 4516 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) i5 = 0; else {
  i1 = 0;
  do {
   i1 = ((HEAP32[((i2 | 0) == 0 ? 0 : i2 + -4 | 0) + 20 >> 2] | 0) == 0 & 1) + i1 | 0;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  i5 = i1;
 }
 i3 = HEAP32[i4 + 4520 >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = 0;
  i5 = i4 + i5 | 0;
  return i5 | 0;
 } else i1 = 0;
 do {
  i1 = ((HEAP32[((i2 | 0) == 0 ? 0 : i2 + -4 | 0) + 20 >> 2] | 0) == 0 & 1) + i1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i3 | 0));
 i5 = i1 + i5 | 0;
 return i5 | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getConstraintsEPPNS_12PxConstraintEjj(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 16 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i1 + 40 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i2 = i1;
 i4 = 0;
 i1 = 0;
 do {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  if (!(i4 >>> 0 < i8 >>> 0 | (i1 >>> 0 >= i7 >>> 0 ? 1 : (HEAP8[i3 + (i4 << 3) >> 0] | 0) != 0))) {
   HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i3 + (i4 << 3) + 4 >> 2];
   i2 = HEAP32[i5 >> 2] | 0;
   i1 = i1 + 1 | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i2 + 40 >> 2] | 0) >>> 0);
 return i1 | 0;
}

function __ZNK13WheelCollider14GetMotorTorqueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(__ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj(HEAP32[i2 + 56 >> 2] | 0, HEAP32[i3 >> 2] | 0));
 return Math_fround(f4);
}

function __ZNK13WheelCollider14GetBrakeTorqueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(__ZNK5physx16PxVehicleNoDrive14getBrakeTorqueEj(HEAP32[i2 + 56 >> 2] | 0, HEAP32[i3 >> 2] | 0));
 return Math_fround(f4);
}

function __ZN9Transform30SetPositionWithoutNotificationERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i6 = i3;
 i4 = i3 + 8 | 0;
 i8 = i1 + 32 | 0;
 i1 = HEAP32[i8 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = i1;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z10SetGlobalT15TransformAccessRKN4math7_float3E(i5, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx14SapPairManager12shrinkMemoryEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 + 28 >> 2] | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = (i1 >>> 16 | i1) + 1 | 0;
 i4 = i6 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 i5 = HEAP32[i6 + 16 >> 2] | 0;
 i3 = i1 >>> 0 < i5 >>> 0;
 if (i3 & (i2 | 0) == (i5 | 0)) return;
 i1 = i3 ? i5 : i1;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i6 + 36 >> 2] = i1 + -1;
 if (i1 >>> 0 > i5 >>> 0) i1 = 1; else if (i1 >>> 0 > (HEAP32[i6 + 12 >> 2] | 0) >>> 2 >>> 0) i1 = i1 >>> 0 <= (HEAP32[i6 + 32 >> 2] | 0) >>> 2 >>> 0; else i1 = 1;
 __ZN5physx14SapPairManager12reallocPairsEb(i6, i1);
 return;
}

function __ZN16AnimationManager15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(16, gb + 63320 | 0, 16, gb + 906919 | 0, gb + 1576256 | 0, gb + 906936 | 0, 34) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i2;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1465160 >> 2] = i1;
 HEAP32[gb + 1115296 + 148 >> 2] = fb + 300;
 HEAP32[gb + 1115296 + 220 >> 2] = fb + 301;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 907015 | 0, gb + 1576256 | 0, gb + 907046 | 0, 43) | 0;
 HEAP32[i1 >> 2] = gb + 179088 + 8;
 __Z19pop_allocation_rootv();
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(i1);
 return;
}

function __ZN13SpringJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(112, i1, 16, gb + 1048932 | 0, 0, gb + 807260 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 157672 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11UnityEngine7Connect14RemoteSettings9GetStringERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEES8_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i2, i1) | 0;
 if ((i1 | 0) != (i2 + 4 | 0)) if ((HEAP32[i1 + 48 >> 2] | 0) == 3) {
  i3 = HEAP32[i1 + 64 >> 2] | 0;
  i3 = (i3 | 0) == 0 ? i1 + 68 | 0 : i3;
  return i3 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i3 = (i2 | 0) == 0 ? i3 + 4 | 0 : i2;
 return i3 | 0;
}

function __ZN10Matrix4x4faSERK10Matrix3x3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 32 >> 2];
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __Z55Animator_CUSTOM_INTERNAL_CALL_SetLookAtPositionInternalP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  __ZN8Animator17SetLookAtPositionE8Vector3f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z46Camera_CUSTOM_INTERNAL_get_cameraToWorldMatrixP12Il2CppObjectP10Matrix4x4f(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i5 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK6Camera22GetCameraToWorldMatrixEv(i1, i4);
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 }
}

function __Z34GetUnityConnectScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1469184 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1044015 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1469184 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044144 | 0, gb + 1044159 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 407 | 0, fb + 408 | 0);
 i2 = HEAP32[gb + 1469184 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z31Sprite_CUSTOM_Internal_GetPivotP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f5 = Math_fround(HEAPF32[i3 + 40 >> 2]);
  f4 = Math_fround(HEAPF32[i3 + 44 >> 2]);
  f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 72 >> 2]));
  f4 = Math_fround(f4 * Math_fround(HEAPF32[i3 + 76 >> 2]));
  f5 = Math_fround(f5);
  f4 = Math_fround(f4);
  i3 = i2;
  HEAPF32[i3 >> 2] = f5;
  HEAPF32[i3 + 4 >> 2] = f4;
  return;
 }
}

function __Z13RegisterClassI13RenderTextureEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 564;
 HEAP32[i2 + 8 >> 2] = gb + 590339;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 84;
 HEAP32[i2 + 20 >> 2] = 160;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31392;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13ConstantForceEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 846;
 HEAP32[i2 + 8 >> 2] = gb + 735691;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 75;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 112144;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI13ComputeShaderEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 601;
 HEAP32[i2 + 8 >> 2] = gb + 469287;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 72;
 HEAP32[i2 + 20 >> 2] = 256;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29872;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI12CubemapArrayEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 555;
 HEAP32[i2 + 8 >> 2] = gb + 397025;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 188;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29952;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11OffMeshLinkEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 907;
 HEAP32[i2 + 8 >> 2] = gb + 842663;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 191;
 HEAP32[i2 + 20 >> 2] = 104;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 169336;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11NavMeshDataEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 909;
 HEAP32[i2 + 8 >> 2] = gb + 843566;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 238;
 HEAP32[i2 + 20 >> 2] = 120;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 169504;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK16BaseVideoTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i4, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = i4 + 80 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i6 = 0;
  STACKTOP = i3;
  return i6 | 0;
 }
 i7 = HEAP32[i4 + 84 >> 2] | 0;
 i8 = HEAP32[i4 + 88 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 224 >> 2] | 0, i4 | 0) | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i1, i7, i8, i7 << 2, i4, HEAP32[i2 >> 2] | 0);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i1, i6);
 i6 = 1;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZNK12RemoveByName17ShouldRemoveStateEP14AnimationState(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0, i9 = 0;
 if (!i7) {
  i8 = 0;
  return i8 | 0;
 }
 i3 = i7 + 112 | 0;
 i6 = i1 + 4 | 0;
 i8 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i8 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i7 + 116 >> 2] | 0; else i2 = i8 & 255;
 i9 = HEAP8[i6 + 11 >> 0] | 0;
 i5 = i9 << 24 >> 24 < 0;
 if ((i2 | 0) != ((i5 ? HEAP32[i1 + 8 >> 2] | 0 : i9 & 255) | 0)) {
  i9 = 0;
  return i9 | 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i4) {
  i3 = HEAP32[i3 >> 2] | 0;
  i2 = i5 ? i1 : i6;
  i1 = HEAP32[i7 + 116 >> 2] | 0;
 } else {
  i2 = i5 ? i1 : i6;
  i1 = i8 & 255;
 }
 i9 = (_strncmp(i3, i2, i1) | 0) == 0;
 return i9 | 0;
}

function __ZN8GUIStyle15SetMouseTooltipER8GUIStateRK11UTF16StringRK5RectTIfE(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 i1 = i2 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 i2 = __Znwj(20) | 0;
 i9 = gb + 63672 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i3;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i2, i6, i4);
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i5;
 return;
}

function __ZN5Unity11SpringJoint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(116, i1, 16, gb + 1048932 | 0, 0, gb + 781892 | 0, 18) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN5Unity5JointC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 113708 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5Umbra8memEqualEPKvS1_j(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = i5 >>> 2;
 L1 : do if (i4) {
  i3 = 0;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
    i1 = 0;
    break;
   }
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
   i3 = i3 + 1 | 0;
   if (i3 >>> 0 >= i4 >>> 0) break L1;
  }
  return i1 | 0;
 } while (0);
 i4 = i5 & 3;
 if (!i4) {
  i5 = 1;
  return i5 | 0;
 }
 i3 = 0;
 while (1) {
  if ((HEAP8[i1 >> 0] | 0) != (HEAP8[i2 >> 0] | 0)) {
   i1 = 0;
   i2 = 8;
   break;
  }
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i4 >>> 0) {
   i1 = 1;
   i2 = 8;
   break;
  } else {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZN4FMOD6System7lockDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6 + 8 | 0;
 i3 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i4 >> 2] = 78;
  HEAP32[i4 + 4 >> 2] = gb + 869720;
  _printf(gb + 857490 | 0, i4) | 0;
  HEAP32[i5 >> 2] = 78;
  HEAP32[i5 + 4 >> 2] = gb + 869720;
  _printf(gb + 853343 | 0, i5) | 0;
  i5 = 78;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869720;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN20SpeedTreeWindManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = i3;
 if (i3 | 0) {
  i5 = i1 + 24 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  if ((i6 | 0) != (i3 | 0)) HEAP32[i5 >> 2] = i6 + (~((i6 + -4 - i4 | 0) >>> 2) << 2);
  i6 = HEAP32[i1 + 32 >> 2] | 0;
  HEAP32[i2 >> 2] = 62;
  HEAP32[i2 + 4 >> 2] = i6;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) <= -1) {
  STACKTOP = i7;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i7;
 return;
}

function __ZN18PlatformEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(92, i1, 16, gb + 1048932 | 0, 0, gb + 806958 | 0, 12) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 156480 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13UnityProfiler17GetAvailableFrameEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i1 = i3 + 20 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i3 = 0;
   return i3 | 0;
  }
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 68 | 0;
 if ((HEAP32[i2 + 1128 >> 2] | 0) >= (HEAP32[i1 >> 2] | 0)) {
  i3 = i2;
  return i3 | 0;
 }
 __ZN17ProfilerFrameDataD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
 i2 = __ZnwjRK10MemLabelIdiPKci(1232, gb + 63576 | 0, 16, gb + 585151 | 0, 953) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i4 = i3 + 84 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 1 | 0;
 HEAP32[i4 >> 2] = i3;
 __ZN17ProfilerFrameDataC2Eii(i2, i1, i3);
 i3 = i2;
 return i3 | 0;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 590111 | 0, 0, 0);
 __ZN13MonoBehaviour18TransferEngineDataI24GenerateTypeTreeTransferEE4PPtrI10MonoScriptERT_(i1, i2) | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) {
  __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
  return;
 }
 i4 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI24GenerateTypeTreeTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i4, HEAP32[i1 + 56 >> 2] | 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12MeshColliderD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 112784 + 8;
 i1 = i4 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = gb + 29060 + 8;
  HEAP32[i4 >> 2] = gb + 26392 + 8;
  __ZdlPv(i4);
  return;
 }
 i2 = i4 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 HEAP32[i4 >> 2] = gb + 29060 + 8;
 HEAP32[i4 >> 2] = gb + 26392 + 8;
 __ZdlPv(i4);
 return;
}

function __ZN12CubemapArray15ThreadedCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine7Connect15AppInstallEventC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1040615 | 0, 1);
 HEAP32[i1 >> 2] = gb + 188916 + 8;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN10HumanTrait11GetBoneNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[gb + 1467164 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = i2 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i6 = i5 >> 4;
 if (!i6) return;
 if (i6 >>> 0 > 268435455) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1);
 i5 = __Znwj(i5) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i5 + (i6 << 4);
 __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j(i1, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0, i6);
 return;
}

function __ZN10Collider2D27UpdateColliderMaterialStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i5 = i6;
 i1 = i2 + 72 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i2, i3, i5);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i7 = HEAP32[i2 + 60 >> 2] | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  i3 = HEAP32[i5 >> 2] | 0;
  i2 = i7 + (i1 << 2) | 0;
  i1 = i7;
  do {
   i7 = HEAP32[i1 >> 2] | 0;
   HEAP32[i7 + 36 >> 2] = i4;
   HEAP32[i7 + 40 >> 2] = i3;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i2 | 0));
 }
 STACKTOP = i6;
 return;
}

function __Z59CullingGroup_CUSTOM_INTERNAL_CALL_SetDistanceReferencePointP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4); else {
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i6;
  HEAP32[i3 + 8 >> 2] = i4;
  __ZN12CullingGroup25SetDistanceReferencePointERKN4math7_float3E(i1, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z43GameObject_CUSTOM_Internal_CreateGameObjectP12Il2CppObjectP12Il2CppString(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 12 | 0;
 i3 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if (__ZNK11ICallString6IsNullEv(i2) | 0) i1 = __Z20MonoCreateGameObjectPKc(0) | 0; else {
  __ZNK11ICallString6ToUTF8Ev(i3, i2);
  i1 = __Z20MonoCreateGameObjectPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 }
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i4, i1) | 0;
 STACKTOP = i5;
 return;
}

function __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, f6 = f0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 f6 = Math_fround(__ZNK6Camera23CalculateShadowDistanceEv(i1));
 HEAPF32[i3 >> 2] = f6;
 HEAPF32[i4 >> 2] = f6;
 __ZNK6Camera11GetPositionEv(i7, i1);
 i1 = __ZL29CalculateSphericalShadowRangeRK6CameraR8Vector3fRf(i1, i7, i4) | 0;
 i3 = HEAP32[i7 + 4 >> 2] | 0;
 i4 = HEAP32[i7 + 8 >> 2] | 0;
 f6 = Math_fround(i1 & 1);
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAPF32[i2 + 12 >> 2] = f6;
 STACKTOP = i5;
 return;
}

function __Z24Material_CUSTOM_GetFloatP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  f7 = Math_fround(__ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE(i5, i1));
  STACKTOP = i6;
  return Math_fround(f7);
 }
 return Math_fround(0.0);
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP16[i3 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 2);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i5);
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  i1 = 0;
  do {
   i6 = i5 + (i1 << 4) | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) * f3);
   i6 = i5 + (i1 << 4) + 8 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) / f3);
   i6 = i5 + (i1 << 4) + 12 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) / f3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __Z13RegisterClassI11MonoManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 597;
 HEAP32[i2 + 8 >> 2] = gb + 463981;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 116;
 HEAP32[i2 + 20 >> 2] = 236;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32272;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11AssetBundleEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 519;
 HEAP32[i2 + 8 >> 2] = gb + 365485;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 142;
 HEAP32[i2 + 20 >> 2] = 188;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 27368;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10AudioMixerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 933;
 HEAP32[i2 + 8 >> 2] = gb + 862985;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 240;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 174128;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _UnityReplayKitTriggerBroadcastStatusCallback(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 240 | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 i2 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 if (i2 | 0) {
  __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc(i5, i2, gb + 581865 | 0);
  __ZN18ScriptingArguments10AddBooleanEb(i5, i3);
  __ZN18ScriptingArguments9AddStringEPKc(i5, i4 | 0 ? i4 : gb + 1576256 | 0);
  HEAP32[i6 >> 2] = 0;
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i5, i6, 0) | 0;
 }
 __Z23scripting_gchandle_freej(i1);
 STACKTOP = i7;
 return;
}

function _forward_DCT(i1, i2, i3, i11, i4, i10, i12) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i11 = i11 | 0;
 i4 = i4 | 0;
 i10 = i10 | 0;
 i12 = i12 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = HEAP32[i1 + 344 >> 2] | 0;
 i5 = HEAP32[i9 + 20 + (HEAP32[i2 + 16 >> 2] << 2) >> 2] | 0;
 i6 = HEAP32[i9 + 8 >> 2] | 0;
 i7 = HEAP32[i9 + 12 >> 2] | 0;
 i8 = HEAP32[i9 + 16 >> 2] | 0;
 i9 = HEAP32[i9 + 36 >> 2] | 0;
 i3 = i3 + (i4 << 2) | 0;
 if (!i12) return; else {
  i2 = 0;
  i1 = i10;
 }
 while (1) {
  mftCall_viii(i7 | 0, i3 | 0, i1 | 0, i9 | 0);
  mftCall_vi(i6 | 0, i9 | 0);
  mftCall_viii(i8 | 0, i11 + (i2 << 7) | 0, i5 | 0, i9 | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i12 | 0)) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function __ZN9Transform19GetLocalEulerAnglesEN4math13RotationOrderE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 24 | 0;
 i5 = i4 + 8 | 0;
 i7 = i4;
 i9 = i2 + 32 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i2 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __Z13GetLocalEuler15TransformAccessN4math13RotationOrderE(i5, i6, i3);
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN9AudioClip16SetMoviePlaybackEP13MoviePlayback(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return;
 __ZN9AudioClip16EnableLegacyModeEv(i4);
 i3 = i4 + 124 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 44 >> 2] = i2;
 if (!i2) return;
 HEAP8[i1 + 40 >> 0] = 1;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if (i2) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 36 >> 2] = 0;
 }
 HEAP32[i4 + 36 >> 2] = 1;
 HEAP32[i4 + 32 >> 2] = 22050;
 HEAP32[i4 + 40 >> 2] = 16;
 HEAP32[i1 + 4 >> 2] = 2;
 HEAP32[i1 >> 2] = 16;
 HEAP32[i1 + 48 >> 2] = 3;
 return;
}

function __ZN8GUIState37InvokeScriptingMakeMasterEventCurrentEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 248 | 0;
 i4 = i2;
 i5 = i2 + 240 | 0;
 i8 = __Z24GetIMGUIScriptingClassesv() | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i4, i3);
 __ZN18ScriptingArguments6AddIntEi(i4, i1);
 HEAP32[i3 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i4, i3, 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZN4FMOD5Sound7getModeEPj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP32[i3 >> 2] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870065;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN39AssetBundleLoadFromMemoryAsyncOperation20ExecuteSynchronouslyEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i3, i1, i2) | 0) __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(i3) | 0;
 if (!(__ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i3) | 0)) {
  i1 = i3 + 92 | 0;
  if (HEAP32[i1 >> 2] | 0) if ((HEAP32[i1 >> 2] | 0) != 1) {
   i2 = i3 + 96 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
 return;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 60 | 0, i4);
 i1 = i1 + 64 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 }
 if (!i5) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12CubemapArray14DestroyTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 92 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine15PlatformWrapper34GetRenderTextureFormatSupportFlagsEv() {
 var i1 = 0, i2 = 0;
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 234 >> 0] | 0) == 0;
 i1 = i1 ? 1 : 3;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 236 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 4;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 235 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 8;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 244 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 16;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 241 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 32;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 247 >> 0] | 0) == 0;
 i1 = i2 ? i1 : i1 | 64;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 246 >> 0] | 0) == 0;
 return (i2 ? i1 : i1 | 128) | 0;
}

function __Z40Terrain_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) {
  i7 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN7Terrain11RemoveTreesERK8Vector2ffi(i6, i5, f3, i4);
  STACKTOP = i7;
  return;
 }
}

function __Z13RegisterClassI12ScriptMapperEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 604;
 HEAP32[i2 + 8 >> 2] = gb + 476527;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 94;
 HEAP32[i2 + 20 >> 2] = 60;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31512;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI11PreloadDataEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 594;
 HEAP32[i2 + 8 >> 2] = gb + 461092;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 150;
 HEAP32[i2 + 20 >> 2] = 64;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31112;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10MonoScriptEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31992;
 HEAP32[i2 + 4 >> 2] = fb + 593;
 HEAP32[i2 + 8 >> 2] = gb + 455653;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 115;
 HEAP32[i2 + 20 >> 2] = 144;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 27480;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _valloc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i4 = i2 & -16 ^ 1431655768;
  HEAP32[i2 >> 2] = i4;
  HEAP32[gb + 1470876 >> 2] = i4;
  i2 = 4096;
  i2 = _memalign(i2, i1) | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i4 = HEAP32[gb + 1470876 + 4 >> 2] | 0;
  i4 = _memalign(i4, i1) | 0;
  STACKTOP = i3;
  return i4 | 0;
 }
 return 0;
}

function __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 147756 + 8;
 HEAP32[i4 >> 2] = gb + 147756 + 52;
 HEAP32[i4 + 4 >> 2] = gb + 147756 + 80;
 i2 = i4 + 12 | 0;
 HEAP32[i2 >> 2] = gb + 147876 + 8;
 i3 = HEAP32[i4 + 104 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[HEAP32[i4 + 96 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i3 | 0);
 }
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i1);
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 < 31 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 3) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 366 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 + -1 | 0) >>> 0 < 31 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 3) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 366 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNK5Umbra7ImpTile11getNodeDataEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i3) {
  i3 = -1;
  return i3 | 0;
 }
 i4 = HEAP32[i1 + 24 >> 2] & 31;
 i2 = Math_imul(i4, i2) | 0;
 i3 = i1 + i3 + (i2 >> 5 << 2) | 0;
 i5 = i3 + 4 | 0;
 i2 = i2 & 31;
 i1 = (1 << i4) + -1 | 0;
 i2 = ((HEAPU8[i5 >> 0] | HEAPU8[i5 + 1 >> 0] << 8 | HEAPU8[i5 + 2 >> 0] << 16 | HEAPU8[i5 + 3 >> 0] << 24) << 32 - i2 & -1 << (i2 ^ 31) | (HEAPU8[i3 >> 0] | HEAPU8[i3 + 1 >> 0] << 8 | HEAPU8[i3 + 2 >> 0] << 16 | HEAPU8[i3 + 3 >> 0] << 24) >>> i2) & i1;
 if (!(i2 & 1 << i4 + -1)) {
  i5 = i2;
  return i5 | 0;
 } else return ((i2 | 0) == (i1 | 0) ? -1 : i2 & i1 >>> 1 | -2147483648) | 0;
 return 0;
}

function __ZNK22BuiltinResourceManager21GetResourceInstanceIDEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 >> 2] = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 i1 = __ZNK13sorted_vectorIN22BuiltinResourceManager8ResourceENSt3__24lessIS1_EENS2_9allocatorIS1_EEE4findIS1_EENS2_11__wrap_iterIPKS1_EERKT_(i3, i5) | 0;
 if ((i1 | 0) == (HEAP32[i3 + 4 >> 2] | 0)) {
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN5physx2Gu29checkOverlapSphere_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 20 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 f5 = Math_fround(Math_fround(Math_fround(f7 * f7) + Math_fround(f6 * f6)) + Math_fround(f5 * f5));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i3 + 12 >> 2]));
 return f5 <= Math_fround(f4 * f4) | 0;
}

function __ZN5physx24NpPtrTableStorageManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 146776 + 8;
 __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i1 + 600 | 0);
 __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i1 + 304 | 0);
 __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEED2Ev(i1 + 8 | 0);
 i1 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN4FMOD3DSP9getBypassEPb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP8[i3 >> 0] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859902;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD3DSP9getActiveEPb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   if (!i3) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
   HEAP8[i3 >> 0] = 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862463;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES12SetSRGBWriteEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 7186 | 0;
 HEAP8[i2 >> 0] = i1 & 1;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0)) return;
 i1 = HEAP8[i2 >> 0] | 0;
 i1 = i1 << 24 >> 24 != 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 536 >> 0] | 0) i1 = i1 & (HEAP32[i5 + 7192 >> 2] | 0) < 1;
 i3 = i1 & 1;
 i4 = i5 + 7188 | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) return;
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 653 >> 0] | 0) {
  i2 = i5 + 4620 | 0;
  if (i1) {
   __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i2, 6);
   break;
  } else {
   __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i2, 6);
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i3;
 return;
}

function __ZN13ComputeBuffer17ReloadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 4 | 0;
 i8 = i2;
 i6 = __Z25GetUncheckedRealGfxDevicev() | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 744 >> 2] | 0, i6 | 0) | 0;
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 804 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 mftCall_viiiii(i7 | 0, i6 | 0, i5 | 0, i4 | 0, i3 | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN12CachedWriter11Align4WriteEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i2 = HEAP32[i3 >> 2] | 0;
 i6 = i2 - (HEAP32[i3 + 4 >> 2] | 0) | 0;
 i6 = (i6 + 3 & -4) - i6 | 0;
 HEAP8[i4 >> 0] = 0;
 if (!i6) {
  STACKTOP = i7;
  return;
 }
 i5 = i3 + 8 | 0;
 i1 = 0;
 while (1) {
  if ((i2 + 1 | 0) >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0) {
   HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i3, i4, 1);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i6 | 0)) break;
  i2 = HEAP32[i3 >> 2] | 0;
 }
 STACKTOP = i7;
 return;
}

function __Z38Collider_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z31GetUnityConnectScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1469184 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1044015 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1469184 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044144 | 0, gb + 1044159 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 407 | 0, fb + 408 | 0);
 i2 = HEAP32[gb + 1469184 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z13RegisterClassI11TimeManagerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28760;
 HEAP32[i2 + 4 >> 2] = fb + 587;
 HEAP32[i2 + 8 >> 2] = gb + 441051;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 5;
 HEAP32[i2 + 20 >> 2] = 216;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31952;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI10FlareLayerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 531;
 HEAP32[i2 + 8 >> 2] = gb + 377883;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 124;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30152;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z12GenerateHashPKhj(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i5 = i7 + 4 | 0;
 __Z15ComputeSHA1HashPKhjPh(i1 | 0, i2 | 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i4, 40, 0);
 i3 = i4 + 11 | 0;
 i1 = 0;
 do {
  if ((HEAP8[i3 >> 0] | 0) < 0) i2 = HEAP32[i4 >> 2] | 0; else i2 = i4;
  HEAP32[i6 >> 2] = HEAPU8[i5 + i1 >> 0];
  _sprintf(i2 + (i1 << 1) | 0, gb + 612085 | 0, i6) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 STACKTOP = i7;
 return;
}

function _clogf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i9 = i3 + 8 | 0;
 i7 = i3;
 i8 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i9 >> 2] = i8;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i9 + 4 >> 2];
 f5 = Math_fround(_cabsf(i6));
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 f4 = Math_fround(_cargf(i6));
 HEAPF32[i1 >> 2] = Math_fround(+Math_log(+f5));
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZNSt3__211__libcpp_dbD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i3 = i5 + 4 | 0;
  while (1) {
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) break;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    _free(HEAP32[i1 >> 2] | 0);
   }
   i1 = i1 + 4 | 0;
  }
  _free(HEAP32[i5 >> 2] | 0);
 }
 i4 = i5 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i3 = i5 + 16 | 0;
  while (1) {
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) break;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 | 0) {
    __ZNSt3__28__i_nodeD2Ev(i2);
    _free(HEAP32[i1 >> 2] | 0);
   }
   i1 = i1 + 4 | 0;
  }
  _free(HEAP32[i4 >> 2] | 0);
 }
 return;
}

function __ZN8VRDevice11FixedUpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 1, 0);
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE15clearCachedDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i1 + 88 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 i1 = i1 + 104 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) i4 = 0; else i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i5 << 2, gb + 838004 | 0, 543) | 0;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i4 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i1 = i4;
  i2 = HEAP32[i6 >> 2] | 0;
  while (1) {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i3 >>> 0) break; else i2 = i2 + 4 | 0;
  }
 }
 i1 = i6 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i6 >> 2] = i4;
  HEAP32[i1 >> 2] = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i6, HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  i2 = HEAPU16[i5 >> 1] | HEAPU16[i5 + 2 >> 1] << 16;
  HEAP16[i1 >> 1] = i2;
  HEAP16[i1 + 2 >> 1] = i2 >>> 16;
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc9ClothCore19addCollisionCapsuleEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i8 = i4 + 8 | 0;
 i7 = i4;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i8 + 8;
 i3 = i3 + 76 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i1 | 0, i5 | 0, i2 | 0, i2 | 0);
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc5Scene20postCallbacksPreSyncEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 1204 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4 + (i2 << 2) | 0;
 if (!i2) {
  i5 = i1;
  __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(i5, 1);
  return;
 }
 i1 = i4 + 64 | 0;
 do {
  i2 = i2 + -1 | 0;
  if (i1 >>> 0 < i5 >>> 0) i1 = i1 + 4 | 0;
  i6 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
  __ZN5physx2Sc7BodySim19deactivateKinematicEv(i6) | 0;
  __ZN5physx2Sc8BodyCore25invalidateKinematicTargetEv(HEAP32[i6 + 52 >> 2] | 0);
 } while ((i2 | 0) != 0);
 i6 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(i6, 1);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_16PxPrismaticJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_16PxParticleSystemEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN30RuntimeInitializeOnLoadManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(172, i1, 16, gb + 1048932 | 0, 0, gb + 454418 | 0, 71) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN30RuntimeInitializeOnLoadManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15LODGroupManager32CalculateAnimatedCrossFadeCulledEhfPhPf(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 if (f2 <= Math_fround(0.0)) {
  i6 = 0;
  return i6 | 0;
 }
 i7 = (i1 & 255) >>> 1;
 i5 = HEAP8[i3 >> 0] | 0;
 i6 = i7 | i1;
 if (i5 << 24 >> 24 == i7 << 24 >> 24) {
  HEAP8[i3 >> 0] = i6;
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  i7 = 1;
  return i7 | 0;
 }
 if (i5 << 24 >> 24 != i6 << 24 >> 24) {
  i7 = 0;
  return i7 | 0;
 }
 f2 = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f2);
 HEAPF32[i4 >> 2] = f2;
 if (!(f2 <= Math_fround(0.0))) {
  i7 = 1;
  return i7 | 0;
 }
 HEAP8[i3 >> 0] = i1;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i7 = 1;
 return i7 | 0;
}

function __Z42VRSettings_Get_Custom_PropLoadedDeviceNamev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i3 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = __Z12GetIVRDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i1 + 4 | 0 : i2, HEAP32[i1 + 20 >> 2] | 0) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i1 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + 24 | 0);
 i3 = i2;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z39Material_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i6, i1, i4);
  STACKTOP = i7;
  return;
 }
}

function __Z36Joint2D_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN7Joint2D16SetConnectedBodyE4PPtrI11Rigidbody2DE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z13RegisterClassI9Texture3DEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 26572;
 HEAP32[i2 + 4 >> 2] = fb + 571;
 HEAP32[i2 + 8 >> 2] = gb + 411365;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 117;
 HEAP32[i2 + 20 >> 2] = 108;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32112;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZThn32_N16ParticleRendererD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + -32 | 0;
 HEAP32[i3 >> 2] = gb + 190956 + 8;
 i1 = i3 + 32 | 0;
 HEAP32[i1 >> 2] = gb + 190956 + 184;
 i2 = HEAP32[i3 + 376 >> 2] | 0;
 if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 HEAP32[i3 >> 2] = gb + 43728 + 8;
 HEAP32[i1 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i3);
 i1 = i3 + 288 | 0;
 if ((HEAP32[i3 + 304 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = gb + 29060 + 8;
  HEAP32[i3 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 292 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 29060 + 8;
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZNSt3__215recursive_mutexC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = _pthread_mutexattr_init(i2 | 0) | 0;
 do if (!i1) {
  i1 = _pthread_mutexattr_settype(i2 | 0, 1) | 0;
  if (i1 | 0) {
   _pthread_mutexattr_destroy(i2 | 0) | 0;
   i4 = 7;
   break;
  }
  i1 = _pthread_mutex_init(i3 | 0, i2 | 0) | 0;
  i2 = _pthread_mutexattr_destroy(i2 | 0) | 0;
  if (!i1) {
   if (i2 | 0) {
    _pthread_mutex_destroy(i3 | 0) | 0;
    i1 = i2;
    i4 = 7;
   }
  } else i4 = 7;
 } else i4 = 7; while (0);
 if ((i4 | 0) == 7) __ZNSt3__220__throw_system_errorEiPKc(i1, gb + 1082376 | 0);
 STACKTOP = i5;
 return;
}

function __ZNK8Animator20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i5) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i5) | 0) if (!(HEAP32[i6 >> 2] | 0)) {
  i5 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i5 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i6 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2, i3, i4) | 0;
 return i6 | 0;
}

function __ZN8Animator13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i4 = __ZN26AnimatorControllerPlayable13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2) | 0;
 return i4 | 0;
}

function __ZN5physx13PxsCCDContext18postCCDDepenetrateEPNS_10PxBaseTaskE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 112 >> 2] | 0;
 i1 = i2 << 7;
 i3 = HEAP32[i4 + 100 >> 2] | 0;
 i2 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
 if ((i2 | 0) != (0 - i1 | 0)) {
  i1 = i2 + i1 | 0;
  i2 = 0;
  do {
   HEAP32[(HEAP32[i3 + (i2 >>> 7 << 3) >> 2] | 0) + ((i2 & 127) * 20 | 0) + 12 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < i1 >>> 0);
 }
 HEAP32[i4 + 128 >> 2] = 0;
 HEAP32[(HEAP32[i4 + 116 >> 2] | 0) + 4 >> 2] = 0;
 __ZN5physx13PxsCCDContext12updateCCDEndEv(i4);
 __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[(HEAP32[i4 + 264 >> 2] | 0) + 224 >> 2] | 0, HEAP32[i4 + 252 >> 2] | 0);
 return;
}

function __ZN26PlayerSettingsSplashScreenC2EP14PlayerSettings(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 84 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = 0;
 i1 = i4 + 76 | 0;
 i2 = i4 + 40 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i2 = i5;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i4 + 92 >> 2] = 0;
 HEAP32[i4 + 96 >> 2] = 0;
 HEAP32[i4 + 116 >> 2] = 0;
 STACKTOP = i6;
 return;
}

function __ZN26AnimatorOverrideControllerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 178476 + 8;
 i1 = i2 + 104 | 0;
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2 + 108 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i2 + 132 | 0;
 if ((HEAP32[i2 + 148 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 136 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 84 | 0;
 if ((HEAP32[i2 + 100 >> 2] | 0) <= -1) {
  __ZN25RuntimeAnimatorControllerD2Ev(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 88 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN25RuntimeAnimatorControllerD2Ev(i2);
 return;
}

function __ZN21UnityAnalyticsManager27OnPlayerSessionStateChangedEjyy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i2 | 0) != 1) return;
 i1 = i1 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i6 = __ZnwjRK10MemLabelIdiPKci(44, gb + 63800 | 0, 16, gb + 1037694 | 0, 67) | 0;
 HEAP32[i6 + 4 >> 2] = __Z21GetUnityConnectClientv() | 0;
 i5 = i6 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 1;
 HEAP32[i6 >> 2] = gb + 188416 + 8;
 HEAP8[i6 + 16 >> 0] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i6 + 24 | 0);
 HEAP32[i5 >> 2] = gb + 1042554;
 HEAP32[i1 >> 2] = i6;
 __ZN14UnityAnalytics23RegisterGlobalCallbacksEv(i6);
 return;
}

function __ZN17PersistentManager22CountInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 i4 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE(i1, i2, i5);
 i2 = HEAP32[i6 >> 2] | 0;
 __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i5, HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN14MemoryProfiler20UnregisterAllocationEPvjRK10MemLabelId(i1, i2, i4, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 if (!i2) return;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i3) | 0;
 if (!i1) return;
 i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if ((i2 | 0) == 0 | (HEAP32[i3 >> 2] | 0) == 58) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i4;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN23AllocationRootReferenceD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63584 | 0);
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z51AnchoredJoint2D_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 160 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  mftCall_vii(i1 | 0, i4 | 0, i3 | 0);
  STACKTOP = i5;
  return;
 }
}

function __Z34Joint_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN5Unity5Joint16SetConnectedBodyE4PPtrI9RigidbodyE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z13RegisterClassI9HaloLayerEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 535;
 HEAP32[i2 + 8 >> 2] = gb + 378037;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 125;
 HEAP32[i2 + 20 >> 2] = 36;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30392;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI9CGProgramEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 31992;
 HEAP32[i2 + 4 >> 2] = fb + 605;
 HEAP32[i2 + 8 >> 2] = gb + 479242;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 109;
 HEAP32[i2 + 20 >> 2] = 96;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29992;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 13 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1 + -1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 13 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1 + -1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNK5physx2Sc19ParticlePacketShape13getFilterInfoERjRNS_12PxFilterDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i1 >> 2] = 0;
 i3 = i3 + 8 | 0;
 i6 = __ZNK5physx2Sc17ParticleSystemSim16getInternalFlagsEv(HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | (i6 >>> 16 & 1 | 2);
 __ZNK5physx2Sc17ParticleSystemSim23getSimulationFilterDataEv(i5, HEAP32[i3 >> 2] | 0);
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN8VRDevice27UpdateDeviceConnectedCachedEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1469372 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469372 | 0, i1);
  i2 = gb + 1469372 | 0;
 } else i2 = 0;
 i3 = i4 + 297 | 0;
 HEAP8[i3 >> 0] = 0;
 i1 = HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 268 >> 2] | 0;
 if (i1 | 0) HEAP8[i3 >> 0] = (mftCall_i(i1 | 0) | 0) & 1;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i5;
 return;
}

function __ZN5physx9NpFactory22createArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP32[gb + 1457328 >> 2] | 0)) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 686195 | 0, 644, gb + 686266 | 0, i1);
  i4 = 0;
  STACKTOP = i1;
  return i4 | 0;
 } else {
  i4 = __ZN12_GLOBAL__N_122createArticulationLinkERN5physx14NpArticulationEPNS0_18NpArticulationLinkERKNS0_11PxTransformE(i4, i2, i3) | 0;
  STACKTOP = i1;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb(i6, i2, i3) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 1 | 0;
 i5 = i7;
 if (!(HEAP32[i6 + 284 >> 2] & 4096)) i1 = i6 + 108 | 0; else i1 = (HEAP32[i6 + 56 >> 2] | 0) + 268 | 0;
 i1 = HEAP8[i1 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 if (i3) i1 = (i1 & 255 | i2) & 255; else i1 = i1 & ((i2 ^ 255) & 255);
 HEAP8[i5 >> 0] = i1;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i6, i4, i5);
 STACKTOP = i7;
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_15PxRevoluteJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_15PxDistanceJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx16PxsIslandManager33removeSleepingPairContactManagersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = HEAP32[i1 + 284 >> 2] | 0;
 i5 = HEAP32[i1 + 504 >> 2] | 0;
 i6 = i1 + 508 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  HEAP32[i6 >> 2] = i5;
  return;
 } else {
  i3 = 0;
  i1 = 0;
 }
 do {
  if ((HEAP32[i4 + ((HEAP32[i5 + (i3 << 3) + 4 >> 2] | 0) * 12 | 0) + 8 >> 2] | 0) >>> 0 >= 16 >>> 0) {
   i9 = i5 + (i3 << 3) | 0;
   i8 = HEAP32[i9 + 4 >> 2] | 0;
   i7 = i5 + (i1 << 3) | 0;
   HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
   HEAP32[i7 + 4 >> 2] = i8;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i2 | 0));
 HEAP32[i6 >> 2] = i1;
 return;
}

function __ZN20GlobalCachingManager7DisposeEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 4 >> 2] | 0)) {
  i4 = i2;
  i5 = 7;
 } else {
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3) {
    __ZN5CacheD2Ev(i3);
    __ZdlPv(i3);
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i2 = i2 + 4 | 0;
  } while ((i2 | 0) != (HEAP32[i1 + 4 >> 2] | 0));
  if (i1 | 0) {
   i4 = i2;
   i5 = 7;
  }
 }
 if ((i5 | 0) == 7) {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   if ((i4 | 0) != (i2 | 0)) HEAP32[i1 + 4 >> 2] = i4 + (~((i4 + -4 - i3 | 0) >>> 2) << 2);
   __ZdlPv(i2);
  }
  __ZdlPv(i1);
 }
 HEAP32[i6 >> 2] = 0;
 return;
}

function __ZN17SurfaceEffector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 157884 + 8;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 1812433254;
 HEAP32[i1 + 88 >> 2] = 1900727103;
 STACKTOP = i4;
 return;
}

function __ZN14PhysicsManager11CapsuleTestE8Vector3fS0_fi23QueryTriggerInteraction(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1 + 12 | 0;
 i7 = i1;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5Unity12PhysicsQuery11CapsuleTestE8Vector3fS1_fi23QueryTriggerInteraction(0, i8, i7, f4, i5, i6) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN14AvatarPlayback5ClearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i3 + 4 | 0;
 i6 = i3 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i2 = i4;
 if ((i1 | 0) != (i4 | 0)) {
  i4 = i3 + 36 | 0;
  i3 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + (i3 * 12 | 0) >> 2] | 0, i4);
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 * 12 | 0) + 4 >> 2] | 0, i4);
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i6 >> 2] | 0;
   i7 = HEAP32[i5 >> 2] | 0;
   i2 = i7;
  } while (i3 >>> 0 < ((i1 - i7 | 0) / 12 | 0) >>> 0);
 }
 if ((i1 | 0) == (i2 | 0)) return;
 HEAP32[i6 >> 2] = i1 + (~(((i1 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
 return;
}

function __ZN13ComputeShader23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 469287 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 479409 | 0, HEAP32[gb + 37316 >> 2] | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags(i2, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider15destroyInstanceEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = i1;
 i4 = i2 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE5eraseERS6_(i2 + 32 | 0, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 i2 = HEAP32[i2 + 84 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 STACKTOP = i3;
 return;
}

function __ZN12NavMeshAgent5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 40 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(3.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(120.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 60 >> 2] = Math_fround(8.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 100 >> 2] = 50;
 HEAP32[i1 + 92 >> 2] = 4;
 i2 = i1 + 107 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 3;
 HEAP8[i1 + 104 >> 0] = 1;
 HEAP8[i1 + 105 >> 0] = 1;
 HEAP8[i1 + 106 >> 0] = 1;
 HEAP32[i1 + 96 >> 2] = -1;
 HEAP32[i1 + 72 >> 2] = 0;
 i1 = i1 + 80 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __Z40SpriteRenderer_CUSTOM_SetSprite_INTERNALP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN14SpriteRenderer9SetSpriteE4PPtrI6SpriteE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z38Material_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf(i6, i1, i4);
  STACKTOP = i7;
  return;
 }
}

function __Z34SparseTexture_CUSTOM_UpdateTileRawP12Il2CppObjectiiiP11Il2CppArray(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i6) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i5) {
  i1 = 0;
  i5 = 0;
  __ZN13SparseTexture10UploadTileEiiiPKhj(i6, i2, i3, i4, i1, i5);
  return;
 }
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 1) | 0;
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 __ZN13SparseTexture10UploadTileEiiiPKhj(i6, i2, i3, i4, i1, i5);
 return;
}

function __Z29CullingGroup_CUSTOM_IsVisibleP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if ((i2 | 0) < 0) __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 510257 | 0, i4);
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 if ((HEAP32[i1 + 24 >> 2] | 0) > (i2 | 0)) {
  i4 = (__ZNK12CullingGroup9IsVisibleEj(i1, i2) | 0) & 1;
  STACKTOP = i5;
  return i4 | 0;
 } else __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 510257 | 0, i4);
 return 0;
}

function __Z19FitCapsuleToExtentsPfS_PKf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i6 = i4;
 i8 = i3 + 8 | 0;
 f7 = Math_fround(HEAPF32[i3 >> 2]);
 i9 = f7 < Math_fround(HEAPF32[i8 >> 2]);
 i8 = HEAP32[(i9 ? i8 : i3) >> 2] | 0;
 HEAP32[i1 >> 2] = i8;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f7 = Math_fround(f7 - (HEAP32[tempDoublePtr >> 2] = i8, Math_fround(HEAPF32[tempDoublePtr >> 2])));
 HEAPF32[i6 >> 2] = f7;
 i3 = f7 > Math_fround(0.0);
 HEAP32[i2 >> 2] = HEAP32[(i3 ? i6 : i5) >> 2];
 STACKTOP = i4;
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 2);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  return;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 2);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  return;
 } else {
  HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
  HEAP32[i2 >> 2] = i4;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i5);
  return;
 }
}

function __Z13RegisterClassI9TextAssetEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 598;
 HEAP32[i2 + 8 >> 2] = gb + 465927;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 49;
 HEAP32[i2 + 20 >> 2] = 64;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31992;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI8WindZoneEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 612;
 HEAP32[i2 + 8 >> 2] = gb + 486986;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 182;
 HEAP32[i2 + 20 >> 2] = 72;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 32232;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__28__sp_mut4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (__ZNSt3__25mutex8try_lockEv(i2) | 0) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 > 16) {
   i3 = 4;
   break;
  }
  __THREW__ = 0;
  invoke_i(fb + 323 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i3 = 7;
   break;
  }
 }
 if ((i3 | 0) == 7) {
  i4 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i4);
 }
 if ((i3 | 0) == 4) {
  __THREW__ = 0;
  invoke_vi(fb + 4006 | 0, i2 | 0);
  i4 = __THREW__;
  __THREW__ = 0;
  if (i4 & 1) {
   i4 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i4);
  }
 }
 return;
}

function __ZNK29ParticleSystemPropertyBinding22GetClassIDForAttributeEj(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i6 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = i6 - i2 >> 4;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 4) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 16 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 if ((i1 | 0) == (i6 | 0) ? 1 : (HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 8 >> 2] | 0;
 return i8 | 0;
}

function __ZN8VRDevice8RecenterEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0)) {
  STACKTOP = i4;
  return;
 }
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 13, 0);
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i4;
 return;
}

function __ZN8UserList11SendMessageERK17MessageIdentifier(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  STACKTOP = i7;
  return;
 }
 i3 = i1 + 4 | 0;
 i1 = i2;
 do {
  i2 = i1 + -1 | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 3) >> 2] >> 2] | 0, i4, i5);
  i8 = HEAP32[i6 >> 2] | 0;
  i1 = (i8 | 0) < (i2 | 0) ? i8 : i2;
 } while ((i1 | 0) > 0);
 STACKTOP = i7;
 return;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImpl14onDeallocationEPv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE5eraseERS4_(i2 + 12 | 0, i1) | 0;
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx19PxsFluidSpatialHash29reorderParticleIndicesToCellsEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjjPt(i1, i6, i4, i7, i3, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 if (i3 | 0) {
  i2 = 0;
  do {
   i1 = i4 + (i2 << 4) + 8 | 0;
   if ((HEAP32[i1 >> 2] | 0) != -1) HEAP32[i1 >> 2] = 0;
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i3 | 0));
 }
 if (!i6) return; else i1 = 0;
 do {
  i2 = HEAPU16[i5 + (i1 << 1) >> 1] | 0;
  i3 = i4 + (i2 << 4) + 8 | 0;
  HEAP32[i7 + ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 + (i2 << 4) + 12 >> 2] | 0) << 2) >> 2] = i1;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 return;
}

function __ZN5physx15PxsParticleData14setVelocitiesVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE(i1, i8, i4, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i8) return;
 i5 = HEAP32[i1 + 48 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = 0;
 while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  i9 = i3;
  HEAP32[i5 + (i4 << 5) + 16 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i5 + (i4 << 5) + 20 >> 2] = HEAP32[i9 + 4 >> 2];
  HEAP32[i5 + (i4 << 5) + 24 >> 2] = HEAP32[i9 + 8 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i8 | 0)) break; else {
   i3 = i3 + i7 | 0;
   i1 = i1 + i6 | 0;
  }
 }
 return;
}

function __ZN22UnityAnalyticsSettingsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189312 + 8;
 i1 = i2 + 28 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 40 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 12 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN16ParticleRenderer16AllocateUVFramesEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = i2 + 376 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 i1 = i2 + 372 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 if (i3 << 4 >>> 0 <= i3 >>> 0) {
  HEAP32[i1 >> 2] = 0;
  i4 = 0;
  return i4 | 0;
 }
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i2, 0, 0) | 0;
 HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] << 4, 16, gb + 63264 | 0, 0, gb + 1048339 | 0, 71) | 0;
 if (!i3) {
  i4 = 1;
  return i4 | 0;
 }
 __Z19pop_allocation_rootv();
 i4 = 1;
 return i4 | 0;
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801075 | 0, i1, 0);
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 843745 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 160 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15FrictionJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 806147 | 0, 14) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 155616 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15DistanceJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(104, i1, 16, gb + 1048932 | 0, 0, gb + 805923 | 0, 13) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 154996 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN10Matrix4x4fC2ERK10Matrix3x3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 32 >> 2];
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZN10HumanTrait13GetFingerNameEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3 ? gb + 908416 | 0 : gb + 908422 | 0, i3 ? 5 : 6);
 if (i2 >>> 0 >= 15) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj((i2 >>> 0) / 3 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand12PhalangeNameEj((i2 >>> 0) % 3 | 0) | 0) | 0;
 return;
}

function __Z38MeshCollider_Set_Custom_PropSharedMeshP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN12MeshCollider13SetSharedMeshE4PPtrI4MeshE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z13RegisterClassI7CubemapEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 32032;
 HEAP32[i2 + 4 >> 2] = fb + 556;
 HEAP32[i2 + 8 >> 2] = gb + 397454;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 89;
 HEAP32[i2 + 20 >> 2] = 164;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 29912;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI6SpriteEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 567;
 HEAP32[i2 + 8 >> 2] = gb + 410464;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 213;
 HEAP32[i2 + 20 >> 2] = 160;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31832;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI6AvatarEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 951;
 HEAP32[i2 + 8 >> 2] = gb + 905757;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 90;
 HEAP32[i2 + 20 >> 2] = 100;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 178860;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _stbir_resize_region(i1, i2, i13, i16, i17, i18, i19, i20, i21, i22, i3, i4, i5, i6, i7, i8, i9, i10, f11, f12, f14, f15) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i10, i1, i2, i13, i16, i17, i18, i19, i20, f11, f12, f14, f15, 0, i22, i3, i4, i21, i7, i8, i5, i6, i9) | 0;
}

function __ZN8Renderer19UpdateTransformInfoEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 36 | 0;
 i1 = HEAP16[i2 + 272 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) i1 = (i1 & 65535) >>> 8 & 255; else {
  i1 = __ZN8Renderer12GetTransformEv(i2) | 0;
  HEAP32[i2 + 212 >> 2] = __ZNK9Transform16GetTransformTypeEv(i1) | 0;
  __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f(i1, i3);
  i1 = HEAP8[i2 + 273 >> 0] | 0;
 }
 if (!(i1 << 24 >> 24)) {
  i1 = i2 + 188 | 0;
  i2 = i2 + 164 | 0;
  __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i3, i2);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0);
 i1 = i2 + 188 | 0;
 i2 = i2 + 164 | 0;
 __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_(i1, i3, i2);
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI14TexFormatRHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f7 = Math_fround(HEAPF32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2]);
  i6 = f7 < Math_fround(0.0);
  i3 = f7 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f7) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8 | -65281;
  HEAP32[i4 >> 2] = i6 ? -65281 : i3;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx3Scb5ClothC2ERKNS_11PxTransformERNS_2Sc15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i5, i3, i1, i4, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i6;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i7 = i5 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP16[i8 >> 1] = HEAP16[i2 >> 1] | 0;
 __ZN5physx2Sc9ClothCoreC2ERKNS_11PxTransformERNS0_15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i5 + 12 | 0, i3, i1, i4, i8);
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] & -251658241 | 184549376;
 STACKTOP = i6;
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxArticulationEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_14PxArticulationEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN16AllProfilerStats11DeserializeEPPib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11MemoryStats11DeserializeEPPib(i1, i2, 0);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 224 | 0, 52);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 432 | 0, 15);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 492 | 0, 29);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 608 | 0, 19);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 684 | 0, 20);
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 764 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 768 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 >> 2] = i3 + 12;
 HEAP32[i1 + 772 >> 2] = HEAP32[i3 + 8 >> 2];
 __Z12ReadIntArrayPPiS_i(i2, i1 + 808 | 0, 43);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 980 | 0, 16);
 __Z12ReadIntArrayPPiS_i(i2, i1 + 1044 | 0, 16);
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 i4 = (i2 | 0) != 0;
 if (i4) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, i2);
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 if (!i4) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 return;
}

function __ZN15QualitySettingsC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 44056 + 8;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN15PointEffector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 156704 + 8;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 84 >> 2] = 1812433254;
 HEAP32[i1 + 88 >> 2] = 1900727103;
 STACKTOP = i4;
 return;
}

function __ZN14SphereCollider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(76, i1, 16, gb + 1048932 | 0, 0, gb + 781963 | 0, 10) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 HEAP32[i4 >> 2] = gb + 113484 + 8;
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14PhysicsManager20CleanupDynamicsSceneEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457416 >> 2] | 0;
 if (i1 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
  i1 = HEAP32[gb + 1457416 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
  HEAP32[gb + 1457416 >> 2] = 0;
 }
 if (__Z12GetIVehiclesv() | 0) {
  i1 = __Z12GetIVehiclesv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 }
 if (__Z9GetIClothv() | 0) {
  i1 = __Z9GetIClothv() | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 }
 i1 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457404 >> 2] = 0;
 return;
}

function __ZN13ScreenManager24SetIsFullScreenImmediateEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0) ^ i2)) {
  STACKTOP = i4;
  return;
 }
 i6 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[i6 + 16 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[i6 + 80 >> 2] | 0, i1 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i1 | 0);
 mftCall_iiiiii(i7 | 0, i1 | 0, i6 | 0, i5 | 0, i2 | 0, HEAP32[i3 + 8 >> 2] | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_110DataStream14pushPvdCommandERN5physx8debugger4comm21PvdInstanceDataStream10PvdCommandE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAP32[i1 >> 2] = i4;
 i2 = i5 + 428 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 + 432 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i5 + 424 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEE15growAndPushBackERKS6_(i5 + 412 | 0, i1) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN11UTF16StringC2ERKS_10MemLabelId(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = i3 + 12 | 0;
 i6 = i1;
 i2 = HEAP32[i6 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i3 + 4 | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  i5 = 0;
  i6 = i3 + 8 | 0;
  HEAP8[i6 >> 0] = i5;
  return;
 } else {
  HEAP32[i2 >> 2] = i1;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1 << 1, 16, i5, 0, gb + 489101 | 0, 124) | 0;
  HEAP32[i3 >> 2] = i5;
  _memcpy(i5 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] << 1 | 0) | 0;
  i5 = 1;
  i6 = i3 + 8 | 0;
  HEAP8[i6 >> 0] = i5;
  return;
 }
}

function __ZN10MeshFilter19SetInstantiatedMeshEP4Mesh(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i3 + 32 | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i1 + 376 >> 2] = HEAP32[i2 >> 2];
  __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106136 | 0, i4);
 STACKTOP = i5;
 return;
}

function __Z40AudioSettings_Set_Custom_PropSpeakerMode16FMOD_SPEAKERMODE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 874916 | 0, 0, gb + 875076 | 0, 66, 512, 0, 0, 0);
 __ZN12AudioManager16GetConfigurationEv(i3, __Z15GetAudioManagerv() | 0);
 HEAP32[i3 >> 2] = i1;
 if (__ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting(__Z15GetAudioManagerv() | 0, i3) | 0) {
  STACKTOP = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 875178 | 0, 0, gb + 875076 | 0, 70, 512, 0, 0, 0);
 STACKTOP = i2;
 return;
}

function __Z13RegisterClassI6ShaderEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 603;
 HEAP32[i2 + 8 >> 2] = gb + 609205;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 48;
 HEAP32[i2 + 20 >> 2] = 100;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31552;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _atanhf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 & 2147483647;
 f1 = (HEAP32[tempDoublePtr >> 2] = i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i2 >>> 0 < 1056964608) {
  if (i2 >>> 0 >= 796917760) {
   f4 = Math_fround(f1 * Math_fround(2.0));
   f1 = Math_fround(Math_fround(_log1pf(Math_fround(f4 + Math_fround(Math_fround(f1 * f4) / Math_fround(Math_fround(1.0) - f1))))) * Math_fround(.5));
  }
 } else f1 = Math_fround(Math_fround(_log1pf(Math_fround(Math_fround(f1 / Math_fround(Math_fround(1.0) - f1)) * Math_fround(2.0)))) * Math_fround(.5));
 f4 = Math_fround(-f1);
 return Math_fround((i3 | 0) < 0 ? f4 : f1);
}

function __ZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPii(i4, i5, i6, i1, i2, i7, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 var i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 HEAP32[i9 >> 2] = gb + 169968 + 8;
 HEAP32[i9 + 4 >> 2] = i4;
 HEAP32[i9 + 8 >> 2] = i1;
 HEAP32[i9 + 12 >> 2] = i2;
 HEAP32[i9 + 16 >> 2] = i3;
 i1 = i9 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback(HEAP32[i4 >> 2] | 0, i5, i6, i9) | 0;
 if (!i7) {
  STACKTOP = i8;
  return 1073741824;
 }
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 STACKTOP = i8;
 return 1073741824;
}

function __ZNK14NavMeshManager20GetOffMeshConnectionEyP8Vector3fS1_Pf(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = __ZNK9dtNavMesh20getOffMeshConnectionEy(i1, i2, i3) | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i3;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i1 + 64 >> 2];
 i6 = 1;
 return i6 | 0;
}

function __ZN9Animation4StopEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i7 + 104 >> 2] | 0;
 i6 = i7 + 108 | 0;
 if ((i1 | 0) != (HEAP32[i6 >> 2] | 0)) do {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + 56 | 0;
  i2 = HEAP16[i5 >> 1] | 0;
  i3 = i2 | 64;
  if ((i2 & 10) == 10) {
   HEAP16[i5 >> 1] = i3;
   i2 = i3;
  }
  HEAP16[i5 >> 1] = i2 & -3;
  __ZN14AnimationState7SetTimeEf(i4, Math_fround(0.0));
  HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -6;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i6 >> 2] | 0));
 i3 = HEAP32[i7 + 316 >> 2] | 0;
 i1 = i7 + 320 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4);
 return;
}

function __ZN5physx6shdfnd6Socket11setBlockingEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i1 + 14 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i2 = i1 + 15 | 0;
 if ((i3 & 1 | 0) == (HEAPU8[i2 >> 0] | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = i1 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i1 = _fcntl(i1, 3, i4) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = i3 ? i1 & -2049 : i1 | 2048;
 if ((_fcntl(i4, 4, i5) | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i2 >> 0] = i3 & 1;
 STACKTOP = i6;
 return;
}

function __ZN5physx2Cm17FreeListAllocator15popFromFreeListEj(i8, i7) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i8 + 148 + (i7 << 2) | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i4 = i6 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i1;
 i2 = i6 + 8 | 0;
 if (i1 | 0) HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) HEAP32[i3 >> 2] = i5; else HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (HEAP32[i3 >> 2] | 0) return i6 | 0;
 i1 = i7 >>> 5;
 i5 = i8 + 16 + (i1 << 2) | 0;
 i7 = HEAP32[i5 >> 2] & ~(1 << (i7 & 31));
 HEAP32[i5 >> 2] = i7;
 if (i7 | 0) return i6 | 0;
 i8 = i8 + 144 | 0;
 HEAP32[i8 >> 2] = HEAP32[i8 >> 2] & ~(1 << i1);
 return i6 | 0;
}

function __ZN5physx18NpArticulationLinkD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 92380 + 8;
 i1 = HEAP32[i2 + 328 >> 2] | 0;
 do if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 320 >> 2] | 0;
  if ((i2 + 300 | 0) == (i1 | 0)) {
   HEAP8[i2 + 316 >> 0] = 0;
   break;
  }
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 } while (0);
 HEAP32[i2 >> 2] = gb + 92112 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i2 + 64 | 0);
 HEAP32[i2 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i2 + 20 | 0);
 HEAP32[i2 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i2);
 return;
}

function __ZN15ReflectionProbe14SetRefreshModeENS_11RefreshModeE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 44 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 HEAP8[i4 + 160 >> 0] = 1;
 if (!((i1 | 0) == 1 ? (HEAP32[i4 + 40 >> 2] | 0) == 1 : 0)) return;
 i3 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!i2) return;
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i5 = 8;
   break;
  }
 }
 if ((i5 | 0) == 8) return;
 __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i3, 3, i4, 63);
 return;
}

function __ZN13UnityProfiler17ReturnFrameToPoolEP17ProfilerFrameData(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i6 + 4 | 0;
 i1 = i2 + 16 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i1 = i2 + 20 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   __Z6FormatPKcz(i3, gb + 585356 | 0, i4);
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 585151 | 0, 939, 1, 0, 0, 0);
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
   STACKTOP = i6;
   return;
  }
 }
 HEAP32[i1 >> 2] = i5;
 STACKTOP = i6;
 return;
}

function __Z37Texture_CUSTOM_INTERNAL_get_texelSizeP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i3 | 0, i4 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z32Collider_Set_Custom_PropMaterialP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function __Z30Event_CUSTOM_GetTypeForControlP12Il2CppObjecti(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i2 = __Z19GetSpecificGUIStatei(HEAP32[i1 + 40 >> 2] | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5 + 8 | 0); else {
  i4 = __ZN5IMGUI22GetEventTypeForControlERK8GUIStateRK10InputEventi(i2, i1, i4) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  i6 = i1;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 8);
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  i6 = i1;
  i1 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i3;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 8);
  return;
 }
}

function __Z13RegisterClassI6SkyboxEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 29672;
 HEAP32[i2 + 4 >> 2] = fb + 546;
 HEAP32[i2 + 8 >> 2] = gb + 384544;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 45;
 HEAP32[i2 + 20 >> 2] = 40;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 31672;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function __Z13RegisterClassI5FlareEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 532;
 HEAP32[i2 + 8 >> 2] = gb + 373565;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 121;
 HEAP32[i2 + 20 >> 2] = 56;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30112;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _quantize(i6, i7, i8) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = 0;
 do {
  i2 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
  i3 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
  i4 = HEAP32[i7 + (i5 + 64 << 2) >> 2] | 0;
  i1 = HEAP32[i7 + (i5 + 192 << 2) >> 2] | 0;
  if ((i2 | 0) < 0) {
   i4 = ___muldi3(i4 - i2 | 0, 0, i3 | 0, 0) | 0;
   i1 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, i1 + 32 | 0) | 0;
   getTempRet0() | 0;
   i1 = 0 - i1 | 0;
  } else {
   i4 = ___muldi3(i4 + i2 | 0, 0, i3 | 0, 0) | 0;
   i1 = _bitshift64Lshr(i4 | 0, getTempRet0() | 0, i1 + 32 | 0) | 0;
   getTempRet0() | 0;
  }
  HEAP16[i6 + (i5 << 1) >> 1] = i1;
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) != 64);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 1) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 7 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 61 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 60 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 1) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 7 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 61 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 60 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNK9Transform11GetRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 i8 = i2 + 32 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z23CalculateGlobalRotation23TransformAccessReadOnly(i4, i5);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN7mecanim12statemachine21GetTransitionConstantEPKNS0_20StateMachineConstantEPKNS0_18StateMachineMemoryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i3 | 0) == -1) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = i2 + 12 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + i2 + (i3 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i3 = (i3 | 0) == 0 ? 0 : i2 + i3 | 0;
  return i3 | 0;
 } else {
  i2 = i2 + 4 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) + i2 + (i1 << 2) | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) + 4 | 0;
  i2 = i2 + (HEAP32[i2 >> 2] | 0) + (i3 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i3 = (i3 | 0) == 0 ? 0 : i2 + i3 | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingIiyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIixE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 268 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 260 >> 2] | 0;
 i3 = i1 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Cct13HandleManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_13PxRigidStaticEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx14NpSceneQueriesC2ERKNS_11PxSceneDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 100104 + 8;
 i4 = i2 + 16 | 0;
 i6 = HEAP32[gb + 1457324 >> 2] | 0;
 i6 = (mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 176 >> 2] | 0, i6 | 0) | 0) + 8 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i6;
 __ZN5physx3Scb5SceneC2ERKNS_11PxSceneDescENS_2Cm13EventProfilerE(i4, i1, i5);
 __ZN5physx2Sq17SceneQueryManagerC2ERNS_3Scb5SceneERKNS_11PxSceneDescE(i2 + 3392 | 0, i4, i1);
 STACKTOP = i3;
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 i4 = (i2 | 0) != 0;
 if (i4) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, i2);
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 if (!i4) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 return;
}

function __Z34setPxVehicleDriveTankMDriveSimDataPN5physx18PxVehicleDriveTankENS_21PxVehicleDriveSimDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 64 | 0;
 _memcpy(i2 + 224 | 0, i1 | 0, HEAP32[i3 >> 2] << 3 | 0) | 0;
 HEAP32[i2 + 288 >> 2] = HEAP32[i3 >> 2];
 i3 = i2 + 304 | 0;
 i4 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i2 + 336 | 0, i1 + 112 | 0, 416) | 0;
 return;
}

function __Z24GetUIScriptingClassesPtrv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1468152 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1012556 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1468152 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1012675 | 0, gb + 1012682 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 346 | 0, fb + 347 | 0);
 i2 = HEAP32[gb + 1468152 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37288 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37240 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 2;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37300 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37252 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i3);
 return;
}

function __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP32[i10 + 4 >> 2] = gb + 1576256;
 HEAP32[i10 + 8 >> 2] = gb + 1576256;
 HEAP32[i10 >> 2] = i1;
 HEAP32[i10 + 12 >> 2] = i2;
 HEAP32[i10 + 16 >> 2] = i3;
 HEAP32[i10 + 20 >> 2] = i4;
 HEAP32[i10 + 24 >> 2] = i5;
 HEAP32[i10 + 28 >> 2] = i6;
 HEAP32[i10 + 32 >> 2] = i7;
 HEAP32[i10 + 36 >> 2] = i8;
 __Z17DebugStringToFileRK21DebugStringToFileData(i10);
 STACKTOP = i9;
 return;
}

function __Z13RegisterClassI4MeshEvv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = gb + 28068;
 HEAP32[i2 + 4 >> 2] = fb + 577;
 HEAP32[i2 + 8 >> 2] = gb + 425651;
 HEAP32[i2 + 12 >> 2] = gb + 1576256;
 HEAP32[i2 + 16 >> 2] = 43;
 HEAP32[i2 + 20 >> 2] = 252;
 HEAP32[i2 + 24 >> 2] = -2147483648;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP8[i3 + 8 >> 0] = 0;
 HEAP32[i2 + 40 >> 2] = gb + 30832;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc(HEAP32[gb + 1110260 >> 2] | 0, i2);
 STACKTOP = i1;
 return;
}

function _tmpfile() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 16 | 0;
 i5 = i8;
 i2 = i8 + 20 | 0;
 i1 = 0;
 while (1) {
  i3 = _tmpnam(i2) | 0;
  if (!i3) {
   i1 = 0;
   break;
  }
  HEAP32[i5 >> 2] = i3;
  HEAP32[i5 + 4 >> 2] = 32962;
  HEAP32[i5 + 8 >> 2] = 384;
  i4 = ___syscall_ret(___syscall5(5, i5 | 0) | 0) | 0;
  i1 = i1 + 1 | 0;
  if ((i4 | 0) > -1) {
   i7 = 5;
   break;
  }
  if ((i1 | 0) >= 100) {
   i1 = 0;
   break;
  }
 }
 if ((i7 | 0) == 5) {
  i1 = ___fdopen(i4, gb + 1075288 | 0) | 0;
  HEAP32[i6 >> 2] = i3;
  ___syscall10(10, i6 | 0) | 0;
 }
 STACKTOP = i8;
 return i1 | 0;
}

function _asinh(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i4 | 0, i3 | 0, 52) | 0;
 getTempRet0() | 0;
 i2 = i2 & 2047;
 HEAP32[tempDoublePtr >> 2] = i4;
 HEAP32[tempDoublePtr + 4 >> 2] = i3 & 2147483647;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 do if (i2 >>> 0 > 1048) d1 = +Math_log(+d1) + .6931471805599453; else {
  if (i2 >>> 0 > 1023) {
   d1 = +Math_log(+(d1 * 2.0 + 1.0 / (d1 + +Math_sqrt(+(d1 * d1 + 1.0)))));
   break;
  }
  if (i2 >>> 0 > 996) {
   d5 = d1 * d1;
   d1 = +_log1p(d1 + d5 / (+Math_sqrt(+(d5 + 1.0)) + 1.0));
  }
 } while (0);
 return +((i3 | 0) < 0 ? -d1 : d1);
}

function __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i1 = i1 + -132 | 0;
 i3 = i1 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = HEAP32[i1 + 268 >> 2] | 0;
 if (!i4) {
  i6 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  return;
 }
 i1 = i1 + 264 | 0;
 i2 = 0;
 do {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i5 | 0, i6 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i7 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 return;
}

function __ZNK5physx2Sc9ClothCore14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i1 = i1 + 28 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 372 >> 2] | 0, i3 | 0) | 0;
 if ((i3 | 0) == -1) {
  f4 = Math_fround(3402823469999999843913219.0e14);
  return Math_fround(f4);
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 380 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0) | 0;
 if (i2 >>> 0 <= i1 >>> 0) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(Math_fround((Math_imul(i2 - i1 | 0, i3) | 0) >>> 0) / Math_fround(1.0e3));
 return Math_fround(f4);
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, HEAP32[i2 + 8 >> 2] | 0, 1);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i2 + 12 | 0, i2);
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
 if (!i1) {
  i2 = i2 + 20 | 0;
  __ZN5physx3Scb4Base7destroyEv(i2);
  return;
 }
 __ZN5physx7NpScene26removeFromParticleBaseListERNS_14PxParticleBaseE(i1, i2);
 __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i1 + 16 | 0, i2 + 20 | 0, 1);
 i2 = i2 + 20 | 0;
 __ZN5physx3Scb4Base7destroyEv(i2);
 return;
}

function __ZN5physx12NpBatchQueryD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 92916 + 8;
 __ZN5physx2Sq17SceneQueryManager12freeSPUTasksEPNS_12NpBatchQueryE((HEAP32[i2 + 8 >> 2] | 0) + 3392 | 0, i2);
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if (!((i1 | 0) == 0 | ((i3 | 0) < 0 | (i3 & 2147483647 | 0) == 0))) {
  i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = i2 + 4 | 0;
 __ZN5physx6shdfnd8SyncImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN16ParticleRendererC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode(i1, 4, i5, i3);
 HEAP32[i1 >> 2] = gb + 190956 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 190956 + 184;
 __ZN8Renderer10SetVisibleEb(i1, 0);
 HEAP32[i1 + 376 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_110DataStream17pushBackObjectRefEPKvPKcS2_(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i3 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i4, i3) | 0;
 HEAP32[i6 >> 2] = gb + 150080 + 8;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i3;
 i3 = i6 + 24 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i4, i6, 16);
 STACKTOP = i5;
 return (HEAPU8[i4 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 i3 = i1 + 56 | 0;
 i2 = i1 + 60 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN3WWW7ReleaseEv(i3);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __Z37AudioSettings_CUSTOM_SetDSPBufferSizeii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 883442 | 0, 0, gb + 875076 | 0, 157, 512, 0, 0, 0);
 __ZN12AudioManager16GetConfigurationEv(i3, __Z15GetAudioManagerv() | 0);
 HEAP32[i3 + 4 >> 2] = i2;
 if (__ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting(__Z15GetAudioManagerv() | 0, i3) | 0) {
  STACKTOP = i1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 883585 | 0, 0, gb + 875076 | 0, 161, 512, 0, 0, 0);
 STACKTOP = i1;
 return;
}

function __Z36MeshFilter_Set_Custom_PropSharedMeshP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function _scalbn(d2, i1) {
 d2 = +d2;
 i1 = i1 | 0;
 var i3 = 0;
 if ((i1 | 0) > 1023) {
  d2 = d2 * 8988465674311579538646525.0e283;
  i3 = i1 + -1023 | 0;
  i1 = i1 + -2046 | 0;
  if ((i3 | 0) > 1023) {
   d2 = d2 * 8988465674311579538646525.0e283;
   i1 = (i1 | 0) > 1023 ? 1023 : i1;
  } else i1 = i3;
 } else if ((i1 | 0) < -1022) {
  d2 = d2 * 2.2250738585072014e-308;
  i3 = i1 + 1022 | 0;
  i1 = i1 + 2044 | 0;
  if ((i3 | 0) < -1022) {
   d2 = d2 * 2.2250738585072014e-308;
   i1 = (i1 | 0) < -1022 ? -1022 : i1;
  } else i1 = i3;
 }
 i1 = _bitshift64Shl(i1 + 1023 | 0, 0, 52) | 0;
 i3 = getTempRet0() | 0;
 HEAP32[tempDoublePtr >> 2] = i1;
 HEAP32[tempDoublePtr + 4 >> 2] = i3;
 return +(d2 * +HEAPF64[tempDoublePtr >> 3]);
}

function __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EEclEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 2496 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i3 = ((i6 + 1 | 0) >>> 0) % 624 | 0;
 i4 = i1 + (i6 << 2) | 0;
 i5 = HEAP32[i1 + (i3 << 2) >> 2] | 0;
 HEAP32[i4 >> 2] = 0 - (i5 & 1) & -1727483681 ^ HEAP32[i1 + ((((i6 + 397 | 0) >>> 0) % 624 | 0) << 2) >> 2] ^ (i5 & 2147483646 | HEAP32[i4 >> 2] & -2147483648) >>> 1;
 i1 = HEAP32[i1 + (HEAP32[i2 >> 2] << 2) >> 2] | 0;
 i1 = i1 >>> 11 ^ i1;
 HEAP32[i2 >> 2] = i3;
 i1 = i1 << 7 & -1658038656 ^ i1;
 i1 = i1 << 15 & -272236544 ^ i1;
 return i1 >>> 18 ^ i1 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 24 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 2) | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if ((i1 | 0) < 24 & (i2 & 4 | 0) == 0) HEAP32[i6 >> 2] = i1; else HEAP32[i7 >> 2] = i2 | 4;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj(i1, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if ((i7 | 0) == -1 | i2 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 i2 = i2 - i5 | 0;
 i3 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (i4) i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 >>> 0 > i7 >>> 0;
 i1 = __ZNSt3__211char_traitsIwE7compareEPKwS3_j(i1 + (i5 << 2) | 0, i6, i2 ? i7 : i3) | 0;
 if (!i1) return (i3 >>> 0 < i7 >>> 0 ? -1 : i2 & 1) | 0; else return i1 | 0;
 return 0;
}

function __ZNK5physx12NpConstraint18getSceneFromActorsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i5 = (i2 | 0) == 0;
 if (i5) i4 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0) & 8)) i4 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0; else i4 = 0;
 i3 = (i1 | 0) == 0;
 if (i3) i2 = 0; else if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0) & 8)) i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0; else i2 = 0;
 i1 = (i4 | 0) != 0;
 if (!(i5 | i1)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i3 | (i2 | 0) != 0 ? (i1 ? i4 : i2) : 0;
 return i5 | 0;
}

function __ZN5physx2Sc5Scene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i6 = 0;
 i3 = (HEAP32[(HEAP32[i2 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 16 | 0;
 if (!((i5 | 0) != 0 & (HEAP32[i3 >> 2] | 0) == 0)) {
  HEAP32[i3 >> 2] = i5;
  return;
 }
 i4 = i2 + 1128 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i5;
  return;
 }
 i1 = i2 + 1124 | 0;
 i2 = 0;
 do {
  i6 = (__ZNK5physx2Sc8BodyCore6getSimEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) | 0) + 144 | 0;
  HEAP16[i6 >> 1] = HEAPU16[i6 >> 1] | 0 | 64;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 HEAP32[i3 >> 2] = i5;
 return;
}

function __ZN5physx2Cm23createFreeListAllocatorERNS_19PxAllocatorCallbackE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, 4244, gb + 778980 | 0, gb + 732730 | 0, 244) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i1 >> 2] = gb + 110628 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = i2;
 i2 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, gb + 778771 | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 __ZN5physx6shdfnd9MutexImplC2Ev(i2);
 _memset(i1 + 16 | 0, 0, 4228) | 0;
 i2 = i1;
 return i2 | 0;
}

function __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_12PxFixedJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN22UnityAnalyticsSettingsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN19BaseConnectSettingsC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 189312 + 8;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 1;
 HEAP8[i1 + 10 >> 0] = 0;
 return;
}

function __ZN13ComputeBuffer19UnloadFromGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i7 = i2 + 4 | 0;
 i6 = i2;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 808 >> 2] | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 i4 = __Z25GetUncheckedRealGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 748 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __Z45AudioSettings_Get_Custom_PropOutputSampleRatev() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 if (i2 | 0) {
  __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i2, i1, 0, 0, 0, 0, 0) | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 if (!(HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0)) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 875219 | 0, 0, gb + 875076 | 0, 101, 1, 0, 0, 0);
 i2 = 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z22GameObject_CUSTOM_FindP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallString6ToUTF8Ev(i3, i4);
 i1 = __Z27FindActiveTransformWithPathPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 if (!i1) {
  i4 = 0;
  i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i4) | 0;
  STACKTOP = i2;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = __ZN9Scripting19ScriptingWrapperForEP6Object(i4) | 0;
 STACKTOP = i2;
 return i4 | 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 8);
  return;
 } else {
  i6 = i3;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 8 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 8);
  return;
 } else {
  i6 = i3;
  i3 = HEAP32[i6 + 4 >> 2] | 0;
  i5 = i1;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 12 | 0;
 i6 = i4;
 i7 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i6, i7, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i5, (HEAP8[i6 + 11 >> 0] | 0) < 0 ? HEAP32[i6 >> 2] | 0 : i6);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 i3 = __ZN15FileSystemEntry8SetFlagsEjj(i5, i2, i3) | 0;
 __ZN13FileEntryDataD2Ev(i5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK5Umbra4AABB10getPlaneEqEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, f6 = f0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 i7 = i3 >>> 1 & 3;
 i3 = (i3 & 1 | 0) != 0;
 i2 = i3 ? i2 + 12 | 0 : i2;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 f6 = Math_fround(HEAPF32[i8 + (i7 << 2) >> 2]);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i1 + (i7 << 2) >> 2] = i3 ? Math_fround(-1.0) : Math_fround(1.0);
 f5 = Math_fround(-f6);
 HEAPF32[i1 + 12 >> 2] = i3 ? f6 : f5;
 STACKTOP = i4;
 return;
}

function __ZN5physx9NpPhysics20releaseSceneInternalERNS_7PxSceneE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 i5 = i1 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L1 : do if (i6 | 0) {
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = i3 + (i2 << 2) | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i7 | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i6 >>> 0) break L1;
  }
  i6 = i6 + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = HEAP32[i3 + (i6 << 2) >> 2];
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 4 >> 2] | 0, i7 | 0);
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, HEAP32[i2 + 8 >> 2] | 0, 1);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i2 + 12 | 0, i2);
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
 if (!i1) {
  i2 = i2 + 20 | 0;
  __ZN5physx3Scb4Base7destroyEv(i2);
  return;
 }
 __ZN5physx7NpScene26removeFromParticleBaseListERNS_14PxParticleBaseE(i1, i2);
 __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i1 + 16 | 0, i2 + 20 | 0, 1);
 i2 = i2 + 20 | 0;
 __ZN5physx3Scb4Base7destroyEv(i2);
 return;
}

function __ZN5physx12NpBatchQuery13setUserMemoryERKNS_18PxBatchQueryMemoryE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!(__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1 + 40 | 0, 0, 0) | 0)) {
  i4 = i1 + 80 | 0;
  i1 = i3;
  i2 = i4 + 48 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  STACKTOP = i5;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 60, gb + 688036 | 0, i2);
  STACKTOP = i5;
  return;
 }
}

function __ZN2UI6Canvas16SetPlaneDistanceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 364 | 0;
 if (!(Math_fround(HEAPF32[i4 >> 2]) != f2)) {
  STACKTOP = i5;
  return;
 }
 HEAPF32[i4 >> 2] = f2;
 HEAPF32[i1 + 408 >> 2] = f2;
 if (HEAP32[i1 + 344 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 i4 = HEAP32[gb + 1467948 >> 2] | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = fb + 1103;
 __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i6, i4, i3);
 i4 = i1 + 224 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 6;
 STACKTOP = i5;
 return;
}

function __ZN23ShaderVariantCollectionC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 68748 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i1 + 36;
 HEAP8[i1 + 44 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN16UnityAdsSettingsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 189284 + 8;
 i1 = i2 + 36 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 + 48 >> 2] | 0;
  HEAP32[i3 >> 2] = 66;
  HEAP32[i3 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 }
 i1 = i2 + 20 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 32 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer17flushRenderEventsEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i1 = i6 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i5 = i6 + 20 | 0;
  i5 = HEAP32[i5 >> 2] | 0;
  i6 = i6 + 24 | 0;
  HEAP32[i6 >> 2] = i5;
  return;
 }
 i2 = i6 + 52 | 0;
 i3 = i6 + 20 | 0;
 i4 = i6 + 24 | 0;
 i5 = 0;
 do {
  i8 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  i7 = HEAP32[i3 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i8 >> 2] | 0) + 8 >> 2] | 0, i8 | 0, i7 | 0, (HEAP32[i4 >> 2] | 0) - i7 | 0);
  i5 = i5 + 1 | 0;
 } while (i5 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 i7 = i6 + 20 | 0;
 i7 = HEAP32[i7 >> 2] | 0;
 i8 = i6 + 24 | 0;
 HEAP32[i8 >> 2] = i7;
 return;
}

function __ZN12_GLOBAL__N_110DataStream15removeObjectRefEPKvPKcS2_(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i3 = __ZN12_GLOBAL__N_110DataStream8toStreamEPKc(i4, i3) | 0;
 HEAP32[i6 >> 2] = gb + 150060 + 8;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i3;
 i3 = i6 + 24 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 0;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i4, i6, 17);
 STACKTOP = i5;
 return (HEAPU8[i4 + 392 >> 0] | 0) ^ 1 | 0;
}

function __Z21GetUIScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[gb + 1468152 >> 2] | 0;
 if (i2 | 0) {
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1012556 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1468152 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i1, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1012675 | 0, gb + 1012682 | 0);
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i1 + 4 >> 0] | 0;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 346 | 0, fb + 347 | 0);
 i2 = HEAP32[gb + 1468152 >> 2] | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN7Striper4InitER13STRIPERCREATE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN7Striper11FreeUsedRamEv(i4) | 0;
 i3 = __Znwj(20) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i4 >> 2] = i3;
 if (__ZN5Unity11Adjacencies4InitEPKtPKji(i3, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0) {
  i4 = 1;
  return i4 | 0;
 }
 i3 = HEAP32[i4 >> 2] | 0;
 if (i3 | 0) {
  i1 = i3 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) __ZdaPv(i2);
  HEAP32[i1 >> 2] = 0;
  i1 = HEAP32[i3 + 16 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
  __ZdlPv(i3);
 }
 HEAP32[i4 >> 2] = 0;
 i4 = 0;
 return i4 | 0;
}

function __ZN22GenericPropertyBinding8RegisterEPKc11ClassIDTypePFfPvEPFvS3_fE(i4, i1, i5, i6, i7) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 i3 = i4 + 260 | 0;
 HEAP32[i4 + 4 + (HEAP32[i3 >> 2] << 2) >> 2] = i1;
 HEAP32[i4 + 68 + (HEAP32[i3 >> 2] << 2) >> 2] = i6;
 HEAP32[i4 + 132 + (HEAP32[i3 >> 2] << 2) >> 2] = i7;
 HEAP32[i4 + 196 + (HEAP32[i3 >> 2] << 2) >> 2] = i5;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN16GeometryJobTasksC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63304 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = -1;
 HEAP32[i1 + 32 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i4 = (__ZNK11Rigidbody2D12OverlapPointERK8Vector2f(i4, i3) | 0) & 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z45AudioSettings_Set_Custom_PropOutputSampleRatei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 875339 | 0, 0, gb + 875076 | 0, 123, 512, 0, 0, 0);
 __ZN12AudioManager16GetConfigurationEv(i3, __Z15GetAudioManagerv() | 0);
 HEAP32[i3 + 8 >> 2] = i1;
 if (__ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting(__Z15GetAudioManagerv() | 0, i3) | 0) {
  STACKTOP = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 875504 | 0, 0, gb + 875076 | 0, 127, 512, 0, 0, 0);
 STACKTOP = i2;
 return;
}

function __Z42AnchoredJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + 156 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  mftCall_vii(i1 | 0, i4 | 0, i3 | 0);
  STACKTOP = i5;
  return;
 }
}

function __Z13GetFileLengthRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i3, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i1 = __ZNK15FileSystemEntry4SizeEv(i4) | 0;
 i3 = getTempRet0() | 0;
 __ZN13FileEntryDataD2Ev(i4);
 setTempRet0(i3 | 0);
 STACKTOP = i2;
 return i1 | 0;
}

function __GLOBAL__sub_I_TextMeshGenerator_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1467756 >> 2] = 0;
 i3 = gb + 63680 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1467756 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1467756 + 12 >> 2] = 16;
 i1 = gb + 1467756 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3835 | 0, fb + 3836 | 0, 0, gb + 1467756 | 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1467900 | 0, 13);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467908 | 0, gb + 946192 | 0, 0, 0);
 return;
}

function _start_pass_coef_19(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i4 + 328 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == 2) i2 = i3; else {
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i4 | 0);
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 + 8 >> 2] = 0;
 do if ((HEAP32[i4 + 228 >> 2] | 0) > 1) HEAP32[i2 + 20 >> 2] = 1; else {
  i1 = HEAP32[i4 + 232 >> 2] | 0;
  if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 < ((HEAP32[i4 + 224 >> 2] | 0) + -1 | 0) >>> 0) {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
   break;
  } else {
   HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 72 >> 2];
   break;
  }
 } while (0);
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZNSt3__218__insertion_sort_3IRNS_6__lessIffEEPfEEvT0_S5_T_(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i7 = 0;
 i2 = i5 + 8 | 0;
 __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_(i5, i5 + 4 | 0, i2, i1) | 0;
 i3 = i5 + 12 | 0;
 i1 = i2;
 while (1) {
  if ((i3 | 0) == (i6 | 0)) break;
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  if (f4 < Math_fround(HEAPF32[i1 >> 2])) {
   i2 = i3;
   while (1) {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    if ((i1 | 0) == (i5 | 0)) break;
    i2 = i1 + -4 | 0;
    if (f4 < Math_fround(HEAPF32[i2 >> 2])) {
     i7 = i1;
     i1 = i2;
     i2 = i7;
    } else break;
   }
   HEAPF32[i1 >> 2] = f4;
  }
  i1 = i3;
  i3 = i3 + 4 | 0;
 }
 return;
}

function __ZNK5physx21PxsBodyTransformVault12getTransformERKNS_11PxsBodyCoreE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i1 = HEAP32[i1 + (((i2 >>> 16 ^ i2) & 1023) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
  i3 = i2 ? i3 : 0;
  return i3 | 0;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 L4 : do if (i2) while (1) {
  if ((HEAP32[i1 + 28 >> 2] | 0) == (i3 | 0)) break L4;
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  if (!i1) {
   i1 = i2;
   break;
  } else {
   i4 = i2;
   i2 = i1;
   i1 = i4;
  }
 } while (0);
 i3 = (HEAP32[i1 + 28 >> 2] | 0) == (i3 | 0);
 i4 = i1;
 i4 = i3 ? i4 : 0;
 return i4 | 0;
}

function __ZN9ShaderLabL25StaticInitializeShaderLabEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63280 | 0, 16, gb + 479897 | 0, gb + 1576256 | 0, gb + 479907 | 0, 67) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1166404 >> 2] = i1;
 i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8keywords10InitializeEv();
 __ZN9shadertag10InitializeEv();
 i2 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63280 | 0, 16, gb + 479907 | 0, 71) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[gb + 1166560 >> 2] = i2;
 if (!i1) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9ShaderLab9IntShader23CreateStateBlocksForKeyEjPK19ShaderPropertySheetS3_(i1, i6, i7, i8) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 do {
  i3 = HEAP32[i2 >> 2] | 0;
  i4 = i3 + 20 | 0;
  if ((HEAP32[i4 >> 2] | 0) > 0) {
   i1 = 0;
   do {
    __ZN9ShaderLab11ShaderState15AddDeviceStatesEjPK19ShaderPropertySheetS3_((HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 4 | 0, i6, i7, i8) | 0;
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN9GfxDevice19PutGeometryJobFenceE13UniqueSmallID(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i7 = i6 + 4 | 0;
 i4 = i6;
 i5 = i3 + 4448 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 if (!(__ZNK17UniqueIDGenerator6ExistsE13UniqueSmallID(i5, i2) | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 __ZN17UniqueIDGenerator9DestroyIDE13UniqueSmallID(i5, i2);
 __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej(i3 + 4412 | 0, i3, i1 & 16777215);
 STACKTOP = i6;
 return;
}

function __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var f5 = f0;
 __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf(i1, i2, f4);
 i2 = HEAP32[i2 >> 2] | 0;
 f5 = Math_fround(f4 - Math_fround(HEAPF32[i2 + (i3 * 20 | 0) >> 2]));
 f4 = Math_fround(f5 * Math_fround(HEAPF32[i2 + (i3 * 20 | 0) + 4 >> 2]));
 f4 = Math_fround(f5 * Math_fround(f4 + Math_fround(HEAPF32[i2 + (i3 * 20 | 0) + 8 >> 2])));
 f4 = Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i2 + (i3 * 20 | 0) + 12 >> 2]) + f4));
 return Math_fround(Math_fround(HEAPF32[i2 + (i3 * 20 | 0) + 16 >> 2]) + f4);
}

function __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 44 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = i1 + 40 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher33SaveDirtyDispatchSessionContainerERNS0_16SessionContainerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i2 + 89 >> 0] | 0)) return;
 if ((HEAP32[i2 + 72 >> 2] | 0) == (HEAP32[i2 + 68 >> 2] | 0)) {
  __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i2, i2 + 16 | 0) | 0;
  __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i2);
  HEAP32[i1 + 128 >> 2] = 0;
  HEAP8[i1 + 52 >> 0] = 1;
  return;
 } else {
  __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv(i2) | 0;
  __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i2);
  HEAP32[i1 + 128 >> 2] = 0;
  HEAP8[i1 + 52 >> 0] = 1;
  return;
 }
}

function __Z24GetTextureShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 + 24 >> 2] | 0;
 if ((i1 | 0) >= (i4 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = HEAP32[i3 + 32 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((HEAP32[i5 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = 0;
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) return i1 | 0;
 if ((i1 | 0) <= -1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[(HEAP32[i3 + 72 >> 2] | 0) + (HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) >> 2] & 1048575) >> 2] | 0;
 return i6 | 0;
}

function __Z10anyGreaterRK8Scalar4fS1_RS_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, f9 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f9 > Math_fround(HEAPF32[i3 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f9 > Math_fround(HEAPF32[i3 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = f9 > Math_fround(HEAPF32[i3 + 8 >> 2]);
 f9 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i3 = f9 > Math_fround(HEAPF32[i3 + 12 >> 2]);
 __ZN8Scalar4fC2Ebbbb(i8, i7, i6, i5, i3);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 STACKTOP = i4;
 return (i7 | i6 | i5 | i3) & 1 | 0;
}

function __ZNSt3__217__assoc_sub_state9__executeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 8 | 0;
 i3 = i1;
 i1 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__215future_categoryEv() | 0;
 HEAP32[i3 >> 2] = 3;
 HEAP32[i3 + 4 >> 2] = gb + 1473484;
 __THREW__ = 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 invoke_vii(fb + 4499 | 0, i1 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i3 | 0);
 } else ___cxa_throw(i1 | 0, gb + 10672 | 0, fb + 3023 | 0);
}

function __ZNK8VRDevice17GetViewportForEyeE15StereoscopicEyeR5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0;
 switch (HEAP32[(__Z17GetPlayerSettingsv() | 0) + 328 >> 2] | 0) {
 case 2:
  {
   i3 = 0;
   return i3 | 0;
  }
 case 1:
  {
   if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 520 >> 2] | 0) != 1) {
    i3 = 0;
    return i3 | 0;
   }
   f4 = Math_fround(HEAPF32[i1 + 312 >> 2]);
   f5 = Math_fround(f4 * Math_fround(.5));
   HEAPF32[i3 >> 2] = Math_fround(Math_fround(i2 | 0) * f5);
   HEAPF32[i3 + 8 >> 2] = f5;
   HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
   HEAPF32[i3 + 12 >> 2] = f4;
   i3 = 1;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx3Ext21InertiaTensorComputerC2ERKNS_7PxMat33ERKNS_6PxVec3Ef(i4, i2, i1, f3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i4 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i4 + 32 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i4 + 36 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 40 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 44 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAPF32[i4 + 48 >> 2] = f3;
 return;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 146452 + 8;
 i1 = i2 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv(i2);
  if (HEAP32[i1 >> 2] | 0) do mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) {
  __ZdlPv(i2);
  return;
 }
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[HEAP32[i2 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx25PxVehicleGraphChannelDescC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 16 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 20 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 24 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 28 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 32 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_10PxMaterialEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = i6 + 8 | 0;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i6 >> 2] = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
 i2 = i7;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 i4 = __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier(HEAP32[i1 + 56 >> 2] | 0, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN15CapsuleCollider9SetCenterERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 i3 = i1 + 72 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 if (f5 != Math_fround(HEAPF32[i2 >> 2])) i4 = 4; else {
  f5 = Math_fround(HEAPF32[i1 + 76 >> 2]);
  if (f5 != Math_fround(HEAPF32[i2 + 4 >> 2])) i4 = 4; else {
   f5 = Math_fround(HEAPF32[i1 + 80 >> 2]);
   if (f5 != Math_fround(HEAPF32[i2 + 8 >> 2])) i4 = 4;
  }
 }
 if ((i4 | 0) == 4) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 return;
}

function __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13MonoBehaviour25TransferEngineAndInstanceI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = __ZN13MonoBehaviour18TransferEngineDataI14SafeBinaryReadEE4PPtrI10MonoScriptERT_(i1, i2) | 0;
 __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject(i1, i3, 0);
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 i5 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI14SafeBinaryReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i5, HEAP32[i1 + 56 >> 2] | 0);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache5ClearER13dynamic_arrayIPNS0_23CachedComponentBindingsELj4EE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, gb + 63320 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z44Collider2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  i4 = (__ZNK10Collider2D12OverlapPointERK8Vector2f(i4, i3) | 0) & 1;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __Z30VRDevice_Get_Custom_PropFamilyv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i3 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = __Z12GetIVRDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i1 + 4 | 0 : i2, HEAP32[i1 + 20 >> 2] | 0) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i1 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + 24 | 0);
 i3 = i2;
 STACKTOP = i4;
 return i3 | 0;
}

function mftCall_fiiiiiiiifiiiif(i15, i1, i2, i7, i8, i9, i10, i11, i12, d13, i14, i3, i4, i5, d6) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 d13 = +d13;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 if ((i15 | 0) >= (fb | 0) & (i15 | 0) < (fb + 15 | 0)) return +Math_fround(FUNCTION_TABLE_fiiiiiiiifiiiif[i15 - fb & 15](i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, Math_fround(d13), i14 | 0, i3 | 0, i4 | 0, i5 | 0, Math_fround(d6)));
 return +ftCall_fiiiiiiiifiiiif(i15 | 0, i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, +d13, i14 | 0, i3 | 0, i4 | 0, i5 | 0, +d6);
}

function __ZNK6IDList16GetRectOfControlEiR5RectTIfE(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 i2 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = i1 + (i2 * 28 | 0) | 0;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i3 | 0)) if (Math_fround(HEAPF32[i1 + 20 >> 2]) != Math_fround(-1.0)) break;
  i1 = i1 + 28 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) return i1 | 0;
 i5 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 i5 = 1;
 return i5 | 0;
}

function __ZNK5physx2Sc5Scene8getStatsERNS_22PxSimulationStatisticsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx2Sc8SimStats7readOutERNS_22PxSimulationStatisticsERKNS_11PxvSimStatsE(HEAP32[i2 + 1184 >> 2] | 0, i1, (HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 6980 | 0);
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 1416 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 1420 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 1424 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 1428 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 1432 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 1436 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 1440 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 1444 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 1448 >> 2];
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 i4 = (i2 | 0) != 0;
 if (i4) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, i2);
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 if (!i4) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 return;
}

function __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorEj(i6, i4, i3, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP16[i3 + 4 >> 1] | 0;
 if ((HEAP16[i6 + 4 >> 1] | 0) == 1) i2 = i6; else i2 = HEAP32[i6 >> 2] | 0;
 i1 = __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E(i4, HEAP32[i2 + (i5 << 2) >> 2] | 0, i3, i1 << 16 >> 16 == 5 | i1 << 16 >> 16 == 15, 0) | 0;
 i2 = i6 + 8 | 0;
 if ((HEAP16[i6 + 12 >> 1] | 0) == 1) {
  i6 = i2;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i1;
  return;
 } else {
  i6 = HEAP32[i2 >> 2] | 0;
  i6 = i6 + (i5 << 2) | 0;
  HEAP32[i6 >> 2] = i1;
  return;
 }
}

function __ZN14SphereCollider9SetCenterERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 i3 = i1 + 64 | 0;
 f5 = Math_fround(HEAPF32[i3 >> 2]);
 if (f5 != Math_fround(HEAPF32[i2 >> 2])) i4 = 4; else {
  f5 = Math_fround(HEAPF32[i1 + 68 >> 2]);
  if (f5 != Math_fround(HEAPF32[i2 + 4 >> 2])) i4 = 4; else {
   f5 = Math_fround(HEAPF32[i1 + 72 >> 2]);
   if (f5 != Math_fround(HEAPF32[i2 + 8 >> 2])) i4 = 4;
  }
 }
 if ((i4 | 0) == 4) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 return;
}

function __ZN14MemoryProfiler22GetRelatedIDMemorySizeEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = (HEAP32[i1 + 160 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = i4;
  i3 = i2;
 }
 L3 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((i1 | 0) == (i4 | 0) ? 1 : (HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i5 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 return i5 | 0;
}

function __ZN12AudioManager33GetAudioEffectInternalDefinitionsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 240 | 0;
 i3 = i1 + 256 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 & 2147483647 | 0) return i2 | 0;
 if ((i4 | 0) > -1) {
  HEAP32[i3 >> 2] = 1024;
  HEAP32[i2 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i2 >> 2] | 0, 4096, 4, i1 + 244 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return i2 | 0;
 } else {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(4096, 4, i1 + 244 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 + 252 >> 2] << 2 | 0) | 0;
  HEAP32[i3 >> 2] = 1024;
  HEAP32[i2 >> 2] = i4;
  return i2 | 0;
 }
 return 0;
}

function __Z29VRDevice_Get_Custom_PropModelv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i3 = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = __Z12GetIVRDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i2 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i1 + 4 | 0 : i2, HEAP32[i1 + 20 >> 2] | 0) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i1 + 4 >> 2] | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + 24 | 0);
 i3 = i2;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z29Animation_Set_Custom_PropClipP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN9Animation7SetClipE4PPtrI13AnimationClipE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function _UNITY_png_destroy_write_struct(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) return;
 _UNITY_png_destroy_info_struct(i3, i2);
 HEAP32[i1 >> 2] = 0;
 if (HEAP32[i3 + 208 >> 2] & 2 | 0) _unity_z_deflateEnd(i3 + 220 | 0) | 0;
 _UNITY_png_free_buffer_list(i3, i3 + 276 | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 380 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 376 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 384 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 388 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 392 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 396 >> 2] | 0);
 _UNITY_png_free(i3, HEAP32[i3 + 592 >> 2] | 0);
 _UNITY_png_destroy_png_struct(i3);
 return;
}

function __ZNKSt3__211__libcpp_db15__subscriptableEPKvi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i2) | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i3 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
    ___resumeException(i3 | 0);
   }
  }
 }
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return i1 | 0;
}

function __ZNK21ArchiveStorageCreator23CheckBlockIsInitializedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 4 | 0;
 if (HEAP8[i1 + 1320 >> 0] | 0) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 __Z6FormatPKcz(i2, gb + 490305 | 0, i3);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 490375 | 0, 655, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 i3 = 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9Behaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 391094 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, HEAP32[gb + 37300 >> 2] | 0, i1 + 32 | 0, 257);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx7NpShape14resetFilteringEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 1, gb + 689543 | 0, 438, gb + 690141 | 0, i5);
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i1 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i3 >> 2] = i4;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 216 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, i3 | 0, 1);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd10ThreadImpl11getPriorityEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 28 | 0;
 i2 = i5;
 if (_pthread_getschedparam(i1 | 0, i4 | 0, i2 | 0) | 0) {
  i4 = 2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = _sched_get_priority_max(i2 | 0) | 0;
 i2 = _sched_get_priority_min(i2 | 0) | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 2;
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = ~~Math_fround(+_roundf(+Math_fround(Math_fround(Math_fround((i1 - i3 | 0) >>> 0) * Math_fround(4.0)) / Math_fround(i1 - i2 | 0))));
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcNS_14PxProfileNamesEj(i1, i4, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 i6 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 288, gb + 766896 | 0, gb + 740601 | 0, 138) | 0;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_(i6, i1, i4, i2, i7);
 STACKTOP = i5;
 return i6 + 116 | 0;
}

function __ZN4FMOD7Channel17set3DConeSettingsEfff(i5, f1, f3, f4) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = HEAP32[gb + 1459872 + (i5 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i5 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i5 & 65535 | 0)) {
   i6 = 0;
   STACKTOP = i7;
   return i6 | 0;
  }
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 858972;
 _printf(gb + 853184 | 0, i6) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN17Physics2DSettings21SetLayerCollisionMaskEij(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 if (i2 >>> 0 > 31) {
  HEAP32[i5 >> 2] = 31;
  __Z6FormatPKcz(i4, gb + 806650 | 0, i5);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4, 0, gb + 805767 | 0, 440, 1, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[(HEAP32[i1 + 168 >> 2] | 0) + (i2 << 2) >> 2] = i3;
  STACKTOP = i6;
  return;
 }
}

function __ZN13ResourceImageC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = __Z13GetFileLengthRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i2) | 0;
 getTempRet0() | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 63528 | 0, 0, gb + 468719 | 0, 17) | 0;
 HEAP32[i1 >> 2] = i4;
 if (__Z12ReadFromFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvyj(i2, i4, 0, 0, HEAP32[i3 >> 2] | 0) | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468815 | 0, 0, gb + 468719 | 0, 21, 1, 0, 0, 0);
 return;
}

function __Z22CleanupAfterRenderLoopR10RenderLoop(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z22GetRenderBufferManagerv() | 0;
 i1 = 0;
 do {
  i3 = i5 + 4 + (i1 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) {
   __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i2, i4);
   HEAP32[i3 >> 2] = 0;
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 __ZN9ShaderLab23ClearGrabPassFrameStateEv();
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 }
 HEAP32[i5 >> 2] = 0;
 return;
}

function _UNITY_TT_Get_VMetrics(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (HEAP8[i1 + 292 >> 0] | 0) {
  mftCall_viiiii(HEAP32[(HEAP32[i1 + 532 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, 1, i2 | 0, i4 | 0, i5 | 0);
  return;
 }
 if ((HEAP16[i1 + 364 >> 1] | 0) == -1) {
  i2 = i1 + 220 | 0;
  HEAP16[i4 >> 1] = (HEAPU16[i2 >> 1] | 0) - i3;
  i4 = HEAP32[i2 >> 2] | 0;
  i4 = (i4 << 16 >> 16) - (i4 >> 16) | 0;
  HEAP16[i5 >> 1] = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
  return;
 } else {
  i2 = i1 + 434 | 0;
  HEAP16[i4 >> 1] = (HEAPU16[i2 >> 1] | 0) - i3;
  i4 = (HEAP16[i2 >> 1] | 0) - (HEAP16[i1 + 436 >> 1] | 0) | 0;
  HEAP16[i5 >> 1] = (i4 | 0) < 0 ? 0 - i4 | 0 : i4;
  return;
 }
}

function mftCall_fiiiiiifiiiiiif(i15, i1, i2, i7, i8, i9, i10, d11, i12, i13, i14, i3, i4, i5, d6) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 d11 = +d11;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 if ((i15 | 0) >= (fb | 0) & (i15 | 0) < (fb + 7 | 0)) return +Math_fround(FUNCTION_TABLE_fiiiiiifiiiiiif[i15 - fb & 7](i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, Math_fround(d11), i12 | 0, i13 | 0, i14 | 0, i3 | 0, i4 | 0, i5 | 0, Math_fround(d6)));
 return +ftCall_fiiiiiifiiiiiif(i15 | 0, i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, +d11, i12 | 0, i13 | 0, i14 | 0, i3 | 0, i4 | 0, i5 | 0, +d6);
}

function __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 d2 = +HEAPF64[i4 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 if (d2 < d3) {
  HEAPF64[i5 >> 3] = d2;
  HEAPF64[i4 >> 3] = d3;
  i4 = i1 + 1 | 0;
  d2 = +HEAPF64[i5 >> 3];
  d3 = +HEAPF64[i7 >> 3];
  if (d2 < d3) {
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i5 >> 3] = d3;
   d2 = +HEAPF64[i7 >> 3];
   d3 = +HEAPF64[i6 >> 3];
   if (d2 < d3) {
    HEAPF64[i6 >> 3] = d2;
    HEAPF64[i7 >> 3] = d3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_(i6, i7, i5, i4, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0;
 i1 = __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_(i6, i7, i5, i1) | 0;
 d2 = +HEAPF64[i4 >> 3];
 d3 = +HEAPF64[i5 >> 3];
 if (d2 < d3) {
  HEAPF64[i5 >> 3] = d2;
  HEAPF64[i4 >> 3] = d3;
  i4 = i1 + 1 | 0;
  d2 = +HEAPF64[i5 >> 3];
  d3 = +HEAPF64[i7 >> 3];
  if (d2 < d3) {
   HEAPF64[i7 >> 3] = d2;
   HEAPF64[i5 >> 3] = d3;
   d2 = +HEAPF64[i7 >> 3];
   d3 = +HEAPF64[i6 >> 3];
   if (d2 < d3) {
    HEAPF64[i6 >> 3] = d2;
    HEAPF64[i7 >> 3] = d3;
    i1 = i1 + 3 | 0;
   } else i1 = i1 + 2 | 0;
  } else i1 = i4;
 }
 return i1 | 0;
}

function __ZNK5physx13BigConvexData13ComputeOffsetERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, f5 = f0, f6 = f0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 4 | 0;
 i4 = i3;
 i2 = HEAPU16[i2 >> 1] | 0;
 i1 = __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_(i1, i7, i4) | 0;
 f5 = Math_fround(Math_fround((i2 + -1 | 0) >>> 0) * Math_fround(.5));
 f6 = Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i7 >> 2]) + Math_fround(1.0)));
 i2 = (Math_imul((~~f6 >>> 0) + (Math_imul(i1, i2) | 0) | 0, i2) | 0) + (~~Math_fround(f5 * Math_fround(Math_fround(HEAPF32[i4 >> 2]) + Math_fround(1.0))) >>> 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager15getRenderBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 64, (i1 ? gb + 658394 | 0 : gb + 837976 | 0) | 0, gb + 657349 | 0, 75) | 0;
 HEAP32[i1 >> 2] = gb + 86472 + 8;
 i2 = i1 + 4 | 0;
 i3 = i2 + 60 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i4 >> 2] = i1;
 i4 = i1;
 return i4 | 0;
}

function __ZN5physx2Sn18RepXCollectionImpl12copyRepXNodeEPKNS0_7XmlNodeE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = __ZN5physx19CVariableMemoryPool8allocateEj(i2 + 8 | 0, 24) | 0;
 i1 = i3 + 4 | 0;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 1576256;
 HEAP32[i1 >> 2] = gb + 1576256;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 20 >> 2] = 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 if (!i1) return i3 | 0;
 HEAP32[i3 + 16 >> 2] = __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_(i2 + 4 | 0, i1, i3) | 0;
 return i3 | 0;
}

function __ZN5physx2Gu9Container18DeleteKeepingOrderEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) return i1 | 0;
 i6 = i3 + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 if (i1 >>> 0 >= i6 >>> 0) {
  i6 = 1;
  return i6 | 0;
 }
 do {
  i6 = i1;
  i1 = i1 + 1 | 0;
  HEAP32[i4 + (i6 << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 i1 = 1;
 return i1 | 0;
}

function __ZN5physx15PxsParticleData13clearSimStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 i7 = HEAP32[i2 + 56 >> 2] | 0;
 i6 = (i1 + -1 | 0) >>> 5;
 i4 = i2 + 48 | 0;
 i5 = 0;
 while (1) {
  i1 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
  if (i1 | 0) {
   i2 = i5 << 5;
   i3 = HEAP32[i4 >> 2] | 0;
   do {
    i8 = (Math_imul(i1 & 0 - i1, 125613361) | 0) >>> 27;
    i8 = HEAP32[gb + 90668 + (i8 << 2) >> 2] | i2;
    HEAP16[i3 + (i8 << 5) + 30 >> 1] = 0;
    HEAPF32[i3 + (i8 << 5) + 12 >> 2] = Math_fround(0.0);
    i1 = i1 + -1 & i1;
   } while ((i1 | 0) != 0);
  }
  if ((i5 | 0) == (i6 | 0)) break; else i5 = i5 + 1 | 0;
 }
 return;
}

function __ZN23OverlapCallbackNonAlloc14processTouchesEPKN5physx12PxOverlapHitEj(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = i1 + 44 | 0;
 if (!i5) {
  i7 = 1;
  return i7 | 0;
 }
 i7 = HEAP32[i1 + 40 >> 2] | 0;
 i2 = i1 + 36 | 0;
 i1 = 0;
 i3 = HEAP32[i6 >> 2] | 0;
 while (1) {
  if ((i3 | 0) >= (i7 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i9 = HEAP32[(HEAP32[i4 + (i1 << 4) + 4 >> 2] | 0) + 8 >> 2] | 0;
  i8 = i3;
  i3 = i3 + 1 | 0;
  HEAP32[i6 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i8 << 2) >> 2] = i9;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN22ParticleSystemRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(1036, i1, 16, gb + 1048932 | 0, 0, gb + 622283 | 0, 42) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN22ParticleSystemRendererC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN18LoadSceneOperationD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 65820 + 8;
 i1 = HEAP32[i2 + 160 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZN18AwakeFromLoadQueueD2Ev(i2 + 180 | 0);
 i1 = i2 + 164 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZN13LoadOperationD2Ev(i2);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 + 176 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 __ZN13LoadOperationD2Ev(i2);
 STACKTOP = i4;
 return;
}

function __ZN14PlayerSettings15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452721 | 0, gb + 448333 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452743 | 0, gb + 448355 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452766 | 0, gb + 449861 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452789 | 0, gb + 449878 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452809 | 0, gb + 448984 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452828 | 0, gb + 448378 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 448085 | 0, gb + 452854 | 0, gb + 448936 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer17ArchiveEventQueueERK8UnityStrS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 __ZN12FileAccessorC2Ev(i4);
 if (!(__ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor(0, i2, i3, i4) | 0)) {
  i3 = 0;
  __ZN12FileAccessorD2Ev(i4);
  STACKTOP = i5;
  return i3 | 0;
 }
 i3 = __ZN11UnityEngine15CloudWebService17SessionEventQueue10SaveToFileER12FileAccessor(i1 + 68 | 0, i4) | 0;
 __ZN12FileAccessor5CloseEv(i4) | 0;
 __ZN12FileAccessorD2Ev(i4);
 STACKTOP = i5;
 return i3 | 0;
}

function __Z33Canvas_Set_Custom_PropWorldCameraP12Il2CppObjectS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  __ZN2UI6Canvas9SetCameraE4PPtrI6CameraE(i5, i1);
  STACKTOP = i6;
  return;
 }
}

function mftCall_iiiiiifffiiifii(i15, i1, i2, i7, i8, i9, d10, d11, d12, i13, i14, i3, d4, i5, i6) {
 i15 = i15 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 d10 = +d10;
 d11 = +d11;
 d12 = +d12;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i15 | 0) >= (fb | 0) & (i15 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiiifffiiifii[i15 - fb & 1](i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, Math_fround(d10), Math_fround(d11), Math_fround(d12), i13 | 0, i14 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0) | 0;
 return ftCall_iiiiiifffiiifii(i15 | 0, i1 | 0, i2 | 0, i7 | 0, i8 | 0, i9 | 0, +d10, +d11, +d12, i13 | 0, i14 | 0, i3 | 0, +d4, i5 | 0, i6 | 0) | 0;
}

function __ZN9Animation7AddClipER13AnimationClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i5, _strlen(i5) | 0);
 __ZN9Animation7AddClipER13AnimationClipRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEiib(i1, i2, i4, -2147483648, 2147483647, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc9ShapeCoreD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 switch (HEAP32[i2 + 68 >> 2] | 0) {
 case 5:
  {
   if (!(HEAP8[i2 + 132 >> 0] | 0)) {
    STACKTOP = i3;
    return;
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 116 >> 2] | 0);
   HEAP16[i2 + 120 >> 1] = 0;
   STACKTOP = i3;
   return;
  }
 case 6:
  {
   if (!(HEAP8[i2 + 132 >> 0] | 0)) {
    STACKTOP = i3;
    return;
   }
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 96 >> 2] | 0);
   HEAP16[i2 + 100 >> 1] = 0;
   STACKTOP = i3;
   return;
  }
 default:
  {
   STACKTOP = i3;
   return;
  }
 }
}

function __ZN5physx2Gu30checkOverlapCapsule_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 f5 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 HEAP32[i6 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAPF32[i6 + 12 >> 2] = f5;
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 + 24 >> 2]));
 i3 = Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i3, i3 + 12 | 0, i6, 0)) <= Math_fround(f5 * f5);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i4 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 156 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sc8ClothSim9startStepEv(__ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i4 + 176 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i4 + 180 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_9PxD6JointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_9PxD6JointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN4FMOD6SoundIC2EPNS_7SystemIE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i1 + 28 >> 2] = i3;
 HEAP32[i1 + 32 >> 2] = i3;
 i3 = i1 + 36 | 0;
 i2 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = i2;
 HEAP32[i1 + 320 >> 2] = 0;
 i2 = i1 + 328 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN2UI20CalculateNestedAlphaEP9TransformPKS0_f(i2, i4, f5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var f1 = f0, i3 = 0;
 L1 : do if ((i2 | 0) == (i4 | 0)) f1 = Math_fround(1.0); else {
  f1 = Math_fround(1.0);
  while (1) {
   i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 186852 | 0) | 0;
   if (i3) if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0) {
    f1 = Math_fround(f1 * Math_fround(HEAPF32[i3 + 36 >> 2]));
    if (HEAP8[i3 + 42 >> 0] | 0) break;
   }
   i2 = HEAP32[i2 + 100 >> 2] | 0;
   if ((i2 | 0) == (i4 | 0)) break L1;
  }
  return Math_fround(f1);
 } while (0);
 f5 = Math_fround(f1 * f5);
 return Math_fround(f5);
}

function __ZN20ArchiveStorageReader15GetDecompressorEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 2392 + (i3 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = i2;
  STACKTOP = i6;
  return i5 | 0;
 }
 i8 = gb + 63552 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i5 = __Z18CreateDecompressor15CompressionType10MemLabelId(i3, i5) | 0;
 HEAP32[i1 >> 2] = i5;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN18GfxFramebufferGLES32InvalidateActiveFramebufferStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP8[i1 + 329 >> 0] = 1;
 __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i5, HEAP32[i1 + 336 >> 2] | 0, 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 168 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i1 = i1 + 176 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN15ReflectionProbe7SetModeENS_4ModeE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i4 + 40 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 HEAP8[i4 + 160 >> 0] = 1;
 if ((i1 | 0) != 1) return;
 if ((HEAP32[i4 + 44 >> 2] | 0) != 1) return;
 i3 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!i2) return;
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i5 = 9;
   break;
  }
 }
 if ((i5 | 0) == 9) return;
 __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i3, 3, i4, 63);
 return;
}

function __ZN13MemoryManager30InitializeMainThreadAllocatorsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 1551 >> 0] | 0)) __ZN13MemoryManager27InitializeDefaultAllocatorsEv(i1);
 i2 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i2 + 544 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
  __ZN12TLSAllocatorI14StackAllocatorEC2EPKc(i2, gb + 582491 | 0);
  HEAP32[i1 + 1552 >> 2] = i2;
  HEAP32[i1 + 3848 >> 2] = i2;
  i4 = i1 + 1544 | 0;
  i3 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 + 1;
  HEAP32[i1 + 1568 + (i3 << 2) >> 2] = i2;
  HEAP8[i1 + 1549 >> 0] = 1;
  HEAP8[i1 + 1550 >> 0] = 1;
  __ZN14MemoryProfiler16StaticInitializeEv();
  return;
 }
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloaderC2EPNS0_23IRestDownloaderListenerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP8[i1 + 5 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 190100 + 8;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP8[i1 + 13 >> 0] = 0;
 HEAP8[i1 + 14 >> 0] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN15FileSystemEntryC2Ev(i1 + 32 | 0);
 __ZN12FileAccessorC2Ev(i1 + 1092 | 0);
 HEAP32[i1 + 2160 >> 2] = 0;
 HEAP32[i1 + 2164 >> 2] = 0;
 return;
}

function __ZN11BoxCollider9SetCenterERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 i3 = i1 + 60 | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f5 != Math_fround(HEAPF32[i3 >> 2])) i4 = 4; else {
  f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  if (f5 != Math_fround(HEAPF32[i1 + 64 >> 2])) i4 = 4; else {
   f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   if (f5 != Math_fround(HEAPF32[i1 + 68 >> 2])) i4 = 4;
  }
 }
 if ((i4 | 0) == 4) {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 return;
}

function __ZN10MemoryFile5WriteEyyPKvPy(i5, i6, i7, i1, i2, i3, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i8 = i8 | 0;
 var i4 = 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 if (!i4) {
  i8 = 0;
  return i8 | 0;
 }
 if (!(HEAP32[i5 + 8 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i1 = mftCall_iiiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0, i6 | 0, i7 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 i2 = getTempRet0() | 0;
 i4 = _i64Add(i1 | 0, i2 | 0, i6 | 0, i7 | 0) | 0;
 i6 = getTempRet0() | 0;
 i7 = i5 + 24 | 0;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i7 + 4 >> 2] = i6;
 if (!i8) {
  i8 = 1;
  return i8 | 0;
 }
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 i8 = 1;
 return i8 | 0;
}

function __ZN10GameObject37RemoveComponentFromGameObjectInternalERN5Unity9ComponentE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i3 + 28 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i5 = i1 + 40 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if ((i6 | 0) <= 0) return;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i6 | 0)) {
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return;
 if ((i1 | 0) == -1) return;
 i3 = i2 + (i1 << 3) | 0;
 i7 = i3 + 8 | 0;
 _memmove(i3 | 0, i7 | 0, i2 + (i6 << 3) - i7 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z62GUIStyle_CUSTOM_INTERNAL_CALL_Internal_CalcSizeWithConstraints13Il2Cpp_IntPtrP12Il2CppObjectRK13Vector2fIcallPS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 8 | 0;
 i6 = i5;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZNK8GUIStyle23CalcSizeWithConstraintsER10GUIContentRK8Vector2f(i6, i1, i2, i7);
 i3 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 STACKTOP = i5;
 return;
}

function __Z49Rigidbody2D_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11Rigidbody2D20GetWorldCenterOfMassEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z42ParticleEmitter_Set_Custom_PropMinEmissionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 132 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z42ParticleEmitter_Set_Custom_PropMaxEmissionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 136 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __ZNK12TreeRenderer15GetTreePositionERK12TreeInstance(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 120 >> 2]));
 f5 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i2 + 124 >> 2]));
 f4 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 128 >> 2]));
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i2 + 136 >> 2]));
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i2 + 140 >> 2]));
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 144 >> 2]));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZNK12NavMeshAgent21CalculateScaledRadiusEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i6 >> 2]);
 i7 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i7 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 i6 = f4 < Math_fround(0.0);
 f5 = Math_fround(-f4);
 f4 = i6 ? f5 : f4;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 36 >> 2]) * (f3 < f4 ? f4 : f3));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN8Animator13GetParametersEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 }
 i4 = i2 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i2 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i2 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 } else {
  __ZN26AnimatorControllerPlayable13GetParametersEv(i1, HEAP32[HEAP32[i2 + 584 >> 2] >> 2] | 0);
  return;
 }
}

function __ZN5physx9NpFactory17removeClothFabricERNS_13PxClothFabricE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i5 = i1 + 3948 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 L1 : do if (!i6) i1 = 0; else {
  i3 = HEAP32[i1 + 3944 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = i3 + (i2 << 2) | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i6 >>> 0) {
    i1 = 0;
    break L1;
   }
  }
  i6 = i6 + -1 | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i1 >> 2] = HEAP32[i3 + (i6 << 2) >> 2];
  i1 = 1;
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return i1 | 0;
}

function __ZN5physx7profile19MemoryEventRecorder14onDeallocationEPv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i5 = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE5eraseERS4_(i2 + 8 | 0, i1) | 0;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i3 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx7NpScene24removeFromRigidActorListERKj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i1 + 3556 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i2 >> 2] = i3;
 i2 = i1 + 3552 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + (i5 << 2) >> 2] = HEAP32[i1 + (i3 << 2) >> 2];
 if (!i3) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 switch (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) {
 case 0:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 case 1:
  {
   HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Sc9ClothCoreD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 if (HEAP16[i2 + 4 >> 1] | 0) {
  __ZN5physx2Sc9ActorCoreD2Ev(i3);
  STACKTOP = i4;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 __ZN5physx2Sc9ActorCoreD2Ev(i3);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra15CameraTransform10setFrustumEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var f6 = f0, f7 = f0;
 f6 = Math_fround(Math_fround(+Math_tan(+Math_fround(Math_fround(Math_fround(f2 * Math_fround(.5)) * Math_fround(3.14159274)) / Math_fround(180.0)))) * f4);
 f2 = Math_fround(-f6);
 f7 = Math_fround(f3 * f2);
 f3 = Math_fround(f6 * f3);
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i1 + 404 >> 2] = f7;
 HEAPF32[i1 + 408 >> 2] = f3;
 HEAPF32[i1 + 412 >> 2] = f6;
 HEAPF32[i1 + 416 >> 2] = f2;
 HEAPF32[i1 + 420 >> 2] = f4;
 HEAPF32[i1 + 424 >> 2] = f5;
 HEAP32[i1 + 428 >> 2] = 0;
 HEAP8[i1 + 436 >> 0] = 1;
 return;
}

function __ZN19RuntimeSceneManager9LoadSceneERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8;
 HEAP32[i9 >> 2] = 0;
 i7 = __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene(i1, i2, i3, i4, i5, i6, i7, 1, i9) | 0;
 __ZN14PreloadManager35WaitForAllAsyncOperationsToCompleteEv(__Z17GetPreloadManagerv() | 0);
 mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 32 >> 2] | 0, i7 | 0);
 STACKTOP = i8;
 return HEAP32[i9 >> 2] | 0;
}

function __ZN10OnGUIStateC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 HEAP32[i1 + 44 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = 1065353216;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i1 + 4 >> 2] = 1065353216;
 HEAP32[i1 + 8 >> 2] = 1065353216;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 1;
 return;
}

function __ZN10Effector2D17ProcessEndContactEP10Collider2DP9b2Contact(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) return;
 i6 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = i1 + 48 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (!i4) return;
 i1 = i6 + (i4 * 40 | 0) | 0;
 i3 = i6;
 while (1) {
  if ((HEAP32[i3 + 32 >> 2] | 0) == (i5 | 0)) break;
  i3 = i3 + 40 | 0;
  if ((i3 | 0) == (i1 | 0)) {
   i7 = 7;
   break;
  }
 }
 if ((i7 | 0) == 7) return;
 i1 = i4 + -1 | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = i6 + (i1 * 40 | 0) | 0;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if ((i7 | 0) == -1 | i2 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 i2 = i2 - i5 | 0;
 i3 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (i4) i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 >>> 0 > i7 >>> 0;
 i1 = __ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1 + i5 | 0, i6, i2 ? i7 : i3) | 0;
 if (!i1) return (i3 >>> 0 < i7 >>> 0 ? -1 : i2 & 1) | 0; else return i1 | 0;
 return 0;
}

function __ZN9GfxDevice14OnCreateBufferEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 i3 = HEAP32[i1 + 4516 + (HEAP32[i2 + 12 >> 2] << 2) >> 2] | 0;
 i4 = i2 + 4 | 0;
 if ((i4 | 0) != (i3 | 0)) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = i2 + 8 | 0; else {
   i2 = i2 + 8 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i2 >> 2] = 0;
   i1 = i2;
  }
  i2 = HEAP32[i3 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 >> 2] = i3;
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 }
 if (!i5) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImplD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = gb + 147756 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i3 + 8 >> 2] = gb + 147756 + 80;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = gb + 147876 + 8;
 i2 = HEAP32[i3 + 108 >> 2] | 0;
 if (i2 | 0) {
  i5 = HEAP32[HEAP32[i3 + 100 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 }
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx7NpScene8addClothERNS_7NpClothE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 __ZN5physx3Scb5Scene8addClothERNS0_5ClothE(i6 + 16 | 0, i5 + 20 | 0);
 i2 = i6 + 3652 | 0;
 HEAP32[i1 >> 2] = i5;
 i3 = i6 + 3656 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 3660 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_7PxClothENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831008;
 HEAP32[i1 + 4 >> 2] = 564;
 HEAP32[i1 + 8 >> 2] = fb + 590;
 HEAP32[i1 + 12 >> 2] = gb + 831020;
 HEAP32[i1 + 16 >> 2] = 565;
 HEAP32[i1 + 20 >> 2] = fb + 591;
 HEAP32[i1 + 24 >> 2] = fb + 511;
 HEAP32[i1 + 28 >> 2] = gb + 831039;
 HEAP32[i1 + 32 >> 2] = 566;
 HEAP32[i1 + 36 >> 2] = fb + 592;
 HEAP32[i1 + 40 >> 2] = fb + 512;
 HEAP32[i1 + 44 >> 2] = gb + 831066;
 HEAP32[i1 + 48 >> 2] = 567;
 HEAP32[i1 + 52 >> 2] = fb + 593;
 HEAP32[i1 + 56 >> 2] = fb + 513;
 HEAP32[i1 + 60 >> 2] = gb + 831085;
 HEAP32[i1 + 64 >> 2] = 568;
 HEAP32[i1 + 68 >> 2] = fb + 594;
 HEAP32[i1 + 72 >> 2] = fb + 514;
 return;
}

function __ZN4FMOD7Channel4stopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   _JS_Sound_Stop(HEAP32[i2 + 164 >> 2] | 0, 0.0);
   __ZN4FMOD8ChannelI11EndCallbackEv(i2);
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 854017;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN37RotationBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 896 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 896 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 896 >> 2] | 0) + 616 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 896 >> 2] | 0) + 804 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 896 >> 2] | 0) + 808 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN21UnityAnalyticsManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(36, i1, 16, gb + 1048932 | 0, 0, gb + 1037903 | 0, 14) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN21UnityAnalyticsManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14PhysicsManager7AddBodyEiR8ListNodeI9RigidbodyE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if ((i1 | 0) > 62) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737601 | 0, 0, gb + 662472 | 0, 1463, 1, 0, 0, 0);
  i1 = 63;
 }
 i2 = i2 + 204 + (i1 << 3) | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i3 + 4 | 0; else {
  i4 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloaderD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 190100 + 8;
 i1 = i2 + 1092 | 0;
 if (HEAP8[i2 + 12 >> 0] | 0) __ZN12FileAccessor5CloseEv(i1) | 0;
 __ZN12FileAccessorD2Ev(i1);
 __ZN13FileEntryDataD2Ev(i2 + 32 | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher31ReleaseDispatchSessionContainerERNS0_16SessionContainerEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i2 + 16 | 0;
 if (__ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr(i2, i4) | 0 | i3 ^ 1) {
  __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i2);
  HEAP32[i1 + 128 >> 2] = 0;
  HEAP8[i1 + 52 >> 0] = 1;
  i4 = 1;
  return i4 | 0;
 } else {
  __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr(i2, i4);
  __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE(i1, i2);
  i4 = 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN10HumanTrait19GetFingerMuscleNameEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3 ? gb + 908416 | 0 : gb + 908422 | 0, i3 ? 5 : 6);
 if (i2 >>> 0 >= 20) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj(i2 >>> 2) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand13FingerDoFNameEj(i2 & 3) | 0) | 0;
 return;
}

function __Z48RelativeJoint2D_CUSTOM_INTERNAL_get_linearOffsetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK15RelativeJoint2D15GetLinearOffsetEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z40WWW_Get_Custom_PropResponseHeadersStringP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 4 | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i3); else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
  i3 = __Z20scripting_string_newPKc((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z40ParticleEmitter_Set_Custom_PropMinEnergyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 124 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z40ParticleEmitter_Set_Custom_PropMaxEnergyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 128 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z25Shader_CUSTOM_FindBuiltinP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE(__Z25GetBuiltinResourceManagerv() | 0, gb + 31552 | 0, i3) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNK6b2Rope4DrawEP6b2Draw(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAPF32[i4 >> 2] = Math_fround(.400000006);
 HEAPF32[i4 + 4 >> 2] = Math_fround(.5);
 HEAPF32[i4 + 8 >> 2] = Math_fround(.699999988);
 if ((HEAP32[i2 >> 2] | 0) <= 1) {
  STACKTOP = i6;
  return;
 }
 i5 = i2 + 4 | 0;
 i1 = 0;
 do {
  i7 = HEAP32[i5 >> 2] | 0;
  i8 = i1;
  i1 = i1 + 1 | 0;
  mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i7 + (i8 << 3) | 0, i7 + (i1 << 3) | 0, i4 | 0);
 } while ((i1 | 0) < ((HEAP32[i2 >> 2] | 0) + -1 | 0));
 STACKTOP = i6;
 return;
}

function __ZN9Rigidbody18SetAngularVelocityERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (i1 & 16 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
 if (i1 & 32 | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
 if (i1 & 64 | 0) HEAPF32[i5 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0, i5 | 0, i3 | 0, 1);
 STACKTOP = i6;
 return;
}

function __ZN5physx2Sn5ConvX6outputEy(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i6 = i3;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 if (HEAP8[i4 + 325 >> 0] | 0) {
  STACKTOP = i5;
  return;
 }
 if (HEAP8[i4 + 308 >> 0] | 0) {
  i1 = _llvm_bswap_i64(i1 | 0, i2 | 0) | 0;
  i2 = getTempRet0() | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = i1;
  HEAP32[i6 + 4 >> 2] = i2;
 }
 i6 = HEAP32[i4 + 304 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, i3 | 0, 8) | 0;
 i6 = i4 + 312 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i3;
 STACKTOP = i5;
 return;
}

function __ZN35ClampVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 884 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 884 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 884 >> 2] | 0) + 616 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 884 >> 2] | 0) + 880 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 884 >> 2] | 0) + 1068 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN13BuildSettings16GetScenePathNameEi(i6, i1, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i3;
 if (!((i5 | 0) > -1 ? ((HEAP32[i1 + 44 >> 2] | 0) - i3 >> 4 | 0) > (i5 | 0) : 0)) {
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i6 + 8 >> 2] = 0;
  return;
 }
 i1 = i4 + (i5 << 4) | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i4 + (i5 << 4) + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 };
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i6, i3, i1);
 return;
}

function __ZN11BoxCollider6CreateEPK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5;
 if (HEAP32[i1 + 36 >> 2] | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f(i3, i1, gb + 62512 | 0);
 i7 = HEAP32[i3 >> 2] | 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = 3;
 HEAP32[i4 + 4 >> 2] = i7;
 HEAP32[i4 + 8 >> 2] = i6;
 HEAP32[i4 + 12 >> 2] = i3;
 __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody(i1, i4, i2);
 STACKTOP = i5;
 return;
}

function __ZN10dtNodePoolC2Eii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 >> 2] = 0;
 i7 = i1 + 4 | 0;
 HEAP32[i7 >> 2] = 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i2 << 5 | 0) | 0;
 HEAP32[i5 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, HEAP32[i4 >> 2] << 1 | 0) | 0;
 i3 = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i3 << 1 | 0) | 0;
 HEAP32[i7 >> 2] = i3;
 _memset(i3 | 0, -1, HEAP32[i6 >> 2] << 1 | 0) | 0;
 _memset(HEAP32[i5 >> 2] | 0, -1, HEAP32[i4 >> 2] << 1 | 0) | 0;
 return;
}

function __Z43DownloadHandler_CUSTOM_InternalCreateScriptP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63808 | 0, 16, gb + 1027567 | 0, 61) | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP8[i2 + 8 >> 0] = 0;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 187584 + 8;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i3 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z35GetMinimumTextureMipHeightForFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 | 1;
 L1 : do if ((i2 | 0) == 31) i1 = 8; else {
  switch (i1 | 0) {
  case 32:
  case 33:
  case 60:
  case 61:
   {
    i1 = 8;
    break L1;
   }
  default:
   {}
  }
  switch (i1 | 0) {
  case 34:
  case 35:
  case 36:
  case 41:
  case 42:
  case 43:
  case 44:
  case 45:
  case 46:
  case 47:
   {
    i1 = 4;
    break L1;
   }
  default:
   {}
  }
  if ((i1 + -48 | 0) >>> 0 < 12) i1 = 1; else {
   switch (i1 | 0) {
   case 10:
   case 11:
   case 12:
   case 26:
   case 27:
    {
     i1 = 4;
     break L1;
    }
   default:
    {}
   }
   i1 = (i2 | 0) == 25 ? 4 : 1;
  }
 } while (0);
 return i1 | 0;
}

function __Z34GetMinimumTextureMipWidthForFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 | 1;
 L1 : do if ((i2 | 0) == 31) i1 = 16; else {
  switch (i1 | 0) {
  case 32:
  case 33:
  case 60:
  case 61:
   {
    i1 = 8;
    break L1;
   }
  default:
   {}
  }
  switch (i1 | 0) {
  case 34:
  case 35:
  case 36:
  case 41:
  case 42:
  case 43:
  case 44:
  case 45:
  case 46:
  case 47:
   {
    i1 = 4;
    break L1;
   }
  default:
   {}
  }
  if ((i1 + -48 | 0) >>> 0 < 12) i1 = 1; else {
   switch (i1 | 0) {
   case 10:
   case 11:
   case 12:
   case 26:
   case 27:
    {
     i1 = 4;
     break L1;
    }
   default:
    {}
   }
   i1 = (i2 | 0) == 25 ? 4 : 1;
  }
 } while (0);
 return i1 | 0;
}

function __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + ((HEAP8[i2 >> 0] | 0) == 0 ? i1 + -8 + (HEAP32[i2 + 12 >> 2] | 0) | 0 : i1) >> 2] | 0) | 0;
 __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i5, i4);
 STACKTOP = i3;
 return;
}

function __Z20HandleSteppedTangentRK11KeyframeTplI8Vector3fES3_RS0_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i3 = i1 + 28 | 0;
 i1 = i2 + 16 | 0;
 i2 = Math_fround(HEAPF32[i3 >> 2]) == Math_fround(inf);
 if (i2 | Math_fround(HEAPF32[i1 >> 2]) == Math_fround(inf)) HEAPF32[i4 >> 2] = Math_fround(inf);
 if (Math_fround(HEAPF32[i3 + 4 >> 2]) == Math_fround(inf)) i5 = 5; else if (Math_fround(HEAPF32[i1 + 4 >> 2]) == Math_fround(inf)) i5 = 5;
 if ((i5 | 0) == 5) HEAPF32[i4 + 4 >> 2] = Math_fround(inf);
 if (!(Math_fround(HEAPF32[i3 + 8 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i1 + 8 >> 2]) == Math_fround(inf))) return;
 HEAPF32[i4 + 8 >> 2] = Math_fround(inf);
 return;
}

function _UNITY_FT_Set_Char_Size(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i9 = (i2 | 0) == 0;
 i10 = i9 ? i3 : i2;
 i9 = i9 ? i3 : (i3 | 0) == 0 ? i2 : i3;
 i3 = (i4 | 0) == 0;
 i8 = i3 ? i5 : i4;
 i2 = (i8 | 0) == 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = (i10 | 0) < 64 ? 64 : i10;
 HEAP32[i7 + 8 >> 2] = (i9 | 0) < 64 ? 64 : i9;
 HEAP32[i7 + 12 >> 2] = i2 ? 72 : i8;
 HEAP32[i7 + 16 >> 2] = i2 ? 72 : i3 ? i5 : (i5 | 0) == 0 ? i4 : i5;
 i5 = _UNITY_FT_Request_Size(i1, i7) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwnerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 148996 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i1 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i1 + 44 >> 2] = gb + 148172 + 8;
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 28 >> 2] = gb + 148172 + 8;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwnerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 148996 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i1 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i1 + 44 >> 2] = gb + 148172 + 8;
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 28 >> 2] = gb + 148172 + 8;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i4 + 8 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i3 = i3 + -16 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev(i3);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0, i1, (HEAP32[i4 + 12 >> 2] | 0) - i1 | 0);
 return;
}

function __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei(i1, i3, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i2 + (i5 * 12 | 0) >> 2] | 0;
 if (!i1) {
  i1 = 0;
  do i1 = i1 + 1 | 0; while (i1 >>> 0 < i6 >>> 0);
  i1 = 0;
  return i1 | 0;
 }
 i4 = (HEAP32[i2 + (i5 * 12 | 0) + 4 >> 2] | 0) == (i3 | 0);
 i3 = 0;
 i2 = 0;
 while (1) {
  if (i4) if ((i2 | 0) == (i5 | 0)) {
   i2 = 8;
   break;
  } else i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i2 = 8;
   break;
  }
 }
 if ((i2 | 0) == 8) return i1 | 0;
 return 0;
}

function __ZNK12NavMeshAgent14GetDestinationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
  STACKTOP = i4;
  return;
 } else {
  __ZN7dtCrowd13getMoveTargetERK13dtCrowdHandlePf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0, i3);
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i4;
  return;
 }
}

function __ZN7Texture15FindTextureByIDE9TextureID(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = (HEAP32[gb + 1158372 >> 2] | 0) + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i5;
 L4 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L4;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((i1 | 0) == (i5 | 0) ? 1 : i4 >>> 0 < (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 3) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 3) | 0;
 do {
  i8 = i5;
  i7 = HEAP32[i8 + 4 >> 2] | 0;
  i2 = i1;
  HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
  HEAP32[i2 + 4 >> 2] = i7;
  i1 = i1 + 8 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx18RepXSerializerImplINS_7PxShapeEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_7PxShapeEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx18RepXSerializerImplINS_7PxClothEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i1, i5, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i6 = __ZN5physx2Sn17readAllPropertiesINS_7PxClothEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE(i7, i6, i5, i2, i4) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN4FMOD6SoundID2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i4 + 320 >> 2] | 0;
 if (i1 | 0) _JS_Sound_ReleaseInstance(i1 | 0) | 0;
 i1 = i4 + 52 | 0;
 i2 = i4 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) {
  i5 = i4 + 56 | 0;
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 8 >> 2] = i3;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i6;
  HEAP32[i5 >> 2] = i1;
  HEAP32[i2 >> 2] = i1;
 }
 i1 = i4 + 24 | 0;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 i6 = i4 + 28 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN4FMOD6Reverb15set3DAttributesEPK11FMOD_VECTORff(i4, i1, f2, f3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 857034;
 _printf(gb + 853184 | 0, i5) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD12ChannelGroup11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i5 = 0;
   STACKTOP = i4;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869672;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN15MBP_PairManager5purgeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 2 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 1 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN14SerializedFile4TypeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 40 | 0;
  if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 44 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
   i3 = i2 + 20 | 0;
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 24 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63720 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z38ParticleEmitter_Set_Custom_PropMinSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 116 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z38ParticleEmitter_Set_Custom_PropMaxSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 4 | 0;
 i4 = i6;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i6 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAPF32[i3 >> 2] = f2;
  HEAPF32[i4 >> 2] = Math_fround(0.0);
  i1 = f2 < Math_fround(0.0);
  HEAP32[i5 + 120 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
  STACKTOP = i6;
  return;
 }
}

function __Z33GetMinimumTextureMipSizeForFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 | 1;
 L1 : do if ((i2 | 0) == 31) i1 = 16; else {
  switch (i1 | 0) {
  case 32:
  case 33:
  case 60:
  case 61:
   {
    i1 = 8;
    break L1;
   }
  default:
   {}
  }
  switch (i1 | 0) {
  case 34:
  case 35:
  case 36:
  case 41:
  case 42:
  case 43:
  case 44:
  case 45:
  case 46:
  case 47:
   {
    i1 = 4;
    break L1;
   }
  default:
   {}
  }
  if ((i1 + -48 | 0) >>> 0 < 12) i1 = 1; else {
   switch (i1 | 0) {
   case 10:
   case 11:
   case 12:
   case 26:
   case 27:
    {
     i1 = 4;
     break L1;
    }
   default:
    {}
   }
   i1 = (i2 | 0) == 25 ? 4 : 1;
  }
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__211__libcpp_db9__addableEPKvi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i2) | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __THREW__ = 0;
   i1 = invoke_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i3 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
    ___resumeException(i3 | 0);
   }
  }
 }
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return i1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP8[i5 + 28 >> 0] = 0;
 i4 = (__ZN5physx2Sc8BodyCore13getSerialCoreERNS_11PxsBodyCoreE(i2 + 64 | 0, i5) | 0) - i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, i4 | 0);
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i5 | 0, 128);
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 + (i4 + 128) | 0, 160 - i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx20PxClothMeshQuadifier13getDescriptorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP16[i1 + 48 >> 1] = HEAP16[i2 + 48 >> 1] & -3;
 HEAP32[i1 + 32 >> 2] = ((HEAP32[i2 + 68 >> 2] | 0) >>> 0) / 3 | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i1 + 24 >> 2] = 12;
 HEAP32[i1 + 44 >> 2] = (HEAP32[i2 + 56 >> 2] | 0) >>> 2;
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 36 >> 2] = 16;
 return;
}

function __ZN5physx6shdfnd10Foundation15destroyInstanceEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1452348 >> 2] | 0;
 if ((HEAP32[gb + 1452352 >> 2] | 0) == 1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[gb + 1452348 >> 2] | 0);
  HEAP32[gb + 1452348 >> 2] = 0;
  HEAP32[gb + 1452352 >> 2] = 0;
  STACKTOP = i2;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 8, gb + 659867 | 0, 178, gb + 732295 | 0, i2);
  STACKTOP = i2;
  return;
 }
}

function __ZN5physx2Sc24ConstraintProjectionTree19getConstraintStatusERKNS0_13ConstraintSimEPKNS0_7BodySimERPS5_RjSA_(i5, i4, i6, i7, i8) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __ZNK5physx2Sc13ConstraintSim8isBrokenEv(i5) | 0;
 i2 = HEAPU16[HEAP32[i5 + 100 >> 2] >> 1] | 0;
 i3 = i5 + 108 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) {
  HEAP32[i7 >> 2] = i1 ? 0 : i2 & 2;
  HEAP32[i8 >> 2] = i1 ? 0 : i2 & 4;
  i8 = i5 + 112 | 0;
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  return;
 } else {
  HEAP32[i7 >> 2] = i1 ? 0 : i2 & 4;
  HEAP32[i8 >> 2] = i1 ? 0 : i2 & 2;
  i8 = i3;
  i8 = HEAP32[i8 >> 2] | 0;
  HEAP32[i6 >> 2] = i8;
  return;
 }
}

function __ZN5physx15PxGeometryQuery7raycastERKNS_6PxVec3ES3_RKNS_10PxGeometryERKNS_11PxTransformEfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEb(i9, i7, i2, i6, f4, i3, i5, i8, i1) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 f4 = Math_fround(f4);
 i3 = i3 | 0;
 i5 = i5 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 var i10 = 0, i11 = 0, i12 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10;
 i12 = HEAP32[gb + 85964 + (HEAP32[i2 >> 2] << 2) >> 2] | 0;
 HEAP16[i11 >> 1] = HEAP16[i3 >> 1] | 0;
 i9 = mftCall_iiiiifiiiiii(i12 | 0, i2 | 0, i6 | 0, i9 | 0, i7 | 0, +f4, i11 | 0, i5 | 0, i8 | 0, i1 | 0, 0, 0) | 0;
 STACKTOP = i10;
 return i9 | 0;
}

function __ZN5FlareC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 32876 + 8;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN23CloudWebServicesManager25RegisterPlayerLoopHandlerEP19CloudServiceHandler(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i1 + 44 | 0;
 i6 = HEAP32[i1 + 56 >> 2] | 0;
 HEAP32[i5 >> 2] = 85;
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i4;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = i5;
 i2 = i1 + 52 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZL33GeomMTDCallback_SphereHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 12 >> 2] = i2;
 i6 = __ZN5physx2Gu28computeMTD_SphereHeightFieldERNS_6PxVec3ERfRKNS0_6SphereERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __GLOBAL__sub_I_DirectorManager_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1188524 >> 2] = 0;
 i3 = gb + 63784 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1188524 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1188524 + 12 >> 2] = 16;
 i1 = gb + 1188524 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3665 | 0, fb + 3666 | 0, 0, gb + 1188524 | 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1188604 | 0, gb + 582666 | 0, 15, 0);
 HEAPF32[gb + 1188456 >> 2] = Math_fround(1.0);
 return;
}

function __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_(i5, i6, i7) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 if (!(HEAP32[i6 >> 2] | 0)) return;
 i8 = i6 + 8 | 0;
 i9 = i8;
 i10 = i7 + 8 | 0;
 i11 = i10;
 i4 = 0;
 do {
  i2 = HEAP32[(HEAP32[i8 >> 2] | 0) + i9 + (i4 << 2) >> 2] | 0;
  i3 = HEAP32[i7 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((i1 | 0) >= (i3 | 0)) {
    i1 = -1;
    break;
   }
   if ((HEAP32[(HEAP32[i10 >> 2] | 0) + i11 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break; else i1 = i1 + 1 | 0;
  }
  HEAP32[i5 + (i4 << 2) >> 2] = i1;
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < (HEAP32[i6 >> 2] | 0) >>> 0);
 return;
}

function __ZN7Terrain19SetMaterialTemplateERK4PPtrI8MaterialE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = i4 + 108 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i2 >> 2] = i3;
 i1 = HEAP32[i4 + 112 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 i4 = HEAP32[i4 + 96 >> 2] | 0;
 HEAP32[i5 >> 2] = (i4 | 0) == 3 ? i3 : 0;
 __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i1, i5, (i4 | 0) == 0 ? gb + 184364 | 0 : (i4 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 268 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 260 >> 2] | 0;
 i3 = i1 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd10Foundation7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1452348 >> 2] | 0;
 if ((HEAP32[gb + 1452352 >> 2] | 0) == 1) {
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[gb + 1452348 >> 2] | 0);
  HEAP32[gb + 1452348 >> 2] = 0;
  HEAP32[gb + 1452352 >> 2] = 0;
  STACKTOP = i2;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i1, 8, gb + 659867 | 0, 178, gb + 732295 | 0, i2);
  STACKTOP = i2;
  return;
 }
}

function __ZN4FMOD6System19getRecordDriverCapsEiPjPiS2_(i3, i1, i2, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (i6 | 0) HEAP32[i6 >> 2] = 44100;
  if (!i7) {
   i7 = 0;
   STACKTOP = i5;
   return i7 | 0;
  }
  HEAP32[i7 >> 2] = 48e3;
  i7 = 0;
  STACKTOP = i5;
  return i7 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870288;
 _printf(gb + 853184 | 0, i4) | 0;
 i7 = 36;
 STACKTOP = i5;
 return i7 | 0;
}

function __ZN33SizeBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 892 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 892 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 892 >> 2] | 0) + 616 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 892 >> 2] | 0) + 800 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 892 >> 2] | 0) + 804 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN19SkinnedMeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(536, i1, 16, gb + 1048932 | 0, 0, gb + 430210 | 0, 91) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN19SkinnedMeshRendererC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13UnityProfiler23RemovePerThreadProfilerEP22UnityProfilerPerThread(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i4) return;
 i2 = i1 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i1 = i1 + 260 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i4 + 68 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i2 = HEAP32[i4 + 60 >> 2] | 0;
 i4 = i4 + 56 | 0;
 i1 = i2;
 if ((i1 | 0) != (i4 | 0)) {
  i3 = 0;
  while (1) {
   HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 276 >> 2] = i3;
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   i1 = i2;
   if ((i1 | 0) == (i4 | 0)) break; else i3 = i3 + 1 | 0;
  }
 }
 return;
}

function __Z10DestripifyIjjEvPKT_iPT0_i(i8, i1, i9, i2) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + -2 | 0;
 i6 = 0;
 i1 = 0;
 L1 : while (1) {
  while (1) {
   if ((i1 | 0) >= (i7 | 0)) break L1;
   i4 = HEAP32[i8 + (i1 << 2) >> 2] | 0;
   i5 = i1 + 1 | 0;
   i2 = HEAP32[i8 + (i5 << 2) >> 2] | 0;
   i3 = HEAP32[i8 + (i1 + 2 << 2) >> 2] | 0;
   if ((i2 | 0) == (i3 | 0) | ((i4 | 0) == (i2 | 0) | (i4 | 0) == (i3 | 0))) i1 = i5; else break;
  }
  i1 = (i1 & 1 | 0) == 0;
  HEAP32[i9 + (i6 << 2) >> 2] = i1 ? i4 : i2;
  HEAP32[i9 + (i6 + 1 << 2) >> 2] = i1 ? i2 : i4;
  HEAP32[i9 + (i6 + 2 << 2) >> 2] = i3;
  i6 = i6 + 3 | 0;
  i1 = i5;
 }
 return;
}

function __GLOBAL__sub_I_runtime_virtualfilesystem_memoryfilesystem_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179068 | 0, gb + 492599 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179032 | 0, gb + 492628 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179020 | 0, gb + 492658 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179056 | 0, gb + 492687 | 0, 10, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1179044 | 0, gb + 492716 | 0, 10, 0);
 return;
}

function _UNITY_FT_Stream_Open(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i2) {
  i5 = 40;
  return i5 | 0;
 }
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i4 = i2 + 20 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i2 + 24 | 0;
 HEAP32[i5 >> 2] = 0;
 i1 = _fopen(i1, gb + 945625 | 0) | 0;
 if (!i1) {
  i5 = 1;
  return i5 | 0;
 }
 _fseek(i1, 0, 2) | 0;
 i6 = _ftell(i1) | 0;
 HEAP32[i2 + 4 >> 2] = i6;
 if (!i6) {
  _fclose(i1) | 0;
  i6 = 81;
  return i6 | 0;
 } else {
  _fseek(i1, 0, 0) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i4 >> 2] = fb + 175;
  HEAP32[i5 >> 2] = fb + 3834;
  i6 = 0;
  return i6 | 0;
 }
 return 0;
}

function _wcsncasecmp(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 if (!i4) i1 = 0; else {
  i1 = HEAP32[i3 >> 2] | 0;
  L3 : do if (!i1) i1 = 0; else {
   i5 = i4;
   while (1) {
    i5 = i5 + -1 | 0;
    i4 = HEAP32[i2 >> 2] | 0;
    if (!((i5 | 0) != 0 & (i4 | 0) != 0)) break L3;
    if ((i1 | 0) != (i4 | 0)) {
     i4 = _towlower(i1) | 0;
     if ((i4 | 0) != (_towlower(HEAP32[i2 >> 2] | 0) | 0)) break;
    }
    i3 = i3 + 4 | 0;
    i2 = i2 + 4 | 0;
    i1 = HEAP32[i3 >> 2] | 0;
    if (!i1) {
     i1 = 0;
     break L3;
    }
   }
   i1 = HEAP32[i3 >> 2] | 0;
  } while (0);
  i1 = _towlower(i1) | 0;
  i1 = i1 - (_towlower(HEAP32[i2 >> 2] | 0) | 0) | 0;
 }
 return i1 | 0;
}

function __ZNK8Material16MarkDependenciesER27GarbageCollectorThreadState(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 32 >> 2] | 0, i3);
 i4 = i1 + 48 | 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 i2 = i1;
 while (1) {
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i2 + 36 >> 2] | 0, i3);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN9AudioClip21AwakeFromLoadThreadedEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (i1 | 0) if (HEAP8[i1 + 224 >> 0] | 0) return;
 if (!(HEAP8[i4 + 64 >> 0] | 0)) return;
 if ((HEAP32[i4 + 52 >> 2] | 0) == 2) return;
 i1 = i4 + 72 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i4 + 76 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) return;
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 i3 = HEAP32[i4 + 88 >> 2] | 0;
 __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i4 + 128 | 0, i1, __ZNK10SampleClip17CalculateFMODModeEv(i4) | 0, i4, i2, i3, 0) | 0;
 return;
}

function __ZN4gles15UpdateDepthTestER15DeviceStateGLESPK20DeviceDepthStateGLESb(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 2 | 0;
 i5 = i6;
 i1 = (i1 | 0) == 0 ? HEAP32[i3 + 460 >> 2] | 0 : i1;
 if ((HEAP8[i1 >> 0] & 1 | 0) == (i4 & 1 | 0)) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 i1 = HEAP8[i1 + 1 >> 0] | 0;
 HEAP8[i5 >> 0] = i4 & 1;
 HEAP8[i5 + 1 >> 0] = i1;
 HEAP8[i2 >> 0] = HEAP8[i5 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
 i5 = __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i3, i2) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN11HaloManager10UpdateHaloEi8Vector3f11ColorRGBA32fjP6Object(i2, i3, i4, i5, f6, i7, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i8 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 while (1) {
  if ((HEAP32[i1 + 32 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 40 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i8 = 5;
   break;
  }
 }
 if ((i8 | 0) == 5) return;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i5 >> 2];
 HEAPF32[i1 + 28 >> 2] = f6;
 HEAP32[i1 + 36 >> 2] = i7;
 return;
}

function _h2v1_upsample(i3, i1, i9, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i2 >> 2] | 0;
 i8 = i3 + 276 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 i6 = i3 + 92 | 0;
 i5 = 0;
 do {
  i3 = HEAP32[i7 + (i5 << 2) >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i4 = i3 + i2 | 0;
  if ((i2 | 0) > 0) {
   i2 = HEAP32[i9 + (i5 << 2) >> 2] | 0;
   i1 = i3;
   while (1) {
    i3 = HEAP8[i2 >> 0] | 0;
    HEAP8[i1 >> 0] = i3;
    HEAP8[i1 + 1 >> 0] = i3;
    i1 = i1 + 2 | 0;
    if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 1 | 0;
   }
   i1 = HEAP32[i8 >> 2] | 0;
  }
  i5 = i5 + 1 | 0;
 } while ((i5 | 0) < (i1 | 0));
 return;
}

function _exp10f(f1) {
 f1 = Math_fround(f1);
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 f2 = Math_fround(_modff(f1, i5));
 f3 = Math_fround(HEAPF32[i5 >> 2]);
 do if (Math_fround(Math_abs(Math_fround(f3))) < Math_fround(8.0)) if (f2 != Math_fround(0.0)) {
  f1 = Math_fround(_exp2f(Math_fround(f2 * Math_fround(3.32192802))));
  f1 = Math_fround(f1 * Math_fround(HEAPF32[gb + 207008 + (~~f3 + 7 << 2) >> 2]));
  break;
 } else {
  f1 = Math_fround(HEAPF32[gb + 207008 + (~~f3 + 7 << 2) >> 2]);
  break;
 } else f1 = Math_fround(+_exp2(+f1 * 3.321928094887362)); while (0);
 STACKTOP = i4;
 return Math_fround(f1);
}

function _atol(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 while (1) {
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24;
  i5 = i1 + 1 | 0;
  if (!(_isspace(i2) | 0)) break; else i1 = i5;
 }
 switch (i2 | 0) {
 case 45:
  {
   i1 = 1;
   i6 = 5;
   break;
  }
 case 43:
  {
   i1 = 0;
   i6 = 5;
   break;
  }
 default:
  {
   i7 = 0;
   i3 = i1;
   i1 = i4;
  }
 }
 if ((i6 | 0) == 5) {
  i7 = i1;
  i3 = i5;
  i1 = HEAP8[i5 >> 0] | 0;
 }
 i2 = (i1 << 24 >> 24) + -48 | 0;
 if (i2 >>> 0 < 10) {
  i1 = 0;
  do {
   i3 = i3 + 1 | 0;
   i1 = (i1 * 10 | 0) - i2 | 0;
   i2 = (HEAP8[i3 >> 0] | 0) + -48 | 0;
  } while (i2 >>> 0 < 10);
 } else i1 = 0;
 return (i7 | 0 ? i1 : 0 - i1 | 0) | 0;
}

function _atoi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 while (1) {
  i4 = HEAP8[i1 >> 0] | 0;
  i2 = i4 << 24 >> 24;
  i5 = i1 + 1 | 0;
  if (!(_isspace(i2) | 0)) break; else i1 = i5;
 }
 switch (i2 | 0) {
 case 45:
  {
   i1 = 1;
   i6 = 5;
   break;
  }
 case 43:
  {
   i1 = 0;
   i6 = 5;
   break;
  }
 default:
  {
   i7 = 0;
   i3 = i1;
   i1 = i4;
  }
 }
 if ((i6 | 0) == 5) {
  i7 = i1;
  i3 = i5;
  i1 = HEAP8[i5 >> 0] | 0;
 }
 i2 = (i1 << 24 >> 24) + -48 | 0;
 if (i2 >>> 0 < 10) {
  i1 = 0;
  do {
   i3 = i3 + 1 | 0;
   i1 = (i1 * 10 | 0) - i2 | 0;
   i2 = (HEAP8[i3 >> 0] | 0) + -48 | 0;
  } while (i2 >>> 0 < 10);
 } else i1 = 0;
 return (i7 | 0 ? i1 : 0 - i1 | 0) | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__213__vector_baseINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEENS5_IS9_Lj4096EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i4 = i4 + -16 | 0;
   HEAP32[i3 >> 2] = i4;
   __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev(i4);
  }
  i4 = HEAP32[i1 >> 2] | 0;
  __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[i1 + 12 >> 2] | 0, i4, (HEAP32[i1 + 8 >> 2] | 0) - i4 | 0);
 }
 return;
}

function __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0;
 i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0) & 1 ^ 1;
 i4 = (i2 | 0) != 0;
 if (i4) __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, i2);
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (HEAP8[i3 + 40 >> 0] | 0) HEAP32[i1 >> 2] = i2;
 if (!i4) return;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 return;
}

function __ZN5physx27PxVehicleDifferentialNWData14setDrivenWheelEjb(i7, i2, i6) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i8 = 0, f9 = f0;
 i8 = i7 + 4 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i4 = i7 + (i2 >>> 5 << 2) | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = 1 << (i2 & 31);
 i3 = (i5 & i2 | 0) != 0;
 if (i6) {
  if (!i3) {
   i1 = i1 + 1 | 0;
   HEAP32[i4 >> 2] = i5 | i2;
   HEAPF32[i7 + 8 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i1 >>> 0));
  }
 } else if (i3) {
  i1 = i1 + -1 | 0;
  HEAP32[i4 >> 2] = i5 & ~i2;
  f9 = Math_fround(Math_fround(1.0) / Math_fround(i1 >>> 0));
  HEAPF32[i7 + 8 >> 2] = (i1 | 0) == 0 ? Math_fround(0.0) : f9;
 }
 HEAP32[i8 >> 2] = i1;
 return;
}

function __ZN5physx14PxsAABBManager21setBPElemVolumeBoundsEjRKNS_11IntegerAABBE(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i4 + 12 >> 2] | 0) + (i2 * 24 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 i1 = i2 >>> 5;
 i3 = 1 << (i2 & 31);
 if (HEAP32[(HEAP32[i4 + 96 >> 2] | 0) + (i1 << 2) >> 2] & i3 | 0) return;
 i1 = (HEAP32[i4 + 68 >> 2] | 0) + (i1 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 & i3 | 0) return;
 HEAP32[i1 >> 2] = i2 | i3;
 return;
}

function __ZN4FMOD5Sound8readDataEPvjPj(i2, i5, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   _memset(i5 | 0, 0, i6 | 0) | 0;
   i6 = 0;
   STACKTOP = i4;
   return i6 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870121;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN18CrashReportManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(32, i1, 16, gb + 1048932 | 0, 0, gb + 1039792 | 0, 22) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN18CrashReportManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN15MBP_PairManagerD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 2 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 1 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i2 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z44DownloadHandlerBuffer_CUSTOM_InternalGetTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027732 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027732 | 0, i2); else {
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  i1 = (i4 | 0) == 0;
  i2 = __Z20scripting_string_newPKcj(i1 ? gb + 1576256 | 0 : i4, i1 ? 0 : i2) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z38Graphics_CUSTOM_DrawProceduralIndirect16GfxPrimitiveTypeP12Il2CppObjecti(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i5 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
   __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj(i3, i2, i4);
   STACKTOP = i6;
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 517864 | 0, 0, gb + 517579 | 0, 3849, 1, 0, 0, 0);
 STACKTOP = i6;
 return;
}

function __Z28collideCellWithMeshTrianglesPN5physx19PxsParticleCollDataEPKjjRKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE(i3, i1, i4, i2, i7, i9, i5, f6, i8) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i8 = i8 | 0;
 if (!i4) return; else i2 = 0;
 while (1) {
  __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE(i3 + ((HEAP32[i1 >> 2] | 0) * 176 | 0) | 0, 0, i7, i9, i5, f6, i8);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZNK9AudioClip14GetSampleCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  i2 = HEAP32[i1 + 124 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP32[i2 + 44 >> 2] | 0) {
    f3 = Math_fround(Math_fround(HEAP32[i1 + 32 >> 2] | 0) * Math_fround(0.0));
    i2 = ~~Math_fround(f3 * Math_fround(HEAP32[i1 + 36 >> 2] | 0)) >>> 0;
    return i2 | 0;
   }
   i1 = HEAP32[i1 + 56 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   i2 = __ZNK14SoundHandleAPI12GetLengthPCMEv(i1) | 0;
   return i2 | 0;
  }
 }
 f3 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 i2 = ~~Math_fround(f3 * Math_fround(HEAP32[i1 + 32 >> 2] | 0)) >>> 0;
 return i2 | 0;
}

function __ZNK8Material14GetOverrideTagEi(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = HEAP32[i1 + 100 >> 2] | 0;
 i2 = HEAP32[i6 + 176 >> 2] | 0;
 i6 = HEAP32[i6 + 180 >> 2] | 0;
 i1 = i6 - i2 >> 3;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 3) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) < (i7 | 0);
   i4 = i4 + 8 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) > (i7 | 0)) {
  i8 = -1;
  return i8 | 0;
 }
 i8 = HEAP32[i1 + 4 >> 2] | 0;
 return i8 | 0;
}

function __ZNK22GenericPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i4, i1, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i4 + 260 >> 2] | 0;
 if (!i3) {
  i7 = -1;
  return i7 | 0;
 } else i1 = 0;
 while (1) {
  if ((HEAP32[i4 + 4 + (i1 << 2) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return i1 | 0;
 if (!((i1 | 0) != -1 & (HEAP8[i5 + 15 >> 0] | 0) == 0)) {
  i7 = -1;
  return i7 | 0;
 }
 HEAP32[i6 >> 2] = i1;
 i7 = HEAP32[i4 + 196 + (i1 << 2) >> 2] | 0;
 return i7 | 0;
}

function __ZNK14Texture2DArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i4, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  STACKTOP = i3;
  return i6 | 0;
 }
 i8 = HEAP32[i4 + 80 >> 2] | 0;
 i7 = HEAP32[i4 + 92 >> 2] | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i1, i8, HEAP32[i4 + 84 >> 2] | 0, Math_imul(HEAP32[gb + 45784 + (i7 << 2) >> 2] | 0, i8) | 0, i7, i2);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i1, i6);
 i6 = 1;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZNK12NavMeshAgent17GetSteeringTargetEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
  STACKTOP = i4;
  return;
 } else {
  __ZNK7dtCrowd14getSteerTargetERK13dtCrowdHandlePf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0, i3);
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  STACKTOP = i4;
  return;
 }
}

function __ZN8Animator18PrepareForPlaybackEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP32[i6 + 108 >> 2] | 0)) return;
 i3 = i6 + 624 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 i4 = i6 + 136 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5) {
  i2 = i6 + 148 | 0;
  if (!(HEAP32[i2 >> 2] | 0)) {
   i1 = i6 + 112 | 0;
   HEAP32[i4 >> 2] = __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i5, i1, i2) | 0;
   __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(i5, i1);
   i1 = HEAP32[i3 >> 2] | 0;
  }
 }
 __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE(i1, i6 + 112 | 0);
 return;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround((i3 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround((i3 >>> 16 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 8 >> 2] = Math_fround(Math_fround(i3 >>> 24 >>> 0) * Math_fround(.00392156886));
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx7NpScene22removeArticulationLinkERNS_18NpArticulationLinkEb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 228 >> 2] | 0, i3 | 0) | 0;
 __ZN5physx7NpActor26removeConstraintsFromSceneEv(i3 + 12 | 0);
 __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE(i3 + 20 | 0, i1 + 3392 | 0);
 i1 = i1 + 16 | 0;
 if (!i2) {
  i3 = i3 + 48 | 0;
  __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i1, i3, i4, 0);
  return;
 }
 __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE(i1, i2 + 8 | 0);
 i3 = i3 + 48 | 0;
 __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb(i1, i3, i4, 0);
 return;
}

function __ZN5physx14PxsAABBManager21selfCollideAggregatesEPKNS_19AggregateSortedDataE(i9, i7) {
 i9 = i9 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i1 = HEAP32[i9 + 372 >> 2] | 0;
 i2 = HEAP32[i9 + 368 >> 2] | 0;
 if (!i1) return;
 i3 = i9 + 180 | 0;
 i8 = 0;
 do {
  i4 = HEAP32[i2 + (i8 << 2) >> 2] | 0;
  i5 = HEAP32[i3 >> 2] | 0;
  i6 = i5 + (i4 * 1048 | 0) | 0;
  if (HEAP8[i5 + (i4 * 1048 | 0) + 1024 >> 0] | 0) if (HEAP8[i5 + (i4 * 1048 | 0) + 1026 >> 0] | 0) __ZN5physx14PxsAABBManager20selfCollideAggregateERKNS_19AggregateSortedDataERKNS_9AggregateEPNS_17SelfCollideBitmapE(i9, i7 + (i4 << 3) | 0, i6, i6);
  i8 = i8 + 1 | 0;
 } while ((i8 | 0) != (i1 | 0));
 return;
}

function __ZN18JobBatchDispatcherC2E11JobPriorityi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(20, gb + 64016 | 0, 16, gb + 441715 | 0, 99) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i7, gb + 63664 | 0);
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i2 + 24 >> 2] = i4;
 HEAP32[i2 + 16 >> 2] = i3;
 STACKTOP = i1;
 return;
}

function __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i5 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i4 + -4 >> 2] | i1;
 HEAP32[i2 >> 2] = i1;
 if ((i4 | 0) == (HEAP32[i5 + 28 >> 2] | 0)) {
  __ZNSt3__26vectorI17TransferMetaFlags13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_(i5 + 20 | 0, i2);
  i1 = HEAP32[i3 >> 2] | 0;
 } else {
  HEAP32[i4 >> 2] = i1;
  i1 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i5 + 36 >> 2] = HEAP32[i1 + -4 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN17AnimationPlayable13AddObjectUserER8UserList(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i6 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i7 = 8;
    break;
   } else i3 = 0;
  }
  if ((i7 | 0) == 8) {
   i7 = 0;
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i5 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return;
}

function __ZN13MonoBehaviour15CreateCoroutineEP12Il2CppObject21ScriptingMethodIl2Cpp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4 + 8 | 0;
 i7 = i4;
 HEAP32[i5 >> 2] = 0;
 i9 = i3;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i3 + 4 >> 2] = i8;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine(i1, i2, i6, i5) | 0;
 STACKTOP = i4;
 return HEAP32[i5 >> 2] | 0;
}

function __ZN11UnityEngine9Analytics9PerfEventC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1037579 | 0, 0);
 HEAP32[i1 >> 2] = gb + 188436 + 8;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = i1 + 48 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN11AudioSource16AnyChannelPausedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) if (HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0) + 236 >> 0] | 0) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = HEAP32[i3 + 432 >> 2] | 0;
 i3 = i3 + 428 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if (HEAP8[(HEAP32[(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 12 >> 2] | 0) + 16 >> 2] | 0) + 236 >> 0] | 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN11AudioFilter4InitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 i2 = i1 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) return;
 i3 = i1 + 36 | 0;
 if ((HEAP32[i3 >> 2] | 0) == 65536) return;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1459888 >> 2] | 0, 0, 0) | 0;
 i5 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 __ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i5, HEAP32[i3 >> 2] | 0, i2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN4FMOD3DSP9setBypassEb(i3, (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0) ^ 1) | 0;
 if (!i4) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10OnGUIState15SetMouseTooltipERK11UTF16String(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 i2 = __Znwj(20) | 0;
 i9 = gb + 63672 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i2, i3, i5);
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function __ZN10MeshFilter20WillDestroyComponentEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  i2 = i1 + 376 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   HEAP32[i2 >> 2] = 0;
   __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
  }
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i3, gb + 1106136 | 0, i4);
 STACKTOP = i5;
 return;
}

function __Z4dot3RK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, f8 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i5 = i4;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(f7 + Math_fround(f8 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f7 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 HEAPF32[i6 >> 2] = Math_fround(f8 + Math_fround(f7 * Math_fround(HEAPF32[i3 + 8 >> 2])));
 HEAP32[i5 >> 2] = __Z6simd4fRKf(i6) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i1, i5);
 STACKTOP = i4;
 return;
}

function __Z31SparseTexture_CUSTOM_UpdateTileP12Il2CppObjectiiiP11Il2CppArray(i1, i4, i5, i6, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i7 = 0;
 if (!i1) {
  i7 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 }
 i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i7) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
  i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0;
 }
 __ZN13SparseTexture17UploadTileColor32EiiiPK11ColorRGBA32j(i7, i4, i5, i6, i2, i1);
 return;
}

function __Z25Animator_CUSTOM_SetBoolIDP12Il2CppObjectih(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i2 = __ZN8Animator7SetBoolEib(i2, i4, i1 << 24 >> 24 != 0) | 0;
 if ((i2 | 0) == 1) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i1, i2, i4);
 return;
}

function _process_data_simple_main_30(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i3 + 388 >> 2] | 0;
 i7 = i2 + 48 | 0;
 do if (!(HEAP8[i7 >> 0] | 0)) {
  i1 = i2 + 8 | 0;
  if (!(mftCall_iii(HEAP32[(HEAP32[i3 + 392 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0) | 0)) return; else {
   HEAP8[i7 >> 0] = 1;
   break;
  }
 } else i1 = i2 + 8 | 0; while (0);
 i8 = HEAP32[i3 + 280 >> 2] | 0;
 i2 = i2 + 52 | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i3 + 396 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i8 | 0, i4 | 0, i5 | 0, i6 | 0);
 if ((HEAP32[i2 >> 2] | 0) >>> 0 < i8 >>> 0) return;
 HEAP8[i7 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZNSt3__28ios_base7failureC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_10error_codeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i3;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZNSt3__212system_errorC2ENS_10error_codeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i5, i2);
 HEAP32[i1 >> 2] = gb + 209152 + 8;
 STACKTOP = i4;
 return;
}

function __ZN5physx20InternalTriangleMeshC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN5physx2Gu13RTreeMidphaseC2Ev(i1 + 16 | 0);
 i2 = i1 + 160 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 176 >> 2] = Math_fround(.00100000005);
 __ZN5physx2Gu13MeshInterfaceC2Ev(i1 + 180 | 0);
 HEAP32[i1 + 200 >> 2] = 1;
 i2 = i1 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i2 + 28 >> 0] = 0;
 return;
}

function __ZN4FMOD7Channel11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i5 = 0;
   STACKTOP = i4;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869672;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN25MinMaxOptimizedPolyCurves26FindMinMaxDoubleIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv(i7, i2 + 40 | 0);
 __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv(i6, i2);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(_fminf(f5, Math_fround(HEAPF32[i6 >> 2])));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(_fmaxf(f4, Math_fround(HEAPF32[i6 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN19RuntimeSceneManager28RemoveWaitingForLoadingSceneEP10UnityScene(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i1 + 24 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + 36 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i1 << 2) | 0;
 L1 : do if (!i1) i1 = i2; else {
  i1 = i2;
  do {
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != (i4 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0);
 i5 = i1 + 4 | 0;
 _memmove(i1 | 0, i5 | 0, (HEAP32[i6 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) - i5 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 return;
}

function __ZN19CharacterController19SetDetectCollisionsEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP8[i1 + 108 >> 0] = i3 & 1;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i4 | 0, i2 | 0);
 i2 = i4 + 8 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 ? i6 & -17 : i6 | 16;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0, i3 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN13RuntimeStaticI15AnimationBinderE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 >> 2] = i3;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12MeshColliderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 112784 + 8;
 i1 = i4 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i4 + 100 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 i1 = HEAP32[i4 + 44 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = gb + 29060 + 8;
  HEAP32[i4 >> 2] = gb + 26392 + 8;
  return;
 }
 i2 = i4 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 HEAP32[i4 >> 2] = gb + 29060 + 8;
 HEAP32[i4 >> 2] = gb + 26392 + 8;
 return;
}

function __Z44Rigidbody2D_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11Rigidbody2D15GetCenterOfMassEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z27Material_CUSTOM_HasPropertyP12Il2CppObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 if (!i2) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i5) {
  i6 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 } else {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  i5 = (__ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i5, i1) | 0) & 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function _unity_z_inflateReset(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = -2;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  i2 = -2;
  return i2 | 0;
 }
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 32768;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 i1 = i2 + 1328 | 0;
 HEAP32[i2 + 108 >> 2] = i1;
 HEAP32[i2 + 80 >> 2] = i1;
 HEAP32[i2 + 76 >> 2] = i1;
 i2 = 0;
 return i2 | 0;
}

function _fopen(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i2 = i5;
 if (!(_memchr(gb + 1074696 | 0, HEAP8[i3 >> 0] | 0, 4) | 0)) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 } else {
  i6 = ___fmodeflags(i3) | 0 | 32768;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = 438;
  i2 = ___syscall_ret(___syscall5(5, i2 | 0) | 0) | 0;
  if ((i2 | 0) < 0) i1 = 0; else {
   i1 = ___fdopen(i2, i3) | 0;
   if (!i1) {
    HEAP32[i4 >> 2] = i2;
    ___syscall6(6, i4 | 0) | 0;
    i1 = 0;
   }
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (!(__Z9SetLocalR15TransformAccessRKN4math7_float4E(i5, i3) | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = (HEAP32[i1 + 28 >> 2] | 0) + i2 | 0;
 HEAP8[i7 >> 0] = HEAPU8[i7 >> 0] | 0 | 2;
 STACKTOP = i4;
 return;
}

function __ZN7ApiGLES21CreateGraphicsProgramEjjjjj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = mftCall_i(HEAP32[i1 + 504 >> 2] | 0) | 0;
 if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 118 >> 0] | 0) mftCall_viii(HEAP32[i1 + 232 >> 2] | 0, i7 | 0, 33367, 1);
 if (i2 | 0) mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i7 | 0, i2 | 0);
 if (i3 | 0) mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i7 | 0, i3 | 0);
 if (i4 | 0) mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i7 | 0, i4 | 0);
 if (i5 | 0) mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i7 | 0, i5 | 0);
 if (!i6) return i7 | 0;
 mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i7 | 0, i6 | 0);
 return i7 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 32 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i1 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx20PxsParticleSystemSim14dynamicsUpdateEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 if (!(HEAP32[i2 + 40 >> 2] | 0)) return;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(.100000001));
 f4 = Math_fround(f4 * f4);
 f4 = Math_fround(f4 * Math_fround(f4 * f4));
 f5 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i2 + 120 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 84 >> 2]) * Math_fround(f5 * Math_fround(Math_fround(45.0) / Math_fround(f4 * Math_fround(3.14159274)))));
 if (!(HEAP32[i3 + 20 >> 2] & 65536)) return;
 __ZN5physx16PxsFluidDynamics9updateSphERNS_10PxBaseTaskE(i2 + 80 | 0, i1);
 return;
}

function __ZN21AssetBundleFileSystem13RemoveArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i4 + 92 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) return;
 __ZN17ArchiveFileSystem14UnmountArchiveEPKc(i2, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
 i2 = i4 + 108 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 if ((HEAP32[i4 + 72 >> 2] | 0) != (HEAP32[i4 + 8 >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) | 0) return;
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i4) | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 368671 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) <= 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN15TerrainCollider20CleanupTreeCollidersEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 80 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + 92 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 if (i2 | 0) do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = i4 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i5 >> 2] | 0, i4 + 84 | 0);
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15SharedLightData15UpdateTransformERK9Transform(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv(i3, i2);
 i4 = i1 + 216 | 0;
 i6 = i3;
 i7 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i4 = i4 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i4 | 0) < (i7 | 0));
 __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv(i3, i2);
 i4 = i1 + 280 | 0;
 i6 = i3;
 i7 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  i4 = i4 + 4 | 0;
  i6 = i6 + 4 | 0;
 } while ((i4 | 0) < (i7 | 0));
 STACKTOP = i5;
 return;
}

function __ZN10OnGUIState13SetKeyTooltipERK11UTF16String(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 i2 = __Znwj(20) | 0;
 i9 = gb + 63672 | 0;
 i8 = HEAP32[i9 + 4 >> 2] | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i7 + 4 >> 2] = i8;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN11UTF16StringC2ERKS_10MemLabelId(i2, i3, i5);
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i6;
 return;
}

function __Z34UpdateTextureImageDataOnMainThreadP9Texture2D(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZN6Object27AllocateAndAssignInstanceIDEPS_(i3) | 0;
 i1 = HEAP32[i3 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) {
  mftCall_vi(HEAP32[i2 + 196 >> 2] | 0, i3 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 12 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(i2 | 0, i3 | 0, 2);
  return;
 } else {
  mftCall_vi(HEAP32[i2 + 192 >> 2] | 0, i3 | 0);
  i2 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 12 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(i2 | 0, i3 | 0, 2);
  return;
 }
}

function __Z27Component_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i1 = __Z18ExtractTagThrowingR11ICallString(i2) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  STACKTOP = i4;
  return (i1 | 0) == (HEAPU16[(HEAP32[i2 + 28 >> 2] | 0) + 52 >> 1] | 0 | 0) | 0;
 }
 return 0;
}

function __Z19LoadAndLookupSymbolRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 4 | 0;
 if (!(__Z18LoadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0)) {
  STACKTOP = i2;
  return 0;
 }
 __Z6FormatPKcz(i1, gb + 455597 | 0, i2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0, gb + 455527 | 0, 203, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 STACKTOP = i2;
 return 0;
}

function __ZN9Texture3D15ThreadedCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN6Shader13AwakeFromLoadE17AwakeFromLoadMode(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = __Z20push_allocation_rootPvP13BaseAllocatorb(i5, 0, 0) | 0;
 i2 = i5 + 32 | 0;
 if (!(HEAP8[i5 + 93 >> 0] | 0)) {
  if (!(HEAP32[i2 >> 2] | 0)) i3 = 3;
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  __ZN6Shader20CreateFromParsedFormEv(i5);
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   HEAP32[i5 + 40 >> 2] = 0;
   i1 = 0;
  } else {
   __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i1, i5);
   i1 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i2 >> 2] | 0, i5 + 40 | 0) | 0;
  }
  HEAP32[i5 + 36 >> 2] = i1;
 }
 if (!i4) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5physx6shdfnd10checkValidERKNS_11PxTransformE(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 16 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 20 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 24 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 12 >> 2] & 2139095040) >>> 0 < 2139095040;
 return i1 | 0;
}

function __ZN5physx28PxRigidDynamicRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 i2 = mftCall_iii(i4 | 0, i2 | 0, i3 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN2UI6Canvas21UpdateCanvasInvMatrixEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 i1 = i5;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i4 = i5 + 112 | 0;
 i1 = i3;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i5 = i5 + 224 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 6;
 STACKTOP = i6;
 return;
}

function __ZN24GenerateTypeTreeTransfer20AssertContainsNoPPtrERK16TypeTreeIterator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 __ZNK16TypeTreeIterator8ChildrenEv(i3, i2);
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 do {
  __ZN24GenerateTypeTreeTransfer20AssertContainsNoPPtrERK16TypeTreeIterator(i1, i3);
  __ZNK16TypeTreeIterator4NextEv(i4, i3);
  i7 = i4;
  i2 = HEAP32[i7 >> 2] | 0;
  i7 = HEAP32[i7 + 4 >> 2] | 0;
  i6 = i3;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i7;
 } while ((i2 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZN24DownloadHandlerAudioClip22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN19UnityConnectServiceD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 189112 + 8;
 __ZN19UnityConnectService25UnregisterGlobalCallbacksEv(i3);
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN3WWW7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i3);
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i3 + 60 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 __ZdlPv(i3);
 STACKTOP = i5;
 return;
}

function __ZN17ShaderPassContext8CopyFromERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 i3 = i1 + 4 | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 __ZN19ShaderPropertySheet8CopyFromERKS_(i1 + 36 | 0, i2 + 36 | 0);
 i2 = HEAP16[i2 + 148 >> 1] | 0;
 HEAP8[i1 + 148 >> 0] = i2;
 HEAP8[i1 + 149 >> 0] = (i2 & 65535) >>> 8;
 return;
}

function __ZN16LightmapSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(240, i1, 16, gb + 1048932 | 0, 0, gb + 518148 | 0, 26) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LightmapSettingsC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER14SafeBinaryRead(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i3, 0, 0) | 0;
 i2 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, HEAP32[gb + 67408 >> 2] | 0, gb + 368654 | 0, i1, 1) | 0;
 if (i2 | 0) {
  if ((i2 | 0) <= 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 __Z19pop_allocation_rootv();
 STACKTOP = i6;
 return;
}

function __ZN13GfxDeviceGLES19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i10 = i1;
 i8 = __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i6, i8) | 0;
 HEAP32[i10 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 __Z23CreateSparseTextureGLES9TextureIDiiN2gl9TexFormatEi(i2, i9, i4, i5, i8, i7);
 STACKTOP = i1;
 return;
}

function __ZN11AudioSource13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (HEAP8[i1 + 33 >> 0] | 0) {
  __ZN11AudioSource11AssignPropsEv(i1);
  if (i2 & 13 | 0) {
   i5 = i1 + 504 | 0;
   __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  }
 }
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 STACKTOP = i4;
 return;
}

function __Z70RectTransformUtility_CUSTOM_INTERNAL_CALL_RectangleContainsScreenPointP12Il2CppObjectRK13Vector2fIcallS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 i4 = (__ZN2UI16PointInRectangleERK8Vector2fPNS_13RectTransformEP6Camera(i4, i2, i1) | 0) & 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList(i4, i5, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i8 = 0, i9 = 0;
 i9 = i7 + 4 | 0;
 i8 = HEAP32[i9 >> 2] | 0;
 if ((i8 | 0) <= 0) {
  i8 = 0;
  HEAP32[i9 >> 2] = i8;
  return;
 }
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[(HEAP32[i7 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if (__Z13IsNodeVisibleRK9SceneNodeRK4AABBRK22SceneCullingParameters(i5 + (i2 * 24 | 0) | 0, i6 + (i2 * 24 | 0) | 0, i4) | 0) {
   HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] = i2;
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i8 | 0));
 HEAP32[i9 >> 2] = i1;
 return;
}

function __Z29Shader_CUSTOM_SetGlobalBufferiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i8 + 8 | 0;
 i4 = i8 + 4 | 0;
 i5 = i8;
 i6 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i4 >> 2] = i1;
 if (!i2) i7 = 4; else {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!i1) i7 = 4; else HEAP32[i5 >> 2] = HEAP32[i1 + 12 >> 2];
 }
 if ((i7 | 0) == 4) HEAP32[i5 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE(i6, i4, i3, 0);
 STACKTOP = i8;
 return;
}

function _UNITY_FT_Outline_Render(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 L1 : do if (!i3) i1 = 33; else if (!i1) i1 = 20; else if (!i4) i1 = 6; else {
  i2 = HEAP32[i3 + 156 >> 2] | 0;
  HEAP32[i5 >> 2] = HEAP32[i3 + 148 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  if (!i2) i1 = 19; else do {
   i1 = mftCall_iii(HEAP32[i2 + 56 >> 2] | 0, HEAP32[i2 + 52 >> 2] | 0, i4 | 0) | 0;
   if (!((i1 | 0) != 0 & (i1 & 255 | 0) == 19)) break L1;
   i2 = _UNITY_FT_Lookup_Renderer(i3, 1869968492, i5) | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN9Texture3D14DestroyTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 96 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 >> 2] | 0, gb + 63272 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN9Rigidbody11SetVelocityERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (i1 & 2 | 0) HEAPF32[i3 >> 2] = Math_fround(0.0);
 if (i1 & 4 | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
 if (i1 & 8 | 0) HEAPF32[i5 >> 2] = Math_fround(0.0);
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i5 >> 2] | 0) + 156 >> 2] | 0, i5 | 0, i3 | 0, 1);
 STACKTOP = i6;
 return;
}

function __ZN9GfxDevice19CopyContextDataFromEPKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 _memcpy(i1 + 3420 | 0, i2 + 3420 | 0, 196) | 0;
 _memcpy(i1 + 4 | 0, i2 + 4 | 0, 3416) | 0;
 HEAP8[i1 + 4192 >> 0] = HEAP8[i2 + 4192 >> 0] | 0;
 HEAP32[i1 + 4196 >> 2] = HEAP32[i2 + 4196 >> 2];
 HEAP32[i1 + 4204 >> 2] = HEAP32[i2 + 4204 >> 2];
 HEAP32[i1 + 4208 >> 2] = HEAP32[i2 + 4208 >> 2];
 HEAP32[i1 + 4212 >> 2] = HEAP32[i2 + 4212 >> 2];
 i3 = HEAP16[i2 + 4380 >> 1] | 0;
 HEAP8[i1 + 4380 >> 0] = i3;
 HEAP8[i1 + 4381 >> 0] = (i3 & 65535) >>> 8;
 HEAP32[i1 + 4384 >> 2] = HEAP32[i2 + 4384 >> 2];
 HEAP32[i1 + 4368 >> 2] = HEAP32[i2 + 4368 >> 2];
 HEAP32[i1 + 4372 >> 2] = HEAP32[i2 + 4372 >> 2];
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERPKc(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i1 = i1 | 0 ? i1 : gb + 1576256 | 0;
 if (HEAP8[i1 >> 0] | 0) HEAP32[i2 >> 2] = (_strlen(i1) | 0) + 1;
 i3 = i3 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i6) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7 + 2 | 0;
 i4 = i7;
 i1 = HEAP16[i6 >> 1] | 0;
 i5 = HEAP16[i2 >> 1] | 0;
 if (i1 << 16 >> 16 == i5 << 16 >> 16) {
  STACKTOP = i7;
  return;
 }
 HEAP16[i2 >> 1] = i1;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if (!i1) {
  STACKTOP = i7;
  return;
 }
 HEAP16[i3 >> 1] = i5;
 HEAP16[i4 >> 1] = HEAP16[i6 >> 1] | 0;
 __ZN5physx2Sc13ConstraintSim14postFlagChangeENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEES5_(i1, i3, i4);
 STACKTOP = i7;
 return;
}

function __ZN5physx2Gu9Container17InitSharedBuffersEjPjb(i8, i7, i6, i5) {
 i8 = i8 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i9;
 i3 = i8 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i8 + 12 | 0;
 if (i4 | 0) if ((HEAP32[i1 >> 2] | 0) > -1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i4);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i8 >> 2] = i7;
 HEAP32[i3 >> 2] = i6;
 if (i5) {
  HEAPF32[i1 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
  STACKTOP = i9;
  return;
 } else {
  HEAP32[i1 >> 2] = -1;
  STACKTOP = i9;
  return;
 }
}

function __ZN5physx27PxRigidStaticRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 24 >> 2] = Math_fround(0.0);
 i2 = mftCall_iii(i4 | 0, i2 | 0, i3 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 12 | 0;
 i4 = i2;
 i3 = HEAP32[gb + 1110260 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i4, i3 + 120 | 0, i5);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == ((HEAP32[i3 + 148 >> 2] | 0) + (HEAP32[i3 + 152 >> 2] << 3) | 0)) {
  i5 = 0;
  STACKTOP = i2;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 STACKTOP = i2;
 return i5 | 0;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 88 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 92 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z33GUIClip_CUSTOM_INTERNAL_CALL_PushRK5RectTIfERK13Vector2fIcallS5_h(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 i6 = i5 + 8 | 0;
 i9 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 i8 = HEAP32[(__Z11GetGUIStatev() | 0) + 280 >> 2] | 0;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN12GUIClipState4PushER10InputEventRK5RectTIfE8Vector2fRKS6_b(i9, i8, i1, i7, i6, i4 << 24 >> 24 != 0);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx2Sc18ParticleSystemCore14getParticleMapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 12;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 12;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 4;
 HEAP32[i3 + 40 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 4;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i3 | 0, 0, 0);
 STACKTOP = i4;
 return HEAP32[i3 + 12 >> 2] | 0;
}

function __ZNK5physx11AdjTriangle11HasNeighborEjPj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] & 536870911;
 if ((i4 | 0) != 536870911 & (i4 | 0) == (i3 | 0)) {
  if (!i1) {
   i4 = 1;
   return i4 | 0;
  }
  HEAP32[i1 >> 2] = 0;
  i4 = 1;
  return i4 | 0;
 }
 i4 = HEAP32[i2 + 4 >> 2] & 536870911;
 if ((i4 | 0) != 536870911 & (i4 | 0) == (i3 | 0)) {
  if (!i1) {
   i4 = 1;
   return i4 | 0;
  }
  HEAP32[i1 >> 2] = 1;
  i4 = 1;
  return i4 | 0;
 }
 i4 = HEAP32[i2 + 8 >> 2] & 536870911;
 if (!((i4 | 0) != 536870911 & (i4 | 0) == (i3 | 0))) {
  i4 = 0;
  return i4 | 0;
 }
 if (!i1) {
  i4 = 1;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = 2;
 i4 = 1;
 return i4 | 0;
}

function __ZNK2UI13RectTransform23CalculateLocalPosition2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3;
 __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i7, i2);
 f6 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(HEAPF32[i7 + 8 >> 2]);
 f5 = Math_fround(f6 + Math_fround(f5 * Math_fround(HEAPF32[i2 + 168 >> 2])));
 f6 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i7 + 12 >> 2]);
 f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 172 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 if (!(__Z9SetLocalS15TransformAccessRKN4math7_float3E(i5, i3) | 0)) {
  STACKTOP = i4;
  return;
 }
 i7 = (HEAP32[i1 + 28 >> 2] | 0) + i2 | 0;
 HEAP8[i7 >> 0] = HEAPU8[i7 >> 0] | 0 | 8;
 STACKTOP = i4;
 return;
}

function __ZN7ApiGLES11VertexArrayC2ERKS_ji19VertexChannelFormatiPKvN2gl21VertexArrayAttribKindE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i1 + 8 >> 2] = i3;
 i7 = i1 + 12 | 0;
 HEAP8[i7 >> 0] = 0;
 i6 = i2 + 860 | 0;
 i8 = __ZNK13TranslateGLES23VertexArrayKindBitfieldEN2gl21VertexArrayAttribKindE(HEAP32[i6 >> 2] | 0, i8) | 0;
 i8 = __ZNK13TranslateGLES23VertexArraySizeBitfieldEi(HEAP32[i6 >> 2] | 0, i4) | 0 | i8;
 HEAP8[i7 >> 0] = i8 | (__ZNK13TranslateGLES23VertexArrayTypeBitfieldE19VertexChannelFormat(HEAP32[i6 >> 2] | 0, i5) | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 268 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 260 >> 2] | 0;
 i3 = i1 + 264 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sn21SerializationRegistry30registerBinaryMetaDataCallbackEPFvRNS_14PxOutputStreamEE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = i5;
 i2 = i6 + 88 | 0;
 i3 = i6 + 92 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 96 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPFvRNS_14PxOutputStreamEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN4FMOD7Channel19set3DMinMaxDistanceEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i3;
 i3 = HEAP32[gb + 1459872 + (i4 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i4 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i4 & 65535 | 0)) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 858934;
 _printf(gb + 853184 | 0, i5) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN2UI13RectTransform15InitializeClassEv() {
 var i1 = 0;
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 590196 | 0, gb + 407233 | 0, gb + 406022 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 28980 | 0, gb + 1105016 | 0, fb + 511 | 0, gb + 29192 | 0);
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 407244 | 0, 89) | 0;
 HEAP32[i1 >> 2] = gb + 44796 + 8;
 HEAP32[gb + 1158344 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 224, 28, HEAP32[gb + 1158344 >> 2] | 0);
 return;
}

function __ZN22DownloadHandlerTexture22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN13MonoBehaviour17GetObjectGUIStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + 132 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2;
  STACKTOP = i4;
  return i3 | 0;
 }
 i2 = __Znwj(48) | 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i3, gb + 63664 | 0);
 i6 = i3;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 i3 = i2;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN12_GLOBAL__N_117ConnectionManager13removeHandlerERN5physx8debugger4comm20PvdConnectionHandlerE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i5 >> 2] | 0);
 i6 = i1 + 164 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 L1 : do if (i7 | 0) {
  i3 = HEAP32[i1 + 160 >> 2] | 0;
  i2 = 0;
  while (1) {
   i1 = i3 + (i2 << 2) | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i7 >>> 0) break L1;
  }
  i7 = i7 + -1 | 0;
  HEAP32[i6 >> 2] = i7;
  HEAP32[i1 >> 2] = HEAP32[i3 + (i7 << 2) >> 2];
 } while (0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i5 >> 2] | 0);
 return;
}

function __ZN11ColorModule8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_(i1, i4);
 i3 = i1 + 8 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 620164 | 0, gb + 620954 | 0, i2, 1) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 if ((i1 | 0) > 0) __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
 }
 __ZN14SafeBinaryRead11EndTransferEv(i4);
 STACKTOP = i5;
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 733457 | 0, i1, 0);
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 842535 | 0, 0);
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 1034411 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z44AnimatorControllerPlayable_CUSTOM_GetFloatIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 if ((i4 | 0) == 1) {
  f6 = Math_fround(HEAPF32[i3 >> 2]);
  STACKTOP = i5;
  return Math_fround(f6);
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4, i2);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 STACKTOP = i5;
 return Math_fround(f6);
}

function ___srandom(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 207768 >> 2] | 0;
 if (!i5) HEAP32[HEAP32[gb + 207772 >> 2] >> 2] = i2; else {
  HEAP32[gb + 207776 >> 2] = (i5 | 0) == 31 | (i5 | 0) == 7 ? 3 : 1;
  HEAP32[gb + 1470384 >> 2] = 0;
  if ((i5 | 0) > 0) {
   i1 = HEAP32[gb + 207772 >> 2] | 0;
   i4 = 0;
   i3 = 0;
   do {
    i6 = ___muldi3(i2 | 0, i3 | 0, 1284865837, 1481765933) | 0;
    i2 = _i64Add(i6 | 0, getTempRet0() | 0, 1, 0) | 0;
    i3 = getTempRet0() | 0;
    HEAP32[i1 + (i4 << 2) >> 2] = i3;
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i5 | 0));
  } else i1 = HEAP32[gb + 207772 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
 }
 return;
}

function __ZNK9Texture3D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i4, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 i2 = HEAP32[i4 + 96 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  STACKTOP = i3;
  return i6 | 0;
 }
 i8 = HEAP32[i4 + 80 >> 2] | 0;
 i7 = HEAP32[i4 + 92 >> 2] | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i1, i8, HEAP32[i4 + 84 >> 2] | 0, Math_imul(HEAP32[gb + 45784 + (i7 << 2) >> 2] | 0, i8) | 0, i7, i2);
 __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i5, i1, i6);
 i6 = 1;
 STACKTOP = i3;
 return i6 | 0;
}

function __ZN8Animator14SetLayerWeightEif(i1, i3, f4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i5 = 0;
 i2 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) return;
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 }
 i2 = i1 + 584 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i1 = HEAP32[i2 >> 2] | 0;
 do {
  __ZN26AnimatorControllerPlayable14SetLayerWeightEif(HEAP32[i1 >> 2] | 0, i3, f4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i5 >> 2] << 2) | 0));
 return;
}

function __ZN5physx7NpScene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 if (f5 > Math_fround(HEAPF32[i2 + 12 >> 2])) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 678666 | 0, 1694, gb + 704010 | 0, i4);
  i3 = -1;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i3 = __ZN5physx3Scb5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb(i3 + 16 | 0, i2, i1) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx7NpScene18removeArticulationERNS_14PxArticulationEb(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if ((i2 | 0) == (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0)) {
  __ZN5physx7NpScene26removeArticulationInternalERNS_14PxArticulationEbb(i2, i1, i4, 1);
  STACKTOP = i5;
  return;
 } else {
  i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i3 >> 2] = gb + 709724;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 8, gb + 678666 | 0, 76, gb + 708910 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 28 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP16[i2 + 4 >> 1] = 1;
 HEAP16[i2 + 6 >> 1] = 3;
 HEAP32[i2 >> 2] = gb + 107148 + 8;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = gb + 93676 + 8;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 107232 + 8;
 HEAP32[i3 >> 2] = gb + 107232 + 104;
 i3 = i2 + 96 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i2 + 112 >> 2] = i1;
 HEAP32[i2 + 52 >> 2] = 1;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = i2 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP16[i2 + 12 >> 1] = 0;
 return;
}

function __ZN5physx18NpArticulationLink8requiresERNS_23PxProcessPxBaseCallbackE(i6, i7) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i6 + 20 | 0;
 i4 = i6 + 24 | 0;
 i1 = HEAP16[i4 >> 1] | 0;
 L1 : do if (i1 << 16 >> 16) {
  i5 = i1 & 65535;
  i2 = 0;
  while (1) {
   if (i1 << 16 >> 16 == 1) i1 = i3; else i1 = HEAP32[i3 >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i5 | 0)) break L1;
   i1 = HEAP16[i4 >> 1] | 0;
  }
 } while (0);
 i1 = HEAP32[i6 + 292 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i1 | 0);
 return;
}

function __ZN5physx13NpVolumeCache14getCacheVolumeERNS_16PxGeometryHolderERNS_11PxTransformE(i5, i1, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i5 + 4 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 HEAP32[i4 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 52 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 56 >> 2];
 HEAP32[i4 + 16 >> 2] = HEAP32[i5 + 60 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i5 + 64 >> 2];
 HEAP32[i4 + 24 >> 2] = HEAP32[i5 + 68 >> 2];
 return mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0) | 0;
}

function __ZN4FMOD12ChannelGroup19setAudibilityFactorEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAPF32[i2 + 40 >> 2] = f3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862556;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN22NavMeshProjectSettingsD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 HEAP32[i1 >> 2] = gb + 169552 + 8;
 i3 = i1 + 28 | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 668 | 0;
 do {
  i6 = i5;
  i5 = i5 + -20 | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i6 + -8 >> 2] | 0;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i2);
  }
 } while ((i5 | 0) != (i3 | 0));
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 STACKTOP = i7;
 return;
}

function __ZN21LinearCollectionField8SetArrayERK9ArrayInfo(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i5 >> 2] | 0) | 0;
 i3 = i5 + 8 | 0;
 if (!(HEAP8[i5 + 4 >> 0] | 0)) i1 = i1 + -8 + (HEAP32[i5 + 16 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + i1 >> 2] = i2;
 if ((HEAP32[i5 + 24 >> 2] | 0) != 1) return;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 4 >> 2];
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i5 + 28 >> 2] | 0) | 0;
 if (!(HEAP8[i5 + 32 >> 0] | 0)) i1 = i1 + -8 + (HEAP32[i5 + 44 >> 2] | 0) | 0;
 HEAP32[(HEAP32[i5 + 36 >> 2] | 0) + i1 >> 2] = i2;
 return;
}

function __ZN21DownloadHandlerBuffer22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 i4 = i1 + 36 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 1, i1 + 24 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN14PhysicsManager27ExecuteDeferredTriggerEraseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1452452 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452452 | 0, i1);
  i1 = gb + 1452452 | 0;
 } else i1 = 0;
 __ZN17TriggerStayStates20executeDeferredEraseEv(i3 + 104 | 0);
 __ZN17TriggerStayStates20executeDeferredEraseEv(i3 + 136 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN14ParticleSystem7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(948, i1, 16, gb + 1048932 | 0, 0, gb + 622150 | 0, 103) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14ParticleSystemC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14DirectorPlayerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 37344 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z42RelativeJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK15RelativeJoint2D9GetTargetEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z26Animator_CUSTOM_SetFloatIDP12Il2CppObjectif(i4, i5, f1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0;
 if (!i4) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i2) {
  i3 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i2 = __ZN8Animator8SetFloatEif(i2, i5, f1) | 0;
 if ((i2 | 0) == 1) return;
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i3, i2, i5);
 return;
}

function _tre_tag_order(i2, i3, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i4 = 0, i7 = 0;
 L1 : do if ((i2 | 0) > 0) {
  i1 = 0;
  while (1) {
   i7 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
   i4 = HEAP32[i6 + (i1 << 2) >> 2] | 0;
   if (!(HEAP32[i3 + (i1 << 2) >> 2] | 0)) {
    if ((i7 | 0) < (i4 | 0)) {
     i1 = 1;
     break L1;
    }
    if ((i7 | 0) > (i4 | 0)) {
     i1 = 0;
     break L1;
    }
   } else {
    if ((i7 | 0) > (i4 | 0)) {
     i1 = 1;
     break L1;
    }
    if ((i7 | 0) < (i4 | 0)) {
     i1 = 0;
     break L1;
    }
   }
   i1 = i1 + 1 | 0;
   if ((i1 | 0) >= (i2 | 0)) {
    i1 = 0;
    break;
   }
  }
 } else i1 = 0; while (0);
 return i1 | 0;
}

function _mseek(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i4 = HEAP32[i1 + 84 >> 2] | 0;
 if (i2 >>> 0 > 2) i6 = 2; else {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 4 >> 2];
  i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  if ((i5 | 0) < (0 - i1 | 0)) i6 = 2; else if (((HEAP32[i4 + 8 >> 2] | 0) - i1 | 0) < (i5 | 0)) i6 = 2; else {
   i1 = i1 + i5 | 0;
   HEAP32[i4 >> 2] = i1;
  }
 }
 if ((i6 | 0) == 2) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNSt3__217__assoc_sub_state4waitEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i5 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = i5;
 i4 = i3 + 4 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i5);
 __THREW__ = 0;
 invoke_vii(fb + 4502 | 0, i1 | 0, i3 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (HEAP8[i4 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i3 >> 2] | 0);
  ___resumeException(i1 | 0);
 } else {
  if (HEAP8[i4 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i3 >> 2] | 0);
  STACKTOP = i2;
  return;
 }
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE9do_lengthER11__mbstate_tPKcS5_j(i2, i1, i6, i3, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 if (!(HEAP32[i2 + 12 >> 2] & 4)) i1 = i6; else if ((i3 - i6 | 0) > 1) if ((HEAP8[i6 >> 0] | 0) == -1) i1 = (HEAP8[i6 + 1 >> 0] | 0) == -2 ? i6 + 2 | 0 : i6; else i1 = i6; else i1 = i6;
 i4 = i3 + -1 | 0;
 i3 = 0;
 while (1) {
  if (!(i3 >>> 0 < i7 >>> 0 & i1 >>> 0 < i4 >>> 0)) break;
  i2 = HEAPU8[i1 + 1 >> 0] << 8;
  if ((i2 & 63488 | 0) == 55296) break;
  if ((HEAPU8[i1 >> 0] | i2) >>> 0 > i5 >>> 0) break; else {
   i3 = i3 + 1 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return i1 - i6 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE9do_lengthER11__mbstate_tPKcS5_j(i2, i1, i6, i3, i7) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 8 >> 2] | 0;
 if (!(HEAP32[i2 + 12 >> 2] & 4)) i1 = i6; else if ((i3 - i6 | 0) > 1) if ((HEAP8[i6 >> 0] | 0) == -2) i1 = (HEAP8[i6 + 1 >> 0] | 0) == -1 ? i6 + 2 | 0 : i6; else i1 = i6; else i1 = i6;
 i4 = i3 + -1 | 0;
 i3 = 0;
 while (1) {
  if (!(i3 >>> 0 < i7 >>> 0 & i1 >>> 0 < i4 >>> 0)) break;
  i2 = HEAPU8[i1 >> 0] << 8;
  if ((i2 & 63488 | 0) == 55296) break;
  if ((HEAPU8[i1 + 1 >> 0] | i2) >>> 0 > i5 >>> 0) break; else {
   i3 = i3 + 1 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return i1 - i6 | 0;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i8 = HEAPU8[i2 + i1 >> 0] | 0;
  i7 = HEAP32[i4 + (i8 * 12 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i4 + (i8 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i4 + (i8 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i7;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i6;
  HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN9Rigidbody7SetMassEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, f4 = f0, i5 = 0;
 i5 = f2 < Math_fround(1.00000001e-07);
 i3 = f2 > Math_fround(1.0e9);
 f4 = i3 ? Math_fround(1.0e9) : f2;
 i3 = i1 + 68 | 0;
 HEAPF32[i3 >> 2] = i5 ? Math_fround(1.00000001e-07) : f4;
 if (!(HEAP8[i1 + 81 >> 0] | 0)) {
  i5 = HEAP32[i1 + 52 >> 2] | 0;
  mftCall_vif(HEAP32[(HEAP32[i5 >> 2] | 0) + 128 >> 2] | 0, i5 | 0, +f2);
 } else __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 i1 = i1 + 56 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i5 = __Z12GetIVehiclesv() | 0;
 mftCall_viif(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, HEAP32[i1 >> 2] | 0, +Math_fround(HEAPF32[i3 >> 2]));
 return;
}

function __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcPNS_21PxProfileNameProviderEj(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i8 = i5 + 8 | 0;
 i7 = i5;
 HEAP32[i8 >> 2] = gb + 114116 + 8;
 i8 = (i2 | 0) == 0 ? i8 : i2;
 i2 = HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0;
 mftCall_vii(HEAP32[HEAP32[i8 >> 2] >> 2] | 0, i7 | 0, i8 | 0);
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 i4 = mftCall_iiiii(i2 | 0, i4 | 0, i3 | 0, i6 | 0, i1 | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = i1 + 4 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if (i5 >>> 0 >= i2 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i4 = i1 + 8 | 0;
 while (1) {
  i2 = i2 + -4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i1 + 21 >> 0] & 9) {
   i3 = HEAP32[i4 >> 2] | 0;
   if ((HEAP32[i1 + 24 >> 2] | 0) == (i3 | 0)) break;
   if ((HEAP32[i1 + 28 >> 2] | 0) == (i3 | 0)) break;
  }
  HEAP32[i6 >> 2] = i2;
  if (i5 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return i1 | 0;
 HEAP32[i6 >> 2] = i2;
 i7 = i1;
 return i7 | 0;
}

function __ZN5physx14NpArticulationC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP16[i1 + 4 >> 1] = 14;
 HEAP16[i1 + 6 >> 1] = 3;
 HEAP32[i1 >> 2] = gb + 91248 + 8;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 i2 = i1 + 24 | 0;
 __ZN5physx2Sc16ArticulationCoreC2Ev(i2);
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -251658241 | 134217728;
 HEAPF32[i1 + 60 >> 2] = Math_fround(__ZNK5physx2Sc16ArticulationCore14getWakeCounterEv(i2));
 HEAP8[i1 + 64 >> 0] = 1;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP8[i1 + 84 >> 0] = 1;
 HEAP32[i1 + 88 >> 2] = i1 + 68;
 HEAP32[i1 + 96 >> 2] = 4;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN4UNET16ScriptingUpdater16PlayerLoopUpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 248 | 0;
 i2 = i5 + 8 | 0;
 i3 = i5;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i5;
  return;
 }
 i7 = i1;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i2, i4);
 HEAP32[i4 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i2, i4, 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN4FMOD7Channel9setVolumeEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   __ZN4FMOD8ChannelI9setVolumeEf(i2, f3) | 0;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 856117;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN15DirectorManager23DestroyPendingPlayablesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[HEAP32[gb + 1188424 >> 2] >> 2] | 0)) return;
 i2 = HEAP32[gb + 1188424 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 while (1) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0);
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63784 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63784 | 0);
  i2 = HEAP32[gb + 1188424 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) break;
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 }
 return;
}

function __ZN14PlayerSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(632, i1, 16, gb + 1048932 | 0, 0, gb + 453198 | 0, 82) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14PlayerSettingsC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN14PhysicsManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(800, i1, 16, gb + 1048932 | 0, 0, gb + 781684 | 0, 75) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14PhysicsManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL28GeomMTDCallback_SphereConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 12 >> 2] = i2;
 i6 = __ZN5physx2Gu23computeMTD_SphereConvexERNS_6PxVec3ERfRKNS0_6SphereERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z49ConstantForce2D_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN15ConstantForce2D16SetRelativeForceERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z35ParticleSystem_CUSTOM_Internal_EmitP12Il2CppObjectR24ParticleSystemEmitParamsi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem21EmitParticlesExternalER24ParticleSystemEmitParamsj(i4, i2, i3);
  return;
 }
}

function __Z30AudioSource_CUSTOM_PlayOneShotP12Il2CppObjectS0_f(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i2) return;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0)) return;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN11AudioSource11PlayOneShotER9AudioClipf(i4, i1, f3);
 return;
}

function __Z29AnimationCurve_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1, i4, i4 + ((__Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0) << 4) | 0);
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_(i2, i2 + (HEAP32[i1 + 68 >> 2] << 4) | 0, i3);
 __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i1);
 STACKTOP = i3;
 return;
}

function _unzGoToNextFile(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 if (!i3) {
  i4 = -102;
  return i4 | 0;
 }
 i4 = i3 + 56 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = -100;
  return i4 | 0;
 }
 i5 = HEAP32[i3 + 36 >> 2] | 0;
 i1 = i3 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i5 | 0) != 65535 & (i2 + 1 | 0) == (i5 | 0)) {
  i5 = -100;
  return i5 | 0;
 }
 i5 = i3 + 52 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i3 + 104 >> 2] | 0) + 46 + (HEAP32[i3 + 108 >> 2] | 0) + (HEAP32[i3 + 112 >> 2] | 0) + (HEAP32[i5 >> 2] | 0);
 HEAP32[i1 >> 2] = i2 + 1;
 i5 = _unzlocal_GetCurrentFileInfoInternal(i3, i3 + 72 | 0, i3 + 152 | 0, 0, 0, 0, 0, 0, 0) | 0;
 HEAP32[i4 >> 2] = (i5 | 0) == 0 & 1;
 return i5 | 0;
}

function __ZThn24_N5physx2Sc20ArticulationJointSimD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -24 | 0;
 HEAP32[i1 >> 2] = gb + 90892 + 8;
 HEAP32[i1 + 24 >> 2] = gb + 90892 + 44;
 i2 = i1 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) != -1) __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 + 4 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, 2, i2);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE(HEAP32[i2 + 152 >> 2] | 0, i2);
 HEAP32[HEAP32[i1 + 36 >> 2] >> 2] = 0;
 __ZN5physx2Sc16ActorInteractionD2Ev(i1);
 return;
}

function __ZN5physx2Sc5Scene20addArticulationJointERNS0_21ArticulationJointCoreERNS0_8BodyCoreES5_(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i5 = _PxGetFoundation() | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 24 >> 2] | 0, i5 | 0) | 0;
 i5 = mftCall_iiiiii(i6 | 0, i4 | 0, 40, (i5 ? gb + 680447 | 0 : gb + 837976 | 0) | 0, gb + 680241 | 0, 782) | 0;
 i4 = __ZNK5physx2Sc8BodyCore6getSimEv(i3) | 0;
 __ZN5physx2Sc20ArticulationJointSimC2ERNS0_21ArticulationJointCoreERNS0_8ActorSimES5_(i5, i2, i4, __ZNK5physx2Sc8BodyCore6getSimEv(i1) | 0);
 return;
}

function __ZN16Physics2DManager20IgnoreLayerCollisionEiib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN17Physics2DSettings20IgnoreLayerCollisionEiib(__Z21GetManagerFromContexti(16) | 0, i2, i3, i4);
 i3 = 1 << i3 | 1 << i2;
 i1 = HEAP32[(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102956 >> 2] | 0;
 if (!i1) return;
 do {
  i2 = HEAP32[i1 + 148 >> 2] | 0;
  if (i2 | 0) if (1 << HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 48 >> 2] & i3 | 0) {
   i2 = HEAP32[i1 + 100 >> 2] | 0;
   if (i2 | 0) do {
    __ZN9b2Fixture8RefilterEv(i2);
    i2 = HEAP32[i2 + 24 >> 2] | 0;
   } while ((i2 | 0) != 0);
  }
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN14BillboardAsset7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(48, i1, 16, gb + 1048932 | 0, 0, gb + 422618 | 0, 16) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN14BillboardAssetC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13AnimationClip7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(296, i1, 16, gb + 1048932 | 0, 0, gb + 908081 | 0, 133) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z43PolygonCollider2D_CUSTOM_GetTotalPointCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i2 = i2 + 160 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i4 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = (i1 - i2 | 0) / 20 | 0;
 i2 = 0;
 i1 = 0;
 do {
  i1 = (HEAP32[i4 + (i2 * 20 | 0) + 12 >> 2] | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return i1 | 0;
}

function __Z36AnimationCurve_CUSTOM_SmoothTangentsP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 if ((i2 | 0) > -1) {
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
  if ((HEAP32[i1 + 68 >> 2] | 0) > (i2 | 0)) {
   __Z22RecalculateSplineSlopeR17AnimationCurveTplIfEif(i1, i2, f3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 544445 | 0, i5);
}

function __Z24Material_CUSTOM_SetFloatP12Il2CppObjectif(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7 + 4 | 0;
 i5 = i7;
 if (!i2) {
  i6 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i6);
 }
 i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i6) {
  i7 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i7);
 } else {
  HEAP32[i5 >> 2] = i3;
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf(i6, i1, f4);
  STACKTOP = i7;
  return;
 }
}

function _UNITY_png_colorspace_set_ICC(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((HEAP16[i2 + 74 >> 1] | 0) < 0) {
  i6 = 0;
  return i6 | 0;
 }
 if (i4 >>> 0 < 132) {
  _UNITY_png_icc_profile_error(i1, i2, i3, i4, gb + 352548 | 0);
  i6 = 0;
  return i6 | 0;
 }
 if (i4 & 3 | 0) {
  _UNITY_png_icc_profile_error(i1, i2, i3, i4, gb + 351232 | 0);
  i6 = 0;
  return i6 | 0;
 }
 if (!(_UNITY_png_icc_check_header(i1, i2, i3, i4, i5, i6) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(_UNITY_png_icc_check_tag_table(i1, i2, i3, i4, i5) | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 _UNITY_png_icc_set_sRGB(i1, i2, i5, 0);
 i6 = 1;
 return i6 | 0;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwnerD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -8 | 0;
 HEAP32[i2 >> 2] = gb + 148996 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i2 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i2 + 44 >> 2] = gb + 148172 + 8;
 i1 = i2 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 28 >> 2] = gb + 148172 + 8;
 i1 = i2 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i2 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwnerD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -4 | 0;
 HEAP32[i2 >> 2] = gb + 148996 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i2 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i2 + 44 >> 2] = gb + 148172 + 8;
 i1 = i2 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 28 >> 2] = gb + 148172 + 8;
 i1 = i2 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i2 = HEAP32[i2 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 L1 : do switch ((HEAP32[i2 + 4 >> 2] & 176) << 24 >> 24) {
 case 16:
  {
   i2 = HEAP8[i1 >> 0] | 0;
   switch (i2 << 24 >> 24) {
   case 43:
   case 45:
    {
     i1 = i1 + 1 | 0;
     break L1;
    }
   default:
    {}
   }
   if ((i3 - i1 | 0) > 1 & i2 << 24 >> 24 == 48) {
    switch (HEAP8[i1 + 1 >> 0] | 0) {
    case 88:
    case 120:
     break;
    default:
     {
      i4 = 7;
      break L1;
     }
    }
    i1 = i1 + 2 | 0;
   } else i4 = 7;
   break;
  }
 case 32:
  {
   i1 = i3;
   break;
  }
 default:
  i4 = 7;
 } while (0);
 return i1 | 0;
}

function __ZN5physx2Sc8ShapeSim18reinsertBroadPhaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i5 = i1 + 8 | 0;
 __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE(HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0, 4, i1);
 i5 = HEAP32[i5 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i5 + 36 >> 2] | 0) + 1008 >> 2] | 0;
 __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E(i3, 0, HEAP32[i1 + 28 >> 2] | 0, i5, 0);
 __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE(i4, i3, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx21solveVDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE(i14, f8, i12, i15, i5, i3, i13, i4, i2, i1, i6, i7, i9, i10, i11) {
 i14 = i14 | 0;
 f8 = Math_fround(f8);
 i12 = i12 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 mftCall_vifiiiiiiiiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 12 >> 2] | 0, i14 | 0, +f8, i12 | 0, i15 | 0, i5 | 0, i3 | 0, i13 | 0, i4 | 0, i2 | 0, i1 | 0, i6 | 0, i7 | 0, i9 | 0, i10 | 0, i11 | 0);
 return;
}

function __ZN5physx21solveVCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE(i14, f8, i12, i15, i5, i3, i13, i4, i2, i1, i6, i7, i9, i10, i11) {
 i14 = i14 | 0;
 f8 = Math_fround(f8);
 i12 = i12 | 0;
 i15 = i15 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i13 = i13 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 mftCall_vifiiiiiiiiiiiii(HEAP32[(HEAP32[i14 >> 2] | 0) + 16 >> 2] | 0, i14 | 0, +f8, i12 | 0, i15 | 0, i5 | 0, i3 | 0, i13 | 0, i4 | 0, i2 | 0, i1 | 0, i6 | 0, i7 | 0, i9 | 0, i10 | 0, i11 | 0);
 return;
}

function __ZN5Umbra11ShadowUtils22normalizePlaneEquationERKNS_7Vector4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(f6 * f6);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f3 + Math_fround(f5 * f5));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f4 * f4)))));
 f6 = Math_fround(f6 * f3);
 f5 = Math_fround(f5 * f3);
 f4 = Math_fround(f4 * f3);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = f3;
 return;
}

function __ZN18ScriptingArguments28AdjustArgumentsToMatchMethodE21ScriptingMethodIl2Cpp(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i5 = i4;
 i7 = i1;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i3 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i3) | 0;
 i1 = i2 + 192 | 0;
 if ((i3 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i1 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i4 = i1 + 132 | 0;
 i5 = i2 + 16 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i7 = i6 + 4 | 0;
 if (i7 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i5, i4, 4); else {
  HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 >> 2] = i7;
 }
 __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 44 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18AsyncUploadManager17CreateInstructionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 1352 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(184, i2 + 1356 | 0, 16, gb + 397729 | 0, 33) | 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  HEAP32[i1 + 132 >> 2] = 0;
  HEAP32[i1 + 136 >> 2] = 0;
  HEAP32[i1 + 140 >> 2] = 1;
  i2 = i1 + 144 | 0;
  i3 = i2;
  i4 = i3 + 36 | 0;
  do {
   HEAP32[i3 >> 2] = 0;
   i3 = i3 + 4 | 0;
  } while ((i3 | 0) < (i4 | 0));
  HEAP8[i2 + 36 >> 0] = 0;
 } else HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i2 = i1 + 140 | 0;
 if (HEAP32[i2 >> 2] | 0) return i1 | 0;
 HEAP32[i2 >> 2] = 1;
 return i1 | 0;
}

function __ZN13TrailRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(552, i1, 16, gb + 1048932 | 0, 0, gb + 421884 | 0, 25) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13TrailRendererC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN13BuildSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(176, i1, 16, gb + 1048932 | 0, 0, gb + 444101 | 0, 11) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13BuildSettingsC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN10GameObject7SetNameEPKc(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i3 = i6;
 i7 = HEAP32[i5 + 8 >> 2] | 0;
 i4 = i7 & 2047;
 if (!(i7 & 2048)) {
  HEAP32[i3 >> 2] = i4;
  HEAP32[i3 + 4 >> 2] = 0;
 } else __Z14CreateMemLabel18MemLabelIdentifierPv(i3, i4, i5);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i5 + 64 | 0, i2, i1);
 i1 = HEAP32[gb + 1104576 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 mftCall_vi(i1 | 0, i5 | 0);
 STACKTOP = i6;
 return;
}

function __ZN10DynamicVBOC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 HEAP32[i1 >> 2] = gb + 57900 + 8;
 i7 = gb + 64016 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i1 + 24 >> 0] = 0;
 HEAP8[i1 + 25 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function __ZL26GeomMTDCallback_SphereMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i5 + 20 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i5 + 24 >> 2];
 HEAP32[i8 + 12 >> 2] = i2;
 i6 = __ZN5physx2Gu21computeMTD_SphereMeshERNS_6PxVec3ERfRKNS0_6SphereERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE(i4, i1, i8, i3, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z57Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionNonAllocRK3RayP11Il2CppArrayfi(i2, i3, f4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 36) | 0;
 i6 = __Z19GetPhysicsManager2Dv() | 0;
 i3 = __ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di(i6, i2, i2 + 12 | 0, f4, i5, 0, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i3) | 0) | 0;
 if (!i3) return i3 | 0; else i2 = 0;
 while (1) {
  __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 36 | 0;
 }
 return i3 | 0;
}

function __Z48RelativeJoint2D_CUSTOM_INTERNAL_set_linearOffsetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN15RelativeJoint2D15SetLinearOffsetERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z40Rigidbody2D_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11Rigidbody2D11GetVelocityEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z40Rigidbody2D_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK11Rigidbody2D11GetPositionEv(i3, i4);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i4 = i2;
  HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __Z27ClearCommonScriptingClassesR22CommonScriptingClasses(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(HEAP32[gb + 1164956 + 768 >> 2] | 0)) {
  i2 = i1 + 124 | 0;
  do {
   HEAP32[i1 >> 2] = 0;
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) < (i2 | 0));
  return;
 } else i2 = 0;
 do {
  i3 = gb + 1164956 + (i2 * 12 | 0) | 0;
  if (!(HEAP8[gb + 1164956 + (i2 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i3 >> 2] | 0); else mftCall_vi(HEAP32[i3 >> 2] | 0, HEAP32[gb + 1164956 + (i2 * 12 | 0) + 4 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[gb + 1164956 + 768 >> 2] | 0) >>> 0);
 i2 = i1 + 124 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function _strtox_519(i4, i5, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i9;
 HEAP32[i7 >> 2] = 0;
 i8 = i7 + 4 | 0;
 HEAP32[i8 >> 2] = i4;
 HEAP32[i7 + 44 >> 2] = i4;
 i6 = i7 + 8 | 0;
 HEAP32[i6 >> 2] = (i4 | 0) < 0 ? -1 : i4 + 2147483647 | 0;
 HEAP32[i7 + 76 >> 2] = -1;
 ___shlim(i7, 0);
 i1 = ___intscan(i7, i1, 1, i2, i3) | 0;
 i2 = getTempRet0() | 0;
 if (i5 | 0) HEAP32[i5 >> 2] = i4 + ((HEAP32[i8 >> 2] | 0) + (HEAP32[i7 + 108 >> 2] | 0) - (HEAP32[i6 >> 2] | 0));
 setTempRet0(i2 | 0);
 STACKTOP = i9;
 return i1 | 0;
}

function __ZNK8Animator25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = __ZNK26AnimatorControllerPlayable25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2, i3) | 0;
 return i5 | 0;
}

function __ZN9AudioClip7WWWSeekEPvjS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i3 = 37;
  return i3 | 0;
 }
 i1 = i3 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
 i4 = HEAP32[i1 >> 2] | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0) >>> 0 >= i2 >>> 0) if ((HEAP32[i3 + 12 >> 2] | 0) >>> 0 >= i2 >>> 0) {
  HEAP32[i3 + 8 >> 2] = i2;
  i4 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0);
 i4 = 20;
 return i4 | 0;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i3 = i1 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = HEAP32[i1 + 268 >> 2] | 0;
 if (!i4) {
  i6 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i6);
  return;
 }
 i1 = i1 + 264 | 0;
 i2 = 0;
 do {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i5 | 0, i6 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i7 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i7);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 76 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i3 = i1 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 32 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i1 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc9ClothCore16setRestPositionsEPKNS_6PxVec4E(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6;
 i1 = i1 + 28 | 0;
 if (!i5) i2 = 0; else {
  i2 = HEAP32[i1 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 344 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i4 + 4 >> 2] = i5 + (i2 << 4);
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 mftCall_vii(i7 | 0, i1 | 0, i3 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5physx20BigConvexDataBuilder10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP16[i2 + 2 >> 1] | 0;
 if (!(i3 << 16 >> 16)) {
  i3 = i2;
  i2 = 0;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  return 1;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i5 | 0, i4 | 0, (i3 & 65535) << 1 | 0, (i2 ? gb + 738946 | 0 : gb + 837976 | 0) | 0, gb + 729209 | 0, 44) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 return 1;
}

function __ZN4gles17UpdateStencilMaskER15DeviceStateGLESPK22DeviceStencilStateGLESh(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = (i1 | 0) == 0 ? HEAP32[i3 + 464 >> 2] | 0 : i1;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i2 = i5 + 2 | 0;
 if ((HEAP8[i2 >> 0] | 0) == i4 << 24 >> 24) {
  i5 = i1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP8[i2 >> 0] = i4;
 i5 = __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i3, i5) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __Z37Light_Set_Custom_PropShadowResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i2 + 1 | 0) >>> 0 > 4) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 540912 | 0, i4);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK5Light16UnshareLightDataEv(i3);
  HEAP32[(HEAP32[i3 + 44 >> 2] | 0) + 100 >> 2] = i2;
  STACKTOP = i4;
  return;
 }
}

function __Z32Canvas_Get_Custom_PropRootCanvasP12Il2CppObject(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 if (i1 | 0) {
  i3 = i1;
  i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
  return i3 | 0;
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(i3) | 0;
 return i3 | 0;
}

function __Z28Animator_CUSTOM_SetIntegerIDP12Il2CppObjectii(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i5 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i1 = __ZN8Animator10SetIntegerEii(i2, i4, i1) | 0;
 if ((i1 | 0) == 1) return;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 return;
}

function _Horizontal_Sweep_Span(i5, i6, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i4 - i3 | 0) >= (i1 | 0)) return;
 i2 = 0 - i1 | 0;
 i1 = i3 + -1 + i1 & i2;
 if ((i1 | 0) != (i2 & i4 | 0)) return;
 i1 = i1 >> HEAP32[i5 >> 2];
 if ((i1 | 0) <= -1) return;
 i2 = HEAP32[i5 + 104 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) return;
 i4 = i6 << 16 >> 16;
 i3 = HEAP32[i5 + 112 >> 2] | 0;
 i6 = (HEAP32[i5 + 60 >> 2] | 0) + (i4 >> 3) + (Math_imul(i3, 0 - i1 | 0) | 0) | 0;
 i5 = i6 + (Math_imul(i3, i2 + -1 | 0) | 0) | 0;
 i6 = (i3 | 0) > 0 ? i5 : i6;
 HEAP8[i6 >> 0] = HEAPU8[i6 >> 0] | 0 | 128 >>> (i4 & 7);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6snextcEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = i5 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i5 + 16 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) if ((mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 40 >> 2] | 0, i5 | 0) | 0) == -1) i1 = -1; else {
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i6 = 5;
 } else {
  i6 = i3 + 1 | 0;
  HEAP32[i2 >> 2] = i6;
  i2 = i6;
  i6 = 5;
 }
 do if ((i6 | 0) == 5) if ((i2 | 0) == (i1 | 0)) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 36 >> 2] | 0, i5 | 0) | 0;
  break;
 } else {
  i1 = HEAPU8[i2 >> 0] | 0;
  break;
 } while (0);
 return i1 | 0;
}

function __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE11flushEventsEv(i8) {
 i8 = i8 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i3 = i8 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = i8 + 20 | 0;
 i1 = i4;
 i5 = (HEAP32[i7 >> 2] | 0) - i1 | 0;
 i6 = HEAP32[i8 + 36 >> 2] | 0;
 if (i6) {
  i1 = i8 + 32 | 0;
  i2 = 0;
  do {
   i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i9 >> 2] | 0) + 8 >> 2] | 0, i9 | 0, i4 | 0, i5 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i6 | 0));
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i7 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i8 >> 2] | 0) + 16 >> 2] | 0, i8 | 0);
 return;
}

function __ZN5physx2Sq11PruningPoolD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101768 + 8;
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 24 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (HEAP32[i4 >> 2] & 16384 | 0) {
  STACKTOP = i5;
  return;
 }
 i3 = i1 + 28 | 0;
 i1 = __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb(i4, gb + 369402 | 0, gb + 932544 | 0, i2, 1) | 0;
 if (i1 | 0) {
  if ((i1 | 0) > 0) __ZN12ImmediatePtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_(i3, i4); else {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) mftCall_iii(i1 | 0, i3 | 0, i4 | 0) | 0;
  }
  __ZN14SafeBinaryRead11EndTransferEv(i4);
 }
 STACKTOP = i5;
 return;
}

function __ZN4File12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = i1 + 12 | 0;
 i4 = __Z13GetFileSystemv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
 __ZN10FileSystem19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i4, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __ZN4FMOD6System16getDSPBufferSizeEPjPi(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i2 + 44 >> 2];
  if (!i4) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
  HEAP32[i4 >> 2] = HEAP32[i2 + 48 >> 2];
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 855097;
 _printf(gb + 853184 | 0, i5) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN22MotionVectorRenderLoopD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 36848 + 8;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63288 | 0);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 12 | 0;
 if ((HEAP32[i2 + 28 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 16 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22MotionVectorRenderLoopD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 36848 + 8;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63288 | 0);
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 28 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 12 >> 2] | 0, i2 + 16 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN17ProceduralTexture17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 160 | 0;
 if (!(HEAP32[i4 >> 2] & 2)) {
  __ZN7Texture17MainThreadCleanupEv(i2);
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -3;
 HEAP32[i2 + 208 >> 2] = 0;
 __ZN7Texture17MainThreadCleanupEv(i2);
 STACKTOP = i5;
 return;
}

function __ZN12LineRenderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(504, i1, 16, gb + 1048932 | 0, 0, gb + 406750 | 0, 24) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN12LineRendererC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12InputManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(192, i1, 16, gb + 1048932 | 0, 0, gb + 441238 | 0, 35) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN12InputManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN12AudioManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(304, i1, 16, gb + 1048932 | 0, 0, gb + 873638 | 0, 53) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN12AudioManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z43GUIStyleState_CUSTOM_INTERNAL_set_textColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3); else {
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = HEAP32[i2 + 8 >> 2] | 0;
  i3 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 8 >> 2] = i6;
  HEAP32[i1 + 12 >> 2] = i5;
  HEAP32[i1 + 16 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = i2;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 if (i1 | 0) if (HEAP32[i1 + 12 >> 2] | 0) {
  __ZNK11LightProbes14LightProbeData33GetLightProbeInterpolationWeightsERK8Vector3fRiR8Vector4fRf(i1, i3, i5, i4, i4 + 16 | 0);
  HEAP32[i4 + 20 >> 2] = HEAP32[i5 >> 2];
  i5 = 1;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i4 + 20 >> 2] = -1;
 i5 = 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __GLOBAL__sub_I_artifacts_generated_webgl_runtime3_lump_cpp() {
 var i1 = 0;
 i1 = gb + 1098168 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1179080 >> 2] = 0;
 HEAP32[gb + 1179080 + 4 >> 2] = 0;
 HEAP32[gb + 1179080 + 8 >> 2] = 0;
 __ZN11MatrixStack5ResetEv(gb + 1179092 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1180120 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1181148 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1182176 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1182176 + 1028 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1184232 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1184232 + 1028 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1186288 | 0);
 __ZN11MatrixStack5ResetEv(gb + 1186288 + 1028 | 0);
 return;
}

function _ungetc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 do if ((i1 | 0) == -1) i1 = -1; else {
  if ((HEAP32[i4 + 76 >> 2] | 0) > -1) i5 = ___lockfile(i4) | 0; else i5 = 0;
  if (!(HEAP32[i4 + 8 >> 2] | 0)) {
   if (!(___toread(i4) | 0)) i2 = 6;
  } else i2 = 6;
  if ((i2 | 0) == 6) {
   i2 = i4 + 4 | 0;
   i3 = HEAP32[i2 >> 2] | 0;
   if (i3 >>> 0 > ((HEAP32[i4 + 44 >> 2] | 0) + -8 | 0) >>> 0) {
    i3 = i3 + -1 | 0;
    HEAP32[i2 >> 2] = i3;
    HEAP8[i3 >> 0] = i1;
    HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -17;
    if (!i5) break;
    ___unlockfile(i4);
    break;
   }
  }
  if (!i5) i1 = -1; else {
   ___unlockfile(i4);
   i1 = -1;
  }
 } while (0);
 return i1 | 0;
}

function _frexp(d1, i5) {
 d1 = +d1;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 52) | 0;
 getTempRet0() | 0;
 switch (i4 & 2047) {
 case 0:
  {
   if (d1 != 0.0) {
    d1 = +_frexp(d1 * 18446744073709551616.0, i5);
    i2 = (HEAP32[i5 >> 2] | 0) + -64 | 0;
   } else i2 = 0;
   HEAP32[i5 >> 2] = i2;
   break;
  }
 case 2047:
  break;
 default:
  {
   HEAP32[i5 >> 2] = (i4 & 2047) + -1022;
   HEAP32[tempDoublePtr >> 2] = i2;
   HEAP32[tempDoublePtr + 4 >> 2] = i3 & -2146435073 | 1071644672;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 }
 return +d1;
}

function __ZN9ProjectorC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 35316 + 8;
 HEAP32[i1 + 64 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN8LODGroup5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 i5 = HEAP32[i1 + 56 >> 2] | 0;
 i4 = i1 + 60 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i5 | 0)) return; else i2 = i1;
 while (1) {
  i1 = i2 + -28 | 0;
  HEAP32[i4 >> 2] = i1;
  i3 = i2 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i4 >> 2] | 0;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN5physx2Sc8ActorSim24postDominanceGroupChangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = i2 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) return;
 do {
  i1 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i1 + 21 >> 0] & 3) {
   i1 = __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE(i1) | 0;
   if (i1 | 0) {
    i3 = i1 + 4 | 0;
    HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 8;
    i3 = i1 + 6 | 0;
    if (!(HEAP16[i3 >> 1] & 2)) {
     __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i1);
     HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
    }
   }
  }
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return;
}

function __ZN5physx20updateLowSpeedTimersEPKfPf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 != Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i1 >> 2] = i4 ? f3 : Math_fround(0.0);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = i1 + 4 | 0;
 i5 = f3 != Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i4 >> 2] = i5 ? f3 : Math_fround(0.0);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i4 = i1 + 8 | 0;
 i5 = f3 != Math_fround(HEAPF32[i4 >> 2]);
 HEAPF32[i4 >> 2] = i5 ? f3 : Math_fround(0.0);
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i1 + 12 | 0;
 i1 = f3 != Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i2 >> 2] = i1 ? f3 : Math_fround(0.0);
 return;
}

function __ZN19ShaderPropertySheet18ReserveValueBufferEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 72 | 0;
 i4 = i1 + 88 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 4, i1 + 76 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 4, i1 + 76 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 84 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN11Rigidbody2D14RecreateJointsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = (__Z14IsWorldPlayingv() | 0) ^ 1;
 if (!i1) return;
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 64 >> 2] | 0;
  if (i2 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i4 | 0);
   i3 = HEAP32[i2 + 28 >> 2] | 0;
   if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0);
  }
 } while ((i1 | 0) != 0);
 return;
}

function __Z44UnityAnalyticsHandler_CUSTOM_SendCustomEventP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  if (i3 | 0) {
   if (!i2) {
    i4 = 1;
    STACKTOP = i5;
    return i4 | 0;
   }
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if (!i1) {
    i4 = 1;
    STACKTOP = i5;
    return i4 | 0;
   }
   i4 = __ZN14UnityAnalytics15SendCustomEventERN11UnityEngine9Analytics15UserCustomEventE(i1, i3) | 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1038915 | 0, i4);
 return 0;
}

function __Z43GUIStyleState_CUSTOM_INTERNAL_get_textColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3); else {
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 4 >> 2] = i6;
  HEAP32[i2 + 8 >> 2] = i5;
  HEAP32[i2 + 12 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __Z19DestroySingleObjectP6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i3 = i1 + 8 | 0;
 if (HEAP32[i3 >> 2] & 1048576 | 0) {
  i5 = __Z20GetPersistentManagerv() | 0;
  __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode(i5, HEAP32[i1 + 4 >> 2] | 0, 1);
 }
 __Z28delete_object_internal_step1P6Object(i1);
 i5 = HEAP32[i3 >> 2] & 2047;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 STACKTOP = i4;
 return;
}

function _SendMessageString(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i1 = __Z20scripting_string_newPKc(i1) | 0;
 i2 = __Z27FindActiveTransformWithPathPKc(i3) | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i3;
  _printf_console(gb + 363594 | 0, i6);
  STACKTOP = i7;
  return;
 }
 if (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i2 + 28 >> 2] | 0, i4, i1) | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 _printf_console(gb + 363530 | 0, i5);
 STACKTOP = i7;
 return;
}

function _fstat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 40 | 0;
 i4 = i7 + 8 | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = ___syscall197(197, i3 | 0) | 0;
 if ((i3 | 0) == -9) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = 1;
  if ((___syscall221(221, i4 | 0) | 0) < 0) i6 = 3; else {
   ___procfdname(i4, i1);
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = i2;
   i1 = ___syscall_ret(___syscall195(195, i5 | 0) | 0) | 0;
  }
 } else i6 = 3;
 if ((i6 | 0) == 3) i1 = ___syscall_ret(i3) | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function _addmntent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(_fseek(i1, 0, 2) | 0)) {
  i9 = HEAP32[i2 + 4 >> 2] | 0;
  i8 = HEAP32[i2 + 8 >> 2] | 0;
  i7 = HEAP32[i2 + 12 >> 2] | 0;
  i6 = HEAP32[i2 + 16 >> 2] | 0;
  i5 = HEAP32[i2 + 20 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = i9;
  HEAP32[i3 + 8 >> 2] = i8;
  HEAP32[i3 + 12 >> 2] = i7;
  HEAP32[i3 + 16 >> 2] = i6;
  HEAP32[i3 + 20 >> 2] = i5;
  i1 = (_fprintf(i1, gb + 1073885 | 0, i3) | 0) >>> 31;
 } else i1 = 1;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNSt3__215__num_get_floatIeEET_PKcS3_Rj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 if ((i2 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 4;
  d1 = 0.0;
 } else {
  i6 = ___errno_location() | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  d1 = +_strtold_l(i2, i5, __ZNSt3__26__clocEv() | 0);
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) HEAP32[i6 >> 2] = i7;
  if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) {
   if ((i2 | 0) == 34) HEAP32[i4 >> 2] = 4;
  } else {
   HEAP32[i4 >> 2] = 4;
   d1 = 0.0;
  }
 }
 STACKTOP = i8;
 return +d1;
}

function __ZNSt3__215__num_get_floatIdEET_PKcS3_Rj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d1 = 0.0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 if ((i2 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = 4;
  d1 = 0.0;
 } else {
  i6 = ___errno_location() | 0;
  i7 = HEAP32[i6 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  d1 = +_strtold_l(i2, i5, __ZNSt3__26__clocEv() | 0);
  i2 = HEAP32[i6 >> 2] | 0;
  if (!i2) HEAP32[i6 >> 2] = i7;
  if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) {
   if ((i2 | 0) == 34) HEAP32[i4 >> 2] = 4;
  } else {
   HEAP32[i4 >> 2] = 4;
   d1 = 0.0;
  }
 }
 STACKTOP = i8;
 return +d1;
}

function __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypej(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i2 = i6;
 if ((HEAP16[gb + 1469204 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469204 | 0, i1);
  i2 = gb + 1469204 | 0;
 } else i2 = 0;
 i1 = HEAP32[i3 + 204 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, i4 | 0, i5 | 0);
 if (!i2) {
  STACKTOP = i6;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i2);
 STACKTOP = i6;
 return;
}

function __ZN9dtNavMesh31connectOffMeshConnectionsToTileEP10dtMeshTile(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i3 = i4 + 48 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  i6 = i2 + (i1 * 104 | 0) + 24 | 0;
  if ((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i6 + 4 >> 2] | 0) == 0) i5 = 6; else {
   i6 = i2 + (i1 * 104 | 0) + 56 | 0;
   if ((HEAP32[i6 >> 2] | 0) == 0 & (HEAP32[i6 + 4 >> 2] | 0) == 0) i5 = 6;
  }
  if ((i5 | 0) == 6) {
   i5 = 0;
   __ZN9dtNavMesh24connectOffMeshConnectionEj(i4, i1);
   i2 = HEAP32[i3 >> 2] | 0;
  }
  i1 = HEAP32[i2 + (i1 * 104 | 0) + 96 >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN5physx25PxcSweepConvexHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 return Math_fround(__ZN5physxL27PxcSweepAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE(i8, i9, i1, i2, i11, i12, f7, i13, i14, i3, i4));
}

function __ZN4FMOD7Channel17set3DDopplerLevelEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAPF32[i2 + 148 >> 2] = f3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 858954;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN14GfxDeviceStats15SetScreenParamsEiiiiii(i5, i6, i7, i2, i3, i4, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i5 + 160 >> 2] = i6;
 HEAP32[i5 + 164 >> 2] = i7;
 if ((i3 | 0) > -1) HEAP32[i5 + 168 >> 2] = i3;
 if ((i2 | 0) > -1) HEAP32[i5 + 172 >> 2] = i2;
 if ((i4 | 0) > -1) HEAP32[i5 + 176 >> 2] = i4;
 i2 = i5 + 180 | 0;
 if ((i1 | 0) > -1) HEAP32[i2 >> 2] = i1; else i1 = HEAP32[i2 >> 2] | 0;
 i6 = Math_imul(i7, i6) | 0;
 i7 = Math_imul((HEAP32[i5 + 176 >> 2] | 0) + (HEAP32[i5 + 172 >> 2] | 0) | 0, (i1 | 0) < 1 ? 1 : i1) | 0;
 HEAP32[i5 + 184 >> 2] = Math_imul(i6, i7 + (HEAP32[i5 + 168 >> 2] | 0) | 0) | 0;
 return;
}

function __ZN12InputManager9GetAnyKeyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 56 >> 2] | 0;
 L1 : do if (i2 | 0) {
  i3 = HEAP32[i4 + 48 >> 2] | 0;
  i1 = 0;
  while (1) {
   if (HEAP32[i3 + (i1 << 2) >> 2] | 0) {
    i1 = 1;
    break;
   }
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  return i1 | 0;
 } while (0);
 i3 = HEAP32[i4 + 76 >> 2] | 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i4 + 68 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 << 2) >> 2] | 0) {
   i1 = 1;
   i2 = 9;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN11dtPathQueue4initEiiPK9dtNavMesh(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i6 = i3 + 228 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i6 >> 2] | 0);
 HEAP32[i6 >> 2] = 0;
 i5 = i3 + 48 | 0;
 __Z6dtFreePv(HEAP32[i5 >> 2] | 0);
 HEAP32[i5 >> 2] = 0;
 i2 = __Z19dtAllocNavMeshQueryPK9dtNavMeshi(i2, i1) | 0;
 HEAP32[i6 >> 2] = i2;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = i3 + 220 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = 0;
 i6 = __Z7dtAlloci(i4 << 3) | 0;
 HEAP32[i5 >> 2] = i6;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i3 + 56 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 224 >> 2] = 0;
 i6 = 1;
 return i6 | 0;
}

function __ZN11UnityEngine7Connect15AppInstallEvent12ToJsonStringER9JSONWrite(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i3, i4);
 i2 = i3 + 32 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 36 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1040512 | 0, 0);
 i2 = i3 + 48 | 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 52 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) return;
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i4, i2, gb + 1041407 | 0, 0);
 return;
}

function __ZN11TerrainData7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(368, i1, 16, gb + 1048932 | 0, 0, gb + 936995 | 0, 23) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11TerrainDataC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11LightProbes7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(192, i1, 16, gb + 1048932 | 0, 0, gb + 380189 | 0, 36) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11LightProbesC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11AudioSource7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(552, i1, 16, gb + 1048932 | 0, 0, gb + 874245 | 0, 38) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11AudioSourceC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZL22stbir__filter_mitchellff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 if (f1 < Math_fround(1.0)) {
  f2 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(f1 * Math_fround(21.0)) + Math_fround(-36.0))) + Math_fround(16.0)) / Math_fround(18.0));
  return Math_fround(f2);
 }
 if (!(f1 < Math_fround(2.0))) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(36.0) - Math_fround(f1 * Math_fround(7.0)))) + Math_fround(-60.0))) + Math_fround(32.0)) / Math_fround(18.0));
 return Math_fround(f2);
}

function __GLOBAL__sub_I_runtime_particlesystem_modules3_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452280 | 0, gb + 615669 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451728 | 0, gb + 615707 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451740 | 0, gb + 615734 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452292 | 0, gb + 615763 | 0, 7, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452104 | 0, gb + 615797 | 0, 7, 0);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK7Joint2D16GetReactionForceEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (f3 < Math_fround(.0000999999974) | (i1 | 0) == 0) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  STACKTOP = i5;
  return;
 } else {
  mftCall_viif(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i1 | 0, +Math_fround(Math_fround(1.0) / f3));
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  STACKTOP = i5;
  return;
 }
}

function __ZN7ApiGLES14TextureSwizzleEj16TextureDimensionN2gl18TextureSwizzleFuncE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i1 + 860 | 0;
 i3 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i2 >> 2] | 0, i3) | 0;
 i4 = __ZNK13TranslateGLES17GetTextureSwizzleEN2gl18TextureSwizzleFuncE(HEAP32[i2 >> 2] | 0, i4) | 0;
 i2 = i1 + 180 | 0;
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 36418, HEAP32[i4 >> 2] | 0);
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 36419, HEAP32[i4 + 4 >> 2] | 0);
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 36420, HEAP32[i4 + 8 >> 2] | 0);
 mftCall_viii(HEAP32[i2 >> 2] | 0, i3 | 0, 36421, HEAP32[i4 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Sc9ClothCore18addCollisionConvexEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i8 = i3 + 8 | 0;
 i7 = i3;
 HEAP32[i8 >> 2] = i1;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 188 >> 2] | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i7 + 4 >> 2] = i8 + 4;
 i2 = i2 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx19PxClothFabricCookerC2ERKNS_15PxClothMeshDescERKNS_6PxVec3Eb(i5, i3, i4, i6) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i8;
 i2 = __Znwj(76) | 0;
 i7 = i2;
 i9 = i7 + 76 | 0;
 do {
  HEAP32[i7 >> 2] = 0;
  i7 = i7 + 4 | 0;
 } while ((i7 | 0) < (i9 | 0));
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 __ZN5physx18PxFabricCookerImpl4cookERKNS_15PxClothMeshDescENS_6PxVec3Eb(i2, i3, i1, i6) | 0;
 STACKTOP = i8;
 return;
}

function __ZN4File5WriteEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = __ZN12FileAccessor5WriteEyPKvPy(HEAP32[i1 + 4 >> 2] | 0, i3, 0, i2, i5) | 0;
 i2 = i5;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i1 + 8 | 0;
 i8 = i1;
 i8 = _i64Add(HEAP32[i8 >> 2] | 0, HEAP32[i8 + 4 >> 2] | 0, i5 | 0, i2 | 0) | 0;
 i7 = getTempRet0() | 0;
 HEAP32[i1 >> 2] = i8;
 HEAP32[i1 + 4 >> 2] = i7;
 STACKTOP = i4;
 return i6 & ((i5 | 0) == (i3 | 0) & (i2 | 0) == 0) | 0;
}

function __ZN21UnityWebStream_Static14WriteBigEndianERNSt3__26vectorIhNS0_9allocatorIhEEEEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3 + 4 | 0;
 i6 = i3;
 HEAP32[i4 >> 2] = _llvm_bswap_i32(i2 | 0) | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZNSt3__26vectorIhNS_9allocatorIhEEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKhEES7_S7_(i1, i5, i4, i4 + 4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN18AwakeFromLoadQueue9IsInQueueER6Object(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = __ZN18AwakeFromLoadQueue19DetermineQueueIndexEPKN5Unity4TypeER6Object(0, HEAP32[gb + 1106156 + 4 + ((HEAP32[i3 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0, 0) | 0;
 i5 = HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + (i2 * 20 | 0) >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i2 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN16UnityAdsSettingsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN19BaseConnectSettingsC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 189284 + 8;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZN16UnityAdsSettings18InitializeDefaultsEv(i1);
 return;
}

function __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 279 >> 0] = i5 & 1;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 i4 = i1 + 92 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) return;
 i2 = i1 + 80 | 0;
 i1 = 0;
 do {
  i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, gb + 80300 | 0) | 0;
  if (i3 | 0) __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b(i3, i5);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 return;
}

function __ZN13TrailRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 384 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i3 + 8 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 344 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13SliderJoint2D7CleanupEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 do if (i1) {
  HEAP8[i3 + 119 >> 0] = 0;
  i1 = i3 + 60 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return;
 } else {
  i1 = i3 + 60 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) return; else {
   HEAP32[i3 + 120 >> 2] = HEAP32[i2 + 100 >> 2];
   HEAP8[i3 + 119 >> 0] = 1;
   break;
  }
 } while (0);
 HEAP8[i3 + 52 >> 0] = 0;
 __ZN7b2World12DestroyJointEP7b2Joint(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 if (__Z14IsWorldPlayingv() | 0) return;
 __ZN16b2ContactManager20FlushPendingContactsEv((HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102872 | 0);
 return;
}

function __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper7popNameEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 i3 = HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + (i3 + -1 << 2) >> 2] | 0;
 HEAP8[i1 >> 0] = 0;
 __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i4 + 12 | 0, i3, i1);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 HEAP8[(HEAP32[i4 + 24 >> 2] | 0) + (i1 + -1) >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN10TagManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(1084, i1, 16, gb + 1048932 | 0, 0, gb + 373245 | 0, 75) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10TagManagerC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z35DoesComponentAllowMultipleInclusioni(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 __Z25InitComponentRequirementsv();
 i5 = (HEAP32[gb + 1162552 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i1 = i5;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >= (i4 | 0)) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) != (i5 | 0)) if ((HEAP32[i1 + 16 >> 2] | 0) <= (i4 | 0)) {
   i4 = i1;
   i5 = (i4 | 0) != (i5 | 0);
   return i5 | 0;
  }
 }
 i4 = i5;
 i5 = (i4 | 0) != (i5 | 0);
 return i5 | 0;
}

function __Z25InitializeLODGroupManagerPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 8 | 0;
 i4 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, gb + 63536 | 0, 16, gb + 425297 | 0, gb + 1576256 | 0, gb + 425023 | 0, 48) | 0;
 i7 = gb + 63536 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN15LODGroupManagerC2E10MemLabelId(i2, i3);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1161200 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 128 >> 0] = 0;
 do if (i2 | 0) {
  __THREW__ = 0;
  invoke_vii(fb + 4565 | 0, i1 | 0, i2 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i1);
   ___resumeException(i3 | 0);
  } else {
   __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2);
   break;
  }
 } while (0);
 return;
}

function __ZNK5physx18PxFabricCookerImpl13getDescriptorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 12 >> 2] = (HEAP32[i2 + 20 >> 2] | 0) + -1;
 HEAP32[i1 + 16 >> 2] = (HEAP32[i2 + 16 >> 2] | 0) + 4;
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 64 >> 2];
 return;
}

function __ZNK16ParticleAnimator17GetColorAnimationEP10ColorRGBAf(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, f4 = f0, f5 = f0, f6 = f0, i7 = 0;
 i1 = 0;
 do {
  i7 = HEAP32[i2 + 88 + (i1 << 2) >> 2] | 0;
  f6 = Math_fround(Math_fround((i7 & 65535) >>> 8 & 255) / Math_fround(255.0));
  f5 = Math_fround(Math_fround(i7 >>> 16 & 255) / Math_fround(255.0));
  f4 = Math_fround(Math_fround(i7 >>> 24 & 255) / Math_fround(255.0));
  HEAPF32[i3 + (i1 << 4) >> 2] = Math_fround(Math_fround(i7 & 255) / Math_fround(255.0));
  HEAPF32[i3 + (i1 << 4) + 4 >> 2] = f6;
  HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f5;
  HEAPF32[i3 + (i1 << 4) + 12 >> 2] = f4;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 5);
 return;
}

function __ZN6SkyboxC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 35844 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN6Object22CheckInstanceIDsLoadedEPii(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if ((i3 | 0) <= 0) {
  STACKTOP = i6;
  return;
 }
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_(i4, HEAP32[gb + 1104264 >> 2] | 0, i5);
  if ((HEAP32[i4 >> 2] | 0) != -1) HEAP32[i5 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN5physx19PxsFluidSpatialHashC2Ejfjb(i5, i3, f2, i1, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAPF32[i5 + 12 >> 2] = f2;
 HEAP32[i5 + 16 >> 2] = i1;
 i1 = i5 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6 + 1 | 0, (i3 << 4) + 16 | 0, gb + 769126 | 0, 38) | 0;
 if (!i4) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i1 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i6, i3 * 216 | 0, gb + 769126 | 0, 41) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5Unity5Cloth7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(384, i1, 16, gb + 1048932 | 0, 0, gb + 839455 | 0, 37) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN5Unity5ClothC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBuffer15ReadNextPayloadEPhi(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i6 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i6 + 16 >> 2] | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 i1 = (HEAP32[i6 >> 2] | 0) + i5 | 0;
 i3 = (HEAP32[i1 >> 2] | 0) + 3 & -4;
 i1 = i1 + 4 | 0;
 i2 = (HEAP32[i6 + 4 >> 2] | 0) - i1 | 0;
 i2 = i3 >>> 0 < i2 >>> 0 ? i3 : i2;
 if (i2 | 0) _memcpy(i7 | 0, i1 | 0, i2 | 0) | 0;
 i1 = i3 - i2 | 0;
 if ((i1 | 0) > 0) _memcpy(i7 + i2 | 0, HEAP32[i6 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i6 + 8 >> 2] | 0) + -1 & i5 + 4 + i3;
 i7 = 1;
 return i7 | 0;
}

function __ZN24AudioScriptBufferManager17GetDSPFilterArrayEjRP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = i1 + 12 | 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i1 >> 2] | 0) | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  return;
 } else {
  i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i1 >> 2] | 0, 0, 4) | 0;
  i1 = (i4 | 0) == 0 ? 0 : i2;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0, i4 | 0, i1 << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 128 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 124 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12LineRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 344 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i3 + 8 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 348 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z16ShouldUseShadowsb(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 f2 = Math_fround(__ZN15QualitySettings29GetShadowDistanceForRenderingEv());
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 116 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __Z15GetGraphicsCapsv() | 0;
 if (!(HEAP8[i3 + 502 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP8[i3 + 500 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i3 + 488 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __Z18GetQualitySettingsv() | 0;
 if (!(HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = f2 > Math_fround(0.0) | i1 ^ 1;
 return i3 | 0;
}

function _UNITY_TT_Save_Context(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 + 116 >> 2] = HEAP32[i1 + 396 >> 2];
 HEAP32[i2 + 128 >> 2] = HEAP32[i1 + 408 >> 2];
 HEAP32[i2 + 140 >> 2] = HEAP32[i1 + 420 >> 2];
 HEAP32[i2 + 144 >> 2] = HEAP32[i1 + 424 >> 2];
 i3 = i1 + 444 | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 148 | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 i5 = i1 + 452 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 156 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i3 = i1 + 460 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 164 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function _ms_seek(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 if (i2 >>> 0 > 2) i6 = 2; else {
  HEAP32[i3 >> 2] = 0;
  i4 = i1 + 8 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 16 >> 2];
  i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  if ((i5 | 0) < (0 - i1 | 0) | (2147483647 - i1 | 0) < (i5 | 0)) i6 = 2; else {
   i1 = i1 + i5 | 0;
   HEAP32[i4 >> 2] = i1;
  }
 }
 if ((i6 | 0) == 2) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function _fchmod(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7 + 40 | 0;
 i4 = i7 + 8 | 0;
 i3 = i7;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = ___syscall94(94, i3 | 0) | 0;
 if ((i3 | 0) == -9) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = 1;
  if ((___syscall221(221, i4 | 0) | 0) < 0) i6 = 3; else {
   ___procfdname(i4, i1);
   HEAP32[i5 >> 2] = i4;
   HEAP32[i5 + 4 >> 2] = i2;
   i1 = ___syscall_ret(___syscall15(15, i5 | 0) | 0) | 0;
  }
 } else i6 = 3;
 if ((i6 | 0) == 3) i1 = ___syscall_ret(i3) | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZNKSt3__211__libcpp_db17__dereferenceableEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i2) | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
    ___resumeException(i2 | 0);
   }
  }
 }
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return i1 | 0;
}

function __ZN7mecanim5human21ComputeHierarchicMassEiPf(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var f1 = f0, i2 = 0, i3 = 0, i6 = 0;
 i3 = HEAP32[gb + 178764 + (i4 << 2) >> 2] | 0;
 i6 = i5 + (i4 << 2) | 0;
 HEAP32[i6 >> 2] = i3;
 f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if (i4 >>> 0 >= 17) return Math_fround(f1);
 i3 = HEAP32[gb + 183736 + (i4 << 4) >> 2] | 0;
 i2 = 0;
 do {
  i2 = i2 + 1 | 0;
  f1 = Math_fround(__ZN7mecanim5human21ComputeHierarchicMassEiPf(HEAP32[gb + 183736 + (i4 << 4) + (i2 << 2) >> 2] | 0, i5));
  f1 = Math_fround(f1 + Math_fround(HEAPF32[i6 >> 2]));
  HEAPF32[i6 >> 2] = f1;
 } while ((i2 | 0) < (i3 | 0));
 return Math_fround(f1);
}

function __ZN7Terrain15SetMaterialTypeENS_12MaterialTypeE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i2 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i1 >> 2] = i4;
 i3 = HEAP32[i2 + 112 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 if ((i4 | 0) == 3) i1 = HEAP32[i2 + 108 >> 2] | 0; else i1 = 0;
 HEAP32[i5 >> 2] = i1;
 __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc(i3, i5, (i4 | 0) == 0 ? gb + 184364 | 0 : (i4 | 0) == 2 ? gb + 184340 | 0 : gb + 184352 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5physx16PxVehicleNoDrive15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 44 | 0;
 i3 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i6 >> 2] | 0) | 0;
 i4 = i1 + 4 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + 15 & -16;
 HEAP32[i4 >> 2] = i5 + i3;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i2, i5, HEAP32[i6 >> 2] | 0, HEAP32[i2 + 48 >> 2] | 0, 0) | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + 15 & -16;
 i3 = i5;
 i1 = HEAP32[i6 >> 2] | 0;
 HEAP32[i2 + 128 >> 2] = i5;
 HEAP32[i2 + 132 >> 2] = i3 + (i1 << 4);
 HEAP32[i4 >> 2] = i3 + (i1 * 48 | 0);
 HEAP32[i2 + 136 >> 2] = i3 + (i1 << 5);
 return;
}

function __ZN4File5WriteEyPKvj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 i8 = __ZN12FileAccessor5WriteEyyPKvPy(HEAP32[i1 + 4 >> 2] | 0, i2, i3, i5, 0, i4, i7) | 0;
 i4 = i7;
 i7 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i9 = _i64Add(i7 | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 i2 = getTempRet0() | 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = i9;
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i6;
 return i8 & ((i7 | 0) == (i5 | 0) & (i4 | 0) == 0) | 0;
}

function __ZN10GameObject7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(80, i1, 16, gb + 1048932 | 0, 0, gb + 369816 | 0, 97) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __Z45ParticleSystem_Set_Custom_PropSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem18SetSimulationSpaceE29ParticleSystemSimulationSpace(i3, i2);
  return;
 }
}

function __Z45AnimationClip_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 272 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
  HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  return;
 }
}

function __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__ZL35LoadMemoryBufferIntoTextureInternalR9Texture2DPKhj20LoadImageCompressionb(i5, i1, i2, i3, i4) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i5 + 52 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i5 + 92 >> 2] | 0;
  i1 = (i1 | 0) == -1 ? 5 : i1;
 } else i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) {
  mftCall_vi(HEAP32[i2 + 196 >> 2] | 0, i5 | 0);
  i5 = 1;
  return i5 | 0;
 } else {
  mftCall_vi(HEAP32[i2 + 192 >> 2] | 0, i5 | 0);
  i5 = 1;
  return i5 | 0;
 }
 return 0;
}

function __ZNKSt3__220__time_get_c_storageIwE3__xEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099896 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099896 | 0) | 0) {
  HEAP32[gb + 1475452 >> 2] = 0;
  HEAP32[gb + 1475452 + 4 >> 2] = 0;
  HEAP32[gb + 1475452 + 8 >> 2] = 0;
  __THREW__ = 0;
  i1 = invoke_ii(fb + 2806 | 0, gb + 210072 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_viii(fb + 1041 | 0, gb + 1475452 | 0, gb + 210072 | 0, i1 | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) break;
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return gb + 1475452 | 0;
}

function __ZNKSt3__220__time_get_c_storageIwE3__rEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099904 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099904 | 0) | 0) {
  HEAP32[gb + 1475464 >> 2] = 0;
  HEAP32[gb + 1475464 + 4 >> 2] = 0;
  HEAP32[gb + 1475464 + 8 >> 2] = 0;
  __THREW__ = 0;
  i1 = invoke_ii(fb + 2806 | 0, gb + 210108 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_viii(fb + 1041 | 0, gb + 1475464 | 0, gb + 210108 | 0, i1 | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) break;
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return gb + 1475464 | 0;
}

function __ZNKSt3__220__time_get_c_storageIwE3__cEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099912 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099912 | 0) | 0) {
  HEAP32[gb + 1475476 >> 2] = 0;
  HEAP32[gb + 1475476 + 4 >> 2] = 0;
  HEAP32[gb + 1475476 + 8 >> 2] = 0;
  __THREW__ = 0;
  i1 = invoke_ii(fb + 2806 | 0, gb + 210156 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_viii(fb + 1041 | 0, gb + 1475476 | 0, gb + 210156 | 0, i1 | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) break;
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return gb + 1475476 | 0;
}

function __ZNKSt3__220__time_get_c_storageIwE3__XEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if (!(HEAP8[gb + 1099888 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099888 | 0) | 0) {
  HEAP32[gb + 1475440 >> 2] = 0;
  HEAP32[gb + 1475440 + 4 >> 2] = 0;
  HEAP32[gb + 1475440 + 8 >> 2] = 0;
  __THREW__ = 0;
  i1 = invoke_ii(fb + 2806 | 0, gb + 210036 | 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (!(i2 & 1)) {
   __THREW__ = 0;
   invoke_viii(fb + 1041 | 0, gb + 1475440 | 0, gb + 210036 | 0, i1 | 0);
   i2 = __THREW__;
   __THREW__ = 0;
   if (!(i2 & 1)) break;
  }
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } while (0);
 return gb + 1475440 | 0;
}

function __ZNKSt3__211__libcpp_db15__decrementableEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i1, i2) | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 0; else {
   __THREW__ = 0;
   i1 = invoke_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0) | 0;
   i2 = __THREW__;
   __THREW__ = 0;
   if (i2 & 1) {
    i2 = ___cxa_find_matching_catch_2() | 0;
    getTempRet0() | 0;
    __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
    ___resumeException(i2 | 0);
   }
  }
 }
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return i1 | 0;
}

function __ZN8Animator23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN14DirectorPlayer8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 104 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 108 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx2Sc10NPhaseCore9visualizeERNS_2Cm12RenderOutputE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (Math_fround(HEAPF32[i1 + 1408 >> 2]) == Math_fround(0.0)) return;
 i1 = HEAP32[i1 + 1204 >> 2] | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 i5 = i2 + (i1 << 2) | 0;
 if ((i1 | 0) <= 0) return;
 i3 = i2 + (i1 + -1 << 2) | 0;
 i4 = i2;
 i1 = i2 + 16 | 0;
 do {
  if (i1 >>> 0 <= i3 >>> 0) i1 = i1 + 4 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  __ZN5physx2Sc19ShapeInstancePairLL9visualizeERNS_2Cm12RenderOutputE((i2 | 0) == 0 ? 0 : i2 + -8 | 0, i6);
  i4 = i4 + 4 | 0;
 } while (i4 >>> 0 < i5 >>> 0);
 return;
}

function __ZN5Umbra9BitVectorC2EjPNS_9AllocatorE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i2 >> 2] = gb + 1451688;
  i1 = gb + 1451688 | 0;
 }
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 i4 = i2 + 8 | 0;
 i2 = (i3 + 31 | 0) >>> 5;
 HEAP32[i4 >> 2] = i2;
 if (!i2) return;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i2 << 2) + 16 | 0, 0) | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  i1 = i1 + 16 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 return;
}

function __ZN4HaloC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 33384 + 8;
 HEAP32[i1 + 44 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN4FMOD12ChannelGroup9setVolumeEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAPF32[i2 + 44 >> 2] = f3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 856117;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13LoadOperation19IntegrateMainThreadEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 i3 = i3 + 140 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (HEAP8[i2 + 4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 8 | 0);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z45AnimationClip_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 272 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  return;
 }
}

function __Z44Rigidbody2D_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D15SetCenterOfMassERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function _UNITY_FT_Outline_Done(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i2 = 33;
  return i2 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = 20;
  return i2 | 0;
 }
 if (!i1) {
  i2 = 6;
  return i2 | 0;
 }
 if (HEAP32[i2 + 16 >> 2] & 1 | 0) {
  i3 = i2 + 4 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 8 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 12 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i3 = 0;
 return i3 | 0;
}

function _strtox(i6, i7, i1) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, i3 = 0, i4 = 0, i5 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i3 = i5;
 i4 = i3 + 112 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i6;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i5 + 44 >> 2] = i6;
 HEAP32[i5 + 76 >> 2] = -1;
 ___shlim(i5, 0);
 d2 = +___floatscan(i5, i1, 1);
 i1 = (HEAP32[i3 >> 2] | 0) - (HEAP32[i4 >> 2] | 0) + (HEAP32[i5 + 108 >> 2] | 0) | 0;
 if (i7 | 0) HEAP32[i7 >> 2] = i1 | 0 ? i6 + i1 | 0 : i6;
 STACKTOP = i8;
 return +d2;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwner7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i1 + -8 | 0;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i4 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i4;
  if (i4 | 0) {
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
   return;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 return;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwner7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i1 + -4 | 0;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i4 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i4;
  if (i4 | 0) {
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
   return;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx18PxcConvexTrianglesC2ERKNS_24PxTriangleMeshGeometryLLERKNS_2Cm23FastVertex2ShapeScalingEPKjjPj(i6, i1, i3, i5, i2, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i5;
 HEAP32[i6 + 12 >> 2] = i2;
 HEAP32[i6 + 16 >> 2] = i4;
 HEAP32[i6 + 40 >> 2] = 2122317823;
 HEAP32[i6 + 44 >> 2] = 2122317823;
 HEAP32[i6 + 48 >> 2] = 2122317823;
 HEAP32[i6 + 52 >> 2] = -25165825;
 HEAP32[i6 + 56 >> 2] = -25165825;
 HEAP32[i6 + 60 >> 2] = -25165825;
 i6 = i6 + 64 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP8[i6 + 12 >> 0] = 0;
 return;
}

function __ZN5physx13PxParticleExt15createIndexPoolEj(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i4 | 0, i3 | 0, 20, (i1 ? gb + 745147 | 0 : gb + 837976 | 0) | 0, gb + 666952 | 0, 327) | 0;
 HEAP32[i1 >> 2] = gb + 88176 + 8;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i2) return i1 | 0;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1 + 8 | 0, i2);
 return i1 | 0;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBuffer16CopyDataToBufferEP26AtomicCircularBufferHandlePhii(i5, i1, i7, i2, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 + i2 | 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if (i3 >>> 0 < i1 >>> 0) {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i2 - i3 + (HEAP32[i5 + 8 >> 2] | 0) | 0;
  i1 = i1 >>> 0 > i6 >>> 0 ? i6 : i1;
  if (!i1) i4 = 0; else {
   _memcpy(i3 | 0, i7 | 0, i1 | 0) | 0;
   i4 = i1;
   i2 = HEAP32[i5 >> 2] | 0;
  }
 } else {
  i4 = 0;
  i2 = (HEAP32[i5 >> 2] | 0) + (i1 - i3) | 0;
 }
 i1 = i6 - i4 | 0;
 if ((i1 | 0) <= 0) return;
 _memcpy(i2 | 0, i7 + i4 | 0, i1 | 0) | 0;
 return;
}

function __ZN2UI6Canvas7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(444, i1, 16, gb + 1048932 | 0, 0, gb + 1012716 | 0, 27) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN2UI6CanvasC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN2UI6Canvas22CalculateMinBucketSizeEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, f4 = f0, f5 = f0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28980 | 0) | 0;
 if (!i1) {
  i2 = 120;
  i1 = (i2 | 0) > 1;
  i2 = i1 ? i2 : 1;
  return i2 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 160 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 164 >> 2]);
 i1 = i2;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 f5 = Math_fround(HEAPF32[i1 + 404 >> 2]);
 i2 = f5 == Math_fround(0.0);
 f5 = i2 ? Math_fround(.100000001) : f5;
 i2 = ~~Math_fround((f4 >= f3 ? f4 : f3) * f5);
 i1 = (i2 | 0) > 1;
 i2 = i1 ? i2 : 1;
 return i2 | 0;
}

function __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 96 | 0;
 i5 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i5 = i1 + 200 | 0;
 i4 = i1 + 224 | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 HEAP32[i1 + 208 >> 2] = i2;
 return;
}

function __ZN10HumanTrait11RightFinger11GetBoneNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 908422 | 0, 6);
 if (i2 >>> 0 >= 15) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj((i2 >>> 0) / 3 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand12PhalangeNameEj((i2 >>> 0) % 3 | 0) | 0) | 0;
 return;
}

function __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f(i4, f1, f5, f2, i6) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 f5 = Math_fround(f5);
 f2 = Math_fround(f2);
 i6 = i6 | 0;
 var f3 = f0;
 HEAPF32[i6 >> 2] = Math_fround(Math_fround(1.0) - f1);
 if (f2 > Math_fround(0.0)) {
  f1 = Math_fround(f2 - Math_fround(f5 * Math_fround(.200000003)));
  f3 = Math_fround(Math_fround(1.0) / Math_fround(f2 - f1));
  f2 = Math_fround(-Math_fround(f1 * f3));
  f1 = Math_fround(Math_fround(__ZNK6Camera6GetFarEv(i4)) / f5);
 } else {
  f2 = Math_fround(1.0);
  f3 = Math_fround(0.0);
  f1 = Math_fround(inf);
 }
 HEAPF32[i6 + 4 >> 2] = f1;
 HEAPF32[i6 + 8 >> 2] = f3;
 HEAPF32[i6 + 12 >> 2] = f2;
 return;
}

function __Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 12 | 0;
 i4 = i2;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i4, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = __ZNK15FileSystemEntry12FolderExistsEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function _UNITY_png_create_write_struct_2(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = _UNITY_png_create_png_struct(i1, i2, i3, i4, i5, i6, i7) | 0;
 if (!i1) return i1 | 0;
 HEAP32[i1 + 280 >> 2] = 8192;
 HEAP32[i1 + 300 >> 2] = 1;
 HEAP32[i1 + 284 >> 2] = -1;
 HEAP32[i1 + 296 >> 2] = 8;
 HEAP32[i1 + 292 >> 2] = 15;
 HEAP32[i1 + 288 >> 2] = 8;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = -1;
 HEAP32[i1 + 316 >> 2] = 8;
 HEAP32[i1 + 312 >> 2] = 15;
 HEAP32[i1 + 308 >> 2] = 8;
 i7 = i1 + 208 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 2097152;
 _UNITY_png_set_write_fn(i1, 0, 0, 0);
 return i1 | 0;
}

function __ZN9Animation7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(332, i1, 16, gb + 1048932 | 0, 0, gb + 907178 | 0, 86) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN9AnimationC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx8debugger4comm19AddProfileZoneEvent9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 i2 = i2 + 22 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP8[i2 >> 0] = (HEAP8[i4 >> 0] | 0) != 0 & 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpScene20removeParticleSystemERNS_16NpParticleSystemE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i1 + 16 | 0, i5 + 20 | 0, 0);
 i6 = i1 + 3640 | 0;
 i3 = i1 + 3644 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
 return;
}

function __ZN5IMGUI9GUIWindowD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN11UTF16StringD2Ev(i3 + 92 | 0);
 __ZN11UTF16StringD2Ev(i3 + 72 | 0);
 i1 = i3 + 28 | 0;
 if ((HEAP32[i3 + 44 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 32 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0) | 0)) {
  i2 = 8;
  return i2 | 0;
 }
 i4 = (HEAP32[i2 + 92 >> 2] | 0) + 16 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i3 | 0) == 0 ? 0 : i4 + i3 | 0, i1) | 0;
 if ((i1 | 0) == -1) {
  i4 = 4;
  return i4 | 0;
 }
 i4 = HEAP32[i2 + 84 >> 2] | 0;
 i4 = (HEAP32[(HEAP32[(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 96 >> 2] | 0, i4 | 0) | 0) + 36 >> 2] | 0) + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0) == -1;
 i4 = i4 ? 1 : 16;
 return i4 | 0;
}

function __ZN25MinMaxOptimizedPolyCurves20FindMinMaxIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv(i7, i2 + 40 | 0);
 __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv(i6, i2);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(_fminf(f5, Math_fround(HEAPF32[i6 >> 2])));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(_fmaxf(f4, Math_fround(HEAPF32[i6 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN21SystemInfoStringCache16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63216 | 0, 16, gb + 363444 | 0, 35) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[gb + 1103748 >> 2] = i1;
 return;
}

function __ZN20UnityConnectSettings17InitializeSettingER19BaseConnectSettings(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 168 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 172 >> 2] | 0)) __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 164 | 0, i3); else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0);
 STACKTOP = i6;
 return;
}

function __ZN13WebCamTexture4PlayEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 120 | 0;
 do if (!(HEAP8[i4 >> 0] | 0)) {
  if (_JS_WebCam_IsSupported() | 0) {
   i5 = __ZNK13WebCamTexture25GetDeviceIdFromDeviceListERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i3 + 108 | 0) | 0;
   if ((i5 | 0) != -1) {
    _JS_WebCamVideo_Start(i5 | 0);
    i2 = i3 + 124 | 0;
    i1 = HEAP32[i2 >> 2] | 0;
    if (!i1) {
     i1 = __Znwj(4) | 0;
     HEAP32[i1 >> 2] = 0;
     HEAP32[i2 >> 2] = i1;
    }
    HEAP32[i1 >> 2] = i5;
    HEAP8[i4 >> 0] = 1;
    break;
   }
  }
  if (!(HEAP8[i4 >> 0] | 0)) return;
 } while (0);
 HEAP8[i3 + 92 >> 0] = 1;
 return;
}

function __ZN12b2BroadPhase9MoveProxyEiRK6b2AABBRK6b2Vec2(i4, i6, i1, i2) {
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 if (!(__ZN13b2DynamicTree9MoveProxyEiRK6b2AABBRK6b2Vec2(i4, i6, i1, i2) | 0)) return;
 i5 = i4 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 36 | 0;
 i2 = i4 + 32 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 << 1;
  i1 = __Z7b2Alloci(i1 << 3) | 0;
  HEAP32[i2 >> 2] = i1;
  _memcpy(i1 | 0, i4 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  __Z6b2FreePv(i4);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i6;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper18addPropertyMessageERKN5physx8debugger14NamespacedNameES5_j(i6, i3, i5, i4) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = HEAP32[i6 + 100 >> 2] | 0;
 if (!i2) {
  STACKTOP = i7;
  return;
 }
 i8 = (HEAP32[i6 + 4 >> 2] | 0) + 4 | 0;
 i9 = HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0;
 i6 = HEAP32[i6 + 96 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 4 >> 2] = i6 + (i2 * 20 | 0);
 mftCall_iiiiii(i9 | 0, i8 | 0, i3 | 0, i5 | 0, i1 | 0, i4 | 0) | 0;
 STACKTOP = i7;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwnerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 148996 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i1 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i1 + 44 >> 2] = gb + 148172 + 8;
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 28 >> 2] = gb + 148172 + 8;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12CachedReader21LockCacheBlockBoundedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i7 = HEAP32[i1 + 12 >> 2] | 0;
 i6 = i1 + 16 | 0;
 i5 = i1 + 4 | 0;
 i3 = i1 + 8 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 12 >> 2] | 0, i7 | 0, HEAP32[i6 >> 2] | 0, i5 | 0, i3 | 0);
 i1 = (HEAP32[i1 + 28 >> 2] | 0) - (Math_imul(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[(i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0 ? i4 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN11TextureData17GetImageReferenceEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i3 = Math_imul(HEAP32[i2 + 4 >> 2] | 0, i3) | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + i3 | 0;
 i7 = i2 + 8 | 0;
 i5 = i2 + 12 | 0;
 i6 = i2 + 20 | 0;
 i3 = i3 + (__Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i7 >> 2] | 0, HEAP32[i5 >> 2] | 0, HEAP32[i6 >> 2] | 0, i4) | 0) | 0;
 i2 = HEAP32[i7 >> 2] >> i4;
 i2 = (i2 | 0) < 1 ? 1 : i2;
 i5 = HEAP32[i5 >> 2] >> i4;
 i4 = HEAP32[i6 >> 2] | 0;
 __ZN14ImageReferenceC2Eiii13TextureFormatPv(i1, i2, (i5 | 0) < 1 ? 1 : i5, Math_imul(HEAP32[gb + 45784 + (i4 << 2) >> 2] | 0, i2) | 0, i4, i3);
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 440 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 436 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 30912 | 0) | 0;
 if (i1 | 0) {
  HEAP32[i1 + 376 >> 2] = HEAP32[i4 >> 2];
  __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106136 | 0, i3);
 STACKTOP = i5;
 return;
}

function __ZN10HumanTrait10LeftFinger11GetBoneNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 908416 | 0, 5);
 if (i2 >>> 0 >= 15) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj((i2 >>> 0) / 3 | 0) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand12PhalangeNameEj((i2 >>> 0) % 3 | 0) | 0) | 0;
 return;
}

function __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D12MovePositionERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z26Transform_CUSTOM_IsChildOfP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else return (__Z22IsChildOrSameTransformR9TransformS0_(i3, i1) | 0) & 1 | 0;
 return 0;
}

function __Z25Event_Get_Custom_PropTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i2 = __Z19GetSpecificGUIStatei(HEAP32[i1 + 40 >> 2] | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4 + 8 | 0); else {
  i3 = __ZN5IMGUI12GetEventTypeERK8GUIStateRK10InputEvent(i2, i1) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function ___setxid(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[i5 + 12 >> 2] = i4;
 i1 = i5 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i5 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 switch (i4 | 0) {
 case 208:
 case 203:
 case 213:
  {
   HEAP32[i1 >> 2] = 1;
   break;
  }
 default:
  {}
 }
 ___synccall(fb + 3995 | 0, i5);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[(___errno_location() | 0) >> 2] = i1;
  i1 = -1;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__215__get_classnameEPKcb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = gb + 215180 | 0;
 i2 = 15;
 while (1) {
  if (!i2) break;
  i5 = (i2 | 0) / 2 | 0;
  i7 = i1 + (i5 << 3) | 0;
  i6 = (_strcmp(HEAP32[i7 >> 2] | 0, i3) | 0) < 0;
  i1 = i6 ? i7 + 8 | 0 : i1;
  i2 = i6 ? i2 + -1 - i5 | 0 : i5;
 }
 do if ((i1 | 0) == (gb + 215180 + 120 | 0)) i1 = 0; else if (!(_strcmp(i3, HEAP32[i1 >> 2] | 0) | 0)) {
  i1 = HEAP16[i1 + 4 >> 1] | 0;
  i2 = i1 & 65535;
  if (i1 << 16 >> 16 == 128) {
   i1 = (i2 | 3840) & 65535;
   break;
  }
  if (!((i2 & 768 | 0) == 0 | i4 ^ 1)) i1 = (i2 | 1024) & 65535;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __ZNK8TypeTree13DumpToConsoleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i2 + 16 | 0;
 i5 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZNK16TypeTreeIterator10DebugPrintERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i5, i3, 0);
 HEAP32[i4 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 _printf_console(gb + 1076431 | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13getPropertiesEN5physx8debugger18NonNegativeIntegerEPNS2_19PropertyDescriptionEjj(i5, i1, i3, i2, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i6 + 8 | 0;
 i8 = i6 + 4 | 0;
 i7 = i6;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i8 >> 2] = i2;
 HEAP32[i7 >> 2] = i4;
 i5 = __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl17getPropertiesImplEN5physx8debugger18NonNegativeIntegerERPNS2_19PropertyDescriptionERjS7_(i5, HEAP32[i1 >> 2] | 0, i9, i8, i7) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN8Renderer13SetLightmapSTERK8Vector4f12LightmapType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f4 != Math_fround(HEAPF32[i1 + 228 + (i3 << 4) >> 2]))) {
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  if (!(f4 != Math_fround(HEAPF32[i1 + 228 + (i3 << 4) + 4 >> 2]))) {
   f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   if (!(f4 != Math_fround(HEAPF32[i1 + 228 + (i3 << 4) + 8 >> 2]))) {
    f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
    if (!(f4 != Math_fround(HEAPF32[i1 + 228 + (i3 << 4) + 12 >> 2]))) return;
   }
  }
 }
 __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i1 + 32 | 0, i2, i3);
 return;
}

function __ZN8Animator7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(636, i1, 16, gb + 1048932 | 0, 0, gb + 910128 | 0, 138) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8AnimatorC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i5 + 12 >> 2] = i3;
 if (!i2) i2 = 0; else {
  i2 = __ZNK5physx2Sc9RigidCore10getPxActorEv(i2 + (HEAP32[gb + 1457208 + 68 + (((HEAP32[i3 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) | 0) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i5 >> 2] = i2;
 if (!i1) {
  i4 = 0;
  i5 = i5 + 4 | 0;
  HEAP32[i5 >> 2] = i4;
  return;
 }
 i4 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(i1 + 16 | 0) | 0;
 i5 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = i4;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx21PxsBodyTransformVault6updateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!(HEAP32[i3 + 4392 >> 2] | 0)) return; else i2 = 0;
 do {
  i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  if (i1 | 0) do {
   i4 = HEAP32[i1 + 28 >> 2] | 0;
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
   HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
   HEAP32[i1 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
   i1 = HEAP32[i1 + 32 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 1024);
 return;
}

function __ZN4Mesh30InvalidateGpuSkinSourceBuffersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 192 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 196 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 200 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22NavMeshProjectSettingsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i7;
 HEAP32[i1 >> 2] = gb + 169552 + 8;
 i3 = i1 + 28 | 0;
 i4 = i2 + 4 | 0;
 i5 = i1 + 668 | 0;
 do {
  i6 = i5;
  i5 = i5 + -20 | 0;
  if ((HEAP8[i5 + 11 >> 0] | 0) < 0) {
   i8 = HEAP32[i5 >> 2] | 0;
   i6 = HEAP32[i6 + -8 >> 2] | 0;
   HEAP32[i2 >> 2] = 66;
   HEAP32[i4 >> 2] = i6;
   __Z19free_alloc_internalPvRK10MemLabelId(i8, i2);
  }
 } while ((i5 | 0) != (i3 | 0));
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 STACKTOP = i7;
 return;
}

function __ZN16Physics2DManagerD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 156040 + 8;
 i1 = i2 + 604 | 0;
 if ((HEAP32[i2 + 620 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 608 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 _memset(i2 + 68 | 0, 0, 536) | 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 + 64 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer12removeClientERN5physx26PxProfileEventBufferClientE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i5 = i1 + 56 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i4 = i1 + 52 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0);
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 HEAP32[i5 >> 2] = i6;
 i7 = HEAP32[i4 >> 2] | 0;
 HEAP32[i7 + (i1 << 2) >> 2] = HEAP32[i7 + (i6 << 2) >> 2];
 return;
}

function __ZN10CBBoxInt327AugmentEiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i5 | 0) < (i2 | 0) ? i5 : i2;
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i6 | 0) < (i3 | 0) ? i6 : i3;
 i5 = i1 + 8 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i6 | 0) < (i4 | 0) ? i6 : i4;
 i5 = i1 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i6 | 0) > (i2 | 0) ? i6 : i2;
 i2 = i1 + 16 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i5 | 0) > (i3 | 0) ? i5 : i3;
 i3 = i1 + 20 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i2 | 0) > (i4 | 0) ? i2 : i4;
 return;
}

function __Z8StrNICmpPKcS0_j(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 while (1) {
  i6 = HEAP8[i1 >> 0] | 0;
  i5 = i6 << 24 >> 24;
  i5 = (i6 + -65 & 255) < 26 ? i5 + 32 | 0 : i5;
  i6 = i5 & 255;
  i7 = HEAP8[i3 >> 0] | 0;
  i4 = i7 << 24 >> 24;
  i4 = (i7 + -65 & 255) < 26 ? i4 + 32 | 0 : i4;
  if (!(i6 << 24 >> 24 ? i6 << 24 >> 24 == (i4 & 255) << 24 >> 24 : 0)) {
   i1 = (i5 & 255) - (i4 & 255) | 0;
   i2 = 4;
   break;
  }
  i2 = i2 + -1 | 0;
  if (!i2) {
   i1 = 0;
   i2 = 4;
   break;
  } else {
   i1 = i1 + 1 | 0;
   i3 = i3 + 1 | 0;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z36EdgeCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0;
 if (__ZN14EdgeCollider2D9SetPointsEPK8Vector2fj(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0) | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808208 | 0, 0, gb + 808253 | 0, 2313, 1, 0, 0, 0);
 return;
}

function __Z34getPxVehicleDriveTankMDriveSimDataPKN5physx18PxVehicleDriveTankE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 288 >> 2] | 0;
 _memcpy(i1 | 0, i2 + 224 | 0, i3 << 3 | 0) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 i3 = i1 + 80 | 0;
 i4 = i2 + 304 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i4 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i4 + 28 >> 2];
 _memcpy(i1 + 112 | 0, i2 + 336 | 0, 416) | 0;
 return;
}

function __Z33Profiler_CUSTOM_AddFramesFromFileP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if (!(__ZNK11ICallString6LengthEv(i2) | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 553044 | 0, 0, gb + 553082 | 0, 120, 1, 0, 0, 0);
  STACKTOP = i4;
  return;
 } else {
  __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i2);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  STACKTOP = i4;
  return;
 }
}

function __ZNK19TouchPhaseEmulation8GetTouchEjR5Touch(i1, i4, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = 0;
 i1 = i4;
 while (1) {
  if ((HEAP32[i6 + (i2 * 96 | 0) + 84 >> 2] | 0) == (i5 | 0)) if ((HEAP32[i6 + (i2 * 96 | 0) >> 2] | 0) != -1) if (!i1) break; else i1 = i1 + -1 | 0;
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= 32) {
   i1 = 0;
   i7 = 7;
   break;
  }
 }
 if ((i7 | 0) == 7) return i1 | 0;
 i1 = i6 + (i2 * 96 | 0) | 0;
 i2 = i3 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i7 = 1;
 return i7 | 0;
}

function __ZN7mecanim12statemachine18GetTransitionCountENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i1 | 0) {
 case 1:
  {
   i2 = i2 + 4 | 0;
   i3 = (HEAP32[i2 >> 2] | 0) + i2 + (HEAP32[i3 + 8 >> 2] << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   return i3 | 0;
  }
 case 2:
  {
   i2 = i2 + 4 | 0;
   i3 = (HEAP32[i2 >> 2] | 0) + i2 + (HEAP32[i3 + 12 >> 2] << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = i2 + 8 | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx7NpScene19removeParticleFluidERNS_15NpParticleFluidE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb(i1 + 16 | 0, i5 + 20 | 0, 0);
 i6 = i1 + 3640 | 0;
 i3 = i1 + 3644 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
 return;
}

function __ZN4FMOD12ChannelGroup11getWaveDataEPfii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869684;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN17AnimationPlayable29CleanupStateMachineBehavioursEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i5 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i6 = 8;
    break;
   } else i3 = 0;
  }
  if ((i6 | 0) == 8) {
   i6 = 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZN14ParticleSystem23RendererBecameInvisibleEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, d4 = 0.0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 80260 | 0) | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 284 >> 2] | 0) == -1) return;
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (HEAP8[i2 + 30 >> 0] | 0) return;
 if (!(HEAP8[i2 + 25 >> 0] | 0)) return;
 if (HEAP8[i2 + 26 >> 0] | 0) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 HEAP8[(HEAP32[i1 >> 2] | 0) + 30 >> 0] = 1;
 d4 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i1 >> 2] | 0) + 32 >> 3] = d4;
 __ZN14ParticleSystem17RemoveFromManagerEv(i3);
 return;
}

function __ZN14ParticleSystem13GetRootSystemEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  return i3 | 0;
 }
 while (1) {
  i1 = i1 + 28 | 0;
  i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 80300 | 0) | 0;
  if (!i3) {
   i1 = i2;
   i2 = 4;
   break;
  }
  i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  if (!i1) {
   i1 = i3;
   i2 = 4;
   break;
  } else i2 = i3;
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN12_GLOBAL__N_112UserRenderer9addClientERN5physx26PxProfileEventBufferClientE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAP32[i1 >> 2] = i4;
 i2 = i5 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i5 + 60 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i5 + 52 >> 2] | 0) + (i3 << 2) >> 2] = i4;
  HEAP32[i2 >> 2] = i3 + 1;
  STACKTOP = i6;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_(i5 + 40 | 0, i1) | 0;
  STACKTOP = i6;
  return;
 }
}

function __ZN12TreeRenderer14RenderLODTreesER6Camerai(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, f5 = f0;
 f5 = Math_fround(HEAPF32[(__Z18GetLODGroupManagerv() | 0) + 24 >> 2]);
 HEAPF32[i2 + 328 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i2 + 360 >> 2]));
 HEAP32[i2 + 332 >> 2] = HEAP32[(__Z18GetLODGroupManagerv() | 0) + 28 >> 2];
 HEAP32[i2 + 336 >> 2] = HEAP32[(__Z18GetLODGroupManagerv() | 0) + 32 >> 2];
 if ((HEAP32[i2 + 132 >> 2] | 0) == (i4 | 0)) return;
 i3 = HEAP32[i2 + 412 >> 2] | 0;
 if (!i3) return;
 i2 = HEAP32[i2 + 400 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 24 | 0) + 4 >> 2] = i4;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return;
}

function __ZN12AdsIdHandler17AddAdsIdListenersER14IAdsIdListener(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i1 + 64 | 0;
 i6 = HEAP32[i1 + 76 >> 2] | 0;
 HEAP32[i5 >> 2] = 5;
 HEAP32[i5 + 4 >> 2] = i6;
 i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(12, 16, i5, 0, gb + 1049224 | 0, 75) | 0;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i4;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i4 >> 2] = i5;
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine9Animation23GetBoundCurveFloatValueERKNS0_10BoundCurveE(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 switch (HEAP32[i1 + 4 >> 2] | 0) {
 case 5:
  {
   f2 = Math_fround(HEAPF32[HEAP32[i1 >> 2] >> 2]);
   return Math_fround(f2);
  }
 case 6:
  {
   f2 = HEAP8[HEAP32[i1 >> 2] >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
   return Math_fround(f2);
  }
 case 7:
  {
   f2 = HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + 54 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
   return Math_fround(f2);
  }
 default:
  {
   i3 = HEAP32[i1 + 8 >> 2] | 0;
   f2 = Math_fround(+mftCall_fii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0));
   return Math_fround(f2);
  }
 }
 return f0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if ((HEAP32[i2 + 8 >> 2] | 0) != 1) return;
 i1 = i2 + 96 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
 }
 i1 = i2 + 84 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = _time(0) | 0;
 if ((i3 - (HEAP32[i2 + 80 >> 2] | 0) | 0) < (HEAP32[i1 >> 2] | 0)) return;
 HEAP32[i1 >> 2] = 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, fb + 3962 | 0, i2 | 0) | 0;
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 48 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 52 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z53Camera_CUSTOM_INTERNAL_CALL_GetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i5 = i2;
  i1 = __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye(i4, i3) | 0;
  i2 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  return;
 }
}

function __Z49Transform_CUSTOM_INTERNAL_CALL_TransformDirectionP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK9Transform18TransformDirectionERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Camera_CUSTOM_INTERNAL_CALL_ViewportToScreenPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera21ViewportToScreenPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Camera_CUSTOM_INTERNAL_CALL_ScreenToViewportPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera21ScreenToViewportPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_(i2, i4, i1, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = i4 + 232 | 0;
 i5 = ((HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16) & 16777215) >>> 14 & 3;
 if (!(i5 & 16777215)) {
  i2 = i3 + 124 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 } else {
  i1 = HEAP32[i4 + 272 >> 2] | 0;
  __Z22SampleReflectionProbesRK23ReflectionProbesContextRK4AABBji20ReflectionProbeUsageR16ReflectionSample(i2, i4 + 276 | 0, i1 << 16 >> 16, i1 >> 16, i5 & 16777215, i3);
  return;
 }
}

function __Z11PremultiplyPh13TextureFormatj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP32[i5 + 8 >> 2] = 1;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = 0;
 if (i1 | 0) {
  if ((i2 | 0) < 9) i3 = 1; else i3 = (i2 | 0) == 1e3 | ((i2 | 0) == 23 | (i2 + -13 | 0) >>> 0 < 9);
  if ((i2 | 0) > 0 & (i4 | 0) > 0 & i3) {
   HEAP32[i5 + 16 >> 2] = i1;
   __Z11PremultiplyR14ImageReference(i5);
   STACKTOP = i6;
   return;
  }
 }
 HEAP32[i5 + 16 >> 2] = 0;
 __Z11PremultiplyR14ImageReference(i5);
 STACKTOP = i6;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i5 + 500 | 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj(i2, (HEAP32[i1 + 4 >> 2] | 0) - i3 >> 2);
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i5 + 504 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i1 = i3;
 } else {
  i5 = i5 + 536 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 i5 = i5 + 536 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZNSt3__219__shared_mutex_base11lock_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i1;
 i4 = i3 + 4 | 0;
 HEAP8[i4 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i1);
 i5 = i1 + 124 | 0;
 i2 = i1 + 28 | 0;
 while (1) {
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) > -1) {
   i1 = i1 & 2147483647;
   if ((i1 | 0) != 2147483647) break;
  }
  __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i2, i3);
 }
 HEAP32[i5 >> 2] = i1 + 1;
 if (HEAP8[i4 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i3 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZNK5physx13NpRigidStatic23checkConstraintValidityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  i4 = 1;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i4) {
  i4 = 1;
  return i4 | 0;
 } else i2 = 0;
 while (1) {
  if (!(HEAP8[i3 + (i2 << 3) >> 0] | 0)) {
   i1 = HEAP32[i3 + (i2 << 3) + 4 >> 2] | 0;
   if (!i1) {
    i1 = 1;
    i2 = 7;
    break;
   }
   if (!(__ZNK5physx12NpConstraint7isValidEv(i1) | 0)) {
    i1 = 0;
    i2 = 7;
    break;
   }
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i4 >>> 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN7mecanim12statemachine23CreateConditionConstantEjjfRNS_6memory9AllocatorE(i4, i5, f6, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 16, 4) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = i4;
 switch (i4 | 0) {
 case 1:
 case 2:
 case 3:
 case 4:
 case 6:
 case 7:
  break;
 default:
  return i1 | 0;
 }
 HEAP32[i2 >> 2] = i5;
 switch (i4 | 0) {
 case 3:
 case 4:
 case 6:
 case 7:
  break;
 default:
  return i1 | 0;
 }
 HEAPF32[i3 >> 2] = f6;
 return i1 | 0;
}

function __ZN5IMGUI14GUIWindowState11SortWindowsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i6 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = fb + 1111;
 __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_(i6, i5, i3);
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = i2 - i1 >> 2;
 i1 = 0;
 do {
  HEAP32[(HEAP32[i3 + (i1 << 2) >> 2] | 0) + 68 >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 STACKTOP = i4;
 return;
}

function __ZN4gles10InvalidateERK14GfxContextGLESR15DeviceStateGLES(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = 0;
 do {
  HEAP32[i3 + 32 + (i1 * 12 | 0) >> 2] = -1;
  HEAP32[i3 + 32 + (i1 * 12 | 0) + 4 >> 2] = 4;
  HEAP32[i3 + 32 + (i1 * 12 | 0) + 8 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 HEAP32[i3 + 424 >> 2] = -1;
 HEAP32[i3 + 416 >> 2] = 0;
 HEAP32[i3 + 444 >> 2] = 0;
 HEAP32[i3 + 448 >> 2] = 0;
 HEAP32[i3 + 564 >> 2] = -1;
 HEAP8[i3 + 568 >> 0] = 0;
 HEAP8[i3 + 570 >> 0] = 0;
 HEAP32[i3 + 572 >> 2] = -1;
 HEAP32[i3 + 576 >> 2] = -1;
 HEAP32[i3 + 420 >> 2] = 0;
 __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES(i2, i3);
 return;
}

function __ZN24RigidbodyMovementState2D21ResetAngularMoveStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, i4 = 0, i5 = 0;
 i1 = i2 + 111 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i4 + 92 >> 2] | 0;
 if (!i5) return;
 f3 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 if (HEAP32[i5 >> 2] | 0) {
  i2 = i5 + 4 | 0;
  i1 = HEAP16[i2 >> 1] | 0;
  if (!(i1 & 16)) {
   if (Math_fround(f3 * f3) > Math_fround(0.0)) {
    i1 = i1 & 65535;
    if (!(i1 & 2)) {
     HEAP16[i2 >> 1] = i1 | 2;
     HEAPF32[i5 + 144 >> 2] = Math_fround(0.0);
    }
   }
   HEAPF32[i5 + 72 >> 2] = f3;
  }
 }
 HEAP32[i5 + 136 >> 2] = HEAP32[i4 + 40 >> 2];
 return;
}

function __ZN22BaseUnityConnectClient22OnRestoreFileAsyncDoneERK8UnityStrS2_b(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
 if ((HEAP32[i1 >> 2] | 0) == 5) return;
 if (i3) __ZN11UnityEngine7Connect13ConfigHandler13ConfigChangedERK8UnityStr(HEAP32[i4 + 544 >> 2] | 0, i2);
 i1 = i4 + 111 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 1;
  __ZN22BaseUnityConnectClient17RestoreValuesFileEv(i4);
  __ZN22BaseUnityConnectClient22UpdateConfigFromServerEv(i4);
  return;
 } else {
  __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3934 | 0, i4);
  return;
 }
}

function __ZN19ConstantBuffersGLES13FindAndBindCBEiii(i3, i1, i7, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i6 = i2 << 16 | i1;
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i2 = (HEAP32[i3 + 16 >> 2] | 0) - i5 | 0;
 i4 = (i2 | 0) / 12 | 0;
 if ((i2 | 0) <= 0) {
  i8 = -1;
  return i8 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = -1;
   i8 = 7;
   break;
  }
 }
 if ((i8 | 0) == 7) return i1 | 0;
 if ((i7 | 0) <= -1) {
  i8 = i1;
  return i8 | 0;
 }
 HEAP16[i5 + (i1 * 12 | 0) + 8 >> 1] = i7;
 i8 = i1;
 return i8 | 0;
}

function __ZN18ScreenManagerWebGL6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __Z16GetRenderManagerv() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 i5 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 56 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) if ((HEAP32[i1 + 60 >> 2] | 0) == (i5 | 0)) return;
 _emscripten_set_canvas_size(i4 | 0, i5 | 0);
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0)) {
  HEAP32[i1 + 64 >> 2] = i4;
  HEAP32[i1 + 68 >> 2] = i5;
 }
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = i5;
 __ZN13RenderManager22OnWindowSizeHasChangedEv(i2);
 return;
}

function __ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 88 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 128 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 136 >> 2] = HEAP32[i2 + 12 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN12AudioManager29ShutdownReinitializeAndReloadEv(i1);
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (__ZN4FMOD6System6updateEv(i1) | 0) != 79;
 return i3 | 0;
}

function __ZN11UmbraModule25SetOcclusionPortalEnabledEPKN5Umbra4TomeEPvjb(i1, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  STACKTOP = i2;
  return;
 }
 if ((__ZNK5Umbra4Tome12getGateCountEv(i3) | 0) >>> 0 > i5 >>> 0) {
  __ZN5Umbra15GateStateVectorC2EPvjb(i1, i4, 0, 0);
  __ZN5Umbra15GateStateVector8setStateEib(i1, i5, i6);
  STACKTOP = i2;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 612777 | 0, 0, gb + 612578 | 0, 202, 1, 0, 0, 0);
  STACKTOP = i2;
  return;
 }
}

function __Z46Camera_CUSTOM_INTERNAL_CALL_WorldToScreenPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera18WorldToScreenPointERK8Vector3fPb(i4, i5, i2, 0);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42CapsuleCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN17CapsuleCollider2D7SetSizeERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function _ps_unicodes_char_index(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i2 + (HEAP32[i1 + 16 >> 2] << 3) + -8 | 0;
 if (i2 >>> 0 > i3 >>> 0) {
  i6 = 0;
  return i6 | 0;
 } else i1 = 0;
 do {
  i5 = i2 + (i3 - i2 >> 4 << 3) | 0;
  i4 = HEAP32[i5 >> 2] | 0;
  if ((i4 | 0) == (i6 | 0)) {
   i1 = i5;
   break;
  }
  i4 = i4 & 2147483647;
  i1 = (i4 | 0) == (i6 | 0) ? i5 : i1;
  if ((i2 | 0) == (i3 | 0)) break;
  i4 = i4 >>> 0 < i6 >>> 0;
  i3 = i4 ? i3 : i5 + -8 | 0;
  i2 = i4 ? i5 + 8 | 0 : i2;
 } while (i2 >>> 0 <= i3 >>> 0);
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 return i6 | 0;
}

function ___divdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = i2 >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i9 = ((i2 | 0) < 0 ? -1 : 0) >> 31 | ((i2 | 0) < 0 ? -1 : 0) << 1;
 i6 = i4 >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i5 = ((i4 | 0) < 0 ? -1 : 0) >> 31 | ((i4 | 0) < 0 ? -1 : 0) << 1;
 i8 = _i64Subtract(i10 ^ i1 | 0, i9 ^ i2 | 0, i10 | 0, i9 | 0) | 0;
 i7 = getTempRet0() | 0;
 i1 = i6 ^ i10;
 i2 = i5 ^ i9;
 return _i64Subtract((___udivmoddi4(i8, i7, _i64Subtract(i6 ^ i3 | 0, i5 ^ i4 | 0, i6 | 0, i5 | 0) | 0, getTempRet0() | 0, 0) | 0) ^ i1 | 0, (getTempRet0() | 0) ^ i2 | 0, i1 | 0, i2 | 0) | 0;
}

function __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK11Rigidbody2D17GetRelativeVectorERK8Vector2f(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 } else {
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f7 = Math_fround(f4 * f8);
  f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f4 = Math_fround(Math_fround(f6 * f8) + Math_fround(f4 * f5));
  HEAPF32[i2 >> 2] = Math_fround(f7 - Math_fround(f6 * f5));
  HEAPF32[i2 + 4 >> 2] = f4;
  return;
 }
}

function __ZN9ShaderLab4PassC2ENS0_8PassTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN9ShaderLab11ShaderStateC2Ev(i1 + 4 | 0);
 i3 = i1 + 728 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 740 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 + 744 >> 2] = i2;
 HEAP32[i1 + 748 >> 2] = 1;
 HEAP32[i1 + 752 >> 2] = 0;
 HEAP32[i1 + 760 >> 2] = 0;
 HEAP32[i1 + 764 >> 2] = 0;
 HEAP32[i1 + 756 >> 2] = i1 + 760;
 HEAP32[i1 + 768 >> 2] = -1;
 HEAP32[i1 + 772 >> 2] = 0;
 HEAP32[i1 + 776 >> 2] = 0;
 HEAP32[i1 + 780 >> 2] = 0;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIsyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIsxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE4copyIS2_EEvRKNS1_IjT_EE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 }
 HEAP32[i3 + 8 >> 2] = i1;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 << 2, gb + 838004 | 0, 543) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i2 + (HEAP32[i5 >> 2] << 2) | 0;
 if (i2 >>> 0 >= i3 >>> 0) return;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN4FMOD3DSP12getParameterEiPfPci(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i5;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i5 = 0;
   STACKTOP = i4;
   return i5 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870093;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i4;
 return i5 | 0;
}

function __Z48Camera_CUSTOM_INTERNAL_CALL_WorldToViewportPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera20WorldToViewportPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48Camera_CUSTOM_INTERNAL_CALL_ViewportToWorldPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera20ViewportToWorldPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27ConvertTextureEndianessReadiPhi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 switch (i2 | 0) {
 case 6:
  {
   i4 = (i3 | 0) / 4 | 0;
   if ((i3 | 0) <= 3) return;
   i2 = 0;
   while (1) {
    HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
   }
   return;
  }
 case 2:
 case 7:
 case 13:
  {
   i4 = (i3 | 0) / 2 | 0;
   if ((i3 | 0) <= 1) return;
   i2 = 0;
   while (1) {
    HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
    i2 = i2 + 1 | 0;
    if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 2 | 0;
   }
   return;
  }
 default:
  return;
 }
}

function __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i1, i2, f3) | 0;
 if ((i4 & -2) << 16 >> 16 == 2) {
  if (!i5) {
   i5 = 0;
   return i5 | 0;
  }
  i5 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i1 + 40 | 0, i2 + 88 | 0, f3) | 0;
  return i5 | 0;
 } else {
  if (!i5) {
   i5 = 0;
   return i5 | 0;
  }
  i5 = __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i1 + 40 | 0, i2, f3) | 0;
  return i5 | 0;
 }
 return 0;
}

function _UNITY_png_get_pixels_per_inch(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) if (!(HEAP32[i2 + 8 >> 2] & 128)) i4 = 5; else if ((HEAP8[i2 + 192 >> 0] | 0) == 1) {
  i1 = HEAP32[i2 + 184 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 188 >> 2] | 0)) {
   if ((i1 | 0) <= -1) {
    i4 = 0;
    STACKTOP = i5;
    return i4 | 0;
   }
  } else i4 = 5;
 } else i4 = 5; else i4 = 5;
 if ((i4 | 0) == 5) i1 = 0;
 i4 = (_UNITY_png_muldiv(i3, i1, 127, 5e3) | 0) == 0;
 i4 = i4 ? 0 : HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function ___fflush_unlocked(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 20 | 0;
 i7 = i5 + 28 | 0;
 if ((HEAP32[i6 >> 2] | 0) >>> 0 > (HEAP32[i7 >> 2] | 0) >>> 0) {
  mftCall_iiii(HEAP32[i5 + 36 >> 2] | 0, i5 | 0, 0, 0) | 0;
  if (!(HEAP32[i6 >> 2] | 0)) i1 = -1; else i2 = 3;
 } else i2 = 3;
 if ((i2 | 0) == 3) {
  i1 = i5 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i5 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i2 >>> 0 < i4 >>> 0) mftCall_iiii(HEAP32[i5 + 40 >> 2] | 0, i5 | 0, i2 - i4 | 0, 1) | 0;
  HEAP32[i5 + 16 >> 2] = 0;
  HEAP32[i7 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEaSEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 4 | 0;
 i4 = i2 + 4 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i6;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i4, i2);
 i6 = i4 + 72 | 0;
 i3 = i2 + 72 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 76 | 0;
 i2 = i2 + 76 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZNK9Heightmap12GetSteepnessEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZNK9Heightmap21GetInterpolatedNormalEff(i5, i1, f2, f3);
 f3 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) * Math_fround(0.0));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 4 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(+Math_acos(+Math_fround(f3 + Math_fround(Math_fround(HEAPF32[i5 + 8 >> 2]) * Math_fround(0.0))))) * Math_fround(.5)) / Math_fround(3.14159274)) * Math_fround(360.0));
 STACKTOP = i4;
 return Math_fround(f3);
}

function __ZN8UserList7ReserveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 4 | 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 & 2147483647) >>> 0 >= i2 >>> 0) return;
 if ((i5 | 0) > -1) {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2 << 3, 4, i1 + 8 | 0, 0, gb + 1047584 | 0, 464) | 0;
  return;
 } else {
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 3, 4, i1 + 8 | 0, 0, gb + 1047584 | 0, 446) | 0;
  _memcpy(i5 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i1 + 16 >> 2] << 3 | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i3 >> 2] = i5;
  return;
 }
}

function __ZN7VRInputC2EPK34UnityVRDeviceSpecificConfiguration(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i1 + 8;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i1 + 24;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = i1 + 48;
 __ZN7VRInput27ResetAllReferenceTransformsEv(i1);
 return;
}

function __ZN6Sprite23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i4 = i2 + 80 | 0;
 i6 = i1 + 16 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i7 = i1 + 36 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 i5 = i1 + 40 | 0;
 if (HEAP8[i5 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i2 = i2 + 84 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
 if (!(HEAP8[i5 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN6Camera7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(1304, i1, 16, gb + 1048932 | 0, 0, gb + 377707 | 0, 92) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6CameraC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx7NpClothC2ENS_7PxFlagsINS_10PxBaseFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 + 6 >> 1] = HEAP16[i1 >> 1] | 0;
 HEAP32[i2 >> 2] = gb + 94588 + 8;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 i1 = i2 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 251658240;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP8[i2 + 43 >> 0] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP16[i1 + 16 >> 1] = 0;
 HEAP32[i2 + 128 >> 2] = gb + 95092 + 8;
 HEAP32[i2 + 140 >> 2] = i2;
 HEAP32[i2 + 144 >> 2] = 0;
 HEAP8[i2 + 148 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, i2, i3, 0, i5);
 i3 = i1 + 16 | 0;
 i5 = i1 + 24 | 0;
 HEAP8[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 3 >> 0] = 1;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i1, gb + 945671 | 0, HEAP32[gb + 37040 >> 2] | 0, i4, 0);
 HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __Z41ConstantForce2D_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN15ConstantForce2D8SetForceERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z22GetStreamingAssetsPathv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 12 | 0;
 i4 = i2;
 __Z14GetAppDataPathv(i3);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 390869 | 0, 15);
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i3, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z18HumanLimitFromMonoRK14MonoHumanLimitR17SkeletonBoneLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP8[i2 + 40 >> 0] = (HEAP32[i1 + 40 >> 2] | 0) != 1 & 1;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = i2 + 12 | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = i2 + 24 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 return;
}

function _UNITY_FT_Stroker_BeginSubPath(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!((i2 | 0) != 0 & (i3 | 0) != 0)) {
  i3 = 6;
  return i3 | 0;
 }
 HEAP8[i2 + 20 >> 0] = 1;
 i6 = i3;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i2 + 21 >> 0] = i1;
 if (!(HEAP32[i2 + 48 >> 2] | 0)) if (!(i1 << 24 >> 24)) i1 = 0; else i1 = (HEAP32[i2 + 44 >> 2] | 0) == 0 & 1; else i1 = 1;
 HEAP8[i2 + 40 >> 0] = i1;
 i4 = i3;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i2 + 28 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 i6 = 0;
 return i6 | 0;
}

function _openlog(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 _pthread_setcancelstate(1, i4 | 0) | 0;
 ___lock(gb + 1469724 | 0);
 if (!i1) HEAP8[gb + 1576076 >> 0] = 0; else {
  i6 = _strnlen(i1, 31) | 0;
  _memcpy(gb + 1576076 | 0, i1 | 0, i6 | 0) | 0;
  HEAP8[gb + 1576076 + i6 >> 0] = 0;
 }
 HEAP32[gb + 1469732 >> 2] = i2;
 HEAP32[gb + 207716 >> 2] = i3;
 if ((i2 & 8 | 0) != 0 & (HEAP32[gb + 207712 >> 2] | 0) < 0) ___openlog();
 ___unlock(gb + 1469724 | 0);
 _pthread_setcancelstate(HEAP32[i4 >> 2] | 0, 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEaSEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 4 | 0;
 i4 = i2 + 4 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i6;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i4, i2);
 i6 = i4 + 72 | 0;
 i3 = i2 + 72 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 76 | 0;
 i2 = i2 + 76 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEaSEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 4 | 0;
 i4 = i2 + 4 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i6;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i4, i2);
 i6 = i4 + 72 | 0;
 i3 = i2 + 72 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 76 | 0;
 i2 = i2 + 76 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZNK6Sprite10GetPaddingEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0;
 i6 = HEAP32[i2 + 104 >> 2] | 0;
 HEAP32[i1 >> 2] = i6;
 i3 = HEAP32[i2 + 108 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = i3;
 f4 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f5 = (HEAP32[tempDoublePtr >> 2] = i6, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i1 + 8 >> 2] = Math_fround(f4 - Math_fround(f5 + Math_fround(HEAPF32[i2 + 96 >> 2])));
 f5 = Math_fround(HEAPF32[i2 + 44 >> 2]);
 f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 HEAPF32[i1 + 12 >> 2] = Math_fround(f5 - Math_fround(f4 + Math_fround(HEAPF32[i2 + 100 >> 2])));
 return;
}

function __ZN9Transform26ValidateHierarchyRecursiveER18TransformHierarchyRiS2_iPh(i2, i4, i5, i6, i1, i7) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 36 >> 2] | 0;
 HEAP8[i7 + i3 >> 0] = 1;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 HEAP32[i6 >> 2] = HEAP32[(HEAP32[i4 + 68 >> 2] | 0) + (i3 << 2) >> 2];
 i3 = i2 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i2 + 80 | 0;
 i1 = 0;
 do {
  __ZN9Transform26ValidateHierarchyRecursiveER18TransformHierarchyRiS2_iPh(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0, i4, i5, i6, 0, i7);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 return;
}

function __ZN7mecanim9animation18GetXformCurveValueERKN4math4trsXEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 switch (i3 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i2 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   break;
  }
 case 4:
  {
   f1 = Math_fround(HEAPF32[i2 + 16 >> 2]);
   break;
  }
 case 5:
  {
   f1 = Math_fround(HEAPF32[i2 + 20 >> 2]);
   break;
  }
 case 6:
  {
   f1 = Math_fround(HEAPF32[i2 + 24 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN6Sprite17MainThreadCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 156 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 152 | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) i1 = i4 + 152 | 0; else {
  do {
   i6 = i1;
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   __ZN14SpriteRenderer14OnDeleteSpriteEv(HEAP32[i6 + 8 >> 2] | 0);
   i2 = i1;
  } while ((i2 | 0) != (i3 | 0));
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = i4 + 152 | 0;
  if ((i2 | 0) != (i1 | 0)) do {
   i6 = i2 + 4 | 0;
   i3 = i2;
   i2 = HEAP32[i6 >> 2] | 0;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 + 152 >> 2] = i1;
 return;
}

function __ZN6Shader7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(100, i1, 16, gb + 1048932 | 0, 0, gb + 478066 | 0, 36) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ShaderC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv(i6) {
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 if (i2 >>> 0 >= i4 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = i6 + 8 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (HEAP8[i1 + 21 >> 0] & 9) {
   i3 = HEAP32[i5 >> 2] | 0;
   if ((HEAP32[i1 + 24 >> 2] | 0) == (i3 | 0)) break;
   if ((HEAP32[i1 + 28 >> 2] | 0) == (i3 | 0)) break;
  }
  i2 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = i2;
  if (i2 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return i1 | 0;
 HEAP32[i6 >> 2] = i2 + 4;
 i7 = i1;
 return i7 | 0;
}

function __ZN5Umbra10PathFinder20getMemoryRequirementEPKNS_7ImpTomeE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  i2 = (HEAP32[i1 + 124 >> 2] | 0) + -1 | 0;
  i1 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
  i2 = (HEAP32[i1 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 * 20 | 0) >> 2] | 0) | 0;
  i1 = i2 + 33 | 0;
  i1 = i1 >> 5;
  i1 = i1 << 3;
  i2 = i2 << 1;
  i2 = i2 + 26088 | 0;
  i1 = i2 + i1 | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
  i2 = i1 + 33 | 0;
  i2 = i2 >> 5;
  i2 = i2 << 3;
  i1 = i1 << 1;
  i1 = i1 + 26088 | 0;
  i2 = i1 + i2 | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN18ResourceImageGroup7CleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZN13ResourceImageD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN13ResourceImageD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZN13ResourceImageD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_110DataStream11originShiftEPKvN5physx6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = gb + 149980 + 8;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i3, i5, 28);
 STACKTOP = i4;
 return (HEAPU8[i3 + 392 >> 0] | 0) ^ 1 | 0;
}

function __Z56Renderer_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = i3 + 32 | 0;
  i4 = HEAP32[i5 + 216 >> 2] | 0;
  i1 = HEAP32[i5 + 220 >> 2] | 0;
  i3 = HEAP32[i5 + 224 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + 212 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i3;
  return;
 }
}

function __Z47Rigidbody_CUSTOM_INTERNAL_CALL_GetPointVelocityP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK9Rigidbody16GetPointVelocityERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Rigidbody2D_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D11SetVelocityERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z40Rigidbody2D_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN11Rigidbody2D11SetPositionERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z37UnityWebRequest_CUSTOM_InternalCreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 4 | 0;
 i3 = __ZN22UnityWebRequestManager21CreateUnityWebRequestEv() | 0;
 if (!i3) {
  __Z6FormatPKcz(i2, gb + 1029622 | 0, i4);
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 1029659 | 0, 49, 17, 0, 0, 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i1 + 8 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __Z35SkinnedMeshRenderer_CUSTOM_BakeMeshP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  __ZN19SkinnedMeshRenderer8BakeMeshER4Mesh(i3, i1);
  return;
 }
}

function __Z28GameObject_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i1 = __Z18ExtractTagThrowingR11ICallString(i2) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  STACKTOP = i4;
  return (i1 | 0) == (HEAPU16[i2 + 52 >> 1] | 0 | 0) | 0;
 }
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN7ApiGLES15BindVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i2 = i3 + 1316 | 0;
 if (HEAP8[i3 + 1992 >> 0] | 0) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) if (!(HEAP32[i2 >> 2] | 0)) return;
  if ((HEAP32[i3 + 1320 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 }
 i6 = i4;
 i1 = HEAP32[i6 >> 2] | 0;
 i6 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i6;
 i2 = HEAP32[i3 + 688 >> 2] | 0;
 if (!i1) i5 = 8; else if ((HEAP32[i3 + 1988 >> 2] | 0) == (HEAP32[i4 + 4 >> 2] | 0)) i5 = 8; else i1 = -1;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAP16[i1 + 2 >> 1] | 0;
  i3 = HEAP16[i1 + 4 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i6 & 65535) << 2) >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Unity5Joint14SetBreakTorqueEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0;
 i5 = i4 + 84 | 0;
 HEAPF32[i5 >> 2] = f1;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i4 + 80 >> 2]);
 i4 = f6 == Math_fround(inf);
 f6 = i4 ? Math_fround(3402823469999999843913219.0e14) : f6;
 f1 = Math_fround(HEAPF32[i5 >> 2]);
 i5 = f1 == Math_fround(inf);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, +f6, +(i5 ? Math_fround(3402823469999999843913219.0e14) : f1));
 return;
}

function __ZN5Unity10HingeJoint13WriteUseMotorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 4 | 0;
 i3 = i2;
 i5 = i1 + 32 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 164 >> 2] | 0, i6 | 0, 2, (HEAP8[i1 + 157 >> 0] | 0) != 0 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i4 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i3 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra8QueryExt20getMemoryRequirementENS0_9QueryTypeEPKNS_4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == 0 | (i1 | 0) != 0) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) != -704643054) {
  i2 = 0;
  return i2 | 0;
 }
 if (i2 & 15 | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 180 >> 2] | 0)) {
  i1 = (HEAP32[i2 + 124 >> 2] | 0) + -1 | 0;
  i2 = i2 + (HEAP32[i2 + 128 >> 2] | 0) | 0;
  i1 = (HEAP32[i2 + (i1 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i2 + (i1 * 20 | 0) >> 2] | 0) | 0;
 } else i1 = HEAP32[i2 + (HEAP32[i2 + 184 >> 2] | 0) + (HEAP32[i2 + 176 >> 2] << 2) >> 2] | 0;
 i2 = (i1 << 1) + 26088 + (i1 + 33 >> 5 << 3) | 0;
 return i2 | 0;
}

function __ZN12AudioManager22GetAutomaticUpdateModeEP10GameObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 if (!i1) {
  i2 = 2;
  return i2 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (i2 | 0) if (__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 67048 | 0) | 0) {
   i1 = 1;
   i2 = 6;
   break;
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 2;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN11UnityEngine7Connect14RemoteSettings8GetFloatERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i2, i1) | 0;
 if ((i1 | 0) == (i2 + 4 | 0)) return Math_fround(f3);
 if ((HEAP32[i1 + 48 >> 2] | 0) != 1) return Math_fround(f3);
 f3 = Math_fround(+HEAPF64[i1 + 56 >> 3]);
 return Math_fround(f3);
}

function __ZN11ShapeModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7;
 i5 = i1 + 124 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 | 0) {
  i8 = i1 + 128 | 0;
  HEAP32[i6 + 4 >> 2] = HEAP32[i8 >> 2];
  HEAP32[HEAP32[i8 >> 2] >> 2] = i6;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i8 >> 2] = 0;
 }
 HEAP32[i1 + 132 >> 2] = i2;
 __ZN11ShapeModule16UpdateCachedMeshEv(i1);
 HEAP32[i4 >> 2] = HEAP32[i3 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i1 + 140 | 0, i4);
 STACKTOP = i7;
 return;
}

function __Z40TargetJoint2D_CUSTOM_INTERNAL_set_targetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN13TargetJoint2D9SetTargetERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z40TargetJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN13TargetJoint2D9SetAnchorERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37296 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37248 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37304 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37040 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37012 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 36996 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4, HEAP32[i1 + 24 >> 2] | 0);
 HEAP32[(HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + ((HEAP32[i3 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 8;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __ZNK9Transform11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 i8 = i2 + 32 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __Z23CalculateGlobalPosition23TransformAccessReadOnly(i4, i5);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 504 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj(i2, (HEAP32[i1 + 4 >> 2] | 0) - i3 >> 2);
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i5 + 508 >> 2] | 0;
 i4 = i1 + (i2 << 2) | 0;
 if ((i2 | 0) > 0) {
  i2 = i1;
  i1 = i3;
 } else {
  i5 = i5 + 540 | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
 while (1) {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  if (i2 >>> 0 >= i4 >>> 0) break; else i1 = i1 + 4 | 0;
 }
 i5 = i5 + 540 | 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN5physx2Sc9ClothCore21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i8 = i4;
 i6 = HEAP32[i2 + 28 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 196 >> 2] | 0;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = i3 + (i1 * 36 | 0);
 i3 = i2 + 88 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 mftCall_viiii(i7 | 0, i6 | 0, i5 | 0, 0, i2 | 0);
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN5physx18PxcSweepConvexMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i8, i9, i1, i2, i11, i12, i5, i6, f7, i13, i14, i3, i4, f10) {
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f10 = Math_fround(f10);
 return Math_fround(__ZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE(i8, i9, i1, i2, i11, i12, f7, i13, i14, i3, i4));
}

function __ZN5Unity5Joint13SetBreakForceEf(i4, f1) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0, i5 = 0, f6 = f0;
 i5 = i4 + 80 | 0;
 HEAPF32[i5 >> 2] = f1;
 i2 = i4 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 >> 2]);
 i5 = f6 == Math_fround(inf);
 f6 = i5 ? Math_fround(3402823469999999843913219.0e14) : f6;
 f1 = Math_fround(HEAPF32[i4 + 84 >> 2]);
 i5 = f1 == Math_fround(inf);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, +f6, +(i5 ? Math_fround(3402823469999999843913219.0e14) : f1));
 return;
}

function __ZN5IMGUI14GUIWindowStateD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3) {
   __ZN5IMGUI9GUIWindowD2Ev(i3);
   __ZdlPv(i3);
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 i1 = i4 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5IMGUI9GUIWindowD2Ev(i2);
  __ZdlPv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) != (i1 | 0)) HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7Channel11getWaveDataEPfii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 869684;
 _printf(gb + 853184 | 0, i3) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System19getStreamBufferSizeEPjS1_(i1, i5, i3) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i1 = (i3 | 0) == 0;
  if (!((i5 | 0) != 0 | i1 ^ 1)) {
   i5 = 0;
   STACKTOP = i6;
   return i5 | 0;
  }
  HEAP32[i5 >> 2] = i1 ? 0 : 8;
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870197;
 _printf(gb + 853184 | 0, i4) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD6System13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i5, i1, i2, i6, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i6) {
   i6 = 0;
   STACKTOP = i4;
   return i6 | 0;
  }
  HEAP32[i6 >> 2] = 1e5;
  i6 = 0;
  STACKTOP = i4;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 868197;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN23ArchiveStorageConverter11ProcessDataEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i1 + 8 | 0;
 i5 = i4;
 i2 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i3 | 0, 0, i2 | 0) | 0;
 if (!((i2 | 0) == (i3 | 0) & (getTempRet0() | 0) == 0)) {
  i6 = -1;
  return i6 | 0;
 }
 i5 = i4;
 i3 = _i64Add(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, i3 | 0, 0) | 0;
 i5 = getTempRet0() | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = __ZN23ArchiveStorageConverter18DecompressAndStoreEv(i1) | 0;
 return i6 | 0;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855533 | 0, i1, 0);
 __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 855555 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 44 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16MinMaxPolyCurves26FindMinMaxDoubleIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv(i7, i2 + 228 | 0);
 __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv(i6, i2);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(_fminf(f5, Math_fround(HEAPF32[i6 >> 2])));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(_fmaxf(f4, Math_fround(HEAPF32[i6 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN14ParticleSystem12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[gb + 1451700 >> 2] | 0;
 if (i1 | 0) __ZN21ParticleSystemManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[gb + 1451700 >> 2] = 0;
 i1 = HEAP32[gb + 1452340 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = gb + 83048 + 8;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + 12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -16 - i3 | 0) >>> 4) << 4);
   __ZdlPv(i2);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[gb + 1452340 >> 2] = 0;
 return;
}

function __ZN13SparseTextureD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 HEAP32[i2 >> 2] = gb + 45096 + 8;
 i4 = i2 + 100 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
  HEAP8[i4 >> 0] = 0;
 }
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i2 + 28 | 0);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 __ZdlPv(i2);
 STACKTOP = i5;
 return;
}

function __ZN12InputManager21GetJoystickButtonNameEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i4 = i7 + 12 | 0;
 if (!i2) {
  HEAP32[i6 >> 2] = i3;
  _snprintf(i4, 100, gb + 441329 | 0, i6) | 0;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  _snprintf(i4, 100, gb + 441307 | 0, i5) | 0;
 };
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i7;
 return;
}

function __ZN10TagManager11TagToStringEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = (HEAP32[i1 + 32 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) i6 = 8; else {
  i1 = i5;
  i3 = i2;
  L2 : while (1) {
   i2 = i3;
   while (1) {
    if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i4 >>> 0) break;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) break L2;
   }
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i1 = i2;
    break;
   } else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) i6 = 8; else if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i4 >>> 0) i6 = 8;
 }
 if ((i6 | 0) == 8) i1 = i5;
 return ((i1 | 0) == (i5 | 0) ? gb + 1110264 | 0 : i1 + 20 | 0) | 0;
}

function __Z46Transform_CUSTOM_INTERNAL_CALL_TransformVectorP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK9Transform15TransformVectorERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Camera_CUSTOM_INTERNAL_CALL_ScreenToWorldPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Camera18ScreenToWorldPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Light_Set_Custom_PropRenderModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i2 >>> 0 > 2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 540947 | 0, i4);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK5Light16UnshareLightDataEv(i3);
  HEAP32[(HEAP32[i3 + 44 >> 2] | 0) + 76 >> 2] = i2;
  STACKTOP = i4;
  return;
 }
}

function __ZN9Rigidbody13SetUseGravityEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 83 | 0;
 if (i2) if (!(HEAP8[i3 >> 0] | 0)) {
  i4 = HEAP32[i1 + 52 >> 2] | 0;
  if (i4 | 0) if ((HEAP16[i4 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 204 >> 2] | 0, i4 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 256 >> 2] | 0, i4 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 }
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, 2, i2 ^ 1 | 0);
 HEAP8[i3 >> 0] = i2 & 1;
 return;
}

function __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i3 = i1 + 100 | 0;
 i4 = i2;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP8[i1 + 1081 >> 0] = 0;
 HEAP8[i1 + 1078 >> 0] = 1;
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 if (f6 != Math_fround(0.0) ? 1 : Math_fround(HEAPF32[i2 + 24 >> 2]) != Math_fround(0.0)) return;
 HEAP8[i1 + 1082 >> 0] = 0;
 i3 = i1 + 228 | 0;
 i4 = i2;
 i5 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN4FMOD7Channel19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859027;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN24dtObstacleAvoidanceQuery9addCircleEPKfffS1_S1_(i3, i4, f5, f6, i7, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i3 + 10452 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) > 103) return;
 HEAP32[i1 >> 2] = i2 + 1;
 HEAP32[i3 + (i2 * 24 | 0) >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + (i2 * 24 | 0) + 4 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + (i2 * 24 | 0) + 8 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + (i2 * 24 | 0) + 12 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAPF32[i3 + (i2 * 24 | 0) + 16 >> 2] = Math_fround(Math_fround(HEAPF32[i3 + 10432 >> 2]) + f5);
 HEAPF32[i3 + (i2 * 24 | 0) + 20 >> 2] = f6;
 return;
}

function __ZN11TimeManager17SetFixedDeltaTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = f2 < Math_fround(.0000999999974);
 i7 = f2 > Math_fround(10.0);
 f6 = i7 ? Math_fround(10.0) : f2;
 f6 = i5 ? Math_fround(.0000999999974) : f6;
 i5 = i1 + 48 | 0;
 HEAPF32[i5 >> 2] = f6;
 HEAPF32[i1 + 60 >> 2] = Math_fround(Math_fround(1.0) / f6);
 HEAPF32[i1 + 52 >> 2] = f6;
 i1 = i1 + 200 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 HEAPF32[i4 >> 2] = f2;
 HEAP32[i1 >> 2] = HEAP32[(f6 > f2 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __Z28QuadTreeNodeRenderer_CleanupR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63248 | 0);
 return;
}

function _Dual_Project(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP16[i1 + 290 >> 1] | 0;
 i6 = HEAP16[i1 + 292 >> 1] | 0;
 i5 = Math_imul(i7, i2 & 65535) | 0;
 i7 = Math_imul(i7, i2 >> 16) | 0;
 i1 = (i7 << 16) + i5 | 0;
 i4 = Math_imul(i6, i3 & 65535) | 0;
 i6 = Math_imul(i6, i3 >> 16) | 0;
 i3 = (i6 << 16) + i4 | 0;
 i2 = i3 + i1 | 0;
 i1 = (i7 >> 16) + (i5 >> 31) + (i4 >> 31) + (i6 >> 16) + (i1 >>> 0 < i5 >>> 0 & 1) + (i3 >>> 0 < i4 >>> 0 & 1) + (i2 >>> 0 < i1 >>> 0 & 1) | 0;
 i4 = i1 >> 31;
 i3 = i4 + i2 | 0;
 return i4 + i1 + (i3 >>> 0 < i2 >>> 0 & 1) + (i3 >>> 0 > 4294959103 & 1) << 18 | (i3 + 8192 | 0) >>> 14 | 0;
}

function _vasprintf(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 i2 = _malloc(240) | 0;
 do if (!i2) i1 = -1; else {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = _vsnprintf(i2, 240, i4, i1) | 0;
  if (i1 >>> 0 < 240) {
   i5 = _realloc(i2, i1 + 1 | 0) | 0;
   HEAP32[i3 >> 2] = i5 | 0 ? i5 : i2;
   break;
  }
  _free(i2);
  if ((i1 | 0) < 0) i1 = -1; else {
   i1 = i1 + 1 | 0;
   i2 = _malloc(i1) | 0;
   HEAP32[i3 >> 2] = i2;
   if (!i2) i1 = -1; else i1 = _vsnprintf(i2, i1, i4, i5) | 0;
  }
 } while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_80kLayerChanged4CallEPviR11MessageData(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1458004 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458004 | 0, i1);
  i1 = gb + 1458004 | 0;
 } else i1 = 0;
 __ZN10Collider2D19RecalculateContactsEv(i4);
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15ucs4_to_utf16leEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15ucs4_to_utf16beEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK10MinMaxAABB8IsInsideERK8Vector3f(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var f1 = f0, i4 = 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if (f1 < Math_fround(HEAPF32[i3 >> 2])) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i3 + 12 | 0;
 if (f1 > Math_fround(HEAPF32[i4 >> 2])) {
  i4 = 0;
  return i4 | 0;
 }
 f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 if (f1 < Math_fround(HEAPF32[i3 + 4 >> 2])) {
  i4 = 0;
  return i4 | 0;
 }
 if (f1 > Math_fround(HEAPF32[i4 + 4 >> 2])) {
  i4 = 0;
  return i4 | 0;
 }
 f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 if (f1 < Math_fround(HEAPF32[i3 + 8 >> 2])) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = !(f1 > Math_fround(HEAPF32[i4 + 8 >> 2]));
 return i4 | 0;
}

function __ZN8Animator14GetLayerWeightEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 i3 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  f5 = Math_fround(-1.0);
  return Math_fround(f5);
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  f5 = Math_fround(-1.0);
  return Math_fround(f5);
 }
 f5 = Math_fround(__ZN26AnimatorControllerPlayable14GetLayerWeightEi(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2));
 return Math_fround(f5);
}

function __ZN6prcoreL10inner_flipILj3EEEvPhS1_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0, i10 = 0, i11 = 0, i12 = 0;
 if (!i3) return;
 while (1) {
  i3 = i3 + -1 | 0;
  i8 = HEAP8[i1 >> 0] | 0;
  i11 = i1 + 1 | 0;
  i7 = HEAP8[i11 >> 0] | 0;
  i9 = i1 + 2 | 0;
  i5 = HEAP8[i9 >> 0] | 0;
  i6 = i2 + 1 | 0;
  i12 = HEAP8[i6 >> 0] | 0;
  i4 = i2 + 2 | 0;
  i10 = HEAP8[i4 >> 0] | 0;
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP8[i11 >> 0] = i12;
  HEAP8[i9 >> 0] = i10;
  HEAP8[i2 >> 0] = i8;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i4 >> 0] = i5;
  if (!i3) break; else {
   i2 = i2 + 3 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN5physx19NpArticulationJoint17resolveReferencesERNS_24PxDeserializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i4 + 196 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, -2147483648, i2 | 0) | 0;
 i1 = i4 + 200 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, -2147483648, i2 | 0) | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0) | 0) >>> 0 >= 50528768) return;
 __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE(i4 + 20 | 0, 0);
 return;
}

function __ZN5physx16PxVehicleDriveNW12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 159296 + 8;
 HEAP32[i1 >> 2] = i3 + 768;
 i1 = i3 + 44 | 0;
 i6 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i1 >> 2] | 0) | 0;
 i5 = i2 + 4 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 HEAP32[i5 >> 2] = i4 + i6;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i3, i4, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 48 >> 2] | 0, 0) | 0;
 __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE(i3, i2);
 return i3 | 0;
}

function __ZN5physx16PxVehicleDrive4W12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 159256 + 8;
 HEAP32[i1 >> 2] = i3 + 800;
 i1 = i3 + 44 | 0;
 i6 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i1 >> 2] | 0) | 0;
 i5 = i2 + 4 | 0;
 i4 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
 HEAP32[i5 >> 2] = i4 + i6;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i3, i4, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 48 >> 2] | 0, 0) | 0;
 __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE(i3, i2);
 return i3 | 0;
}

function __ZN4Mesh7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3;
 i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(252, i1, 16, gb + 1048932 | 0, 0, gb + 426950 | 0, 57) | 0;
 i8 = i1;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i1 = i6;
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i1 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN4MeshC2E10MemLabelId18ObjectCreationMode(i4, i5, i2);
 __Z19pop_allocation_rootv();
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN4FMOD7Channel19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 866098;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 855848;
 _printf(gb + 853184 | 0, i2) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN2UI6Canvas15SetPixelPerfectEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 360 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i4 >> 0] | 0 | 0)) {
  STACKTOP = i5;
  return;
 }
 i2 = i2 & 1;
 HEAP8[i4 >> 0] = i2;
 HEAP8[i1 + 412 >> 0] = i2;
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i4, gb + 1106036 | 0, i3);
 STACKTOP = i5;
 return;
}

function __ZN26ProbeSetTetrahedralization5ClearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 20 | 0;
 i2 = i3 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = i3 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) <= -1) {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 12 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i3 + 4 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i3 + 12 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15MonoScriptCacheC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP8[i1 + 36 >> 0] = 0;
 HEAP8[i1 + 37 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN14TimerQueryGLESD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 77312 + 8;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[gb + 1098256 + 512 >> 2] | 0;
 if ((i1 | 0) == 128) {
  mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 796 >> 2] | 0, 128, gb + 1098256 | 0);
  HEAP32[gb + 1098256 + 512 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[gb + 1098256 + 512 >> 2] = i1 + 1;
 HEAP32[gb + 1098256 + (i1 << 2) >> 2] = i2;
 HEAP32[i3 >> 2] = gb + 77336 + 8;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 8 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14ParticleSystem14SetPlayOnAwakeEb(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
 L1 : do if (i2) while (1) {
  i2 = i2 + 28 | 0;
  i3 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 80300 | 0) | 0;
  if (!i3) break L1;
  i2 = HEAP32[(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0) + 100 >> 2] | 0;
  if (!i2) {
   i1 = i3;
   break;
  } else i1 = i3;
 } while (0);
 __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b(i1, i4);
 return;
}

function __ZN13RuntimeStaticI19UnityPluginRegistryE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(12, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(12, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i4 + 8 >> 2] = 0;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13GfxDeviceGLES15UpdateSRGBWriteEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0)) return;
 i1 = HEAP8[i2 + 7186 >> 0] | 0;
 i1 = i1 << 24 >> 24 != 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 536 >> 0] | 0) i1 = i1 & (HEAP32[i2 + 7192 >> 2] | 0) < 1;
 i3 = i1 & 1;
 i4 = i2 + 7188 | 0;
 if ((i3 | 0) == (HEAP32[i4 >> 2] | 0)) return;
 do if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 653 >> 0] | 0) {
  i2 = i2 + 4620 | 0;
  if (i1) {
   __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i2, 6);
   break;
  } else {
   __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i2, 6);
   break;
  }
 } while (0);
 HEAP32[i4 >> 2] = i3;
 return;
}

function __ZN11UnityEngine9Analytics9PerfEvent12ToJsonStringER9JSONWrite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i1, i2);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 1037508 | 0, 0);
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 1037519 | 0, 0);
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1037535 | 0, 0);
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i2, i1 + 64 | 0, gb + 1037550 | 0, 0);
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 1037568 | 0, 0);
 return;
}

function __Z45Transform_CUSTOM_INTERNAL_CALL_TransformPointP12Il2CppObjectRK8Vector3fRS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK9Transform14TransformPointERK8Vector3f(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21CompareGUIDStringLessRK9UnityGUIDS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 32 | 0;
 i5 = i7;
 __Z12GUIDToStringRK9UnityGUIDPc(i1, i4);
 __Z12GUIDToStringRK9UnityGUIDPc(i2, i5);
 i1 = 0;
 while (1) {
  i2 = HEAP8[i4 + i1 >> 0] | 0;
  i3 = HEAP8[i5 + i1 >> 0] | 0;
  i1 = i1 + 1 | 0;
  if (i2 << 24 >> 24 != i3 << 24 >> 24) break;
  if ((i1 | 0) >= 32) {
   i1 = 0;
   i6 = 5;
   break;
  }
 }
 if ((i6 | 0) == 5) {
  STACKTOP = i7;
  return i1 | 0;
 }
 i6 = i2 << 24 >> 24 < i3 << 24 >> 24;
 STACKTOP = i7;
 return i6 | 0;
}

function __Z19SendMessageInternalPKcS0_P12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i4 = __Z27FindActiveTransformWithPathPKc(i1) | 0;
 if (!i4) {
  HEAP32[i6 >> 2] = i1;
  _printf_console(gb + 363594 | 0, i6);
  STACKTOP = i7;
  return;
 }
 if (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i4 + 28 >> 2] | 0, i2, i3) | 0) {
  STACKTOP = i7;
  return;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 _printf_console(gb + 363530 | 0, i5);
 STACKTOP = i7;
 return;
}

function __Z16HumanLimitToMonoRK17SkeletonBoneLimitR14MonoHumanLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 + 40 >> 2] = (HEAP8[i1 + 40 >> 0] ^ 1) & 255;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = i2 + 12 | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i3 = i2 + 24 | 0;
 i4 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 return;
}

function __Z12IsHiddenFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 12 | 0;
 i4 = i2;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i4, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 i1 = __ZNK15FileSystemEntry8IsHiddenEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallback10processHitERKNS_12PxRaycastHitERKS9_SK_SK_RfPKj(i6, i7, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZN5physx2Gu9Container6ResizeEj(i4, 1) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + (i1 << 2) >> 2] = i2;
 return 1;
}

function __ZNSt3__212strstreambuf4swapERS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4swapERS3_(i1, i2);
 i3 = i1 + 32 | 0;
 i4 = i2 + 32 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i5;
 i4 = i1 + 36 | 0;
 i5 = i2 + 36 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i5 >> 2] = i3;
 i5 = i1 + 40 | 0;
 i3 = i2 + 40 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 44 | 0;
 i2 = i2 + 44 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf16_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15ucs4_to_utf16leEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15ucs4_to_utf16beEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15utf16le_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15utf16be_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK4Mesh14ExtractUvArrayEiPfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i8 = i5 + 104 | 0;
 i1 = i1 + 32 | 0;
 i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
 __ZN14VertexDataInfoC2Ev(i6);
 HEAP8[i8 >> 0] = 0;
 HEAP8[i8 + 1 >> 0] = i4;
 __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i6, i3, i7, i2 + 3 | 0, i8);
 __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i7, HEAP32[i6 + 88 >> 2] | 0, (HEAP32[i1 >> 2] | 0) + 8 | 0, i6);
 STACKTOP = i5;
 return;
}

function __ZN5physx7profile15ZoneManagerImpl21setUserCustomProfilerEPNS_20PxUserCustomProfilerE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = i3;
 i5 = i1 + 16 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return;
 i2 = i1 + 12 | 0;
 i1 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i3 | 0);
 if ((HEAP32[i5 >> 2] | 0) >>> 0 > 1) i1 = 1; else return;
 do {
  i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i5 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx2Sc9ClothCore20addCollisionTriangleERKNS_24PxClothCollisionTriangleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 196 >> 2] | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i2 + 36;
 i2 = i1 + 88 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5Umbra14TomeCollectionC2EPNS_9AllocatorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
  i1 = gb + 1451688 | 0;
 } else i1 = gb + 1451688 | 0;
 i2 = (i2 | 0) == 0 ? 0 : i2 + 3 & -4;
 HEAP32[i2 >> 2] = gb + 80192 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = gb + 80216 + 8;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP8[i2 + 24 >> 0] = 0;
 i2 = i2 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN4FMOD7Channel11setUserDataEPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i2 + 4 >> 2] = i3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI14CanvasRenderer9SyncDepthENS0_8SyncFlagE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (i2 & 1 | 0) {
  i4 = HEAP32[i1 + 204 >> 2] | 0;
  i3 = i4 + 112 | 0;
  HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2;
  i3 = HEAP32[i1 + 208 >> 2] | 0;
  i4 = HEAP32[i4 + 84 >> 2] | 0;
  HEAP32[i4 + (i3 * 672 | 0) + 480 >> 2] = i3;
  HEAP16[i4 + (i3 * 672 | 0) + 664 >> 1] = 2;
 }
 if (!(i2 & 2)) return;
 i3 = HEAP32[i1 + 220 >> 2] | 0;
 i4 = i3 + 112 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 2;
 i4 = HEAP32[i1 + 224 >> 2] | 0;
 i3 = HEAP32[i3 + 84 >> 2] | 0;
 HEAP32[i3 + (i4 * 672 | 0) + 480 >> 2] = i4;
 HEAP16[i3 + (i4 * 672 | 0) + 664 >> 1] = 2;
 return;
}

function __ZN21UnityAnalyticsManager17GetUnityAnalyticsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) return i2 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(44, gb + 63800 | 0, 16, gb + 1037694 | 0, 67) | 0;
 HEAP32[i2 + 4 >> 2] = __Z21GetUnityConnectClientv() | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 188416 + 8;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i2 + 24 | 0);
 HEAP32[i3 >> 2] = gb + 1042554;
 HEAP32[i1 >> 2] = i2;
 __ZN14UnityAnalytics23RegisterGlobalCallbacksEv(i2);
 i2 = HEAP32[i1 >> 2] | 0;
 return i2 | 0;
}

function __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 8 | 0;
 i4 = i3;
 i7 = i1 + 200 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i2 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i2) | 0;
 i1 = i1 + 192 | 0;
 if ((i2 | 0) >= (HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN18PlayableController12PrepareFrameEP8PlayableRy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 HEAP32[i6 >> 2] = fb + 152;
 HEAP8[i6 + 24 >> 0] = 1;
 i5 = i6 + 16 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP8[i6 + 8 >> 0] = 1;
 __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf(i6, i1 + 88 | 0, i2, 0, 0, 0, 0, Math_fround(1.0));
 i1 = i5;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 190100 + 8;
 i1 = i2 + 1092 | 0;
 if (HEAP8[i2 + 12 >> 0] | 0) __ZN12FileAccessor5CloseEv(i1) | 0;
 __ZN12FileAccessorD2Ev(i1);
 __ZN13FileEntryDataD2Ev(i2 + 32 | 0);
 i1 = i2 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 HEAP32[i3 >> 2] = 66;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z38BoxCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN13BoxCollider2D7SetSizeERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z37AudioMixerDuckingSetParameterCallbackP21UnityAudioEffectStateif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 L1 : do if (i1 | 0) switch (i2 | 0) {
 case 0:
  {
   HEAPF32[i1 + 8 >> 2] = f3;
   break L1;
  }
 case 1:
  {
   HEAPF32[i1 + 12 >> 2] = f3;
   break L1;
  }
 case 2:
  {
   HEAPF32[i1 + 16 >> 2] = f3;
   break L1;
  }
 case 3:
  {
   HEAPF32[i1 + 20 >> 2] = f3;
   break L1;
  }
 case 4:
  {
   HEAPF32[i1 + 24 >> 2] = f3;
   break L1;
  }
 case 5:
  {
   HEAPF32[i1 + 28 >> 2] = f3;
   break L1;
  }
 case 6:
  {
   HEAPF32[i1 + 32 >> 2] = f3;
   break L1;
  }
 default:
  break L1;
 } while (0);
 return 0;
}

function __Z31Profiler_CUSTOM_BeginSampleOnlyP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i2);
 __ZN22UnityProfilerPerThread18BeginSampleDynamicERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i1, i3, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i4;
 return;
}

function __Z30Animator_CUSTOM_ResetTriggerIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator12ResetTriggerEi(i1, i4) | 0;
 if ((i1 | 0) == 1) return;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf16_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15utf16le_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L15utf16be_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN7mecanim12statemachine27DestroyStateMachineConstantEPNS0_20StateMachineConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN4FMOD7Channel7setMuteEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP8[i2 + 160 >> 0] = i3 & 1;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859095;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI11CanvasGroup28SendCanvasGroupChangedAlwaysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106076 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN21LightProbeProxyVolume5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 48 >> 2] = 2;
 HEAP32[i1 + 52 >> 2] = 2;
 HEAP32[i1 + 56 >> 2] = 2;
 HEAPF32[i1 + 60 >> 2] = Math_fround(.25);
 i2 = i1 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP8[i1 + 154 >> 0] = 1;
 return;
}

function __ZN19ScriptingInvocationC2EPv21ScriptingMethodIl2Cpp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 96 | 0;
 i5 = i4 + 48 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i5 = i1 + 200 | 0;
 i4 = i1 + 224 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i5 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 HEAP32[i1 + 212 >> 2] = i2;
 return;
}

function __ZN13SliderJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 157460 + 8;
 HEAP8[i1 + 119 >> 0] = 0;
 HEAPF32[i1 + 120 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache15DidReloadDomainEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1466544 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 60 | 0;
 i4 = i2 + 72 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, gb + 63320 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 i1 = i2 + 76 | 0;
 if ((HEAP32[i1 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 __ZN14ConstantString12create_emptyEv(i3);
 STACKTOP = i4;
 return;
}

function __ZN10AudioMixer14GetGroupVUInfoERK9UnityGUIDbPN5audio5mixer6VUInfoE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 if (__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0) {
  i4 = __ZN5audio5mixer14GetGroupVUInfoERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDbPNS0_6VUInfoE(HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 76 >> 2] | 0, i2, i3, i4) | 0;
  return i4 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 407, 1, 0, 0, 0);
  i4 = 0;
  return i4 | 0;
 }
 return 0;
}

function __Z27Animation_CUSTOM_RemoveClipP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  __ZN9Animation10RemoveClipER13AnimationClip(i3, i1);
  return;
 }
}

function __GLOBAL__sub_I_runtime_serialize_transferfunctions_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1166052 >> 2] = 0;
 i3 = gb + 63416 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1166052 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1166052 + 12 >> 2] = 16;
 i1 = gb + 1166052 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3432 | 0, fb + 3433 | 0, 0, gb + 1166052 | 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546608 | 0, fb + 3434 | 0, fb + 3435 | 0, 0, 0);
 return;
}

function _tanh(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = i3 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[tempDoublePtr + 4 >> 2] = i2;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 do if (i2 >>> 0 > 1071748074) if (i2 >>> 0 > 1077149696) {
  d1 = 1.0 - 0.0 / d1;
  break;
 } else {
  d1 = 1.0 - 2.0 / (+_expm1(d1 * 2.0) + 2.0);
  break;
 } else {
  if (i2 >>> 0 > 1070618798) {
   d1 = +_expm1(d1 * 2.0);
   d1 = d1 / (d1 + 2.0);
   break;
  }
  if (i2 >>> 0 > 1048575) {
   d1 = +_expm1(d1 * -2.0);
   d1 = -d1 / (d1 + 2.0);
  }
 } while (0);
 return +((i3 | 0) < 0 ? -d1 : d1);
}

function __ZZN15DirectorManager15InitializeClassEvEN26UpdateDirectorUpdatestruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1188604 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1188604 | 0, i1);
  i1 = gb + 1188604 | 0;
 } else i1 = 0;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 2);
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i2 + ((HEAP32[i1 + 4 >> 2] | 0) - i2 >> 2 << 2);
 while (1) {
  i1 = __ZN15ScriptsIterator4NextEv(i4) | 0;
  if (!i1) {
   i1 = 0;
   i2 = 6;
   break;
  }
  i2 = HEAP32[i1 + 88 >> 2] | 0;
  if (!i2) i2 = 0; else i2 = HEAP32[i2 + 4 >> 2] | 0;
  if ((i2 | 0) == (i3 | 0)) {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) {
  STACKTOP = i5;
  return i1 | 0;
 }
 return 0;
}

function __ZNK15ReflectionProbe16GetGlobalExtentsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, i7 = 0, f8 = f0, f9 = f0, i10 = 0;
 f8 = Math_fround(HEAPF32[i2 + 64 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f8 = Math_fround(f8 * Math_fround(.5));
 f5 = Math_fround(f5 * Math_fround(.5));
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 72 >> 2]) * Math_fround(.5));
 i10 = f8 < Math_fround(0.0);
 f9 = Math_fround(-f8);
 i7 = f5 < Math_fround(0.0);
 f6 = Math_fround(-f5);
 i2 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 HEAPF32[i1 >> 2] = i10 ? f9 : f8;
 HEAPF32[i1 + 4 >> 2] = i7 ? f6 : f5;
 HEAPF32[i1 + 8 >> 2] = i2 ? f4 : f3;
 return;
}

function __ZNK14ParticleSystem26CulledSystemIsStillPlayingEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, d4 = 0.0, i5 = 0, f6 = f0, d7 = 0.0;
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 d4 = +HEAPF64[i3 + 40 >> 3];
 i5 = HEAP32[i1 + 36 >> 2] | 0;
 if (!(HEAP8[i5 + 277 >> 0] | 0)) {
  d7 = d2 - +HEAPF64[i3 + 32 >> 3] + +Math_fround(HEAPF32[i3 + 396 >> 2]);
  f6 = Math_fround(HEAPF32[i5 + 264 >> 2]);
  if (d7 > +Math_fround(f6 + Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 88 >> 2]))) {
   i5 = 0;
   return i5 | 0;
  }
 }
 if (HEAP8[i3 + 13 >> 0] | 0) if (d2 - d4 > +Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 88 >> 2])) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = 1;
 return i5 | 0;
}

function __ZNK11Rigidbody2D9GetVectorERK8Vector2f(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 } else {
  f4 = Math_fround(HEAPF32[i3 >> 2]);
  f6 = Math_fround(HEAPF32[i3 + 4 >> 2]);
  f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
  f7 = Math_fround(f4 * f8);
  f5 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  f4 = Math_fround(Math_fround(f6 * f8) - Math_fround(f4 * f5));
  HEAPF32[i2 >> 2] = Math_fround(f7 + Math_fround(f6 * f5));
  HEAPF32[i2 + 4 >> 2] = f4;
  return;
 }
}

function __ZN8Animator21GetHintWeightPositionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 if (i2 >>> 0 >= 4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f5 = Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 60 >> 2]);
 return Math_fround(f5);
}

function __ZN8Animator21GetGoalWeightRotationEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 if (i2 >>> 0 >= 4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f5 = Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 44 >> 2]);
 return Math_fround(f5);
}

function __ZN8Animator21GetGoalWeightPositionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 if (i2 >>> 0 >= 4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f5 = Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 40 >> 2]);
 return Math_fround(f5);
}

function __ZN8Animator10GetIntegerEiRi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0;
 i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 144 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0) | 0;
 return i5 | 0;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx20PxClothMeshQuadifierD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 64 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 __ZdlPv(i2);
 return;
}

function __ZN4FMOD5Sound11setUserDataEPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i2 + 4 >> 2] = i3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 854655;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN20SubstanceArchiveDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 59540 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = i1 + 40;
 STACKTOP = i2;
 return;
}

function __ZN19UnityConnectServiceD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i3 >> 2] = gb + 189112 + 8;
 __ZN19UnityConnectService25UnregisterGlobalCallbacksEv(i3);
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN3WWW7ReleaseEv(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 48 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i5;
  return;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i3 + 60 >> 2] | 0;
 HEAP32[i4 >> 2] = 66;
 HEAP32[i4 + 4 >> 2] = i3;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
 STACKTOP = i5;
 return;
}

function __ZN17ArchiveFileSystem12MountArchiveEP20ArchiveStorageReader(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i2 = i5;
 if ((HEAP16[gb + 1178992 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1178992 | 0, i1);
  i1 = gb + 1178992 | 0;
 } else i1 = 0;
 __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader(i3, i4);
 if (!i1) {
  STACKTOP = i5;
  return 1;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i5;
 return 1;
}

function __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i6 = i1 + 28 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = (HEAP32[i1 + 24 >> 2] | 0) + -1 + (HEAP32[i1 + 28 >> 2] | 0) | 0;
 __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE6resizeEj(i6, (i2 >>> 0 < i1 >>> 0 ? i1 : i2) + 1 | 0);
 __ZN16MessageForwarder23RegisterMessageCallbackEiPFvPviR11MessageDataEPKN5Unity4TypeE((HEAP32[i6 >> 2] | 0) + (i2 << 5) | 0, HEAP32[i3 + 8 >> 2] | 0, i4, i5);
 return;
}

function __ZN14AudioBehaviourC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 175500 + 8;
 STACKTOP = i4;
 return;
}

function __ZN13MonoBehaviourD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 65372 + 8;
 __ZN13MonoBehaviour15ThreadedCleanupEv(i1);
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 i3 = i1 + 40 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 52 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12ScriptMapper16AddBuiltinShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI6ShaderE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE3AddERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEES4_(i1 + 32 | 0, i2, i5);
 STACKTOP = i4;
 return;
}

function __Z41ParticleSystem_Set_Custom_PropScalingModeP12Il2CppObject25ParticleSystemScalingMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem14SetScalingModeE25ParticleSystemScalingMode(i3, i2);
  return;
 }
}

function __Z37Collider2D_CUSTOM_INTERNAL_set_offsetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  __ZN10Collider2D9SetOffsetERK8Vector2f(i4, i3);
  STACKTOP = i5;
  return;
 }
}

function __Z31Mesh_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 48 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
  return;
 }
}

function __Z20SignedTriangleArea2DRK8Vector2fS1_S1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f10 = Math_fround(HEAPF32[i1 >> 2]);
 f7 = Math_fround(f6 - f10);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f7 = Math_fround(f7 * Math_fround(f5 + f8));
 f9 = Math_fround(HEAPF32[i3 >> 2]);
 f6 = Math_fround(f9 - f6);
 f4 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 return Math_fround(Math_fround(Math_fround(Math_fround(f10 - f9) * Math_fround(f8 + f4)) + Math_fround(f7 + Math_fround(f6 * Math_fround(f5 + f4)))) * Math_fround(.5));
}

function __Z19CreateGLESGfxDevice17GfxDeviceRenderer(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 switch (i1 | 0) {
 case 8:
  {
   i1 = 1;
   break;
  }
 case 11:
  {
   i1 = 4;
   break;
  }
 case 17:
  {
   i1 = 12;
   break;
  }
 default:
  i1 = 0;
 }
 i2 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(8496, gb + 63304 | 0, 16, gb + 602560 | 0, gb + 1576256 | 0, gb + 602574 | 0, 115) | 0;
 __ZN13GfxDeviceGLESC2Ev(i2);
 __Z19pop_allocation_rootv();
 if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 912 >> 2] | 0, i2 | 0, i1 | 0) | 0) return i2 | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 i2 = 0;
 return i2 | 0;
}

function __ZNSt3__28valarrayIjE6resizeEjj(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 | 0) {
  i3 = i5 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((i4 | 0) == (i2 | 0)) break;
   i7 = i4 + -4 | 0;
   HEAP32[i3 >> 2] = i7;
   i4 = i7;
  }
  __ZdlPv(i2);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 }
 L8 : do if (i1 | 0) {
  i2 = __Znwj(i1 << 2) | 0;
  i3 = i5 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  HEAP32[i5 >> 2] = i2;
  while (1) {
   if (!i1) break L8;
   HEAP32[i2 >> 2] = i6;
   i7 = i2 + 4 | 0;
   HEAP32[i3 >> 2] = i7;
   i1 = i1 + -1 | 0;
   i2 = i7;
  }
 } while (0);
 return;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN6Socket11SetBlockingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 ? 0 : 2048;
 if ((_fcntl(i1, 4, i3) | 0) != -1) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 __Z6FormatPKcz(i3, gb + 458740 | 0, i4 + 16 | 0);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 458557 | 0, 390, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i3 = 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Sq11PruningPoolD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101768 + 8;
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc8RigidSimC2ERNS0_5SceneERNS0_9RigidCoreENS0_14IslandNodeInfo4TypeE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE(i4, i2, i1, i3);
 HEAP32[i4 >> 2] = gb + 91016 + 8;
 i1 = HEAP32[i2 + 1200 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = i3 + 1;
  i4 = i4 + 56 | 0;
  HEAP32[i4 >> 2] = i3;
  return;
 } else {
  i5 = i3 + -1 | 0;
  i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i5 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i5;
  i4 = i4 + 56 | 0;
  HEAP32[i4 >> 2] = i3;
  return;
 }
}

function __ZN5physx25PxClothSimpleTetherCookerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 __ZdlPv(i2);
 return;
}

function __ZN13TranslateGLES14InitVertexTypeERK12GraphicsCaps16GfxDeviceLevelGL(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 5126;
 HEAP32[i4 + 4 >> 2] = (i3 | 0) == 1 ? 36193 : 5131;
 HEAP32[i4 + 8 >> 2] = 5121;
 HEAP32[i4 + 12 >> 2] = 5120;
 HEAP32[i4 + 16 >> 2] = 5125;
 i3 = i2 + 2276 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 STACKTOP = i1;
 return;
}

function __ZN13RenderTexture16SetSRGBReadWriteEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (i1) if ((__Z19GetActiveColorSpacev() | 0) == 1) {
  i1 = HEAP32[i3 + 96 >> 2] | 0;
  i2 = __Z12GetGfxDevicev() | 0;
  i2 = (i1 | 0) != (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 708 >> 2] | 0, i2 | 0) | 0);
 } else i2 = 0; else i2 = 0;
 i1 = i3 + 118 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 if (!(HEAP32[i3 + 128 >> 2] | 0)) if (!(HEAP32[i3 + 136 >> 2] | 0)) {
  HEAP8[i1 >> 0] = i2 & 1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407742 | 0, 0, gb + 406201 | 0, 886, 1, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 16 | 0;
 i4 = i6;
 __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ERKS5_(i5, i3);
 if (!i1) {
  STACKTOP = i6;
  return;
 }
 while (1) {
  i1 = i1 + -1 | 0;
  __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EdeEv(i4, i5);
  __ZN8Scalar4faSERKS_(i2, i4) | 0;
  __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EppEv(i5) | 0;
  if (!i1) break; else i2 = i2 + 16 | 0;
 }
 STACKTOP = i6;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwnerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 148996 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 148996 + 72;
 HEAP32[i1 + 8 >> 2] = gb + 148996 + 108;
 HEAP32[i1 + 44 >> 2] = gb + 148172 + 8;
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 28 >> 2] = gb + 148172 + 8;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __Z48Renderer_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = i3 + 32 | 0;
  i4 = HEAP32[i5 + 200 >> 2] | 0;
  i1 = HEAP32[i5 + 204 >> 2] | 0;
  i3 = HEAP32[i5 + 208 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + 196 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i3;
  return;
 }
}

function __Z47Camera_CUSTOM_INTERNAL_CALL_GetStereoViewMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i5 = i2;
  i1 = __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye(i4, i3) | 0;
  i2 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
  return;
 }
}

function __Z38ParticleSystem_CUSTOM_Internal_EmitOldP12Il2CppObjectR22ParticleSystemParticle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem20EmitParticleExternalER22ParticleSystemParticle(i3, i2);
  return;
 }
}

function _Project(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = HEAP16[i1 + 294 >> 1] | 0;
 i6 = HEAP16[i1 + 296 >> 1] | 0;
 i5 = Math_imul(i7, i2 & 65535) | 0;
 i7 = Math_imul(i7, i2 >> 16) | 0;
 i1 = (i7 << 16) + i5 | 0;
 i4 = Math_imul(i6, i3 & 65535) | 0;
 i6 = Math_imul(i6, i3 >> 16) | 0;
 i3 = (i6 << 16) + i4 | 0;
 i2 = i3 + i1 | 0;
 i1 = (i7 >> 16) + (i5 >> 31) + (i4 >> 31) + (i6 >> 16) + (i1 >>> 0 < i5 >>> 0 & 1) + (i3 >>> 0 < i4 >>> 0 & 1) + (i2 >>> 0 < i1 >>> 0 & 1) | 0;
 i4 = i1 >> 31;
 i3 = i4 + i2 | 0;
 return i4 + i1 + (i3 >>> 0 < i2 >>> 0 & 1) + (i3 >>> 0 > 4294959103 & 1) << 18 | (i3 + 8192 | 0) >>> 14 | 0;
}

function _finish_pass_master(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 316 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 + 348 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i3 = i2 + 16 | 0;
 switch (HEAP32[i3 >> 2] | 0) {
 case 0:
  {
   HEAP32[i3 >> 2] = 2;
   if (!(HEAP8[i1 + 178 >> 0] | 0)) {
    i3 = i2 + 28 | 0;
    HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   }
   break;
  }
 case 1:
  {
   HEAP32[i3 >> 2] = 2;
   break;
  }
 case 2:
  {
   if (HEAP8[i1 + 178 >> 0] | 0) HEAP32[i3 >> 2] = 1;
   i3 = i2 + 28 | 0;
   HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
   break;
  }
 default:
  {}
 }
 i3 = i2 + 20 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZNK16b2PrismaticJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 f6 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 192 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 196 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 112 >> 2]));
 f5 = Math_fround(Math_fround(HEAPF32[i2 + 184 >> 2]) * f4);
 f4 = Math_fround(Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 188 >> 2]))) * f3);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f6 + f5) * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN7mecanim8skeleton18CreateSkeletonMaskEjPNS0_19SkeletonMaskElementERNS_6memory9AllocatorE(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = i3;
 if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  i1 = i3 << 3;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, 4) | 0;
  if ((i2 | 0) != (i2 + (i3 << 3) | 0)) _memset(i2 | 0, 0, i1 | 0) | 0;
 }
 i3 = i6;
 i2 = i2 | 0 ? i2 - i3 | 0 : 0;
 HEAP32[i6 >> 2] = i2;
 _memcpy(((i2 | 0) == 0 ? 0 : i2 + i3 | 0) | 0, i4 | 0, i1 | 0) | 0;
 return i5 | 0;
}

function __ZN5physx2Sc9ClothCore18addCollisionSphereERKNS_22PxClothCollisionSphereE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i1 + 16;
 i2 = i2 + 72 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc5Scene19addBrokenConstraintEPNS0_14ConstraintCoreE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 HEAP32[i1 >> 2] = i5;
 i2 = i6 + 192 | 0;
 i3 = i6 + 196 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((HEAP32[i6 + 200 >> 2] & 2147483647) >>> 0 > i4 >>> 0) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] = i5;
  HEAP32[i3 >> 2] = i4 + 1;
  STACKTOP = i7;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i2, i1) | 0;
  STACKTOP = i7;
  return;
 }
}

function __ZN5physx2Sc20ArticulationJointSimD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 90892 + 8;
 HEAP32[i2 + 24 >> 2] = gb + 90892 + 44;
 i1 = i2 + 32 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE(__ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i2 + 4 >> 2] | 0) | 0) + 1204 >> 2] | 0) | 0, 2, i1);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE(HEAP32[i1 + 152 >> 2] | 0, i1);
 HEAP32[HEAP32[i2 + 36 >> 2] >> 2] = 0;
 __ZN5physx2Sc16ActorInteractionD2Ev(i2);
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Unity14CharacterJoint18SetProjectionAngleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(180.0);
 f1 = i4 ? Math_fround(180.0) : f1;
 i4 = i2 + 180 | 0;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f1;
 i2 = i2 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 196 >> 2] | 0, i3 | 0, +Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i4 >> 2]) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274)));
 return;
}

function __ZN23TransformChangeDispatchC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 i1 = i1 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN22BaseUnityConnectClient19SendAppRunningEventEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 72 | 0;
 i2 = ___udivdi3(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 1e3, 0) | 0;
 getTempRet0() | 0;
 if (!i2) return;
 i5 = i1 + 80 | 0;
 i5 = ___udivdi3(HEAP32[i5 >> 2] | 0, HEAP32[i5 + 4 >> 2] | 0, 1e3, 0) | 0;
 getTempRet0() | 0;
 i4 = i1 + 88 | 0;
 i4 = ___udivdi3(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, 1e3, 0) | 0;
 getTempRet0() | 0;
 i3 = i1 + 96 | 0;
 i3 = ___udivdi3(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, 1e3, 0) | 0;
 getTempRet0() | 0;
 __ZN22BaseUnityConnectClient20QueueAppRunningEventEjjjj(i1, i2, i5, i4, i3);
 return;
}

function __ZN14BatchAllocator16AllocateInternalEPPvijjj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = Math_imul(i5, i4) | 0;
 i5 = i1 + 4 | 0;
 HEAP32[i1 + 12 + (HEAP32[i5 >> 2] << 4) + 8 >> 2] = i7;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + 12 + (i4 << 4) + 12 >> 2] = i2;
 HEAP32[i1 + 12 + (i4 << 4) >> 2] = i3;
 i3 = i6 + -1 | 0;
 i6 = i3 + (HEAP32[i1 >> 2] | 0) & 0 - i6;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i1 + 12 + (i4 << 4) + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i7;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = ((HEAP32[i6 >> 2] | 0) + -1 | i3) + 1;
 HEAP32[i5 >> 2] = i4 + 1;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProviderD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148124 + 8;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0);
 HEAP32[i2 + 32 >> 2] = gb + 148188 + 8;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 HEAP32[i2 + 12 >> 2] = gb + 148172 + 8;
 i3 = i2 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i3 >> 2] | 0);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0);
 __ZdlPv(i2);
 return;
}

function __ZN12LineRenderer14UpdateRendererEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP16[i2 + 328 >> 1] | 0;
 if ((i1 & 65535) < 256 | (i1 & 255) << 24 >> 24 == 0) i3 = 3; else {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i1) i3 = 3; else {
   i4 = __ZNK10GameObject8IsActiveEv(i1) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i4) {
    mftCall_vi(HEAP32[i1 + 156 >> 2] | 0, i2 | 0);
    __ZN8Renderer17UpdateSceneHandleEv(i2);
   } else i3 = 6;
  }
 }
 if ((i3 | 0) == 3) {
  i1 = HEAP32[i2 >> 2] | 0;
  i3 = 6;
 }
 if ((i3 | 0) == 6) mftCall_vi(HEAP32[i1 + 160 >> 2] | 0, i2 | 0);
 if (!(HEAP8[i2 + 273 >> 0] | 0)) return;
 __ZN8Renderer13BoundsChangedEv(i2);
 return;
}

function __ZN11UnityEngine9Animation32DestroyControllerBindingConstantEPN7mecanim9animation25ControllerBindingConstantERNS1_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(HEAP32[i1 + 4 >> 2] | 0, i2);
 __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z55Animator_CUSTOM_INTERNAL_CALL_GetIKHintPositionInternalP12Il2CppObjectiR8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN8Animator15GetHintPositionEi(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35ParticleSystem_CUSTOM_Internal_StopP12Il2CppObject26ParticleSystemStopBehavior(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem4StopE26ParticleSystemStopBehavior(i3, i2);
  return 0;
 }
 return 0;
}

function __Z28Animator_CUSTOM_SetTriggerIDP12Il2CppObjecti(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) {
  i2 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN8Animator10SetTriggerEi(i1, i4) | 0;
 if ((i1 | 0) == 1) return;
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i2, i1, i4);
 return;
}

function _UNITY_png_read_sig(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i3 + 437 | 0;
 i4 = HEAP8[i2 >> 0] | 0;
 i5 = i4 & 255;
 if ((i4 & 255) > 7) return;
 i6 = 8 - i5 | 0;
 HEAP32[i3 + 656 >> 2] = 17;
 _UNITY_png_read_data(i3, i1 + 32 + i5 | 0, i6);
 HEAP8[i2 >> 0] = 8;
 i1 = i1 + 32 | 0;
 if (!(_UNITY_png_sig_cmp(i1, i5, i6) | 0)) {
  if ((i4 & 255) >= 3) return;
  i6 = i3 + 204 | 0;
  HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | 4096;
  return;
 }
 if ((i4 & 255) >= 4) _UNITY_png_error(i3, gb + 353121 | 0);
 if (!(_UNITY_png_sig_cmp(i1, i5, i6 + -4 | 0) | 0)) _UNITY_png_error(i3, gb + 353121 | 0); else _UNITY_png_error(i3, gb + 353106 | 0);
}

function _dirname(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 L1 : do if (!i1) i1 = gb + 1087625 | 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = gb + 1087625 | 0; else {
  i2 = _strlen(i1) | 0;
  while (1) {
   i2 = i2 + -1 | 0;
   if ((HEAP8[i1 + i2 >> 0] | 0) != 47) break;
   if (!i2) {
    i1 = gb + 1087627 | 0;
    break L1;
   }
  }
  do {
   if (!i2) {
    i1 = gb + 1087625 | 0;
    break L1;
   }
   i2 = i2 + -1 | 0;
  } while ((HEAP8[i1 + i2 >> 0] | 0) != 47);
  while (1) {
   if (!i2) {
    i1 = gb + 1087627 | 0;
    break L1;
   }
   i3 = i2 + -1 | 0;
   if ((HEAP8[i1 + i3 >> 0] | 0) == 47) i2 = i3; else break;
  }
  HEAP8[i1 + i2 >> 0] = 0;
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcj(i2, i6, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i3 = _strlen(i6) | 0;
 L5 : do if (!i3) i1 = -1; else {
  i4 = i2;
  i1 = i2 + (i1 >>> 0 > i5 >>> 0 ? i5 + 1 | 0 : i1) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i1 = -1;
    break L5;
   }
   i1 = i1 + -1 | 0;
   if (__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i6, i3, i1) | 0) {
    i1 = i1 - i4 | 0;
    break;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZNK22ProceduralMaterialData17GetTextureRawDataEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 80 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = i4;
  i3 = i2;
 }
 L3 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 >= i5 >>> 0) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 > i5 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 return i5 | 0;
}

function __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 86828 + 8;
 i2 = i3 + 4 | 0;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i2 >> 2] | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
  STACKTOP = i4;
  return;
 }
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx16PxsBroadPhaseMBP13postUpdatePPUEPNS_10PxBaseTaskE(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i6 + 84 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) {
  i5 = 0;
  do {
   i4 = HEAP32[i3 + (i5 * 40 | 0) + 28 >> 2] | 0;
   if (i4 | 0) HEAP32[i4 + 116 >> 2] = 0;
   i5 = i5 + 1 | 0;
  } while ((i5 | 0) != (i2 | 0));
 }
 i5 = i1 + 80 | 0;
 __ZN15MBP_PairManager17removeMarkedPairsEPK10MBP_ObjectPN5physx16PxsBroadPhaseMBPERK8BitArrayS8_(i1 + 52 | 0, HEAP32[i1 + 44 >> 2] | 0, i6, i5, i1 + 88 | 0) | 0;
 _memset(HEAP32[i5 >> 2] | 0, 0, HEAP32[i1 + 84 >> 2] << 2 | 0) | 0;
 return;
}

function __ZN15AnchoredJoint2D16CheckConsistencyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D16CheckConsistencyEv(i2);
 i1 = i2 + 76 | 0;
 if (!((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 80 >> 2] & 2139095040 | 0) != 2139095040 : 0)) {
  i4 = gb + 1162356 | 0;
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
 }
 i1 = i2 + 84 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i2 + 88 >> 2] & 2139095040 | 0) != 2139095040 : 0) return;
 i2 = gb + 1162356 | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 return;
}

function __ZN14ParticleSystem27CopyParticlesToUnalignedDstER23ParticleSystemParticlesjjj(i4, i1, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 if ((i1 | 0) != (i5 | 0)) {
  i3 = i1 - i5 | 0;
  i1 = i6 + i1 | 0;
  i3 = i1 - (i3 >>> 0 > i6 >>> 0 ? i6 : i3) | 0;
  i2 = HEAP32[i4 + 12 >> 2] | 0;
  i1 = i2 >>> 0 < i1 >>> 0 ? i2 : i1;
  i2 = i1 - i3 | 0;
  if (!((i2 | 0) == 0 | i1 >>> 0 <= i3 >>> 0)) {
   i1 = 0;
   do {
    __ZN23ParticleSystemParticles14element_assignEjj(i4, i1 + i5 | 0, i1 + i3 | 0);
    i1 = i1 + 1 | 0;
   } while ((i1 | 0) != (i2 | 0));
  }
 }
 __ZN23ParticleSystemParticles12array_resizeEj(i4, i6 + i5 | 0);
 return;
}

function __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i2, i3, i5, i6, i7, i8, i9) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i1 = 0, i4 = 0, i10 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i10 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i10;
  if (i10 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i4 = i1;
   break;
  }
 } else i4 = i1; while (0);
 return __ZN13MemoryManager10ReallocateEPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i2, i3, i5, i6, i7, i8, i9) | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i3 = i2 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i3 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i3, i2);
 i5 = i3 + 72 | 0;
 i1 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i8 = HEAPU8[i2 + i1 >> 0] | 0;
  i7 = HEAP32[i4 + (i8 * 12 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i4 + (i8 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i4 + (i8 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i7;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i6;
  HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN9b2Fixture9SetSensorEb(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = i1 + 58 | 0;
 if ((i4 & 1 | 0) == (HEAPU8[i5 >> 0] | 0 | 0)) return;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = i3 + 4 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP16[i1 >> 1] = i2 & 65533;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  i3 = i3 + 64 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i3 + 16 >> 2] = 0;
  HEAP32[i3 + 20 >> 2] = 0;
 } else if (!(i2 & 2)) {
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 }
 HEAP8[i5 >> 0] = i4 & 1;
 return;
}

function __ZN9Coroutine26CompareCoroutineMethodNameEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 i1 = i1 + 16 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 i7 = i1;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i3;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i4 = (_strcmp(__Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i4) | 0, i2) | 0) == 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN6Shader17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (i3 | 0) if ((HEAP32[i3 + 4 >> 2] | 0) == (HEAP32[gb + 1188344 >> 2] | 0)) HEAP32[gb + 1188348 >> 2] = 0;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (HEAP32[gb + 1166244 >> 2] | 0)) {
  if (i2 | 0) __ZN9ShaderLab9IntShaderD2Ev(i2);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN9ShaderLab16SerializedShaderD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 HEAP32[i1 >> 2] = 0;
 __ZN8Material26ResetAllCachedMaterialDataEP6Shader(i3);
 return;
}

function __ZN5physx7NpScene11removeActorERNS_7PxActorEb(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if ((i2 | 0) == (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0)) {
  __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb(i2, i1, i4, 1);
  STACKTOP = i5;
  return;
 } else {
  i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAP32[i3 >> 2] = gb + 709230;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 8, gb + 678666 | 0, 76, gb + 708910 | 0, i3);
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx2Sc9ClothCore17addCollisionPlaneERKNS_21PxClothCollisionPlaneE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 180 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i1 + 16;
 i2 = i2 + 80 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5Umbra14TomeCollectionD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i4 = i1 + 28 | 0;
 i5 = i1 + 24 | 0;
 if (!(HEAP8[i5 >> 0] | 0)) {
  i1 = i1 + 32 | 0;
  i2 = i4;
 } else {
  i3 = HEAP32[i4 >> 2] | 0;
  i1 = i1 + 32 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i2 = i4; else {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
   i2 = i4;
  }
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i5 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation6CancelEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 i1 = i2 + 92 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i1 >> 2] = 1;
 i1 = i2 + 112 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 __Z6FormatPKcz(i3, gb + 367935 | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 96 | 0, i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __ZN24AudioScriptBufferManager15GetPCMReadArrayEjRP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((__Z21GetScriptingArraySizeP11Il2CppArray(HEAP32[i1 >> 2] | 0) | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  return;
 } else {
  i5 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 132 >> 2] | 0;
  i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i1 >> 2] | 0, 0, 4) | 0;
  i1 = (i4 | 0) == 0 ? 0 : i2;
  i2 = __Z19scripting_array_newP11Il2CppClassjj(i5, 4, i1) | 0;
  _memcpy(__Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0, i4 | 0, i1 << 2 | 0) | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i6, i7, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i6 = HEAP32[i1 >> 2] | 0;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i5;
  return;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  HEAP32[i7 >> 2] = i6;
  STACKTOP = i5;
  return;
 }
}

function __ZN17AnimationPlayable8OwnAssetEP11NamedObject(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 8 | 0;
 i4 = i6;
 i5 = i6 + 4 | 0;
 i1 = i1 + 76 | 0;
 if (!i3) {
  __ZN14AssetReferenceC2Ev(i2);
  __ZN14AssetReferenceaSERKS_(i1, i2) | 0;
  __ZN14AssetReferenceD2Ev(i2);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  __ZN14AssetReferenceC2E4PPtrI6ObjectE(i4, i2);
  __ZN14AssetReferenceaSERKS_(i1, i4) | 0;
  __ZN14AssetReferenceD2Ev(i4);
  STACKTOP = i6;
  return;
 }
}

function __ZN17AnimationPlayable13ClearBindingsEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + 28 >> 2] | 0;
 if ((i5 | 0) <= 0) return;
 i2 = 0;
 do {
  i3 = i2;
  i1 = i4;
  while (1) {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i3 >>> 0) break;
   i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i3 << 3) + 4 >> 2] | 0;
   if (!i1) break;
   if (!(HEAP32[i1 + 16 >> 2] | 0)) {
    i6 = 8;
    break;
   } else i3 = 0;
  }
  if ((i6 | 0) == 8) {
   i6 = 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0);
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZN16UploadHandlerRawD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 187876 + 8;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63808 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 187928 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i3 + 12 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 i3 = i3 + 12 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 return;
}

function __ZN14StackAllocator18FreeAllAllocationsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = i3 + 52 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i5 = i3 + 16 | 0;
 i6 = i3 + 28 | 0;
 i7 = i3 + 12 | 0;
 do {
  i2 = i1 + -4 | 0;
  if (!(HEAP32[i2 >> 2] & 1)) {
   i8 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i1 | 0) | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) - i8;
   HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -8;
   HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + -1;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
  }
  i1 = HEAP32[i1 + -8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN12CullingGroup18SetBoundingSpheresEP11Il2CppArray(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = (i5 | 0) != 0;
 if (i3) i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i5, 0, 16) | 0; else i2 = 0;
 i1 = i4 + 16 | 0;
 if ((i2 | 0) != (HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = i2;
  i2 = i4 + 108 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) __Z23scripting_gchandle_freej(i1);
  if (i3) i1 = __Z22scripting_gchandle_newP12Il2CppObject(i5) | 0; else i1 = 0;
  HEAP32[i2 >> 2] = i1;
 }
 i5 = __Z21GetScriptingArraySizeP11Il2CppArray(i5) | 0;
 HEAP32[i4 + 20 >> 2] = i5;
 __ZN12CullingGroup22SetBoundingSphereCountEj(i4, i5);
 return;
}

function __Z31CullingGroup_CUSTOM_GetDistanceP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 if ((i2 | 0) >= 0) {
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
  if ((HEAP32[i1 + 24 >> 2] | 0) > (i2 | 0)) {
   i4 = __ZNK12CullingGroup11GetDistanceEj(i1, i2) | 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 510257 | 0, i4);
 return 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i3 = i2 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i3 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i3, i2);
 i5 = i3 + 72 | 0;
 i1 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i3 = i2 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i3 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i3, i2);
 i5 = i3 + 72 | 0;
 i1 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNKSt3__214__codecvt_utf8IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN8Animator7GetBoolEiRb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAP8[i3 >> 0] = 0;
 i4 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 64;
  return i5 | 0;
 }
 i5 = HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0;
 i5 = mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i2 | 0, i3 | 0) | 0;
 return i5 | 0;
}

function __ZN7b2JointC2EPK10b2JointDef(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 158592 + 8;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP8[i1 + 61 >> 0] = HEAP8[i2 + 16 >> 0] | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZN6Camera5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 16 | 0;
 i6 = i2;
 i5 = HEAP32[i1 + 844 >> 2] | 0;
 __ZNK6Camera18GetRenderRectangleEv(i6, i1);
 i3 = (__ZNK6Camera17GetSkyboxMaterialEv(i1) | 0) != 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 __ZL16ClearFramebufferN6Camera9ClearModeE5RectTIfERK10ColorRGBAfbb(i5, i4, i1 + 848 | 0, i3, 0);
 __ZN6Camera12RenderSkyboxEv(i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 48 | 0;
 i9 = i5 + 32 | 0;
 i8 = i5 + 16 | 0;
 i6 = i5;
 __ZN5physx5cloth8intFloorERK8Scalar4f(i9, i3);
 __ZN5physx5cloth6GatherI8Scalar4fEC2ERKS2_(i7, i9);
 __ZNK5physx5cloth6GatherI8Scalar4fEclEPKS2_(i8, i7, i2);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 __ZNK5physx5cloth6GatherI8Scalar4fEclEPKS2_(i6, i7, i4);
 __ZN8Scalar4faSERKS_(i1 + 16 | 0, i6) | 0;
 STACKTOP = i5;
 return;
}

function __ZN4FMOD6System13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE(i5, i1, i2, i3, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i6) {
   i6 = 0;
   STACKTOP = i4;
   return i6 | 0;
  }
  HEAP32[i6 >> 2] = 2;
  i6 = 0;
  STACKTOP = i4;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861127;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN4FMOD5Sound7setModeEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   HEAP32[i2 + 44 >> 2] = i3;
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859075;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 4 >> 2] | 0) == 6) {
  HEAP32[i2 + 7060 >> 2] = i1;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i2 + 7064 >> 2] = i3;
  __ZN18GlslGpuProgramGLES19ApplyGpuProgramGLESERK20GpuProgramParametersPKh(i1, i3, HEAP32[i4 + 4 >> 2] | 0);
  i4 = HEAP32[i2 + 7064 >> 2] | 0;
  HEAP32[i2 + 7072 >> 2] = i4 + 80;
  HEAP32[i2 + 4228 >> 2] = i4 + 124;
  HEAP32[i2 + 7068 >> 2] = i1 + 16;
  return;
 }
 HEAP32[i2 + 7060 >> 2] = 0;
 HEAP32[i2 + 7064 >> 2] = 0;
 return;
}

function __ZN10HumanTrait11RightFinger13GetMuscleNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 908422 | 0, 6);
 if (i2 >>> 0 >= 20) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj(i2 >>> 2) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand13FingerDoFNameEj(i2 & 3) | 0) | 0;
 return;
}

function __ZN10GUIElementC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 36280 + 8;
 STACKTOP = i4;
 return;
}

function __ZN10FlareLayerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 33124 + 8;
 STACKTOP = i4;
 return;
}

function __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, f4 = f0, i5 = 0, f6 = f0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i1 | 0) <= 1) return;
 i3 = i1 + -1 | 0;
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 i1 = 0;
 do {
  f4 = Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]);
  i5 = i1;
  i1 = i1 + 1 | 0;
  f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + (i1 << 4) >> 2]));
  f6 = Math_fround(HEAPF32[i2 + (i5 << 4) + 4 >> 2]);
  f4 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i2 + (i1 << 4) + 4 >> 2])) / f4);
  HEAPF32[i2 + (i5 << 4) + 12 >> 2] = f4;
  HEAPF32[i2 + (i1 << 4) + 8 >> 2] = f4;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function _UnityReplayKitStartBroadcasting(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 240 | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 if (i2 | 0) {
  __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc(i3, i2, gb + 581865 | 0);
  __ZN18ScriptingArguments10AddBooleanEb(i3, 0);
  __ZN18ScriptingArguments9AddStringEPKc(i3, gb + 581872 | 0);
  HEAP32[i4 >> 2] = 0;
  __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i3, i4, 0) | 0;
 }
 __Z23scripting_gchandle_freej(i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__214__codecvt_utf8IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__214__codecvt_utf8IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (HEAP8[i3 + 1084 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i3) | 0) {
  i5 = __Z12GetIVRDevicev() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i5 | 0, i3 | 0, i4 | 0);
  i5 = i3 + 424 + (i4 << 6) | 0;
  i2 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
 }
 STACKTOP = i6;
 return i3 + 424 + (i4 << 6) | 0;
}

function __ZNK6Camera17CalculateUsingHDREv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = __ZNK6Camera22CalculateRenderingPathEv(i1) | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 708 >> 2] | 0, i2 | 0) | 0;
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 233 + i2 >> 0] | 0) == 0;
 i3 = __Z18GetQualitySettingsv() | 0;
 i3 = (i4 | 1 | 0) == 3 ? 1 : (HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0) == 0;
 if ((i4 | 0) == 3) i4 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 144 >> 0] | 0) != 0; else i4 = 1;
 if (i2 | (HEAP8[i1 + 1091 >> 0] | 0) == 0) return 0; else return i3 & i4 | 0;
 return 0;
}

function __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i8 >> 2]);
 f7 = Math_fround(HEAPF32[i8 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i8 + 8 >> 2]);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(f7 - f4);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 8;
 HEAP32[i1 + 16 >> 2] = 6;
 HEAP32[i1 + 24 >> 2] = i2 + 100;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i2 + 4;
 HEAP32[i1 + 32 >> 2] = gb + 656091;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 64 >> 2] = fb + 181;
 HEAP32[i1 + 68 >> 2] = fb + 396;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN8Renderer17SetSortingLayerIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 332 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (__ZN10TagManager27IsSortingLayerUniqueIDValidEi(__Z13GetTagManagerv() | 0, i2) | 0) {
  HEAP32[i3 >> 2] = i2;
  i2 = __Z13GetTagManagerv() | 0;
  i3 = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i2, HEAP32[i3 >> 2] | 0) | 0;
  HEAP16[i1 + 338 >> 1] = i3;
  HEAP32[i1 + 220 >> 2] = (HEAP16[i1 + 336 >> 1] | 0) + 32768 | i3 << 16 ^ -2147483648;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 410308 | 0, 0, gb + 410214 | 0, 715, 1, 0, 0, 0);
  return;
 }
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB444411TexFormatI8EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU16[i1 >> 1] | 0;
  i6 = i3 & 240;
  i5 = i3 >>> 4 & 240;
  i3 = i3 << 4 & 240;
  HEAP8[i4 >> 0] = (HEAPU8[gb + 1160176 + ((i6 >>> 4 | i6) << 2) + 1 >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i5 >>> 4 | i5) << 2) >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i3 >>> 4 | i3) << 2) + 2 >> 0] | 0);
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx7NpActor15removeConnectorERNS_7PxActorEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i2 = i2 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 + 36 >> 2] | 0;
 i4 = i4 + 40 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 i5 = i1 + (i5 << 3) | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i1 + (i3 << 3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i1 + 40 >> 2] | 0) return;
 if ((HEAP32[i1 + 44 >> 2] | 0) > -1) __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE6resizeEjRKt(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 1) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 1) | 0;
 do {
  HEAP16[i1 >> 1] = HEAP16[i5 >> 1] | 0;
  i1 = i1 + 2 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN13GfxDeviceGLES13SetDepthStateEPK16DeviceDepthState(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (__ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(HEAP32[(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i4 + 4616 >> 2] | 0) | 0) + 244 >> 2] | 0) | 0) i1 = HEAP32[i4 + 7140 >> 2] | 0;
 i2 = i4 + 7076 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 if ((HEAP8[i3 + 1 >> 0] | 0) != (HEAP8[i1 + 1 >> 0] | 0)) mftCall_vi(HEAP32[i4 + 4656 >> 2] | 0, HEAPU16[i1 + 2 >> 1] | 0);
 i1 = HEAP8[i1 >> 0] | 0;
 if (i1 << 24 >> 24 == (HEAP8[i3 >> 0] | 0)) return;
 mftCall_vi(HEAP32[i4 + 4660 >> 2] | 0, i1 | 0);
 return;
}

function __ZN10HumanTrait10LeftFinger13GetMuscleNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 908416 | 0, 5);
 if (i2 >>> 0 >= 20) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand10FingerNameEj(i2 >>> 2) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, gb + 1086395 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, __ZN7mecanim4hand13FingerDoFNameEj(i2 & 3) | 0) | 0;
 return;
}

function __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKPositionInternalP12Il2CppObjectiR8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN8Animator15GetGoalPositionEi(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43AnimatorControllerPlayable_CUSTOM_SetBoolIDR9HPlayableih(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 156 >> 2] | 0;
 HEAP8[i5 >> 0] = i1 << 24 >> 24 != 0 & 1;
 i1 = mftCall_iiii(i7 | 0, i6 | 0, i3 | 0, i5 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i4;
  return;
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1, i3);
 STACKTOP = i4;
 return;
}

function __Z31Light_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 44 >> 2] | 0;
  i4 = HEAP32[i5 + 24 >> 2] | 0;
  i1 = HEAP32[i5 + 28 >> 2] | 0;
  i3 = HEAP32[i5 + 32 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + 20 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i3;
  return;
 }
}

function __Z20DestroyCullingOutputR13CullingOutput(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i1 + 12 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 24 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 48 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37208 >> 2] | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function _pvalloc(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 if (!(HEAP32[gb + 1470876 >> 2] | 0)) {
  HEAP32[gb + 1470876 + 8 >> 2] = 4096;
  HEAP32[gb + 1470876 + 4 >> 2] = 4096;
  HEAP32[gb + 1470876 + 12 >> 2] = -1;
  HEAP32[gb + 1470876 + 16 >> 2] = -1;
  HEAP32[gb + 1470876 + 20 >> 2] = 0;
  HEAP32[gb + 1470404 + 444 >> 2] = 0;
  i4 = i1 & -16 ^ 1431655768;
  HEAP32[i1 >> 2] = i4;
  HEAP32[gb + 1470876 >> 2] = i4;
  i1 = 4096;
 } else i1 = HEAP32[gb + 1470876 + 4 >> 2] | 0;
 i4 = _memalign(i1, i2 + -1 + i1 & 0 - i1) | 0;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZNKSt3__214__codecvt_utf8IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_(i2, i1, i3, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1 + 4 | 0;
 i9 = i1;
 HEAP32[i10 >> 2] = i3;
 HEAP32[i9 >> 2] = i6;
 i7 = __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i10, i6, i7, i9, HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 + 16 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i10 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i9 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN9HaloLayerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 34348 + 8;
 STACKTOP = i4;
 return;
}

function __ZN5physx7NpScene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i1 = HEAP8[i1 >> 0] | 0;
 if (!(HEAP8[i4 + 2449 >> 0] | 0)) {
  HEAP8[i2 >> 0] = i1;
  __ZN5physx2Sc5Scene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE(i4 + 32 | 0, i3, i2);
  STACKTOP = i5;
  return;
 } else {
  HEAP8[(HEAP32[i4 + 3376 >> 2] | 0) + (i3 & 255) >> 0] = i1;
  i4 = i4 + 3388 | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 32;
  STACKTOP = i5;
  return;
 }
}

function __ZN5physx7NpScene17releaseBatchQueryEPNS_12PxBatchQueryE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 3628 | 0;
 i3 = i1 + 3632 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) != (i4 | 0)) {
  i4 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i4;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
 }
 if (!i6) return;
 mftCall_vi(HEAP32[(HEAP32[i6 >> 2] | 0) + 60 >> 2] | 0, i6 | 0);
 return;
}

function __ZN5physx3Cct26CharacterControllerManager13getControllerEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((HEAP32[i2 + 68 >> 2] | 0) >>> 0 > i1 >>> 0) {
  i2 = HEAP32[(HEAP32[i2 + 64 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 657349 | 0, 108, gb + 659810 | 0, i3);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx13BigConvexData15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, (HEAPU16[i3 + 2 >> 1] | 0) << 1 | 0);
 }
 i1 = i3 + 16 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, ((HEAP32[i3 + 8 >> 2] << 2) + 12 & -16) + (HEAP32[i3 + 12 >> 2] | 0) | 0);
 return;
}

function __ZN21AssetBundleFileSystemD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 73776 + 8;
 i2 = i1 + 92 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 96 | 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11TypeManager17ClassIDToTypeInfoEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i1;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i4, i2 + 120 | 0, i5);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i1 | 0) == ((HEAP32[i2 + 148 >> 2] | 0) + (HEAP32[i2 + 152 >> 2] << 3) | 0)) {
  i5 = 0;
  STACKTOP = i3;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 STACKTOP = i3;
 return i5 | 0;
}

function __Z46Playables_CUSTOM_INTERNAL_CALL_InternalDestroyR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i2 + 16 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (HEAP32[i1 + 4 >> 2] | 0)) return;
 i1 = i2 + 20 | 0;
 __ZN9Scripting11RaiseIfNullEPv(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP32[i1 + 48 >> 2] & 4)) {
  __ZN8Playable22ScheduleForDestructionEv(i1);
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 550418 | 0, 0, gb + 550266 | 0, 371, 1, 0, 0, 0);
  return;
 }
}

function __ZNSt3__219__thread_struct_imp27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 8 >> 2] | 0)) __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_(i1, i3); else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
 }
 __ZNSt3__214__shared_count12__add_sharedEv(HEAP32[i3 >> 2] | 0);
 STACKTOP = i6;
 return;
}

function __ZNK17GeneralConnection14HasBytesToSendEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 88 >> 2] | 0;
 i3 = i1 + 92 | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if (HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + 60 >> 2] | 0) {
   i1 = 1;
   i2 = 9;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  } else i2 = i1;
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN8GUILayerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP8[i1 + 33 >> 0] = 0;
 HEAP32[i1 >> 2] = gb + 36592 + 8;
 STACKTOP = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE6resizeEjRKi(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 32 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i1 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 32 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i1 + 28 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx37PxVehicleWheelsSimDataGeneratedValuesC2EPKNS_22PxVehicleWheelsSimDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 56 >> 2];
 return;
}

function __ZN5Umbra9fillDWordEPjjj(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 i2 = i5 >>> 3;
 if (i2) {
  i4 = i2 << 3;
  i3 = i1;
  while (1) {
   HEAP32[i3 >> 2] = i6;
   HEAP32[i3 + 4 >> 2] = i6;
   HEAP32[i3 + 8 >> 2] = i6;
   HEAP32[i3 + 12 >> 2] = i6;
   HEAP32[i3 + 16 >> 2] = i6;
   HEAP32[i3 + 20 >> 2] = i6;
   HEAP32[i3 + 24 >> 2] = i6;
   HEAP32[i3 + 28 >> 2] = i6;
   i2 = i2 + -1 | 0;
   if (!i2) break; else i3 = i3 + 32 | 0;
  }
  i1 = i1 + (i4 << 2) | 0;
 }
 i2 = i5 & 7;
 if (!i2) return;
 while (1) {
  HEAP32[i1 >> 2] = i6;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN4FMOD6System13set3DSettingsEfff(i1, f3, f4, f5) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i2 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAPF32[i2 + 52 >> 2] = f3;
  HEAPF32[i2 + 56 >> 2] = f4;
  HEAPF32[i2 + 60 >> 2] = f5;
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = 36;
 HEAP32[i6 + 4 >> 2] = gb + 856103;
 _printf(gb + 853184 | 0, i6) | 0;
 i6 = 36;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN22VirtualJoystickManager26UpdatePhysicalJoystickListEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, d3 = 0.0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 d3 = +__Z19GetTimeSinceStartupv();
 if (!(d3 - +HEAPF64[i2 >> 3] > 1.0)) return;
 i4 = i2 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i2 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) != (i5 | 0)) do {
  i7 = i1 + -12 | 0;
  HEAP32[i6 >> 2] = i7;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i7);
  i1 = HEAP32[i6 >> 2] | 0;
 } while ((i1 | 0) != (i5 | 0));
 __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i4);
 HEAPF64[i2 >> 3] = d3;
 return;
}

function __ZN15DirectorManager18OnFixedAdvanceTimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 396 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 i5 = HEAP32[(__Z14GetTimeManagerv() | 0) + 48 >> 2] | 0;
 HEAP32[gb + 1188444 >> 2] = i5;
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i2, fb + 3163 | 0, HEAP32[i1 + 384 >> 2] | 0, HEAP32[i3 >> 2] | 0, 0, 0);
 if (HEAP32[i2 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i2);
 STACKTOP = i4;
 return;
}

function __Z45TextGenerator_CUSTOM_INTERNAL_get_rectExtentsP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3); else {
  i5 = HEAP32[i1 + 64 >> 2] | 0;
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAP32[i2 + 8 >> 2] = i5;
  HEAP32[i2 + 12 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 36980 >> 2] | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z15SetAlphaChanneliiPhi13TextureFormath(i7, i8, i5, i9, i1, i2) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i5 = i5 | 0;
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i10 = 0;
 i4 = __Z20GetTextureFormatInfo13TextureFormat(i1) | 0;
 i6 = HEAP32[i4 + 28 >> 2] | 0;
 i4 = (i2 & 255) << HEAP32[i4 + 24 >> 2];
 if ((i8 | 0) > 0 & (i7 | 0) > 0) {
  i3 = 0;
  i2 = i5;
 } else return;
 while (1) {
  i1 = 0;
  do {
   i5 = i2 + (i1 << 2) | 0;
   i10 = HEAP32[i5 >> 2] | 0;
   HEAP32[i5 >> 2] = (i10 ^ i4) & i6 ^ i10;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i7 | 0));
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i8 | 0)) break; else i2 = i2 + i9 | 0;
 }
 return;
}

function _cff_builder_add_point(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 if (!(HEAP8[i1 + 65 >> 0] | 0)) {
  i5 = i5 + 2 | 0;
  i4 = HEAP16[i5 >> 1] | 0;
  i4 = i4 + 1 << 16 >> 16;
  HEAP16[i5 >> 1] = i4;
  return;
 } else {
  i7 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = i5 + 2 | 0;
  i6 = HEAP16[i1 >> 1] | 0;
  i5 = (HEAP32[i5 + 8 >> 2] | 0) + i6 | 0;
  HEAP32[i7 + (i6 << 3) >> 2] = i2 >> 10;
  HEAP32[i7 + (i6 << 3) + 4 >> 2] = i3 >> 10;
  HEAP8[i5 >> 0] = i4 << 24 >> 24 ? 1 : 2;
  i5 = i1;
  i4 = HEAP16[i5 >> 1] | 0;
  i4 = i4 + 1 << 16 >> 16;
  HEAP16[i5 >> 1] = i4;
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 3) >> 2] | 0;
 switch (i3 & 3) {
 case 1:
  {
   i3 = i3 >>> 4;
   return i3 + 1 + (__ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(i1, i2 + 1 + i3 | 0) | 0) | 0;
  }
 case 0:
  {
   i3 = (HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + (i3 >>> 2 << 3) >> 2] | 0) >>> 2;
   return i3 + 1 + (__ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi(i1, i2 + 1 + i3 | 0) | 0) | 0;
  }
 case 2:
  {
   i3 = 1;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN9allocutil14BuddyAllocator5AllocEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 < i1 >>> 0) {
  i5 = i1 + -1 | 0;
  i1 = 32 - (Math_clz32(i5 | 0) | 0) | 0;
  i1 = ((i5 | 0) == 0 ? 0 : i1) - (HEAPU8[i2 + 24 >> 0] | 0) & 255;
 } else i1 = 0;
 if (!(__ZN9allocutil14BuddyAllocator16InternalAllocateEhRj(i2, i1, i3) | 0)) {
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 i5 = i1 & 255;
 i5 = HEAP32[i3 >> 2] << (HEAPU8[i2 + 24 >> 0] | 0) + i5 | (i5 << 26) + 67108864;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 204 | 0;
 i3 = i1 + 208 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i5 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) != (i4 | 0)) {
  i4 = i4 + -1 | 0;
  HEAP32[i3 >> 2] = i4;
  i5 = HEAP32[i5 >> 2] | 0;
  HEAP32[i5 + (i1 << 2) >> 2] = HEAP32[i5 + (i4 << 2) >> 2];
 }
 i6 = i6 + 116 | 0;
 HEAP8[i6 >> 0] = (HEAPU8[i6 >> 0] | 0) & 251;
 return;
}

function __ZN5physx14NpArticulation15importExtraDataERNS_24PxDeserializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 if (!(HEAP8[i4 + 84 >> 0] | 0)) {
  i1 = i4 + 88 | 0;
  if (HEAP32[i1 >> 2] | 0) {
   i2 = HEAP32[i4 + 96 >> 2] | 0;
   if (i2 & 2147483647 | HEAP32[i4 + 92 >> 2] | 0) {
    i6 = i3 + 4 | 0;
    i5 = HEAP32[i6 >> 2] | 0;
    HEAP32[i6 >> 2] = i5 + (i2 << 2);
    HEAP32[i1 >> 2] = i5;
   }
  }
 }
 i6 = i3 + 4 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i3 = i3 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i4 + 104 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
 return;
}

function __ZN18AsyncUploadManager22UploadStreamingTextureEP28FileTextureUploadInstruction(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i2 = HEAP32[i4 + 1328 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = __ZnwjRK10MemLabelIdiPKci(16, i4 + 1332 | 0, 16, gb + 397729 | 0, 33) | 0; else HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 i6 = HEAP32[i4 + 32 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 i4 = i4 + 8 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = HEAP32[i5 + 140 >> 2] | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZN13SparseTextureD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 HEAP32[i2 >> 2] = gb + 45096 + 8;
 i4 = i2 + 100 | 0;
 if (HEAP8[i4 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
  HEAP8[i4 >> 0] = 0;
 }
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i2 + 28 | 0);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN12HingeJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 155828 + 8;
 HEAP8[i1 + 114 >> 0] = 0;
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __ZN12FixedJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 155404 + 8;
 HEAP8[i1 + 104 >> 0] = 0;
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 STACKTOP = i4;
 return;
}

function __Z46GUIStyle_CUSTOM_Internal_DrawWithTextSelectionP12Il2CppObjectR43MonoInternal_DrawWithTextSelectionArguments(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = __Z11GetGUIStatev() | 0;
 i1 = __Z26MonoGUIContentToTempNativeP12Il2CppObject(i1) | 0;
 __ZNK8GUIStyle21DrawWithTextSelectionER8GUIStateRK5RectTIfER10GUIContentbbbbbiiRK10ColorRGBAfSA_(i4, i3, i2 + 4 | 0, i1, (HEAP32[i2 + 60 >> 2] | 0) != 0, (HEAP32[i2 + 64 >> 2] | 0) != 0, (HEAP32[i2 + 68 >> 2] | 0) != 0, (HEAP32[i2 + 72 >> 2] | 0) != 0, (HEAP32[i2 + 76 >> 2] | 0) != 0, HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i2 + 28 | 0, i2 + 44 | 0);
 return;
}

function __GLOBAL__sub_I_TransformFeedbackSkinning_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1451164 >> 2] = 0;
 i3 = gb + 63544 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1451164 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1451164 + 12 >> 2] = 16;
 i1 = gb + 1451164 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3704 | 0, fb + 3705 | 0, 0, gb + 1451164 | 0);
 HEAP32[gb + 1451244 + 4 >> 2] = 0;
 HEAP32[gb + 1451244 + 8 >> 2] = 0;
 HEAP32[gb + 1451244 >> 2] = gb + 1451244 + 4;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jjRKS4_(i3, i4, i5, i6, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i3); else {
  i1 = i1 - i5 | 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i3, (i2 ? HEAP32[i4 >> 2] | 0 : i4) + (i5 << 2) | 0, i1 >>> 0 < i6 >>> 0 ? i1 : i6);
  return;
 }
}

function __ZN9Animation6SampleEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 108 >> 2] | 0;
 i2 = HEAP32[i5 + 104 >> 2] | 0;
 i6 = i2;
 if ((i1 | 0) == (i2 | 0)) return;
 i7 = i5 + 252 | 0;
 i4 = i1 - i2 >> 2;
 i1 = 0;
 i2 = 0;
 do {
  i3 = HEAP32[i6 + (i2 << 2) >> 2] | 0;
  if (HEAP32[i3 + 96 >> 2] | 0) if (HEAP16[i3 + 56 >> 1] & 2) if (Math_fround(HEAPF32[i3 + 8 >> 2]) > Math_fround(.0000999999974)) i1 = 1;
  i3 = i3 + 64 | 0;
  HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 if (!i1) return;
 __ZN9Animation14SampleInternalEv(i5);
 return;
}

function __ZN6Object11InvokeEventEi(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i2 = HEAP32[i4 + 12 >> 2] | 0;
 i6 = HEAP32[gb + 1104268 >> 2] | 0;
 if (!i2) return; else i1 = i2;
 do {
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 do {
  i3 = i2 + 12 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 1) mftCall_viii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i4 | 0, i5 | 0);
  i1 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i6, i1);
 } while ((i2 | 0) != 0);
 return;
}

function __ZN5physx19PxsFluidSpatialHash20updatePacketSectionsEPjPNS_16PxsFluidParticleEPNS_10PxBaseTaskE(i7, i5, i6, i1) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i7 + 20 | 0;
 i2 = i7 + 16 | 0;
 i4 = 0;
 do {
  i3 = HEAP32[i7 >> 2] | 0;
  switch (HEAP32[i3 + (i4 << 4) + 8 >> 2] | 0) {
  case 0:
  case -1:
   break;
  default:
   __ZN5physx19PxsFluidSpatialHash19buildPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEjPNS_16PxsFluidParticleEPj(i7, i3 + (i4 << 4) | 0, (HEAP32[i1 >> 2] | 0) + (i4 * 216 | 0) | 0, HEAP32[i2 >> 2] | 0, i6, i5);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != 1024);
 return;
}

function __ZN4Mesh17NotifyObjectUsersERK17MessageIdentifier(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 HEAP32[i5 >> 2] = gb + 30832;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i1;
 i2 = HEAP32[i1 + 236 >> 2] | 0;
 i3 = i1 + 232 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i6;
  return;
 }
 do {
  i7 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[i7 + 8 >> 2] | 0, i4, i5);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 STACKTOP = i6;
 return;
}

function __ZN4FMOD6Reverb13setPropertiesEPK22FMOD_REVERB_PROPERTIES(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857020;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN2UI11CanvasGroup17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106076 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN17GeneralConnection27UnregisterConnectionHandlerEPFvjE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = i1 + 116 | 0;
 i2 = HEAP32[i8 >> 2] | 0;
 i4 = i2;
 i7 = HEAP32[i1 + 112 >> 2] | 0;
 while (1) {
  if ((i7 | 0) == (i2 | 0)) {
   i5 = 8;
   break;
  }
  i6 = i7 + 4 | 0;
  if ((HEAP32[i7 >> 2] | 0) == (i3 | 0)) break; else i7 = i6;
 }
 if ((i5 | 0) == 8) return;
 i1 = i4 - i6 | 0;
 i3 = i1 >> 2;
 if (i3) {
  _memmove(i7 | 0, i6 | 0, i1 | 0) | 0;
  i2 = HEAP32[i8 >> 2] | 0;
 }
 i1 = i7 + (i3 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i8 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = i4 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  if (i3 | 0) {
   __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
   return;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 i3 = HEAP32[i4 + 12 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN12EventManager11InvokeEventEP10EventEntryPvi(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i6 = 0;
 i6 = HEAP32[gb + 1104268 >> 2] | 0;
 if (!i2) return; else i1 = i2;
 do {
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 do {
  i3 = i2 + 12 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 1) mftCall_viii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i4 | 0, i5 | 0);
  i1 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i6, i1);
 } while ((i2 | 0) != 0);
 return;
}

function __ZN11UnityEngine9Animation29InvalidateAvatarBindingObjectEPNS0_21AvatarBindingConstantEP6Object(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = i2 + (i1 << 2) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) HEAP32[i4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 if (!i4) return;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = 0;
 do {
  i3 = i2 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) HEAP32[i3 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN11UnityEngine9Animation21AvatarBindingCallbackEPvS1_i(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((i1 | 0) != 2) return;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   i4 = i2 + (i1 << 2) | 0;
   if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) HEAP32[i4 >> 2] = 0;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 if (!i4) return;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i1 = 0;
 do {
  i3 = i2 + (i1 * 12 | 0) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i6 | 0)) HEAP32[i3 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN11UTF16String10CopyStringERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 8 | 0;
 if (HEAP8[i4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 12 | 0);
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i5) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  i5 = 0;
  HEAP8[i4 >> 0] = i5;
  return;
 } else {
  HEAP32[i3 >> 2] = i5;
  i5 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i5 << 1, 16, i1 + 12 | 0, 0, gb + 489101 | 0, 145) | 0;
  HEAP32[i1 >> 2] = i5;
  _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] << 1 | 0) | 0;
  i5 = 1;
  HEAP8[i4 >> 0] = i5;
  return;
 }
}

function __ZN11OffMeshLink15UpdatePositionsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 i1 = i2 + 40 | 0;
 i3 = i1;
 if (!((HEAP32[i3 >> 2] | 0) == 0 & (HEAP32[i3 + 4 >> 2] | 0) == 0)) {
  i4 = __Z17GetNavMeshManagerv() | 0;
  i3 = i1;
  __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i4, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
  i3 = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 }
 __ZN11OffMeshLink13AddConnectionEv(i2);
 HEAP8[i2 + 97 >> 0] = 0;
 return;
}

function __Z45LineRenderer_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectiR8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK12LineRenderer11GetPositionEi(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Camera_Get_Custom_PropAllCamerasv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 92 >> 2] | 0;
 i1 = HEAP32[(__Z16GetRenderManagerv() | 0) + 24 >> 2] | 0;
 i1 = __Z19scripting_array_newP11Il2CppClassjj(i2, 4, (HEAP32[(__Z16GetRenderManagerv() | 0) + 12 >> 2] | 0) + i1 | 0) | 0;
 i2 = __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i1, (__Z16GetRenderManagerv() | 0) + 4 | 0, 0) | 0;
 __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i(i1, (__Z16GetRenderManagerv() | 0) + 16 | 0, i2) | 0;
 return i1 | 0;
}

function _UNITY_tt_face_get_device_metrics(i1, i4, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 716 >> 2] | 0;
 i8 = (HEAP32[i1 + 704 >> 2] | 0) + 8 | 0;
 i5 = HEAP32[i1 + 712 >> 2] | 0;
 if (!i5) return 0;
 i3 = HEAP32[i1 + 720 >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAPU8[i3 + i2 >> 0] | 0 | 0) == (i4 | 0)) {
   i1 = 4;
   break;
  }
  i1 = i2 + 1 | 0;
  if (i1 >>> 0 < i5 >>> 0) i2 = i1; else {
   i1 = 6;
   break;
  }
 }
 if ((i1 | 0) == 4) {
  i6 = i6 + 2 | 0;
  i8 = i8 + (Math_imul(i2, i7) | 0) + i6 | 0;
  return (i6 >>> 0 < i7 >>> 0 ? i8 : 0) | 0;
 } else if ((i1 | 0) == 6) return 0;
 return 0;
}

function b45(i1, f2, i13, i24, i25, i26, i27, i28, i29, i30, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18, i19, i20, i21, i22, i23) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i13 = i13 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i26 = i26 | 0;
 i27 = i27 | 0;
 i28 = i28 | 0;
 i29 = i29 | 0;
 i30 = i30 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 nullFunc_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii(45);
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 4) | 0;
 if (!(HEAP32[i7 >> 2] & 4)) HEAP32[i6 >> 2] = i1 + -1900;
 STACKTOP = i5;
 return;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE(i1, i6, i2, i3, i7, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i5 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i8 = i5;
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i8 >> 2];
 i1 = __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi(i2, i1, i7, i4, 4) | 0;
 if (!(HEAP32[i7 >> 2] & 4)) HEAP32[i6 >> 2] = i1 + -1900;
 STACKTOP = i5;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN4FMOD3DSP12setParameterEif(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 853388;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN14SerializedFile4Type21CompareAgainstNewTypeEP8TypeTree(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6 + 8 | 0;
 i4 = i6;
 i5 = HEAP32[i1 + 44 >> 2] | 0;
 if (!((i2 | 0) != 0 & (i5 | 0) != 0)) {
  i4 = 1;
  i5 = i1 + 48 | 0;
  HEAP32[i5 >> 2] = i4;
  STACKTOP = i6;
  return;
 }
 HEAP32[i3 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = (__Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_(i3, i4) | 0) & 1 ^ 1;
 i5 = i1 + 48 | 0;
 HEAP32[i5 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __ZN13WheelCollider14SetMotorTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i4 = i1 + 148 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 56 >> 2] | 0)) return;
 i3 = i3 + 56 | 0;
 __ZN5physx16PxVehicleNoDrive14setDriveTorqueEjf(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, f2);
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 return;
}

function __ZN13WheelCollider14SetBrakeTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i4 = i1 + 148 | 0;
 if ((HEAP32[i4 >> 2] | 0) == -1) return;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 52 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 56 >> 2] | 0)) return;
 i3 = i3 + 56 | 0;
 __ZN5physx16PxVehicleNoDrive14setBrakeTorqueEjf(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, f2);
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 284 >> 2] | 0, i4 | 0);
 return;
}

function __ZN12ActiveLightsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = 0;
  do {
   i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 180 | 0) >> 2] | 0;
   i5 = i4 + 4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   if (!(HEAP32[i5 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i4, i4 + 8 | 0);
   }
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z31CalculateHierarchyTransformType23TransformAccessReadOnly(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 + 64 >> 2] | 0;
 i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  i4 = i1;
  i3 = i4 >>> 1;
  i3 = i3 | -2;
  i3 = i3 ^ 1;
  i4 = i3 & i4;
  return i4 | 0;
 }
 do {
  i5 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  i1 = (i5 | i1) & -5 | (i5 ^ i1) & 4;
  i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
 } while ((i2 | 0) != -1);
 i5 = i1 >>> 1;
 i5 = i5 | -2;
 i5 = i5 ^ 1;
 i5 = i5 & i1;
 return i5 | 0;
}

function __Z18Shader_CUSTOM_FindP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = __Z15GetScriptMapperv() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3) | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function _UNITY_FT_Lookup_Renderer(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[i1 + 148 >> 2] | 0;
 i3 = (i5 | 0) != 0;
 if (i3) {
  i2 = HEAP32[i5 >> 2] | 0;
  if (i2) i1 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
 }
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 while (1) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAP32[i2 + 16 >> 2] | 0) == (i4 | 0)) break;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i6 = 11;
   break;
  }
 }
 if ((i6 | 0) == 11) return i1 | 0;
 if (!i3) {
  i6 = i2;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i6 = i2;
 return i6 | 0;
}

function _jpeg_write_marker(i5, i3, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0;
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 if (!((HEAP32[i5 + 208 >> 2] | 0) == 0 & (i4 + -101 | 0) >>> 0 < 3)) {
  i6 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 + 20 >> 2] = 20;
  HEAP32[i6 + 24 >> 2] = i4;
  mftCall_vi(HEAP32[i6 >> 2] | 0, i5 | 0);
 }
 i6 = i5 + 332 | 0;
 mftCall_viii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i3 | 0, i2 | 0);
 i3 = HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0;
 if (!i2) return;
 while (1) {
  i2 = i2 + -1 | 0;
  mftCall_vii(i3 | 0, i5 | 0, HEAPU8[i1 >> 0] | 0 | 0);
  if (!i2) break; else i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK9dtNavMesh26getOffMeshConnectionUserIdEyPj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!((i2 & 983040 | 0) == 65536 & 0 == 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i5 = i2 & 65535;
 if (i5 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) {
  i5 = -2147483640;
  return i5 | 0;
 }
 i3 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
 getTempRet0() | 0;
 i1 = HEAP32[i1 + 48 >> 2] | 0;
 if ((i1 + (i5 * 104 | 0) | 0) == 0 ? 1 : (i3 | 0) != (HEAP32[i1 + (i5 * 104 | 0) + 92 >> 2] | 0)) {
  i5 = -2147483640;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i1 + (i5 * 104 | 0) + 84 >> 2];
 i5 = 1073741824;
 return i5 | 0;
}

function __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (HEAP8[i3 + 1083 >> 0] | 0) if (__ZNK6Camera16GetStereoEnabledEv(i3) | 0) {
  i5 = __Z12GetIVRDevicev() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i5 | 0, i3 | 0, i4 | 0);
  i5 = i3 + 296 + (i4 << 6) | 0;
  i2 = i5 + 64 | 0;
  do {
   HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
   i5 = i5 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i5 | 0) < (i2 | 0));
 }
 STACKTOP = i6;
 return i3 + 296 + (i4 << 6) | 0;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i8 = HEAPU8[i2 + i1 >> 0] | 0;
  i7 = HEAP32[i4 + (i8 * 12 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i4 + (i8 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i4 + (i8 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i7;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i6;
  HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZNK14ParticleSystem15AddNewParticlesER23ParticleSystemParticlesRjPj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i7 = i6 + i5 | 0;
 i1 = HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 2548 >> 2] | 0;
 i1 = i1 >>> 0 < i7 >>> 0 ? i1 : i7;
 i7 = i1 - i5 | 0;
 i6 = i7 >>> 0 < i6 >>> 0 ? i7 : i6;
 HEAP32[i3 >> 2] = i6;
 i3 = (i5 + 3 | 3) + i6 & -4;
 __ZN23ParticleSystemParticles13array_reserveEj(i2, i3 + 31 & -32);
 __ZN23ParticleSystemParticles12array_resizeEj(i2, i3);
 i3 = i1 >>> 0 < i5 >>> 0 ? i1 : i5;
 HEAP32[i4 >> 2] = i3;
 return i3 + 3 & -4 | 0;
}

function __ZNK13WheelCollider27GetGlobalSuspensionDistanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i1 + 88 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i5 + 4 >> 2]));
 i1 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i1 ? f4 : f3;
 i1 = f3 < Math_fround(9.99999974e-06);
 f3 = i1 ? Math_fround(9.99999974e-06) : f3;
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB56511TexFormatI8EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAPU16[i1 >> 1] | 0;
  i6 = i5 >>> 3 & 252;
  i3 = i5 << 3 & 248;
  HEAP8[i4 >> 0] = (HEAPU8[gb + 1160176 + ((i6 >>> 6 | i6) << 2) + 1 >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i5 >>> 11 << 3 | i5 >>> 13) << 2) >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i3 >>> 5 | i3) << 2) + 2 >> 0] | 0);
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIfjE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
  i3 = ~~Math_fround(HEAPF32[tempDoublePtr >> 2]) >>> 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0, f2 = f0;
 f1 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f2 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 i3 = (HEAPU8[i3 + 14 >> 0] | 0) & 15;
 i4 = (HEAPU8[i4 + 14 >> 0] | 0) & 15;
 switch ((i3 >>> 0 < i4 >>> 0 ? i4 : i3) | 0) {
 case 0:
  {
   f1 = Math_fround(Math_fround(f1 + f2) * Math_fround(.5));
   break;
  }
 case 1:
  {
   f1 = f1 < f2 ? f1 : f2;
   break;
  }
 case 2:
  {
   f1 = Math_fround(f1 * f2);
   break;
  }
 case 3:
  {
   f1 = f1 > f2 ? f1 : f2;
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN23TransformChangeDispatch16UnregisterSystemER27TransformChangeSystemHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == -1) return;
 i4 = ~(1 << i3);
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 HEAP32[i2 >> 2] = -1;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & i4;
 return;
}

function __ZN15TerrainColliderD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 187060 + 8;
 i1 = i4 + 80 | 0;
 if ((HEAP32[i4 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i4 >> 2] = gb + 110952 + 8;
 i3 = HEAP32[i4 + 44 >> 2] | 0;
 if (!i3) {
  HEAP32[i4 >> 2] = gb + 29060 + 8;
  HEAP32[i4 >> 2] = gb + 26392 + 8;
  return;
 }
 i1 = i4 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 HEAP32[i4 >> 2] = gb + 29060 + 8;
 HEAP32[i4 >> 2] = gb + 26392 + 8;
 return;
}

function __ZL50UnityAudioEffect_InternalGetFloatParameterCallbackP14FMOD_DSP_STATEiPfPc(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i1 >> 2] | 0, i2) | 0;
 if (!i1) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i1 = 36; else {
   i1 = HEAP32[(HEAP32[i2 + 112 >> 2] | 0) + 188 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = (mftCall_iiiii(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0) == 0;
    i1 = i1 ? 0 : 80;
   }
  }
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __Z50WheelCollider_CUSTOM_INTERNAL_get_sidewaysFrictionP12Il2CppObjectP18WheelFrictionCurve(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 124 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  return;
 }
}

function __Z40AudioSource_CUSTOM_GetSpectrumDataHelperP12Il2CppObjectP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) {
  i5 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
  __ZN11AudioSource15GetSpectrumDataEPfii19FMOD_DSP_FFT_WINDOW(i5, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0, i3, i4);
  return;
 }
}

function __ZN9allocutil14BuddyAllocatorD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i3 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) {
  i6 = HEAP32[i5 >> 2] | 0;
  if (i6 | 0) {
   i7 = i6 + -4 | 0;
   i1 = HEAP32[i7 >> 2] | 0;
   if (i1 | 0) {
    i1 = i6 + (i1 << 5) | 0;
    do {
     i2 = i1;
     i1 = i1 + -32 | 0;
     if ((HEAP32[i2 + -16 >> 2] | 0) > -1) {
      __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -28 | 0);
      HEAP32[i1 >> 2] = 0;
     }
    } while ((i1 | 0) != (i6 | 0));
   }
   __ZdaPv(i7);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i3);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN7mecanim12statemachine20DestroyStateConstantEPNS0_13StateConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIjyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIjxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN17CapsuleCollider2D10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 if (!(__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAPF32[i1 + 160 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 164 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 4 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN16MinMaxPolyCurves20FindMinMaxIntegratedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 8 | 0;
 i6 = i3;
 __ZNK15PolynomialCurve20FindMinMaxIntegratedEv(i7, i2 + 228 | 0);
 __ZNK15PolynomialCurve20FindMinMaxIntegratedEv(i6, i2);
 f5 = Math_fround(HEAPF32[i7 >> 2]);
 f5 = Math_fround(_fminf(f5, Math_fround(HEAPF32[i6 >> 2])));
 f4 = Math_fround(HEAPF32[i7 + 4 >> 2]);
 f4 = Math_fround(_fmaxf(f4, Math_fround(HEAPF32[i6 + 4 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZN13ModuleManager4LoadEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 3088 | 0;
 if (HEAP8[i3 >> 0] | 0) return;
 __Z39RegisterStaticallyLinkedModulesGranularv();
 __ZN35RegisterRuntimeInitializeAndCleanup22ExecuteInitializationsEv();
 i4 = i2 + 3084 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i1 = 0;
  do {
   i5 = i2 + 2316 + (i1 * 12 | 0) | 0;
   if (!(HEAP8[i2 + 2316 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_vi(HEAP32[i5 >> 2] | 0, i2 | 0); else mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i2 + 2316 + (i1 * 12 | 0) + 4 >> 2] | 0, i2 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 HEAP8[i3 >> 0] = 1;
 return;
}

function __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 do if (!i1) i3 = gb + 1162356 | 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) i3 = gb + 1162356 | 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
   i3 = (HEAP32[i4 + 896 >> 2] | 0) + 804 | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 return;
}

function __Z49WheelCollider_CUSTOM_INTERNAL_get_forwardFrictionP12Il2CppObjectP18WheelFrictionCurve(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 104 | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
  return;
 }
}

function __Z22IsValidPolynomialCurveRK17AnimationCurveTplIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if ((i2 | 0) > 3) {
  i2 = 0;
  return i2 | 0;
 }
 if ((i2 | 0) < 2) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if (!((i5 ? f4 : f3) <= Math_fround(.0000999999974))) {
  i5 = 0;
  return i5 | 0;
 }
 f4 = Math_fround(Math_fround(HEAPF32[i1 + (i2 + -1 << 4) >> 2]) + Math_fround(-1.0));
 i5 = f4 < Math_fround(0.0);
 f3 = Math_fround(-f4);
 i5 = (i5 ? f3 : f4) <= Math_fround(.0000999999974);
 return i5 | 0;
}

function _cacos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _casin(i5, i6);
 d4 = -+HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = 1.5707963267948966 - +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZN7mecanim9animation21DestroyAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 96 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN6Sprite13PivotToOffsetERK5RectTIfERK8Vector2f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f7 = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 f4 = Math_fround(Math_fround(f8 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 4 >> 2]))) - Math_fround(f8 + Math_fround(f4 * Math_fround(.5))));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f6 + f7) - Math_fround(f6 + Math_fround(f5 * Math_fround(.5))));
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN4FMOD7Channel20set3DConeOrientationEP11FMOD_VECTOR(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 858990;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN4FMOD5Sound7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 212 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   __ZN4FMOD6SoundI7releaseEv(i2) | 0;
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853481;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN23MeshVertexFormatManager10ReleaseAllEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i5 = i1 + 4 | 0;
 if ((i2 | 0) == (i5 | 0)) return;
 while (1) {
  i1 = HEAP32[i2 + 92 >> 2] | 0;
  i3 = i2 + 96 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -16 - i1 | 0) >>> 4) << 4);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i5 | 0)) break; else i2 = i1;
 }
 return;
}

function __Z51ReflectionProbe_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i3 + 108 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 112 >> 2] = i5;
  HEAP32[i3 + 116 >> 2] = i4;
  HEAP32[i3 + 120 >> 2] = i1;
  return;
 }
}

function __Z48NavMeshAgent_CUSTOM_INTERNAL_get_pathEndPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent27GetEndPositionOfCurrentPathEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GUIStyle_CUSTOM_AssignRectOffsetP12Il2CppObjecti13Il2Cpp_IntPtr(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = i1 + 176 + (i4 << 4) | 0;
   HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37328 >> 2] | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[gb + 37212 >> 2] | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __Z15Hash128ToStringRK7Hash128(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i2, 32, 0);
 i4 = i2 + 11 | 0;
 i1 = 0;
 do {
  if ((HEAP8[i4 >> 0] | 0) < 0) i5 = HEAP32[i2 >> 2] | 0; else i5 = i2;
  HEAP32[i6 >> 2] = HEAPU8[i3 + i1 >> 0];
  _snprintf(i5 + (i1 << 1) | 0, 3, gb + 488720 | 0, i6) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 STACKTOP = i7;
 return;
}

function _Split_Conic(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 32 >> 2] = i3;
 i5 = i1 + 8 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i3 = (i4 + i3 | 0) / 2 | 0;
 HEAP32[i1 + 24 >> 2] = i3;
 i4 = ((HEAP32[i1 >> 2] | 0) + i4 | 0) / 2 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i2 >> 2] = (i4 + i3 | 0) / 2 | 0;
 i2 = i1 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 + 36 >> 2] = i3;
 i4 = i1 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = (i5 + i3 | 0) / 2 | 0;
 HEAP32[i1 + 28 >> 2] = i3;
 i1 = ((HEAP32[i1 + 4 >> 2] | 0) + i5 | 0) / 2 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i2 >> 2] = (i1 + i3 | 0) / 2 | 0;
 return;
}

function _jpeg_start_compress(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != 100) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 20;
  HEAP32[i5 + 24 >> 2] = i4;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
 }
 if (i2 << 24 >> 24) _jpeg_suppress_tables(i1, 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 _jinit_compress_master(i1);
 mftCall_vi(HEAP32[HEAP32[i1 + 316 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP8[i1 + 176 >> 0] | 0 ? 102 : 101;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcjj(i2, i5, i4, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (!i6) i1 = -1; else {
  i3 = i2;
  i1 = i2 + (i1 >>> 0 > i4 >>> 0 ? i4 + 1 | 0 : i1) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) {
    i1 = -1;
    break L5;
   }
   i1 = i1 + -1 | 0;
   if (__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i5, i6, i1) | 0) {
    i1 = i1 - i3 | 0;
    break;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (!i1) i3 = 3; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i5 = HEAP16[i4 + 32 >> 1] | 0;
  i2 = (i5 & 255) << 24 >> 24 != 0;
  i1 = i4 + 33 | 0;
  if (!((i5 & 65535) > 255 ^ i2)) return;
  if (i2) {
   HEAP8[i1 >> 0] = 1;
   mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0);
   return;
  }
 } else i3 = 3;
 if ((i3 | 0) == 3) {
  i1 = i4 + 33 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) return;
 }
 HEAP8[i1 >> 0] = 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN2UI11CanvasGroup12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i2, gb + 1106076 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN25ParticleSystemGeometryJob13ReleaseMemJobEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1452212 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1452212 | 0, i1);
  i1 = gb + 1452212 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN19StreamedBinaryWriteILb1EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i1 >> 2] = i3;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 return i6 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i1 >> 2] = i3;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 i6 = i1 + 36 | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = i5;
 i6 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i6 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 return i6 | 0;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueueD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv(i1);
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) != (i3 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 85;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 STACKTOP = i6;
 return;
}

function __ZN10UnityScene23CreateLevelGameManagersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 304 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 288 | 0;
 i3 = i2 + 8 | 0;
 i5 = i2;
 i8 = gb + 64016 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN18AwakeFromLoadQueueC2E10MemLabelId(i3, i4);
 __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue(i1, i3);
 __ZN18AwakeFromLoadQueueD2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z51ReflectionProbe_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 112 >> 2] | 0;
  i4 = HEAP32[i3 + 116 >> 2] | 0;
  i1 = HEAP32[i3 + 120 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 108 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i1;
  return;
 }
}

function __Z49Mesh_CUSTOM_INTERNAL_CALL_GetNativeIndexBufferPtrP12Il2CppObjectRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i1, i3, HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 96 >> 2] | 0, 0, 0) | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 724 >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0) | 0;
 STACKTOP = i4;
 return;
}

function __Z14FMOD_FILE_ReadPvS_jPjS_(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 if (!i2) {
  i5 = 33;
  STACKTOP = i6;
  return i5 | 0;
 }
 i7 = i1;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 if (__ZN12FileAccessor4ReadEyPvPy(i2, i4, 0, i3, i1) | 0) {
  i2 = i1;
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  if (i5 | 0) HEAP32[i5 >> 2] = i1;
  i1 = i2 >>> 0 < 0 | (i2 | 0) == 0 & i1 >>> 0 < i4 >>> 0 ? 22 : 0;
 } else i1 = 19;
 i7 = i1;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i2 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(HEAP32[gb + 1161932 >> 2] | 0, i1) | 0;
 if ((i1 | 0) == ((HEAP32[gb + 1161932 >> 2] | 0) + 4 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 return i2 | 0;
}

function __ZN8LODGroup20ClearCachedRenderersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) {
  HEAP32[i5 >> 2] = 0;
  return;
 }
 i4 = i1 + 76 | 0;
 i3 = 0;
 i1 = i2;
 do {
  i2 = (HEAP32[i4 >> 2] | 0) + (i3 << 2) | 0;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] = 0;
  i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i1 = (HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0) + (i2 * 24 | 0) + 12 | 0;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i1 + 4 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN7ApiGLES5QueryEN2gl6HandleILNS0_10ObjectTypeE4EEENS0_11QueryResultE(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = HEAP32[i2 + 800 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i7 = 3; else if ((HEAP32[i2 + 1988 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i7 = 3; else i1 = -1;
 mftCall_viii(i6 | 0, i1 | 0, i4 | 0, i5 | 0);
 i6 = i5;
 i7 = HEAP32[i6 >> 2] | 0;
 setTempRet0(HEAP32[i6 + 4 >> 2] | 0);
 STACKTOP = i8;
 return i7 | 0;
}

function __ZN5physx7NpClothD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = gb + 94588 + 8;
 i1 = HEAP32[i3 + 124 >> 2] | 0;
 i2 = i1 + 12 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 1) HEAP32[i3 + 64 >> 2] = 0;
 i1 = i1 + 8 | 0;
 if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i2) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZN5physx3Scb5ClothD2Ev(i3 + 20 | 0);
 HEAP32[i3 >> 2] = gb + 95136 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i3);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra9BitVector5resetEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = (i1 + 31 | 0) >>> 5;
 i4 = i2 + 8 | 0;
 if (i3 >>> 0 <= (HEAP32[i4 >> 2] | 0) >>> 0) {
  HEAP32[i4 >> 2] = i3;
  return;
 }
 i5 = i2 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i1 | 0) {
  i6 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 12 >> 2] | 0, i6 | 0, i1 + -16 | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, (i3 << 2) + 16 | 0, 0) | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = i3;
  i1 = i1 + 16 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = i3;
 return;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE18RegisterAllocationEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = (HEAP32[i2 + -8 >> 2] | 0) >>> 1;
 i3 = i1 + 16 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + i4 | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 23;
 i3 = i1 + 24 | 0;
 if (i5 >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) HEAP32[i3 >> 2] = i5;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 i5 = i1 + 20 | 0;
 HEAP32[i5 >> 2] = i4 + 23 + (HEAP32[i5 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv(i1, i2) | 0;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProviderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148124 + 8;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0);
 HEAP32[i2 + 32 >> 2] = gb + 148188 + 8;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[i2 + 36 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 HEAP32[i2 + 12 >> 2] = gb + 148172 + 8;
 i3 = i2 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i3 >> 2] | 0);
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN12NavMeshAgent13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 do if (!i1) i3 = gb + 1162356 | 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) i3 = gb + 1162356 | 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
   i3 = (HEAP32[i4 + 900 >> 2] | 0) + 164 | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 return;
}

function __Z36GameObject_CUSTOM_INTERNAL_get_sceneP12Il2CppObjectPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
 if (!i1) {
  i2 = 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
 i1 = __ZN9Transform8GetSceneEv(i1) | 0;
 if (!i1) {
  i2 = 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __Z21FindTransformWithNameP9TransformPKc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if (!(_strcmp(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0, i4) | 0)) {
  i5 = i1;
  return i5 | 0;
 }
 i5 = i1 + 80 | 0;
 i3 = i1 + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) i2 = 0; else {
  i5 = 0;
  return i5 | 0;
 }
 while (1) {
  i1 = __Z21FindTransformWithNameP9TransformPKc(HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0, i4) | 0;
  i2 = i2 + 1 | 0;
  if (i1 | 0) {
   i2 = 5;
   break;
  }
  if ((i2 | 0) >= (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function _UNITY_tt_face_load_hhea(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i3 + 508 >> 2] | 0;
 do if (!(i1 << 24 >> 24)) {
  i1 = mftCall_iiiii(i2 | 0, i3 | 0, 1751672161, i4 | 0, 0) | 0;
  if (!i1) {
   i2 = i3 + 216 | 0;
   break;
  } else {
   i4 = i1;
   return i4 | 0;
  }
 } else {
  i1 = mftCall_iiiii(i2 | 0, i3 | 0, 1986553185, i4 | 0, 0) | 0;
  if (!i1) i2 = i3 + 296 | 0; else {
   i4 = i1;
   return i4 | 0;
  }
 } while (0);
 i1 = _UNITY_FT_Stream_ReadFields(i4, gb + 223820 | 0, i2) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 i4 = 0;
 return i4 | 0;
}

function _tt_cmap0_validate(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i5 + 8 | 0;
 if ((i3 + 4 | 0) >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i5, 8);
 i4 = (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i3 + 3 >> 0] | 0);
 if (i4 >>> 0 < 262 ? 1 : (i3 + i4 | 0) >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i5, 8);
 if (!(HEAP32[i5 + 12 >> 2] | 0)) return 0;
 i4 = i5 + 20 | 0;
 i2 = 0;
 i1 = i3 + 6 | 0;
 while (1) {
  if ((HEAPU8[i1 >> 0] | 0) >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) _UNITY_ft_validator_error(i5, 16);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == 256) break; else i1 = i1 + 1 | 0;
 }
 return 0;
}

function _start_pass_dpost(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 396 >> 2] | 0;
 do if (!i1) {
  if (!(HEAP8[i2 + 74 >> 0] | 0)) {
   HEAP32[i3 + 4 >> 2] = HEAP32[(HEAP32[i2 + 416 >> 2] | 0) + 4 >> 2];
   break;
  }
  HEAP32[i3 + 4 >> 2] = fb + 23;
  i1 = i3 + 12 | 0;
  if (!(HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = mftCall_iiiiii(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, HEAP32[i3 + 8 >> 2] | 0, 0, HEAP32[i3 + 16 >> 2] | 0, 1) | 0;
 } else {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i1 >> 2] | 0, i2 | 0);
 } while (0);
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 return;
}

function _empty_mem_output_buffer(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 i5 = i4 + 36 | 0;
 i6 = HEAP32[i5 >> 2] << 1;
 i7 = _malloc(i6) | 0;
 if (!i7) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 54;
  HEAP32[i3 + 24 >> 2] = 10;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
 }
 i1 = i4 + 32 | 0;
 _memcpy(i7 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 i2 = i4 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) _free(i3);
 HEAP32[i2 >> 2] = i7;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i4 >> 2] = i7 + i3;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = i7;
 HEAP32[i5 >> 2] = i6;
 return 1;
}

function __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i4 + 8 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i3 = i3 + -16 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i3);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0, i1, (HEAP32[i4 + 12 >> 2] | 0) - i1 | 0);
 return;
}

function __ZNK5physx3Cct8SweptBox18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E(i5, i4, i1, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f9 = Math_fround(HEAPF32[i5 + 44 >> 2]);
 f8 = Math_fround(HEAPF32[i5 + 48 >> 2]);
 f7 = Math_fround(Math_fround(HEAPF32[i5 + 40 >> 2]) * Math_fround(2.0));
 f6 = Math_fround(HEAPF32[i4 + 260 >> 2]);
 __ZN5physx3Cct18computeTemporalBoxERNS_17PxExtendedBounds3EffffRKNS_6PxVec3ERKNS_14PxExtendedVec3ES5_(i1, f9 > f8 ? f9 : f8, f7, f6, Math_fround(HEAPF32[i4 + 272 >> 2]), i4 + 244 | 0, i2, i3);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIjfE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24) >>> 0);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx7NpScene7setFlagENS_11PxSceneFlag4EnumEb(i8, i2, i3) {
 i8 = i8 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i8 + 3388 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i8 + 1224 | 0;
 i7 = i8 + 3364 | 0;
 i1 = HEAP16[((i5 & 4 | 0) == 0 ? i6 : i7) >> 1] | 0;
 if (i3) i1 = (i1 & 65535 | i2) & 65535; else i1 = i1 & ((i2 ^ 65535) & 65535);
 if (!(HEAP8[i8 + 2449 >> 0] | 0)) {
  i8 = i8 + 32 | 0;
  HEAP16[i6 >> 1] = i1;
  __ZN5physx2Sc5Scene6setPCMEb(i8, (i1 & 512) != 0);
  __ZN5physx2Sc5Scene15setContactCacheEb(i8, (i1 & 2048) == 0);
  return;
 } else {
  HEAP16[i7 >> 1] = i1;
  HEAP32[i4 >> 2] = i5 | 4;
  return;
 }
}

function __ZN5physx32PxVehicleTireDataGeneratedValuesC2EPKNS_17PxVehicleTireDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 40 >> 2];
 i3 = i1 + 32 | 0;
 i1 = i2 + 16 | 0;
 i2 = i3 + 24 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN5physx2Gu21intersectSphereSphereERKNS0_6SphereES3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 4 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i1 + 8 >> 2]));
 f4 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3)) + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i2 + 12 >> 2]));
 return f4 <= Math_fround(f3 * f3) | 0;
}

function __ZN4FMOD12ChannelGroup8setPitchEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 862547;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13BoxCollider2D10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  STACKTOP = i4;
  return;
 }
 if (!(__Z18CalculateLocalAABBRK10GameObjectP4AABB(i3, i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAPF32[i1 + 160 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 12 >> 2]) * Math_fround(2.0));
 HEAPF32[i1 + 164 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(2.0));
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 4 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN12MeshCollider12SetSkinWidthEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(1.00000005e-20);
 i4 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i4 ? Math_fround(340282326000000008404918.0e15) : f1;
 f1 = i2 ? Math_fround(1.00000005e-20) : f1;
 HEAPF32[i3 + 124 >> 2] = f1;
 if (!(HEAP8[i3 + 60 >> 0] | 0)) return;
 if (!(HEAP8[i3 + 121 >> 0] | 0)) return;
 if (!(f1 != Math_fround(HEAPF32[i3 + 128 >> 2]))) return;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN8GradientC2Ev(i4);
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[i1 + 4 >> 2] | 0, gb + 1033990 | 0, i4, HEAP32[i1 + 24 >> 2] | 0);
 __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_(i4, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 STACKTOP = i3;
 return;
}

function __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 do if (!i1) i3 = gb + 1162356 | 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) i3 = gb + 1162356 | 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
   i3 = (HEAP32[i4 + 892 >> 2] | 0) + 800 | 0;
   break;
  }
 } while (0);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 return;
}

function __Z25SetPolynomialCurveToValueR17AnimationCurveTplIfER24OptimizedPolynomialCurvef(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 8 | 0;
 HEAPF32[i6 >> 2] = f3;
 __ZN11KeyframeTplIfEC2EfRKf(i5, Math_fround(0.0), i6);
 __ZN11KeyframeTplIfEC2EfRKf(i5 + 16 | 0, Math_fround(1.0), i6);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1, i5, i5 + 32 | 0);
 __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf(i2, i1, Math_fround(1.0)) | 0;
 STACKTOP = i4;
 return;
}

function _tre_neg_char_classes_match(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 L1 : do if (!i3) i1 = 0; else {
  i4 = (i1 | 0) == 0;
  i1 = i3;
  while (1) {
   if (i4) {
    if (_iswctype(i5, i1) | 0) {
     i1 = 1;
     break L1;
    }
   } else {
    i3 = _towupper(i5) | 0;
    if (_iswctype(i3, HEAP32[i2 >> 2] | 0) | 0) {
     i1 = 1;
     break L1;
    }
    i3 = _towlower(i5) | 0;
    if (_iswctype(i3, HEAP32[i2 >> 2] | 0) | 0) {
     i1 = 1;
     break L1;
    }
   }
   i2 = i2 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN33EarlyUpdateUpdatePreloadingstruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1450900 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450900 | 0, i1);
  i1 = gb + 1450900 | 0;
 } else i1 = 0;
 __ZN14PreloadManager16UpdatePreloadingEv(__Z17GetPreloadManagerv() | 0);
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN5physx9NpPhysics17sendMaterialTableERNS_7NpSceneE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 56 | 0;
 i5 = i1 + 52 | 0;
 i1 = 0;
 L1 : while (1) {
  i3 = HEAP32[i6 >> 2] | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 1;
   i2 = 7;
   break;
  }
  i4 = HEAP32[i5 >> 2] | 0;
  while (1) {
   i2 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   i1 = i1 + 1 | 0;
   if (i2 | 0) break;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = 1;
    i2 = 7;
    break L1;
   }
  }
  if (!(__ZN5physx7NpScene11addMaterialERNS_10NpMaterialE(i7, i2) | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingIfiE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  HEAP8[tempDoublePtr >> 0] = HEAP8[i1 >> 0];
  HEAP8[tempDoublePtr + 1 >> 0] = HEAP8[i1 + 1 >> 0];
  HEAP8[tempDoublePtr + 2 >> 0] = HEAP8[i1 + 2 >> 0];
  HEAP8[tempDoublePtr + 3 >> 0] = HEAP8[i1 + 3 >> 0];
  i3 = ~~Math_fround(HEAPF32[tempDoublePtr >> 2]);
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5audio5mixer17AssignOutputGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPN4FMOD12ChannelGroupE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = __ZN4FMOD12ChannelGroup8addGroupEPS0_(i3, HEAP32[HEAP32[i2 >> 2] >> 2] | 0) | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i3 = __ZL16FMOD_ErrorString11FMOD_RESULT_325(i1) | 0;
 HEAP32[i4 >> 2] = gb + 859765;
 HEAP32[i4 + 4 >> 2] = 1034;
 HEAP32[i4 + 8 >> 2] = i3;
 HEAP32[i4 + 12 >> 2] = i1;
 _printf_console(gb + 859725 | 0, i4);
 STACKTOP = i5;
 return;
}

function __ZN5Unity5Cloth12SetSuspendedEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 352 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) + (i1 ? 1 : -1) | 0;
 HEAP32[i4 >> 2] = i2;
 i4 = i3 + 228 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 if (i2 | 0) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 476 >> 2] | 0, i1 | 0) | 0)) {
  HEAP8[i3 + 356 >> 0] = 1;
  i4 = HEAP32[i4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 472 >> 2] | 0, i4 | 0);
  return;
 }
 i1 = i3 + 356 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i4 = HEAP32[i4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 468 >> 2] | 0, i4 | 0);
 return;
}

function __ZN19CollisionListener2DD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 154588 + 8;
 i1 = i2 + 204 | 0;
 if ((HEAP32[i2 + 220 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 208 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i2 + 176 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[i2 + 200 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 __ZdlPv(i2);
 STACKTOP = i4;
 return;
}

function __ZN14SpriteRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1161680 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1161680 | 0, i1);
  i1 = gb + 1161680 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN14RedirectHelper10RedirectToERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 i3 = i5 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN14RedirectHelper15PerformRedirectEPv(i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i4;
 return;
}

function __ZN14ConstantString12create_emptyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (i3 >>> 0 < (gb + 388687 | 0) >>> 0 | i3 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i4 = i3 + -8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i2, HEAP32[i3 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
  }
 }
 HEAP32[i1 >> 2] = gb + 388687 + 1051;
 STACKTOP = i5;
 return;
}

function __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 HEAP32[i6 >> 2] = HEAP32[gb + 62472 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[gb + 62472 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_(i3 + 36 | 0, i2, i1, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZN13OpenFileCacheD2Ev(i1) {
 i1 = i1 | 0;
 __ZN13OpenFileCache13ForceCloseAllEv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 208 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 196 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 184 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 172 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 160 | 0);
 __ZN4FileD2Ev(i1 + 128 | 0);
 __ZN4FileD2Ev(i1 + 96 | 0);
 __ZN4FileD2Ev(i1 + 64 | 0);
 __ZN4FileD2Ev(i1 + 32 | 0);
 __ZN4FileD2Ev(i1);
 return;
}

function __ZN12_GLOBAL__N_110Connection7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = i4 + 104 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0); else {
  i3 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
  if (i3 | 0) return;
 }
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0);
 i3 = HEAP32[i4 + 16 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN11Rigidbody2D15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67088 | 0, gb + 1105016 | 0, fb + 866 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67088 | 0, gb + 1105216 | 0, fb + 867 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67088 | 0, gb + 1105456 | 0, fb + 868 | 0, gb + 29632 | 0);
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 i7 = HEAP32[i1 + 80 >> 2] | 0;
 i5 = i3 + (i7 << 4) | 0;
 if (!i7) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 i1 = i3;
 do {
  i2 = i1 + 12 | 0;
  i3 = HEAP32[i6 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i2 >> 2] = i3;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z46AnimatorControllerPlayable_CUSTOM_GetIntegerIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 if ((i4 | 0) == 1) {
  i4 = HEAP32[i3 >> 2] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4, i2);
 i4 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_tt_face_goto_table(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i2 = HEAP32[i1 + 156 >> 2] | 0;
 i1 = HEAP16[i1 + 152 >> 1] | 0;
 i3 = i2 + ((i1 & 65535) << 4) | 0;
 if (!(i1 << 16 >> 16)) {
  i7 = 142;
  return i7 | 0;
 } else i1 = i2;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
   i2 = HEAP32[i1 + 12 >> 2] | 0;
   if (i2 | 0) break;
  }
  i1 = i1 + 16 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 142;
   i7 = 8;
   break;
  }
 }
 if ((i7 | 0) == 8) return i1 | 0;
 if (i6 | 0) HEAP32[i6 >> 2] = i2;
 i7 = _UNITY_FT_Stream_Seek(i5, HEAP32[i1 + 8 >> 2] | 0) | 0;
 return i7 | 0;
}

function __ZNK16TypeTreeIterator6FatherEv(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = (HEAPU8[i4 + (i3 * 24 | 0) + 2 >> 0] | 0) + -1 | 0;
 i3 = i4 + (i3 * 24 | 0) | 0;
 while (1) {
  i1 = i3;
  i3 = i3 + -24 | 0;
  if (i3 >>> 0 < i4 >>> 0) {
   i1 = 5;
   break;
  }
  if ((HEAPU8[i1 + -22 >> 0] | 0 | 0) == (i2 | 0)) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) {
  HEAP32[i5 >> 2] = i6;
  HEAP32[i5 + 4 >> 2] = (i3 - i4 | 0) / 24 | 0;
  return;
 } else if ((i1 | 0) == 5) {
  HEAP32[i5 >> 2] = 0;
  HEAP32[i5 + 4 >> 2] = 0;
  return;
 }
}

function __ZN9ShaderLab22SerializedBindChannelsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63280 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i3 = i4;
 HEAP32[i3 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 20 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN8VRDevice26ReleaseEyeTextureResourcesEPvP17RenderSurfaceBase(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 4 | 0;
 i5 = i6;
 i1 = HEAP32[i2 + 288 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return 0;
 }
 if (!(__ZNK19VREyeTextureManager16HasRenderSurfaceEP17RenderSurfaceBasePiS2_(i1, i3, i4, i5) | 0)) {
  STACKTOP = i6;
  return 0;
 }
 i1 = HEAP32[i2 + 224 >> 2] | 0;
 if (!i1) {
  STACKTOP = i6;
  return 0;
 }
 mftCall_iii(i1 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0) | 0;
 STACKTOP = i6;
 return 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = (HEAP32[i2 + 4 >> 2] | 0) - i5 >> 2;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, 4) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f4 = Math_fround(f4 * Math_fround(HEAPF32[i1 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 120 >> 2]);
 f5 = Math_fround(f4 + Math_fround(f5 * Math_fround(HEAPF32[i1 + 4 >> 2])));
 f4 = Math_fround(HEAPF32[i2 + 124 >> 2]);
 f4 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i1 + 8 >> 2])));
 i3 = i2 + 128 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) + f4);
 __ZN5physx15PxsParticleData13onOriginShiftERKNS_6PxVec3E(HEAP32[i2 + 16 >> 2] | 0, i1);
 return;
}

function __ZN4FMOD7Channel11set3DSpreadEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 858908;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN22ParticleCollisionEventC2ERK8Vector3fS2_S2_ii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i8 = i1 + 12 | 0;
 i7 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i8 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i8 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i7 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 36 >> 2] = i5;
 HEAP32[i1 + 40 >> 2] = i6;
 return;
}

function __ZN14TimerQueryGLESD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 77312 + 8;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = HEAP32[gb + 1098256 + 512 >> 2] | 0;
 if ((i1 | 0) == 128) {
  mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 796 >> 2] | 0, 128, gb + 1098256 | 0);
  HEAP32[gb + 1098256 + 512 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[gb + 1098256 + 512 >> 2] = i1 + 1;
 HEAP32[gb + 1098256 + (i1 << 2) >> 2] = i2;
 HEAP32[i3 >> 2] = gb + 77336 + 8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 i2 = i3 + 8 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
 __ZdlPv(i3);
 return;
}

function __ZN14PhysicMaterialC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 113008 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN13TrailRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1159828 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1159828 | 0, i1);
  i1 = gb + 1159828 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN13RenderManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i2;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = i1 + 60;
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 72 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z50ParticleSystem_CUSTOM_INTERNAL_set_startRotation3DP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem18SetStartRotation3DERK8Vector3f(i3, i2);
  return;
 }
}

function __Z47TerrainData_CUSTOM_INTERNAL_get_wavingGrassTintP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 192 >> 2] | 0;
  i4 = HEAP32[i3 + 196 >> 2] | 0;
  i1 = HEAP32[i3 + 200 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 188 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i1;
  return;
 }
}

function __Z47ShaderVariantCollection_CUSTOM_ContainsInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 return (__ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i5, i1, i3, i4) | 0) & 1 | 0;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i4 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i4 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i4;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i3, HEAP32[i1 + 4 >> 2] | 0, gb + 1034429 | 0, i2, HEAP32[i1 + 24 >> 2] | 0);
 __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_(i2, i3);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i3, i4, i5, i6, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i3); else {
  i1 = i1 - i5 | 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, (i2 ? HEAP32[i4 >> 2] | 0 : i4) + i5 | 0, i1 >>> 0 < i6 >>> 0 ? i1 : i6);
  return;
 }
}

function __ZN5physx2Gu8EdgeListD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 20 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 3 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 4 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN5physx22PxVehicleWheelsSimData21setTireLoadFilterDataERKNS_27PxVehicleTireLoadFilterDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 HEAPF32[i1 + 16 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(f3 - Math_fround(HEAPF32[i1 >> 2])));
 return;
}

function __ZN5physx11NpAggregate8requiresERNS_23PxProcessPxBaseCallbackE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 36 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = i1 + 40 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0;
  if ((i2 | 0) == 0 ? 1 : (HEAP16[i2 + 4 >> 1] | 0) != 15) mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i2 | 0); else {
   i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0) | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i2 | 0);
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN30ForwardShaderRenderLoopScratchD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 36792 + 8;
 HEAP32[i2 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  i1 = i2 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN30ForwardShaderRenderLoopScratchD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 36792 + 8;
 HEAP32[i1 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i1 + 136 >> 2] | 0) > -1) {
  i2 = i1 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 96 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 80 >> 2] | 0, i1 + 84 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayyPvPy(i1, i8, i4, i2, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = HEAP32[i8 + 1052 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 _fseek(i1, i4, 0) | 0;
 HEAP32[i7 >> 2] = _fread(i6, 1, i5, i1) | 0;
 HEAP32[i7 + 4 >> 2] = 0;
 switch (_ferror(i1) | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 case 18:
  {
   i1 = 10;
   break;
  }
 default:
  i1 = 14;
 }
 HEAP32[i8 + 1056 >> 2] = i1;
 i8 = (i1 | 0) == 0;
 return i8 | 0;
}

function __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 96 | 0;
 i4 = i3 + 48 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i4 = i1 + 200 | 0;
 i3 = i1 + 224 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i3 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP8[i4 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 return;
}

function __ZN16ScriptingManager18GetMonoScriptCacheEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 184 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = i4;
  i3 = i2;
 }
 L3 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) > (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 return i5 | 0;
}

function __ZN12LineRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1158268 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1158268 | 0, i1);
  i1 = gb + 1158268 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN12FlareManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1110812 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110812 | 0, i1);
  i1 = gb + 1110812 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT__4448(i1) {
 i1 = i1 | 0;
 if (!((__Z25scripting_class_get_flagsP11Il2CppClass(i1) | 0) & 8192)) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z27scripting_class_is_abstractP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z28scripting_class_is_interfaceP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 if ((i1 | 0) == (__Z20scripting_get_corlibv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage(__Z14GetMonoManagerv() | 0, i1) | 0) != -1;
 return i1 | 0;
}

function __Z46UploadHandlerRaw_CUSTOM_InternalGetContentTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i2); else {
  i5 = i1 + 12 | 0;
  i2 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 16 >> 2] | 0 : i2 & 255) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z39BillboardAsset_CUSTOM_SetImageTexCoordsP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 500475 | 0);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
  __ZN14BillboardAsset9SetImagesEPK8Vector4fj(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
  return;
 }
}

function __Z21SetShaderGlobalVectorN9ShaderLab16FastPropertyNameERK8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != -1 & (i3 & -1073741824 | 0) == 1073741824) {
  i3 = __Z12GetGfxDevicev() | 0;
  i3 = i3 + 4 + ((HEAP32[i1 >> 2] & 1073741823) << 4) | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  return;
 } else {
  __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, i1, i2, 0);
  return;
 }
}

function __Z15QueueScreenshotRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i1);
 i1 = mftCall_ii(fb + 1576 | 0, ((HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0) | 0;
 HEAP32[gb + 1162560 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 HEAP32[gb + 1162564 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 16 ? 16 : i2;
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i4 = i4 + -16 | 0;
   HEAP32[i3 >> 2] = i4;
   __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i4);
  }
  i4 = HEAP32[i1 >> 2] | 0;
  __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[i1 + 12 >> 2] | 0, i4, (HEAP32[i1 + 8 >> 2] | 0) - i4 | 0);
 }
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcj(i2, i6, i5) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i4 = _strlen(i6) | 0;
 L5 : do if (i1 >>> 0 > i5 >>> 0) {
  i3 = i2 + i1 | 0;
  i1 = i2 + i5 | 0;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) {
    i1 = -1;
    break L5;
   }
   if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i6, i4, i1) | 0)) break;
   i1 = i1 + 1 | 0;
  }
  i1 = i1 - i2 | 0;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZN9Rigidbody14SetConstraintsEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = i2 + 88 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 if (i1 & ~i3 | 0) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if (i1 | 0) if ((HEAP16[i1 + 4 >> 1] | 0) == 5) if (!((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1)) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 }
 HEAP32[i4 >> 2] = i3;
 __ZN9Rigidbody22UpdateMassDistributionEv(i2);
 return;
}

function __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, f6 = f0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  i5 = f6 < Math_fround(0.0);
  i3 = f6 > Math_fround(1.0);
  i3 = ~~Math_fround(Math_fround((i3 ? Math_fround(1.0) : f6) * Math_fround(255.0)) + Math_fround(.5)) >>> 0 << 8 | -65281;
  HEAP32[i4 >> 2] = i5 ? -65281 : i3;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIifE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 4 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 146452 + 8;
 i1 = i2 + 20 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv(i2);
  if (HEAP32[i1 >> 2] | 0) do mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); while ((HEAP32[i1 >> 2] | 0) != 0);
 }
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[HEAP32[i2 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc19ConstraintGroupNode7getRootEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i5 = i3;
  return i5 | 0;
 } else i4 = 1;
 while (1) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i2 = i4;
   break;
  } else {
   i4 = i4 + 1 | 0;
   i1 = i2;
  }
 }
 if (!i2) {
  i5 = i1;
  return i5 | 0;
 }
 HEAP32[i5 + 4 >> 2] = i1;
 i2 = i2 + -1 | 0;
 if (!i2) {
  i5 = i1;
  return i5 | 0;
 }
 do {
  i5 = i3;
  i3 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i5 + 4 >> 2] = i1;
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __ZN5physx20PxsParticleSystemSim23scheduleCollisionUpdateERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 1240 | 0;
 HEAP32[i2 + 1256 >> 2] = 1;
 i4 = i2 + 1252 | 0;
 HEAP32[i4 >> 2] = i1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 HEAP32[i2 + 1248 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2];
 HEAP32[i2 + 1228 >> 2] = 1;
 i1 = i2 + 1224 | 0;
 HEAP32[i1 >> 2] = i3;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
 HEAP32[i2 + 1220 >> 2] = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2];
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 return i2 + 1212 | 0;
}

function __ZN29MotionVectorRenderLoopScratchD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 36828 + 8;
 HEAP32[i2 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  i1 = i2 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN29MotionVectorRenderLoopScratchD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 36828 + 8;
 HEAP32[i1 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i1 + 136 >> 2] | 0) > -1) {
  i2 = i1 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 96 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 80 >> 2] | 0, i1 + 84 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN29DepthOrReplacementPassScratchD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 36896 + 8;
 HEAP32[i2 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  i1 = i2 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN29DepthOrReplacementPassScratchD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 36896 + 8;
 HEAP32[i1 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i1 + 136 >> 2] | 0) > -1) {
  i2 = i1 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 96 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 80 >> 2] | 0, i1 + 84 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN21AssetBundleFileSystemD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 73776 + 8;
 i2 = i1 + 92 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 96 | 0);
 __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev(i1 + 4 | 0);
 return;
}

function __ZN19SkinnedMeshRenderer24AnimatorModifiedCallbackEPvS0_i(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) != 3) return;
 i3 = i4 + 408 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i4);
 i1 = i4 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i4 + 384 | 0;
 i2 = i4 + 400 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i4 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN16UploadHandlerRawC2EPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187876 + 8;
 i4 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = 0;
 i5 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 if (!((i2 | 0) != 0 & (i3 | 0) != 0)) return;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, gb + 63808 | 0, 0, gb + 1027334 | 0, 12) | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i5 >> 2] = i3;
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 return;
}

function __ZN11HaloManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1110856 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1110856 | 0, i1);
  i1 = gb + 1110856 | 0;
 } else i1 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 11 >> 0] = 4;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 HEAP8[i1 + 4 >> 0] = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetRotationR9HPlayableRK11Quaternionf(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 __ZN23AnimationOffsetPlayable11SetRotationE11Quaternionf(i2, i1);
 STACKTOP = i4;
 return;
}

function __Z47UnityWebRequest_Get_Custom_PropDownloadProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (((HEAP32[i1 + 108 >> 2] | 0) + -2 | 0) >>> 0 >= 3) {
    f4 = Math_fround(-1.0);
    STACKTOP = i3;
    return Math_fround(f4);
   }
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return Math_fround(0.0);
}

function __Z40Avatar_CUSTOM_INTERNAL_CALL_GetLimitSignP12Il2CppObjectiR8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZNK6Avatar12GetLimitSignEi(i4, i5, i2);
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _stbir_resize(i1, i2, i11, i12, i13, i14, i15, i16, i17, i18, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i10, i1, i2, i11, i12, i13, i14, i15, i16, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i18, i3, i4, i17, i7, i8, i5, i6, i9) | 0;
}

function _nftw(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i8;
 i6 = i8 + 4 | 0;
 do if ((i3 | 0) < 1) i1 = 0; else {
  i7 = _strlen(i1) | 0;
  if (i7 >>> 0 > 4096) {
   HEAP32[(___errno_location() | 0) >> 2] = 36;
   i1 = -1;
   break;
  } else {
   _memcpy(i6 | 0, i1 | 0, i7 + 1 | 0) | 0;
   _pthread_setcancelstate(1, i5 | 0) | 0;
   i1 = _do_nftw(i6, i2, i3, i4, 0) | 0;
   _pthread_setcancelstate(HEAP32[i5 >> 2] | 0, 0) | 0;
   break;
  }
 } while (0);
 STACKTOP = i8;
 return i1 | 0;
}

function _frexpf(f1, i4) {
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i2 >>> 23;
 switch ((i3 & 255) << 24 >> 24) {
 case 0:
  {
   if (f1 != Math_fround(0.0)) {
    f1 = Math_fround(_frexpf(Math_fround(f1 * Math_fround(18446744099999997952.0)), i4));
    i2 = (HEAP32[i4 >> 2] | 0) + -64 | 0;
   } else i2 = 0;
   HEAP32[i4 >> 2] = i2;
   break;
  }
 case -1:
  break;
 default:
  {
   HEAP32[i4 >> 2] = (i3 & 255) + -126;
   f1 = (HEAP32[tempDoublePtr >> 2] = i2 & -2139095041 | 1056964608, Math_fround(HEAPF32[tempDoublePtr >> 2]));
  }
 }
 return Math_fround(f1);
}

function __ZThn8_N5physx2Gu10ConvexMeshD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 107052 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107052 + 84;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i3;
  return;
 }
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx13BigConvexDataD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, i2);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i8 = HEAPU8[i2 + i1 >> 0] | 0;
  i7 = HEAP32[i4 + (i8 * 12 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i4 + (i8 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i4 + (i8 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i7;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i6;
  HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i4 = HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i4) return;
 i5 = i2 + 24 | 0;
 i3 = i2 + 68 | 0;
 i2 = 0;
 while (1) {
  __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(HEAP32[(HEAP32[(HEAP32[i5 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 28 >> 2] | 0, i6, i7);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE6resizeEjRKb(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 16 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc20ArticulationJointSim7destroyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 30 | 0;
 if (HEAP16[i1 >> 1] & 2) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i2 + 24 | 0);
  HEAP16[i1 >> 1] = (HEAPU16[i1 >> 1] | 0) & 65533;
 }
 i1 = i2 + 4 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i1 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i2 + 8 >> 2] | 0, i2);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i2);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx15PxsParticleData6createERNS_24PxDeserializationContextE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 4 | 0;
 i6 = (HEAP32[i2 >> 2] | 0) + 15 & -16;
 i1 = i6;
 HEAP32[i1 >> 2] = gb + 96500 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 i4 = i1 + 80 | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = (i3 + 31 | 0) >>> 5;
 HEAP32[i1 + 56 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = i5 | -2147483648;
 i5 = (i5 << 2) + 15 & 1073741808;
 HEAP32[i1 + 48 >> 2] = i4 + i5;
 i5 = i5 + (i3 << 5) | 0;
 i4 = HEAP8[i1 + 12 >> 0] | 0 ? i4 + i5 | 0 : 0;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i2 >> 2] = i6 + (i5 + (i4 | 0 ? i3 << 2 : 0) + 68);
 return i1 | 0;
}

function __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[gb + 1451080 >> 2] | 0;
 if ((HEAP32[i5 + 868 >> 2] | 0) == (i2 | 0)) {
  if (HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 162 >> 0] | 0) {
   __ZN7ApiGLES11BindProgramEjb(i5, 0, 0);
   __ZN7ApiGLES11BindProgramEjb(HEAP32[gb + 1451080 >> 2] | 0, i2, i3);
  }
 } else __ZN7ApiGLES11BindProgramEjb(i5, i2, i3);
 if (i3) if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 660 >> 0] | 0) __ZN7ApiGLES16SetPatchVerticesEi(HEAP32[gb + 1451080 >> 2] | 0, i4);
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 7;
 return;
}

function __ZN2UI14CanvasRenderer19SetPopMaterialCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((HEAP32[i1 + 128 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i1 + 116 | 0, i2, i3, 1);
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 STACKTOP = i4;
 return;
}

function __ZN2UI14CanvasRenderer15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 187020 | 0, gb + 1105016 | 0, fb + 980 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 187020 | 0, gb + 1106076 | 0, fb + 981 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 187020 | 0, gb + 1106096 | 0, fb + 982 | 0, 0);
 return;
}

function __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i6, i7, i1, i2) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  i1 = HEAP32[i1 >> 2] | 0;
 } else {
  i6 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 >> 2] = i6;
  HEAP32[i2 >> 2] = i4;
  i1 = i6;
 }
 HEAP32[i7 >> 2] = _llvm_bswap_i32(i1 | 0) | 0;
 STACKTOP = i5;
 return;
}

function __ZN14SplatMaterials11SetSpecularERK11ColorRGBA32f(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i4 = i2 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i5 & 255) << 24 >> 24 == (i1 & 255) << 24 >> 24) if (!((i5 >>> 24 & 255) << 24 >> 24 != (i1 >>> 24 & 255) << 24 >> 24 | ((i5 >>> 16 & 255) << 24 >> 24 != (i1 >>> 16 & 255) << 24 >> 24 ? 1 : ((i5 & 65535) >>> 8 & 255) << 24 >> 24 != ((i1 & 65535) >>> 8 & 255) << 24 >> 24))) if (!(Math_fround(HEAPF32[i2 + 24 >> 2]) != f3)) return;
 HEAP32[i4 >> 2] = i1;
 HEAPF32[i2 + 24 >> 2] = f3;
 __ZN14SplatMaterials15UpdateMaterialsEv(i2);
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE13StaticDestroyES8_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceNull20SetRenderTargetsImplERK20GfxRenderTargetSetup(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = HEAP32[i3 + 36 >> 2] | 0;
 HEAP32[i2 + 4908 >> 2] = i4;
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   HEAP32[i2 + 4872 + (i1 << 2) >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  if ((i4 | 0) >= 8) {
   i3 = i3 + 32 | 0;
   i3 = HEAP32[i3 >> 2] | 0;
   i4 = i2 + 4904 | 0;
   HEAP32[i4 >> 2] = i3;
   return;
  }
 }
 i4 = i4 << 2;
 _memset(i2 + (i4 + 4872) | 0, 0, 32 - i4 | 0) | 0;
 i3 = i3 + 32 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + 4904 | 0;
 HEAP32[i4 >> 2] = i3;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 11 >> 0] = 5;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 HEAP8[i1 + 5 >> 0] = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z45UnityWebRequest_Get_Custom_PropUploadProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (((HEAP32[i1 + 108 >> 2] | 0) + -2 | 0) >>> 0 >= 3) {
    f4 = Math_fround(-1.0);
    STACKTOP = i3;
    return Math_fround(f4);
   }
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return Math_fround(0.0);
}

function __Z38DataUtility_CUSTOM_Internal_GetMinSizeP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  f4 = Math_fround(HEAPF32[i3 + 56 >> 2]);
  HEAPF32[i2 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i3 + 64 >> 2]));
  f4 = Math_fround(HEAPF32[i3 + 60 >> 2]);
  HEAPF32[i2 + 4 >> 2] = Math_fround(f4 + Math_fround(HEAPF32[i3 + 68 >> 2]));
  return;
 }
}

function __Z35LensFlare_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = i3 + 40 | 0;
  i4 = HEAP32[i5 + 4 >> 2] | 0;
  i1 = HEAP32[i5 + 8 >> 2] | 0;
  i3 = HEAP32[i5 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 12 >> 2] = i3;
  return;
 }
}

function __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK16b2PrismaticJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK16b2PrismaticJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN18AudioLowPassFilter18SetCutoffFrequencyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 f2 = Math_fround(Math_fround(f2 + Math_fround(-10.0)) / Math_fround(21990.0));
 i6 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.0);
 f2 = i7 ? Math_fround(1.0) : f2;
 HEAPF32[i5 >> 2] = i6 ? Math_fround(0.0) : f2;
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1 + 44 | 0, i4, i4 + 16 | 0);
 STACKTOP = i3;
 return;
}

function __ZN17ProceduralTexture16ResetAlphaSourceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i5 = HEAP32[i1 + 192 + 4 >> 2] | 0;
 i6 = HEAP32[i1 + 84 >> 2] | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = HEAP8[(__ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_(i6 + 272 | 0, i3) | 0) >> 0] | 0;
 i6 = i1 + 200 | 0;
 i4 = i6;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP8[i1 + 180 >> 0] = i3;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP8[i1 + 181 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function __ZN14SafeBinaryRead16EndArrayTransferEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 120 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + -1 | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i3) i1 = 0; else i1 = (HEAP32[i2 + 108 >> 2] | 0) + ((i1 + -2 | 0) * 12 | 0) | 0;
 HEAP32[i2 + 84 >> 2] = i1;
 i3 = i2 + 100 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 if (!i4) {
  i3 = 0;
  i4 = i2 + 80 | 0;
  HEAP32[i4 >> 2] = i3;
  i4 = i2 + 128 | 0;
  HEAP8[i4 >> 0] = 1;
  return;
 }
 i3 = (HEAP32[i2 + 88 >> 2] | 0) + (i1 + -2 << 5) | 0;
 i4 = i2 + 80 | 0;
 HEAP32[i4 >> 2] = i3;
 i4 = i2 + 128 | 0;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZL19stbir__filter_cubicff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 if (f1 < Math_fround(1.0)) {
  f2 = Math_fround(Math_fround(Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(f1 * Math_fround(3.0)) + Math_fround(-6.0))) + Math_fround(4.0)) / Math_fround(6.0));
  return Math_fround(f2);
 }
 if (!(f1 < Math_fround(2.0))) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(6.0) - f1)) + Math_fround(-12.0))) + Math_fround(8.0)) / Math_fround(6.0));
 return Math_fround(f2);
}

function __Z48NavMeshAgent_CUSTOM_INTERNAL_get_desiredVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent18GetDesiredVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43AnimatorControllerPlayable_CUSTOM_GetBoolIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 if ((i4 | 0) == 1) {
  i4 = HEAP8[i3 >> 0] | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4, i2);
 i4 = HEAP8[i3 >> 0] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z41Animator_CUSTOM_GetAnimatorTransitionInfoP12Il2CppObjecti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 if (!i2) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZNK8Animator25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo(i4, i3, i1) | 0;
  return;
 }
}

function __Z22Camera_CUSTOM_CopyFromP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (i1 | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i1 | 0) {
   if (!i3) {
    i2 = 0;
    __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
   if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
   __ZN6Camera8CopyFromERKS_(i2, i1);
   return;
  }
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 503083 | 0, 0, gb + 502764 | 0, 1460, 1, 0, 0, 0);
 return;
}

function _cacosf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i3 + 16 | 0;
 i6 = i3 + 8 | 0;
 i8 = i3;
 i9 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 + 4 >> 2] = i9;
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i8 + 4 >> 2];
 _casinf(i6, i7);
 f5 = Math_fround(HEAPF32[i6 >> 2]);
 f4 = Math_fround(-Math_fround(HEAPF32[i6 + 4 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(1.57079637) - f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZNK15b2RevoluteJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK15b2RevoluteJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK15b2FrictionJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK15b2FrictionJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK15b2DistanceJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 92 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK15b2DistanceJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK13b2PulleyJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 100 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK13WheelCollider15GetGlobalRadiusEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i1 + 72 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i5 + 4 >> 2]));
 i1 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = i1 ? f4 : f3;
 i1 = f3 < Math_fround(9.99999974e-06);
 f3 = i1 ? Math_fround(9.99999974e-06) : f3;
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN13InitialModule18SetInheritedParamsERK11ColorRGBA32RK8Vector3fS5_S5_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 2620 >> 2] = HEAP32[i2 >> 2];
 i2 = i1 + 2624 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i3 = i1 + 2636 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i4 = i1 + 2648 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 return;
}

function __Z48CharacterController_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN19CharacterController11GetVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45ShaderVariantCollection_CUSTOM_RemoveInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 return (__ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i5, i1, i3, i4) | 0) & 1 | 0;
}

function __Z42Camera_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 852 >> 2] | 0;
  i4 = HEAP32[i3 + 856 >> 2] | 0;
  i1 = HEAP32[i3 + 860 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 848 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i1;
  return;
 }
}

function __Z37Sprite_Get_Custom_PropPackingRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[(__ZNK6Sprite13GetRenderDataEb(i2, 1) | 0) + 32 >> 2] | 0;
 if (!(i1 & 1)) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 568494 | 0, i3); else {
  STACKTOP = i3;
  return i1 >>> 2 & 15 | 0;
 }
 return 0;
}

function __Z33BillboardAsset_CUSTOM_SetVerticesP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 500490 | 0);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 8) | 0;
  __ZN14BillboardAsset11SetVerticesEPK8Vector2fj(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
  return;
 }
}

function __Z30IntersectSphereSphereInclusiveRK6SphereS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 12 >> 2]));
 return Math_fround(f4 * f4) >= f3 | 0;
}

function __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiii11ColorRGBA32P8Materiali(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 var i11 = 0, i12 = 0, i13 = 0;
 i11 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i12 = i11 + 4 | 0;
 i13 = i11;
 HEAP32[i13 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i12 >> 2] = HEAP32[i13 >> 2];
 __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali(i1, i2, i3, i4, i5, i6, i7, Math_fround(1.0), i12, i9, i10);
 STACKTOP = i11;
 return;
}

function _jinit_phuff_decoder(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i1 | 0, 1, 64) | 0;
 HEAP32[i1 + 408 >> 2] = i3;
 HEAP32[i3 >> 2] = fb + 3277;
 i3 = i3 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i3 = i1 + 36 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i1 | 0, 1, HEAP32[i3 >> 2] << 8 | 0) | 0;
 HEAP32[i1 + 140 >> 2] = i2;
 if ((HEAP32[i3 >> 2] | 0) > 0) i1 = 0; else return;
 do {
  _memset(i2 + (i1 << 8) | 0, -1, 256) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareERKS5_(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 if (i3) i7 = HEAP32[i2 + 4 >> 2] | 0; else i7 = i1 & 255;
 i6 = HEAP8[i5 + 11 >> 0] | 0;
 i4 = i6 << 24 >> 24 < 0;
 i6 = i4 ? HEAP32[i5 + 4 >> 2] | 0 : i6 & 255;
 if (i3) i1 = HEAP32[i2 >> 2] | 0; else i1 = i2;
 i2 = i6 >>> 0 < i7 >>> 0;
 i1 = __ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1, i4 ? HEAP32[i5 >> 2] | 0 : i5, i2 ? i6 : i7) | 0;
 if (!i1) return (i7 >>> 0 < i6 >>> 0 ? -1 : i2 & 1) | 0; else return i1 | 0;
 return 0;
}

function __ZN8VRDevice22SetRenderViewportScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0, i5 = 0, i6 = 0;
 if (!(HEAP8[i2 + 330 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1044756 | 0, 0, gb + 1044184 | 0, 1253, 1, 0, 0, 0);
  return;
 }
 i5 = f1 < Math_fround(0.0);
 i6 = f1 > Math_fround(1.0);
 f1 = i6 ? Math_fround(1.0) : f1;
 f1 = i5 ? Math_fround(0.0) : f1;
 i2 = i2 + 312 | 0;
 f3 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f1);
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 if ((i5 ? f4 : f3) <= Math_fround(9.99999997e-07)) return;
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __ZN8Animator12StopPlaybackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 + 548 >> 2] = 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i3 = i1 + 420 | 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i3 : i4) >> 2];
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  STACKTOP = i2;
  return;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 HEAP8[i1 + 24 >> 0] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx20PxcNpCacheStreamPair7reserveEj(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 15 & -16;
 if (i5 >>> 0 > 16384) {
  i7 = -1;
  return i7 | 0;
 }
 i4 = i7 + 8 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i7 + 12 | 0;
 if (!i1) i6 = 4; else {
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 + i5 | 0) >>> 0 > 16384) i6 = 4;
 }
 if ((i6 | 0) == 4) {
  i1 = __ZN5physx17PxcNpMemBlockPool19acquireNpCacheBlockEv(HEAP32[i7 >> 2] | 0) | 0;
  HEAP32[i4 >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  if (!i1) {
   i7 = 0;
   return i7 | 0;
  } else i2 = 0;
 }
 HEAP32[i7 + 12 >> 2] = i2 + i5;
 i7 = i1 + i2 | 0;
 return i7 | 0;
}

function __ZN4FMOD7Channel6setPanEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i3 | 0) {
  i3 = HEAP32[(HEAP32[i3 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i3 | 0) if (!(HEAP8[i3 + 16 >> 0] | 0)) if ((HEAP32[i3 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859011;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN25DeferredRenderLoopScratchD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 36756 + 8;
 HEAP32[i2 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 136 >> 2] | 0) > -1) {
  i1 = i2 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 124 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN25DeferredRenderLoopScratchD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 36756 + 8;
 HEAP32[i1 + 48 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i1 + 136 >> 2] | 0) > -1) {
  i2 = i1 + 120 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 124 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 96 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 80 >> 2] | 0, i1 + 84 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN17GeneralConnection13GetConnectionEj(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 92 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 } else {
  i1 = i4;
  i3 = i2;
 }
 L3 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) > (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 return i5 | 0;
}

function __ZN16Physics2DManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 156040 + 8;
 i1 = i2 + 604 | 0;
 if ((HEAP32[i2 + 620 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 608 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 _memset(i2 + 68 | 0, 0, 536) | 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i2 + 64 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_(i1) {
 i1 = i1 | 0;
 if (!((__Z25scripting_class_get_flagsP11Il2CppClass(i1) | 0) & 8192)) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z27scripting_class_is_abstractP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z28scripting_class_is_interfaceP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 if ((i1 | 0) == (__Z20scripting_get_corlibv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage(__Z14GetMonoManagerv() | 0, i1) | 0) != -1;
 return i1 | 0;
}

function __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT__4326(i1) {
 i1 = i1 | 0;
 if (!((__Z25scripting_class_get_flagsP11Il2CppClass(i1) | 0) & 8192)) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z27scripting_class_is_abstractP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z28scripting_class_is_interfaceP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 if ((i1 | 0) == (__Z20scripting_get_corlibv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage(__Z14GetMonoManagerv() | 0, i1) | 0) != -1;
 return i1 | 0;
}

function __Z47NavMeshAgent_CUSTOM_INTERNAL_get_steeringTargetP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent17GetSteeringTargetEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42PolygonCollider2D_Set_Custom_PropPathCountP12Il2CppObjecti(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) {
  i4 = i3;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 __ZN9Polygon2D12SetPathCountEi(i2 + 160 | 0, i1);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
  __ZN17PolygonCollider2D11RefreshPolyEv(i1);
  return;
 }
}

function __Z40SpriteRenderer_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = HEAP32[i2 + 8 >> 2] | 0;
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  HEAP32[i3 + 344 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 348 >> 2] = i5;
  HEAP32[i3 + 352 >> 2] = i4;
  HEAP32[i3 + 356 >> 2] = i1;
  return;
 }
}

function __Z37GetParticlesLegacyScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1469452 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1049649 | 0, 16) | 0;
 HEAP32[gb + 1469452 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049809 | 0) | 0;
 HEAP32[HEAP32[gb + 1469452 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049818 | 0) | 0;
 HEAP32[(HEAP32[gb + 1469452 >> 2] | 0) + 4 >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 449 | 0, fb + 450 | 0);
 i1 = HEAP32[gb + 1469452 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_FT_Get_Module_Interface(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!((i1 | 0) != 0 & (i4 | 0) != 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i5 = i1 + 20 + (i3 << 2) | 0;
 if ((i3 | 0) <= 0) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = i1 + 20 | 0;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = i1 + 4 | 0;
  if (!(_strcmp(HEAP32[i3 + 8 >> 2] | 0, i4) | 0)) break;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i6 = 8;
   break;
  }
 }
 if ((i6 | 0) == 8) return i1 | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[i3 + 20 >> 2] | 0;
 return i6 | 0;
}

function __ZNK25SingleBlockMemoryFileData4ReadEyyPv(i4, i5, i1, i2, i3, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = _i64Add(i2 | 0, i3 | 0, i5 | 0, i1 | 0) | 0;
 i9 = getTempRet0() | 0;
 i8 = HEAP32[i4 + 28 >> 2] | 0;
 i7 = i9 >>> 0 > 0 | (i9 | 0) == 0 & i7 >>> 0 > i8 >>> 0;
 i8 = _i64Subtract(i8 | 0, 0, i5 | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 i2 = i7 ? i8 : i2;
 i1 = i7 ? i1 : i3;
 if ((i2 | 0) == 0 & (i1 | 0) == 0) {
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 _memcpy(i6 | 0, (HEAP32[i4 + 16 >> 2] | 0) + i5 | 0, i2 | 0) | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK13b2PulleyJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 92 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11b2GearJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 100 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11Rigidbody2D11GetPositionEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZNK9Transform11GetPositionEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  STACKTOP = i4;
  return;
 } else {
  i3 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  STACKTOP = i4;
  return;
 }
}

function __ZNK11AudioSource17GetSamplePositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = HEAP32[i1 + 528 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = i1 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = i3;
  STACKTOP = i5;
  return i4 | 0;
 }
 if (!(HEAP32[i2 + 16 >> 2] | 0)) {
  i4 = i3;
  STACKTOP = i5;
  return i4 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 __ZN20SoundChannelInstance14GetPositionPCMEPj(i1, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN9ShaderLab14PopParserStateEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[gb + 1166560 >> 2] | 0;
 i3 = i2 + 20 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 i7 = i6 + -1 | 0;
 i1 = i7 + i5 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i4 + (i1 >>> 10 << 2) >> 2] | 0) + ((i1 & 1023) << 2) >> 2] | 0;
 HEAP32[i3 >> 2] = i7;
 i2 = i2 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 - i4 | 0;
 if ((1 - i6 - i5 + ((i4 | 0) == 0 ? 0 : (i4 << 8) + -1 | 0) | 0) >>> 0 <= 2047) return i1 | 0;
 __ZdlPv(HEAP32[i3 + -4 >> 2] | 0);
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -4;
 return i1 | 0;
}

function __ZN5physx7NpScene12prepareSolveEfPvj(i7, f1, i5, i6) {
 i7 = i7 | 0;
 f1 = Math_fround(f1);
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP8[i7 + 3696 >> 0] = 1;
 HEAPF32[i7 + 3700 >> 2] = f1;
 __ZN5physx7NpScene9visualizeEv(i7);
 i2 = i7 + 3544 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i7 + 3540 | 0;
  i4 = 0;
  do {
   __ZN5physx12NpConstraint15updateConstantsEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 HEAP8[i7 + 2448 >> 0] = 1;
 if (HEAP8[i7 + 3698 >> 0] | 0) return;
 __ZN5physx2Sc5Scene15setScratchBlockEPvj(i7 + 32 | 0, i5, i6);
 return;
}

function __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i3 | 0) != 0 & (i4 | 0) != 0) {
  HEAP32[i2 + 8 >> 2] = i3;
  HEAP32[i2 + 12 >> 2] = i4;
  HEAP32[i2 + 16 >> 2] = i1 & 1;
  i4 = 1;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 725237 | 0, 69, gb + 725323 | 0, i5);
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN2UI14CanvasRenderer16SetMaterialCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((HEAP32[i1 + 108 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i1 + 96 | 0, i2, i3, 1);
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 STACKTOP = i4;
 return;
}

function __ZN26AnimatorOverrideController15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 178624 | 0, gb + 1105796 | 0, fb + 924 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 178624 | 0, gb + 1105816 | 0, fb + 925 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 178624 | 0, gb + 1105836 | 0, fb + 926 | 0, 0);
 return;
}

function __ZN13WheelCollider15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 159176 | 0, gb + 1105216 | 0, fb + 898 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 159176 | 0, gb + 1105496 | 0, fb + 899 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 159176 | 0, gb + 1105016 | 0, fb + 900 | 0, gb + 29192 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher16SetRequestHeaderERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i4;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i1 + 96 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 __Z6FormatPKcz(i5, gb + 1084502 | 0, i7);
 mftCall_viii(i6 | 0, i1 | 0, i2 | 0, i5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i4;
 return;
}

function __Z47Rigidbody_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody20GetWorldCenterOfMassEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleSystem_Set_Custom_PropUseAutoRandomSeedP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem17SetAutoRandomSeedEb(i3, i2 << 24 >> 24 != 0);
  return;
 }
}

function __Z46UnityWebRequest_CUSTOM_InternalGetCustomMethodP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i1 = i1 + 92 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    i2 = __Z20scripting_string_newPKc(i2) | 0;
    STACKTOP = i3;
    return i2 | 0;
   } else {
    i2 = i1;
    i2 = __Z20scripting_string_newPKc(i2) | 0;
    STACKTOP = i3;
    return i2 | 0;
   }
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z40SpriteRenderer_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 348 >> 2] | 0;
  i4 = HEAP32[i3 + 352 >> 2] | 0;
  i1 = HEAP32[i3 + 356 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 344 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i1;
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __Z17AppendMeshIndicesPtRjPKtjb(i4, i5, i2, i6, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i3 = 0;
 i3 = i6 << 1;
 i1 = HEAP32[i5 >> 2] | 0;
 if (i7) if (!i1) i1 = 0; else {
  HEAP16[i4 + (i1 << 1) >> 1] = HEAP16[i4 + (i1 + -1 << 1) >> 1] | 0;
  HEAP16[i4 + (i1 + 1 << 1) >> 1] = HEAP16[i2 >> 1] | 0;
  i1 = i1 + 2 | 0;
  HEAP32[i5 >> 2] = i1;
 }
 _memcpy(i4 + (i1 << 1) | 0, i2 | 0, i3 | 0) | 0;
 i1 = (HEAP32[i5 >> 2] | 0) + i6 | 0;
 HEAP32[i5 >> 2] = i1;
 if ((i6 & 1 | 0) == 0 | i7 ^ 1) return;
 HEAP16[i4 + (i1 << 1) >> 1] = HEAP16[i4 + (i1 + -1 << 1) >> 1] | 0;
 HEAP32[i5 >> 2] = i1 + 1;
 return;
}

function _jinit_inverse_dct(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i4 + 4 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i4 | 0, 1, 84) | 0;
 HEAP32[i4 + 412 >> 2] = i1;
 HEAP32[i1 >> 2] = fb + 3276;
 i6 = i4 + 36 | 0;
 if ((HEAP32[i6 >> 2] | 0) <= 0) return;
 i3 = i1 + 44 | 0;
 i1 = 0;
 i2 = HEAP32[i4 + 196 >> 2] | 0;
 while (1) {
  i7 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i4 | 0, 1, 256) | 0;
  HEAP32[i2 + 80 >> 2] = i7;
  _memset(i7 | 0, 0, 256) | 0;
  HEAP32[i3 + (i1 << 2) >> 2] = -1;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (HEAP32[i6 >> 2] | 0)) break; else i2 = i2 + 84 | 0;
 }
 return;
}

function _get_current_dir_name() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 160 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 76 | 0;
 i2 = i5;
 i3 = _getenv(gb + 1073779 | 0) | 0;
 if (!i3) i4 = 8; else if (!(HEAP8[i3 >> 0] | 0)) i4 = 8; else if (!(_stat(i3, i1) | 0)) if (!(_stat(gb + 1087625 | 0, i2) | 0)) if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) if ((HEAP32[i1 + 72 >> 2] | 0) == (HEAP32[i2 + 72 >> 2] | 0)) i1 = mftCall_ii(fb + 1576 | 0, i3 | 0) | 0; else i4 = 8; else i4 = 8; else i4 = 8; else i4 = 8;
 if ((i4 | 0) == 8) i1 = _getcwd(0, 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) i2 = 1; else {
  __THREW__ = 0;
  i1 = invoke_ii(fb + 2805 | 0, i1 | 0) | 0;
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i3);
  }
  if (!i1) i2 = 4; else {
   __THREW__ = 0;
   invoke_ii(fb + 2805 | 0, i1 | 0) | 0;
   i3 = __THREW__;
   __THREW__ = 0;
   if (i3 & 1) {
    i3 = ___cxa_find_matching_catch_3(0) | 0;
    getTempRet0() | 0;
    ___clang_call_terminate(i3);
   } else i2 = 4;
  }
 }
 return i2 | 0;
}

function __ZNK9Heightmap20CalculateNormalSobelEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, f8 = f0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 f8 = Math_fround(Math_fround(HEAPF32[i2 + 92 >> 2]) / Math_fround(32766.0));
 i7 = HEAP32[i2 + 96 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 + 88 >> 2];
 HEAPF32[i6 + 4 >> 2] = f8;
 HEAP32[i6 + 8 >> 2] = i7;
 __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f(i1, i3, i4, HEAP32[i2 + 72 >> 2] | 0, HEAP32[i2 + 76 >> 2] | 0, i2 + 4 | 0, i6);
 STACKTOP = i5;
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i8 = HEAPU8[i2 + i1 >> 0] | 0;
  i7 = HEAP32[i4 + (i8 * 12 | 0) + 4 >> 2] | 0;
  i6 = HEAP32[i4 + (i8 * 12 | 0) + 8 >> 2] | 0;
  HEAP32[i5 + (i1 << 4) >> 2] = HEAP32[i4 + (i8 * 12 | 0) >> 2];
  HEAP32[i5 + (i1 << 4) + 4 >> 2] = i7;
  HEAP32[i5 + (i1 << 4) + 8 >> 2] = i6;
  HEAPF32[i5 + (i1 << 4) + 12 >> 2] = Math_fround(0.0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZNK23ShaderVariantCollection15GetVariantCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i4 = i1 + 36 | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = 0;
 do {
  i1 = (((HEAP32[i2 + 24 >> 2] | 0) - (HEAP32[i2 + 20 >> 2] | 0) | 0) / 36 | 0) + i1 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i3) while (1) {
   i3 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) {
    i2 = i3;
    break;
   } else i2 = i3;
  } else {
   i2 = i3;
   while (1) {
    i3 = HEAP32[i2 >> 2] | 0;
    if (!i3) break; else i2 = i3;
   }
  }
 } while ((i2 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZNK12b2WheelJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK12b2WheelJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK12b2MouseJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 i1 = i1 + 32 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1); else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 }
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
 if (!i5) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8LODGroup16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i5 = i1 + 60 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 i2 = i4;
 if (((i4 - i1 | 0) / 28 | 0) >>> 0 <= 8) return;
 i4 = i1 + 224 | 0;
 if ((i2 | 0) == (i4 | 0)) return;
 while (1) {
  i1 = i2 + -28 | 0;
  HEAP32[i5 >> 2] = i1;
  i3 = i2 + -20 | 0;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Cct10ControllerD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i3 >> 2] = gb + 83836 + 8;
 i1 = HEAP32[i3 + 456 >> 2] | 0;
 if (i1 | 0) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i3 | 0);
  i1 = HEAP32[i3 + 400 >> 2] | 0;
  if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 }
 __ZN5physx3Cct9SweepTestD2Ev(i3 + 88 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD3DSP13disconnectAllEbb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = HEAP32[gb + 1459872 + (i3 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i3 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i3 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i2 >> 2] = 36;
 HEAP32[i2 + 4 >> 2] = gb + 857556;
 _printf(gb + 853184 | 0, i2) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i7;
 i2 = i6 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 > (HEAP32[i6 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  i1 = HEAP8[i1 >> 0] | 0;
 } else {
  i3 = HEAP8[i3 >> 0] | 0;
  HEAP8[i1 >> 0] = i3;
  HEAP32[i2 >> 2] = i4;
  i1 = i3;
 }
 HEAP8[i5 + 4 >> 0] = i1;
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i6);
 STACKTOP = i7;
 return;
}

function __ZN15ReflectionProbe28SetProbeDirtyAndCheckRefreshEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP8[i3 + 160 >> 0] = 1;
 if ((HEAP32[i3 + 40 >> 2] | 0) != 1) return;
 if ((HEAP32[i3 + 44 >> 2] | 0) != 1) return;
 i4 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 if (!i2) return;
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i5 = 8;
   break;
  }
 }
 if ((i5 | 0) == 8) return;
 __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(i4, 3, i3, 63);
 return;
}

function __ZN14SplatMaterialsC2ERK4PPtrI11TerrainDataERKS0_I8MaterialEPPKcRK11ColorRGBA32f(i6, i1, i2, i3, i4, f5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 8 >> 2] = -1;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i3;
 HEAP32[i6 + 20 >> 2] = HEAP32[i4 >> 2];
 HEAPF32[i6 + 24 >> 2] = f5;
 i1 = i6 + 28 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN14SplatMaterials16LoadSplatShadersEv(i6);
 __ZN14SplatMaterials15UpdateMaterialsEv(i6);
 return;
}

function __ZN14BatchAllocator6CommitERK10MemLabelId(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i6 >> 2] | 0, HEAP32[i6 + 8 >> 2] | 0, i1, 0, gb + 364691 | 0, 44) | 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 if (!i4) return;
 i5 = i3;
 i2 = 0;
 do {
  i1 = HEAP32[i6 + 12 + (i2 << 4) >> 2] | 0;
  if ((i1 | 0) == -1) i1 = 0; else i1 = (HEAP32[i6 + 12 + (i1 << 4) + 4 >> 2] | 0) + i5 | 0;
  HEAP32[(HEAP32[i6 + 12 + (i2 << 4) + 12 >> 2] | 0) + i1 >> 2] = i3 + (HEAP32[i6 + 12 + (i2 << 4) + 4 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE13StaticDestroyES5_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyPositionInternalP12Il2CppObjectR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator15GetBodyPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Quaternion_CUSTOM_INTERNAL_CALL_SlerpRK11QuaternionfS1_fRS_(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = f3 < Math_fround(0.0);
 i8 = f3 > Math_fround(1.0);
 f3 = i8 ? Math_fround(1.0) : f3;
 __Z5SlerpRK11QuaternionfS1_f(i6, i1, i2, i7 ? Math_fround(0.0) : f3);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 STACKTOP = i5;
 return;
}

function __Z19SetGlobalPreferencePKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, i1, _strlen(i1) | 0);
 __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z14PrepareJobDataRK15UpdateCrowdInfoPS_i(i4, i5, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0, i9 = 0;
 if ((i7 | 0) <= 0) return;
 i8 = i4 + 4 | 0;
 i9 = i4 + 8 | 0;
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = 0;
 i3 = 0;
 while (1) {
  HEAP32[i5 + (i2 << 4) >> 2] = HEAP32[i4 >> 2];
  HEAP32[i5 + (i2 << 4) + 4 >> 2] = HEAP32[i8 >> 2];
  i6 = (i1 | 0) / (i7 - i2 | 0) | 0;
  HEAP32[i5 + (i2 << 4) + 8 >> 2] = (HEAP32[i9 >> 2] | 0) + (i3 << 2);
  HEAP32[i5 + (i2 << 4) + 12 >> 2] = i6;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i7 | 0)) break; else {
   i1 = i1 - i6 | 0;
   i3 = i6 + i3 | 0;
  }
 }
 return;
}

function _UNITY_png_fixed_error(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i1 = i5;
 i2 = gb + 351959 | 0;
 i3 = i1 + 24 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 L1 : do if (!i4) i1 = 0; else {
  i1 = 0;
  do {
   i2 = HEAP8[i4 + i1 >> 0] | 0;
   if (!(i2 << 24 >> 24)) break L1;
   HEAP8[i5 + (i1 + 24) >> 0] = i2;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < 195);
 } while (0);
 HEAP8[i5 + (i1 + 24) >> 0] = 0;
 _UNITY_png_error(i6, i5);
}

function _tt_cmap14_ensure(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i7;
 i6 = i1 + 28 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 if (i4 >>> 0 >= i5 >>> 0) {
  i6 = 0;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i1 + 36 >> 2] = i2;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = _UNITY_ft_mem_realloc(i2, 4, i4, i5, HEAP32[i1 >> 2] | 0, i3) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  i6 = i1;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = i5;
 i6 = 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__210__time_put8__do_putEPcRS1_PK2tmcc(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i10;
 HEAP8[i7 >> 0] = 37;
 i8 = i7 + 1 | 0;
 HEAP8[i8 >> 0] = i5;
 i9 = i7 + 2 | 0;
 HEAP8[i9 >> 0] = i6;
 HEAP8[i7 + 3 >> 0] = 0;
 if (i6 << 24 >> 24) {
  HEAP8[i8 >> 0] = i6;
  HEAP8[i9 >> 0] = i5;
 }
 HEAP32[i3 >> 2] = i2 + (_strftime_l(i2 | 0, (HEAP32[i3 >> 2] | 0) - i2 | 0, i7 | 0, i4 | 0, HEAP32[i1 >> 2] | 0) | 0);
 STACKTOP = i10;
 return;
}

function __ZNK11b2WeldJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 92 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11b2WeldJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11b2RopeJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 76 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 80 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11b2RopeJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 68 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 72 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK11b2GearJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i2 + 48 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 92 >> 2]);
 f4 = Math_fround(f6 * f8);
 f7 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f4 = Math_fround(f4 - Math_fround(f7 * f3));
 f4 = Math_fround(Math_fround(HEAPF32[i5 + 12 >> 2]) + f4);
 f3 = Math_fround(Math_fround(f8 * f7) + Math_fround(f6 * f3));
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i5 + 16 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN9ShaderLab23ClearGrabPassFrameStateEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = __Z22GetRenderBufferManagerv() | 0;
 i1 = HEAP32[gb + 1166496 >> 2] | 0;
 if (i1 | 0) {
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i3, i1);
  HEAP32[gb + 1166496 >> 2] = 0;
 }
 i2 = HEAP32[gb + 1166496 + 16 >> 2] | 0;
 if ((i2 | 0) > 0) i1 = 0; else {
  HEAP32[gb + 1166496 + 16 >> 2] = 0;
  return;
 }
 do {
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i3, HEAP32[(HEAP32[gb + 1166496 + 4 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[gb + 1166496 + 16 >> 2] = 0;
 return;
}

function __ZN7dtCrowdD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN7dtCrowd5purgeEv(i1);
 __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE(i1 + 380 | 0, HEAP32[i1 + 384 >> 2] | 0);
 i2 = i1 + 260 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 80 | 0;
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 240 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
 __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_(i1, i3, i2, i6, i4, i5, i7, i8) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i9 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i9;
 HEAP8[i10 >> 0] = 0;
 i8 = __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i1, i3, i2, i6, i4, i5, i7, i8, 0, 0, i10) | 0;
 STACKTOP = i9;
 return i8 | 0;
}

function __ZN23MeshVertexFormatManager10GetDefaultEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo(i2, gb + 1546313 | 0, i4) | 0;
 i2 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN12EventManager20InvokeEventNonStaticEP10EventEntryPvi(i4, i2, i5, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) return; else i1 = i2;
 do {
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 do {
  i3 = i2 + 12 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 1) mftCall_viii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i5 | 0, i6 | 0);
  i1 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i4, i1);
 } while ((i2 | 0) != 0);
 return;
}

function __ZN12EventManager17InvokeEventCommonEPS_P10EventEntryPvi(i4, i2, i5, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) return; else i1 = i2;
 do {
  i3 = i1 + 12 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 do {
  i3 = i2 + 12 | 0;
  if ((HEAP32[i3 >> 2] | 0) > 1) mftCall_viii(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i5 | 0, i6 | 0);
  i1 = i2;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i4, i1);
 } while ((i2 | 0) != 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (_gettimeofday(i1 | 0, 0) | 0) {
  i3 = 0;
  i1 = 0;
  setTempRet0(i3 | 0);
  STACKTOP = i2;
  return i1 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i4 = ___muldi3(i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0, 1e3, 0) | 0;
 i3 = getTempRet0() | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) / 1e3 | 0;
 i3 = _i64Add(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, i4 | 0, i3 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN11DynamicMesh12CollapseEdgeEii(i1, i8, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i9 = 0;
 i9 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i9) return;
 i7 = HEAP32[i1 >> 2] | 0;
 i5 = i2 & 65535;
 i3 = 0;
 do {
  i6 = i7 + (i3 * 26 | 0) + 24 | 0;
  i1 = HEAP8[i6 >> 0] | 0;
  if (i1 << 24 >> 24) {
   i4 = 0;
   do {
    i2 = i7 + (i3 * 26 | 0) + 12 + (i4 << 1) | 0;
    if ((HEAPU16[i2 >> 1] | 0 | 0) == (i8 | 0)) {
     HEAP16[i2 >> 1] = i5;
     i1 = HEAP8[i6 >> 0] | 0;
    }
    i4 = i4 + 1 | 0;
   } while ((i4 | 0) < (i1 & 255 | 0));
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i9 >>> 0);
 return;
}

function __ZN10Effector2D13RemoveContactEP9b2Contact(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = i1 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i7 + (i2 * 40 | 0) | 0;
 i3 = i7;
 while (1) {
  if ((HEAP32[i3 + 32 >> 2] | 0) == (i5 | 0)) break;
  i3 = i3 + 40 | 0;
  if ((i3 | 0) == (i4 | 0)) {
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return;
 i2 = i2 + -1 | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = i7 + (i2 * 40 | 0) | 0;
 i2 = i3 + 40 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __Z34GetParticlesLegacyScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1469452 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1049649 | 0, 16) | 0;
 HEAP32[gb + 1469452 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049809 | 0) | 0;
 HEAP32[HEAP32[gb + 1469452 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049818 | 0) | 0;
 HEAP32[(HEAP32[gb + 1469452 >> 2] | 0) + 4 >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 449 | 0, fb + 450 | 0);
 i1 = HEAP32[gb + 1469452 >> 2] | 0;
 return i1 | 0;
}

function __Z19GL_CUSTOM_PopMatrixv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 __ZN11MatrixStack3PopEv(gb + 1179092 | 0);
 __ZN11MatrixStack3PopEv(gb + 1180120 | 0);
 __ZN11MatrixStack3PopEv(gb + 1181148 | 0);
 i1 = __ZNK11MatrixStack9GetMatrixEv(gb + 1179092 | 0) | 0;
 i3 = __ZNK11MatrixStack9GetMatrixEv(gb + 1180120 | 0) | 0;
 i4 = __ZNK11MatrixStack9GetMatrixEv(gb + 1181148 | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_get_iCCP(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if (!((i6 | 0) != 0 & ((i5 | 0) != 0 & ((i4 | 0) != 0 & (i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 4096 | 0) != 0 : 0))))) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 116 >> 2];
 i3 = HEAP32[i2 + 120 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i5 = i3;
 HEAP32[i6 >> 2] = (HEAPU8[i5 + 1 >> 0] | 0) << 16 | (HEAPU8[i5 >> 0] | 0) << 24 | (HEAPU8[i5 + 2 >> 0] | 0) << 8 | (HEAPU8[i5 + 3 >> 0] | 0);
 HEAP32[i4 >> 2] = 0;
 i6 = 4096;
 return i6 | 0;
}

function __ZNK12HandlerChain9IsSymLinkERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0) | 0) break;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 88 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 return i5 | 0;
}

function __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectPKcP12Il2CppObject(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(i2, i3, i4) | 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, gb + 28940 | 0) | 0;
 if (!i2) {
  i4 = i1;
  return i4 | 0;
 }
 i2 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i2) {
  i4 = i1;
  return i4 | 0;
 }
 do {
  i1 = i1 | (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i2 + 28 >> 2] | 0, i3, i4) | 0);
  i2 = HEAP32[i2 + 100 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __ZN8Animator24GetAnimatorClipInfoCountEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = __ZNK26AnimatorControllerPlayable24GetAnimatorClipInfoCountEib(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2, i3) | 0;
 return i5 | 0;
}

function __ZN5physx8debugger14PvdMarshallingIayE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = HEAP8[i1 >> 0] | 0;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIaxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i7 = HEAP8[i1 >> 0] | 0;
  i5 = ((i7 | 0) < 0) << 31 >> 31;
  i3 = i2;
  i6 = i3;
  HEAP8[i6 >> 0] = i7;
  HEAP8[i6 + 1 >> 0] = i7 >> 8;
  HEAP8[i6 + 2 >> 0] = i7 >> 16;
  HEAP8[i6 + 3 >> 0] = i7 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = i5;
  HEAP8[i3 + 1 >> 0] = i5 >> 8;
  HEAP8[i3 + 2 >> 0] = i5 >> 16;
  HEAP8[i3 + 3 >> 0] = i5 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx7NpScene11removeClothERNS_7NpClothE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 __ZN5physx3Scb5Scene11removeClothERNS0_5ClothE(i1 + 16 | 0, i5 + 20 | 0);
 i6 = i1 + 3652 | 0;
 i3 = i1 + 3656 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
 return;
}

function __ZN5physx7Cooking9setParamsERKNS_15PxCookingParamsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 28 >> 2];
 i2 = i2 + 36 | 0;
 i1 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = i5 + 160 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i5 + 156 | 0;
  i4 = 0;
  do {
   __ZN5physx2Sc8ClothSim12updateBoundsEv(__ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0) | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb(HEAP32[(HEAP32[i5 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1, 0);
 return;
}

function __ZN19ParticleSystemState28ClearSubEmitterCommandBufferEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 400 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 464 >> 2] = 0;
 HEAP32[i3 + 460 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 return;
}

function __ZN13RenderTexture15SetAntiAliasingEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 + -1 & (i2 | -8) | 0) {
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407881 | 0, 0, gb + 406201 | 0, 870, 1, i1, 0, 0);
  return;
 }
 i3 = i1 + 88 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407931 | 0, 0, gb + 406201 | 0, 873, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __Z46CharacterController_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN19CharacterController9GetCenterEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37UnityWebRequest_CUSTOM_InternalGetUrlP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2); else {
  i5 = i1 + 76 | 0;
  i2 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 80 >> 2] | 0 : i2 & 255) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z33Sprite_Get_Custom_PropPackingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[(__ZNK6Sprite13GetRenderDataEb(i2, 1) | 0) + 32 >> 2] | 0;
 if (!(i1 & 1)) __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 568494 | 0, i3); else {
  STACKTOP = i3;
  return i1 >>> 1 & 1 | 0;
 }
 return 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function _cff_get_cmap_info(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0) + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i4 = HEAP32[i1 + 196 >> 2] | 0;
 if ((i5 | 0) == (i4 + 64 | 0) | (i5 | 0) == (i4 + 104 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = _UNITY_ft_module_get_service(_UNITY_FT_Get_Module(i1, gb + 1007772 | 0) | 0, gb + 1008121 | 0) | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = mftCall_iii(i1 | 0, i2 | 0, i3 | 0) | 0;
 return i5 | 0;
}

function __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 147756 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i1 + 8 >> 2] = gb + 147756 + 80;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = gb + 147876 + 8;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i3) {
  __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
  return;
 }
 i1 = HEAP32[HEAP32[i1 + 100 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i3 | 0);
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_jj(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i3 = HEAP8[i5 + 8 + 3 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 i3 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i6 | 0;
  return __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj(i1, i2, i4, (i8 ? HEAP32[i5 >> 2] | 0 : i5) + (i6 << 2) | 0, i3 >>> 0 < i7 >>> 0 ? i3 : i7) | 0;
 }
 return 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZNK5physx20BigConvexDataBuilder16ComputeValenciesEjPKNS_16HullTriangleDataE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 HEAP32[i5 >> 2] = HEAPU8[(HEAP32[i3 >> 2] | 0) + 38 >> 0];
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP8[i5 + 16 >> 0] = 1;
 i3 = __ZNK5physx20BigConvexDataBuilder7ComputeERKNS_15VALENCIESCREATEE(i3, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK20LocalFileSystemPosix21GetAvailableDiskSpaceEPKcRy(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i3 + 8 | 0;
 if ((_statvfs(i4, i1) | 0) < 0) {
  HEAP32[i2 >> 2] = HEAP32[(___errno_location() | 0) >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  _printf_console(gb + 491460 | 0, i2);
  i5 = 0;
  STACKTOP = i3;
  return i5 | 0;
 } else {
  HEAP32[i5 >> 2] = Math_imul(HEAP32[i1 + 16 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
  HEAP32[i5 + 4 >> 2] = 0;
  i5 = 1;
  STACKTOP = i3;
  return i5 | 0;
 }
 return 0;
}

function __ZNK12HandlerChain8IsHiddenERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0) | 0) break;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 return i5 | 0;
}

function __ZNK12GUIClipState9GetOffsetEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i5;
 i2 = i4;
 if (((i5 - i4 | 0) / 56 | 0) >>> 0 > 2) {
  f8 = Math_fround(HEAPF32[i1 + -56 >> 2]);
  f6 = Math_fround(HEAPF32[i1 + -52 >> 2]);
  f7 = Math_fround(HEAPF32[i2 + 56 >> 2]);
  f6 = Math_fround(f6 - Math_fround(HEAPF32[i2 + 60 >> 2]));
  HEAPF32[i3 >> 2] = Math_fround(f8 - f7);
  HEAPF32[i3 + 4 >> 2] = f6;
  return;
 } else {
  HEAP32[i3 >> 2] = HEAP32[gb + 1162356 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
  return;
 }
}

function __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i1 + 36 >> 2] | 0) | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 4, 4) | 0;
 if (!i5) {
  i5 = 0;
  HEAP32[i3 >> 2] = i5;
  return i3 | 0;
 }
 i4 = i5 << 2;
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i4 | 0, 4) | 0;
 if ((i1 | 0) == (i1 + (i5 << 2) | 0)) {
  i5 = i1;
  HEAP32[i3 >> 2] = i5;
  return i3 | 0;
 }
 _memset(i1 | 0, 0, i4 | 0) | 0;
 i5 = i1;
 HEAP32[i3 >> 2] = i5;
 return i3 | 0;
}

function __ZN7mecanim8skeleton15DestroySkeletonEPNS0_8SkeletonERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx3Scb5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i3 + 2433 >> 0] | 0)) {
  i3 = __ZN5physx2Sc5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb(i3 + 16 | 0, i2, i1) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 682639 | 0, 1473, gb + 704089 | 0, i4);
  i3 = -1;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx2Sc35ParticleElementRbElementInteractionC2ERNS0_19ParticlePacketShapeERNS0_8ShapeSimERNS0_16ActorElementPairE(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i4 >> 2] = gb + 101220 + 8;
 HEAP16[i4 + 4 >> 1] = -1;
 HEAP16[i4 + 6 >> 1] = 1;
 __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i4 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i3 + 8 >> 2] | 0, 4, 12);
 HEAP32[i4 + 32 >> 2] = i2;
 HEAP32[i4 + 36 >> 2] = i3;
 HEAP32[i4 + 40 >> 2] = i1;
 HEAP32[i4 >> 2] = gb + 105688 + 8;
 HEAP32[i4 + 8 >> 2] = gb + 105688 + 52;
 HEAP16[i4 + 44 >> 1] = -1;
 HEAP8[i4 + 46 >> 0] = 0;
 return;
}

function __ZN5physx13NpVolumeCacheD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 101476 + 8;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
  i1 = HEAP32[i2 + 96 >> 2] | 0;
  if (i1 | 0) {
   i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
  }
 }
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if (!((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN20LocalFileSystemPosix5CloseER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i2 + 1052 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = i2 + 1056 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 if (!(_fclose(i3) | 0)) i1 = HEAP32[i2 >> 2] | 0; else {
  switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
  case 0:
   {
    i1 = 0;
    break;
   }
  case 13:
  case 1:
   {
    i1 = 9;
    break;
   }
  case 2:
   {
    i1 = 1;
    break;
   }
  case 18:
   {
    i1 = 10;
    break;
   }
  default:
   i1 = 14;
  }
  HEAP32[i2 >> 2] = i1;
 }
 i3 = (i1 | 0) == 0;
 return i3 | 0;
}

function __ZN12CachedWriter5WriteEPKvj(i6, i4, i2) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 + i2 | 0) >>> 0 < (HEAP32[i6 + 8 >> 2] | 0) >>> 0) {
  _memcpy(i1 | 0, i4 | 0, i2 | 0) | 0;
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i2;
  return;
 }
 if (!i2) return;
 i5 = i6 + 16 | 0;
 i3 = i2;
 i1 = i4;
 while (1) {
  i2 = HEAP32[i5 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
  i2 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i6, i1, i2);
  i3 = i3 - i2 | 0;
  if (!i3) break; else i1 = i1 + i2 | 0;
 }
 return;
}

function __ZN10MeshFilterC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 58216 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_(i1) {
 i1 = i1 | 0;
 if (!((__Z25scripting_class_get_flagsP11Il2CppClass(i1) | 0) & 8192)) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z27scripting_class_is_abstractP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z28scripting_class_is_interfaceP11Il2CppClass(i1) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 if ((i1 | 0) == (__Z20scripting_get_corlibv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage(__Z14GetMonoManagerv() | 0, i1) | 0) != -1;
 return i1 | 0;
}

function __Z45Rigidbody_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody18GetAngularVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42ShaderVariantCollection_CUSTOM_AddInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) {
  i5 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 }
 i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i5) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 return (__ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i5, i1, i3, i4) | 0) & 1 | 0;
}

function __Z34AnimationState_Get_Custom_PropNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2); else {
  i5 = i1 + 112 | 0;
  i2 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 116 >> 2] | 0 : i2 & 255) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __Z28SortingLayer_CUSTOM_IDToNamei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi(i3, __Z13GetTagManagerv() | 0, i1);
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i3 + 4 | 0 : i2, HEAP32[i3 + 20 >> 2] | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return i2 | 0;
 }
 if (!(HEAP32[i3 + 4 >> 2] | 0)) {
  STACKTOP = i4;
  return i2 | 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3 + 24 | 0);
 STACKTOP = i4;
 return i2 | 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __Z14SortGUIByDepthP10GUIElementS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 12 | 0;
 i4 = i3;
 __ZNK9Transform16GetLocalPositionEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i6 + 8 >> 2]);
 __ZNK9Transform16GetLocalPositionEv(i4, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 i2 = f5 < Math_fround(HEAPF32[i4 + 8 >> 2]);
 STACKTOP = i3;
 return i2 | 0;
}

function _trunc(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i5 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i4 | 0, i5 | 0, 52) | 0;
 getTempRet0() | 0;
 i2 = (i2 & 2047) + -1011 | 0;
 if ((i2 | 0) <= 63) {
  i6 = (i2 | 0) < 12;
  i2 = _bitshift64Lshr(-1, -1, i2 | 0) | 0;
  i3 = getTempRet0() | 0;
  i2 = i6 ? -1 : i2;
  i3 = i6 ? 2147483647 : i3;
  if (!((i2 & i4 | 0) == 0 & (i3 & i5 | 0) == 0)) {
   HEAP32[tempDoublePtr >> 2] = i4 & ~i2;
   HEAP32[tempDoublePtr + 4 >> 2] = i5 & ~i3;
   d1 = +HEAPF64[tempDoublePtr >> 3];
  }
 }
 return +d1;
}

function __ZZ23InitPlayerLoopCallbacksvEN41EarlyUpdateUpdateAllUnityWebStreamsstruct7ForwardEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1450888 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1450888 | 0, i1);
  i1 = gb + 1450888 | 0;
 } else i1 = 0;
 __ZN14UnityWebStream24UpdateAllUnityWebStreamsEv();
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmcc(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 4 | 0;
 i11 = i8;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 i7 = mftCall_iiiiiiii(i10 | 0, i1 | 0, i9 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmcc(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0, i9 = 0, i10 = 0, i11 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i8 + 4 | 0;
 i11 = i8;
 i10 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i11 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i11 >> 2];
 i7 = mftCall_iiiiiiii(i10 | 0, i1 | 0, i9 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 STACKTOP = i8;
 return i7 | 0;
}

function __ZNK9Transform16GetTransformTypeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = HEAP32[i4 + 64 >> 2] | 0;
 i1 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
 if ((i2 | 0) == -1) {
  i4 = i1;
  i3 = i4 >>> 1;
  i3 = i3 | -2;
  i3 = i3 ^ 1;
  i4 = i3 & i4;
  return i4 | 0;
 }
 do {
  i5 = HEAP32[i3 + (i2 << 2) >> 2] | 0;
  i1 = (i5 | i1) & -5 | (i5 ^ i1) & 4;
  i2 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
 } while ((i2 | 0) != -1);
 i5 = i1 >>> 1;
 i5 = i5 | -2;
 i5 = i5 ^ 1;
 i5 = i5 & i1;
 return i5 | 0;
}

function __ZNK6Camera9GetAspectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 if (HEAP8[i1 + 1086 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) {
  i3 = __Z14IsWorldPlayingv() | 0;
  i2 = HEAP32[i1 + 1108 >> 2] | 0;
  if (i3 & (i2 | 0) == 1 | (i2 | 0) == 8) {
   i3 = __Z12GetIVRDevicev() | 0;
   if (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i3 | 0) | 0) {
    i3 = __Z12GetIVRDevicev() | 0;
    f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0));
    return Math_fround(f4);
   }
  }
 }
 f4 = Math_fround(HEAPF32[i1 + 1060 >> 2]);
 return Math_fround(f4);
}

function __ZN9ShaderLab9SubShaderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 12 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  do {
   __ZN9ShaderLab4Pass7ReleaseEv(HEAP32[i1 >> 2] | 0);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i2 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 }
 __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i2 + 24 | 0, HEAP32[i2 + 28 >> 2] | 0);
 if ((HEAP32[i2 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc5Scene18clothPreprocessingEPNS_10PxBaseTaskE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i4 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i4 + 156 | 0;
  i3 = 0;
  do {
   __ZN5physx2Sc8ClothSim9startStepEv(__ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] | 0) | 0);
   i3 = i3 + 1 | 0;
  } while (i3 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i4 + 176 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i4 + 180 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx18NpArticulationLink9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i2, 0, i3, i1);
 i2 = HEAP32[i2 + 288 >> 2] | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i3 + 4 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i3 + 8 >> 2]) != Math_fround(0.0); else i1 = 1; else i1 = 1;
 __ZN5physx14NpArticulation14wakeUpInternalEbb(i2, i1, i4);
 return;
}

function __ZN5audio5mixer11IsSuspendedERKNS0_16AudioMixerMemoryE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i4 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE(i1, i2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP8[i3 >> 0] = 0;
 i2 = __ZN4FMOD3DSP9getActiveEPb(i1, i3) | 0;
 i3 = (i2 | 0) != 0 | (HEAP8[i3 >> 0] | 0) == 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5Umbra4Tome4initEPPKS0_PKhj(i4, i5, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i5) {
  i5 = 1;
  return i5 | 0;
 }
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i1 & 65535;
 if ((i1 & -65536 | 0) != -704643072) {
  i5 = (i2 | 0) == 214 ? 5 : 2;
  return i5 | 0;
 }
 if ((i2 | 0) != 18) {
  i5 = i2 >>> 0 > 18 ? 4 : 3;
  return i5 | 0;
 }
 if (i5 & 15 | 0) {
  i5 = 6;
  return i5 | 0;
 }
 if ((i1 | 0) == -1163018018) i1 = 0; else i1 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = i1 >>> 0 > i3 >>> 0;
 i1 = i3 ? 7 : 0;
 if (!((i4 | 0) != 0 & (i3 ^ 1))) {
  i5 = i1;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = i5;
 i5 = i1;
 return i5 | 0;
}

function __ZN5Umbra12RegionFinderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 24192 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 + 144 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 152 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 + 148 >> 2] | 0) + 12 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 120 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 124 >> 2];
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 88 >> 2];
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 52 >> 2];
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 16 >> 2];
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEEC2EPKcP15BucketAllocatorP13BaseAllocatorS9_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[gb + 27044 >> 2] = (HEAP32[gb + 27044 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 27044 >> 2];
 HEAP32[i1 >> 2] = gb + 26720 + 8;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = i5;
 HEAP32[i1 + 44 >> 2] = 0;
 return;
}

function __ZN18WheelFrictionCurve12SetToDefaultENS_9CurveTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   HEAPF32[i1 >> 2] = Math_fround(.400000006);
   HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(.800000011);
   HEAPF32[i1 + 12 >> 2] = Math_fround(.5);
   HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
   return;
  }
 case 1:
  {
   HEAPF32[i1 >> 2] = Math_fround(.200000003);
   HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
   HEAPF32[i1 + 8 >> 2] = Math_fround(.5);
   HEAPF32[i1 + 12 >> 2] = Math_fround(.75);
   HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
   return;
  }
 default:
  return;
 }
}

function __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2) {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i3 = i4 + 4 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) do {
   HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
   __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
   i1 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != 0);
 }
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN14Texture2DArray17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 108 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i2);
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 __ZN7Texture17MainThreadCleanupEv(i2);
 STACKTOP = i5;
 return;
}

function __ZN11UnityEngine9Animation28GenericAnimationBindingCache15BindPPtrGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP8[i2 + 14 >> 0] | 0) {
  i4 = __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) | 0;
  return i4 | 0;
 }
 if ((HEAP16[i2 + 12 >> 1] | 0) != 114) {
  i4 = -1;
  return i4 | 0;
 }
 i4 = __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE(i1, i2, i3, i4) | 0;
 return i4 | 0;
}

function __ZN11UmbraModule38RemoveDuplicatesFromMultipleIndexListsER13CullingOutputPKN5Umbra4TomeEPPNS2_10VisibilityEi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i2 + 4 >> 2] = __ZNK5Umbra9IndexList7getSizeEv(__ZNK5Umbra10Visibility16getOutputObjectsEv(HEAP32[i4 >> 2] | 0) | 0) | 0;
 if ((i5 | 0) > 1) i1 = 1; else return;
 do {
  i3 = __ZNK5Umbra10Visibility15getOutputBufferEv(HEAP32[i4 >> 2] | 0) | 0;
  __ZN5Umbra15OcclusionBuffer7combineERKS0_(i3, __ZNK5Umbra10Visibility15getOutputBufferEv(HEAP32[i4 + (i1 << 2) >> 2] | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_ClearRenderTargetP12Il2CppObjecthhRK10ColorRGBAff(i3, i1, i2, i4, f5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i2 = i2 << 24 >> 24 != 0 & 1;
 i2 = i1 << 24 >> 24 == 0 ? i2 : i2 | 6;
 if (i3 | 0) {
  i1 = HEAP32[i3 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer20AddClearRenderTargetEjRK10ColorRGBAffj(i1, i2, i4, f5, 0);
   STACKTOP = i7;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i6);
}

function __Z44NavMeshAgent_CUSTOM_INTERNAL_get_destinationP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent14GetDestinationEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33CommandBuffer_Get_Custom_PropNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2); else {
  i5 = i1 + 164 | 0;
  i2 = HEAP8[i5 + 11 >> 0] | 0;
  i4 = i2 << 24 >> 24 < 0;
  i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 168 >> 2] | 0 : i2 & 255) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 188 >> 2] = HEAP32[i1 + 160 >> 2];
 HEAP32[i1 + 192 >> 2] = HEAP32[i1 + 164 >> 2];
 HEAP32[i1 + 196 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP32[i1 + 200 >> 2] = HEAP32[i1 + 172 >> 2];
 HEAP32[i1 + 204 >> 2] = HEAP32[i1 + 176 >> 2];
 HEAP32[i1 + 208 >> 2] = HEAP32[i1 + 180 >> 2];
 HEAP32[i1 + 212 >> 2] = HEAP32[i1 + 184 >> 2];
 i2 = i1 + 216 | 0;
 HEAP32[i1 + 536 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_jj(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i3 = HEAP8[i5 + 8 + 3 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 i3 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i6 | 0;
  return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i1, i2, i4, (i8 ? HEAP32[i5 >> 2] | 0 : i5) + (i6 << 2) | 0, i3 >>> 0 < i7 >>> 0 ? i3 : i7) | 0;
 }
 return 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjPKj(i2, i1, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i1 = i3 >>> 1;
 i2 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 36 >> 2] | 0;
 i1 = (HEAP8[((i3 & 1 | 0) == 0 ? i2 + (i1 << 2) + 2 | 0 : i2 + (i1 << 2) + 3 | 0) >> 0] & 127) != 127;
 if (i4 >>> 0 <= 1) {
  i5 = i1 ? i3 : -1;
  return i5 | 0;
 }
 if (i1) {
  i5 = i3;
  return i5 | 0;
 } else {
  i5 = HEAP32[i5 + 4 >> 2] | 0;
  i4 = i5 >>> 1;
  return ((HEAP8[((i5 & 1 | 0) == 0 ? i2 + (i4 << 2) + 2 | 0 : i2 + (i4 << 2) + 3 | 0) >> 0] & 127) == 127 ? -1 : i5) | 0;
 }
 return 0;
}

function __ZNK18ProceduralMaterial17GetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  return;
 } else {
  i2 = i1 + 68 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  return;
 }
}

function __ZN5physx18NpArticulationLink8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE(i2, i3, 0, i1);
 i2 = HEAP32[i2 + 288 >> 2] | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) == Math_fround(0.0)) if (Math_fround(HEAPF32[i3 + 4 >> 2]) == Math_fround(0.0)) i1 = Math_fround(HEAPF32[i3 + 8 >> 2]) != Math_fround(0.0); else i1 = 1; else i1 = 1;
 __ZN5physx14NpArticulation14wakeUpInternalEbb(i2, i1, i4);
 return;
}

function __ZN20SphericalHarmonicsL16ShrinkERK20SphericalHarmonicsL2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 80 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 84 >> 2];
 return;
}

function __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayPvPy(i1, i6, i3, i2, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = HEAP32[i6 + 1052 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = _fread(i4, 1, i3, i2) | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = 0;
 switch (_ferror(i2) | 0) {
 case 0:
  {
   HEAP32[i6 + 1056 >> 2] = 0;
   i6 = (i1 | 0) != 0;
   return i6 | 0;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 case 18:
  {
   i1 = 10;
   break;
  }
 default:
  i1 = 14;
 }
 HEAP32[i6 + 1056 >> 2] = i1;
 i6 = 0;
 return i6 | 0;
}

function __ZN19SpriteMeshGenerator4path9clip_testE8Vector2fi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 1:
  {
   i3 = Math_fround(HEAPF32[i2 >> 2]) >= Math_fround(HEAPF32[i1 + 28 >> 2]);
   return i3 | 0;
  }
 case 2:
  {
   i3 = Math_fround(HEAPF32[i2 >> 2]) <= Math_fround(HEAPF32[i1 + 36 >> 2]);
   return i3 | 0;
  }
 case 8:
  {
   i3 = Math_fround(HEAPF32[i2 + 4 >> 2]) >= Math_fround(HEAPF32[i1 + 32 >> 2]);
   return i3 | 0;
  }
 case 4:
  {
   i3 = Math_fround(HEAPF32[i2 + 4 >> 2]) <= Math_fround(HEAPF32[i1 + 40 >> 2]);
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 481702 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i1 = i1 + 32 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 481721 | 0, gb + 481728 | 0, i1, 0);
 __ZN13SpeedTreeWind8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16Physics2DManager22RemoveRigidbodyUpdatesEP11Rigidbody2D(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = i4 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i5 = i4 + 108 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
  HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 }
 i1 = i4 + 116 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i5 = i3 + 625 | 0;
  HEAP8[i5 >> 0] = 1;
  return;
 }
 i5 = i4 + 120 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[HEAP32[i5 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i5 = i3 + 625 | 0;
 HEAP8[i5 >> 0] = 1;
 return;
}

function __ZN16GUIKeyboardState5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i3);
  __ZdlPv(i3);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13SparseTexture17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 100 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i2);
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 __ZN7Texture17MainThreadCleanupEv(i2);
 STACKTOP = i5;
 return;
}

function __ZN11SoundHandle13CreateChannelEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i1 + 44 >> 2] | 0) == 4) {
   HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
   HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
   i3 = 0;
   return i3 | 0;
  } else {
   i3 = __ZN11SoundHandle8Instance13CreateChannelERS_b(i1, i2, i3) | 0;
   return i3 | 0;
  }
 }
 HEAP32[gb + 1459912 >> 2] = (HEAP32[gb + 1459912 >> 2] | 0) + 1;
 HEAP32[gb + 1459908 >> 2] = (HEAP32[gb + 1459908 >> 2] | 0) + 1;
 i3 = 0;
 return i3 | 0;
}

function __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_GetBoxP12Il2CppObjectR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 do if (!i1) i4 = gb + 1162364 | 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) i4 = gb + 1162364 | 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
   i4 = i3 + 48 + 24 | 0;
   break;
  }
 } while (0);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 return;
}

function __Z42Shader_CUSTOM_INTERNAL_CALL_GetGlobalColoriR10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 20 | 0;
 i4 = i3 + 16 | 0;
 i6 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 __Z21GetShaderGlobalVectorN9ShaderLab16FastPropertyNameE(i6, i5);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i1 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1;
 STACKTOP = i3;
 return;
}

function _cproj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0, d4 = 0.0, i5 = 0;
 d4 = +HEAPF64[i1 >> 3];
 HEAPF64[tempDoublePtr >> 3] = d4;
 if ((HEAP32[tempDoublePtr >> 2] | 0) == 0 ? (HEAP32[tempDoublePtr + 4 >> 2] & 2147483647 | 0) == 2146435072 : 0) i5 = 3; else {
  d2 = +HEAPF64[i1 + 8 >> 3];
  HEAPF64[tempDoublePtr >> 3] = d2;
  if ((HEAP32[tempDoublePtr >> 2] | 0) == 0 ? (HEAP32[tempDoublePtr + 4 >> 2] & 2147483647 | 0) == 2146435072 : 0) i5 = 3; else {
   HEAPF64[i3 >> 3] = d4;
   HEAPF64[i3 + 8 >> 3] = d2;
  }
 }
 if ((i5 | 0) == 3) {
  d4 = +_copysign(0.0, d4);
  HEAPF64[i3 >> 3] = inf;
  HEAPF64[i3 + 8 >> 3] = d4;
 }
 return;
}

function _catanhl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _catanh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _catanh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 HEAPF64[i7 >> 3] = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _catan(i5, i6);
 d4 = -+HEAPF64[i5 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _casinhl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _casinh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _casinh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 HEAPF64[i7 >> 3] = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _casin(i5, i6);
 d4 = -+HEAPF64[i5 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _cacoshl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _cacosh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcjj(i2, i5, i4, i6) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (i1 >>> 0 > i4 >>> 0) {
  i3 = i2 + i1 | 0;
  i1 = i2 + i4 | 0;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) {
    i1 = -1;
    break L5;
   }
   if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i5, i6, i1) | 0)) break;
   i1 = i1 + 1 | 0;
  }
  i1 = i1 - i2 | 0;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP8[i1 + 31 >> 0] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP8[i1 + 28 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i2 = 1;
 return i2 | 0;
}

function __ZNK5Umbra10PortalInfo18getBoundingCirclesERNS_7Vector3ERfS3_RNS_7Vector4E(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i6 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i1 + 64 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 + 68 >> 2];
 i4 = i1 + 48 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 return;
}

function __ZNK4Mesh19ExtractTangentArrayEP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = i3 + 104 | 0;
 i1 = i1 + 32 | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
 __ZN14VertexDataInfoC2Ev(i4);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i6 + 1 >> 0] = 4;
 __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i2, i5, 7, i6);
 __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i5, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i1 >> 2] | 0) + 8 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZNK15dtProximityGrid14getItemCountAtEii(i1, i5, i7) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = (HEAP32[i1 + 24 >> 2] | 0) + -1 & ((Math_imul(i7, 19349663) | 0) ^ (Math_imul(i5, 73856093) | 0));
 i6 = i1 + 8 | 0;
 i4 = 0;
 i1 = HEAP16[(HEAP32[i1 + 20 >> 2] | 0) + (i3 << 1) >> 1] | 0;
 L1 : while (1) {
  do {
   if (i1 << 16 >> 16 == -1) break L1;
   i2 = i1 & 65535;
   i3 = HEAP32[i6 >> 2] | 0;
   i1 = HEAP16[i3 + (i2 << 3) + 2 >> 1] | 0;
  } while ((HEAP16[i3 + (i2 << 3) + 4 >> 1] | 0) != (i5 | 0));
  i4 = ((HEAP16[i3 + (i2 << 3) + 6 >> 1] | 0) == (i7 | 0) & 1) + i4 | 0;
 }
 return i4 | 0;
}

function __ZNK12HandlerChain5IsDirERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0) | 0) break;
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = mftCall_iii(HEAP32[(HEAP32[i5 >> 2] | 0) + 80 >> 2] | 0, i5 | 0, i4 | 0) | 0;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE6resizeEjRKS5_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx11NpAggregateC2Ejb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP16[i3 + 4 >> 1] = 13;
 HEAP16[i3 + 6 >> 1] = 3;
 HEAP32[i3 >> 2] = gb + 90184 + 8;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = i3;
 HEAP32[i3 + 24 >> 2] = -1;
 HEAP32[i3 + 28 >> 2] = i1;
 HEAP8[i3 + 32 >> 0] = i2 & 1;
 HEAP32[i3 + 12 >> 2] = 167772160;
 HEAP32[i3 + 36 >> 2] = 0;
 HEAP32[i3 + 40 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i1 << 2, gb + 675507 | 0, 41) | 0;
 STACKTOP = i4;
 return;
}

function __ZN4FMOD12ChannelGroup9setPausedEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857796;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN28LightProbeProxyVolumeManager17RemoveProxyVolumeEP21LightProbeProxyVolume(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 HEAP16[i6 + 152 >> 1] = -1;
 i7 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i5 = i7 + (i4 << 2) | 0;
 i1 = i7;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == (i6 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i5 | 0)) {
   i8 = 6;
   break;
  }
 }
 if ((i8 | 0) == 6) return;
 i8 = i4 + -1 | 0;
 i7 = i7 + (i8 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i2;
 HEAP32[i3 >> 2] = i8;
 return;
}

function __ZN19SharedBillboardDataC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 56576 + 8;
 i5 = i2 + 8 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 __ZN13dynamic_arrayI8Vector4fLj4EEC2ERKS1_(i1 + 28 | 0, i2 + 28 | 0);
 __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_(i1 + 48 | 0, i2 + 48 | 0);
 __ZN13dynamic_arrayItLj2EEC2ERKS0_(i1 + 68 | 0, i2 + 68 | 0);
 return;
}

function __ZN18JobBatchDispatcherD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i2 + 12 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  if (i2 | 0) i4 = 6;
 } else {
  i1 = 0;
  do {
   __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo((HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
  HEAP32[i3 >> 2] = 0;
  i4 = 6;
 }
 if ((i4 | 0) == 6) if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
 return;
}

function __ZN14RenderSettings18SetAmbientLightOldERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = i5;
 HEAP32[i1 + 64 >> 2] = i4;
 HEAP32[i1 + 68 >> 2] = i3;
 HEAP32[i1 + 72 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = i4;
 HEAP32[i1 + 52 >> 2] = i3;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = i5;
 HEAP32[i1 + 32 >> 2] = i4;
 HEAP32[i1 + 36 >> 2] = i3;
 HEAP32[i1 + 40 >> 2] = i2;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN12NavMeshAgent24SetObstacleAvoidanceTypeE21ObstacleAvoidanceType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i1 + 92 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12CubemapArray17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i2);
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 __ZN7Texture17MainThreadCleanupEv(i2);
 STACKTOP = i5;
 return;
}

function __Z45NavMeshAgent_CUSTOM_INTERNAL_get_nextPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent11GetPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Animator_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator18GetAngualrVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36TerrainData_CUSTOM_RefreshPrototypesP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14DetailDatabase17RefreshPrototypesEv(i1 + 128 | 0);
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2); else {
  __ZN12TreeDatabase17RefreshPrototypesEv(i1 + 84 | 0);
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __Z13ForceLODLevelRK8LODGroupi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((((HEAP32[i1 + 60 >> 2] | 0) - (HEAP32[i1 + 56 >> 2] | 0) | 0) / 28 | 0 | 0) <= (i2 | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 425385 | 0, 0, gb + 425454 | 0, 128, 512, 0, 0, 0);
  return;
 }
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if ((i1 | 0) < 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 425385 | 0, 0, gb + 425454 | 0, 142, 512, 0, 0, 0);
  return;
 } else {
  HEAP32[(HEAP32[(HEAP32[gb + 1161200 >> 2] | 0) + 4 >> 2] | 0) + (i1 * 96 | 0) + 92 >> 2] = (i2 | 0) > -1 ? 1 << i2 : 0;
  return;
 }
}

function _cacosh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _cacos(i5, i6);
 d4 = +HEAPF64[i5 >> 3];
 HEAPF64[i1 >> 3] = -+HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZNK4Mesh18ExtractVertexArrayEP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = i3 + 104 | 0;
 i1 = i1 + 32 | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
 __ZN14VertexDataInfoC2Ev(i4);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i6 + 1 >> 0] = 3;
 __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i2, i5, 0, i6);
 __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i5, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i1 >> 2] | 0) + 8 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZNK4Mesh18ExtractNormalArrayEP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i6 = i3 + 104 | 0;
 i1 = i1 + 32 | 0;
 i5 = HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0;
 __ZN14VertexDataInfoC2Ev(i4);
 HEAP8[i6 >> 0] = 0;
 HEAP8[i6 + 1 >> 0] = 3;
 __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension(i4, i2, i5, 1, i6);
 __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i5, HEAP32[i4 + 88 >> 2] | 0, (HEAP32[i1 >> 2] | 0) + 8 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext21InertiaTensorComputer9setSphereEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0;
 f3 = Math_fround(Math_fround(Math_fround(f1 * Math_fround(4.18879032)) * f1) * f1);
 f1 = Math_fround(Math_fround(Math_fround(f3 * f1) * f1) * Math_fround(.400000006));
 HEAPF32[i2 + 48 >> 2] = f3;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i2 + 16 >> 2] = f1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = f1;
 HEAP32[i2 + 36 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 return;
}

function __ZN5physx2Sn5ConvX6outputEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i1 >> 2] = i3;
 if (HEAP8[i2 + 325 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 if (HEAP8[i2 + 308 >> 0] | 0) {
  HEAP8[i1 >> 0] = i3 >>> 24;
  HEAP8[i1 + 3 >> 0] = i3;
  HEAP8[i1 + 1 >> 0] = i3 >>> 16;
  HEAP8[i1 + 2 >> 0] = i3 >>> 8;
 }
 i3 = HEAP32[i2 + 304 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 4) | 0;
 i3 = i2 + 312 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 STACKTOP = i4;
 return;
}

function __ZN5physx28PxVehicleWheelsGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831955;
 HEAP32[i1 + 4 >> 2] = 636;
 HEAP32[i1 + 8 >> 2] = fb + 2398;
 HEAP32[i1 + 12 >> 2] = gb + 831967;
 HEAP32[i1 + 16 >> 2] = 637;
 HEAP32[i1 + 20 >> 2] = fb + 2399;
 HEAP32[i1 + 24 >> 2] = gb + 831985;
 HEAP32[i1 + 28 >> 2] = 638;
 HEAP32[i1 + 32 >> 2] = fb + 2400;
 HEAP32[i1 + 36 >> 2] = gb + 833671;
 HEAP32[i1 + 40 >> 2] = 639;
 HEAP32[i1 + 44 >> 2] = fb + 3932;
 HEAP32[i1 + 48 >> 2] = fb + 3933;
 HEAP32[i1 + 52 >> 2] = gb + 832002;
 HEAP32[i1 + 56 >> 2] = 640;
 HEAP32[i1 + 60 >> 2] = fb + 3934;
 HEAP32[i1 + 64 >> 2] = fb + 3935;
 return;
}

function __ZN5physx28PxParticleFluidGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx27PxParticleBaseGeneratedInfoC2Ev(i1);
 HEAP32[i1 + 348 >> 2] = gb + 765184;
 HEAP32[i1 + 352 >> 2] = 187;
 HEAP32[i1 + 356 >> 2] = fb + 460;
 HEAP32[i1 + 360 >> 2] = fb + 395;
 HEAP32[i1 + 364 >> 2] = gb + 743152;
 HEAP32[i1 + 368 >> 2] = 188;
 HEAP32[i1 + 372 >> 2] = fb + 461;
 HEAP32[i1 + 376 >> 2] = fb + 396;
 HEAP32[i1 + 380 >> 2] = gb + 743162;
 HEAP32[i1 + 384 >> 2] = 189;
 HEAP32[i1 + 388 >> 2] = fb + 462;
 HEAP32[i1 + 392 >> 2] = fb + 397;
 HEAP32[i1 + 396 >> 2] = gb + 831985;
 HEAP32[i1 + 400 >> 2] = 190;
 HEAP32[i1 + 404 >> 2] = fb + 2175;
 return;
}

function __ZN39AssetBundleLoadFromMemoryAsyncOperation7ExecuteEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj(i3, i1, i2) | 0)) {
  __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i3);
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
  return;
 }
 i1 = HEAP32[gb + 1104184 >> 2] | 0;
 if (!i1) {
  __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(gb + 1104184 | 0);
  i1 = HEAP32[gb + 1104184 >> 2] | 0;
 }
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i1, fb + 3308 | 0, i3);
 return;
}

function __ZN19StreamedBinaryWriteILb1EE16TransferTypelessEPjPKc17TransferMetaFlags(i7, i3, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = _llvm_bswap_i32(HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  STACKTOP = i6;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i5, 4);
  STACKTOP = i6;
  return;
 }
}

function __ZN13TrailRenderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i1 = HEAP32[i1 + 384 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i3 = i1 + 16 | 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i3 : i4) >> 2];
 i3 = i1 + 180 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 0 ? 0 : (i4 | 0) > 90 ? 90 : i4;
 i1 = i1 + 184 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i3 | 0) < 0 ? 0 : (i3 | 0) > 90 ? 90 : i3;
 STACKTOP = i2;
 return;
}

function __ZN11PlayerPrefs8SetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = 253;
 HEAPF32[i5 + 4 >> 2] = f2;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i1 = __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue(i1, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i1 | 0;
}

function __Z43Transform_CUSTOM_INTERNAL_get_localPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Transform16GetLocalPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody16GetInertiaTensorEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUITexture_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i5 = HEAP32[i3 + 60 >> 2] | 0;
  i4 = HEAP32[i3 + 64 >> 2] | 0;
  i1 = HEAP32[i3 + 68 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 56 >> 2];
  HEAP32[i2 + 4 >> 2] = i5;
  HEAP32[i2 + 8 >> 2] = i4;
  HEAP32[i2 + 12 >> 2] = i1;
  return;
 }
}

function __Z32BillboardAsset_CUSTOM_SetIndicesP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 753990 | 0);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 2) | 0;
  __ZN14BillboardAsset10SetIndicesEPKtj(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
  return;
 }
}

function __Z21IntersectSphereSphereRK6SphereS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i2 >> 2]));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i2 + 4 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f3 = Math_fround(f3 - Math_fround(HEAPF32[i2 + 8 >> 2]));
 f3 = Math_fround(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4)) + Math_fround(f3 * f3));
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 12 >> 2]));
 return Math_fround(f4 * f4) > f3 | 0;
}

function __Z20SignedTriangleArea2DPK8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f8 = Math_fround(HEAPF32[i1 >> 2]);
 f5 = Math_fround(f4 - f8);
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f3 + f6));
 f7 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f4 = Math_fround(f7 - f4);
 f2 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 return Math_fround(Math_fround(Math_fround(Math_fround(f8 - f7) * Math_fround(f6 + f2)) + Math_fround(f5 + Math_fround(f4 * Math_fround(f3 + f2)))) * Math_fround(.5));
}

function __Z15CleanLogHandler7LogTypePKcz(i4, i5, i7) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8;
 i3 = HEAP32[gb + 1450784 >> 2] | 0;
 if (!i3) {
  STACKTOP = i8;
  return;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) {
  STACKTOP = i8;
  return;
 }
 do {
  HEAP32[i6 >> 2] = i7;
  mftCall_iiii(HEAP32[i2 + 8 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
 } while ((i1 | 0) != (HEAP32[gb + 1450784 >> 2] | 0));
 STACKTOP = i8;
 return;
}

function _jpeg_stdio_src(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i5 = i2 + 4 | 0;
  i1 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i2 | 0, 0, 40) | 0;
  HEAP32[i3 >> 2] = i1;
  HEAP32[i1 + 32 >> 2] = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i2 | 0, 0, 4096) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i1 + 8 >> 2] = fb + 3285;
 HEAP32[i1 + 12 >> 2] = fb + 1563;
 HEAP32[i1 + 16 >> 2] = fb + 2368;
 HEAP32[i1 + 20 >> 2] = fb + 512;
 HEAP32[i1 + 24 >> 2] = fb + 3286;
 HEAP32[i1 + 28 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function _grayscale_convert(i1, i3, i9, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i9 = i9 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0, i10 = 0;
 i10 = HEAP32[i1 + 28 >> 2] | 0;
 i8 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i4 | 0) < 1 | (i10 | 0) == 0) return;
 while (1) {
  i6 = i4;
  i4 = i4 + -1 | 0;
  i7 = HEAP32[(HEAP32[i9 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  i1 = 0;
  i5 = HEAP32[i3 >> 2] | 0;
  while (1) {
   HEAP8[i7 + i1 >> 0] = HEAP8[i5 >> 0] | 0;
   i1 = i1 + 1 | 0;
   if ((i1 | 0) == (i10 | 0)) break; else i5 = i5 + i8 | 0;
  }
  if ((i6 | 0) <= 1) break; else {
   i2 = i2 + 1 | 0;
   i3 = i3 + 4 | 0;
  }
 }
 return;
}

function _ctanhl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ctanh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _ctan(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 HEAPF64[i7 >> 3] = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ctanh(i5, i6);
 d4 = -+HEAPF64[i5 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _csqrtl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _csqrt(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _csinhl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _csinh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _csin(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 HEAPF64[i7 >> 3] = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _csinh(i5, i6);
 d4 = -+HEAPF64[i5 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _cprojl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _cproj(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _ccoshl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ccosh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _catanl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _catan(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _casinl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _casin(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _cacosl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _cacos(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZN8LODGroup32NotifyLODGroupManagerIndexChangeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 HEAP32[i1 + 68 >> 2] = i2;
 i7 = i1 + 88 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 if (!i3) return;
 i6 = i1 + 76 | 0;
 i5 = i2 & 65535;
 i4 = 0;
 i1 = i3;
 do {
  i2 = HEAP32[(HEAP32[(HEAP32[i6 >> 2] | 0) + (i4 << 2) >> 2] | 0) + 284 >> 2] | 0;
  if ((i2 | 0) != -1) {
   i1 = HEAP32[(__Z16GetRendererScenev() | 0) + 60 >> 2] | 0;
   HEAP16[i1 + (i2 * 24 | 0) + 12 >> 1] = 0;
   HEAP16[i1 + (i2 * 24 | 0) + 14 >> 1] = i5;
   i1 = HEAP32[i7 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 return;
}

function __ZN8Collider15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32548 | 0, gb + 1105216 | 0, fb + 844 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32548 | 0, gb + 1105496 | 0, fb + 845 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 32548 | 0, gb + 1105016 | 0, fb + 846 | 0, gb + 29192 | 0);
 return;
}

function __ZN8Animator15SetHintPositionEiRK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 >= 4) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i4 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i5 = i4 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 i5 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i5 + 68 + (i2 << 6) + 48 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 68 + (i2 << 6) + 52 >> 2] = i1;
 HEAP32[i5 + 68 + (i2 << 6) + 56 >> 2] = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd10SocketImpl11setBlockingEb(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i1 = i3 + 15 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i1 >> 0] | 0 | 0)) {
  STACKTOP = i6;
  return;
 }
 i7 = i3 + 4 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = _fcntl(i3, 3, i4) | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 HEAP32[i5 >> 2] = i2 ? i3 & -2049 : i3 | 2048;
 if ((_fcntl(i4, 4, i5) | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i1 >> 0] = i2 & 1;
 STACKTOP = i6;
 return;
}

function __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs8allocateEjj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = ((Math_imul(i2 << 2, i1) | 0) + 47 & -16) + ((i1 << 3) + 30 & -32) | 0;
 i4 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i5, gb + 835269 | 0, 38) | 0;
 _memset(i4 | 0, 0, i5 | 0) | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = i1;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i4 = i3 + 44 | 0;
 __ZN5physx18PxsDynamicsContext12mergeResultsEv(HEAP32[i3 + 12 >> 2] | 0);
 __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv(i4);
 HEAP32[i3 + 7596 >> 2] = __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv(i4) | 0;
 __ZN5physx2Sc5Scene16afterIntegrationEPNS_10PxBaseTaskE(i2, i1);
 __ZN5physx2Sc5Scene11afterSolverEj(i2, 0);
 return;
}

function __ZN5physx11HullLibrary9removeb2bEPNS_3TriES2_(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_(i4, i2, i3);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 2) >> 2] = 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 HEAP32[(HEAP32[HEAP32[i4 >> 2] >> 2] | 0) + (HEAP32[i3 + 24 >> 2] << 2) >> 2] = 0;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i5;
 return;
}

function __ZN4FMOD12ChannelGroup7setMuteEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859095;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN13RenderTextureD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i6 = i2;
 HEAP32[i1 >> 2] = gb + 44300 + 8;
 i4 = __Z21GetUncheckedGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 424 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN12LineRenderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i1 = HEAP32[i1 + 344 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 i3 = i1 + 16 | 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i3 : i4) >> 2];
 i3 = i1 + 180 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i4 | 0) < 0 ? 0 : (i4 | 0) > 90 ? 90 : i4;
 i1 = i1 + 184 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i3 | 0) < 0 ? 0 : (i3 | 0) > 90 ? 90 : i3;
 STACKTOP = i2;
 return;
}

function __ZN12HandlerChain6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z45ParticleSystem_Set_Custom_PropGravityModifierP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem18SetGravityModifierEf(i3, f2);
  return;
 }
}

function __Z43Animator_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator17GetTargetPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41ParticleSystem_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem14SetPlayOnAwakeEb(i3, i2 << 24 >> 24 != 0);
  return;
 }
}

function __Z40Transform_CUSTOM_INTERNAL_get_lossyScaleP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Transform18GetWorldScaleLossyEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Mesh_CUSTOM_UploadMeshDataP12Il2CppObjecth(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i4 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 if (!(__ZNK4Mesh19CanAccessFromScriptEv(i1) | 0)) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN4Mesh14UploadMeshDataEb(i1, i3 << 24 >> 24 != 0);
 return;
}

function _ccos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 >> 3];
 HEAPF64[i7 >> 3] = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ccosh(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZSt18make_exception_ptrINSt3__212future_errorEESt13exception_ptrT_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = ___cxa_allocate_exception(16) | 0;
 __ZNSt3__212future_errorC2ERKS0_(i2, i1);
 __THREW__ = 0;
 invoke_viii(fb + 1035 | 0, i2 | 0, gb + 10672 | 0, fb + 3023 | 0);
 __THREW__ = 0;
 i1 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 i1 = __ZSt17current_exceptionv() | 0;
 __THREW__ = 0;
 invoke_v(fb + 458 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return i1 | 0;
 return 0;
}

function __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN5physx2Sc9ShapeCore15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (HEAP32[i2 + 68 >> 2] | 0) {
 case 5:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 116 >> 2] | 0, (HEAPU16[i2 + 120 >> 1] | 0) << 1 | 0);
   return;
  }
 case 6:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
   mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 96 >> 2] | 0, (HEAPU16[i2 + 100 >> 1] | 0) << 1 | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Sc9ClothCore13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0, f7 = f0, f8 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0;
 f8 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f7 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f6 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 HEAPF32[i4 >> 2] = f8;
 HEAPF32[i4 + 4 >> 2] = f7;
 HEAPF32[i4 + 8 >> 2] = f6;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx20PxsParticleSystemSimD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 109916 + 8;
 HEAP32[i1 + 1268 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1276 >> 2] = 0;
 HEAP32[i1 + 1240 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAP32[i1 + 1212 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1220 >> 2] = 0;
 HEAP32[i1 + 1184 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1192 >> 2] = 0;
 HEAP32[i1 + 1156 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1164 >> 2] = 0;
 HEAP32[i1 + 1128 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1136 >> 2] = 0;
 __ZN5physx17PxsFluidCollisionD2Ev(i1 + 624 | 0);
 __ZN5physx16PxsFluidDynamicsD2Ev(i1 + 80 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7Channel11setPriorityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 859047;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN17PolygonCollider2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Collider2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 156928 + 8;
 __ZN9Polygon2DC2Ev(i1 + 160 | 0);
 STACKTOP = i4;
 return;
}

function __ZN14CachingManager5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN14CachingManager7DisposeEv(i1);
 HEAP32[i1 >> 2] = 0;
 __Z39GetDefaultApplicationIdentifierForCachev(i3);
 HEAP32[i1 >> 2] = 1;
 __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb(i1, i3, -1, 2147483647, 0);
 __ZN14CachingManager15ClearTempFolderEv(0);
 HEAP8[i1 + 8 >> 0] = 1;
 HEAP8[i1 + 9 >> 0] = 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings7GetBoolERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i2, i1) | 0;
 if ((i1 | 0) == (i2 + 4 | 0)) return i3 | 0;
 if ((HEAP32[i1 + 48 >> 2] | 0) != 2) return i3 | 0;
 i3 = (HEAP8[i1 + 56 >> 0] | 0) != 0;
 return i3 | 0;
}

function __ZL50UnityAudioEffect_InternalSetFloatParameterCallbackP14FMOD_DSP_STATEif(i1, i3, f4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i1 >> 2] | 0, i2) | 0;
 if (!i1) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i1 = 36; else {
   i1 = HEAP32[(HEAP32[i2 + 112 >> 2] | 0) + 184 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = (mftCall_iiif(i1 | 0, i2 | 0, i3 | 0, +f4) | 0) == 0;
    i1 = i1 ? 0 : 80;
   }
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __Z42Rigidbody_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody15GetCenterOfMassEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_png_get_tRNS(i1, i4, i2, i5, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i4 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i4 + 8 >> 2] & 16)) {
  i5 = 0;
  return i5 | 0;
 }
 if ((HEAP8[i4 + 25 >> 0] | 0) == 3) {
  if (!i2) i1 = 0; else {
   HEAP32[i2 >> 2] = HEAP32[i4 + 148 >> 2];
   i1 = 16;
  }
  if (i3) HEAP32[i3 >> 2] = i4 + 152;
 } else {
  if (!i3) i1 = 0; else {
   HEAP32[i3 >> 2] = i4 + 152;
   i1 = 16;
  }
  if (i2) HEAP32[i2 >> 2] = 0;
 }
 if (!i5) {
  i5 = i1;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = HEAPU16[i4 + 22 >> 1];
 i5 = 16;
 return i5 | 0;
}

function _UNITY_FT_MulFix(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 >> 31;
 i3 = (i1 | 0) < 0 ? 0 - i1 | 0 : i1;
 i1 = (i4 | 0) < 0;
 i2 = i1 ? 0 - (i2 | 1) | 0 : i2;
 i1 = i1 ? 0 - i4 | 0 : i4;
 if (((i1 >>> 8) + i3 | 0) >>> 0 < 8191) {
  i4 = ((Math_imul(i1, i3) | 0) + 32768 | 0) >>> 16;
  i2 = (i2 | 0) < 0;
  i3 = 0 - i4 | 0;
  i4 = i2 ? i3 : i4;
  return i4 | 0;
 } else {
  i4 = i3 & 65535;
  i4 = (Math_imul(i1 >>> 16, i4) | 0) + (Math_imul(i3 >>> 16, i1) | 0) + (((Math_imul(i1 & 65535, i4) | 0) + 32768 | 0) >>> 16) | 0;
  i2 = (i2 | 0) < 0;
  i3 = 0 - i4 | 0;
  i4 = i2 ? i3 : i4;
  return i4 | 0;
 }
 return 0;
}

function _ctanl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ctan(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _csinl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _csin(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _clogl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _clog(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _cexpl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _cexp(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function _ccosl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, d4 = 0.0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i5 = i3 + 16 | 0;
 i7 = i3;
 d4 = +HEAPF64[i2 + 8 >> 3];
 HEAPF64[i7 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i7 + 8 >> 3] = d4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i7 + 12 >> 2];
 _ccos(i5, i6);
 d4 = +HEAPF64[i5 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i5 >> 3];
 HEAPF64[i1 + 8 >> 3] = d4;
 STACKTOP = i3;
 return;
}

function __ZNK5Umbra7ImpTome12computeCRC32Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = (HEAP32[i3 + 8 >> 2] | 0) + -8 | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = -1;
 i2 = i1;
 i1 = i3 + 4 | 0;
 do {
  i1 = i1 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[gb + 79084 + (((i3 ^ i4) & 255) << 2) >> 2] ^ i4 >>> 8;
  i5 = i5 >>> 8 ^ HEAP32[gb + 79084 + (((i5 ^ i3 >>> 8) & 255) << 2) >> 2];
  i5 = i5 >>> 8 ^ HEAP32[gb + 79084 + (((i5 ^ i3 >>> 16) & 255) << 2) >> 2];
  i4 = i5 >>> 8 ^ HEAP32[gb + 79084 + ((i5 & 255 ^ i3 >>> 24) << 2) >> 2];
  i2 = i2 + -4 | 0;
 } while ((i2 | 0) != 0);
 i5 = ~i4;
 return i5 | 0;
}

function __ZN9Texture3D17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  __ZN7Texture17MainThreadCleanupEv(i2);
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 __ZN7Texture17MainThreadCleanupEv(i2);
 STACKTOP = i5;
 return;
}

function __ZN9GfxDevice15ResetAllBuffersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 4516 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i1 | 0) != (i3 | 0)) do {
  i4 = (i1 | 0) == 0 ? 0 : i1 + -4 | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 i2 = HEAP32[i2 + 4520 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  i4 = (i1 | 0) == 0 ? 0 : i1 + -4 | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN7mecanim9animation22DestroyAvatarWorkspaceEPNS0_15AvatarWorkspaceERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 + 8 >> 2] | 0, i2);
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 + 4 >> 2] | 0, i2);
 __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 192 >> 2] = HEAP32[i1 + 164 >> 2];
 HEAP32[i1 + 196 >> 2] = HEAP32[i1 + 168 >> 2];
 HEAP32[i1 + 200 >> 2] = HEAP32[i1 + 172 >> 2];
 HEAP32[i1 + 204 >> 2] = HEAP32[i1 + 176 >> 2];
 HEAP32[i1 + 208 >> 2] = HEAP32[i1 + 180 >> 2];
 HEAP32[i1 + 212 >> 2] = HEAP32[i1 + 184 >> 2];
 HEAP32[i1 + 216 >> 2] = HEAP32[i1 + 188 >> 2];
 i2 = i1 + 220 | 0;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerERKNS_7NpShapeE(i2, i5, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = __ZNK5physx2Cm8PtrTable4findEPKv(i2, i1) | 0;
 i4 = i2 + 8 | 0;
 i1 = i2 + 12 | 0;
 if ((HEAP16[i1 >> 1] | 0) == 1) i2 = i4; else i2 = HEAP32[i4 >> 2] | 0;
 __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i5, HEAP32[i2 + (i3 << 2) >> 2] | 0);
 if ((HEAP16[i1 >> 1] | 0) == 1) {
  i5 = i4;
  i5 = i5 + (i3 << 2) | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 } else {
  i5 = HEAP32[i4 >> 2] | 0;
  i5 = i5 + (i3 << 2) | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
}

function __ZN29AnimationStateNetworkProvider24GetNetworkAnimationStateER9AnimationP24AnimationStateForNetworki(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0;
 if ((i5 | 0) <= 0) return;
 i2 = i3 + 104 | 0;
 i1 = 0;
 do {
  __ZN9Animation20BuildAnimationStatesEv(i3);
  i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  HEAP8[i4 + (i1 * 12 | 0) >> 0] = (HEAPU16[i6 + 56 >> 1] | 0) >>> 1 & 1;
  HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAPF32[i4 + (i1 * 12 | 0) + 8 >> 2] = Math_fround(+HEAPF64[i6 + 16 >> 3]);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN14ParticleSystem6UpdateERS_fNS_11UpdateFlagsEi(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = i1 + 36 | 0;
 i5 = i1 + 40 | 0;
 __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE(i1, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, f2, i3);
 __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi(i1, HEAP32[i1 + 32 >> 2] | 0, f2, i3, i4);
 __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE(i1, HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, i3);
 return;
}

function __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i1 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i4;
 HEAP16[i5 + 12 >> 1] = 4;
 HEAP8[i5 + 14 >> 0] = 0;
 HEAP8[i5 + 15 >> 0] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 return;
}

function __Z45ParticleSystem_Get_Custom_PropGravityModifierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem18GetGravityModifierEv(i2));
 return Math_fround(0.0);
}

function __Z44AnimatorControllerPlayable_CUSTOM_SetFloatIDR9HPlayableif(i3, i4, f2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAPF32[i1 >> 2] = f2;
 i6 = HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 140 >> 2] | 0, i6 | 0, i4 | 0, i1 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i5;
  return;
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i1, i4);
 STACKTOP = i5;
 return;
}

function __Z43UnityLogWriter_CUSTOM_WriteStringToUnityLogP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 16 | 0;
 i3 = i5 + 4 | 0;
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 if (__ZNK11ICallString6IsNullEv(i2) | 0) {
  STACKTOP = i5;
  return;
 }
 __ZNK11ICallString6ToUTF8Ev(i3, i2);
 HEAP32[i4 >> 2] = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 _printf_console(gb + 1074693 | 0, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i5;
 return;
}

function __Z43ParticleSystem_Set_Custom_PropPlaybackSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem18SetSimulationSpeedEf(i3, f2);
  return;
 }
}

function __Z42Animator_CUSTOM_INTERNAL_get_pivotPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator16GetPivotPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Animator_CUSTOM_INTERNAL_get_deltaPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator16GetDeltaPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41NavMeshAgent_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK12NavMeshAgent11GetVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Animator_CUSTOM_INTERNAL_get_rootPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator17GetAvatarPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34FindAncestorComponentExactTypeImplR10GameObjecti(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = i1;
 while (1) {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i4) | 0;
  if (i2 | 0) {
   i1 = __ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE(i1, i2) | 0;
   if (i1 | 0) {
    i2 = 6;
    break;
   }
  }
  i3 = HEAP32[i3 + 100 >> 2] | 0;
  if (!i3) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __Z29ComputeShader_CUSTOM_SetFloatP12Il2CppObjectif(i1, i4, f2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = i7 + 4 | 0;
 HEAPF32[i5 >> 2] = f2;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i6 >> 2] = i4;
   __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i3, i6, 4, i5) | 0;
   STACKTOP = i7;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, i3, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i4 = 0, i9 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i9 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i9;
  if (i9 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i4 = i1;
   break;
  }
 } else i4 = i1; while (0);
 return __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i4, i2, i3, i5, i6, i7, i8) | 0;
}

function _UNITY_FT_Sfnt_Table_Info(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i3) i1 = 35; else if (!(HEAP32[i3 + 8 >> 2] & 8)) i1 = 35; else {
  i1 = HEAP32[i3 + 96 >> 2] | 0;
  i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
  if (!i2) i1 = 7; else {
   i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008151 | 0) | 0;
   if (!i1) i1 = 7; else i1 = mftCall_iiiiii(HEAP32[i1 + 8 >> 2] | 0, i3 | 0, i4 | 0, i5 | 0, i7 | 0, i6 | 0) | 0;
  }
 }
 STACKTOP = i8;
 return i1 | 0;
}

function _UNITY_FT_Set_Pixel_Sizes(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i7 = (i2 | 0) == 0;
 i6 = i7 ? i3 : i2;
 i3 = i7 ? i3 : (i3 | 0) == 0 ? i2 : i3;
 i2 = (i6 | 0) == 0 ? 1 : i6;
 i3 = (i3 | 0) == 0 ? 1 : i3;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = (i2 >>> 0 < 65535 ? i2 : 65535) << 6;
 HEAP32[i5 + 8 >> 2] = (i3 >>> 0 < 65535 ? i3 : 65535) << 6;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i3 = _UNITY_FT_Request_Size(i1, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZN5physx13PxTaskManager17createTaskManagerEPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i6 | 0, i5 | 0, 100, (i4 ? gb + 718730 | 0 : gb + 837976 | 0) | 0, gb + 718836 | 0, 194) | 0;
 __ZN5physx9PxTaskMgrC2EPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE(i4, i1, i2, i3);
 return i4 | 0;
}

function __ZN5Umbra15PortalRayTracer12initTraverseERKNS_10PortalNodeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 4364 >> 2] = 1;
 i3 = i2 + 272 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAPF32[i2 + 268 >> 2] = Math_fround(0.0);
 i3 = HEAP32[i2 + 84 >> 2] | 0;
 i2 = HEAP32[HEAP32[HEAP32[i2 >> 2] >> 2] >> 2] | 0;
 i1 = HEAP32[i2 + 136 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  _memset(i3 | 0, 0, i2 | 0) | 0;
  return;
 }
 i2 = (HEAP32[i2 + i1 + (HEAP32[i2 + 144 >> 2] << 2) >> 2] | 0) + 31 >> 5 << 2;
 _memset(i3 | 0, 0, i2 | 0) | 0;
 return;
}

function __ZN15CapsuleCollider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 36 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
  return;
 }
 __ZN15CapsuleCollider9SetRadiusEf(i1, Math_fround(HEAPF32[i1 + 60 >> 2]));
 __ZN15CapsuleCollider9SetHeightEf(i1, Math_fround(HEAPF32[i1 + 64 >> 2]));
 if (HEAP32[i3 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483648);
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN13b2PulleyJoint11ShiftOriginERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 68 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f3);
 i4 = i2 + 4 | 0;
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i5 = i1 + 72 | 0;
 HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) - f3);
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i2 = i1 + 76 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 i2 = i1 + 80 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 return;
}

function __ZN12SoundManager15GetProfilerDataER10AudioStats(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 24 >> 2] = HEAP32[gb + 1459892 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[gb + 1459904 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[gb + 1459912 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[gb + 1459896 >> 2];
 HEAP32[i2 + 60 >> 2] = HEAP32[gb + 1178928 >> 2];
 HEAP32[i2 + 64 >> 2] = HEAP32[gb + 1460028 >> 2];
 HEAP32[i2 + 68 >> 2] = HEAP32[gb + 1459920 >> 2];
 return;
}

function __ZL25InitializeDefaultMaterialv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 8 | 0;
 i3 = i1;
 i6 = gb + 63520 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i2 = __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId(4, i2) | 0;
 HEAP32[gb + 1166352 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 61);
 STACKTOP = i1;
 return;
}

function __Z47ParticleSystem_TriggerModule_CUSTOM_SetColliderP12Il2CppObjectiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZN14ParticleSystem8SyncJobsEb(1);
  i4 = HEAP32[i4 + 912 >> 2] | 0;
  i3 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i4 + 28 + (((i2 | 0) < 0 ? 0 : (i2 | 0) > 5 ? 5 : i2) << 2) >> 2] = i3;
  return;
 }
}

function __Z27GetClothScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459024 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 839673 | 0, 16) | 0;
 HEAP32[gb + 1459024 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839795 | 0) | 0;
 HEAP32[HEAP32[gb + 1459024 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839820 | 0) | 0;
 HEAP32[(HEAP32[gb + 1459024 >> 2] | 0) + 4 >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 258 | 0, fb + 259 | 0);
 i1 = HEAP32[gb + 1459024 >> 2] | 0;
 return i1 | 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function _jpeg_new_colormap(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 384 >> 2] | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i3 | 0) != 207) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i3;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
 }
 if (HEAP8[i1 + 74 >> 0] | 0) if (HEAP8[i1 + 89 >> 0] | 0) if (HEAP32[i1 + 116 >> 2] | 0) {
  i4 = HEAP32[i2 + 24 >> 2] | 0;
  HEAP32[i1 + 424 >> 2] = i4;
  mftCall_vi(HEAP32[i4 + 12 >> 2] | 0, i1 | 0);
  HEAP8[i2 + 8 >> 0] = 0;
  return;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 20 >> 2] = 46;
 mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4swapERS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4swapERS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __ZNK20DynamicPropertySheet17HasQueuedPropertyEN9ShaderLab16FastPropertyNameEN19ShaderPropertySheet12PropertyTypeE(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 112 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) == (i4 | 0)) {
   i1 = 1;
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i5 >>> 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN5physx7NpScene26setVisualizationCullingBoxERKNS_9PxBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene26setVisualizationCullingBoxERKNS_9PxBounds3E(i2 + 32 | 0, i1);
  return;
 } else {
  HEAP8[i2 + 3092 >> 0] = 1;
  HEAP32[i2 + 3068 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 3072 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 3076 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 3080 >> 2] = HEAP32[i1 + 12 >> 2];
  HEAP32[i2 + 3084 >> 2] = HEAP32[i1 + 16 >> 2];
  HEAP32[i2 + 3088 >> 2] = HEAP32[i1 + 20 >> 2];
  i2 = i2 + 3388 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 64;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx11NpAggregate11removeActorERNS_7PxActorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) == 4) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 675507 | 0, 182, gb + 681914 | 0, i3);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  i2 = __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb(i2, i1, 1) | 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZN5Umbra10PathFinderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 24168 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 152 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 + 148 >> 2] | 0) + 12 >> 2] = i1 + -16;
 i1 = HEAP32[i2 + 124 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 128 >> 2];
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 92 >> 2];
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 56 >> 2];
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZN5Umbra10PathFinder11reversePathEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 24174 | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 i4 = HEAP32[i1 + 24168 >> 2] | 0;
 i1 = HEAP16[i4 + ((i2 & 65535) << 1) >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i5 = i2;
  i5 = i5 & 65535;
  i5 = i4 + (i5 << 1) | 0;
  HEAP16[i5 >> 1] = -1;
  return;
 }
 while (1) {
  i6 = i4 + ((i1 & 65535) << 1) | 0;
  i3 = HEAP16[i6 >> 1] | 0;
  HEAP16[i6 >> 1] = i2;
  if (i3 << 16 >> 16 == -1) break; else {
   i2 = i1;
   i1 = i3;
  }
 }
 i6 = HEAP16[i5 >> 1] | 0;
 i6 = i6 & 65535;
 i6 = i4 + (i6 << 1) | 0;
 HEAP16[i6 >> 1] = -1;
 return;
}

function __ZN26VertexDeclarationCacheGLES23CreateVertexDeclarationERK18VertexChannelsInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(36, gb + 63304 | 0, 16, gb + 604363 | 0, 27) | 0;
 HEAP32[i1 >> 2] = gb + 77004 + 8;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return i1 | 0;
}

function __ZN19SpriteMeshGenerator4path8min_costEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i4 = (HEAP32[i1 + 4 >> 2] | 0) - i6 | 0;
 i5 = i4 >> 5;
 if ((i4 | 0) > 0) {
  i4 = 0;
  f2 = Math_fround(3402823469999999843913219.0e14);
  i1 = -1;
 } else {
  i6 = -1;
  return i6 | 0;
 }
 do {
  f3 = Math_fround(HEAPF32[i6 + (i4 << 5) + 24 >> 2]);
  if (!(f3 < Math_fround(0.0))) {
   f3 = Math_fround(f3 + Math_fround(HEAPF32[i6 + (i4 << 5) + 20 >> 2]));
   i7 = f3 < f2;
   i1 = i7 ? i4 : i1;
   f2 = i7 ? f3 : f2;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i5 | 0));
 return i1 | 0;
}

function __ZN16SubstanceArchiveD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 59556 + 8;
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 }
 if ((HEAP32[i1 + 48 >> 2] | 0) > -1) {
  i3 = i1 + 32 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + 36 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
 __ZN4PPtrI11TerrainDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 60 | 0, i4);
 i1 = i1 + 64 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  return;
 }
}

function __ZN15NavMeshSettingsC2ER10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 169704 + 8;
 HEAP32[i1 + 28 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN11PreloadData23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i7 = HEAP32[i1 + 44 >> 2] | 0;
 i5 = i4 + (i7 << 2) | 0;
 if (!i7) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i3 = i2 + 40 | 0;
 i1 = i4;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z43ParticleSystem_Set_Custom_PropStartRotationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem16SetStartRotationEf(i3, f2);
  return;
 }
}

function __Z43ParticleSystem_Set_Custom_PropStartLifetimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem16SetStartLifeTimeEf(i3, f2);
  return;
 }
}

function __Z35Resources_CUSTOM_GetBuiltinResourceP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 __ZNK11ICallString6ToUTF8Ev(i4, i5);
 i2 = __Z27GetScriptingBuiltinResourceP12Il2CppObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z23Input_CUSTOM_GetAxisRawP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 12 | 0;
 i4 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 f3 = Math_fround(__ZN12InputManager10GetAxisRawERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z15GetInputManagerv() | 0, i4));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __Z14RuntimeCleanupv() {
 if (!(HEAP8[gb + 1548962 >> 0] | 0)) return;
 HEAP8[gb + 1548962 >> 0] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanup14ExecuteCleanupEv();
 __ZN10FileSystem8ShutdownEv(__Z13GetFileSystemv() | 0);
 __ZN4File12CleanupClassEv();
 __ZN13MemoryManager16FrameMaintenanceEb(__Z16GetMemoryManagerv() | 0, 1);
 __ZN13MemoryManager16FrameMaintenanceEb(__Z16GetMemoryManagerv() | 0, 1);
 __ZNK14MemoryProfiler21ReportAllocatedMemoryEv(HEAP32[gb + 1163236 >> 2] | 0);
 __Z18ReleaseLogHandlersv();
 __ZN13MemoryManager16FrameMaintenanceEb(__Z16GetMemoryManagerv() | 0, 1);
 __ZN13MemoryManager13StaticDestroyEv();
 return;
}

function _UNITY_FT_List_Finalize(i4, i2, i5, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i6 = 0, i7 = 0;
 if (!((i4 | 0) != 0 & (i5 | 0) != 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  i6 = i5 + 8 | 0;
  if (!i2) do {
   i3 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   mftCall_vii(HEAP32[i6 >> 2] | 0, i5 | 0, i3 | 0);
  } while ((i1 | 0) != 0); else do {
   i7 = i1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   mftCall_viii(i2 | 0, i5 | 0, HEAP32[i7 + 8 >> 2] | 0, i3 | 0);
   mftCall_vii(HEAP32[i6 >> 2] | 0, i5 | 0, i7 | 0);
  } while ((i1 | 0) != 0);
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 return;
}

function _sep_downsample(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i8 = 0, i9 = 0, i10 = 0;
 i8 = HEAP32[i3 + 340 >> 2] | 0;
 i9 = i3 + 60 | 0;
 if ((HEAP32[i9 >> 2] | 0) <= 0) return;
 i1 = HEAP32[i3 + 68 >> 2] | 0;
 i2 = 0;
 while (1) {
  i10 = (HEAP32[i6 + (i2 << 2) >> 2] | 0) + ((Math_imul(HEAP32[i1 + 12 >> 2] | 0, i7) | 0) << 2) | 0;
  mftCall_viiii(HEAP32[i8 + 12 + (i2 << 2) >> 2] | 0, i3 | 0, i1 | 0, (HEAP32[i4 + (i2 << 2) >> 2] | 0) + (i5 << 2) | 0, i10 | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (HEAP32[i9 >> 2] | 0)) break; else i1 = i1 + 84 | 0;
 }
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6snextcEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i2 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 16 | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0) | 0; else {
  HEAP32[i2 >> 2] = i1 + 4;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 do if ((i1 | 0) == -1) i1 = -1; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
   i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0) | 0;
   break;
  } else {
   i1 = HEAP32[i1 >> 2] | 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = gb + 209072 + 12;
 HEAP32[i1 + 12 >> 2] = gb + 209072 + 32;
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i1 + 12 | 0, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 84 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAP32[i1 >> 2] = gb + 208984 + 12;
 HEAP32[i1 + 12 >> 2] = gb + 208984 + 52;
 HEAP32[i1 + 8 >> 2] = gb + 208984 + 32;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_jj(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 i3 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i6 | 0;
  return __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, i2, i4, (i8 ? HEAP32[i5 >> 2] | 0 : i5) + i6 | 0, i3 >>> 0 < i7 >>> 0 ? i3 : i7) | 0;
 }
 return 0;
}

function __ZN9SubModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = i4 + (i7 * 12 | 0) | 0;
 if (!i7) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i3 = i2 + 40 | 0;
 i1 = i4;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i3 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx20InternalTriangleMesh17allocateMaterialsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i1 >>> 0 > 2147483647 ? -1 : i1 << 1;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 731186 | 0 : gb + 837976 | 0) | 0, gb + 724949 | 0, 202) | 0;
 }
 HEAP32[i2 + 160 >> 2] = i1;
 i5 = i1;
 return i5 | 0;
}

function __ZN5physx20InternalTriangleMesh17allocateFaceRemapEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i1 >>> 0 > 1073741823 ? -1 : i1 << 2;
 if (!i1) i1 = 0; else {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
  i3 = _PxGetFoundation() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
  i1 = mftCall_iiiiii(i5 | 0, i4 | 0, i1 | 0, (i3 ? gb + 837736 | 0 : gb + 837976 | 0) | 0, gb + 724949 | 0, 212) | 0;
 }
 HEAP32[i2 + 164 >> 2] = i1;
 i5 = i1;
 return i5 | 0;
}

function __ZN5physx13BigConvexData15importExtraDataERNS_24PxDeserializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i3 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i5 = i2 + 4 | 0;
  i4 = (HEAP32[i5 >> 2] | 0) + 15 & -16;
  HEAP32[i5 >> 2] = i4 + ((HEAPU16[i3 + 2 >> 1] | 0) << 1);
  HEAP32[i1 >> 2] = i4;
 }
 i1 = i3 + 16 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i2 + 4 | 0;
 i6 = (HEAP32[i2 >> 2] | 0) + 15 & -16;
 i4 = i6;
 i5 = (HEAP32[i3 + 8 >> 2] << 2) + 12 & -16;
 HEAP32[i1 >> 2] = i6;
 HEAP32[i2 >> 2] = i4 + (i5 + (HEAP32[i3 + 12 >> 2] | 0));
 HEAP32[i3 + 20 >> 2] = i4 + i5;
 return;
}

function __ZN5IMGUI16GetFocusedWindowER8GUIState(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[i3 + 12 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 L4 : do if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
   if ((i2 | 0) == (i4 | 0)) break L4;
  }
  return i1 | 0;
 } while (0);
 i1 = HEAP32[i3 + 24 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
  i5 = i1;
  return i5 | 0;
 }
 i5 = 0;
 return i5 | 0;
}

function __ZN4FMOD7SystemI19getRecordDriverInfoEiPciP9FMOD_GUID(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP8[i3 >> 0] = HEAP8[gb + 869570 >> 0] | 0;
 HEAP8[i3 + 1 >> 0] = HEAP8[gb + 869570 + 1 >> 0] | 0;
 HEAP8[i3 + 2 >> 0] = HEAP8[gb + 869570 + 2 >> 0] | 0;
 HEAP8[i3 + 3 >> 0] = HEAP8[gb + 869570 + 3 >> 0] | 0;
 HEAP8[i3 + 4 >> 0] = HEAP8[gb + 869570 + 4 >> 0] | 0;
 HEAP8[i3 + 5 >> 0] = HEAP8[gb + 869570 + 5 >> 0] | 0;
 HEAP8[i3 + 6 >> 0] = HEAP8[gb + 869570 + 6 >> 0] | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 return 0;
}

function __ZN4FMOD6Reverb9setActiveEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 856164;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN19ScriptingInvocationC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 96 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 i2 = i1 + 200 | 0;
 i3 = i1 + 224 | 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 HEAP32[i3 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i3 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 return;
}

function __ZN16LightmapSettings17SetGIWorkflowModeEN9Lightmaps14GIWorkflowModeE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = i2 + 8 | 0;
  HEAP32[i2 >> 2] = i3;
  return;
 }
 i2 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
 HEAP32[i2 + 4 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 43424 + 8;
 HEAP32[i2 + 8 >> 2] = 1;
 HEAP32[i2 + 12 >> 2] = 1;
 i4 = i2 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN12_GLOBAL__N_110DataStream19addProfileZoneEventEPvPKctb(i4, i5, i3, i2, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = gb + 149940 + 8;
 i8 = i7 + 8 | 0;
 HEAP32[i8 >> 2] = i5;
 HEAP32[i8 + 4 >> 2] = 0;
 HEAP32[i7 + 16 >> 2] = i3;
 HEAP16[i7 + 20 >> 1] = i2;
 HEAP8[i7 + 22 >> 0] = i1 & 1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i4, i7, 25);
 STACKTOP = i6;
 return;
}

function __Z40Transform_CUSTOM_INTERNAL_get_localScaleP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Transform13GetLocalScaleEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Light_Set_Custom_PropShadowsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i2 >>> 0 > 2) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 540744 | 0, i4);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  __ZN5Light13SetShadowTypeE10ShadowType(i3, i2);
  STACKTOP = i4;
  return;
 }
}

function ___procfdname(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i5;
 i3 = gb + 1069326 | 0;
 i4 = i1 + 15 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i1 | 0) < (i4 | 0));
 if (!i2) {
  HEAP8[i5 + 14 >> 0] = 48;
  HEAP8[i5 + 15 >> 0] = 0;
 } else {
  i3 = i2;
  i1 = 14;
  while (1) {
   i1 = i1 + 1 | 0;
   if (i3 >>> 0 < 10) break; else i3 = (i3 >>> 0) / 10 | 0;
  }
  HEAP8[i5 + i1 >> 0] = 0;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP8[i5 + i1 >> 0] = (i2 >>> 0) % 10 | 0 | 48;
   if (i2 >>> 0 < 10) break; else i2 = (i2 >>> 0) / 10 | 0;
  }
 }
 return;
}

function __ZN7dtCrowd13getMoveTargetERK13dtCrowdHandlePf(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!(HEAP8[i1 + (i3 * 608 | 0) + 602 >> 0] & 4)) {
  HEAP32[i4 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 12 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 16 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 20 >> 2];
  return;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 576 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 580 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i1 + (i3 * 608 | 0) + 584 >> 2];
  return;
 }
}

function __ZN5physx2Sc27ConstraintProjectionManager23addToPendingTreeUpdatesERNS0_19ConstraintGroupNodeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1 + 340 | 0, i5, i4) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
 i5 = i2 + 44 | 0;
 HEAP8[i5 >> 0] = HEAPU8[i5 >> 0] | 4;
 STACKTOP = i3;
 return;
}

function __ZN28LightProbeProxyVolumeContextC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i4 = i3;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i4;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, i4);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN14GfxContextGLES8Instance10InvalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i5 = i2;
 __ZN18GfxFramebufferGLES10InvalidateEv(i1 + 8 | 0);
 i4 = HEAP32[gb + 1451080 >> 2] | 0;
 i7 = i1 + 532 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i1 = i5;
 HEAP32[i1 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i1 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN7ApiGLES15BindVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE(i4, i3);
 STACKTOP = i2;
 return;
}

function __ZN14ConstantString7cleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (i3 >>> 0 < (gb + 388687 | 0) >>> 0 | i3 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i4 = i3 + -8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i2, HEAP32[i3 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
  }
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __Z43ParticleSystem_Get_Custom_PropStartRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem16GetStartRotationEv(i2));
 return Math_fround(0.0);
}

function __Z43ParticleSystem_Get_Custom_PropStartLifetimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem16GetStartLifeTimeEv(i2));
 return Math_fround(0.0);
}

function __Z36TerrainData_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Heightmap7GetSizeEv(i3, i4 + 248 | 0);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32SetVirtualJoystickConnectedStatePKcb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[gb + 1162016 >> 2] | 0;
 i2 = HEAP32[i5 + 20 >> 2] | 0;
 i5 = i5 + 24 | 0;
 if ((i2 | 0) == (HEAP32[i5 >> 2] | 0)) return;
 i3 = i1 & 1;
 i1 = i2;
 do {
  i2 = _strlen(i4) | 0;
  i6 = HEAP8[i1 + 11 >> 0] | 0;
  if ((i2 | 0) == ((i6 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i6 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, i4, i2) | 0)) HEAP8[i1 + 12 >> 0] = i3;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (HEAP32[i5 >> 2] | 0));
 return;
}

function __Z24GetClothScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459024 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 839673 | 0, 16) | 0;
 HEAP32[gb + 1459024 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839795 | 0) | 0;
 HEAP32[HEAP32[gb + 1459024 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839820 | 0) | 0;
 HEAP32[(HEAP32[gb + 1459024 >> 2] | 0) + 4 >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 258 | 0, fb + 259 | 0);
 i1 = HEAP32[gb + 1459024 >> 2] | 0;
 return i1 | 0;
}

function __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = __Z13GetFileSystemv() | 0;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i3, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = __ZNK10FileSystem6DeleteEPKcb(i4, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i1 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function _jpeg_read_header(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i2 & -2 | 0) != 200) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 20;
  HEAP32[i4 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
 }
 i2 = _jpeg_consume_input(i1) | 0;
 switch (i2 | 0) {
 case 1:
  {
   i4 = 1;
   return i4 | 0;
  }
 case 2:
  {
   if (i3 << 24 >> 24) {
    i4 = HEAP32[i1 >> 2] | 0;
    HEAP32[i4 + 20 >> 2] = 51;
    mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
   }
   _jpeg_abort(i1);
   i4 = 2;
   return i4 | 0;
  }
 default:
  {
   i4 = i2;
   return i4 | 0;
  }
 }
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_jj(i1, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i3 = 0, i8 = 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i8 = i3 << 24 >> 24 < 0;
 i3 = i8 ? HEAP32[i5 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i6 | 0;
  return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i1, i2, i4, (i8 ? HEAP32[i5 >> 2] | 0 : i5) + i6 | 0, i3 >>> 0 < i7 >>> 0 ? i3 : i7) | 0;
 }
 return 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcj(i2, i5, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i6 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i3 = _strlen(i5) | 0;
 i1 = i2 + (i1 >>> 0 > i4 >>> 0 ? i4 + 1 | 0 : i1) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   break;
  }
  i1 = i1 + -1 | 0;
  if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i5, i3, i1) | 0)) {
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) i1 = i1 - i2 | 0;
 return i1 | 0;
}

function __ZN8Animator15SetGoalPositionEiRK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 >= 4) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i4 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i5 = i4 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 i5 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 HEAP32[i5 + 68 + (i2 << 6) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 68 + (i2 << 6) + 4 >> 2] = i1;
 HEAP32[i5 + 68 + (i2 << 6) + 8 >> 2] = i4;
 return;
}

function __ZN6prcoreL13inner_stretchILj3ELj3EEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = i3 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i8 = i5 + ((i1 >>> 16) * 3 | 0) | 0;
  i7 = HEAP8[i8 + 1 >> 0] | 0;
  i3 = HEAP8[i8 + 2 >> 0] | 0;
  HEAP8[i4 >> 0] = HEAP8[i8 >> 0] | 0;
  HEAP8[i4 + 1 >> 0] = i7;
  HEAP8[i4 + 2 >> 0] = i3;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc7BodySim20postBody2WorldChangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 128 >> 2] | 0;
 HEAP32[i1 + 96 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 100 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 104 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 108 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 112 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 116 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 24 >> 2];
 __ZN5physx12PxsRigidBody23updatePoseDependenciesVERNS_10PxsContextE(i1 + 64 | 0, HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 1e3 >> 2] | 0);
 __ZN5physx2Sc8RigidSim25notifyShapeTranformChangeEv(i1);
 return;
}

function __ZN4FMOD5Sound8seekDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870130;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN22VirtualJoystickManager32SetVirtualJoystickConnectedStateEPKcb(i1, i6, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i5 = i1 + 24 | 0;
 if ((i3 | 0) == (HEAP32[i5 >> 2] | 0)) return;
 i4 = i2 & 1;
 i1 = i3;
 do {
  i2 = _strlen(i6) | 0;
  i3 = HEAP8[i1 + 11 >> 0] | 0;
  if ((i2 | 0) == ((i3 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0)) if (!(__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, 0, -1, i6, i2) | 0)) HEAP8[i1 + 12 >> 0] = i4;
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (HEAP32[i5 >> 2] | 0));
 return;
}

function __ZN21FixedBehaviourManager6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1155132 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155132 | 0, i1);
  i1 = gb + 1155132 | 0;
 } else i1 = 0;
 __ZN20BaseBehaviourManager12CommonUpdateI21FixedBehaviourManagerEEvv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN12SoundManager12AwaitLoadingEPN11SoundHandle8InstanceE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i3) {
  __ZN11SoundHandle8Instance15UpdateLoadStateEv(0);
  __ZN11SoundHandle8Instance15UpdateLoadStateEv(0);
  i1 = 1;
 } else {
  i2 = i3 + 44 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == 3) i1 = 1; else if ((i1 | 0) == 4) i1 = 0; else {
   __ZN11SoundHandle8Instance15UpdateLoadStateEv(i3);
   i1 = HEAP32[i2 >> 2] | 0;
   if ((i1 | 0) == 3) i1 = 1; else if ((i1 | 0) == 4) i1 = 0; else {
    __ZN11SoundHandle8Instance15UpdateLoadStateEv(i3);
    i1 = (HEAP32[i2 >> 2] | 0) != 4;
   }
  }
 }
 return i1 | 0;
}

function __ZN11MonoManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 if ((i3 | 0) == (i5 | 0)) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 i1 = i3;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 HEAP32[i2 >> 2] = i1;
 i3 = HEAP32[gb + 1170804 >> 2] | 0;
 i4 = i3 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i3 + 8 >> 2] | 0)) {
  __ZNSt3__26vectorIP10MemoryPool13stl_allocatorIS2_L18MemLabelIdentifier72ELi16EEE21__push_back_slow_pathIKS2_EEvRT_(i3, i2);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = i1;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  STACKTOP = i6;
  return;
 }
}

function __Z44DownloadHandler_CUSTOM_InternalCreateTextureP12Il2CppObjecth(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(48, gb + 63808 | 0, 16, gb + 1027567 | 0, 76) | 0;
 __ZN22DownloadHandlerTextureC2Eb(i3, i1 << 24 >> 24 == 0);
 HEAP32[i2 + 8 >> 2] = i3;
 i1 = i3 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i2) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 return;
}

function __GLOBAL__sub_I_TimerQueryGLES_cpp() {
 HEAP32[gb + 1098256 + 544 >> 2] = gb + 1098256 + 544;
 HEAP32[gb + 1098256 + 548 >> 2] = gb + 1098256 + 544;
 HEAP32[gb + 1098256 + 552 >> 2] = gb + 1098256 + 552;
 HEAP32[gb + 1098256 + 556 >> 2] = gb + 1098256 + 552;
 HEAP32[gb + 1098256 + 560 >> 2] = 0;
 HEAP8[gb + 1098256 + 564 >> 0] = 0;
 _memset(gb + 1098256 | 0, 0, 516) | 0;
 HEAP32[gb + 1098256 + 520 >> 2] = 0;
 HEAP32[gb + 1098256 + 520 + 4 >> 2] = 0;
 HEAP32[gb + 1098256 + 520 + 8 >> 2] = 0;
 HEAP32[gb + 1098256 + 520 + 12 >> 2] = 0;
 HEAP32[gb + 1098256 + 520 + 16 >> 2] = 0;
 HEAP32[gb + 1098256 + 520 + 20 >> 2] = 0;
 return;
}

function _jinit_huff_encoder(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 1, 108) | 0;
 HEAP32[i1 + 348 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 2362;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 92 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 96 >> 2] = 0;
 HEAP32[i2 + 80 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 HEAP32[i2 + 100 >> 2] = 0;
 HEAP32[i2 + 84 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 104 >> 2] = 0;
 HEAP32[i2 + 88 >> 2] = 0;
 return;
}

function ___crypt_des(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = (HEAP8[i3 >> 0] | 0) == 95;
 i7 = i4 ? gb + 1056728 | 0 : gb + 1056738 | 0;
 i1 = __crypt_extended_r_uut(i1, i3, i2) | 0;
 i2 = __crypt_extended_r_uut(gb + 1056741 | 0, i7, i6) | 0;
 if (!i2) i5 = 3; else if (!((i1 | 0) != 0 & (_strcmp(i2, i4 ? gb + 1056762 | 0 : gb + 1056783 | 0) | 0) == 0)) i5 = 3;
 if ((i5 | 0) == 3) i1 = (HEAP8[i3 >> 0] | 0) == 42 ? gb + 1085989 | 0 : gb + 1086428 | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = gb + 77508 + 12;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = gb + 77508 + 32;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i2);
 __ZdlPv(i1);
 return;
}

function __ZNKSt16nested_exception14rethrow_nestedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i1 = i2 + 4 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) == 0;
 ___cxa_decrement_exception_refcount(0);
 if (i2) __ZSt9terminatev(); else {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  ___cxa_increment_exception_refcount(i2 | 0);
  __THREW__ = 0;
  invoke_vi(fb + 3996 | 0, i3 | 0);
  __THREW__ = 0;
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_decrement_exception_refcount(i2 | 0);
  ___resumeException(i3 | 0);
 }
}

function __ZN6Socket15SetReuseAddressEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 & 1;
 HEAP32[i4 >> 2] = i3;
 i1 = i2 + 4 | 0;
 if (__ZN6Socket10CheckErrorEiPKcii(__Z15setsockopt_stubiiiPKvj(HEAP32[i1 >> 2] | 0, 1, 2, i4, 4) | 0, gb + 458690 | 0, 0, 0) | 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = i3;
 i4 = (__ZN6Socket10CheckErrorEiPKcii(__Z15setsockopt_stubiiiPKvj(HEAP32[i1 >> 2] | 0, 1, 15, i4, 4) | 0, gb + 458715 | 0, 0, 0) | 0) ^ 1;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx30PxVehicle4WEnable3WTadpoleModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i5 = i4;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i5 >> 2] = -1;
 __ZN5physx16computeDirectionERjS0_(i6, i5);
 __ZN5physx12enable3WModeEjjbRNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE(HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, 0, i3, i2, i1);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD3DSP9setBypassEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853251;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN4FMOD3DSP9setActiveEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) {
  i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i1 | 0) if (!(HEAP8[i1 + 16 >> 0] | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 856164;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN20UnloadSceneOperation19IntegrateMainThreadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z15GetSceneManagerv() | 0;
 i2 = i1 + 64 | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0) | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  i3 = i1 + 60 | 0;
  HEAPF32[i3 >> 2] = Math_fround(1.0);
  return;
 }
 __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene(__Z15GetSceneManagerv() | 0, i3);
 __ZN19RuntimeSceneManager20RemoveAndDeleteSceneEP10UnityScene(__Z15GetSceneManagerv() | 0, i3) | 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 60 | 0;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 return;
}

function __ZN17PhysicsMaterial2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 156188 + 8;
 HEAP32[i1 + 40 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN16ParticleRenderer20SetUVAnimationCyclesEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i3 = i4 + 4 | 0;
 HEAPF32[i5 >> 2] = f1;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i6 = f1 < Math_fround(0.0);
 i3 = HEAP32[(i6 ? i3 : i5) >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 f1 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 i2 = i2 + 364 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN14ParticleSystem31PlaybackSubEmitterCommandBufferERKS_R19ParticleSystemStateb(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 460 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i3 + 456 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i3 = i3 + 400 | 0;
 i1 = 0;
 do {
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + ((HEAP32[i6 + (i1 * 112 | 0) + 88 >> 2] | 0) * 600 | 0) + 596 >> 2] | 0;
  if (i2 | 0) __ZN14ParticleSystem4EmitERS_RK21SubEmitterEmitCommand(i2, i6 + (i1 * 112 | 0) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN13SliderJoint2D8SetAngleEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(-1.0e6);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 HEAPF32[i3 + 96 >> 2] = i2 ? Math_fround(-1.0e6) : f1;
 if (!(HEAP32[i3 + 60 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, 1);
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0);
 return;
}

function __ZN12HandlerChain4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z19Random_CUSTOM_Rangeff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = __Z16GetScriptingRandv() | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = i6 << 11 ^ i6;
 i4 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i4 >> 2];
 i7 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 i5 = i5 + 12 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i7 >> 2] = i4;
 i4 = i6 >>> 8 ^ i6 ^ i4 ^ i4 >>> 19;
 HEAP32[i5 >> 2] = i4;
 f3 = Math_fround(Math_fround((i4 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
 return Math_fround(Math_fround(f3 * f1) + Math_fround(Math_fround(Math_fround(1.0) - f3) * f2));
}

function __Z12testransSignP10TESSvertexS0_S0_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f3 = f0, f5 = f0, f6 = f0;
 f3 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f5 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 28 >> 2]));
 f3 = Math_fround(Math_fround(HEAPF32[i4 + 28 >> 2]) - f3);
 if (!(Math_fround(f5 + f3) > Math_fround(0.0))) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f6 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f6 - Math_fround(HEAPF32[i4 + 24 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f3 * Math_fround(f6 - Math_fround(HEAPF32[i1 + 24 >> 2]))));
 return Math_fround(f5);
}

function __ZNK18ProceduralMaterial18GetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  return;
 } else {
  HEAP32[i3 >> 2] = HEAP32[i1 + 68 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 72 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 76 >> 2];
  HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 80 >> 2];
  return;
 }
}

function __ZN9GfxDevice15InvalidateStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4381 >> 0] = 0;
 HEAP32[i1 + 4384 >> 2] = -1;
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 i1 = i1 + 76 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN7Cubemap34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = HEAP32[i4 + 40 >> 2] | 0;
 HEAP32[i2 + 28 >> 2] = i3;
 HEAP32[i2 + 24 >> 2] = Math_imul(HEAP32[i4 + 44 >> 2] | 0, i3) | 0;
 HEAP32[i2 + 32 >> 2] = 1;
 HEAP32[i2 + 36 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 40 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i1 + 44 >> 2] = 1;
 i2 = i2 + 64 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -1711276033 | 33554432;
 return;
}

function __ZN20LateBehaviourManager6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1155144 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155144 | 0, i1);
  i1 = gb + 1155144 | 0;
 } else i1 = 0;
 __ZN20BaseBehaviourManager12CommonUpdateI20LateBehaviourManagerEEvv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN17TransformInternal25DestroyTransformHierarchyEP18TransformHierarchy(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 if (!i1) return;
 i2 = HEAP32[gb + 1158396 >> 2] | 0;
 i3 = i1 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != -1) {
  i5 = i2 + 12 | 0;
  i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
  i7 = HEAP32[i2 >> 2] | 0;
  i2 = i7 + (i6 << 2) | 0;
  HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] = i4;
  i4 = i7 + (HEAP32[i3 >> 2] << 2) | 0;
  HEAP32[i5 >> 2] = i6;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 >> 2] = -1;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 return;
}

function __ZN15FileSystemEntryaSERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if ((i2 | 0) == (i3 | 0)) return i2 | 0;
 i4 = i2 + 1040 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 | 0);
 _strncpy(i2, i3, 1040) | 0;
 HEAP8[i2 + 1039 >> 0] = 0;
 i1 = HEAP32[i3 + 1040 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = HEAP32[i3 + 1044 >> 2];
 HEAP32[i2 + 1048 >> 2] = 0;
 HEAP32[i2 + 1052 >> 2] = 0;
 HEAP32[i2 + 1056 >> 2] = 0;
 if (!i1) return i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 return i2 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 12 | 0;
 i3 = HEAP8[i5 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 i3 = __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj(i1, i4 ? HEAP32[i5 >> 2] | 0 : i5, i4 ? HEAP32[i1 + 16 >> 2] | 0 : i3 & 255) | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleRK13Vector2fIcallfiff(i1, f2, i3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i7 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16Physics2DManager13OverlapCircleERK8Vector2ffiffPK10Collider2D(i8, i7, f2, i3, f4, f5, 0) | 0) | 0;
 STACKTOP = i6;
 return i3 | 0;
}

function __Z40Terrain_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK7Terrain11GetPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Transform_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Transform11GetPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody11GetVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK9Rigidbody11GetPositionEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Shader_CUSTOM_IsKeywordEnabledP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 i4 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZNK11ICallString6ToUTF8Ev(i3, i5);
 i1 = __ZN8keywords6CreateEPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 i1 = (1 << (i1 & 31) & HEAP32[i4 + 4 + (i1 >>> 5 << 2) >> 2] | 0) != 0 & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z27PlayerPrefs_CUSTOM_GetFloatP12Il2CppStringf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 f2 = Math_fround(__ZN11PlayerPrefs8GetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf(i4, f2));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return Math_fround(f2);
}

function __Z11tesedgeSignP10TESSvertexS0_S0_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var f3 = f0, f5 = f0, f6 = f0;
 f3 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f5 = Math_fround(f3 - Math_fround(HEAPF32[i1 + 24 >> 2]));
 f3 = Math_fround(Math_fround(HEAPF32[i4 + 24 >> 2]) - f3);
 if (!(Math_fround(f5 + f3) > Math_fround(0.0))) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f6 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f5 = Math_fround(f5 * Math_fround(f6 - Math_fround(HEAPF32[i4 + 28 >> 2])));
 f5 = Math_fround(f5 + Math_fround(f3 * Math_fround(f6 - Math_fround(HEAPF32[i1 + 28 >> 2]))));
 return Math_fround(f5);
}

function _UNITY_png_build_grayscale_palette(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 if (!i5) return;
 switch (i1 | 0) {
 case 1:
  {
   i2 = 255;
   i3 = 2;
   break;
  }
 case 2:
  {
   i2 = 85;
   i3 = 4;
   break;
  }
 case 4:
  {
   i2 = 17;
   i3 = 16;
   break;
  }
 case 8:
  {
   i2 = 1;
   i3 = 256;
   break;
  }
 default:
  return;
 }
 i1 = 0;
 i4 = 0;
 while (1) {
  i6 = i4 & 255;
  HEAP8[i5 + (i1 * 3 | 0) >> 0] = i6;
  HEAP8[i5 + (i1 * 3 | 0) + 1 >> 0] = i6;
  HEAP8[i5 + (i1 * 3 | 0) + 2 >> 0] = i6;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i3 | 0)) break; else i4 = i4 + i2 | 0;
 }
 return;
}

function __ZThn4_N5physx5cloth9SwFactory5cloneERKNS0_5ClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = i1 + -4 | 0;
 if (!(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0) + 4 >> 2] | 0)) {
  i4 = __ZN5physx5cloth8allocateEj(560) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i4 >> 2] = gb + 167452 + 8;
  HEAP32[i3 >> 2] = gb + 167452 + 424;
  __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERKS1_(i4 + 16 | 0, i1, i2 + 12 | 0);
  i2 = (i4 | 0) == 0 ? 0 : i3;
  return i2 | 0;
 } else {
  i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 + 4 | 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZNK8Collider21ShouldIgnoreCollisionEPS_(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i6 = HEAP32[i1 + 48 >> 2] | 0;
 i1 = i6 - i2 >> 2;
 if (!i1) i1 = i2; else {
  i5 = i1;
  i1 = i2;
  while (1) {
   i8 = (i5 | 0) / 2 | 0;
   i4 = i2 + (i8 << 2) | 0;
   i3 = (HEAP32[i4 >> 2] | 0) >>> 0 < i7 >>> 0;
   i4 = i4 + 4 | 0;
   i1 = i3 ? i4 : i1;
   i5 = i3 ? i5 + -1 - i8 | 0 : i8;
   if (!i5) break; else i2 = i3 ? i4 : i2;
  }
 }
 if ((i1 | 0) == (i6 | 0)) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = (HEAP32[i1 >> 2] | 0) >>> 0 <= i7 >>> 0;
 return i8 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i3 + 20 + (i1 * 28 | 0) + 24 >> 2];
 return;
}

function __ZN9ShaderLab10SubProgramD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = __Z21GetUncheckedGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 208 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN20GpuProgramParametersD2Ev(i1);
  __ZdlPv(i1);
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 72 | 0);
 if ((HEAP32[i2 + 68 >> 2] | 0) <= -1) return;
 i3 = i2 + 52 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 56 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN9AudioClip20CreateScriptCallbackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return;
 __ZN9AudioClip16EnableLegacyModeEv(i1);
 if (!(__ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0)) return;
 i1 = i1 + 124 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 60 | 0;
 i3 = __Z24GetAudioScriptingClassesv() | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + 68 | 0;
 i2 = (__Z24GetAudioScriptingClassesv() | 0) + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 return;
}

function __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjfbfRNS_6memory9AllocatorE(i1, f2, i3, f4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i6 = 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, 48, 4) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = -1;
 HEAP32[i5 + 8 >> 2] = -1;
 i6 = i5 + 16 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = i1;
 HEAPF32[i5 + 36 >> 2] = f2;
 HEAP8[i5 + 44 >> 0] = i3 & 1;
 HEAPF32[i5 + 40 >> 2] = f4;
 return i5 | 0;
}

function __ZN5physx5cloth6GatherI8Scalar4fEC2ERKS2_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2] & 7;
 i5 = i1 + 4 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 >> 2] & 7;
 i4 = i1 + 8 | 0;
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 >> 2] & 7;
 i3 = i1 + 12 | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 >> 2] & 7;
 HEAP32[i2 + 16 >> 2] = ((HEAP32[i1 >> 2] | 0) >>> 0 < 8) << 31 >> 31;
 HEAP32[i2 + 20 >> 2] = ((HEAP32[i5 >> 2] | 0) >>> 0 < 8) << 31 >> 31;
 HEAP32[i2 + 24 >> 2] = ((HEAP32[i4 >> 2] | 0) >>> 0 < 8) << 31 >> 31;
 HEAP32[i2 + 28 >> 2] = ((HEAP32[i3 >> 2] | 0) >>> 0 < 8) << 31 >> 31;
 return;
}

function __ZN5physx28PxVehicle4WEnable3WDeltaModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 4 | 0;
 i5 = i4;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i5 >> 2] = -1;
 __ZN5physx16computeDirectionERjS0_(i6, i5);
 __ZN5physx12enable3WModeEjjbRNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE(HEAP32[i6 >> 2] | 0, HEAP32[i5 >> 2] | 0, 1, i3, i2, i1);
 STACKTOP = i4;
 return;
}

function __ZN5physx10NpMaterial14setRestitutionEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (f3 < Math_fround(0.0) | f3 > Math_fround(1.0)) {
  i5 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
  HEAPF64[i2 >> 3] = +f3;
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i5, 4, gb + 688978 | 0, 124, gb + 689050 | 0, i2);
 }
 HEAPF32[i1 + 40 >> 2] = f3;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 STACKTOP = i4;
 return;
}

function __ZN29PxsCreateFinalizeContactsTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 32 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 36 >> 2]);
 __Z31createFinalizeContacts_ParallelN5physx14PxFrictionType4EnumEPNS_17PxcSolverBodyDataERNS_16PxsThreadContextEffffPNS_10PxsContextEPijj(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i1 + 56 >> 2] | 0, f5, f4, f3, f2, HEAP32[i1 + 60 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, HEAP32[i1 + 64 >> 2] | 0, HEAP32[i1 + 68 >> 2] | 0) | 0;
 return;
}

function __ZN21WorldParticleColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 191232 + 8;
 STACKTOP = i4;
 return;
}

function __ZN10SampleClipD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 170392 + 8;
 i3 = i1 + 72 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 84 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 __ZN11SoundHandleD2Ev(i1 + 56 | 0);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __Z40ParticleSystem_Set_Custom_PropStartSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem13SetStartSpeedEf(i3, f2);
  return;
 }
}

function __Z40ParticleSystem_Set_Custom_PropStartDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem13SetStartDelayEf(i3, f2);
  return;
 }
}

function __Z29GUI_CUSTOM_SetNextControlNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = __Z11GetGUIStatev() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __ZN10OnGUIState28SetNameOfNextKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1 + 12 | 0, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z29CreateShaderVariantCollectionv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 8 | 0;
 i3 = i1;
 i6 = gb + 63520 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 i2 = __Z20CreateObjectFromCodeI23ShaderVariantCollectionEPT_17AwakeFromLoadMode10MemLabelId(4, i2) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, 61);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function _UNITY_png_create_write_struct(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = _UNITY_png_create_png_struct(i1, i2, i3, i4, 0, 0, 0) | 0;
 if (!i1) return i1 | 0;
 HEAP32[i1 + 280 >> 2] = 8192;
 HEAP32[i1 + 300 >> 2] = 1;
 HEAP32[i1 + 284 >> 2] = -1;
 HEAP32[i1 + 296 >> 2] = 8;
 HEAP32[i1 + 292 >> 2] = 15;
 HEAP32[i1 + 288 >> 2] = 8;
 HEAP32[i1 + 320 >> 2] = 0;
 HEAP32[i1 + 304 >> 2] = -1;
 HEAP32[i1 + 316 >> 2] = 8;
 HEAP32[i1 + 312 >> 2] = 15;
 HEAP32[i1 + 308 >> 2] = 8;
 i4 = i1 + 208 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2097152;
 _UNITY_png_set_write_fn(i1, 0, 0, 0);
 return i1 | 0;
}

function _request_virt_sarray(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) != 1) {
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 14;
  HEAP32[i8 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i1 | 0);
 }
 i8 = _alloc_small(i1, i2, 120) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = i5;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i6;
 HEAP8[i8 + 32 >> 0] = i3;
 HEAP8[i8 + 34 >> 0] = 0;
 i7 = i7 + 68 | 0;
 HEAP32[i8 + 36 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 return i8 | 0;
}

function _request_virt_barray(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i2 | 0) != 1) {
  i8 = HEAP32[i1 >> 2] | 0;
  HEAP32[i8 + 20 >> 2] = 14;
  HEAP32[i8 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i8 >> 2] | 0, i1 | 0);
 }
 i8 = _alloc_small(i1, i2, 120) | 0;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = i5;
 HEAP32[i8 + 8 >> 2] = i4;
 HEAP32[i8 + 12 >> 2] = i6;
 HEAP8[i8 + 32 >> 0] = i3;
 HEAP8[i8 + 34 >> 0] = 0;
 i7 = i7 + 72 | 0;
 HEAP32[i8 + 36 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i7 >> 2] = i8;
 return i8 | 0;
}

function _cf2_stack_getReal(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP32[i1 + 392 >> 2] | 0) - (i1 + 8) >> 3 >>> 0 <= i2 >>> 0) {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 130);
  i3 = 0;
  return i3 | 0;
 }
 i3 = i1 + 8 + (i2 << 3) | 0;
 switch (HEAP32[i1 + 8 + (i2 << 3) + 4 >> 2] | 0) {
 case 2:
  {
   i3 = HEAP32[i3 >> 2] << 16;
   return i3 | 0;
  }
 case 1:
  {
   i1 = HEAP32[i3 >> 2] | 0;
   if ((i1 | 0) < 0) {
    i3 = 0 - (8192 - i1 >> 14) | 0;
    return i3 | 0;
   } else {
    i3 = i1 + 8192 >> 14;
    return i3 | 0;
   }
  }
 default:
  {
   i3 = HEAP32[i3 >> 2] | 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZNK5physx2Sc19ParticlePacketShape18computeWorldBoundsERNS_9PxBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 44 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i2 | 0);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 STACKTOP = i3;
 return;
}

function __ZN5physx9NpPhysics13registerClothEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx9NpFactory13registerClothEv();
 i3 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i1 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 i1 = i1 + 4 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc5Scene17createClothSolverEv((HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 32 | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefIKhEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = (HEAP32[i2 + 4 >> 2] | 0) - i5;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, 4) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0, HEAP32[i4 >> 2] | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn5ConvX11resetUnionsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 292 >> 2] | 0;
 i3 = i1 + 296 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i1 << 4) | 0;
 if ((i1 | 0) > 0) i1 = i2; else {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 do {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
   i2 = HEAP32[i1 + 4 >> 2] | 0;
   if (i2 | 0) {
    i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
    mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
   }
  }
  i1 = i1 + 16 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN5physx2Gu10ConvexMeshD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 107052 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107052 + 84;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i3;
  return;
 }
 i2 = i1 + 56 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx13BigConvexDataD2Ev(i1);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, i1);
 }
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5Unity11SpringJoint12SetToleranceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(1.00000005e-20);
 i4 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i4 ? Math_fround(340282326000000008404918.0e15) : f1;
 i4 = i2 + 112 | 0;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(1.00000005e-20) : f1;
 i2 = i2 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i4 >> 2]));
 return;
}

function __ZN4FMOD7SystemI4initEijPv(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 _JS_Sound_Init();
 __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi(i3 + 76 | 0, i4);
 i4 = __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi(i3 + 124 | 0, -1) | 0;
 HEAP32[i3 + 316 >> 2] = i4;
 if (i4 | 0) {
  i4 = 0;
  STACKTOP = i2;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = 33;
 HEAP32[i1 + 4 >> 2] = gb + 860991;
 _printf(gb + 860996 | 0, i1) | 0;
 i4 = 33;
 STACKTOP = i2;
 return i4 | 0;
}

function __ZN20ArchiveStorageHeader23ReadHeaderAndBlocksInfoER12FileAccessorRNS_6HeaderERNS_10BlocksInfoE(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 if (((i1 ? HEAP32[i3 + 4 >> 2] | 0 : i5 & 255) | 0) != 8) {
  i5 = -1;
  return i5 | 0;
 }
 i1 = i1 ? HEAP32[i3 >> 2] | 0 : i3;
 if (_memcmp(i1, gb + 489810 | 0, 8) | 0) if (_memcmp(i1, gb + 489801 | 0, 8) | 0) {
  i5 = -1;
  return i5 | 0;
 }
 i5 = __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE(i2, i3, i4) | 0;
 return i5 | 0;
}

function __ZN14Texture2DArray19UnloadFromGfxDeviceEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!((HEAP8[i3 + 110 >> 0] | 0) == 0 | i1)) {
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 108 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 + 48 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i2 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 STACKTOP = i5;
 return;
}

function __ZN13RenderTexture23GetNativeDepthBufferPtrEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i3 = i4;
 if (!(HEAP8[i2 + 156 >> 0] | 0)) {
  i3 = __ZN7Texture19GetNativeTexturePtrEv(i2) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  i5 = __Z12GetGfxDevicev() | 0;
  i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 716 >> 2] | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 + 124 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  i3 = mftCall_iii(i6 | 0, i5 | 0, i1 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN13FileEntryDataaSERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if ((i2 | 0) == (i3 | 0)) return i2 | 0;
 i4 = i2 + 1040 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 | 0);
 _strncpy(i2, i3, 1040) | 0;
 HEAP8[i2 + 1039 >> 0] = 0;
 i1 = HEAP32[i3 + 1040 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = HEAP32[i3 + 1044 >> 2];
 HEAP32[i2 + 1048 >> 2] = 0;
 HEAP32[i2 + 1052 >> 2] = 0;
 HEAP32[i2 + 1056 >> 2] = 0;
 if (!i1) return i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 return i2 | 0;
}

function __ZN12_GLOBAL__N_119RendererEventClient17handleBufferFlushEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 12 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i1 + i2;
 HEAP32[i5 >> 2] = gb + 776474;
 HEAP32[i5 + 4 >> 2] = gb + 827872;
 mftCall_iiiiii(i8 | 0, i7 | 0, i3 | 0, gb + 1046975 | 0, i6 | 0, i5 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_110DataStream15destroyInstanceEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[i2 + 64 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, i1 | 0);
 HEAP32[i4 >> 2] = gb + 150040 + 8;
 i5 = i4 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i4, 15);
 STACKTOP = i3;
 return (HEAPU8[i2 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN12WheelJoint2D8SetMotorERK12JointMotor2D(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 108 | 0;
 i5 = i1;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP8[i3 + 116 >> 0] = 1;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN12b2WheelJoint11EnableMotorEb(i2, 1);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN12b2WheelJoint13SetMotorSpeedEf(i1, Math_fround(Math_fround(HEAPF32[i4 >> 2]) * Math_fround(.0174532924)));
 __ZN12b2WheelJoint17SetMaxMotorTorqueEf(i1, Math_fround(HEAPF32[i3 + 112 >> 2]));
 return;
}

function __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = 254;
 HEAP32[i5 + 4 >> 2] = i2;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i2 = __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue(i1, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z28Shader_CUSTOM_DisableKeywordP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZNK11ICallString6ToUTF8Ev(i3, i4);
 i4 = __ZN8keywords6CreateEPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 i1 = i1 + 4 + (i4 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << (i4 & 31));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z21SetShaderGlobalMatrixN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) != -1 & (i3 & -1073741824 | 0) == -2147483648) {
  i3 = __Z12GetGfxDevicev() | 0;
  i3 = i3 + 1764 + ((HEAP32[i1 >> 2] & 1073741823) << 6) | 0;
  i1 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   i3 = i3 + 4 | 0;
   i2 = i2 + 4 | 0;
  } while ((i3 | 0) < (i1 | 0));
  return;
 } else {
  __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, i1, i2, 0);
  return;
 }
}

function __Z20Input_CUSTOM_GetAxisP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2 + 12 | 0;
 i4 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 f3 = Math_fround(__ZN12InputManager7GetAxisERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z15GetInputManagerv() | 0, i4));
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i2;
 return Math_fround(f3);
}

function _UNITY_FT_Outline_Done_Internal(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) {
  i2 = 20;
  return i2 | 0;
 }
 if (!i1) {
  i2 = 6;
  return i2 | 0;
 }
 if (HEAP32[i2 + 16 >> 2] & 1 | 0) {
  i3 = i2 + 4 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 8 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = i2 + 12 | 0;
  _UNITY_ft_mem_free(i1, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i3 = 0;
 return i3 | 0;
}

function _openat(i3, i4, i5, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i7 + 16 | 0;
 if (!(i5 & 4194368)) i1 = 0; else {
  HEAP32[i1 >> 2] = i2;
  i8 = (HEAP32[i1 >> 2] | 0) + (4 - 1) & ~(4 - 1);
  i2 = HEAP32[i8 >> 2] | 0;
  HEAP32[i1 >> 2] = i8 + 4;
  i1 = i2;
 }
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i5 | 32768;
 HEAP32[i6 + 12 >> 2] = i1;
 i8 = ___syscall_ret(___syscall295(295, i6 | 0) | 0) | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEjw(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = i2 + 8 + 3 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i6 = i1 << 24 >> 24 < 0;
 if (i6) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
 do if (i1 >>> 0 < i3 >>> 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEjw(i2, i3 - i1 | 0, i4) | 0; else if (i6) {
  HEAP32[(HEAP32[i2 >> 2] | 0) + (i3 << 2) >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = i3;
  break;
 } else {
  HEAP32[i2 + (i3 << 2) >> 2] = 0;
  HEAP8[i5 >> 0] = i3;
  break;
 } while (0);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i1 >> 2] | 0;
 } else i2 = i2 & 255;
 HEAP8[i5 >> 0] = i3;
 if (i2 >>> 0 > i4 >>> 0) {
  i5 = __ZNSt3__211char_traitsIcE4findEPKcjRS2_(i1 + i4 | 0, i2 - i4 | 0, i5) | 0;
  i1 = (i5 | 0) == 0 ? -1 : i5 - i1 | 0;
 } else i1 = -1;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK12ShaderErrors9HasErrorsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if (!(HEAP8[i2 + 72 >> 0] | 0)) {
   i1 = 1;
   i2 = 9;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) while (1) {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break; else i2 = i1;
  } else while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!i2) break; else i1 = i2;
  }
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 9;
   break;
  } else i2 = i1;
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function __ZN8Renderer16SetMaterialCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i1 + 300 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) {
  STACKTOP = i5;
  return;
 }
 HEAP32[i3 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i1 + 288 | 0, i2, i3, 1);
 i3 = i1 + 218 | 0;
 i2 = HEAP32[i4 >> 2] & 65535;
 i4 = HEAP16[i3 >> 1] | 0;
 HEAP16[i3 >> 1] = (i2 & 65535) < (i4 & 65535) ? i2 : i4;
 __ZN8Renderer13BoundsChangedEv(i1);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 136 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 132 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i6 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 i4 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i2 + (i4 << 2) >> 2];
 __ZN5physx2Sc17ParticleSystemSim7releaseEb(__ZNK5physx2Sc18ParticleSystemCore6getSimEv(i6) | 0, i5);
 return;
}

function __ZN4crnd10crnd_msizeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 16 | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 if (!(i1 & 7)) {
  i3 = mftCall_iii(HEAP32[gb + 43048 >> 2] | 0, i1 | 0, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i3 >> 2] = gb + 401209;
  HEAP32[i3 + 4 >> 2] = 2513;
  HEAP32[i3 + 8 >> 2] = gb + 401421;
  _sprintf(i2, gb + 401176 | 0, i3) | 0;
  _puts(i2) | 0;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i4 + 92 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) return;
 __ZN17ArchiveFileSystem14UnmountArchiveEP20ArchiveStorageReader(i2, i1) | 0;
 i2 = i4 + 108 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 if ((HEAP32[i4 + 72 >> 2] | 0) != (HEAP32[i4 + 8 >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) | 0) return;
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i4) | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN14ConstantStringD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) if (i3 >>> 0 < (gb + 388687 | 0) >>> 0 | i3 >>> 0 >= (gb + 388687 + 1052 | 0) >>> 0) {
  i4 = i3 + -8 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   __Z14CreateMemLabel18MemLabelIdentifierPv(i2, HEAP32[i3 + -4 >> 2] | 0, HEAP32[gb + 1115292 >> 2] | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
  }
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN13ConstantForce11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67048 | 0) | 0;
 if (!i2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 735462 | 0, 0, gb + 735528 | 0, 48, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 } else {
  __ZN9Rigidbody8AddForceERK8Vector3fi(i2, i1 + 36 | 0, 0);
  __ZN9Rigidbody16AddRelativeForceERK8Vector3fi(i2, i1 + 48 | 0, 0);
  __ZN9Rigidbody9AddTorqueERK8Vector3fi(i2, i1 + 60 | 0, 0);
  __ZN9Rigidbody17AddRelativeTorqueERK8Vector3fi(i2, i1 + 72 | 0, 0);
  return;
 }
}

function __ZN11DynamicMesh22RemovePolygonUnorderedEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i4 = i5 + (i2 * 26 | 0) | 0;
 i5 = i5 + (((HEAP32[i3 >> 2] | 0) + -1 | 0) * 26 | 0) | 0;
 i6 = i4 + 26 | 0;
 do {
  HEAP16[i4 >> 1] = HEAP16[i5 >> 1] | 0;
  i4 = i4 + 2 | 0;
  i5 = i5 + 2 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i6 = i1 + 52 | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i5 + (i2 << 2) >> 2] = HEAP32[i5 + ((HEAP32[i6 >> 2] | 0) + -1 << 2) >> 2];
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + -1;
 return;
}

function __Z61GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorPixelPosition13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiP13Vector2fIcall(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti(i7, i1, i2, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i3) | 0, i4);
 i4 = HEAP32[i7 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 STACKTOP = i6;
 return;
}

function __Z42ParticleSystem_Set_Custom_PropMaxParticlesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem18SetMaxNumParticlesEi(i3, i2);
  return;
 }
}

function __Z40ParticleSystem_Get_Custom_PropStartSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem13GetStartSpeedEv(i2));
 return Math_fround(0.0);
}

function __Z40ParticleSystem_Get_Custom_PropStartDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem13GetStartDelayEv(i2));
 return Math_fround(0.0);
}

function __Z39ParticleSystem_Set_Custom_PropStartSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem12SetStartSizeEf(i3, f2);
  return;
 }
}

function __Z37Animator_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator11GetVelocityEv(i3, i4);
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35getPxVehicleDriveSimData_EngineDataPKN5physx21PxVehicleDriveSimDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 64 >> 2] | 0;
 _memcpy(i1 | 0, i2 | 0, i3 << 3 | 0) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 i1 = i1 + 80 | 0;
 i2 = i2 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function _UNITY_tt_glyphzone_done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i1 + 28 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 24 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 16 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 12 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 20 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function _cf2_stack_popFixed(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 392 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 + 8 | 0)) {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 161);
  i3 = 0;
  return i3 | 0;
 }
 i1 = i3 + -8 | 0;
 HEAP32[i2 >> 2] = i1;
 switch (HEAP32[i3 + -4 >> 2] | 0) {
 case 2:
  {
   i3 = HEAP32[i1 >> 2] << 16;
   return i3 | 0;
  }
 case 1:
  {
   i1 = HEAP32[i1 >> 2] | 0;
   if ((i1 | 0) < 0) {
    i3 = 0 - (8192 - i1 >> 14) | 0;
    return i3 | 0;
   } else {
    i3 = i1 + 8192 >> 14;
    return i3 | 0;
   }
  }
 default:
  {
   i3 = HEAP32[i1 >> 2] | 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EOS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i3 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i2, i3);
 i1 = i3 + 72 | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EOS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i3 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i2, i3);
 i1 = i3 + 72 | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 return;
}

function __ZNK5physx7NpActor13findConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseE(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i5 = -1;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i3) {
  i5 = -1;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAPU8[i2 + (i1 << 3) >> 0] | 0 | 0) == (i5 | 0)) if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i4 | 0)) {
   i2 = 7;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN8Animator26ParameterControlledByCurveEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  i4 = 64;
  return i4 | 0;
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = 64;
  return i4 | 0;
 }
 i4 = __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2) | 0;
 return i4 | 0;
}

function __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 20 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 do {
  i4 = i5;
  i5 = HEAP32[i5 + 24 >> 2] | 0;
  while (1) {
   i1 = HEAP32[i4 + 32 >> 2] | 0;
   if (i1 | 0) {
    i4 = i1;
    continue;
   }
   i2 = HEAP32[i4 + 28 >> 2] | 0;
   i1 = HEAP32[i4 + 36 >> 2] | 0;
   if (i2 | 0) HEAP32[i2 + 32 >> 2] = 0;
   __ZN5physx2Sc19ConstraintGroupNode19clearProjectionDataEv(i4);
   i4 = (i1 | 0) == 0 ? i2 : i1;
   if (!i4) break;
  }
 } while ((i5 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate7GUITextD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 185436 + 8;
 i3 = i1 + 36 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 48 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 HEAP32[i1 >> 2] = gb + 36280 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __ZN17ProceduralTexture19UnloadFromGfxDeviceEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 i3 = i5 + 160 | 0;
 if (!(HEAP32[i3 >> 2] & 2)) {
  STACKTOP = i4;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -3;
 HEAP32[i5 + 208 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN16BaseVideoTextureD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i1 >> 2] = gb + 175688 + 8;
 i3 = i1 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4) {
  i4 = i4 + (0 - (HEAP32[i1 + 84 >> 2] | 0) << 2) | 0;
  __ZNK6Object14GetMemoryLabelEv(i2, i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN13GfxDeviceGLES18HandleInvalidStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(__ZN11ContextGLES18HandleInvalidStateEPb(i2) | 0)) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 if (HEAP8[i2 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 920 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZN18GfxFramebufferGLES32UpdateDefaultFramebufferViewportEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0);
 i2 = 1;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN12SoundManager12DisposeSoundEPN11SoundHandle8InstanceE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 116 | 0;
 if (HEAP8[i4 >> 0] | 0) return;
 i2 = i1 + 24 | 0;
 if ((i3 | 0) != (i2 | 0)) {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = i3 + 4 | 0; else {
   i5 = i3 + 4 | 0;
   HEAP32[i1 + 4 >> 2] = HEAP32[i5 >> 2];
   HEAP32[HEAP32[i5 >> 2] >> 2] = i1;
   HEAP32[i3 >> 2] = 0;
   HEAP32[i5 >> 2] = 0;
   i1 = i5;
  }
  i5 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i5;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 }
 HEAP8[i4 >> 0] = 1;
 return;
}

function __ZN12CubemapArray19UnloadFromGfxDeviceEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!((HEAP8[i3 + 106 >> 0] | 0) == 0 | i1)) {
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 104 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 + 48 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i2 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 STACKTOP = i5;
 return;
}

function __Z38ParticleSystem_Get_Custom_PropDurationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem14GetLengthInSecEv(i2));
 return Math_fround(0.0);
}

function __Z16LightAttenuationIA4_tEvP9Texture2DPT_iiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0;
 f7 = Math_fround(__Z24LightAttenuateNormalizedf(Math_fround(Math_fround(i3 | 0) / Math_fround(i5 | 0))));
 i5 = (HEAPF32[tempDoublePtr >> 2] = f7, HEAP32[tempDoublePtr >> 2] | 0);
 i6 = i5 >>> 23 & 255;
 i6 = (i5 >>> 16 & 32768 | (HEAPU16[gb + 1477124 + (i6 << 1) >> 1] | 0) | (i5 & 8388607) >>> (HEAPU8[gb + 1546331 + i6 >> 0] | 0)) & 65535;
 HEAP16[i2 >> 1] = i6;
 HEAP16[i2 + 2 >> 1] = i6;
 HEAP16[i2 + 4 >> 1] = i6;
 HEAP16[i2 + 6 >> 1] = i6;
 return;
}

function __Z16BytesToHexStringPKvj(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i1, i4 << 1, 0);
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 if (!i4) return; else i2 = 0;
 do {
  i6 = HEAPU8[i3 + i2 >> 0] | 0;
  i5 = i2 << 1;
  HEAP8[i1 + i5 >> 0] = HEAP8[(i6 >>> 4) + (gb + 488429) >> 0] | 0;
  HEAP8[i1 + (i5 | 1) >> 0] = HEAP8[(i6 & 15) + (gb + 488429) >> 0] | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function _jpeg_mem_src(i2, i4, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0;
 if ((i4 | 0) == 0 | (i5 | 0) == 0) {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 42;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i2 | 0);
 }
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0, i2 | 0, 0, 28) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i1 + 8 >> 2] = fb + 3287;
 HEAP32[i1 + 12 >> 2] = fb + 1564;
 HEAP32[i1 + 16 >> 2] = fb + 2368;
 HEAP32[i1 + 20 >> 2] = fb + 512;
 HEAP32[i1 + 24 >> 2] = fb + 3286;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i4;
 return;
}

function _fullsize_downsample(i1, i3, i2, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 220 | 0;
 i5 = i1 + 28 | 0;
 _jcopy_sample_rows(i2, 0, i6, 0, HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0);
 i4 = HEAP32[i4 >> 2] | 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i1 = HEAP32[i3 + 28 >> 2] << 3;
 if (!((i4 | 0) > 0 & (i1 - i5 | 0) > 0)) return;
 i2 = i5 + -1 - i1 | 0;
 i2 = 2 - i5 + i1 + ((i2 | 0) > -2 ? i2 : -2) | 0;
 i1 = 0;
 do {
  i3 = (HEAP32[i6 + (i1 << 2) >> 2] | 0) + i5 | 0;
  _memset(i3 | 0, HEAP8[i3 + -1 >> 0] | 0, i2 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function _fmt_u(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 > 0 | (i2 | 0) == 0 & i3 >>> 0 > 4294967295) {
  do {
   i4 = ___uremdi3(i3 | 0, i2 | 0, 10, 0) | 0;
   getTempRet0() | 0;
   i1 = i1 + -1 | 0;
   HEAP8[i1 >> 0] = i4 | 48;
   i4 = i3;
   i3 = ___udivdi3(i3 | 0, i2 | 0, 10, 0) | 0;
   i5 = i2;
   i2 = getTempRet0() | 0;
  } while (i5 >>> 0 > 9 | (i5 | 0) == 9 & i4 >>> 0 > 4294967295);
  i2 = i3;
 } else i2 = i3;
 if (i2) while (1) {
  i1 = i1 + -1 | 0;
  HEAP8[i1 >> 0] = (i2 >>> 0) % 10 | 0 | 48;
  if (i2 >>> 0 < 10) break; else i2 = (i2 >>> 0) / 10 | 0;
 }
 return i1 | 0;
}

function __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 + -4 >> 2] = gb + 147756 + 8;
 HEAP32[i3 >> 2] = gb + 147756 + 52;
 HEAP32[i3 + 4 >> 2] = gb + 147756 + 80;
 i1 = i3 + 12 | 0;
 HEAP32[i1 >> 2] = gb + 147876 + 8;
 i2 = HEAP32[i3 + 104 >> 2] | 0;
 if (!i2) {
  __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
  return;
 }
 i3 = HEAP32[HEAP32[i3 + 96 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
 return;
}

function __ZNK5physx2Gu10ConvexMesh14getPolygonDataEjRNS_13PxHullPolygonE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAPU8[i3 + 55 >> 0] | 0) >>> 0 <= i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i3 + 56 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + (i2 * 20 | 0) >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + (i2 * 20 | 0) + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + (i2 * 20 | 0) + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + (i2 * 20 | 0) + 12 >> 2];
 HEAP16[i1 + 16 >> 1] = HEAPU8[i3 + (i2 * 20 | 0) + 18 >> 0] | 0;
 HEAP16[i1 + 18 >> 1] = HEAP16[i3 + (i2 * 20 | 0) + 16 >> 1] | 0;
 i3 = 1;
 return i3 | 0;
}

function __ZN8Material14SetOverrideTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) | 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 if (!((i4 << 24 >> 24 < 0 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0)) {
  i4 = -1;
  __ZN8Material14SetOverrideTagEii(i2, i1, i4);
  return;
 }
 i4 = __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0;
 __ZN8Material14SetOverrideTagEii(i2, i1, i4);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Sc15ArticulationSim15setIslandHandleERNS0_7BodySimEj(i5, i4, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i5 >> 2] | i1;
 i3 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i4) | 0) + 1204 >> 2] | 0) | 0;
 i1 = i4 + 188 | 0;
 if (!(i2 & 63)) {
  __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i3, i2, i5, i1);
  return;
 } else {
  __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i3, i2, i5, i1);
  return;
 }
}

function __ZN18ScriptingArguments27CheckArgumentsAgainstMethodE21ScriptingMethodIl2Cpp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i2 = i5;
 HEAP32[i2 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i2 + 4 >> 2] = i6;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 i2 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i4) | 0;
 STACKTOP = i3;
 return (i2 | 0) == (HEAP32[i1 + 192 >> 2] | 0) | 0;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 52 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 56 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 52 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 56 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13RenderTextureD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i6 = i2;
 HEAP32[i1 >> 2] = gb + 44300 + 8;
 i4 = __Z21GetUncheckedGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 424 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_117ProfileZoneClient17handleBufferFlushEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i1 + i2;
 HEAP32[i5 >> 2] = gb + 776474;
 HEAP32[i5 + 4 >> 2] = gb + 827872;
 mftCall_iiiiii(i8 | 0, i7 | 0, i3 | 0, gb + 1046975 | 0, i6 | 0, i5 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_117MemoryEventClient17handleBufferFlushEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 i7 = HEAP32[i3 + 8 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i8 = HEAP32[(HEAP32[i7 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i1 + i2;
 HEAP32[i5 >> 2] = gb + 776474;
 HEAP32[i5 + 4 >> 2] = gb + 827872;
 mftCall_iiiiii(i8 | 0, i7 | 0, i3 | 0, gb + 1046975 | 0, i6 | 0, i5 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fPKS1_EEvPT_RKT0_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 16 | 0;
 i5 = i6;
 if (!i3) {
  STACKTOP = i6;
  return;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  i3 = i3 + -1 | 0;
  __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i5, gb + 1097664 | 0);
  __Z3maxRK8Scalar4fS1_(i4, i5, i2);
  __ZN8Scalar4faSERKS_(i1, i4) | 0;
  if (!i3) break; else {
   i1 = i1 + 16 | 0;
   i2 = i2 + 16 | 0;
  }
 }
 STACKTOP = i6;
 return;
}

function __ZN12NavMeshAgent26SetAutoTraverseOffMeshLinkEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP8[i1 + 104 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent11SetAreaCostEjf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 i1 = i1 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845377 | 0, 0, gb + 841797 | 0, 815, 1, 0, 0, 0);
  return;
 }
 if (i2 >>> 0 > 31) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845464 | 0, 0, gb + 841797 | 0, 819, 1, 0, 0, 0);
  return;
 } else {
  i4 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
  __ZN7dtCrowd21updateAgentFilterCostEiif(i4, HEAP32[i1 >> 2] | 0, i2, f3);
  return;
 }
}

function __ZN12InputManager13InputEndFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 + 72 >> 2] | 0) _memset(HEAP32[i1 + 68 >> 2] | 0, 0, HEAP32[i1 + 76 >> 2] << 2 | 0) | 0;
 if (HEAP32[i1 + 92 >> 2] | 0) _memset(HEAP32[i1 + 88 >> 2] | 0, 0, HEAP32[i1 + 96 >> 2] << 2 | 0) | 0;
 i4 = i1 + 100 | 0;
 i2 = i1 + 136 | 0;
 i3 = i2 + 11 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i1 + 140 >> 2] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i3 >> 0] = 0;
  return;
 }
}

function __ZN11Rigidbody2D11SetSleepingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 if (!i2) if (HEAP32[i3 >> 2] | 0) {
  i1 = i3 + 4 | 0;
  i2 = HEAPU16[i1 >> 1] | 0;
  if (i2 & 2 | 0) return;
  HEAP16[i1 >> 1] = i2 | 2;
  HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
  return;
 }
 i2 = i3 + 4 | 0;
 HEAP16[i2 >> 1] = (HEAPU16[i2 >> 1] | 0) & 65533;
 HEAPF32[i3 + 144 >> 2] = Math_fround(0.0);
 i3 = i3 + 64 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 return;
}

function __Z43Animator_CUSTOM_GetCurrentAnimatorStateInfoP12Il2CppObjecti(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK8Animator20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i1, i5, 0, i3) | 0;
  return;
 }
}

function __Z39ParticleSystem_Get_Custom_PropStartSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem12GetStartSizeEv(i2));
 return Math_fround(0.0);
}

function __Z36MonoBehaviour_CUSTOM_InvokeRepeatingP12Il2CppObjectP12Il2CppStringff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z13InvokeDelayedR13MonoBehaviourR11ICallStringff(i2, i5, f3, f4);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _SendMessage(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i3 = __Z27FindActiveTransformWithPathPKc(i1) | 0;
 if (!i3) {
  HEAP32[i5 >> 2] = i1;
  _printf_console(gb + 363594 | 0, i5);
  STACKTOP = i6;
  return;
 }
 if (__ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(HEAP32[i3 + 28 >> 2] | 0, i2, 0) | 0) {
  STACKTOP = i6;
  return;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 _printf_console(gb + 363530 | 0, i4);
 STACKTOP = i6;
 return;
}

function _fclose(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = (HEAP32[i3 >> 2] & 1 | 0) != 0;
 if (!i4) {
  ___lock(gb + 1469464 + 28 | 0);
  i2 = HEAP32[i3 + 52 >> 2] | 0;
  i1 = i3 + 56 | 0;
  if (i2 | 0) HEAP32[i2 + 56 >> 2] = HEAP32[i1 >> 2];
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 + 52 >> 2] = i2;
  if ((HEAP32[gb + 1469464 + 24 >> 2] | 0) == (i3 | 0)) HEAP32[gb + 1469464 + 24 >> 2] = i1;
  ___unlock(gb + 1469464 + 28 | 0);
 }
 i1 = _fflush(i3) | 0;
 i1 = mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, i3 | 0) | 0 | i1;
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 if (i2 | 0) _free(i2);
 if (!i4) _free(i3);
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore13getGlobalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 28 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZNK2UI13RectTransform13GetWorldSpaceER8Vector3fR8Vector2f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
 HEAP32[i3 >> 2] = HEAP32[i1 + 128 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 132 >> 2];
 __ZNK9Transform11GetPositionEv(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN9Animation37SendTransformChangedToCachedTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP8[i1 + 41 >> 0] | 0 ? 32 : 0;
 i7 = i1 + 48 | 0;
 i3 = HEAP32[i7 >> 2] | 0;
 i4 = (HEAP32[i1 + 52 >> 2] | 0) - i3 | 0;
 i5 = i4 >> 2;
 if ((i4 | 0) <= 0) return;
 i2 = i1 + 64 | 0;
 __ZN9Transform20SendTransformChangedEi(HEAP32[i3 >> 2] | 0, HEAP32[i2 >> 2] | i6);
 if ((i4 | 0) > 4) i1 = 1; else return;
 do {
  __ZN9Transform20SendTransformChangedEi(HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] | 0, HEAP32[i2 >> 2] | i6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i5 | 0));
 return;
}

function __ZN7mecanim28CreateValueArrayConstantCopyEPKNS_18ValueArrayConstantEjRNS_6memory9AllocatorE(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, 8, 4) | 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = i3;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i3 = i3 * 12 | 0;
  i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i3 | 0, 4) | 0;
  _memcpy(i4 | 0, ((i2 | 0) == 0 ? 0 : i2 + i1 | 0) | 0, i3 | 0) | 0;
  i1 = i4;
 }
 HEAP32[i6 >> 2] = i1 | 0 ? i1 - i6 | 0 : 0;
 return i5 | 0;
}

function __ZN5physx20PxsParticleSystemSimD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 109916 + 8;
 HEAP32[i1 + 1268 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1276 >> 2] = 0;
 HEAP32[i1 + 1240 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1248 >> 2] = 0;
 HEAP32[i1 + 1212 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1220 >> 2] = 0;
 HEAP32[i1 + 1184 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1192 >> 2] = 0;
 HEAP32[i1 + 1156 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1164 >> 2] = 0;
 HEAP32[i1 + 1128 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 1136 >> 2] = 0;
 __ZN5physx17PxsFluidCollisionD2Ev(i1 + 624 | 0);
 __ZN5physx16PxsFluidDynamicsD2Ev(i1 + 80 | 0);
 return;
}

function __ZN23TransformChangeDispatch20CheckAndClearChangedE27TransformChangeSystemHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 8 | 0;
 i6 = i3 + 4 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __ZN23TransformChangeDispatch40GetAndClearChangedAsBatchedJobs_InternalE27TransformChangeSystemHandlePFvPvPK23TransformAccessReadOnlyjES1_PFvS1_E(i1, i5, fb + 515 | 0, i4, 0);
 STACKTOP = i3;
 return (HEAP32[i4 >> 2] | 0) != 0 | 0;
}

function __ZN13ComputeShader9HasKernelERKN9ShaderLab16FastPropertyNameE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, 22, 0) | 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i3 | 0;
 i4 = (i1 | 0) / 96 | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 * 96 | 0) >> 2] | 0) == (i2 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN12_GLOBAL__N_118LegacySerialStream9alignDataEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i5 = i1 + -1 | 0;
 i1 = i1 - (HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 4 >> 2] & i5) & i5;
 _memset(i2 | 0, 0, ((i1 | 0) < 64 ? i1 : 64) | 0) | 0;
 if ((i1 | 0) > 0) while (1) {
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, ((i1 | 0) < 64 ? i1 : 64) | 0);
  if ((i1 | 0) > 64) i1 = i1 + -64 | 0; else break;
 }
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent19SetStoppingDistanceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 64 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings6GetIntERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i2, i1) | 0;
 if ((i1 | 0) == (i2 + 4 | 0)) return i3 | 0;
 if (HEAP32[i1 + 48 >> 2] | 0) return i3 | 0;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 return i3 | 0;
}

function __Z47ParticleSystem_Get_Custom_PropUseAutoRandomSeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem17GetAutoRandomSeedEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z34ParticleSystem_Set_Custom_PropTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem14SetSecPositionEf(i3, f2);
  return;
 }
}

function __Z34ParticleSystem_Set_Custom_PropLoopP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem7SetLoopEb(i3, i2 << 24 >> 24 != 0);
  return;
 }
}

function __Z27Shader_CUSTOM_EnableKeywordP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = HEAP32[gb + 1166248 >> 2] | 0;
 __ZNK11ICallString6ToUTF8Ev(i3, i4);
 i4 = __ZN8keywords6CreateEPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 i1 = i1 + 4 + (i4 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = 1 << (i4 & 31) | HEAP32[i1 >> 2];
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function ___rand48_step(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 2 | 0;
 i4 = i1 + 4 | 0;
 i6 = ___muldi3((HEAPU16[i2 + 2 >> 1] | 0) << 16 | (HEAPU16[i2 >> 1] | 0) | 0, HEAPU16[i2 + 4 >> 1] | 0 | 0, (HEAPU16[i5 >> 1] | 0) << 16 | (HEAPU16[i1 >> 1] | 0) | 0, HEAPU16[i4 >> 1] | 0 | 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = _i64Add(i6 | 0, i3 | 0, HEAPU16[i2 + 6 >> 1] | 0 | 0, 0) | 0;
 i3 = getTempRet0() | 0;
 HEAP16[i1 >> 1] = i2;
 i1 = _bitshift64Lshr(i2 | 0, i3 | 0, 16) | 0;
 getTempRet0() | 0;
 HEAP16[i5 >> 1] = i1;
 HEAP16[i4 >> 1] = i3;
 setTempRet0(i3 & 65535 | 0);
 return i2 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz(i3, i4, i1, i5, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = i2;
 i2 = _uselocale(i1) | 0;
 i1 = _vsnprintf(i3, i4, i5, i7) | 0;
 if (i2 | 0) {
  __THREW__ = 0;
  invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
  i7 = __THREW__;
  __THREW__ = 0;
  if (i7 & 1) {
   i7 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i7);
  }
 }
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 12 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN4FMOD6System18getChannelsPlayingEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i3) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  HEAP32[i3 >> 2] = HEAP32[i2 + 36 >> 2];
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870217;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z59GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorStringIndex13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectRK13Vector2fIcall(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = __Z26MonoGUIContentToTempNativeP12Il2CppObject(i3) | 0;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i4 = __ZNK8GUIStyle20GetCursorStringIndexERK5RectTIfER10GUIContentRK8Vector2f(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z59Camera_CUSTOM_INTERNAL_CALL_CalculateFrustumCornersInternalP12Il2CppObjectRK5RectTIfEf21MonoOrStereoscopicEyeP11Il2CppArray(i1, i4, f5, i6, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 12) | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK6Camera27CalculateViewportRayVectorsERK5RectTIfEf21MonoOrStereoscopicEyeP8Vector3f(i3, i4, f5, i6, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z25FindAncestorComponentImplR10GameObjecti(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = i1;
 while (1) {
  i1 = HEAP32[i3 + 28 >> 2] | 0;
  i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i4) | 0;
  if (i2 | 0) {
   i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, i2) | 0;
   if (i1 | 0) {
    i2 = 6;
    break;
   }
  }
  i3 = HEAP32[i3 + 100 >> 2] | 0;
  if (!i3) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function _strcasecmp(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 L1 : do if (!(i1 << 24 >> 24)) i1 = 0; else {
  i5 = i1 & 255;
  while (1) {
   i4 = HEAP8[i2 >> 0] | 0;
   if (!(i4 << 24 >> 24)) break L1;
   if (i1 << 24 >> 24 != i4 << 24 >> 24) {
    i5 = _tolower(i5) | 0;
    if ((i5 | 0) != (_tolower(i4 & 255) | 0)) break L1;
   }
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 << 24 >> 24)) {
    i1 = 0;
    break;
   } else i5 = i1 & 255;
  }
 } while (0);
 i5 = _tolower(i1 & 255) | 0;
 return i5 - (_tolower(HEAPU8[i2 >> 0] | 0) | 0) | 0;
}

function _gethostname(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!(_uname(i3) | 0)) {
  i2 = i1 >>> 0 > 65 ? 65 : i1;
  L3 : do if (!i2) i1 = 0; else {
   i1 = 0;
   do {
    i6 = HEAP8[i3 + 65 + i1 >> 0] | 0;
    HEAP8[i4 + i1 >> 0] = i6;
    if (!(i6 << 24 >> 24)) break L3;
    i1 = i1 + 1 | 0;
   } while (i1 >>> 0 < i2 >>> 0);
  } while (0);
  if ((i1 | 0) == (i2 | 0)) {
   HEAP8[i4 + (i2 + -1) >> 0] = 0;
   i1 = 0;
  } else i1 = 0;
 } else i1 = -1;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE(i2 + -4 | 0, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZN9Texture3D19UnloadFromGfxDeviceEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!((HEAP8[i3 + 106 >> 0] | 0) == 0 | i1)) {
  STACKTOP = i5;
  return;
 }
 i1 = i3 + 104 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i6 = __Z12GetGfxDevicev() | 0;
  i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i3 + 48 >> 2];
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  mftCall_vii(i7 | 0, i6 | 0, i2 | 0);
  HEAP8[i1 >> 0] = 0;
 }
 STACKTOP = i5;
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9InputAxis9DoGravityEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var f2 = f0, f4 = f0;
 f4 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 if (!(f4 != Math_fround(0.0))) return;
 i1 = i1 + 80 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (f2 > Math_fround(0.0)) {
  f4 = Math_fround(f2 - Math_fround(f4 * f3));
  HEAPF32[i1 >> 2] = f4;
  if (!(f4 < Math_fround(0.0))) return;
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  return;
 }
 if (!(f2 < Math_fround(0.0))) return;
 f4 = Math_fround(Math_fround(f4 * f3) + f2);
 HEAPF32[i1 >> 2] = f4;
 if (!(f4 > Math_fround(0.0))) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = i6 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = i6 + 8 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i6 + 4 | 0;
  i4 = 0;
  do {
   __ZN5physx7NpScene14updateMaterialERNS_10NpMaterialE(HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2] | 0, i5);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 HEAP32[(HEAP32[i6 + 52 >> 2] | 0) + (HEAP32[i5 + 52 >> 2] << 2) >> 2] = i5;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5physx7NpScene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i3 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh(i3 + 32 | 0, i1, i2);
  STACKTOP = i4;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 547, gb + 708192 | 0, i4);
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx3Ext20DefaultCpuDispatcher6getJobEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i3 + 16 >> 2] | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 8 >> 0] | 0) {
  HEAP32[i2 >> 2] = 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i3 + 12 >> 2] | 0, i1);
  return i4 | 0;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) return i4 | 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return i4 | 0;
}

function __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1 + 300 | 0, i5, i4) | 0;
 if (!(HEAP8[i4 >> 0] | 0)) HEAP32[i1 >> 2] = i2;
 i5 = i2 + 116 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] | 1;
 STACKTOP = i3;
 return;
}

function __ZN5Unity5Joint22SetEnablePreprocessingEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 HEAP8[i1 + 89 >> 0] = i3 & 1;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, 512, i3 ^ 1 | 0);
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0) | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, +(i3 ? Math_fround(0.0) : Math_fround(9.99999993e-09)));
 return;
}

function __ZN5Unity5Cloth7CleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 228 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 31632 | 0) | 0;
  if (i1 | 0) HEAP32[i1 + 504 >> 2] = 0;
 }
 HEAP32[i3 + 240 >> 2] = 0;
 HEAP32[i3 + 244 >> 2] = 0;
 return;
}

function __ZN25MultiBlocksMemoryFileData4LockEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  HEAP32[i2 >> 2] = 0;
  return 1;
 }
 if (i4 >>> 0 > (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, i1 + 8 | 0, 0, gb + 492156 | 0, 38) | 0;
  HEAP32[i2 >> 2] = i4;
  mftCall_iiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, 0, 0, HEAP32[i3 >> 2] | 0, 0, i4 | 0) | 0;
  getTempRet0() | 0;
  return 1;
 } else {
  HEAP32[i2 >> 2] = HEAP32[HEAP32[i1 + 20 >> 2] >> 2];
  return 1;
 }
 return 0;
}

function __ZN19RenderBufferManager26CleanupRenderBufferManagerEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1158348 >> 2] | 0;
 if (!i1) {
  HEAP32[gb + 1158348 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE(i1 + 12 | 0, HEAP32[i1 + 16 >> 2] | 0);
 __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv(i1);
 __ZdlPv(i1);
 HEAP32[gb + 1158348 >> 2] = 0;
 return;
}

function __ZN16BehaviourManager6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1155120 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1155120 | 0, i1);
  i1 = gb + 1155120 | 0;
 } else i1 = 0;
 __ZN20BaseBehaviourManager12CommonUpdateI16BehaviourManagerEEvv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __ZN13GfxDeviceGLES25SetShaderPropertiesCopiedERK19ShaderPropertySheet(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP32[i2 + 44 >> 2] | 0)) return;
 i3 = i1 + 7060 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i4 = i1 + 7064 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i6 = i1 + 4492 | 0;
 HEAP32[i1 + 4504 >> 2] = 0;
 __ZNK20GpuProgramParameters23PrepareOverridingValuesERK19ShaderPropertySheetR13dynamic_arrayIhLj4EE(i5, i2, i6);
 __ZN18GlslGpuProgramGLES19ApplyGpuProgramGLESERK20GpuProgramParametersPKh(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, HEAP32[i6 >> 2] | 0);
 return;
}

function __ZN12LightsModule16DeleteLightsListER4ListI17ParticleLightNodeE(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1 + -344 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (i3 | 0) {
   i6 = i1 + 4 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
   HEAP32[HEAP32[i6 >> 2] >> 2] = i3;
   HEAP32[i1 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  }
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
  i1 = HEAP32[i5 >> 2] | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN12InputManager15ConfigureButtonEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) {
   i4 = 3;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 330) {
   i1 = 350;
   break;
  }
 }
 if ((i4 | 0) == 3) {
  HEAP32[i3 >> 2] = i1;
  return 1;
 }
 while (1) {
  if (HEAP32[i2 + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= 570) {
   i1 = 0;
   i4 = 8;
   break;
  }
 }
 if ((i4 | 0) == 8) return i1 | 0;
 HEAP32[i3 >> 2] = i1;
 i4 = 1;
 return i4 | 0;
}

function __Z40Animator_CUSTOM_GetNextAnimatorStateInfoP12Il2CppObjecti(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 if (!i4) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 if (!i1) {
  i5 = i4;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i5);
 } else {
  __ZNK8Animator20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(i1, i5, 1, i3) | 0;
  return;
 }
}

function __Z38AsyncOperation_Set_Custom_PropPriorityP12Il2CppObjecti(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((i1 | 0) < 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 497254 | 0, 0, gb + 497294 | 0, 71, 1, 0, 0, 0);
  i1 = 0;
 }
 if (i2 | 0) {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if (i2 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i1 | 0);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z34ParticleSystem_Get_Custom_PropTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return Math_fround(__ZNK14ParticleSystem14GetSecPositionEv(i2));
 return Math_fround(0.0);
}

function __Z33Gradient_Set_Custom_PropColorKeysP12Il2CppObjectP11Il2CppArray(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 176 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 i3 = __Z20ConvertColorKeyArrayP11Il2CppArrayPN8Gradient8ColorKeyE(i1, i4) | 0;
 if ((i3 | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i1, i4, i3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z10DeleteFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = __Z13GetFileSystemv() | 0;
 i5 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i3, i5, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = __ZNK10FileSystem6DeleteEPKcb(i4, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNK5physx16PxsSolverExtBody9getAngVelEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = HEAP16[i3 + 8 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 16 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 20 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 24 >> 2];
  return;
 } else {
  i4 = i1 & 65535;
  i5 = (HEAP32[i3 >> 2] | 0) + 128 | 0;
  i1 = HEAP32[i5 + (i4 << 5) + 20 >> 2] | 0;
  i3 = HEAP32[i5 + (i4 << 5) + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + (i4 << 5) + 16 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = i3;
  return;
 }
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN2UI6Canvas15SetSortingOrderEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (HEAP32[i1 + 344 >> 2] | 0) if (!(HEAP8[i1 + 375 >> 0] | 0)) {
  STACKTOP = i4;
  return;
 }
 HEAP16[i1 + 372 >> 1] = i2;
 if (__ZNK2UI6Canvas13GetRenderModeEv(i1) | 0) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = fb + 1103;
 __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i1, i2, i3);
 STACKTOP = i4;
 return;
}

function __ZN26VertexDeclarationCacheGLESD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 41128 + 8;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 20 | 0, HEAP32[i1 + 24 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 4 | 0, HEAP32[i1 + 8 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN16TimerQueriesGLES19AddActiveTimerQueryEP14TimerQueryGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 560 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i3 = i1 + 544 | 0;
 i4 = i2 + 4 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 8 | 0; else {
  i2 = i2 + 8 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZL24stbir__filter_catmullromff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 if (f1 < Math_fround(1.0)) {
  f2 = Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f1 * f1) * Math_fround(Math_fround(2.5) - Math_fround(f1 * Math_fround(1.5)))));
  return Math_fround(f2);
 }
 if (!(f1 < Math_fround(2.0))) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(2.0) - Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(Math_fround(f1 * Math_fround(.5)) + Math_fround(-2.5))) + Math_fround(4.0))));
 return Math_fround(f2);
}

function __Z6AppendRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i4 = _strlen(i3) | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i1, (i5 << 24 >> 24 < 0 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) + i4 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i3, i4) | 0;
 return;
}

function __Z46AnimatorControllerPlayable_CUSTOM_SetIntegerIDR9HPlayableii(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, i3 | 0, i5 | 0) | 0;
 if ((i1 | 0) == 1) {
  STACKTOP = i4;
  return;
 }
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1, i3);
 STACKTOP = i4;
 return;
}

function __Z39ParticleRenderer_Set_Custom_PropUvTilesP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN9Scripting11RaiseIfNullEPv(i2);
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 16) | 0;
  __ZN16ParticleRenderer11SetUVFramesEPK5RectTIfEi(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
  return;
 }
}

function __Z37GetTransformFromComponentOrGameObjectP6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = (HEAP32[i1 + 8 >> 2] | 0) >>> 21;
 if ((i3 - (HEAP32[gb + 29020 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 29020 + 28 >> 2] | 0) >>> 0) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i2) i4 = 4; else i1 = i2;
 } else i4 = 4;
 if ((i4 | 0) == 4) if ((i3 - (HEAP32[gb + 28900 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 28900 + 28 >> 2] | 0) >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 28940 | 0) | 0;
 return i4 | 0;
}

function __Z33Gradient_Set_Custom_PropAlphaKeysP12Il2CppObjectP11Il2CppArray(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 8 | 0;
 i3 = __Z20ConvertAlphaKeyArrayP11Il2CppArrayPN8Gradient8AlphaKeyE(i1, i4) | 0;
 if ((i3 | 0) == -1) {
  STACKTOP = i6;
  return;
 }
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i1, i4, i3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z30PlayerPrefs_CUSTOM_TrySetFloatP12Il2CppStringf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 i1 = (__ZN11PlayerPrefs8SetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf(i4, f2) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i1 | 0;
}

function __Z23ParameterValidityChecksRK9HPlayableb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 586734 | 0, i4);
 if (!(HEAP32[i1 >> 2] | 0)) if (i2) {
  STACKTOP = i4;
  return 1;
 } else __ZN9Scripting26RaiseArgumentNullExceptionEPKc(gb + 586850 | 0); else if (__ZNK9HPlayable7IsValidEv(i1) | 0) {
  STACKTOP = i4;
  return 1;
 } else __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 586973 | 0, i3);
 return 0;
}

function _memcpy(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) >= 4096) return _emscripten_memcpy_big(i1 | 0, i4 | 0, i2 | 0) | 0;
 i3 = i1 | 0;
 if ((i1 & 3) == (i4 & 3)) {
  while (i1 & 3) {
   if (!i2) return i3 | 0;
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
   i1 = i1 + 1 | 0;
   i4 = i4 + 1 | 0;
   i2 = i2 - 1 | 0;
  }
  while ((i2 | 0) >= 4) {
   HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
   i1 = i1 + 4 | 0;
   i4 = i4 + 4 | 0;
   i2 = i2 - 4 | 0;
  }
 }
 while ((i2 | 0) > 0) {
  HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  i1 = i1 + 1 | 0;
  i4 = i4 + 1 | 0;
  i2 = i2 - 1 | 0;
 }
 return i3 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcjj(i2, i4, i3, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i1 = i2 + (i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   break;
  }
  i1 = i1 + -1 | 0;
  if (!(__ZNSt3__211char_traitsIcE4findEPKcjRS2_(i4, i5, i1) | 0)) {
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) i1 = i1 - i2 | 0;
 return i1 | 0;
}

function __ZNK5physx21PxsBodyTransformVault17isInVaultInternalERKNS_11PxsBodyCoreE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3;
 i2 = i2 + ~(i2 << 15) | 0;
 i2 = (i2 >>> 10 ^ i2) * 9 | 0;
 i2 = i2 >>> 6 ^ i2;
 i2 = i2 + ~(i2 << 11) | 0;
 i1 = HEAP32[i1 + (((i2 >>> 16 ^ i2) & 1023) << 2) >> 2] | 0;
 if (i1 | 0) {
  while (1) {
   i2 = i1;
   i1 = HEAP32[i1 + 32 >> 2] | 0;
   i2 = (HEAP32[i2 + 28 >> 2] | 0) == (i3 | 0);
   if (!i1) break;
   if (i2) {
    i1 = 1;
    i4 = 6;
    break;
   }
  }
  if ((i4 | 0) == 6) return i1 | 0;
  if (i2) {
   i4 = 1;
   return i4 | 0;
  }
 }
 i4 = 0;
 return i4 | 0;
}

function __ZNK17GenericDynamicVBO15GetAllocateSizeEPK9GfxBufferj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 switch (HEAP32[i1 + 32 >> 2] | 0) {
 case 4:
  {
   i4 = 2;
   break;
  }
 case 1:
  return ((HEAP32[i2 + 24 >> 2] | 0) == (i3 | 0) ? 0 : i3) | 0;
 default:
  {}
 }
 if ((i4 | 0) == 2) if ((HEAP32[i2 + 24 >> 2] | 0) != (i3 | 0)) {
  i4 = i3;
  return i4 | 0;
 }
 if ((HEAP32[i2 + 24 >> 2] | 0) >>> 0 >= i3 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i3 + -1 | 0;
 i4 = i4 >>> 16 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = (i4 >>> 1 | i4) + 1 | 0;
 return i4 | 0;
}

function __ZNK13b2DynamicTree13GetMaxBalanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  if ((HEAP32[i3 + (i2 * 36 | 0) + 32 >> 2] | 0) >= 2) {
   i5 = (HEAP32[i3 + ((HEAP32[i3 + (i2 * 36 | 0) + 28 >> 2] | 0) * 36 | 0) + 32 >> 2] | 0) - (HEAP32[i3 + ((HEAP32[i3 + (i2 * 36 | 0) + 24 >> 2] | 0) * 36 | 0) + 32 >> 2] | 0) | 0;
   i5 = (i5 | 0) > 0 ? i5 : 0 - i5 | 0;
   i1 = (i1 | 0) > (i5 | 0) ? i1 : i5;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 return i1 | 0;
}

function __ZNK12HandlerChain12LastModifiedERK13FileEntryData(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 L1 : do if ((i2 | 0) != (HEAP32[i3 >> 2] | 0)) {
  i1 = i2;
  while (1) {
   i1 = i1 + -4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i5 | 0) | 0) break;
   if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) break L1;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i3 | 0, i5 | 0);
  return;
 } while (0);
 __ZN8DateTimeC2Ev(i4);
 return;
}

function __ZN7Cubemap23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZN9Texture2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = HEAP32[i1 + 152 >> 2] | 0;
 i5 = HEAP32[i1 + 156 >> 2] | 0;
 if ((i3 | 0) == (i5 | 0)) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 i1 = i3;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImplD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 147700 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 147732 + 8;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
  STACKTOP = i4;
  return;
 }
 i5 = HEAP32[HEAP32[i3 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImplD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 147756 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i3 + 8 >> 2] = gb + 147756 + 80;
 i1 = i3 + 16 | 0;
 HEAP32[i1 >> 2] = gb + 147876 + 8;
 i2 = HEAP32[i3 + 108 >> 2] | 0;
 if (!i2) {
  __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
  return;
 }
 i3 = HEAP32[HEAP32[i3 + 100 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
 return;
}

function __ZN5physx3Ext15CpuWorkerThread9giveUpJobEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = __ZN5physx6shdfnd9SListImpl3popEv(HEAP32[i3 + 20 >> 2] | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 8 >> 0] | 0) {
  HEAP32[i2 >> 2] = 0;
  __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(HEAP32[i3 + 12 >> 2] | 0, i1);
  return i4 | 0;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i1) return i4 | 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return i4 | 0;
}

function __ZN5physx2Gu11HeightField12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP16[i3 + 6 >> 1] = 2;
 HEAP32[i3 >> 2] = gb + 107148 + 8;
 i4 = i3 + 8 | 0;
 HEAP32[i4 >> 2] = gb + 93676 + 8;
 HEAP32[i3 + 12 >> 2] = 1;
 HEAP32[i3 >> 2] = gb + 107232 + 8;
 HEAP32[i4 >> 2] = gb + 107232 + 104;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 116;
 i1 = i2 + 4 | 0;
 i2 = (HEAP32[i1 >> 2] | 0) + 15 & -16;
 HEAP32[i1 >> 2] = i2 + (Math_imul(HEAP32[i3 + 16 >> 2] << 2, HEAP32[i3 + 20 >> 2] | 0) | 0);
 HEAP32[i3 + 36 >> 2] = i2;
 return i3 | 0;
}

function __ZN5physx2Cm8PtrTable7reallocEjjRNS0_22PtrTableStorageManagerE(i5, i3, i1, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i5 + 6 | 0;
 if (HEAP8[i2 >> 0] | 0) if (mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, i1 | 0) | 0) return;
 i1 = mftCall_iii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 << 2 | 0) | 0;
 _memcpy(i1 | 0, HEAP32[i5 >> 2] | 0, HEAPU16[i5 + 4 >> 1] << 2 | 0) | 0;
 if (HEAP8[i2 >> 0] | 0) mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i5 >> 2] | 0, i3 << 2 | 0);
 HEAP32[i5 >> 2] = i1;
 HEAP8[i2 >> 0] = 1;
 return;
}

function __ZN5physx16NpParticleSystemC2Ejb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 2;
 HEAP16[i3 + 4 >> 1] = 11;
 HEAP16[i3 + 6 >> 1] = 3;
 i6 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 96876 + 8;
 __ZN5physx7NpActorC2EPKc(i3 + 12 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 97124 + 8;
 __ZN5physx3Scb14ParticleSystemC2ERKNS_11PxActorType4EnumEjb(i3 + 20 | 0, i5, i1, i2);
 HEAP32[i3 >> 2] = gb + 97380 + 8;
 STACKTOP = i4;
 return;
}

function __ZN5Unity14CharacterJoint21SetProjectionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(3402823469999999843913219.0e14);
 f1 = i4 ? Math_fround(3402823469999999843913219.0e14) : f1;
 i4 = i2 + 176 | 0;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f1;
 i2 = i2 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i4 >> 2]));
 return;
}

function __ZN5Umbra15CameraTransform17setUserClipPlanesEPKNS_7Vector4Ei(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 if ((i4 | 0) > 0) i2 = 0; else {
  i3 = i1 + 332 | 0;
  HEAP32[i3 >> 2] = i4;
  return;
 }
 do {
  i5 = i1 + 64 + (i2 << 4) | 0;
  i6 = i3 + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 i6 = i1 + 332 | 0;
 HEAP32[i6 >> 2] = i4;
 return;
}

function __ZN4FMOD7SystemI9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi(i2 + 220 | 0, -1) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 37;
  HEAP32[i3 + 4 >> 2] = gb + 860448;
  _printf(gb + 853277 | 0, i3) | 0;
  i5 = 37;
  STACKTOP = i4;
  return i5 | 0;
 }
 if (!i5) {
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i1 + 20 >> 2];
 i5 = 0;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN18MultiFrameGUIState15AddNamedControlERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiPN5IMGUI9GUIWindowE(i1, i4, i5, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i6 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = __Znwj(12) | 0;
  i6 = i2 + 4 | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i6 + 4 >> 2] = 0;
  HEAP32[i2 >> 2] = i2 + 4;
  HEAP32[i1 >> 2] = i2;
 }
 if (!i3) i1 = -1; else i1 = HEAP32[i3 >> 2] | 0;
 __ZN5IMGUI19NamedKeyControlList15AddNamedControlERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEii(i2, i4, i5, i1);
 return;
}

function __ZN16PlayerConnection22InitializeListenSocketER12ServerSocketRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i2 + 11 | 0;
 HEAP32[i6 >> 2] = (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 HEAP32[i6 + 4 >> 2] = i3;
 _printf_console(gb + 459885 | 0, i6);
 __ZN12ServerSocket14StartListeningEPKctb(i1, (HEAP8[i5 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i3 & 65535, 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN13OcclusionAreaC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN6ObjectC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 34748 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent15SetAngularSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 52 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent15SetAccelerationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 60 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN10FileSystem23UnmountMemoryFileSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 40 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i5;
 if (i5 | 0) return;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = i1 + 28 | 0;
 i2 = i3 + (HEAP32[i4 >> 2] << 2) | 0;
 i1 = i3;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i6 = 6;
   break;
  }
  i3 = i1 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break; else i1 = i3;
 }
 if ((i6 | 0) == 6) return;
 _memmove(i1 | 0, i3 | 0, i2 - i3 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 return;
}

function __ZL40InitializeParticleSystemScriptingClassesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63728 | 0, 16, gb + 622695 | 0, 16) | 0;
 HEAP32[gb + 1452344 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049809 | 0) | 0;
 HEAP32[HEAP32[gb + 1452344 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 622826 | 0) | 0;
 HEAP32[(HEAP32[gb + 1452344 >> 2] | 0) + 4 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049818 | 0) | 0;
 HEAP32[(HEAP32[gb + 1452344 >> 2] | 0) + 8 >> 2] = i1;
 return;
}

function __Z47AudioMixer_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   HEAP32[i3 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   __ZN10AudioMixer24SetOutputAudioMixerGroupERK4PPtrI15AudioMixerGroupE(i4, i3);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ParticleSystem_Set_Custom_PropRandomSeedP12Il2CppObjectj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem13SetRandomSeedEj(i3, i2);
  return;
 }
}

function __Z38Material_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z38Material_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialMatrixArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z34Material_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z34Material_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialMatrixArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z26Input_CUSTOM_GetButtonDownP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = (__ZN12InputManager13GetButtonDownERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z15GetInputManagerv() | 0, i3) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z25ScriptingStringToPropertyR11ICallString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 12 | 0;
 i3 = i4;
 if (__ZNK11ICallString6IsNullEv(i1) | 0) {
  i3 = -1;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZNK11ICallString6ToUTF8Ev(i3, i1);
 HEAP32[i2 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i2, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3);
 i2 = HEAP32[i2 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 i3 = i2;
 STACKTOP = i4;
 return i3 | 0;
}

function _catanhf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 f4 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i7 >> 2] = f4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _catanf(i5, i6);
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(-f4);
 HEAP32[i1 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function _casinhf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 f4 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i7 >> 2] = f4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _casinf(i5, i6);
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(-f4);
 HEAP32[i1 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZNK12NavMeshAgent18GetDesiredVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 } else {
  i4 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0) | 0;
  i3 = HEAP32[i4 + 532 >> 2] | 0;
  i2 = HEAP32[i4 + 536 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 + 528 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i1 + 8 >> 2] = i2;
  return;
 }
}

function __ZN5simdi8anyEqualERK8Scalar4fS2_RS0_(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4;
 i7 = (HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0);
 i6 = (HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0);
 i5 = (HEAP32[i2 + 8 >> 2] | 0) == (HEAP32[i3 + 8 >> 2] | 0);
 i3 = (HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i3 + 12 >> 2] | 0);
 __ZN8Scalar4fC2Ebbbb(i8, i7, i6, i5, i3);
 __ZN8Scalar4faSERKS_(i1, i8) | 0;
 STACKTOP = i4;
 return (i7 | i6 | (i5 | i3)) & 1 | 0;
}

function __ZN5physx3Ext20DefaultCpuDispatcher7runTaskERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i2 + 33 >> 0] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  return;
 } else {
  i2 = __ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0;
  i3 = i1 + 8 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0);
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i3 = HEAP32[i3 >> 2] | 0;
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 108 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
  return;
 }
}

function __ZN5physx2Sc9ClothCore23removeCollisionTriangleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 196 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 + 1 | 0);
 i2 = i2 + 88 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 STACKTOP = i3;
 return;
}

function __ZN5physx15NpParticleFluidC2Ejb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 3;
 HEAP16[i3 + 4 >> 1] = 12;
 HEAP16[i3 + 6 >> 1] = 3;
 i6 = i3 + 8 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 95632 + 8;
 __ZN5physx7NpActorC2EPKc(i3 + 12 | 0, 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 95912 + 8;
 __ZN5physx3Scb14ParticleSystemC2ERKNS_11PxActorType4EnumEjb(i3 + 20 | 0, i5, i1, i2);
 HEAP32[i3 >> 2] = gb + 96200 + 8;
 STACKTOP = i4;
 return;
}

function __ZN4FMOD7SystemI15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi(i2 + 220 | 0, -1) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 37;
  HEAP32[i3 + 4 >> 2] = gb + 853261;
  _printf(gb + 853277 | 0, i3) | 0;
  i5 = 37;
  STACKTOP = i4;
  return i5 | 0;
 }
 if (!i5) {
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = HEAP32[i1 + 20 >> 2];
 i5 = 0;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN27ForceModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 876 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 876 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 876 >> 2] | 0) + 616 >> 2]);
   break;
  }
 case 3:
  {
   f1 = Math_fround((HEAP8[(HEAP32[i3 + 876 >> 2] | 0) + 801 >> 0] | 0) != 0 & 1);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN24RingBufferMemoryFileData16GetNewWriteBlockEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[(HEAP32[i3 + 76 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = i2;
  return i3 | 0;
 }
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i3 + 97 >> 0] | 0)) if (i2 >>> 0 >= (HEAP32[i3 + 24 >> 2] | 0) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i1 >> 2] = i2 + 1;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 + 20 >> 2] | 0, 16, i3 + 8 | 0, 0, gb + 492374 | 0, 113) | 0;
 return i3 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags(i7, i3, i1, i2) {
 i7 = i7 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 i2 = i7 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i7 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i2 >> 2] = i4;
  STACKTOP = i6;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i5, 4);
  STACKTOP = i6;
  return;
 }
}

function __ZN19CollisionListener2DD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i2 >> 2] = gb + 154588 + 8;
 i1 = i2 + 204 | 0;
 if ((HEAP32[i2 + 220 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 208 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i2 + 176 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i2 = HEAP32[i2 + 200 >> 2] | 0;
 HEAP32[i3 >> 2] = 65;
 HEAP32[i3 + 4 >> 2] = i2;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN10MonoScript18CleanupScriptCacheEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63728 | 0);
 } else {
  i3 = __Z19GetScriptingManagerv() | 0;
  __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i3, HEAP32[i2 + 32 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10Collider2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 48 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = f3 < Math_fround(0.0);
 i5 = f3 > Math_fround(1.0e6);
 f3 = i5 ? Math_fround(1.0e6) : f3;
 HEAPF32[i2 >> 2] = i4 ? Math_fround(0.0) : f3;
 i2 = i1 + 40 | 0;
 if ((HEAP32[i2 >> 2] & 2139095040 | 0) != 2139095040 ? (HEAP32[i1 + 44 >> 2] & 2139095040 | 0) != 2139095040 : 0) return;
 i1 = gb + 1162356 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i5 + 4 >> 2] = i4;
 return;
}

function __Z37Material_CUSTOM_SetColorArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z34Graphics_CUSTOM_CopyTexture_RegionP12Il2CppObjectiiiiiiS0_iiii(i1, i4, i7, i8, i9, i10, i11, i3, i12, i13, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __Z11CopyTextureP7TextureiiiiiiS0_iiii(i2, i4, i7, i8, i9, i10, i11, i1, i12, i13, i5, i6) | 0;
 return;
}

function __Z33Material_CUSTOM_SetColorArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function _UNITY_FT_Get_CMap_Format(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) i1 = -1; else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = -1; else {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
   if (!i2) i1 = -1; else {
    i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008121 | 0) | 0;
    if (!i1) i1 = -1; else if (!(mftCall_iii(HEAP32[i1 >> 2] | 0, i3 | 0, i4 | 0) | 0)) i1 = HEAP32[i4 + 4 >> 2] | 0; else i1 = -1;
   }
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function _fchdir(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6 + 40 | 0;
 i3 = i6 + 8 | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = i1;
 i2 = ___syscall133(133, i2 | 0) | 0;
 if ((i2 | 0) == -9) {
  HEAP32[i3 >> 2] = i1;
  HEAP32[i3 + 4 >> 2] = 1;
  if ((___syscall221(221, i3 | 0) | 0) < 0) i5 = 3; else {
   ___procfdname(i3, i1);
   HEAP32[i4 >> 2] = i3;
   i1 = ___syscall_ret(___syscall12(12, i4 | 0) | 0) | 0;
  }
 } else i5 = 3;
 if ((i5 | 0) == 3) i1 = ___syscall_ret(i2) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryERNS_10PxMaterialENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i1, i3, i2, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i6 = i1 + 4 | 0;
 i8 = HEAP8[i5 >> 0] | 0;
 HEAP32[i7 >> 2] = i4;
 i5 = HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0;
 HEAP8[i6 >> 0] = i8;
 i5 = mftCall_iiiiii(i5 | 0, i3 | 0, i2 | 0, i7 | 0, 1, i6 | 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __ZN9JSONWrite13StartSequenceEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev(i2);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 4;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) >>> 0 >= i3 >>> 0) return;
 HEAP32[i1 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 >> 2] | 0, i3 * 24 | 0, 16, gb + 64016 | 0, 0, gb + 1034933 | 0, 19) | 0;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN8combiner31DecodeTextureCombinerDescriptorEjRNS_9OperationEPNS_6SourceEPNS_7OperandERi(i1, i5, i6, i7, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 >>> 8;
 HEAP32[i6 >> 2] = i1 >>> 16 & 3;
 HEAP32[i7 >> 2] = i1 >>> 18 & 63;
 HEAP32[i6 + 4 >> 2] = i1 & 3;
 HEAP32[i7 + 4 >> 2] = i1 >>> 2 & 63;
 HEAP32[i2 >> 2] = i1 >>> 24;
 if (!(i4 & 128)) {
  i2 = 0;
  i3 = 0;
  i1 = i4 & 255;
 } else {
  i2 = i1 >>> 10 & 6 | 1;
  i3 = i4 & 3;
  i1 = (i4 & 96 | 0) == 0 ? 5 : 8;
 }
 HEAP32[i5 >> 2] = i1;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i2;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx9readFloatEbRNS_13PxInputStreamE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 4) | 0;
 if (!i2) {
  f5 = Math_fround(HEAPF32[i1 >> 2]);
  STACKTOP = i4;
  return Math_fround(f5);
 }
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = i3 >>> 24;
 HEAP8[i1 + 3 >> 0] = i3;
 HEAP8[i1 + 1 >> 0] = i3 >>> 16;
 HEAP8[i1 + 2 >> 0] = (i3 & 65535) >>> 8;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 STACKTOP = i4;
 return Math_fround(f5);
}

function __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE6resizeEjRKj(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx5cloth9SwFactory5cloneERKNS0_5ClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0) + 4 >> 2] | 0)) {
  i4 = __ZN5physx5cloth8allocateEj(560) | 0;
  i3 = i4 + 4 | 0;
  HEAP32[i4 >> 2] = gb + 167452 + 8;
  HEAP32[i3 >> 2] = gb + 167452 + 424;
  __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERKS1_(i4 + 16 | 0, i2 + 4 + -4 | 0, i1 + 12 | 0);
  i2 = (i4 | 0) == 0 ? 0 : i3;
  return i2 | 0;
 } else {
  i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 4 | 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx2Sc9ClothCore22removeCollisionCapsuleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 172 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 + 1 | 0);
 i2 = i2 + 76 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 STACKTOP = i3;
 return;
}

function __ZN5physx16writeBack1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i5, i4, i1, i2, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i5 >>> 0 > 1) {
  i1 = 1;
  do {
   __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i6 + (i1 + -1 << 5) | 0, 0, 0, 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_(i6 + (i5 + -1 << 5) | 0, 0, 0, 0);
 return;
}

function __ZN4File4ReadEyPvj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = i7;
 HEAP32[i8 >> 2] = 0;
 HEAP32[i8 + 4 >> 2] = 0;
 __ZN12FileAccessor4ReadEyyPvPy(HEAP32[i1 + 4 >> 2] | 0, i2, i3, i5, 0, i4, i7) | 0;
 i4 = i7;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = _i64Add(i5 | 0, HEAP32[i4 + 4 >> 2] | 0, i2 | 0, i3 | 0) | 0;
 i3 = getTempRet0() | 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD3DSP6removeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[(HEAP32[i2 + 260 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (i2 | 0) if (!(HEAP8[i2 + 16 >> 0] | 0)) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
   i3 = 0;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 855526;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN20NavMeshBuildSettingsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 4 | 0;
 i3 = i1;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i2 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 8 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(45.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(2.0);
 HEAP8[i1 + 32 >> 0] = 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(.166666672);
 HEAP8[i1 + 40 >> 0] = 0;
 return;
}

function __ZN10MonoScript17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63728 | 0);
 } else {
  i3 = __Z19GetScriptingManagerv() | 0;
  __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i3, HEAP32[i2 + 32 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z53ComputeBuffer_CUSTOM_INTERNAL_CALL_GetNativeBufferPtrP12Il2CppObjectRPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 728 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 >> 2] = mftCall_iii(i7 | 0, i6 | 0, i2 | 0) | 0;
 STACKTOP = i5;
 return;
}

function __Z37Material_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z21SetMaterialFloatArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z34Mesh_CUSTOM_SetArrayForChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __Z35SetMeshComponentFromArrayFromScriptR4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi(i7, i2, i3, i4, i5, i6);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Material_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z21SetMaterialFloatArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z22Object_CUSTOM_ToStringP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __Z19UnityObjectToStringP6Object(i2, i1);
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i1 << 24 >> 24 < 0;
 i1 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i1 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i3;
 return i1 | 0;
}

function _ctanf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 f4 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i7 >> 2] = f4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _ctanhf(i5, i6);
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(-f4);
 HEAP32[i1 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function _csinf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 16 | 0;
 i5 = i3 + 8 | 0;
 i7 = i3;
 f4 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i7 >> 2] = f4;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 _csinhf(i5, i6);
 f4 = Math_fround(HEAPF32[i5 >> 2]);
 f4 = Math_fround(-f4);
 HEAP32[i1 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAPF32[i1 + 4 >> 2] = f4;
 STACKTOP = i3;
 return;
}

function __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = gb + 77508 + 12;
 i1 = i2 + 56 | 0;
 HEAP32[i1 >> 2] = gb + 77508 + 32;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 36 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i2, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i1);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf(i4, f3) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 152 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == f3) {
  STACKTOP = i5;
  return;
 }
 HEAPF32[i2 >> 2] = f3;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE6resizeEjRKS4_(i4 + 244 | 0, 0, i1);
 HEAP32[i4 + 256 >> 2] = 0;
 HEAP32[i4 + 536 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZNSt3__26locale14__install_ctorERKS0_PNS0_5facetEl(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 do if (!i4) {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
 } else {
  i1 = __Znwj(160) | 0;
  __THREW__ = 0;
  invoke_viiii(fb + 362 | 0, i1 | 0, HEAP32[i3 >> 2] | 0, i4 | 0, i5 | 0);
  i5 = __THREW__;
  __THREW__ = 0;
  if (i5 & 1) {
   i5 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   __ZdlPv(i1);
   ___resumeException(i5 | 0);
  } else {
   HEAP32[i2 >> 2] = i1;
   break;
  }
 } while (0);
 __ZNSt3__214__shared_count12__add_sharedEv(i1);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__212strstreambufD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 do if (i2 | 0) if ((HEAP32[i1 + 32 >> 2] & 9 | 0) == 1) {
  i3 = HEAP32[i1 + 44 >> 2] | 0;
  if (!i3) {
   __ZdaPv(i2);
   break;
  }
  __THREW__ = 0;
  invoke_vi(i3 | 0, i2 | 0);
  i3 = __THREW__;
  __THREW__ = 0;
  if (i3 & 1) {
   i3 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
   ___clang_call_terminate(i3);
  }
 } while (0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 return;
}

function __ZN5physx2Sc9ClothCore21removeCollisionConvexEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i7 = i3;
 i5 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 188 >> 2] | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_viiii(i6 | 0, i5 | 0, i4 | 0, i1 | 0, i1 + 1 | 0);
 i2 = i2 + 84 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc16ArticulationCoreC2Ev(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = HEAP32[gb + 1457332 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 8 >> 2] = 4;
 HEAP32[i1 + 12 >> 2] = 4;
 HEAPF32[i1 + 20 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(.100000001));
 HEAP16[i1 + 16 >> 1] = 260;
 f2 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 HEAPF32[i1 + 24 >> 2] = Math_fround(f2 * Math_fround(f2 * Math_fround(.0000499999987)));
 HEAP32[i1 + 32 >> 2] = HEAP32[gb + 92912 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(f2 * Math_fround(f2 * Math_fround(4.99999987e-06)));
 return;
}

function __ZN5physx18NpArticulationLink15importExtraDataERNS_24PxDeserializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE(i4 + 20 | 0, i3);
 __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE(i4 + 12 | 0, i3);
 if (HEAP8[i4 + 316 >> 0] | 0) return;
 i2 = i4 + 320 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i4 + 328 >> 2] | 0;
 if (!(i1 & 2147483647 | HEAP32[i4 + 324 >> 2])) return;
 i3 = i3 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i4 + (i1 << 2);
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZN22VertexDeclarationCacheD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 41128 + 8;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 20 | 0, HEAP32[i1 + 24 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 4 | 0, HEAP32[i1 + 8 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN19ShaderPropertySheet11ComputeHashEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 + 96 >> 2] = 0;
  i3 = 0;
  i2 = i1 + 92 | 0;
  HEAP32[i2 >> 2] = i3;
  return;
 } else {
  i2 = __Z12MurmurHash2APKvij(HEAP32[i1 + 32 >> 2] | 0, i2 << 2, -1756908916) | 0;
  i3 = i1 + 96 | 0;
  HEAP32[i3 >> 2] = i2;
  i2 = __Z12MurmurHash2APKvij(HEAP32[i1 + 52 >> 2] | 0, HEAP32[i1 + 64 >> 2] << 2, i2) | 0;
  HEAP32[i3 >> 2] = i2;
  i2 = __Z12MurmurHash2APKvij(HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 84 >> 2] | 0, i2) | 0;
  i3 = i1 + 92 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN15ReflectionProbe17ShouldAutoRefreshEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if ((HEAP32[i3 + 40 >> 2] | 0) != 1) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i3 + 44 >> 2] | 0) != 1) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = HEAP32[gb + 1112272 >> 2] | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 7;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZN13RuntimeStaticI11WindManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(8, i3, i4, gb + 1041912 | 0, 65) | 0;
  HEAP32[i4 >> 2] = i4;
  HEAP32[i4 + 4 >> 2] = i4;
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(8, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  HEAP32[i4 >> 2] = i4;
  HEAP32[i4 + 4 >> 2] = i4;
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13ComputeBuffer15SetCounterValueEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 i5 = i2 + 12 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) {
  STACKTOP = i6;
  return;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 6)) {
  STACKTOP = i6;
  return;
 }
 i2 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 760 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 mftCall_viii(i7 | 0, i2 | 0, i1 | 0, i3 | 0);
 STACKTOP = i6;
 return;
}

function __ZN11AudioModule27IsFormatSupportedByPlatformEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i2, _strlen(i2) | 0);
 i2 = __ZN9AudioClip27IsFormatSupportedByPlatformERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z54Camera_CUSTOM_INTERNAL_get_nonJitteredProjectionMatrixP12Il2CppObjectP10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i3) | 0;
  i3 = i2 + 64 | 0;
  do {
   HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i2 | 0) < (i3 | 0));
  return;
 }
}

function __Z46UnityWebRequest_Set_Custom_PropUseHttpContinueP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if ((HEAP32[i1 + 108 >> 2] | 0) == 1) {
  HEAP8[i1 + 121 >> 0] = i2 << 24 >> 24 != 0 & 1;
  STACKTOP = i4;
  return;
 } else __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031178 | 0, i4 + 8 | 0);
}

function __Z46UnityWebRequest_Set_Custom_PropChunkedTransferP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i3);
 if ((HEAP32[i1 + 108 >> 2] | 0) == 1) {
  HEAP8[i1 + 120 >> 0] = i2 << 24 >> 24 != 0 & 1;
  STACKTOP = i4;
  return;
 } else __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 1031463 | 0, i4 + 8 | 0);
}

function __Z27ComputeShader_CUSTOM_SetIntP12Il2CppObjectii(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   HEAP32[i5 >> 2] = i3;
   __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i2, i5, 4, i4) | 0;
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _tt_cmap10_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = (HEAPU8[i3 + 13 >> 0] | 0) << 16 | (HEAPU8[i3 + 12 >> 0] | 0) << 24 | (HEAPU8[i3 + 14 >> 0] | 0) << 8 | (HEAPU8[i3 + 15 >> 0] | 0);
 if (i1 >>> 0 > i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = i2 - i1 | 0;
 if (i1 >>> 0 >= ((HEAPU8[i3 + 17 >> 0] | 0) << 16 | (HEAPU8[i3 + 16 >> 0] | 0) << 24 | (HEAPU8[i3 + 18 >> 0] | 0) << 8 | (HEAPU8[i3 + 19 >> 0] | 0)) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = i3 + 20 + (i1 << 1) | 0;
 i3 = (HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i3 + 1 >> 0] | 0);
 return i3 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_jj(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 i3 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i7 = i3 << 24 >> 24 < 0;
 i3 = i7 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i5 | 0;
  return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj(i1, i2, (i7 ? HEAP32[i4 >> 2] | 0 : i4) + (i5 << 2) | 0, i3 >>> 0 < i6 >>> 0 ? i3 : i6) | 0;
 }
 return 0;
}

function __ZN8Playable7ConnectEPS_S0_ii(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 switch (i1 | 0) {
 case 0:
 case 2:
  {
   i5 = 1;
   return i5 | 0;
  }
 default:
  {}
 }
 i5 = (i3 | 0) != 0;
 if (i5) if (!(mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0, i1 | 0, i4 | 0) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0) | 0;
 if (i1 | i5 ^ 1) {
  i5 = i1;
  return i5 | 0;
 }
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0, 0, i4 | 0) | 0;
 i5 = 0;
 return i5 | 0;
}

function __ZN8BitArray4initEj(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = ((i1 & 31 | 0) != 0 & 1) + (i1 >>> 5) | 0;
 i3 = i4 + 4 | 0;
 HEAP32[i3 >> 2] = i1;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i5 + 1 | 0, i2);
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i5, i1 << 2, gb + 717183 | 0, 392) | 0;
 HEAP32[i4 >> 2] = i2;
 _memset(i2 | 0, 0, HEAP32[i3 >> 2] << 2 | 0) | 0;
 STACKTOP = i5;
 return 1;
}

function __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 833719;
 HEAP32[i1 + 4 >> 2] = 553;
 HEAP32[i1 + 8 >> 2] = fb + 625;
 HEAP32[i1 + 12 >> 2] = fb + 540;
 HEAP32[i1 + 16 >> 2] = gb + 833729;
 HEAP32[i1 + 20 >> 2] = 554;
 HEAP32[i1 + 24 >> 2] = fb + 626;
 HEAP32[i1 + 28 >> 2] = fb + 541;
 HEAP32[i1 + 32 >> 2] = gb + 833741;
 HEAP32[i1 + 36 >> 2] = 555;
 HEAP32[i1 + 40 >> 2] = fb + 627;
 HEAP32[i1 + 44 >> 2] = fb + 542;
 HEAP32[i1 + 48 >> 2] = gb + 833752;
 HEAP32[i1 + 52 >> 2] = 556;
 HEAP32[i1 + 56 >> 2] = fb + 628;
 HEAP32[i1 + 60 >> 2] = fb + 543;
 return;
}

function __ZN25ThreadsafeLinearAllocatorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 27156 + 8;
 i3 = i2 + 40 | 0;
 i4 = i2 + 32 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i5 = i2 + 48 | 0;
  i1 = 0;
  do {
   __Z16GetMemoryManagerv() | 0;
   __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 * 12 | 0) >> 2] | 0, HEAP32[i5 >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 HEAP32[i3 >> 2] = 0;
 __Z16GetMemoryManagerv() | 0;
 __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i4 >> 2] | 0, (HEAP32[i2 + 52 >> 2] | 0) * 12 | 0);
 return;
}

function __ZN12NavMeshAgent20SetAvoidancePriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i1 + 100 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __Z24Input_CUSTOM_GetButtonUpP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = (__ZN12InputManager11GetButtonUpERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z15GetInputManagerv() | 0, i3) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function _UNITY_ft_glyphslot_alloc_bitmap(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i7;
 i6 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 100 >> 2] | 0;
 i3 = (HEAP32[i1 + 156 >> 2] | 0) + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!(i2 & 1)) {
  HEAP32[i3 >> 2] = i2 | 1;
  i1 = i1 + 88 | 0;
 } else {
  i1 = i1 + 88 | 0;
  _UNITY_ft_mem_free(i6, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = _UNITY_ft_mem_alloc(i6, i4, i5) | 0;
 STACKTOP = i7;
 return HEAP32[i5 >> 2] | 0;
}

function __ZThn32_N8Renderer23RendererBecameInvisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = i1 + -32 | 0;
 i4 = i1 + 268 | 0;
 i5 = (HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105316 | 0, i3);
 __ZN6Object11InvokeEventEi(i1, 1);
 STACKTOP = i2;
 return;
}

function __ZNK13RenderTexture20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0) == 3) {
  i1 = HEAP32[i1 + 92 >> 2] | 0;
  return i1 | 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0) == 5) {
  i1 = HEAP32[i1 + 92 >> 2] | 0;
  return i1 | 0;
 }
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0) == 6) {
  i1 = HEAP32[i1 + 92 >> 2] | 0;
  return i1 | 0;
 } else {
  i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0) == 4;
  i1 = i1 ? 6 : 1;
  return i1 | 0;
 }
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingItyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingItxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx7NpScene19getActiveTransformsERjh(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i3 + 2448 >> 0] | 0)) {
  i3 = __ZN5physx2Sc5Scene19getActiveTransformsERjh(i3 + 32 | 0, i2, i1) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 778, gb + 708816 | 0, i4);
  HEAP32[i2 >> 2] = 0;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834127;
 HEAP32[i1 + 4 >> 2] = 663;
 HEAP32[i1 + 8 >> 2] = fb + 3940;
 HEAP32[i1 + 12 >> 2] = fb + 3941;
 HEAP32[i1 + 16 >> 2] = gb + 834138;
 HEAP32[i1 + 20 >> 2] = 664;
 HEAP32[i1 + 24 >> 2] = fb + 3942;
 HEAP32[i1 + 28 >> 2] = fb + 3943;
 HEAP32[i1 + 32 >> 2] = gb + 834148;
 HEAP32[i1 + 36 >> 2] = 665;
 HEAP32[i1 + 40 >> 2] = fb + 3944;
 HEAP32[i1 + 44 >> 2] = fb + 3945;
 HEAP32[i1 + 48 >> 2] = gb + 834159;
 HEAP32[i1 + 52 >> 2] = 666;
 HEAP32[i1 + 56 >> 2] = fb + 3946;
 HEAP32[i1 + 60 >> 2] = fb + 3947;
 return;
}

function __ZN5physx2Sn13XmlNodeReader19setCurrentItemValueEPKc(i6, i5) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 if (!i5) i1 = gb + 1576256 | 0; else if (!(HEAP8[i5 >> 0] | 0)) i1 = gb + 1576256 | 0; else {
  i2 = i5;
  i1 = 0;
  while (1) {
   i3 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
   if (!(HEAP8[i2 >> 0] | 0)) {
    i2 = i3;
    break;
   } else i1 = i3;
  }
  i1 = __ZN5physx19CVariableMemoryPool8allocateEj(i4 + 4 | 0, i1 + 2 | 0) | 0;
  _memcpy(i1 | 0, i5 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 HEAP32[(HEAP32[i6 + 12 >> 2] | 0) + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sc10NPhaseCore33releaseActorPairContactReportDataEPNS0_26ActorPairContactReportDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = i2 + 1608 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = i2 + 1620 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i1;
 i1 = i2 + 1612 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 1;
 if ((i3 | 0) < ((HEAP32[i2 + 1604 >> 2] | 0) * 50 | 0)) return;
 __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv(i2 + 1328 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx18PxVehicleGraphDescC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 12 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 16 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 20 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 24 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 28 >> 2] = Math_fround(3402823469999999843913219.0e14);
 return;
}

function __ZN21LightProbeProxyVolume17RemoveFromManagerEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[gb + 1110944 >> 2] | 0;
 HEAP16[i2 + 152 >> 1] = -1;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i4 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i6 = i3 + (i5 << 2) | 0;
 i1 = i3;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i6 | 0)) {
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return;
 i7 = i5 + -1 | 0;
 i6 = i3 + (i7 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i6 >> 2] = i2;
 HEAP32[i4 >> 2] = i7;
 return;
}

function __ZN15ConstantForce2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN24PhysicsUpdateBehaviour2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 154620 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12SkinMeshInfo8AllocateEiib(i1, i7, i2) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = (i1 | 0) == 0 & i2 ? 1 : i1;
 i5 = i4 << 6;
 i6 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci((i7 << 2) + 128 + i5 | 0, 64, gb + 64024 | 0, 0, gb + 428921 | 0, 170) | 0;
 i1 = i6 + 92 | 0;
 i2 = i6;
 i3 = i2 + 128 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 >> 0] = 1;
 i1 = i6 + 128 | 0;
 if (i4) {
  HEAP32[i6 + 68 >> 2] = i1;
  i1 = i1 + i5 | 0;
 }
 if (!i7) return i6 | 0;
 HEAP32[i6 + 72 >> 2] = i1;
 return i6 | 0;
}

function __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = 128;
 i4 = i5 + 8 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i2);
 i2 = __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue(i1, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN11DynamicMesh13CreatePolygonERK13dynamic_arrayI8Vector3fLj4EEj(i5, i1, i6, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i7 = 0;
 i7 = HEAP32[i6 + 12 >> 2] | 0;
 i3 = i5;
 i4 = i3 + 26 | 0;
 do {
  HEAP16[i3 >> 1] = 0;
  i3 = i3 + 2 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP8[i5 + 24 >> 0] = i7;
 HEAP8[i5 + 25 >> 0] = i2;
 if (!i7) return;
 i2 = i1 + 60 | 0;
 i1 = 0;
 do {
  HEAP16[i5 + 12 + (i1 << 1) >> 1] = __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f(i2, (HEAP32[i6 >> 2] | 0) + (i1 * 12 | 0) | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i7 | 0));
 return;
}

function __ZN10SampleClipD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 170392 + 8;
 i3 = i1 + 72 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 84 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 __ZN11SoundHandleD2Ev(i1 + 56 | 0);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __Z51AudioLowPassFilter_Get_Custom_PropCustomCutoffCurveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = __ZNK18AudioLowPassFilter30GetCustomLowpassLevelCurveCopyEv(i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 8 >> 2] | 0) | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return i2 | 0;
}

function __Z41ParticleSystem_Get_Custom_PropPlayOnAwakeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem14GetPlayOnAwakeEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z14ExtractAddressP8sockaddrjPciPi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = i8 + 4 | 0;
 i1 = _getnameinfo(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0, 20, 3) | 0;
 if (!i1) {
  i7 = _atoi(i6) | 0;
  HEAP32[i5 >> 2] = i7;
  STACKTOP = i8;
  return;
 }
 HEAP32[i7 >> 2] = _gai_strerror(i1 | 0) | 0;
 _printf_console(gb + 459141 | 0, i7);
 HEAP32[i5 >> 2] = -1;
 i7 = _atoi(i6) | 0;
 HEAP32[i5 >> 2] = i7;
 STACKTOP = i8;
 return;
}

function _UNITY_FT_Get_CMap_Language_ID(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i3) i1 = 0; else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
   if (!i2) i1 = 0; else {
    i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008121 | 0) | 0;
    if (!i1) i1 = 0; else if (!(mftCall_iii(HEAP32[i1 >> 2] | 0, i3 | 0, i4 | 0) | 0)) i1 = HEAP32[i4 >> 2] | 0; else i1 = 0;
   }
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function _Direct_Move_Orig(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = HEAP16[i2 + 298 >> 1] | 0;
 if (i1 << 16 >> 16) {
  i6 = _UNITY_FT_MulDiv(i5, i1 << 16 >> 16, HEAP32[i2 + 564 >> 2] | 0) | 0;
  i1 = (HEAP32[i3 + 12 >> 2] | 0) + ((i4 & 65535) << 3) | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i6;
 }
 i1 = HEAP16[i2 + 300 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i5 = _UNITY_FT_MulDiv(i5, i1 << 16 >> 16, HEAP32[i2 + 564 >> 2] | 0) | 0;
 i6 = (HEAP32[i3 + 12 >> 2] | 0) + ((i4 & 65535) << 3) + 4 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i5;
 return;
}

function mftCall_viiiiiiiiiiii(i13, i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3, i4) {
 i13 = i13 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i13 | 0) >= (fb | 0) & (i13 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiiiiiiiiiii[i13 - fb & 3](i1 | 0, i2 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i3 | 0, i4 | 0);
  return;
 }
 ftCall_viiiiiiiiiiii(i13 | 0, i1 | 0, i2 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i12 | 0, i3 | 0, i4 | 0);
}

function _realloc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if (!i2) {
  i3 = _malloc(i3) | 0;
  return i3 | 0;
 }
 if (i3 >>> 0 > 4294967231) {
  HEAP32[(___errno_location() | 0) >> 2] = 12;
  i3 = 0;
  return i3 | 0;
 }
 i1 = _try_realloc_chunk(i2 + -8 | 0, i3 >>> 0 < 11 ? 16 : i3 + 11 & -8) | 0;
 if (i1 | 0) {
  i3 = i1 + 8 | 0;
  return i3 | 0;
 }
 i1 = _malloc(i3) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i4 = HEAP32[i2 + -4 >> 2] | 0;
 i4 = (i4 & -8) - ((i4 & 3 | 0) == 0 ? 8 : 4) | 0;
 _memcpy(i1 | 0, i2 | 0, (i4 >>> 0 < i3 >>> 0 ? i4 : i3) | 0) | 0;
 _free(i2);
 i3 = i1;
 return i3 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 8 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j(i4 + -4 | 0, i7, i6, i1);
 STACKTOP = i5;
 return;
}

function __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i2 = i1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i6;
 i7 = __ZNSt3__2L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i9, i6, i7, i2, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 do if (i1 | 0) {
  i1 = __Z29scripting_gchandle_get_targetj(i1) | 0;
  if (!i1) {
   __Z23scripting_gchandle_freej(HEAP32[i2 >> 2] | 0);
   HEAP32[i2 >> 2] = 0;
   break;
  } else {
   i3 = i1;
   return i3 | 0;
  }
 } while (0);
 i3 = __Z20scripting_object_newP11Il2CppClass(i3) | 0;
 HEAP32[i2 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i3) | 0;
 HEAP32[i3 + 8 >> 2] = i2;
 return i3 | 0;
}

function __ZN5physx15PxsParticleDataD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 96500 + 8;
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  STACKTOP = i3;
  return;
 }
 if ((HEAP32[i2 + 60 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 64 | 0, i1);
 __ZdlPv(i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx14SapPairManager7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 3 | 0, HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 2 | 0, HEAP32[i1 + 4 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i1 + 20 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i1 + 24 >> 2] | 0);
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 STACKTOP = i3;
 return;
}

function __ZN4FMOD6System17getRecordPositionEiPj(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  if (!i5) {
   i5 = 0;
   STACKTOP = i4;
   return i5 | 0;
  }
  HEAP32[i5 >> 2] = 0;
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870308;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN15UniformTFMethod13MapBoneBufferEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 8 | 0;
 i6 = i1 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP32[i5 >> 2] | 0;
 i3 = i1 - i7 >> 2;
 if ((i3 | 0) == (i4 | 0)) return i7 | 0;
 i2 = i1;
 if (i3 >>> 0 < i4 >>> 0) {
  __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEj(i5, i4 - i3 | 0);
  i7 = HEAP32[i5 >> 2] | 0;
  return i7 | 0;
 }
 if (i3 >>> 0 <= i4 >>> 0) return i7 | 0;
 i1 = i7 + (i4 << 2) | 0;
 if ((i2 | 0) == (i1 | 0)) return i7 | 0;
 HEAP32[i6 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return i7 | 0;
}

function __ZN15DistanceJoint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var f2 = f0, i4 = 0, i5 = 0;
 __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode(i3, i1);
 if (!(i1 & 16)) return;
 i1 = i3 + 96 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = f2 < Math_fround(.00499999989);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 f2 = i4 ? Math_fround(.00499999989) : f2;
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[i3 + 60 >> 2] | 0;
 if (!i1) return;
 if (!(HEAP8[i3 + 100 >> 0] | 0)) {
  HEAPF32[i1 + 104 >> 2] = f2;
  return;
 } else {
  HEAPF32[i1 + 84 >> 2] = f2;
  return;
 }
}

function __ZN14SpriteRendererD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 58936 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 58936 + 184;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager13sendStreamEndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12HandlerChain4ThenEP17FileSystemHandler(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 4 | 0, i3);
  STACKTOP = i6;
  return i1 | 0;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  STACKTOP = i6;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_png_get_y_pixels_per_inch(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) if (!(HEAP32[i2 + 8 >> 2] & 128)) i4 = 4; else if ((HEAP8[i2 + 192 >> 0] | 0) == 1) {
  i1 = HEAP32[i2 + 188 >> 2] | 0;
  if ((i1 | 0) <= -1) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 } else i4 = 4; else i4 = 4;
 if ((i4 | 0) == 4) i1 = 0;
 i4 = (_UNITY_png_muldiv(i3, i1, 127, 5e3) | 0) == 0;
 i4 = i4 ? 0 : HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_png_get_x_pixels_per_inch(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) if (!(HEAP32[i2 + 8 >> 2] & 128)) i4 = 4; else if ((HEAP8[i2 + 192 >> 0] | 0) == 1) {
  i1 = HEAP32[i2 + 184 >> 2] | 0;
  if ((i1 | 0) <= -1) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 } else i4 = 4; else i4 = 4;
 if ((i4 | 0) == 4) i1 = 0;
 i4 = (_UNITY_png_muldiv(i3, i1, 127, 5e3) | 0) == 0;
 i4 = i4 ? 0 : HEAP32[i3 >> 2] | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 i1 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 209952 + 8;
 HEAP32[i1 >> 2] = gb + 209952 + 56;
 __THREW__ = 0;
 invoke_vii(fb + 4524 | 0, i2 + 12 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 >> 2] = gb + 211428 + 8;
  HEAP32[i1 >> 2] = gb + 211428 + 84;
  return;
 }
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i2 = i1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i6;
 i7 = __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE(i3, i4, i9, i6, i7, i2, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i2 = i1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i6;
 i7 = __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE(i3, i4, i9, i6, i7, i2, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZN8Animator15SetBodyRotationERK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 i4 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 16 >> 2] = i5;
 HEAP32[i4 + 20 >> 2] = i1;
 HEAP32[i4 + 24 >> 2] = i3;
 return;
}

function __ZN5physx9NpPhysics16destroySceneLockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpCloth18setDragCoefficientEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0;
 HEAPF32[i5 >> 2] = f1;
 HEAPF32[i5 + 4 >> 2] = f1;
 HEAPF32[i5 + 8 >> 2] = f1;
 mftCall_vii(i6 | 0, i2 | 0, i5 | 0);
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0;
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i4 + 4 >> 2] = f1;
 HEAPF32[i4 + 8 >> 2] = f1;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN12NavMeshAgent9SetRadiusEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 36 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent9SetHeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 40 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent14SetAutoBrakingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP8[i1 + 105 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __Z45ParticleSystem_Get_Custom_PropSimulationSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return __ZNK14ParticleSystem18GetSimulationSpaceEv(i2) | 0;
 return 0;
}

function __Z32TextGenerator_CUSTOM_Dispose_cppP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
 __ZdlPv(i2);
 return;
}

function __Z28PrecomputeFilterLookupTablesP17PrecomputeContextjifif(i1, i2, i3, f4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 var i7 = 0, f8 = f0;
 f8 = Math_fround(Math_fround(+Math_atan2(1.0, +Math_fround(i3 | 0))) * Math_fround(57.2957763));
 f4 = Math_fround(f4 * Math_fround(.5));
 f4 = f4 < f8 ? f8 : f4;
 i7 = f4 > Math_fround(90.0);
 f4 = i7 ? Math_fround(90.0) : f4;
 __Z19BuildAngleWeightLUTPfiiff(HEAP32[i1 + 96 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0, i2, f4, f6);
 __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei(i3, i1, i5);
 return;
}

function _fgetc(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) < 0) i4 = 3; else if (!(___lockfile(i3) | 0)) i4 = 3; else {
  i1 = i3 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
  } else i1 = ___uflow(i3) | 0;
 }
 do if ((i4 | 0) == 3) {
  i1 = i3 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
   break;
  } else {
   i1 = ___uflow(i3) | 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function ___mremap(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = i6 + 24 | 0;
 HEAP32[i8 >> 2] = i5;
 i9 = (HEAP32[i8 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i5 = HEAP32[i9 >> 2] | 0;
 HEAP32[i8 >> 2] = i9 + 4;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = i5;
 i5 = ___syscall_ret(___syscall163(163, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (i3) i4 = 6;
 } else {
  i5 = i3 + 16 & -16;
  i4 = _malloc(i5) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i4;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 return;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i2 = i1;
 HEAP32[i9 >> 2] = i3;
 HEAP32[i2 >> 2] = i6;
 i7 = __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE(i3, i4, i9, i6, i7, i2, 1114111, 0) | 0;
 HEAP32[i5 >> 2] = HEAP32[i9 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i2 >> 2];
 STACKTOP = i1;
 return i7 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEwj(i2, i5, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (i1 >>> 0 > i4 >>> 0) {
  i3 = i2 + (i1 << 2) | 0;
  i1 = i2 + (i4 << 2) | 0;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) {
    i1 = -1;
    break L5;
   }
   if ((HEAP32[i1 >> 2] | 0) != (i5 | 0)) break;
   i1 = i1 + 4 | 0;
  }
  i1 = i1 - i2 >> 2;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZNK8Animator8HasStateEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i4) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i4) | 0) if (!(HEAP32[i5 >> 2] | 0)) {
  i4 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 92 >> 2] | 0, i4 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i5 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = __ZNK26AnimatorControllerPlayable8HasStateEii(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2, i3) | 0;
 return i5 | 0;
}

function __ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf(i1, i4, i5, i6, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + 15 & -16;
 if (!(HEAP8[i2 + 1412 >> 0] | 0)) {
  i6 = i6 << 1 & 2 | 1;
  return i6 | 0;
 }
 i3 = __ZNK5Umbra18ImpOcclusionBuffer13isAABBVisibleERKNS_7Vector3ES3_Pf(i2, i4, i5, i3) | 0;
 i1 = i3 & 1;
 if ((i6 & 1 | 0) == 0 | i3 ^ 1) {
  i6 = i1;
  return i6 | 0;
 } else {
  i6 = __ZNK5Umbra18ImpOcclusionBuffer18isAABBFullyVisibleERKNS_7Vector3ES3_(i2, i4, i5) | 0;
  return (i6 ? 3 : i1) | 0;
 }
 return 0;
}

function __ZNK13TriggerEvents9GetEventsENS_9EventTypeERK23ParticleSystemParticlesP22ParticleSystemParticlei(i3, i4, i6, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = HEAP32[i3 + (i4 * 20 | 0) + 12 >> 2] | 0;
 i5 = (i5 | 0) < (i2 | 0) ? i5 : i2;
 if ((i5 | 0) <= 0) return i5 | 0;
 i3 = i3 + (i4 * 20 | 0) | 0;
 i2 = 0;
 while (1) {
  __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(i6, i1, 1, HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= (i5 | 0)) break; else i1 = i1 + 120 | 0;
 }
 return i5 | 0;
}

function __ZNK12HandlerChain9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag(i1, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i9 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i8 = 0;
  return i8 | 0;
 } else i1 = 0;
 do {
  i2 = i2 + -4 | 0;
  i9 = HEAP32[i2 >> 2] | 0;
  i1 = i1 | (mftCall_iiiiiii(HEAP32[(HEAP32[i9 >> 2] | 0) + 148 >> 2] | 0, i9 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0);
 } while ((i2 | 0) != (HEAP32[i3 >> 2] | 0));
 return i1 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf(i4, f3) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 i2 = i4 + 156 | 0;
 if (Math_fround(HEAPF32[i2 >> 2]) == f3) {
  STACKTOP = i5;
  return;
 }
 HEAPF32[i2 >> 2] = f3;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE6resizeEjRKS4_(i4 + 248 | 0, 0, i1);
 HEAP32[i4 + 260 >> 2] = 0;
 HEAP32[i4 + 540 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx33PxVehicleWheelDataGeneratedValuesC2EPKNS_18PxVehicleWheelDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 32 >> 2];
 return;
}

function __ZN5physx2Sn20SerializationContext9alignDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i3 = i2 + 184 | 0;
 i6 = i1 + -1 | 0;
 i1 = i1 - (HEAP32[i2 + 196 >> 2] & i6) & i6;
 _memset(i4 | 0, 0, ((i1 | 0) < 64 ? i1 : 64) | 0) | 0;
 if ((i1 | 0) > 0) while (1) {
  __ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj(i3, i4, (i1 | 0) < 64 ? i1 : 64) | 0;
  if ((i1 | 0) > 64) i1 = i1 + -64 | 0; else break;
 }
 STACKTOP = i5;
 return;
}

function __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i1 = i4 + 5912 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i5 = i4 + 7608 | 0;
 HEAP32[i5 >> 2] = 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 i6 = mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 4 >> 2] | 0, i6 | 0) | 0;
 __ZN5physx14PxsAABBManager16updateAABBsAndBPEjjjPNS_10PxBaseTaskEPjjbPi(HEAP32[i4 + 8 >> 2] | 0, i6, 0, 0, i2, HEAP32[i1 >> 2] | 0, HEAP32[i4 + 5916 >> 2] & 2147483647, i3, i5);
 return;
}

function __ZN12NavMeshAgent8SetSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAPF32[i1 + 48 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12NavMeshAgent13SetAutoRepathEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP8[i1 + 106 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function __ZN12BaseRenderer12GetWorldAABBER4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 240 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 if ((i4 & 65535) > 255 | (i4 & 255) << 24 >> 24 != 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
  HEAP8[i3 >> 0] = 0;
  HEAP8[i1 + 241 >> 0] = 0;
 }
 i4 = i1 + 132 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 return;
}

function __ZN12BaseRenderer12GetLocalAABBER4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 240 | 0;
 i4 = HEAP16[i3 >> 1] | 0;
 if ((i4 & 65535) > 255 | (i4 & 255) << 24 >> 24 != 0) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
  HEAP8[i3 >> 0] = 0;
  HEAP8[i1 + 241 >> 0] = 0;
 }
 i4 = i1 + 156 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 return;
}

function __ZN10Collider2D4CastERK8Vector2ffbP12RaycastHit2Di(i1, i2, f3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 if (!(HEAP32[i1 + 72 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i7 = __Z19GetPhysicsManager2Dv() | 0;
 i7 = __ZN16Physics2DManager21GetLayerCollisionMaskEi(i7, HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] | 0) | 0;
 i6 = __ZN16Physics2DManager12ColliderCastEPK10Collider2DRK8Vector2ffibP12RaycastHit2Di(__Z19GetPhysicsManager2Dv() | 0, i1, i2, f3, i7, i4, i5, i6) | 0;
 return i6 | 0;
}

function __Z39ParticleSystemRenderer_RenderBillboardsRK15RenderNodeQueuejRK14ChannelAssignsi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 16 | 0;
 i6 = i5;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP8[i6 + 8 >> 0] = 1;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z47ParticleSystemRenderer_RenderMultipleBillboardsRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i1, i6, i3);
 STACKTOP = i5;
 return;
}

function _getc(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) < 0) i4 = 3; else if (!(___lockfile(i3) | 0)) i4 = 3; else {
  i1 = i3 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
  } else i1 = ___uflow(i3) | 0;
 }
 do if ((i4 | 0) == 3) {
  i1 = i3 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i3 + 8 >> 2] | 0) >>> 0) {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = HEAPU8[i2 >> 0] | 0;
   break;
  } else {
   i1 = ___uflow(i3) | 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function _cf2_hintmask_setAll(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = 0 - i1 & 7;
 if (i1 >>> 0 > 96) {
  _cf2_setError(HEAP32[i4 >> 2] | 0, 18);
  return;
 }
 HEAP32[i4 + 8 >> 2] = i1;
 i2 = (i1 + 7 | 0) >>> 3;
 i3 = i4 + 12 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP8[i4 + 4 >> 0] = 1;
 HEAP8[i4 + 5 >> 0] = 1;
 if (!i1) return;
 if (!i2) i1 = -1; else {
  i1 = 0;
  do {
   HEAP8[i4 + 16 + i1 >> 0] = -1;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i3 >> 2] | 0;
  } while (i1 >>> 0 < i2 >>> 0);
  i1 = i2 + -1 | 0;
 }
 i4 = i4 + 16 + i1 | 0;
 HEAP8[i4 >> 0] = (HEAPU8[i4 >> 0] | 0) & -1 << i5;
 return;
}

function __ZN9b2Contact7AddTypeEPFPS_P9b2FixtureiS2_iP16b2BlockAllocatorEPFvS0_S4_EN7b2Shape4TypeESA_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[gb + 1458112 + (i3 * 60 | 0) + (i4 * 12 | 0) >> 2] = i1;
 HEAP32[gb + 1458112 + (i3 * 60 | 0) + (i4 * 12 | 0) + 4 >> 2] = i2;
 HEAP8[gb + 1458112 + (i3 * 60 | 0) + (i4 * 12 | 0) + 8 >> 0] = 1;
 if ((i3 | 0) == (i4 | 0)) return;
 HEAP32[gb + 1458112 + (i4 * 60 | 0) + (i3 * 12 | 0) >> 2] = i1;
 HEAP32[gb + 1458112 + (i4 * 60 | 0) + (i3 * 12 | 0) + 4 >> 2] = i2;
 HEAP8[gb + 1458112 + (i4 * 60 | 0) + (i3 * 12 | 0) + 8 >> 0] = 0;
 return;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl14onDeallocationEPv(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 8 | 0;
 i2 = i5;
 if (!i3) {
  STACKTOP = i5;
  return;
 }
 i6 = i2;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_17DeallocationEventEEEvT_(i4 + 16 | 0, i1);
 STACKTOP = i5;
 return;
}

function __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Cct13HandleManager12UpdateObjectEjPv(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i1 = i4 & 65535;
 i2 = HEAP32[i6 + 8 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 i7 = HEAP16[(HEAP32[i6 + 12 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 i3 = i7 & 65535;
 if (!(i7 << 16 >> 16 != -1 & i3 >>> 0 < i2 >>> 0)) {
  i7 = 0;
  return i7 | 0;
 }
 if ((HEAPU16[(HEAP32[i6 + 20 >> 2] | 0) + (i1 << 1) >> 1] | 0 | 0) != (i4 >>> 16 | 0)) {
  i7 = 0;
  return i7 | 0;
 }
 HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 2) >> 2] = i5;
 i7 = 1;
 return i7 | 0;
}

function __ZN5physx17EdgeChangeManager23cleanupBrokenEdgeEventsEPKNS_4EdgeE(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i8 = 0;
 i8 = i1 + 28 | 0;
 if (!(HEAP32[i8 >> 2] | 0)) return;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 i6 = i1 + 20 | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 if (!i3) i1 = 0; else {
  i4 = 0;
  i1 = 0;
  do {
   i2 = HEAP32[i5 + (i4 << 2) >> 2] | 0;
   if (!(HEAP32[i7 + (i2 * 12 | 0) + 8 >> 2] & 2)) {
    HEAP32[i5 + (i1 << 2) >> 2] = i2;
    i1 = i1 + 1 | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i3 | 0));
 }
 HEAP32[i6 >> 2] = i1;
 HEAP32[i8 >> 2] = 0;
 return;
}

function __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 | 0, i4 << 2 | 0) | 0;
 if ((i4 | 0) == 0 | i1 ^ 1) return 1; else i1 = 0;
 do {
  i2 = i3 + (i1 << 2) | 0;
  i5 = HEAP8[i2 >> 0] | 0;
  i6 = i2 + 3 | 0;
  HEAP8[i2 >> 0] = HEAP8[i6 >> 0] | 0;
  HEAP8[i6 >> 0] = i5;
  i6 = i2 + 1 | 0;
  i5 = HEAP8[i6 >> 0] | 0;
  i2 = i2 + 2 | 0;
  HEAP8[i6 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP8[i2 >> 0] = i5;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return 1;
}

function __ZN5physx14PxsComputeAABBEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS3_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_(i5, i2, i1);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i5 + 20 >> 2];
 STACKTOP = i4;
 return;
}

function __ZN5Unity5Cloth11SetFrictionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (f1 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 821, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 } else if (f1 > Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838899 | 0, 0, gb + 838562 | 0, 822, 1, 0, 0, 0);
  f1 = Math_fround(1.0);
 }
 HEAPF32[i2 + 84 >> 2] = f1;
 i2 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 372 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN15AudioReverbZone6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) {
  STACKTOP = i3;
  return;
 }
 __ZNK9Transform11GetPositionEv(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f4 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 __ZN4FMOD6Reverb15set3DAttributesEPK11FMOD_VECTORff(HEAP32[i1 + 116 >> 2] | 0, i2, f4, Math_fround(HEAPF32[i1 + 52 >> 2])) | 0;
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher23EnumerateSessionFoldersER13dynamic_arrayI13FileEntryInfoLj8EERPKS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __Z13GetFileSystemv() | 0;
 i1 = i1 + 16 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 if (!(__ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag(i4, i1, i2, 0, 10) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 i4 = (i4 | 0) != ((HEAP32[i2 >> 2] | 0) + ((HEAP32[i2 + 12 >> 2] | 0) * 1088 | 0) | 0);
 return i4 | 0;
}

function __Z46Collider_CUSTOM_INTERNAL_CALL_Internal_RaycastP12Il2CppObjectRK3RayP10RaycastHitf(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0;
 HEAP32[i3 + 40 >> 2] = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   if (!(__ZN8Collider7RaycastERK3RayfR10RaycastHit(i5, i2, f4, i3) | 0)) {
    i5 = 0;
    return i5 | 0;
   }
   __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i3);
   i5 = 1;
   return i5 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40CullingGroup_CUSTOM_SetBoundingDistancesP12Il2CppObjectP11Il2CppArray(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (i1 | 0) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 | 0) {
   if (!i4) i1 = 0; else i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0;
   __ZN12CullingGroup20SetBoundingDistancesEPKfj(i2, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z22Input_CUSTOM_GetButtonP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = (__ZN12InputManager9GetButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(__Z15GetInputManagerv() | 0, i3) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function _fgetws(i1, i2, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (i2) {
  if ((HEAP32[i7 + 76 >> 2] | 0) > -1) i6 = ___lockfile(i7) | 0; else i6 = 0;
  i3 = i2;
  i2 = i1;
  while (1) {
   i3 = i3 + -1 | 0;
   if (!i3) break;
   i5 = ___fgetwc_unlocked(i7) | 0;
   if ((i5 | 0) == -1) break;
   i4 = i2 + 4 | 0;
   HEAP32[i2 >> 2] = i5;
   if ((i5 | 0) == 10) {
    i2 = i4;
    break;
   } else i2 = i4;
  }
  HEAP32[i2 >> 2] = 0;
  i2 = (HEAP32[i7 >> 2] & 32 | 0) == 0 ? i2 : i1;
  if (i6 | 0) ___unlockfile(i7);
  i1 = (i2 | 0) == (i1 | 0) ? 0 : i1;
 }
 return i1 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd12_GLOBAL__N_113PxThreadStartEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 24 >> 2] = _syscall(224, i3 | 0) | 0;
 __ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1 + 12 | 0, 1, 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) {
  mftCall_ii(i2 | 0, i1 | 0) | 0;
  STACKTOP = i3;
  return 0;
 }
 if (!i1) {
  STACKTOP = i3;
  return 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 STACKTOP = i3;
 return 0;
}

function __ZN17ProceduralTexture13RemoveTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 160 | 0;
 if (!(HEAP32[i4 >> 2] & 2)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -3;
 HEAP32[i2 + 208 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN15RelativeJoint2D15SetLinearOffsetERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 88 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 __ZN12b2MotorJoint15SetLinearOffsetERK6b2Vec2(i1, i3);
 STACKTOP = i4;
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValues10SaveValuesER9JSONWrite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 1041356 | 0, 0);
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(i2, i1 + 52 | 0, gb + 1041368 | 0, 0);
 __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1041382 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 20 | 0, gb + 1041396 | 0, 0);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 36 | 0, gb + 1041407 | 0, 0);
 return;
}

function __ZN11NoiseModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 824 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1092 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1356 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 1620 | 0, i2);
 return;
}

function __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 if (!i4) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[i3 + 1072 >> 2] | 0;
 i2 = HEAP32[i3 + 1068 >> 2] | 0;
 i5 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = (i1 - i2 | 0) / 40 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i5 + (i1 * 40 | 0) + 32 >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) return i1 | 0;
 i6 = i1 - (HEAP32[i3 + 1080 >> 2] | 0) | 0;
 return i6 | 0;
}

function __ZN10GameObject8SetLayerEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i2 >>> 0 < 32) {
  HEAP32[i1 + 48 >> 2] = i2;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105216 | 0, i3);
  STACKTOP = i4;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 370009 | 0, 0, gb + 368833 | 0, 779, 1, 0, 0, 0);
  STACKTOP = i4;
  return;
 }
}

function __Z42ParticleSystem_Get_Custom_PropMaxParticlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return __ZNK14ParticleSystem18GetMaxNumParticlesEv(i2) | 0;
 return 0;
}

function __Z40ParticleSystem_Get_Custom_PropIsEmittingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem10IsEmittingEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z40ParticleSystem_CUSTOM_INTERNAL_CALL_EmitP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem4EmitEi(i3, i2);
  return;
 }
}

function __Z31Profiler_Set_Custom_PropLogFileP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __ZN13UnityProfiler10SetLogPathENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z14dictDeleteDictP9TESSallocP4Dict(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0, i7 = 0, i8 = 0;
 i6 = HEAP32[i5 + 16 >> 2] | 0;
 i3 = HEAP32[i6 + 20 >> 2] | 0;
 i7 = i6 + 4 | 0;
 i1 = HEAP32[i7 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (i1 | 0) do {
  i8 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i8 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i7 >> 2] = 0;
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6 | 0);
 mftCall_vii(HEAP32[i4 + 8 >> 2] | 0, HEAP32[i4 + 12 >> 2] | 0, i5 | 0);
 return;
}

function __ZZN2UI14CanvasRenderer15InitializeClassEvEN38FunctorImpl_803kCanvasHierarchyChanged4CallEPviR11MessageData(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 i2 = i4 + 188 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  return;
 } else i1 = i3;
 do {
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i1) break;
  i5 = i1 + 224 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 4;
 } while (!(HEAP32[i1 + 208 >> 2] | 0));
 __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i3, i4);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN6Camera16CheckConsistencyEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, i2 = 0, i4 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i3);
 i2 = i3 + 928 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i4 | 0) < -1 ? -1 : (i4 | 0) > 3 ? 3 : i4;
 i2 = i3 + 920 | 0;
 f1 = Math_fround(HEAPF32[i2 >> 2]);
 if ((HEAP8[i3 + 1088 >> 0] | 0) == 0 & f1 < Math_fround(.00999999977)) {
  HEAPF32[i2 >> 2] = Math_fround(.00999999977);
  f1 = Math_fround(.00999999977);
 }
 i2 = i3 + 924 | 0;
 f1 = Math_fround(f1 + Math_fround(.00999999977));
 if (!(Math_fround(HEAPF32[i2 >> 2]) < f1)) return;
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx3Ext18ProfileZoneHandler7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i3 = i1 + 8 | 0;
 i1 = i2;
 do {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  i5 = HEAP32[i2 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
  i2 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN5physx2Sc15ArticulationSim14internalWakeUpEf(i2, f4) {
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i3 = 0;
 i1 = i2 + 8 | 0;
 if (!(Math_fround(__ZNK5physx2Sc16ArticulationCore14getWakeCounterEv(HEAP32[i1 >> 2] | 0)) < f4)) return;
 __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf(HEAP32[i1 >> 2] | 0, f4);
 i3 = i2 + 16 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i2 + 24 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc7BodySim30internalWakeUpArticulationLinkEf(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, f4);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra20ObjectDistanceParamsC2EPKNS_7Vector3Ef(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = (i2 | 0) != 0;
 HEAP8[i1 + 16 >> 0] = i4 & 1;
 if (!i4) {
  i4 = i1 + 12 | 0;
  HEAPF32[i4 >> 2] = f3;
  return;
 };
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i4 = i1 + 12 | 0;
 HEAPF32[i4 >> 2] = f3;
 return;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 479351 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 479375 | 0, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20GpuProgramParameters15AddTextureParamERKNS_16TextureParameterE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 40 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 44 >> 2] | 0)) {
  __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 36 | 0, i2);
  return;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i4 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i4 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 16;
  return;
 }
}

function __ZN18DownloadHandlerVFS13OnReceiveDataEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(__ZN15FileSystemEntry8IsLockedEv(i1 + 20 | 0) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __ZN12FileAccessor5WriteEyPKvPy(i1 + 1080 | 0, i3, 0, i2, i4) | 0;
 i2 = i4;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i2 = _i64Add(HEAP32[i3 >> 2] | 0, 0, i4 | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 getTempRet0() | 0;
 HEAP32[i3 >> 2] = i2;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_116CompleteCallback7processERN5physx6PxBaseE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0) | 0) return;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (i1 | 0) if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0) | 0) return;
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i3 | 0) | 0) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 | 0, 0, 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i1 = i2 + 12 | 0;
 i2 = i3 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z43ParticleSystem_Get_Custom_PropParticleCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return __ZNK14ParticleSystem16GetParticleCountEv(i2) | 0;
 return 0;
}

function __Z42BillboardRenderer_Set_Custom_PropBillboardP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   HEAP32[i3 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   __ZN17BillboardRenderer12SetBillboardERK4PPtrI14BillboardAssetE(i4, i3);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI14SafeBinaryRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function _UNITY_png_get_pixel_aspect_ratio_fixed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) if (HEAP32[i2 + 8 >> 2] & 128 | 0) {
  i3 = HEAP32[i2 + 184 >> 2] | 0;
  if (i3 | 0) {
   i1 = HEAP32[i2 + 188 >> 2] | 0;
   if ((i3 | 0) > -1 & (i1 | 0) > 0) {
    i3 = (_UNITY_png_muldiv(i4, i1, 1e5, i3) | 0) == 0;
    if (!i3) {
     i4 = HEAP32[i4 >> 2] | 0;
     STACKTOP = i5;
     return i4 | 0;
    }
   }
  }
 }
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_TT_Done_Context(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP16[i1 + 440 >> 1] = 0;
 HEAP16[i1 + 442 >> 1] = 0;
 i3 = i1 + 24 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i3 = i1 + 436 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 432 >> 2] = 0;
 HEAP32[i1 + 428 >> 2] = 0;
 i3 = i1 + 392 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 388 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i1);
 return;
}

function __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 i1 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 209868 + 8;
 HEAP32[i1 >> 2] = gb + 209868 + 56;
 __THREW__ = 0;
 invoke_vii(fb + 4519 | 0, i2 + 12 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 >> 2] = gb + 211316 + 8;
  HEAP32[i1 >> 2] = gb + 211316 + 84;
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i5 = i2 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 i6 = i1 << 24 >> 24 < 0;
 if (i6) i1 = HEAP32[i2 + 4 >> 2] | 0; else i1 = i1 & 255;
 do if (i1 >>> 0 < i3 >>> 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc(i2, i3 - i1 | 0, i4) | 0; else if (i6) {
  HEAP8[(HEAP32[i2 >> 2] | 0) + i3 >> 0] = 0;
  HEAP32[i2 + 4 >> 2] = i3;
  break;
 } else {
  HEAP8[i2 + i3 >> 0] = 0;
  HEAP8[i5 >> 0] = i3;
  break;
 } while (0);
 return;
}

function __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK8Vector3fRK11Quaternionfi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i4, i7);
 HEAP32[i7 + 48 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i7 + 52 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i7 + 56 >> 2] = HEAP32[i3 + 8 >> 2];
 __ZL16DrawMeshInternalRK14ChannelAssignsR4MeshRK10Matrix4x4fi13TransformType(i1, i2, i7, i5, 0);
 STACKTOP = i6;
 return;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888816TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround((i3 >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  HEAPF32[i4 + 4 >> 2] = Math_fround(Math_fround((i3 >>> 16 & 255) >>> 0) * Math_fround(.00392156886));
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 8 >> 2] = i6;
  HEAP32[i4 + 12 >> 2] = i5;
  HEAP32[i4 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAP32[i1 + 8 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 4 >> 2] = i6;
  HEAP32[i4 + 8 >> 2] = i5;
  HEAP32[i4 + 12 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 830932;
 HEAP32[i1 + 4 >> 2] = 630;
 HEAP32[i1 + 8 >> 2] = fb + 3926;
 HEAP32[i1 + 12 >> 2] = gb + 830956;
 HEAP32[i1 + 16 >> 2] = 631;
 HEAP32[i1 + 20 >> 2] = fb + 55;
 HEAP32[i1 + 24 >> 2] = fb + 21;
 HEAP32[i1 + 32 >> 2] = fb + 2382;
 HEAP32[i1 + 36 >> 2] = gb + 830975;
 HEAP32[i1 + 40 >> 2] = 632;
 HEAP32[i1 + 44 >> 2] = fb + 56;
 HEAP32[i1 + 48 >> 2] = fb + 22;
 HEAP32[i1 + 56 >> 2] = fb + 2383;
 HEAP32[i1 + 60 >> 2] = gb + 830994;
 HEAP32[i1 + 64 >> 2] = 633;
 HEAP32[i1 + 68 >> 2] = fb + 2384;
 return;
}

function __ZN5physx2Sq12BucketPrunerD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP32[i4 >> 2] = gb + 101708 + 8;
 __ZN5physx2Sq11PruningPoolD2Ev(i4 + 7616 | 0);
 __ZN5physx2Sq16BucketPrunerCore7releaseEv(i4 + 16 | 0);
 i2 = i4 + 560 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i4);
  STACKTOP = i5;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i4);
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc9ClothCore24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 292 >> 2] | 0, i3 | 0, i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  _memcpy(i1 | 0, i2 | 0, (HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) | 0;
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14resetFilteringEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 1, gb + 700312 | 0, 603, gb + 700493 | 0, i3);
 i1 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 212 >> 2] | 0, i1 | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i1 >> 2] = i4;
 i5 = i1 + 68 | 0;
 i1 = i1 + 4 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 132 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i1 = i5;
 i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 136 >> 2] | 0, i4 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN20UnloadSceneOperationC2EP10UnityScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i3 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 65964 + 8;
 HEAP32[i1 + 64 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN17TransformInternal38OnTransformChangedMaskToSelfAndParentsE15TransformAccessj(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 i4 = HEAP32[i2 + 56 >> 2] | 0;
 i5 = i2 + 36 | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 do {
  i7 = HEAP32[i3 + (i1 << 2) >> 2] & i6;
  i8 = i4 + (i1 << 2) | 0;
  HEAP32[i8 >> 2] = HEAP32[i8 >> 2] | i7;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i7;
  i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN15UnityAdsManagerC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 188244 + 8;
 STACKTOP = i4;
 return;
}

function __ZN14DirectorPlayer17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN15DirectorManager17RemoveFromManagerEP14DirectorPlayer(__Z18GetDirectorManagerv() | 0, i1);
 i3 = i1 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 HEAP8[i4 + 165 >> 0] = 1;
 i1 = i4 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 164 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController(__Z18GetDirectorManagerv() | 0, i4);
  HEAP8[i1 >> 0] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z28PlayerPrefs_CUSTOM_TrySetIntP12Il2CppStringi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 i2 = (__ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i4, i2) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __Z16jpeg_memory_destP20jpeg_compress_structPhiPiPvPFvS3_S3_iE(i2, i4, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0, i2 | 0, 0, 48) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 32 >> 2] = i6;
 HEAP32[i1 + 40 >> 2] = i7;
 HEAP32[i1 + 44 >> 2] = i8;
 HEAP32[i1 + 8 >> 2] = fb + 3377;
 HEAP32[i1 + 12 >> 2] = fb + 1575;
 HEAP32[i1 + 16 >> 2] = fb + 3378;
 return;
}

function __Z15allGreaterEqualRK8Scalar4fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f3 >= Math_fround(HEAPF32[i2 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!(f3 >= Math_fround(HEAPF32[i2 + 4 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f3 >= Math_fround(HEAPF32[i2 + 8 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i2 = f3 >= Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i2 & 1;
 return i2 | 0;
}

function __ZThn32_N8Renderer21RendererBecameVisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = i1 + -32 | 0;
 i4 = i1 + 268 | 0;
 i5 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16 | 4096;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 __ZN6Object11InvokeEventEi(i1, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105296 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jRKS4_(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i3); else {
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i3, (i2 ? HEAP32[i4 >> 2] | 0 : i4) + (i5 << 2) | 0, i1 - i5 | 0);
  return;
 }
}

function __ZNK5physx16PxsSolverExtBody9getLinVelEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = HEAP16[i3 + 8 >> 1] | 0;
 if (i1 << 16 >> 16 == -1) {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  return;
 } else {
  i4 = i1 & 65535;
  i5 = (HEAP32[i3 >> 2] | 0) + 128 | 0;
  i1 = HEAP32[i5 + (i4 << 5) + 4 >> 2] | 0;
  i3 = HEAP32[i5 + (i4 << 5) + 8 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i5 + (i4 << 5) >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  HEAP32[i2 + 8 >> 2] = i3;
  return;
 }
}

function __ZNK5physx11Adjacencies22ComputeNbBoundaryEdgesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 } else {
  i1 = 0;
  i3 = 0;
 }
 do {
  i5 = (HEAP32[i4 + (i3 * 12 | 0) >> 2] & 536870911 | 0) == 536870911;
  i1 = ((HEAP32[i4 + (i3 * 12 | 0) + 4 >> 2] & 536870911 | 0) == 536870911 ? (i5 ? 2 : 1) : i5 & 1) + i1 + ((HEAP32[i4 + (i3 * 12 | 0) + 8 >> 2] & 536870911 | 0) == 536870911 & 1) | 0;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i2 >>> 0);
 return i1 | 0;
}

function __ZNK12b2WheelJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 + 108 >> 2]);
 f6 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 180 >> 2]));
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i2 + 184 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 172 >> 2]));
 f4 = Math_fround(Math_fround(f7 + Math_fround(f4 * Math_fround(HEAPF32[i2 + 176 >> 2]))) * f3);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f6 + f5) * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN7mecanim12statemachine18GetTransitionArrayENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i1 | 0) {
 case 1:
  {
   i2 = i2 + 4 | 0;
   i3 = (HEAP32[i2 >> 2] | 0) + i2 + (HEAP32[i3 + 8 >> 2] << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) + 4 | 0;
   return i3 | 0;
  }
 case 2:
  {
   i2 = i2 + 4 | 0;
   i3 = (HEAP32[i2 >> 2] | 0) + i2 + (HEAP32[i3 + 12 >> 2] << 2) | 0;
   i3 = i3 + (HEAP32[i3 >> 2] | 0) + 4 | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = i2 + 12 | 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingIsfE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 20 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN4FMOD6System11isRecordingEiPb(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  if (!i5) {
   i5 = 0;
   STACKTOP = i4;
   return i5 | 0;
  }
  HEAP8[i5 >> 0] = 0;
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 870326;
 _printf(gb + 853184 | 0, i3) | 0;
 i5 = 36;
 STACKTOP = i4;
 return i5 | 0;
}

function __ZN10MonoScript7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i3 = i2 + 8 | 0;
  if ((HEAP32[i2 + 24 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 12 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63728 | 0);
 } else {
  i3 = __Z19GetScriptingManagerv() | 0;
  __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i3, HEAP32[i2 + 32 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z55ParticleSystemRenderer_CUSTOM_Internal_SetVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlagsh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) {
  i4 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i4) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 } else {
  HEAP8[i4 + 388 >> 0] = 1;
  i4 = i4 + 392 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 << 24 >> 24 ? i1 | i2 & -2 : i1 & ((i2 | 1) ^ -2);
  return;
 }
}

function __Z39ParticleSystem_Get_Custom_PropIsStoppedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem9IsStoppedEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z39ParticleSystem_Get_Custom_PropIsPlayingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem9IsPlayingEv(i2) | 0) & 1 | 0;
 return 0;
}

function _PxRegisterCloth(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN5physx9NpFactory13registerClothEv();
 i3 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = i1 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = HEAP32[i3 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
  return;
 }
 i1 = i1 + 4 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc5Scene17createClothSolverEv((HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 32 | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 i4 = HEAP32[i3 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i4);
 return;
}

function _FT_Init_Table_ft_raccess_guess_table(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 166;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = fb + 167;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = fb + 168;
 HEAP32[i1 + 20 >> 2] = 2;
 HEAP32[i1 + 24 >> 2] = fb + 169;
 HEAP32[i1 + 28 >> 2] = 3;
 HEAP32[i1 + 32 >> 2] = fb + 170;
 HEAP32[i1 + 36 >> 2] = 4;
 HEAP32[i1 + 40 >> 2] = fb + 171;
 HEAP32[i1 + 44 >> 2] = 5;
 HEAP32[i1 + 48 >> 2] = fb + 172;
 HEAP32[i1 + 52 >> 2] = 6;
 HEAP32[i1 + 56 >> 2] = fb + 173;
 HEAP32[i1 + 60 >> 2] = 7;
 HEAP32[i1 + 64 >> 2] = fb + 174;
 HEAP32[i1 + 68 >> 2] = 8;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_jj(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 i3 = HEAP8[i4 + 11 >> 0] | 0;
 i7 = i3 << 24 >> 24 < 0;
 i3 = i7 ? HEAP32[i4 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i5 | 0;
  return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj(i1, i2, (i7 ? HEAP32[i4 >> 2] | 0 : i4) + i5 | 0, i3 >>> 0 < i6 >>> 0 ? i3 : i6) | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcx(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i6 = mftCall_iiiiiii(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZNK5physx24PxClothMeshQuadifierImpl13getDescriptorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1;
 i4 = i2;
 i5 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  i3 = i3 + 4 | 0;
  i4 = i4 + 4 | 0;
 } while ((i3 | 0) < (i5 | 0));
 HEAP16[i1 + 48 >> 1] = HEAP16[i2 + 48 >> 1] & -3;
 HEAP32[i1 + 32 >> 2] = ((HEAP32[i2 + 68 >> 2] | 0) >>> 0) / 3 | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 64 >> 2];
 HEAP32[i1 + 24 >> 2] = 12;
 HEAP32[i1 + 44 >> 2] = (HEAP32[i2 + 56 >> 2] | 0) >>> 2;
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 36 >> 2] = 16;
 return;
}

function __ZN6b2Body13CreateFixtureEPK7b2Shapef(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP16[i5 + 22 >> 1] = 1;
 HEAP16[i5 + 24 >> 1] = -1;
 HEAP16[i5 + 26 >> 1] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i5 + 8 >> 2] = Math_fround(.200000003);
 HEAPF32[i5 + 12 >> 2] = Math_fround(0.0);
 HEAP8[i5 + 20 >> 0] = 0;
 HEAP32[i5 >> 2] = i2;
 HEAPF32[i5 + 16 >> 2] = f3;
 i2 = __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb(i1, i5, 1) | 0;
 STACKTOP = i4;
 return i2 | 0;
}

function __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 765184;
 HEAP32[i1 + 4 >> 2] = 389;
 HEAP32[i1 + 8 >> 2] = fb + 398;
 HEAP32[i1 + 12 >> 2] = fb + 340;
 HEAP32[i1 + 16 >> 2] = gb + 674785;
 HEAP32[i1 + 20 >> 2] = 390;
 HEAP32[i1 + 24 >> 2] = fb + 399;
 HEAP32[i1 + 28 >> 2] = fb + 341;
 HEAP32[i1 + 32 >> 2] = gb + 674805;
 HEAP32[i1 + 36 >> 2] = 391;
 HEAP32[i1 + 40 >> 2] = fb + 400;
 HEAP32[i1 + 44 >> 2] = fb + 342;
 HEAP32[i1 + 48 >> 2] = gb + 674772;
 HEAP32[i1 + 52 >> 2] = 392;
 HEAP32[i1 + 56 >> 2] = fb + 401;
 HEAP32[i1 + 60 >> 2] = fb + 343;
 return;
}

function __ZN5physx2Sc19ParticlePacketShape20setInteractionsDirtyENS0_15CoreInteraction9DirtyFlagE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = HEAP16[i1 + 42 >> 1] | 0;
 i4 = i2 + ((i3 & 65535) << 2) | 0;
 if (!(i3 << 16 >> 16)) return;
 do {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = i3 + 4 | 0;
  HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i5;
  i1 = i3 + 6 | 0;
  if (!(HEAP16[i1 >> 1] & 2)) {
   __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i3);
   HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 2;
  }
  i2 = i2 + 4 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14resetFilteringEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 1, gb + 700312 | 0, 603, gb + 700493 | 0, i3);
 i1 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 212 >> 2] | 0, i1 | 0, i2 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx17PxsFluidCollisionD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 + 452 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 460 >> 2] = 0;
 i3 = i1 + 100 | 0;
 i2 = i1 + 452 | 0;
 do {
  i1 = HEAP32[i2 + -36 >> 2] | 0;
  i2 = i2 + -44 | 0;
  if ((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (i1 | 0) {
    i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
    if (i1 | 0) {
     i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
     mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
    }
   }
  }
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN5physx13GuMeshFactory18removeTriangleMeshERNS_14PxTriangleMeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i2 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 8 | 0, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN4FMOD7SystemI18createChannelGroupEPKcPPNS_12ChannelGroupE(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi(i2 + 124 | 0, -1) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 860351;
  _printf(gb + 853184 | 0, i3) | 0;
  i5 = 36;
  STACKTOP = i4;
  return i5 | 0;
 } else {
  HEAP32[i5 >> 2] = HEAP32[i1 + 20 >> 2];
  i5 = 0;
  STACKTOP = i4;
  return i5 | 0;
 }
 return 0;
}

function __ZN22BlockMemoryCacheWriterD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 37988 + 8;
 i3 = i2 + 20 | 0;
 i4 = i2 + 32 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i2 + 12 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 24 | 0);
 HEAP32[i3 >> 2] = 0;
 __ZdlPv(i2);
 return;
}

function __ZN20TextRenderingPrivate8FontImpl11GrowTextureEi(i5, i6) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = i5 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i5 + 172 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  i1 = i1 << 1;
  HEAP32[i2 >> 2] = i1;
 } else HEAP32[i3 >> 2] = i4 << 1;
 i5 = i5 + 180 | 0;
 i4 = (i6 << 2) + -1 | 0;
 i4 = i4 >>> 16 | i4;
 i4 = i4 >>> 8 | i4;
 i4 = i4 >>> 4 | i4;
 i4 = i4 >>> 2 | i4;
 i4 = (i4 >>> 1 | i4) + 1 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i6 = i6 >>> 0 < i4 >>> 0 ? i4 : i6;
 HEAP32[i5 >> 2] = i1 >>> 0 < i6 >>> 0 ? i1 : i6;
 return;
}

function __ZN15SerializeTraitsI31ArrayOfManagedObjectsTransfererE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP8[i4 + 4 >> 0] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i5;
 HEAP32[i4 + 16 >> 2] = -1;
 HEAP32[i4 >> 2] = HEAP32[i1 + 8 >> 2];
 __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI23ManagedObjectTransfererEEvRT_17TransferMetaFlags(i2, i4, 0);
 STACKTOP = i3;
 return;
}

function __ZN12NavMeshAgent11SetAreaMaskEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i1 + 96 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i4;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i3);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i3);
 STACKTOP = i4;
 return;
}

function ___ptsname_r(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 16 | 0;
 i8 = i7;
 i5 = i7 + 20 | 0;
 i2 = (i4 | 0) == 0 ? 0 : i1;
 HEAP32[i8 >> 2] = i3;
 HEAP32[i8 + 4 >> 2] = -2147199952;
 HEAP32[i8 + 8 >> 2] = i5;
 i1 = ___syscall54(54, i8 | 0) | 0;
 if (!i1) {
  HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
  i1 = (_snprintf(i4, i2, gb + 1073904 | 0, i6) | 0) >>> 0 < i2 >>> 0;
  i1 = i1 ? 0 : 34;
 } else i1 = 0 - i1 | 0;
 STACKTOP = i7;
 return i1 | 0;
}

function __ZZN2UI6Canvas15InitializeClassEvEN39FunctorImpl_1284kCanvasHierarchyChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i2 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + 224 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 4;
  __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv(i4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 if (!(HEAP8[i3 + 33 >> 0] | 0)) return;
 __ZN2UI6Canvas19SyncTransformParentEv(i3);
 return;
}

function __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK8GUIStyle34GetNumCharactersThatFitWithinWidthERK11UTF16Stringf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 + 208 >> 2] | 0;
 i5 = HEAP32[i1 + 212 >> 2] | 0;
 i6 = __ZN13TextRendering17GetITextRenderingEv() | 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 f3 = Math_fround(f3 - Math_fround(i5 + i4 | 0));
 i4 = HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0;
 i5 = __ZNK8GUIStyle14GetCurrentFontEv(i1) | 0;
 i6 = mftCall_iiiifii(i4 | 0, i6 | 0, i5 | 0, i2 | 0, +f3, HEAP32[i1 + 284 >> 2] | 0, HEAP32[i1 + 288 >> 2] | 0) | 0;
 return i6 | 0;
}

function __ZNK5Umbra14TomeCollection13findGateIndexEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? 0 : i1 + i3 | 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i2 | 0) > 0) i1 = 0; else {
  i4 = -1;
  return i4 | 0;
 }
 while (1) {
  if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN5physx8debugger4comm21CreatePropertyMessage9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 28 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 1) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 1) | 0;
 do {
  HEAP16[i1 >> 1] = HEAP16[i5 >> 1] | 0;
  i1 = i1 + 2 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVENS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERKNSB_5Vec3VESK_RSF_RSI_SM_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5Umbra13MatrixFactory7rotateZEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 HEAP32[i1 + 12 >> 2] = 0;
 i5 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 f4 = Math_fround(-f3);
 HEAPF32[i1 >> 2] = f2;
 HEAPF32[i1 + 16 >> 2] = f4;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAPF32[i1 + 4 >> 2] = f3;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 return;
}

function __ZN5Umbra13MatrixFactory7rotateXEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 HEAP32[i1 + 12 >> 2] = 0;
 i5 = i1 + 28 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 f4 = Math_fround(-f3);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = f2;
 HEAPF32[i1 + 36 >> 2] = f4;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i1 + 24 >> 2] = f3;
 HEAPF32[i1 + 40 >> 2] = f2;
 return;
}

function __ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i3 >> 2] = HEAP32[(HEAP32[i2 + 316 >> 2] | 0) + 20 >> 2];
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 860470;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System19getRecordNumDriversEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i3) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  HEAP32[i3 >> 2] = 1;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 870248;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187296 + 8;
 i4 = __Znwj(192) | 0;
 __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i4, i2);
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i4 + 88 >> 2] = i3;
 HEAP8[i4 + 188 >> 0] = 1;
 return;
}

function __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 4 | 0;
 HEAP32[i6 >> 2] = i3;
 __Z6FormatPKcz(i5, gb + 913694 | 0, i6);
 __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2, i5);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i4;
 return;
}

function __ZN22BuiltinResourceManager13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP8[gb + 1546595 >> 0] = 0;
 i1 = HEAP32[gb + 1162852 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -24 - i3 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i2);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1162852 >> 2] = 0;
 return;
}

function __ZN12HandlerChain8SetFlagsER13FileEntryDatajj(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = 0;
  return i6 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i1 + 52 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags(i2, i1 + 52 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10AudioMixer20GetGroupPathFromGUIDERK9UnityGUID(i4, i2, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
  if (!i1) {
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
   HEAP32[i4 + 8 >> 2] = 0;
   __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i4, gb + 1576256 | 0, 0);
   return;
  }
 }
 __ZN5audio5mixer20GetGroupPathFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID(i4, i1, i5);
 return;
}

function __Z41ParticleSystem_Get_Custom_PropScalingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return __ZNK14ParticleSystem14GetScalingModeEv(i2) | 0;
 return 0;
}

function __Z38ParticleSystem_Get_Custom_PropIsPausedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem8IsPausedEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z21IsValidFileNameSymbolc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[gb + 70304 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, i4, _strlen(i4) | 0);
 i1 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i3, i1, 0) | 0) == -1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__217__assoc_sub_state10__sub_waitERNS_11unique_lockINS_5mutexEEE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = i1 + 88 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 L1 : do if (!(i2 & 4)) {
  if (i2 & 8 | 0) {
   HEAP32[i5 >> 2] = i2 & -9;
   __ZNSt3__211unique_lockINS_5mutexEE6unlockEv(i4);
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
   break;
  }
  i3 = i1 + 40 | 0;
  i1 = i2;
  while (1) {
   if (i1 & 4 | 0) break L1;
   __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i3, i4);
   i1 = HEAP32[i5 >> 2] | 0;
  }
 } while (0);
 return;
}

function __ZN8GUIState8EndOnGUIEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 i3 = i3 + 340 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 return;
}

function __ZN5physx3Ext7D6Joint13setTwistLimitERKNS_23PxJointAngularLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 120 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP8[i2 + 85 >> 0] = 1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 833930;
 HEAP32[i1 + 4 >> 2] = 530;
 HEAP32[i1 + 8 >> 2] = fb + 62;
 HEAP32[i1 + 12 >> 2] = fb + 28;
 HEAP32[i1 + 16 >> 2] = gb + 833940;
 HEAP32[i1 + 20 >> 2] = 531;
 HEAP32[i1 + 24 >> 2] = fb + 637;
 HEAP32[i1 + 28 >> 2] = fb + 552;
 HEAP32[i1 + 32 >> 2] = gb + 833952;
 HEAP32[i1 + 36 >> 2] = 532;
 HEAP32[i1 + 40 >> 2] = fb + 2408;
 HEAP32[i1 + 44 >> 2] = fb + 3939;
 HEAP32[i1 + 48 >> 2] = gb + 833962;
 HEAP32[i1 + 52 >> 2] = 533;
 HEAP32[i1 + 56 >> 2] = fb + 638;
 HEAP32[i1 + 60 >> 2] = fb + 553;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!(HEAP32[i4 + 284 >> 2] & 4096)) i1 = i4 + 108 | 0; else i1 = (HEAP32[i4 + 56 >> 2] | 0) + 268 | 0;
 HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i4, i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN5physx13GuMeshFactory17removeHeightFieldERNS_13PxHeightFieldE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i2 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 88 | 0, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN18PlatformEffector2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 156480 + 8;
 STACKTOP = i4;
 return;
}

function __ZN13SpringJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 157672 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12TreeDatabase9Prototype17MainThreadCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 128 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i4 + 116 | 0;
  i1 = 0;
  do {
   __Z19DestroySingleObjectP6Object(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i3 = i4 + 88 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i2 = i4 + 76 | 0;
 i1 = 0;
 do {
  __Z19DestroySingleObjectP6Object(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z44ComputeShader_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   HEAP32[i4 >> 2] = i2;
   __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv(i5, i4, 16, i3) | 0;
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38ParticleSystem_CUSTOM_Internal_IsAliveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem7IsAliveEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z38Matrix4x4_CUSTOM_INTERNAL_CALL_InverseRK10Matrix4x4fRS_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4;
 i2 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 __Z20InvertMatrix4x4_FullPKfPf(i4, i4) | 0;
 i5 = i3;
 i1 = i4;
 i2 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 STACKTOP = i6;
 return;
}

function __Z36Matrix4x4_CUSTOM_INTERNAL_CALL_OrthoffffffR10Matrix4x4f(f4, f5, f6, f7, f8, f9, i1) {
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i10 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i10;
 __ZN10Matrix4x4f8SetOrthoEffffff(i2, f4, f5, f6, f7, f8, f9) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i10;
 return;
}

function __Z35ParticleSystemRenderer_RenderMeshesRK15RenderNodeQueuejRK14ChannelAssignsi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 16 | 0;
 i6 = i5;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i4;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = 1;
 HEAP8[i6 + 8 >> 0] = 1;
 HEAP32[i6 + 12 >> 2] = 0;
 __Z43ParticleSystemRenderer_RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns(i1, i6, i3);
 STACKTOP = i5;
 return;
}

function _setkey(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 i6 = 0;
 while (1) {
  i4 = i7 + i6 | 0;
  HEAP8[i4 >> 0] = 0;
  i2 = 7;
  i3 = i1;
  i5 = 0;
  while (1) {
   i5 = ((HEAPU8[i3 >> 0] | 0) & 1) << i2 | i5 & 255;
   HEAP8[i4 >> 0] = i5;
   if ((i2 | 0) <= 0) break; else {
    i2 = i2 + -1 | 0;
    i3 = i3 + 1 | 0;
   }
  }
  i6 = i6 + 1 | 0;
  if ((i6 | 0) == 8) break; else i1 = i1 + 8 | 0;
 }
 ___des_setkey(i7, gb + 1469560 | 0);
 STACKTOP = i8;
 return;
}

function __ZNSt3__28ios_base5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i5 = i1 + 28 | 0;
 __ZNSt3__26localeC2ERKS0_(i3, i5);
 __ZNSt3__26localeaSERKS0_(i5, i2) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4506 | 0, i1 | 0, 1);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i5 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__26localeD2Ev(i3);
  ___resumeException(i5 | 0);
 } else {
  STACKTOP = i4;
  return HEAP32[i3 >> 2] | 0;
 }
 return 0;
}

function __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwe(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i5 = mftCall_iiiiiid(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, +d6) | 0;
 STACKTOP = i7;
 return i5 | 0;
}

function __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEce(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 var i7 = 0, i8 = 0, i9 = 0, i10 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7 + 4 | 0;
 i10 = i7;
 i9 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i8 >> 2] = HEAP32[i10 >> 2];
 i5 = mftCall_iiiiiid(i9 | 0, i1 | 0, i8 | 0, i3 | 0, i4 | 0, i5 | 0, +d6) | 0;
 STACKTOP = i7;
 return i5 | 0;
}

function __ZNK9AudioClip9GetLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  i2 = HEAP32[i1 + 124 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP32[i2 + 44 >> 2] | 0) {
    f3 = Math_fround(0.0);
    i2 = ~~f3 >>> 0;
    return i2 | 0;
   }
   i1 = HEAP32[i1 + 56 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   f3 = Math_fround(__ZNK14SoundHandleAPI11GetLengthMSEv(i1));
   i2 = ~~f3 >>> 0;
   return i2 | 0;
  }
 }
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 48 >> 2]) * Math_fround(1.0e3));
 i2 = ~~f3 >>> 0;
 return i2 | 0;
}

function __ZN8Renderer10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 300 | 0;
 if ((HEAP32[i3 >> 2] | 0) == 1) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy(i1 + 288 | 0, 1, i2, 1);
 i2 = i1 + 218 | 0;
 i5 = HEAP32[i3 >> 2] & 65535;
 i3 = HEAP16[i2 >> 1] | 0;
 HEAP16[i2 >> 1] = (i5 & 65535) < (i3 & 65535) ? i5 : i3;
 __ZN8Renderer13BoundsChangedEv(i1);
 STACKTOP = i4;
 return;
}

function __ZN5physx8debugger14PvdMarshallingItfE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround((HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5Unity11SpringJointC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN5Unity5JointC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 113708 + 8;
 STACKTOP = i4;
 return;
}

function __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i6, i2 + 4 | 0, i3);
 __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i6, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i5;
 return;
}

function __ZN22VertexDeclarationCacheD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 41128 + 8;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 20 | 0, HEAP32[i1 + 24 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1 + 4 | 0, HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
 i1 = i1 + 44 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
 }
 if (!i6) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14TerrainManager27UnloadTerrainsFromGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = i1 + 4 | 0;
 i1 = i2;
 if ((i1 | 0) == (i5 | 0)) return;
 do {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  i4 = i2 + 240 | 0;
  if (HEAP32[i4 >> 2] | 0) {
   i3 = i2 + 228 | 0;
   i2 = 0;
   do {
    __ZN15TerrainRenderer19UnloadFromGfxDeviceEv(HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 * 20 | 0) + 4 >> 2] | 0);
    i2 = i2 + 1 | 0;
   } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN13RuntimeStaticI21AssetReferenceStorageE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(56, i3, i4, gb + 1041912 | 0, 65) | 0;
  __ZN21AssetReferenceStorageC2Ev(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(56, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  __ZN21AssetReferenceStorageC2Ev(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __Z40ParticleSystem_Get_Custom_PropRandomSeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return __ZNK14ParticleSystem13GetRandomSeedEv(i2) | 0;
 return 0;
}

function __Z23GUI_CUSTOM_FocusControlP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 i1 = __Z11GetGUIStatev() | 0;
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __ZN8GUIState20FocusKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZNK8Animator14IsInTransitionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZNK26AnimatorControllerPlayable14IsInTransitionEi(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2) | 0;
 return i4 | 0;
}

function __ZN5physx7NpScene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(i2 + 32 | 0, i1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 573, gb + 708093 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx7NpScene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i3 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh(i3 + 32 | 0, i1, i2);
  STACKTOP = i4;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 599, gb + 707997 | 0, i4);
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx30PxParticleFluidGeneratedValuesC2EPKNS_15PxParticleFluidE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx29PxParticleBaseGeneratedValuesC2EPKNS_14PxParticleBaseE(i2, i1);
 HEAPF32[i2 + 116 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 120 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 124 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 128 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 765184;
 HEAP32[i1 + 4 >> 2] = 505;
 HEAP32[i1 + 8 >> 2] = fb + 443;
 HEAP32[i1 + 12 >> 2] = fb + 382;
 HEAP32[i1 + 16 >> 2] = gb + 741403;
 HEAP32[i1 + 20 >> 2] = 506;
 HEAP32[i1 + 24 >> 2] = fb + 444;
 HEAP32[i1 + 28 >> 2] = fb + 383;
 HEAP32[i1 + 32 >> 2] = gb + 742656;
 HEAP32[i1 + 36 >> 2] = 509;
 HEAP32[i1 + 40 >> 2] = fb + 445;
 HEAP32[i1 + 44 >> 2] = fb + 384;
 HEAP32[i1 + 48 >> 2] = gb + 743223;
 HEAP32[i1 + 52 >> 2] = 510;
 HEAP32[i1 + 56 >> 2] = fb + 2170;
 HEAP32[i1 + 60 >> 2] = fb + 3565;
 return;
}

function __ZN5Unity11SpringJoint9SetSpringEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i4 ? Math_fround(340282326000000008404918.0e15) : f1;
 i4 = i2 + 104 | 0;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f1;
 i2 = i2 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i4 >> 2]));
 return;
}

function __ZN5Unity11SpringJoint9SetDamperEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i4 ? Math_fround(340282326000000008404918.0e15) : f1;
 i4 = i2 + 108 | 0;
 HEAPF32[i4 >> 2] = i3 ? Math_fround(0.0) : f1;
 i2 = i2 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0) | 0) & 1) return;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i4 >> 2]));
 return;
}

function __ZN5Umbra9Matrix2x26invertERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f3 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f4 * f7) - Math_fround(f6 * f5)));
 HEAPF32[i1 >> 2] = Math_fround(f7 * f3);
 HEAPF32[i1 + 4 >> 2] = Math_fround(-Math_fround(f6 * f3));
 HEAPF32[i1 + 8 >> 2] = Math_fround(-Math_fround(f5 * f3));
 HEAPF32[i1 + 12 >> 2] = Math_fround(f4 * f3);
 return i1 | 0;
}

function __ZN4File4ReadEPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i5;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 __ZN12FileAccessor4ReadEyPvPy(HEAP32[i1 + 4 >> 2] | 0, i3, 0, i2, i5) | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i1 = i2;
 i5 = _i64Add(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i3 | 0, HEAP32[i5 + 4 >> 2] | 0) | 0;
 i1 = getTempRet0() | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 4 >> 2] = i1;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN19SkinnedMeshRenderer26ClearCachedAnimatorBindingEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 408 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 __ZN6Object11RemoveEventEPFvPvS0_iES0_(i1, fb + 527 | 0, i3);
 i1 = i3 + 340 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = i3 + 384 | 0;
 i2 = i3 + 400 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 388 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 396 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN18AnimatorController13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i3 + 136 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i3 + 128 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i3 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE(i2, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0, i3 + 104 | 0) | 0;
 return;
}

function __ZN12_GLOBAL__N_118LegacySerialStream9writeNameEPKc(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!i3) i1 = 0; else if (!(HEAP8[i4 + 12 >> 0] | 0)) i1 = 0; else i1 = (_strlen(i3) | 0) + 1 | 0;
 HEAP32[i2 >> 2] = i1;
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i2 | 0, 4);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, i1 | 0);
 STACKTOP = i5;
 return;
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEEC2EPNS0_7SystemIEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7SetSizeEi(i1, i3);
 return;
}

function __Z51MaterialPropertyBlock_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z51MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z47MaterialPropertyBlock_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z47MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z47Input_CUSTOM_INTERNAL_CALL_GetAccelerationEventiR12Acceleration(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 8 | 0;
 if ((i1 | 0) > -1) if ((__Z20GetAccelerationCountv() | 0) > (i1 | 0)) {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  STACKTOP = i5;
  return;
 }
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536761 | 0, i4);
}

function __Z36ComputeBuffer_CUSTOM_InternalSetDataP12Il2CppObjectP11Il2CppArrayi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0;
   __ZN13ComputeBuffer7SetDataEPKvj(i1, i4, Math_imul(__Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0, i3) | 0);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z27MonoBehaviour_CUSTOM_InvokeP12Il2CppObjectP12Il2CppStringf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 __ZN11ICallStringC2EP12Il2CppString(i4, i2);
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z13InvokeDelayedR13MonoBehaviourR11ICallStringff(i2, i4, f3, Math_fround(0.0));
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _getcwd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i3 = i6 + 8 | 0;
 if (!i1) {
  i2 = 4096;
  i1 = i3;
  i5 = 4;
 } else if (!i2) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 } else i5 = 4;
 if ((i5 | 0) == 4) {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  if ((___syscall_ret(___syscall183(183, i4 | 0) | 0) | 0) < 0) i1 = 0; else if ((i1 | 0) == (i3 | 0)) i1 = mftCall_ii(fb + 1576 | 0, i3 | 0) | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function ___toread(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 74 | 0;
 i3 = HEAP8[i1 >> 0] | 0;
 HEAP8[i1 >> 0] = i3 + 255 | i3;
 i1 = i2 + 20 | 0;
 i3 = i2 + 44 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > (HEAP32[i3 >> 2] | 0) >>> 0) mftCall_iiii(HEAP32[i2 + 36 >> 2] | 0, i2 | 0, 0, 0) | 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(i1 & 20)) {
  i1 = HEAP32[i3 >> 2] | 0;
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 + 4 >> 2] = i1;
  i1 = 0;
 } else if (!(i1 & 4)) i1 = -1; else {
  HEAP32[i2 >> 2] = i1 | 32;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i4 + 12 | 0;
 i7 = i4 + 16 | 0;
 i3 = 0;
 while (1) {
  if ((i3 | 0) >= (i5 | 0)) break;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i2 + 1;
   i2 = HEAP8[i2 >> 0] | 0;
  } else {
   i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0) | 0;
   if ((i2 | 0) == -1) break;
   i2 = i2 & 255;
  }
  HEAP8[i1 >> 0] = i2;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 return i3 | 0;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatBGR888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU16[i1 >> 1] | 0;
  i6 = i3 << 5 & 64512;
  i5 = i3 << 3;
  HEAP8[i4 >> 0] = i3 >>> 2 & 7 | i5;
  HEAP8[i4 + 1 >> 0] = (i6 >>> 6 & 768 | i6) >>> 8;
  HEAP8[i4 + 2 >> 0] = (i5 & 458752 | i3 << 8 & 16252928) >>> 16;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm16SetPropertyValue9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 28 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 32 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 36 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx13GuMeshFactory16removeConvexMeshERNS_12PxConvexMeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i2 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i5 >> 2] = i1;
 i2 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 48 | 0, i5) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN2UI6Canvas25UpdateCanvasPlaneDistanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[i1 + 408 >> 2] = HEAP32[i1 + 364 >> 2];
 if (HEAP32[i1 + 344 >> 2] | 0) {
  STACKTOP = i3;
  return;
 }
 i4 = HEAP32[gb + 1467948 >> 2] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = fb + 1103;
 __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i5, i4, i2);
 i2 = i1 + 224 | 0;
 HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 6;
 STACKTOP = i3;
 return;
}

function __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i1 = i1 + 192 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = i3;
 if (!i3) return;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZN13TargetJoint2D9SetAnchorERK8Vector2f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 if (!(HEAP32[i2 + 60 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0);
 return;
}

function __ZN13AnimationClip17MainThreadCleanupEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (i1 | 0) mftCall_vii(i1 | 0, 0, i4 + 80 | 0);
 i2 = i4 + 80 | 0;
 i3 = i4 + 84 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i5 = i1 + 4 | 0;
  i6 = i1;
  i1 = HEAP32[i5 >> 2] | 0;
  HEAP32[i6 >> 2] = 0;
  HEAP32[i5 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 + 80 >> 2] = i2;
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i4, gb + 1105836 | 0);
 __ZN6Motion17MainThreadCleanupEv(i4);
 return;
}

function __ZN12_GLOBAL__N_119PvdConnectionReaderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 148220 + 8;
 HEAP8[i1 + 20 >> 0] = 0;
 i2 = i1 + 4 | 0;
 __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv(HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 HEAP32[i1 >> 2] = gb + 86828 + 8;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN12MeshRenderer17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 352 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 356 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 364 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN8Renderer17MainThreadCleanupEv(i3);
  return;
 }
 i4 = i3 + 368 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Renderer17MainThreadCleanupEv(i3);
 return;
}

function __ZN10AudioMixer19GetFMODChannelGroupERK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (__ZN10AudioMixer18EnsureValidRuntimeEv(i1) | 0) {
  i2 = __ZN5audio5mixer16FindChannelGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID(HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 76 >> 2] | 0, i2) | 0;
  return i2 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 861553 | 0, 0, gb + 861578 | 0, 430, 1, 0, 0, 0);
  i2 = 0;
  return i2 | 0;
 }
 return 0;
}

function __Z36ComputeBuffer_CUSTOM_InternalGetDataP12Il2CppObjectP11Il2CppArrayi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 1) | 0;
   __ZN13ComputeBuffer7GetDataEPvj(i1, i4, Math_imul(__Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0, i3) | 0);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function _stbir_resize_uint16_generic(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i7, i1, i2, i8, i9, i10, i11, i12, i13, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i14, i15, i3, 1, i5, i5, i4, i4, i6) | 0;
}

function __ZNK6Camera6GetFovEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[i1 + 1087 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
  i2 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) {
   i3 = __Z14IsWorldPlayingv() | 0;
   i2 = HEAP32[i1 + 1108 >> 2] | 0;
   if (i3 & (i2 | 0) == 1 | (i2 | 0) == 8) {
    i3 = __Z12GetIVRDevicev() | 0;
    HEAPF32[i1 + 292 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0));
   }
  }
 }
 return Math_fround(HEAPF32[i1 + 292 >> 2]);
}

function __ZNK13WheelCollider10IsGroundedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 i3 = i1 + 148 | 0;
 if ((HEAP32[i3 >> 2] | 0) == -1) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP8[(HEAP32[i2 + 60 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) * 148 | 0) + 28 >> 0] | 0) == 0;
 return i3 | 0;
}

function __ZN6SpriteD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 45276 + 8;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 i2 = i1 + 136 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63744 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpScene12loadFromDescERKNS_11PxSceneDescE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i1 = 0; else if ((HEAP32[i4 + 3560 >> 2] & 2147483647) >>> 0 < i1 >>> 0) {
  __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i4 + 3552 | 0, i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZN5physx2Sc5Scene11preAllocateEjjjjj(i4 + 32 | 0, i1, HEAP32[i3 + 52 >> 2] | 0, HEAP32[i3 + 56 >> 2] | 0, HEAP32[i3 + 60 >> 2] | 0, HEAP32[i3 + 64 >> 2] | 0);
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 128 >> 2];
 return 1;
}

function __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3 + 32 | 0;
 i7 = i3 + 24 | 0;
 i4 = i3 + 8 | 0;
 i5 = i3;
 HEAP32[i7 >> 2] = __Z4loadPKf(i2) | 0;
 __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv(i6, i7);
 __ZN8Scalar4faSERKS_(i1, i6) | 0;
 HEAP32[i5 >> 2] = __Z4loadPKf(i2 + 12 | 0) | 0;
 __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv(i4, i5);
 __ZN8Scalar4faSERKS_(i1 + 16 | 0, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn8MetaDataC2ERNS0_5ConvXE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i2 + 4 | 0;
 i1 = i2 + 40 | 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 return;
}

function __ZN5physx2Sc9ClothCore20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i3 | 0, i1 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
  _memcpy(i1 | 0, i2 | 0, (HEAP32[i3 + 4 >> 2] | 0) - i1 | 0) | 0;
  STACKTOP = i4;
  return;
 }
}

function __ZN17CapsuleCollider2D12SetDirectionENS_16CapsuleDirectionE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 168 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN10Collider2D19WakeAllBodyContactsEv(i3);
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i3, i2);
  if (!i2) return;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, 0);
  return;
 }
 __ZN10Collider2D7CleanupEb(i3, 0);
 return;
}

function __ZN13UnityProfiler22EndFrameSeparateThreadEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i5) return;
 __ZN22UnityProfilerPerThread8EndFrameEv(i5);
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i4 = 4; else if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) i4 = 5; else i4 = 4;
 if ((i4 | 0) == 4) {
  i1 = HEAP32[i2 + 12 >> 2] | 0;
  if (i1 | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) i4 = 5;
 }
 if ((i4 | 0) == 5) __ZNK22UnityProfilerPerThread15SaveToFrameDataER17ProfilerFrameData(i5, i1);
 __ZN22UnityProfilerPerThread10ClearFrameEv(i5);
 return;
}

function __Z8allEqualRK8Scalar4fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 4 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 8 >> 2]))) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i2 = f3 == Math_fround(HEAPF32[i2 + 12 >> 2]);
 i2 = i2 & 1;
 return i2 | 0;
}

function __Z50MaterialPropertyBlock_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i4 + 8 >> 2] | 0;
 i4 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4);
 STACKTOP = i6;
 return;
}

function __Z46MaterialPropertyBlock_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i4) | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i4, i3);
 STACKTOP = i6;
 return;
}

function __Z40Matrix4x4_CUSTOM_INTERNAL_CALL_TransposeRK10Matrix4x4fRS_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4;
 i2 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 __ZN10Matrix4x4f9TransposeEv(i4) | 0;
 i5 = i3;
 i1 = i4;
 i2 = i5 + 64 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 STACKTOP = i6;
 return;
}

function __Z34ParticleSystem_Get_Custom_PropLoopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return (__ZNK14ParticleSystem7GetLoopEv(i2) | 0) & 1 | 0;
 return 0;
}

function __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i8;
 if (!i6) {
  STACKTOP = i8;
  return;
 } else i1 = 0;
 do {
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i2, i3 + (i1 << 6) | 0, i7);
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i7, i4 + (i1 << 6) | 0, i5 + (i1 << 6) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i6 | 0));
 STACKTOP = i8;
 return;
}

function _stbir_resize_uint8_generic(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i7, i1, i2, i8, i9, i10, i11, i12, i13, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i14, i15, i3, 0, i5, i5, i4, i4, i6) | 0;
}

function _stbir_resize_float_generic(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(i7, i1, i2, i8, i9, i10, i11, i12, i13, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i14, i15, i3, 3, i5, i5, i4, i4, i6) | 0;
}

function __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEcj(i2, i5, i4) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (i1 >>> 0 > i4 >>> 0) {
  i3 = i2 + i1 | 0;
  i1 = i2 + i4 | 0;
  while (1) {
   if ((i1 | 0) == (i3 | 0)) {
    i1 = -1;
    break L5;
   }
   if ((HEAP8[i1 >> 0] | 0) != i5 << 24 >> 24) break;
   i1 = i1 + 1 | 0;
  }
  i1 = i1 - i2 | 0;
 } else i1 = -1; while (0);
 return i1 | 0;
}

function __ZNK13RenderTexture12FitGivenRectERiS0_S0_S0_(i4, i1, i3, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) < 0) {
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i2;
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) < 0) {
  HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + i1;
  HEAP32[i3 >> 2] = 0;
 }
 i1 = HEAP32[i4 + 80 >> 2] | 0;
 if ((HEAP32[i5 >> 2] | 0) > (i1 | 0)) HEAP32[i5 >> 2] = i1;
 i1 = HEAP32[i4 + 84 >> 2] | 0;
 if ((HEAP32[i6 >> 2] | 0) <= (i1 | 0)) return;
 HEAP32[i6 >> 2] = i1;
 return;
}

function __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (!i2) {
  HEAP32[i1 >> 2] = i4;
  HEAP32[i3 + 24 >> 2] = i5;
  HEAP32[i3 + 36 >> 2] = 1;
 } else {
  if ((i2 | 0) != (i4 | 0)) {
   i5 = i3 + 36 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
   HEAP32[i3 + 24 >> 2] = 2;
   HEAP8[i3 + 54 >> 0] = 1;
   break;
  }
  i1 = i3 + 24 | 0;
  if ((HEAP32[i1 >> 2] | 0) == 2) HEAP32[i1 >> 2] = i5;
 } while (0);
 return;
}

function __ZN5physx9NpPhysics11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtbNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i1, i2, i5, i4, i3, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i8 = HEAP32[gb + 1457204 >> 2] | 0;
 HEAP8[i7 >> 0] = HEAP8[i6 >> 0] | 0;
 i6 = __ZN5physx9NpFactory11createShapeERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKPNS_10PxMaterialEtb(i8, i2, i7, i5, i4, i3) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i3 + 1296 | 0;
 __ZN5physx20PxsParticleSystemSim20remapShapesToPacketsEPKPNS_16PxvParticleShapeEj(i3, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 1300 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD6System17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i6 = 0;
  STACKTOP = i4;
  return i6 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861077;
 _printf(gb + 853184 | 0, i3) | 0;
 i6 = 36;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZN4FMOD6System13getNumDriversEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i3) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  HEAP32[i3 >> 2] = 1;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861161;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD6System11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i2 + 372 >> 2] = i3;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 859083;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN11TypeManager7Builder18TraverseDepthFirstERKNS0_4NodeEj(i4, i5, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i5 + 4 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = 1; else {
  i2 = i1;
  i1 = 1;
  i3 = HEAP32[i4 >> 2] | 0;
  do {
   i1 = (__ZN11TypeManager7Builder18TraverseDepthFirstERKNS0_4NodeEj(i4, i3 + (i2 * 12 | 0) | 0, i1 + i6 | 0) | 0) + i1 | 0;
   i3 = HEAP32[i4 >> 2] | 0;
   i2 = HEAP32[i3 + (i2 * 12 | 0) + 8 >> 2] | 0;
  } while ((i2 | 0) != -1);
 }
 i5 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 + 24 >> 2] = i6;
 HEAP32[i5 + 28 >> 2] = i1;
 return i1 | 0;
}

function __ZN11IMGUIModule21ClearDeveloperConsoleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[gb + 1468316 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i2 = i1 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i5 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11UTF16StringD2Ev(i5 + 20 | 0);
  __ZdlPv(i5);
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN10Collider2D12LayerChangedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 if ((HEAP16[gb + 1458004 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1458004 | 0, i1);
  i1 = gb + 1458004 | 0;
 } else i1 = 0;
 __ZN10Collider2D19RecalculateContactsEv(i3);
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __Z12profiler_endP19ProfilerInformation(i1);
 STACKTOP = i4;
 return;
}

function __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetPositionR9HPlayableRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  STACKTOP = i4;
  return;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 __ZN23AnimationOffsetPlayable11SetPositionE8Vector3f(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z33UnityAdsSettings_CUSTOM_SetGameIdiP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i2);
 i2 = __Z19GetUnityAdsSettingsv() | 0;
 __ZNK11ICallString6ToUTF8Ev(i4, i5);
 __ZN16UnityAdsSettings9SetGameIdE15RuntimePlatformRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i2, i1, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z25PlayerPrefs_CUSTOM_GetIntP12Il2CppStringi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 i2 = __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i4, i2) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 mftCall_viiii(i7 | 0, i1 | 0, i2 | 0, i6 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 mftCall_viiii(i7 | 0, i1 | 0, i2 | 0, i6 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZNK9Heightmap14GetPatchRegionEiRiS0_S0_(i1, i2, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i9 = 0;
 i5 = HEAP32[i1 + 80 >> 2] | 0;
 if ((i5 | 0) < 0) return; else i4 = 0;
 while (1) {
  i1 = i5 - i4 | 0;
  i3 = 1 << i1;
  i1 = i3 << i1;
  if ((i2 | 0) < (i1 | 0)) break;
  if ((i5 | 0) > (i4 | 0)) {
   i4 = i4 + 1 | 0;
   i2 = i2 - i1 | 0;
  } else {
   i9 = 5;
   break;
  }
 }
 if ((i9 | 0) == 5) return;
 HEAP32[i6 >> 2] = (i2 | 0) % (i3 | 0) | 0;
 HEAP32[i7 >> 2] = (i2 | 0) / (i3 | 0) | 0;
 HEAP32[i8 >> 2] = i3;
 return;
}

function __ZNK5physx2Cm10Collection10getObjectsEPPNS_6PxBaseEjj(i1, i5, i3, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i6 = 0;
 i4 = HEAP32[i1 + 48 >> 2] | 0;
 i1 = HEAP32[i1 + 80 >> 2] | 0;
 if (!((i3 | 0) != 0 & i1 >>> 0 > i2 >>> 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = 0 - i3 | 0;
 i6 = i2 + 1 | 0;
 i1 = i2 - (i1 >>> 0 > i6 >>> 0 ? i1 : i6) | 0;
 i1 = 0 - (i1 >>> 0 < i3 >>> 0 ? i3 : i1) | 0;
 i3 = 0;
 while (1) {
  HEAP32[i5 + (i3 << 2) >> 2] = HEAP32[i4 + (i2 << 4) >> 2];
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i1 | 0)) break; else i2 = i2 + 1 | 0;
 }
 return i1 | 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatABGR8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i7 = HEAPU16[i1 >> 1] | 0;
  i6 = i7 << 12;
  i3 = i6 & 15728640;
  i5 = i7 << 8 & 61440;
  HEAP32[i4 >> 2] = i7 << 4 & 240 | i7 & 15 | i5 | i7 << 16 & -268435456 | i6 & 251658240 | i3 | i5 >>> 4 | i3 >>> 4;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx3Cct26CharacterControllerManager18getObstacleContextEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((HEAP32[i2 + 120 >> 2] | 0) >>> 0 > i1 >>> 0) {
  i2 = HEAP32[(HEAP32[i2 + 116 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 4, gb + 657349 | 0, 198, gb + 658332 | 0, i3);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZN19CullingGroupManager15InitializeClassEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63600 | 0, 16, gb + 385081 | 0, 61) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[gb + 1114352 >> 2] = i2;
 STACKTOP = i1;
 return;
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
 i1 = i1 + 160 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4); else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
 }
 if (!i6) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12AdsIdHandler31ExecuteAsyncFetchAdsIdJobStaticEPv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP8[i3 + 41 >> 0] = 0;
 HEAP32[i3 + 44 >> 2] = 1;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i1 & 255;
 i2 = i3 + 40 | 0;
 if (!i1) {
  HEAP8[i2 >> 0] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 1;
  HEAPF32[i3 + 36 >> 2] = Math_fround(+__Z19GetTimeSinceStartupv());
  __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3300 | 0, i3);
  __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv(i3);
  return;
 }
}

function __ZN11CustomArray10CheckArrayEm(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i4 = i7 + 12 | 0;
 if (((HEAP32[i7 + 8 >> 2] | 0) + i1 | 0) >>> 0 <= (HEAP32[i4 >> 2] | 0) >>> 0) return i6 | 0;
 i5 = __Znwj(16) | 0;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 if (!i7) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = 1;
  i1 = HEAP32[i4 >> 2] << 1;
 }
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i3 >> 2] = __Znaj(i1) | 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i6 >> 2] = i5;
 if (!i2) return i6 | 0;
 HEAP32[i7 >> 2] = i5;
 return i6 | 0;
}

function __ZN11BoxCollider17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 88 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i2 = i3 + 108 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN8Collider17MainThreadCleanupEv(i3);
  return;
 }
 i4 = i3 + 112 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Collider17MainThreadCleanupEv(i3);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 11 >> 0] = 10;
 i4 = i3;
 i2 = i4 + 10 | 0;
 do {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i4 = i4 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP8[i3 + 10 >> 0] = 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZL44UnityAudioEffect_InternalSetPositionCallbackP14FMOD_DSP_STATEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i1 >> 2] | 0, i2) | 0;
 if (!i1) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i1 = 36; else {
   i1 = HEAP32[(HEAP32[i2 + 112 >> 2] | 0) + 176 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = (mftCall_iii(i1 | 0, i2 | 0, i3 | 0) | 0) == 0;
    i1 = i1 ? 0 : 80;
   }
  }
 }
 STACKTOP = i4;
 return i1 | 0;
}

function __Z43DownloadHandler_CUSTOM_InternalCreateBufferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(40, gb + 63808 | 0, 16, gb + 1027567 | 0, 46) | 0;
 __ZN21DownloadHandlerBufferC2Ev(i2);
 HEAP32[i1 + 8 >> 2] = i2;
 i3 = i2 + 4 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z38AssetBundle_CUSTOM_LoadFromMemoryAsyncP11Il2CppArrayj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 i4 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 i1 = __Znwj(192) | 0;
 __ZN39AssetBundleLoadFromMemoryAsyncOperationC2Ev(i1);
 HEAP32[i1 + 88 >> 2] = i2;
 __ZN39AssetBundleLoadFromMemoryAsyncOperation7ExecuteEPKhj(i1, i4, i3);
 i2 = _il2cpp_object_new(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 28 >> 2] | 0) | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return i2 | 0;
}

function __Z35ParticleSystem_CUSTOM_Internal_PlayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem4PlayEb(i2, 1);
  return 0;
 }
 return 0;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwner5writeEPKhj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 i3 = i1 + -8 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i4 = 1;
  return i4 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i4 = i2;
 return i4 | 0;
}

function __ZNSt3__217__libcpp_sscanf_lEPKcP15__locale_structS1_z(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i2;
 i2 = _uselocale(i1) | 0;
 i1 = _vsscanf(i3, i4, i6) | 0;
 if (i2 | 0) {
  __THREW__ = 0;
  invoke_ii(fb + 2805 | 0, i2 | 0) | 0;
  i6 = __THREW__;
  __THREW__ = 0;
  if (i6 & 1) {
   i6 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i6);
  }
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jRKS4_(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i2 = i1 << 24 >> 24 < 0;
 i1 = i2 ? HEAP32[i4 + 4 >> 2] | 0 : i1 & 255;
 if (i1 >>> 0 < i5 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i3); else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, (i2 ? HEAP32[i4 >> 2] | 0 : i4) + i5 | 0, i1 - i5 | 0);
  return;
 }
}

function __ZNK5physx2Sn12PointerRemap12getObjectRefEyRj(i1, i2, i3, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i4) {
  i7 = 0;
  return i7 | 0;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  i8 = i5 + (i1 << 4) | 0;
  if ((HEAP32[i8 >> 2] | 0) == (i2 | 0) ? (HEAP32[i8 + 4 >> 2] | 0) == (i3 | 0) : 0) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return i1 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 + (i1 << 4) + 8 >> 2];
 i8 = 1;
 return i8 | 0;
}

function __ZNK25ThreadsafeLinearAllocator22GetAllocatedMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2];
 i4 = HEAP32[i4 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 do {
  i5 = i3 + (i2 * 12 | 0) + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2];
  if ((HEAP32[i5 >> 2] | 0) > 0) {
   i5 = i3 + (i2 * 12 | 0) + 4 | 0;
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2];
   i1 = (HEAP32[i5 >> 2] | 0) + i1 | 0;
  }
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZN7mecanim9animation25DestroyBlendTreeWorkspaceEPNS0_18BlendTreeWorkspaceERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 8 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd10Foundation19AlignCheckAllocator28deregisterAllocationListenerERNS_20PxAllocationListenerE(i6, i4) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i7 = 0;
 i5 = i6 + 28 | 0;
 if (!(HEAP32[i5 >> 2] | 0)) return; else i3 = 0;
 while (1) {
  i2 = i6 + 8 + (i3 << 2) | 0;
  i3 = i3 + 1 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i4 | 0)) break;
  if (i3 >>> 0 >= i1 >>> 0) {
   i7 = 5;
   break;
  }
 }
 if ((i7 | 0) == 5) return;
 HEAP32[i2 >> 2] = HEAP32[i6 + 8 + (i1 + -1 << 2) >> 2];
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 return;
}

function __ZN5physx3Ext7D6Joint13setSwingLimitERKNS_16PxJointLimitConeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 148 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP8[i2 + 85 >> 0] = 1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 52 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i1 = i1 + 44 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -8388609;
 HEAP32[i4 >> 2] = -1;
 i1 = i2 + 36 | 0;
 i4 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 HEAP32[i1 >> 2] = i4;
 i1 = i2 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + (i3 << 2) >> 2] = HEAP32[i2 + (i4 << 2) >> 2];
 if (i3 >>> 0 >= i4 >>> 0) return;
 HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] | 0) + 52 >> 2] = i3;
 return;
}

function __ZN5Flare5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j(i2, 1);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i2 + 29 >> 0] = 0;
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(.5);
 HEAP32[i2 + 12 >> 2] = 1065353216;
 HEAP32[i2 + 16 >> 2] = 1065353216;
 HEAP32[i2 + 20 >> 2] = 1065353216;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i2 + 30 >> 0] = 1;
 HEAP8[i2 + 31 >> 0] = 1;
 HEAP8[i2 + 28 >> 0] = 1;
 HEAP8[i1 + 52 >> 0] = 1;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __ZN19ShaderPropertySheetD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i2 + 88 >> 2] | 0) > -1) {
  i1 = i2 + 72 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 76 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 52 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN19ShaderPropertySheetD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 33952 + 8;
 if ((HEAP32[i1 + 88 >> 2] | 0) > -1) {
  i2 = i1 + 72 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 76 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 52 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 56 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 48 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 32 >> 2] | 0, i1 + 36 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN15FrictionJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 155616 + 8;
 STACKTOP = i4;
 return;
}

function __ZN15DistanceJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 154996 + 8;
 STACKTOP = i4;
 return;
}

function __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 STACKTOP = i4;
 return;
}

function __ZN14SphereColliderC2E10MemLabelId18ObjectCreationMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i6;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN8ColliderC2E10MemLabelId18ObjectCreationMode(i1, i5, i3);
 HEAP32[i1 >> 2] = gb + 113484 + 8;
 STACKTOP = i4;
 return;
}

function __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 >>> 0 > 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407642 | 0, 0, gb + 406201 | 0, 939, 1, 0, 0, 0);
  return;
 }
 i3 = i1 + 100 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407669 | 0, 0, gb + 406201 | 0, 942, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN12HandlerChain11PushHandlerEP17FileSystemHandler(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 12 >> 2] | 0)) {
  __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 4 | 0, i3);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  STACKTOP = i6;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService13SessionHeader10SaveToFileER12FileAccessor(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 i1 = i6;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i4 = 0;
  i1 = i2;
 }
 i6 = __ZN12FileAccessor5WriteEyPKvPy(i5, i3, i4, i1, i6) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZN11LightProbes23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i2 = __ZN15GlobalCallbacks3GetEv() | 0;
 i3 = i2 + 38596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return; else i1 = 0;
 do {
  i4 = i2 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i2 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i4 >> 2] | 0); else mftCall_vi(HEAP32[i4 >> 2] | 0, HEAP32[i2 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalVectoriR8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 24 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __Z21GetShaderGlobalVectorN9ShaderLab16FastPropertyNameE(i4, i5);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __Z37TrailRenderer_Get_Custom_PropEndWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = HEAP32[i2 + 384 >> 2] | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i2 + 76 >> 2] | 0) + ((HEAP32[i2 + 88 >> 2] | 0) + -1 << 4) + 4 >> 2]);
  return Math_fround(f3 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 }
 return Math_fround(0.0);
}

function __Z36ParticleSystem_CUSTOM_Internal_PauseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem5PauseEv(i2);
  return 0;
 }
 return 0;
}

function __Z36ParticleSystem_CUSTOM_Internal_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 __ZN14ParticleSystem8SyncJobsEb(1);
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else {
  __ZN14ParticleSystem5ClearEv(i2);
  return 0;
 }
 return 0;
}

function __Z26Transfer_UnityEngineObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI9JSONWrite27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZNK14b2PolygonShape5CloneEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 152) | 0;
 HEAP32[i2 >> 2] = gb + 151728 + 8;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 2;
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 151644 >> 2];
 HEAP32[i2 + 148 >> 2] = 0;
 i3 = i2 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 i6 = i1 + 4 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 _memcpy(i3 | 0, i1 + 12 | 0, 140) | 0;
 return i2 | 0;
}

function __ZN9Behaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4);
 i1 = i1 + 32 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN8Animator12HasParameterEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i3) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i3) | 0) if (!(HEAP32[i4 >> 2] | 0)) {
  i3 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i4 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN26AnimatorControllerPlayable12HasParameterEi(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0, i2) | 0;
 return i4 | 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU16[i1 >> 1] | 0;
  i6 = i3 >>> 4 & 240;
  i5 = i3 << 8 & 61440;
  HEAP8[i4 >> 0] = i6 >>> 4 | i6;
  HEAP8[i4 + 1 >> 0] = (i5 >>> 4 | i5) >>> 8;
  HEAP8[i4 + 2 >> 0] = (i3 << 16 & 983040 | i3 << 20) >>> 16;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx3Scb14ParticleSystemC2ERKNS_11PxActorType4EnumEjb(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 i5 = i4 + 4 | 0;
 HEAP32[i5 >> 2] = 0;
 __ZN5physx2Sc18ParticleSystemCoreC2ERKNS_11PxActorType4EnumEjb(i4 + 12 | 0, i1, i2, i3);
 i3 = i4 + 152 | 0;
 HEAP32[i4 + 168 >> 2] = 0;
 HEAP32[i4 + 172 >> 2] = 0;
 HEAP8[i4 + 176 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 12 >> 0] = 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -251658241 | 117440512;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 if (!(HEAP32[i4 + 284 >> 2] & 4096)) i1 = i4 + 108 | 0; else i1 = (HEAP32[i4 + 56 >> 2] | 0) + 268 | 0;
 HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_(i4, i2, i3);
 STACKTOP = i5;
 return;
}

function __ZN21DownloadHandlerScript18GetBufferForScriptERP11Il2CppArrayRPhRj(i2, i4, i5, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  i1 = HEAP32[(__Z19GetScriptingManagerv() | 0) + 120 >> 2] | 0;
  i1 = __Z19scripting_array_newP11Il2CppClassjj(i1, 1, HEAP32[i3 >> 2] | 0) | 0;
 } else {
  i2 = HEAP32[i2 + 60 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0) HEAP32[i3 >> 2] = i2;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i5 >> 2] = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 1) | 0;
 return;
}

function __ZN19SharedBillboardDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 56576 + 8;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i2 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 48 | 0;
 if ((HEAP32[i2 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 28 | 0;
 if ((HEAP32[i2 + 44 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 32 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN19SharedBillboardDataD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 56576 + 8;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i2 + 84 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 72 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 48 | 0;
 if ((HEAP32[i2 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 52 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if ((HEAP32[i2 + 44 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 28 >> 2] | 0, i2 + 32 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN18SpeedTreeWindAsset17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[gb + 1170600 >> 2] | 0;
 i4 = i1 + 32 | 0;
 i5 = i2 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = i2 + (i1 << 3) | 0;
  i1 = i1 + 1 | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break;
  if (i1 >>> 0 >= i6 >>> 0) {
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return;
 i7 = i3 + 8 | 0;
 _memmove(i3 | 0, i7 | 0, i2 + (i6 << 3) - i7 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 return;
}

function __ZN17CollisionMeshData21GetSharedNxConvexMeshER4Mesh(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN10Matrix4x4f11SetIdentityEv(i4) | 0;
  i2 = __Z11GetIPhysicsv() | 0;
  i4 = mftCall_iiiiiiif(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i3 | 0, 1, 0, i4 | 0, 0, 0.0) | 0;
  HEAP32[i1 >> 2] = i4;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN13RuntimeStaticI18AssetBundleManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(224, i3, i4, gb + 1041912 | 0, 65) | 0;
  __ZN18AssetBundleManagerC2Ev(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(224, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  __ZN18AssetBundleManagerC2Ev(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12TLSAllocatorI14StackAllocatorE13ThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[gb + 1103852 >> 2] | 0;
 HEAP32[gb + 1103852 >> 2] = 0;
 i1 = 0;
 do {
  i4 = i2 + 32 + (i1 << 2) | 0;
  i1 = i1 + 1 | 0;
  if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) {
   i5 = 4;
   break;
  }
 } while ((i1 | 0) < 128);
 if ((i5 | 0) == 4) HEAP32[i4 >> 2] = 0;
 if (!i3) {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63216 | 0);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63216 | 0);
 return;
}

function __ZN11dtNodeQueue8bubbleUpEiP6dtNode(i7, i1, i8) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 L1 : do if ((i1 | 0) > 0) {
  f6 = Math_fround(HEAPF32[i8 + 16 >> 2]);
  i3 = i1;
  while (1) {
   i2 = i3 + -1 | 0;
   i1 = (i2 | 0) / 2 | 0;
   i4 = HEAP32[i7 >> 2] | 0;
   i5 = HEAP32[i4 + (i1 << 2) >> 2] | 0;
   if (!(Math_fround(HEAPF32[i5 + 16 >> 2]) > f6)) {
    i1 = i3;
    break L1;
   }
   HEAP32[i4 + (i3 << 2) >> 2] = i5;
   if ((i2 | 0) > 1) i3 = i1; else break;
  }
 } while (0);
 HEAP32[(HEAP32[i7 >> 2] | 0) + (i1 << 2) >> 2] = i8;
 return;
}

function __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE(i1, i4, i3, 0);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z42GUIStyleState_CUSTOM_SetBackgroundInternalP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (i1 | 0) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  if (i4 | 0) {
   if (!i2) i1 = 0; else {
    i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP32[i4 >> 2] = i1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z36LineRenderer_Get_Custom_PropEndWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = HEAP32[i2 + 344 >> 2] | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i2 + 76 >> 2] | 0) + ((HEAP32[i2 + 88 >> 2] | 0) + -1 << 4) + 4 >> 2]);
  return Math_fround(f3 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 }
 return Math_fround(0.0);
}

function __Z28Animator_CUSTOM_GetBehaviourP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 i1 = __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Animator12GetBehaviourEP11Il2CppClass(i2, i1) | 0) | 0;
 return 0;
}

function _jpeg_write_tables(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i1 | 0) == 100) i1 = i2; else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i1;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i2 | 0);
  i1 = i2;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i3 = i2 + 24 | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 _jinit_marker_writer(i2);
 mftCall_vi(HEAP32[(HEAP32[i2 + 332 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 return;
}

function __ZNK5physx3Cct10Controller16getInternalStateERNS_17PxControllerStateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 432 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 436 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 440 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 244 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 248 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 240 >> 2];
 i3 = HEAP32[i2 + 396 >> 2] | 0;
 HEAP8[i1 + 28 >> 0] = i3 >>> 4 & 1;
 HEAP8[i1 + 29 >> 0] = i3 >>> 5 & 1;
 HEAP8[i1 + 30 >> 0] = i3 >>> 8 & 1;
 HEAP32[i1 + 24 >> 2] = HEAPU8[i2 + 484 >> 0];
 return;
}

function __ZNK14PlayerSettings22GetAutoRotationAllowedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   i2 = (HEAP8[i1 + 377 >> 0] | 0) != 0;
   return i2 | 0;
  }
 case 1:
  {
   i2 = (HEAP8[i1 + 378 >> 0] | 0) != 0;
   return i2 | 0;
  }
 case 2:
  {
   i2 = (HEAP8[i1 + 379 >> 0] | 0) != 0;
   return i2 | 0;
  }
 case 3:
  {
   i2 = (HEAP8[i1 + 380 >> 0] | 0) != 0;
   return i2 | 0;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 452874 | 0, 0, gb + 452899 | 0, 323, 1, 0, 0, 0);
   i2 = 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN9BoxPruner17prepareBIPPruningERK16MBPOS_TmpBuffers(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i4 + 116 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i4 + 84 >> 2] | 0;
  if (i2 | 0) {
   HEAP32[i4 + 32 >> 2] = HEAP32[i4 + 76 >> 2];
   HEAP32[i4 + 36 >> 2] = i1;
   HEAP32[i4 + 40 >> 2] = i2;
   HEAP32[i4 + 44 >> 2] = HEAP32[i3 + 12816 >> 2];
   HEAP32[i4 + 48 >> 2] = HEAP32[i4 + 96 >> 2];
   HEAP32[i4 + 52 >> 2] = HEAP32[i4 + 104 >> 2];
   HEAP32[i4 + 56 >> 2] = HEAP32[i4 + 144 >> 2];
   HEAP8[i4 + 60 >> 0] = 1;
   return;
  }
 }
 HEAP8[i4 + 60 >> 0] = 0;
 return;
}

function __ZN8Collider19SetDisableCollisionEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i1 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i4 | 0, i2 | 0);
 i2 = i4 + 8 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 ? i6 | 16 : i6 & -17;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0, i3 | 0, i4 | 0);
 STACKTOP = i5;
 return;
}

function __ZN8Animator11SetPlayableEP17AnimationPlayable(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + 628 | 0;
 i7 = gb + 37528 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZN8Playable6HandleEv(i3, i2);
 i5 = i3;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 i7 = i1;
 HEAP32[i7 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i7 + 4 >> 2] = i6;
 STACKTOP = i4;
 return;
}

function __ZN5Umbra9Matrix4x45identEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayPvPy(i1, i6, i3, i2, i4, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i6 + 1052 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = _fwrite(i4, 1, i3, i1) | 0;
 HEAP32[i5 + 4 >> 2] = 0;
 switch (_ferror(i1) | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 case 18:
  {
   i1 = 10;
   break;
  }
 default:
  i1 = 14;
 }
 HEAP32[i6 + 1056 >> 2] = i1;
 i6 = (i1 | 0) == 0;
 return i6 | 0;
}

function __ZN13UnityProfiler10CleanupGfxEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2) {
  __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE((HEAP32[i2 + 1124 >> 2] | 0) + 20 | 0);
  i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) {
  __ZN17ProfilerFrameData19FreeAllTimerQueriesEv();
  return;
 }
 __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE((HEAP32[i1 + 1124 >> 2] | 0) + 20 | 0);
 __ZN17ProfilerFrameData19FreeAllTimerQueriesEv();
 return;
}

function __ZN12_GLOBAL__N_110Connection15checkConnectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) do {
  if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) != 2) break L1;
  __ZN5physx6shdfnd10ThreadImpl5sleepEj(100);
 } while (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0); while (0);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) return;
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN11KeyframeTplI11QuaternionfEC2EfRKS0_(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i5 = i1 + 20 | 0;
 i4 = i1 + 36 | 0;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i6 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i6 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 return;
}

function __ZN11AudioSource9SetSpreadEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 i6 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(360.0);
 f2 = Math_fround((i7 ? Math_fround(360.0) : f2) / Math_fround(360.0));
 HEAPF32[i5 >> 2] = i6 ? Math_fround(0.0) : f2;
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1 + 212 | 0, i4, i4 + 16 | 0);
 STACKTOP = i3;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP8[i3 + 11 >> 0] = 9;
 i4 = i3;
 i2 = i4 + 9 | 0;
 do {
  HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
  i4 = i4 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP8[i3 + 9 >> 0] = 0;
 i2 = i3 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z43Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointRK13Vector2fIcalliff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = __Z19GetPhysicsManager2Dv() | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16Physics2DManager12OverlapPointERK8Vector2fiffPK10Collider2D(i7, i6, i2, f3, f4, 0) | 0) | 0;
 STACKTOP = i5;
 return i2 | 0;
}

function __Z3minRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f11 < f10 ? f11 : f10, f9 < f8 ? f9 : f8, f7 < f6 ? f7 : f6, f5 < f4 ? f5 : f4);
 return;
}

function __Z3maxRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0, f10 = f0, f11 = f0;
 f10 = Math_fround(HEAPF32[i2 >> 2]);
 f11 = Math_fround(HEAPF32[i3 >> 2]);
 f8 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f9 = Math_fround(HEAPF32[i3 + 4 >> 2]);
 f6 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f10 < f11 ? f11 : f10, f8 < f9 ? f9 : f8, f6 < f7 ? f7 : f6, f4 < f5 ? f5 : f4);
 return;
}

function __Z39Terrain_Set_Custom_PropMaterialTemplateP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   HEAP32[i3 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   __ZN7Terrain19SetMaterialTemplateERK4PPtrI8MaterialE(i4, i3);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Transfer_UnityEngineObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i4 + 8 >> 2] = 0;
 __Z19TransferField_ArrayI8JSONRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb(i1, i7, i2, i3, i5, i4) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 i6 = i1 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i1 = (i2 | 0) != 2 | i4 ^ 1 ? i1 & -257 : i1 | 256;
 i1 = (i7 | 0) == 1 & (i2 | 0) != 0 & (i3 | 0) == 1 ? i1 | 512 : i1 & -513;
 HEAP32[i6 >> 2] = i1;
 if (i5) {
  HEAP32[i6 >> 2] = i1 & -225 | 64;
  return;
 }
 i1 = i1 & -225;
 if ((i7 | 0) == 2) {
  HEAP32[i6 >> 2] = i1 | 128;
  return;
 } else {
  HEAP32[i6 >> 2] = i1 | 32;
  return;
 }
}

function __ZdlPvRK10MemLabelIdiPKcS4_S4_i(i6, i7, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i5, i6, i7);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i5 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i5;
 if (i5 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i5 = i1;
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i5, i6, i7);
 return;
}

function __ZdaPvRK10MemLabelIdiPKcS4_S4_i(i6, i7, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  i5 = i1;
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i5, i6, i7);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i5 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i5;
 if (i5 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i5 = i1;
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i5, i6, i7);
 return;
}

function __ZThn8_N5physx2Gu11HeightFieldD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 107232 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107232 + 104;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 i4 = i1 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNK9Projector25CalculateProjectionMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f4 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 if (!(HEAP8[i2 + 52 >> 0] | 0)) {
  __ZN10Matrix4x4f14SetPerspectiveEffff(i1, Math_fround(HEAPF32[i2 + 44 >> 2]), f4, f5, f3) | 0;
  return;
 } else {
  f6 = Math_fround(HEAPF32[i2 + 56 >> 2]);
  f7 = Math_fround(-f6);
  __ZN10Matrix4x4f8SetOrthoEffffff(i1, Math_fround(f4 * f7), Math_fround(f6 * f4), f7, f6, f5, f3) | 0;
  return;
 }
}

function __ZNK29LineParametersPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) i2 = -1; else {
  i3 = 0;
  i4 = i4 + 4 | 0;
  HEAP32[i4 >> 2] = i3;
  return 1;
 }
 do {
  i2 = HEAP32[gb + 1111240 + ((HEAPU8[i1 >> 0] ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i3 = ~i2;
 i4 = i4 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 return 1;
}

function __ZNK12HandlerChain6TargetERK13FileEntryDataR15FileSystemEntry(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN6Camera24RemovePostRenderCallbackEPFvRS_PvES1_(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 1156 >> 2] | 0;
 i2 = i2 + 1168 | 0;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = i1 + (i6 << 3) | 0;
 L1 : do if (i6) {
  do {
   if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i1 + 4 >> 2] | 0) == (i4 | 0)) break L1;
   i1 = i1 + 8 | 0;
  } while ((i1 | 0) != (i5 | 0));
  return;
 } while (0);
 if ((i1 | 0) == (i5 | 0)) return;
 i6 = i1 + 8 | 0;
 _memmove(i1 | 0, i6 | 0, i5 - i6 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN5physx2Sn5ConvX15releaseMetaDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx2Sn8MetaDataD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i5;
  return;
 }
 __ZN5physx2Sn8MetaDataD2Ev(i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx14NpShapeManager30releaseExclusiveUserReferencesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) if (!(i2 << 16 >> 16)) return; else i1 = HEAP32[i1 >> 2] | 0;
 i3 = i2 & 65535;
 i4 = 0;
 do {
  i2 = i1 + (i4 << 2) | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 140 >> 2] | 0, i5 | 0) | 0) {
   i2 = HEAP32[i2 >> 2] | 0;
   if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 > 1) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __ZN4crnd10dxt5_block17get_block_values8EPNS_10color_quadIhiEEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 3 >> 0] = i2;
 HEAP8[i1 + 7 >> 0] = i3;
 HEAP8[i1 + 11 >> 0] = (((i2 * 6 | 0) + i3 | 0) >>> 0) / 7 | 0;
 HEAP8[i1 + 15 >> 0] = (((i3 << 1) + (i2 * 5 | 0) | 0) >>> 0) / 7 | 0;
 HEAP8[i1 + 19 >> 0] = (((i3 * 3 | 0) + (i2 << 2) | 0) >>> 0) / 7 | 0;
 HEAP8[i1 + 23 >> 0] = (((i3 << 2) + (i2 * 3 | 0) | 0) >>> 0) / 7 | 0;
 HEAP8[i1 + 27 >> 0] = (((i3 * 5 | 0) + (i2 << 1) | 0) >>> 0) / 7 | 0;
 HEAP8[i1 + 31 >> 0] = (((i3 * 6 | 0) + i2 | 0) >>> 0) / 7 | 0;
 return 8;
}

function __ZN4FMOD6System9getDriverEPi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  if (!i3) {
   i4 = 0;
   STACKTOP = i5;
   return i4 | 0;
  }
  HEAP32[i3 >> 2] = 0;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861141;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN18MultiFrameGUIState5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i3);
  __ZdlPv(i3);
 }
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN17GeneralConnection28RegisterDisconnectionHandlerEPFvjE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i6;
 HEAP32[i3 >> 2] = i2;
 i4 = i1 + 128 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if ((i5 | 0) == (HEAP32[i1 + 132 >> 2] | 0)) {
  __ZNSt3__26vectorIPFvjENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_(i1 + 124 | 0, i3);
  STACKTOP = i6;
  return;
 } else {
  HEAP32[i5 >> 2] = i2;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 4;
  STACKTOP = i6;
  return;
 }
}

function __ZN14ParticleSystem12ClearBuffersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 __ZN23ParticleSystemParticles12array_resizeEj(HEAP32[i2 >> 2] | 0, 0);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + 652 >> 2] = 0;
 HEAP32[i2 + 672 >> 2] = 0;
 HEAP32[i2 + 692 >> 2] = 0;
 HEAP32[i2 + 712 >> 2] = 0;
 if (HEAP32[i2 + 732 >> 2] | 0) _memset(HEAP32[i2 + 728 >> 2] | 0, 0, HEAP32[i2 + 736 >> 2] << 2 | 0) | 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i2 + 480 >> 2] = 0;
 i2 = i2 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN14MessageHandler27RegisterAllMessagesCallbackEPKN5Unity4TypeEPFvPviR11MessageDataEPFbS4_iS6_E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i5 = i1 + 28 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = (HEAP32[i1 + 24 >> 2] | 0) + -1 + (HEAP32[i1 + 28 >> 2] | 0) | 0;
 __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE6resizeEj(i5, (i2 >>> 0 < i1 >>> 0 ? i1 : i2) + 1 | 0);
 i1 = HEAP32[i5 >> 2] | 0;
 HEAP32[i1 + (i2 << 5) + 24 >> 2] = i3;
 HEAP32[i1 + (i2 << 5) + 28 >> 2] = i4;
 return;
}

function __ZN14DataBufferGLES23mapBufferUsageToGLUsageENS_11BufferUsageE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 switch (i1 | 0) {
 case 7:
 case 4:
 case 0:
  {
   i1 = 35044;
   break;
  }
 case 10:
 case 9:
 case 8:
 case 5:
 case 1:
  {
   i1 = 35048;
   break;
  }
 case 2:
 case 6:
  {
   i1 = 35040;
   break;
  }
 case 3:
  {
   i1 = 35046;
   break;
  }
 default:
  {
   HEAP32[i2 >> 2] = i1;
   _printf_console(gb + 602178 | 0, i2);
   i1 = 35048;
  }
 }
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN13TargetJoint2D9SetTargetERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i7 = i2;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i1 + 84 | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 __ZN12b2MouseJoint9SetTargetERK6b2Vec2(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z40ParticleEmitter_Set_Custom_PropParticlesP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 60) | 0;
  __ZN15ParticleEmitter14WriteParticlesEPK14SimpleParticlei(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
  return;
 }
}

function __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc(i2, i1, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 124 >> 0] | 0)) return;
 i1 = __ZNK13TranslateGLES10ObjectTypeEN2gl10ObjectTypeE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 122 >> 0] | 0)) {
  mftCall_viiiii(HEAP32[i2 + 392 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
  return;
 } else {
  mftCall_viiiii(HEAP32[i2 + 376 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
  return;
 }
}

function __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  HEAPF32[i2 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i2 + 8 >> 2] = Math_fround(0.0);
  HEAPF32[i3 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i3 + 8 >> 2] = Math_fround(0.0);
  return;
 } else {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZN5physx7NpScene26removeFromParticleBaseListERNS_14PxParticleBaseE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i1 + 3640 | 0;
 i3 = i1 + 3644 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if (!i4) i1 = 0; else {
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = 0;
  do {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i5 | 0)) break L1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < i4 >>> 0);
 } while (0);
 if ((i1 | 0) == (i4 | 0)) return;
 i5 = i4 + -1 | 0;
 HEAP32[i3 >> 2] = i5;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 + (i1 << 2) >> 2] = HEAP32[i6 + (i5 << 2) >> 2];
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx2Cm9DebugTextC2ERKNS_6PxVec3EfPKcz(i4, i1, f2, i3, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i4 + 1008 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 1012 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 1016 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAPF32[i4 + 1020 >> 2] = f2;
 HEAP32[i7 >> 2] = i5;
 if ((_vsnprintf(i4, 1007, i3, i7) | 0) >= 1) {
  STACKTOP = i6;
  return;
 }
 HEAP8[i4 + 1007 >> 0] = 0;
 STACKTOP = i6;
 return;
}

function __ZN5Unity5Cloth13SetUseTethersEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP8[i2 + 44 >> 0] = i3 & 1;
 i5 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 if (i3) f1 = HEAP8[i2 + 359 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0); else f1 = Math_fround(0.0);
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 268 >> 2] | 0, i5 | 0, i4 | 0);
 STACKTOP = i6;
 return;
}

function __ZN5Umbra16LineSegmentQueryC2ERKNS_7Vector3ES3_PNS_9IndexListE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i5 = i1 + 12 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = 1;
 HEAP32[i1 + 28 >> 2] = i4;
 return;
}

function __ZN5Umbra15CameraTransform17getUserClipPlanesEPNS_7Vector4ERi(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = HEAP32[i1 + 332 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 if ((i2 | 0) > 0) i2 = 0; else return;
 do {
  i5 = i3 + (i2 << 4) | 0;
  i6 = i1 + 64 + (i2 << 4) | 0;
  HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
  HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
  HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
  HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (HEAP32[i4 >> 2] | 0));
 return;
}

function __ZN4crnd10dxt1_block10pack_colorEjjjbj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = (i1 | 0) < 0 ? 0 : ((i1 | 0) > 255 ? 255 : i1) & 255;
 i2 = (i2 | 0) < 0 ? 0 : ((i2 | 0) > 255 ? 255 : i2) & 255;
 i3 = (i3 | 0) < 0 ? 0 : ((i3 | 0) > 255 ? 255 : i3) & 255;
 if (i4) {
  i3 = (((i3 * 31 | 0) + i5 | 0) >>> 0) / 255 | 0;
  i2 = (((i2 * 63 | 0) + i5 | 0) >>> 0) / 255 | 0;
  i1 = (((i1 * 31 | 0) + i5 | 0) >>> 0) / 255 | 0;
 }
 return ((i2 >>> 0 < 63 ? i2 : 63) << 5 | (i1 >>> 0 < 31 ? i1 : 31) << 11 | (i3 >>> 0 < 31 ? i3 : 31)) & 65535 | 0;
}

function __ZN15ReplacementPassD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 36880 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 12 | 0;
 if ((HEAP32[i3 + 28 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 16 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15ReplacementPassD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 36880 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 12 >> 2] | 0, i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClient7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 i2 = i4 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) HEAP32[i2 >> 2] = i3 + -1;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
 if (HEAP32[i2 >> 2] | 0) return;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i4 = i2 + 3 | 0;
 HEAP8[i2 >> 0] = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = i1;
 i4 = i2 + 1 | 0;
 i1 = HEAP8[i4 >> 0] | 0;
 i2 = i2 + 2 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i1;
 STACKTOP = i3;
 return;
}

function __ZN10GameObject31GetSupportedMessagesRecalculateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 60 | 0;
 HEAP32[i6 >> 2] = 0;
 i7 = i1 + 28 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 i5 = i1 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return; else i4 = i2;
 do {
  i3 = HEAP32[i4 + 4 >> 2] | 0;
  if (i3) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i2;
   i2 = HEAP32[i7 >> 2] | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i4 = i4 + 8 | 0;
 } while ((i4 | 0) != (i2 + (i1 << 3) | 0));
 return;
}

function __ZL30StaticInitializeIUnityGraphicsPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[gb + 1163128 >> 2] = fb + 1;
 HEAP32[gb + 1163128 + 4 >> 2] = fb + 3422;
 HEAP32[gb + 1163128 + 8 >> 2] = fb + 3423;
 i3 = HEAP32[gb + 1163140 + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = -1528974012;
 HEAP32[i4 + 4 >> 2] = 2092567196;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 1857125137;
 HEAP32[i4 + 4 >> 2] = -1940204398;
 mftCall_vii(i3 | 0, i2 | 0, gb + 1163128 | 0);
 STACKTOP = i1;
 return;
}

function __Z59ConfigurableJoint_CUSTOM_INTERNAL_get_targetAngularVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 340 >> 2] | 0;
  i1 = HEAP32[i3 + 344 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 336 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z23Mesh_CUSTOM_MarkDynamicP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) {
  i3 = i2;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 if (!(__ZNK4Mesh19CanAccessFromScriptEv(i1) | 0)) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 __ZN4Mesh11MarkDynamicEv(i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 i2 = (HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i3, i2, gb + 1034411 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i3, i2 + 12 | 0, gb + 1034420 | 0, 0);
 return;
}

function __GLOBAL__sub_I_artifacts_generated_webgl_modules_imgui_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = gb + 63672 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[gb + 1468176 >> 2] = 0;
 HEAP32[gb + 1468176 + 4 >> 2] = 0;
 HEAP8[gb + 1468176 + 8 >> 0] = 0;
 i1 = gb + 1468176 + 12 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468176 + 20 >> 2] = 0;
 HEAP32[gb + 1468176 + 24 >> 2] = 0;
 HEAP8[gb + 1468176 + 28 >> 0] = 0;
 i1 = gb + 1468176 + 32 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468176 + 40 >> 2] = 0;
 return;
}

function _UNITY_ft_mem_strdup(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 if (!i5) {
  i1 = 0;
  i7 = 4;
 } else {
  i2 = (_strlen(i5) | 0) + 1 | 0;
  if ((i2 | 0) > 0) {
   i4 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
   i3 = i4;
   i4 = (i4 | 0) == 0 ? 64 : 0;
   i1 = i2;
  } else {
   i1 = i2;
   i7 = 4;
  }
 }
 if ((i7 | 0) == 4) {
  i3 = 0;
  i4 = i1 | 0 ? 6 : 0;
 }
 if (!((i5 | 0) != 0 & (i4 | 0) == 0)) {
  HEAP32[i6 >> 2] = i4;
  return i3 | 0;
 }
 _memcpy(i3 | 0, i5 | 0, i1 | 0) | 0;
 HEAP32[i6 >> 2] = i4;
 return i3 | 0;
}

function __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 212516 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __THREW__ = 0;
 i4 = invoke_i(fb + 314 | 0) | 0;
 i5 = __THREW__;
 __THREW__ = 0;
 do if (!(i5 & 1)) {
  if ((i3 | 0) != (i4 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4002 | 0, HEAP32[i2 >> 2] | 0);
   i5 = __THREW__;
   __THREW__ = 0;
   if (i5 & 1) break;
  }
  return;
 } while (0);
 i5 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 __ZNSt3__26locale5facetD2Ev(i1);
 ___clang_call_terminate(i5);
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_jj(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i3 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i4 | 0;
  return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, (i6 ? HEAP32[i2 >> 2] | 0 : i2) + (i4 << 2) | 0, i3 >>> 0 < i5 >>> 0 ? i3 : i5) | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_jj(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i3 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i4 | 0;
  return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, (i6 ? HEAP32[i2 >> 2] | 0 : i2) + (i4 << 2) | 0, i3 >>> 0 < i5 >>> 0 ? i3 : i5) | 0;
 }
 return 0;
}

function __ZN7dtCrowd13markPathStaleEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if ((HEAP32[i3 + (i2 * 608 | 0) + 476 >> 2] | 0) > 0) i4 = 4; else if ((HEAP32[i3 + (i2 * 608 | 0) + 32 >> 2] | 0) > 1) i4 = 4; else if (HEAP8[i3 + (i2 * 608 | 0) + 44 >> 0] & 2) i4 = 4;
 if ((i4 | 0) == 4) HEAP32[i3 + (i2 * 608 | 0) + 48 >> 2] = 0;
 if ((HEAP8[i3 + (i2 * 608 | 0) + 600 >> 0] | 0) != 2) return;
 if ((HEAP32[i1 + 32 >> 2] | 0) != (HEAP32[i1 + 452 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 92 >> 2] & 536870912)) return;
 HEAP32[i1 + 100 >> 2] = 0;
 return;
}

function __ZN5physx56PxVehicleDriveNWSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE(i3, i5, i4, f6, i2, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx54PxVehicleDriveSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i3, i5, i4, f6, i2, i1, i1 + 128 | 0);
 return;
}

function __ZN5physx56PxVehicleDrive4WSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE(i3, i5, i4, f6, i2, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx54PxVehicleDriveSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i3, i5, i4, f6, i2, i1, i1 + 128 | 0);
 return;
}

function __ZN5physx3Ext7D6Joint8setDriveENS_9PxD6Drive4EnumERKNS_14PxD6JointDriveE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = HEAP32[i3 + 80 >> 2] | 0;
 i7 = i1;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4 + 176 + (i2 << 4) | 0;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i4 + 176 + (i2 << 4) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i4 + 176 + (i2 << 4) + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP8[i3 + 84 >> 0] = 1;
 i3 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 return;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStream5writeEPKhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return 0;
 if (!(HEAP8[i3 + 28 >> 0] | 0)) return 0;
 _fwrite(i1, 1, i2, HEAP32[i3 + 8 >> 2] | 0) | 0;
 i1 = i3 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i3 = i3 + 32 | 0;
 i4 = i3;
 i4 = _i64Add(HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, i2 | 0, 0) | 0;
 i2 = getTempRet0() | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i2;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 return 0;
}

function __Z51MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, i4, i3, 1);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function _tt_get_interface(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = _UNITY_ft_service_list_lookup(HEAP32[HEAP32[i1 + 220 >> 2] >> 2] | 0, i4) | 0;
 if (i2 | 0) {
  i4 = i2;
  return i4 | 0;
 }
 i1 = _UNITY_FT_Get_Module(i1, gb + 1007772 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iii(HEAP32[i1 + 16 >> 2] | 0, i3 | 0, i4 | 0) | 0;
 return i4 | 0;
}

function _sinh(d1) {
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 d3 = (i4 | 0) < 0 ? -.5 : .5;
 i4 = i4 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[tempDoublePtr + 4 >> 2] = i4;
 d2 = +HEAPF64[tempDoublePtr >> 3];
 do if (i4 >>> 0 < 1082535490) {
  d2 = +_expm1(d2);
  if (i4 >>> 0 >= 1072693248) {
   d1 = d3 * (d2 + d2 / (d2 + 1.0));
   break;
  }
  if (i4 >>> 0 >= 1045430272) d1 = d3 * (d2 * 2.0 - d2 * d2 / (d2 + 1.0));
 } else d1 = d3 * 2.0 * +___expo2(d2); while (0);
 return +d1;
}

function __ZZL32InitializeModule_ParticlesLegacyvEN59PostLateUpdateParticlesLegacyUpdateAllParticleSystemsstruct7ForwardEv() {
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (f3 < Math_fround(.0000999999974) | (__Z14IsWorldPlayingv() | 0) ^ 1) return;
 i1 = HEAP32[gb + 1469400 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1469400 | 0)) return;
 do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN15ParticleEmitter20UpdateParticleSystemEf(HEAP32[i4 + 8 >> 2] | 0, f3);
  i2 = i1;
 } while ((i2 | 0) != (gb + 1469400 | 0));
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj(i1, f2, i5, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i6 = 0;
 i1 = i1 + -124 | 0;
 if (!(HEAP8[i1 + 276 >> 0] | 0)) return;
 i6 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17CUDAProfileBufferEyfPKhjj(i1, i6, getTempRet0() | 0, f2, i5, i3, i4);
 return;
}

function __ZNSt3__28ios_base7failureC2EPKcRKNS_10error_codeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 i8 = i3;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i3 = i6;
 HEAP32[i3 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i3 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZNSt3__212system_errorC2ENS_10error_codeEPKc(i1, i5, i2);
 HEAP32[i1 >> 2] = gb + 209152 + 8;
 STACKTOP = i4;
 return;
}

function __ZNK13WheelCollider30GetGlobalForceAppPointDistanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, f5 = f0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i6, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f5 = Math_fround(HEAPF32[i1 + 92 >> 2]);
 f3 = Math_fround(HEAPF32[i6 + 4 >> 2]);
 i1 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = Math_fround(f5 * (i1 ? f4 : f3));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN6Camera16SetTargetBuffersEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PP13RenderTexture(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i8 = i6;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i8 >> 2];
 __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_(i1, 0, i2, i3, i7, i5);
 STACKTOP = i6;
 return;
}

function __ZN4FMOD6System16setDSPBufferSizeEji(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i2 + 44 >> 2] = i3;
  HEAP32[i2 + 48 >> 2] = i4;
  i5 = 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = 36;
 HEAP32[i5 + 4 >> 2] = gb + 861095;
 _printf(gb + 853184 | 0, i5) | 0;
 i5 = 36;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN17CollisionMeshData15GetSharedNxMeshER4Mesh(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  __ZN10Matrix4x4f11SetIdentityEv(i4) | 0;
  i2 = __Z11GetIPhysicsv() | 0;
  i4 = mftCall_iiiiiiif(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i3 | 0, 0, 0, i4 | 0, 0, 0.0) | 0;
  HEAP32[i1 >> 2] = i4;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i4 = i2;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function __ZN14SafeBinaryRead4InitERK16TypeTreeIteratorii24TransferInstructionFlagsRK10MemLabelId(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i8 = i2;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i2 + 4 >> 2] = i7;
 HEAP32[i1 + 64 >> 2] = i3;
 i2 = i6;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i1 + 68 >> 2] = i4;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i1 + 132 >> 2] = 0;
 return i1 + 16 | 0;
}

function __ZN13ProbeRenderer6RenderEP15ReflectionProbeib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i2) {
  __ZN13ProbeRenderer10RenderCubeEP15ReflectionProbeP13RenderTextureib(0, HEAP32[i1 + 20 >> 2] | 0, i3, i4);
  return;
 }
 switch (HEAP32[i2 + 36 >> 2] | 0) {
 case 0:
  {
   __ZN13ProbeRenderer10RenderCubeEP15ReflectionProbeP13RenderTextureib(i2, HEAP32[i1 + 20 >> 2] | 0, i3, i4);
   return;
  }
 case 1:
  {
   __ZN13ProbeRenderer10RenderQuadEP15ReflectionProbeP13RenderTextureib(i2, HEAP32[i1 + 20 >> 2] | 0, 0, i4);
   return;
  }
 default:
  return;
 }
}

function __ZN12AdsIdHandler25ExecuteAsyncFetchAdsIdJobEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP8[i3 + 41 >> 0] = 0;
 HEAP32[i3 + 44 >> 2] = 1;
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i1 & 255;
 i2 = i3 + 40 | 0;
 if (!i1) {
  HEAP8[i2 >> 0] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 1;
  HEAPF32[i3 + 36 >> 2] = Math_fround(+__Z19GetTimeSinceStartupv());
  __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3300 | 0, i3);
  __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv(i3);
  return;
 }
}

function __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalMatrixP12Il2CppObjectiRK10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer18AddSetGlobalMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i1, i4, i3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z35Mesh_CUSTOM_GetArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) {
   __Z30ExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray(i6, i2, i3, i4, i5);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31GUIStyle_CUSTOM_SetFontInternalP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (i1 | 0) {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  if (i4 | 0) {
   if (!i2) i1 = 0; else {
    i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
    if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
   }
   HEAP32[i4 + 240 >> 2] = i1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 20 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = i3 + 16;
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 28 >> 2];
 __ZN24GenerateTypeTreeTransfer8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags(i2, i4, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function _regerror(i2, i1, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 L1 : do if (!i2) i1 = gb + 1074407 | 0; else {
  i1 = gb + 1074407 | 0;
  do {
   if (!(HEAP8[i1 >> 0] | 0)) break L1;
   i2 = i2 + -1 | 0;
   i1 = i1 + ((_strlen(i1) | 0) + 1) | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 HEAP32[i3 >> 2] = (HEAP8[i1 >> 0] | 0) == 0 ? i1 + 1 | 0 : i1;
 i6 = (_snprintf(i5, i6, gb + 1074693 | 0, i3) | 0) + 1 | 0;
 STACKTOP = i4;
 return i6 | 0;
}

function __ZNK19RenderEventsContext7CleanupEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 i4 = 0;
 do {
  i7 = HEAP32[i5 >> 2] | 0;
  i2 = HEAP32[i7 + (i4 * 20 | 0) >> 2] | 0;
  i7 = HEAP32[i7 + (i4 * 20 | 0) + 12 >> 2] | 0;
  i3 = i2 + (i7 << 2) | 0;
  if (i7) {
   i1 = i2;
   do {
    __ZN22RenderingCommandBuffer7CleanupEv(HEAP32[i1 >> 2] | 0);
    i1 = i1 + 4 | 0;
   } while ((i1 | 0) != (i3 | 0));
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) < (i1 | 0));
 return;
}

function __ZN8Animator27InitializeVisibilityCullingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if (!(__ZNK10GameObject8IsActiveEv(i3) | 0)) return;
 __ZN8Animator23ClearContainedRenderersEv(i1);
 if (!(HEAP32[i1 + 92 >> 2] | 0)) {
  HEAP8[i1 + 88 >> 0] = 1;
  return;
 } else {
  __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 >> 2] | 0, gb + 28940 | 0) | 0);
  HEAP8[i1 + 88 >> 0] = (__ZNK8Animator20IsAnyRendererVisibleEv(i1) | 0) & 1;
  return;
 }
}

function __ZN5physx7NpScene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE(i2 + 32 | 0, i1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 560, gb + 708093 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE6resizeEjRKh(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE6resizeEjRKc(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + i6 | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + i1 | 0;
 do {
  HEAP8[i1 >> 0] = HEAP8[i5 >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx6shdfnd10Foundation9errorImplENS_11PxErrorCode4EnumEPKciS5_Pi(i5, i1, i2, i3, i4, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!(HEAP32[i5 + 44 >> 2] & i1)) return;
 i7 = i5 + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 _vsnprintf(gb + 1548984 | 0, 1024, i4, i6) | 0;
 HEAP8[gb + 1548984 + 1024 >> 0] = 0;
 __ZN5physx6shdfnd12ErrorHandler11reportErrorENS_11PxErrorCode4EnumEPKcS5_i(i5 + 116 | 0, i1, gb + 1548984 | 0, i2, i3);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __ZN5physx55PxVehicleDriveNWSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE(i3, i5, i4, f6, i2, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx53PxVehicleDriveSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i3, i5, i4, f6, i2, i1, i1 + 128 | 0);
 return;
}

function __ZN5physx55PxVehicleDrive4WSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE(i3, i5, i4, f6, i2, i1) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx53PxVehicleDriveSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE(i3, i5, i4, f6, i2, i1, i1 + 128 | 0);
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl16createNodeEditorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0;
 i2 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, 36, gb + 767027 | 0, gb + 766736 | 0, 682) | 0;
 i3 = (HEAP32[i1 + 8 >> 2] | 0) + 4 | 0;
 HEAP32[i2 >> 2] = gb + 146564 + 8;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 + 8 >> 2] = i3;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = i1;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 return i2 | 0;
}

function __ZN5physx18NpArticulationLink15exportExtraDataERNS_22PxSerializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE(i4 + 20 | 0, i3);
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i4 + 12 | 0, i3);
 if (HEAP8[i4 + 316 >> 0] | 0) return;
 i2 = HEAP32[i4 + 320 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i4 + 328 >> 2] | 0;
 if (!(i1 & 2147483647 | HEAP32[i4 + 324 >> 2])) return;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, i1 << 2 | 0);
 return;
}

function __ZN16UploadHandlerRaw13TransmitBytesEPvjj(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i6) {
  i7 = -1;
  return i7 | 0;
 }
 i7 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i7) {
  i7 = -1;
  return i7 | 0;
 }
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i7 >>> 0 <= i2 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = i7 - i2 | 0;
 i5 = Math_imul(i5, i4) | 0;
 i7 = i7 >>> 0 > i5 >>> 0 ? i5 : i7;
 _memcpy(i3 | 0, i6 + i2 | 0, i7 | 0) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i7;
 return i7 | 0;
}

function __ZN12HandlerChain11HasFastHashERK13FileEntryDataR7Hash128(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN12AudioManager14ScheduleSourceEP11AudioSourced(i1, i4, d2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 d2 = +d2;
 var i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 464 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if (i3 | 0) {
  i6 = i4 + 468 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i6 >> 2];
  HEAP32[HEAP32[i6 >> 2] >> 2] = i3;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i6 >> 2] = 0;
 }
 HEAPF64[i4 + 480 >> 3] = d2;
 i1 = i1 + 60 | 0;
 if ((i5 | 0) == (i1 | 0)) return;
 i6 = i4 + 468 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[HEAP32[i6 >> 2] >> 2] = i5;
 return;
}

function __Z56ParticleSystem_MainModule_CUSTOM_GetStartDelayMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(__ZN14ParticleSystem18GetStartDelayCurveEv(i2) | 0) + 80 >> 2]);
 return Math_fround(f3);
}

function __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i1, i4, i3, 0);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z38FlattenRelativePathAndRemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __Z16RemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i5, i2);
 __Z19FlattenRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb(i1, i5, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i5);
 STACKTOP = i4;
 return;
}

function __Z34Vector3_CUSTOM_INTERNAL_CALL_SlerpRK8Vector3fS1_fRS_(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = f3 < Math_fround(0.0);
 i8 = f3 > Math_fround(1.0);
 f3 = i8 ? Math_fround(1.0) : f3;
 __Z5SlerpRK8Vector3fS1_f(i6, i1, i2, i7 ? Math_fround(0.0) : f3);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function _cff_lookup_glyph_by_stdcharcode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 1160 | 0;
 if (i1 >>> 0 > 255 | (HEAP32[i3 >> 2] | 0) == 0) {
  i5 = -1;
  return i5 | 0;
 }
 i5 = _cff_get_standard_encoding(i1) | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i4) {
  i5 = -1;
  return i5 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP16[i2 + (i1 << 1) >> 1] | 0) == i5 << 16 >> 16) {
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN9Rigidbody16SetInertiaTensorERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 81 >> 0] = 0;
 if (Math_fround(HEAPF32[i2 >> 2]) > Math_fround(1.1920929e-07)) if (Math_fround(HEAPF32[i2 + 4 >> 2]) > Math_fround(1.1920929e-07)) if (Math_fround(HEAPF32[i2 + 8 >> 2]) > Math_fround(1.1920929e-07)) {
  i1 = HEAP32[i1 + 52 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i2 | 0);
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 733397 | 0, 0, gb + 732812 | 0, 779, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN8Renderer23RendererBecameInvisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = i1 + 268 | 0;
 i5 = (HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105316 | 0, i3);
 __ZN6Object11InvokeEventEi(i1, 1);
 STACKTOP = i2;
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatABGR8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAPU16[i1 >> 1] | 0;
  i5 = i6 << 16;
  i3 = i5 & 15728640;
  HEAP32[i4 >> 2] = i6 >>> 8 & 240 | i6 >>> 12 | i6 << 12 & 61440 | i6 << 8 & 3840 | i6 << 20 & -268435456 | i5 & 251658240 | i3 | i3 >>> 4;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx19PxsSimObjectFactory19destroyArticulationERNS_15PxsArticulationE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = i2 + 280 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i2 + 292 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 i1 = i2 + 284 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 1;
 if ((i3 | 0) < ((HEAP32[i2 + 276 >> 2] | 0) * 50 | 0)) return;
 __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE17releaseEmptySlabsEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx10PxsContext24removeParticleSystemImplEPNS_20PxvParticleSystemSimEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 if (i1) i1 = __ZN5physx20PxsParticleSystemSim19obtainParticleStateEv(i2) | 0; else i1 = 0;
 __ZN5physx20PxsParticleSystemSim5clearEv(i2);
 i4 = HEAP32[i2 + 1124 >> 2] | 0;
 i5 = (HEAP32[i3 + 264 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~(1 << (i4 & 31));
 i5 = i3 + 252 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i4 + 1;
 HEAP32[(HEAP32[i3 + 248 >> 2] | 0) + (i4 << 2) >> 2] = i2;
 return i1 | 0;
}

function __ZN14DetailDatabase19SetDetailPrototypesERKNSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 16 | 0;
 if ((i3 | 0) != (i2 | 0)) __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i3, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 __ZN14DetailDatabase17RefreshPrototypesEv(i1);
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(HEAP32[i1 + 28 >> 2] | 0, 8);
 return;
}

function __ZN12HingeJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D5ResetEv(i1);
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 92 >> 0] = 1;
 HEAP8[i1 + 112 >> 0] = 0;
 HEAP8[i1 + 113 >> 0] = 0;
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 104 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(359.0);
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 72 | 0, gb + 842535 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(i2, i1 + 60 | 0, gb + 1034411 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z34Terrain_Set_Custom_PropTerrainDataP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   HEAP32[i3 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE(i4, i3);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z15NormalizeRobustRK8Vector3fRf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, f7 = f0, i8 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i4 + 16 | 0;
 i6 = i4 + 12 | 0;
 i5 = i4;
 __ZL15NormalizeRobustRK8Vector3fRfS2_(i5, i2, i8, i6);
 f7 = Math_fround(HEAPF32[i8 >> 2]);
 HEAPF32[i3 >> 2] = Math_fround(f7 / Math_fround(HEAPF32[i6 >> 2]));
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function _UNITY_FT_Done_Face(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i5 = 35;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 96 >> 2] | 0;
 if (!i5) {
  i5 = 35;
  return i5 | 0;
 }
 i3 = (HEAP32[i1 + 128 >> 2] | 0) + 52 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i4 + -1;
 if ((i4 | 0) > 1) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 i3 = i5 + 16 | 0;
 i4 = _UNITY_FT_List_Find(i3, i1) | 0;
 if (!i4) {
  i5 = 35;
  return i5 | 0;
 }
 _UNITY_FT_List_Remove(i3, i4);
 _UNITY_ft_mem_free(i2, i4);
 _destroy_face(i2, i1, i5);
 i5 = 0;
 return i5 | 0;
}

function _saveSetjmp(i1, i3, i5, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 setjmpId = setjmpId + 1 | 0;
 HEAP32[i1 >> 2] = setjmpId;
 while ((i2 | 0) < (i4 | 0)) {
  if (!(HEAP32[i5 + (i2 << 3) >> 2] | 0)) {
   HEAP32[i5 + (i2 << 3) >> 2] = setjmpId;
   HEAP32[i5 + ((i2 << 3) + 4) >> 2] = i3;
   HEAP32[i5 + ((i2 << 3) + 8) >> 2] = 0;
   setTempRet0(i4 | 0);
   return i5 | 0;
  }
  i2 = i2 + 1 | 0;
 }
 i4 = i4 * 2 | 0;
 i5 = _realloc(i5 | 0, 8 * (i4 + 1 | 0) | 0) | 0;
 i5 = _saveSetjmp(i1 | 0, i3 | 0, i5 | 0, i4 | 0) | 0;
 setTempRet0(i4 | 0);
 return i5 | 0;
}

function __ZNKSt3__27collateIcE10do_compareEPKcS3_S3_S3_(i1, i3, i5, i2, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i4 = 0, i7 = 0;
 i1 = i3;
 while (1) {
  if ((i2 | 0) == (i6 | 0)) {
   i7 = 7;
   break;
  }
  if ((i1 | 0) == (i5 | 0)) {
   i1 = -1;
   break;
  }
  i3 = HEAP8[i1 >> 0] | 0;
  i4 = HEAP8[i2 >> 0] | 0;
  if (i3 << 24 >> 24 < i4 << 24 >> 24) {
   i1 = -1;
   break;
  }
  if (i4 << 24 >> 24 < i3 << 24 >> 24) {
   i1 = 1;
   break;
  }
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 if ((i7 | 0) == 7) i1 = (i1 | 0) != (i5 | 0) & 1;
 return i1 | 0;
}

function __ZN7mecanim8skeleton8IdentityIN4math7affineXEEET_v(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 return;
}

function __ZN7Terrain16OnTerrainChangedEN11TerrainData12ChangedFlagsE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 if (i3 & 16 | 0) {
  i4 = i2 + 228 | 0;
  i5 = i2 + 240 | 0;
  if (HEAP32[i5 >> 2] | 0) {
   i1 = HEAP32[i4 >> 2] | 0;
   do {
    __ZN14DetailRenderer18ReloadDirtyDetailsEv(HEAP32[i1 + 12 >> 2] | 0);
    i1 = i1 + 20 | 0;
   } while ((i1 | 0) != ((HEAP32[i4 >> 2] | 0) + ((HEAP32[i5 >> 2] | 0) * 20 | 0) | 0));
  }
 }
 if (!(i3 & 8)) {
  i5 = i2 + 224 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i3;
  return;
 } else {
  __ZN7Terrain5FlushEv(i2);
  return;
 }
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 80 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 84 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 80 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 84 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11TerrainData23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN17RemapPPtrTransfer8TransferI13SplatDatabaseEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 932081 | 0, 1);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i2, 1);
 __ZN14DetailDatabase8TransferI17RemapPPtrTransferEEvRT_(i1 + 128 | 0, i2);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i2);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i2, 1);
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i2);
 return;
}

function __Z39AssetBundleRequest_Get_Custom_PropAssetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i1 = __ZN29AssetBundleLoadAssetOperation14GetLoadedAssetEv(i1) | 0;
   if (!i1) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z16SetCullingPlanesR17CullingParametersPK5Planei(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 HEAP32[i2 + 188 >> 2] = i4;
 if ((i4 | 0) > 0) {
  i1 = 0;
  do {
   i5 = i2 + 28 + (i1 << 4) | 0;
   i6 = i3 + (i1 << 4) | 0;
   HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
   HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
   HEAP32[i5 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
   HEAP32[i5 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E(i3, i4, i2 + 352 | 0) | 0;
 return;
}

function _atanh(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0, i4 = 0, d5 = 0.0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i2 = _bitshift64Lshr(i4 | 0, i3 | 0, 52) | 0;
 getTempRet0() | 0;
 i2 = i2 & 2047;
 HEAP32[tempDoublePtr >> 2] = i4;
 HEAP32[tempDoublePtr + 4 >> 2] = i3 & 2147483647;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 if (i2 >>> 0 < 1022) {
  if (i2 >>> 0 >= 991) {
   d5 = d1 * 2.0;
   d1 = +_log1p(d5 + d1 * d5 / (1.0 - d1)) * .5;
  }
 } else d1 = +_log1p(d1 / (1.0 - d1) * 2.0) * .5;
 return +((i3 | 0) < 0 ? -d1 : d1);
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_RKS5_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0, i7 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP8[i5 + 8 + 3 >> 0] | 0;
 i6 = i2 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i1, i7 - i3 >> 2, (HEAP32[i4 >> 2] | 0) - i7 >> 2, i6 ? HEAP32[i5 >> 2] | 0 : i5, i6 ? HEAP32[i5 + 4 >> 2] | 0 : i2 & 255) | 0;
}

function __ZN7mecanim8skeleton30SkeletonBuildReverseIndexArrayEPiPKiPKNS0_8SkeletonES6_(i4, i5, i6, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (HEAP32[i2 >> 2] | 0) {
  i1 = 0;
  do {
   HEAP32[i4 + (i1 << 2) >> 2] = -1;
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) return; else i3 = 0;
 do {
  i2 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
  if ((i2 | 0) != -1) {
   HEAP32[i4 + (i2 << 2) >> 2] = i3;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return;
}

function __ZN7dtCrowd23UpdateActiveObstacleIDsEv(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i7 + 408 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) <= 0) {
  i6 = 0;
  i7 = i7 + 404 | 0;
  HEAP32[i7 >> 2] = i6;
  return;
 }
 i5 = HEAP32[i7 + 416 >> 2] | 0;
 i6 = i7 + 396 | 0;
 i3 = 0;
 i1 = 0;
 do {
  if (HEAP32[i5 + (i3 * 92 | 0) + 84 >> 2] | 0) {
   HEAP32[(HEAP32[i6 >> 2] | 0) + (i1 << 2) >> 2] = i3;
   i1 = i1 + 1 | 0;
   i2 = HEAP32[i4 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i2 | 0));
 i7 = i7 + 404 | 0;
 HEAP32[i7 >> 2] = i1;
 return;
}

function __ZN5physx2Sc5ActorD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i4 >> 2] = gb + 91044 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i2 = i4 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!((i3 | 0) == 0 | (i3 | 0) == (i4 + 4 | 0))) __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[i4 + 36 >> 2] | 0, i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i5, i4);
 STACKTOP = i5;
 return;
}

function __ZN29UnityWebRequestAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 188044 + 8;
 i2 = i1 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i2 >> 2] = 0;
  __ZN14AsyncOperationD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
 __ZN19TransportJavaScript5AbortEv(i3 + 8 | 0);
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63808 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN26AnimatorControllerPlayable13ClearPlayableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + 148 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i1 + 144 | 0;
 i4 = i1 + 64 | 0;
 if ((i2 | 0) > 0) {
  i3 = 0;
  i1 = i2;
  do {
   i2 = HEAP32[(HEAP32[i6 >> 2] | 0) + (i3 << 3) >> 2] | 0;
   if (i2) {
    __Z19free_alloc_internalPvRK10MemLabelId(i2, i4);
    i1 = HEAP32[i5 >> 2] | 0;
   }
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) < (i1 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i6 >> 2] | 0, i4);
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZN24OcclusionCullingSettingsD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 34976 + 8;
 i1 = i2 + 52 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) <= -1) {
  HEAP32[i2 >> 2] = gb + 28344 + 8;
  HEAP32[i2 >> 2] = gb + 28496 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 28344 + 8;
 HEAP32[i2 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN13RuntimeStaticI15DirectorManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(464, i3, i4, gb + 1041912 | 0, 65) | 0;
  __ZN15DirectorManagerC2Ev(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(464, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  __ZN15DirectorManagerC2Ev(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN13RenderTexture28GetCreatedRenderTextureBytesEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1158220 + 4 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (gb + 1158220 | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = 0;
 do {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if (!(HEAP32[i2 + 128 >> 2] | 0)) {
   if (HEAP32[i2 + 136 >> 2] | 0) i4 = 5;
  } else i4 = 5;
  if ((i4 | 0) == 5) {
   i4 = 0;
   i1 = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0) + i1 | 0;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (gb + 1158220 | 0));
 return i1 | 0;
}

function __ZN12_GLOBAL__N_111StreamOwner5writeEPKhj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i4 = 1;
  return i4 | 0;
 }
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i4 = i2;
 return i4 | 0;
}

function __Z49CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalColorP12Il2CppObjectiRK10ColorRGBAf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer18AddSetGlobalVectorERKN9ShaderLab16FastPropertyNameERK8Vector4f(i1, i4, i3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z36Application_CUSTOM_CaptureScreenshotP12Il2CppStringi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 12 | 0;
 i4 = i3;
 __ZN11ICallStringC2EP12Il2CppString(i5, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i4, i5);
 __Z15QueueScreenshotRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i4, i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z18ConvertUTF8toUTF32PKhiPmRi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 4 | 0;
 i7 = i6;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i7 >> 2] = i1;
 if ((__Z18ConvertUTF8toUTF32PPKhS0_PPmS2_15ConversionFlags(i7, i1 + i2 | 0, i5, 0, 0) | 0) == 3) {
  i7 = 0;
  i5 = 0;
  HEAP32[i4 >> 2] = i5;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = 1;
 i5 = (HEAP32[i5 >> 2] | 0) - i3 >> 2;
 HEAP32[i4 >> 2] = i5;
 STACKTOP = i6;
 return i7 | 0;
}

function __Z18ConvertUTF8toUTF16PKhiPtRi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 4 | 0;
 i7 = i6;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i7 >> 2] = i1;
 if ((__Z18ConvertUTF8toUTF16PPKhS0_PPtS2_15ConversionFlags(i7, i1 + i2 | 0, i5, 0, 1) | 0) == 3) {
  i7 = 0;
  i5 = 0;
  HEAP32[i4 >> 2] = i5;
  STACKTOP = i6;
  return i7 | 0;
 }
 i7 = 1;
 i5 = (HEAP32[i5 >> 2] | 0) - i3 >> 1;
 HEAP32[i4 >> 2] = i5;
 STACKTOP = i6;
 return i7 | 0;
}

function _term_destination(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 i3 = 4096 - (HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i3) i1 = i2 + 20 | 0; else {
  i1 = i2 + 20 | 0;
  if ((_fwrite(HEAP32[i2 + 24 >> 2] | 0, 1, i3, HEAP32[i1 >> 2] | 0) | 0) != (i3 | 0)) {
   i3 = HEAP32[i4 >> 2] | 0;
   HEAP32[i3 + 20 >> 2] = 37;
   mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
  }
 }
 _fflush(HEAP32[i1 >> 2] | 0) | 0;
 if (!(_ferror(HEAP32[i1 >> 2] | 0) | 0)) return;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i3 + 20 >> 2] = 37;
 mftCall_vi(HEAP32[i3 >> 2] | 0, i4 | 0);
 return;
}

function __ZnwjRK10MemLabelIdiPKci(i2, i3, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i8 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i8 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i8;
  if (i8 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i4 = i1;
   break;
  }
 } else i4 = i1; while (0);
 return __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i4, i2, i5, i3, 0, i6, i7) | 0;
}

function __ZnajRK10MemLabelIdiPKci(i2, i3, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i4 = 0, i8 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 do if (!i1) {
  i1 = HEAP32[gb + 73344 >> 2] | 0;
  i8 = i1 + 6960 | 0;
  HEAP32[gb + 73344 >> 2] = i8;
  if (i8 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else {
   __ZN13MemoryManagerC2Ev(i1);
   HEAP32[gb + 1188408 >> 2] = i1;
   i4 = i1;
   break;
  }
 } else i4 = i1; while (0);
 return __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci(i4, i2, i5, i3, 0, i6, i7) | 0;
}

function __ZN9DepthPassD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = gb + 36916 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 12 | 0;
 if ((HEAP32[i3 + 28 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i3 + 16 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN9DepthPassD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 36916 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 12 >> 2] | 0, i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatI8EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP8[i4 >> 0] = (HEAPU8[gb + 1160176 + ((i3 >>> 16 & 255) << 2) + 1 >> 0] | 0) + (HEAPU8[gb + 1160176 + ((i3 >>> 8 & 255) << 2) >> 0] | 0) + (HEAPU8[gb + 1160176 + (i3 >>> 24 << 2) + 2 >> 0] | 0);
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6SpriteD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 45276 + 8;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 i2 = i1 + 136 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63744 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx2Sq10FIFOStack23popERPNS0_12AABBTreeNodeES4_(i6, i4, i5) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i7 = 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i6 = 0;
  return i6 | 0;
 }
 i3 = i6 + 12 | 0;
 i7 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i7 << 3) >> 2];
 i4 = i7 + 1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i5 >> 2] = HEAP32[(HEAP32[i6 >> 2] | 0) + (i7 << 3) + 4 >> 2];
 if ((i4 | 0) != (i2 | 0)) {
  i7 = 1;
  return i7 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i7 = 1;
 return i7 | 0;
}

function __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 32 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 i1 = i1 + 44 | 0;
 i2 = 0;
 do {
  __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj((HEAP32[i1 >> 2] | 0) + (i2 * 48 | 0) | 0, i5, i6, i4, HEAP32[gb + 151272 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAPU8[i3 >> 0] | 0) >>> 0);
 return;
}

function __ZN5Umbra13MatrixFactory7rotateYEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0;
 f3 = Math_fround(+Math_sin(+f2));
 f2 = Math_fround(+Math_cos(+f2));
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = i1 + 28 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = f3;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(-f3);
 HEAP32[i1 + 24 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = f2;
 return;
}

function __ZN12HandlerChain4LockER13FileEntryData12FileLockMode(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN11LightProbes21ZeroBakedCoefficientsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 _memset(HEAP32[i1 + 148 >> 2] | 0, 0, (HEAP32[i1 + 160 >> 2] | 0) * 108 | 0) | 0;
 i3 = __ZN15GlobalCallbacks3GetEv() | 0;
 i4 = i3 + 38596 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return; else i1 = 0;
 do {
  i2 = i3 + 37828 + (i1 * 12 | 0) | 0;
  if (!(HEAP8[i3 + 37828 + (i1 * 12 | 0) + 8 >> 0] | 0)) mftCall_v(HEAP32[i2 >> 2] | 0); else mftCall_vi(HEAP32[i2 >> 2] | 0, HEAP32[i3 + 37828 + (i1 * 12 | 0) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 HEAP32[i4 >> 2] = 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = HEAP8[i1 >> 0] | 0;
  if (i3 << 24 >> 24 == 114) {
   HEAP32[i4 >> 2] = 4;
   i3 = i1 + 1 | 0;
   i1 = i3;
   i2 = 4;
   i3 = HEAP8[i3 >> 0] | 0;
  } else i2 = 0;
  if (i3 << 24 >> 24 == 86) {
   i2 = i2 | 2;
   HEAP32[i4 >> 2] = i2;
   i3 = i1 + 1 | 0;
   i1 = i3;
   i3 = HEAP8[i3 >> 0] | 0;
  }
  if (i3 << 24 >> 24 == 75) {
   HEAP32[i4 >> 2] = i2 | 1;
   i1 = i1 + 1 | 0;
  }
 }
 return i1 | 0;
}

function __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 880 >> 2]);
 return Math_fround(f3);
}

function __Z54ParticleAnimator_CUSTOM_INTERNAL_set_worldRotationAxisP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 32 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 36 >> 2] = i4;
  HEAP32[i3 + 40 >> 2] = i1;
  return;
 }
}

function __Z54ParticleAnimator_CUSTOM_INTERNAL_set_localRotationAxisP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 44 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 48 >> 2] = i4;
  HEAP32[i3 + 52 >> 2] = i1;
  return;
 }
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 328 >> 2] | 0;
  i1 = HEAP32[i3 + 332 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 324 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 300 >> 2] | 0;
  i1 = HEAP32[i3 + 304 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 296 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z41Material_CUSTOM_Internal_CreateWithStringP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 563456 | 0, 0, gb + 563359 | 0, 1069, 1, 0, 0, 0);
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, __ZN8Material14CreateMaterialER6Shaderib(__ZN6Shader10GetDefaultEv() | 0, 0, 1) | 0) | 0;
 STACKTOP = i3;
 return;
}

function __Z41Animator_CUSTOM_INTERNAL_CALL_MatchTargetP12Il2CppObjectRK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff(i1, i2, i3, i4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 var i8 = 0;
 if (!i1) i1 = 0; else {
  i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i8) {
   __ZN8Animator11MatchTargetERK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff(i8, i2, i3, i4, i5, f6, f7);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z23scripting_method_invoke21ScriptingMethodIl2CppP12Il2CppObjectR18ScriptingArgumentsPP15Il2CppExceptionb(i1, i4, i2, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0, i7 = 0;
 i7 = __ZNK18ScriptingArguments8GetCountEv(i2) | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _il2cpp_method_get_param_count(i3 | 0) | 0;
 i1 = i2 + 96 | 0;
 if (i6) {
  i7 = _il2cpp_runtime_invoke_convert_args(i3 | 0, i4 | 0, i1 | 0, i7 | 0, i5 | 0) | 0;
  return i7 | 0;
 } else {
  i7 = _il2cpp_runtime_invoke(i3 | 0, i4 | 0, i1 | 0, i5 | 0) | 0;
  return i7 | 0;
 }
 return 0;
}

function __Z17IsNodeVisibleFastRK9SceneNodeRK22SceneCullingParameters(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!(1 << HEAP32[i1 + 4 >> 2] & HEAP32[i2 + 192 >> 2])) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (HEAP8[i1 + 20 >> 0] & 4) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP16[i1 + 14 >> 1] | 0;
 if (i3 << 16 >> 16) if (!((HEAPU8[(HEAP32[(HEAP32[i2 + 812 >> 2] | 0) + ((HEAPU16[i1 + 12 >> 1] | 0) * 12 | 0) >> 2] | 0) + (i3 & 65535) >> 0] | 0) & HEAP32[i1 + 16 >> 2])) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = 1;
 return i3 | 0;
}

function _UNITY_tt_face_load_hmtx(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i1 << 24 >> 24 == 0;
 i2 = mftCall_iiiii(HEAP32[i3 + 508 >> 2] | 0, i3 | 0, (i1 ? 1752003704 : 1986884728) | 0, i4 | 0, i5 | 0) | 0;
 if (i2 | 0) {
  STACKTOP = i6;
  return i2 | 0;
 }
 HEAP32[(i1 ? i3 + 684 | 0 : i3 + 692 | 0) >> 2] = HEAP32[i5 >> 2];
 HEAP32[(i1 ? i3 + 760 | 0 : i3 + 764 | 0) >> 2] = _UNITY_FT_Stream_Pos(i4) | 0;
 STACKTOP = i6;
 return i2 | 0;
}

function _UNITY_png_safecat(i7, i2, i1, i3) {
 i7 = i7 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!((i7 | 0) != 0 & i1 >>> 0 < i2 >>> 0)) {
  i7 = i1;
  return i7 | 0;
 }
 if (i3) {
  i5 = HEAP8[i3 >> 0] | 0;
  i6 = i2 + -1 | 0;
  if (i6 >>> 0 > i1 >>> 0 & i5 << 24 >> 24 != 0) {
   i4 = i1;
   i2 = i5;
   while (1) {
    i3 = i3 + 1 | 0;
    i1 = i4 + 1 | 0;
    HEAP8[i7 + i4 >> 0] = i2;
    i2 = HEAP8[i3 >> 0] | 0;
    if (!(i1 >>> 0 < i6 >>> 0 & i2 << 24 >> 24 != 0)) break; else i4 = i1;
   }
  }
 }
 HEAP8[i7 + i1 >> 0] = 0;
 i7 = i1;
 return i7 | 0;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 44 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i4 + 24 >> 2] | 0;
 if (i3 >>> 0 < i2 >>> 0) {
  HEAP32[i1 >> 2] = i2;
  i3 = i2;
 }
 if (!(HEAP32[i4 + 48 >> 2] & 8)) {
  i4 = -1;
  return i4 | 0;
 }
 i1 = i4 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) {
  HEAP32[i1 >> 2] = i3;
  i2 = i3;
 }
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i4 = -1;
  return i4 | 0;
 }
 i4 = HEAPU8[i1 >> 0] | 0;
 return i4 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i4 + 12 | 0;
 i7 = i4 + 16 | 0;
 i3 = 0;
 while (1) {
  if ((i3 | 0) >= (i5 | 0)) break;
  i2 = HEAP32[i6 >> 2] | 0;
  if (i2 >>> 0 < (HEAP32[i7 >> 2] | 0) >>> 0) {
   HEAP32[i6 >> 2] = i2 + 4;
   i2 = HEAP32[i2 >> 2] | 0;
  } else {
   i2 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0) | 0;
   if ((i2 | 0) == -1) break;
  }
  HEAP32[i1 >> 2] = i2;
  i3 = i3 + 1 | 0;
  i1 = i1 + 4 | 0;
 }
 return i3 | 0;
}

function __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i1, i3, i2, i5, i4, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 i8 = HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0;
 HEAP8[i7 >> 0] = HEAP8[i6 >> 0] | 0;
 i6 = mftCall_iiiiii(i8 | 0, i3 | 0, i2 | 0, i5 | 0, i4 | 0, i7 | 0) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZNK20LocalFileSystemPosix20GetApplicationFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
 __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i4, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i4) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4);
 i1 = i1 + 32 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB88811TexFormatI8EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP8[i4 >> 0] = (HEAPU8[gb + 1160176 + ((HEAPU8[i1 + 1 >> 0] | 0) << 2) + 1 >> 0] | 0) + (HEAPU8[gb + 1160176 + ((HEAPU8[i1 >> 0] | 0) << 2) >> 0] | 0) + (HEAPU8[gb + 1160176 + ((HEAPU8[i1 + 2 >> 0] | 0) << 2) + 2 >> 0] | 0);
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i1 + 128 >> 2] = gb + 27732 + 88;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN23ArchiveStorageConverterD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i3 = i1 + 144 | 0;
 __ZN4File5CloseEv(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 176 | 0);
 __ZN4FileD2Ev(i3);
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN39AssetBundleLoadFromMemoryAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i1 + 128 >> 2] = gb + 27732 + 88;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN23ArchiveStorageConverterD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i3 = i1 + 144 | 0;
 __ZN4File5CloseEv(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 176 | 0);
 __ZN4FileD2Ev(i3);
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN24GenerateTypeTreeTransferC2ER8TypeTree24TransferInstructionFlagsPvi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = i1 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = i3;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP16[i3 + 8 >> 1] = 0;
 HEAP32[i1 + 28 >> 2] = i4;
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 return;
}

function __ZN19VREyeTextureManager30ClearRenderTextureAndSetActiveEP13RenderTexture13GfxClearFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i2, 0, -1, 0, 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i3, i4, Math_fround(1.0), 0, HEAP32[gb + 1166248 >> 2] | 0);
 STACKTOP = i1;
 return;
}

function __ZN19SkinnedMeshRenderer24ReadSkinningDataForClothERK12SkinMeshInfob(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = i2 + 36 | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i7 = HEAP16[i2 + 56 >> 1] | 0;
 i5 = (i7 & 255) << 24 >> 24 ? i4 + (HEAP32[i2 + 48 >> 2] | 0) | 0 : 0;
 i4 = (i7 & 65535) > 255 ? i4 + (HEAP32[i2 + 52 >> 2] | 0) | 0 : 0;
 i7 = __Z9GetIClothv() | 0;
 mftCall_viiiiiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, HEAP32[i1 + 504 >> 2] | 0, HEAP32[i6 >> 2] | 0, i5 | 0, i4 | 0, HEAP32[i2 + 44 >> 2] | 0, i3 | 0);
 return;
}

function __ZN12ScriptMapperD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 68492 + 8;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1 + 44 | 0, HEAP32[i1 + 48 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1 + 32 | 0, HEAP32[i1 + 36 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10TagManager13StringToLayerERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 40 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE4findIS6_EENS_15__tree_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEERKT_(HEAP32[i3 >> 2] | 0, i2) | 0;
 if ((i1 | 0) == ((HEAP32[i3 >> 2] | 0) + 4 | 0)) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 return i3 | 0;
}

function __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 864 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z54ParticleAnimator_CUSTOM_INTERNAL_get_worldRotationAxisP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 36 >> 2] | 0;
  i1 = HEAP32[i3 + 40 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 32 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z54ParticleAnimator_CUSTOM_INTERNAL_get_localRotationAxisP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 48 >> 2] | 0;
  i1 = HEAP32[i3 + 52 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 44 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_originCustomP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 80 >> 2] | 0;
  i1 = HEAP32[i3 + 84 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 76 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_secondaryAxisP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 352 >> 2] | 0;
  i1 = HEAP32[i3 + 356 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 348 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalVectorP12Il2CppObjectiRK8Vector4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer18AddSetGlobalVectorERKN9ShaderLab16FastPropertyNameERK8Vector4f(i1, i4, i3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z46TerrainData_Set_Custom_PropWavingGrassStrengthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 HEAPF32[i3 + 128 + 76 >> 2] = f2;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return;
}

function __Z26Camera_CUSTOM_SetupCurrentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (i1 | 0) if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
  __ZN6Camera15StandaloneSetupER17ShaderPassContext(i2, HEAP32[gb + 1166248 >> 2] | 0);
  return;
 }
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, 0);
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 return;
}

function __Z23SetupLightShaderKeywordRK15SharedLightDataR17ShaderPassContext(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] & -32;
 HEAP32[i1 >> 2] = i2;
 switch (HEAP32[i3 + 40 >> 2] | 0) {
 case 0:
  {
   HEAP32[i1 >> 2] = i2 | 1;
   return;
  }
 case 2:
  if (!(HEAP8[i3 + 84 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2 | 8;
   return;
  } else {
   HEAP32[i1 >> 2] = i2 | 16;
   return;
  }
 case 1:
  if (!(HEAP8[i3 + 84 >> 0] | 0)) {
   HEAP32[i1 >> 2] = i2 | 2;
   return;
  } else {
   HEAP32[i1 >> 2] = i2 | 4;
   return;
  }
 default:
  return;
 }
}

function __Z22Input_CUSTOM_GetKeyInti(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 + -1 | 0) >>> 0 < 569) {
  i4 = __Z15GetInputManagerv() | 0;
  i3 = i1 >>> 5;
  i1 = ((HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + (i3 << 2) >> 2] | HEAP32[(HEAP32[i4 + 68 >> 2] | 0) + (i3 << 2) >> 2]) & 1 << (i1 & 31) | 0) != 0 & 1;
  STACKTOP = i2;
  return i1 | 0;
 }
 if (!i1) {
  i4 = 0;
  STACKTOP = i2;
  return i4 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536680 | 0, i2);
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEwj(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i1 = i2 + ((i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) << 2) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   break;
  }
  i1 = i1 + -4 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) {
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) i1 = i1 - i2 >> 2;
 return i1 | 0;
}

function __ZNK8VRDevice21GetCurrentEyeTexturesEPP13RenderTextureS2_(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 do if (i2 | 0) {
  i3 = HEAP32[i1 + 288 >> 2] | 0;
  if (!i3) {
   HEAP32[i2 >> 2] = 0;
   break;
  } else {
   HEAP32[i2 >> 2] = __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye(i3, 0) | 0;
   break;
  }
 } while (0);
 if (!i4) return;
 i1 = HEAP32[i1 + 288 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = 0;
  return;
 } else {
  HEAP32[i4 >> 2] = __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye(i1, 1) | 0;
  return;
 }
}

function __ZN5physx7NpScene19addArticulationLinkERNS_18NpArticulationLinkE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 16 | 0;
 __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i1, i3 + 48 | 0, 0);
 __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i3 + 20 | 0, i3);
 i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 228 >> 2] | 0, i3 | 0) | 0;
 if (i2 | 0) __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE(i1, i2 + 8 | 0);
 if (!(HEAP32[i3 + 16 >> 2] | 0)) return;
 __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i3 + 12 | 0);
 return;
}

function __ZN5physx2Sc15ArticulationSim12updateForcesEffbRKNS_6PxVec3Ebb(i1, f6, f9, i11, i7, i8, i10) {
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 f9 = Math_fround(f9);
 i11 = i11 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i4 = i1 + 24 | 0;
 i1 = 0;
 do {
  i3 = i1;
  i1 = i1 + 1 | 0;
  __ZN5physx2Sc7BodySim12updateForcesEffbRKNS_6PxVec3Ebb(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0, f6, f9, i11, i7, i8, i10);
  i2 = HEAP32[i5 >> 2] | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx2Gu12TriangleMeshC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = 3;
 HEAP16[i1 + 6 >> 1] = 3;
 HEAP32[i1 >> 2] = gb + 107352 + 8;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 93676 + 8;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 107420 + 8;
 HEAP32[i2 >> 2] = gb + 107420 + 88;
 __ZN5physx20InternalTriangleMeshC2Ev(i1 + 16 | 0);
 HEAP32[i1 + 144 >> 2] = 2122317823;
 HEAP32[i1 + 148 >> 2] = 2122317823;
 HEAP32[i1 + 152 >> 2] = 2122317823;
 HEAP32[i1 + 156 >> 2] = -25165825;
 HEAP32[i1 + 160 >> 2] = -25165825;
 HEAP32[i1 + 164 >> 2] = -25165825;
 return;
}

function __ZN5physx14NpArticulation17resolveReferencesERNS_24PxDeserializationContextE(i7, i5) {
 i7 = i7 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i1 = HEAP32[i7 + 92 >> 2] | 0;
 if (!i1) {
  i7 = i7 + 100 | 0;
  HEAP32[i7 >> 2] = 0;
  return;
 }
 i2 = i7 + 88 | 0;
 i6 = 0;
 do {
  i3 = (HEAP32[i2 >> 2] | 0) + (i6 << 2) | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) HEAP32[i3 >> 2] = mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, -2147483648, i4 | 0) | 0;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i1 | 0));
 i7 = i7 + 100 | 0;
 HEAP32[i7 >> 2] = 0;
 return;
}

function __ZN24MidPhaseQueryLocalReport7onEventEjPj(i1, i8, i7) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i8) return 1;
 i2 = i1 + 4 | 0;
 i6 = 0;
 do {
  i3 = HEAP32[i7 + (i6 << 2) >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
   __ZN5physx2Gu9Container6ResizeEj(i4, 1) | 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i5 >> 2] = i1 + 1;
  HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + (i1 << 2) >> 2] = i3;
  i6 = i6 + 1 | 0;
 } while ((i6 | 0) != (i8 | 0));
 return 1;
}

function __ZN22ProceduralMaterialData14SetArchiveDataEP20SubstanceArchiveData(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (i3 | 0) {
  i2 = i3 + 4 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 }
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = i3;
  return;
 }
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i1 >> 2] = i3;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = i3;
 return;
}

function __Z49ParticleEmitter_CUSTOM_INTERNAL_set_worldVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 144 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 148 >> 2] = i4;
  HEAP32[i3 + 152 >> 2] = i1;
  return;
 }
}

function __Z49ParticleEmitter_CUSTOM_INTERNAL_set_localVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 156 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 160 >> 2] = i4;
  HEAP32[i3 + 164 >> 2] = i1;
  return;
 }
}

function __Z31MonoBehaviour_CUSTOM_IsInvokingP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i3 = (__Z10IsInvokingR13MonoBehaviourR11ICallString(i2, i3) | 0) & 1;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _LzmaProps_Decode(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 < 5) {
  i3 = 4;
  return i3 | 0;
 }
 i2 = (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) | (HEAPU8[i1 + 3 >> 0] | 0) << 16 | (HEAPU8[i1 + 4 >> 0] | 0) << 24;
 HEAP32[i3 + 12 >> 2] = i2 >>> 0 < 4096 ? 4096 : i2;
 i1 = HEAP8[i1 >> 0] | 0;
 if ((i1 & 255) > 224) {
  i3 = 4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = ((i1 & 255) % 9 | 0) & 255;
 HEAP32[i3 + 8 >> 2] = ((i1 & 255) / 45 | 0) & 255;
 HEAP32[i3 + 4 >> 2] = ((((i1 & 255) / 9 | 0) & 255) % 5 | 0) & 255;
 i3 = 0;
 return i3 | 0;
}

function mftCall_iiiiifiiiiif(i12, i1, i2, i4, i5, d6, i7, i8, i9, i10, i11, d3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 d3 = +d3;
 if ((i12 | 0) >= (fb | 0) & (i12 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiifiiiiif[i12 - fb & 1](i1 | 0, i2 | 0, i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, Math_fround(d3)) | 0;
 return ftCall_iiiiifiiiiif(i12 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, +d3) | 0;
}

function __ZNSt3__26locale5__impD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP32[i3 >> 2] = gb + 212688 + 8;
 i4 = i3 + 8 | 0;
 i5 = i3 + 12 | 0;
 i2 = 0;
 while (1) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (i2 >>> 0 >= (HEAP32[i5 >> 2] | 0) - i1 >> 2 >>> 0) break;
  i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
  if (i1 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
  i2 = i2 + 1 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 144 | 0);
 __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i4);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (i3) i4 = 6;
 } else {
  i5 = i3 + 16 & -16;
  i4 = __Znwj(i5) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i4;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 return;
}

function __ZNK5physx3Cct13HandleManager9GetObjectEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i6 = 0;
 i1 = i4 & 65535;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 if (i1 >>> 0 >= i2 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i6 = HEAP16[(HEAP32[i5 + 12 >> 2] | 0) + (i1 << 1) >> 1] | 0;
 i3 = i6 & 65535;
 if (!(i6 << 16 >> 16 != -1 & i3 >>> 0 < i2 >>> 0)) {
  i6 = 0;
  return i6 | 0;
 }
 if ((HEAPU16[(HEAP32[i5 + 20 >> 2] | 0) + (i1 << 1) >> 1] | 0 | 0) != (i4 >>> 16 | 0)) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i3 << 2) >> 2] | 0;
 return i6 | 0;
}

function __ZN5physx19NpArticulationJointC2ERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 HEAP16[i5 + 4 >> 1] = 16;
 HEAP16[i5 + 6 >> 1] = 1;
 HEAP32[i5 >> 2] = gb + 91416 + 8;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = 0;
 i6 = i5 + 12 | 0;
 HEAP32[i6 >> 2] = 0;
 __ZN5physx2Sc21ArticulationJointCoreC2ERKNS_11PxTransformES4_(i5 + 20 | 0, i4, i2);
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & -251658241 | 150994944;
 HEAP32[i5 + 196 >> 2] = i3;
 HEAP32[i5 + 200 >> 2] = i1;
 return;
}

function __ZN29BillboardTreeInstanceRendererC2ER12TreeRendereriib(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN20IntermediateRendererC2Ev(i1);
 HEAP32[i1 + 264 >> 2] = 2;
 HEAP32[i1 + 268 >> 2] = i2;
 HEAP32[i1 + 272 >> 2] = i3;
 HEAP32[i1 >> 2] = gb + 184660 + 8;
 HEAP32[i1 + 280 >> 2] = i4;
 HEAPF32[i1 + 296 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 300 >> 0] = 1;
 i4 = i1 + 236 | 0;
 i5 = (HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16) & 16580607 | (i5 & 1) << 16;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 return;
}

function __ZN21LinearCollectionField8GetArrayEv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = 0;
 i5 = i2 + 4 | 0;
 HEAP32[i5 >> 2] = -1;
 i1 = __Z26scripting_field_get_offsetP9FieldInfo(HEAP32[i3 >> 2] | 0) | 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 if (!(HEAP8[i3 + 4 >> 0] | 0)) i1 = i1 + -8 + (HEAP32[i3 + 16 >> 2] | 0) | 0;
 i1 = HEAP32[i4 + i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) return;
 if (!(HEAP32[i3 + 24 >> 2] | 0)) i1 = __Z22scripting_array_lengthP11Il2CppArray(i1) | 0; else i1 = HEAP32[i4 + 12 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 return;
}

function __ZN15LightmapSTCacheC2ER13BatchRendererR15RenderLoopStats(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP8[i1 >> 0] = 1;
 i3 = __Z12GetGfxDevicev() | 0;
 HEAPF32[i3 + 980 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 984 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 988 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 992 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 996 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 1e3 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 1004 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 1008 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10TagManager11StringToTagERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 28 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE4findIS6_EENS_15__tree_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEERKT_(HEAP32[i3 >> 2] | 0, i2) | 0;
 if ((i1 | 0) == ((HEAP32[i3 >> 2] | 0) + 4 | 0)) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 48 >> 2] | 0;
 return i3 | 0;
}

function __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 864 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_get_sizeCustomP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 68 >> 2] | 0;
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z49ParticleEmitter_CUSTOM_INTERNAL_get_worldVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 148 >> 2] | 0;
  i1 = HEAP32[i3 + 152 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 144 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z49ParticleEmitter_CUSTOM_INTERNAL_get_localVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 160 >> 2] | 0;
  i1 = HEAP32[i3 + 164 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 156 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 376 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 380 >> 2] = i4;
  HEAP32[i3 + 384 >> 2] = i1;
  return;
 }
}

function __Z44TerrainData_Set_Custom_PropWavingGrassAmountP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 HEAPF32[i3 + 128 + 80 >> 2] = f2;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return;
}

function __Z16DeleteRenderLoopP10RenderLoop(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 if (!i5) return;
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 84 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i5 + 68 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 72 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 __ZdlPv(i5);
 return;
}

function _tt_glyph_load(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i3) {
  i5 = 37;
  return i5 | 0;
 }
 if (!i4) {
  i5 = 36;
  return i5 | 0;
 }
 if (!i2) {
  i5 = 35;
  return i5 | 0;
 }
 if ((HEAP32[i2 + 16 >> 2] | 0) >>> 0 <= i5 >>> 0) {
  i5 = 6;
  return i5 | 0;
 }
 if (i1 & 2) {
  i1 = (HEAP32[i2 + 8 >> 2] & 8192 | 0) == 0 ? i1 : i1 & -3;
  i1 = i1 >>> 14 & 2 | i1;
 }
 if (i1 & 1025) i1 = (HEAP32[i2 + 8 >> 2] | 0) >>> 12 & 2 ^ 11 | i1;
 i5 = _UNITY_TT_Load_Glyph(i4, i3, i5, i1) | 0;
 return i5 | 0;
}

function _ccosf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, f7 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 f7 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i6 >> 2] = f7;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 _ccoshf(i4, i5);
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function ___msl_assertion_failed(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 + 4 >> 2] = gb + 1576256;
 HEAP32[i5 + 8 >> 2] = gb + 1576256;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = i3;
 HEAP32[i5 + 20 >> 2] = i4;
 HEAP32[i5 + 24 >> 2] = 2;
 HEAP32[i5 + 28 >> 2] = 0;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP32[i5 + 36 >> 2] = 0;
 __Z17DebugStringToFileRK21DebugStringToFileData(i5);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_jj(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i4 | 0;
  return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, (i6 ? HEAP32[i2 >> 2] | 0 : i2) + i4 | 0, i3 >>> 0 < i5 >>> 0 ? i3 : i5) | 0;
 }
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i3 << 24 >> 24 < 0;
 i3 = i6 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255;
 if (i3 >>> 0 < i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1); else {
  i3 = i3 - i4 | 0;
  return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, (i6 ? HEAP32[i2 >> 2] | 0 : i2) + i4 | 0, i3 >>> 0 < i5 >>> 0 ? i3 : i5) | 0;
 }
 return 0;
}

function __ZNK9dtNavMesh25getTileAndPolyByRefUnsafeEyPPK10dtMeshTilePPK6dtPoly(i2, i3, i1, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = _bitshift64Lshr(i3 | 0, i1 | 0, 20) | 0;
 getTempRet0() | 0;
 i1 = i1 & 268435455;
 if ((i3 & 983040 | 0) == 65536 & 0 == 0) {
  HEAP32[i4 >> 2] = 0;
  i4 = 0;
  HEAP32[i5 >> 2] = i4;
  return;
 } else {
  i2 = i2 + 20 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i2 >> 2] | 0) + (i1 * 56 | 0);
  i4 = (HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 * 56 | 0) + 16 >> 2] | 0) + ((i3 & 65535) << 5) | 0;
  HEAP32[i5 >> 2] = i4;
  return;
 }
}

function __ZNK9DebugGLES19ProgramDeleteStatusEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i1 + 1992 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((i2 | 0) == 0 ? (HEAP32[gb + 74228 >> 2] | 0) == (i2 | 0) : 0) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 mftCall_viii(HEAP32[i1 + 92 >> 2] | 0, i2 | 0, 35712, i3 | 0);
 i3 = (HEAP32[i3 >> 2] | 0) == 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK9DebugGLES18ShaderDeleteStatusEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i1 + 1992 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 if ((i2 | 0) == 0 ? (HEAP32[gb + 74228 >> 2] | 0) == (i2 | 0) : 0) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 0;
 mftCall_viii(HEAP32[i1 + 492 >> 2] | 0, i2 | 0, 35712, i3 | 0);
 i3 = (HEAP32[i3 >> 2] | 0) == 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK9AudioClip12GetLengthSecEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) {
  i2 = HEAP32[i1 + 124 >> 2] | 0;
  if (i2 | 0) {
   if (HEAP32[i2 + 44 >> 2] | 0) {
    f3 = Math_fround(0.0);
    return Math_fround(f3);
   }
   i1 = HEAP32[i1 + 56 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   f3 = Math_fround(Math_fround(__ZNK14SoundHandleAPI11GetLengthMSEv(i1)) * Math_fround(.00100000005));
   return Math_fround(f3);
  }
 }
 f3 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 return Math_fround(f3);
}

function __ZNK20GpuProgramParameters16FindTextureParamERKN9ShaderLab16FastPropertyNameE16TextureDimension(i2, i3, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 i4 = HEAP32[i2 + 40 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i1 + 12 >> 2] | 0) == (i5 | 0)) {
   i2 = 6;
   break;
  }
  i1 = i1 + 16 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 i4 = i3 + (i5 << 3) | 0;
 if (!i5) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = HEAP32[i2 + 24 >> 2] | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i1 = i3;
 while (1) {
  if (((HEAP32[i1 >> 2] | 0) - i5 | 0) >>> 0 < i2 >>> 0) break;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 return i6 | 0;
}

function __ZN7mecanim9animation15HasMotionCurvesERKNS0_18ClipMuscleConstantE(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 1088 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1092 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1096 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1100 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1104 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1108 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 1112 >> 2] | 0) != -1;
 return i1 | 0;
}

function __ZN5physx8debugger14PvdMarshallingIhyE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = HEAPU8[i1 >> 0] | 0;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhxE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i6 = HEAPU8[i1 >> 0] | 0;
  i3 = i2;
  i5 = i3;
  HEAP8[i5 >> 0] = i6;
  HEAP8[i5 + 1 >> 0] = i6 >> 8;
  HEAP8[i5 + 2 >> 0] = i6 >> 16;
  HEAP8[i5 + 3 >> 0] = i6 >> 24;
  i3 = i3 + 4 | 0;
  HEAP8[i3 >> 0] = 0;
  HEAP8[i3 + 1 >> 0] = 0;
  HEAP8[i3 + 2 >> 0] = 0;
  HEAP8[i3 + 3 >> 0] = 0;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 8 | 0;
 }
 return;
}

function __ZN5physx49PxVehicleUpdateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE(f4, i2, i5, i1, i6, i3) {
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 __ZN5physx15PxVehicleUpdate40updateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE(f4, i2, i5, i1, i6, i3);
 return;
}

function __ZN5physx31PxSphereGeometryGeneratedValuesC2EPKNS_16PxSphereGeometryE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, f4 = f0;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  f4 = Math_fround(HEAPF32[i1 >> 2]);
  i1 = (HEAPF32[tempDoublePtr >> 2] = f4, HEAP32[tempDoublePtr >> 2] | 0);
  i2 = i1;
  i1 = !(f4 <= Math_fround(0.0)) & (i1 & 2139095040) >>> 0 < 2139095040 & 1;
  HEAP8[i3 >> 0] = i1;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 } else {
  i2 = HEAP32[i1 >> 2] | 0;
  i1 = 0;
  HEAP8[i3 >> 0] = i1;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN5physx2Sn5ConvX6outputEs(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP16[i1 >> 1] = i3;
 if (HEAP8[i2 + 325 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 if (HEAP8[i2 + 308 >> 0] | 0) {
  HEAP8[i1 >> 0] = (i3 & 65535) >>> 8;
  HEAP8[i1 + 1 >> 0] = i3;
 }
 i3 = HEAP32[i2 + 304 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 2) | 0;
 i3 = i2 + 312 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i1;
 STACKTOP = i4;
 return;
}

function __ZN5physx20PxGetFilterConstantsERNS_12PxGroupsMaskES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = gb + 1098832 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 HEAP16[i3 >> 1] = i5;
 HEAP16[i3 + 2 >> 1] = i5 >>> 16;
 i1 = i1 + 4 | 0;
 HEAP16[i1 >> 1] = i4;
 HEAP16[i1 + 2 >> 1] = i4 >>> 16;
 i1 = gb + 1098832 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2;
 HEAP16[i3 >> 1] = i4;
 HEAP16[i3 + 2 >> 1] = i4 >>> 16;
 i2 = i2 + 4 | 0;
 HEAP16[i2 >> 1] = i1;
 HEAP16[i2 + 2 >> 1] = i1 >>> 16;
 return;
}

function __ZN16b2StackAllocator4FreeEPv(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i5 = i4 + 102796 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i4 + 102412 + (i1 * 12 | 0) | 0;
 if (!(HEAP8[i3 + -4 >> 0] | 0)) {
  i2 = i3 + -8 | 0;
  i3 = i4 + 102400 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - (HEAP32[i2 >> 2] | 0);
 } else {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63408 | 0);
  i2 = i3 + -8 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
 }
 i4 = i4 + 102404 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0);
 HEAP32[i5 >> 2] = i1 + -1;
 return;
}

function __ZN14GrowableBufferC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i2;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = i4;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 i4 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 64, i1, 0, gb + 389912 | 0, 22) | 0;
 HEAP32[i1 + 8 >> 2] = i4;
 _memcpy(i4 | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 return;
}

function __ZN12MeshRenderer15UpdateLocalAABBEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 340 >> 2] | 0;
 i3 = i1 + 188 | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  i3 = i1 + 200 | 0;
  HEAP32[i3 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i3 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i3 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 } else {
  __ZN12MeshRenderer18CalculateLocalAABBER4AABBRKS_RK4Mesh(i3, i1, i2);
  return;
 }
}

function __ZN12HandlerChain10AtomicMoveER13FileEntryDataS1_(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 L1 : do if ((i2 | 0) == (i4 | 0)) i1 = i2; else {
  i1 = (HEAP8[i2 >> 0] | 0) == 110 ? i2 + 1 | 0 : i2;
  if ((i1 | 0) == (i4 | 0)) i1 = i2; else {
   i3 = HEAP8[i1 >> 0] | 0;
   if (i3 << 24 >> 24 == 48) {
    i1 = i1 + 1 | 0;
    break;
   }
   if ((i3 + -49 & 255) < 9) do {
    i1 = i1 + 1 | 0;
    if ((i1 | 0) == (i4 | 0)) {
     i1 = i4;
     break L1;
    }
   } while (((HEAP8[i1 >> 0] | 0) + -48 | 0) >>> 0 < 10); else i1 = i2;
  }
 } while (0);
 return i1 | 0;
}

function __ZN10Collider2D12SetIsTriggerEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 52 | 0;
 if ((HEAPU8[i2 >> 0] | 0 | 0) == (i1 & 1 | 0)) return;
 HEAP8[i2 >> 0] = i1 & 1;
 __ZN10Collider2D19WakeAllBodyContactsEv(i3);
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i3, i2);
  if (!i2) return;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, 0);
  return;
 }
 __ZN10Collider2D7CleanupEb(i3, 0);
 return;
}

function __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 380 >> 2] | 0;
  i1 = HEAP32[i3 + 384 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 376 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z47ParticleEmitter_CUSTOM_INTERNAL_set_rndVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 180 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 184 >> 2] = i4;
  HEAP32[i3 + 188 >> 2] = i1;
  return;
 }
}

function __Z45CullingGroup_CUSTOM_SetDistanceReferencePointP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  if (i3 | 0) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN12CullingGroup29SetDistanceReferenceTransformEPK9Transform(i3, i1);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z43TerrainData_Set_Custom_PropWavingGrassSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i4 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i4);
 }
 HEAPF32[i3 + 128 + 84 >> 2] = f2;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return;
}

function __ZThn8_N5physx2Sc18TriggerInteraction10initializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i1 + -8 | 0;
 i2 = i1 + 8 | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0) | 0;
 i3 = i1 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i2, i4);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i1 + 16 >> 2] | 0, i2);
 HEAP16[i1 + 52 >> 1] = 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 if (i3 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i3 >>> 0 < 11) {
  HEAP8[i1 + 11 >> 0] = i3;
  if (i3) i4 = 6;
 } else {
  i5 = i3 + 16 & -16;
  i4 = __Znwj(i5) | 0;
  HEAP32[i1 >> 2] = i4;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i3;
  i1 = i4;
  i4 = 6;
 }
 if ((i4 | 0) == 6) _memset(i1 | 0, i2 | 0, i3 | 0) | 0;
 HEAP8[i1 + i3 >> 0] = 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcjj(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i2 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i4; else {
  i5 = i2 + 16 & -16;
  i2 = _malloc(i5) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i2;
 }
 if (i4 | 0) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 return;
}

function __ZN8Renderer21RendererBecameVisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = i1 + 268 | 0;
 i5 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16 | 4096;
 HEAP16[i4 >> 1] = i5;
 HEAP8[i4 + 2 >> 0] = i5 >>> 16;
 __ZN6Object11InvokeEventEi(i1, 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1105296 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN8Material17SetShaderKeywordsERK8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i4 + 28 >> 2] = 0;
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i2, i4);
 __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet(i1, i4);
 STACKTOP = i3;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i5;
  HEAP32[i4 + 8 >> 2] = i3;
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 12 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 8 >> 2] = i5;
  HEAP32[i4 + 12 >> 2] = i3;
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 12 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc10NPhaseCore25addToDirtyInteractionListEPNS0_15CoreInteractionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1 + 68 | 0, i5, i4) | 0;
 if (HEAP8[i4 >> 0] | 0) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN5Light8SetColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 i3 = i1 + 44 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = HEAP32[i2 + 8 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 + 20 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 24 >> 2] = i7;
 HEAP32[i4 + 28 >> 2] = i6;
 HEAP32[i4 + 32 >> 2] = i5;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i3 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN20SoundChannelInstance6UpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 164 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) return;
 i5 = i3 + 148 | 0;
 i1 = HEAP16[i5 >> 1] | 0;
 if (i1 & 512) {
  i2 = (__ZN4FMOD7Channel11setPositionEjj(i2, HEAP32[i3 + 116 >> 2] | 0, 2) | 0) == 0;
  i1 = HEAP16[i5 >> 1] | 0;
  if (i2) {
   i1 = i1 & -513;
   HEAP16[i5 >> 1] = i1;
  }
 }
 if (!(i1 & 1024)) return;
 if (__ZN4FMOD7Channel11setPositionEjj(HEAP32[i4 >> 2] | 0, HEAP32[i3 + 120 >> 2] | 0, 1) | 0) return;
 HEAP16[i5 >> 1] = HEAP16[i5 >> 1] & -1025;
 return;
}

function __ZN20QuadTreeNodeRenderer5SetupEP15TerrainRendererP12QuadTreeNode20ReflectionProbeUsageP9Transform(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 264 >> 2] = i2;
 HEAP32[i1 + 268 >> 2] = i3;
 i3 = i1 + 236 | 0;
 i4 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16728063 | i4 << 14 & 49152;
 HEAP16[i3 >> 1] = i4;
 HEAP8[i3 + 2 >> 0] = i4 >>> 16;
 if (!i5) {
  i4 = 0;
  i5 = i1 + 248 | 0;
  HEAP32[i5 >> 2] = i4;
  return;
 }
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = i1 + 248 | 0;
 HEAP32[i5 >> 2] = i4;
 return;
}

function __ZN19ScriptingInvocation5CheckEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i7 = i1 + 200 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 i3 = __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i3) | 0;
 STACKTOP = i2;
 return (i3 | 0) == (HEAP32[i1 + 192 >> 2] | 0) | 0;
}

function __ZN17GenericDynamicVBO11SwapBuffersEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[gb + 1161252 >> 2] = 0;
 HEAP32[gb + 1161256 >> 2] = i1 + 1;
 HEAP32[gb + 1161272 + ((i1 & 1) * 20 | 0) + 12 >> 2] = 0;
 HEAP32[gb + 1161312 + 12 >> 2] = 0;
 i1 = i2 + 84 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) HEAP32[i1 >> 2] = 0;
 i1 = i2 + 88 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  i1 = i2 + 76 | 0;
  HEAP32[i1 >> 2] = 0;
  i2 = i2 + 80 | 0;
  HEAP32[i2 >> 2] = 0;
  return;
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = 0;
 i2 = i2 + 80 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14SerializedFile4TypeC2Eibs(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i2) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = i3 & 1;
 HEAP8[i1 + 41 >> 0] = 1;
 HEAP16[i1 + 42 >> 1] = i4;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = -1;
 return;
}

function __ZN13RuntimeStaticI13RendererSceneE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(156, i3, i4, gb + 1041912 | 0, 65) | 0;
  __ZN13RendererSceneC2Ev(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(156, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  __ZN13RendererSceneC2Ev(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN11UnityEngine15CloudWebService16SessionContainer20DeleteArchivedFolderERK8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i4 = i2 + 11 | 0;
 __Z29DeleteFileOrDirectoryIfExistsPKcb((HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 1) | 0;
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i4 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 i2 = (__ZNK15FileSystemEntry12FolderExistsEv(i3) | 0) ^ 1;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN10AudioMixer13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = (__Z21GetManagerFromContexti(3) | 0) + 68 | 0;
 i4 = i2 + 80 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 84 | 0; else {
  i2 = i2 + 84 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __Z47ParticleEmitter_CUSTOM_INTERNAL_get_rndVelocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 184 >> 2] | 0;
  i1 = HEAP32[i3 + 188 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 180 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z25PlayerPrefs_CUSTOM_HasKeyP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = (__ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z23WWW_Get_Custom_PropSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0)) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function __Z16SmartResetObjectR6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 27592 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 27592 + 28 >> 2] | 0) >>> 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 if (i2) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
  return;
 }
}

function __Z10tesvertCCWP10TESSvertexS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 28 >> 2]);
 f4 = Math_fround(HEAPF32[i3 + 28 >> 2]);
 f8 = Math_fround(f8 * Math_fround(f5 - f4));
 f7 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 f6 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 f4 = Math_fround(f8 + Math_fround(f7 * Math_fround(f4 - f6)));
 return Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 24 >> 2]) * Math_fround(f6 - f5)) + f4) >= Math_fround(0.0) | 0;
}

function mftCall_iiiiifiiiiii(i12, i1, i2, i4, i5, d6, i7, i8, i9, i10, i11, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 if ((i12 | 0) >= (fb | 0) & (i12 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiiiifiiiiii[i12 - fb & 7](i1 | 0, i2 | 0, i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0) | 0;
 return ftCall_iiiiifiiiiii(i12 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0) | 0;
}

function __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = i1;
 do if (!i4) i1 = 0; else {
  i2 = i1 + 112 | 0;
  if (i4 >>> 0 < 29 & (HEAP8[i2 >> 0] | 0) == 0) {
   HEAP8[i2 >> 0] = 1;
   break;
  } else {
   i1 = __Znwj(i4 << 2) | 0;
   break;
  }
 } while (0);
 HEAP32[i3 >> 2] = i1;
 i5 = i1 + (i5 << 2) | 0;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 12 >> 2] = i1 + (i4 << 2);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i4 + 11 | 0;
 i1 = HEAP8[i5 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i6 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
 } else {
  i6 = i4;
  i2 = i1 & 255;
 }
 i3 = (i2 | 0) != 0 & 1;
 i2 = i2 - i3 | 0;
 if (i2) {
  _memmove(i6 | 0, i6 + i3 | 0, i2 | 0) | 0;
  i1 = HEAP8[i5 >> 0] | 0;
 }
 if (i1 << 24 >> 24 < 0) HEAP32[i4 + 4 >> 2] = i2; else HEAP8[i5 >> 0] = i2;
 HEAP8[i6 + i2 >> 0] = 0;
 return;
}

function __ZNK13b2CircleShape5CloneEP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i2 = __ZN16b2BlockAllocator8AllocateEi(i2, 20) | 0;
 HEAP32[i2 >> 2] = gb + 151824 + 8;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 i5 = i1 + 4 | 0;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i3;
 i4 = i1 + 12 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i2 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 return i2 | 0;
}

function __ZN8JobQueue13ScheduleGroupEP8JobGroupNS_16JobQueuePriorityE(i4, i1, i5, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = i5 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) > 0) {
  i3 = i5 + 4 | 0;
  i1 = 0;
  do {
   mftCall_vii(HEAP32[i5 >> 2] | 0, HEAP32[i3 >> 2] | 0, i1 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i2 >> 2] | 0));
 }
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, HEAP32[i5 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i5, gb + 63456 | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 return;
}

function __ZN8Collider7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 36 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 if (__Z12GetIVehiclesv() | 0) {
  i3 = __Z12GetIVehiclesv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i1 | 0);
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0); else mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, 1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN7mecanim9animation13HasRootCurvesERKNS0_18ClipMuscleConstantE(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 1116 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1120 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1124 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1128 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1132 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 1136 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 1140 >> 2] | 0) != -1;
 return i1 | 0;
}

function __ZN5physx13BigConvexDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 3 | 0, HEAP32[i2 + 4 >> 2] | 0);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i2 + 16 >> 2] | 0);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 + 20 >> 2] | 0);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 2 | 0, i1);
  STACKTOP = i3;
  return;
 }
}

function __ZN5Unity5Cloth23SetExternalAccelerationERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0;
 i3 = i1 + 52 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f4 != Math_fround(HEAPF32[i3 >> 2]))) {
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  if (!(f4 != Math_fround(HEAPF32[i1 + 56 >> 2]))) {
   f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   if (!(f4 != Math_fround(HEAPF32[i1 + 60 >> 2]))) return;
  }
 }
 HEAP8[i1 + 357 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN4crnd9crnd_freeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = i4 + 16 | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 if (!(i1 & 7)) {
  mftCall_iiiiii(HEAP32[gb + 43044 >> 2] | 0, i1 | 0, 0, 0, 1, HEAP32[gb + 1157844 >> 2] | 0) | 0;
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i3 >> 2] = gb + 401209;
  HEAP32[i3 + 4 >> 2] = 2513;
  HEAP32[i3 + 8 >> 2] = gb + 401349;
  _sprintf(i2, gb + 401176 | 0, i3) | 0;
  _puts(i2) | 0;
  STACKTOP = i4;
  return;
 }
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 i3 = i1 + 132 | 0;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i3, 4);
 __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 44 | 0, i2);
 return;
}

function __ZN18AnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 902391 | 0, i1, 0);
 __ZN25RuntimeAnimatorController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer10SetVersionEi(i2, 5);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN18AnimatorController19TransferRuntimeDataI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z41Renderer_Set_Custom_PropShadowCastingModeP12Il2CppObject17ShadowCastingMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16777023 | i2 << 6 & 192;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function __Z39Renderer_Set_Custom_PropLightProbeUsageP12Il2CppObject15LightProbeUsage(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16580607 | i2 << 16 & 196608;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function __Z33CanvasRenderer_CUSTOM_SetMaterialP12Il2CppObjectS0_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   if (!i2) {
    i2 = 0;
    __ZN2UI14CanvasRenderer11SetMaterialEP8Materiali(i4, i2, i3);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN2UI14CanvasRenderer11SetMaterialEP8Materiali(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Profiler_Get_Custom_PropLogFilev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i3, (HEAP32[gb + 1451e3 >> 2] | 0) + 88 | 0);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_RKS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i5 = HEAP32[i1 >> 2] | 0; else i5 = i1;
 i7 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i6 = i2 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i1, i7 - i5 | 0, (HEAP32[i3 >> 2] | 0) - i7 | 0, i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i2 & 255) | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getProjectionPlaneERNS_6PxVec3ERf(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP32[i1 + 24 >> 2] & 512)) i1 = __ZNK5physx2Sc18ParticleSystemCore18getProjectionPlaneEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 28 | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZNK11b2EdgeShape11ComputeMassEP10b2MassDataf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f4 = Math_fround(f4 + Math_fround(HEAPF32[i1 + 20 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 16 >> 2]);
 f3 = Math_fround(Math_fround(f3 + Math_fround(HEAPF32[i1 + 24 >> 2])) * Math_fround(.5));
 HEAPF32[i2 + 4 >> 2] = Math_fround(f4 * Math_fround(.5));
 HEAPF32[i2 + 8 >> 2] = f3;
 HEAPF32[i2 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 return;
}

function __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4);
 i1 = i1 + 32 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN21DownloadHandlerScript23OnUnbindScriptingObjectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 i1 = i1 + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 return;
}

function __ZN15TextureTFMethodD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 77432 + 8;
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 20 | 0);
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 24 | 0);
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 28 | 0);
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) {
  __ZdlPv(i1);
  return;
 }
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) != (i4 | 0)) HEAP32[i2 >> 2] = i3 + (~((i3 + -4 - i4 | 0) >>> 2) << 2);
 __ZdlPv(i4);
 __ZdlPv(i1);
 return;
}

function __ZN13TextRendering4FontD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i1 >> 2] = gb + 185220 + 8;
 i3 = i1 + 48 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZNK6Object14GetMemoryLabelEv(i2, i1);
 if (i4 | 0) __ZN20TextRenderingPrivate8FontImplD2Ev(i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i5;
 return;
}

function __ZN13GfxDeviceGLES19CancelPendingMipGenEP17RenderSurfaceBase(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 i7 = i1 + 8488 | 0;
 i2 = HEAP32[i7 >> 2] | 0;
 if (!i2) return;
 i5 = i1 + 8476 | 0;
 i1 = 0;
 do {
  i3 = HEAP32[i5 >> 2] | 0;
  i4 = i3 + (i1 << 2) | 0;
  if ((HEAP32[i4 >> 2] | 0) == (i6 | 0)) {
   i8 = i4 + 4 | 0;
   _memmove(i4 | 0, i8 | 0, i3 + (i2 << 2) - i8 | 0) | 0;
   i2 = (HEAP32[i7 >> 2] | 0) + -1 | 0;
   HEAP32[i7 >> 2] = i2;
   i1 = i1 + -1 | 0;
  }
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __Z48LODGroup_CUSTOM_INTERNAL_get_localReferencePointP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 36 >> 2] | 0;
  i1 = HEAP32[i3 + 40 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 32 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z33GetAllowComponentReplacementClassi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i3 = -1;
  return i3 | 0;
 }
 L3 : while (1) {
  i2 = HEAP32[(HEAP32[gb + 1162556 >> 2] | 0) + 4 >> 2] | 0;
  if (i2 | 0) do {
   i3 = HEAP32[i2 + 16 >> 2] | 0;
   if ((i1 | 0) >= (i3 | 0)) {
    if ((i3 | 0) >= (i1 | 0)) {
     i2 = 9;
     break L3;
    }
    i2 = i2 + 4 | 0;
   }
   i2 = HEAP32[i2 >> 2] | 0;
  } while ((i2 | 0) != 0);
  i1 = __ZN6Object15GetSuperClassIDEi(i1) | 0;
  if (!i1) {
   i1 = -1;
   i2 = 9;
   break;
  }
 }
 if ((i2 | 0) == 9) return i1 | 0;
 return 0;
}

function mftCall_viiiifiiiiif(i12, i1, i2, i4, i5, d6, i7, i8, i9, i10, i11, d3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 d3 = +d3;
 if ((i12 | 0) >= (fb | 0) & (i12 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiiifiiiiif[i12 - fb & 1](i1 | 0, i2 | 0, i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, Math_fround(d3));
  return;
 }
 ftCall_viiiifiiiiif(i12 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, +d3);
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEcj(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 i1 = i2 + (i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = -1;
   break;
  }
  i1 = i1 + -1 | 0;
  if ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24) {
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) i1 = i1 - i2 | 0;
 return i1 | 0;
}

function __ZNK8Animator13GetLayerCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 628 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i2) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = i1 + 596 | 0;
 if (__ZNK9HPlayable7IsValidEv(i2) | 0) if (!(HEAP32[i3 >> 2] | 0)) {
  i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 }
 if (!(HEAP32[i3 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK26AnimatorControllerPlayable13GetLayerCountEv(HEAP32[HEAP32[i1 + 584 >> 2] >> 2] | 0) | 0;
 return i3 | 0;
}

function __ZN5physx5cloth11emptyBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 24 | 0;
 i6 = i2 + 20 | 0;
 i5 = i2 + 16 | 0;
 i3 = i2;
 HEAPF32[i6 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i5 >> 2] = __Z6simd4fRKf(i6) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i4, i5);
 __ZN8Scalar4faSERKS_(i1, i4) | 0;
 __ZngRK8Scalar4f(i3, i1);
 __ZN8Scalar4faSERKS_(i1 + 16 | 0, i3) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext14PrismaticJoint8setLimitERKNS_22PxJointLinearLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext13RevoluteJoint8setLimitERKNS_23PxJointAngularLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc9ClothCore24setParticleAccelerationsEPKNS_6PxVec4E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 312 >> 2] | 0, i1 | 0);
  STACKTOP = i4;
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 308 >> 2] | 0, i2 | 0, i1 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
  _memcpy(i1 | 0, i3 | 0, (HEAP32[i2 + 4 >> 2] | 0) - i1 | 0) | 0;
  STACKTOP = i4;
  return;
 }
}

function __ZN5physx2Sc15ClothFabricCoreD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1 + 4 | 0;
  i3 = (HEAP16[i4 >> 1] | 0) + -1 << 16 >> 16;
  HEAP16[i4 >> 1] = i3;
  if (!(i3 << 16 >> 16)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 }
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 if (!((i4 | 0) > -1 & (i4 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) return;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE(f3, i4, i5) {
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6;
 HEAPF32[i1 >> 2] = f3;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0);
 if (i4) {
  HEAP8[i1 >> 0] = i2 >>> 24;
  HEAP8[i1 + 3 >> 0] = i2;
  HEAP8[i1 + 1 >> 0] = i2 >>> 16;
  HEAP8[i1 + 2 >> 0] = i2 >>> 8;
 }
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i1 | 0, 4) | 0;
 STACKTOP = i6;
 return;
}

function __ZN5Unity5Cloth21SetRandomAccelerationERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0;
 i3 = i1 + 64 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (!(f4 != Math_fround(HEAPF32[i3 >> 2]))) {
  f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
  if (!(f4 != Math_fround(HEAPF32[i1 + 68 >> 2]))) {
   f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   if (!(f4 != Math_fround(HEAPF32[i1 + 72 >> 2]))) return;
  }
 }
 HEAP8[i1 + 357 >> 0] = 1;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN4crnd10dxt5_block17get_block_values8EPjjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = (((i2 * 6 | 0) + i3 | 0) >>> 0) / 7 | 0;
 HEAP32[i1 + 12 >> 2] = (((i3 << 1) + (i2 * 5 | 0) | 0) >>> 0) / 7 | 0;
 HEAP32[i1 + 16 >> 2] = (((i3 * 3 | 0) + (i2 << 2) | 0) >>> 0) / 7 | 0;
 HEAP32[i1 + 20 >> 2] = (((i3 << 2) + (i2 * 3 | 0) | 0) >>> 0) / 7 | 0;
 HEAP32[i1 + 24 >> 2] = (((i3 * 5 | 0) + (i2 << 1) | 0) >>> 0) / 7 | 0;
 HEAP32[i1 + 28 >> 2] = (((i3 * 6 | 0) + i2 | 0) >>> 0) / 7 | 0;
 return 8;
}

function __ZN13RuntimeStaticI12GraphicsCapsE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = i1 + 16 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i4 = __ZnwjRK10MemLabelIdiPKci(736, i3, i4, gb + 1041912 | 0, 65) | 0;
  __ZN12GraphicsCapsC2Ev(i4);
  HEAP32[i1 >> 2] = i4;
  return;
 } else {
  i4 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(736, i3, i4, i2, i1 + 48 | 0, gb + 1041912 | 0, 63) | 0;
  __ZN12GraphicsCapsC2Ev(i4);
  __Z19pop_allocation_rootv();
  HEAP32[i1 >> 2] = i4;
  return;
 }
}

function __ZN12HandlerChain9MakeLocalER13FileEntryDatab(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEEC2EPNS0_7SystemIEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi(i1, i3);
 return;
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z31Light_Set_Custom_PropCookieSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  __ZNK5Light16UnshareLightDataEv(i3);
  HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 64 >> 2] = f2;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
  __ZN5Light7PrecalcEv(i3);
  return;
 }
}

function __Z28GetGLSLPropertyNameRemapGLESPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(_strcmp(i1, HEAP32[gb + 1451104 >> 2] | 0) | 0)) i1 = 0; else if (!(_strcmp(i1, HEAP32[gb + 1451104 + 8 >> 2] | 0) | 0)) i1 = 1; else if (!(_strcmp(i1, HEAP32[gb + 1451104 + 16 >> 2] | 0) | 0)) i1 = 2; else if (!(_strcmp(i1, HEAP32[gb + 1451104 + 24 >> 2] | 0) | 0)) i1 = 3; else if (!(_strcmp(i1, HEAP32[gb + 1451104 + 32 >> 2] | 0) | 0)) i1 = 4; else {
  i2 = (_strncmp(i1, gb + 605728 | 0, 11) | 0) == 0;
  return (i2 ? i1 + 11 | 0 : 0) | 0;
 }
 return HEAP32[gb + 1451104 + (i1 << 3) + 4 >> 2] | 0;
}

function __Z23GL_CUSTOM_BeginInternali(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 switch (i2 | 0) {
 case 4:
  {
   i1 = 0;
   break;
  }
 case 5:
  {
   i1 = 1;
   break;
  }
 case 7:
  {
   i1 = 2;
   break;
  }
 case 1:
  {
   i1 = 3;
   break;
  }
 default:
  __ZN9Scripting18RaiseMonoExceptionEPKcz(gb + 518234 | 0, i3);
 }
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 580 >> 2] | 0, i2 | 0, i1 | 0, HEAP32[gb + 1188348 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __Z20ConfigureBlockRangesP10BlockRangeii(i5, i6, i1) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0;
 i4 = i6 + -1 | 0;
 i2 = (i4 + i1 | 0) / (i1 | 0) | 0;
 i4 = i4 + i2 | 0;
 i3 = (i4 >>> 0) / (i2 >>> 0) | 0;
 if (i2 >>> 0 > i4 >>> 0) return i3 | 0;
 i4 = i3 + -1 | 0;
 i1 = 0;
 do {
  i7 = Math_imul(i1, i2) | 0;
  HEAP32[i5 + (i1 * 12 | 0) >> 2] = i7;
  HEAP32[i5 + (i1 * 12 | 0) + 4 >> 2] = (i1 | 0) == (i4 | 0) ? i6 - i7 | 0 : i2;
  HEAP32[i5 + (i1 * 12 | 0) + 8 >> 2] = i3;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return i3 | 0;
}

function __Z18set_root_referencePvjRK10MemLabelIdP23AllocationRootReference(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i2 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2) | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i2) return;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN23AllocationRootReference15RemoveReferenceEP24ProfilerAllocationHeaderj(i1, i2, i3);
 if (!i4) return;
 __ZN23AllocationRootReference12AddReferenceEP24ProfilerAllocationHeaderj(i4, i2, i3);
 return;
}

function __GLOBAL__sub_I_runtime_mono_serializationbackend_directmemoryaccess_lump_cpp() {
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[gb + 1163040 >> 2] = 0;
 i3 = gb + 63416 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = gb + 1163040 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1163040 + 12 >> 2] = 16;
 i1 = gb + 1163040 + 16 | 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(fb + 3417 | 0, fb + 3418 | 0, 0, gb + 1163040 | 0);
 return;
}

function _UNITY_FT_Vector_Transform_Scaled(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i1 << 16;
 if (!((i2 | 0) != 0 & (i3 | 0) != 0)) return;
 i6 = HEAP32[i2 >> 2] | 0;
 i5 = _UNITY_FT_MulDiv(i6, HEAP32[i3 >> 2] | 0, i1) | 0;
 i4 = i2 + 4 | 0;
 i7 = HEAP32[i4 >> 2] | 0;
 i5 = (_UNITY_FT_MulDiv(i7, HEAP32[i3 + 4 >> 2] | 0, i1) | 0) + i5 | 0;
 i6 = _UNITY_FT_MulDiv(i6, HEAP32[i3 + 8 >> 2] | 0, i1) | 0;
 i3 = (_UNITY_FT_MulDiv(i7, HEAP32[i3 + 12 >> 2] | 0, i1) | 0) + i6 | 0;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i4 >> 2] = i3;
 return;
}

function mftCall_iiiiiiiiiiii(i12, i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 if ((i12 | 0) >= (fb | 0) & (i12 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiiiiiiii[i12 - fb & 3](i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0) | 0;
 return ftCall_iiiiiiiiiiii(i12 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0) | 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPKv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPKv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getProjectionPlaneERNS_6PxVec3ERf(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 if (!(HEAP32[i1 + 24 >> 2] & 512)) i1 = __ZNK5physx2Sc18ParticleSystemCore18getProjectionPlaneEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 28 | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i6;
 HEAP32[i3 + 8 >> 2] = i5;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZNK23SharedMeshRenderingData20GetRuntimeMemorySizeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = HEAP32[i3 + 12 >> 2] | 0;
 if (i2) i1 = (HEAP32[i2 + 24 >> 2] | 0) + i1 | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if (i2) i1 = (HEAP32[i2 + 24 >> 2] | 0) + i1 | 0;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) i2 = i1; else i2 = (HEAP32[i2 + 24 >> 2] | 0) + i1 | 0;
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (!i1) {
  i3 = i2;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 24 >> 2] | 0) + i2 | 0;
 return i3 | 0;
}

function __ZNK10GameObject23QueryComponentTransformEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = i2 + (i5 << 3) | 0;
 if (!i5) {
  i6 = 0;
  return i6 | 0;
 }
 i4 = HEAP32[gb + 28940 + 24 >> 2] | 0;
 i5 = HEAP32[gb + 28940 + 28 >> 2] | 0;
 i1 = i2;
 while (1) {
  if (((HEAP32[i1 >> 2] | 0) - i4 | 0) >>> 0 < i5 >>> 0) break;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 0;
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 return i6 | 0;
}

function __ZN5physx3Ext14SphericalJoint12setLimitConeERKNS_16PxJointLimitConeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 72 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx11NpAggregateD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 90184 + 8;
 __ZN5physx9NpFactory18onAggregateReleaseEPNS_11PxAggregateE(HEAP32[gb + 1457204 >> 2] | 0, i2);
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 40 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5Umbra11ShadowUtils12getCameraDofERKNS_9Matrix4x4E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i2 + 32 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 36 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 40 >> 2]);
 f5 = Math_fround(Math_fround(1.0) / Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f6 * f6) + Math_fround(f4 * f4)) + Math_fround(f3 * f3)))));
 f4 = Math_fround(f4 * f5);
 f3 = Math_fround(f3 * f5);
 HEAPF32[i1 >> 2] = Math_fround(f6 * f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN4Mesh15UnshareMeshDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = i1 + 32 | 0;
 if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0) == 1) return;
 i2 = __ZnwjRK10MemLabelIdiPKci(224, gb + 63232 | 0, 16, gb + 425656 | 0, 2283) | 0;
 __ZN14SharedMeshDataC2ERKS_(i2, HEAP32[i1 >> 2] | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
 }
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN12ServerSocket14StartListeningEPKctb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i2 = _inet_addr(i2 | 0) | 0;
 i3 = _htons(i3) | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = 0;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP16[i6 >> 1] = 2;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP16[i6 + 2 >> 1] = i3;
 i4 = __ZN12ServerSocket14StartListeningEPK8sockaddrjb(i1, i6, 16, i4) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN11AudioSource16SetReverbZoneMixEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 i6 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.10000002);
 f2 = i7 ? Math_fround(1.10000002) : f2;
 HEAPF32[i5 >> 2] = i6 ? Math_fround(0.0) : f2;
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1 + 124 | 0, i4, i4 + 16 | 0);
 STACKTOP = i3;
 return;
}

function __ZN10VertexData8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 i2 = i2 + 4 | 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(0, i2);
 STACKTOP = i1;
 return;
}

function __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z51BillboardAsset_CUSTOM_SetImageTexCoordsInternalListP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 + 8 >> 2] | 0, 0, 16) | 0;
  __ZN14BillboardAsset9SetImagesEPK8Vector4fj(i3, i1, HEAP32[i2 + 12 >> 2] | 0);
  return;
 }
}

function __Z46Cloth_CUSTOM_INTERNAL_get_externalAccelerationP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 56 >> 2] | 0;
  i1 = HEAP32[i3 + 60 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 52 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z45ParticleAnimator_CUSTOM_INTERNAL_set_rndForceP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 56 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 60 >> 2] = i4;
  HEAP32[i3 + 64 >> 2] = i1;
  return;
 }
}

function __Z44CharacterJoint_CUSTOM_INTERNAL_get_swingAxisP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 100 >> 2] | 0;
  i1 = HEAP32[i3 + 104 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 96 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z38Renderer_Set_Custom_PropUseLightProbesP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16580607 | (i2 << 24 >> 24 != 0 & 1) << 16;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function __Z30Light_Set_Custom_PropSpotAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  __ZNK5Light16UnshareLightDataEv(i3);
  HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 60 >> 2] = f2;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
  __ZN5Light7PrecalcEv(i3);
  return;
 }
}

function __Z15CleanupGUIStatei(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = gb + 1468832 + (i1 << 2) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP8[i1 + 284 >> 0] | 0) {
  i1 = HEAP32[i1 + 280 >> 2] | 0;
  if (i1 | 0) __ZN10InputEventD2Ev(i1);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 + 280 >> 2] = 0;
 }
 if (!i1) {
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __ZN8GUIStateD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function _UNITY_FT_Stream_Read(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 8 | 0;
 i7 = HEAP32[i6 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (i3 >>> 0 <= i7 >>> 0) {
  i7 = 85;
  return i7 | 0;
 }
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i4) {
  i4 = i3 - i7 | 0;
  i4 = i4 >>> 0 > i5 >>> 0 ? i5 : i4;
  _memcpy(i2 | 0, (HEAP32[i1 >> 2] | 0) + i7 | 0, i4 | 0) | 0;
  i1 = i4;
 } else i1 = mftCall_iiiii(i4 | 0, i1 | 0, i7 | 0, i2 | 0, i5 | 0) | 0;
 HEAP32[i6 >> 2] = i1 + i7;
 i7 = i1 >>> 0 < i5 >>> 0 ? 85 : 0;
 return i7 | 0;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatRGB888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU16[i1 >> 1] | 0;
  i5 = i3 << 5 & 64512;
  HEAP8[i4 >> 0] = i3 >>> 8 & 248 | i3 >>> 13;
  HEAP8[i4 + 1 >> 0] = (i5 >>> 6 | i5) >>> 8;
  HEAP8[i4 + 2 >> 0] = (i3 << 14 & 458752 | i3 << 19) >>> 16;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx38PxVehicleSuspensionDataGeneratedValuesC2EPKNS_23PxVehicleSuspensionDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_11ConvexHullVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5Umbra9crc32HashEPKjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 } else i3 = -1;
 while (1) {
  i5 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[gb + 79084 + (((i5 ^ i3) & 255) << 2) >> 2] ^ i3 >>> 8;
  i4 = HEAP32[gb + 79084 + (((i5 >>> 8 ^ i4) & 255) << 2) >> 2] ^ i4 >>> 8;
  i4 = HEAP32[gb + 79084 + (((i5 >>> 16 ^ i4) & 255) << 2) >> 2] ^ i4 >>> 8;
  i3 = HEAP32[gb + 79084 + ((i5 >>> 24 ^ i4 & 255) << 2) >> 2] ^ i4 >>> 8;
  i2 = i2 + -4 | 0;
  if (!i2) break; else i1 = i1 + 4 | 0;
 }
 i5 = ~i3;
 return i5 | 0;
}

function __ZN4gles16AddForceCullModeER15DeviceStateGLESPK17DeviceRasterState8CullMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i2 = (i2 | 0) == 0 ? HEAP32[i1 + 472 >> 2] | 0 : i2;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i5 >> 2] = i3;
 i3 = __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i1, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDevice9TextureID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 12 >> 2] = Math_fround(1.0);
 __ZL19BlitFramebufferImplRN4gles23BlitFramebufferDrawQuadER9GfxDevice9TextureIDRK8Vector4f(i1, i2, HEAP32[i3 >> 2] | 0, i5);
 STACKTOP = i4;
 return;
}

function __ZN22ParticleSystemRenderer15UpdateLocalAABBEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = i1 + 188 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 20 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN12NavMeshAgent27UpdateActiveAgentParametersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  STACKTOP = i3;
  return;
 }
 __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams(i1, i2);
 __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i2);
 STACKTOP = i3;
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags(i3, 1);
 i2 = i1 + 380 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) {
  __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
  return;
 }
 HEAP32[i2 >> 2] = i1;
 __ZN17RemapPPtrTransfer11PopMetaFlagEv(i3);
 return;
}

function __Z45ParticleAnimator_CUSTOM_INTERNAL_get_rndForceP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 60 >> 2] | 0;
  i1 = HEAP32[i3 + 64 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 56 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z38Renderer_Set_Custom_PropReceiveShadowsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16776959 | (i2 << 24 >> 24 != 0 & 1) << 8;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function _Update_Max(i1, i6, i2, i3, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i4 = 0, i5 = 0, i8 = 0, i9 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i8;
 i5 = HEAP32[i6 >> 2] | 0;
 if (i5 >>> 0 < i7 >>> 0) {
  i9 = Math_imul(i5, i2) | 0;
  i5 = Math_imul(i7, i2) | 0;
  HEAP32[i3 >> 2] = _UNITY_ft_mem_realloc(i1, 1, i9, i5, HEAP32[i3 >> 2] | 0, i4) | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) {
   HEAP32[i6 >> 2] = i7;
   i1 = 0;
  }
 } else i1 = 0;
 STACKTOP = i8;
 return i1 | 0;
}

function _wcscspn(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 do if (!i1) i1 = _wcslen(i4) | 0; else {
  if (!(HEAP32[i3 + 4 >> 2] | 0)) {
   i1 = _wcschr(i4, i1) | 0;
   if (!i1) {
    i1 = _wcslen(i4) | 0;
    break;
   } else {
    i1 = i1 - i4 >> 2;
    break;
   }
  }
  i2 = HEAP32[i4 >> 2] | 0;
  L10 : do if (!i2) i1 = i4; else {
   i1 = i4;
   do {
    if (_wcschr(i3, i2) | 0) break L10;
    i1 = i1 + 4 | 0;
    i2 = HEAP32[i1 >> 2] | 0;
   } while ((i2 | 0) != 0);
  } while (0);
  i1 = i1 - i4 >> 2;
 } while (0);
 return i1 | 0;
}

function _unity_z_inflateEnd(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 if (!i3) {
  i6 = -2;
  return i6 | 0;
 }
 i6 = i3 + 28 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (!i1) {
  i6 = -2;
  return i6 | 0;
 }
 i4 = i3 + 36 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) {
  i6 = -2;
  return i6 | 0;
 }
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = i3 + 40 | 0;
 if (i5) {
  mftCall_vii(i2 | 0, HEAP32[i3 >> 2] | 0, i5 | 0);
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 mftCall_vii(i2 | 0, HEAP32[i3 >> 2] | 0, i1 | 0);
 HEAP32[i6 >> 2] = 0;
 i6 = 0;
 return i6 | 0;
}

function _strtok(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i1 = HEAP32[gb + 1470400 >> 2] | 0;
  if (!i1) i1 = 0; else i3 = 3;
 } else i3 = 3;
 do if ((i3 | 0) == 3) {
  i1 = i1 + (_strspn(i1, i2) | 0) | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   HEAP32[gb + 1470400 >> 2] = 0;
   i1 = 0;
   break;
  }
  i2 = i1 + (_strcspn(i1, i2) | 0) | 0;
  HEAP32[gb + 1470400 >> 2] = i2;
  if (!(HEAP8[i2 >> 0] | 0)) {
   HEAP32[gb + 1470400 >> 2] = 0;
   break;
  } else {
   HEAP32[gb + 1470400 >> 2] = i2 + 1;
   HEAP8[i2 >> 0] = 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwm(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwl(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcm(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcl(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i5 = mftCall_iiiiii(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNK5Umbra9Matrix2x2eqERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 4 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 8 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 if (f3 != Math_fround(HEAPF32[i2 + 12 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1;
 return i2 | 0;
}

function __ZNK16LightmapSettings17AcquireSharedDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 28 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63160 | 0, 16, gb + 518148 | 0, 86) | 0;
  HEAP32[i1 + 4 >> 2] = 1;
  HEAP32[i1 >> 2] = gb + 43424 + 8;
  HEAP32[i1 + 8 >> 2] = 1;
  HEAP32[i1 + 12 >> 2] = 1;
  i3 = i1 + 16 | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
 }
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE8ContainsEPKv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1103852 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 52 >> 2] | 0;
  if ((i3 | 0) != 0 & (i1 | 0) == (i3 | 0)) {
   i3 = 1;
   return i3 | 0;
  }
  if (i1 | 0) {
   i1 = HEAP32[i2 + 32 >> 2] | 0;
   if (i1 >>> 0 <= i3 >>> 0) if ((i1 + (HEAP32[i2 + 36 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
    i3 = 1;
    return i3 | 0;
   }
  }
  if (__ZNK14StackAllocator20IsOverflowAllocationEPKv(i2, i3) | 0) {
   i3 = 1;
   return i3 | 0;
  }
 }
 i3 = 0;
 return i3 | 0;
}

function __ZN9Transform5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i1 = i1 + 68 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i6 = HEAPU16[i1 >> 1] | 0;
  i3 = i6 << 4 & 61440;
  i5 = i6 << 16 & 15728640;
  HEAP32[i4 >> 2] = i6 << 28 | i6 >>> 12 | i6 >>> 8 & 240 | i6 << 24 & 251658240 | i5 | i3 | i5 >>> 4 | i3 >>> 4;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2;
 i2 = (i3 - i2 | 0) / 24 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 if ((i3 | 0) == (i1 | 0)) return;
 i3 = 0;
 do {
  i5 = i1 + (i3 * 24 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx3Scb5Scene22removeBroadPhaseRegionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2433 >> 0] | 0)) {
  i2 = __ZN5physx2Sc5Scene22removeBroadPhaseRegionEj(i2 + 16 | 0, i1) | 0;
  STACKTOP = i3;
  return i2 | 0;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 682639 | 0, 1482, gb + 703913 | 0, i3);
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZN5Umbra9Matrix2x211flushToZeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2]))) <= 1.0e-15) HEAPF32[i2 >> 2] = Math_fround(0.0);
 i1 = i2 + 4 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 8 | 0;
 if (+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15) HEAPF32[i1 >> 2] = Math_fround(0.0);
 i1 = i2 + 12 | 0;
 if (!(+Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2]))) <= 1.0e-15)) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 return;
}

function __ZN4gles25CreateRenderSurfaceCommonEP7ApiGLESP17RenderSurfaceGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63304 | 0, 16, gb + 609299 | 0, 150) | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i2 + 32 >> 2] = i3;
 i3 = i2 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[(HEAP32[gb + 1451148 >> 2] | 0) + 12 >> 2] | 0;
 HEAP32[i3 >> 2] = i4 >>> 0 > i5 >>> 0 ? i5 : i4;
 i1 = __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES(i1, i2) | 0;
 if (!i1) return;
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __ZN24MaterialDisplayListCache17CachedShaderEntry7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i2 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
  }
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i4 = i1 + 32 | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 }
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN18AssetBundleManager35RemoveAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = i2;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E5eraseERS4_(i1 + 16 | 0, i3) | 0;
 STACKTOP = i4;
 return;
}

function __ZN12HandlerChain6DeleteER13FileEntryDatab(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN12HandlerChain4CopyER13FileEntryDataS1_(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0, i4 | 0, i5 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN11UnityEngine15PlatformWrapper14GetSensorFlagsEv() {
 var i1 = 0, i2 = 0;
 i1 = (__Z15IsGyroAvailablev() | 0) & 1;
 i2 = __ZN10systeminfo21SupportsAccelerometerEv() | 0;
 i1 = i2 ? i1 | 2 : i1;
 i2 = __ZN10systeminfo23SupportsLocationServiceEv() | 0;
 i1 = i2 ? i1 | 4 : i1;
 i2 = __ZN15LocationService18IsHeadingAvailableEv() | 0;
 i1 = i2 ? i1 | 8 : i1;
 i2 = __Z19IsMultiTouchEnabledv() | 0;
 i1 = i2 ? i1 | 16 : i1;
 i2 = __ZN10systeminfo17SupportsVibrationEv() | 0;
 i1 = i2 ? i1 | 32 : i1;
 i2 = __Z24IsTouchPressureSupportedv() | 0;
 return (i2 ? i1 | 64 : i1) | 0;
}

function __Z44NavMeshObstacle_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 84 >> 2] | 0;
  i1 = HEAP32[i3 + 88 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 80 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z44Cloth_CUSTOM_INTERNAL_get_randomAccelerationP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 68 >> 2] | 0;
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z42Shader_CUSTOM_SetGlobalVectorArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i1, i2);
 STACKTOP = i3;
 return;
}

function __Z42Shader_CUSTOM_SetGlobalMatrixArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i1, i2);
 STACKTOP = i3;
 return;
}

function __Z20SyncFenceCullResultsR11CullResults(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 if (HEAP32[i2 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i2);
 i1 = i2 + 1312 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i5 = i2 + 372 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if (!i1) return;
 i4 = i2 + 360 | 0;
 i3 = 0;
 do {
  i2 = (HEAP32[i4 >> 2] | 0) + (i3 * 960 | 0) + 72 | 0;
  if (HEAP32[i2 >> 2] | 0) {
   __Z21CompleteFenceInternalR8JobFence(i2);
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return;
}

function _unzCloseCurrentFile(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = -102;
  return i4 | 0;
 }
 i3 = i1 + 156 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  i4 = -102;
  return i4 | 0;
 }
 if (!(HEAP32[i4 + 92 >> 2] | 0)) if (!(HEAP32[i4 + 140 >> 2] | 0)) i1 = (HEAP32[i4 + 80 >> 2] | 0) == (HEAP32[i4 + 84 >> 2] | 0) ? 0 : -105; else i1 = 0; else i1 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (i2 | 0) _free(i2);
 HEAP32[i4 >> 2] = 0;
 if (HEAP32[i4 + 64 >> 2] | 0) _unity_z_inflateEnd(i4 + 4 | 0) | 0;
 _free(i4);
 HEAP32[i3 >> 2] = 0;
 i4 = i1;
 return i4 | 0;
}

function __ZNK10EnumTraits14ReflectionInfo15GetNameForValueEi(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i5 = i4 + (i1 << 2) | 0;
 L1 : do if (!i1) i1 = i4; else {
  i1 = i4;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i5 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + (i1 - i4 >> 2 << 2) >> 2] | 0;
 return i5 | 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i1, i2);
 __ZN8Scalar4fC2ERKS_(i1 + 16 | 0, i1);
 __ZN8Scalar4fC2ERKS_(i1 + 32 | 0, i1);
 __ZN8Scalar4fC2ERKS_(i1 + 48 | 0, i1);
 __ZN8Scalar4fC2ERKS_(i1 + 64 | 0, i1);
 __ZN8Scalar4fC2ERKS_(i1 + 80 | 0, i1);
 __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i1 + 96 | 0, gb + 1097856 | 0);
 STACKTOP = i2;
 return;
}

function __ZN4crnd10dxt1_block15unpack_endpointEjjbj(i6, i1, i2, i5, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i3 = 0, i4 = 0;
 i2 = i1 >>> (i2 << 4);
 i4 = i2 & 65535;
 i1 = i2 & 31;
 i2 = i2 >>> 5 & 63;
 i3 = i4 >>> 11;
 if (i5) {
  i3 = i3 << 3 | i4 >>> 13;
  i2 = i2 << 2 | i2 >>> 4;
  i1 = i1 << 3 | i1 >>> 2;
 }
 HEAP8[i6 >> 0] = (i3 | 0) > 255 ? 255 : i3;
 HEAP8[i6 + 1 >> 0] = (i2 | 0) > 255 ? 255 : i2;
 HEAP8[i6 + 2 >> 0] = (i1 | 0) > 255 ? 255 : i1;
 HEAP8[i6 + 3 >> 0] = (i7 | 0) < 0 ? 0 : ((i7 | 0) > 255 ? 255 : i7) & 255;
 return;
}

function __ZN13RuntimeStaticI23MeshVertexFormatManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (!i2) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190020 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEEC2EPNS0_7SystemIEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7SetSizeEi(i1, i3);
 return;
}

function __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetDampenP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 884 >> 2] | 0) + 1068 >> 2]);
 return Math_fround(f3);
}

function __Z42ReflectionProbe_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 76 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 80 >> 2] = i4;
  HEAP32[i3 + 84 >> 2] = i1;
  return;
 }
}

function __Z42ParticleAnimator_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 68 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 72 >> 2] = i4;
  HEAP32[i3 + 76 >> 2] = i1;
  return;
 }
}

function _cacoshf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3 + 8 | 0;
 i6 = i3;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 _cacosf(i4, i5);
 i2 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i1 >> 2] = Math_fround(-Math_fround(HEAPF32[i4 + 4 >> 2]));
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEwj(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (!i1) i1 = -1; else {
  i1 = i2 + ((i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) << 2) | 0;
  do {
   if ((i1 | 0) == (i2 | 0)) {
    i1 = -1;
    break L5;
   }
   i1 = i1 + -4 | 0;
  } while ((HEAP32[i1 >> 2] | 0) != (i4 | 0));
  i1 = i1 - i2 >> 2;
 } while (0);
 return i1 | 0;
}

function __ZNK9Texture2D16GetNpotTexelSizeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 if (!(HEAP8[i2 + 110 >> 0] | 0)) {
  i3 = HEAP32[i2 + 72 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 68 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  return;
 } else {
  f5 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0));
  f4 = Math_fround(Math_fround(1.0) / Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0));
  HEAPF32[i1 >> 2] = f5;
  HEAPF32[i1 + 4 >> 2] = f4;
  return;
 }
}

function __ZNK5physx7NpScene23getSimulationStatisticsERNS_22PxSimulationStatisticsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 3696 >> 0] | 0)) {
  __ZNK5physx2Sc5Scene8getStatsERNS_22PxSimulationStatisticsE(i2 + 32 | 0, i1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 1503, gb + 705331 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAP32[i4 + 4 >> 2] = HEAP32[i5 + ((i3 & 65535) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6Socket7ConnectEPKctlbb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i1 = _inet_addr(i1 | 0) | 0;
 i2 = _htons(i2) | 0;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i7 + 8 >> 2] = 0;
 HEAP32[i7 + 12 >> 2] = 0;
 HEAP16[i7 >> 1] = 2;
 HEAP32[i7 + 4 >> 2] = i1;
 HEAP16[i7 + 2 >> 1] = i2;
 i5 = __ZN6Socket7ConnectEPK8sockaddrjlbb(i7, 16, i3, i4, i5) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj(i1, i6, i5) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if ((HEAP32[i1 + 8 >> 2] & 2147483647) >>> 0 < i6 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj(i1, i6);
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = i2 + (i6 << 2) | 0;
 if ((i1 | 0) >= (i6 | 0)) {
  HEAP32[i3 >> 2] = i6;
  return;
 }
 i1 = i2 + (i1 << 2) | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
  i1 = i1 + 4 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 HEAP32[i3 >> 2] = i6;
 return;
}

function __ZN5physx2Gu26checkOverlapOBB_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 + 16 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i3 + 20 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i3 + 24 >> 2];
 HEAP32[i5 + 12 >> 2] = i2;
 i3 = __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE(i5, i1) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx17PxcNpMemBlockPool11flushUnusedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2 + 116 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  STACKTOP = i5;
  return;
 }
 i2 = i2 + 112 | 0;
 do {
  i7 = i1 + -1 | 0;
  i6 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i7 << 2) >> 2] | 0;
  HEAP32[i4 >> 2] = i7;
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i6);
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 STACKTOP = i5;
 return;
}

function __ZN5physx10NpMaterial12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP16[i2 + 6 >> 1] = 2;
 HEAP32[i2 >> 2] = gb + 93588 + 8;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = gb + 93676 + 8;
 HEAP32[i2 + 16 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 93280 + 8;
 HEAP32[i3 >> 2] = gb + 93280 + 108;
 HEAP16[i2 + 44 >> 1] = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 64;
 HEAP32[i2 + 48 >> 2] = i2;
 __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i2) | 0;
 return i2 | 0;
}

function __ZN25MultiBlocksMemoryFileDataD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 71660 + 8;
 i3 = i2 + 20 | 0;
 i4 = i2 + 32 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i2 + 8 | 0;
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i5);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) {
  __ZdlPv(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 24 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN19VREyeTextureManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 if (!i5) {
  STACKTOP = i6;
  return;
 }
 if ((i4 | 0) != (i5 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -20 - i5 | 0) >>> 0) / 20 | 0) * 20 | 0);
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 >> 2] = 87;
 HEAP32[i2 + 4 >> 2] = i4;
 __Z19free_alloc_internalPvRK10MemLabelId(i5, i2);
 STACKTOP = i6;
 return;
}

function __ZN16UploadHandlerRawD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 187876 + 8;
 i1 = i3 + 24 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63808 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 187928 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN13SparseTexture19UnloadFromGfxDeviceEb(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4 + 4 | 0;
 i2 = i4;
 i3 = i5 + 100 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  STACKTOP = i4;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i3 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZL53SortBehaviourItemByExecutionOrderAndReverseInstanceIDRKN18AwakeFromLoadQueue4ItemES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z24GetExecutionOrderManagerv() | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEiPKN5Unity4TypeE(i5, i4, HEAP32[i1 + 8 >> 2] | 0) | 0;
 i2 = __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEiPKN5Unity4TypeE(i5, i3, HEAP32[i2 + 8 >> 2] | 0) | 0;
 return ((i1 | 0) == (i2 | 0) ? (i4 | 0) > (i3 | 0) : (i1 | 0) < (i2 | 0)) | 0;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 868 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 868 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 856 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 856 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z63ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 752 >> 2]);
 return Math_fround(f3);
}

function __Z45BillboardAsset_CUSTOM_SetVerticesInternalListP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 + 8 >> 2] | 0, 0, 8) | 0;
  __ZN14BillboardAsset11SetVerticesEPK8Vector2fj(i3, i1, HEAP32[i2 + 12 >> 2] | 0);
  return;
 }
}

function __Z42ReflectionProbe_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 80 >> 2] | 0;
  i1 = HEAP32[i3 + 84 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 76 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z42ParticleAnimator_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 72 >> 2] | 0;
  i1 = HEAP32[i3 + 76 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 68 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z42NavMeshObstacle_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 48 >> 2] | 0;
  i1 = HEAP32[i3 + 52 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 44 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z42CapsuleCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 76 >> 2] | 0;
  i1 = HEAP32[i3 + 80 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 72 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z41Shader_CUSTOM_SetGlobalFloatArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i1, i2);
 STACKTOP = i3;
 return;
}

function __Z39DeleteLastPathNameComponentWithAnySlashRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = HEAP8[gb + 488812 >> 0] | 0;
 HEAP8[i4 + 1 >> 0] = HEAP8[gb + 488812 + 1 >> 0] | 0;
 HEAP8[i4 + 2 >> 0] = HEAP8[gb + 488812 + 2 >> 0] | 0;
 __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z35Renderer_Set_Custom_PropCastShadowsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16777023 | (i2 << 24 >> 24 != 0 & 1) << 6;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0;
 if ((HEAP32[i1 + 68 >> 2] | 0) < 2) return;
 i3 = HEAP32[i1 + 56 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i3 + (i2 << 4) >> 2]);
 i1 = i2 + 1 | 0;
 f4 = Math_fround(f4 - Math_fround(HEAPF32[i3 + (i1 << 4) >> 2]));
 f5 = Math_fround(HEAPF32[i3 + (i2 << 4) + 4 >> 2]);
 f4 = Math_fround(Math_fround(f5 - Math_fround(HEAPF32[i3 + (i1 << 4) + 4 >> 2])) / f4);
 HEAPF32[i3 + (i2 << 4) + 12 >> 2] = f4;
 HEAPF32[i3 + (i1 << 4) + 8 >> 2] = f4;
 return;
}

function _UNITY_FT_Load_Sfnt_Table(i3, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i7 = 35;
  return i7 | 0;
 }
 if (!(HEAP32[i3 + 8 >> 2] & 8)) {
  i7 = 35;
  return i7 | 0;
 }
 i1 = HEAP32[i3 + 96 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i2) {
  i7 = 7;
  return i7 | 0;
 }
 i1 = mftCall_iii(i2 | 0, i1 | 0, gb + 1008151 | 0) | 0;
 if (!i1) {
  i7 = 7;
  return i7 | 0;
 }
 i7 = mftCall_iiiiii(HEAP32[i1 >> 2] | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return i7 | 0;
}

function mftCall_viiiiiiiiiii(i12, i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i12 = i12 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 if ((i12 | 0) >= (fb | 0) & (i12 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viiiiiiiiiii[i12 - fb & 7](i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0);
  return;
 }
 ftCall_viiiiiiiiiii(i12 | 0, i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0);
}

function _recvfrom(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = i6;
 HEAP32[i8 >> 2] = 12;
 HEAP32[i8 + 4 >> 2] = i9;
 i6 = ___syscall_ret(___syscall102(102, i8 | 0) | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZZN10GUIManager14InitGUIManagerEvEN33UIEventsIMGUIRenderOverlaysstruct7ForwardEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[gb + 1468156 >> 2] | 0;
 HEAP8[(__Z15GetInputManagerv() | 0) + 168 >> 0] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 __ZN10InputEventaSERKS_(i3, i4 + 72 + (i1 * 52 | 0) | 0);
 HEAP32[i3 >> 2] = 7;
 HEAP32[i3 + 40 >> 2] = i1;
 __ZN10GUIManager10DoGUIEventER10InputEventb(i4, i3, 0);
 __ZN10InputEventD2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = i1 - i5 >> 2;
 L1 : do if (i4 >>> 0 < i3 >>> 0) __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj(i2, i3 - i4 | 0); else if (i4 >>> 0 > i3 >>> 0) {
  i2 = i5 + (i3 << 2) | 0;
  while (1) {
   if ((i1 | 0) == (i2 | 0)) break L1;
   i5 = i1 + -4 | 0;
   HEAP32[i6 >> 2] = i5;
   i1 = i5;
  }
 } while (0);
 return;
}

function __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i4 + 8 | 0;
 while (1) {
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) break;
  i3 = i3 + -24 | 0;
  HEAP32[i2 >> 2] = i3;
  __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i3);
 }
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[HEAP32[i4 + 16 >> 2] >> 2] | 0, i1, (HEAP32[i4 + 12 >> 2] | 0) - i1 | 0);
 return;
}

function __ZNK9Heightmap21GetMaximumHeightErrorEiii(i5, i6, i7, i4) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, f8 = f0;
 i1 = 1 << HEAP32[i5 + 80 >> 2];
 if ((i4 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  i3 = 0;
  do {
   i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
   i2 = i2 >> 1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } else {
  i2 = i1;
  i1 = 0;
 }
 i7 = i1 + i6 + (Math_imul(i2, i7) | 0) | 0;
 f8 = Math_fround(HEAPF32[(HEAP32[i5 + 24 >> 2] | 0) + (i7 << 2) >> 2]);
 return Math_fround(f8 * Math_fround(HEAPF32[i5 + 92 >> 2]));
}

function __ZN7ApiGLES13CreateTextureE16TextureDimensionN2gl9TexFormatEiiiii(i2, i3, i4, i5, i1, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1;
 HEAP32[i9 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 804 >> 2] | 0, 1, i9 | 0);
 i9 = HEAP32[i9 >> 2] | 0;
 __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii(i2, i9, i3, i4, i5, 0, i6, i7, i8) | 0;
 STACKTOP = i1;
 return i9 | 0;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerEj(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 8 | 0;
 i1 = i1 + 12 | 0;
 if ((HEAP16[i1 >> 1] | 0) == 1) i2 = i3; else i2 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE(i5, HEAP32[i2 + (i4 << 2) >> 2] | 0);
 if ((HEAP16[i1 >> 1] | 0) == 1) {
  i5 = i3;
  i5 = i5 + (i4 << 2) | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 } else {
  i5 = HEAP32[i3 >> 2] | 0;
  i5 = i5 + (i4 << 2) | 0;
  HEAP32[i5 >> 2] = 0;
  return;
 }
}

function __ZN19SkinnedMeshRenderer27SetSkinnedMeshMotionVectorsEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 465 | 0;
 if ((HEAPU8[i4 >> 0] | 0 | 0) == (i3 & 1 | 0)) return;
 if (!i3) {
  i1 = i1 + 472 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) {
   i5 = i2 + 4 | 0;
   HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
   if (!(HEAP32[i5 >> 2] | 0)) {
    mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
    __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63248 | 0);
   }
   HEAP32[i1 >> 2] = 0;
  }
 }
 HEAP8[i4 >> 0] = i3 & 1;
 return;
}

function __ZN14GfxDeviceStatsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 39052 + 8;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 120 >> 2] = i1 + 124;
 i2 = i1 + 264 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i2 + 16 >> 0] = 0;
 mftCall_viiiiiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 64, 64, 4, 4, 4, 0);
 i1 = i1 + 192 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 868 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 856 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z62ParticleSystem_MainModule_CUSTOM_GetRandomizeRotationDirectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 2540 >> 2]);
 return Math_fround(f3);
}

function __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalMatrixiR10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 72 | 0;
 i3 = i4 + 8 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 __Z21GetShaderGlobalMatrixN9ShaderLab16FastPropertyNameE(i3, i5);
 i1 = i3;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __Z41SphereCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 68 >> 2] | 0;
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z41Joint_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 56 >> 2] | 0;
  i1 = HEAP32[i3 + 60 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 52 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z40ReflectionProbe_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  HEAP32[i3 + 64 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i3 + 68 >> 2] = i4;
  HEAP32[i3 + 72 >> 2] = i1;
  return;
 }
}

function __Z39Hash128_CUSTOM_Internal_Hash128ToStringjjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __Z15Hash128ToStringjjjj(i6, i1, i2, i3, i4);
 i4 = HEAP8[i6 + 11 >> 0] | 0;
 i3 = i4 << 24 >> 24 < 0;
 i4 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i6 >> 2] | 0 : i6, i3 ? HEAP32[i6 + 4 >> 2] | 0 : i4 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i6);
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_FT_Stream_TryRead(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + 8 | 0;
 i4 = HEAP32[i7 >> 2] | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (i5 >>> 0 <= i4 >>> 0) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i6) {
  i6 = i5 - i4 | 0;
  i6 = i6 >>> 0 > i3 >>> 0 ? i3 : i6;
  _memcpy(i2 | 0, (HEAP32[i1 >> 2] | 0) + i4 | 0, i6 | 0) | 0;
  i1 = i6;
 } else i1 = mftCall_iiiii(i6 | 0, i1 | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i7 >> 2] = (HEAP32[i7 >> 2] | 0) + i1;
 i7 = i1;
 return i7 | 0;
}

function _basename(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) i1 = gb + 1087625 | 0; else if (!(HEAP8[i3 >> 0] | 0)) i1 = gb + 1087625 | 0; else {
  i1 = (_strlen(i3) | 0) + -1 | 0;
  L4 : do if (!i1) i1 = 0; else while (1) {
   i2 = i3 + i1 | 0;
   if ((HEAP8[i2 >> 0] | 0) != 47) break L4;
   HEAP8[i2 >> 0] = 0;
   i1 = i1 + -1 | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  } while (0);
  while (1) {
   if (!i1) {
    i1 = 0;
    break;
   }
   i2 = i1 + -1 | 0;
   if ((HEAP8[i3 + i2 >> 0] | 0) == 47) break; else i1 = i2;
  }
  i1 = i3 + i1 | 0;
 }
 return i1 | 0;
}

function __ZNSt3__211timed_mutex4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 HEAP32[i2 >> 2] = i1;
 i3 = i2 + 4 | 0;
 HEAP8[i3 >> 0] = 1;
 __ZNSt3__25mutex4lockEv(i1);
 i4 = i1 + 76 | 0;
 i1 = i1 + 28 | 0;
 while (1) {
  if (!(HEAP8[i4 >> 0] | 0)) break;
  __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE(i1, i2);
 }
 HEAP8[i4 >> 0] = 1;
 if (HEAP8[i3 >> 0] | 0) __ZNSt3__25mutex6unlockEv(HEAP32[i2 >> 2] | 0);
 STACKTOP = i5;
 return;
}

function __ZNK6Camera27GetImplicitProjectionMatrixEffffR10Matrix4x4f(i1, f2, f3, f4, f5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var f7 = f0;
 if (!(HEAP8[i1 + 1088 >> 0] | 0)) {
  __ZN10Matrix4x4f14SetPerspectiveEffff(i6, f4, f5, f2, f3) | 0;
  return;
 } else {
  f5 = Math_fround(HEAPF32[i1 + 916 >> 2]);
  f4 = Math_fround(-f5);
  f7 = Math_fround(HEAPF32[i1 + 1060 >> 2]);
  __ZN10Matrix4x4f8SetOrthoEffffff(i6, Math_fround(f7 * f4), Math_fround(f5 * f7), f4, f5, f2, f3) | 0;
  return;
 }
}

function __ZNK5physx7NpScene16getArticulationsEPPNS_14PxArticulationEjj(i1, i6, i3, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = (HEAP32[i1 + 3568 >> 2] | 0) - i7 | 0;
 i5 = (i2 | 0) < 0 ? 0 : i2;
 i5 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 3564 | 0;
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZNK5physx3Ext13DistanceJoint11getDistanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i5 | 0, i1 | 0);
 f3 = Math_fround(HEAPF32[i5 + 16 >> 2]);
 f3 = Math_fround(f3 * f3);
 f4 = Math_fround(HEAPF32[i5 + 20 >> 2]);
 f4 = Math_fround(f3 + Math_fround(f4 * f4));
 f3 = Math_fround(HEAPF32[i5 + 24 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZNK14CompressedMesh8ValidateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = (i2 | 0) / 3 | 0;
 if ((i2 | 0) != (i4 * 3 | 0)) return 0;
 i1 = HEAP32[i3 + 56 >> 2] | 0;
 if (i1 | 0) {
  if ((i1 | 0) != (i4 << 1 | 0)) return 0;
  if ((HEAP32[i3 + 84 >> 2] | 0) != (i4 | 0)) return 0;
 }
 i1 = HEAP32[i3 + 104 >> 2] | 0;
 if (i1 | 0) {
  i2 = i4 << 1;
  if ((i1 | 0) != (i2 | 0)) return 0;
  if ((HEAP32[i3 + 132 >> 2] | 0) != (i2 | 0)) return 0;
 }
 i3 = HEAP32[i3 + 152 >> 2] | 0;
 return (i3 | 0) == 0 | (i3 | 0) == (i4 << 2 | 0) | 0;
}

function __ZN5physx9readDwordEbRNS_13PxInputStreamE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 4) | 0;
 if (!i2) {
  i3 = HEAP32[i1 >> 2] | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP8[i1 >> 0] = i3 >>> 24;
 HEAP8[i1 + 3 >> 0] = i3;
 HEAP8[i1 + 1 >> 0] = i3 >>> 16;
 HEAP8[i1 + 2 >> 0] = (i3 & 65535) >>> 8;
 i3 = HEAP32[i1 >> 2] | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperationD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 27732 + 8;
 HEAP32[i1 + 128 >> 2] = gb + 27732 + 88;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN23ArchiveStorageConverterD2Ev(i3);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63552 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i3 = i1 + 144 | 0;
 __ZN4File5CloseEv(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 176 | 0);
 __ZN4FileD2Ev(i3);
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 return;
}

function __ZN20TextRenderingPrivate8TextMeshD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 185632 + 8;
 i3 = i1 + 32 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i4 = i1 + 32 | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 }
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN14EdgeCollider2DD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 155208 + 8;
 i1 = i2 + 160 | 0;
 if ((HEAP32[i2 + 176 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 164 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 153816 + 8;
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 37748 + 8;
 HEAP32[i2 >> 2] = gb + 29060 + 8;
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12ScriptMapperD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 68492 + 8;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1 + 44 | 0, HEAP32[i1 + 48 >> 2] | 0);
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE(i1 + 32 | 0, HEAP32[i1 + 36 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __Z62ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 872 >> 2] | 0) + 92 >> 2]);
 return Math_fround(f3);
}

function __Z61ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 528 >> 2]);
 return Math_fround(f3);
}

function __Z61ParticleSystem_MainModule_CUSTOM_GetGravityModifierMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 2356 >> 2]);
 return Math_fround(f3);
}

function __Z40WheelCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 64 >> 2] | 0;
  i1 = HEAP32[i3 + 68 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 60 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z40ReflectionProbe_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 68 >> 2] | 0;
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z12SHA1ToStringPh(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = 0;
 do {
  HEAP32[i5 >> 2] = HEAPU8[i3 + i1 >> 0];
  _snprintf(i4 + (i1 << 1) | 0, 3, gb + 585600 | 0, i5) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 20);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, i4, 40);
 STACKTOP = i6;
 return;
}

function _sendto(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0, i9 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i7;
 i9 = i7 + 8 | 0;
 HEAP32[i9 >> 2] = i1;
 HEAP32[i9 + 4 >> 2] = i2;
 HEAP32[i9 + 8 >> 2] = i3;
 HEAP32[i9 + 12 >> 2] = i4;
 HEAP32[i9 + 16 >> 2] = i5;
 HEAP32[i9 + 20 >> 2] = i6;
 HEAP32[i8 >> 2] = 11;
 HEAP32[i8 + 4 >> 2] = i9;
 i6 = ___syscall_ret(___syscall102(102, i8 | 0) | 0) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZZN19MeshParticleEmitter15InitializeClassEvEN33FunctorImpl_329kMeshFilterChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(33) | 0;
 if (!i2) return;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, i2) | 0;
 if (!i2) return;
 i1 = i3 + 236 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == (__ZN10MeshFilter13GetSharedMeshEv(i2) | 0)) return;
 HEAP32[i1 >> 2] = __ZN10MeshFilter13GetSharedMeshEv(i2) | 0;
 return;
}

function __ZThn32_N17BillboardRendererD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -32 | 0;
 HEAP32[i1 + 340 >> 2] = gb + 56316 + 252;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN9GfxDevice12ExecuteAsyncEiPFvPN21GfxDeviceAsyncCommand10ArgScratchEPKNS0_3ArgEEPS2_S5_R8JobFence(i2, i3, i4, i5, i6, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i7 = 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 if ((i3 | 0) > 0) i1 = 0; else return;
 do {
  i7 = HEAP32[i5 + (i1 << 2) >> 2] | 0;
  HEAP32[i7 + 8 >> 2] = i2;
  mftCall_vii(i4 | 0, i7 | 0, i6 | 0);
  mftCall_vi(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN8VRDevice28HasAudioConfigurationChangedEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 276 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP32[i1 + 280 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = mftCall_i(i2 | 0) | 0;
 if (!i1) i1 = 0; else i1 = (_memcmp(i1, i4 + 331 | 0, 16) | 0) != 0 & 1;
 i2 = mftCall_i(HEAP32[(HEAP32[i3 >> 2] | 0) + 280 >> 2] | 0) | 0;
 if (i2) {
  i4 = (_memcmp(i2, i4 + 347 | 0, 16) | 0) == 0;
  i1 = i4 ? i1 : 1;
 }
 i4 = (i1 & 1) != 0;
 return i4 | 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i2;
 i2 = (i3 - i2 | 0) / 12 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 4;
 if ((i3 | 0) == (i1 | 0)) return;
 i3 = 0;
 do {
  i5 = i1 + (i3 * 12 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0);
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhfE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround(HEAPU8[i1 >> 0] | 0);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx30PxTolerancesScaleGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 673134;
 HEAP32[i1 + 4 >> 2] = 206;
 HEAP32[i1 + 8 >> 2] = fb + 2180;
 HEAP32[i1 + 12 >> 2] = gb + 766883;
 HEAP32[i1 + 16 >> 2] = 207;
 HEAP32[i1 + 20 >> 2] = fb + 472;
 HEAP32[i1 + 24 >> 2] = fb + 407;
 HEAP32[i1 + 28 >> 2] = gb + 673827;
 HEAP32[i1 + 32 >> 2] = 208;
 HEAP32[i1 + 36 >> 2] = fb + 473;
 HEAP32[i1 + 40 >> 2] = fb + 408;
 HEAP32[i1 + 44 >> 2] = gb + 766890;
 HEAP32[i1 + 48 >> 2] = 209;
 HEAP32[i1 + 52 >> 2] = fb + 474;
 HEAP32[i1 + 56 >> 2] = fb + 409;
 return;
}

function __ZN5physx2Gu11HeightFieldD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 107232 + 8;
 HEAP32[i2 + 8 >> 2] = gb + 107232 + 104;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 i4 = i2 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 20 | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i4 = i1 & 65535;
 i2 = 0;
 while (1) {
  if (i1 << 16 >> 16 == 1) i1 = i5; else i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break;
  i1 = HEAP16[i3 >> 1] | 0;
 }
 return;
}

function __ZN5physx18PxVehicleDriveTank8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = (i1 + 3 | 0) >>> 2;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i4) | 0) + 768 | 0, gb + 827622 | 0, 47) | 0;
 __ZN5physx18PxVehicleDriveTankC2Ev(i3);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i3, i3 + 768 | 0, i4, i1) | 0;
 HEAP8[i3 + 113 >> 0] = 2;
 HEAP32[i3 + 752 >> 2] = 0;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN5physx15PxsParticleDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 96500 + 8;
 i1 = HEAP32[i2 + 48 >> 2] | 0;
 if (i1 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 if ((HEAP32[i2 + 60 >> 2] | 0) <= -1) {
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 64 | 0, i1);
 STACKTOP = i3;
 return;
}

function __ZN5Umbra8QueryExt21buildMaskShadowCullerERNS_15ShadowCullerExtERKNS_10VisibilityERKNS_7Vector3EPS7_iPfjPPKNS_15CameraTransformEi(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i2 = i2 + 15 & -16;
 __ZN5Umbra15ImpShadowCullerC2Ev(i2);
 return __ZN5UmbraL21buildShadowCullerImplEPNS_8QueryExtEPNS_15ImpShadowCullerEPKNS_10VisibilityEPKNS_15CameraTransformERKNS_7Vector3EPSB_iPfjPS9_i(i1, i2, i3, 0, i4, i5, i6, i7, i8, i9, i10) | 0;
}

function __ZN4gles8internal21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = (i2 | 0) != 0 & 1;
 HEAP8[i1 + 56 >> 0] = 0;
 HEAP8[i1 + 64 >> 0] = 0;
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i1 + 73 >> 0] = 0;
 HEAP32[i1 + 44 >> 2] = -1;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 return;
}

function __ZN22ProceduralMaterialData18SetAllOutputsDirtyEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 i4 = HEAP32[i2 + 36 >> 2] | 0;
 if ((i1 | 0) != (i4 | 0)) if (i3) do {
  i5 = i1 + 140 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 8;
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i4 | 0)); else do {
  i5 = i1 + 140 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -9;
  i1 = i1 + 156 | 0;
 } while ((i1 | 0) != (i4 | 0));
 i5 = i2 + 28 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i3 ? i4 | 524288 : i4 & -524289;
 return;
}

function __ZN22BlockMemoryCacheWriterD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 37988 + 8;
 i3 = i2 + 20 | 0;
 i4 = i2 + 32 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i2 + 12 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i5);
   i1 = i1 + 4 | 0;
  } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 24 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN21InheritVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 i3 = i1 + 8 | 0;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 < (HEAP32[i2 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i4 >> 2] = i6;
 } else __ZN12CachedWriter16UpdateWriteCacheEPKvj(i4, i3, 4);
 __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 12 | 0, i2);
 return;
}

function __ZN20SpeedTreeWindManager20UnregisterGlobalWindER13SpeedTreeWind(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = i2 + (i1 << 3) | 0;
  i1 = i1 + 1 | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break;
  if (i1 >>> 0 >= i6 >>> 0) {
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return;
 i7 = i3 + 8 | 0;
 _memmove(i3 | 0, i7 | 0, i2 + (i6 << 3) - i7 | 0) | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 return;
}

function __ZN16ReflectionProbes12PresentProbeEP15ReflectionProbe(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = i3 + 168 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
  HEAP32[i4 >> 2] = i1;
 }
 __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer(i3, i1);
 __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej(i2, i3, HEAP32[i3 + 156 >> 2] | 0);
 HEAP8[i3 + 160 >> 0] = 0;
 HEAP8[(HEAP32[i4 >> 2] | 0) + 16 >> 0] = 1;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN15TerrainRenderer24GetPatchMeshVertexFormatEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 232 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 i4 = __Z26GetMeshVertexFormatManagerv() | 0;
 __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo(i2, i1 + 200 | 0);
 i4 = __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo(i4, i2) | 0;
 HEAP32[i3 >> 2] = i4;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN13RendererScene15NotifyInvisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i1 + 72 >> 2] | 0;
 if ((i5 | 0) <= 0) return;
 i6 = i1 + 100 | 0;
 i3 = i1 + 60 | 0;
 i2 = 0;
 do {
  i4 = (HEAP32[i6 >> 2] | 0) + i2 | 0;
  i1 = HEAP8[i4 >> 0] | 0;
  if (i1 << 24 >> 24 == 2) {
   i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 * 24 | 0) >> 2] | 0;
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
   i1 = HEAP8[i4 >> 0] | 0;
  }
  HEAP8[i4 >> 0] = (i1 & 1) << 1;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZN10TagManager27IsSortingLayerUniqueIDValidEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 if (!i4) {
  i4 = 1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 1072 >> 2] | 0;
 i1 = HEAP32[i1 + 1068 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = (i2 - i1 | 0) / 40 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0) == (i4 | 0)) {
   i1 = 1;
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEEC2EPNS0_7SystemIEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7SetSizeEi(i1, i3);
 return;
}

function __ZN10Effector2D32ProcessCheckEffectorColliderMaskEP10Collider2DS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 53 >> 0] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0) | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(1 << HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 48 >> 2] & HEAP32[i1 + 60 >> 2])) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[HEAP32[(HEAP32[HEAP32[i2 + 60 >> 2] >> 2] | 0) + 28 >> 2] >> 2] | 0) == 2;
 return i2 | 0;
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z13TransferFieldI19StreamedBinaryWriteILb0EELb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 2092 >> 2]);
 return Math_fround(f3);
}

function __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 1828 >> 2]);
 return Math_fround(f3);
}

function __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 1564 >> 2]);
 return Math_fround(f3);
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 876 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 876 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z22SetMaterialMatrixArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 64) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material14SetMatrixArrayEN9ShaderLab16FastPropertyNameEPK10Matrix4x4fj(i1, i6, i3, i4);
 STACKTOP = i5;
 return;
}

function __Z20FindShadowMapInCacheP14ShadowMapCachei(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) return 0; else {
  i1 = i4;
  i3 = i2;
 }
 L3 : while (1) {
  i2 = i3;
  while (1) {
   if ((HEAP32[i2 + 16 >> 2] | 0) >= (i5 | 0)) break;
   i2 = HEAP32[i2 + 4 >> 2] | 0;
   if (!i2) break L3;
  }
  i3 = HEAP32[i2 >> 2] | 0;
  if (!i3) {
   i1 = i2;
   break;
  } else i1 = i2;
 }
 if ((i1 | 0) == (i4 | 0)) return 0; else return ((HEAP32[i1 + 16 >> 2] | 0) <= (i5 | 0) ? i1 + 20 | 0 : 0) | 0;
 return 0;
}

function _UNITY_FT_Select_Size(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 35;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 2)) {
  i3 = 35;
  return i3 | 0;
 }
 if ((i2 | 0) < 0) {
  i3 = 6;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) <= (i2 | 0)) {
  i3 = 6;
  return i3 | 0;
 }
 i3 = HEAP32[(HEAP32[(HEAP32[i1 + 96 >> 2] | 0) + 12 >> 2] | 0) + 92 >> 2] | 0;
 if (!i3) {
  _UNITY_FT_Select_Metrics(i1, i2);
  i3 = 0;
  return i3 | 0;
 } else {
  i3 = mftCall_iii(i3 | 0, HEAP32[i1 + 88 >> 2] | 0, i2 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwe(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i4 = mftCall_iiiiid(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, +d5) | 0;
 STACKTOP = i6;
 return i4 | 0;
}

function __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwd(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i4 = mftCall_iiiiid(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, +d5) | 0;
 STACKTOP = i6;
 return i4 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEce(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i4 = mftCall_iiiiid(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, +d5) | 0;
 STACKTOP = i6;
 return i4 | 0;
}

function __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcd(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0, i9 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6 + 4 | 0;
 i9 = i6;
 i8 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 HEAP32[i9 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i7 >> 2] = HEAP32[i9 >> 2];
 i4 = mftCall_iiiiid(i8 | 0, i1 | 0, i7 | 0, i3 | 0, i4 | 0, +d5) | 0;
 STACKTOP = i6;
 return i4 | 0;
}

function __ZNK16ReflectionProbes41CalculateHDRDecodeValuesForDefaultTextureEP7Texture(i5, i1, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!i2) {
  __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace(i5, 0, 0);
  return;
 }
 i4 = HEAP32[i2 + 56 >> 2] | 0;
 if ((__Z19GetActiveColorSpacev() | 0) == 1) i1 = HEAP32[i2 + 60 >> 2] | 0; else i1 = 0;
 __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef(i5, i4, i1, __Z19GetActiveColorSpacev() | 0, f3);
 return;
}

function __ZNK16MeshVertexFormat18GetUsedStreamCountEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  i5 = i5 & 255;
  i5 = i5 + 1 | 0;
  i5 = i5 & 255;
  return i5 | 0;
 } else {
  i1 = 0;
  i2 = 0;
  i3 = 1;
 }
 do {
  if (HEAP8[i4 + 8 + (i2 << 2) + 3 >> 0] | 0) {
   i6 = HEAP8[i4 + 8 + (i2 << 2) >> 0] | 0;
   i1 = (i1 & 255) < (i6 & 255) ? i6 : i1;
  }
  i2 = i2 + 1 | 0;
  i3 = i3 << 1;
 } while ((i2 | 0) < 8 & i3 >>> 0 <= i5 >>> 0);
 i6 = i1 & 255;
 i6 = i6 + 1 | 0;
 i6 = i6 & 255;
 return i6 | 0;
}

function __ZN6Camera4CullER11CullResults8CullFlag(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = -1;
 HEAP32[i4 >> 2] = i1;
 i5 = i4 + 12 | 0;
 HEAP32[i5 >> 2] = i3 | 4;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 if (HEAP8[i1 + 1089 >> 0] | 0) HEAP32[i5 >> 2] = i3 | 6;
 __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults(i1, i4, i2);
 STACKTOP = i6;
 return;
}

function __ZN5physx8debugger14PvdMarshallingIafE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, f5 = f0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  f5 = Math_fround(HEAP8[i1 >> 0] | 0);
  HEAPF32[tempDoublePtr >> 2] = f5;
  HEAP8[i2 >> 0] = HEAP8[tempDoublePtr >> 0];
  HEAP8[i2 + 1 >> 0] = HEAP8[tempDoublePtr + 1 >> 0];
  HEAP8[i2 + 2 >> 0] = HEAP8[tempDoublePtr + 2 >> 0];
  HEAP8[i2 + 3 >> 0] = HEAP8[tempDoublePtr + 3 >> 0];
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i5 + 6 | 0;
 i1 = i5 + 4 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i3 = HEAP16[i1 >> 1] | 0;
  if ((i3 & 65535) > 1) {
   i3 = (i3 & 65535) + -1 | 0;
   i3 = i3 >>> 1 | i3;
   i3 = i3 >>> 2 | i3;
   i3 = i3 >>> 4 | i3;
   i3 = i3 >>> 8 | i3;
   mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i5 >> 2] | 0, ((i3 >>> 16 | i3) << 2) + 4 | 0);
  }
 }
 HEAP32[i5 >> 2] = 0;
 HEAP8[i2 >> 0] = 1;
 HEAP16[i1 >> 1] = 0;
 return;
}

function __ZN21UnityAnalyticsManager13InitAnalyticsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(44, gb + 63800 | 0, 16, gb + 1037694 | 0, 67) | 0;
 HEAP32[i2 + 4 >> 2] = __Z21GetUnityConnectClientv() | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 1;
 HEAP32[i2 >> 2] = gb + 188416 + 8;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i2 + 24 | 0);
 HEAP32[i3 >> 2] = gb + 1042554;
 HEAP32[i1 + 28 >> 2] = i2;
 __ZN14UnityAnalytics23RegisterGlobalCallbacksEv(i2);
 return;
}

function __ZN14FileCacherRead10DirectReadEPvjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (((HEAP32[i1 + 8 >> 2] | 0) - i3 | 0) >>> 0 < i4 >>> 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468417 | 0, 0, gb + 468446 | 0, 73, 32785, 0, 0, 0);
 i5 = i1 + 128 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i5, i1 + 12 | 0) | 0;
 HEAP32[i1 + 140 >> 2] = i2;
 HEAP32[i1 + 144 >> 2] = i4;
 HEAP32[i1 + 148 >> 2] = i3;
 __Z16AsyncReadRequestP16AsyncReadCommand(i5);
 return;
}

function __ZN12AudioManager14OnMixerChangedEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 68 | 0;
 i1 = HEAP32[i4 + 72 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) != (i3 | 0)) do {
  __ZN10AudioMixer11SetupGroupsEv(HEAP32[i1 + 8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 i3 = i4 + 44 | 0;
 i1 = HEAP32[i4 + 48 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  __ZN11AudioSource19ConfigureFMODGroupsEv(HEAP32[i1 + 8 >> 2] | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __Z8pqDeleteP9PriorityQi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if ((i1 | 0) > -1) {
  __Z12pqHeapDeleteP13PriorityQHeapi(HEAP32[i2 >> 2] | 0, i1);
  return;
 }
 HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (~i1 << 2) >> 2] = 0;
 i4 = i2 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 while (1) {
  i2 = i1;
  i1 = i1 + -1 | 0;
  if (HEAP32[HEAP32[i3 + (i1 << 2) >> 2] >> 2] | 0) {
   i1 = 7;
   break;
  }
  HEAP32[i4 >> 2] = i1;
  if ((i2 | 0) <= 1) {
   i1 = 7;
   break;
  }
 }
 if ((i1 | 0) == 7) return;
}

function __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 876 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 852 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 852 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z31Transform_CUSTOM_DetachChildrenP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = i2 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i2 + 80 | 0;
 do __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, 0, 1) | 0; while ((HEAP32[i3 >> 2] | 0) != 0);
 return;
}

function _get_sfnt_table(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   i1 = i1 + 160 | 0;
   break;
  }
 case 3:
  {
   i1 = i1 + 216 | 0;
   break;
  }
 case 4:
  {
   i1 = HEAP8[i1 + 292 >> 0] | 0 ? i1 + 296 | 0 : 0;
   break;
  }
 case 2:
  {
   i1 = i1 + 364 | 0;
   i1 = (HEAP16[i1 >> 1] | 0) == -1 ? 0 : i1;
   break;
  }
 case 5:
  {
   i1 = i1 + 468 | 0;
   break;
  }
 case 1:
  {
   i1 = i1 + 260 | 0;
   break;
  }
 case 6:
  {
   i1 = i1 + 548 | 0;
   i1 = HEAP32[i1 >> 2] | 0 ? i1 : 0;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 i1 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 209952 + 8;
 HEAP32[i1 >> 2] = gb + 209952 + 56;
 __THREW__ = 0;
 invoke_vii(fb + 4521 | 0, i2 + 12 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 >> 2] = gb + 211428 + 8;
  HEAP32[i1 >> 2] = gb + 211428 + 84;
  return;
 }
}

function __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 i1 = i2 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 209868 + 8;
 HEAP32[i1 >> 2] = gb + 209868 + 56;
 __THREW__ = 0;
 invoke_vii(fb + 4515 | 0, i2 + 12 | 0, i3 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 >> 2] = gb + 211316 + 8;
  HEAP32[i1 >> 2] = gb + 211316 + 84;
  return;
 }
}

function __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   if ((i4 | 0) == (i2 | 0)) break;
   i4 = i4 + -24 | 0;
   HEAP32[i3 >> 2] = i4;
   __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i4);
  }
  i4 = HEAP32[i1 >> 2] | 0;
  __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(HEAP32[i1 + 12 >> 2] | 0, i4, (HEAP32[i1 + 8 >> 2] | 0) - i4 | 0);
 }
 return;
}

function __ZNK9Rigidbody24GetInertiaTensorRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 124 >> 2] | 0, i6 | 0, i5 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK14StackAllocator8ContainsEPKv(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 | 0) == (i3 | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 if (i1 | 0) {
  i1 = HEAP32[i2 + 32 >> 2] | 0;
  if (i1 >>> 0 <= i3 >>> 0) if ((i1 + (HEAP32[i2 + 36 >> 2] | 0) | 0) >>> 0 > i3 >>> 0) {
   i3 = 1;
   return i3 | 0;
  }
 }
 i2 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2 + 44 | 0) | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i3 | 0) | 0;
 return i3 | 0;
}

function __ZN8Playable11ClearInputsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 8 | 0;
 if (HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0) {
  i1 = 0;
  do {
   __ZN8Playable10DisconnectEPS_i(i2, i1);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0) >>> 0);
 }
 __Z18GetDirectorManagerv() | 0;
 __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList(gb + 1188456 | 0, HEAP32[i3 >> 2] | 0);
 __Z18GetDirectorManagerv() | 0;
 HEAP32[i3 >> 2] = __ZN15DirectorManager14ConnectionPool8AllocateEi(gb + 1188456 | 0, 0) | 0;
 return;
}

function __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i5) return;
 i2 = 0;
 while (1) {
  i3 = (HEAP32[i1 + 36 >> 2] | 0) + (i2 << 3) + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) HEAP32[i3 >> 2] = mftCall_iiii(HEAP32[HEAP32[i6 >> 2] >> 2] | 0, i6 | 0, -2147483648, i1 | 0) | 0;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i5 | 0)) break;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 return;
}

function __ZN5physx12NpBatchQuery7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1 + 40 | 0, 0, 0) | 0)) {
  __ZN5physx7NpScene17releaseBatchQueryEPNS_12PxBatchQueryE(HEAP32[i1 + 8 >> 2] | 0, i1);
  STACKTOP = i2;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687683 | 0, 617, gb + 687965 | 0, i2);
  STACKTOP = i2;
  return;
 }
}

function __ZN5Umbra6Random3getEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 8 + (HEAP32[i1 >> 2] << 2) | 0;
 i3 = i1 + 4 | 0;
 i2 = (HEAP32[i1 + 8 + (HEAP32[i3 >> 2] << 2) >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0;
 i2 = i2 << 13 | i2 >>> 19;
 HEAP32[i4 >> 2] = i2;
 i4 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 HEAP32[i1 >> 2] = (i4 >> 31 & 11) + i4;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = (i1 >> 31 & 11) + i1;
 return Math_fround((HEAP32[tempDoublePtr >> 2] = i2 & 8388607 | 1065353216, Math_fround(HEAPF32[tempDoublePtr >> 2])) + Math_fround(-1.0));
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z13TransferFieldI24GenerateTypeTreeTransferLb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 852 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipVP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 864 >> 2] | 0) + 568 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipUP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 864 >> 2] | 0) + 564 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 896 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 896 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 904 >> 2]);
 return Math_fround(f3);
}

function __Z44Renderer_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = i3 + 268 | 0;
  i2 = (HEAPU16[i3 >> 1] | 0 | (HEAPU8[i3 + 2 >> 0] | 0) << 16) & 16728063 | i2 << 14 & 49152;
  HEAP16[i3 >> 1] = i2;
  HEAP8[i3 + 2 >> 0] = i2 >>> 16;
  return;
 }
}

function __Z21CountTrianglesInStripItEiPKT_i(i7, i1) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + -2 | 0;
 i5 = 0;
 i1 = 0;
 L1 : while (1) {
  while (1) {
   if ((i1 | 0) >= (i6 | 0)) break L1;
   i2 = HEAP16[i7 + (i1 << 1) >> 1] | 0;
   i3 = i1 + 1 | 0;
   i4 = HEAP16[i7 + (i3 << 1) >> 1] | 0;
   if (i2 << 16 >> 16 == i4 << 16 >> 16) i1 = i3; else break;
  }
  i1 = HEAP16[i7 + (i1 + 2 << 1) >> 1] | 0;
  i5 = ((i2 << 16 >> 16 == i1 << 16 >> 16 ? 1 : i4 << 16 >> 16 == i1 << 16 >> 16) & 1 ^ 1) + i5 | 0;
  i1 = i3;
 }
 return i5 | 0;
}

function _UNITY_FT_Init_FreeType(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = _UNITY_FT_New_Memory() | 0;
 if (!i2) {
  i3 = 7;
  return i3 | 0;
 }
 i3 = _UNITY_FT_New_Library(i2, i1) | 0;
 if (i3 | 0) {
  _UNITY_FT_Done_Memory(i2);
  return i3 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = HEAP32[HEAP32[i3 + 188 >> 2] >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 do {
  _UNITY_FT_Add_Module(i3, i1) | 0;
  i2 = i2 + 4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != 0);
 i1 = 0;
 return i1 | 0;
}

function __ZNKSt3__223__match_any_but_newlineIcE6__execERNS_7__stateIcEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 L1 : do if ((i4 | 0) == (HEAP32[i2 + 12 >> 2] | 0)) {
  HEAP32[i2 >> 2] = -993;
  HEAP32[i2 + 40 >> 2] = 0;
 } else switch (HEAP8[i4 >> 0] | 0) {
 case 10:
 case 13:
  {
   HEAP32[i2 >> 2] = -993;
   HEAP32[i2 + 40 >> 2] = 0;
   break L1;
  }
 default:
  {
   HEAP32[i2 >> 2] = -995;
   HEAP32[i3 >> 2] = i4 + 1;
   HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 4 >> 2];
   break L1;
  }
 } while (0);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } else i1 = i1 & 255;
 L5 : do if (!i1) i1 = -1; else {
  i1 = i2 + (i1 >>> 0 > i3 >>> 0 ? i3 + 1 | 0 : i1) | 0;
  do {
   if ((i1 | 0) == (i2 | 0)) {
    i1 = -1;
    break L5;
   }
   i1 = i1 + -1 | 0;
  } while ((HEAP8[i1 >> 0] | 0) != i4 << 24 >> 24);
  i1 = i1 - i2 | 0;
 } while (0);
 return i1 | 0;
}

function __ZNK5physx7NpScene14getConstraintsEPPNS_12PxConstraintEjj(i1, i6, i3, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = (HEAP32[i1 + 3544 >> 2] | 0) - i7 | 0;
 i5 = (i2 | 0) < 0 ? 0 : i2;
 i5 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 3540 | 0;
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZNK10FileSystem18IsAbsoluteFilePathEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 16 | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 while (1) {
  if (!i1) break;
  i1 = i1 + -1 | 0;
  i6 = HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i6 | 0, i3 | 0) | 0) {
   i1 = 1;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i6 = mftCall_iii(HEAP32[(HEAP32[i6 >> 2] | 0) + 56 >> 2] | 0, i6 | 0, i3 | 0) | 0;
 return i6 | 0;
}

function __ZN5physx2Sc9ClothCore15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 320 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 _memset(i4 | 0, 0, 156) | 0;
 __ZN5physx2Sc9ClothCore14updateBulkDataERNS0_13ClothBulkDataE(i2, i4);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, 320);
 __ZN5physx2Sc13ClothBulkData15exportExtraDataERNS_22PxSerializationContextE(i4, i1);
 __ZN5physx2Sc13ClothBulkDataD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu9Container6DeleteEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 4 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = 0;
 while (1) {
  i1 = i3 + (i2 << 2) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) break;
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i6 >>> 0) {
   i1 = 0;
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return i1 | 0;
 i7 = i6 + -1 | 0;
 HEAP32[i5 >> 2] = i7;
 HEAP32[i1 >> 2] = HEAP32[i3 + (i7 << 2) >> 2];
 i7 = 1;
 return i7 | 0;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN4FMOD6System20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i2 + 368 >> 2] = i3;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861175;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN23ArchiveStorageConverter11GetProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 if (!(HEAP8[i1 + 56 >> 0] | 0)) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i2 = i1 + 48 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i3 | 0) == 0 & (i2 | 0) == 0) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = i1 + 40 | 0;
 f4 = Math_fround(Math_fround(+((HEAP32[i1 >> 2] | 0) >>> 0) + 4294967296.0 * +((HEAP32[i1 + 4 >> 2] | 0) >>> 0)) / Math_fround(+(i3 >>> 0) + 4294967296.0 * +(i2 >>> 0)));
 return Math_fround(f4);
}

function __ZN20ArchiveStorageHeader13GetHeaderSizeERKNS_6HeaderE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP8[i3 + 20 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i2 = HEAP32[i3 + 24 >> 2] | 0; else i2 = i1 & 255;
 i1 = HEAP8[i3 + 36 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 40 >> 2] | 0; else i1 = i1 & 255;
 i2 = i2 + 5 + i1 | 0;
 if (HEAP32[i3 + 72 >> 2] & 256 | 0) {
  i3 = i2 + 31 | 0;
  return i3 | 0;
 }
 i1 = HEAP8[i3 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 4 >> 2] | 0; else i1 = i1 & 255;
 i3 = i2 + 22 + i1 | 0;
 return i3 | 0;
}

function __ZN16Physics2DManager20GetRigidBodyVelocityERK11Rigidbody2D(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i3 + 92 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i3 + 68 >> 2] | 0) != 2) if (!(HEAP8[i3 + 226 >> 0] | 0)) {
  i3 = HEAP32[i1 + 68 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i3;
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i3 + 212 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 216 >> 2];
  return;
 }
 HEAP32[i2 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN14NavMeshManager26SetAvoidancePredictionTimeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i3 = i4 + 4 | 0;
 HEAPF32[i5 >> 2] = f1;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 i6 = f1 > Math_fround(0.0);
 i3 = HEAP32[(i6 ? i5 : i3) >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i2 + 32 >> 2] = i3;
 i2 = HEAP32[i2 + 100 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 + 444 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i4 = i1 + 32 | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 }
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __Z59ParticleSystem_MainModule_CUSTOM_GetStartLifetimeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 896 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z58ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZLimitSpringP12Il2CppObjectP20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 172 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z57ParticleSystem_LightsModule_CUSTOM_GetIntensityMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 920 >> 2] | 0) + 368 >> 2]);
 return Math_fround(f3);
}

function __Z57ParticleSystem_CollisionModule_CUSTOM_GetDampenMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 224 >> 2]);
 return Math_fround(f3);
}

function __Z57ParticleSystem_CollisionModule_CUSTOM_GetBounceMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 488 >> 2]);
 return Math_fround(f3);
}

function __Z43SkinnedMeshRenderer_Set_Custom_PropRootBoneP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42GUIUtility_Set_Custom_PropSystemCopyBufferP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __Z13SetCopyBufferRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 16) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material14SetVectorArrayEN9ShaderLab16FastPropertyNameEPK8Vector4fj(i1, i6, i3, i4);
 STACKTOP = i5;
 return;
}

function _cf2_builder_lineTo(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!(HEAP8[i2 + 64 >> 0] | 0)) {
  i4 = _cff_builder_start_point(i2, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
  if (i4 | 0) {
   i1 = HEAP32[i3 + 24 >> 2] | 0;
   if (HEAP32[i1 >> 2] | 0) return;
   HEAP32[i1 >> 2] = i4;
   return;
  }
 }
 i2 = _cff_builder_add_point1(i2, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
 if (!i2) return;
 i1 = HEAP32[i3 + 24 >> 2] | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__221recursive_timed_mutex8try_lockEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i3 = _pthread_self() | 0;
 if (__ZNSt3__25mutex8try_lockEv(i5) | 0) {
  i4 = i5 + 76 | 0;
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = i5 + 80 | 0;
  if (!i1) {
   i1 = 1;
   i6 = 5;
  } else if ((i3 | 0) == (HEAP32[i2 >> 2] | 0)) if ((i1 | 0) == -1) i1 = 0; else {
   i1 = i1 + 1 | 0;
   i6 = 5;
  } else i1 = 0;
  if ((i6 | 0) == 5) {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i2 >> 2] = i3;
   i1 = 1;
  }
  __ZNSt3__25mutex6unlockEv(i5);
 } else i1 = 0;
 return i1 | 0;
}

function __ZNKSt3__27collateIwE10do_compareEPKwS3_S3_S3_(i1, i3, i5, i2, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i4 = 0, i7 = 0;
 i1 = i3;
 while (1) {
  if ((i2 | 0) == (i6 | 0)) {
   i7 = 7;
   break;
  }
  if ((i1 | 0) == (i5 | 0)) {
   i1 = -1;
   break;
  }
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  if ((i3 | 0) < (i4 | 0)) {
   i1 = -1;
   break;
  }
  if ((i4 | 0) < (i3 | 0)) {
   i1 = 1;
   break;
  }
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 }
 if ((i7 | 0) == 7) i1 = (i1 | 0) != (i5 | 0) & 1;
 return i1 | 0;
}

function __ZNK5physx2Sc8RigidSim14getSimForShapeERNS0_9ShapeCoreE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i3, i1);
 while (1) {
  i1 = __ZN5physx2Sc13ShapeIterator7getNextEv(i3) | 0;
  if (!i1) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((HEAP32[i1 + 28 >> 2] | 0) == (i2 | 0)) {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) {
  STACKTOP = i4;
  return i1 | 0;
 }
 return 0;
}

function __ZN8VRDevice20HandleGfxThreadEventE25UnityVREventGfxThreadTypej(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if ((HEAP16[gb + 1469192 + 6 >> 1] | 0) > -1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(gb + 1469192 | 0, i1);
  __Z12profiler_endP19ProfilerInformation(gb + 1469192 | 0);
  STACKTOP = i3;
  return;
 } else {
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(i2) {
 i2 = i2 | 0;
 var i1 = 0, f3 = f0, f4 = f0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 492 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? HEAP32[i2 + 12 >> 2] | 0 : i1;
 f4 = Math_fround(HEAPF32[i2 + 480 >> 2]);
 f3 = Math_fround(-Math_fround(HEAPF32[i2 + 484 >> 2]));
 if (!((f4 < f3 ? f4 : f3) > Math_fround(0.0))) {
  i2 = 0;
  return i2 | 0;
 }
 i5 = i1 << 2;
 i6 = i1 << 1;
 i2 = i6 + 2048 | 0;
 i1 = i5 + 4 | 0;
 i2 = (i6 + 2 & -4) + i5 + (i2 >>> 0 < i1 >>> 0 ? i1 : i2) | 0;
 return i2 | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 20 | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i4 = i1 & 65535;
 i2 = 0;
 while (1) {
  if (i1 << 16 >> 16 == 1) i1 = i5; else i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break;
  i1 = HEAP16[i3 >> 1] | 0;
 }
 return;
}

function __ZN5physx19PxsSimObjectFactoryC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, 296, gb + 718637 | 0, 30) | 0;
 HEAP32[i1 >> 2] = i3;
 _memset(i3 | 0, 0, 292) | 0;
 HEAP8[i3 + 260 >> 0] = 1;
 HEAP32[i3 + 264 >> 2] = i3 + 4;
 HEAP32[i3 + 272 >> 2] = 64;
 HEAP32[i3 + 276 >> 2] = 32;
 HEAP32[i3 + 280 >> 2] = 0;
 HEAP32[i3 + 284 >> 2] = 0;
 HEAP32[i3 + 288 >> 2] = 2048;
 HEAP32[i3 + 292 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN2UI6Canvas17SetSortingLayerIDEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__ZNK2UI6Canvas13GetRenderModeEv(i3) | 0)) return;
 if (HEAP32[i3 + 344 >> 2] | 0) if (!(HEAP8[i3 + 375 >> 0] | 0)) return;
 i2 = __ZN10TagManager27IsSortingLayerUniqueIDValidEi(__Z13GetTagManagerv() | 0, i1) | 0;
 i1 = i2 ? i1 : 0;
 i2 = i3 + 368 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 i1 = __Z13GetTagManagerv() | 0;
 HEAP16[i3 + 420 >> 1] = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i1, HEAP32[i2 >> 2] | 0) | 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh8SetColorE11ColorRGBA32(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i4 & 255) << 24 >> 24 == (i1 & 255) << 24 >> 24) if (!((i4 >>> 24 & 255) << 24 >> 24 != (i1 >>> 24 & 255) << 24 >> 24 | ((i4 >>> 16 & 255) << 24 >> 24 != (i1 >>> 16 & 255) << 24 >> 24 ? 1 : ((i4 & 65535) >>> 8 & 255) << 24 >> 24 != ((i1 & 65535) >>> 8 & 255) << 24 >> 24))) return;
 HEAP32[i3 >> 2] = i1;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i2);
 return;
}

function __ZN20ArchiveStorageReader17MakeStorageUnusedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 2336 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i4;
 if (i4 | 0) return;
 __ZN12FileAccessor5CloseEv(i2 + 1248 | 0) | 0;
 i3 = i2 + 2376 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i4 = i2 + 2364 | 0;
  i1 = 0;
  do {
   __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE(i2, HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN18GfxFramebufferGLES10InvalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i1 + 520 >> 0] = 0;
 __ZN18GfxFramebufferGLES22EnsureDefaultFBOInitedEv(i1);
 __ZN4gles27UninitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadE(i1 + 340 | 0);
 return;
}

function __ZN17InternalIndexPoolD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 HEAP32[i3 >> 2] = gb + 88176 + 8;
 i2 = HEAP32[i3 + 16 >> 2] | 0;
 if ((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0) {
  i2 = HEAP32[i3 + 8 >> 2] | 0;
  if (i2 | 0) {
   i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i2 | 0);
  }
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
 STACKTOP = i4;
 return;
}

function __Z57ConfigurableJoint_CUSTOM_INTERNAL_get_angularXLimitSpringP12Il2CppObjectP20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 140 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 1300 >> 2]);
 return Math_fround(f3);
}

function __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 1036 >> 2]);
 return Math_fround(f3);
}

function __Z26Application_CUSTOM_HasARGVP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 i1 = (__Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3) | 0) & 1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function b60(i1, i2, i13, i17, i18, f19, f20, i21, i22, i23, i3, i4, i5, i6, i7, i8, f9, f10, f11, f12, i14, i15, i16) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i13 = i13 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 f19 = Math_fround(f19);
 f20 = Math_fround(f20);
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 nullFunc_iiiiiiffiiiiiiiiiffffiii(60);
 return 0;
}

function __ZNK5physx7NpScene13getAggregatesEPPNS_11PxAggregateEjj(i1, i6, i3, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = (HEAP32[i1 + 3580 >> 2] | 0) - i7 | 0;
 i5 = (i2 | 0) < 0 ? 0 : i2;
 i5 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 3576 | 0;
 i3 = ~i3;
 i1 = (i2 | 0) > 0 ? ~i2 : -1;
 i1 = ~(i1 >>> 0 < i3 >>> 0 ? i3 : i1);
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 + i7 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZNK33AssetBundleLoadFromAsyncOperation20IsDirectoryInfoValidERKN20ArchiveStorageHeader13DirectoryInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i1;
 if ((i3 | 0) == (i1 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = (i3 - i1 | 0) / 40 | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i4 + (i1 * 40 | 0) + 16 >> 2] & 4 | 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK20TextRenderingPrivate8FontImpl10GetGlyphNoEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 switch (HEAP32[i1 + 32 >> 2] | 0) {
 case 1:
  {
   i3 = i2 << 24 >> 24;
   i2 = ((((i2 & 255) + -97 & 255) < 26 ? i3 + 224 | 0 : i3) << 24 >> 24) - (HEAP32[i1 + 28 >> 2] | 0) | 0;
   return i2 | 0;
  }
 case 2:
  {
   i3 = i2 << 24 >> 24;
   i3 = ((((i2 & 255) + -65 & 255) < 26 ? i3 + 32 | 0 : i3) << 24 >> 24) - (HEAP32[i1 + 28 >> 2] | 0) | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = i2 - (HEAP32[i1 + 28 >> 2] | 0) | 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN8Animator13ClearBindingsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 604 | 0;
 i3 = i1 + 620 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 608 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 616 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 168 | 0;
 __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i1 + 176 | 0);
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc17ParticleSystemSim8setFlagsEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 52 | 0;
 i1 = (i1 & 4 | 0) == 0;
 if (i1 & ((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i2 >> 2] | 0) | 0) & 4) != 0) {
  i3 = HEAP32[i3 + 56 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, 1);
  return;
 }
 if (i1 | ((__ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(HEAP32[i2 >> 2] | 0) | 0) & 4) != 0) return;
 i3 = HEAP32[i3 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, 0);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE8requiresERNS_23PxProcessPxBaseCallbackE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 20 | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i4 = i1 & 65535;
 i2 = 0;
 while (1) {
  if (i1 << 16 >> 16 == 1) i1 = i5; else i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break;
  i1 = HEAP16[i3 >> 1] | 0;
 }
 return;
}

function __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 i3 = i1 + 8 | 0;
 i4 = i2 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + 4 | 0;
 if (i6 >>> 0 > (HEAP32[i2 + 24 >> 2] | 0) >>> 0) __ZN12CachedReader15UpdateReadCacheEPvj(i4, i3, 4); else {
  HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
  HEAP32[i4 >> 2] = i6;
 }
 __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 12 | 0, i2);
 return;
}

function __ZN19SkinnedMeshRenderer26EndCurrentSkinningInstanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4 + 4 | 0;
 i3 = i4;
 i1 = i1 + 348 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i4;
  return;
 }
 i5 = __Z12GetGfxDevicev() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 256 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i6 | 0, i5 | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z56ParticleSystem_MainModule_CUSTOM_GetStartSpeedMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 772 >> 2]);
 return Math_fround(f3);
}

function __Z37AnimationClip_Get_Custom_PropStopTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13AnimationClip8GetRangeEv(i2, i3);
   f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   STACKTOP = i4;
   return Math_fround(f5);
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28PlayerPrefs_CUSTOM_DeleteKeyP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __ZN11PlayerPrefs9DeleteKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z23GUIStyle_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 }
 __ZdlPv(i1);
 STACKTOP = i3;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4copyEPwjj(i1, i5, i3, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 i2 = i2 - i6 | 0;
 i2 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (i4) i1 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__211char_traitsIwE4copyEPwPKwj(i5, i1 + (i6 << 2) | 0, i2) | 0;
 return i2 | 0;
}

function __ZNK5physx3Cct12SweptCapsule18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E(i5, i4, i1, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f6 = f0, f7 = f0, f8 = f0;
 f8 = Math_fround(HEAPF32[i5 + 40 >> 2]);
 f7 = Math_fround(HEAPF32[i5 + 44 >> 2]);
 f6 = Math_fround(HEAPF32[i4 + 260 >> 2]);
 __ZN5physx3Cct18computeTemporalBoxERNS_17PxExtendedBounds3EffffRKNS_6PxVec3ERKNS_14PxExtendedVec3ES5_(i1, f8, f7, f6, Math_fround(HEAPF32[i4 + 272 >> 2]), i4 + 244 | 0, i2, i3);
 return;
}

function __ZNK10GameObject22CountDerivedComponentsEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i1) | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i3) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = i2 + (i3 << 3) | 0;
 i1 = 0;
 do {
  i1 = (((HEAP32[i2 >> 2] | 0) - i5 | 0) >>> 0 < i4 >>> 0 & 1) + i1 | 0;
  i2 = i2 + 8 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return i1 | 0;
}

function __ZN5physx15PxsParticleData15setRestOffsetsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKfEE(i1, i8, i4, i2) {
 i1 = i1 | 0;
 i8 = i8 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i4 + 4 >> 2] | 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i8) return;
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = 0;
 while (1) {
  HEAP32[i5 + (HEAP32[i1 >> 2] << 2) >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i8 | 0)) break; else {
   i3 = i3 + i7 | 0;
   i1 = i1 + i6 | 0;
  }
 }
 return;
}

function __ZN13ComputeShader13AfterDispatchEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 __Z15gpu_time_samplev();
 i4 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, 22, 0) | 0;
 i4 = (HEAP32[i4 + 24 >> 2] | 0) - (HEAP32[i4 + 20 >> 2] | 0) | 0;
 i5 = (i4 | 0) / 20 | 0;
 if (!i4) return;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 i2 = i1 + 60 | 0;
 i1 = 0;
 do {
  if ((HEAP32[i4 + (i3 * 976 | 0) + 4 + (i1 << 2) >> 2] | 0) > -1) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & ~(1 << i1);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i5 >>> 0);
 return;
}

function __ZN12b2BroadPhase10TouchProxyEi(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i2 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 36 | 0;
 i2 = i2 + 32 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 << 1;
  i1 = __Z7b2Alloci(i1 << 3) | 0;
  HEAP32[i2 >> 2] = i1;
  _memcpy(i1 | 0, i6 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  __Z6b2FreePv(i6);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i4;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return;
}

function __ZN12b2BroadPhase10BufferMoveEi(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = i2 + 40 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + 36 | 0;
 i2 = i2 + 32 | 0;
 if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i6 = HEAP32[i2 >> 2] | 0;
  HEAP32[i3 >> 2] = i1 << 1;
  i1 = __Z7b2Alloci(i1 << 3) | 0;
  HEAP32[i2 >> 2] = i1;
  _memcpy(i1 | 0, i6 | 0, HEAP32[i5 >> 2] << 2 | 0) | 0;
  __Z6b2FreePv(i6);
  i1 = HEAP32[i5 >> 2] | 0;
 }
 HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] = i4;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return;
}

function __ZN11AudioSource18SetSpatialBlendMixEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 i6 = f2 < Math_fround(0.0);
 i7 = f2 > Math_fround(1.0);
 f2 = i7 ? Math_fround(1.0) : f2;
 HEAPF32[i5 >> 2] = i6 ? Math_fround(0.0) : f2;
 __ZN11KeyframeTplIfEC2EfRKf(i4, Math_fround(0.0), i5);
 __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_(i1 + 36 | 0, i4, i4 + 16 | 0);
 STACKTOP = i3;
 return;
}

function __ZN10OnGUIState10BeginOnGUIEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 HEAP32[i1 + 40 >> 2] = 1065353216;
 HEAP32[i1 + 44 >> 2] = 1065353216;
 HEAP32[i1 + 16 >> 2] = 1065353216;
 HEAP32[i1 + 20 >> 2] = 1065353216;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i1 + 4 >> 2] = 1065353216;
 HEAP32[i1 + 8 >> 2] = 1065353216;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 1;
 return;
}

function __ZL38UnityAudioEffect_InternalResetCallbackP14FMOD_DSP_STATE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[i2 >> 2] = 0;
 i1 = __ZN4FMOD3DSP11getUserDataEPPv(HEAP32[i1 >> 2] | 0, i2) | 0;
 if (!i1) {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i2) i1 = 36; else {
   i1 = HEAP32[(HEAP32[i2 + 112 >> 2] | 0) + 168 >> 2] | 0;
   if (!i1) i1 = 0; else {
    i1 = (mftCall_ii(i1 | 0, i2 | 0) | 0) == 0;
    i1 = i1 ? 0 : 80;
   }
  }
 }
 STACKTOP = i3;
 return i1 | 0;
}

function __Z56ParticleSystem_ExternalForcesModule_CUSTOM_GetMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 880 >> 2] | 0) + 8 >> 2]);
 return Math_fround(f3);
}

function __Z55ParticleSystem_TrailModule_CUSTOM_GetLifetimeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 92 >> 2]);
 return Math_fround(f3);
}

function __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitSpringP12Il2CppObjectP20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 120 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z54ParticleSystem_TrailModule_CUSTOM_GetMinVertexDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 276 >> 2]);
 return Math_fround(f3);
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 892 >> 2] | 0) + 616 >> 2]);
 return Math_fround(f3);
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 892 >> 2] | 0) + 352 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapZMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 1700 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapYMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 1436 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 1172 >> 2]);
 return Math_fround(f3);
}

function __ZN8Collider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i4 = i1 + 32 | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 }
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj(i5, f1, i4, i2, i3) {
 i5 = i5 | 0;
 f1 = Math_fround(f1);
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i6 = 0;
 if (!(HEAP8[i5 + 276 >> 0] | 0)) return;
 i6 = __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() | 0;
 __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17CUDAProfileBufferEyfPKhjj(i5, i6, getTempRet0() | 0, f1, i4, i2, i3);
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx18solveConcludeExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 i4 = (HEAP8[i2 >> 0] | 0) == 4 ? 176 : 112;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i3 = i1 & 255;
 i1 = i2 + 48 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i1 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i4 | 0;
 }
 return;
}

function __ZN27ParticleSystemReadOnlyState5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 264 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 268 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 272 >> 2] = 0;
 HEAP8[i1 + 276 >> 0] = 1;
 HEAP8[i1 + 277 >> 0] = 1;
 HEAP8[i1 + 278 >> 0] = 0;
 HEAP8[i1 + 279 >> 0] = 1;
 HEAP32[i1 + 280 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = 1;
 HEAP16[i1 + 84 >> 1] = 0;
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i1 + 88 | 0, Math_fround(0.0), 0) | 0) & 1;
 return;
}

function __ZN10UnityScene10ClearRootsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 104 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 i5 = i1 + 100 | 0;
 if ((i2 | 0) == (i5 | 0)) return; else i1 = i2;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  i2 = i4 + 104 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3) {
   i1 = i4 + 108 | 0;
   HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
   HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
   HEAP32[i2 >> 2] = 0;
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  HEAP32[i4 + 116 >> 2] = 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 892 >> 2] | 0) + 88 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_NoiseModule_CUSTOM_GetOctaveMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 812 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_LightsModule_CUSTOM_GetRangeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 920 >> 2] | 0) + 104 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_GetMinKillSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 936 >> 2]);
 return Math_fround(f3);
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_GetMaxKillSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 940 >> 2]);
 return Math_fround(f3);
}

function __Z44BillboardAsset_CUSTOM_SetIndicesInternalListP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(HEAP32[i2 + 8 >> 2] | 0, 0, 2) | 0;
  __ZN14BillboardAsset10SetIndicesEPKtj(i3, i1, HEAP32[i2 + 12 >> 2] | 0);
  return;
 }
}

function __Z38Shader_CUSTOM_SetGlobalVectorArrayImpliP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i2, i1);
 STACKTOP = i3;
 return;
}

function __Z38Shader_CUSTOM_SetGlobalMatrixArrayImpliP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i2, i1);
 STACKTOP = i3;
 return;
}

function __Z37MaterialPropertyBlock_CUSTOM_SetFloatP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE(i1, i4, f3, 0);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z32Joint_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 44 >> 2] | 0;
  i1 = HEAP32[i3 + 48 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 40 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __Z30CanvasRenderer_CUSTOM_GetAlphaP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer8GetColorEv(i2, i3);
   f5 = Math_fround(HEAPF32[i2 + 12 >> 2]);
   STACKTOP = i4;
   return Math_fround(f5);
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28TextMesh_Get_Custom_PropTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = i2 + 32 | 0;
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  return __Z20scripting_string_newPKcj(i3 ? HEAP32[i1 >> 2] | 0 : i1, i3 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255) | 0;
 }
 return 0;
}

function __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEEC2EjjSB_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj(HEAP32[i1 >> 2] | 0, i3 << 4) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i1 + (i4 << 4) | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1 + (i3 << 4);
 return;
}

function __ZNK5physx7NpActor14getNpAggregateERj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i3) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP8[i2 + (i1 << 3) >> 0] | 0) == 1) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) return i1 | 0;
 HEAP32[i4 >> 2] = i1;
 i5 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 return i5 | 0;
}

function __ZNK5physx6PxVec4plERKS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN5physx6PxVec4C2Effff(i1, f7, f6, f5, Math_fround(f4 + Math_fround(HEAPF32[i3 + 12 >> 2])));
 return;
}

function __ZNK5physx6PxVec4miERKS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN5physx6PxVec4C2Effff(i1, f7, f6, f5, Math_fround(f4 - Math_fround(HEAPF32[i3 + 12 >> 2])));
 return;
}

function __ZNK16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   i1 = i1 + 28 | 0;
   break;
  }
 case 1:
  {
   i1 = i1 + 36 | 0;
   break;
  }
 case 2:
  {
   i1 = i1 + 52 | 0;
   break;
  }
 case 3:
  {
   i1 = i1 + 44 | 0;
   break;
  }
 case 4:
  {
   i1 = i1 + 68 | 0;
   break;
  }
 case 5:
  {
   i1 = i1 + 60 | 0;
   break;
  }
 case 6:
  {
   i1 = i1 + 76 | 0;
   break;
  }
 case 7:
  {
   i1 = i1 + 84 | 0;
   break;
  }
 default:
  i1 = i1 + 28 | 0;
 }
 return i1 | 0;
}

function __ZNK12NavMeshAgent21CalculateScaledHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 __ZNK9Transform18GetWorldScaleLossyEv(i5, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 f3 = Math_fround(HEAPF32[i5 + 4 >> 2]);
 i5 = f3 < Math_fround(0.0);
 f4 = Math_fround(-f3);
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 40 >> 2]) * (i5 ? f4 : f3));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN7mecanim9animation32DeallocateAvatarOuputForBindingsEPNS0_12AvatarOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 16 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i4 >> 2] | 0);
 __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 i3 = i1 + 4 | 0;
 __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i2);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN5physx9NpFactory14onShapeReleaseEPNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 i1 = i2 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE5eraseERKS4_(i2 + 604 | 0, i4) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx32PxTolerancesScaleGeneratedValuesC2EPKNS_17PxTolerancesScaleE(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, f2 = f0, i3 = 0, f6 = f0;
 f2 = Math_fround(HEAPF32[i4 >> 2]);
 i1 = i4 + 4 | 0;
 if (f2 > Math_fround(0.0)) {
  f6 = Math_fround(HEAPF32[i1 >> 2]);
  i3 = f6 > Math_fround(0.0) & 1;
  i1 = (HEAPF32[tempDoublePtr >> 2] = f6, HEAP32[tempDoublePtr >> 2] | 0);
 } else {
  i3 = 0;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 HEAP8[i5 >> 0] = i3;
 HEAPF32[i5 + 4 >> 2] = f2;
 HEAP32[i5 + 8 >> 2] = i1;
 HEAP32[i5 + 12 >> 2] = HEAP32[i4 + 8 >> 2];
 return;
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEEC2EPNS0_7SystemIEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7SetSizeEi(i1, i3);
 return;
}

function __ZL24StaticInitializeIUnityVRPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[gb + 1469364 >> 2] = fb + 3952;
 HEAP32[gb + 1469364 + 4 >> 2] = fb + 409;
 i3 = HEAP32[(__Z18GetUnityInterfacesv() | 0) + 4 >> 2] | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = 586239589;
 HEAP32[i4 + 4 >> 2] = 1008725759;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 426257907;
 HEAP32[i4 + 4 >> 2] = -2134066609;
 mftCall_vii(i3 | 0, i2 | 0, gb + 1469364 | 0);
 STACKTOP = i1;
 return;
}

function __ZL22InternalWarningConsolePKcz(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 2, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 2);
 STACKTOP = i5;
 return;
}

function __Z52ParticleSystem_CollisionModule_CUSTOM_GetRadiusScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 944 >> 2]);
 return Math_fround(f3);
}

function __Z38AnimationClip_Get_Custom_PropStartTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13AnimationClip8GetRangeEv(i2, i3);
   f5 = Math_fround(HEAPF32[i2 >> 2]);
   STACKTOP = i4;
   return Math_fround(f5);
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z27GUIText_Get_Custom_PropTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i1 = i2 + 36 | 0;
  i2 = HEAP8[i1 + 11 >> 0] | 0;
  i3 = i2 << 24 >> 24 < 0;
  return __Z20scripting_string_newPKcj(i3 ? HEAP32[i1 >> 2] | 0 : i1, i3 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255) | 0;
 }
 return 0;
}

function __Z24WWW_Get_Custom_PropErrorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
   if (!i1) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = __Z20scripting_string_newPKc(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function _UNITY_tt_face_load_prep(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1886545264, i2 | 0, i3 | 0) | 0)) {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 636 >> 2] = i3;
  i3 = _UNITY_FT_Stream_ExtractFrame(i2, i3, i1 + 640 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i1 + 640 >> 2] = 0;
  HEAP32[i1 + 636 >> 2] = 0;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function _UNITY_tt_face_load_fpgm(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1718642541, i2 | 0, i3 | 0) | 0)) {
  i3 = HEAP32[i3 >> 2] | 0;
  HEAP32[i1 + 628 >> 2] = i3;
  i3 = _UNITY_FT_Stream_ExtractFrame(i2, i3, i1 + 632 | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i1 + 632 >> 2] = 0;
  HEAP32[i1 + 628 >> 2] = 0;
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZNK5physx2Sn8MetaData12getMetaClassEPKc(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i4) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = 0;
 while (1) {
  i1 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
  i3 = i3 + 1 | 0;
  if (!(_strcmp(HEAP32[i1 + 12 >> 2] | 0, i5) | 0)) break;
  if (i3 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 while (1) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 return i1 | 0;
}

function __ZN8Animator17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN12UserListNode5ClearEv(i1 + 468 | 0);
 __ZN8UserList5ClearEv(i1 + 480 | 0);
 __ZN8Animator11ClearObjectEv(i1);
 i2 = i1 + 624 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN14DirectorPlayer17MainThreadCleanupEv(i1);
  return;
 }
 __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv(i3);
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0, i1 + 112 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZN14DirectorPlayer17MainThreadCleanupEv(i1);
 return;
}

function __ZN7dtCrowd30SetObstaclePositionAndVelocityERK13dtCrowdHandlePKfS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 + 416 >> 2] | 0;
 HEAP32[i1 + (i2 * 92 | 0) >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 12 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 16 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + (i2 * 92 | 0) + 20 >> 2] = HEAP32[i4 + 8 >> 2];
 return;
}

function __ZN4gles21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i5 = i4 + 72 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = (i2 | 0) != 0 & 1;
 HEAP8[i1 + 56 >> 0] = 0;
 HEAP8[i1 + 64 >> 0] = 0;
 HEAP8[i1 + 72 >> 0] = 0;
 HEAP8[i1 + 73 >> 0] = 0;
 HEAP32[i1 + 44 >> 2] = -1;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 return;
}

function __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   i1 = i1 + 28 | 0;
   break;
  }
 case 1:
  {
   i1 = i1 + 36 | 0;
   break;
  }
 case 2:
  {
   i1 = i1 + 52 | 0;
   break;
  }
 case 3:
  {
   i1 = i1 + 44 | 0;
   break;
  }
 case 4:
  {
   i1 = i1 + 68 | 0;
   break;
  }
 case 5:
  {
   i1 = i1 + 60 | 0;
   break;
  }
 case 6:
  {
   i1 = i1 + 76 | 0;
   break;
  }
 case 7:
  {
   i1 = i1 + 84 | 0;
   break;
  }
 default:
  i1 = i1 + 28 | 0;
 }
 return i1 | 0;
}

function __ZN14Texture2DArray16DeleteGfxTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 108 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN10DynamicVBO14AllocateHandleEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[i1 + 25 >> 0] | 0)) {
  HEAP32[gb + 1161248 >> 2] = (HEAP32[gb + 1161248 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1161244 >> 2] & 2147483647;
  i2 = gb + 1161248 | 0;
 } else {
  HEAP32[gb + 1161252 >> 2] = (HEAP32[gb + 1161252 >> 2] | 0) + 1;
  i1 = HEAP32[gb + 1161256 >> 2] | -2147483648;
  i2 = gb + 1161252 | 0;
 }
 i2 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i2;
 HEAP32[i3 + 12 >> 2] = i1;
 return;
}

function __ZL21InternalAssertConsolePKcz(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 1, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 1);
 STACKTOP = i5;
 return;
}

function __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(__ZNK14ParticleSystem18GetSimulationSpeedEv(i2));
 return Math_fround(f3);
}

function __Z42TerrainData_CUSTOM_Internal_SetDetailLayerP12Il2CppObjectiiiiiP11Il2CppArray(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0;
 if (!i1) i1 = 0; else {
  i8 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i8) {
   __ZN14DetailDatabase8SetLayerEiiiiiPKi(i8 + 128 | 0, i2, i3, i4, i5, i6, __Z27scripting_array_element_ptrP11Il2CppArrayij(i7, 0, 4) | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Shader_CUSTOM_SetGlobalFloatArrayImpliP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i5, i4, i2, i1);
 STACKTOP = i3;
 return;
}

function __Z37CanvasRenderer_CUSTOM_SetAlphaTextureP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN2UI14CanvasRenderer15SetAlphaTextureEP7Texture(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN2UI14CanvasRenderer15SetAlphaTextureEP7Texture(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Joint_CUSTOM_INTERNAL_get_axisP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = HEAP32[i3 + 68 >> 2] | 0;
  i1 = HEAP32[i3 + 72 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i2 + 4 >> 2] = i4;
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function _wcstok(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if (!i1) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else i3 = 3;
 } else i3 = 3;
 do if ((i3 | 0) == 3) {
  i1 = i1 + ((_wcsspn(i1, i2) | 0) << 2) | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   HEAP32[i4 >> 2] = 0;
   i1 = 0;
   break;
  }
  i2 = i1 + ((_wcscspn(i1, i2) | 0) << 2) | 0;
  HEAP32[i4 >> 2] = i2;
  if (!(HEAP32[i2 >> 2] | 0)) {
   HEAP32[i4 >> 2] = 0;
   break;
  } else {
   HEAP32[i4 >> 2] = i2 + 4;
   HEAP32[i2 >> 2] = 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarker10initializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + -8 | 0;
 i1 = i2 + 8 | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, 0) | 0;
 i3 = i2 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i1, i4);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i1);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i2 + 16 >> 2] | 0, i1);
 return;
}

function __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77508 + 12;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = gb + 77508 + 32;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i2);
 __ZdlPv(i1);
 return;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl22getNamedPropertyValuesEN5physx8debugger18NonNegativeIntegerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) > -1) if ((HEAP32[i2 + 152 >> 2] | 0) > (i1 | 0)) {
  i1 = HEAP32[(HEAP32[i2 + 148 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  if (i1 | 0) {
   i4 = HEAP32[i1 + 64 >> 2] | 0;
   i2 = i4 + (HEAP32[i1 + 68 >> 2] << 3) | 0;
   HEAP32[i3 >> 2] = i4;
   HEAP32[i3 + 4 >> 2] = i2;
   return;
  }
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 return;
}

function __ZN20FileSystemEnumerator9EnumerateEPFbR13FileEntryInfoPvES2_19FileEnumerationFlag(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i7 = i3 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i7 >> 2] | 0)) return 1;
 do {
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i2 = HEAP32[i1 >> 2] | 0; else i2 = i1;
  __ZN20FileSystemEnumerator18EnumerateDirectoryEPKcPFbR13FileEntryInfoPvES4_19FileEnumerationFlag(i3, i2, i4, i5, i6);
  i1 = i1 + 16 | 0;
 } while ((i1 | 0) != (HEAP32[i7 >> 2] | 0));
 return 1;
}

function __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi(i1, i6, i2, i3, i4) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = (HEAP32[i5 + (i6 * 12 | 0) >> 2] | 0) + i2 | 0;
 if ((i4 | 0) == 4) {
  i1 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
  HEAP32[i2 >> 2] = i1;
  HEAP8[i5 + (i6 * 12 | 0) + 10 >> 0] = 1;
  return;
 } else {
  if (!(_memcmp(i2, i3, i4) | 0)) return;
  _memcpy(i2 | 0, i3 | 0, i4 | 0) | 0;
  HEAP8[i5 + (i6 * 12 | 0) + 10 >> 0] = 1;
  return;
 }
}

function __ZN19AudioHighPassFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(10.0);
 i5 = f2 > Math_fround(22.0e3);
 f2 = i5 ? Math_fround(22.0e3) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(10.0) : f2;
 i1 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(1.0);
 i4 = f2 > Math_fround(10.0);
 f2 = i4 ? Math_fround(10.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(1.0) : f2;
 return;
}

function __ZN13SparseTexture16DeleteGfxTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 100 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN13GfxDeviceGLES14SetScissorRectERK5RectTIiE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 7185 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) {
  __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i1 + 4620 | 0, 13);
  HEAP8[i3 >> 0] = 1;
 }
 i3 = i1 + 7164 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN18GfxFramebufferGLES10SetScissorERK5RectTIiE(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, i2);
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClient15sendEventBufferEN5physx8debugger7DataRefIKhEEjy(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = (HEAP32[i3 + 4 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 20 >> 2] | 0, i5 | 0, i6 | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
 i4 = mftCall_iiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0, i6 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 28 >> 2] | 0, i5 | 0);
 return (i4 | 0) == 0 | 0;
}

function __ZN11MonoManager13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13UnityProfiler24InitializeMemoryProfilerEv(HEAP32[gb + 1451e3 >> 2] | 0);
 __ZN13UnityProfiler19SetupProfilerEventsEv(HEAP32[gb + 1451e3 >> 2] | 0);
 __ZN11MonoManager14LoadAssembliesEv(i1);
 __Z26FillCommonScriptingClassesR22CommonScriptingClasses(i1 + 44 | 0);
 __ZN16ScriptingManager33RebuildNativeTypeToScriptingClassEv(i1);
 __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE(fb + 14 | 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj4EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 11 >> 0] = 3;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZL20InternalErrorConsolePKcz(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 0, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 0);
 STACKTOP = i5;
 return;
}

function __Z51CharacterJoint_CUSTOM_INTERNAL_get_twistLimitSpringP12Il2CppObjectP20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 108 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z51CharacterJoint_CUSTOM_INTERNAL_get_swingLimitSpringP12Il2CppObjectP20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 140 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z50ParticleSystem_CollisionModule_CUSTOM_GetVoxelSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 904 >> 2] | 0) + 964 >> 2]);
 return Math_fround(f3);
}

function __Z25BeginsWithCaseInsensitivePKcS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  if (!(i3 << 24 >> 24)) {
   i1 = 1;
   i2 = 4;
   break;
  }
  i6 = HEAP8[i2 >> 0] | 0;
  i5 = i6 << 24 >> 24;
  i4 = i3 << 24 >> 24;
  if ((((i6 + -65 & 255) < 26 ? i5 + 32 | 0 : i5) & 255) << 24 >> 24 == (((i3 + -65 & 255) < 26 ? i4 + 32 | 0 : i4) & 255) << 24 >> 24) {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } else {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function _strlen(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1;
 L1 : do if (!(i4 & 3)) i3 = 4; else {
  i2 = i4;
  while (1) {
   if (!(HEAP8[i1 >> 0] | 0)) {
    i1 = i2;
    break L1;
   }
   i1 = i1 + 1 | 0;
   i2 = i1;
   if (!(i2 & 3)) {
    i3 = 4;
    break;
   }
  }
 } while (0);
 if ((i3 | 0) == 4) {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if (!((i2 & -2139062144 ^ -2139062144) & i2 + -16843009)) i1 = i1 + 4 | 0; else break;
  }
  if ((i2 & 255) << 24 >> 24) do i1 = i1 + 1 | 0; while ((HEAP8[i1 >> 0] | 0) != 0);
 }
 return i1 - i4 | 0;
}

function _puts(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 191868 >> 2] | 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) i4 = ___lockfile(i3) | 0; else i4 = 0;
 do if ((_fputs(i1, i3) | 0) < 0) i1 = 1; else {
  if ((HEAP8[i3 + 75 >> 0] | 0) != 10) {
   i1 = i3 + 20 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
   if (i2 >>> 0 < (HEAP32[i3 + 16 >> 2] | 0) >>> 0) {
    HEAP32[i1 >> 2] = i2 + 1;
    HEAP8[i2 >> 0] = 10;
    i1 = 0;
    break;
   }
  }
  i1 = (___overflow(i3, 10) | 0) < 0;
 } while (0);
 if (i4 | 0) ___unlockfile(i3);
 return i1 << 31 >> 31 | 0;
}

function _posix_memalign(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 do if ((i1 | 0) == 8) i1 = _malloc(i2) | 0; else {
  i3 = i1 >>> 2;
  if ((i1 & 3 | 0) != 0 | (i3 | 0) == 0) {
   i4 = 22;
   return i4 | 0;
  }
  if (i3 + 1073741823 & i3 | 0) {
   i4 = 22;
   return i4 | 0;
  }
  if ((-64 - i1 | 0) >>> 0 < i2 >>> 0) {
   i4 = 12;
   return i4 | 0;
  } else {
   i1 = _internal_memalign(i1 >>> 0 < 16 ? 16 : i1, i2) | 0;
   break;
  }
 } while (0);
 if (!i1) {
  i4 = 12;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i4 = 0;
 return i4 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEaSEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i4, i2);
 i6 = i4 + 72 | 0;
 i3 = i2 + 72 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 76 | 0;
 i2 = i2 + 76 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEaSEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i4, i2);
 i6 = i4 + 72 | 0;
 i3 = i2 + 72 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i5;
 i4 = i4 + 76 | 0;
 i2 = i2 + 76 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZN9GfxDevice13SetViewMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 3612 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 3;
 i3 = i1 + 1828 | 0;
 i4 = i3;
 i5 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
  i4 = i4 + 4 | 0;
  i5 = i5 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 __Z25InvertMatrix4x4_General3DPKfPf(i2, i1 + 1892 | 0) | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + 3420 | 0) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i1 + 1764 | 0, i3, i1 + 1956 | 0);
 return;
}

function __ZN8Material15ClearPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 100 >> 2] | 0;
 __ZN19ShaderPropertySheet5ClearEb(i2 + 12 | 0, 0);
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 i5 = i2 + 164 | 0;
 HEAP8[i5 >> 0] = HEAP8[i5 >> 0] & -2;
 return;
}

function __ZN5physx7NpShape7setFlagENS_11PxShapeFlag4EnumEb(i5, i2, i3) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP8[((HEAP32[i5 + 36 >> 2] & 64 | 0) == 0 ? i5 + 112 | 0 : (HEAP32[i5 + 40 >> 2] | 0) + 52 | 0) >> 0] | 0;
 if (i3) i1 = (i1 & 255 | i2) & 255; else i1 = i1 & ((i2 ^ 255) & 255);
 HEAP8[i4 >> 0] = i1;
 __ZN5physx7NpShape16setFlagsInternalENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i5, i4);
 STACKTOP = i6;
 return;
}

function __ZN5physx19NpClothParticleData6unlockEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = i4 + 20 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 i2 = i1 & 255;
 if (!(i2 & 4)) {
  i1 = i4 + 12 | 0;
  if (i2 & 2 | 0) {
   i2 = HEAP32[i1 >> 2] | 0;
   mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0, HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0);
  }
  __ZN5physx7NpCloth18unlockParticleDataEv(HEAP32[i1 >> 2] | 0);
  i1 = HEAP8[i3 >> 0] | 0;
 }
 HEAP8[i3 >> 0] = i1 & 249;
 i4 = i4 + 16 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 return;
}

function __ZN25MultiBlocksMemoryFileDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 >> 2] = gb + 71660 + 8;
 i3 = i2 + 20 | 0;
 i4 = i2 + 32 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = i2 + 8 | 0;
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] | 0, i5);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + 24 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN13WebCamTextureD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 25856 + 8;
 i1 = i3 + 120 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i1 = i3 + 124 | 0; else {
  HEAP8[i1 >> 0] = 0;
  i1 = i3 + 124 | 0;
  _JS_WebCamVideo_Stop(HEAP32[HEAP32[i1 >> 2] >> 2] | 0);
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 176 >> 2] | 0, i3 | 0);
 }
 HEAP8[i3 + 92 >> 0] = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  __ZN17BaseWebCamTextureD2Ev(i3);
  return;
 }
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 __ZN17BaseWebCamTextureD2Ev(i3);
 return;
}

function __ZN13SparseTexture15ThreadedCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 100 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN12CubemapArray16DeleteGfxTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z64AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2) | 0;
 switch (i3 | 0) {
 case 1:
  {
   i3 = 0;
   return i3 | 0;
  }
 case 16:
  {
   i3 = 1;
   return i3 | 0;
  }
 default:
  {
   __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i3, i2);
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __Z50ParticleSystem_TriggerModule_CUSTOM_GetRadiusScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 912 >> 2] | 0) + 24 >> 2]);
 return Math_fround(f3);
}

function __Z28GUIStyle_Get_Custom_PropNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP8[i1 + 11 >> 0] | 0;
   i4 = i2 << 24 >> 24 < 0;
   i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i2 & 255) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function _wordfree(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (i1 | 0) {
  if (HEAP32[i3 >> 2] | 0) {
   i2 = i3 + 8 | 0;
   _free(HEAP32[i1 + (HEAP32[i2 >> 2] << 2) >> 2] | 0);
   if ((HEAP32[i3 >> 2] | 0) >>> 0 > 1) {
    i1 = 1;
    do {
     _free(HEAP32[(HEAP32[i4 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) + i1 << 2) >> 2] | 0);
     i1 = i1 + 1 | 0;
    } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
   }
   i1 = HEAP32[i4 >> 2] | 0;
  }
  _free(i1);
  HEAP32[i4 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 return;
}

function _vswscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 368 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i7 + 112 | 0;
 i5 = i7;
 i6 = i5;
 i8 = i6 + 112 | 0;
 do {
  HEAP32[i6 >> 2] = 0;
  i6 = i6 + 4 | 0;
 } while ((i6 | 0) < (i8 | 0));
 HEAP32[i5 + 32 >> 2] = fb + 498;
 HEAP32[i5 + 44 >> 2] = i4;
 HEAP32[i5 + 48 >> 2] = 256;
 HEAP32[i5 + 76 >> 2] = -1;
 HEAP32[i5 + 84 >> 2] = i1;
 i8 = _vfwscanf(i5, i2, i3) | 0;
 STACKTOP = i7;
 return i8 | 0;
}

function __ZN8Animator19ValidateParameterIDE17GetSetValueResulti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i4 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = i3;
 __Z6FormatPKcz(i4, gb + 913694 | 0, i5);
 __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(0, i2, i4);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
 STACKTOP = i1;
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAPU16[i1 >> 1] | 0;
  i3 = i5 << 12 & 15728640;
  HEAP32[i4 >> 2] = i5 & 61455 | i5 << 4 & 240 | i5 << 24 & -268435456 | i5 << 20 & 251658240 | i5 >>> 4 & 3840 | i3 | i3 >>> 4;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx7NpScene14prepareCollideEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 16 | 0;
 __ZN5physx3Scb5Scene26preSimulateUpdateAppThreadEf(i4, f1);
 HEAPF32[i2 + 3700 >> 2] = f1;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) + 52 >> 2] | 0;
 HEAPF32[i2 + 96 >> 2] = f1;
 i5 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 HEAPF32[i2 + 100 >> 2] = i5 ? f1 : Math_fround(0.0);
 __ZN5physx3Scb5Scene22updateLowLevelMaterialEPPNS_10NpMaterialE(i4, i3);
 return;
}

function __ZN5physx2Sq12BucketPruner13removeObjectsEPKjj(i5, i3, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 if (i2 | 0) {
  i1 = i5 + 7616 | 0;
  i4 = 0;
  do {
   __ZN5physx2Sq11PruningPool12removeObjectEj(i1, HEAP32[i3 + (i4 << 2) >> 2] | 0) | 0;
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) != (i2 | 0));
 }
 i3 = HEAP32[i5 + 7628 >> 2] | 0;
 i4 = HEAP32[i5 + 7632 >> 2] | 0;
 HEAP32[i5 + 16 >> 2] = HEAP32[i5 + 7620 >> 2];
 HEAP32[i5 + 24 >> 2] = i3;
 HEAP32[i5 + 28 >> 2] = i4;
 HEAP32[i5 + 32 >> 2] = 0;
 HEAP8[i5 + 7600 >> 0] = 1;
 return;
}

function __ZN5physx2Sc9ClothCore23setSelfCollisionIndicesEPKjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i7 = i4;
 i3 = HEAP32[i3 + 28 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i3 >> 2] | 0) + 336 >> 2] | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i1 + (i2 << 2);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 mftCall_vii(i6 | 0, i3 | 0, i5 | 0);
 STACKTOP = i4;
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManager28removeFromPendingTreeUpdatesERNS0_19ConstraintGroupNodeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 340 | 0, i4) | 0;
 i2 = i1 + 44 | 0;
 HEAP8[i2 >> 0] = (HEAPU8[i2 >> 0] | 0) & 251;
 STACKTOP = i3;
 return;
}

function __ZN5physx19NpArticulationJoint7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i1, 0, 1);
 i2 = i1 + 8 | 0;
 if ((((HEAP32[i1 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  __ZN5physx3Scb4Base7destroyEv(i2);
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx3Scb4Base7destroyEv(i2);
  return;
 }
 __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE(i1, i2);
 __ZN5physx3Scb4Base7destroyEv(i2);
 return;
}

function __ZN5physx16PxsBroadPhaseMBP9updatePPUEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 i5 = HEAP32[i2 + 120 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i7 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i6) return;
 i1 = i1 + 52 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[i7 + (i3 * 40 | 0) + 28 >> 2] | 0;
  if (i2 | 0) __ZN9BoxPruner14findOverlapsMTER15MBP_PairManagerPKjPK10MBP_Object(i2, i1, i5, i4);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i6 | 0));
 return;
}

function __ZN4FMOD7SystemI12createReverbEPPNS_6ReverbE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7GetFreeEi(i1 + 268 | 0, -1) | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 36;
  HEAP32[i3 + 4 >> 2] = gb + 857621;
  _printf(gb + 853184 | 0, i3) | 0;
  i3 = 36;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 + 20 >> 2];
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN29UnityWebRequestAsyncOperationD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 188044 + 8;
 i2 = i1 + 24 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (HEAP32[i4 >> 2] | 0) {
  HEAP32[i2 >> 2] = 0;
  __ZN14AsyncOperationD2Ev(i1);
  return;
 }
 __ZN19TransportJavaScript5AbortEv(i3 + 8 | 0);
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63808 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZN14AsyncOperationD2Ev(i1);
 return;
}

function __ZN22ProceduralMaterialData20ReleaseTextureInputsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i5 = i1 + 48 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 do {
  i3 = i2 + 28 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i4 + 16 >> 2] | 0, gb + 63184 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63736 | 0);
   HEAP32[i3 >> 2] = 0;
   i1 = HEAP32[i5 >> 2] | 0;
  }
  i2 = i2 + 36 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN13GfxDeviceGLES15InvalidateStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN9GfxDevice15InvalidateStateEv(i1);
 HEAP32[i1 + 6620 >> 2] = 7;
 i3 = i1 + 4616 | 0;
 __ZN4gles10InvalidateERK14GfxContextGLESR15DeviceStateGLES(HEAP32[i3 >> 2] | 0, i1 + 6616 | 0);
 i2 = HEAP32[i1 + 4688 >> 2] | 0;
 if ((HEAP8[i1 + 7184 >> 0] | 0) == (HEAP8[i1 + 4381 >> 0] | 0)) mftCall_vi(i2 | 0, 2304); else mftCall_vi(i2 | 0, 2305);
 __ZN18GfxFramebufferGLES32InvalidateActiveFramebufferStateEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i3 >> 2] | 0) | 0);
 return;
}

function __ZN12LineRenderer16SetUseWorldSpaceEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 HEAP8[i3 + 340 >> 0] = i1 & 1;
 i1 = i3 + 316 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  __ZN8Renderer13BoundsChangedEv(i3);
  return;
 }
 i2 = HEAP32[gb + 1158208 + 4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN8Renderer13BoundsChangedEv(i3);
  return;
 }
 i4 = i3 + 320 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i5;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
 __ZN8Renderer13BoundsChangedEv(i3);
 return;
}

function __ZL18InternalLogConsolePKcz(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 3, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 3);
 STACKTOP = i5;
 return;
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 816 >> 2]);
 return Math_fround(f3);
}

function __Z44DebugLogHandler_CUSTOM_Internal_LogExceptionP15Il2CppExceptionP12Il2CppObject(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 do if (!i3) i1 = 0; else if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0)) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
  if (!i4) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else {
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   break;
  }
 } while (0);
 __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i2, i1, 0);
 return;
}

function __Z39TrailRenderer_Get_Custom_PropStartWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = HEAP32[i2 + 384 >> 2] | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i2 + 76 >> 2] | 0) + 4 >> 2]);
  return Math_fround(f3 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 }
 return Math_fround(0.0);
}

function __Z35CommandBuffer_CUSTOM_SetGlobalFloatP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer17AddSetGlobalFloatERKN9ShaderLab16FastPropertyNameEf(i1, i4, f3);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z20IsLightValidToRenderRK5Light(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 switch (HEAP32[i1 + 40 >> 2] | 0) {
 case 0:
  {
   if (Math_fround(HEAPF32[i1 + 48 >> 2]) < Math_fround(.00100000005)) {
    i1 = 0;
    return i1 | 0;
   }
   if (Math_fround(HEAPF32[i1 + 60 >> 2]) < Math_fround(.00100000005)) {
    i1 = 0;
    return i1 | 0;
   }
   i1 = 1;
   return i1 | 0;
  }
 case 2:
  {
   i1 = !(Math_fround(HEAPF32[i1 + 48 >> 2]) < Math_fround(9.99999993e-09));
   return i1 | 0;
  }
 default:
  {
   i1 = 1;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZNK8GUIStyle9ClampRectERK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0, f7 = f0, f8 = f0, i9 = 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 f8 = Math_fround(HEAPF32[i2 + 276 >> 2]);
 i9 = f8 != Math_fround(0.0);
 f7 = Math_fround(HEAPF32[i3 + 8 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 280 >> 2]);
 i2 = f5 != Math_fround(0.0);
 f4 = Math_fround(HEAPF32[i3 + 12 >> 2]);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAPF32[i1 + 8 >> 2] = i9 ? f8 : f7;
 HEAP32[i1 + 4 >> 2] = i6;
 HEAPF32[i1 + 12 >> 2] = i2 ? f5 : f4;
 return;
}

function __ZNK5Umbra14TomeCollection21getClusterPortalCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  i2 = (HEAP32[i1 + 124 >> 2] | 0) + -1 | 0;
  i1 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 * 20 | 0) >> 2] | 0) | 0;
  return i1 | 0;
 } else {
  i2 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK12RemoveByName16ShouldRemoveClipEP13AnimationClip(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 i2 = i4 + 4 | 0;
 i3 = _strlen(i1) | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 if ((i3 | 0) != ((i5 << 24 >> 24 < 0 ? HEAP32[i4 + 8 >> 2] | 0 : i5 & 255) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i2, 0, -1, i1, i3) | 0) == 0;
 return i5 | 0;
}

function __ZN8Remapper14PreallocateIDsExiRiS0_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = i1 + 24 | 0;
 i8 = (HEAP32[i7 >> 2] | 0) + 2 | 0;
 HEAP32[i7 >> 2] = i8;
 HEAP32[i1 + 28 >> 2] = i8;
 HEAP32[i5 >> 2] = i8;
 i3 = _bitshift64Shl(i2 | 0, i3 | 0, 1) | 0;
 i5 = getTempRet0() | 0;
 i5 = _i64Add(HEAP32[i7 >> 2] | 0, 0, i3 | 0, i5 | 0) | 0;
 getTempRet0() | 0;
 HEAP32[i7 >> 2] = i5;
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i6 >> 2] = i5;
 HEAP32[i1 + 36 >> 2] = i4;
 return;
}

function __ZN5physx2Sc18TriggerInteraction10initializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 8 | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0) | 0;
 i3 = i1 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i2, i4);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i1 + 16 >> 2] | 0, i2);
 HEAP16[i1 + 52 >> 1] = 0;
 return;
}

function __ZN3WWW7DestroyEPS_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
  i2 = i1 + 76 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if ((i1 | 0) == 0 | (HEAP32[i2 >> 2] | 0) != 0) return;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
  return;
 } else {
  i2 = i1 + 76 | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
  if ((i1 | 0) == 0 | (HEAP32[i2 >> 2] | 0) != 0) return;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
  return;
 }
}

function __ZN27AnimationLayerMixerPlayableD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 176908 + 8;
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i2 + 76 | 0);
 __ZN8PlayableD2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN20TextRenderingPrivate8TextMeshD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 185632 + 8;
 i3 = i1 + 32 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) < 0) {
  i3 = HEAP32[i3 >> 2] | 0;
  i5 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i2 >> 2] = 66;
  HEAP32[i2 + 4 >> 2] = i5;
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 STACKTOP = i4;
 return;
}

function __ZN12_GLOBAL__N_110Connection10disconnectEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 132 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 i1 = i2 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 + 116 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN10VertexData27ConvertLegacyShaderChannelsERK13dynamic_arrayI11ChannelInfoLj4EEi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 if (!i4) i1 = 0; else {
  i1 = i4 << 2;
  _memmove(i2 | 0, HEAP32[i3 >> 2] | 0, i1 | 0) | 0;
 }
 i1 = 28 - i1 | 0;
 if ((i1 | 0) > 0) {
  i1 = i1 >> 2;
  _memset(i2 + (i4 << 2) | 0, 0, (i1 + (((i1 | 0) < 1 ? i1 : 1) ^ 1073741823) << 2) + 8 | 0) | 0;
 }
 HEAP32[i2 + 28 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + (i4 << 2) >> 2];
 if ((HEAP8[i2 + 10 >> 0] | 0) != 2) return;
 HEAP8[i2 + 11 >> 0] = 4;
 return;
}

function __Z66ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 264 + 352 >> 2]);
 return Math_fround(f3);
}

function __Z49Animator_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 __ZN8Animator28SetRuntimeAnimatorControllerEP25RuntimeAnimatorController(i3, i1);
 return;
}

function __Z38LineRenderer_Get_Custom_PropStartWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = HEAP32[i2 + 344 >> 2] | 0;
  f3 = Math_fround(HEAPF32[(HEAP32[i2 + 76 >> 2] | 0) + 4 >> 2]);
  return Math_fround(f3 * Math_fround(HEAPF32[i2 + 16 >> 2]));
 }
 return Math_fround(0.0);
}

function __Z20resizeCreatedDeletedRPN5physx17PxcBroadPhasePairERj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3 + 1 | 0, i4 << 4, gb + 716761 | 0, 504) | 0;
 _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] << 3 | 0) | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = i5;
 HEAP32[i1 >> 2] = i4 << 1;
 STACKTOP = i3;
 return;
}

function __Z16jpeg_memory_destP20jpeg_compress_structPhiPi(i2, i4, i5, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0, i2 | 0, 0, 48) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i1 + 24 >> 2] = i5;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 32 >> 2] = i6;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = fb + 3377;
 HEAP32[i1 + 12 >> 2] = fb + 1575;
 HEAP32[i1 + 16 >> 2] = fb + 3378;
 return;
}

function _UNITY_png_read_finish_IDAT(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 208 | 0;
 if (!(HEAP32[i1 >> 2] & 8)) {
  _UNITY_png_read_IDAT_data(i3, 0, 0);
  HEAP32[i3 + 232 >> 2] = 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!(i2 & 8)) {
   i4 = i3 + 204 | 0;
   HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 8;
   HEAP32[i1 >> 2] = i2 | 8;
  }
 }
 i1 = i3 + 216 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1229209940) return;
 HEAP32[i3 + 220 >> 2] = 0;
 HEAP32[i3 + 224 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 _UNITY_png_crc_finish(i3, HEAP32[i3 + 404 >> 2] | 0) | 0;
 return;
}

function _gzrewind(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 if ((HEAP8[i1 + 92 >> 0] | 0) != 114) {
  i1 = -1;
  return i1 | 0;
 }
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i1 + 76 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
 if (!(HEAP32[i1 + 88 >> 2] | 0)) _unity_z_inflateReset(i1) | 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = 0;
 i1 = _fseek(HEAP32[i1 + 64 >> 2] | 0, HEAP32[i1 + 96 >> 2] | 0, 0) | 0;
 return i1 | 0;
}

function _cosh(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 HEAP32[tempDoublePtr >> 2] = HEAP32[tempDoublePtr >> 2];
 HEAP32[tempDoublePtr + 4 >> 2] = i2;
 d1 = +HEAPF64[tempDoublePtr >> 3];
 do if (i2 >>> 0 < 1072049730) if (i2 >>> 0 < 1045430272) d1 = 1.0; else {
  d1 = +_expm1(d1);
  d1 = d1 * d1 / ((d1 + 1.0) * 2.0) + 1.0;
 } else if (i2 >>> 0 < 1082535490) {
  d1 = +Math_exp(+d1);
  d1 = (d1 + 1.0 / d1) * .5;
  break;
 } else {
  d1 = +___expo2(d1);
  break;
 } while (0);
 return +d1;
}

function __ZN5physx2Gu31SinglePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_(i4, i3, i5, i6) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 i1 = i4 + 384 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return; else i2 = 0;
 do {
  __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj(i4 + (i2 << 6) | 0, i5, i6, i3, HEAP32[gb + 151272 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx20PxsParticleSystemSim22scheduleDynamicsUpdateERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 20 >> 2] & 65536)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i2 = i1;
  return i2 | 0;
 } else {
  HEAP32[i2 + 1200 >> 2] = 1;
  i3 = i2 + 1196 | 0;
  HEAP32[i3 >> 2] = i1;
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  HEAP32[i2 + 1192 >> 2] = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2];
  i2 = i2 + 1184 | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx15solveConclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 i4 = (HEAP8[i2 >> 0] | 0) == 4 ? 176 : 112;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i3 = i1 & 255;
 i1 = i2 + 48 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i1 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + i4 | 0;
 }
 return;
}

function __ZN5physx10PxsContext17releaseFluidShapeEPNS_16PxsParticleShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 320 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = (HEAP32[i2 + 308 >> 2] | 0) + (i4 >>> 5 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~(1 << (i4 & 31));
 i5 = i2 + 296 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i4 + 1;
 HEAP32[(HEAP32[i2 + 292 >> 2] | 0) + (i4 << 2) >> 2] = i1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN5audio5mixer20TransitionToSnapshotERNS0_16AudioMixerMemoryEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i4 = i1 + 60 | 0;
 i5 = i1 + 56 | 0;
 if ((HEAP8[i5 >> 0] | 0) == 0 ? (HEAP32[i4 >> 2] | 0) == (i2 | 0) : 0) {
  i5 = i1 + 48 | 0;
  HEAPF32[i5 >> 2] = f3;
  return;
 }
 _memcpy(HEAP32[i1 + 24 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 20 >> 2] << 2 | 0) | 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAP8[i5 >> 0] = 0;
 HEAP32[i4 >> 2] = i2;
 i5 = i1 + 48 | 0;
 HEAPF32[i5 >> 2] = f3;
 return;
}

function __ZN5Umbra13MatrixFactory5scaleERKNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = i3;
 HEAP32[i1 + 36 >> 2] = 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i2;
 return;
}

function __ZN17ProceduralTextureD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 59360 + 8;
 i1 = HEAP32[i3 + 116 >> 2] | 0;
 if (i1 | 0) {
  i2 = i3 + 120 | 0;
  if ((HEAP32[i2 >> 2] | 0) != (i1 | 0)) HEAP32[i2 >> 2] = i1;
  __ZdlPv(i1);
 }
 i2 = HEAP32[i3 + 104 >> 2] | 0;
 if (i2 | 0) {
  i1 = i3 + 108 | 0;
  if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) HEAP32[i1 >> 2] = i2;
  __ZdlPv(i2);
 }
 HEAP32[i3 >> 2] = gb + 45392 + 8;
 HEAP32[i3 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i3 + 28 | 0);
 HEAP32[i3 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, (HEAP32[i1 + 52 >> 2] | 0) + 12 | 0, 0);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags(i2, (HEAP32[i1 + 52 >> 2] | 0) + 12 | 0, 0);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16Physics2DManager25AddJointBreakLimitUpdatesEP7Joint2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 588 | 0;
 i4 = i2 + 64 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 68 | 0; else {
  i2 = i2 + 68 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEventD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN11TypeManager32RegisterReservedPersistentTypeIDEiPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 __ZN11TypeManager27FatalErrorOnClassIDConflictEiPKc(i1, i2, i3);
 HEAP32[(__ZN14dense_hash_mapIiPKcN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEEixERS9_(i1 + 176 | 0, i5) | 0) >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z46ParticleSystem_NoiseModule_CUSTOM_GetFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 888 >> 2] | 0) + 800 >> 2]);
 return Math_fround(f3);
}

function __Z21SetMaterialFloatArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = HEAP32[i2 >> 2];
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 __ZN8Material13SetFloatArrayEN9ShaderLab16FastPropertyNameEPKfj(i1, i6, i3, i4);
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Create_Class_pscmaps_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = _UNITY_ft_mem_alloc(HEAP32[i1 >> 2] | 0, 16, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = gb + 1006980;
 HEAP32[i3 + 4 >> 2] = (HEAP32[i1 + 204 >> 2] | 0) + 4;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 i4 = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function b123(i1, f2, i13, i19, i20, i21, i22, i23, i24, i25, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12, i14, i15, i16, i17, i18) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i13 = i13 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i21 = i21 | 0;
 i22 = i22 | 0;
 i23 = i23 | 0;
 i24 = i24 | 0;
 i25 = i25 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 nullFunc_vifiiiiiiiiiiiiiiiiiiiiiii(123);
}

function _vdprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4;
 i7 = i5 + 112 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i4 + 36 >> 2] = fb + 489;
 HEAP32[i4 + 44 >> 2] = i2;
 HEAP32[i4 + 48 >> 2] = 0;
 HEAP32[i4 + 60 >> 2] = i1;
 HEAP8[i4 + 75 >> 0] = -1;
 HEAP32[i4 + 76 >> 2] = -1;
 i7 = _vfprintf(i4, i2, i3) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _str_next(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 do if (!i2) {
  HEAP32[i3 >> 2] = 0;
  i1 = 0;
 } else {
  if ((HEAP8[i1 >> 0] | 0) >= 0) {
   HEAP32[i3 >> 2] = 1;
   i1 = HEAP8[i1 >> 0] | 0;
   break;
  }
  i1 = _mbtowc(i4, i1, i2) | 0;
  if ((i1 | 0) < 0) {
   HEAP32[i3 >> 2] = 1;
   i1 = -1;
  } else {
   HEAP32[i3 >> 2] = i1;
   i1 = HEAP32[i4 >> 2] | 0;
  }
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function _sfnt_table_info(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0;
 if (!((i5 | 0) != 0 & (i6 | 0) != 0)) {
  i6 = 6;
  return i6 | 0;
 }
 i1 = HEAPU16[i2 + 152 >> 1] | 0;
 do if (i4) if (i1 >>> 0 > i3 >>> 0) {
  i1 = HEAP32[i2 + 156 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 + (i3 << 4) >> 2];
  HEAP32[i5 >> 2] = HEAP32[i1 + (i3 << 4) + 8 >> 2];
  i1 = HEAP32[i1 + (i3 << 4) + 12 >> 2] | 0;
  break;
 } else {
  i6 = 142;
  return i6 | 0;
 } while (0);
 HEAP32[i6 >> 2] = i1;
 i6 = 0;
 return i6 | 0;
}

function _setsockopt(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = i6 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i7 >> 2] = 14;
 HEAP32[i7 + 4 >> 2] = i8;
 i5 = ___syscall_ret(___syscall102(102, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function _getsockopt(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 i8 = i6 + 8 | 0;
 HEAP32[i8 >> 2] = i1;
 HEAP32[i8 + 4 >> 2] = i2;
 HEAP32[i8 + 8 >> 2] = i3;
 HEAP32[i8 + 12 >> 2] = i4;
 HEAP32[i8 + 16 >> 2] = i5;
 HEAP32[i8 + 20 >> 2] = 0;
 HEAP32[i7 >> 2] = 15;
 HEAP32[i7 + 4 >> 2] = i8;
 i5 = ___syscall_ret(___syscall102(102, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZThn12_N5physx3Ext14SphericalJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88796 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88796 + 200;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZThn12_N5physx3Ext14PrismaticJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88228 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88228 + 216;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2 + 16 | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK9Texture2D20ExtractImageInternalEP14ImageReferenceNS0_8BlitModeEbi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i6) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411051 | 0, 0, gb + 410682 | 0, 351, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  i6 = 0;
  return i6 | 0;
 } else {
  i6 = __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i6, i2, i3, i4, i5) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN9Texture3D16DeleteGfxTextureEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 104 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) {
  STACKTOP = i5;
  return;
 }
 i6 = __Z12GetGfxDevicev() | 0;
 i7 = HEAP32[(HEAP32[i6 >> 2] | 0) + 452 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i7 | 0, i6 | 0, i1 | 0);
 HEAP8[i4 >> 0] = 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx7NpScene31setClothInterCollisionStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene31setClothInterCollisionStiffnessEf(i2 + 32 | 0, f1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 852, gb + 708402 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx2Gu17RadixSortBufferedD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 86392 + 8;
 if (!(HEAP8[i1 + 32 >> 0] | 0)) {
  __ZdlPv(i1);
  STACKTOP = i2;
  return;
 }
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE20RegisterDeallocationEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = (HEAP32[i2 + -8 >> 2] | 0) >>> 1;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) - i4;
 i3 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -23;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = -23 - i4 + (HEAP32[i3 >> 2] | 0);
 __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv(i1, i2) | 0;
 return;
}

function __ZN16RenderTextureMap7CleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1158228 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) {
   i5 = HEAP32[i2 + 52 >> 2] | 0;
   HEAP32[i1 >> 2] = 65;
   HEAP32[i1 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63536 | 0);
 HEAP32[gb + 1158228 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN12ServerSocket14StartListeningEtb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = _htonl(0) | 0;
 i2 = _htons(i2) | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP16[i5 >> 1] = 2;
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP16[i5 + 2 >> 1] = i2;
 i3 = __ZN12ServerSocket14StartListeningEPK8sockaddrjb(i1, i5, 16, i3) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z33MonoBehaviour_CUSTOM_CancelInvokeP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 __ZN11ICallStringC2EP12Il2CppString(i3, i2);
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z12CancelInvokeR13MonoBehaviourR11ICallString(i2, i3);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_FT_Get_Module(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (!((i1 | 0) != 0 & (i3 | 0) != 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = i1 + 20 + (i2 << 2) | 0;
 if ((i2 | 0) <= 0) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 20 | 0;
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  if (!(_strcmp(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i3) | 0)) {
   i2 = 6;
   break;
  }
  if (i2 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function _strerror(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = 0;
 while (1) {
  if ((HEAPU8[gb + 1057583 + i3 >> 0] | 0) == (i2 | 0)) {
   i2 = 2;
   break;
  }
  i1 = i3 + 1 | 0;
  if ((i1 | 0) == 87) {
   i1 = gb + 1057671 | 0;
   i3 = 87;
   i2 = 5;
   break;
  } else i3 = i1;
 }
 if ((i2 | 0) == 2) if (!i3) i1 = gb + 1057671 | 0; else {
  i1 = gb + 1057671 | 0;
  i2 = 5;
 }
 if ((i2 | 0) == 5) while (1) {
  do {
   i2 = i1;
   i1 = i1 + 1 | 0;
  } while ((HEAP8[i2 >> 0] | 0) != 0);
  i3 = i3 + -1 | 0;
  if (!i3) break; else i2 = 5;
 }
 return i1 | 0;
}

function __ZThn12_N5physx3Ext13RevoluteJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88500 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88500 + 240;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZThn12_N5physx3Ext13DistanceJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 87668 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87668 + 228;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK9Rigidbody11GetRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i3;
 i5 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 84 >> 2] | 0, i6 | 0, i5 | 0);
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = HEAP32[i6 + 12 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK14ParticleSystem13GetStartColorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 i2 = HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 684 >> 2] | 0;
 f5 = Math_fround(Math_fround((i2 & 65535) >>> 8 & 255) / Math_fround(255.0));
 f4 = Math_fround(Math_fround(i2 >>> 16 & 255) / Math_fround(255.0));
 f3 = Math_fround(Math_fround(i2 >>> 24 & 255) / Math_fround(255.0));
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(i2 & 255) / Math_fround(255.0));
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = f3;
 return;
}

function __ZNK13SpeedTreeWind12InTransitionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 + 1380 >> 2]);
 if (f2 != Math_fround(HEAPF32[i1 + 1484 >> 2])) {
  i1 = 1;
  return i1 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 + 1384 >> 2]);
 if (f2 != Math_fround(HEAPF32[i1 + 1488 >> 2])) {
  i1 = 1;
  return i1 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 + 1388 >> 2]);
 if (f2 != Math_fround(HEAPF32[i1 + 1492 >> 2])) {
  i1 = 1;
  return i1 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 + 1376 >> 2]);
 i1 = f2 != Math_fround(HEAPF32[i1 + 1456 >> 2]);
 return i1 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 8 >> 2] = i3;
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx31PxSphericalJointGeneratedValuesC2EPKNS_16PxSphericalJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i2 + 160 | 0, i1 | 0);
 HEAP16[i2 + 188 >> 1] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 HEAPF32[i2 + 192 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 196 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx2Sn27getCompatibilityVersionsStrEPcj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = 50529024;
 HEAP32[i5 + 4 >> 2] = 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i1, i2, gb + 669986 | 0, i5) | 0;
 i5 = _strlen(i1) | 0;
 HEAP32[i4 >> 2] = 50528512;
 HEAP32[i4 + 4 >> 2] = 0;
 __ZN5physx6string9sprintf_sEPcjPKcz(i1 + i5 | 0, i2 - i5 | 0, gb + 669986 | 0, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim14resetFilteringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = __ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0;
 i4 = HEAP32[i1 + 360 >> 2] | 0;
 if (!i4) return;
 i1 = i1 + 356 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_19ParticlePacketShapeE(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_19ParticlePacketShapeE(i3, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return;
}

function __ZN5physx16PxVehicleUpdatesEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f3, i1, i5, i2, i7, i6, i4) {
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 __ZN5physx15PxVehicleUpdate6updateEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE(f3, i1, i5, i2, i7, i6, i4);
 return;
}

function __ZN5IMGUI18RepaintModalWindowER8GUIState(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i4) return;
 i3 = HEAP32[i2 + 280 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == 7) {
  HEAP8[(HEAP32[i2 + 276 >> 2] | 0) + 8 >> 0] = 1;
  i1 = HEAP32[i4 + 24 >> 2] | 0;
  if (i1 | 0) {
   __ZN5IMGUI9GUIWindow5OnGUIER8GUIState(i1, i2);
   i1 = HEAP32[i3 >> 2] | 0;
   i5 = 5;
  }
 } else i5 = 5;
 if ((i5 | 0) == 5) if ((i1 | 0) == 8) return;
 __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i4);
 return;
}

function __ZN19UnityConnectServiceC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 189112 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i1 + 48 | 0;
 i3 = i1 + 16 | 0;
 i4 = i3 + 44 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 + 60 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 __ZN19UnityConnectService23RegisterGlobalCallbacksEv(i1);
 return;
}

function __ZN13BitSetUtility7SetBitsEPjjjb(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 if (!i4) return;
 if (i1) {
  i1 = 0;
  do {
   i6 = i1 + i3 | 0;
   i5 = i2 + (i6 >>> 5 << 2) | 0;
   HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1 << (i6 & 31);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  return;
 } else {
  i1 = 0;
  do {
   i5 = i1 + i3 | 0;
   i6 = i2 + (i5 >>> 5 << 2) | 0;
   HEAP32[i6 >> 2] = HEAP32[i6 >> 2] & ~(1 << (i5 & 31));
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
  return;
 }
}

function __ZN12HandlerChain12CreateAsFileER13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 128 | 0, i2);
 __ZN9Heightmap8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 248 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 128 | 0, i2);
 __ZN9Heightmap8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 248 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11Rigidbody2D7SetMassEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (HEAP8[i1 + 49 >> 0] | 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808013 | 0, 0, gb + 807613 | 0, 652, 512, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 32 >> 2] = i3 ? Math_fround(.0000999999974) : f2;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) return;
 __ZN6b2Body13ResetMassDataEv(i1);
 return;
}

function __ZN11OffMeshLink17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 40 | 0;
 i3 = i2;
 if (!((HEAP32[i3 >> 2] | 0) == 0 & (HEAP32[i3 + 4 >> 2] | 0) == 0)) {
  i4 = __Z17GetNavMeshManagerv() | 0;
  i3 = i2;
  __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i4, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
  i3 = i2;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
 }
 i1 = i1 + 92 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 __ZN14NavMeshManager21UnregisterOffMeshLinkERi(__Z17GetNavMeshManagerv() | 0, i1);
 return;
}

function __ZN11GPUProfiler14ComputeGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!(__ZN11GPUProfiler14CollectGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EEb(i1, 1) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 i2 = 0;
 do {
  i1 = (HEAP32[i3 + (i2 << 4) + 4 >> 2] | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __Z21UnsignedInt64ToStringy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 _snprintf(i5, 255, gb + 1084511 | 0, i6) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
 STACKTOP = i4;
 return;
}

function __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i2, i1, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 124 >> 0] | 0)) return;
 i1 = __ZNK13TranslateGLES10ObjectTypeEN2gl10ObjectTypeE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 122 >> 0] | 0)) {
  mftCall_viiii(HEAP32[i2 + 388 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0);
  return;
 } else {
  mftCall_viiii(HEAP32[i2 + 372 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0);
  return;
 }
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140020 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK4Mesh11HasTopologyE16GfxPrimitiveType(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i2 + 132 >> 2] | 0;
 i2 = HEAP32[i2 + 128 >> 2] | 0;
 i3 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = (i1 - i2 | 0) / 52 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 * 52 | 0) + 40 >> 2] | 0) == (i4 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK28RectTransformPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__Z6StrCmpPKcS0_(i4, HEAP32[gb + 44296 >> 2] | 0) | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 } else {
  i4 = HEAP32[gb + 44296 >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
  return;
 }
}

function __ZN8VRDevice21RequestReloadVRDeviceERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 1469188 >> 2] | 0;
 if (!i3) return;
 HEAP8[i3 >> 0] = 1;
 i4 = i3 + 4 | 0;
 if ((i4 | 0) != (i1 | 0)) __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i4, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 HEAP8[i3 + 1 >> 0] = i2 & 1;
 return;
}

function __ZN7mecanim12statemachine24GetTransitionSourceIndexE28TransitionInterruptionSourceNS0_16TransitionSourceE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if (!i2) i1 = 0; else switch (i1 | 0) {
 case 1:
  {
   i1 = (i2 | 0) == 1 ? 1 : -1;
   break L1;
  }
 case 2:
  {
   i1 = (i2 | 0) == 2 ? 1 : -1;
   break L1;
  }
 case 3:
  {
   i1 = (i2 | 0) == 1 ? 1 : (i2 | 0) == 2 ? 2 : -1;
   break L1;
  }
 case 4:
  {
   i1 = (i2 | 0) == 2 ? 1 : (i2 | 0) == 1 ? 2 : -1;
   break L1;
  }
 default:
  {
   i1 = -1;
   break L1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN7ApiGLES16BindMemoryBufferEjN2gl12BufferTargetE(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 i2 = __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i3 + 860 >> 2] | 0, i1) | 0;
 i1 = i3 + 892 + (i1 << 2) | 0;
 if (HEAP8[i3 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return i2 | 0;
 HEAP32[i1 >> 2] = i4;
 mftCall_vii(HEAP32[i3 + 644 >> 2] | 0, i2 | 0, i4 | 0);
 return i2 | 0;
}

function __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = HEAP32[i1 + 476 >> 2] | 0;
 i3 = mftCall_ii(i3 | 0, __ZNK13TranslateGLES14GetShaderStageEN2gl11ShaderStageE(HEAP32[i1 + 860 >> 2] | 0, i2) | 0) | 0;
 mftCall_viiii(HEAP32[i1 + 480 >> 2] | 0, i3 | 0, 1, i5 | 0, 0);
 mftCall_vi(HEAP32[i1 + 484 >> 2] | 0, i3 | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx7NpScene30setClothInterCollisionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene30setClothInterCollisionDistanceEf(i2 + 32 | 0, f1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 835, gb + 708508 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx3Ext7D6Joint14setLinearLimitERKNS_18PxJointLinearLimitE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 80 >> 2] | 0) + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP8[i2 + 85 >> 0] = 1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVES2_NS0_10ShrunkBoxVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5Unity11AdjTriangle19FindEdgeDirectionalEjjb(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i3 ? i2 : i1;
 i1 = i3 ? i1 : i2;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) if ((HEAP32[i5 + 4 >> 2] | 0) == (i1 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0) & (i3 | 0) == (i1 | 0)) {
  i5 = 1;
  return i5 | 0;
 }
 if ((HEAP32[i5 + 4 >> 2] | 0) == (i4 | 0)) return ((i2 | 0) == (i1 | 0) ? 2 : -1) | 0; else {
  i5 = -1;
  return i5 | 0;
 }
 return 0;
}

function __ZN21ImposterRenderTextureD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (i1 | 0) __Z22DestroyObjectHighLevelP6Objectb(HEAP32[i1 + 28 >> 2] | 0, 0);
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i3) return;
 i1 = i2 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4);
 __ZdlPv(i3);
 return;
}

function __ZN16Physics2DManager18AddEffectorUpdatesEP10Effector2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 580 | 0;
 i4 = i2 + 64 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 68 | 0; else {
  i2 = i2 + 68 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN12SoundManager20RegisterModifiedClipEP10SampleClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 48 | 0;
 i4 = i2 + 108 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 112 | 0; else {
  i2 = i2 + 112 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN12HandlerChain11CreateAsDirER13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN12AudioManager18AddAudioReverbZoneEP15AudioReverbZone(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 80 | 0;
 i4 = i2 + 36 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 40 | 0; else {
  i2 = i2 + 40 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN11TimeManager16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0, i5 = 0;
 i2 = i1 + 48 | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = f4 < Math_fround(.0000999999974);
 i5 = f4 > Math_fround(10.0);
 f4 = i5 ? Math_fround(10.0) : f4;
 f4 = i3 ? Math_fround(.0000999999974) : f4;
 HEAPF32[i2 >> 2] = f4;
 i3 = i1 + 200 | 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) < f4;
 HEAP32[i3 >> 2] = HEAP32[(i5 ? i2 : i3) >> 2];
 i1 = i1 + 204 | 0;
 i3 = Math_fround(HEAPF32[i1 >> 2]) < f4;
 HEAP32[i1 >> 2] = HEAP32[(i3 ? i2 : i1) >> 2];
 return;
}

function __ZN10AudioMixer18PatchLiveLinkValueEjjf(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 32 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = i1 + 36 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 if ((HEAP32[i1 + (i2 * 28 | 0) + 4 >> 2] | 0) >>> 0 <= i3 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i1 + (i2 * 28 | 0) + 8 | 0;
 HEAPF32[(HEAP32[i2 >> 2] | 0) + i2 + (i3 << 2) >> 2] = f4;
 i3 = 1;
 return i3 | 0;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z49AnimationLayerMixerPlayable_CUSTOM_InternalCreateR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(128, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN27AnimationLayerMixerPlayableC2E18DirectorPlayerType(i3, 0);
 __ZN8Playable6HandleEv(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z40SliderJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP24JointTranslationLimits2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 108 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z40Mesh_CUSTOM_GetAllocArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) return __Z35AllocExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei(i5, i2, i3, i4) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Mathf_CUSTOM_LinearToGammaSpacef(f1) {
 f1 = Math_fround(f1);
 do if (!(f1 <= Math_fround(0.0))) {
  if (f1 <= Math_fround(.00313080009)) {
   f1 = Math_fround(f1 * Math_fround(12.9200001));
   break;
  }
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(Math_fround(Math_fround(+Math_pow(+f1, .416666687)) * Math_fround(1.05499995)) + Math_fround(-.0549999997));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, .454545468));
 } else f1 = Math_fround(0.0); while (0);
 return Math_fround(f1);
}

function __Z26profiler_get_info_for_namePKc13ProfilerGroup(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[gb + 1163228 >> 2] | 0;
 if (i3 | 0) {
  i3 = __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE(i3, i1, i2, 0) | 0;
  return i3 | 0;
 }
 if (HEAP8[gb + 1546604 >> 0] | 0) {
  i3 = gb + 1163388 | 0;
  return i3 | 0;
 }
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1163388 | 0, gb + 462477 | 0, 11, 0);
 HEAP8[gb + 1546604 >> 0] = 1;
 i3 = gb + 1163388 | 0;
 return i3 | 0;
}

function __Z26GetUniqueTempPathInProjectv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i3, gb + 488232 | 0, 19);
 __Z17GetUniqueTempPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(f1, f2, i3) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN10Matrix4x4f8SetOrthoEffffff(i5, Math_fround(0.0), Math_fround(1.0), Math_fround(0.0), Math_fround(1.0), f1, f2) | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i5 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, gb + 1162292 | 0);
 STACKTOP = i4;
 return;
}

function _tt_cmap4_char_next(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (i2 >>> 0 > 65534) {
  i4 = 0;
  return i4 | 0;
 }
 if (HEAP32[i1 + 20 >> 2] & 1 | 0) {
  i4 = _tt_cmap4_char_map_linear(i1, i3, 1) | 0;
  return i4 | 0;
 }
 i4 = i1 + 24 | 0;
 if ((i2 | 0) != (HEAP32[i4 >> 2] | 0)) {
  i4 = _tt_cmap4_char_map_binary(i1, i3, 1) | 0;
  return i4 | 0;
 }
 _tt_cmap4_next(i1);
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i4 = i1;
 return i4 | 0;
}

function __ZdlPvRK10MemLabelIdiPKci(i4, i5, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1;
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i3, i4, i5);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i3 = i1;
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i3, i4, i5);
 return;
}

function __ZdaPvRK10MemLabelIdiPKci(i4, i5, i1, i2, i3) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1;
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i3, i4, i5);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i3 = i1;
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i3, i4, i5);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 if (i2 >>> 0 > 4294967279) __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1);
 if (i2 >>> 0 < 11) HEAP8[i1 + 11 >> 0] = i4; else {
  i5 = i2 + 16 & -16;
  i2 = __Znwj(i5) | 0;
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 8 >> 2] = i5 | -2147483648;
  HEAP32[i1 + 4 >> 2] = i4;
  i1 = i2;
 }
 if (i4 | 0) _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP8[i1 + i4 >> 0] = 0;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115064 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115104 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140040 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZN8Collider8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0) {
  i4 = i1 + 32 | 0;
  i3 = HEAP32[i2 + 16 >> 2] | 0;
  i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
  if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 }
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx7NpScene34setClothInterCollisionNbIterationsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene34setClothInterCollisionNbIterationsEj(i2 + 32 | 0, i1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 869, gb + 708293 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx2Sc7Element21destroyLowLevelVolumeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 1073741823 | 0) == 1073741823 & 0 == 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZN5physx14PxsAABBManager13releaseVolumeEj(HEAP32[(HEAP32[(HEAP32[(HEAP32[i3 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i2 & 1073741823) | 0;
 i5 = i1;
 i4 = HEAP32[i5 + 4 >> 2] | 1073741823;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2] | 1073741823;
 HEAP32[i2 + 4 >> 2] = i4;
 return i3 | 0;
}

function __ZN20TextRenderingPrivate15GetFontsManager16StaticInitializeEv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63392 | 0, 16, gb + 1007820 | 0, 38) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[gb + 1467888 >> 2] = i1;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63392 | 0, 16, gb + 1007820 | 0, 39) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1467880 >> 2] = i1;
 return;
}

function __ZN16BaseVideoTexture17StopVideoTexturesEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1459952 + 4 >> 2] | 0)) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i2 | 0, 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[gb + 1459952 + 4 >> 2] | 0));
 return;
}

function __ZN14PhysicsManager11WakeUpSceneEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = 0;
 do {
  i1 = HEAP32[i4 + 204 + (i3 << 3) + 4 >> 2] | 0;
  i5 = i4 + 204 + (i3 << 3) | 0;
  i2 = i1;
  if ((i2 | 0) != (i5 | 0)) do {
   i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 52 >> 2] | 0;
   if (!((i1 | 0) == 0 ? 1 : (HEAP16[i1 + 4 >> 1] | 0) != 5)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i2 = i1;
  } while ((i2 | 0) != (i5 | 0));
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 64);
 return;
}

function __ZN12AudioManager16AddAudioListenerEP13AudioListener(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 52 | 0;
 i4 = i2 + 132 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 136 | 0; else {
  i2 = i2 + 136 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN11IMGUIModule12AddGUIScriptER8ListNodeI13MonoBehaviourE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP32[gb + 1468156 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i3 + 4 | 0; else {
  i4 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __ZN10HumanTrait14MuscleFromBoneEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) < 0) {
  i2 = -1;
  return i2 | 0;
 }
 if ((i1 | 0) < 24) {
  i2 = __ZN7mecanim5human14MuscleFromBoneEii(i1, i2) | 0;
  return i2 | 0;
 }
 if ((i1 | 0) < 39) {
  i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i1 + -24 | 0, i2) | 0;
  i2 = (i2 | 0) != -1 ? i2 + 52 | 0 : -1;
  return i2 | 0;
 }
 if ((i1 | 0) >= 54) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = __ZN7mecanim4hand14MuscleFromBoneEii(i1 + -39 | 0, i2) | 0;
 i2 = (i2 | 0) != -1 ? i2 + 72 | 0 : -1;
 return i2 | 0;
}

function __ZL27GeomMTDCallback_PlaneConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i2, i1, i5, i3, i6) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i7, i5);
 i6 = __ZN5physx2Gu22computeMTD_PlaneConvexERNS_6PxVec3ERfRKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE(i4, i2, i7, i3, i6) | 0;
 STACKTOP = i1;
 return i6 | 0;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z62ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 264 + 88 >> 2]);
 return Math_fround(f3);
}

function __Z44SceneManager_CUSTOM_INTERNAL_CALL_GetSceneAtiRi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((i1 | 0) > -1) if ((HEAP32[(__Z15GetSceneManagerv() | 0) + 16 >> 2] | 0) > (i1 | 0)) {
  HEAP32[i2 >> 2] = HEAP32[(HEAP32[(HEAP32[(__Z15GetSceneManagerv() | 0) + 4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 8 >> 2];
  STACKTOP = i4;
  return;
 }
 HEAP32[i3 >> 2] = i1;
 __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(gb + 561788 | 0, i3);
}

function __Z35ReflectionProbe_CUSTOM_BlendCubemapP12Il2CppObjectS0_fS0_(i1, i2, f5, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 i4 = i4 | 0;
 var i3 = 0;
 if (!i1) i3 = 0; else i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i4) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i4) | 0;
 return (__Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture(i3, i2, f5, i1) | 0) & 1 | 0;
}

function _ilogbf(f2) {
 f2 = Math_fround(f2);
 var i1 = 0, i3 = 0;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 i3 = i1 >>> 23;
 switch ((i3 & 255) << 24 >> 24) {
 case 0:
  {
   i1 = i1 << 9;
   if (!i1) i1 = -2147483648; else if ((i1 | 0) > -1) {
    i3 = i1;
    i1 = -127;
    do {
     i1 = i1 + -1 | 0;
     i3 = i3 << 1;
    } while ((i3 | 0) > -1);
   } else i1 = -127;
   break;
  }
 case -1:
  {
   i1 = i1 & 8388607 | 0 ? -2147483648 : 2147483647;
   break;
  }
 default:
  i1 = (i3 & 255) + -127 | 0;
 }
 return i1 | 0;
}

function __ZplRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 + Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 + Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 + Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f7, f6, f5, Math_fround(f4 + Math_fround(HEAPF32[i3 + 12 >> 2])));
 return;
}

function __ZmlRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 * Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f7, f6, f5, Math_fround(f4 * Math_fround(HEAPF32[i3 + 12 >> 2])));
 return;
}

function __ZmiRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0, f7 = f0;
 f7 = Math_fround(HEAPF32[i2 >> 2]);
 f7 = Math_fround(f7 - Math_fround(HEAPF32[i3 >> 2]));
 f6 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f6 = Math_fround(f6 - Math_fround(HEAPF32[i3 + 4 >> 2]));
 f5 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f7, f6, f5, Math_fround(f4 - Math_fround(HEAPF32[i3 + 12 >> 2])));
 return;
}

function __ZThn12_N5physx3Ext10FixedJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 87952 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87952 + 188;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNK9Texture2D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i6) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 411051 | 0, 0, gb + 410682 | 0, 351, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  i6 = 0;
  return i6 | 0;
 } else {
  i6 = __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi(i6, i2, i3, i4, i5) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115084 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115144 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 166392 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZN8Renderer14UpdateRendererEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP16[i2 + 328 >> 1] | 0;
 if ((i1 & 65535) < 256 | (i1 & 255) << 24 >> 24 == 0) i3 = 3; else {
  i1 = HEAP32[i2 + 28 >> 2] | 0;
  if (!i1) i3 = 3; else {
   i4 = __ZNK10GameObject8IsActiveEv(i1) | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   if (i4) {
    mftCall_vi(HEAP32[i1 + 156 >> 2] | 0, i2 | 0);
    __ZN8Renderer17UpdateSceneHandleEv(i2);
    return;
   }
  }
 }
 if ((i3 | 0) == 3) i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[i1 + 160 >> 2] | 0, i2 | 0);
 return;
}

function __ZN6Object13StaticDestroyEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1104264 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) {
   i5 = HEAP32[i2 + 52 >> 2] | 0;
   HEAP32[i1 >> 2] = 65;
   HEAP32[i1 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63520 | 0);
 HEAP32[gb + 1104264 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx8areEqualERKNS_6PxQuatES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 4 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 if (!(f3 == Math_fround(HEAPF32[i2 + 8 >> 2]))) {
  i2 = 0;
  return i2 | 0;
 }
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 i2 = f3 == Math_fround(HEAPF32[i2 + 12 >> 2]);
 return i2 | 0;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx15PxGeometryQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformES3_S6_(i3, i5, i4, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) > (i2 | 0)) {
  i6 = mftCall_iiiiii(HEAP32[gb + 90332 + (i2 * 28 | 0) + (i1 << 2) >> 2] | 0, i4 | 0, i6 | 0, i3 | 0, i5 | 0, 0) | 0;
  return i6 | 0;
 } else {
  i6 = mftCall_iiiiii(HEAP32[gb + 90332 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0, i3 | 0, i5 | 0, i4 | 0, i6 | 0, 0) | 0;
  return i6 | 0;
 }
 return 0;
}

function __ZN12TreeDatabase8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i3 | 0) == (i5 | 0)) return;
 i6 = i2 + 16 | 0;
 i7 = i2 + 36 | 0;
 i4 = i2 + 40 | 0;
 i1 = i3;
 do {
  i2 = HEAP32[i6 >> 2] | 0;
  i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i7 >> 2] | 0) | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP32[i1 >> 2] = i2;
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN12TextureIdMap7CleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 i2 = HEAP32[gb + 1157724 >> 2] | 0;
 if (i2 | 0) {
  i3 = HEAP32[i2 + 28 >> 2] | 0;
  if (i3 | 0) {
   i5 = HEAP32[i2 + 52 >> 2] | 0;
   HEAP32[i1 >> 2] = 65;
   HEAP32[i1 + 4 >> 2] = i5;
   __Z19free_alloc_internalPvRK10MemLabelId(i3, i1);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63536 | 0);
 HEAP32[gb + 1157724 >> 2] = 0;
 STACKTOP = i4;
 return;
}

function __Z6FormatPKcz(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 10272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4 + 32 | 0;
 i7 = i4;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 _vsnprintf(i5, 10240, i2, i6) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
 STACKTOP = i4;
 return;
}

function __Z61ParticleSystem_ShapeModule_CUSTOM_GetSphericalDirectionAmountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 208 >> 2]);
 return Math_fround(f3);
}

function __Z43ParticleSystem_LightsModule_CUSTOM_GetRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 920 >> 2] | 0) + 8 >> 2]);
 return Math_fround(f3);
}

function __Z37InterpolateLightProbeCoefficientsSafeRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 112 >> 2] | 0;
 if (i4 | 0) if (HEAP32[i4 + 12 >> 2] | 0) {
  __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2(i1, i2, i3);
  return;
 }
 i2 = i3 + 108 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __Z35Camera_Set_Custom_PropTargetTextureP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN6Camera16SetTargetTextureEP13RenderTexture(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN6Camera16SetTargetTextureEP13RenderTexture(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29NeedToDecompressTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 do if ((i1 + -10 | 0) >>> 0 >= 3) if (((i1 | 1) + -25 | 0) >>> 0 >= 5) {
  i2 = i1 + -30 | 0;
  if (i2 >>> 0 < 15) {
   if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) break; else i1 = 0;
   return i1 | 0;
  } else {
   if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) break; else i1 = 0;
   return i1 | 0;
  }
 } while (0);
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 171 + i1 >> 0] | 0) == 0;
 return i2 | 0;
}

function __Z14FreeBlockCountPvjiS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i3 | 0) return;
 i3 = i2 >>> 0 > 65535;
 i1 = i3 ? i2 >>> 16 : i2;
 i2 = i3 ? 16 : 0;
 i3 = (i1 & 65280 | 0) == 0;
 i1 = i3 ? i1 : i1 >>> 8;
 i2 = i3 ? i2 : i2 | 8;
 i3 = (i1 & 240 | 0) == 0;
 i2 = (HEAP8[(i3 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) + (i3 ? i2 : i2 | 4) | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + (((i2 | 0) < (i3 | 0) ? i2 : i3 + -1 | 0) << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZNKSt3__220__time_get_c_storageIcE3__rEv(i1) {
 i1 = i1 | 0;
 do if (!(HEAP8[gb + 1099824 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099824 | 0) | 0) {
  HEAP32[gb + 1474652 >> 2] = 0;
  HEAP32[gb + 1474652 + 4 >> 2] = 0;
  HEAP32[gb + 1474652 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, gb + 1474652 | 0, gb + 1078467 | 0, 11);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else break;
 } while (0);
 return gb + 1474652 | 0;
}

function __ZNKSt3__220__time_get_c_storageIcE3__cEv(i1) {
 i1 = i1 | 0;
 do if (!(HEAP8[gb + 1099832 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099832 | 0) | 0) {
  HEAP32[gb + 1474664 >> 2] = 0;
  HEAP32[gb + 1474664 + 4 >> 2] = 0;
  HEAP32[gb + 1474664 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, gb + 1474664 | 0, gb + 1078479 | 0, 20);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else break;
 } while (0);
 return gb + 1474664 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 139960 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE8ContainsEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + (i1 >>> 25 << 2) >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + ((i1 >>> 18 & 127) << 2) >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + ((i1 >>> 13 & 31) << 2) >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i2 + ((i1 >>> 9 & 15) << 2) >> 2] & 1 << (i1 >>> 4 & 31) | 0) != 0;
 return i2 | 0;
}

function __ZN5physx2Sc15ClothFabricCore16scaleRestlengthsEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, +f3);
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, +f3);
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, +f3);
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, +f3);
 return;
}

function __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 1 | 0, i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i4;
  return 0;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i4;
 return 0;
}

function __ZN14SpriteRenderer15UpdateLocalAABBEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i1 + 188 | 0;
 __ZN14SpriteRenderer15GetSpriteBoundsEv(i4, i1);
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 STACKTOP = i2;
 return;
}

function __ZN13ScreenManager44RequestConcreteOrientationFromPlayerSettingsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, 1);
   return;
  }
 case 1:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, 2);
   return;
  }
 case 2:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, 4);
   return;
  }
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, 3);
   return;
  }
 default:
  return;
 }
}

function __ZN10MemoryPool17PreallocateMemoryEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 36 | 0;
 i5 = HEAP8[i4 >> 0] | 0;
 HEAP8[i4 >> 0] = 1;
 i6 = i2 + 8 | 0;
 if (((i3 | 0) / (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) | 0 | 0) < 0) {
  HEAP8[i4 >> 0] = i5;
  return;
 } else i1 = 0;
 while (1) {
  __ZN10MemoryPool14AllocNewBubbleEv(i2);
  if ((i1 | 0) < ((i3 | 0) / (Math_imul(HEAP32[i2 >> 2] | 0, HEAP32[i6 >> 2] | 0) | 0) | 0 | 0)) i1 = i1 + 1 | 0; else break;
 }
 HEAP8[i4 >> 0] = i5;
 return;
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z44ParticleSystem_MainModule_CUSTOM_GetDurationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(__ZNK14ParticleSystem14GetLengthInSecEv(i2));
 return Math_fround(f3);
}

function __Z42ParticleSystem_TrailModule_CUSTOM_GetRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[(HEAP32[i2 + 908 >> 2] | 0) + 8 >> 2]);
 return Math_fround(f3);
}

function _ps_hints_t2mask(i1, i7, i4, i8) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i9 = 0, i10 = 0;
 i10 = i1 + 4 | 0;
 if (HEAP32[i10 >> 2] | 0) return;
 i5 = i1 + 16 | 0;
 i9 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 i2 = i1 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + i6 | 0) != (i4 | 0)) return;
 i1 = _ps_dimension_set_mask_bits(i5, i8, i3, i6, i7, i9) | 0;
 if (!i1) {
  i1 = _ps_dimension_set_mask_bits(i2, i8, 0, i3, i7, i9) | 0;
  if (!i1) return;
 }
 HEAP32[i10 >> 2] = i1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 return;
}

function __ZNKSt3__220__time_get_c_storageIcE3__xEv(i1) {
 i1 = i1 | 0;
 do if (!(HEAP8[gb + 1099816 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099816 | 0) | 0) {
  HEAP32[gb + 1474640 >> 2] = 0;
  HEAP32[gb + 1474640 + 4 >> 2] = 0;
  HEAP32[gb + 1474640 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, gb + 1474640 | 0, gb + 1078458 | 0, 8);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else break;
 } while (0);
 return gb + 1474640 | 0;
}

function __ZNKSt3__220__time_get_c_storageIcE3__XEv(i1) {
 i1 = i1 | 0;
 do if (!(HEAP8[gb + 1099808 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099808 | 0) | 0) {
  HEAP32[gb + 1474628 >> 2] = 0;
  HEAP32[gb + 1474628 + 4 >> 2] = 0;
  HEAP32[gb + 1474628 + 8 >> 2] = 0;
  __THREW__ = 0;
  invoke_viii(fb + 1040 | 0, gb + 1474628 | 0, gb + 1078449 | 0, 8);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else break;
 } while (0);
 return gb + 1474628 | 0;
}

function __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 8;
 HEAP32[i1 + 16 >> 2] = 6;
 HEAP32[i1 + 24 >> 2] = i2 + 100;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = i2 + 4;
 HEAP32[i1 + 32 >> 2] = gb + 656139;
 i2 = i1 + 36 | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 166372 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 166352 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 166412 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 139940 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 280 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK12HandlerChain6ExistsERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN5physx2Sc9ShapeCore15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 switch (HEAP32[i2 + 68 >> 2] | 0) {
 case 5:
  {
   i3 = i1 + 4 | 0;
   i1 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
   HEAP32[i3 >> 2] = i1 + ((HEAPU16[i2 + 120 >> 1] | 0) << 1);
   HEAP32[i2 + 116 >> 2] = i1;
   return;
  }
 case 6:
  {
   i1 = i1 + 4 | 0;
   i3 = (HEAP32[i1 >> 2] | 0) + 15 & -16;
   HEAP32[i1 >> 2] = i3 + ((HEAPU16[i2 + 100 >> 1] | 0) << 1);
   HEAP32[i2 + 96 >> 2] = i3;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx2Cm17FreeListAllocator10deallocateEPv(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + -4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) < 0) {
  i3 = i4 + 12 | 0;
  __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
  __ZN5physx2Cm17FreeListAllocator9freeChunkEPNS0_5ChunkE(i4, i1);
  __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
  return;
 } else {
  i4 = HEAP32[i4 + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i3 + (0 - i2) | 0);
  return;
 }
}

function __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i5 + 15824 | 0;
 i1 = (HEAP32[i2 >> 2] | 0) + 1 & 255;
 HEAP32[i2 >> 2] = i1;
 i3 = i5 + 15828 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 HEAP32[i5 + 3504 + (i1 << 2) >> 2] = HEAP32[i4 >> 2];
 if ((HEAP32[i3 >> 2] | 0) >>> 0 > 1) i1 = 1; else return;
 do {
  HEAP32[i5 + 3504 + (i1 << 10) + (HEAP32[i2 >> 2] << 2) >> 2] = HEAP32[i4 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra8QueryExt10setWorkMemEPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = (i2 | 0) == 0;
 if (!(i4 | (i3 | 0) != 0)) {
  i4 = 3;
  return i4 | 0;
 }
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i5 = i1 + 56 | 0;
 i6 = i2;
 i2 = i6 + 15 & -16;
 i7 = i2;
 HEAP32[i1 + 60 >> 2] = i7;
 i3 = i7 + (i6 + i3 - i2) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i2;
 HEAP32[i1 + 72 >> 2] = i3 - i2;
 HEAP32[i1 + 76 >> 2] = i4 ? i1 + 36 | 0 : i5;
 i4 = 0;
 return i4 | 0;
}

function __ZN14StackAllocatorILj16EE10deallocateEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = (__ZNK14StackAllocatorILj16EE9getHeaderEPv(i2, i1) | 0) + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | -2147483648;
 i3 = i2 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 i2 = i2 + 8 | 0;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) >= 0) {
   i1 = 6;
   break;
  }
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[HEAP32[i3 >> 2] >> 2] | 0;
  HEAP32[i3 >> 2] = i1;
  if (!i1) {
   i1 = 6;
   break;
  }
 }
 if ((i1 | 0) == 6) return;
}

function __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -4 - i5 | 0) >>> 2) << 2);
   __ZdlPv(i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12HandlerChain8IsLockedERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z45SkinnedMeshRenderer_Set_Custom_PropSharedMeshP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN19SkinnedMeshRenderer7SetMeshEP4Mesh(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN19SkinnedMeshRenderer7SetMeshEP4Mesh(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __GLOBAL__sub_I_MemoryManager_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1188360 | 0, gb + 581916 | 0, 18, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1188372 | 0, gb + 581924 | 0, 18, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1188384 | 0, gb + 581934 | 0, 18, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1188396 | 0, gb + 581934 | 0, 18, 2);
 return;
}

function _UNITY_png_read_filter_row(i3, i4, i5, i6, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i7 = 0;
 i1 = i1 + -1 | 0;
 if (i1 >>> 0 >= 4) return;
 i2 = i3 + 664 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i7 = (HEAPU8[i3 + 434 >> 0] | 0) + 7 | 0;
  HEAP32[i2 >> 2] = fb + 479;
  HEAP32[i3 + 668 >> 2] = fb + 480;
  HEAP32[i3 + 672 >> 2] = fb + 481;
  HEAP32[i3 + 676 >> 2] = (i7 & 504 | 0) == 8 ? fb + 482 | 0 : fb + 483 | 0;
 }
 mftCall_viii(HEAP32[i3 + 664 + (i1 << 2) >> 2] | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function _cprojf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0, i5 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f4 = (HEAP32[tempDoublePtr >> 2] = i3, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 if ((i3 & 2147483647 | 0) == 2139095040) i5 = 3; else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if ((i1 & 2147483647 | 0) == 2139095040) i5 = 3; else {
   HEAP32[i2 >> 2] = i3;
   HEAP32[i2 + 4 >> 2] = i1;
  }
 }
 if ((i5 | 0) == 3) {
  f4 = Math_fround(_copysignf(Math_fround(0.0), f4));
  HEAPF32[i2 >> 2] = Math_fround(inf);
  HEAPF32[i2 + 4 >> 2] = f4;
 }
 return;
}

function __ZZL32InitializeModule_ParticlesLegacyvEN16cleanupAfterLoad7ForwardEv() {
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (f3 < Math_fround(.0000999999974) | (__Z14IsWorldPlayingv() | 0) ^ 1) return;
 i1 = HEAP32[gb + 1469400 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1469400 | 0)) return;
 do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN15ParticleEmitter20UpdateParticleSystemEf(HEAP32[i4 + 8 >> 2] | 0, f3);
  i2 = i1;
 } while ((i2 | 0) != (gb + 1469400 | 0));
 return;
}

function __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK9Heightmap15GetAdjustedSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = ((i2 | 0) / 17 | 0) + -1 | 0;
 i3 = i3 >>> 16 | i3;
 i3 = i3 >>> 8 | i3;
 i3 = i3 >>> 4 | i3;
 i3 = i3 >>> 2 | i3;
 i3 = (i3 >>> 1 | i3) + 1 | 0;
 i2 = i3 >>> 0 > 65535;
 i3 = i2 ? i3 >>> 16 : i3;
 i2 = i2 ? 16 : 0;
 i1 = (i3 & 65280 | 0) == 0;
 i3 = i1 ? i3 : i3 >>> 8;
 i2 = i1 ? i2 : i2 | 8;
 i1 = (i3 & 240 | 0) == 0;
 i2 = (HEAP8[(i1 ? i3 : i3 >>> 4) + (gb + 936717) >> 0] | 0) + (i1 ? i2 : i2 | 4) | 0;
 return (16 << ((i2 | 0) > 1 ? i2 : 1)) + 1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115164 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140220 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140180 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 316 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140060 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK14dtPathCorridor17containsPolyByRefEy(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i1 + 32 >> 2] | 0;
 if ((i5 | 0) <= 0) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = 0;
 while (1) {
  i6 = i2 + (i1 << 3) | 0;
  i1 = i1 + 1 | 0;
  if ((HEAP32[i6 >> 2] | 0) == (i3 | 0) ? (HEAP32[i6 + 4 >> 2] | 0) == (i4 | 0) : 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  if ((i1 | 0) >= (i5 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK12InputManager19GetJoystickPositionEii(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, f6 = f0;
 i5 = HEAP32[i1 + 124 >> 2] | 0;
 i3 = i5;
 if ((((HEAP32[i1 + 128 >> 2] | 0) - i5 | 0) / 12 | 0 | 0) <= (i2 | 0)) {
  f6 = Math_fround(0.0);
  return Math_fround(f6);
 }
 i1 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
 if (((HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) - i1 >> 2 | 0) <= (i4 | 0)) {
  f6 = Math_fround(0.0);
  return Math_fround(f6);
 }
 f6 = Math_fround(HEAPF32[i1 + (i4 << 2) >> 2]);
 return Math_fround(f6);
}

function __ZN9Transform19FindPreviousSiblingEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i1 = HEAP32[i5 + 100 >> 2] | 0;
 if (!i1) {
  i7 = 0;
  return i7 | 0;
 }
 i6 = (HEAP32[i1 + 92 >> 2] | 0) + -1 | 0;
 i3 = i1 + 80 | 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) >= (i6 | 0)) {
   i1 = 0;
   i7 = 6;
   break;
  }
  i4 = i1 + 1 | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((HEAP32[i2 + (i4 << 2) >> 2] | 0) == (i5 | 0)) break; else i1 = i4;
 }
 if ((i7 | 0) == 6) return i1 | 0;
 i7 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
 return i7 | 0;
}

function __ZN5physx2Sc27ConstraintProjectionManager29removeFromPendingGroupUpdatesERNS0_13ConstraintSimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 300 | 0, i4) | 0;
 i2 = i1 + 116 | 0;
 HEAP8[i2 >> 0] = (HEAPU8[i2 >> 0] | 0) & 254;
 STACKTOP = i3;
 return;
}

function __ZN25RuntimeAnimatorControllerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 178296 + 8;
 i1 = i2 + 60 | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 64 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 36 | 0;
 if ((HEAP32[i2 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 40 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i2 + 28 | 0);
 HEAP32[i2 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN20ArchiveStorageReader10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN15FileSystemEntryC2EPKc(i6, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 i4 = __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy(i1, i6, i3, i4) | 0;
 __ZN13FileEntryDataD2Ev(i6);
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN17AnimationCurveTplIfE8TransferI9JSONWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite10SetVersionEi(i2, 2);
 __ZN9JSONWrite8TransferI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_PKc17TransferMetaFlags(i2, i1 + 56 | 0, gb + 1034203 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 76 | 0, gb + 1034211 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 80 | 0, gb + 1034225 | 0, 1);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 84 | 0, gb + 1034240 | 0, 1);
 return;
}

function __ZN12CachedWriter15CompleteWritingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i6 = i1 + 12 | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP32[i6 >> 2] | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i3 + 8 >> 2] | 0;
 i4 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 return mftCall_iii(i5 | 0, i2 | 0, i4 + (Math_imul(mftCall_ii(HEAP32[i3 + 24 >> 2] | 0, i2 | 0) | 0, i1) | 0) | 0) | 0;
}

function __ZN12AudioManager26CreateAllocationBoundSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPN11SoundHandle8InstanceEP10SampleClip(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = __Z20push_allocation_rootPvP13BaseAllocatorb((i6 | 0) == 0 ? HEAP32[gb + 1459924 >> 2] | 0 : i6, 0, 0) | 0;
 i1 = __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO(i5, i2, i3, i6, 0, 0, i4) | 0;
 if (!i7) return i1 | 0;
 __Z19pop_allocation_rootv();
 return i1 | 0;
}

function __ZN12AudioManager14AddAudioSourceEP11AudioSource(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 44 | 0;
 i4 = i2 + 444 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 448 | 0; else {
  i2 = i2 + 448 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __Z58ParticleSystem_ShapeModule_CUSTOM_GetRandomDirectionAmountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 204 >> 2]);
 return Math_fround(f3);
}

function __Z45TerrainData_CUSTOM_UpgradeScaledTreePrototypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 HEAP8[i2 + 124 >> 0] = 0;
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1); else return;
}

function __Z24Tree_Set_Custom_PropDataP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) {
  HEAP32[i4 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i3) | 0;
  HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
  STACKTOP = i5;
  return;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z14UsedBlockCountPvjiS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i3) return;
 i3 = i2 >>> 0 > 65535;
 i1 = i3 ? i2 >>> 16 : i2;
 i2 = i3 ? 16 : 0;
 i3 = (i1 & 65280 | 0) == 0;
 i1 = i3 ? i1 : i1 >>> 8;
 i2 = i3 ? i2 : i2 | 8;
 i3 = (i1 & 240 | 0) == 0;
 i2 = (HEAP8[(i3 ? i1 : i1 >>> 4) + (gb + 936717) >> 0] | 0) + (i3 ? i2 : i2 | 4) | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + (((i2 | 0) < (i3 | 0) ? i2 : i3 + -1 | 0) << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function mftCall_iiiifiififf(i11, i1, i2, i3, d4, i5, i6, d7, i8, d9, d10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 i8 = i8 | 0;
 d9 = +d9;
 d10 = +d10;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifiififf[i11 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, Math_fround(d7), i8 | 0, Math_fround(d9), Math_fround(d10)) | 0;
 return ftCall_iiiifiififf(i11 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, +d7, i8 | 0, +d9, +d10) | 0;
}

function _if_indextoname(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7 + 8 | 0;
 i5 = i7;
 i3 = i7 + 16 | 0;
 i4 = _socket(1, 524290, 0) | 0;
 if ((i4 | 0) < 0) i1 = 0; else {
  HEAP32[i3 + 16 >> 2] = i1;
  HEAP32[i5 >> 2] = i3;
  i5 = _ioctl(i4, 35088, i5) | 0;
  HEAP32[i6 >> 2] = i4;
  ___syscall6(6, i6 | 0) | 0;
  if ((i5 | 0) < 0) i1 = 0; else i1 = _strncpy(i2, i3, 16) | 0;
 }
 STACKTOP = i7;
 return i1 | 0;
}

function __ZThn12_N5physx3Ext7D6JointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 86848 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 86848 + 256;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i3;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i3, i2);
 i5 = i3 + 72 | 0;
 i1 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4swapERS0_(i3, i2);
 i5 = i3 + 72 | 0;
 i1 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNSt3__210__stdinbufIwE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476360 | 0) | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = i4;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP8[i1 + 53 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0) & 1;
 if ((HEAP32[i2 >> 2] | 0) > 8) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1077843 | 0);
 return;
}

function __ZNSt3__210__stdinbufIcE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476352 | 0) | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = i4;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 HEAP8[i1 + 53 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0) | 0) & 1;
 if ((HEAP32[i2 >> 2] | 0) > 8) __ZNSt3__221__throw_runtime_errorEPKc(gb + 1077843 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140200 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140160 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 i11 = i11 | 0;
 i10 = i10 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 return __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVES2_S2_S2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_fb(i1, i3, i2, i6, i11, i10, i8, i9, i4, f5, i7) | 0;
}

function __ZN5physx2Cm17FreeListAllocatorC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = gb + 110628 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = HEAP32[(__ZN5physx6shdfnd9MutexImpl7getSizeEv() | 0) >> 2] | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, gb + 778771 | 0, gb + 778794 | 0, 94) | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 __ZN5physx6shdfnd9MutexImplC2Ev(i1);
 _memset(i2 + 16 | 0, 0, 4228) | 0;
 return;
}

function __ZN5physx14NpArticulationD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 91248 + 8;
 __ZN5physx9NpFactory21onArticulationReleaseEPNS_14PxArticulationE(HEAP32[gb + 1457204 >> 2] | 0, i2);
 i1 = HEAP32[i2 + 96 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if ((i2 + 68 | 0) == (i1 | 0)) {
  HEAP8[i2 + 84 >> 0] = 0;
  return;
 }
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager10QueueEventEPNS0_14CloudEventInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = i1 + 556 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i2 + 36 >> 2] = i1;
 i3 = i2 + 44 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, fb + 3960 | 0, i2 | 0) | 0;
 i2 = 1;
 return i2 | 0;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL17fill_input_bufferP22jpeg_decompress_struct(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 i2 = i1 + 32 | 0;
 i3 = mftCall_iiii(HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 >> 2] | 0, i2 | 0, 65536) | 0;
 if (i3 >>> 0 >= 65536) {
  i4 = i3;
  HEAP32[i1 >> 2] = i2;
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = i4;
  return 1;
 }
 HEAP8[i1 + 32 + i3 >> 0] = -1;
 HEAP8[i3 + 1 + (i1 + 32) >> 0] = -39;
 i3 = i3 + 2 | 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 return 1;
}

function __Z51MaterialPropertyBlock_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i4, i1, i2, 0);
 STACKTOP = i6;
 return;
}

function __Z51AudioSettings_CUSTOM_INTERNAL_CALL_GetConfigurationR27AudioConfigurationScripting(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN12AudioManager16GetConfigurationEv(i3, __Z15GetAudioManagerv() | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 STACKTOP = i2;
 return;
}

function __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_PerspectiveffffR10Matrix4x4f(f4, f5, f6, f7, i1) {
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i8;
 __ZN10Matrix4x4f14SetPerspectiveEffff(i2, f4, f5, f6, f7) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i8;
 return;
}

function __Z19AppendTransformPathRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 if (!((i3 << 24 >> 24 < 0 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0)) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i1, i2) | 0;
  return;
 } else {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i1, 47);
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) | 0;
  return;
 }
}

function __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77508 + 12;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = gb + 77508 + 32;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i3);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, gb + 77612 + 4 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i2);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EOS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i2, i3);
 i1 = i3 + 72 | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EOS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 i3 = i3 + (HEAP32[(HEAP32[i3 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i2, i3);
 i1 = i3 + 72 | 0;
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = HEAP32[i3 + 76 >> 2];
 return;
}

function __ZNK9Texture2D20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZNK6Object20GetRuntimeMemorySizeEv(i1) | 0;
 i2 = (__ZN14MemoryProfiler22GetRelatedIDMemorySizeEj(HEAP32[gb + 1163236 >> 2] | 0, HEAP32[i1 + 48 >> 2] | 0) | 0) + i2 | 0;
 if (!(HEAP8[i1 + 110 >> 0] | 0)) {
  i1 = 0;
  i2 = i2 + i1 | 0;
  return i2 | 0;
 }
 i3 = HEAP32[gb + 1163236 >> 2] | 0;
 i1 = __ZN14MemoryProfiler22GetRelatedIDMemorySizeEj(i3, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0) | 0;
 i2 = i2 + i1 | 0;
 return i2 | 0;
}

function __ZNK9AudioClip12GetFrequencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) if (HEAP32[i1 + 124 >> 2] | 0) {
  i2 = i1 + 56 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) if (HEAP32[i3 + 16 >> 2] | 0) {
   i1 = HEAP32[i2 >> 2] | 0;
   if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
   i3 = ~~Math_fround(__ZNK14SoundHandleAPI12GetFrequencyEv(i1)) >>> 0;
   return i3 | 0;
  }
  i3 = HEAP32[i1 + 32 >> 2] | 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 return i3 | 0;
}

function __ZNK5physx2Sc10ClothShape13getFilterInfoERjRNS_12PxFilterDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i1 >> 2] = 5;
 __ZNK5physx2Sc9ClothCore23getSimulationFilterDataEv(i5, HEAP32[i3 + 20 >> 2] | 0);
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i4;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140240 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 139980 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZN8Animator20ProcessAnimationsJobEPPS_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + (i2 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) return;
 if (!(HEAP32[i2 + 168 >> 2] | 0)) return;
 __ZN8Animator21ProcessAnimationsStepEv(i2);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 if (HEAP32[i1 + 100 >> 2] & 8 | 0) return;
 i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vifi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, 1.0, i1 + 564 | 0);
 return;
}

function __ZN4FMOD6System19setSoftwareChannelsEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  HEAP32[i2 + 40 >> 2] = i3;
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861057;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN2UI6Canvas24UpdateCanvasPixelPerfectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i1 + 412 >> 0] = HEAP8[i1 + 360 >> 0] | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData(i1, gb + 1106036 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN29ParticleSystemPropertyBinding46CleanupParticleSystemAnimationBindingInterfaceEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[gb + 1452340 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = gb + 83048 + 8;
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + 12 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -16 - i3 | 0) >>> 4) << 4);
   __ZdlPv(i2);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 HEAP32[gb + 1452340 >> 2] = 0;
 return;
}

function __ZN13ScreenManager40SetConcreteOrientationFromPlayerSettingsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 0:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 1);
   return;
  }
 case 1:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 2);
   return;
  }
 case 2:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 4);
   return;
  }
 case 3:
  {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 3);
   return;
  }
 default:
  return;
 }
}

function __ZN12HandlerChain18IsAbsoluteFilePathEPKc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z39TrailRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 384 >> 2] | 0;
  f2 = Math_fround(f2 / Math_fround(HEAPF32[i3 + 16 >> 2]));
  HEAPF32[(HEAP32[i3 + 76 >> 2] | 0) + 4 >> 2] = f2;
  return;
 }
}

function __Z39HingeJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP18JointAngleLimits2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 104 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z38RectTransform_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = __ZNK2UI13RectTransform7GetRectEv(i3) | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32CanvasRenderer_CUSTOM_SetTextureP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN2UI14CanvasRenderer10SetTextureEP7Texture(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN2UI14CanvasRenderer10SetTextureEP7Texture(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z22PlayableValidityChecksRK9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP32[i1 + 4 >> 2] | 0)) __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 586463 | 0, i2);
 if (!(HEAP32[i1 >> 2] | 0)) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 586569 | 0, i2 + 8 | 0);
 if (__ZNK9HPlayable7IsValidEv(i1) | 0) {
  STACKTOP = i2;
  return 1;
 } else __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 586682 | 0, i2 + 16 | 0);
 return 0;
}

function __Z12LookupSymbolPvRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 __Z6FormatPKcz(i2, gb + 455597 | 0, i1);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 455527 | 0, 203, 1, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return 0;
}

function _UNITY_png_gamma_correct(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i3 + -1 | 0;
 if ((HEAP8[i2 + 432 >> 0] | 0) == 8) {
  if (i1 >>> 0 < 254) i1 = ~~+Math_floor(+(+Math_pow(+(+(i3 >>> 0) / 255.0), +(+(i4 | 0) * 1.0e-05)) * 255.0 + .5)) & 255; else i1 = i3 & 255;
  i4 = i1 & 255;
  return i4 | 0;
 } else if (i1 >>> 0 < 65534) {
  i4 = ~~+Math_floor(+(+Math_pow(+(+(i3 >>> 0) / 65535.0), +(+(i4 | 0) * 1.0e-05)) * 65535.0 + .5)) & 65535;
  return i4 | 0;
 } else {
  i4 = i3 & 65535;
  return i4 | 0;
 }
 return 0;
}

function _UNITY_png_convert_from_time_t(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _gmtime(i4 | 0) | 0;
 HEAP16[i1 >> 1] = (HEAP32[i2 + 20 >> 2] | 0) + 1900;
 HEAP8[i1 + 2 >> 0] = (HEAP32[i2 + 16 >> 2] | 0) + 1;
 HEAP8[i1 + 3 >> 0] = HEAP32[i2 + 12 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP32[i2 + 8 >> 2];
 HEAP8[i1 + 5 >> 0] = HEAP32[i2 + 4 >> 2];
 HEAP8[i1 + 6 >> 0] = HEAP32[i2 >> 2];
 STACKTOP = i3;
 return;
}

function _strtok_r(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if (!i1) {
  i1 = HEAP32[i4 >> 2] | 0;
  if (!i1) i1 = 0; else i3 = 3;
 } else i3 = 3;
 do if ((i3 | 0) == 3) {
  i1 = i1 + (_strspn(i1, i2) | 0) | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   HEAP32[i4 >> 2] = 0;
   i1 = 0;
   break;
  }
  i2 = i1 + (_strcspn(i1, i2) | 0) | 0;
  HEAP32[i4 >> 2] = i2;
  if (!(HEAP8[i2 >> 0] | 0)) {
   HEAP32[i4 >> 2] = 0;
   break;
  } else {
   HEAP32[i4 >> 2] = i2 + 1;
   HEAP8[i2 >> 0] = 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function _printf_console(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8224 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 16 | 0;
 i4 = i5 + 32 | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 5, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 5);
 STACKTOP = i5;
 return;
}

function _gzungetc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if (!i3) {
  i3 = -1;
  return i3 | 0;
 }
 if ((i2 | 0) == -1 | (HEAP8[i3 + 92 >> 0] | 0) != 114) {
  i3 = -1;
  return i3 | 0;
 }
 i1 = i3 + 108 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  i3 = -1;
  return i3 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 i1 = i3 + 104 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 i1 = i3 + 56 | 0;
 i4 = (HEAP32[i1 >> 2] | 0) == 1;
 HEAP32[i3 + 112 >> 2] = i4 & 1;
 if (i4) HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 i4 = i2;
 return i4 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140100 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19GetDownloadProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (((HEAP32[i1 + 108 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
  f3 = Math_fround(1.0);
  return Math_fround(f3);
 }
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0));
 return Math_fround(f3);
}

function __ZN20ArchiveStorageHeader20GetDirectoryInfoSizeERKNS_13DirectoryInfoE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i5 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i5 = 4;
  return i5 | 0;
 }
 i4 = (i2 - i1 | 0) / 40 | 0;
 i1 = 4;
 i3 = 0;
 do {
  i2 = HEAP8[i5 + (i3 * 40 | 0) + 20 + 11 >> 0] | 0;
  if (i2 << 24 >> 24 < 0) i2 = HEAP32[i5 + (i3 * 40 | 0) + 24 >> 2] | 0; else i2 = i2 & 255;
  i1 = i1 + 21 + i2 | 0;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZN11UnityEngine7Connect15AppRunningEventD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __Z45AnimationOffsetPlayable_CUSTOM_InternalCreateR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN23AnimationOffsetPlayableC2E18DirectorPlayerType(i3, 0);
 __ZN8Playable6HandleEv(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z38LineRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i3 = HEAP32[i3 + 344 >> 2] | 0;
  f2 = Math_fround(f2 / Math_fround(HEAPF32[i3 + 16 >> 2]));
  HEAPF32[(HEAP32[i3 + 76 >> 2] | 0) + 4 >> 2] = f2;
  return;
 }
}

function __Z37Cursor_CUSTOM_INTERNAL_CALL_SetCursorP12Il2CppObjectRK13Vector2fIcall10CursorMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN7Cursors9SetCursorEP9Texture2D8Vector2f10CursorMode(i1, i4, i3);
 STACKTOP = i5;
 return;
}

function __Z13Int64ToStringx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 _snprintf(i5, 255, gb + 585572 | 0, i6) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
 STACKTOP = i4;
 return;
}

function _ftrylockfile(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[(_pthread_self() | 0) + 48 >> 2] | 0;
 i3 = i1 + 76 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 do if ((i4 | 0) == (i2 | 0)) {
  i1 = i1 + 68 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if ((i2 | 0) == 2147483647) i1 = -1; else {
   HEAP32[i1 >> 2] = i2 + 1;
   i1 = 0;
  }
 } else {
  if ((i4 | 0) < 0) HEAP32[i3 >> 2] = 0; else if (i4 | 0) {
   i1 = -1;
   break;
  }
  if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = i2;
  HEAP32[i1 + 68 >> 2] = 1;
  i1 = 0;
 } while (0);
 return i1 | 0;
}

function __ZNK9dtNavMesh12getTileByRefEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if ((i2 | 0) == 0 & (i3 | 0) == 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = _bitshift64Lshr(i2 | 0, i3 | 0, 20) | 0;
 getTempRet0() | 0;
 i4 = i4 & 268435455;
 if (i4 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
 getTempRet0() | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = (HEAP32[i3 + (i4 * 56 | 0) + 4 >> 2] | 0) == (i2 | 0) ? i3 + (i4 * 56 | 0) | 0 : 0;
 return i4 | 0;
}

function __ZNK6Avatar24GetRightFeetBottomHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i1 = i2 + i1 | 0;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(__ZN7mecanim5human18HumanGetFootHeightEPKNS0_5HumanEb(i1, 0));
 return Math_fround(f3);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 115124 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140080 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK14BillboardAsset9GetBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 i2 = HEAP32[i2 + 32 >> 2] | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 20 >> 2]) * Math_fround(.5));
 f5 = Math_fround(f4 + Math_fround(HEAPF32[i2 + 24 >> 2]));
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 16 >> 2]) * Math_fround(.5));
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = f3;
 HEAPF32[i1 + 16 >> 2] = f4;
 HEAPF32[i1 + 20 >> 2] = f3;
 return;
}

function __ZN7ApiGLES11DeleteQueryERN2gl6HandleILNS0_10ObjectTypeE4EEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = 3; else if ((HEAP32[i2 + 1988 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i5 = 3; else i1 = -1;
 HEAP32[i4 >> 2] = i1;
 mftCall_vii(HEAP32[i2 + 796 >> 2] | 0, 1, i4 | 0);
 i5 = i3;
 HEAP32[i5 >> 2] = -1;
 HEAP32[i5 + 4 >> 2] = -559030611;
 STACKTOP = i6;
 return;
}

function __ZN5physx24setVehicleToleranceScaleERKNS_17PxTolerancesScaleE(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(5.0));
 HEAPF32[gb + 1458420 >> 2] = f2;
 f2 = Math_fround(Math_fround(1.0) / f2);
 HEAPF32[gb + 1458424 >> 2] = f2;
 HEAP32[gb + 1458428 >> 2] = HEAP32[i1 >> 2];
 f2 = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * Math_fround(.200000003));
 HEAPF32[gb + 1458432 >> 2] = f2;
 HEAP32[gb + 1458436 >> 2] = HEAP32[i1 >> 2];
 HEAPF32[gb + 1458440 >> 2] = Math_fround(9.99999974e-06);
 return;
}

function __ZN5physx14NpShapeManager20clearShapesOnReleaseERNS_3Scb5SceneERNS_12PxRigidActorE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i1 = HEAP16[i2 + 4 >> 1] | 0;
 if (i1 << 16 >> 16 != 1) if (!(i1 << 16 >> 16)) return; else i2 = HEAP32[i2 >> 2] | 0;
 i5 = i3 + 2464 | 0;
 i1 = i1 & 65535;
 i4 = 0;
 do {
  i3 = HEAP32[i2 + (i4 << 2) >> 2] | 0;
  if (HEAP32[i3 + 36 >> 2] & 268435456 | 0) __ZN5physx3Scb13ObjectTracker6removeERNS0_4BaseE(i5, i3 + 32 | 0);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i1 | 0));
 return;
}

function __ZN23LODTreeInstanceRenderer10UpdateWindEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!(HEAP8[i1 + 289 >> 0] | 0)) i3 = HEAP32[i1 + 284 >> 2] | 0; else i3 = -1;
 __ZN12TreeRenderer21ComputeWindPropertiesEib(i2, HEAP32[i1 + 268 >> 2] | 0, i3, 0);
 __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet(i1, HEAP32[i2 >> 2] | 0);
 HEAP8[i1 + 288 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 STACKTOP = i4;
 return;
}

function __ZN17BillboardRendererD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 340 >> 2] = gb + 56316 + 252;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = gb + 29060 + 8;
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10MonoScript13AwakeFromLoadE17AwakeFromLoadMode(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (i1 & 2 | 0) return;
 i1 = i3 + 124 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 108 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
 __ZN10MonoScript7RebuildEP11Il2CppClass(i3, __Z29scripting_class_from_fullnamePKcS0_S0_(i1, i2, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z28CalculateSubShaderIndexToUsePK6ShaderS1_ii(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 if (!i3) i1 = __ZNK6Shader23GetActiveSubShaderIndexEv(i2) | 0; else if ((i4 | 0) > -1) {
  if ((i1 | 0) < 0) {
   i1 = __ZNK9ShaderLab9IntShader6GetTagEib(HEAP32[i2 + 32 >> 2] | 0, i4, 1) | 0;
   if ((i1 | 0) < 0) {
    i4 = -1;
    return i4 | 0;
   }
  }
  i1 = __ZNK6Shader24GetSubShaderWithTagValueEii(i3, i4, i1) | 0;
  if ((i1 | 0) == -1) {
   i4 = -1;
   return i4 | 0;
  }
 } else i1 = 0;
 i4 = i1;
 return i4 | 0;
}

function __Z26Application_CUSTOM_OpenURLP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i3, i4);
 __Z7OpenURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i3);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z15IntersectTriTriRK8Vector3fS1_S1_S1_S1_S1_PS_S2_Pb(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 var i10 = 0, i11 = 0;
 i10 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i11 = i10;
 i8 = (__Z32tri_tri_intersect_with_isectlinePfS_S_S_S_S_PiS_S_(i1, i2, i3, i4, i5, i6, i11, i7, i8) | 0) != 0;
 HEAP8[i9 >> 0] = (HEAP32[i11 >> 2] | 0) != 0 & 1;
 STACKTOP = i10;
 return i8 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcjj(i1, i5, i3, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 < i6 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 i2 = i2 - i6 | 0;
 i2 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (i4) i1 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _memcpy(i5 | 0, i1 + i6 | 0, i2 | 0) | 0;
 return i2 | 0;
}

function __ZNK6Shader24GetShadowCasterPassToUseEiRi(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 HEAP32[i4 >> 2] = 0;
 i2 = HEAP32[(HEAP32[HEAP32[i3 + 32 >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!(HEAP8[i2 + 48 >> 0] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if ((i1 | 0) > -1) {
  HEAP32[i4 >> 2] = i1;
  i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  return i4 | 0;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i3 + 40 >> 2];
  i4 = HEAP32[i3 + 36 >> 2] | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZNK6Avatar23GetLeftFeetBottomHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i1 = i2 + i1 | 0;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(__ZN7mecanim5human18HumanGetFootHeightEPKNS0_5HumanEb(i1, 1));
 return Math_fround(f3);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140120 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK28RectTransformPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i4, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[gb + 44296 >> 2] | 0;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) {
  i2 = -1;
  do {
   i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
  i1 = ~i2;
 } else i1 = 0;
 return ((i1 | 0) == (HEAP32[i4 + 4 >> 2] | 0) ? 100002 : -1) | 0;
}

function __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE17GetUploadProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (((HEAP32[i1 + 108 >> 2] | 0) + -3 | 0) >>> 0 < 2) {
  f3 = Math_fround(1.0);
  return Math_fround(f3);
 }
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0));
 return Math_fround(f3);
}

function __ZN5physx31PxDefaultBufferedProfilerCreateERNS_12PxFoundationEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i5 | 0, i4 | 0, 104, (i3 ? gb + 740457 | 0 : gb + 837976 | 0) | 0, gb + 660845 | 0, 24) | 0;
 __ZN5physx3Ext23DefaultBufferedProfilerC2ERNS_12PxFoundationEPKc(i3, i1, i2);
 return i3 | 0;
}

function __ZN5physx20PxSetFilterConstantsERKNS_12PxGroupsMaskES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1;
 i4 = i3;
 i3 = i3 + 4 | 0;
 i3 = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
 i1 = gb + 1098832 | 0;
 HEAP32[i1 >> 2] = HEAPU16[i4 >> 1] | HEAPU16[i4 + 2 >> 1] << 16;
 HEAP32[i1 + 4 >> 2] = i3;
 i1 = i2;
 i3 = i1;
 i1 = i1 + 4 | 0;
 i1 = HEAPU16[i1 >> 1] | HEAPU16[i1 + 2 >> 1] << 16;
 i2 = gb + 1098832 + 8 | 0;
 HEAP32[i2 >> 2] = HEAPU16[i3 >> 1] | HEAPU16[i3 + 2 >> 1] << 16;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[gb + 1170888 >> 2] | 0;
 if ((i5 | 0) > 399) _exit(-1); else {
  HEAP32[gb + 1170892 + (i5 * 20 | 0) + 8 >> 2] = i1;
  HEAP32[gb + 1170892 + (i5 * 20 | 0) + 12 >> 2] = i2;
  HEAP32[gb + 1170892 + (i5 * 20 | 0) + 4 >> 2] = i4;
  HEAP32[gb + 1170892 + (i5 * 20 | 0) >> 2] = i3;
  HEAP8[gb + 1170892 + (i5 * 20 | 0) + 16 >> 0] = 0;
  HEAP32[gb + 1170888 >> 2] = i5 + 1;
  return;
 }
}

function __ZN33AssetBundleLoadFromAsyncOperation20IntegrateImmediatelyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i1) | 0)) {
  i2 = i1 + 92 | 0;
  if (HEAP32[i2 >> 2] | 0) if ((HEAP32[i2 >> 2] | 0) != 1) {
   i2 = i1 + 96 | 0;
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN30AudioEffectInternalDescriptionD2Ev(i7) {
 i7 = i7 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = i7 + 60 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i6 = i7 + 64 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) > 0) {
  i4 = 0;
  do {
   i3 = HEAP32[i1 + (i4 * 48 | 0) + 44 >> 2] | 0;
   if (i3) {
    __ZdaPv(i3);
    i2 = HEAP32[i5 >> 2] | 0;
    i1 = HEAP32[i6 >> 2] | 0;
   }
   i4 = i4 + 1 | 0;
  } while ((i4 | 0) < (i2 | 0));
 }
 if (i1 | 0) __ZdaPv(i1);
 i1 = HEAP32[i7 + 180 >> 2] | 0;
 if (!i1) return;
 __ZdaPv(i1);
 return;
}

function __ZN27AnimationLayerMixerPlayableD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 176908 + 8;
 i1 = i2 + 100 | 0;
 if ((HEAP32[i2 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 104 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 80 | 0;
 if ((HEAP32[i2 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 84 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i2 + 76 | 0);
 __ZN8PlayableD2Ev(i2);
 return;
}

function __ZN25MeshMTDGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj(i6, i7, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i4 = HEAP32[i6 + 8 >> 2] | 0;
 i2 = HEAP32[i7 + 8 >> 2] | 0;
 i3 = i4 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i4 >> 2] | 0)) {
  __ZN5physx2Gu9Container6ResizeEj(i4, 1) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[(HEAP32[i4 + 8 >> 2] | 0) + (i1 << 2) >> 2] = i2;
 return 1;
}

function __ZN24DownloadHandlerAudioClipD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187440 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 40 | 0);
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 __Z23scripting_gchandle_freej(i1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN24DownloadHandlerAudioClipD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187440 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 40 | 0);
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 __ZdlPv(i1);
 return;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14TimerQueryGLES10GetElapsedEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = (i1 & 1 | 0) != 0;
 if (i2) {
  i1 = i3 + 24 | 0;
  i4 = i1;
  if ((HEAP32[i4 >> 2] | 0) == -1 ? (HEAP32[i4 + 4 >> 2] | 0) == -1 : 0) {
   i4 = i1;
   HEAP32[i4 >> 2] = 0;
   HEAP32[i4 + 4 >> 2] = 0;
  }
 }
 i1 = i3 + 4 | 0;
 do if (!(HEAP32[i1 >> 2] | 0)) break; while (__ZN16TimerQueriesGLES18PollNextTimerQueryEb(gb + 1098256 | 0, i2) | 0);
 i3 = i3 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 setTempRet0(HEAP32[i3 + 4 >> 2] | 0);
 return i4 | 0;
}

function __ZN12AudioManager13AddAudioMixerEP10AudioMixer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 68 | 0;
 i4 = i2 + 80 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i1 = i2 + 84 | 0; else {
  i2 = i2 + 84 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[HEAP32[i2 >> 2] >> 2] = i1;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
  i1 = i2;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN11UnityEngine7Connect13AppStartEventD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN10GUITextureD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 36436 + 8;
 i2 = i1 + 88 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __Z51MaterialPropertyBlock_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i4, i1, i2);
 STACKTOP = i6;
 return;
}

function __Z38ScriptableObject_CUSTOM_CreateInstanceP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallString6ToUTF8Ev(i3, i4);
 i1 = __ZN9Scripting22CreateScriptableObjectERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z29GL_CUSTOM_LoadPixelMatrixArgsffff(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 f2 = Math_fround(f2 - f1);
 f4 = Math_fround(f4 - f3);
 HEAPF32[i6 >> 2] = f1;
 HEAPF32[i6 + 8 >> 2] = f2;
 HEAPF32[i6 + 4 >> 2] = f3;
 HEAPF32[i6 + 12 >> 2] = f4;
 __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb(i6, __Z12GetGfxDevicev() | 0, 1);
 STACKTOP = i5;
 return;
}

function mftCall_viiifififfi(i11, i1, i2, i3, d4, i5, d6, i7, d8, d9, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 d8 = +d8;
 d9 = +d9;
 i10 = i10 | 0;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiifififfi[i11 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, Math_fround(d6), i7 | 0, Math_fround(d8), Math_fround(d9), i10 | 0);
  return;
 }
 ftCall_viiifififfi(i11 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, +d6, i7 | 0, +d8, +d9, i10 | 0);
}

function _strncmp(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 if (!i4) i1 = 0; else {
  i1 = HEAP8[i3 >> 0] | 0;
  L3 : do if (!(i1 << 24 >> 24)) i1 = 0; else while (1) {
   i4 = i4 + -1 | 0;
   i5 = HEAP8[i2 >> 0] | 0;
   if (!(i1 << 24 >> 24 == i5 << 24 >> 24 & ((i4 | 0) != 0 & i5 << 24 >> 24 != 0))) break L3;
   i3 = i3 + 1 | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i3 >> 0] | 0;
   if (!(i1 << 24 >> 24)) {
    i1 = 0;
    break;
   }
  } while (0);
  i1 = (i1 & 255) - (HEAPU8[i2 >> 0] | 0) | 0;
 }
 return i1 | 0;
}

function __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = HEAP32[i1 + 12 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 4 >> 2] = i5;
  HEAP32[i4 + 8 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx2Sn13XmlNodeReader4readEPKcRS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 16 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, i2) | 0)) break;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = 6;
   break;
  }
 }
 if ((i4 | 0) == 6) return i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = (HEAP8[i1 >> 0] | 0) != 0;
 return i4 | 0;
}

function __ZN5physx15PxVehicleWheels8requiresERNS_23PxProcessPxBaseCallbackE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[i1 + 104 >> 2] | 0);
 i3 = i1 + 44 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 72 | 0;
 i2 = 0;
 do {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Unity17ConfigurableJoint16SetSecondaryAxisERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 348 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, 1);
 return;
}

function __ZN16b2BlockAllocator5ClearEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, gb + 63408 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 HEAP32[i3 >> 2] = 0;
 _memset(HEAP32[i2 >> 2] | 0, 0, HEAP32[i2 + 8 >> 2] << 3 | 0) | 0;
 i1 = i2 + 12 | 0;
 i2 = i1 + 56 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN15LocationService14GetLastHeadingEv() {
 if (HEAP8[gb + 1546330 >> 0] | 0) return gb + 1098112 | 0;
 HEAPF32[gb + 1098112 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1098112 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1098112 + 8 >> 2] = Math_fround(0.0);
 HEAP32[gb + 1098112 + 12 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[gb + 1098112 + 16 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[gb + 1098112 + 20 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF64[gb + 1098112 + 24 >> 3] = 0.0;
 HEAP8[gb + 1546330 >> 0] = 1;
 return gb + 1098112 | 0;
}

function __ZN13GfxDeviceGLES21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii(i3, i1, i2, i4, i5, i6, i7) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 if (HEAP8[i1 + 31 >> 0] | 0) return;
 i3 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i3 + 4616 >> 2] | 0) | 0;
 __ZN18GfxFramebufferGLES7PrepareEv(i3);
 __ZN18GfxFramebufferGLES21GrabIntoRenderTextureEP17RenderSurfaceGLESiiii(i3, i1, i4, i5, i6, i7);
 return;
}

function __ZN11UnityEngine7Connect12AppStopEventD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN10Collider2D26UpdateColliderDensityStateEP11Rigidbody2D(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, f4 = f0;
 i3 = HEAP32[i2 + 72 >> 2] | 0;
 if (!i3) return;
 if (!i1) f4 = Math_fround(1.0); else if (!(HEAP8[i1 + 49 >> 0] | 0)) f4 = Math_fround(1.0); else if (!(HEAP32[i1 + 68 >> 2] | 0)) f4 = Math_fround(HEAPF32[i2 + 48 >> 2]); else f4 = Math_fround(1.0);
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 do {
  HEAPF32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] = f4;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z46TerrainData_CUSTOM_Internal_SetHeightsDelayLODP12Il2CppObjectiiiiP11Il2CppArray(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __ZN9Heightmap10SetHeightsEiiiiPKfb(i7 + 248 | 0, i2, i3, i4, i5, __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AnimationMixerPlayable_CUSTOM_InternalCreateR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(80, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN22AnimationMixerPlayableC2E18DirectorPlayerType(i3, 0);
 __ZN8Playable6HandleEv(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z30MeshFilter_Set_Custom_PropMeshP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN10MeshFilter19SetInstantiatedMeshEP4Mesh(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN10MeshFilter19SetInstantiatedMeshEP4Mesh(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28EnsureRenderTextureIsCreatedP13RenderTexture(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i1, i2, i2) | 0;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  i2 = 0;
  STACKTOP = i3;
  return i2 | 0;
 }
 i2 = i1;
 STACKTOP = i3;
 return i2 | 0;
}

function mftCall_iiiiifiiiif(i11, i1, i2, i3, i4, d5, i6, i7, i8, i9, d10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 d10 = +d10;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiifiiiif[i11 - fb & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5), i6 | 0, i7 | 0, i8 | 0, i9 | 0, Math_fround(d10)) | 0;
 return ftCall_iiiiifiiiif(i11 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5, i6 | 0, i7 | 0, i8 | 0, i9 | 0, +d10) | 0;
}

function __ZN9GfxDevice25SetInvertProjectionMatrixEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4380 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 HEAPF32[i1 + 612 >> 2] = i2 ? Math_fround(-1.0) : Math_fround(1.0);
 i3 = i1 + 1784 | 0;
 HEAPF32[i3 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 i3 = i1 + 1816 | 0;
 HEAPF32[i3 >> 2] = Math_fround(-Math_fround(HEAPF32[i3 >> 2]));
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i1 + 1764 | 0, i1 + 1828 | 0, i1 + 1956 | 0);
 return;
}

function __ZN8Animator17SetLookAtPositionE8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 i4 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 + 40 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 44 >> 2] = i1;
 HEAP32[i4 + 48 >> 2] = i3;
 return;
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ES4_S4_f(i4, i2, i3, f1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 4 | 0;
 i6 = i5;
 HEAPF32[i7 >> 2] = f1;
 HEAP32[i6 >> 2] = __Z6simd4fRKf(i7) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i4, i6);
 HEAP32[i4 + 16 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 20 >> 2] = HEAP32[i3 >> 2];
 STACKTOP = i5;
 return;
}

function __ZN5physx2Sc5Scene10broadPhaseEPNS_10PxBaseTaskE(i5, i3) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i5 + 160 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i5 + 156 | 0;
  i4 = 0;
  do {
   __ZN5physx2Sc8ClothSim12updateBoundsEv(__ZNK5physx2Sc9ClothCore6getSimEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i4 << 2) >> 2] | 0) | 0);
   i4 = i4 + 1 | 0;
  } while (i4 >>> 0 < (HEAP32[i1 >> 2] | 0) >>> 0);
 }
 __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb(HEAP32[(HEAP32[i5 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i3, 0);
 return;
}

function __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[gb + 1170888 >> 2] | 0;
 if ((i1 | 0) > 399) _exit(-1); else {
  HEAP32[gb + 1170892 + (i1 * 20 | 0) + 8 >> 2] = i2;
  HEAP32[gb + 1170892 + (i1 * 20 | 0) + 12 >> 2] = i3;
  HEAP32[gb + 1170892 + (i1 * 20 | 0) + 4 >> 2] = i5;
  HEAP32[gb + 1170892 + (i1 * 20 | 0) >> 2] = i4;
  HEAP8[gb + 1170892 + (i1 * 20 | 0) + 16 >> 0] = 0;
  HEAP32[gb + 1170888 >> 2] = i1 + 1;
  return;
 }
}

function __ZN18GfxFramebufferGLES31FallbackToValidFramebufferStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP8[i1 + 328 >> 0] | 0) == 0;
 if (HEAP8[i1 + 208 >> 0] | 0) {
  if (!i2) return;
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i1, i1 + 16 | 0);
  return;
 }
 if (i2) {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i1, 0);
  __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i1, i1 + 16 | 0);
  return;
 } else {
  __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE(i1, 1);
  return;
 }
}

function __ZN15NavMeshObstacle5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 40 >> 2] = 1;
 HEAPF32[i1 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.5);
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 76 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 72 >> 2] = Math_fround(.100000001);
 HEAP8[i1 + 69 >> 0] = 1;
 HEAP8[i1 + 68 >> 0] = 0;
 return;
}

function __ZN13ScreenManager21SetCursorInsideWindowEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 HEAP8[i4 + 27 >> 0] = i1 & 1;
 i1 = i4 + 24 | 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = HEAP32[i5 + 36 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[i5 + 32 >> 2] | 0, i4 | 0) | 0)) {
  i5 = 0;
  mftCall_vii(i3 | 0, i4 | 0, i5 | 0);
  HEAP8[i1 >> 0] = i2;
  return;
 }
 i5 = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0) | 0) != 1;
 mftCall_vii(i3 | 0, i4 | 0, i5 | 0);
 HEAP8[i1 >> 0] = i2;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager18HandleTimerExpiredEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 560 >> 2] = 0;
 i2 = i1 + 576 | 0;
 i2 = __ZN11UnityEngine15CloudWebService16SessionContainer18GetIndexFromDataIdEy(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 if ((i2 & 65535) > 4) return;
 i2 = i2 & 65535;
 HEAP8[i1 + 40 + (i2 << 7) + 92 >> 0] = 1;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, fb + 3961 | 0, i1 + 40 + (i2 << 7) | 0) | 0;
 return;
}

function __ZN11PlayerPrefs9DeleteAllEv() {
 var i1 = 0, i2 = 0;
 __ZL18InitializeIfNeededv();
 HEAP8[gb + 1544208 >> 0] = 1;
 HEAP32[gb + 1103828 >> 2] = 16;
 i2 = HEAP32[gb + 1103788 >> 2] | 0;
 i1 = i2 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 __ZN11PlayerPrefs4SyncEv();
 return;
}

function __ZN10OnGUIState8EndOnGUIEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN11UTF16StringD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 76 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZN11UTF16StringD2Ev(i2);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i3 = i1 + 28 | 0;
 i4 = i2 + (HEAP32[i3 >> 2] << 2) | 0;
 i1 = i2;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i6 = 5;
   break;
  }
  i2 = i1 + 4 | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break; else i1 = i2;
 }
 if ((i6 | 0) == 5) return i1 | 0;
 _memmove(i1 | 0, i2 | 0, i4 - i2 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 i6 = 1;
 return i6 | 0;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z50MaterialPropertyBlock_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i6 + 4 | 0;
 i5 = i6;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i4, i1, i2);
 STACKTOP = i6;
 return;
}

function __Z31AudioSource_Set_Custom_PropClipP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN11AudioSource12SetAudioClipEP9AudioClip(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN11AudioSource12SetAudioClipEP9AudioClip(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z15printf_consolev7LogTypePKcPi(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 8208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i6 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0)) {
  STACKTOP = i6;
  return;
 }
 _memset(i5 | 0, 0, 8192) | 0;
 _vsnprintf(i5, 8192, i3, i4) | 0;
 _JS_Log_Dump(i5 | 0, i2 | 0);
 STACKTOP = i6;
 return;
}

function __Z10DecodeRGBMRK11ColorRGBA3210RGBMRanges(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(Math_fround(Math_imul(HEAPU8[i2 + 3 >> 0] | 0, i3) | 0) / Math_fround(65025.0));
 i3 = HEAP32[i2 >> 2] | 0;
 f5 = Math_fround(Math_fround((i3 & 65535) >>> 8 & 255) * f6);
 f4 = Math_fround(Math_fround(i3 >>> 16 & 255) * f6);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(i3 & 255) * f6);
 HEAPF32[i1 + 4 >> 2] = f5;
 HEAPF32[i1 + 8 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 140140 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZNK20ArchiveStorageReader15HasStreamBlocksEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 108 >> 2] | 0;
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = (i2 - i1 | 0) / 12 | 0;
 i1 = 0;
 while (1) {
  i4 = HEAP16[i3 + (i1 * 12 | 0) + 8 >> 1] | 0;
  i1 = i1 + 1 | 0;
  if ((i4 & 63) != 0 & (i4 & 64) != 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK12HandlerChain8FilenameERK13FileEntryData(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i2 = i2 + -4 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i4 | 0) | 0;
  if (i1 | 0) {
   i2 = 4;
   break;
  }
  if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN5Umbra12QueryContext7mapTileEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) if (HEAP8[i2 + 24 >> 0] | 0) {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i3 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (Math_imul(HEAP32[i2 + 20 >> 2] | 0, i3) | 0) >> 2] | 0;
  return i3 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (Math_imul(HEAP32[i2 + 20 >> 2] | 0, i3) | 0) >> 2] | 0;
 i3 = (i3 | 0) == 0 ? 0 : (HEAP32[i1 >> 2] | 0) + i3 | 0;
 return i3 | 0;
}

function __ZN2UI6Canvas21WaitOnBatchGenerationEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5 + 4 | 0;
 i3 = i5;
 i4 = i2 + 332 | 0;
 if (HEAP32[i4 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i4);
 i4 = __Z12GetGfxDevicev() | 0;
 i6 = HEAP32[(HEAP32[i4 >> 2] | 0) + 256 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 340 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 mftCall_vii(i6 | 0, i4 | 0, i1 | 0);
 STACKTOP = i5;
 return;
}

function __ZN17PersistentManager14GetLocalFileIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = 0;
 i4 = i5 + 8 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 __ZN17PersistentManager38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier(i1, i2, i5) | 0;
 i1 = i4;
 i2 = HEAP32[i1 >> 2] | 0;
 setTempRet0(HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -8 - i5 | 0) >>> 3) << 3);
   __ZdlPv(i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZL17LightmapDataToCppR16LightmapDataMonoR12LightmapData(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 + 4 >> 2] | 0) | 0;
 if (!i1) {
  i2 = 0;
  i3 = i3 + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __Z39SliderJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 100 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z37Component_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i2 = i2 + -4 | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i2 >> 2] = __Z50ScriptingGetComponentsOfTypeFromGameObjectFastPathP10GameObjectP12Il2CppObject(i1, i3) | 0;
   return;
  }
 }
 HEAP32[i2 >> 2] = 0;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(0);
}

function _UNITY_FT_Stream_ReadAt(i4, i5, i1, i6) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if (i2 >>> 0 <= i5 >>> 0) {
  i6 = 85;
  return i6 | 0;
 }
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 if (!i3) {
  i3 = i2 - i5 | 0;
  i3 = i3 >>> 0 > i6 >>> 0 ? i6 : i3;
  _memcpy(i1 | 0, (HEAP32[i4 >> 2] | 0) + i5 | 0, i3 | 0) | 0;
  i1 = i3;
 } else i1 = mftCall_iiiii(i3 | 0, i4 | 0, i5 | 0, i1 | 0, i6 | 0) | 0;
 HEAP32[i4 + 8 >> 2] = i1 + i5;
 i6 = i1 >>> 0 < i6 >>> 0 ? 85 : 0;
 return i6 | 0;
}

function __ZNSt3__26localeC2ERKS0_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __Znwj(160) | 0;
 __THREW__ = 0;
 invoke_viiii(fb + 360 | 0, i5 | 0, HEAP32[i2 >> 2] | 0, i3 | 0, i4 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZdlPv(i5);
  ___resumeException(i4 | 0);
 } else {
  HEAP32[i1 >> 2] = i5;
  __ZNSt3__214__shared_count12__add_sharedEv(i5);
  return;
 }
}

function __ZNK4Mesh32IsSuitableSizeForDynamicBatchingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i2 + 132 >> 2] | 0;
 i2 = HEAP32[i2 + 128 >> 2] | 0;
 i3 = i2;
 if ((i1 | 0) == (i2 | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = (i1 - i2 | 0) / 52 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 * 52 | 0) + 48 >> 2] | 0) >>> 0 > 300) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN7Terrain12SetNeighborsEPS_S0_S0_S0_(i4, i2, i1, i3, i5) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 + 220 >> 2] = i1;
 if (!i2) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 + 208 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i4 + 212 >> 2] = i1;
 if (!i5) {
  i3 = 0;
  i5 = i4 + 216 | 0;
  HEAP32[i5 >> 2] = i3;
  return;
 }
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = i4 + 216 | 0;
 HEAP32[i5 >> 2] = i3;
 return;
}

function __ZN5physx2Sq8BitArray4initEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = ((i1 & 31 | 0) != 0 & 1) + (i1 >>> 5);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i2 >> 2] | 0);
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, HEAP32[i4 >> 2] << 2, gb + 706818 | 0, 45) | 0;
 HEAP32[i2 >> 2] = i1;
 _memset(i1 | 0, 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 STACKTOP = i3;
 return 1;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN2UI13CanvasManager23RemoveAllDirtyRenderersEPNS_6CanvasE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = i2;
 if (!i2) {
  STACKTOP = i4;
  return;
 }
 __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_(i1 + 12 | 0, i3) | 0;
 STACKTOP = i4;
 return;
}

function __ZN21AnimationPosePlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 72 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  HEAP8[i3 >> 0] = 1;
  return;
 }
 i4 = HEAP16[i2 + 34 >> 1] | 0;
 HEAP32[i1 + 84 >> 2] = __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE(HEAP32[i2 >> 2] | 0, (HEAP8[i2 + 33 >> 0] | 0) != 0, (i4 & 255) << 24 >> 24 != 0, (i4 & 65535) > 255, i1 + 60 | 0) | 0;
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZN15StreamNameSpace11IsDestroyedEx(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 i5 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + (i5 << 3) | 0;
 L4 : do if (i5) while (1) {
  i5 = i1;
  if ((HEAP32[i5 >> 2] | 0) == (i3 | 0) ? (HEAP32[i5 + 4 >> 2] | 0) == (i4 | 0) : 0) break L4;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = i2;
   break;
  }
 } while (0);
 i5 = (i1 | 0) != (i2 | 0);
 return i5 | 0;
}

function __ZN15QualitySettings15SetAntiAliasingEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 72 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1158216 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 i1 = __Z12GetIVRDevicev() | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12TreeDatabase17SetTreePrototypesERKNSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 if ((i3 | 0) != (i2 | 0)) __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_(i3, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 __ZN12TreeDatabase13ValidateTreesEv(i1);
 __ZN12TreeDatabase17RefreshPrototypesEv(i1);
 return;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z48GUIStyle_CUSTOM_INTERNAL_get_Internal_clipOffsetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[i1 + 272 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i1 + 268 >> 2];
   HEAP32[i3 + 4 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i3 = (i5 << 1) + -1 | 0;
 i2 = (i3 >>> 0) / (i5 >>> 0) | 0;
 if (i3 >>> 0 < i5 >>> 0) return i2 | 0;
 i3 = i2 + -1 | 0;
 i1 = 0;
 do {
  i6 = Math_imul(i1, i5) | 0;
  HEAP32[i4 + (i1 * 12 | 0) >> 2] = i6;
  HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] = i5 - ((i1 | 0) == (i3 | 0) ? i6 : 0);
  HEAP32[i4 + (i1 * 12 | 0) + 8 >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return i2 | 0;
}

function __Z38WheelJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 108 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z29TerrainData_CUSTOM_RemoveUserP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN11TerrainData10RemoveUserEP10GameObject(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN11TerrainData10RemoveUserEP10GameObject(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z19GetBytesForOnePixel13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 + -10 | 0) >>> 0 < 3) {
  i2 = 0;
  return i2 | 0;
 }
 if (((i1 | 1) + -25 | 0) >>> 0 < 5) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i1 + -30 | 0;
 if (i2 >>> 0 < 15) {
  if ((i1 + -48 | 0) >>> 0 < 12 | ((i1 + -45 | 0) >>> 0 < 3 | (30847 >>> (i2 & 65535) & 1) != 0)) {
   i2 = 0;
   return i2 | 0;
  }
 } else if ((i1 + -45 | 0) >>> 0 < 3 | (i1 + -48 | 0) >>> 0 < 12) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[gb + 45784 + (i1 << 2) >> 2] | 0;
 return i2 | 0;
}

function __GLOBAL__sub_I_NpActor_cpp() {
 _memset(gb + 1457020 | 0, 0, 136) | 0;
 HEAP32[gb + 1457020 + 24 >> 2] = 12;
 HEAP32[gb + 1457020 + 20 >> 2] = 12;
 HEAP32[gb + 1457020 + 44 >> 2] = 12;
 HEAP32[gb + 1457020 + 48 >> 2] = 12;
 HEAP32[gb + 1457020 + 60 >> 2] = 12;
 HEAP32[gb + 1457020 + 40 >> 2] = 12;
 HEAP32[gb + 1457020 + 92 >> 2] = 48;
 HEAP32[gb + 1457020 + 88 >> 2] = 48;
 HEAP32[gb + 1457020 + 112 >> 2] = 20;
 HEAP32[gb + 1457020 + 116 >> 2] = 20;
 HEAP32[gb + 1457020 + 128 >> 2] = 48;
 HEAP32[gb + 1457020 + 108 >> 2] = 20;
 return;
}

function _UNITY_png_write_sig(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 i3 = i5;
 HEAP32[i3 >> 2] = 1196314761;
 HEAP32[i3 + 4 >> 2] = 169478669;
 HEAP32[i1 + 656 >> 2] = 18;
 i3 = i1 + 437 | 0;
 i4 = HEAPU8[i3 >> 0] | 0;
 _UNITY_png_write_data(i1, i5 + i4 | 0, 8 - i4 | 0);
 if ((HEAPU8[i3 >> 0] | 0) >= 3) {
  STACKTOP = i2;
  return;
 }
 i5 = i1 + 204 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 4096;
 STACKTOP = i2;
 return;
}

function _memset(i2, i6, i1) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i3 = i2 + i1 | 0;
 if ((i1 | 0) >= 20) {
  i6 = i6 & 255;
  i5 = i2 & 3;
  i7 = i6 | i6 << 8 | i6 << 16 | i6 << 24;
  i4 = i3 & ~3;
  if (i5) {
   i5 = i2 + 4 - i5 | 0;
   while ((i2 | 0) < (i5 | 0)) {
    HEAP8[i2 >> 0] = i6;
    i2 = i2 + 1 | 0;
   }
  }
  while ((i2 | 0) < (i4 | 0)) {
   HEAP32[i2 >> 2] = i7;
   i2 = i2 + 4 | 0;
  }
 }
 while ((i2 | 0) < (i3 | 0)) {
  HEAP8[i2 >> 0] = i6;
  i2 = i2 + 1 | 0;
 }
 return i2 - i1 | 0;
}

function ___stdio_seek(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i4 = i5 + 20 | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 60 >> 2];
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = i3;
 if ((___syscall_ret(___syscall140(140, i6 | 0) | 0) | 0) < 0) {
  HEAP32[i4 >> 2] = -1;
  i1 = -1;
 } else i1 = HEAP32[i4 >> 2] | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj(HEAP32[i1 >> 2] | 0, i3 << 4) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i1 + (i4 << 4) | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1 + (i3 << 4);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, -2147483648, i2 | 0);
 HEAP32[i4 >> 2] = gb + 14e4 + 8;
 HEAP32[i4 + 4 >> 2] = i3;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 488 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i1;
 return;
}

function __ZN8DrawUtil11DrawMeshRawERK14ChannelAssignsR4MeshiiPS3_(i3, i4, i5, i1, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i4, i1, HEAP32[i3 >> 2] | 0, i6, 0) | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  STACKTOP = i2;
  return;
 }
 __ZN8DrawUtil18DrawMeshBuffersRawERK11MeshBuffersR4MeshRK14ChannelAssignsii(i1, i4, i3, i5, 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx16PxVehicleDriveNW8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = (i1 + 3 | 0) >>> 2;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i4) | 0) + 768 | 0, gb + 827537 | 0, 63) | 0;
 __ZN5physx16PxVehicleDriveNWC2Ev(i3);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i3, i3 + 768 | 0, i4, i1) | 0;
 HEAP8[i3 + 113 >> 0] = 1;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN5physx16PxVehicleDrive4W8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = (i1 + 3 | 0) >>> 2;
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, (__ZN5physx14PxVehicleDrive15computeByteSizeEj(i4) | 0) + 800 | 0, gb + 827445 | 0, 75) | 0;
 __ZN5physx16PxVehicleDrive4WC2Ev(i3);
 __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i3, i3 + 800 | 0, i4, i1) | 0;
 HEAP8[i3 + 113 >> 0] = 0;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN5physx14NpRigidDynamic8requiresERNS_23PxProcessPxBaseCallbackE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 20 | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i4 = i1 & 65535;
 i2 = 0;
 while (1) {
  if (i1 << 16 >> 16 == 1) i1 = i5; else i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break;
  i1 = HEAP16[i3 >> 1] | 0;
 }
 return;
}

function __ZN5UmbramlERKNS_7Vector2ERKNS_9Matrix2x2E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2]));
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 4 >> 2])));
 f6 = Math_fround(f6 * Math_fround(HEAPF32[i3 + 8 >> 2]));
 f4 = Math_fround(f6 + Math_fround(f4 * Math_fround(HEAPF32[i3 + 12 >> 2])));
 HEAPF32[i1 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN5Light8SetFlareEP5Flare(i5, i2) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = (i2 | 0) == 0;
 if (i3) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = i5 + 48 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i1 | 0)) return;
 if (i3) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 if (!(mftCall_ii(HEAP32[(HEAP32[i5 >> 2] | 0) + 112 >> 2] | 0, i5 | 0) | 0)) return;
 i1 = HEAP32[i5 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 __ZN5Light10SetupFlareEv(i5);
 return;
}

function __ZN5IMGUI14GUIWindowState9GetWindowEi(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i4 = HEAP32[i3 + 4 >> 2] | 0;
 L1 : do if ((i1 | 0) != (i4 | 0)) {
  i2 = i1;
  while (1) {
   i1 = HEAP32[i2 >> 2] | 0;
   i2 = i2 + 4 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) break;
   if ((i2 | 0) == (i4 | 0)) break L1;
  }
  return i1 | 0;
 } while (0);
 i1 = HEAP32[i3 + 24 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 >> 2] | 0) == (i5 | 0)) {
  i5 = i1;
  return i5 | 0;
 }
 i5 = 0;
 return i5 | 0;
}

function __ZN4FMOD6System19setStreamBufferSizeEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = i3;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 36;
 HEAP32[i4 + 4 >> 2] = gb + 861508;
 _printf(gb + 853184 | 0, i4) | 0;
 i4 = 36;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN14CachingManager28SetMaximumDiskSpaceAvailableEx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i1 + 40 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i5 | 0) < (i3 | 0) | ((i5 | 0) == (i3 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 444448 | 0, 0, gb + 444242 | 0, 646, 1, 0, 0, 0);
  return;
 } else {
  i5 = i1 + 32 | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  return;
 }
}

function __ZN13TargetJoint2D19AutoConfigureTargetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i1 = __ZNK10GameObject23QueryComponentTransformEv(i1) | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __ZNK9Transform11GetPositionEv(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 + 84 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 88 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN13RuntimeStaticI11WindManagerE13StaticDestroyEPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i2 + 4 | 0;
 if (i3 | 0) {
  i5 = i3 + 4 | 0;
  i1 = HEAP32[i5 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) do {
   i6 = i1 + 4 | 0;
   i7 = i1;
   i1 = HEAP32[i6 >> 2] | 0;
   HEAP32[i7 >> 2] = 0;
   HEAP32[i6 >> 2] = 0;
  } while ((i1 | 0) != (i3 | 0));
  HEAP32[i5 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i4);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13DrawImmediate10InvalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 72 >> 2] = Math_fround(1.0);
 i1 = i1 + 76 | 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z49ParticleSystem_ShapeModule_CUSTOM_GetNormalOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 60 >> 2]);
 return Math_fround(f3);
}

function __Z38HingeJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i4 = i3 + 96 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 }
}

function __Z20CompareApproximatelyRK10Matrix4x4fS1_f(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, f5 = f0, f6 = f0, i7 = 0;
 i1 = 0;
 while (1) {
  f5 = Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
  f5 = Math_fround(f5 - Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]));
  i7 = f5 < Math_fround(0.0);
  f6 = Math_fround(-f5);
  i1 = i1 + 1 | 0;
  if (!((i7 ? f6 : f5) <= f4)) {
   i1 = 0;
   i2 = 4;
   break;
  }
  if ((i1 | 0) >= 16) {
   i1 = 1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function _fdopendir(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i4 + 4 | 0;
 do if ((_fstat(i2, i1) | 0) < 0) i1 = 0; else {
  if ((HEAP32[i1 + 12 >> 2] & 61440 | 0) != 16384) {
   HEAP32[(___errno_location() | 0) >> 2] = 20;
   i1 = 0;
   break;
  }
  i1 = _calloc(1, 2072) | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i3 >> 2] = 1;
   _fcntl(i2, 2, i3) | 0;
   HEAP32[i1 >> 2] = i2;
  }
 } while (0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK22RenderingCommandBuffer10FindTempRTERKN9ShaderLab16FastPropertyNameE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 60 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i5 = 6;
   break;
  }
 }
 if ((i5 | 0) == 6) return i1 | 0;
 i5 = HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0;
 return i5 | 0;
}

function __ZNK12HandlerChain9CanHandleEPKc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i1 = i1 + -4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i4 | 0) | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == (HEAP32[i3 >> 2] | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN9GfxDevice20ImmediateTexCoordAllEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 HEAPF32[i1 + 76 >> 2] = f2;
 HEAPF32[i1 + 80 >> 2] = f3;
 HEAPF32[i1 + 84 >> 2] = f4;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAPF32[i1 + 92 >> 2] = f3;
 HEAPF32[i1 + 96 >> 2] = f4;
 HEAPF32[i1 + 100 >> 2] = f2;
 HEAPF32[i1 + 104 >> 2] = f3;
 HEAPF32[i1 + 108 >> 2] = f4;
 HEAPF32[i1 + 112 >> 2] = f2;
 HEAPF32[i1 + 116 >> 2] = f3;
 HEAPF32[i1 + 120 >> 2] = f4;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i5;
  HEAP32[i4 + 8 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx13NpRigidStatic8requiresERNS_23PxProcessPxBaseCallbackE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 20 | 0;
 i3 = i1 + 24 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 << 16 >> 16)) return;
 i4 = i1 & 65535;
 i2 = 0;
 while (1) {
  if (i1 << 16 >> 16 == 1) i1 = i5; else i1 = HEAP32[i5 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0, i6 | 0, HEAP32[i1 + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break;
  i1 = HEAP16[i3 >> 1] | 0;
 }
 return;
}

function __ZN15QualitySettings13SetVSyncCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 76 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1158216 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 i1 = __Z12GetIVRDevicev() | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190020 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 STACKTOP = i4;
 return;
}

function __Z43GUIClip_CUSTOM_INTERNAL_CALL_Unclip_Vector2R13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i5 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN12GUIClipState6UnclipERK8Vector2f(i4, i5, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z40TerrainData_CUSTOM_Internal_SetAlphamapsP12Il2CppObjectiiiiP11Il2CppArray(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __ZN13SplatDatabase12SetAlphamapsEiiiiPf(i7 + 32 | 0, i2, i3, i4, i5, __Z27scripting_array_element_ptrP11Il2CppArrayij(i6, 0, 4) | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35GameObject_Get_Custom_PropTransformP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 4 >> 2] | 0;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
 return i2 | 0;
}

function __Z33AnimatorControllerParameterToMonoRK27AnimatorControllerParameterR31MonoAnimatorControllerParameter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 HEAP32[i2 >> 2] = __Z20scripting_string_newPKcj(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP8[i2 + 16 >> 0] = HEAP8[i1 + 28 >> 0] | 0;
 return;
}

function _UNITY_png_handle_as_unknown(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if ((i1 | 0) == 0 | (i4 | 0) == 0) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 588 >> 2] | 0;
 if (!i2) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = HEAP32[i1 + 592 >> 2] | 0;
 i1 = i3 + (i2 * 5 | 0) | 0;
 while (1) {
  i2 = i1 + -5 | 0;
  if (!(_memcmp(i4, i2, 4) | 0)) break;
  if (i2 >>> 0 > i3 >>> 0) i1 = i2; else {
   i1 = 0;
   i5 = 7;
   break;
  }
 }
 if ((i5 | 0) == 7) return i1 | 0;
 i5 = HEAPU8[i1 + -1 >> 0] | 0;
 return i5 | 0;
}

function _sfnt_get_name_index(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = HEAP32[i2 + 16 >> 2] | 0;
 L1 : do if ((i5 | 0) > 0) {
  i1 = 0;
  while (1) {
   if (!(_UNITY_tt_face_get_ps_name(i2, i1, i4) | 0)) if (!(_strcmp(i3, HEAP32[i4 >> 2] | 0) | 0)) break L1;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i5 >>> 0) {
    i1 = 0;
    break;
   }
  }
 } else i1 = 0; while (0);
 STACKTOP = i6;
 return i1 | 0;
}

function __ZN9Animation22ReleaseAnimationStatesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 104 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + 108 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 do {
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1) {
   __ZN14AnimationStateD2Ev(i1);
   __ZdlPv(i1);
   i2 = HEAP32[i5 >> 2] | 0;
  }
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) != (i2 | 0));
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 12 >> 2] = Math_fround(1.0);
  HEAPF32[i4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 16 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc8BodyCore24clearSpatialAccelerationEbb(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim30notifyClearSpatialAccelerationEv(i1);
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 12 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | 2;
 if (i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
 }
 if (!i4) return;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN5physx2Sc7BodySim18onConstraintDetachEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 + 28 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 i5 = i3 + 46 | 0;
 HEAP16[i5 >> 1] = (HEAP16[i5 >> 1] | 0) + -1 << 16 >> 16;
 L1 : do if ((i4 | 0) > 0) {
  while (1) {
   if ((HEAP8[(HEAP32[i1 >> 2] | 0) + 20 >> 0] | 0) == 1) break;
   i1 = i1 + 4 | 0;
   if (i1 >>> 0 >= i2 >>> 0) break L1;
  }
  return;
 } while (0);
 i5 = i3 + 144 | 0;
 HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] & 65279;
 return;
}

function __ZN5physx2Sc24ElementInteractionMarker10initializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 8 | 0;
 i4 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0) | 0;
 i3 = i1 + 12 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i2, i4);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i1 + 16 >> 2] | 0, i2);
 return;
}

function __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferERNS_19PxAllocatorCallbackEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 152, gb + 766896 | 0, gb + 740601 | 0, 175) | 0;
 HEAP32[i3 >> 2] = gb + 147756 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 147756 + 52;
 HEAP32[i3 + 8 >> 2] = gb + 147756 + 80;
 __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEEC2ERNS_19PxAllocatorCallbackEjPS2_(i3 + 16 | 0, i1, i2, 0);
 return i3 | 0;
}

function __ZN5physx11MeshCleanerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 2 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN4crnd10dxt1_block12unpack_colorEtbj(i6, i1, i5, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 & 65535;
 i1 = i4 & 31;
 i2 = i4 >>> 5 & 63;
 i3 = i4 >>> 11;
 if (i5) {
  i3 = i3 << 3 | i4 >>> 13;
  i2 = i2 << 2 | i2 >>> 4;
  i1 = i1 << 3 | i1 >>> 2;
 }
 HEAP8[i6 >> 0] = (i3 | 0) > 255 ? 255 : i3;
 HEAP8[i6 + 1 >> 0] = (i2 | 0) > 255 ? 255 : i2;
 HEAP8[i6 + 2 >> 0] = (i1 | 0) > 255 ? 255 : i1;
 HEAP8[i6 + 3 >> 0] = (i7 | 0) < 0 ? 0 : ((i7 | 0) > 255 ? 255 : i7) & 255;
 return;
}

function __ZN18GfxFramebufferGLES36TryInvalidateDefaultFramebufferDepthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!(HEAP8[(HEAP32[gb + 1451148 >> 2] | 0) + 133 >> 0] | 0)) return;
 i2 = i1 + 168 | 0;
 i3 = HEAP32[i1 + 376 >> 2] | 0;
 if (!i3) {
  if (HEAP32[i2 >> 2] | 0) i4 = 4;
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  if ((HEAP32[i1 + 172 >> 2] | 0) != (HEAP32[i1 + 380 >> 2] | 0)) return;
  if ((i3 | 0) != (HEAP32[i2 >> 2] | 0)) return;
 }
 __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb(i1, gb + 1548969 | 0, 1);
 return;
}

function __ZN17PolygonCollider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN10Collider2D5ResetEv(i1);
 i4 = HEAP32[i1 + 160 >> 2] | 0;
 i3 = i1 + 164 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return; else i2 = i1;
 while (1) {
  i1 = i2 + -20 | 0;
  HEAP32[i3 >> 2] = i1;
  if ((HEAP32[i2 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + -16 | 0);
   HEAP32[i1 >> 2] = 0;
   i1 = HEAP32[i3 >> 2] | 0;
  }
  if ((i1 | 0) == (i4 | 0)) break; else i2 = i1;
 }
 return;
}

function __ZN14SpriteRenderer15InitializeClassEv() {
 var i1 = 0;
 if (__Z13GetIAnimationv() | 0) {
  i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 430338 | 0, 60) | 0;
  HEAP32[i1 >> 2] = gb + 59172 + 8;
  HEAP32[gb + 1161916 >> 2] = i1;
  i1 = __Z13GetIAnimationv() | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 212, 23, HEAP32[gb + 1161916 >> 2] | 0);
 }
 __Z34RegisterPrepareRenderNodesCallbackiPFvR35RenderNodeQueuePrepareThreadContextES2_PFPvvEPFvS3_E(3, fb + 3395 | 0, fb + 3396 | 0, 0, 0);
 return;
}

function __ZL38InitializeUnityConnectScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1044015 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1469184 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1044144 | 0, gb + 1044159 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 STACKTOP = i1;
 return;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z38UnityWebRequest_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 8 | 0;
 __ZN19TransportJavaScript5AbortEv(i3);
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  __ZN19TransportJavaScript5AbortEv(i3);
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63808 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function mftCall_iiiiiiiiiii(i11, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 0 | 0)) return FUNCTION_TABLE_iiiiiiiiiii[i11 - fb & 0](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0) | 0;
 return ftCall_iiiiiiiiiii(i11 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0) | 0;
}

function _unity_z_inflatePrime(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i6 = -2;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  i6 = -2;
  return i6 | 0;
 }
 if ((i5 | 0) > 16) {
  i6 = -2;
  return i6 | 0;
 }
 i3 = i2 + 60 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 + i5 | 0;
 if (i1 >>> 0 > 32) {
  i6 = -2;
  return i6 | 0;
 }
 i2 = i2 + 56 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (((1 << i5) + -1 & i6) << i4);
 HEAP32[i3 >> 2] = i1;
 i6 = 0;
 return i6 | 0;
}

function _stbir_resize_uint8_srgb_edgemode(i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(0, i1, i2, i5, i6, i7, i8, i9, i10, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i11, i12, i3, 0, 0, 0, i4, i4, 1) | 0;
}

function _socketpair(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = i5 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = 0;
 HEAP32[i7 + 20 >> 2] = 0;
 HEAP32[i6 >> 2] = 8;
 HEAP32[i6 + 4 >> 2] = i7;
 i4 = ___syscall_ret(___syscall102(102, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK11Rigidbody2D11GetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i2 + 68 >> 2] | 0) != 2) if (!(HEAP8[i2 + 226 >> 0] | 0)) {
  i2 = HEAP32[i3 + 68 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 + 64 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 + 212 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 216 >> 2];
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN8Material25AcquireSharedMaterialDataEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP8[i1 + 164 >> 0] | 0;
 if (!(i2 & 1)) i5 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i5 = 3;
 if ((i5 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i3);
  i1 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP8[i1 + 164 >> 0] | 0;
 }
 if (i2 & 2) {
  __ZN8Material12UpdateHashesEv(i3);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i5 = i1 + 4 | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZN7mecanim9animation25DestroyClipMuscleConstantEPNS0_18ClipMuscleConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 1720 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 1712 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx3Scb5Scene26preSimulateUpdateAppThreadEf(i1, f4) {
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 var i2 = 0, i3 = 0, i5 = 0;
 i2 = i1 + 16 | 0;
 i1 = __ZNK5physx2Sc5Scene20getNbParticleSystemsEv(i2) | 0;
 i2 = __ZN5physx2Sc5Scene18getParticleSystemsEv(i2) | 0;
 if (!i1) return; else i3 = 0;
 do {
  i5 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
  __ZN5physx3Scb14ParticleSystem18submitForceUpdatesEf(i5 - (HEAP32[gb + 90260 + ((HEAPU8[i5 + 10 >> 0] | 0) << 2) >> 2] | 0) | 0, f4);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i1 | 0));
 return;
}

function __ZN5physx37PxTriangleMeshGeometryGeneratedValuesC2EPKNS_22PxTriangleMeshGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP8[i2 + 28 >> 0] = HEAP8[i1 + 32 >> 0] | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 36 >> 2];
 return;
}

function __ZN5physx2Sc8BodyCore20clearSpatialVelocityEbb(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sc7BodySim26notifyClearSpatialVelocityEv(i1);
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 12 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] | 0 | 4;
 if (i3) {
  HEAP32[i1 + 32 >> 2] = 0;
  HEAP32[i1 + 36 >> 2] = 0;
  HEAP32[i1 + 40 >> 2] = 0;
 }
 if (!i4) return;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene10postSolverEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 i4 = i3 + 44 | 0;
 __ZN5physx18PxsDynamicsContext12mergeResultsEv(HEAP32[i3 + 12 >> 2] | 0);
 __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv(i4);
 HEAP32[i3 + 7596 >> 2] = __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv(i4) | 0;
 __ZN5physx2Sc5Scene16afterIntegrationEPNS_10PxBaseTaskE(i2, i1);
 __ZN5physx2Sc5Scene11afterSolverEj(i2, 0);
 return;
}

function __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh(i2, i5, i4, i9, i7, i8, i10, i11, i3, i6, i1) | 0;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN15TextureTFMethodD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77432 + 8;
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 20 | 0);
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 24 | 0);
 __ZN7ApiGLES13DeleteTextureERj(HEAP32[gb + 1451080 >> 2] | 0, i1 + 28 | 0);
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __ZN13GfxDeviceGLES23UploadSparseTextureTileE9TextureIDiiiPKhii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i9 = 0, i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1 + 4 | 0;
 i10 = i1;
 HEAP32[i10 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i9 >> 2] = HEAP32[i10 >> 2];
 __Z27UploadSparseTextureTileGLES9TextureIDiiiPKhii(i9, i3, i4, i5, i6, i7, i8);
 STACKTOP = i1;
 return;
}

function __ZN13GfxDeviceGLES15ReloadResourcesEv(i1) {
 i1 = i1 | 0;
 __ZN17BufferManagerGLES13InvalidateAllEv(__Z20GetBufferManagerGLESv() | 0);
 __ZN25TransformFeedbackSkinning31CleanupTransformFeedbackShadersEv();
 __ZN9GfxDevice15ResetAllBuffersEv(i1);
 __ZN9GfxDevice16DeleteDynamicVBOEv(i1);
 __ZN9GfxDevice13GetDynamicVBOEv(i1) | 0;
 __ZN9GfxDevice21CommonReloadResourcesEj(7);
 __ZN14GfxContextGLES10InvalidateER7ApiGLES(HEAP32[i1 + 4616 >> 2] | 0, i1 + 4620 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12SoundManager20OnExitPlayModeStaticEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i4 = __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
 i1 = HEAP32[i4 + 52 >> 2] | 0;
 i4 = i4 + 48 | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) return; else {
  i3 = i1;
  i1 = i2;
 }
 do {
  i2 = i3;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (!(HEAP8[i1 + 64 >> 0] | 0)) __ZN10SampleClip15UnloadAudioDataEv(i1) | 0; else __ZN9AudioClip6ReloadEv(i1);
  i1 = i3;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN11TypeManager14MarkDeprecatedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_(i4, i1 + 120 | 0, i5);
 HEAP8[(HEAP32[(HEAP32[i4 + 4 >> 2] | 0) + 4 >> 2] | 0) + 34 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __Z46ParticleSystem_ShapeModule_CUSTOM_GetMeshScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 64 >> 2]);
 return Math_fround(f3);
}

function __Z33RenderTexture_CUSTOM_GetTemporaryiii19RenderTextureFormat22RenderTextureReadWritei(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = __Z22GetRenderBufferManagerv() | 0;
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei(i7, i1, i2, (i3 | 0) < 1 ? 0 : (i3 | 0) < 17 ? 1 : 2, i4, 2, i5, HEAP32[i7 + 24 >> 2] | 0, i6) | 0) | 0;
}

function _Round_Super_45(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((i2 | 0) > -1) {
  i4 = HEAP32[i1 + 480 >> 2] | 0;
  i3 = i3 + i2 - i4 + (HEAP32[i1 + 484 >> 2] | 0) | 0;
  i3 = i3 - ((i3 | 0) % (HEAP32[i1 + 476 >> 2] | 0) | 0) + i4 | 0;
  return ((i3 | 0) < 0 ? i4 : i3) | 0;
 } else {
  i5 = HEAP32[i1 + 480 >> 2] | 0;
  i4 = i3 - i2 + (HEAP32[i1 + 484 >> 2] | 0) - i5 | 0;
  i4 = ((i4 | 0) % (HEAP32[i1 + 476 >> 2] | 0) | 0) - i4 - i5 | 0;
  return ((i4 | 0) > 0 ? 0 - i5 | 0 : i4) | 0;
 }
 return 0;
}

function __ZltRK8DateTimeS1_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = i5 & 65535;
 i6 = HEAP32[i4 >> 2] | 0;
 i3 = i6 & 65535;
 if ((i2 & 65535) < (i3 & 65535)) {
  i6 = 1;
  return i6 | 0;
 }
 if ((i2 & 65535) > (i3 & 65535)) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (i2 >>> 0 < i1 >>> 0) {
  i6 = 1;
  return i6 | 0;
 } else return (i2 >>> 0 <= i1 >>> 0 ? (i5 >>> 16 & 65535) < (i6 >>> 16 & 65535) : 0) | 0;
 return 0;
}

function __ZNKSt3__211__libcpp_db22__less_than_comparableEPKvS2_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 i4 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i2, i1) | 0;
 i1 = __ZNKSt3__211__libcpp_db15__find_iteratorEPKv(i2, i3) | 0;
 if (!i4) i2 = 0; else i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return (i2 | 0) != 0 & (i2 | 0) == (i1 | 0) | 0;
}

function __ZN9Rigidbody16AddNonConvexMeshER8ListNodeI12MeshColliderE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i1 + 44 | 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i3 + 4 | 0; else {
  i4 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __ZN8Animator15SetBodyPositionERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 i4 = HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i3;
 return;
}

function __ZN7ApiGLES20DrawElementsIndirectE16GfxPrimitiveTypejj(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = i2 + 912 | 0;
 if (!(HEAP8[i2 + 1992 >> 0] | 0)) i6 = 3; else if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) i6 = 3;
 if ((i6 | 0) == 3) {
  HEAP32[i1 >> 2] = i4;
  mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 36671, i4 | 0);
 }
 i6 = HEAP32[i2 + 432 >> 2] | 0;
 mftCall_viii(i6 | 0, 5123, __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i2 + 860 >> 2] | 0, i3) | 0, i5 | 0);
 return;
}

function __ZN7ApiGLES10DrawArraysE16GfxPrimitiveTypejjj(i2, i1, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!(HEAP32[i2 + 872 >> 2] | 0)) i1 = __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i2 + 860 >> 2] | 0, i1) | 0; else i1 = 14;
 if (i5 >>> 0 > 1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 495 >> 0] | 0) != 0) {
  mftCall_viiii(HEAP32[i2 + 424 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0);
  return;
 } else {
  mftCall_viii(HEAP32[i2 + 420 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0);
  return;
 }
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAPU16[i1 >> 1] | 0;
  i3 = i5 & 63488;
  HEAP32[i4 >> 2] = i5 << 27 | i3 | i5 << 22 & 117440512 | i5 << 13 & 16515072 | i5 << 7 & 196608 | i3 >>> 5 | 255;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN6CameraD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 32728 + 8;
 __ZN6Camera15ThreadedCleanupEv(i1);
 i2 = i1 + 1156 | 0;
 if ((HEAP32[i1 + 1172 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 1160 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN19RenderEventsContextD2Ev(i1 + 1136 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 832 | 0);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx17AggregateAABBTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 344 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 352 >> 2] = 0;
 HEAP32[i1 + 284 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 292 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 232 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 104 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Unity14CharacterJoint12SetSwingAxisERK8Vector3f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, 1);
 return;
}

function __ZN5Umbra11Transformer13classifyPlaneERKNS_12SIMDRegisterE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = Math_fround(HEAPF32[i3 >> 2]) > Math_fround(0.0);
 i4 = Math_fround(HEAPF32[i3 + 4 >> 2]) > Math_fround(0.0);
 i2 = Math_fround(HEAPF32[i3 + 8 >> 2]) > Math_fround(0.0);
 i3 = Math_fround(HEAPF32[i3 + 12 >> 2]) > Math_fround(0.0);
 HEAP32[i1 >> 2] = i5 << 31 >> 31;
 HEAP32[i1 + 4 >> 2] = i4 << 31 >> 31;
 HEAP32[i1 + 8 >> 2] = i2 << 31 >> 31;
 HEAP32[i1 + 12 >> 2] = i3 << 31 >> 31;
 return;
}

function __ZN4FMOD13ChannelGroupI18overrideSpeakerMixEffffffff(i1, f2, f3, f4, f5, f6, f7, f8, f9) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1;
 HEAP32[i10 >> 2] = 78;
 HEAP32[i10 + 4 >> 2] = gb + 868322;
 _printf(gb + 857490 | 0, i10) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20ArchiveStorageReader22ReadBlocksAndDirectoryER12FileAccessor(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE(i1, 0, i3 + 88 | 0) | 0;
 if (i2 | 0) {
  i3 = i2;
  return i3 | 0;
 }
 if (!(HEAP32[i3 + 80 >> 2] & 64)) i1 = 0; else i1 = __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE(i1, i3 + 8 | 0, i3 + 120 | 0) | 0;
 HEAP8[i3 + 184 >> 0] = (i1 | 0) == 0 & 1;
 i3 = i1;
 return i3 | 0;
}

function __ZN15SkyboxGenerator26ReleaseSkyboxVertexBuffersEv() {
 var i1 = 0;
 if (!(__Z11IsGfxDevicev() | 0)) return;
 if (HEAP32[gb + 1114336 >> 2] | 0) {
  i1 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, HEAP32[gb + 1114336 >> 2] | 0);
  HEAP32[gb + 1114336 >> 2] = 0;
 }
 if (!(HEAP32[gb + 1114348 >> 2] | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, HEAP32[gb + 1114348 >> 2] | 0);
 HEAP32[gb + 1114348 >> 2] = 0;
 return;
}

function __ZN12MeshCollider9SetConvexEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(i1 | (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0) ^ 1)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737019 | 0, 0, gb + 736492 | 0, 475, 1, HEAP32[i2 + 4 >> 2] | 0, 0, 0);
  return;
 }
 HEAP8[i2 + 60 >> 0] = i1 & 1;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 return;
}

function __ZN12AudioManager17RemoveAudioSourceEP11AudioSource(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i1 = i3 + 464 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 468 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = i3 + 444 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = i3 + 448 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN11ShapeModule15ReleaseMeshDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 100 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63232 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 136 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN12SkinMeshInfo10DeallocateEPS_(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z55Terrain_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 136 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45CommandBuffer_CUSTOM_IssuePluginEventInternalP12Il2CppObject13Il2Cpp_IntPtri(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer19AddIssuePluginEventEPFviEi(i1, i3, i4);
   STACKTOP = i6;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i5);
}

function __Z29Application_CUSTOM_ForceCrashi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 switch (i1 | 0) {
 case 0:
  {
   _printf_console(gb + 492925 | 0, i2);
   _llvm_trap();
   break;
  }
 case 1:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 492986 | 0, 0, gb + 492823 | 0, 582, 32785, 0, 0, 0);
   STACKTOP = i2;
   return;
  }
 case 2:
  {
   _abort();
   break;
  }
 default:
  {
   STACKTOP = i2;
   return;
  }
 }
}

function __Z24InitializeIl2CppFromMainRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_iPPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z24RegisterAllInternalCallsv();
 _il2cpp_runtime_unhandled_exception_policy_set(0);
 _il2cpp_set_commandline_arguments(i3 | 0, i4 | 0, 0);
 _il2cpp_set_config_dir(((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0);
 _il2cpp_set_data_dir(((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 _il2cpp_init(gb + 465e3 | 0);
 return 1;
}

function __Z16AsyncReadRequestP16AsyncReadCommand(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZN13OpenFileCache10OpenCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(HEAP32[gb + 1155100 >> 2] | 0, i1) | 0;
 if (!i2) {
  i3 = 2;
  i2 = i1 + 24 | 0;
  HEAP32[i2 >> 2] = i3;
  return;
 }
 i3 = i1 + 16 | 0;
 i2 = __ZN4File4ReadEyPvj(i2, HEAP32[i1 + 20 >> 2] | 0, 0, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0;
 i2 = (i2 | 0) == (HEAP32[i3 >> 2] | 0) ? 0 : 2;
 i3 = i1 + 24 | 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function mftCall_viiiiiifiii(i11, i1, i2, i3, i4, i5, i6, d7, i8, i9, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiiiiifiii[i11 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, Math_fround(d7), i8 | 0, i9 | 0, i10 | 0);
  return;
 }
 ftCall_viiiiiifiii(i11 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, +d7, i8 | 0, i9 | 0, i10 | 0);
}

function _cf2_glyphpath_closeOpenPath(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 11664 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 i3 = i1 + 11665 | 0;
 HEAP8[i3 >> 0] = 1;
 _cf2_glyphpath_lineTo(i1, HEAP32[i1 + 11736 >> 2] | 0, HEAP32[i1 + 11740 >> 2] | 0);
 i4 = i1 + 11744 | 0;
 if (HEAP8[i4 >> 0] | 0) _cf2_glyphpath_pushPrevElem(i1, i1 + 8 | 0, i1 + 11704 | 0, HEAP32[i1 + 11712 >> 2] | 0, HEAP32[i1 + 11716 >> 2] | 0, 1);
 HEAP8[i1 + 11667 >> 0] = 1;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i3 >> 0] = 0;
 HEAP8[i4 >> 0] = 0;
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getCMassLocalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 284 >> 2] & 512 | 0) == 0 ? i2 + 112 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 144 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZN5physx3Scb13ObjectTracker6insertERNS0_4BaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 i1 = __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb(i1, i5, i4) | 0;
 if (HEAP8[i4 >> 0] | 0) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN18DownloadHandlerVFSD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 187728 + 8;
 i2 = i1 + 20 | 0;
 i3 = i1 + 1080 | 0;
 if (__ZN15FileSystemEntry8IsLockedEv(i2) | 0) {
  __ZN12FileAccessor5CloseEv(i3) | 0;
  __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i2, 8, 0) | 0;
 }
 __ZN12FileAccessorD2Ev(i3);
 __ZN13FileEntryDataD2Ev(i2);
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18DownloadHandlerVFSD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 187728 + 8;
 i1 = i3 + 20 | 0;
 i2 = i3 + 1080 | 0;
 if (__ZN15FileSystemEntry8IsLockedEv(i1) | 0) {
  __ZN12FileAccessor5CloseEv(i2) | 0;
  __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i1, 8, 0) | 0;
 }
 __ZN12FileAccessorD2Ev(i2);
 __ZN13FileEntryDataD2Ev(i1);
 HEAP32[i3 >> 2] = gb + 187368 + 8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 __Z23scripting_gchandle_freej(i1);
 __ZdlPv(i3);
 return;
}

function __ZN15UnityWebRequestD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 >> 2] = gb + 187980 + 8;
 HEAP32[i3 >> 2] = i1;
 __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_(gb + 1468908 | 0, i3);
 __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev(i1);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z42GUIStyle_CUSTOM_INTERNAL_get_contentOffsetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[i1 + 264 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i1 + 260 >> 2];
   HEAP32[i3 + 4 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z41GUIClip_CUSTOM_INTERNAL_CALL_Clip_Vector2R13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i5 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN12GUIClipState4ClipERK8Vector2f(i4, i5, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z33GUITexture_Set_Custom_PropTextureP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN10GUITexture10SetTextureEP7Texture(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN10GUITexture10SetTextureEP7Texture(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29TextAsset_Get_Custom_PropTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 48 | 0;
   if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
    i2 = HEAP32[i1 >> 2] | 0;
    i2 = __Z20scripting_string_newPKc(i2) | 0;
    return i2 | 0;
   } else {
    i2 = i1;
    i2 = __Z20scripting_string_newPKc(i2) | 0;
    return i2 | 0;
   }
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z20GetPathNameExtensionPKcj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 L1 : do if (!i4) i1 = gb + 1576256 | 0; else {
  i5 = i4 + -1 | 0;
  i2 = 0;
  i1 = 0;
  L3 : while (1) {
   switch (HEAP8[i3 + (i5 + i1) >> 0] | 0) {
   case 47:
    {
     i1 = gb + 1576256 | 0;
     break L1;
    }
   case 46:
    break L3;
   default:
    {}
   }
   i1 = ~i2;
   i2 = i2 + 1 | 0;
   if (i2 >>> 0 >= i4 >>> 0) {
    i1 = gb + 1576256 | 0;
    break L1;
   }
  }
  i1 = i3 + i4 + i1 | 0;
 } while (0);
 return i1 | 0;
}

function __Z16OffsetCurveValueR17AnimationCurveTplIfEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  i1 = 0;
  do {
   i6 = i5 + (i1 << 4) + 4 | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function mftCall_viiiiiiiiii(i11, i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i11 = i11 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 if ((i11 | 0) >= (fb | 0) & (i11 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_viiiiiiiiii[i11 - fb & 15](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
  return;
 }
 ftCall_viiiiiiiiii(i11 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
}

function _cf2_initGlobalRegionBuffer(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = (HEAP32[i2 + 708 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= (HEAP32[i2 + 700 >> 2] | 0) >>> 0) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = HEAP32[i2 + 716 >> 2] | 0;
 i4 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + (i1 + 1 << 2) >> 2];
 i3 = 0;
 return i3 | 0;
}

function __ZN9UdpSocket4RecvEPvjP8sockaddrPj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 HEAP32[i1 + 36 >> 2] = i4;
 i6 = i1 + 40 | 0;
 HEAP32[i6 >> 2] = HEAP32[i5 >> 2];
 i1 = _recvfrom(HEAP32[i1 + 4 >> 2] | 0, i2, i3, HEAP32[i1 + 32 >> 2] | HEAP32[i1 + 8 >> 2], i4, i6) | 0;
 if ((i1 | 0) < 0) {
  i6 = HEAP32[i6 >> 2] | 0;
  HEAP32[i5 >> 2] = i6;
  return i1 | 0;
 }
 HEAP32[(___errno_location() | 0) >> 2] = 0;
 i6 = HEAP32[i6 >> 2] | 0;
 HEAP32[i5 >> 2] = i6;
 return i1 | 0;
}

function __ZN5physx3Ext7D6Joint16setDriveVelocityERKNS_6PxVec3ES4_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = HEAP32[i3 + 80 >> 2] | 0;
 HEAP32[i4 + 300 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 304 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 + 308 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i4 + 312 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 316 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 320 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamES3_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sn5ConvX15releaseMetaDataEv(i3);
 __ZN5physx2Sn5ConvX11resetUnionsEv(i3);
 __ZN5physx2Sn5ConvX13resetNbErrorsEv(i3);
 if (!(__ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE(i3, i2, 1) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 __ZN5physx2Sn5ConvX13resetNbErrorsEv(i3);
 i3 = (__ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE(i3, i1, 2) | 0) != 0;
 return i3 | 0;
}

function __ZN4gles27UninitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadE(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (HEAP32[i2 >> 2] | 0) __ZN7ApiGLES13DeleteProgramERj(HEAP32[gb + 1451080 >> 2] | 0, i2);
 i1 = i2 + 4 | 0;
 if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
 i1 = i2 + 8 | 0;
 if (HEAP32[i1 >> 2] | 0) __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
 i1 = i2;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN22CrashReportingSettingsD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 189340 + 8;
 i3 = i1 + 12 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  __ZdlPv(i1);
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i5;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 __ZdlPv(i1);
 STACKTOP = i4;
 return;
}

function __ZN18GfxFramebufferGLES8ActivateENS_7BuiltinEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = i2 + 16 | 0;
   break;
  }
 case 1:
  {
   i1 = i2 + 212 | 0;
   break;
  }
 case 2:
  {
   i1 = i2 + 92 | 0;
   break;
  }
 default:
  i1 = 0;
 }
 if (i3) {
  HEAP8[i1 + 56 >> 0] = 2;
  HEAP8[(HEAP32[i1 >> 2] | 0) + 28 >> 0] = 2;
  HEAP8[i1 + 72 >> 0] = 2;
  HEAP8[(HEAP32[i1 + 32 >> 2] | 0) + 28 >> 0] = 2;
 }
 __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup(i2, i1);
 return;
}

function __ZN18GfxFramebufferGLES32UpdateDefaultFramebufferViewportEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, f4 = f0;
 if (!(__Z19GetScreenManagerPtrv() | 0)) return;
 i2 = __Z16GetScreenManagerv() | 0;
 f4 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0);
 f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0);
 i2 = ~~f4 >>> 0;
 HEAP32[i1 + 436 >> 2] = i2;
 HEAP32[i1 + 388 >> 2] = i2;
 i2 = ~~f3 >>> 0;
 HEAP32[i1 + 440 >> 2] = i2;
 HEAP32[i1 + 392 >> 2] = i2;
 return;
}

function __ZN16DeveloperConsole5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 4 | 0;
 i2 = i1 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i5;
 HEAP32[i2 >> 2] = 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i5 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11UTF16StringD2Ev(i5 + 20 | 0);
  __ZdlPv(i5);
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN12_GLOBAL__N_110DataStream14addProfileZoneEPvPKc(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = gb + 149960 + 8;
 i6 = i5 + 8 | 0;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i5 + 16 >> 2] = i1;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i2, i5, 24);
 STACKTOP = i4;
 return;
}

function __ZN12EventManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 8 | 0;
 i4 = i2;
 i7 = gb + 63696 | 0;
 i6 = HEAP32[i7 + 4 >> 2] | 0;
 i5 = i4;
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN10MemoryPoolC2EbPKcii10MemLabelIdi(i1, 0, gb + 369596 | 0, 16, 4096, i3, 16);
 STACKTOP = i2;
 return;
}

function __Z49HumanPoseHandler_CUSTOM_Internal_HumanPoseHandlerP12Il2CppObjectS0_S0_(i4, i1, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i5 = 0;
 i5 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63320 | 0, 16, gb + 930128 | 0, 41) | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZN16HumanPoseHandlerC2EP6AvatarP9Transform(i5, i2, i1);
 HEAP32[i4 + 8 >> 2] = i5;
 return;
}

function __Z43ParticleSystem_ShapeModule_CUSTOM_GetRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 12 >> 2]);
 return Math_fround(f3);
}

function __Z43ParticleSystem_ShapeModule_CUSTOM_GetLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 20 >> 2]);
 return Math_fround(f3);
}

function _cf2_initLocalRegionBuffer(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 i1 = (HEAP32[i2 + 704 >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 >= (HEAP32[i2 + 696 >> 2] | 0) >>> 0) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = HEAP32[i2 + 712 >> 2] | 0;
 i4 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
 HEAP32[i3 + 12 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + (i1 + 1 << 2) >> 2];
 i3 = 0;
 return i3 | 0;
}

function __ZThn12_N5physx3Ext14SphericalJoint11prepareDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + -12 + 80 >> 2] | 0;
 if (!(HEAP16[i1 + 116 >> 1] & 2)) return i1 | 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 104 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 108 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.25))));
 return i1 | 0;
}

function __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i4 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 while (1) {
  if ((i3 | 0) == (i1 | 0)) break;
  i5 = i3 + -4 | 0;
  HEAP32[i2 >> 2] = i5;
  i3 = i5;
 }
 i2 = HEAP32[i4 >> 2] | 0;
 do if (i2 | 0) {
  i1 = HEAP32[i4 + 16 >> 2] | 0;
  if ((i1 | 0) == (i2 | 0)) {
   HEAP8[i1 + 112 >> 0] = 0;
   break;
  } else {
   __ZdlPv(i2);
   break;
  }
 } while (0);
 return;
}

function __ZNK8GUIStyle13GetLineHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = __ZNK8GUIStyle14GetCurrentFontEv(i1) | 0;
 if (!i3) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 i1 = HEAP32[i1 + 284 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 + 36 >> 2] | 0;
  if (i2 | 0) {
   f4 = Math_fround(Math_fround(Math_fround(((i1 | 0) > 500 ? 500 : i1) | 0) * Math_fround(HEAPF32[i3 + 32 >> 2])) / Math_fround(i2 | 0));
   return Math_fround(f4);
  }
 }
 f4 = Math_fround(HEAPF32[i3 + 32 >> 2]);
 return Math_fround(f4);
}

function __ZNK5Umbra14TomeCollection9getBoundsERNS_7Vector3ES2_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i1 = ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i2 = i2 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i3 = (HEAP32[i1 >> 2] | 0) + 32 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __ZN7ApiGLES17DeleteVertexArrayERN2gl6HandleILNS0_10ObjectTypeE3EEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = 3; else if ((HEAP32[i2 + 1988 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i5 = 3; else i1 = -1;
 HEAP32[i4 >> 2] = i1;
 mftCall_vii(HEAP32[i2 + 716 >> 2] | 0, 1, i4 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = -1;
 STACKTOP = i6;
 return;
}

function __ZN6Camera26CalculateMatrixShaderPropsERK10Matrix4x4fRS0_S3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 8 >> 2] = Math_fround(-1.0);
 __ZN10Matrix4x4f8SetScaleERK8Vector3f(i2, i5) | 0;
 __ZN10Matrix4x4fmLERKS_(i2, i1) | 0;
 __Z25InvertMatrix4x4_General3DPKfPf(i2, i3) | 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx3Ext23computeEllipsoidDensityERKNS_6PxVec3Ef(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f3 != Math_fround(0.0);
 f3 = i5 ? f3 : Math_fround(1.0);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 f3 = i5 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 return Math_fround(f2 / Math_fround((i1 ? f4 : f3) * Math_fround(4.18879032)));
}

function __ZN5physx14SingleAABBTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 388 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 396 >> 2] = 0;
 HEAP32[i1 + 320 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i1 + 252 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 184 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 192 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx14NpSpatialIndexC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 107520 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0;
 i2 = _PxGetFoundation() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 i2 = mftCall_iiiiii(i4 | 0, i3 | 0, 7824, (i2 ? gb + 770597 | 0 : gb + 837976 | 0) | 0, gb + 726270 | 0, 23) | 0;
 __ZN5physx2Sq10AABBPrunerC2Eb(i2, 1);
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -4 - i5 | 0) >>> 2) << 2);
   __ZdlPv(i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z52Playable_CUSTOM_INTERNAL_CALL_SetInputWeightInternalR9HPlayableRKS_f(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) return;
 if (!(__Z23ParameterValidityChecksRK9HPlayableb(i2, 0) | 0)) return;
 i1 = __ZNK8Playable12IndexOfInputEPKS_(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) | 0;
 if ((i1 | 0) < 0) return;
 __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1, f3);
 return;
}

function __Z45AnimationState_Get_Custom_PropNormalizedSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 36 >> 2]);
   f4 = Math_fround(f4 / Math_fround(HEAPF32[i1 + 92 >> 2]));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z42ParticleSystem_ShapeModule_CUSTOM_GetAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 16 >> 2]);
 return Math_fround(f3);
}

function __Z20DestroyObjectDelayedP6Objectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE(fb + 554 | 0, i2, f3, 0, Math_fround(0.0), 0, 67);
 STACKTOP = i5;
 return;
}

function _posix_fadvise(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
 HEAP32[i6 + 16 >> 2] = i3;
 HEAP32[i6 + 20 >> 2] = ((i3 | 0) < 0) << 31 >> 31;
 HEAP32[i6 + 24 >> 2] = i4;
 i4 = 0 - (___syscall272(272, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__215numpunct_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__28numpunctIwEC2Ej(i1, i3);
 HEAP32[i1 >> 2] = gb + 213108 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4588 | 0, i1 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__28numpunctIwED2Ev(i1);
  ___resumeException(i3 | 0);
 } else return;
}

function __ZNSt3__215numpunct_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__28numpunctIcEC2Ej(i1, i3);
 HEAP32[i1 >> 2] = gb + 213068 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4587 | 0, i1 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__28numpunctIcED2Ev(i1);
  ___resumeException(i3 | 0);
 } else return;
}

function __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i2, i3, i4, i5); else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 }
 return;
}

function __ZN8LODGroup25RemoveFromCachedRenderersEP8Renderer(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = i1 + 88 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i2 = HEAP32[i1 + 76 >> 2] | 0;
 i1 = 0;
 while (1) {
  i3 = i2 + (i1 << 2) | 0;
  i1 = i1 + 1 | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i4 | 0)) break;
  if (i1 >>> 0 >= i6 >>> 0) {
   i7 = 6;
   break;
  }
 }
 if ((i7 | 0) == 6) return;
 i7 = i6 + -1 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + (i7 << 2) >> 2];
 HEAP32[i5 >> 2] = i7;
 return;
}

function __ZN7mecanim9animation25DestroyControllerConstantEPNS0_18ControllerConstantERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP16[i4 + 2 >> 1] = i3;
  HEAP16[i4 + 4 >> 1] = 15360;
  HEAP16[i4 + 6 >> 1] = 15360;
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackEi(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = i3 + (i2 << 2) | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i4 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i4 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 i1 = i3 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << i2);
 i3 = i3 + 8 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN2UI14CanvasRenderer22CanvasHierarchyChangedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  HEAP32[i3 >> 2] = 0;
  return;
 } else i1 = i4;
 do {
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i1) break;
  i5 = i1 + 224 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 0 | 4;
 } while (!(HEAP32[i1 + 208 >> 2] | 0));
 __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i4, i2);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z52Playable_CUSTOM_INTERNAL_CALL_GetInputWeightInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 if (!((i2 | 0) > -1 & (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0))) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i1 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0;
 if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(HEAPF32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) >> 2]);
 return Math_fround(f3);
}

function __Z37AudioSettings_CUSTOM_GetDSPBufferSizePiS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[(__Z15GetAudioManagerv() | 0) + 88 >> 2] | 0;
 if (i3 | 0) {
  __Z15_CheckFMODError11FMOD_RESULTPKciS1_(__ZN4FMOD6System16getDSPBufferSizeEPjPi(i3, i1, i2) | 0, gb + 875076 | 0, 146, gb + 875669 | 0) | 0;
  return;
 }
 if (!(HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0)) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 875550 | 0, 0, gb + 875076 | 0, 142, 1, 0, 0, 0);
 return;
}

function __ZNK9WWWCached11GetProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (HEAP8[i1 + 84 >> 0] | 0) {
  f3 = Math_fround(1.0);
  return Math_fround(f3);
 }
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2 | 0) if (!(HEAP32[i2 + 92 >> 2] | 0)) if (HEAP32[i2 + 84 >> 2] | 0) {
  f3 = Math_fround(1.0);
  return Math_fround(f3);
 }
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0));
 return Math_fround(f3);
}

function __ZNK9DebugGLES13ActiveTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i3 + 1992 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 mftCall_vii(HEAP32[i3 + 88 >> 2] | 0, 34016, i2 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 1600 >> 2] | 0;
 i3 = (i3 | 0) == -1 ? 1 : (i3 + 33984 | 0) == (HEAP32[i2 >> 2] | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getCMassLocalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 284 >> 2] & 512 | 0) == 0 ? i2 + 112 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 144 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK12NavMeshAgent11GetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  return;
 } else {
  i2 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 540 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 544 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 548 >> 2];
  return;
 }
}

function __ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i6 = HEAP32[i2 + 40 >> 2] | 0;
 i4 = i1 + (i6 << 3) | 0;
 i2 = HEAP32[i3 + 24 >> 2] | 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 return i6 | 0;
}

function __ZN9Scripting18RaiseMonoExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 5136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 16 | 0;
 HEAP32[i5 >> 2] = i2;
 _vsnprintf(i4, 5120, i1, i5) | 0;
 i2 = __ZN11MonoManager25GetImageFromAssemblyIndexEi(__Z14GetMonoManagerv() | 0, 0) | 0;
 _il2cpp_raise_exception(_il2cpp_exception_from_name_msg(i2 | 0, HEAP32[gb + 66600 >> 2] | 0, gb + 590862 | 0, i4 | 0) | 0);
 STACKTOP = i3;
 return;
}

function __ZN7ApiGLES11BindTextureEj16TextureDimension(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i1 = i2 + 1600 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i2 + 1604 + (HEAP32[i1 >> 2] << 2) >> 2] | 0) == (i3 | 0)) return;
 i5 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i2 + 860 >> 2] | 0, i4) | 0;
 mftCall_vii(HEAP32[i2 + 812 >> 2] | 0, i5 | 0, i3 | 0);
 HEAP32[i2 + 1604 + (HEAP32[i1 >> 2] << 2) >> 2] = i3;
 HEAP32[i2 + 1732 + (HEAP32[i1 >> 2] << 2) >> 2] = i4;
 return;
}

function __ZN5physx3Ext14SphericalJointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 88796 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 88796 + 200;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext14PrismaticJointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 88228 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 88228 + 216;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN15TerrainRenderer15GetNodePositionER12QuadTreeNode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[gb + 1162364 >> 2]);
 f5 = Math_fround(HEAPF32[gb + 1162364 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[gb + 1162364 + 8 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 32 >> 2]) + f6);
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 36 >> 2]) + f5);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(HEAPF32[i2 + 40 >> 2]) + f4);
 return;
}

function __ZN14ConstantStringaSEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 8 | 0;
 i5 = i3;
 i8 = gb + 63648 | 0;
 i7 = HEAP32[i8 + 4 >> 2] | 0;
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 HEAP32[i6 + 4 >> 2] = i7;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZN13TargetJoint2D10SmartResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 i1 = __ZNK10GameObject23QueryComponentTransformEv(i1) | 0;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 __ZNK9Transform11GetPositionEv(i3, i1);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 + 84 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 88 >> 2] = i1;
 STACKTOP = i4;
 return;
}

function __ZN10Matrix3x3f18SetBasisTransposedERK8Vector3fS2_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i4 + 8 >> 2];
 return i1 | 0;
}

function __ZN10GUITextureD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 36436 + 8;
 i2 = i1 + 88 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i3 + 4 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63280 | 0);
  }
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z40ParticleSystem_ShapeModule_CUSTOM_GetArcP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 f3 = Math_fround(HEAPF32[i2 + 48 + 36 >> 2]);
 return Math_fround(f3);
}

function __Z29CanvasRenderer_CUSTOM_SetMeshP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN2UI14CanvasRenderer7SetMeshEP4Mesh(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN2UI14CanvasRenderer7SetMeshEP4Mesh(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24BillboardRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + (i3 * 360 | 0) + 188 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i5 = __Z12GetGfxDevicev() | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 188 >> 2] | 0, i5 | 0, HEAP32[i2 >> 2] | 0);
 }
 __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns(0, HEAP32[i1 + (i3 * 360 | 0) + 328 >> 2] | 0, i4);
 return;
}

function __Z12profiler_endP19ProfilerInformation(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 if (i1 | 0) if ((HEAP16[i1 + 6 >> 1] | 0) <= -1) return;
 i2 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 d3 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i2, i1, ~~d3 >>> 0, +Math_abs(d3) >= 1.0 ? (d3 > 0.0 ? ~~+Math_min(+Math_floor(d3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d3 - +(~~d3 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 return;
}

function _ps_hints_t2counter(i1, i2, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i6 = i6 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i7 = 0, i8 = 0, i9 = 0;
 i9 = i1 + 4 | 0;
 if (HEAP32[i9 >> 2] | 0) return;
 i4 = i1 + 16 | 0;
 i7 = HEAP32[i1 >> 2] | 0;
 i8 = HEAP32[i4 >> 2] | 0;
 i5 = i1 + 52 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 if ((i3 + i8 | 0) != (i2 | 0)) return;
 i1 = _ps_dimension_set_mask_bits(i4, i6, 0, i8, 0, i7) | 0;
 if (!i1) {
  i1 = _ps_dimension_set_mask_bits(i5, i6, i8, i3, 0, i7) | 0;
  if (!i1) return;
 }
 HEAP32[i9 >> 2] = i1;
 return;
}

function _pclose(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 _fclose(i1) | 0;
 do {
  HEAP32[i4 >> 2] = i3;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = 0;
  HEAP32[i4 + 12 >> 2] = 0;
  i1 = ___syscall114(114, i4 | 0) | 0;
 } while ((i1 | 0) == -4);
 if ((i1 | 0) < 0) i1 = ___syscall_ret(i1) | 0; else i1 = HEAP32[i2 >> 2] | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZN5physx3Ext20computeEllipsoidMassERKNS_6PxVec3Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = f3 != Math_fround(0.0);
 f3 = i5 ? f3 : Math_fround(1.0);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i5 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 f3 = i5 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 return Math_fround(Math_fround((i2 ? f4 : f3) * Math_fround(4.18879032)) * f1);
}

function __ZN5physx3Ext13RevoluteJointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 88500 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 88500 + 240;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext13DistanceJointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 87668 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 87668 + 228;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx13ActorAABBTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 244 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 252 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN14EmissionModule10EmitCommonER27ParticleSystemEmissionStateRjfj(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, f7 = f0;
 i5 = i1 + 4 | 0;
 f7 = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f3);
 i6 = ~~f7 >>> 0;
 HEAP32[i2 >> 2] = i6;
 HEAPF32[i5 >> 2] = Math_fround(f7 - Math_fround(i6 >>> 0));
 i5 = !(f3 >= Math_fround(.0000999999974));
 f3 = Math_fround(Math_fround(1.0) / f3);
 HEAPF32[i1 >> 2] = i5 ? Math_fround(1.0) : f3;
 return (HEAP32[i2 >> 2] | 0) + i4 | 0;
}

function __ZN11NamedObject7SetNameEPKc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 8 | 0;
 i4 = i6;
 i5 = i2 + 28 | 0;
 if (!(_strcmp(HEAP32[i5 >> 2] | 0, i3) | 0)) {
  STACKTOP = i6;
  return;
 }
 __ZNK6Object14GetMemoryLabelEv(i4, i2);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN14ConstantString6assignEPKc10MemLabelId(i5, i3, i1);
 STACKTOP = i6;
 return;
}

function __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z13TransferFieldI17RemapPPtrTransferLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z47CommandBuffer_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectS0_iS0_iP11Il2CppArrayiS0_(i5, i6, i1, i7, i2, i3, i4, i8) {
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (i5 | 0) if (HEAP32[i5 + 8 >> 2] | 0) {
  if (!i8) {
   STACKTOP = i2;
   return;
  }
  STACKTOP = i2;
  return;
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i1);
}

function __Z46Camera_CUSTOM_INTERNAL_get_worldToCameraMatrixP12Il2CppObjectP10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = __ZNK6Camera22GetWorldToCameraMatrixEv(i3) | 0;
   i3 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    i2 = i2 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39CommandBuffer_CUSTOM_ReleaseTemporaryRTP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer16AddReleaseTempRTERKN9ShaderLab16FastPropertyNameE(i1, i3);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z27GetBlendShapeNameFromScriptRK4Meshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((i2 | 0) >= 0) if (((HEAP32[i1 + 116 >> 2] | 0) - (HEAP32[i1 + 112 >> 2] | 0) >> 4 | 0) > (i2 | 0)) {
  i3 = __Z20scripting_string_newPKc(__Z14GetChannelNameRK14BlendShapeDatai(i1 + 72 | 0, i2) | 0) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i3);
 return 0;
}

function __Z26TerrainData_CUSTOM_AddUserP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN11TerrainData7AddUserEP10GameObject(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN11TerrainData7AddUserEP10GameObject(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21IsAssetBundleFilenameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 11 | 0;
 if (__Z10BeginsWithPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, gb + 368404 | 0) | 0) {
  i2 = 1;
  return i2 | 0;
 }
 if (__Z10BeginsWithPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, gb + 366730 | 0) | 0) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __Z10BeginsWithPKcS0_((HEAP8[i2 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, gb + 366748 | 0) | 0;
 return i2 | 0;
}

function __Z15OffsetCurveTimeR17AnimationCurveTplIfEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i5 = HEAP32[i2 + 56 >> 2] | 0;
  i1 = 0;
  do {
   i6 = i5 + (i1 << 4) | 0;
   HEAPF32[i6 >> 2] = Math_fround(Math_fround(HEAPF32[i6 >> 2]) + f3);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i4 | 0));
 }
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function _herror(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[gb + 191628 >> 2] | 0;
 i5 = (i1 | 0) != 0;
 i6 = i5 ? i1 : gb + 1576256 | 0;
 i5 = i5 ? gb + 1084762 | 0 : gb + 1576256 | 0;
 i1 = _hstrerror(HEAP32[(___h_errno_location() | 0) >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i6;
 HEAP32[i3 + 4 >> 2] = i5;
 HEAP32[i3 + 8 >> 2] = i1;
 _fprintf(i4, gb + 1074145 | 0, i3) | 0;
 STACKTOP = i2;
 return;
}

function _cff_index_get_sid_string(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if ((i3 | 0) == 65535) {
  i3 = 0;
  return i3 | 0;
 }
 if (i3 >>> 0 > 390) {
  i1 = i3 + -391 | 0;
  if ((HEAP32[i2 + 1312 >> 2] | 0) >>> 0 <= i1 >>> 0) {
   i3 = 0;
   return i3 | 0;
  }
  i3 = HEAP32[(HEAP32[i2 + 1316 >> 2] | 0) + (i1 << 2) >> 2] | 0;
  return i3 | 0;
 } else {
  i1 = HEAP32[i2 + 2956 >> 2] | 0;
  if (!i1) {
   i3 = 0;
   return i3 | 0;
  }
  i3 = mftCall_ii(HEAP32[i1 + 20 >> 2] | 0, i3 | 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZSt9terminatev() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(fb + 324 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
 if (i1 | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) {
   i2 = i1 + 48 | 0;
   if ((HEAP32[i2 >> 2] & -256 | 0) == 1126902528 ? (HEAP32[i2 + 4 >> 2] | 0) == 1129074247 : 0) __ZSt11__terminatePFvvE(HEAP32[i1 + 12 >> 2] | 0);
  }
 }
 __ZSt11__terminatePFvvE(__ZSt13get_terminatev() | 0);
}

function __ZNK10Collider2D13GetBouncinessEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!(HEAP32[i1 + 72 >> 2] | 0)) {
  __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i1, i3 + 4 | 0, i2);
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  STACKTOP = i3;
  return Math_fround(f4);
 } else {
  f4 = Math_fround(HEAPF32[(HEAP32[HEAP32[i1 + 60 >> 2] >> 2] | 0) + 40 >> 2]);
  STACKTOP = i3;
  return Math_fround(f4);
 }
 return f0;
}

function __ZN5physx29EntityReportContainerCallback7onEventEjPj(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i5 | 0) != 0 & (i4 | 0) != 0)) return 1;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 + i5 | 0) >>> 0 > (HEAP32[i2 >> 2] | 0) >>> 0) {
  __ZN5physx2Gu9Container6ResizeEj(i2, i5) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 _memcpy((HEAP32[i2 + 8 >> 2] | 0) + (i1 << 2) | 0, i4 | 0, i5 << 2 | 0) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i5;
 return 1;
}

function __ZN5physx20PxsParticleSystemSim24packetShapesFinalizationEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 1296 | 0;
 __ZN5physx20PxsParticleSystemSim20remapShapesToPacketsEPKPNS_16PxvParticleShapeEj(i2, HEAP32[i1 >> 2] | 0, HEAP32[i2 + 1300 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1);
 STACKTOP = i3;
 return;
}

function __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 49852 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 64) {
  STACKTOP = i3;
  return;
 }
 i2 = i2 + 49844 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, 512, gb + 676016 | 0, 267) | 0;
 HEAP32[i1 >> 2] = 64;
 STACKTOP = i3;
 return;
}

function __ZN23ParticleSystemParticles20SetUsesTriggerEventsEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i4 + 876 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 i3 = i4 + 720 | 0;
 if (i2) {
  __ZN14dynamic_bitset6resizeEjb(i3, HEAP32[i4 + 12 >> 2] | 0, 0);
  return;
 }
 i1 = i4 + 728 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 732 >> 2] = 0;
 HEAP32[i4 + 736 >> 2] = 0;
 return;
}

function __ZN15ParticleEmitter24UpdateAllParticleSystemsEv() {
 var i1 = 0, i2 = 0, f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
 if (f3 < Math_fround(.0000999999974) | (__Z14IsWorldPlayingv() | 0) ^ 1) return;
 i1 = HEAP32[gb + 1469400 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (gb + 1469400 | 0)) return;
 do {
  i4 = i1;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  __ZN15ParticleEmitter20UpdateParticleSystemEf(HEAP32[i4 + 8 >> 2] | 0, f3);
  i2 = i1;
 } while ((i2 | 0) != (gb + 1469400 | 0));
 return;
}

function __ZN12SkinMeshInfo10DeallocateEPS_(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) return;
 i1 = i2 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i1);
 i1 = HEAP32[i2 + 100 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
  if (!(HEAP32[i3 >> 2] | 0)) {
   mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
   __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63232 | 0);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
 return;
}

function __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 __ZN10Collider2D19WakeAllBodyContactsEv(i1);
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 if (i4 | 0) if (__ZNK10GameObject8IsActiveEv(i4) | 0) {
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
  __ZN10Collider2D7CleanupEb(i1, i4 & i2);
  if (!i4) return;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i3 | 0);
  return;
 }
 __ZN10Collider2D7CleanupEb(i1, 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z4InitR13CImageSurfaceiii(i6, i2, i3, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i7 = 0, i8 = 0;
 HEAP32[i6 >> 2] = i2;
 i4 = i6 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 i7 = i6 + 8 | 0;
 HEAP32[i7 >> 2] = i1;
 i8 = i6 + 12 | 0;
 i5 = HEAP32[i8 >> 2] | 0;
 if (i5) {
  __ZdaPv(i5);
  i3 = HEAP32[i4 >> 2] | 0;
  i2 = HEAP32[i6 >> 2] | 0;
  i1 = HEAP32[i7 >> 2] | 0;
 }
 i7 = Math_imul(Math_imul(i3, i2) | 0, i1) | 0;
 HEAP32[i8 >> 2] = __Znaj(i7 >>> 0 > 1073741823 ? -1 : i7 << 2) | 0;
 return;
}

function __Z45Application_Get_Custom_PropTemporaryCachePathv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z40GetTemporaryCachePathApplicationSpecificv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z45Application_Get_Custom_PropPersistentDataPathv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z40GetPersistentDataPathApplicationSpecificv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z21Event_CUSTOM_InitCopyP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63864 | 0, 16, gb + 1019057 | 0, 54) | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN10InputEventC2ERKS_(i3, i1);
   HEAP32[i2 + 8 >> 2] = i3;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z21CountTrianglesInStripIjEiPKT_i(i6, i1) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i7 = 0;
 i7 = i1 + -2 | 0;
 if ((i1 | 0) <= 2) {
  i7 = 0;
  return i7 | 0;
 }
 i3 = 0;
 i1 = 0;
 i4 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 while (1) {
  i5 = HEAP32[i6 + (i3 + 2 << 2) >> 2] | 0;
  i3 = i3 + 1 | 0;
  i1 = (((i4 | 0) == (i5 | 0) | ((i2 | 0) == (i4 | 0) | (i2 | 0) == (i5 | 0))) & 1 ^ 1) + i1 | 0;
  if ((i3 | 0) == (i7 | 0)) break; else {
   i2 = i4;
   i4 = i5;
  }
 }
 return i1 | 0;
}

function _UNITY_FT_Vector_Transform(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 i4 = _UNITY_FT_MulFix(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 i3 = i1 + 4 | 0;
 i4 = (_UNITY_FT_MulFix(HEAP32[i3 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0) + i4 | 0;
 i5 = _UNITY_FT_MulFix(HEAP32[i1 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0) | 0;
 i2 = (_UNITY_FT_MulFix(HEAP32[i3 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0) + i5 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN5physx2Sn13XmlNodeReader11removeChildEPKc(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[(HEAP32[i3 + 12 >> 2] | 0) + 16 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, i2) | 0)) break;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = 5;
   break;
  }
 }
 if ((i4 | 0) == 5) return i1 | 0;
 __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE(HEAP32[i3 + 8 >> 2] | 0, i1);
 i4 = 1;
 return i4 | 0;
}

function __ZN5physx2Sc5Actor15onElementDetachERNS0_7ElementE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i3 = i1 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return; else i2 = 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i2) {
   i5 = 7;
   break;
  } else {
   i6 = i1;
   i1 = i2;
   i2 = i6;
  }
 }
 if ((i5 | 0) == 7) return;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = i1;
  return;
 } else {
  HEAP32[i2 + 4 >> 2] = i1;
  return;
 }
}

function __ZN5physx2Sc10StaticCore14setActor2WorldERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 24 >> 2];
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc9StaticSim21postActor2WorldChangeEv(i1);
 return;
}

function __ZN5physx2Gu17RadixSortBufferedD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 86392 + 8;
 if (!(HEAP8[i1 + 32 >> 0] | 0)) {
  STACKTOP = i2;
  return;
 }
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[i2 >> 2] = 0;
 __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi(i1, i2);
 i2 = HEAP32[i2 >> 2] | 0;
 if (!i2) {
  STACKTOP = i3;
  return;
 }
 __ZN9Transform20SendTransformChangedEi(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28980 | 0) | 0, i2);
 STACKTOP = i3;
 return;
}

function __ZN22UnityProfilerPerThread10InitializeEPKcS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1451e3 >> 2] | 0, 0, 0) | 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(288, gb + 63576 | 0, 16, gb + 461711 | 0, 70) | 0;
 __ZN22UnityProfilerPerThreadC2EPKcS1_(i4, i1, i2);
 HEAP32[gb + 1163228 >> 2] = i4;
 __ZN13UnityProfiler20AddPerThreadProfilerEP22UnityProfilerPerThread(HEAP32[gb + 1451e3 >> 2] | 0, i4);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ReflectionProbe17RemoveFromManagerEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i6 + 4 | 0;
 i4 = i6;
 i5 = HEAP32[gb + 1112272 >> 2] | 0;
 if (!i3) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 __ZN16ReflectionProbes11RemoveProbeE4PPtrI15ReflectionProbeE(i5, i1);
 __ZN15ReflectionProbe19ClearRenderTexturesEv(i3);
 STACKTOP = i6;
 return;
}

function __ZN13RenderTexture15OnUpdateExtentsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, f6 = f0;
 i5 = i1 + 76 | 0;
 HEAP32[i5 >> 2] = 1;
 i3 = HEAP32[i1 + 80 >> 2] | 0;
 if (!i3) return;
 i4 = HEAP32[i1 + 84 >> 2] | 0;
 if (!i4) return;
 f6 = Math_fround(Math_fround(1.0) / Math_fround(i4 | 0));
 HEAPF32[i1 + 68 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(i3 | 0));
 HEAPF32[i1 + 72 >> 2] = f6;
 if (i2) i1 = __Z22CalculateMipMapCount3Diii(i3, i4, 1) | 0; else i1 = 1;
 HEAP32[i5 >> 2] = i1;
 return;
}

function __ZN11Rigidbody2D14SetConstraintsENS_11ConstraintsE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 52 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 if (HEAP32[i3 + 92 >> 2] | 0) {
  __ZN11Rigidbody2D17UpdateConstraintsEb(i3, 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if (!i1) return;
 if ((HEAP32[i3 + 68 >> 2] | 0) != 2) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 808078 | 0, 0, gb + 807613 | 0, 833, 512, HEAP32[i3 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZL28InitializeUIScriptingClassesv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1012556 | 0, 16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1468152 >> 2] = i2;
 __Z13RequireMethodPKcS0_S0_S0_(i3, gb + 1049781 | 0, gb + 1049797 | 0, gb + 1012675 | 0, gb + 1012682 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 STACKTOP = i1;
 return;
}

function __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z47Terrain_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 120 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45AnimationState_Set_Custom_PropNormalizedSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f2 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * f2);
   HEAPF32[i1 + 36 >> 2] = f2;
   HEAPF32[i1 + 40 >> 2] = f2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function _gzgets(i4, i5, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if ((i5 | 0) == 0 | (i1 | 0) < 1) {
  i5 = 0;
  return i5 | 0;
 } else {
  i2 = i1;
  i1 = i5;
 }
 while (1) {
  if ((i2 | 0) <= 1) {
   i2 = 0;
   break;
  }
  if ((_gzread(i4, i1, 1) | 0) != 1) {
   i2 = 1;
   break;
  }
  i3 = i1 + 1 | 0;
  if ((HEAP8[i1 >> 0] | 0) == 10) {
   i1 = i3;
   i2 = 1;
   break;
  } else {
   i2 = i2 + -1 | 0;
   i1 = i3;
  }
 }
 HEAP8[i1 >> 0] = 0;
 i5 = i2 & (i1 | 0) == (i5 | 0) ? 0 : i5;
 return i5 | 0;
}

function _bsearch(i6, i1, i2, i7, i8) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 L1 : do if (!i2) i1 = 0; else {
  i5 = i1;
  while (1) {
   i4 = i2 >>> 1;
   i1 = i5 + (Math_imul(i4, i7) | 0) | 0;
   i3 = mftCall_iii(i8 | 0, i6 | 0, i1 | 0) | 0;
   if (!i3) break L1;
   if ((i2 | 0) == 1) {
    i1 = 0;
    break L1;
   }
   i3 = (i3 | 0) < 0;
   i2 = i3 ? i4 : i2 - i4 | 0;
   if (!i2) {
    i1 = 0;
    break;
   } else i5 = i3 ? i5 : i1;
  }
 } while (0);
 return i1 | 0;
}

function __ZNK10Collider2D11GetFrictionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 4 | 0;
 if (!(HEAP32[i1 + 72 >> 2] | 0)) {
  __ZNK10Collider2D24GetColliderMaterialStateERfS0_(i1, i2, i3);
  f4 = Math_fround(HEAPF32[i2 >> 2]);
  STACKTOP = i3;
  return Math_fround(f4);
 } else {
  f4 = Math_fround(HEAPF32[(HEAP32[HEAP32[i1 + 60 >> 2] >> 2] | 0) + 36 >> 2]);
  STACKTOP = i3;
  return Math_fround(f4);
 }
 return f0;
}

function __ZN9Animation12CleanupClassEv() {
 var i1 = 0;
 HEAP32[gb + 1466576 >> 2] = 0;
 i1 = HEAP32[gb + 1465160 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63320 | 0);
 HEAP32[gb + 1465160 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(__Z33GetIAnimationStateNetworkProviderv() | 0, gb + 63400 | 0);
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(0);
 return;
}

function __ZN7ApiGLES18DrawArraysIndirectE16GfxPrimitiveTypejj(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = i2 + 912 | 0;
 if (!(HEAP8[i2 + 1992 >> 0] | 0)) i6 = 3; else if ((HEAP32[i1 >> 2] | 0) != (i4 | 0)) i6 = 3;
 if ((i6 | 0) == 3) {
  HEAP32[i1 >> 2] = i4;
  mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 36671, i4 | 0);
 }
 i6 = HEAP32[i2 + 428 >> 2] | 0;
 mftCall_vii(i6 | 0, __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i2 + 860 >> 2] | 0, i3) | 0, i5 | 0);
 return;
}

function __ZN5physx3Ext10FixedJointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 87952 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 87952 + 188;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2 + 49840 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 64) {
  STACKTOP = i3;
  return;
 }
 i2 = i2 + 49832 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3 + 1 | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, 512, gb + 676016 | 0, 257) | 0;
 HEAP32[i1 >> 2] = 64;
 STACKTOP = i3;
 return;
}

function __ZN2UI6Canvas22CanvasHierarchyChangedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = i3 + 4 | 0;
 if ((i1 | 0) != (HEAP32[i3 >> 2] | 0)) do {
  i4 = HEAP32[i1 >> 2] | 0;
  i5 = i4 + 224 | 0;
  HEAP16[i5 >> 1] = HEAPU16[i5 >> 1] | 4;
  __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv(i4);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 if (!(HEAP8[i2 + 33 >> 0] | 0)) return;
 __ZN2UI6Canvas19SyncTransformParentEv(i2);
 return;
}

function __ZN15AudioEchoFilter6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 __ZN4FMOD3DSP12setParameterEif(i3, 0, Math_fround((HEAP32[i1 + 44 >> 2] | 0) >>> 0)) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 1, Math_fround(HEAPF32[i1 + 48 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 3, Math_fround(HEAPF32[i1 + 52 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 4, Math_fround(HEAPF32[i1 + 56 >> 2])) | 0;
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings8GetValueERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) | 0;
 return ((i2 | 0) != (i1 + 4 | 0) ? i2 + 48 | 0 : 0) | 0;
}

function __ZN11MatrixStack4PushEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 1024 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) > 15) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407034 | 0, 0, gb + 407066 | 0, 20, 1, 0, 0, 0);
  return;
 } else {
  HEAP32[i1 >> 2] = i3 + 1;
  i4 = i2 + (i3 << 6) | 0;
  i1 = i2 + (i3 + -1 << 6) | 0;
  i2 = i4 + 64 | 0;
  do {
   HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i4 | 0) < (i2 | 0));
  return;
 }
}

function __Z42GenericMixerPlayable_CUSTOM_InternalCreateR9HPlayable(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __Z18GetDirectorManagerv() | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63784 | 0, 16, gb + 913955 | 0, 26) | 0;
 __ZN8PlayableC2E18DirectorPlayerType(i3, 3);
 __ZN8Playable6HandleEv(i4, i3);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z38Event_CUSTOM_Internal_GetMousePositionP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[i1 + 8 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i1 + 4 >> 2];
   HEAP32[i3 + 4 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __ZNK32RendererMaterialAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName15InitBy28BitHashEj(i2, i3 & 268435455);
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2] & 268435455 | i3 & -268435456;
 STACKTOP = i1;
 return 100002;
}

function __ZN8VRDevice8SetPauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) return;
 if (!i2) {
  i1 = __Z12GetGfxDevicev() | 0;
  if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 520 >> 2] | 0, i1 | 0) | 0)) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1044318 | 0, 0, gb + 1044184 | 0, 781, 4, 0, 0, 0);
 }
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 860 >> 2] | 0, i1 | 0, 6, i2 & 1 | 0);
 return;
}

function __ZN8UserList11SendMessageERK17MessageIdentifierR11MessageData(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0, i7 = 0;
 i6 = i1 + 16 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 i3 = i1 + 4 | 0;
 i1 = i2;
 do {
  i2 = i1 + -1 | 0;
  __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData(HEAP32[HEAP32[(HEAP32[i3 >> 2] | 0) + (i2 << 3) >> 2] >> 2] | 0, i4, i5);
  i7 = HEAP32[i6 >> 2] | 0;
  i1 = (i7 | 0) < (i2 | 0) ? i7 : i2;
 } while ((i1 | 0) > 0);
 return;
}

function __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (!i1) {
  i4 = -1;
  return i4 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 4 | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0) == (i3 | 0)) {
   i2 = 6;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN5physx8debugger4comm20StreamPropMessageArg9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z46Quaternion_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK11QuaternionfS1_fRS_(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __Z5SlerpRK11QuaternionfS1_f(i6, i1, i2, f3);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i6 + 12 >> 2];
 STACKTOP = i5;
 return;
}

function __Z35Event_CUSTOM_Internal_GetMouseDeltaP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i5 = HEAP32[i1 + 16 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i1 + 12 >> 2];
   HEAP32[i3 + 4 >> 2] = i5;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z31Texture2D_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i2 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  return i2 | 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z30Skybox_Set_Custom_PropMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN6Skybox11SetMaterialEP8Material(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN6Skybox11SetMaterialEP8Material(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27Input_CUSTOM_GetMouseButtoni(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 >>> 0 < 7) {
  i4 = __Z15GetInputManagerv() | 0;
  i1 = i1 + 323 | 0;
  i3 = i1 >>> 5;
  STACKTOP = i2;
  return ((HEAP32[(HEAP32[i4 + 48 >> 2] | 0) + (i3 << 2) >> 2] | HEAP32[(HEAP32[i4 + 68 >> 2] | 0) + (i3 << 2) >> 2]) & 1 << (i1 & 31) | 0) != 0 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536733 | 0, i2);
 return 0;
}

function __Z10InAddrToIPP11sockaddr_in(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 i2 = _inet_ntoa(i4) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 STACKTOP = i3;
 return;
}

function __ZN8Animator15SetPlaybackTimeEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 if ((HEAP32[i2 + 548 >> 2] | 0) != 1) return;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) i1 = 4; else if (!(HEAP32[i2 + 168 >> 2] | 0)) i1 = 4;
 if ((i1 | 0) == 4) __ZN8Animator12CreateObjectEv(i2);
 if (HEAP32[i2 + 108 >> 2] | 0) {
  i1 = HEAP32[i2 + 624 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i2 + 420 >> 2];
  }
 }
 __ZN8Animator23SetPlaybackTimeInternalEf(i2, f3);
 return;
}

function __ZN7b2World10CreateBodyEPK9b2BodyDef(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (HEAP32[i3 + 102868 >> 2] & 2 | 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN16b2BlockAllocator8AllocateEi(i3, 152) | 0;
 __ZN6b2BodyC2EPK9b2BodyDefP7b2World(i4, i1, i3);
 HEAP32[i4 + 92 >> 2] = 0;
 i1 = i3 + 102956 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 96 >> 2] = i2;
 if (i2 | 0) HEAP32[i2 + 92 >> 2] = i4;
 HEAP32[i1 >> 2] = i4;
 i3 = i3 + 102964 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return i4 | 0;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5Umbra11PatchWriter5patchEPKviS2_S2_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = i3;
 HEAP32[i7 + 4 >> 2] = i4 - i2;
 HEAP32[i7 + 8 >> 2] = i5 - (HEAP32[i1 + 4 >> 2] | 0);
 i5 = HEAP32[i1 >> 2] | 0;
 i5 = (mftCall_iiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i7 | 0, 12) | 0) == 12;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZN4FMOD8ChannelI13setSpeakerMixEffffffff(i1, f2, f3, f4, f5, f6, f7, f8, f9) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 var i10 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i10 = i1;
 HEAP32[i10 >> 2] = 78;
 HEAP32[i10 + 4 >> 2] = gb + 868743;
 _printf(gb + 857490 | 0, i10) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17UniqueIDGenerator17DestroyAllIndicesEv(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i6 = 0, i7 = 0;
 i6 = i5 + 12 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 <= 1) return;
 i7 = i5 + 20 | 0;
 i4 = 1;
 do {
  i2 = (HEAP32[i5 >> 2] | 0) + (i4 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if ((i3 & 16777215 | 0) == (i4 | 0)) {
   HEAP32[i2 >> 2] = i3 & -16777216 | HEAP32[i7 >> 2] & 16777215;
   HEAP32[i7 >> 2] = i4;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < i1 >>> 0);
 return;
}

function __ZN16DeveloperConsole10DrawButtonER8GUIStateRK5RectTIfERK11UTF16String(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = i1 + 76 | 0;
 __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i5, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
 HEAP8[i1 + 84 >> 0] = 0;
 i4 = HEAP32[i1 + 124 >> 2] | 0;
 return __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i2, i3, i5, i4, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i2, 2001146706, 0, i3, 1) | 0) | 0;
}

function __ZN13ComputeShader25GetKernelThreadGroupSizesEjPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, 22, 0) | 0;
 i1 = HEAP32[i4 + 8 >> 2] | 0;
 if ((((HEAP32[i4 + 12 >> 2] | 0) - i1 | 0) / 96 | 0) >>> 0 <= i2 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + (i2 * 96 | 0) + 84 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i4 = 1;
 return i4 | 0;
}

function __ZN10RenderLoopD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 80 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 84 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -12 - i2 | 0) >>> 0) / 12 | 0) * 12 | 0);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 72 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -12 - i3 | 0) >>> 0) / 12 | 0) * 12 | 0);
 __ZdlPv(i3);
 return;
}

function __ZNSt3__215recursive_mutex6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2796 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
 if (!i1) return; else {
  __THREW__ = 0;
  invoke_viiii(fb + 363 | 0, gb + 1082411 | 0, gb + 1082291 | 0, 102, gb + 1082369 | 0);
  __THREW__ = 0;
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
}

function __ZNK9Heightmap9GetHeightEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 i5 = HEAP32[i1 + 76 >> 2] | 0;
 f4 = Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) / Math_fround(32766.0));
 i6 = (HEAP32[i1 + 72 >> 2] | 0) + -1 | 0;
 i7 = i5 + -1 | 0;
 i3 = ((i3 | 0) < 0 ? 0 : (i7 | 0) < (i3 | 0) ? i7 : i3) + (Math_imul((i2 | 0) < 0 ? 0 : (i6 | 0) < (i2 | 0) ? i6 : i2, i5) | 0) | 0;
 return Math_fround(f4 * Math_fround(HEAP16[(HEAP32[i1 + 4 >> 2] | 0) + (i3 << 1) >> 1] | 0));
}

function __ZN9Behaviour18UpdateEnabledStateEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (i1) {
  i4 = HEAP16[i3 + 32 >> 1] | 0;
  i2 = (i4 & 255) << 24 >> 24 != 0;
  i1 = i3 + 33 | 0;
  if (!(i2 ^ (i4 & 65535) > 255)) return;
  if (i2) {
   HEAP8[i1 >> 0] = 1;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i3 | 0);
   return;
  }
 } else {
  i1 = i3 + 33 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) return;
 }
 HEAP8[i1 >> 0] = 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0);
 return;
}

function __ZN8WindZone12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 1170608 >> 2] | 0;
 i4 = i1 + 60 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = i1 + 64 | 0; else {
  i1 = i1 + 64 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB565EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAPU16[i1 >> 1] | 0;
  i3 = i5 << 3 & 1920;
  HEAP16[i4 >> 1] = i5 << 1 & 30 | i5 & 2048 | i5 >>> 3 & 1 | i5 << 4 & 61440 | i3 | i3 >>> 4 & 96;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx2Sn5ConvX10initOutputERNS_14PxOutputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 304 >> 2] = i1;
 HEAP32[i2 + 312 >> 2] = 0;
 HEAP8[i2 + 324 >> 0] = 0;
 HEAP8[i2 + 325 >> 0] = 0;
 i3 = __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i2, 1) | 0;
 i1 = __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i2, 2) | 0;
 HEAP32[i2 + 316 >> 2] = HEAP32[i3 + 44 >> 2];
 HEAP32[i2 + 320 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP8[i2 + 308 >> 0] = HEAP8[i1 + 60 >> 0] | 0;
 return 1;
}

function __ZN5Umbra20RuntimeTomeGenerator6Result5clearEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (i1) {
  i2 = HEAP32[i4 >> 2] | 0;
  i1 = i4 + 4 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) i2 = i4; else {
   mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 + (0 - (HEAP32[i3 + -4 >> 2] | 0)) | 0);
   i2 = i4;
  }
 } else {
  i2 = i4;
  i1 = i4 + 4 | 0;
 }
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN29DelayedPointerDeletionManager32CleanupPendingMainThreadPointersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i3 = i2 + 4 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i4 = i2 + 16 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[i4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 16 >> 2] | 0, i5 | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN21UniformBufferTFMethod13MapBoneBufferEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (__Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i2) | 0) {
  __ZN14DataBufferGLES7ReleaseEv(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i3 = i3 << 2;
 i2 = __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb(__Z20GetBufferManagerGLESv() | 0, i3, 8, 0) | 0;
 HEAP32[i1 >> 2] = i2;
 return __ZN14DataBufferGLES3MapEiij(i2, 0, i3, 10) | 0;
}

function __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 4 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 < (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 1);
  __ZN19StreamedBinaryWriteILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN19RuntimeSceneManager21FindSceneByBuildIndexEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 L1 : do if (i4) {
  while (1) {
   if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0) == (i3 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 return i4 | 0;
}

function __ZN19CharacterController5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 72 >> 2] = Math_fround(.00100000005);
 HEAP32[i1 + 76 >> 2] = 1034147594;
 HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 88 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 80 >> 2] = Math_fround(45.0);
 return;
}

function __ZN17MemoryCacheReader14LockCacheBlockEjPPhS1_(i4, i1, i5, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 << 8;
 if ((HEAP32[i2 + 12 >> 2] | 0) >>> 0 > i3 >>> 0) i1 = (HEAP32[i2 >> 2] | 0) + i3 | 0; else i1 = 0;
 HEAP32[i5 >> 2] = i1;
 i5 = (mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 28 >> 2] | 0, i4 | 0) | 0) - i3 | 0;
 HEAP32[i6 >> 2] = i1 + ((i5 | 0) > 256 ? 256 : i5);
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = (HEAP32[i6 >> 2] | 0) + 1;
 return;
}

function __ZN12ImageFilters23SetupRenderTargetCommonER9GfxDeviceP7TextureP13RenderTextureNS_9BlitFlagsE11CubemapFace(i2, i1, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i1) i1 = 0; else i1 = (HEAP32[i1 + 88 >> 2] | 0) > 1;
 if (!((i4 & 1 | 0) != 0 | i1 | (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 780 >> 2] | 0, i2 | 0) | 0))) return;
 __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace(i3, i1 ? 2 : 0, i5);
 return;
}

function __ZN11UnityEngine15PlatformWrapper16GenerateRandomIdEv() {
 var i1 = 0, i2 = 0, d3 = 0.0;
 d3 = +_emscripten_get_now() * 1.0e6;
 i2 = __Z17TimeToNanosecondsy(~~d3 >>> 0, +Math_abs(d3) >= 1.0 ? (d3 > 0.0 ? ~~+Math_min(+Math_floor(d3 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d3 - +(~~d3 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 getTempRet0() | 0;
 i1 = (Math_imul(i2, 1790253981) | 0) + 1900727103 | 0;
 i2 = i2 << 11 ^ i2;
 i1 = i1 ^ i2 ^ i2 >>> 8 ^ i1 >>> 19;
 setTempRet0(i1 & 2147483647 | 0);
 return i1 | 0;
}

function __ZL19empty_output_bufferP20jpeg_compress_struct(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 if (!i1) {
  i1 = i3 + 36 | 0;
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
  i1 = i3 + 24 | 0;
  i2 = i3 + 20 | 0;
 } else {
  i2 = i3 + 20 | 0;
  i4 = i3 + 24 | 0;
  mftCall_viii(i1 | 0, HEAP32[i3 + 40 >> 2] | 0, HEAP32[i2 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  i1 = i4;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 return 1;
}

function __Z43Camera_CUSTOM_INTERNAL_get_projectionMatrixP12Il2CppObjectP10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = __ZNK6Camera19GetProjectionMatrixEv(i3) | 0;
   i3 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    i2 = i2 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Cubemap_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[i2 + 52 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i2 + 92 >> 2] | 0;
  i2 = (i2 | 0) == -1 ? 5 : i2;
  return i2 | 0;
 } else {
  i2 = HEAP32[i1 + 36 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z24CullingGroup_CUSTOM_InitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63600 | 0, 16, gb + 510287 | 0, 218) | 0;
 __ZN12CullingGroupC2Ev(i2);
 HEAP32[i1 + 8 >> 2] = i2;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3); else {
  __ZN12CullingGroup18SetScriptingObjectEP12Il2CppObject(i2, i1);
  STACKTOP = i3;
  return;
 }
}

function __Z19free_alloc_internalPvRK10MemLabelId(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i1, i2, i3);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i4 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i4;
 if (i4 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i4 = i1;
 __ZN13MemoryManager10DeallocateEPvRK10MemLabelId(i4, i2, i3);
 return;
}

function __Z18ConvertUTF16toUTF8PKtiPhRi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i7 = i5;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i7 >> 2] = i1;
 i2 = (__Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags(i7, i1 + (i2 << 1) | 0, i6, i3 + (i2 << 2) | 0, 1) | 0) == 3;
 HEAP32[i4 >> 2] = i2 ? 0 : (HEAP32[i6 >> 2] | 0) - i3 | 0;
 STACKTOP = i5;
 return i2 ^ 1 | 0;
}

function __ZNK9DebugGLES14ProgramBindingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i3 + 1992 >> 0] | 0)) {
  i3 = 1;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i2 >> 2] = 0;
 mftCall_vii(HEAP32[i3 + 88 >> 2] | 0, 35725, i2 | 0);
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 868 >> 2] | 0;
 i3 = (i3 | 0) == -1 ? 1 : (i3 | 0) == (HEAP32[i2 >> 2] | 0);
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9GfxDevice20DestroyRenderSurfaceER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 if (HEAP8[i3 + 31 >> 0] | 0) return;
 i4 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 264 >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 400 >> 2] | 0, i1 | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0, i3 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1047713 | 0, HEAP32[gb + 37300 >> 2] | 0, i1 + 32 | 0, 257);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN9Animation23ClearContainedRenderersEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i2 + 72 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i4 = i2 + 68 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  __ZN6Object11RemoveEventEPFvPvS0_iES0_(HEAP32[i1 >> 2] | 0, fb + 912 | 0, i2);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i1 = HEAP32[i4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[i5 >> 2] = i2 + (~((i2 + -4 - i1 | 0) >>> 2) << 2);
 return;
}

function __ZN8Animator6RecordEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, i4 = 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) return;
 i4 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i4) return;
 if ((HEAP32[i1 + 548 >> 2] | 0) != 2) return;
 f3 = Math_fround(HEAPF32[i1 + 420 >> 2]);
 if (!(f3 >= Math_fround(0.0))) return;
 f3 = Math_fround(f3 * f2);
 __ZN14AvatarPlayback11RecordFrameEfPKN7mecanim9animation12AvatarMemoryEPNS1_16ControllerMemoryE(i1 + 504 | 0, f3, HEAP32[i1 + 136 >> 2] | 0, HEAP32[i4 + 100 >> 2] | 0);
 return;
}

function __ZN5physx8debugger4comm13SetIsTopLevel9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 i2 = i2 + 16 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP8[i2 >> 0] = (HEAP8[i4 >> 0] | 0) != 0 & 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd13ReadWriteLockD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i2 >> 2] | 0;
 _pthread_mutex_destroy(HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, HEAP32[i2 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext7D6JointD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3;
 HEAP32[i2 >> 2] = gb + 86848 + 8;
 HEAP32[i2 + 12 >> 2] = gb + 86848 + 256;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 + 80 >> 2] | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext23computeBoxInertiaTensorERNS_6PxVec3Effff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var f6 = f0;
 f2 = Math_fround(f2 / Math_fround(12.0));
 f4 = Math_fround(f4 * f4);
 f6 = Math_fround(f5 * f5);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(f4 + f6) * f2);
 f5 = Math_fround(f3 * f3);
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(f5 + f6) * f2);
 HEAPF32[i1 + 8 >> 2] = Math_fround(Math_fround(f5 + f4) * f2);
 return;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_10ShrunkBoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 return __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) | 0;
}

function __ZN4FMOD6System14setSpeakerModeE16FMOD_SPEAKERMODE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861112;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN13PhysicsModule20GetRigidBodyVelocityERK9Rigidbody(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i4 = HEAP32[i3 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 8 >> 2] = i3;
 STACKTOP = i1;
 return;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 150816 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  _fflush(i2) | 0;
  _fclose(HEAP32[i1 >> 2] | 0) | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = gb + 148172 + 8;
 i2 = i3 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i3);
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider7releaseEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 i2 = i4 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) HEAP32[i2 >> 2] = i3 + -1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 if (HEAP32[i2 >> 2] | 0) return;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN11MatrixStack4PushERK10Matrix4x4f(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 1024 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) > 15) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407034 | 0, 0, gb + 407066 | 0, 31, 1, 0, 0, 0);
  return;
 } else {
  HEAP32[i3 >> 2] = i4 + 1;
  i3 = i2 + (i4 + -1 << 6) | 0;
  i2 = i3 + 64 | 0;
  do {
   HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
   i3 = i3 + 4 | 0;
   i1 = i1 + 4 | 0;
  } while ((i3 | 0) < (i2 | 0));
  return;
 }
}

function _UNITY_png_get_sCAL_fixed(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 16384)) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = HEAPU8[i2 + 232 >> 0];
 HEAP32[i4 >> 2] = _UNITY_png_fixed(i1, +_atof(HEAP32[i2 + 236 >> 2] | 0), gb + 352015 | 0) | 0;
 HEAP32[i5 >> 2] = _UNITY_png_fixed(i1, +_atof(HEAP32[i2 + 240 >> 2] | 0), gb + 352026 | 0) | 0;
 i5 = 16384;
 return i5 | 0;
}

function _open(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = i3;
 i7 = (HEAP32[i6 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i7 + 4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2 | 32768;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall5(5, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function ___dns_count_addrs(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 L1 : do if (!i3) i1 = 0; else {
  i1 = 0;
  while (1) {
   i3 = i3 + -1 | 0;
   i5 = 0;
   do {
    i4 = ___dns_get_rr(0, 0, HEAP32[gb + 207720 + (i5 << 3) >> 2] | 0, -1, i2, HEAP32[gb + 207720 + (i5 << 3) + 4 >> 2] | 0, 0) | 0;
    if ((i4 | 0) < 0) {
     i1 = i4;
     break L1;
    }
    i1 = i4 + i1 | 0;
    i5 = i5 + 1 | 0;
   } while ((i5 | 0) < 2);
   if (!i3) break; else i2 = i2 + 512 | 0;
  }
 } while (0);
 return i1 | 0;
}

function __ZnwjRKSt9nothrow_t(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 1570 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i2);
  } else i3 = 0;
 } else i3 = i1;
 return i3 | 0;
}

function __ZnajRKSt9nothrow_t(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 1568 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___cxa_begin_catch(i2 | 0) | 0;
  __THREW__ = 0;
  invoke_v(fb + 458 | 0);
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i2);
  } else i3 = 0;
 } else i3 = i1;
 return i3 | 0;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwner5flushEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -8 | 0;
 i3 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i1 = 1; else if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 } else i1 = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return i1 | 0;
}

function __ZNSt3__26locale2id5__getEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 16 | 0;
 i3 = i5 + 12 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = fb + 4e3;
 HEAP32[i4 + 8 >> 2] = 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  HEAP32[i2 >> 2] = i4;
  HEAP32[i3 >> 2] = i2;
  __ZNSt3__211__call_onceERVmPvPFvS2_E(i1, i3, fb + 4001 | 0);
 }
 STACKTOP = i5;
 return (HEAP32[i1 + 4 >> 2] | 0) + -1 | 0;
}

function __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj(HEAP32[i1 >> 2] | 0, i3 * 24 | 0) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i1 + (i4 * 24 | 0) | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1 + (i3 * 24 | 0);
 return;
}

function __ZNSt3__212strstreambuf9pbackfailEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do if ((HEAP32[i3 + 8 >> 2] | 0) == (i2 | 0)) i1 = -1; else {
  if ((i1 | 0) == -1) {
   HEAP32[i4 >> 2] = i2 + -1;
   i1 = 0;
   break;
  }
  i2 = i2 + -1 | 0;
  if (!(HEAP32[i3 + 32 >> 2] & 2)) {
   HEAP32[i4 >> 2] = i2;
   HEAP8[i2 >> 0] = i1;
   break;
  }
  if ((HEAP8[i2 >> 0] | 0) == (i1 << 24 >> 24 | 0)) HEAP32[i4 >> 2] = i2; else i1 = -1;
 } while (0);
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore25getMotionConstraintConfigEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = i2 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i1 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 276 >> 2] | 0, i3 | 0));
 i3 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i3 >> 2] | 0) + 280 >> 2] | 0, i3 | 0));
 i2 = HEAP32[i2 >> 2] | 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 288 >> 2] | 0, i2 | 0));
 return;
}

function __ZNK5physx2Gu9Container8ContainsEjPj(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  i6 = 0;
  return i6 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i6 = 7;
   break;
  }
 }
 if ((i6 | 0) == 7) return i1 | 0;
 if (!i5) {
  i6 = 1;
  return i6 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i6 = 1;
 return i6 | 0;
}

function __ZN9Rigidbody27SetSolverVelocityIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i6 + 292 >> 2] | 0;
 mftCall_viii(HEAP32[i6 + 296 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0);
 mftCall_viii(i5 | 0, i1 | 0, HEAP32[i4 >> 2] | 0, ((i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2) | 0);
 STACKTOP = i3;
 return;
}

function __ZN8VRDevice22DisableStereoRenderingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i2) {
  i2 = __Z12GetGfxDevicev() | 0;
  i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  HEAP32[i3 + 12 >> 2] = 0;
  mftCall_viiifi(i5 | 0, i2 | 0, 7, i3 | 0, 1.0, 0);
 }
 HEAP8[i1 + 300 >> 0] = 0;
 STACKTOP = i4;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx9PxTaskMgr13taskCompletedERNS_6PxTaskE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 if (!(__ZN5physx9PxTaskMgr10resolveRowEjb(i3, HEAP32[i2 + 12 >> 2] | 0, 0) | 0)) {
  i3 = HEAP32[i1 >> 2] | 0;
  __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
  return;
 }
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(i3);
 return;
}

function __ZN24OcclusionCullingSettingsD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 34976 + 8;
 i1 = i2 + 52 | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 56 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 32 | 0;
 if ((HEAP32[i2 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 36 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = gb + 28344 + 8;
 HEAP32[i2 >> 2] = gb + 28496 + 8;
 __ZdlPv(i2);
 return;
}

function __ZN14PlayerSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i4 = i1 + 332 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = (i5 | 0) < 0 ? 0 : (i5 | 0) > 1 ? 1 : i5;
 if ((HEAP32[i1 + 352 >> 2] | 0) == 6) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i2 >> 2] = 1;
 __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy(i1 + 340 | 0, 6, i2, 1);
 STACKTOP = i3;
 return;
}

function __ZN11UnityEngine9Animation40FindTransformBindingIndexBySkeletonIndexERK13dynamic_arrayINS0_14BoundTransformELj4EEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 12 | 0) + 8 >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z42Shader_CUSTOM_GetGlobalVectorArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i2, i5, i4, 0);
 STACKTOP = i3;
 return;
}

function __Z41GUITexture_CUSTOM_INTERNAL_set_pixelInsetP12Il2CppObjectRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 72 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Matrix4x4_CUSTOM_INTERNAL_CALL_TRSRK8Vector3fRK11QuaternionfS1_R10Matrix4x4f(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_(i6, i2, i3, i4);
 i2 = i6;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i5;
 return;
}

function __Z19TestAndRemoveObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if ((i2 | 0) != (i3 | 0)) return;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i4 + 12 | 0;
 i5 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i2 + (i1 << 2) >> 2] = HEAP32[i2 + (i5 << 2) >> 2];
 if (i1 >>> 0 >= (HEAP32[i3 >> 2] | 0) >>> 0) return;
 HEAP32[(HEAP32[(HEAP32[i4 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 24 >> 2] = i1;
 return;
}

function _UNITY_png_check_fp_string(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 4 | 0;
 i1 = i5;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 do if (!(_UNITY_png_check_fp_number(i2, i3, i4, i1) | 0)) i1 = 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) != (i3 | 0)) if (HEAP8[i2 + i1 >> 0] | 0) {
   i1 = 0;
   break;
  }
  i1 = HEAP32[i4 >> 2] | 0;
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4527 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211612 + 8;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_RKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if ((HEAP8[i2 + 8 + 3 >> 0] | 0) < 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 return;
}

function __ZN5physxL29PxcUnimplementedTriangleSweepERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf(i7, i8, i10, i11, i3, i4, f6, i13, i14, i1, i2, i5, i12, f9) {
 i7 = i7 | 0;
 i8 = i8 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f6 = Math_fround(f6);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i12 = i12 | 0;
 f9 = Math_fround(f9);
 return Math_fround(1.0e10);
}

function __ZN5physx8debugger4comm11SetPickable9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 i2 = i2 + 16 | 0;
 HEAP8[i4 >> 0] = HEAP8[i2 >> 0] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0);
 HEAP8[i2 >> 0] = (HEAP8[i4 >> 0] | 0) != 0 & 1;
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext14SphericalJoint11prepareDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 80 >> 2] | 0;
 if (!(HEAP16[i1 + 116 >> 1] & 2)) return i1 | 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 104 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 108 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * Math_fround(.25))));
 return i1 | 0;
}

function __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 24 >> 2];
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc7BodySim20postBody2WorldChangeEv(i1);
 return;
}

function __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 return __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) | 0;
}

function __ZN5physx11HullLibraryD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i3; else {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4 + 1 | 0, i1);
  HEAP32[i3 >> 2] = 0;
  i1 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i1);
 STACKTOP = i4;
 return;
}

function __ZN15UnityWebRequestD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 >> 2] = gb + 187980 + 8;
 HEAP32[i3 >> 2] = i1;
 __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_(gb + 1468908 | 0, i3);
 __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev(i1);
 STACKTOP = i2;
 return;
}

function __ZN15RelativeJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 48 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 76 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 80 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 84 >> 2] = Math_fround(.300000012);
 HEAP8[i1 + 100 >> 0] = 1;
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13RenderTexture28GetCreatedRenderTextureCountEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 1158220 + 4 >> 2] | 0;
 i3 = i2;
 if ((i3 | 0) == (gb + 1158220 | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = 0;
 do {
  i2 = HEAP32[i2 + 8 >> 2] | 0;
  if (!(HEAP32[i2 + 128 >> 2] | 0)) {
   if (HEAP32[i2 + 136 >> 2] | 0) i4 = 5;
  } else i4 = 5;
  if ((i4 | 0) == 5) {
   i4 = 0;
   i1 = i1 + 1 | 0;
  }
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i2;
 } while ((i3 | 0) != (gb + 1158220 | 0));
 return i1 | 0;
}

function __ZN12_GLOBAL__N_117createClothFabricERKN5physx17PxClothFabricDescE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN5physx9NpFactory19createNpClothFabricEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (__ZN5physx13NpClothFabric4loadERKNS_17PxClothFabricDescE(i2, i1) | 0) return i2 | 0;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) {
  i2 = 0;
  return i2 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i2 = 0;
 return i2 | 0;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEventD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i3 = i1 + 4 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 STACKTOP = i4;
 return;
}

function __Z41GUITexture_CUSTOM_INTERNAL_get_pixelInsetP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 72 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39UnityWebRequest_CUSTOM_InternalGetErrorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if ((HEAP32[i1 + 108 >> 2] | 0) != 4) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = HEAP32[i1 + 104 >> 2] | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function _exp10l(d1) {
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 d2 = +_modfl(d1, i5);
 d3 = +HEAPF64[i5 >> 3];
 do if (+Math_abs(+d3) < 16.0) if (d2 != 0.0) {
  d1 = +_exp2l(d2 * 3.321928094887362);
  d1 = d1 * +HEAPF64[gb + 8512 + (~~d3 + 15 << 3) >> 3];
  break;
 } else {
  d1 = +HEAPF64[gb + 8512 + (~~d3 + 15 << 3) >> 3];
  break;
 } else d1 = +Math_pow(10.0, +d1); while (0);
 STACKTOP = i4;
 return +d1;
}

function __ZNK9Rigidbody16GetPointVelocityERK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E(i5, HEAP32[i2 + 52 >> 2] | 0, i3);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZNK8Material6GetTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEbS8_(i4, i1, i2, i3, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = __ZNK8Material6GetTagEib(i1, __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2) | 0, i3) | 0;
 if ((i1 | 0) < 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i4, i5);
  return;
 } else {
  __ZN9shadertag16GetShaderTagNameEi(i4, i1);
  return;
 }
}

function __ZNK5physx7NpActor12getAggregateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP8[i2 + (i1 << 3) >> 0] | 0) == 1) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i4 = 7;
   break;
  }
 }
 if ((i4 | 0) == 7) return i1 | 0;
 i4 = HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0;
 return i4 | 0;
}

function __ZN9Animation14IsPlayingLayerEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = i2;
 while (1) {
  i2 = HEAP32[i1 >> 2] | 0;
  if ((HEAP32[i2 + 32 >> 2] | 0) == (i4 | 0)) if (HEAP16[i2 + 56 >> 1] & 2) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN8Animator7PrepareEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 153 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) i1 = 3; else if (!(HEAP32[i2 + 168 >> 2] | 0)) i1 = 3;
 if ((i1 | 0) == 3) __ZN8Animator12CreateObjectEv(i2);
 if (HEAP32[i2 + 108 >> 2] | 0) {
  i1 = HEAP32[i2 + 624 >> 2] | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 + 96 >> 2] | 0;
   if (i1 | 0) HEAP32[i1 >> 2] = HEAP32[i2 + 420 >> 2];
  }
 }
 if (!(HEAP8[i3 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[i2 + 168 >> 2] | 0) != 0;
 return i3 | 0;
}

function __ZN5physx6shdfnd4Time22getCurrentCounterValueEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 _clock_gettime(0, i2 | 0) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i4 = ___muldi3(i4 | 0, ((i4 | 0) < 0) << 31 >> 31 | 0, 1e9, 0) | 0;
 i3 = getTempRet0() | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = _i64Add(i4 | 0, i3 | 0, i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN5Light16TransformChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(HEAP8[i1 + 33 >> 0] | 0)) return;
 __ZNK5Light16UnshareLightDataEv(i1);
 i2 = i1 + 44 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZN15SharedLightData15UpdateTransformERK9Transform(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i2 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE19RenderTextureFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__Z14IsHalfRTFormat19RenderTextureFormat(i2) | 0) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 476 >> 0] | 0)) HEAP32[i1 >> 2] = 0;
 if (__Z15IsFloatRTFormat19RenderTextureFormat(i2) | 0) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 477 >> 0] | 0)) HEAP32[i1 >> 2] = 0;
 if ((i2 | 0) != 1) return;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 478 >> 0] | 0) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10Matrix3x3f8SetBasisERK8Vector3fS2_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i4 + 8 >> 2];
 return i1 | 0;
}

function __ZN10HumanTrait14BoneFromMuscleEi(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) < 0) {
  i1 = -1;
  return i1 | 0;
 }
 if ((i1 | 0) < 52) {
  i1 = __ZN7mecanim5human14BoneFromMuscleEi(i1) | 0;
  return i1 | 0;
 }
 if ((i1 | 0) < 72) {
  i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i1 + -52 | 0) | 0;
  i1 = (i1 | 0) != -1 ? i1 + 24 | 0 : -1;
  return i1 | 0;
 }
 if ((i1 | 0) >= 92) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = __ZN7mecanim4hand14BoneFromMuscleEi(i1 + -72 | 0) | 0;
 i1 = (i1 | 0) != -1 ? i1 + 39 | 0 : -1;
 return i1 | 0;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z53DownloadHandlerAssetBundle_Get_Custom_PropAssetBundleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN26DownloadHandlerAssetBundle14GetAssetBundleEv(i1) | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027921 | 0, i2);
 return 0;
}

function __Z30Material_Set_Custom_PropShaderP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN8Material9SetShaderEP6Shader(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN8Material9SetShaderEP6Shader(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Animator_Set_Custom_PropAvatarP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN8Animator9SetAvatarEP6Avatar(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN8Animator9SetAvatarEP6Avatar(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Mesh_CUSTOM_SetIndicesImplP12Il2CppObjecti16GfxPrimitiveTypeP11Il2CppArrayih(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __Z24SetMeshIndicesFromScriptR4Meshi16GfxPrimitiveTypeP11Il2CppArrayib(i7, i2, i3, i4, i5, i6 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _if_nametoindex(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6 + 8 | 0;
 i4 = i6;
 i2 = i6 + 16 | 0;
 i3 = _socket(1, 524290, 0) | 0;
 if ((i3 | 0) < 0) i1 = -1; else {
  _strncpy(i2, i1, 16) | 0;
  HEAP32[i4 >> 2] = i2;
  i1 = _ioctl(i3, 35123, i4) | 0;
  HEAP32[i5 >> 2] = i3;
  ___syscall6(6, i5 | 0) | 0;
  i1 = (i1 | 0) < 0 ? 0 : HEAP32[i2 + 16 >> 2] | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function _getsockname(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 6;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _getpeername(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 7;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK16TypeTreeIterator8ChildrenEv(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = i2 + (i1 * 24 | 0) | 0;
 if ((i3 + 24 | 0) >>> 0 < (i2 + ((HEAP32[i5 + 12 >> 2] | 0) * 24 | 0) | 0) >>> 0) if ((HEAPU8[i3 + 26 >> 0] | 0 | 0) == ((HEAPU8[i2 + (i1 * 24 | 0) + 2 >> 0] | 0) + 1 | 0)) {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i4 + 4 >> 2] = i1 + 1;
  return;
 }
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 return;
}

function __ZN9Behaviour12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155104 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1155108 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1155112 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1155116 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8Material17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 164 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (i3 & 1) {
  HEAP8[i2 >> 0] = i3 & -2;
  i1 = HEAP32[i4 >> 2] | 0;
 }
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63288 | 0);
 }
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN8Animator26AnimatorVisibilityCallbackEPvS0_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 0:
  {
   __ZN8Animator19SetVisibleRenderersEb(i1, 1);
   return;
  }
 case 1:
  {
   __ZN8Animator19SetVisibleRenderersEb(i1, __ZNK8Animator20IsAnyRendererVisibleEv(i1) | 0);
   return;
  }
 case 2:
  {
   __ZN8Animator23RemoveContainedRendererEPv(i1, i2);
   __ZN8Animator19SetVisibleRenderersEb(i1, __ZNK8Animator20IsAnyRendererVisibleEv(i1) | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = HEAP16[i2 + 4 >> 1] | 0;
 i1 = i2 + 8 | 0;
 if ((HEAP16[i2 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
 if (!(i3 << 16 >> 16)) return;
 i3 = i3 & 65535;
 i4 = 0;
 do {
  i2 = HEAP32[i1 + (i4 << 2) >> 2] | 0;
  if (i2 | 0) __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE(i5, i2);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 4 | 0;
 i2 = i4 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + 1 | 0) >>> 0 > (HEAP32[i4 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 1);
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 } else {
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
  __ZN18StreamedBinaryReadILb0EE5AlignEv(i4);
  return;
 }
}

function __ZN13WebCamTexture6CreateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!(_JS_WebCam_IsSupported() | 0)) return;
 i4 = __ZNK13WebCamTexture25GetDeviceIdFromDeviceListERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, i3 + 108 | 0) | 0;
 if ((i4 | 0) == -1) return;
 _JS_WebCamVideo_Start(i4 | 0);
 i2 = i3 + 124 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(4) | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i1 >> 2] = i4;
 HEAP8[i3 + 120 >> 0] = 1;
 return;
}

function __Z61GUIStyleState_CUSTOM_GetBackgroundInternalFromDeserializationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags(HEAP32[i1 >> 2] | 0, 8388608) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function _UNITY_LZ4_compress_limitedOutput(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 _memset(i5 | 0, 0, 16416) | 0;
 if ((i3 | 0) < 65547) {
  i5 = _LZ4_compress_generic(i5, i1, i2, i3, i4, 1, 2, 0, 0) | 0;
  STACKTOP = i6;
  return i5 | 0;
 } else {
  i5 = _LZ4_compress_generic(i5, i1, i2, i3, i4, 1, 0, 0, 0) | 0;
  STACKTOP = i6;
  return i5 | 0;
 }
 return 0;
}

function _ttyname_r(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 do if (!(_isatty(i1) | 0)) i1 = 25; else {
  ___procfdname(i2, i1);
  i1 = _readlink(i2, i3, i4) | 0;
  if ((i1 | 0) < 0) {
   i1 = HEAP32[(___errno_location() | 0) >> 2] | 0;
   break;
  }
  if ((i1 | 0) == (i4 | 0)) i1 = 34; else {
   HEAP8[i3 + i1 >> 0] = 0;
   i1 = 0;
  }
 } while (0);
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__215recursive_mutexD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2809 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
 if (!i1) return; else {
  __THREW__ = 0;
  invoke_viiii(fb + 363 | 0, gb + 1082411 | 0, gb + 1082291 | 0, 86, gb + 1082418 | 0);
  __THREW__ = 0;
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_RKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 return;
}

function __ZN9Animation8GetStateEP13AnimationClip(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 __ZN9Animation20BuildAnimationStatesEv(i1);
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  if ((HEAP32[i1 + 96 >> 2] | 0) == (i4 | 0)) {
   i2 = 4;
   break;
  }
  if ((i2 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN7ApiGLES11DrawCaptureE16GfxPrimitiveTypej(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = HEAP32[i3 + 736 >> 2] | 0;
 i2 = i3 + 860 | 0;
 mftCall_vi(i5 | 0, __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i2 >> 2] | 0, i1) | 0);
 if (!(HEAP32[i3 + 872 >> 2] | 0)) i1 = __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(HEAP32[i2 >> 2] | 0, i1) | 0; else i1 = 14;
 mftCall_viii(HEAP32[i3 + 420 >> 2] | 0, i1 | 0, 0, i4 | 0);
 mftCall_v(HEAP32[i3 + 740 >> 2] | 0);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefINS0_12StringHandleEEE(i1, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpScene10setGravityERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i2 + 2448 >> 0] | 0)) {
  HEAP32[i2 + 80 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 84 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 88 >> 2] = HEAP32[i1 + 8 >> 2];
  HEAP32[i2 + 92 >> 2] = 1;
  return;
 } else {
  HEAP32[i2 + 3348 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 + 3352 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i2 + 3356 >> 2] = HEAP32[i1 + 8 >> 2];
  i2 = i2 + 3388 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
  return;
 }
}

function __ZN13GfxDeviceGLES16CreateDepthStateERK13GfxDepthState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 2 | 0;
 i5 = i3;
 HEAP16[i5 >> 1] = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8;
 HEAP8[i4 >> 0] = HEAP8[i5 >> 0] | 0;
 HEAP8[i4 + 1 >> 0] = HEAP8[i5 + 1 >> 0] | 0;
 i2 = __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState(i1 + 6616 | 0, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z43TextGenerator_Get_Custom_PropCharacterCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (!(HEAP8[i1 + 60 >> 0] | 0)) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = HEAP32[i1 + 32 >> 2] | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z42Shader_CUSTOM_GetGlobalMatrixArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i2, i5, i4);
 STACKTOP = i3;
 return;
}

function __Z40Camera_CUSTOM_INTERNAL_get_cullingMatrixP12Il2CppObjectP10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = __ZNK6Camera16GetCullingMatrixEv(i3) | 0;
   i3 = i2 + 64 | 0;
   do {
    HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
    i2 = i2 + 4 | 0;
    i1 = i1 + 4 | 0;
   } while ((i2 | 0) < (i3 | 0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_CUSTOM_GetOutputDataHelperP12Il2CppObjectP11Il2CppArrayi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 4) | 0;
   __ZN11AudioSource13GetOutputDataEPfii(i4, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33GUIStyle_CUSTOM_Internal_CalcSize13Il2Cpp_IntPtrP12Il2CppObjectP13Vector2fIcall(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZNK8GUIStyle8CalcSizeER10GUIContent(i5, i1, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0);
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 STACKTOP = i4;
 return;
}

function __Z30LensFlare_Set_Custom_PropFlareP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN9LensFlare8SetFlareEP5Flare(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN9LensFlare8SetFlareEP5Flare(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26profiler_initialize_threadPKcS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1451e3 >> 2] | 0, 0, 0) | 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(288, gb + 63576 | 0, 16, gb + 461711 | 0, 70) | 0;
 __ZN22UnityProfilerPerThreadC2EPKcS1_(i4, i1, i2);
 HEAP32[gb + 1163228 >> 2] = i4;
 __ZN13UnityProfiler20AddPerThreadProfilerEP22UnityProfilerPerThread(HEAP32[gb + 1451e3 >> 2] | 0, i4);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function _ioctl(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = i3;
 i7 = (HEAP32[i6 >> 2] | 0) + (4 - 1) & ~(4 - 1);
 i3 = HEAP32[i7 >> 2] | 0;
 HEAP32[i6 >> 2] = i7 + 4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall54(54, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _exp10(d1) {
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 d2 = +_modf(d1, i5);
 d3 = +HEAPF64[i5 >> 3];
 do if (+Math_abs(+d3) < 16.0) if (d2 != 0.0) {
  d1 = +_exp2(d2 * 3.321928094887362);
  d1 = d1 * +HEAPF64[gb + 8512 + (~~d3 + 15 << 3) >> 3];
  break;
 } else {
  d1 = +HEAPF64[gb + 8512 + (~~d3 + 15 << 3) >> 3];
  break;
 } else d1 = +Math_pow(10.0, +d1); while (0);
 STACKTOP = i4;
 return +d1;
}

function __ZN5physx20PxsParticleSystemSim23updateDynamicsParameterEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 f2 = Math_fround(Math_fround(HEAPF32[i4 + 4 >> 2]) * Math_fround(.100000001));
 f2 = Math_fround(f2 * f2);
 f2 = Math_fround(f2 * Math_fround(f2 * f2));
 f3 = Math_fround(HEAPF32[i4 + 8 >> 2]);
 HEAPF32[i1 + 120 >> 2] = Math_fround(Math_fround(HEAPF32[i1 + 84 >> 2]) * Math_fround(f3 * Math_fround(Math_fround(45.0) / Math_fround(f2 * Math_fround(3.14159274)))));
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 92112 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i5, i3, i4, i6, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 __ZN5physx26PxClothFabricGeneratedInfoC2Ev(i1);
 STACKTOP = i1;
 return 1;
}

function __ZN15LightProbeGroup12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 if ((i3 | 0) == (gb + 1157924 | 0)) return;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) i1 = i1 + 40 | 0; else {
  i1 = i1 + 40 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = HEAP32[gb + 1157924 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 1157924;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __ZN15FileSystemEntry11HasFastHashER7Hash128(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i3 = HEAP32[(HEAP32[gb + 1179016 >> 2] | 0) + 4 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0, i1 | 0) | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 1040 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0) | 0;
 return i3 | 0;
}

function __ZN15DirectorManager14ConnectionPool8DestructEv(i1) {
 i1 = i1 | 0;
 __ZN15DirectorManager14ConnectionPool11ClearUnsafeEv(i1);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i1 + 48 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i1 + 52 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i1 + 56 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i1 + 60 >> 2] | 0);
 __Z23DestroyMutexLockedStackP16MutexLockedStack(HEAP32[i1 + 64 >> 2] | 0);
 return;
}

function __ZN12_GLOBAL__N_112andNotIsZeroI8Scalar4fEET_RKS2_S4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 32 | 0;
 i7 = i4 + 16 | 0;
 i5 = i4;
 __ZcoRK8Scalar4f(i7, i3);
 __ZanRK8Scalar4fRK14ComplementExprIS_E(i6, i2, i7);
 __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i5, i4 + 48 | 0);
 __ZN5simdieqERK8Scalar4fS2_(i1, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z41SystemInfo_Get_Custom_PropOperatingSystemv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZN10systeminfo18GetOperatingSystemEv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z29CullIntermediateRenderersOnlyRK22SceneCullingParametersR11CullResults(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 796 | 0;
 if (HEAP32[i4 >> 2] | 0) {
  i5 = HEAP32[i3 + 52 >> 2] | 0;
  i1 = 0;
  do {
   HEAP32[i5 + (i1 << 2) >> 2] = i1;
   i1 = i1 + 1 | 0;
   i6 = HEAP32[i4 >> 2] | 0;
  } while (i1 >>> 0 < i6 >>> 0);
  HEAP32[i3 + 56 >> 2] = i6;
 }
 if (!(HEAP8[i2 + 817 >> 0] | 0)) return;
 __ZL10CullLightsRK22SceneCullingParametersR11CullResults(i2, i3);
 return;
}

function __Z26InitializeAsyncReadManagerv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(248, gb + 63216 | 0, 16, gb + 464723 | 0, gb + 390885 | 0, gb + 390902 | 0, 14) | 0;
 __ZN4FileC2Ev(i1);
 __ZN4FileC2Ev(i1 + 32 | 0);
 __ZN4FileC2Ev(i1 + 64 | 0);
 __ZN4FileC2Ev(i1 + 96 | 0);
 __ZN4FileC2Ev(i1 + 128 | 0);
 i2 = i1 + 160 | 0;
 i3 = i2 + 84 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1155100 >> 2] = i1;
 return;
}

function __Z22Mesh_CUSTOM_HasChannelP12Il2CppObject30InternalScriptingShaderChannel(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 if ((i2 | 0) == -1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP8[(HEAP32[i3 + 32 >> 2] | 0) + 8 + (i2 << 2) + 3 >> 0] | 0) != 0 & 1;
 return i3 | 0;
}

function _sendmsg(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 16;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _recvmsg(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 17;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4527 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211588 + 8;
  return;
 }
}

function __ZNK5physx2Sq17SceneQueryManager11canRunOnSPUERKNS_12NpBatchQueryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 128 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (((HEAP32[i2 + 64 >> 2] | 0) + -1 | 0) >>> 0 < 2) i1 = ((HEAP32[i2 + 68 >> 2] | 0) + -1 | 0) >>> 0 < 2; else i1 = 0;
 i2 = (HEAP32[i2 + 76 >> 2] | 0) + -16 | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 388 >> 2] | 0, i2 | 0) | 0;
 i2 = i1 & (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0) != 0;
 return i2 | 0;
}

function __ZNK12NavMeshAgent27GetEndPositionOfCurrentPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) {
  __ZNK12NavMeshAgent11GetPositionEv(i1, i2);
  return;
 } else {
  i4 = __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i2 + 68 | 0) | 0;
  i3 = HEAP32[i4 + 16 >> 2] | 0;
  i2 = HEAP32[i4 + 20 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i4 + 12 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i1 + 8 >> 2] = i2;
  return;
 }
}

function __ZN5physx7NpScene15setCCDMaxPassesEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene15setCCDMaxPassesEj(i2 + 32 | 0, i1);
  STACKTOP = i3;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 705660 | 0, 586, gb + 705738 | 0, i3);
  STACKTOP = i3;
  return;
 }
}

function __ZN5physx2Sc5ActorC2ERNS0_16InteractionSceneEhNS0_14IslandNodeInfo4TypeE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 HEAP32[i4 >> 2] = gb + 91044 + 8;
 i5 = i4 + 20 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 HEAP32[i4 + 36 >> 2] = i3;
 HEAP32[i4 + 40 >> 2] = -1;
 HEAP16[i4 + 44 >> 1] = 0;
 HEAP16[i4 + 46 >> 1] = 0;
 HEAP16[i4 + 48 >> 1] = 0;
 HEAP8[i4 + 50 >> 0] = i1;
 HEAP8[i4 + 51 >> 0] = i2;
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap6createERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, 376, gb + 716671 | 0, 590) | 0;
 if (!i1) {
  STACKTOP = i4;
  return i1 | 0;
 }
 __ZN5physx23PxsBroadPhaseContextSapC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i1, i3, i2);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN5physx13PxParticleExt15createIndexPoolEjjPKj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i6 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i4 = _PxGetFoundation() | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0) | 0;
 i4 = mftCall_iiiiii(i6 | 0, i5 | 0, 20, (i4 ? gb + 745147 | 0 : gb + 837976 | 0) | 0, gb + 666952 | 0, 334) | 0;
 __ZN17InternalIndexPoolC2EjjPKj(i4, i1, i3, i2);
 return i4 | 0;
}

function __ZN4FMOD6System9setOutputE15FMOD_OUTPUTTYPE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861151;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN22BaseUnityConnectClient12PauseSessionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 113 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP8[i3 >> 0] = 1;
 i2 = i1 + 4 | 0;
 L4 : do if ((HEAP32[i2 >> 2] | 0) == 4) i1 = 0; else {
  switch (HEAP32[i2 >> 2] | 0) {
  case 1:
  case 5:
  case 0:
   {
    i1 = 0;
    break L4;
   }
  default:
   {}
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
  i1 = 1;
 } while (0);
 HEAP8[i3 >> 0] = 0;
 i3 = i1;
 return i3 | 0;
}

function __ZN14PhysicsManager13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 i2 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i1 + 32 | 0);
 i2 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 256 >> 2] | 0, i2 | 0, +Math_fround(HEAPF32[i1 + 52 >> 2]));
 if (!(__Z24GetManagerPtrFromContexti(9) | 0)) return;
 __ZN14PhysicsManager20SetupDefaultMaterialEv(i1);
 return;
}

function __ZN14ImageReferenceC2Eiii13TextureFormatPv(i2, i3, i4, i1, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i2 + 12 >> 2] = i1;
 if (i6 | 0) {
  if ((i5 | 0) < 9) i1 = 1; else i1 = (i5 | 0) == 1e3 | ((i5 | 0) == 23 | (i5 + -13 | 0) >>> 0 < 9);
  if ((i3 | 0) > 0 & (i4 | 0) > 0 & (i5 | 0) > 0 & i1) {
   HEAP32[i2 + 16 >> 2] = i6;
   return;
  }
 }
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN13ScreenManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 44628 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP8[i1 + 27 >> 0] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP8[i1 + 25 >> 0] = 1;
 HEAP8[i1 + 26 >> 0] = 1;
 HEAP8[i1 + 24 >> 0] = 1;
 HEAP32[i1 + 36 >> 2] = 1;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __ZN13RenderTexture9GetActiveEi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 348 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (i1 | 0) {
  i2 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
  return i2 | 0;
 }
 i1 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 352 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase(i1) | 0;
 return i2 | 0;
}

function __ZN13GfxDeviceGLES23MemoryBarrierBeforeDrawEyN2gl17MemoryBarrierTypeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1 + 7264 + (i4 << 3) | 0;
 i6 = HEAP32[i5 + 4 >> 2] | 0;
 if (!(i6 >>> 0 < i3 >>> 0 | ((i6 | 0) == (i3 | 0) ? (HEAP32[i5 >> 2] | 0) >>> 0 < i2 >>> 0 : 0))) return;
 i5 = __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(HEAP32[i1 + 5480 >> 2] | 0, i4) | 0;
 i6 = i1 + 7376 | 0;
 HEAP32[i6 >> 2] = HEAP32[i6 >> 2] | i5;
 return;
}

function __ZN11UnityEngine9Animation38FindTransformBindingIndexByBindingHashERK13dynamic_arrayINS0_14BoundTransformELj4EEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN10GUIManager12AddGUIScriptER8ListNodeI13MonoBehaviourE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if ((i3 | 0) == (i2 | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = i3 + 4 | 0; else {
  i4 = i3 + 4 | 0;
  HEAP32[i1 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i1;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i4;
 }
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i3;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 return;
}

function __Z8rotate2DRKfS0_S0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0, f7 = f0, f8 = f0, f9 = f0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f5 = Math_fround(+Math_cos(+f7));
 f7 = Math_fround(+Math_sin(+f7));
 f9 = Math_fround(HEAPF32[i2 >> 2]);
 f8 = Math_fround(f5 * f9);
 f6 = Math_fround(HEAPF32[i3 >> 2]);
 f5 = Math_fround(Math_fround(f7 * f9) + Math_fround(f5 * f6));
 HEAPF32[i1 >> 2] = Math_fround(f8 - Math_fround(f7 * f6));
 HEAPF32[i1 + 4 >> 2] = f5;
 return;
}

function __Z67AnimatorControllerPlayable_CUSTOM_GetAnimatorTransitionInfoInternalR9HPlayablei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) return;
 __ZNK26AnimatorControllerPlayable25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, i1) | 0;
 return;
}

function __Z41Shader_CUSTOM_GetGlobalFloatArrayImplListiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i6 = i3;
 i5 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i2, i5, i4);
 STACKTOP = i3;
 return;
}

function _connect(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 3;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN8Playable7SetDataEyPv(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0;
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) return;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 do {
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 40 >> 2] | 0, i6 | 0, i3 | 0, i4 | 0, i5 | 0);
  i1 = i1 + 8 | 0;
  i6 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != ((HEAP32[i6 + 16 >> 2] | 0) + (HEAP32[i6 + 28 >> 2] << 3) | 0));
 return;
}

function __ZN5physx7NpScene8lockReadEPKcj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = i3 + 3876 | 0;
 i2 = __ZN5physx6shdfnd6TlsGetEj(HEAP32[i4 >> 2] | 0) | 0;
 i1 = i2 >>> 16;
 __ZN5physx6shdfnd6TlsSetEjPv(HEAP32[i4 >> 2] | 0, i2 & -16711681 | (i1 << 16) + 65536 & 16711680) | 0;
 i2 = HEAP32[i3 + 3880 >> 2] | 0;
 if (!((i1 & 255) << 24 >> 24 == 0 & (i2 | 0) != (__ZN5physx6shdfnd10ThreadImpl5getIdEv() | 0))) return;
 __ZN5physx6shdfnd13ReadWriteLock10lockReaderEv(i3 + 3884 | 0);
 return;
}

function __ZN23TransformChangeDispatch24RemoveTransformHierarchyER18TransformHierarchy(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) return;
 i5 = i3 + 12 | 0;
 i6 = (HEAP32[i5 >> 2] | 0) + -1 | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = i3 + (i6 << 2) | 0;
 HEAP32[(HEAP32[i4 >> 2] | 0) + 32 >> 2] = i2;
 i3 = i3 + (HEAP32[i1 >> 2] << 2) | 0;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 >> 2] = -1;
 return;
}

function __ZN21AnimationClipPlayable11SetDurationEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 4 | 0;
 __Z6FormatPKcz(i3, gb + 899928 | 0, i1);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 0, gb + 900023 | 0, 471, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return;
}

function __ZN13TargetJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 48 >> 2] = Math_fround(inf);
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP8[i1 + 104 >> 0] = 1;
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(5.0);
 return;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z40TextGenerator_Get_Custom_PropVertexCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (!(HEAP8[i1 + 60 >> 0] | 0)) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = HEAP32[i1 + 72 >> 2] | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z33Camera_Get_Custom_PropPixelHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK6Camera24GetScreenViewportRectIntEv(i2, i3);
   STACKTOP = i4;
   return HEAP32[i2 + 12 >> 2] | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30AnimationCurve_CUSTOM_EvaluateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f2 = Math_fround(__ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE(i1, f2, 0));
   STACKTOP = i4;
   return Math_fround(f2);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 return Math_fround(0.0);
}

function _acosh(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 52) | 0;
 getTempRet0() | 0;
 i2 = i2 & 2047;
 do if (i2 >>> 0 < 1024) {
  d1 = d1 + -1.0;
  d1 = +_log1p(d1 + +Math_sqrt(+(d1 * d1 + d1 * 2.0)));
 } else if (i2 >>> 0 < 1049) {
  d1 = +Math_log(+(d1 * 2.0 - 1.0 / (+Math_sqrt(+(d1 * d1 + -1.0)) + d1)));
  break;
 } else {
  d1 = +Math_log(+d1) + .6931471805599453;
  break;
 } while (0);
 return +d1;
}

function _accept(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 5;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN9GfxDevice19AsyncResourceUploadEii9TextureID(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0, i8 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 4 | 0;
 i8 = i5;
 i7 = __Z21GetAsyncUploadManagerv() | 0;
 HEAP32[i8 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 >> 2] = HEAP32[i8 >> 2];
 __ZN18AsyncUploadManager19AsyncResourceUploadER9GfxDeviceii9TextureID(i7, i1, i2, i3, i6);
 STACKTOP = i5;
 return;
}

function __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskC2ERNS0_7SwClothERNS1_17EndSimulationTaskE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 + 4 >> 1] = -1;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 168492 + 8;
 HEAP32[i3 + 20 >> 2] = i1;
 HEAP32[i3 + 24 >> 2] = i2;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 + 32 >> 2] = 0;
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcher8stealJobEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 4 | 0;
 i2 = i1 + 28 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i3 = 0;
 while (1) {
  i1 = __ZN5physx3Ext15CpuWorkerThread9giveUpJobEv((HEAP32[i4 >> 2] | 0) + (i3 * 28 | 0) | 0) | 0;
  i3 = i3 + 1 | 0;
  if (i1 | 0) {
   i2 = 4;
   break;
  }
  if (i3 >>> 0 >= (HEAP32[i2 >> 2] | 0) >>> 0) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN5Unity17ConfigurableJoint21SetProjectionDistanceEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(340282326000000008404918.0e15);
 f1 = i4 ? Math_fround(340282326000000008404918.0e15) : f1;
 HEAPF32[i3 + 280 >> 2] = i2 ? Math_fround(0.0) : f1;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i3);
 return;
}

function __ZN30VelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 868 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 868 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 868 >> 2] | 0) + 616 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN30RotationModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 856 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 856 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 856 >> 2] | 0) + 616 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN14BillboardAsset9SetHeightEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = (HEAP32[i3 + 32 >> 2] | 0) + 20 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f2)) return;
 HEAPF32[i1 >> 2] = f2;
 i4 = i3 + 40 | 0;
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN14BillboardAsset9SetBottomEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = (HEAP32[i3 + 32 >> 2] | 0) + 24 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f2)) return;
 HEAPF32[i1 >> 2] = f2;
 i4 = i3 + 40 | 0;
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmittersCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = __ZNK9SubModule19GetSubEmittersCountEv(HEAP32[i2 + 916 >> 2] | 0) | 0;
 return i2 | 0;
}

function __Z50GUIStyle_CUSTOM_GetFontInternalDuringLoadingThreadP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags(HEAP32[i1 + 240 >> 2] | 0, 8388608) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z21AddComponentUncheckedR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 if (!i4) i1 = 0; else i1 = __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass((__Z19GetScriptingManagerv() | 0) + 28 | 0, i4) | 0;
 return __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i3, i4, i1, i5) | 0;
}

function _UNITY_png_get_pHYs(i1, i4, i2, i3, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 if (!((i1 | 0) != 0 & (i4 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i4 + 8 >> 2] & 128)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!i2) i1 = 0; else {
  HEAP32[i2 >> 2] = HEAP32[i4 + 184 >> 2];
  i1 = 128;
 }
 if (i3) {
  HEAP32[i3 >> 2] = HEAP32[i4 + 188 >> 2];
  i1 = 128;
 }
 if (!i5) {
  i5 = i1;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = HEAPU8[i4 + 192 >> 0];
 i5 = 128;
 return i5 | 0;
}

function __ZThn8_N12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv(i1, i5, i6, i3, i4, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 + -8 | 0;
 if (!(HEAP8[i1 + 132 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 112 >> 2] & 4)) return;
 __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv(i1);
 i1 = HEAP32[(HEAP32[i1 + 120 >> 2] | 0) + 4 >> 2] | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i5 | 0, i6 | 0, i3 | 0, i4 | 0, i2 | 0);
 return;
}

function __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4527 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211564 + 8;
  return;
 }
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = gb + 208840 + 12;
 HEAP32[i1 + 8 >> 2] = gb + 208840 + 32;
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i1 + 8 | 0, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 80 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = gb + 208792 + 12;
 HEAP32[i1 + 8 >> 2] = gb + 208792 + 32;
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i1 + 8 | 0, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 80 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNK6b2Body13ShouldCollideEPKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) if (!(HEAP32[i2 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i1) {
  i2 = 1;
  return i2 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) if (!(HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 61 >> 0] | 0)) {
   i1 = 0;
   i2 = 7;
   break;
  }
  i1 = HEAP32[i1 + 12 >> 2] | 0;
  if (!i1) {
   i1 = 1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZNK30SpriteRendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i1 = i5 << 24 >> 24 < 0;
 if (((i1 ? HEAP32[i2 + 4 >> 2] | 0 : i5 & 255) | 0) != 8) {
  i5 = 0;
  return i5 | 0;
 }
 if ((_memcmp(i1 ? HEAP32[i2 >> 2] | 0 : i2, gb + 429505 | 0, 8) | 0) != 0 | i3 ^ 1) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i4 + 4 >> 2] = 0;
 i5 = 1;
 return i5 | 0;
}

function __ZNK19SkinnedMeshRenderer29GetValidBlendShapeWeightCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 428 >> 2] | 0;
 i2 = HEAP32[i1 + 412 >> 2] | 0;
 i3 = i1 + 416 | 0;
 i1 = i4 >>> 0 < i2 >>> 0 ? i4 : i2;
 while (1) {
  i2 = i1 + -1 | 0;
  if ((i2 | 0) <= -1) {
   i1 = 0;
   i2 = 4;
   break;
  }
  if (Math_fround(HEAPF32[(HEAP32[i3 >> 2] | 0) + (i2 << 2) >> 2]) > Math_fround(.0000999999974)) {
   i2 = 4;
   break;
  } else i1 = i2;
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN5physx3Cct10Controller13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, d4 = 0.0;
 d4 = +Math_fround(HEAPF32[i1 >> 2]);
 i3 = i2 + 408 | 0;
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] - d4;
 d4 = +Math_fround(HEAPF32[i1 + 4 >> 2]);
 i3 = i2 + 416 | 0;
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] - d4;
 d4 = +Math_fround(HEAPF32[i1 + 8 >> 2]);
 i3 = i2 + 424 | 0;
 HEAPF64[i3 >> 3] = +HEAPF64[i3 >> 3] - d4;
 __ZN5physx3Cct9SweepTest13onOriginShiftERKNS_6PxVec3E(i2 + 88 | 0, i1);
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 98548 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN19ConstantBuffersGLES12RecordRenderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 12 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 i3 = (HEAP32[i1 + 16 >> 2] | 0) - i2 | 0;
 i4 = (i3 | 0) / 12 | 0;
 if ((i3 | 0) <= 0) return;
 i1 = 0;
 while (1) {
  i3 = HEAP32[i2 + (i1 * 12 | 0) + 4 >> 2] | 0;
  if (i3 | 0) if ((HEAP16[i2 + (i1 * 12 | 0) + 8 >> 1] | 0) > -1) __ZN14DataBufferGLES12RecordRenderEv(i3);
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) break;
  i2 = HEAP32[i5 >> 2] | 0;
 }
 return;
}

function __ZN14BillboardAsset8SetWidthEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = (HEAP32[i3 + 32 >> 2] | 0) + 16 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f2)) return;
 HEAPF32[i1 >> 2] = f2;
 i4 = i3 + 40 | 0;
 i1 = HEAP32[i3 + 44 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  i5 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 4 >> 2] | 0, i5 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 228 >> 2] | 0;
 i1 = HEAP32[i1 + 224 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = i2 - i1 >> 2;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z7GetBitsPKhRjj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i7 = 0, i8 = 0;
 if (!i6) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = HEAP32[i5 >> 2] | 0;
 i3 = i7 >>> 3;
 i4 = i7 - (i3 << 3) | 0;
 i2 = HEAP8[i1 + i3 >> 0] | 0;
 if ((i4 + i6 | 0) >>> 0 > 8) {
  i8 = 8 - i4 | 0;
  i1 = ((HEAPU8[i1 + (i3 + 1) >> 0] | 0) & (1 << i6 - i8) + -1) << i8 | (i2 & 255) >>> i4;
 } else i1 = (i2 & 255) >>> i4 & (1 << i6) + 255;
 HEAP32[i5 >> 2] = i7 + i6;
 i8 = i1 & 255;
 return i8 | 0;
}

function __Z53Quaternion_CUSTOM_INTERNAL_CALL_Internal_FromEulerRadRK8Vector3fR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE(i4, i1, 4);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __Z39SystemInfo_Get_Custom_PropProcessorTypev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZN10systeminfo16GetProcessorTypeEv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z38TextGenerator_Get_Custom_PropLineCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   if (!(HEAP8[i1 + 60 >> 0] | 0)) {
    i2 = 0;
    STACKTOP = i3;
    return i2 | 0;
   }
   i2 = HEAP32[i1 + 52 >> 2] | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z33Sprite_CUSTOM_INTERNAL_get_borderP12Il2CppObjectP8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 56 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Camera_Get_Custom_PropPixelWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK6Camera24GetScreenViewportRectIntEv(i2, i3);
   STACKTOP = i4;
   return HEAP32[i2 + 8 >> 2] | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z27NavMeshAgent_CUSTOM_SetPathP12Il2CppObjectS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3); else return (__ZN12NavMeshAgent7SetPathEPK11NavMeshPath(i2, i1) | 0) & 1 | 0;
 return 0;
}

function __Z27Light_Set_Custom_PropCookieP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN5Light9SetCookieEP7Texture(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN5Light9SetCookieEP7Texture(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z17SetConsoleLogPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1450760 >> 2] | 0, gb + 63176 | 0);
 i1 = (_strlen(i2) | 0) + 1 | 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63176 | 0, 0, gb + 582853 | 0, 122) | 0;
 HEAP32[gb + 1450760 >> 2] = i3;
 _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
 return;
}

function _gzprintf(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 16 | 0;
 i7 = i5;
 i6 = i4 + 4095 | 0;
 HEAP8[i6 >> 0] = 0;
 HEAP32[i7 >> 2] = i2;
 i1 = _vsnprintf(i4, 4096, i1, i7) | 0;
 if (!((i1 + -1 | 0) >>> 0 < 4095 & (HEAP8[i6 >> 0] | 0) == 0)) {
  i7 = 0;
  STACKTOP = i5;
  return i7 | 0;
 }
 i7 = _gzwrite(i3, i4, i1) | 0;
 STACKTOP = i5;
 return i7 | 0;
}

function _cff_get_interface(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = _UNITY_ft_service_list_lookup(HEAP32[HEAP32[i1 + 196 >> 2] >> 2] | 0, i3) | 0;
 if (i2 | 0) {
  i3 = i2;
  return i3 | 0;
 }
 i1 = _UNITY_FT_Get_Module(i1, gb + 1007772 | 0) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i3 | 0) | 0;
 return i3 | 0;
}

function _bind(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i4 + 8 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = 0;
 HEAP32[i6 + 20 >> 2] = 0;
 HEAP32[i5 >> 2] = 2;
 HEAP32[i5 + 4 >> 2] = i6;
 i3 = ___syscall_ret(___syscall102(102, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__25mutex6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2796 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
 if (!i1) return; else {
  __THREW__ = 0;
  invoke_viiii(fb + 363 | 0, gb + 1082283 | 0, gb + 1082291 | 0, 48, gb + 1082369 | 0);
  __THREW__ = 0;
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 }
}

function __ZNK19ShaderPropertySheet11HasPropertyERKN9ShaderLab16FastPropertyNameE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 2) >> 2] | 0) == (i2 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK17AnimationPlayable27GetNextCompatibleDescendantEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 while (1) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) {
   i1 = 0;
   i2 = 6;
   break;
  }
  i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 6;
   break;
  }
  if (!(HEAP32[i1 + 16 >> 2] | 0)) {
   i2 = 6;
   break;
  } else i2 = 0;
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZNK15MonoScriptCache7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = __Z19GetScriptingManagerv() | 0;
  __ZN16ScriptingManager24NotifyScriptCacheReleaseEi(i2, HEAP32[i1 + 32 >> 2] | 0);
  return;
 }
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63728 | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i1 + 1304 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx18RepXSerializerImplINS_11PxAggregateEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i5, i3, i4, i6, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_ii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0) | 0;
 __ZN5physx24PxAggregateGeneratedInfoC2Ev(i1);
 STACKTOP = i1;
 return 1;
}

function __ZN5physx12NpConstraintD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 93148 + 8;
 if (HEAP16[i1 + 6 >> 1] & 1) {
  i3 = HEAP32[i1 + 56 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0);
 }
 __ZN5physx9NpFactory19onConstraintReleaseEPNS_12PxConstraintE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra8QueryExt22buildPlaneShadowCullerERNS_15ShadowCullerExtERKNS_15CameraTransformERKNS_7Vector3EPfjPPS4_i(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = i2 + 15 & -16;
 __ZN5Umbra15ImpShadowCullerC2Ev(i2);
 return __ZN5UmbraL21buildShadowCullerImplEPNS_8QueryExtEPNS_15ImpShadowCullerEPKNS_10VisibilityEPKNS_15CameraTransformERKNS_7Vector3EPSB_iPfjPS9_i(i1, i2, 0, i3, i4, 0, 0, i5, i6, i7, i8) | 0;
}

function __ZN19UnityConnectService18HandleSessionStateEb(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = __Z20GetPlayerSettingsPtrv() | 0;
 if (!i1) return;
 if (!(__ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) | 0)) return;
 if (!(__Z20IsHumanControllingUsv() | 0)) return;
 i1 = _time(0) | 0;
 i2 = i3 + 64 | 0;
 if (i4) {
  HEAP32[i2 >> 2] = i1;
  return;
 }
 if ((i1 - (HEAP32[i2 >> 2] | 0) | 0) >>> 0 <= 1800) return;
 HEAP32[i2 >> 2] = 0;
 __ZN19UnityConnectService13ReportSessionEv(i3);
 return;
}

function __ZN11UnityEngine9Animation29SkeletonFindNodeIndexByNameIDEPKN7mecanim9animation14AvatarConstantEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = i1 + 16 | 0;
 i3 = i2;
 i1 = 0;
 while (1) {
  if ((i1 | 0) >= (i5 | 0)) {
   i1 = -1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == -1 ? 1 : (HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2] | 0) != (i4 | 0)) i1 = i1 + 1 | 0; else {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z13TransferFieldI9JSONWriteLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z49DownloadHandlerAudioClip_Get_Custom_PropAudioClipP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN24DownloadHandlerAudioClip12GetAudioClipEv(i1) | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027975 | 0, i2);
 return 0;
}

function __Z46Quaternion_CUSTOM_INTERNAL_CALL_FromToRotationRK8Vector3fS1_R11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __Z20FromToQuaternionSafeRK8Vector3fS1_(i5, i1, i2);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 STACKTOP = i4;
 return;
}

function __Z46Application_Get_Custom_PropStreamingAssetsPathv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z22GetStreamingAssetsPathv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z43UploadHandlerRaw_CUSTOM_InternalGetProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029222 | 0, i2);
 return Math_fround(0.0);
}

function __Z32setPxVehicleWheelsMWheelsDynDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsDynDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE7copyfmtERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) != (i2 | 0)) {
  __ZNSt3__28ios_base16__call_callbacksENS0_5eventE(i1, 0);
  __ZNSt3__28ios_base7copyfmtERKS0_(i1, i2);
  HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 72 >> 2];
  HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
  __ZNSt3__28ios_base16__call_callbacksENS0_5eventE(i1, 2);
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | 0);
 }
 return i1 | 0;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE7copyfmtERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) != (i2 | 0)) {
  __ZNSt3__28ios_base16__call_callbacksENS0_5eventE(i1, 0);
  __ZNSt3__28ios_base7copyfmtERKS0_(i1, i2);
  HEAP32[i1 + 72 >> 2] = HEAP32[i2 + 72 >> 2];
  HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
  __ZNSt3__28ios_base16__call_callbacksENS0_5eventE(i1, 2);
  HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
  __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | 0);
 }
 return i1 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx19clothTriangleWriterERNS_14PxOutputStreamERKNS_24PxClothCollisionTriangleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2) | 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
 i1 = __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2 + 12 | 0) | 0;
 mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, gb + 1086395 | 0, 1) | 0;
 __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E(i1, i2 + 24 | 0) | 0;
 return;
}

function __ZN17PhysicsMaterial2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 32 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 36 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e5);
 f2 = i4 ? Math_fround(1.0e5) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN16PlayerConnectionD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65632 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 224 | 0);
 __ZN6SocketD2Ev(i1 + 192 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 180 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 168 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 152 | 0);
 __ZN17GeneralConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14MessageHandler15MessageNameToIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i2 + 64 | 0, i1) | 0;
 if ((i1 | 0) == (i2 + 68 | 0)) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 return i2 | 0;
}

function __ZN12_GLOBAL__N_117createClothFabricERN5physx13PxInputStreamE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN5physx9NpFactory19createNpClothFabricEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (__ZN5physx13NpClothFabric4loadERNS_13PxInputStreamE(i2, i1) | 0) return i2 | 0;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) {
  i2 = 0;
  return i2 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i2 = 0;
 return i2 | 0;
}

function __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetCycleCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = ~~Math_fround(HEAPF32[(HEAP32[i2 + 864 >> 2] | 0) + 552 >> 2]);
 return i2 | 0;
}

function __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddExplosionForceP12Il2CppObjectfRK8Vector3fffi(i1, f2, i3, f4, f5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __ZN9Rigidbody17AddExplosionForceEfRK8Vector3fffi(i7, f2, i3, f4, f5, i6);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39RectTransform_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 }
 i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) {
  i3 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i3);
 } else {
  i1 = HEAP32[i3 + 172 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 168 >> 2];
  HEAP32[i2 + 4 >> 2] = i1;
  return;
 }
}

function __Z31Sprite_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 32 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z20IsValidTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 + -1 | 0) >>> 0 < 23 | (i1 + -10 | 0) >>> 0 < 3) return 1;
 i2 = i1 | 1;
 switch (i2 | 0) {
 case 25:
 case 27:
  return 1;
 default:
  {}
 }
 if ((i1 + -48 | 0) >>> 0 < 12) return 1;
 switch (i1 | 0) {
 case 28:
 case 29:
 case 30:
 case 31:
 case 32:
 case 33:
 case 34:
 case 35:
 case 36:
 case 41:
 case 42:
 case 43:
 case 44:
 case 45:
 case 46:
 case 47:
  return 1;
 default:
  return (i2 | 0) == 61 | 0;
 }
 return 0;
}

function _UNITY_ft_glyphslot_set_bitmap(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 156 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) if (HEAP32[i4 + 4 >> 2] & 1 | 0) {
  i4 = i1 + 88 | 0;
  _UNITY_ft_mem_free(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  HEAP32[i4 >> 2] = 0;
  i3 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -2;
  HEAP32[i4 >> 2] = i2;
  return;
 }
 i4 = i1 + 88 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 >> 2] = i2;
 return;
}

function _shutdown(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 i2 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 13;
 HEAP32[i4 + 4 >> 2] = i5;
 i2 = ___syscall_ret(___syscall102(102, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _readdir_r(i1, i3, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 var i2 = 0, i4 = 0, i5 = 0, i7 = 0;
 i4 = ___errno_location() | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i7 = i1 + 16 | 0;
 ___lock(i7 | 0);
 HEAP32[i4 >> 2] = 0;
 i2 = _readdir(i1) | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = i5;
  if (!i2) i1 = 0; else {
   _memcpy(i3 | 0, i2 | 0, HEAPU16[i2 + 8 >> 1] | 0 | 0) | 0;
   i1 = i3;
  }
  ___unlock(i7 | 0);
  HEAP32[i6 >> 2] = i1;
  i1 = 0;
 } else ___unlock(i7 | 0);
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __THREW__ = 0;
 i3 = invoke_ii(fb + 2806 | 0, i2 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 if (!(i4 & 1)) {
  __THREW__ = 0;
  i1 = invoke_iiiiii(fb + 195 | 0, i1 | 0, 0, -1, i2 | 0, i3 | 0) | 0;
  i4 = __THREW__;
  __THREW__ = 0;
  if (!(i4 & 1)) return i1 | 0;
 }
 i4 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___clang_call_terminate(i4);
 return 0;
}

function __ZNK5physx9NpFactory9getShapesEPPNS_7PxShapeEjj(i3, i5, i2, i4) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 + 640 >> 2] | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = i1 - i4 | 0;
 i1 = i1 >>> 0 > i2 >>> 0 ? i1 : i2;
 i2 = HEAP32[i3 + 608 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 } else i3 = 0;
 do {
  HEAP32[i5 + (i3 << 2) >> 2] = HEAP32[i2 + (i3 + i4 << 2) >> 2];
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return i1 | 0;
}

function __ZNK5physx7NpShape14getBoxGeometryERNS_13PxBoxGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 3) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP32[i2 + 36 >> 2] & 1)) i2 = 3; else {
  i2 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
  i1 = i2;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i3 = 1;
 return i3 | 0;
}

function __ZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 i6 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i6 >> 2] = 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_(i2, i2, i5, i6, i1, i3);
 STACKTOP = i4;
 return HEAP32[i5 >> 2] | 0;
}

function __ZNK22RenderingCommandBuffer15FindTempRTIndexERKN9ShaderLab16FastPropertyNameE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 60 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 3) >> 2] | 0) == (i2 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN9Rigidbody19SetSolverIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i5 = HEAP32[i6 + 292 >> 2] | 0;
 mftCall_viii(HEAP32[i6 + 296 >> 2] | 0, i1 | 0, i3 + 4 | 0, i4 | 0);
 mftCall_viii(i5 | 0, i1 | 0, ((i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2) | 0, HEAP32[i4 >> 2] | 0);
 STACKTOP = i3;
 return;
}

function __ZN9AudioClip7SetDataEPKfjj(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i5 = 0;
  return i5 | 0;
 }
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!(__ZN14SoundHandleAPI7SetDataEPKfjj(i1, i3, i4, i5) | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 __ZN12SoundManager20RegisterModifiedClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i2);
 i5 = 1;
 return i5 | 0;
}

function __ZN9Animation8SetClipsERKNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 284 | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 return;
}

function __ZN5physx8debugger4comm8SetColor9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 17 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 18 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 + 19 | 0);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148596 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx2Cm10CollectionD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = gb + 110532 + 8;
 i1 = i3 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i3);
 STACKTOP = i4;
 return;
}

function __ZN5Umbra10VisibilityaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return i1 | 0;
}

function __ZN4crnd15crnd_get_headerERNS_10crn_headerEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) == 0 | i3 >>> 0 < 74) return 0;
 if (((HEAPU8[i2 >> 0] | 0) << 8 | (HEAPU8[i2 + 1 >> 0] | 0) | 0) != 18552) return 0;
 if (((HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0)) >>> 0 < 74) return 0; else return (((HEAPU8[i2 + 7 >> 0] | 0) << 16 | (HEAPU8[i2 + 6 >> 0] | 0) << 24 | (HEAPU8[i2 + 8 >> 0] | 0) << 8 | (HEAPU8[i2 + 9 >> 0] | 0)) >>> 0 > i3 >>> 0 ? 0 : i2) | 0;
 return 0;
}

function __ZN26SizeModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 852 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 852 >> 2] | 0) + 352 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 852 >> 2] | 0) + 616 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN14UnityWebStream26WaitForThreadDecompressionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[i1 + 20 >> 0] | 0) return;
 if (!(HEAP32[i1 + 40 >> 2] | 0)) return;
 if (!(HEAP8[i1 + 19 >> 0] | 0)) return;
 HEAP8[i1 + 16 >> 0] = 1;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 __ZN14UnityWebStream7ReleaseEv(i1);
 return;
}

function __Z60GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_GetWindowRectiR5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN5IMGUI13GetWindowRectER8GUIStatei(i4, __Z11GetGUIStatev() | 0, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __Z43MaterialPropertyBlock_CUSTOM_GetVectorArrayP12Il2CppObjecti(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i4 = __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i1, i2, 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z42Vector3_CUSTOM_INTERNAL_CALL_RotateTowardsRK8Vector3fS1_ffRS_(i1, i2, f3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 __Z13RotateTowardsRK8Vector3fS1_ff(i7, i1, i2, f3, f4);
 HEAP32[i5 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i7 + 4 >> 2];
 HEAP32[i5 + 8 >> 2] = HEAP32[i7 + 8 >> 2];
 STACKTOP = i6;
 return;
}

function __ZN5physx7NpScene17flushQueryUpdatesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i1 + 3696 >> 0] | 0)) {
  __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv(i1 + 3392 | 0);
  STACKTOP = i2;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 2381, gb + 705224 | 0, i2);
  STACKTOP = i2;
  return;
 }
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5Umbra15CameraTransform10setFrustumERKNS_7FrustumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = i1 + 404 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i3 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP8[i1 + 436 >> 0] = 1;
 return;
}

function __ZN19RuntimeSceneManager8GetSceneEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 L1 : do if (i4) {
  while (1) {
   if ((HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0) == (i3 | 0)) break L1;
   i1 = i1 + 4 | 0;
   if ((i1 | 0) == (i2 | 0)) {
    i1 = 0;
    break;
   }
  }
  return i1 | 0;
 } while (0);
 if ((i1 | 0) == (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = HEAP32[i1 >> 2] | 0;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 150816 + 8;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  _fflush(i2) | 0;
  _fclose(HEAP32[i1 >> 2] | 0) | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = gb + 148172 + 8;
 i2 = i3 + 24 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i3 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __Z44AnimationState_Get_Custom_PropNormalizedTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+HEAPF64[i1 + 16 >> 3] / +Math_fround(HEAPF32[i1 + 92 >> 2]));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z37Mesh_Get_Custom_PropVertexBufferCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b(i1, i2, HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 96 >> 2] | 0, 0, 0) | 0;
 STACKTOP = i3;
 return HEAP32[i2 + 4 >> 2] | 0;
}

function __Z32Mesh_Set_Custom_PropSubMeshCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) < 0) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547377 | 0, 0, gb + 546865 | 0, 537, 1, 0, 0, 0);
  return;
 }
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN4Mesh15SetSubMeshCountEjb(i3, i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32AudioMixerReceiveProcessCallbackP21UnityAudioEffectStatePfS1_jii(i1, i6, i7, i3, i4, i2) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, f8 = f0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = Math_imul(i4, i3) | 0;
 if (!i2) return 0; else i1 = 0;
 do {
  f8 = Math_fround(HEAPF32[i6 + (i1 << 2) >> 2]);
  HEAPF32[i7 + (i1 << 2) >> 2] = Math_fround(f8 + Math_fround(HEAPF32[i5 + (i1 << 2) >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return 0;
}

function __Z28AnimationCurve_CUSTOM_AddKeyP12Il2CppObjectff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i4 = __Z20AddKeySmoothTangentsR17AnimationCurveTplIfEff(i1, f2, f3) | 0;
   STACKTOP = i5;
   return i4 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
 return 0;
}

function __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4527 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211540 + 8;
  return;
 }
}

function __ZN6Object24SetCachedScriptingObjectEP12Il2CppObject(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (i1 | 0) {
  HEAP32[i3 + 16 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i1) | 0;
  HEAP32[i3 + 20 >> 2] = i1;
  return;
 }
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN9Scripting30SetCachedPtrOnScriptingWrapperEP12Il2CppObjectP6Object(i2, 0);
 i3 = i3 + 16 | 0;
 __Z23scripting_gchandle_freej(HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx19processDigitalValueEjRKNS_25PxVehicleKeySmoothingDataEbff(i3, i4, i2, f5, f1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 f1 = Math_fround(f1);
 if (i2) f1 = Math_fround(Math_fround(Math_fround(HEAPF32[i4 + (i3 << 2) >> 2]) * f5) + f1); else f1 = Math_fround(f1 - Math_fround(Math_fround(HEAPF32[i4 + 64 + (i3 << 2) >> 2]) * f5));
 i4 = f1 < Math_fround(0.0);
 f5 = i4 ? Math_fround(0.0) : f1;
 i4 = f5 > Math_fround(1.0);
 return Math_fround(i4 ? Math_fround(1.0) : f5);
}

function __ZN5physx14PxVehicleDrive14setToRestStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN5physx15PxVehicleWheels14setToRestStateEv(i1);
 i2 = i1 + 128 | 0;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 193 >> 0] = 0;
 HEAP8[i1 + 194 >> 0] = 0;
 HEAP32[i1 + 196 >> 2] = 1;
 HEAP32[i1 + 200 >> 2] = 1;
 HEAPF32[i1 + 208 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(0.0);
 return;
}

function __ZN4crnd10dxt1_block10pack_colorERKNS_10color_quadIhiEEbj(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAPU8[i3 >> 0] | 0;
 i2 = HEAPU8[i3 + 1 >> 0] | 0;
 i3 = HEAPU8[i3 + 2 >> 0] | 0;
 if (i4) {
  i3 = (((i3 * 31 | 0) + i5 | 0) >>> 0) / 255 | 0;
  i2 = (((i2 * 63 | 0) + i5 | 0) >>> 0) / 255 | 0;
  i1 = (((i1 * 31 | 0) + i5 | 0) >>> 0) / 255 | 0;
 }
 return ((i2 >>> 0 < 63 ? i2 : 63) << 5 | (i1 >>> 0 < 31 ? i1 : 31) << 11 | (i3 >>> 0 < 31 ? i3 : 31)) & 65535 | 0;
}

function __ZN21ProceduralTextureDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 1;
 HEAP8[i1 + 29 >> 0] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP8[i2 + 20 >> 0] = 0;
 return;
}

function __Z26Light_Get_Custom_PropRangeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = HEAP32[i2 + 44 >> 2] | 0;
  return Math_fround(HEAPF32[((HEAP32[i2 + 40 >> 2] | 0) == 3 ? i2 + 204 | 0 : i2 + 48 | 0) >> 2]);
 }
 return Math_fround(0.0);
}

function mftCall_iiiifififf(i10, i1, i2, i3, d4, i5, d6, i7, d8, d9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 d8 = +d8;
 d9 = +d9;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifififf[i10 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, Math_fround(d6), i7 | 0, Math_fround(d8), Math_fround(d9)) | 0;
 return ftCall_iiiifififf(i10 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, +d6, i7 | 0, +d8, +d9) | 0;
}

function mftCall_iiifiififf(i10, i1, i2, d3, i4, i5, d6, i7, d8, d9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 d8 = +d8;
 d9 = +d9;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiifiififf[i10 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, Math_fround(d8), Math_fround(d9)) | 0;
 return ftCall_iiifiififf(i10 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, +d6, i7 | 0, +d8, +d9) | 0;
}

function _listen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 8 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 i2 = i5 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 4;
 HEAP32[i4 + 4 >> 2] = i5;
 i2 = ___syscall_ret(___syscall102(102, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEjw(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = i1 + 8 + 3 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = (HEAP32[i2 >> 2] | 0) - i3 >> 2;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw(i1, i2, i4, i5) | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i2 << 2) | 0;
}

function __ZNK9GfxDevice14GetBufferBytesE14GfxBufferLabel15GfxBufferTarget(i1, i5, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 4516 + (i2 << 2) >> 2] | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) {
  i5 = 0;
  return i5 | 0;
 } else i1 = 0;
 do {
  i3 = (i2 | 0) == 0 ? 0 : i2 + -4 | 0;
  if ((HEAP32[i3 + 20 >> 2] | 0) == (i5 | 0)) i1 = (HEAP32[i3 + 24 >> 2] | 0) + i1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZN9WWWCached14BlockUntilDoneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) return;
 i2 = i1 + 88 | 0;
 i3 = i1 + 92 | 0;
 do {
  i4 = HEAP32[i2 >> 2] | 0;
  if (i4 | 0) mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 64 >> 2] | 0, i4 | 0);
  if (HEAP32[i3 >> 2] | 0) __ZN14PreloadManager16UpdatePreloadingEv(__Z17GetPreloadManagerv() | 0);
 } while (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0));
 return;
}

function __ZN5physx3Cct9SweepTest13voidTestCacheEv(i1) {
 i1 = i1 | 0;
 HEAPF64[i1 + 48 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i1 + 56 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i1 + 64 >> 3] = 1797693134862315708145274.0e284;
 HEAPF64[i1 + 72 >> 3] = -1797693134862315708145274.0e284;
 HEAPF64[i1 + 80 >> 3] = -1797693134862315708145274.0e284;
 HEAPF64[i1 + 88 >> 3] = -1797693134862315708145274.0e284;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = -1;
 return;
}

function __ZN5physx35solveExtContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i5 = i4 + (i1 << 5) | 0;
  __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, 0);
  __ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx25solveContact_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (i3 >>> 0 > 1) {
  i1 = 1;
  do {
   __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i1 + -1 << 5) | 0, i2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i3 + -1 << 5) | 0, i2);
 return;
}

function __ZN5physx21PxcUnimplementedSweepERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i1, i2, i7, i8, i9, i10, i11, i12, f13, i14, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 return Math_fround(3402823469999999843913219.0e14);
}

function __ZN5physx13NpVolumeCache13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i4 = i2 + 60 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f3);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i4 = i2 + 64 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f3);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i2 = i2 + 68 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 return;
}

function __ZN21AnimationClipPlayable19DeallocateResourcesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 72 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  HEAP8[i2 >> 0] = 0;
  __ZN8Playable19DeallocateResourcesEv(i1);
  return;
 }
 i3 = i1 + 92 | 0;
 __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i1 + 60 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP8[i2 >> 0] = 0;
 __ZN8Playable19DeallocateResourcesEv(i1);
 return;
}

function __ZN13RuntimeStaticI19UnityPluginRegistryE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~(((i7 + -24 - i5 | 0) >>> 0) / 24 | 0) * 24 | 0);
   __ZdlPv(i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z6AppendPKcS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i5 = _strlen(i2) | 0;
 i4 = _strlen(i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj(i1, i4 + i5 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i2, i5) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i3, i4) | 0;
 return;
}

function __Z38AsyncOperation_Get_Custom_PropProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z34RemapMonoBehaviourToBuiltinClassIDRK14FileIdentifierx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = (__Z6StrCmpPKcS0_((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, gb + 588322 | 0) | 0) == 0;
 if (!((i2 | 0) == 12e3 & (i3 | 0) == 0)) return -1;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) if (!(HEAP32[i1 + 24 >> 2] | 0)) if ((HEAP32[i1 + 28 >> 2] | 0) == 14) i1 = (HEAP32[i1 + 32 >> 2] | 0) == 0; else i1 = 0; else i1 = 0; else i1 = 0;
 return (i4 | i1 ? 218 : -1) | 0;
}

function __Z20GL_CUSTOM_PushMatrixv() {
 var i1 = 0, i2 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1180120 | 0, i2);
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1179092 | 0, i2);
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 __ZN11MatrixStack4PushERK10Matrix4x4f(gb + 1181148 | 0, i1);
 return;
}

function _gzsetparams(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!i1) {
  i4 = -2;
  return i4 | 0;
 }
 if ((HEAP8[i1 + 92 >> 0] | 0) != 119) {
  i4 = -2;
  return i4 | 0;
 }
 i4 = i1 + 16 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) {
  i5 = HEAP32[i1 + 72 >> 2] | 0;
  HEAP32[i1 + 12 >> 2] = i5;
  if ((_fwrite(i5, 1, 16384, HEAP32[i1 + 64 >> 2] | 0) | 0) != 16384) HEAP32[i1 + 56 >> 2] = -1;
  HEAP32[i4 >> 2] = 16384;
 }
 i5 = _unity_z_deflateParams(i1, i2, i3) | 0;
 return i5 | 0;
}

function ___stdout_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i1 + 36 >> 2] = fb + 295;
 if (!(HEAP32[i1 >> 2] & 64)) {
  HEAP32[i4 >> 2] = HEAP32[i1 + 60 >> 2];
  HEAP32[i4 + 4 >> 2] = 21505;
  HEAP32[i4 + 8 >> 2] = i5 + 12;
  if (___syscall54(54, i4 | 0) | 0) HEAP8[i1 + 75 >> 0] = -1;
 }
 i4 = ___stdio_write(i1, i2, i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj(i3 + -4 | 0, i6, i1, i2);
 STACKTOP = i5;
 return;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i2, i3, i4, i5, i6, i7) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i1 = 0, i8 = 0;
 i8 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i8 >> 8;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 + i1 | 0, (i8 & 2 | 0 ? i6 : 2) | 0, i7 | 0);
 return;
}

function __ZN5physx8readWordEbRNS_13PxInputStreamE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i1 | 0, 2) | 0;
 if (!i2) {
  i3 = HEAP16[i1 >> 1] | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 i3 = HEAP16[i1 >> 1] | 0;
 HEAP8[i1 >> 0] = (i3 & 65535) >>> 8;
 HEAP8[i1 + 1 >> 0] = i3;
 i3 = HEAP16[i1 >> 1] | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Sn5ConvX11alignStreamEPKci(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0;
 i5 = i1 + -1 | 0;
 i2 = i1 - (i5 & i3) & i5;
 i1 = i1 - ((__ZN5physx2Sn5ConvX20getCurrentOutputSizeEv(i4) | 0) & i5) & i5;
 if ((i1 | 0) == (i2 | 0)) {
  __ZN5physx2Sn5ConvX6outputEPKci(i4, i4 + 36 | 0, i2);
  i5 = i3 + i2 | 0;
  return i5 | 0;
 }
 if (!i1) {
  i5 = i3 + i2 | 0;
  return i5 | 0;
 }
 __ZN5physx2Sn5ConvX6outputEPKci(i4, i4 + 36 | 0, i1);
 i5 = i3 + i2 | 0;
 return i5 | 0;
}

function __ZN5physx23PxVehicleDriveSimData4W11setDiffDataERKNS_27PxVehicleDifferential4WDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 528 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZN4crnd10dxt1_block12unpack_colorERjS1_S1_tb(i6, i7, i8, i1, i5) {
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 & 65535;
 i1 = i4 & 31;
 i2 = i4 >>> 5 & 63;
 i3 = i4 >>> 11;
 if (i5) {
  i3 = i3 << 3 | i4 >>> 13;
  i2 = i2 << 2 | i2 >>> 4;
  i1 = i1 << 3 | i1 >>> 2;
 }
 HEAP32[i6 >> 2] = ((i3 | 0) > 255 ? 255 : i3) & 255;
 HEAP32[i7 >> 2] = ((i2 | 0) > 255 ? 255 : i2) & 255;
 HEAP32[i8 >> 2] = ((i1 | 0) > 255 ? 255 : i1) & 255;
 return;
}

function __ZN20OcclusionCullingData12SetUmbraTomeEPKhi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = i1 + 32 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i4 = __Z9GetIUmbrav() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 if (!i3) {
  i4 = 0;
  HEAP32[i1 >> 2] = i4;
  return;
 }
 i4 = __Z9GetIUmbrav() | 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i2 | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = i4;
 return;
}

function __ZN14TimerQueryGLESC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 77312 + 8;
 HEAP8[i2 + 12 >> 0] = 0;
 i1 = HEAP32[gb + 1098256 + 512 >> 2] | 0;
 if (!i1) {
  mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 792 >> 2] | 0, 128, gb + 1098256 | 0);
  HEAP32[gb + 1098256 + 512 >> 2] = 128;
  i1 = 128;
 }
 i1 = i1 + -1 | 0;
 HEAP32[gb + 1098256 + 512 >> 2] = i1;
 HEAP32[i2 + 16 >> 2] = HEAP32[gb + 1098256 + (i1 << 2) >> 2];
 return;
}

function __ZN13SplatDatabaseD2Ev(i5) {
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i5 + 12 >> 2] | 0;
 i2 = i1;
 if (i1 | 0) {
  i3 = i5 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i1 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
  __ZdlPv(i1);
 }
 i3 = HEAP32[i5 >> 2] | 0;
 if (!i3) return;
 i1 = i5 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = HEAP32[i2 >> 2] | 0;
  i5 = i4;
  if (i4 | 0) {
   i6 = i2 + 4 | 0;
   i7 = HEAP32[i6 >> 2] | 0;
   if ((i7 | 0) != (i4 | 0)) HEAP32[i6 >> 2] = i7 + (~((i7 + -4 - i5 | 0) >>> 2) << 2);
   __ZdlPv(i4);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13BaseAllocator17LogAllocationInfoEPKvjPKPvj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 4112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = i4;
 HEAP32[i5 + 4 >> 2] = i3;
 __Z12FormatBufferPciPKcz(i2, 4096, gb + 364584 | 0, i5);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i2, 0, gb + 364615 | 0, 55, 4, 0, 0, 0);
 STACKTOP = i1;
 return;
}

function __ZN11OffMeshLink15SetCostOverrideEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 84 | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) == f2) return;
 HEAPF32[i3 >> 2] = f2;
 i1 = i1 + 40 | 0;
 i4 = i1;
 if ((HEAP32[i4 >> 2] | 0) == 0 & (HEAP32[i4 + 4 >> 2] | 0) == 0) return;
 i5 = __Z17GetNavMeshManagerv() | 0;
 i4 = i1;
 __ZN14NavMeshManager32SetOffMeshConnectionCostOverrideEyf(i5, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0, Math_fround(HEAPF32[i3 >> 2]));
 return;
}

function __ZN11NavMeshPathC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __Z52Event_CUSTOM_INTERNAL_CALL_Internal_SetMousePositionP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z48GUIStyle_CUSTOM_INTERNAL_set_Internal_clipOffsetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 268 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 272 >> 2] = HEAP32[i2 + 4 >> 2];
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z43MaterialPropertyBlock_CUSTOM_GetMatrixArrayP12Il2CppObjecti(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i4 = __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i1, i2) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z41RenderTexture_Get_Custom_PropIsPowerOfTwoP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 if (i1 + -1 & i1 | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 84 >> 2] | 0;
 i2 = (i2 + -1 & i2 | 0) == 0 & 1;
 return i2 | 0;
}

function __Z30Shader_CUSTOM_SetGlobalTextureiP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 4 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = i1;
 if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 __Z22SetShaderGlobalTextureN9ShaderLab16FastPropertyNameEP7Texture(i3, i1);
 STACKTOP = i5;
 return;
}

function __Z30Sampler_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i3 = i1 + 6 | 0;
   i1 = HEAPU16[i3 >> 1] | 0;
   HEAP16[i3 >> 1] = (i1 ^ (i2 << 24 >> 24 == 0) << 31 >> 31) & 32768 ^ i1;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z26tessMeshTessellateInteriorP8TESSmesh(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 44 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 while (1) {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  if (HEAP8[i2 + 21 >> 0] | 0) if (!(__Z28tessMeshTessellateMonoRegionP8TESSmeshP8TESSface(i3, i2) | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  if ((i1 | 0) == (i4 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z26Light_Set_Custom_PropFlareP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) {
    i2 = 0;
    __ZN5Light8SetFlareEP5Flare(i3, i2);
    return;
   }
   i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN5Light8SetFlareEP5Flare(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN6Camera20CleanupDepthTexturesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 1148 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = __Z22GetRenderBufferManagerv() | 0;
  __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i3, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 1152 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = __Z22GetRenderBufferManagerv() | 0;
 __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i3, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx3Ext14SphericalJoint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 120 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx3Ext14PrismaticJoint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 112 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 i2 = __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2 + 20 | 0, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx21PxProfileEventHandler21durationToNanosecondsEy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv() | 0;
 i3 = i4;
 i3 = ___muldi3(HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 i1 = getTempRet0() | 0;
 i2 = i4 + 8 | 0;
 i2 = ___udivdi3(i3 | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 i2 = ___muldi3(i2 | 0, getTempRet0() | 0, 10, 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function __ZN5CacheC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = i1 + 60;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i1 + 72;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 2147483647;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 >> 0] = 1;
 HEAP32[i1 + 48 >> 2] = 1296e4;
 return;
}

function __ZN22BaseUnityConnectClient11StopSessionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 113 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP8[i3 >> 0] = 1;
 i2 = i1 + 4 | 0;
 L4 : do if ((HEAP32[i2 >> 2] | 0) == 5) i1 = 0; else {
  switch (HEAP32[i2 >> 2] | 0) {
  case 5:
  case 0:
   {
    i1 = 0;
    break L4;
   }
  default:
   {}
  }
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
  i1 = 1;
 } while (0);
 HEAP8[i3 >> 0] = 0;
 i3 = i1;
 return i3 | 0;
}

function __ZN21DownloadHandlerScript21SetPreallocatedBufferEP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 56 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  __Z23scripting_gchandle_freej(i4);
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 52 >> 2] = 0;
  HEAP32[i1 + 60 >> 2] = 0;
 }
 if (!i2) return;
 HEAP32[i3 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i2) | 0;
 HEAP32[i1 + 52 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 return;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
 i1 = i1 + 44 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __Z7VFormatPKcPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 10256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 _vsnprintf(i5, 10240, i2, i6) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i5, _strlen(i5) | 0);
 STACKTOP = i4;
 return;
}

function __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 884 >> 2] | 0) + 1065 >> 0] | 0;
 return i2 | 0;
}

function __Z49Event_CUSTOM_INTERNAL_CALL_Internal_SetMouseDeltaP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __GLOBAL__sub_I_runtime_audio_lump_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1552711 | 0, fb + 3783 | 0, fb + 3784 | 0, 0, 0);
 HEAP32[gb + 1459940 >> 2] = 150994944;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459992 | 0, gb + 863777 | 0, 6, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1460004 | 0, gb + 863797 | 0, 6, 0);
 HEAPF32[gb + 1460016 >> 2] = Math_fround(-inf);
 return;
}

function _stbir_resize_uint8_srgb(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(0, i1, i2, i4, i5, i6, i7, i8, i9, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i10, i11, i3, 0, 0, 0, 1, 1, 1) | 0;
}

function _cargl(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 16 | 0;
 i5 = i2;
 d3 = +HEAPF64[i1 + 8 >> 3];
 HEAPF64[i5 >> 3] = +HEAPF64[i1 >> 3];
 HEAPF64[i5 + 8 >> 3] = d3;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 d3 = +_carg(i4);
 STACKTOP = i2;
 return +d3;
}

function _cabsl(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 16 | 0;
 i5 = i2;
 d3 = +HEAPF64[i1 + 8 >> 3];
 HEAPF64[i5 >> 3] = +HEAPF64[i1 >> 3];
 HEAPF64[i5 + 8 >> 3] = d3;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i5 + 12 >> 2];
 d3 = +_cabs(i4);
 STACKTOP = i2;
 return +d3;
}

function __ZN7ApiGLES24CommitSparseTexturePagesEj16TextureDimensioniiiiiiih(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 i4 = __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(HEAP32[i1 + 860 >> 2] | 0, i4) | 0;
 mftCall_viiiiiiiii(HEAP32[i1 + 820 >> 2] | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext13RevoluteJoint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 136 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[(HEAP32[i2 + 1008 >> 2] | 0) + 1150 >> 0] | 0)) {
  if (!i1) return;
  i2 = i2 + 1e3 | 0;
  __ZN5physx17PxcNpMemBlockPool15releaseContactsEv((HEAP32[i2 >> 2] | 0) + 44 | 0);
  __ZN5physx17PxcNpMemBlockPool15releaseContactsEv((HEAP32[i2 >> 2] | 0) + 44 | 0);
  return;
 } else {
  if (i1) return;
  __ZN5physx17PxcNpMemBlockPool15releaseContactsEv((HEAP32[i2 + 1e3 >> 2] | 0) + 44 | 0);
  return;
 }
}

function __Z61Playable_CUSTOM_INTERNAL_CALL_SetInputWeightFromIndexInternalR9HPlayableif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 if (!(HEAP32[i1 + 48 >> 2] & 2)) {
  __ZN8Playable14SetInputWeightEif(i1, i2, f3);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 550201 | 0, 0, gb + 550266 | 0, 251, 1, 0, 0, 0);
  return;
 }
}

function __Z42MaterialPropertyBlock_CUSTOM_GetFloatArrayP12Il2CppObjecti(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5 + 4 | 0;
 i4 = i5;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 i4 = __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i1, i2) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __GLOBAL__sub_I_runtime_dynamics_lump_cpp() {
 HEAP32[gb + 1452864 >> 2] = gb + 87484 + 8;
 HEAP32[gb + 1452868 >> 2] = gb + 87504 + 8;
 HEAP32[gb + 1452868 + 4 >> 2] = 0;
 HEAP32[gb + 1452868 + 8 >> 2] = 0;
 HEAP32[gb + 1452868 + 12 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452884 | 0, gb + 662564 | 0, 3, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452896 | 0, gb + 662594 | 0, 3, 0);
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE10deallocateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((i4 | 0) == (i2 | 0)) break;
   i5 = i4 + -4 | 0;
   HEAP32[i3 >> 2] = i5;
   i4 = i5;
  }
  if ((i1 + 16 | 0) == (i2 | 0)) HEAP8[i1 + 128 >> 0] = 0; else __ZdlPv(i2);
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 return;
}

function __ZNK9Transform16GetLocalRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i2 + 32 | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i6 = HEAP32[(HEAP32[i6 >> 2] | 0) + 8 >> 2] | 0;
 i4 = HEAP32[i6 + (i5 * 40 | 0) + 16 >> 2] | 0;
 i3 = HEAP32[i6 + (i5 * 40 | 0) + 20 >> 2] | 0;
 i2 = HEAP32[i6 + (i5 * 40 | 0) + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 + (i5 * 40 | 0) + 12 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN7mecanim9animation11DestroyClipEPNS0_4ClipERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5physx3Ext13DistanceJoint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 96 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 51 | 0;
 i1 = HEAP8[i2 >> 0] | 0;
 if (i1 & 1) {
  __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE(HEAP32[i3 + 36 >> 2] | 0, i3);
  i1 = HEAP8[i2 >> 0] | 0;
 }
 i4 = (i1 & 241 | i4) & 255;
 HEAP8[i2 >> 0] = i4;
 if (!(i4 & 1)) return;
 __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE(HEAP32[i3 + 36 >> 2] | 0, i3);
 return;
}

function __ZN5physx2Sc27ConstraintProjectionManager10groupUnionERNS0_19ConstraintGroupNodeES3_(i2, i1, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if ((i1 | 0) == (i4 | 0)) return;
 i2 = i4 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 > i3 >>> 0) {
  i2 = i1;
  i1 = i4;
 } else {
  HEAP32[i2 >> 2] = i3 + 1;
  i2 = i4;
 }
 HEAP32[i1 + 4 >> 2] = i2;
 i4 = i2 + 8 | 0;
 HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 i2 = __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2 + 20 | 0, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5Unity5Joint12WakeupActorsEPN5physx7PxJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 4 | 0;
 i3 = i1;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i4 | 0, i3 | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i4 >> 2] | 0);
 __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(HEAP32[i3 >> 2] | 0);
 STACKTOP = i1;
 return;
}

function __ZN24RigidbodyMovementState2D21SetInterpolationStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = i1 + 68 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i2 = i1 + 24 | 0;
 i3 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP8[i1 + 109 >> 0] = 1;
 return;
}

function __ZN16AnimationManager12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1465160 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63320 | 0);
 HEAP32[gb + 1465160 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(__Z33GetIAnimationStateNetworkProviderv() | 0, gb + 63400 | 0);
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(0);
 return;
}

function __ZN14CachingManager23GetCachingDiskSpaceFreeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i1 + 32 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = (i4 | 0) > (i1 | 0) | (i4 | 0) == (i1 | 0) & i5 >>> 0 > i3 >>> 0;
 i1 = _i64Subtract(i5 | 0, i4 | 0, i3 | 0, i1 | 0) | 0;
 i3 = getTempRet0() | 0;
 setTempRet0((i2 ? i3 : 0) | 0);
 return (i2 ? i1 : 0) | 0;
}

function __ZN12LightManager8AddLightEP5Light(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i1 + 36 | 0;
 if ((i4 | 0) == (i3 | 0)) return;
 i2 = HEAP32[i4 >> 2] | 0;
 if (!i2) i1 = i1 + 40 | 0; else {
  i1 = i1 + 40 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[HEAP32[i1 >> 2] >> 2] = i2;
  HEAP32[i4 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[HEAP32[i1 >> 2] >> 2] = i4;
 return;
}

function __Z69AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorStateInfoInternalR9HPlayablei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) return;
 __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, 0, i1) | 0;
 return;
}

function __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 884 >> 2] | 0) + 1064 >> 0] | 0;
 return i2 | 0;
}

function mftCall_viifififfi(i10, i1, i2, d3, i4, d5, i6, d7, d8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 d7 = +d7;
 d8 = +d8;
 i9 = i9 | 0;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viifififfi[i10 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5), i6 | 0, Math_fround(d7), Math_fround(d8), i9 | 0);
  return;
 }
 ftCall_viifififfi(i10 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5, i6 | 0, +d7, +d8, i9 | 0);
}

function _rintf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, f3 = f0;
 i2 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 if ((i2 & 2130706432) >>> 0 <= 1249902592) {
  i2 = (i2 | 0) < 0;
  f3 = Math_fround(Math_fround(f1 + Math_fround(-8388608.0)) + Math_fround(8388608.0));
  f1 = Math_fround(Math_fround(f1 + Math_fround(8388608.0)) + Math_fround(-8388608.0));
  f1 = i2 ? f3 : f1;
  if (f1 == Math_fround(0.0)) f1 = i2 ? Math_fround(-0.0) : Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZgeRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f4 >= Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f4 >= Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = f4 >= Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Ebbbb(i1, i7, i6, i5, f4 >= Math_fround(HEAPF32[i3 + 12 >> 2]));
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj(i4 + -4 | 0, i6, i1, i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9sputbackcEc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 12 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i2 + 8 >> 2] | 0) == (i1 | 0)) i5 = 3; else {
  i1 = i1 + -1 | 0;
  if ((HEAP8[i1 >> 0] | 0) == i3 << 24 >> 24) {
   HEAP32[i4 >> 2] = i1;
   i1 = HEAPU8[i1 >> 0] | 0;
  } else i5 = 3;
 }
 if ((i5 | 0) == 3) i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i3 & 255 | 0) | 0;
 return i1 | 0;
}

function __ZN7mecanim5human12DestroyHumanEPNS0_5HumanERNS_6memory9AllocatorE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 + i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP16[i4 + 2 >> 1] = 15360;
  HEAP16[i4 + 4 >> 1] = 15360;
  HEAP16[i4 + 6 >> 1] = 15360;
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN13MonoBehaviour25TransferEngineAndInstanceI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN13MonoBehaviour18TransferEngineDataI19StreamedBinaryWriteILb0EEEE4PPtrI10MonoScriptERT_(i1, i2) | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) return;
 i4 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI19StreamedBinaryWriteILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i4, HEAP32[i1 + 56 >> 2] | 0);
 return;
}

function __ZN11UnityEngine7Connect13ConfigHandler7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 return;
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUVChannelMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 864 >> 2] | 0) + 560 >> 2] | 0;
 return i2 | 0;
}

function __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetAnimationTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 864 >> 2] | 0) + 544 >> 2] | 0;
 return i2 | 0;
}

function __Z38Mesh_CUSTOM_GetBlendShapeFrameVerticesP12Il2CppObjectiiP11Il2CppArrayS2_S2_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 if (!i1) i1 = 0; else {
  i7 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i7) {
   __Z36GetBlendShapeFrameVerticesFromScriptRK4MeshiiP11Il2CppArrayS3_S3_(i7, i2, i3, i4, i5, i6);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31SetRelaunchApplicationArgumentsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) == (gb + 1170780 | 0)) return;
 __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_(gb + 1170780 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function mftCall_iiiiiifiif(i10, i1, i2, i3, i4, i5, d6, i7, i8, d9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 d9 = +d9;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiiiiifiif[i10 - fb & 7](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0, Math_fround(d9)) | 0;
 return ftCall_iiiiiifiif(i10 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0, +d9) | 0;
}

function _vsscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 112 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i6;
 i5 = i4;
 i7 = i5 + 112 | 0;
 do {
  HEAP32[i5 >> 2] = 0;
  i5 = i5 + 4 | 0;
 } while ((i5 | 0) < (i7 | 0));
 HEAP32[i4 + 32 >> 2] = fb + 488;
 HEAP32[i4 + 44 >> 2] = i1;
 HEAP32[i4 + 76 >> 2] = -1;
 HEAP32[i4 + 84 >> 2] = i1;
 i7 = _vfscanf(i4, i2, i3) | 0;
 STACKTOP = i6;
 return i7 | 0;
}

function _printf_console_log(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 8208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i5 + 16 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i1 = HEAP32[gb + 1450788 >> 2] | 0;
 if (i1 | 0) if (!(mftCall_iiii(i1 | 0, 3, i2 | 0, i3 | 0) | 0)) {
  STACKTOP = i5;
  return;
 }
 _memset(i4 | 0, 0, 8192) | 0;
 _vsnprintf(i4, 8192, i2, i3) | 0;
 _JS_Log_Dump(i4 | 0, 3);
 STACKTOP = i5;
 return;
}

function _cff_cmap_encoding_char_next(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 if (i2 >>> 0 >= 255) {
  i5 = 0;
  return i5 | 0;
 }
 i3 = i1 + 16 | 0;
 i1 = 0;
 do {
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 > 255) {
   i5 = 6;
   break;
  }
  i6 = HEAP16[(HEAP32[i3 >> 2] | 0) + (i2 << 1) >> 1] | 0;
  i1 = i6 & 65535;
 } while (!(i6 << 16 >> 16));
 if ((i5 | 0) == 6) return i1 | 0;
 HEAP32[i4 >> 2] = i2;
 i6 = i1;
 return i6 | 0;
}

function __ZNK5Umbra9Matrix2x28getScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f4 * f4))));
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f3 = Math_fround(Math_sqrt(Math_fround(Math_fround(f5 * f5) + Math_fround(f3 * f3))));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN9Transform23SetHasChangedDeprecatedEb(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 1 << HEAP32[gb + 1477024 >> 2];
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = HEAP32[i2 + 56 >> 2] | 0;
 if (i5) {
  i5 = i3 + (i4 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i1;
  i5 = i2 + 36 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i1;
  return;
 } else {
  i5 = i3 + (i4 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~i1;
  return;
 }
}

function __ZN5physx9PxTaskMgr13decrReferenceEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 >> 2] | 0);
 if (!(__ZN5physx6shdfnd15atomicDecrementEPVi((HEAP32[i3 + 76 >> 2] | 0) + (i2 * 20 | 0) + 4 | 0) | 0)) if (__ZN5physx9PxTaskMgr12dispatchTaskEjb(i3, i2, 0) | 0) {
  i3 = HEAP32[i3 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 7572 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 >> 2] | 0);
 i3 = i2 + 7576 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 + 4 >> 2] | 0);
 i3 = i2 + 7580 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0);
 i2 = i2 + 7584 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5Umbra11PatchWriter5patchEPKvS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = -1;
 i6 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = i2 - i6;
 HEAP32[i5 + 8 >> 2] = i3 - i6;
 i3 = HEAP32[i1 >> 2] | 0;
 i3 = (mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i5 | 0, 12) | 0) == 12;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN4crnd10dxt5_block17get_block_values6EPNS_10color_quadIhiEEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 3 >> 0] = i2;
 HEAP8[i1 + 7 >> 0] = i3;
 HEAP8[i1 + 11 >> 0] = (((i2 << 2) + i3 | 0) >>> 0) / 5 | 0;
 HEAP8[i1 + 15 >> 0] = (((i3 << 1) + (i2 * 3 | 0) | 0) >>> 0) / 5 | 0;
 HEAP8[i1 + 19 >> 0] = (((i3 * 3 | 0) + (i2 << 1) | 0) >>> 0) / 5 | 0;
 HEAP8[i1 + 23 >> 0] = (((i3 << 2) + i2 | 0) >>> 0) / 5 | 0;
 HEAP8[i1 + 27 >> 0] = 0;
 HEAP8[i1 + 31 >> 0] = -1;
 return 6;
}

function __ZN20TerrainPhysicsModule21AttachTerrainColliderER10GameObjectP11TerrainData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i2, gb + 1016757 | 0, 0) | 0;
 if (!i3) return;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i4 + 60 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, 0);
 return;
}

function __ZN20ExternalForcesModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
 i1 = i1 + 8 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __ZN19CharacterController12SetSkinWidthEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 if (f1 < Math_fround(0.0)) {
  if (!i3) i2 = 0; else i2 = HEAP32[i3 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 779485 | 0, 0, gb + 734039 | 0, 677, 1, i2, 0, 0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i3 + 76 >> 2] = f1;
 i2 = HEAP32[i3 + 60 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i4 = i1 + 80 | 0;
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
 if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 i1 = i1 + 176 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= 3) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13DrawImmediate11TexCoordAllEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 HEAPF32[i1 + 76 >> 2] = f2;
 HEAPF32[i1 + 80 >> 2] = f3;
 HEAPF32[i1 + 84 >> 2] = f4;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAPF32[i1 + 92 >> 2] = f3;
 HEAPF32[i1 + 96 >> 2] = f4;
 HEAPF32[i1 + 100 >> 2] = f2;
 HEAPF32[i1 + 104 >> 2] = f3;
 HEAPF32[i1 + 108 >> 2] = f4;
 HEAPF32[i1 + 112 >> 2] = f2;
 HEAPF32[i1 + 116 >> 2] = f3;
 HEAPF32[i1 + 120 >> 2] = f4;
 return;
}

function __ZN12_GLOBAL__N_118createArticulationEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __ZN5physx9NpFactory20createNpArticulationEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
 if (i1 | 0) {
  STACKTOP = i2;
  return i1 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 686195 | 0, 534, gb + 689334 | 0, i2);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN11dtPathQueueD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 228 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 48 | 0;
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
 __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Analytics15UserCustomEvent12ToJsonStringER9JSONWrite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i1, i2);
 __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 1037646 | 0, 0);
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN9JSONWrite8TransferIN11UnityEngine9Analytics15UserCustomEvent12CustomParamsEEEvRT_PKc17TransferMetaFlags(i2, i1 + 48 | 0, gb + 1037651 | 0, 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, 17);
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, 14);
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, 13);
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, 12);
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj(i1, i2, 11);
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZN10MonoScript21AwakeFromLoadThreadedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 124 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 108 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
 __ZN10MonoScript7RebuildEP11Il2CppClass(i3, __Z29scripting_class_from_fullnamePKcS0_S0_(i1, i2, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 return;
}

function __ZL43GeomOverlapCallback_HeightfieldUnregisteredRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 677882 | 0, 975, gb + 677962 | 0, i1);
 STACKTOP = i1;
 return 0;
}

function __Z40Application_CUSTOM_Internal_ExternalCallP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 12 | 0;
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i4, i1);
 __ZNK11ICallString6ToUTF8Ev(i3, i4);
 _JS_Eval_EvalJS(((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __Z36CanvasRenderer_CUSTOM_SetPopMaterialP12Il2CppObjectS0_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN2UI14CanvasRenderer14SetPopMaterialEP8Materiali(i4, i1, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33WWW_Get_Custom_PropUploadProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return Math_fround(0.0);
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __ZNK9Rigidbody15GetCenterOfMassEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 124 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff(i1, i3, f4, f5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 var i2 = 0;
 i2 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 36 >> 2] | 0;
 if ((HEAP8[i2 + (i3 << 2) + 2 >> 0] | 0) < 0) i1 = f5 > f4 | i3 << 1; else i1 = Math_fround(f4 + f5) > Math_fround(1.0) | i3 << 1;
 i3 = i1 >>> 1;
 return ((HEAP8[((i1 & 1 | 0) == 0 ? i2 + (i3 << 2) + 2 | 0 : i2 + (i3 << 2) + 3 | 0) >> 0] & 127) != 127 ? i1 : -1) | 0;
}

function __ZN5physx3Ext10FixedJoint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 80 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE(i4, i2, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i3) | 0)) i1 = 0; else i1 = (HEAP32[(__ZNK5physx2Sc8ShapeSim10getBodySimEv(i3) | 0) + 52 >> 2] | 0) + 16 | 0;
 i4 = HEAP32[i4 + 56 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, HEAP32[i2 + 44 >> 2] | 0, (HEAP32[i3 + 28 >> 2] | 0) + 32 | 0, i1 | 0);
 return;
}

function __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 return __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) | 0;
}

function __ZN5physx28PxDefaultCpuDispatcherCreateEjPj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0) | 0;
 i3 = mftCall_iiiiii(i5 | 0, i4 | 0, 36, (i3 ? gb + 740810 | 0 : gb + 837976 | 0) | 0, gb + 740948 | 0, 29) | 0;
 __ZN5physx3Ext20DefaultCpuDispatcherC2EjPj(i3, i2, i1);
 return i3 | 0;
}

function __ZN5physx24PxAggregateGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 674637;
 HEAP32[i1 + 4 >> 2] = 99;
 HEAP32[i1 + 8 >> 2] = fb + 2143;
 HEAP32[i1 + 12 >> 2] = gb + 756565;
 HEAP32[i1 + 16 >> 2] = 100;
 HEAP32[i1 + 20 >> 2] = fb + 402;
 HEAP32[i1 + 24 >> 2] = fb + 2144;
 HEAP32[i1 + 28 >> 2] = gb + 674649;
 HEAP32[i1 + 32 >> 2] = 101;
 HEAP32[i1 + 36 >> 2] = fb + 2145;
 HEAP32[i1 + 40 >> 2] = gb + 831985;
 HEAP32[i1 + 44 >> 2] = 102;
 HEAP32[i1 + 48 >> 2] = fb + 2146;
 return;
}

function __ZN4Mesh17ReloadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 44 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 3;
 if (!(HEAP8[i1 + 41 >> 0] | 0)) if (!(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 92 >> 2] | 0)) {
  __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
  __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i1, 1);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 __ZN4Mesh27SwizzleVertexColorsIfNeededEb(i1, 1);
 return;
}

function __ZN4FMOD6System9setDriverEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 861498;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN19MeshParticleEmitter19OnMeshFilterChangedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(33) | 0;
 if (!i2) return;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, i2) | 0;
 if (!i2) return;
 i1 = i3 + 236 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == (__ZN10MeshFilter13GetSharedMeshEv(i2) | 0)) return;
 HEAP32[i1 >> 2] = __ZN10MeshFilter13GetSharedMeshEv(i2) | 0;
 return;
}

function __ZN18ProceduralMaterial29ThrowOrWarnIfMaterialIsFrozenEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (!(HEAP32[i1 + 172 >> 2] & 262144)) {
  STACKTOP = i4;
  return;
 } else {
  HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i3 + 4 >> 2] = i2;
  __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(gb + 433870 | 0, i3);
 }
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i5);
 i1 = i1 + 160 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 < (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 } else {
  __ZN12CachedWriter16UpdateWriteCacheEPKvj(i2, i1, 4);
  return;
 }
}

function __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb1EEEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i2);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb0EEEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i2);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12_GLOBAL__N_117ProfileZoneClientD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 150280 + 8;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 i2 = i1 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager27connectionAllocationHandlerEjPKcS2_iPv(i5, i4, i6, i2, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i7 = 0;
 i7 = i5 + 204 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i5 = (HEAP32[i5 + 20 >> 2] | 0) + 8 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i6 | 0, i2 | 0, i3 | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __Z66AnimatorControllerPlayable_CUSTOM_GetNextAnimatorStateInfoInternalR9HPlayablei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) return;
 __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, 1, i1) | 0;
 return;
}

function __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUseRandomRowP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 864 >> 2] | 0) + 556 >> 0] | 0;
 return i2 | 0;
}

function __Z65ParticleSystem_CollisionModule_CUSTOM_GetEnableInteriorCollisionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 949 >> 0] | 0;
 return i2 | 0;
}

function __Z50Renderer_Get_Custom_PropMotionVectorGenerationModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 268 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 10 & 3 | 0;
 }
 return 0;
}

function __Z42GUIStyle_CUSTOM_INTERNAL_set_contentOffsetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 260 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i1 + 264 >> 2] = HEAP32[i2 + 4 >> 2];
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z31Mesh_Set_Custom_PropBoneWeightsP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 32) | 0;
   __ZN4Mesh14SetBoneWeightsEPK13BoneInfluencei(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_FT_Init_Class_tt_cmap14_class_rec(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 40;
 HEAP32[i1 + 4 >> 2] = fb + 1057;
 HEAP32[i1 + 8 >> 2] = fb + 3848;
 HEAP32[i1 + 12 >> 2] = fb + 1058;
 HEAP32[i1 + 16 >> 2] = fb + 1059;
 HEAP32[i1 + 20 >> 2] = fb + 185;
 HEAP32[i1 + 24 >> 2] = fb + 444;
 HEAP32[i1 + 28 >> 2] = fb + 1060;
 HEAP32[i1 + 32 >> 2] = fb + 445;
 HEAP32[i1 + 36 >> 2] = fb + 446;
 HEAP32[i1 + 40 >> 2] = 14;
 HEAP32[i1 + 44 >> 2] = fb + 1061;
 HEAP32[i1 + 48 >> 2] = fb + 1062;
 return;
}

function __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZN5physx18NpArticulationLink7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP32[i1 + 324 >> 2] | 0)) {
  __ZN5physx18NpArticulationLink15releaseInternalEv(i1);
  STACKTOP = i2;
  return;
 } else {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 687181 | 0, 125, gb + 687261 | 0, i2);
  STACKTOP = i2;
  return;
 }
}

function __ZN5physx14NpSpatialIndex6insertERNS_18PxSpatialIndexItemERKNS_9PxBounds3E(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 HEAP32[i6 >> 2] = i2;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 mftCall_iiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i5 | 0, i1 | 0, i6 | 0, 1) | 0;
 HEAP8[i3 + 4 >> 0] = 1;
 STACKTOP = i4;
 return HEAP32[i5 >> 2] | 0;
}

function __ZN5physx14NpArticulation15exportExtraDataERNS_22PxSerializationContextE(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!(HEAP8[i4 + 84 >> 0] | 0)) {
  i1 = HEAP32[i4 + 88 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i4 + 96 >> 2] | 0;
   if (i2 & 2147483647 | HEAP32[i4 + 92 >> 2] | 0) mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0, i2 << 2 | 0);
  }
 }
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP32[i4 + 104 >> 2] | 0);
 return;
}

function __ZN5Cache28SetMaximumDiskSpaceAvailableEx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 40 | 0;
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 if ((i5 | 0) < (i3 | 0) | ((i5 | 0) == (i3 | 0) ? (HEAP32[i4 >> 2] | 0) >>> 0 < i2 >>> 0 : 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 444448 | 0, 0, gb + 444242 | 0, 646, 1, 0, 0, 0);
  return;
 } else {
  i5 = i1 + 32 | 0;
  HEAP32[i5 >> 2] = i2;
  HEAP32[i5 + 4 >> 2] = i3;
  return;
 }
}

function __ZN4Tree20WillDestroyComponentEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (i1 | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i1, gb + 30912 | 0) | 0;
  if (i1 | 0) {
   __ZN8Renderer21ClearCustomPropertiesEv(i1);
   HEAP8[i1 + 348 >> 0] = 0;
  }
 }
 i1 = __ZN20SpeedTreeWindManager11GetInstanceEv() | 0;
 i2 = i2 + 40 | 0;
 __ZN20SpeedTreeWindManager15DeleteLocalWindEP18SpeedTreeLocalWind(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14SpriteRenderer10SmartResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i4 = i2;
 __ZN8Renderer16SetMaterialCountEi(i1, 1);
 HEAP32[i4 >> 2] = __ZN16GraphicsSettings18GetBuiltinMaterialENS_19BuiltinMaterialTypeE(__Z19GetGraphicsSettingsv() | 0, 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i1, i3, 0);
 STACKTOP = i2;
 return;
}

function __ZN14GrowableBufferC2ERK10MemLabelIdjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = i2;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i2 + 4 >> 2] = i5;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i2 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 64, i1, 0, gb + 389912 | 0, 12) | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN14DirectorPlayer4StopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 36 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 HEAP8[i4 + 165 >> 0] = 1;
 i1 = i4 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i4 + 164 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController(__Z18GetDirectorManagerv() | 0, i4);
  HEAP8[i1 >> 0] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZL17Transfer_GUIStyleI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 856 >> 2] | 0) + 800 >> 0] | 0;
 return i2 | 0;
}

function __Z58DownloadHandlerScript_CUSTOM_InternalSetPreallocatedBufferP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN21DownloadHandlerScript21SetPreallocatedBufferEP11Il2CppArray(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027781 | 0, i3);
}

function __Z44Renderer_Get_Custom_PropReflectionProbeUsageP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 14 & 3 | 0;
 }
 return 0;
}

function __Z42GUIUtility_Get_Custom_PropSystemCopyBufferv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z13GetCopyBufferv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z26Input_CUSTOM_GetKeyDownInti(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 + -1 | 0) >>> 0 < 569) {
  i1 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 68 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  STACKTOP = i2;
  return i1 | 0;
 }
 if (!i1) {
  i1 = 0;
  STACKTOP = i2;
  return i1 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536680 | 0, i2);
 return 0;
}

function __Z25GL_CUSTOM_LoadPixelMatrixv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!(__ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0)) {
  STACKTOP = i2;
  return;
 }
 __ZNK6Camera13GetCameraRectEb(i1, __ZN13RenderManager16GetCurrentCameraEv(__Z16GetRenderManagerv() | 0) | 0, 1);
 __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb(i1, __Z12GetGfxDevicev() | 0, 1);
 STACKTOP = i2;
 return;
}

function __Z20InvalidateNavMeshHitP10NavMeshHit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62500 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62500 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62500 + 8 >> 2];
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAPF32[i1 + 24 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function _UNITY_png_set_sCAL_fixed(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 18 | 0;
 i7 = i8;
 if ((i4 | 0) < 1 | (i5 | 0) < 1) {
  STACKTOP = i8;
  return;
 }
 _UNITY_png_ascii_from_fixed(i1, i6, 18, i4);
 _UNITY_png_ascii_from_fixed(i1, i7, 18, i5);
 _UNITY_png_set_sCAL_s(i1, i2, i3, i6, i7);
 STACKTOP = i8;
 return;
}

function mftCall_iiiifiiiii(i10, i1, i2, i3, d4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifiiiii[i10 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 return ftCall_iiiifiiiii(i10 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
}

function _fminf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if ((i3 & 2147483647) >>> 0 > 2139095040) f1 = f2; else {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i4 & 2147483647) >>> 0 <= 2139095040) if ((i4 ^ i3 | 0) < 0) {
   f1 = (i3 | 0) < 0 ? f1 : f2;
   break;
  } else {
   f1 = f1 < f2 ? f1 : f2;
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function _fmaxf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 do if ((i3 & 2147483647) >>> 0 > 2139095040) f1 = f2; else {
  i4 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
  if ((i4 & 2147483647) >>> 0 <= 2139095040) if ((i4 ^ i3 | 0) < 0) {
   f1 = (i3 | 0) < 0 ? f2 : f1;
   break;
  } else {
   f1 = f1 < f2 ? f2 : f1;
   break;
  }
 } while (0);
 return Math_fround(f1);
}

function __ZltRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f4 < Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f4 < Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = f4 < Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Ebbbb(i1, i7, i6, i5, f4 < Math_fround(HEAPF32[i3 + 12 >> 2]));
 return;
}

function __ZgtRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, i5 = 0, i6 = 0, i7 = 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i7 = f4 > Math_fround(HEAPF32[i3 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i6 = f4 > Math_fround(HEAPF32[i3 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i5 = f4 > Math_fround(HEAPF32[i3 + 8 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Ebbbb(i1, i7, i6, i5, f4 > Math_fround(HEAPF32[i3 + 12 >> 2]));
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj(i4 + -4 | 0, i6, i1, i2);
 STACKTOP = i5;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if ((HEAP8[i2 + 8 + 3 >> 0] | 0) < 0) __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 return;
}

function __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray(i6, i4);
 i4 = __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN7mecanim5human18HumanGetFootBottomEPKNS0_5HumanEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i2 + 40 | 0;
 i4 = (HEAP32[i4 >> 2] | 0) + i4 | 0;
 i5 = i4 + 16 | 0;
 i4 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[(HEAP32[i5 >> 2] | 0) + i5 + ((HEAP32[i4 + (HEAP32[i4 >> 2] | 0) + (HEAP32[i2 + 72 + ((i3 ? 5 : 6) << 2) >> 2] << 3) + 4 >> 2] | 0) * 76 | 0) + 68 >> 2];
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148476 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 return __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) | 0;
}

function __ZN5physx16PxsFluidDynamics5clearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i2 = i3 + 84 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj(i3, 0);
  return;
 }
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (i1 | 0) {
  i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj(i3, 0);
 return;
}

function __ZN15DirectorManager15AdvanceTimeFuncEP14AdvanceTimeJobj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 i2 = HEAP32[i2 + (i3 << 2) >> 2] | 0;
 switch (HEAP32[i2 >> 2] | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[gb + 1188448 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[gb + 1188440 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[gb + 1188452 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 __ZN18PlayableController4TickEf(i2, f1);
 return;
}

function __ZN14UnityWebStream14UpdateProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (HEAP8[i1 + 20 >> 0] | 0) return;
 if (!(HEAP32[i1 + 40 >> 2] | 0)) return;
 if (!(HEAP8[i1 + 19 >> 0] | 0)) return;
 HEAP8[i1 + 16 >> 0] = 1;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
  HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
 }
 __ZN14UnityWebStream7ReleaseEv(i1);
 return;
}

function __ZN13GfxDeviceGLES23ClearRandomWriteTargetsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 7196 | 0;
 if ((HEAP32[i4 >> 2] | 0) < 0) {
  HEAP32[i4 >> 2] = -1;
  return;
 } else i2 = 0;
 while (1) {
  i1 = i3 + 7200 + (i2 << 2) | 0;
  if (!(HEAP32[i1 >> 2] | 0)) {
   i1 = i3 + 7232 + (i2 << 2) | 0;
   if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
  } else HEAP32[i1 >> 2] = 0;
  if ((i2 | 0) < (HEAP32[i4 >> 2] | 0)) i2 = i2 + 1 | 0; else break;
 }
 HEAP32[i4 >> 2] = -1;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner5flushEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i1 = 1; else if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0) | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 } else i1 = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return i1 | 0;
}

function __ZN12InputManager23VirtualRedirectTransferER17RemapPPtrTransfer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i2, i1);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return; else i2 = i1;
 do {
  i1 = i2 + 4 | 0;
  if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = __Z7FNVHashPKc(i1) | 0;
  i2 = i2 + 108 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN11UTF16String12BorrowStringEP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 if (HEAP8[i3 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 12 | 0);
 if (i2 | 0) if (_il2cpp_string_length(i2 | 0) | 0) {
  HEAP32[i1 >> 2] = _il2cpp_string_chars(i2 | 0) | 0;
  HEAP32[i1 + 4 >> 2] = _il2cpp_string_length(i2 | 0) | 0;
  HEAP8[i3 >> 0] = 0;
  return;
 }
 HEAP8[i3 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __Z63ParticleSystem_CollisionModule_CUSTOM_GetEnableDynamicCollidersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 948 >> 0] | 0;
 return i2 | 0;
}

function __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesYP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 864 >> 2] | 0) + 540 >> 2] | 0;
 return i2 | 0;
}

function __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesXP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 864 >> 2] | 0) + 536 >> 2] | 0;
 return i2 | 0;
}

function __Z21FindGameObjectWithTagj(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = __Z20GetGameObjectManagerv() | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i4 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if ((HEAPU16[i1 + 52 >> 1] | 0 | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
  if ((i2 | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z17getPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEj(i3, i2, i4, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 i7 = HEAP32[(HEAP32[i3 >> 2] | 0) + 76 >> 2] | 0;
 HEAP16[i6 >> 1] = HEAP16[i2 >> 1] | 0;
 i4 = mftCall_iiiiii(i7 | 0, i3 | 0, i6 | 0, i4 | 0, i1 | 0, 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z15GetChannelIndexRK14BlendShapeDataPKc(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = i2 - i1 >> 4;
 i1 = 0;
 while (1) {
  if (!(_strcmp(HEAP32[i3 + (i1 << 4) >> 2] | 0, i4) | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + -4 | 0;
 i4 = HEAP32[i2 + 32 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZNSt3__26localeC2ERKS0_S2_i(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __Znwj(160) | 0;
 __THREW__ = 0;
 invoke_viiii(fb + 361 | 0, i5 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0);
 i4 = __THREW__;
 __THREW__ = 0;
 if (i4 & 1) {
  i4 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZdlPv(i5);
  ___resumeException(i4 | 0);
 } else {
  HEAP32[i1 >> 2] = i5;
  __ZNSt3__214__shared_count12__add_sharedEv(i5);
  return;
 }
}

function __ZN5physx3Ext7D6Joint15importExtraDataERNS_24PxDeserializationContextE(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = i4 + 80 | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i5 = i1 + 15 & -16;
  i1 = i5 + 384 | 0;
  HEAP32[i2 >> 2] = i1;
  HEAP32[i3 >> 2] = i5;
 }
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = (i5 | 0) == 0 ? 0 : i3;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i5;
 return;
}

function __ZN5physx2Sc11Interaction10initializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, 0) | 0;
 i2 = i1 + 4 | 0;
 __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i1, i3);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i2 >> 2] | 0, i1);
 __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE(HEAP32[i1 + 8 >> 2] | 0, i1);
 return;
}

function __ZN22CrashReportingSettingsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 HEAP32[i1 >> 2] = gb + 189340 + 8;
 i3 = i1 + 12 | 0;
 if ((HEAP8[i3 + 11 >> 0] | 0) >= 0) {
  STACKTOP = i4;
  return;
 }
 i3 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i2 >> 2] = 66;
 HEAP32[i2 + 4 >> 2] = i1;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, i2);
 STACKTOP = i4;
 return;
}

function __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i5);
 i1 = i1 + 8 | 0;
 i2 = i5 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 4 | 0;
 if (i4 >>> 0 > (HEAP32[i5 + 24 >> 2] | 0) >>> 0) {
  __ZN12CachedReader15UpdateReadCacheEPvj(i2, i1, 4);
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i2 >> 2] = i4;
  return;
 }
}

function __ZN17AnimationCurveTplI11QuaternionfE10RemoveKeysEP11KeyframeTplIS0_ES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 80 >> 2] = Math_fround(inf);
 HEAP32[i1 + 76 >> 2] = 0;
 i4 = i1 + 164 | 0;
 i5 = i3;
 _memmove(i2 | 0, i3 | 0, (HEAP32[i1 + 152 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 52 | 0) - i5 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - ((i5 - i2 | 0) / 52 | 0);
 return;
}

function __ZN16PlayerConnectionD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65632 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 224 | 0);
 __ZN6SocketD2Ev(i1 + 192 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 180 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 168 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 152 | 0);
 __ZN17GeneralConnectionD2Ev(i1);
 return;
}

function __ZN14ParticleSystem20GetParticlesExternalEP22ParticleSystemParticlei(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 868 >> 0] | 0)) {
  __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(i1, 2);
 __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii(HEAP32[i2 >> 2] | 0, i3, i4, 0);
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer23UpdateFirstAddEventTimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = _time(0) | 0;
 HEAP32[i1 + 104 + 4 >> 2] = i2;
 i3 = HEAP16[gb + 1478660 >> 1] | 0;
 HEAP16[gb + 1478660 >> 1] = i3 + 1 << 16 >> 16;
 HEAP16[i1 + 112 >> 1] = i3;
 i2 = ___muldi3(i2 | 0, 0, 1e5, 0) | 0;
 i3 = _i64Add(i2 | 0, getTempRet0() | 0, i3 & 65535 | 0, 0) | 0;
 i2 = getTempRet0() | 0;
 i1 = i1 + 96 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 884 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 868 >> 2] | 0) + 800 >> 0] | 0;
 return i2 | 0;
}

function __Z62ParticleSystem_CollisionModule_CUSTOM_GetUsesCollisionMessagesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 968 >> 0] | 0;
 return i2 | 0;
}

function __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetRowIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 864 >> 2] | 0) + 548 >> 2] | 0;
 return i2 | 0;
}

function __Z38GameObject_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i2 = i2 + -4 | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(0);
 } else {
  HEAP32[i2 >> 2] = __Z50ScriptingGetComponentsOfTypeFromGameObjectFastPathP10GameObjectP12Il2CppObject(i1, i3) | 0;
  return;
 }
}

function __Z35getPxVehicleDriveSimData4W_DiffDataPKN5physx23PxVehicleDriveSimData4WE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 528 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __Z26ConstrainToPolynomialCurveR17AnimationCurveTplIfE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i2 = i3 + 68 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) > 3) {
  i4 = HEAP32[i3 + 56 >> 2] | 0;
  __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_(i3, i4 + 48 | 0, i4 + (i1 << 4) | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 if ((i1 | 0) <= 1) return;
 i4 = HEAP32[i3 + 56 >> 2] | 0;
 HEAPF32[i4 >> 2] = Math_fround(0.0);
 HEAPF32[i4 + (i1 + -1 << 4) >> 2] = Math_fround(1.0);
 return;
}

function __Z24Input_CUSTOM_GetKeyUpInti(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 + -1 | 0) >>> 0 < 569) {
  i1 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 88 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  STACKTOP = i2;
  return i1 | 0;
 }
 if (!i1) {
  i1 = 0;
  STACKTOP = i2;
  return i1 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536680 | 0, i2);
 return 0;
}

function ___cxx_global_var_init13() {
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 4 | 0;
 i2 = i3;
 if (HEAP8[gb + 1098864 >> 0] | 0) {
  STACKTOP = i3;
  return;
 }
 HEAPF32[i1 >> 2] = Math_fround(.949999988);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i1) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(gb + 1458888 | 0, i2);
 i2 = gb + 1098864 | 0;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + -4 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + -4 | 0;
 i4 = HEAP32[i2 + 32 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEjc(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0, i6 = 0;
 i6 = i1 + 11 | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = (HEAP32[i2 >> 2] | 0) - i3 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc(i1, i2, i4, i5) | 0;
 if ((HEAP8[i6 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i2 | 0;
}

function __ZNK9Rigidbody18GetAngularVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 160 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK5physx22PxVehicleWheelsSimData7isValidEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 36 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 1) i2 = 4; else {
  i3 = 0;
  do {
   i3 = i3 + 1 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
  } while (i3 >>> 0 < (i1 + -1 | 0) >>> 0);
  i2 = i1 << 2;
 }
 i1 = HEAP32[i4 + 40 >> 2] | 0;
 if ((4 - i2 | 0) == (0 - i1 | 0)) return 1;
 i1 = i1 + 4 - i2 | 0;
 if ((i1 | 0) == 1) return 1; else i2 = 1;
 do i2 = i2 + 1 | 0; while ((i2 | 0) != (i1 | 0));
 return 1;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getSimulationFilterDataEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 16384)) i1 = __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN7Terrain23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = i2 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i2 + 36 | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i1 + 108 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 return;
}

function __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAPF32[i4 >> 2] = Math_fround(Math_fround(((HEAP32[i1 >> 2] | 0) >>> 8 & 255) >>> 0) * Math_fround(.00392156886));
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 100 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i1 = i1 + 108 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i3 >> 2] = __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj(i4, i2, i1) | 0;
 __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE(i4, i2);
 return;
}

function __ZN15QualitySettings28SetShadowDistanceTemporarilyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = f2;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = f2 < Math_fround(0.0);
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __ZN11MatrixStack10MultMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i1 = i1 + ((HEAP32[i1 + 1024 >> 2] | 0) + -1 << 6) | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i1, i2, i3);
 i2 = i3;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i4;
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_12DbD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__213__vector_baseINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEENS5_IS9_Lj4096EEEED2Ev(i1 + 32 | 0);
 __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev(i1 + 16 | 0);
 __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev(i1);
 return;
}

function __ZN10MonoScript16RebuildFromAwakeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 124 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 108 | 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) i2 = HEAP32[i2 >> 2] | 0;
 i4 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0) | 0;
 __ZN10MonoScript7RebuildEP11Il2CppClass(i3, __Z29scripting_class_from_fullnamePKcS0_S0_(i1, i2, (HEAP8[i4 + 11 >> 0] | 0) < 0 ? HEAP32[i4 >> 2] | 0 : i4) | 0);
 return;
}

function __ZL17Transfer_GUIStyleI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 + 28 >> 2];
 __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z44AnimationState_Set_Custom_PropNormalizedTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN14AnimationState7SetTimeEf(i1, Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * f2));
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z32Event_Get_Custom_PropCommandNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = HEAP32[i1 + 44 >> 2] | 0;
   i2 = __Z20scripting_string_newPKc((i2 | 0) == 0 ? gb + 1576256 | 0 : i2) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28UnloadAssetBundleFileStreamsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = __Z20GetPersistentManagerv() | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i3, i1, 1);
  i1 = i1 + 12 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __Z10IsInvokingR13MonoBehaviour(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i5 = i2;
 i4 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = __ZN18DelayedCallManager14HasDelayedCallE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i4, i3, fb + 595 | 0, 0, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function mftCall_iiiiiiiiii(i10, i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiiiiii[i10 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
 return ftCall_iiiiiiiiii(i10 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0) | 0;
}

function _emit_message(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) >= 0) {
  if ((HEAP32[i3 + 104 >> 2] | 0) < (i1 | 0)) return;
  mftCall_vi(HEAP32[i3 + 8 >> 2] | 0, i2 | 0);
  return;
 }
 i4 = i3 + 108 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) i5 = 4; else if ((HEAP32[i3 + 104 >> 2] | 0) > 2) i5 = 4;
 if ((i5 | 0) == 4) {
  mftCall_vi(HEAP32[i3 + 8 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + -4 | 0;
 i4 = HEAP32[i2 + 20 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if ((HEAP8[i2 + 11 >> 0] | 0) < 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0); else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 }
 return;
}

function __ZNK9Rigidbody11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 20 >> 2] | 0;
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK5physx13NpRigidStatic13getGlobalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 52 >> 2] & 64 | 0) == 0 ? i2 + 80 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK12NavMeshAgent23SetOffMeshLinkDataFlagsEP15OffMeshLinkDatay(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __ZNK9dtNavMesh20getOffMeshConnectionEy(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0, i2, i3) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 1;
 HEAP32[i4 + 4 >> 2] = (HEAP32[i1 + 76 >> 2] | 0) != 0 & 1;
 HEAP32[i4 + 12 >> 2] = HEAPU16[i1 + 82 >> 1];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 84 >> 2];
 i4 = 1;
 return i4 | 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i5 << 8;
  HEAP32[i4 >> 2] = i3 & 65280 | i5 >>> 24 | i3 & 16711680 | i3 & -16777216;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatABGR8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i5 << 8;
  HEAP32[i4 >> 2] = i3 & -16777216 | i5 >>> 24 | i3 & 16711680 | i3 & 65280;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB4444EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = (HEAPU8[i1 >> 0] | 0) << 4 & 3840 | (HEAPU8[i1 + 1 >> 0] | 0) & 240 | (HEAPU8[i1 + 2 >> 0] | 0) >>> 4 | 61440;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVES3_RKNS_6shdfnd3aos6FloatVERNS5_5Vec3VESA_SA_RS6_PhSC_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i8 = i8 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i11 = i11 | 0;
 return __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSA_5Vec3VESF_SF_RSB_PhSH_Rhb(i2, i4, i8, i6, i7, i9, i10, i3, i5, i1, i11) | 0;
}

function __ZN5physx16PxVehicleIsInAirERKNS_25PxVehicleWheelQueryResultE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) {
  i3 = 1;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i3 = 1;
  return i3 | 0;
 } else i2 = 0;
 while (1) {
  if (!(HEAP8[i3 + (i2 * 148 | 0) + 28 >> 0] | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i1 >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN20SoundChannelInstance23ApplyBufferedParametersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i2) return;
 __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE(i1 + 4 | 0, i2);
 __ZN20SoundChannelInstance12UpdateVolumeEv(i1);
 __ZN20SoundChannelInstance11UpdatePitchEv(i1);
 __ZN20SoundChannelInstance16UpdatePauseStateEv(i1);
 i1 = HEAP32[i1 + 240 >> 2] | 0;
 if (!i1) return;
 __ZN11AudioSource31UpdateEffectVirtualizationStateEb(i1, 0);
 return;
}

function __ZN17TransformInternal37SetSelfTransformHasChanged_DeprecatedE15TransformAccessjb(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 56 >> 2] | 0;
 if (i4) {
  i4 = i2 + (i1 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i3;
  i5 = i5 + 36 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i3;
  return;
 } else {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~i3;
  return;
 }
}

function __ZN15OcclusionPortal10DeactivateE19DeactivateOperation(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i3 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) != -1) {
  i2 = __Z16GetRendererScenev() | 0;
  __ZN13RendererScene25SetOcclusionPortalEnabledEjb(i2, HEAP32[i1 >> 2] | 0, 1);
 }
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 36 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[(__ZNSt3__23mapINS_4pairIPcS2_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS_9allocatorINS1_IKS3_S8_EEEEEixERSE_(HEAP32[gb + 1166052 >> 2] | 0, i5) | 0) >> 2] = i3;
 STACKTOP = i4;
 return;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN13MonoBehaviour18TransferEngineDataI19StreamedBinaryWriteILb0EEEE4PPtrI10MonoScriptERT_(i1, i2) | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) return;
 i4 = __ZNK13MonoBehaviour8GetClassEv(i1) | 0;
 __Z23TransferScriptingObjectI19StreamedBinaryWriteILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache(i2, i3, i4, HEAP32[i1 + 56 >> 2] | 0);
 return;
}

function __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 852 >> 2] | 0) + 800 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_CollisionModule_CUSTOM_GetMaxCollisionShapesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 904 >> 2] | 0) + 952 >> 2] | 0;
 return i2 | 0;
}

function __Z51MeshRenderer_Set_Custom_PropAdditionalVertexStreamsP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN12MeshRenderer26SetAdditionalVertexStreamsEP4Mesh(i3, i1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Renderer_Get_Custom_PropShadowCastingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 6 & 3 | 0;
 }
 return 0;
}

function __Z39GraphicsSettings_CUSTOM_SetCustomShaderN16GraphicsSettings17BuiltinShaderTypeEP12Il2CppObject(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i1 = __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, i3) | 0;
 if (!i2) {
  i3 = 0;
  HEAP32[i1 >> 2] = i3;
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 return;
}

function __Z27WWW_Get_Custom_PropProgressP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0));
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return Math_fround(0.0);
}

function __Z22delete_object_internalP6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z28delete_object_internal_step1P6Object(i1);
 i4 = HEAP32[i1 + 8 >> 2] & 2047;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Get_Sfnt_Table(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP32[i3 + 8 >> 2] & 8)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i3 + 96 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = mftCall_iii(i1 | 0, i2 | 0, gb + 1008151 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i3 | 0, i4 | 0) | 0;
 return i4 | 0;
}

function __ZNK9Rigidbody16GetInertiaTensorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getSimulationFilterDataEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 16384)) i1 = __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZNK5physx18PxcConvexTriangles9getBoundsERNS_9PxBounds3ERKNS_11PxTransformE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE(i2, i3);
 HEAP32[i1 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 60 >> 2];
 return;
}

function __ZNK5Umbra9BitVector7testNotERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i3 + (i1 << 2) >> 2] & ~HEAP32[i2 + (i1 << 2) >> 2] | 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN5physx2Sn13XmlNodeReader18pushCurrentContextEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 12 | 0;
 i2 = i4 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i4 + 32 >> 2] & 2147483647) >>> 0 > i3 >>> 0) {
  HEAP32[(HEAP32[i4 + 24 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i1 >> 2];
  HEAP32[i2 >> 2] = i3 + 1;
  return;
 } else {
  __ZN5physx6shdfnd5ArrayIPNS_2Sn7XmlNodeENS_7profile26WrapperReflectionAllocatorIS4_EEE15growAndPushBackERKS4_(i4 + 20 | 0, i1) | 0;
  return;
 }
}

function __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i10 = i10 | 0;
 i9 = i9 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i6 = i6 | 0;
 return __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_fb(i1, i2, i5, i10, i9, i7, i8, i3, f4, i6) | 0;
}

function __ZN21InheritVelocityModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 92 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(-1.0e5);
 i5 = f2 > Math_fround(1.0e5);
 f2 = i5 ? Math_fround(1.0e5) : f2;
 f2 = i4 ? Math_fround(-1.0e5) : f2;
 HEAPF32[i3 >> 2] = f2;
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, f2, HEAP16[i1 + 96 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN19CloudServiceHandler20StartEventDispatcherERKN11UnityEngine15CloudWebService18CloudServiceConfigERNS1_16WWWRestHeaderMapE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 68 | 0;
 __ZN11UnityEngine15CloudWebService18CloudServiceConfigaSERKS1_(i4, i2) | 0;
 __ZN11UnityEngine15CloudWebService16WWWRestHeaderMapaSERKS1_(i1 + 1116 | 0, i3) | 0;
 return __ZN11UnityEngine15CloudWebService14DataDispatcher5StartERKNS0_18CloudServiceConfigE(i1 + 792 | 0, i4) | 0;
}

function __ZN18BackgroundJobQueueC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i5, gb + 63664 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i1 + 21 >> 0] = 1;
 STACKTOP = i2;
 return;
}

function __ZN15ConstantForce2D11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67088 | 0) | 0;
 if (!i2) return;
 __ZN11Rigidbody2D8AddForceERK8Vector2fNS_9ForceModeE(i2, i1 + 48 | 0, 0);
 __ZN11Rigidbody2D16AddRelativeForceERK8Vector2fNS_9ForceModeE(i2, i1 + 56 | 0, 0);
 __ZN11Rigidbody2D9AddTorqueEfNS_9ForceModeE(i2, Math_fround(Math_fround(HEAPF32[i1 + 64 >> 2]) * Math_fround(.0174532924)), 0);
 return;
}

function __ZN10GameObject12SetHideFlagsEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -1040385 | i3 << 13 & 1040384;
 i4 = i1 + 40 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i2 = i1 + 28 | 0;
 i1 = 0;
 do {
  i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 48 >> 2] | 0, i5 | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 896 >> 2] | 0) + 800 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 876 >> 2] | 0) + 800 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetRandomizedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 876 >> 2] | 0) + 801 >> 0] | 0;
 return i2 | 0;
}

function __Z54Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleP12Il2CppObjectRK8Vector3fRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z17InstantiateObjectR6ObjectRK8Vector3fRK11Quaternionf(i4, i2, i3) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50AsyncOperation_Set_Custom_PropAllowSceneActivationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 << 24 >> 24 != 0 | 0);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z39Renderer_Get_Custom_PropLightProbeUsageP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 16 & 3 | 0;
 }
 return 0;
}

function __Z15GetChannelIndexRK14BlendShapeDataj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = i2 - i1 >> 4;
 i1 = 0;
 while (1) {
  if ((HEAP32[i3 + (i1 << 4) + 4 >> 2] | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function mftCall_viiifiiiii(i10, i1, i2, i3, d4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiifiiiii[i10 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
  return;
 }
 ftCall_viiifiiiii(i10 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateProfilerStartFramestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 488 >> 2] | 0, i1 | 0) | 0)) __ZN13UnityProfiler19RecordPreviousFrameE12ProfilerMode(2);
 __Z27SetProfilerEnabledThisFrameb(__ZN13UnityProfiler13StartNewFrameE12ProfilerMode(2) | 0);
 if (!(__Z26IsProfilerEnabledThisFramev() | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 624 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__28ios_baseD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 208632 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4506 | 0, i1 | 0, 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__26localeD2Ev(i1 + 28 | 0);
  _free(HEAP32[i1 + 32 >> 2] | 0);
  _free(HEAP32[i1 + 36 >> 2] | 0);
  _free(HEAP32[i1 + 48 >> 2] | 0);
  _free(HEAP32[i1 + 60 >> 2] | 0);
  return;
 }
}

function __ZNK20TextRenderingPrivate8FontImpl37CheckFontWithCustomSizeStyleIsDynamicERiRjPj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i1 + 32 >> 2] | 0) == -2) return;
 if ((HEAP32[i2 >> 2] | 0) != (HEAP32[(HEAP32[i1 + 76 >> 2] | 0) + 36 >> 2] | 0)) {
  HEAP32[i2 >> 2] = 0;
  if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
 }
 if (!(HEAP32[i3 >> 2] | 0)) return;
 HEAP32[i3 >> 2] = 0;
 if (!i4) return;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 2;
 return;
}

function __ZNK12NavMeshAgent20GetRemainingDistanceEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844413 | 0, 0, gb + 841797 | 0, 549, 1, 0, 0, 0);
  f2 = Math_fround(inf);
  return Math_fround(f2);
 } else {
  f2 = Math_fround(__ZNK7dtCrowd22CalculateRemainingPathERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0));
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK12AudioManager11GetCPUUsageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  f4 = Math_fround(0.0);
  STACKTOP = i3;
  return Math_fround(f4);
 }
 __ZN4FMOD6System11getCPUUsageEPfS1_S1_S1_S1_(i1, 0, 0, 0, 0, i2) | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 STACKTOP = i3;
 return Math_fround(f4);
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i4 + 8 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 12 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6Shader17CreateAndPostLoadEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 32 | 0;
 if (!(HEAP8[i3 + 93 >> 0] | 0)) if (HEAP32[i1 >> 2] | 0) return;
 __ZN6Shader20CreateFromParsedFormEv(i3);
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 + 40 >> 2] = 0;
  i1 = 0;
 } else {
  __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i2, i3);
  i1 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i1 >> 2] | 0, i3 + 40 | 0) | 0;
 }
 HEAP32[i3 + 36 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148460 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBufferC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63200 | 0, 0, gb + 487609 | 0, 66) | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 >> 2] = i2 + (HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN19ScriptingInvocation11SetDefaultsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 i2 = i1 + 200 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP32[i1 + 220 >> 2] = 0;
 i2 = i1 + 224 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 HEAP8[i1 + 232 >> 0] = 1;
 HEAP8[i1 + 233 >> 0] = 1;
 HEAP32[i1 + 216 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE10RemoveKeysEP11KeyframeTplIS0_ES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 64 >> 2] = Math_fround(inf);
 HEAP32[i1 + 60 >> 2] = 0;
 i4 = i1 + 132 | 0;
 i5 = i3;
 _memmove(i2 | 0, i3 | 0, (HEAP32[i1 + 120 >> 2] | 0) + ((HEAP32[i4 >> 2] | 0) * 40 | 0) - i5 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - ((i5 - i2 | 0) / 40 | 0);
 return;
}

function __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 864 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_LightsModule_CUSTOM_GetUseRandomDistributionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 12 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_LightsModule_CUSTOM_GetAlphaAffectsIntensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 22 >> 0] | 0;
 return i2 | 0;
}

function __Z35Application_Get_Custom_PropDataPathv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __Z14GetAppDataPathv(i3);
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i4 ? HEAP32[i3 >> 2] | 0 : i3, i4 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function mftCall_viiiiiiiii(i10, i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i10 = i10 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 if ((i10 | 0) >= (fb | 0) & (i10 | 0) < (fb + 31 | 0)) {
  FUNCTION_TABLE_viiiiiiiii[i10 - fb & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
  return;
 }
 ftCall_viiiiiiiii(i10 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function _unzGetOffset(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i3 = -102;
  return i3 | 0;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i2 | 0) < 65535) switch (i2 | 0) {
 case 0:
  break;
 default:
  i3 = 4;
 } else switch (i2 | 0) {
 case 65535:
  break;
 default:
  i3 = 4;
 }
 if ((i3 | 0) == 4) if ((HEAP32[i1 + 48 >> 2] | 0) == (i2 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 52 >> 2] | 0;
 return i3 | 0;
}

function __ZNSt3__212__rs_defaultclEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[gb + 1099760 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099760 | 0) | 0) __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EE4seedEj(gb + 1470932 | 0, 5489);
 return __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EEclEv(gb + 1470932 | 0) | 0;
}

function __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 5136 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5;
 i6 = i5 + 16 | 0;
 HEAP32[i7 >> 2] = HEAP32[i4 >> 2];
 _vsnprintf(i6, 5120, i3, i7) | 0;
 _il2cpp_raise_exception(_il2cpp_exception_from_name_msg(_il2cpp_get_corlib() | 0, i1 | 0, i2 | 0, i6 | 0) | 0);
 STACKTOP = i5;
 return;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB88815TexFormatRGB565EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = (HEAPU8[i1 + 1 >> 0] | 0) << 3 & 2016 | (HEAPU8[i1 >> 0] | 0) << 8 & 63488 | (HEAPU8[i1 + 2 >> 0] | 0) >>> 3;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN5physx21MBPPostUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i3 + 4 >> 1] = -1;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 104148 + 8;
 HEAP32[i3 + 32 >> 2] = i2;
 HEAP32[i3 + 36 >> 2] = i1;
 return;
}

function __ZN20SphericalHarmonicsL215AddAmbientLightERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i1 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i4 = i1 + 36 | 0;
 HEAPF32[i4 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i4 >> 2]));
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = i1 + 72 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f3 + Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZN20ExternalForcesModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620343 | 0, HEAP32[gb + 37012 >> 2] | 0, i1 + 8 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 4;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15QualitySettings24SetShadowNearPlaneOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = f2;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = f2 < Math_fround(0.0);
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 40 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __ZN10GCProfilerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i2 = i1 + 24 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 __Z26scripting_profiler_installPvPFvS_E(i1, fb + 3426 | 0);
 __Z29scripting_profiler_install_gcPFvPviiEPFvS_xE(fb + 536 | 0, fb + 537 | 0);
 __Z29scripting_profiler_set_eventsi(256);
 return;
}

function __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 868 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 856 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z57ParticleSystem_TrailModule_CUSTOM_GetInheritParticleColorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 288 >> 0] | 0;
 return i2 | 0;
}

function __Z38Renderer_Get_Custom_PropReceiveShadowsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16777215) >>> 8 & 1 | 0;
 }
 return 0;
}

function __Z34GetNonInterpolatedLightAttenuationRK17LightProbeContextjPK15SharedLightData(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 i2 = HEAP32[i2 + 120 >> 2] | 0;
 if (!(HEAP32[i2 + 12 >> 2] | 0)) f1 = Math_fround(1.0); else {
  i2 = HEAP32[i2 >> 2] | 0;
  if (!i4) f1 = Math_fround(1.0); else if ((HEAP32[i2 + (i3 << 3) >> 2] | 0) == (HEAP32[i4 + 88 >> 2] | 0)) f1 = Math_fround(HEAPF32[i2 + (i3 << 3) + 4 >> 2]); else f1 = Math_fround(1.0);
 }
 return Math_fround(f1);
}

function __Z24LightAttenuateNormalizedf(f1) {
 f1 = Math_fround(f1);
 var f2 = f0;
 f2 = Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f1 * Math_fround(25.0)) + Math_fround(1.0)));
 if (!(f1 >= Math_fround(.640000045))) return Math_fround(f2);
 if (f1 > Math_fround(1.0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(f2 * Math_fround(Math_fround(1.0) - Math_fround(Math_fround(f1 + Math_fround(-.640000045)) / Math_fround(.359999955))));
 return Math_fround(f2);
}

function ___cxa_get_globals() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5 + 8 | 0;
 i3 = i5;
 i1 = ___cxa_get_globals_fast() | 0;
 if (!i1) {
  i1 = _calloc(1, 8) | 0;
  if (!i1) _abort_message(gb + 1088210 | 0, i3);
  if (!(_pthread_setspecific(HEAP32[gb + 1477004 >> 2] | 0, i1 | 0) | 0)) i2 = i1; else _abort_message(gb + 1088243 | 0, i4);
 } else i2 = i1;
 STACKTOP = i5;
 return i2 | 0;
}

function __ZNKSt3__214error_category10equivalentEiRKNS_15error_conditionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0);
 if ((HEAP32[i4 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i1 = (HEAP32[i4 >> 2] | 0) == (HEAP32[i3 >> 2] | 0); else i1 = 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK5physx2Cm8PtrTable4findEPKv(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP16[i2 + 4 >> 1] | 0;
 i3 = i1 & 65535;
 if (i1 << 16 >> 16 != 1) if (!(i1 << 16 >> 16)) {
  i4 = -1;
  return i4 | 0;
 } else i2 = HEAP32[i2 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
   i2 = 7;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i2 = 7;
   break;
  }
 }
 if ((i2 | 0) == 7) return i1 | 0;
 return 0;
}

function __ZNK5Umbra4Tome13findGateIndexEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 108 >> 2] | 0;
 i4 = (i4 | 0) == 0 ? 0 : i1 + i4 | 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i2 | 0) > 0) i1 = 0; else {
  i4 = -1;
  return i4 | 0;
 }
 while (1) {
  if ((HEAP32[i4 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i2 | 0)) {
   i1 = -1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZNK12GUIClipState10GetTopRectEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  return;
 } else {
  i3 = i3 + -40 | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
  return;
 }
}

function __ZN9ShaderLab22SerializedBindChannels9MergeWithERKS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i4) return;
 i1 = 0;
 do {
  i5 = HEAP32[i3 >> 2] | 0;
  i6 = HEAP32[i5 + (i1 << 3) >> 2] | 0;
  if ((i6 | 0) != -1) __ZN9ShaderLab22SerializedBindChannels4BindE13ShaderChannel15VertexComponentbP12ShaderErrors(i2, i6, HEAP32[i5 + (i1 << 3) + 4 >> 2] | 0, 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx6shdfnd10Foundation19AlignCheckAllocator10deallocateEPv(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i1 = HEAP32[i4 + 28 >> 2] | 0;
 if (i1 | 0) {
  i2 = 0;
  do {
   i5 = HEAP32[i4 + 8 + (i2 << 2) >> 2] | 0;
   mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i3 | 0);
   i2 = i2 + 1 | 0;
  } while ((i2 | 0) != (i1 | 0));
 }
 i5 = HEAP32[i4 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i3 | 0);
 return;
}

function __ZN17CommonStringTable13StaticCleanupEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1115292 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1 + 400 | 0;
  do {
   i3 = i2;
   i2 = i2 + -20 | 0;
   if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
    __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -16 | 0);
    HEAP32[i2 >> 2] = 0;
   }
  } while ((i2 | 0) != (i1 | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63648 | 0);
 HEAP32[gb + 1115292 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_117MemoryEventClientD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 149240 + 8;
 i2 = i1 + 8 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 4 | 0;
 mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings6HasKeyERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) | 0) != (i1 + 4 | 0) | 0;
}

function __ZN10GUIManager7RepaintEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[(__Z15GetInputManagerv() | 0) + 168 >> 0] = 0;
 HEAP32[i4 + 44 >> 2] = 0;
 __ZN10InputEventaSERKS_(i4, i1 + 72 + (i2 * 52 | 0) | 0);
 HEAP32[i4 >> 2] = 7;
 HEAP32[i4 + 40 >> 2] = i2;
 __ZN10GUIManager10DoGUIEventER10InputEventb(i1, i4, 0);
 __ZN10InputEventD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z56ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsLifetimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 287 >> 0] | 0;
 return i2 | 0;
}

function __Z46UnityWebRequest_Get_Custom_PropDownloadedBytesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
   setTempRet0(0);
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z33GetBlendShapeFrameCountFromScriptRK4Meshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if ((i2 | 0) >= 0) {
  i3 = HEAP32[i1 + 112 >> 2] | 0;
  if (((HEAP32[i1 + 116 >> 2] | 0) - i3 >> 4 | 0) > (i2 | 0)) {
   STACKTOP = i5;
   return HEAP32[i3 + (i2 << 4) + 12 >> 2] | 0;
  }
 }
 __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 404122 | 0, i4);
 return 0;
}

function __Z21CalculateMipMapOffsetii13TextureFormati(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i7 = 0, i8 = 0;
 if ((i4 | 0) != 0 & (i3 | 0) != 0 & (i6 | 0) > 0) {
  i1 = 0;
  i2 = 0;
 } else {
  i6 = 0;
  return i6 | 0;
 }
 do {
  i8 = i3 >> i2;
  i7 = i4 >> i2;
  i1 = (__Z18CalculateImageSizeii13TextureFormat((i8 | 0) < 1 ? 1 : i8, (i7 | 0) < 1 ? 1 : i7, i5) | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i6 | 0));
 return i1 | 0;
}

function __Z19UnsignedIntToStringj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 _snprintf(i4, 255, gb + 1084495 | 0, i5) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i3;
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function _UNITY_tt_face_lookup_table(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 i4 = HEAP16[i2 + 152 >> 1] | 0;
 i2 = i1 + ((i4 & 65535) << 4) | 0;
 if (!(i4 << 16 >> 16)) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) if (HEAP32[i1 + 12 >> 2] | 0) {
   i2 = 5;
   break;
  }
  i1 = i1 + 16 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK5physx7NpScene9getLimitsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZNK5physx2Sc5Scene9getLimitsEv(i2 + 32 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZNK5Umbra9BitVector4testERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 << 2) >> 2] & HEAP32[i3 + (i1 << 2) >> 2] | 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK5Umbra11Transformer23transformClipXYToRasterERKNS_7Vector2Eb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0;
 f5 = Math_fround(i4 & 1);
 i2 = ~~Math_fround(f5 + Math_fround(Math_fround(Math_fround(HEAPF32[i3 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)));
 i4 = ~~Math_fround(f5 + Math_fround(Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * Math_fround(32.0)) + Math_fround(32.0)));
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i4;
 return;
}

function __ZN7mecanim4hand8HandPoseC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 i1 = i1 + 40 | 0;
 i2 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5physx2Sc5Scene28scheduleParticleCollisionCpuERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i2 + 148 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i2 = i1;
  return i2 | 0;
 } else {
  i2 = __ZN5physx2Sc17ParticleSystemSim20scheduleCollisionCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i2 + 1204 >> 2] | 0, i2 + 144 | 0, i1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5Umbra10VisibilityC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZN22LocalFileSystemHandler19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = _strlen(gb + 1546878 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1546878 | 0, i3);
 _strncpy(gb + 1546878 | 0, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 1040) | 0;
 return;
}

function __ZN21VRGlobalSettingsState18RestoreGlobalStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[(__Z16GetScreenManagerv() | 0) + 40 >> 2] | 0;
 i3 = __Z16GetScreenManagerv() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0) & (i3 | 0) == (i2 | 0)) return;
 i4 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 108 >> 2] | 0, i4 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 892 >> 2] | 0) + 808 >> 0] | 0;
 return i2 | 0;
}

function __Z37Graphics_CUSTOM_Internal_SetMRTSimpleP11Il2CppArrayP21ScriptingRenderBufferiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 8) | 0;
 i1 = __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0;
 __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_(i1, i6, i2);
 __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iii(i1, i6, i2, i3, i4, i5);
 return;
}

function __Z23Texture2D_CUSTOM_ResizeP12Il2CppObjectii13TextureFormath(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) return (__ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE(i6, i2, i3, i4, i5 << 24 >> 24 != 0 & 1) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z16AppendPathToHashRKN7mecanim5crc32EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = -1; else i1 = HEAP32[gb + 1111240 + ((i1 & 255 ^ 47) << 2) >> 2] ^ i1 >>> 8;
 i4 = _strlen(i2) | 0;
 i3 = i2 + i4 | 0;
 if ((i4 | 0) <= 0) {
  i4 = i1;
  return i4 | 0;
 }
 do {
  i1 = HEAP32[gb + 1111240 + (((HEAPU8[i2 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return i1 | 0;
}

function _UNITY_png_set_sCAL(i1, i2, i3, d4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i8 + 18 | 0;
 i7 = i8;
 if (!(!(d4 <= 0.0) & !(d5 <= 0.0))) {
  STACKTOP = i8;
  return;
 }
 _UNITY_png_ascii_from_fp(i1, i6, 18, d4, 5);
 _UNITY_png_ascii_from_fp(i1, i7, 18, d5, 5);
 _UNITY_png_set_sCAL_s(i1, i2, i3, i6, i7);
 STACKTOP = i8;
 return;
}

function _UNITY_FT_Outline_Translate(i3, i5, i6) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 if (!i3) return;
 i1 = HEAP16[i3 + 2 >> 1] | 0;
 if (i1 << 16 >> 16 <= 0) return;
 i4 = i1 << 16 >> 16;
 i2 = 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i5;
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i6;
  i2 = i2 + 1 << 16 >> 16;
  if ((i2 & 65535 | 0) >= (i4 | 0)) break; else i1 = i1 + 8 | 0;
 }
 return;
}

function _tre_set_one(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = ___tre_mem_alloc_impl(i1, 0, 0, 1, 64) | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = i2;
  HEAP32[i1 + 4 >> 2] = i3;
  HEAP32[i1 + 8 >> 2] = i4;
  HEAP32[i1 + 20 >> 2] = i5;
  HEAP32[i1 + 24 >> 2] = i6;
  HEAP32[i1 + 28 >> 2] = i7;
  HEAP32[i1 + 32 >> 2] = -1;
  HEAP32[i1 + 36 >> 2] = -1;
  HEAP32[i1 + 40 >> 2] = -1;
 }
 return i1 | 0;
}

function __ZNK9Rigidbody11GetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = HEAP32[i2 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 152 >> 2] | 0, i5 | 0, i4 | 0);
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = HEAP32[i5 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN9Rigidbody17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 __ZN9Rigidbody15CleanupInternalEb(i1, 0);
 i3 = i1 + 44 | 0;
 i2 = i1 + 48 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  HEAP32[i2 >> 2] = i3;
  HEAP32[i3 >> 2] = i3;
  return;
 }
 do {
  i4 = i1 + 4 | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 } while ((i1 | 0) != (i3 | 0));
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = i3;
 return;
}

function __ZN7mecanim8skeleton18SkeletonFindNodeUpEPKNS0_8SkeletonEij(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i2 + 4 | 0;
 i5 = i4;
 i2 = i2 + 8 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + i5 + (i1 << 3) >> 2] | 0;
  if ((i1 | 0) == -1) {
   i1 = -1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i5 = HEAP32[i1 >> 2] | 0;
  i3 = i5 >>> 8;
  HEAP32[i4 >> 2] = i3 & 255 | i5 << 24 | i3 & 65280 | i3 & 16711680;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP8[i4 >> 0] = i3 >>> 8;
  HEAP8[i4 + 1 >> 0] = i3 >>> 16;
  HEAP8[i4 + 2 >> 0] = i3 >>> 24;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatBGR888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP8[i4 >> 0] = i3 >>> 24;
  HEAP8[i4 + 1 >> 0] = i3 >>> 16;
  HEAP8[i4 + 2 >> 0] = i3 >>> 8;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ES4_S4_f(i4, i2, i3, f1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i5 + 4 | 0;
 i6 = i5;
 HEAPF32[i7 >> 2] = f1;
 HEAP32[i6 >> 2] = __Z6simd4fRKf(i7) | 0;
 __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i4, i6);
 HEAP32[i4 + 16 >> 2] = i2;
 HEAP32[i4 + 20 >> 2] = i3;
 STACKTOP = i5;
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager16createControllerERNS_9PxPhysicsEPNS_7PxSceneERKNS_16PxControllerDescE(i4, i2, i3, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i3 = _PxGetFoundation() | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0) | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, 2, gb + 658624 | 0, gb + 658713 | 0, 119);
 return mftCall_iii(HEAP32[(HEAP32[i4 >> 2] | 0) + 16 >> 2] | 0, i4 | 0, i1 | 0) | 0;
}

function __ZN16BaseVideoTexture18ReleaseVideoMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 80 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  STACKTOP = i5;
  return;
 }
 i4 = i4 + (0 - (HEAP32[i1 + 84 >> 2] | 0) << 2) | 0;
 __ZNK6Object14GetMemoryLabelEv(i2, i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN15DirectorManager14ConnectionPool8AllocateEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = HEAP32[i2 + 48 + (i3 << 2) >> 2] | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if (!i1) {
  i1 = __ZN15DirectorManager14ConnectionPool10CreateItemEi(i2, i3) | 0;
  HEAP32[i2 + 4 >> 2] = 1;
 } else {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i2 + 28 + (i3 << 2) | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 }
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 return i1 | 0;
}

function __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 52 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 56 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 52 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 56 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv(i5, i4, i6, i2, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i5 + 132 >> 0] | 0)) return;
 if (!(HEAP32[i5 + 112 >> 2] & 4)) return;
 __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv(i5);
 i5 = HEAP32[(HEAP32[i5 + 120 >> 2] | 0) + 4 >> 2] | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i6 | 0, i2 | 0, i3 | 0, i1 | 0);
 return;
}

function __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 876 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 860 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z53ParticleSystem_CollisionModule_CUSTOM_GetCollidesWithP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 904 >> 2] | 0) + 956 >> 2] | 0;
 return i2 | 0;
}

function __Z44UnityWebRequest_Get_Custom_PropUploadedBytesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
   setTempRet0(0);
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z38Renderer_Get_Custom_PropUseLightProbesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 196608 | 0) != 0 | 0;
 }
 return 0;
}

function __Z29Mesh_Set_Custom_PropBindposesP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 64) | 0;
   __ZN4Mesh12SetBindposesEPK10Matrix4x4fi(i3, i1, __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_png_check_chunk_name(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 & 255;
 if (!((i3 + -65 | 0) >>> 0 > 57 | (i3 + -91 | 0) >>> 0 < 6)) {
  i3 = i2 >>> 8 & 255;
  if (!((i3 + -65 | 0) >>> 0 > 57 | (i3 + -91 | 0) >>> 0 < 6)) {
   i3 = i2 >>> 16 & 255;
   if (!((i3 + -65 | 0) >>> 0 > 57 | (i3 + -91 | 0) >>> 0 < 6)) {
    i3 = i2 >>> 24;
    if (!((i3 + -65 | 0) >>> 0 > 57 | (i3 + -91 | 0) >>> 0 < 6)) return;
   }
  }
 }
 _UNITY_png_chunk_error(i1, gb + 353087 | 0);
}

function _posix_fallocate(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = i2;
 HEAP32[i5 + 12 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
 HEAP32[i5 + 16 >> 2] = i3;
 HEAP32[i5 + 20 >> 2] = ((i3 | 0) < 0) << 31 >> 31;
 i3 = 0 - (___syscall324(324, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__219__shared_mutex_base13unlock_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZNSt3__25mutex4lockEv(i1);
 i4 = i1 + 124 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i2 = (i3 & 2147483647) + -1 | 0;
 i3 = i2 | i3 & -2147483648;
 HEAP32[i4 >> 2] = i3;
 if ((i3 | 0) < 0) {
  if (!i2) __ZNSt3__218condition_variable10notify_oneEv(i1 + 76 | 0);
 } else if ((i2 | 0) == 2147483646) __ZNSt3__218condition_variable10notify_oneEv(i1 + 28 | 0);
 __ZNSt3__25mutex6unlockEv(i1);
 return;
}

function __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4534 | 0, i1 | 0, gb + 1087190 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 216384 + 8;
  ___cxa_throw(i1 | 0, gb + 13192 | 0, fb + 3222 | 0);
 }
}

function __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4534 | 0, i1 | 0, gb + 1087190 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 216364 + 8;
  ___cxa_throw(i1 | 0, gb + 13176 | 0, fb + 3222 | 0);
 }
}

function __ZN7Terrain17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 192 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 116 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx3Ext17computeBoxDensityERKNS_6PxVec3Ef(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 i5 = f3 != Math_fround(0.0);
 f3 = i5 ? f3 : Math_fround(1.0);
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i5 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 f3 = i5 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 i1 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 return Math_fround(f2 / (i1 ? f4 : f3));
}

function __ZN5physx34PxVehicleEngineDataGeneratedValuesC2EPKNS_19PxVehicleEngineDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 104 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 108 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 80 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 84 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 92 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 96 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 100 >> 2];
 return;
}

function __ZN5physx2Sc5Scene27scheduleParticleDynamicsCpuERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i2 + 148 >> 2] | 0)) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
  i2 = i1;
  return i2 | 0;
 } else {
  i2 = __ZN5physx2Sc17ParticleSystemSim19scheduleDynamicsCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE(HEAP32[i2 + 1204 >> 2] | 0, i2 + 144 | 0, i1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx17MBPUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i3 + 4 >> 1] = -1;
 HEAP16[i3 + 6 >> 1] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 87404 + 8;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 104192 + 8;
 HEAP32[i3 + 32 >> 2] = i2;
 HEAP32[i3 + 36 >> 2] = i1;
 return;
}

function __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP32[i1 >> 2] = i3;
 if (i2) {
  HEAP8[i1 >> 0] = i3 >>> 24;
  HEAP8[i1 + 3 >> 0] = i3;
  HEAP8[i1 + 1 >> 0] = i3 >>> 16;
  HEAP8[i1 + 2 >> 0] = i3 >>> 8;
 }
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 4) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5Light12SetIntensityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(8.0);
 f2 = i4 ? Math_fround(8.0) : f2;
 f2 = i3 ? Math_fround(0.0) : f2;
 __ZNK5Light16UnshareLightDataEv(i1);
 i3 = i1 + 44 | 0;
 HEAPF32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] = f2;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i3 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN4FMOD6System7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 853481;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN20LocalFileSystemPosix20GetHomeDirectoryPathEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 8 >> 2] | 0; else i1 = i2 & 255;
 if (i1 | 0) return i3 | 0;
 i1 = _getenv(gb + 491503 | 0) | 0;
 if (!i1) {
  i1 = HEAP32[(_getpwuid(_getuid() | 0) | 0) + 20 >> 2] | 0;
  if (!i1) return i3 | 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i3, i1) | 0;
 return i3 | 0;
}

function __ZN15TextureSettings14SetAnisoLimitsEii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[gb + 56192 >> 2] = i2;
 HEAP32[gb + 56196 >> 2] = i1;
 if ((i2 | 0) < 1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 421770 | 0, 0, gb + 421788 | 0, 14, 1, 0, 0, 0);
  i1 = HEAP32[gb + 56196 >> 2] | 0;
 }
 if ((i1 | 0) <= 16) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 421865 | 0, 0, gb + 421788 | 0, 15, 1, 0, 0, 0);
 return;
}

function __ZN13MemoryManager13StaticDestroyEv() {
 var i1 = 0, i2 = 0;
 __ZN14MemoryProfiler13StaticDestroyEv();
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  __ZN13MemoryManager13ThreadCleanupEv(i1);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i2 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i2;
 if (i2 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i2 = i1;
 __ZN13MemoryManager13ThreadCleanupEv(i2);
 return;
}

function __ZN12NavMeshAgent4WarpERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 68 | 0;
 if ((HEAP32[i3 >> 2] | 0) != -1) __ZN7dtCrowd11removeAgentER13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0);
 __ZN9Transform11SetPositionERK8Vector3f(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2);
 __ZN12NavMeshAgent16AddToCrowdSystemEv(i1);
 return (HEAP32[i3 >> 2] | 0) != -1 | 0;
}

function __ZN10Matrix3x3faSERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 40 >> 2];
 return i1 | 0;
}

function __Z7StrICmpPKcS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 while (1) {
  i5 = HEAP8[i1 >> 0] | 0;
  i4 = i5 << 24 >> 24;
  i4 = (i5 + -65 & 255) < 26 ? i4 + 32 | 0 : i4;
  i5 = i4 & 255;
  i6 = HEAP8[i2 >> 0] | 0;
  i3 = i6 << 24 >> 24;
  i3 = (i6 + -65 & 255) < 26 ? i3 + 32 | 0 : i3;
  if (i5 << 24 >> 24 ? i5 << 24 >> 24 == (i3 & 255) << 24 >> 24 : 0) {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } else break;
 }
 return (i4 & 255) - (i3 & 255) | 0;
}

function __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 852 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z54ParticleSystem_LightsModule_CUSTOM_GetUseParticleColorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 20 >> 0] | 0;
 return i2 | 0;
}

function __Z54ParticleSystem_LightsModule_CUSTOM_GetSizeAffectsRangeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 21 >> 0] | 0;
 return i2 | 0;
}

function __Z53ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 286 >> 0] | 0;
 return i2 | 0;
}

function __Z53ParticleSystem_TrailModule_CUSTOM_GetDieWithParticlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 285 >> 0] | 0;
 return i2 | 0;
}

function __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = __ZNK14ParticleSystem18GetSimulationSpaceEv(i2) | 0;
 return i2 | 0;
}

function __Z34Canvas_Get_Custom_PropSortingOrderP12Il2CppObject(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!i2) {
  i1 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
 if (!i1) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i2; else break;
 }
 return HEAP16[i1 + 372 >> 1] | 0;
}

function __Z21Event_CUSTOM_PopEventP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = __Z18GetGUIEventManagerv() | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i3 = (__ZN15GUIEventManager8PopEventER10InputEvent(i2, i1) | 0) & 1;
   STACKTOP = i4;
   return i3 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
 return 0;
}

function _UNITY_png_malloc_array(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) < 1 | (i2 | 0) == 0) _UNITY_png_error(i3, gb + 352038 | 0);
 if ((4294967295 / (i2 >>> 0) | 0) >>> 0 < i1 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = Math_imul(i2, i1) | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 if (i3 | 0) {
  i1 = HEAP32[i3 + 608 >> 2] | 0;
  if (i1 | 0) {
   i3 = mftCall_iii(i1 | 0, i3 | 0, i2 | 0) | 0;
   return i3 | 0;
  }
 }
 i3 = _malloc(i2) | 0;
 return i3 | 0;
}

function _Round_Super(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((i2 | 0) > -1) {
  i4 = HEAP32[i1 + 480 >> 2] | 0;
  i3 = (i3 + i2 - i4 + (HEAP32[i1 + 484 >> 2] | 0) & 0 - (HEAP32[i1 + 476 >> 2] | 0)) + i4 | 0;
  return ((i3 | 0) < 0 ? i4 : i3) | 0;
 } else {
  i5 = HEAP32[i1 + 480 >> 2] | 0;
  i4 = 0 - ((i3 - i2 + (HEAP32[i1 + 484 >> 2] | 0) - i5 & 0 - (HEAP32[i1 + 476 >> 2] | 0)) + i5) | 0;
  return ((i4 | 0) > 0 ? 0 - i5 | 0 : i4) | 0;
 }
 return 0;
}

function _fdim(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
 if (!(i3 >>> 0 > 2146435072 | (i3 | 0) == 2146435072 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 0)) {
  HEAPF64[tempDoublePtr >> 3] = d2;
  i3 = HEAP32[tempDoublePtr + 4 >> 2] & 2147483647;
  if (i3 >>> 0 > 2146435072 | (i3 | 0) == 2146435072 & (HEAP32[tempDoublePtr >> 2] | 0) >>> 0 > 0) d1 = d2; else d1 = d1 > d2 ? d1 - d2 : 0.0;
 }
 return +d1;
}

function __ZNKSt3__220__vector_base_commonILb1EE20__throw_out_of_rangeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4534 | 0, i1 | 0, gb + 1081934 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 216384 + 8;
  ___cxa_throw(i1 | 0, gb + 13192 | 0, fb + 3222 | 0);
 }
}

function __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4534 | 0, i1 | 0, gb + 1081934 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i1 | 0);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 216364 + 8;
  ___cxa_throw(i1 | 0, gb + 13176 | 0, fb + 3222 | 0);
 }
}

function __ZNK9Transform15GetSiblingIndexEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i3 + 100 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 i5 = HEAP32[i2 + 92 >> 2] | 0;
 i2 = i1 + (i5 << 2) | 0;
 i4 = i1;
 L4 : do if (!i5) i1 = i2; else while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break L4;
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = i2;
   break;
  }
 } while (0);
 i5 = i1 - i4 >> 2;
 return i5 | 0;
}

function __ZNK9TextAsset18GetScriptClassNameEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[gb + 1546607 >> 0] | 0) return gb + 1165828 | 0;
 HEAP32[gb + 1165828 >> 2] = 0;
 HEAP32[gb + 1165828 + 4 >> 2] = 0;
 HEAP32[gb + 1165828 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1165828 + 12 >> 2] = i1;
 HEAP32[gb + 1165828 >> 2] = 0;
 HEAP32[gb + 1165828 + 4 >> 2] = 0;
 HEAP32[gb + 1165828 + 8 >> 2] = 0;
 HEAP8[gb + 1546607 >> 0] = 1;
 return gb + 1165828 | 0;
}

function __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EixEj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 16 | 0;
 i7 = i4;
 i6 = (HEAP32[i3 + 16 >> 2] | 0) + (i2 << 4) | 0;
 __ZmiRK8Scalar4fS1_(i7, (HEAP32[i3 + 20 >> 2] | 0) + (i2 << 4) | 0, i6);
 __ZmlRK8Scalar4fS1_(i5, i7, i3);
 __ZplRK8Scalar4fS1_(i1, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZN9Texture2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN9Texture2D16DeleteGfxTextureEv(i1);
  return;
 }
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63272 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 __ZN9Texture2D16DeleteGfxTextureEv(i1);
 return;
}

function __ZN5physx7NpClothD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 94588 + 8;
 i1 = HEAP32[i3 + 124 >> 2] | 0;
 i2 = i1 + 12 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 1) HEAP32[i3 + 64 >> 2] = 0;
 i1 = i1 + 8 | 0;
 if (!(__ZN5physx6shdfnd15atomicDecrementEPVi(i2) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 __ZN5physx3Scb5ClothD2Ev(i3 + 20 | 0);
 HEAP32[i3 >> 2] = gb + 95136 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i3);
 return;
}

function __ZN5physx28solveExtContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i5 = i4 + (i1 << 5) | 0;
  __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i2);
  __ZN5physx15concludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN4File19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN10FileSystem19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i3, __Z13GetFileSystemv() | 0, i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD6System6updateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857013;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN12_GLOBAL__N_120DefaultAssertHandlerclEPKcS2_iRb(i2, i3, i4, i5, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 i2 = i1 + 16 | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[i6 + 4 >> 2] = i5;
 HEAP32[i6 + 8 >> 2] = i3;
 __ZN5physx6string9sprintf_sEPcjPKcz(i2, 1024, gb + 777485 | 0, i6) | 0;
 __ZN5physx6shdfnd11printStringEPKc(i2);
 _abort();
}

function __ZN12_GLOBAL__N_117ConnectionManager23recordAllocationHandlerEjPKcS2_iPv(i5, i4, i6, i2, i3, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i7 = 0;
 i7 = i5 + 204 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i7 >> 2] | 0);
 i5 = HEAP32[i5 + 172 >> 2] | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i4 | 0, i6 | 0, i2 | 0, i3 | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i7 >> 2] | 0);
 return;
}

function __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 896 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z54ParticleSystem_InheritVelocityModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 872 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z47GUIClip_CUSTOM_INTERNAL_CALL_Internal_Clip_RectR5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN12GUIClipState4ClipERK5RectTIfE(i3, (__Z11GetGUIStatev() | 0) + 96 | 0, i1);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z42Random_CUSTOM_INTERNAL_get_rotationUniformP11Quaternionf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __Z35RandomQuaternionUniformDistributionR4Rand(i3, __Z16GetScriptingRandv() | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z24GetAIScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459868 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63728 | 0, 16, gb + 849930 | 0, 16) | 0;
 HEAP32[gb + 1459868 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 850049 | 0, gb + 850064 | 0) | 0;
 HEAP32[HEAP32[gb + 1459868 >> 2] >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 268 | 0, fb + 269 | 0);
 i1 = HEAP32[gb + 1459868 >> 2] | 0;
 return i1 | 0;
}

function __Z20setPxSceneDescLimitsPN5physx11PxSceneDescENS_13PxSceneLimitsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __GLOBAL__sub_I_runtime_camera_renderlayers_lump_cpp() {
 HEAP32[gb + 1114544 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1114544 | 0, gb + 1046318 | 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1114536 | 0, 13);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114504 | 0, gb + 385742 | 0, 2, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1114524 | 0, gb + 385760 | 0, 0, 0);
 return;
}

function __ZNK10UnityScene32MarkLevelGameManagerDependenciesER27GarbageCollectorThreadState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 84 >> 2] | 0, i2);
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 88 >> 2] | 0, i2);
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 92 >> 2] | 0, i2);
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 96 >> 2] | 0, i2);
 return;
}

function __ZN9Texture2D14DestroyTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 52 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN9Texture2D16DeleteGfxTextureEv(i1);
  return;
 }
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63272 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 __ZN9Texture2D16DeleteGfxTextureEv(i1);
 return;
}

function __ZN9TextAsset8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 return;
}

function __ZN9TextAsset8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 48 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 1);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 return;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = (HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0) << 24 | 255;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI15TexFormatBGR88817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | 255;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 3 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Cct9CCTParamsC2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAPF32[i3 + 16 >> 2] = Math_fround(1.0);
 i1 = i3 + 20 | 0;
 i2 = i3 + 59 | 0;
 i4 = i1;
 i5 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 HEAP16[i1 + 36 >> 1] = 0;
 HEAP8[i1 + 38 >> 0] = 0;
 HEAP8[i2 >> 0] = 1;
 HEAP8[i3 + 60 >> 0] = 0;
 return;
}

function __ZN5physx14NpRigidDynamicD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 98548 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13NpRigidStaticD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 99820 + 8;
 __ZN5physx2Sc9RigidCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 99672 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4crnd10dxt5_block17get_block_values6EPjjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = (((i2 << 2) + i3 | 0) >>> 0) / 5 | 0;
 HEAP32[i1 + 12 >> 2] = (((i3 << 1) + (i2 * 3 | 0) | 0) >>> 0) / 5 | 0;
 HEAP32[i1 + 16 >> 2] = (((i3 * 3 | 0) + (i2 << 1) | 0) >>> 0) / 5 | 0;
 HEAP32[i1 + 20 >> 2] = (((i3 << 2) + i2 | 0) >>> 0) / 5 | 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 255;
 return 6;
}

function __ZN4FMOD6System5closeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0)) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = 36;
 HEAP32[i3 + 4 >> 2] = gb + 857693;
 _printf(gb + 853184 | 0, i3) | 0;
 i3 = 36;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN33AssetBundleLoadFromAsyncOperation19IntegrateMainThreadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (__ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv(i1) | 0) return;
 i2 = i1 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 if ((HEAP32[i2 >> 2] | 0) == 1) return;
 i2 = i1 + 96 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
 return;
}

function __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeP11Il2CppArray(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray(i6, i4);
 i4 = __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN18AudioLowPassFilter13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN11AudioFilter13AwakeFromLoadE17AwakeFromLoadMode(i2, i1);
 if (!(HEAP8[i2 + 136 >> 0] | 0)) return;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 171656 | 0) | 0;
 if (!i1) return;
 __Z14ScaleCurveTimeR17AnimationCurveTplIfEf(i2 + 44 | 0, Math_fround(Math_fround(1.0) / Math_fround(__ZNK11AudioSource14GetMaxDistanceEv(i1))));
 return;
}

function __ZN12GUIClipState3PopER10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 4 | 0;
 i5 = HEAP32[i3 >> 2] | 0;
 i4 = i5;
 if (((i5 - (HEAP32[i1 >> 2] | 0) | 0) / 56 | 0) >>> 0 < 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1017848 | 0, 0, gb + 1017283 | 0, 130, 1, 0, 0, 0);
  return;
 } else {
  HEAP32[i3 >> 2] = i4 + -56;
  __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i1, i2, i4 + -112 | 0);
  return;
 }
}

function __Z53ParticleSystem_ExternalForcesModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 880 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z51ParticleSystem_MainModule_CUSTOM_GetStartRotation3DP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 2553 >> 0] | 0;
 return i2 | 0;
}

function __Z50WheelCollider_CUSTOM_INTERNAL_get_suspensionSpringP12Il2CppObjectP11JointSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 76 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleSystem_MainModule_CUSTOM_GetPlayOnAwakeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = (__ZNK14ParticleSystem14GetPlayOnAwakeEv(i2) | 0) & 1;
 return i2 | 0;
}

function __Z39Transform_Set_Custom_PropParentInternalP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN9Transform9SetParentEPS_NS_15SetParentOptionE(i3, i1, 1) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i3, i4, i5, i6, i1, i7, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 if (HEAP32[i3 >> 2] | 0) HEAP32[i3 >> 2] = 0;
 if (i6 | 0) {
  i1 = 0;
  do {
   mftCall_vii(i4 | 0, i5 | 0, i1 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (i7 | 0) mftCall_vi(i7 | 0, i5 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 return;
}

function _UNITY_png_calculate_crc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = HEAP32[i1 + 208 >> 2] | 0;
 if (!(i3 | 0 ? ((HEAP32[i1 + 372 >> 2] & 536870912 | 0) == 0 ? (i5 & 2048 | 0) == 0 : (i5 & 768 | 0) != 768) : 0)) return;
 i5 = i1 + 408 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 while (1) {
  i1 = (i3 | 0) == 0 ? -1 : i3;
  i4 = _unity_z_crc32(i4, i2, i1) | 0;
  i3 = i3 - i1 | 0;
  if (!i3) break; else i2 = i2 + i1 | 0;
 }
 HEAP32[i5 >> 2] = i4;
 return;
}

function _UNITY_FT_New_Memory_Face(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i7 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i7;
 if (!i2) {
  i6 = 6;
  STACKTOP = i7;
  return i6 | 0;
 }
 HEAP32[i6 >> 2] = 1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 16 >> 2] = 0;
 i6 = _UNITY_FT_Open_Face(i1, i6, i4, i5) | 0;
 STACKTOP = i7;
 return i6 | 0;
}

function __ZThn12_N5physx3Ext13RevoluteJoint11prepareDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + -12 + 80 >> 2] | 0;
 HEAPF32[i1 + 112 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 104 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 116 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 108 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 120 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 100 >> 2]) * Math_fround(.25))));
 return i1 | 0;
}

function __ZNSt3__26__clocEv() {
 var i1 = 0, i2 = 0;
 do if (!(HEAP8[gb + 1099800 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099800 | 0) | 0) {
  __THREW__ = 0;
  i1 = invoke_iiii(fb + 502 | 0, 2147483647, gb + 1083663 | 0, 0) | 0;
  i2 = __THREW__;
  __THREW__ = 0;
  if (i2 & 1) {
   i2 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i2 | 0);
  } else {
   HEAP32[gb + 1474564 >> 2] = i1;
   break;
  }
 } while (0);
 return HEAP32[gb + 1474564 >> 2] | 0;
}

function __ZNSt3__210__time_putD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 __THREW__ = 0;
 i3 = invoke_i(fb + 314 | 0) | 0;
 i4 = __THREW__;
 __THREW__ = 0;
 do if (!(i4 & 1)) {
  if ((i2 | 0) != (i3 | 0)) {
   __THREW__ = 0;
   invoke_vi(fb + 4002 | 0, HEAP32[i1 >> 2] | 0);
   i4 = __THREW__;
   __THREW__ = 0;
   if (i4 & 1) break;
  }
  return;
 } while (0);
 i4 = ___cxa_find_matching_catch_3(0) | 0;
 getTempRet0() | 0;
 ___clang_call_terminate(i4);
}

function __ZNK5Umbra9Matrix2x29isUniformEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0, f3 = f0, f4 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 * f3);
 f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 d2 = +Math_fround(Math_sqrt(Math_fround(f3 + Math_fround(f4 * f4))));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 return +Math_abs(+(d2 - +Math_fround(Math_sqrt(Math_fround(f4 + Math_fround(f3 * f3)))))) <= d2 * .0001 | 0;
}

function __ZN9Scripting40InstantiateScriptingWrapperForNativeTypeEPKN5Unity4TypeE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 while (1) {
  i2 = __Z21GetManagerFromContexti(5) | 0;
  i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
  if (i2 | 0) break;
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i3 = 5;
   break;
  }
 }
 if ((i3 | 0) == 5) return i1 | 0;
 i3 = __Z20scripting_object_newP11Il2CppClass(i2) | 0;
 return i3 | 0;
}

function __ZN8GUILayer12CleanupClassEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[gb + 1114500 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (i2 | 0) {
  i3 = i1 + 16 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -8 - i2 | 0) >>> 3) << 3);
  __ZdlPv(i2);
 }
 __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN7Terrain8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i3 = i2 + 16 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i2 + 36 | 0;
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, HEAP32[i1 + 48 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i1 + 108 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
 return;
}

function __ZN5physx3Ext14computeBoxMassERKNS_6PxVec3Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i5 = f3 != Math_fround(0.0);
 f3 = i5 ? f3 : Math_fround(1.0);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i5 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 f3 = i5 ? f4 : f3;
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 i2 = f4 != Math_fround(0.0);
 f4 = Math_fround(f4 * f3);
 return Math_fround((i2 ? f4 : f3) * f1);
}

function __ZN5physx35PxConvexMeshGeometryGeneratedValuesC2EPKNS_20PxConvexMeshGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 32 >> 2];
 return;
}

function __ZN5physx2Sc12BodyIterator7getNextEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 L1 : while (1) {
  if (i2 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i5 = 5;
   break;
  }
  i1 = HEAP32[i2 >> 2] | 0;
  i2 = i2 + 4 | 0;
  HEAP32[i4 >> 2] = i2;
  switch (HEAP8[i1 + 50 >> 0] | 0) {
  case 1:
  case 4:
   break L1;
  default:
   {}
  }
 }
 if ((i5 | 0) == 5) return i1 | 0;
 i5 = HEAP32[i1 + 52 >> 2] | 0;
 return i5 | 0;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 92 | 0, i2);
 __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 92 | 0, i2);
 __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15QualitySettings17SetShadowDistanceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = f2;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 i6 = f2 < Math_fround(0.0);
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __ZN15OcclusionPortal9SetIsOpenEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 72 | 0;
 HEAP8[i4 >> 0] = i1 & 1;
 i1 = i2 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i5 = __Z16GetRendererScenev() | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) i1 = 1; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) i1 = (HEAP8[i4 >> 0] | 0) != 0; else i1 = 1;
 __ZN13RendererScene25SetOcclusionPortalEnabledEjb(i5, i3, i1);
 return;
}

function __ZN14TreeBinaryTreeD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i2 + 48 >> 2] | 0);
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (i1 | 0) {
  __ZN14TreeBinaryTreeD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 if (i1 | 0) {
  __ZN14TreeBinaryTreeD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = i2 + 4 | 0;
 if ((HEAP32[i2 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 8 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14NavMeshManager21UnregisterOffMeshLinkERi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + 92 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 if ((i5 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = -1;
  return;
 }
 i6 = HEAP32[i1 + 80 >> 2] | 0;
 i1 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
 HEAP32[i6 + (i3 << 2) >> 2] = i1;
 HEAP32[i1 + 92 >> 2] = i3;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN13SplatDatabaseC2EP11TerrainData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 512;
 HEAP32[i1 + 40 >> 2] = 512;
 HEAP32[i1 + 44 >> 2] = -1;
 HEAP8[i1 + 48 >> 0] = 1;
 HEAP8[i1 + 49 >> 0] = 1;
 HEAP8[i1 + 50 >> 0] = 1;
 HEAP32[i1 + 32 >> 2] = i2;
 return;
}

function __ZN11UnityEngine7ConnectL18StaticCallOnUpdateEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 240 | 0;
 i3 = i1;
 __ZN19ScriptingInvocationC2EPKcS1_S1_S1_(i3, HEAP32[gb + 66596 >> 2] | 0, gb + 1049797 | 0, gb + 1044144 | 0, gb + 1044159 | 0);
 HEAP32[i2 >> 2] = 0;
 __ZN19ScriptingInvocation6InvokeIP12Il2CppObjectEET_PP15Il2CppExceptionb(i3, i2, 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZN10TagManager21FindDefaultLayerIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 1080 | 0;
 HEAP32[i4 >> 2] = 0;
 i3 = HEAP32[i1 + 1068 >> 2] | 0;
 i1 = (HEAP32[i1 + 1072 >> 2] | 0) - i3 | 0;
 i2 = (i1 | 0) / 40 | 0;
 if (!i1) return; else i1 = 0;
 while (1) {
  if (!(HEAP32[i3 + (i1 * 40 | 0) + 32 >> 2] | 0)) break;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return;
 HEAP32[i4 >> 2] = i1;
 return;
}

function __Z55NavMeshAgent_CUSTOM_INTERNAL_CALL_CalculatePathInternalP12Il2CppObjectRK8Vector3fS0_(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZNK12NavMeshAgent20CalculatePolygonPathERK8Vector3fP11NavMeshPath(i3, i4, i2) | 0) > 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52Bounds_CUSTOM_INTERNAL_CALL_Internal_GetClosestPointR4AABBR8Vector3fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 4 | 0;
 __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf(i2, i1, i5, i4);
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i5 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i5 + 8 >> 2];
 STACKTOP = i4;
 return;
}

function __Z51ParticleSystem_InheritVelocityModule_CUSTOM_GetModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 872 >> 2] | 0) + 8 >> 2] | 0;
 return i2 | 0;
}

function __Z49ParticleSystem_NoiseModule_CUSTOM_GetRemapEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 888 >> 2] | 0) + 1884 >> 0] | 0;
 return i2 | 0;
}

function __Z48ParticleSystem_MainModule_CUSTOM_GetMaxParticlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = __ZNK14ParticleSystem18GetMaxNumParticlesEv(i2) | 0;
 return i2 | 0;
}

function __Z44getPxVehicleWheelsSimData_TireLoadFilterDataPKN5physx22PxVehicleWheelsSimDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __Z38PreallocateObjectFromPersistentManagerib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i2) {
  i3 = __ZN17PersistentManager25PreallocateObjectThreadedEi(__Z20GetPersistentManagerv() | 0, i1) | 0;
  STACKTOP = i4;
  return i3 | 0;
 } else {
  HEAP32[i3 >> 2] = i1;
  i3 = __ZNK4PPtrI6ObjectEcvPS0_Ev(i3) | 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 return 0;
}

function __Z32getPxVehicleWheelsMWheelsDynDataPKN5physx15PxVehicleWheelsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority(i3, i4, i5, i6, i1, i7, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 if (HEAP32[i3 >> 2] | 0) HEAP32[i3 >> 2] = 0;
 if (i6 | 0) {
  i1 = 0;
  do {
   mftCall_vii(i4 | 0, i5 | 0, i1 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i6 | 0));
 }
 if (i7 | 0) mftCall_vi(i7 | 0, i5 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 return;
}

function __Z31Animator_CUSTOM_IsBoneTransformP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   return (__ZN8Animator15IsBoneTransformEP9Transform(i3, i1) | 0) & 1 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29Rigidbody2D_CUSTOM_IsTouchingP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   return (__ZNK11Rigidbody2D10IsTouchingEP10Collider2D(i3, i1) | 0) & 1 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Mesh_CUSTOM_SetTrianglesImplP12Il2CppObjectiP11Il2CppArrayih(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) {
   __Z24SetMeshIndicesFromScriptR4Meshi16GfxPrimitiveTypeP11Il2CppArrayib(i6, i2, 0, i3, i4, i5 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27ConvertToAlphaTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 3:
 case 8:
  {
   i1 = 5;
   break;
  }
 case 7:
  {
   i1 = 2;
   break;
  }
 case 10:
  {
   i1 = 12;
   break;
  }
 case 30:
  {
   i1 = 31;
   break;
  }
 case 32:
  {
   i1 = 33;
   break;
  }
 case 34:
  {
   i1 = 2;
   break;
  }
 case 35:
  {
   i1 = 36;
   break;
  }
 case 45:
  {
   i1 = 47;
   break;
  }
 case 60:
  {
   i1 = 61;
   break;
  }
 default:
  {}
 }
 return i1 | 0;
}

function __Z23LogOutputToSpecificFilePKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1450760 >> 2] | 0, gb + 63176 | 0);
 i2 = (_strlen(i1) | 0) + 1 | 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63176 | 0, 0, gb + 582853 | 0, 122) | 0;
 HEAP32[gb + 1450760 >> 2] = i3;
 _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 i1 = _fopen(i1, gb + 1085899 | 0) | 0;
 HEAP32[gb + 1450764 >> 2] = i1;
 return;
}

function __Z12UnloadObjectP6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __Z28delete_object_internal_step1P6Object(i1);
 i4 = HEAP32[i1 + 8 >> 2] & 2047;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i2);
 STACKTOP = i3;
 return;
}

function __Z12CancelInvokeR13MonoBehaviour(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i5 = i2;
 i4 = __Z21GetDelayedCallManagerv() | 0;
 HEAP32[i5 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_(i4, i3, fb + 595 | 0, 0, 0);
 STACKTOP = i2;
 return;
}

function _UNITY_LZ4_compress(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16416 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 _memset(i4 | 0, 0, 16416) | 0;
 if ((i3 | 0) < 65547) {
  i4 = _LZ4_compress_generic(i4, i1, i2, i3, 0, 0, 2, 0, 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 } else {
  i4 = _LZ4_compress_generic(i4, i1, i2, i3, 0, 0, 0, 0, 0) | 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 return 0;
}

function _sfnt_module_class_pic_free(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i3 + 212 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_sfnt_services(i3, i1);
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _UNITY_FT_Destroy_Class_tt_cmap_classes(i3, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i4, i6);
 HEAP32[i5 >> 2] = 0;
 return;
}

function _cff_driver_class_pic_free(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i5 = i3 + 196 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (!i6) return;
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 | 0) _UNITY_FT_Destroy_Class_cff_services(i3, i1);
 HEAP32[i6 >> 2] = 0;
 i1 = i6 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) _UNITY_FT_Destroy_Class_cff_field_handlers(i3, i2);
 HEAP32[i1 >> 2] = 0;
 _UNITY_ft_mem_free(i4, i6);
 HEAP32[i5 >> 2] = 0;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj(i4 + -4 | 0, i6, i2, i3);
 STACKTOP = i5;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i6 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj(i4 + -4 | 0, i6, i2, i3);
 STACKTOP = i5;
 return;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8ContainsEPKv(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv(i2, i4) | 0) {
  i4 = 1;
  return i4 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) i1 = HEAP32[i3 + 40 >> 2] | 0;
 i4 = __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv(i1, i4) | 0;
 return i4 | 0;
}

function __ZN9GfxDevice22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_(i1, i2, i10, i11, i12, i13, i14, i15, i16, i17, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return;
}

function __ZN7b2WorldD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 102956 >> 2] | 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 + 96 >> 2] | 0;
  i2 = HEAP32[i2 + 100 >> 2] | 0;
  if (i2 | 0) do {
   i4 = i2;
   i2 = HEAP32[i2 + 24 >> 2] | 0;
   HEAP32[i4 + 48 >> 2] = 0;
   __ZN9b2Fixture7DestroyEP16b2BlockAllocator(i4, i3);
  } while ((i2 | 0) != 0);
 } while ((i1 | 0) != 0);
 __ZN12b2BroadPhaseD2Ev(i3 + 102872 | 0);
 __ZN16b2BlockAllocatorD2Ev(i3);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefIKhEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefIKhEE(i1, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx7NpScene15getRenderBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP8[i1 + 3696 >> 0] | 0)) {
  i1 = i1 + 3476 | 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 2, gb + 678666 | 0, 1413, gb + 705429 | 0, i2);
 i1 = i1 + 3476 | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc8BodyCore7restoreEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 156 >> 2] | 0;
 HEAP32[i1 + 140 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 128 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 132 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 136 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 + 48 >> 2];
 HEAP32[i1 + 124 >> 2] = HEAP32[i2 + 52 >> 2];
 HEAP32[i1 + 112 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 116 >> 2] = HEAP32[i2 + 60 >> 2];
 return;
}

function __ZN5physx2Sc12MaterialCoreC2ERKNS_15PxsMaterialDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP16[i2 + 12 >> 1] = HEAP16[i1 + 12 >> 1] | 0;
 i3 = i2 + 14 | 0;
 i1 = i1 + 14 | 0;
 i1 = HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8;
 HEAP8[i3 >> 0] = i1;
 HEAP8[i3 + 1 >> 0] = i1 >> 8;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = -1;
 return;
}

function __ZN5Umbra9Matrix4x35identEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 20 >> 2] = Math_fround(1.0);
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(0.0);
 return i1 | 0;
}

function __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 900 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z49ParticleSystem_NoiseModule_CUSTOM_GetSeparateAxesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 888 >> 2] | 0) + 804 >> 0] | 0;
 return i2 | 0;
}

function __Z48ParticleSystem_TrailModule_CUSTOM_GetTextureModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 908 >> 2] | 0) + 280 >> 2] | 0;
 return i2 | 0;
}

function __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 888 >> 2] | 0) + 808 >> 2] | 0;
 return i2 | 0;
}

function __Z48ParticleSystem_CollisionModule_CUSTOM_GetQualityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 904 >> 2] | 0) + 960 >> 2] | 0;
 return i2 | 0;
}

function __Z46TerrainData_CUSTOM_INTERNAL_get_heightmapScaleP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 248 + 88 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39GUIClip_CUSTOM_INTERNAL_get_topmostRectP5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN12GUIClipState22GetTopMostPhysicalRectEv(i3, (__Z11GetGUIStatev() | 0) + 96 | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z30GetLightProbeProxyVolumeSampleRK28LightProbeProxyVolumeContextsR27LightProbeProxyVolumeSample(i1, i2, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 if (i2 << 16 >> 16 == -1) return;
 i1 = (HEAP32[i1 >> 2] | 0) + ((i2 << 16 >> 16) * 100 | 0) | 0;
 i2 = i5;
 i3 = i1;
 i4 = i2 + 96 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  i2 = i2 + 4 | 0;
  i3 = i3 + 4 | 0;
 } while ((i2 | 0) < (i4 | 0));
 HEAP8[i5 + 96 >> 0] = HEAP8[i1 + 96 >> 0] | 0;
 return;
}

function __Z29GUIStyle_CUSTOM_Internal_DrawP12Il2CppObjectR26MonoInternal_DrawArguments(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i3 = __Z11GetGUIStatev() | 0;
 i1 = __Z26MonoGUIContentToTempNativeP12Il2CppObject(i1) | 0;
 __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb(i4, i3, i2 + 4 | 0, i1, (HEAP32[i2 + 20 >> 2] | 0) != 0, (HEAP32[i2 + 24 >> 2] | 0) != 0, (HEAP32[i2 + 28 >> 2] | 0) != 0, (HEAP32[i2 + 32 >> 2] | 0) != 0);
 return;
}

function __Z21GetAIScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459868 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63728 | 0, 16, gb + 849930 | 0, 16) | 0;
 HEAP32[gb + 1459868 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 850049 | 0, gb + 850064 | 0) | 0;
 HEAP32[HEAP32[gb + 1459868 >> 2] >> 2] = i1;
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 268 | 0, fb + 269 | 0);
 i1 = HEAP32[gb + 1459868 >> 2] | 0;
 return i1 | 0;
}

function __Z14DoubleToStringd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 8 | 0;
 HEAPF64[i5 >> 3] = d2;
 _snprintf(i4, 255, gb + 1084516 | 0, i5) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i3;
 return;
}

function _unzClose(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = -102;
  return i4 | 0;
 }
 i2 = i1 + 156 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 | 0) _free(i4);
  HEAP32[i3 >> 2] = 0;
  if (HEAP32[i3 + 64 >> 2] | 0) _unity_z_inflateEnd(i3 + 4 | 0) | 0;
  _free(i3);
  HEAP32[i2 >> 2] = 0;
 }
 mftCall_iii(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 + 32 >> 2] | 0) | 0;
 _free(i1);
 i4 = 0;
 return i4 | 0;
}

function _shm_open(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i4 = i6 + 4 | 0;
 i1 = ___shm_mapname(i1, i6 + 8 | 0) | 0;
 if (!i1) i1 = -1; else {
  _pthread_setcancelstate(1, i4 | 0) | 0;
  HEAP32[i5 >> 2] = i3;
  i1 = _open(i1, i2 | 657408, i5) | 0;
  _pthread_setcancelstate(HEAP32[i4 >> 2] | 0, 0) | 0;
 }
 STACKTOP = i6;
 return i1 | 0;
}

function _pwrite(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i4;
 HEAP32[i6 + 20 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
 i4 = ___syscall_ret(___syscall181(181, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function ___crypt_sha512(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = _sha512crypt(i1, i2, i3) | 0;
 if ((i1 | 0) != 0 & (_sha512crypt(gb + 1056813 | 0, gb + 1056831 | 0, i4) | 0) == (i4 | 0)) {
  i4 = (_memcmp(i4, gb + 1056861 | 0, 116) | 0) == 0;
  i1 = i4 ? i1 : gb + 1086428 | 0;
 } else i1 = gb + 1086428 | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i3 >> 2] = f5;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(Math_fround(f6 - Math_fround(HEAPF32[i4 >> 2])) / f5);
 i4 = i3 + 4 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) * f5);
 return;
}

function __ZNK5physx2Sc15ArticulationSim13findBodyIndexERNS0_7BodySimE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  i4 = -2147483648;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -2147483648;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN6Camera15StandaloneSetupER17ShaderPassContext(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN13RenderManager16SetCurrentCameraEP6Camera(__Z16GetRenderManagerv() | 0, i1);
 __ZNK6Camera28ExtractCameraRenderingParamsEv(i4, i1);
 __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i1, i2, i4, 5);
 STACKTOP = i3;
 return;
}

function __ZN5simdi8allEqualERK8Scalar4fS2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i2 + 4 >> 2] | 0)) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] | 0) != (HEAP32[i2 + 8 >> 2] | 0)) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (HEAP32[i2 + 12 >> 2] | 0);
 i2 = i2 & 1;
 return i2 | 0;
}

function __ZN5physx7NpCloth7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, HEAP32[i2 + 8 >> 2] | 0, 1);
 i1 = __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) | 0;
 if (!i1) {
  i2 = i2 + 20 | 0;
  __ZN5physx3Scb4Base7destroyEv(i2);
  return;
 }
 __ZN5physx7NpScene11removeClothERNS_7NpClothE(i1, i2);
 i2 = i2 + 20 | 0;
 __ZN5physx3Scb4Base7destroyEv(i2);
 return;
}

function __ZN5physx7NpCloth17resolveReferencesERNS_24PxDeserializationContextE(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i4 + 124 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, -2147483648, i1 | 0) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 12 | 0) | 0;
 __ZN5physx2Sc9ClothCore17resolveReferencesERNS0_15ClothFabricCoreE(i4 + 32 | 0, (HEAP32[i3 >> 2] | 0) + 16 | 0);
 return;
}

function __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 766871;
 HEAP32[i1 + 4 >> 2] = 399;
 HEAP32[i1 + 8 >> 2] = fb + 402;
 HEAP32[i1 + 12 >> 2] = fb + 344;
 HEAP32[i1 + 16 >> 2] = gb + 674822;
 HEAP32[i1 + 20 >> 2] = 400;
 HEAP32[i1 + 24 >> 2] = fb + 403;
 HEAP32[i1 + 28 >> 2] = fb + 345;
 HEAP32[i1 + 32 >> 2] = gb + 765184;
 HEAP32[i1 + 36 >> 2] = 401;
 HEAP32[i1 + 40 >> 2] = fb + 404;
 HEAP32[i1 + 44 >> 2] = fb + 346;
 return;
}

function __ZN5physx17solveContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (i3 >>> 0 > 1) {
  i1 = 1;
  do {
   __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i1 + -1 << 5) | 0, i2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i3 + -1 << 5) | 0, i2);
 return;
}

function __ZN24AudioScriptBufferManager18BeforeDomainReloadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i1 + 4 | 0;
  __Z23scripting_gchandle_freej(HEAP32[i2 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = i1 + 16 | 0;
 __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14TerrainManager17Heightmap_GetSizeER9Heightmap(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i3 + 88 >> 2]);
 f5 = Math_fround(f5 * Math_fround((HEAP32[i3 + 72 >> 2] | 0) + -1 | 0));
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 f4 = Math_fround(HEAPF32[i3 + 96 >> 2]);
 f4 = Math_fround(f4 * Math_fround((HEAP32[i3 + 76 >> 2] | 0) + -1 | 0));
 HEAPF32[i1 >> 2] = f5;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAPF32[i1 + 8 >> 2] = f4;
 return;
}

function __ZN14RenderSettings22SetReflectionIntensityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 364 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 i3 = HEAP32[gb + 1112272 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[((HEAP32[i1 + 368 >> 2] | 0) == 0 ? i1 + 384 | 0 : i1 + 380 | 0) >> 2];
 HEAPF32[i3 + 4 >> 2] = f2;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i3);
 __ZN14RenderSettings27UpdateIndirectSpecularColorEv(i1);
 return;
}

function __ZN14GfxContextGLES8InstanceC2EN2gl13ContextHandleER7ApiGLES(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 __ZN18GfxFramebufferGLESC2ER7ApiGLESPv(i3 + 8 | 0, i2, i3);
 i1 = i3 + 532 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 695 >> 0] | 0)) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 536 >> 2] = -1;
  return;
 } else {
  __ZN7ApiGLES17CreateVertexArrayEv(i1, HEAP32[gb + 1451080 >> 2] | 0);
  return;
 }
}

function __ZN13TranslateGLES21InitFramebufferTargetERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = (HEAP8[i2 + 666 >> 0] | 0) != 0;
 HEAP32[i5 >> 2] = i4 ? 36009 : 36160;
 HEAP32[i5 + 4 >> 2] = i4 ? 36008 : 36160;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 STACKTOP = i3;
 return;
}

function __ZN12LightsModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 16 | 0;
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0) | 0;
 if (HEAP8[i2 + 40 >> 0] | 0) HEAP32[i4 >> 2] = i3;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 24 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 288 | 0, i2);
 return;
}

function __ZN10FileSystem19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _strlen(gb + 1546878 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1546878 | 0, i2);
 _strncpy(gb + 1546878 | 0, (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3, 1040) | 0;
 return;
}

function __ZL23stbir__filter_trapezoidff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f3 = f0, f4 = f0;
 f3 = Math_fround(f2 * Math_fround(.5));
 f4 = Math_fround(f3 + Math_fround(.5));
 f1 = Math_fround(Math_abs(Math_fround(f1)));
 if (f1 >= f4) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 if (f1 <= Math_fround(Math_fround(.5) - f3)) {
  f4 = Math_fround(1.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(Math_fround(f4 - f1) / f2);
 return Math_fround(f4);
}

function __Z54GUILayoutUtility_CUSTOM_INTERNAL_CALL_GetWindowsBoundsR5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN5IMGUI16GetWindowsBoundsER8GUIState(i3, __Z11GetGUIStatev() | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z50ParticleSystem_SubEmittersModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 916 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 892 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z47ParticleSystem_LightsModule_CUSTOM_GetMaxLightsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 920 >> 2] | 0) + 552 >> 2] | 0;
 return i2 | 0;
}

function __Z35Renderer_Get_Custom_PropCastShadowsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) {
  i2 = i1;
  __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i2);
 } else {
  i2 = i2 + 32 + 236 | 0;
  return ((HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 192 | 0) != 0 | 0;
 }
 return 0;
}

function __Z29InitPathNamePersistentManagerv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(220, gb + 63216 | 0, 16, gb + 466747 | 0, gb + 1576256 | 0, gb + 466763 | 0, 48) | 0;
 __ZN17PersistentManagerC2Eii(i1, 0, 2);
 HEAP32[i1 >> 2] = gb + 66936 + 8;
 i2 = i1 + 200 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i1 + 196 >> 2] = i2;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 212 >> 2] = 0;
 HEAP32[i1 + 216 >> 2] = 0;
 __Z19pop_allocation_rootv();
 return;
}

function __Z27Random_Get_Custom_PropValuev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z16GetScriptingRandv() | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i3 = i3 << 11 ^ i3;
 i1 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 i4 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 i2 = i2 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = i3 >>> 8 ^ i3 ^ i1 ^ i1 >>> 19;
 HEAP32[i2 >> 2] = i1;
 return Math_fround(Math_fround((i1 & 8388607) >>> 0) * Math_fround(1.19209304e-07));
}

function _unity_z_adler32_combine(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = (i3 >>> 0) % 65521 | 0;
 i4 = i1 & 65535;
 i3 = i4 + 65520 + (i2 & 65535) | 0;
 i2 = (i1 >>> 16) + 65521 + (i2 >>> 16) - i5 + (((Math_imul(i5, i4) | 0) >>> 0) % 65521 | 0) | 0;
 i3 = i3 >>> 0 > 65521 ? i3 + -65521 | 0 : i3;
 i2 = i2 >>> 0 > 131042 ? i2 + -131042 | 0 : i2;
 return (i2 >>> 0 > 65521 ? i2 + 15 | 0 : i2) << 16 | (i3 >>> 0 > 65521 ? i3 + -65521 | 0 : i3) | 0;
}

function _tlsf_walk_heap(i2, i1, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 | 0 ? i1 : fb + 263 | 0;
 i1 = i2 + 3184 | 0;
 if (!i1) return;
 while (1) {
  i2 = i1 + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 >>> 0 < 4) {
   i1 = 4;
   break;
  }
  i1 = i1 + 8 | 0;
  mftCall_viiii(i4 | 0, i1 | 0, i3 & -4 | 0, i3 & 1 ^ 1 | 0, i5 | 0);
  i1 = ((HEAP32[i2 >> 2] | 0) + -4 & -4) + i1 | 0;
  if (!i1) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return;
}

function _pread(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = 0;
 HEAP32[i6 + 16 >> 2] = i4;
 HEAP32[i6 + 20 >> 2] = ((i4 | 0) < 0) << 31 >> 31;
 i4 = ___syscall_ret(___syscall180(180, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function ___crypt_sha256(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 128 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = _sha256crypt(i1, i2, i3) | 0;
 if ((i1 | 0) != 0 & (_sha256crypt(gb + 1059475 | 0, gb + 1059493 | 0, i4) | 0) == (i4 | 0)) {
  i4 = (_memcmp(i4, gb + 1059523 | 0, 73) | 0) == 0;
  i1 = i4 ? i1 : gb + 1086428 | 0;
 } else i1 = gb + 1086428 | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZZN8VRModuleC1EvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1469188 >> 2] | 0;
 i2 = __Z12GetIVRDevicev() | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 __Z12SetIVRDeviceP9IVRDevice(0);
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63816 | 0);
 HEAP32[i1 + 16 >> 2] = HEAP32[gb + 189476 >> 2];
 HEAP8[i1 + 20 >> 0] = 0;
 return;
}

function __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 766871;
 HEAP32[i1 + 4 >> 2] = 278;
 HEAP32[i1 + 8 >> 2] = fb + 3475;
 HEAP32[i1 + 12 >> 2] = fb + 3476;
 HEAP32[i1 + 16 >> 2] = gb + 673094;
 HEAP32[i1 + 20 >> 2] = 279;
 HEAP32[i1 + 24 >> 2] = fb + 2102;
 HEAP32[i1 + 28 >> 2] = fb + 3477;
 HEAP32[i1 + 32 >> 2] = gb + 754619;
 HEAP32[i1 + 36 >> 2] = 280;
 HEAP32[i1 + 40 >> 2] = fb + 2103;
 HEAP32[i1 + 44 >> 2] = fb + 3478;
 return;
}

function __ZN5physx2Sc9ClothCore25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0, i4 = 0;
 i2 = i2 + 28 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 mftCall_viff(HEAP32[(HEAP32[i4 >> 2] | 0) + 272 >> 2] | 0, i4 | 0, +f3, +Math_fround(HEAPF32[i1 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0, +Math_fround(HEAPF32[i1 + 8 >> 2]));
 return;
}

function __ZN18MultiFrameGUIStateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN5IMGUI14GUIWindowStateD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11TypeManager23CallPostInitializeTypesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 48 | 0;
 i5 = i1 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return; else i4 = 0;
 do {
  i3 = HEAP32[i2 + (i4 * 12 | 0) + 4 >> 2] | 0;
  if (i3) {
   mftCall_v(i3 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < ((i1 - i2 | 0) / 12 | 0) >>> 0);
 return;
}

function __Z50AsyncOperation_Get_Custom_PropAllowSceneActivationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0) & 1;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z47ParticleSystem_TrailModule_CUSTOM_GetWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 284 >> 0] | 0;
 return i2 | 0;
}

function __Z47ParticleSystem_MainModule_CUSTOM_GetStartSize3DP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 2552 >> 0] | 0;
 return i2 | 0;
}

function __Z40GUIClip_CUSTOM_INTERNAL_CALL_Unclip_RectR5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN12GUIClipState6UnclipERK5RectTIfE(i3, (__Z11GetGUIStatev() | 0) + 96 | 0, i1);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z11IntToStringi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 i4 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 _snprintf(i4, 255, gb + 585569 | 0, i5) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i3;
 return;
}

function __ZN9Animation4PlayERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) == 1) {
  __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii(i1, i2, Math_fround(0.0), 0, 0) | 0;
  return 1;
 } else {
  __ZN9Animation9CrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfi(i1, i2, Math_fround(0.0), i3);
  return 1;
 }
 return 0;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext19ProfileEventHandler14findCollectionEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 if ((i4 | 0) == 99999789) {
  i4 = i1 + 4 | 0;
  return i4 | 0;
 }
 i3 = i1 + 24 | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 while (1) {
  if (!i2) {
   i1 = 0;
   i2 = 6;
   break;
  }
  i2 = i2 + -1 | 0;
  i1 = (HEAP32[i3 >> 2] | 0) + (i2 * 20 | 0) | 0;
  if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) {
   i2 = 6;
   break;
  }
 }
 if ((i2 | 0) == 6) return i1 | 0;
 return 0;
}

function __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 8 >> 2];
  return;
 }
 HEAP32[i3 + 128 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 132 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 136 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5Umbra15MemOutputStreamC2EPNS_9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = gb + 79040 + 8;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 if (!i2) {
  if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
   HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
   HEAP32[gb + 1451688 + 8 >> 2] = 1;
  }
  HEAP32[i3 >> 2] = gb + 1451688;
 }
 HEAP32[i1 >> 2] = gb + 78624 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN2UI6Canvas30SetSortingBucketNormalizedSizeEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 if (HEAP32[i3 + 344 >> 2] | 0) return;
 i2 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i2 ? Math_fround(0.0) : f1;
 i2 = i3 + 404 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAPF32[i3 + 416 >> 2] = f1;
 i4 = i3 + 224 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 6;
 return;
}

function __ZN2UI14CanvasRenderer15SetAlphaTextureEP7Texture(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 48 >> 2] | 0;
 i4 = i2 + 140 | 0;
 i3 = (i1 | 0) == (HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = i1;
 if (i3) return;
 i4 = i2 + 162 | 0;
 HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i2 + 188 >> 2] | 0, i2);
 return;
}

function __ZN16GUIKeyboardStateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) {
  __ZN5IMGUI14GUIWindowStateD2Ev(i2);
  __ZdlPv(i2);
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) return;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN15HeightMeshQuery4InitEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 4 | 0;
 HEAPF32[i6 >> 2] = f3;
 HEAPF32[i1 + 16 >> 2] = f2;
 HEAPF32[i5 >> 2] = Math_fround(.00100000005);
 i7 = f3 > Math_fround(.00100000005);
 HEAP32[i1 + 20 >> 2] = HEAP32[(i7 ? i6 : i5) >> 2];
 STACKTOP = i4;
 return;
}

function __ZN13SpringJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13SliderJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10Matrix3x3fC2ERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __Z48ParticleSystem_CollisionModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 904 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z48ConstantForce_CUSTOM_INTERNAL_set_relativeTorqueP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 72 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46ParticleSystem_TriggerModule_CUSTOM_GetOutsideP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 912 >> 2] | 0) + 12 >> 2] | 0;
 return i2 | 0;
}

function __Z45ParticleSystem_CollisionModule_CUSTOM_GetTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 904 >> 2] | 0) + 136 >> 2] | 0;
 return i2 | 0;
}

function __Z45ParticleSystem_CollisionModule_CUSTOM_GetModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 904 >> 2] | 0) + 140 >> 2] | 0;
 return i2 | 0;
}

function __Z25Application_CUSTOM_Unloadv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 __Z6FormatPKcz(i2, gb + 492746 | 0, i1);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 492823 | 0, 118, 512, 0, 0, 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 STACKTOP = i1;
 return;
}

function __Z22WWW_Get_Custom_PropUrlP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __Z20scripting_string_newPKc(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function __Z17deleteBucketAllocP11BucketAlloc(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i4 + 20 >> 2] | 0;
 i5 = i4 + 4 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = i3 + 8 | 0;
 i3 = i3 + 12 | 0;
 if (i1 | 0) do {
  i6 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 mftCall_vii(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i4 | 0);
 return;
}

function _UNITY_FT_Init_Class_tt_cmap13_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 44;
 HEAP32[i1 + 4 >> 2] = fb + 1052;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1053;
 HEAP32[i1 + 16 >> 2] = fb + 1054;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 13;
 HEAP32[i1 + 44 >> 2] = fb + 1055;
 HEAP32[i1 + 48 >> 2] = fb + 1056;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap12_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 44;
 HEAP32[i1 + 4 >> 2] = fb + 1047;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1048;
 HEAP32[i1 + 16 >> 2] = fb + 1049;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 12;
 HEAP32[i1 + 44 >> 2] = fb + 1050;
 HEAP32[i1 + 48 >> 2] = fb + 1051;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap10_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 24;
 HEAP32[i1 + 4 >> 2] = fb + 1021;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1043;
 HEAP32[i1 + 16 >> 2] = fb + 1044;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 10;
 HEAP32[i1 + 44 >> 2] = fb + 1045;
 HEAP32[i1 + 48 >> 2] = fb + 1046;
 return;
}

function b141(i1, f2, f10, f11, f12, f13, f14, f15, f16, f17, f3, f4, f5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 f13 = Math_fround(f13);
 f14 = Math_fround(f14);
 f15 = Math_fround(f15);
 f16 = Math_fround(f16);
 f17 = Math_fround(f17);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_viffffffffffffiiii(141);
}

function __ZNSt3__221recursive_timed_mutexD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 invoke_vi(fb + 4006 | 0, i1 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__218condition_variableD2Ev(i1 + 28 | 0);
  __ZNSt3__25mutexD2Ev(i1);
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__25mutex6unlockEv(i1);
  __ZNSt3__218condition_variableD2Ev(i1 + 28 | 0);
  __ZNSt3__25mutexD2Ev(i1);
  return;
 }
}

function __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2 | 0) {
  i3 = i1 + 4 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  while (1) {
   if ((i4 | 0) == (i2 | 0)) break;
   i5 = i4 + -4 | 0;
   HEAP32[i3 >> 2] = i5;
   i4 = i5;
  }
  if ((i1 + 16 | 0) == (i2 | 0)) {
   HEAP8[i1 + 128 >> 0] = 0;
   break;
  } else {
   __ZdlPv(i2);
   break;
  }
 } while (0);
 return;
}

function __ZNK9Texture2D26CanReuploadDataToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[i1 + 112 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP32[i1 + 52 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if (HEAP8[i1 + 111 >> 0] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 1048576)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z20GetPersistentManagerv() | 0;
 i1 = __ZN17PersistentManager17IsObjectAvailableEi(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc15ArticulationSim13getLinkHandleERNS0_7BodySimE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 L1 : do if (!i3) i1 = -2147483648; else {
  i2 = HEAP32[i1 + 24 >> 2] | 0;
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i4 | 0)) break L1;
   i1 = i1 + 1 | 0;
   if (i1 >>> 0 >= i3 >>> 0) {
    i1 = -2147483648;
    break;
   }
  }
 } while (0);
 return i1 | i5 | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63160 | 0) | 0;
  i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  return i2 | 0;
 } else {
  i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK12NavMeshAgent13GetPathStatusEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 2;
  return i1 | 0;
 }
 i1 = i1 + 68 | 0;
 if (!(HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 44 >> 0] & 1)) {
  i1 = 2;
  return i1 | 0;
 }
 i1 = (HEAPU8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1) | 0) + 44 >> 0] | 0) >>> 1 & 1;
 return i1 | 0;
}

function __ZN8Collider29GetPositionAndRotationUtilityERK9TransformRK8Vector3fR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 __ZNK9Transform14TransformPointERK8Vector3f(i6, i1, i2);
 __ZNK9Transform11GetRotationEv(i5, i1);
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i3, i6, i5);
 STACKTOP = i4;
 return;
}

function __ZN6prcoreL13inner_stretchILj4ELj4EEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = i3 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + (i1 >>> 16 << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
  }
 }
 return;
}

function __ZN5physx5cloth15intersectBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 __Z3maxRK8Scalar4fS1_(i6, i1, i3);
 __ZN8Scalar4faSERKS_(i2, i6) | 0;
 __Z3minRK8Scalar4fS1_(i5, i1 + 16 | 0, i3 + 16 | 0);
 __ZN8Scalar4faSERKS_(i2 + 16 | 0, i5) | 0;
 STACKTOP = i4;
 return;
}

function __ZN17TransformInternal21DetachTransformThreadER18TransformHierarchyjj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i2 + 72 >> 2] | 0;
 i6 = i5 + (i1 << 2) | 0;
 i4 = HEAP32[i6 >> 2] | 0;
 i2 = HEAP32[i2 + 68 >> 2] | 0;
 i3 = i2 + (i3 << 2) | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i2 + (i4 << 2) >> 2] = i1;
 HEAP32[i3 >> 2] = -1;
 if ((i1 | 0) == -1) return;
 HEAP32[i5 + (i1 << 2) >> 2] = i4;
 return;
}

function __ZN15FileSystemEntryC2ERK13FileEntryData(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 1040 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 1040 >> 2];
 HEAP32[i2 + 1044 >> 2] = HEAP32[i1 + 1044 >> 2];
 HEAP32[i2 + 1048 >> 2] = 0;
 HEAP32[i2 + 1052 >> 2] = 0;
 HEAP32[i2 + 1056 >> 2] = 0;
 _strncpy(i2, i1, 1040) | 0;
 HEAP8[i2 + 1039 >> 0] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN14GfxDeviceStats9DrawStats5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 96 | 0;
 i3 = i1 + 100 | 0;
 i4 = i1;
 i5 = i4 + 96 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14DataBufferGLES14RecordRecreateEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = i2 + 20 | 0;
 i1 = i2 + 4 | 0;
 if (HEAP8[i4 >> 0] | 0) __Z34register_external_gfx_deallocationPvPKci(HEAP32[i1 >> 2] | -1073741824, gb + 602218 | 0, 228);
 HEAP32[i2 + 8 >> 2] = i3;
 HEAP32[i2 + 24 >> 2] = HEAP32[HEAP32[i2 >> 2] >> 2];
 HEAP8[i4 >> 0] = 1;
 __Z32register_external_gfx_allocationPvjjPKci(HEAP32[i1 >> 2] | -1073741824, i3, i2, gb + 602218 | 0, 235);
 return;
}

function __ZN13MonoBehaviour15InitializeClassEv() {
 __ZN14MessageHandler27RegisterAllMessagesCallbackEPKN5Unity4TypeEPFvPviR11MessageDataEPFbS4_iS6_E(__ZN14MessageHandler3GetEv() | 0, gb + 27592 | 0, fb + 695 | 0, fb + 376 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 1018436 | 0, gb + 587046 | 0, gb + 587059 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 590111 | 0, gb + 587074 | 0, gb + 587098 | 0);
 __Z48InitializeMonoBehaviourAnimationBindingInterfacev();
 return;
}

function __ZN11OffMeshLink12SetActivatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 99 | 0;
 if ((HEAPU8[i3 >> 0] | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 i1 = i1 + 40 | 0;
 i2 = i1;
 if ((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0) return;
 i4 = __Z17GetNavMeshManagerv() | 0;
 i2 = i1;
 __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb(i4, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, (HEAP8[i3 >> 0] | 0) != 0);
 return;
}

function __Z55QualitySettings_CUSTOM_INTERNAL_set_shadowCascade4SplitRK8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = __Z18GetQualitySettingsv() | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 __ZN15QualitySettings22SetShadowCascade4SplitE8Vector3f(i4, i3);
 STACKTOP = i2;
 return;
}

function __Z48ConstantForce_CUSTOM_INTERNAL_get_relativeTorqueP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 72 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleSystem_MainModule_CUSTOM_GetScalingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = __ZNK14ParticleSystem14GetScalingModeEv(i2) | 0;
 return i2 | 0;
}

function __Z47ConstantForce_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 48 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_GetQualityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 888 >> 2] | 0) + 820 >> 2] | 0;
 return i2 | 0;
}

function __Z34setPxCloth_CentrifugalInertiaScalePN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z31Mathf_CUSTOM_GammaToLinearSpacef(f1) {
 f1 = Math_fround(f1);
 do if (!(f1 <= Math_fround(.0404499993))) {
  if (f1 < Math_fround(1.0)) {
   f1 = Math_fround(+Math_pow(+Math_fround(Math_fround(f1 + Math_fround(.0549999997)) / Math_fround(1.05499995)), 2.4000001));
   break;
  }
  if (f1 == Math_fround(1.0)) f1 = Math_fround(1.0); else f1 = Math_fround(+Math_pow(+f1, 2.20000005));
 } else f1 = Math_fround(f1 / Math_fround(12.9200001)); while (0);
 return Math_fround(f1);
}

function __Z31GUIText_Set_Custom_PropMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   __ZN20TextRenderingPrivate7GUIText11SetMaterialEP8Material(i3, i1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21SetCurrentMemoryOwnerRK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[gb + 1163236 >> 2] | 0;
 if ((i3 | 0) < 4 | (HEAP32[i2 + 4 >> 2] | 0) != 0 | (i4 | 0) == 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i4 = i1;
  HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  return;
 } else {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i4) | 0;
  return;
 }
}

function __ZThn4_N12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE(i6, i1, i3, i5, i2, i4, i7) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 return __ZN12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE(i6 + -4 | 0, i1, i3, i5, i2, i4, i7) | 0;
}

function __ZNSt3__211__libcpp_db10__insert_iEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex4lockEv(gb + 1473456 | 0);
 __THREW__ = 0;
 invoke_iii(fb + 1144 | 0, i1 | 0, i2 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  ___resumeException(i2 | 0);
 } else {
  __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
  return;
 }
}

function __ZN9Rigidbody10DeactivateE19DeactivateOperation(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK9Rigidbody(__Z21GetManagerFromContexti(9) | 0, i3);
 if ((i1 | 0) != 2) __ZN9Rigidbody6CreateEb(i3, 0);
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 36 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA4444EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP16[i4 >> 1] = i3 >>> 12 & 3840 | i3 & 61440 | i3 >>> 24 & 240 | i3 >>> 4 & 15;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatARGB4444EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP16[i4 >> 1] = i3 >>> 4 & 3840 | i3 >>> 28 | i3 >>> 16 & 240 | i3 << 8 & 61440;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_(i1, i2) | 0;
 return ((i2 | 0) != (i1 + 4 | 0) ? i2 + 28 | 0 : 0) | 0;
}

function __ZN22UnityProfilerPerThread22SkipSampleRecurseIndexEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[(HEAP32[HEAP32[(HEAP32[i3 + 16 >> 2] | 0) + (i1 >>> 14 << 2) >> 2] >> 2] | 0) + ((i1 & 16383) * 24 | 0) + 12 >> 2] | 0;
 i1 = i1 + 1 | 0;
 if ((i4 | 0) > 0) i2 = 0; else {
  i4 = i1;
  return i4 | 0;
 }
 do {
  i1 = __ZN22UnityProfilerPerThread22SkipSampleRecurseIndexEj(i3, i1) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZN20ArchiveStorageHeader10CanReadAllERKNS_6HeaderE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 switch ((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0) {
 case 12:
  return (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489819 | 0, 12) | 0) == 0 | 0;
 case 8:
  {
   i3 = (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489801 | 0, 8) | 0) == 0;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZN17BillboardRendererD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 340 >> 2] = gb + 56316 + 252;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN16ReflectionProbes35ClearAllRuntimeReflectionSampleDataEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i2);
 i3 = i2 + 12 | 0;
 i4 = i2 + 24 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i1 = HEAP32[i3 >> 2] | 0;
 do {
  __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture(i2, HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != ((HEAP32[i3 >> 2] | 0) + (HEAP32[i4 >> 2] << 2) | 0));
 return;
}

function __ZN15TerrainRenderer13CleanupMeshesEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 16 >> 2] | 0;
 i5 = i4 + 20 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  i3 = i1 + 16 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 2) {
   __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode(i4, i1);
   i2 = HEAP32[i5 >> 2] | 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
  i1 = i1 + 64 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN14NavMeshManager15UnregisterAgentERi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + 52 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 if ((i5 | 0) == (i3 | 0)) {
  HEAP32[i4 >> 2] = i5;
  HEAP32[i2 >> 2] = -1;
  return;
 }
 i6 = HEAP32[i1 + 40 >> 2] | 0;
 i1 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
 HEAP32[i6 + (i3 << 2) >> 2] = i1;
 HEAP32[i1 + 88 >> 2] = i3;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN13MonoBehaviour10FindMethodEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!(HEAP32[i2 + 20 >> 2] | 0)) {
  i4 = gb + 1164176 | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  return;
 } else {
  __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i1, HEAP32[(HEAP32[i2 + 56 >> 2] | 0) + 4 >> 2] | 0, i3, 1);
  return;
 }
}

function __ZN13GfxDeviceGLES23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if (!i3) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 608 >> 2] | 0, i1 | 0);
 i1 = i1 + 4620 | 0;
 __ZN7ApiGLES22BindElementArrayBufferEj(i1, HEAP32[(HEAP32[i3 + 28 >> 2] | 0) + 4 >> 2] | 0);
 __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj(i1, i2, i6 << 1, i4, 0, i5);
 return;
}

function __Z50RectTransform_CUSTOM_INTERNAL_get_anchoredPositionP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 152 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ConstantForce_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 48 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46ParticleSystem_TriggerModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 912 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z45ParticleSystem_TriggerModule_CUSTOM_GetInsideP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 912 >> 2] | 0) + 8 >> 2] | 0;
 return i2 | 0;
}

function __Z44ParticleSystem_TriggerModule_CUSTOM_GetEnterP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 912 >> 2] | 0) + 16 >> 2] | 0;
 return i2 | 0;
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_GetDampingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 888 >> 2] | 0) + 805 >> 0] | 0;
 return i2 | 0;
}

function __Z33setPxCloth_AngularDragCoefficientPN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z32Physics2D_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = __Z19GetPhysicsManager2Dv() | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZN16Physics2DManager15IgnoreCollisionEP10Collider2DS1_b(i5, i2, i1, i4 << 24 >> 24 != 0);
 return;
}

function __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i1, i2, f3) | 0;
 i1 = i1 + 228 | 0;
 if ((i4 & -2) << 16 >> 16 == 2) {
  __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i1, i2 + 88 | 0, f3) | 0;
  return;
 } else {
  __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf(i1, i2, f3) | 0;
  return;
 }
}

function _UNITY_FT_Init_Class_tt_cmap8_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 24;
 HEAP32[i1 + 4 >> 2] = fb + 1021;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1039;
 HEAP32[i1 + 16 >> 2] = fb + 1040;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 8;
 HEAP32[i1 + 44 >> 2] = fb + 1041;
 HEAP32[i1 + 48 >> 2] = fb + 1042;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap6_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 24;
 HEAP32[i1 + 4 >> 2] = fb + 1021;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1035;
 HEAP32[i1 + 16 >> 2] = fb + 1036;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 6;
 HEAP32[i1 + 44 >> 2] = fb + 1037;
 HEAP32[i1 + 48 >> 2] = fb + 1038;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap4_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 56;
 HEAP32[i1 + 4 >> 2] = fb + 1030;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1031;
 HEAP32[i1 + 16 >> 2] = fb + 1032;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 4;
 HEAP32[i1 + 44 >> 2] = fb + 1033;
 HEAP32[i1 + 48 >> 2] = fb + 1034;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap2_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 24;
 HEAP32[i1 + 4 >> 2] = fb + 1021;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1026;
 HEAP32[i1 + 16 >> 2] = fb + 1027;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 2;
 HEAP32[i1 + 44 >> 2] = fb + 1028;
 HEAP32[i1 + 48 >> 2] = fb + 1029;
 return;
}

function _UNITY_FT_Init_Class_tt_cmap0_class_rec(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 24;
 HEAP32[i1 + 4 >> 2] = fb + 1021;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = fb + 1022;
 HEAP32[i1 + 16 >> 2] = fb + 1023;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = fb + 1024;
 HEAP32[i1 + 48 >> 2] = fb + 1025;
 return;
}

function _start_input_pass(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 i3 = HEAP32[i1 + 392 >> 2] | 0;
 do if ((HEAP32[i1 + 292 >> 2] | 0) > 1) HEAP32[i3 + 28 >> 2] = 1; else {
  i2 = HEAP32[i1 + 296 >> 2] | 0;
  if ((HEAP32[i1 + 284 >> 2] | 0) == 1) {
   HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 72 >> 2];
   break;
  } else {
   HEAP32[i3 + 28 >> 2] = HEAP32[i2 + 12 >> 2];
   break;
  }
 } while (0);
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNK6Camera19GetStereoSeparationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if (HEAP8[i1 + 1083 >> 0] | 0) if (__Z12GetIVRDevicev() | 0) {
  i2 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0) {
   i2 = __Z12GetIVRDevicev() | 0;
   f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0));
   return Math_fround(f3);
  }
 }
 f3 = Math_fround(HEAPF32[i1 + 1096 >> 2]);
 return Math_fround(f3);
}

function __ZN9Animation8GetStateEP14AnimationState(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 __ZN9Animation20BuildAnimationStatesEv(i3);
 i2 = HEAP32[i3 + 104 >> 2] | 0;
 i3 = HEAP32[i3 + 108 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
   i2 = 4;
   break;
  }
  i2 = i2 + 4 | 0;
  if ((i2 | 0) == (i3 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[gb + 73456 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i5 + ((HEAPU16[i1 >> 1] | 0) << 2) >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN6prcoreL13inner_stretchILj2ELj2EEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i5 = HEAP32[i3 + 20 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = HEAP16[i6 + (i1 >>> 16 << 1) >> 1] | 0;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i5 + i1 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx33PxVehicleChassisDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831380;
 HEAP32[i1 + 4 >> 2] = 514;
 HEAP32[i1 + 8 >> 2] = fb + 3975;
 HEAP32[i1 + 12 >> 2] = fb + 3976;
 HEAP32[i1 + 16 >> 2] = gb + 831374;
 HEAP32[i1 + 20 >> 2] = 515;
 HEAP32[i1 + 24 >> 2] = fb + 653;
 HEAP32[i1 + 28 >> 2] = fb + 566;
 HEAP32[i1 + 32 >> 2] = gb + 835752;
 HEAP32[i1 + 36 >> 2] = 516;
 HEAP32[i1 + 40 >> 2] = fb + 3977;
 HEAP32[i1 + 44 >> 2] = fb + 3978;
 return;
}

function __ZN21AnimationPosePlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE(HEAP32[i1 + 84 >> 2] | 0, HEAP32[i4 >> 2] | 0, (HEAP8[i2 + 33 >> 0] | 0) != 0, (HEAP8[i2 + 34 >> 0] | 0) != 0, HEAP32[i3 + 8 >> 2] | 0);
 return;
}

function __ZN12_GLOBAL__N_117ProfileZoneClientD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 150280 + 8;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = i1 + 8 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 return;
}

function __Z45ParticleSystem_LightsModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 920 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z43ParticleSystem_TriggerModule_CUSTOM_GetExitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[(HEAP32[i2 + 912 >> 2] | 0) + 20 >> 2] | 0;
 return i2 | 0;
}

function __Z43ParticleSystem_MainModule_CUSTOM_GetPrewarmP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = (__ZNK14ParticleSystem10GetPrewarmEv(i2) | 0) & 1;
 return i2 | 0;
}

function __Z35AnimationState_Set_Custom_PropLayerP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 32 >> 2] = i2;
   i3 = i1 + 64 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z32setPxCloth_LinearDragCoefficientPN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z32SetPlayerSettingsRunInBackgroundb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 & 1 | 0) == (HEAPU8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] | 0 | 0)) return;
 if (__Z12GetIVRDevicev() | 0) {
  i2 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i2 | 0) | 0) return;
 }
 HEAP8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] = i1 & 1;
 __Z17GetPlayerSettingsv() | 0;
 if (!i1) return;
 __Z14SetPlayerPause11PlayerPauseb(0, 1);
 return;
}

function __Z26TerrainData_CUSTOM_HasUserP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   return (__ZNK11TerrainData7HasUserEP10GameObject(i3, i1) | 0) & 1 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZThn12_N5physx10NpMaterial14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -12 | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0); else __ZN5physx9NpFactory21releaseMaterialToPoolERNS_10NpMaterialE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i1, i2, 2);
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 36 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + 4;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 if ((HEAP16[i1 + 4 >> 1] | 0) != 5) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 return;
}

function __ZN9GfxDevice38ScheduleDynamicVBOGeometryJobsInternalEPFvP25DynamicVBOGeometryJobDatajEPFvS1_ES1_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 __ZN16GeometryJobTasks30ScheduleDynamicVBOGeometryJobsER9GfxDevicePFvP25DynamicVBOGeometryJobDatajEPFvS3_ES3_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle(i1 + 4412 | 0, i1, i2, i3, i4, i5, i6, i7);
 return;
}

function __ZN9GfxDevice30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 4400 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, i1 | 0, HEAP32[i4 >> 2] | 0, i2 | 0);
 HEAP8[(HEAP32[i4 >> 2] | 0) + 31 >> 0] = 1;
 i2 = i1 + 4404 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, i3 | 0);
 HEAP8[(HEAP32[i2 >> 2] | 0) + 31 >> 0] = 1;
 return;
}

function __ZN7mecanim8dynamics8ScalDamp8EvaluateEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, f5 = f0, f6 = f0, f7 = f0;
 i4 = i1 + 4 | 0;
 f7 = Math_fround(HEAPF32[i4 >> 2]);
 f3 = Math_fround(Math_abs(Math_fround(f3)));
 f6 = Math_fround(f3 * Math_fround(f2 - f7));
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f7 + Math_fround(f6 / Math_fround(f3 + f5)));
 i1 = f5 > Math_fround(0.0);
 HEAPF32[i4 >> 2] = i1 ? f3 : f2;
 return;
}

function __ZN6prcoreL13inner_stretchILj1ELj1EEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i6 = i3 + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP8[i4 >> 0] = HEAP8[i5 + (i1 >>> 16) >> 0] | 0;
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = (HEAP32[i6 >> 2] | 0) + i1 | 0;
  }
 }
 return;
}

function __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 __Z3minRK8Scalar4fS1_(i6, i1, i3);
 __ZN8Scalar4faSERKS_(i2, i6) | 0;
 __Z3maxRK8Scalar4fS1_(i5, i1 + 16 | 0, i3 + 16 | 0);
 __ZN8Scalar4faSERKS_(i2 + 16 | 0, i5) | 0;
 STACKTOP = i4;
 return;
}

function __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 833886;
 HEAP32[i1 + 4 >> 2] = 559;
 HEAP32[i1 + 8 >> 2] = fb + 636;
 HEAP32[i1 + 12 >> 2] = fb + 551;
 HEAP32[i1 + 16 >> 2] = gb + 833896;
 HEAP32[i1 + 20 >> 2] = 560;
 HEAP32[i1 + 24 >> 2] = fb + 2406;
 HEAP32[i1 + 28 >> 2] = fb + 3937;
 HEAP32[i1 + 32 >> 2] = gb + 833910;
 HEAP32[i1 + 36 >> 2] = 561;
 HEAP32[i1 + 40 >> 2] = fb + 2407;
 HEAP32[i1 + 44 >> 2] = fb + 3938;
 return;
}

function __ZN5physx2Sc16InteractionScene27swapInteractionArrayIndicesEjjNS0_15InteractionTypeE(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i3 + 16 + (i4 * 12 | 0) | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i6 = i4 + (i1 << 2) | 0;
 i3 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i4 + (i2 << 2) >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 HEAP32[i3 + 12 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = i1;
 return;
}

function __ZN5physx2Gu18computeFeatureCodeEff(f2, f3) {
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i1 = 0;
 do if (f2 == Math_fround(0.0)) if (f3 == Math_fround(0.0)) i1 = 0; else {
  i1 = f3 == Math_fround(1.0);
  i1 = i1 ? 2 : 5;
 } else {
  i1 = f3 == Math_fround(0.0);
  if (f2 == Math_fround(1.0)) {
   i1 = i1 ? 1 : 7;
   break;
  }
  if (i1) i1 = 3; else {
   i1 = !(Math_fround(f2 + f3) >= Math_fround(.999899983));
   i1 = i1 ? 6 : 4;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx27PxFixedJointGeneratedValuesC2EPKNS_12PxFixedJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE(i2, i1);
 HEAPF32[i2 + 160 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
 HEAPF32[i2 + 164 >> 2] = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
 HEAP32[i2 + 168 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5Light17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 44 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 __ZN15SharedLightData17MainThreadCleanupEv(i1);
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN4crnd27crnd_unpack_level_segmentedEPvPKvjPS0_jjj(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if (i5 >>> 0 < 8 | (i1 | 0) != 0 & (i2 | 0) != 0 & (i4 | 0) != 0 ^ 1 | i7 >>> 0 > 15) {
  i7 = 0;
  return i7 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != 519686845) {
  i7 = 0;
  return i7 | 0;
 }
 i7 = __ZN4crnd12crn_unpacker12unpack_levelEPKvjPPvjjj(i1, i2, i3, i4, i5, i6, i7) | 0;
 return i7 | 0;
}

function __ZN17PersistentManager26GetLoadedInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 0) | 0;
 if ((i1 | 0) == -1) return;
 __ZN8Remapper41GetAllLoadedObjectsForSerializedFileIndexEiPNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE(HEAP32[i2 + 56 >> 2] | 0, i1, i3);
 return;
}

function __ZN14UnityWebStreamD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (i1 | 0) __ZN3WWW7ReleaseEv(i1);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3 + 24 | 0);
 return;
}

function __Z44ParticleSystem_TrailModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 908 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z44ParticleSystem_NoiseModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 888 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z31setPxCloth_ExternalAccelerationPN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function _dn_skipname(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i1 = i2;
 while (1) {
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   break;
  }
  i5 = HEAP8[i1 >> 0] | 0;
  if (!(i5 << 24 >> 24)) {
   i6 = 4;
   break;
  }
  i4 = i1 + 1 | 0;
  if ((i5 & 255) > 191) {
   i6 = 6;
   break;
  } else i1 = i4;
 }
 if ((i6 | 0) == 4) i1 = 1 - i2 + i1 | 0; else if ((i6 | 0) == 6) if (i4 >>> 0 < i3 >>> 0) i1 = 2 - i2 + i1 | 0; else i1 = -1;
 return i1 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE(i2 + -4 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4526 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211612 + 8;
  return;
 }
}

function __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4526 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211588 + 8;
  return;
 }
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + 4;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i7 = 0;
 i7 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i7 >> 8;
 if (i7 & 1) i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i3 | 0, i4 + i1 | 0, (i7 & 2 | 0 ? i5 : 2) | 0, i6 | 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 36 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + 4;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZN5physx2Cm17FreeListAllocator14pushOnFreeListEPNS0_5ChunkEj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i5 + 148 + (i4 << 2) | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i2 + 8 >> 2] = i3;
 HEAP32[i1 >> 2] = i3;
 i3 = i4 >>> 5;
 i2 = i5 + 16 + (i3 << 2) | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1 << (i4 & 31);
 i5 = i5 + 144 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 1 << i3;
 return;
}

function __ZN19CloudServiceHandler17PlayerLoopHandlerEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 1144 >> 2] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) == 2) {
  i1 = 1;
  return i1 | 0;
 }
 __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv(i1);
 __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv(i1 + 200 | 0);
 __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv(i1 + 792 | 0);
 i1 = 0;
 return i1 | 0;
}

function __ZL41InitializeParticlesLegacyScriptingClassesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 1049649 | 0, 16) | 0;
 HEAP32[gb + 1469452 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049809 | 0) | 0;
 HEAP32[HEAP32[gb + 1469452 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 1049818 | 0) | 0;
 HEAP32[(HEAP32[gb + 1469452 >> 2] | 0) + 4 >> 2] = i1;
 return;
}

function __Z42GUIStyleState_CUSTOM_GetBackgroundInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting32GetScriptingWrapperForInstanceIDEi(HEAP32[i1 >> 2] | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z40CullingGroup_Set_Custom_PropTargetCameraP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 12 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z30setPxCloth_AngularInertiaScalePN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z16LightAttenuationItEvP9Texture2DPT_iiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0;
 f8 = Math_fround(Math_fround(Math_fround(__Z24LightAttenuateNormalizedf(Math_fround(Math_fround(i3 | 0) / Math_fround(i5 | 0)))) * Math_fround(65535.0)) + Math_fround(.5));
 i6 = f8 >= Math_fround(0.0);
 f7 = Math_fround(f8 + Math_fround(-.99999994));
 HEAP16[i2 >> 1] = ~~(i6 ? f8 : f7);
 return;
}

function _tt_size_select(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i1 + 112 | 0;
 HEAP32[i4 >> 2] = i2;
 if (HEAP32[i3 + 8 >> 2] & 1 | 0) {
  _UNITY_FT_Select_Metrics(i3, i2);
  _UNITY_tt_size_reset(i1) | 0;
  i4 = 0;
  return i4 | 0;
 }
 i1 = mftCall_iiii(HEAP32[(HEAP32[i3 + 532 >> 2] | 0) + 108 >> 2] | 0, i3 | 0, i2 | 0, i1 + 12 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = -1;
 i4 = i1;
 return i4 | 0;
}

function _lseek(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 20 | 0;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP32[i6 + 8 >> 2] = i2;
 HEAP32[i6 + 12 >> 2] = i5;
 HEAP32[i6 + 16 >> 2] = i3;
 i3 = (___syscall_ret(___syscall140(140, i6 | 0) | 0) | 0) != 0;
 STACKTOP = i4;
 return (i3 ? -1 : HEAP32[i5 >> 2] | 0) | 0;
}

function __ZNK6Shader11GetBlobDataEjRPKhRj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 if (!(HEAP32[i1 + 72 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + 4 + (i2 << 1 << 2) | 0;
 HEAP32[i3 >> 2] = i1 + (HEAP32[i2 >> 2] | 0);
 HEAP32[i4 >> 2] = HEAP32[i2 + 4 >> 2];
 i4 = 1;
 return i4 | 0;
}

function __ZNK5physx7NpShape12getLocalPoseEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 36 >> 2] & 4 | 0) == 0 ? i2 + 80 | 0 : HEAP32[i2 + 40 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK5Unity9Component7GetNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[i2 + 64 >> 2] | 0;
  return i2 | 0;
 }
 i2 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i2, HEAP32[(HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) {
  i2 = gb + 1576256 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZN9b2Fixture14DestroyProxiesEP12b2BroadPhase(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 48 | 0;
 if ((HEAP32[i4 >> 2] | 0) <= 0) {
  HEAP32[i4 >> 2] = 0;
  return;
 }
 i2 = i1 + 44 | 0;
 i1 = 0;
 do {
  i5 = (HEAP32[i2 >> 2] | 0) + (i1 * 28 | 0) + 24 | 0;
  __ZN12b2BroadPhase12DestroyProxyEi(i3, HEAP32[i5 >> 2] | 0);
  HEAP32[i5 >> 2] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN9UdpSocketC2Eb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = gb + 65564 + 8;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 i3 = _socket(2, 2, 17) | 0;
 HEAP32[i2 + 4 >> 2] = i3;
 if (!(__ZN6Socket10CheckErrorEiPKcii(i3, gb + 458666 | 0, 0, 0) | 0)) HEAP32[i1 >> 2] = 16384;
 HEAP32[i2 >> 2] = gb + 65580 + 8;
 HEAP8[i2 + 17 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 2;
 return;
}

function __ZN9Rigidbody6WakeUpEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) return;
 if ((HEAP16[i1 + 4 >> 1] | 0) != 5) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0) & 1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 284 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7mecanim9animation19CreateLayerConstantEjjRNS_6memory9AllocatorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, 40, 4) | 0;
 i4 = i3 + 8 | 0;
 HEAP32[i3 + 28 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP8[i3 + 36 >> 0] = 1;
 HEAP8[i3 + 37 >> 0] = 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 return i3 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = i4 + ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0) | 0) << 4) | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + 4;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = 1;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = 28;
 HEAP32[i2 + 4 >> 2] = 1;
 return;
}

function __ZN5physx2Sc5ActorD2Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 HEAP32[i4 >> 2] = gb + 91044 + 8;
 HEAP32[i4 + 28 >> 2] = 0;
 i1 = i4 + 20 | 0;
 i2 = i4 + 24 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) == 0 | (i3 | 0) == (i4 + 4 | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj(HEAP32[i4 + 36 >> 2] | 0, i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = (__ZNK5physx2Sc9RigidCore10getPxActorEv((HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + i1 | 0) | 0) + 20 | 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if (i2 << 16 >> 16 == 1) {
  HEAP32[i3 >> 2] = i1;
  i3 = i2 & 65535;
  return i3 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 i3 = i2 & 65535;
 return i3 | 0;
}

function __ZN11Rigidbody2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 48 >> 0] = 1;
 HEAP8[i1 + 49 >> 0] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(.0500000007);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 1;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP8[i1 + 50 >> 0] = 0;
 return;
}

function __ZN11BoxCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 16 | 0;
 i5 = i4;
 __ZNK9Transform14TransformPointERK8Vector3f(i6, i2, i1 + 60 | 0);
 __ZNK9Transform11GetRotationEv(i5, i2);
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i3, i6, i5);
 STACKTOP = i4;
 return;
}

function __Z43ParticleSystem_MainModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[(HEAP32[i2 + 44 >> 2] | 0) + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z38Shader_CUSTOM_GetGlobalVectorArrayImpli(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i5 = i2;
 i4 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb(i4, i3, 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z29setPxCloth_LinearInertiaScalePN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z29setPxCloth_DampingCoefficientPN5physx7PxClothENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function _wmemmove(i4, i3, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (i1 | 0) == 0;
 if (i4 - i3 >> 2 >>> 0 < i1 >>> 0) {
  if (!i2) do {
   i1 = i1 + -1 | 0;
   HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i3 + (i1 << 2) >> 2];
  } while ((i1 | 0) != 0);
 } else if (!i2) {
  i2 = i3;
  i3 = i4;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   }
  }
 }
 return i4 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if ((HEAP16[i2 + 4 >> 1] | 0) == 8) {
  mftCall_viiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, 1, HEAP32[i2 + 52 >> 2] | 0);
  return;
 } else {
  mftCall_viiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0, -2147483648, i2 | 0);
  return;
 }
}

function __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 i1 = invoke_i(fb + 314 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 >> 2] = gb + 211564 + 8;
  return;
 }
}

function __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 i1 = invoke_i(fb + 314 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  HEAP32[i2 >> 2] = gb + 211540 + 8;
  return;
 }
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5tellpEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 5)) {
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 | 0, 0, 0, 1, 16);
 } else {
  i1 = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = i2 + 8 | 0;
  HEAP32[i2 >> 2] = -1;
  HEAP32[i2 + 4 >> 2] = -1;
 }
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5tellpEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 5)) {
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 | 0, 0, 0, 1, 16);
 } else {
  i1 = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i2 = i2 + 8 | 0;
  HEAP32[i2 >> 2] = -1;
  HEAP32[i2 + 4 >> 2] = -1;
 }
 return;
}

function __ZNK6IDList20CanHaveKeyboardFocusEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 i2 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = i1 + (i2 * 28 | 0) | 0;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i3 | 0)) break;
  i1 = i1 + 28 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i4 = 6;
   break;
  }
 }
 if ((i4 | 0) == 6) return i1 | 0;
 i4 = (HEAP8[i1 + 8 >> 0] | 0) != 0;
 return i4 | 0;
}

function __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i4) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i3 = 0;
 i1 = 0;
 do {
  i1 = ((HEAPU8[i2 + (i3 << 3) >> 0] | 0 | 0) == (i5 | 0) & 1) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE18AddHeaderAndFooterEPvji(i1, i3, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i1 = i2 + -1 & -8 - i3;
 i4 = i3 + i1 | 0;
 if (!i1) {
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -2;
  i1 = 0;
  i2 = i4;
 } else {
  _memset(i3 | 0, -86, i1 | 0) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
  HEAP32[i4 + -4 >> 2] = i1;
  i1 = 1;
  i2 = i4;
 }
 HEAP32[i2 >> 2] = i1 | i5 << 1;
 return i4 + 8 | 0;
}

function __ZN8Animator21SetHintWeightPositionEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 >= 4) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i4 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i5 = i4 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 60 >> 2] = f3;
 return;
}

function __ZN8Animator21SetGoalWeightRotationEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 >= 4) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i4 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i5 = i4 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 44 >> 2] = f3;
 return;
}

function __ZN8Animator21SetGoalWeightPositionEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 if (i2 >>> 0 >= 4) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i4 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i5) return;
 i5 = i4 + i5 + 40 | 0;
 if (!(HEAP32[(HEAP32[i5 >> 2] | 0) + i5 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 68 + (i2 << 6) + 40 >> 2] = f3;
 return;
}

function __ZN5physx2Gu9RadixSort10SetBuffersEPjS2_S2_PS2_(i5, i3, i4, i1, i2) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i3 | 0) != 0 & (i4 | 0) != 0 & (i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[i5 + 12 >> 2] = i4;
 HEAP32[i5 + 16 >> 2] = i1;
 HEAP32[i5 + 20 >> 2] = i2;
 HEAP8[i5 + 32 >> 0] = 0;
 i5 = i5 + 4 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | -2147483648;
 i5 = 1;
 return i5 | 0;
}

function __ZN17CollisionMeshData7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = __Z11GetIPhysicsv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = __Z11GetIPhysicsv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11TypeManager19CallInitializeTypesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 48 | 0;
 i5 = i1 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return; else i4 = 0;
 do {
  i3 = HEAP32[i2 + (i4 * 12 | 0) >> 2] | 0;
  if (i3) {
   mftCall_v(i3 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < ((i1 - i2 | 0) / 12 | 0) >>> 0);
 return;
}

function __ZN11TypeManager15CleanupAllTypesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 48 | 0;
 i5 = i1 + 52 | 0;
 i1 = HEAP32[i5 >> 2] | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return; else i4 = 0;
 do {
  i3 = HEAP32[i2 + (i4 * 12 | 0) + 8 >> 2] | 0;
  if (i3) {
   mftCall_v(i3 | 0);
   i1 = HEAP32[i5 >> 2] | 0;
   i2 = HEAP32[i6 >> 2] | 0;
  }
  i4 = i4 + 1 | 0;
 } while (i4 >>> 0 < ((i1 - i2 | 0) / 12 | 0) >>> 0);
 return;
}

function __ZN10Matrix3x3f8SetScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 + 8 >> 2];
 return i1 | 0;
}

function __Z38BillboardAsset_Set_Custom_PropMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i2 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   i1 = i3 + 36 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30WWW_Get_Custom_PropAssetBundleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(__Z18ExtractAssetBundleR3WWW(i1) | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function ___fpclassify(d2) {
 d2 = +d2;
 var i1 = 0, i3 = 0, i4 = 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i1 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i4 = _bitshift64Lshr(i1 | 0, i3 | 0, 52) | 0;
 getTempRet0() | 0;
 switch (i4 & 2047) {
 case 0:
  {
   i1 = (i1 | 0) != 0 | (i3 & 2147483647 | 0) != 0 ? 3 : 2;
   break;
  }
 case 2047:
  {
   i1 = (i1 | 0) == 0 & (i3 & 1048575 | 0) == 0 & 1;
   break;
  }
 default:
  i1 = 4;
 }
 return i1 | 0;
}

function __ZNSt3__26localeC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Znwj(160) | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1059 | 0, i3 | 0, i2 | 0, 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZdlPv(i3);
  ___resumeException(i2 | 0);
 } else {
  HEAP32[i1 >> 2] = i3;
  __ZNSt3__214__shared_count12__add_sharedEv(i3);
  return;
 }
}

function __ZNK5physx18NpArticulationLink11getChildrenEPPNS_18PxArticulationLinkEj(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 324 >> 2] | 0;
 i5 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 320 | 0;
 i1 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZN8BitArrayC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = 0;
 i4 = i2 + 4 | 0;
 i1 = ((i1 & 31 | 0) != 0 & 1) + (i1 >>> 5) | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, i1 << 2, gb + 717183 | 0, 392) | 0;
 HEAP32[i2 >> 2] = i1;
 _memset(i1 | 0, 0, HEAP32[i4 >> 2] << 2 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx3Ext13RevoluteJoint11prepareDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 80 >> 2] | 0;
 HEAPF32[i1 + 112 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 104 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 116 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 108 >> 2]) * Math_fround(.25))));
 HEAPF32[i1 + 120 >> 2] = Math_fround(+Math_tan(+Math_fround(Math_fround(HEAPF32[i1 + 100 >> 2]) * Math_fround(.25))));
 return i1 | 0;
}

function __ZN5physx2Sc8ShapeSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 90968 + 8;
 __ZN5physx2Sc15ObjectIDTracker9releaseIDEj(HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0) + 1196 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0);
 __ZN5physx2Sc7ElementD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}
function __ZN5physx24PxcGetMaterialShapeShapeEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i2, i4, i1, i6) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 4480 >> 2] | 0;
 if (!i5) return 1;
 i3 = HEAP16[i2 + 34 >> 1] | 0;
 i1 = HEAP16[i4 + 34 >> 1] | 0;
 i2 = 0;
 do {
  HEAP16[i6 + (i2 << 2) >> 1] = i3;
  HEAP16[i6 + (i2 << 2) + 2 >> 1] = i1;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i5 >>> 0);
 return 1;
}

function __ZN4UNET16ScriptingUpdater16SetUpdatePointerEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = __ZN4UNET16ScriptingUpdater3GetEv() | 0;
 __Z14OptionalMethodPKcS0_S0_S0_(i3, HEAP32[gb + 66748 >> 2] | 0, HEAP32[gb + 66756 >> 2] | 0, gb + 1037228 | 0, gb + 1037244 | 0);
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP8[i2 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 STACKTOP = i1;
 return;
}

function __ZN16TimerQueriesGLESC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 544 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 548 >> 2] = i2;
 i2 = i1 + 552 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 556 >> 2] = i2;
 i2 = i1 + 520 | 0;
 HEAP32[i1 + 560 >> 2] = 0;
 HEAP8[i1 + 564 >> 0] = 0;
 _memset(i1 | 0, 0, 516) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 return;
}

function __ZN13MemoryManager16StaticInitializeEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  __ZN13MemoryManager16ThreadInitializeEj(i1, 1048576);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i2 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i2;
 if (i2 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i2 = i1;
 __ZN13MemoryManager16ThreadInitializeEj(i2, 1048576);
 return;
}

function __ZN12CachedReader25GetSerializedFilePathNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i1 | 0);
 i1 = (HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeERK8UnityStrPjPt(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = __Z14StringToUInt64PKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
 i1 = getTempRet0() | 0;
 i5 = ___udivdi3(i4 | 0, i1 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP32[i2 >> 2] = i5;
 i2 = ___uremdi3(i4 | 0, i1 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP16[i3 >> 1] = i2;
 return;
}

function __ZN11UmbraModule13LoadUmbraTomeEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) == 0 | (i3 | 0) == 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = __ZN5Umbra10TomeLoader14loadFromBufferEPKhjPNS_9AllocatorE(i2, i3, 0) | 0;
 if (!(__ZNK5Umbra4Tome9getStatusEv(i1) | 0)) {
  i3 = i1;
  return i3 | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 612798 | 0, 0, gb + 612578 | 0, 97, 512, 0, 0, 0);
 i3 = 0;
 return i3 | 0;
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE8ValidateEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 164 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i1 + 16 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0;
 return i2 | 0;
}

function __ZN10GameObject17GetComponentIndexEPN5Unity9ComponentE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z40OcclusionArea_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 44 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ConstantForce_CUSTOM_INTERNAL_set_torqueP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 60 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39GUIClip_CUSTOM_INTERNAL_CALL_GetTopRectR5RectTIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZNK12GUIClipState10GetTopRectEv(i3, (__Z11GetGUIStatev() | 0) + 96 | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z28Collider2D_CUSTOM_IsTouchingP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i2) | 0;
   return (__ZNK10Collider2D10IsTouchingEPS_(i3, i1) | 0) & 1 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z16LightAttenuationIhEvP9Texture2DPT_iiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var f7 = f0, f8 = f0;
 f8 = Math_fround(Math_fround(Math_fround(__Z24LightAttenuateNormalizedf(Math_fround(Math_fround(i3 | 0) / Math_fround(i5 | 0)))) * Math_fround(255.0)) + Math_fround(.5));
 i6 = f8 >= Math_fround(0.0);
 f7 = Math_fround(f8 + Math_fround(-.99999994));
 HEAP8[i2 >> 0] = ~~(i6 ? f8 : f7);
 return;
}

function _wcsncpy(i6, i2, i1) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 L1 : do if (!i1) {
  i2 = i6;
  i1 = 0;
 } else {
  i5 = i6;
  while (1) {
   i3 = HEAP32[i2 >> 2] | 0;
   if (!i3) {
    i2 = i5;
    break L1;
   }
   i1 = i1 + -1 | 0;
   i4 = i5 + 4 | 0;
   HEAP32[i5 >> 2] = i3;
   if (!i1) {
    i2 = i4;
    i1 = 0;
    break;
   } else {
    i2 = i2 + 4 | 0;
    i5 = i4;
   }
  }
 } while (0);
 _wmemset(i2, 0, i1) | 0;
 return i6 | 0;
}

function _compare_uni_maps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = i3 & 2147483647;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i1 & 2147483647;
 if ((i4 | 0) == (i2 | 0)) {
  if (i3 >>> 0 > i1 >>> 0) {
   i4 = 1;
   return i4 | 0;
  }
  i4 = (i3 >>> 0 < i1 >>> 0) << 31 >> 31;
  return i4 | 0;
 } else {
  if (i4 >>> 0 > i2 >>> 0) {
   i4 = 1;
   return i4 | 0;
  }
  i4 = (i4 >>> 0 < i2 >>> 0) << 31 >> 31;
  return i4 | 0;
 }
 return 0;
}

function ___crypt_md5(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i1 = _md5crypt(i1, i2, i3) | 0;
 if ((i1 | 0) != 0 & (_md5crypt(gb + 1059967 | 0, gb + 1059985 | 0, i4) | 0) == (i4 | 0)) {
  i4 = (_memcmp(i4, gb + 1059998 | 0, 35) | 0) == 0;
  i1 = i4 ? i1 : gb + 1086428 | 0;
 } else i1 = gb + 1086428 | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarker7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + -8 | 0;
 i1 = i3 + 8 | 0;
 i2 = i3 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i2 >> 2] | 0, i1);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i3 + 16 >> 2] | 0, i1);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i1);
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (i3 >>> 0 > 1073741823) __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv(i2);
 i1 = i2 + 128 | 0;
 if (i3 >>> 0 < 29 & (HEAP8[i1 >> 0] | 0) == 0) {
  HEAP8[i1 >> 0] = 1;
  i1 = i2 + 16 | 0;
 } else i1 = __Znwj(i3 << 2) | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i1 + (i3 << 2);
 return;
}

function __ZNK8Playable12IndexOfInputEPKS_(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 3) + 4 >> 2] | 0) == (i4 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN9dtNavMesh26getOffMeshConnectionUnsafeEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!((i2 & 983040 | 0) == 65536 & 0 == 0)) return 0;
 i4 = i2 & 65535;
 if (i4 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) return 0; else {
  i2 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
  getTempRet0() | 0;
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  return ((i2 | 0) == (HEAP32[i3 + (i4 * 104 | 0) + 92 >> 2] | 0) ? i3 + (i4 * 104 | 0) | 0 : 0) | 0;
 }
 return 0;
}

function __ZN8Renderer15RemoveFromSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __Z16GetRendererScenev() | 0;
 i3 = i1 + 284 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == -1) return;
 i5 = i1 + 268 | 0;
 i5 = ((HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16) & 4096 | 0) == 0;
 __ZN13RendererScene14RemoveRendererEi(i2, i4) | 0;
 HEAP32[i3 >> 2] = -1;
 if (i5) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0);
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatABGR8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 & 16711935 | i3 << 16 & -16777216 | i3 >>> 16 & 65280;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatABGR888817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 >> 2] = i3 & 16711935 | i3 >>> 16 & 65280 | i3 << 16 & -16777216;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd7FastIPC11receiveDataERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  STACKTOP = i4;
  return i3 | 0;
 }
 __ZN5physx6shdfnd12PxRingBuffer11receiveDataERPKvRj(i1, i3, i2) | 0;
 i3 = HEAP32[i3 >> 2] | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN5physx2Sc5Scene9setLimitsERKNS_13PxSceneLimitsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZN5physx2Gu5Debug9visualizeERKNS_22PxTriangleMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i6, i8, i3, i4, i1, i2, f5, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 __ZNK5physx2Gu12TriangleMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_11PxMeshScaleERKNS_9PxBounds3Eyfj(HEAP32[i6 + 36 >> 2] | 0, i8, i3, i6 + 4 | 0, i4, i1, i2, f5, i7);
 return;
}

function __ZN12MemoryStreamC2EPhj(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = gb + 113908 + 8;
 HEAP32[i3 + 4 >> 2] = gb + 113908 + 32;
 if (!i1) {
  i2 = 1;
  i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i4, 16, gb + 63552 | 0, 0, gb + 738098 | 0, 20) | 0;
 } else i2 = 0;
 HEAP32[i3 + 24 >> 2] = i1;
 HEAP8[i3 + 8 >> 0] = i2;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = i4;
 return;
}

function __ZN11ErrorStream11reportErrorEN5physx11PxErrorCode4EnumEPKcS4_i(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 switch (i2 | 0) {
 case 1:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i3, 0, gb + 662472 | 0, 184, 4, 0, 0, 0);
   break;
  }
 case 2:
 case 128:
  return;
 default:
  {}
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(i3, 0, i4, i5, 1, 0, 0, 0);
 return;
}

function __Z57ParticleSystem_ShapeModule_CUSTOM_GetUseMeshMaterialIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[i2 + 48 + 213 >> 0] | 0;
 return i2 | 0;
}

function __Z43RectTransform_CUSTOM_INTERNAL_get_sizeDeltaP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 160 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMinP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 136 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMaxP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 144 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40OcclusionArea_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 44 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ConstantForce_CUSTOM_INTERNAL_get_torqueP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 60 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39ConstantForce_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 36 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_FT_Stroker_Set(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!i1) return;
 HEAP32[i1 + 60 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i3;
 HEAP32[i1 + 48 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = (i5 | 0) < 65536 ? 65536 : i5;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = -1;
 HEAP8[i1 + 92 >> 0] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = -1;
 HEAP8[i1 + 124 >> 0] = 0;
 return;
}

function __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i3, i4); else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
 }
 return;
}

function __ZN9AudioClip7CleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = __Z24GetManagerPtrFromContexti(3) | 0;
 if (i1 | 0) if (HEAP8[i1 + 224 >> 0] | 0) return;
 __ZN11SoundHandle7ReleaseEv(i2 + 56 | 0);
 i1 = HEAP8[i2 + 72 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i2 + 76 >> 2] | 0; else i1 = i1 & 255;
 if (!i1) return;
 if (!(__Z24GetManagerPtrFromContexti(3) | 0)) return;
 __ZN12SoundManager10UnloadClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i2);
 return;
}

function __ZN8Animator22SyncPlayStateToCullingEv(i1) {
 i1 = i1 | 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 if (!(HEAP8[i1 + 88 >> 0] | 0)) if ((HEAP32[i1 + 92 >> 2] | 0) == 2) {
  i1 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, 0);
  return;
 }
 i1 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, 1);
 return;
}

function __ZN7ApiGLES22BindElementArrayBufferEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 do if (!(HEAP8[i2 + 1992 >> 0] | 0)) if (!i3) return; else {
  i1 = i2 + 892 | 0;
  break;
 } else {
  i1 = i2 + 892 | 0;
  if ((i3 | 0) == 0 ? 1 : (HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 } while (0);
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 34963, i3 | 0);
 i3 = (HEAP32[gb + 1451096 >> 2] | 0) + 4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 7;
 return;
}

function __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB4444EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU16[i1 >> 1] | 0;
  HEAP16[i4 >> 1] = i3 >>> 4 & 3840 | i3 >>> 3 & 240 | i3 >>> 1 & 15 | 61440;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZN5physx5cloth11SwCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(i1) | 0;
 i3 = __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(i1) | 0;
 return (__ZN5physx5cloth11SwCollisionI8Scalar4fE24estimatePersistentMemoryERKNS0_7SwClothE(i1) | 0) + 1024 + (i2 >>> 0 < i3 >>> 0 ? i3 : i2) | 0;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 i3 = i1 + 148 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 144 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx23solveExt1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i5 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i5 = i4 + (i1 << 5) | 0;
  __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, 0);
  __ZN5physx10conclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i5, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5IMGUI9GUIWindow23ReleaseScriptingObjectsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 120 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 128 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN24AudioScriptBufferManager7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 if (HEAP32[i1 >> 2] | 0) {
  i2 = i1 + 4 | 0;
  __Z23scripting_gchandle_freej(HEAP32[i2 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i2 >> 2] = 0;
 }
 i2 = i1 + 12 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = i1 + 16 | 0;
 __Z23scripting_gchandle_freej(HEAP32[i1 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z42CapsuleCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 160 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ParticleSystem_MainModule_CUSTOM_GetLoopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = (__ZNK14ParticleSystem7GetLoopEv(i2) | 0) & 1;
 return i2 | 0;
}

function __Z39ConstantForce_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 36 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Shader_CUSTOM_GetGlobalMatrixArrayImpli(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i5 = i2;
 i4 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i4, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z38OcclusionArea_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 32 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
   HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31GUIStyle_CUSTOM_GetFontInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting32GetScriptingWrapperForInstanceIDEi(HEAP32[i1 + 240 >> 2] | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (!(__Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f(i1, i2, i4) | 0)) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i4, i3);
 i4 = 1;
 STACKTOP = i5;
 return i4 | 0;
}

function _skip_input_data(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = HEAP32[i3 + 24 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 i6 = i5 + 4 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 if ((i1 | 0) < (i2 | 0)) {
  i4 = i5 + 12 | 0;
  do {
   i2 = i2 - i1 | 0;
   mftCall_ii(HEAP32[i4 >> 2] | 0, i3 | 0) | 0;
   i1 = HEAP32[i6 >> 2] | 0;
  } while ((i2 | 0) > (i1 | 0));
 }
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i2;
 HEAP32[i6 >> 2] = i1 - i2;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__211timed_mutexD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 invoke_vi(fb + 4006 | 0, i1 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__218condition_variableD2Ev(i1 + 28 | 0);
  __ZNSt3__25mutexD2Ev(i1);
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__25mutex6unlockEv(i1);
  __ZNSt3__218condition_variableD2Ev(i1 + 28 | 0);
  __ZNSt3__25mutexD2Ev(i1);
  return;
 }
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP16[i1 + 2 >> 1] | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP16[i4 + 2 >> 1] = i3;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 833858;
 HEAP32[i1 + 4 >> 2] = 536;
 HEAP32[i1 + 8 >> 2] = fb + 635;
 HEAP32[i1 + 12 >> 2] = fb + 550;
 HEAP32[i1 + 16 >> 2] = gb + 833866;
 HEAP32[i1 + 20 >> 2] = 537;
 HEAP32[i1 + 24 >> 2] = fb + 60;
 HEAP32[i1 + 28 >> 2] = fb + 26;
 HEAP32[i1 + 32 >> 2] = gb + 833875;
 HEAP32[i1 + 36 >> 2] = 538;
 HEAP32[i1 + 40 >> 2] = fb + 61;
 HEAP32[i1 + 44 >> 2] = fb + 27;
 return;
}

function __ZN5physx2Sc10NPhaseCore30removeFromDirtyInteractionListEPNS0_15CoreInteractionE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2 + 68 | 0, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx26PxcInvalidSweptContactPairERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf(i1, i2, i7, i8, i9, i10, i11, i12, f13, i14, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 return 0;
}

function __ZN19ClampVelocityModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 800 | 0, i2);
 return;
}

function __ZN18ProceduralMaterial22CacheSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) return;
 i1 = i1 + 140 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i3) {
  HEAP32[i1 >> 2] = i2 | 4;
  return;
 } else {
  HEAP32[i1 >> 2] = i2 & -5;
  return;
 }
}

function __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16MessageForwarder13HandleMessageEPviR11MessageData(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP32[i1 + 24 >> 2] | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 if (((HEAP32[i1 + 4 >> 2] | 0) - i6 >> 2 | 0) <= (i3 | 0)) {
  i6 = i5;
  mftCall_viii(i6 | 0, i2 | 0, i3 | 0, i4 | 0);
  return;
 }
 i6 = HEAP32[i6 + (i3 << 2) >> 2] | 0;
 i6 = (i6 | 0) == 0 ? i5 : i6;
 mftCall_viii(i6 | 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN15NavMeshObstacle15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 168936 | 0, gb + 1105016 | 0, fb + 903 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 168936 | 0, gb + 1105856 | 0, fb + 904 | 0, gb + 29392 | 0);
 return;
}

function __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z38OcclusionArea_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 32 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38BoxCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 60 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _write_marker_byte(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i4 + 1;
 HEAP8[i4 >> 0] = i2;
 i4 = i3 + 4 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 HEAP32[i4 >> 2] = i2;
 if (i2 | 0) return;
 if ((mftCall_ii(HEAP32[i3 + 12 >> 2] | 0, i1 | 0) | 0) << 24 >> 24) return;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 + 20 >> 2] = 24;
 mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
 return;
}

function __ZNK10FileSystem17GetHandlerForPathEPKc(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i5 = i3 + 16 | 0;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 while (1) {
  if (!i2) break;
  i2 = i2 + -1 | 0;
  i1 = HEAP32[(HEAP32[i5 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  if (mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i4 | 0) | 0) {
   i6 = 5;
   break;
  }
 }
 if ((i6 | 0) == 5) return i1 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 return i6 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx10conclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 i4 = (HEAP8[i2 >> 0] | 0) == 4 ? 176 : 112;
 i1 = HEAP8[i2 + 1 >> 0] | 0;
 if (!(i1 << 24 >> 24)) return;
 i3 = i1 & 255;
 i1 = i2 + 48 | 0;
 i2 = 0;
 while (1) {
  HEAP32[i1 + 12 >> 2] = HEAP32[i1 + 28 >> 2];
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i3 >>> 0) break; else i1 = i1 + i4 | 0;
 }
 return;
}

function __ZN21AssetBundleFileSystem30TryUnmountFromGlobalFileSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 108 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 if ((HEAP32[i1 + 72 >> 2] | 0) != (HEAP32[i1 + 8 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 if (__ZNK17ArchiveFileSystem18HasMountedArchivesEv(i3) | 0) return;
 __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i1) | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN18MultiFrameGUIState18ClearNamedControlsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN18BlockRangeInternal16PopLastNodeIndexEP10BlockRangeji(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i6 = 0;
 do {
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= (i5 | 0)) {
   i1 = -1;
   i6 = 5;
   break;
  }
  i2 = i4 + (i1 * 12 | 0) + 4 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
 } while (!(i3 | 0));
 if ((i6 | 0) == 5) return i1 | 0;
 i6 = i3 + -1 | 0;
 HEAP32[i2 >> 2] = i6;
 i6 = (HEAP32[i4 + (i1 * 12 | 0) >> 2] | 0) + i6 | 0;
 return i6 | 0;
}

function __ZN15MulticastSocket10InitializeEPKctb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__ZN6Socket11SetBlockingEb(i1, i4) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = _inet_addr(i2 | 0) | 0;
 i4 = _htons(i3) | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 >> 1] = 2;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP16[i1 + 22 >> 1] = i4;
 i4 = 1;
 return i4 | 0;
}

function __ZN13GfxDeviceGLES10BeginFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4192 >> 0] = 1;
 i1 = i1 + 4616 | 0;
 i2 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 >> 2] | 0) | 0;
 HEAP8[i2 + 72 >> 0] = 2;
 HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + 28 >> 0] = 2;
 HEAP8[i2 + 88 >> 0] = 2;
 HEAP8[(HEAP32[i2 + 48 >> 2] | 0) + 28 >> 0] = 2;
 __ZN18GfxFramebufferGLES8ActivateENS_7BuiltinEb(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 >> 2] | 0) | 0, 0, 1);
 return;
}

function __ZN12_GLOBAL__N_117MemoryEventClientD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 149240 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i1 = i1 + 4 | 0;
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 return;
}

function __ZN11TrailModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 12 | 0, i2);
 __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1 + 292 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 448 | 0, i2);
 __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1 + 712 | 0, i2);
 return;
}

function __Z54ParticleSystem_ShapeModule_CUSTOM_GetMeshMaterialIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[i2 + 48 + 56 >> 2] | 0;
 return i2 | 0;
}

function __Z43Vector3_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK8Vector3fS1_fRS_(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 __Z5SlerpRK8Vector3fS1_f(i6, i1, i2, f3);
 HEAP32[i4 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i6 + 8 >> 2];
 STACKTOP = i5;
 return;
}

function __Z41ConstantForce2D_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 48 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Shader_CUSTOM_GetGlobalFloatArrayImpli(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i5 = i2;
 i4 = (HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 i1 = __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE(i4, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z37DownloadHandler_Get_Custom_PropIsDoneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0) & 1;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027689 | 0, i2);
 return 0;
}

function __Z24GUIStyle_CUSTOM_InitCopyP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = __Znwj(296) | 0;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN8GUIStyleC2ERKS_(i3, i1);
   HEAP32[i2 + 8 >> 2] = i3;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z20getPxSceneDescLimitsPKN5physx11PxSceneDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function _tt_cmap13_char_next(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 24 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i4 = i1 + 28 | 0;
  if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
   _tt_cmap13_next(i1);
   if (!(HEAP8[i3 >> 0] | 0)) {
    i4 = 0;
    return i4 | 0;
   }
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i4 = i3;
   return i4 | 0;
  }
 }
 i4 = _tt_cmap13_char_map_binary(i1, i2, 1) | 0;
 return i4 | 0;
}

function _tt_cmap12_char_next(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 24 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  i4 = i1 + 28 | 0;
  if ((HEAP32[i4 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) {
   _tt_cmap12_next(i1);
   if (!(HEAP8[i3 >> 0] | 0)) {
    i4 = 0;
    return i4 | 0;
   }
   i3 = HEAP32[i1 + 32 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
   i4 = i3;
   return i4 | 0;
  }
 }
 i4 = _tt_cmap12_char_map_binary(i1, i2, 1) | 0;
 return i4 | 0;
}

function _perror(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[gb + 191628 >> 2] | 0;
 i4 = _strerror(HEAP32[(___errno_location() | 0) >> 2] | 0) | 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) i3 = ___lockfile(i2) | 0; else i3 = 0;
 if (i1 | 0) if (HEAP8[i1 >> 0] | 0) {
  _fwrite(i1, _strlen(i1) | 0, 1, i2) | 0;
  _fputc(58, i2) | 0;
  _fputc(32, i2) | 0;
 }
 _fwrite(i4, _strlen(i4) | 0, 1, i2) | 0;
 _fputc(10, i2) | 0;
 if (i3 | 0) ___unlockfile(i2);
 return;
}

function ___fstatfs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 64;
 HEAP32[i3 + 8 >> 2] = i2;
 i6 = ___syscall_ret(___syscall269(269, i3 | 0) | 0) | 0;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZThn8_N12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv(i1, i6, i7, i4, i5, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i2 = 0, i8 = 0;
 i2 = i1 + -8 | 0;
 i8 = i2 + 176 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i2 + (i8 >> 1) | 0;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_viiiiii(i1 | 0, i2 | 0, i6 | 0, i7 | 0, i4 | 0, i5 | 0, i3 | 0);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4526 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211564 + 8;
  return;
 }
}

function __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 213148 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4526 | 0, i1 + 8 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i1 >> 2] = gb + 211540 + 8;
  return;
 }
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2ERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 208728 + 8;
 __ZNSt3__26localeC2ERKS0_(i1 + 4 | 0, i2 + 4 | 0);
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2ERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 208664 + 8;
 __ZNSt3__26localeC2ERKS0_(i1 + 4 | 0, i2 + 4 | 0);
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZNK12AudioManager15GetSpeakerCountEv(i1) {
 i1 = i1 | 0;
 L1 : do if (!(HEAP32[i1 + 88 >> 2] | 0)) i1 = 2; else {
  i1 = HEAP32[i1 + 156 >> 2] | 0;
  switch (i1 | 0) {
  case 2:
  case 1:
   break L1;
  case 3:
   {
    i1 = 4;
    break L1;
   }
  case 4:
   {
    i1 = 5;
    break L1;
   }
  case 5:
   {
    i1 = 6;
    break L1;
   }
  case 6:
   {
    i1 = 8;
    break L1;
   }
  default:
   {
    i1 = 2;
    break L1;
   }
  }
 } while (0);
 return i1 | 0;
}

function __ZN9Scripting40CreateScriptingArrayFromScriptingObjectsEPP12Il2CppObjectiP11Il2CppClass(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z19scripting_array_newP11Il2CppClassjj(i1, 4, i4) | 0;
 if ((i4 | 0) > 0) i1 = 0; else return i2 | 0;
 do {
  __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i2, i1, HEAP32[i3 + (i1 << 2) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return i2 | 0;
}

function __ZN7mecanim9animation28MotionOutputGetDeltaPositionEPKNS0_12MotionOutputE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAPF32[i2 >> 2]);
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 f4 = Math_fround(f6 * f4);
 f3 = Math_fround(f6 * Math_fround(HEAPF32[i2 + 12 >> 2]));
 HEAPF32[i1 >> 2] = Math_fround(f6 * f5);
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAP32[i4 + 4 >> 2] = i3;
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 12 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd10Foundation11decRefCountEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1452352 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(HEAP32[gb + 1452348 >> 2] | 0, 8, gb + 659867 | 0, 206, gb + 659946 | 0, i2);
  STACKTOP = i2;
  return;
 } else {
  HEAP32[gb + 1452352 >> 2] = i1 + -1;
  STACKTOP = i2;
  return;
 }
}

function __ZN5physx3Scb4Base7destroyEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 switch (i2 >>> 30 | 0) {
 case 3:
  {
   i4 = 4;
   break;
  }
 case 2:
  {
   if (!(HEAP8[(HEAP32[i3 >> 2] | 0) + 2433 >> 0] | 0)) i4 = 3; else i4 = 4;
   break;
  }
 default:
  i4 = 3;
 }
 if ((i4 | 0) == 3) {
  __ZN5physx9NpDestroyERNS_3Scb4BaseE(i3);
  return;
 } else if ((i4 | 0) == 4) {
  HEAP32[i1 >> 2] = i2 | 536870912;
  return;
 }
}

function __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx24PxRigidBodyGeneratedInfoC2Ev(i1);
 HEAP32[i1 + 336 >> 2] = gb + 674210;
 HEAP32[i1 + 340 >> 2] = 57;
 HEAP32[i1 + 344 >> 2] = fb + 2130;
 HEAP32[i1 + 348 >> 2] = gb + 674223;
 HEAP32[i1 + 352 >> 2] = 58;
 HEAP32[i1 + 356 >> 2] = fb + 400;
 HEAP32[i1 + 360 >> 2] = fb + 2131;
 HEAP32[i1 + 364 >> 2] = gb + 831985;
 HEAP32[i1 + 368 >> 2] = 59;
 HEAP32[i1 + 372 >> 2] = fb + 2132;
 return;
}

function __ZN4crnd5crc16EPKvjt(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i1 = i1 & 65535 ^ 65535;
 if (!i2) {
  i3 = i1;
  i3 = i3 ^ 65535;
  i3 = i3 & 65535;
  return i3 | 0;
 }
 while (1) {
  i4 = i1 & 65535;
  i1 = (HEAPU8[i3 >> 0] | 0) ^ i4 >>> 8;
  i1 = i1 >>> 4 ^ i1;
  i1 = (i1 | i4 << 8 & 65280) ^ i1 << 5 ^ i1 << 12 & 61440;
  i2 = i2 + -1 | 0;
  if (!i2) break; else i3 = i3 + 1 | 0;
 }
 i4 = i1 ^ 65535;
 i4 = i4 & 65535;
 return i4 | 0;
}

function __ZN2UI13CanvasManager14GetRenderOrderEPKNS_6CanvasE(i1, i6) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i3;
 i5 = i2;
 L1 : do if ((i2 | 0) != (i3 | 0)) {
  i1 = 0;
  while (1) {
   if ((HEAP32[i2 >> 2] | 0) == (i6 | 0)) break;
   i2 = i2 + 4 | 0;
   if ((i2 | 0) == (i3 | 0)) break L1; else i1 = i1 + 1 | 0;
  }
  return i1 | 0;
 } while (0);
 i6 = i4 - i5 >> 2;
 return i6 | 0;
}

function __ZN22UnityProfilerPerThread26BeforeDomainUnloadCallbackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 188 | 0;
 i2 = i1 + 192 | 0;
 __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN22BlockMemoryCacheWriter14LockCacheBlockEjPPhS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i2 + 1 | 0;
 i6 = HEAP32[i1 + 32 >> 2] | 0;
 __ZN22BlockMemoryCacheWriter12ResizeBlocksEj(i1, (i5 | 0) < (i6 | 0) ? i6 : i5);
 i2 = HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i4 >> 2] = i2 + 256;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZN17CollisionMeshDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = __Z11GetIPhysicsv() | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 68 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i3 = __Z11GetIPhysicsv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 72 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES8EndFrameEv(i1) {
 i1 = i1 | 0;
 __ZN18GfxFramebufferGLES36TryInvalidateDefaultFramebufferDepthEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0);
 __ZN17BufferManagerGLES12AdvanceFrameEv(__Z20GetBufferManagerGLESv() | 0);
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 707 >> 0] | 0)) {
  i1 = i1 + 4192 | 0;
  HEAP8[i1 >> 0] = 0;
  return;
 }
 HEAP8[gb + 1548977 >> 0] = 0;
 i1 = i1 + 4192 | 0;
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN12LightsModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = HEAP32[i3 + 272 >> 2] | 0;
 HEAP32[i1 + 556 >> 2] = i3;
 i3 = (Math_imul(i3, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 560 >> 2] = i3;
 i3 = (Math_imul(i3, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 564 >> 2] = i3;
 HEAP32[i1 + 568 >> 2] = (Math_imul(i3, 1812433253) | 0) + 1;
 HEAPF32[i1 + 572 >> 2] = Math_fround(0.0);
 return;
}

function __Z53ParticleSystem_ShapeModule_CUSTOM_GetAlignToDirectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[i2 + 48 + 212 >> 0] | 0;
 return i2 | 0;
}

function __Z36BoxCollider_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 72 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Camera_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 892 | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
   HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
   HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function ___statfs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5;
 i4 = i2;
 i6 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i6 | 0));
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 64;
 HEAP32[i3 + 8 >> 2] = i2;
 i6 = ___syscall_ret(___syscall268(268, i3 | 0) | 0) | 0;
 STACKTOP = i5;
 return i6 | 0;
}

function __ZNK9dtNavMesh20getOffMeshConnectionEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!((i2 & 983040 | 0) == 65536 & 0 == 0)) return 0;
 i4 = i2 & 65535;
 if (i4 >>> 0 > (HEAP32[i1 + 44 >> 2] | 0) >>> 0) return 0; else {
  i2 = _bitshift64Lshr(i2 | 0, i3 | 0, 48) | 0;
  getTempRet0() | 0;
  i3 = HEAP32[i1 + 48 >> 2] | 0;
  return ((i2 | 0) == (HEAP32[i3 + (i4 * 104 | 0) + 92 >> 2] | 0) ? i3 + (i4 * 104 | 0) | 0 : 0) | 0;
 }
 return 0;
}

function __ZNK23TransformChangeDispatch24GetChangeMaskForInterestENS_12InterestTypeE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!(i3 & 1)) i1 = 0; else i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (i3 & 2) i1 = HEAP32[i2 + 24 >> 2] | i1;
 if (i3 & 4) i1 = HEAP32[i2 + 28 >> 2] | i1;
 if (i3 & 8) i1 = HEAP32[i2 + 32 >> 2] | i1;
 if (i3 & 16) i1 = HEAP32[i2 + 36 >> 2] | i1;
 if (!(i3 & 32)) {
  i3 = i1;
  return i3 | 0;
 }
 i3 = HEAP32[i2 + 40 >> 2] | i1;
 return i3 | 0;
}

function __ZN5physx6shdfnd10Foundation11incRefCountEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1452352 >> 2] | 0;
 if (!i1) {
  __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(HEAP32[gb + 1452348 >> 2] | 0, 8, gb + 659867 | 0, 192, gb + 738324 | 0, i2);
  STACKTOP = i2;
  return;
 } else {
  HEAP32[gb + 1452352 >> 2] = i1 + 1;
  STACKTOP = i2;
  return;
 }
}

function __ZN5physx2Sc16InteractionScene21swapActorArrayIndicesERNS_6shdfnd5ArrayIPNS0_5ActorENS2_19ReflectionAllocatorIS5_EEEEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = i4 + (i2 << 2) | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i4 + (i3 << 2) >> 2] | 0;
 HEAP32[i6 >> 2] = i4;
 HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = i5;
 HEAP32[i5 + 40 >> 2] = i3;
 HEAP32[i4 + 40 >> 2] = i2;
 return;
}

function __ZN5physx2Sc10ClothShapeD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 91124 + 8;
 if (HEAP8[i1 + 24 >> 0] | 0) __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 + 8 >> 2] | 0) | 0, i1);
 __ZN5physx2Sc7ElementD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 97124 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(i1, i4, i6, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i7 = 0;
 i3 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 128 | 0;
 i2 = 0;
 do {
  i7 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  mftCall_viiii(HEAP32[(HEAP32[i7 >> 2] | 0) + 8 >> 2] | 0, i7 | 0, i4 | 0, i6 | 0, i5 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN3MBP14findOverlapsMTEPKj(i1, i7) {
 i1 = i1 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i5 = HEAP32[i1 + 28 >> 2] | 0;
 i6 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i4) return;
 i1 = i1 + 52 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[i5 + (i3 * 40 | 0) + 28 >> 2] | 0;
  if (i2 | 0) __ZN9BoxPruner14findOverlapsMTER15MBP_PairManagerPKjPK10MBP_Object(i2, i1, i7, i6);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN18AwakeFromLoadQueue5ClearEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = 0;
 do {
  i3 = i2 + (i1 * 20 | 0) | 0;
  i4 = i2 + (i1 * 20 | 0) + 16 | 0;
  if ((HEAP32[i4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i2 + (i1 * 20 | 0) + 4 | 0);
   HEAP32[i3 >> 2] = 0;
  }
  HEAP32[i3 >> 2] = 0;
  HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 14);
 return;
}

function __ZN15dtProximityGrid13resetCellSizeEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 _memset(HEAP32[i1 + 20 >> 2] | 0, -1, HEAP32[i1 + 24 >> 2] << 1 | 0) | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 65535;
 HEAP32[i1 + 32 >> 2] = 65535;
 HEAP32[i1 + 36 >> 2] = -65535;
 HEAP32[i1 + 40 >> 2] = -65535;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(1.0) / f2);
 HEAPF32[i1 + 4 >> 2] = Math_fround(Math_fround(1.0) / f3);
 return;
}

function __ZN14AnimationState14AllocateCurvesEi(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 56 | 0;
 HEAP16[i2 >> 1] = HEAP16[i2 >> 1] | 16;
 i2 = __Znaj(i4 >>> 0 > 1073741823 ? -1 : i4 << 2) | 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = i2;
 if ((i4 | 0) <= 0) return;
 HEAP32[i2 >> 2] = 0;
 if ((i4 | 0) == 1) return; else i1 = 1;
 do {
  HEAP32[(HEAP32[i3 >> 2] | 0) + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN13SpringJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13SliderJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13RuntimeStaticI18BackgroundJobQueueE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) {
  i4 = i2 + 21 | 0;
  if (HEAP8[i4 >> 0] | 0) HEAP8[i4 >> 0] = 0;
  if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZL7AddQuadPjjii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i3 = i3 * 17 | 0;
 i6 = i3 + i4 | 0;
 HEAP32[i1 + (i2 << 2) >> 2] = i6;
 i5 = i4 + 1 | 0;
 HEAP32[i1 + (i2 + 1 << 2) >> 2] = i5 + i3;
 i3 = i3 + 17 | 0;
 i5 = i3 + i5 | 0;
 HEAP32[i1 + (i2 + 2 << 2) >> 2] = i5;
 HEAP32[i1 + (i2 + 3 << 2) >> 2] = i6;
 HEAP32[i1 + (i2 + 4 << 2) >> 2] = i5;
 HEAP32[i1 + (i2 + 5 << 2) >> 2] = i3 + i4;
 return i2 + 6 | 0;
}

function __Z50ParticleSystem_EmissionModule_CUSTOM_GetBurstCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[i2 + 264 + 584 >> 2] | 0;
 return i2 | 0;
}

function __Z38CullingGroup_CUSTOM_SetBoundingSpheresP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN12CullingGroup18SetBoundingSpheresEP11Il2CppArray(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z38BoxCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 160 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AsyncOperation_Get_Custom_PropIsDoneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0) & 1;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z36Animator_CUSTOM_CrossFadeInFixedTimeP12Il2CppObjectifif(i1, i2, f3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) {
   __ZN8Animator20GotoStateInFixedTimeEiifff(i6, i4, i2, f5, f3, Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34AnimationState_Get_Custom_PropClipP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 + 96 >> 2] | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function _UNITY_png_write_chunk_end(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i1 + 656 >> 2] = 130;
 i4 = HEAP32[i1 + 408 >> 2] | 0;
 HEAP8[i2 >> 0] = i4 >>> 24;
 HEAP8[i2 + 1 >> 0] = i4 >>> 16;
 HEAP8[i2 + 2 >> 0] = i4 >>> 8;
 HEAP8[i2 + 3 >> 0] = i4;
 _UNITY_png_write_data(i1, i2, 4);
 STACKTOP = i3;
 return;
}

function _getdomainname(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 400 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 _uname(i1) | 0;
 if (!i3) i4 = 3; else {
  i1 = i1 + 325 | 0;
  if ((_strlen(i1) | 0) >>> 0 < i3 >>> 0) {
   _strcpy(i2, i1) | 0;
   i1 = 0;
  } else i4 = 3;
 }
 if ((i4 | 0) == 3) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZThn8_N5physx2Sc18TriggerInteraction7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + -8 | 0;
 i1 = i3 + 8 | 0;
 i2 = i3 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i2 >> 2] | 0, i1);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i3 + 16 >> 2] | 0, i1);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_j(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i1, i2 - i3 >> 2, (HEAP32[i4 >> 2] | 0) - i2 >> 2, i5, i6) | 0;
}

function __ZNK8VRDevice22CanSetPlayerPauseValueE11PlayerPause(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0) if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0) | 0) if ((i2 | 0) == 0 & (HEAP8[i1 + 328 >> 0] | 0) != 0) if (!(HEAP32[i1 + 284 >> 2] | 0)) {
  i1 = HEAP32[i1 + 232 >> 2] | 0;
  if (i1 | 0) if (mftCall_i(i1 | 0) | 0) {
   i2 = 0;
   return i2 | 0;
  }
 }
 i2 = 1;
 return i2 | 0;
}

function __ZNK17ArchiveFileSystem12GetLocalPathEPKc(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 i2 = i4 + 4 | 0;
 i5 = HEAP8[i2 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 if (i6) {
  i2 = HEAP32[i2 >> 2] | 0;
  i3 = HEAP32[i4 + 8 >> 2] | 0;
 } else i3 = i5 & 255;
 if (!(_strncmp(i1, i2, i3) | 0)) {
  if (i6) i2 = HEAP32[i4 + 8 >> 2] | 0; else i2 = i5 & 255;
  i1 = i1 + i2 | 0;
 }
 return ((HEAP8[i1 >> 0] | 0) == 47 ? i1 + 1 | 0 : i1) | 0;
}

function __ZN7mecanim9animation21CreateClipMuscleInputEPKNS0_18ClipMuscleConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 24, 4) | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
 HEAP8[i2 + 12 >> 0] = 0;
 HEAPF32[i2 + 16 >> 2] = Math_fround(0.0);
 HEAP8[i2 + 20 >> 0] = 0;
 HEAP8[i2 + 21 >> 0] = 1;
 return i2 | 0;
}

function __ZN6prcoreL11inner_clearILj3EEEvPhjjj(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 if (!i1) return;
 while (1) {
  i1 = i1 + -1 | 0;
  i7 = i2 + 1 | 0;
  i5 = i2 + 2 | 0;
  i6 = ((HEAPU8[i7 >> 0] | 0) << 8 | (HEAPU8[i2 >> 0] | 0) | (HEAPU8[i5 >> 0] | 0) << 16) & i4 | i3;
  HEAP8[i2 >> 0] = i6;
  HEAP8[i7 >> 0] = i6 >>> 8;
  HEAP8[i5 >> 0] = i6 >>> 16;
  if (!i1) break; else i2 = i2 + 3 | 0;
 }
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148596 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx28PxSceneLimitsGeneratedValuesC2EPKNS_13PxSceneLimitsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZN5physx12solve1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (i3 >>> 0 > 1) {
  i1 = 1;
  do {
   __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i1 + -1 << 5) | 0, i2);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i3 | 0));
 }
 __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i3 + -1 << 5) | 0, i2);
 return;
}

function __ZN19SkinnedMeshRenderer14PrepareSkinGPUEiP18JobBatchDispatcher(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i3, i1, i2) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP8[i1 + 93 >> 0] | 0)) {
  i3 = i1;
  return i3 | 0;
 }
 HEAP32[i1 + 96 >> 2] = __ZN4Mesh24QueryGpuSkinSourceBufferEi(HEAP32[i3 + 356 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0) | 0;
 i3 = i1;
 return i3 | 0;
}

function __ZN18ScreenManagerWebGLC2Ev(i1) {
 i1 = i1 | 0;
 __ZN13ScreenManagerC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 25448 + 8;
 _emscripten_set_fullscreenchange_callback(0, i1 | 0, 1, fb + 345 | 0) | 0;
 _emscripten_set_focus_callback(0, 0, 0, fb + 346 | 0) | 0;
 _emscripten_set_blur_callback(0, 0, 0, fb + 346 | 0) | 0;
 HEAP32[i1 + 52 >> 2] = -1;
 i1 = i1 + 56 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN18PlayableController18DoesPlayableExistsEPK8Playable(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 i2 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN16ReflectionProbes13IsActiveProbeEP15ReflectionProbe(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i1 + (i2 << 2) | 0;
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN11CustomArray8NewBlockEPNS_10CustomCellEm(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 i5 = __Znwj(16) | 0;
 i6 = i5 + 4 | 0;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i5 >> 2] = 0;
 i2 = (i4 | 0) != 0;
 if (i2) i1 = HEAP32[i4 + 12 >> 2] << 1; else i2 = 0;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i6 >> 2] = __Znaj(i1) | 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = i5;
 if (!i2) return i3 | 0;
 HEAP32[i4 >> 2] = i5;
 return i3 | 0;
}

function __ZN10RectOffset8TransferI8JSONReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1, gb + 1033960 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 4 | 0, gb + 1033967 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 8 | 0, gb + 1033975 | 0, 0, 0);
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 12 | 0, gb + 1033981 | 0, 0, 0);
 return;
}

function __Z12GUIDToStringRK9UnityGUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z12GUIDToStringRK9UnityGUIDPc(i2, i4);
 HEAP8[i4 + 32 >> 0] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i4, _strlen(i4) | 0);
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Get_Track_Kerning(i3, i4, i5, i6) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) i1 = 35; else if (!i6) i1 = 6; else {
  i2 = HEAP32[i3 + 96 >> 2] | 0;
  i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0;
  if (!i1) i1 = 7; else {
   i1 = mftCall_iii(i1 | 0, i2 | 0, gb + 1008113 | 0) | 0;
   if (!i1) i1 = 7; else i1 = mftCall_iiiii(HEAP32[i1 >> 2] | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
  }
 }
 return i1 | 0;
}

function __ZNSt3__26futureIvE3getEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 __THREW__ = 0;
 invoke_vi(fb + 3997 | 0, i2 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  if (i2 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  ___resumeException(i1 | 0);
 } else {
  if (i2 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i2) | 0;
  return;
 }
}

function __ZN9UdpSocketC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 65564 + 8;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = _socket(2, 2, 17) | 0;
 HEAP32[i1 + 4 >> 2] = i3;
 if (!(__ZN6Socket10CheckErrorEiPKcii(i3, gb + 458666 | 0, 0, 0) | 0)) HEAP32[i2 >> 2] = 16384;
 HEAP32[i1 >> 2] = gb + 65580 + 8;
 HEAP8[i1 + 17 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 2;
 return;
}

function __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 8 | 0;
 i3 = i2;
 i1 = 0;
 while (1) {
  if ((i1 | 0) >= (i5 | 0)) {
   i1 = -1;
   i2 = 4;
   break;
  }
  if ((i1 | 0) == -1 ? 1 : (HEAP32[(HEAP32[i2 >> 2] | 0) + i3 + (i1 << 2) >> 2] | 0) != (i4 | 0)) i1 = i1 + 1 | 0; else {
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN7Texture19GetNativeTexturePtrEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i6 = i2;
 i4 = __Z12GetGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 716 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 48 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 i1 = mftCall_iii(i5 | 0, i4 | 0, i3 | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx2Gu9Container5EmptyEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 if ((HEAP32[i4 + 12 >> 2] | 0) > -1) {
  i2 = i4 + 8 | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i3);
   HEAP32[i2 >> 2] = 0;
  }
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i4 + 4 >> 2] = 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 95912 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx12NpConstraint17resolveReferencesERNS_24PxDeserializationContextE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i2 | 0) | 0;
 i1 = i3 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, -2147483648, i2 | 0) | 0;
 return;
}

function __ZN19VREyeTextureManager28BlitLeftToRightForMonoscopicEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[gb + 1166248 >> 2] | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_(i3, i2, i1, __ZN12ImageFilters19GetBlitCopyMaterialEv() | 0, -1, 1, -1, gb + 62472 | 0, gb + 1162356 | 0);
 return;
}

function __ZN14MemoryProfiler20GetRelatedMemorySizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZN13MemoryManager25GetAllocatorContainingPtrEPKv(__Z16GetMemoryManagerv() | 0, i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZN13FileEntryDataC2ERKS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 1040 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 1040 >> 2];
 HEAP32[i2 + 1044 >> 2] = HEAP32[i1 + 1044 >> 2];
 HEAP32[i2 + 1048 >> 2] = 0;
 HEAP32[i2 + 1052 >> 2] = 0;
 HEAP32[i2 + 1056 >> 2] = 0;
 _strncpy(i2, i1, 1040) | 0;
 HEAP8[i2 + 1039 >> 0] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN13AnimationClip26EnsureQuaternionContinuityEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 100 >> 2] | 0;
 i2 = i3 + 104 | 0;
 if ((i1 | 0) != (HEAP32[i2 >> 2] | 0)) do {
  __Z45EnsureQuaternionContinuityAndRecalculateSlopeR17AnimationCurveTplI11QuaternionfE(i1 + 16 | 0);
  i1 = i1 + 204 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(i1 | 0, i3 | 0, i3 + 80 | 0);
 return;
}

function __ZN11KeyframeTplI8Vector3fEC2EfRKS0_(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 4 | 0;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 return;
}

function __Z50ParticleSystem_ShapeModule_CUSTOM_GetUseMeshColorsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[i2 + 48 + 214 >> 0] | 0;
 return i2 | 0;
}

function __Z50ParticleSystem_ShapeModule_CUSTOM_GetMeshShapeTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[i2 + 48 + 40 >> 2] | 0;
 return i2 | 0;
}

function __Z37Collider2D_CUSTOM_INTERNAL_get_offsetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i4 = i3 + 40 | 0;
   i1 = HEAP32[i4 + 4 >> 2] | 0;
   i3 = i2;
   HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI9JSONWriteLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI10Matrix4x4fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __ZNSt3__211__stdoutbufIwE6xsputnEPKwi(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 L1 : do if (!(HEAP8[i3 + 44 >> 0] | 0)) {
  i1 = 0;
  while (1) {
   if ((i1 | 0) >= (i4 | 0)) break L1;
   if ((mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0) | 0) == -1) break L1;
   i1 = i1 + 1 | 0;
   i2 = i2 + 4 | 0;
  }
 } else i1 = _fwrite(i2, 4, i4, HEAP32[i3 + 32 >> 2] | 0) | 0; while (0);
 return i1 | 0;
}

function __ZNSt3__211__stdoutbufIcE6xsputnEPKci(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 L1 : do if (!(HEAP8[i3 + 44 >> 0] | 0)) {
  i1 = 0;
  while (1) {
   if ((i1 | 0) >= (i4 | 0)) break L1;
   if ((mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, HEAPU8[i2 >> 0] | 0) | 0) == -1) break L1;
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  }
 } else i1 = _fwrite(i2, 1, i4, HEAP32[i3 + 32 >> 2] | 0) | 0; while (0);
 return i1 | 0;
}

function __ZNK9GfxDevice14GetBufferCountE14GfxBufferLabel15GfxBufferTarget(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 4516 + (i2 << 2) >> 2] | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = 0;
 do {
  i1 = ((HEAP32[((i2 | 0) == 0 ? 0 : i2 + -4 | 0) + 20 >> 2] | 0) == (i4 | 0) & 1) + i1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i3 | 0));
 return i1 | 0;
}

function __ZNK5physx9NpFactory15getClothFabricsEPPNS_13PxClothFabricEj(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 3948 >> 2] | 0;
 i5 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 3944 | 0;
 i1 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZNK13TranslateGLES16GetTextureTargetEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) == (i2 | 0)) {
  i2 = 2;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) == (i2 | 0)) {
  i2 = 3;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) == (i2 | 0)) {
  i2 = 4;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 20 >> 2] | 0) == (i2 | 0)) {
  i2 = 5;
  return i2 | 0;
 } else return ((HEAP32[i1 + 24 >> 2] | 0) == (i2 | 0) ? 6 : -1) | 0;
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingIsjE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIsiE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) << 16 >> 16;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx17PxsContactManagerC2EPNS_10PxsContextEj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 76 >> 2] = i2;
 HEAP32[i3 + 80 >> 2] = 0;
 HEAP32[i3 + 84 >> 2] = 0;
 HEAPF32[i3 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i3 + 104 >> 2] = Math_fround(1.0);
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 52 >> 2] = 0;
 return;
}

function __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf(i1, i2, i4, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if (!i1) return i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i4 | 0);
 __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f3, 0, 0) | 0;
 return i1 | 0;
}

function __ZN17CapsuleCollider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 0;
 i4 = gb + 1162356 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 + 53 >> 0] = 0;
 HEAPF32[i1 + 160 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 164 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 168 >> 2] = 0;
 return;
}

function __ZN16ParticleRenderer14UpdateRendererEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 190576 | 0) | 0;
 if (!i2) __ZN8Renderer18UpdateManagerStateEb(i1, 0); else {
  i2 = i2 + 56 | 0;
  i2 = (HEAP32[i2 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0);
  __ZN8Renderer10SetVisibleEb(i1, i2 ^ 1);
  if (!i2) __ZN8Renderer13BoundsChangedEv(i1);
 }
 __ZN8Renderer14UpdateRendererEv(i1);
 return;
}

function __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE10InitializeEv(i1);
 return;
}

function __ZN12_GLOBAL__N_110DataStream23endPropertyMessageGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 150100 + 8;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i1, i3, 14);
 STACKTOP = i2;
 return (HEAPU8[i1 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN11RadixSorterD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 HEAP32[i3 >> 2] = 0;
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 i2 = i3 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __ZdaPv(i1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN10Matrix3x3f9TransposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 12 | 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 24 | 0;
 i4 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 20 | 0;
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __Z38AsyncOperation_Get_Custom_PropPriorityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function mftCall_iiifififf(i9, i1, i2, d3, i4, d5, i6, d7, d8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 d7 = +d7;
 d8 = +d8;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiifififf[i9 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5), i6 | 0, Math_fround(d7), Math_fround(d8)) | 0;
 return ftCall_iiifififf(i9 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5, i6 | 0, +d7, +d8) | 0;
}

function mftCall_iifiififf(i9, i1, d2, i3, i4, d5, i6, d7, d8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 d7 = +d7;
 d8 = +d8;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifiififf[i9 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, Math_fround(d5), i6 | 0, Math_fround(d7), Math_fround(d8)) | 0;
 return ftCall_iifiififf(i9 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, +d5, i6 | 0, +d7, +d8) | 0;
}

function __ZThn8_N5physx2Gu11HeightFieldD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 107232 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107232 + 104;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 i1 = i1 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZNK5physx14NpArticulation8getLinksEPPNS_18PxArticulationLinkEj(i1, i6, i3) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 i5 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 if (!i5) return i5 | 0;
 i4 = i1 + 88 | 0;
 i1 = i2 >>> 0 < i3 >>> 0 ? i2 : i3;
 i2 = 0;
 do {
  HEAP32[i6 + (i2 << 2) >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2];
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return i5 | 0;
}

function __ZN8Collider16SetContactOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i3) return;
 if (!(f2 <= Math_fround(0.0))) {
  HEAPF32[i1 + 56 >> 2] = f2;
  mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0, +f2);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 779669 | 0, 0, gb + 733088 | 0, 605, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
}

function __ZN5physx9NpFactory14createInstanceEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 4556, (i1 ? gb + 768149 | 0 : gb + 837976 | 0) | 0, gb + 686195 | 0, 125) | 0;
 __ZN5physx9NpFactoryC2Ev(i1);
 HEAP32[gb + 1457204 >> 2] = i1;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx2Sc5Scene12beforeSolverEPNS_10PxBaseTaskE(i2, HEAP32[i1 + 12 >> 2] | 0);
 i1 = i2 + 1204 | 0;
 __ZN5physx10PxsContext28runModifiableContactManagersEv(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0);
 __ZN5physx10PxsContext11swapStreamsEv(HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0);
 return;
}

function __ZN5Unity17ConfigurableJoint18SetProjectionAngleEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(180.0);
 f1 = i4 ? Math_fround(180.0) : f1;
 HEAPF32[i3 + 284 >> 2] = i2 ? Math_fround(0.0) : f1;
 i2 = HEAP32[i3 + 32 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i3);
 return;
}

function __ZN19SkinnedMeshRenderer11PrepareSkinEiP18JobBatchDispatcher(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher(i3, i1, i2) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(HEAP8[i1 + 93 >> 0] | 0)) {
  i3 = i1;
  return i3 | 0;
 }
 HEAP32[i1 + 96 >> 2] = __ZN4Mesh24QueryGpuSkinSourceBufferEi(HEAP32[i3 + 356 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0) | 0;
 i3 = i1;
 return i3 | 0;
}

function __ZN17TransformInternal26InsertTransformThreadAfterER18TransformHierarchyjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i1 + 68 >> 2] | 0;
 i7 = i6 + (i2 << 2) | 0;
 i5 = HEAP32[i7 >> 2] | 0;
 HEAP32[i7 >> 2] = i3;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 HEAP32[i1 + (i3 << 2) >> 2] = i2;
 HEAP32[i6 + (i4 << 2) >> 2] = i5;
 if ((i5 | 0) == -1) return;
 HEAP32[i1 + (i5 << 2) >> 2] = i4;
 return;
}

function __ZN16BaseVideoTexture19UpdateVideoTexturesEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 i2 = HEAP32[gb + 1459952 + 4 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP8[i3 + 93 >> 0] = 0;
  if (HEAP8[i3 + 92 >> 0] | 0) {
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 188 >> 2] | 0, i3 | 0);
   i2 = HEAP32[gb + 1459952 + 4 >> 2] | 0;
  }
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = __ZN8Collider14WordsToPointerEjj(HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 i1 = __ZN8Collider14WordsToPointerEjj(HEAP32[i3 + 4 >> 2] | 0, HEAP32[i3 + 12 >> 2] | 0) | 0;
 if (!((i2 | 0) != 0 & (i1 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK8Collider21ShouldIgnoreCollisionEPS_(i2, i1) | 0;
 return i3 | 0;
}

function __ZN14NavMeshCarving5CarveEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 80 >> 2] | 0;
 i2 = HEAP32[i1 + 84 >> 2] | 0;
 i3 = i4;
 if ((i4 | 0) == (i2 | 0)) return;
 i4 = i2 - i3 >> 5;
 HEAP32[gb + 1459532 >> 2] = i4;
 HEAP32[gb + 1459532 + 4 >> 2] = i3;
 HEAP32[gb + 1459532 + 8 >> 2] = HEAP32[i1 + 92 >> 2];
 __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i1, fb + 4004 | 0, gb + 1459532 | 0, i4, 0, 1);
 return;
}

function __ZN14DirectorPlayer7SetTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) return;
 HEAPF64[i1 + 96 >> 3] = d2;
 d2 = +((HEAP32[i1 + 112 >> 2] | 0) >>> 0) * d2;
 i3 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i1 = i1 + 104 | 0;
 HEAP32[i1 >> 2] = ~~d2 >>> 0;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZL31InitializeClothScriptingClassesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63728 | 0, 16, gb + 839673 | 0, 16) | 0;
 HEAP32[gb + 1459024 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839795 | 0) | 0;
 HEAP32[HEAP32[gb + 1459024 >> 2] >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 1049797 | 0, gb + 839820 | 0) | 0;
 HEAP32[(HEAP32[gb + 1459024 >> 2] | 0) + 4 >> 2] = i1;
 return;
}

function __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetStyleStatePtrP12Il2CppObjectiRPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = i1 + 16 + (i2 * 20 | 0);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z14FindSceneIndexRK13dynamic_arrayI10SceneRangeLj4EEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function _UNITY_png_get_oFFs(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!((i5 | 0) != 0 & ((i4 | 0) != 0 & (i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 256 | 0) != 0 : 0)))) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 172 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i2 + 176 >> 2];
 HEAP32[i5 >> 2] = HEAPU8[i2 + 180 >> 0];
 i5 = 256;
 return i5 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_jw(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjjw(i1, i2 - i3 >> 2, (HEAP32[i4 >> 2] | 0) - i2 >> 2, i5, i6) | 0;
}

function __ZNK5Umbra9Matrix2x211getMaxScaleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f4 * f4);
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 f2 = Math_fround(f4 + Math_fround(f2 * f2));
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f4 = Math_fround(f4 * f4);
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 f3 = Math_fround(f4 + Math_fround(f3 * f3));
 return Math_fround(Math_sqrt(Math_fround(f3 > f2 ? f3 : f2)));
}

function __ZN7mecanim8skeleton20SkeletonPoseSetDirtyEPKNS0_8SkeletonEPjiij(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 i3 = HEAP32[(HEAP32[i3 >> 2] | 0) + i3 + (i4 << 3) >> 2] | 0;
 if (!((i4 | 0) == (i5 | 0) | (i3 | 0) == -1)) __ZN7mecanim8skeleton20SkeletonPoseSetDirtyEPKNS0_8SkeletonEPjiij(i1, i2, i3, i5, i6);
 i5 = i2 + (i4 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | i6;
 return;
}

function __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i4 >> 0] = i3;
  HEAP8[i4 + 1 >> 0] = i3;
  HEAP8[i4 + 2 >> 0] = i3;
  if (!i2) break; else {
   i4 = i4 + 3 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN5physx35solveFriction_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i5, i4, i1, i2, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i5) return; else i1 = 0;
 do {
  __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx2Sc8SimStats8simStartEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1;
 i3 = i1 + 24 | 0;
 i4 = i2 + 12 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 i2 = i1 + 12 | 0;
 i3 = i1 + 36 | 0;
 i4 = i2 + 12 | 0;
 do {
  HEAP8[i2 >> 0] = HEAP8[i3 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 _memset(i1 + 24 | 0, 0, 164) | 0;
 return;
}

function __ZN19TouchPhaseEmulation15CompactFingerIDEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 8 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i2 = 0;
 while (1) {
  i3 = 1 << i2;
  if (!(i5 & i3)) break;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) >= 32) {
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 if ((i2 | 0) > (i1 | 0)) {
  i6 = i1;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = (i5 | i3) & ~(1 << i1);
 i6 = i2;
 return i6 | 0;
}

function __ZN15DistanceJoint2D11SetDistanceEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(.00499999989);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i2 ? Math_fround(.00499999989) : f1;
 HEAPF32[i3 + 96 >> 2] = f1;
 i2 = HEAP32[i3 + 60 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP8[i3 + 100 >> 0] | 0)) {
  HEAPF32[i2 + 104 >> 2] = f1;
  return;
 } else {
  HEAPF32[i2 + 84 >> 2] = f1;
  return;
 }
}

function __ZN13RenderTexture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i6 = i2;
 i4 = __Z21GetUncheckedGfxDevicev() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 424 >> 2] | 0;
 HEAP32[i6 >> 2] = HEAP32[i1 + 124 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 mftCall_vii(i5 | 0, i4 | 0, i3 | 0);
 STACKTOP = i2;
 return;
}

function __ZN12TextureInput5CleanEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z36AnimationState_Get_Custom_PropLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 92 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z35GUIStyle_Get_Custom_PropFixedHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 280 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z33Light_CUSTOM_RemoveCommandBuffersP12Il2CppObject20RenderLightEventType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   __ZN19RenderEventsContext20RemoveCommandBuffersEi((HEAP32[i3 + 44 >> 2] | 0) + 208 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _cff_get_ps_name(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = HEAP32[i2 + 656 >> 2] | 0;
 if (HEAP32[i2 + 532 >> 2] | 0) {
  i1 = _UNITY_ft_module_get_service(_UNITY_FT_Get_Module(HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1007772 | 0) | 0, gb + 1008130 | 0) | 0;
  if (i1 | 0) {
   i1 = HEAP32[i1 >> 2] | 0;
   if (i1 | 0) {
    i3 = mftCall_ii(i1 | 0, i2 | 0) | 0;
    return i3 | 0;
   }
  }
 }
 i3 = HEAP32[i3 + 1304 >> 2] | 0;
 return i3 | 0;
}

function _cff_get_cid_from_glyph_index(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 656 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 1456 >> 2] | 0) == 65535) {
  i3 = 6;
  return i3 | 0;
 }
 if ((HEAP32[i1 + 12 >> 2] | 0) >>> 0 < i2 >>> 0) {
  i3 = 6;
  return i3 | 0;
 }
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAPU16[(HEAP32[i1 + 1160 >> 2] | 0) + (i2 << 1) >> 1];
 i3 = 0;
 return i3 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_j(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i1, i2 - i3 | 0, (HEAP32[i4 >> 2] | 0) - i2 | 0, i5, i6) | 0;
}

function __ZNK5Umbra15CameraTransform10getFrustumERNS_7FrustumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 404 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN9Rigidbody15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67048 | 0, gb + 1105016 | 0, fb + 849 | 0, gb + 29192 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 67048 | 0, gb + 1105456 | 0, fb + 850 | 0, gb + 29632 | 0);
 return;
}

function __ZN8Renderer15RemoveFromSceneER13RendererScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 284 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == -1) return;
 i5 = i1 + 268 | 0;
 i5 = ((HEAPU16[i5 >> 1] | 0 | (HEAPU8[i5 + 2 >> 0] | 0) << 16) & 4096 | 0) == 0;
 __ZN13RendererScene14RemoveRendererEi(i2, i4) | 0;
 HEAP32[i3 >> 2] = -1;
 if (i5) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8Animator30HasOnlySingleLayeredControllerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 584 | 0;
 i3 = i1 + 596 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 i1 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 do {
  i1 = i1 | (__ZNK26AnimatorControllerPlayable13GetLayerCountEv(HEAP32[i2 >> 2] | 0) | 0) > 1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) != ((HEAP32[i4 >> 2] | 0) + (HEAP32[i3 >> 2] << 2) | 0));
 i4 = i1 ^ 1;
 return i4 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 150752 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx2Sc8RigidSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 91016 + 8;
 i3 = HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0) + 1200 >> 2] | 0;
 __ZN5physx2Sc15ObjectIDTracker9releaseIDEj(i3, HEAP32[i1 + 56 >> 2] | 0);
 __ZN5physx2Sc8ActorSimD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu5RTree7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (HEAP32[i1 + 84 >> 2] & 1 | 0) {
  STACKTOP = i3;
  return;
 }
 i1 = i1 + 92 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2 + (0 - (HEAP32[i2 + -4 >> 2] | 0)) | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5Umbra9Matrix3x39transposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = i2;
 i4 = i1 + 8 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 24 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 i3 = i1 + 20 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 28 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN29ParticleSystemPropertyBinding49InitializeParticleSystemAnimationBindingInterfaceEv() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(100, gb + 63264 | 0, 16, gb + 621767 | 0, 17) | 0;
 __ZN29ParticleSystemPropertyBindingC2Ev(i1);
 HEAP32[gb + 1452340 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 198, 27, HEAP32[gb + 1452340 >> 2] | 0);
 return;
}

function __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 208 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 200 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN19CullingGroupManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __Z21SetCurrentMemoryOwnerRK10MemLabelId(i4, gb + 63664 | 0);
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 STACKTOP = i2;
 return;
}

function __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 i4 = i1 + 68 | 0;
 i5 = i3;
 _memmove(i2 | 0, i3 | 0, (HEAP32[i1 + 56 >> 2] | 0) + (HEAP32[i4 >> 2] << 4) - i5 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - (i5 - i2 >> 4);
 return;
}

function __ZN14GfxDeviceStats15CopyClientStatsERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 136 | 0;
 i4 = i2 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i4 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i4 + 20 >> 2];
 HEAP32[i1 + 272 >> 2] = HEAP32[i2 + 272 >> 2];
 return;
}

function __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12ServerSocket7GetPortEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = 16;
 if (__ZN6Socket10CheckErrorEiPKcii(_getsockname(HEAP32[i1 + 4 >> 2] | 0, i2, i4) | 0, 0, 0, 0) | 0) {
  i4 = -1;
  STACKTOP = i3;
  return i4 | 0;
 }
 i4 = (_ntohs(HEAP16[i2 + 2 >> 1] | 0) | 0) & 65535;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN11UnityEngine15PlatformWrapper12GetInfoFlagsEv() {
 var i1 = 0, i2 = 0;
 i1 = __Z19GetBuildSettingsPtrv() | 0;
 if (!i1) i1 = 64; else {
  i2 = HEAP8[i1 + 108 >> 0] | 0 ? 2 : 1;
  i1 = ((HEAP8[i1 + 115 >> 0] | 0) == 0 ? i2 | 8 : i2) | 64;
 }
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 505 >> 0] | 0) == 0;
 i2 = i2 ? i1 : i1 | 16777216;
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 507 >> 0] | 0) == 0;
 return (i1 ? i2 : i2 | 33554432) | 1073741824 | 0;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE8ValidateEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 116 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i1 + 16 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0;
 return i2 | 0;
}

function __Z52GUIText_CUSTOM_INTERNAL_CALL_Internal_SetPixelOffsetP12Il2CppObjectRK13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i2 + 4 >> 2] | 0;
   i3 = i3 + 68 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   HEAP32[i3 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleSystem_EmissionModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[i2 + 264 + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z44Canvas_Get_Custom_PropReferencePixelsPerUnitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   return Math_fround(HEAPF32[i1 + 356 >> 2]);
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36AnimationState_Get_Custom_PropWeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 8 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z35Random_CUSTOM_INTERNAL_get_rotationP11Quaternionf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __Z16RandomQuaternionR4Rand(i3, __Z16GetScriptingRandv() | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 STACKTOP = i2;
 return;
}

function __Z35AnimationState_Get_Custom_PropSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 36 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z34GUIStyle_Get_Custom_PropFixedWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 276 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z34AnimationState_Get_Custom_PropTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(+HEAPF64[i1 + 16 >> 3]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function __Z25ApproximateUVDistributionR4Meshi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAPF32[i5 >> 2] = Math_fround(1.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(1.0);
 f4 = Math_fround(__Z25ApproximateUVDistributionPK10Matrix4x4fR4MeshRK8Vector2ffi(0, i1, i5, Math_fround(9.99999971e-10), i2));
 STACKTOP = i3;
 return Math_fround(f4);
}

function __Z18Transfer_BlittableI8JSONReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI8Vector4fEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI8Vector2fEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18CleanupHaloManagerv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP32[gb + 1110376 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  i3 = i2;
  if (i2 | 0) {
   i4 = i1 + 4 | 0;
   i5 = HEAP32[i4 >> 2] | 0;
   if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~(((i5 + -40 - i3 | 0) >>> 0) / 40 | 0) * 40 | 0);
   __ZdlPv(i2);
  }
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[gb + 1110376 >> 2] = 0;
 return;
}

function _UNITY_png_set_compression_buffer_size(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 if ((i2 | 0) < 1) _UNITY_png_error(i1, gb + 354594 | 0);
 if (HEAP32[i1 + 204 >> 2] & 32768 | 0) {
  HEAP32[i1 + 652 >> 2] = i2;
  return;
 }
 if (i2 >>> 0 < 6 | (HEAP32[i1 + 216 >> 2] | 0) != 0) return;
 i3 = i1 + 280 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 _UNITY_png_free_buffer_list(i1, i1 + 276 | 0);
 HEAP32[i3 >> 2] = i2;
 return;
}

function _UNITY_FT_Stream_Skip(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if ((i1 | 0) < 0) {
  i4 = 85;
  return i4 | 0;
 }
 i4 = i3 + 8 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + i1 | 0;
 i2 = HEAP32[i3 + 20 >> 2] | 0;
 if (!i2) {
  if ((HEAP32[i3 + 4 >> 2] | 0) >>> 0 < i1 >>> 0) {
   i4 = 85;
   return i4 | 0;
  }
 } else if (mftCall_iiiii(i2 | 0, i3 | 0, i1 | 0, 0, 0) | 0) {
  i4 = 85;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 i4 = 0;
 return i4 | 0;
}

function mftCall_iiiifiiff(i9, i1, i2, i3, d4, i5, i6, d7, d8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 d8 = +d8;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifiiff[i9 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, Math_fround(d7), Math_fround(d8)) | 0;
 return ftCall_iiiifiiff(i9 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, +d7, +d8) | 0;
}

function _setstate(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 ___lock(gb + 1470376 | 0);
 i2 = (HEAP32[gb + 207772 >> 2] | 0) + -4 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 207776 >> 2] << 8 | HEAP32[gb + 207768 >> 2] << 16 | HEAP32[gb + 1470384 >> 2];
 HEAP32[gb + 207772 >> 2] = i1 + 4;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[gb + 207768 >> 2] = i1 >>> 16;
 HEAP32[gb + 207776 >> 2] = i1 >>> 8 & 255;
 HEAP32[gb + 1470384 >> 2] = i1 & 255;
 ___unlock(gb + 1470376 | 0);
 return i2 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4initEPv(i2, i3);
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = -1;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4initEPv(i2, i3);
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = -1;
 return;
}

function __ZNK5physx2Sn12PointerRemap17checkRefIsNotUsedEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  i4 = 1;
  return i4 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = 0;
 while (1) {
  if ((HEAP32[i1 + (i2 << 4) + 8 >> 2] | 0) == (i4 | 0)) {
   i1 = 0;
   i2 = 5;
   break;
  }
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= i3 >>> 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN5physx8debugger14PvdMarshallingItjE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingItiE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = (HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8) & 65535;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 2 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx22PxDefaultFileInputDataC2EPKc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = gb + 87616 + 8;
 i2 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 i1 = _fopen(i1, gb + 945625 | 0) | 0;
 if (!i1) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   HEAP32[i3 + 8 >> 2] = 0;
   return;
  }
 } else HEAP32[i2 >> 2] = i1;
 _fseek(i1, 0, 2) | 0;
 HEAP32[i3 + 8 >> 2] = _ftell(HEAP32[i2 >> 2] | 0) | 0;
 _fseek(HEAP32[i2 >> 2] | 0, 0, 0) | 0;
 return;
}

function __ZN24MaterialDisplayListCache20MaterialDisplayLists22InvalidateDisplayListsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) {
  i5 = i2 + 20 | 0;
  i1 = 0;
  do {
   __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv((HEAP32[i5 >> 2] | 0) + (i1 * 244 | 0) | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i4 | 0));
 }
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN23ShaderVariantCollectionD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 68748 + 8;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1 + 32 | 0, HEAP32[i1 + 36 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13MemoryManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 1544 | 0;
 __ZN13MemoryManager13ThreadCleanupEv(i2);
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   i4 = HEAP32[i2 + 1568 + (i1 << 2) >> 2] | 0;
   mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 i4 = HEAP32[i2 + 1556 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
 return;
}

function __ZN12_GLOBAL__N_110DataStream19endSetPropertyValueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i1 + 204 >> 2] = 0;
 HEAP32[i3 >> 2] = gb + 150180 + 8;
 __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE(i1, i3, 10);
 STACKTOP = i2;
 return (HEAPU8[i1 + 392 >> 0] | 0) ^ 1 | 0;
}

function __ZN10MonoScript10FindMethodEPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i4 = gb + 1164176 | 0;
  i1 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i2;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i1;
  return;
 } else {
  __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i2, HEAP32[i1 + 4 >> 2] | 0, i3, 1);
  return;
 }
}

function __Z53Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46ParticleSystem_ShapeModule_CUSTOM_GetShapeTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP32[i2 + 48 + 8 >> 2] | 0;
 return i2 | 0;
}

function __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetRectOffsetPtrP12Il2CppObjectiRPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i3 >> 2] = i1 + 176 + (i2 << 4);
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z33Graphics_CUSTOM_CopyTexture_SliceP12Il2CppObjectiiS0_ii(i1, i4, i5, i3, i6, i7) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __Z11CopyTextureP7TextureiiS0_ii(i2, i4, i5, i1, i6, i7) | 0;
 return;
}

function _UNITY_ft_service_list_lookup(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 if (!((i1 | 0) != 0 & (i3 | 0) != 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  if (!(_strcmp(i2, i3) | 0)) break;
  i1 = i1 + 8 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) {
   i1 = 0;
   i4 = 6;
   break;
  }
 }
 if ((i4 | 0) == 6) return i1 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 return i4 | 0;
}

function mftCall_iiiiifiif(i9, i1, i2, i3, i4, d5, i6, i7, d8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 d8 = +d8;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 31 | 0)) return FUNCTION_TABLE_iiiiifiif[i9 - fb & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5), i6 | 0, i7 | 0, Math_fround(d8)) | 0;
 return ftCall_iiiiifiif(i9 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5, i6 | 0, i7 | 0, +d8) | 0;
}

function __ZNK21EnlightenSceneMapping14FindSceneIndexEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 * 28 | 0) + 16 >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i4 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN9WWWCached8GetErrorEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 20 | 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i2 << 24 >> 24 < 0;
 if (i4) i2 = HEAP32[i3 + 24 >> 2] | 0; else i2 = i2 & 255;
 if (!i2) {
  i1 = HEAP32[i3 + 88 >> 2] | 0;
  if (!i1) {
   i4 = 0;
   return i4 | 0;
  }
  i4 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
  return i4 | 0;
 }
 if (i4) i1 = HEAP32[i1 >> 2] | 0;
 i4 = i1;
 return i4 | 0;
}

function __ZN5physx23solve1D4Block_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i1, i5, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6);
 __ZN5physx12writeBack1D4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i6, 0, 0, 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20setMaxMotionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore20setMaxMotionDistanceEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx14NpArticulation9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(i1, i4, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 88 | 0;
 i2 = 0;
 do {
  __ZN5physx18NpArticulationLink9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, i4, i5);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN4crndL20crnd_default_reallocEPvjPjbS0_(i1, i4, i5, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 do if (!i1) {
  i1 = _malloc(i4) | 0;
  if (i5) HEAP32[i5 >> 2] = i1 | 0 ? i4 : 0;
 } else {
  if (!i4) {
   _free(i1);
   if (!i5) {
    i1 = 0;
    break;
   }
   HEAP32[i5 >> 2] = 0;
   i1 = 0;
   break;
  }
  if (i2) i1 = _realloc(i1, i4) | 0; else i1 = 0;
  if (i5) HEAP32[i5 >> 2] = i4;
 } while (0);
 return i1 | 0;
}

function __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 1040830 | 0, HEAP32[gb + 36972 >> 2] | 0, i1 + 4 | 0, 0);
 HEAP32[(HEAP32[HEAP32[i2 + 16 >> 2] >> 2] | 0) + ((HEAP32[i2 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = 1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN14RenderSettings28SetGeneratedSkyboxReflectionEP7Cubemap(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i2 + 384 | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1112272 >> 2] | 0;
 i3 = HEAP32[i2 + 364 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[((HEAP32[i2 + 368 >> 2] | 0) == 0 ? i4 : i2 + 380 | 0) >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i1);
 return;
}

function __ZN13WheelCollider19CreateWheelIfNeededEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 148 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i3 = i1;
  return i3 | 0;
 }
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) if (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 i3 = HEAP32[i3 >> 2] | 0;
 return i3 | 0;
}

function __ZN12TLSAllocatorI14StackAllocatorEC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN13BaseAllocatorC2EPKc(i2, i1);
 HEAP32[i2 >> 2] = gb + 27048 + 8;
 if (!(HEAP32[gb + 1103856 >> 2] | 0)) i1 = 1; else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 365320 | 0, 0, gb + 365400 | 0, 20, 1, 0, 0, 0);
  i1 = (HEAP32[gb + 1103856 >> 2] | 0) + 1 | 0;
 }
 HEAP32[gb + 1103856 >> 2] = i1;
 _memset(i2 + 32 | 0, 0, 512) | 0;
 return;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE8ValidateEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 308 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i1 + 16 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0;
 return i2 | 0;
}

function __Z47DownloadHandlerAudioClip_CUSTOM_InternalGetDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZL20InternalGetByteArrayPK15DownloadHandler(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027975 | 0, i2);
 return 0;
}

function __Z40InitializeLightAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63320 | 0, 16, gb + 379767 | 0, 282) | 0;
 HEAP32[i1 >> 2] = gb + 35256 + 8;
 __ZN20LightPropertyBinding14GenerateHashesEv(i1);
 HEAP32[gb + 1111236 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 108, 25, HEAP32[gb + 1111236 >> 2] | 0);
 return;
}

function __Z29UnloadGameObjectAndComponentsR10GameObject(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 40 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) i1 = 0; else {
  __Z22delete_object_internalP6Object(i2);
  return;
 }
 do {
  i4 = __ZNK10GameObject22GetComponentPtrAtIndexEi(i2, i1) | 0;
  if (i4 | 0) __Z22delete_object_internalP6Object(i4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 __Z22delete_object_internalP6Object(i2);
 return;
}

function __Z26GetContentModificationDateRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZN15FileSystemEntryC2EPKc(i4, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 __ZNK15FileSystemEntry12LastModifiedEv(i1, i4);
 __ZN13FileEntryDataD2Ev(i4);
 STACKTOP = i3;
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function mftCall_vifififfi(i9, i1, d2, i3, d4, i5, d6, d7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vifififfi[i9 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, Math_fround(d4), i5 | 0, Math_fround(d6), Math_fround(d7), i8 | 0);
  return;
 }
 ftCall_vifififfi(i9 | 0, i1 | 0, +d2, i3 | 0, +d4, i5 | 0, +d6, +d7, i8 | 0);
}

function __ZNK5Umbra14TomeCollection7getTomeEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 if (HEAP32[i2 + 44 >> 2] | 0) {
  i3 = HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + ((HEAP32[i2 + 40 >> 2] | 0) + (i3 << 5)) >> 2] | 0;
  return i3 | 0;
 }
 if (i3 | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else return (HEAP8[i2 + 24 >> 0] | 0 ? 0 : i1) | 0;
 return 0;
}

function __ZNK15FileSystemEntry12FolderExistsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 1040 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i3 | 0) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i3 | 0) | 0;
 return i3 | 0;
}

function __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i6 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i6 >> 8;
 if (i6 & 1) i1 = HEAP32[(HEAP32[i4 >> 2] | 0) + i1 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i3 | 0, i4 + i1 | 0, (i6 & 2 | 0 ? i5 : 2) | 0);
 return;
}

function __ZN5physx9NpPhysics15releaseInstanceEv() {
 var i1 = 0;
 i1 = (HEAP32[gb + 1457336 >> 2] | 0) + -1 | 0;
 HEAP32[gb + 1457336 >> 2] = i1;
 if (i1 | 0) return i1 | 0;
 __ZN5physx9NpFactory15destroyInstanceEv();
 i1 = HEAP32[gb + 1457324 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457324 >> 2] = 0;
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 i1 = HEAP32[gb + 1457336 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 44 >> 2] & 2147483647) >>> 0 >= i1 >>> 0) {
  i2 = i2 + 40 | 0;
  HEAP32[i2 >> 2] = i1;
  return;
 }
 __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i2, i1);
 i2 = i2 + 40 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx3Cct10ControllerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83836 + 8;
 i1 = HEAP32[i2 + 456 >> 2] | 0;
 if (i1 | 0) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
  mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
  i1 = HEAP32[i2 + 400 >> 2] | 0;
  if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 }
 __ZN5physx3Cct9SweepTestD2Ev(i2 + 88 | 0);
 return;
}

function __ZN5physx2Sc16InteractionScene11preAllocateEjjjj(i2, i4, i6, i5, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i4 >>> 0 > 64 ? i4 : 64;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj(i2, i1);
 i1 = HEAP32[i2 + 1e3 >> 2] | 0;
 if (!i1) return;
 __ZN5physx10PxsContext11preAllocateEjjjj(i1, i4, i6, i5, i3);
 return;
}

function __ZN2UI14CanvasRenderer14SetPopMaterialEP8Materiali(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(__ZN2UI14CanvasRenderer17SetMaterialNoSyncEP8MaterialiR13dynamic_arrayI4PPtrIS1_ELj4EE(i1, i2, i3, i1 + 116 | 0) | 0)) return;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN24UserAuthorizationManager31ReplyToUserAuthorizationRequestEbb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 4 | 0;
 if (i3) HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = 0;
 i1 = i2 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN14AsyncOperation15InvokeCoroutineEv(i2);
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22NavMeshProjectSettings11SetAreaCostEjf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 if (i2 >>> 0 > 31) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 841954 | 0, 0, gb + 841974 | 0, 193, 1, 0, 0, 0);
  return;
 }
 HEAPF32[i1 + 28 + (i2 * 20 | 0) + 16 >> 2] = f3;
 i1 = HEAP32[(HEAP32[gb + 1459032 >> 2] | 0) + 100 >> 2] | 0;
 if (!i1) return;
 __ZN7dtCrowd16UpdateFilterCostEif(i1, i2, f3);
 return;
}

function __ZN15DistanceJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D5ResetEv(i1);
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 100 >> 0] = 0;
 HEAP8[i1 + 101 >> 0] = 1;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN12TextureInputD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63736 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12NavMeshAgent14SetDestinationERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844323 | 0, 0, gb + 841797 | 0, 149, 1, 0, 0, 0);
  i2 = 0;
  return i2 | 0;
 } else {
  i2 = __ZN7dtCrowd17requestMoveTargetERK13dtCrowdHandlePKf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i2) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZL27CleanupGlobalNameConversionPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1166132 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63416 | 0);
 HEAP32[gb + 1166132 >> 2] = 0;
 return;
}

function __Z50Transform_CUSTOM_INTERNAL_CALL_SetLocalEulerAnglesP12Il2CppObjectRK8Vector3fN4math13RotationOrderE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Transform19SetLocalEulerAnglesERK8Vector3fN4math13RotationOrderE(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Playables_CUSTOM_INTERNAL_CALL_DisconnectInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 if (!(HEAP32[i1 + 48 >> 2] & 1)) {
  __ZN8Playable10DisconnectEPS_i(i1, i2);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 550470 | 0, 0, gb + 550266 | 0, 414, 1, 0, 0, 0);
  return;
 }
}

function __Z49LightProbeProxyVolume_Set_Custom_PropProbeDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 60 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
   HEAPF32[i1 >> 2] = f2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Camera_Get_Custom_PropStereoActiveEyeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   if (!(__ZNK6Camera16GetStereoEnabledEv(i2) | 0)) {
    i2 = 2;
    return i2 | 0;
   }
   i2 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4208 >> 2] | 0;
   return i2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34WWW_Get_Custom_PropBytesDownloadedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function __Z29AudioMasterDSPProcessCallbackP21UnityAudioEffectStatePfS1_jii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0;
 i7 = gb + 1097872 | 0;
 i7 = _i64Add(HEAP32[i7 >> 2] | 0, HEAP32[i7 + 4 >> 2] | 0, i4 | 0, 0) | 0;
 i1 = getTempRet0() | 0;
 i6 = gb + 1097872 | 0;
 HEAP32[i6 >> 2] = i7;
 HEAP32[i6 + 4 >> 2] = i1;
 _memcpy(i3 | 0, i2 | 0, Math_imul(i4 << 2, i5) | 0) | 0;
 return 0;
}

function __Z21CheckShouldRenderPassiR8Material(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z18GetQualitySettingsv() | 0;
 i3 = HEAPU8[(HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 81 >> 0] | 0;
 i2 = HEAP32[(__ZN8Material9GetShaderEv(i2) | 0) + 32 >> 2] | 0;
 return ((i3 ^ 1) & HEAP32[(HEAP32[(HEAP32[HEAP32[(HEAP32[i2 >> 2] | 0) + (HEAP32[i2 + 48 >> 2] << 2) >> 2] >> 2] | 0) + (i1 << 2) >> 2] | 0) + 752 >> 2] | 0) == 0 | 0;
}

function _XXH32_reset(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i2 + 606290984;
 HEAP32[i1 + 16 >> 2] = i2 + -2048144777;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i2 + 1640531535;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return 0;
}

function mftCall_iiifiifii(i9, i1, i2, d3, i4, i5, d6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiifiifii[i9 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0) | 0;
 return ftCall_iiifiifii(i9 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0) | 0;
}

function _remove(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i1 = i4;
 HEAP32[i1 >> 2] = i2;
 i1 = ___syscall_ret(___syscall10(10, i1 | 0) | 0) | 0;
 if (!i1) i1 = 0; else if ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 21) {
  HEAP32[i3 >> 2] = i2;
  i1 = ___syscall_ret(___syscall40(40, i3 | 0) | 0) | 0;
 }
 STACKTOP = i4;
 return i1 | 0;
}

function _opendir(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i2 = _open(i1, 589824, i4) | 0;
 do if ((i2 | 0) < 0) i1 = 0; else {
  i1 = _calloc(1, 2072) | 0;
  if (!i1) {
   HEAP32[i3 >> 2] = i2;
   ___syscall6(6, i3 | 0) | 0;
   i1 = 0;
   break;
  } else {
   HEAP32[i1 >> 2] = i2;
   break;
  }
 } while (0);
 STACKTOP = i4;
 return i1 | 0;
}

function ___towrite(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 74 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 HEAP8[i2 >> 0] = i3 + 255 | i3;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!(i2 & 8)) {
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  i3 = HEAP32[i1 + 44 >> 2] | 0;
  HEAP32[i1 + 28 >> 2] = i3;
  HEAP32[i1 + 20 >> 2] = i3;
  HEAP32[i1 + 16 >> 2] = i3 + (HEAP32[i1 + 48 >> 2] | 0);
  i1 = 0;
 } else {
  HEAP32[i1 >> 2] = i2 | 32;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_jc(i1, i2, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjjc(i1, i2 - i3 | 0, (HEAP32[i4 >> 2] | 0) - i2 | 0, i5, i6) | 0;
}

function __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 _il2cpp_runtime_object_init_exception(i1 | 0, i2 | 0);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc(i1, 0, 0);
 STACKTOP = i3;
 return;
}

function __ZN9AudioClip11ReadyToPlayEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i1 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  if ((__ZNK14SoundHandleAPI12GetLoadStateEv(i1) | 0) == 3) {
   i2 = 1;
   return i2 | 0;
  }
 }
 i2 = 0;
 return i2 | 0;
}

function __ZN5physx7NpScene5solveEfPNS_10PxBaseTaskEPvjb(i6, f2, i1, i4, i5, i3) {
 i6 = i6 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 678666 | 0, 2042, gb + 707769 | 0, i1);
 STACKTOP = i1;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction21deactivateForLowLevelEbj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = i3 + 32 | 0;
 i5 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i4 >> 2] | 0) | 0;
 __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj(i5, HEAP32[i4 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0, i2, i1);
 HEAP8[i3 + 46 >> 0] = 0;
 return;
}

function __ZN5physx25PxVehicleConstraintShader19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i1 + 372 >> 2] | 0;
 i4 = i1 + 112 | 0;
 i3 = (HEAP8[i4 >> 0] | 0) + -1 << 24 >> 24;
 HEAP8[i4 >> 0] = i3;
 if (i3 << 24 >> 24) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20setMaxMotionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore20setMaxMotionDistanceEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx15PxsParticleDataC2EPh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = gb + 96500 + 8;
 HEAP8[i2 + 4 >> 0] = 0;
 i4 = i2 + 80 | 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = (i1 + 31 | 0) >>> 5;
 HEAP32[i2 + 56 >> 2] = i4;
 HEAP32[i2 + 60 >> 2] = i3 | -2147483648;
 i3 = (i3 << 2) + 15 & 1073741808;
 HEAP32[i2 + 48 >> 2] = i4 + i3;
 HEAP32[i2 + 52 >> 2] = HEAP8[i2 + 12 >> 0] | 0 ? i4 + (i3 + (i1 << 5)) | 0 : 0;
 return;
}

function __ZN23ShaderVariantCollection13ClearVariantsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 32 | 0;
 i2 = i1 + 36 | 0;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = 0;
 return;
}

function __ZN18ProceduralMaterial18SetMaterialsBrokenERNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - i2 | 0;
 if ((i1 | 0) <= 0) return;
 i1 = (i1 >> 2) + -1 | 0;
 do {
  i3 = (HEAP32[i2 + (i1 << 2) >> 2] | 0) + 28 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2048;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) > -1);
 return;
}

function __ZN16GraphicsSettings10SmartResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAP32[i1 + 40 >> 2] = 1;
 HEAP32[i1 + 48 >> 2] = 1;
 HEAP32[i1 + 56 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAP32[i1 + 64 >> 2] = 1;
 HEAP32[i1 + 80 >> 2] = 1;
 HEAP32[i1 + 88 >> 2] = 1;
 i1 = i1 + 128 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN13CameraLODData13RemoveAtIndexEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 28 | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP8[i3 + i2 >> 0] = HEAP8[i3 + ((HEAP32[i5 >> 2] | 0) + -1) >> 0] | 0;
 i3 = i1 + 48 | 0;
 i4 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i1 + (i4 << 2) >> 2];
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + -1;
 HEAP32[i3 >> 2] = i4;
 return;
}

function __ZN12ImageFilters19ReleaseTargetForLDREPP13RenderTexture(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(__Z22GetRenderBufferManagerv() | 0, i4);
 i2 = i1 + 24 | 0;
 if ((i4 | 0) == (HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = 0;
 i1 = i1 + 28 | 0;
 if ((i4 | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN10OnGUIState28SetNameOfNextKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
  __ZdlPv(i2);
 }
 i2 = __Znwj(12) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i2, i3);
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE8ValidateEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 212 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i1 + 16 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0;
 return i2 | 0;
}

function __Z48Gyroscope_CUSTOM_INTERNAL_CALL_attitude_InternaliR11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z11GetAttitudei(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i4 + 12 >> 2];
 STACKTOP = i3;
 return;
}

function __Z45DownloadHandlerTexture_CUSTOM_InternalGetDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZL20InternalGetByteArrayPK15DownloadHandler(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027830 | 0, i2);
 return 0;
}

function __Z44ParticleSystem_ShapeModule_CUSTOM_GetEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i2) __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 i2 = HEAP8[i2 + 48 + 4 >> 0] | 0;
 return i2 | 0;
}

function __Z39SetContentModificationDateToCurrentTimeRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = __ZN15FileSystemEntry5TouchEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z38NavMeshAgent_CUSTOM_SamplePathPositionP12Il2CppObjectifP10NavMeshHit(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) return (__ZNK12NavMeshAgent18SamplePathPositionEifP10NavMeshHit(i5, i2, f3, i4) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Physics2D_CUSTOM_GetIgnoreCollisionP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = __Z19GetPhysicsManager2Dv() | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 return (__ZNK16Physics2DManager18GetIgnoreCollisionEP10Collider2DS1_(i4, i2, i1) | 0) & 1 | 0;
}

function __Z34GUI_CUSTOM_GetNameOfFocusedControlv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 __ZN8GUIState23GetNameOfFocusedControlEv(i3, __Z11GetGUIStatev() | 0);
 i2 = __Z20scripting_string_newPKc((HEAP8[i3 + 11 >> 0] | 0) < 0 ? HEAP32[i3 >> 2] | 0 : i3) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i3);
 STACKTOP = i1;
 return i2 | 0;
}

function __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority(i2, i3, i4, i5, i6, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 if (HEAP32[i2 >> 2] | 0) HEAP32[i2 >> 2] = 0;
 if (i5 | 0) {
  i1 = 0;
  do {
   mftCall_vii(i3 | 0, i4 | 0, i1 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) != (i5 | 0));
 }
 if (i6 | 0) mftCall_vi(i6 | 0, i4 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function _UNITY_png_do_swap(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 if ((HEAP8[i1 + 9 >> 0] | 0) != 16) return;
 i4 = Math_imul(HEAPU8[i1 + 10 >> 0] | 0, HEAP32[i1 >> 2] | 0) | 0;
 if (!i4) return; else {
  i2 = 0;
  i1 = i3;
 }
 while (1) {
  i5 = HEAP8[i1 >> 0] | 0;
  i3 = i1 + 1 | 0;
  HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
  HEAP8[i3 >> 0] = i5;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 2 | 0;
 }
 return;
}

function __ZNSt3__217moneypunct_bynameIwLb1EED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 212028 + 8;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 52 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 40 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217moneypunct_bynameIwLb0EED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211972 + 8;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 52 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 40 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb1EED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211916 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb0EED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211860 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN7mecanim9reflectorILj8EE7reflectEh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 << 7 & 255;
 i2 = (i1 & 2) == 0 ? i2 : (i2 & 255 | 64) & 255;
 i2 = (i1 & 4) == 0 ? i2 : (i2 & 255 | 32) & 255;
 i2 = (i1 & 8) == 0 ? i2 : (i2 & 255 | 16) & 255;
 i2 = (i1 & 16) == 0 ? i2 : (i2 & 255 | 8) & 255;
 i2 = (i1 & 32) == 0 ? i2 : (i2 & 255 | 4) & 255;
 i2 = (i1 & 64) == 0 ? i2 : (i2 & 255 | 2) & 255;
 return (i1 << 24 >> 24 > -1 ? i2 : (i2 & 255 | 1) & 255) | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148188 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx2Sc10NPhaseCore30processPersistentContactEventsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 while (1) {
  i1 = i1 + -1 | 0;
  i2 = HEAP32[i4 >> 2] | 0;
  i3 = (i1 | 0) == 0;
  if ((HEAP32[i2 + 44 >> 2] & 1032 | 0) == 1032) __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj(i2, 8, 0, 0, 0);
  if (i3) break; else i4 = i4 + 4 | 0;
 }
 return;
}

function __ZN5physx15PxVehicleWheels15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 44 | 0;
 i5 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i3 >> 2] | 0) | 0;
 i4 = i1 + 4 | 0;
 i1 = (HEAP32[i4 >> 2] | 0) + 15 & -16;
 HEAP32[i4 >> 2] = i1 + i5;
 __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i2, i1, HEAP32[i3 >> 2] | 0, HEAP32[i2 + 48 >> 2] | 0, 0) | 0;
 return;
}

function __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f3, i4, i2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAPF32[i6 >> 2] = f3;
 i4 = __ZL23setMassAndUpdateInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(0, i1, i6, 1, i4, i2) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z44DownloadHandlerBuffer_CUSTOM_InternalGetDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZL20InternalGetByteArrayPK15DownloadHandler(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1027732 | 0, i2);
 return 0;
}

function __Z37GUIStyle_Set_Custom_PropStretchHeightP12Il2CppObjecth(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 << 24 >> 24 != 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP8[i1 + 293 >> 0] = i3 & 1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z27Object_CUSTOM_DestroyObjectP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i1) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN9Scripting26DestroyObjectFromScriptingE4PPtrI6ObjectEf(i4, f2);
 STACKTOP = i3;
 return;
}

function __Z25WWW_Get_Custom_PropIsDoneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) & 1;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 580303 | 0, i2);
 return 0;
}

function __Z25Caching_CUSTOM_CleanCachev() {
 var i1 = 0;
 if ((__ZN14CachingManager21GetAuthorizationLevelEv(__Z17GetCachingManagerv() | 0) | 0) > 0) {
  i1 = (__ZN5Cache10CleanCacheEv(__ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0) | 0) & 1;
  return i1 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 501688 | 0, 0, gb + 501721 | 0, 47, 1, 0, 0, 0);
  i1 = 0;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_png_set_bKGD(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0 | (i3 | 0) == 0) return;
 i1 = i2 + 162 | 0;
 HEAP16[i1 >> 1] = HEAP16[i3 >> 1] | 0;
 HEAP16[i1 + 2 >> 1] = HEAP16[i3 + 2 >> 1] | 0;
 HEAP16[i1 + 4 >> 1] = HEAP16[i3 + 4 >> 1] | 0;
 HEAP16[i1 + 6 >> 1] = HEAP16[i3 + 6 >> 1] | 0;
 HEAP16[i1 + 8 >> 1] = HEAP16[i3 + 8 >> 1] | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 32;
 return;
}

function _tt_cmap4_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 HEAP32[i3 >> 2] = i2;
 do if (i2 >>> 0 > 65535) i1 = 0; else if (!(HEAP32[i1 + 20 >> 2] & 1)) {
  i1 = _tt_cmap4_char_map_binary(i1, i3, 0) | 0;
  break;
 } else {
  i1 = _tt_cmap4_char_map_linear(i1, i3, 0) | 0;
  break;
 } while (0);
 STACKTOP = i4;
 return i1 | 0;
}

function __Znwj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (i1 | 0) == 0 ? 1 : i1;
 while (1) {
  i3 = _malloc(i2) | 0;
  if (i3 | 0) {
   i1 = 6;
   break;
  }
  i1 = __ZSt15get_new_handlerv() | 0;
  if (!i1) {
   i1 = 5;
   break;
  }
  mftCall_v(i1 | 0);
 }
 if ((i1 | 0) == 5) {
  i3 = ___cxa_allocate_exception(4) | 0;
  __ZNSt9bad_allocC2Ev(i3);
  ___cxa_throw(i3 | 0, gb + 13048 | 0, fb + 3215 | 0);
 } else if ((i1 | 0) == 6) return i3 | 0;
 return 0;
}

function __ZZ19InitializeGfxDevicejEN38PreLateUpdateEndGraphicsJobsLatestruct7ForwardEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1157628 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 884 >> 2] | 0, i1 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0);
 i1 = __ZN10DynamicVBO9NextFrameEv() | 0;
 i2 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 512 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 i3 = i1 + 80 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26locale8__globalEv() {
 var i1 = 0;
 do if (!(HEAP8[gb + 1100448 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100448 | 0) | 0) {
  __THREW__ = 0;
  invoke_i(fb + 321 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else {
   HEAP32[gb + 1476396 >> 2] = gb + 1476392;
   break;
  }
 } while (0);
 return HEAP32[gb + 1476396 >> 2] | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 209072 + 12;
 HEAP32[i1 + 12 >> 2] = gb + 209072 + 32;
 HEAP32[i1 + 4 >> 2] = 0;
 __ZNSt3__28ios_base4initEPv(i1 + 12 | 0, i2);
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = -1;
 HEAP32[i1 >> 2] = gb + 208984 + 12;
 HEAP32[i1 + 12 >> 2] = gb + 208984 + 52;
 HEAP32[i1 + 8 >> 2] = gb + 208984 + 32;
 return;
}

function __ZNK5physx3Ext7D6Joint8getDriveENS_9PxD6Drive4EnumE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = HEAP32[i3 + 80 >> 2] | 0;
 i6 = i4 + 176 + (i2 << 4) | 0;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i3 + 4 >> 2] = i5;
 i3 = HEAP32[i4 + 176 + (i2 << 4) + 8 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i4 + 176 + (i2 << 4) + 12 >> 2];
 HEAP32[i1 + 8 >> 2] = i3;
 return;
}

function __ZN9Animation18CleanupBoundCurvesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 84 | 0;
 i3 = i1 + 96 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i4 = i1 + 100 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 88 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i4 = i1 + 252 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
 return;
}

function __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i3 = i2 + 100 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) i5 = 3; else if (!(HEAP32[i1 + 8 >> 2] | 0)) i5 = 3;
 if ((i5 | 0) == 3) {
  __ZN8Material15BuildPropertiesEv(i2);
  i1 = HEAP32[i3 >> 2] | 0;
 }
 return __ZNK19ShaderPropertySheet11HasPropertyERKN9ShaderLab16FastPropertyNameE(i1 + 12 | 0, i4) | 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB565EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP16[i4 >> 1] = i3 >>> 27 | i3 & 63488 | i3 >>> 13 & 2016;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx2Sc18ParticleSystemCore23setRestParticleDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0, f4 = f0, i5 = 0;
 f3 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 i5 = i2 + 52 | 0;
 f4 = Math_fround(f3 * Math_fround(HEAPF32[i5 >> 2]));
 i2 = i2 + 76 | 0;
 f4 = Math_fround(f4 * Math_fround(1 << HEAP32[i2 >> 2] >>> 0));
 HEAPF32[i5 >> 2] = f1;
 HEAP32[i2 >> 2] = __Z25computePacketSizeMultLog2ff(f4, Math_fround(f3 * f1)) | 0;
 return;
}

function __ZN21RotationBySpeedModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 804 >> 2]) + Math_fround(.00100000005));
 HEAPF32[i3 >> 2] = f5;
 i1 = i1 + 808 | 0;
 i4 = f5 < Math_fround(HEAPF32[i1 >> 2]);
 HEAP32[i1 >> 2] = HEAP32[(i4 ? i1 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN21DownloadHandlerScriptD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 187584 + 8;
 i2 = i1 + 56 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __Z23scripting_gchandle_freej(i3);
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 + 52 >> 2] = 0;
  HEAP32[i1 + 60 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN21DownloadHandlerScriptD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 187584 + 8;
 i1 = i3 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
  HEAP32[i3 + 52 >> 2] = 0;
  HEAP32[i3 + 60 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = gb + 187368 + 8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 __Z23scripting_gchandle_freej(i1);
 __ZdlPv(i3);
 return;
}

function __ZN20ArchiveStorageHeader26CanReadHeaderAndBlocksInfoERKNS_6HeaderE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i2 = i3 << 24 >> 24 < 0;
 if (((i2 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255) | 0) != 8) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489810 | 0, 8) | 0)) {
  i3 = 1;
  return i3 | 0;
 }
 i3 = (_memcmp(i2 ? HEAP32[i1 >> 2] | 0 : i1, gb + 489801 | 0, 8) | 0) == 0;
 return i3 | 0;
}

function __ZN10RectOffset8TransferI9JSONWriteEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1, gb + 1033960 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 4 | 0, gb + 1033967 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 8 | 0, gb + 1033975 | 0, 0);
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i1 + 12 | 0, gb + 1033981 | 0, 0);
 return;
}

function __ZN10Effector2D19FindContactGroupEndEPKNS_15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i3 = (HEAP32[i1 + 36 >> 2] | 0) + ((HEAP32[i1 + 48 >> 2] | 0) * 40 | 0) | 0;
 while (1) {
  i1 = i2 + 40 | 0;
  if ((i1 | 0) == (i3 | 0)) {
   i1 = 4;
   break;
  }
  if ((HEAP32[i2 + 56 >> 2] | 0) == (i4 | 0)) i2 = i1; else {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return i2 | 0;
 return 0;
}

function __ZL32StaticInitializeIUnityInterfacesPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63168 | 0, 16, gb + 460922 | 0, 34) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1163148 >> 2] = i1;
 HEAP32[gb + 1163140 >> 2] = fb + 1578;
 HEAP32[gb + 1163140 + 4 >> 2] = fb + 2754;
 return;
}

function __Z42AnimationCurve_Get_Custom_PropPostWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZNK17AnimationCurveTplIfE15GetPostInfinityEv(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z41Material_CUSTOM_Internal_CreateWithShaderP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i2, __ZN8Material14CreateMaterialER6Shaderib(i3, 0, 1) | 0) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUIStyle_Set_Custom_PropStretchWidthP12Il2CppObjecth(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 << 24 >> 24 != 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP8[i1 + 292 >> 0] = i3 & 1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z29Event_Get_Custom_PropPressureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
   STACKTOP = i3;
   return Math_fround(f4);
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return Math_fround(0.0);
}

function mftCall_iiiiiifii(i9, i1, i2, i3, i4, i5, d6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiifii[i9 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, Math_fround(d6), i7 | 0, i8 | 0) | 0;
 return ftCall_iiiiiifii(i9 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6, i7 | 0, i8 | 0) | 0;
}

function mftCall_iiiifiiii(i9, i1, i2, i3, d4, i5, i6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifiiii[i9 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 return ftCall_iiiifiiii(i9 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function _stbir_resize_uint8(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(0, i1, i2, i3, i4, i5, i6, i7, i8, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i9, -1, 0, 0, 0, 0, 1, 1, 0) | 0;
}

function _stbir_resize_float(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace(0, i1, i2, i3, i4, i5, i6, i7, i8, Math_fround(0.0), Math_fround(0.0), Math_fround(1.0), Math_fround(1.0), 0, i9, -1, 0, 3, 0, 0, 1, 1, 0) | 0;
}

function __ZThn8_N5physx2Gu12TriangleMeshD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + -8 | 0;
 HEAP32[i3 >> 2] = gb + 107420 + 8;
 HEAP32[i1 >> 2] = gb + 107420 + 88;
 i1 = i1 + 8 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i1);
 __ZN5physx20InternalTriangleMeshD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i3);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26locale7classicEv() {
 var i1 = 0;
 do if (!(HEAP8[gb + 1100280 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100280 | 0) | 0) {
  __THREW__ = 0;
  invoke_i(fb + 320 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else {
   HEAP32[gb + 1476388 >> 2] = gb + 1476384;
   break;
  }
 } while (0);
 return HEAP32[gb + 1476388 >> 2] | 0;
}

function __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EE4seedEj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 HEAP32[i3 >> 2] = i1;
 i2 = 1;
 while (1) {
  if ((i2 | 0) == 624) break;
  i4 = (Math_imul(i1 >>> 30 ^ i1, 1812433253) | 0) + i2 | 0;
  HEAP32[i3 + (i2 << 2) >> 2] = i4;
  i2 = i2 + 1 | 0;
  i1 = i4;
 }
 HEAP32[i3 + 2496 >> 2] = 0;
 return;
}

function __ZNK14SoundHandleAPI13GetMemoryInfoEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 if (i1) {
  i2 = i3;
  i1 = 0;
  do {
   i1 = (__ZNK11SoundHandle8Instance21GetMemoryInfoInternalEb(i2, 0) | 0) + i1 | 0;
   i2 = HEAP32[i2 + 108 >> 2] | 0;
  } while ((i2 | 0) != (i3 | 0));
  return i1 | 0;
 } else {
  i3 = __ZNK11SoundHandle8Instance21GetMemoryInfoInternalEb(i3, 0) | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZN9Scripting9GetMethodEPKcS1_S1_S1_(i4, i1, i2, i3, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = __Z29scripting_class_from_fullnamePKcS0_S0_(i1, i2, i3) | 0;
 if (!i1) {
  i2 = gb + 1164176 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  return;
 } else {
  __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i4, i1, i5, -1);
  return;
 }
}

function __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB4444EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP16[i4 >> 1] = i3 & 240 | i3 >>> 4 | i3 << 4 & 3840 | 61440;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148476 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i3, i5) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 8 | 0;
 i4 = HEAP16[i1 >> 1] | 0;
 i2 = HEAP16[i5 >> 1] | 0;
 if (i2 << 16 >> 16 == i4 << 16 >> 16) return;
 HEAP16[i1 >> 1] = i2;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i4 & 65535 | 0, HEAPU16[i5 >> 1] | 0 | 0);
 return;
}

function __ZN5physx11NpAggregateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 90184 + 8;
 __ZN5physx9NpFactory18onAggregateReleaseEPNS_11PxAggregateE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 40 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5Unity5Cloth15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 228 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 84 >> 2] | 0, i3 | 0) | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0);
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 + 240 >> 2] = 0;
 HEAP32[i1 + 244 >> 2] = 0;
 return;
}

function __ZN37InheritVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (i3 | 0) return;
 __ZN14ParticleSystem8SyncJobsEb(1);
 i3 = HEAP32[i2 + 872 >> 2] | 0;
 HEAPF32[i3 + 92 >> 2] = f4;
 HEAP8[i3 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i3 + 12 | 0, i3 + 100 | 0, f4, HEAP16[i3 + 96 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN2UI14CanvasRenderer11SetMaterialEP8Materiali(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(__ZN2UI14CanvasRenderer17SetMaterialNoSyncEP8MaterialiR13dynamic_arrayI4PPtrIS1_ELj4EE(i1, i2, i3, i1 + 96 | 0) | 0)) return;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2056;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN15b2ContactFilter13ShouldCollideEP9b2FixtureS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP16[i2 + 56 >> 1] | 0;
 if (!(i1 << 16 >> 16 == 0 ? 1 : i1 << 16 >> 16 != (HEAP16[i3 + 56 >> 1] | 0))) {
  i3 = i1 << 16 >> 16 > 0;
  return i3 | 0;
 }
 if (!((HEAP16[i3 + 52 >> 1] & HEAP16[i2 + 54 >> 1]) << 16 >> 16)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP16[i3 + 54 >> 1] & HEAP16[i2 + 52 >> 1]) << 16 >> 16 != 0;
 return i3 | 0;
}

function __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i2, HEAP32[i2 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10InputEvent4InitEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 11;
 i3 = i1 + 20 | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = i2;
 HEAP8[i1 + 48 >> 0] = 0;
 return;
}

function __Z48AudioReverbZone_Set_Custom_PropRoomRolloffFactorP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 104 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_FT_Get_Charmap_Index(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 L1 : do if (!i3) i1 = -1; else {
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) i1 = -1; else {
   i4 = HEAP32[i1 + 36 >> 2] | 0;
   if ((i4 | 0) > 0) {
    i2 = HEAP32[i1 + 40 >> 2] | 0;
    i1 = 0;
    do {
     if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) break L1;
     i1 = i1 + 1 | 0;
    } while ((i1 | 0) < (i4 | 0));
   } else i1 = 0;
  }
 } while (0);
 return i1 | 0;
}

function mftCall_iiiiiiiii(i9, i1, i2, i3, i4, i5, i6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 63 | 0)) return FUNCTION_TABLE_iiiiiiiii[i9 - fb & 63](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 return ftCall_iiiiiiiii(i9 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function _newlocale(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 if (!(HEAP8[i3 >> 0] | 0)) i4 = 4; else if (!(_strcmp(i3, gb + 1083663 | 0) | 0)) i4 = 4; else if (!(_strcmp(i3, gb + 1073759 | 0) | 0)) i4 = 4; else i1 = 0;
 do if ((i4 | 0) == 4) if (!i1) if (!(HEAP32[gb + 1469692 >> 2] | 0)) {
  HEAP32[gb + 1469692 >> 2] = 1;
  i1 = gb + 1469696 | 0;
  break;
 } else {
  i1 = _calloc(1, 4) | 0;
  break;
 } while (0);
 return i1 | 0;
}

function _jpeg_std_error(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 3288;
 HEAP32[i1 + 4 >> 2] = fb + 2369;
 HEAP32[i1 + 8 >> 2] = fb + 3289;
 HEAP32[i1 + 12 >> 2] = fb + 490;
 HEAP32[i1 + 16 >> 2] = fb + 3290;
 HEAP32[i1 + 104 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 112 >> 2] = gb + 14912;
 HEAP32[i1 + 116 >> 2] = 124;
 HEAP32[i1 + 120 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9sputbackcEw(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i3 + 12 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) == (i2 | 0)) i5 = 3; else {
  i2 = i2 + -4 | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) HEAP32[i4 >> 2] = i2; else i5 = 3;
 }
 if ((i5 | 0) == 3) i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 44 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwERKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i3 + (HEAP32[i2 + 4 >> 2] << 2) | 0);
 return;
}

function __ZNK4crnd25static_huffman_data_model26compute_decoder_table_bitsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 >>> 0 > 16) {
  i1 = i3;
  i2 = 0;
 } else {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  i4 = i2 + 1 | 0;
  if (i1 >>> 0 > 3) {
   i1 = i1 >>> 1;
   i2 = i4;
  } else break;
 }
 i4 = i2 + 2 + ((i4 | 0) != 32 & 1 << i4 >>> 0 < i3 >>> 0 & 1) | 0;
 i4 = (i4 >>> 0 < 11 ? i4 : 11) & 255;
 return i4 | 0;
}

function __ZNK13AnimationClip15GetAverageSpeedEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 216 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
  return;
 } else {
  HEAP32[i2 >> 2] = HEAP32[i1 + 1048 >> 2];
  HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 1052 >> 2];
  HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 1056 >> 2];
  return;
 }
}

function __ZNK12AudioManager14GetRealDSPTimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 4 | 0;
 i2 = i4;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
 } else {
  __ZN4FMOD6System11getDSPClockEPjS1_(i1, i2, i3) | 0;
  i2 = HEAP32[i2 >> 2] | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 setTempRet0(i2 | 0);
 STACKTOP = i4;
 return i1 | 0;
}

function __ZN7mecanim9animation18CreateConstantClipERNS0_12ConstantClipEjRNS_6memory9AllocatorE(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0, i5 = 0;
 HEAP32[i1 >> 2] = i4;
 i5 = i1 + 4 | 0;
 if (!i4) i1 = 0; else {
  i3 = i4 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i4 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i5 >> 2] = i1 | 0 ? i1 - i5 | 0 : 0;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15createParticlesERKNS_22PxParticleCreationDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 24 >> 2] & 32768)) __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i2 + 32 | 0) | 0;
 i2 = __ZN5physx3Scb14ParticleSystem15createParticlesERKNS_22PxParticleCreationDataE(i2 + 20 | 0, i1) | 0;
 return i2 | 0;
}

function __ZN18ColorBySpeedModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i1 + 164 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 168 >> 2]) + Math_fround(-.00100000005));
 HEAPF32[i4 >> 2] = f5;
 i1 = f5 < Math_fround(HEAPF32[i3 >> 2]);
 HEAP32[i3 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i1 = 0;
 do {
  i4 = HEAP32[i3 + (i1 * 20 | 0) >> 2] | 0;
  i5 = HEAP32[i3 + (i1 * 20 | 0) + 12 >> 2] | 0;
  if (i5 | 0) {
   i2 = 0;
   do {
    __ZN6Object24RegisterInstanceIDNoLockEPS_(HEAP32[i4 + (i2 * 12 | 0) >> 2] | 0);
    i2 = i2 + 1 | 0;
   } while ((i2 | 0) != (i5 | 0));
  }
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 14);
 return;
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE8ValidateEPS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459872 + (i2 >>> 28 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 260 >> 2] | 0) + ((i2 >>> 16 & 4095) << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i1 + 16 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 12 >> 2] | 0) == (i2 & 65535 | 0) ? i1 : 0;
 return i2 | 0;
}

function __ZL29StaticCleanupIUnityInterfacesPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1163148 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63168 | 0);
 HEAP32[gb + 1163148 >> 2] = 0;
 return;
}

function __Z43Material_CUSTOM_Internal_CreateWithMaterialP12Il2CppObjectS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i2, __ZN8Material14CreateMaterialERKS_ib(i3, 0, 1) | 0) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AnimationCurve_Get_Custom_PropPreWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __ZNK17AnimationCurveTplIfE14GetPreInfinityEv(i1) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z31Input_CUSTOM_GetMouseButtonDowni(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 >>> 0 < 7) {
  i1 = i1 + 323 | 0;
  i1 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 68 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  STACKTOP = i2;
  return i1 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536733 | 0, i2);
 return 0;
}

function __Z18Transfer_BlittableI8JSONReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferI4AABBEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function _UNITY_ft_synthesize_vertical_metrics(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = (i3 | 0) < 0 ? ((i4 | 0) < (i3 | 0) ? i3 : i4) : i4 - i3 | 0;
 i2 = (i2 | 0) == 0 ? (i3 * 12 | 0) / 10 | 0 : i2;
 HEAP32[i1 + 20 >> 2] = (HEAP32[i1 + 8 >> 2] | 0) - ((HEAP32[i1 + 16 >> 2] | 0) / 2 | 0);
 HEAP32[i1 + 24 >> 2] = (i2 - i3 | 0) / 2 | 0;
 HEAP32[i1 + 28 >> 2] = i2;
 return;
}

function _fchownat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = i5;
 i5 = ___syscall_ret(___syscall298(298, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8pubimbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0);
 i1 = i1 + 4 | 0;
 __ZNSt3__26localeC2ERKS0_(i4, i1);
 __ZNSt3__26localeaSERKS0_(i1, i2) | 0;
 STACKTOP = i3;
 return HEAP32[i4 >> 2] | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8pubimbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0);
 i1 = i1 + 4 | 0;
 __ZNSt3__26localeC2ERKS0_(i4, i1);
 __ZNSt3__26localeaSERKS0_(i1, i2) | 0;
 STACKTOP = i3;
 return HEAP32[i4 >> 2] | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcERKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i3 + (HEAP32[i2 + 4 >> 2] | 0) | 0);
 return;
}

function __ZN7ApiGLES13DeleteProgramERj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 switch (i1 | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 i2 = i3 + 868 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 + 872 >> 2] = 0;
  mftCall_vi(HEAP32[i3 + 516 >> 2] | 0, 0);
  i1 = HEAP32[i4 >> 2] | 0;
 }
 mftCall_vi(HEAP32[i3 + 508 >> 2] | 0, i1 | 0);
 HEAP32[i4 >> 2] = -1;
 return;
}

function __ZN6Object8AddEventEPFvPvS0_iES0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i1 = i1 + 12 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i4 = __ZN10MemoryPool8AllocateEv(HEAP32[gb + 1104268 >> 2] | 0) | 0;
 i6 = i4 + 8 | 0;
 i7 = i6;
 HEAP32[i7 >> 2] = 0;
 HEAP32[i7 + 4 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 1;
 HEAP32[i4 >> 2] = i3;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i4;
 return;
}

function __ZN5physx30solveExtFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i5, i4, i1, i2, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i5) return; else i1 = 0;
 do {
  __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx2Sn13XmlNodeReader9gotoChildEPKc(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i1 + 12 | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 while (1) {
  if (!(_strcasecmp(HEAP32[i1 >> 2] | 0, i3) | 0)) break;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i4 = 5;
   break;
  }
 }
 if ((i4 | 0) == 5) return i1 | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = 1;
 return i4 | 0;
}

function __ZN5physx2Sc5Scene26setVisualizationCullingBoxERKNS_9PxBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 HEAP32[i2 + 6136 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 6140 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 6144 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 6148 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 6152 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 6156 >> 2] = HEAP32[i1 + 20 >> 2];
 return;
}

function __ZN5physx2Sc18ParticleSystemCore18addDeltaVelocitiesERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef(i2, i4, i3, f5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiif(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0, +f5);
 return;
}

function __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 80 | 0, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 84 | 0, 0);
 return;
}

function __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 80 | 0, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 84 | 0, 0);
 return;
}

function __ZN17SizeBySpeedModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, f5 = f0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i1 + 800 | 0;
 f5 = Math_fround(Math_fround(HEAPF32[i1 + 804 >> 2]) + Math_fround(-.00100000005));
 HEAPF32[i4 >> 2] = f5;
 i1 = f5 < Math_fround(HEAPF32[i3 >> 2]);
 HEAP32[i3 >> 2] = HEAP32[(i1 ? i4 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN14RedirectHelper10OnRedirectEl(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 L1 : do if ((i1 + -300 | 0) >>> 0 < 8) {
  switch (i1 | 0) {
  case 304:
  case 306:
   {
    i1 = 0;
    break L1;
   }
  default:
   {}
  }
  i1 = i2 + 4 | 0;
  i3 = (HEAP32[i1 >> 2] | 0) + 1 | 0;
  HEAP32[i1 >> 2] = i3;
  i1 = HEAP32[i2 >> 2] | 0;
  if ((i1 | 0) == -1) i1 = 0; else i1 = i3 >>> 0 <= i1 >>> 0 ? 0 : 18;
 } else i1 = 0; while (0);
 return i1 | 0;
}

function __Z47AudioReverbZone_Set_Custom_PropReflectionsDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 84 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_CUSTOM_SetSplatMaterialPropertyBlockP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   if (!i2) i1 = 0; else i1 = HEAP32[i2 + 8 >> 2] | 0;
   __ZN7Terrain28CopySplatMaterialCustomPropsEPK19ShaderPropertySheet(i3, i1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __ZNK5physx2Sq8AABBTree12computeDepthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i4 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_(i1, i1, i3, i4, 0, 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZN7Joint2D7CleanupEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i3 + 60 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP8[i3 + 52 >> 0] = 0;
 __ZN7b2World12DestroyJointEP7b2Joint(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 if (__Z14IsWorldPlayingv() | 0) return;
 __ZN16b2ContactManager20FlushPendingContactsEv((HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0) + 102872 | 0);
 return;
}

function __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB565EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP16[i4 >> 1] = i3 << 8 & 63488 | i3 >>> 3 | i3 << 3 & 2016;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 150768 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx5cloth12horizontalOrE8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 4 | 0;
 i4 = i3;
 HEAP32[i5 >> 2] = HEAP32[i2 + 4 >> 2] | HEAP32[i2 >> 2] | HEAP32[i2 + 8 >> 2] | HEAP32[i2 + 12 >> 2];
 HEAP32[i4 >> 2] = __Z6simd4iRKi(i5) | 0;
 __ZNK13Simd4iFactoryIRKiEcv8Scalar4fEv(i1, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore16setContactOffsetEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15createParticlesERKNS_22PxParticleCreationDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 24 >> 2] & 32768)) __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i2 + 32 | 0) | 0;
 i2 = __ZN5physx3Scb14ParticleSystem15createParticlesERKNS_22PxParticleCreationDataE(i2 + 20 | 0, i1) | 0;
 return i2 | 0;
}

function __ZN5physx10NpMaterial14onRefCountZeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!(HEAP16[i2 + 6 >> 1] & 1)) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0); else __ZN5physx9NpFactory21releaseMaterialToPoolERNS_10NpMaterialE(HEAP32[gb + 1457204 >> 2] | 0, i2);
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, i1, 2);
 return;
}

function __ZN5Umbra9Matrix2x29transposeERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) == (i1 | 0)) {
  i3 = i2 + 4 | 0;
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = i2 + 8 | 0;
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  return;
 }
}

function __ZN5FlareD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 32876 + 8;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 36 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -32 - i3 | 0) >>> 5) << 5);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN2UI6Canvas18UpdateEventIndexesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = HEAP32[i1 + 344 >> 2] | 0;
 if (i3 | 0) if (!(HEAP8[i1 + 375 >> 0] | 0)) {
  __ZN2UI6Canvas18UpdateEventIndexesEv(i3);
  STACKTOP = i4;
  return;
 }
 HEAP32[i2 >> 2] = 0;
 __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi(i1, i2);
 STACKTOP = i4;
 return;
}

function __ZN12AudioManager18BeforeDomainUnloadEv() {
 var i1 = 0, i2 = 0;
 if (!(__Z24GetManagerPtrFromContexti(3) | 0)) return;
 if (!(HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 296 >> 2] | 0)) return;
 i2 = (__Z21GetManagerFromContexti(3) | 0) + 296 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(28) | 0;
  __ZN24AudioScriptBufferManagerC2Ev(i1);
  HEAP32[i2 >> 2] = i1;
 }
 __ZN24AudioScriptBufferManager18BeforeDomainReloadEv(i1);
 return;
}

function __ZN10GUITexture5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 56 >> 2] = 1056964608;
 HEAP32[i1 + 60 >> 2] = 1056964608;
 HEAP32[i1 + 64 >> 2] = 1056964608;
 HEAP32[i1 + 68 >> 2] = 1056964608;
 i2 = i1 + 36 | 0;
 i1 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __Z54LightProbeProxyVolume_Set_Custom_PropProbePositionModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 88 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AnimationState_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN14AnimationState10SetEnabledEb(i1, i2 << 24 >> 24 != 0);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z32GUIStyle_Set_Custom_PropWordWrapP12Il2CppObjecth(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 << 24 >> 24 != 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP8[i1 + 248 >> 0] = i3 & 1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z32GUIStyle_Set_Custom_PropRichTextP12Il2CppObjecth(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 << 24 >> 24 != 0;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP8[i1 + 249 >> 0] = i3 & 1;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z29Input_CUSTOM_GetMouseButtonUpi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 >>> 0 < 7) {
  i1 = i1 + 323 | 0;
  i1 = (HEAP32[(HEAP32[(__Z15GetInputManagerv() | 0) + 88 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] & 1 << (i1 & 31) | 0) != 0 & 1;
  STACKTOP = i2;
  return i1 | 0;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 536733 | 0, i2);
 return 0;
}

function __Z22scripting_array_new_3dP11Il2CppClassjjjj(i2, i1, i3, i4, i5) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 HEAP32[i6 >> 2] = i3;
 HEAP32[i6 + 4 >> 2] = i4;
 HEAP32[i6 + 8 >> 2] = i5;
 i5 = _il2cpp_array_new_full(_il2cpp_array_class_get(i2 | 0, 3) | 0, i6 | 0, 0) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function __Z18Transfer_BlittableI9JSONWriteLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferI4AABBEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18ActivateGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 __ZN10GameObject8ActivateEv(i1);
 return;
}

function __Z11loadAlignedPKfj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4 + 8 | 0;
 i6 = i4;
 __ZN6detail13OffsetPointerIfEC2EPKfj(i6, i3, i2);
 HEAP32[i5 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i5 + 4 >> 2] = HEAP32[i6 + 4 >> 2];
 __ZN13Simd4fFactoryIN6detail13OffsetPointerIfEEEC2ES2_(i1, i5);
 STACKTOP = i4;
 return;
}

function _select(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = i5;
 i5 = ___syscall_ret(___syscall142(142, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function _linkat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i7 = i6;
 HEAP32[i7 >> 2] = i1;
 HEAP32[i7 + 4 >> 2] = i2;
 HEAP32[i7 + 8 >> 2] = i3;
 HEAP32[i7 + 12 >> 2] = i4;
 HEAP32[i7 + 16 >> 2] = i5;
 i5 = ___syscall_ret(___syscall303(303, i7 | 0) | 0) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function _cf2_stack_popInt(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 392 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (i1 + 8 | 0)) {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 161);
  i4 = 0;
  return i4 | 0;
 }
 i4 = i3 + -8 | 0;
 if ((HEAP32[i3 + -4 >> 2] | 0) == 2) {
  HEAP32[i2 >> 2] = i4;
  i4 = HEAP32[i4 >> 2] | 0;
  return i4 | 0;
 } else {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 160);
  i4 = 0;
  return i4 | 0;
 }
 return 0;
}

function __ZThn24_N5physx2Sc21ConstraintInteraction11updateStateEb(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -24 | 0;
 i3 = i2 + 30 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 & 2)) {
  i4 = i2 + 28 | 0;
  HEAP16[i4 >> 1] = 0;
  return;
 }
 if (i4) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i2 + 24 | 0);
  i1 = HEAP16[i3 >> 1] | 0;
 }
 HEAP16[i3 >> 1] = i1 & 65533;
 i4 = i2 + 28 | 0;
 HEAP16[i4 >> 1] = 0;
 return;
}

function __ZN5physx7NpShape15releaseInternalEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, HEAP32[i2 + 8 >> 2] | 0, 1);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 12 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f2, i4, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAPF32[i6 >> 2] = f2;
 i4 = __ZL20updateMassAndInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(0, i1, i6, 1, i4, i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN4FMOD8ChannelI13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i9 = i1;
 HEAP32[i9 >> 2] = 78;
 HEAP32[i9 + 4 >> 2] = gb + 868616;
 _printf(gb + 857490 | 0, i9) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17ProfilerFrameData15AllocTimerQueryEv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[gb + 1163260 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = __Z12GetGfxDevicev() | 0;
  i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 660 >> 2] | 0, i3 | 0) | 0;
  return i3 | 0;
 } else {
  i4 = i3 + -1 | 0;
  i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i4 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  return i3 | 0;
 }
 return 0;
}

function __ZN14RenderSettings19SetCustomReflectionEP7Cubemap(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = i2 + 380 | 0;
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[gb + 1112272 >> 2] | 0;
 i3 = HEAP32[i2 + 364 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[((HEAP32[i2 + 368 >> 2] | 0) == 0 ? i2 + 384 | 0 : i4) >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i1);
 return;
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 160 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags(i2, i1 + 160 | 0, 0);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TextRendering4Font15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 i3 = i1 + 48 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 __ZNK6Object14GetMemoryLabelEv(i2, i1);
 if (i4 | 0) __ZN20TextRenderingPrivate8FontImplD2Ev(i4);
 __Z19free_alloc_internalPvRK10MemLabelId(i4, i2);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i5;
 return;
}

function __ZN11ColorModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 i1 = i1 + 8 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, gb + 620164 | 0, gb + 620954 | 0, i1, 0);
 __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z42AnimationCurve_Set_Custom_PropPostWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN17AnimationCurveTplIfE15SetPostInfinityEi(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z33Canvas_Get_Custom_PropScaleFactorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2;
   while (1) {
    i2 = HEAP32[i1 + 344 >> 2] | 0;
    if (!i2) break; else i1 = i2;
   }
   return Math_fround(HEAPF32[i1 + 352 >> 2]);
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28Scene_CUSTOM_GetPathInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i4 = i1 + 12 | 0;
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i1 + 16 >> 2] | 0 : i2 & 255) | 0;
 return i2 | 0;
}

function __Z28Scene_CUSTOM_GetNameInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i4 = i1 + 28 | 0;
 i2 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 i2 = __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i1 + 32 >> 2] | 0 : i2 & 255) | 0;
 return i2 | 0;
}

function __Z21Object_CUSTOM_DestroyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i1) | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN9Scripting26DestroyObjectFromScriptingE4PPtrI6ObjectEf(i4, f2);
 STACKTOP = i3;
 return;
}

function __Z13free_internalPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) {
  __ZN13MemoryManager10DeallocateEPv(i1, i2);
  return;
 }
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i3 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i3;
 if (i3 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i3 = i1;
 __ZN13MemoryManager10DeallocateEPv(i3, i2);
 return;
}

function __ZZN15NavMeshObstacle15InitializeClassEvEN32FunctorImpl_206kTransformChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (i1 & 1 | 0) {
  i2 = i3 + 136 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 }
 if (i1 & 2 | 0) {
  i2 = i3 + 136 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 2;
 }
 if (!(i1 & 8)) return;
 i3 = i3 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEES9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = i5 - i4 >> 2;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i1, i2, (HEAP32[i3 >> 2] | 0) - i5 >> 2) | 0;
 return i4 + (i2 << 2) | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148460 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaNERKS4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3 + 16 | 0;
 i4 = i3;
 __ZanRK8Scalar4fS1_(i5, i2, i1);
 __ZN8Scalar4faSERKS_(i2, i5) | 0;
 i5 = i2 + 16 | 0;
 __ZanRK8Scalar4fS1_(i4, i5, i1 + 16 | 0);
 __ZN8Scalar4faSERKS_(i5, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore16setContactOffsetEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx15PxSerialization21createBinaryConverterEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 i1 = _PxGetFoundation() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_iiiiii(i3 | 0, i2 | 0, 364, (i1 ? gb + 746970 | 0 : gb + 837976 | 0) | 0, gb + 745680 | 0, 430) | 0;
 __ZN5physx2Sn5ConvXC2Ev(i1);
 return i1 | 0;
}

function __ZN5Umbra11ArrayMapper5fetchEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 + 20 >> 2] | 0;
 i4 = Math_imul(i5, HEAP32[i1 + 24 >> 2] | 0) | 0;
 i3 = Math_imul(i4, i2) | 0;
 i5 = (Math_imul(HEAP32[i1 + 32 >> 2] | 0, i5) | 0) + 15 & -16;
 i4 = i3 + i4 | 0;
 _memcpy(HEAP32[i1 + 4 >> 2] | 0, (HEAP32[i1 + 8 >> 2] | 0) + i3 | 0, (i5 >>> 0 <= i4 >>> 0 ? i5 : i4) - i3 | 0) | 0;
 HEAP32[i1 + 28 >> 2] = i2;
 return;
}

function __ZN27AnimatorControllerParameterC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN26AnimatorControllerPlayable11ResolveHashEi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
  return;
 }
}

function __ZN20TextRenderingPrivate14DynamicFontMap13StaticDestroyEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1467884 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63392 | 0);
 HEAP32[gb + 1467884 >> 2] = 0;
 return;
}

function __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionZP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 56 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionYP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 52 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionXP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 48 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52LightProbeProxyVolume_Set_Custom_PropBoundingBoxModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 36 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42CullingGroup_CUSTOM_SetBoundingSphereCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN12CullingGroup22SetBoundingSphereCountEj(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, i2, i3, i4, i5, i6, i7, i8);
 return;
}

function __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function mftCall_viiiiiiii(i9, i1, i2, i3, i4, i5, i6, i7, i8) {
 i9 = i9 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 if ((i9 | 0) >= (fb | 0) & (i9 | 0) < (fb + 31 | 0)) {
  FUNCTION_TABLE_viiiiiiii[i9 - fb & 31](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
  return;
 }
 ftCall_viiiiiiii(i9 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function _jinit_huff_decoder(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 1, 172) | 0;
 HEAP32[i1 + 408 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 3278;
 HEAP32[i2 + 4 >> 2] = fb + 505;
 HEAP32[i2 + 56 >> 2] = 0;
 HEAP32[i2 + 40 >> 2] = 0;
 HEAP32[i2 + 60 >> 2] = 0;
 HEAP32[i2 + 44 >> 2] = 0;
 HEAP32[i2 + 64 >> 2] = 0;
 HEAP32[i2 + 48 >> 2] = 0;
 HEAP32[i2 + 68 >> 2] = 0;
 HEAP32[i2 + 52 >> 2] = 0;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getExternalAccelerationEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 256)) i1 = __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZNK14NavMeshManager11MapPositionEPyP8Vector3fRKS1_S4_RK13dtQueryFilter(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i1) {
  i6 = 0;
  return i6 | 0;
 }
 __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf(i1, i4, i5, i6, i2, i3) | 0;
 i6 = i2;
 i6 = (HEAP32[i6 >> 2] | 0) != 0 | (HEAP32[i6 + 4 >> 2] | 0) != 0;
 return i6 | 0;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  HEAPF32[i4 + 4 >> 2] = Math_fround(1.0);
  if (!i2) break; else {
   i4 = i4 + 8 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm21BeginSetPropertyValue9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE8allocateERNS3_13CollisionDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 436 | 0;
 i2 = i2 + 432 | 0;
 HEAP32[i1 >> 2] = __ZN14StackAllocatorILj16EE8allocateEj(HEAP32[i3 >> 2] | 0, HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] << 4) | 0;
 HEAP32[i1 + 4 >> 2] = __ZN14StackAllocatorILj16EE8allocateEj(HEAP32[i3 >> 2] | 0, (HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0) * 48 | 0) | 0;
 return;
}

function __ZN5physx42PxVehicleDifferential4WDataGeneratedValuesC2EPKNS_27PxVehicleDifferential4WDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx2Sc24ElementInteractionMarker7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = i1 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i1 + 16 >> 2] | 0, i2);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i2);
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN2UI6Canvas24NestedCanvasListContainsEPS0_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 424 >> 2] | 0;
 i2 = HEAP32[i2 + 428 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 4;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN15FrictionJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D5ResetEv(i1);
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 92 >> 0] = 1;
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0);
 return;
}

function __ZN13GfxDeviceGLES26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1 + 4 | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN4gles18AliasRenderSurfaceEP17RenderSurfaceGLES9TextureID(i2, i4);
 STACKTOP = i1;
 return;
}

function __ZN10Matrix3x3f11SetIdentityEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 return i1 | 0;
}

function __ZN10HumanTrait11HasColliderER6Avatari(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (i3 >>> 0 >= 24) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = (HEAP32[i1 + 56 >> 2] | 0) + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = i1 + i2 | 0;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 264 + (i3 << 2) >> 2] | 0) != -1;
 return i3 | 0;
}

function __Z51LightProbeProxyVolume_Set_Custom_PropResolutionModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 40 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43AudioReverbZone_Set_Custom_PropDecayHFRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 76 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AudioReverbZone_Set_Custom_PropLFReferenceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 100 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AnimationCurve_Set_Custom_PropPreWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN17AnimationCurveTplIfE14SetPreInfinityEi(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z31Animator_CUSTOM_PlayInFixedTimeP12Il2CppObjectiif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN8Animator20GotoStateInFixedTimeEiifff(i5, i3, i2, f4, Math_fround(0.0), Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __ZNK9Heightmap7GetSizeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0, f5 = f0;
 f5 = Math_fround(HEAPF32[i2 + 88 >> 2]);
 f5 = Math_fround(f5 * Math_fround((HEAP32[i2 + 72 >> 2] | 0) + -1 | 0));
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 f3 = Math_fround(HEAPF32[i2 + 96 >> 2]);
 f3 = Math_fround(f3 * Math_fround((HEAP32[i2 + 76 >> 2] | 0) + -1 | 0));
 HEAPF32[i1 >> 2] = f5;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fE23estimateTemporaryMemoryEPNS0_20SwInterCollisionDataEj(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 if (!i4) i1 = 0; else {
  i3 = 0;
  i1 = 0;
  do {
   i1 = (HEAP32[i2 + (i3 * 76 | 0) + 8 >> 2] | 0) + i1 | 0;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 }
 i3 = i1 << 2;
 i2 = i3 + 4096 | 0;
 return (i2 >>> 0 < i3 >>> 0 ? i3 : i2) + i3 + (i1 * 10 | 0) + (i4 * 72 | 0) | 0;
}

function __ZN5physx3Ext14SphericalJoint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 120);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZN5physx3Ext14PrismaticJoint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 112);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZN5physx2Sq17SceneQueryManager29setDynamicTreeRebuildRateHintEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i3 + 72 >> 2] = i2;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i3 + 64 >> 2] | 0) == 1) __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(i1, i2);
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i3 + 68 >> 2] | 0) != 1) return;
 __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(i1, i2);
 return;
}

function __ZN5Umbra17BasePoolAllocator9removeAllEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) do {
  i4 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i5 = HEAP32[i2 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0, i4 + -16 | 0);
 } while ((i1 | 0) != 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 return;
}

function __ZN26DownloadHandlerAssetBundle7OnAbortEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 24 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = __Z21GetAssetBundleManagerv() | 0;
  __ZN18AssetBundleManager17UnloadAssetBundleEP11AssetBundle(i3, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function __ZN18AnimatorController15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 178256 | 0, gb + 1105816 | 0, fb + 916 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 178256 | 0, gb + 1105836 | 0, fb + 917 | 0, 0);
 return;
}

function __ZN15RelativeJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15DirectorManager14ScheduleForAddEP18PlayableController(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 440 >> 0] | 0)) {
  __ZN15DirectorManager12AddToManagerEP18PlayableController(i1, i2);
  return;
 } else {
  i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63784 | 0, 16, gb + 582681 | 0, 400) | 0;
  HEAP32[i1 + 4 >> 2] = i2;
  i2 = HEAP32[gb + 1188420 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i1;
  return;
 }
}

function __ZN14dtPathCorridor4initEPK9dtNavMeshi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 + 24 >> 2] = i2;
 i4 = i1 + 40 | 0;
 HEAP32[i4 >> 2] = i3;
 i3 = __Z7dtAlloci(i3 << 3) | 0;
 HEAP32[i1 + 28 >> 2] = i3;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i1 + 36 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = 1;
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 56 >> 2];
 i4 = 1;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_1L5gNXORERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = (HEAP16[i2 >> 1] ^ HEAP16[i1 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 2 >> 1] = (HEAP16[i2 + 2 >> 1] ^ HEAP16[i1 + 2 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 4 >> 1] = (HEAP16[i2 + 4 >> 1] ^ HEAP16[i1 + 4 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 6 >> 1] = (HEAP16[i2 + 6 >> 1] ^ HEAP16[i1 + 6 >> 1]) & 65535 ^ 65535;
 return;
}

function __Z42AudioReverbZone_Set_Custom_PropReverbDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 92 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AudioReverbZone_Set_Custom_PropHFReferenceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 96 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Terrain_CUSTOM_CreateTerrainGameObjectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Z18GetITerrainManagerv() | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 i3 = __ZN9Scripting19ScriptingWrapperForEP6Object(mftCall_iii(i3 | 0, i2 | 0, i1 | 0) | 0) | 0;
 return i3 | 0;
}

function __Z35CullingGroup_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN12CullingGroup10SetEnabledEb(i1, i2 << 24 >> 24 != 0);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE19FileEnumerationFlagRNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_(i1, 0, i2, i3, i4) | 0;
 return 1;
}

function __Z15Transfer_StringI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function _tre_purge_regset(i5, i1, i6) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if ((i2 | 0) > -1) {
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  i3 = 0;
  do {
   i1 = i2 >>> 1;
   if (!(i2 & 1)) HEAP32[i4 + (i1 * 12 | 0) >> 2] = i6; else HEAP32[i4 + (i1 * 12 | 0) + 4 >> 2] = i6;
   i3 = i3 + 1 | 0;
   i2 = HEAP32[i5 + (i3 << 2) >> 2] | 0;
  } while ((i2 | 0) > -1);
 }
 HEAP32[i5 >> 2] = -1;
 return;
}

function __ZNK5physx3Ext14SphericalJoint12getLimitConeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i2) return;
 i1 = i1 + 4 | 0;
 if (!(mftCall_iiii(i2 | 0, HEAP32[i1 >> 2] | 0, 0, i3 | 0) | 0)) return;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = i4 + 16 | 0;
 __ZZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_S7_S5_(i4, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i2, i3);
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getExternalAccelerationEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 256)) i1 = __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv(i1 + 32 | 0) | 0; else i1 = (HEAP32[i1 + 28 >> 2] | 0) + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZNK5Umbra6Portal4getZERKNS_7Vector3ES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0, i6 = 0;
 i6 = (HEAP32[i1 >> 2] | 0) >>> 30;
 f5 = Math_fround(HEAPF32[i2 + (i6 << 2) >> 2]);
 f4 = Math_fround(Math_fround(HEAP32[i1 + 4 >> 2] & 65535 | 0) * Math_fround(.0000152590219));
 return Math_fround(Math_fround(Math_fround(HEAPF32[i3 + (i6 << 2) >> 2]) * f4) + Math_fround(f5 * Math_fround(Math_fround(1.0) - f4)));
}

function __ZNK14SoundHandleAPI20GetMusicChannelCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 40 >> 2] | 0;
  if (!i1) i1 = 0; else {
   HEAP32[i2 >> 2] = 0;
   i1 = (__ZN4FMOD5Sound19getMusicNumChannelsEPi(i1, i2) | 0) == 0;
   i1 = i1 ? HEAP32[i2 >> 2] | 0 : 0;
  }
 }
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN8b2IslandD2Ev(i1) {
 i1 = i1 | 0;
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0);
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0);
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZN6Shader8PostLoadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 + 40 >> 2] = 0;
  i2 = 0;
  i3 = i1 + 36 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 } else {
  __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i3, i1);
  i2 = __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi(HEAP32[i2 >> 2] | 0, i1 + 40 | 0) | 0;
  i3 = i1 + 36 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN6Camera8SetDepthEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 HEAPF32[i3 + 888 >> 2] = f1;
 i2 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0);
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5physx3Ext13RevoluteJoint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 136);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZN5physx27solveFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i5, i4, i1, i2, i3) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i5) return; else i1 = 0;
 do {
  __ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN5physx21PxVehicleDriveDynData14setToRestStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 64 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 65 >> 0] = 0;
 HEAP8[i1 + 66 >> 0] = 0;
 HEAP32[i1 + 68 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5audio5mixer23GetExposedPropertyValueERKNS0_16AudioMixerMemoryEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[(HEAP32[i1 + 40 >> 2] | 0) + (i2 << 2) >> 2]);
 if (f3 != Math_fround(-inf)) return Math_fround(f3);
 i4 = (HEAP32[i1 + 76 >> 2] | 0) + 76 | 0;
 f3 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + (HEAP32[i4 + (HEAP32[i4 >> 2] | 0) + (i2 << 2) >> 2] << 2) >> 2]);
 return Math_fround(f3);
}

function __ZN5Umbra6Random4getIEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 8 + (HEAP32[i1 >> 2] << 2) | 0;
 i3 = i1 + 4 | 0;
 i2 = (HEAP32[i1 + 8 + (HEAP32[i3 >> 2] << 2) >> 2] | 0) + (HEAP32[i4 >> 2] | 0) | 0;
 i2 = i2 << 13 | i2 >>> 19;
 HEAP32[i4 >> 2] = i2;
 i4 = (HEAP32[i1 >> 2] | 0) + -1 | 0;
 HEAP32[i1 >> 2] = (i4 >> 31 & 11) + i4;
 i1 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = (i1 >> 31 & 11) + i1;
 return i2 | 0;
}

function __ZN23ShaderVariantCollectionD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 68748 + 8;
 __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1 + 32 | 0, HEAP32[i1 + 36 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12_GLOBAL__N_1L4gNORERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = (HEAP16[i2 >> 1] | HEAP16[i1 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 2 >> 1] = (HEAP16[i2 + 2 >> 1] | HEAP16[i1 + 2 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 4 >> 1] = (HEAP16[i2 + 4 >> 1] | HEAP16[i1 + 4 >> 1]) & 65535 ^ 65535;
 HEAP16[i3 + 6 >> 1] = (HEAP16[i2 + 6 >> 1] | HEAP16[i1 + 6 >> 1]) & 65535 ^ 65535;
 return;
}

function __Z54GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawPrefixLabel13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 __Z22MonoGUIContentToNativeP12Il2CppObjectR10GUIContent(i3, gb + 1468176 | 0);
 __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib(i1, __Z11GetGUIStatev() | 0, i2, gb + 1468176 | 0, i4, i5 << 24 >> 24 != 0);
 return;
}

function __Z48ExtractUmbraCameraTransformFromCullingParametersRK17CullingParametersRN5Umbra15CameraTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 188 >> 2] | 0;
 if ((i3 | 0) > 6) __ZN5Umbra15CameraTransform17setUserClipPlanesEPKNS_7Vector4Ei(i2, i1 + 124 | 0, i3 + -6 | 0);
 __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE(i2, i1 + 544 | 0, i1 + 608 | 0, 0, 0);
 return;
}

function __Z40AudioReverbZone_Set_Custom_PropDiffusionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 108 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39setPxSphericalJoint_SphericalJointFlagsPN5physx16PxSphericalJointENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z39setPxPrismaticJoint_PrismaticJointFlagsPN5physx16PxPrismaticJointENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z30setPxTriangleMeshGeometryScalePN5physx22PxTriangleMeshGeometryENS_11PxMeshScaleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function _UNITY_png_get_text(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) {
  i1 = HEAP32[i2 + 128 >> 2] | 0;
  if ((i1 | 0) > 0) {
   if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i2 + 136 >> 2];
   if (!i4) {
    i4 = i1;
    return i4 | 0;
   }
   HEAP32[i4 >> 2] = i1;
   i4 = i1;
   return i4 | 0;
  }
 }
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i4 = 0;
 return i4 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 276 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 316 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn264_N31CanvasBatchIntermediateRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv(i1 + -264 | 0);
 i2 = i1 + 36 | 0;
 i3 = i1 + 52 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNK5physx3Ext7D6Joint16getDrivePositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 80 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 272 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 276 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 280 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 284 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 288 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 292 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 296 >> 2];
 return;
}

function __ZNK5Umbra13TomeUserIdMap8getIndexEj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i4 = -1;
  return i4 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = 0;
 while (1) {
  if ((HEAP32[i2 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = -1;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_(i1, i2) | 0;
 return ((i2 | 0) == (i1 + 4 | 0) ? 0 : i2 + 28 | 0) | 0;
}

function __ZN9Rigidbody16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 HEAPF32[i3 >> 2] = Math_fround(1.00000001e-07);
 i1 = i1 + 68 | 0;
 i4 = Math_fround(HEAPF32[i1 >> 2]) > Math_fround(1.00000001e-07);
 HEAP32[i1 >> 2] = HEAP32[(i4 ? i1 : i3) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP32[i4 >> 2] = i3 << 8 | i3 << 16 | i3 << 24 | 255;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm18SetPropertyMessage9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx5cloth8SwSolver17EndSimulationTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 20 | 0;
 __ZN5physx5cloth8SwSolver14interCollisionEv(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 8 | 0;
 i2 = i1;
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP16[i1 + 76 >> 1] | 0, i2 | 0, ((i2 | 0) < 0) << 31 >> 31 | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext18ProfileZoneHandlerD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 87256 + 8;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) {
  __ZdlPv(i2);
  return;
 }
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx3Ext13DistanceJoint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 96);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZN5physx25PxClothSimpleTetherCookerC2ERKNS_15PxClothMeshDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __Znwj(28) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 1;
 __ZN5physx29PxClothSimpleTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i3, i1);
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore13setRestOffsetEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx10NpMaterial7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, HEAP32[i2 + 8 >> 2] | 0, 1);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 12 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Umbra9fnv64HashEPKhj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!i5) {
  i4 = -873292572;
  i5 = -2078137563;
  setTempRet0(i4 | 0);
  return i5 | 0;
 } else {
  i3 = 0;
  i2 = -873292572;
  i1 = -2078137563;
 }
 do {
  i1 = ___muldi3((HEAPU8[i4 + i3 >> 0] | 0) ^ i1 | 0, i2 | 0, 435, 256) | 0;
  i2 = getTempRet0() | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i5 | 0));
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN18PlayableController4PlayEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 164 | 0;
 if (HEAP8[i2 >> 0] | 0) return;
 i3 = i1 + 156 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = HEAP32[i1 + 168 >> 2] | 0;
 if (i4 | 0) HEAP32[i3 >> 2] = __Z29scripting_gchandle_get_targetj(i4) | 0;
 if ((HEAP32[i1 >> 2] | 0) != 3) __ZN15DirectorManager14ScheduleForAddEP18PlayableController(__Z18GetDirectorManagerv() | 0, i1);
 HEAP8[i2 >> 0] = 1;
 return;
}

function __ZN15SharedLightData21UpdateSpotAngleValuesEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f3 = Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 60 >> 2]) * Math_fround(.5)) / Math_fround(360.0)) * Math_fround(2.0)) * Math_fround(3.14159274));
 f2 = Math_fround(+Math_cos(+f3));
 HEAPF32[i1 + 68 >> 2] = Math_fround(f2 / Math_fround(+Math_sin(+f3)));
 HEAPF32[i1 + 72 >> 2] = Math_fround(Math_fround(1.0) / f2);
 return;
}

function __ZN14StackAllocator16SetRequestedSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (HEAP32[i1 + 52 >> 2] | 0) {
  i1 = i1 + 40 | 0;
  HEAP32[i1 >> 2] = i2;
  return;
 }
 i4 = i1 + 32 | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i4 >> 2] = __ZN13MemoryManager18LowLevelReallocateEPvjj(HEAP32[i4 >> 2] | 0, i2, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 i1 = i1 + 40 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13UnityProfiler18ClearPendingFramesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZN17ProfilerFrameDataD2Ev(i3);
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63576 | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN17ProfilerFrameDataD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63576 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13TargetJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12FixedJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D5ResetEv(i1);
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 92 >> 0] = 1;
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10HumanTrait13GetColliderIdER6Avatari(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (i3 >>> 0 >= 24) {
  i3 = -1;
  return i3 | 0;
 }
 i1 = (HEAP32[i1 + 56 >> 2] | 0) + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = -1;
  return i3 | 0;
 }
 i1 = i1 + i2 | 0;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0)) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 264 + (i3 << 2) >> 2] | 0;
 return i3 | 0;
}

function __Z58ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint23SetAngularYZLimitSpringERK20SoftJointLimitSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Rigidbody2D_Set_Custom_PropCollisionDetectionModeP12Il2CppObjectN11Rigidbody2D22CollisionDetectionModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D25SetCollisionDetectionModeENS_22CollisionDetectionModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48LightProbeProxyVolume_Set_Custom_PropRefreshModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = i3 + 44 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
   HEAP32[i1 >> 2] = i2;
   HEAP8[i3 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioReverbZone_Set_Custom_PropDecayTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 72 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI8JSONReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIyEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIsEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIdEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8JSONRead8TransferIaEEvRT_PKc17TransferMetaFlagsb(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function _UNITY_png_set_sBIT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0 | (i3 | 0) == 0) return;
 i1 = i2 + 140 | 0;
 HEAP8[i1 >> 0] = HEAP8[i3 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i3 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i3 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i3 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[i3 + 4 >> 0] | 0;
 i3 = i2 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
 return;
}

function _setrlimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 4 >> 2] = i1;
 i1 = i4 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 ___synccall(fb + 3992 | 0, i4);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else {
  HEAP32[(___errno_location() | 0) >> 2] = i1;
  i1 = -1;
 }
 STACKTOP = i3;
 return i1 | 0;
}

function __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj(i1, i5, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -4 | 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 + i4 | 0) >>> 0 > (HEAP32[i1 + 12 >> 2] | 0) >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 _memcpy(i5 | 0, (HEAP32[i1 + 20 >> 2] | 0) + i3 | 0, i4 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i4;
 i5 = i4;
 return i5 | 0;
}

function __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEEC2EjjS9_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __Znwj(i3 << 3) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i1 + (i4 << 3) | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1 + (i3 << 3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEaSERKS7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255);
 }
 return;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE24GetBookKeepingMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = i1 + i2 | 0;
  return i2 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
 i2 = i1 + i2 | 0;
 return i2 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __ZN5Umbra10TomeLoader14loadFromBufferEPKhjPNS_9AllocatorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = gb + 78648 + 8;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i2;
 i3 = __ZN5Umbra10TomeLoader4loadERNS_11InputStreamEPNS_9AllocatorE(i5, i3) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv(i2, i6, i7, i4, i5, i3) {
 i2 = i2 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 var i1 = 0, i8 = 0;
 i8 = i2 + 176 | 0;
 i1 = HEAP32[i8 >> 2] | 0;
 i8 = HEAP32[i8 + 4 >> 2] | 0;
 i2 = i2 + (i8 >> 1) | 0;
 if (i8 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_viiiiii(i1 | 0, i2 | 0, i6 | 0, i7 | 0, i4 | 0, i5 | 0, i3 | 0);
 return;
}

function __Z51AnchoredJoint2D_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 88 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 84 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioReverbZone_Set_Custom_PropDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 112 >> 2] = f2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z25Animator_CUSTOM_CrossFadeP12Il2CppObjectifif(i1, i2, f3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) {
   __ZN8Animator9GotoStateEiifff(i6, i4, i2, f5, f3, Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z15Transfer_StringI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function __Z15Transfer_StringI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function __Z15Transfer_StringI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function b5(i1, f2, i13, i14, i15, i16, i17, i18, i19, i20, i3, i4, i5, i6, i7, i8, i9, i10, i11, i12) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i18 = i18 | 0;
 i19 = i19 | 0;
 i20 = i20 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 nullFunc_vifiiiiiiiiiiiiiiiiii(5);
}

function __ZThn32_N12MeshRendererD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -32 | 0;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEaSERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26localeaSERKS0_(i1 + 4 | 0, i2 + 4 | 0) | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEaSERKS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26localeaSERKS0_(i1 + 4 | 0, i2 + 4 | 0) | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 + 28 >> 2];
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i3 + (HEAP32[i2 + 4 >> 2] << 2) | 0);
 return;
}

function __ZNSt13runtime_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216304 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4617 | 0, i1 + 4 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNK5physx3Ext10FixedJoint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 80);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZNK5Umbra4Tome21getClusterPortalCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 + 180 >> 2] | 0)) {
  i2 = (HEAP32[i1 + 124 >> 2] | 0) + -1 | 0;
  i1 = i1 + (HEAP32[i1 + 128 >> 2] | 0) | 0;
  i1 = (HEAP32[i1 + (i2 * 20 | 0) + 4 >> 2] | 0) + (HEAP32[i1 + (i2 * 20 | 0) >> 2] | 0) | 0;
  return i1 | 0;
 } else {
  i2 = HEAP32[i1 + (HEAP32[i1 + 184 >> 2] | 0) + (HEAP32[i1 + 176 >> 2] << 2) >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK2UI13RectTransform25CalculateRectInLocalSpaceEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv(i1, i2);
 f3 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 HEAPF32[i1 >> 2] = Math_fround(-Math_fround(f3 * Math_fround(HEAPF32[i2 + 168 >> 2])));
 f3 = Math_fround(HEAPF32[i1 + 12 >> 2]);
 HEAPF32[i1 + 4 >> 2] = Math_fround(-Math_fround(f3 * Math_fround(HEAPF32[i2 + 172 >> 2])));
 return;
}

function __ZNK13Lz4Compressor14CompressMemoryEPKvjPvPj16CompressionLevel(i1, i3, i4, i5, i6, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 if (i4 >>> 0 >= 2147483647) {
  i6 = 0;
  return i6 | 0;
 }
 i1 = HEAP32[i6 >> 2] | 0;
 if (i1 >>> 0 >= 2147483647) {
  i6 = 0;
  return i6 | 0;
 }
 i5 = _UNITY_LZ4_compress_limitedOutput(i3, i5, i4, i1) | 0;
 HEAP32[i6 >> 2] = i5;
 i6 = (i5 | 0) > 0;
 return i6 | 0;
}

function __ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] & 2147483647;
 if (!(HEAP8[i2 + 25 >> 0] | 0)) {
  if ((i1 | 0) != (HEAP32[gb + 1161244 >> 2] | 0)) {
   i2 = 0;
   return i2 | 0;
  }
 } else if ((i1 | 0) != (HEAP32[gb + 1161256 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1;
 return i2 | 0;
}

function __ZN9Scripting34ScriptingWrapperClassForNativeTypeEPKN5Unity4TypeE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = __Z21GetManagerFromContexti(5) | 0;
  i2 = HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
  if (i2 | 0) {
   i1 = i2;
   i2 = 4;
   break;
  }
  i1 = HEAP32[i1 >> 2] | 0;
  if ((i1 | 0) == (gb + 28304 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN8VRDevice20UpdateVRSplashScreenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 284 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) return;
 if (__ZN14VRSplashScreen6UpdateEPFvRK11QuaternionfRK8Vector3fS5_E(i2, HEAP32[i1 + 368 >> 2] | 0) | 0) return;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63816 | 0);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN7mecanim9animation17CreateAvatarInputEPKNS0_14AvatarConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 20, 4) | 0;
 HEAPF32[i2 >> 2] = Math_fround(0.0);
 HEAP32[i2 + 4 >> 2] = -1;
 HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP8[i2 + 17 >> 0] = 0;
 HEAP8[i2 + 18 >> 0] = 0;
 return i2 | 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = i1 | 0 ? i1 : gb + 1576256 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else i1 = (_strlen(i1) | 0) + 1 | 0;
 i2 = i2 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 4;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148628 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc9StaticSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 91220 + 8;
 __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE(HEAP32[i1 + 36 >> 2] | 0, i1);
 HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 4 >> 2] = 0;
 __ZN5physx2Sc8RigidSimD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore13setRestOffsetEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx11NpAggregate17removeAndReinsertERNS_7PxActorEb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i5 = HEAPU16[i1 + 4 >> 1] | 0;
 i4 = i1 + (HEAP32[gb + 1457020 + 68 + (i5 << 2) >> 2] | 0) | 0;
 __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE(i1 + (HEAP32[gb + 1457020 + (i5 << 2) >> 2] | 0) | 0, 0, i1);
 __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb(i3 + 8 | 0, i4, i2);
 return;
}

function __ZN2UI11CanvasGroup15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 186852 | 0, gb + 1105056 | 0, fb + 978 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 186852 | 0, gb + 1105076 | 0, fb + 979 | 0, 0);
 return;
}

function __ZN21InheritVelocityModuleD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 83416 + 8;
 i1 = i2 + 244 | 0;
 if ((HEAP32[i2 + 260 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 248 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 156 | 0;
 if ((HEAP32[i2 + 172 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 160 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN21InheritVelocityModuleD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 83416 + 8;
 i2 = i1 + 244 | 0;
 if ((HEAP32[i1 + 260 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 248 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 172 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 156 >> 2] | 0, i1 + 160 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN15MBP_PairManager12shrinkMemoryEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 i1 = i1 >>> 1 | i1;
 i1 = i1 >>> 2 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 16 | i1;
 i2 = i1 + 1 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (i2 >>> 0 < (HEAP32[i3 + 24 >> 2] | 0) >>> 0) return;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 __ZN15MBP_PairManager12reallocPairsEv(i3);
 return;
}

function __ZN13SubstanceData25SetProceduralMemoryBudgetE19ProceduralCacheSize(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 switch (i2 | 0) {
 case 0:
  {
   HEAP32[i1 + 20 >> 2] = 1;
   return;
  }
 case 1:
  {
   HEAP32[i1 + 20 >> 2] = 2;
   return;
  }
 case 2:
  {
   HEAP32[i1 + 20 >> 2] = 3;
   return;
  }
 case 3:
  {
   HEAP32[i1 + 20 >> 2] = 3;
   return;
  }
 default:
  {
   HEAP32[i1 + 20 >> 2] = 0;
   return;
  }
 }
}

function __ZN12InputManager19SetJoystickPositionEiif(i1, i2, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var i3 = 0, i6 = 0;
 i6 = HEAP32[i1 + 124 >> 2] | 0;
 i3 = i6;
 if ((((HEAP32[i1 + 128 >> 2] | 0) - i6 | 0) / 12 | 0 | 0) <= (i2 | 0)) return;
 i1 = HEAP32[i3 + (i2 * 12 | 0) >> 2] | 0;
 if (((HEAP32[i3 + (i2 * 12 | 0) + 4 >> 2] | 0) - i1 >> 2 | 0) <= (i4 | 0)) return;
 HEAPF32[i1 + (i4 << 2) >> 2] = f5;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager5PauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i1 >> 2] = 2;
 if (!i2) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3958 | 0, i1 | 0) | 0;
 i2 = 1;
 return i2 | 0;
}

function __Z57ConfigurableJoint_CUSTOM_INTERNAL_set_angularXLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint22SetAngularXLimitSpringERK20SoftJointLimitSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40TerrainData_CUSTOM_GetInterpolatedHeightP12Il2CppObjectff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return Math_fround(__ZNK9Heightmap21GetInterpolatedHeightEff(i4 + 248 | 0, f2, f3));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Quaternion_CUSTOM_INTERNAL_CALL_InverseRK11QuaternionfRS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(-Math_fround(HEAPF32[i1 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i1 + 4 >> 2]));
 f3 = Math_fround(-Math_fround(HEAPF32[i1 + 8 >> 2]));
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 HEAPF32[i2 >> 2] = f5;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f3;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = __ZN15FileSystemEntry8IsLockedEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIsEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN9JSONWrite8TransferIaEEvRT_PKc17TransferMetaFlags(HEAP32[i2 + 20 >> 2] | 0, (HEAP8[i2 >> 0] | 0) == 0 ? i3 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i3, HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function _XXH64_canonicalFromHash(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _llvm_bswap_i64(i2 | 0, i3 | 0) | 0;
 i2 = getTempRet0() | 0;
 i3 = i1;
 i1 = i3;
 HEAP8[i1 >> 0] = i4;
 HEAP8[i1 + 1 >> 0] = i4 >> 8;
 HEAP8[i1 + 2 >> 0] = i4 >> 16;
 HEAP8[i1 + 3 >> 0] = i4 >> 24;
 i3 = i3 + 4 | 0;
 HEAP8[i3 >> 0] = i2;
 HEAP8[i3 + 1 >> 0] = i2 >> 8;
 HEAP8[i3 + 2 >> 0] = i2 >> 16;
 HEAP8[i3 + 3 >> 0] = i2 >> 24;
 return;
}

function _UNITY_png_read_filter_row_sub(i2, i4, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = ((HEAPU8[i2 + 11 >> 0] | 0) + 7 | 0) >>> 3;
 if (i1 >>> 0 >= i5 >>> 0) return;
 i3 = 0 - i1 | 0;
 i2 = i1;
 i1 = i4 + i1 | 0;
 while (1) {
  HEAP8[i1 >> 0] = (HEAPU8[i1 + i3 >> 0] | 0) + (HEAPU8[i1 >> 0] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i5 | 0)) break; else i1 = i1 + 1 | 0;
 }
 return;
}

function _UNITY_png_destroy_png_struct(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 768 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!i1) {
  STACKTOP = i4;
  return;
 }
 _memcpy(i2 | 0, i1 | 0, 756) | 0;
 _memset(i1 | 0, 0, 756) | 0;
 i3 = HEAP32[i2 + 612 >> 2] | 0;
 if (!i3) _free(i1); else mftCall_vii(i3 | 0, i2 | 0, i1 | 0);
 _UNITY_png_free_jmpbuf(i2);
 STACKTOP = i4;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 496 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__217moneypunct_bynameIwLb1EED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 212028 + 8;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 52 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 40 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 return;
}

function __ZNSt3__217moneypunct_bynameIwLb0EED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211972 + 8;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 52 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 40 | 0);
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1 + 28 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb1EED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211916 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 return;
}

function __ZNSt3__217moneypunct_bynameIcLb0EED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 211860 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 48 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 36 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 24 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_(i1, i2, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKw(i1, i2 - i3 >> 2, (HEAP32[i4 >> 2] | 0) - i2 >> 2, i5) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i3 + (HEAP32[i2 + 4 >> 2] | 0) | 0);
 return;
}

function __ZNK5physx2Sc15ArticulationSim16updateDriveCacheERNS_9PxcFsDataEfj(i4, i1, f2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 __ZNK5physx2Sc15ArticulationSim11checkResizeEv(i4);
 __ZN5physx21PxcArticulationHelper20initializeDriveCacheERNS_9PxcFsDataEtPKNS_19PxsArticulationLinkEfjPcj(i1, HEAP32[i4 + 16 >> 2] & 65535, HEAP32[i4 + 12 >> 2] | 0, f2, i3, HEAP32[i4 + 148 >> 2] | 0, HEAP32[i4 + 152 >> 2] | 0);
 return;
}

function __ZNK5physx18PxArticulationLink8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 687162 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 701087 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 833471 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK26AnimatorControllerPlayable23GetStateMachineConstantEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = i1 + 12 | 0;
 i1 = i1 + 4 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 + (i2 << 2) | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + i3 + (HEAP32[i1 + (HEAP32[i1 >> 2] | 0) >> 2] << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i2 = (i2 | 0) == 0 ? 0 : i1 + i2 | 0;
 return i2 | 0;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE22GetAllocatedMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = i1 + i2 | 0;
  return i2 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
 i2 = i1 + i2 | 0;
 return i2 | 0;
}

function __ZN9Transform26SupportedMessagesDidChangeEi(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 i2 = 1 << (i1 & 31);
 if (!(i4 & 8)) {
  i4 = i3 + (i1 >>> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i2;
  return;
 } else {
  i4 = i3 + (i1 >>> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i2;
  return;
 }
}

function __ZN5physx9readChunkERaS0_S0_S0_RNS_13PxInputStreamE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i1 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i2 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i3 | 0, 1) | 0;
 mftCall_iiii(HEAP32[HEAP32[i5 >> 2] >> 2] | 0, i5 | 0, i4 | 0, 1) | 0;
 return;
}

function __ZN5physx2Sc18TriggerInteraction7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = i1 + 12 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i3 >> 2] | 0, i2);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i1 + 16 >> 2] | 0, i2);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i2);
 return;
}

function __ZN5physx21PxVehicleDriveDynDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 64 >> 0] = 0;
 HEAP8[i1 + 65 >> 0] = 0;
 HEAP8[i1 + 66 >> 0] = 0;
 HEAP32[i1 + 68 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 1;
 HEAPF32[i1 + 76 >> 2] = Math_fround(360.0);
 HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN4FMOD8ChannelI15setChannelGroupEPNS_12ChannelGroupE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
 if (!i2) i1 = 0; else {
  i2 = HEAP32[(HEAP32[i2 + 164 >> 2] | 0) + ((i1 >>> 16 & 4095) << 2) >> 2] | 0;
  if (!i2) i1 = 0; else if (!(HEAP8[i2 + 16 >> 0] | 0)) i1 = (HEAP32[i2 + 12 >> 2] | 0) == (i1 & 65535 | 0) ? i2 : 0; else i1 = 0;
 }
 HEAP32[i3 + 68 >> 2] = i1;
 return 0;
}

function __Z49Rigidbody_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK8Vector3fS3_i(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN9Rigidbody18AddForceAtPositionERK8Vector3fS2_i(i5, i2, i3, i4);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49ConstantForce2D_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 60 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 56 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38DownloadHandler_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 __ZN15DownloadHandler7ReleaseEv(i2);
 return;
}

function __Z37setPxRevoluteJoint_RevoluteJointFlagsPN5physx15PxRevoluteJointENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z37setPxDistanceJoint_DistanceJointFlagsPN5physx15PxDistanceJointENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z28setPxConvexMeshGeometryScalePN5physx20PxConvexMeshGeometryENS_11PxMeshScaleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __Z27Physics2D_CUSTOM_IsTouchingP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = __Z19GetPhysicsManager2Dv() | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 return (__ZNK16Physics2DManager10IsTouchingEPK10Collider2DS2_(i4, i2, i1) | 0) & 1 | 0;
}

function __Z15Transfer_StringI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z13TransferFieldI18StreamedBinaryReadILb1EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function __Z15Transfer_StringI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z13TransferFieldI18StreamedBinaryReadILb0EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function __ZNSt11logic_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216284 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4617 | 0, i1 + 4 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNK5physx3Ext14PrismaticJoint8getLimitEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE21GetReservedMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = i1 + i2 | 0;
  return i2 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 i2 = i1 + i2 | 0;
 return i2 | 0;
}

function __ZNK13SparseTexture17GetUploadTileSizeEiRiS0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = HEAP32[i1 + 80 >> 2] >> i2;
 i6 = (i6 | 0) > 1 ? i6 : 1;
 i2 = HEAP32[i1 + 84 >> 2] >> i2;
 i2 = (i2 | 0) > 1 ? i2 : 1;
 i5 = HEAP32[i1 + 88 >> 2] | 0;
 HEAP32[i3 >> 2] = (i6 | 0) < (i5 | 0) ? i6 : i5;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 HEAP32[i4 >> 2] = (i2 | 0) < (i3 | 0) ? i2 : i3;
 return;
}

function __ZN8GUIState12GetControlIDEi9FocusType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i5 + 8 >> 2] = 0;
 HEAP32[i5 + 12 >> 2] = 0;
 i3 = __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i1, i2, i3, i5, 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN8Collider10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 41 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 if (!i2) __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK8Collider(__Z17GetPhysicsManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx35PxVehicleAutoBoxDataGeneratedValuesC2EPKNS_20PxVehicleAutoBoxDataE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 128 >> 2];
 i1 = 0;
 do {
  HEAP32[i3 + 4 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 i1 = 0;
 do {
  HEAP32[i3 + 132 + (i1 << 2) >> 2] = HEAP32[i2 + 128 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 return;
}

function __ZN5physx27PxcContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb(i4, i5, i6, i7, i2, i3, i1, 0) | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11setGridSizeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore11setGridSizeEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5IMGUI12GetEventTypeERK8GUIStateRK10InputEvent(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 L1 : do if (!(HEAP32[i2 + 60 >> 2] | 0)) {
  switch (i1 | 0) {
  case 7:
  case 8:
  case 12:
   break L1;
  default:
   {}
  }
  i1 = 11;
 } else if (!(HEAP32[i2 + 268 >> 2] | 0)) switch (i1 | 0) {
 case 0:
 case 1:
 case 9:
 case 10:
 case 16:
  {
   i1 = 11;
   break L1;
  }
 default:
  {}
 } while (0);
 return i1 | 0;
}

function __ZN24CollectBroadphaseTerrainD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 114036 + 8;
 i1 = i2 + 40 | 0;
 if ((HEAP32[i2 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 44 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 20 | 0;
 if ((HEAP32[i2 + 36 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 24 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN24CollectBroadphaseTerrainD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 114036 + 8;
 i2 = i1 + 40 | 0;
 if ((HEAP32[i1 + 56 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 44 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 36 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 20 >> 2] | 0, i1 + 24 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicMaterial18SetFrictionCombineEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  break;
 case 1:
  {
   i1 = 2;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 0;
 }
 HEAP32[i3 + 32 >> 2] = i1;
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 __ZN14PhysicMaterial15ChangedMaterialEv(i3);
 return;
}

function __ZN12MeshCollider15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 112968 | 0, gb + 1105156 | 0, fb + 847 | 0, 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 112968 | 0, gb + 1105196 | 0, fb + 848 | 0, 0);
 return;
}

function __ZN12AudioManager26SetDefaultMicrophoneDriverEP9FMOD_GUID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 260 | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
  return;
 }
}

function __Z30NavMeshAgent_CUSTOM_CopyPathToP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i2);
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK12NavMeshAgent8CopyPathEP11NavMeshPath(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_ft_mem_dup(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 if ((i4 | 0) > 0) {
  i2 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i1 | 0, i4 | 0) | 0;
  i1 = i2;
  i2 = (i2 | 0) == 0 ? 64 : 0;
 } else {
  i1 = 0;
  i2 = i4 | 0 ? 6 : 0;
 }
 if (!((i3 | 0) != 0 & (i2 | 0) == 0)) {
  HEAP32[i5 >> 2] = i2;
  return i1 | 0;
 }
 _memcpy(i1 | 0, i3 | 0, i4 | 0) | 0;
 HEAP32[i5 >> 2] = i2;
 return i1 | 0;
}

function _TT_Access_Glyph_Frame(i5, i1, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i5 + 24 >> 2] | 0;
 i1 = _UNITY_FT_Stream_Seek(i4, i2) | 0;
 if (i1 | 0) {
  i5 = i1;
  return i5 | 0;
 }
 i1 = _UNITY_FT_Stream_EnterFrame(i4, i3) | 0;
 if (i1 | 0) {
  i5 = i1;
  return i5 | 0;
 }
 HEAP32[i5 + 200 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i5 + 204 >> 2] = HEAP32[i4 + 36 >> 2];
 i5 = 0;
 return i5 | 0;
}

function _ft_outline_glyph_prepare(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i2 + 72 >> 2] = 1869968492;
 i3 = i2 + 108 | 0;
 i1 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 i2 = i2 + 124 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -2;
 return 0;
}

function __ZNK5physx3Ext7D6Joint13getTwistLimitEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 120 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK5physx3Ext7D6Joint13getSwingLimitEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 148 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK5physx3Ext13RevoluteJoint8getLimitEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 84 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK13b2DynamicTree13ComputeHeightEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i3 + (i2 * 36 | 0) + 24 >> 2] | 0;
 if ((i4 | 0) == -1) return 0; else {
  i5 = __ZNK13b2DynamicTree13ComputeHeightEi(i1, i4) | 0;
  i4 = __ZNK13b2DynamicTree13ComputeHeightEi(i1, HEAP32[i3 + (i2 * 36 | 0) + 28 >> 2] | 0) | 0;
  return ((i5 | 0) > (i4 | 0) ? i5 : i4) + 1 | 0;
 }
 return 0;
}

function __ZNK12TreeRenderer19LODTreeInstanceData21PrepareWindPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 if (i2 | 0) if (!(HEAP32[i2 + 44 >> 2] | 0)) __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i2, 0);
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 if (!i1) return;
 if (HEAP32[i1 + 44 >> 2] | 0) return;
 __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb(i1, 1);
 return;
}

function __ZN5physx7NpScene7collideEfPNS_10PxBaseTaskEPvj(i5, f2, i1, i3, i4) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 32, gb + 678666 | 0, 2087, gb + 707769 | 0, i1);
 STACKTOP = i1;
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149584 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 280 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 320 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager16purgeControllersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 68 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i3 + 64 | 0;
 do {
  i4 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
  __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE(i3, mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2] | 0, i4 | 0) | 0);
 } while ((HEAP32[i1 >> 2] | 0) != 0);
 return;
}

function __ZN5physx38PxJointAngularLimitPairGeneratedValuesC2EPKNS_23PxJointAngularLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx2Sc9ClothCore13setGlobalPoseERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = i2 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i1 + 16 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i1 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc17ParticleSystemSim19scheduleRefilteringEv(i1);
 return;
}

function __ZN5physx20PxsParticleSystemSim21collisionFinalizationEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 1304 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 1;
 HEAP32[i2 + 32 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZN4FMOD7SystemI10getVersionEPj(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!i3) {
  HEAP32[i1 >> 2] = 37;
  HEAP32[i1 + 4 >> 2] = gb + 861528;
  _printf(gb + 853277 | 0, i1) | 0;
  i3 = 37;
  STACKTOP = i2;
  return i3 | 0;
 } else {
  HEAP32[i3 >> 2] = 279047;
  i3 = 0;
  STACKTOP = i2;
  return i3 | 0;
 }
 return 0;
}

function __ZN14DataBufferGLES11CopySubDataEPKS_iii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!(HEAP8[i1 + 20 >> 0] | 0)) __ZN14DataBufferGLES16RecreateWithDataEiPKv(i1, HEAP32[i1 + 8 >> 2] | 0, 0);
 __ZN7ApiGLES17CopyBufferSubDataEjjlll(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i3, i4, i5);
 HEAP32[i1 + 28 >> 2] = HEAP32[HEAP32[i1 >> 2] >> 2];
 return;
}

function ___randname(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 ___clock_gettime(0, i2 | 0) | 0;
 i1 = 0;
 i2 = (HEAP32[i2 + 4 >> 2] | 0) * 65537 ^ (i2 >>> 4) + i3;
 while (1) {
  HEAP8[i3 + i1 >> 0] = (i2 & 15) + 65 | i2 << 1 & 32;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 6) break; else i2 = i2 >>> 5;
 }
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = gb + 208936 + 12;
 HEAP32[i3 >> 2] = gb + 208936 + 32;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i3, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = gb + 208888 + 12;
 HEAP32[i3 >> 2] = gb + 208888 + 32;
 i2 = i2 + (HEAP32[(HEAP32[i2 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4moveERS0_(i3, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNK5Umbra17BasePoolAllocator7isEmptyEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = 0;
  do {
   i2 = i2 + 1 | 0;
   i1 = HEAP32[i1 >> 2] | 0;
  } while ((i1 | 0) != 0);
  i1 = i2;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 if (i2) do {
  i1 = (HEAP32[i2 + 8 >> 2] | 0) + i1 | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return (i1 | 0) == (HEAP32[i3 + 12 >> 2] | 0) | 0;
}

function __ZN8Animator11ResolveHashEi(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (HEAP32[i1 + 108 >> 2] | 0) {
  i1 = HEAP32[i1 + 624 >> 2] | 0;
  if (i1 | 0) {
   __ZN26AnimatorControllerPlayable11ResolveHashEi(i2, i1, i3);
   return;
  }
 };
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i2, gb + 1576256 | 0, 0);
 return;
}

function __ZN5physx3Ext7D6Joint15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 80 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
  mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, 384);
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i3 + 16 >> 2] | 0);
 return;
}

function __ZN5physx2Sn13XmlNodeReaderD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 146564 + 8;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) {
  __ZdlPv(i2);
  return;
 }
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx2Gu11HeightFieldD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 107232 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107232 + 104;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 i1 = i1 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11setGridSizeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore11setGridSizeEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx15NpParticleFluid25lockParticleFluidReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 i2 = mftCall_iii(i5 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate17TextMeshGeneratorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __Z19DestroySingleObjectP6Object(i1);
 i1 = i2 + 88 | 0;
 if ((HEAP32[i2 + 104 >> 2] | 0) <= -1) {
  i2 = i2 + 68 | 0;
  __ZN11UTF16StringD2Ev(i2);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 92 | 0);
 HEAP32[i1 >> 2] = 0;
 i2 = i2 + 68 | 0;
 __ZN11UTF16StringD2Ev(i2);
 return;
}

function __ZN19VREyeTextureManager16UpdateFrameCountEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 64 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i4 = HEAP32[i1 >> 2] | 0;
 if (!(HEAP8[i1 + 104 >> 0] | 0)) {
  HEAP32[i1 + 36 >> 2] = i4 + (((i2 >>> 0) % (i3 >>> 0) | 0) * 20 | 0);
  return;
 } else {
  HEAP32[i1 + 36 >> 2] = i1 + 16;
  HEAP32[i1 + 40 >> 2] = i4 + (((i2 >>> 0) % (i3 >>> 0) | 0) * 20 | 0);
  return;
 }
}

function __ZN14StackAllocatorILj16EE8allocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i4 = i2 + 8 | 0;
 i3 = (HEAP32[i4 >> 2] | 0) + 23 & -16;
 i5 = __ZNK14StackAllocatorILj16EE9getHeaderEPv(i2, i3) | 0;
 i2 = i2 + 12 | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i5 + 4 >> 2] = i1 & 2147483647;
 HEAP32[i2 >> 2] = i5;
 HEAP32[i4 >> 2] = i3 + i1;
 i2 = i3;
 return i2 | 0;
}

function __ZN14PhysicMaterial16SetBounceCombineEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  break;
 case 1:
  {
   i1 = 2;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 0;
 }
 HEAP32[i3 + 36 >> 2] = i1;
 i2 = HEAP32[i3 + 52 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i1 | 0);
 __ZN14PhysicMaterial15ChangedMaterialEv(i3);
 return;
}

function __ZN12_GLOBAL__N_1L5gNANDERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = HEAP16[i2 >> 1] & HEAP16[i1 >> 1] & 65535 ^ 65535;
 HEAP16[i3 + 2 >> 1] = HEAP16[i2 + 2 >> 1] & HEAP16[i1 + 2 >> 1] & 65535 ^ 65535;
 HEAP16[i3 + 4 >> 1] = HEAP16[i2 + 4 >> 1] & HEAP16[i1 + 4 >> 1] & 65535 ^ 65535;
 HEAP16[i3 + 6 >> 1] = HEAP16[i2 + 6 >> 1] & HEAP16[i1 + 6 >> 1] & 65535 ^ 65535;
 return;
}

function __ZN12_GLOBAL__N_118LegacySerialStream17registerReferenceERN5physx6PxBaseEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 756264 | 0, 160, gb + 756378 | 0, i1);
 STACKTOP = i1;
 return;
}

function __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint20SetLinearLimitSpringERK20SoftJointLimitSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Material_Set_Custom_PropGlobalIlluminationFlagsP12Il2CppObject31MaterialGlobalIlluminationFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Material26SetGlobalIlluminationFlagsE31MaterialGlobalIlluminationFlags(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27Sampler_Get_Custom_PropNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   i2 = __Z20scripting_string_newPKc(HEAP32[i1 >> 2] | 0) | 0;
   STACKTOP = i3;
   return i2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __GLOBAL__sub_I_runtime_scenemanager_lump_cpp() {
 var i1 = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1163400 + (i1 * 12 | 0) >> 2] = 0;
  HEAP32[gb + 1163400 + (i1 * 12 | 0) + 4 >> 2] = 0;
  HEAP8[gb + 1163400 + (i1 * 12 | 0) + 8 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 64);
 HEAP32[gb + 1163400 + 768 >> 2] = 0;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546605 | 0, fb + 3428 | 0, fb + 3429 | 0, 0, 0);
 return;
}

function _UNITY_FT_List_Up(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i2 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 if (!i3) return;
 HEAP32[i3 + 4 >> 2] = i5;
 if (!i5) HEAP32[i1 + 4 >> 2] = i3; else HEAP32[i5 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZThn12_N5physx10NpMaterialD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 93280 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 93280 + 108;
 __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNK5physx2Sn5ConvX12getMetaClassEiNS0_12MetaDataTypeE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 1:
  {
   i3 = HEAP32[(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + 20 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   return i3 | 0;
  }
 case 2:
  {
   i3 = HEAP32[(HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 20 >> 2] | 0) + (i1 << 2) >> 2] | 0;
   return i3 | 0;
  }
 default:
  {
   i3 = 0;
   return i3 | 0;
  }
 }
 return 0;
}

function __ZNK5physx14PxRigidDynamic8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 832257 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 701087 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 833471 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK17ArchiveFileSystem5IsDirERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i4, i1, i2);
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  STACKTOP = i3;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 + 16 >> 2] & 1 | 0) != 0;
 STACKTOP = i3;
 return i4 | 0;
}

function __ZN9ShaderLab7Program22ComputeSupportsShadowsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 205 | 0;
 HEAP8[i3 >> 0] = 0;
 i4 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i4) return;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 << 5) >> 2] & 224 | 0) break;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i5 = 6;
   break;
  }
 }
 if ((i5 | 0) == 6) return;
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZN7Joint2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  HEAP16[i4 + 2 >> 1] = 15360;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm12ErrorMessage9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 return;
}

function __ZN5physx8debugger4comm11OriginShift9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 20 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx37PxJointLinearLimitPairGeneratedValuesC2EPKNS_22PxJointLinearLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx18ReducedVertexCloud5CleanEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i3 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5Umbra9Matrix3x35identEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 return;
}

function __ZN26AnimatorControllerPlayableD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 177524 + 8;
 HEAP32[i1 + 80 >> 2] = gb + 177524 + 200;
 i2 = i1 + 112 | 0;
 if ((HEAP32[i1 + 128 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 116 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN24dtObstacleAvoidanceQuery5resetEPKfff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 HEAP32[i1 + 10452 >> 2] = 0;
 HEAP32[i1 + 10456 >> 2] = 0;
 HEAP32[i1 + 10460 >> 2] = 0;
 HEAP32[i1 + 10420 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 10424 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 10428 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 10432 >> 2] = f3;
 HEAPF32[i1 + 10436 >> 2] = f4;
 return;
}

function __ZN22MemoryCacherReadBlocks14LockCacheBlockEjPPhS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i3 - (Math_imul(i1, i2) | 0) | 0;
 HEAP32[i4 >> 2] = i5 + ((i1 | 0) < (i3 | 0) ? i1 : i3);
 return;
}

function __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayyPvPy(i2, i3, i4, i1, i5, i6, i7, i8) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = HEAP32[i3 + 1052 >> 2] | 0;
 if (!i1) {
  i8 = 0;
  return i8 | 0;
 }
 _fseek(i1, i4, 0) | 0;
 i8 = mftCall_iiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i3 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
 return i8 | 0;
}

function __ZN15FileSystemEntryC2EPKcR17FileSystemHandler(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 1040 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 _strncpy(i1, i2, 1040) | 0;
 __Z24ConvertSeparatorsToUnityPc(i1);
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN14dtPathCorridor8setToEndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i1 + 20 >> 2];
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i4 = i1 + ((HEAP32[i2 >> 2] | 0) + -1 << 3) | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = 1;
 return;
}

function __ZN13RenderTexture20SetEnableRandomWriteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 120 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP8[i3 >> 0] = i2 & 1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409801 | 0, 0, gb + 406201 | 0, 901, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN11UnityEngine7Connect16PersistentValues5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 i2 = i1 + 4 | 0;
 i3 = i2 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i3 >> 0] = 0;
 }
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 return;
}

function __Z49GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawCursor13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiRK10ColorRGBAf(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = __Z11GetGUIStatev() | 0;
 __ZNK8GUIStyle10DrawCursorER8GUIStateRK5RectTIfER10GUIContentiRK10ColorRGBAf(i6, i1, i2, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i3) | 0, i4, i5);
 return;
}

function __Z36UploadHandler_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 8 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
  __Z23scripting_gchandle_freej(HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 __ZN13UploadHandler7ReleaseEv(i2);
 return;
}

function __Z35AnimationState_Set_Custom_PropSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN14AnimationState8SetSpeedEf(i1, f2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 256 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN12b2EPCollider7CollideEP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS7_(i6, i1, i2, i3, i4, i5);
 STACKTOP = i6;
 return;
}

function __Z21AddComponentUncheckedR10GameObjectiP10MonoScriptPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 if (!i4) i1 = 0; else i1 = __ZN10MonoScript8GetClassEv(i4) | 0;
 return __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE(i2, i3, i1, i4, i5) | 0;
}

function _UNITY_FT_List_Iterate(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0, i6 = 0;
 if (!((i1 | 0) != 0 & (i3 | 0) != 0)) {
  i4 = 6;
  return i4 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 } else i2 = i1;
 do {
  i6 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = mftCall_iii(i3 | 0, i2 | 0, i4 | 0) | 0;
  i5 = (i1 | 0) == 0;
  i2 = i5 ? i6 : i2;
 } while (i5 & (i2 | 0) != 0);
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i5 = HEAP32[i1 >> 2] | 0; else i5 = i1;
 i2 = HEAP32[i2 >> 2] | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKc(i1, i2 - i5 | 0, (HEAP32[i3 >> 2] | 0) - i2 | 0, i4) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEES9_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i4 = HEAP32[i1 >> 2] | 0; else i4 = i1;
 i5 = HEAP32[i2 >> 2] | 0;
 i2 = i5 - i4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i1, i2, (HEAP32[i3 >> 2] | 0) - i5 | 0) | 0;
 return i4 + i2 | 0;
}

function __ZNK9Texture2D27IsSupportedReadPixelsFormatE13TextureFormat(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) + -8 | 0;
 if (i1 >>> 0 < 9) i1 = 265 >>> (i1 & 511) & 1; else i1 = 0;
 i2 = i3 + -3 | 0;
 if (i2 >>> 0 >= 18) {
  i3 = (i1 | 0) == (i3 | 0);
  return i3 | 0;
 }
 if (!(147471 >>> i2 & 1)) {
  i3 = (i1 | 0) == (i3 | 0);
  return i3 | 0;
 } else return 1;
 return 0;
}

function __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_S2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f5 = f0, f6 = f0;
 f5 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f5 = Math_fround(f5 - Math_fround(HEAPF32[i4 + 4 >> 2]));
 i4 = i3 + 4 | 0;
 f6 = Math_fround(f5 / Math_fround(HEAPF32[i4 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(f6 * Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i4 >> 2] = f5;
 return;
}

function __ZN8Collider22GetPositionAndRotationERK9TransformR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1 + 16 | 0;
 i4 = i1;
 __ZNK9Transform11GetPositionEv(i5, i2);
 __ZNK9Transform11GetRotationEv(i4, i2);
 __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i3, i5, i4);
 STACKTOP = i1;
 return;
}

function __ZN5physx8debugger4comm11DeriveClass9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 return;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 147876 + 8;
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[HEAP32[i2 + 84 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN5physx7NpShape15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 __ZN5physx2Sc9ShapeCore15importExtraDataERNS_24PxDeserializationContextE(i2 + 48 | 0, i1);
 i1 = i1 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 i4 = i4 + 4 | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i2 + 192 >> 2] = (i3 | 0) == 0 ? 0 : i4;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i3;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0;
 f1 = Math_fround(Math_fround(1.0) - f1);
 if (f1 != Math_fround(0.0)) f1 = Math_fround(Math_fround(+Math_log(+f1)) / Math_fround(.693147182)); else f1 = Math_fround(-128.0);
 i2 = i3 + 500 | 0;
 if (f1 == Math_fround(HEAPF32[i2 >> 2])) return;
 HEAPF32[i2 >> 2] = f1;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Gu5Debug9visualizeERKNS_20PxConvexMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj(i6, i8, i3, i4, i1, i2, f5, i7) {
 i6 = i6 | 0;
 i8 = i8 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f5 = Math_fround(f5);
 i7 = i7 | 0;
 __ZNK5physx2Gu10ConvexMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_9PxBounds3Eyfj(HEAP32[i6 + 32 >> 2] | 0, i8, i3, i4, i1, i2, f5, i7);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Unity14CharacterJoint19SetEnableProjectionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 172 | 0;
 HEAP8[i3 >> 0] = i2 & 1;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, 6, (HEAP8[i3 >> 0] | 0) != 0 | 0);
 return;
}

function __ZN5Umbra11PatchWriterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 i3 = i1 + 8 | 0;
 if (HEAP8[i3 >> 0] | 0) {
  STACKTOP = i4;
  return;
 }
 HEAP8[i3 >> 0] = 1;
 HEAP32[i2 >> 2] = -2;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0, 12) | 0;
 STACKTOP = i4;
 return;
}

function __ZN5FlareD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 32876 + 8;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 36 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -32 - i3 | 0) >>> 5) << 5);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN3MBP11freeBuffersEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i3 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i4, i2);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 92 >> 2] = 0;
 __ZN5physx2Gu9Container5EmptyEv(i3 + 5236 | 0) | 0;
 STACKTOP = i4;
 return;
}

function __ZN22SharedSpriteRenderDataD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 45376 + 8;
 i1 = i2 + 28 | 0;
 if ((HEAP32[i2 + 44 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 32 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 8 | 0;
 if ((HEAP32[i2 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 12 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22SharedSpriteRenderDataD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 45376 + 8;
 i2 = i1 + 28 | 0;
 if ((HEAP32[i1 + 44 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 32 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 8 >> 2] | 0, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN18PlatformEffector2D15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 802207 | 0, gb + 806901 | 0, gb + 802245 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 802207 | 0, gb + 806910 | 0, gb + 802290 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 802207 | 0, gb + 806925 | 0, gb + 802308 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 802207 | 0, gb + 806938 | 0, gb + 802324 | 0);
 return;
}

function __ZN14StackAllocator16FrameMaintenanceEb(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i1 = HEAP32[i4 + 40 >> 2] | 0;
 i2 = i4 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 if (HEAP32[i4 + 52 >> 2] | 0) return;
 i5 = i4 + 32 | 0;
 HEAP32[i5 >> 2] = __ZN13MemoryManager18LowLevelReallocateEPvjj(HEAP32[i5 >> 2] | 0, i1, i3) | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i4 + 20 >> 2] = i1;
 return;
}

function __ZN14GrowableBuffer13EnlargeBufferEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i2 = i3 - i2 | 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = i1 + 12 | 0;
 i2 = (i2 >>> 0 < i4 >>> 0 ? i4 : i2) + (HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i2;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(HEAP32[i3 >> 2] | 0, i2, 64, i1, 0, gb + 389912 | 0, 37) | 0;
 return;
}

function __ZN13RenderTexture19SetAutoGenerateMipsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 117 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP8[i3 >> 0] = i2 & 1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409651 | 0, 0, gb + 406201 | 0, 878, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __Z42AudioReverbZone_Set_Custom_PropReflectionsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 80 >> 2] = i2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36ComputeBuffer_CUSTOM_SetCounterValueP12Il2CppObjectj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN13ComputeBuffer15SetCounterValueEj(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z35PlatformDeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP16[i4 >> 1] = 47;
 __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z20Graphics_CUSTOM_BlitP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[gb + 1166248 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture(i4, i2, i1);
 return;
}

function _tt_cmap0_char_next(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i3 = (HEAP32[i1 + 16 >> 2] | 0) + 6 | 0;
 i2 = 0;
 i1 = HEAP32[i4 >> 2] | 0;
 while (1) {
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= 256) {
   i1 = 0;
   i3 = 4;
   break;
  }
  i5 = HEAP8[i3 + i1 >> 0] | 0;
  i2 = i5 & 255;
  if (i5 << 24 >> 24) {
   i3 = 4;
   break;
  }
 }
 if ((i3 | 0) == 4) {
  HEAP32[i4 >> 2] = i1;
  return i2 | 0;
 }
 return 0;
}

function _cf2_stack_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 i3 = _UNITY_ft_mem_qalloc(i1, 396, i5) | 0;
 if (HEAP32[i5 >> 2] | 0) {
  STACKTOP = i4;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 392 >> 2] = i3 + 8;
 STACKTOP = i4;
 return i3 | 0;
}

function ___string_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + 84 | 0;
 i6 = HEAP32[i4 >> 2] | 0;
 i7 = i3 + 256 | 0;
 i5 = _memchr(i6, 0, i7) | 0;
 i5 = (i5 | 0) == 0 ? i7 : i5 - i6 | 0;
 i3 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 _memcpy(i2 | 0, i6 | 0, i3 | 0) | 0;
 HEAP32[i1 + 4 >> 2] = i6 + i3;
 i2 = i6 + i5 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i4 >> 2] = i2;
 return i3 | 0;
}

function __ZZN10Collider2D15InitializeClassEvEN33FunctorImpl_82kDidRemoveComponent4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = i3 + 156 | 0;
 if ((i2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) == 0) return;
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 153580 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 153580 + 28 >> 2] | 0) >>> 0) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZThn8_N12_GLOBAL__N_117ConnectionManager14onDeallocationEPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i2 = i1 + -8 | 0;
 i4 = i2 + 184 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i2 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i4 = i1;
  mftCall_vii(i4 | 0, i2 | 0, i3 | 0);
  return;
 } else {
  i4 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
  mftCall_vii(i4 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8pop_backEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 + 3 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i2 = i1 + 4 | 0;
  i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 << 2) >> 2] = 0;
 } else {
  i3 = (i3 & 255) + -1 | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP32[i1 + (i3 << 2) >> 2] = 0;
 }
 return;
}

function __ZNK11Rigidbody2D18GetAngularVelocityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 if ((HEAP32[i1 + 68 >> 2] | 0) == 2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(Math_fround(HEAPF32[((HEAP8[i1 + 227 >> 0] | 0) == 0 ? i2 + 72 | 0 : i1 + 220 | 0) >> 2]) * Math_fround(57.2957802));
 return Math_fround(f3);
}

function __ZN5physx8debugger4comm10EventGroup9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148912 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn13XmlWriterImplD0Ev(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0, i5 = 0;
 HEAP32[i4 >> 2] = gb + 146492 + 8;
 i2 = i4 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i4);
  return;
 }
 i3 = i4 + 8 | 0;
 do {
  HEAP32[i2 >> 2] = i1 + -1;
  i5 = HEAP32[i3 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 12 >> 2] | 0, i5 | 0);
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != 0);
 __ZdlPv(i4);
 return;
}

function __ZN5physx2Gu9ContainerC2ERKS1_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 i4 = i2 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAPF32[i2 + 12 >> 2] = Math_fround(2.0);
 __ZN5physx2Gu9Container7SetSizeEj(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 _memcpy(HEAP32[i4 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 99672 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra10StackAllocC2ERS0_(i5, i1) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 HEAP32[i5 >> 2] = i1;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = i1 + 12 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = i6 + -16 - i1 & -16;
 i3 = i1 + i4 | 0;
 if (i3 >>> 0 > i6 >>> 0) i1 = 0; else HEAP32[i2 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i1;
 HEAP32[i5 + 8 >> 2] = i1 + i4;
 HEAP32[i5 + 12 >> 2] = i1;
 HEAP32[i5 + 16 >> 2] = i4;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 48 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN13OcclusionArea5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 HEAP8[i1 + 56 >> 0] = 1;
 return;
}

function __ZN12LightsModule20ResetUsedLightsCacheEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i1 + 584 | 0;
 i4 = i1 + 576 | 0;
 i1 = i1 + 580 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i4 | 0)) return;
 i5 = HEAP32[i3 >> 2] | 0;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 >> 2] = i5;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i3;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i4 >> 2] = i4;
 return;
}

function __Z38AnimationState_Set_Custom_PropWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN14AnimationState11SetWrapModeEi(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z37AsyncOperation_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
}

function __Z35RenderTexture_CUSTOM_GetDepthBufferP12Il2CppObjectP21ScriptingRenderBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i1 | 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
   __ZN13RenderTexture6CreateEv(i1) | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 136 >> 2];
   return;
  }
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __Z35RenderTexture_CUSTOM_GetColorBufferP12Il2CppObjectP21ScriptingRenderBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 | 0) {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i1 | 0) {
   HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
   __ZN13RenderTexture6CreateEv(i1) | 0;
   HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 128 >> 2];
   return;
  }
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __Z34Camera_CUSTOM_SetTargetBuffersImplP12Il2CppObjectP21ScriptingRenderBufferS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN6Camera22SetTargetBuffersScriptEiPK21ScriptingRenderBufferPS0_(i4, 1, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34AnimationState_Set_Custom_PropTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN14AnimationState7SetTimeEf(i1, f2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function _wcsncmp(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 L1 : do if (!i3) i1 = 0; else {
  while (1) {
   i4 = HEAP32[i2 >> 2] | 0;
   i5 = HEAP32[i1 >> 2] | 0;
   if ((i5 | 0) == 0 | ((i4 | 0) == 0 | (i4 | 0) != (i5 | 0))) break;
   i3 = i3 + -1 | 0;
   if (!i3) {
    i1 = 0;
    break L1;
   } else {
    i1 = i1 + 4 | 0;
    i2 = i2 + 4 | 0;
   }
  }
  i1 = i4 - i5 | 0;
 } while (0);
 return i1 | 0;
}

function _ualarm(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i3;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i2;
 i4 = i5 + 8 | 0;
 HEAP32[i4 >> 2] = 0;
 i2 = i5 + 12 | 0;
 HEAP32[i2 >> 2] = i1;
 _setitimer(0, i5 | 0, i5 | 0) | 0;
 STACKTOP = i3;
 return ((HEAP32[i4 >> 2] | 0) * 1e6 | 0) + (HEAP32[i2 >> 2] | 0) | 0;
}

function _tre_ast_new_iter(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i1 = _tre_ast_new_node(i1, 2, 16) | 0;
 if (!i1) i1 = 0; else {
  i6 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i6 >> 2] = i2;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[i6 + 8 >> 2] = i4;
  i4 = i6 + 12 | 0;
  HEAP8[i4 >> 0] = HEAP8[i4 >> 0] & -2 | i5 & 1;
  HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 }
 return i1 | 0;
}

function _jpeg_set_marker_processor(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 404 >> 2] | 0;
 if ((i2 | 0) == 254) {
  HEAP32[i4 + 24 >> 2] = i3;
  return;
 }
 if ((i2 & -16 | 0) == 224) {
  HEAP32[i4 + 28 + (i2 + -224 << 2) >> 2] = i3;
  return;
 } else {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 68;
  HEAP32[i4 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
  return;
 }
}

function __ZZN8Renderer15InitializeClassEvEN28FunctorImpl_131kLayerChanged4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i1 = i3 + 284 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i4 = __Z16GetRendererScenev() | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0) | 0;
 HEAP32[(HEAP32[i4 + 60 >> 2] | 0) + (i2 * 24 | 0) + 4 >> 2] = i3;
 return;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 85436 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85436 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 85388 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85388 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 86012 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 86012 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 84176 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 84176 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx2Sc16ArticulationCore22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_(i1, i6, i5, i2, i3, i4, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i7 = i7 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZNK5physx2Sc15ArticulationSim22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_(i1, i6, i5, i2, i3, i4, i7);
 return;
}

function __ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 92 >> 2] | 0) + 4 | 0;
 i2 = i3 + (HEAP32[i3 >> 2] | 0) + (i2 << 2) | 0;
 i1 = (HEAP32[i1 + 100 >> 2] | 0) + 4 | 0;
 i1 = i1 + (HEAP32[i1 >> 2] | 0) + (HEAP32[i2 + (HEAP32[i2 >> 2] | 0) >> 2] << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return (HEAP8[((i2 | 0) == 0 ? 0 : i1 + i2 | 0) + 81 >> 0] | 0) != 0 | 0;
}

function __ZN5physx2Gu12TriangleMeshD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 107420 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107420 + 88;
 i3 = i1 + 16 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i3);
 __ZN5physx20InternalTriangleMeshD2Ev(i3);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5Unity5Cloth21SetCollisionMassScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (f1 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 832, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i2 + 88 >> 2] = f1;
 i2 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 380 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN26DownloadHandlerAssetBundle7PrepareEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 i1 = HEAP8[i3 + 176 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) i1 = HEAP32[i3 + 180 >> 2] | 0; else i1 = i1 & 255;
 if (i1 | 0) if (__ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv(i3) | 0) {
  HEAP32[i2 + 28 >> 2] = 2;
  i3 = 1;
  return i3 | 0;
 }
 HEAP32[i2 + 28 >> 2] = 1;
 i3 = 0;
 return i3 | 0;
}

function __ZN16MessageForwarder18HasMessageCallbackERK17MessageIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) < ((HEAP32[i1 + 4 >> 2] | 0) - i4 >> 2 | 0)) if (HEAP32[i4 + (i3 << 2) >> 2] | 0) {
  i4 = 1;
  return i4 | 0;
 }
 if (!(HEAP32[i1 + 24 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = (HEAP32[i2 + 16 >> 2] & 1 | 0) != 0;
 return i4 | 0;
}

function __ZN12SocketStream4RecvEPvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = __ZN6Socket4RecvEPvjP12RecvUserData(i3, i1, i2, 0) | 0;
 if (i1 | 0) {
  if ((i1 | 0) >= 0) {
   i3 = i1;
   return i3 | 0;
  }
  if (__ZN6Socket15WouldBlockErrorEv() | 0) {
   i3 = i1;
   return i3 | 0;
  }
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0);
 i3 = i1;
 return i3 | 0;
}

function __ZN12ImageFilters20GetTargetAfterOpaqueEbb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 do if ((HEAP32[i1 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0)) i1 = i1 + 24 | 0; else {
  if (!((HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0) | i2)) {
   i1 = i1 + 24 | 0;
   break;
  }
  if (i2 | i3 ^ 1) {
   i1 = i1 + 28 | 0;
   break;
  } else {
   i1 = i1 + 24 | 0;
   break;
  }
 } while (0);
 return HEAP32[i1 >> 2] | 0;
}

function __ZN12FileAccessorD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 70828 + 8;
 if (HEAP8[i2 + 1064 >> 0] | 0) {
  i1 = HEAP32[i2 + 1048 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 4 | 0) | 0;
 }
 i1 = HEAP32[i2 + 1044 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN11UnityEngine7Connect15AppRunningEventC2Ejjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1040034 | 0, 0);
 HEAP32[i1 >> 2] = gb + 188876 + 8;
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i3;
 HEAP32[i1 + 40 >> 2] = i4;
 HEAP32[i1 + 44 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __Z60Gyroscope_CUSTOM_INTERNAL_CALL_rotationRateUnbiased_InternaliR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z27GetGyroRotationRateUnbiasedi(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __Z50Renderer_Set_Custom_PropMotionVectorGenerationModeP12Il2CppObject26MotionVectorGenerationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Renderer29SetMotionVectorGenerationModeE26MotionVectorGenerationMode(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AnchoredJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 80 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 76 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41NavMeshAgent_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK8Vector3fP10NavMeshHit(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return (__ZNK12NavMeshAgent7RaycastERK8Vector3fP10NavMeshHit(i4, i2, i3) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36CullingGroup_CUSTOM_FinalizerFailureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 510390 | 0, 0, gb + 510287 | 0, 232, 1, 0, 0, 0);
 i2 = i1 + 8 | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else __ZN12CullingGroupD2Ev(i1);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63600 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z34RectOffset_Get_Custom_PropVerticalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 12 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z27CalculateShadowSphereOffsetbf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (i1) {
  f2 = Math_fround(.400000006);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(1.0) - Math_fround(f2 / Math_fround(180.0)));
 i1 = f2 < Math_fround(0.0);
 i3 = f2 > Math_fround(1.0);
 f2 = Math_fround((i3 ? Math_fround(1.0) : f2) * Math_fround(.400000006));
 f2 = i1 ? Math_fround(0.0) : f2;
 return Math_fround(f2);
}

function _UNITY_FT_New_Face(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 if (!i2) {
  i5 = 6;
  STACKTOP = i6;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = 4;
 HEAP32[i5 + 12 >> 2] = i2;
 HEAP32[i5 + 16 >> 2] = 0;
 i5 = _UNITY_FT_Open_Face(i1, i5, i3, i4) | 0;
 STACKTOP = i6;
 return i5 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4initEPv(i2, i3);
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = -1;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + (HEAP32[i4 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 __ZNSt3__28ios_base4initEPv(i2, i3);
 HEAP32[i2 + 72 >> 2] = 0;
 HEAP32[i2 + 76 >> 2] = -1;
 return;
}

function __ZNK9dtNavMesh14getPolyRefBaseEPK10dtMeshTile(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i3 = (i2 - (HEAP32[i1 + 20 >> 2] | 0) | 0) / 56 | 0;
 i2 = _bitshift64Shl(HEAP32[i2 + 4 >> 2] | 0, 0, 48) | 0;
 i1 = getTempRet0() | 0;
 i3 = _bitshift64Shl(i3 | 0, 0, 20) | 0;
 i1 = getTempRet0() | 0 | i1;
 i2 = i3 | i2;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN9Animation10RemoveClipER13AnimationClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = gb + 179124 + 8;
 HEAP32[i4 + 4 >> 2] = i2;
 mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 __ZN9Animation10RemoveClipERK19ShouldRemoveFunctorPKc(i1, i4, 0);
 STACKTOP = i3;
 return;
}

function __ZN8GUIState23GetNameOfFocusedControlEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
  return;
 } else {
  __ZN5IMGUI19NamedKeyControlList16GetNameOfControlEi(i1, i3, HEAP32[i2 >> 2] | 0);
  return;
 }
}

function __ZN5physx35PxVehicleChassisDataGeneratedValuesC2EPKNS_20PxVehicleChassisDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx13NpVolumeCache21setMaxNbDynamicShapesEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 100 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > i2 >>> 0) {
  HEAP8[i3 + 117 >> 0] = 1;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 76 >> 2] = i2;
 if ((HEAP32[i3 + 104 >> 2] & 2147483647) >>> 0 >= i2 >>> 0) return;
 __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i3 + 96 | 0, i2);
 return;
}

function __ZN26DownloadHandlerAssetBundleD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 187296 + 8;
 i2 = i1 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN26DownloadHandlerAssetBundleD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 187296 + 8;
 i1 = i3 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = gb + 187368 + 8;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 __Z23scripting_gchandle_freej(i1);
 __ZdlPv(i3);
 return;
}

function __ZN11TerrainData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN13SplatDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN14DetailDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 128 | 0, i2);
 __ZN9Heightmap8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 248 | 0, i2);
 return;
}

function __Z53AudioHighPassFilter_Set_Custom_PropHighpassResonanceQP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 48 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45WheelCollider_CUSTOM_ConfigureVehicleSubstepsP12Il2CppObjectfii(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN13WheelCollider24ConfigureVehicleSubstepsEfii(i5, f2, i3, i4);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29ComputeShader_CUSTOM_DispatchP12Il2CppObjectiiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 if (!i1) i1 = 0; else {
  i6 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i6) {
   __ZN13ComputeShader21DispatchComputeShaderEjiii(i6, i2, i3, i4, i5) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Event_Set_Custom_PropKeyCodeP12Il2CppObjecti(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i1 & 65535;
 if (i2 | 0) {
  i1 = HEAP32[i2 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP16[i1 + 38 >> 1] = i3;
   STACKTOP = i5;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i4);
}

function __Z25GetAudioEffectDefinitionsjPPP26UnityAudioEffectDefinition(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = HEAP32[gb + 1162584 >> 2] | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 if ((((HEAP32[i4 + 4 >> 2] | 0) - i2 | 0) / 24 | 0) >>> 0 <= i1 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i2 + (i1 * 24 | 0) + 12 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_ii(i1 | 0, i3 | 0) | 0;
 return i4 | 0;
}

function _UNITY_png_muldiv(i5, i2, i3, i4) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d1 = 0.0;
 if (!i4) {
  i5 = 0;
  return i5 | 0;
 }
 if ((i2 | 0) == 0 | (i3 | 0) == 0) {
  HEAP32[i5 >> 2] = 0;
  i5 = 1;
  return i5 | 0;
 }
 d1 = +Math_floor(+(+(i2 | 0) * +(i3 | 0) / +(i4 | 0) + .5));
 if (!(d1 <= 2147483647.0 & d1 >= -2147483648.0)) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = ~~d1;
 i5 = 1;
 return i5 | 0;
}

function _lcong48(i1) {
 i1 = i1 | 0;
 HEAP16[gb + 228072 >> 1] = HEAP16[i1 >> 1] | 0;
 HEAP16[gb + 228072 + 2 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
 HEAP16[gb + 228072 + 4 >> 1] = HEAP16[i1 + 4 >> 1] | 0;
 HEAP16[gb + 228072 + 6 >> 1] = HEAP16[i1 + 6 >> 1] | 0;
 HEAP16[gb + 228072 + 8 >> 1] = HEAP16[i1 + 8 >> 1] | 0;
 HEAP16[gb + 228072 + 10 >> 1] = HEAP16[i1 + 10 >> 1] | 0;
 HEAP16[gb + 228072 + 12 >> 1] = HEAP16[i1 + 12 >> 1] | 0;
 return;
}

function _jpeg_write_m_header(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((HEAP32[i1 + 208 >> 2] | 0) == 0 & (i4 + -101 | 0) >>> 0 < 3)) {
  i5 = HEAP32[i1 >> 2] | 0;
  HEAP32[i5 + 20 >> 2] = 20;
  HEAP32[i5 + 24 >> 2] = i4;
  mftCall_vi(HEAP32[i5 >> 2] | 0, i1 | 0);
 }
 mftCall_viii(HEAP32[(HEAP32[i1 + 332 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
 return;
}

function _jinit_marker_writer(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 1, 32) | 0;
 HEAP32[i1 + 332 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 3250;
 HEAP32[i2 + 4 >> 2] = fb + 3251;
 HEAP32[i2 + 8 >> 2] = fb + 3252;
 HEAP32[i2 + 12 >> 2] = fb + 3253;
 HEAP32[i2 + 16 >> 2] = fb + 3254;
 HEAP32[i2 + 20 >> 2] = fb + 485;
 HEAP32[i2 + 24 >> 2] = fb + 2360;
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdatePresentAfterDrawstruct7ForwardEv() {
 var i1 = 0, i2 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 if (__Z11IsBatchmodev() | 0) return;
 i2 = __Z12GetGfxDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 488 >> 2] | 0, i2 | 0) | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 500 >> 2] | 0, i2 | 0);
 __Z16PresentAfterDrawN9GfxDevice11PresentModeE(i1);
 return;
}

function __ZNSt3__28ios_base4initEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 + 16 >> 2] = (i1 | 0) == 0 & 1;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 4098;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 6;
 i3 = i2 + 28 | 0;
 i1 = i2 + 32 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 __ZNSt3__26localeC2Ev(i3);
 return;
}

function __ZNSt3__225notify_all_at_thread_exitERNS_18condition_variableENS_11unique_lockINS_5mutexEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = _pthread_getspecific(HEAP32[(__ZNSt3__219__thread_local_dataEv() | 0) >> 2] | 0) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP8[i2 + 4 >> 0] = 0;
 __ZNSt3__215__thread_struct25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE(i4, i1, i3);
 return;
}

function __ZNK15Lz4Decompressor16DecompressMemoryEPKvPjPvS2_(i1, i3, i2, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 >>> 0 >= 2147483647) {
  i5 = 0;
  return i5 | 0;
 }
 i2 = HEAP32[i5 >> 2] | 0;
 if (i2 >>> 0 >= 2147483647) {
  i5 = 0;
  return i5 | 0;
 }
 i4 = _UNITY_LZ4_decompress_safe(i3, i4, i1, i2) | 0;
 HEAP32[i5 >> 2] = i4;
 i5 = (i4 | 0) > 0;
 return i5 | 0;
}

function __ZN9Transform4FindEPKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 i4 = HEAP32[i2 + 92 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (!i4) {
  i4 = i2;
  return i4 | 0;
 }
 while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = i2;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN8GUIState19GetIDOfNamedControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 return i2 | 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148548 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx35PxcContactCapsuleHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu25contactCapsuleHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx2Sc18ParticleSystemCore13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i2, i4, i3, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0, i5 | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 __ZN5physx2Sc5Scene29processNarrowPhaseTouchEventsEv(i2);
 __ZN5physx10PxsContext13updateIslandsEfPNS_10PxBaseTaskE(i3, Math_fround(HEAPF32[i2 + 64 >> 2]), i1);
 return;
}

function __ZN5physx14PxsAABBManager8destroyVEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = HEAP32[i1 + 49828 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] | 0, i3 | 0);
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx14PxsAABBManagerD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Unity5Cloth18SetSolverFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (f1 < Math_fround(1.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838940 | 0, 0, gb + 838562 | 0, 873, 1, 0, 0, 0);
  f1 = Math_fround(1.0);
 }
 HEAPF32[i2 + 120 >> 2] = f1;
 i2 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN15RelativeJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13RenderTexture15SetAsEyeTextureEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 119 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP8[i3 >> 0] = i2 & 1;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409729 | 0, 0, gb + 406201 | 0, 896, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13GfxDeviceGLES13ReadbackImageER14ImageReferenceiiiiii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0;
 __ZN18GfxFramebufferGLES7PrepareEv(i1);
 return __ZN18GfxFramebufferGLES13ReadbackImageER14ImageReferenceiiiiii(i1, i2, i3, i4, i5, i6, i7, i8) | 0;
}

function __ZN13BoxCollider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 0;
 i4 = gb + 1162356 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 + 53 >> 0] = 0;
 HEAPF32[i1 + 160 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 164 >> 2] = Math_fround(1.0);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager29getAndAddRefCurrentConnectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) i1 = 0; else {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
  i1 = HEAP32[i1 >> 2] | 0;
 }
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return i1 | 0;
}

function __ZN11JpegDecoderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 43136 + 8;
 i3 = i2 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  _jpeg_destroy_decompress(i1);
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 }
 i1 = i2 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdlPv(i2);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11HaloManager4HaloC2ERK8Vector3fRK11ColorRGBA32fij(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i3 >> 2];
 HEAPF32[i1 + 28 >> 2] = f4;
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i1 + 36 >> 2] = i6;
 return;
}

function __ZN10Matrix4x4fmLERKS_(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i5;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i4, i1, i2);
 i1 = i4;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 STACKTOP = i5;
 return i4 | 0;
}

function __Z52AudioDistortionFilter_Set_Custom_PropDistortionLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 44 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51AudioLowPassFilter_Set_Custom_PropLowpassResonanceQP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 132 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44RenderTexture_CUSTOM_INTERNAL_CALL_IsCreatedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   if (HEAP32[i2 + 128 >> 2] | 0) {
    i2 = 1;
    return i2 | 0;
   }
   i2 = (HEAP32[i2 + 136 >> 2] | 0) != 0 & 1;
   return i2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40TargetJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 88 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 84 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40TargetJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 80 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 76 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_png_get_sCAL(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 16384)) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = HEAPU8[i2 + 232 >> 0];
 HEAPF64[i4 >> 3] = +_atof(HEAP32[i2 + 236 >> 2] | 0);
 HEAPF64[i5 >> 3] = +_atof(HEAP32[i2 + 240 >> 2] | 0);
 i5 = 16384;
 return i5 | 0;
}

function _UNITY_png_create_read_struct_2(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i1 = _UNITY_png_create_png_struct(i1, i2, i3, i4, i5, i6, i7) | 0;
 if (!i1) return i1 | 0;
 HEAP32[i1 + 204 >> 2] = 32768;
 HEAP32[i1 + 652 >> 2] = 8192;
 i7 = i1 + 208 | 0;
 HEAP32[i7 >> 2] = HEAP32[i7 >> 2] | 3145728;
 _UNITY_png_set_read_fn(i1, 0, 0);
 return i1 | 0;
}

function _UNITY_ft_glyphslot_free_bitmap(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 156 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) if (HEAP32[i3 + 4 >> 2] & 1 | 0) {
  i3 = i1 + 88 | 0;
  _UNITY_ft_mem_free(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i3 >> 2] | 0);
  HEAP32[i3 >> 2] = 0;
  i3 = (HEAP32[i2 >> 2] | 0) + 4 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -2;
  return;
 }
 HEAP32[i1 + 88 >> 2] = 0;
 return;
}

function _pwritev(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = 0;
 i4 = ___syscall_ret(___syscall334(334, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _ether_ntoa_r(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = i4;
 i2 = 0;
 do {
  HEAP32[i5 >> 2] = HEAPU8[i3 + i2 >> 0];
  i1 = i1 + (_sprintf(i1, (i2 | 0) == 0 ? gb + 1074088 | 0 : gb + 1074093 | 0, i5) | 0) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 6);
 STACKTOP = i6;
 return i4 | 0;
}

function _close_file(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (i1 | 0) {
  if ((HEAP32[i1 + 76 >> 2] | 0) > -1) ___lockfile(i1) | 0;
  if ((HEAP32[i1 + 20 >> 2] | 0) >>> 0 > (HEAP32[i1 + 28 >> 2] | 0) >>> 0) mftCall_iiii(HEAP32[i1 + 36 >> 2] | 0, i1 | 0, 0, 0) | 0;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  if (i2 >>> 0 < i3 >>> 0) mftCall_iiii(HEAP32[i1 + 40 >> 2] | 0, i1 | 0, i2 - i3 | 0, 1) | 0;
 }
 return;
}

function ___sin(d1, d2, i5) {
 d1 = +d1;
 d2 = +d2;
 i5 = i5 | 0;
 var d3 = 0.0, d4 = 0.0, d6 = 0.0;
 d6 = d1 * d1;
 d3 = d6 * (d6 * d6) * (d6 * 1.58969099521155e-10 + -2.5050760253406863e-08) + (d6 * (d6 * 2.7557313707070068e-06 + -1.984126982985795e-04) + .00833333333332249);
 d4 = d6 * d1;
 if (!i5) d1 = d4 * (d6 * d3 + -.16666666666666632) + d1; else d1 = d1 - (d4 * .16666666666666632 + (d6 * (d2 * .5 - d4 * d3) - d2));
 return +d1;
}

function ___fmodeflags(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = (_strchr(i1, 43) | 0) == 0;
 i2 = HEAP8[i1 >> 0] | 0;
 i3 = i3 ? i2 << 24 >> 24 != 114 & 1 : 2;
 i4 = (_strchr(i1, 120) | 0) == 0;
 i3 = i4 ? i3 : i3 | 128;
 i1 = (_strchr(i1, 101) | 0) == 0;
 i1 = i1 ? i3 : i3 | 524288;
 i1 = i2 << 24 >> 24 == 114 ? i1 : i1 | 64;
 i1 = i2 << 24 >> 24 == 119 ? i1 | 512 : i1;
 return (i2 << 24 >> 24 == 97 ? i1 | 1024 : i1) | 0;
}

function __ZThn12_N5physx3Ext14SphericalJointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88796 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88796 + 200;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZThn12_N5physx3Ext14PrismaticJointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88228 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88228 + 216;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNK6Avatar13GetHumanScaleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) f2 = Math_fround(1.0); else {
  i1 = i1 + 20 | 0;
  i3 = HEAP32[i1 >> 2] | 0;
  if (!i3) f2 = Math_fround(1.0); else {
   i1 = i3 + i1 | 0;
   i3 = i1 + 40 | 0;
   if (!(HEAP32[(HEAP32[i3 >> 2] | 0) + i3 >> 2] | 0)) f2 = Math_fround(1.0); else f2 = Math_fround(HEAPF32[i1 + 360 >> 2]);
  }
 }
 return Math_fround(f2);
}

function __ZN9GfxDevice21RegisterNativeTextureE9TextureIDi16TextureDimension(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i5 = i1;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 __ZN12TextureIdMap13UpdateTextureE9TextureIDi(i2, i4);
 STACKTOP = i1;
 return;
}

function __ZN9AudioClip6ReloadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 108 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 112 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 1048576)) return;
 __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
 return;
}

function __ZN8Gradient13SwapAlphaKeysEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i7 = i1 + (i2 << 2) + 3 | 0;
 i5 = HEAP8[i7 >> 0] | 0;
 i6 = i1 + 48 + (i2 << 1) | 0;
 i2 = HEAP16[i6 >> 1] | 0;
 i4 = i1 + (i3 << 2) + 3 | 0;
 HEAP8[i7 >> 0] = HEAP8[i4 >> 0] | 0;
 i3 = i1 + 48 + (i3 << 1) | 0;
 HEAP16[i6 >> 1] = HEAP16[i3 >> 1] | 0;
 HEAP8[i4 >> 0] = i5;
 HEAP16[i3 >> 1] = i2;
 return;
}

function __ZN8Collider16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i2 & 64 | 0) == 0 | (i3 | 0) == 0) return;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0) | 0) + 8 >> 2] | 0;
 if ((__ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody(i1, 0) | 0) == (i3 | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8Animator14GetAvatarScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) {
  HEAPF32[i1 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
  return;
 } else {
  i2 = HEAP32[i2 + 136 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 28 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 32 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 36 >> 2];
  return;
 }
}

function __ZN5physx6shdfnd9SListImpl3popEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 if (i2 | 0) while (1) {
  if (HEAP32[i1 >> 2] | 0) continue;
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = 1;
  if (!i2) break;
 }
 i2 = HEAP32[i3 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return i2 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 >> 2] = 0;
 return i2 | 0;
}

function __ZN5physx31PxcPCMContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu28pcmContactCapsuleHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx2Sc18ParticleSystemCore12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i2, i4, i3, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0, i5 | 0);
 return;
}

function __ZN5Unity5Cloth17SetSleepThresholdEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (f1 < Math_fround(0.0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 838858 | 0, 0, gb + 838562 | 0, 883, 1, 0, 0, 0);
  f1 = Math_fround(0.0);
 }
 HEAPF32[i2 + 124 >> 2] = f1;
 i2 = HEAP32[i2 + 228 >> 2] | 0;
 if (!i2) return;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 452 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5Umbra9Matrix2x2mLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 i3 = i1 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 8 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 i3 = i1 + 12 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 return i1 | 0;
}

function __ZN23PreloadManagerOperationC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 65892 + 8;
 HEAP32[i1 + 24 >> 2] = 0;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN22DownloadHandlerTextureD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187656 + 8;
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22DownloadHandlerTextureD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187656 + 8;
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 __ZdlPv(i1);
 return;
}

function __ZN13RenderTexture10SetVRUsageE14VRTextureUsage(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 112 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407812 | 0, 0, gb + 406201 | 0, 891, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13GfxDeviceGLES16BeginBufferWriteEP9GfxBufferjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i2 + 12 >> 2] | 0) == 1) {
  i4 = __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE10BeginWriteEjj(i2, i3, i4) | 0;
  return i4 | 0;
 } else {
  i4 = __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE10BeginWriteEjj(i2, i3, i4) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN11AudioSource12SetStereoPanEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(-1.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i2 ? Math_fround(-1.0) : f1;
 i2 = i3 + 404 | 0;
 if (!(f1 != Math_fround(HEAPF32[i2 >> 2]))) {
  __ZN11AudioSource16UpdateParametersEv(i3);
  return;
 }
 HEAPF32[i2 >> 2] = f1;
 __ZN11AudioSource16UpdateParametersEv(i3);
 return;
}

function __Z37UnityWebRequest_Get_Custom_PropIsDoneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return ((HEAP32[i1 + 108 >> 2] | 0) + -3 | 0) >>> 0 < 2 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z37AudioReverbZone_Set_Custom_PropRoomLFP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 68 >> 2] = i2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioReverbZone_Set_Custom_PropRoomHFP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 64 >> 2] = i2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioReverbZone_Set_Custom_PropReverbP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 88 >> 2] = i2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36RectOffset_Get_Custom_PropHorizontalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 4 >> 2] | 0) + (HEAP32[i1 >> 2] | 0) | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function _UNITY_LZ4_compress_limitedOutput_withState(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i1 & 3 | 0) {
  i5 = 0;
  return i5 | 0;
 }
 _memset(i1 | 0, 0, 16416) | 0;
 if ((i4 | 0) < 65547) {
  i5 = _LZ4_compress_generic(i1, i2, i3, i4, i5, 1, 2, 0, 0) | 0;
  return i5 | 0;
 } else {
  i5 = _LZ4_compress_generic(i1, i2, i3, i4, i5, 1, 0, 0, 0) | 0;
  return i5 | 0;
 }
 return 0;
}

function _preadv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 HEAP32[i6 + 16 >> 2] = 0;
 i4 = ___syscall_ret(___syscall333(333, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZThn12_N5physx3Ext13RevoluteJointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 88500 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88500 + 240;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZThn12_N5physx3Ext13DistanceJointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 87668 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87668 + 228;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNK6Object8HasEventEPFvPvS0_iEPKv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if ((HEAP32[i1 + 8 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZNK6Camera28ExtractCameraRenderingParamsEv(i5, i1);
 __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE(i1, i2, i5, i3);
 STACKTOP = i4;
 return;
}

function __ZN5physx34PxcContactSphereHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu24contactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx34PxcContactConvexHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx13NpVolumeCache20setMaxNbStaticShapesEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 88 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 > i2 >>> 0) {
  HEAP8[i3 + 116 >> 0] = 1;
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i3 + 72 >> 2] = i2;
 if ((HEAP32[i3 + 92 >> 2] & 2147483647) >>> 0 >= i2 >>> 0) return;
 __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i3 + 84 | 0, i2);
 return;
}

function __ZN5Umbra12QueryContext12allocWorkMemEjb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 16 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = i5 + (i2 + 15 & -16) | 0;
 if (i6 >>> 0 > (HEAP32[i1 + 12 >> 2] | 0) >>> 0) {
  i6 = 0;
  return i6 | 0;
 }
 HEAP32[i4 >> 2] = i6;
 if ((i5 | 0) == 0 | i3 ^ 1) {
  i6 = i5;
  return i6 | 0;
 }
 _memset(i5 | 0, 0, i2 | 0) | 0;
 i6 = i5;
 return i6 | 0;
}

function __ZN5Light12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 __ZN15SharedLightData15UpdateTransformERK9Transform(i2, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 __ZN12LightManager8AddLightEP5Light(__Z15GetLightManagerv() | 0, i1);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN31CanvasBatchIntermediateRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv(i1);
 i2 = i1 + 300 | 0;
 i3 = i1 + 316 | 0;
 if ((HEAP32[i3 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 304 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 312 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN22ParticleSystemRenderer6UpdateERK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 568 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 __ZN8Renderer18UpdateManagerStateEb(i1, 1);
 return;
}

function __ZN21DownloadHandlerBufferD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187512 + 8;
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN21DownloadHandlerBufferD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187512 + 8;
 if ((HEAP32[i1 + 36 >> 2] | 0) > -1) {
  i2 = i1 + 20 | 0;
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 24 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 __ZdlPv(i1);
 return;
}

function __ZN13TargetJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13ProbeRenderer8ConvolveEbijjb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i7 = 0, i8 = 0;
 i7 = i1 + 20 | 0;
 i8 = HEAP32[i7 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i8 >> 2] | 0) + 112 >> 2] | 0, i8 | 0) | 0)) return;
 __Z21CubemapGPUConvolutionP13RenderTextureS0_bijjb(HEAP32[i7 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, i2, i3, i4, i5, i6) | 0;
 return;
}

function __ZN13MemoryManager17GetAllocatorIndexEP13BaseAllocator(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = HEAP32[i2 + 1544 >> 2] | 0;
 if ((i4 | 0) > 0) i1 = 0; else return i4 | 0;
 while (1) {
  if ((HEAP32[i2 + 1568 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = i1 + 1 | 0;
  if ((i1 | 0) >= (i4 | 0)) {
   i1 = i4;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN12MeshRendererD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16SetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEESC_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0, i2, i3);
 return;
}

function __ZN11AudioModule12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN13AudioProfiler12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE(i2, i3, i4, i5);
 return;
}

function __Z9IsSymlinkRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 1072 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN15FileSystemEntryC2EPKc(i3, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 i1 = __ZNK15FileSystemEntry9IsSymLinkEv(i3) | 0;
 __ZN13FileEntryDataD2Ev(i3);
 STACKTOP = i2;
 return i1 | 0;
}

function __Z51CharacterJoint_CUSTOM_INTERNAL_set_twistLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint19SetTwistLimitSpringERK20SoftJointLimitSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51CharacterJoint_CUSTOM_INTERNAL_set_swingLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint19SetSwingLimitSpringERK20SoftJointLimitSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50AudioHighPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 44 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38GUIText_CUSTOM_Internal_GetPixelOffsetP12Il2CppObjectP13Vector2fIcall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = HEAP32[i3 + 72 >> 2] | 0;
   HEAP32[i2 >> 2] = HEAP32[i3 + 68 >> 2];
   HEAP32[i2 + 4 >> 2] = i1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33CullingGroup_CUSTOM_EraseSwapBackP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN12CullingGroup13EraseSwapBackEj(i1, i2);
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 232 | 0;
 i4 = HEAPU16[i4 >> 1] | 0 | (HEAPU8[i4 + 2 >> 0] | 0) << 16;
 if ((i4 & 196608 | 0) == 0 | i2 ^ 1) if ((i4 & 8192 | 0) == 0 | i3 ^ 1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 224 | 0;
 i4 = (HEAPU16[i4 >> 1] | 0) > 65533 ? (HEAPU16[i4 + 2 >> 1] | 0) > 65533 : 0;
 return i4 | 0;
}

function __Z14OptionalMethodPKcS0_S0_S0_(i4, i1, i2, i3, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = __Z12OptionalTypePKcS0_S0_(i1, i2, i3) | 0;
 if (!i1) {
  i2 = gb + 1164176 | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i5 = i4;
  HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i5 + 4 >> 2] = i3;
  return;
 } else {
  __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i4, i1, i5, -1);
  return;
 }
}

function __Z12CollectPPtrsRK6ObjectRNSt3__23setIiNS2_4lessIiEENS2_9allocatorIiEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = gb + 67212 + 8;
 HEAP32[i4 + 4 >> 2] = i2;
 __ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags(i4, HEAP32[i1 + 4 >> 2] | 0, 64) | 0;
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Stream_GetULongLE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 3 | 0;
 if (i4 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i4 = 0;
  HEAP32[i2 >> 2] = i3;
  return i4 | 0;
 }
 i4 = (HEAPU8[i3 + 2 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0);
 i3 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 return i4 | 0;
}

function _t1_hints_stem(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = _UNITY_FT_RoundFix(HEAP32[i1 >> 2] | 0) | 0;
 i1 = _UNITY_FT_RoundFix(HEAP32[i1 + 4 >> 2] | 0) | 0;
 i5 = i2 + 4 | 0;
 if (HEAP32[i5 >> 2] | 0) return;
 i1 = _ps_dimension_add_t1stem(i2 + 16 + ((i3 >>> 0 > 1 ? 1 : i3) * 36 | 0) | 0, i4 >> 16, i1 >> 16, HEAP32[i2 >> 2] | 0, 0) | 0;
 if (!i1) return;
 HEAP32[i5 >> 2] = i1;
 return;
}

function _inet_ntoa(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1 & 255;
 HEAP32[i3 + 4 >> 2] = i1 >>> 8 & 255;
 HEAP32[i3 + 8 >> 2] = i1 >>> 16 & 255;
 HEAP32[i3 + 12 >> 2] = i1 >>> 24;
 _snprintf(gb + 1576132 | 0, 16, gb + 1074236 | 0, i3) | 0;
 STACKTOP = i2;
 return gb + 1576132 | 0;
}

function __ZNSt3__213__lower_boundIRNS_6__lessIjjEEPKjjEET0_S6_S6_RKT1_T_(i4, i5, i1, i2) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i4;
 i1 = i5 - i4 >> 2;
 while (1) {
  if (!i1) break;
  i5 = (i1 | 0) / 2 | 0;
  i6 = i2 + (i5 << 2) | 0;
  i4 = (HEAP32[i6 >> 2] | 0) >>> 0 < i3 >>> 0;
  i2 = i4 ? i6 + 4 | 0 : i2;
  i1 = i4 ? i1 + -1 - i5 | 0 : i5;
 }
 return i2 | 0;
}

function __ZNK9dtNavMesh10getTileRefEPK10dtMeshTile(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i3 = (i2 - (HEAP32[i1 + 20 >> 2] | 0) | 0) / 56 | 0;
 i2 = _bitshift64Shl(HEAP32[i2 + 4 >> 2] | 0, 0, 48) | 0;
 i1 = getTempRet0() | 0;
 i3 = _bitshift64Shl(i3 | 0, 0, 20) | 0;
 i1 = getTempRet0() | 0 | i1;
 i2 = i3 | i2;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK5physx14NpArticulation22computeImpulseResponseEPNS_18PxArticulationLinkERNS_6PxVec3ES4_RKNS_24PxArticulationDriveCacheERKS3_S9_(i6, i5, i4, i1, i2, i3, i7) {
 i6 = i6 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i7 = i7 | 0;
 __ZNK5physx2Sc16ArticulationCore22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_(i6 + 24 | 0, i5 + 64 | 0, i4, i1, i2, i3, i7);
 return;
}

function __ZN9Animation19SetVisibleRenderersEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP8[i1 + 42 >> 0] = i2 & 1;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 i2 = i1 + 256 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) != 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0);
 if (i3 | (HEAP32[i2 >> 2] | 0) == 0) return;
 __ZN9Animation15UpdateAnimationEd(i1, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
 return;
}

function __ZN6Socket4SendEPKvjP12SendUserData(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) i1 = _send(i5, i2, i3, i1) | 0; else i1 = _sendto(i5, i2, i3, i1 | HEAP32[i4 >> 2], HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 + 8 >> 2] | 0) | 0;
 if ((i1 | 0) < 0) return i1 | 0;
 HEAP32[(___errno_location() | 0) >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx7NpActor7OffsetsC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 136) | 0;
 HEAP32[i1 + 24 >> 2] = 12;
 HEAP32[i1 + 20 >> 2] = 12;
 HEAP32[i1 + 44 >> 2] = 12;
 HEAP32[i1 + 48 >> 2] = 12;
 HEAP32[i1 + 60 >> 2] = 12;
 HEAP32[i1 + 40 >> 2] = 12;
 HEAP32[i1 + 92 >> 2] = 48;
 HEAP32[i1 + 88 >> 2] = 48;
 HEAP32[i1 + 112 >> 2] = 20;
 HEAP32[i1 + 116 >> 2] = 20;
 HEAP32[i1 + 128 >> 2] = 48;
 HEAP32[i1 + 108 >> 2] = 20;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148580 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148240 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx35solveContactPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i2);
 __ZN5physxL22concludeContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEjj(HEAP32[i3 + 16 >> 2] | 0, HEAP16[i3 + 26 >> 1] | 0, 144, 128);
 return;
}

function __ZN5physx30PxcPCMContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu27pcmContactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx30PxcPCMContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu27pcmContactConvexHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i2;
 HEAP32[i2 + 8 >> 2] = i2;
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP8[i2 + 32 >> 0] = 0;
 return;
}

function __ZN5physx2Sc15ArticulationSim9setActiveEbj(i1, i6, i7) {
 i1 = i1 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = i1 + 28 | 0;
 i2 = HEAP32[i5 >> 2] | 0;
 if (!i2) return;
 i4 = i1 + 24 | 0;
 i1 = 0;
 do {
  i3 = i1;
  i1 = i1 + 1 | 0;
  __ZN5physx2Sc5Actor9setActiveEbj(HEAP32[(HEAP32[i4 >> 2] | 0) + (i3 << 2) >> 2] | 0, i6, i7);
  i2 = HEAP32[i5 >> 2] | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __ZN5physx19NpClothParticleData7tryLockENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 20 | 0;
 i4 = HEAP8[i1 >> 0] | HEAP8[i3 >> 0];
 HEAP8[i1 >> 0] = i4;
 i2 = i2 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(i4 & 6)) i1 = i1 + 1 | 0; else if (!i1) i1 = 1; else {
  i4 = 0;
  return i4 | 0;
 }
 HEAP8[i3 >> 0] = i4;
 HEAP32[i2 >> 2] = i1;
 i4 = 1;
 return i4 | 0;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 92 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5Umbra10VisibilityC2EPNS_9IndexListEPNS_15OcclusionBufferE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i4 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = 0;
 HEAP32[i4 + 16 >> 2] = 0;
 HEAP32[i4 + 20 >> 2] = 0;
 HEAP32[i4 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 return;
}

function __ZN4FMOD6SoundI4lockEjjPPvS2_PjS3_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if (i4 | 0) HEAP32[i4 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, gb + 64016 | 0, 0, gb + 854034 | 0, 1408) | 0;
 if (i6 | 0) HEAP32[i6 >> 2] = i3;
 if (i5 | 0) HEAP32[i5 >> 2] = 0;
 if (!i7) return 0;
 HEAP32[i7 >> 2] = 0;
 return 0;
}

function __ZN14SafeBinaryRead21CleanupConverterTableEv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 1166052 >> 2] | 0;
 i1 = i2 + 4 | 0;
 __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14Physics2DState7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 __ZN7b2World11DestroyBodyEP6b2Body(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZN7b2WorldD2Ev(i3);
 __ZdlPv(i3);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12InputManager12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1161932 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 HEAP32[gb + 1161932 >> 2] = 0;
 return;
}

function __ZN10AudioMixer13CleanupMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 76 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i4 = HEAP32[i1 + 72 >> 2] | 0;
 __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE(i3, i4, HEAP32[(__Z21GetManagerFromContexti(3) | 0) + 88 >> 2] | 0, i1 + 32 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z49AudioReverbFilter_Set_Custom_PropReflectionsLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 68 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49AudioReverbFilter_Set_Custom_PropReflectionsDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 72 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35AudioReverbZone_Set_Custom_PropRoomP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 60 >> 2] = i2;
   __ZN15AudioReverbZone12VerifyValuesEv(i3);
   __ZN15AudioReverbZone13SetFMODValuesEv(i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30getPxTriangleMeshGeometryScalePKN5physx22PxTriangleMeshGeometryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function _UNITY_png_chunk_report(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if (HEAP32[i1 + 204 >> 2] & 32768 | 0) {
  if ((i4 | 0) < 2) return;
  if (!(HEAP32[i1 + 208 >> 2] & 1048576)) _UNITY_png_chunk_error(i1, i2); else return;
 }
 i3 = HEAP32[i1 + 208 >> 2] | 0;
 if ((i4 | 0) < 1) if (!(i3 & 2097152)) _UNITY_png_error(i1, i2); else return; else if (!(i3 & 4194304)) _UNITY_png_error(i1, i2); else return;
}

function _strcmp(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP8[i2 >> 0] | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 if (i1 << 24 >> 24 == 0 ? 1 : i1 << 24 >> 24 != i4 << 24 >> 24) i2 = i4; else {
  do {
   i2 = i2 + 1 | 0;
   i3 = i3 + 1 | 0;
   i1 = HEAP8[i2 >> 0] | 0;
   i4 = HEAP8[i3 >> 0] | 0;
  } while (!(i1 << 24 >> 24 == 0 ? 1 : i1 << 24 >> 24 != i4 << 24 >> 24));
  i2 = i4;
 }
 return (i1 & 255) - (i2 & 255) | 0;
}

function __ZNK18ProceduralMaterial17GetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(HEAPF32[i1 + 68 >> 2]);
 return Math_fround(f3);
}

function __ZNK12AudioManager21GetPlayingSourceCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 i4 = i1 + 44 | 0;
 i3 = i2;
 if ((i3 | 0) == (i4 | 0)) {
  i4 = 0;
  return i4 | 0;
 } else i1 = 0;
 do {
  i5 = i2;
  i2 = HEAP32[i3 + 4 >> 2] | 0;
  i1 = ((__ZNK11AudioSource9IsPlayingEv(HEAP32[i5 + 8 >> 2] | 0) | 0) & 1) + i1 | 0;
  i3 = i2;
 } while ((i3 | 0) != (i4 | 0));
 return i1 | 0;
}

function __ZN9Animation18SetVisibleInternalEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP8[i1 + 42 >> 0] = i2 & 1;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 i2 = i1 + 256 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) != 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0);
 if (i3 | (HEAP32[i2 >> 2] | 0) == 0) return;
 __ZN9Animation15UpdateAnimationEd(i1, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
 return;
}

function __ZN7mecanim9animation16CreateClipOutputEiRNS_6memory9AllocatorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 4, 4) | 0;
 if (!i2) i1 = 0; else {
  i3 = i2 << 2;
  i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, 4) | 0;
  if ((i1 | 0) != (i1 + (i2 << 2) | 0)) _memset(i1 | 0, 0, i3 | 0) | 0;
 }
 HEAP32[i4 >> 2] = i1;
 return i4 | 0;
}

function __ZN6Object16RevertWeakHandleEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = __Z29scripting_gchandle_get_targetj(i1) | 0;
 __Z23scripting_gchandle_freej(HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
 i3 = 1;
 return i3 | 0;
}

function __ZN5physx7NpScene29addArticulationLinkConstraintERNS_18NpArticulationLinkE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 228 >> 2] | 0, i2 | 0) | 0;
 if (i1 | 0) __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE(i3 + 16 | 0, i1 + 8 | 0);
 if (!(HEAP32[i2 + 16 >> 2] | 0)) return;
 __ZN5physx7NpActor29addConstraintsToSceneInternalEv(i2 + 12 | 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i3 >> 0] = 1;
 i1 = __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i1 + 20 | 0, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx10PxsContext17addParticleSystemEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb(i2, i4, i3, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0, i6 = 0;
 i1 = HEAP32[gb + 1098848 >> 2] | 0;
 i6 = HEAP32[gb + 1098848 + 4 >> 2] | 0;
 i2 = i2 + (i6 >> 1) | 0;
 if (i6 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 return mftCall_iiiii(i1 | 0, i2 | 0, i4 | 0, i3 | 0, i5 | 0) | 0;
}

function __ZN5Umbra10QueryState10setWorkMemEPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0, i7 = 0;
 i4 = i1 + 56 | 0;
 i6 = i2;
 i5 = i6 + 15 & -16;
 i7 = i5;
 HEAP32[i1 + 60 >> 2] = i7;
 i3 = i7 + (i6 + i3 - i5) | 0;
 HEAP32[i1 + 64 >> 2] = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = i5;
 HEAP32[i1 + 72 >> 2] = i3 - i5;
 HEAP32[i1 + 76 >> 2] = (i2 | 0) == 0 ? i1 + 36 | 0 : i4;
 return;
}

function __ZN4FMOD7SystemI16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869187;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN14PhysicsManager7BoxCastERK8Vector3fS2_S2_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction(i1, i2, i3, i4, i5, f6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return __ZN5Unity12PhysicsQuery7BoxCastERK8Vector3fS3_S3_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction(0, i2, i3, i4, i5, f6, i7, i8, i9) | 0;
}

function __ZN12b2BroadPhase12UnBufferMoveEi(i1, i5) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i6 = 0;
 i6 = i1 + 40 | 0;
 i2 = HEAP32[i6 >> 2] | 0;
 if ((i2 | 0) <= 0) return;
 i4 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = 0;
 i1 = i2;
 do {
  i2 = i4 + (i3 << 2) | 0;
  if ((HEAP32[i2 >> 2] | 0) == (i5 | 0)) {
   HEAP32[i2 >> 2] = -1;
   i1 = HEAP32[i6 >> 2] | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) < (i1 | 0));
 return;
}

function __ZN12SoundManager14OnExitPlayModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 i3 = i1 + 48 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = HEAP32[i4 + 8 >> 2] | 0;
  if (!(HEAP8[i1 + 64 >> 0] | 0)) __ZN10SampleClip15UnloadAudioDataEv(i1) | 0; else __ZN9AudioClip6ReloadEv(i1);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN10UnityScene14AddRootToSceneERS_R9Transform(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i2 + 104 | 0;
 if (HEAP32[i3 >> 2] | 0) return;
 i4 = i1 + 100 | 0;
 if ((i3 | 0) != (i4 | 0)) {
  i5 = i2 + 108 | 0;
  i6 = HEAP32[i4 >> 2] | 0;
  HEAP32[i3 >> 2] = i6;
  HEAP32[i5 >> 2] = i4;
  HEAP32[i6 + 4 >> 2] = i3;
  HEAP32[HEAP32[i5 >> 2] >> 2] = i3;
 }
 HEAP32[i2 + 116 >> 2] = i1;
 return;
}

function __Z33GUI_CUSTOM_INTERNAL_CALL_DoToggleRK5RectTIfEihP12Il2CppObject13Il2Cpp_IntPtr(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i5 = HEAP32[i5 >> 2] | 0;
 i6 = __Z11GetGUIStatev() | 0;
 return (__ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStylei(i6, i1, i3 << 24 >> 24 != 0, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i4) | 0, i5, i2) | 0) & 1 | 0;
}

function __Z30setPxActor_ClientBehaviorFlagsPN5physx7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP16[i4 >> 1] = 47;
 __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc(i1, i2, i4);
 STACKTOP = i3;
 return;
}

function __Z26RemoveCleanLogEntryHandlerPFb7LogTypePKcPiE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 HEAP32[i2 >> 2] = i1;
 i1 = HEAP32[gb + 1450784 >> 2] | 0;
 if (!i1) {
  STACKTOP = i3;
  return;
 }
 __ZNSt3__24listIPFb7LogTypePKcPiE13stl_allocatorIS6_L18MemLabelIdentifier7ELi16EEE6removeERKS6_(i1, i2);
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Stream_GetULong(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 3 | 0;
 if (i4 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i4 = 0;
  HEAP32[i2 >> 2] = i3;
  return i4 | 0;
 }
 i4 = (HEAPU8[i3 + 1 >> 0] | 0) << 16 | (HEAPU8[i3 >> 0] | 0) << 24 | (HEAPU8[i3 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0);
 i3 = i3 + 4 | 0;
 HEAP32[i2 >> 2] = i3;
 return i4 | 0;
}

function _putchar_unlocked(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[gb + 191868 >> 2] | 0;
 if ((HEAP8[i2 + 75 >> 0] | 0) == (i1 | 0)) i5 = 4; else {
  i3 = i2 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = i4 + 1;
   HEAP8[i4 >> 0] = i1;
   i1 = i1 & 255;
  } else i5 = 4;
 }
 if ((i5 | 0) == 4) i1 = ___overflow(i2, i1) | 0;
 return i1 | 0;
}

function __ZThn8_N5physx17ConvexMeshBuilderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 110060 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110060 + 84;
 __ZN5physx17ConvexHullBuilderD2Ev(i1 + 132 | 0);
 __ZN5physx2Gu10ConvexMeshD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZThn12_N5physx3Ext10FixedJointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 87952 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87952 + 188;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, f4 = f0, f5 = f0, f6 = f0;
 i3 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 f6 = Math_fround(HEAPF32[i3 + i2 >> 2]);
 f5 = Math_fround(HEAPF32[i3 + (i2 + 4) >> 2]);
 f4 = Math_fround(HEAPF32[i3 + (i2 + 8) >> 2]);
 __ZN8Scalar4fC2Effff(i1, f6, f5, f4, Math_fround(HEAPF32[i3 + (i2 + 12) >> 2]));
 return;
}

function __ZN8Animator17GetAvatarPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) {
  HEAPF32[i1 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
  return;
 } else {
  i2 = HEAP32[i2 + 136 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
  return;
 }
}

function __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatABGR8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatBGRA8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6Socket4RecvEPvjP12RecvUserData(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i4) i1 = _recvfrom(i5, i2, i3, i1, 0, 0) | 0; else i1 = _recvfrom(i5, i2, i3, i1 | HEAP32[i4 >> 2], HEAP32[i4 + 4 >> 2] | 0, i4 + 8 | 0) | 0;
 if ((i1 | 0) < 0) return i1 | 0;
 HEAP32[(___errno_location() | 0) >> 2] = 0;
 return i1 | 0;
}

function __ZN6Camera20SetTemporarySettingsERK23CameraTemporarySettings(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 928 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 292 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 1060 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP8[i1 + 1087 >> 0] = HEAP8[i2 + 13 >> 0] | 0;
 HEAP8[i1 + 1086 >> 0] = HEAP8[i2 + 12 >> 0] | 0;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx9writeWordEtbRNS_14PxOutputStreamE(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i5;
 HEAP16[i1 >> 1] = i3;
 if (i2) {
  HEAP8[i1 >> 0] = (i3 & 65535) >>> 8;
  HEAP8[i1 + 1 >> 0] = i3;
 }
 mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, 2) | 0;
 STACKTOP = i5;
 return;
}

function __ZN5physx3Scb5Scene19bufferCreationErrorEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
 HEAP32[i3 >> 2] = i1;
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(i4, 16, gb + 682639 | 0, 1386, gb + 771531 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction19activateForLowLevelEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 32 | 0;
 i4 = __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i3 >> 2] | 0) | 0;
 __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj(i4, HEAP32[i3 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, i1);
 HEAP8[i2 + 46 >> 0] = 1;
 return;
}

function __ZN5physx2Gu25checkOverlapOBB_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 __ZN5physx2Gu8getPlaneERKNS_11PxTransformE(i4, i3);
 i3 = __ZN5physx2Gu17intersectPlaneBoxERKNS_7PxPlaneERKNS0_3BoxE(i4, i2) | 0;
 STACKTOP = i1;
 return i3 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx19PxsFluidSpatialHash20updatePacketSectionsEPjPNS_16PxsFluidParticleEPNS_10PxBaseTaskE(HEAP32[i2 + 72 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 48 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx29PxvRegisterLegacyHeightFieldsEv() {
 HEAP32[gb + 104632 + 24 >> 2] = fb + 92;
 HEAP32[gb + 104632 + 80 >> 2] = fb + 93;
 HEAP32[gb + 104632 + 108 >> 2] = fb + 94;
 HEAP32[gb + 104632 + 136 >> 2] = fb + 95;
 HEAP32[gb + 105216 + 24 >> 2] = fb + 92;
 HEAP32[gb + 105216 + 80 >> 2] = fb + 93;
 HEAP32[gb + 105216 + 108 >> 2] = fb + 94;
 HEAP32[gb + 105216 + 136 >> 2] = fb + 95;
 HEAP8[gb + 1551034 >> 0] = 0;
 return;
}

function __ZN5Umbra20ObjectDistanceParamsaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 return i1 | 0;
}

function __ZN18AudioLowPassFilterD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 171508 + 8;
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12LightsModule9ResetSeedERK27ParticleSystemReadOnlyState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 272 >> 2] | 0;
 HEAP32[i1 + 556 >> 2] = i2;
 i2 = (Math_imul(i2, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 560 >> 2] = i2;
 i2 = (Math_imul(i2, 1812433253) | 0) + 1 | 0;
 HEAP32[i1 + 564 >> 2] = i2;
 HEAP32[i1 + 568 >> 2] = (Math_imul(i2, 1812433253) | 0) + 1;
 HEAPF32[i1 + 572 >> 2] = Math_fround(0.0);
 return;
}

function __ZL18DestroyCachedStripPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = 0;
 do {
  i2 = gb + 1467184 + (i1 << 2) | 0;
  i3 = HEAP32[i2 >> 2] | 0;
  if (i3 | 0) {
   i4 = HEAP32[i3 + 4 >> 2] | 0;
   if (i4 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63232 | 0);
  }
  __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 63160 | 0);
  HEAP32[i2 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 return;
}

function __Z63ParticleSystemExtensionsImpl_CUSTOM_GetSafeTriggerParticlesSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZNK14ParticleSystem27GetSafeTriggerParticlesSizeEN13TriggerEvents9EventTypeE(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function mftCall_vffffffi(i8, d1, d2, d3, d4, d5, d6, i7) {
 i8 = i8 | 0;
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vffffffi[i8 - fb & 1](Math_fround(d1), Math_fround(d2), Math_fround(d3), Math_fround(d4), Math_fround(d5), Math_fround(d6), i7 | 0);
  return;
 }
 ftCall_vffffffi(i8 | 0, +d1, +d2, +d3, +d4, +d5, +d6, i7 | 0);
}

function __ZNK7b2World14QueryProxyAABBEP20b2QueryProxyCallbackRK6b2AABB(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i1 = i1 + 102872 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 __ZNK13b2DynamicTree5QueryI24b2WorldQueryProxyWrapperEEvPT_RK6b2AABB(i1, i5, i3);
 STACKTOP = i4;
 return;
}

function __ZNK5Umbra14TomeCollection15getObjectUserIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = HEAP32[i1 + 76 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 + i3 | 0) != 0) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 80 >> 2] | 0;
 i3 = HEAP32[((i3 | 0) == 0 ? 0 : i1 + i3 | 0) + (i2 << 2) >> 2] | 0;
 return i3 | 0;
}

function __ZNK22GenericPropertyBinding13FindHashIndexEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = HEAP32[i2 + 260 >> 2] | 0;
 if (!i4) {
  i4 = -1;
  return i4 | 0;
 } else i1 = 0;
 while (1) {
  if ((HEAP32[i2 + 4 + (i1 << 2) >> 2] | 0) == (i3 | 0)) {
   i2 = 4;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) {
   i1 = -1;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZNK16UnityAdsSettings9GetGameIdE15RuntimePlatform(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 8:
  {
   i2 = i1 + 20 | 0;
   return i2 | 0;
  }
 case 11:
  {
   i2 = i1 + 36 | 0;
   return i2 | 0;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1042829 | 0, 0, gb + 1042881 | 0, 188, 1, 0, 0, 0);
   i2 = gb + 1468928 | 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN9Animation16SetVisibleBoundsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP8[i1 + 42 >> 0] = i2 & 1;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 i2 = i1 + 256 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) != 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0);
 if (i3 | (HEAP32[i2 >> 2] | 0) == 0) return;
 __ZN9Animation15UpdateAnimationEd(i1, +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
 return;
}

function __ZN7dtCrowd21initializeAgentFilterERK13dtCrowdHandlePKfi(i2, i1, i6, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i3 = (i4 | 0) > 32 ? 32 : i4;
 if ((i4 | 0) > 0) i1 = 0; else return;
 do {
  HEAP32[i2 + (i5 * 132 | 0) + (i1 << 2) >> 2] = HEAP32[i6 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN6Object33AllocateAndAssignInstanceIDNoLockEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[gb + 29188 >> 2] | 0) + -2 | 0;
 HEAP32[gb + 29188 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i3;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) + 24 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 2097151 | i3 << 21;
 __ZN6Object17InsertObjectInMapEPS_(i1);
 return i1 | 0;
}

function __ZN5physx8debugger14PvdMarshallingIhjE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhiE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150800 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150548 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i3 >> 0] = 1;
 i1 = __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i1 + 20 | 0, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5physx18ReducedVertexCloudD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1 + 16 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 i1 = i1 + 12 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 92 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator16estimateTomeSizeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5Umbra20RuntimeTomeGenerator12estimateTomeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEERNS0_8EstimateE(i1, i2, i3, i4);
 STACKTOP = i4;
 return 384;
}

function __ZN2UI12DoSyncBoundsERNS_13UIInstructionERK10MinMaxAABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 548 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP16[i1 + 664 >> 1] = 2;
 return;
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 236 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 28 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12b2ChainShape11CreateChainEPK6b2Vec2i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 16 | 0;
 HEAP32[i4 >> 2] = i3;
 i3 = __Z7b2Alloci(i3 << 3) | 0;
 HEAP32[i1 + 12 >> 2] = i3;
 _memcpy(i3 | 0, i2 | 0, HEAP32[i4 >> 2] << 3 | 0) | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP16[i3 + 16 >> 1] = 0;
 return;
}

function __ZN12AdsIdHandler16FetchCachedAdsIdEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = i1 + 40 | 0;
 do if (HEAP8[i2 >> 0] | 0) {
  f3 = Math_fround(+__Z19GetTimeSinceStartupv());
  if (Math_fround(f3 - Math_fround(HEAPF32[i1 + 36 >> 2])) > Math_fround(120.0)) {
   HEAP8[i2 >> 0] = 0;
   break;
  }
  if (HEAP8[i2 >> 0] | 0) {
   i2 = 1;
   return i2 | 0;
  }
 } while (0);
 HEAP32[i1 + 44 >> 2] = 1;
 i2 = 0;
 return i2 | 0;
}

function __ZN10MemoryFileD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 71428 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) {
  __ZdlPv(i1);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __Z58Physics2D_CUSTOM_INTERNAL_CALL_Internal_GetRayIntersectionRK3RayfiP12RaycastHit2D(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((__ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di(__Z19GetPhysicsManager2Dv() | 0, i1, i1 + 12 | 0, f2, i3, 0, i4, 1) | 0) != 1) return;
 __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i4);
 return;
}

function __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_highAngularXLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint20SetHighAngularXLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Projector_Set_Custom_PropOrthographicP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 52 >> 0] = i2 << 24 >> 24 != 0 & 1;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32setPxRigidBody_RigidDynamicFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i4 + 4 | 0;
 if (HEAP32[i2 >> 2] | 0) {
  i3 = i4 + 8 | 0;
  i1 = 0;
  do {
   mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i4 >> 2] | 0, i1 | 0);
   i1 = i1 + 1 | 0;
  } while (i1 >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0);
 }
 i1 = HEAP32[i4 + 12 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(i1 | 0, HEAP32[i4 >> 2] | 0);
 return;
}

function __Z19getNbPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 i2 = mftCall_iii(i5 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __Z15Transfer_StringI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z22TransferField_NonArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function mftCall_iifififf(i8, i1, d2, i3, d4, i5, d6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifififf[i8 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, Math_fround(d4), i5 | 0, Math_fround(d6), Math_fround(d7)) | 0;
 return ftCall_iifififf(i8 | 0, i1 | 0, +d2, i3 | 0, +d4, i5 | 0, +d6, +d7) | 0;
}

function _memcmp(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 L1 : do if (!i2) i1 = 0; else {
  while (1) {
   i4 = HEAP8[i1 >> 0] | 0;
   i5 = HEAP8[i3 >> 0] | 0;
   if (i4 << 24 >> 24 != i5 << 24 >> 24) break;
   i2 = i2 + -1 | 0;
   if (!i2) {
    i1 = 0;
    break L1;
   } else {
    i1 = i1 + 1 | 0;
    i3 = i3 + 1 | 0;
   }
  }
  i1 = (i4 & 255) - (i5 & 255) | 0;
 } while (0);
 return i1 | 0;
}

function _ctermid(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4 + 8 | 0;
 i1 = (i1 | 0) == 0 ? gb + 1576184 | 0 : i1;
 HEAP8[i1 >> 0] = 0;
 i2 = _open(gb + 1076019 | 0, 524545, i4) | 0;
 if ((i2 | 0) > -1) {
  _ttyname_r(i2, i1, 20) | 0;
  HEAP32[i3 >> 2] = i2;
  ___syscall6(6, i3 | 0) | 0;
 }
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK9WWWCached6GetETAEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 if (HEAP8[i1 + 84 >> 0] | 0) {
  d3 = 0.0;
  return +d3;
 }
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2 | 0) if (!(HEAP32[i2 + 92 >> 2] | 0)) if (HEAP32[i2 + 84 >> 2] | 0) {
  d3 = 0.0;
  return +d3;
 }
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  d3 = 0.0;
  return +d3;
 }
 d3 = +mftCall_di(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return +d3;
}

function __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1 >>> 2;
 i2 = HEAP32[i2 + 12 + ((i1 & 1) << 2) >> 2] | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK23TransformChangeDispatch40AssertConsistentCombinedSubsystemChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i5) return;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = 0;
 do {
  i4 = HEAP32[(HEAP32[i3 + (i2 << 2) >> 2] | 0) + 68 >> 2] | 0;
  i1 = 0;
  do i1 = HEAP32[i4 + (i1 << 2) >> 2] | 0; while ((i1 | 0) != -1);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i5 | 0));
 return;
}

function __ZNK12NavMeshAgent27GetInternalAnimationPolyRefEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = (__ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) + 40 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN5physx8debugger14PvdMarshallingIajE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIaiE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  HEAP8[i2 + 2 >> 0] = i3 >> 16;
  HEAP8[i2 + 3 >> 0] = i3 >> 24;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148644 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext14SphericalJoint21setSphericalJointFlagENS_20PxSphericalJointFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = (HEAP32[i3 + 80 >> 2] | 0) + 116 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 i4 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx3Ext14PrismaticJoint21setPrismaticJointFlagENS_20PxPrismaticJointFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = (HEAP32[i3 + 80 >> 2] | 0) + 108 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 i4 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx31PxJointLimitConeGeneratedValuesC2EPKNS_16PxJointLimitConeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap9updatePPUEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx23PxsBroadPhaseContextSap11batchRemoveEv(i2);
 i1 = i2 + 256 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i1 = i2 + 296 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i2 = i2 + 336 | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx14NpSpatialIndex6updateEjRKNS_9PxBounds3E(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i5 | 0, i1 | 0, 1);
 HEAP8[i3 + 4 >> 0] = 1;
 STACKTOP = i4;
 return;
}

function __ZN19CharacterControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __Z45AudioReverbFilter_Set_Custom_PropDecayHFRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 64 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioReverbFilter_Set_Custom_PropLfReferenceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 100 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40CleanupRendererAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158360 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158360 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158364 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158364 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158368 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158368 >> 2] = 0;
 return;
}

function __Z38ScheduleDifferentJobsConcurrentDependsR8JobFencePK3JobiRKS_11JobPriority(i1, i4, i5, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i5) return;
 if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 if ((i5 | 0) > 0) i1 = 0; else return;
 do {
  mftCall_vi(HEAP32[i4 + (i1 << 3) >> 2] | 0, HEAP32[i4 + (i1 << 3) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z35GUIStyle_Set_Custom_PropFixedHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAPF32[i1 + 280 >> 2] = f2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z28getPxConvexMeshGeometryScalePKN5physx20PxConvexMeshGeometryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i2 + 28 >> 2];
 return;
}

function _start_pass_main(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 320 >> 2] | 0;
 if (HEAP8[i1 + 176 >> 0] | 0) return;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP32[i3 + 20 >> 2] = i2;
 if (!i2) {
  HEAP32[i3 + 4 >> 2] = fb + 196;
  return;
 } else {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
  return;
 }
}

function __ZThn4_N5physx5cloth9SwFactoryD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 167292 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 167292 + 88;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZThn4_N5physx5cloth9SwFactoryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 167292 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 167292 + 88;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f5 = f0, f6 = f0;
 i2 = i2 & 255;
 i3 = i3 & 255;
 f6 = HEAP32[i4 + 1280 + (i2 << 2) >> 2] & 1 << i3 | 0 ? Math_fround(1.0) : Math_fround(0.0);
 f5 = HEAP32[i4 + 1280 + (i3 << 2) >> 2] & 1 << i2 | 0 ? Math_fround(1.0) : Math_fround(0.0);
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 4 >> 2] = f5;
 return;
}

function __ZN7ApiGLES18UnbindMemoryBufferEN2gl12BufferTargetE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 716 >> 0] | 0)) i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 636 >> 2] | 0;
 HEAP32[i2 + 892 + (i1 << 2) >> 2] = 0;
 i3 = HEAP32[i2 + 644 >> 2] | 0;
 mftCall_vii(i3 | 0, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(HEAP32[i2 + 860 >> 2] | 0, i1) | 0, 0);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148564 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148320 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx31PxcContactBoxHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu21contactBoxHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx27PxClothGeodesicTetherCookerC2ERKNS_15PxClothMeshDescE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = __Znwj(108) | 0;
 HEAP32[i1 >> 2] = i2;
 i4 = i1 + 8 | 0;
 i5 = i4 + 100 | 0;
 do {
  HEAP32[i4 >> 2] = 0;
  i4 = i4 + 4 | 0;
 } while ((i4 | 0) < (i5 | 0));
 __ZN5physx31PxClothGeodesicTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i1, i2);
 HEAP32[i3 >> 2] = i1;
 return;
}

function __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) i1 = 0; else i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, -2147483648, i1 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0);
 return i1 | 0;
}

function __ZN5physx13NpClothFabric7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, 0, 1);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12CachedReader3EndEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 16 | 0;
 i2 = (Math_imul(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i3 >> 2] | 0) | 0) + ((HEAP32[i1 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0)) | 0;
 __ZN12CachedReader16OutOfBoundsErrorEjj(i1, i2, 0);
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = -1;
 return i2 | 0;
}

function __Z54ConfigurableJoint_CUSTOM_INTERNAL_set_lowAngularXLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint19SetLowAngularXLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ReflectionProbe_Set_Custom_PropBlendDistanceP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 136 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioReverbFilter_Set_Custom_PropRoomRolloffP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 56 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioReverbFilter_Set_Custom_PropReverbLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 76 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioReverbFilter_Set_Custom_PropReverbDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 80 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioReverbFilter_Set_Custom_PropHfReferenceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 92 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43CanvasRenderer_Get_Custom_PropRelativeDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   if (!(HEAP32[i2 + 204 >> 2] | 0)) {
    i2 = -1;
    return i2 | 0;
   }
   i2 = HEAP32[i2 + 208 >> 2] | 0;
   return i2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43CanvasRenderer_Get_Custom_PropAbsoluteDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   if (!(HEAP32[i2 + 204 >> 2] | 0)) {
    i2 = -1;
    return i2 | 0;
   }
   i2 = HEAP32[i2 + 216 >> 2] | 0;
   return i2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42CapsuleCollider2D_Set_Custom_PropDirectionP12Il2CppObjectN17CapsuleCollider2D16CapsuleDirectionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17CapsuleCollider2D12SetDirectionENS_16CapsuleDirectionE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AnimationState_Set_Custom_PropWeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAPF32[i1 + 8 >> 2] = f2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z34GUIStyle_Set_Custom_PropFixedWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAPF32[i1 + 276 >> 2] = f2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z31TerrainData_CUSTOM_GetSteepnessP12Il2CppObjectff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return Math_fround(__ZNK9Heightmap12GetSteepnessEff(i4 + 248 | 0, f2, f3));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z20Animator_CUSTOM_PlayP12Il2CppObjectiif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN8Animator9GotoStateEiifff(i5, i3, i2, f4, Math_fround(0.0), Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function ___uflow(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i4;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) if (!(___toread(i1) | 0)) i3 = 3; else i1 = -1; else i3 = 3;
 if ((i3 | 0) == 3) if ((mftCall_iiii(HEAP32[i1 + 32 >> 2] | 0, i1 | 0, i2 | 0, 1) | 0) == 1) i1 = HEAPU8[i2 >> 0] | 0; else i1 = -1;
 STACKTOP = i4;
 return i1 | 0;
}

function __ZZN8Collider15InitializeClassEvEN37FunctorImpl_778kForceRecreateCollider4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, 0);
 return;
}

function __ZThn12_N5physx3Ext7D6JointD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 86848 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 86848 + 256;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZNK5physx2Sc9RigidCore10getPxActorEv(i1) {
 i1 = i1 | 0;
 switch (HEAPU8[i1 + 10 >> 0] | 0 | 0) {
 case 0:
  {
   i1 = i1 + (HEAP32[gb + 1097392 >> 2] | 0) | 0;
   return i1 | 0;
  }
 case 1:
  {
   i1 = i1 + (HEAP32[gb + 1097392 + 4 >> 2] | 0) | 0;
   return i1 | 0;
  }
 case 4:
  {
   i1 = i1 + (HEAP32[gb + 1097392 + 8 >> 2] | 0) | 0;
   return i1 | 0;
  }
 default:
  {
   i1 = 0;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZN7Joint2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  i4 = i1 + 68 | 0;
  HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx2Sc21ConstraintInteraction11updateStateEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i4 + 30 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 & 2)) {
  i4 = i4 + 28 | 0;
  HEAP16[i4 >> 1] = 0;
  return;
 }
 if (i2) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i4 + 24 | 0);
  i1 = HEAP16[i3 >> 1] | 0;
 }
 HEAP16[i3 >> 1] = i1 & 65533;
 i4 = i4 + 28 | 0;
 HEAP16[i4 >> 1] = 0;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE(i2, i4, i3, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0, i5 | 0);
 return;
}

function __ZN5physx27PxcPCMContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu24pcmContactBoxHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 92 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN4FMOD7SystemI17getCDROMDriveNameEiPciS1_iS1_i(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1;
 HEAP32[i8 >> 2] = 78;
 HEAP32[i8 + 4 >> 2] = gb + 869326;
 _printf(gb + 857490 | 0, i8) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN26AnimatorControllerPlayableD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 177524 + 8;
 HEAP32[i1 + 80 >> 2] = gb + 177524 + 200;
 i2 = i1 + 112 | 0;
 if ((HEAP32[i1 + 128 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 116 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 return;
}

function __ZN21UnityWebStream_Static13ReadBigEndianERPKhS1_Rj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4 + 4 | 0;
 if (i5 >>> 0 > i2 >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = (HEAPU8[i4 + 1 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0) << 24 | (HEAPU8[i4 + 2 >> 0] | 0) << 8 | (HEAPU8[i4 + 3 >> 0] | 0);
 HEAP32[i1 >> 2] = i5;
 i5 = 1;
 return i5 | 0;
}

function __ZN20TextRenderingPrivate8FontImpl14AddRectToCacheERNS0_13CharacterInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_(i3, i1 + 60 | 0, i2);
 STACKTOP = i3;
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE15SetPostInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 176 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 80 >> 2] = Math_fround(inf);
 HEAP32[i2 + 76 >> 2] = 0;
 return;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 28 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 60 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN13GfxDeviceGLES11SetViewportERK5RectTIiE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 7148 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 __ZN18GfxFramebufferGLES11SetViewportERK5RectTIiE(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, i2);
 return;
}

function __Z49NavMeshAgent_Set_Custom_PropObstacleAvoidanceTypeP12Il2CppObject21ObstacleAvoidanceType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent24SetObstacleAvoidanceTypeE21ObstacleAvoidanceType(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Light_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZNK5Light16UnshareLightDataEv(i2);
   __ZN19RenderEventsContext23RemoveAllCommandBuffersEv((HEAP32[i2 + 44 >> 2] | 0) + 208 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AudioEchoFilter_Set_Custom_PropDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 44 >> 2] = ~~f2 >>> 0;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29setPxRigidBody_RigidBodyFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z25SetNameAndResetGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, ((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2) | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 return;
}

function __Z15Transfer_StringI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function mftCall_iiiififf(i8, i1, i2, i3, d4, i5, d6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiiififf[i8 - fb & 7](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, Math_fround(d6), Math_fround(d7)) | 0;
 return ftCall_iiiififf(i8 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, +d6, +d7) | 0;
}

function mftCall_iiifiiff(i8, i1, i2, d3, i4, i5, d6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiifiiff[i8 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0, Math_fround(d6), Math_fround(d7)) | 0;
 return ftCall_iiifiiff(i8 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, +d6, +d7) | 0;
}

function _imaxdiv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = ___divdi3(i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 i7 = getTempRet0() | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 i3 = ___remdi3(i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 i4 = getTempRet0() | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i2 = i2 + -116 | 0;
 HEAP32[i4 >> 2] = i1;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i4 | 0, 1) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZNK5physx7NpShape18getCapsuleGeometryERNS_17PxCapsuleGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 2) {
  i3 = 0;
  return i3 | 0;
 }
 if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = 1;
 return i3 | 0;
}

function __ZNK5physx3Ext7D6Joint16getDriveVelocityERNS_6PxVec3ES3_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = HEAP32[i3 + 80 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 300 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 304 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 308 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 + 312 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 316 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 320 >> 2];
 return;
}

function __ZNK22UnityProfilerPerThread15GetActiveSampleEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 48 >> 2] | 0;
 i1 = i3 + ~i1 | 0;
 if (!((i1 | 0) > -1 & (i1 | 0) < (i3 | 0))) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[(HEAP32[i2 + 36 >> 2] | 0) + (i1 << 4) >> 2] | 0;
 i3 = (HEAP32[HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + (i3 >>> 14 << 2) >> 2] >> 2] | 0) + ((i3 & 16383) * 24 | 0) | 0;
 return i3 | 0;
}

function __ZNK20UnityConnectSettings25IsConnectServiceAvailableEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[gb + 1469104 >> 2] | 0)) __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv(gb + 1469104 | 0);
 i1 = __Z20GetPlayerSettingsPtrv() | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(__ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z20IsHumanControllingUsv() | 0;
 return i1 | 0;
}

function __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 147876 + 8;
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (i1 | 0) {
  i3 = HEAP32[HEAP32[i2 + 84 >> 2] >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 }
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i2);
 return;
}

function __ZN5physx3Ext13RevoluteJoint20setRevoluteJointFlagENS_19PxRevoluteJointFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = (HEAP32[i3 + 80 >> 2] | 0) + 132 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 i4 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 92 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 92 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN4FMOD4DSPI16getParameterInfoEiPcS1_S1_iPfS2_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i8 = i1;
 HEAP32[i8 >> 2] = 78;
 HEAP32[i8 + 4 >> 2] = gb + 868815;
 _printf(gb + 857490 | 0, i8) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 84 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i3);
 if (!i1) i1 = 0; else i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAP8[i3 + 152 >> 0] = i1;
 return;
}

function __ZN22CrashReportingSettingsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN19BaseConnectSettingsC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 189340 + 8;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZN13BaseAllocatorC2EPKc(i1, i2);
 HEAP32[i1 >> 2] = gb + 73348 + 8;
 i1 = i1 + 32 | 0;
 i2 = i1;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 i2 = i1;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return;
}

function __ZN17AnimationCurveTplI11QuaternionfE14SetPreInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 172 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 80 >> 2] = Math_fround(inf);
 HEAP32[i2 + 76 >> 2] = 0;
 return;
}

function __ZN14PhysicsManager18OverlapBoxNonAllocERK8Vector3fS2_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return __ZN5Unity12PhysicsQuery18OverlapBoxNonAllocERK8Vector3fS3_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction(i1 + 736 | 0, i2, i3, i4, i5, i6, i7, i8) | 0;
}

function __ZN12SoundManager19FlushDisposedSoundsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 i3 = i1 + 24 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  __ZN11SoundHandle8InstanceD2Ev(i4);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63328 | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __Z56Gyroscope_CUSTOM_INTERNAL_CALL_userAcceleration_InternaliR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z19GetUserAccelerationi(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __Z42AudioReverbFilter_Set_Custom_PropDiffusionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 84 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AudioReverbFilter_Set_Custom_PropDecayTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 60 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z10tesvertLeqP10TESSvertexS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 f3 = Math_fround(HEAPF32[i1 + 24 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 if (f3 < f4) {
  i2 = 1;
  i2 = i2 & 1;
  return i2 | 0;
 }
 if (!(f3 == f4)) {
  i2 = 0;
  i2 = i2 & 1;
  return i2 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 28 >> 2]);
 i2 = f4 <= Math_fround(HEAPF32[i2 + 28 >> 2]);
 i2 = i2 & 1;
 return i2 | 0;
}

function __ZNK7dtCrowd7hasPathEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if ((HEAP32[i3 + (i2 * 608 | 0) + 476 >> 2] | 0) > 0) {
  i3 = 1;
  return i3 | 0;
 }
 if ((HEAP32[i3 + (i2 * 608 | 0) + 32 >> 2] | 0) > 1) {
  i3 = 1;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 20 >> 2] | 0) + (i2 * 56 | 0) + 40 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) != 0 | (HEAP32[i3 + 4 >> 2] | 0) != 0;
 return i3 | 0;
}

function __ZN7Texture20SetGlobalAnisoLimitsEii(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = (i1 | 0) == -1 ? 9 : i1;
 i1 = (i3 | 0) == -1 ? 16 : i3;
 if ((HEAP32[gb + 55820 >> 2] | 0) == (i2 | 0) ? (HEAP32[gb + 55824 >> 2] | 0) == (i1 | 0) : 0) return;
 HEAP32[gb + 55820 >> 2] = i2;
 HEAP32[gb + 55824 >> 2] = i1;
 __ZL21SetAnisoLimitEnumImplN7Texture20AnisotropicFilteringEb(HEAP32[gb + 55816 >> 2] | 0, 1);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148628 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext13DistanceJoint20setDistanceJointFlagENS_19PxDistanceJointFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = (HEAP32[i3 + 80 >> 2] | 0) + 92 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 i4 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 36 >> 2] | 0, i4 | 0);
 return;
}

function __ZN5physx2Sc9ShapeCore14setShape2ActorERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 32 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 36 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 56 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx26PxcPCMContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu23pcmContactCapsuleConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx23PxvRegisterHeightFieldsEv() {
 HEAP32[gb + 104632 + 24 >> 2] = fb + 84;
 HEAP32[gb + 104632 + 80 >> 2] = fb + 85;
 HEAP32[gb + 104632 + 108 >> 2] = fb + 86;
 HEAP32[gb + 104632 + 136 >> 2] = fb + 87;
 HEAP32[gb + 105216 + 24 >> 2] = fb + 88;
 HEAP32[gb + 105216 + 80 >> 2] = fb + 89;
 HEAP32[gb + 105216 + 108 >> 2] = fb + 90;
 HEAP32[gb + 105216 + 136 >> 2] = fb + 91;
 HEAP8[gb + 1551034 >> 0] = 1;
 return;
}

function __ZN5physx22PxcContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx23PxcContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 + 424 >> 2] | 0;
 i2 = i2 + 428 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i3 + 224 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
  __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv(i3);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN19CullingGroupManager18RemoveCullingGroupEP12CullingGroup(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 12 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i6 + (i5 << 2) >> 2] | 0;
 i2 = i2 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i6 + (i3 << 2) >> 2] = i1;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN18BuoyancyEffector2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 56 >> 0] = 1;
 HEAP32[i1 + 60 >> 2] = -1;
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 116 >> 2] = Math_fround(0.0);
 return;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN15CapsuleColliderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManager21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 __ZN5Unity12PhysicsQuery21OverlapBoxUserCollectERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE(0, i2, i3, i4, i5, i6, i7);
 return;
}

function __ZN12WWWDelayCall7CleanupEPv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) return 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!((i1 | 0) == 0 | (HEAP32[i3 >> 2] | 0) != 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (i1 | 0) mftCall_ii(i1 | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 __ZdlPv(i2);
 return 0;
}

function __ZN10CBBoxInt328ClampMaxEiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1 + 12 | 0;
 i6 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (i6 | 0) < (i2 | 0) ? i6 : i2;
 i2 = i1 + 16 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i5 | 0) < (i3 | 0) ? i5 : i3;
 i3 = i1 + 20 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i2 | 0) < (i4 | 0) ? i2 : i4;
 return;
}

function __Z5recipRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 >> 2]));
 f4 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 4 >> 2]));
 f3 = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 8 >> 2]));
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i2 + 12 >> 2])));
 return;
}

function __Z44MaterialPropertyBlock_Get_Custom_PropIsEmptyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 44 >> 2] | 0) == 0 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z43UnityWebRequest_Get_Custom_PropIsModifiableP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 108 >> 2] | 0) == 1 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z42WindZone_Set_Custom_PropWindPulseMagnitudeP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 52 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42WindZone_Set_Custom_PropWindPulseFrequencyP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 56 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AudioReverbFilter_Set_Custom_PropDryLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 44 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AudioEchoFilter_Set_Custom_PropDecayRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 48 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37TerrainData_CUSTOM_GetAlphamapTextureP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK13SplatDatabase15GetAlphaTextureEi(i3 + 32 | 0, i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34RenderTexture_Set_Custom_PropDepthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = (i2 | 0) < 1 ? 0 : (i2 | 0) < 17 ? 1 : 2;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33WheelCollider_CUSTOM_GetWorldPoseP12Il2CppObjectP8Vector3fP11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZNK13WheelCollider12GetWorldPoseEP8Vector3fP11Quaternionf(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP16[i3 + 6 >> 1] | 0) <= -1) return;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i2, i3, i1) | 0;
 return;
}

function __Z19SetupLODFadeKeywordR17ShaderPassContexti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   i2 = i1 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -12582913 | 8388608;
   return;
  }
 case -1:
  {
   i2 = i1 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -12582913 | 4194304;
   return;
  }
 default:
  {
   i2 = i1 + 4 | 0;
   HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -12582913;
   return;
  }
 }
}

function _wcswidth(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 L1 : do if (!i3) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = 0;
  i5 = i1;
  i1 = 0;
  while (1) {
   i3 = i3 + -1 | 0;
   i4 = HEAP32[i5 >> 2] | 0;
   if (!i4) break L1;
   i1 = _wcwidth(i4) | 0;
   if ((i1 | 0) <= -1) break L1;
   i2 = i1 + i2 | 0;
   if (!i3) break; else i5 = i5 + 4 | 0;
  }
 } while (0);
 return ((i1 | 0) < 0 ? i1 : i2) | 0;
}

function _lldiv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0, i8 = 0;
 i8 = ___divdi3(i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 i7 = getTempRet0() | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = i8;
 HEAP32[i6 + 4 >> 2] = i7;
 i3 = ___remdi3(i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 i4 = getTempRet0() | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 return;
}

function _globfree(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 if (!(HEAP32[i4 >> 2] | 0)) i1 = i4 + 4 | 0; else {
  i3 = i4 + 8 | 0;
  i1 = i4 + 4 | 0;
  i2 = 0;
  do {
   _free((HEAP32[(HEAP32[i1 >> 2] | 0) + ((HEAP32[i3 >> 2] | 0) + i2 << 2) >> 2] | 0) + -4 | 0);
   i2 = i2 + 1 | 0;
  } while (i2 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 }
 _free(HEAP32[i1 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEEC2EjjS5_(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = i1;
 if (!i3) i1 = 0; else i1 = __Znwj(i3 << 2) | 0;
 HEAP32[i2 >> 2] = i1;
 i4 = i1 + (i4 << 2) | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = i1 + (i3 << 2);
 return;
}

function __ZNK9Heightmap21InitPxHeightFieldDescERN5physx17PxHeightFieldDescEiiPNS0_19PxHeightFieldSampleE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP32[i2 + 12 >> 2] = 4;
 HEAP32[i2 + 16 >> 2] = i5;
 HEAPF32[i2 + 20 >> 2] = Math_fround(-Math_fround(HEAPF32[i1 + 84 >> 2]));
 HEAPF32[i2 + 24 >> 2] = Math_fround(4.0);
 return;
}

function __ZN9Animation9IsPlayingEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 i2 = HEAP32[i2 + 108 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 while (1) {
  if (HEAP16[(HEAP32[i1 >> 2] | 0) + 56 >> 1] & 2) {
   i1 = 1;
   i2 = 4;
   break;
  }
  i1 = i1 + 4 | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN6Object27AllocateAndAssignInstanceIDEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[gb + 29188 >> 2] | 0) + -2 | 0;
 HEAP32[gb + 29188 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i3;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) + 24 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 2097151 | i3 << 21;
 __ZN6Object17InsertObjectInMapEPS_(i1);
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148896 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN27ParticleSystemReadOnlyState8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 288 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN23ShaderVariantCollection23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN20TextRenderingPrivate8FontImpl12HasCharacterEjij(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i1 + 32 >> 2] | 0) == -2) {
  i4 = __ZN20TextRenderingPrivate8FontImpl19HasCharacterDynamicEj(i1, i2) | 0;
  return i4 | 0;
 } else {
  i4 = __ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj(i1, i2, i3, i4, Math_fround(1.0), 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function __ZN14SphereColliderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13SliderJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN15AnchoredJoint2D5ResetEv(i1);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 116 >> 0] = 0;
 HEAP8[i1 + 117 >> 0] = 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 118 >> 0] = 1;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN13PhysicsModule21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 __ZN5Unity12PhysicsQuery21OverlapBoxUserCollectERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE(0, i2, i3, i4, i5, i6, i7);
 return;
}

function __ZN13MonoBehaviour21StartCoroutineManagedEPKcP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __ZN13MonoBehaviour14StartCoroutineEPKcP12Il2CppObject(i1, i2, i3) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i1 + 48 >> 2] = 1;
 i3 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 132 >> 2] | 0) | 0;
 HEAP32[i3 + 8 >> 2] = i1;
 return i3 | 0;
}

function __ZN12InputManager18GetAnyKeyThisFrameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i1 = 0;
 while (1) {
  if (HEAP32[i2 + (i1 << 2) >> 2] | 0) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i3 >>> 0) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __Z59ConfigurableJoint_CUSTOM_INTERNAL_set_targetAngularVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint24SetTargetAngularVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48Transform_CUSTOM_INTERNAL_CALL_RotateAroundLocalP12Il2CppObjectRK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Transform17RotateAroundLocalERK8Vector3ff(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Projector_Set_Custom_PropOrthographicSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 56 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioReverbFilter_Set_Custom_PropDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 88 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioChorusFilter_Set_Custom_PropWetMix3P12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 56 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioChorusFilter_Set_Custom_PropWetMix2P12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 52 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioChorusFilter_Set_Custom_PropWetMix1P12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 48 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39GameObject_CUSTOM_FindGameObjectWithTagP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(__Z21FindGameObjectWithTagj(__Z18ExtractTagThrowingR11ICallString(i3) | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z37AnimationState_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAPU16[i1 + 56 >> 1] | 0) >>> 1 & 1 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28Gradient_Set_Custom_PropModeP12Il2CppObject12GradientMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 68 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function mftCall_iiififii(i8, i1, i2, d3, i4, d5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiififii[i8 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5), i6 | 0, i7 | 0) | 0;
 return ftCall_iiififii(i8 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5, i6 | 0, i7 | 0) | 0;
}

function __ZThn120_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + -120 | 0;
 i2 = i4 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i4 + 156 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + 160 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN6Sprite13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 76 >> 2];
 __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE(i2 + 80 | 0, 0, i3, i2 + 32 | 0);
 STACKTOP = i1;
 return;
}

function __ZN6Camera19SetDepthTextureModeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 & 5 | 0) != 4) {
  i3 = i1 + 1072 | 0;
  HEAP32[i3 >> 2] = i2;
  return;
 }
 if (!i1) i3 = 0; else i3 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 376014 | 0, 0, gb + 375437 | 0, 1238, 512, i3, 0, 0);
 i2 = i2 | 1;
 i3 = i1 + 1072 | 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN5physx25PxcPCMContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22pcmContactSphereConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx25PxcPCMContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22pcmContactPlaneCapsuleERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx25PxcPCMContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu22pcmContactConvexConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18PxsDynamicsContext6createEPNS_10PxsContextE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, 160, gb + 716492 | 0, 117) | 0;
 if (!i1) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __ZN5physx18PxsDynamicsContextC2EPNS_10PxsContextE(i1, i2);
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj(i5, i4, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i5 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 + i3 | 0) >>> 0 > (HEAP32[i5 + 12 >> 2] | 0) >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 _memcpy(i4 | 0, (HEAP32[i5 + 20 >> 2] | 0) + i2 | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i3;
 i5 = i3;
 return i5 | 0;
}

function __ZN4FMOD7SystemI11getDSPClockEPjS1_(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d2 = 0.0;
 d2 = +__Z19GetTimeSinceStartupv() * 44100.0;
 i1 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 if (i3 | 0) HEAP32[i3 >> 2] = i1;
 if (!i4) return 0;
 HEAP32[i4 >> 2] = ~~d2 >>> 0;
 return 0;
}

function __ZN22DownloadHandlerTexture17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) return;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i3) return;
 i3 = __Z28StartCreateTextureFromBufferPKhjb(HEAP32[i1 + 20 >> 2] | 0, i3, (HEAP8[i1 + 44 >> 0] | 0) != 0) | 0;
 HEAP32[i2 >> 2] = i3;
 __Z34UpdateTextureImageDataOnMainThreadP9Texture2D(i3);
 HEAP8[i1 + 8 >> 0] = 1;
 return;
}

function __ZN17BaseWebCamTextureD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26152 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 108 | 0);
 HEAP32[i1 >> 2] = gb + 175688 + 8;
 __ZN16BaseVideoTexture15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE15SetPostInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 144 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 64 >> 2] = Math_fround(inf);
 HEAP32[i2 + 60 >> 2] = 0;
 return;
}

function __ZN15ArchiveReadFileC2EP20ArchiveStorageReaderPKN20ArchiveStorageHeader4NodeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = gb + 70660 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 i3 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 __ZN20ArchiveStorageReader15MakeStorageUsedEv(i2) | 0;
 return;
}

function __ZN14PhysicsManager11CapsuleCastERK8Vector3fS2_fS2_fR10RaycastHiti23QueryTriggerInteraction(i1, i2, i3, f4, i5, f6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return __ZN5Unity12PhysicsQuery11CapsuleCastERK8Vector3fS3_fS3_fR10RaycastHiti23QueryTriggerInteraction(0, i2, i3, f4, i5, f6, i7, i8, i9) | 0;
}

function __ZN13WheelColliderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13RenderTexture14SetVolumeDepthEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) if (!(HEAP32[i1 + 136 >> 2] | 0)) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 409578 | 0, 0, gb + 406201 | 0, 863, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
 return;
}

function __ZN13CameraLODData7ExtractER12LODDataArray(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var d3 = 0.0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 28 >> 2];
 d3 = +__Z19GetTimeSinceStartupv();
 i1 = i2 + 8 | 0;
 if (!(d3 - +HEAPF64[i1 >> 3] > 1.0000000474974513e-03)) {
  i2 = 0;
  return i2 | 0;
 }
 HEAPF64[i1 >> 3] = d3;
 i2 = 1;
 return i2 | 0;
}

function __ZN12NavMeshAgent19CompleteOffMeshLinkEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845282 | 0, 0, gb + 841797 | 0, 773, 1, 0, 0, 0);
  return;
 } else {
  i2 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
  __ZN7dtCrowd19completeOffMeshLinkEib(i2, HEAP32[i1 >> 2] | 0, 1);
  return;
 }
}

function __ZN11UnityEngine9Animation28GetBoundCurveInstanceIDValueERKNS0_10BoundCurveE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == 9) {
  i1 = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0;
  return i1 | 0;
 } else {
  i2 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
  return i1 | 0;
 }
 return 0;
}

function __Z61Animator_Set_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator40SetAllowConstantClipSamplingOptimizationEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKRotationInternalP12Il2CppObjectiRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator15SetGoalRotationEiRK11Quaternionf(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48AnimatorControllerPlayable_CUSTOM_ResetTriggerIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 160 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 if ((i3 | 0) == 1) return;
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i3, i2);
 return;
}

function __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalMatrixiRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __Z21SetShaderGlobalMatrixN9ShaderLab16FastPropertyNameERK10Matrix4x4f(i4, i2);
 STACKTOP = i3;
 return;
}

function __Z39AudioReverbFilter_Set_Custom_PropRoomLFP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 96 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AudioReverbFilter_Set_Custom_PropRoomHFP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 52 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AudioChorusFilter_Set_Custom_PropDryMixP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 44 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Sampler_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAPU16[i1 + 6 >> 1] | 0) >>> 15 & 255 ^ 1 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28WindZone_Set_Custom_PropModeP12Il2CppObjectN8WindZone12WindZoneModeE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 36 | 0;
   if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
   HEAP32[i1 >> 2] = i3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _default_walker(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i4 | 0 ? gb + 597730 | 0 : gb + 597735 | 0;
 HEAP32[i5 + 8 >> 2] = i3;
 HEAP32[i5 + 12 >> 2] = i2 + -8;
 _printf(gb + 597740 | 0, i5) | 0;
 STACKTOP = i1;
 return;
}

function __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13SetFloatValueEPvf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = i1 + 268 | 0;
 i3 = (f2 > Math_fround(.00100000005) | f2 < Math_fround(-.00100000005)) & 1;
 i3 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16776959 | i3 << 8;
 HEAP16[i1 >> 1] = i3;
 HEAP8[i1 + 2 >> 0] = i3 >>> 16;
 return;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j(i1, i4, i3, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i2 = i1 + 4 | 0;
 i1 = i3 - i4 | 0;
 if ((i1 | 0) > 0) {
  _memcpy(HEAP32[i2 >> 2] | 0, i4 | 0, i1 | 0) | 0;
  HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (i1 >> 2 << 2);
 }
 return;
}

function __ZNSt3__215numpunct_bynameIwEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__28numpunctIwEC2Ej(i1, i3);
 HEAP32[i1 >> 2] = gb + 213108 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4588 | 0, i1 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__28numpunctIwED2Ev(i1);
  ___resumeException(i3 | 0);
 } else return;
}

function __ZNSt3__215numpunct_bynameIcEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__28numpunctIcEC2Ej(i1, i3);
 HEAP32[i1 >> 2] = gb + 213068 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4587 | 0, i1 | 0, i2 | 0);
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  __ZNSt3__28numpunctIcED2Ev(i1);
  ___resumeException(i3 | 0);
 } else return;
}

function __ZNK5physx2Sc9ClothCore15getTetherConfigEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0;
 i2 = i2 + 28 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 f4 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i5 >> 2] | 0) + 256 >> 2] | 0, i5 | 0));
 i2 = HEAP32[i2 >> 2] | 0;
 f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN8Animator17SetAvatarRotationERK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i1 = HEAP32[i1 + 136 >> 2] | 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 16 >> 2] = i5;
 HEAP32[i1 + 20 >> 2] = i4;
 HEAP32[i1 + 24 >> 2] = i3;
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPNS0_4comm21PvdInstanceDataStream10PvdCommandEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149584 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149600 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5physx27PxVehicleSuspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb(i1, i3, i5, i2, i4, i6) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i6 = i6 | 0;
 __ZN5physx15PxVehicleUpdate18suspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb(i1, i3, i5, i2, i4, i6);
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN17PersistentManager38LoadAndIntegrateAllPreallocatedObjectsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 176 | 0;
 i3 = i1 + 120 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) return;
 do {
  __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv(i1);
  __ZN17PersistentManager27IntegrateAllThreadedObjectsEv(i1);
 } while ((HEAP32[i2 >> 2] | 0) != (HEAP32[i3 >> 2] | 0));
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE14SetPreInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 140 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 64 >> 2] = Math_fround(inf);
 HEAP32[i2 + 60 >> 2] = 0;
 return;
}

function __ZN15MulticastSocket7DisbandEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i3 + 4 >> 2] = _htonl(0) | 0;
 i1 = (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket15SetSocketOptionEiiPvj(i1, 0, 36, i3, 8) | 0, gb + 584610 | 0, 0, 0) | 0) ^ 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN12SoundManager20SetLoopPointsForClipEP10SampleClipPN4FMOD5SoundE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 if ((__ZNK10SampleClip20GetCompressionFormatEv(i2) | 0) != 7) return;
 f4 = Math_fround(HEAPF32[i2 + 48 >> 2]);
 __ZN4FMOD5Sound13setLoopPointsEjjjj(i3, 2112, 2, ~~Math_fround(Math_fround(f4 * Math_fround(HEAP32[i2 + 32 >> 2] | 0)) + Math_fround(2112.0)) >>> 0, 2) | 0;
 return;
}

function __ZN12AdsIdHandler20IsCachedAdsIdExpiredEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = i1 + 40 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 f3 = Math_fround(+__Z19GetTimeSinceStartupv());
 if (Math_fround(f3 - Math_fround(HEAPF32[i1 + 36 >> 2])) > Math_fround(120.0)) {
  HEAP8[i2 >> 0] = 0;
  i2 = 1;
  return i2 | 0;
 } else {
  i2 = (HEAP8[i2 >> 0] | 0) == 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN11b2EdgeShape3SetERK6b2Vec2S2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = i2;
 i2 = HEAP32[i5 + 4 >> 2] | 0;
 i4 = i1 + 12 | 0;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i4 + 4 >> 2] = i2;
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 20 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP8[i1 + 44 >> 0] = 0;
 HEAP8[i1 + 45 >> 0] = 0;
 return;
}

function __Z52Gyroscope_CUSTOM_INTERNAL_CALL_rotationRate_InternaliR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z19GetGyroRotationRatei(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __Z51Transform_CUSTOM_INTERNAL_CALL_RotateAroundInternalP12Il2CppObjectRK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Transform12RotateAroundERK8Vector3ff(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularZLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint16SetAngularZLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularYLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint16SetAngularYLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50WheelCollider_CUSTOM_INTERNAL_set_sidewaysFrictionP12Il2CppObjectRK18WheelFrictionCurve(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider19SetSidewaysFrictionERK18WheelFrictionCurve(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AnimationState_Set_Custom_PropBlendModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 72 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z38AudioChorusFilter_Set_Custom_PropDepthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 68 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioChorusFilter_Set_Custom_PropDelayP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 60 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Event_Set_Custom_PropPressureP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAPF32[i1 + 28 >> 2] = f2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z24GetLastPathNameComponentPKcj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0, i6 = 0;
 if (!i4) {
  i6 = i1;
  return i6 | 0;
 }
 i5 = i4 + -1 | 0;
 i3 = 0;
 i2 = 0;
 while (1) {
  if ((HEAP8[i1 + (i5 + i2) >> 0] | 0) == 47) break;
  i2 = ~i3;
  i3 = i3 + 1 | 0;
  if (i3 >>> 0 >= i4 >>> 0) {
   i6 = 6;
   break;
  }
 }
 if ((i6 | 0) == 6) return i1 | 0;
 i6 = i1 + i4 + i2 | 0;
 return i6 | 0;
}

function __Z21setPxConstraint_FlagsPN5physx12PxConstraintENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z11KeyToStringi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 > 569) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 } else {
  i2 = HEAP32[gb + 59864 + (i2 << 2) >> 2] | 0;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
  return;
 }
}

function mftCall_viififfi(i8, i1, i2, d3, i4, d5, d6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viififfi[i8 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5), Math_fround(d6), i7 | 0);
  return;
 }
 ftCall_viififfi(i8 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5, +d6, i7 | 0);
}

function mftCall_iiiiiiii(i8, i1, i2, i3, i4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 127 | 0)) return FUNCTION_TABLE_iiiiiiii[i8 - fb & 127](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return ftCall_iiiiiiii(i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
}

function _mprotect(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i6 = i1 & -4096;
 HEAP32[i5 >> 2] = i6;
 HEAP32[i5 + 4 >> 2] = (i1 + i2 + 4096 + -1 & -4096) - i6;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall125(125, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZNSt3__28ios_base4swapERS0_(i1, i2);
 i5 = i1 + 72 | 0;
 i3 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4swapERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 __ZNSt3__28ios_base4swapERS0_(i1, i2);
 i5 = i1 + 72 | 0;
 i3 = i2 + 72 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i4;
 i3 = i1 + 76 | 0;
 i2 = i2 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZNSt3__25alignEjjRPvRj(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0, i6 = 0, i7 = 0;
 i6 = HEAP32[i5 >> 2] | 0;
 if (i6 >>> 0 < i3 >>> 0) i1 = 0; else {
  i2 = HEAP32[i4 >> 2] | 0;
  i7 = i2 + (i1 + -1) & 0 - i1;
  i1 = i7;
  i2 = i7 - i2 | 0;
  if (i2 >>> 0 > (i6 - i3 | 0) >>> 0) i1 = 0; else {
   HEAP32[i4 >> 2] = i1;
   HEAP32[i5 >> 2] = i6 - i2;
  }
 }
 return i1 | 0;
}

function __ZNK28MonoBehaviourPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i2 = HEAP8[i3 + 11 >> 0] | 0;
 i1 = i2 << 24 >> 24 < 0;
 if (((i1 ? HEAP32[i3 + 4 >> 2] | 0 : i2 & 255) | 0) == 9) return (_memcmp(i1 ? HEAP32[i3 >> 2] | 0 : i3, gb + 1047713 | 0, 9) | 0) == 0 & (i4 ^ 1) | 0; else return 0;
 return 0;
}

function __ZNK24RendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 return i3 | 0;
}

function __ZN8VRDevice33VRNodeToTrackedNodeNameDeprecatedEi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = gb + 1044481 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 1044494 | 0;
   break;
  }
 case 3:
 case 2:
  {
   i1 = gb + 1044508 | 0;
   break;
  }
 case 4:
  {
   i1 = gb + 1044304 | 0;
   break;
  }
 case 5:
  {
   i1 = gb + 1044289 | 0;
   break;
  }
 default:
  i1 = gb + 1576256 | 0;
 }
 return i1 | 0;
}

function __ZN5physx9NpPhysics16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(i6, i1, i2, i3, i5, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 return __ZN5physx9NpFactory16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj(HEAP32[gb + 1457204 >> 2] | 0, i1, i2, i3, i5, i4) | 0;
}

function __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj(HEAP32[i3 >> 2] | 0, i2, i1);
 __ZN5physx2Sc8ShapeSim21destroyLowLevelVolumeEv(i2) | 0;
 i3 = (HEAP32[(HEAP32[HEAP32[i3 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 36 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN5physx29solveContactPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i2);
 __ZN5physxL22concludeContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEjj(HEAP32[i3 + 16 >> 2] | 0, HEAP16[i3 + 26 >> 1] | 0, 240, 224);
 return;
}

function __ZN5physx24PxcPCMContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu21pcmContactPlaneConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx24PxcPCMContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu21pcmContactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN22UnityProfilerPerThread16EndSampleDynamicEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 d2 = +_emscripten_get_now() * 1.0e6;
 __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy(i1, 0, ~~d2 >>> 0, +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0;
 return;
}

function __ZN18ScreenManagerWebGL13SetLockCursorE14CursorLockMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) != 1) {
  _emscripten_exit_pointerlock() | 0;
  return;
 }
 if (!(_JS_SystemInfo_HasCursorLock() | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 363170 | 0, 0, gb + 363219 | 0, 129, 1, 0, 0, 0);
  return;
 } else {
  _emscripten_request_pointerlock(0, 1) | 0;
  return;
 }
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 344 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 390244 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14BillboardAsset23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == 1) {
  i2 = HEAP32[i2 + 1552 >> 2] | 0;
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
  return i2 | 0;
 } else {
  i2 = i2 + 3824 + (i1 * 24 | 0) + 8 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
  i2 = HEAP32[i2 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN12EventManager8HasEventEP10EventEntryPFvPvS2_iEPKv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 while (1) {
  if ((HEAP32[i1 + 8 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) {
   i1 = 1;
   i2 = 5;
   break;
  }
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 5;
   break;
  }
 }
 if ((i2 | 0) == 5) return i1 | 0;
 return 0;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 72 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z58AssetBundleCreateRequest_CUSTOM_DisableCompatibilityChecksP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP8[i1 + 124 >> 0] = 0;
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
}

function __Z51TextGenerator_Get_Custom_PropFontSizeUsedForBestFitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 76 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z46AnimatorControllerPlayable_CUSTOM_SetTriggerIDR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 if ((i3 | 0) == 1) return;
 __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i3, i2);
 return;
}

function __Z38WindZone_Set_Custom_PropWindTurbulenceP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 48 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Projector_Set_Custom_PropNearClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 36 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Physics2D_CUSTOM_INTERNAL_set_gravityRK13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = __Z20GetPhysics2DSettingsv() | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN17Physics2DSettings10SetGravityERK8Vector2f(i4, i3);
 STACKTOP = i2;
 return;
}

function __Z37GUIStyle_Set_Custom_PropImagePositionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 256 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z37AudioReverbFilter_Set_Custom_PropRoomP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 48 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioEchoFilter_Set_Custom_PropWetMixP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 56 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioEchoFilter_Set_Custom_PropDryMixP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 52 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioChorusFilter_Set_Custom_PropRateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 64 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Mesh_CUSTOM_GetBlendShapeFrameWeightP12Il2CppObjectii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return Math_fround(__Z34GetBlendShapeFrameWeightFromScriptRK4Meshii(i4, i2, i3));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z26setPxJoint_ConstraintFlagsPN5physx7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function _UNITY_ft_mem_strcpyn(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 L1 : do if (i2 >>> 0 > 1) while (1) {
  i4 = HEAP8[i3 >> 0] | 0;
  if (!(i4 << 24 >> 24)) break L1;
  i3 = i3 + 1 | 0;
  i5 = i1 + 1 | 0;
  HEAP8[i1 >> 0] = i4;
  i2 = i2 + -1 | 0;
  if (i2 >>> 0 <= 1) {
   i1 = i5;
   break;
  } else i1 = i5;
 } while (0);
 HEAP8[i1 >> 0] = 0;
 return (HEAP8[i3 >> 0] | 0) != 0 | 0;
}

function mftCall_iiiiiiif(i8, i1, i2, i3, i4, i5, i6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 d7 = +d7;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiiiif[i8 - fb & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, Math_fround(d7)) | 0;
 return ftCall_iiiiiiif(i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, +d7) | 0;
}

function mftCall_iiiiifii(i8, i1, i2, i3, i4, d5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiiifii[i8 - fb & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5), i6 | 0, i7 | 0) | 0;
 return ftCall_iiiiifii(i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5, i6 | 0, i7 | 0) | 0;
}

function mftCall_iiiifiii(i8, i1, i2, i3, d4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiiifiii[i8 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, i7 | 0) | 0;
 return ftCall_iiiifiii(i8 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, i7 | 0) | 0;
}

function mftCall_iifiiiii(i8, i1, d2, i3, i4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifiiiii[i8 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return ftCall_iifiiiii(i8 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
}

function b33(i1, i2, i10, i11, i12, i13, i14, i15, i16, i17, i3, f4, f5, f6, f7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_iiiiiiiiiiiiffffii(33);
 return 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8pop_backEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 11 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (i3 << 24 >> 24 < 0) {
  i2 = i1 + 4 | 0;
  i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
  HEAP32[i2 >> 2] = i3;
  HEAP8[(HEAP32[i1 >> 2] | 0) + i3 >> 0] = 0;
 } else {
  i3 = (i3 & 255) + -1 | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i1 + i3 >> 0] = 0;
 }
 return;
}

function __ZNK5physx7NpScene10getGravityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i2 + 3388 >> 2] & 1)) {
  HEAP32[i1 >> 2] = HEAP32[i2 + 80 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 84 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 88 >> 2];
  return;
 } else {
  HEAP32[i1 >> 2] = HEAP32[i2 + 3348 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 3352 >> 2];
  HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 3356 >> 2];
  return;
 }
}

function __ZNK5Umbra10PortalInfo13getHullVertexEiRNS_7Vector3E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = i4 + (HEAP32[i4 + 112 >> 2] | 0) + (((HEAP32[i1 + 76 >> 2] | 0) + i2 | 0) * 12 | 0) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 164 >> 2] | 0;
 if (!i3) {
  HEAPF32[i1 >> 2] = Math_fround(inf);
  HEAPF32[i1 + 4 >> 2] = Math_fround(-inf);
  return;
 } else {
  i2 = HEAP32[i2 + 152 >> 2] | 0;
  i3 = HEAP32[i2 + ((i3 + -1 | 0) * 52 | 0) >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  return;
 }
}

function __ZNK15TerrainRenderer8GetIndexEiii(i1, i5, i6, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = 1 << HEAP32[i1 + 28 >> 2];
 if ((i4 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  i3 = 0;
  do {
   i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
   i2 = i2 >> 1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } else {
  i2 = i1;
  i1 = 0;
 }
 return i1 + i5 + (Math_imul(i2, i6) | 0) | 0;
}

function __ZN9LensFlare8SetColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 44 >> 2] = i5;
 HEAP32[i1 + 48 >> 2] = i4;
 HEAP32[i1 + 52 >> 2] = i3;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZN9GfxDevice19FlipRectForViewportER5RectTIiEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 + 4 | 0;
 i4 = i2 - (HEAP32[i6 >> 2] | 0) | 0;
 i2 = i1 + 12 | 0;
 i3 = i4 - (HEAP32[i2 >> 2] | 0) | 0;
 i5 = (i3 | 0) < (i4 | 0);
 i1 = i5 ? i3 : i4;
 i1 = (i1 | 0) < 0 ? 0 : i1;
 HEAP32[i6 >> 2] = i1;
 i1 = (i5 ? i4 : i3) - i1 | 0;
 HEAP32[i2 >> 2] = (i1 | 0) < 0 ? 0 : i1;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 150752 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd10checkValidERKNS_6PxQuatE(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 12 >> 2] & 2139095040) >>> 0 < 2139095040;
 return i1 | 0;
}

function __ZN5physx3Scb13ObjectTracker6removeERNS0_4BaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_(i2, i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN19SkinnedMeshRenderer12SetLocalAABBERK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 436 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i3 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i3 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP8[i1 + 466 >> 0] = 0;
 return;
}

function __ZN18PlayableController7SetTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 HEAPF64[i1 + 96 >> 3] = d2;
 d2 = +((HEAP32[i1 + 112 >> 2] | 0) >>> 0) * d2;
 i3 = +Math_abs(d2) >= 1.0 ? (d2 > 0.0 ? ~~+Math_min(+Math_floor(d2 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d2 - +(~~d2 >>> 0)) / 4294967296.0) >>> 0) : 0;
 i1 = i1 + 104 | 0;
 HEAP32[i1 >> 2] = ~~d2 >>> 0;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN18PhysxJobDispatcher10submitTaskERN5physx10PxBaseTaskE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i3, fb + 3718 | 0, i2, 1);
 __Z21ClearFenceWithoutSyncR8JobFence(i3);
 STACKTOP = i1;
 return;
}

function __ZN16CircleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12MeshRendererD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 43728 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 43728 + 180;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 i2 = i1 + 288 | 0;
 if ((HEAP32[i1 + 304 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 292 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11SoundHandle7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 __ZN11SoundHandleaSERKS_(i1, i3);
 __ZN11SoundHandleD2Ev(i3);
 STACKTOP = i2;
 return;
}

function __ZN11AudioSource11FixedUpdateEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = i3 + 500 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Z15GetAudioManagerv() | 0;
  i1 = __ZN12AudioManager22GetAutomaticUpdateModeEP10GameObject(i1, HEAP32[i3 + 28 >> 2] | 0) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 if ((i1 | 0) != 1) return;
 if (!(HEAP8[i3 + 33 >> 0] | 0)) return;
 __ZN11AudioSource16UpdateParametersEv(i3);
 return;
}

function __ZN10UnityScene19RemoveRootFromSceneER9Transformb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i1 = i3 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i3 = i3 + 116 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i4 = i3 + 108 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 i3 = i3 + 116 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN10MeshFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z59AnchoredJoint2D_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15AnchoredJoint2D31SetAutoConfigureConnectedAnchorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53Renderer_Set_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 32 + 244 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49WheelCollider_CUSTOM_INTERNAL_set_forwardFrictionP12Il2CppObjectRK18WheelFrictionCurve(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider18SetForwardFrictionERK18WheelFrictionCurve(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49ParticleEmitter_Set_Custom_PropRndAngularVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = f2 < Math_fround(0.0);
   HEAPF32[i3 + 196 >> 2] = i1 ? Math_fround(0.0) : f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44GUIStyle_CUSTOM_INTERNAL_CALL_Internal_Draw213Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 >> 2] | 0;
 i1 = __Z11GetGUIStatev() | 0;
 __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib(i6, i1, i2, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i3) | 0, i4, i5 << 24 >> 24 != 0);
 return;
}

function __Z38UnityWebRequest_Get_Custom_PropIsErrorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 108 >> 2] | 0) == 4 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z37Projector_Set_Custom_PropFarClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 40 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36UnityWebRequest_CUSTOM_InternalAbortP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19TransportJavaScript5AbortEv(i1 + 8 | 0);
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
}

function __Z36RenderTexture_CUSTOM_DiscardContentsP12Il2CppObjecthh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN13RenderTexture15DiscardContentsEbb(i4, i2 << 24 >> 24 != 0, i3 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Animator_CUSTOM_GetBoneTransformP12Il2CppObject14HumanBodyBones(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Animator16GetBoneTransformEi(i3, i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z23CalculateLightingLayersRK12ActiveLights(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i2 + (i1 * 180 | 0) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else {
  i1 = i2;
  i2 = -1;
 }
 do {
  i4 = HEAP32[i1 + 16 >> 2] | 0;
  i2 = ((i4 | 0) == 0 ? -1 : i4) & i2;
  i1 = i1 + 180 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i4 = ~i2;
 return i4 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _strlen(i2) | 0;
 __THREW__ = 0;
 i1 = invoke_iiiiii(fb + 192 | 0, i1 | 0, 0, -1, i2 | 0, i3 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i3);
 } else return i1 | 0;
 return 0;
}

function __ZNK9Transform13GetLocalScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i2 + 32 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i3 = HEAP32[i5 + (i4 * 40 | 0) + 32 >> 2] | 0;
 i2 = HEAP32[i5 + (i4 * 40 | 0) + 36 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + (i4 * 40 | 0) + 28 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZNK9Heightmap13GetPatchIndexEiii(i1, i5, i6, i4) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i1 = 1 << HEAP32[i1 + 80 >> 2];
 if ((i4 | 0) > 0) {
  i2 = i1;
  i1 = 0;
  i3 = 0;
  do {
   i1 = (Math_imul(i2, i2) | 0) + i1 | 0;
   i2 = i2 >> 1;
   i3 = i3 + 1 | 0;
  } while ((i3 | 0) != (i4 | 0));
 } else {
  i2 = i1;
  i1 = 0;
 }
 return i1 + i5 + (Math_imul(i2, i6) | 0) | 0;
}

function __ZNK24DownloadHandlerAudioClip11GetProgressEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 i4 = HEAP32[i2 + 36 >> 2] & 2147483647;
 if (!(HEAP8[i2 + 8 >> 0] | 0)) if (!i4) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(i3 >>> 0) / Math_fround(i4 >>> 0));
  if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(1.0);
 return Math_fround(f1);
}

function __ZNK10GameObject38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i4 = HEAP32[i2 + 40 >> 2] | 0;
 i2 = i1 + (i4 << 3) | 0;
 if (!i4) return;
 do {
  __Z16MarkObjectAsRootRK6ObjectR27GarbageCollectorThreadState(HEAP32[i1 + 4 >> 2] | 0, i3);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN8Renderer17MainThreadCleanupEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = i3 + 316 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i4 = i3 + 320 | 0;
  HEAP32[i2 + 4 >> 2] = HEAP32[i4 >> 2];
  HEAP32[HEAP32[i4 >> 2] >> 2] = i2;
  HEAP32[i1 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 }
 i1 = HEAP32[i3 + 312 >> 2] | 0;
 if (!i1) return;
 __ZN8LODGroup25RemoveFromCachedRenderersEP8Renderer(i1, i3);
 return;
}

function __ZN5physx5cloth8intFloorERK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = ~~Math_fround(Math_floor(Math_fround(HEAPF32[i2 >> 2])));
 i4 = ~~Math_fround(Math_floor(Math_fround(HEAPF32[i2 + 4 >> 2])));
 i3 = ~~Math_fround(Math_floor(Math_fround(HEAPF32[i2 + 8 >> 2])));
 __ZN8Scalar4fC2Eiiii(i1, i5, i4, i3, ~~Math_fround(Math_floor(Math_fround(HEAPF32[i2 + 12 >> 2]))));
 return;
}

function __ZN5physx2Sc17ParticleSystemSim19unlinkParticleShapeEPNS0_19ParticlePacketShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i1 = HEAP16[i1 + 48 >> 1] | 0;
 i4 = i2 + 360 | 0;
 i5 = (HEAP32[i4 >> 2] | 0) + -1 | 0;
 i2 = HEAP32[i2 + 356 >> 2] | 0;
 i3 = HEAP32[i2 + (i5 << 2) >> 2] | 0;
 HEAP16[i3 + 48 >> 1] = i1;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i2 + ((i1 & 65535) << 2) >> 2] = i3;
 return;
}

function __ZN5physx2Sc17ParticleSystemSim19scheduleRefilteringEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 360 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 356 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc19ParticlePacketShape20setInteractionsDirtyENS0_15CoreInteraction9DirtyFlagE(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, 1);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx26PxMeshScaleGeneratedValuesC2EPKNS_11PxMeshScaleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return;
}

function __ZN5physx23PxcPCMContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu20pcmContactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx23PxcPCMContactConvexMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu20pcmContactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx23PxcPCMContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu20pcmContactCapsuleBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx16PxsIslandManager27setWokenPairContactManagersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 284 >> 2] | 0;
 i4 = HEAP32[i1 + 504 >> 2] | 0;
 i1 = HEAP32[i1 + 508 >> 2] | 0;
 if (!i1) return; else i2 = 0;
 do {
  HEAP32[i4 + (i2 << 3) >> 2] = HEAP32[i3 + ((HEAP32[i4 + (i2 << 3) + 4 >> 2] | 0) * 12 | 0) + 8 >> 2] & -16;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN5physx16PxsIslandManager21clearEdgeCreatedFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 336 >> 2] | 0;
 i4 = HEAP32[i1 + 332 >> 2] | 0;
 i1 = HEAP32[i1 + 284 >> 2] | 0;
 if (!i3) return; else i2 = 0;
 do {
  i5 = i1 + ((HEAP32[i4 + (i2 << 2) >> 2] | 0) * 12 | 0) + 8 | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & -5;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN5Image8SetImageERK14ImageReferenceb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 __ZN5Image8SetImageEii13TextureFormatb(i1, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i2 + 8 >> 2] | 0, HEAP32[i2 >> 2] | 0, i3);
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 if (!(HEAP32[i2 + 16 >> 2] | 0)) return;
 __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE(i2, i1, 0);
 return;
}

function __ZN2UI13CanvasManager20MarkAllCanvasesDirtyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  i4 = i3 + 224 | 0;
  HEAP16[i4 >> 1] = HEAPU16[i4 >> 1] | 0 | 4;
  __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv(i3);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN23CloudWebServicesManager27UnregisterPlayerLoopHandlerEP19CloudServiceHandler(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 __ZNSt3__24listIP19CloudServiceHandler13stl_allocatorIS2_L18MemLabelIdentifier85ELi16EEE6removeERKS2_(i1 + 44 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN22DownloadHandlerTexture13CreateTextureEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 if (HEAP32[i2 >> 2] | 0) return;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i3) return;
 i3 = __Z28StartCreateTextureFromBufferPKhjb(HEAP32[i1 + 20 >> 2] | 0, i3, (HEAP8[i1 + 44 >> 0] | 0) != 0) | 0;
 HEAP32[i2 >> 2] = i3;
 __Z34UpdateTextureImageDataOnMainThreadP9Texture2D(i3);
 HEAP8[i1 + 8 >> 0] = 1;
 return;
}

function __ZN21ArchiveStorageCreator22GetEstimatedHeaderSizeEjyj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = ___udivdi3(i2 | 0, i3 | 0, i4 | 0, 0) | 0;
 i3 = ___muldi3(i3 | 0, getTempRet0() | 0, 12, 0) | 0;
 i4 = getTempRet0() | 0;
 i2 = _i64Add(i1 * 2088 | 0, 0, 1036, 0) | 0;
 i4 = _i64Add(i2 | 0, getTempRet0() | 0, i3 | 0, i4 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i4 | 0;
}

function __ZN18PlayableController7DestroyEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP8[i3 + 165 >> 0] = 1;
 i1 = i3 + 168 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z23scripting_gchandle_freej(i2);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i3 + 164 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController(__Z18GetDirectorManagerv() | 0, i3);
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN14AnimationState13SetupStopTimeEv(i3) {
 i3 = i3 | 0;
 var f1 = f0, i2 = 0;
 i2 = Math_fround(HEAPF32[i3 + 36 >> 2]) >= Math_fround(0.0);
 do if ((HEAP32[i3 + 68 >> 2] | 1 | 0) == 1) if (i2) {
  f1 = Math_fround(HEAPF32[i3 + 92 >> 2]);
  break;
 } else {
  f1 = Math_fround(HEAPF32[i3 + 88 >> 2]);
  break;
 } else f1 = i2 ? Math_fround(inf) : Math_fround(-inf); while (0);
 HEAPF32[i3 + 44 >> 2] = f1;
 return;
}

function __ZN12MeshCollider16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i1 = i1 + 124 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(1.00000005e-20);
 i4 = f2 > Math_fround(340282326000000008404918.0e15);
 f2 = i4 ? Math_fround(340282326000000008404918.0e15) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(1.00000005e-20) : f2;
 return;
}

function __Z7FNVHashPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP8[i1 >> 0] | 0;
 if (!(i2 << 24 >> 24)) i1 = 349519301; else {
  i4 = -2128831035;
  do {
   i1 = i1 + 1 | 0;
   i3 = i2 << 24 >> 24 ^ i4;
   i4 = Math_imul(i3, 16777619) | 0;
   i2 = HEAP8[i1 >> 0] | 0;
  } while (i2 << 24 >> 24 != 0);
  i1 = Math_imul(i3, 20078995) | 0;
 }
 i4 = (i1 >>> 7 ^ i1) * 9 | 0;
 return (i4 >>> 17 ^ i4) * 33 | 0;
}

function __Z55Animator_CUSTOM_INTERNAL_CALL_SetIKHintPositionInternalP12Il2CppObjectiRK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator15SetHintPositionEiRK8Vector3f(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Joint_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 132 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Projector_Set_Custom_PropFieldOfViewP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 44 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Projector_Set_Custom_PropAspectRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 48 >> 2] = f2;
   mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function mftCall_viiiiiff(i8, i1, i2, i3, i4, i5, d6, d7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 d7 = +d7;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiiiiff[i8 - fb & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, Math_fround(d6), Math_fround(d7));
  return;
 }
 ftCall_viiiiiff(i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6, +d7);
}

function _ft_outline_glyph_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 108 | 0;
 i4 = i1 + 20 | 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != 1869968492) {
  i4 = 18;
  return i4 | 0;
 }
 i1 = _UNITY_FT_Outline_New(HEAP32[i1 >> 2] | 0, HEAP16[i2 + 110 >> 1] | 0, HEAP16[i3 >> 1] | 0, i4) | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 _UNITY_FT_Outline_Copy(i3, i4) | 0;
 i4 = 0;
 return i4 | 0;
}

function __ZThn12_N12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i(i1, i2, i5, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 + -12 | 0;
 if (!(HEAP8[i1 + 132 >> 0] | 0)) return;
 mftCall_viiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0, i2 | 0, i5 | 0, i3 | 0, i4 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 return __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj(i1, i2, i3, i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) | 0;
}

function __ZN7mecanim12statemachine33DestroySelectorTransitionConstantEPNS0_26SelectorTransitionConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIN12_GLOBAL__N_124PropertyMessageEntryImplEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148912 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc24ElementInteractionMarker11updateStateEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i4 + 6 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 & 2)) {
  i4 = i4 + 4 | 0;
  HEAP16[i4 >> 1] = 0;
  return;
 }
 if (i2) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i4);
  i1 = HEAP16[i3 >> 1] | 0;
 }
 HEAP16[i3 >> 1] = i1 & 65533;
 i4 = i4 + 4 | 0;
 HEAP16[i4 >> 1] = 0;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i2 + 1204 | 0;
 if (HEAP32[i2 + 148 >> 2] | 0) __ZN5physx21PxsBodyTransformVault6updateEv((HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0) + 1444 | 0);
 __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(HEAP32[i1 >> 2] | 0, 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_11PxAggregateEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx16NpParticleSystemD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 97124 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation11GetProgressEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (HEAP32[i1 + 84 >> 2] | 0) {
  f2 = Math_fround(1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZN23PreloadManagerOperation11GetProgressEv(i1));
 f2 = Math_fround(Math_fround(f2 * Math_fround(.100000001)) + Math_fround(Math_fround(HEAPF32[i1 + 136 >> 2]) * Math_fround(.899999976)));
 return Math_fround(f2);
}

function __ZN23ShaderVariantCollection8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer8TransferINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_PKc17TransferMetaFlags(i2, i1 + 32 | 0, gb + 479375 | 0, 0);
 return;
}

function __ZN19TouchPhaseEmulation15FindByPointerIdEPP9TouchImplj(i1, i5, i6) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 4 | 0;
 i1 = 0;
 i3 = 0;
 do {
  i2 = HEAP32[i4 >> 2] | 0;
  if ((HEAP32[i2 + (i3 * 96 | 0) + 80 >> 2] | 0) == (i6 | 0)) {
   HEAP32[i5 + (i1 << 2) >> 2] = i2 + (i3 * 96 | 0);
   i1 = i1 + 1 | 0;
  }
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 32);
 return i1 | 0;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN8Collider8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 60 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 340 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN10MemoryFileD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 71428 + 8;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + 12 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z55ConfigurableJoint_Set_Custom_PropConfiguredInWorldSpaceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint25SetConfiguredInWorldSpaceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetRotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetTargetRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49InitializeSpriteRendererAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 430338 | 0, 60) | 0;
 HEAP32[i1 >> 2] = gb + 59172 + 8;
 HEAP32[gb + 1161916 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 212, 23, HEAP32[gb + 1161916 >> 2] | 0);
 return;
}

function __Z49ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint14SetLinearLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49CharacterJoint_CUSTOM_INTERNAL_set_highTwistLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint17SetHighTwistLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Collider_Get_Custom_PropAttachedRigidbodyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37NavMeshPath_CUSTOM_GetCornersNonAllocP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i2, 0, 12) | 0;
 i2 = __Z21GetScriptingArraySizeP11Il2CppArray(i2) | 0;
 i4 = __Z17GetNavMeshManagerv() | 0;
 return __ZN14NavMeshManager20CalculatePathCornersEP8Vector3fiRK11NavMeshPath(i4, i3, i2, HEAP32[i1 + 8 >> 2] | 0) | 0;
}

function _UNITY_FT_Glyph_Transform(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 if (!i2) i1 = 6; else {
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  if (!i1) i1 = 6; else {
   i1 = HEAP32[i1 + 20 >> 2] | 0;
   if (!i1) i1 = 18; else {
    mftCall_viii(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
    if (!i3) i1 = 0; else {
     _UNITY_FT_Vector_Transform(i2 + 12 | 0, i3);
     i1 = 0;
    }
   }
  }
 }
 return i1 | 0;
}

function _strncat(i6, i3, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = i6 + (_strlen(i6) | 0) | 0;
 L1 : do if (i2) while (1) {
  i5 = HEAP8[i3 >> 0] | 0;
  if (!(i5 << 24 >> 24)) break L1;
  i2 = i2 + -1 | 0;
  i4 = i1 + 1 | 0;
  HEAP8[i1 >> 0] = i5;
  if (!i2) {
   i1 = i4;
   break;
  } else {
   i3 = i3 + 1 | 0;
   i1 = i4;
  }
 } while (0);
 HEAP8[i1 >> 0] = 0;
 return i6 | 0;
}

function _append(i3, i4, i1, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 i1 = _malloc(i1 + 9 | 0) | 0;
 if (!i1) i1 = -1; else {
  HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
  HEAP32[i1 >> 2] = 0;
  i2 = i1 + 4 | 0;
  _strcpy(i2, i4) | 0;
  if (i5 | 0) {
   i5 = i2 + (_strlen(i2) | 0) | 0;
   HEAP8[i5 >> 0] = 47;
   HEAP8[i5 + 1 >> 0] = 0;
  }
  HEAP32[i3 >> 2] = i1;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNK22DownloadHandlerTexture11GetProgressEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 i4 = HEAP32[i2 + 36 >> 2] & 2147483647;
 if (!(HEAP8[i2 + 8 >> 0] | 0)) if (!i4) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(i3 >>> 0) / Math_fround(i4 >>> 0));
  if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(1.0);
 return Math_fround(f1);
}

function __ZN9GfxDevice19EndGraphicsJobsLateEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1157628 >> 2] | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 884 >> 2] | 0, i1 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0);
 i1 = __ZN10DynamicVBO9NextFrameEv() | 0;
 i2 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 512 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN8GUIState24Internal_SetManagedEventEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 280 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i1 = i1 + 284 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  if (i4 | 0) __ZN10InputEventD2Ev(i4);
  __Z19free_alloc_internalPvRK10MemLabelId(i4, gb + 63864 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP8[i1 >> 0] = 0;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN8ColliderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx22PxcPCMContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu19pcmContactBoxConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx20PxProfileZoneManager24createProfileZoneManagerEPNS_12PxFoundationE(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!i2) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0) | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 48, gb + 766896 | 0, gb + 740601 | 0, 160) | 0;
 __ZN5physx7profile15ZoneManagerImplC2EPNS_12PxFoundationE(i1, i2);
 return i1 | 0;
}

function __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx15NpParticleFluidD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 95912 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN2UI6Canvas20SetupOverlayMatricesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN2UI6Canvas19GetProjectionMatrixEv(i1) | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, gb + 1162292 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, gb + 1162292 | 0);
 return;
}

function __ZN26AnimatorControllerPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 144 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + 64 | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN18AudioLowPassFilterD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 171508 + 8;
 i2 = i1 + 100 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 104 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE13TextureFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__Z19IsHalfTextureFormat13TextureFormat(i2) | 0) if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 476 >> 0] | 0)) HEAP32[i1 >> 2] = 0;
 if (!(__Z20IsFloatTextureFormat13TextureFormat(i2) | 0)) return;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 477 >> 0] | 0) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZL25DestroySparseTexturesGLESPv(i1) {
 i1 = i1 | 0;
 __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(gb + 1451152 | 0, HEAP32[gb + 1451152 + 4 >> 2] | 0);
 HEAP32[gb + 1451152 + 8 >> 2] = 0;
 HEAP32[gb + 1451152 >> 2] = gb + 1451152 + 4;
 HEAP32[gb + 1451152 + 4 >> 2] = 0;
 return;
}

function __Z51MeshRenderer_Get_Custom_PropAdditionalVertexStreamsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK12MeshRenderer26GetAdditionalVertexStreamsEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48InitializeRectTransformAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 407244 | 0, 89) | 0;
 HEAP32[i1 >> 2] = gb + 44796 + 8;
 HEAP32[gb + 1158344 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 224, 28, HEAP32[gb + 1158344 >> 2] | 0);
 return;
}

function __Z48InitializeMonoBehaviourAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 457339 | 0, 62) | 0;
 HEAP32[i1 >> 2] = gb + 65524 + 8;
 HEAP32[gb + 1163036 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 114, 24, HEAP32[gb + 1163036 >> 2] | 0);
 return;
}

function __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalVectoriRK8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __Z21SetShaderGlobalVectorN9ShaderLab16FastPropertyNameERK8Vector4f(i4, i2);
 STACKTOP = i3;
 return;
}

function __Z37Light_Set_Custom_PropShadowNormalBiasP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 116 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36CanvasRenderer_CUSTOM_GetPopMaterialP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN2UI14CanvasRenderer14GetPopMaterialEi(i3, i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33GUIStyle_Set_Custom_PropFontStyleP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 288 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z33GUIStyle_Set_Custom_PropAlignmentP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 244 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function _sfnt_get_glyph_name(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i6;
 i1 = _UNITY_tt_face_get_ps_name(i1, i2, i5) | 0;
 if (i1 | 0) {
  STACKTOP = i6;
  return i1 | 0;
 }
 _UNITY_ft_mem_strcpyn(i3, HEAP32[i5 >> 2] | 0, i4) | 0;
 STACKTOP = i6;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP8[i4 + 8 + 3 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i1, i2, i3, i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) | 0;
}

function __ZNK4Mesh15GetTopologyMaskEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i3 = HEAP32[i2 + 128 >> 2] | 0;
 i2 = (HEAP32[i2 + 132 >> 2] | 0) - i3 | 0;
 i4 = (i2 | 0) / 52 | 0;
 if (!i2) {
  i4 = 0;
  return i4 | 0;
 } else {
  i2 = 0;
  i1 = 0;
 }
 do {
  i1 = 1 << HEAP32[i3 + (i2 * 52 | 0) + 40 >> 2] | i1;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZNK30SpriteRendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i2 >> 2] = i3;
 __ZN8Renderer13BoundsChangedEv(i1);
 __ZN14SpriteRenderer15SetupPropertiesEv(i1);
 __ZN14SpriteRenderer18UpdateCachedSpriteEv(i1);
 return;
}

function __ZNK21DownloadHandlerBuffer11GetProgressEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 i4 = HEAP32[i2 + 36 >> 2] & 2147483647;
 if (!(HEAP8[i2 + 8 >> 0] | 0)) if (!i4) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(i3 >>> 0) / Math_fround(i4 >>> 0));
  if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(1.0);
 return Math_fround(f1);
}

function __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 132 >> 2] | 0;
 if (!i3) {
  HEAPF32[i1 >> 2] = Math_fround(inf);
  HEAPF32[i1 + 4 >> 2] = Math_fround(-inf);
  return;
 } else {
  i2 = HEAP32[i2 + 120 >> 2] | 0;
  i3 = HEAP32[i2 + ((i3 + -1 | 0) * 40 | 0) >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  return;
 }
}

function __ZN9SubModule5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy(i1 + 8 | 0, 1, i3, 1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sq10AABBPruner11shiftOriginERKNS_6PxVec3E(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx2Sq11PruningPool11shiftOriginERKNS_6PxVec3E(i3 + 7760 | 0, i2);
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (i1 | 0) __ZN5physx2Sq8AABBTree11shiftOriginERKNS_6PxVec3E(i1, i2);
 if (!(HEAP8[i3 + 7808 >> 0] | 0)) return;
 __ZN5physx2Sq16BucketPrunerCore11shiftOriginERKNS_6PxVec3E(i3 + 144 | 0, i2);
 return;
}

function __ZN4FMOD7SystemI13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i1 + 376 >> 2] = i2;
 HEAP32[i1 + 380 >> 2] = i3;
 HEAP32[i1 + 384 >> 2] = i4;
 HEAP32[i1 + 388 >> 2] = i5;
 return 0;
}

function __ZN22ParticleSystemRenderer14UpdateRendererEv(i1) {
 i1 = i1 | 0;
 if (!(__ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 80300 | 0) | 0)) {
  __ZN8Renderer18UpdateManagerStateEb(i1, 0);
  __ZN8Renderer14UpdateRendererEv(i1);
  return;
 } else {
  __ZN8Renderer10SetVisibleEb(i1, 1);
  __ZN8Renderer13BoundsChangedEv(i1);
  __ZN8Renderer14UpdateRendererEv(i1);
  return;
 }
}

function __ZN18AwakeFromLoadQueue10ClearQueueEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + (i2 * 20 | 0) | 0;
 i4 = i1 + (i2 * 20 | 0) + 16 | 0;
 if ((HEAP32[i4 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i3 >> 2] | 0, i1 + (i2 * 20 | 0) + 4 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + (i2 * 20 | 0) + 12 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __ZN14PhysicsManager18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction(i1, i2, i3, f4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5Unity12PhysicsQuery18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction(0, i2, i3, f4, i5, i6, i7) | 0;
}

function __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj(i3, i2, i4, i5, i6, i1, i7) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i7 = i7 | 0;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj(i3 + 8 | 0, HEAP32[i2 + 8 >> 2] | 0, i4, i5, i6, i7);
 return 1;
}

function __ZN10MonoScript5RenewEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti(i2, HEAPU8[i1 + 140 >> 0] | 0, i1, HEAP32[i1 + 64 >> 2] | 0) | 0;
 HEAP32[i1 + 88 >> 2] = i2;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache(__Z19GetScriptingManagerv() | 0, i2);
 return;
}

function __Z55SkinnedMeshRenderer_Set_Custom_PropSkinnedMotionVectorsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19SkinnedMeshRenderer27SetSkinnedMeshMotionVectorsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetAngularYZDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48CharacterJoint_CUSTOM_INTERNAL_set_lowTwistLimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint16SetLowTwistLimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46UnityWebRequest_Get_Custom_PropUseHttpContinueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 121 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z46UnityWebRequest_Get_Custom_PropChunkedTransferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 120 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z36Light_Set_Custom_PropShadowNearPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 120 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35CullingGroup_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return (HEAP32[i1 + 8 >> 2] | 0) != -1 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z33Event_Set_Custom_PropDisplayIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 40 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z32GetMousePositionFromInputManagerv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 i4 = __Z15GetInputManagerv() | 0;
 i3 = HEAP32[i4 + 116 >> 2] | 0;
 f2 = Math_fround(HEAPF32[i4 + 120 >> 2]);
 i4 = __Z16GetScreenManagerv() | 0;
 f2 = Math_fround(Math_fround((mftCall_ii(HEAP32[(HEAP32[i4 >> 2] | 0) + 84 >> 2] | 0, i4 | 0) | 0) + -1 | 0) - f2);
 HEAP32[i1 >> 2] = i3;
 HEAPF32[i1 + 4 >> 2] = f2;
 return;
}

function __Z32GUIStyle_Set_Custom_PropFontSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 284 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z32GUIStyle_Set_Custom_PropClippingP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 252 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z19setPxMaterial_FlagsPN5physx10PxMaterialENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z15Transfer_StringI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z22TransferField_NonArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function __Z11loadAlignedPKf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 8 | 0;
 i3 = i2 + 4 | 0;
 i5 = i2;
 __ZN6detail14AlignedPointerIfEC2EPKf(i5, i1);
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __ZN13Simd4fFactoryIN6detail14AlignedPointerIfEEEC2ES2_(i3, i4);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function mftCall_viiifiii(i8, i1, i2, i3, d4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiifiii[i8 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0, i7 | 0);
  return;
 }
 ftCall_viiifiii(i8 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0, i7 | 0);
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP8[i4 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 return __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, i2, i3, i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) | 0;
}

function __ZNK9Transform16GetLocalPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i2 + 32 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i5 = HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0;
 i3 = HEAP32[i5 + (i4 * 40 | 0) + 4 >> 2] | 0;
 i2 = HEAP32[i5 + (i4 * 40 | 0) + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + (i4 * 40 | 0) >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZNK5physx2Sc14ConstraintCore8getForceERNS_6PxVec3ES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[i2 + 8 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  HEAP32[i3 + 4 >> 2] = 0;
  HEAP32[i3 + 8 >> 2] = 0;
  return;
 } else {
  __ZN5physx2Sc13ConstraintSim8getForceERNS_6PxVec3ES3_(i1, i2, i3);
  return;
 }
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getDynamicFrictionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 4096)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore18getDynamicFrictionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 52 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE28getMassSpaceInvInertiaTensorEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 2)) i1 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i1 + 64 | 0) | 0; else i1 = (HEAP32[i1 + 56 >> 2] | 0) + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN9Animation19SortAnimationStatesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_(HEAP32[i1 + 104 >> 2] | 0, HEAP32[i1 + 108 >> 2] | 0, i2);
 i3 = i1 + 252 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -3;
 HEAP32[i1 + 248 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = 1 << i4;
 i1 = i3 + 1592 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!((HEAP8[i3 + 1992 >> 0] | 0) == 0 | (i2 & i5 | 0) == 0)) return;
 HEAP32[i1 >> 2] = i2 | i5;
 i5 = HEAP32[i3 + 768 >> 2] | 0;
 mftCall_vi(i5 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i3 + 860 >> 2] | 0, i4) | 0);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 + 4 >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148188 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx21PxcPCMContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu18pcmContactPlaneBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx21PxcContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu18contactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_9PxD6JointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx15NpParticleFluid23setRestParticleDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0;
 switch ((HEAP32[i2 + 24 >> 2] | 0) >>> 30 | 0) {
 case 2:
  {
   i3 = 2;
   break;
  }
 case 3:
  return;
 default:
  {}
 }
 if ((i3 | 0) == 2) if (HEAP8[(HEAP32[i2 + 20 >> 2] | 0) + 2433 >> 0] | 0) return;
 __ZN5physx2Sc18ParticleSystemCore23setRestParticleDistanceEf(i2 + 32 | 0, f1);
 return;
}

function __ZN5physx10NpMaterialD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 93280 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 93280 + 108;
 __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN23AllocationRootReference15RemoveReferenceEP24ProfilerAllocationHeaderj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 >> 2] = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) - i3;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN23AllocationRootReferenceD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63584 | 0);
 return;
}

function __ZN20BufferedSocketStream8ShutdownEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 18 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i2 = 1;
  i1 = i1 + 19 | 0;
  HEAP8[i1 >> 0] = 0;
  return i2 | 0;
 }
 i3 = __ZN6Socket10CheckErrorEiPKcii(__Z13shutdown_stubii(HEAP32[i1 + 4 >> 2] | 0, 2) | 0, gb + 584846 | 0, 107, 0) | 0;
 HEAP8[i2 >> 0] = 0;
 i2 = i3 ^ 1;
 i1 = i1 + 19 | 0;
 HEAP8[i1 >> 0] = 0;
 return i2 | 0;
}

function __ZN19CharacterControllerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18ProfilerConnection21EnableProfilerMessageEPKvjj(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i1 & 1 | 0) != 0;
 i3 = HEAP32[gb + 1163256 >> 2] | 0;
 if (i2) HEAP32[i3 >> 2] = i4; else if ((HEAP32[i3 >> 2] | 0) != (i4 | 0)) return;
 i4 = HEAP32[gb + 1451e3 >> 2] | 0;
 HEAP32[i4 + 28 >> 2] = i1;
 __ZN13UnityProfiler10SetEnabledEb(i4, i2);
 return;
}

function __ZN16b2BlockAllocatorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 4 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) {
  i1 = 0;
  do {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0, gb + 63408 | 0);
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63408 | 0);
 return;
}

function __ZN13GfxDeviceGLES32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN4gles24CreateColorRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE(i1 + 4620 | 0, i2, __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(HEAP32[i1 + 5480 >> 2] | 0, i3, (HEAP32[i2 + 20 >> 2] | 0) >>> 2 & 1) | 0);
 return 1;
}

function __ZN12_GLOBAL__N_117ConnectionManager14onDeallocationEPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = i1 + 184 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i4 = HEAP32[i4 + 4 >> 2] | 0;
 i1 = i1 + (i4 >> 1) | 0;
 if (!(i4 & 1)) {
  i4 = i2;
  mftCall_vii(i4 | 0, i1 | 0, i3 | 0);
  return;
 } else {
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + i2 >> 2] | 0;
  mftCall_vii(i4 | 0, i1 | 0, i3 | 0);
  return;
 }
}

function __ZN11SoundHandleC2ERKS_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = i2;
 if (!i2) {
  HEAP32[i3 >> 2] = i1;
  return;
 }
 i2 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP32[i3 >> 2] = i1;
 return;
}

function __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKPositionInternalP12Il2CppObjectiRK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator15SetGoalPositionEiRK8Vector3f(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeTorqueP12Il2CppObjectRK8Vector3fi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Rigidbody17AddRelativeTorqueERK8Vector3fi(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46SkinnedMeshRenderer_CUSTOM_SetBlendShapeWeightP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN19SkinnedMeshRenderer19SetBlendShapeWeightEjf(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45InitializeBlendShapeAnimationBindingInterfacev() {
 var i1 = 0;
 if (!(__Z13GetIAnimationv() | 0)) return;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63320 | 0, 16, gb + 426857 | 0, 134) | 0;
 HEAP32[i1 >> 2] = gb + 58584 + 8;
 HEAP32[gb + 1161540 >> 2] = i1;
 i1 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, 137, 20, HEAP32[gb + 1161540 >> 2] | 0);
 return;
}

function __Z39AudioMixerDuckingGetFloatBufferCallbackP21UnityAudioEffectStatePKcPfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = HEAP32[i1 + 28 >> 2] | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(_log10f(Math_fround(HEAPF32[i4 >> 2]))) * Math_fround(10.0));
 HEAPF32[i3 + 4 >> 2] = Math_fround(Math_fround(_log10f(Math_fround(HEAPF32[i4 + 4 >> 2]))) * Math_fround(20.0));
 return 0;
}

function __Z32WindZone_Set_Custom_PropWindMainP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 44 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32RectOffset_Set_Custom_PropBottomP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 12 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z28Rigidbody2D_CUSTOM_AddTorqueP12Il2CppObjectfN11Rigidbody2D9ForceModeE(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN11Rigidbody2D9AddTorqueEfNS_9ForceModeE(i4, f2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z15Transfer_StringI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI9JSONWrite16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function mftCall_viiiiiii(i8, i1, i2, i3, i4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 63 | 0)) {
  FUNCTION_TABLE_viiiiiii[i8 - fb & 63](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
  return;
 }
 ftCall_viiiiiii(i8 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function _tt_cmap14_def_char_count(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = (HEAPU8[i2 + 1 >> 0] | 0) << 16 | (HEAPU8[i2 >> 0] | 0) << 24 | (HEAPU8[i2 + 2 >> 0] | 0) << 8 | (HEAPU8[i2 + 3 >> 0] | 0);
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = i1;
 i2 = i2 + 7 | 0;
 i1 = 0;
 while (1) {
  i1 = i1 + 1 + (HEAPU8[i2 >> 0] | 0) | 0;
  i3 = i3 + -1 | 0;
  if (!i3) break; else i2 = i2 + 4 | 0;
 }
 return i1 | 0;
}

function _gray_raster_new(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i2 >> 2] = 0;
 i3 = _UNITY_ft_mem_alloc(i1, 4, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = i3;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((i4 | 0) == (i2 | 0)) break;
  i5 = i4 + -8 | 0;
  HEAP32[i3 >> 2] = i5;
  i4 = i5;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 return;
}

function __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 i1 = i1 + 102872 | 0;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 __ZNK13b2DynamicTree5QueryI19b2WorldQueryWrapperEEvPT_RK6b2AABB(i1, i5, i3);
 STACKTOP = i4;
 return;
}

function __ZNK22NavMeshProjectSettings11GetAreaCostEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 if (i2 >>> 0 > 31) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 841954 | 0, 0, gb + 841974 | 0, 212, 1, 0, 0, 0);
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 } else {
  f3 = Math_fround(HEAPF32[i1 + 28 + (i2 * 20 | 0) + 16 >> 2]);
  return Math_fround(f3);
 }
 return f0;
}

function __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i5 = 0;
 i5 = 1 << i4;
 i1 = i3 + 1592 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP8[i3 + 1992 >> 0] | 0) != 0 & (i2 & i5 | 0) == 0) return;
 HEAP32[i1 >> 2] = i2 & ~i5;
 i5 = HEAP32[i3 + 772 >> 2] | 0;
 mftCall_vi(i5 | 0, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(HEAP32[i3 + 860 >> 2] | 0, i4) | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5physx21PxcContactConvexMesh2ERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx15PxsCCDSweepTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 24 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 20 | 0;
 i2 = 0;
 do {
  i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
  Math_fround(__ZN5physx10PxsCCDPair16sweepEstimateToiEv(i4));
  HEAP32[i4 + 92 >> 2] = 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx13BigConvexData13CreateOffsetsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP16[i4 + 2 >> 1] = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (i1 >>> 0 > 1) {
  i2 = 0;
  i3 = 1;
 } else return;
 do {
  i2 = (HEAPU16[i4 + (i3 + -1 << 2) >> 1] | 0) + (i2 & 65535) | 0;
  HEAP16[i4 + (i3 << 2) + 2 >> 1] = i2;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i1 >>> 0);
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 450783 | 0, i1, 0);
 __ZN30RuntimeInitializeOnLoadManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN2UI13CanvasManager14GetDisplaySizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 i2 = __Z16GetScreenManagerv() | 0;
 f4 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0);
 i2 = __Z16GetScreenManagerv() | 0;
 f3 = Math_fround(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN27AnimationLayerMixerPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 32 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN24UVModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 switch (i4 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 864 >> 2] | 0) + 88 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[(HEAP32[i3 + 864 >> 2] | 0) + 352 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN18ScriptingArguments9AddUInt64Ey(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 192 | 0;
 i5 = i1 + (HEAP32[i4 >> 2] << 3) | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 96 + (i3 << 2) >> 2] = i1 + (i3 << 3);
 HEAP32[i1 + 144 + (HEAP32[i4 >> 2] << 2) >> 2] = 11;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZN18AudioMixerSnapshot8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN17AnimationCurveTplIfE15SetPostInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 80 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZN16RayRTreeCallbackILi1ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 85436 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85436 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16RayRTreeCallbackILi1ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 85388 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85388 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16RayRTreeCallbackILi0ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 86012 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 86012 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16RayRTreeCallbackILi0ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 84176 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 84176 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i3 + 160 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i3 + 72 | 0;
 HEAP32[i3 + 156 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 88 >> 2] = HEAP32[i3 + 80 >> 2];
 HEAP8[i1 >> 0] = 1;
 HEAP32[i2 >> 2] = i3 + 92;
 HEAP32[i3 + 76 >> 2] = 1;
 i3 = 1;
 return i3 | 0;
}

function __ZN12SocketStream4SendEPKvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = __ZN6Socket4SendEPKvjP12SendUserData(i3, i1, i2, 0) | 0;
 if ((i1 | 0) >= 0) {
  i3 = i1;
  return i3 | 0;
 }
 if (__ZN6Socket15WouldBlockErrorEv() | 0) {
  i3 = i1;
  return i3 | 0;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0);
 i3 = i1;
 return i3 | 0;
}

function __ZN10GUITexture23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 52 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z56CharacterController_Set_Custom_PropEnableOverlapRecoveryP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController24SetEnableOverlapRecoveryEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularXDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint16SetAngularXDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44UnityWebRequest_Get_Custom_PropRedirectLimitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 36 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z43Transform_CUSTOM_INTERNAL_CALL_RotateAroundP12Il2CppObjectRK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Transform12RotateAroundERK8Vector3ff(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Event_Set_Custom_PropClickCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 32 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z28delete_object_internal_step2P6Object(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[i1 + 8 >> 2] & 2047;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i3);
 STACKTOP = i2;
 return;
}

function __Z26CommandBuffer_CUSTOM_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN22RenderingCommandBuffer13ClearCommandsEv(i1);
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
}

function __Z22SpriteRenderer_CleanupR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63744 | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __GLOBAL__sub_I_SwCollision_cpp() {
 ___cxx_global_var_init();
 ___cxx_global_var_init1();
 ___cxx_global_var_init2();
 ___cxx_global_var_init3();
 ___cxx_global_var_init4();
 ___cxx_global_var_init5();
 ___cxx_global_var_init6();
 ___cxx_global_var_init7();
 ___cxx_global_var_init8();
 ___cxx_global_var_init9();
 ___cxx_global_var_init10();
 ___cxx_global_var_init11();
 ___cxx_global_var_init12();
 return;
}

function _wcsncat(i6, i3, i2) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i1 = i6 + ((_wcslen(i6) | 0) << 2) | 0;
 L1 : do if (i2) while (1) {
  i5 = HEAP32[i3 >> 2] | 0;
  if (!i5) break L1;
  i2 = i2 + -1 | 0;
  i4 = i1 + 4 | 0;
  HEAP32[i1 >> 2] = i5;
  if (!i2) {
   i1 = i4;
   break;
  } else {
   i3 = i3 + 4 | 0;
   i1 = i4;
  }
 } while (0);
 HEAP32[i1 >> 2] = 0;
 return i6 | 0;
}

function _seed48(i1) {
 i1 = i1 | 0;
 HEAP16[gb + 1478662 >> 1] = HEAP16[gb + 228072 >> 1] | 0;
 HEAP16[gb + 1478662 + 2 >> 1] = HEAP16[gb + 228072 + 2 >> 1] | 0;
 HEAP16[gb + 1478662 + 4 >> 1] = HEAP16[gb + 228072 + 4 >> 1] | 0;
 HEAP16[gb + 228072 >> 1] = HEAP16[i1 >> 1] | 0;
 HEAP16[gb + 228072 + 2 >> 1] = HEAP16[i1 + 2 >> 1] | 0;
 HEAP16[gb + 228072 + 4 >> 1] = HEAP16[i1 + 4 >> 1] | 0;
 return gb + 1478662 | 0;
}

function ___ftello_unlocked(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!(HEAP32[i2 >> 2] & 128)) i1 = 1; else i1 = (HEAP32[i2 + 20 >> 2] | 0) >>> 0 > (HEAP32[i2 + 28 >> 2] | 0) >>> 0 ? 2 : 1;
 i1 = mftCall_iiii(HEAP32[i2 + 40 >> 2] | 0, i2 | 0, 0, i1 | 0) | 0;
 if ((i1 | 0) >= 0) i1 = i1 - (HEAP32[i2 + 8 >> 2] | 0) + (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i2 + 20 >> 2] | 0) - (HEAP32[i2 + 28 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 89572 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 89572 + 32;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0, i2 + -8 | 0, HEAP32[i2 + -4 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP8[i4 + 11 >> 0] | 0;
 i6 = i5 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i1, i2, i3, i6 ? HEAP32[i4 >> 2] | 0 : i4, i6 ? HEAP32[i4 + 4 >> 2] | 0 : i5 & 255) | 0;
}

function __ZNK7dtCrowd29getObstacleFromProximityIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 400 >> 2] | 0;
 if ((i3 | 0) > (i2 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (((HEAP32[i1 + 404 >> 2] | 0) + i3 | 0) <= (i2 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 416 >> 2] | 0) + ((HEAP32[(HEAP32[i1 + 396 >> 2] | 0) + (i2 - i3 << 2) >> 2] | 0) * 92 | 0) | 0;
 return i3 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17getStaticFrictionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 8192)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore17getStaticFrictionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 56 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getDynamicFrictionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 4096)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore18getDynamicFrictionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 52 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZNK5Umbra20ObjectDistanceParams17getReferencePointERNS_7Vector3E(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i1 + 16 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 };
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = (HEAP8[i2 >> 0] | 0) != 0;
 return i3 | 0;
}

function __ZNK15RelativeJoint2D15GetLinearOffsetEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = HEAP32[i2 + 88 >> 2];
  HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 92 >> 2];
  return;
 } else {
  i2 = __ZNK12b2MotorJoint15GetLinearOffsetEv(i3) | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  return;
 }
}

function __ZN7mecanim12statemachine20GetBlendTreeConstantERKNS0_13StateConstantEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 12 | 0;
 i1 = HEAP32[(HEAP32[i3 >> 2] | 0) + i3 + (i1 << 2) >> 2] | 0;
 if ((i1 | 0) == -1) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i2 + 20 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 + (i1 << 2) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i3 = (i3 | 0) == 0 ? 0 : i2 + i3 | 0;
 return i3 | 0;
}

function __ZN5physx20PxcPCMContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu17pcmContactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx20PxcContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu17contactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx18RepXSerializerImplINS_7PxShapeEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx18RepXSerializerImplINS_7PxClothEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE(i6, i3, i2, i5, i4, i1) {
 i6 = i6 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 20 >> 2] | 0, i6 | 0, HEAP32[i3 + 4 >> 2] | 0, i2 | 0, i5 | 0, i4 | 0, i1 | 0);
 return;
}

function __ZN5physx13PxsCCDContext6createEPNS_10PxsContextE(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, 268, gb + 714377 | 0, 253) | 0;
 if (!i1) {
  STACKTOP = i3;
  return i1 | 0;
 }
 __ZN5physx13PxsCCDContextC2EPNS_10PxsContextE(i1, i2);
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN4Tree23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN2UI14CanvasRenderer13SetShouldCullEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 164 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2560;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN26AnimatorControllerPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 48 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN23ShaderVariantCollection8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN22UnityProfilerPerThread7CleanupEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN13UnityProfiler23RemovePerThreadProfilerEP22UnityProfilerPerThread(HEAP32[gb + 1451e3 >> 2] | 0, i1);
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (i1 | 0) __ZN22UnityProfilerPerThreadD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
 HEAP32[gb + 1163228 >> 2] = 0;
 return;
}

function __ZN20SubstanceArchiveDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 59540 + 8;
 __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1 + 36 | 0, HEAP32[i1 + 40 >> 2] | 0);
 if ((HEAP32[i1 + 28 >> 2] | 0) <= -1) return;
 i2 = i1 + 12 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 16 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN18DownloadHandlerVFS4InitEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 20 | 0;
 i1 = i1 + 1080 | 0;
 if (__ZN15FileSystemEntry8IsLockedEv(i3) | 0) {
  __ZN12FileAccessor5CloseEv(i1) | 0;
  __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i3, 8, 0) | 0;
 }
 __ZN15FileSystemEntry3SetEPKc(i3, i2);
 return __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i3, 2, i1) | 0;
}

function __ZN17AnimationCurveTplIfE14SetPreInfinityEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 HEAP32[i2 + 76 >> 2] = i1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(inf);
 HEAP32[i2 >> 2] = 0;
 HEAPF32[i2 + 32 >> 2] = Math_fround(inf);
 HEAP32[i2 + 28 >> 2] = 0;
 return;
}

function __ZN15PolynomialCurve12IsValidCurveERK17AnimationCurveTplIfE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i2) {
  i2 = 1;
  return i2 | 0;
 }
 i3 = i2 + -1 | 0;
 i4 = HEAP32[i1 + 56 >> 2] | 0;
 i1 = Math_fround(HEAPF32[i4 >> 2]) != Math_fround(0.0);
 i2 = ((Math_fround(HEAPF32[i4 + (i3 << 4) >> 2]) != Math_fround(1.0) & 1) + (i1 ? i2 : i3) | 0) < 9;
 return i2 | 0;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 28 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 28 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13RenderTexture24CorrectVerticalTexelSizeEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var f2 = f0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) return;
 i1 = i1 + 72 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 if (!(!(f2 < Math_fround(0.0)) | i3 ^ 1)) {
  HEAPF32[i1 >> 2] = Math_fround(-f2);
  return;
 }
 if (!(f2 > Math_fround(0.0)) | i3) return;
 HEAPF32[i1 >> 2] = Math_fround(-f2);
 return;
}

function __ZN12MeshCollider13SetSharedMeshE4PPtrI4MeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 + 68 >> 2] | 0) == (i1 | 0)) if (!(HEAP8[i2 + 120 >> 0] | 0)) return;
 HEAP32[i2 + 64 >> 2] = i1;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 return;
}

function __Z66AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoCountInternal9HPlayableRS_ih(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZNK26AnimatorControllerPlayable24GetAnimatorClipInfoCountEib(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, i4 << 24 >> 24 != 0) | 0;
 return i4 | 0;
}

function __Z54Camera_CUSTOM_INTERNAL_set_nonJitteredProjectionMatrixP12Il2CppObjectRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera30SetNonJitteredProjectionMatrixERK10Matrix4x4f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK8Vector3fi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Rigidbody16AddRelativeForceERK8Vector3fi(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Light_Set_Custom_PropShadowCustomResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   HEAP32[(HEAP32[i3 + 44 >> 2] | 0) + 104 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40SliderJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK24JointTranslationLimits2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D9SetLimitsERK24JointTranslationLimits2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34MaterialPropertyBlock_CUSTOM_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   __ZN19ShaderPropertySheet5ClearEb(i1, 1);
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
}

function __Z31RectOffset_Set_Custom_PropRightP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 4 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z30WindZone_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i1 = i2 + 40 | 0;
   if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
   HEAPF32[i1 >> 2] = f3;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Event_Set_Custom_PropModifiersP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 24 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z30Event_Set_Custom_PropCharacterP12Il2CppObjectt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP16[i1 + 36 >> 1] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z29Avatar_CUSTOM_SetMuscleMinMaxP12Il2CppObjectiff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN6Avatar15SetMuscleMinMaxEiff(i5, i2, f3, f4);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24Font_CUSTOM_HasCharacterP12Il2CppObjectt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN20TextRenderingPrivate8FontImpl12HasCharacterEjij(HEAP32[i3 + 48 >> 2] | 0, i2 & 65535, 0, 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z15Transfer_StringI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z19TransferField_ArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_(i1, i2, i3);
 STACKTOP = i3;
 return;
}

function _UNITY_LZ4_slideInputBuffer(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i2 = i1 + 16396 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 i4 = i1 + 16392 | 0;
 i3 = i1 + 16400 | 0;
 i6 = HEAP32[i3 >> 2] | 0;
 i1 = i6 >>> 0 < 65536 ? i6 : 65536;
 _memmove(i5 | 0, (HEAP32[i4 >> 2] | 0) + i6 + (0 - i1) | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = i5;
 HEAP32[i3 >> 2] = i1;
 return (HEAP32[i2 >> 2] | 0) + i1 | 0;
}

function _wcscmp(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == 0 | ((i1 | 0) == 0 | (i1 | 0) != (i4 | 0))) i2 = i4; else {
  do {
   i2 = i2 + 4 | 0;
   i3 = i3 + 4 | 0;
   i1 = HEAP32[i2 >> 2] | 0;
   i4 = HEAP32[i3 >> 2] | 0;
  } while (!((i4 | 0) == 0 | ((i1 | 0) == 0 | (i1 | 0) != (i4 | 0))));
  i2 = i4;
 }
 return i1 - i2 | 0;
}

function _t2_hints_funcs_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = fb + 3861;
 HEAP32[i1 + 8 >> 2] = fb + 1082;
 HEAP32[i1 + 12 >> 2] = fb + 314;
 HEAP32[i1 + 16 >> 2] = fb + 315;
 HEAP32[i1 + 20 >> 2] = fb + 970;
 HEAP32[i1 + 24 >> 2] = fb + 187;
 return;
}

function ___cxa_can_catch(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 i1 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 if (i1) HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i5;
 return i1 & 1 | 0;
}

function __ZNSt3__219__thread_local_dataEv() {
 var i1 = 0;
 do if (!(HEAP8[gb + 1100480 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100480 | 0) | 0) {
  __THREW__ = 0;
  invoke_vi(fb + 4010 | 0, gb + 1476996 | 0);
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_2() | 0;
   getTempRet0() | 0;
   ___resumeException(i1 | 0);
  } else break;
 } while (0);
 return gb + 1476996 | 0;
}

function __ZNSt3__212strstreambuf6__initEPciS1_(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) i2 = _strlen(i4) | 0; else i2 = (i2 | 0) < 0 ? 2147483647 : i2;
 if (!i1) i1 = i4 + i2 | 0; else {
  HEAP32[i3 + 24 >> 2] = i1;
  HEAP32[i3 + 20 >> 2] = i1;
  HEAP32[i3 + 28 >> 2] = i1 + i2;
 }
 HEAP32[i3 + 8 >> 2] = i4;
 HEAP32[i3 + 12 >> 2] = i4;
 HEAP32[i3 + 16 >> 2] = i1;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 <= i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i4 << 2) | 0;
}

function __ZNK6Camera25CalculateFarCullDistancesEPff(i3, i4, f5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 var f1 = f0, i2 = 0, i6 = 0;
 i6 = i3 + 924 | 0;
 i2 = 0;
 do {
  f1 = Math_fround(HEAPF32[i3 + 932 + (i2 << 2) >> 2]);
  if (!(f1 != Math_fround(0.0))) f1 = Math_fround(HEAPF32[i6 >> 2]);
  HEAPF32[i4 + (i2 << 2) >> 2] = Math_fround(f1 + f5);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 32);
 return;
}

function __ZNK5physx5cloth6GatherI8Scalar4fEclEPKS2_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Eiiii(i1, HEAP32[i3 + 16 >> 2] & HEAP32[i2 + (HEAP32[i3 >> 2] << 2) >> 2], HEAP32[i3 + 20 >> 2] & HEAP32[i2 + (HEAP32[i3 + 4 >> 2] << 2) >> 2], HEAP32[i3 + 24 >> 2] & HEAP32[i2 + (HEAP32[i3 + 8 >> 2] << 2) >> 2], HEAP32[i3 + 28 >> 2] & HEAP32[i2 + (HEAP32[i3 + 12 >> 2] << 2) >> 2]);
 return;
}

function __ZNK5physx3Cct26CharacterControllerManager17onObstacleRemovedEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 68 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 64 | 0;
 i2 = 0;
 do {
  __ZN5physx3Cct9SweepTest17onObstacleRemovedEj((HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 88 | 0, i4);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN9Projector23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 64 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN8Animator20SetLookAtClampWeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 52 >> 2] = f2;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf14TexFormatRHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_117ProfileZoneClientEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148240 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_19ParticlePacketShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj(HEAP32[i2 >> 2] | 0, i1, 0);
 __ZN5physx2Sc7Element21destroyLowLevelVolumeEv(i1) | 0;
 i2 = (HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 40 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 40 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN26AnimatorControllerPlayable12HasParameterEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = (HEAP32[i1 + 92 >> 2] | 0) + 16 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = (__ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj((i1 | 0) == 0 ? 0 : i3 + i1 | 0, i2) | 0) != -1;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 946466 | 0, i1, 0);
 __ZN20TextRenderingPrivate8TextMesh8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18ScriptingArguments8AddInt64Ex(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 192 | 0;
 i5 = i1 + (HEAP32[i4 >> 2] << 3) | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 + 96 + (i3 << 2) >> 2] = i1 + (i3 << 3);
 HEAP32[i1 + 144 + (HEAP32[i4 >> 2] << 2) >> 2] = 9;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i3 + 64 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i3 + 24 | 0;
 HEAP32[i3 + 60 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 40 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP8[i1 >> 0] = 1;
 HEAP32[i2 >> 2] = i3 + 44;
 HEAP32[i3 + 28 >> 2] = 1;
 i3 = 1;
 return i3 | 0;
}

function __ZN16PxOverflowBufferIN5physx10PxSweepHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i3 + 128 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = i3 + 56 | 0;
 HEAP32[i3 + 124 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 72 >> 2] = HEAP32[i3 + 64 >> 2];
 HEAP8[i1 >> 0] = 1;
 HEAP32[i2 >> 2] = i3 + 76;
 HEAP32[i3 + 60 >> 2] = 1;
 i3 = 1;
 return i3 | 0;
}

function __ZN14RenderSettings22SetAmbientEquatorColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 48 >> 2] = i5;
 HEAP32[i1 + 52 >> 2] = i4;
 HEAP32[i1 + 56 >> 2] = i3;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN12_GLOBAL__N_112PropDescImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148768 + 8;
 HEAP32[i1 + 52 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 64 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __Z62AnimatorControllerPlayable_CUSTOM_CrossFadeInFixedTimeInternalR9HPlayableifif(i1, i2, f3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4, i2, f5, f3, Math_fround(0.0));
 return;
}

function __Z58RenderTexture_CUSTOM_INTERNAL_CALL_GetNativeDepthBufferPtrP12Il2CppObjectRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i2 >> 2] = __ZN13RenderTexture23GetNativeDepthBufferPtrEv(i3) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Animator_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK8Animator28GetRuntimeAnimatorControllerEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47TerrainData_CUSTOM_Internal_SetDetailResolutionP12Il2CppObjectii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN14DetailDatabase19SetDetailResolutionEii(i4 + 128 | 0, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing2LimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint14SetSwing2LimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing1LimitP12Il2CppObjectRK14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint14SetSwing1LimitERK14SoftJointLimit(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Rigidbody2D_Set_Custom_PropInterpolationP12Il2CppObjectN11Rigidbody2D13InterpolationE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D16SetInterpolationENS_13InterpolationE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28ParticleEmitter_CUSTOM_Emit2P12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ParticleEmitter15ResetEmitterPosEv(i3);
   __ZN15ParticleEmitter4EmitEjf(i3, i2, Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21setPxCloth_ClothFlagsPN5physx7PxClothENS_7PxFlagsINS_11PxClothFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z15CalcPixelMatrixRK5RectTIfER10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(f5 + Math_fround(HEAPF32[i1 + 8 >> 2]));
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 __ZN10Matrix4x4f8SetOrthoEffffff(i2, f5, f4, f3, Math_fround(f3 + Math_fround(HEAPF32[i1 + 12 >> 2])), Math_fround(-1.0), Math_fround(100.0)) | 0;
 return;
}

function _UNITY_png_get_sCAL_s(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i5 = 0;
  return i5 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 16384)) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = HEAPU8[i2 + 232 >> 0];
 HEAP32[i4 >> 2] = HEAP32[i2 + 236 >> 2];
 HEAP32[i5 >> 2] = HEAP32[i2 + 240 >> 2];
 i5 = 16384;
 return i5 | 0;
}

function _readlinkat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = ___syscall_ret(___syscall305(305, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _ft_raster1_transform(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) {
  i4 = 6;
  return i4 | 0;
 }
 if (i3 | 0) _UNITY_FT_Outline_Transform(i2 + 108 | 0, i3);
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 _UNITY_FT_Outline_Translate(i2 + 108 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
 i4 = 0;
 return i4 | 0;
}

function _ft_black_new(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 HEAP32[i2 >> 2] = 0;
 i3 = _UNITY_ft_mem_alloc(i1, 4, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = i3;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 <= i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i4 << 2) | 0;
}

function __ZNK5physx3Cct15ObstacleContext11getObstacleEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (i1 >>> 0 > i2 >>> 0) {
  i3 = (HEAP32[i3 + 4 >> 2] | 0) + (i2 * 72 | 0) + 8 | 0;
  return i3 | 0;
 }
 i1 = i2 - i1 | 0;
 if (i1 >>> 0 >= (HEAP32[i3 + 20 >> 2] | 0) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[i3 + 16 >> 2] | 0) + (i1 << 6) + 8 | 0;
 return i3 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17getStaticFrictionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 8192)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore17getStaticFrictionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 56 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE28getMassSpaceInvInertiaTensorEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 2)) i1 = __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i1 + 64 | 0) | 0; else i1 = (HEAP32[i1 + 56 >> 2] | 0) + 96 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZNK5Umbra4Tome9getBoundsERNS_7Vector3ES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 i2 = i1 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZNK20LocalFileSystemPosix12LastModifiedERK13FileEntryData(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 __ZN8DateTimeC2Ev(i3);
 if (_stat(i4, i1) | 0) {
  STACKTOP = i2;
  return;
 }
 __Z19UnixTimeToUnityTimelR8DateTime(HEAP32[i1 + 56 >> 2] | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN8Animator19SetLookAtHeadWeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 60 >> 2] = f2;
 return;
}

function __ZN8Animator19SetLookAtEyesWeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 64 >> 2] = f2;
 return;
}

function __ZN8Animator19SetLookAtBodyWeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i3 = (HEAP32[i1 + 124 >> 2] | 0) + 20 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i4 = i3 + i4 + 40 | 0;
 if (!(HEAP32[(HEAP32[i4 >> 2] | 0) + i4 >> 2] | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 + 132 >> 2] | 0) + 24 >> 2] | 0) + 56 >> 2] = f2;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 16 | 0;
  }
 }
 return;
}

function __ZN5physx19PxcPCMContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu16pcmContactBoxBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5Umbra20ObjectDistanceParamsC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZN5Image13ReformatImageEii13TextureFormatN14ImageReference8BlitModeE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i1 + 8 >> 2] | 0) == (i3 | 0)) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 __ZN5Image13ReformatImageERK14ImageReferenceii13TextureFormatNS0_8BlitModeE(i1, i1, i2, i3, i4, i5);
 return;
}

function __ZN5Flare23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 44 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN21ExecutionOrderManager49SortBehaviourByExecutionOrderAndReverseInstanceIDEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[gb + 1163032 >> 2] | 0;
 i4 = __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi(i3, i1) | 0;
 i3 = __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi(i3, i2) | 0;
 return ((i4 | 0) == (i3 | 0) ? (i1 | 0) > (i2 | 0) : (i4 | 0) < (i3 | 0)) | 0;
}

function __ZN15TextureTFMethod13MapBoneBufferEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 + 36 >> 2] = (i2 >>> 0) / 12 | 0;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = (HEAP32[i1 + 12 >> 2] | 0) - i4 >> 2;
 if (i1 >>> 0 < i2 >>> 0) {
  __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEj(i3, i2 - i1 | 0);
  i4 = HEAP32[i3 >> 2] | 0;
  return i4 | 0;
 } else return i4 | 0;
 return 0;
}

function __ZN15FileSystemEntry10AtomicMoveERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 1040 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i2 + 1040 >> 2] | 0)) if ((HEAP32[i1 + 1044 >> 2] | 0) == (HEAP32[i2 + 1044 >> 2] | 0)) {
  i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0) | 0;
  return i3 | 0;
 }
 HEAP32[i1 + 1056 >> 2] = 10;
 i3 = 0;
 return i3 | 0;
}

function __ZN15CapsuleColliderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14SphereCollider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 36 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  __ZN14SphereCollider9SetRadiusEf(i1, Math_fround(HEAPF32[i1 + 60 >> 2]));
  if (HEAP32[i3 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 }
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN14RenderSettings21SetAmbientGroundColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 60 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 64 >> 2] = i5;
 HEAP32[i1 + 68 >> 2] = i4;
 HEAP32[i1 + 72 >> 2] = i3;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN12FileAccessor5WriteEyyPKvPy(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0;
 i8 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 20 >> 2] | 0, i8 | 0, i1 + 4 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return i8 | 0;
}

function __ZN11BoxCollider5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 i1 = i1 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 62512 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 62512 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 62512 + 8 >> 2];
 return;
}

function __ZL22InitializeModule_Audiov() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63328 | 0, 16, gb + 873991 | 0, gb + 1576256 | 0, gb + 874012 | 0, 233) | 0;
 HEAP32[i1 >> 2] = gb + 175940 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIAudioP6IAudio(i1);
 HEAP32[gb + 1115296 + 136 >> 2] = fb + 287;
 HEAP32[gb + 1115296 + 264 >> 2] = fb + 288;
 HEAP32[gb + 1115296 + 308 >> 2] = fb + 289;
 return;
}

function __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1 + 4 | 0, i2);
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __Z39DirectorPlayer_CUSTOM_SetTimeUpdateModeP12Il2CppObject18DirectorUpdateMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 148 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_CUSTOM_SetSpatializerFloatP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return (__ZN11AudioSource19SetSpatializerFloatEif(i4, i2, f3) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33CanvasRenderer_CUSTOM_GetMaterialP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN2UI14CanvasRenderer11GetMaterialEi(i3, i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Light_Set_Custom_PropShadowBiasP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   HEAPF32[(HEAP32[i3 + 44 >> 2] | 0) + 112 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Animation_CUSTOM_GetStateCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Animation20BuildAnimationStatesEv(i2);
   return (HEAP32[i2 + 108 >> 2] | 0) - (HEAP32[i2 + 104 >> 2] | 0) >> 2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29RectOffset_Set_Custom_PropTopP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 8 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z21setPxActor_ActorFlagsPN5physx7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0;
 HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function __Z10dictSearchP4DictPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0, i5 = 0;
 i4 = i1 + 20 | 0;
 i5 = i1 + 12 | 0;
 i2 = i1;
 while (1) {
  i2 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) {
   i1 = 4;
   break;
  }
  if (mftCall_iiii(HEAP32[i4 >> 2] | 0, HEAP32[i5 >> 2] | 0, i3 | 0, i1 | 0) | 0) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return i2 | 0;
 return 0;
}

function _UNITY_tt_face_load_cmap(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 504 | 0;
 i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1668112752, i2 | 0, i4 | 0) | 0;
 if (i3 | 0) {
  i4 = i3;
  return i4 | 0;
 }
 i1 = _UNITY_FT_Stream_ExtractFrame(i2, HEAP32[i4 >> 2] | 0, i1 + 500 | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = 0;
 i4 = i1;
 return i4 | 0;
}

function _utimensat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = ___syscall_ret(___syscall320(320, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _tt_cmap6_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = i2 - ((HEAPU8[i3 + 6 >> 0] | 0) << 8 | (HEAPU8[i3 + 7 >> 0] | 0)) | 0;
 if (i1 >>> 0 >= ((HEAPU8[i3 + 8 >> 0] | 0) << 8 | (HEAPU8[i3 + 9 >> 0] | 0)) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = i3 + 10 + (i1 << 1) | 0;
 i3 = (HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i3 + 1 >> 0] | 0);
 return i3 | 0;
}

function _hstrerror(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -1 | 0;
 L1 : do if (!i2) i1 = gb + 1074152 | 0; else {
  i1 = gb + 1074152 | 0;
  do {
   if (!(HEAP8[i1 >> 0] | 0)) break L1;
   i1 = i1 + 1 | 0;
   do {
    i3 = i1;
    i1 = i1 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) != 0);
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 return (HEAP8[i1 >> 0] | 0 ? i1 : i1 + 1 | 0) | 0;
}

function _ft_smooth_transform(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) {
  i4 = 6;
  return i4 | 0;
 }
 if (i3 | 0) _UNITY_FT_Outline_Transform(i2 + 108 | 0, i3);
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 _UNITY_FT_Outline_Translate(i2 + 108 | 0, HEAP32[i4 >> 2] | 0, HEAP32[i4 + 4 >> 2] | 0);
 i4 = 0;
 return i4 | 0;
}

function __ZThn4_N12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj(i5, i1, i4, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj(i5 + -4 | 0, i1, i4, i2, i3) | 0;
}

function __ZNSt3__221__throw_runtime_errorEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = ___cxa_allocate_exception(8) | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4505 | 0, i2 | 0, i1 | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___cxa_free_exception(i2 | 0);
  ___resumeException(i1 | 0);
 } else ___cxa_throw(i2 | 0, gb + 13128 | 0, fb + 3224 | 0);
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZN9Scripting26GetMethodWithSearchOptionsEPKcS1_S1_S1_N24ScriptingMethodFiltering18MethodSearchFilterE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i1, __Z29scripting_class_from_fullnamePKcS0_S0_(i2, i3, i4) | 0, i5, i6);
 return;
}

function __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 12 | 0;
  }
 }
 return;
}

function __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf14TexFormatRHalfEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP16[i4 >> 1] = HEAP16[i1 >> 1] | 0;
  if (!i2) break; else {
   i4 = i4 + 2 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6Camera23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 744 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 150768 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148628 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Sc11Interaction7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i2 >> 2] | 0, i1);
 __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE(HEAP32[i1 + 8 >> 2] | 0, i1);
 __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i1);
 return;
}

function __ZN5Umbra9BitVector6andNotERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & ~HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra14MemInputStream4readEPvj(i3, i5, i2) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0, i6 = 0;
 i6 = i3 + 8 | 0;
 i1 = HEAP32[i6 >> 2] | 0;
 i4 = i1 >>> 0 >= i2 >>> 0 ? i2 : i1;
 i2 = i3 + 4 | 0;
 if (i5) {
  _memcpy(i5 | 0, HEAP32[i2 >> 2] | 0, i4 | 0) | 0;
  i1 = HEAP32[i6 >> 2] | 0;
 }
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i4;
 HEAP32[i6 >> 2] = i1 - i4;
 return i4 | 0;
}

function __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags(i2, i1 + 32 | 0, 0);
 return;
}

function __ZN23AnimationOffsetPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 40 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 946403 | 0, i1, 0);
 __ZN20TextRenderingPrivate7GUIText8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 344 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 344 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14SphereColliderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11SoundHandleC2EPNS_8InstanceE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 if (!i1) return;
 i1 = HEAP32[i1 + 120 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 }
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z54SkinnedMeshRenderer_Set_Custom_PropUpdateWhenOffscreenP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19SkinnedMeshRenderer22SetUpdateWhenOffscreenEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetTargetVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetPositionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetTargetPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51CharacterController_CUSTOM_INTERNAL_CALL_SimpleMoveP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN19CharacterController10SimpleMoveERK8Vector3f(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48Renderer_Set_Custom_PropStaticBatchRootTransformP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 308 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1 + 4 | 0, i2);
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __Z45SystemInfo_CUSTOM_SupportsRenderTextureFormat19RenderTextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (i1 >>> 0 > 22) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 497711 | 0, i2); else {
  i1 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 233 + i1 >> 0] | 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 return 0;
}

function __Z45LineRenderer_CUSTOM_INTERNAL_CALL_SetPositionP12Il2CppObjectiRK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN12LineRenderer11SetPositionEiRK8Vector3f(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40UnityWebRequest_CUSTOM_InternalGetMethodP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 88 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1029776 | 0, i2);
 return 0;
}

function __Z40CommandBuffer_Get_Custom_PropSizeInBytesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 24 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z31SparseTexture_CUSTOM_UnloadTileP12Il2CppObjectiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i1) i1 = 0; else {
  i5 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i5) {
   __ZN13SparseTexture10UploadTileEiiiPKhj(i5, i2, i3, i4, 0, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27Event_Set_Custom_PropButtonP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 + 20 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z12SetupSteppedPfRK11KeyframeTplIfES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(Math_fround(HEAPF32[i2 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i3 + 8 >> 2]) == Math_fround(inf))) return;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function _renameat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = ___syscall_ret(___syscall302(302, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getParticleMassEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 1024)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 44 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZNK26AnimatorControllerPlayable21GetStateMachineMemoryEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 100 >> 2] | 0) + 4 | 0;
 i1 = (HEAP32[i1 + 92 >> 2] | 0) + 4 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 + (i2 << 2) | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + i3 + (HEAP32[i1 + (HEAP32[i1 >> 2] | 0) >> 2] << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return ((i2 | 0) == 0 ? 0 : i1 + i2 | 0) | 0;
}

function __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 80 | 0, 0);
 __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 100 | 0, i2);
 return;
}

function __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 80 | 0, 0);
 __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 100 | 0, i2);
 return;
}

function __ZN7mecanim12statemachine24CreateStateMachineOutputEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, 20, 4) | 0;
 HEAP8[i3 >> 0] = 0;
 HEAP32[i3 + 4 >> 2] = 128;
 HEAP32[i3 + 8 >> 2] = 128;
 HEAP8[i3 + 16 >> 0] = 0;
 HEAP8[i3 + 17 >> 0] = 0;
 HEAP8[i3 + 18 >> 0] = 0;
 return i3 | 0;
}

function __ZN6Skybox23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPNS_26PxProfileEventBufferClientEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150548 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPNS0_4comm20PvdConnectionHandlerEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150800 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext14SphericalJointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 88796 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88796 + 200;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext14PrismaticJointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 88228 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88228 + 216;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc9ClothCore15setTetherConfigERKNS_19PxClothTetherConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = i2 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i3 >> 2] | 0) + 244 >> 2] | 0, i3 | 0, +Math_fround(HEAPF32[i1 + 4 >> 2]));
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 252 >> 2] | 0, i2 | 0, +Math_fround(HEAPF32[i1 >> 2]));
 return;
}

function __ZN5physx2Sc15CoreInteraction11updateStateEb(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i4 + 6 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if (!(i1 & 2)) {
  i4 = i4 + 4 | 0;
  HEAP16[i4 >> 1] = 0;
  return;
 }
 if (i2) {
  __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i4);
  i1 = HEAP16[i3 >> 1] | 0;
 }
 HEAP16[i3 >> 1] = i1 & 65533;
 i4 = i4 + 4 | 0;
 HEAP16[i4 >> 1] = 0;
 return;
}

function __ZN5Umbra9BitVector5orNotERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | ~HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra4Tome13updateVersionEPKS0_PNS_9AllocatorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 do if (!i2) i1 = 1; else {
  i3 = HEAP32[i2 >> 2] | 0;
  i1 = i3 & 65535;
  if ((i3 & -65536 | 0) != -704643072) {
   i1 = (i1 | 0) == 214 ? 5 : 2;
   break;
  }
  if ((i1 | 0) == 18) i1 = (i2 & 15 | 0) == 0 ? 0 : 6; else i1 = i1 >>> 0 > 18 ? 4 : 3;
 } while (0);
 return ((i1 | 0) == 3 ? 0 : i2) | 0;
}

function __ZN22AnimationMixerPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 36 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN20UnityConnectSettings5ResetEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP8[i2 + 196 >> 0] = 0;
 HEAP8[i2 + 197 >> 0] = 0;
 i1 = HEAP32[i2 + 164 >> 2] | 0;
 i2 = i2 + 168 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN17BaseWebCamTextureD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26152 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 108 | 0);
 HEAP32[i1 >> 2] = gb + 175688 + 8;
 __ZN16BaseVideoTexture15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13WheelColliderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12FileAccessor4ReadEyyPvPy(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 var i8 = 0;
 i8 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i8) {
  i8 = 0;
  return i8 | 0;
 }
 i8 = mftCall_iiiiiiiii(HEAP32[(HEAP32[i8 >> 2] | 0) + 12 >> 2] | 0, i8 | 0, i1 + 4 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return i8 | 0;
}

function __Z55Terrain_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain13SetLightmapSTERK8Vector4f12LightmapType(i3, i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53NavMeshAgent_CUSTOM_GetCurrentOffMeshLinkDataInternalP12Il2CppObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK12NavMeshAgent25GetCurrentOffMeshLinkDataEP15OffMeshLinkData(i3, i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorRotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody24SetInertiaTensorRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46SkinnedMeshRenderer_CUSTOM_GetBlendShapeWeightP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK19SkinnedMeshRenderer19GetBlendShapeWeightEj(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42PointEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D14SetForceTargetE19EffectorSelection2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42PointEffector2D_Set_Custom_PropForceSourceP12Il2CppObject19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D14SetForceSourceE19EffectorSelection2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39SystemInfo_CUSTOM_SupportsTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 + -1 | 0) >>> 0 > 60) __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 497789 | 0, i2); else {
  i1 = HEAP8[(__Z15GetGraphicsCapsv() | 0) + 171 + i1 >> 0] | 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 return 0;
}

function __Z39AnimationState_Get_Custom_PropBlendModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 72 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z24SetMeshIndicesFromScriptR4Meshi16GfxPrimitiveTypeP11Il2CppArrayib(i2, i1, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i1 | 0) == -1) {
  __ZN4Mesh15SetSubMeshCountEjb(i2, 1, 1);
  i1 = 0;
 }
 __ZN4Mesh10SetIndicesEPKjjj16GfxPrimitiveTypeb(i2, __Z27scripting_array_element_ptrP11Il2CppArrayij(i4, 0, 4) | 0, i5, i1, i3, i6) | 0;
 return;
}

function __Z21InitializeAudioModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63328 | 0, 16, gb + 873991 | 0, gb + 1576256 | 0, gb + 874012 | 0, 233) | 0;
 HEAP32[i1 >> 2] = gb + 175940 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIAudioP6IAudio(i1);
 HEAP32[gb + 1115296 + 136 >> 2] = fb + 287;
 HEAP32[gb + 1115296 + 264 >> 2] = fb + 288;
 HEAP32[gb + 1115296 + 308 >> 2] = fb + 289;
 return;
}

function mftCall_iiidiiii(i8, i1, i2, d3, i4, i5, i6, i7) {
 i8 = i8 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if ((i8 | 0) >= (fb | 0) & (i8 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiidiiii[i8 - fb & 1](i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
 return ftCall_iiidiiii(i8 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, i6 | 0, i7 | 0) | 0;
}

function _mknodat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = ___syscall_ret(___syscall297(297, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _fstatat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i1;
 HEAP32[i6 + 4 >> 2] = i2;
 HEAP32[i6 + 8 >> 2] = i3;
 HEAP32[i6 + 12 >> 2] = i4;
 i4 = ___syscall_ret(___syscall300(300, i6 | 0) | 0) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZNSt3__28ios_base16__call_callbacksENS0_5eventE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0, i6 = 0;
 i4 = i2 + 32 | 0;
 i5 = i2 + 36 | 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 while (1) {
  if (!i1) break;
  i6 = i1 + -1 | 0;
  mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + (i6 << 2) >> 2] | 0, i3 | 0, i2 | 0, HEAP32[(HEAP32[i5 >> 2] | 0) + (i6 << 2) >> 2] | 0);
  i1 = i6;
 }
 return;
}

function __ZNSt3__211timed_mutex6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 invoke_vi(fb + 4006 | 0, i1 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else {
  HEAP8[i1 + 76 >> 0] = 0;
  __ZNSt3__218condition_variable10notify_oneEv(i1 + 28 | 0);
  __ZNSt3__25mutex6unlockEv(i1);
  return;
 }
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZNK5physx13NpVolumeCache7isValidEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (HEAP8[i2 + 116 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i2 + 117 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 if ((HEAP32[i1 + 20 >> 2] | 0) != (HEAP32[i2 + 108 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 24 >> 2] | 0) == (HEAP32[i2 + 112 >> 2] | 0);
 return i2 | 0;
}

function __ZN9Texture2D15UpdatePOTStatusEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (i2 + -1 & i2 | 0) {
  i3 = 0;
  i2 = i1 + 108 | 0;
  HEAP8[i2 >> 0] = i3;
  return;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 i2 = (i2 + -1 & i2 | 0) == 0 & 1;
 i3 = i1 + 108 | 0;
 HEAP8[i3 >> 0] = i2;
 return;
}

function __ZN8JobQueue17CreateJobsForEachEPFvPvjES0_jPFvS0_E10JobGroupIDP8JobGroup(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i7 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63456 | 0, 16, gb + 441822 | 0, 42) | 0;
 HEAP32[i7 >> 2] = i2;
 HEAP32[i7 + 4 >> 2] = i3;
 HEAP32[i7 + 8 >> 2] = i4;
 HEAP32[i7 + 12 >> 2] = i5;
 return i7 | 0;
}

function __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math7affineXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_i(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 + 4 | 0;
 i3 = i3 + 4 | 0;
 __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i(i1, (HEAP32[i2 >> 2] | 0) + i2 + (i4 * 40 | 0) + 12 | 0, (HEAP32[i3 >> 2] | 0) + i3 + (i4 * 40 | 0) + 12 | 0, i4);
 return;
}

function __ZN7mecanim12statemachine28DestroySelectorStateConstantEPNS0_21SelectorStateConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7Joint2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i3 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i3 >> 2]);
 i4 = f2 < Math_fround(0.0);
 HEAPF32[i3 >> 2] = i4 ? Math_fround(0.0) : f2;
 i1 = i1 + 48 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRFloatEEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 8 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_113ClassDescImplEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148644 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext13RevoluteJointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 88500 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 88500 + 240;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext13DistanceJointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87668 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87668 + 228;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN22UnityProfilerPerThread10ClearFrameEv(i1) {
 i1 = i1 | 0;
 __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj(i1 + 4 | 0, 0);
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 156 >> 0] = 0;
 HEAP8[i1 + 157 >> 0] = 0;
 return;
}

function __ZN21AnimationClipPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 28 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN20TextRenderingPrivate13GetLoadTargetEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 3:
 case 0:
  {
   i1 = 2;
   break;
  }
 case 1:
  {
   i1 = 0;
   break;
  }
 case 2:
  {
   i1 = 131072;
   break;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 945354 | 0, 0, gb + 945383 | 0, 672, 1, 0, 0, 0);
   i1 = 2;
  }
 }
 return i1 | 0;
}

function __ZN19VREyeTextureManager22ReleaseEyeTextureStageERNS_12TextureStageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) i3 = 0; else {
  __Z19DestroySingleObjectP6Object(i1);
  HEAP32[i2 >> 2] = 0;
  i3 = 1;
 }
 i1 = i2 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return i3 | 0;
 __Z19DestroySingleObjectP6Object(i2);
 HEAP32[i1 >> 2] = 0;
 i3 = 1;
 return i3 | 0;
}

function __ZN17PersistentManager25GetSerializedFileInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i1) | 0) >> 2] | 0;
 return i2 | 0;
}

function __ZN15DirectorManager11AcquireNodeEv() {
 var i1 = 0, i2 = 0;
 if (!(HEAP32[HEAP32[gb + 1188432 >> 2] >> 2] | 0)) {
  i2 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63784 | 0, 16, gb + 582681 | 0, 935) | 0;
  HEAP32[i2 + 16 >> 2] = 10;
  HEAP32[i2 + 20 >> 2] = 0;
  return i2 | 0;
 }
 i1 = HEAP32[gb + 1188432 >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 return i2 | 0;
}

function __ZN14RenderSettings18SetAmbientSkyColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 32 >> 2] = i5;
 HEAP32[i1 + 36 >> 2] = i4;
 HEAP32[i1 + 40 >> 2] = i3;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN12_GLOBAL__N_137BuggyBindElementArrayBufferWorkaround17BindBufferWrapperEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[gb + 1451084 >> 2] | 0, i1 | 0, i2 | 0);
 switch (i1 | 0) {
 case 34963:
  {
   mftCall_vii(HEAP32[gb + 1451084 >> 2] | 0, 34962, HEAP32[gb + 1451088 >> 2] | 0);
   return;
  }
 case 34962:
  {
   HEAP32[gb + 1451088 >> 2] = i2;
   return;
  }
 default:
  return;
 }
}

function __ZN11UnityEngine7Connect16PersistentValues13RestoreValuesER8JSONRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11UnityEngine7Connect20BasePersistentValues18TransferBaseValuesI8JSONReadEEvRT_(i1, i2);
 __ZN8JSONRead8TransferIyEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 64 | 0, gb + 1042308 | 0, 0, 0);
 __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb(i2, i1 + 72 | 0, gb + 1042326 | 0, 0, 0);
 return;
}

function __ZN11CullResults26DestroySharedRendererSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 1372 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10Collider2D10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour10DeactivateE19DeactivateOperation(i1, i2);
 __ZN10Collider2D7CleanupEb(i1, 0);
 __ZN16Physics2DManager25DestroyColliderCollisionsEP10Collider2D(__Z19GetPhysicsManager2Dv() | 0, i1);
 __ZN16Physics2DManager31DestroyColliderIgnoreCollisionsEP10Collider2D(__Z19GetPhysicsManager2Dv() | 0, i1);
 return;
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_secondaryAxisP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint16SetSecondaryAxisERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50WheelCollider_CUSTOM_INTERNAL_set_suspensionSpringP12Il2CppObjectRK11JointSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48WheelJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK12WheelJoint2D14GetMotorTorqueEf(i3, f2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48SliderJoint2D_CUSTOM_INTERNAL_CALL_GetMotorForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK13SliderJoint2D13GetMotorForceEf(i3, f2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48HingeJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK12HingeJoint2D14GetMotorTorqueEf(i3, f2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48ConfigurableJoint_CUSTOM_INTERNAL_set_slerpDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint13SetSlerpDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Gyroscope_CUSTOM_INTERNAL_CALL_gravity_InternaliR8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z10GetGravityi(i4, i1);
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i4 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i4 + 8 >> 2];
 STACKTOP = i3;
 return;
}

function __Z38ParticleEmitter_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AnimationState_Get_Custom_PropWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 68 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z37GUIStyle_Get_Custom_PropImagePositionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 256 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z30RectOffset_Set_Custom_PropLeftP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function __Z22scripting_array_new_2dP11Il2CppClassjjj(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i5 + 4 >> 2] = i4;
 i4 = _il2cpp_array_new_full(_il2cpp_array_class_get(i2 | 0, 2) | 0, i5 | 0, 0) | 0;
 STACKTOP = i1;
 return i4 | 0;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function _UNITY_png_get_pixel_aspect_ratio(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 if ((i2 | 0) != 0 & (i3 | 0) != 0) if (!(HEAP32[i3 + 8 >> 2] & 128)) f1 = Math_fround(0.0); else {
  i2 = HEAP32[i3 + 184 >> 2] | 0;
  if (!i2) f1 = Math_fround(0.0); else f1 = Math_fround(Math_fround((HEAP32[i3 + 188 >> 2] | 0) >>> 0) / Math_fround(i2 >>> 0));
 } else f1 = Math_fround(0.0);
 return Math_fround(f1);
}

function _UNITY_FT_Get_Renderer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 L1 : do if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 148 >> 2] | 0;
  if (!i1) i1 = 0; else {
   i2 = i1;
   while (1) {
    i1 = HEAP32[i2 + 8 >> 2] | 0;
    if ((HEAP32[i1 + 16 >> 2] | 0) == (i3 | 0)) break L1;
    i2 = HEAP32[i2 + 4 >> 2] | 0;
    if (!i2) {
     i1 = 0;
     break;
    }
   }
  }
 } while (0);
 return i1 | 0;
}

function _fdimf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var f3 = f0;
 if (((HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647) >>> 0 <= 2139095040) if (((HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 2147483647) >>> 0 > 2139095040) f1 = f2; else {
  f3 = Math_fround(f1 - f2);
  f1 = f1 > f2 ? f3 : Math_fround(0.0);
 }
 return Math_fround(f1);
}

function _cff_slot_init(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 656 >> 2] | 0) + 2952 >> 2] | 0;
 if (!i3) return 0;
 i1 = _UNITY_FT_Get_Module(HEAP32[(HEAP32[i1 + 96 >> 2] | 0) + 4 >> 2] | 0, gb + 1006904 | 0) | 0;
 if (!i1) return 0;
 i3 = mftCall_ii(HEAP32[i3 + 8 >> 2] | 0, i1 | 0) | 0;
 HEAP32[(HEAP32[i2 + 156 >> 2] | 0) + 36 >> 2] = i3;
 return 0;
}

function _cff_get_glyph_name(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[i1 + 656 >> 2] | 0;
 if (!(HEAP32[i1 + 2956 >> 2] | 0)) {
  i4 = 11;
  return i4 | 0;
 }
 i1 = _cff_index_get_sid_string(i1, HEAPU16[(HEAP32[i1 + 1160 >> 2] | 0) + (i2 << 1) >> 1] | 0) | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 _UNITY_ft_mem_strcpyn(i3, i1, i4) | 0;
 i4 = 0;
 return i4 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getRestitutionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 2048)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore14getRestitutionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getParticleMassEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 1024)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 44 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK13RendererScene23GetDynamicBoundingBoxesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 i1 = i1 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  i2 = i2 + (i1 * 24 | 0) | 0;
  return i2 | 0;
 }
 i3 = __Z9GetIUmbrav() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i2 = i2 + (i1 * 24 | 0) | 0;
 return i2 | 0;
}

function __ZN7Joint2D8ReCreateEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_112PropDescImplEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148320 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149584 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx21computeIsAccelAppliedEPKfPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i2 >> 0] = Math_fround(HEAPF32[i1 >> 2]) != Math_fround(0.0) & 1;
 HEAP8[i2 + 1 >> 0] = Math_fround(HEAPF32[i1 + 4 >> 2]) != Math_fround(0.0) & 1;
 HEAP8[i2 + 2 >> 0] = Math_fround(HEAPF32[i1 + 8 >> 2]) != Math_fround(0.0) & 1;
 HEAP8[i2 + 3 >> 0] = Math_fround(HEAPF32[i1 + 12 >> 2]) != Math_fround(0.0) & 1;
 return;
}

function __ZN5physx17PxcContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Gu14contactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE(i4, i5, i6, i7, i2, i3, i1) | 0;
}

function __ZN5physx17ConvexMeshBuilderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 110060 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110060 + 84;
 __ZN5physx17ConvexHullBuilderD2Ev(i1 + 132 | 0);
 __ZN5physx2Gu10ConvexMeshD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra9BitVector4_xorERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] ^ HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN5Umbra9BitVector4_andERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] & HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN17TransformInternal27UpdateDeepChildCountUpwardsER18TransformHierarchyii(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if ((i1 | 0) == -1) return;
 i4 = HEAP32[i2 + 16 >> 2] | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 do {
  i5 = i4 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
  i1 = HEAP32[i2 + (i1 << 2) >> 2] | 0;
 } while ((i1 | 0) != -1);
 return;
}

function __ZN13AvatarBuilder12GetAllParentER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN13AvatarBuilder12GetAllParentER9TransformS1_RNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb(__ZN9Transform7GetRootEv(i1) | 0, i1, i2, i3, i4);
 return;
}

function __ZN12LightsModule9FreeCacheER19ParticleSystemState(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 452 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, i2 + 8 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11JpegDecoder7CleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  _jpeg_destroy_decompress(i1);
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 }
 i1 = i2 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i3 >> 2] = 0;
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdlPv(i2);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z62ParticleSystemRenderer_CUSTOM_Internal_GetEnabledVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return HEAP32[i3 + 340 + 52 >> 2] & i2 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46getPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __Z44CharacterJoint_CUSTOM_INTERNAL_set_swingAxisP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AreaEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D14SetForceTargetE19EffectorSelection2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37GUIStyle_Get_Custom_PropStretchHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 293 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function _UnityRegisterRenderingPlugin(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = 0;
 HEAP32[i4 + 12 >> 2] = i1;
 HEAP32[i4 + 16 >> 2] = i2;
 __Z14RegisterPluginPvR20UnityPluginFunctions(0, i4);
 STACKTOP = i3;
 return;
}

function _UNITY_FT_Init_Class_cff_cmap_encoding_class_rec(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 20;
 HEAP32[i2 + 4 >> 2] = fb + 1090;
 HEAP32[i2 + 8 >> 2] = fb + 3863;
 HEAP32[i2 + 12 >> 2] = fb + 1091;
 HEAP32[i2 + 16 >> 2] = fb + 1092;
 i2 = i2 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZNK18DownloadHandlerVFS11GetProgressEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 16 >> 2] | 0;
 i4 = HEAP32[i2 + 2148 >> 2] | 0;
 if (!(HEAP8[i2 + 8 >> 0] | 0)) if (!i4) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(i3 >>> 0) / Math_fround(i4 >>> 0));
  if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 } else f1 = Math_fround(1.0);
 return Math_fround(f1);
}

function __ZNK11Rigidbody2D20GetWorldCenterOfMassEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i2 + 68 >> 2] | 0) != 2) {
  i2 = HEAP32[i3 + 48 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 + 44 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN7mecanim9animation19GetVectorCurveValueERKN4math7_float3Ei(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 switch (i3 | 0) {
 case 0:
  {
   f1 = Math_fround(HEAPF32[i2 >> 2]);
   break;
  }
 case 1:
  {
   f1 = Math_fround(HEAPF32[i2 + 4 >> 2]);
   break;
  }
 case 2:
  {
   f1 = Math_fround(HEAPF32[i2 + 8 >> 2]);
   break;
  }
 default:
  f1 = Math_fround(0.0);
 }
 return Math_fround(f1);
}

function __ZN5physx6string9sprintf_sEPcjPKcz(i3, i1, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if ((i3 | 0) == 0 | (i4 | 0) == 0) {
  i5 = -1;
  STACKTOP = i2;
  return i5 | 0;
 }
 HEAP32[i1 >> 2] = i5;
 i5 = _vsprintf(i3, i4, i1) | 0;
 STACKTOP = i2;
 return i5 | 0;
}

function __ZN5physx19PxcGetMaterialShapeEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE(i2, i4, i1, i5) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 4480 >> 2] | 0;
 if (!i3) return 1;
 i1 = i2 + 34 | 0;
 i2 = 0;
 do {
  HEAP16[i5 + (i2 << 2) + (i4 << 1) >> 1] = HEAP16[i1 >> 1] | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i3 >>> 0);
 return 1;
}

function __ZN5Umbra9BitVector3_orERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 8 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i1 = 0;
 do {
  i5 = i2 + (i1 << 2) | 0;
  HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | HEAP32[i3 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i4 >> 2] | 0) >>> 0);
 return;
}

function __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 905605 | 0, i1, 0);
 __ZN26AnimatorOverrideController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15RenderNodeQueue9EraseNodeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i5 = i4 + (i2 * 360 | 0) | 0;
 i3 = i5 + 360 | 0;
 i2 = i1 + 12 | 0;
 _memmove(i5 | 0, i3 | 0, i4 + ((HEAP32[i2 >> 2] | 0) * 360 | 0) - i3 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i2 = i1 + 32804 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN11TimeManager27SetMaximumParticleDeltaTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAPF32[i4 >> 2] = f2;
 i5 = i1 + 48 | 0;
 i6 = Math_fround(HEAPF32[i5 >> 2]) > f2;
 HEAP32[i1 + 204 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __ZN10TagManager32GetSortingLayerUniqueIDFromValueEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (HEAP32[i3 + 1080 >> 2] | 0) + i1 | 0;
 if ((i1 | 0) < 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = HEAP32[i3 + 1068 >> 2] | 0;
 if ((i1 | 0) >= (((HEAP32[i3 + 1072 >> 2] | 0) - i2 | 0) / 40 | 0 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i2 + (i1 * 40 | 0) + 32 >> 2] | 0;
 return i3 | 0;
}

function __Z66Animator_Get_Custom_PropIsRootPositionOrRotationControlledByCurvesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator45IsRootTranslationOrRotationControllerByCurvesEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52DistanceJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15DistanceJoint2D24SetAutoConfigureDistanceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Animator_CUSTOM_SetIKHintPositionWeightInternalP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator21SetHintWeightPositionEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43WheelJoint2D_CUSTOM_INTERNAL_set_suspensionP12Il2CppObjectRK17JointSuspension2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12WheelJoint2D13SetSuspensionERK17JointSuspension2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_Set_Custom_PropInterpolationP12Il2CppObject22RigidbodyInterpolation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody16SetInterpolationE22RigidbodyInterpolation(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Joint_Set_Custom_PropEnableCollisionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUIStyle_Get_Custom_PropStretchWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 292 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z36AnimationCurve_Get_Custom_PropLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 68 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __GLOBAL__sub_I_runtime_jobs_lump_cpp() {
 __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(gb + 1162184 | 0, gb + 441662 | 0, 19, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162192 | 0, gb + 441680 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162204 | 0, gb + 441701 | 0, 0, 0);
 return;
}

function _UNITY_FT_Init_Class_cff_cmap_unicode_class_rec(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 24;
 HEAP32[i2 + 4 >> 2] = fb + 1093;
 HEAP32[i2 + 8 >> 2] = fb + 3864;
 HEAP32[i2 + 12 >> 2] = fb + 1094;
 HEAP32[i2 + 16 >> 2] = fb + 1095;
 i2 = i2 + 20 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZThn4_N12MemoryStream4readEPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i5 = i1 + -4 | 0;
 i1 = i5 + 12 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i5 + 20 >> 2] | 0;
 i3 = (i4 + i3 | 0) >>> 0 > i6 >>> 0 ? i6 - i4 | 0 : i3;
 _memcpy(i2 | 0, (HEAP32[i5 + 24 >> 2] | 0) + i4 | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i3;
 return i3 | 0;
}

function __ZNSt3__27codecvtIwc11__mbstate_tEC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212516 + 8;
 __THREW__ = 0;
 i1 = invoke_i(fb + 314 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i3 | 0);
 } else {
  HEAP32[i2 + 8 >> 2] = i1;
  return;
 }
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = HEAP8[i2 + 8 + 3 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
 }
 return i1 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getRestitutionEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 2048)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore14getRestitutionEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7getMassEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 if (!(HEAP32[i2 + 284 >> 2] & 1)) f1 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i2 + 64 | 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i2 + 56 >> 2] | 0) + 92 >> 2]);
 i2 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 return Math_fround(i2 ? f1 : Math_fround(0.0));
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZNK18ProceduralMaterial19GetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = Math_fround(HEAPF32[i1 + 68 >> 2]) > Math_fround(.5);
 return i2 | 0;
}

function __ZN8VRDevice19GetSinglePassStereoEv() {
 var i1 = 0;
 switch (HEAP32[(__Z17GetPlayerSettingsv() | 0) + 328 >> 2] | 0) {
 case 2:
  {
   i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 504 >> 0] | 0) != 0;
   i1 = i1 ? 2 : 0;
   return i1 | 0;
  }
 case 1:
  {
   i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 520 >> 2] | 0;
   return i1 | 0;
  }
 default:
  {
   i1 = 0;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = i3 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 if (i4 | 0) while (1) {
  if (HEAP32[i1 >> 2] | 0) continue;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = 1;
  if (!i4) break;
 }
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx3Ext10FixedJointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87952 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 87952 + 188;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx21PxsBodyTransformVaultC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4364 >> 2] = 0;
 HEAP8[i1 + 4356 >> 0] = 1;
 HEAP32[i1 + 4360 >> 2] = i1 + 4100;
 HEAP32[i1 + 4368 >> 2] = 64;
 HEAP32[i1 + 4372 >> 2] = 256;
 HEAP32[i1 + 4376 >> 2] = 0;
 HEAP32[i1 + 4380 >> 2] = 0;
 HEAP32[i1 + 4384 >> 2] = 10240;
 HEAP32[i1 + 4388 >> 2] = 0;
 HEAP32[i1 + 4392 >> 2] = 0;
 _memset(i1 | 0, 0, 4096) | 0;
 return;
}

function __ZN18JobBatchDispatcher8KickJobsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i2 + 12 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i1 = 0;
 do {
  __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo((HEAP32[i2 >> 2] | 0) + (i1 << 4) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (HEAP32[i3 >> 2] | 0));
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN13UnityProfiler26BeforeDomainUnloadCallbackEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 i3 = i1 + 56 | 0;
 i1 = i2;
 if ((i1 | 0) != (i3 | 0)) do {
  __ZN22UnityProfilerPerThread26BeforeDomainUnloadCallbackEv(HEAP32[i2 + 8 >> 2] | 0);
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __Z43Cloth_Set_Custom_PropUseContinuousCollisionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth25SetUseContinuousCollisionEb(i3, f2 != Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_GetMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1 + 4 | 0, i2);
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __Z40PointEffector2D_Set_Custom_PropForceModeP12Il2CppObject19EffectorForceMode2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D12SetForceModeE19EffectorForceMode2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35AnimationState_Get_Custom_PropLayerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 32 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z32Renderer_Get_Custom_PropMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Renderer32GetAndAssignInstantiatedMaterialEib(i2, 0, 0) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z16setPxShape_FlagsPN5physx7PxShapeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 mftCall_vii(i5 | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return;
}

function _wmemcmp(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 L1 : do if (!i1) i1 = 0; else {
  while (1) {
   i4 = HEAP32[i3 >> 2] | 0;
   i5 = HEAP32[i2 >> 2] | 0;
   if ((i4 | 0) != (i5 | 0)) break;
   i1 = i1 + -1 | 0;
   if (!i1) {
    i1 = 0;
    break L1;
   } else {
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   }
  }
  i1 = i4 - i5 | 0;
 } while (0);
 return i1 | 0;
}

function __ZZN2UI23InitializeCanvasManagerEvEN45PostLateUpdateUpdateCanvasRectTransformstruct7ForwardEv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN2UI6Canvas25UpdateCanvasRectTransformEb(HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZNK13RendererScene20GetDynamicSceneNodesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 i1 = i1 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  i2 = i2 + (i1 * 24 | 0) | 0;
  return i2 | 0;
 }
 i3 = __Z9GetIUmbrav() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i2 = i2 + (i1 * 24 | 0) | 0;
 return i2 | 0;
}

function __ZNK11Rigidbody2D10GetInertiaEv(i2) {
 i2 = i2 | 0;
 var f1 = f0, i3 = 0;
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 do if (!i3) f1 = Math_fround(0.0); else if ((HEAP32[i2 + 68 >> 2] | 0) == 2) f1 = Math_fround(0.0); else if (!(HEAP8[i2 + 77 >> 0] | 0)) {
  f1 = Math_fround(HEAPF32[i3 + 124 >> 2]);
  break;
 } else {
  f1 = Math_fround(HEAPF32[i2 + 88 >> 2]);
  break;
 } while (0);
 return Math_fround(f1);
}

function __ZN9Animation17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN9Animation22ReleaseOwnedAnimationsEv(i1);
  return;
 }
 i4 = i1 + 260 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN9Animation22ReleaseOwnedAnimationsEv(i1);
 return;
}

function __ZN5physx9NpPhysics7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = (HEAP32[gb + 1457336 >> 2] | 0) + -1 | 0;
 HEAP32[gb + 1457336 >> 2] = i1;
 if (i1 | 0) return;
 __ZN5physx9NpFactory15destroyInstanceEv();
 i1 = HEAP32[gb + 1457324 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457324 >> 2] = 0;
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 return;
}

function __ZN5physx5cloth9SwFactoryD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 167292 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 167292 + 88;
 i1 = i2 + 12 | 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i2);
 return;
}

function __ZN5physx5cloth9SwFactoryD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 167292 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 167292 + 88;
 i1 = i2 + 12 | 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if ((i3 | 0) > -1 & (i3 & 2147483647 | 0) != 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i1 >> 2] | 0);
 HEAP32[i2 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i2);
 return;
}

function __ZN5physx33PxVehicleGearsDataGeneratedValuesC2EPKNS_18PxVehicleGearsDataE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i3 + 128 >> 2] = HEAP32[i2 + 128 >> 2];
 HEAP32[i3 + 132 >> 2] = HEAP32[i2 + 132 >> 2];
 HEAP32[i3 + 136 >> 2] = HEAP32[i2 + 136 >> 2];
 i1 = 0;
 do {
  HEAP32[i3 + (i1 << 2) >> 2] = HEAP32[i2 + (i1 << 2) >> 2];
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 32);
 return;
}

function __Z51Rigidbody2D_Set_Custom_PropUseFullKinematicContactsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D27SetUseFullKinematicContactsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51PlatformEffector2D_Set_Custom_PropUseOneWayGroupingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D20SetUseOneWayGroupingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51NavMeshAgent_Set_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent26SetAutoTraverseOffMeshLinkEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51CharacterController_Set_Custom_PropDetectCollisionsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController19SetDetectCollisionsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48NavMeshAgent_CUSTOM_INTERNAL_CALL_SetDestinationP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN12NavMeshAgent14SetDestinationERK8Vector3f(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43RectTransform_Get_Custom_PropDrivenByObjectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK2UI13RectTransform17GetDrivenByObjectEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Collider2D_Get_Custom_PropAttachedRigidbodyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK10Collider2D20GetAttachedRigidbodyEb(i2, 1) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_GetFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1 + 4 | 0, i2);
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 HEAP32[i4 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __Z41Joint_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody2D_Set_Custom_PropConstraintsP12Il2CppObjectN11Rigidbody2D11ConstraintsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D14SetConstraintsENS_11ConstraintsE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Display_CUSTOM_GetRenderingBuffersImpl13Il2Cpp_IntPtrP21ScriptingRenderBufferS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __Z12GetGfxDevicev() | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 368 >> 2] | 0, i1 | 0) | 0;
 i2 = __Z12GetGfxDevicev() | 0;
 HEAP32[i3 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 372 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __Z38AudioSource_CUSTOM_GetSpatializerFloatP12Il2CppObjectiPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return (__ZN11AudioSource19GetSpatializerFloatEiPf(i4, i2, i3) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35ComputeBuffer_Get_Custom_PropStrideP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 4 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z34Camera_CUSTOM_RemoveCommandBuffersP12Il2CppObject21RenderCameraEventType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19RenderEventsContext20RemoveCommandBuffersEi(i3 + 1136 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33GUIStyle_Get_Custom_PropFontStyleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 288 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z33GUIStyle_Get_Custom_PropAlignmentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 244 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z30Caching_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 if ((__ZN14CachingManager21GetAuthorizationLevelEv(__Z17GetCachingManagerv() | 0) | 0) > 1) {
  __ZN14CachingManager10SetEnabledEb(__Z17GetCachingManagerv() | 0, i1 << 24 >> 24 != 0);
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 501819 | 0, 0, gb + 501721 | 0, 246, 1, 0, 0, 0);
  return;
 }
}

function __Z23profiler_cleanup_threadv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN13UnityProfiler23RemovePerThreadProfilerEP22UnityProfilerPerThread(HEAP32[gb + 1451e3 >> 2] | 0, i1);
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (i1 | 0) __ZN22UnityProfilerPerThreadD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
 HEAP32[gb + 1163228 >> 2] = 0;
 return;
}

function __Z16BytesToHexStringPKvjPc(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0, i6 = 0;
 if (!i3) return; else i1 = 0;
 do {
  i6 = HEAPU8[i2 + i1 >> 0] | 0;
  i5 = i1 << 1;
  HEAP8[i4 + i5 >> 0] = HEAP8[(i6 >>> 4) + (gb + 488429) >> 0] | 0;
  HEAP8[i4 + (i5 | 1) >> 0] = HEAP8[(i6 & 15) + (gb + 488429) >> 0] | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __Z14RectIntToRectfRK5RectTIiE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(HEAP32[i2 >> 2] | 0);
 f4 = Math_fround(HEAP32[i2 + 4 >> 2] | 0);
 f5 = Math_fround(HEAP32[i2 + 8 >> 2] | 0);
 f3 = Math_fround(HEAP32[i2 + 12 >> 2] | 0);
 HEAPF32[i1 >> 2] = f6;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 12 >> 2] = f3;
 return;
}

function _UNITY_png_set_shift(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = i1 + 212 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 8;
 i1 = i1 + 517 | 0;
 HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
 HEAP8[i1 + 1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
 HEAP8[i1 + 2 >> 0] = HEAP8[i2 + 2 >> 0] | 0;
 HEAP8[i1 + 3 >> 0] = HEAP8[i2 + 3 >> 0] | 0;
 HEAP8[i1 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 return;
}

function _gzdopen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = i5 + 4 | 0;
 if ((i1 | 0) < 0) {
  i4 = 0;
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 _snprintf(i3, 46, gb + 362546 | 0, i4) | 0;
 i4 = _gz_open(i3, i2, i1) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function ___muldsi3(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i6 = i1 & 65535;
 i5 = i2 & 65535;
 i3 = Math_imul(i5, i6) | 0;
 i4 = i1 >>> 16;
 i1 = (i3 >>> 16) + (Math_imul(i5, i4) | 0) | 0;
 i5 = i2 >>> 16;
 i2 = Math_imul(i5, i6) | 0;
 return (setTempRet0((i1 >>> 16) + (Math_imul(i5, i4) | 0) + (((i1 & 65535) + i2 | 0) >>> 16) | 0), i1 + i2 << 16 | i3 & 65535 | 0) | 0;
}

function __ZThn8_N12_GLOBAL__N_110Connection14onDeallocationEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + -8 | 0;
 if (!(HEAP8[i1 + 132 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 112 >> 2] & 4)) return;
 __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv(i1);
 i1 = HEAP32[(HEAP32[i1 + 120 >> 2] | 0) + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZN8ColliderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 >> 2] = gb + 110952 + 8;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 i3 = i2;
 if (i2 | 0) {
  i4 = i1 + 48 | 0;
  i5 = HEAP32[i4 >> 2] | 0;
  if ((i5 | 0) != (i2 | 0)) HEAP32[i4 >> 2] = i5 + (~((i5 + -4 - i3 | 0) >>> 2) << 2);
  __ZdlPv(i2);
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN7mecanim12statemachine19GetTransitionSourceE28TransitionInterruptionSourcej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if (!i2) i1 = 0; else switch (i1 | 0) {
 case 2:
 case 1:
 case 0:
  break L1;
 case 3:
  {
   i1 = (i2 | 0) == 1 ? 1 : 2;
   break L1;
  }
 case 4:
  {
   i1 = (i2 | 0) == 1 ? 2 : 1;
   break L1;
  }
 default:
  {
   i1 = 0;
   break L1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN5physx8debugger15ForwardingArrayINS0_20PropertyMessageEntryEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148896 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i2 + 4 >> 1] | 0) << 2) >> 2] | 0;
 if ((((HEAP32[i2 + (i1 + 4) >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + i1 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i2 | 0;
}

function __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148912 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj(HEAP32[i2 >> 2] | 0, i1, 0);
 __ZN5physx2Sc7Element21destroyLowLevelVolumeEv(i1) | 0;
 i2 = (HEAP32[(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) + 1184 >> 2] | 0) + 44 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN4crnd11crnd_assertEPKcS1_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4;
 i5 = i4 + 16 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP32[i6 + 8 >> 2] = i1;
 _sprintf(i5, gb + 401176 | 0, i6) | 0;
 _puts(i5) | 0;
 STACKTOP = i4;
 return;
}

function __ZN4FMOD8ChannelI11UpdatePitchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0, f4 = f0;
 i2 = HEAP32[i1 + 164 >> 2] | 0;
 if (HEAP8[i1 + 161 >> 0] | 0) {
  d3 = 1.0e-07;
  _JS_Sound_SetPitch(i2 | 0, +d3);
  return;
 }
 f4 = Math_fround(HEAPF32[i1 + 140 >> 2]);
 d3 = +Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i1 + 152 >> 2])) / Math_fround(44100.0));
 _JS_Sound_SetPitch(i2 | 0, +d3);
 return;
}

function __ZN20GpuProgramParameters14AddMatrixParamEPKcii15ShaderParamTypeiiiP16PropertyNamesSet(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet(i1, i2, i3, i4, i5, i6, i7, i8, 1, i9);
 return;
}

function __ZN20GlobalCachingManager15GetCacheIndicesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) return i2 | 0;
 i2 = __Znwj(12) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 __ZN20GlobalCachingManager16ReadCacheIndicesERNSt3__26vectorIP5CacheNS0_9allocatorIS3_EEEEb(0, i2, 1);
 i2 = HEAP32[i1 >> 2] | 0;
 return i2 | 0;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 i2 = i1 + 80 | 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i1 = f3 < Math_fround(0.0);
 i4 = f3 > Math_fround(1.0);
 f3 = i4 ? Math_fround(1.0) : f3;
 HEAPF32[i2 >> 2] = i1 ? Math_fround(0.0) : f3;
 return;
}

function __ZN14ParticleSystem17SystemWillRayCastERKS_(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  i1 = HEAP32[i2 + 904 >> 2] | 0;
  if (!i1) i1 = 0; else if (!(HEAP8[i1 + 4 >> 0] | 0)) i1 = 0; else if ((HEAP32[i1 + 136 >> 2] | 0) == 1) i1 = (HEAP32[i2 + 940 >> 2] | 0) > 0; else i1 = 0;
 } else i1 = 0;
 return i1 | 0;
}

function __ZN14BillboardAsset13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 40 | 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 __ZN25TransformFeedbackSkinning8SkinMeshERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb(i2, i3, i4, i5, i6, i7, i8, i9);
 return;
}

function __ZN10Collider2D8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i3);
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z63AnimatorControllerPlayable_CUSTOM_GetAnimatorControllerInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 84 >> 2] | 0) | 0;
  return i1 | 0;
 } else {
  i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(0) | 0;
  return i1 | 0;
 }
 return 0;
}

function __Z50NavMeshAgent_CUSTOM_GetNextOffMeshLinkDataInternalP12Il2CppObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK12NavMeshAgent22GetNextOffMeshLinkDataEP15OffMeshLinkData(i3, i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Joint2D_CUSTOM_INTERNAL_CALL_GetReactionTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK7Joint2D17GetReactionTorqueEf(i3, f2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Event_Get_Custom_PropDisplayIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 40 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z33Collider_Set_Custom_PropIsTriggerP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 128 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GUIStyle_Get_Custom_PropFontSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 284 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z32GUIStyle_Get_Custom_PropClippingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 252 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z29Cloth_CUSTOM_SetEnabledFadingP12Il2CppObjecthf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN5Unity5Cloth16SetEnabledFadingEbf(i4, i2 << 24 >> 24 != 0, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28TerrainData_CUSTOM_GetHeightP12Il2CppObjectii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return Math_fround(__ZNK9Heightmap9GetHeightEii(i4 + 248 | 0, i2, i3));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28Event_Get_Custom_PropKeyCodeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAPU16[i1 + 38 >> 1] | 0 | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z25Event_Set_Custom_PropTypeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 >> 2] = i2;
   STACKTOP = i4;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i3);
}

function _UNITY_png_data_freer(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 switch (i3 | 0) {
 case 1:
  {
   i3 = i2 + 220 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i4;
   return;
  }
 case 2:
  {
   i3 = i2 + 220 | 0;
   HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~i4;
   return;
  }
 default:
  _UNITY_png_error(i1, gb + 350363 | 0);
 }
}

function _putc_unlocked(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 if ((HEAP8[i2 + 75 >> 0] | 0) == (i1 | 0)) i5 = 4; else {
  i3 = i2 + 20 | 0;
  i4 = HEAP32[i3 >> 2] | 0;
  if (i4 >>> 0 < (HEAP32[i2 + 16 >> 2] | 0) >>> 0) {
   HEAP32[i3 >> 2] = i4 + 1;
   HEAP8[i4 >> 0] = i1;
   i1 = i1 & 255;
  } else i5 = 4;
 }
 if ((i5 | 0) == 4) i1 = ___overflow(i2, i1) | 0;
 return i1 | 0;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb1EED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 85436 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85436 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb0EED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 85388 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85388 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb1EED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 86012 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 86012 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb0EED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 84176 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 84176 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZNSt3__214__rotate_rightINS_11__wrap_iterIPwEEEET_S4_S4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i6 = i3 + -4 | 0;
 i5 = HEAP32[i6 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 i2 = i6 - i4 | 0;
 i6 = i2 >> 2;
 i1 = i3 + (0 - i6 << 2) | 0;
 if (!i6) i1 = i3; else _memmove(i1 | 0, i4 | 0, i2 | 0) | 0;
 HEAP32[i4 >> 2] = i5;
 return i1 | 0;
}

function __ZNSt3__212ctype_bynameIcED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 212824 + 8;
 __THREW__ = 0;
 invoke_vi(fb + 4002 | 0, HEAP32[i1 + 16 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__25ctypeIcED2Ev(i1);
  ___clang_call_terminate(i2);
 } else {
  __ZNSt3__25ctypeIcED2Ev(i1);
  return;
 }
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if ((i1 | 0) != (i2 | 0)) {
  i3 = HEAP8[i2 + 11 >> 0] | 0;
  i4 = i3 << 24 >> 24 < 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
 }
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 <= i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i4 | 0;
}

function __ZNK9ShaderLab11ShaderState25InsertUnsupportedVariantsEPKNS_7ProgramE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 184 >> 2] | 0;
 if (!i3) return;
 i4 = i1 + 700 | 0;
 i2 = HEAP32[i2 + 172 >> 2] | 0;
 __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_(i4, (HEAP32[i4 >> 2] | 0) + (HEAP32[i1 + 712 >> 2] << 5) | 0, i2, i2 + (i3 << 5) | 0) | 0;
 return;
}

function __ZNK5physx6PxVec4mlEf(i1, i3, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0, f6 = f0;
 f6 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 f5 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f2);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f2);
 __ZN5physx6PxVec4C2Effff(i1, f6, f5, f4, Math_fround(Math_fround(HEAPF32[i3 + 12 >> 2]) * f2));
 return;
}

function __ZN9ShaderLab33GenerateFastPropertyName28BitHashEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = _strlen(i1) | 0;
 i3 = i1 + i2 | 0;
 if ((i2 | 0) > 0) i2 = -1; else {
  i3 = 0;
  return i3 | 0;
 }
 do {
  i2 = HEAP32[gb + 1111240 + (((HEAPU8[i1 >> 0] | 0) ^ i2 & 255) << 2) >> 2] ^ i2 >>> 8;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 i3 = i2 & 268435455 ^ 268435455;
 return i3 | 0;
}

function __ZN7mecanim12statemachine25DestroyTransitionConstantEPNS0_18TransitionConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7mecanim12statemachine25DestroyStateMachineMemoryEPNS0_18StateMachineMemoryERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7Joint2D12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i3 | 0) <= 1) if (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -1 | 0) >>> 0 >= 4) {
  mftCall_vi(HEAP32[i1 + 560 >> 2] | 0, HEAP32[i4 >> 2] | 0);
  return;
 }
 mftCall_vii(HEAP32[i1 + 564 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN5physx15PxsParticleData13fixupPointersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 80 | 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = (i2 + 31 | 0) >>> 5;
 HEAP32[i1 + 56 >> 2] = i4;
 HEAP32[i1 + 60 >> 2] = i3 | -2147483648;
 i3 = (i3 << 2) + 15 & 1073741808;
 HEAP32[i1 + 48 >> 2] = i4 + i3;
 HEAP32[i1 + 52 >> 2] = HEAP8[i1 + 12 >> 0] | 0 ? i4 + (i3 + (i2 << 5)) | 0 : 0;
 return;
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 379149 | 0, i1, 0);
 __ZN24OcclusionCullingSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20QuadTreeNodeRenderer17SetLightmapParamsEtRK8Vector4f12LightmapType(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP16[i1 + 228 + (i4 << 1) >> 1] = i2;
 i4 = i1 + 196 + (i4 << 4) | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i4 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __ZN18AsyncUploadManager13GetAsyncFenceEP6Object(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3 | 0) if ((((HEAP32[i3 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 32032 + 24 >> 2] | 0) | 0) >>> 0 < (HEAP32[gb + 32032 + 28 >> 2] | 0) >>> 0) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i1 | 0, i3 | 0);
  return;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN14SafeBinaryReadD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 108 | 0;
 if ((HEAP32[i2 + 124 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 112 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 i1 = i2 + 88 | 0;
 if ((HEAP32[i2 + 104 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2 + 92 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13TriggerModule16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = i1 + 24 | 0;
 HEAPF32[i3 >> 2] = Math_fround(.00999999977);
 i4 = Math_fround(HEAPF32[i1 >> 2]) < Math_fround(.00999999977);
 HEAP32[i1 >> 2] = HEAP32[(i4 ? i3 : i1) >> 2];
 STACKTOP = i2;
 return;
}

function __ZN13GfxDeviceGLES16CreateDynamicVBOEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 694 >> 0] | 0) == 0;
 i2 = __Znwj(100) | 0;
 if (i3) {
  __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj(i2, i1, 1, 0, 0);
  return i2 | 0;
 } else {
  __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj(i2, i1, 2, 1048576, 65536);
  return i2 | 0;
 }
 return 0;
}

function __ZN13GfxDeviceGLES15SetStencilStateEPK18DeviceStencilStatei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 7080 | 0;
 i5 = i1 + 7180 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i2 | 0)) if ((HEAP32[i5 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i4 >> 2] = i2;
 __ZN7ApiGLES16BindStencilStateEPK15GfxStencilStatei(i1 + 4620 | 0, i2, i3);
 HEAP32[i5 >> 2] = i3;
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 244 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 | 0) return;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN12FileAccessorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 70828 + 8;
 if (HEAP8[i2 + 1064 >> 0] | 0) {
  i1 = HEAP32[i2 + 1048 >> 2] | 0;
  if (i1 | 0) mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 4 | 0) | 0;
 }
 i1 = HEAP32[i2 + 1044 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 return;
}

function __ZN11Rigidbody2D10SetInertiaEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 i4 = f2 < Math_fround(.0000999999974);
 i5 = f2 > Math_fround(1.0e6);
 f2 = i5 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 88 >> 2] = i4 ? Math_fround(.0000999999974) : f2;
 HEAP8[i1 + 77 >> 0] = 1;
 __ZN6b2Body13ResetMassDataEv(i3);
 return;
}

function __ZN11HaloManager4HaloC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 24 >> 0] = 0;
 HEAP8[i1 + 25 >> 0] = 0;
 HEAP8[i1 + 26 >> 0] = 0;
 HEAP8[i1 + 27 >> 0] = -1;
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = 1;
 return;
}

function __Z51ConfigurableJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint21SetProjectionDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50SpringJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SpringJoint2D24SetAutoConfigureDistanceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50RelativeJoint2D_Set_Custom_PropAutoConfigureOffsetP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15RelativeJoint2D22SetAutoConfigureOffsetEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50ParticleSystemRenderer_Get_Custom_PropSortingFudgeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z50NavMeshObstacle_Set_Custom_PropCarveOnlyStationaryP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle22SetCarveOnlyStationaryEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45Animation_Set_Custom_PropAnimateOnlyIfVisibleP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Animation14SetCullingTypeENS_11CullingTypeE(i3, i2 << 24 >> 24 != 0 & 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44TerrainData_Get_Custom_PropTreeInstanceCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 100 | 0;
   return ((HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 40 | 0 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Animator_CUSTOM_SetIKRotationWeightInternalP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator21SetGoalWeightRotationEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Animator_CUSTOM_SetIKPositionWeightInternalP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator21SetGoalWeightPositionEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42NavMeshAgent_Set_Custom_PropUpdatePositionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i3 = i3 + 107 | 0;
   HEAP8[i3 >> 0] = HEAP8[i3 >> 0] & -2 | i2 << 24 >> 24 != 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32RectOffset_Get_Custom_PropBottomP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 12 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z32GUIStyle_Get_Custom_PropWordWrapP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 248 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z32GUIStyle_Get_Custom_PropRichTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP8[i1 + 249 >> 0] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z32Behaviour_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function _UNITY_FT_GlyphLoader_New(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 i3 = _UNITY_ft_mem_alloc(i1, 96, i4) | 0;
 i4 = HEAP32[i4 >> 2] | 0;
 if (i4 | 0) {
  STACKTOP = i5;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i2 >> 2] = i3;
 STACKTOP = i5;
 return i4 | 0;
}

function _FMOD_System_Create(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Znwj(392) | 0;
 HEAP32[gb + 1459948 >> 2] = (HEAP32[gb + 1459948 >> 2] | 0) + 1;
 __ZN4FMOD7SystemIC2Ei(i3, 0);
 i2 = HEAP32[gb + 1459948 >> 2] | 0;
 HEAP32[gb + 1459872 + (i2 << 2) >> 2] = i3;
 HEAP32[i3 + 8 >> 2] = i2;
 i2 = HEAP32[i3 + 12 >> 2] & 65535 | i2 << 28;
 HEAP32[i3 + 20 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 return 0;
}

function _jcopy_sample_rows(i2, i3, i4, i5, i1, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i6 = i6 | 0;
 if ((i1 | 0) <= 0) return;
 i3 = i2 + (i3 << 2) | 0;
 i2 = i4 + (i5 << 2) | 0;
 while (1) {
  _memcpy(HEAP32[i2 >> 2] | 0, HEAP32[i3 >> 2] | 0, i6 | 0) | 0;
  if ((i1 | 0) > 1) {
   i3 = i3 + 4 | 0;
   i2 = i2 + 4 | 0;
   i1 = i1 + -1 | 0;
  } else break;
 }
 return;
}

function __ZZN2UI23InitializeCanvasManagerEvEN42EarlyUpdateUpdateCanvasRectTransformstruct7ForwardEv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 1467948 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN2UI6Canvas25UpdateCanvasRectTransformEb(HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 i3 = i2 << 24 >> 24 < 0;
 if (i3) i2 = HEAP32[i1 + 4 >> 2] | 0; else i2 = i2 & 255;
 if (i2 >>> 0 <= i4 >>> 0) __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv(i1);
 if (i3) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i4 | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7getMassEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 if (!(HEAP32[i2 + 284 >> 2] & 1)) f1 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i2 + 64 | 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i2 + 56 >> 2] | 0) + 92 >> 2]);
 i2 = f1 > Math_fround(0.0);
 f1 = Math_fround(Math_fround(1.0) / f1);
 return Math_fround(i2 ? f1 : Math_fround(0.0));
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE22getClientBehaviorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 4 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 11 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 3 | 0) >> 0] | 0;
}

function __ZNK27AnimatorControllerParameter15GetDefaultFloatEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if ((HEAP32[i1 + 16 >> 2] | 0) == 1) {
  f2 = Math_fround(HEAPF32[i1 + 20 >> 2]);
  return Math_fround(f2);
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911430 | 0, 0, gb + 911526 | 0, 74, 1, 0, 0, 0);
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK11Rigidbody2D15GetCenterOfMassEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i2 + 68 >> 2] | 0) != 2) {
  i2 = HEAP32[i3 + 32 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i3 + 28 >> 2];
  HEAP32[i1 + 4 >> 2] = i2;
  return;
 }
 HEAP32[i1 >> 2] = HEAP32[gb + 1162356 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162356 + 4 >> 2];
 return;
}

function __ZN9Texture3D19AllocateTextureDataEi13TextureFormatb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = (HEAP32[gb + 45784 + (i3 << 2) >> 2] | 0) + i2 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63272 | 0, 0, gb + 411375 | 0, 135) | 0;
 if (!((i2 | 0) != 0 & i4)) return i2 | 0;
 _memset(i2 | 0, -51, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN9GfxDevice18AllocRenderSurfaceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 380 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i3, 16, gb + 63304 | 0, 0, gb + 392043 | 0, 714) | 0;
 _memset(i1 | 0, 0, i3 | 0) | 0;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP8[i1 + 30 >> 0] = i2 & 1;
 return i1 | 0;
}

function __ZN5physx8debugger15ForwardingArrayINS0_18PropertyMessageArgEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149600 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext7D6JointD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 86848 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 86848 + 256;
 if (!(HEAP16[i1 + 6 >> 1] & 1)) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 80 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx18collideWithCapsuleEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i2, i3, i1, f5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 f5 = Math_fround(f5);
 var i4 = 0;
 if (!i3) return; else i4 = 0;
 do {
  __ZN5physx18collideWithCapsuleERNS_19PxsParticleCollDataERKNS_17PxCapsuleGeometryEf(i2 + (i4 * 176 | 0) | 0, i1, f5);
  i4 = i4 + 1 | 0;
 } while ((i4 | 0) != (i3 | 0));
 return;
}

function __ZN18LoadSceneOperation19IntegrateTimeSlicedEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(__ZN27TimeSliceAwakeFromLoadQueue19IntegrateTimeSlicedEi(i2 + 84 | 0, i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i2 + 469 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i2 = 1;
  return i2 | 0;
 }
 if ((HEAP32[i2 + 24 >> 2] | 0) != 1) {
  i2 = 1;
  return i2 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i2 = 0;
 return i2 | 0;
}

function __ZN17BillboardRenderer17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 348 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN8Renderer17MainThreadCleanupEv(i1);
  return;
 }
 i4 = i1 + 352 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Renderer17MainThreadCleanupEv(i1);
 return;
}

function __ZN14ParticleSystem18SystemWannaRayCastERKS_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 904 >> 2] | 0;
 if (!i2) i1 = 0; else if (!(HEAP8[i2 + 4 >> 0] | 0)) i1 = 0; else if ((HEAP32[i2 + 136 >> 2] | 0) == 1) if (!(HEAP32[i1 + 936 >> 2] | 0)) {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 } else i1 = 0; else i1 = 0;
 return i1 | 0;
}

function __ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 __ZL18InitializeIfNeededv();
 return (__ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_(HEAP32[gb + 1103788 >> 2] | 0, i1) | 0) != 0 | 0;
}

function __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyRotationInternalP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator15SetBodyRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50Physics2D_CUSTOM_INTERNAL_get_colliderContactColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z20GetPhysics2DSettingsv() | 0;
 i4 = HEAP32[i5 + 140 >> 2] | 0;
 i3 = HEAP32[i5 + 144 >> 2] | 0;
 i2 = HEAP32[i5 + 148 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 136 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z47Terrain_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain13SetLightmapSTERK8Vector4f12LightmapType(i3, i2, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AssetBundle_Get_Custom_PropMainAssetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z29LoadMainObjectFromAssetBundleR11AssetBundle(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Light_Set_Custom_PropCullingMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZNK5Light16UnshareLightDataEv(i3);
   HEAP32[(HEAP32[i3 + 44 >> 2] | 0) + 36 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Renderer_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31LODGroup_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Event_Get_Custom_PropClickCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 32 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z31Collider_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z22ExtractRenderNodeQueueRK11CullResults15ExtractionFlagsR15RenderNodeQueue(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext(__Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags(i3, i1 + 1136 | 0, i1 + 16 | 0, HEAP32[i1 + 1196 >> 2] | 0, i2) | 0) | 0;
}

function _UNITY_LZ4_compress_withState(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i1 & 3 | 0) {
  i4 = 0;
  return i4 | 0;
 }
 _memset(i1 | 0, 0, 16416) | 0;
 if ((i4 | 0) < 65547) {
  i4 = _LZ4_compress_generic(i1, i2, i3, i4, 0, 0, 2, 0, 0) | 0;
  return i4 | 0;
 } else {
  i4 = _LZ4_compress_generic(i1, i2, i3, i4, 0, 0, 0, 0, 0) | 0;
  return i4 | 0;
 }
 return 0;
}

function _posix_madvise(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if ((i3 | 0) == 4) i1 = 0; else {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  HEAP32[i4 + 8 >> 2] = i3;
  i1 = 0 - (___syscall219(219, i4 | 0) | 0) | 0;
 }
 STACKTOP = i5;
 return i1 | 0;
}

function __ZNSt3__28numpunctIwEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212984 + 8;
 HEAP32[i1 + 8 >> 2] = 46;
 HEAP32[i1 + 12 >> 2] = 44;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return; else {
  __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i2 >> 2] | 0);
  __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE(i1, HEAP32[i2 + 4 >> 2] | 0);
  __ZdlPv(i2);
  return;
 }
}

function __ZNKSt3__25ctypeIwE9do_narrowEPKwS3_cPc(i1, i4, i5, i6, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = i2 | 0;
 var i3 = 0, i7 = 0;
 i3 = (i5 - i4 | 0) >>> 2;
 i1 = i2;
 i2 = i4;
 while (1) {
  if ((i2 | 0) == (i5 | 0)) break;
  i7 = HEAP32[i2 >> 2] | 0;
  HEAP8[i1 >> 0] = i7 >>> 0 < 128 ? i7 & 255 : i6;
  i1 = i1 + 1 | 0;
  i2 = i2 + 4 | 0;
 }
 return i4 + (i3 << 2) | 0;
}

function __ZN6prcoreL12RemapGenericI11TexFormatA817TexFormatARGB8888EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i4 >> 2] = HEAPU8[i1 >> 0];
  if (!i2) break; else {
   i4 = i4 + 4 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + (HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd10SocketImpl5writeEPKhj(i5, i3, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 i2 = i5 + 4 | 0;
 do {
  i1 = _send(HEAP32[i2 >> 2] | 0, i3, i4, 0) | 0;
  if ((i1 | 0) >= 0) {
   i6 = 5;
   break;
  }
 } while ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 11);
 if ((i6 | 0) == 5) return i1 | 0;
 HEAP8[i5 + 14 >> 0] = 0;
 i6 = 0;
 return i6 | 0;
}

function __ZN5physx2Sc5Scene13endSimulationEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 1104 | 0;
 __ZN5physx2Sc10NPhaseCore28fireCustomFilteringCallbacksEv(HEAP32[i2 >> 2] | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 + 28 >> 2] = HEAP32[i2 + 20 >> 2];
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1 & 2147483647;
 i1 = i1 + 80 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 734920 | 0, i1, 0);
 __ZN5Unity17ConfigurableJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN4FMOD6SoundI16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 HEAP32[i6 >> 2] = 78;
 HEAP32[i6 + 4 >> 2] = gb + 869053;
 _printf(gb + 857490 | 0, i6) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN22ParticleSystemRenderer12GetLocalAABBER4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i4, __ZN8Renderer12GetTransformEv(i1) | 0);
 __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_(i1 + 568 | 0, i4, i2);
 STACKTOP = i3;
 return;
}

function __ZN20SubstanceArchiveDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 59540 + 8;
 __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1 + 36 | 0, HEAP32[i1 + 40 >> 2] | 0);
 if ((HEAP32[i1 + 28 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 12 >> 2] | 0, i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN16LightmapSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63160 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14RenderSettings24SetDefaultReflectionModeENS_21DefaultReflectionModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 + 368 >> 2] = i2;
 i3 = HEAP32[gb + 1112272 >> 2] | 0;
 i4 = HEAP32[i1 + 364 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[((i2 | 0) == 0 ? i1 + 384 | 0 : i1 + 380 | 0) >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i3);
 return;
}

function __ZN14FileCacherRead16UnlockCacheBlockEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 if ((HEAP32[i2 + 28 >> 2] | 0) == (i3 | 0)) {
  i1 = i2 + 32 | 0;
  if ((HEAP32[i1 >> 2] | 0) != 1) i4 = 4;
 } else i4 = 4;
 if ((i4 | 0) == 4) {
  if ((HEAP32[i2 + 40 >> 2] | 0) != (i3 | 0)) return;
  i1 = i2 + 44 | 0;
  if ((HEAP32[i1 >> 2] | 0) != 1) return;
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13WheelCollider22CreatePhysXObjIfNeededEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 148 >> 2] | 0) != -1) return;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __Z49PlatformEffector2D_Set_Custom_PropUseSideFrictionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D18SetUseSideFrictionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Physics2D_CUSTOM_INTERNAL_get_colliderAsleepColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z20GetPhysics2DSettingsv() | 0;
 i4 = HEAP32[i5 + 124 >> 2] | 0;
 i3 = HEAP32[i5 + 128 >> 2] | 0;
 i2 = HEAP32[i5 + 132 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 120 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z47TerrainData_Get_Custom_PropAlphamapTextureCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 32 | 0;
   return (HEAP32[i2 + 16 >> 2] | 0) - (HEAP32[i2 + 12 >> 2] | 0) >> 2 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47Canvas_Set_Custom_PropSortingGridNormalizedSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas30SetSortingBucketNormalizedSizeEf(i3, Math_fround(i2 | 0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46CharacterJoint_Set_Custom_PropEnableProjectionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint19SetEnableProjectionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43SkinnedMeshRenderer_Get_Custom_PropRootBoneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN19SkinnedMeshRenderer11GetRootBoneEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42PolygonCollider2D_Get_Custom_PropPathCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 160 | 0;
   return ((HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 20 | 0 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35RenderTexture_Set_Custom_PropFormatP12Il2CppObject19RenderTextureFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 if (!i4) return;
 if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 if ((i4 | 0) > 0) i1 = 0; else return;
 do {
  mftCall_vi(HEAP32[i3 + (i1 << 3) >> 2] | 0, HEAP32[i3 + (i1 << 3) + 4 >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __Z31RectOffset_Get_Custom_PropRightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 4 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z30Event_Get_Custom_PropModifiersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 24 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z30Event_Get_Custom_PropCharacterP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP16[i1 + 36 >> 1] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28Shader_CUSTOM_GetGlobalFloati(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0, i5 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2 + 4 | 0;
 i5 = i2;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 f3 = Math_fround(__Z20GetShaderGlobalFloatN9ShaderLab16FastPropertyNameE(i4));
 STACKTOP = i2;
 return Math_fround(f3);
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i2 + 4 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
 __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_((HEAP8[i2 >> 0] | 0) == 0 ? i1 + (HEAP32[i2 + 12 >> 2] | 0) + -8 | 0 : i1, HEAP32[i2 + 20 >> 2] | 0);
 return;
}

function __Z14SkipPathPrefixPKcS0_jb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 do if (i4) if (!(_strncmp(i1, i2, i3) | 0)) {
  i1 = i1 + i3 | 0;
  break;
 } else {
  i4 = i1;
  return i4 | 0;
 } else {
  i4 = _strstr(i1, i2) | 0;
  i1 = (i4 | 0) == 0 ? i1 : i4 + i3 | 0;
 } while (0);
 while (1) if ((HEAP8[i1 >> 0] | 0) == 47) i1 = i1 + 1 | 0; else break;
 return i1 | 0;
}

function _UNITY_FT_Stream_GetUOffset(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 2 | 0;
 if (i4 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i4 = 0;
  HEAP32[i2 >> 2] = i3;
  return i4 | 0;
 }
 i4 = (HEAPU8[i3 + 1 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0) << 16 | (HEAPU8[i4 >> 0] | 0);
 i3 = i3 + 3 | 0;
 HEAP32[i2 >> 2] = i3;
 return i4 | 0;
}

function _output_message(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 208 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = i2 + 8 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i4 | 0, 200);
 i1 = HEAP32[gb + 191628 >> 2] | 0;
 HEAP32[i3 >> 2] = i4;
 _fprintf(i1, gb + 1076431 | 0, i3) | 0;
 STACKTOP = i2;
 return;
}

function _copysign(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0, i4 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i4 = HEAP32[tempDoublePtr >> 2] | 0;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 HEAPF64[tempDoublePtr >> 3] = d2;
 i3 = HEAP32[tempDoublePtr + 4 >> 2] & -2147483648 | i3 & 2147483647;
 HEAP32[tempDoublePtr >> 2] = i4;
 HEAP32[tempDoublePtr + 4 >> 2] = i3;
 return +(+HEAPF64[tempDoublePtr >> 3]);
}

function __ZNK8GUIStyle8CalcSizeER10GUIContent(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAPF32[i5 >> 2] = Math_fround(0.0);
 HEAPF32[i5 + 4 >> 2] = Math_fround(0.0);
 __ZNK8GUIStyle10DoCalcSizeER10GUIContentRK8Vector2f(i1, i2, i3, i5);
 STACKTOP = i4;
 return;
}

function __ZNK5physx2Sq12BucketPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE(i4, i3, i5, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP8[i4 + 7600 >> 0] | 0) {
  i5 = 1;
  return i5 | 0;
 }
 i5 = __ZNK5physx2Sq16BucketPrunerCore5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE(i4 + 16 | 0, i3, i5, i1, i2) | 0;
 return i5 | 0;
}

function __ZNK16ReflectionProbes28RealtimeReflectionProbeCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + (i2 << 2) | 0;
 i2 = i1;
 i1 = 0;
 do {
  i1 = ((HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0) == 1 & 1) + i1 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) != (i2 | 0));
 return i1 | 0;
}

function __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatA8EEvPKNS_9InnerInfoE(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) return;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP8[i4 >> 0] = HEAP32[i1 >> 2];
  if (!i2) break; else {
   i4 = i4 + 1 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 86828 + 8;
 i1 = i1 + 4 | 0;
 __ZN5physx6shdfnd10ThreadImplD2Ev(HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149568 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext23DefaultBufferedProfiler11flushEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 __ZN5physx3Ext18ProfileZoneHandler11flushEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE(i1 + 60 | 0, i1 + 88 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh(i4, i1, i2, i5, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 HEAP32[i4 >> 2] = gb + 90860 + 8;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = -1;
 HEAP16[i4 + 16 >> 1] = -1;
 HEAP16[i4 + 18 >> 1] = -1;
 HEAP8[i4 + 20 >> 0] = i5;
 HEAP8[i4 + 21 >> 0] = i3;
 return;
}

function __ZN5physx2Gu12TriangleMesh7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(HEAP32[i2 + 224 >> 2] | 0, i2, 3, 0);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN4FMOD7SystemI20set3DSpeakerPositionE12FMOD_SPEAKERffb(i1, i2, f3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869795;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 HEAP32[i6 >> 2] = 78;
 HEAP32[i6 + 4 >> 2] = gb + 869556;
 _printf(gb + 857490 | 0, i6) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN14DLHAudioHelperD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 188088 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i2 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) {
  __ZdlPv(i1);
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63808 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11OffMeshLink16RemoveConnectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 40 | 0;
 i2 = i1;
 if ((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0) return;
 i3 = __Z17GetNavMeshManagerv() | 0;
 i2 = i1;
 __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i3, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __ZN11OffMeshLink16OnNavMeshCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 40 | 0;
 i2 = i1;
 if ((HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0) return;
 i3 = __Z17GetNavMeshManagerv() | 0;
 i2 = i1;
 __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i3, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __ZN10GUIManager26ProcessEventForCursorFlashERK10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 switch (HEAP32[i2 >> 2] | 0) {
 case 4:
 case 1:
 case 0:
  break;
 default:
  return;
 }
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 f3 = Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
 HEAPF32[(HEAP32[gb + 1468156 >> 2] | 0) + 40 + (i2 << 2) >> 2] = f3;
 return;
}

function __Z72Camera_Set_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1120 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48Physics2D_CUSTOM_INTERNAL_get_colliderAwakeColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z20GetPhysics2DSettingsv() | 0;
 i4 = HEAP32[i5 + 108 >> 2] | 0;
 i3 = HEAP32[i5 + 112 >> 2] | 0;
 i2 = HEAP32[i5 + 116 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 104 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z47CanvasRenderer_Set_Custom_PropHasPopInstructionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer20SetHasPopInstructionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46NavMeshAgent_CUSTOM_ActivateCurrentOffMeshLinkP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent26ActivateCurrentOffMeshLinkEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_zDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint9SetZDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_yDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint9SetYDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_xDriveP12Il2CppObjectRK10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint9SetXDriveERK10JointDrive(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42RenderTexture_CUSTOM_Internal_SetDimensionP12Il2CppObject16TextureDimension(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture12SetDimensionE16TextureDimension(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Cloth_Set_Custom_PropUseVirtualParticlesP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth22SetUseVirtualParticlesEb(i3, f2 != Math_fround(0.0));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39HingeJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK18JointAngleLimits2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12HingeJoint2D9SetLimitsERK18JointAngleLimits2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34ComputeBuffer_Get_Custom_PropCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i1 = HEAP32[i1 + 72 >> 2] | 0;
  if (i1 | 0) __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv(i1) | 0;
  HEAP8[i2 >> 0] = 1;
 }
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i1 = HEAP32[i1 + 72 >> 2] | 0;
  if (i1 | 0) __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv(i1) | 0;
  HEAP8[i2 >> 0] = 1;
 }
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10getDampingEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 128)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore10getDampingEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 12 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK19SkinnedMeshRenderer19GetBlendShapeWeightEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, f5 = f0;
 i4 = HEAP32[i1 + 428 >> 2] | 0;
 i3 = HEAP32[i1 + 412 >> 2] | 0;
 if ((i4 >>> 0 < i3 >>> 0 ? i4 : i3) >>> 0 <= i2 >>> 0) {
  f5 = Math_fround(0.0);
  return Math_fround(f5);
 }
 f5 = Math_fround(HEAPF32[(HEAP32[i1 + 416 >> 2] | 0) + (i2 << 2) >> 2]);
 return Math_fround(f5);
}

function __ZNK18ScreenManagerWebGL13GetLockCursorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (!(_JS_SystemInfo_HasCursorLock() | 0)) {
  i1 = 0;
  STACKTOP = i2;
  return i1 | 0;
 }
 _emscripten_get_pointerlock_status(i1 | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) != 0 & 1;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN8Renderer21ClearCustomPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 224 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN7ApiGLES17CreateVertexArrayEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 720 >> 2] | 0, 1, i4 | 0);
 i2 = HEAP32[i2 + 1988 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN7ApiGLES17CreateFramebufferEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 536 >> 2] | 0, 1, i4 | 0);
 i2 = HEAP32[i2 + 1988 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 i2 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i4 | 0, 1) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148752 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149616 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11HeightField7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(HEAP32[i2 + 112 >> 2] | 0, i2, 1, 0);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE(i1, i3, i2, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5physx2Gu11gjkRelativeINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE(i1, i3, i2, i4, i5, i6, i7) | 0;
}

function __ZN5physx19PxsFluidSpatialHashD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2 + 1 | 0, HEAP32[i1 >> 2] | 0);
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx17collideWithSphereEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i3, i1, i5, f4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 f4 = Math_fround(f4);
 var i2 = 0;
 if (!i1) return; else i2 = 0;
 do {
  __ZN5physx17collideWithSphereERNS_19PxsParticleCollDataERKNS_16PxSphereGeometryEf(i3 + (i2 * 176 | 0) | 0, i5, f4);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN5Unity17ConfigurableJoint20ApplySetupAxesToDescEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, i3);
 return;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 621574 | 0, i1, 0);
 __ZN22ParticleSystemRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 844212 | 0, i1, 0);
 __ZN22NavMeshProjectSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20OcclusionCullingDataD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 34876 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN19RenderBufferManager23InitRenderBufferManagerEv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(36) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[gb + 1158348 >> 2] = i1;
 return;
}

function __ZN17SizeBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __ZN16ReflectionProbes20BlurMipmapLevelsFromEP15ReflectionProbei(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i3 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 __ZN13ProbeRenderer8ConvolveEbijjb(i1, 1, 63, i4, -1, 1);
 return;
}

function __ZN14SpriteRenderer17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 368 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN8Renderer17MainThreadCleanupEv(i1);
  return;
 }
 i4 = i1 + 372 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Renderer17MainThreadCleanupEv(i1);
 return;
}

function __ZN12TLSAllocatorI14StackAllocatorE16ThreadInitializeEP13BaseAllocator(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 HEAP32[gb + 1103852 >> 2] = i3;
 i1 = 0;
 while (1) {
  i4 = i2 + 32 + (i1 << 2) | 0;
  i1 = i1 + 1 | 0;
  if (!(HEAP32[i4 >> 2] | 0)) break;
  if ((i1 | 0) >= 128) {
   i5 = 5;
   break;
  }
 }
 if ((i5 | 0) == 5) return;
 HEAP32[i4 >> 2] = i3;
 return;
}

function __ZN11TimeManager19SetMaximumDeltaTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAPF32[i4 >> 2] = f2;
 i5 = i1 + 48 | 0;
 i6 = Math_fround(HEAPF32[i5 >> 2]) > f2;
 HEAP32[i1 + 200 >> 2] = HEAP32[(i6 ? i5 : i4) >> 2];
 STACKTOP = i3;
 return;
}

function __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z54RenderSettings_CUSTOM_INTERNAL_get_ambientEquatorColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z17GetRenderSettingsv() | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 i3 = HEAP32[i5 + 52 >> 2] | 0;
 i2 = HEAP32[i5 + 56 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z48TargetJoint2D_Set_Custom_PropAutoConfigureTargetP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13TargetJoint2D22SetAutoConfigureTargetEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48SurfaceEffector2D_Set_Custom_PropUseContactForceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D18SetUseContactForceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48AudioSource_Set_Custom_PropSpatializePostEffectsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource24SetSpatializePostEffectsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48AudioSource_Set_Custom_PropBypassListenerEffectsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource24SetBypassListenerEffectsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Physics2D_CUSTOM_INTERNAL_get_colliderAABBColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z20GetPhysics2DSettingsv() | 0;
 i4 = HEAP32[i5 + 156 >> 2] | 0;
 i3 = HEAP32[i5 + 160 >> 2] | 0;
 i2 = HEAP32[i5 + 164 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 152 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z43TerrainData_Get_Custom_PropDetailResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 128 | 0;
   return Math_imul(HEAP32[i2 + 36 >> 2] | 0, HEAP32[i2 + 40 >> 2] | 0) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42TerrainCollider_Get_Custom_PropTerrainDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN15TerrainCollider14GetTerrainDataEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41TerrainData_Get_Custom_PropAlphamapLayersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 32 | 0;
   return ((HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0) / 44 | 0 | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Rigidbody_CUSTOM_INTERNAL_CALL_AddTorqueP12Il2CppObjectRK8Vector3fi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Rigidbody9AddTorqueERK8Vector3fi(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38RenderTexture_Set_Custom_PropIsCubemapP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture12SetDimensionE16TextureDimension(i3, i2 << 24 >> 24 ? 4 : 2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36NavMeshObstacle_Set_Custom_PropShapeP12Il2CppObject20NavMeshObstacleShape(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle8SetShapeE20NavMeshObstacleShape(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29RectOffset_Get_Custom_PropTopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 8 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28Gradient_Get_Custom_PropModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 68 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z28Cloth_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i2 << 24 >> 24 != 0 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z17PxcPoolMallocTermv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1457392 >> 2] | 0;
 if (!i1) {
  STACKTOP = i2;
  return;
 }
 __ZN17PxcPoolMallocDataD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[gb + 1457392 >> 2] | 0);
 HEAP32[gb + 1457392 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function _ftruncate(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
 i2 = ___syscall_ret(___syscall194(194, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _closelog() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 _pthread_setcancelstate(1, i2 | 0) | 0;
 ___lock(gb + 1469724 | 0);
 _close(HEAP32[gb + 207712 >> 2] | 0) | 0;
 HEAP32[gb + 207712 >> 2] = -1;
 ___unlock(gb + 1469724 | 0);
 _pthread_setcancelstate(HEAP32[i2 >> 2] | 0, 0) | 0;
 STACKTOP = i1;
 return;
}

function __ZNSt3__28numpunctIcEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212944 + 8;
 HEAP8[i1 + 8 >> 0] = 46;
 HEAP8[i1 + 9 >> 0] = 44;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK5physx3Ext7D6Joint14getLinearLimitEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 80 >> 2] | 0) + 96 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 20 >> 2];
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148240 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Gu10ConvexMesh7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb(HEAP32[i2 + 128 >> 2] | 0, i2, 2, 0);
 i1 = i2 + 6 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 i1 = i2 + 8 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 12 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx27InternalTriangleMeshBuilder15releaseEdgeListEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx2Gu8EdgeListD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN4crndL18crnd_default_msizeEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 528 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 i2 = i1 + 16 | 0;
 HEAP32[i3 >> 2] = gb + 401209;
 HEAP32[i3 + 4 >> 2] = 2485;
 HEAP32[i3 + 8 >> 2] = gb + 401395;
 _sprintf(i2, gb + 401176 | 0, i3) | 0;
 _puts(i2) | 0;
 STACKTOP = i1;
 return 0;
}

function __ZN4FMOD7SystemI12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869254;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1048607 | 0, i1, 0);
 __ZN21WorldParticleCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15TerrainCollider17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 68 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  __ZN8Collider17MainThreadCleanupEv(i1);
  return;
 }
 i4 = i1 + 72 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i4 >> 2];
 HEAP32[HEAP32[i4 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i4 >> 2] = 0;
 __ZN8Collider17MainThreadCleanupEv(i1);
 return;
}

function __Z53RenderSettings_CUSTOM_INTERNAL_get_ambientGroundColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z17GetRenderSettingsv() | 0;
 i4 = HEAP32[i5 + 64 >> 2] | 0;
 i3 = HEAP32[i5 + 68 >> 2] | 0;
 i2 = HEAP32[i5 + 72 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 60 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z46ReflectionProbe_Set_Custom_PropTimeSlicingModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ReflectionProbe18SetTimeSlicingModeENS_15TimeSlicingModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Cloth_CUSTOM_INTERNAL_set_externalAccelerationP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth23SetExternalAccelerationERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Camera_CUSTOM_INTERNAL_set_worldToCameraMatrixP12Il2CppObjectRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45SkinnedMeshRenderer_Get_Custom_PropSharedMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN19SkinnedMeshRenderer7GetMeshEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45Animator_CUSTOM_GetHintWeightPositionInternalP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZN8Animator21GetHintWeightPositionEi(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37RenderTexture_Set_Custom_PropIsVolumeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture12SetDimensionE16TextureDimension(i3, i2 << 24 >> 24 ? 3 : 2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Renderer_Set_Custom_PropProbeAnchorP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 280 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34CommandBuffer_CUSTOM_ReleaseBufferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __Z27Event_Get_Custom_PropButtonP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 + 20 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z14CleanupShadersv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1166244 >> 2] | 0;
 if (i1 | 0) __ZN9ShaderLab9IntShaderD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166244 >> 2] = 0;
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) {
  __ZN9ShaderLab16CleanupShaderLabEv();
  return;
 }
 HEAP32[i1 + 32 >> 2] = 0;
 __ZN9ShaderLab16CleanupShaderLabEv();
 return;
}

function _truncate(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP32[i4 + 8 >> 2] = i2;
 HEAP32[i4 + 12 >> 2] = ((i2 | 0) < 0) << 31 >> 31;
 i2 = ___syscall_ret(___syscall193(193, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _rint(d1) {
 d1 = +d1;
 var i2 = 0, i3 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] | 0;
 i3 = i2 & 2146435072;
 if (!(i3 >>> 0 > 1126170624 | (i3 | 0) == 1126170624 & 0 > 0)) {
  i2 = (i2 | 0) < 0;
  d1 = i2 ? d1 + -4503599627370496.0 + 4503599627370496.0 : d1 + 4503599627370496.0 + -4503599627370496.0;
  if (d1 == 0.0) d1 = i2 ? -0.0 : 0.0;
 }
 return +d1;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10getDampingEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 128)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore10getDampingEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 12 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE17getDominanceGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP8[((i3 & 2 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 12 | 0 : (HEAP32[i1 + (i2 + 8) >> 2] | 0) + 2 | 0) >> 0] | 0;
}

function __ZNK17AnimationCurveTplIfE8GetRangeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 68 >> 2] | 0;
 if (!i3) {
  HEAPF32[i1 >> 2] = Math_fround(inf);
  HEAPF32[i1 + 4 >> 2] = Math_fround(-inf);
  return;
 } else {
  i2 = HEAP32[i2 + 56 >> 2] | 0;
  i3 = HEAP32[i2 + (i3 + -1 << 4) >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i1 + 4 >> 2] = i3;
  return;
 }
}

function __ZNK14RenderSettings13CalcFogFactorEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0;
 if (!(HEAP8[i1 + 312 >> 0] | 0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f3 = Math_fround(HEAPF32[i1 + 344 >> 2]);
 f2 = Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_fround(Math_fround(f3 * f3) * f2) * f2)))));
 return Math_fround(f2);
}

function __ZN7Texture12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1158372 >> 2] | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63272 | 0);
 HEAP32[gb + 1158372 >> 2] = 0;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager22setDebugRenderingFlagsENS_7PxFlagsINS_27PxControllerDebugRenderFlag4EnumEjEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 if (HEAP32[i1 >> 2] | 0) return;
 i1 = i2 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene20particlePostShapeGenEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 148 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i2 + 144 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx14PxsAABBManager13setActorDirtyEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (!(i2 & 1)) return;
 i1 = i2 >>> 1;
 if (HEAP8[(HEAP32[i3 + 180 >> 2] | 0) + ((HEAP32[(HEAP32[i3 + 260 >> 2] | 0) + (i1 << 2) >> 2] | 0) * 1048 | 0) + 1024 >> 0] | 0) return;
 i3 = (HEAP32[i3 + 268 >> 2] | 0) + (i2 >>> 6 << 2) | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1 << (i1 & 31);
 return;
}

function __ZN4FMOD13ChannelGroupI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868197;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 378221 | 0, i1, 0);
 __ZN21LightProbeProxyVolume8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN21AnimationPosePlayable19DeallocateResourcesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 72 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i3 = i1 + 84 | 0;
  __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE(HEAP32[i3 >> 2] | 0, i1 + 60 | 0);
  HEAP32[i3 >> 2] = 0;
 }
 HEAP8[i2 >> 0] = 0;
 __ZN8Playable19DeallocateResourcesEv(i1);
 return;
}

function __ZN16ReflectionProbes21IsSmoothnessSupportedEv() {
 var i1 = 0, i2 = 0;
 i2 = (HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0) == 8;
 i1 = __Z15GetGraphicsCapsv() | 0;
 if (!i2) {
  i2 = (HEAP32[i1 + 88 >> 2] | 0) > 20;
  return i2 | 0;
 }
 if (!(HEAP8[i1 + 704 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 726 >> 0] | 0) != 0;
 return i2 | 0;
}

function __ZN14RenderSettings11SetFogColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 320 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 324 >> 2] = i5;
 HEAP32[i1 + 328 >> 2] = i4;
 HEAP32[i1 + 332 >> 2] = i3;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 76928 + 8;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
 if ((HEAP32[i1 + 52 >> 2] | 0) <= -1) return;
 i2 = i1 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 76928 + 8;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
 if ((HEAP32[i1 + 52 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 36 >> 2] | 0, i1 + 40 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN13RendererScene27UpdatePreviousFrameMatricesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i3 = i2 + (i1 * 24 | 0) | 0;
 if (!i1) return; else i1 = i2;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0);
  i1 = i1 + 24 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN12HeaderHelper13SetAllHeadersEPKcj(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 L1 : do if (!i1) i1 = 0; else {
  i2 = 0;
  while (1) {
   if (!(_isspace(HEAP8[i4 + i2 >> 0] | 0) | 0)) break L1;
   i2 = i2 + 1 | 0;
   if ((i2 | 0) == (i1 | 0)) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 return __ZN12HeaderHelper21ParseAndSetAllHeadersEPKcj(i3, i4, i1) | 0;
}

function __ZN10CBBoxInt328ClampMinEiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i5 | 0) > (i2 | 0) ? i5 : i2;
 i2 = i1 + 4 | 0;
 i5 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = (i5 | 0) > (i3 | 0) ? i5 : i3;
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = (i2 | 0) > (i4 | 0) ? i2 : i4;
 return;
}

function __Z48ConfigurableJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint18SetProjectionAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48CharacterJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint21SetProjectionDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47SliderJoint2D_Set_Custom_PropAutoConfigureAngleP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D21SetAutoConfigureAngleEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47PlatformEffector2D_Set_Custom_PropUseSideBounceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D16SetUseSideBounceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47GameObject_CUSTOM_Internal_AddComponentWithTypeP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z24MonoAddComponentWithTypeR10GameObjectP12Il2CppObject(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47AudioSource_Set_Custom_PropIgnoreListenerVolumeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource23SetIgnoreListenerVolumeEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Display_CUSTOM_SetRenderingResolutionImpl13Il2Cpp_IntPtrii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = __Z16GetScreenManagerv() | 0;
 i5 = HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0;
 i1 = __Z16GetScreenManagerv() | 0;
 mftCall_viiiii(i5 | 0, i4 | 0, i2 | 0, i3 | 0, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0, 0);
 return;
}

function __Z40Renderer_Get_Custom_PropStaticBatchIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 32 | 0;
   return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Rigidbody_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK8Vector3fi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN9Rigidbody8AddForceERK8Vector3fi(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Animation_Set_Custom_PropCullingTypeP12Il2CppObjectN9Animation11CullingTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Animation14SetCullingTypeENS_11CullingTypeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35NavMeshAgent_CUSTOM_FindClosestEdgeP12Il2CppObjectP10NavMeshHit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZNK12NavMeshAgent14DistanceToEdgeEP10NavMeshHit(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34RegisterPrepareRenderNodesCallbackiPFvR35RenderNodeQueuePrepareThreadContextES2_PFPvvEPFvS3_E(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[gb + 1112412 + (i1 << 4) >> 2] = i4;
 HEAP32[gb + 1112412 + (i1 << 4) + 4 >> 2] = i5;
 HEAP32[gb + 1112412 + (i1 << 4) + 8 >> 2] = i2;
 HEAP32[gb + 1112412 + (i1 << 4) + 12 >> 2] = i3;
 return;
}

function _UNITY_FT_Library_Version(i1, i4, i5, i6) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 0;
  i3 = 0;
  i1 = 0;
 } else {
  i2 = HEAP32[i1 + 12 >> 2] | 0;
  i3 = HEAP32[i1 + 8 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 if (i4 | 0) HEAP32[i4 >> 2] = i1;
 if (i5 | 0) HEAP32[i5 >> 2] = i3;
 if (!i6) return;
 HEAP32[i6 >> 2] = i2;
 return;
}

function _UNITY_FT_Bitmap_Done(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = 33;
  return i2 | 0;
 }
 if (!i2) {
  i2 = 6;
  return i2 | 0;
 }
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 i2 = 0;
 return i2 | 0;
}

function __ZThn24_N5physx2Sc21ConstraintInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -24 | 0;
 HEAP32[i1 >> 2] = gb + 90796 + 8;
 HEAP32[i1 + 24 >> 2] = gb + 90796 + 48;
 __ZN5physx2Sc16ActorInteractionD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputcEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i1 + 28 >> 2] | 0)) i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 & 255 | 0) | 0; else {
  HEAP32[i3 >> 2] = i4 + 1;
  HEAP8[i4 >> 0] = i2;
  i1 = i2 & 255;
 }
 return i1 | 0;
}

function __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 148 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i4 = HEAP32[i2 + 156 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 160 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return;
}

function __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = __Z4loadPKf((HEAP32[i3 >> 2] | 0) + (i2 * 3 << 2) | 0) | 0;
 __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv(i1, i5);
 STACKTOP = i4;
 return;
}

function __ZNK18ProceduralMaterial25IsSubstancePropertyCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 140 >> 2] & 4 | 0) != 0;
 return i2 | 0;
}

function __ZNK16ParticleAnimator29WillAutoDestructIfNoParticlesERK19PrivateParticleInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 108 | 0;
 if (HEAP32[i1 >> 2] | 0) if (__Z14IsWorldPlayingv() | 0) {
  if ((HEAP32[i1 >> 2] | 0) == 2) {
   i2 = 1;
   return i2 | 0;
  }
  if (HEAP8[i2 + 37 >> 0] | 0) if (!(HEAP8[i2 + 38 >> 0] | 0)) {
   i2 = 1;
   return i2 | 0;
  }
 }
 i2 = 0;
 return i2 | 0;
}

function __ZN9GfxDevice21SwapDynamicVBOBuffersEj(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 4512 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  if (!(HEAP32[i3 >> 2] | 0)) HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 896 >> 2] | 0, i2 | 0) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i4 | 0);
 return;
}

function __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i4 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 __ZN7Cursors9SetCursorEP9Texture2D8Vector2f10CursorMode(i1, i4, 0);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sn13XmlWriterImplD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = gb + 146492 + 8;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) return;
 i2 = i2 + 8 | 0;
 do {
  HEAP32[i3 >> 2] = i1 + -1;
  i4 = HEAP32[i2 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 12 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i3 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx15PxVehicleWheels4freeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i4) return;
 i1 = i1 + 72 | 0;
 i3 = 0;
 do {
  i2 = HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + (i3 * 224 | 0) + 208 >> 2] | 0) + 368 >> 2] | 0;
  if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN5Unity14CharacterJoint20ApplySetupAxesToDescEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, i3);
 return;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1046572 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1041655 | 0, i1, 0);
 __ZN20UnityConnectSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15MulticastSocket4SendEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = i1 + 20;
 HEAP32[i5 + 8 >> 2] = 16;
 i3 = __ZN6Socket4SendEPKvjP12SendUserData(i1, i2, i3, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN14VelocityModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __ZN14AnimationState19SetupUnstoppedStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 12 | 0;
 i2 = i1 + 80 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 i2 = i1 + 8 | 0;
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i2 >> 2] = Math_fround(.000100100006);
 i1 = i1 + 56 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] | 2;
 return;
}

function __ZN13BaseAllocatorC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 26612 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[gb + 27044 >> 2] = (HEAP32[gb + 27044 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 27044 >> 2];
 return;
}

function __ZL27ClearTransformTemporaryFlagR9Transform(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -4097;
 i1 = HEAP32[i2 + 80 >> 2] | 0;
 i3 = HEAP32[i2 + 92 >> 2] | 0;
 i2 = i1 + (i3 << 2) | 0;
 if (!i3) return;
 do {
  __ZL27ClearTransformTemporaryFlagR9Transform(HEAP32[i1 >> 2] | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z61Animator_Get_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN8Animator40GetAllowConstantClipSamplingOptimizationEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z54TerrainData_Set_Custom_PropInternal_alphamapResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SplatDatabase21SetAlphamapResolutionEi(i3 + 32 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z54NavMeshObstacle_Set_Custom_PropCarvingTimeToStationaryP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle19SetTimeToStationaryEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48LODGroup_CUSTOM_INTERNAL_set_localReferencePointP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8LODGroup22SetLocalReferencePointERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45CanvasGroup_Set_Custom_PropIgnoreParentGroupsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI11CanvasGroup21SetIgnoreParentGroupsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = HEAP16[i2 + 152 + 2 >> 1] | 0;
   return (i2 << 16 >> 16 == -1 ? -1 : i2 & 65535) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Animator_CUSTOM_GetIKRotationWeightInternalP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZN8Animator21GetGoalWeightRotationEi(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43Animator_CUSTOM_GetIKPositionWeightInternalP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZN8Animator21GetGoalWeightPositionEi(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36FindComponentInGameObjectOrAncestorsR10GameObjecti(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = __ZN5Unity4Type26FindTypeByPersistentTypeIDEi(i3) | 0;
 if (i1 | 0) {
  i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(i2, i1) | 0;
  if (i1 | 0) {
   i3 = i1;
   return i3 | 0;
  }
 }
 i3 = __Z25FindAncestorComponentImplR10GameObjecti(i2, i3) | 0;
 return i3 | 0;
}

function __Z32Joint_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30RectOffset_Get_Custom_PropLeftP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z30GetPlayerShouldRunInBackgroundv() {
 var i1 = 0;
 if (!(__Z20GetPlayerSettingsPtrv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 if (__Z12GetIVRDevicev() | 0) {
  i1 = __Z12GetIVRDevicev() | 0;
  if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0) | 0) {
   i1 = 1;
   return i1 | 0;
  }
 }
 i1 = (HEAP8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] | 0) != 0;
 return i1 | 0;
}

function __Z30AudioSource_CUSTOM_PlayDelayedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   i1 = f2 < Math_fround(0.0);
   __ZN11AudioSource4PlayEd(i3, i1 ? 0.0 : -+f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29GL_CUSTOM_INTERNAL_CALL_ColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0, i5 = 0;
 i5 = __Z12GetGfxDevicev() | 0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 mftCall_viffff(HEAP32[(HEAP32[i5 >> 2] | 0) + 568 >> 2] | 0, i5 | 0, +f4, +f3, +f2, +Math_fround(HEAPF32[i1 + 12 >> 2]));
 return;
}

function __Z25BillboardRenderer_CleanupR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, i1 + 8 | 0);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff(i5, f4, f3) {
 i5 = i5 | 0;
 f4 = Math_fround(f4);
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0;
 i1 = i5 + 308 | 0;
 i2 = i5 + 312 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f4) if (Math_fround(HEAPF32[i2 >> 2]) == f3) return;
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i2 >> 2] = f3;
 HEAP32[i5 + 536 >> 2] = 0;
 return;
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj(i1, i3, i4, i5) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i2 = 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) i1 = HEAP32[i1 >> 2] | 0;
 i2 = (i2 & 65535) - i5 | 0;
 i2 = (i2 | 0) < 0 ? 0 : i2;
 i4 = i2 >>> 0 < i4 >>> 0 ? i2 : i4;
 _memcpy(i3 | 0, i1 + (i5 << 2) | 0, i4 << 2 | 0) | 0;
 return i4 | 0;
}

function __ZNK13b2PulleyJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i2 + 116 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 136 >> 2]));
 f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i2 + 140 >> 2])) * f3);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN7mecanim6memory16InPlaceAllocator8AllocateEjj(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i5 = 0;
 i5 = i4 + 4 | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 i3 = (i1 + -1 & 0 - i3) + i3 | 0;
 i1 = i3 + i2 | 0;
 if (i1 >>> 0 > ((HEAP32[i4 + 8 >> 2] | 0) + (HEAP32[i4 + 12 >> 2] | 0) | 0) >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i5 >> 2] = i1;
 i5 = i3;
 return i5 | 0;
}

function __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150800 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 150548 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx29PxClothSimpleTetherCookerImplC2ERKNS_15PxClothMeshDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 1;
 __ZN5physx29PxClothSimpleTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i2, i1);
 return;
}

function __ZN5physx15PxVehicleWheels15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __ZN5physx15PxVehicleWheels15computeByteSizeEj(HEAP32[i2 + 44 >> 2] | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 40 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5physx14NpSpatialIndexD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = gb + 107520 + 8;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 STACKTOP = i3;
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 734671 | 0, i1, 0);
 __ZN5Unity14CharacterJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN28LightProbeProxyVolumeContext5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 if (!(__ZNK16LightmapSettings19AreLightProbesBakedEv(__Z19GetLightmapSettingsv() | 0) | 0)) {
  i2 = 0;
  i1 = i1 + 20 | 0;
  HEAP8[i1 >> 0] = i2;
  return;
 }
 i3 = (__ZN21LightProbeProxyVolume18HasHardwareSupportEv() | 0) & 1;
 i2 = i1 + 20 | 0;
 HEAP8[i2 >> 0] = i3;
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 379002 | 0, i1, 0);
 __ZN20OcclusionCullingData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16CircleCollider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 0;
 i4 = gb + 1162356 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 + 53 >> 0] = 0;
 HEAPF32[i1 + 160 >> 2] = Math_fround(.5);
 return;
}

function __ZN15AudioMixerGroupD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 174700 + 8;
 i2 = i1 + 32 | 0;
 if ((HEAP32[i1 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 36 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 76952 + 8;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
 if ((HEAP32[i1 + 52 >> 2] | 0) <= -1) return;
 i2 = i1 + 36 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 76952 + 8;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) __ZN14DataBufferGLES7ReleaseEv(i2);
 if ((HEAP32[i1 + 52 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 36 >> 2] | 0, i1 + 40 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 380 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 380 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11UnityEngine15PlatformWrapper32GetLocalTimeOffsetInMillisecondsEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 _time(i3 | 0) | 0;
 i2 = _localtime(i3 | 0) | 0;
 i3 = _mktime(_gmtime(i3 | 0) | 0) | 0;
 i2 = ~~(+_difftime(i3 | 0, _mktime(i2 | 0) | 0) * 1.0e3);
 STACKTOP = i1;
 return i2 | 0;
}

function __ZN11Rigidbody2D14SetAngularDragEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i2 ? Math_fround(0.0) : f1;
 HEAPF32[i3 + 40 >> 2] = f1;
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 if (!i2) return;
 if (HEAP8[i3 + 227 >> 0] | 0) return;
 HEAPF32[i2 + 136 >> 2] = f1;
 return;
}

function __ZN10GameObject27SetComponentAtIndexInternalE4PPtrIN5Unity9ComponentEEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 i2 = __ZNK4PPtrIN5Unity9ComponentEEcvPS1_Ev(i2) | 0;
 HEAP32[i1 + (i3 << 3) >> 2] = HEAP32[(HEAP32[gb + 1106156 + 4 + ((HEAP32[i2 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 24 >> 2];
 HEAP32[i1 + (i3 << 3) + 4 >> 2] = i2;
 return;
}

function __ZN10GUITexture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 88 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z50WheelCollider_Set_Custom_PropForceAppPointDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider24SetForceAppPointDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50RenderSettings_CUSTOM_INTERNAL_get_ambientSkyColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z17GetRenderSettingsv() | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z50PlatformEffector2D_Set_Custom_PropRotationalOffsetP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D19SetRotationalOffsetEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46RenderTexture_Set_Custom_PropEnableRandomWriteP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture20SetEnableRandomWriteEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46DistanceJoint2D_Set_Custom_PropMaxDistanceOnlyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15DistanceJoint2D18SetMaxDistanceOnlyEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46AudioSource_Set_Custom_PropIgnoreListenerPauseP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource22SetIgnoreListenerPauseEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43ConfigurableJoint_Set_Custom_PropSwapBodiesP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint13SetSwapBodiesEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39TerrainData_Get_Custom_PropDetailHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 128 | 0;
   return Math_imul(HEAP32[i2 + 36 >> 2] | 0, HEAP32[i2 + 40 >> 2] | 0) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Rigidbody2D_Set_Custom_PropSleepModeP12Il2CppObjectN11Rigidbody2D9SleepModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D12SetSleepModeENS_9SleepModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Terrain_Set_Custom_PropMaterialTypeP12Il2CppObjectN7Terrain12MaterialTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain15SetMaterialTypeENS_12MaterialTypeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Rigidbody2D_Set_Custom_PropBodyTypeP12Il2CppObjectN11Rigidbody2D8BodyTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D11SetBodyTypeENS_8BodyTypeEb(i3, i2, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Projector_Set_Custom_PropMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 64 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z19il2cpp_array_new_2djjP11Il2CppClass(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 i3 = _il2cpp_array_new_full(_il2cpp_array_class_get(i3 | 0, 2) | 0, i5 | 0, 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __Z13GetSocketPorti(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3 + 8 | 0;
 i4 = i3;
 HEAP32[i4 >> 2] = 128;
 if (_getsockname(i1, i2, i4) | 0) {
  i4 = -1;
  STACKTOP = i3;
  return i4 | 0;
 }
 i4 = _ntohs((HEAP32[i2 >> 2] | 0) >>> 16 & 65535) | 0;
 STACKTOP = i3;
 return i4 | 0;
}

function _fwrite(i2, i4, i1, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i5 = 0, i6 = 0;
 i5 = Math_imul(i1, i4) | 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  i6 = (___lockfile(i3) | 0) == 0;
  i2 = ___fwritex(i2, i5, i3) | 0;
  if (!i6) ___unlockfile(i3);
 } else i2 = ___fwritex(i2, i5, i3) | 0;
 if ((i2 | 0) != (i5 | 0)) i1 = (i2 >>> 0) / (i4 >>> 0) | 0;
 return i1 | 0;
}

function ___cxx_global_var_init1() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097840 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNK5physx13NpVolumeCache7isValidEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (HEAP8[i3 + 116 + i2 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i3 + 80 >> 2] | 0;
 if (!i2) {
  i3 = (HEAP32[i1 + 20 >> 2] | 0) == (HEAP32[i3 + 108 >> 2] | 0);
  return i3 | 0;
 } else {
  i3 = (HEAP32[i1 + 24 >> 2] | 0) == (HEAP32[i3 + 112 >> 2] | 0);
  return i3 | 0;
 }
 return 0;
}

function __ZN9WWWCachedD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 64912 + 8;
 _free(HEAP32[i2 + 80 >> 2] | 0);
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (!i1) {
  __ZN3WWWD2Ev(i2);
  __ZdlPv(i2);
  return;
 }
 __ZN3WWW7ReleaseEv(i1);
 __ZN3WWWD2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN8Renderer26SupportedMessagesDidChangeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = i2 + 284 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i3 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 60 >> 2] | 0;
 i2 = __Z16GetRendererScenev() | 0;
 i2 = (HEAP32[i2 + 60 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] & -2 | i3 >>> 4 & 1;
 return;
}

function __ZN7mecanim5human18HumanGetFootHeightEPKNS0_5HumanEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 40 | 0;
 i3 = (HEAP32[i3 >> 2] | 0) + i3 | 0;
 i4 = i3 + 16 | 0;
 i3 = i3 + 4 | 0;
 return Math_fround(HEAPF32[(HEAP32[i4 >> 2] | 0) + i4 + ((HEAP32[i3 + (HEAP32[i3 >> 2] | 0) + (HEAP32[i1 + 72 + ((i2 ? 5 : 6) << 2) >> 2] << 3) + 4 >> 2] | 0) * 76 | 0) + 68 >> 2]);
}

function __ZN7ApiGLES18ClearBufferSubDataEjN2gl12BufferTargetEll(i3, i4, i5, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i6 = 0;
 i6 = __ZN7ApiGLES9MapBufferEjN2gl12BufferTargetEllj(i3, i4, i5, i1, i2, 10) | 0;
 i1 = (i2 - i1 | 0) >>> 2;
 if (i1 | 0) _memset(i6 | 0, 0, i1 << 2 | 0) | 0;
 __ZN7ApiGLES11UnmapBufferEjN2gl12BufferTargetE(i3, i4, i5);
 return;
}

function __ZN5physx8debugger15ForwardingArrayINS0_10NamedValueEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148644 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 __ZN5physx2Sc5ActorC2ERNS0_16InteractionSceneEhNS0_14IslandNodeInfo4TypeE(i3, HEAP32[i2 + 1204 >> 2] | 0, HEAP8[i1 + 10 >> 0] | 0, i4);
 HEAP32[i3 >> 2] = gb + 91068 + 8;
 HEAP32[i3 + 52 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN5physx14NpArticulation8requiresERNS_23PxProcessPxBaseCallbackE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 88 | 0;
 i2 = 0;
 do {
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1037672 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1047979 | 0, i1, 0);
 __ZN19MeshParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16ReflectionProbes15BlurMipmapLevelEP15ReflectionProbei(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i3 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 __ZN13ProbeRenderer8ConvolveEbijjb(i1, 1, 63, i4, i4, 0);
 return;
}

function __ZN14SplatPrototypeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(15.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(15.0);
 i1 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClient11isConnectedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 return i1 | 0;
}

function __ZN12MeshCollider14SetInflateMeshEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 121 >> 0] = i1 & 1;
 if (!(HEAP8[i2 + 60 >> 0] | 0)) return;
 if ((HEAPU8[i2 + 122 >> 0] | 0) == (i1 & 1 | 0)) return;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 return;
}

function __ZN12ImageDecoder7SetDataEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i2) {
  HEAP8[i1 + 4 >> 0] = 1;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  return;
 } else {
  i4 = i1 + 24 | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i1 + 28 >> 2] = i3;
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i4 | 0, fb + 351 | 0);
  return;
 }
}

function __ZN10OnGUIStateD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if (i1 | 0) {
  __ZN11UTF16StringD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = HEAP32[i2 + 76 >> 2] | 0;
 if (!i1) return;
 __ZN11UTF16StringD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __Z57AnimatorControllerPlayable_CUSTOM_PlayInFixedTimeInternalR9HPlayableiif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i3, i2, f4, Math_fround(0.0), Math_fround(0.0));
 return;
}

function __Z53TerrainData_Set_Custom_PropInternal_baseMapResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SplatDatabase20SetBaseMapResolutionEi(i3 + 32 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyPositionInternalP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator15SetBodyPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50LODGroup_Set_Custom_PropCrossFadeAnimationDurationf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(f1 <= Math_fround(0.0))) {
  HEAPF32[(__Z18GetLODGroupManagerv() | 0) + 32 >> 2] = f1;
  STACKTOP = i2;
  return;
 } else __ZN9Scripting22RaiseArgumentExceptionEPKcz(gb + 539975 | 0, i2);
}

function __Z46Animator_Set_Custom_PropLinearVelocityBlendingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator25SetLinearVelocityBlendingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Animator_Set_Custom_PropLayersAffectMassCenterP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator25SetLayersAffectMassCenterEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_CUSTOM_INTERNAL_CALL_AddTreeInstanceP12Il2CppObjectRK12TreeInstance(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain15AddTreeInstanceERK12TreeInstance(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Cloth_CUSTOM_INTERNAL_set_randomAccelerationP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth21SetRandomAccelerationERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Transform_CUSTOM_INTERNAL_set_localRotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform16SetLocalRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38TerrainData_Get_Custom_PropDetailWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = i2 + 128 | 0;
   return Math_imul(HEAP32[i2 + 36 >> 2] | 0, HEAP32[i2 + 40 >> 2] | 0) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38GameObject_CUSTOM_SetActiveRecursivelyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10GameObject30SetActiveRecursivelyDeprecatedEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Animator_Set_Custom_PropCullingModeP12Il2CppObjectN8Animator11CullingModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator14SetCullingModeENS_11CullingModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Joint_CUSTOM_INTERNAL_set_axisP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29dtAllocObstacleAvoidanceQueryv() {
 var i1 = 0, i2 = 0;
 i1 = __Z7dtAlloci(10464) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 + 10452 >> 2] = 0;
 HEAP32[i1 + 10456 >> 2] = 0;
 HEAP32[i1 + 10460 >> 2] = 0;
 i2 = i1 + 10420 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return i1 | 0;
}

function __Z28Event_Get_Custom_PropRawTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   STACKTOP = i3;
   return HEAP32[i1 >> 2] | 0;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
 return 0;
}

function __Z26setPxSceneDescSanityBoundsPN5physx11PxSceneDescENS_9PxBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 160 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 164 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 168 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 172 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 176 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 180 >> 2] = HEAP32[i1 + 20 >> 2];
 return;
}

function _UNITY_FT_Load_Char(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if (!i3) {
  i4 = 35;
  return i4 | 0;
 }
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 if (i2) {
  i1 = mftCall_iii(HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0) | 0;
  i1 = i1 >>> 0 >= (HEAP32[i3 + 16 >> 2] | 0) >>> 0 ? 0 : i1;
 }
 i4 = _UNITY_FT_Load_Glyph(i3, i1, i4) | 0;
 return i4 | 0;
}

function __ZThn8_N5physx13NpClothFabricD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 106864 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 106864 + 112;
 __ZN5physx2Sc15ClothFabricCoreD2Ev(i1 + 16 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNK8VRDevice18SetCompositorLayerEP7TextureRK8Vector3fS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i1 + 260 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iiii(i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
 return i4 | 0;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZNK11b2GearJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i2 + 156 >> 2]);
 f5 = Math_fround(f4 * Math_fround(HEAPF32[i2 + 240 >> 2]));
 f4 = Math_fround(Math_fround(f4 * Math_fround(HEAPF32[i2 + 244 >> 2])) * f3);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN9InputAxis13MakeAnalogKeyEiiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = i3;
 HEAP32[i1 + 64 >> 2] = i4;
 HEAP32[i1 + 68 >> 2] = i5;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 92 >> 2] = Math_fround(3.0);
 HEAP8[i1 + 104 >> 0] = 1;
 return;
}

function __ZN8Renderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 224 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63280 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8Material15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63288 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = i1 + 264 + (i2 * 20 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 return;
}

function __ZN7ApiGLES16DispatchIndirectEjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i5 = 0;
 i1 = i2 + 908 | 0;
 if (!(HEAP8[i2 + 1992 >> 0] | 0)) i5 = 3; else if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) i5 = 3;
 if ((i5 | 0) == 3) {
  HEAP32[i1 >> 2] = i3;
  mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 37102, i3 | 0);
 }
 mftCall_vi(HEAP32[i2 + 472 >> 2] | 0, i4 | 0);
 return;
}

function __ZN7ApiGLES11CreateQueryEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 792 >> 2] | 0, 1, i4 | 0);
 i2 = HEAP32[i2 + 1988 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 STACKTOP = i3;
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148548 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148320 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Sc7BodySim19postActorFlagChangeEjj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = i1 & 2;
 if ((i4 | 0) == (i2 & 2 | 0)) return;
 i1 = i3 + 146 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) HEAP8[i1 >> 0] = 1;
 i1 = i3 + 144 | 0;
 i2 = HEAPU16[i1 >> 1] | 0;
 if (!i4) {
  HEAP16[i1 >> 1] = i2 & 65534;
  return;
 } else {
  HEAP16[i1 >> 1] = i2 | 1;
  return;
 }
}

function __ZN5Unity11SpringJoint20ApplySetupAxesToDescEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, i3);
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 429151 | 0, i1, 0);
 __ZN19SkinnedMeshRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 734401 | 0, i1, 0);
 __ZN19CharacterController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 367172 | 0, i1, 0);
 __ZN19AssetBundleManifest8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18ScriptingArguments7AddEnumEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + (HEAP32[i3 >> 2] << 3) >> 2] = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i2 << 2) >> 2] = i1 + (i2 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + 1;
 HEAP32[i1 + 144 + (i2 << 2) >> 2] = 8;
 return;
}

function __ZN18PlatformEffector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN18BuoyancyEffector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15SharedLightData18CalculateAreaRangeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f2 = Math_fround(HEAPF32[i1 + 52 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f2 = Math_fround((f2 < f3 ? f3 : f2) * Math_fround(.5));
 return Math_fround(Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(HEAPF32[i1 + 44 >> 2]) / Math_fround(.00499999989)) + Math_fround(-1.0)))) * f2);
}

function __ZN13GfxDeviceGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN18GfxFramebufferGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, i2, i3);
 __ZN9GfxDevice30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_(i1, i2, i3);
 return;
}

function __ZN12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i(i5, i1, i4, i2, i3) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP8[i5 + 132 >> 0] | 0)) return;
 mftCall_viiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 68 >> 2] | 0, i5 | 0, i1 | 0, i4 | 0, i2 | 0, i3 | 0);
 mftCall_vi(HEAP32[(HEAP32[i5 >> 2] | 0) + 44 >> 2] | 0, i5 | 0);
 return;
}

function __ZN12WWWDelayCallC2EP3WWWPF15CallObjectStateP6ObjectPvES4_S5_PFS2_S5_E(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i2 + 76 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i5;
 HEAP32[i1 + 16 >> 2] = i6;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager25GetUnusedSessionContainerERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 128 >> 0] | 0)) i1 = 0; else if (!(HEAP8[i1 + 256 >> 0] | 0)) i1 = 1; else if (!(HEAP8[i1 + 384 >> 0] | 0)) i1 = 2; else if (!(HEAP8[i1 + 512 >> 0] | 0)) i1 = 3; else {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 i2 = 1;
 return i2 | 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager16StartExpiryTimerERNS0_16SessionContainerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = i2 + 104 | 0;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1 + 568 | 0;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP8[i2 + 91 >> 0] = 1;
 HEAP8[i2 + 92 >> 0] = 0;
 HEAP32[i1 + 560 >> 2] = 1;
 return;
}

function __ZN11ForceModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19SkinnedMeshRenderer12SetLocalAABBERK4AABB(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z4sqrtRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(Math_sqrt(Math_fround(HEAPF32[i2 >> 2])));
 f4 = Math_fround(Math_sqrt(Math_fround(HEAPF32[i2 + 4 >> 2])));
 f3 = Math_fround(Math_sqrt(Math_fround(HEAPF32[i2 + 8 >> 2])));
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(Math_sqrt(Math_fround(HEAPF32[i2 + 12 >> 2]))));
 return;
}

function __Z49ParticleRenderer_Set_Custom_PropUvAnimationCyclesP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN16ParticleRenderer20SetUVAnimationCyclesEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49AudioLowPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18AudioLowPassFilter18SetCutoffFrequencyEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Canvas_Set_Custom_PropNormalizedSortingGridSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas30SetSortingBucketNormalizedSizeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45RenderTexture_Set_Custom_PropAutoGenerateMipsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture19SetAutoGenerateMipsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44NavMeshAgent_CUSTOM_INTERNAL_set_destinationP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent14SetDestinationERK8Vector3f(i3, i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer8SetColorERK10ColorRGBAf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Motion_Get_Custom_PropAverageAngularSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Playables_CUSTOM_GetTypeOfInternal13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN9Scripting11RaiseIfNullEPv(i1);
 if ((HEAP32[i1 + 16 >> 2] | 0) != (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i1 + 20 | 0;
 __ZN9Scripting11RaiseIfNullEPv(HEAP32[i2 >> 2] | 0);
 i2 = __ZN8Playable15GetTypeInstanceEv(HEAP32[i2 >> 2] | 0) | 0;
 return i2 | 0;
}

function _rand() {
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = gb + 1099752 | 0;
 i2 = ___muldi3(HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0, 1284865837, 1481765933) | 0;
 i2 = _i64Add(i2 | 0, getTempRet0() | 0, 1, 0) | 0;
 i1 = getTempRet0() | 0;
 i3 = gb + 1099752 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 i1 = _bitshift64Lshr(i2 | 0, i1 | 0, 33) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((i4 | 0) == (i2 | 0)) break;
  i5 = i4 + -4 | 0;
  HEAP32[i3 >> 2] = i5;
  i4 = i5;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 return;
}

function __ZNK5physx19NpArticulationJoint13getTwistLimitERfS1_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i2 + 12 >> 2] & 65536)) {
  HEAP32[i1 >> 2] = HEAP32[i2 + 160 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i2 + 156 >> 2];
  return;
 } else {
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 + 136 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i2 + 140 >> 2];
  return;
 }
}

function __ZNK5physx19NpArticulationJoint13getSwingLimitERfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i1 + 12 >> 2] & 32768)) {
  HEAP32[i2 >> 2] = HEAP32[i1 + 132 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i1 + 136 >> 2];
  return;
 } else {
  i1 = HEAP32[i1 + 16 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i1 + 128 >> 2];
  HEAP32[i3 >> 2] = HEAP32[i1 + 132 >> 2];
  return;
 }
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZNK5Umbra4Path9getLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, f4 = f0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = (i3 | 0) <= (i2 | 0) ? i3 : i2;
 if (!i2) {
  f4 = Math_fround(-1.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + (i2 + -1 << 5) + 16 >> 2]);
 return Math_fround(f4);
}

function __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 36 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5physx8debugger15ForwardingArrayINS0_9PtrOffsetEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx7profile15ZoneManagerImpl18flushProfileEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 12 | 0;
 i2 = 0;
 do {
  i4 = (HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0) + 12 | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0);
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN5physx6shdfnd4swapINS_5cloth11SwCollisionI8Scalar4fE13CollisionDataEEEvRT_S8_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0, i6 = 0;
 i3 = i1;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i6 = i2;
 i5 = HEAP32[i6 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i6 >> 2];
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN5physx2Sc5Scene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 HEAP8[i2 + 1412 >> 0] = 1;
 __ZN5physx10PxsContext25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1, f3);
 if (i1 | 0) return;
 HEAPF32[i2 + 1408 >> 2] = f3;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i4 | 0, i3 | 0);
 return;
}

function __ZN5Unity5Joint18SetEnableCollisionEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 HEAP8[i1 + 88 >> 0] = i3 & 1;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, 8, i3 | 0);
 return;
}

function __ZN5Unity10HingeJoint20ApplySetupAxesToDescEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, i3);
 return;
}

function __ZN5Unity10FixedJoint20ApplySetupAxesToDescEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity5Joint9SetupAxesEi(i2, i3);
 return;
}

function __ZN20FileSystemEnumerator5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = i1 + -16 | 0;
  HEAP32[i2 >> 2] = i4;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN17SurfaceEffector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17CapsuleCollider2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14MessageHandler28MessageIDToMessageIdentifierEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = (HEAP32[i2 + 52 >> 2] | 0) + (i3 * 20 | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i3 + 16 >> 2];
 return;
}

function __ZN13GfxDeviceGLES19SetUserBackfaceModeEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 4381 | 0;
 if ((HEAPU8[i2 >> 0] | 0) == (i1 & 1 | 0)) return;
 i4 = i1 & 1;
 HEAP8[i2 >> 0] = i4;
 i1 = HEAP32[i3 + 4688 >> 2] | 0;
 if ((HEAP8[i3 + 7184 >> 0] | 0) == i4 << 24 >> 24) {
  mftCall_vi(i1 | 0, 2304);
  return;
 } else {
  mftCall_vi(i1 | 0, 2305);
  return;
 }
}

function __ZN10SizeModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __ZN10MemoryFile5CloseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return 1;
 i4 = i3 + 4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 if (!(HEAP32[i4 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i3, i1 + 12 | 0);
 }
 HEAP32[i2 >> 2] = 0;
 return 1;
}

function __Z64scripting_unity_engine_object_new_and_invoke_default_constructorP11Il2CppClassP6ObjectPP15Il2CppException(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = _il2cpp_object_new(i1 | 0) | 0;
 if (!i1) return i1 | 0;
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) | 0;
 _il2cpp_runtime_object_init_exception(i1 | 0, i3 | 0);
 return i1 | 0;
}

function __Z50ConfigurableJoint_Set_Custom_PropRotationDriveModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint20SetRotationDriveModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Rigidbody_Set_Custom_PropMaxDepenetrationVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody27SetMaxDepenetrationVelocityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48Texture_CUSTOM_INTERNAL_CALL_GetNativeTexturePtrP12Il2CppObjectRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i2 >> 2] = __ZN7Texture19GetNativeTexturePtrEv(i3) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientLightP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z17GetRenderSettingsv() | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z46CharacterController_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43RenderSettings_CUSTOM_INTERNAL_get_fogColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z17GetRenderSettingsv() | 0;
 i4 = HEAP32[i5 + 324 >> 2] | 0;
 i3 = HEAP32[i5 + 328 >> 2] | 0;
 i2 = HEAP32[i5 + 332 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 320 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z43Camera_CUSTOM_INTERNAL_set_projectionMatrixP12Il2CppObjectRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41MaterialPropertyBlock_CUSTOM_DestroyBlockP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 return;
}

function __Z41Animator_CUSTOM_INTERNAL_set_rootRotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator17SetAvatarRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Light_Get_Custom_PropCommandBufferCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK19RenderEventsContext21GetCommandBufferCountEv((HEAP32[i2 + 44 >> 2] | 0) + 208 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28TextMesh_Get_Custom_PropFontP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK20TextRenderingPrivate8TextMesh7GetFontEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z17SetConsoleLogPathPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1450760 >> 2] | 0, gb + 63176 | 0);
 i2 = (_strlen(i1) | 0) + 1 | 0;
 i3 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63176 | 0, 0, gb + 582853 | 0, 122) | 0;
 HEAP32[gb + 1450760 >> 2] = i3;
 _memcpy(i3 | 0, i1 | 0, i2 | 0) | 0;
 return;
}

function __Z17Projector_CleanupR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63288 | 0);
 return;
}

function __Z16TransferTextPPtrI8JSONReadEvR4PPtrI6ObjectERT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb(i2, i4, gb + 1034719 | 0, 0, 0);
 HEAP32[i1 >> 2] = HEAP32[i4 >> 2];
 STACKTOP = i3;
 return;
}

function mftCall_vifffff(i7, i1, d2, d3, d4, d5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vifffff[i7 - fb & 1](i1 | 0, Math_fround(d2), Math_fround(d3), Math_fround(d4), Math_fround(d5), Math_fround(d6));
  return;
 }
 ftCall_vifffff(i7 | 0, i1 | 0, +d2, +d3, +d4, +d5, +d6);
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP8[i3 + 8 + 3 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj(i1, i2, i5 ? HEAP32[i3 >> 2] | 0 : i3, i5 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0;
}

function __ZNKSt3__25ctypeIwE11do_scan_notEtPKwS3_(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) {
   i1 = i4;
   break;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 >= 128) break;
  if (!((HEAP16[(__ZNSt3__25ctypeIcE13classic_tableEv() | 0) + (i2 << 1) >> 1] & i3) << 16 >> 16)) break;
  i1 = i1 + 4 | 0;
 }
 return i1 | 0;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i3) {
  __ZN9Scripting30SetCachedPtrOnScriptingWrapperEP12Il2CppObjectP6Object(i1, i2);
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
  i3 = i1;
  return i3 | 0;
 } else return i3 | 0;
 return 0;
}

function __ZN5physx2Sq16BucketPrunerCore12updateObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 if (!(__ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE(i2, i1) | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 __ZN5physx2Sq16BucketPrunerCore9addObjectERKNS0_13PrunerPayloadERKNS_9PxBounds3E(i2, i1, i3) | 0;
 i3 = 1;
 return i3 | 0;
}

function __ZN4FMOD8ChannelI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868197;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN3MBP21addToOutOfBoundsArrayEj(i5, i4) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i2 = i5 + 5236 | 0;
 i3 = i5 + 5240 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) {
  __ZN5physx2Gu9Container6ResizeEj(i2, 1) | 0;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 HEAP32[i3 >> 2] = i1 + 1;
 HEAP32[(HEAP32[i5 + 5244 >> 2] | 0) + (i1 << 2) >> 2] = i4;
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 904313 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 430974 | 0, i1, 0);
 __ZN18ProceduralMaterial8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802207 | 0, i1, 0);
 __ZN18PlatformEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1039541 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800967 | 0, i1, 0);
 __ZN18BuoyancyEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN18BlockRangeInternal25GetSizeFromLastBlockRangeEP10BlockRangej(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 do {
  i1 = i1 + -1 | 0;
  if ((i1 | 0) <= -1) {
   i1 = 0;
   i4 = 5;
   break;
  }
  i2 = HEAP32[i3 + (i1 * 12 | 0) + 4 >> 2] | 0;
 } while (!(i2 | 0));
 if ((i4 | 0) == 5) return i1 | 0;
 i4 = (HEAP32[i3 + (i1 * 12 | 0) >> 2] | 0) + i2 | 0;
 return i4 | 0;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 863942 | 0, i1, 0);
 __ZN18AudioMixerSnapshot8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17PersistentManager26GetStreamNameSpaceInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN17PersistentManager26GetStreamNameSpaceInternalEi(i2, i1) | 0;
 return i2 | 0;
}

function __ZN16ReflectionProbes14BlurProbeFacesEP15ReflectionProbei(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = i3 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i3) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 __ZN13ProbeRenderer8ConvolveEbijjb(i1, 1, i4, 1, 1, 0);
 return;
}

function __ZN16CircleCollider2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13b2DynamicTree12DestroyProxyEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZN13b2DynamicTree10RemoveLeafEi(i1, i2);
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 + (i2 * 36 | 0) + 20 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + (i2 * 36 | 0) + 32 >> 2] = -1;
 HEAP32[i3 >> 2] = i2;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 945895 | 0, i1, 0);
 __ZN13TextRendering4Font8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager29connectionDeallocationHandlerEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 204 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = (HEAP32[i2 + 20 >> 2] | 0) + 8 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN12TextureInput8GetImageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) return i2 | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(20, gb + 63736 | 0, 16, gb + 432191 | 0, 171) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 return i2 | 0;
}

function __ZN11BoxCollider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 36 | 0;
 if (HEAP32[i3 >> 2] | 0) {
  __ZN11BoxCollider7SetSizeERK8Vector3f(i1, i1 + 72 | 0);
  if (HEAP32[i3 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483645);
 }
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN11AudioSource24SetSpatializePostEffectsEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i3 + 423 | 0;
 if ((i1 & 1 | 0) == (HEAPU8[i2 >> 0] | 0 | 0)) i1 = 0; else {
  HEAP8[i2 >> 0] = i1 & 1;
  i1 = 1;
 }
 if (!(HEAP32[i3 + 540 >> 2] | 0)) {
  if (!i1) return;
 } else __ZN11AudioSource12ApplyFiltersEv(i3);
 __ZN11AudioSource27ForceRolloffCurveEvaluationEv(i3);
 return;
}

function __Z46RenderTexture_CUSTOM_Internal_SetSRGBReadWriteP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture16SetSRGBReadWriteEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46AnimatorControllerPlayable_CUSTOM_PlayInternal9HPlayableRS_iif(i1, i2, i3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) return;
 __ZN26AnimatorControllerPlayable9GotoStateEiifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i4, i3, f5, Math_fround(0.0), Math_fround(0.0));
 return;
}

function __Z45CharacterJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity14CharacterJoint18SetProjectionAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44SurfaceEffector2D_Set_Custom_PropUseFrictionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D14SetUseFrictionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AudioSource_Set_Custom_PropBypassReverbZonesP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource20SetBypassReverbZonesEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AreaEffector2D_Set_Custom_PropUseGlobalAngleP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D17SetUseGlobalAngleEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Canvas_Set_Custom_PropRenderModeP12Il2CppObjectN2UI6Canvas10RenderModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas13SetRenderModeENS0_10RenderModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Shader_CUSTOM_SetGlobalFloatif(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 4 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i4 >> 2] = HEAP32[i5 >> 2];
 __Z20SetShaderGlobalFloatN9ShaderLab16FastPropertyNameEf(i4, f2);
 STACKTOP = i3;
 return;
}

function mftCall_iiififf(i7, i1, i2, d3, i4, d5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiififf[i7 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5), Math_fround(d6)) | 0;
 return ftCall_iiififf(i7 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5, +d6) | 0;
}

function mftCall_iifiiff(i7, i1, d2, i3, i4, d5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifiiff[i7 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, Math_fround(d5), Math_fround(d6)) | 0;
 return ftCall_iifiiff(i7 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, +d5, +d6) | 0;
}

function _empty_output_buffer(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i3 = i2 + 24 | 0;
 if ((_fwrite(HEAP32[i3 >> 2] | 0, 1, 4096, HEAP32[i2 + 20 >> 2] | 0) | 0) != 4096) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i4 + 20 >> 2] = 37;
  mftCall_vi(HEAP32[i4 >> 2] | 0, i1 | 0);
 }
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = 4096;
 return 1;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZNK28RectTransformPropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = HEAP32[gb + 44296 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3, _strlen(i3) | 0);
 return;
}

function __ZNK14VertexDataInfo14GetStreamIndexE13ShaderChannel(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = 1 << i1;
 if (HEAP32[i2 + 32 >> 2] & i1 | 0) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP32[i2 + 44 >> 2] & i1 | 0) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 56 >> 2] & i1)) return ((HEAP32[i2 + 68 >> 2] & i1 | 0) == 0 ? -1 : 3) | 0; else {
  i2 = 2;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148580 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff(i5, f4, f3) {
 i5 = i5 | 0;
 f4 = Math_fround(f4);
 f3 = Math_fround(f3);
 var i1 = 0, i2 = 0;
 i1 = i5 + 312 | 0;
 i2 = i5 + 316 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f4) if (Math_fround(HEAPF32[i2 >> 2]) == f3) return;
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i2 >> 2] = f3;
 HEAP32[i5 + 540 >> 2] = 0;
 return;
}

function __ZN5physx20InternalTriangleMesh16allocateVerticesEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i2 >> 2] = i1;
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i3, (i1 * 12 | 0) + 12 | 0, gb + 724949 | 0, 167) | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 STACKTOP = i3;
 return i1 | 0;
}

function __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 89572 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i2 + 8 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 __ZdlPv(i2);
 return;
}

function __ZN4FMOD7ReverbI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868197;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17PersistentManager24ResetHighestFileIDAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 1) | 0;
 if ((i1 | 0) == -1) return;
 i2 = (HEAP32[i2 + 4 >> 2] | 0) + (i1 * 24 | 0) + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __ZN15PointEffector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12PhysXRaycast26GetGameObjectForRaycastHitERK10RaycastHit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i2) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = HEAP32[i2 + 28 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEventC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 190148 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN10GameObject21WillDestroyGameObjectEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 + 56 >> 2] = 16;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i3 = HEAP32[i2 + 40 >> 2] | 0;
 i2 = i1 + (i3 << 3) | 0;
 if (!i3) return;
 do {
  i3 = HEAP32[i1 + 4 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN10AudioMixerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 174168 + 8;
 i2 = i1 + 48 | 0;
 if ((HEAP32[i1 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 52 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_highAngularXLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 160 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z52WebCamTexture_Get_Custom_PropVideoVerticallyMirroredP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 220 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51NavMeshObstacle_Set_Custom_PropCarvingMoveThresholdP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle16SetMoveThresholdEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51AnimatorControllerPlayable_CUSTOM_CrossFadeInternalR9HPlayableifif(i1, i2, f3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 __ZN26AnimatorControllerPlayable9GotoStateEiifff(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i4, i2, f5, f3, Math_fround(0.0));
 return;
}

function __Z45Rigidbody_CUSTOM_INTERNAL_set_angularVelocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody18SetAngularVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody12MoveRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Camera_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37TextMesh_Set_Custom_PropCharacterSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh16SetCharacterSizeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Animator_Set_Custom_PropUpdateModeP12Il2CppObjectN8Animator10UpdateModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator13SetUpdateModeENS_10UpdateModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Font_Set_Custom_PropMaterialP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 40 >> 2] = __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27GUIText_Get_Custom_PropFontP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK20TextRenderingPrivate7GUIText7GetFontEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = i3 + 36 | 0;
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i3, gb + 1112784 | 0, i1, 0);
 __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE(i3, gb + 1112788 | 0, i2, 0);
 return;
}

function _UNITY_png_calloc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 if (!i3) _UNITY_png_error(i2, gb + 1030621 | 0);
 i1 = HEAP32[i2 + 608 >> 2] | 0;
 if (!i1) i1 = _malloc(i3) | 0; else i1 = mftCall_iii(i1 | 0, i2 | 0, i3 | 0) | 0;
 if (!i1) _UNITY_png_error(i2, gb + 1030621 | 0);
 _memset(i1 | 0, 0, i3 | 0) | 0;
 i3 = i1;
 return i3 | 0;
}

function _tcsetattr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 if (i2 >>> 0 > 2) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 } else {
  HEAP32[i4 >> 2] = i3;
  i1 = _ioctl(i1, i2 + 21506 | 0, i4) | 0;
 }
 STACKTOP = i5;
 return i1 | 0;
}

function _cff_cmap_unicode_init(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = HEAP32[i1 + 656 >> 2] | 0;
 if (!(HEAP32[i2 + 1160 >> 2] | 0)) {
  i3 = 163;
  return i3 | 0;
 }
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i2 + 2956 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0, i3 | 0, HEAP32[i2 + 12 >> 2] | 0, fb + 1096 | 0, 0, i1 | 0) | 0;
 return i3 | 0;
}

function __ZNSt3__213__vector_baseINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) {
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  while (1) {
   if ((i2 | 0) == (i3 | 0)) break;
   i4 = i2 + -8 | 0;
   HEAP32[i1 >> 2] = i4;
   i2 = i4;
  }
  __ZdlPv(i3);
 }
 return;
}

function __ZNK8Animator26ShouldInterruptMatchTargetEv(i1) {
 i1 = i1 | 0;
 if (Math_fround(HEAPF32[i1 + 364 >> 2]) >= Math_fround(0.0)) {
  if (__ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi(HEAP32[i1 + 624 >> 2] | 0, 0) | 0) {
   i1 = 1;
   return i1 | 0;
  }
  if (!(__ZNK8Animator20IsInMatchTargetStateEv(i1) | 0)) {
   i1 = 1;
   return i1 | 0;
  }
 }
 i1 = 0;
 return i1 | 0;
}

function __ZN9Scripting29GetFirstNonGenericParentClassEP11Il2CppClassS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if ((i2 | 0) == (i1 | 0)) i1 = i2; else while (1) {
  if (!(__Z26scripting_class_is_genericP11Il2CppClass(i1) | 0)) break L1;
  i1 = __Z26scripting_class_get_parentP11Il2CppClass(i1) | 0;
  if ((i1 | 0) == (i2 | 0)) {
   i1 = i2;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __ZN8VRDevice6EndEyeEPK6Camerai(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) return;
 HEAP32[i1 + 316 >> 2] = -1;
 i2 = __Z12GetGfxDevicev() | 0;
 __ZN9GfxDevice18SetStereoActiveEyeE15StereoscopicEye(i2, 0);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 860 >> 2] | 0, i2 | 0, 1, i3 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148896 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd10ThreadImplC2EPFPvS2_ES2_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i3 + 24 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 HEAP32[i3 + 28 >> 2] = 0;
 __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE(i3, 0, 0);
 return;
}

function __ZN5physx2Sc9ShapeCore24resolveMaterialReferenceEjt(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) HEAP16[i3 + 66 >> 1] = i1;
 switch (HEAP32[i3 + 68 >> 2] | 0) {
 case 6:
  {
   HEAP16[(HEAP32[i3 + 96 >> 2] | 0) + (i2 << 1) >> 1] = i1;
   return;
  }
 case 5:
  {
   HEAP16[(HEAP32[i3 + 116 >> 2] | 0) + (i2 << 1) >> 1] = i1;
   return;
  }
 default:
  return;
 }
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx24PxDefaultMemoryInputData4readEPvj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i3 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = (HEAP32[i3 + 4 >> 2] | 0) - i5 | 0;
 i1 = i6 >>> 0 > i1 >>> 0 ? i1 : i6;
 _memcpy(i2 | 0, (HEAP32[i3 + 8 >> 2] | 0) + i5 | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
 return i1 | 0;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 738002 | 0, i1, 0);
 __ZN5Unity11SpringJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 803070 | 0, i1, 0);
 __ZN17SurfaceEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 431704 | 0, i1, 0);
 __ZN17ProceduralTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801731 | 0, i1, 0);
 __ZN17Physics2DSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 863974 | 0, i1, 0);
 __ZN17AudioReverbFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 853401 | 0, i1, 0);
 __ZN17AudioChorusFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14AreaEffector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12WWWDelayCallD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i3 = i1 + 76 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!((i1 | 0) == 0 | (HEAP32[i3 >> 2] | 0) != 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 mftCall_ii(i1 | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 return;
}

function __Z56AnimatorControllerPlayable_CUSTOM_GetLayerWeightInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  f3 = Math_fround(-1.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(__ZN26AnimatorControllerPlayable14GetLayerWeightEi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2));
 return Math_fround(f3);
}

function __Z54ConfigurableJoint_CUSTOM_INTERNAL_get_lowAngularXLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 148 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47WheelCollider_Set_Custom_PropSuspensionDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider21SetSuspensionDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47SurfaceEffector2D_Set_Custom_PropSpeedVariationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D17SetSpeedVariationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47BuoyancyEffector2D_Set_Custom_PropFlowVariationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D16SetFlowVariationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47BuoyancyEffector2D_Set_Custom_PropFlowMagnitudeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D16SetFlowMagnitudeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Mesh_CUSTOM_PrintErrorBadSubmeshIndexTrianglesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547051 | 0, 0, gb + 546865 | 0, 106, 1, i1, 0, 0);
 return;
}

function __Z44NavMeshObstacle_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle11SetVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43PlatformEffector2D_Set_Custom_PropUseOneWayP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D12SetUseOneWayEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Canvas_Set_Custom_PropOverridePixelPerfectP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas23SetOverridePixelPerfectEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Motion_Get_Custom_PropAverageDurationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function mftCall_viffffi(i7, i1, d2, d3, d4, d5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viffffi[i7 - fb & 1](i1 | 0, Math_fround(d2), Math_fround(d3), Math_fround(d4), Math_fround(d5), i6 | 0);
  return;
 }
 ftCall_viffffi(i7 | 0, i1 | 0, +d2, +d3, +d4, +d5, i6 | 0);
}

function _t1_hints_funcs_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 24 | 0;
 do {
  HEAP8[i2 >> 0] = 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 + 4 >> 2] = fb + 3860;
 HEAP32[i1 + 8 >> 2] = fb + 1082;
 HEAP32[i1 + 12 >> 2] = fb + 968;
 HEAP32[i1 + 16 >> 2] = fb + 969;
 HEAP32[i1 + 20 >> 2] = fb + 4203;
 HEAP32[i1 + 24 >> 2] = fb + 187;
 return;
}

function _iconv_open(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = _find_charmap(i1) | 0;
 if ((i3 | 0) == -1) i4 = 4; else {
  i1 = _find_charmap(i2) | 0;
  if ((i1 | 0) == -1) i4 = 4; else if ((HEAPU8[gb + 1069354 + i3 >> 0] | 0) > 207) i4 = 4; else i1 = i1 << 16 | i3;
 }
 if ((i4 | 0) == 4) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj(i1, i2, i5 ? HEAP32[i3 >> 2] | 0 : i3, i5 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0;
}

function __ZNK9ShaderLab7Program26FindBestMatchingSubProgramERK16ShaderKeywordSet(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = __ZN9ShaderLab32FindBestMatchingShaderKeywordSetERK16ShaderKeywordSetRK13dynamic_arrayIS0_Lj4EEPS5_(i1, i2 + 28 | 0, i2 + 172 | 0) | 0;
 if ((i1 | 0) <= -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZNK5physx7NpShape17getSphereGeometryERNS_16PxSphereGeometryE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 116 | 0;
 if (HEAP32[i1 >> 2] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 if (HEAP32[i2 + 36 >> 2] & 1) i1 = (HEAP32[i2 + 40 >> 2] | 0) + 56 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 i3 = 1;
 return i3 | 0;
}

function __ZNK5physx12NpConstraint8getForceERNS_6PxVec3ES2_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 100 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 104 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 108 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 + 112 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 116 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 120 >> 2];
 return;
}

function __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNK19SkinnedMeshRenderer25DoesQualifyForGPUSkinningEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 504 >> 2] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 508 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP8[(__Z17GetPlayerSettingsv() | 0) + 414 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 511 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZN9Heightmap14RecreateShapesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 68 >> 2] | 0;
 i3 = i1 + 64 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = HEAP32[i4 + 8 >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 144 >> 2] | 0, i4 | 0, 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx33PxJointLinearLimitGeneratedValuesC2EPKNS_18PxJointLinearLimitE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 return;
}

function __ZN5physx2Sc13ShapeIterator7getNextEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if (!i1) {
   i1 = 0;
   i4 = 5;
   break;
  }
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i3 >> 2] = i2;
  if (0 == 0 ? (HEAP32[i1 + 12 >> 2] & -1073741824 | 0) == 0 : 0) break; else i1 = i2;
 }
 if ((i4 | 0) == 5) return i1 | 0;
 i4 = i1;
 return i4 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx26PxAggregateGeneratedValuesC2EPKNS_11PxAggregateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
 HEAP8[i2 + 4 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0) & 1;
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN4FMOD7SystemI20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869359;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17TransformInternal23AllocateTransformThreadER18TransformHierarchyjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (HEAP32[i3 + 68 >> 2] | 0) + (i2 << 2) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 4 >> 2] = i2;
 if ((i2 | 0) == -1) {
  HEAP32[i1 >> 2] = -1;
  return;
 }
 HEAP32[(HEAP32[i3 + 72 >> 2] | 0) + (i2 << 2) >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 return;
}

function __ZN17PolygonCollider2D15CreatePrimitiveEi8Vector2fS0_b(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = i1 + 160 | 0;
 __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_(i6, i2, i3, i4);
 if (!i5) return;
 __ZN9Polygon2D16CheckConsistencyEv(i6);
 __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(i1, 1, 0);
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1048432 | 0, i1, 0);
 __ZN16ParticleRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1048111 | 0, i1, 0);
 __ZN16ParticleAnimator8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1037316 | 0, i1, 0);
 __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15QualitySettings24SetParticleRaycastBudgetEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN14RenderSettings17SetFlareFadeSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 HEAPF32[i1 + 308 >> 2] = f2;
 i4 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  __ZN5Light10SetupFlareEv(i1 + -36 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN13UnityProfiler19RecordPreviousFrameE12ProfilerMode(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 1 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 __ZN11GPUProfiler8EndFrameEv();
 if (HEAP32[i2 + 24 >> 2] & i1 | 0) __ZN13UnityProfiler11SetIsActiveEb(i2, 0);
 __ZN13UnityProfiler8EndFrameEv(i2);
 HEAP8[i3 >> 0] = 0;
 return;
}

function __ZN13GfxDeviceGLES15SetBackfaceModeEb(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3 + 7184 | 0;
 if ((HEAPU8[i2 >> 0] | 0) == (i1 & 1 | 0)) return;
 i4 = i1 & 1;
 HEAP8[i2 >> 0] = i4;
 i1 = HEAP32[i3 + 4688 >> 2] | 0;
 if (i4 << 24 >> 24 == (HEAP8[i3 + 4381 >> 0] | 0)) {
  mftCall_vi(i1 | 0, 2304);
  return;
 } else {
  mftCall_vi(i1 | 0, 2305);
  return;
 }
}

function __ZN13BoxCollider2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 | 0) return;
 }
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN12_GLOBAL__N_110Connection11isConnectedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0);
 return i1 | 0;
}

function __Z49AudioLowPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK18AudioLowPassFilter18GetCutoffFrequencyEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47Canvas_Get_Custom_PropNormalizedSortingGridSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK2UI6Canvas30GetSortingBucketNormalizedSizeEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45CharacterController_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN19CharacterController4MoveERK8Vector3f(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41CanvasGroup_Set_Custom_PropBlocksRaycastsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI11CanvasGroup17SetBlocksRaycastsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40TrailRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 192 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Joint_Set_Custom_PropEnablePreprocessingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Joint22SetEnablePreprocessingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z3absRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(Math_abs(Math_fround(HEAPF32[i2 >> 2])));
 f4 = Math_fround(Math_abs(Math_fround(HEAPF32[i2 + 4 >> 2])));
 f3 = Math_fround(Math_abs(Math_fround(HEAPF32[i2 + 8 >> 2])));
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(Math_abs(Math_fround(HEAPF32[i2 + 12 >> 2]))));
 return;
}

function __Z39SliderJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D8SetMotorERK12JointMotor2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37HingeJoint_CUSTOM_INTERNAL_set_springP12Il2CppObjectRK11JointSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint9SetSpringERK11JointSpring(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37HingeJoint_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK11JointLimits(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint9SetLimitsERK11JointLimits(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Motion_Get_Custom_PropApparentSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Canvas_Get_Custom_PropRenderOrderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN2UI13CanvasManager14GetRenderOrderEPKNS_6CanvasE(__ZN2UI16GetCanvasManagerEv() | 0, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32TextMesh_Set_Custom_PropRichTextP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh11SetRichTextEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32LODGroup_Set_Custom_PropFadeModeP12Il2CppObjectN8LODGroup11LODFadeModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8LODGroup11SetFadeModeENS_11LODFadeModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function mftCall_iiiiiff(i7, i1, i2, i3, i4, d5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiff[i7 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5), Math_fround(d6)) | 0;
 return ftCall_iiiiiff(i7 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5, +d6) | 0;
}

function mftCall_iiiffii(i7, i1, i2, d3, d4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiffii[i7 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), Math_fround(d4), i5 | 0, i6 | 0) | 0;
 return ftCall_iiiffii(i7 | 0, i1 | 0, i2 | 0, +d3, +d4, i5 | 0, i6 | 0) | 0;
}

function _unity_z_inflateBackEnd(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (!i1) {
  i4 = -2;
  return i4 | 0;
 }
 i2 = i1 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i4 = -2;
  return i4 | 0;
 }
 i4 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i4) {
  i4 = -2;
  return i4 | 0;
 }
 mftCall_vii(i4 | 0, HEAP32[i1 + 40 >> 2] | 0, i3 | 0);
 HEAP32[i2 >> 2] = 0;
 i4 = 0;
 return i4 | 0;
}

function _unity_z_deflateBound(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 11 + ((i2 + 7 | 0) >>> 3) + ((i2 + 63 | 0) >>> 6) | 0;
 if (!i1) return i3 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return i3 | 0;
 if ((HEAP32[i1 + 48 >> 2] | 0) != 15) return i3 | 0;
 if ((HEAP32[i1 + 80 >> 2] | 0) != 15) return i3 | 0;
 i3 = _unity_z_compressBound(i2) | 0;
 return i3 | 0;
}

function _jinit_input_controller(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 0, 24) | 0;
 HEAP32[i1 + 400 >> 2] = i2;
 HEAP32[i2 >> 2] = fb + 1558;
 HEAP32[i2 + 4 >> 2] = fb + 3269;
 HEAP32[i2 + 8 >> 2] = fb + 3270;
 HEAP32[i2 + 12 >> 2] = fb + 3271;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP8[i2 + 17 >> 0] = 0;
 HEAP8[i2 + 20 >> 0] = 1;
 return;
}

function __ZZL31InitializeAudioManagerCallbacksvEN39PostLateUpdateUpdateVideoTexturesstruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = __Z9GetIAudiov() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateUpdateAllSkinnedMeshesstruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0)) return;
 __ZN19SkinnedMeshRenderer22UpdateAllSkinnedMeshesENS_10UpdateTypeEP13dynamic_arrayIPS_Lj4EE(1, 0);
 return;
}

function __ZNKSt3__25ctypeIwE5do_isEPKwS3_Pt(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 while (1) {
  if ((i3 | 0) == (i4 | 0)) break;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAPU16[(__ZNSt3__25ctypeIcE13classic_tableEv() | 0) + (i1 << 1) >> 1] | 0; else i1 = 0;
  HEAP16[i2 >> 1] = i1;
  i2 = i2 + 2 | 0;
  i3 = i3 + 4 | 0;
 }
 return i4 | 0;
}

function __ZNK15TextureSettings8GetAnisoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(HEAP32[i1 >> 2] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[gb + 56192 >> 2] | 0;
 if ((i2 | 0) < (i1 | 0)) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = HEAP32[gb + 56196 >> 2] | 0;
 i2 = (i2 | 0) > (i1 | 0) ? i1 : i2;
 return i2 | 0;
}

function __ZN9WWWCached17SetThreadPriorityE14ThreadPriority(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 HEAP32[i1 + 60 >> 2] = i3;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i3 | 0);
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN9UdpSocket4SendEPKvjP8sockaddrj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 24 >> 2] = i4;
 HEAP32[i1 + 28 >> 2] = i5;
 i1 = _sendto(HEAP32[i1 + 4 >> 2] | 0, i2, i3, HEAP32[i1 + 20 >> 2] | HEAP32[i1 + 8 >> 2], i4, i5) | 0;
 if ((i1 | 0) < 0) return i1 | 0;
 HEAP32[(___errno_location() | 0) >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149600 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx28PxClothFabricGeneratedValuesC2EPKNS_13PxClothFabricE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 8) __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15setActorSimFlagEb(i2, i3);
 __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5physx14NpSpatialIndex6removeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i4 | 0, 1);
 HEAP8[i2 + 4 >> 0] = 1;
 STACKTOP = i3;
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 736306 | 0, i1, 0);
 __ZN5Unity10HingeJoint8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5Umbra11PatchWriter6finishEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i1 + 8 >> 0] = 1;
 HEAP32[i3 >> 2] = -2;
 i1 = HEAP32[i1 >> 2] | 0;
 i1 = (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0, 12) | 0) == 12;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN5Light15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30512 | 0, gb + 1105016 | 0, fb + 496 | 0, 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 374193 | 0, gb + 378131 | 0, gb + 374342 | 0);
 __Z40InitializeLightAnimationBindingInterfacev();
 return;
}

function __ZN4FMOD4DSPI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868197;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1011618 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 590196 | 0, i1, 0);
 __ZN2UI13RectTransform8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN26AnimatorControllerPlayable19DeallocateResourcesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 72 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i3 = i1 + 84 | 0;
  if (HEAP32[i3 >> 2] | 0) {
   HEAP32[i3 >> 2] = 0;
   __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i1);
   HEAP8[i1 + 152 >> 0] = 0;
  }
 }
 HEAP8[i2 >> 0] = 0;
 __ZN8Playable19DeallocateResourcesEv(i1);
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 402133 | 0, i1, 0);
 __ZN16LightmapSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 373756 | 0, i1, 0);
 __ZN16GraphicsSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14RenderSettings16SetFlareStrengthEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 HEAPF32[i1 + 304 >> 2] = f2;
 i4 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  __ZN5Light10SetupFlareEv(i1 + -36 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __ZN14Physics2DState12DestroyWorldEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 __ZN7b2World11DestroyBodyEP6b2Body(HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZN7b2WorldD2Ev(i2);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13MemoryManager16FrameMaintenanceEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = i2 + 1544 | 0;
 if ((HEAP32[i4 >> 2] | 0) > 0) i1 = 0; else return;
 do {
  i5 = HEAP32[i2 + 1568 + (i1 << 2) >> 2] | 0;
  mftCall_vii(HEAP32[(HEAP32[i5 >> 2] | 0) + 76 >> 2] | 0, i5 | 0, i3 | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i4 >> 2] | 0));
 return;
}

function __ZN11Rigidbody2D7SetDragEf(i3, f1) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i2 = 0, i4 = 0;
 i2 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i2 ? Math_fround(0.0) : f1;
 HEAPF32[i3 + 36 >> 2] = f1;
 i2 = HEAP32[i3 + 92 >> 2] | 0;
 if (!i2) return;
 if (HEAP8[i3 + 226 >> 0] | 0) return;
 HEAPF32[i2 + 132 >> 2] = f1;
 return;
}

function __ZL30RegisterFilteredObjectCallbackPP12Il2CppObjectiPv(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 if ((i3 | 0) > 0) i1 = 0; else return;
 do {
  __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(__ZN9Scripting16GetInstanceIDForEP12Il2CppObject(HEAP32[i2 + (i1 << 2) >> 2] | 0) | 0, i4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __Z6selectRK8Scalar4fS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 __ZeoRK8Scalar4fS1_(i7, i3, i4);
 __ZanRK8Scalar4fS1_(i6, i7, i2);
 __ZeoRK8Scalar4fS1_(i1, i6, i4);
 STACKTOP = i5;
 return;
}

function __Z56CharacterController_Get_Custom_PropEnableOverlapRecoveryP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN19CharacterController24GetEnableOverlapRecoveryEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50TerrainData_CUSTOM_NeedUpgradeScaledTreePrototypesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK12TreeDatabase27NeedUpgradeScaledPrototypesEv(i2 + 84 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46RelativeJoint2D_Set_Custom_PropCorrectionScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15RelativeJoint2D18SetCorrectionScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46BuoyancyEffector2D_Set_Custom_PropSurfaceLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D15SetSurfaceLevelEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45Renderer_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Renderer19SetLightmapIndexIntEi12LightmapType(i3, i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45NavMeshAgent_CUSTOM_INTERNAL_set_nextPositionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent11SetPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45AnimationClipPlayable_CUSTOM_GetAnimationClipR9HPlayable(i1) {
 i1 = i1 | 0;
 if (__Z22PlayableValidityChecksRK9HPlayable(i1) | 0) {
  i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 164 >> 2] | 0) | 0;
  return i1 | 0;
 } else {
  i1 = __ZN9Scripting19ScriptingWrapperForEP6Object(0) | 0;
  return i1 | 0;
 }
 return 0;
}

function __Z44Mesh_CUSTOM_PrintErrorBadSubmeshIndexIndicesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 547109 | 0, 0, gb + 546865 | 0, 119, 1, i1, 0, 0);
 return;
}

function __Z42SurfaceEffector2D_Set_Custom_PropUseBounceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D12SetUseBounceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42ReflectionProbe_CUSTOM_IsFinishedRenderingP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN15ReflectionProbe19IsFinishedRenderingEi(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42NavMeshAgent_Set_Custom_PropUpdateRotationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent17SetUpdateRotationEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39LineRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 344 >> 2] | 0) + 192 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Screen_Set_Custom_PropFullScreenh(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z16GetScreenManagerv() | 0;
 i2 = i1 << 24 >> 24 != 0;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if ((i1 | 0) == -1) i1 = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0) | 0; else i1 = (i1 | 0) == 1;
 if (!(i2 ^ i1)) return;
 __ZN13ScreenManager20RequestSetFullscreenEb(i3, i2);
 return;
}

function __Z32NavMeshAgent_CUSTOM_SetLayerCostP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN12NavMeshAgent11SetAreaCostEjf(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30MeshFilter_Get_Custom_PropMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN10MeshFilter19GetInstantiatedMeshEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26Object_Get_Custom_PropNameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __Z20scripting_string_newPKc(mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z22assign_allocation_rootPvjRK10MemLabelIdPKcS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[gb + 1163236 >> 2] | 0;
 __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_(i6, i1, i2, __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i3) | 0, i4, i5);
 return;
}

function __Z13VFormatBufferPciPKcz(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0, i7 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5 + 16 | 0;
 i7 = i5;
 HEAP32[i7 >> 2] = i4;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 i4 = _vsnprintf(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_png_read_filter_row_up(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0, i5 = 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i5) return; else {
  i3 = 0;
  i1 = i4;
 }
 while (1) {
  HEAP8[i2 >> 0] = (HEAPU8[i1 >> 0] | 0) + (HEAPU8[i2 >> 0] | 0);
  i3 = i3 + 1 | 0;
  if ((i3 | 0) == (i5 | 0)) break; else {
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function ___cos(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0, d6 = 0.0;
 d3 = d1 * d1;
 d4 = d3 * d3;
 d5 = d3 * .5;
 d6 = 1.0 - d5;
 return +(d6 + (1.0 - d6 - d5 + (d3 * (d3 * (d3 * (d3 * 2.480158728947673e-05 + -.001388888888887411) + .0416666666666666) + d4 * d4 * (d3 * (2.087572321298175e-09 - d3 * 1.1359647557788195e-11) + -2.7557314351390663e-07)) - d1 * d2)));
}

function __ZNSt3__26localeC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __THREW__ = 0;
 i2 = invoke_i(fb + 322 | 0) | 0;
 i3 = __THREW__;
 __THREW__ = 0;
 if (i3 & 1) {
  i3 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i3);
 } else {
  i3 = HEAP32[i2 >> 2] | 0;
  HEAP32[i1 >> 2] = i3;
  __ZNSt3__214__shared_count12__add_sharedEv(i3);
  return;
 }
}

function __ZNSt3__212strstreambufC2EPhiS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, i4);
 return;
}

function __ZNSt3__212strstreambufC2EPciS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, i4);
 return;
}

function __ZNSt3__212strstreambufC2EPaiS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, i4);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = (HEAP32[i2 >> 2] | 0) - i3 >> 2;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj(i1, i2, 1) | 0;
 return i3 + (i2 << 2) | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7crbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + (i1 << 2) | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNK27AnimatorControllerParameter14GetDefaultBoolEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 16 >> 2] | 0) {
 case 9:
 case 4:
  {
   i1 = (HEAP8[i1 + 28 >> 0] | 0) != 0;
   return i1 | 0;
  }
 default:
  {
   __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911896 | 0, 0, gb + 911526 | 0, 133, 1, 0, 0, 0);
   i1 = 0;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZN8Collider22CreatePhysXObjIfNeededEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP32[i1 + 36 >> 2] | 0) return;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN7mecanim8skeleton19DestroySkeletonMaskEPNS0_12SkeletonMaskERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn5ConvX8convert8EPKcRKNS0_15PxMetaDataEntryES6_(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP8[i4 + 325 >> 0] | 0) return;
 i1 = HEAP32[i4 + 304 >> 2] | 0;
 i3 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i2 + 12 >> 2] | 0) | 0;
 i4 = i4 + 312 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i3;
 return;
}

function __ZN5physx2Cm8PtrTable15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 4 | 0;
 if ((HEAPU16[i1 >> 1] | 0) <= 1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i3 >> 2] | 0, (HEAPU16[i1 >> 1] | 0) << 2 | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx10PxsContext14updateDynamicsEfPNS_10PxBaseTaskERNS_18PxsMaterialManagerE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(HEAPF32[i2 + 64 >> 2]), HEAP32[i1 + 12 >> 2] | 0, i2);
 return;
}

function __ZN5physx24PxsParticleSystemBatcherC2ERNS_10PxsContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Cm10FanoutTaskC2EPKc(i2, gb + 718490 | 0);
 __ZN5physx2Cm10FanoutTaskC2EPKc(i2 + 92 | 0, gb + 718525 | 0);
 __ZN5physx2Cm10FanoutTaskC2EPKc(i2 + 184 | 0, gb + 718563 | 0);
 __ZN5physx2Cm10FanoutTaskC2EPKc(i2 + 276 | 0, gb + 718598 | 0);
 HEAP32[i2 + 368 >> 2] = i1;
 return;
}

function __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 + 56 >> 2] | 0;
 if ((HEAP32[i3 + 8 >> 2] | 0) == (i2 | 0)) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 if ((HEAP32[i3 + 12 >> 2] | 0) != (i2 | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 1);
 return;
}

function __ZN4FMOD7SystemI20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869285;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI17set3DConeSettingsEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 858972;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI11setDefaultsEfffi(i1, f2, f3, f4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868863;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN3MBP8finalizeEPN5physx16PxsBroadPhaseMBPE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 80 | 0;
 __ZN15MBP_PairManager17removeMarkedPairsEPK10MBP_ObjectPN5physx16PxsBroadPhaseMBPERK8BitArrayS8_(i2 + 52 | 0, HEAP32[i2 + 44 >> 2] | 0, i1, i3, i2 + 88 | 0) | 0;
 _memset(HEAP32[i3 >> 2] | 0, 0, HEAP32[i2 + 84 >> 2] << 2 | 0) | 0;
 return HEAP32[i2 + 60 >> 2] | 0;
}

function __ZN22BuiltinResourceManager16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63528 | 0, 16, gb + 451357 | 0, 1145) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[gb + 1162852 >> 2] = i1;
 HEAP8[gb + 1546595 >> 0] = 0;
 return;
}

function __ZN16SpriteRenderDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP32[i3 >> 2] | 0)) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63744 | 0);
 }
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15QualitySettings22SetAnisotropicTexturesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 68 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN15QualitySettings10SetLODBiasEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 84 | 0;
 if (Math_fround(HEAPF32[i3 >> 2]) == f2) return;
 HEAPF32[i3 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1047963 | 0, i1, 0);
 __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14PhysicsManager21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5Unity12PhysicsQuery21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction(i1 + 736 | 0, i2, i3, f4, i5, i6) | 0;
}

function __ZN14PhysicsManager21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction(i1, i2, f3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return __ZN5Unity12PhysicsQuery21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction(i1 + 736 | 0, i2, f3, i4, i5, i6, i7) | 0;
}

function __ZN14ParticleSystem18SetGravityModifierEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 2356 >> 2] = f2;
 HEAP8[i1 + 2362 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2276 | 0, i1 + 2364 | 0, f2, HEAP16[i1 + 2360 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN13RuntimeStaticI17UniqueIDGeneratorE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if (i2 | 0) if ((HEAP32[i2 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i2 + 4 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i3);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_110DataStream7releaseEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  i2 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = i2;
  if (i2 | 0) return;
 }
 i2 = HEAP32[i3 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN12AudioManager23OnEnterPlayModePreStartEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 68 | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 120 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN11AudioSource13SetSpatializeEb(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 422 | 0;
 if ((i3 & 1 | 0) == (HEAPU8[i1 >> 0] | 0 | 0)) i1 = 0; else {
  HEAP8[i1 >> 0] = i3 & 1;
  i1 = 1;
 }
 if ((HEAP32[i2 + 540 >> 2] | 0) != 0 ^ i3) __ZN11AudioSource16CreateFMODGroupsEv(i2); else if (!i1) return;
 __ZN11AudioSource27ForceRolloffCurveEvaluationEv(i2);
 return;
}

function __ZL30InitializeGlobalNameConversionPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(16, gb + 63416 | 0, 16, gb + 468995 | 0, gb + 1576256 | 0, gb + 469031 | 0, 90) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP8[i1 + 12 >> 0] = 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1166132 >> 2] = i1;
 return;
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularZLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 192 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularYLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 180 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Rigidbody_Get_Custom_PropMaxDepenetrationVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN9Rigidbody27GetMaxDepenetrationVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47ConfigurableJoint_Set_Custom_PropProjectionModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetProjectionModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ConfigurableJoint_Set_Custom_PropAngularZMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetAngularZMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ConfigurableJoint_Set_Custom_PropAngularYMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetAngularYMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ConfigurableJoint_Set_Custom_PropAngularXMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint17SetAngularXMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Transform_CUSTOM_INTERNAL_set_localPositionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform16SetLocalPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody16SetInertiaTensorERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Cloth_Set_Custom_PropWorldAccelerationScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth25SetWorldAccelerationScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42ReflectionProbe_Set_Custom_PropRefreshModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ReflectionProbe14SetRefreshModeENS_11RefreshModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42LODGroup_Set_Custom_PropAnimateCrossFadingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8LODGroup21SetAnimateCrossFadingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Camera_CUSTOM_INTERNAL_set_cullingMatrixP12Il2CppObjectRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera16SetCullingMatrixERK10Matrix4x4f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38WheelJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12WheelJoint2D8SetMotorERK12JointMotor2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38HingeJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12HingeJoint2D8SetMotorERK12JointMotor2D(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_Set_Custom_PropRolloffModeP12Il2CppObject11RolloffMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource14SetRolloffModeE11RolloffMode(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35TextMesh_Set_Custom_PropLineSpacingP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh14SetLineSpacingEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32checkOverlapCapsule_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i3, (HEAP32[i1 + 36 >> 2] | 0) + 32 | 0, i2, i1 + 4 | 0, 0) | 0;
}

function __Z32AudioMeasurement_GetTimeConstantff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 if (f2 <= Math_fround(0.0)) {
  f2 = Math_fround(1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(1.0) / f2);
 f2 = Math_fround(Math_fround(1.0) - Math_fround(_exp2f(Math_fround(f2 * Math_fround(_log2f(Math_fround(Math_fround(1.0) - f1)))))));
 return Math_fround(f2);
}

function __Z31NavMeshAgent_CUSTOM_SetAreaCostP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN12NavMeshAgent11SetAreaCostEjf(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z10IsZeroGUIDP9FMOD_GUID(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 if (HEAP32[i1 >> 2] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!((i2 & 65535) << 16 >> 16 == 0 & i2 >>> 0 < 65536)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i1 + 8 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) == 0 & (HEAP32[i2 + 4 >> 2] | 0) == 0;
 return i2 | 0;
}

function mftCall_vififfi(i7, i1, d2, i3, d4, d5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vififfi[i7 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, Math_fround(d4), Math_fround(d5), i6 | 0);
  return;
 }
 ftCall_vififfi(i7 | 0, i1 | 0, +d2, i3 | 0, +d4, +d5, i6 | 0);
}

function mftCall_iiiiiii(i7, i1, i2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 255 | 0)) return FUNCTION_TABLE_iiiiiii[i7 - fb & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
 return ftCall_iiiiiii(i7 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function __ZZN10Collider2D15InitializeClassEvEN30FunctorImpl_81kDidAddComponent4CallEPviR11MessageData(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 if ((((HEAP32[i1 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 153580 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 153580 + 28 >> 2] | 0) >>> 0) return;
 HEAP32[i3 + 156 >> 2] = i1;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + (i1 << 2) | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5physx2Sn21SerializationRegistry17getBinaryMetaDataERNS_14PxOutputStreamE(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 92 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 88 | 0;
 i2 = 0;
 do {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0, i4 | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZNK24RendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) >= (mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0) | 0)) return;
 HEAP32[(HEAP32[i3 + 288 >> 2] | 0) + (i1 << 2) >> 2] = i4;
 return;
}

function __ZNK19RuntimeSceneManager19GetLoadedSceneCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  i1 = ((HEAP32[(HEAP32[i3 + (i2 << 2) >> 2] | 0) + 80 >> 2] | 0) == 2 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZN8DateTime26FromMicrosecondsSinceEpochEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = ___udivdi3(i2 | 0, i3 | 0, 1e6, 0) | 0;
 HEAP16[i1 >> 1] = getTempRet0() | 0;
 HEAP32[i1 + 4 >> 2] = i4;
 i3 = ___uremdi3(i2 | 0, i3 | 0, 1e6, 0) | 0;
 i3 = ___muldi3(i3 | 0, getTempRet0() | 0, 10, 0) | 0;
 getTempRet0() | 0;
 HEAP16[i1 + 2 >> 1] = i3;
 return;
}

function __ZN7mecanim9animation16GetAllBlendValueEPNS0_17BlendTreeConstantER13dynamic_arrayIiLj4EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 __ZN7mecanim9animation16GetAllBlendValueEjP9OffsetPtrINS0_21BlendTreeNodeConstantEER13dynamic_arrayIiLj4EE(0, (i3 | 0) == 0 ? 0 : i3 + i1 | 0, i2);
 return;
}

function __ZN7Terrain13OnTreeUpdatedEi(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0, i4 = 0;
 i4 = i1 + 228 | 0;
 i2 = i1 + 240 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i1 = HEAP32[i4 >> 2] | 0;
 do {
  __ZN12TreeRenderer11TreeUpdatedEi(HEAP32[i1 + 8 >> 2] | 0, i3);
  i1 = i1 + 20 | 0;
 } while ((i1 | 0) != ((HEAP32[i4 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 20 | 0) | 0));
 return;
}

function __ZN6MotionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 176392 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148564 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 204 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj(i2, i1);
 HEAP32[i2 + 200 >> 2] = i1;
 return;
}

function __ZN5physx3Ext14SphericalJoint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 88776 | 0) | 0;
 return;
}

function __ZN5physx3Ext14PrismaticJoint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 88208 | 0) | 0;
 return;
}

function __ZN5physx33PxArticulationLinkGeneratedValuesC2EPKNS_18PxArticulationLinkE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx26PxRigidBodyGeneratedValuesC2EPKNS_11PxRigidBodyE(i2, i1);
 HEAP32[i2 + 148 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 + 152 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx2Gu25PersistentContactManifold12drawManifoldERKNS0_17PersistentContactERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVESC_(i3, i1, i2, i4, i5) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj(i1, i4, i5, i2, -16776961);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra12QueryContext17addQueryDebugQuadERKNS_7Vector3ES3_S3_S3_RKNS_7Vector4E(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) return;
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED0Ev(i1) {
 i1 = i1 | 0;
 __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20OcclusionCullingDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 34876 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802586 | 0, i1, 0);
 __ZN15RelativeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 380928 | 0, i1, 0);
 __ZN15ReflectionProbe8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 405349 | 0, i1, 0);
 __ZN15QualitySettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15QualitySettings21SetMasterTextureLimitEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 64 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802334 | 0, i1, 0);
 __ZN15PointEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 842436 | 0, i1, 0);
 __ZN15NavMeshObstacle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801269 | 0, i1, 0);
 __ZN15DistanceJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 733808 | 0, i1, 0);
 __ZN15CapsuleCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 864200 | 0, i1, 0);
 __ZN15AudioReverbZone8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 863848 | 0, i1, 0);
 __ZN15AudioMixerGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855573 | 0, i1, 0);
 __ZN15AudioEchoFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800658 | 0, i1, 0);
 __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10GameObjectD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 28800 + 8;
 __ZN14ConstantStringD2Ev(i1 + 64 | 0);
 i2 = i1 + 28 | 0;
 if ((HEAP32[i1 + 44 >> 2] | 0) <= -1) {
  HEAP32[i1 >> 2] = gb + 26392 + 8;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 32 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10Effector2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10Collider2DD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __Z9LightMaskjRK14LightingLayers(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0, i5 = 0;
 if ((i1 | 0) == -1) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = 0;
 i2 = ~i1;
 i1 = 0;
 while (1) {
  if (i2 & 1) {
   i5 = HEAP32[i4 + 4 + (i3 << 2) >> 2] | 0;
   i1 = ((i5 | 0) == -1 ? 0 : 1 << i5) | i1;
  }
  i2 = i2 >>> 1;
  if (!i2) break; else i3 = i3 + 1 | 0;
 }
 return i1 | 0;
}

function __Z55TerrainData_Set_Custom_PropInternal_heightmapResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Heightmap13SetResolutionEi(i3 + 248 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Effector2D_Get_Custom_PropDesignedForNonTriggerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45WheelCollider_Set_Custom_PropWheelDampingRateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider19SetWheelDampingRateEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45PointEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D17SetForceVariationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45PointEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D17SetForceMagnitudeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45PhysicMaterial_Set_Custom_PropDynamicFrictionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14PhysicMaterial18SetDynamicFrictionEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45CharacterController_Set_Custom_PropStepOffsetP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController13SetStepOffsetEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45CharacterController_Set_Custom_PropSlopeLimitP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController13SetSlopeLimitEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45BuoyancyEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D14SetAngularDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44TrailRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[(HEAP32[i3 + 384 >> 2] | 0) + 16 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Canvas_Set_Custom_PropReferencePixelsPerUnitP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas25SetReferencePixelsPerUnitEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Rigidbody2D_Set_Custom_PropFreezeRotationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D17SetFreezeRotationEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41MonoBehaviour_Set_Custom_PropUseGUILayoutP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13MonoBehaviour15SetUseGUILayoutEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41LineRenderer_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12LineRenderer16SetUseWorldSpaceEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Effector2D_Set_Custom_PropUseColliderMaskP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10Effector2D18SetUseColliderMaskEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Camera_Get_Custom_PropTargetTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK6Camera16GetTargetTextureEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26TerrainData_CUSTOM_AddTreeP12Il2CppObjectP12TreeInstance(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12TreeDatabase7AddTreeERK12TreeInstance(i3 + 84 | 0, i2) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z25Event_CUSTOM_Internal_UseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 if (i1 | 0) {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (i1 | 0) {
   HEAP32[i1 >> 2] = 12;
   STACKTOP = i3;
   return;
  }
 }
 __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1019159 | 0, i2);
}

function mftCall_iiiifii(i7, i1, i2, i3, d4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiifii[i7 - fb & 3](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0, i6 | 0) | 0;
 return ftCall_iiiifii(i7 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0, i6 | 0) | 0;
}

function mftCall_iiifiii(i7, i1, i2, d3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiifiii[i7 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0, i6 | 0) | 0;
 return ftCall_iiifiii(i7 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function _realloc_in_place(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 if (i2 >>> 0 > 4294967231) {
  HEAP32[(___errno_location() | 0) >> 2] = 12;
  i2 = 0;
  return i2 | 0;
 } else {
  i3 = i1 + -8 | 0;
  i2 = (_try_realloc_chunk(i3, i2 >>> 0 < 11 ? 16 : i2 + 11 & -8) | 0) == (i3 | 0);
  i2 = i2 ? i1 : 0;
  return i2 | 0;
 }
 return 0;
}

function _jpeg_stdio_dest(i2, i4) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 24 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  i1 = mftCall_iiii(HEAP32[HEAP32[i2 + 4 >> 2] >> 2] | 0, i2 | 0, 0, 28) | 0;
  HEAP32[i3 >> 2] = i1;
 }
 HEAP32[i1 + 8 >> 2] = fb + 3281;
 HEAP32[i1 + 12 >> 2] = fb + 1561;
 HEAP32[i1 + 16 >> 2] = fb + 3282;
 HEAP32[i1 + 20 >> 2] = i4;
 return;
}

function __ZThn4_N5physx12MemoryBufferD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 89572 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 89572 + 32;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0, i2 + -8 | 0, HEAP32[i2 + -4 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + (i1 << 2) | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNK5physx14NpArticulation24getSolverIterationCountsERjS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 32)) i1 = __ZNK5physx2Sc16ArticulationCore24getSolverIterationCountsEv(i1 + 24 | 0) | 0; else i1 = HEAP16[(HEAP32[i1 + 20 >> 2] | 0) + 20 >> 1] | 0;
 i1 = i1 & 65535;
 HEAP32[i3 >> 2] = i1 >>> 8;
 HEAP32[i2 >> 2] = i1 & 255;
 return;
}

function __ZNK21ScriptingObjectOfTypeI10AudioMixerEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNK20LocalFileSystemPosix6TargetERK13FileEntryDataR15FileSystemEntry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 4096 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i4;
 if (!(_realpath(i2, i1) | 0)) i1 = 0; else {
  __ZN15FileSystemEntry3SetEPKc(i3, i1);
  i1 = 1;
 }
 STACKTOP = i4;
 return i1 | 0;
}

function __ZNK20LocalFileSystemPosix4SizeERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 i3 = (_stat(i2, i4) | 0) == 0;
 i2 = HEAP32[i4 + 36 >> 2] | 0;
 setTempRet0((i3 ? ((i2 | 0) < 0) << 31 >> 31 : 0) | 0);
 STACKTOP = i1;
 return (i3 ? i2 : 0) | 0;
}

function __ZNK13RendererScene21GetDynamicObjectCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 i1 = i1 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  i2 = i2 - i1 | 0;
  return i2 | 0;
 }
 i3 = __Z9GetIUmbrav() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i2 = i2 - i1 | 0;
 return i2 | 0;
}

function __ZNK13MonoBehaviour30ShouldRunStateMachineBehaviourEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 56 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP16[i1 + 36 >> 1] | 0;
 if (!((i1 & 255) << 24 >> 24)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((i1 & 65535) >= 256) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (HEAP32[i2 + 8 >> 2] & 1048576 | 0) == 0;
 return i2 | 0;
}

function __ZN8Renderer10DeactivateE19DeactivateOperation(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 160 >> 2] | 0, i3 | 0);
 i1 = i3 + 316 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 320 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN7mecanim23DestroyValueArrayWeightEPNS_16ValueArrayWeightERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7TerrainD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 184192 + 8;
 i2 = i1 + 228 | 0;
 if ((HEAP32[i1 + 244 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 232 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefIKhEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i2 >> 2] | 0) | 0;
 i2 = i1 + 4 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 4;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + (HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx3Ext13RevoluteJoint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 88480 | 0) | 0;
 return;
}

function __ZN5physx3Ext13DistanceJoint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 87648 | 0) | 0;
 return;
}

function __ZN5physx2Gu11HeightField15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = Math_imul(HEAP32[i2 + 16 >> 2] << 2, HEAP32[i2 + 20 >> 2] | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 36 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5physx17ConvexHullBuilderC2EPNS_2Gu14ConvexHullDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = i1;
 i2 = i2 + 24 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN5physx16PxVehicleNoDriveC2Ev(i1) {
 i1 = i1 | 0;
 HEAP16[i1 + 4 >> 1] = 512;
 HEAP16[i1 + 6 >> 1] = 3;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(.230800003);
 HEAPF32[i1 + 16 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(3.0);
 HEAPF32[i1 + 24 >> 2] = Math_fround(.333333343);
 HEAP32[i1 >> 2] = gb + 158796 + 8;
 return;
}

function __ZN4FMOD6SoundI15StopAllChannelsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 52 | 0;
 i2 = i1 + 60 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = HEAP32[i1 >> 2] | 0;
  _JS_Sound_Stop(HEAP32[i4 + 164 >> 2] | 0, 0.0);
  __ZN4FMOD8ChannelI11EndCallbackEv(i4);
  i1 = HEAP32[i2 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN4FMOD4DSPI11setDefaultsEfffi(i1, f2, f3, f4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868863;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1011545 | 0, i1, 0);
 __ZN2UI11CanvasGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14RenderSettings15SetHaloStrengthEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 HEAPF32[i1 + 300 >> 2] = f2;
 i4 = __Z15GetLightManagerv() | 0;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 if ((i3 | 0) == (i4 | 0)) return;
 do {
  __ZN5Light9SetupHaloEv(i1 + -36 | 0);
  i1 = HEAP32[i3 + 4 >> 2] | 0;
  i3 = i1;
 } while ((i3 | 0) != (i4 | 0));
 return;
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 308 | 0, 16) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 128 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49CharacterJoint_CUSTOM_INTERNAL_get_highTwistLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 128 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43LineRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[(HEAP32[i3 + 344 >> 2] | 0) + 16 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Rigidbody_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody15SetCenterOfMassERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42NavMeshObstacle_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42CapsuleCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15CapsuleCollider9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Rigidbody_Set_Custom_PropDetectCollisionsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody19SetDetectCollisionsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Animator_CUSTOM_INTERNAL_set_rootPositionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator17SetAvatarPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40TerrainData_CUSTOM_RemoveDetailPrototypeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14DetailDatabase21RemoveDetailPrototypeEi(i3 + 128 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39CanvasGroup_Set_Custom_PropInteractableP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI11CanvasGroup15SetInteractableEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Transform_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform11SetRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody11SetRotationERK11Quaternionf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_WarpP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN12NavMeshAgent4WarpERK8Vector3f(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Terrain_Get_Custom_PropLightmapIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   i2 = HEAP16[i2 + 152 >> 1] | 0;
   return (i2 << 16 >> 16 == -1 ? -1 : i2 & 65535) | 0;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36HingeJoint_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK10JointMotor(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint8SetMotorERK10JointMotor(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31checkOverlapSphere_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu6SphereE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i3, (HEAP32[i1 + 36 >> 2] | 0) + 32 | 0, i2, i1 + 4 | 0, 0) | 0;
}

function __Z31Object_Set_Custom_PropHideFlagsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 48 >> 2] | 0, i3 | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29ClearRepeatingLogMessageStatev() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1170808 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z23DefaultCleanLogHandlerv7LogTypePKcPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 _vfprintf(HEAP32[gb + 1450792 >> 2] | 0, i2, i4) | 0;
 _fflush(HEAP32[gb + 1450792 >> 2] | 0) | 0;
 STACKTOP = i1;
 return 1;
}

function _start_pass_prep(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 324 >> 2] | 0;
 if (i2 | 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 + 20 >> 2] = 4;
  mftCall_vi(HEAP32[i2 >> 2] | 0, i1 | 0);
 }
 HEAP32[i3 + 48 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i3 + 52 >> 2] = 0;
 HEAP32[i3 + 56 >> 2] = 0;
 HEAP32[i3 + 60 >> 2] = HEAP32[i1 + 220 >> 2] << 1;
 return;
}

function __ZZN15DirectorManager15InitializeClassEvEN39PostLateUpdateDirectorRenderImagestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0)) return;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 6);
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5physx3Cct10Controller12getKineShapeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 i1 = HEAP32[i1 + 400 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i3 | 0, 1, 0) | 0;
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE13getActorFlagsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 i3 = HEAP32[i1 + (i2 + 4) >> 2] | 0;
 return HEAP16[((i3 & 1 | 0) == 0 ? (HEAP32[gb + 90260 + 24 + ((i3 >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 8 | 0 : HEAP32[i1 + (i2 + 8) >> 2] | 0) >> 1] | 0;
}

function __ZNK5Umbra4Tome9getStatusEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) {
  i2 = 1;
  return i2 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = i3 & 65535;
 if ((i3 & -65536 | 0) != -704643072) {
  i3 = (i2 | 0) == 214 ? 5 : 2;
  return i3 | 0;
 }
 if ((i2 | 0) == 18) return ((i1 & 15 | 0) == 0 ? 0 : 6) | 0; else {
  i3 = i2 >>> 0 > 18 ? 4 : 3;
  return i3 | 0;
 }
 return 0;
}

function __ZNK33AssetBundleLoadFromAsyncOperation10PrintErrorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 92 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 if ((HEAP32[i2 >> 2] | 0) == 1) return;
 i2 = i1 + 96 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 0, gb + 365786 | 0, 420, 1, 0, 0, 0);
 return;
}

function __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = i1 + 4 | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + i2 | 0;
 i1 = __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE(i1, (HEAP32[i2 >> 2] | 0) + i2 | 0) | 0;
 return i1 | 0;
}

function __ZN5physx7NpShape8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = HEAP8[i1 >> 0] | 0;
 __ZN5physx7NpShape16setFlagsInternalENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i2, i4);
 STACKTOP = i3;
 return;
}

function __ZN5physx3Ext18ProfileZoneHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 87256 + 8;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc10NPhaseCore10updatePairEPNS0_15CoreInteractionE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP16[i1 + 6 >> 1] & 1) if (HEAP16[i1 + 4 >> 1] & 1) if ((__ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb(i2, i1, 0, 0) | 0) != (i1 | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN5physx2Gu28checkOverlapOBB_triangleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults(i1, (HEAP32[i2 + 36 >> 2] | 0) + 32 | 0, i3, i2 + 4 | 0, 0) | 0;
}

function __ZN5physx2Gu11HeightField13releaseMemoryEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(HEAP16[i2 + 6 >> 1] & 1)) {
  STACKTOP = i1;
  return;
 }
 i2 = i2 + 36 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZN5physx27InternalTriangleMeshBuilderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN5physx2Gu8EdgeListD2Ev(i2);
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2);
 }
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5Unity9Component23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 589668 | 0, i1, 0);
 __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN22UnityWebRequestManager8RegisterEP15UnityWebRequest(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(12) | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = gb + 1468908;
 i1 = HEAP32[gb + 1468908 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[gb + 1468908 >> 2] = i2;
 HEAP32[gb + 1468908 + 8 >> 2] = (HEAP32[gb + 1468908 + 8 >> 2] | 0) + 1;
 return;
}

function __ZN22ParticleSystemRenderer12GetWorldAABBER4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 568 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 return;
}

function __ZN15MulticastSocket6SetTTLEh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = i2;
 i2 = (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket15SetSocketOptionEiiPvj(i1, 0, 33, i4, 1) | 0, gb + 584644 | 0, 0, 0) | 0) ^ 1;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 411274 | 0, i1, 0);
 __ZN14Texture2DArray8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 429490 | 0, i1, 0);
 __ZN14SpriteRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14RenderSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 381335 | 0, i1, 0);
 __ZN14RenderSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 448085 | 0, i1, 0);
 __ZN14PlayerSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 737328 | 0, i1, 0);
 __ZN14PhysicsManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 737107 | 0, i1, 0);
 __ZN14PhysicMaterial8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 618922 | 0, i1, 0);
 __ZN14ParticleSystem8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800815 | 0, i1, 0);
 __ZN14AreaEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_1L9gSWAP_ANDERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = HEAP16[i2 + 4 >> 1] & HEAP16[i1 >> 1];
 HEAP16[i3 + 2 >> 1] = HEAP16[i2 + 6 >> 1] & HEAP16[i1 + 2 >> 1];
 HEAP16[i3 + 4 >> 1] = HEAP16[i2 >> 1] & HEAP16[i1 + 4 >> 1];
 HEAP16[i3 + 6 >> 1] = HEAP16[i2 + 2 >> 1] & HEAP16[i1 + 6 >> 1];
 return;
}

function __ZN12_GLOBAL__N_119RendererEventClientD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 150428 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 240 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Rigidbody_Set_Custom_PropSolverVelocityIterationsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody27SetSolverVelocityIterationsEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48CharacterJoint_CUSTOM_INTERNAL_get_lowTwistLimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 116 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Animator_CUSTOM_GetCurrentAnimatorClipInfoCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN8Animator24GetAnimatorClipInfoCountEib(i3, i2, 1) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44RelativeJoint2D_Set_Custom_PropAngularOffsetP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15RelativeJoint2D16SetAngularOffsetEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44PointEffector2D_Set_Custom_PropDistanceScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D16SetDistanceScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44PlatformEffector2D_Set_Custom_PropSurfaceArcP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D13SetSurfaceArcEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44PhysicMaterial_Set_Custom_PropStaticFrictionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14PhysicMaterial17SetStaticFrictionEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44NavMeshAgent_Set_Custom_PropStoppingDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent19SetStoppingDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44CharacterController_Set_Custom_PropSkinWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController12SetSkinWidthEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44BuoyancyEffector2D_Set_Custom_PropLinearDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D13SetLinearDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AreaEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D17SetForceVariationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44AreaEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D17SetForceMagnitudeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41NavMeshAgent_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent11SetVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40OffMeshLink_Set_Custom_PropBiDirectionalP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11OffMeshLink16SetBiDirectionalEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Collider2D_Set_Custom_PropUsedByEffectorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10Collider2D17SetUsedByEffectorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioSource_Set_Custom_PropBypassEffectsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource16SetBypassEffectsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Animator_CUSTOM_SetLayerWeightP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator14SetLayerWeightEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Shader_CUSTOM_GetGlobalInti(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i1 = ~~Math_fround(__Z20GetShaderGlobalFloatN9ShaderLab16FastPropertyNameE(i3));
 STACKTOP = i2;
 return i1 | 0;
}

function __Z26PlainLogToPlayerConnection7LogTypePKcPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 __Z28LogToPlayerConnectionMessage7LogTypeN17GeneralConnection9MessageIDEPKcPi(0, 100, i2, i4);
 STACKTOP = i1;
 return 1;
}

function __Z26CleanLogToPlayerConnection7LogTypePKcPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 __Z28LogToPlayerConnectionMessage7LogTypeN17GeneralConnection9MessageIDEPKcPi(0, 101, i2, i4);
 STACKTOP = i1;
 return 1;
}

function _Vertical_Sweep_Init(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i4 + 112 >> 2] | 0;
 i1 = 0 - i3 | 0;
 HEAP16[i4 + 156 >> 1] = i1;
 i1 = Math_imul(HEAP16[i2 >> 1] | 0, i1) | 0;
 i2 = i4 + 148 | 0;
 HEAP32[i2 >> 2] = i1;
 if ((i3 | 0) <= 0) return;
 HEAP32[i2 >> 2] = (Math_imul((HEAP32[i4 + 104 >> 2] | 0) + -1 | 0, i3) | 0) + i1;
 return;
}

function mftCall_viiiffi(i7, i1, i2, i3, d4, d5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viiiffi[i7 - fb & 1](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), Math_fround(d5), i6 | 0);
  return;
 }
 ftCall_viiiffi(i7 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, +d5, i6 | 0);
}

function __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNK17GlobalGameManager7GetNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i2, HEAP32[(HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) {
  i2 = gb + 1576256 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD7SystemI11getCPUUsageEPfS1_S1_S1_S1_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if (i2 | 0) HEAPF32[i2 >> 2] = Math_fround(60.0);
 if (i3 | 0) HEAPF32[i3 >> 2] = Math_fround(30.0);
 if (i4 | 0) HEAPF32[i4 >> 2] = Math_fround(0.0);
 if (!i5) return 0;
 HEAPF32[i5 >> 2] = Math_fround(10.0);
 return 0;
}

function __ZN4FMOD6SoundI13setVariationsEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869173;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN15RelativeJoint2D18SetCorrectionScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 84 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MotorJoint19SetCorrectionFactorEf(i2, f1);
 return;
}

function __ZN15QualitySettings18SetMaximumLODLevelEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 88 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN14UnityAnalyticsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 4 >> 2] = __Z21GetUnityConnectClientv() | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 188416 + 8;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i1 + 24 | 0);
 HEAP32[i2 >> 2] = gb + 1042554;
 return;
}

function __ZN14NavMeshManager12RemoveTileAtEiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = i1 + 108 | 0;
 i1 = __ZNK9dtNavMesh12getTileRefAtEiii(HEAP32[i5 >> 2] | 0, i2, i3, i4) | 0;
 i2 = getTempRet0() | 0;
 if ((i1 | 0) == 0 & (i2 | 0) == 0) return;
 __ZN9dtNavMesh10removeTileEyPPKhPi(HEAP32[i5 >> 2] | 0, i1, i2, 0, 0) | 0;
 return;
}

function __ZN12MemoryStream4readEPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = i1 + 12 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i6 = HEAP32[i1 + 20 >> 2] | 0;
 i3 = (i5 + i3 | 0) >>> 0 > i6 >>> 0 ? i6 - i5 | 0 : i3;
 _memcpy(i2 | 0, (HEAP32[i1 + 24 >> 2] | 0) + i5 | 0, i3 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i3;
 return i3 | 0;
}

function __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularXDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 252 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48ParticleRenderer_Set_Custom_PropUvAnimationYTileP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN16ParticleRenderer19SetUVAnimationYTileEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48ParticleRenderer_Set_Custom_PropUvAnimationXTileP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN16ParticleRenderer19SetUVAnimationXTileEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain16SetLightmapIndexEi12LightmapType(i3, i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Effector2D_Get_Custom_PropDesignedForTriggerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody12MovePositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41SphereCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14SphereCollider9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Input_CUSTOM_INTERNAL_get_accelerationP8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __Z15GetAccelerationv(i3);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 STACKTOP = i2;
 return;
}

function __Z36Cloth_Set_Custom_PropSolverFrequencyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth18SetSolverFrequencyEf(i3, Math_fround(i2 & 255));
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Transform_Set_Custom_PropHasChangedP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform23SetHasChangedDeprecatedEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Renderer_CUSTOM_SetStaticBatchInfoP12Il2CppObjectii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Renderer18SetStaticBatchInfoEii(i4, i2, i3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Animator_Get_Custom_PropAvatarRootP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Animator13GetAvatarRootEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _UNITY_LZ4_saveDict(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 16392 | 0;
 i1 = i1 + 16400 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i3 = i3 >>> 0 > 65536 ? 65536 : i3;
 i3 = i3 >>> 0 > i5 >>> 0 ? i5 : i3;
 _memmove(i2 | 0, (HEAP32[i4 >> 2] | 0) + i5 + (0 - i3) | 0, i3 | 0) | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i1 >> 2] = i3;
 return i3 | 0;
}

function _destroy_size(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i4 + 8 >> 2] | 0;
 if (i2 | 0) mftCall_vi(i2 | 0, i4 | 0);
 i1 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 60 >> 2] | 0;
 if (i1 | 0) mftCall_vi(i1 | 0, i4 | 0);
 i2 = i4 + 40 | 0;
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 _UNITY_ft_mem_free(i3, i4);
 return;
}

function _bindtextdomain(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i3 = 6; else if (!(HEAP8[i1 >> 0] | 0)) i3 = 6; else if (!i2) i1 = gb + 1087627 | 0; else if ((HEAP8[i2 >> 0] | 0) == 47) if (!(HEAP8[i2 + 1 >> 0] | 0)) i1 = gb + 1087627 | 0; else i3 = 6; else i3 = 6;
 if ((i3 | 0) == 6) {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZZN2UI14CanvasRenderer15InitializeClassEvEN34FunctorImpl_802kCanvasGroupChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 2176;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZNSt3__218__libcpp_refstringaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i4;
 i4 = i4 + -4 | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i3 + -4 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i2 + -1;
 if ((i2 + -1 | 0) < 0) __ZdlPv(i3 + -12 | 0);
 return i1 | 0;
}

function __ZNK5physx2Sc17ParticleSystemSim23getSimulationFilterDataEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv(HEAP32[i2 + 52 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK16LevelGameManager7GetNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i2, HEAP32[(HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) {
  i2 = gb + 1576256 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZNK14ImageReference12IsValidImageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 if ((i3 | 0) < 9) i2 = 1; else i2 = (i3 | 0) == 1e3 | ((i3 | 0) == 23 | (i3 + -13 | 0) >>> 0 < 9);
 i3 = (HEAP32[i1 + 4 >> 2] | 0) > 0 & (HEAP32[i1 + 8 >> 2] | 0) > 0 & (i3 | 0) > 0 & i2;
 return i3 | 0;
}

function __ZN7mecanim8skeleton8IdentityIN4math4trsXEEET_v(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 1065353216;
 HEAP32[i1 + 28 >> 2] = 1065353216;
 HEAP32[i1 + 32 >> 2] = 1065353216;
 HEAP32[i1 + 36 >> 2] = 1065353216;
 return;
}

function __ZN7ApiGLES15BindArrayBufferEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 do if (!(HEAP8[i2 + 1992 >> 0] | 0)) if (!i3) return; else {
  i1 = i2 + 896 | 0;
  break;
 } else {
  i1 = i2 + 896 | 0;
  if ((i3 | 0) == 0 ? 1 : (HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 } while (0);
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 34962, i3 | 0);
 return;
}

function __ZN5physx3Ext10FixedJoint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 87932 | 0) | 0;
 return;
}

function __ZN5physx11NpAggregate15exportExtraDataERNS_22PxSerializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 40 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, 16);
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i3 + 36 >> 2] << 2 | 0);
 return;
}

function __ZN4Mesh15ByteSwapIndicesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 i3 = ((HEAP32[i3 + 116 >> 2] | 0) - i1 | 0) >>> 1;
 if (!i3) return;
 i2 = 0;
 while (1) {
  HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i3 | 0)) break; else i1 = i1 + 2 | 0;
 }
 return;
}

function __ZN4FMOD7SystemI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869672;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer15SetParentCanvasEPNS_6CanvasE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 188 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i4, i1);
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN15AudioMixerGroupD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 174700 + 8;
 i2 = i1 + 32 | 0;
 if ((HEAP32[i1 + 48 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 36 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14BillboardAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19SharedBillboardData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(HEAP32[i1 + 32 >> 2] | 0, i2);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 827168 | 0, i1, 0);
 __ZN13WheelCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13WheelCollider16RecreateColliderEPK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) return;
 if (!(__ZNK10GameObject8IsActiveEv(i3) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 421148 | 0, i1, 0);
 __ZN13TrailRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 803162 | 0, i1, 0);
 __ZN13TargetJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 803021 | 0, i1, 0);
 __ZN13SpringJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 410430 | 0, i1, 0);
 __ZN13SparseTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802891 | 0, i1, 0);
 __ZN13SliderJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 590339 | 0, i1, 0);
 __ZN13RenderTexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 443248 | 0, i1, 0);
 __ZN13BuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13BoxCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800904 | 0, i1, 0);
 __ZN13BoxCollider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 897916 | 0, i1, 0);
 __ZN13AnimationClip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing2LimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 160 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing1LimitP12Il2CppObjectP14SoftJointLimit(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 148 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46CanvasRenderer_Set_Custom_PropPopMaterialCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer19SetPopMaterialCountEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43SurfaceEffector2D_Set_Custom_PropForceScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D13SetForceScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43PhysicsMaterial2D_Set_Custom_PropBouncinessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17PhysicsMaterial2D13SetBouncinessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43BuoyancyEffector2D_Set_Custom_PropFlowAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D12SetFlowAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39NavMeshAgent_Set_Custom_PropAutoBrakingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent14SetAutoBrakingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39MeshCollider_Set_Custom_PropInflateMeshP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12MeshCollider14SetInflateMeshEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Rigidbody2D_Set_Custom_PropFixedAngleP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D17SetFreezeRotationEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Camera_CUSTOM_INTERNAL_set_pixelRectP12Il2CppObjectRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera21SetScreenViewportRectERK5RectTIfE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33TextMesh_Set_Custom_PropAlignmentP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh12SetAlignmentEs(i3, i2 & 65535);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33GUITexture_Get_Custom_PropTextureP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN10GUITexture10GetTextureEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32NavMeshAgent_CUSTOM_GetLayerCostP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK12NavMeshAgent11GetAreaCostEj(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z27Material_CUSTOM_GetPassNameP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z20scripting_string_newPKc(__ZNK8Material11GetPassNameEi(i3, i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26getPxSceneDescSanityBoundsPKN5physx11PxSceneDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 160 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 164 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 168 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 172 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 176 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 180 >> 2];
 return;
}

function __Z19CreateRealGfxDevice17GfxDeviceRendererb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) == 4) {
  i2 = __Z19CreateNullGfxDevicev() | 0;
  return i2 | 0;
 }
 i1 = i2 + -8 | 0;
 if (i1 >>> 0 >= 10) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(521 >>> (i1 & 1023) & 1)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __Z19CreateGLESGfxDevice17GfxDeviceRenderer(i2) | 0;
 return i2 | 0;
}

function __GLOBAL__sub_I_runtime_video_lump_cpp() {
 var i1 = 0;
 HEAP32[gb + 1459952 >> 2] = 0;
 HEAP32[gb + 1459952 + 4 >> 2] = 0;
 HEAP32[gb + 1459952 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1459952 + 12 >> 2] = i1;
 HEAP32[gb + 1459968 >> 2] = 0;
 HEAP32[gb + 1459968 + 4 >> 2] = 0;
 HEAP32[gb + 1459968 + 8 >> 2] = 0;
 return;
}

function __GLOBAL__sub_I_runtime_math_random_lump_cpp() {
 var i1 = 0;
 i1 = _time(0) | 0;
 HEAP32[gb + 1162392 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[gb + 1162392 + 4 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[gb + 1162392 + 8 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[gb + 1162392 + 12 >> 2] = i1;
 return;
}

function mftCall_viiiiii(i7, i1, i2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 255 | 0)) {
  FUNCTION_TABLE_viiiiii[i7 - fb & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
  return;
 }
 ftCall_viiiiii(i7 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function __ZNK21ScriptingObjectOfTypeI7CubemapEptEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 do if (!i1) i1 = 0; else {
  i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (!i1) {
   i1 = HEAP32[i2 >> 2] | 0;
   break;
  } else return i1 | 0;
 } while (0);
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (i4 | 0) mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i4 + i3 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN6SocketC2Eiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 HEAP32[i1 >> 2] = gb + 65564 + 8;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 i4 = _socket(i2, i3, i4) | 0;
 HEAP32[i1 + 4 >> 2] = i4;
 if (__ZN6Socket10CheckErrorEiPKcii(i4, gb + 458666 | 0, 0, 0) | 0) return;
 HEAP32[i5 >> 2] = 16384;
 return;
}

function __ZN5physx32solveContactCoulomb_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx2Sn20SerializationContext9writeNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z(__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0, 8, gb + 672319 | 0, 243, gb + 672432 | 0, i1);
 STACKTOP = i1;
 return;
}

function __ZN5physx10PxsContext20removeParticleSystemEPNS_20PxvParticleSystemSimEb(i2, i4, i3) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i5 = 0;
 i1 = HEAP32[gb + 1098856 >> 2] | 0;
 i5 = HEAP32[gb + 1098856 + 4 >> 2] | 0;
 i2 = i2 + (i5 >> 1) | 0;
 if (i5 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 return mftCall_iiii(i1 | 0, i2 | 0, i4 | 0, i3 | 0) | 0;
}

function __ZN4FMOD7SystemI20getRecordDriverInfoWEiPsiP9FMOD_GUID(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869577;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperation20LoadCachedArchiveJobEPv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 92 >> 2] | 0) != 1) __ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv(i1) | 0;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN20SphericalHarmonicsL211AddWeightedERKS_f(i2, i3, f4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 var i1 = 0, i5 = 0, f6 = f0;
 i1 = 0;
 do {
  f6 = Math_fround(Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]) * f4);
  i5 = i2 + (i1 << 2) | 0;
  HEAPF32[i5 >> 2] = Math_fround(Math_fround(HEAPF32[i5 >> 2]) + f6);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 27);
 return;
}

function __ZN16Physics2DManager26GetGameObjectForRaycastHitERK12RaycastHit2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZNK10Collider2D20GetAttachedRigidbodyEb(i1, 0) | 0;
 if (!i2) {
  i2 = HEAP32[i1 + 28 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = HEAP32[i2 + 28 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN15MBP_PairManager13reserveMemoryEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) return;
 if (i1 + -1 & i1) {
  i1 = i1 >>> 1 | i1;
  i1 = i1 >>> 2 | i1;
  i1 = i1 >>> 4 | i1;
  i1 = i1 >>> 8 | i1;
  i1 = (i1 >>> 16 | i1) + 1 | 0;
 }
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 + 24 >> 2] = i1;
 __ZN15MBP_PairManager12reallocPairsEv(i2);
 return;
}

function __ZN13SpeedTreeWind10SWindGroupC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 200 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 208 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 212 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 216 >> 2] = Math_fround(.00499999989);
 HEAPF32[i1 + 220 >> 2] = Math_fround(1.0);
 _memset(i1 | 0, 0, 200) | 0;
 return;
}

function __ZN12_GLOBAL__N_110Connection14onDeallocationEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i2 + 132 >> 0] | 0)) return;
 if (!(HEAP32[i2 + 112 >> 2] & 4)) return;
 __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv(i2);
 i2 = HEAP32[(HEAP32[i2 + 120 >> 2] | 0) + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z48ParticleSystemRenderer_Set_Custom_PropRenderModeP12Il2CppObject24ParticleSystemRenderMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP16[i3 + 340 >> 1] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleSystemRenderer_Set_Custom_PropAlignmentP12Il2CppObject25ParticleSystemRenderSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 372 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45SliderJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13SliderJoint2D19GetJointTranslationEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45Renderer_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK12BaseRenderer19GetLightmapIndexIntE12LightmapType(i2 + 32 | 0, 1) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45PhysicMaterial_Get_Custom_PropDynamicFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14PhysicMaterial18GetDynamicFrictionEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45NavMeshAgent_Get_Custom_PropRemainingDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12NavMeshAgent20GetRemainingDistanceEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44Animator_CUSTOM_GetNextAnimatorClipInfoCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZN8Animator24GetAnimatorClipInfoCountEib(i3, i2, 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43WheelJoint2D_CUSTOM_INTERNAL_get_suspensionP12Il2CppObjectP17JointSuspension2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 96 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Rigidbody_Set_Custom_PropMaxAngularVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody21SetMaxAngularVelocityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Effector2D_Get_Custom_PropRequiresColliderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42Camera_Set_Custom_PropTransparencySortModeP12Il2CppObjectN6Camera20TransparencySortModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 1068 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40WheelCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Transform_CUSTOM_INTERNAL_set_localScaleP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform13SetLocalScaleERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Cloth_Set_Custom_PropStretchingStiffnessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth22SetStretchingStiffnessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Rigidbody_Set_Custom_PropFreezeRotationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody17SetFreezeRotationEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Animator_Set_Custom_PropApplyRootMotionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator18SetApplyRootMotionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Animation_Set_Custom_PropAnimatePhysicsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Animation17SetAnimatePhysicsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34DeveloperConsole_HandleLogFunctionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1468316 >> 2] | 0;
 if (!i1) return;
 __ZN16DeveloperConsole9HandleLogERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType(i1, i2, i3, i4);
 return;
}

function __Z34CanvasRenderer_Set_Custom_PropCullP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer13SetShouldCullEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31NavMeshAgent_CUSTOM_GetAreaCostP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK12NavMeshAgent11GetAreaCostEj(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Camera_CUSTOM_INTERNAL_set_rectP12Il2CppObjectRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z16DestroyGfxDevicev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1157628 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63304 | 0);
 HEAP32[gb + 1157628 >> 2] = 0;
 __ZN12GraphicsCaps25CleanupGraphicsCapsMemoryEv();
 __ZN12TextureIdMap7CleanupEv();
 __ZN16RenderTextureMap7CleanupEv();
 return;
}

function mftCall_viifiii(i7, i1, i2, d3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viifiii[i7 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0, i6 | 0);
  return;
 }
 ftCall_viifiii(i7 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0, i6 | 0);
}

function mftCall_vifiiii(i7, i1, d2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_vifiiii[i7 - fb & 3](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, i5 | 0, i6 | 0);
  return;
 }
 ftCall_vifiiii(i7 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function _unity_z_tr_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 2840 >> 2] = i1 + 148;
 HEAP32[i1 + 2848 >> 2] = gb + 25152;
 HEAP32[i1 + 2852 >> 2] = i1 + 2440;
 HEAP32[i1 + 2860 >> 2] = gb + 25172;
 HEAP32[i1 + 2864 >> 2] = i1 + 2684;
 HEAP32[i1 + 2872 >> 2] = gb + 25192;
 HEAP16[i1 + 5816 >> 1] = 0;
 HEAP32[i1 + 5820 >> 2] = 0;
 HEAP32[i1 + 5812 >> 2] = 8;
 _init_block(i1);
 return;
}

function _cff_glyph_load(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!i3) {
  i5 = 37;
  return i5 | 0;
 }
 i1 = (i4 | 0) == 0 ? i1 | 3 : i1;
 i2 = (i1 & 1 | 0) == 0 ? i4 : 0;
 if (i2 | 0) if ((HEAP32[i4 >> 2] | 0) != (HEAP32[i3 + 4 >> 2] | 0)) {
  i5 = 35;
  return i5 | 0;
 }
 i5 = _cff_slot_load(i3, i2, i5, i1) | 0;
 return i5 | 0;
}

function ___cxx_global_var_init11() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(.0000999999974);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097680 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__212__rs_defaultD2Ev(i1) {
 i1 = i1 | 0;
 i1 = (HEAP32[gb + 1470900 >> 2] | 0) + -1 | 0;
 HEAP32[gb + 1470900 >> 2] = i1;
 if (!i1) {
  __THREW__ = 0;
  invoke_ii(fb + 2796 | 0, gb + 1470904 | 0) | 0;
  i1 = __THREW__;
  __THREW__ = 0;
  if (i1 & 1) {
   i1 = ___cxa_find_matching_catch_3(0) | 0;
   getTempRet0() | 0;
   ___clang_call_terminate(i1);
  }
 }
 return;
}

function __ZNK11SoundHandle19IsStreamingFromDiskEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 48 >> 2] & 128)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = i1 + 88 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) != 0 | (HEAP32[i1 + 4 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i(0, i2, i3, i4, i5);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIPhED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149568 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx31PxClothGeodesicTetherCookerImplC2ERKNS_15PxClothMeshDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i2 >> 2] = i1;
 i3 = i2 + 8 | 0;
 i4 = i3 + 100 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 __ZN5physx31PxClothGeodesicTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE(i2, i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD6SoundI12addSyncPointEjjPKcPP14FMOD_SYNCPOINT(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868923;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN18PlatformEffector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18BuoyancyEffector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN17PersistentManager14IsStreamLoadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, 0) | 0;
 if ((i1 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 * 24 | 0) >> 2] | 0) != 0;
 return i2 | 0;
}

function __ZN16RayRTreeCallbackILi1ELb1EED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 85436 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85436 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZN16RayRTreeCallbackILi1ELb0EED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 85388 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 85388 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZN16RayRTreeCallbackILi0ELb1EED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 86012 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 86012 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZN16RayRTreeCallbackILi0ELb0EED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 84176 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 84176 + 32;
 if (!(HEAP8[i1 + 180 >> 0] | 0)) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 mftCall_iiiiiiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 + 68 | 0, i1 + 132 | 0, i1 + 144 | 0, i1 + 156 | 0, i1 + 64 | 0, i1 + 168 | 0) | 0;
 return;
}

function __ZN15QualitySettings15SetBlendWeightsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 60 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 __ZN15QualitySettings13ApplySettingsEib(i1, -1, 0);
 return;
}

function __ZN12ScriptMapper23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 476527 | 0, i1, 0);
 __ZN12ScriptMapper8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 842251 | 0, i1, 0);
 __ZN12NavMeshAgent8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 737071 | 0, i1, 0);
 __ZN12MeshCollider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 405180 | 0, i1, 0);
 __ZN12LineRenderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 801424 | 0, i1, 0);
 __ZN12HingeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 397025 | 0, i1, 0);
 __ZN12CubemapArray8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855932 | 0, i1, 0);
 __ZN12AudioManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __Z61ParticleSystemExtensionsImpl_CUSTOM_GetSafeCollisionEventSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK14ParticleSystem25GetSafeCollisionEventSizeEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51Camera_Set_Custom_PropClearStencilAfterLightingPassP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1093 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z48ConfigurableJoint_CUSTOM_INTERNAL_get_slerpDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 264 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Rigidbody_Set_Custom_PropCollisionDetectionModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody25SetCollisionDetectionModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Canvas_Get_Custom_PropSortingGridNormalizedSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ~~Math_fround(__ZNK2UI6Canvas30GetSortingBucketNormalizedSizeEv(i2)) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45Rigidbody_Get_Custom_PropSleepAngularVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody23GetSleepAngularVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45CharacterController_Get_Custom_PropStepOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN19CharacterController13GetStepOffsetEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45CharacterController_Get_Custom_PropSlopeLimitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN19CharacterController13GetSlopeLimitEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Rigidbody2D_Set_Custom_PropAngularVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D18SetAngularVelocityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42PointEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D14SetAngularDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AudioReverbZone_Set_Custom_PropMinDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15AudioReverbZone14SetMinDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42AudioReverbZone_Set_Custom_PropMaxDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15AudioReverbZone14SetMaxDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39GUI_CUSTOM_INTERNAL_set_backgroundColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __Z11GetGUIStatev() | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 + 28 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 32 >> 2] = i5;
 HEAP32[i2 + 36 >> 2] = i4;
 HEAP32[i2 + 40 >> 2] = i3;
 return;
}

function __Z38SliderJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D12SetUseLimitsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody2D_Set_Custom_PropUseAutoMassP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D14SetUseAutoMassEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38NavMeshObstacle_Set_Custom_PropCarvingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle10SetCarvingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38NavMeshAgent_Set_Custom_PropAutoRepathP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent13SetAutoRepathEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource14SetPlayOnAwakeEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Renderer_Set_Custom_PropLightmapIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Renderer19SetLightmapIndexIntEi12LightmapType(i3, i2, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Canvas_Set_Custom_PropOverrideSortingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas18SetOverrideSortingEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36TerrainData_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Heightmap7SetSizeERK8Vector3f(i3 + 248 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Animator_CUSTOM_InterruptMatchTargetP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator20InterruptMatchTargetEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35HingeJoint_Set_Custom_PropUseSpringP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint12SetUseSpringEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35HingeJoint_Set_Custom_PropUseLimitsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint12SetUseLimitsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z16FromToQuaternionRK8Vector3fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 48 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_(i5, i2, i3) | 0;
 __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf(i5, i1);
 STACKTOP = i4;
 return;
}

function __GLOBAL__sub_I_runtime_shaders_gpuprograms_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166372 | 0, gb + 479448 | 0, 0, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1166384 | 0, gb + 479486 | 0, 0, 0);
 __ZN23DefaultMeshVertexFormatC2Ej(gb + 1166396 | 0, 159);
 return;
}

function _tre_ast_new_node(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = ___tre_mem_alloc_impl(i2, 0, 0, 1, 32) | 0;
 if (!i1) i1 = 0; else {
  i4 = ___tre_mem_alloc_impl(i2, 0, 0, 1, i4) | 0;
  HEAP32[i1 + 4 >> 2] = i4;
  if (!i4) i1 = 0; else {
   HEAP32[i1 >> 2] = i3;
   HEAP32[i1 + 8 >> 2] = -1;
   HEAP32[i1 + 12 >> 2] = -1;
  }
 }
 return i1 | 0;
}

function _logbf(f1) {
 f1 = Math_fround(f1);
 do if (((HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040) if (f1 == Math_fround(0.0)) {
  f1 = Math_fround(Math_fround(-1.0) / Math_fround(f1 * f1));
  break;
 } else {
  f1 = Math_fround(_ilogbf(f1) | 0);
  break;
 } else f1 = Math_fround(f1 * f1); while (0);
 return Math_fround(f1);
}

function __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 89572 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 89572 + 32;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) return;
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0, i2 + -8 | 0, HEAP32[i2 + -4 >> 2] | 0);
 return;
}

function __ZNK19TextRenderingModule38FontGetNumCharactersThatFitWithinWidthEPN13TextRendering4FontERK11UTF16Stringfij(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN20TextRenderingPrivate8FontImpl34GetNumCharactersThatFitWithinWidthERK11UTF16Stringfij(HEAP32[i2 + 48 >> 2] | 0, i3, f4, i5, i6) | 0;
}

function __ZNK19ShaderPropertySheet14GetVectorArrayEi(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i1 = HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i4 = i1 >>> 20 & 1023;
 HEAP32[i2 + 4 >> 2] = i4;
 if (!i4) {
  i4 = 0;
  HEAP32[i2 >> 2] = i4;
  return;
 }
 i4 = (HEAP32[i3 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZNK19ShaderPropertySheet14GetMatrixArrayEi(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i1 = HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i4 = i1 >>> 20 & 1023;
 HEAP32[i2 + 4 >> 2] = i4;
 if (!i4) {
  i4 = 0;
  HEAP32[i2 >> 2] = i4;
  return;
 }
 i4 = (HEAP32[i3 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZNK14UnityWebStream19GetProgressForSceneEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 if (!i1) {
  f3 = HEAP8[i2 + 19 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
  return Math_fround(f3);
 } else {
  f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0));
  return Math_fround(f3);
 }
 return f0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12getNbClassesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 128 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i2 = HEAP32[i1 + 124 >> 2] | 0;
 i3 = 0;
 i1 = 0;
 do {
  i1 = ((HEAP32[i2 + (i3 << 2) >> 2] | 0) != 0 & 1) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while (i3 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZN5physx9PxTaskMgr13decrReferenceERNS_14PxLightCpuTaskE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0) return;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0);
  return;
 } else {
  mftCall_vii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, i2 | 0);
  return;
 }
}

function __ZN5physx8debugger15ForwardingArrayIjED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIhED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148752 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger15ForwardingArrayIcED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149616 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) {
  __ZdlPv(i1);
  return;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 if (!(HEAP32[i2 >> 2] & 16384)) __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 28 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 if (!(HEAP32[i2 >> 2] & 16384)) __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 28 | 0, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD4DSPI7getInfoEPcPjPiS3_S3_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 HEAP32[i6 >> 2] = 78;
 HEAP32[i6 + 4 >> 2] = gb + 857570;
 _printf(gb + 857490 | 0, i6) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN23SharedMeshRenderingData18UnloadVertexStreamEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 12 + (i2 << 3) | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i4 >> 2] | 0) + 236 >> 2] | 0, i4 | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 12 + (i2 << 3) + 4 >> 2] = 0;
 return;
}

function __ZN17SurfaceEffector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN17ProceduralTexture14SetAlphaSourceE20ProceduralOutputTypejbb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0, i7 = 0;
 i7 = i1 + 200 | 0;
 i6 = i7;
 HEAP32[i6 >> 2] = HEAP32[i7 >> 2];
 HEAP32[i6 + 4 >> 2] = i3;
 HEAP8[i1 + 180 >> 0] = i4 & 1;
 HEAP32[i1 + 164 >> 2] = i2;
 HEAP8[i1 + 181 >> 0] = i5 & 1;
 return;
}

function __ZN17CapsuleCollider2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN17AudioChorusFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 60 >> 2] = Math_fround(40.0);
 HEAPF32[i1 + 64 >> 2] = Math_fround(.800000011);
 HEAPF32[i1 + 68 >> 2] = Math_fround(.0299999993);
 return;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 402117 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN12_GLOBAL__N_1L4gXORERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = HEAP16[i2 >> 1] ^ HEAP16[i1 >> 1];
 HEAP16[i3 + 2 >> 1] = HEAP16[i2 + 2 >> 1] ^ HEAP16[i1 + 2 >> 1];
 HEAP16[i3 + 4 >> 1] = HEAP16[i2 + 4 >> 1] ^ HEAP16[i1 + 4 >> 1];
 HEAP16[i3 + 6 >> 1] = HEAP16[i2 + 6 >> 1] ^ HEAP16[i1 + 6 >> 1];
 return;
}

function __ZN12_GLOBAL__N_1L4gANDERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = HEAP16[i2 >> 1] & HEAP16[i1 >> 1];
 HEAP16[i3 + 2 >> 1] = HEAP16[i2 + 2 >> 1] & HEAP16[i1 + 2 >> 1];
 HEAP16[i3 + 4 >> 1] = HEAP16[i2 + 4 >> 1] & HEAP16[i1 + 4 >> 1];
 HEAP16[i3 + 6 >> 1] = HEAP16[i2 + 6 >> 1] & HEAP16[i1 + 6 >> 1];
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager25recordDeallocationHandlerEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 204 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = HEAP32[i2 + 172 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN11AudioSource17SetSamplePositionEj(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i2 + 16 >> 2] | 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  __ZN20SoundChannelInstance14SetPositionPCMEj(i1, i4) | 0;
 }
 HEAP32[i3 + 528 >> 2] = i4;
 return;
}

function __ZL19OnLightProbesUpdatev() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1110944 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + (i2 << 2) | 0;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP32[i3 + 44 >> 2] | 0)) HEAP8[i3 + 154 >> 0] = 1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __Z46TrailRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 180 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45Animator_Get_Custom_PropRightFeetBottomHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator24GetRightFeetBottomHeightEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44WheelJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12WheelJoint2D19GetJointTranslationEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44TrailRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 384 >> 2] | 0) + 16 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44RelativeJoint2D_Get_Custom_PropAngularOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK15RelativeJoint2D16GetAngularOffsetEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44PhysicMaterial_Get_Custom_PropStaticFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14PhysicMaterial17GetStaticFrictionEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44ParticleEmitter_Get_Custom_PropParticleCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ((HEAP32[i2 + 60 >> 2] | 0) - (HEAP32[i2 + 56 >> 2] | 0) | 0) / 48 | 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43ParticleSystem_Get_Custom_PropPlaybackSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14ParticleSystem18GetSimulationSpeedEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Terrain_Set_Custom_PropDetailObjectDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain22SetDetailObjectDensityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AnimationClip_Get_Custom_PropHumanMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39GUI_CUSTOM_INTERNAL_get_backgroundColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z11GetGUIStatev() | 0;
 i4 = HEAP32[i5 + 32 >> 2] | 0;
 i3 = HEAP32[i5 + 36 >> 2] | 0;
 i2 = HEAP32[i5 + 40 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 28 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z39Cloth_Set_Custom_PropWorldVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth21SetWorldVelocityScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Cloth_Set_Custom_PropCollisionMassScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth21SetCollisionMassScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Joint2D_Set_Custom_PropEnableCollisionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Joint2D18SetEnableCollisionEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUITexture_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10GUITexture8SetColorERK10ColorRGBAf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Rigidbody2D_CUSTOM_SetDragBehaviourP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D16SetDragBehaviourEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31TextMesh_Set_Custom_PropTabSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh10SetTabSizeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31TextMesh_Set_Custom_PropOffsetZP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh10SetOffsetZEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Shader_CUSTOM_GetGlobalTexturei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i4 = i2;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 i1 = __Z22GetShaderGlobalTextureN9ShaderLab16FastPropertyNameE(i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i1, i2, 1, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 16) | 0, 16, i4) | 0;
 return;
}

function __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i1, i2, 2, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 64) | 0, 64, i4) | 0;
 return;
}

function __GLOBAL__sub_I_PluginInterfaceVR_cpp() {
 var i1 = 0;
 HEAP32[gb + 1469348 >> 2] = 0;
 HEAP32[gb + 1469348 + 4 >> 2] = 0;
 HEAP32[gb + 1469348 + 8 >> 2] = 0;
 i1 = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1469348 + 12 >> 2] = i1;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1573590 | 0, fb + 3951 | 0, 0, 0, 0);
 return;
}

function _UNITY_png_create_read_struct(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = _UNITY_png_create_png_struct(i1, i2, i3, i4, 0, 0, 0) | 0;
 if (!i1) return i1 | 0;
 HEAP32[i1 + 204 >> 2] = 32768;
 HEAP32[i1 + 652 >> 2] = 8192;
 i4 = i1 + 208 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 3145728;
 _UNITY_png_set_read_fn(i1, 0, 0);
 return i1 | 0;
}

function _UNITY_FT_Stream_GetUShortLE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i4 = 0;
  HEAP32[i2 >> 2] = i3;
  return i4 | 0;
 }
 i4 = ((HEAPU8[i4 >> 0] | 0) << 8 | (HEAPU8[i3 >> 0] | 0)) & 65535;
 i3 = i3 + 2 | 0;
 HEAP32[i2 >> 2] = i3;
 return i4 | 0;
}

function b87(i1, i2, i8, i9, i10, i11, i12, i13, i14, f15, f3, f4, f5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 f15 = Math_fround(f15);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiiiiiiiiiffffii(87);
 return 0;
}

function _memmove(i1, i4, i2) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i4 | 0) < (i1 | 0) & (i1 | 0) < (i4 + i2 | 0)) {
  i3 = i1;
  i4 = i4 + i2 | 0;
  i1 = i1 + i2 | 0;
  while ((i2 | 0) > 0) {
   i1 = i1 - 1 | 0;
   i4 = i4 - 1 | 0;
   i2 = i2 - 1 | 0;
   HEAP8[i1 >> 0] = HEAP8[i4 >> 0] | 0;
  }
  i1 = i3;
 } else _memcpy(i1, i4, i2) | 0;
 return i1 | 0;
}

function __ZNSt3__212strstreambuf9underflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = i1 + 16 | 0;
 if ((i2 | 0) == (HEAP32[i3 >> 2] | 0)) {
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  if (i2 >>> 0 < i1 >>> 0) {
   HEAP32[i3 >> 2] = i1;
   i4 = 4;
  } else i1 = -1;
 } else i4 = 4;
 if ((i4 | 0) == 4) i1 = HEAPU8[i2 >> 0] | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_RKS4_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_RKS4_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i3 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__25ctypeIwE10do_scan_isEtPKwS3_(i2, i3, i1, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) {
   i1 = i4;
   break;
  }
  i2 = HEAP32[i1 >> 2] | 0;
  if (i2 >>> 0 < 128) if ((HEAP16[(__ZNSt3__25ctypeIcE13classic_tableEv() | 0) + (i2 << 1) >> 1] & i3) << 16 >> 16) break;
  i1 = i1 + 4 | 0;
 }
 return i1 | 0;
}

function __ZNK7Joint2D17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (f2 < Math_fround(.0000999999974) | (i1 | 0) == 0) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(+mftCall_fif(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, +Math_fround(Math_fround(1.0) / f2)));
 return Math_fround(f2);
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5Umbra14TomeCollection11getNumTomesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 3 & -4;
 i2 = i3;
 if ((i1 | 0) == 0 | (i3 | 0) == 0) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) {
  i3 = i1;
  return i3 | 0;
 }
 if (!(HEAP32[i2 + 32 >> 2] | 0)) i1 = 0; else i1 = (HEAP8[i2 + 24 >> 0] | 0) == 0;
 i3 = i1 & 1;
 return i3 | 0;
}

function __ZNK19ShaderPropertySheet13GetFloatArrayEi(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i1 = HEAP32[(HEAP32[i3 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i4 = i1 >>> 20 & 1023;
 HEAP32[i2 + 4 >> 2] = i4;
 if (!i4) {
  i4 = 0;
  HEAP32[i2 >> 2] = i4;
  return;
 }
 i4 = (HEAP32[i3 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148304 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx3Ext7D6Joint17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 76 | 0;
 HEAP32[i3 >> 2] = __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE(i1, HEAP32[i3 >> 2] | 0, i2 + 12 | 0, gb + 87140 | 0) | 0;
 return;
}

function __ZN5physx2Sn13XmlNodeReaderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 146564 + 8;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!((i1 | 0) > -1 & (i1 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra7ImpTile17getPortalDataSizeEPKS0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = HEAP32[i1 + 52 >> 2] & 65535;
 i4 = i3 + -1 | 0;
 i2 = i1 + i2 | 0;
 i2 = ((HEAP32[i2 + (i4 * 36 | 0) + 4 >> 2] | 0) + (HEAP32[i2 + (i4 * 36 | 0) >> 2] | 0) << 4) + (i3 * 36 | 0) | 0;
 return i2 | 0;
}

function __ZN35RegisterRuntimeInitializeAndCleanup14ExecuteCleanupEv() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 1170888 >> 2] | 0;
 if ((i1 | 0) <= 0) return;
 do {
  i2 = i1;
  i1 = i1 + -1 | 0;
  i3 = HEAP32[gb + 1170892 + (i1 * 20 | 0) + 12 >> 2] | 0;
  if (i3 | 0) mftCall_vi(i3 | 0, HEAP32[gb + 1170892 + (i1 * 20 | 0) + 4 >> 2] | 0);
 } while ((i2 | 0) > 1);
 return;
}

function __ZN18DownloadHandlerVFS17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 20 | 0;
 if (!(__ZN15FileSystemEntry8IsLockedEv(i2) | 0)) {
  i2 = i1 + 8 | 0;
  HEAP8[i2 >> 0] = 1;
  return;
 }
 __ZN12FileAccessor5CloseEv(i1 + 1080 | 0) | 0;
 __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(i2, 8, 0) | 0;
 i2 = i1 + 8 | 0;
 HEAP8[i2 >> 0] = 1;
 return;
}

function __ZN16CircleCollider2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15FrictionJoint2D12SetMaxTorqueEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 100 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN15b2FrictionJoint12SetMaxTorqueEf(i2, f1);
 return;
}

function __ZN12_GLOBAL__N_1L3gORERN5physx12PxGroupsMaskERKS1_S4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i3 >> 1] = HEAP16[i2 >> 1] | HEAP16[i1 >> 1];
 HEAP16[i3 + 2 >> 1] = HEAP16[i2 + 2 >> 1] | HEAP16[i1 + 2 >> 1];
 HEAP16[i3 + 4 >> 1] = HEAP16[i2 + 4 >> 1] | HEAP16[i1 + 4 >> 1];
 HEAP16[i3 + 6 >> 1] = HEAP16[i2 + 6 >> 1] | HEAP16[i1 + 6 >> 1];
 return;
}

function __ZN12_GLOBAL__N_112PropDescImplD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148768 + 8;
 HEAP32[i1 + 52 >> 2] = gb + 148928 + 8;
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 64 >> 2] | 0);
 return;
}

function __ZN12LightManager11RemoveLightEP5Light(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i2 | 0) == 0;
 i1 = i1 ? 0 : (i1 ? 0 : i2 + 36 | 0) + -36 | 0;
 i2 = i1 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 40 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12AudioManager14OnExitPlayModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 68 | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 i2 = i1;
 if ((i2 | 0) == (i3 | 0)) return;
 do {
  i4 = HEAP32[i1 + 8 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i4 >> 2] | 0) + 124 >> 2] | 0, i4 | 0);
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = i1;
 } while ((i2 | 0) != (i3 | 0));
 return;
}

function __ZN11TimeManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 441051 | 0, i1, 0);
 __ZN11TimeManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11TerrainData23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 932069 | 0, i1, 0);
 __ZN11TerrainData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 802696 | 0, i1, 0);
 __ZN11Rigidbody2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 842663 | 0, i1, 0);
 __ZN11OffMeshLink8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 843566 | 0, i1, 0);
 __ZN11NavMeshData8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11MonoManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 463981 | 0, i1, 0);
 __ZN11MonoManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11LightProbes23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 378404 | 0, i1, 0);
 __ZN11LightProbes8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 867588 | 0, i1, 0);
 __ZN11AudioSource8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 365485 | 0, i1, 0);
 __ZN11AssetBundle8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10Matrix3x4fC2ERK10Matrix3x3f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3;
 i2 = i4 + 36 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAPF32[i3 + 44 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 40 >> 2] = Math_fround(0.0);
 HEAPF32[i3 + 36 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10GUITexture8SetColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 60 >> 2] = i5;
 HEAP32[i1 + 64 >> 2] = i4;
 HEAP32[i1 + 68 >> 2] = i3;
 __ZN10GUITexture10BuildSheetEv(i1);
 return;
}

function __ZN10Effector2D12BeginContactEP9b2Contact(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 60 >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 60 >> 2] | 0;
 __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact(0, i2, i3, i1);
 __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact(1, i3, i2, i1);
 return;
}

function __Z45LineRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 344 >> 2] | 0) + 180 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_Get_Custom_PropTreeLODBiasMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK7Terrain24GetTreeLODBiasMultiplierEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44CharacterController_Get_Custom_PropSkinWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN19CharacterController12GetSkinWidthEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43LineRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 344 >> 2] | 0) + 16 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41TargetJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13TargetJoint2D15SetDampingRatioEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41SpringJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SpringJoint2D15SetDampingRatioEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41PlatformEffector2D_Set_Custom_PropSideArcP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18PlatformEffector2D10SetSideArcEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41PhysicsMaterial2D_Set_Custom_PropFrictionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17PhysicsMaterial2D11SetFrictionEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41BuoyancyEffector2D_Set_Custom_PropDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN18BuoyancyEffector2D10SetDensityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41AreaEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D14SetAngularDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Light_Set_Custom_PropAlreadyLightmappedP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Light13SetBakedIndexEi(i3, i2 << 24 >> 24 ? -1 : -2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38TerrainData_CUSTOM_RemoveTreePrototypeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12TreeDatabase19RemoveTreePrototypeEi(i3 + 84 | 0, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38SpringJoint_Set_Custom_PropMinDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity11SpringJoint14SetMinDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38SpringJoint_Set_Custom_PropMaxDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity11SpringJoint14SetMaxDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38RenderTexture_Get_Custom_PropIsCubemapP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0) == 4 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37SliderJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D11SetUseMotorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37HingeJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12HingeJoint2D12SetUseLimitsEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AudioSource_Set_Custom_PropSpatializeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource13SetSpatializeEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34HingeJoint_Set_Custom_PropUseMotorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity10HingeJoint11SetUseMotorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Display_CUSTOM_GetRenderingExtImpl13Il2Cpp_IntPtrPiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __Z16GetScreenManagerv() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 i2 = __Z16GetScreenManagerv() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __Z29DirectorPlayer_CUSTOM_SetTimeP12Il2CppObjectd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   mftCall_vid(HEAP32[(HEAP32[i3 >> 2] | 0) + 156 >> 2] | 0, i3 | 0, +d2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __ZN15PolynomialCurve12IsValidCurveERK17AnimationCurveTplIfE(i2) | 0;
 i1 = (i1 & -2) << 16 >> 16 != 2;
 if (i1 | i3 ^ 1) {
  i3 = i1 & i3;
  return i3 | 0;
 }
 i3 = __ZN15PolynomialCurve12IsValidCurveERK17AnimationCurveTplIfE(i2 + 88 | 0) | 0;
 return i3 | 0;
}

function __Z21pqHeapDeletePriorityQP9TESSallocP13PriorityQHeap(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 i1 = i1 + 12 | 0;
 mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0);
 mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 mftCall_vii(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i2 | 0);
 return;
}

function _unity_z_deflateTune(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!i1) {
  i5 = -2;
  return i5 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i5 = -2;
  return i5 | 0;
 }
 HEAP32[i1 + 140 >> 2] = i2;
 HEAP32[i1 + 128 >> 2] = i3;
 HEAP32[i1 + 144 >> 2] = i4;
 HEAP32[i1 + 124 >> 2] = i5;
 i5 = 0;
 return i5 | 0;
}

function ___cxx_global_var_init() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(1.1920929e-07);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097856 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7crbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + i1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNK6Object12GetClassNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1110260 >> 2] | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(i2, HEAP32[(HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 4 + ((HEAP32[i1 + 8 >> 2] | 0) >>> 21 << 2) >> 2] | 0) + 16 >> 2] | 0) | 0;
 if (!i1) {
  i2 = gb + 1576256 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZNK5physx2Sq12BucketPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE(i4, i2, i5, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (HEAP8[i4 + 7600 >> 0] | 0) {
  i5 = 1;
  return i5 | 0;
 }
 i5 = __ZNK5physx2Sq16BucketPrunerCore7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE(i4 + 16 | 0, i2, i5, i1, i3) | 0;
 return i5 | 0;
}

function __ZN9GfxDevice17ImmediateTexCoordEifff(i1, i2, f3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 if (i2 >>> 0 >= 4) return;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) >> 2] = f3;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) + 4 >> 2] = f4;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) + 8 >> 2] = f5;
 return;
}

function __ZN9GfxDevice14OnDeleteBufferEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i2 | 0) == 0;
 i1 = i1 ? 0 : (i1 ? 0 : i2 + 4 | 0) + -4 | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 8 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8UserList15GetEntryInOtherEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1 + (i2 << 3) | 0;
 i1 = HEAP32[i1 + (i2 << 3) + 4 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i3 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  return i3 | 0;
 } else {
  i3 = (HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0) + (i1 << 3) | 0;
  return i3 | 0;
 }
 return 0;
}

function __ZN6Socket15SetSocketOptionEiib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i4 & 1;
 i4 = __Z15setsockopt_stubiiiPKvj(HEAP32[i1 + 4 >> 2] | 0, i2, i3, i6, 4) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __ZN5physx34solveFriction_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx2Sc21ArticulationJointCore13setTwistLimitEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 HEAPF32[i2 + 140 >> 2] = f1;
 HEAPF32[i2 + 136 >> 2] = f3;
 HEAPF32[i2 + 164 >> 2] = Math_fround(+Math_tan(+Math_fround(f3 * Math_fround(.25))));
 HEAPF32[i2 + 168 >> 2] = Math_fround(+Math_tan(+Math_fround(f1 * Math_fround(.25))));
 return;
}

function __ZN5physx2Sc21ArticulationJointCore13setSwingLimitEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 HEAPF32[i1 + 112 >> 2] = f2;
 HEAPF32[i1 + 116 >> 2] = f3;
 HEAPF32[i1 + 152 >> 2] = Math_fround(+Math_tan(+Math_fround(f2 * Math_fround(.25))));
 HEAPF32[i1 + 156 >> 2] = Math_fround(+Math_tan(+Math_fround(f3 * Math_fround(.25))));
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i3 + 20 | 0, i2, i1, i4);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i2, i1);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i1 + 20 | 0, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i2, i1);
 return;
}

function __ZN5physx13PxCloneStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_12PxRigidActorE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 __ZN5physx12_GLOBAL__N_120copyStaticPropertiesERNS_12PxRigidActorERKS1_(i1, i3);
 i3 = i1;
 return i3 | 0;
}

function __ZN5physx11HullLibraryC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, 12, gb + 730220 | 0, 1369) | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN2UI14DoSyncClippingERNS_13UIInstructionEbRK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 667 >> 0] = i2 & 1;
 i2 = i1 + 648 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i3 + 12 >> 2];
 HEAP16[i1 + 664 >> 1] = 2;
 return;
}

function __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNKSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE14__count_uniqueIS6_EEjRKT_(i1 + 96 | 0, i2) | 0) == 1 | 0;
}

function __ZN15PointEffector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15CollisionEvents10SortEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = HEAP32[i1 >> 2] | 0;
 __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_(i3, i3 + ((HEAP32[i1 + 12 >> 2] | 0) * 44 | 0) | 0, i2);
 STACKTOP = i2;
 return;
}

function __ZN14ParticleSystem13SetStartSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 352 >> 2] = f2;
 HEAP8[i1 + 358 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 272 | 0, i1 + 360 | 0, f2, HEAP16[i1 + 356 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN14ParticleSystem12KeepUpdatingEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 i1 = HEAP32[i3 + 40 >> 2] | 0;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i2 >> 2] | 0) != 1) {
  HEAP32[i2 >> 2] = 1;
  HEAP8[i1 + 13 >> 0] = 1;
 }
 __ZN14ParticleSystem12AddToManagerEv(i3);
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 855855 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10UnityScene18UnloadSceneObjectsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 104 | 0;
 i2 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + 100 | 0;
 if ((i2 | 0) == (i3 | 0)) return; else i1 = i2;
 do {
  __Z22DestroyObjectHighLevelP6Objectb(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 28 >> 2] | 0, 0);
  i1 = HEAP32[i4 >> 2] | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN10SampleClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 853549 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10AudioMixerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 174168 + 8;
 i2 = i1 + 48 | 0;
 if ((HEAP32[i1 + 64 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 52 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZL41RuntimeInitializeOnSceneLoadedBeforeAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 2:
 case 4:
  break;
 default:
  return;
 }
 __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadE25RuntimeInitializeLoadType(__Z21GetManagerFromContexti(19) | 0, 1);
 return;
}

function __Z61AnimationClip_CUSTOM_INTERNAL_CALL_EnsureQuaternionContinuityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13AnimationClip26EnsureQuaternionContinuityEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50ParticleRenderer_Set_Custom_PropParticleRenderModeP12Il2CppObject18ParticleRenderMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 340 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46ParticleSystemRenderer_Set_Custom_PropSortModeP12Il2CppObject22ParticleSystemSortMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP16[i3 + 342 >> 1] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D12MoveRotationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45PhysicMaterial_Set_Custom_PropFrictionCombineP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14PhysicMaterial18SetFrictionCombineEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45NavMeshAgent_Set_Custom_PropAvoidancePriorityP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent20SetAvoidancePriorityEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45AudioReverbFilter_Set_Custom_PropReverbPresetP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17AudioReverbFilter15SetReverbPresetEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Animator_Get_Custom_PropLeftFeetBottomHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator23GetLeftFeetBottomHeightEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43SliderJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13SliderJoint2D17GetReferenceAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41ReflectionProbe_Set_Custom_PropImportanceP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ReflectionProbe13SetImportanceEs(i3, i2 & 65535);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41CharacterController_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41CharacterController_Set_Custom_PropHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19CharacterController9SetHeightEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AudioSource_Set_Custom_PropSpatialBlendP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource18SetSpatialBlendMixEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38WebCamTexture_Get_Custom_PropIsPlayingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Transform_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform11SetPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody11SetVelocityERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody11SetPositionERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38ParticleEmitter_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38BoxCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11BoxCollider9SetCenterERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37RenderTexture_Get_Custom_PropIsVolumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0) == 3 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Animator_Set_Custom_PropStabilizeFeetP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator16SetStabilizeFeetEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUI_CUSTOM_INTERNAL_set_contentColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __Z11GetGUIStatev() | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 48 >> 2] = i5;
 HEAP32[i2 + 52 >> 2] = i4;
 HEAP32[i2 + 56 >> 2] = i3;
 return;
}

function __Z34Object_CUSTOM_Internal_CloneSingleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z11CloneObjectR6Object(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30Animator_CUSTOM_GetLayerWeightP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZN8Animator14GetLayerWeightEi(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function _UNITY_FT_Stream_GetUShort(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 + 1 | 0;
 if (i4 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i4 = 0;
  HEAP32[i2 >> 2] = i3;
  return i4 | 0;
 }
 i4 = ((HEAPU8[i3 >> 0] | 0) << 8 | (HEAPU8[i4 >> 0] | 0)) & 65535;
 i3 = i3 + 2 | 0;
 HEAP32[i2 >> 2] = i3;
 return i4 | 0;
}

function ___munmap(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 mftCall_vi(fb + 3993 | 0, -1);
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall91(91, i4 | 0) | 0) | 0;
 mftCall_v(fb + 455 | 0);
 STACKTOP = i3;
 return i2 | 0;
}

function ___cxx_global_var_init10() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(7.99900007);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097696 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__217__call_once_proxyINS_5tupleIJONS_12_GLOBAL__N_111__fake_bindEEEEEEvPv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = (HEAP32[i2 >> 2] | 0) + (i3 >> 1) | 0;
 if (i3 & 1) i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + i1 >> 2] | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i3 = HEAP32[i1 >> 2] | 0; else i3 = i1;
 i2 = (HEAP32[i2 >> 2] | 0) - i3 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj(i1, i2, 1) | 0;
 return i3 + i2 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + i1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNK9GfxDevice18GetWorldViewMatrixEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 3612 | 0;
 if (!(HEAP32[i2 >> 2] & 3)) {
  i2 = i1 + 3548 | 0;
  return i2 | 0;
 } else {
  i3 = i1 + 3548 | 0;
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i1 + 1828 | 0, i1 + 3420 | 0, i3);
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -4;
  i2 = i3;
  return i2 | 0;
 }
 return 0;
}

function __ZNK9AudioClip16GetBitsPerSampleEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) if (HEAP32[i1 + 124 >> 2] | 0) {
  i1 = HEAP32[i1 + 56 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZNK14SoundHandleAPI16GetBitsPerSampleEv(i1) | 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5Umbra14TomeCollection7getSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP8[i1 + 24 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i2 >> 2] | 0) == -1163018018) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZN9GfxDevice25IsRenderTargetConfigValidEjj19RenderTextureFormat17DepthBufferFormat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2] | 0) < (i2 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2] | 0) >= (i3 | 0);
 return i5 | 0;
}

function __ZN8Collider16RecreateColliderEPK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i3) return;
 if (!(__ZNK10GameObject8IsActiveEv(i3) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4sizeEv(i1 + 416 | 0) | 0;
 return __ZN5physx5PxMaxIjEET_S1_S1_(i2 * 80 | 0, (__ZNK5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4sizeEv(i1 + 392 | 0) | 0) << 5) | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 8) __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15setActorSimFlagEb(i2, i3);
 __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 839010 | 0, i1, 0);
 __ZN5Unity5Cloth8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN2UI13CanvasManager8SortListEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = fb + 1103;
 __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_(i4, i1, i3);
 STACKTOP = i2;
 return;
}

function __ZN25b2PolygonAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b(i2, HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4, 0);
 return;
}

function __ZN21ImposterRenderTexture12SetUseMipmapEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 36 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN6Camera16SetTargetTextureEP13RenderTexture(HEAP32[i1 + 16 >> 2] | 0, HEAP32[(i2 ? i1 + 24 | 0 : i1 + 20 | 0) >> 2] | 0);
 i3 = 1;
 return i3 | 0;
}

function __ZN18MultiFrameGUIState15GetControlNamedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) | 0;
 return i2 | 0;
}

function __ZN15CollisionModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i2 + 996 | 0, i4);
 STACKTOP = i1;
 return;
}

function __ZN14AreaEffector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12EventManager8AddEventEPFvPvS0_iES0_P10EventEntry(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i1 = __ZN10MemoryPool8AllocateEv(i1) | 0;
 i5 = i1 + 8 | 0;
 HEAP32[i5 >> 2] = 0;
 HEAP32[i5 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i4;
 return i1 | 0;
}

function __ZN10TagManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 370841 | 0, i1, 0);
 __ZN10TagManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 455653 | 0, i1, 0);
 __ZN10MonoScript8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10GameObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 368689 | 0, i1, 0);
 __ZN10GameObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10GUITexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 385664 | 0, i1, 0);
 __ZN10GUITexture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10FileSystem21MountMemoryFileSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 40 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i4 + 1;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i4 | 0) > 0) {
  i4 = i3;
  return i4 | 0;
 }
 __ZN10FileSystem12MountHandlerEP17FileSystemHandler(i1, i3) | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 return i4 | 0;
}

function __ZN10Effector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800893 | 0, i1, 0);
 __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800956 | 0, i1, 0);
 __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 862985 | 0, i1, 0);
 __ZN10AudioMixer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZL40RuntimeInitializeOnSceneLoadedAfterAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 switch (i3 | 0) {
 case 2:
 case 4:
  break;
 default:
  return;
 }
 __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadE25RuntimeInitializeLoadType(__Z21GetManagerFromContexti(19) | 0, 0);
 return;
}

function __Z48ParticleAnimator_Set_Custom_PropDoesAnimateColorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 112 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47WebCamTexture_Get_Custom_PropVideoRotationAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 216 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_zDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 228 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_yDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 216 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_xDriveP12Il2CppObjectP10JointDrive(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 204 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43TrailRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 384 >> 2] | 0) + 184 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Rigidbody_Get_Custom_PropMaxAngularVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody21GetMaxAngularVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43CanvasRenderer_Set_Custom_PropMaterialCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI14CanvasRenderer16SetMaterialCountEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40WheelCollider_Set_Custom_PropMotorTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider14SetMotorTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40WheelCollider_Set_Custom_PropBrakeTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider14SetBrakeTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40RelativeJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15RelativeJoint2D12SetMaxTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40PhysicMaterial_Set_Custom_PropBouncinessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14PhysicMaterial13SetBouncinessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40NavMeshAgent_Set_Custom_PropAngularSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent15SetAngularSpeedEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40NavMeshAgent_Set_Custom_PropAccelerationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent15SetAccelerationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40FrictionJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15FrictionJoint2D12SetMaxTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40FixedJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12FixedJoint2D15SetDampingRatioEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioSource_Set_Custom_PropReverbZoneMixP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource16SetReverbZoneMixEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AreaEffector2D_Set_Custom_PropForceAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D13SetForceAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38RenderTexture_Set_Custom_PropUseMipMapP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture9SetMipMapEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36WheelJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12WheelJoint2D11SetUseMotorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Rigidbody2D_Set_Custom_PropSimulatedP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D12SetSimulatedEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36OffMeshLink_Set_Custom_PropActivatedP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11OffMeshLink12SetActivatedEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36HingeJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12HingeJoint2D11SetUseMotorEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36GUI_CUSTOM_INTERNAL_get_contentColorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z11GetGUIStatev() | 0;
 i4 = HEAP32[i5 + 48 >> 2] | 0;
 i3 = HEAP32[i5 + 52 >> 2] | 0;
 i2 = HEAP32[i5 + 56 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 44 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z35LensFlare_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9LensFlare8SetColorERK10ColorRGBAf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Skybox_Get_Custom_PropMaterialP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK6Skybox11GetMaterialEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj(i1, i2, 0, __Z27scripting_array_element_ptrP11Il2CppArrayij(i3, 0, 4) | 0, 4, i4) | 0;
 return;
}

function __Z26Avatar_CUSTOM_SetParameterP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN6Avatar12SetParameterEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24FullscreenChangeCallbackiPK31EmscriptenFullscreenChangeEventPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  _emscripten_set_canvas_size(HEAP32[i3 + 64 >> 2] | 0, HEAP32[i3 + 68 >> 2] | 0);
  return 1;
 } else {
  _emscripten_set_canvas_size(HEAP32[i2 + 272 >> 2] | 0, HEAP32[i2 + 276 >> 2] | 0);
  return 1;
 }
 return 0;
}

function __Z18HermiteCooficientsdRdS_S_S_(d1, i2, i3, i4, i5) {
 d1 = +d1;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var d6 = 0.0, d7 = 0.0, d8 = 0.0, d9 = 0.0;
 d8 = d1 * d1;
 d9 = d8 * d1;
 d6 = d9 * 2.0;
 d7 = d8 * 3.0;
 HEAPF64[i2 >> 3] = d6 - d7 + 1.0;
 HEAPF64[i3 >> 3] = d9 - d8 * 2.0 + d1;
 HEAPF64[i4 >> 3] = d9 - d8;
 HEAPF64[i5 >> 3] = d7 - d6;
 return;
}

function b44(i1, i2, i10, i11, i12, i13, i14, i15, i16, i17, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i16 = i16 | 0;
 i17 = i17 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_viiiiiiiiiiiiiiiii(44);
}

function _strerror_r(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i2 = _strerror(i1) | 0;
 i1 = _strlen(i2) | 0;
 if (i1 >>> 0 < i4 >>> 0) {
  _memcpy(i3 | 0, i2 | 0, i1 + 1 | 0) | 0;
  i1 = 0;
 } else {
  i1 = i4 + -1 | 0;
  if (!i4) i1 = 34; else {
   _memcpy(i3 | 0, i2 | 0, i1 | 0) | 0;
   HEAP8[i3 + i1 >> 0] = 0;
   i1 = 34;
  }
 }
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputcEw(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 24 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (HEAP32[i2 + 28 >> 2] | 0)) i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 | 0) | 0; else {
  HEAP32[i3 >> 2] = i4 + 4;
  HEAP32[i4 >> 2] = i1;
 }
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i4 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i4 = i1;
  i1 = i2 & 255;
 }
 i4 = i4 + i1 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 return;
}

function __ZNKSt3__219__iostream_category7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) == 1) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1077701 | 0, 35);
 } else __ZNKSt3__212__do_message7messageEi(i1, i2, i3);
 return;
}

function __ZNK9Transform14CountNodesDeepEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i4) {
  i4 = 1;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 80 >> 2] | 0;
 i2 = 0;
 i1 = 1;
 do {
  i1 = (__ZNK9Transform14CountNodesDeepEv(HEAP32[i3 + (i2 << 2) >> 2] | 0) | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZNK8Material21GetShaderKeywordNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE((HEAP32[i1 + 100 >> 2] | 0) + 124 | 0, i2);
 return;
}

function __ZNK20LocalFileSystemPosix9IsSymLinkERK13FileEntryData(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (_lstat(i3, i1) | 0) {
  i3 = 0;
  STACKTOP = i2;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 12 >> 2] & 61440 | 0) == 40960;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN7mecanim12statemachine28DestroyStateMachineWorkspaceEPNS0_21StateMachineWorkspaceERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 __ZN7mecanim12statemachine21DestroyStateWorkspaceEPNS0_14StateWorkspaceERNS_6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i2);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd8SyncImpl3setEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 _pthread_mutex_lock(i2 | 0) | 0;
 i1 = i2 + 80 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  _pthread_mutex_unlock(i2 | 0) | 0;
  return;
 }
 HEAP8[i1 >> 0] = 1;
 i1 = i2 + 76 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 _pthread_cond_broadcast(i2 + 28 | 0) | 0;
 _pthread_mutex_unlock(i2 | 0) | 0;
 return;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizer21visualizeAngularLimitERKNS_11PxTransformEffb(i4, i3, f2, f5, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 __ZN5physx2Cm21visualizeAngularLimitERNS0_12RenderOutputEfRKNS_11PxTransformEffb(HEAP32[i4 + 12 >> 2] | 0, Math_fround(HEAPF32[i4 + 8 >> 2]), i3, f2, f5, i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 i1 = i2 + 120 | 0;
 __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE(i2, 1, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i4 + 20 | 0, i2, i1, i3);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i3 + 20 | 0, i2, i1, i4);
 return;
}

function __ZN4FMOD7SystemI14getDriverInfoWEiPsiP9FMOD_GUID(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 869344;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN29DelayedPointerDeletionManager17GrowPendingBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] << 1;
 i2 = i2 >>> 0 < 128 ? 128 : i2;
 HEAP32[i3 >> 2] = i2;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i1 >> 2] = mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i1 >> 2] | 0, i2 << 2 | 0, 16) | 0;
 return;
}

function __ZN22BaseUnityConnectClient14AppRunningTickEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 104 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) {
  HEAP32[i3 >> 2] = i2;
  return;
 }
 if ((i2 - i4 | 0) >>> 0 < (HEAP32[i1 + 608 >> 2] | 0) >>> 0) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 return;
}

function __ZN17TransformInternal19FreeTransformThreadER18TransformHierarchyjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = i1 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[(HEAP32[i1 + 68 >> 2] | 0) + (i3 << 2) >> 2] = i4;
 if ((i4 | 0) == -1) return;
 HEAP32[(HEAP32[i1 + 72 >> 2] | 0) + (i4 << 2) >> 2] = i3;
 return;
}

function __ZN15PointEffector2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN10Effector2D5ResetEv(i1);
 HEAPF32[i1 + 92 >> 2] = Math_fround(-10.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0);
 i1 = i1 + 104 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN15FrictionJoint2D11SetMaxForceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 96 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN15b2FrictionJoint11SetMaxForceEf(i2, f1);
 return;
}

function __ZN13InitialModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i2 + 2556 | 0, i4);
 STACKTOP = i1;
 return;
}

function __ZN13DrawImmediate13ImmediateVertC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 88 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAPF32[i1 + 24 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 28 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 36 >> 2] = Math_fround(1.0);
 return;
}

function __ZN13BoxCollider2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClient6addRefEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0) | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12NavMeshAgent9ResetPathEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 844688 | 0, 0, gb + 841797 | 0, 621, 1, 0, 0, 0);
  return;
 } else {
  __ZN7dtCrowd14resetAgentPathERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0);
  return;
 }
}

function __ZN11AudioSource12SetAudioClipEP9AudioClip(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = (i3 | 0) == 0;
 if (i4) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 i5 = i2 + 436 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) return;
 __ZN11AudioSource4StopEb(i2, 1);
 if (i4) i1 = 0; else i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 return;
}

function __ZN11AudioFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 853489 | 0, i1, 0);
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZL15CompareVerticesRK8Vector2fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 if (f3 < f4) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(f3 == f4)) {
  i2 = 0;
  return i2 | 0;
 }
 f4 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i2 = f4 < Math_fround(HEAPF32[i2 + 4 >> 2]);
 return i2 | 0;
}

function __Z57ParticleSystemRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 352 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Rigidbody2D_Get_Custom_PropAngularVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11Rigidbody2D18GetAngularVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42LineRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[(HEAP32[i3 + 344 >> 2] | 0) + 184 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42HingeJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12HingeJoint2D17GetReferenceAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42FixedJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12FixedJoint2D17GetReferenceAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbZone_Get_Custom_PropMinDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK15AudioReverbZone14GetMinDistanceEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbZone_Get_Custom_PropMaxDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK15AudioReverbZone14GetMaxDistanceEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Transform_Get_Custom_PropParentInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 + 100 >> 2] | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Cloth_Set_Custom_PropBendingStiffnessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth19SetBendingStiffnessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Terrain_Set_Custom_PropLightmapIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain16SetLightmapIndexEi12LightmapType(i3, i2, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36TerrainData_Set_Custom_PropThicknessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Heightmap12SetThicknessEf(i3 + 248 | 0, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Rigidbody_Set_Custom_PropIsKinematicP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody14SetIsKinematicEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Rigidbody2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZNK11Rigidbody2D16IsTouchingLayersEi(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35OcclusionPortal_Set_Custom_PropOpenP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15OcclusionPortal9SetIsOpenEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31ParticleEmitter_CUSTOM_SimulateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ParticleEmitter20UpdateParticleSystemEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Display_CUSTOM_GetSystemExtImpl13Il2Cpp_IntPtrPiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __Z16GetScreenManagerv() | 0;
 HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
 i2 = __Z16GetScreenManagerv() | 0;
 HEAP32[i3 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __Z30TextMesh_Set_Custom_PropAnchorP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh9SetAnchorEs(i3, i2 & 65535);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24Animator_CUSTOM_HasStateP12Il2CppObjectii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) return (__ZNK8Animator8HasStateEii(i4, i2, i3) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _XXH64_hashFromCanonical(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1;
 i1 = i1 + 4 | 0;
 i1 = _llvm_bswap_i64(HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24 | 0, HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function _initgroups(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 144 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i5 + 8 | 0;
 i4 = i5;
 HEAP32[i4 >> 2] = 32;
 if ((_getgrouplist(i1, i2, i3, i4) | 0) < 0) i1 = -1; else i1 = _setgroups(HEAP32[i4 >> 2] | 0, i3 | 0) | 0;
 STACKTOP = i5;
 return i1 | 0;
}

function __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i1 + -128 | 0, 0, 0) | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7sungetcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) == (i3 | 0)) i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, -1) | 0; else {
  i1 = i3 + -4 | 0;
  HEAP32[i2 >> 2] = i1;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7sungetcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) == (i3 | 0)) i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, -1) | 0; else {
  i1 = i3 + -1 | 0;
  HEAP32[i2 >> 2] = i1;
  i1 = HEAPU8[i1 >> 0] | 0;
 }
 return i1 | 0;
}

function __ZNK5physx2Gu12TriangleMesh14getLocalBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 152 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 156 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 160 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 164 >> 2];
 return;
}

function __ZNK5physx19NpArticulationJoint20getTargetOrientationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] & 4 | 0) == 0 ? i2 + 80 | 0 : (HEAP32[i2 + 16 >> 2] | 0) + 56 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK19TouchPhaseEmulation13GetTouchCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  if ((HEAP32[i4 + (i2 * 96 | 0) + 84 >> 2] | 0) == (i3 | 0)) i1 = ((HEAP32[i4 + (i2 * 96 | 0) >> 2] | 0) != -1 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 32);
 return i1 | 0;
}

function __ZNK18AudioLowPassFilter18GetCutoffFrequencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 100 >> 2] | 0) + 4 >> 2]);
 i1 = f2 < Math_fround(0.0);
 i3 = f2 > Math_fround(1.0);
 f2 = Math_fround(Math_fround((i3 ? Math_fround(1.0) : f2) * Math_fround(21990.0)) + Math_fround(10.0));
 return Math_fround(i1 ? Math_fround(10.0) : f2);
}

function __ZNK14UnityWebStream24GetProgressUntilLoadableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i2) {
  f3 = HEAP8[i1 + 19 >> 0] | 0 ? Math_fround(1.0) : Math_fround(0.0);
  return Math_fround(f3);
 } else {
  f3 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0));
  return Math_fround(f3);
 }
 return f0;
}

function __ZNK13WheelCollider13IsInitializedEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 148 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 52 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 56 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZN9Scripting9GetMethodEP11Il2CppClassPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i2) {
  i4 = gb + 1164176 | 0;
  i2 = HEAP32[i4 + 4 >> 2] | 0;
  i3 = i1;
  HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
  HEAP32[i3 + 4 >> 2] = i2;
  return;
 } else {
  __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i1, i2, i3, -1);
  return;
 }
}

function __ZN9Coroutine18CleanupCoroutineGCEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 48 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 if (HEAP32[i1 + 44 >> 2] | 0) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 if (HEAP32[i1 >> 2] | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 457216 | 0, 0, gb + 456812 | 0, 159, 1, 0, 0, 0);
 __ZdlPv(i1);
 return;
}

function __ZN6Object30StringToClassIDCaseInsensitiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 i1 = __ZN11TypeManager19ClassNameToTypeInfoEPKcb(HEAP32[gb + 1110260 >> 2] | 0, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 1) | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd9MutexImplC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 _pthread_mutexattr_init(i3 | 0) | 0;
 _pthread_mutexattr_settype(i3 | 0, 1) | 0;
 _pthread_mutex_init(i1 | 0, i3 | 0) | 0;
 _pthread_mutexattr_destroy(i3 | 0) | 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc7PhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[gb + 1457332 >> 2] = i3;
 __ZN5physx7PxvInitERKNS_14PxvOffsetTableE(i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra20RuntimeStructBuilderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 140 | 0;
 HEAP32[i2 >> 2] = 0;
 if (!(HEAP32[gb + 1451688 + 8 >> 2] | 0)) {
  HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
  HEAP32[gb + 1451688 + 8 >> 2] = 1;
 }
 HEAP32[i2 >> 2] = gb + 1451688;
 HEAP32[i1 + 144 >> 2] = 0;
 HEAP32[i1 + 148 >> 2] = 0;
 HEAP32[i1 + 152 >> 2] = 0;
 return;
}

function __ZN4FMOD7SystemI13getDriverInfoEiPciP9FMOD_GUID(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 861484;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer19DisableRectClippingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 165 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 HEAP8[i2 >> 0] = 0;
 i2 = i1 + 162 | 0;
 HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 2064;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN23ParticleSystemParticles15WriteCustomDataEPKN4math14float4_storageEii(i1, i4, i2, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 if ((i5 | 0) <= 0) return;
 i2 = i1 + 828 + (i2 * 20 | 0) | 0;
 i3 = i5 << 4;
 i1 = 0;
 do {
  _memcpy(HEAP32[i2 >> 2] | 0, i4 | 0, i3 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZN19ControllerHitReportD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 87504 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~(((i4 + -44 - i2 | 0) >>> 0) / 44 | 0) * 44 | 0);
 __ZdlPv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN15RelativeJoint2D12SetMaxTorqueEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 80 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MotorJoint12SetMaxTorqueEf(i2, f1);
 return;
}

function __ZN14ParticleSystem16SetStartLifeTimeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP8[(HEAP32[i1 + 40 >> 2] | 0) + 26 >> 0] = 1;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 88 >> 2] = f2;
 HEAP8[i1 + 94 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 8 | 0, i1 + 96 | 0, f2, HEAP16[i1 + 92 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN13TargetJoint2D15SetDampingRatioEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 96 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MouseJoint15SetDampingRatioEf(i2, f1);
 return;
}

function __ZN13SpringJoint2D11SetDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(.00499999989);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(.00499999989) : f1;
 HEAPF32[i2 + 96 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 HEAPF32[i2 + 104 >> 2] = f1;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 8;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 1;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i1 = i1 + 4 | 0;
 HEAP32[i4 >> 2] = 4;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i4 | 0) | 0;
 STACKTOP = i3;
 return;
}

function __ZN12NavMeshAgent6ResumeEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845200 | 0, 0, gb + 841797 | 0, 767, 1, 0, 0, 0);
  return;
 } else {
  __ZN7dtCrowd12stopExplicitERK13dtCrowdHandleb(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, 0);
  return;
 }
}

function __Z39WheelCollider_Set_Custom_PropSteerAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider13SetSteerAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Rigidbody2D_Set_Custom_PropGravityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D15SetGravityScaleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39RelativeJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15RelativeJoint2D11SetMaxForceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39OffMeshLink_Set_Custom_PropCostOverrideP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11OffMeshLink15SetCostOverrideEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39FrictionJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15FrictionJoint2D11SetMaxForceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39DistanceJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15DistanceJoint2D11SetDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AudioSource_Set_Custom_PropDopplerLevelP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource15SetDopplerLevelEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36SpringJoint_Set_Custom_PropToleranceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity11SpringJoint12SetToleranceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Motion_Get_Custom_PropIsHumanMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Collider2D_Set_Custom_PropIsTriggerP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10Collider2D12SetIsTriggerEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35AnimationClip_Get_Custom_PropLegacyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Canvas_Set_Custom_PropPixelPerfectP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas15SetPixelPerfectEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33TextMesh_Set_Custom_PropFontStyleP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh12SetFontStyleEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Material_Get_Custom_PropShaderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Material9GetShaderEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30Animator_Get_Custom_PropAvatarP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN8Animator9GetAvatarEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z21DestroyShadowMapCacheP14ShadowMapCache(i1) {
 i1 = i1 | 0;
 if (i1 | 0) __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63632 | 0);
 return;
}

function _UNITY_ft_mem_alloc(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if ((i3 | 0) > 0) {
  i1 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i1 | 0, i3 | 0) | 0;
  if (!i1) {
   i2 = 0;
   i1 = 64;
  } else {
   _memset(i1 | 0, 0, i3 | 0) | 0;
   i2 = i1;
   i1 = 0;
  }
 } else {
  i2 = 0;
  i1 = i3 | 0 ? 6 : 0;
 }
 HEAP32[i4 >> 2] = i1;
 return i2 | 0;
}

function mftCall_iiiiiid(i7, i1, i2, i3, i4, i5, d6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiiiid[i7 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6) | 0;
 return ftCall_iiiiiid(i7 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, +d6) | 0;
}

function _truncf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = (i3 >>> 23 & 255) + -118 | 0;
 if ((i2 | 0) <= 31) {
  i2 = (i2 | 0) < 9 ? 2147483647 : -1 >>> i2;
  if (i2 & i3) f1 = (HEAP32[tempDoublePtr >> 2] = i3 & ~i2, Math_fround(HEAPF32[tempDoublePtr >> 2]));
 }
 return Math_fround(f1);
}

function __ZNK9AudioClip15GetChannelCountEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0)) if (HEAP32[i1 + 124 >> 2] | 0) {
  i1 = HEAP32[i1 + 56 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
  i1 = __ZNK14SoundHandleAPI14GetNumChannelsEv(i1) | 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 return i1 | 0;
}

function __ZNK23ParticleSystemParticles14ReadCustomDataEPN4math14float4_storageEii(i1, i4, i2, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i3 = 0;
 if ((i5 | 0) <= 0) return;
 i2 = i1 + 828 + (i2 * 20 | 0) | 0;
 i3 = i5 << 4;
 i1 = 0;
 do {
  _memcpy(i4 | 0, HEAP32[i2 >> 2] | 0, i3 | 0) | 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __ZNK12TLSAllocatorI14StackAllocatorE17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i1 + 32 >> 2] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, gb + 63160 | 0) | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return i2 | 0;
}

function __ZN9Transform23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1044255 | 0, i1, 0);
 __ZN9Transform8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN7Texture23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 609266 | 0, i1, 0);
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN7Terrain24SetTreeLODBiasMultiplierEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0;
 HEAPF32[i1 + 196 >> 2] = f3;
 i4 = HEAP32[i1 + 240 >> 2] | 0;
 if (!i4) return;
 i2 = HEAP32[i1 + 228 >> 2] | 0;
 i1 = 0;
 do {
  HEAPF32[(HEAP32[i2 + (i1 * 20 | 0) + 8 >> 2] | 0) + 360 >> 2] = f3;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i4 >>> 0);
 return;
}

function __ZN5physx44solveFrictionCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i1, i5, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6);
 return;
}

function __ZN5physx3Ext26computeSphereInertiaTensorERNS_6PxVec3Effb(i2, f3, f4, i1) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i1 = i1 | 0;
 f4 = Math_fround(Math_fround(f3 * f4) * f4);
 f4 = Math_fround(f4 * (i1 ? Math_fround(.666666686) : Math_fround(.400000006)));
 HEAPF32[i2 >> 2] = f4;
 HEAPF32[i2 + 4 >> 2] = f4;
 HEAPF32[i2 + 8 >> 2] = f4;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE(i4 + 20 | 0, i2, i1, i3);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i2, i1);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i1 + 20 | 0, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i2, i1);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 8) __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15setActorSimFlagEb(i2, i3);
 __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5physx15PxsParticleData7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((i1 | 0) == 0 | (HEAP8[i1 + 4 >> 0] | 0) == 0) {
  STACKTOP = i2;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 STACKTOP = i2;
 return;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1012675 | 0, i1, 0);
 __ZN2UI6Canvas8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN17InternalIndexPoolD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 88176 + 8;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN13TargetJoint2D12SetFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 100 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MouseJoint12SetFrequencyEf(i2, f1);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager11isConnectedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZN11TerrainData17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(i1, 256);
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 56 >> 2] | 0);
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 60 >> 2] | 0);
 __ZN12TreeDatabase17MainThreadCleanupEv(i1 + 84 | 0);
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 184 >> 2] | 0);
 return;
}

function __Z48AudioSource_Get_Custom_PropSpatializePostEffectsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource24GetSpatializePostEffectsEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48AudioSource_Get_Custom_PropBypassListenerEffectsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource24GetBypassListenerEffectsEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46OffMeshLink_Set_Custom_PropAutoUpdatePositionsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 96 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ParticleAnimator_Set_Custom_PropAutodestructP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 108 >> 2] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43PhysicMaterial_Set_Custom_PropBounceCombineP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14PhysicMaterial16SetBounceCombineEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43AudioReverbZone_Set_Custom_PropReverbPresetP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15AudioReverbZone15SetReverbPresetEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ConfigurableJoint_Set_Custom_PropZMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint10SetZMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ConfigurableJoint_Set_Custom_PropYMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint10SetYMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40ConfigurableJoint_Set_Custom_PropXMotionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity17ConfigurableJoint10SetXMotionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Rigidbody_Set_Custom_PropSleepThresholdP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody17SetSleepThresholdEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Animator_Set_Custom_PropFeetPivotActiveP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator18SetFeetPivotActiveEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent4MoveERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AnimationClip_Set_Custom_PropFrameRateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13AnimationClip13SetSampleRateEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Renderer_Get_Custom_PropLightmapIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK12BaseRenderer19GetLightmapIndexIntE12LightmapType(i2 + 32 | 0, 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37GL_CUSTOM_INTERNAL_CALL_MultiTexCoordiRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, i5 = 0;
 i5 = __Z12GetGfxDevicev() | 0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 mftCall_viifff(HEAP32[(HEAP32[i5 >> 2] | 0) + 576 >> 2] | 0, i5 | 0, i1 | 0, +f4, +f3, +Math_fround(HEAPF32[i2 + 8 >> 2]));
 return;
}

function __Z36BoxCollider_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11BoxCollider7SetSizeERK8Vector3f(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Rigidbody_Set_Custom_PropUseGravityP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody13SetUseGravityEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35ParticleEmitter_Set_Custom_PropEmitP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ParticleEmitter7SetEmitEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Mesh_CUSTOM_GetBlendShapeFrameCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z33GetBlendShapeFrameCountFromScriptRK4Meshi(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35AnimationClip_Set_Custom_PropLegacyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13AnimationClip9SetLegacyEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Collider2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZNK10Collider2D16IsTouchingLayersEi(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z25Animator_CUSTOM_SetTargetP12Il2CppObjectif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i4 = 0;
 if (!i1) i1 = 0; else {
  i4 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i4) {
   __ZN8Animator9SetTargetEif(i4, i2, f3);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z12ReadIntArrayPPiS_i(i3, i4, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i6 = 0;
 if ((i5 | 0) <= 0) return;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = 0;
 i6 = i2;
 while (1) {
  HEAP32[i4 + (i1 << 2) >> 2] = HEAP32[i6 >> 2];
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == (i5 | 0)) break; else i6 = i6 + 4 | 0;
 }
 HEAP32[i3 >> 2] = i2 + (i5 << 2);
 return;
}

function _FT_MSB(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 >>> 0 > 65535;
 i3 = i2 ? i1 >>> 16 : i1;
 i1 = i2 ? 16 : 0;
 i2 = (i3 & 65280 | 0) == 0;
 i3 = i2 ? i3 : i3 >>> 8;
 i1 = i2 ? i1 : i1 | 8;
 i2 = (i3 & 240 | 0) == 0;
 i3 = i2 ? i3 : i3 >>> 4;
 i1 = i2 ? i1 : i1 | 4;
 i2 = (i3 & 12 | 0) == 0;
 return ((i2 ? i3 : i3 >>> 2) >>> 1 & 1) + (i2 ? i1 : i1 | 2) | 0;
}

function _unzGoToFilePos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i2 = -102;
  return i2 | 0;
 }
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 4 >> 2];
 i2 = _unzlocal_GetCurrentFileInfoInternal(i1, i1 + 72 | 0, i1 + 152 | 0, 0, 0, 0, 0, 0, 0) | 0;
 HEAP32[i1 + 56 >> 2] = (i2 | 0) == 0 & 1;
 return i2 | 0;
}

function __ZNSt3__29strstreamD2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + (HEAP32[i3 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 36 >> 2];
 __ZNSt3__212strstreambufD2Ev(i1 + 12 | 0);
 __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED2Ev(i1, i2 + 4 | 0);
 return;
}

function __ZN9Texture3D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 411365 | 0, i1, 0);
 __ZN9Texture3D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9Texture2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 411078 | 0, i1, 0);
 __ZN9Texture2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 465927 | 0, i1, 0);
 __ZN9TextAsset8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9Rigidbody23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 737574 | 0, i1, 0);
 __ZN9Rigidbody8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9Projector23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 380711 | 0, i1, 0);
 __ZN9Projector8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 373687 | 0, i1, 0);
 __ZN9LensFlare8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9AudioClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 856797 | 0, i1, 0);
 __ZN9AudioClip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN9Animation23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 896226 | 0, i1, 0);
 __ZN9Animation8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN6MotionD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 176392 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx2Sc13ConstraintSim14hasDynamicBodyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 108 >> 2] | 0;
 if (i1 | 0) if (!(HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 44 >> 0] & 1)) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[i1 + 52 >> 2] | 0) + 44 >> 0] & 1) == 0;
 return i2 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE(i2, i1);
 __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE(i1 + 20 | 0, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0);
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i2, i1);
 return;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation17ConvertArchiveJobEPv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 92 >> 2] | 0) != 1) __ZN37AssetBundleLoadFromFileAsyncOperation14ConvertArchiveEv(i1) | 0;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN18PlatformEffector2D19SetRotationalOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-359.999908);
 i4 = f2 > Math_fround(359.999908);
 f2 = i4 ? Math_fround(359.999908) : f2;
 HEAPF32[i1 + 88 >> 2] = i3 ? Math_fround(-359.999908) : f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15RelativeJoint2D11SetMaxForceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 76 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MotorJoint11SetMaxForceEf(i2, f1);
 return;
}

function __ZN12NavMeshAgent4StopEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 845120 | 0, 0, gb + 841797 | 0, 761, 1, 0, 0, 0);
  return;
 } else {
  __ZN7dtCrowd12stopExplicitERK13dtCrowdHandleb(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, 1);
  return;
 }
}

function __ZN11UnityEngine9Animation37HasGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  if ((HEAP32[i1 + 40 >> 2] | 0) != -1) {
   i2 = 1;
   return i2 | 0;
  }
  if ((HEAP32[i1 + 44 >> 2] | 0) != -1) {
   i2 = 1;
   return i2 | 0;
  }
 }
 i2 = (HEAP32[i1 + 48 >> 2] | 0) != -1;
 return i2 | 0;
}

function __ZN11ForceModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = HEAP32[i3 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i2 + 804 | 0, i4);
 STACKTOP = i1;
 return;
}

function __ZN10Effector2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153396 + 8;
 i2 = i1 + 36 | 0;
 if ((HEAP32[i1 + 52 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 40 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10Collider2DD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 153816 + 8;
 i2 = i1 + 60 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 64 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __Z44ReflectionProbe_Set_Custom_PropBoxProjectionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 141 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ParticleEmitter_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 192 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39AudioSource_Get_Custom_PropSpatialBlendP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource18GetSpatialBlendMixEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38TargetJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13TargetJoint2D12SetFrequencyEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38SpringJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SpringJoint2D12SetFrequencyEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody2D_Set_Custom_PropAngularDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D14SetAngularDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38NavMeshAgent_Set_Custom_PropBaseOffsetP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent13SetBaseOffsetEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_Set_Custom_PropMinDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource14SetMinDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_Set_Custom_PropMaxDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource14SetMaxDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Light_Get_Custom_PropShadowNormalBiasP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 116 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Graphics_CUSTOM_GetActiveColorBufferP21ScriptingRenderBuffer(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 348 >> 2] | 0, i3 | 0, 0) | 0;
 return;
}

function __Z33Collider_Get_Custom_PropIsTriggerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32TextMesh_Set_Custom_PropFontSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN20TextRenderingPrivate8TextMesh11SetFontSizeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GameObject_Set_Custom_PropActiveP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10GameObject13SetSelfActiveEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Transform_Get_Custom_PropRootP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN9Transform7GetRootEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z27Avatar_CUSTOM_GetAxisLengthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return Math_fround(__ZNK6Avatar13GetAxisLengthEi(i3, i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z18ConvertUTF8toUTF16RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayItLj2EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i1 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 return __Z18ConvertUTF8toUTF16PKhiR13dynamic_arrayItLj2EE(i4 ? HEAP32[i1 >> 2] | 0 : i1, i4 ? HEAP32[i1 + 4 >> 2] | 0 : i3 & 255, i2) | 0;
}

function _reap(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 while (1) if ((_waitpid(i1 | 0, i2 | 0, 0) | 0) < 0) if ((HEAP32[(___errno_location() | 0) >> 2] | 0) == 4) continue; else break; else if (!(HEAP32[i2 >> 2] & 127)) break; else continue;
 STACKTOP = i3;
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  HEAP32[i2 >> 2] = 0;
  HEAP32[i3 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu18ConvexHullNoScaleV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(HEAP32[i4 + 48 >> 2] | 0, i1, i3, i2);
 return;
}

function __ZNK5physx17AggregateAABBTask25updateNumFastMovingShapesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 + 400 >> 2] | 0) + ((HEAP32[i1 + 340 >> 2] | 0) + ((HEAP32[i1 + 280 >> 2] | 0) + ((HEAP32[i1 + 220 >> 2] | 0) + ((HEAP32[i1 + 160 >> 2] | 0) + (HEAP32[i1 + 100 >> 2] | 0))))));
 return;
}

function __ZNK5physx16PxParticleSystem8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 764992 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 700834 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK26AnimatorControllerPlayable20GetStateMachineMixerEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 92 >> 2] | 0) + 4 | 0;
 i2 = i3 + (HEAP32[i3 >> 2] | 0) + (i2 << 2) | 0;
 i2 = i2 + (HEAP32[i2 >> 2] | 0) | 0;
 return HEAP32[(HEAP32[(HEAP32[i1 + 144 >> 2] | 0) + (HEAP32[i2 >> 2] << 3) >> 2] | 0) + (HEAP32[i2 + 4 >> 2] << 2) >> 2] | 0;
}

function __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE14GetUploadBytesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK15b2DistanceJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 100 >> 2]) * f3);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 116 >> 2]) * f3);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 120 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK14dtNavMeshQuery24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyyPKfPf(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf(i6, i3, i2, i7);
 __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf(i1, i4, i5, i7, i7 + 4 | 0) | 0;
 return;
}

function __ZN9Transform20SendTransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 32 | 0;
 __ZL24SendTransformChangedMaskRK18TransformHierarchyii(HEAP32[i3 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0, i2);
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(HEAP32[gb + 1158396 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN7TerrainD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 184192 + 8;
 i2 = i1 + 228 | 0;
 if ((HEAP32[i1 + 244 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 232 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5physx2Sc21ConstraintInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 90796 + 8;
 HEAP32[i1 + 24 >> 2] = gb + 90796 + 48;
 __ZN5physx2Sc16ActorInteractionD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx27solveExtContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx20solveExtContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (!i3) return; else i1 = 0;
 do {
  __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i4 + (i1 << 5) | 0, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx14PxsAABBManager17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(i2 & 1)) {
  __ZN5physx5Elems17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE(i3 + 8 | 0, i2 >>> 1, i1);
  return;
 } else {
  __ZN5physx5Elems17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE(i3 + 296 | 0, i2 >>> 1, i1);
  return;
 }
}

function __ZN5physx10NpMaterial7setFlagENS_14PxMaterialFlag4EnumEb(i3, i2, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i3 + 44 | 0;
 if (i4) HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | i2; else HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & ((i2 ^ 65535) & 65535);
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i3);
 return;
}

function __ZN5Unity5Cloth16SetEnabledFadingEbf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 if (i2) if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, 1);
 HEAPF32[i1 + 344 >> 2] = i2 ? Math_fround(1.0) : Math_fround(0.0);
 HEAPF32[i1 + 348 >> 2] = f3;
 return;
}

function __ZN30ForwardShaderRenderLoopScratch15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags(i2, i1 + 160 | 0, 0);
 return;
}

function __ZN14PhysicsManager23SetDefaultContactOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 if (!(f2 <= Math_fround(0.0))) {
  HEAPF32[i1 + 48 >> 2] = f2;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737405 | 0, 0, gb + 662472 | 0, 1179, 1, 0, 0, 0);
  return;
 }
}

function __Z53ParticleSystemRenderer_Set_Custom_PropNormalDirectionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 368 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53ParticleSystemRenderer_Set_Custom_PropMinParticleSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 344 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53ParticleSystemRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 348 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z50AnimatorControllerPlayable_CUSTOM_HasStateInternal9HPlayableRS_ii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i2) | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = (__ZNK26AnimatorControllerPlayable8HasStateEii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i3, i4) | 0) & 1;
 return i4 | 0;
}

function __Z43Terrain_Set_Custom_PropCollectDetailPatchesP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 200 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42SkinnedMeshRenderer_Set_Custom_PropQualityP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN19SkinnedMeshRenderer10SetQualityEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42RenderTexture_CUSTOM_Internal_GetDimensionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41Animator_Get_Custom_PropRecorderStartTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator20GetRecorderStartTimeEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40WheelCollider_Get_Custom_PropMotorTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13WheelCollider14GetMotorTorqueEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40WheelCollider_Get_Custom_PropBrakeTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13WheelCollider14GetBrakeTorqueEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40PhysicMaterial_Get_Custom_PropBouncinessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14PhysicMaterial13GetBouncinessEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40Camera_Get_Custom_PropCommandBufferCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK19RenderEventsContext21GetCommandBufferCountEv(i2 + 1136 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40AudioSource_Get_Custom_PropReverbZoneMixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource16GetReverbZoneMixEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Texture2D_CUSTOM_INTERNAL_CALL_CompressP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Texture2D8CompressEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39LocationService_Get_Custom_PropLastDataP12Il2CppObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if ((__ZN15LocationService17GetLocationStatusEv() | 0) != 2) _printf_console(gb + 536577 | 0, i1);
 __ZN15LocationService15GetLastLocationEv(i2);
 STACKTOP = i1;
 return;
}

function __Z39Light_Get_Custom_PropAlreadyLightmappedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 88 >> 2] | 0) >>> 31 & 255 ^ 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Terrain_Set_Custom_PropLegacyShininessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Terrain18SetLegacyShininessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38SurfaceEffector2D_Set_Custom_PropSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN17SurfaceEffector2D8SetSpeedEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38CircleCollider2D_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN16CircleCollider2D9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Camera_Set_Custom_PropOrthographicSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera19SetOrthographicSizeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Light_Get_Custom_PropShadowNearPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 120 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Cloth_Set_Custom_PropSleepThresholdP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth17SetSleepThresholdEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34MeshCollider_Set_Custom_PropConvexP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12MeshCollider9SetConvexEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Camera_Set_Custom_PropOrthographicP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera15SetOrthographicEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Behaviour_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Cloth_Set_Custom_PropUseGravityP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth13SetUseGravityEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __GLOBAL__sub_I_SwSelfCollision_cpp() {
 HEAP32[gb + 1097568 >> 2] = -1;
 HEAP32[gb + 1097568 + 4 >> 2] = -1;
 HEAP32[gb + 1097568 + 8 >> 2] = -1;
 HEAP32[gb + 1097568 + 12 >> 2] = 0;
 HEAP32[gb + 1097584 >> 2] = 872415232;
 HEAP32[gb + 1097584 + 4 >> 2] = 872415232;
 HEAP32[gb + 1097584 + 8 >> 2] = 872415232;
 HEAP32[gb + 1097584 + 12 >> 2] = 872415232;
 return;
}

function __GLOBAL__sub_I_SaveAndLoadHelper_cpp() {
 var i1 = 0;
 i1 = gb + 1098248 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[gb + 1450976 >> 2] = 0;
 HEAP32[gb + 1450976 + 4 >> 2] = 0;
 HEAP32[gb + 1450976 + 8 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450988 | 0, gb + 584121 | 0, 10, 0);
 return;
}

function __ZNK5physx15PxParticleFluid8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765009 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 700834 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK20LocalFileSystemPosix5IsDirERK13FileEntryData(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 80 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i2;
 if (_stat(i3, i1) | 0) {
  i3 = 0;
  STACKTOP = i2;
  return i3 | 0;
 }
 i3 = (HEAP32[i1 + 12 >> 2] & 61440 | 0) == 16384;
 STACKTOP = i2;
 return i3 | 0;
}

function __ZN9Scripting25BroadcastScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN9Scripting25BroadcastScriptingMessageER10GameObjectPKcP12Il2CppObject(i1, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i3) | 0;
}

function __ZN8WindZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 486986 | 0, i1, 0);
 __ZN8WindZone8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 442476 | 0, i1, 0);
 __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN8Material23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 469691 | 0, i1, 0);
 __ZN8Material8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN8LODGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 425104 | 0, i1, 0);
 __ZN8LODGroup8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN8Collider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 906336 | 0, i1, 0);
 __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN8Animator23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 902235 | 0, i1, 0);
 __ZN8Animator8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx6shdfnd9SListImpl5flushEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 1;
 if (i3 | 0) while (1) {
  if (HEAP32[i1 >> 2] | 0) continue;
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = 1;
  if (!i3) break;
 }
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return i3 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx10PxsContext20updateContactManagerEfPNS_10PxBaseTaskE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(HEAPF32[i2 + 64 >> 2]), HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13NpClothFabricD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 106864 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 106864 + 112;
 __ZN5physx2Sc15ClothFabricCoreD2Ev(i1 + 16 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN39AssetBundleLoadFromMemoryAsyncOperation11FinalizeJobEPv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 92 >> 2] | 0) != 1) __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv(i1) | 0;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN29MotionVectorRenderLoopScratch15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __ZN15ReflectionProbe13SetImportanceEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 << 16 >> 16 < 0;
 if (i3) {
  if (!i1) i4 = 0; else i4 = HEAP32[i1 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 383583 | 0, 0, gb + 380852 | 0, 249, 4, i4, 0, 0);
 }
 HEAP16[i1 + 60 >> 1] = i3 ? 0 : i2;
 return;
}

function __ZN13WebCamTexture4StopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 120 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i2 = i1 + 92 | 0;
  HEAP8[i2 >> 0] = 0;
  return;
 }
 HEAP8[i2 >> 0] = 0;
 _JS_WebCamVideo_Stop(HEAP32[HEAP32[i1 + 124 >> 2] >> 2] | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0);
 i2 = i1 + 92 | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN13TargetJoint2D11SetMaxForceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 92 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 __ZN12b2MouseJoint11SetMaxForceEf(i2, f1);
 return;
}

function __ZN12b2MouseJoint11ShiftOriginERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, i4 = 0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 i4 = i1 + 76 | 0;
 HEAPF32[i4 >> 2] = Math_fround(Math_fround(HEAPF32[i4 >> 2]) - f3);
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i1 + 80 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) - f3);
 return;
}

function __ZN12_GLOBAL__N_119RendererEventClientD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 150428 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12HeaderHelper13SetAllHeadersEPKc(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = i4;
 while (1) {
  i2 = HEAP8[i1 >> 0] | 0;
  if (!(_isspace(i2 << 24 >> 24) | 0)) break; else i1 = i1 + 1 | 0;
 }
 if (!(i2 << 24 >> 24)) i1 = 0; else i1 = i1 - i4 + (_strlen(i1) | 0) | 0;
 return __ZN12HeaderHelper21ParseAndSetAllHeadersEPKcj(i3, i4, i1) | 0;
}

function __Z42ParticleEmitter_Set_Custom_PropRndRotationP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 193 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Camera_Set_Custom_PropUseOcclusionCullingP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1089 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Terrain_Set_Custom_PropEditorRenderFlagsP12Il2CppObjectN7Terrain11RenderFlagsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 204 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37TargetJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13TargetJoint2D11SetMaxForceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37SpringJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SpringJoint2D11SetDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37MeshCollider_Set_Custom_PropSkinWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12MeshCollider12SetSkinWidthEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37HingeJoint_CUSTOM_INTERNAL_get_springP12Il2CppObjectP11JointSpring(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 116 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37FixedJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12FixedJoint2D12SetFrequencyEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Light_Get_Custom_PropShadowStrengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Component_Get_Custom_PropGameObjectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i2 + 28 >> 2] | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34TerrainData_CUSTOM_GetAdjustedSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __ZNK9Heightmap15GetAdjustedSizeEi(i3 + 248 | 0, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Renderer_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Motion_Get_Custom_PropIsLoopingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31LODGroup_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Collider_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29HumanTrait_CUSTOM_HasColliderP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN10HumanTrait11HasColliderER6Avatari(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29GUI_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = __Z11GetGUIStatev() | 0;
 i5 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 16 >> 2] = i5;
 HEAP32[i2 + 20 >> 2] = i4;
 HEAP32[i2 + 24 >> 2] = i3;
 return;
}

function _UNITY_png_muldiv_warn(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var d5 = 0.0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 if ((i2 | 0) == 0 | (i3 | 0) == 0) {
  i4 = 0;
  return i4 | 0;
 }
 d5 = +Math_floor(+(+(i2 | 0) * +(i3 | 0) / +(i4 | 0) + .5));
 i4 = !(d5 >= -2147483648.0) | !(d5 <= 2147483647.0) ? 0 : ~~d5;
 return i4 | 0;
}

function _dup2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i5;
 do {
  HEAP32[i4 >> 2] = i1;
  HEAP32[i4 + 4 >> 2] = i2;
  i3 = ___syscall63(63, i4 | 0) | 0;
 } while ((i3 | 0) == -16);
 i4 = ___syscall_ret(i3) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function ___cxx_global_var_init7() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(-1.0);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097744 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__28__get_dbEv() {
 if (!(HEAP8[gb + 1099768 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099768 | 0) | 0) {
  HEAP32[gb + 1473432 >> 2] = 0;
  HEAP32[gb + 1473432 + 4 >> 2] = 0;
  HEAP32[gb + 1473432 + 8 >> 2] = 0;
  HEAP32[gb + 1473432 + 12 >> 2] = 0;
  HEAP32[gb + 1473432 + 16 >> 2] = 0;
  HEAP32[gb + 1473432 + 20 >> 2] = 0;
 }
 return gb + 1473432 | 0;
}

function __ZNSt3__214collate_bynameIwED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 212740 + 8;
 __THREW__ = 0;
 invoke_vi(fb + 4002 | 0, HEAP32[i1 + 8 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__27collateIwED2Ev(i1);
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__214collate_bynameIcED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 212708 + 8;
 __THREW__ = 0;
 invoke_vi(fb + 4002 | 0, HEAP32[i1 + 8 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__27collateIcED2Ev(i1);
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNSt3__212ctype_bynameIwED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 212876 + 8;
 __THREW__ = 0;
 invoke_vi(fb + 4002 | 0, HEAP32[i1 + 8 >> 2] | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  __ZNSt3__26locale5facetD2Ev(i1);
  ___clang_call_terminate(i2);
 } else return;
}

function __ZNK9AudioClip7GetDataEPfjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i4 = 0;
  return i4 | 0;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i4 = __ZNK14SoundHandleAPI7GetDataEPfjj(i1, i2, i3, i4) | 0;
 return i4 | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE10getInvMassEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 1)) {
  f2 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i1 + 64 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 56 >> 2] | 0) + 92 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx15PxsParticleData15getWorldBoundsVEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 44 >> 2];
 return;
}

function __ZNK5physx12NpConstraint13getBreakForceERfS1_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP32[i3 + 20 >> 2] & 2)) {
  __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_(i3 + 28 | 0, i2, i1);
  return;
 } else {
  i3 = HEAP32[i3 + 24 >> 2] | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 + 8 >> 2];
  HEAP32[i1 >> 2] = HEAP32[i3 + 12 >> 2];
  return;
 }
}

function __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 i2 = HEAP32[i2 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(HEAPF32[i2 + 12 >> 2]));
 return;
}

function __ZN9Coroutine17ContinueCoroutineEP6ObjectPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i2 + 40 >> 2] | 0) == (i1 | 0)) {
  i2 = __ZN9Coroutine3RunEPb(i2, 0) | 0;
  return i2 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 456785 | 0, 0, gb + 456812 | 0, 65, 1, 0, 0, 0);
  i2 = 1;
  return i2 | 0;
 }
 return 0;
}

function __ZN7dtCrowd19updateAgentVelocityERK13dtCrowdHandlePKf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i1 + (i2 * 608 | 0) + 516 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + (i2 * 608 | 0) + 520 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + (i2 * 608 | 0) + 524 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __ZN5physx8debugger4comm17PushBackObjectRef9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx2Sc5Scene6solverEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene12beforeSolverEPNS_10PxBaseTaskE(i2, i1);
 i2 = i2 + 1204 | 0;
 __ZN5physx10PxsContext28runModifiableContactManagersEv(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0);
 __ZN5physx10PxsContext11swapStreamsEv(HEAP32[(HEAP32[i2 >> 2] | 0) + 1e3 >> 2] | 0);
 return;
}

function __ZN5physx2Sc5Scene34setClothInterCollisionNbIterationsEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 168 >> 2] | 0;
 if (i1 | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i3 | 0);
 i1 = HEAP32[i2 + 172 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx2Sc5Scene31setClothInterCollisionStiffnessEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = HEAP32[i2 + 168 >> 2] | 0;
 if (i1 | 0) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +f3);
 i1 = HEAP32[i2 + 172 >> 2] | 0;
 if (!i1) return;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, +f3);
 return;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizer18visualizeLimitConeERKNS_11PxTransformEffb(i3, i2, f4, f5, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 __ZN5physx2Cm18visualizeLimitConeERNS0_12RenderOutputEfRKNS_11PxTransformEffb(HEAP32[i3 + 12 >> 2] | 0, Math_fround(HEAPF32[i3 + 8 >> 2]), i2, f4, f5, i1);
 return;
}

function __ZN5physx26solveFriction_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx17writeBack1D4BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i1, i5, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN5physx12writeBack1D4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_(i6, 0, 0, 0);
 return;
}

function __ZN5physx13NpClothFabricC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 4 >> 1] = 4;
 HEAP16[i1 + 6 >> 1] = 3;
 HEAP32[i1 >> 2] = gb + 106772 + 8;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = gb + 93676 + 8;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 106864 + 8;
 HEAP32[i2 >> 2] = gb + 106864 + 112;
 __ZN5physx2Sc15ClothFabricCoreC2Ev(i1 + 16 | 0);
 return;
}

function __ZN4crnd13crnd_get_dataEPvPPKvPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) != 519686845) {
  i3 = 0;
  return i3 | 0;
 }
 if (i2 | 0) HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 if (!i3) {
  i3 = 1;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 + 8 >> 2];
 i3 = 1;
 return i3 | 0;
}

function __ZN4FMOD8ChannelI19set3DDistanceFilterEbff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868659;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869751;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator13FontSizeRatioEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (f1 == Math_fround(0.0)) f1 = Math_fround(1.0); else {
  i2 = HEAP32[(HEAP32[(HEAP32[i2 + 184 >> 2] | 0) + 76 >> 2] | 0) + 36 >> 2] | 0;
  if (!i2) f1 = Math_fround(1.0); else f1 = Math_fround(f1 / Math_fround(i2 | 0));
 }
 return Math_fround(f1);
}

function __ZN19AtomicPageAllocator5ClearEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 32780 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i1 = 0;
 do {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 12 + (i1 << 2) >> 2] | 0, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN16ParticleRenderer5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAPF32[i1 + 344 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 348 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 352 >> 2] = Math_fround(.25);
 HEAP32[i1 + 356 >> 2] = 1;
 HEAP32[i1 + 360 >> 2] = 1;
 HEAPF32[i1 + 364 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 368 >> 2] = Math_fround(0.0);
 return;
}

function __Z51ShaderVariantCollection_Get_Custom_PropVariantCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK23ShaderVariantCollection15GetVariantCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51ParticleSystemRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 356 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ParticleRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 368 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z51ParticleEmitter_Set_Custom_PropEmitterVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 140 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49getPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj(i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z49getPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj(i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z42Terrain_Set_Custom_PropDrawTreesAndFoliageP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 90 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Animation_Set_Custom_PropPlayAutomaticallyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 40 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41TrailRenderer_Set_Custom_PropAutodestructP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 396 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41RenderTexture_Set_Custom_PropAntiAliasingP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture15SetAntiAliasingEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41ReflectionProbe_Set_Custom_PropResolutionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ReflectionProbe13SetResolutionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40UnityAnalyticsHandler_CUSTOM_FlushEventsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 280 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZN19CloudServiceHandler11FlushEventsEv(i1) | 0;
 i1 = i1 & 1 ^ 1;
 return i1 | 0;
}

function __Z40LineRenderer_Set_Custom_PropNumPositionsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12LineRenderer17SetPositionsCountEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40CubemapArray_Get_Custom_PropCubemapCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Camera_Set_Custom_PropLayerCullSphericalP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1090 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioSource_CUSTOM_SetScheduledStartTimeP12Il2CppObjectd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource21SetScheduledStartTimeEd(i3, d2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Animator_Get_Custom_PropRecorderStopTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator19GetRecorderStopTimeEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39WheelCollider_Get_Custom_PropSteerAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13WheelCollider13GetSteerAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39WheelCollider_Get_Custom_PropSprungMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13WheelCollider13GetSprungMassEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39SliderJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13SliderJoint2D13GetJointSpeedEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39AudioSource_Get_Custom_PropDopplerLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource15GetDopplerLevelEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37NavMeshObstacle_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37NavMeshObstacle_Set_Custom_PropHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15NavMeshObstacle9SetHeightEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37HingeJoint_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP11JointLimits(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 96 | 0, 20) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37ConstantForce2D_Set_Custom_PropTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ConstantForce2D9SetTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Collider_Set_Custom_PropContactOffsetP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Collider16SetContactOffsetEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37CapsuleCollider_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15CapsuleCollider9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37CapsuleCollider_Set_Custom_PropHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15CapsuleCollider9SetHeightEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Camera_Set_Custom_PropOpaqueSortModeP12Il2CppObjectN6Camera14OpaqueSortModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 1064 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33GUI_CUSTOM_INTERNAL_CALL_DoButtonRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = __Z11GetGUIStatev() | 0;
 return (__ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle(i4, i1, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0, i3) | 0) & 1 | 0;
}

function __Z29GUI_CUSTOM_INTERNAL_get_colorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i5 = __Z11GetGUIStatev() | 0;
 i4 = HEAP32[i5 + 16 >> 2] | 0;
 i3 = HEAP32[i5 + 20 >> 2] | 0;
 i2 = HEAP32[i5 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i5 + 12 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __Z25AssetBundle_CUSTOM_UnloadP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __Z17UnloadAssetBundleR11AssetBundleb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z16TransferTextPPtrI9JSONWriteEvR4PPtrI6ObjectERT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
 __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags(i2, i4, gb + 1034719 | 0, 0);
 STACKTOP = i3;
 return;
}

function ___cxx_global_var_init6() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(1.0);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097760 | 0, i2);
 STACKTOP = i1;
 return;
}

function ___cxx_global_var_init5() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(0.0);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097776 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZZN14PhysicsManager15InitializeClassEvEN58EarlyUpdatePhysicsResetInterpolatedTransformPositionstruct7ForwardEv() {
 if (!(__ZN11TimeManager16HasFixedTimeStepEv(__Z14GetTimeManagerv() | 0) | 0)) return;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN14PhysicsManager34ResetInterpolatedTransformPositionEv(__Z21GetManagerFromContexti(9) | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwFabric15scaleRestvaluesEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 40 >> 2] | 0;
 i4 = HEAP32[i2 + 44 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (!i4) return;
 do {
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f3);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader(i1 + -128 | 0, 0, 0) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
}

function __ZNK5physx14SingleAABBTask25updateNumFastMovingShapesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 + 452 >> 2] | 0) + ((HEAP32[i1 + 384 >> 2] | 0) + ((HEAP32[i1 + 316 >> 2] | 0) + ((HEAP32[i1 + 248 >> 2] | 0) + ((HEAP32[i1 + 180 >> 2] | 0) + (HEAP32[i1 + 112 >> 2] | 0))))));
 return;
}

function __ZNK5physx13PxRigidStatic8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 701374 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 833471 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK21AssetBundleFileSystem25GetRelativeFileSystemPathEPKc(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 96 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 100 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 return __Z14SkipPathPrefixPKcS0_jb(i5, i3, i1, 1) | 0;
}

function __ZN7Terrain23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 937588 | 0, i1, 0);
 __ZN7Terrain8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 800807 | 0, i1, 0);
 __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx3Scb5Actor7OffsetsC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 16;
 HEAP32[i1 + 4 >> 2] = 16;
 HEAP32[i1 + 16 >> 2] = 16;
 HEAP32[i1 + 44 >> 2] = 16;
 HEAP32[i1 + 36 >> 2] = 16;
 HEAP32[i1 + 40 >> 2] = 16;
 HEAP32[i1 + 12 >> 2] = 12;
 HEAP32[i1 + 8 >> 2] = 12;
 HEAP32[i1 + 52 >> 2] = 12;
 HEAP32[i1 + 20 >> 2] = 12;
 HEAP32[i1 + 68 >> 2] = 12;
 return;
}

function __ZN5physx2Sc5Scene30setClothInterCollisionDistanceEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = HEAP32[i2 + 168 >> 2] | 0;
 if (i1 | 0) mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, +f3);
 i1 = HEAP32[i2 + 172 >> 2] | 0;
 if (!i1) return;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, +f3);
 return;
}

function __ZN5physx2Gu9RadixSortC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 86408 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP8[i1 + 32 >> 0] = 1;
 HEAP32[i2 >> 2] = -2147483648;
 return;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeLinearLimitERKNS_11PxTransformES4_fb(i4, i2, i3, f5, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f5 = Math_fround(f5);
 i1 = i1 | 0;
 __ZN5physx2Cm20visualizeLinearLimitERNS0_12RenderOutputEfRKNS_11PxTransformES5_fb(HEAP32[i4 + 12 >> 2] | 0, Math_fround(HEAPF32[i4 + 8 >> 2]), i2, i3, f5, i1);
 return;
}

function __ZN5physx20PxsSolverCoreGeneral6createEv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i2, 4, gb + 716577 | 0, 119) | 0;
 if (!i1) {
  STACKTOP = i2;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = gb + 103348 + 8;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN20UnityConnectSettings15ThreadedCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 164 >> 2] | 0;
 i2 = i2 + 168 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN17Physics2DSettings23SetColliderContactColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 136 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 140 >> 2] = i5;
 HEAP32[i1 + 144 >> 2] = i4;
 HEAP32[i1 + 148 >> 2] = i3;
 return;
}

function __ZN13MemoryManager22GetTotalProfilerMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 63576 >> 2] | 0;
 if ((i2 | 0) < 128) i1 = HEAP32[i1 + 3824 + (i2 * 24 | 0) >> 2] | 0; else {
  i1 = HEAP32[i1 + 1764 + (i2 + -128 << 2) >> 2] | 0;
  i1 = i1 >>> 0 > 512 >>> 0 ? i1 : 0;
 }
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function __ZN11LightProbes23ZeroBakedLightOcclusionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 180 >> 2] | 0;
 if ((i3 | 0) <= 0) return;
 i2 = i1 + 168 | 0;
 i1 = 0;
 do {
  i4 = HEAP32[i2 >> 2] | 0;
  HEAP32[i4 + (i1 << 3) >> 2] = -2;
  HEAP32[i4 + (i1 << 3) + 4 >> 2] = 1065353216;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN10AtomicList5ClearEP10AtomicNodei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = i1 + 4 | 0;
 if ((HEAP32[i4 >> 2] | 0) != (i3 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + 1;
 i4 = i2;
 return i4 | 0;
}

function __Z57ParticleSystemRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 352 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z50ParticleSystemRenderer_Set_Custom_PropSortingFudgeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 364 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46Animator_Get_Custom_PropLayersAffectMassCenterP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator25GetLayersAffectMassCenterEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44TerrainData_CUSTOM_RecalculateBasemapIfDirtyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13SplatDatabase25RecalculateBasemapIfDirtyEv(i2 + 32 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Rigidbody_Set_Custom_PropSolverIterationsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody19SetSolverIterationsEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Rigidbody_CUSTOM_INTERNAL_CALL_SetDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody10SetDensityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Rigidbody_Get_Custom_PropSleepThresholdP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody17GetSleepThresholdEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39GetPathWithPlatformSpecificDllExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 455488 | 0, 0, gb + 455527 | 0, 36, 1, 0, 0, 0);
 return;
}

function __Z39DirectorPlayer_CUSTOM_GetTimeUpdateModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36HingeJoint_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP10JointMotor(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 128 | 0, 12) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Graphics_CUSTOM_GetActiveDepthBufferP21ScriptingRenderBuffer(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 i1 = __ZN13RenderTexture9GetActiveEi(0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 352 >> 2] | 0, i3 | 0) | 0;
 return;
}

function __Z36AudioSource_Set_Custom_PropPanStereoP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource12SetStereoPanEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Canvas_Set_Custom_PropPlaneDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas16SetPlaneDistanceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Graphics_CUSTOM_CopyTexture_FullP12Il2CppObjectS0_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i3) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i3) | 0;
 __Z11CopyTextureP7TextureS0_(i2, i1) | 0;
 return;
}

function __Z31Light_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Light8SetColorERK10ColorRGBAf(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30CreateBoxedObjectFromPrimitiveb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP8[i3 >> 0] = i1 & 1;
 i1 = __Z19scripting_value_boxP11Il2CppClassPv(HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 44 >> 2] | 0, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z29InitializeMemoryProfilerStatsv() {
 var i1 = 0, i2 = 0;
 i1 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1451e3 >> 2] | 0, 0, 0) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(140, gb + 63576 | 0, 16, gb + 462119 | 0, 159) | 0;
 __ZN19MemoryProfilerStatsC2Ev(i2);
 HEAP32[gb + 1163248 >> 2] = i2;
 if (!i1) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z28Mesh_CUSTOM_GetTrianglesImplP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z35AllocExtractMeshTrianglesFromScriptRK4Meshi(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _reset_input_controller(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 400 >> 2] | 0;
 HEAP32[i2 >> 2] = fb + 1558;
 HEAP8[i2 + 16 >> 0] = 0;
 HEAP8[i2 + 17 >> 0] = 0;
 HEAP8[i2 + 20 >> 0] = 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[HEAP32[i1 + 404 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[i1 + 140 >> 2] = 0;
 return;
}

function _cff_face_done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i3 = HEAP32[i1 + 100 >> 2] | 0;
 i2 = HEAP32[i1 + 532 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[i2 + 12 >> 2] | 0, i1 | 0);
 i2 = i1 + 656 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 _cff_font_done(i1);
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function ___getdents(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall220(220, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function ___cxx_global_var_init8() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 4 | 0;
 i3 = i1;
 HEAPF32[i3 >> 2] = Math_fround(.5);
 HEAP32[i2 >> 2] = __Z6simd4fRKf(i3) | 0;
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(gb + 1097728 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZNSt3__213__vector_baseIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (i3 | 0) {
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
  while (1) {
   if ((i2 | 0) == (i3 | 0)) break;
   i4 = i2 + -4 | 0;
   HEAP32[i1 >> 2] = i4;
   i2 = i4;
  }
  __ZdlPv(i3);
 }
 return;
}

function __ZNSt3__211__stdoutbufIwE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476360 | 0) | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP8[i1 + 44 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) & 1;
 return;
}

function __ZNSt3__211__stdoutbufIcE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i2 = __ZNKSt3__26locale9use_facetERNS0_2idE(i2, gb + 1476352 | 0) | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP8[i1 + 44 >> 0] = (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0) | 0) & 1;
 return;
}

function __ZNK6Camera16GetCullingMatrixEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 680 | 0;
 if (!(HEAP8[i1 + 1085 >> 0] | 0)) return i3 | 0;
 i4 = i3;
 i1 = __ZNK6Camera20GetWorldToClipMatrixEv(i1) | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 return i3 | 0;
}

function __ZNK5physx2Sc5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i3 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
}

function __ZNK19RenderEventsContext21GetCommandBufferCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if ((i4 | 0) <= 0) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  i1 = (HEAP32[i3 + (i2 * 20 | 0) + 12 >> 2] | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i4 | 0));
 return i1 | 0;
}

function __ZN6Camera23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 1044265 | 0, i1, 0);
 __ZN6Camera8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx8debugger4comm15RemoveObjectRef9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx8debugger18MemPvdOutputStreamD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148660 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx6shdfnd10ThreadImpl5sleepEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i3;
 i4 = (i1 >>> 0) % 1e3 | 0;
 HEAP32[i2 >> 2] = i1 - i4;
 HEAP32[i2 + 4 >> 2] = i4 * 1e6;
 do {} while ((_nanosleep(i2 | 0, i2 | 0) | 0) == -1);
 STACKTOP = i3;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore15createParticlesERKNS_22PxParticleCreationDataE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i3 | 0) | 0;
}

function __ZN5physx2Gu19intersectBoxCapsuleERKNS0_3BoxERKNS0_7CapsuleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 f4 = Math_fround(__ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_(i2, i2 + 12 | 0, i1 + 36 | 0, i1 + 48 | 0, i1, 0, 0));
 f3 = Math_fround(HEAPF32[i2 + 24 >> 2]);
 return f4 <= Math_fround(f3 * f3) | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx29solveExtFrictionConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5Unity10FixedJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 92 | 0, i2);
 __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN4FMOD8ChannelI13getLoopPointsEPjjS1_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868539;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17Physics2DSettings22SetColliderAsleepColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 120 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 124 >> 2] = i5;
 HEAP32[i1 + 128 >> 2] = i4;
 HEAP32[i1 + 132 >> 2] = i3;
 return;
}

function __ZN14PhysicsManager20GetDefaultPxMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 i3 = HEAP32[gb + 1457408 >> 2] | 0;
 mftCall_iiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 152 >> 2] | 0, i3 | 0, i2 | 0, 1, 0) | 0;
 STACKTOP = i1;
 return HEAP32[i2 >> 2] | 0;
}

function __ZN13GfxDeviceNull15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace(i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z49ParticleSystemRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 360 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40WebCamTexture_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40RenderTexture_Set_Custom_PropVolumeDepthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture14SetVolumeDepthEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40CapsuleCollider_Set_Custom_PropDirectionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15CapsuleCollider12SetDirectionEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Animator_Get_Custom_PropFeetPivotActiveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator18GetFeetPivotActiveEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38WheelJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12WheelJoint2D13GetJointSpeedEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38HingeJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12HingeJoint2D13GetJointSpeedEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38HingeJoint2D_Get_Custom_PropJointAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK12HingeJoint2D13GetJointAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Camera_Set_Custom_PropStereoMirrorModeP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1112 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_Get_Custom_PropMinDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource14GetMinDistanceEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AudioSource_Get_Custom_PropMaxDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource14GetMaxDistanceEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Camera_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN19RenderEventsContext23RemoveAllCommandBuffersEv(i2 + 1136 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36SphereCollider_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14SphereCollider9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Rigidbody_Set_Custom_PropAngularDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody14SetAngularDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36BillboardAsset_Set_Custom_PropHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14BillboardAsset9SetHeightEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36BillboardAsset_Set_Custom_PropBottomP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14BillboardAsset9SetBottomEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Animator_Set_Custom_PropPlaybackTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator15SetPlaybackTimeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33SpringJoint_Set_Custom_PropSpringP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity11SpringJoint9SetSpringEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33SpringJoint_Set_Custom_PropDamperP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity11SpringJoint9SetDamperEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Transform_CUSTOM_SetSiblingIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Transform23SetSiblingIndexInternalEib(i3, i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32LODGroup_Get_Custom_PropLodCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ((HEAP32[i2 + 60 >> 2] | 0) - (HEAP32[i2 + 56 >> 2] | 0) | 0) / 28 | 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Motion_Get_Custom_PropLegacyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Cloth_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z27GameObject_CUSTOM_SetActiveP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10GameObject13SetSelfActiveEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Light_Get_Custom_PropFlareP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK5Light8GetFlareEv(i2) | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_get_PLTE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 8 | 0) != 0 : 0)) {
  i4 = 0;
  return i4 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i4 >> 2] = HEAPU16[i2 + 20 >> 1];
 i4 = 8;
 return i4 | 0;
}

function _UNITY_FT_Init_Class_pscmaps_interface(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 2635;
 HEAP32[i2 + 4 >> 2] = fb + 145;
 HEAP32[i2 + 8 >> 2] = fb + 1083;
 HEAP32[i2 + 12 >> 2] = fb + 1084;
 HEAP32[i2 + 16 >> 2] = fb + 2636;
 HEAP32[i2 + 20 >> 2] = fb + 2637;
 HEAP32[i2 + 24 >> 2] = gb + 225782;
 HEAP32[i2 + 28 >> 2] = gb + 223972;
 return;
}

function _wctype(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0, i5 = 0;
 i4 = HEAP8[i3 >> 0] | 0;
 i1 = 1;
 i2 = gb + 1066261 | 0;
 i5 = 97;
 while (1) {
  if (i4 << 24 >> 24 == i5 << 24 >> 24) if (!(_strcmp(i3, i2) | 0)) break;
  i2 = i2 + 6 | 0;
  i5 = HEAP8[i2 >> 0] | 0;
  if (!(i5 << 24 >> 24)) {
   i1 = 0;
   break;
  } else i1 = i1 + 1 | 0;
 }
 return i1 | 0;
}

function _symlinkat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall304(304, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _setpriority(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall97(97, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _glCompressedTexSubImage3D__wrapper(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 _glCompressedTexSubImage3D(i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0);
}

function _getresuid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall209(209, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _getresgid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall211(211, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _futimesat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall299(299, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function ___madvise(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall219(219, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__212strstreambufC2EPKhi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 2;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, 0);
 return;
}

function __ZNSt3__212strstreambufC2EPKci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 2;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, 0);
 return;
}

function __ZNSt3__212strstreambufC2EPKai(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 2;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 __ZNSt3__212strstreambuf6__initEPciS1_(i1, i2, i3, 0);
 return;
}

function __ZNK5physx7NpScene22getClientBehaviorFlagsEh(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 if (HEAP32[i3 + 3388 >> 2] & 32 | 0) {
  i1 = HEAP8[(HEAP32[i3 + 3376 >> 2] | 0) + (i2 & 255) >> 0] | 0;
  if (i1 << 24 >> 24 != -1) {
   i3 = i1;
   return i3 | 0;
  }
 }
 i3 = __ZNK5physx2Sc5Scene22getClientBehaviorFlagsEh(i3 + 32 | 0, i2) | 0;
 return i3 | 0;
}

function __ZNK5physx3Ext14PrismaticJoint11getPositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 32 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 | 0);
 f3 = Math_fround(HEAPF32[i4 + 16 >> 2]);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZNK5physx2Gu10ConvexMesh14getLocalBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 36 >> 2];
 return;
}

function __ZNK5physx14NpArticulation22getSeparationToleranceEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 16 >> 2] & 8)) {
  f2 = Math_fround(__ZNK5physx2Sc16ArticulationCore22getSeparationToleranceEv(i1 + 24 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 20 >> 2] | 0) + 12 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK13MonoBehaviour7GetNameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (i2 | 0) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
  return i2 | 0;
 }
 i1 = i1 + 40 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = i1;
  return i2 | 0;
 }
 return 0;
}

function __ZNK11b2RopeJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 92 >> 2]) * f3);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 104 >> 2]) * f3);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i2 + 108 >> 2]));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN9WWWCachedD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 64912 + 8;
 _free(HEAP32[i2 + 80 >> 2] | 0);
 i1 = HEAP32[i2 + 92 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 i1 = HEAP32[i2 + 88 >> 2] | 0;
 if (!i1) {
  __ZN3WWWD2Ev(i2);
  return;
 }
 __ZN3WWW7ReleaseEv(i1);
 __ZN3WWWD2Ev(i2);
 return;
}

function __ZN8Gradient17ValidateColorKeysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 64 | 0;
 if ((HEAPU8[i2 >> 0] | 0) >= 2) return;
 HEAP8[i2 >> 0] = 2;
 i2 = i1 + 4 | 0;
 HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
 HEAP8[i2 + 1 >> 0] = HEAP8[i1 + 1 >> 0] | 0;
 HEAP8[i2 + 2 >> 0] = HEAP8[i1 + 2 >> 0] | 0;
 HEAP16[i1 + 32 >> 1] = 0;
 HEAP16[i1 + 34 >> 1] = -1;
 return;
}

function __ZN7ApiGLES13IsVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, i5 = 0;
 i4 = HEAP32[i2 + 692 >> 2] | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i5 = 3; else if ((HEAP32[i2 + 1988 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0)) i5 = 3; else i1 = -1;
 return (mftCall_ii(i4 | 0, i1 | 0) | 0) << 24 >> 24 != 0 | 0;
}

function __ZN6Sprite23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 410464 | 0, i1, 0);
 __ZN6Sprite8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN6Shader23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 609205 | 0, i1, 0);
 __ZN6Shader8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhtE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 2 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIhsE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAPU8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 2 | 0;
 }
 return;
}

function __ZN5physx2Sc21ConstraintInteraction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + 32 | 0;
 if ((HEAP8[(HEAP32[i1 >> 2] | 0) + 116 >> 0] & 6) != 6) return 1;
 i2 = __ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i2 + 4 >> 2] | 0) | 0;
 __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE(i2, HEAP32[i1 >> 2] | 0);
 return 1;
}

function __ZN5physx2Gu22intersectSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 f3 = Math_fround(f3 + Math_fround(HEAPF32[i1 + 24 >> 2]));
 return Math_fround(__ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf(i1, i1 + 12 | 0, i2, 0)) <= Math_fround(f3 * f3) | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra7ImpTile19getViewTreeDataSizeEPKS0_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 24 >> 2] | 0;
 i4 = i3 >>> 5;
 i1 = i3 >>> 21;
 i2 = i3 >>> 13;
 return ((((Math_imul((i4 + 1 | 0) >>> 1, i3 & 31) | 0) + 31 | 0) >>> 5) + (((i4 << 1) + 31 | 0) >>> 5) << 2) + (3 - i2 + (i3 >>> 9) + (((1 - i1 + i2 | 0) >>> 1) + i1 << 2)) & -4 | 0;
}

function __ZN25DeferredRenderLoopScratch15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 164 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __ZN23b2EdgeAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_(i2, HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4);
 return;
}

function __ZN17Physics2DSettings21SetColliderAwakeColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 104 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 108 >> 2] = i5;
 HEAP32[i1 + 112 >> 2] = i4;
 HEAP32[i1 + 116 >> 2] = i3;
 return;
}

function __ZN16BaseVideoTexture20SuspendVideoTexturesEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1459952 + 4 >> 2] | 0)) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 208 >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[gb + 1459952 + 4 >> 2] | 0));
 return;
}

function __ZN15AnchoredJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 __ZN7Joint2D5ResetEv(i1);
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 92 >> 0] = 1;
 return;
}

function __ZN12ImageDecoder14MemoryReadFuncEPvPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 4 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i3 = i5 >>> 0 < i3 >>> 0 ? i5 : i3;
 _memcpy(i2 | 0, HEAP32[i1 >> 2] | 0, i3 | 0) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i3;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) - i3;
 return i3 | 0;
}

function __Z43Cloth_Get_Custom_PropUseContinuousCollisionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround((HEAP8[i2 + 92 >> 0] | 0) != 0 & 1);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_PlayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_Get_Custom_PropSleepVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody16GetSleepVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Camera_Get_Custom_PropStereoSeparationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK6Camera19GetStereoSeparationEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AudioSource_Set_Custom_PropTimeSamplesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource17SetSamplePositionEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Renderer_Set_Custom_PropSortingOrderP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Renderer15SetSortingOrderEs(i3, i2 & 65535);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Rigidbody2D_Set_Custom_PropRotationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D11SetRotationEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34TerrainData_CUSTOM_SetBasemapDirtyP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 32 + 50 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Light_Get_Custom_PropShadowBiasP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 112 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function _unlinkat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall301(301, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _llvm_cttz_i32(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP8[cttz_i8 + (i2 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 | 0;
 i1 = HEAP8[cttz_i8 + (i2 >> 8 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 8 | 0;
 i1 = HEAP8[cttz_i8 + (i2 >> 16 & 255) >> 0] | 0;
 if ((i1 | 0) < 8) return i1 + 16 | 0;
 return (HEAP8[cttz_i8 + (i2 >>> 24) >> 0] | 0) + 24 | 0;
}

function _list_add(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0, i5 = 0;
 i4 = _calloc(1, 132) | 0;
 if (i4 | 0) {
  i5 = i4 + 112 | 0;
  _strcpy(i5, i1) | 0;
  HEAP32[i4 + 4 >> 2] = i5;
  i1 = HEAP32[i3 >> 2] | 0;
  if (i1 | 0) HEAP32[i1 >> 2] = i4;
  HEAP32[i3 >> 2] = i4;
  if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = i4;
 }
 return i4 | 0;
}

function ___cxa_get_globals_fast() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(_pthread_once(gb + 1477e3 | 0, fb + 461 | 0) | 0)) {
  i2 = _pthread_getspecific(HEAP32[gb + 1477004 >> 2] | 0) | 0;
  STACKTOP = i1;
  return i2 | 0;
 } else _abort_message(gb + 1085124 | 0, i1);
 return 0;
}

function __ZeqRK8DateTimeS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i3 & 65535) << 16 >> 16 == (i4 & 65535) << 16 >> 16) return ((i3 >>> 16 & 65535) << 16 >> 16 == (i4 >>> 16 & 65535) << 16 >> 16 ? (HEAP32[i1 + 4 >> 2] | 0) == (HEAP32[i2 + 4 >> 2] | 0) : 0) | 0; else return 0;
 return 0;
}

function __ZThn4_NK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = i3 + -4 | 0;
 i3 = HEAP32[i1 + 512 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i3 | 0, i3 + (HEAP32[i1 + 516 >> 2] << 4) | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
}

function __ZNKSt3__25ctypeIcE10do_toupperEPcPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 while (1) {
  if ((i2 | 0) == (i3 | 0)) break;
  i1 = HEAP8[i2 >> 0] | 0;
  if (i1 << 24 >> 24 > -1) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_upper_tableEv() | 0) + (i1 << 24 >> 24 << 2) >> 2] & 255;
  HEAP8[i2 >> 0] = i1;
  i2 = i2 + 1 | 0;
 }
 return i3 | 0;
}

function __ZNKSt3__25ctypeIcE10do_tolowerEPcPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 while (1) {
  if ((i2 | 0) == (i3 | 0)) break;
  i1 = HEAP8[i2 >> 0] | 0;
  if (i1 << 24 >> 24 > -1) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_lower_tableEv() | 0) + (i1 << 24 >> 24 << 2) >> 2] & 255;
  HEAP8[i2 >> 0] = i1;
  i2 = i2 + 1 | 0;
 }
 return i3 | 0;
}

function __ZNK9Rigidbody27GetSolverVelocityIterationsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0, i2 + 4 | 0, i3 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE10getInvMassEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 1)) {
  f2 = Math_fround(__ZNK5physx2Sc8BodyCore14getInverseMassEv(i1 + 64 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 56 >> 2] | 0) + 92 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx16PxsParticleShape10getBoundsVEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 24 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 28 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 32 >> 2];
 return;
}

function __ZNK5physx14NpArticulation25getStabilizationThresholdEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 16 >> 2] & 16)) {
  f2 = Math_fround(__ZNK5physx2Sc16ArticulationCore17getSleepThresholdEv(i1 + 24 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 20 >> 2] | 0) + 16 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK15FileSystemEntry12GetAssetGUIDEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 1040 >> 2] | 0;
 if (!i3) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
  return;
 }
}

function __ZNK14Texture2DArray26CanReuploadDataToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP32[i1 + 96 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 1048576)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z20GetPersistentManagerv() | 0;
 i1 = __ZN17PersistentManager17IsObjectAvailableEi(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZN5physx8debugger4comm14CreateInstance9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 return;
}

function __ZN5physx8debugger14PvdMarshallingIatE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 2 | 0;
 }
 return;
}

function __ZN5physx8debugger14PvdMarshallingIasE12marshalBlockEPKhPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + i3 | 0;
 if ((i3 | 0) <= 0) return;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3;
  HEAP8[i2 + 1 >> 0] = i3 >> 8;
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i4 >>> 0) break; else i2 = i2 + 2 | 0;
 }
 return;
}

function __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149568 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE13simulateClothEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 716 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i3 + 524 | 0;
 do {
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE12iterateClothEv(i3);
  __ZN5physx5cloth14IterationStateI8Scalar4fE6updateEv(i2);
 } while ((HEAP32[i1 >> 2] | 0) != 0);
 return;
}

function __ZN5physx2Sn5ConvX16getNbMetaClassesENS0_12MetaDataTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   i2 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 24 >> 2] | 0;
   return i2 | 0;
  }
 case 2:
  {
   i2 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 24 >> 2] | 0;
   return i2 | 0;
  }
 default:
  {
   i2 = 0;
   return i2 | 0;
  }
 }
 return 0;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx24solveContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5Umbra20ObjectDistanceParams17setReferencePointEPKNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = (i2 | 0) != 0;
 HEAP8[i1 + 16 >> 0] = i3 & 1;
 if (!i3) return;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN4FMOD6SoundI13getLoopPointsEPjjS1_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868539;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI9getOutputEiPPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 857600;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI6Canvas19GetCanvasMeshBoundsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 292 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 296 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 300 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 304 >> 2];
 HEAP32[i1 + 16 >> 2] = HEAP32[i2 + 308 >> 2];
 HEAP32[i1 + 20 >> 2] = HEAP32[i2 + 312 >> 2];
 return;
}

function __ZN19AtomicPageAllocatorD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 32780 | 0;
 if ((HEAP32[i3 >> 2] | 0) <= 0) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i1 = 0;
 do {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 12 + (i1 << 2) >> 2] | 0, i2);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN18ScriptingArguments8AddFloatEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = i1 + 192 | 0;
 HEAPF32[i1 + (HEAP32[i3 >> 2] << 3) >> 2] = f2;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i4 << 2) >> 2] = i1 + (i4 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 2;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN18AudioMixerSnapshot23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN17Physics2DSettings20SetColliderAABBColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 152 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 156 >> 2] = i5;
 HEAP32[i1 + 160 >> 2] = i4;
 HEAP32[i1 + 164 >> 2] = i3;
 return;
}

function __ZN16TimerQueriesGLES12ReleaseQueryEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0;
 i4 = i2 + 512 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == 128) {
  mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 796 >> 2] | 0, 128, i2 | 0);
  HEAP32[i4 >> 2] = 0;
  i1 = 0;
 }
 HEAP32[i4 >> 2] = i1 + 1;
 HEAP32[i2 + (i1 << 2) >> 2] = i3;
 return;
}

function __ZN16BaseVideoTexture19ResumeVideoTexturesEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1459952 + 4 >> 2] | 0)) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 212 >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[gb + 1459952 + 4 >> 2] | 0));
 return;
}

function __ZN15TerrainCollider15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 1016757 | 0, gb + 1016827 | 0, gb + 1016805 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 151564 | 0, gb + 1105776 | 0, fb + 986 | 0, gb + 29192 | 0);
 return;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl9lockClassEN5physx8debugger18NonNegativeIntegerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) <= -1) return;
 if ((HEAP32[i2 + 128 >> 2] | 0) <= (i1 | 0)) return;
 i1 = HEAP32[(HEAP32[i2 + 124 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 if (!i1) return;
 HEAP8[i1 + 68 >> 0] = 1;
 return;
}

function __Z51ParticleSystemRenderer_CUSTOM_Internal_GetMeshCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK22ParticleSystemRenderer12GetMeshCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51AnimatorOverrideController_CUSTOM_Internal_SetDirtyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN26AnimatorOverrideController11ManualDirtyEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 352 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46AnimatorControllerPlayable_CUSTOM_StringToHashP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z44AudioSource_Get_Custom_PropBypassReverbZonesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource20GetBypassReverbZonesEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43TerrainData_CUSTOM_RecalculateTreePositionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN12TreeDatabase24RecalculateTreePositionsEv(i2 + 84 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38AudioSource_CUSTOM_SetScheduledEndTimeP12Il2CppObjectd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource19SetScheduledEndTimeEd(i3, d2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Texture_CUSTOM_Internal_GetDimensionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36AudioMixer_Set_Custom_PropUpdateModeP12Il2CppObject20AudioMixerUpdateMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 104 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35WheelCollider_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35PointEffector2D_Set_Custom_PropDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15PointEffector2D7SetDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35LensFlare_Set_Custom_PropBrightnessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9LensFlare13SetBrightnessEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35BillboardAsset_Set_Custom_PropWidthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14BillboardAsset8SetWidthEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34HingeJoint_Get_Custom_PropVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK5Unity10HingeJoint11GetVelocityEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Canvas_Set_Custom_PropSortingOrderP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas15SetSortingOrderEs(i3, i2 & 65535);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Joint_Set_Custom_PropBreakTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Joint14SetBreakTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Light_Get_Custom_PropCookieSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31AudioSource_Set_Custom_PropTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource14SetSecPositionEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31AudioSource_Set_Custom_PropMuteP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource7SetMuteEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31AudioSource_Set_Custom_PropLoopP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource7SetLoopEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30CreateBoxedObjectFromPrimitivej(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = __Z19scripting_value_boxP11Il2CppClassPv(HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 24 >> 2] | 0, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z30CreateBoxedObjectFromPrimitivei(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = __Z19scripting_value_boxP11Il2CppClassPv(HEAP32[(__Z21GetManagerFromContexti(5) | 0) + 44 + 36 >> 2] | 0, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z10BeginsWithPKcS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  if (!(i3 << 24 >> 24)) {
   i1 = 1;
   i2 = 4;
   break;
  }
  if ((HEAP8[i2 >> 0] | 0) == i3 << 24 >> 24) {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } else {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function _mkdirat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall296(296, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _mincore(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall218(218, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNKSt3__27collateIwE12do_transformEPKwS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i4);
 return;
}

function __ZNKSt3__27collateIcE12do_transformEPKcS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_(i1, i3, i4);
 return;
}

function __ZNK8VRDevice19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 280 >> 2] | 0;
 if (!i1) return;
 __ZNK7VRInput19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i2);
 return;
}

function __ZNK5physx7NpShape23getSimulationFilterDataEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 36 >> 2] & 8 | 0) == 0 ? i2 + 64 | 0 : (HEAP32[i2 + 40 >> 2] | 0) + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5physx8debugger4comm12BeginSection9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148880 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148752 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 149616 + 8;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i1, i2, i3, i4, i5, i6) | 0;
}

function __ZN5audio5mixer27ClearExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i3) return;
 i2 = HEAP32[i2 + 40 >> 2] | 0;
 i1 = 0;
 do {
  HEAPF32[i2 + (i1 << 2) >> 2] = Math_fround(-inf);
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return;
}

function __ZN5Umbra10PortalInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = -1;
 i2 = i1 + 76 | 0;
 i3 = i1 + 8 | 0;
 i4 = i3 + 68 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i2 >> 2] = -1;
 HEAP8[i1 + 144 >> 0] = 0;
 return;
}

function __ZN5Light23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 374193 | 0, i1, 0);
 __ZN5Light8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN5Flare23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 373565 | 0, i1, 0);
 __ZN5Flare8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN4FMOD8ChannelI13setLoopPointsEjjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 854586;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI8getInputEiPPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 857591;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI11getDefaultsEPfS1_S1_Pi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i1;
 HEAP32[i5 >> 2] = 78;
 HEAP32[i5 + 4 >> 2] = gb + 868772;
 _printf(gb + 857490 | 0, i5) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI14set3DOcclusionEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868364;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN23TransformChangeDispatch12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1158396 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[gb + 1158396 >> 2] = 0;
 return;
}

function __ZN19CullingGroupManager12CleanupClassEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1114352 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63600 | 0);
 HEAP32[gb + 1114352 >> 2] = 0;
 return;
}

function __ZN16BaseVideoTexture18PauseVideoTexturesEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1459952 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[gb + 1459952 + 4 >> 2] | 0)) return;
 do {
  i2 = HEAP32[i1 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0, i2 | 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[gb + 1459952 + 4 >> 2] | 0));
 return;
}

function __ZN13AnimationClip13SetSampleRateEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(f2 < Math_fround(9.99999974e-06))) {
  HEAPF32[i1 + 88 >> 2] = f2;
  return;
 }
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 907248 | 0, 0, gb + 899654 | 0, 125, 4, i1, 0, 0);
 return;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStream18getWrittenDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN12IFileAdapter5WriteER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function __ZN11UnityEngine7Connect20BasePersistentValues5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 i2 = i1 + 4 | 0;
 i3 = i2 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i3 >> 0] = 0;
  return;
 }
}

function __ZN11CustomArrayD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZdaPv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 do {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  if (i3 | 0) __ZdaPv(i3);
  __ZdlPv(i2);
 } while ((i1 | 0) != 0);
 return;
}

function __Z55QualitySettings_CUSTOM_INTERNAL_get_shadowCascade4SplitP8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 i2 = (HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 44 >> 2] | 0) * 108 | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z54NavMeshObstacle_Get_Custom_PropCarvingTimeToStationaryP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z53ParticleSystemRenderer_Get_Custom_PropNormalDirectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 368 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z53ParticleSystemRenderer_Get_Custom_PropMinParticleSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 344 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z53ParticleSystemRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 348 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51AnimatorUtility_CUSTOM_DeoptimizeTransformHierarchyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z28DeoptimizeTransformHierarchyR10GameObject(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Rigidbody_Get_Custom_PropSolverVelocityIterationsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Rigidbody27GetSolverVelocityIterationsEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48Terrain_CUSTOM_ApplyDelayedHeightmapModificationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN7Terrain33ApplyDelayedHeightmapModificationEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46TrailRenderer_Set_Custom_PropMinVertexDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 392 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z46ParticleEmitter_Set_Custom_PropAngularVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 200 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Collider_Get_Custom_PropContactOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK8Collider16GetContactOffsetEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Profiler_CUSTOM_GetRuntimeMemorySizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Texture2DArray_Get_Custom_PropDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35ReflectionProbe_Set_Custom_PropModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN15ReflectionProbe7SetModeENS_4ModeE(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Rigidbody2D_Set_Custom_PropInertiaP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D10SetInertiaEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Canvas_Set_Custom_PropScaleFactorP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas14SetScaleFactorEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Light_Get_Custom_PropSpotAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30Light_Get_Custom_PropIntensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[(HEAP32[i2 + 44 >> 2] | 0) + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30Animator_CUSTOM_IsInTransitionP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZNK8Animator14IsInTransitionEi(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26Mesh_CUSTOM_GetIndicesImplP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z33AllocExtractMeshIndicesFromScriptRK4Meshi(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _UNITY_png_get_y_offset_inches(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 if ((i2 | 0) != 0 & (i3 | 0) != 0) if (!(HEAP32[i3 + 8 >> 2] & 256)) f1 = Math_fround(0.0); else if ((HEAP8[i3 + 180 >> 0] | 0) == 1) f1 = Math_fround(+(HEAP32[i3 + 176 >> 2] | 0) * .00003937); else f1 = Math_fround(0.0); else f1 = Math_fround(0.0);
 return Math_fround(f1);
}

function _UNITY_png_get_x_offset_inches(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f1 = f0;
 if ((i2 | 0) != 0 & (i3 | 0) != 0) if (!(HEAP32[i3 + 8 >> 2] & 256)) f1 = Math_fround(0.0); else if ((HEAP8[i3 + 180 >> 0] | 0) == 1) f1 = Math_fround(+(HEAP32[i3 + 172 >> 2] | 0) * .00003937); else f1 = Math_fround(0.0); else f1 = Math_fround(0.0);
 return Math_fround(f1);
}

function _writev(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall146(146, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _readlink(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall85(85, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _lchown(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall198(198, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZThn32_N19SkinnedMeshRenderer23UpdatePreviousFrameDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = i1 + -32 | 0;
 __ZN12BaseRenderer23UpdatePreviousFrameDataEv(i1 + 32 | 0);
 if (!(HEAP8[i1 + 465 >> 0] | 0)) return;
 i3 = i1 + 468 | 0;
 i1 = i1 + 472 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i2 + 8 + 3 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
}

function __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 148172 + 8;
 i2 = i1 + 12 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx5cloth8SwFabric15scaleRestvaluesEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0, i4 = 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 i4 = HEAP32[i2 + 48 >> 2] | 0;
 i2 = i1 + (i4 << 2) | 0;
 if (!i4) return;
 do {
  HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f3);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx3Ext19ProfileEventHandler5clearEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 i1 = HEAP32[i3 + 28 >> 2] | 0;
 if (i1 | 0) {
  i2 = HEAP32[i3 + 24 >> 2] | 0;
  do {
   i1 = i1 + -1 | 0;
   HEAP32[i2 + (i1 * 20 | 0) + 12 >> 2] = 0;
  } while ((i1 | 0) != 0);
 }
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 36 >> 2] = 0;
 return;
}

function __ZN5physx2Sc9RigidCore20removeShapeFromSceneERNS0_9ShapeCoreEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 i2 = __ZNK5physx2Sc8RigidSim14getSimForShapeERNS0_9ShapeCoreE(i1, i2) | 0;
 __ZN5physx2Sc5Scene11removeShapeERNS0_8ShapeSimEb(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0, i2, i3);
 return;
}

function __ZN5physx2Sc5Scene22prepareParticleSystemsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 148 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 144 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc17ParticleSystemSim9startStepEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD7SystemI15getPluginHandleE15FMOD_PLUGINTYPEiPj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869540;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN28LightProbeProxyVolumeManager19OnLightProbesUpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 + (i2 << 2) | 0;
 do {
  i3 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP32[i3 + 44 >> 2] | 0)) HEAP8[i3 + 154 >> 0] = 1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN22b2EdgeAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_(i2, HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4);
 return;
}

function __ZN20TextRenderingPrivate19NativeTextGenerator17PixelCorrectRoundEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0;
 if (!(HEAP8[i1 + 229 >> 0] | 0)) return Math_fround(f2);
 f3 = Math_fround(HEAPF32[i1 + 248 >> 2]);
 f2 = Math_fround(Math_fround(Math_floor(Math_fround(Math_fround(f3 * f2) + Math_fround(.5)))) / f3);
 return Math_fround(f2);
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStream18getWrittenDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN12IFileAdapter4ReadER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiiiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0) | 0;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[i1 + 12 >> 0] | 0) __ZN12FileAccessor5CloseEv(i1 + 1092 | 0) | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP8[i1 + 5 >> 0] = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN11JpegDecoderD0Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 43136 + 8;
 i1 = i3 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  _jpeg_destroy_decompress(i2);
  i1 = HEAP32[i1 >> 2] | 0;
  if (i1 | 0) __ZdlPv(i1);
 }
 i1 = HEAP32[i3 + 36 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i3);
  return;
 }
 __ZdlPv(i1);
 __ZdlPv(i3);
 return;
}

function __Z54RenderTexture_CUSTOM_INTERNAL_CALL_MarkRestoreExpectedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13RenderTexture19MarkRestoreExpectedEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z53AudioHighPassFilter_Get_Custom_PropHighpassResonanceQP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45ParticleRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 348 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45CharacterController_Get_Custom_PropIsGroundedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN19CharacterController10IsGroundedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40NavMeshAgent_Set_Custom_PropWalkableMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent11SetAreaMaskEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40Cloth_Get_Custom_PropUseVirtualParticlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround((HEAP8[i2 + 93 >> 0] | 0) != 0 & 1);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Effector2D_Set_Custom_PropColliderMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10Effector2D15SetColliderMaskEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Animator_Get_Custom_PropGravityWeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator16GetGravityWeightEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Terrain_Set_Custom_PropDrawHeightmapP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 89 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Collider2D_Get_Custom_PropBouncinessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK10Collider2D13GetBouncinessEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36AudioSource_Get_Custom_PropPanStereoP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource12GetStereoPanEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35SpriteRenderer_Set_Custom_PropFlipYP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 361 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35SpriteRenderer_Set_Custom_PropFlipXP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 360 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Animator_Set_Custom_PropLogWarningsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 424 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34SliderJoint2D_Set_Custom_PropAngleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13SliderJoint2D8SetAngleEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34NavMeshAgent_Set_Custom_PropRadiusP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent9SetRadiusEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34NavMeshAgent_Set_Custom_PropHeightP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent9SetHeightEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34LensFlare_Set_Custom_PropFadeSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9LensFlare12SetFadeSpeedEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Joint2D_Set_Custom_PropBreakTorqueP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Joint2D14SetBreakTorqueEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34AreaEffector2D_Set_Custom_PropDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN14AreaEffector2D7SetDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Joint_Set_Custom_PropBreakForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Joint13SetBreakForceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29DirectorPlayer_CUSTOM_GetTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return +(+mftCall_di(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i2 | 0));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return +(0.0);
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_convert_from_struct_tm(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i1 >> 1] = (HEAP32[i2 + 20 >> 2] | 0) + 1900;
 HEAP8[i1 + 2 >> 0] = (HEAP32[i2 + 16 >> 2] | 0) + 1;
 HEAP8[i1 + 3 >> 0] = HEAP32[i2 + 12 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP32[i2 + 8 >> 2];
 HEAP8[i1 + 5 >> 0] = HEAP32[i2 + 4 >> 2];
 HEAP8[i1 + 6 >> 0] = HEAP32[i2 >> 2];
 return;
}

function _UNITY_FT_Get_Char_Index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i3 + 12 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0) | 0;
 i3 = i3 >>> 0 >= (HEAP32[i1 + 16 >> 2] | 0) >>> 0 ? 0 : i3;
 return i3 | 0;
}

function _readv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall145(145, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _msync(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall144(144, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _chown(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall212(212, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateProfilerEndFramestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 488 >> 2] | 0, i1 | 0) | 0) != 1) return;
 __ZN13UnityProfiler19RecordPreviousFrameE12ProfilerMode(2);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 620 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = i3 + -4 | 0;
 i3 = HEAP32[i1 + 500 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i3 | 0, i3 + (HEAP32[i1 + 504 >> 2] << 2) | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZNK8WWWAudio11GetCapacityEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 f2 = Math_fround((mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0) | 0) >>> 0);
 i1 = HEAP32[i1 >> 2] | 0;
 return ~~Math_fround(f2 / Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0))) >>> 0 | 0;
}

function __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0, f5 = f0;
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 i2 = i3 + 4 | 0;
 f5 = Math_fround(f4 / Math_fround(HEAPF32[i2 >> 2]));
 HEAPF32[i3 >> 2] = Math_fround(f5 * Math_fround(HEAPF32[i3 >> 2]));
 HEAPF32[i2 >> 2] = f4;
 return;
}

function __ZN8Playable6HandleEv(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i2 = i4 + 20 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  __Z18GetDirectorManagerv() | 0;
  i1 = __ZN15DirectorManager11AcquireNodeEv() | 0;
  HEAP32[i2 >> 2] = i1;
 }
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i1 + 20 >> 2] = i4;
 return;
}

function __ZN8Animator9SetAvatarEP6Avatar(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 i3 = (i2 | 0) == 0;
 if (i3) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 i5 = i4 + 104 | 0;
 if ((HEAP32[i5 >> 2] | 0) == (i1 | 0)) return;
 if (i3) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i5 >> 2] = i1;
 __ZN8Animator6RebindEb(i4, 1);
 return;
}

function __ZN5physx8debugger4comm10EndSection9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 24 | 0);
 return;
}

function __ZN5physx2Sn5ConvX6outputEPKci(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 if (!((i2 | 0) != 0 & (HEAP8[i3 + 325 >> 0] | 0) == 0)) return;
 i4 = HEAP32[i3 + 304 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
 i3 = i3 + 312 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
 return;
}

function __ZN5physx2Gu8GJKLocalERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5physx2Gu8gjkLocalINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i1, i2, i3, i4, i5, i6) | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra15PortalRayTracerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 if (i1 | 0) HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] = i1;
 i1 = HEAP32[i2 + 4416 >> 2] | 0;
 if (i1 | 0) HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4420 >> 2];
 i1 = HEAP32[i2 + 4380 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4384 >> 2];
 return;
}

function __ZN4Mesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 425651 | 0, i1, 0);
 __ZN4Mesh8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN4FMOD8ChannelI16setSpeakerLevelsE12FMOD_SPEAKERPfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868726;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI16getSpeakerLevelsE12FMOD_SPEAKERPfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868599;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbI15get3DAttributesEP11FMOD_VECTORPfS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868379;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i1 + 48 >> 2];
 if (i4 | 0) HEAP32[i4 >> 2] = HEAP32[i1 + 36 >> 2];
 if (!i5) return 0;
 HEAP32[i5 >> 2] = 32;
 return 0;
}

function __ZN27AnimatorControllerParameter8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN21ExecutionOrderManager12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163032 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63520 | 0);
 HEAP32[gb + 1163032 >> 2] = 0;
 return;
}

function __ZN18CrashReportManager22InitCrashReportHandlerERK8UnityStrS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = i1 + 28 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i4 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63160 | 0, 16, gb + 1039700 | 0, 43) | 0;
 __ZN18CrashReportHandlerC2ERK8UnityStrS2_(i4, i2, i3);
 HEAP32[i1 >> 2] = i4;
 return;
}

function __ZN15TerrainRenderer13BuildRendererER12QuadTreeNodebi(i1, i3, i2, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 if (i2) {
  i2 = i3 + 60 | 0;
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | 2;
 }
 i1 = i3 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 i4 = i3 + 60 | 0;
 HEAP8[i4 >> 0] = HEAP8[i4 >> 0] | 4;
 return;
}

function __ZN15CapsuleCollider5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 i2 = i1 + 72 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 HEAP32[i1 + 68 >> 2] = 1;
 return;
}

function __ZN15AudioReverbZone17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 116 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __ZN4FMOD6Reverb7releaseEv(i3) | 0;
  HEAP32[i2 >> 2] = 0;
 }
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 __ZN12AudioManager21RemoveAudioReverbZoneEP15AudioReverbZone(__Z15GetAudioManagerv() | 0, i1);
 return;
}

function __ZN11UnityEngine7ConnectL19ConfigChangedStaticEPNS0_14RemoteSettingsERK8UnityStrR8JSONRead(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 if (__Z6StrCmpPKcS0_((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 1041415 | 0) | 0) return;
 __ZN11UnityEngine7Connect14RemoteSettings7SetJSONER8JSONRead(i1, i3);
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobScheduler5CloseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
 HEAP8[i2 >> 0] = 0;
 i2 = 1;
 return i2 | 0;
}

function __ZN11Rigidbody2D15SetCenterOfMassERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 i5 = i2;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i2 = i1 + 80 | 0;
 HEAP32[i2 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i2 + 4 >> 2] = i4;
 HEAP8[i1 + 76 >> 0] = 1;
 __ZN6b2Body13ResetMassDataEv(i3);
 return;
}

function __Z8GetTouchjR5Touch(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if ((HEAP32[gb + 1101424 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i2 = gb + 1101428 + (i2 * 68 | 0) | 0;
 i3 = i1 + 68 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 i3 = 1;
 return i3 | 0;
}

function __Z52AudioDistortionFilter_Get_Custom_PropDistortionLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51ParticleSystemRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 356 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51ParticleRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 368 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51ParticleEmitter_Get_Custom_PropEmitterVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 140 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51ConfigurableJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 280 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z51AudioLowPassFilter_Get_Custom_PropLowpassResonanceQP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 132 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z46TerrainData_Get_Custom_PropWavingGrassStrengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 128 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45ReflectionProbe_Set_Custom_PropShadowDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 96 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Renderer_Set_Custom_PropSortingLayerIDP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Renderer17SetSortingLayerIDEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Camera_Set_Custom_PropDepthTextureModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera19SetDepthTextureModeEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Rigidbody_Get_Custom_PropAngularDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody14GetAngularDragEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36BillboardAsset_Get_Custom_PropHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14BillboardAsset9GetHeightEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36BillboardAsset_Get_Custom_PropBottomP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14BillboardAsset9GetBottomEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Mesh_Get_Custom_PropBlendShapeCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 116 >> 2] | 0) - (HEAP32[i2 + 112 >> 2] | 0) >> 4 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Material_Set_Custom_PropRenderQueueP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Material20SetCustomRenderQueueEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34ReflectionProbe_Set_Custom_PropHdrP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 140 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34Animator_Set_Custom_PropFireEventsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 425 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Texture_CUSTOM_Internal_GetHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Collider2D_Set_Custom_PropDensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10Collider2D10SetDensityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32CanvasGroup_Set_Custom_PropAlphaP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI11CanvasGroup8SetAlphaEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z21HasAlphaTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 1:
 case 2:
 case 4:
 case 5:
 case 6:
 case 9:
 case 11:
 case 12:
 case 13:
 case 14:
 case 17:
 case 20:
 case 25:
 case 29:
 case 31:
 case 33:
 case 36:
 case 46:
 case 47:
  return 1;
 default:
  return (i1 | 0) == 61 | (i1 + -54 | 0) >>> 0 < 6 | 0;
 }
 return 0;
}

function __Z15FMOD_FILE_ClosePvS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) i1 = 19; else {
  i1 = __ZN12FileAccessor5CloseEv(i2) | 0;
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  i1 = i1 ? 0 : 19;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63328 | 0);
 HEAP32[gb + 1459944 >> 2] = (HEAP32[gb + 1459944 >> 2] | 0) + -1;
 return i1 | 0;
}

function _UNITY_png_set_user_transform_info(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 if (HEAP32[i1 + 204 >> 2] & 32768 | 0) if (HEAP32[i1 + 208 >> 2] & 64 | 0) {
  _UNITY_png_app_error(i1, gb + 354723 | 0);
  return;
 }
 HEAP32[i1 + 196 >> 2] = i2;
 HEAP8[i1 + 200 >> 0] = i3;
 HEAP8[i1 + 201 >> 0] = i4;
 return;
}

function _UNITY_png_icc_check_length(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i4 >>> 0 < 132) {
  _UNITY_png_icc_profile_error(i1, i2, i3, i4, gb + 352548 | 0);
  i4 = 0;
  return i4 | 0;
 }
 if (!(i4 & 3)) {
  i4 = 1;
  return i4 | 0;
 }
 _UNITY_png_icc_profile_error(i1, i2, i3, i4, gb + 351232 | 0);
 i4 = 0;
 return i4 | 0;
}

function _poll(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall168(168, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _calloc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!i2) i1 = 0; else {
  i1 = Math_imul(i3, i2) | 0;
  if ((i3 | i2) >>> 0 > 65535) i1 = ((i1 >>> 0) / (i2 >>> 0) | 0 | 0) == (i3 | 0) ? i1 : -1;
 }
 i2 = _malloc(i1) | 0;
 if (!i2) return i2 | 0;
 if (!(HEAP32[i2 + -4 >> 2] & 3)) return i2 | 0;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZNK9Rigidbody19GetSolverIterationsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 296 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNK5physx3Ext14PrismaticJoint11getVelocityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i4 | 0, i1 | 0);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZNK5physx20PxsParticleSystemSim16getShapesUpdateVERNS_29PxvParticleShapeUpdateResultsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = i3;
 i4 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 >> 2] = i4 + (i3 << 2);
 return;
}

function __ZN9AudioClip27IsFormatSupportedByPlatformERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 switch (__ZN9AudioClip22GetFormatFromExtensionERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) | 0) {
 case 13:
 case 0:
  {
   i1 = 0;
   return i1 | 0;
  }
 default:
  {}
 }
 i1 = 1;
 return i1 | 0;
}

function __ZN7mecanim9animation15FindMuscleIndexEj(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = gb + 1465304 | 0;
 while (1) {
  if ((HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0)) break;
  i1 = i1 + 8 | 0;
  if ((i1 | 0) == (gb + 1465304 + 1240 | 0)) {
   i1 = -1;
   i3 = 5;
   break;
  }
 }
 if ((i3 | 0) == 5) return i1 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 return i3 | 0;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE24estimatePersistentMemoryERKNS0_7SwClothE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4sizeEv(i1 + 344 | 0) | 0;
 return ((__ZNK5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4sizeEv(i1 + 356 | 0) | 0) << 5) + (i2 * 96 | 0) | 0;
}

function __ZN5physx42PxVehicleTireLoadFilterDataGeneratedValuesC2EPKNS_27PxVehicleTireLoadFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx38solveFrictionCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi(i6, i1, i5, i2, i3, i4) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i6);
 return;
}

function __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh(i6, i2, i1, i5, i3, i4) {
 i6 = i6 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = 0;
 HEAP16[i6 + 8 >> 1] = i1;
 HEAP8[i6 + 10 >> 0] = i2;
 HEAP8[i6 + 11 >> 0] = i3;
 HEAP8[i6 + 12 >> 0] = i4;
 HEAP8[i6 + 13 >> 0] = i5;
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i6, i4, i5, i1, i2, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 return 1;
}

function __ZN5physx12MemoryBufferD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 89572 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i2 + 8 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 __ZdlPv(i2);
 return;
}

function __ZN4FMOD6SoundI19set3DMinMaxDistanceEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 858934;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21LightProbeProxyVolume18HasHardwareSupportEv() {
 var i1 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0)) i1 = 0; else if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 177 >> 0] | 0)) i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 191 >> 0] | 0) != 0; else i1 = 1;
 return i1 & (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0) > 39 | 0;
}

function __ZN17WeakPtrSharedDataC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 70308 + 8;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[gb + 1178928 >> 2] = (HEAP32[gb + 1178928 >> 2] | 0) + 1;
 return;
}

function __ZN17Physics2DSettingsD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156328 + 8;
 i2 = i1 + 168 | 0;
 if ((HEAP32[i1 + 184 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 172 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15NavMeshObstacle18OnTransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2 & 1 | 0) {
  i3 = i1 + 136 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
 }
 if (i2 & 2 | 0) {
  i3 = i1 + 136 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 2;
 }
 if (!(i2 & 8)) return;
 i3 = i1 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
 return;
}

function __ZN14SpriteRenderer9SetSpriteE4PPtrI6SpriteE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 340 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i3 >> 2] = i1;
 __ZN8Renderer13BoundsChangedEv(i2);
 __ZN14SpriteRenderer15SetupPropertiesEv(i2);
 __ZN14SpriteRenderer18UpdateCachedSpriteEv(i2);
 return;
}

function __ZN13GfxDeviceGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 __ZNK18GfxFramebufferGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, i2);
 return;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStream17getLoadedDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __ZN12_GLOBAL__N_116RequiresCallback7processERN5physx6PxBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i2 | 0) | 0) return;
 i3 = HEAP32[i1 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, i2 | 0, 0, 0);
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeEyPjPt(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = ___udivdi3(i1 | 0, i2 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP32[i3 >> 2] = i5;
 i3 = ___uremdi3(i1 | 0, i2 | 0, 1e5, 0) | 0;
 getTempRet0() | 0;
 HEAP16[i4 >> 1] = i3;
 return;
}

function __Z51NavMeshObstacle_Get_Custom_PropCarvingMoveThresholdP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 72 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45getPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z44Terrain_Set_Custom_PropTreeBillboardDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 68 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44ReflectionProbe_Set_Custom_PropNearClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 88 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43ParticleRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 344 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Canvas_Set_Custom_PropSortingLayerIDP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas17SetSortingLayerIDEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Animator_Get_Custom_PropPlaybackTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator15GetPlaybackTimeEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Rigidbody2D_Get_Custom_PropRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11Rigidbody2D11GetRotationEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Terrain_Set_Custom_PropCastShadowsP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 88 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33WheelCollider_Set_Custom_PropMassP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13WheelCollider7SetMassEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Texture_Set_Custom_PropMipMapBiasP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Texture13SetMipMapBiasEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33NavMeshAgent_Set_Custom_PropSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent8SetSpeedEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Joint2D_Set_Custom_PropBreakForceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Joint2D13SetBreakForceEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33AudioSource_Set_Custom_PropVolumeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource9SetVolumeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33AudioSource_Set_Custom_PropSpreadP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource9SetSpreadEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Texture_CUSTOM_Internal_GetWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29Mesh_CUSTOM_GetBlendShapeNameP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return __Z27GetBlendShapeNameFromScriptRK4Meshi(i3, i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _mknod(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall14(14, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _fwide(i4, i2) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i5 = 0;
 if ((HEAP32[i4 + 76 >> 2] | 0) > -1) i5 = ___lockfile(i4) | 0; else i5 = 0;
 i3 = i4 + 74 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (!(i1 << 24 >> 24)) {
  i1 = (i2 >> 31 | (0 - i2 | 0) >>> 31) & 255;
  HEAP8[i3 >> 0] = i1;
 }
 if (i5 | 0) ___unlockfile(i4);
 return i1 << 24 >> 24 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255) | 0;
}

function __ZNK5physx3Ext13RevoluteJoint11getVelocityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i4 | 0, i1 | 0);
 f3 = Math_fround(HEAPF32[i4 >> 2]);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZNK20OcclusionCullingData22GetStaticRendererCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  i1 = (HEAP32[i3 + (i2 << 5) + 4 >> 2] | 0) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < i4 >>> 0);
 return i1 | 0;
}

function __ZN9Scripting20SendScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject(i1, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i3) | 0;
}

function __ZN8Animator16GetGravityWeightEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 if (!(HEAP8[i2 + 153 >> 0] | 0)) f1 = Math_fround(0.0); else {
  i2 = HEAP32[i2 + 132 >> 2] | 0;
  if (!i2) f1 = Math_fround(0.0); else {
   i2 = HEAP32[i2 + 16 >> 2] | 0;
   if (!i2) f1 = Math_fround(0.0); else f1 = Math_fround(HEAPF32[i2 + 284 >> 2]);
  }
 }
 return Math_fround(f1);
}

function __ZN7mecanim9animation14AvatarConstant8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 464 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1 + 396 | 0;
 __ZN7mecanim5human5HumanC2Ev(i1);
 __ZN7mecanim4hand4HandC2Ev(i2);
 __ZN7mecanim4hand4HandC2Ev(i2);
 STACKTOP = i1;
 return;
}

function __ZN5physx3Ext21computeCapsuleDensityEfff(f3, f1, f2) {
 f3 = Math_fround(f3);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(f2 / Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(4.18879032)) * f3) * f3) + Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(f1 * Math_fround(2.0)))));
}

function __ZN5physx2Sc5Scene21finishParticleSystemsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 148 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 144 | 0;
 i2 = 0;
 do {
  __ZN5physx2Sc17ParticleSystemSim7endStepEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx2Sc16ArticulationCore12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_(i1, i4, i2, i3, i5) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc15ArticulationSim12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_(i1, i4, i2, i3, i5);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i6, i4, i5, i1, i2, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 return 1;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD6SoundI12getOpenStateEP14FMOD_OPENSTATEPjPbS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = _JS_Sound_GetLoadState(HEAP32[i1 + 320 >> 2] | 0) | 0;
 if (i3 | 0) HEAP32[i3 >> 2] = 100;
 if (i4 | 0) HEAP8[i4 >> 0] = 0;
 if (!i5) return 0;
 HEAP8[i5 >> 0] = 0;
 return 0;
}

function __ZN18AsyncUploadManager18ScheduleJobPrivateER8JobFencePFvP28FileTextureUploadInstructionES3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((__Z22GetJobQueueThreadCountv() | 0) > 0) {
  __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i2, i3, i4, 0);
  return;
 } else {
  mftCall_vi(i3 | 0, i4 | 0);
  return;
 }
}

function __ZN17ProceduralTexture17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) return;
 if ((HEAP32[i1 + 108 >> 2] | 0) == (HEAP32[i1 + 104 >> 2] | 0)) {
  __ZN17PersistentManager14ReloadFromDiskER6Object(__Z20GetPersistentManagerv() | 0, i1) | 0;
  return;
 } else {
  __ZN17ProceduralTexture18UploadBakedTextureEv(i1);
  return;
 }
}

function __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 56 | 0;
 i4 = i1 + 28 + (HEAP32[i3 >> 2] << 2) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
 i1 = HEAP32[i1 + 48 + (HEAP32[i3 >> 2] << 2) >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN14VRSplashScreen22StopTrackingLossSplashEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 __Z22DestroyObjectHighLevelP6Objectb(HEAP32[i2 >> 2] | 0, 0);
 i3 = i1 + 8 | 0;
 __Z22DestroyObjectHighLevelP6Objectb(HEAP32[i3 >> 2] | 0, 0);
 HEAP8[i1 + 17 >> 0] = 0;
 HEAP8[i1 + 45 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_16ParserILb1EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 150932 + 8;
 HEAP32[i2 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN12_GLOBAL__N_16ParserILb0EED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 151008 + 8;
 HEAP32[i2 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN12_GLOBAL__N_117ProfileZoneClient16handleEventAddedERKN5physx18PxProfileEventNameE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, HEAP32[i2 + 4 >> 2] | 0, HEAP32[i1 >> 2] | 0, HEAP16[i1 + 4 >> 1] | 0, (HEAP8[i1 + 6 >> 0] | 0) != 0 | 0);
 return;
}

function __Z50WheelCollider_Get_Custom_PropForceAppPointDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z50PlatformEffector2D_Get_Custom_PropRotationalOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z50AudioHighPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z49ParticleSystemRenderer_Get_Custom_PropLengthScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 360 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z49ParticleRenderer_Get_Custom_PropUvAnimationCyclesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 364 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z49ParticleEmitter_Get_Custom_PropRndAngularVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 196 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45RectTransform_Get_Custom_PropDrivenPropertiesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK2UI13RectTransform19GetDrivenPropertiesEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44TerrainData_Get_Custom_PropWavingGrassAmountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 128 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43Terrain_Set_Custom_PropDetailObjectDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 80 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43ReflectionProbe_Set_Custom_PropFarClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 92 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43NavMeshAgent_Get_Custom_PropIsOnOffMeshLinkP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK12NavMeshAgent15IsOnOffMeshLinkEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43GameObject_Get_Custom_PropIsStaticBatchableP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK10GameObject17IsStaticBatchableEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41AudioClip_Get_Custom_PropPreloadAudioDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK10SampleClip19GetPreloadAudioDataEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39RenderTexture_CUSTOM_Internal_SetHeightP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture9SetHeightEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Animation_CUSTOM_PlayDefaultAnimationP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) return (__ZN9Animation4PlayEi(i3, i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35BillboardAsset_Get_Custom_PropWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK14BillboardAsset8GetWidthEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32LightProbes_Get_Custom_PropCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK11LightProbes14LightProbeData12GetNumProbesEv(i2 + 32 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32AudioSource_CUSTOM_PlayScheduledP12Il2CppObjectd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource4PlayEd(i3, d2 < 0.0 ? 0.0 : d2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Camera_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   _memmove(i2 | 0, i3 + 864 | 0, 16) | 0;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31AudioSource_Get_Custom_PropTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource14GetSecPositionEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28Light_Get_Custom_PropIsBakedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 88 >> 2] | 0) >>> 31 & 255 ^ 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZZN8VRModuleC1EvEN11whilePaused7ForwardEv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) return;
 if (__ZNK8VRDevice10ShouldQuitEv(__Z12GetIVRDevicev() | 0) | 0) {
  i1 = __Z15GetInputManagerv() | 0;
  HEAP8[i1 + 189 >> 0] = 1;
  HEAP8[i1 + 188 >> 0] = 1;
  return;
 } else {
  __ZN8VRDevice12ProcessFocusEv(__Z12GetIVRDevicev() | 0);
  return;
 }
}

function __ZThn4_NK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = (HEAP32[i1 + 336 >> 2] | 0) == 0 ? i1 + 320 | 0 : i1 + 332 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 return;
}

function __ZNK9Texture3D26CanReuploadDataToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP32[i1 + 96 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 1048576)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z20GetPersistentManagerv() | 0;
 i1 = __ZN17PersistentManager17IsObjectAvailableEi(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZNK13SliderJoint2D13GetMotorForceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (f2 < Math_fround(.0000999999974) | (i1 | 0) == 0) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZNK16b2PrismaticJoint13GetMotorForceEf(i1, Math_fround(Math_fround(1.0) / f2)));
 return Math_fround(f2);
}

function __ZNK12HingeJoint2D14GetMotorTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (f2 < Math_fround(.0000999999974) | (i1 | 0) == 0) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZNK15b2RevoluteJoint14GetMotorTorqueEf(i1, Math_fround(Math_fround(1.0) / f2)));
 return Math_fround(f2);
}

function __ZN9Animation11SetWrapModeEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 HEAP32[i2 + 36 >> 2] = i3;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 i2 = i2 + 108 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN14AnimationState11SetWrapModeEi(HEAP32[i1 >> 2] | 0, i3);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN8BitArray5emptyEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN6Object15StringToClassIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 i1 = __ZN11TypeManager19ClassNameToTypeInfoEPKcb(HEAP32[gb + 1110260 >> 2] | 0, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, 0) | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx7NpScene18updateDirtyShadersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 3544 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return;
 i1 = i1 + 3540 | 0;
 i2 = 0;
 do {
  __ZN5physx12NpConstraint15updateConstantsEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0);
  i2 = i2 + 1 | 0;
 } while (i2 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE(i4 + 20 | 0, i2, i1, i3);
 return;
}

function __ZN5physx21solveExtFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE(i6, i4, i5, i1, i2, i3) {
 i6 = i6 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
 return 1;
}

function __ZN4FMOD7SystemI14createGeometryEiiPPNS_8GeometryE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869222;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI12loadGeometryEPKviPPNS_8GeometryE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869696;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN23AnimationOffsetPlayable11SetRotationE11Quaternionf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 92 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 96 >> 2] = i5;
 HEAP32[i1 + 100 >> 2] = i4;
 HEAP32[i1 + 104 >> 2] = i3;
 return;
}

function __ZN16GUIKeyboardState16SaveFromGUIStateER8GUIState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 12 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 i3 = i2 + 8 | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14AsyncOperation20SetCoroutineCallbackEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E(i2, i3, i1, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i3;
 HEAP32[i2 + 12 >> 2] = i5;
 HEAP32[i2 + 16 >> 2] = i4;
 return;
}

function __ZN13UnityProfiler24InitializeMemoryProfilerEv(i1) {
 i1 = i1 | 0;
 __Z26scripting_profiler_installPvPFvS_E(0, fb + 3669 | 0);
 __Z29scripting_profiler_install_gcPFvPviiEPFvS_xE(fb + 692 | 0, fb + 693 | 0);
 __Z37scripting_profiler_install_allocationPFvPvP12Il2CppObjectP11Il2CppClassE(fb + 694 | 0);
 __Z29scripting_profiler_set_eventsi(384);
 return;
}

function __Z49LightProbeProxyVolume_Get_Custom_PropProbeDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z49AudioReverbFilter_Get_Custom_PropReflectionsLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 68 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z49AudioReverbFilter_Get_Custom_PropReflectionsDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 72 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48ConfigurableJoint_Get_Custom_PropProjectionAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 284 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48CharacterJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 176 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z48AudioReverbZone_Get_Custom_PropRoomRolloffFactorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43TerrainData_Get_Custom_PropWavingGrassSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 128 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Terrain_Set_Custom_PropTreeCrossFadeLengthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 72 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Terrain_Set_Custom_PropHeightmapPixelErrorP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 52 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41WebCamTexture_Set_Custom_PropRequestedFPSP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 104 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40getPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i2, i3) | 0;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z38GL_CUSTOM_INTERNAL_CALL_Internal_ClearhhRK10ColorRGBAff(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i2 = i2 << 24 >> 24 != 0 & 1;
 __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext(i1 << 24 >> 24 == 0 ? i2 : i2 | 6, i3, f4, 0, HEAP32[gb + 1166248 >> 2] | 0);
 __Z15gpu_time_samplev();
 return;
}

function __Z37Camera_Set_Custom_PropStereoTargetEyeP12Il2CppObject13TargetEyeMask(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 824 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36NavMeshAgent_Set_Custom_PropAreaMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN12NavMeshAgent11SetAreaMaskEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Canvas_Set_Custom_PropTargetDisplayP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN2UI6Canvas16SetTargetDisplayEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Animator_Get_Custom_PropPivotWeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN8Animator14GetPivotWeightEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35AnimationClip_Get_Custom_PropLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZN13AnimationClip9GetLengthEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Rigidbody2D_Get_Custom_PropInertiaP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11Rigidbody2D10GetInertiaEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Collider2D_Get_Custom_PropFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK10Collider2D11GetFrictionEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30Texture3D_Get_Custom_PropDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29Cloth_Set_Custom_PropFrictionP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth11SetFrictionEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27GetScriptingBuiltinResourceP12Il2CppObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z38GetScriptingBuiltinResourceFromManagerR22BuiltinResourceManagerP12Il2CppObjectRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(HEAP32[gb + 1162852 >> 2] | 0, i1, i2) | 0;
}

function __Z25Light_Set_Custom_PropTypeP12Il2CppObject9LightType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Light12SetLightTypeE9LightType(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_set_write_fn(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 HEAP32[i1 + 184 >> 2] = i2;
 HEAP32[i1 + 176 >> 2] = (i3 | 0) == 0 ? fb + 484 | 0 : i3;
 HEAP32[i1 + 468 >> 2] = (i4 | 0) == 0 ? fb + 3247 | 0 : i4;
 i1 = i1 + 180 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function _write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall4(4, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK15RelativeJoint2D16GetAngularOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(HEAPF32[i1 + 96 >> 2]);
  return Math_fround(f3);
 } else {
  f3 = Math_fround(Math_fround(__ZNK12b2MotorJoint16GetAngularOffsetEv(i2)) * Math_fround(57.2957802));
  return Math_fround(f3);
 }
 return f0;
}

function __ZN9GfxDevice11CopyTextureE9TextureIDiiiiiiiS0_iiiii(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return;
}

function __ZN9Animation4StopER14AnimationState(i1, i4) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i3 = 0;
 i3 = i4 + 56 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 i2 = i1 | 64;
 if ((i1 & 10) == 10) {
  HEAP16[i3 >> 1] = i2;
  i1 = i2;
 }
 HEAP16[i3 >> 1] = i1 & -3;
 __ZN14AnimationState7SetTimeEf(i4, Math_fround(0.0));
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -6;
 return;
}

function __ZN6Camera20SetReplacementShaderEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 828 >> 2] = i1;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i2 + 832 | 0, i3) | 0;
 return;
}

function __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 180 | 0;
 HEAP32[i1 + 184 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E(i2, HEAP32[i1 + 12 >> 2] | 0, (HEAP8[i1 + 156 >> 0] & 2) != 0, HEAP32[i1 + 8 >> 2] | 0) | 0;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Light12SetLightTypeE9LightType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 i3 = i1 + 44 | 0;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 40 >> 2] = i2;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i3 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN4FMOD8ChannelI14set3DOcclusionEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868364;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbID2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 24 | 0;
 i3 = i1 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i1 = i1 + 28 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i2, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, i3) | 0;
}

function __ZN16b2BlockAllocator4FreeEPvi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) return;
 if ((i3 | 0) > 640) {
  __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63408 | 0);
  return;
 } else {
  i3 = i1 + 12 + ((HEAPU8[gb + 1552061 + i3 >> 0] | 0) << 2) | 0;
  HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
  HEAP32[i3 >> 2] = i2;
  return;
 }
}

function __ZN13GfxDeviceGLES17SetGpuProgramNameEP10GpuProgramPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) return;
 __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i2 + 4620 | 0, 2, i1, 0, i3);
 return;
}

function __ZN12FileAccessor5WriteEyPKvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 24 >> 2] | 0, i6 | 0, i1 + 4 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 return i6 | 0;
}

function __Z72Camera_Get_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1120 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52Camera_CUSTOM_INTERNAL_CALL_ResetWorldToCameraMatrixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera24ResetWorldToCameraMatrixEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47ParticleRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 352 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47BuoyancyEffector2D_Get_Custom_PropFlowVariationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 116 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47BuoyancyEffector2D_Get_Custom_PropFlowMagnitudeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 112 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43Application_CUSTOM_RequestUserAuthorizationi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN24UserAuthorizationManager24RequestUserAuthorizationEi(__Z27GetUserAuthorizationManagerv() | 0, i1) | 0;
 i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 36 >> 2] | 0) | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return i1 | 0;
}

function __Z41Rigidbody_Get_Custom_PropDetectCollisionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Rigidbody19GetDetectCollisionsEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41MonoBehaviour_Get_Custom_PropUseGUILayoutP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN13MonoBehaviour15GetUseGUILayoutEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40ReflectionProbe_Set_Custom_PropIntensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 132 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Camera_Set_Custom_PropStereoConvergenceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 1100 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38RenderTexture_CUSTOM_Internal_SetWidthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN13RenderTexture8SetWidthEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Rigidbody_Set_Custom_PropConstraintsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody14SetConstraintsEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AudioSource_Get_Custom_PropIsVirtualP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource21AreAllChannelsVirtualEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Animator_Get_Custom_PropHumanScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK8Animator13GetHumanScaleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31HingeJoint_Get_Custom_PropAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK5Unity10HingeJoint8GetAngleEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31GUIText_Set_Custom_PropRichTextP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 65 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i2;
 HEAP32[i5 + 8 >> 2] = i3;
 i3 = ___syscall_ret(___syscall3(3, i5 | 0) | 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _psnames_module_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 204 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) _UNITY_FT_Destroy_Class_pscmaps_services(i1, i5);
 HEAP32[i4 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i4);
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getParticleBaseFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 32768)) {
  i1 = __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i1 + 32 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP16[(HEAP32[i1 + 28 >> 2] | 0) + 76 >> 1] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx14NpArticulation17getSleepThresholdEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 16 >> 2] & 16)) {
  f2 = Math_fround(__ZNK5physx2Sc16ArticulationCore17getSleepThresholdEv(i1 + 24 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 20 >> 2] | 0) + 16 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZN8Renderer24CopyCustomPropertiesFromERK19ShaderPropertySheet(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 224 >> 2] | 0;
 if (i3 | 0) if ((HEAP32[i3 + 92 >> 2] | 0) == (HEAP32[i2 + 92 >> 2] | 0)) return;
 __ZN19ShaderPropertySheet8CopyFromERKS_(__ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv(i1) | 0, i2);
 return;
}

function __ZN8Renderer16LayerMaskChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 284 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) return;
 i3 = __Z16GetRendererScenev() | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
 HEAP32[(HEAP32[i3 + 60 >> 2] | 0) + (i2 * 24 | 0) + 4 >> 2] = i1;
 return;
}

function __ZN5physx3Ext18computeCapsuleMassEfff(f3, f2, f1) {
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(4.18879032)) * f3) * f3) + Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(f2 * Math_fround(2.0)))) * f1);
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE(i4 + 20 | 0, i2, i1, i3);
 return;
}

function __ZN5physx16collideWithPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf(i3, i2, i1, f4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 f4 = Math_fround(f4);
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx16collideWithPlaneERNS_19PxsParticleCollDataEf(i3 + (i1 * 176 | 0) | 0, f4);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Unity11Adjacencies7AddEdgeEjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = HEAP32[i1 >> 2] | 0;
 i6 = HEAP32[i1 + 8 >> 2] | 0;
 HEAP32[i6 + (i5 * 12 | 0) >> 2] = i2;
 HEAP32[i6 + (i5 * 12 | 0) + 4 >> 2] = i3;
 HEAP32[i6 + (i5 * 12 | 0) + 8 >> 2] = i4;
 HEAP32[i1 >> 2] = i5 + 1;
 return 1;
}

function __ZN3WWWD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 73968 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) __ZN14UnityWebStream7ReleaseEv(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 64 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 20 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManager18SetBounceThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 i1 = i1 + 52 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) != f2)) return;
 HEAPF32[i1 >> 2] = f2;
 i1 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN14DLHAudioHelperD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 188088 + 8;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63808 | 0);
 return;
}

function __ZN13SpringJoint2D12SetFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 104 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 HEAPF32[i2 + 68 >> 2] = f1;
 return;
}

function __ZN13GfxDeviceGLES14EndBufferWriteEP9GfxBufferj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i2 + 12 >> 2] | 0) == 1) {
  __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE8EndWriteEj(i2, i3);
  return;
 } else {
  __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE8EndWriteEj(i2, i3);
  return;
 }
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher25IsSessionContainerExpiredERNS0_16SessionContainerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = HEAP32[i2 + 104 + 4 >> 2] | 0;
 i3 = _time(0) | 0;
 return ((i2 + -1 | 0) >>> 0 < i3 >>> 0 ? ((HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 8 >> 2] | 0) + -1 | 0) >>> 0 < (i3 - i2 | 0) >>> 0 : 0) | 0;
}

function __ZN11ClothModule33SetUpSkinnedBuffersOnSkinnedClothEPN5Unity5ClothEPvS3_S3_jb(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 __ZN5Unity5Cloth19SetUpSkinnedBuffersEPvS1_S1_j(i2, i3, i4, 0, i6);
 if (!i7) return;
 __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv(i2);
 return;
}

function __Z51ParticleEmitter_CUSTOM_INTERNAL_CALL_ClearParticlesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN15ParticleEmitter14ClearParticlesEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47WheelCollider_Get_Custom_PropSuspensionDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47SurfaceEffector2D_Get_Custom_PropSpeedVariationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z47AudioReverbZone_Get_Custom_PropReflectionsDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z46TrailRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 384 >> 2] | 0) + 180 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46TrailRenderer_Get_Custom_PropMinVertexDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 392 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z46ParticleEmitter_Get_Custom_PropAngularVelocityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 200 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43getPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i2, i3) | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z40ParticleAnimator_Set_Custom_PropSizeGrowP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 84 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioSource_Get_Custom_PropBypassEffectsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource16GetBypassEffectsEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Camera_Set_Custom_PropStereoSeparationP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 1096 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AudioEchoFilter_Get_Custom_PropDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround((HEAP32[i2 + 44 >> 2] | 0) >>> 0);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Camera_Set_Custom_PropRenderingPathP12Il2CppObject13RenderingPath(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 928 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35AudioSource_Set_Custom_PropPriorityP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11AudioSource11SetPriorityEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Transform_CUSTOM_SetAsLastSiblingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Transform23SetSiblingIndexInternalEib(i2, 2147483647, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Rigidbody2D_Set_Custom_PropMassP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D7SetMassEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Rigidbody2D_Set_Custom_PropDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11Rigidbody2D7SetDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Sprite_Get_Custom_PropPackedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(__ZNK6Sprite13GetRenderDataEb(i2, 1) | 0) + 32 >> 2] & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Cloth_Set_Custom_PropDampingP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Unity5Cloth10SetDampingEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z16GetMemoryManagerv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1188408 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = HEAP32[gb + 73344 >> 2] | 0;
 i2 = i1 + 6960 | 0;
 HEAP32[gb + 73344 >> 2] = i2;
 if (i2 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap();
 __ZN13MemoryManagerC2Ev(i1);
 HEAP32[gb + 1188408 >> 2] = i1;
 i2 = i1;
 return i2 | 0;
}

function _UNITY_png_handle_IEND(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i1 = i3 + 204 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 & 5 | 0) != 5) _UNITY_png_chunk_error(i3, gb + 352423 | 0);
 HEAP32[i1 >> 2] = i2 | 24;
 _UNITY_png_crc_finish(i3, i4) | 0;
 if (!i4) return;
 _UNITY_png_chunk_benign_error(i3, gb + 352446 | 0);
 return;
}

function b52(i1, i2, i7, i8, i9, f10, f11, f12, i13, i14, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 f11 = Math_fround(f11);
 f12 = Math_fround(f12);
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_iiiiiifffiiifii(52);
 return 0;
}

function __ZZN26AnimatorOverrideController15InitializeClassEvEN42FunctorImpl_63kDidModifyAnimatorController4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 208840 + 12;
 HEAP32[i3 >> 2] = gb + 208840 + 32;
 HEAP32[i1 + 4 >> 2] = 0;
 __ZNSt3__28ios_base4initEPv(i3, i2);
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = -1;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = gb + 208792 + 12;
 HEAP32[i3 >> 2] = gb + 208792 + 32;
 HEAP32[i1 + 4 >> 2] = 0;
 __ZNSt3__28ios_base4initEPv(i3, i2);
 HEAP32[i1 + 80 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = -1;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__erase_to_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 + 3 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = i2;
 } else {
  HEAP32[i1 + (i2 << 2) >> 2] = 0;
  HEAP8[i3 >> 0] = i2;
 }
 return;
}

function __ZNK12WheelJoint2D14GetMotorTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (f2 < Math_fround(.0000999999974) | (i1 | 0) == 0) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZNK12b2WheelJoint14GetMotorTorqueEf(i1, Math_fround(Math_fround(1.0) / f2)));
 return Math_fround(f2);
}

function __ZN7ApiGLES15DebugPushMarkerEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[gb + 1451148 >> 2] | 0;
 if (!(HEAP8[i3 + 123 >> 0] | 0)) return;
 if (!(HEAP8[i3 + 122 >> 0] | 0)) {
  mftCall_vii(HEAP32[i1 + 396 >> 2] | 0, 0, i2 | 0);
  return;
 } else {
  mftCall_viiii(HEAP32[i1 + 380 >> 2] | 0, 33354, 0, 0, i2 | 0);
  return;
 }
}

function __ZN5physx36PxHeightFieldGeometryGeneratedValuesC2EPKNS_21PxHeightFieldGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 16 >> 2];
 HEAP8[i2 + 16 >> 0] = HEAP8[i1 + 20 >> 0] | 0;
 return;
}

function __ZN5physx2Sc7ElementD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 90952 + 8;
 __ZN5physx2Sc5Actor15onElementDetachERNS0_7ElementE(HEAP32[i1 + 8 >> 2] | 0, i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra15GateStateVector8setStateEib(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = 1 << (i3 & 31);
 if (i4) {
  i4 = i1 + (i3 >> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | i2;
  return;
 } else {
  i4 = i1 + (i3 >> 5 << 2) | 0;
  HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i2;
  return;
 }
}

function __ZN4FMOD13ChannelGroupI24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868297;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI13RectTransformD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 56064 + 8;
 i2 = i1 + 80 | 0;
 if ((HEAP32[i1 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 84 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN29LineParametersPropertyBindingC2E11ClassIDTypeN11UnityEngine9Animation8BindTypeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = gb + 43452 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 i4 = __Z13GetIAnimationv() | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 4 >> 2] | 0, i4 | 0, i2 | 0, i3 | 0, i1 | 0);
 return;
}

function __ZN24UserAuthorizationManager5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = 3;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  i3 = i1 + 4 | 0;
  HEAP32[i3 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0);
 HEAP32[i2 >> 2] = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ConstantForce2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = gb + 1162356 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAPF32[i1 + 64 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13SpringJoint2D15SetDampingRatioEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 100 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 HEAPF32[i2 + 72 >> 2] = f1;
 return;
}

function __ZN13GfxDeviceGLES32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN4gles24CreateDepthRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE(i1 + 4620 | 0, i2, __ZNK13TranslateGLES9GetFormatE17DepthBufferFormat(HEAP32[i1 + 5480 >> 2] | 0, i3) | 0);
 return 1;
}

function __ZN12FixedJoint2D12SetFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0e6);
 f1 = i4 ? Math_fround(1.0e6) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 100 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 HEAPF32[i2 + 68 >> 2] = f1;
 return;
}

function __ZN12FileAccessor4ReadEyPvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i6) {
  i6 = 0;
  return i6 | 0;
 }
 i6 = mftCall_iiiiiii(HEAP32[(HEAP32[i6 >> 2] | 0) + 16 >> 2] | 0, i6 | 0, i1 + 4 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 return i6 | 0;
}

function __Z46RelativeJoint2D_Get_Custom_PropCorrectionScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z46BuoyancyEffector2D_Get_Custom_PropSurfaceLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45WheelCollider_Get_Custom_PropWheelDampingRateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45PhysicMaterial_Get_Custom_PropFrictionCombineP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN14PhysicMaterial18GetFrictionCombineEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45ParticleRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 348 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45LineRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 344 >> 2] | 0) + 180 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45CharacterJoint_Get_Custom_PropProjectionAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 180 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45BuoyancyEffector2D_Get_Custom_PropAngularDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40Rigidbody_Get_Custom_PropUseConeFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Rigidbody18GetUseConeFrictionEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39ParticleAnimator_Set_Custom_PropDampingP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 80 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39OffMeshLink_Set_Custom_PropNavMeshLayerP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11OffMeshLink7SetAreaEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Transform_Get_Custom_PropHasChangedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Transform23GetHasChangedDeprecatedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Camera_Set_Custom_PropTargetDisplayP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera16SetTargetDisplayEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33AudioSource_Get_Custom_PropVolumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource9GetVolumeEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33AudioSource_Get_Custom_PropSpreadP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource9GetSpreadEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32Shader_Set_Custom_PropMaximumLODP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Shader19SetMaximumShaderLODEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z14GetChannelNameRK14BlendShapeDatai(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i2 | 0) < 0) {
  i3 = gb + 1576256 | 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 40 >> 2] | 0;
 if (((HEAP32[i1 + 44 >> 2] | 0) - i3 >> 4 | 0) <= (i2 | 0)) {
  i3 = gb + 1576256 | 0;
  return i3 | 0;
 }
 i3 = HEAP32[i3 + (i2 << 4) >> 2] | 0;
 return i3 | 0;
}

function __Z13FocusCallbackiPK20EmscriptenFocusEventPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = (i1 | 0) == 13;
 __Z14SetPlayerFocusb(i1);
 if (!(__Z30GetPlayerShouldRunInBackgroundv() | 0)) __Z14SetPlayerPause11PlayerPauseb(i1 & 1 ^ 1, 1);
 if (i1) return 1;
 __ZN12InputManager14ResetInputAxesEv(__Z15GetInputManagerv() | 0);
 return 1;
}

function mftCall_fiiiif(i6, i1, i2, i3, i4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 1 | 0)) return +Math_fround(FUNCTION_TABLE_fiiiif[i6 - fb & 1](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5)));
 return +ftCall_fiiiif(i6 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5);
}

function __ZThn4_NK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = (HEAP32[i1 + 300 >> 2] | 0) == 0 ? i1 + 284 | 0 : i1 + 296 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getParticleBaseFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & 32768)) {
  i1 = __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i1 + 32 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP16[(HEAP32[i1 + 28 >> 2] | 0) + 76 >> 1] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZN9InputAxis10MakeButtonEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 56 >> 2] = i2;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = i3;
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0e3);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0e3);
 HEAP8[i1 + 104 >> 0] = 0;
 return;
}

function __ZN8BitArrayD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) {
  __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN5simdimiERK8Scalar4fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Scalar4fC2Eiiii(i1, (HEAP32[i2 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0, (HEAP32[i2 + 4 >> 2] | 0) - (HEAP32[i3 + 4 >> 2] | 0) | 0, (HEAP32[i2 + 8 >> 2] | 0) - (HEAP32[i3 + 8 >> 2] | 0) | 0, (HEAP32[i2 + 12 >> 2] | 0) - (HEAP32[i3 + 12 >> 2] | 0) | 0);
 return;
}

function __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 + 864 + (i1 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 89572 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 89572 + 32;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) return;
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i2 + 8 >> 2] | 0) + 4 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i4, i3, i5, i6, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i4, i3, i5, i6, i1, i2);
 return;
}

function __ZN4FMOD8ChannelI19get3DDistanceFilterEPbPfS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868432;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPID2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = i1 + 24 | 0;
 i3 = i1 + 32 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i2 | 0)) return;
 i1 = i1 + 28 | 0;
 i5 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 + 8 >> 2] = i4;
 HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN4FMOD13ChannelGroupI20override3DAttributesEPK11FMOD_VECTORS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868246;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21AudioDistortionFilter16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i1 = i1 + 44 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN15UniformTFMethodD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 77360 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = i1 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 __ZdlPv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 189712 + 8;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63800 | 0);
 __ZdlPv(i1);
 return;
}

function __ZL28GeomMTDCallback_ConvexConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 return __ZN5physx2Gu23computeMTD_ConvexConvexERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformES6_S9_(i4, i1, i2, i5, i3, i6) | 0;
}

function __Z50RenderTexture_CUSTOM_INTERNAL_CALL_DiscardContentsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13RenderTexture15DiscardContentsEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45ReflectionProbe_Get_Custom_PropShadowDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45PointEffector2D_Get_Custom_PropForceVariationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45PointEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z45AudioReverbFilter_Get_Custom_PropDecayHFRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44ReflectionProbe_Get_Custom_PropBlendDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 136 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44PointEffector2D_Get_Custom_PropDistanceScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44BuoyancyEffector2D_Get_Custom_PropLinearDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AudioReverbFilter_Get_Custom_PropLfReferenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AreaEffector2D_Get_Custom_PropForceVariationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Terrain_Set_Custom_PropBasemapDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 60 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Camera_Set_Custom_PropNearClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera7SetNearEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GUI_CUSTOM_INTERNAL_CALL_DoLabelRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i3 = HEAP32[i3 >> 2] | 0;
 i4 = __Z11GetGUIStatev() | 0;
 __ZN5IMGUI8GUILabelER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle(i4, i1, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0, i3);
 return;
}

function __Z31CalculateInverseLerpOffsetScaleRK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0;
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(Math_fround(1.0) / Math_fround(f4 - f3));
 f3 = Math_fround(-Math_fround(f3 * f4));
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __Z31AudioClip_Get_Custom_PropLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9AudioClip12GetLengthSecEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30Light_Set_Custom_PropIntensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Light12SetIntensityEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function mftCall_viffff(i6, i1, d2, d3, d4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_viffff[i6 - fb & 15](i1 | 0, Math_fround(d2), Math_fround(d3), Math_fround(d4), Math_fround(d5));
  return;
 }
 ftCall_viffff(i6 | 0, i1 | 0, +d2, +d3, +d4, +d5);
}

function mftCall_iififf(i6, i1, d2, i3, d4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iififf[i6 - fb & 3](i1 | 0, Math_fround(d2), i3 | 0, Math_fround(d4), Math_fround(d5)) | 0;
 return ftCall_iififf(i6 | 0, i1 | 0, +d2, i3 | 0, +d4, +d5) | 0;
}

function ___tandf(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 var d3 = 0.0, d4 = 0.0, d5 = 0.0;
 d3 = d1 * d1;
 d4 = d3 * d3;
 d5 = d3 * d1;
 d1 = d5 * (d3 * .13339200271297674 + .3333313950307914) + d1 + d5 * d4 * (d3 * .024528318116654728 + .05338123784456704 + d4 * (d3 * .009465647849436732 + .002974357433599673));
 return Math_fround(i2 | 0 ? -1.0 / d1 : d1);
}

function __ZNSt3__219__shared_mutex_base15try_lock_sharedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 __ZNSt3__25mutex4lockEv(i3);
 i1 = i3 + 124 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i2 = i4 & 2147483647;
 if ((i4 | 0) > -1 & (i2 | 0) != 2147483647) {
  HEAP32[i1 >> 2] = i2 + 1;
  i1 = 1;
 } else i1 = 0;
 __ZNSt3__25mutex6unlockEv(i3);
 return i1 | 0;
}

function __ZNK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = (HEAP32[i1 + 336 >> 2] | 0) == 0 ? i1 + 320 | 0 : i1 + 332 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN6Sprite17NotifyObjectUsersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = HEAP32[i1 + 156 >> 2] | 0;
 i3 = i1 + 152 | 0;
 i1 = i2;
 if ((i1 | 0) == (i3 | 0)) return;
 do {
  i4 = i2;
  i2 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN14SpriteRenderer14OnDeleteSpriteEv(HEAP32[i4 + 8 >> 2] | 0);
  i1 = i2;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5physx2Gu20registerHeightFieldsEv() {
 HEAP32[gb + 90332 + 24 >> 2] = fb + 136;
 HEAP32[gb + 90332 + 52 >> 2] = fb + 137;
 HEAP32[gb + 90332 + 80 >> 2] = fb + 138;
 HEAP32[gb + 90332 + 108 >> 2] = fb + 139;
 HEAP32[gb + 90332 + 136 >> 2] = fb + 140;
 HEAP32[gb + 90332 + 164 >> 2] = fb + 141;
 HEAP32[gb + 90332 + 192 >> 2] = fb + 142;
 return;
}

function __ZN4FMOD8ChannelI17get3DConeSettingsEPfS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868395;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18ScriptingArguments9AddDoubleEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0, i4 = 0;
 i3 = i1 + 192 | 0;
 HEAPF64[i1 + (HEAP32[i3 >> 2] << 3) >> 3] = d2;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i4 << 2) >> 2] = i1 + (i4 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 3;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN18AudioMixerSnapshot8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN17AudioReverbFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN11AudioFilter4InitEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0);
 __ZN4FMOD3DSP9setBypassEb(HEAP32[i2 >> 2] | 0, 0) | 0;
 return;
}

function __ZN13AnimationClip13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i2, gb + 1105816 | 0);
 HEAP32[i2 + 264 >> 2] = 2139095040;
 HEAP32[i2 + 268 >> 2] = -8388608;
 i1 = HEAP32[gb + 1466576 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(i1 | 0, i2 | 0, i2 + 80 | 0);
 return;
}

function __ZN12FixedJoint2D15SetDampingRatioEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, i4 = 0;
 i3 = f1 < Math_fround(0.0);
 i4 = f1 > Math_fround(1.0);
 f1 = i4 ? Math_fround(1.0) : f1;
 f1 = i3 ? Math_fround(0.0) : f1;
 HEAPF32[i2 + 96 >> 2] = f1;
 i2 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i2) return;
 HEAPF32[i2 + 72 >> 2] = f1;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 189712 + 8;
 i2 = i1 + 4 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 i3 = i1 + 8 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
 HEAP8[i2 >> 0] = 0;
 return;
}

function __Z50Camera_CUSTOM_INTERNAL_CALL_ResetReplacementShaderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera22ResetReplacementShaderEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47Cloth_CUSTOM_INTERNAL_CALL_ClearTransformMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN5Unity5Cloth20ClearTransformMotionEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z47AudioListener_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 60 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Terrain_Get_Custom_PropTreeBillboardDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 68 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44ReflectionProbe_Get_Custom_PropNearClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44PlatformEffector2D_Get_Custom_PropSurfaceArcP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44NavMeshAgent_Get_Custom_PropStoppingDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AudioReverbFilter_Get_Custom_PropRoomRolloffP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AudioReverbFilter_Get_Custom_PropReverbLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AudioReverbFilter_Get_Custom_PropReverbDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AudioReverbFilter_Get_Custom_PropHfReferenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z44AreaEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43TrailRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 384 >> 2] | 0) + 184 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43SurfaceEffector2D_Get_Custom_PropForceScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43ParticleRenderer_Get_Custom_PropLengthScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 344 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43Camera_CUSTOM_ResetStereoProjectionMatricesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera29ResetStereoProjectionMatricesEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43BuoyancyEffector2D_Get_Custom_PropFlowAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41CanvasRenderer_CUSTOM_DisableRectClippingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN2UI14CanvasRenderer19DisableRectClippingEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39Rigidbody_Get_Custom_PropFreezeRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Rigidbody17GetFreezeRotationEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Physics_CUSTOM_INTERNAL_CALL_CheckBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return (__ZN14PhysicsManager7BoxTestERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i1, i2, i3, i4, i5) | 0) & 1 | 0;
}

function __Z36TerrainData_CUSTOM_ResetDirtyDetailsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN14DetailDatabase17ResetDirtyDetailsEv(i2 + 128 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36AudioSource_Get_Custom_PropIsPlayingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN11AudioSource18IsPlayingScriptingEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34GameObject_Get_Custom_PropIsStaticP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN10GameObject21GetIsStaticDeprecatedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32WheelCollider_Get_Custom_PropRpmP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK13WheelCollider6GetRpmEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32AudioSource_Get_Custom_PropPitchP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK11AudioSource8GetPitchEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Mesh_CUSTOM_INTERNAL_set_boundsP12Il2CppObjectRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN4Mesh9SetBoundsERK4AABB(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z25Camera_Set_Custom_PropHdrP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP8[i3 + 1091 >> 0] = i2 << 24 >> 24 != 0 & 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_png_malloc(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 if (i1 | 0) {
  i2 = HEAP32[i3 + 608 >> 2] | 0;
  if (!i2) i1 = _malloc(i1) | 0; else i1 = mftCall_iii(i2 | 0, i3 | 0, i1 | 0) | 0;
  if (i1 | 0) {
   i3 = i1;
   return i3 | 0;
  }
 }
 _UNITY_png_error(i3, gb + 1030621 | 0);
 return 0;
}

function _UNITY_FT_Stream_Seek(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i3) {
  if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < i2 >>> 0) {
   i3 = 85;
   return i3 | 0;
  }
 } else if (mftCall_iiiii(i3 | 0, i1 | 0, i2 | 0, 0, 0) | 0) {
  i3 = 85;
  return i3 | 0;
 }
 HEAP32[i1 + 8 >> 2] = i2;
 i3 = 0;
 return i3 | 0;
}

function _copysignf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 return Math_fround((HEAP32[tempDoublePtr >> 2] = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & -2147483648 | i3 & 2147483647, Math_fround(HEAPF32[tempDoublePtr >> 2])));
}

function _cff_check_points(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (((HEAP16[i1 + 22 >> 1] | 0) + i2 + (HEAP16[i1 + 58 >> 1] | 0) | 0) >>> 0 <= (HEAP32[i1 + 4 >> 2] | 0) >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = _UNITY_FT_GlyphLoader_CheckPoints(i1, i2, 0) | 0;
 return i2 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0; else {
  HEAP32[i2 >> 2] = i3 + 4;
  i1 = HEAP32[i3 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0; else {
  HEAP32[i2 >> 2] = i3 + 1;
  i1 = HEAPU8[i3 >> 0] | 0;
 }
 return i1 | 0;
}

function __ZNK39AssetBundleLoadFromStreamAsyncOperation21GetExpectedStreamSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = __ZNK23ArchiveStorageConverter22GetOriginalArchiveSizeEv(i1) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (__Z19GetActiveColorSpacev() | 0) == 0;
 HEAPF32[i1 >> 2] = Math_fround(5.0);
 HEAPF32[i1 + 4 >> 2] = i2 ? Math_fround(.454545468) : Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN8Renderer12LayerChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 284 | 0;
 if ((HEAP32[i2 >> 2] | 0) == -1) return;
 i3 = __Z16GetRendererScenev() | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
 HEAP32[(HEAP32[i3 + 60 >> 2] | 0) + (i2 * 24 | 0) + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Cm10FanoutTaskD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx18solveFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN22ParticleSystemRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) < 2) __ZN8Renderer16SetMaterialCountEi(i1, 2);
 __ZN22ParticleSystemRenderer16UpdateCachedMeshEv(i1);
 return;
}

function __ZN19UnityConnectService30OnSceneLoadedBeforeAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 switch (i4 | 0) {
 case 2:
 case 4:
  break;
 default:
  return;
 }
 __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i1, 1);
 return;
}

function __ZN19StreamedBinaryWriteILb1EE4InitE24TransferInstructionFlags20BuildTargetSelection(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 return i1 + 16 | 0;
}

function __ZN19StreamedBinaryWriteILb0EE4InitE24TransferInstructionFlags20BuildTargetSelection(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 i4 = i3;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 return i1 + 16 | 0;
}

function __ZN18ScriptingArguments10AddBooleanEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP8[i1 + (HEAP32[i3 >> 2] << 3) >> 0] = i2 & 1;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i2 << 2) >> 2] = i1 + (i2 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN15ParticleEmitter10DeactivateE19DeactivateOperation(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i3 + 109 >> 0] = 0;
 i1 = i3 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 212 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14NavMeshManager13UpdateCarvingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 104 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN14NavMeshCarving14PrepareCarvingEv(i2);
 __ZN14NavMeshCarving5CarveEv(HEAP32[i1 >> 2] | 0);
 if (__Z14IsWorldPlayingv() | 0) return;
 __ZN14NavMeshCarving17ApplyCarveResultsEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN13UnityProfiler27RecordPreviousFrameInternalE12ProfilerMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 1 | 0;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 __ZN11GPUProfiler8EndFrameEv();
 if (HEAP32[i1 + 24 >> 2] & i2 | 0) __ZN13UnityProfiler11SetIsActiveEb(i1, 0);
 __ZN13UnityProfiler8EndFrameEv(i1);
 HEAP8[i3 >> 0] = 0;
 return;
}

function __ZN13GfxDeviceNull16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode(i1, i2, i3, i4, i5, i6, f7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return;
}

function __ZN12WheelJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN15AnchoredJoint2D5ResetEv(i1);
 HEAP8[i1 + 116 >> 0] = 0;
 HEAPF32[i1 + 108 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 112 >> 2] = Math_fround(1.0e4);
 HEAPF32[i1 + 96 >> 2] = Math_fround(.699999988);
 HEAPF32[i1 + 100 >> 2] = Math_fround(2.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(90.0);
 return;
}

function __ZL31GetAndClearChangedTransformsJobP27GetChangedTransformsJobDataPK23TransformAccessReadOnlyj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = i1 + 4 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = (HEAP32[i5 >> 2] | 0) + i3;
 _memcpy((HEAP32[i1 >> 2] | 0) + (i4 << 3) | 0, i2 | 0, i3 << 3 | 0) | 0;
 return;
}

function __Z46Terrain_Set_Custom_PropTreeMaximumFullLODCountP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 76 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z45AudioSource_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 500 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44Application_CUSTOM_GetStreamProgressForLeveli(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 if ((i1 | 0) > -1) {
  i2 = __Z16GetBuildSettingsv() | 0;
  if (((HEAP32[i2 + 32 >> 2] | 0) - (HEAP32[i2 + 28 >> 2] | 0) >> 4 | 0) > (i1 | 0)) {
   f3 = Math_fround(1.0);
   return Math_fround(f3);
  }
 }
 f3 = Math_fround(0.0);
 return Math_fround(f3);
}

function __Z43Terrain_Get_Custom_PropDetailObjectDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43ReflectionProbe_Get_Custom_PropFarClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43PhysicsMaterial2D_Get_Custom_PropBouncinessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43MonoBehaviour_CUSTOM_Internal_IsInvokingAllP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__Z10IsInvokingR13MonoBehaviour(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Light_Get_Custom_PropShadowCustomResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 104 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Cloth_Get_Custom_PropWorldAccelerationScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z43AudioReverbZone_Get_Custom_PropReverbPresetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK15AudioReverbZone15GetReverbPresetEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43AudioReverbZone_Get_Custom_PropDecayHFRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42PointEffector2D_Get_Custom_PropAngularDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42ParticleEmitter_Get_Custom_PropMinEmissionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 132 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42ParticleEmitter_Get_Custom_PropMaxEmissionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 136 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42LineRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 344 >> 2] | 0) + 184 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42AudioReverbZone_Get_Custom_PropLFReferenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40Animator_Get_Custom_PropIsMatchingTargetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator16IsMatchingTargetEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Light_Set_Custom_PropBounceIntensityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 52 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34RenderTexture_Get_Custom_PropDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[gb + 71796 + (HEAP32[i2 + 100 >> 2] << 2) >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Camera_Set_Custom_PropFarClipPlaneP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera6SetFarEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27EdgeCollider2D_CUSTOM_ResetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26DirectorPlayer_CUSTOM_StopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i2 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z25MultiplyMatrixArray4x4REFPK10Matrix4x4fS1_PS_j(i2, i3, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 if (!i5) return; else i1 = 0;
 do {
  __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i2 + (i1 << 6) | 0, i3 + (i1 << 6) | 0, i4 + (i1 << 6) | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z22Animator_CUSTOM_UpdateP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator15UpdateWithDeltaEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function mftCall_vffffi(i6, d1, d2, d3, d4, i5) {
 i6 = i6 | 0;
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vffffi[i6 - fb & 1](Math_fround(d1), Math_fround(d2), Math_fround(d3), Math_fround(d4), i5 | 0);
  return;
 }
 ftCall_vffffi(i6 | 0, +d1, +d2, +d3, +d4, i5 | 0);
}

function _getpriority(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall96(96, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return ((i2 | 0) < 0 ? i2 : 20 - i2 | 0) | 0;
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLLD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 101396 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 101396 + 52;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNK23ArchiveStorageConverter22GetOriginalArchiveSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
 } else if (!(HEAP8[i1 + 56 >> 0] | 0)) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = i2 + 64 | 0;
  i1 = HEAP32[i2 + 4 >> 2] | 0;
  i2 = HEAP32[i2 >> 2] | 0;
 }
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN5physx6shdfnd16MemoryMappedFileC2EPKcj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, 4, gb + 777846 | 0, 27) | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i1;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fEclEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 716 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = i3 + 524 | 0;
 do {
  __ZN5physx5cloth14SwSolverKernelI8Scalar4fE12iterateClothEv(i3);
  __ZN5physx5cloth14IterationStateI8Scalar4fE6updateEv(i2);
 } while ((HEAP32[i1 >> 2] | 0) != 0);
 return;
}

function __ZN5physx2Sc9ClothCore13setTargetPoseERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = i2 + 28 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, i1 + 16 | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStyle(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStylei(i1, i2, i3, i4, i5, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i1, -1784436876, 0, i2, 1) | 0) | 0;
}

function __ZN4FMOD7SystemI11recordStartEiPNS_5SoundEb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869728;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI17get3DConeSettingsEPfS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 868395;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN22UnityWebRequestManager10UnregisterEP15UnityWebRequest(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_(gb + 1468908 | 0, i3);
 STACKTOP = i2;
 return;
}

function __ZN18AnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN25RuntimeAnimatorController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i2);
 __ZN18AnimatorController19TransferRuntimeDataI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16TimerQueriesGLES13AllocateQueryEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 512 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  mftCall_vii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 792 >> 2] | 0, 128, i2 | 0);
  HEAP32[i3 >> 2] = 128;
  i1 = 128;
 }
 i1 = i1 + -1 | 0;
 HEAP32[i3 >> 2] = i1;
 return HEAP32[i2 + (i1 << 2) >> 2] | 0;
}

function __ZN16ParticleRendererD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 190956 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 190956 + 184;
 i2 = HEAP32[i1 + 376 >> 2] | 0;
 if (!i2) {
  __ZN8RendererD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 __ZN8RendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14AreaEffector2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 56 >> 0] = 1;
 HEAP32[i1 + 60 >> 2] = -1;
 HEAP8[i1 + 116 >> 0] = 0;
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(10.0);
 i1 = i1 + 100 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES23CreateGPUSkinPoseBufferEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 511 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63304 | 0, 16, gb + 603515 | 0, 1195) | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 76908 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader7OnAbortEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[i1 + 12 >> 0] | 0) __ZN12FileAccessor5CloseEv(i1 + 1092 | 0) | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP8[i1 + 5 >> 0] = 1;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN10GpuProgram22ApplyTextureParametersEPKhR9GfxDevice10ShaderType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 4 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return i4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, i4 | 0);
 i4 = i4 + (i1 * 12 | 0) | 0;
 return i4 | 0;
}

function __ZN10AudioMixer23OnEnterPlayModePreStartEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 76 >> 2] | 0;
 if (i2 | 0) __ZN5audio5mixer27ClearExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryE(HEAP32[i1 + 72 >> 2] | 0, i2);
 __ZN10AudioMixer18SetCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE(i1, i1 + 68 | 0);
 return;
}

function __Z49Rigidbody_CUSTOM_INTERNAL_CALL_ResetInertiaTensorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Rigidbody18ResetInertiaTensorEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z49Camera_CUSTOM_INTERNAL_CALL_ResetProjectionMatrixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera21ResetProjectionMatrixEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z44WebCamTexture_Set_Custom_PropRequestedHeightP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 100 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43PhysicMaterial_Get_Custom_PropBounceCombineP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN14PhysicMaterial16GetBounceCombineEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42WindZone_Get_Custom_PropWindPulseMagnitudeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42WindZone_Get_Custom_PropWindPulseFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Terrain_Get_Custom_PropTreeCrossFadeLengthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 72 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Terrain_Get_Custom_PropHeightmapPixelErrorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42Terrain_Get_Custom_PropDetailObjectDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbZone_Get_Custom_PropReverbDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbZone_Get_Custom_PropHFReferenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbFilter_Get_Custom_PropDiffusionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z42AudioReverbFilter_Get_Custom_PropDecayTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41WebCamTexture_Get_Custom_PropRequestedFPSP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41SpringJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41AreaEffector2D_Get_Custom_PropAngularDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39WheelCollider_Get_Custom_PropIsGroundedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK13WheelCollider10IsGroundedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39NavMeshAgent_Get_Custom_PropPathPendingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK12NavMeshAgent11PathPendingEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39NavMeshAgent_Get_Custom_PropIsPathStaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK12NavMeshAgent11IsPathStaleEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36TerrainData_Get_Custom_PropThicknessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 248 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Terrain_Set_Custom_PropTreeDistanceP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 64 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Texture_Set_Custom_PropFilterModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Texture13SetFilterModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Texture_Set_Custom_PropAnisoLevelP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Texture13SetAnisoLevelEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Camera_Set_Custom_PropFieldOfViewP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera6SetFovEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Camera_Set_Custom_PropCullingMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera14SetCullingMaskEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Animation_Set_Custom_PropWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Animation11SetWrapModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Camera_Set_Custom_PropCameraTypeP12Il2CppObject10CameraType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 1108 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Rigidbody_Set_Custom_PropMassP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody7SetMassEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Rigidbody_Set_Custom_PropDragP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN9Rigidbody7SetDragEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Animator_Set_Custom_PropSpeedP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator8SetSpeedEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function mftCall_iiiiff(i6, i1, i2, i3, d4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiiiff[i6 - fb & 7](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), Math_fround(d5)) | 0;
 return ftCall_iiiiff(i6 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, +d5) | 0;
}

function b81(i1, i2, i7, i8, i9, i10, i11, i12, f13, i14, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 f13 = Math_fround(f13);
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 nullFunc_fiiiiiiiifiiiif(81);
 return Math_fround(0);
}

function __ZngRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 f5 = Math_fround(-Math_fround(HEAPF32[i2 >> 2]));
 f4 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 f3 = Math_fround(-Math_fround(HEAPF32[i2 + 8 >> 2]));
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(-Math_fround(HEAPF32[i2 + 12 >> 2])));
 return;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb1EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf(i2 + -4 | 0, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZThn4_N16RayRTreeCallbackILi1ELb0EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf(i2 + -4 | 0, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb1EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf(i2 + -4 | 0, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZThn4_N16RayRTreeCallbackILi0ELb0EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf(i2 + -4 | 0, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNK8VRDevice25GetCameraStereoSeparationEPK6Camera(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 i1 = HEAP32[i1 + 280 >> 2] | 0;
 if (!i1) {
  f3 = Math_fround(__ZNK6Camera19GetStereoSeparationEv(i2));
  return Math_fround(f3);
 } else {
  f3 = Math_fround(__ZNK7VRInput16GetEyeSeparationEv(i1));
  return Math_fround(f3);
 }
 return f0;
}

function __ZNK5physx7NpCloth16lockParticleDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0;
 HEAP8[i3 >> 0] = 1;
 i1 = mftCall_iii(i4 | 0, i1 | 0, i3 | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK21EnlightenSceneMapping17GetRenderersBeginEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 32 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 >> 2] | 0) + ((HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + (i2 * 56 | 0) >> 2] | 0) * 40 | 0) | 0;
 return i2 | 0;
}

function __ZNK19VREyeTextureManager19GetEyeTextureHeightEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f3 = Math_fround((HEAP32[i1 + 60 >> 2] | 0) >>> 0);
 f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i1 + 96 >> 2])) + Math_fround(.5));
 i1 = f3 >= Math_fround(0.0);
 f2 = Math_fround(f3 + Math_fround(-.99999994));
 return ~~(i1 ? f3 : f2) | 0;
}

function __ZN8Collider25CreateWithoutIgnoreAttachEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) return;
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) return;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN6Camera18SetBackgroundColorERK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = HEAP32[i2 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 HEAP32[i1 + 848 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 852 >> 2] = i5;
 HEAP32[i1 + 856 >> 2] = i4;
 HEAP32[i1 + 860 >> 2] = i3;
 return;
}

function __ZN5physx37PxJointLimitParametersGeneratedValuesC2EPKNS_22PxJointLimitParametersE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 16 >> 2];
 return;
}

function __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc8RigidSimC2ERNS0_5SceneERNS0_9RigidCoreENS0_14IslandNodeInfo4TypeE(i3, i2, i1, 8);
 HEAP32[i3 >> 2] = gb + 91220 + 8;
 __ZN5physx2Sc16InteractionScene8addActorERNS0_5ActorEb(HEAP32[i2 + 1204 >> 2] | 0, i3, 0);
 return;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation7ExecuteEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[gb + 1104184 >> 2] | 0;
 if (!i1) {
  __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(gb + 1104184 | 0);
  i1 = HEAP32[gb + 1104184 >> 2] | 0;
 }
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i1, fb + 3306 | 0, i2);
 return;
}

function __ZN2UI29MarkParentCanvasDirtyAsNeededEPNS_6CanvasE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 while (1) {
  i1 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i1) {
   i1 = 4;
   break;
  }
  i2 = i1 + 224 | 0;
  HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 4;
  if (HEAP32[i1 + 208 >> 2] | 0) {
   i1 = 4;
   break;
  }
 }
 if ((i1 | 0) == 4) return;
}

function __ZN25StaticProfilerInformation8RegisterEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1163396 >> 2] | 0;
 if (!i1) return;
 i2 = (HEAP32[gb + 1451e3 >> 2] | 0) + 76 | 0;
 do {
  __ZN9profiling14SamplerManager15RegisterSamplerEP19ProfilerInformation(HEAP32[i2 >> 2] | 0, i1) | 0;
  i1 = HEAP32[i1 + 8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN19SkinnedMeshRenderer34GetVisibleSkinnedMeshRendererCountEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1161628 + 4 >> 2] | 0;
 if ((i1 | 0) == (gb + 1161628 | 0)) {
  i2 = 0;
  return i2 | 0;
 } else {
  i2 = i1;
  i1 = 0;
 }
 do {
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (gb + 1161628 | 0));
 return i1 | 0;
}

function __ZN13SubstanceData7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 if (!(HEAP8[i1 + 16 >> 0] | 0)) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63736 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
 return;
}

function __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE10InitializeEv(i1);
 return;
}

function __ZN12HandlerChainD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAP32[i1 >> 2] = gb + 70844 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = i1 + 8 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i4 + (~((i4 + -4 - i2 | 0) >>> 2) << 2);
 __ZdlPv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN12EventManager11RemoveEventEP10EventEntry(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (!i1) return;
 do {
  i2 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  i4 = i2 + 12 | 0;
  HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + -1;
  if (!(HEAP32[i4 >> 2] | 0)) __ZN10MemoryPool10DeallocateEPv(i3, i2);
 } while ((i1 | 0) != 0);
 return;
}

function __ZN11WindManagerD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0, i5 = 0;
 i3 = i2 + 4 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do {
  i4 = i1 + 4 | 0;
  i5 = i1;
  i1 = HEAP32[i4 >> 2] | 0;
  HEAP32[i5 >> 2] = 0;
  HEAP32[i4 >> 2] = 0;
 } while ((i1 | 0) != (i2 | 0));
 HEAP32[i3 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN10Collider2D17OnRemoveComponentEPN5Unity9ComponentE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 156 | 0;
 if ((i2 | 0) == 0 | (HEAP32[i1 >> 2] | 0) == 0) return;
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 153580 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 153580 + 28 >> 2] | 0) >>> 0) return;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z43UnityAnalyticsHandler_CUSTOM_InternalCreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__Z27GetUnityAnalyticsManagerPtrv() | 0)) return;
 i2 = __ZN21UnityAnalyticsManager17GetUnityAnalyticsEv(__Z24GetUnityAnalyticsManagerv() | 0) | 0;
 if (!i2) return;
 __ZN18BaseUnityAnalytics6RetainEv(i2);
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z41TargetJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41Projector_Get_Custom_PropOrthographicSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41PlatformEffector2D_Get_Custom_PropSideArcP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41PhysicsMaterial2D_Get_Custom_PropFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 32 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41CharacterController_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41CharacterController_Get_Custom_PropHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41BuoyancyEffector2D_Get_Custom_PropDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41AudioReverbFilter_Get_Custom_PropDryLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z41AudioEchoFilter_Get_Custom_PropDecayRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40TrailRenderer_Get_Custom_PropTextureModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 384 >> 2] | 0) + 192 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40ReflectionProbe_Get_Custom_PropIntensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 132 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40ParticleEmitter_Get_Custom_PropMinEnergyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 124 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40ParticleEmitter_Get_Custom_PropMaxEnergyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 128 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40FrictionJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioReverbZone_Get_Custom_PropDiffusionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Camera_Get_Custom_PropStereoConvergenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 1100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37AudioSource_Get_Custom_PropSpatializeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource13GetSpatializeEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34GUIText_Set_Custom_PropLineSpacingP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 56 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33TrailRenderer_Set_Custom_PropTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 388 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z30Animator_CUSTOM_StartRecordingP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8Animator14StartRecordingEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27getPxSphereGeometry_IsValidPKN5physx16PxSphereGeometryE(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (HEAP32[i1 >> 2] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 i1 = !(f2 <= Math_fround(0.0)) & ((HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040;
 return i1 | 0;
}

function __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_Pf(i1, i2, i3, i4, i5) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __ZNK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = (HEAP32[i1 + 300 >> 2] | 0) == 0 ? i1 + 284 | 0 : i1 + 296 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i1 >> 2] | 0, i2 << 4 | 0) | 0;
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(HEAP32[i4 + 48 >> 2] | 0, i1, i3, i2);
 return;
}

function __ZNK39AssetBundleLoadFromStreamAsyncOperation18GetDownloadedBytesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = __ZNK23ArchiveStorageConverter22GetOriginalArchiveSizeEv(i1) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK19VREyeTextureManager18GetEyeTextureWidthEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f3 = Math_fround((HEAP32[i1 + 56 >> 2] | 0) >>> 0);
 f3 = Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i1 + 96 >> 2])) + Math_fround(.5));
 i1 = f3 >= Math_fround(0.0);
 f2 = Math_fround(f3 + Math_fround(-.99999994));
 return ~~(i1 ? f3 : f2) | 0;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImplD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 147700 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 147732 + 8;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[HEAP32[i2 + 12 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Cm10FanoutTaskD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx12NpConstraint15updateConstantsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 128 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 i3 = HEAP32[i2 + 56 >> 2] | 0;
 if (!(__ZN5physx2Sc14ConstraintCore15updateConstantsEPv(i2 + 28 | 0, mftCall_ii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0) | 0) | 0)) return;
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN4Node5ResetEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) {
  __ZN4NodeD2Ev(i1);
  __ZdlPv(i1);
 }
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4NodeD2Ev(i2);
  __ZdlPv(i2);
 }
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP8[i3 + 24 >> 0] = 0;
 HEAP32[i3 + 28 >> 2] = 0;
 return;
}

function __ZN18ScriptingArguments9AddIntPtrEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + (HEAP32[i3 >> 2] << 3) >> 2] = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i2 << 2) >> 2] = i1 + (i2 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 10;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 32 | 0, i2);
 __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN17InternalIndexPoolC2Ej(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = gb + 88176 + 8;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if (!i1) return;
 __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i2 + 8 | 0, i1);
 return;
}

function __ZN17ArchiveFileSystem4SeekER13FileEntryDatax10FileOrigin(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 return i5 | 0;
}

function __ZN15QualitySettings22SetShadowCascade2SplitEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 f2 = i3 ? Math_fround(0.0) : f2;
 HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 44 >> 2] = f2;
 return;
}

function __ZN13GfxDeviceNull16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63304 | 0, 16, gb + 612090 | 0, 135) | 0;
 __ZN10GpuProgramC2Ev(i4);
 HEAP32[i4 >> 2] = gb + 78600 + 8;
 return i4 | 0;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream18getWrittenDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN10MemoryFile9SetLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 mftCall_viii(HEAP32[(HEAP32[i4 >> 2] | 0) + 24 >> 2] | 0, i4 | 0, i2 | 0, i3 | 0);
 i4 = 1;
 return i4 | 0;
}

function __Z48Rigidbody_CUSTOM_INTERNAL_CALL_ResetCenterOfMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Rigidbody17ResetCenterOfMassEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43WebCamTexture_Set_Custom_PropRequestedWidthP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 96 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43Terrain_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 92 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z43GameObject_Get_Custom_PropActiveInHierarchyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK10GameObject8IsActiveEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42Transform_Get_Custom_PropHierarchyCapacityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Transform20GetHierarchyCapacityEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42ReflectionProbe_Set_Custom_PropCullingMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 100 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40RelativeJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40ParticleAnimator_Get_Custom_PropSizeGrowP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40NavMeshAgent_Get_Custom_PropAngularSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40NavMeshAgent_Get_Custom_PropAccelerationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40LineRenderer_Get_Custom_PropNumPositionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 348 >> 2] | 0) + 20 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40FixedJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40Cloth_Get_Custom_PropStretchingStiffnessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioReverbZone_Get_Custom_PropDecayTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 72 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioReverbFilter_Get_Custom_PropDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioChorusFilter_Get_Custom_PropWetMix3P12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioChorusFilter_Get_Custom_PropWetMix2P12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AudioChorusFilter_Get_Custom_PropWetMix1P12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z40AreaEffector2D_Get_Custom_PropForceAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39LineRenderer_Get_Custom_PropTextureModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 344 >> 2] | 0) + 192 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37ShaderVariantCollection_CUSTOM_WarmUpP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN23ShaderVariantCollection13WarmupShadersEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Camera_Get_Custom_PropNearClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK6Camera7GetNearEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32Camera_Set_Custom_PropClearFlagsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera13SetClearFlagsEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28LODGroup_Set_Custom_PropSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN8LODGroup7SetSizeEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Camera_Set_Custom_PropAspectP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera9SetAspectEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z22PlatformAppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_(i2, i3, i1);
 return;
}

function mftCall_viifff(i6, i1, i2, d3, d4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viifff[i6 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3), Math_fround(d4), Math_fround(d5));
  return;
 }
 ftCall_viifff(i6 | 0, i1 | 0, i2 | 0, +d3, +d4, +d5);
}

function mftCall_iiiiii(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 255 | 0)) return FUNCTION_TABLE_iiiiii[i6 - fb & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 return ftCall_iiiiii(i6 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function b8(i1, i2, i7, i8, i9, i10, f11, i12, i13, i14, i3, i4, i5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 f11 = Math_fround(f11);
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 nullFunc_fiiiiiifiiiiiif(8);
 return Math_fround(0);
}

function _ft_ansi_stream_io(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 if (!i4) if ((HEAP32[i1 + 4 >> 2] | 0) >>> 0 < i2 >>> 0) {
  i5 = 1;
  return i5 | 0;
 }
 i5 = HEAP32[i1 + 12 >> 2] | 0;
 if ((HEAP32[i1 + 8 >> 2] | 0) != (i2 | 0)) _fseek(i5, i2, 0) | 0;
 i5 = _fread(i3, 1, i4, i5) | 0;
 return i5 | 0;
}

function __ZThn4_N5physx12MemoryBufferD1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 89572 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 89572 + 32;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i2) return;
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0, i2 + -8 | 0, HEAP32[i2 + -4 >> 2] | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 68 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 72 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 68 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 72 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 64 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 68 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 64 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 68 | 0;
 i2 = HEAPU8[i2 >> 0] | HEAPU8[i2 + 1 >> 0] << 8 | HEAPU8[i2 + 2 >> 0] << 16 | HEAPU8[i2 + 3 >> 0] << 24;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function __ZNK9ShaderLab6TexEnv11PrepareDataEiiP15GfxTextureParam(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = __ZN10builtintex17GetDefaultTextureE16TextureDimension(HEAP32[i3 + 4 >> 2] | 0) | 0;
 HEAP32[i4 + 8 >> 2] = i1;
 return;
}

function __ZNK6Camera20GetTemporarySettingsER23CameraTemporarySettings(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 928 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 292 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 1060 >> 2];
 HEAP8[i2 + 13 >> 0] = HEAP8[i1 + 1087 >> 0] | 0;
 HEAP8[i2 + 12 >> 0] = HEAP8[i1 + 1086 >> 0] | 0;
 return;
}

function __ZNK5physx15NpParticleFluid12getViscosityEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 64)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore12getViscosityEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 8 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx15NpParticleFluid12getStiffnessEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 24 >> 2] & 32)) {
  f2 = Math_fround(__ZNK5physx2Sc18ParticleSystemCore12getStiffnessEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + 4 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx14NpRigidDynamic17getAngularDampingEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 8)) {
  f2 = Math_fround(__ZNK5physx2Sc8BodyCore17getAngularDampingEv(i1 + 64 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 56 >> 2] | 0) + 112 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK19TouchPhaseEmulation19GetActiveTouchCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = 0;
 i1 = 0;
 do {
  if ((HEAP32[i3 + (i2 * 96 | 0) >> 2] | 0) != -1) i1 = (((HEAP32[i3 + (i2 * 96 | 0) + 36 >> 2] | 0) + -3 | 0) >>> 0 > 1 & 1) + i1 | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) != 32);
 return i1 | 0;
}

function __ZN9Transform12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1158396 >> 2] | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[gb + 1158396 >> 2] = 0;
 return;
}

function __ZN8Animator14SetAvatarScaleERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i1 = HEAP32[i1 + 136 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 32 >> 2] = i4;
 HEAP32[i1 + 36 >> 2] = i3;
 return;
}

function __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 766871;
 HEAP32[i1 + 4 >> 2] = 268;
 HEAP32[i1 + 8 >> 2] = fb + 3479;
 HEAP32[i1 + 12 >> 2] = fb + 3480;
 HEAP32[i1 + 16 >> 2] = gb + 754608;
 HEAP32[i1 + 20 >> 2] = 269;
 HEAP32[i1 + 24 >> 2] = fb + 2104;
 HEAP32[i1 + 28 >> 2] = fb + 3481;
 return;
}

function __ZN5physx30solveConcludeExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, 0);
 __ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i2, i1);
 return;
}

function __ZN22NavMeshProjectSettings7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(668, i1, 16, gb + 1048932 | 0, 0, gb + 846521 | 0, 28) | 0;
 __ZN22NavMeshProjectSettingsC2ER10MemLabelId18ObjectCreationMode(i3, i1, i2);
 __Z19pop_allocation_rootv();
 return i3 | 0;
}

function __ZN21AssetBundleFileSystem18IsAbsoluteFilePathEPKc(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 96 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 100 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 return (_strncmp(i5, i3, i1) | 0) == 0 | 0;
}

function __ZN19ShaderPropertySheet22GetWritableVectorArrayEi(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i3 = i1 >>> 20 & 1023;
 if (!i3) i1 = 0; else i1 = (HEAP32[i2 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i3;
 return;
}

function __ZN19ShaderPropertySheet22GetWritableMatrixArrayEi(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i3 = i1 >>> 20 & 1023;
 if (!i3) i1 = 0; else i1 = (HEAP32[i2 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i3;
 return;
}

function __ZN17BaseObjectManager16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63520 | 0, 16, gb + 464723 | 0, gb + 369609 | 0, gb + 369627 | 0, 53) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1104724 >> 2] = i1;
 __ZN11TypeManager24InitializeGlobalInstanceEv();
 __ZN6Object16StaticInitializeEv();
 return;
}

function __ZN16MemoryFileSystem4SeekER13FileEntryDatax10FileOrigin(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
 return i5 | 0;
}

function __ZN14EdgeCollider2D12SetPolygon2DEP9Polygon2D(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (i3 | 0)) {
  i2 = 0;
  i1 = 0;
 } else {
  i2 = HEAP32[i3 >> 2] | 0;
  i1 = HEAP32[i3 + 12 >> 2] | 0;
 }
 __ZN14EdgeCollider2D9SetPointsEPK8Vector2fj(i4, i2, i1) | 0;
 return;
}

function __ZN14AnimationEvent8TransferI17RemapPPtrTransferEEvRT_(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 16 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i3 + 36 >> 2] | 0) | 0;
 if (!(HEAP8[i3 + 40 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z58setPxVehicleSuspensionData_MassAndPreserveNaturalFrequencyPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i3 = 0, f4 = f0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 i3 = i2 + 16 | 0;
 HEAPF32[i2 >> 2] = Math_fround(f4 * Math_fround(f1 / Math_fround(HEAPF32[i3 >> 2])));
 HEAPF32[i3 >> 2] = f1;
 return;
}

function __Z47RenderTexture_CUSTOM_INTERNAL_CALL_GenerateMipsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13RenderTexture12GenerateMipsEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z42Terrain_Set_Custom_PropHeightmapMaximumLODP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 56 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41ReflectionProbe_Set_Custom_PropClearFlagsP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 104 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41BillboardAsset_Get_Custom_PropVertexCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK14BillboardAsset14GetNumVerticesEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Rigidbody2D_Get_Custom_PropGravityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39RelativeJoint2D_Get_Custom_PropMaxForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39ParticleAnimator_Get_Custom_PropDampingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39OffMeshLink_Get_Custom_PropCostOverrideP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39FrictionJoint2D_Get_Custom_PropMaxForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39DistanceJoint2D_Get_Custom_PropDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Cloth_Get_Custom_PropWorldVelocityScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 76 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39Cloth_Get_Custom_PropCollisionMassScaleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39AudioReverbFilter_Get_Custom_PropRoomLFP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39AudioReverbFilter_Get_Custom_PropRoomHFP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z39AudioChorusFilter_Get_Custom_PropDryMixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Terrain_Get_Custom_PropLegacyShininessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38TargetJoint2D_Get_Custom_PropFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38SpringJoint_Get_Custom_PropMaxDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38SpringJoint2D_Get_Custom_PropFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38ParticleEmitter_Get_Custom_PropMinSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 116 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38ParticleEmitter_Get_Custom_PropMaxSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 120 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38CircleCollider2D_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 160 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Camera_Get_Custom_PropOrthographicSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 916 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AudioReverbZone_Get_Custom_PropDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 112 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Animator_Get_Custom_PropStabilizeFeetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN8Animator16GetStabilizeFeetEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36ShaderVariantCollection_CUSTOM_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN23ShaderVariantCollection13ClearVariantsEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35getPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i2, i3) | 0;
 i3 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z34Transform_CUSTOM_SetAsFirstSiblingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Transform23SetSiblingIndexInternalEib(i2, 0, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_ft_mem_qalloc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > 0) {
  i1 = mftCall_iii(HEAP32[i1 + 4 >> 2] | 0, i1 | 0, i2 | 0) | 0;
  i2 = i1;
  i1 = (i1 | 0) == 0 ? 64 : 0;
  HEAP32[i3 >> 2] = i1;
  return i2 | 0;
 } else {
  i1 = 0;
  i2 = i2 | 0 ? 6 : 0;
  HEAP32[i3 >> 2] = i2;
  return i1 | 0;
 }
 return 0;
}

function mftCall_iiiifi(i6, i1, i2, i3, d4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiifi[i6 - fb & 3](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0) | 0;
 return ftCall_iiiifi(i6 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0) | 0;
}

function mftCall_iiifii(i6, i1, i2, d3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiifii[i6 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0) | 0;
 return ftCall_iiifii(i6 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0) | 0;
}

function mftCall_iifiii(i6, i1, d2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifiii[i6 - fb & 1](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, i5 | 0) | 0;
 return ftCall_iifiii(i6 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function _getint(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!(_iswdigit(HEAP32[HEAP32[i2 >> 2] >> 2] | 0) | 0)) i1 = 0; else {
  i1 = 0;
  do {
   i3 = HEAP32[i2 >> 2] | 0;
   i1 = (i1 * 10 | 0) + -48 + (HEAP32[i3 >> 2] | 0) | 0;
   i3 = i3 + 4 | 0;
   HEAP32[i2 >> 2] = i3;
  } while ((_iswdigit(HEAP32[i3 >> 2] | 0) | 0) != 0);
 }
 return i1 | 0;
}

function __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 i1 = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = (HEAP32[i3 >> 2] | 0) + 4 | 0;
  HEAP32[i3 >> 2] = i2;
  i1 = i1 + -1 | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZNKSt3__25ctypeIwE10do_toupperEPwPKw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 while (1) {
  if ((i2 | 0) == (i3 | 0)) break;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_upper_tableEv() | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i2 + 4 | 0;
 }
 return i3 | 0;
}

function __ZNKSt3__25ctypeIwE10do_tolowerEPwPKw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 while (1) {
  if ((i2 | 0) == (i3 | 0)) break;
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_lower_tableEv() | 0) + (i1 << 2) >> 2] | 0;
  HEAP32[i2 >> 2] = i1;
  i2 = i2 + 4 | 0;
 }
 return i3 | 0;
}

function __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 f4 = Math_fround(HEAPF32[i2 >> 2]);
 HEAPF32[i3 >> 2] = f4;
 f4 = Math_fround(Math_fround(HEAPF32[i2 >> 2]) / f4);
 i3 = i3 + 4 | 0;
 HEAPF32[i3 >> 2] = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f4);
 return;
}

function __ZNK5physx11NpAggregate9getActorsEPPNS_7PxActorEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = (HEAP32[i3 + 36 >> 2] | 0) - i2 | 0;
 i5 = (i5 | 0) < 0 ? 0 : i5;
 i1 = i5 >>> 0 < i1 >>> 0 ? i5 : i1;
 _memcpy(i4 | 0, (HEAP32[i3 + 40 >> 2] | 0) + (i2 << 2) | 0, i1 << 2 | 0) | 0;
 return i1 | 0;
}

function __ZN9TransformD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 56064 + 8;
 i2 = i1 + 80 | 0;
 if ((HEAP32[i1 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 84 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx32PxClothParticleDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773288;
 HEAP32[i1 + 4 >> 2] = 404;
 HEAP32[i1 + 8 >> 2] = fb + 2274;
 HEAP32[i1 + 12 >> 2] = fb + 3674;
 HEAP32[i1 + 16 >> 2] = gb + 773298;
 HEAP32[i1 + 20 >> 2] = 405;
 HEAP32[i1 + 24 >> 2] = fb + 2275;
 HEAP32[i1 + 28 >> 2] = fb + 3675;
 return;
}

function __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE(i1, i2, i3, i4, i5, i6) | 0;
}

function __ZN5physx2Cm10CollectionD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 >> 2] = gb + 110532 + 8;
 i1 = i3 + 44 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 i1 = i3 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN5physx18PxcNpThreadContextD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 308 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i1 + 300 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 95136 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP16[i2 + 4 >> 1] | 0;
 HEAP8[i2 + 6 >> 0] = (i1 & 65535) < 2 & 1;
 if (!(i1 << 16 >> 16)) HEAP32[i2 >> 2] = 0;
 i1 = HEAP16[i2 + 12 >> 1] | 0;
 HEAP8[i2 + 14 >> 0] = (i1 & 65535) < 2 & 1;
 if (i1 << 16 >> 16) return;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN4FMOD7SystemI17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 44100;
 if (i4 | 0) HEAP32[i4 >> 2] = 2;
 if (!i5) return 0;
 HEAP32[i5 >> 2] = 2;
 return 0;
}

function __ZN4FMOD6SoundI13getVariationsEPfS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869077;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN19ShaderPropertySheet21GetWritableFloatArrayEi(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = HEAP32[(HEAP32[i2 + 52 >> 2] | 0) + (i1 << 2) >> 2] | 0;
 i3 = i1 >>> 20 & 1023;
 if (!i3) i1 = 0; else i1 = (HEAP32[i2 + 72 >> 2] | 0) + (i1 & 1048575) | 0;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i3;
 return;
}

function __ZN13MemoryManager29SetTempAllocatorRequestedSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 1552 >> 2] | 0;
 if (!(i2 >>> 0 > 1048575 & (i1 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 __ZN14StackAllocator16SetRequestedSizeEj(__ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv(i1) | 0, i2);
 i2 = 1;
 return i2 | 0;
}

function __ZN12AudioManager11StopSourcesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 48 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = i2 + 44 | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  i4 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  __ZN11AudioSource4StopEb(HEAP32[i4 + 8 >> 2] | 0, 1);
 } while ((HEAP32[i3 >> 2] | 0) != (i2 | 0));
 return;
}

function __ZN11AudioFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0) return;
 i2 = i1 + 40 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) __ZN11AudioFilter4InitEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0);
 __ZN4FMOD3DSP9setBypassEb(HEAP32[i2 >> 2] | 0, 0) | 0;
 return;
}

function __Z41Rigidbody_Get_Custom_PropSolverIterationsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Rigidbody19GetSolverIterationsEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41Rigidbody_CUSTOM_INTERNAL_CALL_IsSleepingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN9Rigidbody10IsSleepingEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41RenderTexture_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN13RenderTexture6CreateEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41DecompressNativeTextureFormatWithMipLevel13TextureFormatS_iiiPKjiiPj(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj(i1, i2, i3, i4, i6, i7, 0, i9) | 0;
}

function __Z41Camera_Get_Custom_PropActualRenderingPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK6Camera22CalculateRenderingPathEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38WindZone_Get_Custom_PropWindTurbulenceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Terrain_Get_Custom_PropBasemapDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38SurfaceEffector2D_Get_Custom_PropSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38SpringJoint_Get_Custom_PropMinDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Rigidbody2D_Get_Custom_PropAngularDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38Projector_Get_Custom_PropNearClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38NavMeshAgent_Get_Custom_PropBaseOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AudioChorusFilter_Get_Custom_PropDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 68 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AudioChorusFilter_Get_Custom_PropDelayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z38AnimationClip_Get_Custom_PropFrameRateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 88 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37MeshCollider_Get_Custom_PropSkinWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 124 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37FixedJoint2D_Get_Custom_PropFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 100 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Rigidbody_Get_Custom_PropIsKinematicP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Rigidbody14GetIsKinematicEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Camera_Get_Custom_PropFarClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK6Camera6GetFarEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Texture_Set_Custom_PropWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Texture11SetWrapModeEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31OffMeshLink_Set_Custom_PropAreaP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN11OffMeshLink7SetAreaEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Light_Set_Custom_PropBakedIndexP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN5Light13SetBakedIndexEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31GameObject_Set_Custom_PropLayerP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN10GameObject8SetLayerEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31Camera_Set_Custom_PropEventMaskP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera12SetEventMaskEj(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27Font_Get_Custom_PropDynamicP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + 32 >> 2] | 0) == -2 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z27Camera_Set_Custom_PropDepthP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN6Camera8SetDepthEf(i3, f2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Random_Set_Custom_PropSeedi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScriptingRandv() | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 12 >> 2] = (Math_imul(i1, 1812433253) | 0) + 1;
 return;
}

function _tt_driver_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0, i5 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = i1 + 220 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if (!i4) return;
 i5 = HEAP32[i4 >> 2] | 0;
 if (i5 | 0) _UNITY_FT_Destroy_Class_tt_services(i1, i5);
 HEAP32[i4 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i4);
 HEAP32[i3 >> 2] = 0;
 return;
}

function _tre_ast_new_catenation(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = _tre_ast_new_node(i1, 1, 8) | 0;
 if (!i1) i1 = 0; else {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 + 16 >> 2] = (HEAP32[i3 + 16 >> 2] | 0) + (HEAP32[i2 + 16 >> 2] | 0);
 }
 return i1 | 0;
}

function _cf2_getBlueMetrics(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 + 736 | 0;
 HEAP32[i2 >> 2] = _UNITY_FT_DivFix(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, 65536e3) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 + 376 >> 2] << 16;
 HEAP32[i4 >> 2] = HEAP32[i2 + 380 >> 2] << 16;
 return;
}

function __ZThn8_N12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + -8 + 16 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNSt3__219__shared_weak_count4lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 while (1) {
  if ((i2 | 0) == -1) {
   i1 = 0;
   break;
  }
  i4 = HEAP32[i3 >> 2] | 0;
  if ((i4 | 0) == (i2 | 0)) HEAP32[i3 >> 2] = i2 + 1;
  if ((i4 | 0) == (i2 | 0)) break;
  i2 = i4;
 }
 return i1 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx14NpRigidDynamic16getLinearDampingEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 284 >> 2] & 4)) {
  f2 = Math_fround(__ZNK5physx2Sc8BodyCore16getLinearDampingEv(i1 + 64 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[(HEAP32[i1 + 56 >> 2] | 0) + 108 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZN6Object15SetupWeakHandleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 16 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i3 = __Z27scripting_gchandle_weak_newP12Il2CppObject(__Z29scripting_gchandle_get_targetj(i3) | 0) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, 0);
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx6shdfnd9Allocator8allocateEjPKci(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i3) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i4 = mftCall_iiiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 8 >> 2] | 0, i4 | 0, i3 | 0, gb + 1576256 | 0, i1 | 0, i2 | 0) | 0;
 return i4 | 0;
}

function __ZN5physx31PxClothFabricPhaseGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 772419;
 HEAP32[i1 + 4 >> 2] = 304;
 HEAP32[i1 + 8 >> 2] = fb + 2224;
 HEAP32[i1 + 12 >> 2] = fb + 3606;
 HEAP32[i1 + 16 >> 2] = gb + 772429;
 HEAP32[i1 + 20 >> 2] = 305;
 HEAP32[i1 + 24 >> 2] = fb + 2225;
 HEAP32[i1 + 28 >> 2] = fb + 3607;
 return;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Cm10FanoutTaskD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx26resetVehicleToleranceScaleEv() {
 HEAPF32[gb + 1458420 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1458424 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1458428 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1458432 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1458436 >> 2] = Math_fround(0.0);
 HEAPF32[gb + 1458440 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx15solveExt1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return; else i1 = 0;
 do {
  __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3 + (i1 << 5) | 0, 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN4FMOD7SystemI16createSoundGroupEPKcPPNS_10SoundGroupE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869237;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI11getSoundRAMEPiS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869645;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI11getDefaultsEPfS1_S1_Pi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i2 | 0) HEAPF32[i2 >> 2] = Math_fround(44100.0);
 if (i3 | 0) HEAPF32[i3 >> 2] = Math_fround(1.0);
 if (i4 | 0) HEAPF32[i4 >> 2] = Math_fround(1.0);
 if (!i5) return 0;
 HEAP32[i5 >> 2] = 128;
 return 0;
}

function __ZN24iPhoneRemoteNotificationC2EP11objc_object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) return;
 if (!(__ZNK10GameObject8IsActiveEv(i1) | 0)) return;
 __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv(i2);
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i2);
 return;
}

function __ZN17SharedTextureData17GetImageReferenceEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i2, i1, i3, i4) | 0;
 return;
}

function __ZN17Physics2DSettingsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156328 + 8;
 i2 = i1 + 168 | 0;
 if ((HEAP32[i1 + 184 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 172 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN14RenderSettings23UpdateDefaultReflectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[gb + 1112272 >> 2] | 0;
 i3 = HEAP32[i1 + 364 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[((HEAP32[i1 + 368 >> 2] | 0) == 0 ? i1 + 384 | 0 : i1 + 380 | 0) >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i2);
 return;
}

function __ZN13WheelCollider16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i1 = i1 + 84 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN10Collider2D5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 36 >> 2] = 0;
 i4 = gb + 1162356 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP8[i1 + 53 >> 0] = 0;
 return;
}

function __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientProbeP20SphericalHarmonicsL2(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __ZNK14RenderSettings15GetAmbientProbeEv(__Z17GetRenderSettingsv() | 0) | 0;
 i3 = i1 + 108 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z46AnimationClip_CUSTOM_INTERNAL_CALL_ClearCurvesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13AnimationClip11ClearCurvesEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40BillboardAsset_Get_Custom_PropIndexCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK14BillboardAsset13GetNumIndicesEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39NavMeshAgent_CUSTOM_CompleteOffMeshLinkP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN12NavMeshAgent19CompleteOffMeshLinkEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37TextMesh_Get_Custom_PropCharacterSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37TargetJoint2D_Get_Custom_PropMaxForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 92 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37SpringJoint2D_Get_Custom_PropDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Projector_Get_Custom_PropFarClipPlaneP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37NavMeshObstacle_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37NavMeshObstacle_Get_Custom_PropHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Light_Get_Custom_PropShadowResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37ConstantForce2D_Get_Custom_PropTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Cloth_Get_Custom_PropBendingStiffnessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37CapsuleCollider_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37CapsuleCollider_Get_Custom_PropHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37AudioReverbFilter_Get_Custom_PropRoomP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37AudioEchoFilter_Get_Custom_PropWetMixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37AudioEchoFilter_Get_Custom_PropDryMixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37AudioChorusFilter_Get_Custom_PropRateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z37Animator_Get_Custom_PropIsOptimizableP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator13IsOptimizableEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Animator_Get_Custom_PropIsInitializedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator13IsInitializedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Animator_Get_Custom_PropHasRootMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator13HasRootMotionEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36SpringJoint_Get_Custom_PropToleranceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 112 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35OffMeshLink_Get_Custom_PropOccupiedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11OffMeshLink11GetOccupiedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34getPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = __ZNK5physx22PxVehicleWheelsSimData11getTireDataEj(i2, i3) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z34Canvas_Get_Custom_PropPixelPerfectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK2UI6Canvas15GetPixelPerfectEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Camera_Get_Custom_PropFieldOfViewP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK6Camera6GetFovEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30GUIText_Set_Custom_PropTabSizeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAPF32[i3 + 60 >> 2] = f2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Rigidbody_Get_Custom_PropMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody7GetMassEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z29Rigidbody_Get_Custom_PropDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK9Rigidbody7GetDragEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z29Animator_Get_Custom_PropSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK8Animator8GetSpeedEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28Animator_CUSTOM_StringToHashP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = __ZN8Animator22ScriptingStringToCRC32ER11ICallString(i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z26Font_Get_Custom_PropAscentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ~~Math_fround(__ZNK13TextRendering4Font9GetAscentEv(i2)) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z17GetUnityWebStreamv() {
 var i1 = 0, i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[gb + 1451264 >> 2] | 0;
 if (i1 | 0) {
  STACKTOP = i2;
  return i1 | 0;
 }
 _printf_console(gb + 612065 | 0, i2);
 i1 = HEAP32[gb + 1451264 >> 2] | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function mftCall_viifif(i6, i1, i2, d3, i4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viifif[i6 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, Math_fround(d5));
  return;
 }
 ftCall_viifif(i6 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, +d5);
}

function mftCall_viiffi(i6, i1, i2, d3, d4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viiffi[i6 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3), Math_fround(d4), i5 | 0);
  return;
 }
 ftCall_viiffi(i6 | 0, i1 | 0, i2 | 0, +d3, +d4, i5 | 0);
}

function _ps_hints_close(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (i1 | 0) {
  i4 = i1;
  return i4 | 0;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 i2 = _ps_dimension_end(i3 + 16 | 0, i4, i1) | 0;
 if (i2 | 0) {
  i4 = i2;
  return i4 | 0;
 }
 i4 = _ps_dimension_end(i3 + 52 | 0, i4, i1) | 0;
 return i4 | 0;
}

function _glTexSubImage3D__wrapper(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 _glTexSubImage3D(i1 | 0, i2 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0, i11 | 0, i3 | 0);
}

function ___fpclassifyf(f2) {
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = (HEAPF32[tempDoublePtr >> 2] = f2, HEAP32[tempDoublePtr >> 2] | 0);
 switch ((i1 >>> 23 & 255) << 24 >> 24) {
 case 0:
  {
   i1 = i1 & 2147483647 | 0 ? 3 : 2;
   break;
  }
 case -1:
  {
   i1 = (i1 & 8388607 | 0) == 0 & 1;
   break;
  }
 default:
  i1 = 4;
 }
 return i1 | 0;
}

function __ZZN15NavMeshObstacle15InitializeClassEvEN33FunctorImpl_207kDidVelocityChange4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i3 = i1 + 80 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZThn4_N12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + -4 + 20 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEw(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 8 + 3 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = 1;
 } else {
  HEAP8[i1 >> 0] = 1;
  i1 = i2;
 }
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = 0;
 return i2 | 0;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i4 + 424 + (i1 << 6) | 0;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 HEAP8[i4 + 1084 >> 0] = 0;
 return;
}

function __ZN5physx2Sc10ClothShapeD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 91124 + 8;
 if (!(HEAP8[i1 + 24 >> 0] | 0)) {
  __ZN5physx2Sc7ElementD2Ev(i1);
  return;
 }
 __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 + 8 >> 2] | 0) | 0, i1);
 __ZN5physx2Sc7ElementD2Ev(i1);
 return;
}

function __ZN4FMOD8ChannelI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 855848;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI18get3DCustomRolloffEPP11FMOD_VECTORPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868413;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI11registerDSPEP20FMOD_DSP_DESCRIPTIONPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869765;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI6getTagEPKciP8FMOD_TAG(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869070;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN24EllipsoidParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE14CheckIntegrityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv(HEAP32[i1 + 40 >> 2] | 0) | 0;
 return i2 & (__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv(HEAP32[i1 + 36 >> 2] | 0) | 0) | 0;
}

function __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13RenderTexture6CreateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 i1 = __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_(i1, i3, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_117ConnectionManager10disconnectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EERN7mecanim6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE(i1, 1, 0, i2) | 0;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager4StopEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 3;
 HEAP32[i1 + 560 >> 2] = 0;
 __ZN11UnityEngine15CloudWebService19SessionEventManager20ArchivePendingEventsEv(i1);
 i1 = 1;
 return i1 | 0;
}

function __Z55TerrainData_Get_Custom_PropInternal_heightmapResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 248 + 72 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40BillboardAsset_Get_Custom_PropImageCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK14BillboardAsset12GetNumImagesEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38AudioSource_Get_Custom_PropTimeSamplesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK11AudioSource17GetSamplePositionEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38AudioClip_Get_Custom_PropIsReadyToPlayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN9AudioClip11ReadyToPlayEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Shader_Get_Custom_PropDisableBatchingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 64 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36SphereCollider_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Projector_Get_Custom_PropFieldOfViewP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Projector_Get_Custom_PropAspectRatioP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z36Light_Get_Custom_PropBounceIntensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Sprite_Get_Custom_PropPixelsPerUnitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 140 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Rigidbody_Get_Custom_PropUseGravityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK9Rigidbody13GetUseGravityEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35PointEffector2D_Get_Custom_PropDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Cloth_Get_Custom_PropSleepThresholdP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 124 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Canvas_Get_Custom_PropPlaneDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 364 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Camera_Get_Custom_PropStereoEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK6Camera16GetStereoEnabledEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Renderer_Get_Custom_PropIsVisibleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Renderer16IsVisibleInSceneEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32GL_CUSTOM_INTERNAL_get_modelviewP10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0) | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z32AudioClip_CUSTOM_UnloadAudioDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN10SampleClip15UnloadAudioDataEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _sincosl(d1, i2, i3) {
 d1 = +d1;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0, i6 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i4 + 8 | 0;
 i5 = i4;
 _sincos(d1, i6, i5);
 HEAPF64[i2 >> 3] = +HEAPF64[i6 >> 3];
 HEAPF64[i3 >> 3] = +HEAPF64[i5 >> 3];
 STACKTOP = i4;
 return;
}

function __ZThn8_N5physx2Sc18TriggerInteraction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + -8 | 0;
 if (HEAP16[i1 + 56 >> 1] & 32) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + 51 >> 0] & 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[i1 + 16 >> 2] | 0) + 51 >> 0] & 1) == 0;
 return i2 | 0;
}

function __ZNK8VRDevice19GetEyeTextureHeightEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 288 >> 2] | 0;
 if (!i1) {
  i1 = __Z16GetScreenManagerv() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = __ZNK19VREyeTextureManager19GetEyeTextureHeightEv(i1) | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK14UnityWebStream24GetEstimatedDownloadSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = __ZNK39AssetBundleLoadFromStreamAsyncOperation21GetExpectedStreamSizeEv(i1) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN8Animator17SetAvatarPositionERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 i1 = HEAP32[i1 + 136 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i3;
 return;
}

function __ZN7dtCrowd14RemoveObstacleER13dtCrowdHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = HEAP32[i1 + 416 >> 2] | 0;
 HEAP32[i4 + (i3 * 92 | 0) + 84 >> 2] = 0;
 i1 = i1 + 412 | 0;
 HEAP32[i4 + (i3 * 92 | 0) + 88 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN5physx10PxsContext14updateDynamicsEfPNS_10PxBaseTaskERNS_18PxsMaterialManagerE(i4, f3, i2, i1) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx17PxcNpMemBlockPool23acquireConstraintMemoryEv(i4 + 44 | 0);
 __ZN5physx18PxsDynamicsContext6updateEfPNS_10PxBaseTaskE(HEAP32[i4 + 12 >> 2] | 0, f3, i2);
 return;
}

function __ZN4FMOD7SystemI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 855848;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI8getGroupEiPPNS_12ChannelGroupE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 862489;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN24ScriptingMethodFiltering36MethodDescriptionMatchesSearchFilterENS_18MethodSearchFilterEbi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 & 2 | 0) == 0 | i2 ^ 1)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!((i1 & 1 | 0) == 0 | i2)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (i1 & 4 | 0) == 0 | (i3 | 0) < 1;
 return i3 | 0;
}

function __ZN18ScriptingArguments6AddIntEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + (HEAP32[i3 >> 2] << 3) >> 2] = i2;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i1 + 96 + (i2 << 2) >> 2] = i1 + (i2 << 3);
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 1;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN14ParticleSystem4CullEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 i2 = i1 + 40 | 0;
 HEAP8[(HEAP32[i2 >> 2] | 0) + 30 >> 0] = 1;
 d3 = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAPF64[(HEAP32[i2 >> 2] | 0) + 32 >> 3] = d3;
 __ZN14ParticleSystem17RemoveFromManagerEv(i1);
 return;
}

function __ZN13ProbeRendererC2EP13RenderTextureS1_b(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i3;
 HEAP8[i1 + 28 >> 0] = i4 & 1;
 return;
}

function __ZN10MeshFilter15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 1046285 | 0, gb + 430168 | 0, gb + 1048075 | 0);
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30872 | 0, gb + 1105256 | 0, fb + 523 | 0, 0);
 return;
}

function __Z45MonoBehaviour_CUSTOM_Internal_CancelInvokeAllP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z12CancelInvokeR13MonoBehaviour(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z39SliderJoint2D_Get_Custom_PropLimitStateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK13SliderJoint2D13GetLimitStateEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Animator_CUSTOM_CheckIfInIKPassInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN8Animator10IsInIKPassEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38MonoBehaviour_CUSTOM_StopAllCoroutinesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13MonoBehaviour17StopAllCoroutinesEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35WheelCollider_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 72 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35TextMesh_Get_Custom_PropLineSpacingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35Terrain_Get_Custom_PropTreeDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 64 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z35LensFlare_Get_Custom_PropBrightnessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34AreaEffector2D_Get_Custom_PropDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Physics2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z19GetPhysicsManager2Dv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 return (__ZNK16Physics2DManager16IsTouchingLayersEPK10Collider2Di(i3, i1, i2) | 0) & 1 | 0;
}

function __Z28Camera_Get_Custom_PropAspectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(__ZNK6Camera9GetAspectEv(i2));
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z23tessMeshDiscardExteriorP8TESSmesh(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0, i4 = 0;
 i4 = i3 + 44 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 if ((i1 | 0) == (i4 | 0)) return;
 do {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  if (!(HEAP8[i2 + 21 >> 0] | 0)) __Z15tessMeshZapFaceP8TESSmeshP8TESSface(i3, i2);
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __Z23Random_CUSTOM_InitStatei(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScriptingRandv() | 0;
 HEAP32[i2 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 i1 = (Math_imul(i1, 1812433253) | 0) + 1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 12 >> 2] = (Math_imul(i1, 1812433253) | 0) + 1;
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function mftCall_viiiii(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 255 | 0)) {
  FUNCTION_TABLE_viiiii[i6 - fb & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
  return;
 }
 ftCall_viiiii(i6 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_65kDidDeleteMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_64kDidModifyMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = i3 + 8 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0, 0, i4 | 0);
 return;
}

function __ZNK27AnimatorControllerParameter13GetDefaultIntEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 16 >> 2] | 0) == 3) {
  i1 = HEAP32[i1 + 24 >> 2] | 0;
  return i1 | 0;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 911712 | 0, 0, gb + 911526 | 0, 104, 1, 0, 0, 0);
  i1 = 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0, f4 = f0, f5 = f0;
 i2 = HEAP32[i2 >> 2] | 0;
 f5 = Math_fround(HEAPF32[i2 >> 2]);
 f4 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f5, f4, f3, Math_fround(HEAPF32[i2 + 12 >> 2]));
 return;
}

function __ZN9SubModule14SubEmitterData8LessThanEPKS0_S2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 if ((i3 | 0) == (i4 | 0)) {
  i4 = (HEAP32[i1 >> 2] | 0) < (HEAP32[i2 >> 2] | 0);
  return i4 | 0;
 } else {
  i4 = (i3 | 0) < (i4 | 0);
  return i4 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd12ErrorHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (__ZN5physx6shdfnd10Foundation11getInstanceEv() | 0) + 48 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 765184;
 HEAP32[i1 + 4 >> 2] = 395;
 HEAP32[i1 + 8 >> 2] = fb + 396;
 HEAP32[i1 + 12 >> 2] = fb + 338;
 HEAP32[i1 + 16 >> 2] = gb + 674772;
 HEAP32[i1 + 20 >> 2] = 396;
 HEAP32[i1 + 24 >> 2] = fb + 397;
 HEAP32[i1 + 28 >> 2] = fb + 339;
 return;
}

function __ZN5physx24NpPtrTableStorageManager8canReuseEjj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (i1 >>> 0 < 5) i2 = 0; else if (i1 >>> 0 < 17) i2 = 1; else i2 = i1 >>> 0 < 65 ? 2 : 3;
 if (i3 >>> 0 < 5) i1 = 0; else if (i3 >>> 0 < 17) i1 = 1; else i1 = i3 >>> 0 < 65 ? 2 : 3;
 return i3 >>> 0 < 65 & (i2 | 0) == (i1 | 0) | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 92112 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx17PxMeshOverlapUtilD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == (i2 + 4 | 0)) {
  STACKTOP = i3;
  return;
 }
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i1);
 STACKTOP = i3;
 return;
}

function __ZN5physx12NpConstraintD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 93148 + 8;
 if (HEAP16[i1 + 6 >> 1] & 1) {
  i2 = HEAP32[i1 + 56 >> 2] | 0;
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 }
 __ZN5physx9NpFactory19onConstraintReleaseEPNS_12PxConstraintE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 return;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Umbra8fillByteEPvhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i3) return;
 if (i3 >>> 0 > 7) {
  i4 = i1 & 7;
  if (i4 | 0) {
   i4 = 8 - i4 | 0;
   _memset(i1 | 0, i2 | 0, i4 | 0) | 0;
   _memset(i1 + i4 | 0, i2 | 0, i3 - i4 | 0) | 0;
   return;
  }
 }
 _memset(i1 | 0, i2 | 0, i3 | 0) | 0;
 return;
}

function __ZN4FMOD8ChannelI18set3DCustomRolloffEP11FMOD_VECTORi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868640;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI10loadPluginEPKcPjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869709;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI18get3DCustomRolloffEPP11FMOD_VECTORPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868413;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI8addInputEPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 857481;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN26AnimatorControllerPlayable22SyncControllerConstantEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 84 >> 2] | 0;
 if (!i2) return;
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, 0) | 0;
 if ((i2 | 0) == (HEAP32[i1 + 92 >> 2] | 0)) return;
 __ZN26AnimatorControllerPlayable13RebuildMemoryEv(i1);
 return;
}

function __ZN15CollisionModule9ResetSeedERK27ParticleSystemReadOnlyState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i1 + 996 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN14PhysicsManager10OverlapBoxERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5Unity12PhysicsQuery10OverlapBoxERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction(i1 + 736 | 0, i2, i3, i4, i5, i6) | 0;
}

function __ZN10MemoryPool16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63696 | 0, 16, gb + 488467 | 0, 9) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[gb + 1170804 >> 2] = i1;
 return;
}

function __Z8XORCryptPKvjS0_jPv(i2, i3, i4, i5, i6) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 var i1 = 0;
 if (!i5) return; else i1 = 0;
 do {
  HEAP8[i6 + i1 >> 0] = (HEAPU8[i4 + i1 >> 0] | 0) ^ (HEAPU8[i2 + ((i1 >>> 0) % (i3 >>> 0) | 0) >> 0] | 0) + i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i5 | 0));
 return;
}

function __Z54TerrainData_Get_Custom_PropInternal_alphamapResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 32 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42NavMeshAgent_Get_Custom_PropUpdateRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAPU8[i2 + 107 >> 0] | 0) >>> 1 & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Transform_Get_Custom_PropHierarchyCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Transform17GetHierarchyCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Animator_CUSTOM_ApplyBuiltinRootMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN8Animator22ApplyBuiltinRootMotionEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Projector_Set_Custom_PropIgnoreLayersP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 60 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37AnimationClip_Set_Custom_PropWrapModeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 96 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Cloth_Get_Custom_PropSolverFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ~~Math_fround(HEAPF32[i2 + 120 >> 2]) & 255 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34SliderJoint2D_Get_Custom_PropAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34NavMeshAgent_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34NavMeshAgent_Get_Custom_PropHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34LensFlare_Get_Custom_PropFadeSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34Joint2D_Get_Custom_PropBreakTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z34GUIText_Get_Custom_PropLineSpacingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 56 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33TrailRenderer_Get_Custom_PropTimeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 388 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33SpringJoint_Get_Custom_PropSpringP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 104 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33SpringJoint_Get_Custom_PropDamperP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 108 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z24LODGroup_CUSTOM_ForceLODP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __Z13ForceLODLevelRK8LODGroupi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z14b2PairLessThanRK6b2PairS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 if ((i3 | 0) < (i4 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 if ((i3 | 0) != (i4 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i2 + 4 >> 2] | 0);
 return i4 | 0;
}

function _UNITY_png_write_image(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 if (!i3) return;
 i4 = i3 + 348 | 0;
 if (!(HEAP32[i4 >> 2] | 0)) return; else i2 = 0;
 while (1) {
  _UNITY_png_write_row(i3, HEAP32[i1 >> 2] | 0);
  i2 = i2 + 1 | 0;
  if (i2 >>> 0 >= (HEAP32[i4 >> 2] | 0) >>> 0) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function _UNITY_FT_Init_Class_ft_outline_glyph_class(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 40;
 HEAP32[i1 + 4 >> 2] = 1869968492;
 HEAP32[i1 + 8 >> 2] = fb + 1004;
 HEAP32[i1 + 12 >> 2] = fb + 3837;
 HEAP32[i1 + 16 >> 2] = fb + 1005;
 HEAP32[i1 + 20 >> 2] = fb + 961;
 HEAP32[i1 + 24 >> 2] = fb + 4201;
 HEAP32[i1 + 28 >> 2] = fb + 1006;
 return;
}

function mftCall_viiiif(i6, i1, i2, i3, i4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiiif[i6 - fb & 3](i1 | 0, i2 | 0, i3 | 0, i4 | 0, Math_fround(d5));
  return;
 }
 ftCall_viiiif(i6 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5);
}

function mftCall_viiifi(i6, i1, i2, i3, d4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_viiifi[i6 - fb & 7](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4), i5 | 0);
  return;
 }
 ftCall_viiifi(i6 | 0, i1 | 0, i2 | 0, i3 | 0, +d4, i5 | 0);
}

function mftCall_viifii(i6, i1, i2, d3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_viifii[i6 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0, i5 | 0);
  return;
 }
 ftCall_viifii(i6 | 0, i1 | 0, i2 | 0, +d3, i4 | 0, i5 | 0);
}

function mftCall_vifiii(i6, i1, d2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_vifiii[i6 - fb & 3](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0, i5 | 0);
  return;
 }
 ftCall_vifiii(i6 | 0, i1 | 0, +d2, i3 | 0, i4 | 0, i5 | 0);
}

function _cfmakeraw(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -1516;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -2;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -32844;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -305 | 48;
 HEAP8[i1 + 23 >> 0] = 1;
 HEAP8[i1 + 22 >> 0] = 0;
 return;
}

function __ZThn8_N5physx2Sc18TriggerInteraction10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + -8 | 0;
 if (HEAP16[i1 + 56 >> 1] & 32) {
  i2 = 1;
  return i2 | 0;
 }
 if (HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + 51 >> 0] & 1) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[i1 + 16 >> 2] | 0) + 51 >> 0] & 1) != 0;
 return i2 | 0;
}

function __ZNK8VRDevice18GetEyeTextureWidthEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 288 >> 2] | 0;
 if (!i1) {
  i1 = __Z16GetScreenManagerv() | 0;
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = __ZNK19VREyeTextureManager18GetEyeTextureWidthEv(i1) | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK8Animator38PrepareAnimatorControllerPlayableCacheEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 if (HEAP32[i1 + 596 >> 2] | 0) return;
 i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 + 584 | 0);
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK14ImageReference13NeedsReformatEii13TextureFormat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (i2 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 if ((HEAP32[i1 + 8 >> 2] | 0) != (i3 | 0)) {
  i4 = 1;
  return i4 | 0;
 }
 i4 = (HEAP32[i1 >> 2] | 0) != (i4 | 0);
 return i4 | 0;
}

function __ZN9Scripting36IsSystemCollectionsGenericDictionaryEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 if (_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i1) | 0, gb + 465881 | 0) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 i1 = (i1 | 0) == (__Z20scripting_get_corlibv() | 0);
 return i1 | 0;
}

function __ZN6Camera25InvokePostRenderCallbacksEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = HEAP32[i2 + 1156 >> 2] | 0;
 i4 = HEAP32[i2 + 1168 >> 2] | 0;
 i3 = i1 + (i4 << 3) | 0;
 if (!i4) return;
 do {
  mftCall_vii(HEAP32[i1 >> 2] | 0, i2 | 0, HEAP32[i1 + 4 >> 2] | 0);
  i1 = i1 + 8 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN5simdieqERK8Scalar4fS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Scalar4fC2Ebbbb(i1, (HEAP32[i2 >> 2] | 0) == (HEAP32[i3 >> 2] | 0), (HEAP32[i2 + 4 >> 2] | 0) == (HEAP32[i3 + 4 >> 2] | 0), (HEAP32[i2 + 8 >> 2] | 0) == (HEAP32[i3 + 8 >> 2] | 0), (HEAP32[i2 + 12 >> 2] | 0) == (HEAP32[i3 + 12 >> 2] | 0));
 return;
}

function __ZN5physx2Sc5Scene15postNarrowPhaseEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + 1204 | 0;
 if (HEAP32[i2 + 148 >> 2] | 0) __ZN5physx21PxsBodyTransformVault6updateEv((HEAP32[(HEAP32[i1 >> 2] | 0) + 1e3 >> 2] | 0) + 1444 | 0);
 __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(HEAP32[i1 >> 2] | 0, 0);
 return;
}

function __ZN5physx2Cm17FreeListAllocator11directAllocEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 + 16 | 0, 0, gb + 732730 | 0, 82) | 0) + 16 | 0;
 i3 = i2;
 HEAP32[i3 + -4 >> 2] = 16;
 HEAP32[i3 + -8 >> 2] = i1;
 return i2 | 0;
}

function __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 560 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx18addTorqueCurvePairEPNS_19PxVehicleEngineDataEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0, i5 = 0;
 i4 = i1 + 64 | 0;
 HEAPF32[i1 + (HEAP32[i4 >> 2] << 1 << 2) >> 2] = f2;
 i5 = HEAP32[i4 >> 2] | 0;
 HEAPF32[i1 + ((i5 << 1 | 1) << 2) >> 2] = f3;
 HEAP32[i4 >> 2] = i5 + 1;
 return;
}

function __ZN5audio5mixer26CopyExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) != (i4 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 _memcpy(i3 | 0, HEAP32[i2 + 40 >> 2] | 0, i4 << 2 | 0) | 0;
 i4 = 1;
 return i4 | 0;
}

function __ZN4FMOD8ChannelI15get3DAttributesEP11FMOD_VECTORS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868379;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869942;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869598;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI11getWaveDataEPfii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i1;
 HEAP32[i4 >> 2] = 78;
 HEAP32[i4 + 4 >> 2] = gb + 869684;
 _printf(gb + 857490 | 0, i4) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN3WWWD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 73968 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (i2 | 0) __ZN14UnityWebStream7ReleaseEv(i2);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 64 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 20 | 0);
 return;
}

function __ZN20BufferedSocketStream13OnSocketErrorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 19 >> 0] = (HEAP32[i1 + 72 >> 2] | 0) != 0 & 1;
 i2 = i1 + 18 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZN6Socket10CheckErrorEiPKcii(__Z13shutdown_stubii(HEAP32[i1 + 4 >> 2] | 0, 2) | 0, gb + 584846 | 0, 107, 0) | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN16MemoryFileSystem18IsAbsoluteFilePathEPKc(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 24 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 28 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 return (_strncmp(i5, i3, i1) | 0) == 0 | 0;
}

function __ZN14DetailDatabase17ResetDirtyDetailsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i3 = i1;
 if ((i2 | 0) == (i1 | 0)) return;
 i2 = (i2 - i1 | 0) / 52 | 0;
 i1 = 0;
 do {
  HEAP8[i3 + (i1 * 52 | 0) + 24 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i2 >>> 0);
 return;
}

function __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl(i1, i2, _time(0) | 0) | 0;
}

function __ZN13b2DynamicTree8FreeNodeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 16 | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i4 + (i2 * 36 | 0) + 20 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i4 + (i2 * 36 | 0) + 32 >> 2] = -1;
 HEAP32[i3 >> 2] = i2;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN13MemoryManager18AddCustomAllocatorEP13BaseAllocator(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = i2 + 3812 | 0;
 i4 = HEAP32[i5 >> 2] | 0;
 i2 = i2 + 1764 + (i4 << 2) | 0;
 HEAP32[i5 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 >> 2] = i4 + 128;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN13MemoryManager12GetAllocatorERK10MemLabelId(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) < 128) {
  i2 = HEAP32[i2 + 3824 + (i1 * 24 | 0) >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = HEAP32[i2 + 1764 + (i1 + -128 << 2) >> 2] | 0;
  i2 = i2 >>> 0 > 512 >>> 0 ? i2 : 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN13InitialModule9ResetSeedERK27ParticleSystemReadOnlyState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i1 + 2556 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN11ClothModule19CleanupClothManagerEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 if (!i1) return;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, 0, 0) | 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1459016 >> 2] = 0;
 return;
}

function __Z59AnchoredJoint2D_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 92 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z53TerrainData_Get_Custom_PropInternal_baseMapResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 32 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 4);
 return;
}

function __Z39InitializeAnimationStateNetworkProviderv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 907015 | 0, gb + 1576256 | 0, gb + 907046 | 0, 43) | 0;
 HEAP32[i1 >> 2] = gb + 179088 + 8;
 __Z19pop_allocation_rootv();
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(i1);
 return;
}

function __Z38NavMeshAgent_Get_Custom_PropPathStatusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK12NavMeshAgent13GetPathStatusEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38HingeJoint2D_Get_Custom_PropLimitStateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK12HingeJoint2D13GetLimitStateEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38AudioSource_Get_Custom_PropRolloffModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK11AudioSource14GetRolloffModeEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35NavMeshAgent_Get_Custom_PropHasPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK12NavMeshAgent7HasPathEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33WheelCollider_Get_Custom_PropMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 96 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Texture_Get_Custom_PropMipMapBiasP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33NavMeshAgent_Get_Custom_PropSpeedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Joint2D_Get_Custom_PropBreakForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z33Collider2D_Get_Custom_PropDensityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z18TreePrototypeToCppRK17MonoTreePrototypeR13TreePrototype(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(HEAP32[i2 >> 2] | 0) | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_set_expand_gray_1_2_4_to_8(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4096;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _UNITY_FT_List_Remove(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!((i2 | 0) != 0 & (i1 | 0) != 0)) return;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) HEAP32[i2 >> 2] = i1; else HEAP32[i3 + 4 >> 2] = i1;
 if (!i1) {
  HEAP32[i2 + 4 >> 2] = i3;
  return;
 } else {
  HEAP32[i1 >> 2] = i3;
  return;
 }
}

function _tre_ast_new_union(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = _tre_ast_new_node(i1, 3, 8) | 0;
 if (!i1) i1 = 0; else {
  i4 = HEAP32[i1 + 4 >> 2] | 0;
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = i3;
  HEAP32[i1 + 16 >> 2] = (HEAP32[i3 + 16 >> 2] | 0) + (HEAP32[i2 + 16 >> 2] | 0);
 }
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdateProfilerSynchronizeStatsstruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z26IsProfilerEnabledThisFramev() | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 628 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 640 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 276 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 316 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZNKSt3__26locale5__imp9use_facetEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZNKSt3__26locale5__imp9has_facetEl(i1, i2) | 0) return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0; else {
  i2 = ___cxa_allocate_exception(4) | 0;
  __ZNSt8bad_castC2Ev(i2);
  ___cxa_throw(i2 | 0, gb + 13256 | 0, fb + 3017 | 0);
 }
 return 0;
}

function __ZNK17ArchiveFileSystem8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK16Physics2DManager10IsTouchingEPK10Collider2DS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) == (i3 | 0) | ((i2 | 0) == 0 | (i3 | 0) == 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK19CollisionListener2D10IsTouchingEPK10Collider2DS2_((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2, i3) | 0;
 return i3 | 0;
}

function __ZN9GfxDevice25ReleaseAsyncCommandHeaderEPN21GfxDeviceAsyncCommand3ArgE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64024 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 673116;
 HEAP32[i1 + 4 >> 2] = 260;
 HEAP32[i1 + 8 >> 2] = fb + 368;
 HEAP32[i1 + 12 >> 2] = fb + 311;
 HEAP32[i1 + 16 >> 2] = gb + 673123;
 HEAP32[i1 + 20 >> 2] = 261;
 HEAP32[i1 + 24 >> 2] = fb + 369;
 HEAP32[i1 + 28 >> 2] = fb + 312;
 return;
}

function __ZN5physx2Sq11PruningPoolC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 101768 + 8;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 24 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = -1;
 return;
}

function __ZN5physx28PxClothParticleGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 772405;
 HEAP32[i1 + 4 >> 2] = 300;
 HEAP32[i1 + 8 >> 2] = fb + 3604;
 HEAP32[i1 + 12 >> 2] = fb + 3605;
 HEAP32[i1 + 16 >> 2] = gb + 772409;
 HEAP32[i1 + 20 >> 2] = 301;
 HEAP32[i1 + 24 >> 2] = fb + 483;
 HEAP32[i1 + 28 >> 2] = fb + 415;
 return;
}

function __ZN5audio5mixer25SetExposedParameterValuesERKNS0_18AudioMixerConstantEPKfiRNS0_16AudioMixerMemoryE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) != (i3 | 0)) {
  i4 = 0;
  return i4 | 0;
 }
 _memcpy(HEAP32[i4 + 40 >> 2] | 0, i2 | 0, i3 << 2 | 0) | 0;
 i4 = 1;
 return i4 | 0;
}

function __ZN5Umbra6KDTree8buildLutEPjPKji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i1;
 HEAP32[i5 + 4 >> 2] = i3;
 __ZN5Umbra9KDRankLUT9constructEPKj(i5, i2);
 STACKTOP = i4;
 return;
}

function __ZN4FMOD7SystemI13getNumPluginsE15FMOD_PLUGINTYPEPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869492;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI18set3DCustomRolloffEP11FMOD_VECTORi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868640;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI10getChannelEiPPNS_7ChannelE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 862521;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI13RectTransformD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 56064 + 8;
 i2 = i1 + 80 | 0;
 if ((HEAP32[i1 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 84 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN22BaseUnityConnectClient18OnEnterStatePausedEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 HEAP32[i1 + 4 >> 2] = 4;
 i1 = i1 + 280 | 0;
 __ZN19CloudServiceHandler11FlushEventsEv(HEAP32[i1 >> 2] | 0) | 0;
 __ZN19CloudServiceHandler17PauseEventHandlerEb(HEAP32[i1 >> 2] | 0, 1) | 0;
 return;
}

function __ZN19CharacterController13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 if (i3 | 0) if (__ZNK10GameObject8IsActiveEv(i3) | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN17ArchiveFileSystem18IsAbsoluteFilePathEPKc(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 4 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 8 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 return (_strncmp(i5, i3, i1) | 0) == 0 | 0;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13MonoBehaviour19ReleaseMonoInstanceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (HEAP32[i1 + 20 >> 2] | 0) mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, 0);
 HEAP32[i1 + 60 >> 2] = 0;
 i1 = i1 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZNK15MonoScriptCache7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES28DestroyRenderSurfacePlatformEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 4616 | 0;
 i3 = __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 >> 2] | 0) | 0;
 __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES(i3, i2, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN12_GLOBAL__N_118LegacySerialStream9writeDataEPKvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i4 >> 2] >> 2] | 0, i4 | 0, i1 | 0, i2 | 0) | 0;
 i3 = i3 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i2;
 return;
}

function __ZN12AdsIdHandler22HandleAdsIdAsyncStatusEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 if (i2) {
  HEAP32[i3 >> 2] = 3;
  HEAP8[i1 + 41 >> 0] = 1;
  __ZN18BackgroundJobQueue11ScheduleJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3301 | 0, i1);
  return;
 } else {
  HEAP32[i3 >> 2] = 0;
  return;
 }
}

function __Z56SystemInfo_Get_Custom_PropSupportsRawShadowDepthSamplingv() {
 var i1 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 503 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 116 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__Z28CheckPlatformSupportsShadowsv() | 0) & 1;
 return i1 | 0;
}

function __Z51TerrainData_Get_Custom_PropDetailResolutionPerPatchP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 128 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44Camera_CUSTOM_INTERNAL_CALL_ResetFieldOfViewP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera16ResetFieldOfViewEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z41Rigidbody2D_Get_Custom_PropFreezeRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 52 >> 2] | 0) >>> 2 & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Camera_CUSTOM_ResetStereoViewMatricesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera23ResetStereoViewMatricesEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36Graphics_CUSTOM_Internal_SetRTSimpleP21ScriptingRenderBufferS0_iii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_(1, i1, i2);
 __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iii(1, i1, i2, i3, i4, i5);
 return;
}

function __Z35ReflectionProbe_Set_Custom_PropTypeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 36 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35Material_Get_Custom_PropRenderQueueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK8Material20GetActualRenderQueueEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Shader_Get_Custom_PropRenderQueueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 52 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32WindZone_Get_Custom_PropWindMainP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32Joint_Get_Custom_PropBreakTorqueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z32CanvasGroup_Get_Custom_PropAlphaP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30AudioClip_CUSTOM_LoadAudioDataP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN10SampleClip13LoadAudioDataEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Mesh_CUSTOM_ClearBlendShapesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z16ClearBlendShapesR14BlendShapeData(i2 + 72 | 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26Cubemap_CUSTOM_SmoothEdgesP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN7Cubemap10FixupEdgesEi(i3, i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_(i2, i3, i1);
 return;
}

function _UNITY_png_set_option(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 if (!((i1 | 0) != 0 & (i2 & -3 | 0) == 0)) {
  i3 = 1;
  return i3 | 0;
 }
 i4 = 3 << i2;
 i5 = i1 + 548 | 0;
 i1 = HEAPU8[i5 >> 0] | 0;
 HEAP8[i5 >> 0] = i1 & (i4 ^ 255) | (i3 | 0 ? 3 : 2) << i2;
 i3 = (i1 & i4) >>> i2;
 return i3 | 0;
}

function __ZNSt3__26locale5__imp12install_fromINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476324 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476316 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476308 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476300 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEc(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 11 | 0;
 if ((HEAP8[i1 >> 0] | 0) < 0) {
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 + 4 >> 2] = 1;
 } else {
  HEAP8[i1 >> 0] = 1;
  i1 = i2;
 }
 HEAP8[i1 >> 0] = i3;
 HEAP8[i1 + 1 >> 0] = 0;
 return i2 | 0;
}

function __ZNK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 512 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i4 | 0, i4 + (HEAP32[i1 + 516 >> 2] << 4) | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZNK28MonoBehaviourPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, f3 > Math_fround(.00100000005) | f3 < Math_fround(-.00100000005) | 0);
 return;
}

function __ZNK16MemoryFileSystem8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148172 + 8;
 i2 = i1 + 12 | 0;
 __ZN5physx6shdfnd9MutexImplD2Ev(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx3Ext14SphericalJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 88776 | 0, 120) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN5physx3Ext14PrismaticJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 88208 | 0, 112) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN4FMOD6SoundI21setMusicChannelVolumeEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869091;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI6Canvas25GetRootWorldToLocalMatrixEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetWorldToLocalMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 return;
}

function __ZN2UI6Canvas25GetRootLocalToWorldMatrixEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 __ZNK9Transform21GetLocalToWorldMatrixEv(i3, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 return;
}

function __ZN21InheritVelocityModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 98 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 12 | 0, i1 + 100 | 0, Math_fround(0.0), HEAP16[i1 + 96 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN18DelayedCallManagerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37632 + 8;
 __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + 28 | 0, HEAP32[i1 + 32 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalEiRK31LocalSerializedObjectIdentifierRi(i1, HEAP32[i1 + 84 >> 2] | 0, i2, i3);
 return;
}

function __ZN16b2PolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_(i2, HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4);
 return;
}

function __ZN14ParticleSystem29AllocateAllStructuresOfArraysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!(HEAP8[i1 + 868 >> 0] | 0)) {
  __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
  i1 = HEAP32[i2 >> 2] | 0;
 }
 __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(i1, 2);
 return;
}

function __ZN12CachedWriter16InitActiveWriterERNS_12ActiveWriterER15CacheWriterBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = i1 + 4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0, i3 | 0, i1 + 8 | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __Z45Animation_Get_Custom_PropAnimateOnlyIfVisibleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 44 >> 2] | 0) == 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44ParticleAnimator_Get_Custom_PropAutodestructP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 108 >> 2] | 0) != 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Canvas_Get_Custom_PropSortingLayerIDP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK2UI6Canvas17GetSortingLayerIDEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Light_Get_Custom_PropCullingMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31TextMesh_Get_Custom_PropTabSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 68 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31TextMesh_Get_Custom_PropOffsetZP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 52 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Rigidbody2D_Get_Custom_PropMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 32 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Rigidbody2D_Get_Custom_PropDragP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 36 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z31Mesh_Get_Custom_PropVertexCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 32 >> 2] | 0) + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Joint_Get_Custom_PropBreakForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 80 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z29Mesh_Get_Custom_PropCanAccessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK4Mesh19CanAccessFromScriptEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26profiler_begin_instance_idP19ProfilerInformationi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP16[i1 + 6 >> 1] | 0) <= -1) return;
 i3 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i3) return;
 if (!(HEAP8[i3 >> 0] | 0)) return;
 __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi(i3, i1, i2) | 0;
 return;
}

function __Z26Rigidbody2D_CUSTOM_IsAwakeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11Rigidbody2D10IsSleepingEv(i2) | 0) & 1 ^ 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z22RecalculateSplineSlopeIfEvR17AnimationCurveTplIT_E(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 68 | 0;
 if ((HEAP32[i3 >> 2] | 0) > 0) i1 = 0; else return;
 do {
  __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i2, i1, Math_fround(0.0));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (HEAP32[i3 >> 2] | 0));
 return;
}

function __Z19ComputeUniformScaleRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0;
 f4 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 8 >> 2]);
 return Math_fround(Math_sqrt(Math_fround(Math_fround(Math_fround(f4 * f4) + Math_fround(f3 * f3)) + Math_fround(f2 * f2))));
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfertEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfersEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z17Mesh_CUSTOM_ClearP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   __ZN4Mesh5ClearEb(i3, i2 << 24 >> 24 != 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function _UNITY_FT_Angle_Diff(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 - i1 | 0;
 i3 = ((i3 | 0) > -11796479 ? i3 : -11796479) + i1 + 23592959 - i2 | 0;
 i1 = i3 - ((i3 >>> 0) % 23592960 | 0) + i2 - i1 | 0;
 i2 = i1 + ~((i1 | 0) < 11796480 ? i1 : 11796480) + 23592960 | 0;
 return i1 + (((i2 >>> 0) % 23592960 | 0) - i2) | 0;
}

function b38(i1, f2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_vifiiiiiiiiiiiii(38);
}

function _unzGoToFirstFile(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i1 = -102;
  return i1 | 0;
 }
 HEAP32[i1 + 52 >> 2] = HEAP32[i1 + 68 >> 2];
 HEAP32[i1 + 48 >> 2] = 0;
 i2 = _unzlocal_GetCurrentFileInfoInternal(i1, i1 + 72 | 0, i1 + 152 | 0, 0, 0, 0, 0, 0, 0) | 0;
 HEAP32[i1 + 56 >> 2] = (i2 | 0) == 0 & 1;
 i1 = i2;
 return i1 | 0;
}

function __ZNSt3__26locale5__imp12install_fromINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476260 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476252 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476244 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1475432 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNK8Material20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK6Object20GetRuntimeMemorySizeEv(i1) | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) return i2 | 0;
 if (!(HEAP8[i1 + 164 >> 0] & 1)) return i2 | 0;
 i2 = i2 + 112 + (__ZNK19ShaderPropertySheet16GetSerializeSizeEv(i1 + 12 | 0) | 0) | 0;
 return i2 | 0;
}

function __ZNK4Mesh18GetSubMeshBuffer16Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 + 128 >> 2] | 0) + (i2 * 52 | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 i3 = (HEAP32[i3 + 116 >> 2] | 0) - i1 | 0;
 return ((i3 | 0) != 0 & i3 >>> 0 > i2 >>> 0 ? i1 + i2 | 0 : 0) | 0;
}

function __ZNK21AssetBundleFileSystem9CanHandleEPKc(i2, i5) {
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i1 = i2 + 96 | 0;
 i4 = HEAP8[i1 + 11 >> 0] | 0;
 if (i4 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i2 + 100 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i4 & 255;
 }
 return (_strncmp(i5, i3, i1) | 0) == 0 | 0;
}

function __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i4 >> 2] = HEAP32[i3 >> 2];
 __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi(gb + 465948 | 0, i1, i2, i4);
}

function __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i4 + 296 + (i1 << 6) | 0;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 HEAP8[i4 + 1083 >> 0] = 0;
 return;
}

function __ZN5physx7profile19MemoryEventRecorderD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 147732 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[HEAP32[i2 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx3Ext13RevoluteJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 88480 | 0, 136) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN5physx2Sc7BodySim24sleepStateIntegrityCheckEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP8[i1 + 51 >> 0] & 1) != 0;
 i2 = __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(HEAP32[i1 + 36 >> 2] | 0) | 0;
 return i3 ^ (HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + ((HEAP32[i1 + 188 >> 2] | 0) * 12 | 0) + 8 >> 0] & 16) != 0 | 0;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!(HEAP32[i2 + 44 >> 2] | 0)) i1 = 0; else i1 = HEAP32[HEAP32[i2 + 40 >> 2] >> 2] | 0;
 __ZN5physx2Sc5Scene17finalizationPhaseEPNS_10PxBaseTaskE(HEAP32[i2 + 92 >> 2] | 0, i1);
 return;
}

function __ZN5physx24PxMeshScaleGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 766871;
 HEAP32[i1 + 4 >> 2] = 264;
 HEAP32[i1 + 8 >> 2] = fb + 3471;
 HEAP32[i1 + 12 >> 2] = fb + 3472;
 HEAP32[i1 + 16 >> 2] = gb + 673085;
 HEAP32[i1 + 20 >> 2] = 265;
 HEAP32[i1 + 24 >> 2] = fb + 3473;
 HEAP32[i1 + 28 >> 2] = fb + 3474;
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 98548 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx16PxVehicleNoDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj(i2, i1, i3, i4, 0, HEAP32[i4 + 40 >> 2] | 0);
 return;
}

function __ZN5physx12NpConstraint17getScbRigidObjectEPNS_12PxRigidActorE(i1) {
 i1 = i1 | 0;
 L1 : do if (!i1) i1 = 0; else switch (HEAP16[i1 + 4 >> 1] | 0) {
 case 5:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 case 15:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 default:
  {
   i1 = i1 + 48 | 0;
   break L1;
  }
 } while (0);
 return i1 | 0;
}

function __ZN4FMOD6SoundI12getSyncPointEiPP14FMOD_SYNCPOINT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869040;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18PlatformEffector2D13SetSurfaceArcEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(360.0);
 f2 = i4 ? Math_fround(360.0) : f2;
 HEAPF32[i1 + 80 >> 2] = i3 ? Math_fround(0.0) : f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN13SplatDatabase13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN13SplatDatabase16CheckConsistencyEv(i2);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (i1 | 0) if (!(HEAP32[i1 + 4 >> 2] | 0)) {
  __ZN13SplatDatabase13UploadBasemapEv(i2);
  return;
 }
 __ZN13SplatDatabase18RecalculateBasemapEb(i2, 0);
 return;
}

function __ZN11ShapeModule9ResetSeedERK27ParticleSystemReadOnlyState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i1 + 140 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN11ForceModule9ResetSeedERK27ParticleSystemReadOnlyState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 + 272 >> 2];
 __ZN5RandN7SetSeedERKi(i1 + 804 | 0, i4);
 STACKTOP = i3;
 return;
}

function __ZN10TagManager13LayerToStringEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 > 31) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 373203 | 0, 0, gb + 370982 | 0, 312, 1, 0, 0, 0);
  i2 = gb + 1110264 | 0;
  return i2 | 0;
 } else {
  i2 = i1 + 44 + (i2 << 5) | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z56AnimatorControllerPlayable_CUSTOM_IsInTransitionInternalR9HPlayablei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (__ZNK26AnimatorControllerPlayable14IsInTransitionEi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2) | 0) & 1;
 return i2 | 0;
}

function __Z55SkinnedMeshRenderer_Get_Custom_PropSkinnedMotionVectorsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 465 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z55ConfigurableJoint_Get_Custom_PropConfiguredInWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 292 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Renderer_Get_Custom_PropIsPartOfStaticBatchP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP16[i2 + 218 >> 1] | 0) != 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Texture2D_Get_Custom_PropMipmapCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Texture2D16CountDataMipmapsEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33LODGroup_CUSTOM_RecalculateBoundsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __Z25UpdateLODGroupBoundingBoxR8LODGroup(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GL_CUSTOM_INTERNAL_CALL_TexCoordRK8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i4 >> 2] | 0) + 572 >> 2] | 0, i4 | 0, +f3, +f2, +Math_fround(HEAPF32[i1 + 8 >> 2]));
 return;
}

function __Z31Light_Get_Custom_PropRenderModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 76 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Light_Get_Custom_PropBakedIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30WindZone_Get_Custom_PropRadiusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 40 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z30InstallPlayerConnectionLoggingb(i1) {
 i1 = i1 | 0;
 if (i1) {
  __Z18SetLogEntryHandlerPFb7LogTypePKcPiE(fb + 352 | 0);
  __Z23AddCleanLogEntryHandlerPFb7LogTypePKcPiE(fb + 353 | 0);
  return;
 } else {
  __Z18SetLogEntryHandlerPFb7LogTypePKcPiE(0);
  __Z26RemoveCleanLogEntryHandlerPFb7LogTypePKcPiE(fb + 353 | 0);
  return;
 }
}

function __Z30GUIText_Get_Custom_PropTabSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 60 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z29Rigidbody2D_CUSTOM_IsSleepingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11Rigidbody2D10IsSleepingEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26BeginRenderQueueExtractionR15RenderNodeQueueRK11CullResults15ExtractionFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags(i1, i2 + 1136 | 0, i2 + 16 | 0, HEAP32[i2 + 1196 >> 2] | 0, i3) | 0;
}

function _ft_bitmap_glyph_bbox(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i1 + 20 >> 2] << 6;
 HEAP32[i2 >> 2] = i4;
 i3 = i1 + 28 | 0;
 HEAP32[i2 + 8 >> 2] = (HEAP32[i3 + 4 >> 2] << 6) + i4;
 i1 = HEAP32[i1 + 24 >> 2] << 6;
 HEAP32[i2 + 12 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1 - (HEAP32[i3 >> 2] << 6);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 496 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZNSt3__26locale5__imp12install_fromINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474620 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474612 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474604 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474580 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK17ArchiveFileSystem6ExistsERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __ZNK17ArchiveFileSystem14FindItemByPathEPKc(i4, i1, i2);
 STACKTOP = i3;
 return (HEAP32[i4 + 4 >> 2] | 0) != 0 | 0;
}

function __ZN9ShaderLab25SerializedTexturePropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 1;
 return;
}

function __ZN6Camera15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 29832 | 0, gb + 1105016 | 0, fb + 493 | 0, 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 1044265 | 0, gb + 375420 | 0, gb + 373393 | 0);
 return;
}

function __ZN5physx3Ext13DistanceJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 87648 | 0, 96) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN5physx2Sq17SceneQueryManager11shiftOriginERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0, i1 | 0);
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx23PxVehicleWheels4SimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 + 736 + (i1 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 736 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 736 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5physx23PxVehicleWheels4SimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 + 688 + (i1 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 688 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 688 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5Umbra14TomeCollection11deserializeERNS_11InputStreamEPPKNS_4TomeEiPNS_9AllocatorE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZN5Umbra17ImpTomeCollection11deserializeERNS_11InputStreamEPPKNS_7ImpTomeEiPNS_9AllocatorE((i1 | 0) == 0 ? 0 : i1 + 3 & -4, i2, i3, i4, i5) | 0;
}

function __ZN4Mesh18GetSubMeshBuffer16Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i3 + 128 >> 2] | 0) + (i2 * 52 | 0) + 32 >> 2] | 0;
 i1 = HEAP32[i3 + 112 >> 2] | 0;
 i3 = (HEAP32[i3 + 116 >> 2] | 0) - i1 | 0;
 return ((i3 | 0) != 0 & i3 >>> 0 > i2 >>> 0 ? i1 + i2 | 0 : 0) | 0;
}

function __ZN4FMOD7ReverbIC2EPNS_7SystemIE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 return;
}

function __ZN4FMOD4DSPI16getSpeakerActiveE12FMOD_SPEAKERPb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868832;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI17overrideFrequencyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868267;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer20WillDestroyComponentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 188 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) {
  HEAP32[i2 >> 2] = 0;
  return;
 }
 __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, i3, i1);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13ProbeRenderer8ConvolveEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 20 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 112 >> 2] | 0, i3 | 0) | 0)) return;
 __Z21CubemapGPUConvolutionP13RenderTextureS0_bijjb(HEAP32[i2 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0, 63, 0, -1, 1) | 0;
 return;
}

function __ZN12WheelJoint2D13SetSuspensionERK17JointSuspension2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN7Joint2D8ReCreateEb(i1, 0);
 return;
}

function __ZN12LODFadeCacheC2ER13BatchRenderer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = __Z12GetGfxDevicev() | 0;
 HEAP32[i1 + 4 >> 2] = i2 + 4;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 i2 = i2 + 964 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = i1 + 196 + (i3 << 4) | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN10SpookyHash4InitEyy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 HEAP32[i1 + 288 >> 2] = 0;
 HEAP8[i1 + 292 >> 0] = 0;
 i6 = i1 + 192 | 0;
 HEAP32[i6 >> 2] = i2;
 HEAP32[i6 + 4 >> 2] = i3;
 i3 = i1 + 200 | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i5;
 return;
}

function __Z54SkinnedMeshRenderer_Get_Custom_PropUpdateWhenOffscreenP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 464 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z54LightProbeProxyVolume_Get_Custom_PropProbePositionModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48ParticleSystemRenderer_Get_Custom_PropRenderModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAPU16[i2 + 340 >> 1] | 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Canvas_Get_Custom_PropTargetDisplayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK2UI6Canvas16GetTargetDisplayEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Animation_Get_Custom_PropIsPlayingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZN9Animation9IsPlayingEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Shader_Get_Custom_PropIsSupportedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK6Shader11IsSupportedEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32GameObject_Get_Custom_PropActiveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK10GameObject8IsActiveEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32GUIText_Set_Custom_PropFontStyleP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 80 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32GUIText_Set_Custom_PropAlignmentP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP16[i3 + 52 >> 1] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Cloth_Get_Custom_PropFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 84 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z13VFormatBufferPciPKcPi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = HEAP32[i4 >> 2];
 i4 = _vsnprintf(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _UNITY_png_set_palette_to_rgb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 33558528;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _cff_driver_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 28 >> 2] = 1;
 HEAP8[i1 + 32 >> 0] = 0;
 HEAP32[i1 + 36 >> 2] = 500;
 HEAP32[i1 + 40 >> 2] = 400;
 HEAP32[i1 + 44 >> 2] = 1e3;
 HEAP32[i1 + 48 >> 2] = 275;
 HEAP32[i1 + 52 >> 2] = 1667;
 HEAP32[i1 + 56 >> 2] = 275;
 HEAP32[i1 + 60 >> 2] = 2333;
 HEAP32[i1 + 64 >> 2] = 0;
 return 0;
}

function __ZZ16InitClothManagervEN45PostLateUpdatePhysicsSkinnedClothUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 i1 = __Z12GetGfxDevicev() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 516 >> 2] | 0, i1 | 0) | 0)) return;
 __Z12UpdateClothsv();
 __Z20FinishUpdatingClothsv();
 return;
}

function __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -4 | 0;
 __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZThn32_N22ParticleSystemRenderer21RendererBecameVisibleEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN8Renderer21RendererBecameVisibleEv(i1);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 80300 | 0) | 0;
 if (!i1) return;
 __ZN14ParticleSystem21RendererBecameVisibleEv(i1);
 return;
}

function __ZNK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 500 >> 2] | 0;
 mftCall_viiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i4 | 0, i4 + (HEAP32[i1 + 504 >> 2] << 2) | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN9SubModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 8 | 0, 0);
 return;
}

function __ZN9SubModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags(i2, i1 + 8 | 0, 0);
 return;
}

function __ZN6prcoreL10inner_flipILj2EEEvPhS1_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i3) return;
 while (1) {
  i3 = i3 + -1 | 0;
  i4 = HEAP16[i1 >> 1] | 0;
  HEAP16[i1 >> 1] = HEAP16[i2 >> 1] | 0;
  HEAP16[i2 >> 1] = i4;
  if (!i3) break; else {
   i2 = i2 + 2 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function __ZN5physx2Sq12BucketPrunerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 101708 + 8;
 __ZN5physx2Sq11PruningPoolD2Ev(i1 + 7616 | 0);
 __ZN5physx2Sq16BucketPrunerCore7releaseEv(i1 + 16 | 0);
 i1 = i1 + 560 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizer19visualizeDoubleConeERKNS_11PxTransformEfb(i4, i3, f2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 i1 = i1 | 0;
 __ZN5physx2Cm19visualizeDoubleConeERNS0_12RenderOutputEfRKNS_11PxTransformEfb(HEAP32[i4 + 12 >> 2] | 0, Math_fround(HEAPF32[i4 + 8 >> 2]), i3, f2, i1);
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD7SystemI17createDSPByPluginEjPPNS_3DSPE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869204;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI16setSpeakerActiveE12FMOD_SPEAKERb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868875;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN22PerThreadPageAllocatorC2ER19AtomicPageAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = 0;
 i3 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = __ZN19AtomicPageAllocator12AllocatePageEj(i2, 32768) | 0;
 HEAP32[i3 >> 2] = 32768;
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16SubstanceArchive15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63736 | 0);
 return;
}

function __ZN16MecanimAnimation25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN11UnityEngine9Animation28GenericAnimationBindingCache25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding(HEAP32[gb + 1466544 >> 2] | 0, i2, i3, i4);
 return;
}

function __ZN15b2CircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_(i2, HEAP32[(HEAP32[i1 + 48 >> 2] | 0) + 32 >> 2] | 0, i3, HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 32 >> 2] | 0, i4);
 return;
}

function __ZN14AnimationState21CleanupUnstoppedStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = i1 + 12 | 0;
 i2 = i1 + 80 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = HEAP32[i1 + 84 >> 2];
 i1 = i1 + 56 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3;
 return;
}

function __ZN13DrawImmediate8TexCoordEifff(i1, i2, f3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 if (i2 >>> 0 >= 4) return;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) >> 2] = f3;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) + 4 >> 2] = f4;
 HEAPF32[i1 + 76 + (i2 * 12 | 0) + 8 >> 2] = f5;
 return;
}

function __Z53AssetBundle_Get_Custom_PropIsStreamedSceneAssetBundleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 184 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Behaviour_Get_Custom_PropIsActiveAndEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP8[i2 + 33 >> 0] | 0) != 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42RenderTexture_CUSTOM_INTERNAL_CALL_ReleaseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13RenderTexture7ReleaseEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38CanvasRenderer_Get_Custom_PropHasMovedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP16[i2 + 162 >> 1] & 1031) != 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Rigidbody2D_Get_Custom_PropFixedAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 52 >> 2] | 0) >>> 2 & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Rigidbody_Get_Custom_PropConstraintsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Rigidbody14GetConstraintsEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Animator_Get_Custom_PropRecorderModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK8Animator15GetRecorderModeEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Cubemap_Get_Custom_PropMipmapCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Texture2D16CountDataMipmapsEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31GUIText_Set_Custom_PropFontSizeP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP32[i3 + 76 >> 2] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z31AudioSource_Get_Custom_PropMuteP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource7GetMuteEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31AudioSource_Get_Custom_PropLoopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK11AudioSource7GetLoopEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30GL_CUSTOM_INTERNAL_CALL_VertexRK8Vector3f(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, i4 = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 mftCall_vifff(HEAP32[(HEAP32[i4 >> 2] | 0) + 560 >> 2] | 0, i4 | 0, +f3, +f2, +Math_fround(HEAPF32[i1 + 8 >> 2]));
 return;
}

function __Z28LODGroup_Get_Custom_PropSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 44 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z28Cloth_Get_Custom_PropDampingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 48 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function __Z27Camera_Get_Custom_PropDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return Math_fround(HEAPF32[i2 + 888 >> 2]);
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return Math_fround(0.0);
}

function _UNITY_png_set_tRNS_to_alpha(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 33558528;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _wcsrchr(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = _wcslen(i2) | 0;
 L1 : do if ((i1 | 0) > -1) {
  i1 = i2 + (i1 << 2) | 0;
  while (1) {
   if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break L1;
   i1 = i1 + -4 | 0;
   if (i1 >>> 0 < i2 >>> 0) {
    i1 = 0;
    break;
   }
  }
 } else i1 = 0; while (0);
 return i1 | 0;
}

function _a64l(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = 0;
 i3 = i1;
 i1 = 0;
 while (1) {
  i2 = HEAP8[i3 >> 0] | 0;
  if (!(i2 << 24 >> 24)) break;
  i1 = (_memchr(gb + 1060052 | 0, i2 << 24 >> 24, 65) | 0) - (gb + 1060052) << i4 | i1;
  i4 = i4 + 6 | 0;
  if ((i4 | 0) >= 36) break; else i3 = i3 + 1 | 0;
 }
 return i1 | 0;
}

function ___shlim(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 HEAP32[i1 + 104 >> 2] = i2;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 i4 = HEAP32[i1 + 4 >> 2] | 0;
 i5 = i3 - i4 | 0;
 HEAP32[i1 + 108 >> 2] = i5;
 if ((i2 | 0) != 0 & (i5 | 0) > (i2 | 0)) HEAP32[i1 + 100 >> 2] = i4 + i2; else HEAP32[i1 + 100 >> 2] = i3;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__erase_to_endEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP8[(HEAP32[i1 >> 2] | 0) + i2 >> 0] = 0;
  HEAP32[i1 + 4 >> 2] = i2;
 } else {
  HEAP8[i1 + i2 >> 0] = 0;
  HEAP8[i3 >> 0] = i2;
 }
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 280 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 320 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZNK5physx2Sc18ParticleSystemCore14getWorldBoundsEv(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i3 | 0, i1 | 0);
 return;
}

function __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i1 | 0) == (HEAP32[i2 + 8 >> 2] | 0)) __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi(0, i2, i3, i4);
 return;
}

function __ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 if (_strcmp(__Z24scripting_class_get_nameP11Il2CppClass(i1) | 0, gb + 466150 | 0) | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z25scripting_class_get_imageP11Il2CppClass(i1) | 0;
 i1 = (i1 | 0) == (__Z20scripting_get_corlibv() | 0);
 return i1 | 0;
}

function __ZN5physx2Sn12PointerRemapD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!((i2 | 0) > -1 & (i2 & 2147483647 | 0) != 0)) return;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i2, i1, i2 + 176 | 0, i2 + 172 | 0, 1) | 0;
}

function __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 if (!i1) return i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i3 | 0);
 return i1 | 0;
}

function __ZN4crnd12symbol_codec14start_decodingEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + i3;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i3 = 1;
 return i3 | 0;
}

function __ZN4FMOD7SystemI19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 859027;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN24iPhoneRemoteNotificationC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN19SkinnedMeshRenderer23UpdatePreviousFrameDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN12BaseRenderer23UpdatePreviousFrameDataEv(i1 + 32 | 0);
 if (!(HEAP8[i1 + 465 >> 0] | 0)) return;
 i3 = i1 + 468 | 0;
 i1 = i1 + 472 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN18ScreenManagerWebGL31EmscriptenFullScreenChangeEventEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  _emscripten_set_canvas_size(HEAP32[i1 + 64 >> 2] | 0, HEAP32[i1 + 68 >> 2] | 0);
  return;
 } else {
  _emscripten_set_canvas_size(HEAP32[i2 + 272 >> 2] | 0, HEAP32[i2 + 276 >> 2] | 0);
  return;
 }
}

function __ZN18ProceduralMaterial13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Material13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 HEAP32[i1 + 144 >> 2] = HEAP32[i1 + 4 >> 2];
 __ZN18ProceduralMaterial17AwakeDependenciesEb(i1, 0);
 i2 = i1 + 172 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 524288;
 return;
}

function __ZN18PlatformEffector2D10SetSideArcEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(180.0);
 f2 = i4 ? Math_fround(180.0) : f2;
 HEAPF32[i1 + 84 >> 2] = i3 ? Math_fround(0.0) : f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN17UniqueIDGenerator7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = -1;
 return;
}

function __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf(i2, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf(i2, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf(i2, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf(i2, i1, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZN12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN12FileAccessor4SeekEx10FileOrigin(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i5) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = mftCall_iiiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 32 >> 2] | 0, i5 | 0, i1 + 4 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
 return i5 | 0;
}

function __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionZP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 56 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionYP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 52 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionXP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 48 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52LightProbeProxyVolume_Get_Custom_PropBoundingBoxModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z52DistanceJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 101 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51Camera_Get_Custom_PropClearStencilAfterLightingPassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1093 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46ParticleSystemRenderer_Get_Custom_PropSortModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAPU16[i2 + 342 >> 1] | 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35AudioSource_Get_Custom_PropPriorityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK11AudioSource11GetPriorityEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34OffMeshLink_CUSTOM_UpdatePositionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11OffMeshLink15UpdatePositionsEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Texture_CUSTOM_GetNativeTextureIDP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZN7Texture19GetNativeTexturePtrEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Light_Get_Custom_PropShadowsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z26Shader_CUSTOM_PropertyToIDP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 i1 = __Z25ScriptingStringToPropertyR11ICallString(i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __Z25Camera_Get_Custom_PropHdrP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK6Camera17CalculateUsingHDREv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function mftCall_iiiiid(i6, i1, i2, i3, i4, d5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 if ((i6 | 0) >= (fb | 0) & (i6 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiiiid[i6 - fb & 7](i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5) | 0;
 return ftCall_iiiiid(i6 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, +d5) | 0;
}

function __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i1 + -5 | 0) >>> 0 > 1) {
  i2 = i2 + 66 | 0;
  return i2 | 0;
 }
 if ((i1 | 0) == 5) {
  i2 = HEAP32[i2 + 116 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = HEAP32[i2 + 96 >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN9Projector5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(.100000001);
 HEAPF32[i1 + 40 >> 2] = Math_fround(100.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(60.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(10.0);
 HEAP8[i1 + 52 >> 0] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN8Animator22PrepareAnimationEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 if (HEAP32[i1 + 100 >> 2] & 8 | 0) return;
 i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vifi(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, 1.0, i1 + 564 | 0);
 return;
}

function __ZN6Shader28DeleteDefaultShaderLabShaderEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1166244 >> 2] | 0;
 if (i1 | 0) __ZN9ShaderLab9IntShaderD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63280 | 0);
 HEAP32[gb + 1166244 >> 2] = 0;
 i1 = HEAP32[gb + 1166240 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN5physx9PxTaskMgr12addReferenceEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi((HEAP32[i2 + 76 >> 2] | 0) + (i1 * 20 | 0) + 4 | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return;
}

function __ZN5physx7NpScene26setBounceThresholdVelocityEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(HEAP8[i2 + 2448 >> 0] | 0)) {
  __ZN5physx2Sc5Scene26setBounceThresholdVelocityEf(i2 + 32 | 0, f1);
  return;
 } else {
  HEAPF32[i2 + 3360 >> 2] = f1;
  i2 = i2 + 3388 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 2;
  return;
 }
}

function __ZN5physx6shdfnd10Foundation19AlignCheckAllocator26registerAllocationListenerERNS_20PxAllocationListenerE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 28 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 >= 5) return;
 HEAP32[i3 + 8 + (HEAP32[i1 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN5physx3Ext10FixedJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 87932 | 0, 80) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN5physx2Sc9ClothCore15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 4 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i3 + 320;
 HEAP32[i2 + 36 >> 2] = i3;
 __ZN5physx2Sc13ClothBulkData15importExtraDataERNS_24PxDeserializationContextE(i3, i1);
 return;
}

function __ZN5physx21PxcArticulationHelper12getDataSizesEjRjS1_S1_(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i5 = 0;
 i5 = (i1 * 176 | 0) + 272 + (i1 * 96 | 0) + ((i1 << 2) + 60 & -64) | 0;
 HEAP32[i3 >> 2] = i5;
 HEAP32[i4 >> 2] = i5 + (i1 << 5) + (i1 * 496 | 0);
 HEAP32[i2 >> 2] = i1 * 608;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE(i2 + 20 | 0, i1);
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5physx15computeMaxIndexEPKtj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else {
  i3 = i1;
  i1 = 0;
 }
 while (1) {
  i3 = i3 + -1 | 0;
  i4 = HEAP16[i2 >> 1] | 0;
  i1 = (i4 & 65535) > (i1 & 65535) ? i4 : i1;
  if (!i3) break; else i2 = i2 + 2 | 0;
 }
 return i1 | 0;
}

function __ZN5physx11NpAggregate15importExtraDataERNS_24PxDeserializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = i3 + 40 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i4 = i2 + 4 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) + 15 & -16;
 HEAP32[i4 >> 2] = i2 + (HEAP32[i3 + 36 >> 2] << 2);
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx11AdjacenciesD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN5physx6shdfnd9Allocator10deallocateEPv(i3, i2 + -4 | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __ZN4FMOD7SystemI19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 866098;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPIC2EPNS_7SystemIE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 24 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i1 + 28 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = i2;
 return;
}

function __ZN4FMOD13ChannelGroupI14overrideVolumeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868341;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI14get3DOcclusionEPfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868182;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19ConstantBuffersGLES10ResetBindsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = (HEAP32[i1 + 16 >> 2] | 0) - i3 | 0;
 i2 = (i1 | 0) / 12 | 0;
 if ((i1 | 0) > 0) i1 = 0; else return;
 do {
  HEAP16[i3 + (i1 * 12 | 0) + 8 >> 1] = -1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN19CloudServiceHandler7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 1148 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 __ZN19CloudServiceHandler12CloseServiceEv(i1) | 0;
 __ZN19CloudServiceHandlerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19CharacterController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19CharacterController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN19AssetBundleManifest8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16UploadHandlerRawC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 187876 + 8;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN13UploadHandlerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 187928 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __Z23scripting_gchandle_freej(i3);
  HEAP32[i2 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN13RenderTexture25GetLiveRenderTextureCountEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1158220 + 4 >> 2] | 0;
 if ((i1 | 0) == (gb + 1158220 | 0)) {
  i2 = 0;
  return i2 | 0;
 } else {
  i2 = i1;
  i1 = 0;
 }
 do {
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (gb + 1158220 | 0));
 return i1 | 0;
}

function __ZN12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __Z51NavMeshAgent_Get_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 104 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51LightProbeProxyVolume_Get_Custom_PropResolutionModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51CharacterController_Get_Custom_PropDetectCollisionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 108 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50ParticleRenderer_Get_Custom_PropParticleRenderModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 340 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50ConfigurableJoint_Get_Custom_PropRotationDriveModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 288 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39NavMeshAgent_Get_Custom_PropIsOnNavMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 68 >> 2] | 0) != -1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39EdgeCollider2D_Get_Custom_PropEdgeCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 172 >> 2] | 0) + -1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33AudioClip_Get_Custom_PropChannelsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9AudioClip15GetChannelCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Shader_Get_Custom_PropMaximumLODP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK6Shader19GetMaximumShaderLODEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31HumanPoseHandler_CUSTOM_DisposeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63320 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z29GUIText_Set_Custom_PropAnchorP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i1 = 0; else {
  i3 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i3) {
   HEAP16[i3 + 54 >> 1] = i2;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z20ClearShaderCacheGLESv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451144 >> 2] | 0;
 if (!i1) return;
 __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(HEAP32[gb + 1451144 >> 2] | 0) | 0;
 return;
}

function __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i1 + 152 >> 2] | 0) __ZN13BatchRenderer5FlushEv(i1);
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i1 + 8 | 0, 7);
 __Z16ApplySHConstantsI28ApplyBuiltinInstancePropertyEvRT_RK20SphericalHarmonicsL2(i1, i2);
 return;
}

function _logbl(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
 do if (i2 >>> 0 < 2146435072 | (i2 | 0) == 2146435072 & 0 < 0) if (d1 == 0.0) {
  d1 = -1.0 / (d1 * d1);
  break;
 } else {
  d1 = +(_ilogbl(d1) | 0);
  break;
 } else d1 = d1 * d1; while (0);
 return +d1;
}

function __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E6getDirEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] | 0) + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5physx2Sq8AABBTreeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sq8AABBTree7releaseEv(i1);
 i1 = i1 + 8 | 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 STACKTOP = i2;
 return;
}

function __ZN5physx23PxVehicleWheels4SimData22setSuspTravelDirectionEjRKNS_6PxVec3E(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + 640 + (i2 * 12 | 0) >> 2] = HEAP32[i1 >> 2];
 HEAP32[i3 + 640 + (i2 * 12 | 0) + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 + 640 + (i2 * 12 | 0) + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5Umbra9allocTomeEjPNS_9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 20 | 0;
 if (!i2) i1 = _malloc(i1) | 0; else i1 = mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i1 + 20 & -16;
 HEAP32[i2 + -4 >> 2] = i2 - i1;
 return i2 | 0;
}

function __ZN5Umbra12StreamWriter6putStrEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = _strlen(i2) | 0;
 i4 = i1 + 4 | 0;
 if (!(HEAP8[i4 >> 0] | 0)) return;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP8[i4 >> 0] = (mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0) == (i3 | 0) & 1;
 return;
}

function __ZN4FMOD8ChannelI19get3DMinMaxDistanceEPfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868452;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869816;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869306;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI10getChannelEiPPNS_7ChannelE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 862521;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN18CapsuleCast2DQueryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14ParticleSystem16SetStartRotationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 2092 >> 2] = f2;
 HEAP8[i1 + 2098 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 2012 | 0, i1 + 2100 | 0, f2, HEAP16[i1 + 2096 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN13SpeedTreeWind16SBranchWindLevelC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAPF32[i1 + 120 >> 2] = Math_fround(.300000012);
 HEAPF32[i1 + 124 >> 2] = Math_fround(.75);
 HEAPF32[i1 + 128 >> 2] = Math_fround(.300000012);
 i2 = i1 + 120 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN11TypeManager24InitializeGlobalInstanceEv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(292, gb + 63520 | 0, 16, gb + 464723 | 0, gb + 373318 | 0, gb + 373107 | 0, 132) | 0;
 __ZN11TypeManagerC2ERN4RTTI16RuntimeTypeArrayE(i1, gb + 1106156 | 0);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1110260 >> 2] = i1;
 return;
}

function __Z51Rigidbody2D_Get_Custom_PropUseFullKinematicContactsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 50 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z51PlatformEffector2D_Get_Custom_PropUseOneWayGroupingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 77 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50SpringJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 108 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50ShaderVariantCollection_Get_Custom_PropShaderCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z50RelativeJoint2D_Get_Custom_PropAutoConfigureOffsetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 100 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z49CharacterController_Get_Custom_PropCollisionFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 140 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33NavMeshObstacle_CUSTOM_FitExtentsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN15NavMeshObstacle10FitExtentsEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Transform_CUSTOM_GetSiblingIndexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Transform15GetSiblingIndexEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208728 + 8;
 __ZNSt3__26localeC2Ev(i1 + 4 | 0);
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208664 + 8;
 __ZNSt3__26localeC2Ev(i1 + 4 | 0);
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZNK5physx7NpScene26getBounceThresholdVelocityEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP32[i1 + 3388 >> 2] & 2)) {
  f2 = Math_fround(__ZNK5physx2Sc5Scene26getBounceThresholdVelocityEv(i1 + 32 | 0));
  return Math_fround(f2);
 } else {
  f2 = Math_fround(HEAPF32[i1 + 3360 >> 2]);
  return Math_fround(f2);
 }
 return f0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 f1 = Math_fround(HEAPF32[i2 + 500 >> 2]);
 if (!(f1 <= Math_fround(-128.0))) f1 = Math_fround(+Math_exp(+Math_fround(f1 * Math_fround(.693147182)))); else f1 = Math_fround(0.0);
 return Math_fround(Math_fround(1.0) - f1);
}

function __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu18ConvexHullNoScaleV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(HEAP32[i4 + 48 >> 2] | 0, i1, i3, i2);
 return;
}

function __ZNK14StackAllocator15WalkAllocationsEPFvPKvjPKPvjE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) return;
 do {
  i2 = HEAP32[i1 + -4 >> 2] | 0;
  if (!(i2 & 1)) mftCall_viiii(i3 | 0, i1 | 0, i2 >>> 1 | 0, 0, 0);
  i1 = HEAP32[i1 + -8 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZNK14SerializedFile12GetHighestIDEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if ((HEAP32[i1 + 32 >> 2] | 0) == (i2 | 0)) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = i2 + -24 | 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN9TransformD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 56064 + 8;
 i2 = i1 + 80 | 0;
 if ((HEAP32[i1 + 96 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 84 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN6prcoreL10inner_flipILj4EEEvPhS1_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i3) return;
 while (1) {
  i3 = i3 + -1 | 0;
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  HEAP32[i2 >> 2] = i4;
  if (!i3) break; else {
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return;
}

function __ZN6prcoreL10inner_flipILj1EEEvPhS1_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 if (!i3) return;
 while (1) {
  i3 = i3 + -1 | 0;
  i4 = HEAP8[i1 >> 0] | 0;
  HEAP8[i1 >> 0] = HEAP8[i2 >> 0] | 0;
  HEAP8[i2 >> 0] = i4;
  if (!i3) break; else {
   i2 = i2 + 1 | 0;
   i1 = i1 + 1 | 0;
  }
 }
 return;
}

function __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == 2) {
  i2 = HEAP32[i1 + 1144 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = __Z23GetRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureType(HEAP32[i1 + 1124 >> 2] | 0, i2) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx2Sn13XmlNodeReader10leaveChildEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 12 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (HEAP32[i2 + 16 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i3 = 1;
 return i3 | 0;
}

function __ZN5physx2Sc8ShapeSim20removeFromBroadPhaseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (0 == 0 ? (HEAP32[i1 + 12 >> 2] & 1073741823 | 0) == 1073741823 : 0) return;
 __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE(HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0, i2 ? 4 : 0, i1);
 return;
}

function __ZN5physx2Sc5Scene9islandGenEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 __ZN5physx2Sc5Scene29processNarrowPhaseTouchEventsEv(i2);
 __ZN5physx10PxsContext13updateIslandsEfPNS_10PxBaseTaskE(i3, Math_fround(HEAPF32[i2 + 64 >> 2]), i1);
 return;
}

function __ZN5physx2Sc5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i3 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0) | 0;
}

function __ZN5physx2Cm8PtrTable15importExtraDataERNS_24PxDeserializationContextE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0, i4 = 0;
 i1 = HEAP16[i3 + 4 >> 1] | 0;
 if ((i1 & 65535) <= 1) return;
 i4 = i2 + 4 | 0;
 i2 = (HEAP32[i4 >> 2] | 0) + 15 & -16;
 HEAP32[i4 >> 2] = i2 + ((i1 & 65535) << 2);
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!(HEAP32[i2 + 44 >> 2] | 0)) i1 = 0; else i1 = HEAP32[HEAP32[i2 + 40 >> 2] >> 2] | 0;
 __ZN5physx2Sc5Scene14postBroadPhaseEPNS_10PxBaseTaskE(HEAP32[i2 + 92 >> 2] | 0, i1);
 return;
}

function __ZN5physx20PxsParticleSystemSim25spatialHashUpdateSectionsEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx19PxsFluidSpatialHash20updatePacketSectionsEPjPNS_16PxsFluidParticleEPNS_10PxBaseTaskE(HEAP32[i2 + 72 >> 2] | 0, HEAP32[i2 + 36 >> 2] | 0, HEAP32[(HEAP32[i2 + 8 >> 2] | 0) + 48 >> 2] | 0, i1);
 return;
}

function __ZN4FMOD7SystemI19setGeometrySettingsEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869836;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI13CanvasManager25UpdateCanvasRectTransformEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 i2 = i2 + 4 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN2UI6Canvas25UpdateCanvasRectTransformEb(HEAP32[i1 >> 2] | 0, 0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17CircleCast2DQueryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14UnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb(i1, i2, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, 0) | 0;
}

function __ZN14RedirectHelper16SetRedirectLimitEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) > 128 ? 1 : (HEAP32[i1 + 4 >> 2] | 0) >>> 0 > i2 >>> 0) {
  i2 = 29;
  return i2 | 0;
 }
 if ((i2 | 0) < 0) {
  HEAP32[i1 >> 2] = -1;
  i2 = 0;
  return i2 | 0;
 } else {
  HEAP32[i1 >> 2] = i2;
  i2 = 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13PhysicsModule25CreateNxMeshFromUnityMeshEP4MeshbbRK10Matrix4x4f13TransformTypef(i1, i2, i3, i4, i5, i6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 return __Z25CreatePxMeshFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypef(i2, i3, i4, i5, i6, f7) | 0;
}

function __ZN11TimeManager12SetTimeScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (f2 <= Math_fround(100.0) & f2 >= Math_fround(0.0)) {
  HEAPF32[i1 + 196 >> 2] = f2;
  return;
 } else {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 441348 | 0, 0, gb + 441411 | 0, 392, 1, 0, 0, 0);
  return;
 }
}

function __Z50NavMeshObstacle_Get_Custom_PropCarveOnlyStationaryP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 69 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z49Rigidbody2D_Get_Custom_PropCollisionDetectionModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 64 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z49NavMeshAgent_Get_Custom_PropObstacleAvoidanceTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48ParticleRenderer_Get_Custom_PropUvAnimationYTileP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 360 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48ParticleRenderer_Get_Custom_PropUvAnimationXTileP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 356 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46Camera_CUSTOM_INTERNAL_CALL_ResetCullingMatrixP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   HEAP8[i2 + 1085 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z40AudioSource_CUSTOM_INTERNAL_CALL_UnPauseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11AudioSource7UnPauseEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z34AudioClip_Get_Custom_PropFrequencyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9AudioClip12GetFrequencyEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Animator_Get_Custom_PropLayerCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK8Animator13GetLayerCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32AudioClip_Get_Custom_PropSamplesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9AudioClip14GetSampleCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Object_Get_Custom_PropHideFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 8 >> 2] | 0) >>> 13 & 127 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Animator_Get_Custom_PropIsHumanP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK8Animator7IsHumanEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z25Light_Get_Custom_PropTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[(HEAP32[i2 + 44 >> 2] | 0) + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z19dtFreePathQueryInfoP15dtPathQueryInfo(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
  __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
  __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 }
 HEAP32[i1 >> 2] = 0;
 __Z6dtFreePv(i1);
 return;
}

function _UNITY_png_set_strip_alpha(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 262144;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _UNITY_png_get_y_pixels_per_meter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 128)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP8[i2 + 192 >> 0] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 188 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_png_get_x_pixels_per_meter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 128)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP8[i2 + 192 >> 0] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 184 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_ft_smooth_lcdv_renderer_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (i4 | 0) return;
 _UNITY_ft_mem_free(i3, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function _unity_z_inflateGetHeader(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = -2;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i2 = -2;
  return i2 | 0;
 }
 if (!(HEAP32[i1 + 8 >> 2] & 2)) {
  i2 = -2;
  return i2 | 0;
 }
 HEAP32[i1 + 32 >> 2] = i2;
 HEAP32[i2 + 48 >> 2] = 0;
 i2 = 0;
 return i2 | 0;
}

function _logb(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
 do if (i2 >>> 0 < 2146435072 | (i2 | 0) == 2146435072 & 0 < 0) if (d1 == 0.0) {
  d1 = -1.0 / (d1 * d1);
  break;
 } else {
  d1 = +(_ilogb(d1) | 0);
  break;
 } else d1 = d1 * d1; while (0);
 return +d1;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i6 = i1;
 HEAP32[i6 >> 2] = 0;
 HEAP32[i6 + 4 >> 2] = 0;
 i6 = i1 + 8 | 0;
 HEAP32[i6 >> 2] = -1;
 HEAP32[i6 + 4 >> 2] = -1;
 return;
}

function __ZN9GfxDevice14SetWorldMatrixERK10Matrix4x4f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 3420 | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 i4 = i3 + 3612 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] | 1;
 return;
}

function __ZN7mecanim6CRCKeyENS_7eStringE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[gb + 1553738 >> 0] | 0)) {
  __ZN12_GLOBAL__N_19InitTableEv();
  HEAP32[gb + 1466796 >> 2] = gb + 1098896;
  HEAP8[gb + 1553738 >> 0] = 1;
  i2 = gb + 1098896 | 0;
 } else i2 = HEAP32[gb + 1466796 >> 2] | 0;
 return HEAP32[i2 + (i1 << 3) >> 2] | 0;
}

function __ZN5physx3Ext7D6Joint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = mftCall_iiiiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0, i4 + 12 | 0, gb + 87140 | 0, 384) | 0;
 HEAP32[i4 + 76 >> 2] = i3;
 return (i3 | 0) != 0 | 0;
}

function __ZN5physx23PxVehicleWheels4SimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 + 784 + (i1 * 12 | 0) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 784 + (i1 * 12 | 0) + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 784 + (i1 * 12 | 0) + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5physx21PxSpringGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 765184;
 HEAP32[i1 + 4 >> 2] = 505;
 HEAP32[i1 + 8 >> 2] = fb + 443;
 HEAP32[i1 + 12 >> 2] = fb + 382;
 HEAP32[i1 + 16 >> 2] = gb + 741403;
 HEAP32[i1 + 20 >> 2] = 506;
 HEAP32[i1 + 24 >> 2] = fb + 444;
 HEAP32[i1 + 28 >> 2] = fb + 383;
 return;
}

function __ZN5physx16PxsIslandManager17setEdgeConstraintERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_13PxsConstraintE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = (HEAP32[i3 + 284 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 | 0;
 HEAP32[i2 >> 2] = i1 | HEAP32[i2 >> 2] | 1;
 HEAP8[i3 + 477 >> 0] = 1;
 return;
}

function __ZN5Umbra20SingleBlockAllocator8allocateEjPKc(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = i2 + 12 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 < i3 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 return i3 | 0;
}

function __ZN5Umbra10StackAlloc5resetEPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i2;
 i2 = i4 + 15 & -16;
 i5 = i2;
 HEAP32[i1 + 4 >> 2] = i5;
 i3 = i5 + (i4 + i3 - i2) | 0;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 16 >> 2] = i3 - i2;
 return;
}

function __ZN4FMOD6SoundI21getMusicChannelVolumeEiPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868962;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI19get3DMinMaxDistanceEPfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868452;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI11getSubSoundEiPPNS_5SoundE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 859469;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI11overridePanEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868285;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN19CloudServiceHandler8SaveFileERK8UnityStrS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = HEAP8[i3 + 11 >> 0] | 0;
 i5 = i4 << 24 >> 24 < 0;
 return __ZN19CloudServiceHandler8SaveFileERK8UnityStrPKvj(i1, i2, i5 ? HEAP32[i3 >> 2] | 0 : i3, i5 ? HEAP32[i3 + 4 >> 2] | 0 : i4 & 255) | 0;
}

function __ZN18PlatformEffector2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN10Effector2D5ResetEv(i1);
 HEAP8[i1 + 76 >> 0] = 1;
 HEAP8[i1 + 77 >> 0] = 0;
 HEAP8[i1 + 78 >> 0] = 0;
 HEAP8[i1 + 79 >> 0] = 0;
 HEAPF32[i1 + 80 >> 2] = Math_fround(180.0);
 HEAPF32[i1 + 84 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 88 >> 2] = Math_fround(0.0);
 return;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16ShapeCast2DQueryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14ShadowSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 8 >> 2] = -1;
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 16 >> 2] = Math_fround(.0500000007);
 HEAPF32[i1 + 20 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 24 >> 2] = Math_fround(.200000003);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 _free(i1);
 if (!(_pthread_setspecific(HEAP32[gb + 1477004 >> 2] | 0, 0) | 0)) {
  STACKTOP = i2;
  return;
 } else _abort_message(gb + 1085223 | 0, i2);
}

function __Z49ShaderVariantCollection_Get_Custom_PropIsWarmedUpP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 44 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z49PlatformEffector2D_Get_Custom_PropUseSideFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 78 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z49Joint_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 36 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48TargetJoint2D_Get_Custom_PropAutoConfigureTargetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 104 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48SurfaceEffector2D_Get_Custom_PropUseContactForceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 104 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48ParticleAnimator_Get_Custom_PropDoesAnimateColorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 112 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z48LightProbeProxyVolume_Get_Custom_PropRefreshModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 44 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47ParticleSystemRenderer_Get_Custom_PropAlignmentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 372 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47ConfigurableJoint_Get_Custom_PropProjectionModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 276 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47ConfigurableJoint_Get_Custom_PropAngularZMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 116 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47ConfigurableJoint_Get_Custom_PropAngularYMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 112 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47ConfigurableJoint_Get_Custom_PropAngularXMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 108 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42TerrainData_Get_Custom_PropHeightmapHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 248 + 76 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Canvas_Get_Custom_PropRenderModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK2UI6Canvas13GetRenderModeEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z17SkipSampleRecursePK14ProfilerSample(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = i2 + 24 | 0;
 i3 = HEAP32[i2 + 12 >> 2] | 0;
 if ((i3 | 0) > 0) i2 = 0; else {
  i3 = i1;
  return i3 | 0;
 }
 do {
  i1 = __Z17SkipSampleRecursePK14ProfilerSample(i1) | 0;
  i2 = i2 + 1 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function __Z13AddComponentsR10GameObjectPKcz(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 __Z23AddComponentsFromVAListR10GameObjectPKcPi(i1, i2, i5);
 STACKTOP = i4;
 return;
}

function _UNITY_png_set_scale_16(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 67108864;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _UNITY_png_set_gray_to_rgb(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 20480;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _UNITY_ft_smooth_lcd_renderer_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (i4 | 0) return;
 _UNITY_ft_mem_free(i3, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function _unzSetOffset(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = -102;
  return i2 | 0;
 }
 HEAP32[i1 + 52 >> 2] = i2;
 HEAP32[i1 + 48 >> 2] = HEAP32[i1 + 36 >> 2];
 i2 = _unzlocal_GetCurrentFileInfoInternal(i1, i1 + 72 | 0, i1 + 152 | 0, 0, 0, 0, 0, 0, 0) | 0;
 HEAP32[i1 + 56 >> 2] = (i2 | 0) == 0 & 1;
 return i2 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNK5physx7NpShape11getGeometryEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!(HEAP32[i1 + 36 >> 2] & 1)) i1 = i1 + 116 | 0; else i1 = (HEAP32[i1 + 40 >> 2] | 0) + 56 | 0;
 i3 = i2 + 40 | 0;
 do {
  HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
  i2 = i2 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return;
}

function __ZNK5physx12NpConstraint7isValidEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 8 >> 2] | 0;
 if (!i1) i2 = 0; else i2 = (HEAP16[i1 + 4 >> 1] | 0) != 6;
 i1 = HEAP32[i3 + 12 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  i3 = i2 | i3;
  return i3 | 0;
 }
 i3 = (HEAP16[i1 + 4 >> 1] | 0) != 6;
 i3 = i2 | i3;
 return i3 | 0;
}

function __ZN9ShaderLab10SubProgram17DestroyGpuProgramEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 i2 = __Z21GetUncheckedGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 208 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8Animator13StartPlaybackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 548 | 0;
 if ((HEAP32[i2 >> 2] | 0) == 2) return;
 HEAP32[i2 >> 2] = 1;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) return;
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) return;
 HEAP8[i1 + 24 >> 0] = 1;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE(i2 + 20 | 0, i1);
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5Unity11SpringJoint5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN5Unity5Joint5ResetEv(i1);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(10.0);
 HEAPF32[i1 + 108 >> 2] = Math_fround(.200000003);
 HEAPF32[i1 + 112 >> 2] = Math_fround(.0250000004);
 return;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD8ChannelI18setInputChannelMixEPfi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868679;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI18getInputChannelMixEPfi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868507;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI11setSubSoundEiPNS_5SoundE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869141;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN37AssetBundleLoadFromFileAsyncOperation11LoadArchiveEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 208 | 0;
 return __ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy(i1, i1 + 192 | 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZN21RotationBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19Job_InvokeCoroutineEPv(i1) {
 i1 = i1 | 0;
 __ZN14AsyncOperation15InvokeCoroutineEv(i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN19SpriteMeshGenerator16GetOptimizedPathEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN19SpriteMeshGenerator4pathC2ERKS0_(i1, (HEAP32[i2 >> 2] | 0) + (i3 * 68 | 0) | 0);
 __ZL15ProcessVerticesRNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEEEPFbNS_11__wrap_iterIPS2_EES9_S9_E(i1);
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15Cast2DQueryBaseD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManager20ReleasePvdConnectionEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457416 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 i1 = HEAP32[gb + 1457416 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457416 >> 2] = 0;
 return;
}

function __ZN13RenderTexture21SetShadowSamplingModeE18ShadowSamplingMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 108 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 if ((HEAP32[i1 + 96 >> 2] | 0) != 3) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __Z47SliderJoint2D_Get_Custom_PropAutoConfigureAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 118 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47Rigidbody_Get_Custom_PropCollisionDetectionModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47Material_Get_Custom_PropGlobalIlluminationFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47CanvasRenderer_Get_Custom_PropHasPopInstructionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 184 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47AudioSource_Get_Custom_PropIgnoreListenerVolumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 496 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47AudioListener_Get_Custom_PropVelocityUpdateModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 60 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46CanvasRenderer_Get_Custom_PropPopMaterialCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 128 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41TerrainData_Get_Custom_PropHeightmapWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 248 + 72 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Camera_CUSTOM_INTERNAL_CALL_ResetAspectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN6Camera11ResetAspectEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z33Material_Get_Custom_PropPassCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK8Material12GetPassCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _UNITY_png_get_y_offset_microns(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 256)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP8[i2 + 180 >> 0] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 176 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_png_get_x_offset_microns(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 256)) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP8[i2 + 180 >> 0] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 172 >> 2] | 0;
 return i2 | 0;
}

function b86(i1, i2, i8, i9, i10, i11, i12, i13, i14, i15, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i13 = i13 | 0;
 i14 = i14 | 0;
 i15 = i15 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_viiiiiiiiiiiiiii(86);
}

function _zipOpenNewFileInZip2(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 return _zipOpenNewFileInZip3(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3, -15, 8, 0, 0, 0) | 0;
}

function _rewind(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  i2 = (___lockfile(i1) | 0) == 0;
  ___fseeko_unlocked(i1, 0, 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -33;
  if (!i2) ___unlockfile(i1);
 } else {
  ___fseeko_unlocked(i1, 0, 0) | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -33;
 }
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNK5physx2Sq12BucketPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP8[i3 + 7600 >> 0] | 0) {
  i3 = 1;
  return i3 | 0;
 }
 i3 = __ZNK5physx2Sq16BucketPrunerCore7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE(i3 + 16 | 0, i2, i1) | 0;
 return i3 | 0;
}

function __ZN9Scripting21RaiseManagedExceptionEPKcS1_S1_z(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i5 >> 2] = i4;
 __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi(i1, i2, i3, i5);
}

function __ZN9LensFlare5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 40 >> 2] = 1065353216;
 HEAP32[i1 + 44 >> 2] = 1065353216;
 HEAP32[i1 + 48 >> 2] = 1065353216;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP8[i1 + 72 >> 0] = 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(3.0);
 HEAP32[i1 + 64 >> 2] = 6;
 return;
}

function __ZN9GfxDevice24ReleaseSharedTextureDataEP17SharedTextureData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63272 | 0);
 return;
}

function __ZN9GfxDevice21CommonReloadResourcesEj(i1) {
 i1 = i1 | 0;
 if (i1 & 4 | 0) __ZN7Texture9ReloadAllEbbb(1, 1, 0);
 if (i1 & 2 | 0) __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 396560 | 0, 0, gb + 392043 | 0, 954, 1, 0, 0, 0);
 if (!(i1 & 1)) return;
 __ZN13RenderTexture10ReleaseAllEv();
 return;
}

function __ZN7mecanim19ReserveKeywordTableEv() {
 var i1 = 0;
 if (!(HEAP8[gb + 1553738 >> 0] | 0)) {
  __ZN12_GLOBAL__N_19InitTableEv();
  HEAP32[gb + 1466796 >> 2] = gb + 1098896;
  HEAP8[gb + 1553738 >> 0] = 1;
  i1 = gb + 1098896 | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[gb + 1466796 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZN7mecanim12statemachine29GetTransitionSourceStateIndexENS0_16TransitionSourceEPNS0_18StateMachineMemoryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i1 | 0) {
 case 1:
  {
   i1 = HEAP32[i2 + 8 >> 2] | 0;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i2 + 12 >> 2] | 0;
   break;
  }
 default:
  i1 = -1;
 }
 return i1 | 0;
}

function __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 36 | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP8[i3 + 1080 >> 0] = 0;
 HEAP8[i3 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx8debugger22ForwardingMemoryBufferD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5physx3Ext7D6Joint9setMotionENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i3 + 80 >> 2] | 0) + 72 + (i1 << 2) >> 2] = i2;
 HEAP8[i3 + 84 >> 0] = 1;
 i3 = HEAP32[i3 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i3 | 0);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE(i2 + 20 | 0, i1);
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN4FMOD6SoundI19setSubSoundSentenceEPii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869153;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer20SetHasPopInstructionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 184 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 188 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 224 | 0;
 HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 4;
 return;
}

function __ZN20SphericalHarmonicsL2pLERKS_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0, i4 = 0, f5 = f0;
 i1 = 0;
 do {
  f5 = Math_fround(HEAPF32[i3 + (i1 << 2) >> 2]);
  i4 = i2 + (i1 << 2) | 0;
  HEAPF32[i4 >> 2] = Math_fround(f5 + Math_fround(HEAPF32[i4 >> 2]));
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 27);
 return i2 | 0;
}

function __ZN19CloudServiceHandler16HandlePlayerLoopEv(i1) {
 i1 = i1 | 0;
 __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv(i1);
 __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv(i1 + 200 | 0);
 __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv(i1 + 792 | 0);
 return;
}

function __ZN19AudioHighPassFilter6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 __ZN4FMOD3DSP12setParameterEif(i3, 0, Math_fround(HEAPF32[i1 + 44 >> 2])) | 0;
 __ZN4FMOD3DSP12setParameterEif(HEAP32[i2 >> 2] | 0, 1, Math_fround(HEAPF32[i1 + 48 >> 2])) | 0;
 return;
}

function __ZN17PersistentManager29RegisterInOrderDeleteCallbackEPFvRKNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEbE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i2;
 return;
}

function __ZN16Physics2DManager28RemoveJointBreakLimitUpdatesEP7Joint2D(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 68 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN14PhysicMaterial8LoadDescERNS_18PhysicMaterialDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 + 16 >> 2];
 return;
}

function __ZN14PhysicMaterial8DumpDescERNS_18PhysicMaterialDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 44 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 48 >> 2];
 return;
}

function __ZN14BoxCast2DQueryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN13EmscriptenWWWD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 25328 + 8;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2 | 0) _free(i2);
 _JS_WebRequest_Release(HEAP32[i1 + 80 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 100 | 0);
 __ZN3WWWD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12MeshCollider12SetIsTriggerEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) if (!(HEAP8[i1 + 60 >> 0] | 0)) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 737019 | 0, 0, gb + 736492 | 0, 450, 1, HEAP32[i1 + 4 >> 2] | 0, 0, 0);
  return;
 }
 __ZN8Collider12SetIsTriggerEb(i1, i2);
 return;
}

function __ZN11UnityEngine7Connect14RemoteSettings13ConfigChangedERK8UnityStrR8JSONRead(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (__Z6StrCmpPKcS0_((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, gb + 1041415 | 0) | 0) return;
 __ZN11UnityEngine7Connect14RemoteSettings7SetJSONER8JSONRead(i1, i3);
 return;
}

function __ZL26InitializeModule_Animationv() {
 var i1 = 0;
 HEAP32[gb + 1162104 >> 2] = fb + 3803;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63320 | 0, 16, gb + 910276 | 0, gb + 1576256 | 0, gb + 910295 | 0, 19) | 0;
 HEAP32[i1 >> 2] = gb + 178916 + 8;
 __Z19pop_allocation_rootv();
 __Z13SetIAnimationP10IAnimation(i1);
 return;
}

function __Z48getPxVehicleDriveSimData4W_AckermannGeometryDataPKN5physx23PxVehicleDriveSimData4WE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 560 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z47WebCamTexture_Get_Custom_PropDidUpdateThisFrameP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 93 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z47PlatformEffector2D_Get_Custom_PropUseSideBounceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 79 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46Terrain_Get_Custom_PropTreeMaximumFullLODCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 76 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46RenderTexture_Get_Custom_PropEnableRandomWriteP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 120 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46ReflectionProbe_Get_Custom_PropTimeSlicingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 48 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46DistanceJoint2D_Get_Custom_PropMaxDistanceOnlyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 100 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46CharacterJoint_Get_Custom_PropEnableProjectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 172 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46AudioSource_Get_Custom_PropIgnoreListenerPauseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 427 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z46Animator_Get_Custom_PropLinearVelocityBlendingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 418 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45NavMeshAgent_Get_Custom_PropAvoidancePriorityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45Canvas_Get_Custom_PropCachedSortingLayerValueP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 420 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45AudioSource_Get_Custom_PropVelocityUpdateModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 500 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45AudioReverbFilter_Get_Custom_PropReverbPresetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 104 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42NavMeshAgent_Get_Custom_PropUpdatePositionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 107 >> 0] & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Canvas_Get_Custom_PropIsRootCanvasP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (HEAP32[i2 + 344 >> 2] | 0) == 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30Font_Get_Custom_PropLineHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return ~~Math_fround(HEAPF32[i2 + 32 >> 2]) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z23GetVirtualJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i1) {
 i1 = i1 | 0;
 __ZNK22VirtualJoystickManager23GetVirtualJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(HEAP32[gb + 1162016 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z10dictDeleteP4DictP8DictNode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 8 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i4 + 8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] = i4;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function _UNITY_png_set_expand(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 33558528;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _fopen_file_func(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 if ((i2 & 3 | 0) == 1) i1 = gb + 945625 | 0; else if (!(i2 & 4)) i1 = (i2 & 8 | 0) == 0 ? 0 : gb + 777169 | 0; else i1 = gb + 491595 | 0;
 if (!((i3 | 0) != 0 & (i1 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = _fopen(i3, i1) | 0;
 return i3 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = gb + 208936 + 12;
 HEAP32[i3 >> 2] = gb + 208936 + 32;
 __ZNSt3__28ios_base4initEPv(i3, i2);
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = -1;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = gb + 208888 + 12;
 HEAP32[i3 >> 2] = gb + 208888 + 32;
 __ZNSt3__28ios_base4initEPv(i3, i2);
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = -1;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwjRKS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcjRKS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, i3);
 return;
}

function __ZNK7ApiGLES5CheckEjPKcjS1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i5 = HEAP32[i1 + 1988 >> 2] | 0;
 if ((__ZN2gl17GetCurrentContextEv() | 0) != (i5 | 0)) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) != 0;
 return i5 | 0;
}

function __ZNK5physx6PxVec3mlEf(i1, i3, f2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var f4 = f0, f5 = f0;
 f5 = Math_fround(Math_fround(HEAPF32[i3 >> 2]) * f2);
 f4 = Math_fround(Math_fround(HEAPF32[i3 + 4 >> 2]) * f2);
 __ZN5physx6PxVec3C2Efff(i1, f5, f4, Math_fround(Math_fround(HEAPF32[i3 + 8 >> 2]) * f2));
 return;
}

function __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE16GetDownloadBytesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZN9GfxDevice16SetRenderTargetsERK20GfxRenderTargetSetup(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4196 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 4200 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 4204 >> 2] = HEAP32[i2 + 48 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 900 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN7ApiGLES24DisableVertexArrayAttribEj(i4, i5) {
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = i4 + 1572 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i3 = 1 << i5;
 if ((HEAP8[i4 + 1992 >> 0] | 0) != 0 & (i2 & i3 | 0) == 0) return;
 HEAP32[i1 >> 2] = i2 & ~i3;
 mftCall_vi(HEAP32[i4 + 708 >> 2] | 0, i5 | 0);
 return;
}

function __ZN5physx6shdfnd14printFormattedEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 1040 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3 + 16 | 0;
 i5 = i3;
 HEAP32[i5 >> 2] = i2;
 _vsprintf(i4, i1, i5) | 0;
 _puts(i4) | 0;
 STACKTOP = i3;
 return;
}

function __ZN5physx16PxsIslandManager14setEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_17PxsContactManagerE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = (HEAP32[i3 + 284 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | i1;
 HEAP8[i3 + 477 >> 0] = 1;
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD8ChannelI14setLowPassGainEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868711;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI14get3DOcclusionEPfS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868182;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbI13getPropertiesEP22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868909;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP16[i1 + 4 >> 1] = i3;
 HEAP16[i1 + 6 >> 1] = i4;
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1163396 >> 2];
 HEAP32[gb + 1163396 >> 2] = i1;
 return;
}

function __ZN19ControllerHitReportD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 87504 + 8;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -44 - i3 | 0) >>> 0) / 44 | 0) * 44 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z49Playable_CUSTOM_INTERNAL_CALL_GetDurationInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  d2 = 0.0;
  return +d2;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 d2 = +mftCall_di(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return +d2;
}

function __Z46OffMeshLink_Get_Custom_PropAutoUpdatePositionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 96 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45RenderTexture_Get_Custom_PropAutoGenerateMipsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 117 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45CanvasRenderer_Get_Custom_PropHasRectClippingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 165 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z45Animator_Get_Custom_PropHasTransformHierarchyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 561 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44WebCamTexture_Get_Custom_PropRequestedHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38AudioSource_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11AudioSource5PauseEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32Mesh_Get_Custom_PropSubMeshCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK4Mesh15GetSubMeshCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29Avatar_Get_Custom_PropIsValidP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return (__ZNK6Avatar7IsValidEv(i2) | 0) & 1 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _UNITY_png_get_pixels_per_meter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) != 0 & (i2 | 0) != 0) if (HEAP32[i2 + 8 >> 2] & 128 | 0) if ((HEAP8[i2 + 192 >> 0] | 0) == 1) {
  i1 = HEAP32[i2 + 184 >> 2] | 0;
  if ((i1 | 0) == (HEAP32[i2 + 188 >> 2] | 0)) {
   i2 = i1;
   return i2 | 0;
  }
 }
 i2 = 0;
 return i2 | 0;
}

function _UNITY_ft_raster1_renderer_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 208 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (i4 | 0) return;
 _UNITY_ft_mem_free(i3, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function _UNITY_FT_GlyphLoader_Rewind(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 20 | 0;
 HEAP16[i1 + 22 >> 1] = 0;
 HEAP16[i2 >> 1] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 i1 = i1 + 56 | 0;
 i3 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__213shared_futureIvEaSERKS1_(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (i1 | 0) __ZNSt3__214__shared_count12__add_sharedEv(i1);
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 return i2 | 0;
}

function __ZNSt13runtime_errorC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216304 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4617 | 0, i1 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 68 >> 2] | 0;
 if ((i1 + -5 | 0) >>> 0 > 1) {
  i2 = 1;
  return i2 | 0;
 }
 if ((i1 | 0) == 5) {
  i2 = HEAP16[i2 + 120 >> 1] | 0;
  return i2 | 0;
 } else {
  i2 = HEAP16[i2 + 100 >> 1] | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK29LineParametersPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP8[i3 + 15 >> 0] | 0) {
  i4 = -1;
  return i4 | 0;
 }
 HEAP32[i4 >> 2] = HEAP32[i3 + 4 >> 2];
 i4 = 100002;
 return i4 | 0;
}

function __ZNK13TranslateGLES14GetShaderStageEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == 35633) i1 = 0; else if ((i2 | 0) == 36488) i1 = 1; else if ((i2 | 0) == 36487) i1 = 2; else if ((i2 | 0) == 36313) i1 = 3; else if ((i2 | 0) == 35632) i1 = 4; else return ((i2 | 0) == 37305 ? 5 : -1091584273) | 0;
 return i1 | 0;
}

function __ZNK12FileAccessor8PositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 + 4 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZNK10UnityScene12GetRootCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 100 | 0;
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 if ((i1 | 0) == (i3 | 0)) {
  i3 = 0;
  return i3 | 0;
 } else {
  i2 = i1;
  i1 = 0;
 }
 do {
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i2 + 4 >> 2] | 0;
 } while ((i2 | 0) != (i3 | 0));
 return i1 | 0;
}

function __ZN9InputAxis12MakeJoystickEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 76 >> 2] = 2;
 HEAP32[i1 + 88 >> 2] = i2;
 HEAPF32[i1 + 100 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(.189999998);
 HEAPF32[i1 + 92 >> 2] = Math_fround(0.0);
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 0;
 return;
}

function __ZN7mecanim9animation22DestroyControllerInputEPNS0_15ControllerInputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 + 12 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx12NpBatchQuery15finalizeExecuteEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 144 >> 2] = -16;
 i2 = i1 + 24 | 0;
 HEAP8[i1 + 148 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 __ZN5physx6shdfnd14atomicExchangeEPVii(i1 + 40 | 0, 0) | 0;
 return;
}

function __ZN5Umbra9IndexListaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return i1 | 0;
}

function __ZN5Umbra9FloatListaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return i1 | 0;
}

function __ZN5Umbra10StackAllocC2EPvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i2;
 i2 = i4 + 15 & -16;
 i5 = i2;
 HEAP32[i1 + 4 >> 2] = i5;
 i3 = i5 + (i4 + i3 - i2) | 0;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 16 >> 2] = i3 - i2;
 return;
}

function __ZN4FMOD7SystemI19getMasterSoundGroupEPPNS_10SoundGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869420;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12AudioManager21RemoveAudioReverbZoneEP15AudioReverbZone(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 36 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 40 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z45CanvasGroup_Get_Custom_PropIgnoreParentGroupsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 42 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44SurfaceEffector2D_Get_Custom_PropUseFrictionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 105 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44ReflectionProbe_Get_Custom_PropBoxProjectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 141 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44ParticleEmitter_Get_Custom_PropUseWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 192 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z44AreaEffector2D_Get_Custom_PropUseGlobalAngleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 116 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43CanvasRenderer_Get_Custom_PropMaterialCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 108 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42UnityAnalyticsHandler_CUSTOM_SetUserGenderP12Il2CppObjectN14UnityAnalytics6GenderE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN14UnityAnalytics13SetUserGenderENS_6GenderE(i1, i2) | 0;
 return i2 | 0;
}

function __Z42Camera_Get_Custom_PropTransparencySortModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 1068 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29Animation_CUSTOM_GetClipCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return __ZNK9Animation12GetClipCountEv(i2) | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z18Transfer_BlittableI8JSONReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_set_strip_16(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = i1 + 208 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!(i3 & 64)) {
  HEAP32[i2 >> 2] = i3 | 16384;
  i3 = i1 + 212 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1024;
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353836 | 0);
  return;
 }
}

function _UNITY_ft_smooth_renderer_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 i1 = i1 + 216 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i4 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i2 >> 2] = i4;
 if (i4 | 0) return;
 _UNITY_ft_mem_free(i3, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function _tcdrain(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 21513;
 HEAP32[i3 + 8 >> 2] = 1;
 i1 = ___syscall_ret(___syscall54(54, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _emscripten_glCompressedTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _emscripten_glCompressedTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__25ctypeIcEC2EPKtbj(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1 + -1;
 HEAP32[i2 >> 2] = gb + 212772 + 8;
 i1 = i2 + 8 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP8[i2 + 12 >> 0] = i4 & 1;
 if (!i3) HEAP32[i1 >> 2] = __ZNSt3__25ctypeIcE13classic_tableEv() | 0;
 return;
}

function __ZN9b2FixtureC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 + 52 >> 1] = 1;
 HEAP16[i1 + 54 >> 1] = -1;
 HEAP16[i1 + 56 >> 1] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN9GfxDevice14ImmediateColorEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 HEAPF32[i1 + 60 >> 2] = f2;
 HEAPF32[i1 + 64 >> 2] = f3;
 HEAPF32[i1 + 68 >> 2] = f4;
 HEAPF32[i1 + 72 >> 2] = f5;
 return;
}

function __ZN9Animation4PlayER14AnimationStatei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) == 1) {
  __ZN9Animation14QueueCrossFadeER14AnimationStatefii(i1, i2, Math_fround(0.0), 0, 0) | 0;
  return;
 } else {
  __ZN9Animation9CrossFadeER14AnimationStatefib(i1, i2, Math_fround(0.0), i3, 1);
  return;
 }
}

function __ZN7ApiGLES27BindTransformFeedbackBufferEjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 1172 + (i3 << 2) | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 mftCall_viii(HEAP32[i2 + 652 >> 2] | 0, 35982, i3 | 0, i4 | 0);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd10checkValidERKNS_6PxVec3E(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 4 >> 2] & 2139095040) >>> 0 >= 2139095040) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 8 >> 2] & 2139095040) >>> 0 < 2139095040;
 return i1 | 0;
}

function __ZN5physx2Sc8BodyCore14setWakeCounterEfb(i1, f3, i2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 i2 = i2 | 0;
 HEAPF32[i1 + 152 >> 2] = f3;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 if (f3 > Math_fround(0.0) | i2) __ZN5physx2Sc7BodySim6wakeUpEv(i1);
 __ZN5physx2Sc7BodySim18postSetWakeCounterEfb(i1, f3, i2);
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLLD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101396 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 101396 + 52;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15computeMaxIndexEPKjj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else {
  i3 = i1;
  i1 = 0;
 }
 while (1) {
  i3 = i3 + -1 | 0;
  i4 = HEAP32[i2 >> 2] | 0;
  i1 = i4 >>> 0 > i1 >>> 0 ? i4 : i1;
  if (!i3) break; else i2 = i2 + 4 | 0;
 }
 return i1 | 0;
}

function __ZN5Unity5Joint18SetConnectedAnchorERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 52 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, 2);
 return;
}

function __ZN5Umbra9crc32HashEPKhj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else i3 = -1;
 while (1) {
  i1 = i1 + -1 | 0;
  i3 = HEAP32[gb + 79084 + (((HEAPU8[i2 >> 0] | 0) ^ i3 & 255) << 2) >> 2] ^ i3 >>> 8;
  if (!i1) break; else i2 = i2 + 1 | 0;
 }
 i3 = ~i3;
 return i3 | 0;
}

function __ZN4FMOD7SystemI15getNetworkProxyEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869440;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN30ReportScriptingObjectsTransfer8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN30ReportScriptingObjectsTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags(i1, i2, 0);
 return;
}

function __ZN16Physics2DManager21RemoveEffectorUpdatesEP10Effector2D(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 64 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 68 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN15SharedGfxBufferD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 58920 + 8;
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  __ZdlPv(i1);
  return;
 }
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 236 >> 2] | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15QualitySettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15QualitySettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15OcclusionPortal8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __Z43WebCamTexture_Get_Custom_PropRequestedWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Terrain_Get_Custom_PropReflectionProbeUsageP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43Terrain_Get_Custom_PropCollectDetailPatchesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 200 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z43ConfigurableJoint_Get_Custom_PropSwapBodiesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 293 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42SkinnedMeshRenderer_Get_Custom_PropQualityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 460 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42ReflectionProbe_Get_Custom_PropCullingMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42PointEffector2D_Get_Custom_PropForceTargetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 116 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42PointEffector2D_Get_Custom_PropForceSourceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 112 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42CapsuleCollider2D_Get_Custom_PropDirectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 168 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return;
}

function __Z38Rigidbody_Get_Custom_PropInterpolationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAPU8[i2 + 102 >> 0] | 0 | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31AudioMixerDuckingCreateCallbackP21UnityAudioEffectState(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(64, gb + 63328 | 0, 16, gb + 862871 | 0, 58) | 0;
 HEAP32[i1 + 28 >> 2] = i2;
 i1 = i2;
 i2 = i1 + 64 | 0;
 do {
  HEAP8[i1 >> 0] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return 0;
}

function __Z20CreateShadowMapCachev() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63632 | 0, 16, gb + 380631 | 0, 16) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 return i1 | 0;
}

function __Z12FormatBufferPciPKcz(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 __Z13VFormatBufferPciPKcPi(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return;
}

function _UNITY_FT_Init_Class_ft_bitmap_glyph_class(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 52;
 HEAP32[i1 + 4 >> 2] = 1651078259;
 HEAP32[i1 + 8 >> 2] = fb + 1007;
 HEAP32[i1 + 12 >> 2] = fb + 3838;
 HEAP32[i1 + 16 >> 2] = fb + 1008;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = fb + 4202;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function _jpeg_has_multiple_scans(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i2 + -202 | 0) >>> 0 > 8) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
 }
 return HEAP8[(HEAP32[i1 + 400 >> 2] | 0) + 16 >> 0] | 0;
}

function _cf2_buf_readByte(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i3 + 1;
  i3 = HEAPU8[i3 >> 0] | 0;
  return i3 | 0;
 } else {
  _cf2_setError(HEAP32[i1 >> 2] | 0, 85);
  i3 = 0;
  return i3 | 0;
 }
 return 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__26thread20hardware_concurrencyEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2813 | 0, 84) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return ((i1 | 0) < 0 ? 0 : i1) | 0;
 return 0;
}

function __ZNSt3__210ostrstreamD2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + (HEAP32[i3 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 12 >> 2];
 __ZNSt3__212strstreambufD2Ev(i1 + 4 | 0);
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, i2 + 4 | 0);
 return;
}

function __ZNSt3__210istrstreamD2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + (HEAP32[i3 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 12 >> 2];
 __ZNSt3__212strstreambufD2Ev(i1 + 8 | 0);
 __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED2Ev(i1, i2 + 4 | 0);
 return;
}

function __ZNSt11logic_errorC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216284 + 8;
 __THREW__ = 0;
 invoke_vii(fb + 4617 | 0, i1 + 4 | 0, i2 | 0);
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_2() | 0;
  getTempRet0() | 0;
  ___resumeException(i2 | 0);
 } else return;
}

function __ZNKSt3__28messagesIwE3getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZNKSt3__28messagesIcE3getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZNK8Playable14GetInputWeightEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if ((HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  f3 = Math_fround(-1.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(HEAPF32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) >> 2]);
 return Math_fround(f3);
}

function __ZNK12CachedWriter12ActiveWriter11GetPositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i3 + (Math_imul(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0, i2) | 0) | 0;
}

function __ZN8RemapperC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 4;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = i1 + 16;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = -1;
 return;
}

function __ZN5physx23PxVehicleDriveSimDataNW11setDiffDataERKNS_27PxVehicleDifferentialNWDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 528 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5Umbra10StackAlloc8allocateEjPKc(i5, i2, i1) {
 i5 = i5 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = i5 + 12 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = i4 + (i2 + 15 & -16) | 0;
 if (i1 >>> 0 > (HEAP32[i5 + 8 >> 2] | 0) >>> 0) {
  i5 = 0;
  return i5 | 0;
 }
 HEAP32[i3 >> 2] = i1;
 i5 = i4;
 return i5 | 0;
}

function __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei(i1, i2, i3, i4, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i1, 2001146706, 0, i2, 1) | 0) | 0;
}

function __ZN4crnd25crnd_set_memory_callbacksEPFPvS0_jPjbS0_EPFjS0_S0_ES0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = (i1 | 0) != 0 & (i2 | 0) != 0;
 HEAP32[gb + 43044 >> 2] = i4 ? i1 : fb + 7 | 0;
 HEAP32[gb + 43048 >> 2] = i4 ? i2 : fb + 66 | 0;
 HEAP32[gb + 1157844 >> 2] = i4 ? i3 : 0;
 return;
}

function __ZN4crnd10dxt3_block9set_alphaEjjjb(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i3 = i1 + ((i3 << 1) + (i2 >>> 1)) | 0;
 i2 = i2 << 2 & 4;
 HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & (15 << i2 ^ 255) | (i5 ? (((i4 * 15 | 0) + 128 | 0) >>> 0) / 255 | 0 : i4) << i2;
 return;
}

function __ZN4FMOD8ChannelI20get3DConeOrientationEP11FMOD_VECTOR(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 865684;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI13setMusicSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869113;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI15getSystemObjectEPPNS_6SystemE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 862473;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer17DirtySyncTypeFlagEt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = (HEAP16[i3 >> 1] | i2) & 65535 | 2048;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN23TransformChangeDispatch37InitTransformHierarchyTRSChangedMasksER18TransformHierarchy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 40 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 44 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 52 >> 2] = HEAP32[i1 + 40 >> 2];
 return;
}

function __ZN19CharacterController23UpdateControllerManagerEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457412 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457412 >> 2] = 0;
 i1 = _PxCreateControllerManager(__Z16GetDynamicsScenev() | 0) | 0;
 HEAP32[gb + 1457412 >> 2] = i1;
 return;
}

function __ZN18DelayedCallManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37632 + 8;
 __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE(i1 + 28 | 0, HEAP32[i1 + 32 >> 2] | 0);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN17GameObjectManager13StaticDestroyEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1104660 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63520 | 0);
 HEAP32[gb + 1104660 >> 2] = 0;
 return;
}

function __ZN17AudioCustomFilterC2EP13MonoBehaviour(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 170700 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP8[i1 + 13 >> 0] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __ZN17AudioCustomFilter4InitEv(i1);
 return;
}

function __ZN13OpenFileCacheC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN4FileC2Ev(i1);
 __ZN4FileC2Ev(i1 + 32 | 0);
 __ZN4FileC2Ev(i1 + 64 | 0);
 __ZN4FileC2Ev(i1 + 96 | 0);
 __ZN4FileC2Ev(i1 + 128 | 0);
 i1 = i1 + 160 | 0;
 i2 = i1 + 84 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN12AudioManager19RemoveAudioListenerEP13AudioListener(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 132 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 136 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 8 | 0;
 if (HEAP8[i4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP8[i4 >> 0] = 1;
 return;
}

function __Z43PlatformEffector2D_Get_Custom_PropUseOneWayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 76 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42Terrain_Get_Custom_PropHeightmapMaximumLODP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 56 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42SurfaceEffector2D_Get_Custom_PropUseBounceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 106 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42ReflectionProbe_Get_Custom_PropRefreshModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 44 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42ParticleEmitter_Get_Custom_PropRndRotationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 193 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42Canvas_Get_Custom_PropOverridePixelPerfectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 361 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42AudioReverbZone_Get_Custom_PropReflectionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 80 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41ReflectionProbe_Get_Custom_PropClearFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 104 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41Camera_Get_Custom_PropUseOcclusionCullingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1089 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41AreaEffector2D_Get_Custom_PropForceTargetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 112 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38CustomEventData_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63160 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z37Rigidbody_CUSTOM_INTERNAL_CALL_WakeUpP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Rigidbody6WakeUpEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Animation_CUSTOM_INTERNAL_CALL_SampleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Animation6SampleEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37Animation_CUSTOM_INTERNAL_CALL_RewindP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Animation6RewindEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29GetTextureSizeAllowedMultiple13TextureFormat(i1) {
 i1 = i1 | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) return 4;
 if (((i1 | 1) + -25 | 0) >>> 0 < 5) return 4;
 switch (i1 | 0) {
 case 34:
 case 35:
 case 36:
 case 45:
 case 46:
 case 47:
  return 4;
 default:
  return ((i1 + -41 | 0) >>> 0 < 4 ? 4 : 1) | 0;
 }
 return 0;
}

function __Z25Rigidbody2D_CUSTOM_WakeUpP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11Rigidbody2D11SetSleepingEb(i2, 0);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24Mathf_CUSTOM_FloatToHalff(f1) {
 f1 = Math_fround(f1);
 var i2 = 0, i3 = 0;
 i3 = (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0);
 i2 = i3 >>> 23 & 255;
 return (HEAPU16[gb + 1477124 + (i2 << 1) >> 1] | 0 | i3 >>> 16 & 32768 | (i3 & 8388607) >>> (HEAPU8[gb + 1546331 + i2 >> 0] | 0)) & 65535 | 0;
}

function __Z15GetAccelerationv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0, f4 = f0;
 f4 = Math_fround(+HEAPF64[gb + 1097904 + 32 >> 3]);
 f3 = Math_fround(+HEAPF64[gb + 1097904 + 40 >> 3]);
 f2 = Math_fround(+HEAPF64[gb + 1097904 + 48 >> 3]);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 HEAPF32[i1 + 8 >> 2] = f2;
 return;
}

function _cf2_stack_pushFixed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 392 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i1 + 392 | 0)) {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 130);
  return;
 } else {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = 0;
  HEAP32[i3 >> 2] = i4 + 8;
  return;
 }
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__215recursive_mutex8try_lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2810 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return (i1 | 0) == 0 | 0;
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EjwRKS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, i2, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EjcRKS4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, i2, i3);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20getRigidDynamicFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 4096)) {
  i1 = i1 + 108 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 } else {
  i1 = (HEAP32[i1 + 56 >> 2] | 0) + 268 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZN9GfxDevice30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return;
}

function __ZN9GfxDevice28ScheduleGeometryJobsInternalEPFvP15GeometryJobDataEPK22GeometryJobInstructionj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN16GeometryJobTasks20ScheduleGeometryJobsER9GfxDevicePFvP15GeometryJobDataEPK22GeometryJobInstructionjb(i1 + 4412 | 0, i1, i2, i3, i4, 0);
 return;
}

function __ZN9GfxDevice18CloneRenderSurfaceEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0, (HEAP8[i2 + 30 >> 0] | 0) != 0 | 0) | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 404 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 return i3 | 0;
}

function __ZN8PlayableD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 37536 + 8;
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  __ZdlPv(i1);
  return;
 }
 __Z18GetDirectorManagerv() | 0;
 __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList(gb + 1188456 | 0, HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE10deallocateERKNS3_13CollisionDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 436 | 0;
 __ZN14StackAllocatorILj16EE10deallocateEPv(HEAP32[i2 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 __ZN14StackAllocatorILj16EE10deallocateEPv(HEAP32[i2 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN5physx2Sc5Scene23checkConstraintBreakageEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 208 >> 2] | 0;
 if (!i1) return;
 i2 = i2 + 204 | 0;
 do {
  i1 = i1 + -1 | 0;
  __ZN5physx2Sc13ConstraintSim21checkMaxForceExceededEv(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0);
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx11Adjacencies17AssignNewEdgeCodeEjh(i4, i3, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 & 536870911;
 if ((i1 | 0) == 536870911) return;
 i4 = (HEAP32[i4 + 4 >> 2] | 0) + (i1 * 12 | 0) + (i3 >>> 30 << 2) | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & 536870911 | (i2 & 255) << 30;
 return;
}

function __ZN4FMOD4DSPI16showConfigDialogEPvb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868892;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI7getNameEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868219;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN20ArchiveStorageReader18ReleaseCachedBlockEPNS_11CachedBlockE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 28 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (!(HEAP16[(HEAP32[i1 + 104 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) + 8 >> 1] & 64)) return;
 HEAP32[i2 + 32 >> 2] = 0;
 return;
}

function __ZN17PolygonCollider2D12SetPolygon2DEP9Polygon2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 160 | 0;
 __ZN9Polygon2D7SetPathEiRK13dynamic_arrayI8Vector2fLj4EE(i3, 0, HEAP32[i2 >> 2] | 0);
 __ZN9Polygon2D16CheckConsistencyEv(i3);
 __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(i1, 1, 0);
 return;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14SphereCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14RenderSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14RenderSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14ParticleSystem12SetStartSizeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 HEAPF32[i1 + 772 >> 2] = f2;
 HEAP8[i1 + 778 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1 + 692 | 0, i1 + 780 | 0, f2, HEAP16[i1 + 776 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13GfxDeviceNull18CreateVertexBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __Znwj(28) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 78552 + 8;
 return i1 | 0;
}

function __ZN12NavMeshAgent17SetUpdateRotationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 107 | 0;
 i4 = HEAP8[i3 >> 0] | 0;
 if (((i4 & 255) >>> 1 & 1 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i4 & -3 | (i2 & 1) << 1 & 255;
 if (!i2) return;
 HEAPF32[i1 + 56 >> 2] = Math_fround(inf);
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobScheduler10InitializeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 if (HEAP8[i2 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i1 + 8 >> 2] = __ZnwjRK10MemLabelIdiPKci(1, gb + 63800 | 0, 16, gb + 1046485 | 0, 31) | 0;
 HEAP8[i2 >> 0] = 1;
 i2 = 1;
 return i2 | 0;
}

function __ZN11IMGUIModule25IsDeveloperConsoleVisibleEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1468316 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP8[i1 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 24 >> 2] | 0) != 0;
 return i1 | 0;
}

function __Z56AnimatorControllerPlayable_CUSTOM_SetLayerWeightInternalR9HPlayableif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 __ZN26AnimatorControllerPlayable14SetLayerWeightEif(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2, f3);
 return;
}

function __Z45Playable_CUSTOM_INTERNAL_CALL_GetTimeInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  d2 = 0.0;
  return +d2;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 d2 = +mftCall_di(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 return +d2;
}

function __Z42Terrain_Get_Custom_PropDrawTreesAndFoliageP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 90 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42LODGroup_Get_Custom_PropAnimateCrossFadingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 52 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z42Animation_Get_Custom_PropPlayAutomaticallyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 40 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41TrailRenderer_Get_Custom_PropAutodestructP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 396 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41RenderTexture_Get_Custom_PropAntiAliasingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41ReflectionProbe_Get_Custom_PropResolutionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 52 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41ReflectionProbe_Get_Custom_PropImportanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 60 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41LineRenderer_Get_Custom_PropUseWorldSpaceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 340 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Terrain_Get_Custom_PropEditorRenderFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 204 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40PointEffector2D_Get_Custom_PropForceModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 120 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40EdgeCollider2D_Get_Custom_PropPointCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 172 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40ConfigurableJoint_Get_Custom_PropZMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 104 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40ConfigurableJoint_Get_Custom_PropYMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 100 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Camera_Get_Custom_PropLayerCullSphericalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1090 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29NavMeshAgent_CUSTOM_ResetPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN12NavMeshAgent9ResetPathEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Animator_CUSTOM_StopRecordingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN8Animator13StopRecordingEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z29Animator_CUSTOM_StartPlaybackP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN8Animator13StartPlaybackEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24Rigidbody2D_CUSTOM_SleepP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11Rigidbody2D11SetSleepingEb(i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z19GetDownloadProgressbjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var f1 = f0;
 if (i2) f1 = Math_fround(1.0); else if (!i4) f1 = Math_fround(0.0); else {
  f1 = Math_fround(Math_fround(i3 >>> 0) / Math_fround(i4 >>> 0));
  if (f1 > Math_fround(1.0)) f1 = Math_fround(1.0);
 }
 return Math_fround(f1);
}

function __Z17PxcPoolMallocInitv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = __ZN5physx6shdfnd9Allocator8allocateEjPKci(i1, 892, gb + 768423 | 0, 67) | 0;
 HEAP32[gb + 1457392 >> 2] = i2;
 __ZN17PxcPoolMallocDataC2Ev(i2);
 STACKTOP = i1;
 return;
}

function _setvbuf(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i3 + 75 | 0;
 HEAP8[i1 >> 0] = -1;
 switch (i4 | 0) {
 case 2:
  {
   HEAP32[i3 + 48 >> 2] = 0;
   break;
  }
 case 1:
  {
   HEAP8[i1 >> 0] = 10;
   break;
  }
 default:
  {}
 }
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 64;
 return 0;
}

function _setdomainname(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall121(121, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj(i1, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, i3);
 HEAP32[i1 >> 2] = gb + 212468 + 8;
 return;
}

function __ZNK9AudioClip20GetMusicChannelCountEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZNK14SoundHandleAPI20GetMusicChannelCountEv(i1) | 0;
 return i1 | 0;
}

function __ZNK5physx7NpShape16getPlaneGeometryERNS_15PxPlaneGeometryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 116 >> 2] | 0) != 1) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i1 + 36 >> 2] & 1)) i1 = 1; else i1 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + 56 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 i2 = 1;
 return i2 | 0;
}

function __ZNK5physx19NpArticulationJoint17getTargetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 12 >> 2] & 8 | 0) == 0 ? i2 + 96 | 0 : (HEAP32[i2 + 16 >> 2] | 0) + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZNK5Umbra14TomeCollection13getGateUserIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 i2 = HEAP32[((i3 | 0) == 0 ? 0 : i1 + i3 | 0) + (i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZNK12FileAccessor4SizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i2) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i1 + 4 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN9allocutil14BuddyAllocator4FreeENS_5ChunkE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i1 >>> 26;
 if (!i2) return;
 i2 = i2 + 255 | 0;
 __ZN9allocutil14BuddyAllocator12InternalFreeEjh(i3, (i1 & 67108863) >>> ((HEAPU8[i3 + 24 >> 0] | 0) + (i2 & 255) | 0), i2 & 255);
 return;
}

function __ZN9ShaderLab6TexEnvC2ERKNS_25SerializedTexturePropertyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 16 >> 2];
 i1 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i1, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 return;
}

function __ZN9GfxDevice21ReleaseSharedMeshDataEP14SharedMeshData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i2 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
 return;
}

function __ZN7ApiGLES10GenTextureE16TextureDimension(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 mftCall_vii(HEAP32[i2 + 804 >> 2] | 0, 1, i3 | 0);
 STACKTOP = i1;
 return HEAP32[i3 >> 2] | 0;
}

function __ZN6Camera22ResetReplacementShaderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 + 828 >> 2] = 0;
 i2 = i1 + 832 | 0;
 i3 = i2 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i2 >> 2] >> 0] = 0;
  HEAP32[i1 + 836 >> 2] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 0;
  HEAP8[i3 >> 0] = 0;
  return;
 }
}

function __ZN5physx2Gu9ContainerC2Ejf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var i4 = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 i4 = f1 < Math_fround(0.0);
 HEAPF32[i3 + 12 >> 2] = i4 ? Math_fround(0.0) : f1;
 __ZN5physx2Gu9Container7SetSizeEj(i3, i2) | 0;
 return;
}

function __ZN5physx27PxDefaultMemoryOutputStreamD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 HEAP32[i2 >> 2] = gb + 87532 + 8;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i1 | 0);
 __ZdlPv(i2);
 return;
}

function __ZN5Umbra12QueryContext17addQueryDebugLineERKNS_7Vector3ES3_RKNS_7Vector4E(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) return;
 mftCall_viiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN4FMOD7SystemI14getSpeakerModeEP16FMOD_SPEAKERMODE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869657;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer32DirtySyncTypeFlagPreservingBatchEt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 162 | 0;
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] | i2;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN15AnchoredJoint2D18SetConnectedAnchorERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN7Joint2D8ReCreateEb(i1, 0);
 return;
}

function __ZN14RotationModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 536 | 0, i2);
 return;
}

function __ZN14PhysicsManager7BoxTestERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5Unity12PhysicsQuery7BoxTestERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction(0, i2, i3, i4, i5, i6) | 0;
}

function __ZN10GameObject14CopyPropertiesERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i2 + 48 >> 2] = HEAP32[i1 + 48 >> 2];
 i3 = HEAP32[i1 + 52 >> 2] | 0;
 HEAP16[i2 + 52 >> 1] = i3;
 HEAP8[i2 + 54 >> 0] = i3 >>> 16;
 HEAP8[i2 + 55 >> 0] = -1;
 __ZN14ConstantStringaSERKS_(i2 + 64 | 0, i1 + 64 | 0);
 return;
}

function __Z41Effector2D_Get_Custom_PropUseColliderMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 56 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41CanvasGroup_Get_Custom_PropBlocksRaycastsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 41 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z41AudioClip_Get_Custom_PropLoadInBackgroundP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 65 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Rigidbody2D_Get_Custom_PropInterpolationP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 56 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40RenderTexture_Get_Custom_PropVolumeDepthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40NavMeshAgent_Get_Custom_PropWalkableMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40ConfigurableJoint_Get_Custom_PropXMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40CapsuleCollider_Get_Custom_PropDirectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 68 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Camera_Get_Custom_PropDepthTextureModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 1072 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Rigidbody_CUSTOM_INTERNAL_CALL_SleepP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Rigidbody5SleepEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z27CanvasRenderer_CUSTOM_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN2UI14CanvasRenderer5ClearEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z19GetTimeSinceStartupv() {
 var d1 = 0.0, i2 = 0;
 i2 = (HEAP8[gb + 1544207 >> 0] | 0) == 0;
 d1 = +_emscripten_get_now();
 if (i2) {
  HEAPF64[gb + 1097984 >> 3] = d1;
  HEAP8[gb + 1544207 >> 0] = 1;
  d1 = 0.0;
  return +d1;
 } else {
  d1 = (d1 - +HEAPF64[gb + 1097984 >> 3]) * .001;
  return +d1;
 }
 return 0.0;
}

function __Z19CleanupClothManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 if (!i1) return;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, 0, 0) | 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1459016 >> 2] = 0;
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z17GetCleanedLogFilev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _getenv(gb + 582938 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) | 0;
 return;
}

function _UNITY_png_set_sRGB_gAMA_and_cHRM(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 if (_UNITY_png_colorspace_set_sRGB(i1, i2 + 40 | 0, i3) | 0) {
  i3 = i2 + 114 | 0;
  HEAP16[i3 >> 1] = HEAPU16[i3 >> 1] | 0 | 24;
 }
 _UNITY_png_colorspace_sync_info(i1, i2);
 return;
}

function _UNITY_FT_List_Find(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 >> 2] | 0;
  if (!i1) i1 = 0; else while (1) {
   if ((HEAP32[i1 + 8 >> 2] | 0) == (i2 | 0)) break L1;
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   if (!i1) {
    i1 = 0;
    break;
   }
  }
 } while (0);
 return i1 | 0;
}

function _jpeg_input_complete(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 if ((i2 + -200 | 0) >>> 0 > 10) {
  i3 = HEAP32[i1 >> 2] | 0;
  HEAP32[i3 + 20 >> 2] = 20;
  HEAP32[i3 + 24 >> 2] = i2;
  mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
 }
 return HEAP8[(HEAP32[i1 + 400 >> 2] | 0) + 17 >> 0] | 0;
}

function _cf2_stack_pushInt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 392 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 | 0) == (i1 + 392 | 0)) {
  _cf2_setError(HEAP32[i1 + 4 >> 2] | 0, 130);
  return;
 } else {
  HEAP32[i4 >> 2] = i2;
  HEAP32[i4 + 4 >> 2] = 2;
  HEAP32[i3 >> 2] = i4 + 8;
  return;
 }
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNSt3__218__libcpp_refstringC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = _strlen(i2) | 0;
 i3 = __Znwj(i4 + 13 | 0) | 0;
 HEAP32[i3 >> 2] = i4;
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i3 + 8 >> 2] = 0;
 i3 = i3 + 12 | 0;
 _memcpy(i3 | 0, i2 | 0, i4 + 1 | 0) | 0;
 HEAP32[i1 >> 2] = i3;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwRKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, _wcslen(i2) | 0);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcRKS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function __ZNK15FileSystemEntry4SizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1044 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  i1 = 0;
  setTempRet0(i1 | 0);
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN7mecanim9animation22DestroyBlendTreeOutputEPNS0_15BlendTreeOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7ApiGLES23BindShaderStorageBufferEjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 1188 + (i3 << 2) | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 mftCall_viii(HEAP32[i2 + 652 >> 2] | 0, 37074, i3 | 0, i4 | 0);
 return;
}

function __ZN7ApiGLES23BindAtomicCounterBufferEjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 1284 + (i3 << 2) | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 mftCall_viii(HEAP32[i2 + 652 >> 2] | 0, 37568, i3 | 0, i4 | 0);
 return;
}

function __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_12BitDataArrayEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 return ((i4 | 0) == 0 ? 0 : (HEAP32[i2 >> 2] | 0) + i4 | 0) + (Math_imul(HEAP32[i2 + 8 >> 2] | 0, ((HEAP32[i2 + 16 >> 2] | 0) + i3 | 0) >>> 5) | 0) | 0;
}

function __ZN5Umbra4PathaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i3 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return i1 | 0;
}

function __ZN4FMOD6SoundI10getNumTagsEPiS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 869015;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN3MBP12purgeHandlesEP10MBP_Objectj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 if (i1 >>> 0 <= 1) return;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i2 = i3 + 4208 + (i1 << 2) | 0;
 HEAP32[(HEAP32[i3 + 96 + (i1 << 4) + 8 >> 2] | 0) + (i4 << 2) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i4;
 return;
}

function __ZN21ExecutionOrderManager29SortBehaviourByExecutionOrderEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[gb + 1163032 >> 2] | 0;
 i1 = __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi(i3, i1) | 0;
 return (i1 | 0) < (__ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi(i3, i2) | 0) | 0;
}

function __ZN14EmissionModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 return;
}

function __ZN14DataBufferGLESD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 4 | 0;
 if (HEAP8[i2 + 20 >> 0] | 0) __Z34register_external_gfx_deallocationPvPKci(HEAP32[i1 >> 2] | -1073741824, gb + 602218 | 0, 116);
 if (!(HEAP32[i1 >> 2] | 0)) return;
 __ZN7ApiGLES12DeleteBufferERj(HEAP32[gb + 1451080 >> 2] | 0, i1);
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13WheelCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13WheelCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SparseTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SparseTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13RenderTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13RenderTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13OcclusionArea8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13ConstantForce8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13BuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13BuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13AnimationClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN13AnimationClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12LineRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN8Renderer10SetVisibleEb(i1, (HEAP32[(HEAP32[i1 + 348 >> 2] | 0) + 20 >> 2] | 0) >>> 0 > 1);
 if (i2 & 1 | 0) return;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __Z40OffMeshLink_Get_Custom_PropBiDirectionalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 98 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Joint_Get_Custom_PropEnablePreprocessingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 89 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z40Collider2D_Get_Custom_PropUsedByEffectorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 53 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39SparseTexture_Get_Custom_PropTileHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39RenderTexture_CUSTOM_Internal_GetHeightP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 84 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39OffMeshLink_Get_Custom_PropNavMeshLayerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39NavMeshAgent_Get_Custom_PropAutoBrakingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 105 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39MeshCollider_Get_Custom_PropInflateMeshP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 121 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Animator_Get_Custom_PropApplyRootMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 417 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Renderer_Get_Custom_PropSortingLayerIDP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 332 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Camera_Get_Custom_PropStereoMirrorModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1112 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33SetUpSkinnedBuffersOnSkinnedClothPN5Unity5ClothEPvS2_S2_jb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __ZN5Unity5Cloth19SetUpSkinnedBuffersEPvS1_S1_j(i1, i2, i3, 0, i5);
 if (!i6) return;
 __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv(i1);
 return;
}

function __Z32NavMeshAgent_CUSTOM_StopInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN12NavMeshAgent4StopEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z28Animator_CUSTOM_StopPlaybackP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN8Animator12StopPlaybackEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z16GetCustomLogFilev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _getenv(gb + 582923 | 0) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 if (!i2) return;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) | 0;
 return;
}

function _UNITY_png_get_y_offset_pixels(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 256)) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i2 + 180 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 176 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_png_get_x_offset_pixels(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 8 >> 2] & 256)) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[i2 + 180 >> 0] | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 172 >> 2] | 0;
 return i2 | 0;
}

function mftCall_vdddddd(i7, d1, d2, d3, d4, d5, d6) {
 i7 = i7 | 0;
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 if ((i7 | 0) >= (fb | 0) & (i7 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vdddddd[i7 - fb & 1](+d1, +d2, +d3, +d4, +d5, +d6);
  return;
 }
 ftCall_vdddddd(i7 | 0, +d1, +d2, +d3, +d4, +d5, +d6);
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getRigidBodyFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 4096)) {
  i1 = i1 + 108 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 } else {
  i1 = (HEAP32[i1 + 56 >> 2] | 0) + 268 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i4 + 1360 >> 2];
 if (i2 | 0) HEAP32[i2 >> 2] = HEAP32[i4 + 1356 >> 2];
 if (!i1) return 1;
 HEAP32[i1 >> 2] = HEAP32[i4 + 1364 >> 2];
 return 1;
}

function __ZN8VRDevice10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 296 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 if (i2) {
  __ZN8VRDevice22StartRenderingToDeviceEv(i1);
  return;
 } else {
  __ZN8VRDevice21StopRenderingToDeviceEv(i1);
  return;
 }
}

function __ZN5physx8debugger18MemPvdOutputStreamD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148660 + 8;
 HEAP32[i2 + 4 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sq10AABBPruner22refitUpdatedAndRemovedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i3 + 7764 >> 2] | 0;
 if (!i2) return;
 __ZN5physx2Sq8AABBTree11refitMarkedEjPKNS_9PxBounds3EPj(i1, i2, HEAP32[i3 + 7772 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5physx23ArticulationRootManagerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101628 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD6SoundI15deleteSyncPointEP14FMOD_SYNCPOINT(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868936;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN28ApplyBuiltinInstanceProperty22PerformFlushPropertiesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 __ZN20DynamicPropertySheet10FlushQueueEv(i2);
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 __ZN19ShaderPropertySheet5ClearEb(i2, 1);
 return;
}

function __ZN20LocalFileSystemPosix4SeekER13FileEntryDatax10FileOrigin(i1, i2, i4, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i5 = 0;
  return i5 | 0;
 }
 i5 = (_fseek(i1, i4, (i5 | 0) == 3 ? 2 : (i5 | 0) == 2 & 1) | 0) == 0;
 return i5 | 0;
}

function __ZN17SurfaceEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!(HEAP8[i2 + 105 >> 0] | 0)) HEAPF32[i1 + 144 >> 2] = Math_fround(0.0);
 if (HEAP8[i2 + 106 >> 0] | 0) return;
 HEAPF32[i1 + 148 >> 2] = Math_fround(0.0);
 return;
}

function __ZN17CommonStringTableD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 400 | 0;
 do {
  i3 = i2;
  i2 = i2 + -20 | 0;
  if ((HEAP32[i3 + -4 >> 2] | 0) > -1) {
   __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i3 + -16 | 0);
   HEAP32[i2 >> 2] = 0;
  }
 } while ((i2 | 0) != (i1 | 0));
 return;
}

function __ZN16ParticleRendererD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 190956 + 8;
 HEAP32[i1 + 32 >> 2] = gb + 190956 + 184;
 i2 = HEAP32[i1 + 376 >> 2] | 0;
 if (!i2) {
  __ZN8RendererD2Ev(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63264 | 0);
 __ZN8RendererD2Ev(i1);
 return;
}

function __ZN16GUIKeyboardState16LoadIntoGUIStateER8GUIState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 12 >> 2];
 i3 = i1 + 8 | 0;
 HEAP32[i2 + 8 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN15QualitySettings24SetAsyncUploadBufferSizeEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (i1 | 0) < 2 ? 2 : (i1 | 0) > 512 ? 512 : i1;
 i1 = (HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 104 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN15DirectorManager30ScheduleForDestructionInternalEP8Playable(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63784 | 0, 16, gb + 582681 | 0, 847) | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = HEAP32[gb + 1188424 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN15ArchiveReadFile4ReadEyPvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = i1 + 16 | 0;
 return mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZN14UnityAnalytics29OnSceneLoadedAfterAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN14UnityAnalytics23OnSceneLoadedAfterAwakeEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, 0, 0);
 return;
}

function __ZN13dynamic_arrayI12LightmapDataLj4EE5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 if ((HEAP32[i2 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12CullingGroup25SetDistanceReferencePointERKN4math7_float3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 68 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 72 >> 2] = i4;
 HEAP32[i1 + 76 >> 2] = i3;
 HEAP32[i1 + 80 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager35CheckAndSetupActiveSessionContainerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 552 >> 2] | 0) == 4) if (!(__ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = 1;
 return i1 | 0;
}

function __Z50Playable_CUSTOM_INTERNAL_CALL_GetPlayStateInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __Z39CanvasGroup_Get_Custom_PropInteractableP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 40 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z39Animation_Get_Custom_PropAnimatePhysicsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 41 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38SparseTexture_Get_Custom_PropTileWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38SparseTexture_Get_Custom_PropIsCreatedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 100 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38SliderJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 117 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Rigidbody2D_Get_Custom_PropConstraintsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 52 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38RenderTexture_Get_Custom_PropUseMipMapP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 116 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38RenderTexture_CUSTOM_Internal_GetWidthP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 80 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38NavMeshAgent_Get_Custom_PropAutoRepathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 106 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Effector2D_Get_Custom_PropColliderMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 60 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38AudioSource_Get_Custom_PropPlayOnAwakeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 497 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Camera_Get_Custom_PropStereoTargetEyeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 824 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Camera_Get_Custom_PropOpaqueSortModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 1064 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Animation_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN9Animation4StopEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI8JSONReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_get_gAMA(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(i3 | 0 ? (HEAP16[i2 + 114 >> 1] & 1) != 0 : 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAPF64[i3 >> 3] = +(HEAP32[i2 + 40 >> 2] | 0) * 1.0e-05;
 i3 = 1;
 return i3 | 0;
}

function _LzmaDec_InitDicAndState(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 76 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 if (i2 | 0) {
  HEAP32[i1 + 44 >> 2] = 0;
  HEAP32[i1 + 48 >> 2] = 0;
  HEAP32[i1 + 80 >> 2] = 1;
 }
 if (!i3) return;
 HEAP32[i1 + 80 >> 2] = 1;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekoffExNS_8ios_base7seekdirEj(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13shrink_to_fitEv(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4514 | 0, i1 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13shrink_to_fitEv(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_vii(fb + 4512 | 0, i1 | 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNK9Texture2D25GetImageReferenceInternalEP14ImageReferenceii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii(i1, i2, i3, i4) | 0;
 return i4 | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20getRigidDynamicFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 4096)) {
  i1 = i1 + 108 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 } else {
  i1 = (HEAP32[i1 + 56 >> 2] | 0) + 268 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZNK5physx14NpRigidDynamic21getMaxAngularVelocityEv(i2) {
 i2 = i2 | 0;
 var f1 = f0;
 if (!(HEAP32[i2 + 284 >> 2] & 16)) f1 = Math_fround(__ZNK5physx2Sc8BodyCore14getMaxAngVelSqEv(i2 + 64 | 0)); else f1 = Math_fround(HEAPF32[(HEAP32[i2 + 56 >> 2] | 0) + 116 >> 2]);
 return Math_fround(Math_sqrt(Math_fround(f1)));
}

function __ZNK13SplatDatabase10GetBasemapEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 44 >> 2] | 0;
 if ((i2 | 0) != (__Z19GetActiveColorSpacev() | 0)) __ZN13SplatDatabase18RecalculateBasemapEb(i1, 0);
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i1) return 0; else return (HEAP32[i1 + 4 >> 2] | 0 ? i1 : 0) | 0;
 return 0;
}

function __ZN5physx3Ext14PrismaticJoint22setPrismaticJointFlagsENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[(HEAP32[i2 + 80 >> 2] | 0) + 108 >> 1] = HEAP16[i1 >> 1] | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Gu5RTree15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 128);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 92 >> 2] | 0, (HEAP32[i2 + 80 >> 2] | 0) * 112 | 0);
 return;
}

function __ZN4FMOD6SoundI13getSoundGroupEPPNS_10SoundGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869026;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63784 | 0, 16, gb + 582681 | 0, 412) | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = HEAP32[gb + 1188416 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN13UploadHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 187928 + 8;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) {
  __Z23scripting_gchandle_freej(i3);
  HEAP32[i2 >> 2] = 0;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12MeshCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12MeshCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12LineRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12LineRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12CubemapArray8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12CubemapArray8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12AudioManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN12AudioManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12AudioManager16UnScheduleSourceEP11AudioSource(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 464 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 468 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer11PurgeEventsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 68 | 0;
 if ((HEAP32[i1 + 72 >> 2] | 0) == (HEAP32[i3 >> 2] | 0)) return;
 __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeItemsEj(i3, i2);
 HEAP8[i1 + 89 >> 0] = 1;
 return;
}

function __Z51GeometryUtility_CUSTOM_INTERNAL_CALL_TestPlanesAABBP11Il2CppArrayRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0;
 return (__Z14TestPlanesAABBPK5PlaneiRK4AABB(i3, __Z21GetScriptingArraySizeP11Il2CppArray(i1) | 0, i2) | 0) & 1 | 0;
}

function __Z38Rigidbody2D_Get_Custom_PropUseAutoMassP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 49 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38NavMeshObstacle_Get_Custom_PropCarvingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 68 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Joint2D_Get_Custom_PropEnableCollisionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 40 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z38Application_Get_Custom_PropAbsoluteURLv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i4 = i2 + 524 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 return __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i2 + 528 >> 2] | 0 : i1 & 255) | 0;
}

function __Z37SliderJoint2D_Get_Custom_PropUseMotorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 116 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Projector_Get_Custom_PropIgnoreLayersP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 60 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37HingeJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 113 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37Canvas_Get_Custom_PropOverrideSortingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 375 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37AudioReverbZone_Get_Custom_PropRoomLFP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 68 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37AudioReverbZone_Get_Custom_PropRoomHFP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 64 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37AudioReverbZone_Get_Custom_PropReverbP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z37AnimationClip_Get_Custom_PropWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Renderer_Get_Custom_PropSortingOrderP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 336 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36AudioMixer_Get_Custom_PropUpdateModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 104 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35LightProbeProxyVolume_CUSTOM_UpdateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   HEAP8[i2 + 154 >> 0] = 1;
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI8JSONReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI8JSONRead10Matrix4x4fEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z16GetStringFromEnvPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = _getenv(i1 | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 if (!i1) return;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i2, i1) | 0;
 return;
}

function _strfmon_l(i2, i3, i1, i4, i5) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i1;
 HEAP32[i6 >> 2] = i5;
 i5 = _vstrfmon_l(i2, i3, i4, i6) | 0;
 STACKTOP = i1;
 return i5 | 0;
}

function _getgroups(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall205(205, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZThn4_N5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = __ZN5physx5cloth8allocateEj(116) | 0;
 __ZN5physx5cloth8SwSolverC2EPNS_13PxProfileZoneEPNS_13PxTaskManagerE(i3, i1, i2);
 return ((i3 | 0) == 0 ? 0 : i3 + 4 | 0) | 0;
}

function __ZNSt3__212strstreambufC2EPFPvjEPFvS1_E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = 4096;
 HEAP32[i1 + 40 >> 2] = i2;
 HEAP32[i1 + 44 >> 2] = i3;
 return;
}

function __ZNK6Avatar7IsHumanEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i2 + i1 + 40 | 0;
 i2 = (HEAP32[(HEAP32[i2 >> 2] | 0) + i2 >> 2] | 0) != 0;
 return i2 | 0;
}

function __ZNK5physx14NpArticulation26getMaxProjectionIterationsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 4)) {
  i1 = __ZNK5physx2Sc16ArticulationCore26getMaxProjectionIterationsEv(i1 + 24 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + 8 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx14NpArticulation26getExternalDriveIterationsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 2)) {
  i1 = __ZNK5physx2Sc16ArticulationCore26getExternalDriveIterationsEv(i1 + 24 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + 4 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK11AudioSource8IsPausedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 456 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP32[i2 + 16 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0) + 236 >> 0] | 0) != 0;
 return i2 | 0;
}

function __ZN9UdpSocket12SetBroadcastEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 1;
 i1 = (__Z15setsockopt_stubiiiPKvj(HEAP32[i1 + 4 >> 2] | 0, 1, 6, i3, 4) | 0) == 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZN8WindZone18ResetDefaultValuesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.00999999977);
 return;
}

function __ZN5physx9NpPhysics20MeshDeletionListener28onGuMeshFactoryBufferReleaseEPKNS_6PxBaseEtb(i3, i2, i4, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(HEAP32[gb + 1457324 >> 2] | 0, i2, 0, i1 ? 2 : 1);
 return;
}

function __ZN5physx45PxVehicleAckermannGeometryDataGeneratedValuesC2EPKNS_30PxVehicleAckermannGeometryDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx2Sc18TriggerInteraction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP16[i2 + 56 >> 1] & 32) {
  i2 = 0;
  return i2 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 12 >> 2] | 0) + 51 >> 0] & 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + 51 >> 0] & 1) == 0;
 return i2 | 0;
}

function __ZN5physx2Gu11HeightField15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + 15 & -16;
 HEAP32[i3 >> 2] = i1 + (Math_imul(HEAP32[i2 + 16 >> 2] << 2, HEAP32[i2 + 20 >> 2] | 0) | 0);
 HEAP32[i2 + 36 >> 2] = i1;
 return;
}

function __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 var i4 = 0;
 i4 = i3 >>> 2;
 i2 = HEAP32[i2 >> 2] | 0;
 i3 = i3 & 3;
 HEAPF32[i2 + (i4 * 224 | 0) + (i3 << 2) >> 2] = f1;
 HEAPF32[i2 + (i4 * 224 | 0) + 16 + (i3 << 2) >> 2] = f1;
 return;
}

function __ZN5physx20PxsSolverCoreGeneral8destroyVEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD8ChannelI15getSystemObjectEPPNS_6SystemE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 862473;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI13setSoundGroupEPNS_10SoundGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869127;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN18CapsuleCast2DQueryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 return;
}

function __ZN16ControllerFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 return i3 | 0;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN15HeightMeshQueryD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 169856 + 8;
 __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1 + 4 | 0, HEAP32[i1 + 8 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14ImageReferenceC2Eii13TextureFormat(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i2, i4) | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN12GUIClipState19EndThroughExceptionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i4;
 if ((i4 | 0) == (i1 | 0) | (i2 | 0) == (i1 | 0)) return;
 HEAP32[i3 >> 2] = i2 + (~(((i2 + -56 - i1 | 0) >>> 0) / 56 | 0) * 56 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager11FlushEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3958 | 0, i1 | 0) | 0;
 i1 = 1;
 return i1 | 0;
}

function __Z37RenderTexture_CUSTOM_ReleaseTemporaryP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z22GetRenderBufferManagerv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture(i2, i1);
 return;
}

function __Z37Projector_Get_Custom_PropOrthographicP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 52 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36WheelJoint2D_Get_Custom_PropUseMotorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 116 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Texture2DArray_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Rigidbody2D_Get_Custom_PropSleepModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 60 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36NavMeshObstacle_Get_Custom_PropShapeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36NavMeshAgent_Get_Custom_PropAreaMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36LightProbes_Get_Custom_PropCellCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 44 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36HingeJoint2D_Get_Custom_PropUseMotorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 112 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Collider2D_Get_Custom_PropShapeCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 72 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Collider2D_Get_Custom_PropErrorStateP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 56 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Animation_Get_Custom_PropCullingTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 44 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Camera_Get_Custom_PropTargetDisplayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 820 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Camera_Get_Custom_PropRenderingPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 928 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z13VFormatLengthPKcPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = HEAP32[i2 >> 2];
 i2 = _vsnprintf(0, 0, i1, i4) | 0;
 STACKTOP = i3;
 return ((i2 | 0) > -1 ? i2 : -1) | 0;
}

function _inet_aton(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i4;
 if ((___ipparse(i3, 2, i1) | 0) < 0) i1 = 0; else {
  HEAP32[i2 >> 2] = HEAP32[i3 + 4 >> 2];
  i1 = 1;
 }
 STACKTOP = i4;
 return i1 | 0;
}

function _glBlitFramebuffer__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 _glBlitFramebuffer(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
}

function _cf2_arrstack_init(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 10;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZNKSt3__25ctypeIcE9do_narrowEPKcS3_cPc(i3, i1, i4, i5, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  i3 = HEAP8[i1 >> 0] | 0;
  HEAP8[i2 >> 0] = i3 << 24 >> 24 > -1 ? i3 : i5;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 return i4 | 0;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_(HEAP32[i4 + 48 >> 2] | 0, i1, i3, i2);
 return;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZN8Animator28CreateStateMachineBehavioursEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 i2 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 HEAP8[i1 + 426 >> 0] = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i1 | 0) | 0) & 1;
 return;
}

function __ZN5Umbra9IndexList11setCapacityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i1 = i5 + 8 | 0;
 i5 = i5 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = (i4 | 0) <= (i3 | 0) ? i4 : i3;
 return;
}

function __ZN5Umbra9FloatList11setCapacityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i1 = i5 + 8 | 0;
 i5 = i5 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 i3 = HEAP32[i5 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = (i4 | 0) <= (i3 | 0) ? i4 : i3;
 return;
}

function __ZN4crnd5utils16compute_max_mipsEjj(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i1 | i3;
 if (!i2) i1 = 0; else if ((i2 | 0) == 1) i1 = 1; else {
  i4 = i1;
  i2 = i3;
  i1 = 1;
  do {
   i2 = i2 >>> 1;
   i4 = i4 >>> 1;
   i1 = i1 + 1 | 0;
  } while ((i4 | i2) >>> 0 > 1);
 }
 return i1 | 0;
}

function __ZN18ScriptingArguments9AddStringEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20scripting_string_newPKc(i2) | 0;
 i2 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i2 >> 2] << 2) >> 2] = i3;
 HEAP32[i1 + 144 + (HEAP32[i2 >> 2] << 2) >> 2] = 4;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN17CircleCast2DQueryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 return;
}

function __ZN15QualitySettings23SetAsyncUploadTimeSliceEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (i1 | 0) < 1 ? 1 : (i1 | 0) > 33 ? 33 : i1;
 i1 = (HEAP32[i3 + 28 >> 2] | 0) + ((HEAP32[i3 + 44 >> 2] | 0) * 108 | 0) + 100 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN14SafeBinaryRead11EndTransferEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i4 = i2 + 100 | 0;
 i1 = HEAP32[i4 >> 2] | 0;
 i3 = i1 + -1 | 0;
 HEAP32[i4 >> 2] = i3;
 if (!i3) i1 = 0; else i1 = (HEAP32[i2 + 88 >> 2] | 0) + (i1 + -2 << 5) | 0;
 HEAP32[i2 + 80 >> 2] = i1;
 HEAP8[i2 + 128 >> 0] = 1;
 return;
}

function __ZN14ParticleSystem26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN14ParticleSystem8SyncJobsEb(0);
 __ZN25ParticleSystemGeometryJob12ScheduleJobsEPP12BaseRendererjPK6CameraRK10Matrix4x4f(i1, i2, i3, i4);
 return;
}

function __ZN14CompletionTask4InitEPN5physx7PxSceneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 388 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 16 >> 2] = 1;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP8[i1 + 20 >> 0] = 0;
 return;
}

function __ZN14AnimationState4StopEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 56 | 0;
 i1 = HEAP16[i3 >> 1] | 0;
 if ((i1 & 10) == 10) {
  i1 = i1 | 64;
  HEAP16[i3 >> 1] = i1;
 }
 HEAP16[i3 >> 1] = i1 & -3;
 __ZN14AnimationState7SetTimeEf(i2, Math_fround(0.0));
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -6;
 return;
}

function __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fPKS1_EEvPT_RKT0_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) return;
 i2 = HEAP32[i2 >> 2] | 0;
 while (1) {
  i3 = i3 + -1 | 0;
  __ZN8Scalar4faSERKS_(i1, i2) | 0;
  if (!i3) break; else {
   i1 = i1 + 16 | 0;
   i2 = i2 + 16 | 0;
  }
 }
 return;
}

function __ZN12_GLOBAL__N_110DataStream27getPropertyDefinitionHelperEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 96 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return i1 | 0;
}

function __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11TimeManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11TimeManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NavMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NavMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11MonoManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11MonoManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11LightProbes8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11LightProbes8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11BoxCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AudioSource8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AudioSource8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AssetBundle8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11AssetBundle8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10MemoryFile5WriteEyPKvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = i1 + 24 | 0;
 return mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __Z50Playable_CUSTOM_INTERNAL_CALL_SetPlayStateInternalR9HPlayable9PlayState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z38Input_Get_Custom_PropCompositionStringv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z15GetInputManagerv() | 0;
 i4 = i2 + 148 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 return __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i2 + 152 >> 2] | 0 : i1 & 255) | 0;
}

function __Z36Terrain_Get_Custom_PropDrawHeightmapP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 89 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Rigidbody2D_Get_Custom_PropSimulatedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 48 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36OffMeshLink_Get_Custom_PropActivatedP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 99 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36Joint_Get_Custom_PropEnableCollisionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 88 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z36GameObject_Get_Custom_PropActiveSelfP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 54 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Transform_Get_Custom_PropChildCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Terrain_Get_Custom_PropMaterialTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35SpriteRenderer_Get_Custom_PropFlipYP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 361 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35SpriteRenderer_Get_Custom_PropFlipXP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 360 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Rigidbody2D_Get_Custom_PropBodyTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 68 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35RenderTexture_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35ReflectionProbe_Get_Custom_PropTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35ReflectionProbe_Get_Custom_PropModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 40 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35ParticleEmitter_Get_Custom_PropEmitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 205 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35HingeJoint_Get_Custom_PropUseSpringP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 158 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35HingeJoint_Get_Custom_PropUseLimitsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 156 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35AudioReverbZone_Get_Custom_PropRoomP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 60 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Animator_Get_Custom_PropLogWarningsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 424 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Animator_Get_Custom_PropCullingModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Camera_Get_Custom_PropOrthographicP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 1088 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32setPxParticleReadDataFlagsBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z26TrailRenderer_CUSTOM_ClearP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN13TrailRenderer5ClearEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z26NavMeshAgent_CUSTOM_ResumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN12NavMeshAgent6ResumeEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z24GetAssetBundleFileSystemv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451040 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63552 | 0, 16, gb + 585751 | 0, 179) | 0;
 __ZN21AssetBundleFileSystemC2EPKc(i1, HEAP32[gb + 27264 >> 2] | 0);
 HEAP32[gb + 1451040 >> 2] = i1;
 return i1 | 0;
}

function _sn_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = i1 + 20 | 0;
 i5 = HEAP32[i4 >> 2] | 0;
 i1 = (HEAP32[i1 + 16 >> 2] | 0) - i5 | 0;
 i1 = i1 >>> 0 > i3 >>> 0 ? i3 : i1;
 _memcpy(i5 | 0, i2 | 0, i1 | 0) | 0;
 HEAP32[i4 >> 2] = (HEAP32[i4 >> 2] | 0) + i1;
 return i3 | 0;
}

function _munlock(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall151(151, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _getservbyport(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = (_getservbyport_r(i1, i2, gb + 1469816 | 0, gb + 1469832 | 0, 32, i3) | 0) == 0;
 i2 = i2 ? gb + 1469816 | 0 : 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _getservbyname(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = (_getservbyname_r(i1, i2, gb + 1469768 | 0, gb + 1469784 | 0, 32, i3) | 0) == 0;
 i2 = i2 ? gb + 1469768 | 0 : 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _getrusage(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall77(77, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function ___wcsxfrm_l(i3, i4, i5, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = _wcslen(i4) | 0;
 if (i1 >>> 0 < i5 >>> 0) _wmemcpy(i3, i4, i1 + 1 | 0) | 0; else {
  i2 = i5 + -1 | 0;
  if (i5 | 0) {
   _wmemcpy(i3, i4, i2) | 0;
   HEAP32[i3 + (i2 << 2) >> 2] = 0;
  }
 }
 return i1 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0, -2147483648, i1 | 0);
 return;
}

function __ZThn8_N5physx3Cct17CapsuleControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZThn4_N12MemoryStreamD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 113908 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 113908 + 32;
 if (!(HEAP8[i1 + 8 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 24 >> 2] | 0, gb + 63552 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNK5physx3Cct10Controller16getInternalStatsERNS_17PxControllerStatsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i1 + 2 >> 1] = HEAP16[i2 + 388 >> 1] | 0;
 HEAP16[i1 + 4 >> 1] = HEAP16[i2 + 390 >> 1] | 0;
 HEAP16[i1 >> 1] = HEAP16[i2 + 394 >> 1] | 0;
 HEAP16[i1 + 6 >> 1] = HEAP16[i2 + 392 >> 1] | 0;
 return;
}

function __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 switch (HEAP8[i1 + 50 >> 0] | 0) {
 case 1:
 case 4:
  {
   i1 = (HEAP32[i1 + 52 >> 2] | 0) + 16 | 0;
   return i1 | 0;
  }
 default:
  {
   i1 = (HEAP32[i1 + 52 >> 2] | 0) + 16 | 0;
   return i1 | 0;
  }
 }
 return 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getRigidBodyFlagsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 284 >> 2] & 4096)) {
  i1 = i1 + 108 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 } else {
  i1 = (HEAP32[i1 + 56 >> 2] | 0) + 268 | 0;
  i1 = HEAP8[i1 >> 0] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZN9ShaderLab26GetFastPropertyIndexByNameEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZN7mecanim9animation16CreateClipSimpleEjRNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 48, 4) | 0;
 i2 = i1;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function __ZN5physx2Sc18TriggerInteraction10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP16[i2 + 56 >> 1] & 32) {
  i2 = 1;
  return i2 | 0;
 }
 if (HEAP8[(HEAP32[i2 + 12 >> 2] | 0) + 51 >> 0] & 1) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (HEAP8[(HEAP32[i2 + 16 >> 2] | 0) + 51 >> 0] & 1) != 0;
 return i2 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i3 + 20 | 0, i2, i1);
 return;
}

function __ZN5physx21PxVehicleDriveSimData13setClutchDataERKNS_19PxVehicleClutchDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 256 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5Unity17ConfigurableJoint20SetRotationDriveModeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 288 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN4FMOD6SoundI15getSystemObjectEPPNS_6SystemE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 862473;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN17GameObjectManager16StaticInitializeEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63520 | 0, 16, gb + 368833 | 0, 1203) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[gb + 1104660 >> 2] = i1;
 return;
}

function __ZN14PhysicsManager15IgnoreCollisionER8ColliderS1_b(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!((__ZNK8Collider21ShouldIgnoreCollisionEPS_(i2, i3) | 0) ^ i4)) return;
 __ZN8Collider15IgnoreCollisionEPS_b(i2, i3, i4);
 __ZN8Collider15IgnoreCollisionEPS_b(i3, i2, i4);
 return;
}

function __ZN14PhysicsManager13CreateReportsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, 0, 0);
 i2 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i1 + 28 | 0, 0);
 return;
}

function __ZN14MinMaxGradient19InitializeOptimizedER23OptimizedMinMaxGradient(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Gradient19InitializeOptimizedER17OptimizedGradient(i1, i2);
 if ((HEAP16[i1 + 152 >> 1] | 0) != 3) return;
 __ZN8Gradient19InitializeOptimizedER17OptimizedGradient(i1 + 72 | 0, i2 + 208 | 0);
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN12SocketStream8ShutdownEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 18 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i1 = __ZN6Socket10CheckErrorEiPKcii(__Z13shutdown_stubii(HEAP32[i1 + 4 >> 2] | 0, 2) | 0, gb + 584846 | 0, 107, 0) | 0;
 HEAP8[i2 >> 0] = 0;
 i2 = i1 ^ 1;
 return i2 | 0;
}

function __ZN12AudioManager16RemoveAudioMixerEP10AudioMixer(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i3 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i3 = i3 + 84 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN11Rigidbody2D25SetCollisionDetectionModeENS_22CollisionDetectionModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 64 >> 2] = i2;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + 4 | 0;
 i3 = HEAPU16[i1 >> 1] | 0;
 HEAP16[i1 >> 1] = (i2 | 0) == 1 ? i3 | 8 : i3 & 65527;
 return;
}

function __ZN11RadixSorter12ResetIndicesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0, i4 = 0;
 i3 = i2 + 8 | 0;
 if (!(HEAP32[i3 >> 2] | 0)) return i2 | 0;
 i4 = HEAP32[i2 + 12 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i4 + (i1 << 2) >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < (HEAP32[i3 >> 2] | 0) >>> 0);
 return i2 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i1 >>> 0 <= i2 >>> 0 & (i1 + 4096 | 0) >>> 0 >= i2 >>> 0) {
  i1 = i1 + 4096 | 0;
  if ((i2 + (i3 + 15 & -16) | 0) == (HEAP32[i1 >> 2] | 0)) HEAP32[i1 >> 2] = i2;
 } else _free(i2);
 return;
}

function __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10GameObject12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1104660 >> 2] | 0;
 if (i1 | 0) {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63520 | 0);
 HEAP32[gb + 1104660 >> 2] = 0;
 return;
}

function __Z45RectTransform_Set_Custom_PropDrivenPropertiesP12Il2CppObjectN2UI13RectTransform16DrivenPropertiesE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35OcclusionPortal_Get_Custom_PropOpenP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 72 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Collider2D_Get_Custom_PropIsTriggerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 52 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z35Application_Get_Custom_PropSrcValuev() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z17GetPlayerSettingsv() | 0;
 i4 = i2 + 540 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 return __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i2 + 544 >> 2] | 0 : i1 & 255) | 0;
}

function __Z34ReflectionProbe_Get_Custom_PropHdrP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 140 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34HingeJoint_Get_Custom_PropUseMotorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 157 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34CubemapArray_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34CanvasRenderer_Get_Custom_PropCullP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 164 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Animator_Get_Custom_PropUpdateModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 96 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34Animator_Get_Custom_PropFireEventsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 425 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Camera_Get_Custom_PropCullingMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 880 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Camera_Get_Custom_PropCameraTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 1108 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z16dtAllocSetCustomPFPviEPFvS_ES1_S3_PFS_S_iE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[gb + 1459036 >> 2] = i1;
 HEAP32[gb + 1459028 >> 2] = i2;
 HEAP32[gb + 1459528 >> 2] = i3;
 HEAP32[gb + 1459524 >> 2] = i4;
 HEAP32[gb + 1459040 >> 2] = i5;
 return;
}

function _UNITY_png_sig_cmp(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 if (i1 >>> 0 > 8) i1 = 8; else if (!i1) {
  i3 = -1;
  return i3 | 0;
 }
 if (i3 >>> 0 > 7) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = _memcmp(i2 + i3 | 0, gb + 350355 + i3 | 0, (i1 + i3 | 0) >>> 0 > 8 ? 8 - i3 | 0 : i1) | 0;
 return i3 | 0;
}

function _UNITY_FT_List_Add(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 i3 = i1 + 4 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = i4;
 if (!i4) HEAP32[i1 >> 2] = i2; else HEAP32[i4 + 4 >> 2] = i2;
 HEAP32[i3 >> 2] = i2;
 return;
}

function _tcsetpgrp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 i5 = i3 + 4 | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i4 >> 2] = i5;
 i2 = _ioctl(i1, 21520, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _ps_hinter_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 _ps_hints_init(i2, HEAP32[i1 + 8 >> 2] | 0);
 _psh_globals_funcs_init(i1 + 100 | 0);
 i3 = i1 + 112 | 0;
 _t1_hints_funcs_init(i3);
 HEAP32[i3 >> 2] = i2;
 i1 = i1 + 140 | 0;
 _t2_hints_funcs_init(i1);
 HEAP32[i1 >> 2] = i2;
 return 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) i1 = -1; else {
  i2 = i1 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i1 + 4;
  i1 = HEAP32[i1 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5uflowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0) == -1) i1 = -1; else {
  i2 = i1 + 12 | 0;
  i1 = HEAP32[i2 >> 2] | 0;
  HEAP32[i2 >> 2] = i1 + 1;
  i1 = HEAPU8[i1 >> 0] | 0;
 }
 return i1 | 0;
}

function __ZNK5physx5cloth8SwSolver10beginFrameEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 8 | 0;
 i1 = i2;
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 16 >> 2] | 0, i3 | 0, HEAP16[i2 + 76 >> 1] | 0, i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, i1 | 0);
 return;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZNK20LocalFileSystemPosix18GetApplicationPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _strlen(gb + 1547918 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1547918 | 0, i2);
 return;
}

function __ZN5physx3Ext13DistanceJoint21setDistanceJointFlagsENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[(HEAP32[i2 + 80 >> 2] | 0) + 92 >> 1] = HEAP16[i1 >> 1] | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc5Scene19getActiveTransformsERjh(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[(HEAP32[i2 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 >> 2] | 0;
 return i3 | 0;
}

function __ZN5Unity5Joint9SetAnchorERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 40 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, 2);
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD7SystemI9getOutputEP15FMOD_OUTPUTTYPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 857600;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI7getNameEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 78;
 HEAP32[i3 + 4 >> 2] = gb + 868219;
 _printf(gb + 857490 | 0, i3) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20TextRenderingPrivate7GUIText11GetMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 + 4 >> 2] | 0;
}

function __ZN19RuntimeSceneManager14GetActiveSceneEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 44 >> 2] | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + (i1 + -1 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN19ControllerHitReport15onControllerHitERKN5physx16PxControllersHitE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 60 >> 2] | 0;
 __ZN19ControllerHitReport5onHitERKN5physx15PxControllerHitEP8Collider(i1, i2, mftCall_ii(HEAP32[(HEAP32[i3 >> 2] | 0) + 80 >> 2] | 0, i3 | 0) | 0);
 return;
}

function __ZN15Cast2DQueryBaseD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 return;
}

function __ZN13TranslateGLES16InitBufferTargetERK12GraphicsCaps16GfxDeviceLevelGL(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 + 2296 | 0;
 i2 = gb + 74588 | 0;
 i3 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN13GfxDeviceNull22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN12AudioManager15DidReloadDomainEv() {
 var i1 = 0, i2 = 0;
 i2 = (__Z21GetManagerFromContexti(3) | 0) + 296 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i1 = __Znwj(28) | 0;
  __ZN24AudioScriptBufferManagerC2Ev(i1);
  HEAP32[i2 >> 2] = i1;
 }
 __ZN24AudioScriptBufferManager15DidReloadDomainEv(i1);
 return;
}

function __ZN11MatrixStack3PopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 1024 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) < 2) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 407139 | 0, 0, gb + 407066 | 0, 42, 1, 0, 0, 0);
  return;
 } else {
  HEAP32[i1 >> 2] = i2 + -1;
  return;
 }
}

function __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10TagManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10TagManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10MonoScript8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10MonoScript8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10MemoryFile4ReadEyPvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 var i6 = 0;
 i6 = i1 + 24 | 0;
 return mftCall_iiiiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, HEAP32[i6 >> 2] | 0, HEAP32[i6 + 4 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10GameObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10GameObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10GUITexture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10GUITexture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10AudioMixer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN10AudioMixer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZL22InitializeModule_IMGUIv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63864 | 0, 16, gb + 1018954 | 0, gb + 1576256 | 0, gb + 1018969 | 0, 83) | 0;
 HEAP32[i1 >> 2] = gb + 187260 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIIMGUIP6IIMGUI(i1);
 __ZN10GUIManager14InitGUIManagerEv();
 return;
}

function __Z44GL_CUSTOM_INTERNAL_CALL_LoadProjectionMatrixRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i1 | 0);
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0);
 return;
}

function __Z37GraphicsSettings_CUSTOM_SetShaderModeN16GraphicsSettings17BuiltinShaderTypeEN21BuiltinShaderSettings17BuiltinShaderModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(__ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, i1) | 0) + 4 >> 2] = i2;
 return;
}

function __Z37AnimationClipPlayable_CUSTOM_GetSpeedR9HPlayable(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  f2 = Math_fround(-1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 168 >> 2]);
 return Math_fround(f2);
}

function __Z35getPxVehicleDriveSimDataNW_DiffDataPKN5physx23PxVehicleDriveSimDataNWE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 528 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z34Terrain_Get_Custom_PropCastShadowsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 88 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z34MeshCollider_Get_Custom_PropConvexP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 60 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Texture_Get_Custom_PropFilterModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 32 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Texture_Get_Custom_PropAnisoLevelP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33TextMesh_Get_Custom_PropFontStyleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 76 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33TextMesh_Get_Custom_PropAlignmentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 56 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33RenderTexture_Get_Custom_PropSRGBP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 118 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33AudioClip_Get_Custom_PropLoadTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 52 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z33Animation_Get_Custom_PropWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32Camera_Get_Custom_PropClearFlagsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 844 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function mftCall_iifff(i5, i1, d2, d3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iifff[i5 - fb & 1](i1 | 0, Math_fround(d2), Math_fround(d3), Math_fround(d4)) | 0;
 return ftCall_iifff(i5 | 0, i1 | 0, +d2, +d3, +d4) | 0;
}

function _symlink(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall83(83, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _setpgid(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall57(57, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _mlock(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall150(150, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _lstat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall196(196, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _drand48() {
 var i1 = 0, i2 = 0;
 i2 = ___rand48_step(gb + 228072 | 0, gb + 228072 + 6 | 0) | 0;
 i2 = _bitshift64Shl(i2 | 0, getTempRet0() | 0, 4) | 0;
 i1 = getTempRet0() | 0 | 1072693248;
 HEAP32[tempDoublePtr >> 2] = i2;
 HEAP32[tempDoublePtr + 4 >> 2] = i1;
 return +(+HEAPF64[tempDoublePtr >> 3] + -1.0);
}

function _cf2_hintmap_init(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _memset(i1 + 4 + 8 | 0, 0, 3856) | 0;
 HEAP8[i1 + 13 >> 0] = HEAP8[i2 + 140 >> 0] | 0;
 HEAP32[i1 + 16 >> 2] = i5;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 return;
}

function __ZNSt13exception_ptraSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i3 | 0)) {
  ___cxa_increment_exception_refcount(i3 | 0);
  ___cxa_decrement_exception_refcount(HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 }
 return i1 | 0;
}

function __ZNK5physx27PxClothGeodesicTetherCooker13getTetherDataEPjPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 _memcpy(i2 | 0, HEAP32[i1 + 84 >> 2] | 0, HEAP32[i1 + 88 >> 2] << 2 | 0) | 0;
 _memcpy(i3 | 0, HEAP32[i1 + 96 >> 2] | 0, HEAP32[i1 + 100 >> 2] << 2 | 0) | 0;
 return;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZNK19TextRenderingModule29TMGenGetCursorIndexAtPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfERK8Vector2f(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN20TextRenderingPrivate17TextMeshGenerator24GetCursorIndexAtPositionERK5RectTIfERK8Vector2f(i2, i3, i4) | 0;
}

function __ZNK15b2RevoluteJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i2 + 84 >> 2]);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 88 >> 2]) * f3);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN8UVModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 272 | 0, i2);
 return;
}

function __ZN8DateTime14GetDaysInMonthEi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 12:
 case 10:
 case 8:
 case 7:
 case 5:
 case 3:
 case 1:
  {
   i1 = 31;
   break;
  }
 case 11:
 case 9:
 case 6:
 case 4:
  {
   i1 = 30;
   break;
  }
 case 2:
  {
   i1 = 28;
   break;
  }
 default:
  i1 = -1;
 }
 return i1 | 0;
}

function __ZN7ApiGLES17BindUniformBufferEjj(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 916 + (i3 << 2) | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 mftCall_viii(HEAP32[i2 + 652 >> 2] | 0, 35345, i3 | 0, i4 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) return;
 __ZN5physx3Scb14ParticleSystem16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE(i3 + 20 | 0, i2, i1);
 return;
}

function __ZN4FMOD4DSPI15getSystemObjectEPPNS_6SystemE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 862473;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN19SkinnedMeshRenderer22SetUpdateWhenOffscreenEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 464 >> 0] = i1 & 1;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 __ZN8Renderer18UpdateManagerStateEb(i2, i1);
 __ZN8Renderer13BoundsChangedEv(i2);
 return;
}

function __ZN14Texture2DArray19AllocateTextureDataEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 411289 | 0, 134) | 0;
 if (!((i1 | 0) != 0 & i3)) return i1 | 0;
 _memset(i1 | 0, -1, i2 | 0) | 0;
 return i1 | 0;
}

function __ZN14BoxCast2DQueryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 156124 + 8;
 i2 = i1 + 340 | 0;
 if ((HEAP32[i1 + 356 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 344 | 0);
  HEAP32[i2 >> 2] = 0;
 }
 __ZN16b2BlockAllocatorD2Ev(i1 + 268 | 0);
 return;
}

function __ZN13EmscriptenWWWD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 25328 + 8;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2 | 0) _free(i2);
 _JS_WebRequest_Release(HEAP32[i1 + 80 >> 2] | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 100 | 0);
 __ZN3WWWD2Ev(i1);
 return;
}

function __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN10HumanTrait4Body13GetMuscleNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZN7mecanim5human10MuscleNameEj(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function __ZL28InitializeAIScriptingClassesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(4, gb + 63728 | 0, 16, gb + 849930 | 0, 16) | 0;
 HEAP32[gb + 1459868 >> 2] = i1;
 i1 = __Z12OptionalTypePKcS0_S0_(gb + 1049781 | 0, gb + 850049 | 0, gb + 850064 | 0) | 0;
 HEAP32[HEAP32[gb + 1459868 >> 2] >> 2] = i1;
 return;
}

function __Z40GUIStyle_CUSTOM_Internal_CalcMinMaxWidth13Il2Cpp_IntPtrP12Il2CppObjectPfS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZNK8GUIStyle15CalcMinMaxWidthER10GUIContentPfS2_(i1, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0, i3, i4);
 return;
}

function __Z32TextMesh_Get_Custom_PropFontSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 72 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32LODGroup_Get_Custom_PropFadeModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 48 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32GUIText_Get_Custom_PropFontStyleP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 80 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z32GUIText_Get_Custom_PropAlignmentP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 52 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Camera_Get_Custom_PropEventMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 884 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z23AudioSource_CUSTOM_StopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN11AudioSource4StopEb(i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI9JSONWriteLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWrite4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18GetEternalGUIStatev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1468876 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63864 | 0, 16, gb + 1018102 | 0, 94) | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 1;
 HEAP32[gb + 1468876 >> 2] = i1;
 return i1 | 0;
}

function _UTF16String_TakeOverPreAllocatedUTF16Bytes(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 8 | 0;
 if (HEAP8[i4 >> 0] | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP8[i4 >> 0] = 1;
 return;
}

function _stat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall195(195, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _rename(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall38(38, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _jpeg_abort(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[i1 + 36 >> 2] | 0, i2 | 0, 1);
 i1 = i2 + 20 | 0;
 if (!(HEAP8[i2 + 16 >> 0] | 0)) {
  HEAP32[i1 >> 2] = 100;
  return;
 } else {
  HEAP32[i1 >> 2] = 200;
  HEAP32[i2 + 268 >> 2] = 0;
  return;
 }
}

function _access(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall33(33, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function ___cxx_global_var_init4() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __Z6simd4iiiii(i2, 0, 0, 0, -1);
 __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E(gb + 1097792 | 0, i2);
 STACKTOP = i1;
 return;
}

function ___cxx_global_var_init3() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __Z6simd4iiiii(i2, 0, 0, -1, 0);
 __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E(gb + 1097808 | 0, i2);
 STACKTOP = i1;
 return;
}

function ___cxx_global_var_init2() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 __Z6simd4iiiii(i2, -1, 0, 0, 0);
 __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E(gb + 1097824 | 0, i2);
 STACKTOP = i1;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateResetInputAxisstruct7ForwardEv() {
 var i1 = 0;
 i1 = __ZN12InputManager17GetTextFieldInputEv(__Z15GetInputManagerv() | 0) | 0;
 if (!(i1 & (HEAP8[gb + 1548963 >> 0] | 0) == 0)) return;
 __ZN12InputManager14ResetInputAxesEv(__Z15GetInputManagerv() | 0);
 return;
}

function __ZNSt3__25ctypeIcE21__classic_upper_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(fb + 316 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNSt3__25ctypeIcE21__classic_lower_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(fb + 315 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNK5Umbra4Tome15getObjectUserIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 76 >> 2] | 0;
 if ((i3 | 0) != 0 & (i1 + i3 | 0) != 0) {
  i3 = -1;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 80 >> 2] | 0;
 i3 = HEAP32[((i3 | 0) == 0 ? 0 : i1 + i3 | 0) + (i2 << 2) >> 2] | 0;
 return i3 | 0;
}

function __ZNK25UnityWebRequestJavaScript19GetDownloadProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(Math_fround((HEAP32[i1 + 32 >> 2] | 0) >>> 0) / Math_fround(i2 >>> 0));
 return Math_fround(f3);
}

function __ZN9Scripting22RaiseSecurityExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi(gb + 466116 | 0, gb + 466132 | 0, i1, i3);
}

function __ZN9Animation6RewindEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 104 >> 2] | 0;
 i2 = i2 + 108 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  __ZN14AnimationState7SetTimeEf(HEAP32[i1 >> 2] | 0, Math_fround(0.0));
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN8Scalar4fC2Ebbbb(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = ~((i3 ^ 1) << 31 >> 31);
 HEAP32[i1 + 4 >> 2] = ~((i4 ^ 1) << 31 >> 31);
 HEAP32[i1 + 8 >> 2] = ~((i5 ^ 1) << 31 >> 31);
 HEAP32[i1 + 12 >> 2] = ~((i2 ^ 1) << 31 >> 31);
 return;
}

function __ZN6b2Body16SetFixedRotationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i4 = HEAPU16[i3 >> 1] | 0;
 if (!((i4 & 16 | 0) != 0 ^ i2)) return;
 HEAP16[i3 >> 1] = i2 ? i4 | 16 : i4 & 65519;
 HEAPF32[i1 + 72 >> 2] = Math_fround(0.0);
 __ZN6b2Body13ResetMassDataEv(i1);
 return;
}

function __ZN5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = __ZN5physx5cloth8allocateEj(116) | 0;
 __ZN5physx5cloth8SwSolverC2EPNS_13PxProfileZoneEPNS_13PxTaskManagerE(i3, i1, i2);
 return ((i3 | 0) == 0 ? 0 : i3 + 4 | 0) | 0;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx2Sn5ConvX17checkPaddingBytesEPKci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 L1 : do if ((i3 | 0) > 0) {
  i1 = 0;
  do {
   if ((HEAP8[i2 + i1 >> 0] | 0) != -51) break L1;
   i1 = i1 + 1 | 0;
  } while ((i1 | 0) < (i3 | 0));
 } else i1 = 0; while (0);
 return (i1 | 0) == (i3 | 0) | 0;
}

function __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = (__ZNK5physx2Sc9RigidCore10getPxActorEv(i1 + 16 | 0) | 0) + 20 | 0;
 i2 = HEAP16[i1 + 4 >> 1] | 0;
 if (i2 << 16 >> 16 != 1) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 >> 2] = i1;
 return i2 & 65535 | 0;
}

function __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5physx14PxRigidBodyExt13addForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb(i1, i2, i4, i3, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb(i1, i2, i4, i3, i5);
 return;
}

function __ZN5Unity5Joint7SetAxisERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 64 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, 1);
 return;
}

function __ZN5Unity17ConfigurableJoint17SetProjectionModeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 276 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint17SetAngularZMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 116 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint17SetAngularYMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 112 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint17SetAngularXMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 108 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN29UnityWebRequestAsyncOperationC2EP15UnityWebRequest(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 188044 + 8;
 HEAP32[i1 + 24 >> 2] = i2;
 i2 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN14PhysicsManager7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction(i1, i2, f3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5Unity12PhysicsQuery7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction(0, i2, f3, i4, i5, i6) | 0;
}

function __ZN13AnimationClip9GetLengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 __ZN13AnimationClip8GetRangeEv(i4, i1);
 f3 = Math_fround(HEAPF32[i4 + 4 >> 2]);
 STACKTOP = i2;
 return Math_fround(f3);
}

function __ZN12_GLOBAL__N_16ParserILb1EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 150932 + 8;
 HEAP32[i2 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN12_GLOBAL__N_16ParserILb0EED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 151008 + 8;
 HEAP32[i2 + 8 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 20 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZL21InitializeCachedStripPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = 0;
 do {
  i2 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63160 | 0, 16, gb + 930529 | 0, 31) | 0;
  HEAP32[i2 >> 2] = 0;
  HEAP32[i2 + 4 >> 2] = 0;
  HEAP32[gb + 1467184 + (i1 << 2) >> 2] = i2;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 16);
 return;
}

function __ZL16term_destinationP20jpeg_compress_struct(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 i2 = (HEAP32[i1 + 24 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP32[i1 + 28 >> 2] = i2;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 return;
}

function __Z43LightmapSettings_Set_Custom_PropLightProbesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z19GetLightmapSettingsv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN16LightmapSettings14SetLightProbesEP11LightProbes(i2, i1);
 return;
}

function __Z35getPxVehicleDriveSimData_ClutchDataPKN5physx21PxVehicleDriveSimDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 256 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z32TextMesh_Get_Custom_PropRichTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 84 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Texture_Get_Custom_PropWrapModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 44 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Texture3D_Get_Custom_PropFormatP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31OffMeshLink_Get_Custom_PropAreaP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 88 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31GameObject_Get_Custom_PropLayerP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 48 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31GUIText_Get_Custom_PropFontSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 76 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z16ReadConditionalyPPiRP19ProfilerInformationb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i4 + 4;
 if (!(HEAP32[i4 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = __ZN17ProfilerFrameData30DeserializeProfilerInformationEPPib(i1, i3) | 0;
 return;
}

function _UNITY_png_set_pHYs(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 HEAP32[i2 + 184 >> 2] = i3;
 HEAP32[i2 + 188 >> 2] = i4;
 HEAP8[i2 + 192 >> 0] = i5;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 128;
 return;
}

function _UNITY_png_set_oFFs(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 HEAP32[i2 + 172 >> 2] = i3;
 HEAP32[i2 + 176 >> 2] = i4;
 HEAP8[i2 + 180 >> 0] = i5;
 i5 = i2 + 8 | 0;
 HEAP32[i5 >> 2] = HEAP32[i5 >> 2] | 256;
 return;
}

function _UNITY_png_malloc_warn(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!((i1 | 0) == 0 | (i2 | 0) == 0)) {
  i3 = HEAP32[i1 + 608 >> 2] | 0;
  if (!i3) i1 = _malloc(i2) | 0; else i1 = mftCall_iii(i3 | 0, i1 | 0, i2 | 0) | 0;
  if (i1 | 0) {
   i3 = i1;
   return i3 | 0;
  }
 }
 i3 = 0;
 return i3 | 0;
}

function mftCall_vffff(i5, d1, d2, d3, d4) {
 i5 = i5 | 0;
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_vffff[i5 - fb & 7](Math_fround(d1), Math_fround(d2), Math_fround(d3), Math_fround(d4));
  return;
 }
 ftCall_vffff(i5 | 0, +d1, +d2, +d3, +d4);
}

function _strsignal(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if ((i2 + -1 | 0) >>> 0 > 63 | (i2 | 0) == 0) i1 = gb + 1075341 | 0; else {
  i1 = gb + 1075341 | 0;
  do {
   do {
    i3 = i1;
    i1 = i1 + 1 | 0;
   } while ((HEAP8[i3 >> 0] | 0) != 0);
   i2 = i2 + -1 | 0;
  } while ((i2 | 0) != 0);
 }
 return i1 | 0;
}

function _mkdir(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall39(39, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _gcvt(d1, i2, i3) {
 d1 = +d1;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 HEAPF64[i5 + 8 >> 3] = d1;
 _sprintf(i3, gb + 1075336 | 0, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _chmod(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall15(15, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZThn8_N5physx3Cct13BoxControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__25mutex8try_lockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __THREW__ = 0;
 i1 = invoke_ii(fb + 2810 | 0, i1 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return (i1 | 0) == 0 | 0;
 return 0;
}

function __ZNKSt3__27collateIwE7do_hashEPKwS3_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i2 = 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i4 = (HEAP32[i1 >> 2] | 0) + (i2 << 4) | 0;
  i5 = i4 & -268435456;
  i2 = (i5 >>> 24 | i5) ^ i4;
  i1 = i1 + 4 | 0;
 }
 return i2 | 0;
}

function __ZNK5physx5cloth8SwSolver8endFrameEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 72 >> 2] | 0;
 if (!i1) return;
 i3 = i1 + 8 | 0;
 i1 = i2;
 mftCall_viiiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, HEAP16[i2 + 76 >> 1] | 0, i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, i1 | 0);
 return;
}

function __ZNK11b2WeldJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0, f5 = f0;
 f5 = Math_fround(HEAPF32[i2 + 104 >> 2]);
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 108 >> 2]) * f3);
 HEAPF32[i1 >> 2] = Math_fround(f5 * f3);
 HEAPF32[i1 + 4 >> 2] = f4;
 return;
}

function __ZN9ShaderLab10GrabPassesC2E10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i1 + 12;
 return;
}

function __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7ApiGLES11BindProgramEjb(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 868 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i2 + 872 >> 2] = i4 & 1;
 mftCall_vi(HEAP32[i2 + 516 >> 2] | 0, i3 | 0);
 return;
}

function __ZN6b2Rope8SetAngleEf(i1, f3) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 var i2 = 0, i4 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i4 = i2 + -2 | 0;
 if ((i2 | 0) <= 2) return;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = 0;
 do {
  HEAPF32[i2 + (i1 << 2) >> 2] = f3;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i4 | 0));
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc8RigidSim25notifyShapeTranformChangeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) return;
 do {
  if (0 == 0 ? (HEAP32[i1 + 12 >> 2] & -1073741824 | 0) == 0 : 0) __ZN5physx2Sc8ShapeSim17onTransformChangeEv(i1);
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5Umbra16LineSegmentQueryC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 1;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN37InheritVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 if (i3 | 0) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i2 + 872 >> 2] | 0) + 92 >> 2]);
 return Math_fround(f4);
}

function __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 i3 = i2 + 4 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN19CharacterController12SetIsTriggerEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1) {
  if (!i2) i1 = 0; else i1 = HEAP32[i2 + 4 >> 2] | 0;
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 734357 | 0, 0, gb + 734039 | 0, 712, 1, i1, 0, 0);
 }
 HEAP8[i2 + 40 >> 0] = 0;
 return;
}

function __ZN17SurfaceEffector2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN10Effector2D5ResetEv(i1);
 HEAPF32[i1 + 92 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(.100000001);
 HEAP8[i1 + 104 >> 0] = 0;
 HEAP8[i1 + 105 >> 0] = 1;
 HEAP8[i1 + 106 >> 0] = 1;
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[i1 + 160 >> 0] | 0)) return;
 i2 = i1 + 80 | 0;
 HEAP8[i1 + 84 >> 0] = (HEAP32[i2 >> 2] | 0) != 0 & 1;
 HEAP32[i2 >> 2] = HEAP32[i1 + 88 >> 2];
 HEAP32[i1 + 72 >> 2] = HEAP32[i1 + 156 >> 2];
 return;
}

function __ZN16MemoryFileSystem9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i3 | 0, i4 | 0) | 0;
 return i4 | 0;
}

function __ZN15AnchoredJoint2D9SetAnchorERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN7Joint2D8ReCreateEb(i1, 0);
 return;
}

function __ZN13GfxTimerQueryD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77336 + 8;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 8 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner4lockEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0)) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 + 40 >> 2] | 0);
 HEAP8[i1 + 60 >> 0] = 1;
 return i1 + 8 | 0;
}

function __ZN12CubemapArray19AllocateTextureDataEib(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 32, gb + 63272 | 0, 0, gb + 397053 | 0, 133) | 0;
 if (!((i1 | 0) != 0 & i3)) return i1 | 0;
 _memset(i1 | 0, -1, i2 | 0) | 0;
 return i1 | 0;
}

function __ZN10SampleClip13LoadAudioDataEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return 1;
 __ZN10SampleClip13LoadBaseSoundEv(i1);
 if (HEAP8[i1 + 64 >> 0] | 0) return 1;
 __ZN12SoundManager20RegisterModifiedClipEP10SampleClip(__Z15GetSoundManagerv() | 0, i1);
 return 1;
}

function __ZN10AudioMixer11IsSuspendedEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = __ZN5audio5mixer11IsSuspendedERKNS0_16AudioMixerMemoryE(i1) | 0;
 return i1 | 0;
}

function __Z46RenderSettings_Set_Custom_PropCustomReflectionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z17GetRenderSettingsv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN14RenderSettings19SetCustomReflectionEP7Cubemap(i2, i1);
 return;
}

function __Z31GUIText_Get_Custom_PropRichTextP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 65 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z31Cloth_Get_Custom_PropUseGravityP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 45 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30Transform_CUSTOM_GetChildCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 92 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z30TextMesh_Get_Custom_PropAnchorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 58 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf(i1, i2, i3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye(i1, i2, i3, i4, f5, 0);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_png_get_sRGB(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 2048 | 0) != 0 : 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAPU16[i2 + 112 >> 1];
 i3 = 2048;
 return i3 | 0;
}

function _LzmaDec_Free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 + 4 | 0;
 i4 = i1 + 16 | 0;
 mftCall_vii(HEAP32[i3 >> 2] | 0, i2 | 0, HEAP32[i4 >> 2] | 0);
 HEAP32[i4 >> 2] = 0;
 i1 = i1 + 20 | 0;
 mftCall_vii(HEAP32[i3 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function mftCall_vifff(i5, i1, d2, d3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_vifff[i5 - fb & 15](i1 | 0, Math_fround(d2), Math_fround(d3), Math_fround(d4));
  return;
 }
 ftCall_vifff(i5 | 0, i1 | 0, +d2, +d3, +d4);
}

function mftCall_iiiff(i5, i1, i2, d3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiff[i5 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), Math_fround(d4)) | 0;
 return ftCall_iiiff(i5 | 0, i1 | 0, i2 | 0, +d3, +d4) | 0;
}

function mftCall_iiffi(i5, i1, d2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 0 | 0)) return FUNCTION_TABLE_iiffi[i5 - fb & 0](i1 | 0, Math_fround(d2), Math_fround(d3), i4 | 0) | 0;
 return ftCall_iiffi(i5 | 0, i1 | 0, +d2, +d3, i4 | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKcj(i1, i2, i3, _strlen(i3) | 0) | 0;
}

function __ZNKSt3__27collateIcE7do_hashEPKcS3_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i2 = 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  i4 = (HEAP8[i1 >> 0] | 0) + (i2 << 4) | 0;
  i5 = i4 & -268435456;
  i2 = (i5 >>> 24 | i5) ^ i4;
  i1 = i1 + 1 | 0;
 }
 return i2 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 return i3 + (i1 << 2) + -4 | 0;
}

function __ZNK8VRDevice19GetProjectionMatrixEPK6Camera21MonoOrStereoscopicEye(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNK8VRDevice38GetProjectionMatrixWithClippingOffsetsEPK6Camera21MonoOrStereoscopicEyeffR10Matrix4x4f(i2, i3, i4, Math_fround(0.0), Math_fround(0.0), i1);
 return;
}

function __ZNK5physx2Sc18ParticleSystemCore16getParticleCountEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK29LineParametersPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 HEAPF32[(HEAP32[((HEAP32[i1 + 4 >> 2] | 0) == 120 ? i2 + 344 | 0 : i2 + 384 | 0) >> 2] | 0) + 16 >> 2] = f3;
 return;
}

function __ZNK25UnityWebRequestJavaScript17GetUploadProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(0.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(Math_fround((HEAP32[i1 + 32 >> 2] | 0) >>> 0) / Math_fround(i2 >>> 0));
 return Math_fround(f3);
}

function __ZNK14ParticleSystem18GetStartRotation3DEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 44 >> 2] | 0;
 i3 = HEAP32[i4 + 1828 >> 2] | 0;
 i2 = HEAP32[i4 + 2092 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + 1564 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Transform8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Transform8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Texture3D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Texture3D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Texture2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Texture2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Rigidbody8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Rigidbody8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Projector8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Projector8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9LensFlare8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9LensFlare8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9GfxDevice13GetDynamicVBOEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4512 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 896 >> 2] | 0, i1 | 0) | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9AudioClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9AudioClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Animation8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN9Animation8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx9PxTaskMgr13getTaskFromIDEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 60 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i3 >> 2] | 0);
 i2 = HEAP32[(HEAP32[i2 + 76 >> 2] | 0) + (i1 * 20 | 0) >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i3 >> 2] | 0);
 return i2 | 0;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 368671 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN16Physics2DManager7RaycastERK3RayfiR12RaycastHit2D(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 return (__ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di(i1, i2, i2 + 12 | 0, f3, i4, 0, i5, 1) | 0) == 1 | 0;
}

function __ZN15NavMeshObstacle10SetExtentsERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 56 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = i1 + 136 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8;
 return;
}

function __ZN14StackAllocator12SetBlockSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 32 | 0;
 i3 = i1 + 36 | 0;
 HEAP32[i4 >> 2] = __ZN13MemoryManager18LowLevelReallocateEPvjj(HEAP32[i4 >> 2] | 0, i2, HEAP32[i3 >> 2] | 0) | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 return;
}

function __ZN13GfxDeviceGLES16SetAntiAliasFlagEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 718 >> 0] | 0)) return;
 i1 = i1 + 4620 | 0;
 if (i2) {
  __ZN7ApiGLES6EnableEN2gl10EnabledCapE(i1, 7);
  return;
 } else {
  __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i1, 7);
  return;
 }
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN12_GLOBAL__N_110DataStream11isConnectedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 392 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 388 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0) | 0;
 HEAP8[i1 >> 0] = i2 & 1;
 return i2 | 0;
}

function __ZN12TextureInput10ClearImageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 16 >> 2] | 0, gb + 63184 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12PhysXRaycast7RaycastERK3Rayfi23QueryTriggerInteractionR10RaycastHit(i1, i2, f3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN5Unity12PhysicsQuery7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction(0, i2, f3, i6, i4, i5) | 0;
}

function __ZN12CachedWriter9InitWriteER15CacheWriterBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 i3 = i1 + 4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, 0, i3 | 0, i1 + 8 | 0);
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __Z40Physics_CUSTOM_INTERNAL_CALL_CheckSphereRK8Vector3ffi23QueryTriggerInteraction(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 return (__ZN14PhysicsManager10SphereTestERK8Vector3ffi23QueryTriggerInteraction(__Z17GetPhysicsManagerv() | 0, i1, f2, i3, i4) | 0) & 1 | 0;
}

function __Z32Input_Get_Custom_PropInputStringv() {
 var i1 = 0, i2 = 0, i3 = 0, i4 = 0;
 i2 = __Z15GetInputManagerv() | 0;
 i4 = i2 + 136 | 0;
 i1 = HEAP8[i4 + 11 >> 0] | 0;
 i3 = i1 << 24 >> 24 < 0;
 return __Z20scripting_string_newPKcj(i3 ? HEAP32[i4 >> 2] | 0 : i4, i3 ? HEAP32[i2 + 140 >> 2] | 0 : i1 & 255) | 0;
}

function __Z30Mesh_Get_Custom_PropIsReadableP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP8[i2 + 41 >> 0] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z29GUIText_Get_Custom_PropAnchorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP16[i2 + 54 >> 1] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z22Animator_CUSTOM_RebindP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN8Animator6RebindEb(i2, 1);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadyEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadxEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadtEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadsEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadjEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadiEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadhEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadfEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReaddEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __Z18Transfer_BlittableI14SafeBinaryReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadaEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, i2, i1);
 return;
}

function __GLOBAL__sub_I_runtime_allocator2_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1103860 | 0, gb + 365288 | 0, 19, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1103872 | 0, gb + 365302 | 0, 19, 2);
 return;
}

function _sockatmark(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = (_ioctl(i1, 35077, i4) | 0) < 0;
 STACKTOP = i2;
 return (i1 ? -1 : HEAP32[i3 >> 2] | 0) | 0;
}

function _sleep(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 0;
 i1 = (_nanosleep(i3 | 0, i3 | 0) | 0) == 0;
 STACKTOP = i2;
 return (i1 ? 0 : HEAP32[i3 >> 2] | 0) | 0;
}

function _fill_fopen_filefunc(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 335;
 HEAP32[i1 + 4 >> 2] = fb + 138;
 HEAP32[i1 + 8 >> 2] = fb + 139;
 HEAP32[i1 + 12 >> 2] = fb + 514;
 HEAP32[i1 + 16 >> 2] = fb + 140;
 HEAP32[i1 + 20 >> 2] = fb + 515;
 HEAP32[i1 + 24 >> 2] = fb + 516;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZNSt3__27promiseIvEC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = __Znwj(92) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = gb + 208172 + 8;
 i3 = i2 + 8 | 0;
 i4 = i3 + 84 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 return i3 + (i1 << 2) + -4 | 0;
}

function __ZNK9AudioClip12GetSoundSizeEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZNK14SoundHandleAPI13GetMemoryInfoEb(i1, 1) | 0;
 return i1 | 0;
}

function __ZNK7ApiGLES3GetEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = 0;
 mftCall_vii(HEAP32[i1 + 88 >> 2] | 0, i2 | 0, i4 | 0);
 STACKTOP = i3;
 return HEAP32[i4 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Gu15HeightFieldUtil27getFaceIndexAtTriangleIndexEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 >>> 1;
 i1 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 36 >> 2] | 0;
 return ((HEAP8[((i2 & 1 | 0) == 0 ? i1 + (i3 << 2) + 2 | 0 : i1 + (i3 << 2) + 3 | 0) >> 0] & 127) != 127 ? i2 : -1) | 0;
}

function __ZNK21EnlightenSceneMapping16GetRenderersSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) < 0) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 32 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + (i2 * 56 | 0) + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZNK13MonoBehaviour6GetDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z9GetIAudiov() | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 144 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZNK12StatusHelper10IsCompleteEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = i1 & -2;
 L1 : do if ((i1 + -300 | 0) >>> 0 < 8) {
  switch (i1 | 0) {
  case 304:
  case 306:
   break L1;
  default:
   i1 = 0;
  }
  return i1 | 0;
 } while (0);
 i2 = (i2 | 0) != 100;
 return i2 | 0;
}

function __ZNK12CachedWriter11GetPositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[i1 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i3 + (Math_imul(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0, i2) | 0) | 0;
}

function __ZN7b2World11ClearForcesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 102956 >> 2] | 0;
 if (!i1) return;
 do {
  HEAPF32[i1 + 76 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 80 >> 2] = Math_fround(0.0);
  HEAPF32[i1 + 84 >> 2] = Math_fround(0.0);
  i1 = HEAP32[i1 + 96 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN5physx2Sn18checkCompatibilityEjj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 switch (i2 | 0) {
 case 50529024:
  {
   if (!i1) i1 = 1; else i3 = 5;
   break;
  }
 case 50528512:
  {
   if (!i1) i1 = 1; else i3 = 5;
   break;
  }
 default:
  i3 = 5;
 }
 if ((i3 | 0) == 5) i1 = 0;
 return i1 | 0;
}

function __ZN5physx2Sc16InteractionScene8addActorERNS0_5ActorEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Actor9setActiveEbj(i2, i1, 1);
 if (i1) {
  __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE(i3, i2);
  return;
 } else {
  HEAP32[i2 + 40 >> 2] = -2;
  return;
 }
}

function __ZN5physx23PxsBroadPhaseContextSap7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14NpRigidDynamicD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 98548 + 8;
 __ZN5physx2Sc8BodyCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx13NpRigidStaticD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 99820 + 8;
 __ZN5physx2Sc9RigidCoreD2Ev(i1 + 64 | 0);
 HEAP32[i1 >> 2] = gb + 99672 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx13IslandManagerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101648 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra15MemOutputStreamD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 78624 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 12 >> 2] | 0, i3 | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7SystemI19getSoftwareChannelsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869625;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI19getHardwareChannelsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869400;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI19getGeometrySettingsEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869380;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854979;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN36ExternalForcesModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 if (i3 | 0) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i2 + 880 >> 2] | 0) + 8 >> 2]);
 return Math_fround(f4);
}

function __ZN2UI6Canvas23ClearNestedCanvasDepthsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 424 >> 2] | 0;
 i2 = HEAP32[i2 + 428 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) return;
 do {
  HEAPF32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] = Math_fround(-1.0);
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN2UI15DoSyncTransformERNS_13UIInstructionERK10Matrix4x4f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 484 | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP16[i3 + 664 >> 1] = 2;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh7SetFontE4PPtrIN13TextRendering4FontEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 48 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i3 >> 2] = i1;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i2);
 return;
}

function __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 if (!i3) return;
 i1 = i1 + 16 | 0;
 if (!i4) __ZN12CachedReader4SkipEj(i1, i3); else __ZN12CachedReader4ReadEPvj(i1, i4, i3);
 __ZN12CachedReader10Align4ReadEv(i1);
 return;
}

function __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 if (!i3) return;
 i1 = i1 + 16 | 0;
 if (!i4) __ZN12CachedReader4SkipEj(i1, i3); else __ZN12CachedReader4ReadEPvj(i1, i4, i3);
 __ZN12CachedReader10Align4ReadEv(i1);
 return;
}

function __ZN17UniqueIDGenerator9DestroyIDE13UniqueSmallID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] & 16777215;
 i2 = i1 + 20 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + (i3 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777216 | HEAP32[i2 >> 2] & 16777215;
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[i1 + 64 >> 0] | 0)) return;
 i2 = i1 + 32 | 0;
 HEAP8[i1 + 36 >> 0] = (HEAP32[i2 >> 2] | 0) != 0 & 1;
 HEAP32[i2 >> 2] = HEAP32[i1 + 40 >> 2];
 HEAP32[i1 + 24 >> 2] = HEAP32[i1 + 60 >> 2];
 return;
}

function __ZN16PxOverflowBufferIN5physx10PxSweepHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[i1 + 128 >> 0] | 0)) return;
 i2 = i1 + 64 | 0;
 HEAP8[i1 + 68 >> 0] = (HEAP32[i2 >> 2] | 0) != 0 & 1;
 HEAP32[i2 >> 2] = HEAP32[i1 + 72 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i1 + 124 >> 2];
 return;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags(i2, HEAP32[gb + 67408 >> 2] | 0, gb + 368654 | 0, i1, 0);
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i2);
 return;
}

function __ZN14ParticleSystem13SetStartDelayEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 HEAPF32[i1 + 80 >> 2] = f2;
 HEAP8[i1 + 86 >> 0] = (__Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs(i1, i1 + 88 | 0, f2, HEAP16[i1 + 84 >> 1] | 0) | 0) & 1;
 return;
}

function __ZN12NavMeshAgent17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) != -1) __ZN7dtCrowd11removeAgentER13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0);
 __ZN14NavMeshManager15UnregisterAgentERi(__Z17GetNavMeshManagerv() | 0, i1 + 88 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService13SessionHeader5ResetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  i2 = HEAP32[i1 >> 2] | 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP8[i2 >> 0] = 0;
  return;
 } else {
  HEAP8[i2 >> 0] = 0;
  i2 = i1;
  HEAP8[i2 >> 0] = 0;
  return;
 }
}

function __ZN10TagManager29GetSortingLayerIndexFromValueEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAP32[i2 + 1080 >> 2] | 0) + i1 | 0;
 if ((i1 | 0) >= 0) if ((i1 | 0) < (((HEAP32[i2 + 1072 >> 2] | 0) - (HEAP32[i2 + 1068 >> 2] | 0) | 0) / 40 | 0 | 0)) {
  i2 = i1;
  return i2 | 0;
 }
 i2 = 0;
 return i2 | 0;
}

function __ZN10MemoryPool8AllocateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = i2 + 32 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) {
  __ZN10MemoryPool14AllocNewBubbleEv(i2);
  i1 = HEAP32[i3 >> 2] | 0;
  if (!i1) {
   i3 = 0;
   return i3 | 0;
  }
 }
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 i3 = i1;
 return i3 | 0;
}

function __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f(i3, i1);
 HEAP32[i1 + 48 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 52 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 56 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewStringUTFP12Il2CppStringRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z28WindZone_Get_Custom_PropModeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function __Z28Font_Get_Custom_PropFontSizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) return HEAP32[i2 + 36 >> 2] | 0;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
 return 0;
}

function _UNITY_png_set_alpha_mode(i2, i3, d1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 d1 = +d1;
 d1 = +Math_floor(+((d1 > 0.0 & d1 < 128.0 ? d1 * 1.0e5 : d1) + .5));
 if (d1 > 2147483647.0 | d1 < -2147483647.0) _UNITY_png_fixed_error(i2, gb + 354019 | 0); else {
  _UNITY_png_set_alpha_mode_fixed(i2, i3, ~~d1);
  return;
 }
}

function mftCall_iiiii(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 255 | 0)) return FUNCTION_TABLE_iiiii[i5 - fb & 255](i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
 return ftCall_iiiii(i5 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function _tcgetpgrp(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = (_ioctl(i1, 21519, i4) | 0) < 0;
 STACKTOP = i2;
 return (i1 ? -1 : HEAP32[i3 >> 2] | 0) | 0;
}

function _raccess_guess_linux_cap(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = _raccess_make_file_name(HEAP32[i1 >> 2] | 0, i3, gb + 947047 | 0) | 0;
 if (!i1) {
  i5 = 64;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i5 = 0;
 return i5 | 0;
}

function _link(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = ___syscall_ret(___syscall9(9, i4 | 0) | 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _erand48(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = ___rand48_step(i1, gb + 228072 + 6 | 0) | 0;
 i2 = _bitshift64Shl(i2 | 0, getTempRet0() | 0, 4) | 0;
 i1 = getTempRet0() | 0 | 1072693248;
 HEAP32[tempDoublePtr >> 2] = i2;
 HEAP32[tempDoublePtr + 4 >> 2] = i1;
 return +(+HEAPF64[tempDoublePtr >> 3] + -1.0);
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -116 | 0;
 i2 = HEAP32[i1 + 140 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8in_availEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) i1 = i3 - i2 >> 2; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK22VirtualJoystickManager24GetPhysicalJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i2);
 return;
}

function __ZNK14ParticleSystem11GetNumTilesERiS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 1;
 HEAP32[i2 >> 2] = 1;
 i1 = HEAP32[i1 + 864 >> 2] | 0;
 if (!(HEAP8[i1 + 4 >> 0] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[i1 + 536 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i1 + 540 >> 2];
 return;
}

function __ZNK13AnimationClip18GetAverageDurationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 216 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 1068 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[i1 + 1064 >> 2]));
 return Math_fround(f2);
}

function __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((HEAP32[i2 + 4 >> 2] | 0) == (i3 | 0)) {
  i1 = i2 + 28 | 0;
  if ((HEAP32[i1 >> 2] | 0) != 1) HEAP32[i1 >> 2] = i4;
 }
 return;
}

function __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8WindZone8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8WindZone8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Renderer15SetSortingOrderEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 336 | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 if ((i4 & 65535) << 16 >> 16 == i2 << 16 >> 16) return;
 HEAP16[i3 >> 1] = i2;
 HEAP32[i1 + 220 >> 2] = i4 & -65536 ^ -2147483648 | (i2 << 16 >> 16) + 32768;
 return;
}

function __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Material8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Material8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8LODGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8LODGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Animator8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN8Animator8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Object24RegisterInstanceIDNoLockEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) + 24 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 2097151 | i3 << 21;
 __ZN6Object17InsertObjectInMapEPS_(i1);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Cct26CharacterControllerManagerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Cct26CharacterControllerManagerD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD7SystemI19setHardwareChannelsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869856;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI10getDSPHeadEPPNS_3DSPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 857610;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI14disconnectFromEPNS_3DSPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868757;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854655;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN22ParticleSystemRenderer21RendererBecameVisibleEv(i1) {
 i1 = i1 | 0;
 __ZN8Renderer21RendererBecameVisibleEv(i1);
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 80300 | 0) | 0;
 if (!i1) return;
 __ZN14ParticleSystem21RendererBecameVisibleEv(i1);
 return;
}

function __ZN22LocalFileSystemHandler16CurrentDirectoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _strlen(gb + 1546878 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1546878 | 0, i2);
 return;
}

function __ZN15TerrainCollider14SetTerrainDataE4PPtrI11TerrainDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 60 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i3 >> 2] = i1;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0);
 return;
}

function __ZN15NavMeshObstacle9SetCenterERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i3 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i3 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 i2 = i1 + 136 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8;
 return;
}

function __ZN15DirectorManager24ConstructPlayableOfClassEP11Il2CppClass(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(56, gb + 63784 | 0, 16, gb + 582681 | 0, 899) | 0;
 __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i3, 0, 3);
 __ZN8Playable6HandleEv(i1, i3);
 return;
}

function __ZN14BoxCast2DQuery19InitializeCastShapeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = i1 + 372 | 0;
 f3 = Math_fround(Math_fround(HEAPF32[i1 + 524 >> 2]) * Math_fround(.5));
 __ZN14b2PolygonShape8SetAsBoxEff(i2, f3, Math_fround(Math_fround(HEAPF32[i1 + 528 >> 2]) * Math_fround(.5)));
 return i2 | 0;
}

function __ZN12InputManager15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63528 | 0, 16, gb + 441167 | 0, 894) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1161932 >> 2] = i1;
 __Z19SetupKeyNameMappingv();
 return;
}

function __ZN12FileAccessor5CloseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP8[i1 + 1064 >> 0] | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i1 + 4 | 0) | 0;
 return i2 | 0;
}

function __ZN10HumanTrait4Body11GetBoneNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZN7mecanim5human8BoneNameEj(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function __Z43setPxVehicleWheelsSimData_WheelEnabledStatePN5physx22PxVehicleWheelsSimDataEjb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if (i3) {
  __ZN5physx22PxVehicleWheelsSimData11enableWheelEj(i2, i1);
  return;
 } else {
  __ZN5physx22PxVehicleWheelsSimData12disableWheelEj(i2, i1);
  return;
 }
}

function __Z12StringToGUIDRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP8[i2 + 11 >> 0] | 0;
 i4 = i3 << 24 >> 24 < 0;
 __Z12StringToGUIDPKcj(i1, i4 ? HEAP32[i2 >> 2] | 0 : i2, i4 ? HEAP32[i2 + 4 >> 2] | 0 : i3 & 255);
 return;
}

function _UNITY_png_get_y_offset_inches_fixed(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) != 0 & (i1 | 0) != 0) if (!(HEAP32[i1 + 8 >> 2] & 256)) i1 = 0; else if ((HEAP8[i1 + 180 >> 0] | 0) == 1) i1 = HEAP32[i1 + 176 >> 2] | 0; else i1 = 0; else i1 = 0;
 return _UNITY_png_muldiv_warn(i2, i1, 500, 127) | 0;
}

function _UNITY_png_get_x_offset_inches_fixed(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) != 0 & (i1 | 0) != 0) if (!(HEAP32[i1 + 8 >> 2] & 256)) i1 = 0; else if ((HEAP8[i1 + 180 >> 0] | 0) == 1) i1 = HEAP32[i1 + 172 >> 2] | 0; else i1 = 0; else i1 = 0;
 return _UNITY_png_muldiv_warn(i2, i1, 500, 127) | 0;
}

function mftCall_iiiif(i5, i1, i2, i3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iiiif[i5 - fb & 3](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4)) | 0;
 return ftCall_iiiif(i5 | 0, i1 | 0, i2 | 0, i3 | 0, +d4) | 0;
}

function mftCall_iiifi(i5, i1, i2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiifi[i5 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0) | 0;
 return ftCall_iiifi(i5 | 0, i1 | 0, i2 | 0, +d3, i4 | 0) | 0;
}

function mftCall_iifii(i5, i1, d2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) return FUNCTION_TABLE_iifii[i5 - fb & 3](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0) | 0;
 return ftCall_iifii(i5 | 0, i1 | 0, +d2, i3 | 0, i4 | 0) | 0;
}

function _tcgetsid(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i2;
 i3 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = i3;
 i1 = (_ioctl(i1, 21545, i4) | 0) < 0;
 STACKTOP = i2;
 return (i1 ? -1 : HEAP32[i3 >> 2] | 0) | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8in_availEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (i2 >>> 0 < i3 >>> 0) i1 = i3 - i2 | 0; else i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 20 | 0;
 __ZN5physx2Sc10NPhaseCore33releaseActorPairContactReportDataEPNS0_26ActorPairContactReportDataE(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 1104 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZNK5physx14NpArticulation26getInternalDriveIterationsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] & 1)) {
  i1 = __ZNK5physx2Sc16ArticulationCore26getInternalDriveIterationsEv(i1 + 24 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[HEAP32[i1 + 20 >> 2] >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK29UnityWebRequestAsyncOperation7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63808 | 0);
 return;
}

function __ZNK10SampleClip12GetLoadStateEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = __ZNK14SoundHandleAPI12GetLoadStateEv(i1) | 0;
 return i1 | 0;
}

function __ZN9GfxDevice20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx7NpScene18setSolverBatchSizeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(HEAP8[i2 + 2449 >> 0] | 0)) {
  __ZN5physx2Sc5Scene18setSolverBatchSizeEj(i2 + 32 | 0, i1);
  return;
 } else {
  HEAP32[i2 + 3368 >> 2] = i1;
  i2 = i2 + 3388 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 16;
  return;
 }
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ERKS5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 __ZN8Scalar4fC2ERKS_(i2, i1);
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sc9ShapeCore23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx2Sc9ClothCore23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 44 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx2Sc7BodySim10onActivateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP8[i1 + 50 >> 0] | 0) == 4) return;
 i2 = (HEAP32[i1 + 52 >> 2] | 0) + 45 | 0;
 HEAP8[i2 >> 0] = HEAPU8[i2 >> 0] & 254;
 __ZN5physx2Sc5Scene12onBodyWakeUpEPNS0_7BodySimE(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0, i1);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 16 >> 2] | 0; else i1 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeJointFramesERKNS_11PxTransformES4_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Cm20visualizeJointFramesERNS0_12RenderOutputEfRKNS_11PxTransformES5_(HEAP32[i3 + 12 >> 2] | 0, Math_fround(HEAPF32[i3 + 4 >> 2]), i2, i1);
 return;
}

function __ZN5physx21MBPPostUpdateWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx11NodeManagerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101688 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx11EdgeManagerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101668 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 __ZdlPv(i1);
 STACKTOP = i2;
 return;
}

function __ZN4FMOD7SystemI17getOutputByPluginEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869506;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI17getNumCDROMDrivesEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869474;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI17getNetworkTimeoutEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869456;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI17get3DNumListenersEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869267;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI7getTypeEP13FMOD_DSP_TYPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868849;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN23MeshVertexFormatManagerD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN21VRGlobalSettingsState15SaveGlobalStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[(__Z16GetScreenManagerv() | 0) + 40 >> 2] | 0;
 i2 = __Z16GetScreenManagerv() | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 >> 2] = i3 | 0 ? i3 : i2;
 return;
}

function __ZN15dtPathQueryInfo5purgeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
 __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15UniformTFMethodD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77360 + 8;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __ZN15NavMeshObstacle9SetRadiusEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = f2 > Math_fround(9.99999974e-06);
 f2 = i3 ? f2 : Math_fround(9.99999974e-06);
 HEAPF32[i1 + 56 >> 2] = f2;
 HEAPF32[i1 + 64 >> 2] = f2;
 i1 = i1 + 136 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 return;
}

function __ZN15NavMeshObstacle8SetShapeE20NavMeshObstacleShape(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 40 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 __ZN15NavMeshObstacle10FitExtentsEv(i1);
 i3 = i1 + 136 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 8;
 return;
}

function __ZN10GameObject15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63520 | 0, 16, gb + 368833 | 0, 1203) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[gb + 1104660 >> 2] = i1;
 return;
}

function __Z25GetProceduralMemoryBudget19ProceduralCacheSize(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 3:
  {
   i1 = 0;
   break;
  }
 case 2:
  {
   i1 = 536870912;
   break;
  }
 case 1:
  {
   i1 = 268435456;
   break;
  }
 case 0:
  {
   i1 = 134217728;
   break;
  }
 default:
  i1 = 1;
 }
 return i1 | 0;
}

function _UNITY_png_get_gAMA_fixed(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(i3 | 0 ? (HEAP16[i2 + 114 >> 1] & 1) != 0 : 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 40 >> 2];
 i3 = 1;
 return i3 | 0;
}

function _psh_globals_destroy(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 208 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = 0;
 HEAP32[i1 + 928 >> 2] = 0;
 HEAP32[i1 + 1444 >> 2] = 0;
 HEAP32[i1 + 1960 >> 2] = 0;
 _UNITY_ft_mem_free(i2, i1);
 return;
}

function _glTexImage3D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 _glTexImage3D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0, i10 | 0);
}

function _ft_raster1_get_cbox(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) return;
 _UNITY_FT_Outline_Get_CBox(i2 + 108 | 0, i3);
 return;
}

function _ft_outline_glyph_copy(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 20 | 0;
 i3 = i1 + 20 | 0;
 i1 = _UNITY_FT_Outline_New(HEAP32[i2 >> 2] | 0, HEAP16[i4 + 2 >> 1] | 0, HEAP16[i4 >> 1] | 0, i3) | 0;
 if (i1 | 0) return i1 | 0;
 _UNITY_FT_Outline_Copy(i4, i3) | 0;
 return i1 | 0;
}

function __ZThn8_N5physx19TriangleMeshBuilderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -8 | 0;
 __ZN5physx2Gu12TriangleMeshD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0;
 return HEAP8[(HEAP32[gb + 90260 + 24 + (((HEAP32[i1 + (i2 + 4) >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) + (i1 + i2) + 13 >> 0] | 0;
}

function __ZNK12NavMeshAgent11IsPathStaleEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK14dtPathCorridor11isPathStaleEv(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) | 0;
 return i1 | 0;
}

function __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN7Terrain8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN7Terrain8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5physx2Sc17ParticleSystemSim7endStepEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0);
 __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv(i1);
 __ZN5physx2Sc17ParticleSystemSim17updateRigidBodiesEv(i1);
 return;
}

function __ZN5physx2Cm10FanoutTask12addReferenceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 88 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 12 | 0) | 0;
 HEAP8[i1 + 84 >> 0] = 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN5physx29BroadPhaseBatchUpdateWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = 0;
 __ZN5physx23PxsBroadPhaseContextSap11batchUpdateEjRPNS_17PxcBroadPhasePairERjS4_(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, i1 + 28 | 0, i2, i1 + 36 | 0);
 return;
}

function __ZN4crnd25static_huffman_data_modelC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 __ZN4crnd25static_huffman_data_modelaSERKS0_(i1, i2) | 0;
 return;
}

function __ZN4FMOD7SystemI17setOutputByPluginEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869910;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI17setNetworkTimeoutEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869892;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI17set3DNumListenersEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869777;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI15setNetworkProxyEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869876;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI15getOutputHandleEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869524;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN16LightmapSettings14SetSceneHandleEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN21EnlightenSceneMapping14SetSceneHandleEi(i1 + 100 | 0, i2);
 __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE(i2, HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 36 + 12 >> 2] | 0, i1 + 56 | 0);
 return;
}

function __ZN13AudioProfiler17CaptureAudioClipsERNS_27AudioProfilerCaptureContextE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetSoundManagerv() | 0;
 __ZN12SoundManager19CaptureProfilerInfoER13dynamic_arrayI21AudioProfilerClipInfoLj4EERS0_IcLj1EE(i2, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN12GUIClipState22GetTopMostPhysicalRectEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i2 + 4 >> 2] | 0) + -56 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN12BaseRenderer11ClearProbesER10RenderNode(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 232 | 0;
 i3 = (HEAPU16[i2 >> 1] | 0 | (HEAPU8[i2 + 2 >> 0] | 0) << 16) & 16531455;
 HEAP16[i2 >> 1] = i3;
 HEAP8[i2 + 2 >> 0] = i3 >>> 16;
 HEAP16[i1 + 268 >> 1] = -1;
 HEAP16[i1 + 272 >> 1] = -1;
 return;
}

function __ZL21LibpngReadFuncWrapperP14png_struct_defPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _UNITY_png_get_io_ptr(i1) | 0;
 if ((mftCall_iiii(HEAP32[i4 + 4 >> 2] | 0, HEAP32[i4 >> 2] | 0, i2 | 0, i3 | 0) | 0) == (i3 | 0)) return; else _UNITY_png_error(i1, gb + 402106 | 0);
}

function __Z64RenderBufferHelper_CUSTOM_INTERNAL_CALL_GetNativeRenderBufferPtr13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 HEAP32[i2 >> 2] = mftCall_iii(HEAP32[(HEAP32[i3 >> 2] | 0) + 732 >> 2] | 0, i3 | 0, i1 | 0) | 0;
 return;
}

function __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_FindClassP12Il2CppStringRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 HEAP32[i2 >> 2] = 0;
 STACKTOP = i3;
 return;
}

function __Z35Physics_CUSTOM_INTERNAL_get_gravityP8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i4 = __Z17GetPhysicsManagerv() | 0;
 i3 = HEAP32[i4 + 36 >> 2] | 0;
 i2 = HEAP32[i4 + 40 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i4 + 32 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z22CreateMutexLockedQueuev() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63200 | 0, 16, gb + 487713 | 0, 6) | 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63200 | 0, 16, gb + 487790 | 0, 12) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i2;
 return i1 | 0;
}

function _UNITY_FT_Render_Glyph(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i3 = 6;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) {
  i3 = 6;
  return i3 | 0;
 }
 i3 = _UNITY_FT_Render_Glyph_Internal(HEAP32[(HEAP32[i3 + 96 >> 2] | 0) + 4 >> 2] | 0, i1, i2) | 0;
 return i3 | 0;
}

function mftCall_viiff(i5, i1, i2, d3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viiff[i5 - fb & 3](i1 | 0, i2 | 0, Math_fround(d3), Math_fround(d4));
  return;
 }
 ftCall_viiff(i5 | 0, i1 | 0, i2 | 0, +d3, +d4);
}

function mftCall_viffi(i5, i1, d2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viffi[i5 - fb & 3](i1 | 0, Math_fround(d2), Math_fround(d3), i4 | 0);
  return;
 }
 ftCall_viffi(i5 | 0, i1 | 0, +d2, +d3, i4 | 0);
}

function _unzGetFilePos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) {
  i2 = -102;
  return i2 | 0;
 }
 if (!(HEAP32[i1 + 56 >> 2] | 0)) {
  i2 = -100;
  return i2 | 0;
 }
 HEAP32[i2 >> 2] = HEAP32[i1 + 52 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 48 >> 2];
 i2 = 0;
 return i2 | 0;
}

function _swprintf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _vswprintf(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _strfmon(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _vstrfmon_l(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _snprintf(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i6 = i5;
 HEAP32[i6 >> 2] = i4;
 i4 = _vsnprintf(i1, i2, i3, i6) | 0;
 STACKTOP = i5;
 return i4 | 0;
}

function _ft_smooth_get_cbox(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 if ((HEAP32[i2 + 72 >> 2] | 0) != (HEAP32[i1 + 16 >> 2] | 0)) return;
 _UNITY_FT_Outline_Get_CBox(i2 + 108 | 0, i3);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED1Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + -4 | 0;
 HEAP32[i2 >> 2] = gb + 167452 + 8;
 HEAP32[i1 >> 2] = gb + 167452 + 424;
 __ZN5physx5cloth7SwClothD2Ev(i1 + 12 | 0);
 HEAP32[i2 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i2);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + -4 | 0;
 HEAP32[i2 >> 2] = gb + 167452 + 8;
 HEAP32[i1 >> 2] = gb + 167452 + 424;
 __ZN5physx5cloth7SwClothD2Ev(i1 + 12 | 0);
 HEAP32[i2 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i2);
 return;
}

function __ZNSt3__212future_errorC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 __ZNSt11logic_errorC2ERKS_(i1, i2);
 HEAP32[i1 >> 2] = gb + 208152 + 8;
 i4 = i2 + 8 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4cendEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 return i3 + (i1 << 2) | 0;
}

function __ZNKSt3__212__do_message7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strerror(i3) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i3, _strlen(i3) | 0);
 return;
}

function __ZNK7Texture41QueryPersistentManagerForDataAvailabilityEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 + 8 >> 2] & 1048576)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z20GetPersistentManagerv() | 0;
 i1 = __ZN17PersistentManager17IsObjectAvailableEi(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZN8VRDevice12GetAdapterIdEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 329 | 0;
 HEAP8[i2 >> 0] = 0;
 i1 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 272 >> 2] | 0;
 if (i1 | 0) {
  i1 = mftCall_i(i1 | 0) | 0;
  if (i1 | 0) {
   i2 = i1;
   return i2 | 0;
  }
 }
 HEAP8[i2 >> 0] = 1;
 i2 = 0;
 return i2 | 0;
}

function __ZN8JSONRead12EndMetaGroupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 164 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 i2 = i1 + 76 | 0;
 i3 = (HEAP32[i2 >> 2] | 0) + -1 | 0;
 HEAP32[i1 + 40 >> 2] = HEAP32[(HEAP32[i1 + 64 >> 2] | 0) + (i3 << 2) >> 2];
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx23ArticulationRootManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101628 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5Unity17ConfigurableJoint10SetZMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 104 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity17ConfigurableJoint10SetYMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 100 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity11AdjacenciesC2EPKtPKji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 __ZN5Unity11Adjacencies4InitEPKtPKji(i1, i2, i3, i4) | 0;
 return;
}

function __ZN5UmbramlERKNS_9Matrix3x3ES2_(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0, i5 = 0;
 i5 = i3;
 i2 = i5 + 36 | 0;
 do {
  HEAP32[i5 >> 2] = HEAP32[i1 >> 2];
  i5 = i5 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i5 | 0) < (i2 | 0));
 __ZN5Umbra9Matrix3x3mLERKS0_(i3, i4) | 0;
 return;
}

function __ZN5Umbra9IndexListC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5Umbra9FloatListC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5Umbra10VisibilityC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN4FMOD8ChannelI14getLowPassGainEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868553;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI16getNumSyncPointsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868998;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI9getPausedEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868227;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN24dtObstacleAvoidanceQueryC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 10452 >> 2] = 0;
 HEAP32[i1 + 10456 >> 2] = 0;
 HEAP32[i1 + 10460 >> 2] = 0;
 i1 = i1 + 10420 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN15ReflectionProbe17GetCachedRendererEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 168 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 i3 = __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe(HEAP32[gb + 1112272 >> 2] | 0, i1) | 0;
 HEAP32[i2 >> 2] = i3;
 return i3 | 0;
}

function __ZN14SerializedFile12FinalizeInitE24TransferInstructionFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 48 >> 2] = i2 | 256;
 HEAP8[i1 + 44 >> 0] = i2 >>> 9 & 1;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN14SerializedFile10ReadHeaderEv(i1) | 0;
 return i2 | 0;
}

function __ZN13TranslateGLES30InitRenderTextureFormat2FormatERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 2172 | 0;
 i2 = gb + 74496 | 0;
 i3 = i1 + 92 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __ZN12IFileAdapter5WriteER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function __ZN12AudioManager9SetVolumeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(HEAP32[i1 + 88 >> 2] | 0)) return;
 __ZN4FMOD12ChannelGroup9setVolumeEf(HEAP32[i1 + 100 >> 2] | 0, f2) | 0;
 __ZN4FMOD12ChannelGroup9setVolumeEf(HEAP32[i1 + 108 >> 2] | 0, f2) | 0;
 HEAPF32[i1 + 32 >> 2] = f2;
 return;
}

function __ZN12AudioManager14UpdateListenerERK8Vector3fS2_S2_S2_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) return;
 __ZN4FMOD6System23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_(i1, 0, i2, i3, i5, i4) | 0;
 return;
}

function __Z24RegisterModuleClasses_AIv() {
 __Z13RegisterClassI22NavMeshProjectSettingsEvv();
 __Z13RegisterClassI11NavMeshDataEvv();
 __Z13RegisterClassI12NavMeshAgentEvv();
 __Z13RegisterClassI15NavMeshSettingsEvv();
 __Z13RegisterClassI11OffMeshLinkEvv();
 __Z13RegisterClassI15NavMeshObstacleEvv();
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWriteyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritexEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritetEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritesEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritejEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWriteiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritehEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritefEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWritedEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI9JSONWriteLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI9JSONWriteaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_TT_Goto_CodeRange(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i2 + -1 | 0;
 HEAP32[i1 + 356 >> 2] = HEAP32[i1 + 444 + (i4 << 3) >> 2];
 HEAP32[i1 + 364 >> 2] = HEAP32[i1 + 444 + (i4 << 3) + 4 >> 2];
 HEAP32[i1 + 360 >> 2] = i3;
 HEAP32[i1 + 352 >> 2] = i2;
 return;
}

function _UNITY_FT_Add_Default_Modules(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 if (!i3) return;
 i1 = HEAP32[HEAP32[i3 + 188 >> 2] >> 2] | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 do {
  _UNITY_FT_Add_Module(i3, i2) | 0;
  i1 = i1 + 4 | 0;
  i2 = HEAP32[i1 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return;
}

function _Direct_Move_Y(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = i3 & 65535;
 i1 = (HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
 i4 = (HEAP32[i2 + 24 >> 2] | 0) + i3 | 0;
 HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 16;
 return;
}

function mftCall_viiif(i5, i1, i2, i3, d4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 d4 = +d4;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 31 | 0)) {
  FUNCTION_TABLE_viiif[i5 - fb & 31](i1 | 0, i2 | 0, i3 | 0, Math_fround(d4));
  return;
 }
 ftCall_viiif(i5 | 0, i1 | 0, i2 | 0, i3 | 0, +d4);
}

function mftCall_viifi(i5, i1, i2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_viifi[i5 - fb & 15](i1 | 0, i2 | 0, Math_fround(d3), i4 | 0);
  return;
 }
 ftCall_viifi(i5 | 0, i1 | 0, i2 | 0, +d3, i4 | 0);
}

function _wcsspn(i4, i3) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i2 = HEAP32[i4 >> 2] | 0;
 L1 : do if (!i2) i1 = i4; else {
  i1 = i4;
  do {
   if (!(_wcschr(i3, i2) | 0)) break L1;
   i1 = i1 + 4 | 0;
   i2 = HEAP32[i1 >> 2] | 0;
  } while ((i2 | 0) != 0);
 } while (0);
 return i1 - i4 >> 2 | 0;
}

function _emscripten_glTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _emscripten_glTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function _cff_get_kerning(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 532 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 if (!i5) return 0;
 HEAP32[i4 >> 2] = mftCall_iiii(HEAP32[i5 + 84 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 return 0;
}

function __ZNSt3__25ctypeIcE13classic_tableEv() {
 var i1 = 0, i2 = 0;
 __THREW__ = 0;
 i1 = invoke_i(fb + 317 | 0) | 0;
 i2 = __THREW__;
 __THREW__ = 0;
 if (i2 & 1) {
  i2 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i2);
 } else return HEAP32[i1 >> 2] | 0;
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 return i3 + (i1 << 2) | 0;
}

function __ZNK5physx25PxClothSimpleTetherCooker13getTetherDataEPjPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 _memcpy(i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] << 2 | 0) | 0;
 _memcpy(i3 | 0, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] << 2 | 0) | 0;
 return;
}

function __ZNK5physx14NpRigidDynamic24getSolverIterationCountsERjS1_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAPU16[((HEAP32[i2 + 284 >> 2] & 256 | 0) == 0 ? i2 + 110 | 0 : (HEAP32[i2 + 56 >> 2] | 0) + 132 | 0) >> 1] | 0;
 HEAP32[i3 >> 2] = i2 >>> 8;
 HEAP32[i1 >> 2] = i2 & 255;
 return;
}

function __ZNK5physx12NpConstraint8getFlagsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP16[i2 + 124 >> 1] | 0;
 if (!(HEAP32[i2 + 20 >> 2] & 4)) {
  i2 = HEAP16[i2 + 28 >> 1] & (i1 | -2);
  return i2 | 0;
 } else {
  i2 = HEAP16[(HEAP32[i2 + 24 >> 2] | 0) + 16 >> 1] & (i1 | -2);
  return i2 | 0;
 }
 return 0;
}

function __ZNK2UI6Canvas30GetSortingBucketNormalizedSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 f3 = Math_fround(HEAPF32[i1 + 404 >> 2]);
 i2 = f3 == Math_fround(0.0);
 return Math_fround(i2 ? Math_fround(.100000001) : f3);
}

function __ZNK15b2FrictionJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 84 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 88 >> 2]) * f3);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Sprite8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Sprite8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Shader8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Shader8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Camera8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Camera8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Avatar8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN6Avatar8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx35NpArticulationJointGetBodiesFromScbERNS_3Scb17ArticulationJointERPNS0_4BodyES5_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = i3 + -8 | 0;
 i3 = HEAP32[i4 + 200 >> 2] | 0;
 HEAP32[i1 >> 2] = (HEAP32[i4 + 196 >> 2] | 0) + 48;
 HEAP32[i2 >> 2] = i3 + 48;
 return;
}

function __ZN5physx2Sc19ConstraintGroupNode18initProjectionDataEPS1_PNS0_13ConstraintSimE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + 40 >> 2] = i1;
 if (!i2) return;
 i1 = i2 + 32 | 0;
 HEAP32[i3 + 36 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i3;
 HEAP32[i3 + 28 >> 2] = i2;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx2Sc5Scene7collideEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 673134;
 HEAP32[i1 + 4 >> 2] = 272;
 HEAP32[i1 + 8 >> 2] = fb + 2105;
 HEAP32[i1 + 12 >> 2] = gb + 673116;
 HEAP32[i1 + 16 >> 2] = 273;
 HEAP32[i1 + 20 >> 2] = fb + 370;
 HEAP32[i1 + 24 >> 2] = fb + 313;
 return;
}

function __ZN5Unity17ConfigurableJoint10SetXMotionEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 96 >> 2] = i1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i2);
 return;
}

function __ZN5Unity10HingeJoint12SetUseLimitsEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 156 >> 0] = i1 & 1;
 i1 = HEAP32[i2 + 32 >> 2] | 0;
 if (!i1) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0) & 1) return;
 __ZN5Unity10HingeJoint14WriteUseLimitsEv(i2);
 return;
}

function __ZN4FMOD8ChannelI13get3DPanLevelEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868472;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI13setPluginPathEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869928;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI8getPitchEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868237;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN33AssetBundleLoadFromAsyncOperation13DeleteStorageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 80 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63552 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN24iPhoneRemoteNotificationD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 20 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 return;
}

function __ZN20LocalFileSystemPosix29ConvertErrnoToFileSystemErrorEi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 13:
 case 1:
  {
   i1 = 9;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 case 18:
  {
   i1 = 10;
   break;
  }
 default:
  i1 = 14;
 }
 return i1 | 0;
}

function __ZN19ScriptingInvocation6InvokeIbEET_PP15Il2CppExceptionb(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i3, i2) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP8[i1 + 8 >> 0] | 0) != 0;
 return i3 | 0;
}

function __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i5 = i3;
 i4 = HEAP32[i5 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i5 >> 2];
 HEAP32[i3 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 32780 >> 2] = 0;
 return;
}

function __ZN18AwakeFromLoadQueue33RegisterObjectInstanceIDsInternalEPNS_4ItemEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 if (!i3) return; else i1 = 0;
 do {
  __ZN6Object24RegisterInstanceIDNoLockEPS_(HEAP32[i2 + (i1 * 12 | 0) >> 2] | 0);
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN16PlayerConnection4PollEv(i1) {
 i1 = i1 | 0;
 __ZN17GeneralConnection4PollEv(i1);
 switch (HEAP32[i1 + 144 >> 2] | 0) {
 case 0:
  {
   __ZN16PlayerConnection14PollListenModeEv(i1);
   return;
  }
 case 1:
  {
   __ZN16PlayerConnection15PollConnectModeEv(i1);
   return;
  }
 default:
  return;
 }
}

function __ZN12InputManager10UpdateAxesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 i2 = i2 + 32 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 do {
  mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
  i1 = i1 + 108 | 0;
 } while ((i1 | 0) != (HEAP32[i2 >> 2] | 0));
 return;
}

function __ZN12IFileAdapter4ReadER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function __ZL31InitializeModule_TerrainPhysicsv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63624 | 0, 16, gb + 1016930 | 0, gb + 1576256 | 0, gb + 1016954 | 0, 23) | 0;
 HEAP32[i1 >> 2] = gb + 187244 + 8;
 __Z19pop_allocation_rootv();
 __Z18SetITerrainPhysicsP15ITerrainPhysics(i1);
 return;
}

function __Z43RectTransform_Set_Custom_PropDrivenByObjectP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) {
  if (!i2) return;
  return;
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z37GetUnityWebRequestScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1468904 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL41InitializeUnityWebRequestScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 378 | 0, fb + 379 | 0);
 i1 = HEAP32[gb + 1468904 >> 2] | 0;
 return i1 | 0;
}

function __Z37Compass_CUSTOM_INTERNAL_get_rawVectorP12Il2CppObjectP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (__ZN15LocationService14GetLastHeadingEv() | 0) + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return _il2cpp_unity_liveness_calculation_begin(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0) | 0;
}

function mftCall_viiii(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 511 | 0)) {
  FUNCTION_TABLE_viiii[i5 - fb & 511](i1 | 0, i2 | 0, i3 | 0, i4 | 0);
  return;
 }
 ftCall_viiii(i5 | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _zipOpenNewFileInZip(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return _zipOpenNewFileInZip3(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10, 0, -15, 8, 0, 0, 0) | 0;
}

function _tt_get_kerning(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = HEAP32[i1 + 532 >> 2] | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 if (!i5) return 0;
 HEAP32[i4 >> 2] = mftCall_iiii(HEAP32[i5 + 84 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 return 0;
}

function _raccess_guess_vfat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i1 = _raccess_make_file_name(HEAP32[i1 >> 2] | 0, i3, gb + 947058 | 0) | 0;
 if (!i1) {
  i5 = 64;
  return i5 | 0;
 }
 HEAP32[i4 >> 2] = i1;
 HEAP32[i5 >> 2] = 0;
 i5 = 0;
 return i5 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, i3);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i3 = HEAP32[i1 >> 2] | 0;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 } else {
  i3 = i1;
  i1 = i2 & 255;
 }
 return i3 + (i1 << 2) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, i3);
 return;
}

function __ZNK9dtNavMesh24getNextOffMeshConnectionEPK19dtOffMeshConnection(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 96 >> 2] | 0;
 if ((i1 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i2 + 48 >> 2] | 0) + (i1 * 104 | 0) | 0;
 return i2 | 0;
}

function __ZNK5physx2Sc16ArticulationCore10isSleepingEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) {
  i2 = Math_fround(HEAPF32[i2 + 32 >> 2]) == Math_fround(0.0);
  return i2 | 0;
 } else {
  i2 = __ZNK5physx2Sc15ArticulationSim10isSleepingEv(i1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK26DownloadHandlerAssetBundle6IsDoneEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 28 >> 2] & -2 | 0) == 2) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK14VehiclesModule19VehiclesNeedsUpdateEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1458700 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 1458540 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0);
 return i1 | 0;
}

function __ZNK13RenderTexture22GetSupportedMipMapFlagEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 170 >> 0] | 0) != 0 & i1;
 if ((HEAP32[i2 + 104 >> 2] | 0) == 3) return i1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 534 >> 0] | 0) == 0 | 0; else return i1 | 0;
 return 0;
}

function __ZNK10MemoryFile4SizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
  setTempRet0(i2 | 0);
  return i1 | 0;
 }
 i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
 i1 = getTempRet0() | 0;
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN8WindZone5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(20.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 56 >> 2] = Math_fround(.00999999977);
 return;
}

function __ZN8Animator9SetTargetEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 if (i2 >>> 0 >= 6) return;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) return;
 i1 = HEAP32[i1 + 128 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAPF32[i1 + 8 >> 2] = f3;
 return;
}

function __ZN5physx2Sc14ConstraintCore13setBreakForceEff(i1, f3, f2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 HEAPF32[i1 + 56 >> 2] = f3;
 HEAPF32[i1 + 60 >> 2] = f2;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc13ConstraintSim15setBreakForceLLEff(i1, f3, f2);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx2Sc5Scene8simulateEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx24PxPhysicsGeneratedValuesC2EPKNS_9PxPhysicsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx17MBPUpdateWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Unity5Joint13AwakeFromLoadE17AwakeFromLoadMode(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i2 + 28 >> 2] | 0;
 if (i1 | 0) if (__ZNK10GameObject8IsActiveEv(i1) | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0);
  return;
 }
 __ZN5Unity5Joint7CleanupEv(i2);
 return;
}

function __ZN5Umbra16LineSegmentQueryaSERKS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = (i3 | 0) == 0 ? 0 : i3 + 3 & -4;
 i1 = i1 + 3 & -4;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 return i3 | 0;
}

function __ZN4FMOD8ChannelI12getLoopCountEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868526;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI16getNumParametersEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868798;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD13ChannelGroupI7getMuteEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868211;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN29TriggerModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 if (i3 | 0) {
  f4 = Math_fround(0.0);
  return Math_fround(f4);
 }
 f4 = Math_fround(HEAPF32[(HEAP32[i2 + 912 >> 2] | 0) + 24 >> 2]);
 return Math_fround(f4);
}

function __ZN16UnityAdsSettings18SetPlatformEnabledE15RuntimePlatformb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = 1 << i1;
 if (i3) {
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i1;
  return;
 } else {
  i3 = i2 + 12 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~i1;
  return;
 }
}

function __ZN15dtPathQueryInfoD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z6dtFreePv(HEAP32[i2 + 48 >> 2] | 0);
 __Z6dtFreePv(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15HeightMeshQueryD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 169856 + 8;
 __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE(i1 + 4 | 0, HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZN12HandlerChainD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 70844 + 8;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 __ZdlPv(i3);
 return;
}

function __Z6StrCmpPKcS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 while (1) {
  i3 = HEAP8[i1 >> 0] | 0;
  i4 = HEAP8[i2 >> 0] | 0;
  if (i3 << 24 >> 24 ? i3 << 24 >> 24 == i4 << 24 >> 24 : 0) {
   i1 = i1 + 1 | 0;
   i2 = i2 + 1 | 0;
  } else break;
 }
 return (i3 & 255) - (i4 & 255) | 0;
}

function __Z21CleanupEngineGraphicsv() {
 if (!(HEAP8[gb + 1548965 >> 0] | 0)) return 1;
 __Z14CleanupShadersv();
 __ZN22BuiltinResourceManager19DestroyAllResourcesEv(__Z25GetBuiltinResourceManagerv() | 0);
 __Z24ShaderPassContextCleanupv();
 __Z16DestroyGfxDevicev();
 HEAP8[gb + 1548965 >> 0] = 0;
 return 1;
}

function __Z20Terrain_CUSTOM_FlushP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else {
  i2 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
  if (i2) {
   __ZN7Terrain5FlushEv(i2);
   return;
  }
 }
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z18Transfer_BlittableI8JSONReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function __Z18Transfer_BlittableI8JSONReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z29Transfer_Blittable_ArrayFieldI8JSONReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo(HEAP32[i2 + 20 >> 2] | 0, HEAP32[i2 + 24 >> 2] | 0, i1);
 return;
}

function _UNITY_FT_Hypot(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 HEAP32[i4 + 4 >> 2] = i2;
 i2 = _UNITY_FT_Vector_Length(i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function mftCall_vifii(i5, i1, d2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_vifii[i5 - fb & 3](i1 | 0, Math_fround(d2), i3 | 0, i4 | 0);
  return;
 }
 ftCall_vifii(i5 | 0, i1 | 0, +d2, i3 | 0, i4 | 0);
}

function _unity_z_deflatePrime(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) {
  i3 = -2;
  return i3 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i3 = -2;
  return i3 | 0;
 }
 HEAP32[i1 + 5820 >> 2] = i2;
 HEAP16[i1 + 5816 >> 1] = (1 << i2) + 65535 & i3;
 i3 = 0;
 return i3 | 0;
}

function _strcasestr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _strlen(i2) | 0;
 L1 : do if (!(HEAP8[i1 >> 0] | 0)) i1 = 0; else while (1) {
  if (!(_strncasecmp(i1, i2, i3) | 0)) break L1;
  i1 = i1 + 1 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   i1 = 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function _l64a(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = gb + 1575791 | 0; else {
  i2 = i1;
  i1 = gb + 1575791 | 0;
  do {
   HEAP8[i1 >> 0] = HEAP8[(i2 & 63) + (gb + 1060052) >> 0] | 0;
   i1 = i1 + 1 | 0;
   i2 = i2 >>> 6;
  } while ((i2 | 0) != 0);
 }
 HEAP8[i1 >> 0] = 0;
 return gb + 1575791 | 0;
}

function _glCompressedTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _glCompressedTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZanRK8Scalar4fRK14ComplementExprIS_E(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Ejjjj(i1, HEAP32[i3 >> 2] & ~HEAP32[i2 >> 2], HEAP32[i3 + 4 >> 2] & ~HEAP32[i2 + 4 >> 2], HEAP32[i3 + 8 >> 2] & ~HEAP32[i2 + 8 >> 2], HEAP32[i3 + 12 >> 2] & ~HEAP32[i2 + 12 >> 2]);
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj(i4, i3, i1, i2, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj(i4 + -124 | 0, i3, i1, i2, i5);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDsc11__mbstate_tEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476368 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDic11__mbstate_tEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476376 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__28numpunctIwE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _wcslen(gb + 213024 | 0) | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, gb + 213024 | 0, i2);
 return;
}

function __ZNK12b2MouseJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 96 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 100 >> 2]) * f3);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZNK10FileSystem16CurrentDirectoryEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _strlen(gb + 1546878 | 0) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1546878 | 0, i2);
 return;
}

function __ZN5physx5cloth11PhaseConfigC2Et(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 >> 1] = i1;
 HEAP16[i2 + 2 >> 1] = -1;
 HEAPF32[i2 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 12 >> 2] = Math_fround(1.0);
 HEAPF32[i2 + 16 >> 2] = Math_fround(1.0);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext23DefaultBufferedProfilerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Ext23DefaultBufferedProfilerD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5Unity11AdjacenciesD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 8 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZdaPv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Light8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Light8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Flare8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN5Flare8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4gles20GetShaderTargetLevelE16GfxDeviceLevelGL(i1) {
 i1 = i1 | 0;
 if ((i1 + -10 | 0) >>> 0 < 3) i1 = 50; else if ((i1 + -8 | 0) >>> 0 < 5) i1 = 41; else if ((i1 + -5 | 0) >>> 0 < 8) i1 = 40; else if ((i1 + -3 | 0) >>> 0 < 2) i1 = 50; else i1 = (i1 + -2 | 0) >>> 0 < 3 ? 40 : 30;
 return i1 | 0;
}

function __ZN4FMOD8ChannelI12setLoopCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868698;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI11getPriorityEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868587;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD8ChannelI11get3DSpreadEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868486;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854979;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854979;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI13getMusicSpeedEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868984;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20TextRenderingPrivate14DynamicFontMap16StaticInitializeEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63392 | 0, 16, gb + 945383 | 0, 95) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1467884 >> 2] = i1;
 return;
}

function __Z7Empty2DP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = -2139062144;
 HEAP8[i2 + 1 >> 0] = -2139062144 >> 8;
 HEAP8[i2 + 2 >> 0] = -2139062144 >> 16;
 HEAP8[i2 + 3 >> 0] = -2139062144 >> 24;
 return;
}

function __Z34Scene_CUSTOM_GetBuildIndexInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = __ZNK10UnityScene13GetBuildIndexEv(i1) | 0;
 return i2 | 0;
}

function __Z27CullingGroup_CUSTOM_DisposeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i2 >> 2] | 0;
  if (!i1) i1 = 0; else __ZN12CullingGroupD2Ev(i1);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63600 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z26DestroyStreamedClipBuilderP19StreamedClipBuilder(i1) {
 i1 = i1 | 0;
 if (i1 | 0) if ((HEAP32[i1 + 16 >> 2] | 0) > -1) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 return;
}

function __Z16IntersectRayAABBRK3RayRK4AABBPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = __Z16IntersectRayAABBRK3RayRK4AABBPfS5_(i1, i2, i3, i4) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__26locale5__imp12install_fromINS_7codecvtIwc11__mbstate_tEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476360 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7codecvtIcc11__mbstate_tEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476352 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNKSt3__28numpunctIwE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i2 = _wcslen(gb + 213048 | 0) | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, gb + 213048 | 0, i2);
 return;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L22utf16le_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L22utf16be_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L22utf16le_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L22utf16be_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
}

function __ZNK6Object14GetMemoryLabelEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 8 >> 2] | 0;
 i3 = i4 & 2047;
 if (!(i4 & 2048)) {
  HEAP32[i1 >> 2] = i3;
  HEAP32[i1 + 4 >> 2] = 0;
  return;
 } else {
  __Z14CreateMemLabel18MemLabelIdentifierPv(i1, i3, i2);
  return;
 }
}

function __ZNK5physx38PxArticulationLinkCollectionPropHelper10createLinkEPNS_14PxArticulationEPNS_18PxArticulationLinkERKNS_11PxTransformE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNK28MonoBehaviourPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0) | 0;
 return Math_fround(i2 ? Math_fround(1.0) : Math_fround(0.0));
}

function __ZNK13RendererScene20GetStaticObjectCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 144 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z9GetIUmbrav() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZNK12b2MotorJoint16GetReactionForceEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var f4 = f0;
 f4 = Math_fround(Math_fround(HEAPF32[i2 + 80 >> 2]) * f3);
 f3 = Math_fround(Math_fround(HEAPF32[i2 + 84 >> 2]) * f3);
 HEAPF32[i1 >> 2] = f4;
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZN9GfxDevice21SetWorldMatrixAndTypeERK10Matrix4x4f13TransformType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, (i3 & 4 | 0) != 0 | 0);
 return;
}

function __ZN6Camera30SetNonJitteredProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP8[i1 + 1119 >> 0] = 1;
 i3 = i1 + 1240 | 0;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 return;
}

function __ZN5physx9NpPhysics14createMaterialEfff(i4, f3, f1, f2) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE(i4, __ZN5physx9NpFactory14createMaterialEfff(HEAP32[gb + 1457204 >> 2] | 0, f3, f1, f2) | 0) | 0;
}

function __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 148720 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx24PxsComputeAABBLocalSpaceERKNS_17PxcAABBDataStaticERNS_9PxBounds3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_(i1 + 36 | 0, i2, i1, Math_fround(HEAPF32[i1 + 28 >> 2]), 0);
 return;
}

function __ZN4FMOD7SystemI12unloadPluginEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869969;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854655;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854655;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD6SoundI12getLoopCountEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868526;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN15NavMeshObstacle9SetHeightEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = f2 > Math_fround(9.99999974e-06);
 HEAPF32[i1 + 60 >> 2] = Math_fround((i3 ? f2 : Math_fround(9.99999974e-06)) * Math_fround(.5));
 i1 = i1 + 136 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 return;
}

function __ZL31InitializeModule_ParticleSystemv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63264 | 0, 16, gb + 622371 | 0, gb + 1576256 | 0, gb + 622401 | 0, 24) | 0;
 HEAP32[i1 >> 2] = gb + 83640 + 8;
 __Z19pop_allocation_rootv();
 __Z18SetIParticleSystemP15IParticleSystem(i1);
 return;
}

function __ZL23CleanupModule_Animationv() {
 var i1 = 0;
 HEAP32[gb + 1162104 >> 2] = 0;
 i1 = __Z13GetIAnimationv() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63320 | 0);
 __Z13SetIAnimationP10IAnimation(0);
 return;
}

function __ZL13MotionHandleriPK27EmscriptenDeviceMotionEventPv(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = gb + 1097904 | 0;
 i1 = i3;
 i2 = i4 + 80 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 return 1;
}

function __Z34GetUnityWebRequestScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1468904 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL41InitializeUnityWebRequestScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 378 | 0, fb + 379 | 0);
 i1 = HEAP32[gb + 1468904 >> 2] | 0;
 return i1 | 0;
}

function __Z32CrashReport_CUSTOM_GetReportDataP12Il2CppStringPd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i3, i1);
 HEAPF64[i2 >> 3] = 0.0;
 STACKTOP = i3;
 return 0;
}

function __Z30setPxVehicleDriveMDriveDynDataPN5physx14PxVehicleDriveENS_21PxVehicleDriveDynDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 128 | 0;
 i1 = i3 + 96 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 return;
}

function __GLOBAL__sub_I_SamplerManager_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451016 | 0, gb + 585479 | 0, 11, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451028 | 0, gb + 585511 | 0, 11, 0);
 return;
}

function _UNITY_png_destroy_info_struct(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 HEAP32[i2 >> 2] = 0;
 _UNITY_png_free_data(i1, i3, 32767, -1);
 _memset(i3 | 0, 0, 244) | 0;
 _UNITY_png_free(i1, i3);
 return;
}

function _tt_cmap14_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = (HEAPU8[i2 + 7 >> 0] | 0) << 16 | (HEAPU8[i2 + 6 >> 0] | 0) << 24 | (HEAPU8[i2 + 8 >> 0] | 0) << 8 | (HEAPU8[i2 + 9 >> 0] | 0);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return 0;
}

function _abort_message(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i3 = HEAP32[gb + 191628 >> 2] | 0;
 _vfprintf(i3, i1, i4) | 0;
 _fputc(10, i3) | 0;
 _abort();
}

function ___stdio_exit() {
 var i1 = 0;
 ___lock(gb + 1469464 + 28 | 0);
 i1 = HEAP32[gb + 1469464 + 24 >> 2] | 0;
 if (i1 | 0) do {
  _close_file(i1);
  i1 = HEAP32[i1 + 56 >> 2] | 0;
 } while ((i1 | 0) != 0);
 _close_file(HEAP32[gb + 191864 >> 2] | 0);
 _close_file(HEAP32[gb + 191984 >> 2] | 0);
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i1 = i2;
 }
 return i1 + i3 + -1 | 0;
}

function __ZNK5physx14NpArticulation11getAPISceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 16 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK13SliderJoint2D13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(__ZNK16b2PrismaticJoint13GetJointSpeedEv(i1)) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZNK12TLSAllocatorI14StackAllocatorE24GetBookKeepingMemorySizeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i4 + 32 + (i3 << 2) >> 2] | 0;
  if (i2) i1 = (HEAP32[i2 + 28 >> 2] | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 128);
 return i1 | 0;
}

function __ZNK12AudioManager25RequiresCustomSpatializerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 140 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) {
  i2 = HEAP32[i1 + 144 >> 2] | 0;
  i2 = (i2 | 0) != 0;
  return i2 | 0;
 } else {
  i2 = i2 & 255;
  i2 = (i2 | 0) != 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 466045 | 0, i1, i3);
}

function __ZN7ApiGLES11BindSamplerEij(i2, i3, i4) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0;
 i1 = i2 + 1860 + (i3 << 2) | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i4 | 0)) return;
 HEAP32[i1 >> 2] = i4;
 mftCall_vii(HEAP32[i2 + 832 >> 2] | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN5physx6shdfnd10checkValidEPKc(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4096 | 0;
 while (1) {
  if (HEAP8[i1 >> 0] | 0) {
   i1 = 1;
   i2 = 4;
   break;
  }
  i1 = i1 + 1 | 0;
  if (i1 >>> 0 >= i2 >>> 0) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN5physx2Sc5Scene24initActiveBodiesIteratorERNS0_12BodyIteratorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 + 1204 >> 2] | 0;
 i4 = HEAP32[i3 >> 2] | 0;
 i3 = i4 + (HEAP32[i3 + 4 >> 2] << 2) | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = i4;
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 __ZN5physx2Sc5Scene5solveEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx10NpMaterial22setFrictionCombineModeENS_13PxCombineMode4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 46 | 0;
 HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 15 | i2 << 4;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZN5Umbra4PathC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = i2 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5Umbra20getRuntimeInfoStringENS_10InfoStringE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = gb + 612968 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 612916 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 612895 | 0;
   break;
  }
 default:
  i1 = gb + 1576256 | 0;
 }
 return i1 | 0;
}

function __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN4Mesh8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0;
 __ZN4Mesh8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 if (!i3) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN4FMOD6SoundI12setLoopCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868698;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI13getNumOutputsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868784;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN20TextRenderingPrivate8TextMesh5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 52 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 HEAP16[i1 + 58 >> 1] = 0;
 HEAP16[i1 + 56 >> 1] = 0;
 HEAPF32[i1 + 64 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 68 >> 2] = Math_fround(4.0);
 return;
}

function __ZN12NavMeshAgent27SetInternalAnimationPolyRefEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN7dtCrowd24setAgentAnimationPolyRefERK13dtCrowdHandley(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i2, i3);
 return;
}

function __ZN12HingeJoint2D7CleanupEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2) HEAP8[i1 + 114 >> 0] = 0; else {
  i3 = HEAP32[i1 + 60 >> 2] | 0;
  if (i3 | 0) {
   HEAP32[i1 + 116 >> 2] = HEAP32[i3 + 116 >> 2];
   HEAP8[i1 + 114 >> 0] = 1;
  }
 }
 __ZN7Joint2D7CleanupEb(i1, i2);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj(i4, i1) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 15 & -16;
 i3 = i4 + 4096 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i4 + 4096 - i1 | 0) >>> 0 < i2 >>> 0) i1 = _malloc(i2) | 0; else HEAP32[i3 >> 2] = i1 + i2;
 return i1 | 0;
}

function __ZN10__cxxabiv112_GLOBAL__N_110construct_Ev() {
 var i1 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!(_pthread_key_create(gb + 1477004 | 0, fb + 4013 | 0) | 0)) {
  STACKTOP = i1;
  return;
 } else _abort_message(gb + 1085173 | 0, i1);
}

function __Z49Playable_CUSTOM_INTERNAL_CALL_SetDurationInternalR9HPlayabled(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vid(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, +d2);
 return;
}

function __Z38AndroidJNI_CUSTOM_SetStaticStringField13Il2Cpp_IntPtrS_P12Il2CppString(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return;
}

function __Z37RuntimeUndo_CUSTOM_SetTransformParentP12Il2CppObjectS0_P12Il2CppString(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return;
}

function __Z36RenderSettings_Set_Custom_PropSkyboxP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z17GetRenderSettingsv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN14RenderSettings17SetSkyboxMaterialEP8Material(i2, i1);
 return;
}

function __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (i1 & i2) return f4 > Math_fround(0.0) & ((i3 | 0) > 1 & (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 532 >> 0] | 0) == 0) | 0; else return 0;
 return 0;
}

function __Z20FakeGetTimeInSamplesv() {
 var d1 = 0.0;
 d1 = +__Z19GetTimeSinceStartupv() * 44100.0;
 setTempRet0((+Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~d1 >>> 0 | 0;
}

function _Direct_Move_X(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = i3 & 65535;
 i1 = (HEAP32[i2 + 16 >> 2] | 0) + (i3 << 3) | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i4;
 i4 = (HEAP32[i2 + 24 >> 2] | 0) + i3 | 0;
 HEAP8[i4 >> 0] = HEAPU8[i4 >> 0] | 0 | 8;
 return;
}

function _unlockpt(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i4 = i2 + 4 | 0;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i3 >> 2] = i4;
 i1 = _ioctl(i1, 1074025521, i3) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _hashmd_48(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 if (i1 >>> 0 > 64) {
  i3 = i1 + -65 & -64;
  i2 = i1;
  do {
   _sha512_update(i4, i5, 64);
   i2 = i2 + -64 | 0;
  } while (i2 >>> 0 > 64);
  i1 = i1 + -64 - i3 | 0;
 }
 _sha512_update(i4, i5, i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ejw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, i2, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ejc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, i2, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i1 = i2;
 }
 return i1 + i3 + -1 | 0;
}

function __ZNK8Animator25GetStateMachineBehavioursEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK6Camera26GetStereoSingleCullEnabledEv(i1) {
 i1 = i1 | 0;
 if (__ZNK6Camera16GetStereoEnabledEv(i1) | 0) if (HEAP8[i1 + 1083 >> 0] | 0) if (HEAP8[i1 + 1084 >> 0] | 0) if ((HEAP32[i1 + 824 >> 2] | 0) == 3) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 1112 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK19TextRenderingModule22TMGenGetCursorPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfEi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN20TextRenderingPrivate17TextMeshGenerator17GetCursorPositionERK5RectTIfEi(i1, i3, i4, i5);
 return;
}

function __ZNK18ProceduralMaterial20HasSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) | 0) != 0 | 0;
}

function __ZNK13ScreenManager20GetCurrentResolutionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 4 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0) | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNK12NavMeshAgent15IsOnOffMeshLinkEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) + 601 >> 0] | 0) == 2;
 return i1 | 0;
}

function __ZN5physx10NpMaterial25setRestitutionCombineModeENS_13PxCombineMode4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 46 | 0;
 HEAP8[i3 >> 0] = (HEAPU8[i3 >> 0] | 0) & 240 | i2;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZN5Umbra10TomeLoader8freeTomeEPKNS_4TomeEPNS_9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 i1 = i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0;
 if (!i2) {
  _free(i1);
  return;
 } else {
  mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
  return;
 }
}

function __ZN4FMOD8ChannelI9getVolumeEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868630;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7SystemI10recordStopEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869740;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI12getNumInputsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 857578;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN21UniformBufferTFMethod20IsBoneCountSupportedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 661 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 576 >> 2] | 0) >>> 0) / 48 | 0) >>> 0 >= i2 >>> 0;
 return i2 | 0;
}

function __ZN19GfxThreadableDevice20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 392115 | 0, 0, gb + 392043 | 0, 939, 1, 0, 0, 0);
 return;
}

function __ZN15FileSystemEntryC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 1040 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 __ZN15FileSystemEntry3SetEPKc(i1, i2);
 return;
}

function __ZN15FileSystemEntry8SetFlagsEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 104 >> 2] | 0, i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 return i4 | 0;
}

function __ZN14PhysicsManager13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZN5Unity12PhysicsQuery13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction(i1 + 736 | 0, i2, f3, i4, i5) | 0;
}

function __ZN13GfxDeviceGLES12GetSRGBWriteEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 493 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 653 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 7186 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZN12FixedJoint2D7CleanupEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i2) HEAP8[i1 + 104 >> 0] = 0; else {
  i3 = HEAP32[i1 + 60 >> 2] | 0;
  if (i3 | 0) {
   HEAP32[i1 + 108 >> 2] = HEAP32[i3 + 96 >> 2];
   HEAP8[i1 + 104 >> 0] = 1;
  }
 }
 __ZN7Joint2D7CleanupEb(i1, i2);
 return;
}

function __ZN12FileAccessor9SetLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 1048 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = mftCall_iiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, i1 + 4 | 0, i2 | 0, i3 | 0) | 0;
 return i4 | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer14PurgeAllEventsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 68 | 0;
 if ((HEAP32[i1 + 72 >> 2] | 0) == (HEAP32[i2 >> 2] | 0)) return;
 __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv(i2);
 HEAP8[i1 + 89 >> 0] = 1;
 return;
}

function __ZN10OnGUIState30ClearNameOfNextKeyboardControlEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 68 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i2);
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10GISettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 1;
 HEAP8[i1 + 21 >> 0] = 1;
 return;
}

function __ZN10AudioMixer19EnsureValidConstantEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 72 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
  HEAP32[i2 >> 2] = i1;
  if (!i1) {
   i2 = 0;
   return i2 | 0;
  }
 }
 i2 = 1;
 return i2 | 0;
}

function __Z44setPxParticleReadDataCollisionVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z33Scene_CUSTOM_GetRootCountInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZNK10UnityScene12GetRootCountEv(i1) | 0;
 return i2 | 0;
}

function _UNITY_png_write_rows(i3, i1, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if ((i3 | 0) != 0 & (i4 | 0) != 0) i2 = 0; else return;
 while (1) {
  _UNITY_png_write_row(i3, HEAP32[i1 >> 2] | 0);
  i2 = i2 + 1 | 0;
  if ((i2 | 0) == (i4 | 0)) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function _emscripten_glTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _emscripten_glTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function _close(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall6(6, i3 | 0) | 0;
 i1 = ___syscall_ret((i1 | 0) == -4 ? -115 : i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN44EarlyUpdateResetFrameStatsAfterPresentstruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 488 >> 2] | 0, i1 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 620 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj(i4, i3, i1, i2, i5) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj(i4 + -124 | 0, i3, i1, i2, i5);
 return;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE6getlocEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZNSt3__26localeC2ERKS0_(i3, i1 + 4 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE6getlocEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZNSt3__26localeC2ERKS0_(i3, i1 + 4 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE22GetAllocatedMemorySizeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i4 + 32 + (i3 << 2) >> 2] | 0;
  if (i2) i1 = (HEAP32[i2 + 16 >> 2] | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 128);
 return i1 | 0;
}

function __ZNK12HingeJoint2D13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(__ZNK15b2RevoluteJoint13GetJointSpeedEv(i1)) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZNK12HingeJoint2D13GetJointAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(__ZNK15b2RevoluteJoint13GetJointAngleEv(i1)) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZN9Transform22EnsureCapacityIncreaseEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 32 >> 2] | 0;
 i1 = (HEAP32[HEAP32[i3 + 16 >> 2] >> 2] | 0) + i1 | 0;
 if (i1 >>> 0 <= (HEAP32[i3 >> 2] | 0) >>> 0) return;
 __ZN9Transform20SetHierarchyCapacityEj(i2, i1 << 1);
 return;
}

function __ZN9Scripting28RaiseNotImplementedExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 466071 | 0, i1, i3);
}

function __ZN9GfxDevice19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i8 = i1;
 HEAP32[i8 >> 2] = 1;
 HEAP32[i8 + 4 >> 2] = 1;
 return;
}

function __ZN9GfxDevice16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __Z16CreateGpuProgram20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput(i2, i3, i4) | 0;
}

function __ZN5physx7NpShape15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc9ShapeCore15exportExtraDataERNS_22PxSerializationContextE(i2 + 48 | 0, i1);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, HEAP32[i2 + 192 >> 2] | 0);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 68 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 60 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc21ArticulationJointCore20setTargetOrientationERKNS_6PxQuatE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 60 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 64 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 68 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 72 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 116 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 120 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 124 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 128 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN4FMOD8ChannelI8getIndexEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868498;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD7ReverbI9getActiveEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 862463;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN4FMOD4DSPI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854655;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI14CanvasRenderer20OnCanvasGroupChangedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 162 | 0;
 HEAP16[i2 >> 1] = HEAPU16[i2 >> 1] | 0 | 2176;
 __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE(HEAP32[gb + 1467948 >> 2] | 0, HEAP32[i1 + 188 >> 2] | 0, i1);
 return;
}

function __ZN21ExecutionOrderManager15InitializeClassEv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(20, gb + 63520 | 0, 16, gb + 464723 | 0, gb + 457238 | 0, gb + 457260 | 0, 105) | 0;
 __ZN21ExecutionOrderManagerC2Ev(i1);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1163032 >> 2] = i1;
 return;
}

function __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i3, i2) | 0;
 if (HEAP32[i3 >> 2] | 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 return i3 | 0;
}

function __ZN17BillboardRenderer12SetBillboardERK4PPtrI14BillboardAssetE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = i3 + 344 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN17BillboardRenderer21UpdateCachedBillboardEv(i3);
 return;
}

function __ZN15TextureTFMethod16BindForRenderingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7ApiGLES17ActiveTextureUnitEj(HEAP32[gb + 1451080 >> 2] | 0, 0);
 __ZN7ApiGLES11BindTextureEj16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, HEAP32[i1 + 20 + (HEAP32[i1 + 32 >> 2] << 2) >> 2] | 0, 2);
 return;
}

function __ZN13GfxDeviceGLES5ClearEjRK10ColorRGBAffj(i1, i2, i3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 __ZN18GfxFramebufferGLES5ClearEjRK10ColorRGBAffib(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0, i2, i3, f4, i5, 1);
 return;
}

function __Z32Random_CUSTOM_INTERNAL_get_stateP9RandState(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScriptingRandv() | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph(i1, i2, i3 + 32 | 0, i3, HEAP32[i3 + 84 >> 2] | 0, i4 + 32 | 0, i4, HEAP32[i4 + 84 >> 2] | 0);
 return;
}

function __Z20push_allocation_rootPvP13BaseAllocatorb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!i4) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN14MemoryProfiler18PushAllocationRootEPvP13BaseAllocatorb(i4, i1, i2, i3) | 0;
 return i4 | 0;
}

function __Z18IsLinearCollectionP11Il2CppClass(i1) {
 i1 = i1 | 0;
 if ((__Z23scripting_type_get_typePK10Il2CppType(__Z24scripting_class_get_typeP11Il2CppClass(i1) | 0) | 0) == 29) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = __ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass(i1) | 0;
 return i1 | 0;
}

function ___uremdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i6 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 i5 = i6 | 0;
 ___udivmoddi4(i1, i2, i3, i4, i5) | 0;
 STACKTOP = i6;
 return (setTempRet0(HEAP32[i5 + 4 >> 2] | 0), HEAP32[i5 >> 2] | 0) | 0;
}

function __ZNSt3__217__assoc_sub_state12__make_readyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 12 | 0;
 __ZNSt3__25mutex4lockEv(i2);
 i3 = i1 + 88 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 4;
 __ZNSt3__218condition_variable10notify_allEv(i1 + 40 | 0);
 __ZNSt3__25mutex6unlockEv(i2);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj(i1, i2, _wcslen(i2) | 0);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function __ZNK5physx2Sc5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK5physx18PxsDynamicsContext28computeUnconstrainedVelocityEPNS_12PxsRigidBodyE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f(HEAP32[i1 + 64 >> 2] | 0, i1, i1 + 16 | 0, Math_fround(HEAPF32[i2 + 124 >> 2]));
 return;
}

function __ZNK5physx12NpConstraint10getNpSceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 20 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE21GetReservedMemorySizeEv(i4) {
 i4 = i4 | 0;
 var i1 = 0, i2 = 0, i3 = 0;
 i3 = 0;
 i1 = 0;
 do {
  i2 = HEAP32[i4 + 32 + (i3 << 2) >> 2] | 0;
  if (i2) i1 = (HEAP32[i2 + 20 >> 2] | 0) + i1 | 0;
  i3 = i3 + 1 | 0;
 } while ((i3 | 0) != 128);
 return i1 | 0;
}

function __ZN6Socket11SetBlockingEib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2 ? 0 : 2048;
 i2 = (_fcntl(i1, 4, i4) | 0) != -1;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZN5physx7NpShape18setQueryFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE(i1) {
 i1 = i1 | 0;
 switch (HEAP16[i1 + 4 >> 1] | 0) {
 case 5:
  {
   i1 = i1 + 20 | 0;
   break;
  }
 case 6:
  {
   i1 = i1 + 20 | 0;
   break;
  }
 case 15:
  {
   i1 = i1 + 20 | 0;
   break;
  }
 default:
  i1 = 1;
 }
 return i1 | 0;
}

function __ZN5physx6shdfnd6Socket5writeEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i1 + 14 >> 0] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
 return i3 | 0;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx35PxClothStretchConfigGeneratedValuesC2EPKNS_20PxClothStretchConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i4 + 16 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 12 | 0) >> 2] = i3;
 HEAP8[i4 + 477 >> 0] = 1;
 return;
}

function __ZN5Umbra9IndexList6setPtrEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i5 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = (i4 | 0) <= (i3 | 0) ? i4 : i3;
 return;
}

function __ZN5Umbra9FloatList6setPtrEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i5 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i3 = HEAP32[i5 + 4 >> 2] | 0;
 i1 = i5 + 8 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i1 >> 2] = (i4 | 0) <= (i3 | 0) ? i4 : i3;
 return;
}

function __ZN2UI11CanvasGroup16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0, i4 = 0;
 i1 = i1 + 36 | 0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN16Physics2DManager21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN19CollisionListener2D21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2, i3);
 return;
}

function __ZN15QualitySettings22ApplyExpensiveSettingsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1158216 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0);
 i1 = __Z12GetIVRDevicev() | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15LightProbeGroup17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 36 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 40 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13RendererScene25SetOcclusionPortalEnabledEjb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = __Z9GetIUmbrav() | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 40 >> 2] | 0, i4 | 0, HEAP32[i1 + 144 >> 2] | 0, HEAP32[i1 + 140 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN13AudioListener17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 132 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 136 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z42setPxParticleReadDataCollisionNormalBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z30Mathf_CUSTOM_ClosestPowerOfTwoi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + -1 | 0;
 i2 = i2 >>> 16 | i2;
 i2 = i2 >>> 8 | i2;
 i2 = i2 >>> 4 | i2;
 i2 = i2 >>> 2 | i2;
 i2 = (i2 >>> 1 | i2) + 1 | 0;
 i3 = i2 >>> 1;
 return ((i1 - i3 | 0) >>> 0 < (i2 - i1 | 0) >>> 0 ? i3 : i2) | 0;
}

function __Z25SetupTerrainPhysicsModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63624 | 0, 16, gb + 1016930 | 0, gb + 1576256 | 0, gb + 1016954 | 0, 23) | 0;
 HEAP32[i1 >> 2] = gb + 187244 + 8;
 __Z19pop_allocation_rootv();
 __Z18SetITerrainPhysicsP15ITerrainPhysics(i1);
 return;
}

function __Z24InitializeNavMeshManagerv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(140, gb + 63704 | 0, 16, gb + 842172 | 0, 1384) | 0;
 __ZN14NavMeshManagerC2Ev(i1);
 HEAP32[gb + 1459032 >> 2] = i1;
 HEAP32[gb + 1115296 + 192 >> 2] = fb + 264;
 HEAP32[gb + 1115296 + 212 >> 2] = fb + 265;
 return;
}

function __Z15StartFMODRecordPN4FMOD6SystemEiPN11SoundHandle8InstanceEb(i3, i4, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 36 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 40 >> 2] | 0;
 return __ZN4FMOD6System11recordStartEiPNS_5SoundEb(i3, i4, i1, i5) | 0;
}

function _hashmd(i4, i1, i5) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i5 = i5 | 0;
 var i2 = 0, i3 = 0;
 if (i1 >>> 0 > 32) {
  i3 = i1 + -33 & -32;
  i2 = i1;
  do {
   _sha256_update(i4, i5, 32);
   i2 = i2 + -32 | 0;
  } while (i2 >>> 0 > 32);
  i1 = i1 + -32 - i3 | 0;
 }
 _sha256_update(i4, i5, i1);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 32 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK9ShaderLab9IntShader19CreatePropertySheetERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63280 | 0, 16, gb + 481096 | 0, 91) | 0;
 __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_(i3, i2, HEAP32[i1 + 92 >> 2] | 0);
 return i3 | 0;
}

function __ZNK5physx14NpArticulation8getSceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 16 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK5physx11NpAggregate11getAPISceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK12NavMeshAgent13IsPathPartialEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) + 44 >> 0] & 2) != 0;
 return i1 | 0;
}

function __ZN5physx8debugger4comm28SendPropertyMessageFromGroup9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcherD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Ext20DefaultCpuDispatcherD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Ext18computeConeDensityEfff(f3, f1, f2) {
 f3 = Math_fround(f3);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(f2 / Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(Math_abs(Math_fround(f1)))) / Math_fround(3.0)));
}

function __ZN5physx2Sq8AABBTreeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 536 >> 2] = 0;
 HEAP32[i1 + 540 >> 2] = 0;
 HEAP32[i1 + 544 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN5physx2Sn21SerializationRegistryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sn21SerializationRegistryD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc8ShapeSimD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 90968 + 8;
 __ZN5physx2Sc15ObjectIDTracker9releaseIDEj(HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0) + 1196 >> 2] | 0, HEAP32[i1 + 20 >> 2] | 0);
 __ZN5physx2Sc7ElementD2Ev(i1);
 return;
}

function __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Cm8PtrTable15importExtraDataERNS_24PxDeserializationContextE(i2, i1);
 __ZN5physx2Cm8PtrTable15importExtraDataERNS_24PxDeserializationContextE(i2 + 8 | 0, i1);
 return;
}

function __ZN5Umbra16getAPIInfoStringENS_10InfoStringE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = gb + 612968 | 0;
   break;
  }
 case 1:
  {
   i1 = gb + 612916 | 0;
   break;
  }
 case 2:
  {
   i1 = gb + 612895 | 0;
   break;
  }
 default:
  i1 = gb + 1576256 | 0;
 }
 return i1 | 0;
}

function __ZN4FMOD8ChannelI6getPanEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868568;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff(i1, i2, i3, f4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 __ZN26AnimatorControllerPlayable17GotoStateInternalEiifffb(i1, i2, i3, f4, f5, f6, 1);
 return;
}

function __ZN18PlayableController17SetTimeUpdateModeE18DirectorUpdateMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) != 3) {
  HEAP32[i1 >> 2] = i2;
  return;
 }
 __ZN15DirectorManager17RemoveFromManagerEP18PlayableController(__Z18GetDirectorManagerv() | 0, i1);
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN18BaseUnityAnalytics7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63800 | 0);
 return;
}

function __ZN17CommonStringTable16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(400, gb + 63648 | 0, 16, gb + 389739 | 0, gb + 1576256 | 0, gb + 389753 | 0, 59) | 0;
 __ZN17CommonStringTableC2Ev(i1);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1115292 >> 2] = i1;
 return;
}

function __ZN13GfxDeviceGLES16SetForceCullModeE8CullMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4384 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, HEAP32[i1 + 7088 >> 2] | 0);
 return;
}

function __ZN11UnityEngine7Connect13ConnectConfig14GroupingConfig11ResetValuesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 300;
 HEAP32[i1 + 4 >> 2] = 30;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 12 >> 2] = 300;
 HEAP32[i1 + 16 >> 2] = 2592e3;
 HEAP32[i1 + 20 >> 2] = 20;
 HEAP32[i1 + 24 >> 2] = 60;
 return;
}

function __ZN11CustomArrayC2Em(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i3 = __Znwj(16) | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = __Znaj(i2) | 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN11AudioModule16GetProfilerStatsER10AudioStats(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12AudioManager15GetProfilerDataER10AudioStats(__Z15GetAudioManagerv() | 0, i2);
 i1 = __Z15GetSoundManagerv() | 0;
 if (!i1) return;
 __ZN12SoundManager15GetProfilerDataER10AudioStats(i1, i2);
 return;
}

function __Z7CRCFeedjPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) {
  i3 = i1;
  return i3 | 0;
 }
 while (1) {
  i3 = i3 + -1 | 0;
  i1 = HEAP32[gb + 69280 + (((HEAPU8[i2 >> 0] | 0) ^ i1 & 255) << 2) >> 2] ^ i1 >>> 8;
  if (!i3) break; else i2 = i2 + 1 | 0;
 }
 return i1 | 0;
}

function __Z60Playables_CUSTOM_INTERNAL_CALL_SetPlayableDeleteOnDisconnectR9HPlayableh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + 52 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -3 | (i2 << 24 >> 24 != 0 & 1) << 1 & 65535;
 return;
}

function __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetActiveSceneRi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZN19RuntimeSceneManager14GetActiveSceneEv(__Z15GetSceneManagerv() | 0) | 0;
 if (!i2) {
  i2 = 0;
  HEAP32[i1 >> 2] = i2;
  return;
 }
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z45Playable_CUSTOM_INTERNAL_CALL_SetTimeInternalR9HPlayabled(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vid(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, +d2);
 return;
}

function __Z36Application_CUSTOM_DontDestroyOnLoadP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i1) return;
 __ZN19RuntimeSceneManager17DontDestroyOnLoadER6Object(__Z15GetSceneManagerv() | 0, i1) | 0;
 return;
}

function __Z20RequiredComponentsOfP13MonoBehaviour(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z26GetManagedAttributeManagerv() | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 return __ZN23ManagedAttributeManager21GetRequiredComponentsEP11Il2CppClass(i2, i1) | 0;
}

function mftCall_iiidi(i5, i1, i2, d3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 if ((i5 | 0) >= (fb | 0) & (i5 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiidi[i5 - fb & 1](i1 | 0, i2 | 0, +d3, i4 | 0) | 0;
 return ftCall_iiidi(i5 | 0, i1 | 0, i2 | 0, +d3, i4 | 0) | 0;
}

function _iswprint(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 < 255) i1 = (i1 + 1 & 127) >>> 0 > 32 & 1; else if ((i1 + -57344 | 0) >>> 0 < 8185 | (i1 >>> 0 < 8232 | (i1 + -8234 | 0) >>> 0 < 47062)) i1 = 1; else return ((i1 + -65532 | 0) >>> 0 > 1048579 | (i1 & 65534 | 0) == 65534) & 1 ^ 1 | 0;
 return i1 | 0;
}

function _gzputc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP8[i4 >> 0] = i2;
 i2 = (_gzwrite(i1, i4, 1) | 0) == 1;
 STACKTOP = i3;
 return (i2 ? HEAPU8[i4 >> 0] | 0 : -1) | 0;
}

function __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb1EEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476292 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb0EEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476284 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb1EEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476276 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb0EEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476268 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 i4 = i1 + 8 | 0;
 HEAP32[i4 >> 2] = -1;
 HEAP32[i4 + 4 >> 2] = -1;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4cendEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i1 = i2;
 }
 return i1 + i3 | 0;
}

function __ZNK5physx9NpPhysics14getNbMaterialsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = (HEAP32[i1 + 36 >> 2] | 0) - (HEAP32[i1 + 44 >> 2] | 0) | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZNK5physx2Gu11HeightField9saveCellsEPvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 i4 = Math_imul(HEAP32[i3 + 20 >> 2] << 2, HEAP32[i3 + 16 >> 2] | 0) | 0;
 i2 = i4 >>> 0 > i2 >>> 0 ? i2 : i4;
 _memcpy(i1 | 0, HEAP32[i3 + 36 >> 2] | 0, i2 | 0) | 0;
 return i2 | 0;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE11PoolElement8ContainsEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 12 >> 2] | 0;
 if (i3 >>> 0 > i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (i3 + (HEAP32[i1 + 16 >> 2] | 0) | 0) >>> 0 > i2 >>> 0;
 return i3 | 0;
}

function __ZNK16UploadHandlerRaw11GetProgressEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  f3 = Math_fround(1.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(Math_fround((HEAP32[i1 + 32 >> 2] | 0) >>> 0) / Math_fround(i2 >>> 0));
 return Math_fround(f3);
}

function __ZNK16Physics2DManager16IsTouchingLayersEPK10Collider2Di(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK19CollisionListener2D16IsTouchingLayersEPK10Collider2Di((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2, i3) | 0;
 return i3 | 0;
}

function __ZNK13MonoBehaviour33IsPersistentStateMachineBehaviourEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP8[i2 + 36 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 8 >> 2] & 1048576 | 0) != 0;
 return i2 | 0;
}

function __ZNK12WheelJoint2D13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(__ZNK12b2WheelJoint13GetJointSpeedEv(i1)) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZNK12NavMeshAgent11PathPendingEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) + 602 >> 0] & 4) != 0;
 return i1 | 0;
}

function __ZN9Scripting25RaiseInvalidCastExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 466095 | 0, i1, i3);
}

function __ZN8PlayableD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37536 + 8;
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 __Z18GetDirectorManagerv() | 0;
 __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList(gb + 1188456 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKNS0_10ValueDeltaERNS_5human9HumanPoseE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN7mecanim9animation12GetHumanPoseINS0_10ValueDeltaEEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i1, i2, i3);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale1Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 64 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale0Ef(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 56 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx20MTorqueCurvePropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834114;
 HEAP32[i1 + 4 >> 2] = 521;
 HEAP32[i1 + 8 >> 2] = fb + 29;
 HEAP32[i1 + 12 >> 2] = fb + 30;
 HEAP32[i1 + 16 >> 2] = fb + 2409;
 HEAP32[i1 + 20 >> 2] = fb + 19;
 HEAP32[i1 + 24 >> 2] = fb + 3766;
 return;
}

function __ZN5physx13IslandManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101648 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN4crnd31crnd_get_fundamental_dxt_formatE10crn_format(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = _i64Add(i1 | 0, i2 | 0, -3, -1) | 0;
 i4 = getTempRet0() | 0;
 i3 = i4 >>> 0 < 0 | (i4 | 0) == 0 & i3 >>> 0 < 4;
 setTempRet0((i3 ? 0 : i2) | 0);
 return (i3 ? 2 : i1) | 0;
}

function __ZN4FMOD7SystemI13get3DSettingsEPfS1_S1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = HEAP32[i1 + 52 >> 2];
 if (i3 | 0) HEAP32[i3 >> 2] = HEAP32[i1 + 56 >> 2];
 if (!i4) return 0;
 HEAP32[i4 >> 2] = HEAP32[i1 + 60 >> 2];
 return 0;
}

function __ZN2UI6Canvas18SetOverrideSortingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!(HEAP32[i1 + 344 >> 2] | 0)) return;
 i3 = i1 + 375 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i3 >> 0] | 0 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN2UI6Canvas27UpdateCanvasOverrideSortingEv(i1);
 return;
}

function __ZN28ParticleSystemSubEmitterDataC2Ev(i1) {
 i1 = i1 | 0;
 __ZN11MinMaxCurveC2Ev(i1);
 __ZN11MinMaxCurveC2Ev(i1 + 264 | 0);
 HEAPF32[i1 + 580 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 584 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 588 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 596 >> 2] = 0;
 return;
}

function __ZN18BuoyancyEffector2D12SetFlowAngleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-359.999908);
 i4 = f2 > Math_fround(359.999908);
 f2 = i4 ? Math_fround(359.999908) : f2;
 HEAPF32[i1 + 108 >> 2] = i3 ? Math_fround(-359.999908) : f2;
 return;
}

function __ZN17MessageIdentifierC2EPKcNS_7OptionsEPKN5Unity4TypeES1_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i4;
 HEAP32[i1 + 4 >> 2] = i5;
 HEAP32[i1 + 8 >> 2] = -1;
 HEAP32[i1 + 16 >> 2] = i3;
 return;
}

function __ZN15ApplicationInfo16GetInstallerNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP8[i1 + 11 >> 0] = 0;
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN14SpriteRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN8Renderer13BoundsChangedEv(i1);
 __ZN14SpriteRenderer15SetupPropertiesEv(i1);
 __ZN14SpriteRenderer18UpdateCachedSpriteEv(i1);
 return;
}

function __ZN13Simd4fFactoryIN6detail9FourTupleEEC2Effff(i1, f3, f4, f5, f2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = f2;
 return;
}

function __ZN13GfxDeviceNull17CreateIndexBufferEv(i1) {
 i1 = i1 | 0;
 i1 = __Znwj(28) | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 78576 + 8;
 return i1 | 0;
}

function __ZN13BaseAllocator13TryDeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0) | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0);
 i2 = 1;
 return i2 | 0;
}

function __ZN11ShapeModule17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 124 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 128 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11AudioSource24SetOutputAudioMixerGroupE4PPtrI15AudioMixerGroupE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i2 + 440 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i3 >> 2] = i1;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i2);
 return;
}

function __ZN10GISettingsC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 1;
 HEAP8[i1 + 21 >> 0] = 1;
 return;
}

function __ZL35StaticInitializeRuntimeSceneManagerPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(88, gb + 63824 | 0, 16, gb + 462840 | 0, gb + 462848 | 0, gb + 462762 | 0, 38) | 0;
 __ZN19RuntimeSceneManagerC2Ev(i1);
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1164172 >> 2] = i1;
 return;
}

function __Z37CalculateJobCountWithMinIndicesPerJobiii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) {
  i3 = 1;
  return i3 | 0;
 }
 i2 = (i1 + -1 + i2 | 0) / (i2 | 0) | 0;
 i3 = (i3 << 1) + 2 | 0;
 i3 = (i3 | 0) < (i2 | 0) ? i3 : i2;
 i3 = (i3 | 0) > 16 ? 16 : i3;
 return i3 | 0;
}

function __Z32CountListsWithValidRendererCountPK16RendererCullData(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 56 >> 2] | 0) != 0 & 1) + (((HEAP32[i1 + 44 >> 2] | 0) != 0 & 1) + (((HEAP32[i1 + 32 >> 2] | 0) != 0 & 1) + (((HEAP32[i1 + 20 >> 2] | 0) != 0 & 1) + ((HEAP32[i1 + 8 >> 2] | 0) != 0 & 1)))) | 0;
}

function __Z25GetGpuProgramTypeFromDataPKhS0_(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 - i3 | 0) >>> 0 < 4) i1 = 0; else {
  i2 = i3 + 4 | 0;
  if ((HEAP32[i3 >> 2] | 0) == 201608170) if ((i1 - i2 | 0) >>> 0 < 4) i1 = 0; else i1 = HEAP32[i2 >> 2] | 0; else i1 = 0;
 }
 return i1 | 0;
}

function _UNITY_png_malloc_base(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i2) {
  i3 = 0;
  return i3 | 0;
 }
 if (i1 | 0) {
  i3 = HEAP32[i1 + 608 >> 2] | 0;
  if (i3 | 0) {
   i3 = mftCall_iii(i3 | 0, i1 | 0, i2 | 0) | 0;
   return i3 | 0;
  }
 }
 i3 = _malloc(i2) | 0;
 return i3 | 0;
}

function _UNITY_FT_Stream_ExtractFrame(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = _UNITY_FT_Stream_EnterFrame(i2, i1) | 0;
 if (i1 | 0) return i1 | 0;
 i4 = i2 + 32 | 0;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i4 >> 2] = 0;
 HEAP32[i2 + 36 >> 2] = 0;
 return i1 | 0;
}

function _cfsetispeed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do if (!i2) i1 = 0; else if (!(i2 & -4112)) {
  i1 = i1 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -4112 | i2;
  i1 = 0;
  break;
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
  break;
 } while (0);
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i1 = i2;
 }
 return i1 + i3 | 0;
}

function __ZNK5physx12NpConstraint8getSceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 20 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK12NavMeshAgent11IsPathValidEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0) + 44 >> 0] & 1) != 0;
 return i1 | 0;
}

function __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 465955 | 0, i1, i3);
}

function __ZN7mecanim4hand10CreateHandERNS_6memory9AllocatorE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 60, 4) | 0;
 i2 = i1;
 i3 = i2 + 60 | 0;
 do {
  HEAP32[i2 >> 2] = -1;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function __ZN7ApiGLESD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 852 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __ZdlPv(i3);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 856 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN6Camera16SetCullingMatrixERK10Matrix4x4f(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i4 = i3 + 680 | 0;
 i2 = i4 + 64 | 0;
 do {
  HEAP32[i4 >> 2] = HEAP32[i1 >> 2];
  i4 = i4 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i4 | 0) < (i2 | 0));
 HEAP8[i3 + 1085 >> 0] = 0;
 return;
}

function __ZN5physx7NpScene22checkCollisionInternalEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 3692 >> 2] | 0;
 if (i2) {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, -1) | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx6shdfnd9atomicMaxEPVii(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 do {
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) HEAP32[i3 >> 2] = (i1 | 0) < (i4 | 0) ? i4 : i1;
 } while ((i2 | 0) != (i1 | 0));
 return HEAP32[i3 >> 2] | 0;
}

function __ZN5physx6shdfnd7FastIPC8sendDataEPKvjb(i1, i3, i4, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i1) return 1; else return (__ZN5physx6shdfnd12PxRingBuffer8sendDataENS1_11MessageTypeEPKvjb(i1, 100, i3, i4, i2) | 0) != 0 | 0;
 return 0;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fE11getParticleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i2 + 96 >> 2] | 0) + ((HEAPU16[(HEAP32[i2 + 104 >> 2] | 0) + (i1 << 1) >> 1] | 0) * 76 | 0) >> 2] | 0) + (HEAP32[(HEAP32[i2 + 108 >> 2] | 0) + (i1 << 2) >> 2] << 4) | 0;
}

function __ZN5physx3Scb14ParticleSystemD2Ev(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 152 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __ZN5physx2Sc18ParticleSystemCoreD2Ev(i3 + 12 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx2Sn20SerializationContextD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sn20SerializationContextD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc7BodySim14internalWakeUpEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = HEAP32[i2 + 152 >> 2] | 0;
 if (!i1) {
  __ZN5physx2Sc7BodySim18internalWakeUpBaseEf(i2, f3);
  return;
 } else {
  __ZN5physx2Sc15ArticulationSim14internalWakeUpEf(i1, f3);
  return;
 }
}

function __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE(i1) {
 i1 = i1 | 0;
 switch (HEAPU8[i1 + 20 >> 0] | 0 | 0) {
 case 1:
  {
   i1 = i1 + 24 | 0;
   break;
  }
 case 4:
 case 3:
 case 2:
 case 0:
  {
   i1 = i1 + -8 | 0;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5physx16PxsFluidDynamics12mergeDensityEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + 120 | 0;
 __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE(i2, 1, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN4FMOD13ChannelGroupI4stopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 854017;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN18ScriptingArguments18AddScriptingStringEP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i3 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 4;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN14PreloadManager17PopIntegrateQueueEP23PreloadManagerOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 20 >> 2] | 0;
 i2 = i1 + 32 | 0;
 _memmove(i3 | 0, i3 + 4 | 0, (HEAP32[i2 >> 2] << 2) + -4 | 0) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN10SampleClip17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 108 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 112 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z32AndroidJNI_CUSTOM_SetStringField13Il2Cpp_IntPtrS_P12Il2CppString(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return;
}

function __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 mftCall_vi(i2 | 0, i3 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __Z16ByteSwapDateTimeR8DateTime(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP16[i1 >> 1] = _llvm_bswap_i16(HEAP16[i1 >> 1] | 0) | 0;
 i2 = i1 + 2 | 0;
 HEAP16[i2 >> 1] = _llvm_bswap_i16(HEAP16[i2 >> 1] | 0) | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
 return;
}

function _independent_calloc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 i3 = _ialloc(i1, i5, 3, i3) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function ___fseeko(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i4 = 0;
 if ((HEAP32[i3 + 76 >> 2] | 0) > -1) {
  i4 = (___lockfile(i3) | 0) == 0;
  i1 = ___fseeko_unlocked(i3, i1, i2) | 0;
  if (!i4) ___unlockfile(i3);
 } else i1 = ___fseeko_unlocked(i3, i1, i2) | 0;
 return i1 | 0;
}

function __ZThn4_NK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i2 + 348 >> 2] | 0;
 if (!i1) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i2 + 344 >> 2] | 0, i1 << 4 | 0) | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP8[i2 + 11 >> 0] | 0;
 if (i1 << 24 >> 24 < 0) {
  i3 = HEAP32[i2 + 4 >> 2] | 0;
  i1 = HEAP32[i2 >> 2] | 0;
 } else {
  i3 = i1 & 255;
  i1 = i2;
 }
 return i1 + i3 | 0;
}

function __ZNKSt3__214__codecvt_utf8IwE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
}

function __ZNKSt3__214__codecvt_utf8IDiE9do_lengthER11__mbstate_tPKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0) | 0;
}

function __ZNK5physx16PxSphericalJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765091 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx16PxPrismaticJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765058 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(i1, i2);
 return;
}

function __ZNK26PlayerSettingsSplashScreen29GetSplashScreenOverlayOpacityEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, i3 = 0;
 i3 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0) != 0;
 f2 = i3 ? Math_fround(0.0) : Math_fround(.5);
 return Math_fround(_fmaxf(f2, Math_fround(HEAPF32[i1 + 36 >> 2])));
}

function __ZNK16TypeTreeIterator10ByteOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 >= (HEAP32[i1 + 52 >> 2] | 0) >>> 0) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN8GUILayer15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(24) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[gb + 1114500 >> 2] = i1;
 return;
}

function __ZN8Collider32RigidbodyMassDistributionChangedEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) return;
 i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
 if (!i1) return;
 __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 return;
}

function __ZN7ApiGLES14DebugPopMarkerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451148 >> 2] | 0;
 if (!(HEAP8[i2 + 123 >> 0] | 0)) return;
 if (!(HEAP8[i2 + 122 >> 0] | 0)) {
  mftCall_v(HEAP32[i1 + 400 >> 2] | 0);
  return;
 } else {
  mftCall_v(HEAP32[i1 + 384 >> 2] | 0);
  return;
 }
}

function __ZN5physx3Ext15computeConeMassEfff(f3, f2, f1) {
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(Math_abs(Math_fround(f2)))) / Math_fround(3.0)) * f1);
}

function __ZN5physx22PxVehicleSetUpdateModeENS_19PxVehicleUpdateMode4EnumE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   HEAP8[gb + 1552705 >> 0] = 0;
   return;
  }
 case 1:
  {
   HEAP8[gb + 1552705 >> 0] = 1;
   return;
  }
 default:
  {
   HEAP8[gb + 1552705 >> 0] = 0;
   return;
  }
 }
}

function __ZN5physx16PxsParticleShape8destroyVEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 __ZN5physx10PxsContext17releaseFluidShapeEPNS_16PxsParticleShapeE(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i1);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __ZN5physx16PxsIslandManager24setEdgeArticulationJointERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAP32[i2 + 284 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
 HEAP8[i2 + 477 >> 0] = 1;
 return;
}

function __ZN5physx11NodeManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101688 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx11EdgeManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 101668 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 + 4 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra12QueryContext18addQueryDebugPointERKNS_7Vector3ERKNS_7Vector4E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN20TextRenderingPrivate7GUIText5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 64 >> 0] = 1;
 HEAP16[i1 + 54 >> 1] = 0;
 HEAP16[i1 + 52 >> 1] = 0;
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(4.0);
 HEAP32[i1 + 68 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 return;
}

function __ZN15DownloadHandler7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63808 | 0);
 return;
}

function __ZN14AvatarPlayback9StartTimeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if ((HEAP32[i1 + 28 >> 2] | 0) == -1) {
  f2 = Math_fround(-1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 4 >> 2] | 0) + ((HEAP32[i1 + 20 >> 2] | 0) * 12 | 0) + 8 >> 2]);
 return Math_fround(f2);
}

function __ZN14AvatarPlayback10CursorTimeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, f3 = f0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if ((i2 | 0) == -1) {
  f3 = Math_fround(-1.0);
  return Math_fround(f3);
 }
 f3 = Math_fround(HEAPF32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 * 12 | 0) + 8 >> 2]);
 return Math_fround(f3);
}

function __ZN13ScreenManager23SetIsOrientationEnabledE18EnabledOrientationb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3) {
  i3 = i1 + 32 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | i2;
  return;
 } else {
  i3 = i1 + 32 | 0;
  HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & ~i2;
  return;
 }
}

function __ZN13PhysicsModule29BakeNxMeshStreamFromUnityMeshEP4MeshbbbR13dynamic_arrayIhLj1EE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __Z29BakePxMeshStreamFromUnityMeshP4MeshbbbR13dynamic_arrayIhLj1EE(i2, i3, i4, i5, i6);
 return;
}

function __ZN11MatrixStack9SetMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + ((HEAP32[i1 + 1024 >> 2] | 0) + -1 << 6) | 0;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 return;
}

function __ZN10systeminfo16GetProcessorTypeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 64908 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1 + 12 | 0);
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1);
 return;
}

function __Z52Playable_CUSTOM_INTERNAL_CALL_GetOutputCountInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) + 48 >> 2] | 0;
 return i1 | 0;
}

function __Z51Playable_CUSTOM_INTERNAL_CALL_CanSetWeightsInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = ((HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] | 0) >>> 1 & 1 ^ 1) & 255;
 return i1 | 0;
}

function __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi(__Z20GetPersistentManagerv() | 0, i1, i2);
 return;
}

function __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawIconRK8Vector3fP12Il2CppStringh(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return;
}

function __Z35GUIStyle_CUSTOM_Internal_CalcHeight13Il2Cpp_IntPtrP12Il2CppObjectf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 >> 2] | 0;
 return Math_fround(__ZNK8GUIStyle10CalcHeightER10GUIContentf(i1, __Z26MonoGUIContentToTempNativeP12Il2CppObject(i2) | 0, f3));
}

function __Z32Debug_CUSTOM_SetDiagnosticSwitchP12Il2CppStringP12Il2CppObjecth(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return;
}

function __Z28AssetBundle_CUSTOM_LoadAsyncP12Il2CppObjectP12Il2CppStringS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return 0;
}

function __GLOBAL__sub_I_runtime_audio2_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1459980 | 0, gb + 863662 | 0, 6, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1552710 | 0, fb + 3785 | 0, fb + 3786 | 0, 0, 0);
 return;
}

function _UNITY_png_get_bKGD(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 32 | 0) != 0 : 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = i2 + 162;
 i3 = 32;
 return i3 | 0;
}

function _tt_cmap13_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _tt_cmap13_char_map_binary(i1, i4, 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _tt_cmap12_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _tt_cmap12_char_map_binary(i1, i4, 0) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _llvm_bitreverse_i32(i1) {
 i1 = i1 | 0;
 i1 = (i1 & 2863311530) >>> 1 | (i1 & 1431655765) << 1;
 i1 = (i1 & 3435973836) >>> 2 | (i1 & 858993459) << 2;
 i1 = (i1 & 4042322160) >>> 4 | (i1 & 252645135) << 4;
 i1 = (i1 & 4278255360) >>> 8 | (i1 & 16711935) << 8;
 return i1 >>> 16 | i1 << 16;
}

function _emscripten_glCompressedTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _emscripten_glCompressedTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function __ZThn32_NK12MeshRenderer19GetStaticBatchIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + -32 | 0;
 i2 = HEAP32[i1 + 340 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP16[i1 + 218 >> 1] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 + 3 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP32[HEAP32[i1 >> 2] >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
 } else {
  HEAP32[i1 >> 2] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 return;
}

function __ZNK5physx2Sc18ParticleSystemCore16getParticleStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK5physx15PxRevoluteJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765075 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx15PxDistanceJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 742891 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Unity10HingeJoint28PxJointSupportsInternalStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 159 >> 0] | 0;
 if ((HEAP8[i1 + 157 >> 0] | 0) == i2 << 24 >> 24) return 1; else return ((HEAP16[(HEAP32[i1 + 32 >> 2] | 0) + 4 >> 1] | 0) == 261 | 0) == (i2 & 255 | 0) | 0;
 return 0;
}

function __ZNK26DownloadHandlerAssetBundle11GetProgressEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0));
 return Math_fround(f2);
}

function __ZNK15SharedLightData24GetFinalShadowResolutionEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if ((i1 | 0) != -1) return i1 | 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 24 >> 2] | 0;
 return i1 | 0;
}

function __ZN9Scripting22RaiseArgumentExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 466027 | 0, i1, i3);
}

function __ZN9Animation17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 256 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 260 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx8debugger4comm25BeginPropertyMessageGroup9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 return;
}

function __ZN5physx7profile19MemoryEventRecorderD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 147732 + 8;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[HEAP32[i2 + 8 >> 2] >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx7NpScene20checkResultsInternalEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 3688 >> 2] | 0;
 if (i2) {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, -1) | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx5cloth8allocateEj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 i1 = mftCall_iiiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, gb + 1576256 | 0, gb + 837553 | 0, 21) | 0;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx2Sc19ParticlePacketShapeD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc19ParticlePacketShapeD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx23PxVehicleWheels4SimData12setWheelDataEjRKNS_18PxVehicleWheelDataE((HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i3);
 return;
}

function __ZN5physx18NpArticulationLink11clearTorqueENS_11PxForceMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i2, i1, 0, 1);
 return;
}

function __ZN4FMOD7SystemI9unlockDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869982;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN25PostFilteredUserCollector10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, HEAP32[(HEAP32[i3 + 4 >> 2] | 0) + 8 >> 2] | 0);
 return 0;
}

function __ZN23SharedMeshRenderingData17UnloadIndexBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 236 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN21ExecutionOrderManager27SetDefaultExecutionOrderForEPKN5Unity4TypeEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = HEAP32[i2 + 24 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + (i2 << 3) >> 2] = i3;
 HEAP32[i1 + (i2 << 3) + 4 >> 2] = i4;
 return;
}

function __ZN18UnityConnectClient11HandleAdsIdEv(i1) {
 i1 = i1 | 0;
 if ((__ZN10systeminfo18GetRuntimePlatformEv() | 0) != 11) return;
 if (!(__Z20IsHumanControllingUsv() | 0)) return;
 __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener(__Z15GetAdsIdHandlerv() | 0, i1 + 680 | 0) | 0;
 return;
}

function __ZN18AsyncUploadManager17CleanUpMemoryPoolEv(i1) {
 i1 = i1 | 0;
 __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv(i1 + 1352 | 0);
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i1 + 1328 | 0);
 __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv(i1 + 1340 | 0);
 return;
}

function __ZN17UniqueIDGenerator15CreatePureIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN17UniqueIDGenerator8CreateIDEv(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] & 16777215 | 0;
}

function __ZN15PointEffector2D16SetDistanceScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.0000999999974);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 100 >> 2] = i3 ? Math_fround(.0000999999974) : f2;
 return;
}

function __ZN14AvatarPlayback8StopTimeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if ((HEAP32[i1 + 28 >> 2] | 0) == -1) {
  f2 = Math_fround(-1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 4 >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 12 | 0) + 8 >> 2]);
 return Math_fround(f2);
}

function __ZN10Effector2D17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 68 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10Collider2D14OnAddComponentEPN5Unity9ComponentE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 if ((((HEAP32[i2 + 8 >> 2] | 0) >>> 21) - (HEAP32[gb + 153580 + 24 >> 2] | 0) | 0) >>> 0 >= (HEAP32[gb + 153580 + 28 >> 2] | 0) >>> 0) return;
 HEAP32[i1 + 156 >> 2] = i2;
 return;
}

function __Z51Playable_CUSTOM_INTERNAL_CALL_GetInputCountInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 8 >> 2] | 0) + 28 >> 2] | 0;
 return i1 | 0;
}

function __Z38Caching_Set_Custom_PropExpirationDelayi(i1) {
 i1 = i1 | 0;
 if ((__ZN14CachingManager21GetAuthorizationLevelEv(__Z17GetCachingManagerv() | 0) | 0) <= 0) return;
 __ZN5Cache18SetExpirationDelayEi(__ZN14CachingManager15GetCurrentCacheEv(__Z17GetCachingManagerv() | 0) | 0, i1);
 return;
}

function __Z32Scene_CUSTOM_GetIsLoadedInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 80 >> 2] | 0) == 2 & 1;
 return i2 | 0;
}

function __Z31GetAnimationScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1466572 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL35InitializeAnimationScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 295 | 0, fb + 296 | 0);
 i1 = HEAP32[gb + 1466572 >> 2] | 0;
 return i1 | 0;
}

function __Z30GUI_CUSTOM_Internal_GetTooltipv() {
 var i1 = 0, i2 = 0;
 i2 = __Z11GetGUIStatev() | 0;
 i1 = HEAP32[i2 + 84 >> 2] | 0;
 i1 = (i1 | 0) == 0 ? HEAP32[i2 + 88 >> 2] | 0 : i1;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN11UTF16String18GetScriptingStringEv(i1) | 0;
 return i2 | 0;
}

function __Z30ComputeBuffer_CUSTOM_CopyCountP12Il2CppObjectS0_i(i1, i3, i4) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i2 = 0;
 if (!i1) i2 = 0; else i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i3) i1 = 0; else i1 = HEAP32[i3 + 8 >> 2] | 0;
 __ZN13ComputeBuffer9CopyCountEPS_S0_j(i2, i1, i4);
 return;
}

function __Z22IsChildOrSameTransformR9TransformS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 1;
   i2 = 4;
   break;
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   i2 = 4;
   break;
  }
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __Z21GetVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 i1 = __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0;
 return ((i1 | 0) != (HEAP32[gb + 1469348 + 4 >> 2] | 0) ? i1 : 0) | 0;
}

function __GLOBAL__sub_I_GUIText_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467920 | 0, gb + 946214 | 0, 2, 0);
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467932 | 0, gb + 946229 | 0, 0, 0);
 return;
}

function _UNITY_png_gamma_16bit_correct(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 + -1 | 0) >>> 0 < 65534) {
  i2 = ~~+Math_floor(+(+Math_pow(+(+(i1 >>> 0) / 65535.0), +(+(i2 | 0) * 1.0e-05)) * 65535.0 + .5)) & 65535;
  return i2 | 0;
 } else {
  i2 = i1 & 65535;
  return i2 | 0;
 }
 return 0;
}

function _UNITY_FT_List_Insert(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 if (!i3) HEAP32[i1 + 4 >> 2] = i2; else HEAP32[i3 >> 2] = i2;
 HEAP32[i1 >> 2] = i2;
 return;
}

function _swab(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 if ((i3 | 0) > 1) while (1) {
  HEAP8[i1 >> 0] = HEAP8[i2 + 1 >> 0] | 0;
  HEAP8[i1 + 1 >> 0] = HEAP8[i2 >> 0] | 0;
  i3 = i3 + -2 | 0;
  if ((i3 | 0) <= 1) break; else {
   i2 = i2 + 2 | 0;
   i1 = i1 + 2 | 0;
  }
 }
 return;
}

function _setlogmask(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if (!i2) i1 = HEAP32[gb + 207708 >> 2] | 0; else do {
  i1 = HEAP32[gb + 207708 >> 2] | 0;
  i3 = HEAP32[gb + 207708 >> 2] | 0;
  if ((i3 | 0) == (i1 | 0)) HEAP32[gb + 207708 >> 2] = i2;
 } while ((i3 | 0) != (i1 | 0));
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAP32[i2 >> 2] | 0;
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetcEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0; else i1 = HEAPU8[i2 >> 0] | 0;
 return i1 | 0;
}

function __ZNKSt3__28messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _catopen((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 1) | 0;
 return i3 >>> ((i3 | 0) != (-1 | 0) & 1) | 0;
}

function __ZNKSt3__28messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _catopen((HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2, 1) | 0;
 return i3 >>> ((i3 | 0) != (-1 | 0) & 1) | 0;
}

function __ZNK14DetailDatabase12IsPatchEmptyEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = (Math_imul(HEAP32[i1 + 36 >> 2] | 0, i3) | 0) + i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 return (HEAP32[i2 + (i3 * 52 | 0) + 40 >> 2] | 0) == (HEAP32[i2 + (i3 * 52 | 0) + 44 >> 2] | 0) | 0;
}

function __ZN8Renderer29SetMotionVectorGenerationModeE26MotionVectorGenerationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 268 | 0;
 i2 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16774143 | i2 << 10 & 3072;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 return;
}

function __ZN8Playable14ProcessVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i5 | 0, i1 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZN6b2RopeC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i2 = i1 + 40 | 0;
 i3 = i1;
 i4 = i3 + 36 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAPF32[i2 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 44 >> 2] = Math_fround(.100000001);
 return;
}

function __ZN5physx8debugger4comm23AppendPropertyValueData9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 12 | 0);
 return;
}

function __ZN5physx3Scb5Scene15addArticulationERNS0_12ArticulationE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene3addINS0_12ArticulationELb1EEEvRT_RNS0_13ObjectTrackerE(i2, i1, i2 + 2700 | 0);
 HEAP8[i1 + 52 >> 0] = Math_fround(HEAPF32[i1 + 48 >> 2]) == Math_fround(0.0) & 1;
 return;
}

function __ZN5physx3Cct17CapsuleControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore16getParticleStateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i2 + 16 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx18NpArticulationLink10clearForceENS_11PxForceMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i2) | 0;
 __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i2, i1, 1, 0);
 return;
}

function __ZN5physx11NpAggregate8getSceneEv(i1) {
 i1 = i1 | 0;
 if ((((HEAP32[i1 + 12 >> 2] | 0) >>> 30) + -1 | 0) >>> 0 >= 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZN15dtLocalBoundary5resetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAP32[i1 + 236 >> 2] = 0;
 return;
}

function __ZN14AreaEffector2D13SetForceAngleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-359.999908);
 i4 = f2 > Math_fround(359.999908);
 f2 = i4 ? Math_fround(359.999908) : f2;
 HEAPF32[i1 + 92 >> 2] = i3 ? Math_fround(-359.999908) : f2;
 return;
}

function __ZN14AnimationState10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 56 | 0;
 if (i2) if (!(HEAP16[i3 >> 1] & 2)) HEAPF64[i1 + 24 >> 3] = +HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3];
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -3 | (i2 & 1) << 1 & 65535;
 return;
}

function __ZN13SpeedTreeWind13SetTreeValuesERK8Vector3ff(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 HEAP32[i1 + 1332 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 1336 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 1340 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAPF32[i1 + 1344 >> 2] = f3;
 return;
}

function __ZN13RuntimeStaticI14dynamic_bitsetE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 + 8 >> 2] | 0, i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_138ArchiveRedirectFileSystemStaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1451040 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 HEAP32[gb + 1451040 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider6addRefEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 24 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = i1 + 28 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN12MemoryStreamD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 113908 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 113908 + 32;
 if (!(HEAP8[i1 + 8 >> 0] | 0)) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 24 >> 2] | 0, gb + 63552 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11NamedObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Object8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1 + 28 | 0, i2);
 return;
}

function __ZN10GameObjectD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28800 + 8;
 __ZN14ConstantStringD2Ev(i1 + 64 | 0);
 if ((HEAP32[i1 + 44 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 28 >> 2] | 0, i1 + 32 | 0);
 __ZdlPv(i1);
 return;
}

function __ZL24InitializeModule_Terrainv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(40, gb + 63616 | 0, 16, gb + 937128 | 0, gb + 1576256 | 0, gb + 937151 | 0, 23) | 0;
 __ZN14TerrainManagerC2Ev(i1);
 __Z19pop_allocation_rootv();
 __Z18SetITerrainManagerP15ITerrainManager(i1);
 return;
}

function __ZL13SortTexByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) | 0;
 return (_strcmp(i1, __ZNK9ShaderLab16FastPropertyName7GetNameEv(i2) | 0) | 0) < 0 | 0;
}

function __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z31Object_CUSTOM_DontDestroyOnLoadP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i1) return;
 __ZN19RuntimeSceneManager17DontDestroyOnLoadER6Object(__Z15GetSceneManagerv() | 0, i1) | 0;
 return;
}

function __Z30Object_CUSTOM_DestroyImmediateP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN9Scripting35DestroyObjectFromScriptingImmediateEP6Objectb(i1, i2 << 24 >> 24 != 0);
 return;
}

function __Z24CleanupPersistentManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1166040 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63216 | 0);
 HEAP32[gb + 1166040 >> 2] = 0;
 __Z23CleanupAsyncReadManagerv();
 return;
}

function __Z16ClearScissorRectbRK5RectTIiER9GfxDevice(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i1) {
  mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 160 >> 2] | 0, i3 | 0, i2 | 0);
  return;
 } else {
  mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0, i3 | 0);
  return;
 }
}

function _UNITY_png_set_read_fn(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i3) return;
 HEAP32[i3 + 184 >> 2] = i1;
 HEAP32[i3 + 180 >> 2] = (i2 | 0) == 0 ? fb + 478 | 0 : i2;
 i1 = i3 + 176 | 0;
 if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 HEAP32[i3 + 468 >> 2] = 0;
 return;
}

function _UNITY_png_get_sBIT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 if (!(i3 | 0 ? (HEAP32[i2 + 8 >> 2] & 2 | 0) != 0 : 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = i2 + 140;
 i3 = 2;
 return i3 | 0;
}

function ___stdio_close(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i1 + 60 >> 2];
 i1 = ___syscall_ret(___syscall6(6, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZThn4_N12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE(i2 + -4 | 0, i1);
 return;
}

function __ZThn28_N14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj(i1 + -28 | 0, i2, i3, i4);
 return;
}

function __ZNK5physx31PxClothGeodesicTetherCookerImpl13getTetherDataEPjPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i2 | 0, HEAP32[i1 + 84 >> 2] | 0, HEAP32[i1 + 88 >> 2] << 2 | 0) | 0;
 _memcpy(i3 | 0, HEAP32[i1 + 96 >> 2] | 0, HEAP32[i1 + 100 >> 2] << 2 | 0) | 0;
 return;
}

function __ZNK11LightProbes14LightProbeData11GetPositionEjRPK8Vector3f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i1 + 72 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = (HEAP32[i1 + 60 >> 2] | 0) + (i2 * 12 | 0);
 i3 = 1;
 return i3 | 0;
}

function __ZN9Texture2D15ExtractMipLevelEP17SharedTextureDataiibb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb(HEAP32[i1 + 52 >> 2] | 0, i2, i3, i4, i5, i6);
 return;
}

function __ZN7mecanim9animation19DestroyStreamedClipERNS0_12StreamedClipERNS_6memory9AllocatorE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 + i1 | 0);
 return;
}

function __ZN7mecanim9animation19DestroyConstantClipERNS0_12ConstantClipERNS_6memory9AllocatorE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 + i1 | 0);
 return;
}

function __ZN6b2RopeD2Ev(i1) {
 i1 = i1 | 0;
 __Z6b2FreePv(HEAP32[i1 + 4 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 8 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 12 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 16 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 20 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __ZN5physx2Sn18RepXCollectionImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sn18RepXCollectionImplD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sn13XmlNodeReader13countChildrenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 16 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 } else i1 = 0;
 do {
  i1 = i1 + 1 | 0;
  i2 = HEAP32[i2 + 8 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return i1 | 0;
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 97124 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx18PxsDynamicsContext7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx18PxsDynamicsContextD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Cm8PtrTable15exportExtraDataERNS_22PxSerializationContextE(i2, i1);
 __ZN5physx2Cm8PtrTable15exportExtraDataERNS_22PxSerializationContextE(i2 + 8 | 0, i1);
 return;
}

function __ZN4FMOD7SystemI7lockDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 869720;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN19MemoryProfilerStats24RemoveDynamicObjectCountEP6Objecti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if ((i3 | 0) != 1) return;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 return;
}

function __ZN18ScriptingArguments12AddOutObjectEPP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i3 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 12;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN13UploadHandler7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63808 | 0);
 return;
}

function __Z48Playable_CUSTOM_INTERNAL_CALL_CanDestroyInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = ((HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] | 0) >>> 2 & 1 ^ 1) & 255;
 return i1 | 0;
}

function __Z35setPxParticleReadDataVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 24 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z35setPxParticleReadDataPositionBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z22CleanupLODGroupManagerPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1161200 >> 2] | 0;
 if (i1 | 0) __ZN15LODGroupManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63536 | 0);
 HEAP32[gb + 1161200 >> 2] = 0;
 __ZN17UniqueIDGenerator7CleanupEv(gb + 1161220 | 0);
 return;
}

function __Z16IntersectRayAABBRK3RayRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = __Z16IntersectRayAABBRK3RayRK4AABBPfS5_(i1, i2, i3 + 4 | 0, i3) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _UNITY_png_set_gAMA(i3, i4, d1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 d1 = +d1;
 var i2 = 0;
 i2 = _UNITY_png_fixed(i3, d1, gb + 354214 | 0) | 0;
 if ((i3 | 0) == 0 | (i4 | 0) == 0) return;
 _UNITY_png_colorspace_set_gamma(i3, i4 + 40 | 0, i2);
 _UNITY_png_colorspace_sync_info(i3, i4);
 return;
}

function ___muldi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0, i6 = 0;
 i5 = i1;
 i6 = i3;
 i3 = ___muldsi3(i5, i6) | 0;
 i1 = getTempRet0() | 0;
 return (setTempRet0((Math_imul(i2, i6) | 0) + (Math_imul(i4, i5) | 0) + i1 | i1 & 0 | 0), i3 | 0 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore23getSimulationFilterDataEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 44 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1));
}

function __ZNK5physx12PxFixedJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 742907 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager21FindAllDerivedClassesEPK4RTTIR13dynamic_arrayIS2_Lj4EEb(HEAP32[gb + 1110260 >> 2] | 0, i1, i2, (i3 | 0) == 1);
 return;
}

function __ZN8WindZone17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 64 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN7ApiGLES18DeleteRenderbufferERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (HEAP32[i2 >> 2] | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 mftCall_vii(HEAP32[i1 + 624 >> 2] | 0, 36161, 0);
 mftCall_vii(HEAP32[i1 + 620 >> 2] | 0, 1, i2 | 0);
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN5physx31PxParticleSystemGeneratedValuesC2EPKNS_16PxParticleSystemE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx29PxParticleBaseGeneratedValuesC2EPKNS_14PxParticleBaseE(i2, i1);
 HEAP32[i2 + 116 >> 2] = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN5physx2Sc8RigidSimD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 91016 + 8;
 i2 = HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0) + 1200 >> 2] | 0;
 __ZN5physx2Sc15ObjectIDTracker9releaseIDEj(i2, HEAP32[i1 + 56 >> 2] | 0);
 __ZN5physx2Sc8ActorSimD2Ev(i1);
 return;
}

function __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb(i1, i5, i3, i4, i2) {
 i1 = i1 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 return __ZL23setMassAndUpdateInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(1, i1, i5, i3, i4, i2) | 0;
}

function __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK5physx2Cm8PtrTable4findEPKv(i3, i1) | 0;
 i1 = i3 + 8 | 0;
 if ((HEAP16[i3 + 12 >> 1] | 0) != 1) i1 = HEAP32[i1 >> 2] | 0;
 return HEAP32[i1 + (i2 << 2) >> 2] | 0;
}

function __ZN2UI6Canvas19SetProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP8[i1 + 44 >> 0] = 0;
 i3 = i1 + 48 | 0;
 i1 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
  i3 = i3 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i3 | 0) < (i1 | 0));
 return;
}

function __ZN14CachingManager20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Cache20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(HEAP32[i1 + 4 >> 2] | 0, i2);
 return;
}

function __ZN13RuntimeStaticI19UnityConnectServiceE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxTimerQueryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 77336 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 i3 = i1 + 8 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAP32[HEAP32[i3 >> 2] >> 2] = i2;
 __ZdlPv(i1);
 return;
}

function __ZN13GfxDeviceGLES16DrawNullGeometryE16GfxPrimitiveTypeii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 608 >> 2] | 0, i1 | 0);
 __ZN7ApiGLES10DrawArraysE16GfxPrimitiveTypejjj(i1 + 4620 | 0, i2, 0, i3, i4);
 return;
}

function __ZN12TLSAllocatorI14StackAllocatorE10ReallocateEPvji(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = HEAP32[gb + 1103852 >> 2] | 0;
 if (!i1) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = __ZN14StackAllocator10ReallocateEPvji(i1, i2, i3, i4) | 0;
 return i4 | 0;
}

function __Z50Application_CUSTOM_GetStreamProgressForLevelByNameP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return Math_fround(1.0);
}

function __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier(__Z20GetPersistentManagerv() | 0, i1, i2);
 return;
}

function __Z28GetAnimationScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1466572 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL35InitializeAnimationScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 295 | 0, fb + 296 | 0);
 i1 = HEAP32[gb + 1466572 >> 2] | 0;
 return i1 | 0;
}

function __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 160 >> 2] | 0) >>> 0 < i2 >>> 0;
 return i2 | 0;
}

function __Z18GetProjectionPlanePKN5physx14PxParticleBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, i1 | 0, i1 + 12 | 0);
 return;
}

function _reset_marker_reader(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 404 >> 2] | 0;
 HEAP32[i1 + 196 >> 2] = 0;
 HEAP32[i1 + 124 >> 2] = 0;
 HEAP32[i1 + 380 >> 2] = 0;
 HEAP8[i2 + 12 >> 0] = 0;
 HEAP8[i2 + 13 >> 0] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i2 + 160 >> 2] = 0;
 return;
}

function _printf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _vfprintf(HEAP32[gb + 191868 >> 2] | 0, i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateUpdateResolutionstruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) return;
 __Z20SetHasFrameToPresentb(0);
 __Z15SetIsFirstFrameb(1);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8numpunctIwEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474596 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8numpunctIcEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474572 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8messagesIwEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476340 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_8messagesIcEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1476332 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNK7dtCrowd26getAgentFromProximityIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 400 >> 2] | 0) <= (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 16 >> 2] | 0) + ((HEAP32[(HEAP32[i1 + 392 >> 2] | 0) + (i2 << 2) >> 2] | 0) * 608 | 0) | 0;
 return i2 | 0;
}

function __ZNK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i2 + 348 >> 2] | 0;
 if (!i1) return;
 _memcpy(HEAP32[i3 >> 2] | 0, HEAP32[i2 + 344 >> 2] | 0, i1 << 4 | 0) | 0;
 return;
}

function __ZNK5physx2Sc8BodyCore17getAngularDampingEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) i3 = 4; else if ((HEAP8[i1 + 31 >> 0] | 0) == 1) i1 = i1 + 52 | 0; else i3 = 4;
 if ((i3 | 0) == 4) i1 = i2 + 124 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZNK5physx14NpSpatialIndex12flushUpdatesEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 4 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 0;
  return;
 }
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZNK5physx11AdjTriangle22ComputeNbBoundaryEdgesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 >> 2] & 536870911 | 0) == 536870911;
 return ((HEAP32[i1 + 8 >> 2] & 536870911 | 0) == 536870911 & 1) + ((HEAP32[i1 + 4 >> 2] & 536870911 | 0) == 536870911 ? (i2 ? 2 : 1) : i2 & 1) | 0;
}

function __ZNK29LineParametersPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 return Math_fround(HEAPF32[(HEAP32[((HEAP32[i1 + 4 >> 2] | 0) == 120 ? i2 + 344 | 0 : i2 + 384 | 0) >> 2] | 0) + 16 >> 2]);
}

function __ZNK15b2RevoluteJoint13GetJointAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 52 >> 2] | 0) + 56 >> 2]);
 f2 = Math_fround(f2 - Math_fround(HEAPF32[(HEAP32[i1 + 48 >> 2] | 0) + 56 >> 2]));
 return Math_fround(f2 - Math_fround(HEAPF32[i1 + 116 >> 2]));
}

function __ZNK10UnityScene7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63824 | 0);
 return;
}

function __ZN9Scripting18RaiseNullExceptionEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i3 >> 2] = i2;
 __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi(gb + 466004 | 0, i1, i3);
}

function __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sc17ParticleSystemSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc17ParticleSystemSimD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData11setTireDataEjRKNS_17PxVehicleTireDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx23PxVehicleWheels4SimData11setTireDataEjRKNS_17PxVehicleTireDataE((HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i3);
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 95912 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5Unity17ConfigurableJoint27ApplyKeepConfigurationSpaceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i2) return;
 if ((mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0) | 0) & 1) return;
 __ZN5Unity17ConfigurableJoint7SetupD6Ev(i1);
 return;
}

function __ZN5Umbra9Matrix2x23detEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f3 = Math_fround(f3 * Math_fround(HEAPF32[i1 + 12 >> 2]));
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 return Math_fround(f3 - Math_fround(f2 * Math_fround(HEAPF32[i1 + 8 >> 2])));
}

function __ZN5Umbra16LineSegmentQueryC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i1 = i2 + 3 & -4;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN26AnimatorOverrideController15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 104 | 0;
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(HEAP32[i2 >> 2] | 0, i1 + 108 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN25MultiBlocksMemoryFileData9SetLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = ___udivdi3(i2 | 0, i3 | 0, HEAP32[i1 + 16 >> 2] | 0, 0) | 0;
 getTempRet0() | 0;
 __ZN25MultiBlocksMemoryFileData17AdjustBlocksCountEj(i1, i3);
 HEAP32[i1 + 40 >> 2] = i2;
 return;
}

function __ZN15dtProximityGrid5clearEv(i1) {
 i1 = i1 | 0;
 _memset(HEAP32[i1 + 20 >> 2] | 0, -1, HEAP32[i1 + 24 >> 2] << 1 | 0) | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 65535;
 HEAP32[i1 + 32 >> 2] = 65535;
 HEAP32[i1 + 36 >> 2] = -65535;
 HEAP32[i1 + 40 >> 2] = -65535;
 return;
}

function __ZN15OcclusionPortal22CalculatePortalEnabledEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(__ZNK10GameObject8IsActiveEv(i2) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (HEAP8[i1 + 72 >> 0] | 0) != 0;
 return i2 | 0;
}

function __ZN15LODGroupManager20ClearAllForceLODMaskEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 if (!i3) return;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 * 96 | 0) + 92 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while (i1 >>> 0 < i3 >>> 0);
 return;
}

function __ZN13RuntimeStaticI18UnityConnectClientE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13ProbeRendererC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 1;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 28 >> 0] = 0;
 __ZN7Hash1285ResetEv(i1);
 return;
}

function __Z29GetPhysicsScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457452 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL33InitializePhysicsScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 205 | 0, fb + 206 | 0);
 i1 = HEAP32[gb + 1457452 >> 2] | 0;
 return i1 | 0;
}

function __Z27Screen_CUSTOM_SetResolutioniihi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __Z16GetScreenManagerv() | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 8 >> 2] | 0, i5 | 0, i1 | 0, i2 | 0, i3 << 24 >> 24 != 0 | 0, i4 | 0);
 return;
}

function __Z23InternalStringGeneratorRN20TextRenderingPrivate19NativeTextGeneratorEbPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv(i1) | 0;
 return __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj(i1, i3) | 0;
}

function __Z23AssetBundle_CUSTOM_LoadP12Il2CppObjectP12Il2CppStringS0_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i3);
 STACKTOP = i1;
 return 0;
}

function _UNITY_png_info_init_3(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 if (i3 >>> 0 < 244) {
  HEAP32[i2 >> 2] = 0;
  _free(i1);
  i1 = _UNITY_png_malloc_base(0, 244) | 0;
  HEAP32[i2 >> 2] = i1;
 }
 _memset(i1 | 0, 0, 244) | 0;
 return;
}

function _srand48(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP16[i3 >> 1] = 13070;
 HEAP16[i3 + 2 >> 1] = i1;
 HEAP16[i3 + 4 >> 1] = i1 >>> 16;
 _seed48(i3) | 0;
 STACKTOP = i2;
 return;
}

function _llroundf(f1) {
 f1 = Math_fround(f1);
 f1 = Math_fround(+_roundf(+f1));
 setTempRet0((+Math_abs(+f1) >= 1.0 ? (+f1 > 0.0 ? ~~+Math_min(+Math_floor(+f1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f1 - +(~~+f1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~+f1 >>> 0 | 0;
}

function _getchar_unlocked() {
 var i1 = 0, i2 = 0, i3 = 0;
 i1 = HEAP32[gb + 191748 >> 2] | 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i3 + 1;
  i1 = HEAPU8[i3 >> 0] | 0;
 } else i1 = ___uflow(i1) | 0;
 return i1 | 0;
}

function __ZNSt3__26locale5__imp12install_fromINS_7collateIwEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474548 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_7collateIcEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474540 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 11 | 0;
 if ((HEAP8[i2 >> 0] | 0) < 0) {
  HEAP8[HEAP32[i1 >> 2] >> 0] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
 } else {
  HEAP8[i1 >> 0] = 0;
  HEAP8[i2 >> 0] = 0;
 }
 return;
}

function __ZNKSt3__212ctype_bynameIwE10do_toupperEPwPKw(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 + 8 | 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  HEAP32[i1 >> 2] = _towupper_l(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i1 = i1 + 4 | 0;
 }
 return i3 | 0;
}

function __ZNKSt3__212ctype_bynameIwE10do_tolowerEPwPKw(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 + 8 | 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  HEAP32[i1 >> 2] = _towlower_l(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i1 = i1 + 4 | 0;
 }
 return i3 | 0;
}

function __ZNK8Animator45IsRootTranslationOrRotationControllerByCurvesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 168 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 40 >> 2] | 0) != -1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 44 >> 2] | 0) != -1;
 return i1 | 0;
}

function __ZNK5physx2Sc8BodyCore16getLinearDampingEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) i3 = 4; else if ((HEAP8[i1 + 31 >> 0] | 0) == 1) i1 = i1 + 48 | 0; else i3 = 4;
 if ((i3 | 0) == 4) i1 = i2 + 120 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZNK18ScreenManagerWebGL12IsFullScreenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 288 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 _emscripten_get_fullscreen_status(i2 | 0) | 0;
 STACKTOP = i1;
 return (HEAP32[i2 >> 2] | 0) != 0 | 0;
}

function __ZNK14ParticleSystem28CalculateRequiredCatchupTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var f3 = f0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!(HEAP8[i1 + 277 >> 0] | 0)) return +d2;
 f3 = Math_fround(d2);
 d2 = +Math_fround(_fmodf(f3, Math_fround(HEAPF32[i1 + 264 >> 2])));
 return +d2;
}

function __ZNK12NavMeshAgent7HasPathEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 68 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
 i1 = __ZNK7dtCrowd7hasPathEi(i2, HEAP32[i1 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZNK12AudioManager18GetMemoryAllocatedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 _FMOD_Memory_GetStats(i2, 0, 1) | 0;
 STACKTOP = i1;
 return HEAP32[i2 >> 2] | 0;
}

function __ZN9GfxDevice22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return;
}

function __ZN8Animator10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour10DeactivateE19DeactivateOperation(i1, i2);
 __ZN8Animator26ClearRelatedPropertyBlocksEv(i1);
 __ZN8Animator11ClearObjectEv(i1);
 __ZN8Animator23ClearContainedRenderersEv(i1);
 return;
}

function __ZN5physx6shdfnd4Time17getElapsedSecondsEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0, d3 = 0.0;
 _gettimeofday(gb + 1457444 | 0, 0) | 0;
 d3 = +(HEAP32[gb + 1457444 >> 2] | 0) + +(HEAP32[gb + 1457444 + 4 >> 2] | 0) * 1.0e-06;
 d2 = d3 - +HEAPF64[i1 >> 3];
 HEAPF64[i1 >> 3] = d3;
 return +d2;
}

function __ZN5physx3Cct13BoxControllerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx30PxClothParticleGeneratedValuesC2EPKNS_15PxClothParticleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN26AnimatorOverrideController23GetAnimationSetBindingsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 104 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0);
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __ZN15dtLocalBoundaryC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 236 >> 2] = 0;
 HEAPF32[i1 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 4 >> 2] = Math_fround(3402823469999999843913219.0e14);
 HEAPF32[i1 + 8 >> 2] = Math_fround(3402823469999999843913219.0e14);
 return;
}

function __ZN15TerrainCollider12SetIsTriggerEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 1016694 | 0, 0, gb + 1016445 | 0, 346, 512, i1, 0, 0);
 return;
}

function __ZN15NavMeshSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI11NavMeshDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 28 | 0, i2);
 return;
}

function __ZN13GfxDeviceNull17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return;
}

function __ZN12_GLOBAL__N_110Connection6addRefEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 100 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = i1 + 104 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __Z45Rigidbody_Set_Custom_PropSleepAngularVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z35ReflectionProbeBlendInfoToScriptingRK24ReflectionProbeBlendInfoR33ScriptingReflectionProbeBlendInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(HEAP32[i1 >> 2] | 0) | 0;
 return;
}

function __Z20HandleSteppedTangentRK11KeyframeTplIfES2_Rf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i2 + 8 >> 2]) == Math_fround(inf))) return;
 HEAPF32[i3 >> 2] = Math_fround(inf);
 return;
}

function __Z18HandleSteppedCurveRK11KeyframeTplIfES2_Rf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(Math_fround(HEAPF32[i1 + 12 >> 2]) == Math_fround(inf))) if (!(Math_fround(HEAPF32[i2 + 8 >> 2]) == Math_fround(inf))) return;
 HEAP32[i3 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function _wcstombs(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 i3 = _wcsrtombs(i1, i5, i3, 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _testSetjmp(i3, i5, i4) {
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 while ((i2 | 0) < (i4 | 0)) {
  i1 = HEAP32[i5 + (i2 << 3) >> 2] | 0;
  if (!i1) break;
  if ((i1 | 0) == (i3 | 0)) return HEAP32[i5 + ((i2 << 3) + 4) >> 2] | 0;
  i2 = i2 + 1 | 0;
 }
 return 0;
}

function _tcgetattr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = ((_ioctl(i1, 21505, i4) | 0) != 0) << 31 >> 31;
 STACKTOP = i3;
 return i2 | 0;
}

function _strsep(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if (!i1) i1 = 0; else {
  i2 = i1 + (_strcspn(i1, i2) | 0) | 0;
  if (!(HEAP8[i2 >> 0] | 0)) i2 = 0; else {
   HEAP8[i2 >> 0] = 0;
   i2 = i2 + 1 | 0;
  }
  HEAP32[i3 >> 2] = i2;
 }
 return i1 | 0;
}

function _mbstowcs(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i2;
 i3 = _mbsrtowcs(i1, i5, i3, 0) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _emscripten_glCopyTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _emscripten_glCopyTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function __ZThn12_N5physx7NpShapeD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = i1 + -12 | 0;
 __ZN5physx7NpShapeD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZNSt3__28__c_nodeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 208104 + 8;
 _free(HEAP32[i1 + 12 >> 2] | 0);
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
  _free(HEAP32[i1 >> 2] | 0);
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj(i1, i2, _strlen(i2) | 0) | 0;
}

function __ZNKSt3__212ctype_bynameIcE10do_toupperEPcPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 + 16 | 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  HEAP8[i1 >> 0] = _toupper_l(HEAPU8[i1 >> 0] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 }
 return i3 | 0;
}

function __ZNKSt3__212ctype_bynameIcE10do_tolowerEPcPKc(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 + 16 | 0;
 while (1) {
  if ((i1 | 0) == (i3 | 0)) break;
  HEAP8[i1 >> 0] = _tolower_l(HEAPU8[i1 >> 0] | 0, HEAP32[i2 >> 2] | 0) | 0;
  i1 = i1 + 1 | 0;
 }
 return i3 | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZNK22LocalFileSystemHandler26GetApplicationContentsPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZNK16TypeTreeIterator4TypeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 + 4 >> 2] | 0) * 24 | 0) + 4 >> 2] | 0;
 return ((i1 | 0) < 0 ? HEAP32[gb + 36932 >> 2] | 0 : HEAP32[i2 + 20 >> 2] | 0) + (i1 & 2147483647) | 0;
}

function __ZNK16TypeTreeIterator4NameEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 i1 = HEAP32[(HEAP32[i2 >> 2] | 0) + ((HEAP32[i1 + 4 >> 2] | 0) * 24 | 0) + 8 >> 2] | 0;
 return ((i1 | 0) < 0 ? HEAP32[gb + 36932 >> 2] | 0 : HEAP32[i2 + 20 >> 2] | 0) + (i1 & 2147483647) | 0;
}

function __ZN8Playable14SetInputWeightEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (f3 < Math_fround(0.0) ? 1 : (HEAP32[i1 + 28 >> 2] | 0) >>> 0 <= i2 >>> 0) return;
 HEAPF32[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 3) >> 2] = f3;
 return;
}

function __ZN8Animator27ClearStateMachineBehavioursEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 426 >> 0] = 0;
 if (!(__ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0)) return;
 i1 = HEAP32[(HEAP32[i1 + 628 >> 2] | 0) + 20 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7Joint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 64 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 68 | 0;
 HEAP32[i3 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[HEAP32[i1 >> 2] >> 2] = i3;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx7NpScene14checkCollisionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 3692 >> 2] | 0;
 if (i2) {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, -1) | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx3Ext15CpuWorkerThreadD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Ext15CpuWorkerThreadD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx3Cct15ObstacleContextD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx3Cct15ObstacleContextD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE(i2, i3 + 32 | 0, i1 + (HEAP32[gb + 1457208 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) | 0);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData22setSuspTravelDirectionEjRKNS_6PxVec3E(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx23PxVehicleWheels4SimData22setSuspTravelDirectionEjRKNS_6PxVec3E((HEAP32[i3 + 32 >> 2] | 0) + ((i2 >>> 2) * 944 | 0) | 0, i2 & 3, i1);
 return;
}

function __ZN5physx16PxsIslandManager16clearEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAP32[i2 + 284 >> 2] | 0) + ((HEAP32[i1 >> 2] | 0) * 12 | 0) + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & 15;
 HEAP8[i2 + 477 >> 0] = 1;
 return;
}

function __ZN17Physics2DSettings20SetContactArrowScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(.100000001);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 + 100 >> 2] = i3 ? Math_fround(.100000001) : f2;
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner6addRefEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return;
}

function __ZL26InitializeModule_Physics2Dv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(628, gb + 63408 | 0, 16, gb + 807904 | 0, gb + 1576256 | 0, gb + 807923 | 0, 18) | 0;
 __ZN16Physics2DManagerC2Ev(i1);
 __Z19pop_allocation_rootv();
 __Z13SetIPhysics2DP10IPhysics2D(i1);
 return;
}

function __Z22setPxMeshScaleRotationPN5physx11PxMeshScaleENS_6PxQuatE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __Z21WWW_CUSTOM_DestroyWWWP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 if (!i1) {
  HEAP32[i3 >> 2] = 0;
  return;
 }
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = 0;
 if (!i1) return;
 __ZN3WWW7DestroyEPS_b(i1, i2 << 24 >> 24 != 0);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_5ctypeIwEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474588 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__26locale5__imp12install_fromINS_5ctypeIcEEEEvRKS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__26locale2id5__getEv(gb + 1474556 | 0) | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, __ZNKSt3__26locale5__imp9use_facetEl(i2, i3) | 0, i3);
 return;
}

function __ZNSt3__215__thread_struct25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__219__thread_struct_imp25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE(HEAP32[i1 >> 2] | 0, i2, i3);
 return;
}

function __ZNK5physx9PxD6Joint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765108 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 743901 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx7NpShape14getNbMaterialsEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 36 >> 2] & 2)) {
  i1 = __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv(i1 + 48 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP16[(HEAP32[i1 + 40 >> 2] | 0) + 116 >> 1] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx2Sc8BodyCore14getMaxAngVelSqEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) i3 = 4; else if ((HEAP8[i1 + 31 >> 0] | 0) == 1) i1 = i1 + 56 | 0; else i3 = 4;
 if ((i3 | 0) == 4) i1 = i2 + 112 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZNK5physx2Sc8BodyCore14getInverseMassEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (!i1) i3 = 4; else if ((HEAP8[i1 + 31 >> 0] | 0) == 1) i1 = i1 + 44 | 0; else i3 = 4;
 if ((i3 | 0) == 4) i1 = i2 + 140 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i1, HEAP32[i3 + 48 >> 2] | 0, i2);
 return;
}

function __ZNK22LocalFileSystemHandler25GetApplicationManagedPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZNK14ParticleSystem26GetCollisionEventsExternalEiP26MonoParticleCollisionEventi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZNK15CollisionEvents9GetEventsEiP26MonoParticleCollisionEventi((HEAP32[i1 + 32 >> 2] | 0) + 620 | 0, i2, i3, i4) | 0;
}

function __ZN9UdpSocketD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 65580 + 8;
 i1 = i2 + 4 | 0;
 if (!(HEAP8[i2 + 17 >> 0] | 0)) {
  HEAP32[i1 >> 2] = -1;
  i1 = -1;
 } else i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 65564 + 8;
 _close(i1) | 0;
 __ZdlPv(i2);
 return;
}

function __ZN5physx7NpShape10isWritableEv(i1) {
 i1 = i1 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP16[i1 + 6 >> 1] & 2) != 0;
 return i1 | 0;
}

function __ZN5physx2Sn13XmlWriterImpl10leaveChildEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 4 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 return;
}

function __ZN5physx29PxD6JointDriveGeneratedValuesC2EPKNS_14PxD6JointDriveE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN4FMOD4DSPI5resetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 HEAP32[i2 >> 2] = 78;
 HEAP32[i2 + 4 >> 2] = gb + 868857;
 _printf(gb + 857490 | 0, i2) | 0;
 STACKTOP = i1;
 return 78;
}

function __ZN2UI6Canvas23GetRootCanvasMeshBoundsEv(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i2; else break;
 }
 __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv(i3, i1);
 return;
}

function __ZN19SkinnedMeshRenderer22GetBonesPerVertexCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 460 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 i1 = HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 60 >> 2] | 0;
 return i1 | 0;
}

function __ZN19MemoryProfilerStats21AddDynamicObjectCountEP6Objecti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = i1 + 104 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 if ((i3 | 0) != 1) return;
 i3 = i1 + 108 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN17AnimationPlayable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0) == (i2 | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) | 0;
 return i2 | 0;
}

function __ZN14CachingManager18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(HEAP32[i1 + 4 >> 2] | 0, i2);
 return;
}

function __ZN13GfxDeviceGLES16CreateTimerQueryEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZnwjRK10MemLabelIdiPKci(32, gb + 63304 | 0, 16, gb + 603515 | 0, 1303) | 0;
 __ZN14TimerQueryGLESC2Ev(i1);
 return i1 | 0;
}

function __ZN13DrawImmediate5ColorEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 HEAPF32[i1 + 60 >> 2] = f2;
 HEAPF32[i1 + 64 >> 2] = f3;
 HEAPF32[i1 + 68 >> 2] = f4;
 HEAPF32[i1 + 72 >> 2] = f5;
 return;
}

function __ZN12_GLOBAL__N_119RendererEventClient19handleClientRemovedEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12IFileAdapter4SeekER13FileEntryDatax10FileOrigin(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZN10GCProfiler10ResetStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 i1 = i1 + 24 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __Z48setPxVehicleDriveSimData4W_AckermannGeometryDataPN5physx23PxVehicleDriveSimData4WERKNS_30PxVehicleAckermannGeometryDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE(i2, i1);
 return;
}

function __Z39Input_CUSTOM_INTERNAL_get_mousePositionP8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z15GetInputManagerv() | 0;
 i2 = HEAP32[i3 + 120 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 116 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __Z36Scene_CUSTOM_GetLoadingStateInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 80 >> 2] | 0;
 return i2 | 0;
}

function __Z26GetPhysicsScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457452 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL33InitializePhysicsScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 205 | 0, fb + 206 | 0);
 i1 = HEAP32[gb + 1457452 >> 2] | 0;
 return i1 | 0;
}

function __Z20dtAllocProximityGridv() {
 var i1 = 0, i2 = 0;
 i1 = __Z7dtAlloci(44) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return i1 | 0;
}

function __Z14UnquantizeBC6Hih(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 & 255;
 if ((i2 & 255) > 14) {
  i3 = i1;
  return i3 | 0;
 }
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 } else return (((1 << i3) + -1 | 0) == (i1 | 0) ? 65535 : (i1 << 16 | 32768) >> i3) | 0;
 return 0;
}

function __GLOBAL__sub_I_SparseTextureGLES_cpp() {
 HEAP32[gb + 1451152 + 4 >> 2] = 0;
 HEAP32[gb + 1451152 + 8 >> 2] = 0;
 HEAP32[gb + 1451152 >> 2] = gb + 1451152 + 4;
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1548978 | 0, fb + 3702 | 0, fb + 3703 | 0, 0, 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN47FixedUpdateScriptRunDelayedFixedFrameRatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = __Z21GetDelayedCallManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 1);
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 + -4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i4 | 0, i3 | 0, i2 | 0);
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN9Scripting11RaiseIfNullEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1057545 | 0, i2); else {
  STACKTOP = i2;
  return;
 }
}

function __ZN7mecanim9animation16DestroyDenseClipERNS0_9DenseClipERNS_6memory9AllocatorE(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 20 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 + i1 | 0);
 return;
}

function __ZN5physx8debugger4comm17StringHandleEvent9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 return;
}

function __ZN5physx7NpScene23addArticulationLinkBodyERNS_18NpArticulationLinkE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb(i2 + 16 | 0, i1 + 48 | 0, 0);
 __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE(i1 + 20 | 0, i1);
 return;
}

function __ZN5physx7NpScene12checkResultsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 3688 >> 2] | 0;
 if (i2) {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, -1) | 0;
  return i2 | 0;
 } else {
  i2 = __ZN5physx6shdfnd8SyncImpl4waitEj(i1, 0) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZN5physx2Sn13XmlNodeReader17popCurrentContextEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 28 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i2 = i2 + -1 | 0;
 HEAP32[i3 + 12 >> 2] = HEAP32[(HEAP32[i3 + 24 >> 2] | 0) + (i2 << 2) >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN5physx2Sc5Scene14updateDynamicsEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx10PxsContext14updateDynamicsEfPNS_10PxBaseTaskERNS_18PxsMaterialManagerE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(HEAPF32[i2 + 64 >> 2]), i1, i2);
 return;
}

function __ZN5physx14NpShapeManagerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(HEAP32[gb + 1457204 >> 2] | 0) + 440 >> 2] | 0;
 __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE(i1, i2);
 __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE(i1 + 8 | 0, i2);
 return;
}

function __ZN26AnimatorOverrideController11ClearMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 104 | 0;
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(HEAP32[i2 >> 2] | 0, i1 + 108 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN26AnimatorControllerPlayable9GotoStateEiifff(i1, i2, i3, f4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 __ZN26AnimatorControllerPlayable17GotoStateInternalEiifffb(i1, i2, i3, f4, f5, f6, 0);
 return;
}

function __ZN26AnimatorControllerPlayable24ClearFirstEvaluationFlagEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = (HEAP32[i1 + 100 >> 2] | 0) + 20 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) return;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN20OcclusionCullingData17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = __Z9GetIUmbrav() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18ScriptingArguments9AddObjectEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i3 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 5;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN17BillboardRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI14BillboardAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 344 | 0, i2);
 return;
}

function __ZN15RenderNodeQueueD2Ev(i1) {
 i1 = i1 | 0;
 __ZN15RenderNodeQueue7CleanupEv(i1);
 __ZN19AtomicPageAllocatorD2Ev(i1 + 20 | 0);
 if ((HEAP32[i1 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15CollisionModule9FreeCacheER19ParticleSystemState(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 444 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64024 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 448 >> 2] = 0;
 return;
}

function __ZN14NavMeshManager23InitializeCarvingSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 104 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = __ZnwjRK10MemLabelIdiPKci(112, gb + 63704 | 0, 16, gb + 842172 | 0, 1295) | 0;
 __ZN14NavMeshCarvingC2Ev(i2);
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13TranslateGLES28InitDepthBufferFormat2FormatERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 2264 | 0;
 HEAP32[i2 >> 2] = HEAP32[gb + 74484 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[gb + 74484 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[gb + 74484 + 8 >> 2];
 return;
}

function __Z27GetIMGUIScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1468884 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL31InitializeIMGUIScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 363 | 0, fb + 364 | 0);
 i1 = HEAP32[gb + 1468884 >> 2] | 0;
 return i1 | 0;
}

function __Z24GL_CUSTOM_MultiTexCoord3ifff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 var i5 = 0;
 i5 = __Z12GetGfxDevicev() | 0;
 mftCall_viifff(HEAP32[(HEAP32[i5 >> 2] | 0) + 576 >> 2] | 0, i5 | 0, i1 | 0, +f2, +f3, +f4);
 return;
}

function __Z22IsChildOrSameTransformP9TransformS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 L1 : do if (!i1) i1 = 0; else while (1) {
  if ((i1 | 0) == (i2 | 0)) {
   i1 = 1;
   break L1;
  }
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) {
   i1 = 0;
   break;
  }
 } while (0);
 return i1 | 0;
}

function __Z20SetStackTraceLogType17StackTraceLogType(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 73464 >> 2] = i1;
 HEAP32[gb + 73464 + 4 >> 2] = i1;
 HEAP32[gb + 73464 + 8 >> 2] = i1;
 HEAP32[gb + 73464 + 12 >> 2] = i1;
 HEAP32[gb + 73464 + 16 >> 2] = i1;
 HEAP32[gb + 73464 + 20 >> 2] = i1;
 return;
}

function __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem10ToAbsoluteEPKc(i1, i3, (HEAP8[i2 + 11 >> 0] | 0) < 0 ? HEAP32[i2 >> 2] | 0 : i2);
 return;
}

function __Z12GetTimestampv() {
 var d1 = 0.0;
 d1 = +_emscripten_get_now() * 1.0e6;
 setTempRet0((+Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~d1 >>> 0 | 0;
}

function _llrintf(f1) {
 f1 = Math_fround(f1);
 f1 = Math_fround(_rintf(f1));
 setTempRet0((+Math_abs(+f1) >= 1.0 ? (+f1 > 0.0 ? ~~+Math_min(+Math_floor(+f1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((+f1 - +(~~+f1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~+f1 >>> 0 | 0;
}

function _fwprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vfwprintf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _asprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vasprintf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZNSt3__28ios_base4moveERS0_(i1, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 72 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZNSt3__28ios_base4moveERS0_(i1, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 72 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveERS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZNSt3__28ios_base4moveERS0_(i1, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 72 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveEOS3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 __ZNSt3__28ios_base4moveERS0_(i1, i2);
 i3 = i2 + 72 | 0;
 HEAP32[i1 + 72 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i3 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNSt3__215__time_get_tempIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212ctype_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, 1);
 HEAP32[i1 >> 2] = gb + 214104 + 8;
 return;
}

function __ZNSt3__215__time_get_tempIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212ctype_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, 1);
 HEAP32[i1 >> 2] = gb + 214052 + 8;
 return;
}

function __ZNSt3__212strstreambufC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 215432 + 8;
 HEAP32[i1 + 32 >> 2] = 4;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 return;
}

function __ZNK5physx7PxCloth8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 764818 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 if (!(_strcmp(gb + 747111 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx2Sn5ConvX13resetNbErrorsEv(i2);
 return (__ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE(i2, i1, i3) | 0) != 0 | 0;
}

function __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb(i1, i2, i3, i5, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i4 = i4 | 0;
 return __ZL20updateMassAndInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb(1, i1, i2, i3, i5, i4) | 0;
}

function __ZN5Umbra9RasterOps4fillERNS_17BlockRasterBufferEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memset(HEAP32[i1 + 4 >> 2] | 0, i2 & 255 | 0, Math_imul((HEAPU8[i1 + 2 >> 0] | 0) - (HEAPU8[i1 >> 0] | 0) << 2, (HEAPU8[i1 + 3 >> 0] | 0) - (HEAPU8[i1 + 1 >> 0] | 0) | 0) | 0) | 0;
 return;
}

function __ZN26AnimatorOverrideController10ClearAssetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 104 | 0;
 __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE(HEAP32[i2 >> 2] | 0, i1 + 108 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN20ExternalForcesModule9FreeCacheER19ParticleSystemState(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 432 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) __Z19free_alloc_internalPvRK10MemLabelId(i3, gb + 64016 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 436 >> 2] = 0;
 return;
}

function __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb(HEAP32[i1 + 4 >> 2] | 0, i2, i3) | 0;
}

function __ZL25InitializeModule_Vehiclesv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 835882 | 0, gb + 1576256 | 0, gb + 835900 | 0, 73) | 0;
 HEAP32[i1 >> 2] = gb + 167072 + 8;
 __Z19pop_allocation_rootv();
 __Z12SetIVehiclesP9IVehicles(i1);
 return;
}

function __Z53Playable_CUSTOM_INTERNAL_CALL_CanChangeInputsInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] & 1 ^ 1) & 255;
 return i1 | 0;
}

function __Z38GUIClip_CUSTOM_INTERNAL_CALL_GetMatrixR10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (__Z11GetGUIStatev() | 0) + 108 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function _Round_To_Double_Grid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i2 + 16 + i3 & -32;
  i3 = (i3 | 0) < 0 ? 0 : i3;
  return i3 | 0;
 } else {
  i3 = 0 - (16 - i2 + i3 & -32) | 0;
  i3 = (i3 | 0) > 0 ? 0 : i3;
  return i3 | 0;
 }
 return 0;
}

function _glTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _glTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function __ZZN14Physics2DState10InitializeEvEN37FixedUpdatePhysics2DFixedUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i5 = i5 + -4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i4 | 0, i3 | 0, i2 | 0);
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj(i3 + -116 | 0, i2, i1) | 0;
}

function __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 77548 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 32 | 0);
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 return;
}

function __ZNSt3__214__shared_count16__release_sharedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if (!i2) {
  mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
  i1 = 1;
 } else i1 = 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKw(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj(i1, i2, i3, i4, _wcslen(i4) | 0) | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj(i1, i2, i3, i4, _strlen(i4) | 0) | 0;
}

function __ZNK5physx11AdjTriangle18ComputeNbNeighborsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 >> 2] & 536870911 | 0) != 536870911;
 return ((HEAP32[i1 + 8 >> 2] & 536870911 | 0) != 536870911 & 1) + ((HEAP32[i1 + 4 >> 2] & 536870911 | 0) == 536870911 ? i2 & 1 : i2 ? 2 : 1) | 0;
}

function __ZNK3WWW6IsDoneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  i2 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
  return i2 | 0;
 } else {
  i2 = __ZNK14UnityWebStream10IsFinishedEv(i2) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK14RenderSettings19GetFlatAmbientColorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 28 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK13SliderJoint2D17GetReferenceAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 100 >> 2]) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZN8Remapper16IsPreallocatedIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 36 >> 2] | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 if ((HEAP32[i1 + 28 >> 2] | 0) > (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 32 >> 2] | 0) >= (i2 | 0);
 return i2 | 0;
}

function __ZN7ApiGLES26BindDispatchIndirectBufferEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 908 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 37102, i3 | 0);
 return;
}

function __ZN5physx8debugger4comm15NameHandleValue9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 return;
}

function __ZN5physx8debugger4comm14AddProfileZone9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 + 16 | 0);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore11setGridSizeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 + 56 >> 2]);
 HEAP32[i2 + 76 >> 2] = __Z25computePacketSizeMultLog2ff(f1, Math_fround(f3 * Math_fround(HEAPF32[i2 + 52 >> 2]))) | 0;
 return;
}

function __ZN5physx2Gu5RTree15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 i1 = (HEAP32[i3 >> 2] | 0) + 127 & -128;
 HEAP32[i3 >> 2] = i1 + ((HEAP32[i2 + 80 >> 2] | 0) * 112 | 0);
 HEAP32[i2 + 92 >> 2] = i1;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc17ParticleSystemSim21prepareCollisionInputEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData20setWheelCentreOffsetEjRKNS_6PxVec3E((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5physx19TriangleMeshBuilderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Gu12TriangleMeshD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx17PxStringTableImplD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx17PxStringTableImplD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBuffer18GetNextPayloadSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if ((i2 | 0) == (HEAP32[i1 + 16 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + i2 >> 2] | 0;
 return i2 | 0;
}

function __ZN36ExternalForcesModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (i3 | 0) return;
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i2 + 880 >> 2] | 0) + 8 >> 2] = f4;
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation12GetDebugNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 365754 | 0, 31);
 return;
}

function __ZN2UI6Canvas22GetOrderOverrideCanvasEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  if (HEAP8[i1 + 375 >> 0] | 0) {
   i2 = 4;
   break;
  }
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) {
   i2 = 4;
   break;
  } else i1 = i2;
 }
 if ((i2 | 0) == 4) return i1 | 0;
 return 0;
}

function __ZN25VirtualJoystickPropertiesC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2);
 HEAP8[i1 + 12 >> 0] = i3 & 1;
 return;
}

function __ZN18ScriptingArguments8AddArrayEP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i3 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 7;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN16ScriptingManager29GetUserDefinedAssemblyPostfixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZN15DistanceJoint2D18SetMaxDistanceOnlyEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 100 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN7Joint2D8ReCreateEb(i1, 0);
 return;
}

function __ZN14PhysicsManager10SphereTestERK8Vector3ffi23QueryTriggerInteraction(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZN5Unity12PhysicsQuery10SphereTestERK8Vector3ffi23QueryTriggerInteraction(0, i2, f3, i4, i5) | 0;
}

function __ZN12_GLOBAL__N_15qAsinEff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 return Math_fround(Math_fround(+Math_asin(+(i3 ? Math_fround(-1.0) : f2))) * f1);
}

function __ZN12WheelJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher22ResetNetworkRetryIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 i2 = i1 + 84 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = HEAP32[HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 100 >> 2] >> 2];
 return;
}

function __Z37setPxParticleReadDataRestOffsetBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKfEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z33RenderSettings_Set_Custom_PropSunP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z17GetRenderSettingsv() | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN14RenderSettings6SetSunEP5Light(i2, i1);
 return;
}

function __Z26GetCoreScriptingClassesPtrv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451044 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL30InitializeCoreScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 181 | 0, fb + 182 | 0);
 i1 = HEAP32[gb + 1451044 >> 2] | 0;
 return i1 | 0;
}

function __Z25GUIStyleState_CUSTOM_InitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(20) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i2 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z17RuntimeInitializev() {
 if (HEAP8[gb + 1548962 >> 0] | 0) return;
 HEAP8[gb + 1548962 >> 0] = 1;
 __ZN13MemoryManager16StaticInitializeEv();
 __ZN10FileSystem5StartEv(__Z13GetFileSystemv() | 0);
 __ZN35RegisterRuntimeInitializeAndCleanup22ExecuteInitializationsEv();
 return;
}

function __Z14SetSHConstantsR28ApplyBuiltinInstancePropertyRK20SphericalHarmonicsL2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19ShaderPropertySheet20ReservePropertyCountEj(i1 + 8 | 0, 7);
 __Z16ApplySHConstantsI28ApplyBuiltinInstancePropertyEvRT_RK20SphericalHarmonicsL2(i1, i2);
 return;
}

function _Round_To_Half_Grid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i3 + i2 & -64 | 32;
  i3 = (i3 | 0) < 0 ? 32 : i3;
  return i3 | 0;
 } else {
  i3 = i3 - i2 & -64 | 32;
  i3 = (i3 | 0) < 0 ? -32 : 0 - i3 | 0;
  return i3 | 0;
 }
 return 0;
}

function _wcschr(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 if (!i3) i1 = i1 + ((_wcslen(i1) | 0) << 2) | 0; else {
  while (1) {
   i2 = HEAP32[i1 >> 2] | 0;
   if ((i2 | 0) == 0 | (i2 | 0) == (i3 | 0)) break; else i1 = i1 + 4 | 0;
  }
  i1 = i2 | 0 ? i1 : 0;
 }
 return i1 | 0;
}

function _swscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vswscanf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _sprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vsprintf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _fwscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vfwscanf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _fprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vfprintf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _dprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vdprintf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function ___tre_mem_new_impl(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) i1 = _calloc(1, 24) | 0; else {
  HEAP32[i1 >> 2] = 0;
  HEAP32[i1 + 4 >> 2] = 0;
  HEAP32[i1 + 8 >> 2] = 0;
  HEAP32[i1 + 12 >> 2] = 0;
  HEAP32[i1 + 16 >> 2] = 0;
  HEAP32[i1 + 20 >> 2] = 0;
 }
 return i1 | 0;
}

function __ZNSt3__218condition_variable10notify_oneEv(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(fb + 2798 | 0, i1 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNSt3__218condition_variable10notify_allEv(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(fb + 2799 | 0, i1 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNK5physx2Sc16ArticulationCore16createDriveCacheEfj(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK5physx2Sc15ArticulationSim16createDriveCacheEfj(i1, f2, i3) | 0;
 return i3 | 0;
}

function __ZNK5physx29PxClothSimpleTetherCookerImpl13getTetherDataEPjPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i2 | 0, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] << 2 | 0) | 0;
 _memcpy(i3 | 0, HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] << 2 | 0) | 0;
 return;
}

function __ZNK22LocalFileSystemHandler21GetUserAppCacheFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZNK14DataBufferGLES17UpdateCausesStallEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i2 >>> 0 > (HEAP32[i1 >> 2] | 0) >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 160 >> 2] | 0) >>> 0 < i2 >>> 0;
 return i2 | 0;
}

function __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 2172 + (i2 << 2) >> 2] | 0;
 if (!i3) {
  i3 = i1;
  return i3 | 0;
 }
 i3 = HEAP32[gb + 74780 + (i1 << 2) >> 2] | 0;
 return i3 | 0;
}

function __ZNK12HingeJoint2D17GetReferenceAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 116 >> 2]) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZN9Scripting16GetInstanceIDForEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZN5Umbra15BufferAllocatorC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 128 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 + 128 >> 2] = -1;
 HEAP32[i1 + 132 >> 2] = 0;
 HEAP32[i1 + 136 >> 2] = 1024;
 return;
}

function __ZN23AnimationOffsetPlayable11SetPositionE8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 HEAP32[i1 + 80 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 84 >> 2] = i4;
 HEAP32[i1 + 88 >> 2] = i3;
 return;
}

function __ZN18BackgroundJobQueueD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 21 | 0;
 if (HEAP8[i2 >> 0] | 0) HEAP8[i2 >> 0] = 0;
 if ((HEAP32[i1 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14dtPathCorridor10invalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 1;
 HEAP8[i1 + 44 >> 0] = 0;
 HEAP32[i1 + 48 >> 2] = HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + 56 >> 2];
 return;
}

function __ZN11UnityEngine15PlatformWrapper12GetScreenDPIEv() {
 var i1 = 0;
 if (!(__Z19GetScreenManagerPtrv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z16GetScreenManagerv() | 0;
 i1 = ~~Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
 return i1 | 0;
}

function __ZL24InitializeModule_Physicsv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 781758 | 0, gb + 1576256 | 0, gb + 781775 | 0, 255) | 0;
 HEAP32[i1 >> 2] = gb + 151472 + 8;
 __Z19pop_allocation_rootv();
 __Z11SetIPhysicsP8IPhysics(i1);
 return;
}

function __Z53VRSettings_Get_Custom_PropRenderViewportScaleInternalv() {
 var f1 = f0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 f1 = Math_fround(__ZNK8VRDevice22GetRenderViewportScaleEv(__Z12GetIVRDevicev() | 0));
 return Math_fround(f1);
}

function __Z38CalculateExplicitLightProbeCoordinatesiR29LightProbeSamplingCoordinates(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = i1;
 return;
}

function __Z24InitializeVehiclesModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 835882 | 0, gb + 1576256 | 0, gb + 835900 | 0, 73) | 0;
 HEAP32[i1 >> 2] = gb + 167072 + 8;
 __Z19pop_allocation_rootv();
 __Z12SetIVehiclesP9IVehicles(i1);
 return;
}

function __Z24GetIMGUIScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1468884 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL31InitializeIMGUIScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 363 | 0, fb + 364 | 0);
 i1 = HEAP32[gb + 1468884 >> 2] | 0;
 return i1 | 0;
}

function __Z19VehiclesNeedsUpdatev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1458700 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 1458540 >> 2] | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) != (HEAP32[i1 >> 2] | 0);
 return i1 | 0;
}

function __Z18CanRemoveComponentRN5Unity9ComponentEPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z19CanReplaceComponentRN5Unity9ComponentEiPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE(i1, 0, i2) | 0;
}

function _UNITY_png_get_uint_31(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0);
 if ((i1 | 0) < 0) _UNITY_png_error(i2, gb + 353053 | 0); else return i1 | 0;
 return 0;
}

function _UNITY_png_gamma_8bit_correct(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 + -1 | 0) >>> 0 < 254) {
  i2 = ~~+Math_floor(+(+Math_pow(+(+(i1 >>> 0) / 255.0), +(+(i2 | 0) * 1.0e-05)) * 255.0 + .5)) & 255;
  return i2 | 0;
 } else {
  i2 = i1 & 255;
  return i2 | 0;
 }
 return 0;
}

function _PxGetValue(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 4:
 case 2:
 case 0:
  {
   i1 = 196609;
   break;
  }
 case 1:
  {
   i1 = 131072;
   break;
  }
 case 3:
  {
   i1 = 131072;
   break;
  }
 case 5:
  {
   i1 = 131072;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function mftCall_fiff(i4, i1, d2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 3 | 0)) return +Math_fround(FUNCTION_TABLE_fiff[i4 - fb & 3](i1 | 0, Math_fround(d2), Math_fround(d3)));
 return +ftCall_fiff(i4 | 0, i1 | 0, +d2, +d3);
}

function _unity_z_inflateSyncPoint(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -2;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) {
  i1 = -2;
  return i1 | 0;
 }
 if ((HEAP32[i1 >> 2] | 0) == 13) i1 = (HEAP32[i1 + 60 >> 2] | 0) == 0; else i1 = 0;
 i1 = i1 & 1;
 return i1 | 0;
}

function _emscripten_glCopyTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _emscripten_glCopyTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function __ZZ23InitPlayerLoopCallbacksvEN46FixedUpdateScriptRunBehaviourFixedUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = __Z24GetFixedBehaviourManagerv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKw(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj(i1, i2, i3, i4, _wcslen(i4) | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj(i1, i2, i3, i4, _strlen(i4) | 0) | 0;
}

function __ZNSt3__211timed_mutex8try_lockEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (__ZNSt3__25mutex8try_lockEv(i2) | 0) {
  i1 = i2 + 76 | 0;
  if (!(HEAP8[i1 >> 0] | 0)) {
   HEAP8[i1 >> 0] = 1;
   i1 = 1;
  } else i1 = 0;
  __ZNSt3__25mutex6unlockEv(i2);
 } else i1 = 0;
 return i1 | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE16do_positive_signEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE16do_positive_signEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE16do_positive_signEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE16do_positive_signEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK9Transform18FindLastChildIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 92 >> 2] | 0;
 if (i2) do {
  i1 = HEAP32[(HEAP32[i1 + 80 >> 2] | 0) + (i2 + -1 << 2) >> 2] | 0;
  i2 = HEAP32[i1 + 92 >> 2] | 0;
 } while ((i2 | 0) != 0);
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZNK9Texture2D16CountDataMipmapsEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = __Z22CalculateMipMapCount3Diii(HEAP32[i1 + 84 >> 2] | 0, HEAP32[i1 + 88 >> 2] | 0, 1) | 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc15ArticulationSim17releaseDriveCacheERNS_9PxcFsDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 STACKTOP = i1;
 return;
}

function __ZNK22LocalFileSystemHandler20GetUserAppDataFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZNK15FileSystemEntry12LastModifiedEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 1040 >> 2] | 0;
 if (!i3) {
  __ZN8DateTimeC2Ev(i1);
  return;
 } else {
  mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
  return;
 }
}

function __ZNK12FixedJoint2D17GetReferenceAngleEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) * Math_fround(57.2957802));
 return Math_fround(f2);
}

function __ZN8Animator13IsPlayingBackEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 548 >> 2] | 0;
 if ((i2 | 0) == 1) {
  i2 = 1;
  return i2 | 0;
 }
 if ((i2 | 0) != 2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = Math_fround(HEAPF32[i1 + 420 >> 2]) < Math_fround(0.0);
 return i2 | 0;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 140 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + (HEAP32[gb + 1457020 + 68 + ((HEAPU16[i1 + 4 >> 1] | 0) << 2) >> 2] | 0) >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sn13XmlWriterImpl15addAndGotoChildEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 8 >> 2] | 0, i3 | 0, i1 | 0);
 i2 = i2 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN5physx2Sc5Scene22removeBroadPhaseRegionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZN5physx16PxsBroadPhaseMBPD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx16PxsBroadPhaseMBPD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13PxsCCDContext7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx13PxsCCDContextD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN4Tree23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI18SpeedTreeWindAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 return;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN13SpeedTreeWind8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 return;
}

function __ZN16MessageForwarder24GetExpectedParameterTypeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) >> 2 | 0) <= (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN15TextureSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 2 ? 2 : i2;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 1 ? 1 : i2;
 return;
}

function __ZN15SharedGfxBufferD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 58920 + 8;
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 236 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN15LocationService15GetLastLocationEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN14dtPathCorridor12setStateFlagEbh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i2) {
  i2 = i1 + 44 | 0;
  HEAP8[i2 >> 0] = HEAP8[i2 >> 0] | i3;
  return;
 } else {
  i2 = i1 + 44 | 0;
  HEAP8[i2 >> 0] = (HEAPU8[i2 >> 0] | 0) & (i3 & 255 ^ 255);
  return;
 }
}

function __ZN13WebCamTexture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0);
 i1 = i1 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12GUIClipStateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~(((i2 + -56 - i3 | 0) >>> 0) / 56 | 0) * 56 | 0);
 __ZdlPv(i3);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher29ResetDispatchSessionContainerERNS0_16SessionContainerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv(i2);
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 1;
 return;
}

function __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Object8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_(i1 + 28 | 0, i2);
 return;
}

function __Z41Animation_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z38Rigidbody_Set_Custom_PropSleepVelocityP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE(i1, i2, i3, i4, 0);
 return;
}

function __Z29AnimationCurve_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 72 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 56 >> 2] | 0, i1 + 60 | 0);
 __ZdlPv(i1);
 return;
}

function __GLOBAL__sub_I_runtime_plugininterface_lump_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546601 | 0, fb + 3419 | 0, fb + 3420 | 0, -1, 0);
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1546602 | 0, fb + 3421 | 0, 0, 0, 0);
 return;
}

function _sscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vsscanf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _fscanf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 i3 = _vfscanf(i1, i2, i5) | 0;
 STACKTOP = i4;
 return i3 | 0;
}

function _bind_textdomain_codeset(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) i3 = 5; else if (!(HEAP8[i1 >> 0] | 0)) i3 = 5; else if (i2 | 0) if (_strcasecmp(i2, gb + 1073753 | 0) | 0) i3 = 5;
 if ((i3 | 0) == 5) HEAP32[(___errno_location() | 0) >> 2] = 22;
 return 0;
}

function __ZorRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Scalar4fC2Ejjjj(i1, HEAP32[i3 >> 2] | HEAP32[i2 >> 2], HEAP32[i3 + 4 >> 2] | HEAP32[i2 + 4 >> 2], HEAP32[i3 + 8 >> 2] | HEAP32[i2 + 8 >> 2], HEAP32[i3 + 12 >> 2] | HEAP32[i2 + 12 >> 2]);
 return;
}

function __ZeoRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Scalar4fC2Ejjjj(i1, HEAP32[i3 >> 2] ^ HEAP32[i2 >> 2], HEAP32[i3 + 4 >> 2] ^ HEAP32[i2 + 4 >> 2], HEAP32[i3 + 8 >> 2] ^ HEAP32[i2 + 8 >> 2], HEAP32[i3 + 12 >> 2] ^ HEAP32[i2 + 12 >> 2]);
 return;
}

function __ZanRK8Scalar4fS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Scalar4fC2Ejjjj(i1, HEAP32[i3 >> 2] & HEAP32[i2 >> 2], HEAP32[i3 + 4 >> 2] & HEAP32[i2 + 4 >> 2], HEAP32[i3 + 8 >> 2] & HEAP32[i2 + 8 >> 2], HEAP32[i3 + 12 >> 2] & HEAP32[i2 + 12 >> 2]);
 return;
}

function __ZZN15TerrainCollider15InitializeClassEvEN30FunctorImpl_379kTerrainChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i3 + 4 >> 2] | 0) != 256) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn4_N12MemoryStreamD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 HEAP32[i1 >> 2] = gb + 113908 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 113908 + 32;
 if (!(HEAP8[i1 + 8 >> 0] | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 24 >> 2] | 0, gb + 63552 | 0);
 return;
}

function __ZNSt3__213random_deviceD2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(fb + 2812 | 0, HEAP32[i1 >> 2] | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNK8VRDevice10ShouldQuitEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 236 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_i(i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx7NpShape18getQueryFilterDataEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 48 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZNK22LocalFileSystemHandler19GetUserConfigFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZN9ShaderLab14TopParserStateEv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 1166560 >> 2] | 0;
 i1 = (HEAP32[i2 + 20 >> 2] | 0) + -1 + (HEAP32[i2 + 16 >> 2] | 0) | 0;
 return HEAP32[(HEAP32[(HEAP32[i2 + 4 >> 2] | 0) + (i1 >>> 10 << 2) >> 2] | 0) + ((i1 & 1023) << 2) >> 2] | 0;
}

function __ZN8Animator15BindingsDataSet5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE(HEAP32[i1 >> 2] | 0, i1 + 8 | 0);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN6Object15SetIsPersistentEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 | 0;
 __Z27profiler_change_persistancyibb(HEAP32[i1 + 4 >> 2] | 0, (HEAP32[i3 >> 2] & 1048576 | 0) != 0, i2);
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] & -1048577 | (i2 & 1) << 20;
 return;
}

function __ZN5physx7PxvInitERKNS_14PxvOffsetTableE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __Z17PxcPoolMallocInitv();
 i3 = gb + 1457360 | 0;
 i2 = i3 + 12 | 0;
 do {
  HEAP8[i3 >> 0] = HEAP8[i1 >> 0] | 0;
  i3 = i3 + 1 | 0;
  i1 = i1 + 1 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN5physx7NpScene15SceneCompletion7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[HEAP32[i2 + 20 >> 2] >> 2] | 0);
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ERKS5_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 __ZN8Scalar4fC2ERKS_(i2, i1);
 i3 = i1 + 16 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx43solveFrictionCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13setBreakForceEff(i2, f1, f3) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 f3 = Math_fround(f3);
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viff(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, +f1, +f3);
 return;
}

function __ZN5physx3Cct10Controller15releaseInternalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 464 >> 2] | 0;
 __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE(i2, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0);
 return;
}

function __ZN5physx2Sn13XmlNodeWriter6endTagEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = i3 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) HEAP32[i1 >> 2] = HEAP32[i2 + 20 >> 2];
 i1 = i3 + 16 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = i2 + -1;
 return;
}

function __ZN5physx2Sc8ClothSim8reinsertEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE(i2, i1);
 __ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE(i2, i1) | 0;
 return;
}

function __ZN5physx2Gu9ContaineraSERKS1_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Gu9Container7SetSizeEj(i2, HEAP32[i1 + 4 >> 2] | 0) | 0;
 _memcpy(HEAP32[i2 + 8 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0, HEAP32[i2 >> 2] << 2 | 0) | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN5physx19NpArticulationJointD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 HEAP32[i1 >> 2] = gb + 91416 + 8;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14NpSpatialIndex5flushEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 4 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) {
  HEAP8[i1 >> 0] = 0;
  return;
 }
 i2 = HEAP32[i2 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN25SingleBlockMemoryFileDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 71752 + 8;
 if ((HEAP32[i1 + 32 >> 2] | 0) <= -1) return;
 i2 = i1 + 16 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 20 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh16SetCharacterSizeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 60 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN18CrashReportManager33OnPlayerSessionStateChangedStaticEjyy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN18CrashReportManager27OnPlayerSessionStateChangedEjyy(__Z21GetManagerFromContexti(23) | 0, i1, 0, 0, 0, 0);
 return;
}

function __ZN18BuoyancyEffector2D16SetFlowVariationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 116 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN18BuoyancyEffector2D16SetFlowMagnitudeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 112 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN13TrailRenderer11TrailPointsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 56200 + 8;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN10VertexData14AllocateMemoryEj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 16 | 0;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 32, gb + 63232 | 0, 0, gb + 430527 | 0, 81) | 0;
 if (!i2) return i2 | 0;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 return i2 | 0;
}

function __Z23InitializePhysicsModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 781758 | 0, gb + 1576256 | 0, gb + 781775 | 0, 255) | 0;
 HEAP32[i1 >> 2] = gb + 151472 + 8;
 __Z19pop_allocation_rootv();
 __Z11SetIPhysicsP8IPhysics(i1);
 return;
}

function __Z23GetCoreScriptingClassesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451044 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZL30InitializeCoreScriptingClassesv();
 __Z27SetupModuleScriptingClassesPFvvES0_(fb + 181 | 0, fb + 182 | 0);
 i1 = HEAP32[gb + 1451044 >> 2] | 0;
 return i1 | 0;
}

function _Round_Up_To_Grid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i2 + 63 + i3 & -64;
  i3 = (i3 | 0) < 0 ? 0 : i3;
  return i3 | 0;
 } else {
  i3 = 0 - (63 - i2 + i3 & -64) | 0;
  i3 = (i3 | 0) > 0 ? 0 : i3;
  return i3 | 0;
 }
 return 0;
}

function _tt_cmap13_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 13;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 9 >> 0] | 0) << 16 | (HEAPU8[i1 + 8 >> 0] | 0) << 24 | (HEAPU8[i1 + 10 >> 0] | 0) << 8 | (HEAPU8[i1 + 11 >> 0] | 0);
 return 0;
}

function _tt_cmap12_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 12;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 9 >> 0] | 0) << 16 | (HEAPU8[i1 + 8 >> 0] | 0) << 24 | (HEAPU8[i1 + 10 >> 0] | 0) << 8 | (HEAPU8[i1 + 11 >> 0] | 0);
 return 0;
}

function _tt_cmap10_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 10;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 9 >> 0] | 0) << 16 | (HEAPU8[i1 + 8 >> 0] | 0) << 24 | (HEAPU8[i1 + 10 >> 0] | 0) << 8 | (HEAPU8[i1 + 11 >> 0] | 0);
 return 0;
}

function __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13GetFloatValueEPv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 268 | 0;
 return Math_fround((HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 256 | 0 ? Math_fround(1.0) : Math_fround(0.0));
}

function __ZNKSt3__210moneypunctIwLb1EE14do_curr_symbolEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE14do_curr_symbolEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE14do_curr_symbolEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE14do_curr_symbolEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZNK13MonoBehaviour25ShouldRunScriptableObjectEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP8[i1 + 36 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = ((HEAP32[i1 + 28 >> 2] | 0) + -1 | 0) >>> 0 < 2;
 return i1 | 0;
}

function __ZNK13GfxDeviceGLES14GetScissorRectEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 7164 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN9ShaderLab9IntShader19SetMaximumShaderLODEP6Shaderi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 56 | 0;
 if ((HEAP32[i4 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i4 >> 2] = i3;
 __ZN9ShaderLab9IntShader8PostLoadEP6Shader(i1, i2);
 return;
}

function __ZN9GfxDevice11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return;
}

function __ZN8VRModule11VRLoadSceneEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i3 | 0) == 0 & (__Z12GetIVRDevicev() | 0) != 0)) return;
 __ZN8VRDevice15InitializePosesEv(__Z12GetIVRDevicev() | 0);
 return;
}

function __ZN8Playable7GetTypeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i1 = HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 192 >> 2] | 0;
  return i1 | 0;
 } else {
  i1 = __Z26scripting_object_get_classP12Il2CppObject(i1) | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZN8Playable19PrepareFrameVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN7ApiGLES22BindDrawIndirectBufferEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 912 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 36671, i3 | 0);
 return;
}

function __ZN5physx8debugger4comm11CreateClass9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 4 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 return;
}

function __ZN5physx36PxVehicleWheels4SimDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 835762;
 HEAP32[i1 + 4 >> 2] = 608;
 HEAP32[i1 + 8 >> 2] = fb + 2428;
 HEAP32[i1 + 12 >> 2] = gb + 835781;
 HEAP32[i1 + 16 >> 2] = 609;
 HEAP32[i1 + 20 >> 2] = fb + 2429;
 return;
}

function __ZN5physx2Sq16BucketPrunerCore17setExternalMemoryEjPNS_9PxBounds3EPNS0_13PrunerPayloadE(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[i4 >> 2] = i2;
 HEAP32[i4 + 8 >> 2] = i1;
 HEAP32[i4 + 12 >> 2] = i3;
 HEAP32[i4 + 16 >> 2] = 0;
 return;
}

function __ZN5physx2Sc13ConstraintSim11projectPoseEPNS0_7BodySimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx20PxsConstraintProjectEPKNS_13PxsConstraintEbf(i2 + 32 | 0, (HEAP32[i2 + 112 >> 2] | 0) == (i1 | 0), Math_fround(HEAPF32[(HEAP32[i2 + 96 >> 2] | 0) + 64 >> 2]));
 return;
}

function __ZN5physx2Cm12RenderBufferD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Cm12RenderBufferD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx14NpSpatialIndex11rebuildFullEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 __ZN5physx2Sq10AABBPruner5purgeEv(HEAP32[i2 >> 2] | 0);
 i2 = HEAP32[i2 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 HEAP8[i1 + 4 >> 0] = 0;
 return;
}

function __ZN5Umbra4AABB13flattenToSideEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) < 3) {
  HEAP32[i1 + 12 + (i2 << 2) >> 2] = HEAP32[i1 + (i2 << 2) >> 2];
  return;
 } else {
  i2 = i2 + -3 | 0;
  HEAP32[i1 + (i2 << 2) >> 2] = HEAP32[i1 + 12 + (i2 << 2) >> 2];
  return;
 }
}

function __ZN4glsl22IsShaderParameterArrayEPKciiPb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i2 | 0) > 3) i1 = (_strcmp(i1 + i2 + -3 | 0, gb + 435660 | 0) | 0) == 0; else i1 = 0;
 if (i4 | 0) HEAP8[i4 >> 0] = i1 & 1;
 return (i3 | 0) > 1 | i1 | 0;
}

function __ZN17SurfaceEffector2D17SetSpeedVariationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 96 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN14ParticleSystem13SetUsesTrailsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i1 + 874 | 0;
 if (HEAP8[i2 >> 0] | 0) return;
 HEAP8[i2 >> 0] = 1;
 __ZN14ParticleTrails10ReallocateEjj(i1 + 740 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, -1);
 return;
}

function __ZN14GfxContextGLESD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE(i1, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN13SpringJoint2D5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN15AnchoredJoint2D5ResetEv(i1);
 HEAPF32[i1 + 96 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 104 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 108 >> 0] = 1;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN13GfxDeviceGLES18BeforePluginRenderEv(i1) {
 i1 = i1 | 0;
 __ZN18GfxFramebufferGLES7PrepareEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0);
 __Z14CheckErrorGLESPK7ApiGLESPKcS3_l(i1 + 4620 | 0, gb + 604335 | 0, gb + 603515 | 0, 299) | 0;
 return;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP8[i1 + 5 >> 0] = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher24IsArchivedSessionExpiredEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ((i2 + -1 | 0) >>> 0 < i3 >>> 0 ? ((HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 8 >> 2] | 0) + -1 | 0) >>> 0 < (i3 - i2 | 0) >>> 0 : 0) | 0;
}

function __ZL28PostprocessWebGLGraphicsCapsv() {
 var i1 = 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 518 >> 0] | 0)) i1 = 0; else i1 = ((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0) + -2 | 0) >>> 0 < 3 & 1;
 HEAP8[(__Z15GetGraphicsCapsv() | 0) + 518 >> 0] = i1;
 return;
}

function __Z43Application_CUSTOM_CanStreamedLevelBeLoadedi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 | 0) <= -1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z16GetBuildSettingsv() | 0;
 i1 = ((HEAP32[i2 + 32 >> 2] | 0) - (HEAP32[i2 + 28 >> 2] | 0) >> 4 | 0) > (i1 | 0) & 1;
 return i1 | 0;
}

function __Z26CleanupTextRenderingModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__ZN13TextRendering17GetITextRenderingEv() | 0, gb + 63392 | 0);
 __ZN13TextRendering17SetITextRenderingEPNS_14ITextRenderingE(0);
 __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv();
 return;
}

function __Z24ClearRegisteredVRDevicesv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1469348 >> 2] | 0;
 i2 = HEAP32[gb + 1469348 + 4 >> 2] | 0;
 if ((i2 | 0) == (i1 | 0)) return;
 HEAP32[gb + 1469348 + 4 >> 2] = i2 + (~(((0 - i1 + (i2 + -668) | 0) >>> 0) / 668 | 0) * 668 | 0);
 return;
}

function __Z23GetRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == 1) {
  i2 = __ZN13RenderTexture9GetActiveEi(0) | 0;
  return i2 | 0;
 } else {
  i2 = HEAP32[i1 + 4 + (i2 << 2) >> 2] | 0;
  return i2 | 0;
 }
 return 0;
}

function __Z18get_root_referencePvRK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i2) | 0;
 return HEAP32[(mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 | 0) | 0) >> 2] | 0;
}

function _UNITY_tt_face_load_post(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1886352244, i2 | 0, 0) | 0;
 if (i3 | 0) return i3 | 0;
 i3 = _UNITY_FT_Stream_ReadFields(i2, gb + 223464 | 0, i1 + 468 | 0) | 0;
 return i3 | 0;
}

function _UNITY_tt_face_load_pclt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1346587732, i2 | 0, 0) | 0;
 if (i3 | 0) return i3 | 0;
 i3 = _UNITY_FT_Stream_ReadFields(i2, gb + 223348 | 0, i1 + 548 | 0) | 0;
 return i3 | 0;
}

function _UNITY_tt_face_load_head(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1751474532, i2 | 0, 0) | 0;
 if (i3 | 0) return i3 | 0;
 i3 = _UNITY_FT_Stream_ReadFields(i2, gb + 223264 | 0, i1 + 160 | 0) | 0;
 return i3 | 0;
}

function _UNITY_tt_face_load_bhed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_iiiii(HEAP32[i1 + 508 >> 2] | 0, i1 | 0, 1651008868, i2 | 0, 0) | 0;
 if (i3 | 0) return i3 | 0;
 i3 = _UNITY_FT_Stream_ReadFields(i2, gb + 223264 | 0, i1 + 160 | 0) | 0;
 return i3 | 0;
}

function mftCall_fiif(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1 | 0)) return +Math_fround(FUNCTION_TABLE_fiif[i4 - fb & 1](i1 | 0, i2 | 0, Math_fround(d3)));
 return +ftCall_fiif(i4 | 0, i1 | 0, i2 | 0, +d3);
}

function __ZThn32_NK8Renderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i1 = i1 + -32 | 0;
 i4 = HEAP16[i1 + 218 >> 1] | 0;
 i3 = i4 & 65535;
 return (i4 << 16 >> 16 == 0 | (i3 | 0) > (i2 | 0) ? i2 : i3 + -1 | 0) + (HEAPU16[i1 + 216 >> 1] | 0) | 0;
}

function __ZThn12_NK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZThn12_NK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i2 + 876 + (i3 << 3) | 0;
 i2 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i1;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i2;
 return;
}

function __ZN9GfxDevice26InsertCustomMarkerCallbackEPFviEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 mftCall_vi(i2 | 0, i3 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7Terrain27GetSplatMaterialCustomPropsER19ShaderPropertySheet(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 116 >> 2] | 0;
 if (!i1) {
  __ZN19ShaderPropertySheet5ClearEb(i2, 1);
  return;
 } else {
  __ZN19ShaderPropertySheet8CopyFromERKS_(i2, i1);
  return;
 }
}

function __ZN7Joint2D10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 52 >> 0] = 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, (i2 + -1 | 0) >>> 0 < 2 | 0);
 __ZN9Behaviour10DeactivateE19DeactivateOperation(i1, i2);
 return;
}

function __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19setTypePairFrictionEjjf(i2, i1, i3, f4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 HEAPF32[(HEAP32[i2 >> 2] | 0) + ((Math_imul(HEAP32[i2 + 20 >> 2] | 0, i1) | 0) + i3 << 2) >> 2] = f4;
 return;
}

function __ZN5physx2Sn5ConvX6read64ERPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 8;
 i1 = HEAP32[i3 >> 2] | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEy(i2, i1, i3);
 setTempRet0(i3 | 0);
 return i1 | 0;
}

function __ZN5physx27PxDefaultMemoryOutputStreamD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 87532 + 8;
 i1 = HEAP32[i2 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx20PxVehiclePostUpdatesEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE(i2, i1, i3);
 return;
}

function __ZN5Umbra5QueryC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i1 = i2 + 3 & -4;
 i2 = i3 + 120 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN20TextRenderingPrivate8TextMesh14SetLineSpacingEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 64 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN18BuoyancyEffector2D15SetSurfaceLevelEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 92 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN14GfxDeviceStats16ResetClientStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 136 >> 2] = 0;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAPF32[i1 + 272 >> 2] = Math_fround(0.0);
 return;
}

function __ZN13GfxDeviceGLES21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 __ZN7ApiGLES13DeleteProgramERj(i1 + 4620 | 0, i3);
 __ZdlPv(i3);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES12DeleteBufferEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9GfxDevice14OnDeleteBufferEP9GfxBuffer(i1, i2);
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12LineRenderer10LinePointsD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 44764 + 8;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i1);
 return;
}

function __ZN11TypeManager18InitializeAllTypesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z20push_allocation_rootPvP13BaseAllocatorb(HEAP32[gb + 1110260 >> 2] | 0, 0, 0) | 0;
 __ZN11TypeManager25InitializeDerivedFromInfoEv(i1);
 if (!i2) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZL25GetSubmeshTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj(i1, i3, i2);
 return;
}

function __ZL19StaticCleanupPlayerPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1450972 >> 2] | 0;
 if (i1 | 0) __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63680 | 0);
 HEAP32[gb + 1450972 >> 2] = 0;
 return;
}

function __Z35Resources_CUSTOM_UnloadUnusedAssetsv() {
 var i1 = 0, i2 = 0;
 i2 = __Z33CreateUnloadUnusedAssetsOperationb(1) | 0;
 i1 = __Z20scripting_object_newP11Il2CppClass(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 36 >> 2] | 0) | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return i1 | 0;
}

function __Z29LightmapSettings_CUSTOM_Resetv() {
 var i1 = 0;
 i1 = __Z19GetLightmapSettingsv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 i1 = __Z19GetLightmapSettingsv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 return;
}

function mftCall_fiii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 31 | 0)) return +Math_fround(FUNCTION_TABLE_fiii[i4 - fb & 31](i1 | 0, i2 | 0, i3 | 0));
 return +ftCall_fiii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
}

function _tt_cmap8_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 8;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 9 >> 0] | 0) << 16 | (HEAPU8[i1 + 8 >> 0] | 0) << 24 | (HEAPU8[i1 + 10 >> 0] | 0) << 8 | (HEAPU8[i1 + 11 >> 0] | 0);
 return 0;
}

function _tt_cmap13_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = (HEAPU8[i2 + 13 >> 0] | 0) << 16 | (HEAPU8[i2 + 12 >> 0] | 0) << 24 | (HEAPU8[i2 + 14 >> 0] | 0) << 8 | (HEAPU8[i2 + 15 >> 0] | 0);
 HEAP8[i1 + 24 >> 0] = 0;
 return 0;
}

function _tt_cmap12_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = (HEAPU8[i2 + 13 >> 0] | 0) << 16 | (HEAPU8[i2 + 12 >> 0] | 0) << 24 | (HEAPU8[i2 + 14 >> 0] | 0) << 8 | (HEAPU8[i2 + 15 >> 0] | 0);
 HEAP8[i1 + 24 >> 0] = 0;
 return 0;
}

function _psnames_get_service(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = _UNITY_ft_service_list_lookup(HEAP32[HEAP32[i1 + 204 >> 2] >> 2] | 0, i2) | 0;
 return i2 | 0;
}

function _glTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 _glTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0, i9 | 0);
}

function _cf2_hintmask_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 4 | 0;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 12 >> 2] = 0;
 HEAP32[i3 + 16 >> 2] = 0;
 HEAP32[i3 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZZN14Physics2DState10InitializeEvEN30PreUpdatePhysics2DUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn32_N22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZNK14StackAllocator20IsOverflowAllocationEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i1 + 44 | 0) | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZN5physx34solveContactCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   i1 = HEAP32[i1 + 4 >> 2] | 0;
   break;
  }
 case 2:
  {
   i1 = HEAP32[i1 + 8 >> 2] | 0;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN5physx2Sc5Scene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx10PxsContext27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx20PxsParticleSystemSim18packetShapesUpdateEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx10PxsContext28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5Umbra20ObjectDistanceParamsC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 return;
}

function __ZN29TriggerModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (i3 | 0) return;
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAPF32[(HEAP32[i2 + 912 >> 2] | 0) + 24 >> 2] = f4;
 return;
}

function __ZN27UnloadUnusedAssetsOperation12GetDebugNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 461113 | 0, 22);
 return;
}

function __ZN19SpriteMeshGenerator4path4clipEv(i1) {
 i1 = i1 | 0;
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i1, 1);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i1, 2);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i1, 8);
 __ZN19SpriteMeshGenerator4path9clip_edgeEi(i1, 4);
 return;
}

function __ZN16ParticleRenderer19SetUVAnimationYTileEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 i2 = i3 + 360 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN16ParticleRenderer16GenerateUVFramesEv(i3);
 return;
}

function __ZN16ParticleRenderer19SetUVAnimationXTileEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 i2 = i3 + 356 | 0;
 if ((i1 | 0) == (HEAP32[i2 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN16ParticleRenderer16GenerateUVFramesEv(i3);
 return;
}

function __ZN15QualitySettings17SetShadowCascadesEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 1) i1 = 1; else if ((i1 | 0) > 4) i1 = 4; else i1 = (i1 | 0) == 3 ? 2 : i1;
 HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + ((HEAP32[i2 + 44 >> 2] | 0) * 108 | 0) + 32 >> 2] = i1;
 return;
}

function __ZN15PointEffector2D17SetForceVariationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 96 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN15PointEffector2D17SetForceMagnitudeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 92 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN14ObjectGUIState10BeginOnGUIEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP32[i1 >> 2] = 1;
 return;
}

function __ZN14NavMeshManager32SetOffMeshConnectionCostOverrideEyf(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i1) return;
 __ZN9dtNavMesh32setOffMeshConnectionCostModifierEyf(i1, i2, i3, f4) | 0;
 return;
}

function __ZN14GfxDeviceStats19EndRenderFrameStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 HEAP8[i1 + 280 >> 0] = 0;
 d3 = +__Z19GetTimeSinceStartupv();
 i2 = i1 + 276 | 0;
 HEAPF32[i2 >> 2] = Math_fround(d3 - +HEAPF64[i1 + 264 >> 3] + +Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZN14GfxDeviceStats19EndClientFrameStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 HEAP8[i1 + 280 >> 0] = 0;
 d3 = +__Z19GetTimeSinceStartupv();
 i2 = i1 + 272 | 0;
 HEAPF32[i2 >> 2] = Math_fround(d3 - +HEAPF64[i1 + 264 >> 3] + +Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZN14CompletionTaskC2Ev(i1) {
 i1 = i1 | 0;
 HEAP16[i1 + 4 >> 1] = -1;
 HEAP16[i1 + 6 >> 1] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 87444 + 8;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP8[i1 + 20 >> 0] = 0;
 return;
}

function __ZN14AreaEffector2D17SetForceVariationEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 100 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN13UnityProfiler22DomainReloadedCallbackEv() {
 var i1 = 0, i2 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) return;
 i2 = i1 + 56 | 0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if ((i1 | 0) != (i2 | 0)) do i1 = HEAP32[i1 + 4 >> 2] | 0; while ((i1 | 0) != (i2 | 0));
 return;
}

function __ZN13MonoBehaviour22CanHandleNotificationsEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (HEAP32[(HEAP32[i1 + 60 >> 2] | 0) + (i2 + 27 << 3) >> 2] | 0) != 0;
 return i3 | 0;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStream7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12CubemapArray17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 106 >> 0] | 0) return;
 if (__ZN7Texture25ReloadFromStorageIfNeededEPvb(i1, HEAP32[i1 + 52 >> 2] | 0, (HEAP8[i1 + 105 >> 0] | 0) != 0) | 0) return;
 __ZN12CubemapArray13UploadTextureEv(i1);
 return;
}

function __ZN10Effector2D13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 if ((i2 | 0) != 0 & (i2 & 20 | 0) == 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __Z40setPxVehicleWheelsSimData_SuspensionDataPN5physx22PxVehicleWheelsSimDataEjNS_23PxVehicleSuspensionDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE(i2, i1, i3);
 return;
}

function __Z32getPxVehicleWheelsMWheelsSimDataPKN5physx15PxVehicleWheelsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = i2 + 8 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z28CheckPlatformSupportsShadowsv() {
 var i1 = 0;
 i1 = __Z15GetGraphicsCapsv() | 0;
 if (!(HEAP8[i1 + 502 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP8[i1 + 500 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 488 >> 2] | 0) != 0;
 return i1 | 0;
}

function __Z22getPxMeshScaleRotationPKN5physx11PxMeshScaleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 12 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __Z20LightAttenuateApproxRKfS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(Math_fround(25.0) / Math_fround(HEAPF32[i2 >> 2]));
 return Math_fround(Math_fround(1.0) / Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i1 >> 2])) + Math_fround(1.0)));
}

function _UNITY_png_read_update_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 208 >> 2] & 64)) {
  _UNITY_png_read_start_row(i1);
  _UNITY_png_read_transform_info(i1, i2);
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353160 | 0);
  return;
 }
}

function _UNITY_png_benign_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i1 + 208 >> 2] & 1048576 | 0) return;
 if (!(HEAP32[i1 + 204 >> 2] & 32768)) _UNITY_png_error(i1, i2);
 if (!(HEAP32[i1 + 372 >> 2] | 0)) _UNITY_png_error(i1, i2); else _UNITY_png_chunk_error(i1, i2);
}

function _Round_To_Grid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i2 + 32 + i3 & -64;
  i3 = (i3 | 0) < 0 ? 0 : i3;
  return i3 | 0;
 } else {
  i3 = 0 - (32 - i2 + i3 & -64) | 0;
  i3 = (i3 | 0) > 0 ? 0 : i3;
  return i3 | 0;
 }
 return 0;
}

function _sfnt_get_interface(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = _UNITY_ft_service_list_lookup(HEAP32[HEAP32[i1 + 212 >> 2] >> 2] | 0, i2) | 0;
 return i2 | 0;
}

function __ZThn12_NK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZThn12_NK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNSt3__215__thread_structC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(24) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignESt16initializer_listIwE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendESt16initializer_listIwE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignESt16initializer_listIcE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendESt16initializer_listIcE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE11do_groupingEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE11do_groupingEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE11do_groupingEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE11do_groupingEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK8VRDevice20GetDeviceRefreshRateEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 112 >> 2]);
 return Math_fround(f2);
}

function __ZNK5physx7NpScene26getVisualizationCullingBoxEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 3388 >> 2] & 64 | 0) if (HEAP8[i1 + 3092 >> 0] | 0) {
  i1 = i1 + 3068 | 0;
  return i1 | 0;
 }
 i1 = __ZNK5physx2Sc5Scene26getVisualizationCullingBoxEv(i1 + 32 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx19NpArticulationJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5Umbra4Tome14testCapabilityEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 & 1 | 0) if (!(HEAP32[i1 + 164 >> 2] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 if (i2 & 4 | 0) if (!(HEAP32[i1 + 16 >> 2] & 1)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = i2 >>> 0 < 8;
 return i2 | 0;
}

function __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 1924 + (i2 << 2) >> 2] | 0;
 if (!i3) {
  i3 = i1;
  return i3 | 0;
 }
 i3 = HEAP32[gb + 74780 + (i1 << 2) >> 2] | 0;
 return i3 | 0;
}

function __ZNK13GfxDeviceGLES11GetViewportEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 7148 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN8WWWAudioD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 HEAP32[i1 >> 2] = gb + 71808 + 8;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i3 >> 2] | 0) + 92 >> 2] | 0, i3 | 0, 0);
 __ZN3WWW7ReleaseEv(HEAP32[i2 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN6Camera6RenderER11CullResultsR17ShaderPassContextNS_10RenderFlagE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv(i1, i2, i3, 0, i4, 0);
 return;
}

function __ZN5physx6shdfnd13ReadWriteLock10lockReaderEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi((HEAP32[i1 >> 2] | 0) + 4 | 0) | 0;
 _pthread_mutex_unlock(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0;
 return;
}

function __ZN5physx5cloth7Factory13createFactoryENS1_8PlatformEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i2 | 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN5physx5cloth8allocateEj(24) | 0;
 __ZN5physx5cloth9SwFactoryC2Ev(i2);
 i2 = (i2 | 0) == 0 ? 0 : i2 + 4 | 0;
 return i2 | 0;
}

function __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_9DataArrayEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = HEAP32[i2 + 4 >> 2] | 0;
 return ((i4 | 0) == 0 ? 0 : (HEAP32[i2 >> 2] | 0) + i4 | 0) + (Math_imul(HEAP32[i2 + 8 >> 2] | 0, i3) | 0) | 0;
}

function __ZN26LegacyTreeInstanceRenderer6UpdateEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 236 | 0;
 i2 = i2 & 1;
 i2 = i2 << 8 | i2 << 6 | (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16776767;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 return;
}

function __ZN25ScriptingVertexDataLayoutC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN23TransformChangeDispatch22GetSubSystemInterestedE15TransformAccess27TransformChangeSystemHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (1 << HEAP32[i2 >> 2] & HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0) + (HEAP32[i1 + 4 >> 2] << 2) >> 2] | 0) != 0 | 0;
}

function __ZN22LocalFileSystemHandler16LastErrorMessageEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZN19VREyeTextureManager17BlitToFramebufferE15UnityVRBlitModeRK5RectTIfEf(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 __ZN19VREyeTextureManager12BlitToBufferE15UnityVRBlitModeRK5RectTIfEfP13RenderTexture(i1, i2, i3, f4, 0);
 return;
}

function __ZN16MeshVertexFormatD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i3) return;
 i1 = i1 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) != (i3 | 0)) HEAP32[i1 >> 2] = i2 + (~((i2 + -16 - i3 | 0) >>> 4) << 4);
 __ZdlPv(i3);
 return;
}

function __ZN14PlayerSettings20SetMacFullscreenModeEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) {
  __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 453073 | 0, 0, gb + 452899 | 0, 796, 512, 0, 0, 0);
  i1 = 1;
 }
 HEAP32[i2 + 400 >> 2] = i1;
 return;
}

function __ZN14AreaEffector2D17SetForceMagnitudeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 96 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN13EmscriptenWWW14BlockUntilDoneEv(i1) {
 i1 = i1 | 0;
 if (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0) return;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 363033 | 0, 0, gb + 363071 | 0, 144, 1, 0, 0, 0);
 return;
}

function __ZN13BitSetUtility12CreateBitSetEjRK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 + 31 | 0) >>> 5 << 2;
 i2 = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i2, 0, gb + 488156 | 0, 11) | 0;
 _memset(i2 | 0, 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStream7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12GUIClipStateC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i1 + 156 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN10MonoScript17GetPropertiesHashEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z30getPxVehicleDriveMDriveDynDataPKN5physx14PxVehicleDriveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i2 = i2 + 128 | 0;
 i3 = i1 + 96 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z29CleanupParticlesFromNodeQueueR15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] | 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 192 >> 2] | 0, gb + 64024 | 0);
 return;
}

function __Z21CheckImageFormatValidii13TextureFormat(i1, i2, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 var i3 = 0;
 if ((i4 | 0) < 9) i3 = 1; else i3 = (i4 | 0) == 1e3 | ((i4 | 0) == 23 | (i4 + -13 | 0) >>> 0 < 9);
 return (i1 | 0) > 0 & (i2 | 0) > 0 & (i4 | 0) > 0 & i3 | 0;
}

function __Z17GetSocketErrorMsgi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = _strerror(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, i2, _strlen(i2) | 0);
 return;
}

function _wmemcpy(i4, i2, i1) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 if (i1 | 0) {
  i3 = i4;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i3 >> 2] = HEAP32[i2 >> 2];
   if (!i1) break; else {
    i2 = i2 + 4 | 0;
    i3 = i3 + 4 | 0;
   }
  }
 }
 return i4 | 0;
}

function _textdomain(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = gb + 1073406 | 0; else if (!(HEAP8[i1 >> 0] | 0)) i1 = gb + 1073406 | 0; else if (!(_strcmp(i1, gb + 1073406 | 0) | 0)) i1 = gb + 1073406 | 0; else {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNK8VRDevice19GetGPUTimeLastFrameEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 176 >> 2]);
 return Math_fround(f2);
}

function __ZN9GfxDevice28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return;
}

function __ZN8Renderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 i2 = i1 + 218 | 0;
 i3 = HEAP32[i1 + 300 >> 2] & 65535;
 i1 = HEAP16[i2 >> 1] | 0;
 HEAP16[i2 >> 1] = (i3 & 65535) < (i1 & 65535) ? i3 : i1;
 return;
}

function __ZN7ApiGLES17ActiveTextureUnitEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 1600 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 mftCall_vi(HEAP32[i2 + 808 >> 2] | 0, i3 + 33984 | 0);
 HEAP32[i1 >> 2] = i3;
 return;
}

function __ZN6Object24CalculateCachedTypeIndexEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) + 24 >> 2] | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 2097151 | i3 << 21;
 return i1 | 0;
}

function __ZN5physx6shdfnd7FastIPCD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd7FastIPCD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sq10AABBPrunerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sq10AABBPrunerD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx28PxVehicleComputeSprungMassesEjPKNS_6PxVec3ERS1_fjPf(i3, i4, i1, f6, i2, i5) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 f6 = Math_fround(f6);
 i2 = i2 | 0;
 i5 = i5 | 0;
 __ZN5physx19computeSprungMassesEjPKNS_6PxVec3ERS1_fjPf(i3, i4, i1, f6, i2, i5);
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13GuMeshFactoryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx13GuMeshFactoryD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx10PxsContext21processContactManagerEPNS_17PxsContactManagerEjPv(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = i3 + 148 | 0;
 i4 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i4 + 1;
 HEAP32[i3 + 20 + (i4 << 2) >> 2] = i1;
 return 1;
}

function __ZN19VREyeTextureManager21SetUnityTextureFormatE28UnityVREyeTextureLayoutFlagsbi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 44 >> 2] = i2;
 HEAP8[i1 + 105 >> 0] = i3 & 1;
 HEAP32[i1 + 100 >> 2] = (i4 | 0) < 1 ? 1 : i4;
 return;
}

function __ZN14SphereCollider5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(.5);
 i1 = i1 + 64 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1162364 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1162364 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1162364 + 8 >> 2];
 return;
}

function __ZN14PhysicsManager11RaycastTestERK3Rayfi23QueryTriggerInteraction(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZN5Unity12PhysicsQuery11RaycastTestERK3Rayfi23QueryTriggerInteraction(0, i2, f3, i4, i5) | 0;
}

function __ZN13RuntimeStaticI20HardwareInfoReporterE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN20HardwareInfoReporter12CleanupClassEv(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStream7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12TextureInput9SetBufferEPv(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = i3;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = i3;
 return;
}

function __ZN10DebugStats11DeserializeEPPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + 4 >> 2];
 HEAP32[i2 >> 2] = i3 + 12;
 HEAP32[i1 + 8 >> 2] = HEAP32[i3 + 8 >> 2];
 return;
}

function __Z32Event_Set_Custom_PropCommandNameP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i2);
 STACKTOP = i1;
 return;
}

function __Z28LayerMask_CUSTOM_LayerToNamei(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __ZN10TagManager13LayerToStringEj(__Z13GetTagManagerv() | 0, i1) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return __Z20scripting_string_newPKcj((i2 | 0) == 0 ? i1 + 4 | 0 : i2, HEAP32[i1 + 20 >> 2] | 0) | 0;
}

function _UNITY_ft_base_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 188 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 i3 = HEAP32[i1 >> 2] | 0;
 _UNITY_ft_destroy_default_module_classes(i1);
 _UNITY_ft_mem_free(i3, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function mftCall_iiii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1023 | 0)) return FUNCTION_TABLE_iiii[i4 - fb & 1023](i1 | 0, i2 | 0, i3 | 0) | 0;
 return ftCall_iiii(i4 | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function mftCall_iiff(i4, i1, d2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiff[i4 - fb & 1](i1 | 0, Math_fround(d2), Math_fround(d3)) | 0;
 return ftCall_iiff(i4 | 0, i1 | 0, +d2, +d3) | 0;
}

function __ZZN19CharacterController15InitializeClassEvEN35FunctorImpl_589kAnimatorMoveBuiltin4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN19CharacterController22ApplyRootMotionBuiltinEP14RootMotionData(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZNK5physx2Sc8BodyCore26getHasValidKinematicTargetEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP8[i1 + 31 >> 0] | 0) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 28 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext14SphericalJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext14PrismaticJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx18PxVehicleDriveTank12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx18NpArticulationLink12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + ((HEAP32[i1 + 16 >> 2] & 6 | 0 ? 0 : i2) << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZNK13SliderJoint2D19GetJointTranslationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZNK16b2PrismaticJoint19GetJointTranslationEv(i1));
 return Math_fround(f2);
}

function __ZN7ApiGLES16SetPatchVerticesEi(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 1580 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 748 >> 2] | 0, 36466, i3 | 0);
 return;
}

function __ZN5physx6shdfnd10ThreadImplC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcher15resetWakeSignalEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 20 | 0;
 __ZN5physx6shdfnd8SyncImpl5resetEv(HEAP32[i1 >> 2] | 0);
 if (!(HEAP8[i2 + 32 >> 0] | 0)) return;
 __ZN5physx6shdfnd8SyncImpl3setEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN5physx3Ext14PrismaticJoint29setProjectionAngularToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 104 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra16LineSegmentQuery6setEndERKNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN26SharedLightmapSettingsDataD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 43424 + 8;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (i1 | 0) __ZdaPv(i1);
 i1 = HEAP32[i2 + 24 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 __ZdaPv(i1);
 __ZdlPv(i2);
 return;
}

function __ZN23AllocationRootReference12AddReferenceEP24ProfilerAllocationHeaderj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 HEAP32[i2 >> 2] = i1;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
 return;
}

function __ZN22PerThreadPageAllocator10InitializeER19AtomicPageAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = __ZN19AtomicPageAllocator12AllocatePageEj(i2, 32768) | 0;
 HEAP32[i1 + 8 >> 2] = 32768;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh10SetTabSizeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 68 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN20TextRenderingPrivate8TextMesh10SetOffsetZEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 52 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN20OcclusionCullingData7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 i2 = __Z9GetIUmbrav() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN18ProfilerConnection26HandleSetAudioCaptureFlagsEPKvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i2 = __Z9GetIAudiov() | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN14ParticleSystem11AutoPrewarmEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if (!(HEAP8[i2 + 278 >> 0] | 0)) return;
 if (!(HEAP8[i2 + 277 >> 0] | 0)) return;
 __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE(i1, Math_fround(0.0), 3);
 return;
}

function __ZN12_GLOBAL__N_110Connection18getConnectionStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 84 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZN12TreeDatabaseC2ER11TerrainData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 HEAP32[i1 >> 2] = i2;
 i1 = i1 + 4 | 0;
 i2 = i1;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 36 >> 0] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService17SessionEventQueueC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN11TimeManager10TimeHolderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZL22InitializeModule_Umbrav() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63600 | 0, 16, gb + 612557 | 0, gb + 1576256 | 0, gb + 612578 | 0, 497) | 0;
 HEAP32[i1 >> 2] = gb + 78796 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIUmbraP6IUmbra(i1);
 return;
}

function __ZL22InitializeModule_Clothv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 839588 | 0, gb + 1576256 | 0, gb + 839603 | 0, 50) | 0;
 HEAP32[i1 >> 2] = gb + 168744 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIClothP6ICloth(i1);
 return;
}

function __Z5rsqrtRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 __Z4sqrtRK8Scalar4f(i4, i2);
 __Z5recipRK8Scalar4f(i1, i4);
 STACKTOP = i3;
 return;
}

function __Z5ClearR13CImageSurface(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdaPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z40Rigidbody_Set_Custom_PropUseConeFrictionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z32RuntimeUndo_CUSTOM_RecordObjectsP11Il2CppArrayP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i2);
 STACKTOP = i1;
 return;
}

function __Z31RuntimeUndo_CUSTOM_RecordObjectP12Il2CppObjectP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i2);
 STACKTOP = i1;
 return;
}

function _flockfile(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 if (_ftrylockfile(i1) | 0) {
  i2 = i1 + 76 | 0;
  i3 = i1 + 80 | 0;
  do {
   i4 = HEAP32[i2 >> 2] | 0;
   if (i4 | 0) ___wait(i2 | 0, i3 | 0, i4 | 0, 1);
  } while ((_ftrylockfile(i1) | 0) != 0);
 }
 return;
}

function _fdatasync(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall148(148, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdatePlayerEmitCanvasGeometrystruct7ForwardEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1115296 + 408 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 404 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZNSt3__210__time_getD2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_vi(fb + 4002 | 0, HEAP32[i1 >> 2] | 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i8 >> 2] = i6;
 return 3;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc17ParticleSystemSim18getSimParticleDataERNS_28PxvParticleSystemSimDataDescEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = HEAP32[i3 + 56 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK15FileSystemEntry6TargetERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 124 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0) | 0;
 return i3 | 0;
}

function __ZNK13TranslateGLES13GetFormatDescE19RenderTextureFormat17TextureColorSpace(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i3 + 2172 + (i1 << 2) >> 2] | 0;
 if (i2) i1 = HEAP32[gb + 74780 + (i1 << 2) >> 2] | 0;
 return i3 + 28 + (i1 * 24 | 0) | 0;
}

function __ZN8GUIStyle14GetGUIClipRectEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1468288 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1468288 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[gb + 1468288 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[gb + 1468288 + 12 >> 2];
 return;
}

function __ZN8Collider10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK8Collider(__Z17GetPhysicsManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8Animator16GetDeltaRotationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 284 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN6Shader21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 if ((HEAP32[i2 >> 2] | 0) != (HEAP32[gb + 1166244 >> 2] | 0)) return;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP8[i1 + 93 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd6SocketD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd6SocketD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx6PxVec4C2Effff(i5, f2, f3, f4, f1) {
 i5 = i5 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f1 = Math_fround(f1);
 HEAPF32[i5 >> 2] = f2;
 HEAPF32[i5 + 4 >> 2] = f3;
 HEAPF32[i5 + 8 >> 2] = f4;
 HEAPF32[i5 + 12 >> 2] = f1;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167452 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 167452 + 424;
 __ZN5physx5cloth7SwClothD2Ev(i1 + 16 | 0);
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167452 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 167452 + 424;
 __ZN5physx5cloth7SwClothD2Ev(i1 + 16 | 0);
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZN5physx3Ext14SphericalJoint28setProjectionLinearToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 112 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext14PrismaticJoint28setProjectionLinearToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 100 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext13RevoluteJoint29setProjectionAngularToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 128 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl18setTolerancesScaleERKNS_17PxTolerancesScaleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 132 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return;
 __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData(i1, i2, i3);
 return;
}

function __ZN2UI14CanvasRenderer8GetColorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 32 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN29DelayedPointerDeletionManager21DeallocateLocalMemoryEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN23PreloadManagerOperation12GetDebugNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function __ZN18ScriptingArguments9AddStructEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 192 | 0;
 HEAP32[i1 + 96 + (HEAP32[i3 >> 2] << 2) >> 2] = i2;
 HEAP32[i1 + 144 + (HEAP32[i3 >> 2] << 2) >> 2] = 6;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 return;
}

function __ZN18LoadSceneOperation22CompleteLoadFirstSceneEv(i1) {
 i1 = i1 | 0;
 __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv(i1);
 i1 = __Z22GetGameManagerIfExistsi(9) | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN17ProceduralTexture32FixNormalUsageAndFormatAtRuntimeEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 + 172 >> 2] = 4;
 i2 = i3 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == 3) {
  HEAP32[i2 >> 2] = 4;
  i1 = 4;
 }
 HEAP32[i3 + 216 >> 2] = i1;
 return;
}

function __ZN14ParticleSystem13SetUsesLightsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i1 + 873 | 0;
 if (HEAP8[i2 >> 0] | 0) return;
 HEAP8[i2 >> 0] = 1;
 __ZN14dynamic_bitset6resizeEjb(i1 + 600 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, 0);
 return;
}

function __ZN10MeshFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 32 | 0, i2);
 return;
}

function __ZN10CastFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(Math_fround(HEAPF32[i3 + 40 >> 2]) > Math_fround(0.0))) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 return i3 | 0;
}

function __ZN10AudioMixer12UpdateBypassEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) return;
 __ZN5audio5mixer12UpdateBypassERNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryE(HEAP32[i1 + 72 >> 2] | 0, HEAP32[i1 + 76 >> 2] | 0);
 return;
}

function __Z49AnimationClipPlayable_CUSTOM_SetRemoveStartOffsetR9HPlayableh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 173 >> 0] = i2 << 24 >> 24 != 0 & 1;
 return;
}

function __Z44getPxParticleReadDataCollisionVelocityBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 56 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z42SkinnedMeshRenderer_RenderWithLastPositionRK15RenderNodeQueuejRK14ChannelAssignsi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z34SkinnedMeshRenderer_InternalRenderRK15RenderNodeQueuejRK14ChannelAssignsib(i1, i2, i3, i4, 1);
 return;
}

function __Z26CreateAllowNameConversionsv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(16, gb + 63416 | 0, 16, gb + 469031 | 0, 71) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP8[i1 + 12 >> 0] = 1;
 return i1 | 0;
}

function __Z18IsAbsoluteFilePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z13GetFileSystemv() | 0;
 return __ZNK10FileSystem18IsAbsoluteFilePathEPKc(i2, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function _UNITY_FT_Init_Class_ft_standard_raster(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 1869968492;
 HEAP32[i1 + 4 >> 2] = fb + 1080;
 HEAP32[i1 + 8 >> 2] = fb + 965;
 HEAP32[i1 + 12 >> 2] = fb + 454;
 HEAP32[i1 + 16 >> 2] = fb + 1081;
 HEAP32[i1 + 20 >> 2] = fb + 3854;
 return;
}

function mftCall_vfff(i4, d1, d2, d3) {
 i4 = i4 | 0;
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_vfff[i4 - fb & 3](Math_fround(d1), Math_fround(d2), Math_fround(d3));
  return;
 }
 ftCall_vfff(i4 | 0, +d1, +d2, +d3);
}

function _putw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i1;
 i2 = (_fwrite(i4, 4, 1, i2) | 0) + -1 | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _mlockall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall152(152, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZNSt3__218condition_variableD2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(fb + 2797 | 0, i1 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 HEAP32[i5 >> 2] = i3;
 HEAP32[i8 >> 2] = i6;
 return 3;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getBreakForceERfS5_(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext13RevoluteJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext13DistanceJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK17AnimationCurveTplI11QuaternionfE15GetPostInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 176 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZN9UdpSocketD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 65580 + 8;
 i1 = i2 + 4 | 0;
 if (!(HEAP8[i2 + 17 >> 0] | 0)) {
  HEAP32[i1 >> 2] = -1;
  i1 = -1;
 } else i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = gb + 65564 + 8;
 _close(i1) | 0;
 return;
}

function __ZN9Scripting11RaiseIfNullEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 if (!i1) __ZN9Scripting18RaiseNullExceptionEPKcz(gb + 1057545 | 0, i2); else {
  STACKTOP = i2;
  return;
 }
}

function __ZN8Gradient7SetKeysEPNS_8ColorKeyEjPNS_8AlphaKeyEj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj(i1, i2, i3);
 __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj(i1, i4, i5);
 return;
}

function __ZN8GUIState18CycleKeyboardFocusERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = __ZN8GUIState24GetNextKeyboardControlIDERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb(0, i2, i3) | 0;
 return;
}

function __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 60 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7Texture15InitializeClassEv() {
 var i1 = 0, i2 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63272 | 0, 16, gb + 410978 | 0, 47) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1158372 >> 2] = i1;
 return;
}

function __ZN6prcoreL11inner_clearILj2EEEvPhjjj(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 while (1) {
  i1 = i1 + -1 | 0;
  HEAP16[i2 >> 1] = (HEAPU16[i2 >> 1] | 0) & i4 | i3;
  if (!i1) break; else i2 = i2 + 2 | 0;
 }
 return;
}

function __ZN5physx3Ext13RevoluteJoint28setProjectionLinearToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 124 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx35solveFrictionCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx2Sc8BodyCore17setAngularDampingEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  HEAPF32[i1 + 52 >> 2] = f3;
  return;
 }
 HEAPF32[i2 + 124 >> 2] = f3;
 return;
}

function __ZN5physx17PxcNpMemBlockPool20acquireFrictionBlockEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i1, i1 + 40 + ((HEAP32[i1 + 128 >> 2] | 0) * 12 | 0) | 0, 0, 0, 0) | 0;
}

function __ZN5physx12_GLOBAL__N_115OverlapCallback6invokeERfPKNS_2Sq13PrunerPayloadEj(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = HEAP32[i3 + 4 >> 2] | 0;
 return mftCall_iii(HEAP32[HEAP32[i3 >> 2] >> 2] | 0, i3 | 0, HEAP32[i4 >> 2] | 0) | 0;
}

function __ZN18UnityConnectClient33OnPlayerSessionStateChangedStaticEPS_jyy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 __ZN18UnityConnectClient27OnPlayerSessionStateChangedEjyy(i1, i2, i3, i4, i5, i6);
 return;
}

function __ZN18BuoyancyEffector2D14SetAngularDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 104 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN17ProceduralTexture17TextureParametersC2Eiii13TextureFormat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 HEAP32[i1 + 12 >> 2] = i5;
 return;
}

function __ZN14ImageReference9BlitImageEiiRKS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(HEAP32[i4 + 16 >> 2] | 0)) return;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 __ZN6prcore9BlitImageERK14ImageReferenceRS0_ii(i4, i1, i2, i3);
 return;
}

function __ZN13WebCamTexture7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0);
 i1 = i1 + 124 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __ZdlPv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN11ColorModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 8 | 0, i2);
 return;
}

function __ZL22stbir__filter_triangleff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0;
 f2 = Math_fround(Math_abs(Math_fround(f1)));
 i3 = !(f2 <= Math_fround(1.0));
 f2 = Math_fround(Math_fround(1.0) - f2);
 return Math_fround(i3 ? Math_fround(0.0) : f2);
}

function __ZL21CleanupModule_Terrainv() {
 var i1 = 0;
 i1 = __Z18GetITerrainManagerv() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63616 | 0);
 __Z18SetITerrainManagerP15ITerrainManager(0);
 return;
}

function __Z27RenderSettings_CUSTOM_Resetv() {
 var i1 = 0;
 i1 = __Z17GetRenderSettingsv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 i1 = __Z17GetRenderSettingsv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 return;
}

function __Z21InitializeUmbraModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63600 | 0, 16, gb + 612557 | 0, gb + 1576256 | 0, gb + 612578 | 0, 497) | 0;
 HEAP32[i1 >> 2] = gb + 78796 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIUmbraP6IUmbra(i1);
 return;
}

function __Z21InitializeClothModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63400 | 0, 16, gb + 839588 | 0, gb + 1576256 | 0, gb + 839603 | 0, 50) | 0;
 HEAP32[i1 >> 2] = gb + 168744 + 8;
 __Z19pop_allocation_rootv();
 __Z9SetIClothP6ICloth(i1);
 return;
}

function __Z17Event_CUSTOM_InitP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(52, gb + 63864 | 0, 16, gb + 1019057 | 0, 26) | 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i3;
 __ZN10InputEvent4InitEi(i3, i2);
 return;
}

function _Round_Down_To_Grid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i3 + i2 & -64;
  i3 = (i3 | 0) < 0 ? 0 : i3;
  return i3 | 0;
 } else {
  i3 = 0 - (i3 - i2 & -64) | 0;
  i3 = (i3 | 0) > 0 ? 0 : i3;
  return i3 | 0;
 }
 return 0;
}

function mftCall_viff(i4, i1, d2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 31 | 0)) {
  FUNCTION_TABLE_viff[i4 - fb & 31](i1 | 0, Math_fround(d2), Math_fround(d3));
  return;
 }
 ftCall_viff(i4 | 0, i1 | 0, +d2, +d3);
}

function mftCall_iiif(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iiif[i4 - fb & 7](i1 | 0, i2 | 0, Math_fround(d3)) | 0;
 return ftCall_iiif(i4 | 0, i1 | 0, i2 | 0, +d3) | 0;
}

function mftCall_iifi(i4, i1, d2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iifi[i4 - fb & 7](i1 | 0, Math_fround(d2), i3 | 0) | 0;
 return ftCall_iifi(i4 | 0, i1 | 0, +d2, i3 | 0) | 0;
}

function b117(i1, i2, i4, i5, f6, i7, i8, i9, i10, i11, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 nullFunc_iiiiifiiiiif(117);
 return 0;
}

function _wmemchr(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 L1 : do if (!i2) i1 = 0; else while (1) {
  if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) break L1;
  i2 = i2 + -1 | 0;
  if (!i2) {
   i1 = 0;
   break;
  } else i1 = i1 + 4 | 0;
 } while (0);
 return i1 | 0;
}

function _glCompressedTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _glCompressedTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function _getpgid(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall132(132, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZThn32_N19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZNSt3__212strstreambuf6freezeEb(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 do if (i2 & 4 | 0) if (i3) {
  HEAP32[i1 >> 2] = i2 | 8;
  break;
 } else {
  HEAP32[i1 >> 2] = i2 & -9;
  break;
 } while (0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLESt16initializer_listIwE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSESt16initializer_listIwE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLESt16initializer_listIcE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSESt16initializer_listIcE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __ZNK5Umbra10PortalInfo9getCenterERNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 36 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZNK17AnimationCurveTplI11QuaternionfE14GetPreInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 172 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZNK12MeshRenderer23GetMeshStaticBatchIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 340 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP16[i1 + 218 >> 1] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZNK10Collider2D10IsTouchingEPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == 0 | (i2 | 0) == (i1 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZNK16Physics2DManager10IsTouchingEPK10Collider2DS2_(__Z19GetPhysicsManager2Dv() | 0, i1, i2) | 0;
 return i2 | 0;
}

function __ZN9Rigidbody27InvalidateAssociatedVehicleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 64 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1) return;
 i2 = __Z12GetIVehiclesv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN7dtCrowd24setAgentAnimationPolyRefERK13dtCrowdHandley(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = (HEAP32[i1 + 20 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 56 | 0) + 40 | 0;
 HEAP32[i2 >> 2] = i3;
 HEAP32[i2 + 4 >> 2] = i4;
 return;
}

function __ZN7ApiGLES14BindReadBufferEj(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = i2 + 904 | 0;
 if (HEAP8[i2 + 1992 >> 0] | 0) if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i3;
 mftCall_vii(HEAP32[i2 + 644 >> 2] | 0, 36662, i3 | 0);
 return;
}

function __ZN5physx2Sc9RigidCore15addShapeToSceneERNS0_9ShapeCoreE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc5Scene8addShapeERNS0_8RigidSimERNS0_9ShapeCoreE(__ZNK5physx2Sc8ActorSim8getSceneEv(i1) | 0, i1, i2);
 return;
}

function __ZN5physx2Sc8BodyCore16setLinearDampingEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  HEAPF32[i1 + 48 >> 2] = f2;
  return;
 }
 HEAPF32[i3 + 120 >> 2] = f2;
 return;
}

function __ZN5physx2Cm24destroyFreeListAllocatorERNS0_17FreeListAllocatorE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx17PxcNpMemBlockPool19acquireNpCacheBlockEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i1, i1 + 64 + ((HEAP32[i1 + 124 >> 2] | 0) * 12 | 0) | 0, 0, 0, 0) | 0;
}

function __ZN5physx17PxcNpMemBlockPool19acquireContactBlockEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i1, i1 + 16 + ((HEAP32[i1 + 136 >> 2] | 0) * 12 | 0) | 0, 0, 0, 1) | 0;
}

function __ZN5physx14NpRigidDynamic15switchFromNoSimEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (HEAP8[i2 + 2433 >> 0] | 0) return;
 __ZN5physx3Scb5Scene20switchRigidFromNoSimERNS0_11RigidObjectEb(i2, i1, 1);
 return;
}

function __ZN31TransformFeedbackSkinPoseBufferD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 76908 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playable(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) != 1) return;
 __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playableb(i1, i2, i3, 0);
 return;
}

function __ZN22BlockMemoryCacheWriter11GetPathNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 468001 | 0, 12);
 return;
}

function __ZN20TextRenderingPrivate8TextMesh11SetRichTextEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 84 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN19CloudServiceHandler11FlushEventsEv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher39StartJobSetupSessionContainerToDispatchEv(i1 + 792 | 0);
 return __ZN11UnityEngine15CloudWebService19SessionEventManager11FlushEventsEv(i1 + 200 | 0) | 0;
}

function __ZN18BuoyancyEffector2D13SetLinearDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 100 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN17SharedTextureDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 41960 + 8;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 i2 = i1 + 8 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN15NavMeshObstacle22SetCarveOnlyStationaryEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 69 | 0;
 i1 = i1 + 136 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 return;
}

function __ZN15DirectorManager8FreeNodeEP5HNode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 i2 = HEAP32[gb + 1188432 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12ImageFilters8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN14GraphicsHelper8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE(i1, i2, i3, i4);
 __Z15gpu_time_samplev();
 return;
}

function __ZN11UnityEngine9Animation27GetCurveCountForBindingTypeEj(i1) {
 i1 = i1 | 0;
 L1 : do if ((i1 | 0) == 2) i1 = 4; else {
  switch (i1 | 0) {
  case 1:
  case 3:
  case 4:
   {
    i1 = 3;
    break L1;
   }
  default:
   {}
  }
  i1 = 1;
 } while (0);
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer19ConvertToFolderTimeEjt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ___muldi3(i1 | 0, 0, 1e5, 0) | 0;
 i2 = _i64Add(i1 | 0, getTempRet0() | 0, i2 & 65535 | 0, 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function __ZL32StaticDestroyRuntimeSceneManagerPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1164172 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63824 | 0);
 HEAP32[gb + 1164172 >> 2] = 0;
 return;
}

function __ZL15SortColorByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES6_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) | 0;
 return (_strcmp(i1, __ZNK9ShaderLab16FastPropertyName7GetNameEv(i2) | 0) | 0) < 0 | 0;
}

function __Z49setPxVehicleWheelsDynData_TireForceShaderFunctionPN5physx22PxVehicleWheelsDynDataEPFvPKvffffffffffffRfS4_S4_S4_E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxVehicleWheelsDynData26setTireForceShaderFunctionEPFvPKvffffffffffffRfS3_S3_S3_E(i2, i1);
 return;
}

function __Z44setPxVehicleWheelsSimData_TireLoadFilterDataPN5physx22PxVehicleWheelsSimDataERKNS_27PxVehicleTireLoadFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxVehicleWheelsSimData21setTireLoadFilterDataERKNS_27PxVehicleTireLoadFilterDataE(i2, i1);
 return;
}

function __Z42getPxParticleReadDataCollisionNormalBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 48 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z26AndroidJNI_CUSTOM_ThrowNew13Il2Cpp_IntPtrP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i1, i2);
 STACKTOP = i1;
 return 0;
}

function __Z18SetApplicationPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z13GetFileSystemv() | 0;
 __ZNK10FileSystem18SetApplicationPathEPKc(i2, (HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1);
 return;
}

function mftCall_viif(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 127 | 0)) {
  FUNCTION_TABLE_viif[i4 - fb & 127](i1 | 0, i2 | 0, Math_fround(d3));
  return;
 }
 ftCall_viif(i4 | 0, i1 | 0, i2 | 0, +d3);
}

function _getsid(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall147(147, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZThn12_NK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx16PxVehicleNoDrive12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx16PxVehicleDriveNW12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx16PxVehicleDrive4W12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx16NpParticleSystem12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx14NpArticulation16updateDriveCacheERNS_24PxArticulationDriveCacheEfj(i4, i1, f2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 __ZNK5physx2Sc16ArticulationCore16updateDriveCacheERNS_9PxcFsDataEfj(i4 + 24 | 0, i1, f2, i3);
 return;
}

function __ZNK20LocalFileSystemPosix8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 1052 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i2 = 0;
 } else {
  i2 = _ftell(i1) | 0;
  i1 = ((i2 | 0) < 0) << 31 >> 31;
 }
 setTempRet0(i1 | 0);
 return i2 | 0;
}

function __ZN7mecanim12statemachine36GetTransitionInterruptionSourceCountE28TransitionInterruptionSource(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 3:
 case 4:
  {
   i1 = 3;
   break;
  }
 case 2:
 case 1:
  {
   i1 = 2;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN7Texture20SetMipMapBiasNoDirtyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 40 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN6prcoreL11inner_clearILj1EEEvPhjjj(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 while (1) {
  i1 = i1 + -1 | 0;
  HEAP8[i2 >> 0] = (HEAPU8[i2 >> 0] | 0) & i4 | i3;
  if (!i1) break; else i2 = i2 + 1 | 0;
 }
 return;
}

function __ZN5physx44PxClothMotionConstraintConfigGeneratedValuesC2EPKNS_29PxClothMotionConstraintConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx2Sq11getHitActorEPKNS_3Scb5ActorE(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK5physx2Sc9RigidCore10getPxActorEv(i1 + (HEAP32[gb + 1457208 + 68 + (((HEAP32[i1 + 4 >> 2] | 0) >>> 24 & 15) << 2) >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx13NpRigidStatic15switchFromNoSimEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (HEAP8[i2 + 2433 >> 0] | 0) return;
 __ZN5physx3Scb5Scene20switchRigidFromNoSimERNS0_11RigidObjectEb(i2, i1, 0);
 return;
}

function __ZN4FMOD8ChannelI7setModeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i2 & 3;
 if (!i3) return 0;
 i4 = i1 + 72 | 0;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & -4 | i3;
 _JS_Sound_SetLoop(HEAP32[i1 + 164 >> 2] | 0, (i2 & 2 | 0) != 0 | 0);
 return 0;
}

function __ZN22ParticleSystemRenderer15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 80260 | 0, gb + 1105156 | 0, fb + 752 | 0, gb + 30832 | 0);
 return;
}

function __ZN22MemoryCacherReadBlocks11GetPathNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 468544 | 0, 4);
 return;
}

function __ZN17UniqueIDGenerator16DestroyPureIndexEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 20 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -16777216 | HEAP32[i3 >> 2] & 16777215;
 HEAP32[i3 >> 2] = i2;
 return;
}

function __ZN15UniformTFMethod16BindForRenderingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, (HEAP32[i1 + 12 >> 2] | 0) - i3 >> 2 >>> 2 | 0, i3 | 0);
 return;
}

function __ZN15FileSystemEntry6DeleteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i3) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 116 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0) | 0;
 return i3 | 0;
}

function __ZN15AudioReverbZone17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 116 >> 2] | 0;
 if (i2 | 0) __ZN4FMOD6Reverb9setActiveEb(i2, 0) | 0;
 __ZN12AudioManager21RemoveAudioReverbZoneEP15AudioReverbZone(__Z15GetAudioManagerv() | 0, i1);
 return;
}

function __ZN14SerializedFile7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if (HEAP32[i2 >> 2] | 0) return;
 __ZN14SerializedFileD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63416 | 0);
 return;
}

function __ZN12NavMeshAgent11SetVelocityERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN7dtCrowd19updateAgentVelocityERK13dtCrowdHandlePKf(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0, i2);
 return;
}

function __ZL17sample_allocationPvP12Il2CppObjectP11Il2CppClass(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN22UnityProfilerPerThread18SampleGCAllocationEP12Il2CppObjectP11Il2CppClass(i1, i2, i3);
 return;
}

function __Z16RecordForEachJobPFvPvjES_jPFvS_ER21SingleThreadedJobInfo(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 + 12 >> 2] = i4;
 HEAP32[i5 >> 2] = i2;
 HEAP32[i5 + 4 >> 2] = i3;
 HEAP32[i5 + 8 >> 2] = i1;
 return;
}

function __Z15NormalizeRobustRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZL15NormalizeRobustRK8Vector3fRfS2_(i1, i2, i3 + 4 | 0, i3);
 STACKTOP = i3;
 return;
}

function _UNITY_tt_face_free_hdmx(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 104 >> 2] | 0;
 i3 = i1 + 720 | 0;
 _UNITY_ft_mem_free(HEAP32[i2 + 28 >> 2] | 0, HEAP32[i3 >> 2] | 0);
 HEAP32[i3 >> 2] = 0;
 _UNITY_FT_Stream_ReleaseFrame(i2, i1 + 704 | 0);
 return;
}

function _UNITY_png_get_compression_buffer_size(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if (!(HEAP32[i1 + 204 >> 2] & 32768)) {
  i1 = HEAP32[i1 + 280 >> 2] | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[i1 + 652 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function _UNITY_FT_Init_Class_ft_grays_raster(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 1869968492;
 HEAP32[i1 + 4 >> 2] = fb + 1017;
 HEAP32[i1 + 8 >> 2] = fb + 964;
 HEAP32[i1 + 12 >> 2] = fb + 442;
 HEAP32[i1 + 16 >> 2] = fb + 1018;
 HEAP32[i1 + 20 >> 2] = fb + 3847;
 return;
}

function mftCall_viii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 2047 | 0)) {
  FUNCTION_TABLE_viii[i4 - fb & 2047](i1 | 0, i2 | 0, i3 | 0);
  return;
 }
 ftCall_viii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
}

function _uname(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall122(122, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _fsync(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall118(118, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdatePlayerUpdateCanvasesstruct7ForwardEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1115296 + 396 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 400 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 4 >> 2] & 74) {
 case 64:
  {
   i1 = 8;
   break;
  }
 case 8:
  {
   i1 = 16;
   break;
  }
 case 0:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 10;
 }
 return i1 | 0;
}

function __ZNKSt3__28ios_base6getlocEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZNSt3__26localeC2ERKS0_(i3, i1 + 28 | 0);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __ZNK9AudioClip8GetMovieEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z21GetManagerFromContexti(3) | 0) + 224 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 return i1 | 0;
}

function __ZNK8Material32AcquireSharedMaterialDataFromJobEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if ((HEAP8[i1 + 164 >> 0] & 3) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZNK5physx9NpPhysics17getTriangleMeshesEPPNS_14PxTriangleMeshEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx13GuMeshFactory17getTriangleMeshesEPPNS_14PxTriangleMeshEjj(HEAP32[gb + 1457204 >> 2] | 0, i4, i1, i2) | 0;
}

function __ZNK5physx13GuMeshFactory19getNbTriangleMeshesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZNK20TextRenderingPrivate8FontImpl22GetFontSizeFromSpacingEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 f2 = Math_fround(Math_fround(HEAP32[i1 + 36 >> 2] | 0) * f2);
 return Math_fround(f2 / Math_fround(HEAPF32[i1 + 32 >> 2]));
}

function __ZNK12WheelJoint2D19GetJointTranslationEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(__ZNK12b2WheelJoint19GetJointTranslationEv(i1));
 return Math_fround(f2);
}

function __ZN9GfxDevice15ImmediateNormalEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 HEAPF32[i1 + 48 >> 2] = f2;
 HEAPF32[i1 + 52 >> 2] = f3;
 HEAPF32[i1 + 56 >> 2] = f4;
 return;
}

function __ZN8Scalar4fC2Effff(i1, f3, f4, f5, f2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = f3;
 HEAPF32[i1 + 4 >> 2] = f4;
 HEAPF32[i1 + 8 >> 2] = f5;
 HEAPF32[i1 + 12 >> 2] = f2;
 return;
}

function __ZN5physx3Ext10FixedJoint29setProjectionAngularToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 76 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc8ClothSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc8ClothSimD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc8BodyCore14setMaxAngVelSqEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  HEAPF32[i1 + 56 >> 2] = f3;
  return;
 }
 HEAPF32[i2 + 112 >> 2] = f3;
 return;
}

function __ZN5physx2Sc8BodyCore14setInverseMassEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = HEAP32[i3 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  HEAPF32[i1 + 44 >> 2] = f2;
  return;
 }
 HEAPF32[i3 + 140 >> 2] = f2;
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5Umbra9RasterOps17updateDepthBufferERKNS_17BlockRasterBufferERNS_11DepthBufferEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf(i1, i2, f3);
 return;
}

function __ZN2UI13RectTransform38SetAnchoredPositionWithoutNotificationERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 152 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN17SurfaceEffector2D8SetSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(-1.0e6);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 92 >> 2] = i3 ? Math_fround(-1.0e6) : f2;
 return;
}

function __ZN17PhysicsMaterial2D13SetBouncinessEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e5);
 f2 = i4 ? Math_fround(1.0e5) : f2;
 HEAPF32[i1 + 36 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN15PointEffector2D14SetAngularDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 108 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN14LineParametersD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 44780 + 8;
 i2 = i1 + 76 | 0;
 if ((HEAP32[i1 + 92 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 80 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_115StringTableImpl7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12WheelJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 152796 + 8;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12MeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 380 | 0, i2);
 return;
}

function __ZN11ShapeModuleD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 83032 + 8;
 i2 = i1 + 104 | 0;
 if ((HEAP32[i1 + 120 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 108 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN11ColorModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 8 | 0, i2);
 return;
}

function __ZN11ColorModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 8 | 0, i2);
 return;
}

function __ZL21GetAllTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE(i1, i3);
 return;
}

function mftCall_vifi(i4, i1, d2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_vifi[i4 - fb & 15](i1 | 0, Math_fround(d2), i3 | 0);
  return;
 }
 ftCall_vifi(i4 | 0, i1 | 0, +d2, i3 | 0);
}

function _unlink(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall10(10, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _strupr(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (i1 << 24 >> 24) {
  i2 = i3;
  do {
   HEAP8[i2 >> 0] = _toupper(i1 << 24 >> 24) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i2 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 return i3 | 0;
}

function _strlwr(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (i1 << 24 >> 24) {
  i2 = i3;
  do {
   HEAP8[i2 >> 0] = _tolower(i1 << 24 >> 24) | 0;
   i2 = i2 + 1 | 0;
   i1 = HEAP8[i2 >> 0] | 0;
  } while (i1 << 24 >> 24 != 0);
 }
 return i3 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 452 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i1 >> 0] | 0 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 280 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 492 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__28valarrayIjED2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_viii(fb + 1063 | 0, i1 | 0, 0, 0);
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNSt3__26locale5__imp7installINS_15time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476260 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476252 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476244 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1475432 | 0) | 0);
 return;
}

function __ZNK9ShaderLab9IntShader14GetRenderQueueEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[(HEAP32[(HEAP32[i2 >> 2] | 0) + (i1 << 2) >> 2] | 0) + 56 >> 2] | 0;
 if ((i1 | 0) != -1) {
  i2 = i1;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 52 >> 2] | 0;
 return i2 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx2Gu12TriangleMesh12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 204);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx15NpParticleFluid12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx13GuMeshFactory17getNbHeightFieldsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZNK25BlendshapePropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __ZN19SkinnedMeshRenderer19SetBlendShapeWeightEjf(HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0, f3);
 return;
}

function __ZNK19CharacterController22GetWorldCenterPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 96 | 0);
 return;
}

function __ZNK17AnimationCurveTplI8Vector3fE15GetPostInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 144 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZNK14VertexDataInfo16GetStreamsLayoutEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 56 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 68 >> 2];
 return;
}

function __ZN9GfxDevice21CopyRenderSurfaceDescEP17RenderSurfaceBasePKS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i2 | 0, i3 | 0, mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 380 >> 2] | 0, i1 | 0, (HEAP8[i3 + 30 >> 0] | 0) != 0 | 0) | 0) | 0;
 return;
}

function __ZN9GfxDevice13EndFrameStatsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, d3 = 0.0;
 HEAP8[i1 + 3896 >> 0] = 0;
 d3 = +__Z19GetTimeSinceStartupv();
 i2 = i1 + 3888 | 0;
 HEAPF32[i2 >> 2] = Math_fround(d3 - +HEAPF64[i1 + 3880 >> 3] + +Math_fround(HEAPF32[i2 >> 2]));
 return;
}

function __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb(HEAP32[gb + 1110260 >> 2] | 0, i1, i2, i3);
 return;
}

function __ZN6IDList10BeginOnGUIEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP32[i2 + 8 >> 2] = -1;
 HEAP32[i2 + 12 >> 2] = -1;
 HEAP8[i1 + 20 >> 0] = 0;
 HEAP32[i1 >> 2] = 1;
 return;
}

function __ZN5physx7profile32PxProfileMemoryEventRecorderImpl7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx6shdfnd18BufferedSocketImplC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP16[i1 + 12 >> 1] = 0;
 HEAP8[i1 + 14 >> 0] = 0;
 HEAP8[i1 + 15 >> 0] = 1;
 HEAP32[i1 >> 2] = gb + 110664 + 8;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fED2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fE10deallocateERKNS3_13CollisionDataE(i1, i1 + 424 | 0);
 __ZN5physx5cloth11SwCollisionI8Scalar4fE10deallocateERKNS3_13CollisionDataE(i1, i1 + 416 | 0);
 return;
}

function __ZN5physx3Ext10FixedJoint28setProjectionLinearToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 72 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx37solveFrictionCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx2Sc5Scene20rigidBodyNarrowPhaseEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx10PxsContext20updateContactManagerEfPNS_10PxBaseTaskE(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(HEAPF32[i2 + 64 >> 2]), i1);
 return;
}

function __ZN5physx23PxSetGroupCollisionFlagEttb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = i1 & 1;
 i1 = i3 & 65535;
 i3 = i2 & 65535;
 HEAP8[gb + 1550009 + (i3 << 5) + i1 >> 0] = i4;
 HEAP8[gb + 1550009 + (i1 << 5) + i3 >> 0] = i4;
 return;
}

function __ZN2UI6Canvas16SetTargetDisplayEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (__ZNK2UI6Canvas13GetRenderModeEv(i1) | 0) return;
 if (HEAP32[i1 + 344 >> 2] | 0) return;
 i1 = i1 + 374 | 0;
 if ((HEAP8[i1 >> 0] | 0) == (i2 | 0)) return;
 HEAP8[i1 >> 0] = i2;
 return;
}

function __ZN19CharacterController15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 111552 | 0, gb + 1105456 | 0, fb + 843 | 0, gb + 29632 | 0);
 return;
}

function __ZN16b2ContactManagerC2Ev(i1) {
 i1 = i1 | 0;
 __ZN12b2BroadPhaseC2Ev(i1);
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 68 >> 2] = gb + 152736;
 HEAP32[i1 + 72 >> 2] = gb + 152760;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP8[i1 + 80 >> 0] = 0;
 return;
}

function __ZN15TerrainRenderer23SetNeighboringRenderersEPS_S0_S0_S0_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN15RelativeJoint2D16SetAngularOffsetEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 96 >> 2] = f2;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN12b2MotorJoint16SetAngularOffsetEf(i1, Math_fround(f2 * Math_fround(.0174532924)));
 return;
}

function __ZN14AreaEffector2D14SetAngularDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 108 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN13GfxDeviceNull15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 return;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader7OnAbortEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP8[i1 + 5 >> 0] = 1;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN10CBBoxInt325EmptyEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 >> 2] | 0) > (HEAP32[i1 + 12 >> 2] | 0)) return 1;
 if ((HEAP32[i1 + 4 >> 2] | 0) > (HEAP32[i1 + 16 >> 2] | 0)) return 1; else return (HEAP32[i1 + 8 >> 2] | 0) > (HEAP32[i1 + 20 >> 2] | 0) | 0;
 return 0;
}

function __ZN10CBBoxInt325ClearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 2147483647;
 HEAP32[i1 + 4 >> 2] = 2147483647;
 HEAP32[i1 + 8 >> 2] = 2147483647;
 HEAP32[i1 + 12 >> 2] = -2147483648;
 HEAP32[i1 + 16 >> 2] = -2147483648;
 HEAP32[i1 + 20 >> 2] = -2147483648;
 return;
}

function __Z49AnimationClipPlayable_CUSTOM_GetRemoveStartOffsetR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 173 >> 0] | 0;
 return i1 | 0;
}

function __Z34GameObject_Set_Custom_PropIsStaticP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else if (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) return;
 __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1);
}

function __Z13InitIndexListR9IndexListj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2 << 2, 16, gb + 64024 | 0, 0, gb + 375877 | 0, 82) | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function b139(i1, i2, i3, f4, i5, i6, f7, i8, f9, f10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 f10 = Math_fround(f10);
 nullFunc_iiiifiififf(139);
 return 0;
}

function _unity_z_deflateSetHeader(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = -2; else {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) i1 = -2; else if ((HEAP32[i1 + 24 >> 2] | 0) == 2) {
   HEAP32[i1 + 28 >> 2] = i2;
   i1 = 0;
  } else i1 = -2;
 }
 return i1 | 0;
}

function _umask(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall60(60, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _tt_property_set(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (_strcmp(i2, gb + 1008266 | 0) | 0) {
  i3 = 12;
  return i3 | 0;
 }
 if ((HEAP32[i3 >> 2] | 0) != 35) {
  i3 = 7;
  return i3 | 0;
 }
 HEAP32[i1 + 64 >> 2] = 35;
 i3 = 0;
 return i3 | 0;
}

function _rmdir(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall40(40, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _chdir(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall12(12, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarkerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + -8 | 0);
 STACKTOP = i2;
 return;
}

function __ZThn32_N17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E(i2 + -12 | 0, i1);
 return;
}

function __ZNKSt3__28numpunctIcE12do_falsenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1087441 | 0, 5);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 220 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 768);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 336);
 return;
}

function __ZNK5physx13GuMeshFactory17getNbConvexMeshesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZNK26DownloadHandlerAssetBundle22ShouldDiscardOperationEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 if (HEAP32[i1 + 24 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 28 >> 2] | 0) == -1;
 return i1 | 0;
}

function __ZNK26DownloadHandlerAssetBundle13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK39AssetBundleLoadFromStreamAsyncOperation18GetDownloadedBytesEv(i1) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZNK17AnimationCurveTplI8Vector3fE14GetPreInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 140 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i3 + 1924 + (i1 << 2) >> 2] | 0;
 if (i2) i1 = HEAP32[gb + 74780 + (i1 << 2) >> 2] | 0;
 return i3 + 28 + (i1 * 24 | 0) | 0;
}

function __ZNK12MeshRenderer19GetStaticBatchIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 340 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (!(HEAP16[i1 + 218 >> 1] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZN9LensFlare13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 if (i2 & 1 | 0) return;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZN7mecanim9animation18ControllerConstant15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 910060 | 0, gb + 910079 | 0, gb + 901463 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 910060 | 0, gb + 910097 | 0, gb + 910115 | 0);
 return;
}

function __ZN5physxL21PxcInvalidContactPairERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return 0;
}

function __ZN5physx7profile30PxProfileMemoryEventBufferImpl7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 20 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn5ConvX11alignTargetEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1 + -1 | 0;
 i1 = i1 - ((__ZN5physx2Sn5ConvX20getCurrentOutputSizeEv(i2) | 0) & i3) & i3;
 if (!i1) return;
 __ZN5physx2Sn5ConvX6outputEPKci(i2, i2 + 36 | 0, i1);
 return;
}

function __ZN5physx2Sc9StaticSimD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 91220 + 8;
 __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE(HEAP32[i1 + 36 >> 2] | 0, i1);
 HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 4 >> 2] = 0;
 __ZN5physx2Sc8RigidSimD2Ev(i1);
 return;
}

function __ZN5physx2Sc7BodySimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc7BodySimD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc5Scene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[(HEAP32[i3 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 12 >> 0] = HEAP8[i2 >> 0] | 0;
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx10PxsContext23prepareCMDiscreteUpdateEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx27solveContactPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i2);
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5IMGUI11FocusWindowER8GUIStatei(i1, i3) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (i2 | 0) if ((HEAP32[i2 >> 2] | 0) != (i3 | 0)) return;
 HEAP32[i1 + 12 >> 2] = i3;
 return;
}

function __ZN25SingleBlockMemoryFileDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 71752 + 8;
 if ((HEAP32[i1 + 32 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 16 >> 2] | 0, i1 + 20 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN20TextRenderingPrivate8TextMesh12SetAlignmentEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 56 | 0;
 if ((HEAP16[i3 >> 1] | 0) == i2 << 16 >> 16) return;
 HEAP16[i3 >> 1] = i2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN17PhysicsMaterial2D11SetFrictionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e5);
 f2 = i4 ? Math_fround(1.0e5) : f2;
 HEAPF32[i1 + 32 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN16MessageForwarderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN14MemoryProfiler13ThreadCleanupEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1163240 >> 2] | 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63584 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63584 | 0);
 return;
}

function __ZN13TrailRenderer11TrailPointsD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 56200 + 8;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 8 >> 2] | 0, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12BaseRenderer23UpdatePreviousFrameDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 68 | 0;
 i1 = i1 + 4 | 0;
 i2 = i3 + 64 | 0;
 do {
  HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
  i3 = i3 + 4 | 0;
  i1 = i1 + 4 | 0;
 } while ((i3 | 0) < (i2 | 0));
 return;
}

function __ZN11TimeManager16HasFixedTimeStepEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 d2 = +HEAPF64[i1 + 32 >> 3] + +Math_fround(HEAPF32[i1 + 48 >> 2]);
 if (d2 > +HEAPF64[i1 + 64 >> 3]) if (!(HEAP8[i1 + 130 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = 1;
 return i1 | 0;
}

function __Z46setPxVehicleWheelsSimData_SceneQueryFilterDataPN5physx22PxVehicleWheelsSimDataEjNS_12PxFilterDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE(i2, i1, i3);
 return;
}

function __Z43AnimationClipPlayable_CUSTOM_SetApplyFootIKR9HPlayableh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 172 >> 0] = i2 << 24 >> 24 != 0 & 1;
 return;
}

function __Z36profiler_begin_frame_separate_thread12ProfilerMode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP32[i2 + 24 >> 2] & 1)) return;
 __ZN13UnityProfiler24BeginFrameSeparateThreadE12ProfilerMode(i2, i1);
 return;
}

function mftCall_vfii(i4, d1, i2, i3) {
 i4 = i4 | 0;
 d1 = +d1;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vfii[i4 - fb & 1](Math_fround(d1), i2 | 0, i3 | 0);
  return;
 }
 ftCall_vfii(i4 | 0, +d1, i2 | 0, i3 | 0);
}

function _syslog(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0, i5 = 0;
 i4 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i5 = i4;
 HEAP32[i5 >> 2] = i3;
 ___vsyslog(i1, i2, i5);
 STACKTOP = i4;
 return;
}

function _pipe(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall42(42, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _nice(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall34(34, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _fputwc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  i3 = (___lockfile(i2) | 0) == 0;
  i1 = ___fputwc_unlocked(i1, i2) | 0;
  if (!i3) ___unlockfile(i2);
 } else i1 = ___fputwc_unlocked(i1, i2) | 0;
 return i1 | 0;
}

function _fill_mem_input_buffer(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = 120;
 mftCall_vii(HEAP32[i2 + 4 >> 2] | 0, i1 | 0, -1);
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = gb + 361358;
 HEAP32[i1 + 4 >> 2] = 2;
 return 1;
}

function _acct(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall51(51, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_91kDidDeleteMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_90kDidModifyMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZThn8_N5physx2Sc23ElementActorInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + -8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__219__shared_mutex_base8try_lockEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 __ZNSt3__25mutex4lockEv(i2);
 i1 = i2 + 124 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  HEAP32[i1 >> 2] = -2147483648;
  i1 = 1;
 } else i1 = 0;
 __ZNSt3__25mutex6unlockEv(i2);
 return i1 | 0;
}

function __ZNKSt3__28numpunctIcE11do_truenameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1087447 | 0, 4);
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8getSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc16ArticulationCore16updateDriveCacheERNS_9PxcFsDataEfj(i4, i1, f2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 __ZNK5physx2Sc15ArticulationSim16updateDriveCacheERNS_9PxcFsDataEfj(HEAP32[i4 >> 2] | 0, i1, f2, i3);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 84);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 84);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext10FixedJoint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx2Gu11HeightField12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx14NpRigidDynamic12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx14NpArticulation12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZN6Skybox23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 36 | 0, i2);
 return;
}

function __ZN5physx6shdfnd16MemoryMappedFileD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, HEAP32[i1 >> 2] | 0);
 STACKTOP = i2;
 return;
}

function __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i4 = 0;
 i4 = i3;
 i1 = HEAP32[i4 + 4 >> 2] | 0;
 i3 = i2;
 HEAP32[i3 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 + 4 >> 2] = i1;
 return;
}

function __ZN5physx3Ext7D6Joint29setProjectionAngularToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 380 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc8ActorSimD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sc5ActorD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx28NpArticulationGetRootFromScbERNS_3Scb12ArticulationE(i1) {
 i1 = i1 | 0;
 i1 = i1 + -12 | 0;
 if (!(HEAP32[i1 + 92 >> 2] | 0)) return 0; else {
  i1 = HEAP32[HEAP32[i1 + 88 >> 2] >> 2] | 0;
  return ((i1 | 0) == 0 ? 0 : i1 + 48 | 0) | 0;
 }
 return 0;
}

function __ZN5physx16GetMaterialIndexEPKNS_2Gu15HeightFieldDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 >>> 1;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 return (HEAPU8[((i2 & 1 | 0) == 0 ? i1 + (i3 << 2) + 2 | 0 : i1 + (i3 << 2) + 3 | 0) >> 0] | 0) & 127 | 0;
}

function __ZN5physx13NpRigidStatic13switchToNoSimEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 48 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 if (HEAP8[i2 + 2433 >> 0] | 0) return;
 __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb(i2, i1, 0);
 return;
}

function __ZN5Umbra15MemOutputStreamD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 78624 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN5Light13SetBakedIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 if ((HEAP32[(HEAP32[i3 >> 2] | 0) + 88 >> 2] | 0) == (i2 | 0)) return;
 __ZNK5Light16UnshareLightDataEv(i1);
 HEAP32[(HEAP32[i3 >> 2] | 0) + 88 >> 2] = i2;
 return;
}

function __ZN21AnimationClipPlayable7SetClipEP13AnimationClip(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var d2 = 0.0;
 HEAP32[i3 + 164 >> 2] = i1;
 if (!i1) d2 = 0.0; else d2 = +Math_fround(__ZN13AnimationClip9GetLengthEv(i1));
 __ZN8Playable11SetDurationEd(i3, d2);
 return;
}

function __ZN19SkinnedMeshRenderer17ReloadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 508 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = __Z12GetGfxDevicev() | 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 300 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __ZN19CharacterController7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 60 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 mftCall_vi(HEAP32[(HEAP32[i3 >> 2] | 0) + 4 >> 2] | 0, i3 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZN17SurfaceEffector2D13SetForceScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0);
 f2 = i4 ? Math_fround(1.0) : f2;
 HEAPF32[i1 + 100 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN17MemoryCacheWriter11GetPathNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 468001 | 0, 12);
 return;
}

function __ZN17MemoryCacheReader11GetPathNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 468001 | 0, 12);
 return;
}

function __ZN13GfxDeviceGLES17ApplyBackfaceModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4688 >> 2] | 0;
 if ((HEAP8[i1 + 7184 >> 0] | 0) == (HEAP8[i1 + 4381 >> 0] | 0)) {
  mftCall_vi(i2 | 0, 2304);
  return;
 } else {
  mftCall_vi(i2 | 0, 2305);
  return;
 }
}

function __Z45UnityAnalyticsHandler_CUSTOM_SetUserBirthYearP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 1; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 1; else i1 = __ZN14UnityAnalytics16SetUserBirthYearEj(i1, i2) | 0;
 }
 return i1 | 0;
}

function __Z37getPxParticleReadDataRestOffsetBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 32 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _il2cpp_object_new(i1 | 0) | 0;
 if (!i1) return i1 | 0;
 __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object(i1, i2) | 0;
 return i1 | 0;
}

function __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (HEAP32[i1 >> 2] | 0) HEAP32[i1 >> 2] = 0;
 mftCall_vi(i2 | 0, i3 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function _UNITY_FT_Stream_GetChar(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 >= (HEAP32[i1 + 36 >> 2] | 0) >>> 0) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i2 >> 2] = i3 + 1;
 i3 = HEAP8[i3 >> 0] | 0;
 return i3 | 0;
}

function _glCopyTexSubImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _glCopyTexSubImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function _dup(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = i1;
 i1 = ___syscall_ret(___syscall41(41, i3 | 0) | 0) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _cf2_arrstack_getPointer(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 20 >> 2] | 0) >>> 0 <= i1 >>> 0) {
  _cf2_setError(HEAP32[i2 + 4 >> 2] | 0, 130);
  i1 = 0;
 }
 return (HEAP32[i2 + 28 >> 2] | 0) + (Math_imul(HEAP32[i2 + 8 >> 2] | 0, i1) | 0) | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 156 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 456 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZThn32_N16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZNSt3__211unique_lockINS_5mutexEE6unlockEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) __ZNSt3__220__throw_system_errorEiPKc(1, gb + 1077185 | 0);
 __ZNSt3__25mutex6unlockEv(HEAP32[i1 >> 2] | 0);
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZNK5physx3Scb5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx2Sc5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3 + 16 | 0, i4, i1, i2) | 0;
}

function __ZNK5physx2Gu11HeightField24getTriangleMaterialIndexEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 >>> 1;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 return (HEAPU8[((i2 & 1 | 0) == 0 ? i1 + (i3 << 2) + 2 | 0 : i1 + (i3 << 2) + 3 | 0) >> 0] | 0) & 127 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 84);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 84);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 144);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 768);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 800);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 200);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN6prcoreL11inner_clearILj4EEEvPhjjj(i2, i1, i3, i4) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 while (1) {
  i1 = i1 + -1 | 0;
  HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & i4 | i3;
  if (!i1) break; else i2 = i2 + 4 | 0;
 }
 return;
}

function __ZN5physx9PxTaskMgrD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx9PxTaskMgrD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx9NpPhysicsD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx9NpPhysicsD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx9NpFactoryD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx9NpFactoryD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i1 + 16 | 0) | 0;
 __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i1 + 20 | 0) | 0;
 return i1 | 0;
}

function __ZN5physx3Ext7D6Joint28setProjectionLinearToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 376 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext22computeCylinderDensityEfff(f3, f1, f2) {
 f3 = Math_fround(f3);
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(f2 / Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(f1 * Math_fround(2.0))));
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 91844 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + -32 | 0;
 i1 = i2 + 12 | 0;
 if (__ZN5physx6shdfnd15atomicDecrementEPVi(i2 + 16 | 0) | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN5Umbra16LineSegmentQuery8setStartERKNS_7Vector3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN33AssetBundleLoadFromAsyncOperation27IntegrateWithPreloadManagerEv(i1) {
 i1 = i1 | 0;
 __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation(__Z17GetPreloadManagerv() | 0, i1);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN24AudioScriptBufferManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 __ZN24AudioScriptBufferManager4InitEv(i1);
 return;
}

function __ZN23ParticleSystemParticles22SetUsesCollisionEventsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 875 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 if (i2) return;
 HEAP32[i1 + 632 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 185320 | 0, gb + 1105256 | 0, fb + 959 | 0, 0);
 return;
}

function __ZN19SkinnedMeshRenderer11GetAnimatorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 408 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i1);
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __ZN13RuntimeStaticI21AssetReferenceStorageE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN21AssetReferenceStorageD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_16ParserILb1EE7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12_GLOBAL__N_16ParserILb0EE7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12LineRenderer10LinePointsD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 44764 + 8;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 8 >> 2] | 0, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11OffMeshLink12AddToManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 92 | 0;
 if ((HEAP32[i2 >> 2] | 0) != -1) return;
 __ZN14NavMeshManager19RegisterOffMeshLinkER11OffMeshLinkRi(__Z17GetNavMeshManagerv() | 0, i1, i2);
 HEAP8[i1 + 97 >> 0] = 1;
 return;
}

function __Z5WhiteP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = -1;
 HEAP8[i2 + 1 >> 0] = -1 >> 8;
 HEAP8[i2 + 2 >> 0] = -1 >> 16;
 HEAP8[i2 + 3 >> 0] = -1 >> 24;
 return;
}

function __Z51scripting_object_new_and_invoke_default_constructorP11Il2CppClassPP15Il2CppException(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _il2cpp_object_new(i1 | 0) | 0;
 if (!i1) return i1 | 0;
 _il2cpp_runtime_object_init_exception(i1 | 0, i2 | 0);
 return i1 | 0;
}

function __Z39VRStats_Get_Custom_PropGpuTimeLastFramev() {
 var f1 = f0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 f1 = Math_fround(__ZNK8VRDevice19GetGPUTimeLastFrameEv(__Z12GetIVRDevicev() | 0));
 return Math_fround(f1);
}

function __Z27setPxHeightFieldDescSamplesPN5physx17PxHeightFieldDescENS_13PxStridedDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = i1;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z19GetCachedBinaryNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_S7_S7_R11fixed_arrayIcLj33EE(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i6 >> 0] = 0;
 return;
}

function _tcflush(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _ioctl(i1, 21515, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _gzeof(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP8[i1 + 92 >> 0] | 0) != 114) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP32[i1 + 60 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 56 >> 2] | 0) == 1 & 1;
 return i1 | 0;
}

function __ZThn8_N5physx2Sc21ElementSimInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + -8 | 0);
 STACKTOP = i2;
 return;
}

function __ZNK5physx7NpScene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx3Scb5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3 + 16 | 0, i4, i1, i2) | 0;
}

function __ZNK5physx7NpScene18getSolverBatchSizeEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 3388 >> 2] & 16)) {
  i1 = __ZNK5physx2Sc5Scene18getSolverBatchSizeEv(i1 + 32 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[i1 + 3368 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i1, HEAP32[i3 + 4 >> 2] | 0, i2);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 240);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx2Gu10ConvexMesh12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 200);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 308 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx13NpRigidStatic12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx13NpClothFabric12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE18getAngularVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 264 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 268 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 272 >> 2];
 return;
}

function __ZNK21LightProbeProxyVolume13GetResolutionERjS0_S0_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 140 >> 2];
 HEAP32[i3 >> 2] = HEAP32[i1 + 144 >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 + 148 >> 2];
 return;
}

function __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKfRNS_5human9HumanPoseE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE(i1, i2, i3);
 return;
}

function __ZN7Texture12SetUsageModeE16TextureUsageMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 56 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx7NpActor7releaseERNS_7PxActorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb(HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 4 >> 2] | 0, i2, 0) | 0;
 return;
}

function __ZN5physx27solveContactCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx17ConvexMeshBuilderC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu10ConvexMeshC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 110060 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110060 + 84;
 __ZN5physx17ConvexHullBuilderC2EPNS_2Gu14ConvexHullDataE(i1 + 132 | 0, i1 + 16 | 0);
 return;
}

function __ZN22RenderingCommandBuffer20AddDrawMeshInstancedEP4MeshiP8MaterialiPK10Matrix4x4fjP19ShaderPropertySheet(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return;
}

function __ZN14TerrainManager25ReloadTerrainsToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i3 = i1 + 4 | 0;
 if ((i2 | 0) == (i3 | 0)) return; else i1 = i2;
 do i1 = HEAP32[i1 + 4 >> 2] | 0; while ((i1 | 0) != (i3 | 0));
 return;
}

function __ZN12_GLOBAL__N_116clothSizeGreaterIN5physx5cloth8SwSolver22CpuClothSimulationTaskEEEbRKT_S7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[(HEAP32[i1 + 20 >> 2] | 0) + 12 >> 2] | 0) >>> 0 > (HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + 12 >> 2] | 0) >>> 0 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher39StartJobSetupSessionContainerToDispatchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3959 | 0, i1 | 0) | 0;
 return;
}

function __ZN10CBBoxInt32C2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 2147483647;
 HEAP32[i1 + 4 >> 2] = 2147483647;
 HEAP32[i1 + 8 >> 2] = 2147483647;
 HEAP32[i1 + 12 >> 2] = -2147483648;
 HEAP32[i1 + 16 >> 2] = -2147483648;
 HEAP32[i1 + 20 >> 2] = -2147483648;
 return;
}

function __ZL19CleanupModule_Audiov() {
 HEAP32[gb + 1115296 + 136 >> 2] = 0;
 HEAP32[gb + 1115296 + 264 >> 2] = 0;
 HEAP32[gb + 1115296 + 308 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIAudiov() | 0, gb + 63328 | 0);
 __Z9SetIAudioP6IAudio(0);
 return;
}

function __Z35getPxParticleReadDataVelocityBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 24 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z35getPxParticleReadDataPositionBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 16 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z23DestroyMutexLockedQueueP16MutexLockedQueue(i1) {
 i1 = i1 | 0;
 if (i1 | 0) {
  __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63200 | 0);
  HEAP32[i1 >> 2] = 0;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63200 | 0);
 return;
}

function _tcflow(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _ioctl(i1, 21514, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZThn12_NK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6substrEjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jjRKS4_(i1, i2, i3, i4, i2);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6substrEjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_(i1, i2, i3, i4, i2);
 return;
}

function __ZNK5physx9NpPhysics15getHeightFieldsEPPNS_13PxHeightFieldEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx13GuMeshFactory15getHeightFieldsEPPNS_13PxHeightFieldEjj(HEAP32[gb + 1457204 >> 2] | 0, i4, i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 116);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 108);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getLinearVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 252 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 256 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 260 >> 2];
 return;
}

function __ZNK14AsyncOperation7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if ((i1 | 0) == 0 | (HEAP32[i2 >> 2] | 0) != 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZNK10SampleClip14CalculateFlagsEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 if (!(HEAP8[i2 + 44 >> 0] | 0)) i1 = 0; else i1 = (HEAP32[i2 + 52 >> 2] | 0) == 1 ? 2 : 0;
 i2 = ((__ZNK10SampleClip17CalculateFMODModeEv(i2) | 0) & 128 | 0) == 0;
 return (i2 ? i1 : 2) | 0;
}

function __ZN9GfxDevice17SendVRDeviceEventEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(__Z12GetIVRDevicev() | 0)) return;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0);
 return;
}

function __ZN7mecanim9animation14AvatarConstant15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 910045 | 0, gb + 906080 | 0, gb + 905792 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 910045 | 0, gb + 906091 | 0, gb + 905809 | 0);
 return;
}

function __ZN7Texture13SetMipMapBiasEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 40 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAPF32[i3 >> 2] = f2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 456 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i1 >> 0] | 0 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 284 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 496 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Sn5ConvXD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx2Sn5ConvXD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc19ConstraintGroupNode19clearProjectionDataEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 20 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN5physx2Sc14ConstraintCore15updateConstantsEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 _memcpy(HEAP32[i1 + 60 >> 2] | 0, i2 | 0, HEAP32[i1 + 44 >> 2] | 0) | 0;
 i2 = 1;
 return i2 | 0;
}

function __ZN5physx24PxsParticleSystemBatcher19schedulePipelineGpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0);
 return i2 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEED0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN25SubstanceRawTextureSharedD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 59344 + 8;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN25SubstanceRawTextureSharedD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 59344 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63736 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN22VirtualJoystickManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF64[i1 >> 3] = -2.0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN21ArchiveStorageCreator10BeginBlockE15CompressionType16CompressionLevelj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj(i1, 0, i2, i3, i4) | 0;
}

function __ZN20TextRenderingPrivate8TextMesh9SetAnchorEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 58 | 0;
 if ((HEAP16[i3 >> 1] | 0) == i2 << 16 >> 16) return;
 HEAP16[i3 >> 1] = i2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN15HeightMeshQueryC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 169856 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i1 + 8;
 HEAPF32[i1 + 16 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 20 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14VehiclesModule37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf(i2, f3);
 return;
}

function __ZN12b2ChainShape13SetPrevVertexERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 36 >> 0] = 1;
 return;
}

function __ZN12b2ChainShape13SetNextVertexERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 28 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP8[i1 + 37 >> 0] = 1;
 return;
}

function __ZN11AudioSource19GetSpatializerFloatEiPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 540 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = (__ZN4FMOD3DSP12getParameterEiPfPci(i1, i2, i3, 0, 0) | 0) == 0;
 return i3 | 0;
}

function __ZN10DynamicVBOD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 57900 + 8;
 i2 = i1 + 4 | 0;
 if ((HEAP32[i1 + 20 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 8 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z59GeometryUtility_CUSTOM_INTERNAL_CALL_Internal_ExtractPlanesP11Il2CppArrayRK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane(i2, __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 16) | 0);
 return;
}

function __GLOBAL__sub_I_runtime_utilities3_lump_cpp() {
 __ZN12UnityVersionC2EPKc(gb + 1178892 | 0, gb + 1040146 | 0);
 HEAP32[gb + 1178912 + 12 >> 2] = 0;
 HEAP32[gb + 1178912 + 8 >> 2] = 0;
 HEAP32[gb + 1178912 >> 2] = 3;
 HEAP32[gb + 1178912 + 4 >> 2] = 0;
 return;
}

function mftCall_diii(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 7 | 0)) return +FUNCTION_TABLE_diii[i4 - fb & 7](i1 | 0, i2 | 0, i3 | 0);
 return +ftCall_diii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
}

function b63(i1, i2, i5, i6, i7, i8, i9, i10, i11, i12, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i12 = i12 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 nullFunc_viiiiiiiiiiii(63);
}

function b116(i1, i2, i4, i5, f6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 nullFunc_iiiiifiiiiii(116);
 return 0;
}

function _jpeg_set_quality(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 i1 = (i1 | 0) > 100 ? 100 : i1;
 if ((i1 | 0) < 50) i1 = 5e3 / (i1 | 0) | 0; else i1 = 200 - (i1 << 1) | 0;
 _jpeg_set_linear_quality(i2, i1, i3);
 return;
}

function _imaxabs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = (i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 0;
 i3 = _i64Subtract(0, 0, i1 | 0, i2 | 0) | 0;
 i5 = getTempRet0() | 0;
 setTempRet0((i4 ? i2 : i5) | 0);
 return (i4 ? i1 : i3) | 0;
}

function _ft_raster1_init(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 56 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, HEAP32[i2 + 164 >> 2] | 0, HEAP32[i2 + 168 >> 2] | 0);
 return 0;
}

function _finish_output_pass(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 384 >> 2] | 0;
 if (HEAP8[i1 + 74 >> 0] | 0) mftCall_vi(HEAP32[(HEAP32[i1 + 424 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 i2 = i2 + 12 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function _cf2_arrstack_finalize(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 i1 = i1 + 28 | 0;
 _UNITY_ft_mem_free(i2, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZThn12_N5physx10NpMaterialD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -12 | 0;
 HEAP32[i1 >> 2] = gb + 93280 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 93280 + 108;
 __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 __ZNSt3__28ios_base5clearEj(i1, 0);
 return i3 | 0;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i1 + 24 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i4 >> 2] = i2;
 __ZNSt3__28ios_base5clearEj(i1, 0);
 return i3 | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw(i1, 1, 45);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc(i1, 1, 45);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 84);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 132);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 112);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx12NpConstraint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK26DownloadHandlerAssetBundle9GetLengthEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK39AssetBundleLoadFromStreamAsyncOperation18GetDownloadedBytesEv(i1) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZNK15dtProximityGrid9getBoundsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 28 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 36 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 40 >> 2];
 return;
}

function __ZNK15dtProximityGrid11getCellSizeEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 >> 2]));
 HEAPF32[i2 + 4 >> 2] = Math_fround(Math_fround(1.0) / Math_fround(HEAPF32[i1 + 4 >> 2]));
 return;
}

function __ZN9SubModuleD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 83576 + 8;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN9GfxDevice17SendVRDeviceEventEjf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 860 >> 2] | 0, i1 | 0, i2 | 0, (HEAPF32[tempDoublePtr >> 2] = f3, HEAP32[tempDoublePtr >> 2] | 0) | 0);
 return;
}

function __ZN9GfxDevice16DeleteDynamicVBOEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 4512 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx3Ext19computeCylinderMassEfff(f3, f2, f1) {
 f3 = Math_fround(f3);
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(Math_fround(Math_fround(f3 * Math_fround(3.14159274)) * f3) * Math_fround(f2 * Math_fround(2.0))) * f1);
}

function __ZN5physx2Sn18RepXCollectionImpl7destroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx14PxSetFilterOpsERKNS_10PxFilterOp4EnumES3_S3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[gb + 1457424 >> 2] = HEAP32[i1 >> 2];
 HEAP32[gb + 1457428 >> 2] = HEAP32[i2 >> 2];
 HEAP32[gb + 1457432 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __ZN5physx13NpVolumeCache17getNbCachedShapesEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0)) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 100 >> 2] | 0) + (HEAP32[i1 + 88 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZN26AnimatorOverrideController30OnInvalidateAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZN21AssetBundleFileSystem23MountToGlobalFileSystemEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 108 | 0;
 if (HEAP8[i2 >> 0] | 0) return;
 __ZN10FileSystem12MountHandlerEP17FileSystemHandler(__Z13GetFileSystemv() | 0, i1) | 0;
 HEAP8[i2 >> 0] = 1;
 return;
}

function __ZN17ProceduralTexture21AwakeFromLoadThreadedEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 HEAP32[i3 + 172 >> 2] = 4;
 i2 = i3 + 56 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) == 3) {
  HEAP32[i2 >> 2] = 4;
  i1 = 4;
 }
 HEAP32[i3 + 216 >> 2] = i1;
 return;
}

function __ZN15CapsuleCollider12SetDirectionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 68 | 0;
 if ((HEAP32[i3 >> 2] | 0) != (i2 | 0)) HEAP32[i3 >> 2] = i2;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, -2147483648);
 return;
}

function __ZL37StaticInitializeAudioSourceFilterRootPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63328 | 0, 16, gb + 863681 | 0, gb + 1576256 | 0, gb + 863701 | 0, 12) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1459888 >> 2] = i1;
 return;
}

function __ZL37StaticInitializeAudioCustomFilterRootPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(4, gb + 63328 | 0, 16, gb + 863822 | 0, gb + 1576256 | 0, gb + 855251 | 0, 31) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1459928 >> 2] = i1;
 return;
}

function __Z43AnimationClipPlayable_CUSTOM_GetApplyFootIKR9HPlayable(i1) {
 i1 = i1 | 0;
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP8[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 172 >> 0] | 0;
 return i1 | 0;
}

function __Z35VRDevice_Get_Custom_PropRefreshRatev() {
 var f1 = f0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 f1 = Math_fround(__ZNK8VRDevice20GetDeviceRefreshRateEv(__Z12GetIVRDevicev() | 0));
 return Math_fround(f1);
}

function __Z35CreateInstanceFixedBehaviourManagerv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37916 + 8;
 HEAP32[gb + 1155108 >> 2] = i1;
 return;
}

function __Z34GL_CUSTOM_IssuePluginEventInternal13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = HEAP32[i1 >> 2] | 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 740 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z33UnityAdsSettings_CUSTOM_GetGameIdi(i1) {
 i1 = i1 | 0;
 i1 = __ZNK16UnityAdsSettings9GetGameIdE15RuntimePlatform(__Z19GetUnityAdsSettingsv() | 0, i1) | 0;
 return __Z20scripting_string_newPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function __Z26CalculateImageMipLevelSizeii13TextureFormatj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 >> i4;
 i4 = i2 >> i4;
 return __Z18CalculateImageSizeii13TextureFormat((i1 | 0) < 1 ? 1 : i1, (i4 | 0) < 1 ? 1 : i4, i3) | 0;
}

function __Z18CleanupAudioModulev() {
 HEAP32[gb + 1115296 + 136 >> 2] = 0;
 HEAP32[gb + 1115296 + 264 >> 2] = 0;
 HEAP32[gb + 1115296 + 308 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIAudiov() | 0, gb + 63328 | 0);
 __Z9SetIAudioP6IAudio(0);
 return;
}

function _t2_hints_open(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 2;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 return;
}

function _t1_hints_open(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 return;
}

function _remainderf(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 f2 = Math_fround(_remquof(f1, f2, i3));
 STACKTOP = i3;
 return Math_fround(f2);
}

function _out(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 L1 : do if (i1 | 0) while (1) {
  i1 = i1 + -1 | 0;
  if (HEAP32[i3 >> 2] & 32 | 0) break L1;
  _fputwc(HEAP32[i2 >> 2] | 0, i3) | 0;
  if (!i1) break; else i2 = i2 + 4 | 0;
 } while (0);
 return;
}

function _modfl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 d1 = +_modf(d1, i4);
 HEAPF64[i2 >> 3] = +HEAPF64[i4 >> 3];
 STACKTOP = i3;
 return +d1;
}

function _ft_smooth_init(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 56 >> 2] | 0) + 8 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, HEAP32[i2 + 164 >> 2] | 0, HEAP32[i2 + 168 >> 2] | 0);
 return 0;
}

function _ft_outline_glyph_transform(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i2 | 0) _UNITY_FT_Outline_Transform(i1 + 20 | 0, i2);
 if (!i3) return;
 _UNITY_FT_Outline_Translate(i1 + 20 | 0, HEAP32[i3 >> 2] | 0, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZL31InitializeAudioManagerCallbacksvEN33FixedUpdateAudioFixedUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = __Z9GetIAudiov() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn8_N5physx2Sc18TriggerInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + -8 | 0);
 STACKTOP = i2;
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = i2 + 532 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
 HEAPF32[i1 >> 2] = f3;
 HEAP32[i2 + 536 >> 2] = 0;
 return;
}

function __ZThn32_N14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZThn24_N5physx2Sc16ActorInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1 + -24 | 0);
 STACKTOP = i2;
 return;
}

function __ZNSt3__26locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476324 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476316 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476308 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476300 | 0) | 0);
 return;
}

function __ZNK5physx9NpPhysics15getConvexMeshesEPPNS_12PxConvexMeshEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx13GuMeshFactory15getConvexMeshesEPPNS_12PxConvexMeshEjj(HEAP32[gb + 1457204 >> 2] | 0, i4, i1, i2) | 0;
}

function __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i4 | 0, i3 | 0, i2 | 0);
 return;
}

function __ZNK5physx30PxShapeMaterialsPropertyHelper12setMaterialsEPNS_7PxShapeEPKPNS_10PxMaterialEt(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 36);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 132);
 return;
}

function __ZNK5physx19NpArticulationJoint12getDriveTypeEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 12 >> 2] & 16384)) {
  i1 = HEAPU8[i1 + 145 >> 0] | 0;
  return i1 | 0;
 } else {
  i1 = HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 124 >> 2] | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZN9GfxDevice9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return;
}

function __ZN8Gradient17ValidateAlphaKeysEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 65 | 0;
 if ((HEAPU8[i2 >> 0] | 0) >= 2) return;
 HEAP8[i2 >> 0] = 2;
 HEAP8[i1 + 7 >> 0] = HEAP8[i1 + 3 >> 0] | 0;
 HEAP16[i1 + 48 >> 1] = 0;
 HEAP16[i1 + 50 >> 1] = -1;
 return;
}

function __ZN5physx7NpShapeD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx7NpShapeD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx7NpSceneD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx7NpSceneD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] & 2147483647) >>> 0 < i1 >>> 0) __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj(i2, i1);
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd14atomicExchangeEPVii(i3, i4) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i1 = 0, i2 = 0;
 do {
  i1 = HEAP32[i3 >> 2] | 0;
  i2 = HEAP32[i3 >> 2] | 0;
  if ((i2 | 0) == (i1 | 0)) HEAP32[i3 >> 2] = i4;
 } while ((i2 | 0) != (i1 | 0));
 return i1 | 0;
}

function __ZN5physx3Ext13RevoluteJoint18setDriveForceLimitEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 76 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene23postIslandGenSecondPassEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 98212 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx14PxGetFilterOpsERNS_10PxFilterOp4EnumES2_S2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1457424 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 1457428 >> 2];
 HEAP32[i3 >> 2] = HEAP32[gb + 1457432 >> 2];
 return;
}

function __ZN5Unity9Component23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN12ImmediatePtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 28 | 0, i2);
 return;
}

function __ZN23ManagedAttributeManager15InitializeClassEv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKcS3_S3_i(1, gb + 63848 | 0, 16, gb + 464723 | 0, gb + 464732 | 0, gb + 464756 | 0, 21) | 0;
 __Z19pop_allocation_rootv();
 HEAP32[gb + 1165824 >> 2] = i1;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh12SetFontStyleEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 76 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN15PointEffector2D7SetDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 104 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN14GfxContextGLESC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 4;
 HEAP32[i1 + 12 >> 2] = -559030611;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = -559030611;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN13ScreenManager17RequestResolutionEiibi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4 & 1;
 HEAP32[i1 + 16 >> 2] = i5;
 return;
}

function __ZN12NavMeshAgent15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 168976 | 0, gb + 1105016 | 0, fb + 902 | 0, gb + 29192 | 0);
 return;
}

function __ZN12AudioManager35GetCurrentSpatializerDefinitionNameEv(i1) {
 i1 = i1 | 0;
 i1 = __ZN12AudioManager31GetCurrentSpatializerDefinitionEv(i1) | 0;
 if (!i1) {
  i1 = gb + 1576256 | 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 >> 2] | 0) + 128 | 0;
 return i1 | 0;
}

function __ZN11AudioSource19SetSpatializerFloatEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 + 540 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (__ZN4FMOD3DSP12setParameterEif(i1, i2, f3) | 0) == 0;
 return i2 | 0;
}

function __Z40VRSettings_Get_Custom_PropIsDeviceActivev() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z12GetIVRDevicev() | 0;
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0) & 1;
 return i1 | 0;
}

function __Z38GUIClip_CUSTOM_INTERNAL_CALL_SetMatrixRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 __ZN12GUIClipState9SetMatrixER10InputEventRK10Matrix4x4f(i2, HEAP32[(__Z11GetGUIStatev() | 0) + 280 >> 2] | 0, i1);
 return;
}

function __Z34CreateInstanceLateBehaviourManagerv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37936 + 8;
 HEAP32[gb + 1155112 >> 2] = i1;
 return;
}

function __Z32getPxParticleReadDataFlagsBufferPKN5physx18PxParticleReadDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 40 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z14EmptyNormalMapP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = 127;
 HEAP8[i2 + 1 >> 0] = 127;
 HEAP8[i2 + 2 >> 0] = -1;
 HEAP8[i2 + 3 >> 0] = 127;
 return;
}

function _wprintf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _vwprintf(i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _tt_cmap14_done(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 36 >> 2] | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 if (!i3) return;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function _rand_r(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (Math_imul(HEAP32[i1 >> 2] | 0, 1103515245) | 0) + 12345 | 0;
 HEAP32[i1 >> 2] = i2;
 i1 = i2 >>> 11 ^ i2;
 i1 = i1 << 7 & -1658038656 ^ i1;
 i1 = i1 << 15 & -272236544 ^ i1;
 return (i1 >>> 18 ^ i1) >>> 1 | 0;
}

function _llabs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0, i5 = 0;
 i4 = (i2 | 0) > 0 | (i2 | 0) == 0 & i1 >>> 0 > 0;
 i3 = _i64Subtract(0, 0, i1 | 0, i2 | 0) | 0;
 i5 = getTempRet0() | 0;
 setTempRet0((i4 ? i2 : i5) | 0);
 return (i4 ? i1 : i3) | 0;
}

function __ZZN13WheelCollider15InitializeClassEvEN33FunctorImpl_1264kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476260 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476252 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476244 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1475432 | 0) | 0);
 return;
}

function __ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 + 56 >> 2]);
 f2 = Math_fround(f2 * Math_fround(HEAPF32[i1 + 52 >> 2]));
 return Math_fround(f2 * Math_fround(1 << HEAP32[i1 + 76 >> 2] >>> 0));
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx11NpAggregate12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE18getAngularVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 264 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 268 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 272 >> 2];
 return;
}

function __ZN9Rigidbody21UpdateKinematicTargetERKN5physx11PxTransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 80 >> 0] | 0)) return;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN8VRModule27CleanupGfxResourcesCallbackEv() {
 var i1 = 0;
 if (!(HEAP32[gb + 1469188 >> 2] | 0)) return;
 if (!(__Z12GetIVRDevicev() | 0)) return;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8TypeTree8AddChildERK16TypeTreeIterator(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8TypeTree8AddChildEj(i2, HEAP32[i3 + 4 >> 2] | 0);
 i3 = (HEAP32[i2 + 12 >> 2] | 0) + -1 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 160 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf(i3, f2) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 var i1 = 0;
 i1 = i3 + 460 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Ext13RevoluteJoint17setDriveGearRatioEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 80 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx27PxDefaultMemoryOutputStreamC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = gb + 87532 + 8;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 99672 + 8;
 __ZN5physx14NpShapeManagerD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx16PxsParticleShapeC2EPNS_10PxsContextEj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = gb + 109884 + 8;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = 0;
 HEAP32[i3 + 44 >> 2] = 0;
 HEAP32[i3 + 48 >> 2] = 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh11SetFontSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 72 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv(i1);
 return;
}

function __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = __ZN8Playable7ConnectEPS_S0_ii(i1, i2, i3, i4) | 0;
 HEAP8[i2 + 56 >> 0] = 0;
 HEAP8[i1 + 56 >> 0] = 0;
 return i4 | 0;
}

function __ZN14AreaEffector2D7SetDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0, i4 = 0;
 i3 = f2 < Math_fround(0.0);
 i4 = f2 > Math_fround(1.0e6);
 f2 = i4 ? Math_fround(1.0e6) : f2;
 HEAPF32[i1 + 104 >> 2] = i3 ? Math_fround(0.0) : f2;
 return;
}

function __ZN12AudioManager25GetScriptBufferManagerPtrEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 296 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) return i2 | 0;
 i2 = __Znwj(28) | 0;
 __ZN24AudioScriptBufferManagerC2Ev(i2);
 HEAP32[i1 >> 2] = i2;
 return i2 | 0;
}

function __ZN10AudioMixer14OnExitPlayModeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 76 >> 2] | 0;
 if (!i2) return;
 __ZN5audio5mixer27ClearExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryE(HEAP32[i1 + 72 >> 2] | 0, i2);
 return;
}

function __ZL15SortFloatByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEfEES5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __ZNK9ShaderLab16FastPropertyName7GetNameEv(i1) | 0;
 return (_strcmp(i1, __ZNK9ShaderLab16FastPropertyName7GetNameEv(i2) | 0) | 0) < 0 | 0;
}

function __Z34Caching_CUSTOM_GetVersionFromCacheP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return -1;
}

function __Z33Gizmos_CUSTOM_INTERNAL_get_matrixP10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = gb + 1162292 | 0;
 i3 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
  i1 = i1 + 4 | 0;
  i2 = i2 + 4 | 0;
 } while ((i1 | 0) < (i3 | 0));
 return;
}

function __Z32setPxVehicleChassisDataMCMOffsetPN5physx20PxVehicleChassisDataENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags(i1, i4) | 0;
}

function __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate8TextMeshEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 185320 | 0, i2, i3);
 return;
}

function __Z23AsyncReadForceCloseFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 __ZN13OpenFileCache10ForceCloseERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(HEAP32[gb + 1155100 >> 2] | 0, i1);
 return;
}

function __Z21GetPreallocatedMemoryi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 73344 >> 2] | 0;
 i1 = i2 + ((0 - i1 & 15) + i1) | 0;
 HEAP32[gb + 73344 >> 2] = i1;
 if (i1 >>> 0 > (gb + 1088336 + 9056 | 0) >>> 0) _llvm_trap(); else return i2 | 0;
 return 0;
}

function mftCall_iiid(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_iiid[i4 - fb & 1](i1 | 0, i2 | 0, +d3) | 0;
 return ftCall_iiid(i4 | 0, i1 | 0, i2 | 0, +d3) | 0;
}

function _tcsendbreak(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i1;
 HEAP32[i3 >> 2] = 0;
 i2 = _ioctl(i2, 21513, i3) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _raccess_guess_apple_single(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i4 >> 2] = 0;
 if (!i2) {
  i5 = 81;
  return i5 | 0;
 }
 i5 = _raccess_guess_apple_generic(i2, 333312, i5) | 0;
 return i5 | 0;
}

function _raccess_guess_apple_double(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i4 >> 2] = 0;
 if (!i2) {
  i5 = 81;
  return i5 | 0;
 }
 i5 = _raccess_guess_apple_generic(i2, 333319, i5) | 0;
 return i5 | 0;
}

function _pass_startup(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP8[(HEAP32[i1 + 316 >> 2] | 0) + 12 >> 0] = 0;
 i2 = i1 + 332 | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function _glCopyTexImage2D__wrapper(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 _glCopyTexImage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0, i8 | 0);
}

function _ft_bitmap_glyph_copy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 24 >> 2];
 return _UNITY_FT_Bitmap_Copy(i3, i1 + 28 | 0, i2 + 28 | 0) | 0;
}

function _emscripten_glGetActiveUniform__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _emscripten_glGetActiveUniform(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function _creat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _open(i1, 577, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function __ZZN15DirectorManager15InitializeClassEvEN47PreLateUpdateDirectorUpdateAnimationBeginstruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 3);
 return;
}

function __ZZN15DirectorManager15InitializeClassEvEN47FixedUpdateDirectorFixedUpdatePostPhysicsstruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 1);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN35PostLateUpdateBatchModeUpdatestruct7ForwardEv() {
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 if (!(__Z11IsBatchmodev() | 0)) return;
 __ZN13RenderManager15BatchModeUpdateEv(__Z16GetRenderManagerv() | 0);
 return;
}

function __ZThn32_N13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZNSt3__26locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474620 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474612 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474604 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474580 | 0) | 0);
 return;
}

function __ZNKSt3__25ctypeIcE8do_widenEPKcS3_Pc(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  HEAP8[i2 >> 0] = HEAP8[i1 >> 0] | 0;
  i2 = i2 + 1 | 0;
  i1 = i1 + 1 | 0;
 }
 return i4 | 0;
}

function __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st(i5, i4, i3, i2, i1) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i5 >> 2] | 0) + 56 >> 2] | 0, i5 | 0, i4 | 0, i3 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 44);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getLinearVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 252 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 256 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 260 >> 2];
 return;
}

function __ZNK22GenericPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 mftCall_vif(HEAP32[i1 + 132 + (HEAP32[i2 >> 2] << 2) >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0, +f3);
 return;
}

function __ZNK17AnimationCurveTplIfE15GetPostInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 80 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZN9Transform26CalculateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return 0; else {
  i1 = __ZN10GameObject17WillHandleMessageERK17MessageIdentifier(i1, gb + 1105016 | 0) | 0;
  return (i1 ? 8 : 0) | 0;
 }
 return 0;
}

function __ZN8TypeTree16AssignTypeStringERK16TypeTreeIteratorPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) + 4 | 0, i1 + 20 | 0, i3);
 return;
}

function __ZN8TypeTree16AssignNameStringERK16TypeTreeIteratorPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc((HEAP32[i1 >> 2] | 0) + ((HEAP32[i2 + 4 >> 2] | 0) * 24 | 0) + 8 | 0, i1 + 20 | 0, i3);
 return;
}

function __ZN7mecanim9animation10SampleClipERKNS0_12ConstantClipEjPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i1 = i1 + 4 | 0;
 i4 = HEAP32[i1 >> 2] | 0;
 _memcpy(i3 | 0, ((i4 | 0) == 0 ? 0 : i4 + i1 | 0) | 0, i2 << 2 | 0) | 0;
 return;
}

function __ZN7ApiGLES20CreateComputeProgramEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = mftCall_i(HEAP32[i1 + 504 >> 2] | 0) | 0;
 mftCall_vii(HEAP32[i1 + 524 >> 2] | 0, i3 | 0, i2 | 0);
 mftCall_vi(HEAP32[i1 + 520 >> 2] | 0, i3 | 0);
 return i3 | 0;
}

function __ZN5physx3Ext13RevoluteJoint16setDriveVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 72 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx28solveFrictionCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji((HEAP32[i3 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) | 0, i1 & 3, i2);
 return;
}

function __ZN5physx20PxsParticleSystemSim24setExternalAccelerationVERKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 1112 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 1116 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 1120 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5physx10NpMaterial8setFlagsENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 + 44 >> 1] = HEAP16[i1 >> 1] | 0;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i2);
 return;
}

function __ZN5Umbra9RasterOps8fillOnesERNS_17BlockRasterBufferE(i1) {
 i1 = i1 | 0;
 _memset(HEAP32[i1 + 4 >> 2] | 0, -1, Math_imul((HEAPU8[i1 + 2 >> 0] | 0) - (HEAPU8[i1 >> 0] | 0) << 2, (HEAPU8[i1 + 3 >> 0] | 0) - (HEAPU8[i1 + 1 >> 0] | 0) | 0) | 0) | 0;
 return;
}

function __ZN5Umbra4Tome14swapEndiannessEPS0_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 >>> 2;
 if (!i2) return;
 while (1) {
  i2 = i2 + -1 | 0;
  HEAP32[i1 >> 2] = _llvm_bswap_i32(HEAP32[i1 >> 2] | 0) | 0;
  if (!i2) break; else i1 = i1 + 4 | 0;
 }
 return;
}

function __ZN4Mesh11MarkDynamicEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 44 | 0;
 i3 = HEAP8[i2 >> 0] | 0;
 if (i3 & 4) return;
 HEAP8[i2 >> 0] = i3 | 4;
 __ZN4Mesh16SetChannelsDirtyEjb(i1, HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 96 >> 2] | 0, 1);
 return;
}

function __ZN4Mesh10SetIndicesEPKtjj16GfxPrimitiveTypeb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i1, i2, i3, i4, i5, i6 ? 5 : 37) | 0;
}

function __ZN4Mesh10SetIndicesEPKjjj16GfxPrimitiveTypeb(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei(i1, i2, i3, i4, i5, i6 ? 4 : 36) | 0;
}

function __ZN39AssetBundleLoadFromStreamAsyncOperation11SetPriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 56 >> 2] = i2;
 i1 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i1) return;
 __ZN23ArchiveStorageConverter11SetPriorityE14ThreadPriority(i1, i2);
 return;
}

function __ZN26VertexDeclarationCacheGLES24DestroyVertexDeclarationEP17VertexDeclaration(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN17BillboardRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN17BillboardRenderer21UpdateCachedBillboardEv(i1);
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN15ReflectionProbe29CheckAndReleaseCachedRendererEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 168 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + 16 | 0;
 if (HEAP8[i1 >> 0] | 0) return;
 HEAP8[i1 >> 0] = 1;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN15NavMeshObstacle10SetCarvingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 68 | 0;
 i1 = i1 + 136 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 return;
}

function __ZN13MemoryManager21RemoveCustomAllocatorERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i2 >> 2] | 0) + -128 | 0;
 i2 = i1 + 3812 | 0;
 HEAP32[i1 + 1764 + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXml7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 11312 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN12HandlerChain13ClearHandlersEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == (i3 | 0)) return;
 HEAP32[i1 >> 2] = i2 + (~((i2 + -4 - i3 | 0) >>> 2) << 2);
 return;
}

function __ZL23CleanupModule_Physics2Dv() {
 var i1 = 0;
 i1 = __Z13GetIPhysics2Dv() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63408 | 0);
 __Z13SetIPhysics2DP10IPhysics2D(0);
 return;
}

function __Z50Application_CUSTOM_ReplyToUserAuthorizationRequesthh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24UserAuthorizationManager31ReplyToUserAuthorizationRequestEbb(__Z27GetUserAuthorizationManagerv() | 0, i1 << 24 >> 24 != 0, i2 << 24 >> 24 != 0);
 return;
}

function __Z49setPxVehicleWheelsSimData_TireForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E(i2, i1, i3);
 return;
}

function __Z49setPxVehicleWheelsSimData_SuspForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E(i2, i1, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate7GUITextEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 185592 | 0, i2, i3);
 return;
}

function __Z11IsHDRFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 + -15 | 0) >>> 0 < 3) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = i1 + -6 | 0;
 if (i2 >>> 0 < 18) return (159745 >>> (i2 & 262143) & 1 | 0) != 0 | 0;
 i2 = (i1 | 0) == 24;
 return i2 | 0;
}

function _UNITY_png_write_finish_row(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 368 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + 1 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i2 >>> 0 < (HEAP32[i1 + 352 >> 2] | 0) >>> 0) return;
 _UNITY_png_compress_IDAT(i1, 0, 0, 4);
 return;
}

function _PxCreateBasePhysics(i5, i1, i3, i4, i2) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 return __ZN5physx9NpPhysics14createInstanceEjRNS_12PxFoundationERKNS_17PxTolerancesScaleEbPNS_20PxProfileZoneManagerE(i5, i1, i3, i4, i2) | 0;
}

function b85(i1, i2, i4, i5, f6, i7, i8, i9, i10, i11, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 f3 = Math_fround(f3);
 nullFunc_viiiifiiiiif(85);
}

function _wscanf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _vwscanf(i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _malloc_usable_size(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i1 = HEAP32[i1 + -4 >> 2] | 0;
 i2 = i1 & 3;
 if ((i2 | 0) == 1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (i1 & -8) - ((i2 | 0) == 0 ? 8 : 4) | 0;
 return i2 | 0;
}

function __ZZN11Rigidbody2D15InitializeClassEvEN35FunctorImpl_200kAnimatorMoveBuiltin4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11Rigidbody2D22ApplyRootMotionBuiltinEP14RootMotionData(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZNSt3__26localeaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__214__shared_count12__add_sharedEv(HEAP32[i2 >> 2] | 0);
 __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 return i1 | 0;
}

function __ZNSt3__25mutexD2Ev(i1) {
 i1 = i1 | 0;
 __THREW__ = 0;
 invoke_ii(fb + 2809 | 0, i1 | 0) | 0;
 i1 = __THREW__;
 __THREW__ = 0;
 if (i1 & 1) {
  i1 = ___cxa_find_matching_catch_3(0) | 0;
  getTempRet0() | 0;
  ___clang_call_terminate(i1);
 } else return;
}

function __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i1, HEAP32[i3 + 4 >> 2] | 0, i2);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx3Ext7D6Joint12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 88);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 280 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx10NpMaterial12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 64);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMaxDepenetrationVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(-Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 1024 | 0) == 0 ? i1 + 156 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 172 | 0) >> 2]));
}

function __ZNK17AnimationCurveTplIfE14GetPreInfinityEv(i1) {
 i1 = i1 | 0;
 switch (HEAP32[i1 + 76 >> 2] | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __ZN5physx2Sc14ConstraintCore9setBodiesEPNS0_9RigidCoreES3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc13ConstraintSim16postBodiesChangeEPNS0_9RigidCoreES3_(i1, i2, i3);
 return;
}

function __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcijNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN31CanvasBatchIntermediateRenderer13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1110384 >> 2] | 0;
 if (i1 | 0) __ZN10MemoryPoolD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
 HEAP32[gb + 1110384 >> 2] = 0;
 return;
}

function __ZN17SharedTextureDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 41960 + 8;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 8 >> 2] | 0, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14TerrainManager18GetTerrainPositionEP7Terrain(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i3 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 return;
}

function __ZN14PlayerSettings17SetStackTraceTypeE7LogType17StackTraceLogType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(i2, i3);
 HEAP32[(HEAP32[i1 + 340 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 return;
}

function __ZN14PhysicMaterial18GetFrictionCombineEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  break;
 case 2:
  {
   i1 = 1;
   break;
  }
 case 1:
  {
   i1 = 2;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN14ImageReference10ClearImageERK11ColorRGBA32NS_9ClearModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 __ZN6prcore10ClearImageER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE(i1, i2, i3);
 return;
}

function __ZN13MemoryManager20GetTempAllocatorSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 1552 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(__ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv(i1) | 0) + 36 >> 2] | 0;
 return i1 | 0;
}

function __ZN13MemoryManager16GetAllocatorNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 1544 >> 2] | 0) <= (i2 | 0)) {
  i2 = gb + 582059 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 1568 + (i2 << 2) >> 2] | 0) + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZN12TLSAllocatorI14StackAllocatorE8AllocateEji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[gb + 1103852 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZN14StackAllocator8AllocateEji(i1, i2, i3) | 0;
 return i3 | 0;
}

function __Z42VRSettings_Get_Custom_PropEyeTextureHeightv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z12GetIVRDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __Z37VRSettings_Get_Custom_PropRenderScalev() {
 var f1 = f0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  f1 = Math_fround(0.0);
  return Math_fround(f1);
 }
 f1 = Math_fround(__ZNK8VRDevice14GetRenderScaleEv(__Z12GetIVRDevicev() | 0));
 return Math_fround(f1);
}

function __Z36RenderTexture_CUSTOM_SupportsStencilP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 return (__Z28RenderTextureSupportsStencilP13RenderTexture(i1) | 0) & 1 | 0;
}

function __Z35RenderTexture_Set_Custom_PropActiveP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(i1, 0, -1, 0, 0);
 return;
}

function __Z24setPxCloth_StretchConfigPN5physx7PxClothENS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 260 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function __Z24RegisterStrippedTypeInfoI30RuntimeInitializeOnLoadManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31472 | 0, i2, i3);
 return;
}

function __Z23AddIntermediateRendererP20IntermediateRendererP6Camera(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = __Z16GetRendererScenev() | 0; else i1 = HEAP32[i1 + 1132 >> 2] | 0;
 __ZN21IntermediateRenderers3AddEP20IntermediateRenderer(i1, i2);
 return;
}

function _getc_unlocked(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 >>> 0 < (HEAP32[i1 + 8 >> 2] | 0) >>> 0) {
  HEAP32[i2 >> 2] = i3 + 1;
  i1 = HEAPU8[i3 >> 0] | 0;
 } else i1 = ___uflow(i1) | 0;
 return i1 | 0;
}

function _emscripten_glGetActiveAttrib__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _emscripten_glGetActiveAttrib(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZZN15DirectorManager15InitializeClassEvEN45PreLateUpdateDirectorUpdateAnimationEndstruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 4);
 return;
}

function __ZZN13TrailRenderer15InitializeClassEvEN31FunctorImpl_27kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Renderer16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 HEAP8[i1 + 340 >> 0] = 1;
 return;
}

function __ZThn8_NK5physx3Cct17CapsuleController21getHalfHeightInternalEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = i1 + -8 | 0;
 f2 = Math_fround(HEAPF32[i1 + 496 >> 2]);
 return Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i1 + 500 >> 2]) * Math_fround(.5)));
}

function __ZThn32_N12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZThn32_N12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1 + -32 | 0, i2, i3) | 0;
}

function __ZNK5physx9NpPhysics11getNbScenesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 116 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i2 >> 2] | 0);
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i2 >> 2] | 0);
 return i1 | 0;
}

function __ZNK5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19getTypePairFrictionEjj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 return Math_fround(HEAPF32[(HEAP32[i2 >> 2] | 0) + ((Math_imul(HEAP32[i2 + 20 >> 2] | 0, i1) | 0) + i3 << 2) >> 2]);
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 316 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK15CapsuleCollider15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 72 | 0);
 return;
}

function __ZNK14GfxContextGLES13GetDefaultFBOEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = (HEAP32[i2 + 16 >> 2] | 0) + 384 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN5physx3Ext13DistanceJoint14setMinDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 72 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx3Ext13DistanceJoint14setMaxDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 76 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5Unity5Cloth25SetWorldAccelerationScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 80 >> 2] = f2;
 i1 = HEAP32[i1 + 228 >> 2] | 0;
 if (!i1) return;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN5Unity5Cloth25SetUseContinuousCollisionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 92 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 228 >> 2] | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 2, i2 | 0);
 return;
}

function __ZN22LocalFileSystemHandler9MakeLocalER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return i3 | 0;
}

function __ZN14PhysicMaterial5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAPF32[i1 + 40 >> 2] = Math_fround(.600000024);
 HEAPF32[i1 + 44 >> 2] = Math_fround(.600000024);
 HEAPF32[i1 + 48 >> 2] = Math_fround(0.0);
 return;
}

function __ZN14PhysicMaterial17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12AudioManager22GetScriptBufferManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 296 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) return i2 | 0;
 i2 = __Znwj(28) | 0;
 __ZN24AudioScriptBufferManagerC2Ev(i2);
 HEAP32[i1 >> 2] = i2;
 return i2 | 0;
}

function __Z46Input_CUSTOM_INTERNAL_get_compositionCursorPosP13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z15GetInputManagerv() | 0;
 i2 = HEAP32[i3 + 164 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 160 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z44Debug_Get_Custom_PropDeveloperConsoleVisiblev() {
 var i1 = 0;
 if (!(__Z9GetIIMGUIv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z9GetIIMGUIv() | 0;
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0) & 1;
 return i1 | 0;
}

function __Z41VRSettings_Get_Custom_PropEyeTextureWidthv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z12GetIVRDevicev() | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __Z35setPxVehicleWheelsSimData_WheelDataPN5physx22PxVehicleWheelsSimDataEjNS_18PxVehicleWheelDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE(i2, i1, i3);
 return;
}

function __Z30CreateInstanceBehaviourManagerv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37896 + 8;
 HEAP32[gb + 1155104 >> 2] = i1;
 return;
}

function __Z28Scene_CUSTOM_IsValidInternali(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i2 = __Z15GetSceneManagerv() | 0;
 i1 = (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0) != 0 & 1;
 return i1 | 0;
}

function __Z26SkinnedMeshRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z34SkinnedMeshRenderer_InternalRenderRK15RenderNodeQueuejRK14ChannelAssignsib(i1, i2, i3, i4, 0);
 return;
}

function __Z24GL_CUSTOM_MultiTexCoord2iff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_viifff(HEAP32[(HEAP32[i4 >> 2] | 0) + 576 >> 2] | 0, i4 | 0, i1 | 0, +f2, +f3, 0.0);
 return;
}

function _unzGetCurrentFileInfo(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return _unzlocal_GetCurrentFileInfoInternal(i1, i2, 0, i3, i4, i5, i6, i7, i8) | 0;
}

function _shm_unlink(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 272 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = ___shm_mapname(i1, i2) | 0;
 if (!i1) i1 = -1; else i1 = _unlink(i1) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _scanf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 i2 = _vscanf(i1, i4) | 0;
 STACKTOP = i3;
 return i2 | 0;
}

function _llroundl(d1) {
 d1 = +d1;
 d1 = +_roundl(d1);
 setTempRet0((+Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~d1 >>> 0 | 0;
}

function __ZThn8_N5physx2Gu12TriangleMeshD1Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + -8 >> 2] = gb + 107420 + 8;
 HEAP32[i1 >> 2] = gb + 107420 + 88;
 i1 = i1 + 8 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i1);
 __ZN5physx20InternalTriangleMeshD2Ev(i1);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 140 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 148 >> 2];
 return;
}

function __ZNKSt3__28messagesIwE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNKSt3__28messagesIcE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNKSt3__25ctypeIwE8do_widenEPKcS3_Pw(i3, i1, i4, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 while (1) {
  if ((i1 | 0) == (i4 | 0)) break;
  HEAP32[i2 >> 2] = HEAP8[i1 >> 0];
  i2 = i2 + 4 | 0;
  i1 = i1 + 1 | 0;
 }
 return i4 | 0;
}

function __ZNK8LODGroup22GetWorldReferencePointEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 32 | 0);
 return;
}

function __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE(i1, HEAP32[i3 + 48 >> 2] | 0, i2);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 480 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE9getShapesEPPNS_7PxShapeEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj(i4 + 20 | 0, i1, i2, i3) | 0;
}

function __ZNK15NavMeshObstacle14GetWorldCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 44 | 0);
 return;
}

function __ZNK14SphereCollider15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 64 | 0);
 return;
}

function __ZNK14NavMeshManager27IsOffMeshConnectionOccupiedEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = __ZNK7dtCrowd13IsRefOccupiedEy(i1, i2, i3) | 0;
 return i3 | 0;
}

function __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   mftCall_v(HEAP32[i1 + 44 >> 2] | 0);
   return;
  }
 case 0:
  {
   mftCall_v(HEAP32[i1 + 48 >> 2] | 0);
   return;
  }
 default:
  return;
 }
}

function __ZN7ApiGLES12DeleteShaderERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 switch (i3 | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 mftCall_vi(HEAP32[i1 + 488 >> 2] | 0, i3 | 0);
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf(i2, f3) {
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 var i1 = 0;
 i1 = i2 + 536 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f3) return;
 HEAPF32[i1 >> 2] = f3;
 HEAP32[i2 + 540 >> 2] = 0;
 return;
}

function __ZN5physx20BigConvexDataBuilderC2EPKNS_2Gu14ConvexHullDataEPNS_13BigConvexDataEPKNS_6PxVec3E(i4, i2, i1, i3) {
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[i4 + 8 >> 2] = i3;
 HEAP32[i4 + 4 >> 2] = i1;
 HEAP32[i4 >> 2] = i2;
 return;
}

function __ZN5physx12NpConstraint12actorDeletedEPNS_12PxRigidActorE(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) {
  HEAP32[i1 >> 2] = 0;
  return;
 } else {
  HEAP32[i3 + 12 >> 2] = 0;
  return;
 }
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17RemapPPtrTransfer8TransferI24OcclusionCullingSettingsEEvRT_PKc17TransferMetaFlags(i2, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 return;
}

function __ZN23SharedMeshRenderingDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 58656 + 8;
 i1 = i1 + 8 | 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN21InheritVelocityModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1 + 12 | 0, i2);
 return;
}

function __ZN15AnimationBinder20SetValueAwakeGenericERK20BoundCurveDeprecated(i1) {
 i1 = i1 | 0;
 if (((HEAP32[i1 + 4 >> 2] | 0) + -5 | 0) >>> 0 >= 2) return;
 __ZN11UnityEngine9Animation27BoundCurveValueAwakeGenericER6Object(HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN14PhysicMaterial16GetBounceCombineEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 switch (i1 | 0) {
 case 3:
 case 0:
  break;
 case 2:
  {
   i1 = 1;
   break;
  }
 case 1:
  {
   i1 = 2;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN14NavMeshManager32SetPathfindingIterationsPerFrameEi(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (i1 | 0) > 0 ? i1 : 0;
 HEAP32[i3 + 36 >> 2] = i2;
 i1 = HEAP32[i3 + 100 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 + 448 >> 2] = i2;
 return;
}

function __ZN14LineParametersD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 44780 + 8;
 if ((HEAP32[i1 + 92 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 76 >> 2] | 0, i1 + 80 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN13UnityProfiler13StartNewFrameE12ProfilerMode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN13UnityProfiler21StartNewFrameInternalE12ProfilerMode(i2, i1) | 0;
 return i2 | 0;
}

function __ZN13Simd4iFactoryIN6detail9FourTupleEEC2Eiiii(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN13PhysicsModule10GetGravityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __Z21GetManagerFromContexti(9) | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 32 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 40 >> 2];
 return;
}

function __ZN12MemoryStreamD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 113908 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 113908 + 32;
 if (!(HEAP8[i1 + 8 >> 0] | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 24 >> 2] | 0, gb + 63552 | 0);
 return;
}

function __ZN11ShapeModuleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83032 + 8;
 if ((HEAP32[i1 + 120 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 104 >> 2] | 0, i1 + 108 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11AudioSource23SetIgnoreListenerVolumeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 496 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i1);
 return;
}

function __ZL27CleanupModule_JSONSerializev() {
 __Z35UnregisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(fb + 998 | 0);
 __Z35UnregisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(fb + 999 | 0);
 return;
}

function __Z31CrashReport_CUSTOM_RemoveReportP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return 0;
}

function __Z25GL_CUSTOM_ClearWithSkyboxhP12Il2CppObject(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __Z15ClearWithSkyboxbPK6Camera(i2 << 24 >> 24 != 0, i1);
 return;
}

function __Z20ReadObjectFromVectorR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z20ReadObjectFromVectorILb0EEvR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags(i1, i2, i3);
 return;
}

function __Z20FindPluginExecutablePKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1576256 | 0, 0);
 return;
}

function _UNITY_png_get_sPLT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0 & (i3 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i2 + 224 >> 2];
 i3 = HEAP32[i2 + 228 >> 2] | 0;
 return i3 | 0;
}

function _UNITY_FT_Done_Glyph(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 if (!i1) return;
 i2 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 i3 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] | 0;
 if (i3 | 0) mftCall_vi(i3 | 0, i1 | 0);
 _UNITY_ft_mem_free(i2, i1);
 return;
}

function _llround(d1) {
 d1 = +d1;
 d1 = +_round(+d1);
 setTempRet0((+Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~d1 >>> 0 | 0;
}

function _gzgetc(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = (_gzread(i1, i3, 1) | 0) == 1;
 STACKTOP = i2;
 return (i1 ? HEAPU8[i3 >> 0] | 0 : -1) | 0;
}

function _getw(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 i1 = (_fread(i3, 4, 1, i1) | 0) != 0;
 STACKTOP = i2;
 return (i1 ? HEAP32[i3 >> 2] | 0 : -1) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj(i1, i2, i3, _wcslen(i3) | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj(i1, i2, i3, _strlen(i3) | 0) | 0;
}

function __ZNKSt3__26locale5__imp9has_facetEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 8 >> 2] | 0;
 if ((HEAP32[i1 + 12 >> 2] | 0) - i3 >> 2 >>> 0 > i2 >>> 0) i1 = (HEAP32[i3 + (i2 << 2) >> 2] | 0) != 0; else i1 = 0;
 return i1 | 0;
}

function __ZNK5physx2Sc5Scene22getNbBroadPhaseRegionsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 208);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0, 152);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK26LegacyTreeInstanceRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[HEAP32[i1 + 276 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZNK13WheelCollider15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 60 | 0);
 return;
}

function __ZNK13OcclusionArea15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 44 | 0);
 return;
}

function __ZN8LODGroup15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30752 | 0, gb + 1105016 | 0, fb + 522 | 0, gb + 29192 | 0);
 return;
}

function __ZN5physx3Ext13DistanceJoint12setToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 80 >> 2] = f2;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext13DistanceJoint12setStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 84 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc13ConstraintSim19destroyLLConstraintEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc5Scene25deallocateConstraintBlockEPvj(HEAP32[i2 + 96 >> 2] | 0, i1, HEAP32[i2 + 44 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx13PxsCCDContext14postCCDAdvanceEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx28MFrictionVsSlipGraphPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 831317;
 HEAP32[i1 + 4 >> 2] = 605;
 HEAP32[i1 + 8 >> 2] = fb + 24;
 HEAP32[i1 + 12 >> 2] = fb + 24;
 HEAP32[i1 + 16 >> 2] = 3;
 HEAP32[i1 + 20 >> 2] = 2;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11detachShapeERNS_7PxShapeEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb(i2 + 20 | 0, i1, i2, i3);
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 192 >> 2] | 0, i2 | 0, i1 | 0, i3 | 0);
 return;
}

function __ZN5Umbra9RasterOps5clearERNS_17BlockRasterBufferE(i1) {
 i1 = i1 | 0;
 _memset(HEAP32[i1 + 4 >> 2] | 0, 0, Math_imul((HEAPU8[i1 + 2 >> 0] | 0) - (HEAPU8[i1 >> 0] | 0) << 2, (HEAPU8[i1 + 3 >> 0] | 0) - (HEAPU8[i1 + 1 >> 0] | 0) | 0) | 0) | 0;
 return;
}

function __ZN25PathNamePersistentManager24PathIDToPathNameInternalEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, (HEAP32[i2 + 208 >> 2] | 0) + (i3 * 12 | 0) | 0);
 return;
}

function __ZN23MeshVertexFormatManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = __Z46get_current_allocation_root_reference_internalv() | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 4;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN23AllocationRootReference7ReleaseEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN23AllocationRootReferenceD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63584 | 0);
 return;
}

function __ZN18PlayableController4StopEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 164 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController(__Z18GetDirectorManagerv() | 0, i1);
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN18ColorBySpeedModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 return;
}

function __ZN16PlayerConnection25CreateAndReportConnectionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[gb + 1163124 >> 2] = (HEAP32[gb + 1163124 >> 2] | 0) + 1;
 __ZN17GeneralConnection18RegisterConnectionEji(i1, HEAP32[gb + 1163124 >> 2] | 0, i2);
 return;
}

function __ZN16NovodexAllocator8allocateEjPKcS1_i(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63400 | 0, 0, gb + 662472 | 0, 167) | 0;
}

function __ZN16LightmapSettings28SetStaticLightmapSceneHandleEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE(i2, HEAP32[(__Z21GetManagerFromContexti(26) | 0) + 36 + 12 >> 2] | 0, i1 + 56 | 0);
 return;
}

function __ZN13GfxDeviceGLES23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN11TimeManager5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 48 >> 2] = Math_fround(.0199999996);
 HEAPF32[i1 + 200 >> 2] = Math_fround(.333333343);
 HEAPF32[i1 + 196 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 204 >> 2] = Math_fround(.0299999993);
 return;
}

function __ZN10dtNodePoolD2Ev(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 8 >> 2] | 0);
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZL30InitializeModule_JSONSerializev() {
 __Z33RegisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(fb + 998 | 0);
 __Z33RegisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE(fb + 999 | 0);
 return;
}

function __Z48GUIClip_CUSTOM_Internal_GetAbsoluteMousePositionP13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z11GetGUIStatev() | 0;
 i2 = HEAP32[i3 + 240 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 236 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z30Caching_CUSTOM_DeleteFromCacheP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return 0;
}

function __Z27getPxHeightFieldDescSamplesPKN5physx17PxHeightFieldDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 12 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z24RegisterStrippedTypeInfoI26AnimatorOverrideControllerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 178624 | 0, i2, i3);
 return;
}

function _UNITY_png_free_buffer_list(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (!i1) return;
 HEAP32[i2 >> 2] = 0;
 do {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  _UNITY_png_free(i3, i2);
 } while ((i1 | 0) != 0);
 return;
}

function mftCall_viid(i4, i1, i2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 3 | 0)) {
  FUNCTION_TABLE_viid[i4 - fb & 3](i1 | 0, i2 | 0, +d3);
  return;
 }
 ftCall_viid(i4 | 0, i1 | 0, i2 | 0, +d3);
}

function b77(i1, i2, i3, f4, i5, f6, i7, f8, f9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 i10 = i10 | 0;
 nullFunc_viiifififfi(77);
}

function _unzGetGlobalInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) {
  i2 = -102;
  return i2 | 0;
 }
 i3 = i1 + 36 | 0;
 i1 = HEAP32[i3 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i2 + 4 >> 2] = i1;
 i2 = 0;
 return i2 | 0;
}

function __ZNK8Animator22GetControllerWorkspaceEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMaxDepenetrationVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(-Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 1024 | 0) == 0 ? i1 + 156 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 172 | 0) >> 2]));
}

function __ZNK13GfxDeviceNull27GetActiveRenderColorSurfaceEi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i2 + 4872 + (i1 << 2) >> 2] | 0;
 if (!i1) {
  i2 = HEAP32[i2 + 4400 >> 2] | 0;
  return i2 | 0;
 } else {
  i2 = i1;
  return i2 | 0;
 }
 return 0;
}

function __ZN9Transform23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN9Transform25CompleteTransformTransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN8WWWAudioD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 71808 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, 0);
 __ZN3WWW7ReleaseEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN8Renderer10AddToSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = __Z16GetRendererScenev() | 0;
 i3 = i1 + 284 | 0;
 if ((HEAP32[i3 >> 2] | 0) != -1) return;
 HEAP32[i3 >> 2] = __ZN13RendererScene11AddRendererEP8Renderer(i2, i1) | 0;
 return;
}

function __ZN8Animator18GetFeetPivotActiveEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 128 >> 2] | 0) + 12 >> 2]);
 return Math_fround(f2);
}

function __ZN7dtCrowd12stopExplicitERK13dtCrowdHandleb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = (HEAP32[i1 + 16 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 608 | 0) + 602 | 0;
 HEAP8[i2 >> 0] = HEAP8[i2 >> 0] & -9 | (i3 & 1) << 3 & 255;
 return;
}

function __ZN5physx28PxTriangleMeshRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx28PxRigidDynamicRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx28PxArticulationRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx20solveContactPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3, i2);
 return;
}

function __ZN4FileC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN25RuntimeAnimatorController17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i2, gb + 1105796 | 0);
 __ZN8UserList5ClearEv(i1 + 56 | 0);
 __ZN8UserList5ClearEv(i2);
 return;
}

function __ZN18LoadSceneOperation21PostLoadSceneAdditiveEv(i1) {
 i1 = i1 | 0;
 __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv(i1 + 180 | 0);
 __ZN18LoadSceneOperation21CompleteAwakeSequenceEv(i1);
 if ((HEAP32[i1 + 460 >> 2] | 0) != 1) return;
 return;
}

function __ZN17PersistentManager25GetSerializedFileInternalEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(__ZN17PersistentManager26GetStreamNameSpaceInternalEi(i1, i2) | 0) >> 2] | 0;
 return i2 | 0;
}

function __ZN14FileCacherRead13AllocateBlockERNS_10CacheBlockE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(HEAP32[i1 + 4 >> 2] | 0, 16, gb + 63552 | 0, 0, gb + 468446 | 0, 30) | 0;
 return;
}

function __ZN13MonoBehaviour15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 132 >> 2] | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 40 >> 2] | 0) > -1) __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 24 >> 2] | 0, i1 + 28 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12GUIClipState7ReapplyER10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i3 | 0)) return;
 __ZN12GUIClipState5ApplyER10InputEventR7GUIClip(i1, i2, i3 + -56 | 0);
 return;
}

function __ZN10VertexData10DeallocateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10Effector2D17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0)) return;
 __ZN16Physics2DManager21RemoveEffectorUpdatesEP10Effector2D(__Z19GetPhysicsManager2Dv() | 0, i1);
 return;
}

function __ZL25ProgramUniformMatrix4x3fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 324 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL25ProgramUniformMatrix4x2fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 316 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL25ProgramUniformMatrix3x4fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 320 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL25ProgramUniformMatrix3x2fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 308 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL25ProgramUniformMatrix2x4fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 312 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL25ProgramUniformMatrix2x3fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 304 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __Z35setPxVehicleDriveSimDataNW_DiffDataPN5physx23PxVehicleDriveSimDataNWERKNS_27PxVehicleDifferentialNWDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx23PxVehicleDriveSimDataNW11setDiffDataERKNS_27PxVehicleDifferentialNWDataE(i2, i1);
 return;
}

function __Z35setPxVehicleDriveSimData4W_DiffDataPN5physx23PxVehicleDriveSimData4WERKNS_27PxVehicleDifferential4WDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx23PxVehicleDriveSimData4W11setDiffDataERKNS_27PxVehicleDifferential4WDataE(i2, i1);
 return;
}

function __Z27CreateInstanceUpdateManagerv() {
 var i1 = 0, i2 = 0;
 i1 = __Znwj(16) | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = gb + 37956 + 8;
 HEAP32[gb + 1155116 >> 2] = i1;
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity17ConfigurableJointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 111956 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI25RuntimeAnimatorControllerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 178436 | 0, i2, i3);
 return;
}

function _init_destination(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 1, 4096) | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = 4096;
 return;
}

function __ZZN8Collider15InitializeClassEvEN32FunctorImpl_779kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZN8Animator15InitializeClassEvEN32FunctorImpl_386kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 + -4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 208648 + 8;
 __ZNSt3__28ios_base4initEPv(i1, i2);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = -1;
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 208616 + 8;
 __ZNSt3__28ios_base4initEPv(i1, i2);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = -1;
 return;
}

function __ZNK5physx2Cm19CmEventNameProvider15getProfileNamesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = gb + 1098824 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK11BoxCollider15GetGlobalCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform14TransformPointERK8Vector3f(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0, i2 + 60 | 0);
 return;
}

function __ZN7mecanim12statemachine10IsDisabledEPKNS0_17StateMachineInputE(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i1) | 0) ^ 1;
 return i1 | 0;
}

function __ZN5physx3Ext13DistanceJoint10setDampingEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 + 80 >> 2] | 0) + 88 >> 2] = f1;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx2Sc24ElementInteractionMarkerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 40 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 44 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene19updateCCDSinglePassEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene19islandGenSecondPassEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx16PxsFluidDynamics10mergeForceEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx27PxRigidStaticRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx27PxHeightFieldRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx27PxClothFabricRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN3WWW7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 if ((i1 | 0) == 0 | (HEAP32[i2 >> 2] | 0) != 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0);
 return;
}

function __ZN2UI14CanvasRenderer11GetSyncFlagEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[i1 + 204 >> 2] | 0) != 0;
 i2 = i3 & 1;
 i1 = (HEAP32[i1 + 220 >> 2] | 0) != 0;
 if (i3) return (i1 ? 3 : i2) | 0; else return (i1 ? 2 : i2) | 0;
 return 0;
}

function __ZN18AsyncUploadManager13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1157732 >> 2] | 0;
 if (i1 | 0) __ZN18AsyncUploadManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63160 | 0);
 HEAP32[gb + 1157732 >> 2] = 0;
 return;
}

function __ZN14SplatMaterials14SetTerrainDataERK4PPtrI11TerrainDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i2 >> 2] | 0) == (i1 | 0)) return;
 HEAP32[i2 >> 2] = i1;
 __ZN14SplatMaterials15UpdateMaterialsEv(i2);
 return;
}

function __ZN13RuntimeStaticI15DirectorManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN15DirectorManagerD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13RuntimeStaticI15AnimationBinderE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN15AnimationBinderD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12FlareManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 4;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN12CachedReader18InitResourceImagesER18ResourceImageGroup(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 36 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN11dtPathQueue5purgeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 228 | 0;
 __Z18dtFreeNavMeshQueryP14dtNavMeshQuery(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 i1 = i1 + 48 | 0;
 __Z6dtFreePv(HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11KeyframeTplIfEC2EfRKf(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 HEAPF32[i1 >> 2] = f2;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(0.0);
 return;
}

function __ZN11AudioSource12AddToManagerEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1460024 >> 2] = (HEAP32[gb + 1460024 >> 2] | 0) + 1;
 if (!(HEAP8[i1 + 497 >> 0] | 0)) return;
 if (!(__Z14IsWorldPlayingv() | 0)) return;
 __ZN11AudioSource4PlayEd(i1, 0.0);
 return;
}

function __ZN11AudioModule21SetActiveOutputDriverEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __Z18GetAudioManagerPtrv() | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN12AudioManager21SetActiveOutputDriverEP9FMOD_GUID(i1, i2) | 0;
 return i2 | 0;
}

function __ZN10systeminfo24GetRuntimePlatformStringEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 454760 | 0, 5);
 return;
}

function __ZL20dst_init_destinationP20jpeg_compress_struct(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 + 20 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i1 + 24 >> 2];
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __Z44UnityAnalyticsHandler_CUSTOM_InternalDestroyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i1 = i1 + 8 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN18BaseUnityAnalytics7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z44Debug_Set_Custom_PropDeveloperConsoleVisibleh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__Z9GetIIMGUIv() | 0)) return;
 i2 = __Z9GetIIMGUIv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z42Input_CUSTOM_INTERNAL_get_mouseScrollDeltaP13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z15GetInputManagerv() | 0;
 i2 = HEAP32[i3 + 112 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 108 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z34setPxVehicleWheelsSimData_TireDataPN5physx22PxVehicleWheelsSimDataEjNS_17PxVehicleTireDataE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData11setTireDataEjRKNS_17PxVehicleTireDataE(i2, i1, i3);
 return;
}

function __Z30GUI_CUSTOM_Internal_SetTooltipP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return;
}

function __Z24RegisterStrippedTypeInfoI24PhysicsUpdateBehaviour2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 154956 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI24EllipsoidParticleEmitterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 190404 | 0, i2, i3);
 return;
}

function _llrint(d1) {
 d1 = +d1;
 d1 = +_rint(d1);
 setTempRet0((+Math_abs(d1) >= 1.0 ? (d1 > 0.0 ? ~~+Math_min(+Math_floor(d1 / 4294967296.0), 4294967295.0) >>> 0 : ~~+Math_ceil((d1 - +(~~d1 >>> 0)) / 4294967296.0) >>> 0) : 0) | 0);
 return ~~d1 >>> 0 | 0;
}

function _bitshift64Ashr(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  setTempRet0(i2 >> i1 | 0);
  return i3 >>> i1 | (i2 & (1 << i1) - 1) << 32 - i1;
 }
 setTempRet0(((i2 | 0) < 0 ? -1 : 0) | 0);
 return i2 >> i1 - 32 | 0;
}

function __ZZN9Rigidbody15InitializeClassEvEN35FunctorImpl_465kAnimatorMoveBuiltin4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN9Rigidbody22ApplyRootMotionBuiltinEP14RootMotionData(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZN8VRDevice10InitializeEbEN30FixedUpdateVRFixedUpdatestruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN46PostLateUpdatePlayerSendFramePostPresentstruct7ForwardEv() {
 var i1 = 0;
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 i1 = HEAP32[gb + 1115296 + 348 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZThn8_N5physx17ConvexMeshBuilderD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 110060 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110060 + 84;
 __ZN5physx17ConvexHullBuilderD2Ev(i1 + 132 | 0);
 __ZN5physx2Gu10ConvexMeshD2Ev(i1);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 128 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 132 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 136 >> 2];
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 524 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, 1114111, 0) | 0;
}

function __ZNK8VRDevice24GetDisableBackBufferMSAAEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 261 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK8Renderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = HEAP16[i1 + 218 >> 1] | 0;
 i3 = i4 & 65535;
 return (i4 << 16 >> 16 == 0 | (i3 | 0) > (i2 | 0) ? i2 : i3 + -1 | 0) + (HEAPU16[i1 + 216 >> 1] | 0) | 0;
}

function __ZNK8Animator21GetControllerConstantEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(__ZNK5physx5cloth14IterationStateI8Scalar4fE16getPreviousAlphaEv(i1));
 return Math_fround(f2 + Math_fround(HEAPF32[i1 + 196 >> 2]));
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE9getShapesEPPNS_7PxShapeEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj(i4 + 20 | 0, i1, i2, i3) | 0;
}

function __ZNK4crnd10dxt3_block9get_alphaEjjb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = HEAPU8[i1 + ((i3 << 1) + (i2 >>> 1)) >> 0] | 0;
 i3 = ((i2 & 1 | 0) == 0 ? i3 : i3 >>> 4) & 15;
 return (i4 ? i3 << 4 : 0) | i3 | 0;
}

function __ZNK12b2ChainShape11ComputeMassEP10b2MassDataf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN8Collider17HasActorRigidbodyEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZN6Shader19SetMaximumShaderLODEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 32 >> 2] | 0;
 if ((HEAP32[i3 + 56 >> 2] | 0) == (i2 | 0)) return;
 __ZN9ShaderLab9IntShader19SetMaximumShaderLODEP6Shaderi(i3, i1, i2);
 return;
}

function __ZN5physx2Sc23ElementActorInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx26PxConvexMeshRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN27ShapeModulePropertyBindings13SetFloatValueER14ParticleSystemif(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 if (i3 | 0) return;
 __ZN14ParticleSystem8SyncJobsEb(1);
 HEAP32[i2 + 104 >> 2] = ~~f4;
 return;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17RemapPPtrTransfer8TransferI22ParticleSystemRendererEEvRT_PKc17TransferMetaFlags(i2, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 return;
}

function __ZN14NavMeshManager7AddTileEPhii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((__ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy(HEAP32[i1 + 108 >> 2] | 0, i2, i3, 1, i4, 0) | 0) >= 0) return;
 __Z6dtFreePv(i2);
 return;
}

function __ZN12IFileAdapter9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function __ZN11AudioSource22SetIgnoreListenerPauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 427 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN11AudioSource16UpdatePauseStateEv(i1);
 return;
}

function __ZL23ProgramUniformMatrix4fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 300 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL23ProgramUniformMatrix3fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 296 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __ZL23ProgramUniformMatrix2fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiiii(HEAP32[i1 + 292 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
 return;
}

function __Z5b2LogPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i4 = i3;
 HEAP32[i4 >> 2] = i2;
 _vprintf(i1, i4) | 0;
 STACKTOP = i3;
 return;
}

function __Z24RegisterStrippedTypeInfoI24OcclusionCullingSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 35088 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI23CloudWebServicesManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 189852 | 0, i2, i3);
 return;
}

function __Z20SetShaderGlobalFloatN9ShaderLab16FastPropertyNameEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, i1, f2, 0);
 return;
}

function __Z19GL_CUSTOM_TexCoord3fff(f1, f2, f3) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vifff(HEAP32[(HEAP32[i4 >> 2] | 0) + 572 >> 2] | 0, i4 | 0, +f1, +f2, +f3);
 return;
}

function __Z10md5_startsP11md5_context(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 1732584193;
 HEAP32[i1 + 12 >> 2] = -271733879;
 HEAP32[i1 + 16 >> 2] = -1732584194;
 HEAP32[i1 + 20 >> 2] = 271733878;
 return;
}

function _UNITY_FT_Stream_OpenMemory(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function b13(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 nullFunc_iiiiiiiiiiii(13);
 return 0;
}

function _tre_compare_items(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] >> 2] | 0;
 i2 = HEAP32[HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] >> 2] | 0;
 return ((i1 | 0) < (i2 | 0) ? -1 : (i1 | 0) > (i2 | 0) & 1) | 0;
}

function _clearerr(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  i2 = (___lockfile(i1) | 0) == 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -49;
  if (!i2) ___unlockfile(i1);
 } else HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -49;
 return;
}

function _cff_parser_init(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _memset(i1 + 4 | 0, 0, 408) | 0;
 HEAP32[i1 + 404 >> 2] = i1 + 16;
 HEAP32[i1 + 408 >> 2] = i2;
 HEAP32[i1 + 412 >> 2] = i3;
 HEAP32[i1 >> 2] = i4;
 return;
}

function __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_83kSetPolygon2D4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 116 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 120 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 124 >> 2];
 return;
}

function __ZNKSt3__27collateIwE7compareEPKwS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZNKSt3__27collateIcE7compareEPKcS3_S3_S3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return mftCall_iiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0) | 0;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE(i3, i4, i5, 1114111, 0) | 0;
}

function __ZNK8VRDevice26GetApplicationHasLostFocusEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 284 >> 2] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 232 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_i(i1 | 0) | 0;
 return i1 | 0;
}

function __ZNK8Animator19GetControllerMemoryEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx6shdfnd7FastIPC14haveConnectionEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[((HEAP8[i2 + 12 >> 0] | 0) == 0 ? i1 : i1 + 1 | 0) >> 0] & 1) != 0;
 return i2 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 152 >> 2];
 return;
}

function __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE9getShapesEPPNS_7PxShapeEjj(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj(i4 + 20 | 0, i1, i2, i3) | 0;
}

function __ZNK13AnimationClip22GetAverageAngularSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 i1 = HEAP32[i1 + 216 >> 2] | 0;
 if (!i1) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 1084 >> 2]);
 return Math_fround(f2);
}

function __ZNK12b2MotorJoint10GetAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = (HEAP32[i2 + 52 >> 2] | 0) + 12 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK12b2MotorJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = (HEAP32[i2 + 48 >> 2] | 0) + 12 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN8Animator14GetPivotWeightEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  f2 = Math_fround(0.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 136 >> 2] | 0) + 132 >> 2]);
 return Math_fround(f2);
}

function __ZN5physx7profile15ZoneManagerImpl7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn22DeserializationContextD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Gu12TriangleMeshD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 107420 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 107420 + 88;
 i1 = i1 + 16 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i1);
 __ZN5physx20InternalTriangleMeshD2Ev(i1);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene18updateCCDMultiPassEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx13PxsCCDContext12postCCDSweepEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx25PxAggregateRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData4freeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx22PxVehicleTelemetryData4freeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11detachShapeERNS_7PxShapeEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb(i2 + 20 | 0, i1, i2, i3);
 return;
}

function __ZN5physx13updateJouncesEPKfPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN24MeshIntermediateRenderer13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1110380 >> 2] | 0;
 if (i1 | 0) __ZN10MemoryPoolD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
 HEAP32[gb + 1110380 >> 2] = 0;
 return;
}

function __ZN23DefaultMeshVertexFormatC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 i2 = HEAP32[gb + 1161832 >> 2] | 0;
 HEAP32[gb + 1161832 >> 2] = i2 + 1;
 HEAP32[gb + 1161836 + (i2 << 2) >> 2] = i1;
 return;
}

function __ZN20SoundChannelInstance8getDelayE14FMOD_DELAYTYPEPjS1_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 80 + (i2 << 2) >> 2];
 HEAP32[i4 >> 2] = HEAP32[i1 + 96 + (i2 << 2) >> 2];
 return 0;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper14getNamedValuesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 72 >> 2] | 0;
 i2 = HEAP32[i2 + 76 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i3 + (i2 << 3);
 return;
}

function __ZN12ServerSocketC2Eiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN6SocketC2Eiii(i1, i2, i3, i4);
 HEAP32[i1 >> 2] = gb + 73540 + 8;
 HEAP8[i1 + 17 >> 0] = 0;
 __ZN6Socket15SetReuseAddressEb(i1, 1) | 0;
 return;
}

function __ZN12GUIClipState24SetAbsoluteMousePositionERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 140 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN11GameManager17MainThreadCleanupEv(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = 0;
 do {
  i3 = gb + 1104348 + (i1 << 2) | 0;
  if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) HEAP32[i3 >> 2] = 0;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 28);
 return;
}

function __ZN10systeminfo21GetTemporaryCachePathEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 1075291 | 0, 4);
 return;
}

function __ZN10PngDecoderD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 43108 + 8;
 i2 = i1 + 32 | 0;
 i1 = i1 + 36 | 0;
 if (HEAP32[i2 >> 2] | 0) _UNITY_png_destroy_read_struct(i2, i1, 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z4GrayP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = 127;
 HEAP8[i2 + 1 >> 0] = 127;
 HEAP8[i2 + 2 >> 0] = 127;
 HEAP8[i2 + 3 >> 0] = 127;
 return;
}

function __Z45setPxVehicleWheelsSimData_SuspTravelDirectionPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData22setSuspTravelDirectionEjRKNS_6PxVec3E(i2, i1, i3);
 return;
}

function __Z37Physics2D_CUSTOM_INTERNAL_get_gravityP13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = __Z20GetPhysics2DSettingsv() | 0;
 i2 = HEAP32[i3 + 36 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 32 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z37AnimationClipPlayable_CUSTOM_SetSpeedR9HPlayablef(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(__Z22PlayableValidityChecksRK9HPlayable(i1) | 0)) return;
 HEAPF32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 168 >> 2] = f2;
 return;
}

function __Z28getPxTolerancesScale_IsValidPKN5physx17PxTolerancesScaleE(i1) {
 i1 = i1 | 0;
 if (!(Math_fround(HEAPF32[i1 >> 2]) > Math_fround(0.0))) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = Math_fround(HEAPF32[i1 + 4 >> 2]) > Math_fround(0.0);
 return i1 | 0;
}

function __Z28AndroidJNI_CUSTOM_FatalErrorP12Il2CppString(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN11ICallStringC2EP12Il2CppString(i2, i1);
 STACKTOP = i2;
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity14CharacterJointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 111756 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI23ShaderVariantCollectionEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31592 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI22NavMeshProjectSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 169664 | 0, i2, i3);
 return;
}

function __Z18GetSurfaceTexelPtrR13CImageSurfaceii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = (Math_imul(HEAP32[i1 >> 2] | 0, i3) | 0) + i2 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) + ((Math_imul(i3, HEAP32[i1 + 8 >> 2] | 0) | 0) << 2) | 0;
}

function _UNITY_png_malloc_default(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 if (i1 | 0) {
  i1 = _malloc(i1) | 0;
  if (i1 | 0) {
   i2 = i1;
   return i2 | 0;
  }
 }
 _UNITY_png_error(i2, gb + 352096 | 0);
 return 0;
}

function _UNITY_FT_Activate_Size(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 36; else {
  i2 = HEAP32[i1 >> 2] | 0;
  if (!i2) i1 = 35; else if (!(HEAP32[i2 + 96 >> 2] | 0)) i1 = 35; else {
   HEAP32[i2 + 88 >> 2] = i1;
   i1 = 0;
  }
 }
 return i1 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 528 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__219__shared_weak_count14__release_weakEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 8 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if (!i2) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return;
}

function __ZNK5physx5cloth14IterationStateI8Scalar4fE16getPreviousAlphaEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround((HEAP32[i1 + 192 >> 2] | 0) >>> 0);
 return Math_fround(Math_fround(1.0) - Math_fround(f2 * Math_fround(HEAPF32[i1 + 196 >> 2])));
}

function __ZNK5physx2Sn18RepXCollectionImpl18getTolerancesScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 132 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZNK5physx2Sc5Scene17getBroadPhaseTypeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 49828 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx7NpShape12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12createObjectERPhRNS_24PxDeserializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx7NpCloth12createObjectERPhRNS_24PxDeserializationContextE(i1, i2) | 0;
}

function __ZNK20UnityConnectSettings16IsHwStatsEnabledEv(i1) {
 i1 = i1 | 0;
 if (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(__Z17GetPlayerSettingsv() | 0) | 0) if (__Z20IsHumanControllingUsv() | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = 0;
 return i1 | 0;
}

function __ZNK20HardwareInfoReporter16IsHwStatsEnabledEv(i1) {
 i1 = i1 | 0;
 if (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(__Z17GetPlayerSettingsv() | 0) | 0) if (__Z20IsHumanControllingUsv() | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = 0;
 return i1 | 0;
}

function __ZN9AudioClip23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN16StreamedResource8TransferI17RemapPPtrTransferEEvRT_(i1 + 72 | 0, i2);
 return;
}

function __ZN7mecanim9animation8GetGoalXERKNS0_18ClipMuscleConstantEPKfi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN7mecanim9animation8GetClipXERKNS0_18ClipMuscleConstantEPKfi(i1, i2, i3, (i4 * 7 | 0) + 14 | 0);
 return;
}

function __ZN5physx34PxVehicleClutchDataGeneratedValuesC2EPKNS_19PxVehicleClutchDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx2Sc21ElementSimInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore17setTargetVelocityERKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 76 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 80 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 84 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN5physx24PxMaterialRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11detachShapeERNS_7PxShapeEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb(i2 + 20 | 0, i1, i2, i3);
 return;
}

function __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN12ImmediatePtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1 + 28 | 0, i2);
 return;
}

function __ZN21ArchiveStorageCreator16BeginStreamBlockE15CompressionType16CompressionLevel(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj(i1, 1, i2, i3, -1) | 0;
}

function __ZN19CloudServiceHandler17StartEventHandlerERK8UnityStrii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN11UnityEngine15CloudWebService19SessionEventManager5StartERK8UnityStrii(i1 + 200 | 0, i2, i3, i4) | 0;
}

function __ZN19CloudServiceHandler10QueueEventEPN11UnityEngine15CloudWebService14CloudEventInfoE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN11UnityEngine15CloudWebService19SessionEventManager10QueueEventEPNS0_14CloudEventInfoE(i1 + 200 | 0, i2) | 0;
}

function __ZN15FrictionJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15FileSystemEntry12CreateAsFileEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN15DistanceJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15AnchoredJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19StreamedBinaryWriteILb0EE8TransferI13TrailRendererEEvRT_PKc17TransferMetaFlags(i2, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 return;
}

function __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = (HEAP32[i1 >> 2] | 0) + -4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -1;
 if ((i2 + -1 | 0) < 0) __ZdlPv((HEAP32[i1 >> 2] | 0) + -12 | 0);
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i1 + 4 >> 2] | 0, i2, 8);
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i1 + 4 >> 2] | 0, i2, 1);
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i1 + 4 >> 2] | 0, i2, 4);
 return;
}

function __ZN10DynamicVBOD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 57900 + 8;
 if ((HEAP32[i1 + 20 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 4 >> 2] | 0, i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __Z37GraphicsSettings_CUSTOM_GetShaderModeN16GraphicsSettings17BuiltinShaderTypeE(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE(__Z19GetGraphicsSettingsv() | 0, i1) | 0) + 4 >> 2] | 0;
}

function __Z32getPxVehicleChassisDataMCMOffsetPKN5physx20PxVehicleChassisDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __Z24RegisterStrippedTypeInfoI22ParticleSystemRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 80260 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI21WorldParticleColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 191360 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI21UnityAnalyticsManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 188588 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI21AudioDistortionFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 170864 | 0, i2, i3);
 return;
}

function __Z17GL_CUSTOM_Vertex3fff(f1, f2, f3) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 var i4 = 0;
 i4 = __Z12GetGfxDevicev() | 0;
 mftCall_vifff(HEAP32[(HEAP32[i4 >> 2] | 0) + 560 >> 2] | 0, i4 | 0, +f1, +f2, +f3);
 return;
}

function __GLOBAL__sub_I_ExtDefaultSimulationFilterShader_cpp() {
 _memset(gb + 1550009 | 0, 1, 1024) | 0;
 HEAP32[gb + 1098832 >> 2] = 0;
 HEAP32[gb + 1098832 + 4 >> 2] = 0;
 HEAP32[gb + 1098832 + 8 >> 2] = 0;
 HEAP32[gb + 1098832 + 12 >> 2] = 0;
 return;
}

function _UNITY_tt_face_done_kern(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i1 + 104 >> 2] | 0, i1 + 740 | 0);
 i1 = i1 + 744 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function _Round_None(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i2 | 0) > -1) {
  i3 = i3 + i2 | 0;
  i3 = (i3 | 0) < 0 ? 0 : i3;
  return i3 | 0;
 } else {
  i3 = i2 - i3 | 0;
  i3 = (i3 | 0) > 0 ? 0 : i3;
  return i3 | 0;
 }
 return 0;
}

function ___p1evll(d4, i1, i2) {
 d4 = +d4;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0;
 d3 = +HEAPF64[i1 >> 3] + d4;
 i2 = i2 + -1 | 0;
 do {
  i1 = i1 + 8 | 0;
  d3 = d3 * d4 + +HEAPF64[i1 >> 3];
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 return +d3;
}

function ___memrchr(i4, i1, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 & 255;
 do {
  if (!i2) {
   i1 = 0;
   break;
  }
  i2 = i2 + -1 | 0;
  i1 = i4 + i2 | 0;
 } while ((HEAP8[i1 >> 0] | 0) != i3 << 24 >> 24);
 return i1 | 0;
}

function __ZNK8Animator18GetControllerInputEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 96 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 488 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK19UnityConnectService11IsAvailableEv(i1) {
 i1 = i1 | 0;
 i1 = __Z20GetPlayerSettingsPtrv() | 0;
 if (!i1) return 0;
 if (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) | 0) return __Z20IsHumanControllingUsv() | 0; else return 0;
 return 0;
}

function __ZNK15GUIEventManager15GetEventAtIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = (HEAP32[i1 + 16 >> 2] | 0) + i2 | 0;
 return (HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (((i2 >>> 0) / 78 | 0) << 2) >> 2] | 0) + (((i2 >>> 0) % 78 | 0) * 52 | 0) | 0;
}

function __ZN9SubModuleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83576 + 8;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) {
  __ZdlPv(i1);
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 + 8 >> 2] | 0, i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN7mecanim9animation31UpdateAvatarMemoryFirstEvalFlagEPNS0_12AvatarMemoryEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = f2 == Math_fround(0.0) & 1;
 i1 = i1 + 136 | 0;
 HEAP8[i1 >> 0] = (HEAPU8[i1 >> 0] | 0) & i3;
 return;
}

function __ZN5physx23NpParticleFluidReadDataD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE12setActorFlagENS_11PxActorFlag4EnumEb(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15NpActorTemplateINS_7PxClothEE20setActorFlagInternalENS_11PxActorFlag4EnumEb(i2, i1, i3);
 return;
}

function __ZN21WorldParticleCollider5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 36 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 40 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 44 >> 2] = -1;
 HEAP8[i1 + 48 >> 0] = 0;
 return;
}

function __ZN19ControllerHitReport10onShapeHitERKN5physx20PxControllerShapeHitE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19ControllerHitReport5onHitERKN5physx15PxControllerHitEP8Collider(i1, i2, HEAP32[(HEAP32[i2 + 60 >> 2] | 0) + 8 >> 2] | 0);
 return;
}

function __ZN18GfxFramebufferGLES8BlitQuadEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 340 | 0;
 __ZN4gles25InitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadENS_24BlitFramebufferAlphaModeENS_35BlitFramebufferColorSpaceConversionE(i1, 1, 0) | 0;
 return i1 | 0;
}

function __ZN15b2ContactSolverD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i2 >> 2] | 0, HEAP32[i1 + 40 >> 2] | 0);
 __ZN16b2StackAllocator4FreeEPv(HEAP32[i2 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0);
 return;
}

function __ZN15TerrainRenderer10FindParentER12QuadTreeNode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN15TerrainRenderer7GetNodeEiii(i1, (HEAP32[i2 + 24 >> 2] | 0) / 2 | 0, (HEAP32[i2 + 28 >> 2] | 0) / 2 | 0, (HEAP32[i2 + 32 >> 2] | 0) + 1 | 0) | 0;
}

function __ZN15FileSystemEntry11MoveToTrashEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN15FileSystemEntry11CreateAsDirEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN13RuntimeStaticI13RendererSceneE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN13RendererSceneD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES19RenderTargetBarrierEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 166 >> 0] | 0)) return;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 167 >> 0] | 0) return;
 mftCall_v(HEAP32[i1 + 4988 >> 2] | 0);
 return;
}

function __ZN13AudioListener15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 171468 | 0, gb + 1105256 | 0, fb + 906 | 0, 0);
 return;
}

function __ZN12AdsIdHandler29InvokeAllDelegateAndListenersEv(i1) {
 i1 = i1 | 0;
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3300 | 0, i1);
 __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher24StartJobRetryWebDispatchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, fb + 3962 | 0, i1 | 0) | 0;
 return;
}

function __ZN10EventEntry10PostInvokeEP12EventManager(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) return;
 __ZN10MemoryPool10DeallocateEPv(i2, i1);
 return;
}

function __Z6simd4iRKi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN13Simd4iFactoryIRKiEC2ES1_(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __Z6simd4fRKf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN13Simd4fFactoryIRKfEC2ES1_(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __Z24RegisterStrippedTypeInfoI21LightProbeProxyVolumeEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30592 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI20UnityConnectSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 189244 | 0, i2, i3);
 return;
}

function __Z14SecondsBetweenRK8DateTimeS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = _i64Subtract(HEAP32[i2 + 4 >> 2] | 0, HEAPU16[i2 >> 1] | 0 | 0, HEAP32[i1 + 4 >> 2] | 0, HEAPU16[i1 >> 1] | 0 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function _UNITY_png_set_interlace_handling(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(HEAP8[i1 + 428 >> 0] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = i1 + 212 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 2;
 i1 = 7;
 return i1 | 0;
}

function _fgetwc(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 if ((HEAP32[i2 + 76 >> 2] | 0) > -1) {
  i3 = (___lockfile(i2) | 0) == 0;
  i1 = ___fgetwc_unlocked(i2) | 0;
  if (!i3) ___unlockfile(i2);
 } else i1 = ___fgetwc_unlocked(i2) | 0;
 return i1 | 0;
}

function __ZZN15DirectorManager15InitializeClassEvEN36FixedUpdateDirectorFixedUpdatestruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 0);
 return;
}

function __ZNK29ParticleSystemPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNK29LineParametersPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNK14RedirectHelper21GetRedirectsRemainingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) return -1; else {
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  return (i2 >>> 0 < i1 >>> 0 ? 0 : i2 - i1 | 0) | 0;
 }
 return 0;
}

function __ZNK12_GLOBAL__N_123DoubleBufferedOutStream11isConnectedEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZN7mecanim9animation17GetClipCurveCountERKNS0_18ClipMuscleConstantE(i1) {
 i1 = i1 | 0;
 i1 = i1 + 1060 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) + (HEAP32[i1 + 36 >> 2] | 0) | 0;
}

function __ZN7Texture13SetFilterModeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 32 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7Texture13SetAnisoLevelEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 36 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j(HEAP32[i1 + 4 >> 2] | 0, i2, 1);
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE13getBufferSizeEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0, i4 = 0;
 i3 = i1 << 2;
 i4 = i1 << 1;
 i1 = i4 + 2048 | 0;
 i2 = i3 + 4 | 0;
 return (i4 + 2 & -4) + i3 + (i1 >>> 0 < i2 >>> 0 ? i2 : i1) | 0;
}

function __ZN5physx2Sn9XmlParser8allocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1 + 28 | 0, i2);
 return;
}

function __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i2 >> 2] & 16384 | 0) return;
 __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1 + 28 | 0, i2);
 return;
}

function __ZN5Unity5Cloth13SetUseGravityEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 45 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 228 >> 2] | 0;
 if (!i1) return;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 2, i2 ^ 1 | 0);
 return;
}

function __ZN18GfxFramebufferGLES25GetPendingFramebufferNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 288 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN18GfxFramebufferGLES25GetCurrentFramebufferNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 168 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN16ReflectionProbes17SetDefaultTextureE4PPtrI7TextureEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 4 >> 2] = f3;
 __ZN16ReflectionProbes16UpdateSampleDataEv(i1);
 return;
}

function __ZN15DirectorManager14ConnectionPool22NumInFlightConnectionsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 44 >> 2] | 0) + ((HEAP32[i1 + 40 >> 2] | 0) + ((HEAP32[i1 + 36 >> 2] | 0) + ((HEAP32[i1 + 32 >> 2] | 0) + (HEAP32[i1 + 28 >> 2] | 0)))) | 0;
}

function __ZN13WheelCollider32RigidbodyMassDistributionChangedEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 148 >> 2] | 0) == -1) return;
 __ZN9Rigidbody22UpdateMassDistributionEv(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
 return;
}

function __ZN13MemoryManager13GetMemcatNameERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if ((i1 | 0) >= 128) {
  i2 = gb + 582059 | 0;
  return i2 | 0;
 }
 i2 = HEAP32[gb + 62648 + (i1 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN12TLSAllocatorI14StackAllocatorE13TryDeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1103852 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN14StackAllocator13TryDeallocateEPv(i1, i2) | 0;
 return i2 | 0;
}

function __ZN11TimeManager13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 + 48 >> 2]);
 HEAPF32[i1 + 60 >> 2] = Math_fround(Math_fround(1.0) / f3);
 HEAPF32[i1 + 52 >> 2] = f3;
 return;
}

function __ZN11ColorModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1 + 8 | 0, i2);
 return;
}

function __ZN11AudioSource24SetBypassListenerEffectsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 425 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) != (i2 & 1 | 0)) HEAP8[i3 >> 0] = i2 & 1;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i1);
 return;
}

function __Z46QualitySettings_Set_Custom_PropMaxQueuedFramesi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, ((i1 | 0) < -1 ? -1 : (i1 | 0) > 10 ? 10 : i1) | 0);
 return;
}

function __Z27setPxVehicleChassisDataMMOIPN5physx20PxVehicleChassisDataENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity11SpringJointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 113868 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN2UI14CanvasRendererEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 187020 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN13TextRendering4FontEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 64868 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI20OcclusionCullingDataEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30992 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI19MeshParticleEmitterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 190748 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI19CharacterControllerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 111552 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI19AudioHighPassFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171240 | 0, i2, i3);
 return;
}

function __Z22SetShaderGlobalTextureN9ShaderLab16FastPropertyNameEP7Texture(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture((HEAP32[gb + 1166248 >> 2] | 0) + 36 | 0, i1, i2);
 return;
}

function _UNITY_png_write_flush(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 if ((HEAP32[i1 + 368 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 352 >> 2] | 0) >>> 0) return;
 _UNITY_png_compress_IDAT(i1, 0, 0, 2);
 HEAP32[i1 + 476 >> 2] = 0;
 _UNITY_png_flush(i1);
 return;
}

function b56(i1, i2, i3, i4, f5, i6, i7, i8, i9, f10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 f10 = Math_fround(f10);
 nullFunc_iiiiifiiiif(56);
 return 0;
}

function _emscripten_glReadPixels__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _emscripten_glReadPixels(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareClassesEPKvS7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) - (HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0) | 0;
}

function __ZZN2UI14CanvasRenderer15InitializeClassEvEN32FunctorImpl_801kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN2UI14CanvasRenderer18OnTransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP8[(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i2 + -8 + 32 >> 2] | 0) | 0) + 51 >> 0] & 1) == 0 | 0;
}

function __ZNK8Material20GetActualRenderQueueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if ((i2 | 0) > -1) return i2 | 0;
 i2 = HEAP32[(HEAP32[(__ZNK8Material9GetShaderEv(i1) | 0) + 32 >> 2] | 0) + 52 >> 2] | 0;
 return i2 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 132 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 136 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 140 >> 2];
 return;
}

function __ZNK5physx2Gu13MeshInterface7IsValidEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return 0;
 if (!(HEAP32[i1 + 4 >> 2] | 0)) return 0;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) return 0; else return (HEAP32[i1 + 12 >> 2] | 0) != 0 | 0;
 return 0;
}

function __ZNK25BlendshapePropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK19SkinnedMeshRenderer19GetBlendShapeWeightEj(HEAP32[i2 + 12 >> 2] | 0, HEAP32[i2 >> 2] | 0));
}

function __ZN8Scalar4faSERKS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return i2 | 0;
}

function __ZN6Object15GetSuperClassIDEi(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[(__ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0) >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 528 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Sc18TriggerInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx24PxMaterialRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return mftCall_iifff(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, 0.0, 0.0, 0.0) | 0;
}

function __ZN5physx21PxShapeRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx21PxClothRepXSerializerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5Umbra10QueryState10getWorkMemERPhRj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1 + 60 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i3 >> 2] = (HEAP32[i1 + 64 >> 2] | 0) - (HEAP32[i4 >> 2] | 0);
 return;
}

function __ZN27ShapeModulePropertyBindings13GetFloatValueERK14ParticleSystemi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var f4 = f0;
 f4 = Math_fround(HEAP32[i2 + 104 >> 2] | 0);
 return Math_fround((i3 | 0) == 0 ? f4 : Math_fround(0.0));
}

function __ZN20QuadTreeNodeRenderer13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1467168 >> 2] | 0;
 if (i1 | 0) __ZN10MemoryPoolD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63696 | 0);
 HEAP32[gb + 1467168 >> 2] = 0;
 return;
}

function __ZN19StreamedBinaryWriteILb1EE20TransferTypelessDataEjPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1 + 16 | 0;
 __ZN12CachedWriter5WriteEPKvj(i4, i3, i2);
 __ZN12CachedWriter11Align4WriteEv(i4);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i1 + 16 | 0;
 __ZN12CachedWriter5WriteEPKvj(i4, i3, i2);
 __ZN12CachedWriter11Align4WriteEv(i4);
 return;
}

function __ZN19CharacterController24SetEnableOverlapRecoveryEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 152 >> 0] = i2 & 1;
 i1 = HEAP32[gb + 1457412 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN17AnimationPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN15PxsCMUpdateTask7releaseEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = i1;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN13RuntimeStaticI12GraphicsCapsE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN12GraphicsCapsD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13RuntimeStaticI12AdsIdHandlerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN12AdsIdHandlerD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN12HingeJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12FixedJoint2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11AudioSource15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 171656 | 0, gb + 1105256 | 0, fb + 907 | 0, 0);
 return;
}

function __Z4loadPKf(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 __ZN13Simd4fFactoryIPKfEC2ES1_(i3, i1);
 STACKTOP = i2;
 return HEAP32[i3 >> 2] | 0;
}

function __Z43setPxVehicleWheelsSimData_WheelCentreOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E(i2, i1, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity10HingeJointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 112544 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity10FixedJointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 112344 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI19SkinnedMeshRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31632 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI19AssetBundleManifestEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28028 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18PlatformEffector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 156664 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18CrashReportManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 188780 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18BuoyancyEffector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 154156 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18AudioMixerSnapshotEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 174940 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18AudioLowPassFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171428 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18AnimatorControllerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 178256 | 0, i2, i3);
 return;
}

function __Z15RegisterMonoRPCPFvPKcE(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i3 = i2;
 HEAP32[i3 >> 2] = 0;
 HEAP32[i3 >> 2] = i1;
 STACKTOP = i2;
 return;
}

function mftCall_fff(i3, d1, d2) {
 i3 = i3 | 0;
 d1 = +d1;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 15 | 0)) return +Math_fround(FUNCTION_TABLE_fff[i3 - fb & 15](Math_fround(d1), Math_fround(d2)));
 return +ftCall_fff(i3 | 0, +d1, +d2);
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 8 + 3 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i1 + 4 >> 2] = i2; else HEAP8[i3 >> 0] = i2;
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 120 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 124 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 128 >> 2];
 return;
}

function __ZNK5physx22PxVehicleWheelsSimData20getWheelShapeMappingEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP8[(i1 & 3) + ((HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 928) >> 0] | 0;
 return (i2 << 24 >> 24 == -1 ? -1 : i2 & 255) | 0;
}

function __ZNK15FileSystemEntry9IsSymLinkEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZL16DrawMeshInternalRK14ChannelAssignsR4MeshRK10Matrix4x4fi13TransformType(i1, i2, i3, i4, 1);
 return;
}

function __ZN7Texture11SetWrapModeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 8) | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 2) | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, 4) | 0;
 return;
}

function __ZN5physx7NpShape23setSimulationFilterDataERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj8ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i2 + 32 | 0, i2 + 48 | 0, i1);
 return;
}

function __ZN5physx5cloth9SwFactoryC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 167292 + 8;
 HEAP32[i1 + 4 >> 2] = gb + 167292 + 88;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN5physx2Sq16BucketPrunerCoreD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN5physx2Sq16BucketPrunerCore7releaseEv(i1);
 i1 = i1 + 544 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i1, i2);
 return;
}

function __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (HEAP8[i1 + 51 >> 0] & 1) __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE(i2, i1);
 HEAP32[i1 + 40 >> 2] = -1;
 return;
}

function __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedERK15TransformAccess(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy(i1, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN15QualitySettings19SetShadowResolutionENS_16ShadowResolutionE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 24 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 3 ? 3 : i2;
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer8TransferI12WheelJoint2DEEvRT_PKc17TransferMetaFlags(i2, i1, HEAP32[gb + 67408 >> 2] | 0, 0);
 return;
}

function __ZN12InputManager23GetEnableIMECompositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 172 >> 2] | 0;
 if (!i2) {
  i2 = (HEAP8[i1 + 168 >> 0] | 0) != 0;
  return i2 | 0;
 } else {
  i2 = (i2 | 0) == 1;
  return i2 | 0;
 }
 return 0;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient6IsDoneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZN10Effector2D12AddToManagerEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0) | 0)) return;
 __ZN16Physics2DManager18AddEffectorUpdatesEP10Effector2D(__Z19GetPhysicsManager2Dv() | 0, i1);
 return;
}

function __Z40AudioSource_Set_Custom_PropRolloffFactorP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884695 | 0, 0, gb + 875076 | 0, 1715, 1, 0, 0, 0);
 return;
}

function __Z31ComputeBuffer_CUSTOM_InitBufferP12Il2CppObjectiij(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 var i5 = 0;
 i5 = __Znwj(28) | 0;
 __ZN13ComputeBufferC2Ejjj(i5, i2, i3, i4);
 HEAP32[i1 + 8 >> 2] = i5;
 return;
}

function __Z27setPxBoxGeometryHalfExtentsPN5physx13PxBoxGeometryENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __Z24RegisterStrippedTypeInfoIN2UI13RectTransformEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28980 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18SpeedTreeWindAssetEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31752 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18ProceduralMaterialEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31152 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI18DelayedCallManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30032 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17SurfaceEffector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 158068 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17PolygonCollider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 157088 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17PhysicsMaterial2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 156288 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17Physics2DSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 156440 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17CapsuleCollider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 154352 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17AudioReverbFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 175128 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17AudioChorusFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 170164 | 0, i2, i3);
 return;
}

function __Z21InitializeHaloManagerv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(12, gb + 63160 | 0, 16, gb + 378047 | 0, 454) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[gb + 1110376 >> 2] = i1;
 return;
}

function mftCall_vidd(i4, i1, d2, d3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 if ((i4 | 0) >= (fb | 0) & (i4 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vidd[i4 - fb & 1](i1 | 0, +d2, +d3);
  return;
 }
 ftCall_vidd(i4 | 0, i1 | 0, +d2, +d3);
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP8[(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i2 + -8 + 32 >> 2] | 0) | 0) + 51 >> 0] & 1) != 0 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return (i1 | 0) == 0 | 0;
}

function __ZNK6Camera23CalculateShadowDistanceEv(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f2 = Math_fround(__ZN15QualitySettings29GetShadowDistanceForRenderingEv());
 f3 = Math_fround(HEAPF32[i1 + 924 >> 2]);
 return Math_fround(f3 < f2 ? f3 : f2);
}

function __ZNK3WWW8IsCachedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  i2 = (HEAP8[i1 + 33 >> 0] | 0) != 0;
  return i2 | 0;
 } else {
  i2 = __ZNK14UnityWebStream8IsCachedEv(i2) | 0;
  return i2 | 0;
 }
 return 0;
}

function __ZNK15FileSystemEntry8IsHiddenEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZNK12IFileAdapter8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function __ZN9LensFlare8SetFlareEP5Flare(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 if ((HEAP32[i2 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i2);
 return;
}

function __ZN9Coroutine26CompareCoroutineEnumeratorEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if ((i2 | 0) == 0 | (i1 | 0) == 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (i1 | 0) == (HEAP32[i2 >> 2] | 0);
 return i2 | 0;
}

function __ZN8PlayableC2EP12Il2CppObject18DirectorPlayerType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = gb + 37536 + 8;
 __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType(i1, 0, i2, i3);
 return;
}

function __ZN7mecanim12statemachine17CreateStateOutputEPKNS0_13StateConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = mftCall_iiii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0, 8, 4) | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 return i2 | 0;
}

function __ZN5physx6PxVec4C2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj(i3, i2) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i3 + 532 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i3 + 540 >> 2] = 0;
 return;
}

function __ZN5physx2Sc16ActorInteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx19NpClothParticleDataD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx18ReducedVertexCloudC2EPKNS_6PxVec3Ej(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = i3;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx17PxStringTableImpl7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN22PerThreadPageAllocator14AcquireNewPageEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = __ZN19AtomicPageAllocator12AllocatePageEj(HEAP32[i1 + 12 >> 2] | 0, i2) | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN19MemoryProfilerStats20RegisterGCAllocationEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 112 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 i1 = i1 + 116 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 return;
}

function __ZN15ConstantForce2D16SetRelativeForceERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 56 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN13RuntimeStaticI12EventManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN10MemoryPoolD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceNull21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return;
}

function __ZN10PngDecoderD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 43108 + 8;
 i2 = i1 + 32 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) {
  __ZdlPv(i1);
  return;
 }
 _UNITY_png_destroy_read_struct(i2, i1 + 36 | 0, 0);
 __ZdlPv(i1);
 return;
}

function __ZN10EventEntry7DestroyEP12EventManager(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 12 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + -1;
 if (HEAP32[i3 >> 2] | 0) return;
 __ZN10MemoryPool10DeallocateEPv(i2, i1);
 return;
}

function __Z58GUIUtility_CUSTOM_INTERNAL_CALL_Internal_GetNextControlID2i9FocusTypeRK5RectTIfE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN8GUIState12GetControlIDEi9FocusTypeRK5RectTIfE(__Z11GetGUIStatev() | 0, i1, i2, i3) | 0;
}

function __Z24RegisterStrippedTypeInfoIN2UI11CanvasGroupEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 186852 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17ProceduralTextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31192 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17GlobalGameManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28760 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI17BillboardRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29752 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16ParticleRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 191192 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16ParticleAnimatorEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 190916 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16CircleCollider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 154548 | 0, i2, i3);
 return;
}

function __Z20Event_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 8 >> 2] | 0;
  if (!i1) i1 = 0; else __ZN10InputEventD2Ev(i1);
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63864 | 0);
 return;
}

function _seekdir(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 16 | 0;
 ___lock(i3 | 0);
 HEAP32[i1 + 4 >> 2] = _lseek(HEAP32[i1 >> 2] | 0, i2, 0) | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 ___unlock(i3 | 0);
 return;
}

function __ZZN9LensFlare15InitializeClassEvEN32FunctorImpl_770kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZZN2UI13RectTransform15InitializeClassEvEN31FunctorImpl_65kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN2UI13RectTransform18OnTransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZN20TextRenderingPrivate8TextMesh15InitializeClassEvEN31FunctorImpl_293kDidAddComponent4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv(i1);
 return;
}

function __ZNSt3__215__thread_struct27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__219__thread_struct_imp27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212564 + 8;
 return;
}

function __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212612 + 8;
 return;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_22PxTriangleMeshGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK26AnimatorControllerPlayable13GetLayerCountEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[HEAP32[i1 + 92 >> 2] >> 2] | 0;
 return i1 | 0;
}

function __ZNK15FileSystemEntry6ExistsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE(i1, i2, i3, 1);
 return;
}

function __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = gb + 37536 + 8;
 __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType(i1, i2, 0, i3);
 return;
}

function __ZN8JSONRead13StartSequenceEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 if ((HEAP32[i1 + 16 >> 2] | 0) != 4) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZN8Animator14SetCullingModeENS_11CullingModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 92 | 0;
 if ((HEAP32[i3 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i3 >> 2] = i2;
 __ZN8Animator20OnCullingModeChangedEv(i1);
 return;
}

function __ZN8Animator13RetargeterJobEPPS_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) return;
 __ZN8Animator12RetargetStepEv(i1);
 return;
}

function __ZN7mecanim12statemachine25DestroyStateMachineOutputEPNS0_18StateMachineOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx9NpFactory13registerClothEv() {
 HEAP32[gb + 1457344 >> 2] = fb + 160;
 HEAP32[gb + 1457388 >> 2] = fb + 2181;
 HEAP32[gb + 1457384 >> 2] = fb + 2182;
 __ZN5physx2Sc7Physics13registerClothEv(HEAP32[gb + 1457332 >> 2] | 0);
 return;
}

function __ZN5physx6shdfnd8TlsAllocEv() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = i1;
 _pthread_key_create(i2 | 0, 0) | 0;
 STACKTOP = i1;
 return HEAP32[i2 >> 2] | 0;
}

function __ZN5physx2Sn18RepXCollectionImpl11setUpVectorERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 144 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 148 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 152 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx2Sn13XmlNodeReader7releaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene15createAggregateEPvb(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZN5physx14PxsAABBManager15createAggregateEPvb(HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i3, i1) | 0;
}

function __ZN5physx2Sc21ArticulationJointCore28setTwistLimitContactDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 144 >> 2] = f1;
 HEAPF32[i2 + 172 >> 2] = Math_fround(+Math_tan(+Math_fround(f1 * Math_fround(.25))));
 return;
}

function __ZN5physx2Sc21ArticulationJointCore28setSwingLimitContactDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 120 >> 2] = f1;
 HEAPF32[i2 + 160 >> 2] = Math_fround(+Math_tan(+Math_fround(f1 * Math_fround(.25))));
 return;
}

function __ZN5physx10NpMaterial17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 48 >> 2] = i2;
 __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i2) | 0;
 return;
}

function __ZN5Light15ResetBakedIndexEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 44 | 0;
 if ((HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0) == -2) return;
 __ZNK5Light16UnshareLightDataEv(i1);
 HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] = -2;
 return;
}

function __ZN5IMGUI14GUIWindowStateC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = -1;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN18ProfilerConnection10InitializeEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 66280 >> 2];
 HEAP32[i1 + 4 >> 2] = -2;
 HEAP32[gb + 1163256 >> 2] = i1;
 __ZN18ProfilerConnection18PrepareConnectionsEv(0);
 return;
}

function __ZN18LoadSceneOperation31CompletePreloadManagerLoadSceneEv(i1) {
 i1 = i1 | 0;
 __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv(i1 + 180 | 0);
 __ZN18LoadSceneOperation21CompleteAwakeSequenceEv(i1);
 __Z16CleanupAfterLoadv();
 return;
}

function __ZN18LoadSceneOperation27GetTransferInstructionFlagsEN19RuntimeSceneManager11LoadingModeE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
 case 1:
 case 2:
 case 4:
  {
   i1 = 268435456;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN15TerrainCollider16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Collider16TransformChangedEi(i1, i2);
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15NavMeshObstacle17OnVelocityChangedEP8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN15FileSystemEntry8IsLockedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN13DrawImmediateD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) __ZN16MeshVertexFormatD2Ev(i2);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13AnimationClip15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 897916 | 0, gb + 908023 | 0, gb + 897939 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 897916 | 0, gb + 908040 | 0, gb + 908057 | 0);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE7hasDataEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 16 >> 0] | 0)) {
  i1 = 0;
  i1 = i1 & 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 8 >> 2] | 0);
 i1 = i1 & 1;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE7hasDataEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 16 >> 0] | 0)) {
  i1 = 0;
  i1 = i1 & 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 12 >> 2] | 0) != (HEAP32[i1 + 8 >> 2] | 0);
 i1 = i1 & 1;
 return i1 | 0;
}

function __ZN11AudioSource20SetBypassReverbZonesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 426 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) != (i2 & 1 | 0)) HEAP8[i3 >> 0] = i2 & 1;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i1);
 return;
}

function __ZN10VertexDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 84 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  HEAP32[i1 >> 2] = 0;
  return;
 }
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63232 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10HttpHelper24IsCommentAllowedInHeaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return (_strcasecmp((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1, gb + 1026939 | 0) | 0) == 0 | 0;
}

function __Z5BlackP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = 0;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 return;
}

function __Z30GUIStyle_CUSTOM_SetDefaultFontP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN8GUIStyle14SetDefaultFontEPN13TextRendering4FontE(i1);
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity9ComponentEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29020 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16SubstanceArchiveEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31872 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16LightmapSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30672 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16LevelGameManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28456 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16GraphicsSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30192 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI16BaseVideoTextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 26532 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15UnityAdsManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 188356 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15TerrainColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 151564 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15RelativeJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 157292 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15PointEffector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 156888 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15ParticleEmitterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 190576 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15NavMeshSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 169816 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15NavMeshObstacleEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 168936 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15FrictionJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 155788 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15DistanceJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 155168 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15ConstantForce2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 154768 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15AudioReverbZoneEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 174088 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15AudioMixerGroupEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 174800 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15AudioEchoFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171052 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15AnchoredJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 152968 | 0, i2, i3);
 return;
}

function __Z22UnregisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE(i1) {
 i1 = i1 | 0;
 if ((HEAP32[gb + 1450796 >> 2] | 0) != (i1 | 0)) return;
 HEAP32[gb + 1450796 >> 2] = 0;
 return;
}

function _UNITY_ft_raccess_rule_by_darwin_vfs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 > 8) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = ((HEAP32[(HEAP32[i1 + 188 >> 2] | 0) + 68 + (i2 << 3) + 4 >> 2] | 0) + -3 | 0) >>> 0 < 2 & 1;
 return i2 | 0;
}

function mftCall_fif(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 31 | 0)) return +Math_fround(FUNCTION_TABLE_fif[i3 - fb & 31](i1 | 0, Math_fround(d2)));
 return +ftCall_fif(i3 | 0, i1 | 0, +d2);
}

function b75(i1, i2, f3, i4, i5, f6, i7, f8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 nullFunc_iiifiififf(75);
 return 0;
}

function b73(i1, i2, i3, f4, i5, f6, i7, f8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 f9 = Math_fround(f9);
 nullFunc_iiiifififf(73);
 return 0;
}

function __ZNSt3__26chrono12system_clock9to_time_tERKNS0_10time_pointIS1_NS0_8durationIxNS_5ratioILx1ELx1000000EEEEEEE(i1) {
 i1 = i1 | 0;
 i1 = ___divdi3(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, 1e6, 0) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212420 + 8;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 11 | 0;
 if ((HEAP8[i3 >> 0] | 0) < 0) HEAP32[i1 + 4 >> 2] = i2; else HEAP8[i3 >> 0] = i2;
 return;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_21PxHeightFieldGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK14VertexDataInfo20GetActiveStreamCountEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 68 >> 2] | 0) != 0 & 1) + (((HEAP32[i1 + 56 >> 2] | 0) != 0 & 1) + (((HEAP32[i1 + 44 >> 2] | 0) != 0 & 1) + ((HEAP32[i1 + 32 >> 2] | 0) != 0 & 1))) | 0;
}

function __ZNK13b2DynamicTree8ValidateEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if ((i1 | 0) == -1) return;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 do i1 = HEAP32[i2 + (i1 * 36 | 0) + 20 >> 2] | 0; while ((i1 | 0) != -1);
 return;
}

function __ZN9Transform8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 __ZN9Transform25CompleteTransformTransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN9LensFlare15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30472 | 0, gb + 1105016 | 0, fb + 494 | 0, 0);
 return;
}

function __ZN8Renderer10AddToSceneER13RendererScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 284 | 0;
 if ((HEAP32[i3 >> 2] | 0) != -1) return;
 HEAP32[i3 >> 2] = __ZN13RendererScene11AddRendererEP8Renderer(i2, i1) | 0;
 return;
}

function __ZN5physx2Sc5Scene20fireCallBacksPreSyncEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene29fireBrokenConstraintCallbacksEv(i1);
 __ZN5physx2Sc5Scene20fireTriggerCallbacksEv(i1);
 __ZN5physx2Sc5Scene26fireQueuedContactCallbacksEb(i1, 0);
 return;
}

function __ZN5physx28PxBoxGeometryGeneratedValuesC2EPKNS_13PxBoxGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5physx10PxsContext9updateCCDEfPNS_10PxBaseTaskEb(i4, f3, i1, i2) {
 i4 = i4 | 0;
 f3 = Math_fround(f3);
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx13PxsCCDContext9updateCCDEfPNS_10PxBaseTaskEb(HEAP32[i4 + 16 >> 2] | 0, f3, i1, i2);
 return;
}

function __ZN26AnimatorOverrideController11ManualDirtyEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0);
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZN19CharacterController13SetSlopeLimitEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 80 >> 2] = f2;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN14SphereCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Collider29GetPositionAndRotationUtilityERK9TransformRK8Vector3fR10Matrix4x4f(i2, i1 + 64 | 0, i3);
 return;
}

function __ZN14DirectorPlayer15SetPrepareStageEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) return;
 if (HEAP8[i1 + 164 >> 0] | 0) return;
 i1 = i1 + 160 | 0;
 if ((HEAP32[i1 >> 2] | 0) == 2) return;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN11TypeManager21CleanupGlobalInstanceEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1110260 >> 2] | 0;
 if (i1 | 0) __ZN11TypeManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63520 | 0);
 HEAP32[gb + 1110260 >> 2] = 0;
 return;
}

function __ZN11CustomArray9GetOffsetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 i2 = 0;
 do {
  i3 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  i2 = (HEAP32[i3 + 8 >> 2] | 0) + i2 | 0;
 } while ((i1 | 0) != 0);
 return i2 | 0;
}

function __Z3RedP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 HEAP8[i2 >> 0] = -1;
 HEAP8[i2 + 1 >> 0] = 0;
 HEAP8[i2 + 2 >> 0] = 0;
 HEAP8[i2 + 3 >> 0] = 0;
 return;
}

function __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[gb + 65256 + (i1 << 2) >> 2] = i2;
 HEAP32[gb + 65144 + (i1 << 2) >> 2] = i3;
 return;
}

function __Z24RegisterStrippedTypeInfoI15ResourceManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31432 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15ReflectionProbeEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31272 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15QualitySettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32192 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15OcclusionPortalEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31032 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15LightProbeGroupEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30552 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15EditorExtensionEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 26492 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI15CapsuleColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 64328 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14SphereColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 113668 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14PhysicsManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 113316 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14PhysicMaterialEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 113108 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14EdgeCollider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 155364 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14AudioBehaviourEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 175648 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14AreaEffector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 153356 | 0, i2, i3);
 return;
}

function __Z22GetUnityConnectServicev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1469104 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv(gb + 1469104 | 0);
 i1 = HEAP32[gb + 1469104 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_png_write_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 176 >> 2] | 0;
 if (!i4) _UNITY_png_error(i1, gb + 354786 | 0); else {
  mftCall_viii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function _UNITY_png_free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 i3 = HEAP32[i1 + 612 >> 2] | 0;
 if (!i3) {
  _free(i2);
  return;
 } else {
  mftCall_vii(i3 | 0, i1 | 0, i2 | 0);
  return;
 }
}

function _gzflush(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = _do_flush(i2, i1) | 0;
 if (i1 | 0) {
  i2 = i1;
  return i2 | 0;
 }
 _fflush(HEAP32[i2 + 64 >> 2] | 0) | 0;
 i2 = HEAP32[i2 + 56 >> 2] | 0;
 i2 = (i2 | 0) == 1 ? 0 : i2;
 return i2 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 76 >> 2];
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return (i1 | 0) == 0 | 0;
}

function __ZNK9allocutil14BuddyAllocator6SizeOfENS_5ChunkE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = (HEAP32[i1 >> 2] | 0) >>> 26;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = 1 << (HEAPU8[i2 + 24 >> 0] | 0) + (i1 + 255 & 255);
 return i2 | 0;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_20PxConvexMeshGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMinCCDAdvanceCoefficientEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 64 | 0) == 0 ? i1 + 140 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 124 | 0) >> 2]);
}

function __ZNK15FileSystemEntry5IsDirEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZNK14DetailDatabase12IsPatchDirtyEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = (Math_imul(HEAP32[i1 + 36 >> 2] | 0, i3) | 0) + i2 | 0;
 return (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + (i3 * 52 | 0) + 24 >> 0] | 0) != 0 | 0;
}

function __ZN7mecanim12statemachine24DestroyConditionConstantEPNS0_17ConditionConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN6Object15ClassIDToStringEi(i1) {
 i1 = i1 | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0;
 if (!i1) {
  i1 = gb + 1576256 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd6Socket5flushEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i1 + 14 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
 return i1 | 0;
}

function __ZN5physx2Sn13XmlNodeReader15gotoNextSiblingEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 i2 = 1;
 return i2 | 0;
}

function __ZN5physx2Sn13XmlNodeReader14gotoFirstChildEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i1 >> 2] = i2;
 i2 = 1;
 return i2 | 0;
}

function __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10NPhaseCore30removeFromDirtyInteractionListEPNS0_15CoreInteractionE(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0, i1);
 return;
}

function __ZN4FMOD13ChannelGroupI14getParentGroupEPPNS_12ChannelGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 i1 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 return 0;
}

function __ZN21UniformBufferTFMethod16BindForRenderingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN7ApiGLES17BindUniformBufferEjj(HEAP32[gb + 1451080 >> 2] | 0, 0, HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN15QualitySettings19SetShadowProjectionE16ShadowProjection(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 1 ? 1 : i2;
 return;
}

function __ZN15FileSystemEntry5TouchEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, i1 | 0) | 0;
 return i2 | 0;
}

function __ZN13GfxDeviceGLES13SetBufferNameEP9GfxBufferPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc(i1 + 4620 | 0, 0, HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 4 >> 2] | 0, 0, i3);
 return;
}

function __ZN12BaseRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData(i2, i3) | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher4StopEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) if ((HEAP32[i1 >> 2] | 0) != 2) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 3;
 i1 = 1;
 return i1 | 0;
}

function __ZL18MonoBehaviourDoGUIPvN13MonoBehaviour13GUILayoutTypeEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function __Z5storePfRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 12 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z36AudioSource_Set_Custom_PropMinVolumeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884529 | 0, 0, gb + 875076 | 0, 1665, 1, 0, 0, 0);
 return;
}

function __Z36AudioSource_Set_Custom_PropMaxVolumeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884612 | 0, 0, gb + 875076 | 0, 1690, 1, 0, 0, 0);
 return;
}

function __Z24RegisterStrippedTypeInfoI14Texture2DArrayEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32072 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14SpriteRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31792 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14RenderSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31352 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14PlayerSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31072 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14ParticleSystemEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 80300 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14DirectorPlayerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30072 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI14BillboardAssetEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29712 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13WheelColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 159176 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13TargetJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 158272 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13SpringJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 157844 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13SliderJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 157632 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13ConstantForceEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 112144 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13BoxCollider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 153776 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13AudioListenerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171468 | 0, i2, i3);
 return;
}

function _UNITY_png_read_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = HEAP32[i1 + 180 >> 2] | 0;
 if (!i4) _UNITY_png_error(i1, gb + 352386 | 0); else {
  mftCall_viii(i4 | 0, i1 | 0, i2 | 0, i3 | 0);
  return;
 }
}

function _UNITY_png_longjmp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i1 | 0) {
  i3 = HEAP32[i1 + 156 >> 2] | 0;
  if (i3 | 0) {
   i1 = HEAP32[i1 + 160 >> 2] | 0;
   if (i1 | 0) mftCall_vii(i3 | 0, i1 | 0, i2 | 0);
  }
 }
 _abort();
}

function _UNITY_FT_Destroy_Class_ft_smooth_lcdv_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _UNITY_ft_smooth_lcdv_renderer_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function _tt_cmap4_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 32 >> 2] = ((HEAPU8[i2 + 6 >> 0] | 0) << 8 | (HEAPU8[i2 + 7 >> 0] | 0)) >>> 1;
 HEAP32[i1 + 24 >> 2] = -1;
 HEAP32[i1 + 28 >> 2] = 0;
 return 0;
}

function _jpeg_quality_scaling(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) < 1 ? 1 : i1;
 i1 = (i1 | 0) > 100 ? 100 : i1;
 if ((i1 | 0) < 50) {
  i1 = 5e3 / (i1 | 0) | 0;
  return i1 | 0;
 } else {
  i1 = 200 - (i1 << 1) | 0;
  return i1 | 0;
 }
 return 0;
}

function _cfsetospeed(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(i2 & -4112)) {
  i1 = i1 + 8 | 0;
  HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -4112 | i2;
  i1 = 0;
 } else {
  HEAP32[(___errno_location() | 0) >> 2] = 22;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZZN20SpeedTreeWindManagerC1EvEN25PreUpdateWindUpdatestruct7ForwardEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1170600 >> 2] | 0;
 __ZN20SpeedTreeWindManager6UpdateEf(i1, Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]));
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEwj(i1, i2, i3) | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEwj(i1, i2, i3) | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj(i1, i2, i3) | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj(i1, i2, i3) | 0;
}

function __ZNK9DebugGLES3LogEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 662 >> 0] | 0)) return;
 mftCall_viiiiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 412 >> 2] | 0, 33354, 33361, 0, 33387, 0, i2 | 0);
 return;
}

function __ZNK8Collider12GetRigidbodyEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0) | 0) + 8 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5Umbra14TomeCollection16getGateStateSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 104 >> 2] | 0) + 31 >> 5 << 2;
 return i1 | 0;
}

function __ZNK21EnlightenSceneMapping14GetSystemAtlasEPK26EnlightenSystemInformation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 80 >> 2] | 0) + (HEAP32[i2 + 8 >> 2] << 5) | 0;
 return i2 | 0;
}

function __ZNK12IFileAdapter4SizeERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 1052 >> 2] | 0;
 i2 = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function __ZNK11OffMeshLink11GetOccupiedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z17GetNavMeshManagerv() | 0;
 i1 = i1 + 40 | 0;
 return __ZNK14NavMeshManager27IsOffMeshConnectionOccupiedEy(i2, HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0) | 0;
}

function __ZN9Behaviour10DeactivateE19DeactivateOperation(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i2 + 33 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0);
 return;
}

function __ZN8Animator24SetHasTransformHierarchyEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 561 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i3 >> 0] = i2 & 1;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZN5physx6shdfnd10ThreadImpl4killEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) {
  HEAP32[i1 >> 2] = 2;
  return;
 }
 _pthread_cancel(HEAP32[i2 + 20 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN5physx2Sc9ClothCore23setExternalAccelerationENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 20 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 24 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx2Sc7BodySim16resetSleepFilterEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 156 >> 2] = 0;
 HEAP32[i1 + 160 >> 2] = 0;
 HEAP32[i1 + 164 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 HEAP32[i1 + 176 >> 2] = 0;
 HEAP32[i1 + 180 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene19initDominanceMatrixEv(i3) {
 i3 = i3 | 0;
 var i1 = 0, i2 = 0;
 i1 = 0;
 i2 = -2;
 while (1) {
  HEAP32[i3 + 1280 + (i1 << 2) >> 2] = ~i2;
  i1 = i1 + 1 | 0;
  if ((i1 | 0) == 32) break; else i2 = i2 << 1;
 }
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene13postIslandGenEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene13ccdBroadPhaseEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN3MBPD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN3MBPD2Ev(i1);
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN17RemapPPtrTransfer11AddMetaFlagE17TransferMetaFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = (HEAP32[i1 + 24 >> 2] | 0) + -4 | 0;
 i2 = HEAP32[i3 >> 2] | i2;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i1 + 36 >> 2] = i2;
 return;
}

function __ZN14RenderSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) return;
 if ((__Z24GetManagerPtrFromContexti(25) | 0) != (i1 | 0)) return;
 __ZN14RenderSettings17UpdateGlobalStateEv(i1);
 return;
}

function __ZN12CachedReaderC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = -1;
 HEAP8[i1 + 32 >> 0] = 0;
 return;
}

function __ZN12BaseRenderer23RendererBecameInvisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 236 | 0;
 i2 = (HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 16773119;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 return;
}

function __Z51RenderSettings_Set_Custom_PropDefaultReflectionModeN14RenderSettings21DefaultReflectionModeE(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings24SetDefaultReflectionModeENS_21DefaultReflectionModeE(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z36CleanupAnimationStateNetworkProviderv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z33GetIAnimationStateNetworkProviderv() | 0, gb + 63400 | 0);
 __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(0);
 return;
}

function __Z26CleanupMemoryProfilerStatsv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163248 >> 2] | 0;
 if (i1 | 0) __ZN19MemoryProfilerStatsD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63576 | 0);
 HEAP32[gb + 1163248 >> 2] = 0;
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity5JointEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 112744 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoIN5Unity5ClothEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 168704 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13WebCamTextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 26112 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13TrailRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32152 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13SparseTextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31712 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13RenderTextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31392 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13OcclusionAreaEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30952 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13MonoBehaviourEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 27592 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13ComputeShaderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29872 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13BuildSettingsEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29792 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI13AnimationClipEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 65780 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12WheelJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 158484 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12NavMeshAgentEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 168976 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12MeshColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 112968 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12FixedJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 155576 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12AudioManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171808 | 0, i2, i3);
 return;
}

function __Z21GetUnityConnectClientv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1469024 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZN13RuntimeStaticI18UnityConnectClientE10InitializeEv(gb + 1469024 | 0);
 i1 = HEAP32[gb + 1469024 >> 2] | 0;
 return i1 | 0;
}

function __Z21GetBackgroundJobQueuev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1104184 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv(gb + 1104184 | 0);
 i1 = HEAP32[gb + 1104184 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_FT_Stream_ReleaseFrame(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 | 0) if (HEAP32[i1 + 20 >> 2] | 0) {
  _UNITY_ft_mem_free(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i2 >> 2] | 0);
  HEAP32[i2 >> 2] = 0;
 }
 HEAP32[i2 >> 2] = 0;
 return;
}

function mftCall_fii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 63 | 0)) return +Math_fround(FUNCTION_TABLE_fii[i3 - fb & 63](i1 | 0, i2 | 0));
 return +ftCall_fii(i3 | 0, i1 | 0, i2 | 0);
}

function ___tre_mem_destroy(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i1 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) do {
  _free(HEAP32[i1 >> 2] | 0);
  i3 = i1;
  i1 = HEAP32[i1 + 4 >> 2] | 0;
  _free(i3);
 } while ((i1 | 0) != 0);
 _free(i2);
 return;
}

function ___sindf(d1) {
 d1 = +d1;
 var d2 = 0.0, d3 = 0.0;
 d2 = d1 * d1;
 d3 = d2 * d1;
 return Math_fround(d3 * (d2 * d2) * (d2 * 2.718311493989822e-06 + -1.9839334836096632e-04) + (d3 * (d2 * .008333329385889463 + -.16666666641626524) + d1));
}

function __ZZN8Animator15InitializeClassEvEN31FunctorImpl_395kDidAddComponent4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Animator14OnAddComponentEPN5Unity9ComponentE(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZNK7Terrain12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i1) return;
 __ZNK14SplatMaterials12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE(i1, i2);
 return;
}

function __ZNK5physx2Sc8BodyCore17getInverseInertiaEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 156 >> 2] | 0;
 if (i1 | 0) if ((HEAP8[i1 + 31 >> 0] | 0) == 1) {
  i2 = i1 + 32 | 0;
  return i2 | 0;
 }
 i2 = i2 + 128 | 0;
 return i2 | 0;
}

function __ZNK24RendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = HEAP32[i3 + 4 >> 2];
 return 21;
}

function __ZNK10GISettings29IsRealtimeEnvironmentLightingEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) if (HEAP8[i1 + 21 >> 0] | 0) return 1;
 i1 = HEAP16[i1 + 20 >> 1] | 0;
 return (i1 & 65535) > 255 & (i1 & 255) << 24 >> 24 == 0 | 0;
}

function __ZN9Rigidbody10SetDensityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) return;
 __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb(i1, f2, 0, 0) | 0;
 return;
}

function __ZN8Scalar4fC2ERKS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 + 12 >> 2];
 return;
}

function __ZN7ApiGLES15ActivateContextEN2gl13ContextHandleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if ((i1 | 0) == (-559030611 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i2 + 1988 >> 2] = i1;
 i2 = 1;
 return i2 | 0;
}

function __ZN5physx6shdfnd10ThreadImplD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2 + 16 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) return;
 if ((HEAP32[i1 >> 2] | 0) == 1) _pthread_cancel(HEAP32[i2 + 20 >> 2] | 0) | 0;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN5physx2Sc18TriggerInteraction16isOneActorActiveEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + 51 >> 0] & 1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[(HEAP32[i1 + 16 >> 2] | 0) + 51 >> 0] & 1) != 0;
 return i1 | 0;
}

function __ZN5physx2Sc11InteractionD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN29AnimationStateNetworkProvider29GetNetworkAnimationStateCountER9Animation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Animation20BuildAnimationStatesEv(i2);
 return (HEAP32[i2 + 108 >> 2] | 0) - (HEAP32[i2 + 104 >> 2] | 0) >> 2 | 0;
}

function __ZN15QualitySettings16SetShadowQualityENS_13ShadowQualityE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] = (i2 | 0) < 0 ? 0 : (i2 | 0) > 2 ? 2 : i2;
 return;
}

function __ZN15FileSystemEntryC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 1040 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function __ZN14UnityAnalytics27OnSceneTimingCallbackStaticEPS_RK15SceneLoadTimingRK8UnityStr(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14UnityAnalytics21OnSceneTimingCallbackERK15SceneLoadTimingRK8UnityStr(i1, i2, i3);
 return;
}

function __ZN11Rigidbody2D16SetDragBehaviourEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i3) return;
 if (HEAP32[i1 + 68 >> 2] | 0) return;
 __ZN6b2Body7SetTypeE10b2BodyType(i3, i2 ? 1 : 2);
 return;
}

function __ZN11AudioSource16SetBypassEffectsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 424 | 0;
 if ((HEAPU8[i3 >> 0] | 0 | 0) != (i2 & 1 | 0)) HEAP8[i3 >> 0] = i2 & 1;
 __ZN11AudioSource19ConfigureFMODGroupsEv(i1);
 return;
}

function __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
 return;
}

function __Z36setPxVehicleDriveSimData_AutoBoxDataPN5physx21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx21PxVehicleDriveSimData14setAutoBoxDataERKNS_20PxVehicleAutoBoxDataE(i2, i1);
 return;
}

function __Z28getPxScene_BroadPhaseRegionsPKN5physx7PxSceneEPNS_22PxBroadPhaseRegionInfoEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 376 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z24RemapClassIDToNewClassIDib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) == 241) i1 = 240; else if ((i1 | 0) == 243) i1 = 273; else if ((i1 | 0) == 245) i1 = 272; else return ((i1 | 0) == 1012 ? 1011 : i1) | 0;
 return i1 | 0;
}

function __Z24RegisterStrippedTypeInfoI12ScriptMapperEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31512 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12MeshRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30912 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12LineRendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30712 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12InputManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30432 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12HingeJoint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 156e3 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI12CubemapArrayEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29952 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11OffMeshLinkEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 169336 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11NavMeshDataEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 169504 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11BoxColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 110912 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11AudioSourceEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 171656 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11AudioFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 170352 | 0, i2, i3);
 return;
}

function __Z12CalculateEtaiid(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 var d4 = 0.0;
 d4 = +__Z19GetTimeSinceStartupv();
 i2 = i2 - i1 | 0;
 d3 = d4 - d3;
 return +(+(((i2 | 0) < 0 ? 0 : i2) | 0) / (+(i1 | 0) / (d3 < .1 ? .1 : d3)));
}

function _UNITY_png_zalloc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) i1 = 0; else if ((4294967295 / (i3 >>> 0) | 0) >>> 0 > i2 >>> 0) i1 = _UNITY_png_malloc_warn(i1, Math_imul(i3, i2) | 0) | 0; else i1 = 0;
 return i1 | 0;
}

function _UNITY_FT_Stream_ExitFrame(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 20 >> 2] | 0) {
  _UNITY_ft_mem_free(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 >> 2] | 0);
  HEAP32[i1 >> 2] = 0;
 }
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function _UNITY_FT_Destroy_Class_ft_smooth_lcd_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _UNITY_ft_smooth_lcd_renderer_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function _emscripten_glVertexAttribPointer__wrapper(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 _emscripten_glVertexAttribPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function ___openlog() {
 var i1 = 0;
 i1 = _socket(1, 524290, 0) | 0;
 do if ((i1 | 0) >= 0) if ((_connect(i1, gb + 350286 | 0, 12) | 0) < 0) {
  _close(i1) | 0;
  break;
 } else {
  HEAP32[gb + 207712 >> 2] = i1;
  break;
 } while (0);
 return;
}

function __ZZN14ParticleSystem15InitializeClassEvEN32FunctorImpl_241kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14ParticleSystem16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZNK5physx2Sc16ArticulationCore17releaseDriveCacheERNS_9PxcFsDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZNK5physx2Sc15ArticulationSim17releaseDriveCacheERNS_9PxcFsDataE(i1, i2);
 return;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_17PxCapsuleGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK2UI6Canvas15GetPixelPerfectEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 361 >> 0] | 0)) i1 = i2; else break;
 }
 return (HEAP8[i1 + 360 >> 0] | 0) != 0 | 0;
}

function __ZNK20LightPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZNK19VREyeTextureManager22GetDeviceTextureFormatEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 16 >> 2] | 0;
 return i2 | 0;
}

function __ZNK14UnityWebStream10IsFinishedEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 20 >> 0] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 if (!(HEAP8[i1 + 19 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 16 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZN9Projector15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 380711 | 0, gb + 383236 | 0, gb + 380780 | 0);
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 380711 | 0, gb + 383253 | 0, gb + 380795 | 0);
 return;
}

function __ZN8Renderer27CheckStaticBatchConsistencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 218 | 0;
 i3 = HEAP32[i1 + 300 >> 2] & 65535;
 i1 = HEAP16[i2 >> 1] | 0;
 HEAP16[i2 >> 1] = (i3 & 65535) < (i1 & 65535) ? i3 : i1;
 return;
}

function __ZN6Object15StringToClassIDEPKc(i1) {
 i1 = i1 | 0;
 i1 = __ZN11TypeManager19ClassNameToTypeInfoEPKcb(HEAP32[gb + 1110260 >> 2] | 0, i1, 0) | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx20PxClothMeshQuadifierC2ERKNS_15PxClothMeshDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = __Znwj(76) | 0;
 __ZN5physx24PxClothMeshQuadifierImplC2ERKNS_15PxClothMeshDescE(i3, i1);
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx16NpParticleSystemD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 97124 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5physx14solve1D4_BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE(i3);
 return;
}

function __ZN4Tree15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 184796 | 0, gb + 1105336 | 0, fb + 954 | 0, 0);
 return;
}

function __ZN2UI6Canvas29UpdateCachedSortingLayerValueEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z13GetTagManagerv() | 0;
 HEAP16[i1 + 420 >> 1] = __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(i2, HEAP32[i1 + 368 >> 2] | 0) | 0;
 return;
}

function __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv(i1) {
 i1 = i1 | 0;
 HEAP32[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) + 12 >> 2] = -1;
 __ZN24GenerateTypeTreeTransfer11EndTransferEv(i1);
 return;
}

function __ZN22MemoryCacherReadBlocksC2EPPhij(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = gb + 67276 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 return;
}

function __ZN20LocalFileSystemWebGL10AtomicMoveER13FileEntryDataS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZN20LocalFileSystemPosix10AtomicMoveER13FileEntryDataS1_(i1, i2, i3) | 0;
 _JS_FileSystem_Sync();
 return i3 | 0;
}

function __ZN15NavMeshObstacle12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager16RegisterObstacleER15NavMeshObstacleRi(__Z17GetNavMeshManagerv() | 0, i1, i1 + 36 | 0);
 i1 = i1 + 136 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 8;
 return;
}

function __ZN15NavMeshObstacle11SetVelocityERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 80 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __ZN15MBP_PairManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN14MessageHandler10InitializeEP11TypeManagerPKN5Unity4TypeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 __ZN14MessageHandler28InitializeMessageIdentifiersEv(i1);
 return;
}

function __ZN14AnimationState24SetWeightTargetImmediateEfb(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 HEAPF32[i1 + 8 >> 2] = f2;
 i1 = i1 + 56 | 0;
 HEAP16[i1 >> 1] = HEAP16[i1 >> 1] & -38 | (i3 & 1) << 2 & 65535;
 return;
}

function __ZN13SubstanceData4InitEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 4;
 return;
}

function __ZN13Simd4fFactoryIN6detail13OffsetPointerIfEEEC2ES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __Z35profiler_set_active_separate_threadb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP32[i2 + 24 >> 2] & 1)) return;
 __ZN13UnityProfiler23SetActiveSeparateThreadEb(i2, i1);
 return;
}

function __Z26ValidateAllocatorIntegrity10MemLabelId(i1) {
 i1 = i1 | 0;
 i1 = __ZN13MemoryManager12GetAllocatorERK10MemLabelId(__Z16GetMemoryManagerv() | 0, i1) | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __Z24RegisterStrippedTypeInfoI11TimeManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31952 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11TerrainDataEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 66968 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11Rigidbody2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 67088 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11PreloadDataEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31112 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11NamedObjectEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28068 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11MonoManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32272 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11LightProbesEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30632 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11GameManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28608 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI11AssetBundleEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 27368 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10SampleClipEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 170496 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10Effector2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 153580 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10AudioMixerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 174128 | 0, i2, i3);
 return;
}

function __Z20setPxJoint_LocalPosePN5physx7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_handle_unknown(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _UNITY_png_crc_finish(i1, i3) | 0;
 if (!(HEAP32[i1 + 372 >> 2] & 536870912)) _UNITY_png_chunk_error(i1, gb + 353028 | 0); else return;
}

function _UNITY_TT_Init_Glyph_Loading(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 512 >> 2] = fb + 190;
 HEAP32[i1 + 520 >> 2] = fb + 2647;
 HEAP32[i1 + 524 >> 2] = fb + 2648;
 HEAP32[i1 + 528 >> 2] = fb + 2649;
 HEAP32[i1 + 516 >> 2] = fb + 3865;
 return;
}

function b6(i1, i2, i4, i5, i6, i7, i8, i9, i10, i11, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 i11 = i11 | 0;
 i3 = i3 | 0;
 nullFunc_viiiiiiiiiii(6);
}

function __ZZN19SkinnedMeshRenderer15InitializeClassEvEN31FunctorImpl_789kBecameInvisible4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn32_NK17BillboardRenderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + -32 + 360 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i1 = i1 & 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 36 >> 2] | 0) != 0;
 i1 = i1 & 1;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEv(i1) | 0;
 if ((i3 | 0) != -1) HEAP32[i2 >> 2] = i3;
 return i1 | 0;
}

function __ZNKSt3__25ctypeIwE5do_isEtw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3 >>> 0 < 128) i1 = (HEAP16[(__ZNSt3__25ctypeIcE13classic_tableEv() | 0) + (i3 << 1) >> 1] & i2) << 16 >> 16 != 0; else i1 = 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5crendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNK7Joint2D10FetchBodyAEv(i1) {
 i1 = i1 | 0;
 i1 = __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 67088 | 0) | 0;
 if (i1 | 0) __ZN11Rigidbody2D6CreateEv(i1);
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK6Camera30GetNonJitteredProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 1119 >> 0] | 0)) {
  i1 = __ZNK6Camera19GetProjectionMatrixEv(i1) | 0;
  return i1 | 0;
 } else {
  i1 = i1 + 1240 | 0;
  return i1 | 0;
 }
 return 0;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_16PxSphereGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMinCCDAdvanceCoefficientEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 64 | 0) == 0 ? i1 + 140 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 124 | 0) >> 2]);
}

function __ZNK18AnimatorController27GetAnimationClipsToRegisterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13dynamic_arrayI4PPtrI13AnimationClipELj4EEC2ERKS3_(i1, mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0) | 0);
 return;
}

function __ZNK17IAnimationBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Cm17FreeListAllocator10directFreeEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 + (0 - (HEAP32[i1 + -4 >> 2] | 0)) | 0);
 return;
}

function __ZN5physx15NpParticleFluidD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 95912 + 8;
 __ZN5physx3Scb14ParticleSystemD2Ev(i1 + 20 | 0);
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN4Halo15InitializeClassEv() {
 __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_(__ZN14MessageHandler3GetEv() | 0, gb + 30352 | 0, gb + 1105016 | 0, fb + 495 | 0, 0);
 return;
}

function __ZN4FMOD7SystemI13set3DSettingsEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 HEAPF32[i1 + 52 >> 2] = f2;
 HEAPF32[i1 + 56 >> 2] = f3;
 HEAPF32[i1 + 60 >> 2] = f4;
 return 0;
}

function __ZN26SharedLightmapSettingsDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 43424 + 8;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 if (i2 | 0) __ZdaPv(i2);
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i1) return;
 __ZdaPv(i1);
 return;
}

function __ZN22CreateGpuProgramOutputD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN20GpuProgramParametersD2Ev(i2);
  __ZdlPv(i2);
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __ZN17GeneralConnection10ConnectionC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 17 >> 0] = 0;
 HEAP8[i1 + 18 >> 0] = 0;
 __ZN20BufferedSocketStreamC2Eijj(i1 + 20 | 0, i2, 8388608, 8388608);
 return;
}

function __ZN17AudioCustomFilter14GetOrCreateDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 __ZN17AudioCustomFilter4InitEv(i1);
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i2);
 return;
}

function __ZN13GfxDeviceGLES20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN31TransformFeedbackSkinPoseBuffer6UpdateEPK10Matrix4x4fi(i2, i3, i4);
 return;
}

function __ZL18ProgramUniform4uivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 340 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL18ProgramUniform3uivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 336 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL18ProgramUniform2uivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 332 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL18ProgramUniform1uivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 328 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __Z57CrashReportHandler_Set_Custom_PropEnableCaptureExceptionsh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(__Z21GetCrashReportManagerv() | 0) + 28 >> 2] | 0;
 if (!i2) return;
 HEAP8[i2 + 1 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z28Resources_CUSTOM_UnloadAssetP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0;
 __ZN9Scripting24UnloadAssetFromScriptingEP6Object(i1);
 return;
}

function __Z27getPxVehicleChassisDataMMOIPKN5physx20PxVehicleChassisDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z24RegisterStrippedTypeInfoIN2UI6CanvasEEviPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 67128 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10TagManagerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31912 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10MonoScriptEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 27480 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10MeshFilterEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30872 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10GameObjectEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28900 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10GUITextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30312 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10GUIElementEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30232 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10FlareLayerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30152 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI10Collider2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32588 | 0, i2, i3);
 return;
}

function _UNITY_FT_Stroker_Rewind(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 HEAP32[i1 + 64 >> 2] = 0;
 HEAP32[i1 + 84 >> 2] = -1;
 HEAP8[i1 + 92 >> 0] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = -1;
 HEAP8[i1 + 124 >> 0] = 0;
 return;
}

function mftCall_iii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 2047 | 0)) return FUNCTION_TABLE_iii[i3 - fb & 2047](i1 | 0, i2 | 0) | 0;
 return ftCall_iii(i3 | 0, i1 | 0, i2 | 0) | 0;
}

function _term_mem_destination(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 HEAP32[HEAP32[i1 + 20 >> 2] >> 2] = HEAP32[i1 + 32 >> 2];
 HEAP32[HEAP32[i1 + 24 >> 2] >> 2] = (HEAP32[i1 + 36 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function _glGetActiveUniform__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _glGetActiveUniform(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function __ZZN12NavMeshAgent15InitializeClassEvEN32FunctorImpl_103kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN12NavMeshAgent18OnTransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN52PostLateUpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z21GetDelayedCallManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 2);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 536 >> 2] = 0;
 __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE(i1, i2 + 12 | 0, i2 + 320 | 0);
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEv(i1) | 0;
 if ((i3 | 0) != -1) HEAP8[i2 >> 0] = i3;
 return i1 | 0;
}

function __ZNSt13runtime_errorC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216304 + 8;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = i2 + -4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 72 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 76 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 80 >> 2];
 return;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_15PxPlaneGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK12AudioManager16GetAudioListenerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 52 | 0;
 if ((HEAP32[i1 + 56 >> 2] | 0) == (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 8 >> 2] | 0;
 return i2 | 0;
}

function __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170680 + 8;
 HEAP32[gb + 1459920 >> 2] = (HEAP32[gb + 1459920 >> 2] | 0) + -1;
 __ZN17WeakPtrSharedDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP8[(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i2 + 32 >> 2] | 0) | 0) + 51 >> 0] & 1) == 0 | 0;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene11postCCDPassEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene11collideStepEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN4FMOD8ChannelI15getChannelGroupEPPNS_12ChannelGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 return 0;
}

function __ZN2UI6Canvas30SendIgnoreNextTransformChangedEv(i1) {
 i1 = i1 | 0;
 __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE(__ZNK10GameObject23QueryComponentTransformEv(HEAP32[i1 + 28 >> 2] | 0) | 0, i1);
 return;
}

function __ZN18PlayableController15SetPrepareStageE13DirectorStage(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP8[i1 + 164 >> 0] | 0) return;
 i1 = i1 + 160 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZL17ProgramUniform4ivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 288 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform4fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 284 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform3ivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 280 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform3fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 276 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform2ivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 272 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform2fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 268 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform1ivPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 264 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __ZL17ProgramUniform1fvPK7ApiGLESjiihPKv(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 mftCall_viiii(HEAP32[i1 + 260 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0, i6 | 0);
 return;
}

function __Z34profiler_end_frame_separate_threadi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 if (!(HEAP32[i2 + 24 >> 2] & 1)) return;
 __ZN13UnityProfiler22EndFrameSeparateThreadEj(i2, i1);
 return;
}

function __Z31ReadObjectFromPersistentManageri(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) < 1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode(__Z20GetPersistentManagerv() | 0, i1, -1) | 0;
 return i1 | 0;
}

function __Z24ReleaseBufferManagerGLESv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451092 >> 2] | 0;
 if (i1 | 0) __ZN17BufferManagerGLESD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63304 | 0);
 HEAP32[gb + 1451092 >> 2] = 0;
 return;
}

function __Z24RegisterStrippedTypeInfoI9AudioClipEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 170640 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9AnimationEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 176192 | 0, i2, i3);
 return;
}

function __Z22RectOffset_CUSTOM_InitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(16) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z21setPxClothParticlePosPN5physx15PxClothParticleENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function _bitshift64Shl(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  setTempRet0(i2 << i1 | (i3 & (1 << i1) - 1 << 32 - i1) >>> 32 - i1 | 0);
  return i3 << i1;
 }
 setTempRet0(i3 << i1 - 32 | 0);
 return 0;
}

function ___expo2f(f1) {
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(Math_fround(+Math_exp(+Math_fround(f1 + Math_fround(-162.889587)))) * Math_fround(1661534989999999921690316.0e11)) * Math_fround(1661534989999999921690316.0e11));
}

function __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_788kBecameVisible4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNK9dtNavMesh25getFirstOffMeshConnectionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 48 >> 2] | 0) + (i2 * 104 | 0) | 0;
 return i2 | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5Umbra18ReceiverMaskBuffer8getDepthEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return Math_fround(Math_fround(HEAPU16[((i1 | 0) == 0 ? 0 : i1 + 1 & -2) + ((i3 << 7) + i2 << 1) >> 1] | 0) / Math_fround(65535.0));
}

function __ZNK3MBP12getBoxPrunerEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 <= i1 >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + (i1 * 40 | 0) + 28 >> 2] | 0;
 return i2 | 0;
}

function __ZNK24RingBufferMemoryFileData4SizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 i1 = _i64Add(HEAP32[i1 + 48 >> 2] | 0, 0, HEAP32[i2 >> 2] | 0, HEAP32[i2 + 4 >> 2] | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __ZNK22GenericPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(+mftCall_fi(HEAP32[i1 + 68 + (HEAP32[i2 >> 2] << 2) >> 2] | 0, HEAP32[i2 + 12 >> 2] | 0));
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10GetPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv(HEAP32[i1 + 36 >> 2] | 0, i2) | 0;
}

function __ZNK17IAnimationBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN9GfxDevice14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN13DrawImmediate5BeginE16GfxPrimitiveTypePK14ChannelAssigns(HEAP32[i1 + 4408 >> 2] | 0, i2, i3);
 return;
}

function __ZN8Collider8ReCreateEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 36 >> 2] | 0)) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN5physx3Cct10Controller9onReleaseEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx3Cct9SweepTest9onReleaseERKNS_6PxBaseE(i4 + 88 | 0, i3);
 return;
}

function __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = i1;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = i2;
 return;
}

function __ZN5physx10NpMaterialD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 93280 + 8;
 HEAP32[i1 + 12 >> 2] = gb + 93280 + 108;
 __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZN5Unity5Cloth21SetWorldVelocityScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = i1 + 76 | 0;
 if (!(Math_fround(HEAPF32[i3 >> 2]) != f2)) return;
 HEAP8[i1 + 357 >> 0] = 1;
 HEAPF32[i3 >> 2] = f2;
 return;
}

function __ZN4FMOD7SystemI19getRecordDriverCapsEiPjPiS2_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i4 | 0) HEAP32[i4 >> 2] = 44100;
 if (!i5) return 0;
 HEAP32[i5 >> 2] = 48e3;
 return 0;
}

function __ZN21UnityAnalyticsManagerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188476 + 8;
 __ZN21UnityAnalyticsManager15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15FrictionJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15DistanceJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15ConstantForce2D8SetForceERK8Vector2f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1 + 48 | 0;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN15AnchoredJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14AvatarPlayback9NextIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 16 >> 2] | 0;
 i1 = i2 + 1 | 0;
 if ((i3 | 0) <= 0) {
  i3 = i1;
  return i3 | 0;
 }
 i3 = (i1 | 0) % (i3 | 0) | 0;
 return i3 | 0;
}

function __ZN12TLSAllocatorI14StackAllocatorE16FrameMaintenanceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1103852 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN12NavMeshAgent21RemoveFromCrowdSystemEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN7dtCrowd11removeAgentER13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0);
 return;
}

function __Z9FTReallocP13FT_MemoryRec_llPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i4, i3, 16, gb + 63392 | 0, 0, gb + 946903 | 0, 20) | 0;
}

function __Z57CrashReportHandler_Get_Custom_PropEnableCaptureExceptionsv() {
 var i1 = 0;
 i1 = HEAP32[(__Z21GetCrashReportManagerv() | 0) + 28 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP8[i1 + 1 >> 0] | 0;
 return i1 | 0;
}

function __Z52Screen_Set_Custom_PropAutorotateToPortraitUpsideDownh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 2, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z46Input_CUSTOM_INTERNAL_set_compositionCursorPosRK13Vector2fIcall(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z15GetInputManagerv() | 0;
 HEAP32[i2 + 160 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 164 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __Z44setPxVehicleWheelsDynData_WheelRotationSpeedPN5physx22PxVehicleWheelsDynDataEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf(i2, i1, f3);
 return;
}

function __Z44setPxVehicleWheelsDynData_WheelRotationAnglePN5physx22PxVehicleWheelsDynDataEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx22PxVehicleWheelsDynData21setWheelRotationAngleEjf(i2, i1, f3);
 return;
}

function __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 HEAP32[i1 >> 2] = __ZN9Scripting19ScriptingWrapperForEP6Object(i2) | 0;
 return;
}

function __Z35setPxVehicleDriveSimData_EngineDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx21PxVehicleDriveSimData13setEngineDataERKNS_19PxVehicleEngineDataE(i2, i1);
 return;
}

function __Z35setPxVehicleDriveSimData_ClutchDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx21PxVehicleDriveSimData13setClutchDataERKNS_19PxVehicleClutchDataE(i2, i1);
 return;
}

function __Z27getPxRigidActor_ConstraintsPKN5physx12PxRigidActorEPPNS_12PxConstraintEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z27getPxBoxGeometryHalfExtentsPKN5physx13PxBoxGeometryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 8 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 12 >> 2];
 return;
}

function __Z24RegisterStrippedTypeInfoI9TransformEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 28940 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9Texture3DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32112 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9Texture2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32032 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9TextAssetEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31992 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9RigidbodyEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 67048 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9ProjectorEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31232 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9LensFlareEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30472 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9HaloLayerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30392 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9CGProgramEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29992 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI9BehaviourEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29672 | 0, i2, i3);
 return;
}

function __Z24ConvertSeparatorsToUnityPc(i1) {
 i1 = i1 | 0;
 L1 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 0:
   break L1;
  case 92:
   {
    HEAP8[i1 >> 0] = 47;
    break;
   }
  default:
   {}
  }
  i1 = i1 + 1 | 0;
 }
 return;
}

function __Z23getPxArticulation_LinksPKN5physx14PxArticulationEPPNS_18PxArticulationLinkEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function mftCall_vif(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 1023 | 0)) {
  FUNCTION_TABLE_vif[i3 - fb & 1023](i1 | 0, Math_fround(d2));
  return;
 }
 ftCall_vif(i3 | 0, i1 | 0, +d2);
}

function _glGetActiveAttrib__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _glGetActiveAttrib(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function _gets(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _fgets(i1, 2147483647, HEAP32[gb + 191748 >> 2] | 0) | 0;
 if (i2 | 0) {
  i1 = i1 + ((_strlen(i1) | 0) + -1) | 0;
  if ((HEAP8[i1 >> 0] | 0) == 10) HEAP8[i1 >> 0] = 0;
 }
 return i2 | 0;
}

function _emscripten_glDrawRangeElements__wrapper(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 _emscripten_glDrawRangeElements(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function __ZThn28_N14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj(i1 + -28 | 0, i2, i3);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + (HEAP32[i3 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + (HEAP32[i3 + -12 >> 2] | 0) >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function __ZNSt11logic_errorC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 216284 + 8;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 i2 = i2 + -4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6lengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5crendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_13PxBoxGeometryE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZNK13b2DynamicTree9GetHeightEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if ((i2 | 0) == -1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + (i2 * 36 | 0) + 32 >> 2] | 0;
 return i2 | 0;
}

function __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] = i3;
 return;
}

function __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] = i3;
 return;
}

function __ZN8VRDevice19GetSupportedDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(i1) {
 i1 = i1 | 0;
 __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE(HEAP32[gb + 1469188 >> 2] | 0, i1);
 return;
}

function __ZN7mecanim9animation25DestroyStreamedClipMemoryERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 175480 + 8;
 HEAP32[gb + 1460028 >> 2] = (HEAP32[gb + 1460028 >> 2] | 0) + -1;
 __ZN17WeakPtrSharedDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx42PxVehicleDifferentialNWDataGeneratedValuesC2EPKNS_27PxVehicleDifferentialNWDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = __ZNK5physx27PxVehicleDifferentialNWData20getDrivenWheelStatusEv(i1) | 0;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP8[(__ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(HEAP32[i2 + 32 >> 2] | 0) | 0) + 51 >> 0] & 1) != 0 | 0;
}

function __ZN5physx22PxVehicleWheelsSimData15setSubStepCountEfjj(i3, f4, i2, i1) {
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAPF32[i3 + 48 >> 2] = f4;
 HEAP32[i3 + 52 >> 2] = i2;
 HEAP32[i3 + 56 >> 2] = i1;
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN4NodeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (i2 | 0) {
  __ZN4NodeD2Ev(i2);
  __ZdlPv(i2);
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return; else {
  __ZN4NodeD2Ev(i1);
  __ZdlPv(i1);
  return;
 }
}

function __ZN11ClothModule23SetClothingSceneGravityERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1459016 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z40AudioSource_Get_Custom_PropRolloffFactorP12Il2CppObject(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884695 | 0, 0, gb + 875076 | 0, 1702, 1, 0, 0, 0);
 return Math_fround(0.0);
}

function __Z33setPxArticulationJoint_TwistLimitPN5physx19PxArticulationJointEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 136 >> 2] | 0, i3 | 0, +f1, +f2);
 return;
}

function __Z25SetNbModifiedContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i3 + 480 + (i1 * 28 | 0) + (i2 << 2) >> 2] = i4;
 return;
}

function __Z24RegisterStrippedTypeInfoI8WindZoneEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32232 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8RendererEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31312 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8MaterialEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30792 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8LODGroupEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30752 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8GUILayerEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30272 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8ColliderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32548 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI8AnimatorEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 67008 | 0, i2, i3);
 return;
}

function __Z19setPxD6Joint_MotionPN5physx9PxD6JointENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 120 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function mftCall_iif(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 7 | 0)) return FUNCTION_TABLE_iif[i3 - fb & 7](i1 | 0, Math_fround(d2)) | 0;
 return ftCall_iif(i3 | 0, i1 | 0, +d2) | 0;
}

function _iswalpha(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 < 131072) i1 = (HEAPU8[((HEAPU8[(i1 >>> 8) + (gb + 1060117) >> 0] | 0) << 5 | i1 >>> 3 & 31) + (gb + 1060117) >> 0] | 0) >>> (i1 & 7) & 1; else i1 = i1 >>> 0 < 196606 & 1;
 return i1 | 0;
}

function __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_243kDidDeleteMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11ShapeModule13DidDeleteMeshEP14ParticleSystem(i1 + 48 | 0, i1);
 return;
}

function __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDsc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476368 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDic11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476376 | 0) | 0);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNK5physx9NpPhysics15getClothFabricsEPPNS_13PxClothFabricEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx9NpFactory15getClothFabricsEPPNS_13PxClothFabricEj(HEAP32[gb + 1457204 >> 2] | 0, i3, i1) | 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK3WWW24GetEstimatedDownloadSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK14UnityWebStream24GetEstimatedDownloadSizeEv(i1) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZNK17ProceduralTexture20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return __Z21CalculateMipMapOffsetii13TextureFormati(HEAP32[i1 + 88 >> 2] | 0, HEAP32[i1 + 92 >> 2] | 0, HEAP32[i1 + 100 >> 2] | 0, HEAP32[i1 + 96 >> 2] | 0) | 0;
}

function __ZNK13b2PulleyJoint16GetGroundAnchorBEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 76 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK13b2PulleyJoint16GetGroundAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 68 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK13GfxDeviceGLES21GetDefaultHDRRTFormatEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 235 >> 0] | 0) {
  i1 = 2;
  return i1 | 0;
 }
 i1 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0;
 return i1 | 0;
}

function __ZN8Animator8WriteJobEPPS_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) return;
 __ZN8Animator9WriteStepEv(i1);
 return;
}

function __ZN7mecanim9animation22DestroyClipMuscleInputEPNS0_15ClipMuscleInputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7ApiGLES13DeleteSamplerERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (HEAP32[i2 >> 2] | 0) {
 case -1:
 case 0:
  return;
 default:
  {}
 }
 mftCall_vii(HEAP32[i1 + 828 >> 2] | 0, 1, i2 | 0);
 HEAP32[i2 >> 2] = -1;
 return;
}

function __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EppEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
 i2 = i1 + 20 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 16;
 return i1 | 0;
}

function __ZN5physx2Sc5Scene23removeArticulationJointERNS0_21ArticulationJointCoreE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15TextureTFMethod13DoneRenderingEv(i1) {
 i1 = i1 | 0;
 __ZN7ApiGLES11BindTextureEj16TextureDimension(HEAP32[gb + 1451080 >> 2] | 0, 0, 2);
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = ((HEAP32[i1 >> 2] | 0) + 1 | 0) % 3 | 0;
 return;
}

function __ZN15MonoScriptCacheD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14RenderSettings13CalcFogFactorEff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(1.0) - Math_fround(+Math_exp(+Math_fround(-Math_fround(Math_fround(Math_fround(f1 * f1) * f2) * f2)))));
}

function __ZN14BillboardAssetD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13TriggerModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAPF32[i1 + 24 >> 2] = Math_fround(1.0);
 return;
}

function __ZN13ModuleManager3GetEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1162952 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 __ZN13RuntimeStaticI13ModuleManagerE10InitializeEv(gb + 1162952 | 0);
 i1 = HEAP32[gb + 1162952 >> 2] | 0;
 return i1 | 0;
}

function __ZN13GfxDeviceGLES17AfterPluginRenderEv(i1) {
 i1 = i1 | 0;
 __Z14CheckErrorGLESPK7ApiGLESPKcS3_l(i1 + 4620 | 0, gb + 604335 | 0, gb + 603515 | 0, 304) | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN13GfxDeviceGLES16DeleteTimerQueryEP13GfxTimerQuery(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 84496 + 8;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12ImageDecoder11SetReadFuncEPvPFjS0_PhjE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i3;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZN11TerrainData21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 __ZN13SplatDatabase18RecalculateBasemapEb(i1 + 32 | 0, 1);
 i1 = i1 + 128 | 0;
 HEAP8[i1 >> 0] = 1;
 __ZN14DetailDatabase28GenerateTextureAtlasThreadedEv(i1);
 return;
}

function __ZN10GUIManager16ResetCursorFlashEi(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
 HEAPF32[(HEAP32[gb + 1468156 >> 2] | 0) + 40 + (i1 << 2) >> 2] = f2;
 return;
}

function __Z33setPxArticulationJoint_SwingLimitPN5physx19PxArticulationJointEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 96 >> 2] | 0, i3 | 0, +f1, +f2);
 return;
}

function __Z25SetNbDiscreteContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i3 + 88 + (i1 * 28 | 0) + (i2 << 2) >> 2] = i4;
 return;
}

function __Z24RegisterStrippedTypeInfoI7TextureEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 26572 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI7TerrainEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 35740 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI7Joint2DEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 32628 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI7CubemapEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29912 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI6MotionEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 176524 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI6AvatarEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 178860 | 0, i2, i3);
 return;
}

function __Z18setPxD6Joint_DrivePN5physx9PxD6JointENS_9PxD6Drive4EnumENS_14PxD6JointDriveE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 164 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_set_gAMA_fixed(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 _UNITY_png_colorspace_set_gamma(i1, i2 + 40 | 0, i3);
 _UNITY_png_colorspace_sync_info(i1, i2);
 return;
}

function _UNITY_FT_Init_Class_cff_service_ps_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 1086;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = fb + 2642;
 HEAP32[i2 + 12 >> 2] = 0;
 HEAP32[i2 + 16 >> 2] = 0;
 return;
}

function _UNITY_FT_Destroy_Class_ft_raster1_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _UNITY_ft_raster1_renderer_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function _LzmaDec_Init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 1;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 80 >> 2] = 1;
 return;
}

function __ZZN16AnimationManager15InitializeClassEvEN43FixedUpdateLegacyFixedAnimationUpdatestruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN16AnimationManager6UpdateEv(HEAP32[gb + 1465160 >> 2] | 0);
 return;
}

function __ZZN11Rigidbody2D15InitializeClassEvEN32FunctorImpl_198kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11Rigidbody2D16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 536 >> 2] = 0;
 __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE(i1, i2 + 12 | 0, i2 + 284 | 0);
 return;
}

function __ZThn12_N5physx7NpShape14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + -12 | 0;
 __ZN5physx9NpFactory14onShapeReleaseEPNS_7PxShapeE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx9NpDestroyERNS_3Scb4BaseE(i1 + 32 | 0);
 return;
}

function __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209952 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 209952 + 56;
 return;
}

function __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209868 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 209868 + 56;
 return;
}

function __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIwc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476360 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIcc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476352 | 0) | 0);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setgEPwS4_S4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i1 + 16 >> 2] = i4;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setgEPcS4_S4_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i1 + 16 >> 2] = i4;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 8 + 3 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return i1 | 0;
}

function __ZNK8VRDevice27GetOverrideApplicationPauseEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 232 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx3Cct17CapsuleController21getHalfHeightInternalEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 + 496 >> 2]);
 return Math_fround(f2 + Math_fround(Math_fround(HEAPF32[i1 + 500 >> 2]) * Math_fround(.5)));
}

function __ZNK5physx3Cct17CapsuleController14getUpDirectionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 44 >> 2];
 return;
}

function __ZNK5physx2Sn18RepXCollectionImpl11getUpVectorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 144 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 148 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 152 >> 2];
 return;
}

function __ZNK16DeveloperConsole9IsVisibleEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 24 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZN9Scripting32SetScriptingArrayTypeElementImplEP11Il2CppArrayiP12Il2CppObject(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] = i3;
 return;
}

function __ZN8Animator15GetPlaybackTimeEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if ((HEAP32[i1 + 548 >> 2] | 0) != 1) {
  f2 = Math_fround(-1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 556 >> 2]);
 return Math_fround(f2);
}

function __ZN7mecanim4hand14MuscleFromBoneEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[gb + 179556 + (((i1 | 0) % 3 | 0) * 12 | 0) + (2 - i2 << 2) >> 2] | 0;
 return ((i2 | 0) == -1 ? -1 : i2 + (((i1 | 0) / 3 | 0) << 2) | 0) | 0;
}

function __ZN6Object20NamespaceFromClassIDEi(i1) {
 i1 = i1 | 0;
 i1 = __ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 return i1 | 0;
}

function __ZN6Camera17RemoveImageFilterERK11ImageFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12ImageFilters17RemoveImageFilterERK11ImageFilter(__Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i1 + 1124 >> 2] | 0) | 0, i2);
 return;
}

function __ZN5physx6shdfnd10SocketImplC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 110688 + 8;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP16[i1 + 12 >> 1] = 0;
 HEAP8[i1 + 14 >> 0] = 0;
 HEAP8[i1 + 15 >> 0] = 1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore16setInternalFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 72 | 0;
 HEAP32[i2 >> 2] = HEAPU16[i1 >> 1] | 0 | HEAP32[i2 >> 2] & -65536;
 return;
}

function __ZN5physx2Sc15ClothFabricCoreC2ERKNS_7PxEMPTYE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 if (!(HEAP32[i2 + 8 >> 2] | 0)) return;
 i2 = i2 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | -2147483648;
 return;
}

function __ZN5physx28PxArticulationRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0) | 0;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN2gl20IsFormatDepthStencilENS_9TexFormatE(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i1) | 0) + 12 >> 2] & 24 | 0) == 24 | 0;
}

function __ZN26b2PolygonAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN21UniformBufferTFMethodD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 77396 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __ZN14DataBufferGLES7ReleaseEv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN13SplatDatabase29SetMaterialRequiresSmoothnessEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 49 | 0;
 if ((i2 & 1 | 0) != (HEAPU8[i3 >> 0] | 0 | 0)) HEAP8[i1 + 50 >> 0] = 1;
 HEAP8[i3 >> 0] = i2 & 1;
 return;
}

function __ZN13GfxDeviceNull17DestroyGpuProgramEPK10GpuProgram(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClientD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 148084 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN12HingeJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12FixedJoint2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 153008 + 8;
 __ZN7Joint2D15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12BaseRenderer21RendererBecameVisibleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 236 | 0;
 i2 = HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16 | 4096;
 HEAP16[i1 >> 1] = i2;
 HEAP8[i1 + 2 >> 0] = i2 >>> 16;
 return;
}

function __Z38scripting_class_get_system_type_objectP11Il2CppClass(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = _il2cpp_class_get_type(i1 | 0) | 0;
  if (!i1) i1 = 0; else i1 = _il2cpp_type_get_object(i1 | 0) | 0;
 }
 return i1 | 0;
}

function __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = _il2cpp_object_get_virtual_method(i2 | 0, HEAP32[i3 >> 2] | 0) | 0;
 return;
}

function __Z27getPxPhysics_TriangleMeshesPKN5physx9PxPhysicsEPPNS_14PxTriangleMeshEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z24getPxCloth_StretchConfigPKN5physx7PxClothENS_22PxClothFabricPhaseType4EnumE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 264 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 return;
}

function __Z24RegisterStrippedTypeInfoI6SpriteEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31832 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI6SkyboxEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31672 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI6ShaderEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 31552 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI6CameraEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 29832 | 0, i2, i3);
 return;
}

function __Z23getPxClothFabric_PhasesPKN5physx13PxClothFabricEPNS_18PxClothFabricPhaseEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z21setPxSceneDescGravityPN5physx11PxSceneDescENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __Z18TestAABBVisibilityPKN5Umbra15OcclusionBufferE8Vector3fS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (__ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf(i1, i2, i3, 0, 0) | 0) != 0 | 0;
}

function __Z18SetProjectionPlanePN5physx14PxParticleBaseENS_15PxMetaDataPlaneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viif(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, i2 | 0, +Math_fround(HEAPF32[i2 + 12 >> 2]));
 return;
}

function __Z17ComputeIdentifierPK8sockaddr(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __Z7CRCDonej(__Z7CRCFeedjPKhj(__Z7CRCFeedjPKhj(__Z8CRCBeginv() | 0, i1 + 4 | 0, 4) | 0, i1 + 2 | 0, 2) | 0) | 0;
 return i1 | 0;
}

function _UNITY_png_write_chunk_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0 & (i3 | 0) != 0)) return;
 _UNITY_png_write_data(i1, i2, i3);
 _UNITY_png_calculate_crc(i1, i2, i3);
 return;
}

function mftCall_vii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 8191 | 0)) {
  FUNCTION_TABLE_vii[i3 - fb & 8191](i1 | 0, i2 | 0);
  return;
 }
 ftCall_vii(i3 | 0, i1 | 0, i2 | 0);
}

function mftCall_vff(i3, d1, d2) {
 i3 = i3 | 0;
 d1 = +d1;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 7 | 0)) {
  FUNCTION_TABLE_vff[i3 - fb & 7](Math_fround(d1), Math_fround(d2));
  return;
 }
 ftCall_vff(i3 | 0, +d1, +d2);
}

function b50(i1, i2, f3, i4, f5, i6, f7, f8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 i9 = i9 | 0;
 nullFunc_viifififfi(50);
}

function _wcscpy(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0, i4 = 0;
 i2 = i3;
 while (1) {
  i4 = HEAP32[i1 >> 2] | 0;
  HEAP32[i2 >> 2] = i4;
  if (!i4) break; else {
   i2 = i2 + 4 | 0;
   i1 = i1 + 4 | 0;
  }
 }
 return i3 | 0;
}

function _strlcat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _strnlen(i1, i3) | 0;
 if ((i4 | 0) == (i3 | 0)) i1 = _strlen(i2) | 0; else i1 = _strlcpy(i1 + i4 | 0, i2, i3 - i4 | 0) | 0;
 return i1 + i4 | 0;
}

function _inet_lnaof(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) > -1) i1 = i1 & 16777215; else if (i1 >>> 0 < 3221225472) {
  i1 = i1 & 65535;
  break;
 } else {
  i1 = i1 & 255;
  break;
 } while (0);
 return i1 | 0;
}

function _compare_offsets(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0;
 i2 = HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0;
 return (i1 >>> 0 > i2 >>> 0 ? 1 : (i1 >>> 0 < i2 >>> 0) << 31 >> 31) | 0;
}

function __ZZN14PhysicsManager15InitializeClassEvEN35FixedUpdatePhysicsFixedUpdatestruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN14PhysicsManager11FixedUpdateEv(__Z21GetManagerFromContexti(9) | 0);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6lengthEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return i1 | 0;
}

function __ZNK8VRDevice27GetOverrideStereoSeparationEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 169 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx2Sn21SerializationRegistry17getSerializerNameEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + (i1 << 3) + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 16 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 20 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 24 >> 2];
 return;
}

function __ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) >>> 0 < (HEAP32[i2 + 88 + ((HEAPU8[i1 + 20 >> 0] | 0) << 2) >> 2] | 0) >>> 0 | 0;
}

function __ZNK14dtPathCorridor11isPathStaleEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 48 >> 2] | 0;
 if (!i2) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (i2 | 0) != (HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + 56 >> 2] | 0);
 return i2 | 0;
}

function __ZNK10FileSystem21GetAvailableDiskSpaceEPKcRy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZN9Scripting28RaiseObjectDisposedExceptionEPKcS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_raise_exception(_il2cpp_exception_from_name_msg(_il2cpp_get_corlib() | 0, gb + 465948 | 0, gb + 465980 | 0, i2 | 0) | 0);
 return;
}

function __ZN8Animator15SetPrepareStageEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i2) return;
 __ZN18PlayableController15SetPrepareStageE13DirectorStage(i2, (HEAP32[i1 + 96 >> 2] | 0) == 1 ? 0 : 3);
 return;
}

function __ZN7mecanim9animation21DestroyBlendTreeInputEPNS0_14BlendTreeInputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx7CookingD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1);
 STACKTOP = i2;
 return;
}

function __ZN5physx6shdfnd9Allocator10deallocateEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 540 >> 2] = 0;
 __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE(i1, i2 + 16 | 0, i2 + 324 | 0);
 return;
}

function __ZN5physx2Sc5Scene23setCreateContactReportsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0;
 if (!i1) return;
 __ZN5physx10PxsContext22setCreateContactStreamEb(i1, i2);
 return;
}

function __ZN5physx2Sc5Scene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[(HEAP32[i3 + 1152 >> 2] | 0) + ((i2 & 255) << 2) >> 2] | 0) + 20 >> 2] = i1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = __ZN5physx15PxsParticleData6createERNS_24PxDeserializationContextE(i1) | 0;
 return;
}

function __ZN5physx2Sc15CoreInteraction14addToDirtyListEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10NPhaseCore25addToDirtyInteractionListEPNS0_15CoreInteractionE(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0, i1);
 return;
}

function __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b(i1, i1 + 4 | 0, 0, 0, 0) | 0;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN25b2PolygonAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN25b2CapsuleAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0)) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0)) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16Physics2DManager26DestroyRigidbodyCollisionsEP11Rigidbody2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19CollisionListener2D26DestroyRigidbodyCollisionsEP11Rigidbody2D((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2);
 return;
}

function __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_ScaleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 84496 + 8;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __Z48Screen_Set_Custom_PropAutorotateToLandscapeRighth(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 8, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z42VRDevice_CUSTOM_INTERNAL_CALL_GetNativePtrRPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) i2 = 0; else i2 = __ZNK8VRDevice12GetNativePtrEv(__Z12GetIVRDevicev() | 0) | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z34setPxVehicleDriveSimData_GearsDataPN5physx21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx21PxVehicleDriveSimData12setGearsDataERKNS_18PxVehicleGearsDataE(i2, i1);
 return;
}

function __Z24RegisterStrippedTypeInfoI5LightEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30512 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI5FlareEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30112 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI4TreeEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 184796 | 0, i2, i3);
 return;
}

function __Z18CheckValidFileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return (__Z24CheckValidFileNameDetailRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) | 0) == 0 | 0;
}

function __Z11GetAttitudei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 return;
}

function _UNITY_ft_pic_container_init(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 188 | 0;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return _UNITY_ft_base_pic_init(i1) | 0;
}

function _UNITY_FT_Outline_New(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) {
  i4 = 33;
  return i4 | 0;
 }
 i4 = _UNITY_FT_Outline_New_Internal(HEAP32[i1 >> 2] | 0, i2, i3, i4) | 0;
 return i4 | 0;
}

function _UNITY_FT_Destroy_Class_ft_smooth_renderer_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _UNITY_ft_smooth_renderer_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function b111(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 nullFunc_iiiiiiiiiii(111);
 return 0;
}

function _strndup(i3, i1) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _strnlen(i3, i1) | 0;
 i1 = _malloc(i2 + 1 | 0) | 0;
 if (!i1) i1 = 0; else {
  _memcpy(i1 | 0, i3 | 0, i2 | 0) | 0;
  HEAP8[i1 + i2 >> 0] = 0;
 }
 return i1 | 0;
}

function _rewinddir(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 ___lock(i2 | 0);
 _lseek(HEAP32[i1 >> 2] | 0, 0, 0) | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 ___unlock(i2 | 0);
 return;
}

function ___cxx_global_var_init12() {
 __Z6simd4fffff(gb + 1097664 | 0, Math_fround(-3402823469999999843913219.0e14), Math_fround(-3402823469999999843913219.0e14), Math_fround(-3402823469999999843913219.0e14), Math_fround(0.0));
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj(i1, i2, _wcslen(i2) | 0) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj(i1, i2, _wcslen(i2) | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj(i1, i2, _strlen(i2) | 0) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj(i1, i2, _strlen(i2) | 0) | 0;
}

function __ZNK9Transform18GetTransformAccessEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 32 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK8Material16IsKeywordEnabledEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 i2 = __ZN8keywords6CreateEPKc(i2) | 0;
 return (1 << (i2 & 31) & HEAP32[i1 + 124 + (i2 >>> 5 << 2) >> 2] | 0) != 0 | 0;
}

function __ZNK2UI6Canvas17GetSortingLayerIDEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break;
  if (!(HEAP8[i1 + 375 >> 0] | 0)) i1 = i2; else break;
 }
 return HEAP32[i1 + 368 >> 2] | 0;
}

function __ZNK18ScreenManagerWebGL20GetCurrentResolutionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = _JS_SystemInfo_GetHeight() | 0;
 HEAP32[i1 >> 2] = _JS_SystemInfo_GetWidth() | 0;
 HEAP32[i1 + 8 >> 2] = 60;
 return;
}

function __ZNK12TLSAllocatorI14StackAllocatorE15WalkAllocationsEPFvPKvjPKPvjE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (!i1) return;
 __ZNK14StackAllocator15WalkAllocationsEPFvPKvjPKPvjE(i1, i2);
 return;
}

function __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene9solveStepEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx29PxParticleSystemGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx27PxParticleBaseGeneratedInfoC2Ev(i1);
 HEAP32[i1 + 348 >> 2] = gb + 831985;
 HEAP32[i1 + 352 >> 2] = 193;
 HEAP32[i1 + 356 >> 2] = fb + 2179;
 return;
}

function __ZN5physx20PxVehicleShiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx15PxVehicleUpdate11shiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE(i2, i1, i3);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i2 + 20 | 0, i1, i2);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE17resolveReferencesERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5Umbra21UserCallbackAllocator8allocateEjPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZN24b2ChainAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN24b2ChainAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0)) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(__Z20push_allocation_rootPvP13BaseAllocatorb(i1, 0, 0) | 0)) return;
 __Z19pop_allocation_rootv();
 return;
}

function __ZN14AsyncOperation16CleanupCoroutineEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) return;
 mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, HEAP32[i1 + 16 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13UnityProfiler24BeginFrameSeparateThreadE12ProfilerMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN22UnityProfilerPerThread10BeginFrameE12ProfilerMode(i1, i2);
 return;
}

function __ZN13SplatDatabase27SetMaterialRequiresMetallicEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 48 | 0;
 if ((i2 & 1 | 0) != (HEAPU8[i3 >> 0] | 0 | 0)) HEAP8[i1 + 50 >> 0] = 1;
 HEAP8[i3 >> 0] = i2 & 1;
 return;
}

function __ZN12_GLOBAL__N_19MyFastXml8getErrorERi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 1056 | 0;
 i3 = HEAP32[i4 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 1052 >> 2];
 HEAP32[i4 >> 2] = 0;
 return i3 | 0;
}

function __ZN11dtNodeQueueC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, (i2 << 2) + 4 | 0) | 0;
 return;
}

function __Z47Screen_Set_Custom_PropAutorotateToLandscapeLefth(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 4, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z41SystemInfo_Get_Custom_PropSupportsShadowsv() {
 var i1 = 0;
 if (!(HEAP8[(__Z16GetBuildSettingsv() | 0) + 116 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__Z28CheckPlatformSupportsShadowsv() | 0) & 1;
 return i1 | 0;
}

function __Z36QualitySettings_CUSTOM_DecreaseLevelh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 __ZN15QualitySettings15SetCurrentIndexEib(i2, (HEAP32[i2 + 44 >> 2] | 0) + -1 | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z36AudioSource_Get_Custom_PropMinVolumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884529 | 0, 0, gb + 875076 | 0, 1652, 1, 0, 0, 0);
 return Math_fround(0.0);
}

function __Z36AudioSource_Get_Custom_PropMaxVolumeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 884612 | 0, 0, gb + 875076 | 0, 1677, 1, 0, 0, 0);
 return Math_fround(0.0);
}

function __Z32setPxArticulationJoint_DriveTypePN5physx19PxArticulationJointENS_28PxArticulationJointDriveType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z24RegisterStrippedTypeInfoI4MeshEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30832 | 0, i2, i3);
 return;
}

function __Z24RegisterStrippedTypeInfoI4HaloEviPKcS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_(HEAP32[gb + 1110260 >> 2] | 0, i1, gb + 30352 | 0, i2, i3);
 return;
}

function __Z21CleanupNavMeshManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459032 >> 2] | 0;
 if (i1 | 0) __ZN14NavMeshManagerD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63704 | 0);
 HEAP32[gb + 1459032 >> 2] = 0;
 return;
}

function __Z19setPxMeshScaleScalePN5physx11PxMeshScaleENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function _UNITY_png_set_sRGB(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 _UNITY_png_colorspace_set_sRGB(i1, i2 + 40 | 0, i3) | 0;
 _UNITY_png_colorspace_sync_info(i1, i2);
 return;
}

function _wmemset(i3, i4, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 var i2 = 0;
 if (i1 | 0) {
  i2 = i3;
  while (1) {
   i1 = i1 + -1 | 0;
   HEAP32[i2 >> 2] = i4;
   if (!i1) break; else i2 = i2 + 4 | 0;
  }
 }
 return i3 | 0;
}

function _tlsf_malloc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 3 & -4;
 i2 = (i2 + -1 | 0) >>> 0 < 1073741823 ? (i3 >>> 0 > 12 ? i3 : 12) : 0;
 return _block_prepare_used(i1, _block_locate_free(i1, i2) | 0, i2) | 0;
}

function __ZZN16AnimationManager15InitializeClassEvEN40PreLateUpdateLegacyAnimationUpdatestruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN16AnimationManager6UpdateEv(HEAP32[gb + 1465160 >> 2] | 0);
 return;
}

function __ZZN10Collider2D15InitializeClassEvEN31FunctorImpl_79kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN10Collider2D16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN45EarlyUpdateScriptRunDelayedStartupFramestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z21GetDelayedCallManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 4);
 return;
}

function __ZNSt3__215messages_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212388 + 8;
 return;
}

function __ZNSt3__215messages_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212356 + 8;
 return;
}

function __ZNKSt3__223__system_error_category23default_error_conditionEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__216generic_categoryEv() | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = gb + 1476988;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP8[i1 + 11 >> 0] | 0;
 if (i2 << 24 >> 24 < 0) i1 = HEAP32[i1 + 4 >> 2] | 0; else i1 = i2 & 255;
 return i1 | 0;
}

function __ZNK5physx9NpPhysics9getShapesEPPNS_7PxShapeEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx9NpFactory9getShapesEPPNS_7PxShapeEjj(HEAP32[gb + 1457204 >> 2] | 0, i4, i1, i2) | 0;
}

function __ZN9Transform18GetTransformAccessEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 32 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN7mecanim9animation20DestroyLayerConstantEPNS0_13LayerConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN7mecanim5human14MuscleFromBoneEii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 >>> 0 > 23 | i2 >>> 0 > 2) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = HEAP32[gb + 177812 + (i1 * 12 | 0) + (2 - i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN7mecanim12statemachine18DestroyStateOutputEPNS0_11StateOutputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx25PxDefaultFileOutputStream5writeEPKvj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = _fwrite(i3, 1, i2, i1) | 0;
 return i3 | 0;
}

function __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i2 + 20 | 0, i1, i2);
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN3WWW8SetErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1 + 20 | 0, i2) | 0;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN30RuntimeInitializeOnLoadManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN23b2EdgeAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN23b2EdgeAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN23b2ChainAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN18CrashReportManagerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188668 + 8;
 __ZN18CrashReportManager15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17GeneralConnection13MulticastInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 52 >> 0] = 0;
 return;
}

function __ZN13MemoryManager20SetTempAllocatorSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14StackAllocator12SetBlockSizeEj(__ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv(HEAP32[i1 + 1552 >> 2] | 0) | 0, i2);
 return;
}

function __ZN13DrawImmediate6NormalEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 HEAPF32[i1 + 48 >> 2] = f2;
 HEAPF32[i1 + 52 >> 2] = f3;
 HEAPF32[i1 + 56 >> 2] = f4;
 return;
}

function __ZN13ComputeShader30HasStaticallyResolvedResourcesE17GfxDeviceRendereri(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (__ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, i2, i3) | 0) + 32 | 0;
}

function __ZN12ServerSocket6AcceptEP8sockaddrPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _accept(HEAP32[i1 + 4 >> 2] | 0, i2, i3) | 0;
 __ZN6Socket10CheckErrorEiPKcii(i3, gb + 584832 | 0, 11, 0) | 0;
 return i3 | 0;
}

function __ZN12MeshRenderer26SetAdditionalVertexStreamsEP4Mesh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 380 >> 2] = i1;
 __ZN12MeshRenderer16UpdateCachedMeshEv(i2);
 return;
}

function __ZN12AudioManager23InitScriptBufferManagerEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 296 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 i2 = __Znwj(28) | 0;
 __ZN24AudioScriptBufferManagerC2Ev(i2);
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN11NavMeshPathD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if ((HEAP32[i1 + 24 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, i1 + 12 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN10FileSystem8ShutdownEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1179016 >> 2] | 0;
 if (i1 | 0) __ZN10FileSystemD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63552 | 0);
 HEAP32[gb + 1179016 >> 2] = 0;
 return;
}

function __Z8EndsWithPKcjS0_j(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i2 >>> 0 < i4 >>> 0) {
  i4 = 0;
  return i4 | 0;
 }
 i4 = (_strncmp(i1 + i2 + (0 - i4) | 0, i3, i4) | 0) == 0;
 return i4 | 0;
}

function __Z46get_current_allocation_root_reference_internalv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163236 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i1) | 0;
 return i1 | 0;
}

function __Z36QualitySettings_CUSTOM_IncreaseLevelh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z18GetQualitySettingsv() | 0;
 __ZN15QualitySettings15SetCurrentIndexEib(i2, (HEAP32[i2 + 44 >> 2] | 0) + 1 | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z25getPxPhysics_HeightFieldsPKN5physx9PxPhysicsEPPNS_13PxHeightFieldEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function _UNITY_FT_Init_Class_tt_service_gx_multi_masters(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = fb + 469;
 HEAP32[i1 + 12 >> 2] = fb + 1099;
 HEAP32[i1 + 16 >> 2] = fb + 470;
 return;
}

function mftCall_vfi(i3, d1, i2) {
 i3 = i3 | 0;
 d1 = +d1;
 i2 = i2 | 0;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vfi[i3 - fb & 1](Math_fround(d1), i2 | 0);
  return;
 }
 ftCall_vfi(i3 | 0, +d1, i2 | 0);
}

function _malloc_set_footprint_limit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((i1 | 0) == -1) i1 = 0; else {
  i2 = HEAP32[gb + 1470876 + 8 >> 2] | 0;
  i1 = i1 + -1 + i2 & 0 - i2;
 }
 HEAP32[gb + 1470404 + 440 >> 2] = i1;
 return i1 | 0;
}

function _cff_charset_cid_to_gindex(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 16 >> 2] | 0) >>> 0 < i2 >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAPU16[(HEAP32[i1 + 12 >> 2] | 0) + (i2 << 1) >> 1] | 0;
 return i2 | 0;
}

function __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_399kDidDeleteMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN44UpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z21GetDelayedCallManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0, 2);
 return;
}

function __ZNKSt3__215error_condition7messageEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZNK9Transform23GetHasChangedDeprecatedEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 32 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0) + (HEAP32[i1 + 4 >> 2] << 2) >> 2] & 1 << HEAP32[gb + 1477024 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i4 >> 2] | 0) + 56 >> 2] | 0, i4 | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function __ZNK5physx3Cct13BoxController14getUpDirectionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 36 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 40 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 44 >> 2];
 return;
}

function __ZNK5Umbra10PortalInfo15getNumTrianglesEv(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 if (!(HEAP8[i1 + 144 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 72 >> 2] | 0) + -2 | 0;
 return i1 | 0;
}

function __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 _il2cpp_raise_exception(_il2cpp_exception_from_name_msg(_il2cpp_get_corlib() | 0, gb + 465948 | 0, gb + 466004 | 0, gb + 1576256 | 0) | 0);
 return;
}

function __ZN8Scalar4fC2Ejjjj(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN8Scalar4fC2Eiiii(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i4;
 HEAP32[i1 + 8 >> 2] = i5;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN5physx3Cct17CapsuleController15setClimbingModeENS_21PxCapsuleClimbingMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) > 1) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i2 + 504 >> 2] = i1;
 i2 = 1;
 return i2 | 0;
}

function __ZN5Umbra9IndexListC2EPiii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 return;
}

function __ZN5Umbra9FloatListC2EPfii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i4;
 return;
}

function __ZN4FMOD8ChannelI15getCurrentSoundEPPNS_5SoundE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 i1 = HEAP32[i1 + 64 >> 2] | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 20 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 return 0;
}

function __ZN22b2EdgeAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN18AudioLowPassFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 132 >> 2] = Math_fround(1.0);
 HEAP8[i1 + 136 >> 0] = 0;
 HEAP32[i1 + 112 >> 2] = 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN18AsyncUploadManager16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(1364, gb + 63160 | 0, 16, gb + 397649 | 0, 49) | 0;
 __ZN18AsyncUploadManagerC2Ev(i1);
 HEAP32[gb + 1157732 >> 2] = i1;
 return;
}

function __ZN11AudioFilter13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0);
 return;
}

function __Z35GUI_CUSTOM_Internal_GetMouseTooltipv() {
 var i1 = 0;
 i1 = HEAP32[(__Z11GetGUIStatev() | 0) + 84 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN11UTF16String18GetScriptingStringEv(i1) | 0;
 return i1 | 0;
}

function __Z26setPxSceneDescFilterShaderPN5physx11PxSceneDescEPFNS_7PxFlagsINS_12PxFilterFlag4EnumEtEEjNS_12PxFilterDataEjS6_RNS2_INS_10PxPairFlag4EnumEtEEPKvjE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 32 >> 2] = i1;
 return;
}

function __Z25getPxPhysics_ConvexMeshesPKN5physx9PxPhysicsEPPNS_12PxConvexMeshEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z17DecodeRGBMChanneljjjh(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i4 & 255;
 i3 = ((Math_imul((i3 & i1) >>> i4, i2) | 0) >>> 0) / 510 | 0;
 return (i3 >>> 0 > 255 ? 255 : i3) << i4 | 0;
}

function _cff_index_get_string(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 + 1312 >> 2] | 0) >>> 0 <= i2 >>> 0) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i1 + 1316 >> 2] | 0) + (i2 << 2) >> 2] | 0;
 return i2 | 0;
}

function _bitshift64Lshr(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i1 | 0) < 32) {
  setTempRet0(i2 >>> i1 | 0);
  return i3 >>> i1 | (i2 & (1 << i1) - 1) << 32 - i1;
 }
 setTempRet0(0);
 return i2 >>> i1 - 32 | 0;
}

function __ZZN2UI6Canvas15InitializeClassEvEN33FunctorImpl_1283kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN2UI6Canvas16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN47PreLateUpdateScriptRunBehaviourLateUpdatestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z23GetLateBehaviourManagerv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZNK8VRDevice23GetIsParallelProjectionEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 164 >> 0] | 0) == 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Gu12TriangleMesh24getTriangleMaterialIndexEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 176 >> 2] | 0;
 if (!i1) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = HEAP16[i1 + (i2 << 1) >> 1] | 0;
 return i2 | 0;
}

function __ZNK5physx25PxVehicleConstraintShader19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE(i3, i2, i1, i4) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i4 = i4 | 0;
 return 1;
}

function __ZNK26PlayerSettingsSplashScreen24GetShowUnitySplashScreenEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 4 >> 0] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0) == 0;
 return i1 | 0;
}

function __ZNK21AssetBundleFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZNK15b2RevoluteJoint13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 52 >> 2] | 0) + 72 >> 2]);
 return Math_fround(f2 - Math_fround(HEAPF32[(HEAP32[i1 + 48 >> 2] | 0) + 72 >> 2]));
}

function __ZN9ShaderLab9SubShader19CreateFromSubShaderERKS0_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZnwjRK10MemLabelIdiPKci(60, gb + 63280 | 0, 16, gb + 481282 | 0, 65) | 0;
 __ZN9ShaderLab9SubShaderC2ERKS0_(i2, i1);
 return i2 | 0;
}

function __ZN8Animator5IKJobEPPS_j(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + (i2 << 2) >> 2] | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 if (!(HEAP32[i1 + 168 >> 2] | 0)) return;
 __ZN8Animator6IKStepEv(i1);
 return;
}

function __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 540 >> 2] = 0;
 __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE(i1, i2 + 16 | 0, i2 + 288 | 0);
 return;
}

function __ZN5physx22PxVehicleWheelsDynData21setWheelRotationAngleEjf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i2 >> 2] | 0) + ((i3 >>> 2) * 224 | 0) + 32 + ((i3 & 3) << 2) >> 2] = f1;
 return;
}

function __ZN5physx17ConvexMeshBuilderD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 110060 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 110060 + 84;
 __ZN5physx17ConvexHullBuilderD2Ev(i1 + 132 | 0);
 __ZN5physx2Gu10ConvexMeshD2Ev(i1);
 return;
}

function __ZN2gl15IsFormatIntegerENS_9TexFormatE(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i1) | 0) + 12 >> 2] & 128 | 0) != 0 | 0;
}

function __ZN29AssetBundleLoadAssetOperation7PerformEv(i1) {
 i1 = i1 | 0;
 __ZN29AssetBundleLoadAssetOperation34CollectFullPreloadDataDependenciesER13dynamic_arrayIiLj4EE(i1, i1 + 64 | 0);
 __ZN13LoadOperation7PerformEv(i1);
 return;
}

function __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20TextRenderingPrivate8TextMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16Physics2DManager25DestroyColliderCollisionsEP10Collider2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19CollisionListener2D25DestroyColliderCollisionsEP10Collider2D((HEAP32[gb + 1458412 >> 2] | 0) + 12 | 0, i2);
 return;
}

function __ZN14SafeBinaryRead20TransferTypelessDataEjPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if ((i2 | 0) == 0 | (i3 | 0) == 0) return;
 __ZN12CachedReader4ReadEPvj(i1 + 16 | 0, i3, i2);
 return;
}

function __ZN14SafeBinaryRead16IsCurrentVersionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 80 >> 2] | 0;
 i2 = HEAP32[i1 + 16 >> 2] | 0;
 return (i2 | 0) == (HEAP16[(__ZNK16TypeTreeIterator7GetNodeEv(i1) | 0) >> 1] | 0) | 0;
}

function __ZN13WheelCollider10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Collider10DeactivateE19DeactivateOperation(i1, i2);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12_GLOBAL__N_116StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = __Znwj(12) | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[gb + 1103788 >> 2] = i1;
 return;
}

function __ZL20PngWriteToMemoryFuncP14png_struct_defPhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = _UNITY_png_get_io_ptr(i1) | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __Z39getPxRigidDynamic_SolverIterationCountsPKN5physx14PxRigidDynamicERjS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 296 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z24getPxScene_ArticulationsPKN5physx7PxSceneEPPNS_14PxArticulationEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function _UNITY_png_default_write_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 if ((_fwrite(i2, 1, i3, HEAP32[i1 + 184 >> 2] | 0) | 0) == (i3 | 0)) return; else _UNITY_png_error(i1, gb + 354814 | 0);
}

function _UNITY_FT_New_Memory() {
 var i1 = 0;
 i1 = _malloc(16) | 0;
 if (!i1) return i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = fb + 1100;
 HEAP32[i1 + 12 >> 2] = fb + 191;
 HEAP32[i1 + 8 >> 2] = fb + 4207;
 return i1 | 0;
}

function b18(i1, i2, i3, i4, i5, i6, f7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 nullFunc_viiiiiifiii(18);
}

function _inet_netof(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 do if ((i1 | 0) > -1) i1 = i1 >>> 24; else if (i1 >>> 0 < 3221225472) {
  i1 = i1 >>> 16;
  break;
 } else {
  i1 = i1 >>> 8;
  break;
 } while (0);
 return i1 | 0;
}

function _emscripten_glVertexAttrib4f__wrapper(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 _emscripten_glVertexAttrib4f(i1 | 0, +f2, +f3, +f4, +f5);
}

function __ZZN9Rigidbody15InitializeClassEvEN32FunctorImpl_464kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN9Rigidbody16TransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZN8LODGroup15InitializeClassEvEN32FunctorImpl_428kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8LODGroup18OnTransformChangedEi(i1, HEAP32[i3 + 4 >> 2] | 0);
 return;
}

function __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN12MeshRenderer15InitializeClassEvEN30FunctorImpl_98kDidModifyBounds4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZNSt3__217__assoc_sub_stateD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208172 + 8;
 __ZNSt3__218condition_variableD2Ev(i1 + 40 | 0);
 __ZNSt3__25mutexD2Ev(i1 + 12 | 0);
 __ZNSt13exception_ptrD2Ev(i1 + 8 | 0);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 if ((HEAP8[i1 + 3 >> 0] | 0) < 0) i1 = (HEAP32[i1 >> 2] & 2147483647) + -1 | 0; else i1 = 1;
 return i1 | 0;
}

function __ZNK8VRDevice22GetOverrideFieldOfViewEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 167 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK4Mesh20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __ZNK6Object20GetRuntimeMemorySizeEv(i1) | 0;
 return (__ZNK23SharedMeshRenderingData20GetRuntimeMemorySizeEv(HEAP32[i1 + 36 >> 2] | 0) | 0) + i2 | 0;
}

function __ZNK13RenderTexture32CalculateNeedsInvertedProjectionEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 123 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0) == 0;
 return i1 | 0;
}

function __ZNK12b2MouseJoint10GetAnchorAEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 76 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZNK11b2GearJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 + 156 >> 2]);
 return Math_fround(Math_fround(f3 * Math_fround(HEAPF32[i1 + 256 >> 2])) * f2);
}

function __ZN8DateTime21FromSecondsSinceEpochEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i1;
 HEAP32[i4 >> 2] = 0;
 HEAP32[i4 + 4 >> 2] = 0;
 HEAP16[i1 >> 1] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN6Camera14AddImageFilterERK11ImageFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12ImageFilters14AddImageFilterERK11ImageFilter(__Z25GetRenderLoopImageFiltersR10RenderLoop(HEAP32[i1 + 1124 >> 2] | 0) | 0, i2);
 return;
}

function __ZN5physx7NpShape13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj32ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE(i2 + 32 | 0, i2 + 48 | 0, f1);
 return;
}

function __ZN5physx2Sc9ActorCore17setDominanceGroupEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 12 >> 0] = i1;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc8ActorSim24postDominanceGroupChangeEv(i1);
 return;
}

function __ZN5physx2Gu12TriangleMesh15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx20InternalTriangleMesh15importExtraDataERNS_24PxDeserializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i2 + 20 | 0, i1, i2);
 return;
}

function __ZN5physx16PxsBroadPhaseMBP9addRegionERKNS_18PxBroadPhaseRegionEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN3MBP12addBoxPrunerERKN5physx18PxBroadPhaseRegionEb(HEAP32[i3 + 84 >> 2] | 0, i2, i1) | 0;
}

function __ZN5Umbra5Float8isFiniteEf(f1) {
 f1 = Math_fround(f1);
 return f1 <= Math_fround(3402823469999999843913219.0e14) & (f1 == f1 & Math_fround(0.0) == Math_fround(0.0) & f1 >= Math_fround(-3402823469999999843913219.0e14)) | 0;
}

function __ZN4UNET16ScriptingUpdater18ClearUpdatePointerEv() {
 var i1 = 0;
 i1 = __ZN4UNET16ScriptingUpdater3GetEv() | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1164176 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[gb + 1164176 + 4 >> 0] | 0;
 return;
}

function __ZN4Mesh27InitChannelsToDefaultValuesEjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z23ClearVertexDataChannelsjjjR14VertexDataInfo(i2, i3, i4, (HEAP32[i1 + 32 >> 2] | 0) + 8 | 0);
 return;
}

function __ZN2gl15IsFormatIEEE754ENS_9TexFormatE(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i1) | 0) + 12 >> 2] & 96 | 0) != 0 | 0;
}

function __ZN18ScriptingArgumentsC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 96 | 0;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP32[i1 + 192 >> 2] = 0;
 return;
}

function __ZN15DownloadHandlerD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __Z23scripting_gchandle_freej(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15DownloadHandlerD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 187368 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __Z23scripting_gchandle_freej(i2);
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicMaterial17ReleasePxMaterialEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 52 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14NavMeshManager26UpdateAllNavMeshAgentCostsEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) return;
 __ZN7dtCrowd16UpdateFilterCostEif(i1, i2, f3);
 return;
}

function __ZN14DirectorPlayer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 __ZN19StreamedBinaryWriteILb0EE5AlignEv(i2);
 return;
}

function __ZN13GfxDeviceGLES19SetProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9GfxDevice19SetProjectionMatrixERK10Matrix4x4f(i1, i2);
 i2 = i1 + 6620 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 4;
 return;
}

function __ZN11TerrainData16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 __ZN9Heightmap16CheckConsistencyEv(i1 + 248 | 0);
 __ZN12TreeDatabase13ValidateTreesEv(i1 + 84 | 0);
 __ZN14DetailDatabase15ValidateDetailsEv(i1 + 128 | 0);
 return;
}

function __Z40VRSettings_Get_Custom_PropShowDeviceViewv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZNK8VRDevice17GetShowDeviceViewEv(__Z12GetIVRDevicev() | 0) | 0) & 1;
 return i1 | 0;
}

function __Z39getPxArticulation_SolverIterationCountsPKN5physx14PxArticulationERjS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z36Terrain_Get_Custom_PropActiveTerrainv() {
 var i1 = 0;
 i1 = __Z18GetITerrainManagerv() | 0;
 return __ZN9Scripting19ScriptingWrapperForEP6Object(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0) | 0;
}

function __Z33getPxArticulationJoint_TwistLimitPKN5physx19PxArticulationJointERfS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 140 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z33getPxArticulationJoint_SwingLimitPKN5physx19PxArticulationJointERfS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 100 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z21getPxClothParticlePosPKN5physx15PxClothParticleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z21CleanupGlobalGUIStatev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1468876 >> 2] | 0, gb + 63864 | 0);
 HEAP32[gb + 1468876 >> 2] = 0;
 __Z19free_alloc_internalPvRK10MemLabelId(0, gb + 63864 | 0);
 return;
}

function __Z17SetNbTriggerPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i3 + 676 + (i1 * 28 | 0) + (i2 << 2) >> 2] = i4;
 return;
}

function b129(i1, f2, i3, i4, f5, i6, f7, f8) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 nullFunc_iifiififf(129);
 return 0;
}

function b107(i1, i2, f3, i4, f5, i6, f7, f8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 nullFunc_iiifififf(107);
 return 0;
}

function _ft_smooth_render_lcd_v(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = _ft_smooth_render_generic(i1, i4, i2, i3, 4) | 0;
 if (i1 | 0) return i1 | 0;
 HEAP8[i4 + 94 >> 0] = 6;
 return i1 | 0;
}

function ___polevll(d4, i1, i2) {
 d4 = +d4;
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0;
 d3 = +HEAPF64[i1 >> 3];
 do {
  i1 = i1 + 8 | 0;
  d3 = d3 * d4 + +HEAPF64[i1 >> 3];
  i2 = i2 + -1 | 0;
 } while ((i2 | 0) != 0);
 return +d3;
}

function __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsCanvasManagerEmitOffScreenGeometrystruct7ForwardEv() {
 __ZN2UI13CanvasManager34EmitWorldScreenspaceCameraGeometryENS0_10CameraTypeE(HEAP32[gb + 1467948 >> 2] | 0, 2);
 return;
}

function __ZZN12MeshRenderer15InitializeClassEvEN29FunctorImpl_100kDidModifyMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476368 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476376 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476292 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476284 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476276 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476268 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp11make_globalEv() {
 var i1 = 0;
 i1 = HEAP32[(__ZNSt3__26locale7classicEv() | 0) >> 2] | 0;
 HEAP32[gb + 1476392 >> 2] = i1;
 __ZNSt3__214__shared_count12__add_sharedEv(i1);
 return gb + 1476392 | 0;
}

function __ZNK8VRDevice20ResetCompositorLayerEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) return;
 i1 = HEAP32[i1 + 264 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZNK5physx2Gu10ConvexMesh14getIndexBufferEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 56 >> 2] | 0) + (((HEAPU8[i1 + 54 >> 0] | 0) * 15 | 0) + ((HEAPU8[i1 + 55 >> 0] | 0) * 20 | 0) + ((HEAPU16[i1 + 52 >> 1] | 0) << 1)) | 0;
}

function __ZNK17BillboardRenderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 360 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  i1 = i1 & 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 36 >> 2] | 0) != 0;
 i1 = i1 & 1;
 return i1 | 0;
}

function __ZN9Texture2D13GetAsyncFenceEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i4 = i2 + 144 | 0;
 i3 = HEAP32[i4 + 4 >> 2] | 0;
 i2 = i1;
 HEAP32[i2 >> 2] = HEAP32[i4 >> 2];
 HEAP32[i2 + 4 >> 2] = i3;
 return;
}

function __ZN8Animator20InterruptMatchTargetEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) {
  HEAP8[i1 + 416 >> 0] = 1;
  return;
 } else {
  HEAPF32[i1 + 364 >> 2] = Math_fround(-1.0);
  HEAP32[i1 + 368 >> 2] = -1;
  return;
 }
}

function __ZN7mecanim9animation18DestroyAvatarInputEPNS0_11AvatarInputERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene26setBounceThresholdVelocityEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 __ZN5physx10PxsContext18setBounceThresholdEf(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, Math_fround(-f1));
 return;
}

function __ZN5physx24PxDefaultMemoryInputDataC2EPhj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i3 >> 2] = gb + 87560 + 8;
 HEAP32[i3 + 4 >> 2] = i2;
 HEAP32[i3 + 8 >> 2] = i1;
 HEAP32[i3 + 12 >> 2] = 0;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11attachShapeERNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i2 + 20 | 0, i1, i2);
 return;
}

function __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE(i2 + 20 | 0, i1, i2);
 return;
}

function __ZN5physx14NpRigidDynamic11clearTorqueENS_11PxForceMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i2, i1, 0, 1);
 return;
}

function __ZN5Umbra9BitVectorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i1 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 + -16 | 0);
 return;
}

function __ZN4crnd25static_huffman_data_modelC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 return;
}

function __ZN20UnloadSceneOperationD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65964 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 68 | 0);
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20TextRenderingPrivate7GUIText8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15QualitySettings29GetShadowDistanceForRenderingEv() {
 var i1 = 0;
 i1 = __Z21GetManagerFromContexti(11) | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2]);
}

function __ZN15NavMeshObstacle13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 i2 = i1 + 136 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 8;
 return;
}

function __ZN14PhysicsManager34SetDefaultSolverVelocityIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 HEAP32[i1 + 172 >> 2] = (i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2;
 return;
}

function __ZN14NavMeshManager23RemoveOffMeshConnectionEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 108 >> 2] | 0;
 if (!i1) return;
 __ZN9dtNavMesh23removeOffMeshConnectionEy(i1, i2, i3) | 0;
 return;
}

function __ZN14AssetReferenceC2ERKS_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 if (!i1) return;
 __ZN21AssetReferenceStorage12AddReferenceEi(HEAP32[gb + 1162408 >> 2] | 0, i1);
 return;
}

function __ZN11UnityEngine9Animation40SetFlattenedSkeletonTransformsMainThreadER9TransformRKNS0_21AvatarBindingConstantE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Transform40SendTransformChangedToModifiedTransformsEv(i1);
 return;
}

function __Z6GetBitPKhRj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 i4 = i3 >>> 3;
 i1 = (HEAPU8[i1 + i4 >> 0] | 0) >>> (i3 - (i4 << 3) | 0) & 1;
 HEAP32[i2 >> 2] = i3 + 1;
 return i1 | 0;
}

function __Z65SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddAmbientLightInternalRK10ColorRGBAfR20SphericalHarmonicsL2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20SphericalHarmonicsL215AddAmbientLightERK10ColorRGBAf(i2, i1);
 return;
}

function __Z42Screen_Set_Custom_PropAutorotateToPortraith(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, 1, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z37Physics2D_CUSTOM_IgnoreLayerCollisioniih(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN16Physics2DManager20IgnoreLayerCollisionEiib(__Z19GetPhysicsManager2Dv() | 0, i1, i2, i3 << 24 >> 24 != 0);
 return;
}

function __Z30getPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkEPPS0_j(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 236 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z25getPxPhysics_ClothFabricsPKN5physx9PxPhysicsEPPNS_13PxClothFabricEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z22getPxConstraint_ActorsPKN5physx12PxConstraintERPNS_12PxRigidActorES5_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z11GetHostNamev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 459312 | 0, 7);
 return;
}

function _XXH32_canonicalFromHash(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = _llvm_bswap_i32(i2 | 0) | 0;
 HEAP8[i1 >> 0] = i2;
 HEAP8[i1 + 1 >> 0] = i2 >> 8;
 HEAP8[i1 + 2 >> 0] = i2 >> 16;
 HEAP8[i1 + 3 >> 0] = i2 >> 24;
 return;
}

function _UNITY_png_default_read_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 if ((_fread(i2, 1, i3, HEAP32[i1 + 184 >> 2] | 0) | 0) == (i3 | 0)) return; else _UNITY_png_error(i1, gb + 402106 | 0);
}

function _UNITY_png_convert_to_rfc1123(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 | 0) {
  i1 = i1 + 549 | 0;
  if (_UNITY_png_convert_to_rfc1123_buffer(i1, i2) | 0) {
   i2 = i1;
   return i2 | 0;
  }
 }
 i2 = 0;
 return i2 | 0;
}

function _UNITY_FT_Bitmap_Init(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function mftCall_dii(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 7 | 0)) return +FUNCTION_TABLE_dii[i3 - fb & 7](i1 | 0, i2 | 0);
 return +ftCall_dii(i3 | 0, i1 | 0, i2 | 0);
}

function b66(i1, i2, i3, i4, i5, f6, i7, i8, f9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 f9 = Math_fround(f9);
 nullFunc_iiiiiifiif(66);
 return 0;
}

function _ps_hints_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0, i4 = 0;
 i3 = i1 + 4 | 0;
 i4 = i3 + 84 | 0;
 do {
  HEAP32[i3 >> 2] = 0;
  i3 = i3 + 4 | 0;
 } while ((i3 | 0) < (i4 | 0));
 HEAP32[i1 >> 2] = i2;
 return;
}

function _munlockall() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall_ret(___syscall153(153, i1 | 0) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _glReadPixels__wrapper(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 _glReadPixels(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0, i7 | 0);
}

function _ffs(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) i1 = 0; else if (!(i1 & 1)) {
  i2 = 0;
  while (1) {
   i1 = i1 >>> 1;
   if (i1 & 1 | 0) break; else i2 = i2 + 1 | 0;
  }
  i1 = i2 + 2 | 0;
 } else i1 = 1;
 return i1 | 0;
}

function __ZZN2UI23InitializeCanvasManagerEvEN47UIEventsCanvasmanagerEmitOnScreenGeometrystruct7ForwardEv() {
 __ZN2UI13CanvasManager34EmitWorldScreenspaceCameraGeometryENS0_10CameraTypeE(HEAP32[gb + 1467948 >> 2] | 0, 1);
 return;
}

function __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_791kDidDeleteMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = 0;
 return;
}

function __ZNSt3__26locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476360 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476352 | 0) | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__zeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__zeroEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = 0;
 while (1) {
  if ((i1 | 0) == 3) break;
  HEAP32[i2 + (i1 << 2) >> 2] = 0;
  i1 = i1 + 1 | 0;
 }
 return;
}

function __ZNK9Texture2D20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = Math_imul(HEAP32[i1 + 44 >> 2] | 0, HEAP32[i1 + 40 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc15ArticulationSim10isSleepingEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[(HEAP32[HEAP32[i1 + 24 >> 2] >> 2] | 0) + 51 >> 0] & 1) == 0;
 return i1 | 0;
}

function __ZNK5physx13NpClothFabric9getPhasesEPNS_18PxClothFabricPhaseEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore9getPhasesEPNS_18PxClothFabricPhaseEj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK17FileSystemHandler12GetAssetGUIDERK13FileEntryData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZNK17ArchiveFileSystem12GetAssetGUIDERK13FileEntryData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZNK13GfxDeviceGLES14IsShaderActiveE10ShaderType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 7060 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[i1 + 80 + i2 >> 0] | 0) != 0;
 return i2 | 0;
}

function __ZNK13EmscriptenWWW11GetProgressEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 if (HEAP8[i1 + 96 >> 0] | 0) {
  f2 = Math_fround(1.0);
  return Math_fround(f2);
 }
 f2 = Math_fround(HEAPF32[i1 + 84 >> 2]);
 return Math_fround(f2);
}

function __ZNK12b2WheelJoint13GetJointSpeedEv(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[(HEAP32[i1 + 48 >> 2] | 0) + 72 >> 2]);
 return Math_fround(Math_fround(HEAPF32[(HEAP32[i1 + 52 >> 2] | 0) + 72 >> 2]) - f2);
}

function __ZNK12CubemapArray26CanReuploadDataToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 92 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = __ZNK7Texture41QueryPersistentManagerForDataAvailabilityEv(i1) | 0;
 return i1 | 0;
}

function __ZN9Rigidbody14SetAngularDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 76 >> 2] = f2;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN9InputAxis9MakeMouseEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 76 >> 2] = 1;
 HEAP32[i1 + 88 >> 2] = i2;
 HEAPF32[i1 + 96 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 100 >> 2] = Math_fround(.100000001);
 return;
}

function __ZN6Camera9SetAspectEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 1060 >> 2] = f2;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 HEAP8[i1 + 1086 >> 0] = 0;
 return;
}

function __ZN5physx9NpPhysics17createHeightFieldERKNS_17PxHeightFieldDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx13GuMeshFactory17createHeightFieldERKNS_17PxHeightFieldDescE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx24PxvRegisterArticulationsEv() {
 HEAP32[gb + 1457380 >> 2] = fb + 1;
 HEAP32[gb + 1457376 >> 2] = fb + 410;
 HEAP32[gb + 1457372 >> 2] = fb + 3721;
 __ZN5physx36PxsSolverCoreRegisterArticulationFnsEv();
 return;
}

function __ZN5physx16NpParticleSystem15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc18ParticleSystemCore15exportExtraDataERNS_22PxSerializationContextE(i2 + 32 | 0, i1);
 return;
}

function __ZN5physx14NpRigidDynamic10clearForceENS_11PxForceMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17clearSpatialForceENS_11PxForceMode4EnumEbb(i2, i1, 1, 0);
 return;
}

function __ZN5Umbra9Matrix2x25identEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 12 >> 2] = Math_fround(1.0);
 return;
}

function __ZN2gl13IsFormatFloatENS_9TexFormatE(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i1) | 0) + 12 >> 2] & 32 | 0) != 0 | 0;
}

function __ZN23AnimationOffsetPlayable11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 80 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 84 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 88 >> 2];
 return;
}

function __ZN20LocalFileSystemWebGL6DeleteER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZN20LocalFileSystemPosix6DeleteER13FileEntryDatab(i1, i2, i3) | 0;
 _JS_FileSystem_Sync();
 return i3 | 0;
}

function __ZN20LocalFileSystemWebGL4CopyER13FileEntryDataS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZN20LocalFileSystemPosix4CopyER13FileEntryDataS1_(i1, i2, i3) | 0;
 _JS_FileSystem_Sync();
 return i3 | 0;
}

function __ZN15TerrainCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24GenerateTypeTreeTransfer12TransferBaseI15TerrainColliderEEvRT_17TransferMetaFlags(i2, i1, 0);
 return;
}

function __ZN14DataBufferGLES13EnsureStorageEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP8[i1 + 20 >> 0] | 0) if ((HEAP32[i1 + 8 >> 2] | 0) >= (i2 | 0)) return;
 __ZN14DataBufferGLES16RecreateWithDataEiPKv(i1, i2, 0);
 return;
}

function __Z52QualitySettings_Get_Custom_PropShadowNearPlaneOffsetv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 40 >> 2]);
}

function __Z47QualitySettings_Set_Custom_PropShadowResolutionN15QualitySettings16ShadowResolutionE(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings19SetShadowResolutionENS_16ShadowResolutionE(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z43setPxVehicleWheelsSimData_WheelShapeMappingPN5physx22PxVehicleWheelsSimDataEji(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji(i2, i1, i3);
 return;
}

function __Z35RegisterModuleClasses_TextRenderingv() {
 __Z13RegisterClassIN13TextRendering4FontEEvv();
 __Z13RegisterClassIN20TextRenderingPrivate7GUITextEEvv();
 __Z13RegisterClassIN20TextRenderingPrivate8TextMeshEEvv();
 return;
}

function __Z24Mathf_CUSTOM_PerlinNoiseff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(Math_fround(__ZN11PerlinNoise5NoiseEff(f1, f2)) + Math_fround(.689999997)) / Math_fround(1.48300004));
}

function __Z23PlayerCleanupCachedDatav() {
 var i1 = 0;
 __ZN19RenderBufferManager14GarbageCollectEi(__Z22GetRenderBufferManagerv() | 0, 15);
 i1 = HEAP32[gb + 1115296 + 428 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __Z22getPxRigidActor_ShapesPKN5physx12PxRigidActorEPPNS_7PxShapeEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z22getPxPhysics_MaterialsPKN5physx9PxPhysicsEPPNS_10PxMaterialEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z10GetLocalIPv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj(i1, gb + 459312 | 0, 7);
 return;
}

function _UNITY_FT_Bitmap_New(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function _ft_smooth_render_lcd(i1, i4, i2, i3) {
 i1 = i1 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = _ft_smooth_render_generic(i1, i4, i2, i3, 3) | 0;
 if (i1 | 0) return i1 | 0;
 HEAP8[i4 + 94 >> 0] = 5;
 return i1 | 0;
}

function __ZZN8Renderer15InitializeClassEvEN32FunctorImpl_130kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN33PreUpdateCheckTexFieldInputstruct7ForwardEv() {
 var i1 = 0;
 i1 = (__ZN12InputManager17GetTextFieldInputEv(__Z15GetInputManagerv() | 0) | 0) & 1;
 HEAP8[gb + 1548963 >> 0] = i1;
 return;
}

function __ZNKSt3__210error_code7messageEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i3 | 0, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZNK16MemoryFileSystem12GetAssetGUIDERK13FileEntryData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN8GUIState12PopAndDeleteEPS_(i1) {
 i1 = i1 | 0;
 __ZN8GUIState13MoveAllDataToERS_b(i1, HEAP32[gb + 1468832 + (HEAP32[i1 + 348 >> 2] << 2) >> 2] | 0, 0);
 if (!i1) return;
 __ZN8GUIStateD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN7mecanim6memory16MecanimAllocator8AllocateEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, i3, i1 + 4 | 0, 0, gb + 913345 | 0, 415) | 0;
}

function __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene3addINS0_17ArticulationJointELb0EEEvRT_RNS0_13ObjectTrackerE(i2, i1, i2 + 2740 | 0);
 return;
}

function __ZN5physx2Sn13XmlWriterImpl5writeEPKcS3_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = HEAP32[i3 + 8 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 20 >> 2] | 0, i3 | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx25PxDefaultFileOutputStreamD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 87592 + 8;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 _fclose(i1) | 0;
 __ZdlPv(i2);
 return;
}

function __ZN5physx16PxVehicleNoDrive14setToRestStateEv(i1) {
 i1 = i1 | 0;
 _memset(HEAP32[i1 + 128 >> 2] | 0, 0, ((HEAP32[i1 + 48 >> 2] << 2) + 12 & -16) * 3 | 0) | 0;
 __ZN5physx15PxVehicleWheels14setToRestStateEv(i1);
 return;
}

function __ZN5physx15NpParticleFluid15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc18ParticleSystemCore15exportExtraDataERNS_22PxSerializationContextE(i2 + 32 | 0, i1);
 return;
}

function __ZN5physx10NpMaterial18setDynamicFrictionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 32 >> 2] = f2;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZN4FMOD7SystemI16getDSPBufferSizeEPjPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = HEAP32[i1 + 44 >> 2];
 if (!i3) return 0;
 HEAP32[i3 >> 2] = HEAP32[i1 + 48 >> 2];
 return 0;
}

function __ZN2gl12IsFormatHalfENS_9TexFormatE(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(HEAP32[(HEAP32[gb + 1451080 >> 2] | 0) + 860 >> 2] | 0, i1) | 0) + 12 >> 2] & 64 | 0) != 0 | 0;
}

function __ZN19SkinnedMeshRenderer7SetMeshEP4Mesh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 352 >> 2] = i1;
 __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv(i2);
 return;
}

function __ZN19CharacterController11GetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 116 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 120 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 124 >> 2];
 return;
}

function __ZN17GeneralConnection13MulticastInfo5ClearEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 52 >> 0] = 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN14ParticleSystem23CheckSupportsProceduralERKS_(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!(HEAP8[i1 + 25 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 26 >> 0] | 0) == 0;
 return i1 | 0;
}

function __ZN14MinMaxGradientC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 __ZN8GradientC2Ev(i1);
 __ZN8GradientC2Ev(i1 + 72 | 0);
 i2 = i1 + 144 | 0;
 HEAP32[i2 >> 2] = -1;
 HEAP32[i2 + 4 >> 2] = -1;
 HEAP16[i1 + 152 >> 1] = 0;
 return;
}

function __ZN14DirectorPlayer8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 __ZN24GenerateTypeTreeTransfer5AlignEv(i2);
 return;
}

function __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb1EE5AlignEv(i2);
 return;
}

function __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 __ZN18StreamedBinaryReadILb0EE5AlignEv(i2);
 return;
}

function __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE10InitializeEv(i1);
 return;
}

function __ZN11AudioModule25AudioManagerAwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __Z15GetAudioManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z6simd4fffff(i1, f3, f4, f5, f2) {
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f2 = Math_fround(f2);
 __ZN13Simd4fFactoryIN6detail9FourTupleEEC2Effff(i1, f3, f4, f5, f2);
 return;
}

function __Z40AudioSettings_CUSTOM_INTERNAL_CALL_ResetRK27AudioConfigurationScripting(i1) {
 i1 = i1 | 0;
 return (__ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting(__Z15GetAudioManagerv() | 0, i1) | 0) & 1 | 0;
}

function __Z39setPxRigidDynamic_SolverIterationCountsPN5physx14PxRigidDynamicEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 292 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z23HTML5MouseButtonToUnityi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
  {
   i1 = 0;
   break;
  }
 case 1:
  {
   i1 = 2;
   break;
  }
 case 2:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 3;
 }
 return i1 | 0;
}

function __Z22setPxConstraint_ActorsPN5physx12PxConstraintEPNS_12PxRigidActorES3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 32 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z22getPxScene_ConstraintsPKN5physx7PxSceneEPPNS_12PxConstraintEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z19GL_CUSTOM_TexCoord2ff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 var i3 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_vifff(HEAP32[(HEAP32[i3 >> 2] | 0) + 572 >> 2] | 0, i3 | 0, +f1, +f2, 0.0);
 return;
}

function __Z15Transfer_StringI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z46get_current_allocation_root_reference_internalv() | 0;
 return;
}

function __Z15Transfer_StringI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z46get_current_allocation_root_reference_internalv() | 0;
 return;
}

function __Z14FMOD_FILE_SeekPvjS_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) {
  i3 = 33;
  return i3 | 0;
 }
 i3 = __ZN12FileAccessor4SeekEx10FileOrigin(i1, i2, 0, 1) | 0;
 i3 = i3 ? 0 : 19;
 return i3 | 0;
}

function _cff_cmap_unicode_done(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 20 | 0;
 _UNITY_ft_mem_free(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdateRendererNotifyInvisiblestruct7ForwardEv() {
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 __ZN13RendererScene15NotifyInvisibleEv(__Z16GetRendererScenev() | 0);
 return;
}

function __ZThn80_NK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + -80 + 84 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx19PxArticulationJoint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 686453 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Umbra14TomeCollection15getClusterCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 124 >> 2] | 0;
 return i1 | 0;
}

function __ZN9GfxDevice11CopyTextureE9TextureIDiiiS0_iii(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 return;
}

function __ZN8Animator17OnPlayableDestroyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = gb + 37528 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i1 + 628 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170680 + 8;
 HEAP32[gb + 1459920 >> 2] = (HEAP32[gb + 1459920 >> 2] | 0) + -1;
 __ZN17WeakPtrSharedDataD2Ev(i1);
 return;
}

function __ZN5physx2Sc7PhysicsD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN5physx7PxvTermEv();
 HEAP32[gb + 1457332 >> 2] = 0;
 return;
}

function __ZN5physx2Sc14ConstraintCore23setMinResponseThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 64 >> 2] = f2;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) return;
 HEAPF32[i1 + 92 >> 2] = f2;
 return;
}

function __ZN5physx2Gu12TriangleMesh15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx20InternalTriangleMesh15exportExtraDataERNS_22PxSerializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE(i2 + 12 | 0, i1);
 return;
}

function __ZN5physx14PxsAABBManager9prepareBPEv(i1) {
 i1 = i1 | 0;
 __ZNK5physx14SingleAABBTask25updateNumFastMovingShapesEv(i1 + 49868 | 0);
 __ZNK5physx17AggregateAABBTask25updateNumFastMovingShapesEv(i1 + 50608 | 0);
 return;
}

function __ZN5physx13NpClothFabric15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc15ClothFabricCore15importExtraDataERNS_24PxDeserializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN5physx10NpMaterial17setStaticFrictionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 36 >> 2] = f2;
 __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE(HEAP32[gb + 1457324 >> 2] | 0, i1);
 return;
}

function __ZN22AnimationMixerPlayable18SetInputConnectionEP8Playablei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZN8Playable18SetInputConnectionEPS_i(i1, i2, i3) | 0;
 HEAP8[i1 + 56 >> 0] = 1;
 return i3 | 0;
}

function __ZN20LocalFileSystemPosix12CreateAsFileER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _fopen(i2, gb + 1085899 | 0) | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 _fclose(i1) | 0;
 i2 = 1;
 return i2 | 0;
}

function __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 80 >> 2] = Math_fround(inf);
 HEAP32[i1 + 76 >> 2] = 0;
 return;
}

function __ZN16b2PolygonContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN16b2CapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags(i2, i1 + 24 | 0, gb + 1046958 | 0, 0);
 return;
}

function __ZN11AudioModule26SetDefaultMicrophoneDriverEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __Z18GetAudioManagerPtrv() | 0;
 if (!i1) return;
 __ZN12AudioManager26SetDefaultMicrophoneDriverEP9FMOD_GUID(i1, i2);
 return;
}

function __ZL42GeomOverlapCallback_HeightfieldHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z50QualitySettings_Get_Custom_PropShadowCascade2Splitv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 44 >> 2]);
}

function __Z39setPxArticulation_SolverIterationCountsPN5physx14PxArticulationEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z21getPxScene_AggregatesPKN5physx7PxSceneEPPNS_11PxAggregateEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z21getPxSceneDescGravityPKN5physx11PxSceneDescE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function __Z21FindTypeTreeSeperatorPKc(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2;
 L1 : while (1) {
  switch (HEAP8[i1 >> 0] | 0) {
  case 0:
  case 46:
   break L1;
  default:
   {}
  }
  i1 = i1 + 1 | 0;
 }
 return i1 - i2 | 0;
}

function __Z20getPxJoint_LocalPosePKN5physx7PxJointENS_17PxJointActorIndex4EnumE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 return;
}

function __Z13SetNbCCDPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 HEAP32[i3 + 284 + (i1 * 28 | 0) + (i2 << 2) >> 2] = i4;
 return;
}

function __ZNSt3__219__shared_mutex_base6unlockEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__25mutex4lockEv(i1);
 HEAP32[i1 + 124 >> 2] = 0;
 __ZNSt3__218condition_variable10notify_allEv(i1 + 28 | 0);
 __ZNSt3__25mutex6unlockEv(i1);
 return;
}

function __ZNK8VRDevice17GetOverrideAspectEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 168 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEixEj(i1, i2, 0);
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getMaxMotionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv(i1 + 32 | 0));
}

function __ZNK5physx18PxVehicleDriveTank8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 834990 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Umbra4Tome12getCellCountEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 136 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + i2 + (HEAP32[i1 + 144 >> 2] << 2) >> 2] | 0;
 return i2 | 0;
}

function __ZN5physx6shdfnd4Time18peekElapsedSecondsEv(i1) {
 i1 = i1 | 0;
 _gettimeofday(gb + 1457444 | 0, 0) | 0;
 return +(+(HEAP32[gb + 1457444 >> 2] | 0) + +(HEAP32[gb + 1457444 + 4 >> 2] | 0) * 1.0e-06 - +HEAPF64[i1 >> 3]);
}

function __ZN31TransformFeedbackSkinPoseBufferD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 76908 + 8;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN26AnimatorOverrideController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN26AnimatorOverrideController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN24MaterialDisplayListCache16CachedShaderPassC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 240) | 0;
 HEAP8[i1 + 240 >> 0] = 3;
 HEAP8[i1 + 241 >> 0] = 2;
 HEAP8[i1 + 242 >> 0] = 1;
 HEAP8[i1 + 243 >> 0] = 0;
 return;
}

function __ZN21UnityAnalyticsManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188476 + 8;
 __ZN21UnityAnalyticsManager15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN19SkinnedMeshRenderer11GetOptBonesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 384 | 0;
 if (HEAP32[i1 + 396 >> 2] | 0) return i2 | 0;
 __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv(i1);
 return i2 | 0;
}

function __ZN15b2CircleContact7DestroyEP9b2ContactP16b2BlockAllocator(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __ZN16b2BlockAllocator4FreeEPvi(i2, i1, 156);
 return;
}

function __ZN10PngDecoder7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 32 | 0;
 i1 = i1 + 36 | 0;
 if (HEAP32[i2 >> 2] | 0) _UNITY_png_destroy_read_struct(i2, i1, 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z21getPxAggregate_ActorsPKN5physx11PxAggregateEPPNS_7PxActorEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z16CreateRenderLoopR6Camera(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i1 = __Znwj(104) | 0;
 i2 = i1;
 i3 = i2 + 104 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function _ft_raster1_set_mode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 56 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, i2 | 0, i3 | 0) | 0;
}

function __ZZN13WheelCollider15InitializeClassEvEN38FunctorImpl_1263kForceRecreateCollider4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Collider25CreateWithoutIgnoreAttachEv(i1);
 return;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18getConstraintFlagsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE24getParticleReadDataFlagsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i1 + 32 | 0) | 0;
}

function __ZNK5Umbra14TomeCollection14getObjectCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 64 >> 2] | 0;
 return i1 | 0;
}

function __ZN9GfxDevice15ImmediateVertexEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 __ZN13DrawImmediate6VertexEfff(HEAP32[i1 + 4408 >> 2] | 0, f2, f3, f4);
 return;
}

function __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 175480 + 8;
 HEAP32[gb + 1460028 >> 2] = (HEAP32[gb + 1460028 >> 2] | 0) + -1;
 __ZN17WeakPtrSharedDataD2Ev(i1);
 return;
}

function __ZN6Camera6SetFovEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP8[i1 + 1087 >> 0] = 0;
 HEAPF32[i1 + 292 >> 2] = f2;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx6shdfnd28atomicCompareExchangePointerEPPVvPvS4_(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) HEAP32[i3 >> 2] = i4;
 return i1 | 0;
}

function __ZN5physx3Ext14SphericalJoint22setSphericalJointFlagsENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[(HEAP32[i2 + 80 >> 2] | 0) + 116 >> 1] = HEAP16[i1 >> 1] | 0;
 return;
}

function __ZN5physx2Sn5ConvX6read32ERPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 4;
 i1 = HEAP32[i3 >> 2] | 0;
 __ZN5physx2Sn5ConvX6outputEi(i2, i1);
 return i1 | 0;
}

function __ZN5physx2Sn5ConvX6read16ERPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i3 + 2;
 i1 = HEAP16[i3 >> 1] | 0;
 __ZN5physx2Sn5ConvX6outputEs(i2, i1);
 return i1 | 0;
}

function __ZN5physx2Sc9ClothCore26setCentrifugalInertiaScaleENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx22PxDefaultFileInputDataD0Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 HEAP32[i2 >> 2] = gb + 87616 + 8;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 if (!i1) {
  __ZdlPv(i2);
  return;
 }
 _fclose(i1) | 0;
 __ZdlPv(i2);
 return;
}

function __ZN4Mesh14UploadMeshDataEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) HEAP8[i1 + 41 >> 0] = 0;
 __ZN4Mesh14ClearSkinCacheEv(i1);
 __ZN4Mesh18UpdateVertexFormatEv(i1);
 __ZN4Mesh18CreateMeshIfNeededEv(i1);
 return;
}

function __ZN18ScreenManagerWebGL13SetShowCursorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 _JS_Cursor_SetShow(i2 | 0);
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN18PlatformEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK18PlatformEffector2D21CalculateContactStateERN10Effector2D15EffectorContactE(i1, i2);
 return;
}

function __ZN15ReplacementPass20AcquireRendererSceneERK19SharedRendererScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN14SafeBinaryRead4WalkERK16TypeTreeIteratorPi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib(i2, i1 + 16 | 0, i3, (HEAP32[i1 >> 2] & 512 | 0) != 0);
 return;
}

function __ZN13GfxDeviceNull12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return;
}

function __ZN11UnityEngine7Connect13AppStartEventC2Ev(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1040626 | 0, 1);
 HEAP32[i1 >> 2] = gb + 188976 + 8;
 return;
}

function __ZN10systeminfo13SupportsAudioEv() {
 var i1 = 0;
 i1 = __Z9GetIAudiov() | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0) != 0;
 return i1 | 0;
}

function __Z59QualitySettings_Get_Custom_PropBillboardsFaceCameraPositionv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 83 >> 0] | 0;
}

function __Z42UnityAdsSettings_CUSTOM_SetPlatformEnabledih(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16UnityAdsSettings18SetPlatformEnabledE15RuntimePlatformb(__Z19GetUnityAdsSettingsv() | 0, i1, i2 << 24 >> 24 != 0);
 return;
}

function __Z40GUIUtility_Get_Custom_PropHasModalWindowv() {
 var i1 = 0;
 i1 = HEAP32[(__Z11GetGUIStatev() | 0) + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 24 >> 2] | 0) != 0 & 1;
 return i1 | 0;
}

function __Z36Event_CUSTOM_Internal_SetNativeEvent13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 __ZN8GUIState24Internal_SetManagedEventEPv(__Z19GetSpecificGUIStatei(HEAP32[i1 + 40 >> 2] | 0) | 0, i1);
 return;
}

function __Z33VRDevice_Get_Custom_PropIsPresentv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZNK8VRDevice18GetDeviceConnectedEv(__Z12GetIVRDevicev() | 0) | 0) & 1;
 return i1 | 0;
}

function __Z26scripting_class_get_objectP11Il2CppClass(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = _il2cpp_class_get_type(i1 | 0) | 0;
  if (!i1) i1 = 0; else i1 = _il2cpp_type_get_object(i1 | 0) | 0;
 }
 return i1 | 0;
}

function __Z20FromInternalInfinityi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 1:
  {
   i1 = 2;
   break;
  }
 case 0:
  {
   i1 = 4;
   break;
  }
 case 3:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = 8;
 }
 return i1 | 0;
}

function __Z19getPxMeshScaleScalePKN5physx11PxMeshScaleE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 8 >> 2];
 return;
}

function _UNITY_png_fixed(i2, d1, i3) {
 i2 = i2 | 0;
 d1 = +d1;
 i3 = i3 | 0;
 d1 = +Math_floor(+(d1 * 1.0e5 + .5));
 if (d1 > 2147483647.0 | d1 < -2147483648.0) _UNITY_png_fixed_error(i2, i3); else return ~~d1 | 0;
 return 0;
}

function _posix_openpt(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = _open(gb + 1073916 | 0, i1, i2) | 0;
 STACKTOP = i2;
 return i1 | 0;
}

function _ft_smooth_set_mode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 56 >> 2] | 0) + 12 >> 2] | 0, HEAP32[i1 + 52 >> 2] | 0, i2 | 0, i3 | 0) | 0;
}

function _ferror(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  i2 = (___lockfile(i1) | 0) == 0;
  i1 = (HEAP32[i1 >> 2] | 0) >>> 5 & 1;
 } else i1 = (HEAP32[i1 >> 2] | 0) >>> 5 & 1;
 return i1 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4initEPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base4initEPv(i1, i2);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = -1;
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4initEPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base4initEPv(i1, i2);
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = -1;
 return;
}

function __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474596 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474572 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15messages_bynameIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476340 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_15messages_bynameIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476332 | 0) | 0);
 return;
}

function __ZNK8VRDevice15GetDisableVSyncEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 152 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK8GUIStyle23CalcSizeWithConstraintsER10GUIContentRK8Vector2f(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZNK8GUIStyle10DoCalcSizeER10GUIContentRK8Vector2f(i1, i2, i3, i4);
 return;
}

function __ZNK5physx2Sq12BucketPruner9visualizeERNS_2Cm12RenderOutputEj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx2Sq16BucketPrunerCore9visualizeERNS_2Cm12RenderOutputEj(i3 + 16 | 0, i2, i1);
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getMaxMotionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv(i1 + 32 | 0));
}

function __ZNK5physx16PxVehicleNoDrive8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 833702 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx16PxVehicleDriveNW8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 834943 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx16PxVehicleDrive4W8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 835156 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Umbra14TomeCollection12getGateCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx9NpPhysics17createClothFabricERKNS_17PxClothFabricDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx9NpFactory17createClothFabricERKNS_17PxClothFabricDescE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx2Sc9ClothCore25setAngularDragCoefficientENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN5physx10PxsContext13updateIslandsEfPNS_10PxBaseTaskE(i3, f1, i2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 __ZN5physx16PxsIslandManager13updateIslandsEPNS_10PxBaseTaskEj(i3 + 6172 | 0, i2, 0);
 return;
}

function __ZN23SharedMeshRenderingData17CreateIndexBufferEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 HEAP32[i1 + 8 >> 2] = mftCall_ii(HEAP32[(HEAP32[i2 >> 2] | 0) + 216 >> 2] | 0, i2 | 0) | 0;
 return;
}

function __ZN19LowerResBlitTextureD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN19CharacterController9GetCenterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 96 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 100 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 104 >> 2];
 return;
}

function __ZN16ReflectionProbes27IsRealtimeReflectionEnabledEv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return (HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 82 >> 0] | 0) != 0 | 0;
}

function __ZN15DirectorManager20FixedAdvanceTimeFuncEP14AdvanceTimeJobj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN18PlayableController4TickEf(HEAP32[i1 + (i2 << 2) >> 2] | 0, Math_fround(HEAPF32[gb + 1188444 >> 2]));
 return;
}

function __ZN14DetailDatabase21RemoveDetailPrototypeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 937237 | 0, 0, gb + 932993 | 0, 672, 1, 0, 0, 0);
 return;
}

function __ZN14BillboardAssetD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 40 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13RendererScene28SceneAfterCullingOutputReadyEPK9IndexListPK16RendererCullData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13RendererScene16UpdateVisibilityEPK9IndexList(HEAP32[gb + 1112704 >> 2] | 0, i1);
 return;
}

function __ZN13GfxDeviceGLES14DisableScissorEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 7185 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 __ZN7ApiGLES7DisableEN2gl10EnabledCapE(i1 + 4620 | 0, 13);
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 84496 + 8;
 __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv(i1 + 8 | 0);
 return;
}

function __ZN11UnityEngine7Connect12AppStopEventC2Ev(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE(i1, gb + 1040115 | 0, 1);
 HEAP32[i1 >> 2] = gb + 188896 + 8;
 return;
}

function __ZN11JpegDecoderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 43136 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __Z48setPxVehicleWheelsSimData_MinLongSlipDenominatorPN5physx22PxVehicleWheelsSimDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 __ZN5physx22PxVehicleWheelsSimData25setMinLongSlipDenominatorEf(i2, f1);
 return;
}

function __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawGUITextureRK5RectTIfEP12Il2CppObjectiiiiS4_(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return;
}

function __Z26setPxConstraint_BreakForcePN5physx12PxConstraintEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 60 >> 2] | 0, i3 | 0, +f1, +f2);
 return;
}

function _UNITY_FT_Destroy_Class_pshinter_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _pshinter_module_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function mftCall_vid(i3, i1, d2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 15 | 0)) {
  FUNCTION_TABLE_vid[i3 - fb & 15](i1 | 0, +d2);
  return;
 }
 ftCall_vid(i3 | 0, i1 | 0, +d2);
}

function _setsid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall_ret(___syscall66(66, i1 | 0) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _jpeg_destroy(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) mftCall_vi(HEAP32[i3 + 40 >> 2] | 0, i1 | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function _inet_makeaddr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do if (i1 >>> 0 < 256) i1 = i1 << 24; else if (i1 >>> 0 < 65536) {
  i1 = i1 << 16;
  break;
 } else {
  i1 = i1 << 8;
  break;
 } while (0);
 return i1 | i2 | 0;
}

function _getlogin_r(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _getlogin() | 0;
 if (!i3) i1 = 6; else if ((_strlen(i3) | 0) >>> 0 < i2 >>> 0) {
  _strcpy(i1, i3) | 0;
  i1 = 0;
 } else i1 = 34;
 return i1 | 0;
}

function _emscripten_glGetFramebufferAttachmentParameteriv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetFramebufferAttachmentParameteriv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZZN14PhysicsManager15InitializeClassEvEN28PreUpdatePhysicsUpdatestruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN14PhysicsManager6UpdateEv(__Z21GetManagerFromContexti(9) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_14collate_bynameIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474548 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_14collate_bynameIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474540 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476292 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476284 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476276 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476268 | 0) | 0);
 return;
}

function __ZNKSt3__25ctypeIcE10do_tolowerEc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1 << 24 >> 24 > -1) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_lower_tableEv() | 0) + (i1 << 24 >> 24 << 2) >> 2] & 255;
 return i1 | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE24getParticleReadDataFlagsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx15PxVehicleWheels8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 828315 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZN9Heightmap14CleanupPhysicsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 100 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN8Animator18GetAngualrVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 312 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 316 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 320 >> 2];
 return;
}

function __ZN8Animator13ClearPlayableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = gb + 37528 | 0;
 i2 = HEAP32[i3 + 4 >> 2] | 0;
 i1 = i1 + 628 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 >> 2];
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore17getPxParticleBaseEv(i1) {
 i1 = i1 | 0;
 return ((HEAP8[i1 + 10 >> 0] | 0) == 2 ? i1 + (HEAP32[gb + 1097392 + 28 >> 2] | 0) | 0 : i1 + (HEAP32[gb + 1097392 + 24 >> 2] | 0) | 0) | 0;
}

function __ZN5physx13NpClothFabric15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc15ClothFabricCore15exportExtraDataERNS_22PxSerializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN26AnimatorControllerPlayable21SetOverrideControllerEP26AnimatorOverrideController(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 84 >> 2] = i2;
 __ZN26AnimatorControllerPlayable13GenerateGraphEv(i1);
 return;
}

function __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP16[i1 + 4 >> 1] = i3;
 HEAP16[i1 + 6 >> 1] = i4;
 return;
}

function __ZN18UnityPropertySheet11UnityTexEnvC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i1 + 4 >> 2] = 1065353216;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN18SpeedTreeWindAsset13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20SpeedTreeWindManager18RegisterGlobalWindER13SpeedTreeWind(HEAP32[gb + 1170600 >> 2] | 0, i1 + 32 | 0);
 return;
}

function __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 64 >> 2] = Math_fround(inf);
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN16b2ContactManager20FlushPendingContactsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 80 | 0;
 HEAP8[i2 >> 0] = 1;
 __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i1, i1);
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN14TerrainManager23TryGetSplatBaseMaterialEP7Terrain(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i2 + 112 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 72 >> 2] | 0;
 return i2 | 0;
}

function __ZN12PhysXRaycast12CleanupClassEv() {
 var i1 = 0;
 i1 = __Z19GetRaycastInterfacev() | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 __Z19SetRaycastInterfaceP8IRaycast(0);
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient10ReleaseWWWEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 32 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN3WWW7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN10PngDecoderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 43108 + 8;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZL28GeomMTDCallback_NotSupportedRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_(i4, i1, i2, i5, i3, i6) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i5 = i5 | 0;
 i3 = i3 | 0;
 i6 = i6 | 0;
 return 0;
}

function __Z47SystemInfo_Get_Custom_PropGraphicsDeviceVersionv() {
 var i1 = 0;
 i1 = (__Z15GetGraphicsCapsv() | 0) + 48 | 0;
 return __Z20scripting_string_newPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function __Z36setPxVehicleDriveDynData_AnalogInputPN5physx21PxVehicleDriveDynDataEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i2, i1, f3);
 return;
}

function __Z34setPxVehicleAutoBoxData_DownRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i3 + 128 + (i2 << 2) >> 2] = f1;
 return;
}

function __Z32getPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricEPjj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z32Gizmos_CUSTOM_INTERNAL_get_colorP10ColorRGBAf(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 1065353216;
 HEAP32[i1 + 4 >> 2] = 1065353216;
 HEAP32[i1 + 8 >> 2] = 1065353216;
 HEAP32[i1 + 12 >> 2] = 1065353216;
 return;
}

function __Z27RegisterAllowNameConversionPKcS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z27RegisterAllowNameConversionR20AllowNameConversionsPKcS2_S2_(HEAP32[gb + 1166132 >> 2] | 0, i1, i2, i3);
 return;
}

function __Z26getPxD6Joint_DriveVelocityPKN5physx9PxD6JointERNS_6PxVec3ES4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 184 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z18ToInternalInfinityi(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
  {
   i1 = 1;
   break;
  }
 case 4:
  {
   i1 = 0;
   break;
  }
 case 0:
  {
   i1 = 3;
   break;
  }
 default:
  i1 = 2;
 }
 return i1 | 0;
}

function _UNITY_png_set_packing(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 if ((HEAPU8[i1 + 432 >> 0] | 0) >= 8) return;
 i2 = i1 + 212 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 4;
 HEAP8[i1 + 433 >> 0] = 8;
 return;
}

function _UNITY_ft_validator_init(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function b59(i1, i2, i3, i4, i5, i6, i7, i8, i9, i10) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 i10 = i10 | 0;
 nullFunc_viiiiiiiiii(59);
}

function b138(i1, i2, i3, f4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_iiiifiiiii(138);
 return 0;
}

function _pause() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall_ret(___syscall29(29, i1 | 0) | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _feof(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  i2 = (___lockfile(i1) | 0) == 0;
  i1 = (HEAP32[i1 >> 2] | 0) >>> 4 & 1;
 } else i1 = (HEAP32[i1 >> 2] | 0) >>> 4 & 1;
 return i1 | 0;
}

function __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_244kDidModifyMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11ShapeModule17DidModifyMeshDataEv(i1 + 48 | 0);
 return;
}

function __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pubsetbufEPwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pubsetbufEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNKSt3__27collateIwE9transformEPKwS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function __ZNKSt3__27collateIcE9transformEPKcS3_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_viiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function __ZNK7Terrain11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 return;
}

function __ZNK5physx2Sc5Scene32getMaxNbConstraintDataBlocksUsedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv((HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 44 | 0) | 0;
}

function __ZNK5physx19PxClothFabricCooker4saveERNS_14PxOutputStreamEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx18PxFabricCookerImpl4saveERNS_14PxOutputStreamEb(HEAP32[i3 >> 2] | 0, i2, 0);
 return;
}

function __ZNK5physx19NpArticulationJoint28getTwistLimitContactDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 4096 | 0) == 0 ? i1 + 164 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 116 | 0) >> 2]);
}

function __ZNK5physx14PxVehicleDrive8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 828300 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx14PxTriangleMesh8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 753858 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx14PxArticulation8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 765118 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK25ThreadsafeLinearAllocator21GetReservedMemorySizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
 return Math_imul(HEAP32[i1 + 48 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
}

function __ZN8Animator17GetTargetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 336 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 340 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 344 >> 2];
 return;
}

function __ZN7Joint2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 40 >> 0] = 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(inf);
 HEAPF32[i1 + 48 >> 2] = Math_fround(inf);
 return;
}

function __ZN5physx6shdfnd13ReadWriteLock10lockWriterEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0;
 i1 = (HEAP32[i1 >> 2] | 0) + 4 | 0;
 do {} while ((HEAP32[i1 >> 2] | 0) != 0);
 return;
}

function __ZN5physx3Ext13RevoluteJoint21setRevoluteJointFlagsENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[(HEAP32[i2 + 80 >> 2] | 0) + 132 >> 1] = HEAP16[i1 >> 1] | 0;
 return;
}

function __ZN5physx2Sc9ClothCore24setLinearDragCoefficientENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx25PxVehicleConstraintShader19visualiseConstraintERNS_22PxConstraintVisualizerEPKvRKNS_11PxTransformES7_j(i5, i3, i1, i2, i4) {
 i5 = i5 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5physx22XmlMemoryAllocatorImpl10deallocateEPh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) return;
 __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj(i2 + 8 | 0, i1 + -8 | 0, HEAP32[i1 + -4 >> 2] | 0);
 return;
}

function __ZN24OcclusionCullingSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24OcclusionCullingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN24EllipsoidParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN21AudioDistortionFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN18BaseUnityAnalyticsC2ER22BaseUnityConnectClient(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 188396 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 return;
}

function __ZN17AnimationPlayable18SetInputConnectionEP8Playablei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZN8Playable18SetInputConnectionEPS_i(i1, i2, i3) | 0;
 HEAP8[i1 + 56 >> 0] = 1;
 return i3 | 0;
}

function __ZN15AudioEchoFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 44 >> 2] = 500;
 HEAPF32[i1 + 48 >> 2] = Math_fround(.5);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 HEAPF32[i1 + 56 >> 2] = Math_fround(1.0);
 return;
}

function __ZN14VertexDataInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 100 | 0;
 i2 = i1 + 100 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZN14PhysicsManager26SetDefaultSolverIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 HEAP32[i1 + 168 >> 2] = (i2 | 0) < 1 ? 1 : (i2 | 0) > 255 ? 255 : i2;
 return;
}

function __ZN14AssetReferenceC2E4PPtrI6ObjectE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 __ZN21AssetReferenceStorage12AddReferenceEi(HEAP32[gb + 1162408 >> 2] | 0, i2);
 return;
}

function __ZN13MemoryManager15GetLargestAllocERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 3824 + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
 return HEAP32[i2 >> 2] | 0;
}

function __ZN13GfxDeviceNull13ReadbackImageER14ImageReferenceiiiiii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return 1;
}

function __ZN13ComputeShader18GetConstantBuffersE17GfxDeviceRendereri(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (__ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, i2, i3) | 0) + 20 | 0;
}

function __ZN11AudioFilter6GetDSPEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 40 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 | 0) return i3 | 0;
 __ZN11AudioFilter4InitEv(i1);
 i3 = HEAP32[i2 >> 2] | 0;
 return i3 | 0;
}

function __Z48Caching_Get_Custom_PropMaximumAvailableDiskSpacev() {
 var i1 = 0;
 i1 = __ZN14CachingManager28GetMaximumDiskSpaceAvailableEv(__Z17GetCachingManagerv() | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __Z46SystemInfo_Get_Custom_PropGraphicsDeviceVendorv() {
 var i1 = 0;
 i1 = (__Z15GetGraphicsCapsv() | 0) + 16 | 0;
 return __Z20scripting_string_newPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function __Z45QualitySettings_Get_Custom_PropShadowDistancev() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 36 >> 2]);
}

function __Z33setPxCloth_MotionConstraintConfigPN5physx7PxClothERKNS_29PxClothMotionConstraintConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 236 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z19getPxPhysics_ShapesPKN5physx9PxPhysicsEPPNS_7PxShapeEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z19getPxPhysics_ScenesPKN5physx9PxPhysicsEPPNS_7PxSceneEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0, 0) | 0;
}

function __Z15CleanupVRModulev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1469188 >> 2] | 0;
 if (i1 | 0) __ZN8VRModuleD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63816 | 0);
 HEAP32[gb + 1469188 >> 2] = 0;
 return;
}

function _UNITY_FT_Destroy_Class_psnames_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _psnames_module_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function b118(i1, i2, i3, f4, i5, i6, f7, f8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 f8 = Math_fround(f8);
 nullFunc_iiiifiiff(118);
 return 0;
}

function _pshinter_module_class_pic_free(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 200 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (!i3) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i3);
 HEAP32[i2 >> 2] = 0;
 return;
}

function _glVertexAttribPointer__wrapper(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 _glVertexAttribPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function _emscripten_glUniform4f__wrapper(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 _emscripten_glUniform4f(i1 | 0, +f2, +f3, +f4, +f5);
}

function _emscripten_glDrawElementsInstanced__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _emscripten_glDrawElementsInstanced(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZlsRK8Scalar4fi(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Ejjjj(i1, HEAP32[i3 >> 2] << i2, HEAP32[i3 + 4 >> 2] << i2, HEAP32[i3 + 8 >> 2] << i2, HEAP32[i3 + 12 >> 2] << i2);
 return;
}

function __ZZN12MeshRenderer15InitializeClassEvEN28FunctorImpl_99kDidDeleteMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 344 >> 2] = 0;
 return;
}

function __ZNSt3__28ios_base34__set_failbit_and_consider_rethrowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 4;
 if (!(HEAP32[i1 + 20 >> 2] & 4)) return; else ___cxa_rethrow();
}

function __ZNSt3__26locale5__imp7installINS_12ctype_bynameIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474588 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_12ctype_bynameIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474556 | 0) | 0);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_9basic_iosIwS2_EES6_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_9basic_iosIcS2_EES6_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_9basic_iosIwS2_EES6_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_9basic_iosIcS2_EES6_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i4 = i4 - i3 | 0;
 return (i4 >>> 0 < i5 >>> 0 ? i4 : i5) | 0;
}

function __ZNK6Camera11GetPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform11GetPositionEv(i1, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i2 + 28 >> 2] | 0, gb + 28940 | 0) | 0);
 return;
}

function __ZNK5physx19NpArticulationJoint28getSwingLimitContactDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 256 | 0) == 0 ? i1 + 140 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 100 | 0) >> 2]);
}

function __ZNK5physx13PxHeightField8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 753780 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx13PxClothFabric8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 764826 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK19SkinnedMeshRenderer16GetBindposeCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 356 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 156 >> 2] | 0;
 return i1 | 0;
}

function __ZNK11RemoveByPtr17ShouldRemoveStateEP14AnimationState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i2 + 96 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
 return i2 | 0;
}

function __ZN9Rigidbody7SetDragEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 72 >> 2] = f2;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN8Animator16GetPivotPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 324 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 328 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 332 >> 2];
 return;
}

function __ZN8Animator16GetDeltaPositionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 272 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 276 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 280 >> 2];
 return;
}

function __ZN5physx9NpPhysics18createTriangleMeshERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx13GuMeshFactory18createTriangleMeshERNS_13PxInputStreamE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 834286;
 HEAP32[i1 + 4 >> 2] = 550;
 HEAP32[i1 + 8 >> 2] = fb + 2410;
 HEAP32[i1 + 12 >> 2] = fb + 3952;
 return;
}

function __ZN5physx3Ext19ProfileEventHandler12onEventValueERKNS_16PxProfileEventIdEjyx(i7, i1, i2, i3, i4, i5, i6) {
 i7 = i7 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return;
}

function __ZN5physx2Sc9ClothCore22setAngularInertiaScaleENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene7endStepEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 76 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1 & 2147483647;
 i1 = i1 + 80 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN21ProceduralTextureData23SetSubstanceShuffledUIDEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 40 | 0;
 i3 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN21LightProbeProxyVolumeD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 34500 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15FileSystemEntry9MakeLocalEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 1040 >> 2] | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i3 >> 2] | 0) + 144 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0) | 0;
}

function __ZN13GfxDeviceGLES14SetWorldMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9GfxDevice14SetWorldMatrixERK10Matrix4x4f(i1, i2);
 i2 = i1 + 6620 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 return;
}

function __ZN12TLSAllocatorI14StackAllocatorE10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1103852 >> 2] | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return;
}

function __ZN11UnityEngine7Connect20BasePersistentValues13RestoreValuesER8JSONRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11UnityEngine7Connect20BasePersistentValues18TransferBaseValuesI8JSONReadEEvRT_(i1, i2);
 return;
}

function __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij(i1, i2, i3, 0);
 return;
}

function __ZL25ResetEllipsoidEmitterRandv() {
 HEAP32[gb + 1469384 >> 2] = 3;
 HEAP32[gb + 1469384 + 4 >> 2] = 1142332464;
 HEAP32[gb + 1469384 + 8 >> 2] = 2077314801;
 HEAP32[gb + 1469384 + 12 >> 2] = -1318445546;
 return;
}

function __Z55QualitySettings_Get_Custom_PropRealtimeReflectionProbesv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 82 >> 0] | 0;
}

function __Z33IsNonMonoBehaviourUnityEngineTypeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return (__Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 264 >> 2] | 0) | 0) ^ 1 | 0;
}

function __Z26setPxD6Joint_DriveVelocityPN5physx9PxD6JointENS_6PxVec3ES2_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 180 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z20getPxShape_MaterialsPKN5physx7PxShapeEPPNS_10PxMaterialEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z19GetActiveColorSpacev() {
 var i1 = 0;
 if (!(__Z20GetPlayerSettingsPtrv() | 0)) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = __ZNK14PlayerSettings13GetColorSpaceEv(__Z17GetPlayerSettingsv() | 0) | 0;
 return i1 | 0;
}

function __Z17SetupObjectMatrixRK10Matrix4x4fi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = __Z12GetGfxDevicev() | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 104 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z14GetLightProbesv() {
 var i1 = 0;
 if (!(__Z22GetLightmapSettingsPtrv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN16LightmapSettings14GetLightProbesEv(__Z19GetLightmapSettingsv() | 0) | 0;
 return i1 | 0;
}

function _UNITY_png_start_read_image(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 if (!(HEAP32[i1 + 208 >> 2] & 64)) {
  _UNITY_png_read_start_row(i1);
  return;
 } else {
  _UNITY_png_app_error(i1, gb + 353340 | 0);
  return;
 }
}

function _cff_get_is_cid(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 656 >> 2] | 0;
 HEAP8[i2 >> 0] = 0;
 if (!i1) return 0;
 if ((HEAP32[i1 + 1456 >> 2] | 0) == 65535) return 0;
 HEAP8[i2 >> 0] = 1;
 return 0;
}

function __ZThn24_N5physx2Sc21ConstraintInteractionD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -24 | 0;
 HEAP32[i1 >> 2] = gb + 90796 + 8;
 HEAP32[i1 + 24 >> 2] = gb + 90796 + 48;
 __ZN5physx2Sc16ActorInteractionD2Ev(i1);
 return;
}

function __ZNSt3__28ios_base33__set_badbit_and_consider_rethrowEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 if (!(HEAP32[i1 + 20 >> 2] & 1)) return; else ___cxa_rethrow();
}

function __ZNK7b2Joint8IsActiveEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP16[(HEAP32[i1 + 48 >> 2] | 0) + 4 >> 1] & 32)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP16[(HEAP32[i1 + 52 >> 2] | 0) + 4 >> 1] & 32) != 0;
 return i1 | 0;
}

function __ZNK5physx12PxConvexMesh8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 753930 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx12PxConstraint8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 829242 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZN9GfxDevice23UploadSparseTextureTileE9TextureIDiiiPKhii(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return;
}

function __ZN9GfxDevice12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return;
}

function __ZN5physx6PxVec3C2Efff(i4, f1, f2, f3) {
 i4 = i4 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 HEAPF32[i4 >> 2] = f1;
 HEAPF32[i4 + 4 >> 2] = f2;
 HEAPF32[i4 + 8 >> 2] = f3;
 return;
}

function __ZN5physx5cloth10deallocateEPv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = __ZN5physx6shdfnd12getAllocatorEv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc9ClothCore25setSelfCollisionStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 328 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx2Sc9ClothCore21setLinearInertiaScaleENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene15deleteAggregateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx14PxsAABBManager15deleteAggregateEj(HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0, i1);
 return;
}

function __ZN5physx20PxsParticleSystemSim13setSimulatedVEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 1108 >> 0] = i1 & 1;
 if (i1) return;
 __ZN5physx20PxsParticleSystemSim24clearParticleConstraintsEv(i2);
 return;
}

function __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb(i4, i3, i2, i1, 1) | 0;
}

function __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity17ConfigurableJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN25MultiBlocksMemoryFileData6UnlockEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[HEAP32[i1 + 20 >> 2] >> 2] | 0) == (i2 | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 8 | 0);
 return;
}

function __ZN22BaseUnityConnectClient30OnEnteringStatePausedOrStoppedEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 __ZN22BaseUnityConnectClient17SaveSessionValuesEv(i1);
 return;
}

function __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return 0;
}

function __ZN19ConstantBuffersGLESC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN19AudioHighPassFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN18CrashReportManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188668 + 8;
 __ZN18CrashReportManager15ThreadedCleanupEv(i1);
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN15AudioReverbZone14SetMinDistanceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 48 >> 2] = f2;
 __ZN15AudioReverbZone12VerifyValuesEv(i1);
 __ZN15AudioReverbZone13SetFMODValuesEv(i1);
 return;
}

function __ZN15AudioReverbZone14SetMaxDistanceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 52 >> 2] = f2;
 __ZN15AudioReverbZone12VerifyValuesEv(i1);
 __ZN15AudioReverbZone13SetFMODValuesEv(i1);
 return;
}

function __ZN13TextRendering4Font13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20TextRenderingPrivate8FontImpl17AwakeFromLoadImplE17AwakeFromLoadMode(HEAP32[i1 + 48 >> 2] | 0, i2);
 return;
}

function __ZN13MemoryManager13GetAllocCountERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 3824 + ((HEAP32[i2 >> 2] | 0) * 24 | 0) + 20 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2];
 return HEAP32[i2 >> 2] | 0;
}

function __ZN12TreeDatabase19RemoveTreePrototypeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 937237 | 0, 0, gb + 933103 | 0, 457, 1, 0, 0, 0);
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher37SetupSessionContainerToDispatchStaticEPv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv(i1);
 return;
}

function __ZL35GeomOverlapCallback_MeshHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z9RecordJobPFvPvES_R21SingleThreadedJobInfo(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 + 12 >> 2] = i1;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = 0;
 HEAP32[i3 + 8 >> 2] = 0;
 return;
}

function __Z52QualitySettings_Get_Custom_PropAsyncUploadBufferSizev() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 104 >> 2] | 0;
}

function __Z48setPxVehicleDifferentialNWData_DrivenWheelStatusPN5physx27PxVehicleDifferentialNWDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx27PxVehicleDifferentialNWData20setDrivenWheelStatusEj(i2, i1);
 return;
}

function __Z48setPxArticulationJoint_TwistLimitContactDistancePN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z48setPxArticulationJoint_SwingLimitContactDistancePN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z44getPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj(i1, i2));
}

function __Z44getPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj(i1, i2));
}

function __Z36GeomOverlapCallback_PlaneHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z35setPxScene_CCDContactModifyCallbackPN5physx7PxSceneEPNS_26PxCCDContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z32GetPlayerSettingsRunInBackgroundv() {
 var i1 = 0;
 if (!(__Z20GetPlayerSettingsPtrv() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(__Z17GetPlayerSettingsv() | 0) + 388 >> 0] | 0) != 0;
 return i1 | 0;
}

function __Z32AudioMixerDuckingDestroyCallbackP21UnityAudioEffectState(i1) {
 i1 = i1 | 0;
 i1 = i1 + 28 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63328 | 0);
 HEAP32[i1 >> 2] = 0;
 return 0;
}

function __Z16MarkObjectAsRootPK6ObjectR27GarbageCollectorThreadState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 4 >> 2] | 0, i2);
 return;
}

function _Direct_Move_Orig_Y(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = (HEAP32[i2 + 12 >> 2] | 0) + ((i3 & 65535) << 3) + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
 return;
}

function _emscripten_glFramebufferTexture2D__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _emscripten_glFramebufferTexture2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZThn32_NK17BillboardRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + -32 + 360 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 return i2 | 0;
}

function __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -132 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -128 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -124 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -120 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -116 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZSt12__unexpectedPFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 mftCall_v(i1 | 0);
 _abort_message(gb + 1088294 | 0, i2);
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputnEPKwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputnEPKci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNSt3__211timed_mutexC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 76 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 HEAP8[i1 + 76 >> 0] = 0;
 return;
}

function __ZNKSt3__25ctypeIcE10do_toupperEc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1 << 24 >> 24 > -1) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_upper_tableEv() | 0) + ((i1 & 255) << 2) >> 2] & 255;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = (HEAP32[i1 + 8 >> 2] & 2147483647) + -1 | 0; else i1 = 10;
 return i1 | 0;
}

function __ZNK5physx7NpScene16getSpuDispatcherEv(i1) {
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx7NpScene16getGpuDispatcherEv(i1) {
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx7NpScene16getCpuDispatcherEv(i1) {
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx14NpArticulation17releaseDriveCacheERNS_24PxArticulationDriveCacheE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx2Sc16ArticulationCore17releaseDriveCacheERNS_9PxcFsDataE(i2 + 24 | 0, i1);
 return;
}

function __ZNK5physx11PxAggregate8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 747736 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK15FileSystemEntry7IsLocalEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(HEAP32[gb + 1179016 >> 2] | 0) + 4 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZN9Texture2D24AcquireSharedTextureDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 if (!i1) return i1 | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZN8Material26SetGlobalIlluminationFlagsE31MaterialGlobalIlluminationFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 96 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN8DrawUtil31CleanupDrawMeshRawFromNodeQueueER15RenderNodeQueuej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17MeshRenderingData7ReleaseEv(HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 * 360 | 0) + 328 >> 2] | 0);
 return;
}

function __ZN7Texture7ReleaseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 64 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i2;
 if (i2 | 0) return;
 __Z19DestroySingleObjectP6Object(i1);
 return;
}

function __ZN5physx9NpPhysics17createHeightFieldERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx13GuMeshFactory17createHeightFieldERNS_13PxInputStreamE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx6shdfnd4Time19getCounterFrequencyEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 1;
 HEAP32[i2 + 4 >> 2] = 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 10;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN5physx2Sc9ClothCore24setSelfCollisionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 320 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx2Sc9ClothCore21setDampingCoefficientENS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene15setScratchBlockEPvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx10PxsContext15setScratchBlockEPvj(HEAP32[(HEAP32[i3 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1, i2);
 return;
}

function __ZN5physx2Gu13RTreeMidphase15importExtraDataERNS_24PxDeserializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Gu5RTree15importExtraDataERNS_24PxDeserializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN4FMOD7SystemI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (!i4) return 0;
 HEAP32[i4 >> 2] = 1e5;
 return 0;
}

function __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return 0;
}

function __ZN17GeneralConnection10ConnectionD2Ev(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv(i1);
 __ZN20BufferedSocketStreamD2Ev(i1 + 20 | 0);
 return;
}

function __ZN16ParticleRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN16ParticleRenderer16GenerateUVFramesEv(i1);
 return;
}

function __ZN13SliderJoint2D12SetUseLimitsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 117 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN16b2PrismaticJoint11EnableLimitEb(i1, i2);
 return;
}

function __ZN13GfxDeviceGLES28GetNativeVertexBufferPointerEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZN13GfxDeviceGLES13SetViewMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9GfxDevice13SetViewMatrixERK10Matrix4x4f(i1, i2);
 i2 = i1 + 6620 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 3;
 return;
}

function __ZN12SkinMeshInfoC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 92 | 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 HEAP8[i3 >> 0] = 1;
 return;
}

function __ZN12NavMeshAgent12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager13RegisterAgentER12NavMeshAgentRi(__Z17GetNavMeshManagerv() | 0, i1, i1 + 88 | 0);
 __ZN12NavMeshAgent16AddToCrowdSystemEv(i1);
 return;
}

function __Z57GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_MoveWindowiRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5IMGUI20MoveWindowFromLayoutER8GUIStateiRK5RectTIfE(__Z11GetGUIStatev() | 0, i1, i2);
 return;
}

function __Z52QualitySettings_Get_Custom_PropParticleRaycastBudgetv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 92 >> 2] | 0;
}

function __Z51QualitySettings_Get_Custom_PropAsyncUploadTimeSlicev() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 100 >> 2] | 0;
}

function __Z35Physics_CUSTOM_IgnoreLayerCollisioniih(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14PhysicsManager15IgnoreCollisionEiib(__Z17GetPhysicsManagerv() | 0, i1, i2, i3 << 24 >> 24 != 0);
 return;
}

function __Z24PlayerEmitCanvasGeometryv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1115296 + 408 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 404 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __Z23SetClothingSceneGravityRK8Vector3f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1459016 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z18getPxD6Joint_DrivePKN5physx9PxD6JointENS_9PxD6Drive4EnumE(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0);
 return;
}

function __Z17getPxJoint_ActorsPKN5physx7PxJointERPNS_12PxRigidActorES5_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 28 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z13SetCopyBufferRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(gb + 1103764 | 0, i1) | 0;
 return;
}

function _UNITY_FT_Done_FreeType(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) {
  i1 = 33;
  return i1 | 0;
 }
 i2 = HEAP32[i1 >> 2] | 0;
 _UNITY_FT_Done_Library(i1) | 0;
 _UNITY_FT_Done_Memory(i2);
 i1 = 0;
 return i1 | 0;
}

function b134(f1, f2, f3, f4, f5, f6, i7) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 nullFunc_vffffffi(134);
}

function _tt_property_get(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (_strcmp(i2, gb + 1008266 | 0) | 0) {
  i3 = 12;
  return i3 | 0;
 }
 HEAP32[i3 >> 2] = HEAP32[i1 + 64 >> 2];
 i3 = 0;
 return i3 | 0;
}

function _iswpunct(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 < 131072) i1 = (HEAPU8[((HEAPU8[(i1 >>> 8) + (gb + 1063093) >> 0] | 0) << 5 | i1 >>> 3 & 31) + (gb + 1063093) >> 0] | 0) >>> (i1 & 7) & 1; else i1 = 0;
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdateFinishFrameRenderingstruct7ForwardEv() {
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 if (__Z11IsBatchmodev() | 0) return;
 __Z12PlayerRenderb(0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateUpdateInputManagerstruct7ForwardEv() {
 if (!(__Z23IsWorldPlayingThisFramev() | 0)) return;
 __ZN12InputManager12ProcessInputEv(__Z15GetInputManagerv() | 0);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetnEPwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetnEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNSt3__211__libcpp_dbC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore16getContactOffsetEv(i1 + 32 | 0));
}

function __ZNK5physx10PxMaterial8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 763461 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5Umbra9IndexList7getSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return ((i2 | 0) <= (i1 | 0) ? i2 : i1) | 0;
}

function __ZNK5Umbra9FloatList7getSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return ((i2 | 0) <= (i1 | 0) ? i2 : i1) | 0;
}

function __ZNK5Umbra4Path11getNumNodesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return ((i2 | 0) <= (i1 | 0) ? i2 : i1) | 0;
}

function __ZNK23ArchiveStorageConverter13GetBlocksInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i2) return 0; else return ((HEAP8[i1 + 56 >> 0] | 0) == 0 ? 0 : i2 + 88 | 0) | 0;
 return 0;
}

function __ZN9DepthPass20AcquireRendererSceneERK19SharedRendererScene(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 4 | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + 1;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN8Playable29SetPlayableDeleteOnDisconnectEPS_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 52 | 0;
 if (!i1) return;
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -3 | (i2 & 1) << 1 & 65535;
 return;
}

function __ZN8GUIState12GetControlIDEi9FocusTypeRK5RectTIfE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb(i1, i2, i3, i4, 1) | 0;
}

function __ZN5physx22XmlMemoryAllocatorImpl8allocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __ZN5physx19CVariableMemoryPool8allocateEj(i2 + 8 | 0, i1) | 0;
 return i2 | 0;
}

function __ZN4crnd12symbol_codecC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN22ParticleSystemRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN22ParticleSystemRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN22NavMeshProjectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return;
}

function __ZN17AudioChorusFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14Texture2DArray13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 4 | 0) == 4) if (!(HEAP32[i1 + 96 >> 2] | 0)) return;
 __ZN14Texture2DArray13UploadTextureEv(i1);
 return;
}

function __ZN14GfxDeviceStats11ClientStats5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN14AnimationState13CleanupCurvesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 4 | 0;
 if (HEAP16[i1 + 56 >> 1] & 16) {
  i1 = HEAP32[i2 >> 2] | 0;
  if (i1 | 0) __ZdaPv(i1);
 }
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN13SliderJoint2D11SetUseMotorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 116 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN16b2PrismaticJoint11EnableMotorEb(i1, i2);
 return;
}

function __ZN13GfxDeviceGLES27GetNativeIndexBufferPointerEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[(HEAP32[i2 + 28 >> 2] | 0) + 4 >> 2] | 0;
 return i2 | 0;
}

function __ZN11dtPathQueue18setStaleInProgressEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) return;
 if (!(HEAP32[i1 + 60 >> 2] & 536870912)) return;
 HEAP32[i1 + 68 >> 2] = 0;
 return;
}

function __ZN10GameObject13SetSelfActiveEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) {
  __ZN10GameObject8ActivateEv(i1);
  return;
 } else {
  __ZN10GameObject10DeactivateE19DeactivateOperation(i1, 0);
  return;
 }
}

function __ZL35ResetRandSeedForMeshParticleEmitterv() {
 HEAP32[gb + 1477044 >> 2] = 4;
 HEAP32[gb + 1477048 >> 2] = -1340201579;
 HEAP32[gb + 1477052 >> 2] = -2129358646;
 HEAP32[gb + 1477056 >> 2] = 471808435;
 return;
}

function __Z53VRSettings_Set_Custom_PropRenderViewportScaleInternalf(f1) {
 f1 = Math_fround(f1);
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice22SetRenderViewportScaleEf(__Z12GetIVRDevicev() | 0, f1);
 return;
}

function __Z51QualitySettings_Get_Custom_PropAnisotropicFilteringv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 68 >> 2] | 0;
}

function __Z40setPxHeightFieldGeometryHeightFieldFlagsPN5physx21PxHeightFieldGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 20 >> 0] = HEAP8[i1 >> 0] | 0;
 return;
}

function __Z38setPxParticleBase_SimulationFilterDataPN5physx14PxParticleBaseERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z33Screen_Set_Custom_PropOrientation17ScreenOrientation(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z31CommandBuffer_CUSTOM_InitBufferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(180) | 0;
 __ZN22RenderingCommandBufferC2ERK10MemLabelId(i2, gb + 63536 | 0);
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z31CalculateImageSizeForTypicalGPUii13TextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __Z18CalculateImageSizeii13TextureFormat(i1, i2, (i3 | 0) == 3 | (i3 | 0) == 8 ? 5 : i3) | 0;
}

function __Z27getPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z27GetPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0, i3 | 0, i2 | 0) | 0;
}

function __Z25GetNbModifiedContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i3 + 480 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0;
}

function _UNITY_png_set_write_user_transform_fn(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = i1 + 212 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1048576;
 HEAP32[i1 + 192 >> 2] = i2;
 return;
}

function _UNITY_TT_Set_CodeRange(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 + -1 | 0;
 HEAP32[i1 + 444 + (i2 << 3) >> 2] = i3;
 HEAP32[i1 + 444 + (i2 << 3) + 4 >> 2] = i4;
 return;
}

function b42(i1, f2, i3, f4, i5, f6, f7, i8) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 i8 = i8 | 0;
 nullFunc_vifififfi(42);
}

function _glRenderbufferStorageMultisample__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glRenderbufferStorageMultisample(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function ___signbit(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = _bitshift64Lshr(HEAP32[tempDoublePtr >> 2] | 0, HEAP32[tempDoublePtr + 4 >> 2] | 0, 63) | 0;
 getTempRet0() | 0;
 return i2 | 0;
}

function ___cosdf(d1) {
 d1 = +d1;
 var d2 = 0.0;
 d1 = d1 * d1;
 d2 = d1 * d1;
 return Math_fround(1.0 - d1 * .499999997251031 + d2 * .04166662332373906 + d1 * d2 * (d1 * 2.439044879627741e-05 + -.001388676377460993));
}

function __ZZN6Camera15InitializeClassEvEN31FunctorImpl_99kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 1076 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN36UpdateScriptRunBehaviourUpdatestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z19GetBehaviourManagerv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn8_N5physx13NpClothFabricD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 106864 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 106864 + 112;
 __ZN5physx2Sc15ClothFabricCoreD2Ev(i1 + 16 | 0);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEPNS_13basic_ostreamIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 return i1 | 0;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEPNS_13basic_ostreamIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 72 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setpEPwS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = i3;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setpEPcS4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = i3;
 return;
}

function __ZNK5physx7NpShape13getOwnerSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 20 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE(i1) | 0;
 return i1 | 0;
}

function __ZNK5physx12NpConstraint23getMinResponseThresholdEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 20 >> 2] & 8)) i1 = i1 + 92 | 0; else i1 = (HEAP32[i1 + 24 >> 2] | 0) + 20 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZNK16DeveloperConsole15IsVisibleNoLockEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 24 >> 2] | 0)) if (!(HEAP32[i1 + 12 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 >> 0] | 0) == 0;
 return i1 | 0;
}

function __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z21GetManagerFromContexti(5) | 0;
 return HEAP32[(HEAP32[i2 + 168 >> 2] | 0) + (HEAP32[i1 + 24 >> 2] << 2) >> 2] | 0;
}

function __ZN8VRDevice16SetDeviceEnabledEb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[gb + 1469188 >> 2] | 0)) return;
 i2 = __Z12GetIVRDevicev() | 0;
 if (!i2) return;
 __ZN8VRDevice10SetEnabledEb(i2, i1);
 return;
}

function __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx9NpPhysics16createConvexMeshERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx13GuMeshFactory16createConvexMeshERNS_13PxInputStreamE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx2Sn9XmlParser10deallocateEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) return;
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 12 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc9ClothCore22setSleepLinearVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 360 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN5physx2Sc9ClothCore22setFrictionCoefficientEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx14NpSpatialIndexD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 107520 + 8;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Unity5Cloth12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z23GetLateBehaviourManagerv() | 0, i1 + 372 | 0, -1);
 HEAP8[i1 + 358 >> 0] = 1;
 return;
}

function __ZN5Umbra6Double8isFiniteERKd(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 d2 = +HEAPF64[i1 >> 3];
 return d2 <= 1797693134862315708145274.0e284 & (d2 >= -1797693134862315708145274.0e284 & (d2 == d2 & 0.0 == 0.0)) | 0;
}

function __ZN5Umbra4PathC2EPNS0_4NodeEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra19getRuntimeInfoValueENS_9InfoValueE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 1:
 case 0:
  {
   i1 = 3;
   break;
  }
 case 2:
  {
   i1 = 16;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN4FMOD8ChannelI8getDelayE14FMOD_DELAYTYPEPjS2_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i3 | 0) HEAP32[i3 >> 2] = 0;
 if (!i4) return 0;
 HEAP32[i4 >> 2] = 0;
 return 0;
}

function __ZN27GenericSlowGarbageCollector18GenerateInstanceIDEi17TransferMetaFlags(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN27GenericSlowGarbageCollector16ProcessReferenceEi(i1, i2);
 return i2 | 0;
}

function __ZN12_GLOBAL__N_111storeBoundsI8Scalar4fEEvPfRKN5physx5cloth11BoundingBoxIT_EE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __Z5storePfRK8Scalar4f(i2, i1);
 __Z5storePfRK8Scalar4f(i2 + 12 | 0, i1 + 16 | 0);
 return;
}

function __ZN12HingeJoint2D12SetUseLimitsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 113 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN15b2RevoluteJoint11EnableLimitEb(i1, i2);
 return;
}

function __Z43getPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i1, i2) | 0) ^ 1 | 0;
}

function __Z40setPxArticulationJoint_TargetOrientationPN5physx19PxArticulationJointERKNS_6PxQuatE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z33VRSettings_Get_Custom_PropEnabledv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZNK8VRDevice10GetEnabledEv(__Z12GetIVRDevicev() | 0) | 0) & 1;
 return i1 | 0;
}

function __Z25setPxPrismaticJoint_LimitPN5physx16PxPrismaticJointERKNS_22PxJointLinearLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z25GetNbDiscreteContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i3 + 88 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0;
}

function __Z18EnsureRadiusIsSaneRf(i1) {
 i1 = i1 | 0;
 var f2 = f0, f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 f2 = Math_fround(HEAPF32[gb + 1452812 >> 2]);
 if (!(f3 > f2)) return;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __Z17setPxJoint_ActorsPN5physx7PxJointEPNS_12PxRigidActorES3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 24 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function _Unity_FT_Done_FreeType(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return 0;
 i2 = HEAP32[i1 >> 2] | 0;
 _UNITY_FT_Done_Library(i1) | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63392 | 0);
 return 0;
}

function _UNITY_tt_face_free_sbit(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i1 + 104 >> 2] | 0, i1 + 724 | 0);
 HEAP32[i1 + 728 >> 2] = 0;
 HEAP32[i1 + 732 >> 2] = 0;
 HEAP32[i1 + 736 >> 2] = 0;
 return;
}

function _UNITY_FT_Stream_Free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = HEAP32[i1 + 28 >> 2] | 0;
 _UNITY_FT_Stream_Close(i1);
 if (i2 | 0) return;
 _UNITY_ft_mem_free(i3, i1);
 return;
}

function _unzeof(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -102;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 156 >> 2] | 0;
 if (!i1) {
  i1 = -102;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 92 >> 2] | 0) == 0 & 1;
 return i1 | 0;
}

function _towctrans(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 switch (i2 | 0) {
 case 1:
  {
   i1 = _towupper(i1) | 0;
   break;
  }
 case 2:
  {
   i1 = _towlower(i1) | 0;
   break;
  }
 default:
  {}
 }
 return i1 | 0;
}

function _isatty(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = STACKTOP;
 STACKTOP = STACKTOP + 64 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i1 = (_tcgetattr(i1, i2) | 0) == 0 & 1;
 STACKTOP = i2;
 return i1 | 0;
}

function _gzclearerr(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = i1 + 56 | 0;
 if ((HEAP32[i2 >> 2] | 0) != 1) HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 _clearerr(HEAP32[i1 + 64 >> 2] | 0);
 return;
}

function ___ftello(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) {
  i2 = (___lockfile(i1) | 0) == 0;
  i1 = ___ftello_unlocked(i1) | 0;
 } else i1 = ___ftello_unlocked(i1) | 0;
 return i1 | 0;
}

function __ZNSt3__26locale5__imp7installINS_8numpunctIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474596 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8numpunctIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474572 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8messagesIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476340 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_8messagesIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1476332 | 0) | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw(i1, i2);
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_(i1, i2) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc(i1, i2);
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_(i1, i2) | 0;
}

function __ZNK5physx6shdfnd6Socket10isBlockingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!(HEAP8[i1 + 14 >> 0] | 0)) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 15 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore26getCentrifugalInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore16getContactOffsetEv(i1 + 32 | 0));
}

function __ZNK5physx19NpArticulationJoint22getTangentialStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 1024 | 0) == 0 ? i1 + 148 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 108 | 0) >> 2]);
}

function __ZN9Transform8GetSceneEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!(HEAP32[i1 + 104 >> 2] | 0)) while (1) {
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 return HEAP32[i1 + 116 >> 2] | 0;
}

function __ZN8Animator11GetVelocityEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 300 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 304 >> 2];
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 + 308 >> 2];
 return;
}

function __ZN6Camera17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN21IntermediateRenderers5ClearEj(HEAP32[i1 + 1132 >> 2] | 0, 0);
 __ZN13RenderManager12RemoveCameraEP6Camera(__Z16GetRenderManagerv() | 0, i1);
 return;
}

function __ZN5physx2Sc9ClothCore21setStiffnessFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx2Sc9ClothCore21setCollisionMassScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 220 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx2Sc5Scene22setNbContactDataBlocksEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx17PxcNpMemBlockPool13setBlockCountEj((HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 44 | 0, i1);
 return;
}

function __ZN5physx13NpVolumeCache7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpScene18releaseVolumeCacheEPNS_13NpVolumeCacheE(__ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(HEAP32[i1 + 80 >> 2] | 0) | 0, i1);
 return;
}

function __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN11TypeManager19ClassNameToTypeInfoEPKcb(HEAP32[gb + 1110260 >> 2] | 0, i1, (i2 | 0) == 1) | 0;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN21WorldParticleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN21LightProbeProxyVolume8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN20UnloadSceneOperationD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65964 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 68 | 0);
 __ZN14AsyncOperationD2Ev(i1);
 return;
}

function __ZN15ConstantForce2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 154808 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15AudioEchoFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15AnchoredJoint2D31SetAutoConfigureConnectedAnchorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 92 >> 0] = i2 & 1;
 if (!(HEAP32[i1 + 60 >> 2] | 0)) return;
 __ZN7Joint2D8ReCreateEb(i1, 0);
 return;
}

function __ZN14VehiclesModule21GetColliderForVehicleEPN5physx16PxVehicleNoDriveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj(i2 + 72 | 0, i3) | 0;
}

function __ZN14CachingManager28GetMaximumDiskSpaceAvailableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 + 4 >> 2] | 0) + 32 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZN12HingeJoint2D11SetUseMotorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 112 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN15b2RevoluteJoint11EnableMotorEb(i1, i2);
 return;
}

function __ZN12AdsIdHandler28ScheduleJobToFetchAsyncAdsIdEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 41 >> 0] = 1;
 __ZN18BackgroundJobQueue11ScheduleJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3301 | 0, i1);
 return;
}

function __ZN11TextureData5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __Z9pqIsEmptyP9PriorityQ(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i1 = 0;
  i1 = i1 & 1;
  return i1 | 0;
 }
 i1 = (HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0) == 0;
 i1 = i1 & 1;
 return i1 | 0;
}

function __Z49QualitySettings_Get_Custom_PropMasterTextureLimitv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 64 >> 2] | 0;
}

function __Z33setPxArticulationJoint_ParentPosePN5physx19PxArticulationJointERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z26getPxConstraint_BreakForcePKN5physx12PxConstraintERfS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 64 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __Z24setPxRevoluteJoint_LimitPN5physx15PxRevoluteJointERKNS_23PxJointAngularLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_set_mem_fn(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 HEAP32[i1 + 604 >> 2] = i2;
 HEAP32[i1 + 608 >> 2] = i3;
 HEAP32[i1 + 612 >> 2] = i4;
 return;
}

function _UNITY_TT_Get_HMetrics(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_viiiii(HEAP32[(HEAP32[i1 + 532 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function _UNITY_FT_Destroy_Class_sfnt_module_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _sfnt_module_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function _Direct_Move_Orig_X(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = (HEAP32[i2 + 12 >> 2] | 0) + ((i3 & 65535) << 3) | 0;
 HEAP32[i3 >> 2] = (HEAP32[i3 >> 2] | 0) + i4;
 return;
}

function _tre_set_empty(i1) {
 i1 = i1 | 0;
 i1 = ___tre_mem_alloc_impl(i1, 0, 0, 1, 32) | 0;
 if (!i1) i1 = 0; else {
  HEAP32[i1 >> 2] = -1;
  HEAP32[i1 + 4 >> 2] = -1;
  HEAP32[i1 + 8 >> 2] = -1;
 }
 return i1 | 0;
}

function _remainder(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 var i3 = 0;
 i3 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 d2 = +_remquo(d1, d2, i3);
 STACKTOP = i3;
 return +d2;
}

function __ZZN8VRModuleC1EvEN10playerQuit7ForwardEv() {
 var i1 = 0;
 if (!(__Z12GetIVRDevicev() | 0)) return;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn4_N12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE(i1 + -4 | 0, i2);
 return;
}

function __ZThn28_N14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj(i1 + -28 | 0, i2, i3);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7collateIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474548 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_7collateIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474540 | 0) | 0);
 return;
}

function __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj(i1, i2, i3);
 HEAP32[i1 >> 2] = gb + 212468 + 8;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEjw(i1, i2, 0);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc(i1, i2, 0);
 return;
}

function __ZNKSt3__214error_category10equivalentERKNS_10error_codeEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ((HEAP32[i2 >> 2] | 0) == (i3 | 0) ? (HEAP32[i2 + 4 >> 2] | 0) == (i1 | 0) : 0) | 0;
}

function __ZNK8VRDevice12GetNativePtrEv(i1) {
 i1 = i1 | 0;
 if (!(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 200 >> 2] | 0;
 return i1 | 0;
}

function __ZNK8Animator25GetLayersAffectMassCenterEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(HEAP32[i1 + 128 >> 2] | 0) + 17 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore25getAngularDragCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx19NpArticulationJoint13getOwnerSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK5physx14NpRigidDynamic25getStabilizationThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 2048 | 0) == 0 ? i1 + 212 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 176 | 0) >> 2]);
}

function __ZNK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 84 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK20BufferedSocketStream11IsConnectedEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 19 >> 0] | 0) if (HEAP32[i1 + 72 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 18 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK15MonoScriptCache6RetainEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache(__Z19GetScriptingManagerv() | 0, i1);
 return;
}

function __ZN8PlayableC2E18DirectorPlayerType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 37536 + 8;
 __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType(i1, 0, 0, i2);
 return;
}

function __ZN6Socket15SetSocketOptionEiiPvj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return __Z15setsockopt_stubiiiPKvj(HEAP32[i1 + 4 >> 2] | 0, i2, i3, i4, i5) | 0;
}

function __ZN5physx2Sn9XmlParser12processCloseEPKcjRb(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 + 16 | 0;
 HEAP32[i4 >> 2] = HEAP32[(HEAP32[i4 >> 2] | 0) + 20 >> 2];
 return 1;
}

function __ZN5physx2Gu13RTreeMidphase15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Gu5RTree15exportExtraDataERNS_22PxSerializationContextE(i2 + 16 | 0, i1);
 return;
}

function __ZN5physx23SetMFrictionVsSlipGraphEPNS_17PxVehicleTireDataEjjf(i3, i1, i2, f4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 f4 = Math_fround(f4);
 HEAPF32[i3 + 16 + (i1 << 3) + (i2 << 2) >> 2] = f4;
 return;
}

function __ZN24OcclusionCullingSettings17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN13RendererScene27CleanupPVSAndRequestRebuildEv(__Z16GetRendererScenev() | 0);
 __ZN11GameManager17MainThreadCleanupEv(i1);
 return;
}

function __ZN21AudioDistortionFilter6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD3DSP12setParameterEif(i2, 0, Math_fround(HEAPF32[i1 + 44 >> 2])) | 0;
 return;
}

function __ZN18AudioLowPassFilter26SetCutoffFrequencyInternalEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) return;
 __ZN4FMOD3DSP12setParameterEif(i1, 0, f2) | 0;
 return;
}

function __ZN17RemapPPtrTransfer11PopMetaFlagEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 24 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2 + -4;
 HEAP32[i1 + 36 >> 2] = HEAP32[i2 + -8 >> 2];
 return;
}

function __ZN17AnimationCurveTplIfE15InvalidateCacheEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 4 >> 2] = Math_fround(inf);
 HEAP32[i1 >> 2] = 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(inf);
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN14ParticleSystem22SetUsesRotationalSpeedEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (HEAP8[i1 + 869 >> 0] | 0) return;
 __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv(i1);
 return;
}

function __ZN14ParticleSystem22SetUsesInitialVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (HEAP8[i1 + 872 >> 0] | 0) return;
 __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv(i1);
 return;
}

function __ZN13MonoBehaviour18ReleaseScriptCacheEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 56 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZNK15MonoScriptCache7ReleaseEv(i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceGLES20GetVertexDeclarationERK18VertexChannelsInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 7384 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP32[i1 + 8 >> 2] = 100;
 HEAP32[i1 + 12 >> 2] = 10;
 HEAP32[i1 + 16 >> 2] = 500;
 return;
}

function __ZN11UnityEngine15PlatformWrapper14GetRendererAPIEv() {
 var i1 = 0;
 if (!(__Z11IsGfxDevicev() | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher5PauseEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 if ((HEAP32[i1 >> 2] | 0) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 2;
 i1 = 1;
 return i1 | 0;
}

function __ZN11RadixSorterC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = __Znaj(4096) | 0;
 HEAP32[i1 + 4 >> 2] = __Znaj(1024) | 0;
 return;
}

function __ZL30GeomOverlapCallback_PlanePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z46setPxPrismaticJoint_ProjectionAngularTolerancePN5physx16PxPrismaticJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z45LightProbeGroup_Get_Custom_PropProbePositionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z23GetCoreScriptingClassesv() | 0) + 456 >> 2] | 0, 12, 0) | 0;
}

function __Z38QualitySettings_Get_Custom_PropLodBiasv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 84 >> 2]);
}

function __Z36setPxMaterial_RestitutionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z32setPxVehicleAutoBoxData_UpRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i3 + (i2 << 2) >> 2] = f1;
 return;
}

function __Z32setPxArticulationJoint_ChildPosePN5physx19PxArticulationJointERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z29setPxSphericalJoint_LimitConePN5physx16PxSphericalJointERKNS_16PxJointLimitConeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z23NormalizeInputCharactert(i1) {
 i1 = i1 | 0;
 switch (i1 << 16 >> 16) {
 case 13:
 case 3:
  {
   i1 = 10;
   break;
  }
 case 127:
 case 8:
  {
   i1 = 8;
   break;
  }
 default:
  {}
 }
 return i1 | 0;
}

function __Z20PlayerUpdateCanvasesv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1115296 + 396 >> 2] | 0;
 if (i1 | 0) mftCall_v(i1 | 0);
 i1 = HEAP32[gb + 1115296 + 400 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function _ps_hints_done(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 _ps_dimension_done(i1 + 16 | 0, i2);
 _ps_dimension_done(i1 + 52 | 0, i2);
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function _cf2_freeSeacComponent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i2 + 4 | 0;
 _cff_free_glyph_data(HEAP32[i1 + 4 >> 2] | 0, i3, (HEAP32[i2 + 8 >> 2] | 0) - (HEAP32[i3 >> 2] | 0) | 0);
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_8ios_baseES5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_8ios_baseES5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_8ios_baseES5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_8ios_baseES5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_ii(i2 | 0, i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0) | 0;
 return i1 | 0;
}

function __ZNK5physx7PxShape8isKindOfEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!(_strcmp(gb + 690295 | 0, i1) | 0)) {
  i2 = 1;
  return i2 | 0;
 }
 i2 = (_strcmp(i1, gb + 827530 | 0) | 0) == 0;
 return i2 | 0;
}

function __ZNK5physx2Sc9ClothCore24getLinearDragCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 100 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx19NpArticulationJoint20getTwistLimitEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[((HEAP32[i1 + 12 >> 2] & 8192 | 0) == 0 ? i1 + 168 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 120 | 0) >> 0] | 0) != 0 | 0;
}

function __ZNK5physx19NpArticulationJoint20getTangentialDampingEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 2048 | 0) == 0 ? i1 + 152 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 112 | 0) >> 2]);
}

function __ZNK5physx14NpRigidDynamic25getContactReportThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 128 | 0) == 0 ? i1 + 172 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 128 | 0) >> 2]);
}

function __ZNK13MonoBehaviour18IsScriptableObjectEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = ((HEAP32[i1 + 28 >> 2] | 0) + -1 | 0) >>> 0 < 2;
 return i1 | 0;
}

function __ZNK10Collider2D15GetAttachedBodyEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 72 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[HEAP32[i1 + 60 >> 2] >> 2] | 0) + 28 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx9NpPhysics17createClothFabricERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx9NpFactory17createClothFabricERNS_13PxInputStreamE(HEAP32[gb + 1457204 >> 2] | 0, i1) | 0;
}

function __ZN5physx6shdfnd21atomicCompareExchangeEPViii(i3, i4, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i3 >> 2] | 0;
 if ((i1 | 0) == (i2 | 0)) HEAP32[i3 >> 2] = i4;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx34PxClothParticleDataGeneratedValuesC2EPKNS_19PxClothParticleDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx2Sc7Physics13registerClothEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i1 >> 2] = __ZN5physx5cloth7Factory13createFactoryENS1_8PlatformEPv(0, 0) | 0;
 return;
}

function __ZN5Unity14CharacterJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity14CharacterJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5Light7PrecalcEv(i1) {
 i1 = i1 | 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData7PrecalcEv(HEAP32[i1 + 44 >> 2] | 0);
 __ZN5Light9SetupHaloEv(i1);
 __ZN5Light10SetupFlareEv(i1);
 return;
}

function __ZN23TransformChangeDispatchD2Ev(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 16 >> 2] | 0) <= -1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20UnityConnectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN20OcclusionCullingData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20OcclusionCullingData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19ScriptingInvocation6InvokeIP12Il2CppStringEET_PP15Il2CppExceptionb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i2, i3) | 0;
}

function __ZN19ScriptingInvocation6InvokeIP12Il2CppObjectEET_PP15Il2CppExceptionb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i2, i3) | 0;
}

function __ZN14dtPathCorridor14SetPathPartialEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (i2) i1 = i1 | 2; else i1 = i1 & 253;
 HEAP8[i3 >> 0] = i1;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper10getTopNameEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) {
  i1 = gb + 1576256 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 return i1 | 0;
}

function __ZN12_GLOBAL__N_110DataStream15isInstanceValidEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 64 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __ZN12CubemapArray13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 4 | 0) == 4) if (!(HEAP32[i1 + 92 >> 2] | 0)) return;
 __ZN12CubemapArray13UploadTextureEv(i1);
 return;
}

function __ZN10SampleClip14ReleaseIfEqualE11SoundHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 56 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (HEAP32[i2 >> 2] | 0)) return;
 __ZN11SoundHandle7ReleaseEv(i1);
 return;
}

function __ZL29GeomOverlapCallback_PlaneMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z47QualitySettings_Get_Custom_PropShadowResolutionv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 24 >> 2] | 0;
}

function __Z47QualitySettings_Get_Custom_PropShadowProjectionv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 28 >> 2] | 0;
}

function __Z45setPxSphericalJoint_ProjectionLinearTolerancePN5physx16PxSphericalJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z45setPxPrismaticJoint_ProjectionLinearTolerancePN5physx16PxPrismaticJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z42setPxArticulationJoint_TangentialStiffnessPN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 104 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z37setPxArticulationJoint_TargetVelocityPN5physx19PxArticulationJointERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z32setPxScene_ContactModifyCallbackPN5physx7PxSceneEPNS_23PxContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z30GetGUIStateCurrentDisplayIndexv() {
 var i1 = 0;
 i1 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i1 | 0) <= -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 1468320 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z29CompletedReadObjectFromVectorR6Object(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 0);
 return;
}

function _UNITY_png_set_invalid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = i2 + 8 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) return;
 HEAP32[i4 >> 2] = HEAP32[i4 >> 2] & ~i3;
 return;
}

function _UNITY_FT_Destroy_Class_cff_driver_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _cff_driver_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}
function stackAlloc(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + i2 | 0;
 STACKTOP = STACKTOP + 15 & -16;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abortStackOverflow(i2 | 0);
 return i1 | 0;
}

function __ZNSt3__26locale5__imp7installINS_5ctypeIwEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474588 | 0) | 0);
 return;
}

function __ZNSt3__26locale5__imp7installINS_5ctypeIcEEEEvPT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__26locale5__imp7installEPNS0_5facetEl(i1, i2, __ZNSt3__26locale2id5__getEv(gb + 1474556 | 0) | 0);
 return;
}

function __ZNK9HPlayable7IsValidEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i2 + 16 >> 2] | 0) == (HEAP32[i1 + 4 >> 2] | 0);
 return i2 | 0;
}

function __ZNK5physx19NpArticulationJoint21getExternalComplianceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 128 | 0) == 0 ? i1 + 128 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 96 | 0) >> 2]);
}

function __ZNK5physx19NpArticulationJoint20getSwingLimitEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[((HEAP32[i1 + 12 >> 2] & 512 | 0) == 0 ? i1 + 144 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 104 | 0) >> 0] | 0) != 0 | 0;
}

function __ZNK5Umbra14TomeCollection9serializeERNS_12OutputStreamE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5Umbra17ImpTomeCollection9serializeERNS_12OutputStreamE((i1 | 0) == 0 ? 0 : i1 + 3 & -4, i2) | 0;
}

function __ZNK13GfxDeviceGLES27GetActiveRenderColorSurfaceEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0) + 212 + (i2 << 2) >> 2] | 0;
}

function __ZNK11dtPathQueue16getRequestStatusEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  i2 = -2147483648;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 60 >> 2] | 0;
 return i2 | 0;
}

function __ZN9Rigidbody27SetMaxDepenetrationVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 216 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN8Animator40SetAllowConstantClipSamplingOptimizationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 560 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN5physx6shdfnd6Socket7connectEPKctj(i3, i1, i2, i4) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i4 = i4 | 0;
 return __ZN5physx6shdfnd10SocketImpl7connectEPKctj(HEAP32[i3 + 4 >> 2] | 0, i1, i2, i4) | 0;
}

function __ZN5physx2Sc9ClothCore18setSolverFrequencyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __ZN5physx10PxsContext17registerParticlesEv() {
 HEAP32[gb + 1098848 >> 2] = fb + 161;
 HEAP32[gb + 1098848 + 4 >> 2] = 0;
 HEAP32[gb + 1098856 >> 2] = fb + 408;
 HEAP32[gb + 1098856 + 4 >> 2] = 0;
 return;
}

function __ZN5Umbra15getAPIInfoValueENS_9InfoValueE(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 1:
 case 0:
  {
   i1 = 3;
   break;
  }
 case 2:
  {
   i1 = 16;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN22BaseUnityConnectClient31InvokeDonePreparingOnMainThreadEv(i1) {
 i1 = i1 | 0;
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(__Z21GetBackgroundJobQueuev() | 0, fb + 3934 | 0, i1);
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13GetActivePoolEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[((HEAP32[i1 + 36 >> 2] | 0) >>> 0 > i2 >>> 0 ? i1 + 40 | 0 : i1 + 48 | 0) + 4 >> 2] | 0;
}

function __ZN19ScriptingInvocation6InvokeIP11Il2CppArrayEET_PP15Il2CppExceptionb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb(i1, i2, i3) | 0;
}

function __ZN18ProfilerConnection7CleanupEv() {
 var i1 = 0;
 __ZN18ProfilerConnection17RemoveConnectionsEv(0);
 i1 = HEAP32[gb + 1163256 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 HEAP32[gb + 1163256 >> 2] = 0;
 return;
}

function __ZN18AudioLowPassFilter6UpdateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD3DSP12setParameterEif(i2, 1, Math_fround(HEAPF32[i1 + 132 >> 2])) | 0;
 return;
}

function __ZN18AnimatorController52OnInvalidateAnimatorControllerAndRebuildDependenciesEv(i1) {
 i1 = i1 | 0;
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZN15DirectorManager10CreateNodeEv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63784 | 0, 16, gb + 582681 | 0, 935) | 0;
 HEAP32[i1 + 16 >> 2] = 10;
 HEAP32[i1 + 20 >> 2] = 0;
 return i1 | 0;
}

function __ZN14ParticleSystem21SetUsesAxisOfRotationEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (HEAP8[i1 + 868 >> 0] | 0) return;
 __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv(i1);
 return;
}

function __ZN14AnimationState15SetClonedCurvesERS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 56 | 0;
 HEAP16[i3 >> 1] = HEAP16[i3 >> 1] & -17;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 + 4 >> 2];
 return;
}

function __ZN13ScreenManager18SetAllowCursorLockEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 26 >> 0] = i2 & 1;
 if (i2) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN13ScreenManager18SetAllowCursorHideEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 25 >> 0] = i2 & 1;
 if (i2) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, 1);
 return;
}

function __ZN13MonoBehaviour10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13MonoBehaviour17StopAllCoroutinesEv(i1);
 __ZN9Behaviour10DeactivateE19DeactivateOperation(i1, i2);
 return;
}

function __ZN13ComputeShader10GetKernelsE17GfxDeviceRendereri(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (__ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri(i1, i2, i3) | 0) + 8 | 0;
}

function __ZN12WheelJoint2D11SetUseMotorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 116 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) return;
 __ZN12b2WheelJoint11EnableMotorEb(i1, i2);
 return;
}

function __ZN12IFileAdapter4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i2 + 1052 >> 2] = HEAP32[i1 + 4 >> 2];
 return 1;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue11ResetValuesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 1;
 HEAP32[i1 + 4 >> 2] = 100;
 HEAP32[i1 + 8 >> 2] = 10;
 HEAP32[i1 + 12 >> 2] = 500;
 return;
}

function __ZL28GeomOverlapCallback_MeshMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE(i2, i4, i3, i5, i1) {
 i2 = i2 | 0;
 i4 = i4 | 0;
 i3 = i3 | 0;
 i5 = i5 | 0;
 i1 = i1 | 0;
 return 0;
}

function __Z59QualitySettings_Set_Custom_PropBillboardsFaceCameraPositionh(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings31SetBillboardsFaceCameraPositionEb(__Z18GetQualitySettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z46QualitySettings_Get_Custom_PropPixelLightCountv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 16 >> 2] | 0;
}

function __Z46QualitySettings_Get_Custom_PropMaximumLODLevelv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 88 >> 2] | 0;
}

function __Z45setPxRevoluteJoint_ProjectionAngularTolerancePN5physx15PxRevoluteJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z34setPxTriangleMeshGeometryMeshFlagsPN5physx22PxTriangleMeshGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 32 >> 0] = HEAP8[i1 >> 0] | 0;
 return;
}

function __Z21setPxJoint_BreakForcePN5physx7PxJointEff(i3, f1, f2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 mftCall_viff(HEAP32[(HEAP32[i3 >> 2] | 0) + 52 >> 2] | 0, i3 | 0, +f1, +f2);
 return;
}

function __Z21ScheduleMainThreadJobPFvPvES_10JobGroupID(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_vi(i2 | 0, i3 | 0);
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function mftCall_vdd(i3, d1, d2) {
 i3 = i3 | 0;
 d1 = +d1;
 d2 = +d2;
 if ((i3 | 0) >= (fb | 0) & (i3 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vdd[i3 - fb & 1](+d1, +d2);
  return;
 }
 ftCall_vdd(i3 | 0, +d1, +d2);
}

function _self_destruct(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 _free_pool(i1, 1);
 _free_pool(i1, 0);
 i2 = i1 + 4 | 0;
 _jpeg_free_small(i1, HEAP32[i2 >> 2] | 0, 84);
 HEAP32[i2 >> 2] = 0;
 _jpeg_mem_term(i1);
 return;
}

function _grayscale_convert_21(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _jcopy_sample_rows(HEAP32[i2 >> 2] | 0, i3, i4, 0, i5, HEAP32[i1 + 92 >> 2] | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKw(i1, i2) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEPKw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw(i1, i2) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc(i1, i2) | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc(i1, i2) | 0;
}

function __ZNK9ShaderLab7Program11IsSupportedEPK6Shader(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 204 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP32[i1 + 20 >> 2] | 0) != 0;
 return i2 | 0;
}

function __ZNK5physx2Sc9ClothCore22getAngularInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx2Sc5Scene29getMaxNbContactDataBlocksUsedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx17PxcNpMemBlockPool20getMaxUsedBlockCountEv((HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 44 | 0) | 0;
}

function __ZNK5physx2Sc5Scene26getBounceThresholdVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(-Math_fround(__ZNK5physx10PxsContext18getBounceThresholdEv(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0)));
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore13getRestOffsetEv(i1 + 32 | 0));
}

function __ZNK5physx19NpArticulationJoint21getInternalComplianceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 64 | 0) == 0 ? i1 + 124 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 92 | 0) >> 2]);
}

function __ZNK5physx12NpConstraint9getActorsERPNS_12PxRigidActorES3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i3 + 8 >> 2];
 HEAP32[i2 >> 2] = HEAP32[i3 + 12 >> 2];
 return;
}

function __ZNK28MonoBehaviourPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 100001;
}

function __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i1, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN9Coroutine17SetMoveNextMethodE21ScriptingMethodIl2Cpp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 return;
}

function __ZN7mecanim9animation16GetWeightsDirectERKNS0_23BlendDirectDataConstantEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 _memset(i2 | 0, 0, i1 << 2 | 0) | 0;
 return;
}

function __ZN6Camera21ResetProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1081 >> 0] = 1;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 HEAP8[i1 + 1082 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext21InertiaTensorComputerC2Eb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) return;
 i1 = i2 + 52 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i1 | 0));
 return;
}

function __ZN5physx12NpConstraint20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZN5physx11NpAggregate18removeArticulationERNS_14PxArticulationE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx11NpAggregate29removeArticulationAndReinsertERNS_14PxArticulationEb(i2, i1, 1) | 0;
}

function __ZN4FMOD7SystemI19getStreamBufferSizeEPjS1_(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = (i2 | 0) == 0;
 if (!((i3 | 0) != 0 | i1 ^ 1)) return 0;
 HEAP32[i3 >> 2] = i1 ? 0 : 8;
 return 0;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN21UniformBufferTFMethod15UnmapBoneBufferEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 __ZN14DataBufferGLES5UnmapEv(HEAP32[i1 >> 2] | 0);
 __ZN14DataBufferGLES12RecordUpdateEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN19TouchPhaseEmulationD0Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 62260 + 8;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i2) {
  __ZdlPv(i1);
  return;
 }
 __ZdaPv(i2);
 __ZdlPv(i1);
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19SkinnedMeshRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19MeshParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19MeshParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19CharacterController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19CharacterController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19AssetBundleManifest8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16MessageForwarder27RegisterAllMessagesCallbackEPFvPviR11MessageDataEPFbS0_iS2_E(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 HEAP32[i1 + 28 >> 2] = i3;
 return;
}

function __ZN16MBPOS_TmpBuffersC2Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12800 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN14dtPathCorridor12SetPathValidEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 44 | 0;
 i1 = HEAP8[i3 >> 0] | 0;
 if (i2) i1 = i1 | 1; else i1 = i1 & 254;
 HEAP8[i3 >> 0] = i1;
 return;
}

function __ZN14DetailDatabase33DidThreadedLoadCreateTextureAtlasEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 4 >> 2] | 0) == 0;
 return i1 | 0;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE7SetDataEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 HEAP32[i1 + 24 >> 2] = i3;
 return;
}

function __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientProbeRK20SphericalHarmonicsL2(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings15SetAmbientProbeERK20SphericalHarmonicsL2(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z45QualitySettings_Get_Custom_PropShadowCascadesv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 32 >> 2] | 0;
}

function __Z44setPxRevoluteJoint_ProjectionLinearTolerancePN5physx15PxRevoluteJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z41setPxArticulationJoint_InternalCompliancePN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z41setPxArticulationJoint_ExternalCompliancePN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z40setPxArticulationJoint_TangentialDampingPN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z39GUIUtility_CUSTOM_GetPermanentControlIDv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[(__Z19GetSpecificGUIStatei(0) | 0) + 276 >> 2] | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i1 + 1;
 return i1 | 0;
}

function __Z33setPxRigidDynamic_KinematicTargetPN5physx14PxRigidDynamicERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 224 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z33setPxMaterial_FrictionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z31Cursor_Set_Custom_PropLockState14CursorLockMode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z29Cursor_Set_Custom_PropVisibleh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z21getPxClothFabric_SetsPKN5physx13PxClothFabricEPjj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i3 | 0, i1 | 0) | 0;
}

function __Z14CreateJobQueuePKcS0_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = __ZnwjRK10MemLabelIdiPKci(1, gb + 63200 | 0, 16, gb + 441822 | 0, 15) | 0;
 HEAP32[gb + 1162216 >> 2] = i3;
 return;
}

function _UNITY_FT_Destroy_Class_tt_driver_class(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 _tt_driver_class_pic_free(i1);
 if (!i2) return;
 _UNITY_ft_mem_free(i3, i2);
 return;
}

function mftCall_fi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 1023 | 0)) return +Math_fround(FUNCTION_TABLE_fi[i2 - fb & 1023](i1 | 0));
 return +ftCall_fi(i2 | 0, i1 | 0);
}

function b31(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_iiiiiiiiii(31);
 return 0;
}

function _tt_cmap6_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 6;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
 return 0;
}

function _tt_cmap4_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 4;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
 return 0;
}

function _tt_cmap2_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 2;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
 return 0;
}

function _tt_cmap0_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 >> 2] = (HEAPU8[i1 + 4 >> 0] | 0) << 8 | (HEAPU8[i1 + 5 >> 0] | 0);
 return 0;
}

function __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareEntriesEPKvS7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 8 >> 2] | 0) - (HEAP32[i2 + 8 >> 2] | 0) | 0;
}

function __ZZN13AudioListener15InitializeClassEvEN31FunctorImpl_179kDidAddComponent4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN13AudioListener12ApplyFiltersEv(i1);
 return;
}

function __ZZL31InitializeAudioManagerCallbacksvEN31PostLateUpdateUpdateAudiostruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z9GetIAudiov() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + -116 + 280 >> 2] = i2;
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + -116 + 256 >> 2] = i1;
 return;
}

function __ZNK5physx3Cct17CapsuleController8getStatsERNS_17PxControllerStatsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx3Cct10Controller16getInternalStatsERNS_17PxControllerStatsE(i2 + 8 | 0, i1);
 return;
}

function __ZNK5physx3Cct17CapsuleController8getStateERNS_17PxControllerStateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx3Cct10Controller16getInternalStateERNS_17PxControllerStateE(i2 + 8 | 0, i1);
 return;
}

function __ZNK5physx2Sc9ClothCore21getLinearInertiaScaleEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + ((i2 >>> 2) * 224 | 0) + 16 + ((i2 & 3) << 2) >> 2]);
}

function __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + ((i2 >>> 2) * 224 | 0) + 32 + ((i2 & 3) << 2) >> 2]);
}

function __ZNK5physx14NpArticulation13getOwnerSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK30SpriteRendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 213;
}

function __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Effff(i1, Math_fround(1.0), Math_fround(1.0), Math_fround(1.0), Math_fround(1.0));
 return;
}

function __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Effff(i1, Math_fround(0.0), Math_fround(0.0), Math_fround(0.0), Math_fround(0.0));
 return;
}

function __ZN9Coroutine16SetCurrentMethodE21ScriptingMethodIl2Cpp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 32 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP8[i1 + 4 >> 0] = HEAP8[i2 + 4 >> 0] | 0;
 return;
}

function __ZN8Material9SetShaderEP6Shader(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = i1;
 __ZN8Material17UpdateToNewShaderEb(i2, 0);
 return;
}

function __ZN6Camera19SetOrthographicSizeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 916 >> 2] = f2;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx7NpShape14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 __ZN5physx9NpFactory14onShapeReleaseEPNS_7PxShapeE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 __ZN5physx9NpDestroyERNS_3Scb4BaseE(i1 + 32 | 0);
 return;
}

function __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 _pthread_join(HEAP32[i1 + 20 >> 2] | 0, 0) | 0;
 i1 = 1;
 return i1 | 0;
}

function __ZN5physx2Sc5Scene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 5908 >> 2] = i1;
 return;
}

function __ZN5physx13NpVolumeCache10invalidateEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 88 >> 2] = 0;
 HEAP32[i1 + 100 >> 2] = 0;
 HEAP8[i1 + 117 >> 0] = 1;
 HEAP8[i1 + 116 >> 0] = 1;
 return;
}

function __ZN5Unity9Component7SetNameEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN5Unity17ConfigurableJoint25SetConfiguredInWorldSpaceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 292 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Umbra9Matrix2x29transposeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 4 | 0;
 i2 = HEAP32[i3 >> 2] | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN24MaterialDisplayListCache16CachedShaderPass15ResetMRUIndicesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 240 >> 0] = 3;
 HEAP8[i1 + 241 >> 0] = 2;
 HEAP8[i1 + 242 >> 0] = 1;
 HEAP8[i1 + 243 >> 0] = 0;
 return;
}

function __ZN19MeshParticleEmitter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 220 >> 0] = 0;
 HEAP8[i1 + 221 >> 0] = 0;
 HEAPF32[i1 + 224 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 228 >> 2] = Math_fround(0.0);
 return;
}

function __ZN16ScriptingManager14CreateInstanceEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = __Z20scripting_object_newP11Il2CppClass(i2) | 0;
 return i2 | 0;
}

function __ZN16PlayerConnection7CleanupEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163120 >> 2] | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1163120 >> 2] = 0;
 return;
}

function __ZN15MulticastSocket12SetBroadcastEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket15SetSocketOptionEiib(i1, 1, 6, i2) | 0, gb + 584686 | 0, 0, 0) | 0) ^ 1 | 0;
}

function __ZN14dtPathCorridor8freePathEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 28 | 0;
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZN14FileCacherRead15DeallocateBlockERNS_10CacheBlockE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i2 >> 2] | 0, gb + 63552 | 0);
 HEAP32[i2 >> 2] = 0;
 return;
}

function __ZN14CachingManager23GetCachingDiskSpaceUsedEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 + 4 >> 2] | 0) + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZN13RendererScene17BeginCameraRenderEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 152 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 HEAP8[i2 >> 0] = 0;
 __ZN13RendererScene15InitializeUmbraEv(i1);
 return;
}

function __ZN13PhysicsModule19CreateNxHeightFieldEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1457408 >> 2] | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZN12b2ChainShapeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 151604 + 8;
 i2 = i1 + 12 | 0;
 __Z6b2FreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_122DistanceJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN12MeshRenderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
 return;
}

function __ZN12HandlerChain5WriteER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher5CloseEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 i1 = 1;
 return i1 | 0;
}

function __ZN11SoundHandleC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[gb + 1459896 >> 2] = (HEAP32[gb + 1459896 >> 2] | 0) + 1;
 HEAP32[gb + 1459892 >> 2] = (HEAP32[gb + 1459892 >> 2] | 0) + 1;
 return;
}

function __Z45QualitySettings_Get_Custom_PropSoftVegetationv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 81 >> 0] | 0;
}

function __Z38setPxParticleBase_ExternalAccelerationPN5physx14PxParticleBaseERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z38QualitySettings_Set_Custom_PropShadowsN15QualitySettings13ShadowQualityE(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings16SetShadowQualityENS_13ShadowQualityE(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z29DeleteCachedSerializationDataP23CachedSerializationData(i1) {
 i1 = i1 | 0;
 if (i1 | 0) __ZN23CachedSerializationDataD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63496 | 0);
 return;
}

function __Z20ReleaseScreenManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1158216 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 HEAP32[gb + 1158216 >> 2] = 0;
 return;
}

function b58(i1, i2, f3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 nullFunc_iiifiifii(58);
 return 0;
}

function __ZZN8Animator15InitializeClassEvEN43FunctorImpl_387kDidModifyAnimatorController4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZNK5physx2Sc9ClothCore21getDampingCoefficientEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore13getRestOffsetEv(i1 + 32 | 0));
}

function __ZNK17UniqueIDGenerator6ExistsE13UniqueSmallID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 return (HEAP32[(HEAP32[i1 >> 2] | 0) + ((i2 & 16777215) << 2) >> 2] | 0) == (i2 | 0) | 0;
}

function __ZNK17ProceduralTexture7IsBakedEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 128 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 108 >> 2] | 0) != (HEAP32[i1 + 104 >> 2] | 0);
 return i1 | 0;
}

function __ZN8Animator17IsAutoPlayingBackEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 548 >> 2] | 0) != 2) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = Math_fround(HEAPF32[i1 + 420 >> 2]) < Math_fround(0.0);
 return i1 | 0;
}

function __ZN7mecanim4hand11DestroyHandEPNS0_4HandERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx7NpScene14executeCollideEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene7collideEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), i1);
 return;
}

function __ZN5physx6PxVec3aSERKS0_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 8 >> 2] = HEAP32[i1 + 8 >> 2];
 return i2 | 0;
}

function __ZN5physx34PxClothTetherConfigGeneratedValuesC2EPKNS_19PxClothTetherConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __ZN5physx32PxCapsuleGeometryGeneratedValuesC2EPKNS_17PxCapsuleGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 8 >> 2];
 return;
}

function __ZN5physx14NpSceneQueriesD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 100104 + 8;
 __ZN5physx2Sq17SceneQueryManagerD2Ev(i1 + 3392 | 0);
 __ZN5physx3Scb5SceneD2Ev(i1 + 16 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx10PxsContext25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 HEAPF32[i2 + 5988 + (i1 << 2) >> 2] = f3;
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN24RingBufferMemoryFileData26SetMaxAllocatedBlocksCountEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 if ((HEAP32[i1 >> 2] | 0) >>> 0 >= i2 >>> 0) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN19CharacterController24CleanupControllerManagerEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457412 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 HEAP32[gb + 1457412 >> 2] = 0;
 return;
}

function __ZN18UnityConnectClient15GetCloudServiceEv(i1) {
 i1 = i1 | 0;
 return __ZN23CloudWebServicesManager15GetCloudServiceEN19CloudServiceHandler11ServiceTypeE(__Z26GetCloudWebServicesManagerv() | 0, 1) | 0;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN18ProceduralMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN18PlatformEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN18BuoyancyEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16BaseVideoTexture10YUYVToRGBAEPt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16BaseVideoTexture10YUYVToRGBAEPti(i1, i2, mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0);
 return;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13TextRendering4Font8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12b2MouseJoint4DumpEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z5b2LogPKcz(gb + 799965 | 0, i1);
 STACKTOP = i1;
 return;
}

function __ZN12_GLOBAL__N_123DoubleBufferedOutStream10disconnectEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 100 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClientD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 148084 + 8;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12HandlerChain4ReadER13FileEntryDatayyPvPy(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 return 0;
}

function __Z51QualitySettings_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings22SetAnisotropicTexturesEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z44QualitySettings_Get_Custom_PropSoftParticlesv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 80 >> 0] | 0;
}

function __Z43QualitySettings_Get_Custom_PropBlendWeightsv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 60 >> 2] | 0;
}

function __Z43QualitySettings_Get_Custom_PropAntiAliasingv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 72 >> 2] | 0;
}

function __Z34GL_CUSTOM_INTERNAL_CALL_MultMatrixRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z32setPxVehicleWheelsMWheelsSimDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsSimDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx22PxVehicleWheelsSimDataaSERKS0_(i2 + 8 | 0, i1) | 0;
 return;
}

function __Z31GL_Set_Custom_PropInvertCullingh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z26DestroySoundHandleInstancePN11SoundHandle8InstanceE(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __ZN11SoundHandle8InstanceD2Ev(i1);
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63328 | 0);
 return;
}

function __Z23SetInputWeightFromIndexR9HPlayableif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __ZN8Playable14SetInputWeightEif(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i2, f3);
 return;
}

function __Z23GetGlobalCachingManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1162492 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[gb + 1162492 >> 2] = i1;
 return i1 | 0;
}

function __Z17IsUsingSubEmitterP14ParticleSystem(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = HEAP32[i1 + 28 >> 2] | 0;
  if (!i1) i1 = 0; else i1 = __ZNK10GameObject8IsActiveEv(i1) | 0;
 }
 return i1 | 0;
}

function __Z17GetNbTriggerPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i3 + 676 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0;
}

function b82(i1, i2, i3, f4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_viiifiiiii(82);
}

function b62(i1, f2, i3, f4, i5, f6, f7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 nullFunc_iifififf(62);
 return 0;
}

function _glVertexAttrib4f__wrapper(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 _glVertexAttrib4f(i1 | 0, +f2, +f3, +f4, +f5);
}

function _cff_cmap_unicode_char_next(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 656 >> 2] | 0) + 2956 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function _cff_cmap_unicode_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[(HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 656 >> 2] | 0) + 2956 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE(i1 + 320 | 0);
 HEAP32[i1 + 536 >> 2] = 0;
 return;
}

function __ZNK5physx27PxClothGeodesicTetherCooker23getNbTethersPerParticleEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return ((HEAP32[i1 + 88 >> 2] | 0) >>> 0) / ((HEAP32[i1 + 4 >> 2] | 0) >>> 0) | 0 | 0;
}

function __ZN9GfxDevice18SetStereoActiveEyeE15StereoscopicEye(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 + 1748 >> 2] = i2 | 0 ? Math_fround(1.0) : Math_fround(0.0);
 HEAP32[i1 + 4208 >> 2] = i2;
 return;
}

function __ZN9CoroutineC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP8[i1 + 52 >> 0] = 0;
 return;
}

function __ZN5physx7NpScene12executeSceneEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene8simulateEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), i1);
 return;
}

function __ZN5physx7NpCloth15exportExtraDataERNS_22PxSerializationContextE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc9ClothCore15exportExtraDataERNS_22PxSerializationContextE(i2 + 32 | 0, i1);
 return;
}

function __ZN5physx30NbModifiedContactPairsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773081;
 HEAP32[i1 + 4 >> 2] = 368;
 HEAP32[i1 + 8 >> 2] = fb + 300;
 HEAP32[i1 + 12 >> 2] = fb + 422;
 return;
}

function __ZN5physx30NbDiscreteContactPairsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773104;
 HEAP32[i1 + 4 >> 2] = 367;
 HEAP32[i1 + 8 >> 2] = fb + 301;
 HEAP32[i1 + 12 >> 2] = fb + 423;
 return;
}

function __ZN5physx2Sc13ConstraintSim15needsProjectionEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP16[HEAP32[i1 + 100 >> 2] >> 1] & 6)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 12 >> 2] | 0) == 0;
 return i1 | 0;
}

function __ZN5Umbra5Query16setGatePathCostsEPKfb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 + 16 >> 2] = i2;
 HEAP8[i1 + 20 >> 0] = i3 & 1;
 return;
}

function __ZN5Umbra12getAllocatorEv() {
 if (HEAP32[gb + 1451688 + 8 >> 2] | 0) return gb + 1451688 | 0;
 HEAP32[gb + 1451688 >> 2] = gb + 79060 + 8;
 HEAP32[gb + 1451688 + 8 >> 2] = 1;
 return gb + 1451688 | 0;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN18ColorBySpeedModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAPF32[i1 + 164 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 168 >> 2] = Math_fround(1.0);
 HEAP16[i1 + 160 >> 1] = 1;
 return;
}

function __ZN17MemoryCacheReader10DirectReadEPvjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _memcpy(i2 | 0, (HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0) + i3 | 0, i4 | 0) | 0;
 return;
}

function __ZN14ParticleSystem5PauseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 40 >> 2] | 0;
 HEAP32[i2 + 8 >> 2] = 2;
 HEAP8[i2 + 12 >> 0] = 0;
 __ZN14ParticleSystem17RemoveFromManagerEv(i1);
 return;
}

function __ZN13UnityProfiler23SetActiveSeparateThreadEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN22UnityProfilerPerThread11SetIsActiveEb(i1, i2);
 return;
}

function __ZN13GfxDeviceGLES17BeginTimerQueriesEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0)) return;
 __ZN16TimerQueriesGLES17BeginTimerQueriesEv(gb + 1098256 | 0);
 return;
}

function __ZN11AudioSource17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioSource4StopEb(i1, 1);
 __ZN11AudioSource7CleanupEv(i1);
 HEAP32[gb + 1460024 >> 2] = (HEAP32[gb + 1460024 >> 2] | 0) + -1;
 return;
}

function __ZN11AudioModule13GetNumDevicesEv(i1) {
 i1 = i1 | 0;
 i1 = __Z18GetAudioManagerPtrv() | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK12AudioManager13GetNumDevicesEv(i1) | 0;
 return i1 | 0;
}

function __Z52Application_CUSTOM_RequestAdvertisingIdentifierAsyncP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return (__ZN12AdsIdHandler17RequestAdsIdAsyncEP12Il2CppObject(__Z15GetAdsIdHandlerv() | 0, i1) | 0) & 1 | 0;
}

function __Z50Physics2D_CUSTOM_INTERNAL_set_colliderContactColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings23SetColliderContactColorERK10ColorRGBAf(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z44SystemInfo_Get_Custom_PropGraphicsDeviceNamev() {
 var i1 = 0;
 i1 = __Z15GetGraphicsCapsv() | 0;
 return __Z20scripting_string_newPKc((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function __Z43getPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5physx22PxVehicleWheelsSimData20getWheelShapeMappingEj(i1, i2) | 0;
}

function __Z34Graphics_Set_Custom_PropActiveTier12GraphicsTier(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z27GetGyroRotationRateUnbiasedi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __Z11GetGUIStatev() {
 var i1 = 0;
 i1 = HEAP32[gb + 187256 >> 2] | 0;
 if ((i1 | 0) > -1) i1 = HEAP32[gb + 1468320 + (i1 << 2) >> 2] | 0; else i1 = 0;
 return HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0;
}

function _UNITY_png_set_compression_strategy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (!i1) return;
 i3 = i1 + 208 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1;
 HEAP32[i1 + 300 >> 2] = i2;
 return;
}

function _UNITY_LZ4_resetStreamState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 & 3 | 0) {
  i2 = 1;
  return i2 | 0;
 }
 _memset(i1 | 0, 0, 16416) | 0;
 HEAP32[i1 + 16396 >> 2] = i2;
 i2 = 0;
 return i2 | 0;
}

function _UNITY_FT_Reference_Face(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 35;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 128 >> 2] | 0) + 52 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = 0;
 return i1 | 0;
}

function mftCall_ff(i2, d1) {
 i2 = i2 | 0;
 d1 = +d1;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 7 | 0)) return +Math_fround(FUNCTION_TABLE_ff[i2 - fb & 7](Math_fround(d1)));
 return +ftCall_ff(i2 | 0, +d1);
}

function b9(i1, i2, i3, i4, f5, i6, i7, f8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 f8 = Math_fround(f8);
 nullFunc_iiiiifiif(9);
 return 0;
}

function _cff_cmap_encoding_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 >= 256) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAPU16[(HEAP32[i1 + 16 >> 2] | 0) + (i2 << 1) >> 1] | 0;
 return i2 | 0;
}

function __ZZN11AudioSource15InitializeClassEvEN32FunctorImpl_2215kDidAddComponent4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN11AudioSource12ApplyFiltersEv(i1);
 return;
}

function __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZNK9allocutil14BuddyAllocator5EmptyEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[HEAP32[i1 + 8 >> 2] >> 2] | 0) + ((HEAPU8[i1 + 26 >> 0] | 0) << 5) + 20 >> 2] | 0) == (HEAP32[i1 + 20 >> 2] | 0) | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11getGridSizeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv(i1 + 32 | 0));
}

function __ZNK5physx14NpArticulation16createDriveCacheEfj(i3, f1, i2) {
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 return __ZNK5physx2Sc16ArticulationCore16createDriveCacheEfj(i3 + 24 | 0, f1, i2) | 0;
}

function __ZNK12NavMeshAgent9GetFilterEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
 return __ZNK7dtCrowd14getAgentFilterEi(i2, HEAP32[i1 + 68 >> 2] | 0) | 0;
}

function __ZNK10FileSystem26GetApplicationContentsPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] | 0;
}

function __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] | 0;
}

function __ZN7mecanim9animation20CreateBlendTreeInputERNS_6memory9AllocatorE(i1) {
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0, 8, 4) | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 8;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 2;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 4;
 return;
}

function __ZN5physx8debugger4comm15DestroyInstance9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 + 8 | 0);
 return;
}

function __ZN5physx33PxClothFabricPhaseGeneratedValuesC2EPKNS_18PxClothFabricPhaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __ZN5physx2Sc18ParticleSystemCoreD2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 16 >> 2] | 0;
 if (i1 | 0) __ZN5physx15PxsParticleData7releaseEv(i1);
 __ZN5physx2Sc9ActorCoreD2Ev(i2);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 + 132 >> 1] = HEAP16[i1 >> 1] | 0;
 return;
}

function __ZN5physx10printShapeEPNS_12PxsRigidBodyENS_14PxGeometryType4EnumEPKcfjb(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 return;
}

function __ZN5Unity11SpringJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity11SpringJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5Umbra21UserCallbackAllocator10deallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN4FMOD6SoundI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i4 | 0) HEAP32[i4 >> 2] = 0;
 return 0;
}

function __ZN33AssetBundleLoadFromAsyncOperation6IsDoneEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 92 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = __ZN23PreloadManagerOperation6IsDoneEv(i1) | 0;
 return i1 | 0;
}

function __ZN21AudioDistortionFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17SurfaceEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN17ProceduralTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17ProceduralTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN17Physics2DSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17Physics2DSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN17CapsuleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17CapsuleCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17AudioReverbFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17AudioChorusFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14CompletionTask22ProcessAllPhysicsTasksEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 20 | 0;
 if (HEAP8[i1 >> 0] | 0) return 1;
 do __Z21ExecuteOneJobQueueJobv() | 0; while (!(HEAP8[i1 >> 0] | 0));
 return 1;
}

function __ZN11AudioModule6UpdateEv(i1) {
 i1 = i1 | 0;
 __ZN12AudioManager6UpdateEv(__Z15GetAudioManagerv() | 0);
 i1 = __Z15GetSoundManagerv() | 0;
 if (!i1) return;
 __ZN12SoundManager6UpdateEv(i1);
 return;
}

function __Z41QualitySettings_Get_Custom_PropVSyncCountv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 76 >> 2] | 0;
}

function __Z40VRSettings_Set_Custom_PropShowDeviceViewh(i1) {
 i1 = i1 | 0;
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice17SetShowDeviceViewEb(__Z12GetIVRDevicev() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z40Physics2D_CUSTOM_GetIgnoreLayerCollisionii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNK16Physics2DManager23GetIgnoreLayerCollisionEii(__Z19GetPhysicsManager2Dv() | 0, i1, i2) | 0) & 1 | 0;
}

function __Z32GL_CUSTOM_INTERNAL_set_modelviewRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z31setPxVehicleNoDrive_DriveTorquePN5physx16PxVehicleNoDriveEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx16PxVehicleNoDrive14setDriveTorqueEjf(i2, i1, f3);
 return;
}

function __Z31setPxVehicleNoDrive_BrakeTorquePN5physx16PxVehicleNoDriveEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx16PxVehicleNoDrive14setBrakeTorqueEjf(i2, i1, f3);
 return;
}

function __Z29GL_CUSTOM_SetRevertBackfacingh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z23setPxD6Joint_TwistLimitPN5physx9PxD6JointERKNS_23PxJointAngularLimitPairE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_reciprocal2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0;
 d3 = +Math_floor(+(1.0e15 / +(i1 | 0) / +(i2 | 0) + .5));
 return (d3 <= 2147483647.0 & d3 >= -2147483648.0 ? ~~d3 : 0) | 0;
}

function _UNITY_LZ4_setStreamDecode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 12 >> 2] = i3;
 HEAP32[i1 + 8 >> 2] = i2 + i3;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return 1;
}

function _glTexStorage3D__wrapper(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 _glTexStorage3D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0, i6 | 0);
}

function _glGetActiveUniformBlockName__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glGetActiveUniformBlockName(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _ft_raccess_sort_ref_by_id(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP16[i1 >> 1] | 0;
 i2 = HEAP16[i2 >> 1] | 0;
 return ((i1 & 65535) < (i2 & 65535) ? -1 : (i1 & 65535) > (i2 & 65535) & 1) | 0;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 76 | 0;
 i1 = HEAP32[i3 >> 2] & 255;
 HEAP32[i3 >> 2] = i2 << 24 >> 24;
 return i1 | 0;
}

function __ZNSt3__28__i_nodeD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 4 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return; else {
  __ZNSt3__28__i_nodeD2Ev(i2);
  _free(HEAP32[i1 >> 2] | 0);
  return;
 }
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i2 << 2) | 0;
}

function __ZNK9DebugGLES10LogApiCallEPKcS1_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 8 >> 2] = i3;
 HEAP32[i1 + 12 >> 2] = i4;
 return;
}

function __ZNK5physx3Cct13BoxController8getStatsERNS_17PxControllerStatsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx3Cct10Controller16getInternalStatsERNS_17PxControllerStatsE(i2 + 8 | 0, i1);
 return;
}

function __ZNK5physx3Cct13BoxController8getStateERNS_17PxControllerStateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZNK5physx3Cct10Controller16getInternalStateERNS_17PxControllerStateE(i2 + 8 | 0, i1);
 return;
}

function __ZNK5physx2Sq12BucketPruner10getPayloadERKj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 7632 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 7636 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] << 3) | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getMaxParticlesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx11NpAggregate13getOwnerSceneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN5physx3Scb5Scene10getPxSceneEv(i1) | 0;
 return i1 | 0;
}

function __ZNK17BillboardRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 360 >> 2] | 0;
 if (!i1) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 36 >> 2] | 0;
 return i2 | 0;
}

function __ZNK10FileSystem25GetApplicationManagedPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN9Rigidbody21SetMaxAngularVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN6Socket15WouldBlockErrorEv() {
 var i1 = 0;
 switch (HEAP32[(___errno_location() | 0) >> 2] | 0) {
 case 4:
 case 11:
 case 115:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaSERKS4_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN8Scalar4faSERKS_(i2, i1) | 0;
 __ZN8Scalar4faSERKS_(i2 + 16 | 0, i1 + 16 | 0) | 0;
 return i2 | 0;
}

function __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene3addINS0_10ConstraintELb1EEEvRT_RNS0_13ObjectTrackerE(i2, i1, i2 + 2660 | 0);
 return;
}

function __ZN5physx3Ext20computeSphereDensityEff(f2, f1) {
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 return Math_fround(f1 / Math_fround(Math_fround(Math_fround(f2 * Math_fround(4.18879032)) * f2) * f2));
}

function __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 673104;
 HEAP32[i1 + 4 >> 2] = 257;
 HEAP32[i1 + 8 >> 2] = fb + 3482;
 HEAP32[i1 + 12 >> 2] = fb + 3483;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 166040 + 8;
 return;
}

function __ZN5physx21SapPostUpdateWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx23PxsBroadPhaseContextSap13postUpdatePPUEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx20clearTorqueCurvePairEPNS_19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 68 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5Unity5Joint31SetAutoConfigureConnectedAnchorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 36 >> 0] = i2 & 1;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, 3);
 return;
}

function __ZN5Umbra20RuntimeTomeGenerator6ResultC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN4FMOD8ChannelI9isPlayingEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 if (!(HEAP32[i1 + 64 >> 2] | 0)) i1 = 0; else i1 = HEAP8[i1 + 161 >> 0] ^ 1;
 HEAP8[i2 >> 0] = i1;
 return 0;
}

function __ZN4FMOD7SystemI17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv(i1) {
 i1 = i1 | 0;
 __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv(i1);
 __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv(i1 + 40 | 0);
 return;
}

function __ZN24PhysicsUpdateBehaviour2D17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE(__Z24GetFixedBehaviourManagerv() | 0, i1 + 36 | 0);
 return;
}

function __ZN21LightProbeProxyVolumeD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 34500 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18AnimatorController28InvalidateAnimatorControllerEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZN15dtProximityGridC2Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN15UniformTFMethod20IsBoneCountSupportedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((((HEAP32[(__Z15GetGraphicsCapsv() | 0) + 580 >> 2] | 0) / 4 | 0) + -10 | 0) / 3 | 0) >>> 0 > i2 >>> 0 | 0;
}

function __ZN15ReflectionProbe18SetTimeSlicingModeENS_15TimeSlicingModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 48 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13GfxDeviceGLES20UpdateConstantBufferEijPKv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN19ConstantBuffersGLES8UpdateCBEiiPKv(i1 + 6624 | 0, i2, i3, i4);
 return;
}

function __ZN12_GLOBAL__N_1L37PostProcessCullResultsForSkyboxProbesEPK9SceneNodePK4AABBR9IndexListPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i3 + 4 >> 2] = 0;
 return;
}

function __ZN11AudioFilter17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD3DSP7releaseEv(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z55AnimatorControllerPlayable_CUSTOM_GetLayerCountInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 return __ZNK26AnimatorControllerPlayable13GetLayerCountEv(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) | 0;
}

function __Z49Physics2D_CUSTOM_INTERNAL_set_colliderAsleepColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings22SetColliderAsleepColorERK10ColorRGBAf(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z42setPxFixedJoint_ProjectionAngularTolerancePN5physx12PxFixedJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z40setPxRigidDynamic_StabilizationThresholdPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 268 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z40setPxRigidDynamic_ContactReportThresholdPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 304 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z39setPxParticleFluid_RestParticleDistancePN5physx15PxParticleFluidEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 268 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z37setPxRigidBody_MassSpaceInertiaTensorPN5physx11PxRigidBodyERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z34Profiler_CUSTOM_SetSamplersEnabledh(i1) {
 i1 = i1 | 0;
 __ZNK9profiling14SamplerManager18SetSamplersEnabledEb(HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 76 >> 2] | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z15IsInstanceValidP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (__ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) | 0) != 0;
 return i1 | 0;
}

function __GLOBAL__sub_I_LogAssert_cpp() {
 HEAP32[gb + 1450768 >> 2] = 0;
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1450772 | 0, gb + 582834 | 0, 11, 0);
 return;
}

function _UNITY_png_set_benign_errors(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 208 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = (i2 | 0) == 0 ? i3 & -7340033 : i3 | 7340032;
 return;
}

function _geteuid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall201(201, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _getegid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall202(202, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZZN8VRDevice10InitializeEbEN33PostLateUpdateVRPostPresentstruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + (i2 << 2) | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK8Animator17GetAnimationClipsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 604 | 0;
 if (HEAP32[i1 + 616 >> 2] | 0) return i2 | 0;
 __ZN8Animator24SetupAnimationClipsCacheEv(i1);
 return i2 | 0;
}

function __ZNK5physx2Sc5Scene26getNbContactDataBlocksUsedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx17PxcNpMemBlockPool17getUsedBlockCountEv((HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 44 | 0) | 0;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11getGridSizeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv(i1 + 32 | 0));
}

function __ZN9Texture3D13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 4 | 0) == 4) if (!(HEAP32[i1 + 96 >> 2] | 0)) return;
 __ZN9Texture3D13UploadTextureEv(i1);
 return;
}

function __ZN9Scripting37GetScriptingArrayTypeElementNoRefImplEP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(__Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0) >> 2] | 0;
}

function __ZN9LensFlare13SetBrightnessEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 56 >> 2] = f2;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZN7Cubemap16SetSourceTextureE11CubemapFace4PPtrI9Texture2DE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(HEAP32[i1 + 152 >> 2] | 0) + (i2 << 2) >> 2] = HEAP32[i3 >> 2];
 return;
}

function __ZN5physx9NpPhysics20createParticleSystemEjb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx9NpFactory20createParticleSystemEjb(HEAP32[gb + 1457204 >> 2] | 0, i1, i2) | 0;
}

function __ZN5physx7NpScene12executeSolveEPNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene5solveEfPNS_10PxBaseTaskE(i2 + 32 | 0, Math_fround(HEAPF32[i2 + 3700 >> 2]), i1);
 return;
}

function __ZN5physx6shdfnd4TimeC2Ev(i1) {
 i1 = i1 | 0;
 _gettimeofday(gb + 1457444 | 0, 0) | 0;
 HEAPF64[i1 >> 3] = +(HEAP32[gb + 1457444 >> 2] | 0) + +(HEAP32[gb + 1457444 + 4 >> 2] | 0) * 1.0e-06;
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx27NbBroadPhaseRemovesPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773018;
 HEAP32[i1 + 4 >> 2] = 372;
 HEAP32[i1 + 8 >> 2] = fb + 798;
 HEAP32[i1 + 12 >> 2] = fb + 838;
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114456 + 8;
 return;
}

function __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv(i1, i3, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0) + (i3 << 2) >> 2] = i2;
 return;
}

function __ZN5physx10PxsContext19destroyArticulationERNS_15PxsArticulationE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx19PxsSimObjectFactory19destroyArticulationERNS_15PxsArticulationE(i2, i1);
 return;
}

function __ZN5Unity10HingeJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity10HingeJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN2UI6Canvas39UpdateCanvasSortingBucketNormalizedSizeEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 416 >> 2] = HEAP32[i1 + 404 >> 2];
 i1 = i1 + 224 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 6;
 return;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN2UI13RectTransform8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN19AudioHighPassFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16SubstanceArchive8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16ParticleRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16ParticleAnimator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16ParticleAnimator8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16LightmapSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16GraphicsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15ReflectionProbe19ScheduleFullRefreshEv(i1) {
 i1 = i1 | 0;
 __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei(HEAP32[gb + 1112272 >> 2] | 0, 3, i1, 63);
 return;
}

function __ZN15QualitySettings31SetBillboardsFaceCameraPositionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 83 >> 0] = i2 & 1;
 return;
}

function __ZN15MulticastSocket7SetLoopEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZN6Socket10CheckErrorEiPKcii(__ZN6Socket15SetSocketOptionEiib(i1, 0, 34, i2) | 0, gb + 584662 | 0, 0, 0) | 0) ^ 1 | 0;
}

function __ZN12FlareManager17LoadFlareMaterialEv(i1) {
 i1 = i1 | 0;
 __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali((__Z21GetManagerFromContexti(6) | 0) + 84 | 0, i1 + 24 | 0, 1);
 return;
}

function __ZN11UmbraModule18CreateShadowCullerEv(i1) {
 i1 = i1 | 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(53248, gb + 64016 | 0, 16, gb + 612578 | 0, 113) | 0;
 __ZN5Umbra15ShadowCullerExtC2Ev(i1);
 return i1 | 0;
}

function __ZL23ResetRandSeedForEmitterv() {
 HEAP32[gb + 1477076 >> 2] = 5;
 HEAP32[gb + 1477080 >> 2] = 472231674;
 HEAP32[gb + 1477084 >> 2] = -2041064797;
 HEAP32[gb + 1477088 >> 2] = -2032904880;
 return;
}

function __Z54RenderSettings_CUSTOM_INTERNAL_set_ambientEquatorColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings22SetAmbientEquatorColorERK10ColorRGBAf(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z47QualitySettings_Set_Custom_PropShadowProjection16ShadowProjection(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings19SetShadowProjectionE16ShadowProjection(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z41setPxFixedJoint_ProjectionLinearTolerancePN5physx12PxFixedJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z40setPxArticulation_StabilizationThresholdPN5physx14PxArticulationEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z40setPxArticulationJoint_TwistLimitEnabledPN5physx19PxArticulationJointEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z40setPxArticulationJoint_SwingLimitEnabledPN5physx19PxArticulationJointEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z30setPxVehicleNoDrive_SteerAnglePN5physx16PxVehicleNoDriveEjf(i2, i1, f3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 f3 = Math_fround(f3);
 __ZN5physx16PxVehicleNoDrive13setSteerAngleEjf(i2, i1, f3);
 return;
}

function __Z29scripting_class_from_fullnamePKcS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN11MonoManager17GetScriptingClassEPKcS1_S1_(__Z14GetMonoManagerv() | 0, i1, i2, i3) | 0;
}

function __Z27GL_Set_Custom_PropWireframeh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z27GL_Set_Custom_PropSRGBWriteh(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, i1 << 24 >> 24 != 0 | 0);
 return;
}

function __Z26setPxRigidActor_GlobalPosePN5physx12PxRigidActorERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0, 1);
 return;
}

function __Z22RecalculateSplineSlopeR17AnimationCurveTplIfEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif(i1, i2, f3);
 return;
}

function __Z19profiler_start_mode12ProfilerMode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 __ZN13UnityProfiler18StartProfilingModeE12ProfilerMode(i2, i1);
 return;
}

function __Z13GetNbCCDPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i3 + 284 + (i1 * 28 | 0) + (i2 << 2) >> 2] | 0;
}

function _getuid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall199(199, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _getgid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall200(200, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE(i1 + 284 | 0);
 HEAP32[i1 + 536 >> 2] = 0;
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK5physx2Sq10AABBPruner10getPayloadERKj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 7776 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 7780 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] << 3) | 0;
}

function __ZNK5physx2Sc8ShapeSim10getBodySimEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 i2 = HEAP8[i1 + 50 >> 0] | 0;
 return (i2 << 24 >> 24 == 1 | i2 << 24 >> 24 == 4 ? i1 : 0) | 0;
}

function __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i3 + 56 >> 2];
 HEAP32[i1 >> 2] = HEAP32[i3 + 60 >> 2];
 return;
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getMaxParticlesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx14NpRigidDynamic17getSleepThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 284 >> 2] & 32 | 0) == 0 ? i1 + 208 | 0 : (HEAP32[i1 + 56 >> 2] | 0) + 120 | 0) >> 2]);
}

function __ZNK14UnityWebStream16CanSceneBeLoadedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 19 >> 0] | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP8[i1 + 16 >> 0] | 0) != 0;
 return i2 | 0;
}

function __ZNK11dtPathQueue18getRequestPathSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 52 >> 2] | 0;
 return i2 | 0;
}

function __ZN9LensFlare12SetFadeSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 60 >> 2] = f2;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZN9GfxDevice17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN8Animator16GetStabilizeFeetEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[(HEAP32[i1 + 128 >> 2] | 0) + 16 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZN5physx7NpCloth8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0, HEAP32[i2 + 124 >> 2] | 0);
 return;
}

function __ZN5physx3Cct26CharacterControllerManager15setTessellationEbf(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP8[i3 + 132 >> 0] = i1 & 1;
 HEAPF32[i3 + 128 >> 2] = f2;
 return;
}

function __ZN5physx3Cct17getSceneTimestampEPKNS0_30InternalCBData_FindTouchedGeomE(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 360 >> 2] | 0, i1 | 0) | 0;
}

function __ZN5physx2Sq12BucketPrunerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 101708 + 8;
 __ZN5physx2Sq16BucketPrunerCoreC2Eb(i1 + 16 | 0, 1);
 __ZN5physx2Sq11PruningPoolC2Ev(i1 + 7616 | 0);
 return;
}

function __ZN5physx2Cm12RenderBuffer5clearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 + 56 >> 2] = 0;
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114496 + 8;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 166120 + 8;
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 166080 + 8;
 return;
}

function __ZN5physx16PxsFluidDynamicsD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 120 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 128 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 100 >> 2] = 0;
 return;
}

function __ZN5audio5mixer18SetExposedPropertyERKNS0_16AudioMixerMemoryEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 HEAPF32[(HEAP32[i1 + 40 >> 2] | 0) + (i2 << 2) >> 2] = f3;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN27AnimatorControllerParameter13SetControllerEP18AnimatorController(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = i1;
 return;
}

function __ZN15CacheWriterBase18GetAddressOfMemoryEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468549 | 0, 0, gb + 468620 | 0, 17, 1, 0, 0, 0);
 return 0;
}

function __ZN14ParticleSystem17SetUses3DRotationEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (HEAP8[i1 + 870 >> 0] | 0) return;
 __ZN23ParticleSystemParticles17SetUses3DRotationEv(i1);
 return;
}

function __ZN13GfxDeviceGLES15EndTimerQueriesEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[(__Z15GetGraphicsCapsv() | 0) + 169 >> 0] | 0)) return;
 __ZN16TimerQueriesGLES15EndTimerQueriesEv(gb + 1098256 | 0);
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig11ResetValuesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP32[i1 + 8 >> 2] = 100;
 HEAP32[i1 + 12 >> 2] = 10;
 HEAP32[i1 + 16 >> 2] = 500;
 return;
}

function __ZN11Rigidbody2D14SetUseAutoMassEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 49 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) return;
 __ZN6b2Body13ResetMassDataEv(i1);
 return;
}

function __ZL33AllowIdentityTransformDestructionv() {
 var i1 = 0;
 i1 = HEAP32[(HEAP32[gb + 1158204 >> 2] | 0) + 28 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, 61);
 return;
}

function __Z8GetStatsPKN5physx7PxSceneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx22PxSimulationStatisticsC2Ev(i1);
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 312 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z55QualitySettings_Set_Custom_PropRealtimeReflectionProbesh(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings27SetRealtimeReflectionProbesEb(__Z18GetQualitySettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z54AndroidJNI_CUSTOM_INTERNAL_CALL_CallStaticObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z48Physics2D_CUSTOM_INTERNAL_set_colliderAwakeColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings21SetColliderAwakeColorERK10ColorRGBAf(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z46GUIUtility_CUSTOM_SetDidGUIWindowsEatLastEventh(i1) {
 i1 = i1 | 0;
 __ZN10GUIManager28SetDidGUIWindowsEatLastEventEbi(i1 << 24 >> 24 != 0, __Z30GetGUIStateCurrentDisplayIndexv() | 0);
 return;
}

function __Z41RenderSettings_Set_Custom_PropAmbientModeN14RenderSettings11AmbientModeE(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings14SetAmbientModeENS_11AmbientModeE(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z40getPxArticulationJoint_TargetOrientationPKN5physx19PxArticulationJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z39Screen_Get_Custom_PropCurrentResolutionv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z38QualitySettings_Get_Custom_PropShadowsv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 20 >> 2] | 0;
}

function __Z36Caching_Get_Custom_PropSpaceOccupiedv() {
 var i1 = 0;
 i1 = __ZN14CachingManager23GetCachingDiskSpaceUsedEv(__Z17GetCachingManagerv() | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __Z34Debug_CUSTOM_ClearDeveloperConsolev() {
 var i1 = 0;
 if (!(__Z9GetIIMGUIv() | 0)) return;
 i1 = __Z9GetIIMGUIv() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __Z30createPxPhysics_TriangleMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __Z29setPxRigidBody_CMassLocalPosePN5physx11PxRigidBodyERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z27profiler_change_persistancyibb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN19MemoryProfilerStats21ChangePersistancyflagEibb(HEAP32[gb + 1163248 >> 2] | 0, i1, i2, i3);
 return;
}

function __Z21getPxJoint_BreakForcePKN5physx7PxJointERfS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_viii(HEAP32[(HEAP32[i3 >> 2] | 0) + 56 >> 2] | 0, i3 | 0, i1 | 0, i2 | 0);
 return;
}

function __GLOBAL__sub_I_runtime_webrequest_downloadhandler_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1468892 | 0, gb + 1026885 | 0, 9, 0);
 return;
}

function _UNITY_png_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 if (i1 | 0) {
  i3 = HEAP32[i1 + 168 >> 2] | 0;
  if (i3 | 0) mftCall_vii(i3 | 0, i1 | 0, i2 | 0);
 }
 _UNITY_png_longjmp(i1, 1);
}

function mftCall_ii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 4095 | 0)) return FUNCTION_TABLE_ii[i2 - fb & 4095](i1 | 0) | 0;
 return ftCall_ii(i2 | 0, i1 | 0) | 0;
}

function _llvm_ctpop_i32(i1) {
 i1 = i1 | 0;
 i1 = i1 - (i1 >>> 1 & 1431655765) | 0;
 i1 = (i1 & 858993459) + (i1 >>> 2 & 858993459) | 0;
 return Math_imul(i1 + (i1 >>> 4) & 252645135, 16843009) >>> 24 | 0;
}

function _getppid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall64(64, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _getpgrp() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall65(65, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _finite(d1) {
 d1 = +d1;
 var i2 = 0;
 HEAPF64[tempDoublePtr >> 3] = d1;
 i2 = HEAP32[tempDoublePtr + 4 >> 2] & 2146435072;
 return (i2 >>> 0 < 2146435072 | (i2 | 0) == 2146435072 & 0 < 0) & 1 | 0;
}

function ___cxx_global_var_init_2() {
 var i1 = 0;
 if (HEAP8[gb + 1097992 >> 0] | 0) return;
 HEAP32[gb + 1103852 >> 2] = 0;
 i1 = gb + 1097992 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZZN2UI23InitializeCanvasManagerEvEN41UIEventsCanvasManagerRenderOverlaysstruct7ForwardEi(i1) {
 i1 = i1 | 0;
 __ZN2UI13CanvasManager14RenderOverlaysEi(HEAP32[gb + 1467948 >> 2] | 0, i1);
 return;
}

function __ZNKSt3__25ctypeIwE10do_toupperEw(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_upper_tableEv() | 0) + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__25ctypeIwE10do_tolowerEw(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1 >>> 0 < 128) i1 = HEAP32[(__ZNSt3__25ctypeIcE21__classic_lower_tableEv() | 0) + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK5physx2Sc21ElementSimInteraction13getNPhaseCoreEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 8 >> 2] | 0) | 0) + 1104 >> 2] | 0;
}

function __ZNK14TerrainManager16GetActiveTerrainEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 12 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 8 >> 2] | 0;
 return i1 | 0;
}

function __ZNK13CameraLODData17HasNotBeenUsedForEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 var d3 = 0.0;
 d3 = +__Z19GetTimeSinceStartupv();
 return Math_fround(d3 - +HEAPF64[i1 + 8 >> 3]) > f2 | 0;
}

function __ZN9Texture2D11EncodeToJPGER13dynamic_arrayIhLj1EEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZL18Texture2D_EncodeToP9Texture2DR13dynamic_arrayIhLj1EEii(i1, i2, 1, i3) | 0;
}

function __ZN7b2Joint4DumpEv(i1) {
 i1 = i1 | 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 __Z5b2LogPKcz(gb + 803339 | 0, i1);
 STACKTOP = i1;
 return;
}

function __ZN5physx9NpPhysics19createParticleFluidEjb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx9NpFactory19createParticleFluidEjb(HEAP32[gb + 1457204 >> 2] | 0, i1, i2) | 0;
}

function __ZN5physx7NpScene23forceDynamicTreeRebuildEbb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq17SceneQueryManager23forceDynamicTreeRebuildEbb(i3 + 3392 | 0, i2, i1);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE(i1 + 324 | 0);
 HEAP32[i1 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Ext17computeSphereMassEff(f2, f1) {
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(Math_fround(Math_fround(f2 * Math_fround(4.18879032)) * f2) * f2) * f1);
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 166e3 + 8;
 return;
}

function __ZN5physx23ProjectionPlanePropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 743282;
 HEAP32[i1 + 4 >> 2] = 184;
 HEAP32[i1 + 8 >> 2] = fb + 3579;
 HEAP32[i1 + 12 >> 2] = fb + 3580;
 return;
}

function __ZN5physx20PxsParticleSystemSim15addInteractionVERKNS_16PxvParticleShapeEjjbb(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN4gles19ActivateTextureUnitER15DeviceStateGLESj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7ApiGLES17ActiveTextureUnitEj(HEAP32[gb + 1451080 >> 2] | 0, i2);
 HEAP32[i1 + 424 >> 2] = i2;
 return;
}

function __ZN24PhysicsUpdateBehaviour2D12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z24GetFixedBehaviourManagerv() | 0, i1 + 36 | 0, -1);
 return;
}

function __ZN17AudioChorusFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15ResourceManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15ResourceManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15RelativeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15RelativeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15ReflectionProbe23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15ReflectionProbe8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15QualitySettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15PointEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15OcclusionPortal8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15NavMeshObstacle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15DistanceJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15ConstantForce2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15CapsuleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15CapsuleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15CacheReaderBase18GetAddressOfMemoryEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 468247 | 0, 0, gb + 468318 | 0, 9, 1, 0, 0, 0);
 return 0;
}

function __ZN15AudioReverbZone7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 116 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD6Reverb7releaseEv(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AudioReverbZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15AudioMixerGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AudioMixerGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AudioEchoFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14dtPathCorridorD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 28 | 0;
 __Z6dtFreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZN14GfxDeviceStats10StateStats5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN13RuntimeStaticI23MeshVertexFormatManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI23MeshVertexFormatManagerE10InitializeEv(i1);
 return;
}

function __ZN13GfxDeviceGLES18CreateStencilStateERK15GfxStencilState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState(i1 + 6616 | 0, i2) | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher29PreformRetryWebDispatchStaticEPv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher23PreformRetryWebDispatchEv(i1);
 return;
}

function __ZL23CompareMeshTriangleDataRK16MeshTriangleDataS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 return f3 > Math_fround(HEAPF32[i2 + 4 >> 2]) | 0;
}

function __Z53RenderSettings_CUSTOM_INTERNAL_set_ambientGroundColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings21SetAmbientGroundColorERK10ColorRGBAf(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z30setPxRigidBody_AngularVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, i1 | 0, 1);
 return;
}

function __Z24setPxD6Joint_LinearLimitPN5physx9PxD6JointERKNS_18PxJointLinearLimitE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z105Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorStateInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925254 | 0, fb + 942 | 0);
 return;
}

function _glFramebufferTextureLayer__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glFramebufferTextureLayer(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _getpid() {
 var i1 = 0, i2 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 i2 = ___syscall20(20, i1 | 0) | 0;
 STACKTOP = i1;
 return i2 | 0;
}

function _emscripten_glShaderBinary__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _emscripten_glShaderBinary(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _cff_sid_to_glyph_name(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 656 >> 2] | 0;
 return _cff_index_get_sid_string(i1, HEAPU16[(HEAP32[i1 + 1160 >> 2] | 0) + (i2 << 1) >> 1] | 0) | 0;
}

function ___freadptr(i2, i3) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4 >> 2] | 0;
 i2 = (HEAP32[i2 + 8 >> 2] | 0) - i1 | 0;
 if (!i2) i1 = 0; else HEAP32[i3 >> 2] = i2;
 return i1 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZThn4_N5physx5cloth8SwFabric18scaleTetherLengthsEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = i2 + 76 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f1);
 return;
}

function __ZThn4_N12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv(i2 + -4 | 0, i1);
 return;
}

function __ZNSt3__219__shared_weak_count16__release_sharedEv(i1) {
 i1 = i1 | 0;
 if (__ZNSt3__214__shared_count16__release_sharedEv(i1) | 0) __ZNSt3__219__shared_weak_count14__release_weakEv(i1);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 40 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 52 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 40 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 52 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 36 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 48 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE16do_positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 36 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE16do_negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 48 | 0);
 return;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return __ZNKSt3__218__time_get_storageIwE15__do_date_orderEv(i1 + 12 | 0) | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return __ZNKSt3__218__time_get_storageIcE15__do_date_orderEv(i1 + 12 | 0) | 0;
}

function __ZNK5physx3Scb5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE(i2 + 16 | 0, i1) | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 736 + ((i1 & 3) * 12 | 0) | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 688 + ((i1 & 3) * 12 | 0) | 0;
}

function __ZNK5physx19NpArticulationJoint12getStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 16 | 0) == 0 ? i1 + 108 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 84 | 0) >> 2]);
}

function __ZNK5physx13NpClothFabric18getParticleIndicesEPjj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore18getParticleIndicesEPjj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK23ArchiveStorageConverter16GetDirectoryInfoEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return 0; else return (HEAP8[i1 + 184 >> 0] | 0 ? i1 + 120 | 0 : 0) | 0;
 return 0;
}

function __ZNK17ArchiveFileSystem9CanHandleEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return (_strstr(i2, i1) | 0) != 0 | 0;
}

function __ZNK16MemoryFileSystem9CanHandleEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return (_strstr(i2, i1) | 0) != 0 | 0;
}

function __ZNK13MonoBehaviour24IsSharedBetweenAnimatorsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 37 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK10FileSystem21GetUserAppCacheFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN9Texture2D15UpdateImageDataEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0);
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN9Rigidbody17SetSleepThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vif(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i1 | 0, +f2);
 return;
}

function __ZN9GfxDevice31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fE13getBufferSizeEj(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 << 2;
 i2 = i3 + 4096 | 0;
 return (i2 >>> 0 < i3 >>> 0 ? i3 : i2) + (i1 << 3) | 0;
}

function __ZN5physx24NbBroadPhaseAddsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773038;
 HEAP32[i1 + 4 >> 2] = 371;
 HEAP32[i1 + 8 >> 2] = fb + 799;
 HEAP32[i1 + 12 >> 2] = fb + 839;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114736 + 8;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114656 + 8;
 return;
}

function __ZN5Unity5Cloth15SetCoefficientsEPNS0_26ClothConstrainCoefficientsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(HEAP32[i1 + 128 >> 2] | 0, i2 | 0, HEAP32[i1 + 140 >> 2] << 3 | 0) | 0;
 return;
}

function __ZN21BillboardBatchManager13StaticCleanupEPv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1159948 >> 2] | 0, gb + 63616 | 0);
 HEAP32[gb + 1159948 >> 2] = 0;
 return;
}

function __ZN20LocalFileSystemWebGL5CloseER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = __ZN20LocalFileSystemPosix5CloseER13FileEntryData(i1, i2) | 0;
 _JS_FileSystem_Sync();
 return i2 | 0;
}

function __ZN19TransportJavaScript7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 _JS_WebRequest_Release(i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14RenderSettings30SetDefaultReflectionResolutionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 372 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN13ComputeShader13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13ComputeShader18DestroyRuntimeDataEv(i1);
 __ZN13ComputeShader17CreateRuntimeDataEv(i1);
 return;
}

function __Z47Physics2D_CUSTOM_INTERNAL_set_colliderAABBColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings20SetColliderAABBColorERK10ColorRGBAf(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z39setPxRigidBody_MinCCDAdvanceCoefficientPN5physx11PxRigidBodyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 208 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z39setPxRigidBody_MaxDepenetrationVelocityPN5physx11PxRigidBodyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 216 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z39Gizmos_CUSTOM_INTERNAL_CALL_DrawFrustumRK8Vector3fffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 return;
}

function __Z37setPxArticulation_SeparationTolerancePN5physx14PxArticulationEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z36setPxRigidDynamic_MaxAngularVelocityPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z36getPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i1, i2));
}

function __Z36Light_Get_Custom_PropPixelLightCountv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 16 >> 2] | 0;
}

function __Z32setPxArticulationJoint_StiffnessPN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z31setPxCloth_SimulationFilterDataPN5physx7PxClothERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 428 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z30NavMeshPath_CUSTOM_NavMeshPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(52) | 0;
 __ZN11NavMeshPathC2Ev(i2);
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __Z30GetClassIDWithoutLoadingObjecti(i1) {
 i1 = i1 | 0;
 i1 = __Z27GetTypeWithoutLoadingObjecti(i1) | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __Z29setPxRigidBody_LinearVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0, 1);
 return;
}

function __Z28createPxPhysics_HeightFieldsPN5physx9PxPhysicsERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __Z28createPxPhysics_ConvexMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927965 | 0, fb + 988 | 0);
 return;
}

function __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorClipInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925543 | 0, fb + 980 | 0);
 return;
}

function _UNITY_png_set_text(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!(_UNITY_png_set_text_2(i1, i2, i3, i4) | 0)) return; else _UNITY_png_error(i1, gb + 354345 | 0);
}

function _PxCreateFoundation(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx6shdfnd10Foundation14createInstanceEjRNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE(i3, i2, i1) | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN8VRDevice10InitializeEbEN29FrameEventsVRBeginFramestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0);
 return;
}

function __ZNKSt3__26locale9use_facetERNS0_2idE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return __ZNKSt3__26locale5__imp9use_facetEl(i1, __ZNSt3__26locale2id5__getEv(i2) | 0) | 0;
}

function __ZNKSt3__26locale9has_facetERNS0_2idE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return __ZNKSt3__26locale5__imp9has_facetEl(i1, __ZNSt3__26locale2id5__getEv(i2) | 0) | 0;
}

function __ZNK5physx7NpScene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZNK5physx3Scb5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE(i2 + 16 | 0, i1) | 0;
}

function __ZNK5physx2Sq11PruningPool10getPayloadERKj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 16 >> 2] | 0) + (HEAP32[(HEAP32[i2 + 20 >> 2] | 0) + (HEAP32[i1 >> 2] << 2) >> 2] << 3) | 0;
}

function __ZNK5physx2Sc5Scene31getClothInterCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 168 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0));
}

function __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 96 | 0);
 return;
}

function __ZNK31SortCollisionEventsByGameObjectclERK22ParticleCollisionEventS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (HEAP32[i2 + 40 >> 2] | 0) < (HEAP32[i3 + 40 >> 2] | 0) | 0;
}

function __ZNK13MonoBehaviour23IsStateMachineBehaviourEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 36 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK10__cxxabiv117__pbase_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i1 | 0) == (i2 | 0) | (i2 | 0) == (gb + 13360 | 0) | 0;
}

function __ZNK10FileSystem20GetUserAppDataFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK10FileSystem20GetApplicationFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12ConstantClipEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 >> 2] | 0) + i1 + (i2 << 2) >> 2]);
}

function __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Scb14ParticleSystem16releaseParticlesEv(i1 + 20 | 0);
 return;
}

function __ZN5physx21PxsFluidCollisionTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx17PxsFluidCollision26processShapeListWithFilterEjj(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 24 >> 2] | 0, 0);
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114696 + 8;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114576 + 8;
 return;
}

function __ZN5Umbra4Math5atan2ENS_5FloatES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 return Math_fround(+Math_atan2(+f3, +Math_fround(HEAPF32[i2 >> 2])));
}

function __ZN4FMOD8ChannelI13set3DPanLevelEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 _JS_Sound_Set3D(HEAP32[i1 + 164 >> 2] | 0, f2 > Math_fround(0.0) | 0);
 HEAPF32[i1 + 144 >> 2] = f2;
 return 0;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN2UI11CanvasGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN27UnloadUnusedAssetsOperation19IntegrateMainThreadEv(i1) {
 i1 = i1 | 0;
 __Z26GarbageCollectSharedAssetsb((HEAP8[i1 + 64 >> 0] | 0) != 0);
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 return;
}

function __ZN24OcclusionCullingSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13RendererScene27CleanupPVSAndRequestRebuildEv(__Z16GetRendererScenev() | 0);
 return;
}

function __ZN15QualitySettings27SetRealtimeReflectionProbesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 82 >> 0] = i2 & 1;
 return;
}

function __ZN15ConstantForce2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 154808 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15AudioEchoFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170204 + 8;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14Texture2DArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14SpriteRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14SpriteRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14SphereCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP16[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i1 + 80 >> 2] | 0) | 0) >> 1] | 0) <= (i2 | 0) | 0;
}

function __ZN14RenderSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14RenderSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PlayerSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14PhysicsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PhysicsManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PhysicMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14ParticleSystem8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN14ImageReference9BlitImageERKS_NS_10ColorSpaceENS_8BlitModeE(i1, i2, 0, i3);
 return;
}

function __ZN14EdgeCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14EdgeCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14AreaEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13SplatDatabase24DidCreateOnLoadingThreadEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 4 >> 2] | 0) == 0;
 return i1 | 0;
}

function __ZN13ScreenManager14GetResolutionsEib(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN11Rigidbody2D12SetSimulatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 48 >> 0] = i2 & 1;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) return;
 __ZN6b2Body9SetActiveEb(i1, i2);
 return;
}

function __ZN10GUITexture13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN10GUITexture10BuildSheetEv(i1);
 return;
}

function __Z49Bounds_CUSTOM_INTERNAL_CALL_Internal_IntersectRayR3RayR4AABBPf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (__Z16IntersectRayAABBRK3RayRK4AABBPf(i1, i2, i3) | 0) & 1 | 0;
}

function __Z48Caching_Set_Custom_PropMaximumAvailableDiskSpacex(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14CachingManager28SetMaximumDiskSpaceAvailableEx(__Z17GetCachingManagerv() | 0, i1, i2);
 return;
}

function __Z46RenderSettings_Get_Custom_PropCustomReflectionv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK14RenderSettings19GetCustomReflectionEv(__Z17GetRenderSettingsv() | 0) | 0) | 0;
}

function __Z37setPxVehicleWheelsSimData_ChassisMassPN5physx22PxVehicleWheelsSimDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 __ZN5physx22PxVehicleWheelsSimData14setChassisMassEf(i2, f1);
 return;
}

function __Z37getPxArticulationJoint_TargetVelocityPKN5physx19PxArticulationJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z35setPxParticleBase_MaxMotionDistancePN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 204 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z34setPxScene_VisualizationCullingBoxPN5physx7PxSceneERKNS_9PxBounds3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 300 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z34setPxRevoluteJoint_DriveForceLimitPN5physx15PxRevoluteJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z34getPxVehicleAutoBoxData_DownRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i2 + 128 + (i1 << 2) >> 2]);
}

function __Z31setPxShape_SimulationFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 76 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z24GUIStatePushDisplayIndexi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[gb + 187256 >> 2] | 0) + 1 | 0;
 HEAP32[gb + 187256 >> 2] = i2;
 HEAP32[gb + 1468320 + (i2 << 2) >> 2] = i1;
 return;
}

function __Z23setPxCloth_TetherConfigPN5physx7PxClothERKNS_19PxClothTetherConfigE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 268 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z17profiler_end_mode12ProfilerMode(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 __ZN13UnityProfiler16EndProfilingModeE12ProfilerMode(i2, i1);
 return;
}

function __Z16MarkObjectAsRootRK6ObjectR27GarbageCollectorThreadState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState(HEAP32[i1 + 4 >> 2] | 0, i2);
 return;
}

function __Z16CalcInvDeltaTimef(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = f1 > Math_fround(9.99999974e-06);
 f1 = Math_fround(Math_fround(1.0) / f1);
 return Math_fround(i2 ? f1 : Math_fround(1.0));
}

function __Z103Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorTransitionInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925447 | 0, fb + 944 | 0);
 return;
}

function _UNITY_png_get_valid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i3 = 0;
  return i3 | 0;
 }
 i3 = HEAP32[i2 + 8 >> 2] & i3;
 return i3 | 0;
}

function mftCall_if(i2, d1) {
 i2 = i2 | 0;
 d1 = +d1;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 1 | 0)) return FUNCTION_TABLE_if[i2 - fb & 1](Math_fround(d1)) | 0;
 return ftCall_if(i2 | 0, +d1) | 0;
}

function b74(i1, i2, i3, i4, i5, f6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 i8 = i8 | 0;
 nullFunc_iiiiiifii(74);
 return 0;
}

function b47(i1, i2, i3, f4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 nullFunc_iiiifiiii(47);
 return 0;
}

function _ptsname(i1) {
 i1 = i1 | 0;
 i1 = ___ptsname_r(i1, gb + 1576054 | 0, 22) | 0;
 if (!i1) i1 = gb + 1576054 | 0; else {
  HEAP32[(___errno_location() | 0) >> 2] = i1;
  i1 = 0;
 }
 return i1 | 0;
}

function _glGetFramebufferAttachmentParameteriv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetFramebufferAttachmentParameteriv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetShaderPrecisionFormat__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetShaderPrecisionFormat(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN15DirectorManager15InitializeClassEvEN38PostLateUpdateDirectorLateUpdatestruct7ForwardEv() {
 __ZN15DirectorManager12ExecuteStageE13DirectorStage(HEAP32[gb + 1188524 >> 2] | 0, 5);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 28 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_(i1, i2 + 28 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 24 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE14do_curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 24 | 0);
 return;
}

function __ZNK5physx2Sc5Scene39getDefaultContactReportStreamBufferSizeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc10NPhaseCore39getDefaultContactReportStreamBufferSizeEv(HEAP32[i1 + 1104 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc5Scene30getClothInterCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 168 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0));
}

function __ZNK5physx19NpArticulationJoint10getDampingEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 12 >> 2] & 32 | 0) == 0 ? i1 + 112 | 0 : (HEAP32[i1 + 16 >> 2] | 0) + 88 | 0) >> 2]);
}

function __ZNK26DownloadHandlerAssetBundle8GetErrorEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 28 >> 2] | 0) == -1) if (!(HEAP32[i1 + 16 >> 2] | 0)) {
  i1 = 19;
  return i1 | 0;
 }
 i1 = 0;
 return i1 | 0;
}

function __ZNK15ReflectionProbe23ConfiguredToAutoRefreshEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 40 >> 2] | 0) != 1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 44 >> 2] | 0) == 1;
 return i1 | 0;
}

function __ZNK15Lz4Decompressor16DecompressStreamEPvPKvPjS0_S3_b(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return 0;
}

function __ZNK10FileSystem19GetUserConfigFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN7mecanim9animation15GetMotionStartXERKNS0_18ClipMuscleConstantE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi(i1, i2, 0);
 return;
}

function __ZN6Camera15SetOrthographicEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 1088 >> 0] = i2 & 1;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx2Sn20SerializationContext9writeDataEPKvj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj(i3 + 184 | 0, i1, i2) | 0;
 return;
}

function __ZN5physx22NbTriggerPairsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773055;
 HEAP32[i1 + 4 >> 2] = 370;
 HEAP32[i1 + 8 >> 2] = fb + 298;
 HEAP32[i1 + 12 >> 2] = fb + 420;
 return;
}

function __ZN5Umbra9Matrix4x35clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 48 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function __ZN4FMOD7SystemI13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 if (i5 | 0) HEAP32[i5 >> 2] = 2;
 return 0;
}

function __ZN22BlockMemoryCacheWriter15CompleteWritingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 __ZN22BlockMemoryCacheWriter12ResizeBlocksEj(i1, (i2 >>> 8) + 1 | 0);
 return 1;
}

function __ZN15DirectorManager25CanScheduleForDestructionEP8Playable(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = (HEAP16[i2 + 52 >> 1] & 1) == 0;
 return i2 | 0;
}

function __ZN15AudioReverbZone12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN15AudioReverbZone4InitEv(i1);
 __ZN12AudioManager18AddAudioReverbZoneEP15AudioReverbZone(__Z15GetAudioManagerv() | 0, i1);
 return;
}

function __ZN14StackAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26936 + 8;
 __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i1 + 32 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __Z48getPxVehicleDifferentialNWData_DrivenWheelStatusPKN5physx27PxVehicleDifferentialNWDataE(i1) {
 i1 = i1 | 0;
 return __ZNK5physx27PxVehicleDifferentialNWData20getDrivenWheelStatusEv(i1) | 0;
}

function __Z48Physics2D_Set_Custom_PropQueriesStartInCollidersh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings26SetQueriesStartInCollidersEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z41setPxArticulation_MaxProjectionIterationsPN5physx14PxArticulationEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z41setPxArticulation_InternalDriveIterationsPN5physx14PxArticulationEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z41setPxArticulation_ExternalDriveIterationsPN5physx14PxArticulationEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 52 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z34ComputeBuffer_CUSTOM_DestroyBufferP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN13ComputeBufferD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __Z33setPxRevoluteJoint_DriveGearRatioPN5physx15PxRevoluteJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32Caching_Get_Custom_PropSpaceFreev() {
 var i1 = 0;
 i1 = __ZN14CachingManager23GetCachingDiskSpaceFreeEv(__Z17GetCachingManagerv() | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __Z30setPxArticulationJoint_DampingPN5physx19PxArticulationJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z23setPxD6Joint_SwingLimitPN5physx9PxD6JointERKNS_16PxJointLimitConeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z19GetUserAccelerationi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __Z19GetGyroRotationRatei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __Z14CreateMemLabel18MemLabelIdentifierP24ProfilerAllocationHeader(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 >> 2];
 return;
}

function __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorStateInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925352 | 0, fb + 943 | 0);
 return;
}

function __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925730 | 0, fb + 171 | 0);
 return;
}

function _UNITY_png_set_sig_bytes(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 if ((i2 | 0) > 8) _UNITY_png_error(i1, gb + 350322 | 0);
 HEAP8[i1 + 437 >> 0] = (i2 | 0) < 0 ? 0 : i2;
 return;
}

function _UNITY_FT_Set_Debug_Hook(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!(i2 >>> 0 < 4 & ((i1 | 0) != 0 & (i3 | 0) != 0))) return;
 HEAP32[i1 + 172 + (i2 << 2) >> 2] = i3;
 return;
}

function b95(i1, i2, i3, i4, i5, i6, i7, i8, i9) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 i9 = i9 | 0;
 nullFunc_viiiiiiiii(95);
}

function b83(i1, i2, i3, f4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 nullFunc_iiiififf(83);
 return 0;
}

function b27(i1, i2, f3, i4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 nullFunc_iiifiiff(27);
 return 0;
}

function _cf2_getFamilyOtherBlues(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 736 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 179 >> 0];
 HEAP32[i3 >> 2] = i1 + 332;
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN8VRDevice10InitializeEbEN27FrameEventsVREndFramestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdatePlayerSendFrameStartedstruct7ForwardEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1115296 + 420 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZNSt3__212strstreambuf3strEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 32 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i3 & 4 | 0) HEAP32[i2 >> 2] = i3 | 8;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNKSt3__214__codecvt_utf8IDsE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__214__codecvt_utf8IDiE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK7Texture16GetNpotTexelSizeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 72 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK5physx2Sc9ClothCore25getSelfCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 332 >> 2] | 0, i1 | 0));
}

function __ZNK29LineParametersPropertyBinding17GetLineParametersEP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[((HEAP32[i1 + 4 >> 2] | 0) == 120 ? i2 + 344 | 0 : i2 + 384 | 0) >> 2] | 0;
}

function __ZNK21ExecutionOrderManager27GetDefaultExecutionOrderForEPKN5Unity4TypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 3) + 4 >> 2] | 0;
}

function __ZNK20TextRenderingPrivate8FontImpl11GetTabWidthEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj(i1, 32, 0, 0, Math_fround(1.0), 0));
}

function __ZNK19VREyeTextureManager21GetUnityTextureFormatEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 16 >> 2] | 0;
 return i1 | 0;
}

function __ZNK16MemoryFileSystem8FilenameERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _strrchr(i2, 47) | 0;
 if (!i1) i1 = _strrchr(i2, 92) | 0;
 return (i1 | 0 ? i1 + 1 | 0 : i2) | 0;
}

function __ZNK10FileSystem18GetApplicationPathEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN8Animator13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14DirectorPlayer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 __ZN8Animator6RebindEb(i1, 0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE(i1 + 288 | 0);
 HEAP32[i1 + 540 >> 2] = 0;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16collideParticlesEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth11SwCollisionI8Scalar4fEclERKNS0_14IterationStateIS2_EE(i1 + 12 | 0, i1 + 524 | 0);
 return;
}

function __ZN5physx3Cct17CapsuleController14setUpDirectionERKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E(i1 + 8 | 0, i2);
 return;
}

function __ZN5physx3Cct17CapsuleController11setPositionERKNS_14PxExtendedVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx3Cct10Controller6setPosERKNS_14PxExtendedVec3E(i2 + 8 | 0, i1) | 0;
}

function __ZN5physx3Cct15ObstacleContext7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct26CharacterControllerManager22releaseObstacleContextERNS0_15ObstacleContextE(HEAP32[i1 + 56 >> 2] | 0, i1);
 return;
}

function __ZN5physx38PxVehicleWheels4SimDataGeneratedValuesC2EPKNS_23PxVehicleWheels4SimDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1 + 832;
 HEAP32[i2 + 4 >> 2] = i1 + 848;
 return;
}

function __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Scb14ParticleSystem16releaseParticlesEv(i1 + 20 | 0);
 return;
}

function __ZN5physx21MBPPostUpdateWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx16PxsBroadPhaseMBP13postUpdatePPUEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx14PxLightCpuTask15removeReferenceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN28LightProbeProxyVolumeManager21SwapVolumeTextureSetsER21LightProbeProxyVolume(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + 164 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & 1 ^ 1;
 return;
}

function __ZN23ParticleSystemParticles13SetUsesTrailsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 874 >> 0] = 1;
 __ZN14ParticleTrails10ReallocateEjj(i1 + 740 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, -1);
 return;
}

function __ZN18PlatformEffector2D20SetUseOneWayGroupingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 77 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15NavMeshObstacle19SetTimeToStationaryEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = i1 + 76 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __ZN15MulticastSocketC2Ev(i1) {
 i1 = i1 | 0;
 __ZN6SocketC2Eiii(i1, 2, 2, 17);
 HEAP32[i1 >> 2] = gb + 73524 + 8;
 HEAP8[i1 + 17 >> 0] = 0;
 __ZN6Socket15SetReuseAddressEb(i1, 1) | 0;
 return;
}

function __ZN14ParticleSystem17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN11ShapeModule17MainThreadCleanupEv(i1 + 48 | 0);
 __ZN12LightsModule17MainThreadCleanupEv(HEAP32[i1 + 920 >> 2] | 0);
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13WheelCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13TargetJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13TargetJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13SpringJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13SparseTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13SliderJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13RenderTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13OcclusionArea8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13GfxDeviceGLES17CreateRasterStateERK14GfxRasterState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState(i1 + 6616 | 0, i2) | 0;
}

function __ZN13ConstantForce23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13ConstantForce8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13BuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13AnimationClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11UnityEngine15PlatformWrapper17RequestAdsIdAsyncER14IAdsIdListener(i1) {
 i1 = i1 | 0;
 return __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener(__Z15GetAdsIdHandlerv() | 0, i1) | 0;
}

function __ZN11AudioModule23DeleteAudioCustomFilterEP17AudioCustomFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 return;
}

function __ZN10GUIManager16GUIObjectWrapperC2EP16DeveloperConsole(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = fb + 196;
 HEAP32[i1 + 8 >> 2] = fb + 2707;
 return;
}

function __ZL34StaticDestroyAudioSourceFilterRootPv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1459888 >> 2] | 0, gb + 63328 | 0);
 HEAP32[gb + 1459888 >> 2] = 0;
 return;
}

function __ZL34StaticDestroyAudioCustomFilterRootPv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1459928 >> 2] | 0, gb + 63328 | 0);
 HEAP32[gb + 1459928 >> 2] = 0;
 return;
}

function __Z39setPxD6Joint_ProjectionAngularTolerancePN5physx9PxD6JointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z38QualitySettings_CUSTOM_SetQualityLevelih(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15QualitySettings15SetCurrentIndexEib(__Z18GetQualitySettingsv() | 0, i1, i2 << 24 >> 24 != 0);
 return;
}

function __Z37Camera_Get_Custom_PropAllCamerasCountv() {
 var i1 = 0;
 i1 = HEAP32[(__Z16GetRenderManagerv() | 0) + 24 >> 2] | 0;
 return (HEAP32[(__Z16GetRenderManagerv() | 0) + 12 >> 2] | 0) + i1 | 0;
}

function __Z36setPxConstraint_MinResponseThresholdPN5physx12PxConstraintEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z34Screen_Set_Custom_PropSleepTimeouti(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z16GetScreenManagerv() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 60 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z33setPxParticleBase_DynamicFrictionPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 164 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32setPxRevoluteJoint_DriveVelocityPN5physx15PxRevoluteJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 136 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z25setPxHeightFieldDescFlagsPN5physx17PxHeightFieldDescENS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 + 28 >> 1] = HEAP16[i1 >> 1] | 0;
 return;
}

function __Z23setPxScene_FrictionTypePN5physx7PxSceneENS_14PxFrictionType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 284 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z22GUIClip_CUSTOM_Reapplyv() {
 var i1 = 0;
 i1 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 __ZN12GUIClipState7ReapplyER10InputEvent(i1, HEAP32[(__Z11GetGUIStatev() | 0) + 280 >> 2] | 0);
 return;
}

function __Z20GetGfxDeviceTypeName17GfxDeviceRenderer(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 21) {
  i1 = gb + 396407 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 41020 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z20CheckMessageDataTypeiR11MessageData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[(HEAP32[gb + 1104584 + 52 >> 2] | 0) + (i1 * 20 | 0) + 12 >> 2] | 0) == (HEAP32[i2 >> 2] | 0) | 0;
}

function __Z13GrayscaleRampP9Texture2DPhiiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 _memset(i2 | 0, i3 & 255 | 0, 4) | 0;
 return;
}

function __Z101Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorClipInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925825 | 0, fb + 981 | 0);
 return;
}

function _UNITY_FT_Vector_From_Polar(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = 0;
 _UNITY_FT_Vector_Rotate(i1, i3);
 return;
}

function mftCall_vi(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 4095 | 0)) {
  FUNCTION_TABLE_vi[i2 - fb & 4095](i1 | 0);
  return;
 }
 ftCall_vi(i2 | 0, i1 | 0);
}

function _ttyname(i1) {
 i1 = i1 | 0;
 i1 = _ttyname_r(i1, gb + 1576204 | 0, 32) | 0;
 if (!i1) i1 = gb + 1576204 | 0; else {
  HEAP32[(___errno_location() | 0) >> 2] = i1;
  i1 = 0;
 }
 return i1 | 0;
}

function _memory_stream_close(i1) {
 i1 = i1 | 0;
 _UNITY_ft_mem_free(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function _glDrawElementsInstanced__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glDrawElementsInstanced(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _emscripten_glVertexAttrib3f__wrapper(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _emscripten_glVertexAttrib3f(i1 | 0, +f2, +f3, +f4);
}

function _emscripten_glFramebufferRenderbuffer__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glFramebufferRenderbuffer(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN4Tree15InitializeClassEvEN33FunctorImpl_52kOnWillRenderObject4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN4Tree18OnWillRenderObjectEv(i1);
 return;
}

function __ZZN23CloudWebServicesManagerC1E10MemLabelId18ObjectCreationModeEN39EarlyUpdateCloudWebServicesUpdatestruct7ForwardEv() {
 __ZN23CloudWebServicesManager23PlayerLoopHandlerStaticEv();
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | 0);
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | 0);
 return;
}

function __ZNSt3__217iostream_categoryEv() {
 if (!(HEAP8[gb + 1099792 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099792 | 0) | 0) HEAP32[gb + 1473496 >> 2] = gb + 209280 + 8;
 return gb + 1473496 | 0;
}

function __ZNKSt3__214__codecvt_utf8IwE10do_unshiftER11__mbstate_tPcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK5physx2Sc9ClothCore24getSelfCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 324 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc5Scene27getCCDContactModifyCallbackEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx10PxsContext27getCCDContactModifyCallbackEv(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 640 + ((i1 & 3) * 12 | 0) | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE16getNbConstraintsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE(i1 + 12 | 0, 0) | 0;
}

function __ZNK5physx13NpClothFabric16getTetherLengthsEPfj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore16getTetherLengthsEPfj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK5physx13NpClothFabric16getTetherAnchorsEPjj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore16getTetherAnchorsEPjj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK21ExecutionOrderManager30GetCustomAwakeFromLoadQueueForEPKN5Unity4TypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 >> 2] | 0) + (HEAP32[i2 + 24 >> 2] << 3) >> 2] | 0;
}

function __ZNK16UploadHandlerRaw15GetNumBytesLeftEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 32 >> 2] | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return (i1 >>> 0 < i2 >>> 0 ? 0 : i1 - i2 | 0) | 0;
}

function __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[HEAP32[i2 >> 2] >> 2]);
 __ZN8Scalar4fC2Effff(i1, f3, f3, f3, f3);
 return;
}

function __ZNK13GfxDeviceGLES18GetCurrentTargetAAEv(i1) {
 i1 = i1 | 0;
 return __ZNK18GfxFramebufferGLES15GetSamplesCountEv(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0) | 0;
}

function __ZNK12BaseRenderer19GetLightmapIndexIntE12LightmapType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP16[i1 + 228 + (i2 << 1) >> 1] | 0;
 return (i2 << 16 >> 16 == -1 ? -1 : i2 & 65535) | 0;
}

function __ZN8Playable15GetTypeInstanceEv(i1) {
 i1 = i1 | 0;
 return __Z38scripting_class_get_system_type_objectP11Il2CppClass(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0) | 0;
}

function __ZN7mecanim9animation14GetMotionStopXERKNS0_18ClipMuscleConstantE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi(i1, i2, 0);
 return;
}

function __ZN7mecanim9animation13GetRootStartXERKNS0_18ClipMuscleConstantE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi(i1, i2, 7);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 76 >> 2] | 0;
 mftCall_vi(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sq11PruningPool11preallocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((HEAP32[i2 + 8 >> 2] | 0) >>> 0 >= i1 >>> 0) return;
 __ZN5physx2Sq11PruningPool6resizeEj(i2, i1);
 return;
}

function __ZN5physx2Sc5Scene18setSolverBatchSizeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx10PxsContext18setSolverBatchSizeEj(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1);
 return;
}

function __ZN5physx2Gu15EdgeListBuilderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114536 + 8;
 return;
}

function __ZN5Unity17ConfigurableJoint13SetSwapBodiesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 293 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Umbra15GateStateVectorC2EPvjb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i1 >> 2] = i2;
 if (!i4) return;
 _memset(i2 | 0, -1, i3 | 0) | 0;
 return;
}

function __ZN25RuntimeAnimatorController8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN21AnimationClipPlayable7SetTimeEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 var i3 = 0;
 i3 = i1 + 96 | 0;
 HEAP32[i1 + 100 >> 2] = HEAP32[i3 >> 2];
 HEAPF32[i3 >> 2] = Math_fround(d2);
 return;
}

function __ZN14PlayerSettings19PostInitializeClassEv() {
 if (!(__Z24GetManagerPtrFromContexti(0) | 0)) return;
 __ZN14PlayerSettings18InitDefaultCursorsEv(__Z21GetManagerFromContexti(0) | 0);
 return;
}

function __ZN13FileEntryDataD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 1040 >> 2] | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN10Matrix3x3f7SetZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1;
 i3 = i2 + 36 | 0;
 do {
  HEAP32[i2 >> 2] = 0;
  i2 = i2 + 4 | 0;
 } while ((i2 | 0) < (i3 | 0));
 return i1 | 0;
}

function __ZL18UnityDetourReallocPvi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci(i1, i2, 16, gb + 63704 | 0, 0, gb + 842172 | 0, 111) | 0;
}

function __Z48getPxArticulationJoint_TwistLimitContactDistancePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0));
}

function __Z48getPxArticulationJoint_SwingLimitContactDistancePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
}

function __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_CallObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z38setPxD6Joint_ProjectionLinearTolerancePN5physx9PxD6JointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z38getPxParticleBase_SimulationFilterDataPKN5physx14PxParticleBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z38getPxParticleBase_ExternalAccelerationPKN5physx14PxParticleBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z32setPxRigidDynamic_SleepThresholdPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 260 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32setPxRigidDynamic_AngularDampingPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 240 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32setPxParticleBase_StaticFrictionPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z26setPxD6Joint_DrivePositionPN5physx9PxD6JointERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z23GUIStatePopDisplayIndexv() {
 var i1 = 0, i2 = 0;
 i2 = HEAP32[gb + 187256 >> 2] | 0;
 i1 = HEAP32[gb + 1468320 + (i2 << 2) >> 2] | 0;
 HEAP32[gb + 187256 >> 2] = i2 + -1;
 return i1 | 0;
}

function __Z14IsHalfRTFormat19RenderTextureFormat(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 2:
 case 13:
 case 15:
  {
   i1 = 1;
   break;
  }
 default:
  i1 = (i1 | 2 | 0) == 3;
 }
 return i1 | 0;
}

function __Z100Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928062 | 0, fb + 989 | 0);
 return;
}

function _UNITY_png_set_read_user_transform_fn(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 212 | 0;
 HEAP32[i3 >> 2] = HEAP32[i3 >> 2] | 1048576;
 HEAP32[i1 + 188 >> 2] = i2;
 return;
}

function mftCall_vf(i2, d1) {
 i2 = i2 | 0;
 d1 = +d1;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 63 | 0)) {
  FUNCTION_TABLE_vf[i2 - fb & 63](Math_fround(d1));
  return;
 }
 ftCall_vf(i2 | 0, +d1);
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN8VRDevice10InitializeEbEN25EarlyUpdateVRUpdatestruct7ForwardEv() {
 var i1 = 0;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
 return;
}

function __ZZN8Animator15InitializeClassEvEN31FunctorImpl_390kDidModifyAvatar4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZZN8Animator15InitializeClassEvEN31FunctorImpl_389kDidDeleteMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZZN8Animator15InitializeClassEvEN31FunctorImpl_388kDidModifyMotion4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZNSt3__216generic_categoryEv() {
 if (!(HEAP8[gb + 1100464 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100464 | 0) | 0) HEAP32[gb + 1476988 >> 2] = gb + 216020 + 8;
 return gb + 1476988 | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 16 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 16 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 12 | 0);
 return;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 12 | 0);
 return;
}

function __ZNK6Shader19CreatePropertySheetERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK9ShaderLab9IntShader19CreatePropertySheetERK10MemLabelId(HEAP32[i1 + 32 >> 2] | 0, i2) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 + 4 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK23ArchiveStorageConverter23GetProcessedArchiveSizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZNK13MonoBehaviour17HaveAudioCallbackEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 144 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZNK10FileSystem16LastErrorMessageEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN9GfxDevice23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return;
}

function __ZN8Renderer20ResetStaticBatchInfoEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 216 | 0;
 HEAP16[i2 >> 1] = 0;
 HEAP16[i2 + 2 >> 1] = 0 >>> 16;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN8Animator25SetLinearVelocityBlendingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 418 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN7mecanim9animationL25MuscleIndexIdSortFunctionENS0_13MuscleIndexIdES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) >>> 0 < (HEAP32[i2 + 4 >> 2] | 0) >>> 0 | 0;
}

function __ZN6Camera7SetNearEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 920 >> 2] = f2;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx5cloth8SwFabric18scaleTetherLengthsEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 i2 = i2 + 80 | 0;
 HEAPF32[i2 >> 2] = Math_fround(Math_fround(HEAPF32[i2 >> 2]) * f1);
 return;
}

function __ZN5physx2Sc15ClothFabricCoreC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN5physx20ProcessBPResultsTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxsAABBManager16processBPResultsERKNS_20PxsComputeAABBParamsE(HEAP32[i1 + 40 >> 2] | 0, i1 + 20 | 0);
 return;
}

function __ZN5physx18RestvaluesPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773316;
 HEAP32[i1 + 4 >> 2] = 133;
 HEAP32[i1 + 8 >> 2] = fb + 424;
 HEAP32[i1 + 12 >> 2] = fb + 2276;
 return;
}

function __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_viii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0, 1);
 return;
}

function __ZN5physx17SapUpdateWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx23PxsBroadPhaseContextSap9updatePPUEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx16PxsFluidDynamics17OrderedIndexTableC2Ev(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = 0;
 do {
  HEAP32[i2 + (i1 << 2) >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 512);
 return;
}

function __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi(i1) {
 i1 = i1 | 0;
 return __ZN11TypeManager41GetDeserializationStubForPersistentTypeIDEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0;
}

function __ZN5Umbra4Math3powENS_5FloatES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 return Math_fround(+Math_pow(+f3, +Math_fround(HEAPF32[i2 >> 2])));
}

function __ZN5Umbra10StatsAlloc8allocateEjPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 32 + i3;
 return i3 + 16 | 0;
}

function __ZN24GenerateTypeTreeTransfer10SetVersionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) >> 1] = i2;
 return;
}

function __ZN23CloudWebServicesManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN20LocalFileSystemWebGLD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 71220 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN20LocalFileSystemPosixD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 71220 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN19TransportJavaScriptC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN19SkinnedMeshRenderer19GetOptBonesWritableEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 340 | 0;
 if (HEAP32[i2 >> 2] | 0) __Z21CompleteFenceInternalR8JobFence(i2);
 return i1 + 384 | 0;
}

function __ZN18PlatformEffector2D18SetUseSideFrictionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 78 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN14PlayerSettings18SetSubmitAnalyticsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 392 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN13SplatDatabase17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 24 >> 2] | 0);
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 28 >> 2] | 0);
 return;
}

function __ZN13RuntimeStaticI20HardwareInfoReporterE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI20HardwareInfoReporterE10InitializeEv(i1);
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12WheelJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12ScriptMapper23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12ScriptMapper8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12NavMeshAgent8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12MeshCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12MeshCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12LineRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12HingeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12CubemapArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12AudioManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11AudioModule15IsAudioDisabledEv(i1) {
 i1 = i1 | 0;
 i1 = __Z18GetAudioManagerPtrv() | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 224 >> 0] | 0) != 0;
 return i1 | 0;
}

function __Z99Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorControllerInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924741 | 0, fb + 2575 | 0);
 return;
}

function __Z51UnityAdsSettings_Set_Custom_PropInitializeOnStartuph(i1) {
 i1 = i1 | 0;
 __ZN16UnityAdsSettings22SetInitializeOnStartupEb(__Z19GetUnityAdsSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z50RenderSettings_CUSTOM_INTERNAL_set_ambientSkyColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings18SetAmbientSkyColorERK10ColorRGBAf(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z40getPxRigidBody_MassSpaceInvInertiaTensorPKN5physx11PxRigidBodyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __Z39setPxScene_ClothInterCollisionStiffnessPN5physx7PxSceneEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z33getPxArticulationJoint_ParentPosePKN5physx19PxArticulationJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z32setPxArticulation_SleepThresholdPN5physx14PxArticulationEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z31setPxRigidDynamic_LinearDampingPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 232 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z31setPxParticleBase_ContactOffsetPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 220 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z30setPxDistanceJoint_MinDistancePN5physx15PxDistanceJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z30setPxDistanceJoint_MaxDistancePN5physx15PxDistanceJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z21BeginSplashScreenFadev() {
 var d1 = 0.0;
 HEAP32[gb + 1157848 >> 2] = 2;
 HEAPF64[gb + 1098080 >> 3] = .5;
 d1 = +__Z19GetTimeSinceStartupv();
 HEAPF64[gb + 1098064 >> 3] = d1;
 return;
}

function __Z18RecalculateAutoKeyR17AnimationCurveTplIfEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __Z19RecalculateAutoKeyTIfEvR17AnimationCurveTplIT_Eif(i1, i2, f3);
 return;
}

function __Z18InitializeVRModulev() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(24, gb + 63816 | 0, 16, gb + 1046195 | 0, 328) | 0;
 __ZN8VRModuleC2Ev(i1);
 HEAP32[gb + 1469188 >> 2] = i1;
 return;
}

function _tt_cmap0_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 >>> 0 >= 256) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAPU8[(HEAP32[i1 + 16 >> 2] | 0) + (i2 + 6) >> 0] | 0;
 return i2 | 0;
}

function _sfnt_stream_close(i1) {
 i1 = i1 | 0;
 _UNITY_ft_mem_free(HEAP32[i1 + 28 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 + 24 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function _glVertexAttribIPointer__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glVertexAttribIPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _glFramebufferTexture2D__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glFramebufferTexture2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _emscripten_glUniform4i__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _emscripten_glUniform4i(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _emscripten_glClearColor__wrapper(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _emscripten_glClearColor(+f1, +f2, +f3, +f4);
}

function _emscripten_glBlendColor__wrapper(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _emscripten_glBlendColor(+f1, +f2, +f3, +f4);
}

function _do_setrlimit(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 if (!(HEAP32[i2 >> 2] | 0)) HEAP32[i2 >> 2] = 0 - (___setrlimit(HEAP32[i1 + 4 >> 2] | 0, HEAP32[i1 >> 2] | 0) | 0);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN5Light15InitializeClassEvEN31FunctorImpl_36kTransformChanged4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN5Light16TransformChangedEv(i1);
 return;
}

function __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212168 + 8;
 return;
}

function __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212140 + 8;
 return;
}

function __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212112 + 8;
 return;
}

function __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212084 + 8;
 return;
}

function __ZNSt3__215system_categoryEv() {
 if (!(HEAP8[gb + 1100472 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1100472 | 0) | 0) HEAP32[gb + 1476992 >> 2] = gb + 216056 + 8;
 return gb + 1476992 | 0;
}

function __ZNSt3__215future_categoryEv() {
 if (!(HEAP8[gb + 1099784 >> 0] | 0)) if (___cxa_guard_acquire(gb + 1099784 | 0) | 0) HEAP32[gb + 1473484 >> 2] = gb + 208196 + 8;
 return gb + 1473484 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i2 | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE13do_pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE13do_neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = 2;
 HEAP8[i1 + 1 >> 0] = 3;
 HEAP8[i1 + 2 >> 0] = 0;
 HEAP8[i1 + 3 >> 0] = 4;
 return;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx2Sc9ClothCore22getSleepLinearVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 364 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc9ClothCore22getFrictionCoefficientEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc5Scene26getFrictionOffsetThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 12 >> 2] | 0) + 144 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 784 + ((i1 & 3) * 12 | 0) | 0;
}

function __ZNK14BillboardAsset20AcquireBillboardDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZNK13Lz4Compressor14CompressStreamEPvPKvPjS0_S3_b(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return 0;
}

function __ZN7mecanim9animation12GetRootStopXERKNS0_18ClipMuscleConstantE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi(i1, i2, 7);
 return;
}

function __ZN7TextureD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 45392 + 8;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN6Camera6SetFarEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 924 >> 2] = f2;
 HEAP8[i1 + 1077 >> 0] = 1;
 HEAP8[i1 + 1079 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 280 >> 2] = i2;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 256 >> 2] = i1;
 return;
}

function __ZN5physx7NpScene15setFrictionTypeENS_14PxFrictionType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene15setFrictionTypeENS_14PxFrictionType4EnumE(i2 + 32 | 0, i1);
 return;
}

function __ZN5physx6shdfnd8SyncImplC2Ev(i1) {
 i1 = i1 | 0;
 _pthread_mutex_init(i1 | 0, 0) | 0;
 _pthread_cond_init(i1 + 28 | 0, 0) | 0;
 HEAP8[i1 + 80 >> 0] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 return;
}

function __ZN5physx5cloth11BoundingBoxI8Scalar4fEaSERKS3_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN8Scalar4faSERKS_(i2, i1) | 0;
 __ZN8Scalar4faSERKS_(i2 + 16 | 0, i1 + 16 | 0) | 0;
 return i2 | 0;
}

function __ZN5physx2Sc5Scene15setFrictionTypeENS_14PxFrictionType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 7600 >> 2] = i1;
 return;
}

function __ZN5physx22PxVehicleWheelsSimData12disableWheelEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 44 + (i2 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~(1 << (i2 & 31));
 return;
}

function __ZN5physx22PxVehicleWheelsDynData26setTireForceShaderFunctionEPFvPKvffffffffffffRfS3_S3_S3_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 4 >> 2] = i2;
 return;
}

function __ZN5physx18NbCCDPairsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773070;
 HEAP32[i1 + 4 >> 2] = 369;
 HEAP32[i1 + 8 >> 2] = fb + 299;
 HEAP32[i1 + 12 >> 2] = fb + 421;
 return;
}

function __ZN5physx14PxLightCpuTask12addReferenceEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5Umbra10StackAllocD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN2UI6Canvas23SetOverridePixelPerfectEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 361 | 0;
 if ((i2 & 1 | 0) == (HEAPU8[i1 >> 0] | 0 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN25SingleBlockMemoryFileData4LockEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 28 >> 2] | 0)) i1 = 0; else i1 = HEAP32[i1 + 16 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 return 1;
}

function __ZN25RuntimeAnimatorController8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 return;
}

function __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN22NavMeshProjectSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN19TransportJavaScriptD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 12 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 _JS_WebRequest_Release(i2 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN15NavMeshObstacle16SetMoveThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i1 = i1 + 72 | 0;
 if (Math_fround(HEAPF32[i1 >> 2]) == f2) return;
 HEAPF32[i1 >> 2] = f2;
 return;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN14ParticleSystem13SetUses3DSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 if (HEAP8[i1 + 871 >> 0] | 0) return;
 __ZN23ParticleSystemParticles13SetUses3DSizeEv(i1);
 return;
}

function __ZN14MemoryProfilerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 172 >> 2] = 0;
 _memset(i1 + 16 | 0, 0, 136) | 0;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager21nullAllocationHandlerEjPKcS2_iPv(i6, i1, i2, i3, i4, i5) {
 i6 = i6 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN12CullingGroup29SetDistanceReferenceTransformEPK9Transform(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 80 >> 2] = i1;
 return;
}

function __ZN12AudioManager17ShouldSourcePauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 41 >> 0] | 0)) return ((HEAP8[i1 + 40 >> 0] | 0) == 0 | i2) ^ 1 | 0; else return 1;
 return 0;
}

function __ZN10GUIManager16GUIObjectWrapperC2EP13MonoBehaviour(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = fb + 195;
 HEAP32[i1 + 8 >> 2] = fb + 2706;
 return;
}

function __Z99Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816105 | 0, fb + 878 | 0);
 return;
}

function __Z43LightmapSettings_Get_Custom_PropLightProbesv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN16LightmapSettings14GetLightProbesEv(__Z19GetLightmapSettingsv() | 0) | 0) | 0;
}

function __Z38setPxScene_ClothInterCollisionDistancePN5physx7PxSceneEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32getPxArticulationJoint_ChildPosePKN5physx19PxArticulationJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z30setPxParticleBase_ParticleMassPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z27Mathf_CUSTOM_NextPowerOfTwoi(i1) {
 i1 = i1 | 0;
 i1 = i1 + -1 | 0;
 i1 = i1 >>> 16 | i1;
 i1 = i1 >>> 8 | i1;
 i1 = i1 >>> 4 | i1;
 i1 = i1 >>> 2 | i1;
 return (i1 >>> 1 | i1) + 1 | 0;
}

function __Z26setPxShape_QueryFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z15GetAccelerationi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function _UNITY_png_save_uint_32(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = i2 >>> 24;
 HEAP8[i1 + 1 >> 0] = i2 >>> 16;
 HEAP8[i1 + 2 >> 0] = i2 >>> 8;
 HEAP8[i1 + 3 >> 0] = i2;
 return;
}

function _memalign(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 >>> 0 < 9) {
  i2 = _malloc(i2) | 0;
  return i2 | 0;
 } else {
  i2 = _internal_memalign(i1, i2) | 0;
  return i2 | 0;
 }
 return 0;
}

function _i64Subtract(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = i2 - i4 - (i3 >>> 0 > i1 >>> 0 | 0) >>> 0;
 return (setTempRet0(i4 | 0), i1 - i3 >>> 0 | 0) | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 + i2 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) _free(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK9WWWCached14GetPartialSizeEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 454652 | 0, 319, 1, 0, 0, 0);
 return 0;
}

function __ZNK9WWWCached14GetPartialDataEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 454652 | 0, 309, 1, 0, 0, 0);
 return 0;
}

function __ZNK8Animator29GetAnimatorOverrideControllerEv(i1) {
 i1 = i1 | 0;
 return __Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i1 + 108 | 0) | 0;
}

function __ZNK6Shader7GetNameEv(i1) {
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0) | 0;
 return ((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0;
}

function __ZNK5physx2Sc9ClothCore21getStiffnessFrequencyEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc9ClothCore21getCollisionMassScaleEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 216 >> 2] | 0, i1 | 0));
}

function __ZNK5physx29PxShapeGeometryPropertyHelper15getGeometryTypeEPKNS_7PxShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 864 + ((i1 & 3) << 4) | 0;
}

function __ZNK5Umbra4Tome13getGateUserIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 + 108 >> 2] | 0;
 return HEAP32[((i3 | 0) == 0 ? 0 : i1 + i3 | 0) + (i2 << 2) >> 2] | 0;
}

function __ZN9DebugGLESC2ERK7ApiGLES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN5physx9NpPhysics15createAggregateEjb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN5physx9NpFactory15createAggregateEjb(HEAP32[gb + 1457204 >> 2] | 0, i1, i2) | 0;
}

function __ZN5physx3Cct13BoxController14setUpDirectionERKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E(i1 + 8 | 0, i2);
 return;
}

function __ZN5physx3Cct13BoxController11setPositionERKNS_14PxExtendedVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx3Cct10Controller6setPosERKNS_14PxExtendedVec3E(i2 + 8 | 0, i1) | 0;
}

function __ZN5physx24PxDefaultMemoryInputData4seekEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 + 4 >> 2] | 0;
 HEAP32[i2 + 12 >> 2] = i3 >>> 0 < i1 >>> 0 ? i3 : i1;
 return;
}

function __ZN5physx23NpParticleFluidReadData18setDataAccessFlagsENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 201 >> 0] = HEAP8[i1 >> 0] | 0;
 return;
}

function __ZN5physx14NpSceneQueriesD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 100104 + 8;
 __ZN5physx2Sq17SceneQueryManagerD2Ev(i1 + 3392 | 0);
 __ZN5physx3Scb5SceneD2Ev(i1 + 16 | 0);
 return;
}

function __ZN27StateMachineBehaviourPlayerC2EP28IStateMachineBehaviourSender(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN21UnityAnalyticsManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19SkinnedMeshRenderer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN18ProceduralMaterial17SetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK10ColorRGBAf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN18PlatformEffector2D16SetUseSideBounceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 79 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN14PreloadManager18PeekIntegrateQueueEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 32 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[HEAP32[i1 + 20 >> 2] >> 2] | 0;
 return i1 | 0;
}

function __ZN14MemoryProfiler23GetCurrentRootReferenceEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[gb + 1163244 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZN13RuntimeStaticI19UnityConnectServiceE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv(i1);
 return;
}

function __ZN13GfxDeviceGLES16CreateBlendStateERK13GfxBlendState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState(i1 + 6616 | 0, i2) | 0;
}

function __ZN13ConstantForce17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE(__Z24GetFixedBehaviourManagerv() | 0, i1 + 84 | 0);
 return;
}

function __ZN13BitSetUtility13DestroyBitSetERPjRK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i2);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcher25OnDataBlockConsumedStaticEPv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher19OnDataBlockConsumedEv(i1);
 return;
}

function __ZN11TimeManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11TimeManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11Rigidbody2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11Rigidbody2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11PreloadData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11PreloadData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11OffMeshLink23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11OffMeshLink8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11NavMeshData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NavMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11LightProbes23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11LightProbes8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11BoxCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11BoxCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11AudioSource23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioSource8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11AudioFilter7CleanupEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 40 | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 if (!i2) return;
 __ZN4FMOD3DSP7releaseEv(i2) | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AssetBundle8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZL19CleanupModule_IMGUIv() {
 __ZN10GUIManager17CleanupGUIManagerEv();
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIIMGUIv() | 0, gb + 63864 | 0);
 __Z9SetIIMGUIP6IIMGUI(0);
 return;
}

function __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize3R8Vector3fS0_S0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z14OrthoNormalizeP8Vector3fS0_S0_(i1, i2, i3);
 return;
}

function __Z38Physics_CUSTOM_GetIgnoreLayerCollisionii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZN14PhysicsManager18GetIgnoreCollisionEii(__Z17GetPhysicsManagerv() | 0, i1, i2) | 0) & 1 | 0;
}

function __Z29setPxRigidDynamic_WakeCounterPN5physx14PxRigidDynamicEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 276 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z29setPxParticleBase_RestitutionPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z28setPxParticleFluid_ViscosityPN5physx15PxParticleFluidEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 260 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z28setPxParticleFluid_StiffnessPN5physx15PxParticleFluidEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 252 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z28setPxDistanceJoint_TolerancePN5physx15PxDistanceJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z28setPxDistanceJoint_StiffnessPN5physx15PxDistanceJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 148 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z22createPxPhysics_ScenesPN5physx9PxPhysicsERKNS_11PxSceneDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __Z19dtFreeProximityGridP15dtProximityGrid(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __Z6dtFreePv(HEAP32[i1 + 20 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 + 8 >> 2] | 0);
 __Z6dtFreePv(i1);
 return;
}

function __GLOBAL__sub_I_runtime_animation_director_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1466772 | 0, gb + 904339 | 0, 4, 0);
 return;
}

function _UNITY_png_save_int_32(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = i2 >>> 24;
 HEAP8[i1 + 1 >> 0] = i2 >>> 16;
 HEAP8[i1 + 2 >> 0] = i2 >>> 8;
 HEAP8[i1 + 3 >> 0] = i2;
 return;
}

function _start_pass_upsample(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 416 >> 2] | 0;
 HEAP32[i2 + 92 >> 2] = HEAP32[i1 + 276 >> 2];
 HEAP32[i2 + 96 >> 2] = HEAP32[i1 + 96 >> 2];
 return;
}

function _glGetInternalformativ__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glGetInternalformativ(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _glGetActiveUniformsiv__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glGetActiveUniformsiv(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _cf2_getFamilyBlues(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 736 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 178 >> 0];
 HEAP32[i3 >> 2] = i1 + 276;
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1 + -132 | 0);
 return;
}

function __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1 + -128 | 0);
 return;
}

function __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1 + -124 | 0);
 return;
}

function __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1 + -120 | 0);
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1 + -116 | 0);
 return;
}

function __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209816 + 8;
 return;
}

function __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209764 + 8;
 return;
}

function __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209700 + 8;
 return;
}

function __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209636 + 8;
 return;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 HEAP32[i5 >> 2] = i3;
 return 3;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx2Sc5Scene34getClothInterCollisionNbIterationsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 168 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE16getNbConstraintsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE(i1 + 12 | 0, 0) | 0;
}

function __ZNK30SpriteRendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 340 >> 2] | 0;
}

function __ZN9GfxDevice25SetShaderPropertiesSharedERK19ShaderPropertySheet(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN8VRDevice22SetDidPauseApplicationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 328 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEEC2ERNS_19PxAllocatorCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 HEAP32[i2 >> 2] = gb + 114616 + 8;
 return;
}

function __ZN5physx16NbShapesPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 773009;
 HEAP32[i1 + 4 >> 2] = 373;
 HEAP32[i1 + 8 >> 2] = fb + 797;
 HEAP32[i1 + 12 >> 2] = fb + 837;
 return;
}

function __ZN5physx14materialAccessEPKNS_14PxTriangleMeshEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i2 | 0, i1 | 0) | 0) & 65535 | 0;
}

function __ZN4Mesh30AcquireSharedMeshRenderingDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZN2UI14CanvasRenderer16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 204 >> 2] | 0;
 if (!i1) return;
 i1 = i1 + 112 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4;
 return;
}

function __ZN24GenerateTypeTreeTransfer18SetScriptingObjectEP12Il2CppObjecti(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 return;
}

function __ZN20UnityConnectSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN20QuadTreeNodeRendererC2Ev(i1) {
 i1 = i1 | 0;
 __ZN20IntermediateRendererC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 184124 + 8;
 HEAP32[i1 + 264 >> 2] = 0;
 HEAP32[i1 + 268 >> 2] = 0;
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return;
}

function __ZN19ClampVelocityModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP8[i1 + 1064 >> 0] = 0;
 HEAP8[i1 + 1065 >> 0] = 0;
 HEAPF32[i1 + 1068 >> 2] = Math_fround(1.0);
 return;
}

function __ZN18ProceduralMaterial19SetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP9Texture2D(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN18ProceduralMaterial18GetSubstanceHandleEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 148 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZN14dtPathCorridor12SetPathStaleEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (i1) i1 = 0; else i1 = HEAP32[(HEAP32[i2 + 24 >> 2] | 0) + 56 >> 2] | 0;
 HEAP32[i2 + 48 >> 2] = i1;
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN13AnimationClip15GetRuntimeAssetEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 216 >> 2] | 0;
 if (i2 | 0) if (HEAP32[i1 + 220 >> 2] | 0) return i2 | 0;
 i2 = 0;
 return i2 | 0;
}

function __ZN12TreeDatabase19UpdateTreeInstancesEv(i1) {
 i1 = i1 | 0;
 __ZN12TreeDatabase13ValidateTreesEv(i1);
 __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE(HEAP32[i1 >> 2] | 0, 2);
 return;
}

function __ZN11UmbraModule20CleanupUmbraTomeDataEPKN5Umbra4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 __ZN5Umbra10TomeLoader8freeTomeEPKNS_4TomeEPNS_9AllocatorE(i2, 0);
 return;
}

function __ZN11AudioModule23CreateAudioCustomFilterEP13MonoBehaviour(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = __Znwj(24) | 0;
 __ZN17AudioCustomFilterC2EP13MonoBehaviour(i1, i2);
 return i1 | 0;
}

function __ZN10SampleClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10GpuProgramC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 41108 + 8;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 + 12 >> 2] = 1;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 return;
}

function __ZL13ResetRandSeedv() {
 HEAP32[gb + 1477060 >> 2] = 2;
 HEAP32[gb + 1477064 >> 2] = -670100789;
 HEAP32[gb + 1477068 >> 2] = 1989020952;
 HEAP32[gb + 1477072 >> 2] = 1186267769;
 return;
}

function __Z97Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925640 | 0, fb + 157 | 0);
 return;
}

function __Z96Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_SetPlayableDeleteOnDisconnectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552356 | 0, fb + 3015 | 0);
 return;
}

function __Z96Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParametersArrayInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926174 | 0, fb + 2578 | 0);
 return;
}

function __Z49Physics2D_Set_Custom_PropMinPenetrationForPenaltyf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings27SetMinPenetrationForPenaltyEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientLightRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings18SetAmbientSkyColorERK10ColorRGBAf(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z45Physics2D_Set_Custom_PropShowColliderContactsh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings23SetShowColliderContactsEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z45Physics2D_Set_Custom_PropChangeStopsCallbacksh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings23SetChangeStopsCallbacksEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z42setPxScene_ClothInterCollisionNbIterationsPN5physx7PxSceneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z37getPxRigidBody_MassSpaceInertiaTensorPKN5physx11PxRigidBodyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z36ReleaseInstanceFixedBehaviourManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155108 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __Z29setPxArticulation_WakeCounterPN5physx14PxArticulationEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z28setPxParticleBase_RestOffsetPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 212 >> 2] | 0, i2 | 0, +f1);
 return;
}

function mftCall_di(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 15 | 0)) return +FUNCTION_TABLE_di[i2 - fb & 15](i1 | 0);
 return +ftCall_di(i2 | 0, i1 | 0);
}

function b148(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 nullFunc_iiiiiiiii(148);
 return 0;
}

function _ft_ansi_stream_close(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 _fclose(HEAP32[i2 >> 2] | 0) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function _cf2_getOtherBlues(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 736 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 177 >> 0];
 HEAP32[i3 >> 2] = i1 + 236;
 return;
}

function _cf2_getBlueValues(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = HEAP32[i1 + 736 >> 2] | 0;
 HEAP32[i2 >> 2] = HEAPU8[i1 + 176 >> 0];
 HEAP32[i3 >> 2] = i1 + 180;
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdatePlayerSendFrameCompletestruct7ForwardEv() {
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 __Z23PlayerSendFrameCompleteb(1);
 return;
}

function __ZNSt3__25ctypeIcED2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 HEAP32[i1 >> 2] = gb + 212772 + 8;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (i2 | 0) if (HEAP8[i1 + 12 >> 0] | 0) __ZdaPv(i2);
 return;
}

function __ZNK8Animator29ValidateHasAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 108 >> 2] | 0) if (HEAP32[i1 + 624 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = 0;
 return i1 | 0;
}

function __ZNK5physx7NpShape16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 36 >> 2] & 16 | 0) == 0 ? i1 + 108 | 0 : (HEAP32[i1 + 40 >> 2] | 0) + 44 | 0) >> 2]);
}

function __ZNK5physx2Sc5Scene26getSimulationEventCallbackEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i2 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 16 >> 2] | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE16getNbConstraintsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE(i1 + 12 | 0, 0) | 0;
}

function __ZNK5Unity10HingeJoint22BuildUseSpringInternalEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 157 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 158 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK10Collider2D16IsTouchingLayersEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK16Physics2DManager16IsTouchingLayersEPK10Collider2Di(__Z19GetPhysicsManager2Dv() | 0, i1, i2) | 0;
}

function __ZN8Animator25SetLayersAffectMassCenterEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 HEAP8[(HEAP32[i1 + 128 >> 2] | 0) + 17 >> 0] = i2 & 1;
 return;
}

function __ZN8Animator18SetFeetPivotActiveEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 HEAPF32[(HEAP32[i1 + 128 >> 2] | 0) + 12 >> 2] = f2;
 return;
}

function __ZN5physx7NpScene14updateMaterialERNS_10NpMaterialE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene14updateMaterialERNS_2Sc12MaterialCoreE(i2 + 16 | 0, i1 + 32 | 0);
 return;
}

function __ZN5physx7NpScene14removeMaterialERNS_10NpMaterialE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx3Scb5Scene14removeMaterialERNS_2Sc12MaterialCoreE(i2 + 16 | 0, i1 + 32 | 0);
 return;
}

function __ZN5physx2Sc21ConstraintInteractionD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 90796 + 8;
 HEAP32[i1 + 24 >> 2] = gb + 90796 + 48;
 __ZN5physx2Sc16ActorInteractionD2Ev(i1);
 return;
}

function __ZN5physx2Gu5RTreeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 84 >> 2] = 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 76 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 HEAP32[i1 + 64 >> 2] = 4;
 return;
}

function __ZN5physx26PxcFrictionPatchStreamPairC2ERNS_17PxcNpMemBlockPoolE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP32[i2 + 8 >> 2] = 0;
 return;
}

function __ZN5physx23GetMFrictionVsSlipGraphEPKNS_17PxVehicleTireDataEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i3 + 16 + (i1 << 3) + (i2 << 2) >> 2]);
}

function __ZN5audio5mixer20ClearExposedPropertyERKNS0_16AudioMixerMemoryEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[(HEAP32[i1 + 40 >> 2] | 0) + (i2 << 2) >> 2] = Math_fround(-inf);
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity5Cloth8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN31CanvasBatchIntermediateRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN31CanvasBatchIntermediateRendererD2Ev(i1);
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1110384 >> 2] | 0, i1);
 return;
}

function __ZN25RuntimeAnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i1 + 32 | 0, i2);
 return;
}

function __ZN23PreloadManagerOperation14SetFinalTimingEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 return;
}

function __ZN23ParticleSystemParticles13SetUsesLightsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 873 >> 0] = 1;
 __ZN14dynamic_bitset6resizeEjb(i1 + 600 | 0, HEAP32[i1 + 16 >> 2] & 2147483647, 0);
 return;
}

function __ZN22MemoryCacherReadBlocks10DirectReadEPvjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __Z13ReadFileCacheR15CacheReaderBasePvjj(i1, i2, i3, i4);
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE11GetPoolListEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i1 + 36 >> 2] | 0) >>> 0 > i2 >>> 0 ? i1 + 40 | 0 : i1 + 48 | 0) | 0;
}

function __ZN18ProceduralMaterial23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN18ProceduralMaterial8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN18ProceduralMaterial18SetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK8Vector4f(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN14dtPathCorridorC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = 0;
 HEAP8[i1 + 44 >> 0] = 0;
 HEAP32[i1 + 48 >> 2] = 0;
 return;
}

function __ZN13TextRendering4Font23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13TextRendering4Font8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13MemoryManager31ThreadTempAllocFrameMaintenanceEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 1552 >> 2] | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN10TagManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10TagManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10MonoScript8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10GameObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10GameObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10GUITexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10GUITexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10Collider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10AudioMixer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZL20ForwardInvokeDelayedP6ObjectPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 20 >> 2] | 0)) return 1;
 __ZN13MonoBehaviour18CallMethodInactiveEPKc(i1, i2) | 0;
 return 1;
}

function __Z98Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInFixedTimeInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926338 | 0, fb + 3 | 0);
 return;
}

function __Z97Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightFromIndexInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551682 | 0, fb + 44 | 0);
 return;
}

function __Z95Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParameterCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926086 | 0, fb + 2577 | 0);
 return;
}

function __Z7OpenURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 _JS_Eval_OpenURL(((HEAP8[i1 + 11 >> 0] | 0) < 0 ? HEAP32[i1 >> 2] | 0 : i1) | 0);
 return;
}

function __Z46getPxPrismaticJoint_ProjectionAngularTolerancePKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
}

function __Z46CleanupSpriteRendererAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161916 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1161916 >> 2] = 0;
 return;
}

function __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = _il2cpp_class_from_system_type(i1 | 0) | 0;
 return i1 | 0;
}

function __Z37VRSettings_Set_Custom_PropRenderScalef(f1) {
 f1 = Math_fround(f1);
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice14SetRenderScaleEf(__Z12GetIVRDevicev() | 0, f1);
 return;
}

function __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __Z35ReleaseInstanceLateBehaviourManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155112 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __Z32getPxVehicleAutoBoxData_UpRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
}

function __Z26setPxDistanceJoint_DampingPN5physx15PxDistanceJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 156 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z23GetCurrentRenderOptionsv() {
 var i1 = 0;
 i1 = __Z18GetQualitySettingsv() | 0;
 return HEAPU8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 81 >> 0] | 0 | 0;
}

function __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 + (i2 << 2) >> 2] = i3;
 return;
}

function __Z21ReleasePreloadManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163176 >> 2] | 0;
 if (i1 | 0) {
  __ZN14PreloadManagerD2Ev(i1);
  __ZdlPv(i1);
 }
 HEAP32[gb + 1163176 >> 2] = 0;
 return;
}

function __Z19getPxD6Joint_MotionPKN5physx9PxD6JointENS_8PxD6Axis4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, i1 | 0) | 0;
}

function __Z12SetToDefaultR11JointSpring(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(35.0e3);
 HEAPF32[i1 + 4 >> 2] = Math_fround(4500.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(.5);
 return;
}

function _UNITY_png_get_compression_type(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 26 >> 0] | 0;
 return i2 | 0;
}

function _SetFullscreen(i1) {
 i1 = i1 | 0;
 if (!(__Z19GetScreenManagerPtrv() | 0)) return;
 __ZN13ScreenManager24SetIsFullScreenImmediateEb(__Z16GetScreenManagerv() | 0, (i1 | 0) != 0);
 return;
}

function _llvm_ctlz_i64(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = Math_clz32(i1) | 0;
 if ((i1 | 0) == 32) i1 = i1 + (Math_clz32(i3) | 0) | 0;
 setTempRet0(0);
 return i1 | 0;
}

function _jpeg_open_backing_store(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i3 + 20 >> 2] = 49;
 mftCall_vi(HEAP32[i3 >> 2] | 0, i1 | 0);
 return;
}

function _conjf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(-Math_fround(HEAPF32[i2 + 4 >> 2]));
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAPF32[i1 + 4 >> 2] = f3;
 return;
}

function __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_400kDidModifyMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 120 >> 0] = 1;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateUpdateCaptureScreenshotstruct7ForwardEv() {
 if (!(__Z22NeedToPerformRenderingv() | 0)) return;
 __Z23UpdateCaptureScreenshotv();
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = i1 + 76 | 0;
 i1 = HEAP32[i3 >> 2] | 0;
 HEAP32[i3 >> 2] = i2;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK5physx2Sc9ClothCore19getPreviousTimeStepEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc9ClothCore18getSolverFrequencyEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0));
}

function __ZNK5physx13NpClothFabric13getRestvaluesEPfj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore13getRestvaluesEPfj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK13GfxDeviceNull14GetScissorRectEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 return;
}

function __ZNK13EmscriptenWWW6GetUrlEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 100 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  return i1 | 0;
 } else return i1 | 0;
 return 0;
}

function __ZN8Material21BuildShaderKeywordSetEv(i1) {
 i1 = i1 | 0;
 __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet(i1 + 80 | 0, (HEAP32[i1 + 100 >> 2] | 0) + 124 | 0);
 return;
}

function __ZN6IDList14SetSearchIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) <= -1) return;
 if ((HEAP32[i1 + 36 >> 2] | 0) <= (i2 | 0)) return;
 HEAP32[i1 + 44 >> 2] = i2;
 return;
}

function __ZN5physx2Sc5Scene15setCCDMaxPassesEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx10PxsContext15setCCDMaxPassesEj(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0, i1);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc17ParticleSystemSim14resetFilteringEv(i1);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData11enableWheelEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 44 + (i2 >>> 5 << 2) | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1 << (i2 & 31);
 return;
}

function __ZN5physx13NpClothFabricD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 106864 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 106864 + 112;
 __ZN5physx2Sc15ClothFabricCoreD2Ev(i1 + 16 | 0);
 return;
}

function __ZN5physx13NpClothFabric4loadERKNS_17PxClothFabricDescE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Sc15ClothFabricCore4loadERKNS_17PxClothFabricDescE(i2 + 16 | 0, i1) | 0;
}

function __ZN5Unity5Cloth17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE(__Z23GetLateBehaviourManagerv() | 0, i1 + 372 | 0);
 return;
}

function __ZN5Light5ResetEv(i1) {
 i1 = i1 | 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData5ResetEv(HEAP32[i1 + 44 >> 2] | 0);
 HEAPF32[i1 + 52 >> 2] = Math_fround(1.0);
 return;
}

function __ZN22BaseUnityConnectClient7IsStateENS_5StateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
 return (HEAP32[i1 >> 2] | 0) == (i2 | 0) | 0;
}

function __ZN21WorldParticleCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN20TextRenderingPrivate7GUIText11SetMaterialEP8Material(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 92 >> 2] = i1;
 return;
}

function __ZN20ArchiveStorageHeader17GetBlocksInfoSizeERKNS_10BlocksInfoE(i1) {
 i1 = i1 | 0;
 return ((((HEAP32[i1 + 20 >> 2] | 0) - (HEAP32[i1 + 16 >> 2] | 0) | 0) / 12 | 0) * 10 | 0) + 20 | 0;
}

function __ZN18CrashReportManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17FileSystemHandler11MoveToTrashER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
 return 1;
}

function __ZN14SafeBinaryRead20OverrideRootTypeNameEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 88 >> 2] | 0) + ((HEAP32[i1 + 100 >> 2] | 0) + -1 << 5) + 8 >> 2] = i2;
 return;
}

function __ZN14RenderSettings20SetReflectionBouncesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 376 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN14RenderSettings12CleanupClassEv() {
 __ZN12LightManager12CleanupClassEv();
 __ZN16ReflectionProbes12CleanupClassEv();
 __ZN28LightProbeProxyVolumeManager12CleanupClassEv();
 return;
}

function __ZN13UnityProfiler16EndProfilingModeE12ProfilerMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 24 >> 2] & i2)) return;
 __ZN13UnityProfiler11SetIsActiveEb(i1, 0);
 return;
}

function __ZN13EmscriptenWWW10OnProgressEPvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAPF32[i1 + 84 >> 2] = Math_fround(Math_fround(i2 >>> 0) / Math_fround(i3 >>> 0));
 return;
}

function __ZN13ConstantForce12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi(__Z24GetFixedBehaviourManagerv() | 0, i1 + 84 | 0, -1);
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfig11ResetValuesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 100;
 HEAP32[i1 + 4 >> 2] = 10;
 HEAP32[i1 + 8 >> 2] = 500;
 return;
}

function __ZN11AudioFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZL28CleanupModule_TerrainPhysicsv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z18GetITerrainPhysicsv() | 0, gb + 63624 | 0);
 __Z18SetITerrainPhysicsP15ITerrainPhysics(0);
 return;
}

function __ZL28CleanupModule_ParticleSystemv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z18GetIParticleSystemv() | 0, gb + 63264 | 0);
 __Z18SetIParticleSystemP15IParticleSystem(0);
 return;
}

function __Z53SceneManager_Get_Custom_PropSceneCountInBuildSettingsv() {
 var i1 = 0;
 i1 = __Z16GetBuildSettingsv() | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) >> 4 | 0;
}

function __Z45getPxSphericalJoint_ProjectionLinearTolerancePKN5physx16PxSphericalJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
}

function __Z45getPxPrismaticJoint_ProjectionLinearTolerancePKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
}

function __Z45CleanupRectTransformAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158344 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158344 >> 2] = 0;
 return;
}

function __Z45CleanupMonoBehaviourAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1163036 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1163036 >> 2] = 0;
 return;
}

function __Z44Physics2D_Set_Custom_PropAlwaysShowCollidersh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings22SetAlwaysShowCollidersEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z42getPxArticulationJoint_TangentialStiffnessPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0));
}

function __Z37Caching_Get_Custom_PropSpaceAvailablev() {
 var i1 = 0;
 i1 = __ZN14CachingManager23GetCachingDiskSpaceFreeEv(__Z17GetCachingManagerv() | 0) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __Z34setPxScene_BounceThresholdVelocityPN5physx7PxSceneEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 256 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z31setPxVehicleGearsData_GearRatioPN5physx18PxVehicleGearsDataENS0_4EnumEf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i3 + (i2 << 2) >> 2] = f1;
 return;
}

function __Z28RenderTextureSupportsStencilP13RenderTexture(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = (__Z12GetGfxDevicev() | 0) + 4396 | 0; else i1 = i1 + 100 | 0;
 return (HEAP32[i1 >> 2] | 0) > 1 | 0;
}

function __Z26setPxParticleBase_GridSizePN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 228 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z11GetPositioni(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function __ZZN8VRModuleC1EvEN25audioConfigurationChanged7ForwardEv() {
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice27OnAudioConfigurationChangedEv(__Z12GetIVRDevicev() | 0);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNKSt3__27collateIwE4hashEPKwS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNKSt3__27collateIcE4hashEPKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK5physx2Sc9ClothCore27getNbVirtualParticleWeightsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 240 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP7getCapsERNS_16PxBroadPhaseCapsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 256;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 1;
 return 1;
}

function __ZNK19TouchPhaseEmulation19IsMultiTouchEnabledEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 23 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 22 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK15ArchiveReadFile4SizeEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP32[i1 + 8 >> 2] | 0) + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZN9RigidbodyD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN9Rigidbody27GetMaxDepenetrationVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 220 >> 2] | 0, i1 | 0));
}

function __ZN5physx7NpScene29setDynamicTreeRebuildRateHintEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq17SceneQueryManager29setDynamicTreeRebuildRateHintEj(i2 + 3392 | 0, i1);
 return;
}

function __ZN5physx2Sc14ConstraintCore19prepareForSetBodiesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 68 >> 2] | 0;
 if (!i1) return;
 __ZN5physx2Sc13ConstraintSim15preBodiesChangeEv(i1);
 return;
}

function __ZN5physx27PxClothGeodesicTetherCookerD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN5physx31PxClothGeodesicTetherCookerImplD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN22VirtualJoystickManager23GetVirtualJoystickIndexEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb(i1, i2, 0) | 0;
}

function __ZN18ScriptingArguments11GetUInt64AtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + (i2 << 3) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 setTempRet0(HEAP32[i1 + 4 >> 2] | 0);
 return i2 | 0;
}

function __ZN18ProceduralMaterial17SetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __ZN18PlatformEffector2D12SetUseOneWayEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 76 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN17ArchiveFileSystem14UnmountArchiveEP20ArchiveStorageReader(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader(i1, i2);
 return 1;
}

function __ZN15QualitySettings17SetSoftVegetationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 81 >> 0] = i2 & 1;
 return;
}

function __ZN13RuntimeStaticI17UniqueIDGeneratorE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI17UniqueIDGeneratorE10InitializeEv(i1);
 return;
}

function __ZN13GfxDeviceNull16CreateDynamicVBOEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(100) | 0;
 __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj(i2, i1, 1, 0, 0);
 return i2 | 0;
}

function __ZN12TLSAllocatorI14StackAllocatorED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 27048 + 8;
 HEAP32[gb + 1103856 >> 2] = (HEAP32[gb + 1103856 >> 2] | 0) + -1;
 __ZdlPv(i1);
 return;
}

function __ZN11OffMeshLink16SetBiDirectionalEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 98 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN11AudioSource14SetRolloffModeE11RolloffMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 416 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN10Collider2D17SetUsedByEffectorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 53 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZL21DeveloperConsoleDoGUIPvN13MonoBehaviour13GUILayoutTypeEii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN16DeveloperConsole5DoGUIEv(i1) | 0;
}

function __Z7FTAllocP13FT_MemoryRec_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i2, 16, gb + 63392 | 0, 0, gb + 946903 | 0, 10) | 0;
}

function __Z6simd4iiiii(i1, i3, i4, i5, i2) {
 i1 = i1 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i2 = i2 | 0;
 __ZN13Simd4iFactoryIN6detail9FourTupleEEC2Eiiii(i1, i3, i4, i5, i2);
 return;
}

function __Z56setPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z54Physics_Set_Custom_PropDefaultSolverVelocityIterationsi(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManager34SetDefaultSolverVelocityIterationsEi(__Z17GetPhysicsManagerv() | 0, i1);
 return;
}

function __Z45getPxRevoluteJoint_ProjectionAngularTolerancePKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0));
}

function __Z43scripting_object_invoke_default_constructorP12Il2CppObjectPP15Il2CppException(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_runtime_object_init_exception(i1 | 0, i2 | 0);
 return;
}

function __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_NewObject13Il2Cpp_IntPtrS_P11Il2CppArrayRPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z33setPxCloth_SelfCollisionStiffnessPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 396 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z32GetShaderInstanceMatrixParamNamei(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 6) {
  i1 = gb + 480196 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 4e4 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z30Graphics_CUSTOM_DrawProcedural16GfxPrimitiveTypeii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii(i1, i2, i3);
 return;
}

function __Z29getPxSphericalJoint_LimitConePKN5physx16PxSphericalJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z25setPxParticleBase_DampingPN5physx14PxParticleBaseEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z21setPxCloth_TargetPosePN5physx7PxClothERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z21setPxCloth_GlobalPosePN5physx7PxClothERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z18GUIClip_CUSTOM_Popv() {
 var i1 = 0;
 i1 = (__Z11GetGUIStatev() | 0) + 96 | 0;
 __ZN12GUIClipState3PopER10InputEvent(i1, HEAP32[(__Z11GetGUIStatev() | 0) + 280 >> 2] | 0);
 return;
}

function __Z10GetGravityi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 4 >> 2] = Math_fround(0.0);
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 return;
}

function _UNITY_png_get_palette_max(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = -1;
  return i2 | 0;
 }
 i2 = HEAP32[i1 + 420 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_png_get_interlace_type(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 28 >> 0] | 0;
 return i2 | 0;
}

function b140(i1, i2, f3, i4, f5, f6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 i7 = i7 | 0;
 nullFunc_viififfi(140);
}

function _i64Add(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i3 = i1 + i3 >>> 0;
 return (setTempRet0(i2 + i4 + (i3 >>> 0 < i1 >>> 0 | 0) >>> 0 | 0), i3 | 0) | 0;
}

function _glCopyBufferSubData__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glCopyBufferSubData(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _emscripten_glStencilFuncSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glStencilFuncSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glRotatef__wrapper(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _emscripten_glRotatef(+f1, +f2, +f3, +f4);
}

function _emscripten_glRenderbufferStorage__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glRenderbufferStorage(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glDrawArraysInstanced__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glDrawArraysInstanced(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _cff_get_glyph_data(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _cff_index_access_element((HEAP32[i1 + 656 >> 2] | 0) + 1176 | 0, i2, i3, i4) | 0;
}

function __ZNSt3__26chrono12system_clock11from_time_tEl(i1) {
 i1 = i1 | 0;
 i1 = ___muldi3(i1 | 0, ((i1 | 0) < 0) << 31 >> 31 | 0, 1e6, 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212564 + 8;
 return;
}

function __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212612 + 8;
 return;
}

function __ZNKSt3__26locale4nameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, (HEAP32[i2 >> 2] | 0) + 144 | 0);
 return;
}

function __ZNK5physx7NpShape13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 36 >> 2] & 32 | 0) == 0 ? i1 + 176 | 0 : (HEAP32[i1 + 40 >> 2] | 0) + 48 | 0) >> 2]);
}

function __ZNK5physx2Sc9ClothCore26getNbSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 300 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore26getNbParticleAccelerationsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 316 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc8BodyCore10isSleepingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 51 >> 0] & 1) == 0;
 return i1 | 0;
}

function __ZNK5physx2Gu11HeightField17getTriangleNormalEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK5physx2Gu11HeightField25getTriangleNormalInternalEj(i1, i2, i3);
 return;
}

function __ZNK2UI6Canvas16GetTargetDisplayEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 344 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 return HEAP8[i1 + 374 >> 0] | 0;
}

function __ZNK14ParticleSystem18LimitParticleCountEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 2548 >> 2] | 0;
 return (i1 >>> 0 < i2 >>> 0 ? i1 : i2) | 0;
}

function __ZNK13TranslateGLES9FilterMinE17TextureFilterModeb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return HEAP32[(i3 ? gb + 75468 | 0 : gb + 75480 | 0) + (i2 << 2) >> 2] | 0;
}

function __ZN8Animator18SetApplyRootMotionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 417 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN7Texture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx7Cooking7releaseEv(i1) {
 i1 = i1 | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 return;
}

function __ZN5physx2Sq11getHitShapeEPKNS_3Scb5ShapeE(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZNK5physx2Sc9ShapeCore10getPxShapeEv(i1 + 16 | 0) | 0;
 return i1 | 0;
}

function __ZN5physx2Gu8EdgeListC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN5physx17MBPUpdateWorkTask11runInternalEv(i1) {
 i1 = i1 | 0;
 __ZN5physx16PxsBroadPhaseMBP9updatePPUEPNS_10PxBaseTaskE(HEAP32[i1 + 20 >> 2] | 0, HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZN5physx11AdjTriangle4FlipEv(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 + 4 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i3;
 return;
}

function __ZN5physx10PxsContext27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 84 >> 2] = i1;
 return;
}

function __ZN5audio5mixer21ValidateSnapshotIndexERNS0_18AudioMixerConstantEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((i2 | 0) > -1 ? (HEAP32[i1 + 32 >> 2] | 0) >>> 0 > i2 >>> 0 : 0) | 0;
}

function __ZN5Unity11AdjacenciesC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN26AnimatorOverrideController17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN12UserListNode5ClearEv(i1 + 120 | 0);
 __ZN25RuntimeAnimatorController17MainThreadCleanupEv(i1);
 return;
}

function __ZN23UnityPurchasingSettingsC2Ev(i1) {
 i1 = i1 | 0;
 __ZN19BaseConnectSettingsC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 189396 + 8;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 return;
}

function __ZN22VirtualJoystickManager22ConnectVirtualJoystickEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb(i1, i2, 1) | 0;
}

function __ZN19UnityConnectService20OnPlayerPausedStaticEPS_b(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i1, i2 ? 2 : 3);
 return;
}

function __ZN18ScriptingArguments10GetInt64AtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + (i2 << 3) | 0;
 i2 = HEAP32[i1 >> 2] | 0;
 setTempRet0(HEAP32[i1 + 4 >> 2] | 0);
 return i2 | 0;
}

function __ZN18BackgroundJobQueue11ScheduleJobEPFvPvES0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_(i1, i2, i3);
 return;
}

function __ZN18AnimatorController30OnInvalidateAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier(i1, gb + 1105796 | 0);
 return;
}

function __ZN17AudioCustomFilter12readCallbackEP14FMOD_DSP_STATEPfS2_jii(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN16ParticleRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 376 >> 2] | 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63264 | 0);
 return;
}

function __ZN16GUIKeyboardStateC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN15QualitySettings16SetSoftParticlesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 80 >> 0] = i2 & 1;
 return;
}

function __ZN15ParticleEmitter10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 204 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __ZN15MulticastSocket4RecvEPvjP12RecvUserData(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return __ZN6Socket4RecvEPvjP12RecvUserData(i1, i2, i3, i4) | 0;
}

function __ZN14SafeBinaryRead12IsOldVersionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP16[(__ZNK16TypeTreeIterator7GetNodeEv(HEAP32[i1 + 80 >> 2] | 0) | 0) >> 1] | 0) == (i2 | 0) | 0;
}

function __ZN14RenderSettings14SetAmbientModeENS_11AmbientModeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 188 >> 2] = i2;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN13AudioListener23SetAlternativeTransformEP9Transform(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 64 >> 2] = i1;
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE13SetDownloaderERNS0_14RestDownloaderE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 28 >> 2] = i2;
 return;
}

function __ZN11AudioSource14SetPlayOnAwakeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 497 | 0;
 if ((HEAPU8[i1 >> 0] | 0 | 0) == (i2 & 1 | 0)) return;
 HEAP8[i1 >> 0] = i2 & 1;
 return;
}

function __Z93Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddDirectionalLightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568100 | 0, fb + 669 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915093 | 0, fb + 4088 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914923 | 0, fb + 4086 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915008 | 0, fb + 4087 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914838 | 0, fb + 4085 | 0);
 return;
}

function __Z62setPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 100 >> 2] = f1;
 return;
}

function __Z57RenderSettings_Set_Custom_PropDefaultReflectionResolutioni(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings30SetDefaultReflectionResolutionEi(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z56setPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z52QualitySettings_Set_Custom_PropShadowNearPlaneOffsetf(f1) {
 f1 = Math_fround(f1);
 __ZN15QualitySettings24SetShadowNearPlaneOffsetEf(__Z18GetQualitySettingsv() | 0, f1);
 return;
}

function __Z44getPxRevoluteJoint_ProjectionLinearTolerancePKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0));
}

function __Z43Physics2D_Set_Custom_PropQueriesHitTriggersh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings21SetQueriesHitTriggersEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z41getPxArticulationJoint_InternalCompliancePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
}

function __Z41getPxArticulationJoint_ExternalCompliancePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
}

function __Z40getPxArticulationJoint_TangentialDampingPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0));
}

function __Z38Physics2D_CUSTOM_SetLayerCollisionMaskii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16Physics2DManager21SetLayerCollisionMaskEij(__Z19GetPhysicsManager2Dv() | 0, i1, i2);
 return;
}

function __Z32setPxCloth_SelfCollisionDistancePN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 388 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z29setPxMaterial_DynamicFrictionPN5physx10PxMaterialEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z27NavMesh_CUSTOM_SetLayerCostif(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __ZN22NavMeshProjectSettings11SetAreaCostEjf(__Z25GetNavMeshProjectSettingsv() | 0, i1, f2);
 return;
}

function __Z27CleanupTerrainPhysicsModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z18GetITerrainPhysicsv() | 0, gb + 63624 | 0);
 __Z18SetITerrainPhysicsP15ITerrainPhysics(0);
 return;
}

function __Z22setPxD6JointDriveFlagsPN5physx14PxD6JointDriveENS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __Z21IsThreadableGfxDevice17GfxDeviceRenderer(i1) {
 i1 = i1 | 0;
 i1 = i1 + -1 | 0;
 if (i1 >>> 0 < 21) return (1619971 >>> (i1 & 2097151) & 1 | 0) != 0 | 0; else return 0;
 return 0;
}

function __Z20RequiredComponentsOfP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return __ZN23ManagedAttributeManager21GetRequiredComponentsEP11Il2CppClass(__Z26GetManagedAttributeManagerv() | 0, i1) | 0;
}

function __Z11OpenConsolev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1450764 >> 2] | 0;
 if (i1 | 0) return i1 | 0;
 i1 = HEAP32[gb + 191868 >> 2] | 0;
 HEAP32[gb + 1450764 >> 2] = i1;
 return i1 | 0;
}

function _UNITY_FT_Init_Class_pshinter_interface(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 2632;
 HEAP32[i2 + 4 >> 2] = fb + 2633;
 HEAP32[i2 + 8 >> 2] = fb + 2634;
 return;
}

function _UNITY_FT_Init_Class_cff_service_cid_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 189;
 HEAP32[i2 + 4 >> 2] = fb + 1089;
 HEAP32[i2 + 8 >> 2] = fb + 456;
 return;
}

function b147(i1, f2, f3, f4, f5, f6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 nullFunc_vifffff(147);
}

function _ps_get_standard_strings(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 390) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP16[gb + 224484 + (i1 << 1) >> 1] | 0) + (gb + 947122) | 0;
 return i1 | 0;
}

function _mrand48() {
 var i1 = 0;
 i1 = ___rand48_step(gb + 228072 | 0, gb + 228072 + 6 | 0) | 0;
 i1 = _bitshift64Lshr(i1 | 0, getTempRet0() | 0, 16) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function _lrand48() {
 var i1 = 0;
 i1 = ___rand48_step(gb + 228072 | 0, gb + 228072 + 6 | 0) | 0;
 i1 = _bitshift64Lshr(i1 | 0, getTempRet0() | 0, 17) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212420 + 8;
 return;
}

function __ZNSt3__211char_traitsIwE4findEPKwjRS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i2) i1 = 0; else i1 = _wmemchr(i1, HEAP32[i3 >> 2] | 0, i2) | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK7Terrain23TryGetSplatBaseMaterialEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 112 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 72 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc9ClothCore25getNbSelfCollisionIndicesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 340 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx16PxBroadPhaseBase7getCapsERNS_16PxBroadPhaseCapsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return 1;
}

function __ZNK13MonoBehaviour17GetExecutionOrderEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 return i1 | 0;
}

function __ZNK13GfxDeviceNull11GetViewportEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 1;
 return;
}

function __ZNK13AnimationClip9IsLoopingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 216 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 1725 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZN9Transform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Transform8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9Texture3D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Texture3D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9Texture2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Texture2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9TextAsset8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9Rigidbody23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Rigidbody8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9Projector23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Projector8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9LensFlare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9LensFlare8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9AudioClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9AudioClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN9Animation23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Animation8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8Playable17GetScriptInstanceEPS_(i1) {
 i1 = i1 | 0;
 switch (i1 | 0) {
 case 0:
 case 2:
  {
   i1 = 0;
   break;
  }
 default:
  i1 = HEAP32[i1 + 4 >> 2] | 0;
 }
 return i1 | 0;
}

function __ZN5physx7NpScene11addMaterialERNS_10NpMaterialE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx3Scb5Scene11addMaterialERNS_2Sc12MaterialCoreE(i2 + 16 | 0, i1 + 32 | 0) | 0;
}

function __ZN5physx3Cct9SweepTest17onObstacleRemovedEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 152 | 0;
 if ((HEAP32[i1 >> 2] | 0) != (i2 | 0)) return;
 HEAP32[i1 >> 2] = -1;
 return;
}

function __ZN5physx2Sc10NPhaseCore15fetchFilterPairEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i2 + 108 >> 2] | 0) + (i1 >>> 5 << 2) >> 2] | 0) + ((i1 & 31) * 12 | 0) | 0;
}

function __ZN5physx14NpArticulation7getRootEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 92 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[HEAP32[i1 + 88 >> 2] >> 2] | 0;
 return i1 | 0;
}

function __ZN5Umbra6KDTree10getLUTSizeEi(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = i1 >>> 16;
 i3 = i1 >>> 8;
 return 3 - i3 + (i1 >>> 4) + (((1 - i2 + i3 | 0) >>> 1) + i2 << 2) & -4 | 0;
}

function __ZN4crnd12symbol_codec13stop_decodingEv(i1) {
 i1 = i1 | 0;
 i1 = (HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0;
 setTempRet0(((i1 | 0) < 0) << 31 >> 31 | 0);
 return i1 | 0;
}

function __ZN4File4LockENS_8LockModeEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor(HEAP32[i1 >> 2] | 0, i2, 0) | 0;
}

function __ZN2UI6Canvas23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN2UI6Canvas8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN22BuiltinResourceManager22InitializeAllResourcesEv() {
 __ZN22BuiltinResourceManager19InitializeResourcesEv(HEAP32[gb + 1162852 >> 2] | 0);
 HEAP8[gb + 1546595 >> 0] = 1;
 return;
}

function __ZN21AudioDistortionFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17CollisionMeshDataC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP8[i1 + 16 >> 0] = 0;
 return;
}

function __ZN16LightmapSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16LightmapSettings8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN16GraphicsSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16GraphicsSettings8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15UnityAdsManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15TerrainCollider14TerrainChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i2 | 0) != 256) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15QualitySettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15QualitySettings18SetPixelLightCountEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + ((HEAP32[i1 + 44 >> 2] | 0) * 108 | 0) + 16 >> 2] = i2;
 return;
}

function __ZN14dtNavMeshQueryC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = i1 + 8 | 0;
 i2 = i1 + 76 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN14RenderSettings19SetAmbientIntensityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 184 >> 2] = f2;
 __ZN14RenderSettings23UpdateFinalAmbientProbeEv(i1);
 return;
}

function __ZN13TextRendering4Font5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN20TextRenderingPrivate8FontImpl5ResetEv(HEAP32[i1 + 48 >> 2] | 0);
 HEAPF32[i1 + 32 >> 2] = Math_fround(.100000001);
 return;
}

function __ZN13PhysicsModule24CapsuleColliderSetHeightER15CapsuleColliderf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 __ZN15CapsuleCollider9SetHeightEf(i2, f3);
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader8CloseVFSEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 12 >> 0] | 0)) return;
 __ZN12FileAccessor5CloseEv(i1 + 1092 | 0) | 0;
 return;
}

function __ZN11JpegDecoder9ErrorExitEP18jpeg_common_struct(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 mftCall_vi(HEAP32[i2 + 8 >> 2] | 0, i1 | 0);
 _longjmp(i2 + 132 | 0, 1);
}

function __ZN10Effector2D18SetUseColliderMaskEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 56 >> 0] = i2 & 1;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __Z93Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInFixedTimeInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926509 | 0, fb + 28 | 0);
 return;
}

function __Z92Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815936 | 0, fb + 876 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsInTransitionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926001 | 0, fb + 983 | 0);
 return;
}

function __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924833 | 0, fb + 2576 | 0);
 return;
}

function __Z48Bounds_CUSTOM_INTERNAL_CALL_Internal_SqrDistanceRK4AABBRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__Z20CalculateSqrDistanceRK8Vector3fRK4AABB(i2, i1));
}

function __Z42CleanupBlendShapeAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161540 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1161540 >> 2] = 0;
 return;
}

function __Z37setPxScene_DynamicTreeRebuildRateHintPN5physx7PxSceneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 336 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z32setPxVehicleDriveTank_DriveModelPN5physx18PxVehicleDriveTankENS_30PxVehicleDriveTankControlModel4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 752 >> 2] = i1;
 return;
}

function __Z31ReleaseInstanceBehaviourManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155104 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __Z28setPxMaterial_StaticFrictionPN5physx10PxMaterialEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 36 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z26NavMesh_CUSTOM_SetAreaCostif(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __ZN22NavMeshProjectSettings11SetAreaCostEjf(__Z25GetNavMeshProjectSettingsv() | 0, i1, f2);
 return;
}

function __Z20setPxShape_LocalPosePN5physx7PxShapeERKNS_11PxTransformE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 68 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_get_image_height(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 4 >> 2] | 0;
 return i2 | 0;
}

function b3(i1, i2, f3, i4, f5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiififii(3);
 return 0;
}

function _glGetProgramBinary__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glGetProgramBinary(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function _emscripten_glUniform3f__wrapper(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _emscripten_glUniform3f(i1 | 0, +f2, +f3, +f4);
}

function _emscripten_glGetAttachedShaders__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetAttachedShaders(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function ___strdup(i2) {
 i2 = i2 | 0;
 var i1 = 0, i3 = 0;
 i3 = (_strlen(i2) | 0) + 1 | 0;
 i1 = _malloc(i3) | 0;
 if (!i1) i1 = 0; else _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateClearImmediateRenderersstruct7ForwardEv() {
 __ZN13RendererScene26ClearIntermediateRenderersEv(__Z16GetRendererScenev() | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN38EarlyUpdateExecuteMainThreadJobsstruct7ForwardEv() {
 __ZN18BackgroundJobQueue21ExecuteMainThreadJobsEv(__Z21GetBackgroundJobQueuev() | 0);
 return;
}

function __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNSt3__211char_traitsIcE4findEPKcjRS2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i2) i1 = 0; else i1 = _memchr(i1, HEAPU8[i3 >> 0] | 0, i2) | 0;
 return i1 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10date_orderEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10date_orderEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK8Animator21HasAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 108 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 624 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZNK6Camera20GetClipToWorldMatrixER10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z20InvertMatrix4x4_FullPKfPf(__ZNK6Camera20GetWorldToClipMatrixEv(i1) | 0, i2) | 0;
 return;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx2Sc5Scene22getClientBehaviorFlagsEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP8[(HEAP32[(HEAP32[i2 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 12 >> 0] | 0;
}

function __ZNK5physx2Sc5Scene21getBroadPhaseCallbackEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i2 + 1152 >> 2] | 0) + ((i1 & 255) << 2) >> 2] | 0) + 20 >> 2] | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 192 + ((i1 & 3) * 48 | 0) | 0;
}

function __ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i2 + 5988 + (i1 << 2) >> 2]);
}

function __ZNK14DirectorPlayer7GetTimeEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 if (!i1) {
  d2 = 0.0;
  return +d2;
 }
 d2 = +HEAPF64[i1 + 96 >> 3];
 return +d2;
}

function __ZNK12NavMeshAgent16GetInternalAgentEv(i1) {
 i1 = i1 | 0;
 return __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0, i1 + 68 | 0) | 0;
}

function __ZN9GfxDevice18SetGlobalDepthBiasEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 HEAPF32[i1 + 4368 >> 2] = f2;
 HEAPF32[i1 + 4372 >> 2] = f3;
 return;
}

function __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(HEAP32[i1 + 288 >> 2] | 0) + (i3 << 2) >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN8DateTime13GetDaysInYearEi(i1) {
 i1 = i1 | 0;
 if (!(i1 & 3)) return (((i1 | 0) % 100 | 0 | 0) != 0 | ((i1 | 0) % 400 | 0 | 0) == 0 ? 366 : 365) | 0; else return 365;
 return 0;
}

function __ZN5physx9PxTaskMgr14stopSimulationEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx5cloth10findBitSetEj(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = 0;
 while (1) {
  i1 = i1 >>> 1;
  if (!i1) {
   i1 = i2;
   break;
  } else i2 = i2 + 1 | 0;
 }
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx2Gu12TriangleMesh18setupMeshInterfaceEv(i1) {
 i1 = i1 | 0;
 __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv(i1 + 16 | 0);
 HEAP32[i1 + 32 >> 2] = i1 + 196;
 return;
}

function __ZN5physx20PxcNpCacheStreamPairC2ERNS_17PxcNpMemBlockPoolE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 8 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = 0;
 return;
}

function __ZN5physx16PxVehicleNoDrive14setDriveTorqueEjf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i3 + 132 >> 2] | 0) + (i2 << 2) >> 2] = f1;
 return;
}

function __ZN5physx16PxVehicleNoDrive14setBrakeTorqueEjf(i3, i2, f1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[i3 + 136 >> 2] | 0) + (i2 << 2) >> 2] = f1;
 return;
}

function __ZN2UI14CanvasRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN24PhysicsUpdateBehaviour2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN20TextRenderingPrivate15DynamicFontDataC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = i1 + 4;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN19TransportJavaScript5AbortEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 _JS_WebRequest_Abort(i2 | 0);
 HEAP8[i1 + 16 >> 0] = 1;
 return;
}

function __ZN14Texture2DArray15UpdateImageDataEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) __ZN14Texture2DArray13RebuildMipMapEv(i1);
 __ZN14Texture2DArray13UploadTextureEv(i1);
 return;
}

function __ZN14SerializedFile14AddExternalRefERK14FileIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20dynamic_block_vectorI14FileIdentifierE9push_backERKS0_(i1 + 92 | 0, i2);
 return;
}

function __ZN12TreeRenderer11RemoveTreesERK8Vector3ffi(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 __ZN12TreeRenderer11ReloadTreesEi(i1, 500);
 return;
}

function __ZN10GameObject23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10GameObject18TransferComponentsI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN10AtomicList3AddEP10AtomicNodeS1_i(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i3 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return 1;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetLayerWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925169 | 0, fb + 76 | 0);
 return;
}

function __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925084 | 0, fb + 40 | 0);
 return;
}

function __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815775 | 0, fb + 874 | 0);
 return;
}

function __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816021 | 0, fb + 877 | 0);
 return;
}

function __Z90Register_UnityEngine_Experimental_Director_DirectorPlayer_INTERNAL_CALL_PlayStructInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511997 | 0, fb + 2824 | 0);
 return;
}

function __Z46Physics2D_Set_Custom_PropAngularSleepTolerancef(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings24SetAngularSleepToleranceEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z42Physics2D_Set_Custom_PropShowColliderSleeph(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings20SetShowColliderSleepEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z35setPxVehicleClutchDataMAccuracyModePN5physx19PxVehicleClutchDataENS_27PxVehicleClutchAccuracyMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z30setPxCloth_SleepLinearVelocityPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 452 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z30setPxCloth_FrictionCoefficientPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 372 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z26GL_CUSTOM_IssuePluginEventi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 736 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z25GetBuiltinVectorParamNamei(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 110) {
  i1 = gb + 480196 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 40548 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z21SetNbBroadPhaseRemovePN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 76 + (i1 << 2) >> 2] = i3;
 return;
}

function __Z20RegisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1450796 >> 2] = i1;
 return;
}

function __Z17setPxScene_LimitsPN5physx7PxSceneERKNS_13PxSceneLimitsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z13WriteTypeTreeRK8TypeTreeR13dynamic_arrayIhLj1EEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK8TypeTree9BlobWriteER13dynamic_arrayIhLj1EEb(i1, i2, i3);
 return;
}

function __GLOBAL__sub_I_runtime_webrequest_lump_cpp() {
 HEAP32[gb + 1468908 >> 2] = gb + 1468908;
 HEAP32[gb + 1468908 + 4 >> 2] = gb + 1468908;
 HEAP32[gb + 1468908 + 8 >> 2] = 0;
 return;
}

function _UNITY_png_set_error_fn(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (!i1) return;
 HEAP32[i1 + 172 >> 2] = i2;
 HEAP32[i1 + 168 >> 2] = i3;
 return;
}

function _UNITY_png_get_filter_type(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 27 >> 0] | 0;
 return i2 | 0;
}

function __ZNK5physx2Sc9ClothCore23getNbCollisionTrianglesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + ((i1 & 3) * 48 | 0) | 0;
}

function __ZNK27AnimatorControllerParameter7GetNameEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) {
  i1 = HEAP32[i1 >> 2] | 0;
  return i1 | 0;
 } else return i1 | 0;
 return 0;
}

function __ZNK25ThreadsafeLinearAllocator19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZNK19LowerResBlitTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZNK13SplatDatabase22GetSpecularMetallicMapEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 if (!i1) return 0; else return (HEAP32[i1 + 4 >> 2] | 0 ? i1 : 0) | 0;
 return 0;
}

function __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN8WindZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8WindZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8Material23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Material8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8LODGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8LODGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8Collider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN8Animator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Animator8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN6SocketC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 65564 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 16384;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Sn13XmlNodeReader7setNodeERNS0_7XmlNodeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 28 >> 2] = 0;
 HEAP32[i2 + 12 >> 2] = i1;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx2Sc5Scene20setMeshContactMarginEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 6160 >> 2] = f1;
 return;
}

function __ZN5physx20PxsParticleSystemSim19passCollisionInputVENS_31PxvParticleCollisionUpdateInputE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 1304 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __ZN5physx17PxsContactManager6setCCDEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i2 = i2 + 8 | 0;
 i3 = HEAP32[i2 >> 2] & -7;
 HEAP32[i2 >> 2] = i1 ? i3 | 2 : i3;
 return;
}

function __ZN5physx16PxVehicleNoDrive13setSteerAngleEjf(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i3 + 128 >> 2] | 0) + (i1 << 2) >> 2] = f2;
 return;
}

function __ZN5physx14PxLightCpuTask7releaseEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx14NpSpatialIndex25setIncrementalRebuildRateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(HEAP32[i2 + 8 >> 2] | 0, i1);
 return;
}

function __ZN21UniformBufferTFMethodD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 77396 + 8;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN14DataBufferGLES7ReleaseEv(i1);
 return;
}

function __ZN20UnloadSceneOperation12GetDebugNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 68 | 0);
 return;
}

function __ZN19AudioHighPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN19AssetBundleManifest23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN18SpeedTreeWindAssetD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN18AudioMixerSnapshotD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17PolygonCollider2D11RefreshPolyEv(i1) {
 i1 = i1 | 0;
 __ZN9Polygon2D16CheckConsistencyEv(i1 + 160 | 0);
 __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D(i1, 1, 0);
 return;
}

function __ZN16LightmapSettings14SetLightProbesEP11LightProbes(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 32 >> 2] = i1;
 return;
}

function __ZN15ResourceManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15ResourceManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14ParticleSystem22SetUsesEmitAccumulatorEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi(HEAP32[i1 + 32 >> 2] | 0, i2);
 return;
}

function __ZN14CachingManager21GetAuthorizationLevelEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 return ((HEAP8[i1 + 8 >> 0] | 0) == 0 ? ((i2 | 0) == 2 ? 2 : 0) : i2) | 0;
}

function __ZN13UnityProfiler10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i1 = i1 + 28 | 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 ? i3 | 1 : i3 & -2;
 return;
}

function __ZN13RuntimeStaticI15ApplicationInfoE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI15ApplicationInfoE10InitializeEv(i1);
 return;
}

function __ZN13RuntimeStaticI13ModuleManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 4 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13BuildSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11UnityEngine9Analytics15AnalyticsConfig12EventsConfig11ResetValuesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 100;
 HEAP32[i1 + 4 >> 2] = 10;
 HEAP32[i1 + 8 >> 2] = 500;
 return;
}

function __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerIndexInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925e3 | 0, fb + 979 | 0);
 return;
}

function __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646956 | 0, fb + 276 | 0);
 return;
}

function __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647039 | 0, fb + 333 | 0);
 return;
}

function __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631914 | 0, fb + 239 | 0);
 return;
}

function __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631997 | 0, fb + 296 | 0);
 return;
}

function __Z90Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerNameInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924917 | 0, fb + 978 | 0);
 return;
}

function __Z89Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddAmbientLightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568018 | 0, fb + 3093 | 0);
 return;
}

function __Z89Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanChangeInputsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550669 | 0, fb + 1804 | 0);
 return;
}

function __Z66ShaderVariantCollection_ShaderVariant_CUSTOM_Internal_CheckVariantP12Il2CppObject14ShaderPassTypeP11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z45Profiler_CUSTOM_SetTempAllocatorRequestedSizej(i1) {
 i1 = i1 | 0;
 return (__ZN13MemoryManager29SetTempAllocatorRequestedSizeEj(__Z16GetMemoryManagerv() | 0, i1) | 0) & 1 | 0;
}

function __Z44UnityConnectSettings_Set_Custom_PropTestModeh(i1) {
 i1 = i1 | 0;
 __ZN20UnityConnectSettings11SetTestModeEb(__Z23GetUnityConnectSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z32Caching_Get_Custom_PropSpaceUsedv() {
 var i1 = 0;
 i1 = __ZN14CachingManager23GetCachingDiskSpaceUsedEv(__Z17GetCachingManagerv() | 0) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __Z31getPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj(i1, i2));
}

function __Z31getPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx16PxVehicleNoDrive14getBrakeTorqueEj(i1, i2));
}

function __Z30scripting_method_has_attribute21ScriptingMethodIl2CppP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_method_has_attribute(HEAP32[i1 >> 2] | 0, i2 | 0) | 0;
}

function __Z30getPxRigidBody_AngularVelocityPKN5physx11PxRigidBodyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z29setPxCloth_StiffnessFrequencyPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z29setPxCloth_CollisionMassScalePN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 380 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z25getPxPrismaticJoint_LimitPKN5physx16PxPrismaticJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z25GetBuiltinTexEnvParamNamei(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 22) {
  i1 = gb + 480196 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 40460 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z25GetBuiltinMatrixParamNamei(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 19) {
  i1 = gb + 480196 | 0;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 40236 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __Z25EnsureLoopFrameContinuityI11QuaternionfEvR17AnimationCurveTplIT_E(i1) {
 i1 = i1 | 0;
 __Z35EnsureQuaternionContinuityLoopFrameR17AnimationCurveTplI11QuaternionfE(i1);
 return;
}

function __Z19setPxShape_GeometryPN5physx7PxShapeERKNS_10PxGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z17GetTransformDepthR9Transform(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = 0;
 while (1) {
  i1 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i1) break; else i2 = i2 + 1 | 0;
 }
 return i2 | 0;
}

function __GLOBAL__sub_I_runtime_allocator_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1103840 | 0, gb + 364565 | 0, 19, 2);
 return;
}

function _UNITY_png_get_color_type(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 25 >> 0] | 0;
 return i2 | 0;
}

function _UNITY_FT_Reference_Library(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 33;
  return i1 | 0;
 }
 i1 = i1 + 224 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 i1 = 0;
 return i1 | 0;
}

function _fseek_file_func(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 if (i4 >>> 0 < 3) {
  _fseek(i2, i3, i4) | 0;
  i1 = 0;
 } else i1 = -1;
 return i1 | 0;
}

function _emscripten_glStencilOpSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glStencilOpSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetProgramInfoLog__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetProgramInfoLog(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glBlendFuncSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glBlendFuncSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZThn24_NK5physx2Sc16ActorInteraction13getNPhaseCoreEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 + -24 + 4 >> 2] | 0) | 0) + 1104 >> 2] | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK9Rigidbody21GetMaxAngularVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 252 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc9ClothCore22getNbMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 268 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore22getNbCollisionConvexesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore22getNbCollisionCapsulesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK2UI13RectTransform7GetRectEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 177 >> 0] | 0) __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE(i1, 0, 0);
 return i1 + 120 | 0;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -8 >> 2] | 0) >>> 1 | 0;
}

function __ZNK13SliderJoint2D13GetLimitStateEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 140 >> 2] | 0;
 return i1 | 0;
}

function __ZNK13MonoBehaviour13GetScriptTypeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return i1 | 0;
}

function __ZNK11Rigidbody2D10IsSleepingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 92 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP16[i1 + 4 >> 1] & 2) == 0;
 return i1 | 0;
}

function __ZN9WWWCached7GetSizeEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 454652 | 0, 314, 1, 0, 0, 0);
 return 0;
}

function __ZN9WWWCached7GetDataEv(i1) {
 i1 = i1 | 0;
 __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE(gb + 580340 | 0, 0, gb + 454652 | 0, 304, 1, 0, 0, 0);
 return 0;
}

function __ZN9Rigidbody16SetInterpolationE22RigidbodyInterpolation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 102 >> 0] = i2;
 __ZN9Rigidbody23UpdateInterpolationNodeEv(i1);
 return;
}

function __ZN8Gradient16SetConstantColorE11ColorRGBA32(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 HEAP8[i1 + 65 >> 0] = 1;
 HEAP8[i1 + 64 >> 0] = 1;
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 32 | 0;
 HEAP32[i1 + 4 >> 2] = HEAP32[i2 >> 2];
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx23PxSpringGeneratedValuesC2EPKNS_8PxSpringE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __ZN23ManagedAttributeManager12CleanupClassEv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1165824 >> 2] | 0, gb + 63848 | 0);
 HEAP32[gb + 1165824 >> 2] = 0;
 return;
}

function __ZN21LightProbeProxyVolume23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN20ExternalForcesModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN18BackgroundJobQueue10InitializeEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 21 | 0;
 if (HEAP8[i1 >> 0] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP8[i1 >> 0] = 1;
 i1 = 1;
 return i1 | 0;
}

function __ZN18AudioLowPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17PhysicsMaterial2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17FileSystemHandler6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN16LightmapSettings24SetEnlightenSceneMappingERK21EnlightenSceneMapping(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN21EnlightenSceneMappingaSERKS_(i1 + 100 | 0, i2) | 0;
 return;
}

function __ZN15ParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15OcclusionPortal23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14StackAllocatorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26936 + 8;
 __ZN13MemoryManager12LowLevelFreeEPvj(HEAP32[i1 + 32 >> 2] | 0, HEAP32[i1 + 36 >> 2] | 0);
 return;
}

function __ZN13GfxDeviceNull17DestroySubProgramEPN9ShaderLab10SubProgramE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 __ZN9ShaderLab10SubProgramD2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN13GfxDeviceGLES17DestroySubProgramEPN9ShaderLab10SubProgramE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 __ZN9ShaderLab10SubProgramD2Ev(i2);
 __ZdlPv(i2);
 return;
}

function __ZN12MeshRenderer13SetSharedMeshE4PPtrI4MeshE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 376 >> 2] = HEAP32[i2 >> 2];
 __ZN12MeshRenderer16UpdateCachedMeshEv(i1);
 return;
}

function __ZN12AudioManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL38CleanupUnityWebRequestScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1468904 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1468904 >> 2] = 0;
 return;
}

function __ZL38CleanupParticlesLegacyScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1469452 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1469452 >> 2] = 0;
 return;
}

function __Z90Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralIndirectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559017 | 0, fb + 16 | 0);
 return;
}

function __Z89Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResolveHashInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 925919 | 0, fb + 982 | 0);
 return;
}

function __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551450 | 0, fb + 1809 | 0);
 return;
}

function __Z88Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927807 | 0, fb + 4150 | 0);
 return;
}

function __Z59setPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 96 >> 2] = f1;
 return;
}

function __Z50QualitySettings_Set_Custom_PropShadowCascade2Splitf(f1) {
 f1 = Math_fround(f1);
 __ZN15QualitySettings22SetShadowCascade2SplitEf(__Z18GetQualitySettingsv() | 0, f1);
 return;
}

function __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedMethod13Il2Cpp_IntPtrS_hRPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z48setPxVehicleAckermannGeometryDataMAxleSeparationPN5physx30PxVehicleAckermannGeometryDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z45Physics2D_Set_Custom_PropMaxAngularCorrectionf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings23SetMaxAngularCorrectionEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z45Physics2D_Set_Custom_PropLinearSleepTolerancef(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings23SetLinearSleepToleranceEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z41Physics2D_Set_Custom_PropShowColliderAABBh(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings19SetShowColliderAABBEb(__Z20GetPhysics2DSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z35Debug_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_RK10ColorRGBAffh(i1, i2, i3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 return;
}

function __Z34getPxCloth_CentrifugalInertiaScalePKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 168 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z29getPxRigidBody_LinearVelocityPKN5physx11PxRigidBodyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z29getPxRigidBody_CMassLocalPosePKN5physx11PxRigidBodyE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z28ReleaseInstanceUpdateManagerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1155116 >> 2] | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __Z25setPxMaterial_RestitutionPN5physx10PxMaterialEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z17GetBuildTimestampv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i2 + 4 >> 2] = 0;
 HEAP16[i1 >> 1] = 0;
 HEAP32[i1 + 4 >> 2] = 1483535639;
 return;
}

function _UNITY_png_get_rowbytes(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 + 12 >> 2] | 0;
 return i2 | 0;
}

function _UNITY_png_get_bit_depth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 24 >> 0] | 0;
 return i2 | 0;
}

function _wcsdup(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (_wcslen(i1) | 0) + 1 | 0;
 i3 = _malloc(i2 << 2) | 0;
 if (!i3) i1 = 0; else i1 = _wmemcpy(i3, i1, i2) | 0;
 return i1 | 0;
}

function __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 _memcpy(i1 | 0, i3 | 0, i2 - i3 | 0) | 0;
 return;
}

function __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 + -12 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK6Avatar13HasRootMotionEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 40 >> 2] | 0) != -1;
 return i1 | 0;
}

function __ZNK5physx31PxClothGeodesicTetherCookerImpl23getNbTethersPerParticleEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 88 >> 2] | 0) >>> 0) / ((HEAP32[i1 + 4 >> 2] | 0) >>> 0) | 0 | 0;
}

function __ZNK5physx2Sc9ClothCore21getNbVirtualParticlesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc9ClothCore21getNbCollisionSpheresEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc15ClothFabricCore20getNbParticleIndicesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK19TransportJavaScript9GetStatusEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZNK12HingeJoint2D13GetLimitStateEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 60 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 224 >> 2] | 0;
 return i1 | 0;
}

function __ZN9Texture2D19UnloadFromGfxDeviceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((HEAP8[i1 + 112 >> 0] | 0) == 0 | i2)) return;
 __ZN9Texture2D16DeleteGfxTextureEv(i1);
 return;
}

function __ZN7Terrain23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Terrain8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN7Joint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5physx2Sq12BucketPruner11shiftOriginERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq16BucketPrunerCore11shiftOriginERKNS_6PxVec3E(i2 + 16 | 0, i1);
 return;
}

function __ZN5Unity17ToNovodexInfinityEf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = f1 == Math_fround(inf);
 return Math_fround(i2 ? Math_fround(3402823469999999843913219.0e14) : f1);
}

function __ZN4Mesh21AcquireSharedMeshDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 i2 = i1 + 4 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + 1;
 return i1 | 0;
}

function __ZN25MinMaxOptimizedPolyCurves9IntegrateEv(i1) {
 i1 = i1 | 0;
 __ZN24OptimizedPolynomialCurve9IntegrateEv(i1);
 __ZN24OptimizedPolynomialCurve9IntegrateEv(i1 + 40 | 0);
 return;
}

function __ZN20BufferedSocketStream18CanSendNonblockingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((HEAP32[i1 + 20 >> 2] | 0) - (HEAP32[i1 + 40 >> 2] | 0) | 0) >>> 0 >= i2 >>> 0 | 0;
}

function __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 380 >> 2] = i1;
 return;
}

function __ZN19CloudServiceHandler17PauseEventHandlerEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN11UnityEngine15CloudWebService19SessionEventManager5PauseEb(i1 + 200 | 0, i2) | 0;
}

function __ZN19CharacterController23CreateControllerManagerEv() {
 var i1 = 0;
 i1 = _PxCreateControllerManager(__Z16GetDynamicsScenev() | 0) | 0;
 HEAP32[gb + 1457412 >> 2] = i1;
 return;
}

function __ZN18PlatformEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17PhysicsMaterial2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17AudioChorusFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN16b2StackAllocatorC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 102400 >> 2] = 0;
 HEAP32[i1 + 102404 >> 2] = 0;
 HEAP32[i1 + 102408 >> 2] = 0;
 HEAP32[i1 + 102796 >> 2] = 0;
 return;
}

function __ZN14RenderSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14RenderSettings8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14PreloadManager17IsLoadingOrQueuedEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 12 >> 2] | 0) {
  i1 = 1;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 32 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZN14PlayerSettings23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PlayerSettings8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14ParticleSystem24SetCustomSimulationSpaceERK4PPtrI9TransformE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 288 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN14ParticleSystem23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14ParticleSystem8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13SpringJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13SliderJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11UnityEngine15CloudWebService19SessionEventManager5CloseEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) i1 = 0; else {
  HEAP32[i1 >> 2] = 0;
  i1 = 1;
 }
 return i1 | 0;
}

function __ZN11TimeManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11IMGUIModule26SetDeveloperConsoleVisibleEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[gb + 1468316 >> 2] | 0;
 if (!i1) return;
 HEAP8[i1 >> 0] = i2 & 1 ^ 1;
 return;
}

function __ZL37CleanupParticleSystemScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1452344 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1452344 >> 2] = 0;
 return;
}

function __Z87Register_UnityEngine_Networking_DownloadHandler_INTERNAL_CALL_InternalCreateAssetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028277 | 0, fb + 328 | 0);
 return;
}

function __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551370 | 0, fb + 1808 | 0);
 return;
}

function __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanSetWeightsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550751 | 0, fb + 1805 | 0);
 return;
}

function __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_set_enableCaptureExceptionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039955 | 0, fb + 3933 | 0);
 return;
}

function __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedField13Il2Cpp_IntPtrS_hRPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z43UnityConnectSettings_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 __ZN20UnityConnectSettings10SetEnabledEb(__Z23GetUnityConnectSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z42getPxFixedJoint_ProjectionAngularTolerancePKN5physx12PxFixedJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
}

function __Z40getPxRigidDynamic_StabilizationThresholdPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i1 | 0));
}

function __Z40getPxRigidDynamic_ContactReportThresholdPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 300 >> 2] | 0, i1 | 0));
}

function __Z39getPxParticleFluid_RestParticleDistancePKN5physx15PxParticleFluidE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0));
}

function __Z34getPxJoint_RelativeAngularVelocityPKN5physx7PxJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z33getPxCloth_MotionConstraintConfigPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 240 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z33getPxCloth_AngularDragCoefficientPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 196 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z33Coroutine_CUSTOM_ReleaseCoroutineP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 __ZN9Coroutine18CleanupCoroutineGCEPv(i1);
 return;
}

function __Z30getPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(__ZNK5physx16PxVehicleNoDrive13getSteerAngleEj(i1, i2));
}

function __Z24getPxRevoluteJoint_LimitPKN5physx15PxRevoluteJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 132 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z18SetNbBroadPhaseAddPN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 64 + (i1 << 2) >> 2] = i3;
 return;
}

function __Z10SetNbShapePN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 20 + (i1 << 2) >> 2] = i3;
 return;
}

function _UNITY_png_permit_mng_features(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i1 & 5;
 if (!i2) {
  i2 = 0;
  return i2 | 0;
 }
 HEAP32[i2 + 596 >> 2] = i1;
 i2 = i1;
 return i2 | 0;
}

function _UNITY_png_get_channels(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP8[i2 + 29 >> 0] | 0;
 return i2 | 0;
}

function _emscripten_glUniformMatrix4fv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glUniformMatrix4fv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glUniformMatrix3fv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glUniformMatrix3fv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glUniformMatrix2fv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glUniformMatrix2fv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetShaderInfoLog__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetShaderInfoLog(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 12 | 0);
 return;
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLL12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc19ShapeInstancePairLL12onDeactivateEj(i2 + -8 | 0, i1) | 0;
 return 1;
}

function __ZNSt3__221recursive_timed_mutexC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 84 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZNSt3__221__thread_specific_ptrINS_15__thread_structEE16__at_thread_exitEPv(i1) {
 i1 = i1 | 0;
 if (i1 | 0) {
  __ZNSt3__215__thread_structD2Ev(i1);
  __ZdlPv(i1);
 }
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbumpEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (i2 << 2);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5gbumpEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (i2 << 2);
 return;
}

function __ZNK9Transform11IsSceneRootEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 100 >> 2] | 0) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 8 >> 2] & 1048576 | 0) == 0;
 return i1 | 0;
}

function __ZNK9Rigidbody13GetUseGravityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return ((mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0) & 2) == 0 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 68 >> 2]);
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 60 >> 2]);
}

function __ZNK5physx2Sc9ClothCore20getNbCollisionPlanesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0) | 0;
}

function __ZN9UdpSocket5CloseEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 17 | 0;
 if (!(HEAP8[i2 >> 0] | 0)) return;
 _close(HEAP32[i1 + 4 >> 2] | 0) | 0;
 HEAP8[i2 >> 0] = 0;
 return;
}

function __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN9GfxDevice17DestroyGpuProgramEPK10GpuProgram(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 return;
}

function __ZN8Animator16SetStabilizeFeetEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) return;
 HEAP8[(HEAP32[i1 + 128 >> 2] | 0) + 16 >> 0] = i2 & 1;
 return;
}

function __ZN8Animator13BatchedIKPassERK13dynamic_arrayI11DirectorJobLj8EE(i1) {
 i1 = i1 | 0;
 __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb(i1, 0, 1, 0);
 return;
}

function __ZN8Animator13BatchedFKPassERK13dynamic_arrayI11DirectorJobLj8EE(i1) {
 i1 = i1 | 0;
 __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb(i1, 1, 0, 0);
 return;
}

function __ZN5physx2Sc5Scene19scheduleParticleGpuERNS_10PxBaseTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0);
 return i1 | 0;
}

function __ZN5physx2Sc13ConstraintSim8getRigidEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = HEAP32[i2 + 104 >> 2] | 0;
 return HEAP32[((i1 | 0) == 0 ? i2 + 4 | 0 : i2 + 8 | 0) >> 2] | 0;
}

function __ZN5Umbra20ObjectDistanceParams26setMinRelativeContributionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 20 >> 2] = f2;
 return;
}

function __ZN31ParticleSystemParticlesTempDataD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __ZN20SphericalHarmonicsL27SetZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 108 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN18ProceduralMaterial19SetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN18AsyncUploadManager12HasCompletedE10AsyncFence(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + 4 >> 2] | 0) != (HEAP32[(HEAP32[i2 >> 2] | 0) + 140 >> 2] | 0) | 0;
}

function __ZN18AnimatorController17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN18AnimatorController10ClearAssetEv(i1);
 __ZN25RuntimeAnimatorController17MainThreadCleanupEv(i1);
 return;
}

function __ZN17SurfaceEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17PolygonCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Collider2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN16SubstanceArchive23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN16ReflectionSample10InvalidateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 124 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN15TextureSettings14GetAnisoLimitsERiS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 56192 >> 2];
 HEAP32[i2 >> 2] = HEAP32[gb + 56196 >> 2];
 return;
}

function __ZN13WheelCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13OcclusionArea23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12WheelJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12ServerSocket6AcceptEv(i1) {
 i1 = i1 | 0;
 i1 = _accept(HEAP32[i1 + 4 >> 2] | 0, 0, 0) | 0;
 __ZN6Socket10CheckErrorEiPKcii(i1, gb + 584832 | 0, 11, 0) | 0;
 return i1 | 0;
}

function __ZL36CleanupTextRenderingScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1467896 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1467896 >> 2] = 0;
 return;
}

function __Z9ReadPixelI11ColorRGBA32ET_PKh13TextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32(i2, i3, i1);
 return;
}

function __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551772 | 0, fb + 45 | 0);
 return;
}

function __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551853 | 0, fb + 15 | 0);
 return;
}

function __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFrameMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647262 | 0, fb + 277 | 0);
 return;
}

function __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFrameMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647342 | 0, fb + 334 | 0);
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetPlayStateInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550987 | 0, fb + 3013 | 0);
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetPlayStateInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550908 | 0, fb + 1807 | 0);
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927653 | 0, fb + 4148 | 0);
 return;
}

function __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_get_enableCaptureExceptionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039876 | 0, fb + 291 | 0);
 return;
}

function __Z53setPxSimulationStatisticsParticlesGpuMeshCacheHitratePN5physx22PxSimulationStatisticsEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 884 >> 2] = f1;
 return;
}

function __Z50setPxVehicleDifferential4WDataMFrontLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z45QualitySettings_Set_Custom_PropSoftVegetationh(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings17SetSoftVegetationEb(__Z18GetQualitySettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z44Physics2D_Set_Custom_PropMaxTranslationSpeedf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings22SetMaxTranslationSpeedEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z44Physics2D_Set_Custom_PropMaxLinearCorrectionf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings22SetMaxLinearCorrectionEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z41getPxFixedJoint_ProjectionLinearTolerancePKN5physx12PxFixedJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
}

function __Z40getPxArticulation_StabilizationThresholdPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
}

function __Z37CleanupLightAnimationBindingInterfacev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1111236 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1111236 >> 2] = 0;
 return;
}

function __Z33getPxJoint_RelativeLinearVelocityPKN5physx7PxJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z32getPxCloth_LinearDragCoefficientPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 188 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z32Screen_Get_Custom_PropFullScreenv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0) & 1 | 0;
}

function __Z27setPxJoint_InvInertiaScale1PN5physx7PxJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 96 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z27setPxJoint_InvInertiaScale0PN5physx7PxJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z26setPxCloth_SolverFrequencyPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z26setPxCloth_DragCoefficientPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 200 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z22setPxArticulation_NamePN5physx14PxArticulationEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 116 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __GLOBAL__sub_I_SizeByVelocityModule_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1452140 | 0, gb + 615349 | 0, 7, 0);
 return;
}

function _UNITY_png_get_image_width(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!((i1 | 0) != 0 & (i2 | 0) != 0)) {
  i2 = 0;
  return i2 | 0;
 }
 i2 = HEAP32[i2 >> 2] | 0;
 return i2 | 0;
}

function mftCall_vd(i2, d1) {
 i2 = i2 | 0;
 d1 = +d1;
 if ((i2 | 0) >= (fb | 0) & (i2 | 0) < (fb + 1 | 0)) {
  FUNCTION_TABLE_vd[i2 - fb & 1](+d1);
  return;
 }
 ftCall_vd(i2 | 0, +d1);
}

function b136(i1, i2, i3, f4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiiifiii(136);
 return 0;
}

function b125(i1, f2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iifiiiii(125);
 return 0;
}

function __ZNSt3__219__shared_mutex_baseC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZNKSt3__28numpunctIwE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 16 | 0);
 return;
}

function __ZNKSt3__28numpunctIcE11do_groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 12 | 0);
 return;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData11getTireDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP32[i2 + 32 >> 2] | 0) + ((i1 >>> 2) * 944 | 0) + 384 + ((i1 & 3) << 6) | 0;
}

function __ZNK20LocalFileSystemPosix8FilenameERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _strrchr(i2, 47) | 0;
 if (!i1) i1 = _strrchr(i2, 92) | 0;
 return i1 + 1 | 0;
}

function __ZNK14UnityWebStream13IsReadyToPlayEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 19 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP8[i1 + 16 >> 0] | 0) != 0;
 return i1 | 0;
}

function __ZNK13GfxDeviceNull27GetActiveRenderDepthSurfaceEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = HEAP32[i2 + 4904 >> 2] | 0;
 if (!i1) i1 = HEAP32[i2 + 4404 >> 2] | 0;
 return i1 | 0;
}

function __ZNK10MonoScript13GetScriptTypeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return i1 | 0;
}

function __ZN9Texture2D11EncodeToPNGER13dynamic_arrayIhLj1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZL18Texture2D_EncodeToP9Texture2DR13dynamic_arrayIhLj1EEii(i1, i2, 0, 0) | 0;
}

function __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0;
}

function __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, 4) | 0;
}

function __ZN6Sprite23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Sprite8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN6Shader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Shader8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN6Camera23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Camera8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN6Avatar23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Avatar8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5physx3Cct17CapsuleController16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 52 >> 2] = f1;
 return;
}

function __ZN20SphericalHarmonicsL17SetZeroEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 48 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN20LocalFileSystemPosixD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 71220 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 4 | 0);
 return;
}

function __ZN18BuoyancyEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN17ProceduralTexture8SetOwnerEP18ProceduralMaterial(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 84 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN17ProceduralTexture17TextureParametersC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 62;
 return;
}

function __ZN16GraphicsSettings18GetBuiltinMaterialENS_19BuiltinMaterialTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) i1 = HEAP32[i1 + 124 >> 2] | 0; else i1 = 0;
 return i1 | 0;
}

function __ZN15AudioEchoFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14PhysicMaterialD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13WheelCollider17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 __ZN8Collider17MainThreadCleanupEv(i1);
 return;
}

function __ZN13GfxDeviceNull15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN13GfxDeviceNull14ImmediateColorEffff(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 return;
}

function __ZN13GfxDeviceGLES15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN13AnimationClip23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13AnimationClip8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12HandlerChain11MoveToTrashER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0, i2 | 0, 1) | 0;
}

function __ZN10SampleClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10Effector2D15SetColliderMaskEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 60 >> 2] = i2;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZL35CleanupUnityConnectScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1469184 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1469184 >> 2] = 0;
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927345 | 0, fb + 947 | 0);
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_HasStateInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926670 | 0, fb + 172 | 0);
 return;
}

function __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927499 | 0, fb + 986 | 0);
 return;
}

function __Z85Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MoveGameObjectToScenev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563063 | 0, fb + 3065 | 0);
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_DisconnectInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552278 | 0, fb + 3014 | 0);
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_AnimationLayerMixerPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914613 | 0, fb + 3804 | 0);
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetRemoveStartOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914535 | 0, fb + 4084 | 0);
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetRemoveStartOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914457 | 0, fb + 2528 | 0);
 return;
}

function __Z49setPxVehicleDifferential4WDataMRearLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z49RenderSettings_Set_Custom_PropReflectionIntensityf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings22SetReflectionIntensityEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewObjectArrayi13Il2Cpp_IntPtrS_RPv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function __Z43RenderSettings_CUSTOM_INTERNAL_set_fogColorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings11SetFogColorERK10ColorRGBAf(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z37NavMeshPath_CUSTOM_DestroyNavMeshPathP12Il2CppObject(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN11NavMeshPathD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __Z31getPxCloth_SimulationFilterDataPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 432 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z31getPxCloth_ExternalAccelerationPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 208 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z27scripting_gchandle_weak_newP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = _il2cpp_gchandle_new_weakref(i1 | 0, 0) | 0;
 return i1 | 0;
}

function __Z26getPxRigidActor_GlobalPosePKN5physx12PxRigidActorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 84 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z20IsFloatTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 i1 = i1 + -6 | 0;
 if (i1 >>> 0 < 18) return (159745 >>> (i1 & 262143) & 1 | 0) != 0 | 0; else return 0;
 return 0;
}

function __GLOBAL__sub_I_runtime_virtualfilesystem_lump_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1548958 | 0, fb + 3454 | 0, fb + 3455 | 0, 0, 0);
 return;
}

function __GLOBAL__sub_I_runtime_misc3_lump_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1162860 | 0, gb + 454719 | 0, 10, 0);
 return;
}

function _XXH32_hashFromCanonical(i1) {
 i1 = i1 | 0;
 return _llvm_bswap_i32(HEAPU8[i1 >> 0] | HEAPU8[i1 + 1 >> 0] << 8 | HEAPU8[i1 + 2 >> 0] << 16 | HEAPU8[i1 + 3 >> 0] << 24 | 0) | 0;
}

function _UNITY_png_set_text_compression_window_bits(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 312 >> 2] = (i2 | 0) > 15 ? 15 : (i2 | 0) < 8 ? 8 : i2;
 return;
}

function b146(i1, i2, f3, i4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 nullFunc_iiififf(146);
 return 0;
}

function _emscripten_glTexCoordPointer__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glTexCoordPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetShaderSource__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetShaderSource(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glFrustum__wrapper(d1, d2, d3, d4, d5, d6) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 _emscripten_glFrustum(+d1, +d2, +d3, +d4, +d5, +d6);
}

function _cf2_outline_reset(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 _UNITY_FT_GlyphLoader_Rewind(HEAP32[i2 + 12 >> 2] | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4 | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 4 | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8 | 0);
 return;
}

function __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) + 8 | 0);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv(i1 + -4 | 0);
 return;
}

function __ZNSt3__26locale2id6__initEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1474568 >> 2] | 0;
 HEAP32[gb + 1474568 >> 2] = i2 + 1;
 HEAP32[i1 + 4 >> 2] = i2 + 1;
 return;
}

function __ZNSt3__218shared_timed_mutexC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 128 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZNSt3__215recursive_mutex4lockEv(i1) {
 i1 = i1 | 0;
 i1 = _pthread_mutex_lock(i1 | 0) | 0;
 if (i1 | 0) __ZNSt3__220__throw_system_errorEiPKc(i1, gb + 1082435 | 0);
 return;
}

function __ZNK9Rigidbody17GetSleepThresholdEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0));
}

function __ZNK5physx2Sc9ClothCore18getNbRestPositionsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx22PxVehicleWheelsDynData22getTireForceShaderDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK19ShaderPropertySheet16GetSerializeSizeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 84 >> 2] | 0) + 32 + ((HEAP32[i1 + 64 >> 2] | 0) + (HEAP32[i1 + 44 >> 2] | 0) << 2) | 0;
}

function __ZNK13GfxDeviceGLES27GetActiveRenderDepthSurfaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0) + 244 >> 2] | 0;
}

function __ZN9GfxDevice12ImmediateEndEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4408 >> 2] | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 __ZN13DrawImmediate11FlushBufferEv(i1);
 return;
}

function __ZN7mecanim5human18BoneParentFromTDoFEi(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 6) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 177784 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 92656 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx13NpClothFabric4loadERNS_13PxInputStreamE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Sc15ClothFabricCore4loadERNS_13PxInputStreamE(i2 + 16 | 0, i1) | 0;
}

function __ZN5Unity11SpringJointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 112584 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7SystemI21getMasterChannelGroupEPPNS_12ChannelGroupE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[(HEAP32[i1 + 316 >> 2] | 0) + 20 >> 2];
 return 0;
}

function __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN23AnimationOffsetPlayableD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN17CollisionMeshData20VertexDataHasChangedEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) if (!(HEAP32[i1 + 12 >> 2] | 0)) return;
 HEAP8[i1 + 16 >> 0] = 1;
 return;
}

function __ZN17AudioReverbFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15PointEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14Texture2DArray23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14PhysicsManager14CleanupReportsEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1457404 >> 2] | 0;
 mftCall_viii(HEAP32[(HEAP32[i1 >> 2] | 0) + 164 >> 2] | 0, i1 | 0, 0, 0);
 return;
}

function __ZN14PhysicMaterial23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12_GLOBAL__N_110Connection15unlockOutStreamEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12_GLOBAL__N_110Connection13lockOutStreamEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 24 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZN12CubemapArray15UpdateImageDataEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) __ZN12CubemapArray13RebuildMipMapEv(i1);
 __ZN12CubemapArray13UploadTextureEv(i1);
 return;
}

function __ZN11TimeManager21DidFinishLoadingSceneEv(i1) {
 i1 = i1 | 0;
 HEAPF64[i1 + 168 >> 3] = -+HEAPF64[i1 + 64 >> 3];
 HEAP8[i1 + 128 >> 0] = 1;
 HEAP8[i1 + 129 >> 0] = 1;
 return;
}

function __Z9ReadPixelI10ColorRGBAfET_PKh13TextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf(i2, i3, i1);
 return;
}

function __Z87Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926429 | 0, fb + 4 | 0);
 return;
}

function __Z84Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByBuildIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562638 | 0, fb + 3061 | 0);
 return;
}

function __Z84Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_RectangleContainsScreenPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014694 | 0, fb + 476 | 0);
 return;
}

function __Z84Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanDestroyInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550831 | 0, fb + 1806 | 0);
 return;
}

function __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927888 | 0, fb + 4151 | 0);
 return;
}

function __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924664 | 0, fb + 4147 | 0);
 return;
}

function __Z83Register_UnityEngine_Networking_DownloadHandlerScript_InternalSetPreallocatedBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028652 | 0, fb + 4304 | 0);
 return;
}

function __Z48setPxVehicleTireLoadFilterDataMMaxNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z47NavMesh_CUSTOM_SetPathfindingIterationsPerFramei(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager32SetPathfindingIterationsPerFrameEi(__Z17GetNavMeshManagerv() | 0, i1);
 return;
}

function __Z44QualitySettings_Set_Custom_PropSoftParticlesh(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings16SetSoftParticlesEb(__Z18GetQualitySettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z41Physics_Set_Custom_PropQueriesHitTriggersh(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManager21SetQueriesHitTriggersEb(__Z17GetPhysicsManagerv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z41Caching_Set_Custom_PropCompressionEnabledh(i1) {
 i1 = i1 | 0;
 __ZN14CachingManager21SetCompressionEnabledEb(__Z17GetCachingManagerv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z31getPxShape_SimulationFilterDataPKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 80 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z30setPxScene_NbContactDataBlocksPN5physx7PxSceneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 408 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z30getPxCloth_AngularInertiaScalePKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z30GetBuiltinMatrixParamArraySize24BuiltinShaderMatrixParam(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[(HEAP32[gb + 1157720 >> 2] | 0) + 100 >> 2] | 0) + (i1 << 1) >> 1] | 0;
}

function __Z24setPxShape_ContactOffsetPN5physx7PxShapeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 112 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z24setPxCloth_ContactOffsetPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 436 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z19setPxSceneDescFlagsPN5physx11PxSceneDescENS_7PxFlagsINS_11PxSceneFlag4EnumEtEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP16[i2 + 100 >> 1] = HEAP16[i1 >> 1] | 0;
 return;
}

function __Z19setPxRigidBody_MassPN5physx11PxRigidBodyEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 128 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z18setPxScene_GravityPN5physx7PxSceneERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 248 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_png_create_info_struct(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else {
  i1 = _UNITY_png_malloc_base(i1, 244) | 0;
  if (i1) _memset(i1 | 0, 0, 244) | 0;
 }
 return i1 | 0;
}

function _UNITY_png_crc_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 _UNITY_png_read_data(i1, i2, i3);
 _UNITY_png_calculate_crc(i1, i2, i3);
 return;
}

function b40(i1, i2, i3, i4, i5, i6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 f7 = Math_fround(f7);
 nullFunc_iiiiiiif(40);
 return 0;
}

function b10(i1, i2, i3, i4, f5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiiiifii(10);
 return 0;
}

function __ZZ24InitializeEngineGraphicsbEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv() {
 __ZN13RendererScene26ClearIntermediateRenderersEv(__Z16GetRendererScenev() | 0);
 return;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 460 >> 2] = f1;
 HEAP32[i2 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__28numpunctIwED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 212984 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 return;
}

function __ZNSt3__28numpunctIcED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 212944 + 8;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 12 | 0);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6cbeginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale1Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 64 >> 2]);
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale0Ev(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 56 >> 2]);
}

function __ZNK5physx3Ext20ProfileZoneInterface7getNameEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 44 + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31) | 0) == 0 | 0;
}

function __ZNK5physx14PxVehicleGraph14getLatestValueEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i2 + 3504 + (i1 << 10) + (HEAP32[i2 + 15824 >> 2] << 2) >> 2]);
}

function __ZNK26AnimatorOverrideController27GetAnimationClipsToRegisterEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK26AnimatorOverrideController16GetOverrideClipsEv(i1, i2);
 return;
}

function __ZNK17FileSystemHandler12LastModifiedERK13FileEntryData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 + 1056 >> 2] = 15;
 __ZN8DateTimeC2Ev(i1);
 return;
}

function __ZNK13SparseTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZNK13RenderTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZNK13GfxDeviceGLES26GetActiveRenderTargetCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0) + 248 >> 2] | 0;
}

function __ZN6Object19IsClassIDDeprecatedEi(i1) {
 i1 = i1 | 0;
 return (HEAP8[(__ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0) + 34 >> 0] | 0) != 0 | 0;
}

function __ZN6Avatar13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i1 + 76 | 0, gb + 1105876 | 0);
 return;
}

function __ZN5physx5cloth11BoundingBoxI8Scalar4fEC2ERKS3_(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN8Scalar4fC2ERKS_(i2, i1);
 __ZN8Scalar4fC2ERKS_(i2 + 16 | 0, i1 + 16 | 0);
 return;
}

function __ZN5physx2Sc8ShapeSim18onRestOffsetChangeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh(i1, 16, 1);
 return;
}

function __ZN5Light23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Light8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5Light13SetShadowTypeE10ShadowType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 96 >> 2] = i2;
 return;
}

function __ZN5Flare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Flare8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN2UI13RectTransform23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Transform8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN22AnimationMixerPlayableD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN19GfxThreadableDevice20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN18ProfilerConnection32HandleSetMemoryRecordModeMessageEPKvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[gb + 1163252 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __ZN18ProceduralMaterial16SetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN17PersistentManager18SetActiveNameSpaceEiNS_19ActiveNameSpaceTypeE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 84 + (i3 << 2) >> 2] = i2;
 return;
}

function __ZN17AudioReverbFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15TextureSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAPF32[i1 + 8 >> 2] = Math_fround(0.0);
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN15ReflectionProbe13SetResolutionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 52 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13SparseTexture23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13RuntimeStaticI12EventManagerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI12EventManagerE10InitializeEv(i1);
 return;
}

function __ZN13RuntimeStaticI12AdsIdHandlerE16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 >> 2] | 0) return;
 __ZN13RuntimeStaticI12AdsIdHandlerE10InitializeEv(i1);
 return;
}

function __ZN13RendererScene27SetPreventAddRemoveRendererEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 148 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + (i2 ? 1 : -1);
 return;
}

function __ZN13LoadOperation12GetDebugNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 148 | 0);
 return;
}

function __ZN13GfxDeviceNull12DeleteBufferEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 mftCall_vi(HEAP32[(HEAP32[i2 >> 2] | 0) + 4 >> 2] | 0, i2 | 0);
 return;
}

function __ZN13ComputeShader23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN10SampleClip8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN10SampleClip8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 return;
}

function __ZN10SampleClip8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetDurationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551214 | 0, fb + 10 | 0);
 return;
}

function __Z84Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815859 | 0, fb + 875 | 0);
 return;
}

function __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632220 | 0, fb + 3294 | 0);
 return;
}

function __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632296 | 0, fb + 1998 | 0);
 return;
}

function __Z5splatILj3EE8Scalar4fRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 + 12 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f3, f3, f3, f3);
 return;
}

function __Z52QualitySettings_Set_Custom_PropParticleRaycastBudgeti(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings24SetParticleRaycastBudgetEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z52QualitySettings_Set_Custom_PropAsyncUploadBufferSizei(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings24SetAsyncUploadBufferSizeEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z44setPxVehicleAckermannGeometryDataMFrontWidthPN5physx30PxVehicleAckermannGeometryDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z39getPxRigidBody_MinCCDAdvanceCoefficientPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 212 >> 2] | 0, i1 | 0));
}

function __Z39getPxRigidBody_MaxDepenetrationVelocityPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 220 >> 2] | 0, i1 | 0));
}

function __Z39GfxDeviceWaitForAllRenderJobsToCompletev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1157628 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0);
 return;
}

function __Z37getPxArticulation_SeparationTolerancePKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0));
}

function __Z36getPxRigidDynamic_MaxAngularVelocityPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 252 >> 2] | 0, i1 | 0));
}

function __Z36GiveDebuggerChanceToAttachIfRequiredv() {
 if (HEAP8[gb + 1546596 >> 0] | 0) return;
 if (!(_getenv(gb + 452002 | 0) | 0)) return;
 HEAP8[gb + 1546596 >> 0] = 1;
 return;
}

function __Z32getPxArticulationJoint_StiffnessPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0));
}

function __Z30GetBuiltinVectorParamArraySize24BuiltinShaderVectorParam(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[(HEAP32[gb + 1157720 >> 2] | 0) + 60 >> 2] | 0) + (i1 << 1) >> 1] | 0;
}

function __Z29scripting_field_has_attributeP11Il2CppClassP9FieldInfoS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _il2cpp_field_has_attribute(i2 | 0, i3 | 0) | 0;
}

function __Z29getPxCloth_LinearInertiaScalePKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z29getPxCloth_DampingCoefficientPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 180 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z29Cursor_Get_Custom_PropVisiblev() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0) & 1 | 0;
}

function __Z29Camera_Get_Custom_PropCurrentv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN13RenderManager19GetCurrentCameraPtrEv(__Z16GetRenderManagerv() | 0) | 0) | 0;
}

function __Z28CompareBlendShapeVertexIndexRK16BlendShapeVertexS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 36 >> 2] | 0) >>> 0 < (HEAP32[i2 + 36 >> 2] | 0) >>> 0 | 0;
}

function __Z24setPxJoint_InvMassScale1PN5physx7PxJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 88 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z24setPxJoint_InvMassScale0PN5physx7PxJointEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z23setPxCloth_InertiaScalePN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 172 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_TT_Clear_CodeRange(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i2 + -1 | 0;
 HEAP32[i1 + 444 + (i2 << 3) >> 2] = 0;
 HEAP32[i1 + 444 + (i2 << 3) + 4 >> 2] = 0;
 return;
}

function b89(i1, i2, i3, i4, i5, i6, i7, i8) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 i8 = i8 | 0;
 nullFunc_viiiiiiii(89);
}

function b53(i1, f2, i3, i4, f5, f6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 nullFunc_iifiiff(53);
 return 0;
}

function b149(i1, f2, f3, f4, f5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 nullFunc_viffffi(149);
}

function _sync() {
 var i1 = 0;
 i1 = STACKTOP;
 STACKTOP = STACKTOP + 16 | 0;
 if ((STACKTOP | 0) >= (STACK_MAX | 0)) abort();
 ___syscall36(36, i1 | 0) | 0;
 STACKTOP = i1;
 return;
}

function _glTransformFeedbackVaryings__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glTransformFeedbackVaryings(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glTexStorage2D__wrapper(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 _glTexStorage2D(i1 | 0, i2 | 0, i3 | 0, i4 | 0, i5 | 0);
}

function __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateMemoryFrameMaintenancestruct7ForwardEv() {
 __ZN13MemoryManager16FrameMaintenanceEb(__Z16GetMemoryManagerv() | 0, 0);
 return;
}

function __ZThn4_N5physx5cloth8SwSolver11removeClothEPNS0_5ClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx5cloth8SwSolver11removeClothEPNS0_5ClothE(i2 + -4 | 0, i1);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5c_strEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 _memcpy(i1 | 0, i3 | 0, i2 - i3 | 0) | 0;
 return;
}

function __ZNK5physx2Sc5Scene18getSolverBatchSizeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx10PxsContext18getSolverBatchSizeEv(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc15ClothFabricCore15getNbRestvaluesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK20LocalFileSystemPosix20GetUserAppDataFolderEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 184 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK16ChannelGroupData20GetMeasuredPeakLevelEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(Math_sqrt(Math_fround(HEAPF32[i1 + 36 + (i2 * 24 | 0) + 12 >> 2])));
}

function __ZNK13AudioListener19GetCurrentTransformEv(i1) {
 i1 = i1 | 0;
 return __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
}

function __ZN8Playable11DerivesFromEP11Il2CppClass(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0) == (i2 | 0) | 0;
}

function __ZN8Material20SetCustomRenderQueueEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 36 | 0;
 if ((HEAP32[i1 >> 2] | 0) == (i2 | 0)) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN7StriperC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 24 >> 2] = 0;
 return;
}

function __ZN7ApiGLES8DispatchEjjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 mftCall_viii(HEAP32[i1 + 468 >> 2] | 0, i2 | 0, i3 | 0, i4 | 0);
 return;
}

function __ZN5physx7Cooking16platformMismatchEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (i1 >>> 0 < 5) return (22 >>> (i1 & 31) & 1) != 0 | 0; else return 0;
 return 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx3Cct17CapsuleController13setStepOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 56 >> 2] = f1;
 return;
}

function __ZN5physx3Cct17CapsuleController13setSlopeLimitEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 48 >> 2] = f1;
 return;
}

function __ZN5physx2Sc8ShapeSim18onFilterDataChangeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh(i1, 1, 4);
 return;
}

function __ZN5physx2Sc18ParticleSystemCore20obtainStandaloneDataEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 return;
}

function __ZN5physx16PxsBroadPhaseMBP11shiftOriginERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN3MBP11shiftOriginERKN5physx6PxVec3E(HEAP32[i2 + 84 >> 2] | 0, i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 97640 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN21LightProbeProxyVolume12GetTransformEv(i1) {
 i1 = i1 | 0;
 return __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE(HEAP32[i1 + 28 >> 2] | 0, gb + 28940 | 0) | 0;
}

function __ZN21BillboardBatchManager24BillboardBatchFreeMemJobEP25DynamicVBOGeometryJobData(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __ZN21AnimationPosePlayableD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN21AnimationClipPlayableD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16ParticleRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN16MinMaxPolyCurves15DoubleIntegrateEv(i1) {
 i1 = i1 | 0;
 __ZN15PolynomialCurve15DoubleIntegrateEv(i1);
 __ZN15PolynomialCurve15DoubleIntegrateEv(i1 + 228 | 0);
 return;
}

function __ZN15NavMeshObstacle23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15LightProbeGroup23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15ConstantForce2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15AudioReverbZone23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15ArchiveReadFile5WriteEyyPKvPy(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 return 0;
}

function __ZN14FileCacherRead11GetPathNameEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 12 | 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper27GetApplicationInstallerNameEv(i1) {
 i1 = i1 | 0;
 __ZN15ApplicationInfo16GetInstallerNameEv(i1, __Z18GetApplicationInfov() | 0);
 return;
}

function __ZN11UmbraModule18DeleteShadowCullerEPN5Umbra15ShadowCullerExtE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 64016 | 0);
 return;
}

function __ZN11NamedObjectD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10RenderLoopC2ER6Camera(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 104 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN10MemoryPool10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 i1 = i1 + 32 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZL8StbAllocjPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 0, gb + 404494 | 0, 594) | 0;
}

function __ZL32CleanupPhysics2DScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1458416 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1458416 >> 2] = 0;
 return;
}

function __ZL32CleanupAnimationScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1466572 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1466572 >> 2] = 0;
 return;
}

function __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetDurationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551292 | 0, fb + 8 | 0);
 return;
}

function __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926749 | 0, fb + 77 | 0);
 return;
}

function __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926899 | 0, fb + 41 | 0);
 return;
}

function __Z83Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815699 | 0, fb + 873 | 0);
 return;
}

function __Z83Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551606 | 0, fb + 630 | 0);
 return;
}

function __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927049 | 0, fb + 945 | 0);
 return;
}

function __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927197 | 0, fb + 984 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552128 | 0, fb + 3617 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_StringToHashv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926263 | 0, fb + 2579 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927732 | 0, fb + 4149 | 0);
 return;
}

function __Z82Register_UnityEngine_Camera_set_useJitteredProjectionMatrixForTransparentRenderingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505190 | 0, fb + 2797 | 0);
 return;
}

function __Z82Register_UnityEngine_Camera_get_useJitteredProjectionMatrixForTransparentRenderingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505115 | 0, fb + 1630 | 0);
 return;
}

function __Z5splatILj2EE8Scalar4fRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 + 8 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f3, f3, f3, f3);
 return;
}

function __Z5splatILj1EE8Scalar4fRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 + 4 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f3, f3, f3, f3);
 return;
}

function __Z56setPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z49setPxVehicleSuspensionDataMCamberAtMaxCompressionPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z43setPxVehicleAckermannGeometryDataMRearWidthPN5physx30PxVehicleAckermannGeometryDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z42Physics2D_Set_Custom_PropVelocityThresholdf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings20SetVelocityThresholdEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z42Physics2D_Set_Custom_PropContactArrowScalef(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings20SetContactArrowScaleEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z42Physics2D_Set_Custom_PropBaumgarteTOIScalef(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings20SetBaumgarteTOIScaleEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z40getPxArticulationJoint_TwistLimitEnabledPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
}

function __Z40getPxArticulationJoint_SwingLimitEnabledPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0) | 0;
}

function __Z35getPxParticleBase_MaxMotionDistancePKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0));
}

function __Z34getPxRevoluteJoint_DriveForceLimitPKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0));
}

function __Z26getPxD6Joint_DrivePositionPKN5physx9PxD6JointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 176 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z24GetCurrentTimeAsDateTimev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _time(0) | 0;
 HEAP32[i1 >> 2] = ((i2 | 0) < 0) << 31 >> 31 & 65535;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __Z22setPxCloth_WakeCounterPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 460 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z22IsBuildTarget64BitBlob19BuildTargetPlatform(i1) {
 i1 = i1 | 0;
 i1 = i1 + -19 | 0;
 if (i1 >>> 0 < 7) return (97 >>> (i1 & 127) & 1) != 0 | 0; else return 0;
 return 0;
}

function __Z14CreateMemLabel18MemLabelIdentifierPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = HEAP32[i3 + -4 >> 2];
 return;
}

function _UNITY_png_set_swap(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 if ((HEAP8[i1 + 432 >> 0] | 0) != 16) return;
 i1 = i1 + 212 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 16;
 return;
}

function _LzmaDec_FreeProbs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 16 | 0;
 mftCall_vii(HEAP32[i2 + 4 >> 2] | 0, i2 | 0, HEAP32[i1 >> 2] | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function b17(i1, i2, i3, i4, i5, f6, f7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 f6 = Math_fround(f6);
 f7 = Math_fround(f7);
 nullFunc_viiiiiff(17);
}

function _wctrans(i1) {
 i1 = i1 | 0;
 if (!(_strcmp(i1, gb + 1069310 | 0) | 0)) i1 = 1; else {
  i1 = (_strcmp(i1, gb + 1069318 | 0) | 0) == 0;
  i1 = i1 ? 2 : 0;
 }
 return i1 | 0;
}

function _nrand48(i1) {
 i1 = i1 | 0;
 i1 = ___rand48_step(i1, gb + 228072 + 6 | 0) | 0;
 i1 = _bitshift64Lshr(i1 | 0, getTempRet0() | 0, 17) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function _jrand48(i1) {
 i1 = i1 | 0;
 i1 = ___rand48_step(i1, gb + 228072 + 6 | 0) | 0;
 i1 = _bitshift64Lshr(i1 | 0, getTempRet0() | 0, 16) | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function ___fpurge(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK9Rigidbody14GetAngularDragEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 244 >> 2] | 0, i1 | 0));
}

function __ZNK8Animator21GetAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 return __Z17dynamic_pptr_castIP18AnimatorController25RuntimeAnimatorControllerET_RK4PPtrIT0_E(i1 + 108 | 0) | 0;
}

function __ZNK8Animator13IsInitializedEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 168 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZNK5physx2Sc15ClothFabricCore14getNbParticlesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx27PxVehicleDifferentialNWData16getIsDrivenWheelEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + (i2 >>> 5 << 2) >> 2] & 1 << (i2 & 31) | 0) != 0 | 0;
}

function __ZNK13MonoBehaviour18ShouldRunBehaviourEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) return 1; else return (HEAP8[i1 + 36 >> 0] | 0) == 0 | 0;
 return 0;
}

function __ZNK11ICallString6LengthEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = _il2cpp_string_length(i1 | 0) | 0;
 return i1 | 0;
}

function __ZN9Rigidbody23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN9Behaviour23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN8Renderer20SetupSortingOverrideEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 220 >> 2] = HEAPU16[i1 + 338 >> 1] << 16 ^ -2147483648 | (HEAP16[i1 + 336 >> 1] | 0) + 32768;
 return;
}

function __ZN8Renderer10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 328 >> 0] = i2 & 1;
 __ZN8Renderer10SetVisibleEb(i1, (HEAP8[i1 + 329 >> 0] | 0) != 0);
 return;
}

function __ZN7mecanim5human14BoneFromMuscleEi(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) > 51) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 179672 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN5physx3Cct13BoxController16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 52 >> 2] = f1;
 return;
}

function __ZN5physx2Sc9ClothCore18clearInterpolationEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 304 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Gu9ContainerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAPF32[i1 + 12 >> 2] = Math_fround(2.0);
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 96588 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN4Mesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN4Mesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN4FMOD8ChannelI11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 168 >> 2] = i2;
 return 0;
}

function __ZN2UI6Canvas19UnloadFromGfxDeviceEv(i1) {
 i1 = i1 | 0;
 __ZN2UI7Batches7DestroyEv(i1 + 228 | 0);
 i1 = i1 + 224 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 6;
 return;
}

function __ZN2UI13RectTransform12CleanupClassEv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1158344 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1158344 >> 2] = 0;
 return;
}

function __ZN2UI11CanvasGroup23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN25ThreadsafeLinearAllocator13TryDeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0, i2 | 0);
 return 1;
}

function __ZN24MeshIntermediateRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN24MeshIntermediateRendererD2Ev(i1);
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1110380 >> 2] | 0, i1);
 return;
}

function __ZN22LocalFileSystemHandler19InitializeFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1040 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = i1;
 return;
}

function __ZN21AnimationClipPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 120 >> 2] = i2;
 return;
}

function __ZN19SkinnedMeshRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 340 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return;
 __Z21CompleteFenceInternalR8JobFence(i1);
 return;
}

function __ZN19CloudServiceHandler22ResetNetworkRetryIndexEv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcher22ResetNetworkRetryIndexEv(i1 + 792 | 0);
 return;
}

function __ZN15ReflectionProbeD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15NavMeshObstacleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15LightProbeGroupD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15AudioReverbZoneD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManager17SetSleepThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 if (!(HEAP32[gb + 1457408 >> 2] | 0)) return;
 HEAPF32[i1 + 44 >> 2] = f2;
 return;
}

function __ZN14DirectorPlayer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14AreaEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12b2BroadPhaseD2Ev(i1) {
 i1 = i1 | 0;
 __Z6b2FreePv(HEAP32[i1 + 32 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 44 >> 2] | 0);
 __Z6b2FreePv(HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN12_GLOBAL__N_110DataStream12disableCacheEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 408 >> 0] = 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobSchedulerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 189712 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 return;
}

function __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN11AssetBundle23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11AssetBundle8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL42RequestRecreateEyeTexturesBeforeNextUpdatev() {
 var i1 = 0;
 i1 = __Z12GetIVRDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __ZL20JpgWriteToBufferFuncPvS_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_viii(HEAP32[i1 >> 2] | 0, HEAP32[i1 + 4 >> 2] | 0, i2 | 0, i3 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631618 | 0, fb + 238 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631338 | 0, fb + 237 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631058 | 0, fb + 236 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631693 | 0, fb + 295 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631413 | 0, fb + 294 | 0);
 return;
}

function __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631133 | 0, fb + 293 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_ConnectInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552203 | 0, fb + 147 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551531 | 0, fb + 629 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927424 | 0, fb + 948 | 0);
 return;
}

function __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927578 | 0, fb + 987 | 0);
 return;
}

function __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632372 | 0, fb + 3295 | 0);
 return;
}

function __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632446 | 0, fb + 1999 | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_IsValidInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550536 | 0, fb + 1802 | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914764 | 0, fb + 3806 | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetAnimationClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914107 | 0, fb + 2526 | 0);
 return;
}

function __Z58setPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 872 >> 2] = i1;
 return;
}

function __Z51QualitySettings_Set_Custom_PropAsyncUploadTimeSlicei(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings23SetAsyncUploadTimeSliceEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z41NavMesh_CUSTOM_SetAvoidancePredictionTimef(f1) {
 f1 = Math_fround(f1);
 __ZN14NavMeshManager26SetAvoidancePredictionTimeEf(__Z17GetNavMeshManagerv() | 0, f1);
 return;
}

function __Z38setPxSceneDescCcdContactModifyCallbackPN5physx11PxSceneDescEPNS_26PxCCDContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 return;
}

function __Z33getPxRevoluteJoint_DriveGearRatioPKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 156 >> 2] | 0, i1 | 0));
}

function __Z30getPxArticulationJoint_DampingPKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
}

function __Z28getPxJoint_RelativeTransformPKN5physx7PxJointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z26PlayerSendFramePostPresentb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1115296 + 348 >> 2] | 0;
 if (!((i2 | 0) != 0 & i1)) return;
 mftCall_v(i2 | 0);
 return;
}

function __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1450800 >> 2] = i1;
 return;
}

function __Z21setPxShape_RestOffsetPN5physx7PxShapeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 120 >> 2] | 0, i2 | 0, +f1);
 return;
}

function __Z21setPxCloth_RestOffsetPN5physx7PxClothEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 mftCall_vif(HEAP32[(HEAP32[i2 >> 2] | 0) + 444 >> 2] | 0, i2 | 0, +f1);
 return;
}

function _png_get_uint_32(i1) {
 i1 = i1 | 0;
 return (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0) | 0;
}

function _glGetShaderPrecisionFormat__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetShaderPrecisionFormat(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glVertexPointer__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glVertexPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetRenderbufferParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetRenderbufferParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetInfoLogARB__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glGetInfoLogARB(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glBufferSubData__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glBufferSubData(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function ___strxfrm_l(i2, i3, i4, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i1 = _strlen(i3) | 0;
 if (i1 >>> 0 < i4 >>> 0) _strcpy(i2, i3) | 0;
 return i1 | 0;
}

function __ZSt14set_unexpectedPFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 216180 >> 2] | 0;
 HEAP32[gb + 216180 >> 2] = (i1 | 0) == 0 ? fb + 3 | 0 : i1;
 return i2 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6cbeginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK9GfxDevice28GetActiveRenderSurfaceHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, 0) | 0) + 8 >> 2] | 0;
}

function __ZNK8Renderer21GetWorldToLocalMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform21GetWorldToLocalMatrixEv(i1, __ZN8Renderer12GetTransformEv(i2) | 0);
 return;
}

function __ZNK8Renderer21GetLocalToWorldMatrixEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK9Transform21GetLocalToWorldMatrixEv(i1, __ZN8Renderer12GetTransformEv(i2) | 0);
 return;
}

function __ZNK5physx15NpParticleFluid23getRestParticleDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc18ParticleSystemCore23getRestParticleDistanceEv(i1 + 32 | 0));
}

function __ZNK5physx13NpClothFabric7getSetsEPjj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore7getSetsEPjj(i2 + 16 | 0, i3, i1) | 0;
}

function __ZNK13MonoBehaviour8GetClassEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx2Sc9ClothCore18unlockParticleDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc8ShapeSim16onMaterialChangeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh(i1, 2, 1);
 return;
}

function __ZN5physx2Sc7ElementD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 90952 + 8;
 __ZN5physx2Sc5Actor15onElementDetachERNS0_7ElementE(HEAP32[i1 + 8 >> 2] | 0, i1);
 return;
}

function __ZN5physx25PxDefaultFileOutputStreamD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87592 + 8;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 _fclose(i1) | 0;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 99220 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN2UI11CanvasGroupD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17WeakPtrSharedDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 70308 + 8;
 HEAP32[gb + 1178928 >> 2] = (HEAP32[gb + 1178928 >> 2] | 0) + -1;
 __ZdlPv(i1);
 return;
}

function __ZN16SubstanceArchive13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + 8 >> 2] = HEAP32[i1 + 4 >> 2];
 return;
}

function __ZN16Physics2DManager29ConvertCollision2DToScriptingEP11Collision2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z29ConvertCollision2DToScriptingP11Collision2D(i2) | 0;
}

function __ZN15FrictionJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15DistanceJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN15AnchoredJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14SphereCollider23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Collider8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14RenderSettings17SetLinearFogStartEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 336 >> 2] = f2;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN14ParticleSystem18SetSimulationSpaceE29ParticleSystemSimulationSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 280 >> 2] = i2;
 return;
}

function __ZN14ParticleSystem13SetRandomSeedEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 + 36 >> 2] | 0;
 HEAP8[i1 + 276 >> 0] = 0;
 HEAP32[i1 + 272 >> 2] = i2;
 return;
}

function __ZN14NavMeshManager20UpdateCarvingResultsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 104 >> 2] | 0;
 if (!i1) return;
 __ZN14NavMeshCarving17ApplyCarveResultsEv(i1);
 return;
}

function __ZN14DirectorPlayerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14AudioBehaviourD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13ConstantForce23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13AudioListener23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12b2ChainShape5ClearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 12 | 0;
 __Z6b2FreePv(HEAP32[i2 >> 2] | 0);
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZN12_GLOBAL__N_117EventBufferClient6unlockEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12CullingGroup18SetScriptingObjectEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = __Z22scripting_gchandle_newP12Il2CppObject(i2) | 0;
 return;
}

function __ZN11UnityEngine15CloudWebService17CloudJobScheduler11ScheduleJobEPFvPvES2_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(i2 | 0, i3 | 0);
 return 1;
}

function __ZN10SampleClip23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN10MonoScript23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL30CleanupTerrainScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1467748 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1467748 >> 2] = 0;
 return;
}

function __ZL30CleanupPhysicsScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1457452 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1457452 >> 2] = 0;
 return;
}

function __Z82Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558942 | 0, fb + 15 | 0);
 return;
}

function __Z81Register_UnityEngine_SceneManagement_SceneManager_LoadSceneAsyncNameIndexInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562782 | 0, fb + 148 | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_Playables_BeginIgnoreAllocationTrackerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552445 | 0, fb + 112 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUVChannelMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647698 | 0, fb + 3407 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646810 | 0, fb + 3401 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetAnimationTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646520 | 0, fb + 3399 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUVChannelMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647771 | 0, fb + 2047 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646883 | 0, fb + 3402 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetAnimationTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646593 | 0, fb + 2043 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_SetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638830 | 0, fb + 3351 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_GetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638903 | 0, fb + 3352 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631768 | 0, fb + 3292 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631841 | 0, fb + 3293 | 0);
 return;
}

function __Z80Register_UnityEngine_Experimental_Director_AnimationMixerPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914691 | 0, fb + 3805 | 0);
 return;
}

function __Z48setPxVehicleTireLoadFilterDataMMinNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z43Physics_Set_Custom_PropDefaultContactOffsetf(f1) {
 f1 = Math_fround(f1);
 __ZN14PhysicsManager23SetDefaultContactOffsetEf(__Z17GetPhysicsManagerv() | 0, f1);
 return;
}

function __Z41Physics2D_Set_Custom_PropMaxRotationSpeedf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings19SetMaxRotationSpeedEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z40scripting_liveness_calculation_from_rootP12Il2CppObjectPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_unity_liveness_calculation_from_root(i1 | 0, i2 | 0);
 return;
}

function __Z39getPxD6Joint_ProjectionAngularTolerancePKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0));
}

function __Z36getPxConstraint_MinResponseThresholdPKN5physx12PxConstraintE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 72 >> 2] | 0, i1 | 0));
}

function __Z35Matrix4x4_Get_Custom_PropIsIdentityRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 return (__ZNK10Matrix4x4f10IsIdentityEf(i1, Math_fround(HEAPF32[gb + 62452 >> 2])) | 0) & 1 | 0;
}

function __Z33getPxParticleBase_DynamicFrictionPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
}

function __Z32getPxRevoluteJoint_DriveVelocityPKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0));
}

function __Z26setPxScene_SolverBatchSizePN5physx7PxSceneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 424 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z26MonoGUIContentToTempNativeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 __Z22MonoGUIContentToNativeP12Il2CppObjectR10GUIContent(i1, gb + 1468220 | 0);
 return gb + 1468220 | 0;
}

function __Z24getPxD6Joint_LinearLimitPKN5physx9PxD6JointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z22GL_CUSTOM_LoadIdentityv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0, gb + 1162292 | 0);
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_png_set_compression_window_bits(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 292 >> 2] = (i2 | 0) > 15 ? 15 : (i2 | 0) < 8 ? 8 : i2;
 return;
}

function _Move_CVT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i2 = (HEAP32[i1 + 384 >> 2] | 0) + (i2 << 2) | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + i3;
 return;
}

function _png_get_int_32(i1) {
 i1 = i1 | 0;
 return (HEAPU8[i1 + 1 >> 0] | 0) << 16 | (HEAPU8[i1 >> 0] | 0) << 24 | (HEAPU8[i1 + 2 >> 0] | 0) << 8 | (HEAPU8[i1 + 3 >> 0] | 0) | 0;
}

function _iswcntrl(i1) {
 i1 = i1 | 0;
 if ((i1 & -2 | 0) == 8232 | (i1 >>> 0 < 32 | (i1 + -127 | 0) >>> 0 < 33)) i1 = 1; else i1 = (i1 + -65529 | 0) >>> 0 < 3;
 return i1 & 1 | 0;
}

function _funlockfile(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i3 = i1 + 68 | 0;
 i2 = (HEAP32[i3 >> 2] | 0) + -1 | 0;
 HEAP32[i3 >> 2] = i2;
 if (!i2) ___unlockfile(i1);
 return;
}

function __ZZ29InitializeTextRenderingModulevEN40CleanUpTextRenderingGarbageCollectstruct7ForwardEv() {
 __ZN20TextRenderingPrivate17TextMeshGenerator14GarbageCollectEv();
 return;
}

function __ZSt13set_terminatePFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 216092 >> 2] | 0;
 HEAP32[gb + 216092 >> 2] = (i1 | 0) == 0 ? fb + 2 | 0 : i1;
 return i2 | 0;
}

function __ZNSt3__26localeC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 __ZNSt3__214__shared_count12__add_sharedEv(i2);
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbumpEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5gbumpEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 return;
}

function __ZNSt13exception_ptrC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i2 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 ___cxa_increment_exception_refcount(i2 | 0);
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK9GfxDevice27GetActiveRenderSurfaceWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 348 >> 2] | 0, i1 | 0, 0) | 0) + 4 >> 2] | 0;
}

function __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj(i1, i2, 0);
 return;
}

function __ZNK5physx2Sc9ClothCore14getNbParticlesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i2 + 156 >> 2] | 0) + 31 >> 0] | 0) == 1 ^ i1 ^ 1 | 0;
}

function __ZNK5physx2Sc15ClothFabricCore12getNbTethersEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK16ChannelGroupData18GetMeasuredVULevelEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(Math_sqrt(Math_fround(HEAPF32[i1 + 36 + (i2 * 24 | 0) + 8 >> 2])));
}

function __ZNK15FileSystemEntry8FilenameEv(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = _strrchr(i2, 47) | 0;
 if (!i1) i1 = _strrchr(i2, 92) | 0;
 return (i1 | 0 ? i1 + 1 | 0 : i2) | 0;
}

function __ZN9RigidbodyD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP32[i1 + 44 >> 2] = 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN9GfxDevice28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2);
 return;
}

function __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2);
 return;
}

function __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2);
 return;
}

function __ZN6Object15IsClassIDSealedEi(i1) {
 i1 = i1 | 0;
 return (HEAP8[(__ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0) + 33 >> 0] | 0) != 0 | 0;
}

function __ZN5physx20PxsParticleSystemSim19obtainParticleStateEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 8 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx19PxsMaterialCombinerC2Eff(i3, f2, f1) {
 i3 = i3 | 0;
 f2 = Math_fround(f2);
 f1 = Math_fround(f1);
 HEAPF32[i3 >> 2] = f2;
 HEAPF32[i3 + 4 >> 2] = f1;
 return;
}

function __ZN5physx18PxsDynamicsContext12mergeResultsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx17PxcNpMemBlockPool23releaseConstraintMemoryEv((HEAP32[i1 + 96 >> 2] | 0) + 44 | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 99968 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx14SapPairManagerC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 40 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5physx13NpClothFabric16scaleRestlengthsEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 __ZN5physx2Sc15ClothFabricCore16scaleRestlengthsEf(i2 + 16 | 0, f1);
 return;
}

function __ZN5Unity5Cloth23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity5Cloth8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN2UI13CanvasManager17EmitDataForCameraEP6Camera(i1) {
 i1 = i1 | 0;
 __ZN2UI13CanvasManager21EmitGeometryForCameraEP6Camera(HEAP32[gb + 1467948 >> 2] | 0, i1);
 return;
}

function __ZN25SubstanceRawTextureSharedC2EPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = 1;
 HEAP32[i1 >> 2] = gb + 59344 + 8;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN22CreateGpuProgramOutput20CreateChannelAssignsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(4) | 0;
 HEAP32[i2 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return i2 | 0;
}

function __ZN16GUIKeyboardState8EndFrameEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv(i1);
 return;
}

function __ZN14SpriteRenderer12CleanupClassEv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1161916 >> 2] | 0, gb + 63320 | 0);
 HEAP32[gb + 1161916 >> 2] = 0;
 return;
}

function __ZN13TrailRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13LoadOperation13SetNoWorkToDoEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 60 >> 2] = Math_fround(1.0);
 i1 = i1 + 24 | 0;
 HEAP32[i1 >> 2] = 1;
 HEAP32[i1 >> 2] = 2;
 return;
}

function __ZN13GfxDeviceNull17ImmediateTexCoordEifff(i1, i2, f3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 return;
}

function __ZN13ConstantForceD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13AudioListenerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12TLSAllocatorI14StackAllocatorED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 27048 + 8;
 HEAP32[gb + 1103856 >> 2] = (HEAP32[gb + 1103856 >> 2] | 0) + -1;
 return;
}

function __ZN12NavMeshAgent23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN10TagManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10TagManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN10HumanTrait12RequiredBoneEi(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 24) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = __ZN7mecanim5human12RequiredBoneEj(i1) | 0;
 return i1 | 0;
}

function __ZN10GameObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10GameObject18TransferComponentsI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN10GameObject23InvokeDestroyedCallbackEPS_(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1104572 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __ZN10Collider2D12AddToManagerEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 72 >> 2] | 0) return;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN10AudioMixer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10AudioMixer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL22SortFloatArrayFunctionPKvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 return f3 < Math_fround(HEAPF32[i2 >> 2]) | 0;
}

function __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926595 | 0, fb + 2 | 0);
 return;
}

function __Z80Register_UnityEngine_ShaderVariantCollection_ShaderVariant_Internal_CheckVariantv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567168 | 0, fb + 668 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistanceMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627346 | 0, fb + 224 | 0);
 return;
}

function __Z80Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistanceMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627419 | 0, fb + 281 | 0);
 return;
}

function __Z79Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_ClearInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567946 | 0, fb + 3646 | 0);
 return;
}

function __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUseRandomRowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646666 | 0, fb + 3400 | 0);
 return;
}

function __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUseRandomRowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646738 | 0, fb + 2044 | 0);
 return;
}

function __Z79Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableInteriorCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643344 | 0, fb + 3385 | 0);
 return;
}

function __Z79Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableInteriorCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643416 | 0, fb + 2027 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetApplyFootIKv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914385 | 0, fb + 4083 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914035 | 0, fb + 4082 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetApplyFootIKv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914313 | 0, fb + 2527 | 0);
 return;
}

function __Z55ScriptableObject_CUSTOM_Internal_CreateScriptableObjectP12Il2CppObject(i1) {
 i1 = i1 | 0;
 __ZN9Scripting28CreateEngineScriptableObjectEP12Il2CppObject(i1);
 return;
}

function __Z46RenderSettings_Set_Custom_PropAmbientIntensityf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings19SetAmbientIntensityEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z44Time_Set_Custom_PropMaximumParticleDeltaTimef(f1) {
 f1 = Math_fround(f1);
 __ZN11TimeManager27SetMaximumParticleDeltaTimeEf(__Z14GetTimeManagerv() | 0, f1);
 return;
}

function __Z41setPxClothMotionConstraintConfigStiffnessPN5physx29PxClothMotionConstraintConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z39getPxArticulationJoint_ConcreteTypeNamePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z38getPxD6Joint_ProjectionLinearTolerancePKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0));
}

function __Z37setPxTriangleMeshGeometryTriangleMeshPN5physx22PxTriangleMeshGeometryEPNS_14PxTriangleMeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 return;
}

function __Z37setPxSceneDescSimulationEventCallbackPN5physx11PxSceneDescEPNS_25PxSimulationEventCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_method_get_param(HEAP32[i1 >> 2] | 0, i2 | 0) | 0;
}

function __Z32getPxRigidDynamic_SleepThresholdPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 264 >> 2] | 0, i1 | 0));
}

function __Z32getPxRigidDynamic_AngularDampingPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 244 >> 2] | 0, i1 | 0));
}

function __Z32getPxParticleBase_StaticFrictionPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0));
}

function __Z29scripting_gchandle_get_targetj(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) == -1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = _il2cpp_gchandle_get_target(i1 | 0) | 0;
 return i1 | 0;
}

function __Z26getPxShape_QueryFilterDataPKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z25Screen_Get_Custom_PropDpiv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
}

function __Z24SetExecutionRestrictions21ExecutionRestrictions(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1104728 >> 2] | 0;
 HEAP32[gb + 1104728 >> 2] = i1;
 return i2 | 0;
}

function __Z23getPxD6Joint_TwistLimitPKN5physx9PxD6JointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 152 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z23getPxD6Joint_SwingLimitPKN5physx9PxD6JointE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 160 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __GLOBAL__sub_I_ProfilerImpl_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1451004 | 0, gb + 585112 | 0, 14, 0);
 return;
}

function _glGetActiveUniformBlockiv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetActiveUniformBlockiv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glFramebufferRenderbuffer__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glFramebufferRenderbuffer(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glShaderSource__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glShaderSource(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glDrawElements__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glDrawElements(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glColorPointer__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glColorPointer(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLL10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx2Sc19ShapeInstancePairLL10onActivateEj(i2 + -8 | 0, i1) | 0;
}

function __ZNSt3__215messages_bynameIwEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212388 + 8;
 return;
}

function __ZNSt3__215messages_bynameIcEC2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 4 >> 2] = i3 + -1;
 HEAP32[i1 >> 2] = gb + 212356 + 8;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__set_long_capEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = i2 | -2147483648;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__set_long_capEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = i2 | -2147483648;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) i1 = HEAP32[i1 >> 2] | 0;
 return i1 | 0;
}

function __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP8[(HEAP32[i1 + 8 >> 2] | 0) + 50 >> 0] | 0;
 return i1 << 24 >> 24 == 1 | i1 << 24 >> 24 == 4 | 0;
}

function __ZNK5physx2Sc5Scene29getContactCorrelationDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 6164 >> 2]);
}

function __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5Umbra15GateStateVector8getStateEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 >> 5 << 2) >> 2] & 1 << (i2 & 31) | 0) != 0 | 0;
}

function __ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 return mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
}

function __ZNK14StackAllocator19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i1 | 0) == (i2 | 0) | 0;
}

function __ZN9Texture3D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN9TextAsset23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN7mecanim5human12BoneFromTDoFEi(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 6) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 177756 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZN5physx6shdfnd7FastXml8Callback21processXmlDeclarationERKNS1_14AttributePairsEPKci(i4, i1, i2, i3) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 1;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 464 >> 2] = f1;
 HEAP32[i2 + 540 >> 2] = 0;
 return;
}

function __ZN5physx3Cct13BoxController13setStepOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 56 >> 2] = f1;
 return;
}

function __ZN5physx3Cct13BoxController13setSlopeLimitEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 if (!(f1 > Math_fround(0.0))) return;
 HEAPF32[i2 + 48 >> 2] = f1;
 return;
}

function __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh(i1, i2, 1, 0, 0, 0);
 return;
}

function __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 56 >> 2] | 0;
 return mftCall_ii(HEAP32[HEAP32[i1 >> 2] >> 2] | 0, i1 | 0) | 0;
}

function __ZN5physx17AggregateAABBTask22setNumFastMovingShapesEjj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + 44 + (i2 * 60 | 0) + 56 >> 2] = i1;
 return;
}

function __ZN5physx13BigConvexDataC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 28 | 0;
 do {
  HEAP16[i1 >> 1] = 0;
  i1 = i1 + 2 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5Umbra15CameraTransform15setMatrixFormatENS_12MatrixFormatE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 432 >> 2] = i2;
 return;
}

function __ZN4FMOD7SystemI11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 372 >> 2] = i2;
 return 0;
}

function __ZN25RuntimeAnimatorController8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i2);
 return;
}

function __ZN20LocalFileSystemPosix9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return (_truncate(i2, i3) | 0) == 0 | 0;
}

function __ZN17AnimationPlayableD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Playable10DisconnectEPS_i(i1, i2);
 HEAP8[i1 + 56 >> 0] = 0;
 return;
}

function __ZN16RTreeCookerRemap5remapEPjjj(i3, i4, i2, i1) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i4 >> 2] = i2 << 5 | (i1 << 1) + 30 & 30 | 1;
 return;
}

function __ZN15TerrainRenderer11RenderStep2Ev(i1) {
 i1 = i1 | 0;
 __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode(i1, (HEAP32[i1 + 20 >> 2] | 0) + -64 | 0);
 return;
}

function __ZN14RenderSettings15SetLinearFogEndEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 340 >> 2] = f2;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN13RenderTexture23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12NavMeshAgentD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN12LineRenderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11UmbraModule30GetUmbraVisibilityOutputBufferEPKN5Umbra10VisibilityE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5Umbra10Visibility15getOutputBufferEv(i2) | 0;
}

function __ZN11AudioFilter23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL28CleanupIMGUIScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1468884 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1468884 >> 2] = 0;
 return;
}

function __ZL28CleanupClothScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1459024 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1459024 >> 2] = 0;
 return;
}

function __ZL28CleanupAudioScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1459932 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1459932 >> 2] = 0;
 return;
}

function __ZL23CheckAndClearChangedJobPiPK23TransformAccessReadOnlyj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZL20DidChangeActiveSceneP10UnitySceneS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14RenderSettings17UpdateGlobalStateEv(__Z21GetManagerFromContexti(25) | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetTimeInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551140 | 0, fb + 7 | 0);
 return;
}

function __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetTimeInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551066 | 0, fb + 9 | 0);
 return;
}

function __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926826 | 0, fb + 78 | 0);
 return;
}

function __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 926976 | 0, fb + 42 | 0);
 return;
}

function __Z79Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountInBuildSettingsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562282 | 0, fb + 207 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_Playables_EndIgnoreAllocationTrackerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552519 | 0, fb + 113 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927125 | 0, fb + 946 | 0);
 return;
}

function __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 927273 | 0, fb + 985 | 0);
 return;
}

function __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_SetActiveScenev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562425 | 0, fb + 1844 | 0);
 return;
}

function __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562496 | 0, fb + 3059 | 0);
 return;
}

function __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562567 | 0, fb + 3060 | 0);
 return;
}

function __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetActiveScenev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562354 | 0, fb + 3639 | 0);
 return;
}

function __Z78Register_UnityEngine_RenderBufferHelper_INTERNAL_CALL_GetNativeRenderBufferPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532107 | 0, fb + 2931 | 0);
 return;
}

function __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637714 | 0, fb + 3342 | 0);
 return;
}

function __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637785 | 0, fb + 2012 | 0);
 return;
}

function __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630786 | 0, fb + 3285 | 0);
 return;
}

function __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630857 | 0, fb + 1997 | 0);
 return;
}

function __Z78Register_UnityEngine_Experimental_Director_GenericMixerPlayable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 551934 | 0, fb + 3616 | 0);
 return;
}

function __Z77Register_UnityEngine_Networking_UnityWebRequest_InternalGetResponseHeaderKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033499 | 0, fb + 2760 | 0);
 return;
}

function __Z5splatILj0EE8Scalar4fRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i2 >> 2]);
 __ZN8Scalar4fC2Effff(i1, f3, f3, f3, f3);
 return;
}

function __Z56setPxSimulationStatisticsRequiredContactConstraintMemoryPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 56 >> 2] = i1;
 return;
}

function __Z46ScriptableObject_CUSTOM_CreateInstanceFromTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting30CreateScriptableObjectWithTypeEP12Il2CppObjectb(i1, 1) | 0;
}

function __Z45QualitySettings_Set_Custom_PropShadowDistancef(f1) {
 f1 = Math_fround(f1);
 __ZN15QualitySettings17SetShadowDistanceEf(__Z18GetQualitySettingsv() | 0, f1);
 return;
}

function __Z43Texture_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE(i1) {
 i1 = i1 | 0;
 __ZN7Texture13SetAnisoLimitENS_20AnisotropicFilteringE(i1);
 return;
}

function __Z41setPxVehicleDifferential4WDataMCentreBiasPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z39setPxClothParticleDataPreviousParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z39getPxSphericalJoint_SphericalJointFlagsPKN5physx16PxSphericalJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
}

function __Z39getPxScene_ClothInterCollisionStiffnessPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
}

function __Z39getPxPrismaticJoint_PrismaticJointFlagsPKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0) | 0;
}

function __Z39UnityAdsSettings_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 __ZN19BaseConnectSettings10SetEnabledEb(__Z19GetUnityAdsSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z39Graphics_CUSTOM_ClearRandomWriteTargetsv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 776 >> 2] | 0, i1 | 0);
 return;
}

function __Z34Screen_Get_Custom_PropSleepTimeoutv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
}

function __Z33Screen_Get_Custom_PropOrientationv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function __Z32getPxArticulation_SleepThresholdPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
}

function __Z31getPxRigidDynamic_LinearDampingPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0));
}

function __Z31getPxParticleBase_ContactOffsetPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 216 >> 2] | 0, i1 | 0));
}

function __Z30getPxDistanceJoint_MinDistancePKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0));
}

function __Z30getPxDistanceJoint_MaxDistancePKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
}

function __Z30GUIUtility_CUSTOM_GetControlIDi9FocusType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN8GUIState12GetControlIDEi9FocusType(__Z11GetGUIStatev() | 0, i1, i2) | 0;
}

function __Z27GL_Get_Custom_PropWireframev() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0) & 1 | 0;
}

function __Z25setPxActor_DominanceGroupPN5physx7PxActorEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 56 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z13GL_CUSTOM_Endv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 584 >> 2] | 0, i1 | 0);
 __Z15gpu_time_samplev();
 return;
}

function __Z13CleanupIl2Cppv() {
 __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE(0);
 _il2cpp_shutdown();
 return;
}

function __GLOBAL__sub_I_runtime_containers_lump_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1544235 | 0, fb + 3353 | 0, fb + 3354 | 0, 0, 0);
 return;
}

function __GLOBAL__sub_I_PxsFluidDynamics_cpp() {
 var i1 = 0;
 i1 = 0;
 do {
  HEAP32[gb + 1454972 + (i1 << 2) >> 2] = i1;
  i1 = i1 + 1 | 0;
 } while ((i1 | 0) != 512);
 return;
}

function _UNITY_png_reciprocal(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 d2 = +Math_floor(+(1.0e10 / +(i1 | 0) + .5));
 return (d2 <= 2147483647.0 & d2 >= -2147483648.0 ? ~~d2 : 0) | 0;
}

function _ft_smooth_render(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _ft_smooth_render_generic(i1, i2, (i3 | 0) == 1 ? 0 : i3, i4, 0) | 0;
}

function __ZZ24InitializeNavMeshManagervEN37PreLateUpdateAIUpdatePostScriptstruct7ForwardEv() {
 __ZN14NavMeshManager16UpdatePostScriptEv(HEAP32[gb + 1459032 >> 2] | 0);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208728 + 8;
 __ZNSt3__26localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208664 + 8;
 __ZNSt3__26localeD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__214error_category23default_error_conditionEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i3;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE13positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE13negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE13positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE13negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE13positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE13negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE13positive_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE13negative_signEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK8VRDevice16GetFramePresentsEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 192 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZNK8VRDevice16GetDroppedFramesEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 184 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZNK14SplatMaterials13HasSmoothnessEv(i1) {
 i1 = i1 | 0;
 return __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i1 + 40 | 0, gb + 1467272 | 0) | 0;
}

function __ZNK10FileSystem18SetApplicationPathEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _strncpy(gb + 1547918 | 0, i2, 1040) | 0;
 HEAP8[gb + 1547918 + 1039 >> 0] = 0;
 return;
}

function __ZN7mecanim12statemachine13StateConstant15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 910026 | 0, gb + 910040 | 0, gb + 1048102 | 0);
 return;
}

function __ZN7TextureD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc5Scene15setContactCacheEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 7605 >> 0] = i1 & 1;
 return;
}

function __ZN5physx22PxDefaultFileInputDataD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87616 + 8;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 _fclose(i1) | 0;
 return;
}

function __ZN5audio5mixer12GetLiveValueERNS0_16AudioMixerMemoryEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 28 >> 2] | 0) + (i2 << 2) >> 2]);
}

function __ZN5Umbra9Matrix4x45clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 64 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN5Umbra9Matrix3x35clearEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN3WWW18GetResponseHeadersEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, i2 + 64 | 0);
 return;
}

function __ZN20TextRenderingPrivate8FontImpl5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 16 >> 2] = Math_fround(1.0);
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN18SpeedTreeWindTimesC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 44 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN15TextureTFMethod20IsBoneCountSupportedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0) >>> 0 >= i2 >>> 0 | 0;
}

function __ZN15ParticleEmitter8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN13SplatDatabase25RecalculateBasemapIfDirtyEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 50 >> 0] | 0)) return;
 __ZN13SplatDatabase18RecalculateBasemapEb(i1, 0);
 return;
}

function __ZN13SplatDatabase20SetBaseMapResolutionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 40 >> 2] = i2;
 __ZN13SplatDatabase18RecalculateBasemapEb(i1, 0);
 return;
}

function __ZN13RenderManager16SetCurrentCameraEP6Camera(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN12HingeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12FixedJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN12CubemapArray23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11UnityEngine15PlatformWrapper19GetBundleIdentifierEv(i1) {
 i1 = i1 | 0;
 __ZN15ApplicationInfo19GetBundleIdentifierEv(i1, __Z18GetApplicationInfov() | 0);
 return;
}

function __ZN11UnityEngine15PlatformWrapper14GetCloudUserIdEv(i1) {
 i1 = i1 | 0;
 __ZN20UnityConnectSettings14GetCloudUserIdEv(i1, __Z21GetManagerFromContexti(22) | 0);
 return;
}

function __ZN11OffMeshLinkD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11AudioFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10Effector2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL27CleanupCoreScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1451044 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1451044 >> 2] = 0;
 return;
}

function __Z78Register_UnityEngine_SceneManagement_SceneManager_UnloadSceneNameIndexInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562924 | 0, fb + 149 | 0);
 return;
}

function __Z78Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsDeprecatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655675 | 0, fb + 392 | 0);
 return;
}

function __Z78Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSingleWithParentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579651 | 0, fb + 156 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647122 | 0, fb + 3403 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetCycleCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647422 | 0, fb + 3405 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647192 | 0, fb + 3404 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetCycleCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647492 | 0, fb + 2045 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_SetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634624 | 0, fb + 3315 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_GetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634694 | 0, fb + 3316 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableDynamicCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643204 | 0, fb + 3384 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableDynamicCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643274 | 0, fb + 2026 | 0);
 return;
}

function __Z77Register_UnityEngine_AnimatorOverrideController_set_runtimeAnimatorControllerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928420 | 0, fb + 4152 | 0);
 return;
}

function __Z77Register_UnityEngine_AnimatorOverrideController_get_runtimeAnimatorControllerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928350 | 0, fb + 2580 | 0);
 return;
}

function __Z50setPxVehicleTireDataMCamberStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z49QualitySettings_Set_Custom_PropMasterTextureLimiti(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings21SetMasterTextureLimitEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z46RenderSettings_Set_Custom_PropFogStartDistancef(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings17SetLinearFogStartEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z46Physics_Set_Custom_PropDefaultSolverIterationsi(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManager26SetDefaultSolverIterationsEi(__Z17GetPhysicsManagerv() | 0, i1);
 return;
}

function __Z46Object_CUSTOM_FindObjectsOfTypeIncludingAssetsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE(i1, 0) | 0;
}

function __Z45setPxVehicleDifferential4WDataMFrontRearSplitPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z45Bounds_CUSTOM_INTERNAL_CALL_Internal_ContainsRK4AABBRK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__ZNK4AABB8IsInsideERK8Vector3f(i1, i2) | 0) & 1 | 0;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToObjectArrayP11Il2CppArray13Il2Cpp_IntPtrRPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z42setPxVehicleAckermannGeometryDataMAccuracyPN5physx30PxVehicleAckermannGeometryDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z41getPxArticulation_MaxProjectionIterationsPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __Z41getPxArticulation_InternalDriveIterationsPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0) | 0;
}

function __Z41getPxArticulation_ExternalDriveIterationsPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
}

function __Z40setPxVehicleDifferential4WDataMFrontBiasPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 16 >> 2] = f1;
 return;
}

function __Z40UnityAdsSettings_Set_Custom_PropTestModeh(i1) {
 i1 = i1 | 0;
 __ZN16UnityAdsSettings11SetTestModeEb(__Z19GetUnityAdsSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z38getPxVehicleDriveTank_ConcreteTypeNamePKN5physx18PxVehicleDriveTankE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z38getPxScene_ClothInterCollisionDistancePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
}

function __Z38getPxArticulationLink_ConcreteTypeNamePKN5physx18PxArticulationLinkE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z30getPxParticleBase_ParticleMassPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
}

function __Z28getPxPrismaticJoint_VelocityPKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
}

function __Z28getPxPrismaticJoint_PositionPKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
}

function __Z27GL_Get_Custom_PropSRGBWritev() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0) & 1 | 0;
}

function __Z26GetTextureColorSpaceString17TextureColorSpace(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 0 ? gb + 421066 | 0 : (i1 | 0) == 1 ? gb + 470258 | 0 : gb + 419832 | 0) | 0;
}

function __Z23setPxScene_CCDMaxPassesPN5physx7PxSceneEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 264 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z23getPxCloth_TetherConfigPKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 272 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z22PlayerSendFrameStartedb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1115296 + 420 >> 2] | 0;
 if (!((i2 | 0) != 0 & i1)) return;
 mftCall_v(i2 | 0);
 return;
}

function _UNITY_LZ4_uncompress_unknownOutputSize(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _UNITY_LZ4_decompress_safe(i1, i2, i3, i4) | 0;
}

function _UNITY_FT_Init_Class_sfnt_service_sfnt_table(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 179;
 HEAP32[i1 + 4 >> 2] = fb + 1064;
 HEAP32[i1 + 8 >> 2] = fb + 180;
 return;
}

function _uselocale(i1) {
 i1 = i1 | 0;
 var i2 = 0, i3 = 0;
 i2 = (_pthread_self() | 0) + 184 | 0;
 i3 = HEAP32[i2 >> 2] | 0;
 if (i1 | 0) HEAP32[i2 >> 2] = i1;
 return i3 | 0;
}

function _glClearColor__wrapper(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 _glClearColor(+f1, +f2, +f3, +f4);
}

function _cff_index_forget_element(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i1 + 28 >> 2] | 0) return;
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLLD1Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -8 | 0;
 HEAP32[i1 >> 2] = gb + 101396 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 101396 + 52;
 return;
}

function __ZNSt3__211char_traitsIwE7compareEPKwS3_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) i1 = 0; else i1 = _wmemcmp(i1, i2, i3) | 0;
 return i1 | 0;
}

function __ZNSt3__210ostrstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210ostrstreamD2Ev(i1, gb + 215632 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 52 | 0);
 return;
}

function __ZNSt3__210istrstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210istrstreamD2Ev(i1, gb + 215536 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 56 | 0);
 return;
}

function __ZNK6Camera15GetStereoEyeEndEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 1112 >> 0] | 0)) return ((HEAP32[i1 + 824 >> 2] | 0) >>> 1 & 1) + 1 | 0; else return 1;
 return 0;
}

function __ZNK5physx7NpScene26getSimulationEventCallbackEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene26getSimulationEventCallbackEh(i2 + 32 | 0, i1) | 0;
}

function __ZNK5physx2Sc9ClothCore10isSleepingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Sc5Scene15getCCDMaxPassesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx10PxsContext15getCCDMaxPassesEv(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc16ActorInteraction13getNPhaseCoreEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__ZNK5physx2Sc8ActorSim8getSceneEv(HEAP32[i1 + 4 >> 2] | 0) | 0) + 1104 >> 2] | 0;
}

function __ZNK5Umbra4Tome7getSizeEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 >> 2] | 0) == -1163018018) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 return i1 | 0;
}

function __ZNK13TranslateGLES13GetFormatDescE17DepthBufferFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + 28 + ((HEAP32[i1 + 2264 + (i2 << 2) >> 2] | 0) * 24 | 0) | 0;
}

function __ZNK13Simd4iFactoryIRKiEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[HEAP32[i2 >> 2] >> 2] | 0;
 __ZN8Scalar4fC2Eiiii(i1, i2, i2, i2, i2);
 return;
}

function __ZN9GfxDevice26UpdateViewProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_(i1 + 1764 | 0, i1 + 1828 | 0, i1 + 1956 | 0);
 return;
}

function __ZN8GUIStyle14SetDefaultFontEPN13TextRendering4FontE(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[gb + 1468160 >> 2] = i1;
 return;
}

function __ZN8DateTime10IsLeapYearEi(i1) {
 i1 = i1 | 0;
 if (!(i1 & 3)) if (!((i1 | 0) % 100 | 0)) i1 = ((i1 | 0) % 400 | 0 | 0) == 0; else i1 = 1; else i1 = 0;
 return i1 | 0;
}

function __ZN8Animator17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 if (HEAP8[i1 + 33 >> 0] | 0) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7mecanim4hand4HandC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 60 | 0;
 do {
  HEAP32[i1 >> 2] = -1;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN7Texture23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx34NpShapeGetScRigidObjectFromScbSLOWERKNS_3Scb5ShapeE(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + -32 + 20 >> 2] | 0;
 return ((i1 | 0) == 0 ? 0 : i1 + 64 | 0) | 0;
}

function __ZN5physx2Sc19ConstraintGroupNode11projectPoseERS1_(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc24ConstraintProjectionTree11projectPoseERNS0_19ConstraintGroupNodeE(i1);
 return;
}

function __ZN5Umbra20ObjectDistanceParams16setDistanceScaleEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 >> 2] = f2;
 return;
}

function __ZN5Umbra10Visibility14setInputBufferEPKNS_15OcclusionBufferE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 16 >> 2] = i2;
 return;
}

function __ZN24PhysicsUpdateBehaviour2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN21AssetBundleFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem19InitializeFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1040 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = i1;
 return;
}

function __ZN16ReflectionSampleC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 124 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN14RenderSettings13SetFogDensityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 344 >> 2] = f2;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager21setProfileZoneManagerERN5physx20PxProfileZoneManagerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 208 >> 2] = i1;
 return;
}

function __ZN12CachedReader10Align4ReadEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + ((HEAP32[i1 >> 2] | 0) + 3 - i2 & -4);
 return;
}

function __ZN10MonoScript8GetClassEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 88 >> 2] | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return i1 | 0;
}

function __ZN10GUIElementD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN10FlareLayerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630508 | 0, fb + 235 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630368 | 0, fb + 234 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630228 | 0, fb + 233 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630578 | 0, fb + 292 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630438 | 0, fb + 291 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630298 | 0, fb + 290 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterPropertiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645840 | 0, fb + 761 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterPropertiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646040 | 0, fb + 819 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637574 | 0, fb + 253 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637434 | 0, fb + 252 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637294 | 0, fb + 251 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637644 | 0, fb + 310 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637504 | 0, fb + 309 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637364 | 0, fb + 308 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetDampenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632080 | 0, fb + 240 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetDampenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632150 | 0, fb + 297 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642704 | 0, fb + 270 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642774 | 0, fb + 327 | 0);
 return;
}

function __Z77Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeTriggerParticlesSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655746 | 0, fb + 824 | 0);
 return;
}

function __Z76Register_UnityEngine_UnityEventQueueSystem_INTERNAL_CALL_GetGlobalEventQueuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581336 | 0, fb + 3664 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630648 | 0, fb + 3284 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630717 | 0, fb + 1996 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646382 | 0, fb + 3398 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646244 | 0, fb + 3397 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646451 | 0, fb + 2042 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646313 | 0, fb + 2041 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_SetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636664 | 0, fb + 3333 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_GetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636733 | 0, fb + 3334 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_CollisionModule_SetUsesCollisionMessagesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643962 | 0, fb + 3388 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_CollisionModule_GetUsesCollisionMessagesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644031 | 0, fb + 2030 | 0);
 return;
}

function __Z76Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_CalcSizeWithConstraintsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024302 | 0, fb + 325 | 0);
 return;
}

function __Z76Register_UnityEngine_Animator_get_isRootPositionOrRotationControlledByCurvesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918885 | 0, fb + 2552 | 0);
 return;
}

function __Z75Register_UnityEngine_GUIStyleState_GetBackgroundInternalFromDeserializationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021915 | 0, fb + 2718 | 0);
 return;
}

function __Z54setPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 56 >> 2] = i1;
 return;
}

function __Z44setPxVehicleWheelsSimData_ThresholdLongSpeedPN5physx22PxVehicleWheelsSimDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 48 >> 2] = f1;
 return;
}

function __Z43setPxVehicleSuspensionDataMCamberAtMaxDroopPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 28 >> 2] = f1;
 return;
}

function __Z39setPxVehicleDifferential4WDataMRearBiasPN5physx27PxVehicleDifferential4WDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z39getPxParticleBase_ParticleReadDataFlagsPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0) | 0;
}

function __Z39Physics2D_Set_Custom_PropBaumgarteScalef(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings17SetBaumgarteScaleEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z38scripting_profiler_install_enter_leavePFvPvPK10MethodInfoES4_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_profiler_install_enter_leave(i1 | 0, i2 | 0);
 return;
}

function __Z37getPxScene_ContactCorrelationDistancePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 272 >> 2] | 0, i1 | 0));
}

function __Z36RemoveErrorWithIdentifierFromConsolei(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1450804 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __Z33RenderSettings_Get_Custom_PropSunv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZNK14RenderSettings6GetSunEv(__Z17GetRenderSettingsv() | 0) | 0) | 0;
}

function __Z29getPxRigidDynamic_WakeCounterPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 280 >> 2] | 0, i1 | 0));
}

function __Z29getPxParticleBase_RestitutionPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
}

function __Z29GetNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0) >>> 1 | 0;
}

function __Z28getPxParticleFluid_ViscosityPKN5physx15PxParticleFluidE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0));
}

function __Z28getPxParticleFluid_StiffnessPKN5physx15PxParticleFluidE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 248 >> 2] | 0, i1 | 0));
}

function __Z28getPxDistanceJoint_TolerancePKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
}

function __Z28getPxDistanceJoint_StiffnessPKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0));
}

function __Z25scripting_class_from_namePK11Il2CppImagePKcS3_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _il2cpp_class_from_name(i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __Z23GetVirtualJoystickIndexPKc(i1) {
 i1 = i1 | 0;
 return __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb(HEAP32[gb + 1162016 >> 2] | 0, i1, 0) | 0;
}

function __Z20IsNPOTTextureAllowedb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0;
 return (i1 ? (i2 | 0) == 2 : (i2 | 0) > 0) | 0;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_tt_size_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 296 >> 2] = -1;
 HEAP32[i1 + 300 >> 2] = -1;
 HEAP8[i1 + 72 + 36 >> 0] = 0;
 HEAP32[i1 + 112 >> 2] = -1;
 return 0;
}

function b124(i1, i2, f3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_iiiffii(124);
 return 0;
}

function _unztell(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = -102; else {
  i1 = HEAP32[i1 + 156 >> 2] | 0;
  if (!i1) i1 = -102; else i1 = HEAP32[i1 + 24 >> 2] | 0;
 }
 return i1 | 0;
}

function _strtoull_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = _strtoull(i1, i2, i3) | 0;
 setTempRet0(getTempRet0() | 0);
 return i4 | 0;
}

function ___errno_location() {
 var i1 = 0;
 if (!(HEAP32[gb + 1469464 >> 2] | 0)) i1 = gb + 1469556 | 0; else i1 = HEAP32[(_pthread_self() | 0) + 64 >> 2] | 0;
 return i1 | 0;
}

function __ZltRK18ParticleSorterPredS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var f3 = f0;
 f3 = Math_fround(HEAPF32[i1 >> 2]);
 return f3 < Math_fround(HEAPF32[i2 >> 2]) | 0;
}

function __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimitD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN14ParticleSystem15InitializeClassEvEN16cleanupAfterLoad7ForwardEv() {
 __ZN14ParticleSystem14BeginUpdateAllEv();
 __ZN14ParticleSystem12EndUpdateAllEv();
 return;
}

function __ZNSt3__28valarrayIjEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 __ZNSt3__28valarrayIjE6resizeEjj(i1, i2, 0);
 return;
}

function __ZNSt3__215__time_get_tempIwEC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212ctype_bynameIwEC2EPKcj(i1, i2, 1);
 HEAP32[i1 >> 2] = gb + 214104 + 8;
 return;
}

function __ZNSt3__215__time_get_tempIcEC2EPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__212ctype_bynameIcEC2EPKcj(i1, i2, 1);
 HEAP32[i1 >> 2] = gb + 214052 + 8;
 return;
}

function __ZNSt3__211char_traitsIcE7compareEPKcS3_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i3) i1 = 0; else i1 = _memcmp(i1, i2, i3) | 0;
 return i1 | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE11curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE11curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE11curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE11curr_symbolEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx7NpShape8getFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP8[((HEAP32[i1 + 36 >> 2] & 64 | 0) == 0 ? i1 + 112 | 0 : (HEAP32[i1 + 40 >> 2] | 0) + 52 | 0) >> 0] | 0;
}

function __ZNK5physx2Sc17ParticleSystemSim16getInternalFlagsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc18ParticleSystemCore16getInternalFlagsEv(HEAP32[i1 + 52 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc15ClothFabricCore9getNbSetsEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK4Mesh18GetTotalIndexCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 return ((HEAP32[i1 + 116 >> 2] | 0) - (HEAP32[i1 + 112 >> 2] | 0) | 0) >>> 1 | 0;
}

function __ZNK4Mesh15GetSubMeshCountEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 32 >> 2] | 0;
 return ((HEAP32[i1 + 132 >> 2] | 0) - (HEAP32[i1 + 128 >> 2] | 0) | 0) / 52 | 0 | 0;
}

function __ZNK30SpriteRendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __ZNK24OcclusionCullingSettings20InvalidatePVSOnSceneEv(i1) {
 i1 = i1 | 0;
 __ZN13RendererScene27CleanupPVSAndRequestRebuildEv(__Z16GetRendererScenev() | 0);
 return;
}

function __ZNK15ArchiveReadFile8PositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 16 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZNK14SplatMaterials11HasSpecularEv(i1) {
 i1 = i1 | 0;
 return __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i1 + 40 | 0, gb + 1467372 | 0) | 0;
}

function __ZNK14SplatMaterials11HasMetallicEv(i1) {
 i1 = i1 | 0;
 return __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE(i1 + 40 | 0, gb + 1467288 | 0) | 0;
}

function __ZNK14DLHAudioHelper14GetPartialSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK14DLHAudioHelper14GetPartialDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK12_GLOBAL__N_122SocketNetworkOutStream11isConnectedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx6shdfnd6Socket11isConnectedEv((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) | 0;
}

function __ZN9Texture2D23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Texture2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN9GfxDevice20DeallocRenderSurfaceEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63304 | 0);
 return;
}

function __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i1 + 32 | 0, i2);
 return;
}

function __ZN6Avatar17NotifyObjectUsersERK17MessageIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i1 + 76 | 0, i2);
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx3Cct17CapsuleController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx28SimulationStatisticsPropertyC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 772384;
 HEAP32[i1 + 4 >> 2] = 252;
 HEAP32[i1 + 8 >> 2] = fb + 3603;
 return;
}

function __ZN5physx22XmlMemoryAllocatorImplD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 142044 + 8;
 __ZN5physx19CVariableMemoryPoolD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxcNpThreadContext10clearStatsEv(i1) {
 i1 = i1 | 0;
 _memset(i1 + 104 | 0, 0, 196) | 0;
 HEAP32[i1 + 8760 >> 2] = 0;
 HEAP32[i1 + 8764 >> 2] = 0;
 return;
}

function __ZN5physx14SingleAABBTask22setNumFastMovingShapesEjj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 + 48 + (i2 * 68 | 0) + 64 >> 2] = i1;
 return;
}

function __ZN5Umbra10Visibility15setOutputBufferEPNS_15OcclusionBufferE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 8 >> 2] = i2;
 return;
}

function __ZN5Light16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 __ZNK5Light16UnshareLightDataEv(i1);
 __ZN15SharedLightData16CheckConsistencyEv(HEAP32[i1 + 44 >> 2] | 0);
 return;
}

function __ZN19CloudServiceHandler31SetICloudServiceHandlerListenerEP28ICloudServiceHandlerListener(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 1168 >> 2] = i2;
 return;
}

function __ZN18SpeedTreeWindAssetD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18AudioMixerSnapshotD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN18AudioMixerSnapshot13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(i2 & 4)) return;
 __ZN9UnityGUID4InitEv(i1 + 36 | 0);
 return;
}

function __ZN16MemoryFileSystem19InitializeFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1040 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = i1;
 return;
}

function __ZN14DirectorPlayer38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN13PhysicsModule16GetProfilerStatsER12PhysicsStats(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14PhysicsManager19GetPerformanceStatsER12PhysicsStats(0, i2);
 return;
}

function __ZN13LoadOperation19IntegrateTimeSlicedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN27TimeSliceAwakeFromLoadQueue19IntegrateTimeSlicedEi(i1 + 84 | 0, i2) | 0;
}

function __ZN13GfxDeviceNullD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 77628 + 8;
 __ZN9GfxDevice16DeleteDynamicVBOEv(i1);
 __ZN9GfxDeviceD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12LightManager15InitializeClassEv() {
 var i1 = 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAP32[gb + 1112264 >> 2] = i1;
 return;
}

function __ZN12HandlerChain5WriteER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN11UnityEngine7Connect13ConnectConfig11ResetValuesEv(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue11ResetValuesEv(i1 + 4 | 0);
 return;
}

function __ZN11UTF16StringD2Ev(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 8 >> 0] | 0)) return;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, i1 + 12 | 0);
 return;
}

function __ZN11NamedObject23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Object8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11AudioModule30GetOrCreateDSPFromCustomFilterEP17AudioCustomFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN17AudioCustomFilter14GetOrCreateDSPEv(i2) | 0;
}

function __ZN10systeminfo21GetPersistentDataPathEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, gb + 1103752 | 0);
 return;
}

function __ZN10DynamicVBO9NextFrameEv() {
 var i1 = 0;
 HEAP32[gb + 1161248 >> 2] = 0;
 i1 = HEAP32[gb + 1161244 >> 2] | 0;
 HEAP32[gb + 1161244 >> 2] = i1 + 1;
 return i1 | 0;
}

function __ZN10AtomicList5TouchEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return i3 | 0;
}

function __ZL25CleanupUIScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1468152 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1468152 >> 2] = 0;
 return;
}

function __ZL25CleanupAIScriptingClassesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1459868 >> 2] | 0, gb + 63728 | 0);
 HEAP32[gb + 1459868 >> 2] = 0;
 return;
}

function __ZL20UnityDetourAllocTempi(i1) {
 i1 = i1 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 64016 | 0, 0, gb + 842172 | 0, 103) | 0;
}

function __Z76Register_UnityEngine_TerrainData_Internal_GetMinimumDetailResolutionPerPatchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 937822 | 0, fb + 258 | 0);
 return;
}

function __Z76Register_UnityEngine_TerrainData_Internal_GetMaximumDetailResolutionPerPatchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 937891 | 0, fb + 259 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_MainModule_SetRandomizeRotationDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625617 | 0, fb + 220 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_MainModule_GetRandomizeRotationDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625686 | 0, fb + 277 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurveMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632876 | 0, fb + 241 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurveMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632945 | 0, fb + 298 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627082 | 0, fb + 223 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627151 | 0, fb + 280 | 0);
 return;
}

function __Z76Register_UnityEngine_ParticleSystemRenderer_Internal_GetEnabledVertexStreamsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655415 | 0, fb + 823 | 0);
 return;
}

function __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MergeScenesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562995 | 0, fb + 3064 | 0);
 return;
}

function __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_CreateScenev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562856 | 0, fb + 3063 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetRowIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647562 | 0, fb + 3406 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetRowIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647630 | 0, fb + 2046 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeCollisionEventSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655607 | 0, fb + 2086 | 0);
 return;
}

function __Z75Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorPixelPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024062 | 0, fb + 165 | 0);
 return;
}

function __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimeUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512251 | 0, fb + 2825 | 0);
 return;
}

function __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimeUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512319 | 0, fb + 1654 | 0);
 return;
}

function __Z75Register_UnityEngine_AnimatorOverrideController_Internal_CreateAnimationSetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928282 | 0, fb + 3818 | 0);
 return;
}

function __Z75Register_UnityEngine_AnimationClip_INTERNAL_CALL_EnsureQuaternionContinuityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915691 | 0, fb + 3808 | 0);
 return;
}

function __Z74Register_UnityEngine_Networking_DownloadHandlerAssetBundle_get_assetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028857 | 0, fb + 2740 | 0);
 return;
}

function __Z74Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_GetWindowRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021553 | 0, fb + 4280 | 0);
 return;
}

function __Z53setPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 52 >> 2] = i1;
 return;
}

function __Z46setPxVehicleEngineDataMDampingRateFullThrottlePN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 92 >> 2] = f1;
 return;
}

function __Z44setPxVehicleDriveDynData_EngineRotationSpeedPN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 76 >> 2] = f1;
 return;
}

function __Z44RenderSettings_Set_Custom_PropFlareFadeSpeedf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings17SetFlareFadeSpeedEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z43setPxVehicleSuspensionDataMSpringDamperRatePN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z43Physics2D_Set_Custom_PropVelocityIterationsi(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings21SetVelocityIterationsEi(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z43Physics2D_Set_Custom_PropPositionIterationsi(i1) {
 i1 = i1 | 0;
 __ZN17Physics2DSettings21SetPositionIterationsEi(__Z20GetPhysics2DSettingsv() | 0, i1);
 return;
}

function __Z40RenderBufferHelper_CUSTOM_SetStoreActionP21ScriptingRenderBufferi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 29 >> 0] = i2;
 return;
}

function __Z37getPxRevoluteJoint_RevoluteJointFlagsPKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 168 >> 2] | 0, i1 | 0) | 0;
}

function __Z37getPxDistanceJoint_DistanceJointFlagsPKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0) | 0;
}

function __Z35setPxSceneDescContactModifyCallbackPN5physx11PxSceneDescEPNS_23PxContactModifyCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __Z34getPxArticulationLink_InboundJointPKN5physx18PxArticulationLinkE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 228 >> 2] | 0, i1 | 0) | 0;
}

function __Z31Cursor_Get_Custom_PropLockStatev() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function __Z30setPxClothFabricPhasePhaseTypePN5physx18PxClothFabricPhaseENS_22PxClothFabricPhaseType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z29getPxArticulation_WakeCounterPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
}

function __Z28getPxParticleBase_RestOffsetPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i1 | 0));
}

function __Z27getPxRevoluteJoint_VelocityPKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
}

function __Z27getPxDistanceJoint_DistancePKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
}

function __Z25Profiler_CUSTOM_EndSamplev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1163228 >> 2] | 0;
 if (!i1) return;
 __ZN22UnityProfilerPerThread16EndSampleDynamicEv(i1);
 return;
}

function __Z22setPxActor_OwnerClientPN5physx7PxActorEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 64 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z22ConnectVirtualJoystickPKc(i1) {
 i1 = i1 | 0;
 return __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb(HEAP32[gb + 1162016 >> 2] | 0, i1, 1) | 0;
}

function __Z21getPxCloth_GlobalPosePKN5physx7PxClothE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 124 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function _UNITY_png_set_user_limits(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (!i1) return;
 HEAP32[i1 + 624 >> 2] = i2;
 HEAP32[i1 + 628 >> 2] = i3;
 return;
}

function b36(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiiiiiii(36);
 return 0;
}

function _wcstoimax(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, 0, -2147483648) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _strtoimax(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, 0, -2147483648) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _emscripten_glGetVertexAttribPointerv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetVertexAttribPointerv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetObjectParameterivARB__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetObjectParameterivARB(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glBufferData__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glBufferData(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _cf2_outline_close(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 _cff_builder_close_contour(i1);
 _UNITY_FT_GlyphLoader_Add(HEAP32[i1 + 12 >> 2] | 0);
 return;
}

function __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_792kDidModifyMesh4CallEPviR11MessageData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZThn4_N5physx5cloth8SwSolver8addClothEPNS0_5ClothE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx5cloth8SwSolver8addClothEPNS0_5ClothE(i2 + -4 | 0, i1);
 return;
}

function __ZNSt3__28ios_base15sync_with_stdioEb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (HEAP8[gb + 1077792 >> 0] | 0) != 0;
 HEAP8[gb + 1077792 >> 0] = i1 & 1;
 return i2 | 0;
}

function __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 8 + 3 >> 0] | 0) < 0) __ZdlPv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE10pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE10neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE10pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE10neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE10pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE10neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE10pos_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 40 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE10neg_formatEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 44 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK12_GLOBAL__N_121SocketNetworkInStream11isConnectedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx6shdfnd6Socket11isConnectedEv((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) | 0;
}

function __ZN9Transform30EnsureTransformHierarchyExistsEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 32 >> 2] | 0) return;
 __ZN9Transform25RebuildTransformHierarchyEv(i1);
 return;
}

function __ZN9ProjectorD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN9LensFlareD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN9HaloLayerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN8WindZone23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN5physx6shdfnd7FastXml8Callback14processDoctypeEPKcS4_S4_S4_(i5, i1, i2, i3, i4) {
 i5 = i5 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 1;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx21PxVehicleDriveSimData14setAutoBoxDataERKNS_20PxVehicleAutoBoxDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 _memcpy(i2 + 272 | 0, i1 | 0, 256) | 0;
 return;
}

function __ZN5Umbra9IndexListC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra9FloatListC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra11PatchWriter4initERNS_12OutputStreamEPKh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __ZN4FMOD13ChannelGroupI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP8[i1 + 53 >> 0] = 0;
 return;
}

function __ZN17PolygonCollider2D16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 __ZN10Collider2D16CheckConsistencyEv(i1);
 __ZN9Polygon2D16CheckConsistencyEv(i1 + 160 | 0);
 return;
}

function __ZN17PhysicsMaterial2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15DirectorManager16GenerateUniqueIdEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1188436 >> 2] = (HEAP32[gb + 1188436 >> 2] | 0) + 1;
 return HEAP32[gb + 1188436 >> 2] | 0;
}

function __ZN14ManagerContextC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 112 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN14GrowableBufferD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i2) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1);
 return;
}

function __ZN14DetailDatabase29UpdateDetailPrototypesIfDirtyEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 __ZN14DetailDatabase17RefreshPrototypesEv(i1);
 return;
}

function __ZN13MemoryManager18GetCustomAllocatorERK10MemLabelId(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 1764 + ((HEAP32[i2 >> 2] | 0) + -128 << 2) >> 2] | 0;
}

function __ZN13GfxDeviceNull20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN13GfxDeviceNull17CaptureScreenshotEiiiiPh(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 1;
}

function __ZN12HandlerChain4ReadER13FileEntryDatayPvPy(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function __ZN10HumanTrait9GetParentEi(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 54) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[gb + 179880 + (i1 << 2) >> 2] | 0;
 return i1 | 0;
}

function __ZL25InitializeUnityWebStreamsPv(i1) {
 i1 = i1 | 0;
 i1 = __Znwj(8) | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 HEAP32[gb + 1451260 >> 2] = i1;
 return;
}

function __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558814 | 0, fb + 26 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650992 | 0, fb + 287 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651060 | 0, fb + 343 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_ShapeModule_SetSphericalDirectionAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627936 | 0, fb + 226 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_ShapeModule_GetSphericalDirectionAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628004 | 0, fb + 283 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentSize3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651296 | 0, fb + 762 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625977 | 0, fb + 221 | 0);
 return;
}

function __Z75Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626045 | 0, fb + 278 | 0);
 return;
}

function __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetScenePathByBuildIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563141 | 0, fb + 1845 | 0);
 return;
}

function __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetBuildIndexByScenePathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563208 | 0, fb + 1846 | 0);
 return;
}

function __Z74Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneAtv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562715 | 0, fb + 3062 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646110 | 0, fb + 3396 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 646177 | 0, fb + 2040 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635620 | 0, fb + 3324 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635687 | 0, fb + 2008 | 0);
 return;
}

function __Z74Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRateUnbiased_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536857 | 0, fb + 2943 | 0);
 return;
}

function __Z73Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028728 | 0, fb + 2738 | 0);
 return;
}

function __Z39RenderBufferHelper_CUSTOM_SetLoadActionP21ScriptingRenderBufferi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 28 >> 0] = i2;
 return;
}

function __Z38Time_Get_Custom_PropTimeSinceLevelLoadv() {
 var i1 = 0;
 i1 = __Z14GetTimeManagerv() | 0;
 return Math_fround(+HEAPF64[i1 + 96 >> 3] + +HEAPF64[i1 + 168 >> 3]);
}

function __Z38Compass_Get_Custom_PropHeadingAccuracyP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(__ZN15LocationService14GetLastHeadingEv() | 0) + 8 >> 2]);
}

function __Z36setPxClothMotionConstraintConfigBiasPN5physx29PxClothMotionConstraintConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z35setPxHeightFieldGeometryHeightFieldPN5physx21PxHeightFieldGeometryEPNS_13PxHeightFieldE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z26getPxDistanceJoint_DampingPKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0));
}

function __Z20profiler_set_enabledb(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i2) return;
 __ZN13UnityProfiler10SetEnabledEb(i2, i1);
 return;
}

function __GLOBAL__sub_I_FontImpl_cpp() {
 __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE(gb + 1467836 | 0, gb + 946242 | 0, 0, 0);
 return;
}

function mftCall_f(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) >= (fb | 0) & (i1 | 0) < (fb + 63 | 0)) return +Math_fround(FUNCTION_TABLE_f[i1 - fb & 63]());
 return +ftCall_f(i1 | 0);
}

function b88(i1, i2, i3, i4, f5, f6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 f6 = Math_fround(f6);
 nullFunc_iiiiiff(88);
 return 0;
}

function _strtoll_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i4 = _strtoll(i1, i2, i3) | 0;
 setTempRet0(getTempRet0() | 0);
 return i4 | 0;
}

function _conjl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0;
 d3 = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i1 + 8 >> 3] = d3;
 return;
}

function __ZNSt3__25mutex4lockEv(i1) {
 i1 = i1 | 0;
 i1 = _pthread_mutex_lock(i1 | 0) | 0;
 if (i1 | 0) __ZNSt3__220__throw_system_errorEiPKc(i1, gb + 1082265 | 0);
 return;
}

function __ZNK9Rigidbody7GetMassEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
}

function __ZNK9Rigidbody7GetDragEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 236 >> 2] | 0, i1 | 0));
}

function __ZNK5physx7NpScene32getContactReportStreamBufferSizeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene39getDefaultContactReportStreamBufferSizeEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx7NpScene31getClothInterCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc5Scene31getClothInterCollisionStiffnessEv(i1 + 32 | 0));
}

function __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK13ScreenManager19GetSystemResolutionEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 28 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZN8WindZoneD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN8Renderer23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN8Material23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Material8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN8GUILayerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN6Camera21BeginSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1) {
 i1 = i1 | 0;
 __ZN5physx9NpFactory14onActorReleaseEPNS_7PxActorE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 return;
}

function __ZN5physx6shdfnd12ErrorHandlerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx37PxVehicleWheelsDynDataGeneratedValuesC2EPKNS_22PxVehicleWheelsDynDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 return;
}

function __ZN5physx2Sc9ClothCore10putToSleepEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 392 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc7BodySim30internalWakeUpArticulationLinkEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __ZN5physx2Sc7BodySim18internalWakeUpBaseEf(i1, f2);
 return;
}

function __ZN5physx2Sc5Scene24getOutOfBoundsAggregatesEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 51612 | 0;
}

function __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 125 >> 0] = i2;
 return;
}

function __ZN4Mesh16GetSkinInfluenceEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN16MeshSkinningData16GetSkinInfluenceEi((HEAP32[i1 + 32 >> 2] | 0) + 144 | 0, i2) | 0;
}

function __ZN2UI6Canvas24SetCachedMeshBoundsDirtyEv(i1) {
 i1 = i1 | 0;
 do {
  HEAP8[i1 + 400 >> 0] = 1;
  i1 = HEAP32[i1 + 344 >> 2] | 0;
 } while ((i1 | 0) != 0);
 return;
}

function __ZN2UI20DoSyncInheritedAlphaERNS_13UIInstructionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 644 >> 2] = f2;
 HEAP16[i1 + 664 >> 1] = 4;
 return;
}

function __ZN22LocalFileSystemHandler18IsAbsoluteFilePathEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0; else return (HEAP8[i2 >> 0] | 0) == 47 | 0;
 return 0;
}

function __ZN21UniformBufferTFMethod13DoneRenderingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZN14DataBufferGLES12RecordRenderEv(i1);
 return;
}

function __ZN21AssetBundleFileSystem4SeekER13FileEntryDatax10FileOrigin(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN20QuadTreeNodeRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20IntermediateRendererD2Ev(i1);
 __ZN10MemoryPool10DeallocateEPv(HEAP32[gb + 1467168 >> 2] | 0, i1);
 return;
}

function __ZN19TouchPhaseEmulation20SetMultiTouchEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP8[i1 + 23 >> 0] | 0) return;
 HEAP8[i1 + 22 >> 0] = i2 & 1;
 return;
}

function __ZN13PhysicsModule21ReleaseNxTriangleMeshEP17PhysicsModuleMesh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 return;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStream5flushEv(i1) {
 i1 = i1 | 0;
 return (__ZN5physx6shdfnd6Socket5flushEv((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0) | 0) & 1 ^ 1 | 0;
}

function __ZN11UnityEngine9Animation27BoundCurveValueAwakeGenericER6Object(i1) {
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0, 16);
 return;
}

function __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_ClearRenderTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559559 | 0, fb + 1 | 0);
 return;
}

function __Z75Register_UnityEngineInternal_GIDebugVisualisation_ResetRuntimeInputTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513133 | 0, fb + 94 | 0);
 return;
}

function __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559680 | 0, fb + 632 | 0);
 return;
}

function __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559813 | 0, fb + 634 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651364 | 0, fb + 763 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625483 | 0, fb + 219 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625235 | 0, fb + 218 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624987 | 0, fb + 217 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625550 | 0, fb + 276 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625302 | 0, fb + 275 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625054 | 0, fb + 274 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633750 | 0, fb + 244 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633616 | 0, fb + 243 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633482 | 0, fb + 242 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633817 | 0, fb + 301 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633683 | 0, fb + 300 | 0);
 return;
}

function __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633549 | 0, fb + 299 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629736 | 0, fb + 3277 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629802 | 0, fb + 1995 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmittersCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645183 | 0, fb + 2039 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636802 | 0, fb + 3335 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636868 | 0, fb + 2011 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638698 | 0, fb + 3350 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638764 | 0, fb + 2014 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetUseRandomDistributionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648308 | 0, fb + 3409 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetAlphaAffectsIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648796 | 0, fb + 3413 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetUseRandomDistributionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648374 | 0, fb + 2049 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetAlphaAffectsIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648862 | 0, fb + 2053 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633884 | 0, fb + 3307 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetRandomizedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634016 | 0, fb + 3308 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633950 | 0, fb + 2003 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetRandomizedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634082 | 0, fb + 2004 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxCollisionShapesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643488 | 0, fb + 3386 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxCollisionShapesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643554 | 0, fb + 2028 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderComponentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655541 | 0, fb + 2085 | 0);
 return;
}

function __Z73Register_UnityEngine_Networking_DownloadHandler_InternalCreateAssetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028211 | 0, fb + 994 | 0);
 return;
}

function __Z73Register_UnityEngine_GeometryUtility_INTERNAL_CALL_Internal_ExtractPlanesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534103 | 0, fb + 2936 | 0);
 return;
}

function __Z73Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorStringIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024130 | 0, fb + 197 | 0);
 return;
}

function __Z73Register_UnityEngine_CullingGroup_INTERNAL_CALL_SetDistanceReferencePointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511006 | 0, fb + 2821 | 0);
 return;
}

function __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792986 | 0, fb + 3779 | 0);
 return;
}

function __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792920 | 0, fb + 3778 | 0);
 return;
}

function __Z72Register_UnityEngine_Networking_DownloadHandlerAudioClip_InternalGetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028924 | 0, fb + 2741 | 0);
 return;
}

function __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039415 | 0, fb + 1123 | 0);
 return;
}

function __Z50setPxSimulationStatisticsParticlesGpuMeshCacheUsedPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 880 >> 2] = i1;
 return;
}

function __Z50setPxSimulationStatisticsParticlesGpuMeshCacheSizePN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 876 >> 2] = i1;
 return;
}

function __Z44RenderSettings_Set_Custom_PropFogEndDistancef(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings15SetLinearFogEndEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z43RenderSettings_Set_Custom_PropFlareStrengthf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings16SetFlareStrengthEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z42setPxVehicleDriveDynData_AutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 84 >> 2] = f1;
 return;
}

function __Z42setPxVehicleDriveDynDataMAutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 84 >> 2] = f1;
 return;
}

function __Z41setPxVehicleSuspensionDataMMaxCompressionPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z36getPxVehicleNoDrive_ConcreteTypeNamePKN5physx16PxVehicleNoDriveE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z36getPxVehicleDriveNW_ConcreteTypeNamePKN5physx16PxVehicleDriveNWE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z36getPxVehicleDrive4W_ConcreteTypeNamePKN5physx16PxVehicleDrive4WE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z36getPxSphericalJoint_ConcreteTypeNamePKN5physx16PxSphericalJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z36getPxPrismaticJoint_ConcreteTypeNamePKN5physx16PxPrismaticJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z36getPxParticleSystem_ConcreteTypeNamePKN5physx16PxParticleSystemE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z34getPxScene_FrictionOffsetThresholdPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 276 >> 2] | 0, i1 | 0));
}

function __Z34getPxScene_BounceThresholdVelocityPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 260 >> 2] | 0, i1 | 0));
}

function __Z32getPxArticulationJoint_DriveTypePKN5physx19PxArticulationJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
}

function __Z32getNbPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 232 >> 2] | 0, i1 | 0) | 0;
}

function __Z31getPxVehicleGearsData_GearRatioPKN5physx18PxVehicleGearsDataENS0_4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i2 + (i1 << 2) >> 2]);
}

function __Z26getPxParticleBase_GridSizePKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 224 >> 2] | 0, i1 | 0));
}

function __Z20getPxShape_LocalPosePKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 72 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z11GetRotationi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function _AllocateUTF16Memory(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, i2, 0, gb + 489101 | 0, 14) | 0;
}

function _wcstoll(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, 0, -2147483648) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _strtoll(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, 0, -2147483648) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _jpeg_alloc_quant_table(i1) {
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 0, 130) | 0;
 HEAP8[i1 + 128 >> 0] = 0;
 return i1 | 0;
}

function _emscripten_glUniform3i__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glUniform3i(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glColorMask__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glColorMask(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _conj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var d3 = 0.0;
 d3 = -+HEAPF64[i2 + 8 >> 3];
 HEAPF64[i1 >> 3] = +HEAPF64[i2 >> 3];
 HEAPF64[i1 + 8 >> 3] = d3;
 return;
}

function _cff_get_standard_encoding(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 >= 256) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP16[gb + 225782 + (i1 << 1) >> 1] | 0;
 return i1 | 0;
}

function __ZNSt3__29strstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD2Ev(i1, gb + 215748 | 0);
 __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i1 + 60 | 0);
 return;
}

function __ZNK17FileSystemHandler6TargetERK13FileEntryDataR15FileSystemEntry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZNK14DLHAudioHelper11GetCapacityEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __ZN9Texture3D15UpdateImageDataEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2) __ZN9Texture3D13RebuildMipMapEv(i1);
 __ZN9Texture3D13UploadTextureEv(i1);
 return;
}

function __ZN9TextAsset9SetScriptERK8UnityStr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iiii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, i2 | 0, 0) | 0;
}

function __ZN9GfxDevice21CreateComputeBufferIDEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1157624 >> 2] = (HEAP32[gb + 1157624 >> 2] | 0) + 1;
 return HEAP32[gb + 1157624 >> 2] | 0;
}

function __ZN5physx3Cct26CharacterControllerManager39setPreventVerticalSlidingAgainstCeilingEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 135 >> 0] = i1 & 1;
 return;
}

function __ZN5physx23PxGetGroupCollisionFlagEtt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[(i2 & 65535) + (gb + 1550009 + ((i1 & 65535) << 5)) >> 0] | 0) != 0 | 0;
}

function __ZN5physx19PxClothFabricCookerD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __ZN5physx18PxFabricCookerImplD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 95136 + 8;
 __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE(i1);
 return;
}

function __ZN5physx14NpSpatialIndex11rebuildStepEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sq10AABBPruner9buildStepEv(HEAP32[i1 + 8 >> 2] | 0) | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 return;
}

function __ZN5Umbra16LineSegmentQuery12setObjectSetEPNS_9IndexListE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 28 >> 2] = i2;
 return;
}

function __ZN5Umbra11ArrayMapperD2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 12 >> 2] | 0;
 if (!i2) return;
 HEAP32[i2 + 4 >> 2] = HEAP32[i1 + 16 >> 2];
 return;
}

function __ZN24UserAuthorizationManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 >> 2] = 3;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN19GCProfilerCallbacks9OnGCEventEPvii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN10GCProfiler13RegisterEventENS_7GCEventEi(i1, i2, 0);
 return;
}

function __ZN18BaseUnityAnalytics16IsAnalyticsReadyEv(i1) {
 i1 = i1 | 0;
 i1 = mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0) | 0;
 return (i1 ? 0 : 2) | 0;
}

function __ZN15AudioMixerGroup13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(i2 & 4)) return;
 __ZN9UnityGUID4InitEv(i1 + 56 | 0);
 return;
}

function __ZN14RenderSettings6SetSunEP5Light(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 388 >> 2] = i1;
 return;
}

function __ZN14RenderSettings16SetUseFogNoDirtyEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 312 >> 0] = i2 & 1;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN14ParticleSystem14SetScalingModeE25ParticleSystemScalingMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 284 >> 2] = i2;
 return;
}

function __ZN13TriggerEvents5ClearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 HEAP32[i1 + 72 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceNull19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN12ImageDecoderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 43080 + 8;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN11UnityEngine9AnimationltERKNS0_13CachedBindingES3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 >> 2] | 0) >>> 0 < (HEAP32[i2 >> 2] | 0) >>> 0 | 0;
}

function __ZN11UmbraModule15GetObjectUserIDEPKN5Umbra4TomeEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZNK5Umbra4Tome15getObjectUserIDEi(i2, i3) | 0;
}

function __ZN11AudioModule19SetApplicationPauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12AudioManager19SetApplicationPauseEb(__Z15GetAudioManagerv() | 0, i2);
 return;
}

function __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayListImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560002 | 0, fb + 637 | 0);
 return;
}

function __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayListImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560126 | 0, fb + 639 | 0);
 return;
}

function __Z73Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559747 | 0, fb + 633 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterSystemv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645710 | 0, fb + 759 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterSystemv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645910 | 0, fb + 817 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635488 | 0, fb + 247 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635356 | 0, fb + 246 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635224 | 0, fb + 245 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635554 | 0, fb + 304 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635422 | 0, fb + 303 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635290 | 0, fb + 302 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623589 | 0, fb + 212 | 0);
 return;
}

function __Z73Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623655 | 0, fb + 269 | 0);
 return;
}

function __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_SetHumanPosev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930405 | 0, fb + 174 | 0);
 return;
}

function __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_GetHumanPosev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930339 | 0, fb + 173 | 0);
 return;
}

function __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914247 | 0, fb + 658 | 0);
 return;
}

function __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 914181 | 0, fb + 747 | 0);
 return;
}

function __Z73Register_UnityEngine_AssetBundleManifest_INTERNAL_CALL_GetAssetBundleHashv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497081 | 0, fb + 549 | 0);
 return;
}

function __Z72Register_UnityEngine_RenderTexture_INTERNAL_CALL_GetNativeDepthBufferPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576201 | 0, fb + 3136 | 0);
 return;
}

function __Z72Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014771 | 0, fb + 323 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631488 | 0, fb + 3290 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631208 | 0, fb + 3288 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630928 | 0, fb + 3286 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631553 | 0, fb + 3291 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 631273 | 0, fb + 3289 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630993 | 0, fb + 3287 | 0);
 return;
}

function __Z72Register_UnityEngine_Networking_UnityWebRequest_InternalSetRequestHeaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033376 | 0, fb + 997 | 0);
 return;
}

function __Z72Register_UnityEngine_GUIUtility_INTERNAL_CALL_Internal_GetNextControlID2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024548 | 0, fb + 478 | 0);
 return;
}

function __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791605 | 0, fb + 3755 | 0);
 return;
}

function __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791540 | 0, fb + 3754 | 0);
 return;
}

function __Z72Register_UnityEngine_AssetBundleCreateRequest_DisableCompatibilityChecksv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496092 | 0, fb + 3465 | 0);
 return;
}

function __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalSetContentTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029440 | 0, fb + 4306 | 0);
 return;
}

function __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetContentTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029376 | 0, fb + 2743 | 0);
 return;
}

function __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalSetCustomMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032105 | 0, fb + 4308 | 0);
 return;
}

function __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalGetCustomMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032227 | 0, fb + 2747 | 0);
 return;
}

function __Z71Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_MoveWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021620 | 0, fb + 4281 | 0);
 return;
}

function __Z56getPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z53AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectArrayElement13Il2Cpp_IntPtriRPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z52AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticObjectField13Il2Cpp_IntPtrS_RPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z47RenderSettings_Set_Custom_PropReflectionBouncesi(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings20SetReflectionBouncesEi(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z40setPxJointLimitParametersContactDistancePN5physx22PxJointLimitParametersEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 16 >> 2] = f1;
 return;
}

function __Z39setPxVehicleSuspensionDataMCamberAtRestPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z35getPxParticleBase_ParticleBaseFlagsPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0) | 0;
}

function __Z33getPxCloth_SelfCollisionStiffnessPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 400 >> 2] | 0, i1 | 0));
}

function __Z28Screen_Get_Custom_PropHeightv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
}

function __Z26PlayerRenderCanvasOverlaysi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1115296 + 412 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __Z25getPxParticleBase_DampingPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
}

function __Z24getPxRevoluteJoint_AnglePKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0));
}

function __Z19getPxShape_GeometryPKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z19UnixTimeToUnityTimelR8DateTime(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = ((i1 | 0) < 0) << 31 >> 31 & 65535;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z18getPxScene_GravityPKN5physx7PxSceneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 252 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z18Transfer_BlittableI17RemapPPtrTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z12IsUserActiveRKj(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 >>> 0 < 17) return (82009 >>> (i1 & 131071) & 1 | 0) != 0 | 0; else return 0;
 return 0;
}

function _UNITY_LZ4_compressBound(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 2113929216) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = i1 + 16 + ((i1 >>> 0) / 255 | 0) | 0;
 return i1 | 0;
}

function b57(i1, i2, d3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_iiidiiii(57);
 return 0;
}

function b25(i1, f2, i3, f4, f5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 nullFunc_vififfi(25);
}

function _strxfrm(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 var i4 = 0;
 i4 = _strlen(i2) | 0;
 if (i4 >>> 0 < i3 >>> 0) _strcpy(i1, i2) | 0;
 return i4 | 0;
}

function _jpeg_alloc_huff_table(i1) {
 i1 = i1 | 0;
 i1 = mftCall_iiii(HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0, i1 | 0, 0, 274) | 0;
 HEAP8[i1 + 273 >> 0] = 0;
 return i1 | 0;
}

function _glMapBufferRange__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _glMapBufferRange(i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function _glClientWaitSync__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _glClientWaitSync(i1 | 0, i2 | 0, i3 | 0, i4 | 0) | 0;
}

function __ZSt17__throw_bad_allocv() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt9bad_allocC2Ev(i1);
 ___cxa_throw(i1 | 0, gb + 13048 | 0, fb + 3215 | 0);
}

function __ZNSt3__26locale5__imp12make_classicEv() {
 __ZNSt3__26locale5__impC2Ej(gb + 1100288 | 0, 1);
 HEAP32[gb + 1476384 >> 2] = gb + 1100288;
 return gb + 1476384 | 0;
}

function __ZNSt3__215__thread_structD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) {
  __ZNSt3__219__thread_struct_impD2Ev(i1);
  __ZdlPv(i1);
 }
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 + 11 >> 0] | 0) < 0) __ZdlPv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE8groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb0EE8groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb1EE8groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__210moneypunctIcLb0EE8groupingEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 56 | 0) | 0;
}

function __ZNK5physx7NpScene30getClothInterCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc5Scene30getClothInterCollisionDistanceEv(i1 + 32 | 0));
}

function __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EdeEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EixEj(i1, i2, 0);
 return;
}

function __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK13WheelCollider17GetVehicleNoDriveEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) + 56 >> 2] | 0;
}

function __ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i1 | 0) == (i2 | 0) | 0;
}

function __ZN9GfxDevice23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8Playable22ScheduleForDestructionEv(i1) {
 i1 = i1 | 0;
 __ZN15DirectorManager22ScheduleForDestructionEP8Playable(__Z18GetDirectorManagerv() | 0, i1);
 return;
}

function __ZN6SkyboxD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN6Skybox11SetMaterialEP8Material(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 4 >> 2] | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 return;
}

function __ZN6Camera19EndSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5physx3Cct13BoxController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN19UnityConnectService27OnDidReloadMonoDomainStaticEPS_(i1) {
 i1 = i1 | 0;
 __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i1, 0);
 return;
}

function __ZN19TransportJavaScript10OnProgressEPvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 20 >> 2] = i3;
 HEAP32[i1 + 24 >> 2] = i2;
 return;
}

function __ZN14PhysicMaterialD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13PhysicsModule19ReleaseNxConvexMeshEP17PhysicsModuleMesh(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 return;
}

function __ZN12TextureInputC2Ev(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 36 | 0;
 do {
  HEAP32[i1 >> 2] = 0;
  i1 = i1 + 4 | 0;
 } while ((i1 | 0) < (i2 | 0));
 return;
}

function __ZN12HandlerChain19InitializeFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1040 >> 2] = i1;
 HEAP32[i2 + 1044 >> 2] = i1;
 return;
}

function __ZL20SortItemByInstanceIDRKN18AwakeFromLoadQueue4ItemES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) < (HEAP32[i2 + 4 >> 2] | 0) | 0;
}

function __Z73Register_UnityEngine_GUIStyle_Internal_GetNumCharactersThatFitWithinWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024196 | 0, fb + 7 | 0);
 return;
}

function __Z73Register_UnityEngine_Application_GetUserAuthorizationRequestMode_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495714 | 0, fb + 38 | 0);
 return;
}

function __Z72Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayListImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559880 | 0, fb + 635 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647974 | 0, fb + 279 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipUv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647844 | 0, fb + 278 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648039 | 0, fb + 336 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipUv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 647909 | 0, fb + 335 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_ShapeModule_SetRandomDirectionAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627806 | 0, fb + 225 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_ShapeModule_GetRandomDirectionAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627871 | 0, fb + 282 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638568 | 0, fb + 256 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638438 | 0, fb + 255 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638308 | 0, fb + 254 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638633 | 0, fb + 313 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638503 | 0, fb + 312 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638373 | 0, fb + 311 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640892 | 0, fb + 264 | 0);
 return;
}

function __Z72Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640957 | 0, fb + 321 | 0);
 return;
}

function __Z72Register_UnityEngine_Animator_INTERNAL_CALL_SetBoneLocalRotationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920898 | 0, fb + 934 | 0);
 return;
}

function __Z72Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_CalculatePathInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848604 | 0, fb + 426 | 0);
 return;
}

function __Z71Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014836 | 0, fb + 985 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_TrailModule_SetInheritParticleColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650626 | 0, fb + 3426 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_TrailModule_GetInheritParticleColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650690 | 0, fb + 2061 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshMaterialIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629060 | 0, fb + 3274 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshMaterialIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629124 | 0, fb + 1992 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_MainModule_SetCustomSimulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626229 | 0, fb + 3256 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_MainModule_GetCustomSimulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626293 | 0, fb + 1979 | 0);
 return;
}

function __Z71Register_UnityEngine_Networking_DownloadHandler_InternalCreateAudioClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028357 | 0, fb + 995 | 0);
 return;
}

function __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791476 | 0, fb + 3753 | 0);
 return;
}

function __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791412 | 0, fb + 3752 | 0);
 return;
}

function __Z71Register_UnityEngine_Animator_set_allowConstantClipSamplingOptimizationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919784 | 0, fb + 4125 | 0);
 return;
}

function __Z71Register_UnityEngine_Animator_get_allowConstantClipSamplingOptimizationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919720 | 0, fb + 2558 | 0);
 return;
}

function __Z70Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028794 | 0, fb + 2739 | 0);
 return;
}

function __Z70Register_UnityEngine_Networking_DownloadHandlerAudioClip_get_audioClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028989 | 0, fb + 2742 | 0);
 return;
}

function __Z62getPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 100 >> 2]);
}

function __Z56getPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z48Input_Get_Custom_PropEatKeyPressOnTextFieldFocusv() {
 return (__ZN12InputManager30GetEatKeyPressOnTextFieldFocusEv(__Z15GetInputManagerv() | 0) | 0) & 1 | 0;
}

function __Z46QualitySettings_Set_Custom_PropPixelLightCounti(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings18SetPixelLightCountEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z46QualitySettings_Set_Custom_PropMaximumLODLeveli(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings18SetMaximumLODLevelEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z42setPxClothStretchConfigStiffnessMultiplierPN5physx20PxClothStretchConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z42getPxScene_ClothInterCollisionNbIterationsPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 160 >> 2] | 0, i1 | 0) | 0;
}

function __Z42RenderSettings_Set_Custom_PropHaloStrengthf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings15SetHaloStrengthEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z40setPxJointLimitParametersBounceThresholdPN5physx22PxJointLimitParametersEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z39Application_CUSTOM_SetStackTraceLogType7LogTypei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(i1, i2);
 return;
}

function __Z37setPxClothMotionConstraintConfigScalePN5physx29PxClothMotionConstraintConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z35setPxVehicleDifferential4WDataMTypePN5physx27PxVehicleDifferential4WDataENS0_4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 return;
}

function __Z35getPxVehicleWheels_ConcreteTypeNamePKN5physx15PxVehicleWheelsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z35getPxRevoluteJoint_ConcreteTypeNamePKN5physx15PxRevoluteJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z35getPxParticleFluid_ConcreteTypeNamePKN5physx15PxParticleFluidE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z35getPxDistanceJoint_ConcreteTypeNamePKN5physx15PxDistanceJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z35DoesBuildTargetSupportBlobification19BuildTargetPlatform24TransferInstructionFlags(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i2 & 67108864 | 0) != 0 | 0;
}

function __Z33setPxConvexMeshGeometryConvexMeshPN5physx20PxConvexMeshGeometryEPNS_12PxConvexMeshE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 32 >> 2] = i1;
 return;
}

function __Z32getPxScene_WakeCounterResetValuePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 432 >> 2] | 0, i1 | 0));
}

function __Z32getPxCloth_SelfCollisionDistancePKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 392 >> 2] | 0, i1 | 0));
}

function __Z29getPxMaterial_DynamicFrictionPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0));
}

function __Z28setPxSceneDescFilterCallbackPN5physx11PxSceneDescEPNS_26PxSimulationFilterCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 36 >> 2] = i1;
 return;
}

function __Z27Screen_Get_Custom_PropWidthv() {
 var i1 = 0;
 i1 = __Z16GetScreenManagerv() | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
}

function __Z27NavMesh_CUSTOM_GetLayerCosti(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK22NavMeshProjectSettings11GetAreaCostEj(__Z25GetNavMeshProjectSettingsv() | 0, i1));
}

function __Z26setPxHeightFieldDescFormatPN5physx17PxHeightFieldDescENS_19PxHeightFieldFormat4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z22CreateMutexLockedStackv() {
 var i1 = 0;
 i1 = __ZnwjRK10MemLabelIdiPKci(8, gb + 63200 | 0, 16, gb + 487865 | 0, 6) | 0;
 HEAP32[i1 >> 2] = 0;
 return i1 | 0;
}

function __Z16DestroyIndexListR9IndexList(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 64024 | 0);
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z15setPxShape_NamePN5physx7PxShapeEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 144 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __Z15setPxJoint_NamePN5physx7PxJointEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 108 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function b0(i1, i2, i3, f4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_viiifiii(0);
}

function _ldiv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = (i2 | 0) / (i3 | 0) | 0;
 HEAP32[i1 + 4 >> 2] = (i2 | 0) % (i3 | 0) | 0;
 return;
}

function _glStencilFuncSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glStencilFuncSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glRenderbufferStorage__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glRenderbufferStorage(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glDrawArraysInstanced__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glDrawArraysInstanced(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glViewport__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glViewport(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _duplocale(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _calloc(1, 4) | 0;
 if ((i1 | 0) != (-1 | 0) & (i2 | 0) != 0) HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 return i2 | 0;
}

function __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffnessD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CBD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdatePollPlayerConnectionstruct7ForwardEv() {
 __ZN16PlayerConnection4PollEv(__ZN16PlayerConnection3GetEv() | 0);
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateGUIClearEventsstruct7ForwardEv() {
 __ZN15GUIEventManager11ClearEventsEv(__Z18GetGUIEventManagerv() | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 536 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 528 >> 2] | 0) >>> 0 | 0;
}

function __ZThn32_N22ParticleSystemRenderer23RendererBecameInvisibleEv(i1) {
 i1 = i1 | 0;
 __ZN22ParticleSystemRenderer23RendererBecameInvisibleEv(i1 + -32 | 0);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -12 + 80 >> 2] | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE8setstateEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | i2);
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE8setstateEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base5clearEj(i1, HEAP32[i1 + 16 >> 2] | i2);
 return;
}

function __ZNK8Renderer16IsVisibleInSceneEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 268 | 0;
 return ((HEAPU16[i1 >> 1] | 0 | (HEAPU8[i1 + 2 >> 0] | 0) << 16) & 4096 | 0) != 0 | 0;
}

function __ZNK5physx7NpScene34getClothInterCollisionNbIterationsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene34getClothInterCollisionNbIterationsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx14NpShapeManager15shapeIsAttachedERNS_7NpShapeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (__ZNK5physx2Cm8PtrTable4findEPKv(i2, i1) | 0) != -1 | 0;
}

function __ZNK23LODTreeInstanceRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[HEAP32[i1 + 276 >> 2] >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK15DirectorManager16GetScriptMethodsEs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 420 >> 2] | 0) + (((i2 << 16 >> 16) + -1 | 0) * 40 | 0) | 0;
}

function __ZNK10MemoryFile8PositionEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 24 | 0;
 i1 = HEAP32[i2 >> 2] | 0;
 setTempRet0(HEAP32[i2 + 4 >> 2] | 0);
 return i1 | 0;
}

function __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN8VRDevice15InitializePosesEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 280 >> 2] | 0;
 if (!i1) return;
 __ZN7VRInput27ResetAllReferenceTransformsEv(i1);
 return;
}

function __ZN8Animator17GetAvatarConstantEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 153 >> 0] | 0)) __ZN8Animator16InitializeAvatarEv(i1);
 return HEAP32[i1 + 124 >> 2] | 0;
}

function __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE15clearCachedDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc5Scene21getOutOfBoundsObjectsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 8 >> 2] | 0) + 51600 | 0;
}

function __ZN5physx2Gu13MeshInterfaceC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx21PxVehicleDriveSimData12setGearsDataERKNS_18PxVehicleGearsDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 _memcpy(i2 + 112 | 0, i1 | 0, 144) | 0;
 return;
}

function __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf(i2, i3, f1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + (i3 << 2) >> 2] = f1;
 return;
}

function __ZN5physx20InternalTriangleMeshD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx20InternalTriangleMesh7releaseEv(i1);
 __ZN5physx2Gu13RTreeMidphaseD2Ev(i1 + 16 | 0);
 return;
}

function __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb(i4, i3, i2, i1) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5Unity11SpringJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 112584 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5Umbra10Visibility17setOutputClustersEPNS_9IndexListE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] = i2;
 return;
}

function __ZN5Umbra10Visibility15setInputObjectsEPKNS_9IndexListE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 >> 2] = i2;
 return;
}

function __ZN5LightD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4Halo23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN43MultiWriterSingleReaderAtomicCircularBufferD2Ev(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[i1 >> 2] | 0, gb + 63200 | 0);
 return;
}

function __ZN22PerThreadPageAllocatorC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN22LocalFileSystemHandler18SetApplicationPathEPKc(i1) {
 i1 = i1 | 0;
 _strncpy(gb + 1547918 | 0, i1, 1040) | 0;
 HEAP8[gb + 1547918 + 1039 >> 0] = 0;
 return;
}

function __ZN18StreamedBinaryReadILb1EE10ReadDirectEPvi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN12CachedReader4ReadEPvj(i1 + 16 | 0, i2, i3);
 return;
}

function __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN12CachedReader4ReadEPvj(i1 + 16 | 0, i2, i3);
 return;
}

function __ZN17LowLevelAllocator7ReallocEPvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN13MemoryManager18LowLevelReallocateEPvjj(i1, i2, i3) | 0;
}

function __ZN17AnimationPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 72 >> 0] = 1;
 return;
}

function __ZN16TimerQueriesGLES16PollTimerQueriesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 do {} while (__ZN16TimerQueriesGLES18PollNextTimerQueryEb(i1, i2) | 0);
 return;
}

function __ZN15ReflectionProbe21ReleaseCachedRendererEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 168 | 0;
 HEAP8[(HEAP32[i1 >> 2] | 0) + 16 >> 0] = 1;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14RenderSettings10SetFogModeE7FogMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 316 >> 2] = i2;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN14DirectorPlayer8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14DirectorPlayer13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN13GfxDeviceNull32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 1;
}

function __ZN11UnityEngine15PlatformWrapper21GetApplicationVersionEv(i1) {
 i1 = i1 | 0;
 __ZN15ApplicationInfo10GetVersionEv(i1, __Z18GetApplicationInfov() | 0);
 return;
}

function __ZL16UnityDetourAlloci(i1) {
 i1 = i1 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63704 | 0, 0, gb + 842172 | 0, 95) | 0;
}

function __Z73Register_UnityEngine_Camera_INTERNAL_CALL_CalculateFrustumCornersInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506486 | 0, fb + 1 | 0);
 return;
}

function __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalTransactionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039350 | 0, fb + 1 | 0);
 return;
}

function __Z71Register_UnityEngine_Rendering_CommandBuffer_SetShadowSamplingMode_Implv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560362 | 0, fb + 643 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645776 | 0, fb + 760 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645976 | 0, fb + 818 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649256 | 0, fb + 282 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649320 | 0, fb + 339 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642220 | 0, fb + 268 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetBounceMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642456 | 0, fb + 269 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642284 | 0, fb + 325 | 0);
 return;
}

function __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetBounceMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642520 | 0, fb + 326 | 0);
 return;
}

function __Z70Register_UnityEngine_Renderer_INTERNAL_set_realtimeLightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526490 | 0, fb + 2891 | 0);
 return;
}

function __Z70Register_UnityEngine_Renderer_INTERNAL_get_realtimeLightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526427 | 0, fb + 2890 | 0);
 return;
}

function __Z70Register_UnityEngine_Profiling_Profiler_set_maxNumberOfSamplesPerFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553754 | 0, fb + 3624 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650500 | 0, fb + 3425 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650563 | 0, fb + 2060 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_SubEmittersModule_RemoveSubEmitterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645647 | 0, fb + 3395 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ShapeModule_SetSkinnedMeshRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628934 | 0, fb + 3273 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ShapeModule_GetSkinnedMeshRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628997 | 0, fb + 1991 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633014 | 0, fb + 3300 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633077 | 0, fb + 2002 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627220 | 0, fb + 3263 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627283 | 0, fb + 3264 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634148 | 0, fb + 3309 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634211 | 0, fb + 2005 | 0);
 return;
}

function __Z70Register_UnityEngine_Gyroscope_INTERNAL_CALL_userAcceleration_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536978 | 0, fb + 2945 | 0);
 return;
}

function __Z70Register_UnityEngine_DynamicGI_INTERNAL_CALL_UpdateMaterialsForTerrainv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512943 | 0, fb + 2827 | 0);
 return;
}

function __Z70Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesWithVariantv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497018 | 0, fb + 1597 | 0);
 return;
}

function __Z70Register_UnityEngine_AI_NavMeshAgent_GetCurrentOffMeshLinkDataInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847521 | 0, fb + 4015 | 0);
 return;
}

function __Z69Register_UnityEngine_Networking_DownloadHandler_InternalCreateTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028149 | 0, fb + 4303 | 0);
 return;
}

function __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028590 | 0, fb + 2737 | 0);
 return;
}

function __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028528 | 0, fb + 2736 | 0);
 return;
}

function __Z69Register_UnityEngine_Connect_UnityAdsSettings_set_initializeOnStartupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043299 | 0, fb + 3945 | 0);
 return;
}

function __Z69Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserBirthYearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039231 | 0, fb + 1122 | 0);
 return;
}

function __Z48setPxSimulationStatisticsNbAxisSolverConstraintsPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 48 >> 2] = i1;
 return;
}

function __Z39setPxVehicleDriveDynData_GearSwitchTimePN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __Z39setPxVehicleDriveDynDataMGearSwitchTimePN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __Z39SortingLayer_CUSTOM_GetLayerValueFromIDi(i1) {
 i1 = i1 | 0;
 return __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi(__Z13GetTagManagerv() | 0, i1) | 0;
}

function __Z38Physics_Set_Custom_PropBounceThresholdf(f1) {
 f1 = Math_fround(f1);
 __ZN14PhysicsManager18SetBounceThresholdEf(__Z17GetPhysicsManagerv() | 0, f1);
 return;
}

function __Z38Physics2D_CUSTOM_GetLayerCollisionMaski(i1) {
 i1 = i1 | 0;
 return __ZN16Physics2DManager21GetLayerCollisionMaskEi(__Z19GetPhysicsManager2Dv() | 0, i1) | 0;
}

function __Z38Compass_Get_Custom_PropMagneticHeadingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(__ZN15LocationService14GetLastHeadingEv() | 0) >> 2]);
}

function __Z38Application_Get_Custom_PropIsWebPlayerv() {
 var i1 = 0;
 i1 = __ZN10systeminfo18GetRuntimePlatformEv() | 0;
 return ((i1 | 0) == 5 | (i1 | 0) == 3) & 1 | 0;
}

function __Z37setPxVehicleSuspensionDataMSprungMassPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 16 >> 2] = f1;
 return;
}

function __Z36getPxVehicleDriveSimData_AutoBoxDataPKN5physx21PxVehicleDriveSimDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(i1 | 0, i2 + 272 | 0, 256) | 0;
 return;
}

function __Z36Physics2D_Set_Custom_PropTimeToSleepf(f1) {
 f1 = Math_fround(f1);
 __ZN17Physics2DSettings14SetTimeToSleepEf(__Z20GetPhysics2DSettingsv() | 0, f1);
 return;
}

function __Z35Physics_CUSTOM_INTERNAL_set_gravityRK8Vector3f(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManager10SetGravityERK8Vector3f(__Z17GetPhysicsManagerv() | 0, i1);
 return;
}

function __Z34Compass_Get_Custom_PropTrueHeadingP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(__ZN15LocationService14GetLastHeadingEv() | 0) + 4 >> 2]);
}

function __Z31setPxClothParticleDataParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z30setPxSceneDescDynamicStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 120 >> 2] = i1;
 return;
}

function __Z28getPxMaterial_StaticFrictionPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0));
}

function __Z27GetTextureIDOrBlackFallbackP9Texture2D(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? (HEAP32[gb + 1157932 >> 2] | 0) + 48 | 0 : i1 + 48 | 0) >> 2] | 0;
}

function __Z26NavMesh_CUSTOM_GetAreaCosti(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK22NavMeshProjectSettings11GetAreaCostEj(__Z25GetNavMeshProjectSettingsv() | 0, i1));
}

function __Z17getPxScene_LimitsPKN5physx7PxSceneE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __Z15setPxActor_NamePN5physx7PxActorEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 32 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function _div(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = (i2 | 0) / (i3 | 0) | 0;
 HEAP32[i1 + 4 >> 2] = (i2 | 0) % (i3 | 0) | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__set_short_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 8 + 3 >> 0] = i2;
 return;
}

function __ZNKSt3__224__generic_error_category7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNKSt3__212__do_message7messageEi(i1, 0, i3);
 return;
}

function __ZNK5physx7NpScene29getContactCorrelationDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc5Scene29getContactCorrelationDistanceEv(i1 + 32 | 0));
}

function __ZNK5physx2Sn21SerializationRegistry17getSerializerTypeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i2 + 12 >> 2] | 0) + (i1 << 3) >> 1] | 0;
}

function __ZNK5physx2Sc5Scene20getMeshContactMarginEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 6160 >> 2]);
}

function __ZNK5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i2 + 132 >> 2] | 0) + (i1 << 2) >> 2]);
}

function __ZNK5physx16PxVehicleNoDrive14getBrakeTorqueEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i2 + 136 >> 2] | 0) + (i1 << 2) >> 2]);
}

function __ZNK24RendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __ZNK18AnimatorController17GetAnimationClipsEv(i1) {
 i1 = i1 | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0, 1) | 0;
 return i1 + 80 | 0;
}

function __ZNK13TranslateGLES23VertexArrayKindBitfieldEN2gl21VertexArrayAttribKindE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75596 + (i2 << 2) >> 2] | 0;
}

function __ZNK12StatusHelper10IsRedirectEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return (i1 | 0) != 306 & ((i1 | 0) != 304 & (i1 + -300 | 0) >>> 0 < 8) | 0;
}

function __ZN9GfxDevice12PresentFrameEPK14ChannelAssigns(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 504 >> 2] | 0, i1 | 0);
 return;
}

function __ZN7Cursors16GetCursorHotspotEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 1100516 >> 2];
 HEAP32[i1 + 4 >> 2] = HEAP32[gb + 1100516 + 4 >> 2];
 return;
}

function __ZN6Shader23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Shader8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN5physx9PxTaskMgr12addReferenceERNS_14PxLightCpuTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 16 | 0) | 0;
 return;
}

function __ZN5physx5cloth14SwSolverKernelI8Scalar4fE20selfCollideParticlesEv(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEclEv(i1 + 460 | 0);
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcher16getAffinityMasksEPjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _memset(i1 | 0, 0, i2 << 2 | 0) | 0;
 return;
}

function __ZN5physx3Cct12SweptCapsuleC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct11SweptVolumeC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 86284 + 8;
 HEAP32[i1 + 36 >> 2] = 1;
 return;
}

function __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 32 >> 2] = i2;
 return;
}

function __ZN5Umbra4PathC2Ev(i1) {
 i1 = i1 | 0;
 i1 = (i1 | 0) == 0 ? 0 : i1 + 3 & -4;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN4HaloD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7SystemI16setDSPBufferSizeEji(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 44 >> 2] = i2;
 HEAP32[i1 + 48 >> 2] = i3;
 return 0;
}

function __ZN18DelayedCallManager17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN18DelayedCallManager8ClearAllEv(i1);
 __ZN11GameManager17MainThreadCleanupEv(i1);
 return;
}

function __ZN17AudioReverbFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN16ParticleSortData12CompareValueERKS_S1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) >>> 0 > (HEAP32[i2 + 4 >> 2] | 0) >>> 0 | 0;
}

function __ZN15NavMeshObstacle17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager18UnregisterObstacleERi(__Z17GetNavMeshManagerv() | 0, i1 + 36 | 0);
 return;
}

function __ZN15AudioReverbZone16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 __ZN5Unity9Component16CheckConsistencyEv(i1);
 __ZN15AudioReverbZone12VerifyValuesEv(i1);
 return;
}

function __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN14StackAllocator10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_iii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0) | 0;
 return;
}

function __ZN13AudioListener13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode(i1, i2);
 return;
}

function __ZN12_GLOBAL__N_122SocketNetworkOutStream10disconnectEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd6Socket10disconnectEv((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0);
 return;
}

function __ZN12PhysXRaycast15InitializeClassEv() {
 var i1 = 0;
 i1 = __Znwj(4) | 0;
 HEAP32[i1 >> 2] = gb + 113952 + 8;
 __Z19SetRaycastInterfaceP8IRaycast(i1);
 return;
}

function __ZN11UnityEngine9Animation43DoesBindingSupportConstantCurveOptimizationERKNS0_14GenericBindingE(i1) {
 i1 = i1 | 0;
 return (HEAP16[i1 + 12 >> 1] | 0) == 4 | 0;
}

function __ZN10SampleClip8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZL22CleanupModule_Vehiclesv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z12GetIVehiclesv() | 0, gb + 63400 | 0);
 __Z12SetIVehiclesP9IVehicles(0);
 return;
}

function __Z72Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_GetRayIntersectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812219 | 0, fb + 1 | 0);
 return;
}

function __Z71Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawMeshInstancedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559100 | 0, fb + 17 | 0);
 return;
}

function __Z70Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578454 | 0, fb + 686 | 0);
 return;
}

function __Z70Register_UnityEngine_TerrainData_Internal_GetMinimumAlphamapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938021 | 0, fb + 261 | 0);
 return;
}

function __Z70Register_UnityEngine_TerrainData_Internal_GetMaximumAlphamapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938084 | 0, fb + 262 | 0);
 return;
}

function __Z70Register_UnityEngine_RaycastHit_INTERNAL_CALL_CalculateRaycastTexCoordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796006 | 0, fb + 189 | 0);
 return;
}

function __Z70Register_UnityEngine_Profiling_Profiler_get_maxNumberOfSamplesPerFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553691 | 0, fb + 191 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640006 | 0, fb + 260 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639880 | 0, fb + 259 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639754 | 0, fb + 258 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640069 | 0, fb + 317 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639943 | 0, fb + 316 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639817 | 0, fb + 315 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623827 | 0, fb + 213 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624631 | 0, fb + 216 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624399 | 0, fb + 215 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624167 | 0, fb + 214 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623351 | 0, fb + 211 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623890 | 0, fb + 270 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624694 | 0, fb + 273 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624462 | 0, fb + 272 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624230 | 0, fb + 271 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623414 | 0, fb + 268 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639096 | 0, fb + 257 | 0);
 return;
}

function __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639159 | 0, fb + 314 | 0);
 return;
}

function __Z70Register_UnityEngine_Experimental_Director_Playables_GetTypeOfInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552065 | 0, fb + 661 | 0);
 return;
}

function __Z70Register_UnityEngine_DrivenRectTransformTracker_CanRecordModificationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555054 | 0, fb + 201 | 0);
 return;
}

function __Z70Register_UnityEngine_AnimatorOverrideController_Internal_SetClipByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928553 | 0, fb + 949 | 0);
 return;
}

function __Z70Register_UnityEngine_AnimatorOverrideController_Internal_GetClipByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928490 | 0, fb + 438 | 0);
 return;
}

function __Z69Register_UnityEngine_Terrain_INTERNAL_set_realtimeLightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942861 | 0, fb + 4184 | 0);
 return;
}

function __Z69Register_UnityEngine_Terrain_INTERNAL_get_realtimeLightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942799 | 0, fb + 4183 | 0);
 return;
}

function __Z69Register_UnityEngine_ScriptableObject_Internal_CreateScriptableObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500091 | 0, fb + 3468 | 0);
 return;
}

function __Z69Register_UnityEngine_SceneManagement_Scene_GetRootGameObjectsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561460 | 0, fb + 3058 | 0);
 return;
}

function __Z69Register_UnityEngine_QualitySettings_set_billboardsFaceCameraPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522933 | 0, fb + 3545 | 0);
 return;
}

function __Z69Register_UnityEngine_QualitySettings_INTERNAL_set_shadowCascade4Splitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522001 | 0, fb + 3537 | 0);
 return;
}

function __Z69Register_UnityEngine_QualitySettings_INTERNAL_get_shadowCascade4Splitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521939 | 0, fb + 3536 | 0);
 return;
}

function __Z69Register_UnityEngine_Profiling_Profiler_SetTempAllocatorRequestedSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554015 | 0, fb + 1812 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_TriggerModule_GetMaxColliderCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645007 | 0, fb + 2037 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634764 | 0, fb + 3317 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634826 | 0, fb + 2007 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636540 | 0, fb + 3332 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636602 | 0, fb + 2010 | 0);
 return;
}

function __Z69Register_UnityEngine_Connect_UnityAdsSettings_get_initializeOnStartupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043237 | 0, fb + 293 | 0);
 return;
}

function __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791350 | 0, fb + 3751 | 0);
 return;
}

function __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_highAngularXLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791966 | 0, fb + 3761 | 0);
 return;
}

function __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791288 | 0, fb + 3750 | 0);
 return;
}

function __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_highAngularXLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791904 | 0, fb + 3760 | 0);
 return;
}

function __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetLookAtPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920790 | 0, fb + 4130 | 0);
 return;
}

function __Z69Register_UnityEngine_AnchoredJoint2D_set_autoConfigureConnectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818682 | 0, fb + 3876 | 0);
 return;
}

function __Z69Register_UnityEngine_AnchoredJoint2D_get_autoConfigureConnectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818620 | 0, fb + 2351 | 0);
 return;
}

function __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1046095 | 0, fb + 4433 | 0);
 return;
}

function __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1046034 | 0, fb + 4432 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_worldRotationAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051865 | 0, fb + 4450 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_localRotationAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051987 | 0, fb + 4452 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_worldRotationAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051804 | 0, fb + 4449 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_localRotationAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051926 | 0, fb + 4451 | 0);
 return;
}

function __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateScriptv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028088 | 0, fb + 3921 | 0);
 return;
}

function __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028027 | 0, fb + 3920 | 0);
 return;
}

function __Z68Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_GetWindowsBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021684 | 0, fb + 3896 | 0);
 return;
}

function __Z68Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_EnableRectClippingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013550 | 0, fb + 4244 | 0);
 return;
}

function __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039480 | 0, fb + 1124 | 0);
 return;
}

function __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038999 | 0, fb + 3930 | 0);
 return;
}

function __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize2R8Vector3fS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z14OrthoNormalizeP8Vector3fS0_(i1, i2);
 return;
}

function __Z48setPxSimulationStatisticsNbActiveKinematicBodiesPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z45QualitySettings_Set_Custom_PropShadowCascadesi(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings17SetShadowCascadesEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z44Canvas_CUSTOM_GetETC1SupportedCanvasMaterialv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN2UI30GetETC1SupportedCanvasMaterialEv() | 0) | 0;
}

function __Z43QualitySettings_Set_Custom_PropCurrentLeveli(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings15SetCurrentIndexEib(__Z18GetQualitySettingsv() | 0, i1, 1);
 return;
}

function __Z41setPxVehicleSuspensionDataMSpringStrengthPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z40getPxScene_ContactReportStreamBufferSizePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 420 >> 2] | 0, i1 | 0) | 0;
}

function __Z34getPxVehicleDrive_ConcreteTypeNamePKN5physx14PxVehicleDriveE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z34getPxRigidDynamic_ConcreteTypeNamePKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z34getPxArticulation_ConcreteTypeNamePKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z34getNbPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function __Z32setPxSceneDescBroadPhaseCallbackPN5physx11PxSceneDescEPNS_20PxBroadPhaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 44 >> 2] = i1;
 return;
}

function __Z32Mesh_CUSTOM_ExtractArrayFromListP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 return i1 | 0;
}

function __Z30getPxCloth_SleepLinearVelocityPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 456 >> 2] | 0, i1 | 0));
}

function __Z30getPxCloth_FrictionCoefficientPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 376 >> 2] | 0, i1 | 0));
}

function __Z29setPxSceneDescStaticStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 116 >> 2] = i1;
 return;
}

function __Z21GetNbBroadPhaseRemovePKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[i2 + 76 + (i1 << 2) >> 2] | 0;
}

function __GLOBAL__sub_I_UnityWebStream_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1548980 | 0, fb + 3706 | 0, fb + 3707 | 0, 0, 0);
 return;
}

function _UNITY_FT_Stream_Close(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (!i1) return;
 i2 = HEAP32[i1 + 24 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function mftCall_i(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) >= (fb | 0) & (i1 | 0) < (fb + 511 | 0)) return FUNCTION_TABLE_i[i1 - fb & 511]() | 0;
 return ftCall_i(i1 | 0) | 0;
}

function _unity_z_deflateInit_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _unity_z_deflateInit2_(i1, i2, 8, 15, 8, 0, i3, i4) | 0;
}

function _getopt_long_only(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return ___getopt_long(i1, i2, i3, i4, i5, 1) | 0;
}

function _emscripten_glVertexAttrib2f__wrapper(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 _emscripten_glVertexAttrib2f(i1 | 0, +f2, +f3);
}

function _emscripten_glScissor__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _emscripten_glScissor(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetBufferParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetBufferParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function ___fpending(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) i1 = 0; else i1 = (HEAP32[i1 + 20 >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) | 0;
 return i1 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -12 + 80 >> 2] | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj(i1) {
 i1 = i1 | 0;
 return (i1 >>> 0 < 11 ? 10 : (i1 + 16 & -16) + -1 | 0) | 0;
}

function __ZNKSt3__223__system_error_category7messageEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNKSt3__212__do_message7messageEi(i1, 0, i3);
 return;
}

function __ZNK8WWWAudio14GetPartialSizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx3Ext7D6Joint9getMotionENS_8PxD6Axis4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i2 + 80 >> 2] | 0) + 72 + (i1 << 2) >> 2] | 0;
}

function __ZNK5physx2Sq17AABBTreeUpdateMap8checkMapEjRKNS0_8AABBTreeE(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 return (HEAP32[i2 + 4 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx16PxVehicleNoDrive13getSteerAngleEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i2 + 128 >> 2] | 0) + (i1 << 2) >> 2]);
}

function __ZN9GfxDevice24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN8WWWAudio17UnlockPartialDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0);
 return;
}

function __ZN6Object12SetHideFlagsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -1040385 | i2 << 13 & 1040384;
 return;
}

function __ZN5physx3Scb5Scene11shiftOriginERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene11shiftOriginERKNS_6PxVec3E(i2 + 16 | 0, i1);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx2Sc9ShapeCore8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 64 >> 0] = HEAP8[i1 >> 0] | 0;
 return;
}

function __ZN5physx19getYTorqueCurvePairEPKNS_19PxVehicleEngineDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i1 + ((i2 << 1 | 1) << 2) >> 2]);
}

function __ZN4FMOD8ChannelI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN24RingBufferMemoryFileData12SetBlockSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (HEAP32[i1 + 16 >> 2] | 0) return;
 HEAP32[i1 + 20 >> 2] = i2;
 return;
}

function __ZN23ControllerContactFilterC2EPKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = gb + 111320 + 8;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN22BlockMemoryCacheWriter16UnlockCacheBlockEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN21AnimationClipPlayableD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 return;
}

function __ZN20TextRenderingPrivate7GUIText7SetFontE4PPtrIN13TextRendering4FontEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 88 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN14MessageHandler24MessageIDToParameterTypeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + (i2 * 20 | 0) + 12 >> 2] | 0;
}

function __ZN13ResourceImageD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63528 | 0);
 return;
}

function __ZN13PhysicsModule31GetColliderSharedMeshInstanceIDER12MeshCollider(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK12MeshCollider13GetSharedMeshEv(i2) | 0;
}

function __ZN13GfxDeviceNull32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 1;
}

function __ZN12_GLOBAL__N_121SocketNetworkInStream10disconnectEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd6Socket10disconnectEv((HEAP32[i1 + 8 >> 2] | 0) + 4 | 0);
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner6unlockEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 60 >> 0] = 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 + 40 >> 2] | 0);
 return;
}

function __ZN11NamedObjectD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 32336 + 8;
 __ZN14ConstantStringD2Ev(i1 + 28 | 0);
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10GUIManager28SetDidGUIWindowsEatLastEventEbi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[gb + 1468156 >> 2] | 0) + 9 + i2 >> 0] = i1 & 1;
 return;
}

function __Z71Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812343 | 0, fb + 4 | 0);
 return;
}

function __Z70Register_UnityEngine_TextGenerator_INTERNAL_CALL_Populate_Internal_cppv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010773 | 0, fb + 1 | 0);
 return;
}

function __Z69Register_UnityEngine_TerrainData_Internal_GetMinimumBaseMapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938147 | 0, fb + 263 | 0);
 return;
}

function __Z69Register_UnityEngine_TerrainData_Internal_GetMaximumBaseMapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938209 | 0, fb + 264 | 0);
 return;
}

function __Z69Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetRelativePointVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785877 | 0, fb + 858 | 0);
 return;
}

function __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Multiplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559286 | 0, fb + 631 | 0);
 return;
}

function __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_ColDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559224 | 0, fb + 173 | 0);
 return;
}

function __Z69Register_UnityEngine_Rendering_CommandBuffer_IssuePluginEventInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560426 | 0, fb + 644 | 0);
 return;
}

function __Z69Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToAxisAngleRadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545228 | 0, fb + 625 | 0);
 return;
}

function __Z69Register_UnityEngine_QualitySettings_get_billboardsFaceCameraPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522871 | 0, fb + 135 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649796 | 0, fb + 284 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649858 | 0, fb + 341 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystemRenderer_Internal_SetVertexStreamsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655353 | 0, fb + 768 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_SetTriggerParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655939 | 0, fb + 154 | 0);
 return;
}

function __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_GetTriggerParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655877 | 0, fb + 394 | 0);
 return;
}

function __Z69Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506384 | 0, fb + 558 | 0);
 return;
}

function __Z69Register_UnityEngine_AvatarBuilder_INTERNAL_CALL_BuildHumanAvatarMonov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930020 | 0, fb + 992 | 0);
 return;
}

function __Z69Register_UnityEngine_AssetBundle_LoadAssetWithSubAssetsAsync_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496788 | 0, fb + 359 | 0);
 return;
}

function __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetIKHintPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920622 | 0, fb + 933 | 0);
 return;
}

function __Z69Register_UnityEngine_Animator_INTERNAL_CALL_GetIKHintPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920560 | 0, fb + 932 | 0);
 return;
}

function __Z68Register_UnityEngine_RenderTexture_INTERNAL_CALL_MarkRestoreExpectedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576002 | 0, fb + 3653 | 0);
 return;
}

function __Z68Register_UnityEngine_RenderSettings_INTERNAL_set_ambientEquatorColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519313 | 0, fb + 3515 | 0);
 return;
}

function __Z68Register_UnityEngine_RenderSettings_INTERNAL_get_ambientEquatorColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519252 | 0, fb + 3514 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650754 | 0, fb + 3427 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650815 | 0, fb + 3428 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshMaterialIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629188 | 0, fb + 3275 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_SetBoxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628490 | 0, fb + 3268 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_GetBoxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628551 | 0, fb + 3269 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshMaterialIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629249 | 0, fb + 1993 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637856 | 0, fb + 3343 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637917 | 0, fb + 2013 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetUseParticleColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648552 | 0, fb + 3411 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetSizeAffectsRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648674 | 0, fb + 3412 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetUseParticleColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648613 | 0, fb + 2051 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetSizeAffectsRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648735 | 0, fb + 2052 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632520 | 0, fb + 3296 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634274 | 0, fb + 3310 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634335 | 0, fb + 3311 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxPlaneCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644206 | 0, fb + 2031 | 0);
 return;
}

function __Z68Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetProgressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029561 | 0, fb + 799 | 0);
 return;
}

function __Z68Register_UnityEngine_Networking_UnityWebRequest_get_downloadProgressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032904 | 0, fb + 801 | 0);
 return;
}

function __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_originCustomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543259 | 0, fb + 2978 | 0);
 return;
}

function __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_originCustomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543198 | 0, fb + 2977 | 0);
 return;
}

function __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_boundsGlobalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543019 | 0, fb + 2974 | 0);
 return;
}

function __Z68Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawPrefixLabelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023803 | 0, fb + 163 | 0);
 return;
}

function __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_set_lowAngularXLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791843 | 0, fb + 3759 | 0);
 return;
}

function __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_get_lowAngularXLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791782 | 0, fb + 3758 | 0);
 return;
}

function __Z68Register_UnityEngine_Camera_INTERNAL_set_nonJitteredProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505054 | 0, fb + 2796 | 0);
 return;
}

function __Z68Register_UnityEngine_Camera_INTERNAL_get_nonJitteredProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504993 | 0, fb + 2795 | 0);
 return;
}

function __Z68Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipInstancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513595 | 0, fb + 3497 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_set_useHttpContinuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032458 | 0, fb + 4309 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_set_downloadHandlerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033745 | 0, fb + 4314 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_set_chunkedTransferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033259 | 0, fb + 4312 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_get_useHttpContinuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032398 | 0, fb + 2750 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadedBytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033023 | 0, fb + 2757 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadHandlerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033685 | 0, fb + 2762 | 0);
 return;
}

function __Z67Register_UnityEngine_Networking_UnityWebRequest_get_chunkedTransferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033199 | 0, fb + 2759 | 0);
 return;
}

function __Z67Register_UnityEngine_Connect_UnityConnectSettings_set_testConfigUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043955 | 0, fb + 3950 | 0);
 return;
}

function __Z67Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038939 | 0, fb + 3929 | 0);
 return;
}

function __Z46setPxSimulationStatisticsCompressedContactSizePN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 52 >> 2] = i1;
 return;
}

function __Z45GUIStyle_CUSTOM_Internal_GetCursorFlashOffsetv() {
 return Math_fround(__ZN10GUIManager18GetCursorFlashTimeEi(__Z30GetGUIStateCurrentDisplayIndexv() | 0));
}

function __Z40setPxVehicleWheelDataMMaxHandBrakeTorquePN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z39setPxClothStretchConfigCompressionLimitPN5physx20PxClothStretchConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z37Resources_CUSTOM_FindObjectsOfTypeAllP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE(i1, 2) | 0;
}

function __Z37Physics_Set_Custom_PropSleepThresholdf(f1) {
 f1 = Math_fround(f1);
 __ZN14PhysicsManager17SetSleepThresholdEf(__Z17GetPhysicsManagerv() | 0, f1);
 return;
}

function __Z36getPxMaterial_RestitutionCombineModePKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
}

function __Z35setPxVehicleSuspensionDataMMaxDroopPN5physx23PxVehicleSuspensionDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z34getPxVehicleDriveSimData_GearsDataPKN5physx21PxVehicleDriveSimDataE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(i1 | 0, i2 + 112 | 0, 144) | 0;
 return;
}

function __Z34AudioListener_Set_Custom_PropPauseh(i1) {
 i1 = i1 | 0;
 __ZN12AudioManager16SetListenerPauseEb(__Z15GetAudioManagerv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z31Profiler_CUSTOM_GetSamplerNamesv() {
 return __ZNK9profiling14SamplerManager16GetSamplersNamesEv(HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 76 >> 2] | 0) | 0;
}

function __Z29setPxSceneDescSimulationOrderPN5physx11PxSceneDescENS_17PxSimulationOrder4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 152 >> 2] = i1;
 return;
}

function __Z29getPxCloth_StiffnessFrequencyPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0));
}

function __Z29getPxCloth_CollisionMassScalePKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 384 >> 2] | 0, i1 | 0));
}

function __Z27GetNumScenesInBuildSettingsv() {
 var i1 = 0;
 i1 = __Z16GetBuildSettingsv() | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) >> 4 | 0;
}

function __Z19ClearConsoleLogPathv() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1450760 >> 2] | 0, gb + 63176 | 0);
 HEAP32[gb + 1450760 >> 2] = 0;
 return;
}

function __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6vectorIS5_NS3_IS5_EEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _fgetpos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ___ftello(i1) | 0;
 if ((i1 | 0) < 0) i1 = -1; else {
  HEAP32[i2 >> 2] = i1;
  i1 = 0;
 }
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208936 + 12;
 HEAP32[i1 + 4 >> 2] = gb + 208936 + 32;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208888 + 12;
 HEAP32[i1 + 4 >> 2] = gb + 208888 + 32;
 return;
}

function __ZNK8WWWAudio14GetPartialDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK32RendererMaterialAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9TextAsset8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN9ShaderLab13InitShaderLabEv() {
 if (HEAP8[gb + 1546616 >> 0] | 0) return;
 HEAP8[gb + 1546616 >> 0] = 1;
 HEAP32[gb + 1166412 >> 2] = 2147483647;
 return;
}

function __ZN9AudioClip8WWWCloseEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 37; else if (!i2) i1 = 0; else {
  __ZdlPv(i2);
  i1 = 0;
 }
 return i1 | 0;
}

function __ZN8Renderer18SetStaticBatchInfoEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP16[i1 + 216 >> 1] = i2;
 HEAP16[i1 + 218 >> 1] = i3;
 return;
}

function __ZN5physx7NpScene22removeBroadPhaseRegionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN5physx3Scb5Scene22removeBroadPhaseRegionEj(i2 + 16 | 0, i1) | 0;
}

function __ZN5physx6shdfnd9atomicAddEPVii(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 var i3 = 0;
 i3 = HEAP32[i2 >> 2] | 0;
 HEAP32[i2 >> 2] = i3 + i1;
 return i3 + i1 | 0;
}

function __ZN5physx6shdfnd8SyncImpl5resetEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(i1 | 0) | 0;
 HEAP8[i1 + 80 >> 0] = 0;
 _pthread_mutex_unlock(i1 | 0) | 0;
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcher7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn21SerializationRegistry7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sc5Scene6setPCMEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[(HEAP32[(HEAP32[i2 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 7604 >> 0] = i1 & 1;
 return;
}

function __ZN5Unity17ConfigurableJoint30ApplyRebuildConfigurationSpaceEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Umbra10PortalInfoaSERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(((i1 | 0) == 0 ? 0 : i1 + 3 & -4) | 0, i2 + 3 & -4 | 0, 145) | 0;
 return i1 | 0;
}

function __ZN4File13SetFileLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return __ZN12FileAccessor9SetLengthEy(HEAP32[i1 + 4 >> 2] | 0, i2, i3) | 0;
}

function __ZN15ReflectionProbeD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15NavMeshObstacleD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15LightProbeGroupD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15AudioReverbZoneD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14UnityAnalyticsD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188416 + 8;
 __ZN14UnityAnalytics25UnregisterGlobalCallbacksEv(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14TerrainManager12GetWorldAABBEPN5Unity9ComponentE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK7Terrain12GetWorldAABBEv(i1, i3);
 return;
}

function __ZN13TranslateGLES24InitTextureFormat2FormatERK12GraphicsCaps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(i1 + 1924 | 0, gb + 74236 | 0, 248) | 0;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider4lockEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd9MutexImpl4lockEv(HEAP32[i1 + 24 >> 2] | 0);
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __Z68Register_UnityEngine_TerrainData_Internal_GetMaximumDetailPatchCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 937960 | 0, fb + 260 | 0);
 return;
}

function __Z68Register_UnityEngine_Profiling_Profiler_GetTotalUnusedReservedMemoryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554186 | 0, fb + 197 | 0);
 return;
}

function __Z68Register_UnityEngine_PolygonCollider2D_INTERNAL_CALL_CreatePrimitivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817924 | 0, fb + 304 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetMinVertexDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649920 | 0, fb + 285 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetMinVertexDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649981 | 0, fb + 342 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636418 | 0, fb + 250 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636296 | 0, fb + 249 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636174 | 0, fb + 248 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636479 | 0, fb + 307 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636357 | 0, fb + 306 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636235 | 0, fb + 305 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632581 | 0, fb + 2e3 | 0);
 return;
}

function __Z68Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655816 | 0, fb + 393 | 0);
 return;
}

function __Z68Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSinglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579590 | 0, fb + 374 | 0);
 return;
}

function __Z68Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallStaticObjectMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593982 | 0, fb + 259 | 0);
 return;
}

function __Z68Register_UnityEngineInternal_GIDebugVisualisation_get_pauseCycleModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513426 | 0, fb + 108 | 0);
 return;
}

function __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544551 | 0, fb + 2986 | 0);
 return;
}

function __Z67Register_UnityEngine_Terrain_Internal_GetSplatMaterialPropertyBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944285 | 0, fb + 4199 | 0);
 return;
}

function __Z67Register_UnityEngine_RenderSettings_set_defaultReflectionResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520606 | 0, fb + 3526 | 0);
 return;
}

function __Z67Register_UnityEngine_RenderSettings_INTERNAL_set_ambientGroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519434 | 0, fb + 3517 | 0);
 return;
}

function __Z67Register_UnityEngine_RenderSettings_INTERNAL_get_ambientGroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519374 | 0, fb + 3516 | 0);
 return;
}

function __Z67Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_FromEulerRadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545168 | 0, fb + 2989 | 0);
 return;
}

function __Z67Register_UnityEngine_PhysicMaterial_Internal_CreateDynamicsMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796069 | 0, fb + 3815 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630108 | 0, fb + 3282 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629988 | 0, fb + 3280 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629868 | 0, fb + 3278 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630168 | 0, fb + 3283 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 630048 | 0, fb + 3281 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629928 | 0, fb + 3279 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650380 | 0, fb + 3424 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetDieWithParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650260 | 0, fb + 3423 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650440 | 0, fb + 2059 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetDieWithParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650320 | 0, fb + 2058 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_ShapeModule_SetAlignToDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628072 | 0, fb + 3267 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_ShapeModule_GetAlignToDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628132 | 0, fb + 1987 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637174 | 0, fb + 3340 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637054 | 0, fb + 3338 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636934 | 0, fb + 3336 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637234 | 0, fb + 3341 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637114 | 0, fb + 3339 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636994 | 0, fb + 3337 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638976 | 0, fb + 3353 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639036 | 0, fb + 2015 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642584 | 0, fb + 3381 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetCollidesWithv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643084 | 0, fb + 3383 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642644 | 0, fb + 3382 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetCollidesWithv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643144 | 0, fb + 2025 | 0);
 return;
}

function __Z67Register_UnityEngine_Connect_UnityConnectSettings_get_testConfigUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043895 | 0, fb + 298 | 0);
 return;
}

function __Z67Register_UnityEngine_ComputeBuffer_INTERNAL_CALL_GetNativeBufferPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510051 | 0, fb + 2814 | 0);
 return;
}

function __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyRotationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920068 | 0, fb + 4129 | 0);
 return;
}

function __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919948 | 0, fb + 4127 | 0);
 return;
}

function __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyRotationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920008 | 0, fb + 4128 | 0);
 return;
}

function __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919888 | 0, fb + 4126 | 0);
 return;
}

function __Z67Register_UnityEngine_AnimatorClipInfo_ClipInstanceToScriptingObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918711 | 0, fb + 2548 | 0);
 return;
}

function __Z67Register_UnityEngine_AndroidJNIHelper_INTERNAL_CALL_CreateJavaProxyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591037 | 0, fb + 3169 | 0);
 return;
}

function __Z67Register_UnityEngine_AI_NavMeshAgent_GetNextOffMeshLinkDataInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847584 | 0, fb + 4016 | 0);
 return;
}

function __Z66Register_UnityEngine_GUIText_INTERNAL_CALL_Internal_SetPixelOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008618 | 0, fb + 4211 | 0);
 return;
}

function __Z66Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMousePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019396 | 0, fb + 4269 | 0);
 return;
}

function __Z66Register_UnityEngine_Connect_UnityConnectSettings_set_testEventUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043836 | 0, fb + 3949 | 0);
 return;
}

function __Z66Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserGenderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039172 | 0, fb + 1121 | 0);
 return;
}

function __Z61getPxVehicleTireData_RecipLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 44 >> 2]);
}

function __Z59getPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 96 >> 2]);
}

function __Z48getPxVehicleAckermannGeometryDataMAxleSeparationPKN5physx30PxVehicleAckermannGeometryDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z48Input_Set_Custom_PropEatKeyPressOnTextFieldFocush(i1) {
 i1 = i1 | 0;
 HEAP8[(__Z15GetInputManagerv() | 0) + 169 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z46setPxSimulationStatisticsNbActiveDynamicBodiesPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z46LocationService_Get_Custom_PropIsEnabledByUserP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return (__ZN15LocationService22IsServiceEnabledByUserEv() | 0) & 1 | 0;
}

function __Z45setPxSimulationStatisticsPeakConstraintMemoryPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 60 >> 2] = i1;
 return;
}

function __Z40RenderSettings_Set_Custom_PropFogDensityf(f1) {
 f1 = Math_fround(f1);
 __ZN14RenderSettings13SetFogDensityEf(__Z17GetRenderSettingsv() | 0, f1);
 return;
}

function __Z37Matrix4x4_CUSTOM_INTERNAL_CALL_InvertRK10Matrix4x4fPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (__Z20InvertMatrix4x4_FullPKfPf(i1, i2) | 0) & 1 | 0;
}

function __Z36setPxVehicleDriveDynDataMEnginespeedPN5physx21PxVehicleDriveDynDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 76 >> 2] = f1;
 return;
}

function __Z36Object_CUSTOM_FindSceneObjectsOfTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE(i1, 1) | 0;
}

function __Z33getPxRigidStatic_ConcreteTypeNamePKN5physx13PxRigidStaticE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z33getPxClothFabric_ConcreteTypeNamePKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z30getPxParticleBase_MaxParticlesPKN5physx14PxParticleBaseE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0) | 0;
}

function __Z29GL_CUSTOM_RenderTargetBarrierv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0);
 return;
}

function __Z28getPxScene_MeshContactMarginPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 280 >> 2] | 0, i1 | 0));
}

function __Z25getPxMaterial_RestitutionPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0));
}

function __Z21CleanupVehiclesModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z12GetIVehiclesv() | 0, gb + 63400 | 0);
 __Z12SetIVehiclesP9IVehicles(0);
 return;
}

function __GLOBAL__sub_I_runtime_utilities_lump_cpp() {
 HEAP32[gb + 1170780 >> 2] = 0;
 HEAP32[gb + 1170780 + 4 >> 2] = 0;
 HEAP32[gb + 1170780 + 8 >> 2] = 0;
 return;
}

function _UNITY_FT_Stroker_Export(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _UNITY_FT_Stroker_ExportBorder(i1, 0, i2);
 _UNITY_FT_Stroker_ExportBorder(i1, 1, i2);
 return;
}

function _wcstoumax(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, -1, -1) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _strtoumax(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, -1, -1) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _glStencilOpSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glStencilOpSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glGetProgramInfoLog__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetProgramInfoLog(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glBlendFuncSeparate__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glBlendFuncSeparate(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZZN14PhysicsManager15InitializeClassEvEN15didDestroyWorld7ForwardEv() {
 __ZN14PhysicsManager13RecreateSceneEv(__Z21GetManagerFromContexti(9) | 0);
 return;
}

function __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD1Ev(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev(i1 + -4 | 0);
 return;
}

function __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__set_short_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 11 >> 0] = i2;
 return;
}

function __ZNK8Animator28WarningStringIfLoggingActiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK7dtCrowd11GetObstacleERK13dtCrowdHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 416 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 92 | 0) | 0;
}

function __ZNK5physx9NpPhysics19getNbTriangleMeshesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx13GuMeshFactory19getNbTriangleMeshesEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZNK5physx7NpScene21getBroadPhaseCallbackEh(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene21getBroadPhaseCallbackEh(i2 + 32 | 0, i1) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx16PxBroadPhaseBase10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj(i3, i4, i1, i2) {
 i3 = i3 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK5Umbra20ObjectDistanceParams26getMinRelativeContributionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 20 >> 2]);
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -8 >> 2] | 0) >>> 1 | 0;
}

function __ZNK14MemoryProfiler32GetRegisteredAllocationsOverviewERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK14DLHAudioHelper6IsDoneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK10FileSystem9LastErrorEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 192 >> 2] | 0, i1 | 0) | 0;
}

function __ZN9Rigidbody10IsSleepingEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0;
}

function __ZN8WWWAudio15LockPartialDataEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN8VRDevice33SetCustomSplashUpdateLoopCallbackEPFvRK11QuaternionfRK8Vector3fS5_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 368 >> 2] = i2;
 return;
}

function __ZN8Animator5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP8[i1 + 417 >> 0] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 HEAP8[i1 + 561 >> 0] = 1;
 return;
}

function __ZN7mecanim6memory16MecanimAllocator10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, i1 + 4 | 0);
 return;
}

function __ZN7ApiGLES11VertexArrayC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP8[i1 + 12 >> 0] = 0;
 return;
}

function __ZN6Camera26ClearIntermediateRenderersEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN21IntermediateRenderers5ClearEj(HEAP32[i1 + 1132 >> 2] | 0, i2);
 return;
}

function __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 7748 >> 2] = i1 + -3;
 HEAP32[i2 + 7756 >> 2] = 0;
 return;
}

function __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i3 + 928 + i1 >> 0] = i2;
 return;
}

function __ZN5physx13printCCDDebugEPKcPKNS_12PxsRigidBodyENS_14PxGeometryType4EnumEb(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5Umbra9Matrix2x25clearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN4FMOD13ChannelGroupI19getAudibilityFactorEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 40 >> 2];
 return 0;
}

function __ZN2UI11CanvasGroupD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN17WeakPtrSharedDataD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 70308 + 8;
 HEAP32[gb + 1178928 >> 2] = (HEAP32[gb + 1178928 >> 2] | 0) + -1;
 return;
}

function __ZN17PersistentManager20ClearActiveNameSpaceENS_19ActiveNameSpaceTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 84 + (i2 << 2) >> 2] = -1;
 return;
}

function __ZN14DirectorPlayerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14AudioBehaviourD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11UnityEngine15PlatformWrapper20IsRootedOrJailbrokenEv() {
 return (__ZN15ApplicationInfo14GetSandboxTypeEv(__Z18GetApplicationInfov() | 0) | 0) == 3 | 0;
}

function __ZN11UnityEngine15CloudWebService14DataDispatcherD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11ClothModule16InitClothManagerEv(i1) {
 i1 = i1 | 0;
 _PxRegisterCloth(__Z14GetDynamicsSDKv() | 0);
 HEAP32[gb + 1115296 + 280 >> 2] = fb + 254;
 return;
}

function __ZN11AudioModule16SetListenerPauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12AudioManager16SetListenerPauseEb(__Z15GetAudioManagerv() | 0, i2);
 return;
}

function __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __Z69Register_UnityEngine_Joint2D_Joint2D_CUSTOM_INTERNAL_GetReactionForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818291 | 0, fb + 8 | 0);
 return;
}

function __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544611 | 0, fb + 622 | 0);
 return;
}

function __Z67Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578570 | 0, fb + 688 | 0);
 return;
}

function __Z67Register_UnityEngine_Rendering_GraphicsSettings_GetGraphicsSettingsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558244 | 0, fb + 204 | 0);
 return;
}

function __Z67Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Singlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559164 | 0, fb + 131 | 0);
 return;
}

function __Z67Register_UnityEngine_RenderSettings_get_defaultReflectionResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520546 | 0, fb + 117 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_SubEmittersModule_AddSubEmitterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645587 | 0, fb + 290 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641674 | 0, fb + 267 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641554 | 0, fb + 266 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641434 | 0, fb + 265 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640450 | 0, fb + 262 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641734 | 0, fb + 324 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641614 | 0, fb + 323 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641494 | 0, fb + 322 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640510 | 0, fb + 319 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_LightsModule_SetRangeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649028 | 0, fb + 281 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_LightsModule_GetRangeMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649088 | 0, fb + 338 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMinKillSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642844 | 0, fb + 271 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxKillSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642964 | 0, fb + 272 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMinKillSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642904 | 0, fb + 328 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxKillSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643024 | 0, fb + 329 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystemRenderer_set_cameraVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654195 | 0, fb + 298 | 0);
 return;
}

function __Z67Register_UnityEngine_ParticleSystemRenderer_get_cameraVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654135 | 0, fb + 355 | 0);
 return;
}

function __Z67Register_UnityEngine_LightProbes_INTERNAL_CALL_GetInterpolatedProbev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533428 | 0, fb + 617 | 0);
 return;
}

function __Z67Register_UnityEngine_Experimental_Director_Playables_CastToInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552005 | 0, fb + 367 | 0);
 return;
}

function __Z67Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506324 | 0, fb + 557 | 0);
 return;
}

function __Z67Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506264 | 0, fb + 556 | 0);
 return;
}

function __Z67Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597020 | 0, fb + 716 | 0);
 return;
}

function __Z67Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_CalculatePathInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850131 | 0, fb + 164 | 0);
 return;
}

function __Z67Register_UnityEngine_AI_NavMeshObstacle_set_carvingTimeToStationaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851561 | 0, fb + 597 | 0);
 return;
}

function __Z67Register_UnityEngine_AI_NavMeshObstacle_get_carvingTimeToStationaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851501 | 0, fb + 687 | 0);
 return;
}

function __Z66Register_UnityEngine_SceneManagement_Scene_GetLoadingStateInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561234 | 0, fb + 1840 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632758 | 0, fb + 3298 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632817 | 0, fb + 3299 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626964 | 0, fb + 3261 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627023 | 0, fb + 3262 | 0);
 return;
}

function __Z66Register_UnityEngine_Networking_UnityWebRequest_get_uploadProgressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032685 | 0, fb + 800 | 0);
 return;
}

function __Z66Register_UnityEngine_MonoBehaviour_StopCoroutineViaEnumerator_Autov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549608 | 0, fb + 3009 | 0);
 return;
}

function __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_sizeCustomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543139 | 0, fb + 2976 | 0);
 return;
}

function __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_sizeCustomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543080 | 0, fb + 2975 | 0);
 return;
}

function __Z66Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRate_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536798 | 0, fb + 2942 | 0);
 return;
}

function __Z66Register_UnityEngine_Experimental_Director_Playable_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550610 | 0, fb + 1803 | 0);
 return;
}

function __Z66Register_UnityEngine_Connect_UnityConnectSettings_get_testEventUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043777 | 0, fb + 297 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792437 | 0, fb + 3769 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792861 | 0, fb + 3777 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792319 | 0, fb + 3767 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793333 | 0, fb + 3784 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792378 | 0, fb + 3768 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792802 | 0, fb + 3776 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792260 | 0, fb + 3766 | 0);
 return;
}

function __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793274 | 0, fb + 3783 | 0);
 return;
}

function __Z66Register_UnityEngine_CharacterController_set_enableOverlapRecoveryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797787 | 0, fb + 3822 | 0);
 return;
}

function __Z66Register_UnityEngine_CharacterController_get_enableOverlapRecoveryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797728 | 0, fb + 2321 | 0);
 return;
}

function __Z66Register_UnityEngine_Camera_INTERNAL_CALL_ResetWorldToCameraMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504834 | 0, fb + 3473 | 0);
 return;
}

function __Z66Register_UnityEngine_Application_RequestAdvertisingIdentifierAsyncv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494722 | 0, fb + 1585 | 0);
 return;
}

function __Z66Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipSystemsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513656 | 0, fb + 3498 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleEmitter_INTERNAL_CALL_ClearParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051454 | 0, fb + 3963 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_set_uploadHandlerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033627 | 0, fb + 4313 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_set_redirectLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033141 | 0, fb + 4311 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadedBytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032965 | 0, fb + 2756 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadHandlerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033569 | 0, fb + 2761 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_get_redirectLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033083 | 0, fb + 2758 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalSetMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032047 | 0, fb + 4307 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalGetMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032169 | 0, fb + 2746 | 0);
 return;
}

function __Z65Register_UnityEngine_Networking_UnityWebRequest_GetResponseHeaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033441 | 0, fb + 1115 | 0);
 return;
}

function __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectField13Il2Cpp_IntPtrS_RPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __Z39setPxHeightFieldDescConvexEdgeThresholdPN5physx17PxHeightFieldDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z38AndroidJNI_CUSTOM_CallStaticLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 setTempRet0(0);
 return 0;
}

function __Z37getPxScene_MaxNbContactDataBlocksUsedPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 416 >> 2] | 0, i1 | 0) | 0;
}

function __Z37getPxScene_DynamicTreeRebuildRateHintPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 340 >> 2] | 0, i1 | 0) | 0;
}

function __Z37RenderSettings_Set_Custom_PropFogMode7FogMode(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings10SetFogModeE7FogMode(__Z17GetRenderSettingsv() | 0, i1);
 return;
}

function __Z35setPxHeightFieldGeometryColumnScalePN5physx21PxHeightFieldGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 16 >> 2] = f1;
 return;
}

function __Z35scripting_class_get_field_from_nameP11Il2CppClassPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_class_get_field_from_name(i1 | 0, i2 | 0) | 0;
}

function __Z33GUIUtility_CUSTOM_HasMouseControli(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(__Z11GetGUIStatev() | 0) + 276 >> 2] | 0) + 4 >> 2] | 0) == (i1 | 0) | 0;
}

function __Z32getPxRigidBody_RigidDynamicFlagsPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0) | 0;
}

function __Z31getPxClothFabric_ReferenceCountPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
}

function __Z28GUIStyleState_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __Z27getPxJoint_InvInertiaScale1PKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0));
}

function __Z27getPxCloth_PreviousTimeStepPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
}

function __Z26profiler_unregister_objectP6Object(i1) {
 i1 = i1 | 0;
 __ZN19MemoryProfilerStats16UnregisterObjectEP6Object(HEAP32[gb + 1163248 >> 2] | 0, i1);
 return;
}

function __Z22getPxRigidBody_InvMassPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
}

function __Z20PlayerRenderUnityGUIi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1115296 + 416 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function __Z18GetNbBroadPhaseAddPKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[i2 + 64 + (i1 << 2) >> 2] | 0;
}

function __Z10GetNbShapePKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[i2 + 20 + (i1 << 2) >> 2] | 0;
}

function __GLOBAL__sub_I_VRGfxHelpers_cpp() {
 HEAP32[gb + 1469332 >> 2] = -1;
 __ZN9ShaderLab16FastPropertyName4InitEPKc(gb + 1469332 | 0, gb + 1046318 | 0);
 return;
}

function __GLOBAL__sub_I_PlayerPaths_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1548964 | 0, fb + 3667 | 0, fb + 3668 | 0, 0, 0);
 return;
}

function b143(i1, f2, i3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 nullFunc_iififf(143);
 return 0;
}

function _wcstoull(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, -1, -1) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _strtoull(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, -1, -1) | 0;
 setTempRet0(getTempRet0() | 0);
 return i3 | 0;
}

function _cff_free_glyph_data(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _cff_index_forget_element((HEAP32[i1 + 656 >> 2] | 0) + 1176 | 0, i2);
 return;
}

function _cf2_builder_moveTo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[i1 + 28 >> 2] | 0;
 _cff_builder_close_contour(i2);
 HEAP8[i2 + 64 >> 0] = 0;
 return;
}

function ___cxa_is_pointer_type(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (___dynamic_cast(i1, gb + 13008 | 0, gb + 13304 | 0, 0) | 0) != 0;
 return i1 & 1 | 0;
}

function ___cxa_bad_typeid() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt10bad_typeidC2Ev(i1);
 ___cxa_throw(i1 | 0, gb + 13272 | 0, fb + 3234 | 0);
}

function __ZZN14ParticleSystem15InitializeClassEvEN47PreLateUpdateParticleSystemBeginUpdateAllstruct7ForwardEv() {
 __ZN14ParticleSystem14BeginUpdateAllEv();
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN33PostLateUpdateInputEndFramestruct7ForwardEv() {
 __ZN12InputManager13InputEndFrameEv(__Z15GetInputManagerv() | 0);
 return;
}

function __ZThn116_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + -116 + 276 >> 0] | 0) != 0 | 0;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -116 + 256 >> 2] | 0;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE9set_rdbufEPNS_15basic_streambufIwS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE9set_rdbufEPNS_15basic_streambufIcS2_EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7pubsyncEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7pubsyncEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __ZNSt3__213shared_futureIvED2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__set_long_pointerEPw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__set_long_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__set_long_pointerEPc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__set_long_sizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 540 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 532 >> 2] | 0) >>> 0 | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -8 >> 2] | 0) >>> 1 | 0;
}

function __ZNK14SpriteRenderer28GetSpriteRenderDataInContextEPK6Sprite(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK6Sprite24GetRenderDataForPlayModeEv(i2) | 0;
}

function __ZN9GfxDevice19CreateComputeBufferE15ComputeBufferIDjjj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __ZN7dtCrowd11GetObstacleERK13dtCrowdHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 416 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 92 | 0) | 0;
}

function __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv(i1) {
 i1 = i1 | 0;
 return (__ZN5physx6shdfnd21atomicCompareExchangeEPViii(i1 + 8 | 0, 0, 0) | 0) != 0 | 0;
}

function __ZN5physx2Sc5Scene18releaseConstraintsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc16InteractionScene18releaseConstraintsEb(HEAP32[i1 + 1204 >> 2] | 0, 1);
 return;
}

function __ZN5physx2Cm12RefCountable14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx14NpRigidDynamic14setWakeCounterEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __ZN5physx3Scb4Body14setWakeCounterEf(i1 + 48 | 0, f2);
 return;
}

function __ZN5Umbra10Visibility24setOutputObjectDistancesEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 20 >> 2] = i2;
 return;
}

function __ZN5Umbra10Visibility16setOutputObjectsEPNS_9IndexListE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) >> 2] = i2;
 return;
}

function __ZN4Mesh23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN4Mesh8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN4File13GetFileLengthEv(i1) {
 i1 = i1 | 0;
 i1 = __ZNK15FileSystemEntry4SizeEv(HEAP32[i1 >> 2] | 0) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __ZN27UnloadUnusedAssetsOperation7PerformEv(i1) {
 i1 = i1 | 0;
 __ZN17PersistentManager21UnloadNonDirtyStreamsEv(__Z20GetPersistentManagerv() | 0);
 return;
}

function __ZN13TrailRenderer16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer16TransformChangedEi(i1, i2);
 HEAP8[i1 + 340 >> 0] = 1;
 return;
}

function __ZN13ConstantForceD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13AudioListenerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12NavMeshAgent14OnNavMeshAddedEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) != -1) return;
 __ZN12NavMeshAgent16AddToCrowdSystemEv(i1);
 return;
}

function __ZN12MeshRenderer10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Renderer10DeactivateE19DeactivateOperation(i1, i2);
 return;
}

function __ZN11UnityEngine15CloudWebService18RestFileDownloader22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 2160 >> 2] = i2;
 return;
}

function __ZN11MatrixStack18SetCurrentIdentityEv(i1) {
 i1 = i1 | 0;
 __ZN10Matrix4x4f11SetIdentityEv(i1 + ((HEAP32[i1 + 1024 >> 2] | 0) + -1 << 6) | 0) | 0;
 return;
}

function __ZN10TagManager23GetSortingLayerUniqueIDEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 1068 >> 2] | 0) + (i2 * 40 | 0) + 32 >> 2] | 0;
}

function __ZL21CleanupModule_Physicsv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z11GetIPhysicsv() | 0, gb + 63400 | 0);
 __Z11SetIPhysicsP8IPhysics(0);
 return;
}

function __Z68Register_UnityEngine_TerrainData_INTERNAL_CALL_GetInterpolatedNormalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939135 | 0, fb + 2 | 0);
 return;
}

function __Z66Register_UnityEngine_VR_VRSettings_set_renderViewportScaleInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045587 | 0, fb + 44 | 0);
 return;
}

function __Z66Register_UnityEngine_VR_VRSettings_get_renderViewportScaleInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045528 | 0, fb + 56 | 0);
 return;
}

function __Z66Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578682 | 0, fb + 690 | 0);
 return;
}

function __Z66Register_UnityEngine_StaticBatchingUtility_InternalCombineVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536460 | 0, fb + 645 | 0);
 return;
}

function __Z66Register_UnityEngine_Rendering_CommandBuffer_SetGlobalTexture_Implv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560250 | 0, fb + 641 | 0);
 return;
}

function __Z66Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558883 | 0, fb + 130 | 0);
 return;
}

function __Z66Register_UnityEngine_ReflectionProbe_get_minBakedCubemapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557906 | 0, fb + 202 | 0);
 return;
}

function __Z66Register_UnityEngine_ReflectionProbe_get_maxBakedCubemapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557965 | 0, fb + 203 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_SetCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645359 | 0, fb + 757 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_GetCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645418 | 0, fb + 815 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_CollisionModule_SetRadiusScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643844 | 0, fb + 274 | 0);
 return;
}

function __Z66Register_UnityEngine_ParticleSystem_CollisionModule_GetRadiusScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643903 | 0, fb + 331 | 0);
 return;
}

function __Z66Register_UnityEngine_Object_GetOffsetOfInstanceIDInCPlusPlusObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579722 | 0, fb + 220 | 0);
 return;
}

function __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530749 | 0, fb + 597 | 0);
 return;
}

function __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530866 | 0, fb + 599 | 0);
 return;
}

function __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531060 | 0, fb + 602 | 0);
 return;
}

function __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531119 | 0, fb + 603 | 0);
 return;
}

function __Z66Register_UnityEngine_Graphics_Internal_GetMaxDrawMeshInstanceCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532422 | 0, fb + 144 | 0);
 return;
}

function __Z66Register_UnityEngine_GeometryUtility_INTERNAL_CALL_CalculateBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534227 | 0, fb + 618 | 0);
 return;
}

function __Z66Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_GetClosestPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545857 | 0, fb + 626 | 0);
 return;
}

function __Z66Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticObjectFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594499 | 0, fb + 707 | 0);
 return;
}

function __Z65Register_UnityEngine_TerrainData_set_Internal_heightmapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938561 | 0, fb + 4159 | 0);
 return;
}

function __Z65Register_UnityEngine_TerrainData_get_Internal_heightmapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938503 | 0, fb + 2591 | 0);
 return;
}

function __Z65Register_UnityEngine_StaticBatchingUtility_InternalCombineIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536519 | 0, fb + 2941 | 0);
 return;
}

function __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetPaddingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569961 | 0, fb + 3108 | 0);
 return;
}

function __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetOuterUVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569903 | 0, fb + 3107 | 0);
 return;
}

function __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetInnerUVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569845 | 0, fb + 3106 | 0);
 return;
}

function __Z65Register_UnityEngine_SpriteRenderer_INTERNAL_CALL_GetSpriteBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569787 | 0, fb + 3105 | 0);
 return;
}

function __Z65Register_UnityEngine_SkinnedMeshRenderer_set_skinnedMotionVectorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524409 | 0, fb + 2866 | 0);
 return;
}

function __Z65Register_UnityEngine_SkinnedMeshRenderer_get_skinnedMotionVectorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524351 | 0, fb + 1686 | 0);
 return;
}

function __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_set_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524525 | 0, fb + 2868 | 0);
 return;
}

function __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_get_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524467 | 0, fb + 2867 | 0);
 return;
}

function __Z65Register_UnityEngine_RuntimeAnimatorController_get_animationClipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930471 | 0, fb + 2588 | 0);
 return;
}

function __Z65Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786203 | 0, fb + 3692 | 0);
 return;
}

function __Z65Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786145 | 0, fb + 3691 | 0);
 return;
}

function __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_set_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556804 | 0, fb + 3042 | 0);
 return;
}

function __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_get_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556746 | 0, fb + 3041 | 0);
 return;
}

function __Z65Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToEulerRadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545110 | 0, fb + 2988 | 0);
 return;
}

function __Z65Register_UnityEngine_QualitySettings_set_realtimeReflectionProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522813 | 0, fb + 3544 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650876 | 0, fb + 3429 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverTrailv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651128 | 0, fb + 3431 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650934 | 0, fb + 3430 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverTrailv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651186 | 0, fb + 3432 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_SetStartRotation3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624757 | 0, fb + 3244 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626113 | 0, fb + 3255 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625861 | 0, fb + 3253 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_GetStartRotation3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624815 | 0, fb + 1977 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626171 | 0, fb + 1978 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625919 | 0, fb + 3254 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632642 | 0, fb + 3297 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 632700 | 0, fb + 2001 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634396 | 0, fb + 3312 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634454 | 0, fb + 2006 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystemRenderer_Internal_GetMeshCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655095 | 0, fb + 2082 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_set_configuredInWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793870 | 0, fb + 3788 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_get_configuredInWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793812 | 0, fb + 2305 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_secondaryAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790672 | 0, fb + 3743 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularZLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792202 | 0, fb + 3765 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792086 | 0, fb + 3763 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793216 | 0, fb + 3782 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_secondaryAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790614 | 0, fb + 3742 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularZLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792144 | 0, fb + 3764 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792028 | 0, fb + 3762 | 0);
 return;
}

function __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793158 | 0, fb + 3781 | 0);
 return;
}

function __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_twistLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789710 | 0, fb + 3730 | 0);
 return;
}

function __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_swingLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789826 | 0, fb + 3732 | 0);
 return;
}

function __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_twistLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789652 | 0, fb + 3729 | 0);
 return;
}

function __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_swingLimitSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789768 | 0, fb + 3731 | 0);
 return;
}

function __Z65Register_UnityEngine_BillboardAsset_SetImageTexCoordsInternalListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501133 | 0, fb + 2767 | 0);
 return;
}

function __Z65Register_UnityEngine_AudioSettings_INTERNAL_CALL_GetConfigurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885288 | 0, fb + 3789 | 0);
 return;
}

function __Z65Register_UnityEngine_AnimatorUtility_DeoptimizeTransformHierarchyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928958 | 0, fb + 3820 | 0);
 return;
}

function __Z65Register_UnityEngine_AnimatorOverrideController_Internal_SetDirtyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928730 | 0, fb + 3819 | 0);
 return;
}

function __Z65Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591268 | 0, fb + 3171 | 0);
 return;
}

function __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_connectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818562 | 0, fb + 3875 | 0);
 return;
}

function __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_connectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818504 | 0, fb + 3874 | 0);
 return;
}

function __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_pathEndPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848160 | 0, fb + 4020 | 0);
 return;
}

function __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_desiredVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847219 | 0, fb + 4013 | 0);
 return;
}

function __Z64Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029504 | 0, fb + 2744 | 0);
 return;
}

function __Z64Register_UnityEngine_Networking_UnityWebRequest_get_responseCodev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032628 | 0, fb + 2752 | 0);
 return;
}

function __Z64Register_UnityEngine_Networking_UnityWebRequest_get_isModifiablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032744 | 0, fb + 2753 | 0);
 return;
}

function __Z64Register_UnityEngine_Networking_UnityWebRequest_InternalGetErrorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032291 | 0, fb + 2748 | 0);
 return;
}

function __Z64Register_UnityEngine_Networking_UnityWebRequest_GetRequestHeaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1033319 | 0, fb + 1114 | 0);
 return;
}

function __Z64Register_UnityEngine_GUIStyle_GetFontInternalDuringLoadingThreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023357 | 0, fb + 2727 | 0);
 return;
}

function __Z64Register_UnityEngine_Connect_UnityAdsSettings_SetPlatformEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043180 | 0, fb + 4430 | 0);
 return;
}

function __Z64Register_UnityEngine_CanvasRenderer_SplitIndiciesStreamsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014373 | 0, fb + 4251 | 0);
 return;
}

function __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_FlushEventsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039060 | 0, fb + 2763 | 0);
 return;
}

function __Z53getPxSimulationStatisticsParticlesGpuMeshCacheHitratePKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 884 >> 2]);
}

function __Z50getPxVehicleDifferential4WDataMFrontLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z43QualitySettings_Set_Custom_PropBlendWeightsi(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings15SetBlendWeightsEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z43QualitySettings_Set_Custom_PropAntiAliasingi(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings15SetAntiAliasingEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z39AndroidJNI_CUSTOM_CallStaticFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return Math_fround(0.0);
}

function __Z36getPxScene_SceneQueryStaticTimestampPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 360 >> 2] | 0, i1 | 0) | 0;
}

function __Z35setPxHeightFieldGeometryHeightScalePN5physx21PxHeightFieldGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z35setPxClothStretchConfigStretchLimitPN5physx20PxClothStretchConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z34setPxJointLimitParametersStiffnessPN5physx22PxJointLimitParametersEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z33getPxMaterial_FrictionCombineModePKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
}

function __Z32getPxFixedJoint_ConcreteTypeNamePKN5physx12PxFixedJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z32getPxConstraint_ConcreteTypeNamePKN5physx12PxConstraintE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z29CrashReport_CUSTOM_GetReportsv() {
 return __Z19scripting_array_newP11Il2CppClassjj(HEAP32[(__Z19GetScriptingManagerv() | 0) + 128 >> 2] | 0, 4, 0) | 0;
}

function __Z28setPxSceneDescBroadPhaseTypePN5physx11PxSceneDescENS_16PxBroadPhaseType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 40 >> 2] = i1;
 return;
}

function __Z28getPxRigidDynamic_IsSleepingPKN5physx14PxRigidDynamicE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 256 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getPxJoint_InvInertiaScale0PKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0));
}

function __Z26getPxCloth_SolverFrequencyPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
}

function __Z24getPxD6Joint_SwingZAnglePKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0));
}

function __Z24getPxD6Joint_SwingYAnglePKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
}

function __Z22getNbPxShape_MaterialsPKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0) & 65535 | 0;
}

function _UNITY_LZ4_create(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _calloc(8, 2052) | 0;
 _memset(i2 | 0, 0, 16416) | 0;
 HEAP32[i2 + 16396 >> 2] = i1;
 return i2 | 0;
}

function b98(i1, i2, i3, f4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_iiiifii(98);
 return 0;
}

function b21(i1, i2, f3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_iiifiii(21);
 return 0;
}

function b133(i1, i2, i3, f4, f5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 i6 = i6 | 0;
 nullFunc_viiiffi(133);
}

function _glUniformMatrix4fv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glUniformMatrix4fv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glUniformMatrix3fv__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glUniformMatrix3fv(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glGetShaderInfoLog__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetShaderInfoLog(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glBindAttribLocation__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glBindAttribLocation(i1 | 0, i2 | 0, i3 | 0);
}

function __ZZN8VRModuleC1EvEN30beforeInitializeEngineGraphics7ForwardEv() {
 __ZN8VRModule30BeforeInitializeEngineGraphicsEv(HEAP32[gb + 1469188 >> 2] | 0);
 return;
}

function __ZZN17Physics2DSettings15InitializeClassEvEN15didDestroyWorld7ForwardEv() {
 __ZN14Physics2DState13RecreateWorldEv(HEAP32[gb + 1458412 >> 2] | 0);
 return;
}

function __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1 + -8 | 0);
 return;
}

function __ZThn8_N12_GLOBAL__N_117ConnectionManagerD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -8 | 0;
 __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStream7executeEv(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_123DoubleBufferedOutStream7executeEv(i1 + -4 | 0);
 return;
}

function __ZThn4_N12_GLOBAL__N_117ConnectionManagerD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj(i1) {
 i1 = i1 | 0;
 return (i1 >>> 0 < 2 ? 1 : (i1 + 4 & -4) + -1 | 0) | 0;
}

function __ZNSt16nested_exceptionD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208136 + 8;
 ___cxa_decrement_exception_refcount(HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZNSt16nested_exceptionC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208136 + 8;
 HEAP32[i1 + 4 >> 2] = ___cxa_current_primary_exception() | 0;
 return;
}

function __ZNK6Camera17GetStereoEyeBeginEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 1112 >> 0] | 0)) return HEAP32[i1 + 824 >> 2] & 1 ^ 1 | 0; else return 0;
 return 0;
}

function __ZNK5physx7profile21NullEventNameProvider15getProfileNamesEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZNK30SpriteRendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(0.0);
}

function __ZNK29ParticleSystemPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK29LineParametersPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx7NpScene22setNbContactDataBlocksEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sc5Scene22setNbContactDataBlocksEj(i2 + 32 | 0, i1);
 return;
}

function __ZN5physx3Cct8SweptBoxC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct11SweptVolumeC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 86060 + 8;
 HEAP32[i1 + 36 >> 2] = 0;
 return;
}

function __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8tabCountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) + (HEAP32[i1 + 20 >> 2] | 0) | 0;
}

function __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5Unity5Cloth10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour10DeactivateE19DeactivateOperation(i1, i2);
 return;
}

function __ZN4Mesh5SetUvEiPK8Vector2fj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 __ZN4Mesh5SetUvEiPKfjj(i1, i2, i3, 2, i4);
 return;
}

function __ZN19UnityConnectService20OnExitPlayModeStaticEPS_(i1) {
 i1 = i1 | 0;
 __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i1, 0);
 return;
}

function __ZN19TouchPhaseEmulationD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 62260 + 8;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 if (!i1) return;
 __ZdaPv(i1);
 return;
}

function __ZN17FileSystemHandler4LockER13FileEntryData12FileLockMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN17AnimationPlayableD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 176764 + 8;
 __ZN14AssetReferenceD2Ev(i1 + 76 | 0);
 __ZN8PlayableD2Ev(i1);
 return;
}

function __ZN14Texture2DArray5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 return;
}

function __ZN14RenderSettings9SetUseFogEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 312 >> 0] = i2 & 1;
 __ZN14RenderSettings14ApplyFogParamsEv(i1);
 return;
}

function __ZN14DirectorPlayer8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i1, i2);
 return;
}

function __ZN13SubstanceData19AreMaterialsLoadingEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2];
 return (HEAP32[i1 >> 2] | 0) > 0 | 0;
}

function __ZN12NavMeshAgentD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN12HandlerChain4SeekER13FileEntryDatax10FileOrigin(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN11Rigidbody2D10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11Rigidbody2D7CleanupE19DeactivateOperation(i1, i2);
 return;
}

function __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN6Object8TransferI17RemapPPtrTransferEEvRT_(i1, i2);
 return;
}

function __ZN11AudioFilter17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 if (!i1) return;
 __ZN4FMOD3DSP9setBypassEb(i1, 1) | 0;
 return;
}

function __Z67Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813152 | 0, fb + 1 | 0);
 return;
}

function __Z66Register_UnityEngine_SystemInfo_get_supportsRawShadowDepthSamplingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498656 | 0, fb + 58 | 0);
 return;
}

function __Z65Register_UnityEngine_Rigidbody_INTERNAL_CALL_ClosestPointOnBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785819 | 0, fb + 857 | 0);
 return;
}

function __Z65Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForceAtPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815606 | 0, fb + 303 | 0);
 return;
}

function __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560068 | 0, fb + 638 | 0);
 return;
}

function __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560192 | 0, fb + 640 | 0);
 return;
}

function __Z65Register_UnityEngine_QualitySettings_get_realtimeReflectionProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522755 | 0, fb + 134 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_SetCustomParticleDataInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653310 | 0, fb + 765 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626357 | 0, fb + 222 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626415 | 0, fb + 279 | 0);
 return;
}

function __Z65Register_UnityEngine_ParticleSystem_GetCustomParticleDataInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653368 | 0, fb + 391 | 0);
 return;
}

function __Z65Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531710 | 0, fb + 610 | 0);
 return;
}

function __Z65Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531822 | 0, fb + 612 | 0);
 return;
}

function __Z65Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530808 | 0, fb + 598 | 0);
 return;
}

function __Z65Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531284 | 0, fb + 605 | 0);
 return;
}

function __Z65Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531392 | 0, fb + 606 | 0);
 return;
}

function __Z65Register_UnityEngine_LightProbeProxyVolume_get_isFeatureSupportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544230 | 0, fb + 185 | 0);
 return;
}

function __Z65Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533256 | 0, fb + 616 | 0);
 return;
}

function __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532282 | 0, fb + 613 | 0);
 return;
}

function __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow1v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532224 | 0, fb + 236 | 0);
 return;
}

function __Z65Register_UnityEngine_GeometryUtility_INTERNAL_CALL_TestPlanesAABBv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534169 | 0, fb + 644 | 0);
 return;
}

function __Z65Register_UnityEngine_CharacterController_INTERNAL_CALL_SimpleMovev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796787 | 0, fb + 857 | 0);
 return;
}

function __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKRotationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920302 | 0, fb + 931 | 0);
 return;
}

function __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920186 | 0, fb + 929 | 0);
 return;
}

function __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKRotationInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920244 | 0, fb + 930 | 0);
 return;
}

function __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920128 | 0, fb + 928 | 0);
 return;
}

function __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_GetKey_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546517 | 0, fb + 627 | 0);
 return;
}

function __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_AddKey_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546296 | 0, fb + 650 | 0);
 return;
}

function __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_SetDestinationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846684 | 0, fb + 914 | 0);
 return;
}

function __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_suspensionSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836419 | 0, fb + 3982 | 0);
 return;
}

function __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_sidewaysFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836919 | 0, fb + 3986 | 0);
 return;
}

function __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_suspensionSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836362 | 0, fb + 3981 | 0);
 return;
}

function __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_sidewaysFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836862 | 0, fb + 3985 | 0);
 return;
}

function __Z64Register_UnityEngine_Texture_SetGlobalAnisotropicFilteringLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571265 | 0, fb + 3110 | 0);
 return;
}

function __Z64Register_UnityEngine_TerrainData_set_Internal_alphamapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940898 | 0, fb + 4171 | 0);
 return;
}

function __Z64Register_UnityEngine_TerrainData_get_Internal_alphamapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940841 | 0, fb + 2602 | 0);
 return;
}

function __Z64Register_UnityEngine_TerrainData_NeedUpgradeScaledTreePrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940650 | 0, fb + 2600 | 0);
 return;
}

function __Z64Register_UnityEngine_SkinnedMeshRenderer_set_updateWhenOffscreenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524294 | 0, fb + 2865 | 0);
 return;
}

function __Z64Register_UnityEngine_SkinnedMeshRenderer_get_updateWhenOffscreenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524237 | 0, fb + 1685 | 0);
 return;
}

function __Z64Register_UnityEngine_SceneManagement_Scene_GetBuildIndexInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561347 | 0, fb + 1842 | 0);
 return;
}

function __Z64Register_UnityEngine_Renderer_GetClosestReflectionProbesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527361 | 0, fb + 2902 | 0);
 return;
}

function __Z64Register_UnityEngine_RenderTexture_INTERNAL_CALL_DiscardContentsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575902 | 0, fb + 3652 | 0);
 return;
}

function __Z64Register_UnityEngine_RenderSettings_INTERNAL_set_ambientSkyColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519195 | 0, fb + 3513 | 0);
 return;
}

function __Z64Register_UnityEngine_RenderSettings_INTERNAL_get_ambientSkyColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519138 | 0, fb + 3512 | 0);
 return;
}

function __Z64Register_UnityEngine_RectTransform_INTERNAL_set_anchoredPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555419 | 0, fb + 3025 | 0);
 return;
}

function __Z64Register_UnityEngine_RectTransform_INTERNAL_get_anchoredPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555362 | 0, fb + 3024 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics_set_defaultSolverVelocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782984 | 0, fb + 3725 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics2D_INTERNAL_set_colliderContactColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810919 | 0, fb + 3748 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics2D_INTERNAL_get_colliderContactColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810862 | 0, fb + 3747 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645069 | 0, fb + 3394 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645126 | 0, fb + 2038 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635754 | 0, fb + 3325 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635811 | 0, fb + 2009 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshColorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629310 | 0, fb + 3276 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshShapeTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628612 | 0, fb + 3270 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshColorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629367 | 0, fb + 1994 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshShapeTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628669 | 0, fb + 1988 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625369 | 0, fb + 3249 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625121 | 0, fb + 3247 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624873 | 0, fb + 3245 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625426 | 0, fb + 3250 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625178 | 0, fb + 3248 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624930 | 0, fb + 3246 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_INTERNAL_set_startRotation3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652523 | 0, fb + 3438 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_INTERNAL_get_startRotation3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652466 | 0, fb + 3437 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633368 | 0, fb + 3305 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633254 | 0, fb + 3303 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633140 | 0, fb + 3301 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633425 | 0, fb + 3306 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633311 | 0, fb + 3304 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 633197 | 0, fb + 3302 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626907 | 0, fb + 1984 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655484 | 0, fb + 2084 | 0);
 return;
}

function __Z64Register_UnityEngine_LightProbeProxyVolume_set_probePositionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543595 | 0, fb + 2981 | 0);
 return;
}

function __Z64Register_UnityEngine_LightProbeProxyVolume_get_probePositionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543538 | 0, fb + 1774 | 0);
 return;
}

function __Z64Register_UnityEngine_Camera_INTERNAL_CALL_ResetReplacementShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507385 | 0, fb + 3480 | 0);
 return;
}

function __Z64Register_UnityEngine_Application_ReplyToUserAuthorizationRequestv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495657 | 0, fb + 2759 | 0);
 return;
}

function __Z64Register_UnityEngine_AnimatorOverrideController_GetOverrideClipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928845 | 0, fb + 2582 | 0);
 return;
}

function __Z64Register_UnityEngine_AnimatorOverrideController_GetOriginalClipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928788 | 0, fb + 2581 | 0);
 return;
}

function __Z64Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591326 | 0, fb + 3172 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMesh_SetPathfindingIterationsPerFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850793 | 0, fb + 3776 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMeshAgent_set_autoTraverseOffMeshLinkv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847750 | 0, fb + 4017 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMeshAgent_get_autoTraverseOffMeshLinkv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847693 | 0, fb + 2443 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_steeringTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847162 | 0, fb + 4012 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_worldVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050659 | 0, fb + 4437 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_localVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050771 | 0, fb + 4439 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_worldVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050603 | 0, fb + 4436 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_localVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050715 | 0, fb + 4438 | 0);
 return;
}

function __Z63Register_UnityEngine_Networking_UploadHandler_InternalCreateRawv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029266 | 0, fb + 4305 | 0);
 return;
}

function __Z63Register_UnityEngine_Networking_UnityWebRequest_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1031883 | 0, fb + 3926 | 0);
 return;
}

function __Z63Register_UnityEngine_Networking_DownloadHandler_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028421 | 0, fb + 3922 | 0);
 return;
}

function __Z63Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMouseDeltav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019500 | 0, fb + 4271 | 0);
 return;
}

function __Z63Register_UnityEngine_Connect_UnityAdsSettings_IsPlatformEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043124 | 0, fb + 2765 | 0);
 return;
}

function __Z49getPxVehicleDifferential4WDataMRearLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z45Input_Set_Custom_PropSimulateMouseWithTouchesh(i1) {
 i1 = i1 | 0;
 HEAP8[(__Z15GetInputManagerv() | 0) + 190 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z40setPxVehicleDriveDynDataMGearDownPressedPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 66 >> 0] = i1 & 1;
 return;
}

function __Z39Application_CUSTOM_HasUserAuthorizationi(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__Z27GetUserAuthorizationManagerv() | 0) >> 2] & i1 | 0) == (i1 | 0) | 0;
}

function __Z38QualitySettings_Set_Custom_PropLodBiasf(f1) {
 f1 = Math_fround(f1);
 __ZN15QualitySettings10SetLODBiasEf(__Z18GetQualitySettingsv() | 0, f1);
 return;
}

function __Z36setPxVehicleWheelDataMMaxBrakeTorquePN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z35getPxScene_CCDContactModifyCallbackPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 184 >> 2] | 0, i1 | 0) | 0;
}

function __Z35GUI_CUSTOM_INTERNAL_CALL_DragWindowRK5RectTIfE(i1) {
 i1 = i1 | 0;
 __ZN5IMGUI10DragWindowER8GUIStateRK5RectTIfE(__Z11GetGUIStatev() | 0, i1);
 return;
}

function __Z32setPxJointLimitParametersDampingPN5physx22PxJointLimitParametersEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z31setPxJointAngularLimitPairUpperPN5physx23PxJointAngularLimitPairEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z31setPxJointAngularLimitPairLowerPN5physx23PxJointAngularLimitPairEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z29getNbPxRigidActor_ConstraintsPKN5physx12PxRigidActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function __Z29getNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __Z29GetRowBytesFromWidthAndFormati13TextureFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_imul(HEAP32[gb + 45784 + (i2 << 2) >> 2] | 0, i1) | 0;
}

function __Z28getPxArticulation_IsSleepingPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getPxArticulation_AggregatePKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
}

function __Z17CreateBatchDeleteR11BatchDeletej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2 >>> 0 > 256 ? 256 : i2;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __Z15DestroyJobQueuev() {
 __Z19free_alloc_internalPvRK10MemLabelId(HEAP32[gb + 1162216 >> 2] | 0, gb + 63200 | 0);
 HEAP32[gb + 1162216 >> 2] = 0;
 return;
}

function __Z11GetNicePathR15CacheReaderBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __GLOBAL__sub_I_AssetBundleFileSystem_cpp() {
 __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_(gb + 1548966 | 0, 0, fb + 3670 | 0, 0, 0);
 return;
}

function mftCall_v(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) >= (fb | 0) & (i1 | 0) < (fb + 511 | 0)) {
  FUNCTION_TABLE_v[i1 - fb & 511]();
  return;
 }
 ftCall_v(i1 | 0);
}

function b93(i1, i2, i3, i4, i5, i6, i7) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 i7 = i7 | 0;
 nullFunc_viiiiiii(93);
}

function b122(f1, f2, f3, f4, i5) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 nullFunc_vffffi(122);
}

function _getopt_long(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return ___getopt_long(i1, i2, i3, i4, i5, 0) | 0;
}

function __ZNSt3__217__assoc_sub_state16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208728 + 8;
 __ZNSt3__26localeD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208664 + 8;
 __ZNSt3__26localeD2Ev(i1 + 4 | 0);
 return;
}

function __ZNK9ShaderLab10SubProgram14EnsureCompiledEv(i1) {
 i1 = i1 | 0;
 if (HEAP32[i1 + 8 >> 2] | 0) return;
 __ZN9ShaderLab10SubProgram7CompileEv(i1);
 return;
}

function __ZNK5physx7NpScene26getFrictionOffsetThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc5Scene26getFrictionOffsetThresholdEv(i1 + 32 | 0));
}

function __ZNK5physx2Sc5Scene24getContactModifyCallbackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 5908 >> 2] | 0;
}

function __ZNK5physx2Sc23ElementActorInteraction23isLastFilterInteractionEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[(HEAP32[i1 + 40 >> 2] | 0) + 16 >> 1] | 0) == 1 | 0;
}

function __ZNK28RectTransformPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK28MonoBehaviourPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9Transform7GetRootEv(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 while (1) {
  i2 = HEAP32[i1 + 100 >> 2] | 0;
  if (!i2) break; else i1 = i2;
 }
 return i1 | 0;
}

function __ZN9Scripting32GetScriptingArrayStringStartImplEP11Il2CppArray(i1) {
 i1 = i1 | 0;
 return __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
}

function __ZN9Scripting32GetScriptingArrayObjectStartImplEP11Il2CppArray(i1) {
 i1 = i1 | 0;
 return __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, 0, 4) | 0;
}

function __ZN9GfxDevice20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5physx5cloth8SwTetherC2Etf(i3, i1, f2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAP16[i3 >> 1] = i1;
 HEAPF32[i3 + 4 >> 2] = f2;
 return;
}

function __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx22PxDefaultFileInputData4readEPvj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return _fread(i2, 1, i1, HEAP32[i3 + 4 >> 2] | 0) | 0;
}

function __ZN5Umbra10Visibility22setOutputContributionsEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 28 >> 2] = i2;
 return;
}

function __ZN4FMOD7ReverbI15set3DAttributesEPK11FMOD_VECTORff(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 return 0;
}

function __ZN22UnityAnalyticsSettings18InitializeDefaultsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 1;
 HEAP8[i1 + 10 >> 0] = 0;
 return;
}

function __ZN19CloudServiceHandler20PauseEventDispatcherEv(i1) {
 i1 = i1 | 0;
 return __ZN11UnityEngine15CloudWebService14DataDispatcher5PauseEv(i1 + 792 | 0) | 0;
}

function __ZN19CloudServiceHandler16StopEventHandlerEv(i1) {
 i1 = i1 | 0;
 return __ZN11UnityEngine15CloudWebService19SessionEventManager4StopEv(i1 + 200 | 0) | 0;
}

function __ZN17MemoryCacheWriter16UnlockCacheBlockEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN17MemoryCacheReader16UnlockCacheBlockEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 8 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + -1;
 return;
}

function __ZN14CachingManager17VerifyValidDomainERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN13GfxDeviceNull20ImmediateTexCoordAllEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 return;
}

function __ZN12LightManager12CleanupClassEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1112264 >> 2] | 0;
 if (i1 | 0) __ZdlPv(i1);
 HEAP32[gb + 1112264 >> 2] = 0;
 return;
}

function __ZN11OffMeshLinkD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN11AudioModule27GetDSPFromAudioCustomFilterEP17AudioCustomFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN17AudioCustomFilter6GetDSPEv(i2) | 0;
}

function __ZN11AudioFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10SampleClip8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i2);
 return;
}

function __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812673 | 0, fb + 1 | 0);
 return;
}

function __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812284 | 0, fb + 4 | 0);
 return;
}

function __Z65Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578296 | 0, fb + 48 | 0);
 return;
}

function __Z64Register_UnityEngine_Transform_INTERNAL_CALL_SetLocalEulerAnglesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577728 | 0, fb + 682 | 0);
 return;
}

function __Z64Register_UnityEngine_Transform_INTERNAL_CALL_GetLocalEulerAnglesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577671 | 0, fb + 681 | 0);
 return;
}

function __Z64Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 562225 | 0, fb + 206 | 0);
 return;
}

function __Z64Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559945 | 0, fb + 636 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics_get_defaultSolverVelocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782927 | 0, fb + 230 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_TriggerModule_SetRadiusScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644785 | 0, fb + 275 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_TriggerModule_GetRadiusScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644842 | 0, fb + 332 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_CollisionModule_SetVoxelSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643730 | 0, fb + 273 | 0);
 return;
}

function __Z64Register_UnityEngine_ParticleSystem_CollisionModule_GetVoxelSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643787 | 0, fb + 330 | 0);
 return;
}

function __Z64Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeVertexBufferPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548423 | 0, fb + 628 | 0);
 return;
}

function __Z64Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531599 | 0, fb + 608 | 0);
 return;
}

function __Z64Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531178 | 0, fb + 604 | 0);
 return;
}

function __Z64Register_UnityEngine_Collider_INTERNAL_CALL_ClosestPointOnBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794758 | 0, fb + 860 | 0);
 return;
}

function __Z64Register_UnityEngine_CanvasRenderer_SplitUIVertexStreamsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014316 | 0, fb + 36 | 0);
 return;
}

function __Z64Register_UnityEngine_CanvasRenderer_CreateUIVertexStreamInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014430 | 0, fb + 21 | 0);
 return;
}

function __Z64Register_UnityEngine_Camera_INTERNAL_CALL_CalculateObliqueMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508604 | 0, fb + 571 | 0);
 return;
}

function __Z64Register_UnityEngine_AssetBundle_LoadAssetWithSubAssets_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496731 | 0, fb + 358 | 0);
 return;
}

function __Z64Register_UnityEngine_Application_GetStreamProgressForLevelByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493161 | 0, fb + 199 | 0);
 return;
}

function __Z64Register_UnityEngine_Animator_IsParameterControlledByCurveStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923996 | 0, fb + 975 | 0);
 return;
}

function __Z64Register_UnityEngine_AnimatorOverrideController_Internal_SetClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928673 | 0, fb + 310 | 0);
 return;
}

function __Z64Register_UnityEngine_AnimatorOverrideController_Internal_GetClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928616 | 0, fb + 439 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMesh_GetPathfindingIterationsPerFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850850 | 0, fb + 243 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMeshObstacle_set_carvingMoveThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851444 | 0, fb + 596 | 0);
 return;
}

function __Z64Register_UnityEngine_AI_NavMeshObstacle_get_carvingMoveThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851387 | 0, fb + 686 | 0);
 return;
}

function __Z63Register_UnityEngine_WheelCollider_INTERNAL_set_forwardFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836806 | 0, fb + 3984 | 0);
 return;
}

function __Z63Register_UnityEngine_WheelCollider_INTERNAL_get_forwardFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836750 | 0, fb + 3983 | 0);
 return;
}

function __Z63Register_UnityEngine_Terrain_GetClosestReflectionProbesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943089 | 0, fb + 4187 | 0);
 return;
}

function __Z63Register_UnityEngine_TerrainData_set_Internal_baseMapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941011 | 0, fb + 4172 | 0);
 return;
}

function __Z63Register_UnityEngine_TerrainData_get_Internal_baseMapResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940955 | 0, fb + 2603 | 0);
 return;
}

function __Z63Register_UnityEngine_SceneManagement_Scene_GetRootCountInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561404 | 0, fb + 1843 | 0);
 return;
}

function __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetInertiaTensorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787087 | 0, fb + 3731 | 0);
 return;
}

function __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_get_worldCenterOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814010 | 0, fb + 3845 | 0);
 return;
}

function __Z63Register_UnityEngine_Rendering_GraphicsSettings_SetCustomShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558132 | 0, fb + 3052 | 0);
 return;
}

function __Z63Register_UnityEngine_Rendering_GraphicsSettings_GetCustomShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558188 | 0, fb + 1832 | 0);
 return;
}

function __Z63Register_UnityEngine_Rendering_CommandBuffer_ReleaseTemporaryRTv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559503 | 0, fb + 3054 | 0);
 return;
}

function __Z63Register_UnityEngine_Renderer_set_lightProbeProxyVolumeOverridev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526811 | 0, fb + 2894 | 0);
 return;
}

function __Z63Register_UnityEngine_Renderer_get_lightProbeProxyVolumeOverridev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526755 | 0, fb + 1705 | 0);
 return;
}

function __Z63Register_UnityEngine_RenderTexture_Internal_CreateRenderTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574395 | 0, fb + 3649 | 0);
 return;
}

function __Z63Register_UnityEngine_Physics2D_INTERNAL_set_colliderAsleepColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810806 | 0, fb + 3746 | 0);
 return;
}

function __Z63Register_UnityEngine_Physics2D_INTERNAL_get_colliderAsleepColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810750 | 0, fb + 3745 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635112 | 0, fb + 3322 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634888 | 0, fb + 3318 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635168 | 0, fb + 3323 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635056 | 0, fb + 3321 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634944 | 0, fb + 3319 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628822 | 0, fb + 3272 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628878 | 0, fb + 1990 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639324 | 0, fb + 3355 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641022 | 0, fb + 3367 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetSeparateAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639380 | 0, fb + 2017 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641078 | 0, fb + 2021 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623477 | 0, fb + 3233 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623533 | 0, fb + 3234 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_LightsModule_SetLightPrefabv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648440 | 0, fb + 3410 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_LightsModule_GetLightPrefabv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648496 | 0, fb + 2050 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634512 | 0, fb + 3313 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 634568 | 0, fb + 3314 | 0);
 return;
}

function __Z63Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawCursorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023916 | 0, fb + 164 | 0);
 return;
}

function __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_set_relativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823048 | 0, fb + 3911 | 0);
 return;
}

function __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_get_relativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822992 | 0, fb + 3910 | 0);
 return;
}

function __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791726 | 0, fb + 3757 | 0);
 return;
}

function __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791670 | 0, fb + 3756 | 0);
 return;
}

function __Z63Register_UnityEngine_CharacterJoint_INTERNAL_set_highTwistLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790050 | 0, fb + 3736 | 0);
 return;
}

function __Z63Register_UnityEngine_CharacterJoint_INTERNAL_get_highTwistLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789994 | 0, fb + 3735 | 0);
 return;
}

function __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ResetProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505265 | 0, fb + 3474 | 0);
 return;
}

function __Z63Register_UnityEngine_Audio_AudioMixer_set_outputAudioMixerGroupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894351 | 0, fb + 4074 | 0);
 return;
}

function __Z63Register_UnityEngine_Audio_AudioMixer_get_outputAudioMixerGroupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894295 | 0, fb + 2515 | 0);
 return;
}

function __Z63Register_UnityEngine_AssetBundle_get_isStreamedSceneAssetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496450 | 0, fb + 1593 | 0);
 return;
}

function __Z63Register_UnityEngine_Application_CanStreamedLevelBeLoadedByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493312 | 0, fb + 1581 | 0);
 return;
}

function __Z63Register_UnityEngine_AnimatorUtility_OptimizeTransformHierarchyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 928902 | 0, fb + 4153 | 0);
 return;
}

function __Z63Register_UnityEngine_AnimationClip_Internal_CreateAnimationClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915398 | 0, fb + 3807 | 0);
 return;
}

function __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ExceptionOccurredv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591650 | 0, fb + 3672 | 0);
 return;
}

function __Z63Register_UnityEngine_AI_NavMeshObstacle_set_carveOnlyStationaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851331 | 0, fb + 4033 | 0);
 return;
}

function __Z63Register_UnityEngine_AI_NavMeshObstacle_get_carveOnlyStationaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851275 | 0, fb + 2460 | 0);
 return;
}

function __Z63Register_UnityEngine_AI_NavMeshAgent_ActivateCurrentOffMeshLinkv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847465 | 0, fb + 4014 | 0);
 return;
}

function __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalSetUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032573 | 0, fb + 4310 | 0);
 return;
}

function __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalGetUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032518 | 0, fb + 2751 | 0);
 return;
}

function __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1031828 | 0, fb + 3925 | 0);
 return;
}

function __Z62Register_UnityEngine_GUIStyle_INTERNAL_set_Internal_clipOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022911 | 0, fb + 4294 | 0);
 return;
}

function __Z62Register_UnityEngine_GUIStyle_INTERNAL_get_Internal_clipOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022856 | 0, fb + 4293 | 0);
 return;
}

function __Z62Register_UnityEngine_GUIClip_Internal_GetAbsoluteMousePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1026159 | 0, fb + 3919 | 0);
 return;
}

function __Z62Register_UnityEngine_Connect_UnityConnectSettings_set_testModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043722 | 0, fb + 3948 | 0);
 return;
}

function __Z62Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserIdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039117 | 0, fb + 1120 | 0);
 return;
}

function __Z62Register_UnityEngine_Analytics_CustomEventData_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038208 | 0, fb + 3928 | 0);
 return;
}

function __Z55SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_ClearInternalR20SphericalHarmonicsL2(i1) {
 i1 = i1 | 0;
 __ZN20SphericalHarmonicsL27SetZeroEv(i1);
 return;
}

function __Z48getPxVehicleTireLoadFilterDataMMaxNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z42Physics_Set_Custom_PropQueriesHitBackfacesh(i1) {
 i1 = i1 | 0;
 HEAP8[(__Z17GetPhysicsManagerv() | 0) + 798 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z36setPxJointLimitParametersRestitutionPN5physx22PxJointLimitParametersEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z36Time_Set_Custom_PropMaximumDeltaTimef(f1) {
 f1 = Math_fround(f1);
 __ZN11TimeManager19SetMaximumDeltaTimeEf(__Z14GetTimeManagerv() | 0, f1);
 return;
}

function __Z34getPxScene_VisualizationCullingBoxPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 304 >> 2] | 0, i1 | 0) | 0;
}

function __Z33RenderSettings_Set_Custom_PropFogh(i1) {
 i1 = i1 | 0;
 __ZN14RenderSettings9SetUseFogEb(__Z17GetRenderSettingsv() | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z32setPxHeightFieldGeometryRowScalePN5physx21PxHeightFieldGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z31getPxAggregate_ConcreteTypeNamePKN5physx11PxAggregateE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z30CleanupDynamicBatchGeometryJobP25DynamicVBOGeometryJobData(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64024 | 0);
 return;
}

function __Z29getPxRigidBody_RigidBodyFlagsPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0;
}

function __Z28getPxClothFabric_NbParticlesPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __Z27SortingLayer_CUSTOM_IsValidi(i1) {
 i1 = i1 | 0;
 return (__ZN10TagManager27IsSortingLayerUniqueIDValidEi(__Z13GetTagManagerv() | 0, i1) | 0) & 1 | 0;
}

function __Z25RectOffset_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __Z24getPxShape_ContactOffsetPKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0));
}

function __Z24getPxCloth_ContactOffsetPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 440 >> 2] | 0, i1 | 0));
}

function __Z20Gradient_CUSTOM_InitP12Il2CppObject(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = __Znwj(72) | 0;
 __ZN8GradientC2Ev(i2);
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __Z20CleanupPhysicsModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z11GetIPhysicsv() | 0, gb + 63400 | 0);
 __Z11SetIPhysicsP8IPhysics(0);
 return;
}

function __Z19getPxRigidBody_MassPKN5physx11PxRigidBodyE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 132 >> 2] | 0, i1 | 0));
}

function _glGetShaderSource__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glGetShaderSource(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetVertexAttribiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetVertexAttribiv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetVertexAttribfv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetVertexAttribfv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetTexParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetTexParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetTexParameterfv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetTexParameterfv(i1 | 0, i2 | 0, i3 | 0);
}

function __ZZN14ParticleSystem15InitializeClassEvEN46PostLateUpdateParticleSystemEndUpdateAllstruct7ForwardEv() {
 __ZN14ParticleSystem12EndUpdateAllEv();
 return;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -12 + 80 >> 2] | 0;
}

function __ZNK7dtCrowd8getAgentERK13dtCrowdHandle(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + ((HEAP32[i2 >> 2] | 0) * 608 | 0) | 0;
}

function __ZNK5physx9NpPhysics17getNbHeightFieldsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx13GuMeshFactory17getNbHeightFieldsEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZNK5physx9NpPhysics17getNbConvexMeshesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx13GuMeshFactory17getNbConvexMeshesEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5Umbra10PortalInfo12getGateIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 80 + (i2 << 2) >> 2] | 0;
}

function __ZNK16b2PrismaticJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 108 >> 2]) * f2);
}

function __ZNK13TranslateGLES23VertexArrayTypeBitfieldE19VertexChannelFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75628 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES20GetTextureSRGBDecodeEN2gl17TextureSrgbDecodeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 74628 + (i2 << 2) >> 2] | 0;
}

function __ZN9Scripting35DestroyObjectFromScriptingImmediateEP6Objectb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
 return;
}

function __ZN5physx19getXTorqueCurvePairEPKNS_19PxVehicleEngineDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i1 + (i2 << 1 << 2) >> 2]);
}

function __ZN5physx10PxsContext18setBounceThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 12 >> 2] | 0) + 140 >> 2] = f2;
 return;
}

function __ZN5IMGUIL14SortTwoWindowsEPKNS_9GUIWindowES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 68 >> 2] | 0) < (HEAP32[i2 + 68 >> 2] | 0) | 0;
}

function __ZN4FileD2Ev(i1) {
 i1 = i1 | 0;
 __ZN4File5CloseEv(i1) | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev(i1 + 16 | 0);
 return;
}

function __ZN4File7IsValidEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = (HEAP32[i1 + 4 >> 2] | 0) != 0;
 return i1 | 0;
}

function __ZN19UnityConnectService18OnPlayerQuitStaticEPS_(i1) {
 i1 = i1 | 0;
 __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE(i1, 0);
 return;
}

function __ZN16ScriptingManager14IsTrustedTokenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN14DetailDatabase21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 1;
 __ZN14DetailDatabase28GenerateTextureAtlasThreadedEv(i1);
 return;
}

function __ZN13RuntimeStaticI22VirtualJoystickManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 __ZN13RuntimeStaticI22VirtualJoystickManagerE7DestroyEv(i1);
 return;
}

function __ZN11DynamicMesh9AddVertexERK8Vector3f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN12VertexWelderILi2048EE4PushERK8Vector3f(i1 + 60 | 0, i2) | 0;
 return;
}

function __ZN10dtNodePool5clearEv(i1) {
 i1 = i1 | 0;
 _memset(HEAP32[i1 + 4 >> 2] | 0, -1, HEAP32[i1 + 16 >> 2] << 1 | 0) | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN10GUIElementD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN10FlareLayerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __Z65Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsuleNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783552 | 0, fb + 2 | 0);
 return;
}

function __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812510 | 0, fb + 2 | 0);
 return;
}

function __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CapsuleCastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812052 | 0, fb + 1 | 0);
 return;
}

function __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512135 | 0, fb + 6 | 0);
 return;
}

function __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512193 | 0, fb + 7 | 0);
 return;
}

function __Z64Register_UnityEngine_SystemInfo_get_supportsCubemapArrayTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499016 | 0, fb + 65 | 0);
 return;
}

function __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_Transactionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1039293 | 0, fb + 1 | 0);
 return;
}

function __Z64Register_UnityEngineInternal_GIDebugVisualisation_PauseCycleModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513257 | 0, fb + 96 | 0);
 return;
}

function __Z63Register_UnityEngine_WebCamTexture_Internal_CreateWebCamTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895312 | 0, fb + 155 | 0);
 return;
}

function __Z63Register_UnityEngine_Transform_INTERNAL_CALL_TransformDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578398 | 0, fb + 685 | 0);
 return;
}

function __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForceAtPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785708 | 0, fb + 302 | 0);
 return;
}

function __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddRelativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815550 | 0, fb + 872 | 0);
 return;
}

function __Z63Register_UnityEngine_Profiling_Profiler_GetTotalAllocatedMemoryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554130 | 0, fb + 196 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635e3 | 0, fb + 3320 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetNormalOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629424 | 0, fb + 230 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetNormalOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629480 | 0, fb + 287 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_set_normalDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654311 | 0, fb + 299 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_set_minParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654837 | 0, fb + 301 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_set_maxParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654949 | 0, fb + 302 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_get_normalDirectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654255 | 0, fb + 356 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_get_minParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654781 | 0, fb + 358 | 0);
 return;
}

function __Z63Register_UnityEngine_ParticleSystemRenderer_get_maxParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654893 | 0, fb + 359 | 0);
 return;
}

function __Z63Register_UnityEngine_MonoBehaviour_StartCoroutine_Auto_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549469 | 0, fb + 659 | 0);
 return;
}

function __Z63Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeIndexBufferPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548480 | 0, fb + 3e3 | 0);
 return;
}

function __Z63Register_UnityEngine_Material_Internal_GetTextureScaleAndOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565314 | 0, fb + 649 | 0);
 return;
}

function __Z63Register_UnityEngine_HumanPoseHandler_Internal_HumanPoseHandlerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930283 | 0, fb + 953 | 0);
 return;
}

function __Z63Register_UnityEngine_Diagnostics_PlayerConnection_get_connectedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552591 | 0, fb + 186 | 0);
 return;
}

function __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToScreenPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506950 | 0, fb + 564 | 0);
 return;
}

function __Z63Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506062 | 0, fb + 554 | 0);
 return;
}

function __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToViewportPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506894 | 0, fb + 563 | 0);
 return;
}

function __Z63Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_IntersectRayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545801 | 0, fb + 364 | 0);
 return;
}

function __Z63Register_UnityEngine_AudioHighPassFilter_set_highpassResonanceQv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891431 | 0, fb + 627 | 0);
 return;
}

function __Z63Register_UnityEngine_AudioHighPassFilter_get_highpassResonanceQv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891375 | 0, fb + 717 | 0);
 return;
}

function __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591383 | 0, fb + 250 | 0);
 return;
}

function __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticMethodIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592461 | 0, fb + 255 | 0);
 return;
}

function __Z63Register_UnityEngineInternal_GIDebugVisualisation_get_cycleModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513370 | 0, fb + 107 | 0);
 return;
}

function __Z62Register_UnityEngine_WebGL_UNetWebGlHelpers_InitUpdateFunctionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1037261 | 0, fb + 391 | 0);
 return;
}

function __Z62Register_UnityEngine_WebCamTexture_get_videoVerticallyMirroredv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 896121 | 0, fb + 2524 | 0);
 return;
}

function __Z62Register_UnityEngine_Transform_INTERNAL_get_worldToLocalMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578186 | 0, fb + 3149 | 0);
 return;
}

function __Z62Register_UnityEngine_Transform_INTERNAL_get_localToWorldMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578241 | 0, fb + 3150 | 0);
 return;
}

function __Z62Register_UnityEngine_Texture_INTERNAL_CALL_GetNativeTexturePtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571772 | 0, fb + 3115 | 0);
 return;
}

function __Z62Register_UnityEngine_Terrain_ApplyDelayedHeightmapModificationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943701 | 0, fb + 3831 | 0);
 return;
}

function __Z62Register_UnityEngine_Screen_set_autorotateToPortraitUpsideDownv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534702 | 0, fb + 3569 | 0);
 return;
}

function __Z62Register_UnityEngine_SceneManagement_Scene_GetIsLoadedInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561179 | 0, fb + 1839 | 0);
 return;
}

function __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetCenterOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787032 | 0, fb + 3730 | 0);
 return;
}

function __Z62Register_UnityEngine_Renderer_INTERNAL_set_lightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526266 | 0, fb + 2888 | 0);
 return;
}

function __Z62Register_UnityEngine_Renderer_INTERNAL_get_lightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526211 | 0, fb + 2887 | 0);
 return;
}

function __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_set_linearOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820554 | 0, fb + 3888 | 0);
 return;
}

function __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_get_linearOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820499 | 0, fb + 3887 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_set_particleRaycastBudgetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522510 | 0, fb + 3541 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_set_asyncUploadBufferSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523629 | 0, fb + 3551 | 0);
 return;
}

function __Z62Register_UnityEngine_Physics2D_INTERNAL_set_colliderAwakeColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810695 | 0, fb + 3744 | 0);
 return;
}

function __Z62Register_UnityEngine_Physics2D_INTERNAL_get_colliderAwakeColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810640 | 0, fb + 3743 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_TrailModule_GetTextureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650097 | 0, fb + 2056 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638198 | 0, fb + 3348 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638088 | 0, fb + 3346 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 637978 | 0, fb + 3344 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638253 | 0, fb + 3349 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638143 | 0, fb + 3347 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 638033 | 0, fb + 3345 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640782 | 0, fb + 3365 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640340 | 0, fb + 3363 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640837 | 0, fb + 3366 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640395 | 0, fb + 2019 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_MainModule_SetMaxParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626689 | 0, fb + 3259 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_MainModule_GetMaxParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626744 | 0, fb + 1982 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetQualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643620 | 0, fb + 3387 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641794 | 0, fb + 3374 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetQualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 643675 | 0, fb + 2029 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641849 | 0, fb + 2022 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_set_pivotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654522 | 0, fb + 3449 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_get_pivotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654467 | 0, fb + 3448 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544133 | 0, fb + 2985 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544023 | 0, fb + 2984 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543913 | 0, fb + 2983 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_set_boundingBoxModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543375 | 0, fb + 2979 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544078 | 0, fb + 1778 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543968 | 0, fb + 1777 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543858 | 0, fb + 1776 | 0);
 return;
}

function __Z62Register_UnityEngine_LightProbeProxyVolume_get_boundingBoxModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543320 | 0, fb + 1772 | 0);
 return;
}

function __Z62Register_UnityEngine_LODGroup_INTERNAL_set_localReferencePointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540057 | 0, fb + 2954 | 0);
 return;
}

function __Z62Register_UnityEngine_LODGroup_INTERNAL_get_localReferencePointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540002 | 0, fb + 2953 | 0);
 return;
}

function __Z62Register_UnityEngine_Gyroscope_INTERNAL_CALL_attitude_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537041 | 0, fb + 2946 | 0);
 return;
}

function __Z62Register_UnityEngine_Experimental_Director_DirectorPlayer_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512080 | 0, fb + 3493 | 0);
 return;
}

function __Z62Register_UnityEngine_DistanceJoint2D_set_autoConfigureDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819155 | 0, fb + 3878 | 0);
 return;
}

function __Z62Register_UnityEngine_DistanceJoint2D_get_autoConfigureDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819100 | 0, fb + 2353 | 0);
 return;
}

function __Z62Register_UnityEngine_ConstantForce_INTERNAL_set_relativeTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794369 | 0, fb + 3797 | 0);
 return;
}

function __Z62Register_UnityEngine_ConstantForce_INTERNAL_get_relativeTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794314 | 0, fb + 3796 | 0);
 return;
}

function __Z62Register_UnityEngine_Connect_UnityConnectSettings_get_testModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043667 | 0, fb + 296 | 0);
 return;
}

function __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_set_slerpDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793447 | 0, fb + 3786 | 0);
 return;
}

function __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_get_slerpDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793392 | 0, fb + 3785 | 0);
 return;
}

function __Z62Register_UnityEngine_CharacterJoint_INTERNAL_set_lowTwistLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789939 | 0, fb + 3734 | 0);
 return;
}

function __Z62Register_UnityEngine_CharacterJoint_INTERNAL_get_lowTwistLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789884 | 0, fb + 3733 | 0);
 return;
}

function __Z62Register_UnityEngine_CharacterController_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796945 | 0, fb + 3818 | 0);
 return;
}

function __Z62Register_UnityEngine_Application_set_backgroundLoadingPriorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495368 | 0, fb + 3464 | 0);
 return;
}

function __Z62Register_UnityEngine_AI_NavMeshAgent_set_obstacleAvoidanceTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849728 | 0, fb + 4027 | 0);
 return;
}

function __Z62Register_UnityEngine_AI_NavMeshAgent_get_obstacleAvoidanceTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849673 | 0, fb + 2454 | 0);
 return;
}

function __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_nextPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847107 | 0, fb + 4011 | 0);
 return;
}

function __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_nextPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847052 | 0, fb + 4010 | 0);
 return;
}

function __Z61Register_UnityEngine_TextGenerator_get_fontSizeUsedForBestFitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011289 | 0, fb + 2678 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_set_rndVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050881 | 0, fb + 4441 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_get_rndVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050827 | 0, fb + 4440 | 0);
 return;
}

function __Z61Register_UnityEngine_Networking_UploadHandler_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1029322 | 0, fb + 3923 | 0);
 return;
}

function __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalBeginv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1031939 | 0, fb + 2745 | 0);
 return;
}

function __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalAbortv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1031993 | 0, fb + 3927 | 0);
 return;
}

function __Z61Register_UnityEngine_GUIClip_INTERNAL_CALL_Internal_Clip_Rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025940 | 0, fb + 3915 | 0);
 return;
}

function __Z61Register_UnityEngine_Connect_UnityConnectSettings_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043613 | 0, fb + 3947 | 0);
 return;
}

function __Z61Register_UnityEngine_Analytics_CustomEventData_InternalCreatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038154 | 0, fb + 4428 | 0);
 return;
}

function __Z44getPxVehicleAckermannGeometryDataMFrontWidthPKN5physx30PxVehicleAckermannGeometryDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z43Physics_Get_Custom_PropSleepAngularVelocityv() {
 return Math_fround(__ZN14PhysicsManager23GetSleepAngularVelocityEv(__Z17GetPhysicsManagerv() | 0));
}

function __Z43Physics_Get_Custom_PropDefaultContactOffsetv() {
 return Math_fround(__ZN14PhysicsManager23GetDefaultContactOffsetEv(__Z17GetPhysicsManagerv() | 0));
}

function __Z40setPxSimulationStatisticsNbDynamicBodiesPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __Z38setPxVehicleDriveDynDataMGearUpPressedPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 65 >> 0] = i1 & 1;
 return;
}

function __Z34setPxClothTetherConfigStretchLimitPN5physx19PxClothTetherConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z33setPxVehicleEngineDataMPeakTorquePN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 84 >> 2] = f1;
 return;
}

function __Z31setPxVehicleAutoBoxData_LatencyPN5physx20PxVehicleAutoBoxDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 128 >> 2] = f1;
 return;
}

function __Z31Object_CUSTOM_FindObjectsOfTypeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE(i1, 1) | 0;
}

function __Z30setPxJointLinearLimitPairUpperPN5physx22PxJointLinearLimitPairEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z30setPxJointLinearLimitPairLowerPN5physx22PxJointLinearLimitPairEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z25getNbPxArticulation_LinksPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 108 >> 2] | 0, i1 | 0) | 0;
}

function __Z24profiler_register_objectP6Object(i1) {
 i1 = i1 | 0;
 __ZN19MemoryProfilerStats14RegisterObjectEP6Object(HEAP32[gb + 1163248 >> 2] | 0, i1);
 return;
}

function __Z24getPxJoint_InvMassScale1PKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0));
}

function __Z24getPxJoint_InvMassScale0PKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0));
}

function __Z21SetupOddNegativeScaleR9GfxDeviceb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 + 608 >> 2] = i2 ? Math_fround(-1.0) : Math_fround(1.0);
 return;
}

function _Vertical_Sweep_Step(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = i1 + 148 | 0;
 HEAP32[i2 >> 2] = (HEAP32[i2 >> 2] | 0) + (HEAP16[i1 + 156 >> 1] | 0);
 return;
}

function _UNITY_tt_face_done_loca(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Stream_ReleaseFrame(HEAP32[i1 + 104 >> 2] | 0, i1 + 700 | 0);
 HEAP32[i1 + 696 >> 2] = 0;
 return;
}

function b23(i1, f2, f3, f4, f5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 nullFunc_viffff(23);
}

function __ZZN13BuildSettingsC1E10MemLabelId18ObjectCreationModeEN27initializedPreloadedPlugins7ForwardEv() {
 __Z33PluginsInitializePreloadedPluginsv();
 return;
}

function __ZThn340_N17BillboardRenderer15OnBoundsChangedEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + -68 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1 + -340 | 0);
 return;
}

function __ZNKSt3__28messagesIwE5closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNKSt3__28messagesIcE5closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_ii(HEAP32[i1 + 844 >> 2] | 0, i2 + 7936 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx3Ext14PrismaticJoint29getProjectionAngularToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 104 >> 2]);
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 + -4 | 0;
}

function __ZNK14PlayerSettings17GetStackTraceTypeE7LogType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 340 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = HEAP32[i1 + 8 >> 2] | 0;
 return i1 | 0;
}

function __ZN7Texture13SetAnisoLimitENS_20AnisotropicFilteringE(i1) {
 i1 = i1 | 0;
 __ZL21SetAnisoLimitEnumImplN7Texture20AnisotropicFilteringEb(i1, 0);
 return;
}

function __ZN7Joint2D15InitializeClassEv() {
 __Z41RegisterAllowNameConversionInDerivedTypesPKcS0_S0_(gb + 800807 | 0, gb + 806296 | 0, gb + 800723 | 0);
 return;
}

function __ZN5physx6shdfnd13ReadWriteLock12unlockReaderEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd15atomicDecrementEPVi((HEAP32[i1 >> 2] | 0) + 4 | 0) | 0;
 return;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore20returnStandaloneDataEPNS_15PxsParticleDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx2Cm8PtrTableC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP16[i1 + 4 >> 1] = 0;
 HEAP8[i1 + 6 >> 0] = 1;
 HEAP8[i1 + 7 >> 0] = 0;
 return;
}

function __ZN5physx22XmlMemoryAllocatorImplD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 142044 + 8;
 __ZN5physx19CVariableMemoryPoolD2Ev(i1 + 8 | 0);
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx16PxsBroadPhaseMBP12removeRegionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return __ZN3MBP15removeBoxPrunerEj(HEAP32[i2 + 84 >> 2] | 0, i1) | 0;
}

function __ZN5physx15NpParticleFluid25lockParticleFluidReadDataEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0;
}

function __ZN4FMOD8ChannelI17set3DConeSettingsEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 return 0;
}

function __ZN21LinearCollectionField24SetSizeFieldInListObjectEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] = i2;
 return;
}

function __ZN19CloudServiceHandler19StopEventDispatcherEv(i1) {
 i1 = i1 | 0;
 return __ZN11UnityEngine15CloudWebService14DataDispatcher4StopEv(i1 + 792 | 0) | 0;
}

function __ZN17PhysicsMaterial2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(.400000006);
 HEAPF32[i1 + 36 >> 2] = Math_fround(0.0);
 return;
}

function __ZN16MinMaxPolyCurves9IntegrateEv(i1) {
 i1 = i1 | 0;
 __ZN15PolynomialCurve9IntegrateEv(i1);
 __ZN15PolynomialCurve9IntegrateEv(i1 + 228 | 0);
 return;
}

function __ZN14ImageReference10FlipImageYEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 __ZN6prcore10FlipImageYER14ImageReference(i1);
 return;
}

function __ZN13GfxDeviceNullD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 77628 + 8;
 __ZN9GfxDevice16DeleteDynamicVBOEv(i1);
 __ZN9GfxDeviceD2Ev(i1);
 return;
}

function __ZN13GfxDeviceNull5ClearEjRK10ColorRGBAffj(i1, i2, i3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 return;
}

function __ZN12_GLOBAL__N_120DistanceJointProjectEPKvRN5physx11PxTransformES4_b(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_(i1, i2);
 return;
}

function __Z64Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSphereNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783445 | 0, fb + 1 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812988 | 0, fb + 2 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CircleCastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811733 | 0, fb + 1 | 0);
 return;
}

function __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812162 | 0, fb + 1 | 0);
 return;
}

function __Z63Register_UnityEngineInternal_GIDebugVisualisation_StopCycleModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513314 | 0, fb + 97 | 0);
 return;
}

function __Z63Register_UnityEngineInternal_GIDebugVisualisation_PlayCycleModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513201 | 0, fb + 95 | 0);
 return;
}

function __Z62Register_UnityEngine_TerrainData_Internal_GetMaximumResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 937767 | 0, fb + 257 | 0);
 return;
}

function __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_SetTreeInstancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940318 | 0, fb + 957 | 0);
 return;
}

function __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_GetTreeInstancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940263 | 0, fb + 956 | 0);
 return;
}

function __Z62Register_UnityEngine_Screen_get_autorotateToPortraitUpsideDownv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534647 | 0, fb + 155 | 0);
 return;
}

function __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785653 | 0, fb + 856 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_get_particleRaycastBudgetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522455 | 0, fb + 131 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_get_asyncUploadBufferSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523574 | 0, fb + 143 | 0);
 return;
}

function __Z62Register_UnityEngine_Profiling_Profiler_GetTotalReservedMemoryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554247 | 0, fb + 198 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_TrailModule_SetTextureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650042 | 0, fb + 286 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetDeathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645477 | 0, fb + 758 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetBirthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645249 | 0, fb + 756 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetDeathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645532 | 0, fb + 816 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetBirthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 645304 | 0, fb + 814 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640570 | 0, fb + 263 | 0);
 return;
}

function __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640625 | 0, fb + 320 | 0);
 return;
}

function __Z62Register_UnityEngine_Camera_INTERNAL_CALL_WorldToViewportPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506731 | 0, fb + 560 | 0);
 return;
}

function __Z62Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToWorldPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506786 | 0, fb + 561 | 0);
 return;
}

function __Z62Register_UnityEngine_AudioDistortionFilter_set_distortionLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891542 | 0, fb + 628 | 0);
 return;
}

function __Z62Register_UnityEngine_AudioDistortionFilter_get_distortionLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891487 | 0, fb + 718 | 0);
 return;
}

function __Z62Register_UnityEngine_AssetBundleManifest_GetDirectDependenciesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497147 | 0, fb + 617 | 0);
 return;
}

function __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591439 | 0, fb + 251 | 0);
 return;
}

function __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticFieldIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592517 | 0, fb + 256 | 0);
 return;
}

function __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallObjectMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592749 | 0, fb + 257 | 0);
 return;
}

function __Z62Register_UnityEngine_AI_OffMeshLinkData_GetOffMeshLinkInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852326 | 0, fb + 919 | 0);
 return;
}

function __Z61Register_UnityEngine_Terrain_INTERNAL_set_lightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942745 | 0, fb + 4182 | 0);
 return;
}

function __Z61Register_UnityEngine_Terrain_INTERNAL_get_lightmapScaleOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942691 | 0, fb + 4181 | 0);
 return;
}

function __Z61Register_UnityEngine_TerrainData_get_detailResolutionPerPatchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939812 | 0, fb + 2595 | 0);
 return;
}

function __Z61Register_UnityEngine_TerrainData_INTERNAL_set_wavingGrassTintv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939575 | 0, fb + 4165 | 0);
 return;
}

function __Z61Register_UnityEngine_TerrainData_INTERNAL_get_wavingGrassTintv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939521 | 0, fb + 4164 | 0);
 return;
}

function __Z61Register_UnityEngine_ShaderVariantCollection_get_variantCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567347 | 0, fb + 1866 | 0);
 return;
}

function __Z61Register_UnityEngine_SceneManagement_Scene_GetIsDirtyInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561293 | 0, fb + 1841 | 0);
 return;
}

function __Z61Register_UnityEngine_Rigidbody_INTERNAL_get_worldCenterOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786091 | 0, fb + 3690 | 0);
 return;
}

function __Z61Register_UnityEngine_Rigidbody2D_set_useFullKinematicContactsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814546 | 0, fb + 3848 | 0);
 return;
}

function __Z61Register_UnityEngine_Rigidbody2D_get_useFullKinematicContactsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814492 | 0, fb + 2326 | 0);
 return;
}

function __Z61Register_UnityEngine_Rendering_GraphicsSettings_SetShaderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558024 | 0, fb + 3051 | 0);
 return;
}

function __Z61Register_UnityEngine_Rendering_GraphicsSettings_GetShaderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558078 | 0, fb + 1831 | 0);
 return;
}

function __Z61Register_UnityEngine_Renderer_INTERNAL_get_worldToLocalMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525263 | 0, fb + 2874 | 0);
 return;
}

function __Z61Register_UnityEngine_Renderer_INTERNAL_get_localToWorldMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525317 | 0, fb + 2875 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderTexture_INTERNAL_CALL_GenerateMipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576063 | 0, fb + 3654 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_set_defaultReflectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520492 | 0, fb + 3525 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientProbev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519754 | 0, fb + 3521 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientLightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519548 | 0, fb + 3519 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientProbev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519700 | 0, fb + 3520 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientLightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519494 | 0, fb + 3518 | 0);
 return;
}

function __Z61Register_UnityEngine_QualitySettings_set_asyncUploadTimeSlicev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523520 | 0, fb + 3550 | 0);
 return;
}

function __Z61Register_UnityEngine_QualitySettings_set_anisotropicFilteringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522221 | 0, fb + 3539 | 0);
 return;
}

function __Z61Register_UnityEngine_PlatformEffector2D_set_useOneWayGroupingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825646 | 0, fb + 3920 | 0);
 return;
}

function __Z61Register_UnityEngine_PlatformEffector2D_get_useOneWayGroupingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825592 | 0, fb + 2376 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_set_colliderAABBColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811030 | 0, fb + 3750 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_get_colliderAABBColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810976 | 0, fb + 3749 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_TrailModule_SetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650152 | 0, fb + 3422 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_TrailModule_GetWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 650206 | 0, fb + 2057 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_SetStartSize3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623953 | 0, fb + 3237 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_SetScalingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626473 | 0, fb + 3257 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_SetPlayOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626581 | 0, fb + 3258 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_GetStartSize3Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624007 | 0, fb + 1976 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_GetScalingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626527 | 0, fb + 1980 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_MainModule_GetPlayOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626635 | 0, fb + 1981 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetMaxLightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649384 | 0, fb + 3418 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649148 | 0, fb + 3416 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetMaxLightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649438 | 0, fb + 2054 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649202 | 0, fb + 3417 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_EmissionModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626799 | 0, fb + 3260 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_EmissionModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 626853 | 0, fb + 1983 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642112 | 0, fb + 3377 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642348 | 0, fb + 3379 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642166 | 0, fb + 3378 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642402 | 0, fb + 3380 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystemRenderer_set_trailMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655299 | 0, fb + 3452 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystemRenderer_get_trailMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655245 | 0, fb + 2083 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleRenderer_set_cameraVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052960 | 0, fb + 713 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleRenderer_get_cameraVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052906 | 0, fb + 815 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleEmitter_set_emitterVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050549 | 0, fb + 705 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleEmitter_get_emitterVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050495 | 0, fb + 808 | 0);
 return;
}

function __Z61Register_UnityEngine_MeshRenderer_set_additionalVertexStreamsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536406 | 0, fb + 2940 | 0);
 return;
}

function __Z61Register_UnityEngine_MeshRenderer_get_additionalVertexStreamsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536352 | 0, fb + 1735 | 0);
 return;
}

function __Z61Register_UnityEngine_LightmapSettings_set_lightmapsModeLegacyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533825 | 0, fb + 3563 | 0);
 return;
}

function __Z61Register_UnityEngine_LightProbeProxyVolume_set_resolutionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543484 | 0, fb + 2980 | 0);
 return;
}

function __Z61Register_UnityEngine_LightProbeProxyVolume_get_resolutionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543430 | 0, fb + 1773 | 0);
 return;
}

function __Z61Register_UnityEngine_Input_INTERNAL_CALL_GetAccelerationEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538803 | 0, fb + 2951 | 0);
 return;
}

function __Z61Register_UnityEngine_Gyroscope_INTERNAL_CALL_gravity_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536924 | 0, fb + 2944 | 0);
 return;
}

function __Z61Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetRTv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533202 | 0, fb + 2934 | 0);
 return;
}

function __Z61Register_UnityEngine_ConstantForce_INTERNAL_set_relativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794166 | 0, fb + 3793 | 0);
 return;
}

function __Z61Register_UnityEngine_ConstantForce_INTERNAL_get_relativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794112 | 0, fb + 3792 | 0);
 return;
}

function __Z61Register_UnityEngine_Connect_UnityConnectSettings_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043559 | 0, fb + 295 | 0);
 return;
}

function __Z61Register_UnityEngine_Cloth_INTERNAL_CALL_ClearTransformMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841166 | 0, fb + 3767 | 0);
 return;
}

function __Z61Register_UnityEngine_CharacterController_set_detectCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797674 | 0, fb + 3821 | 0);
 return;
}

function __Z61Register_UnityEngine_CharacterController_get_detectCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797620 | 0, fb + 2320 | 0);
 return;
}

function __Z61Register_UnityEngine_Camera_set_clearStencilAfterLightingPassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508184 | 0, fb + 2811 | 0);
 return;
}

function __Z61Register_UnityEngine_Camera_get_clearStencilAfterLightingPassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508130 | 0, fb + 1645 | 0);
 return;
}

function __Z61Register_UnityEngine_BillboardAsset_GetImageTexCoordsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501033 | 0, fb + 2765 | 0);
 return;
}

function __Z61Register_UnityEngine_AudioLowPassFilter_set_customCutoffCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891107 | 0, fb + 4072 | 0);
 return;
}

function __Z61Register_UnityEngine_AudioLowPassFilter_get_customCutoffCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891053 | 0, fb + 2513 | 0);
 return;
}

function __Z61Register_UnityEngine_AssetBundleCreateRequest_get_assetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496038 | 0, fb + 1589 | 0);
 return;
}

function __Z61Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewBooleanArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596195 | 0, fb + 3188 | 0);
 return;
}

function __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851133 | 0, fb + 4031 | 0);
 return;
}

function __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851079 | 0, fb + 4030 | 0);
 return;
}

function __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_destinationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846796 | 0, fb + 4007 | 0);
 return;
}

function __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_destinationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846742 | 0, fb + 4006 | 0);
 return;
}

function __Z61Register_UnityEngineInternal_GIDebugVisualisation_set_texTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513541 | 0, fb + 3496 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleRenderer_set_particleRenderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052665 | 0, fb + 4459 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleRenderer_get_particleRenderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052612 | 0, fb + 2778 | 0);
 return;
}

function __Z60Register_UnityEngine_GUIUtility_SetDidGUIWindowsEatLastEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025075 | 0, fb + 3906 | 0);
 return;
}

function __Z60Register_UnityEngine_GUIStyle_Internal_DrawWithTextSelectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023972 | 0, fb + 4302 | 0);
 return;
}

function __Z56getPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z49getPxVehicleSuspensionDataMCamberAtMaxCompressionPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z48SystemInfo_Get_Custom_PropDeviceUniqueIdentifierv() {
 return __Z20scripting_string_newPKc(__ZN10systeminfo25GetDeviceUniqueIdentifierEv() | 0) | 0;
}

function __Z44setPxSimulationStatisticsNbActiveConstraintsPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z43getPxVehicleAckermannGeometryDataMRearWidthPKN5physx30PxVehicleAckermannGeometryDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z41UnityAdsSettings_CUSTOM_IsPlatformEnabledi(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__Z19GetUnityAdsSettingsv() | 0) + 12 >> 2] & 1 << i1 | 0) != 0 | 0;
}

function __Z41QualitySettings_Set_Custom_PropVSyncCounti(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings13SetVSyncCountEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z40setPxSceneDescContactCorrelationDistancePN5physx11PxSceneDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 88 >> 2] = f1;
 return;
}

function __Z39setPxSimulationStatisticsNbStaticBodiesPN5physx22PxSimulationStatisticsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __Z38GUIStyle_CUSTOM_Internal_GetLineHeight13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK8GUIStyle13GetLineHeightEv(HEAP32[i1 >> 2] | 0));
}

function __Z37setPxVehicleDriveDynData_UseAutoGearsPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 64 >> 0] = i1 & 1;
 return;
}

function __Z37setPxVehicleDriveDynDataMUseAutoGearsPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 64 >> 0] = i1 & 1;
 return;
}

function __Z36Light_Set_Custom_PropPixelLightCounti(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettings18SetPixelLightCountEi(__Z18GetQualitySettingsv() | 0, i1);
 return;
}

function __Z33setPxVehicleWheelDataMDampingRatePN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 16 >> 2] = f1;
 return;
}

function __Z32setPxVehicleGearsDataMSwitchTimePN5physx18PxVehicleGearsDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 136 >> 2] = f1;
 return;
}

function __Z32setPxVehicleGearsDataMFinalRatioPN5physx18PxVehicleGearsDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 128 >> 2] = f1;
 return;
}

function __Z32getPxScene_ContactModifyCallbackPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 180 >> 2] | 0, i1 | 0) | 0;
}

function __Z31Profiler_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 __ZN13UnityProfiler10SetEnabledEb(HEAP32[gb + 1451e3 >> 2] | 0, i1 << 24 >> 24 != 0);
 return;
}

function __Z30getPxMaterial_ConcreteTypeNamePKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z28getPxAggregate_SelfCollisionPKN5physx11PxAggregateE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
}

function __Z28Display_CUSTOM_SetParamsImpl13Il2Cpp_IntPtriiii(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function __Z27scripting_array_element_ptrP11Il2CppArrayij(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i1 + ((Math_imul(i3, i2) | 0) + 16) | 0;
}

function __Z27UnityWebRequestJobSchedulerPFvPvES_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __Z26setPxSceneDescFrictionTypePN5physx11PxSceneDescENS_14PxFrictionType4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 84 >> 2] = i1;
 return;
}

function __Z25GetShouldShowSplashScreenv() {
 return __ZNK26PlayerSettingsSplashScreen24GetShowUnitySplashScreenEv((__Z17GetPlayerSettingsv() | 0) + 144 | 0) | 0;
}

function __Z23Gradient_CUSTOM_CleanupP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = HEAP32[i1 + 8 >> 2] | 0;
 if (!i1) return;
 __ZdlPv(i1);
 return;
}

function __Z22getPxCloth_WakeCounterPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 464 >> 2] | 0, i1 | 0));
}

function __Z19CollectWorldObjectsR13dynamic_arrayIiLj4EEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE(i1);
 return;
}

function __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 1;
}

function __Z15PluginsGetCountv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1162584 >> 2] | 0;
 return ((HEAP32[i1 + 4 >> 2] | 0) - (HEAP32[i1 >> 2] | 0) | 0) / 24 | 0 | 0;
}

function _UNITY_png_chunk_benign_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 208 >> 2] & 1048576)) _UNITY_png_chunk_error(i1, i2); else return;
}

function _UNITY_FT_Init_Class_cff_service_glyph_dict(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 188;
 HEAP32[i2 + 4 >> 2] = fb + 1087;
 return;
}

function _UNITY_FT_Destroy_Class_cff_field_handlers(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function _emscripten_glTexParameterf__wrapper(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 _emscripten_glTexParameterf(i1 | 0, i2 | 0, +f3);
}

function _cargf(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 + 4 >> 2]);
 return Math_fround(+Math_atan2(+f2, +Math_fround(HEAPF32[i1 >> 2])));
}

function ___cxa_bad_cast() {
 var i1 = 0;
 i1 = ___cxa_allocate_exception(4) | 0;
 __ZNSt8bad_castC2Ev(i1);
 ___cxa_throw(i1 | 0, gb + 13256 | 0, fb + 3017 | 0);
}

function __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 return;
}

function __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 return;
}

function __ZNKSt3__212ctype_bynameIcE10do_toupperEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_toupper_l(i2 & 255, HEAP32[i1 + 16 >> 2] | 0) | 0) & 255 | 0;
}

function __ZNKSt3__212ctype_bynameIcE10do_tolowerEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_tolower_l(i2 & 255, HEAP32[i1 + 16 >> 2] | 0) | 0) & 255 | 0;
}

function __ZNK5physx7NpScene29getMaxNbContactDataBlocksUsedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene29getMaxNbContactDataBlocksUsedEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx3Ext14SphericalJoint28getProjectionLinearToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 112 >> 2]);
}

function __ZNK5physx3Ext14PrismaticJoint28getProjectionLinearToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 100 >> 2]);
}

function __ZNK5physx3Ext13RevoluteJoint29getProjectionAngularToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 128 >> 2]);
}

function __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK5physx13NpClothFabric20getNbParticleIndicesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore20getNbParticleIndicesEv(i1 + 16 | 0) | 0;
}

function __ZNK26PlayerSettingsSplashScreen22CanDisableSplashScreenEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0) != 0 | 0;
}

function __ZNK25BlendshapePropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK15b2RevoluteJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * f2);
}

function __ZNK15b2FrictionJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 92 >> 2]) * f2);
}

function __ZNK11AudioSource9GetSpreadEv(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_fround(HEAPF32[(HEAP32[i1 + 268 >> 2] | 0) + 4 >> 2]) * Math_fround(360.0));
}

function __ZN9ProjectorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN9LensFlareD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN9HaloLayerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN9GfxDevice15CreateTextureIDEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 39048 >> 2] = (HEAP32[gb + 39048 >> 2] | 0) + 1;
 return HEAP32[gb + 39048 >> 2] | 0;
}

function __ZN8VRDevice19CleanupGfxResourcesEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 299 >> 0] | 0)) return;
 __ZN8VRDevice21StopRenderingToDeviceEv(i1);
 return;
}

function __ZN6Camera24ResetWorldToCameraMatrixEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1080 >> 0] = 1;
 HEAP8[i1 + 1076 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx2Sq12BucketPruner11preallocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq11PruningPool11preallocateEj(i2 + 7616 | 0, i1);
 return;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN5physx14PxVehicleGraph24clearRecordedChannelDataEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 15824 >> 2] = 0;
 _memset(i1 + 3504 | 0, 0, 12288) | 0;
 return;
}

function __ZN5Umbra5FloatpLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) + f2);
 return i1 | 0;
}

function __ZN5Umbra5FloatmLEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) * f2);
 return i1 | 0;
}

function __ZN5Umbra5FloatmIEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) - f2);
 return i1 | 0;
}

function __ZN5Umbra5FloatdVEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 >> 2] = Math_fround(Math_fround(HEAPF32[i1 >> 2]) / f2);
 return i1 | 0;
}

function __ZN5Umbra10Visibility19setOutputObjectMaskEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 24 >> 2] = i2;
 return;
}

function __ZN5Umbra10PortalInfoC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(((i1 | 0) == 0 ? 0 : i1 + 3 & -4) | 0, i2 + 3 & -4 | 0, 145) | 0;
 return;
}

function __ZN4gles18GetFramebufferGLESEv() {
 return __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[(__Z25GetUncheckedRealGfxDevicev() | 0) + 4616 >> 2] | 0) | 0;
}

function __ZN28ApplyBuiltinInstanceProperty4InitER9GfxDevice(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 HEAP32[i1 >> 2] = i2 + 4;
 return;
}

function __ZN23ControllerContactFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 2;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE21PageAllocationElementC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED0Ev(i1) {
 i1 = i1 | 0;
 __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17FileSystemHandler10AtomicMoveER13FileEntryDataS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN14ParticleSystem18SetSimulationSpeedEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 36 >> 2] | 0) + 268 >> 2] = f2;
 return;
}

function __ZN11AudioModule14SetBypassOnDSPEPN4FMOD3DSPEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN4FMOD3DSP9setBypassEb(i2, i3) | 0;
 return;
}

function __ZN10AtomicList5ResetEP10AtomicNodei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = i2;
 HEAP32[i1 + 4 >> 2] = i3;
 return;
}

function __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_RaycastTestv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784433 | 0, fb + 6 | 0);
 return;
}

function __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_CapsuleCastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784377 | 0, fb + 2 | 0);
 return;
}

function __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812831 | 0, fb + 1 | 0);
 return;
}

function __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811841 | 0, fb + 1 | 0);
 return;
}

function __Z62Register_UnityEngine_WheelJoint2D_INTERNAL_CALL_GetMotorTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822614 | 0, fb + 17 | 0);
 return;
}

function __Z62Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundLocalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579242 | 0, fb + 50 | 0);
 return;
}

function __Z62Register_UnityEngine_SystemInfo_get_supportedRenderTargetCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499269 | 0, fb + 70 | 0);
 return;
}

function __Z62Register_UnityEngine_SliderJoint2D_INTERNAL_CALL_GetMotorForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821452 | 0, fb + 16 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_set_shadowNearPlaneOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521778 | 0, fb + 12 | 0);
 return;
}

function __Z62Register_UnityEngine_QualitySettings_get_shadowNearPlaneOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521723 | 0, fb + 12 | 0);
 return;
}

function __Z62Register_UnityEngine_HingeJoint2D_INTERNAL_CALL_GetMotorTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820070 | 0, fb + 15 | 0);
 return;
}

function __Z62Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_SqrDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545746 | 0, fb + 14 | 0);
 return;
}

function __Z62Register_UnityEngine_Application_get_backgroundLoadingPriorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495313 | 0, fb + 34 | 0);
 return;
}

function __Z61Register_UnityEngine_Texture2D_LoadRawTextureData_ImplPointerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572448 | 0, fb + 672 | 0);
 return;
}

function __Z61Register_UnityEngine_TerrainData_Internal_SetDetailResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939712 | 0, fb + 955 | 0);
 return;
}

function __Z61Register_UnityEngine_ShaderVariantCollection_ContainsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567502 | 0, fb + 153 | 0);
 return;
}

function __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetPointVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785939 | 0, fb + 859 | 0);
 return;
}

function __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785552 | 0, fb + 854 | 0);
 return;
}

function __Z61Register_UnityEngine_RenderSettings_get_defaultReflectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520438 | 0, fb + 116 | 0);
 return;
}

function __Z61Register_UnityEngine_QualitySettings_get_asyncUploadTimeSlicev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523466 | 0, fb + 142 | 0);
 return;
}

function __Z61Register_UnityEngine_QualitySettings_get_anisotropicFilteringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522167 | 0, fb + 129 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783900 | 0, fb + 136 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_TriggerModule_SetColliderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644899 | 0, fb + 755 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystem_TriggerModule_GetColliderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644953 | 0, fb + 813 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystemRenderer_set_velocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654081 | 0, fb + 297 | 0);
 return;
}

function __Z61Register_UnityEngine_ParticleSystemRenderer_get_velocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654027 | 0, fb + 354 | 0);
 return;
}

function __Z61Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531656 | 0, fb + 609 | 0);
 return;
}

function __Z61Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531768 | 0, fb + 611 | 0);
 return;
}

function __Z61Register_UnityEngine_LightmapSettings_get_lightmapsModeLegacyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533771 | 0, fb + 147 | 0);
 return;
}

function __Z61Register_UnityEngine_GameObject_Internal_AddComponentWithTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515971 | 0, fb + 637 | 0);
 return;
}

function __Z61Register_UnityEngine_GUISettings_Internal_GetCursorFlashSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021745 | 0, fb + 52 | 0);
 return;
}

function __Z61Register_UnityEngine_ConfigurableJoint_set_projectionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793656 | 0, fb + 440 | 0);
 return;
}

function __Z61Register_UnityEngine_ConfigurableJoint_get_projectionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793602 | 0, fb + 509 | 0);
 return;
}

function __Z61Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506118 | 0, fb + 555 | 0);
 return;
}

function __Z61Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoViewMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505928 | 0, fb + 553 | 0);
 return;
}

function __Z61Register_UnityEngine_AudioLowPassFilter_set_lowpassResonanceQv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891215 | 0, fb + 625 | 0);
 return;
}

function __Z61Register_UnityEngine_AudioLowPassFilter_get_lowpassResonanceQv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891161 | 0, fb + 715 | 0);
 return;
}

function __Z61Register_UnityEngine_Animator_GetCurrentAnimatorClipInfoCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921441 | 0, fb + 963 | 0);
 return;
}

function __Z61Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_FindClosestEdgev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850191 | 0, fb + 427 | 0);
 return;
}

function __Z61Register_UnityEngineInternal_GIDebugVisualisation_get_texTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513487 | 0, fb + 109 | 0);
 return;
}

function __Z60Register_UnityEngine_TerrainData_INTERNAL_get_heightmapScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938619 | 0, fb + 4160 | 0);
 return;
}

function __Z60Register_UnityEngine_Sprites_DataUtility_Internal_GetMinSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 570019 | 0, fb + 3109 | 0);
 return;
}

function __Z60Register_UnityEngine_SpringJoint2D_set_autoConfigureDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818797 | 0, fb + 3877 | 0);
 return;
}

function __Z60Register_UnityEngine_SpringJoint2D_get_autoConfigureDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818744 | 0, fb + 2352 | 0);
 return;
}

function __Z60Register_UnityEngine_ShaderVariantCollection_get_shaderCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567294 | 0, fb + 1865 | 0);
 return;
}

function __Z60Register_UnityEngine_ShaderVariantCollection_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567241 | 0, fb + 3643 | 0);
 return;
}

function __Z60Register_UnityEngine_ScriptableObject_CreateInstanceFromTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500198 | 0, fb + 1604 | 0);
 return;
}

function __Z60Register_UnityEngine_Rendering_CommandBuffer_get_sizeInBytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558718 | 0, fb + 1834 | 0);
 return;
}

function __Z60Register_UnityEngine_Renderer_set_motionVectorGenerationModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526374 | 0, fb + 2889 | 0);
 return;
}

function __Z60Register_UnityEngine_Renderer_get_motionVectorGenerationModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526321 | 0, fb + 1701 | 0);
 return;
}

function __Z60Register_UnityEngine_RenderTexture_Internal_SetSRGBReadWritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574717 | 0, fb + 3122 | 0);
 return;
}

function __Z60Register_UnityEngine_RelativeJoint2D_set_autoConfigureOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820446 | 0, fb + 3886 | 0);
 return;
}

function __Z60Register_UnityEngine_RelativeJoint2D_get_autoConfigureOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820393 | 0, fb + 2358 | 0);
 return;
}

function __Z60Register_UnityEngine_Profiling_Profiler_GetRuntimeMemorySizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553866 | 0, fb + 1811 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetOutsidev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644477 | 0, fb + 3391 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644267 | 0, fb + 3389 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetOutsidev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644530 | 0, fb + 2034 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644320 | 0, fb + 2032 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetShapeTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627700 | 0, fb + 3266 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetShapeTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627753 | 0, fb + 1986 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639648 | 0, fb + 3360 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639542 | 0, fb + 3358 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639436 | 0, fb + 3356 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639701 | 0, fb + 3361 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639595 | 0, fb + 3359 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639489 | 0, fb + 3357 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623721 | 0, fb + 3235 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624525 | 0, fb + 3242 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624293 | 0, fb + 3240 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624061 | 0, fb + 3238 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623245 | 0, fb + 3231 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625755 | 0, fb + 3251 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623774 | 0, fb + 3236 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624578 | 0, fb + 3243 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624346 | 0, fb + 3241 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 624114 | 0, fb + 3239 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623298 | 0, fb + 3232 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 625808 | 0, fb + 3252 | 0);
 return;
}

function __Z60Register_UnityEngine_Object_FindObjectsOfTypeIncludingAssetsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580171 | 0, fb + 1938 | 0);
 return;
}

function __Z60Register_UnityEngine_Mesh_PrintErrorCantAccessMeshForIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547587 | 0, fb + 3606 | 0);
 return;
}

function __Z60Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexTrianglesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547640 | 0, fb + 3607 | 0);
 return;
}

function __Z60Register_UnityEngine_Input_INTERNAL_set_compositionCursorPosv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539547 | 0, fb + 3598 | 0);
 return;
}

function __Z60Register_UnityEngine_Input_INTERNAL_get_compositionCursorPosv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539494 | 0, fb + 3597 | 0);
 return;
}

function __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetStyleStatePtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022282 | 0, fb + 988 | 0);
 return;
}

function __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetRectOffsetPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022374 | 0, fb + 990 | 0);
 return;
}

function __Z60Register_UnityEngine_ConfigurableJoint_set_rotationDriveModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793105 | 0, fb + 3780 | 0);
 return;
}

function __Z60Register_UnityEngine_ConfigurableJoint_get_rotationDriveModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793052 | 0, fb + 2303 | 0);
 return;
}

function __Z60Register_UnityEngine_Cloth_INTERNAL_set_externalAccelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840418 | 0, fb + 3988 | 0);
 return;
}

function __Z60Register_UnityEngine_Cloth_INTERNAL_get_externalAccelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840365 | 0, fb + 3987 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing2Limitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790265 | 0, fb + 3740 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing1Limitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790159 | 0, fb + 3738 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing2Limitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790212 | 0, fb + 3739 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing1Limitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790106 | 0, fb + 3737 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterController_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797281 | 0, fb + 3820 | 0);
 return;
}

function __Z60Register_UnityEngine_CharacterController_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797228 | 0, fb + 3819 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_set_worldToCameraMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504781 | 0, fb + 2792 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_get_worldToCameraMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504728 | 0, fb + 2791 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_get_cameraToWorldMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504675 | 0, fb + 2790 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ResetCullingMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507624 | 0, fb + 3481 | 0);
 return;
}

function __Z60Register_UnityEngine_Audio_AudioMixerSnapshot_get_audioMixerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894810 | 0, fb + 2518 | 0);
 return;
}

function __Z60Register_UnityEngine_AsyncOperation_set_allowSceneActivationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497658 | 0, fb + 2762 | 0);
 return;
}

function __Z60Register_UnityEngine_AsyncOperation_get_allowSceneActivationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497605 | 0, fb + 1600 | 0);
 return;
}

function __Z60Register_UnityEngine_AnimationClip_INTERNAL_CALL_ClearCurvesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915759 | 0, fb + 3809 | 0);
 return;
}

function __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToBooleanArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595348 | 0, fb + 3180 | 0);
 return;
}

function __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewDoubleArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596556 | 0, fb + 3195 | 0);
 return;
}

function __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectClassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592272 | 0, fb + 3178 | 0);
 return;
}

function __Z60Register_UnityEngine_AI_NavMeshPath_CalculateCornersInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852185 | 0, fb + 2462 | 0);
 return;
}

function __Z59Register_UnityEngine_VR_VRDevice_INTERNAL_CALL_GetNativePtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045937 | 0, fb + 3956 | 0);
 return;
}

function __Z59Register_UnityEngine_TextGenerator_INTERNAL_get_rectExtentsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010836 | 0, fb + 4233 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_set_rndForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052186 | 0, fb + 4454 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_get_rndForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052134 | 0, fb + 4453 | 0);
 return;
}

function __Z59Register_UnityEngine_Networking_UnityWebRequest_get_isErrorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032852 | 0, fb + 2755 | 0);
 return;
}

function __Z58getPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 872 >> 2] | 0;
}

function __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx2Minusx1PKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx1Minusx0PKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __Z50Texture_CUSTOM_SetGlobalAnisotropicFilteringLimitsii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7Texture20SetGlobalAnisoLimitsEii(i1, i2);
 return;
}

function __Z40setPxParticleReadDataValidParticleBitmapPN5physx18PxParticleReadDataEPKj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __Z37scripting_profiler_install_allocationPFvPvP12Il2CppObjectP11Il2CppClassE(i1) {
 i1 = i1 | 0;
 _il2cpp_profiler_install_allocation(i1 | 0);
 return;
}

function __Z32Compass_Get_Custom_PropTimestampP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[(__ZN15LocationService14GetLastHeadingEv() | 0) + 24 >> 3]);
}

function __Z32AndroidJNI_CUSTOM_CallLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 setTempRet0(0);
 return 0;
}

function __Z31setPxVehicleEngineDataMMaxOmegaPN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 88 >> 2] = f1;
 return;
}

function __Z31getPxScene_FilterShaderDataSizePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 200 >> 2] | 0, i1 | 0) | 0;
}

function __Z28getPxMaterial_ReferenceCountPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __Z27setPxSceneDescSpuDispatcherPN5physx11PxSceneDescEPNS_15PxSpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 112 >> 2] = i1;
 return;
}

function __Z27setPxSceneDescGpuDispatcherPN5physx11PxSceneDescEPNS_15PxGpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 108 >> 2] = i1;
 return;
}

function __Z27setPxSceneDescCpuDispatcherPN5physx11PxSceneDescEPNS_15PxCpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 104 >> 2] = i1;
 return;
}

function __Z25getNbPxClothFabric_PhasesPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxShape_RestOffsetPKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0));
}

function __Z21getPxCloth_RestOffsetPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 448 >> 2] | 0, i1 | 0));
}

function _UNITY_tt_get_cmap_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 48 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function _finitef(f1) {
 f1 = Math_fround(f1);
 return ((HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040 | 0;
}

function __ZNSt3__211char_traitsIwE4moveEPwPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3) i1 = _wmemmove(i1, i2, i3) | 0;
 return i1 | 0;
}

function __ZNSt13runtime_erroraSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__218__libcpp_refstringaSERKS0_(i1 + 4 | 0, i2 + 4 | 0) | 0;
 return i1 | 0;
}

function __ZNK8WWWAudio6IsDoneEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 4 >> 2] | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK6Object20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 return __ZN14MemoryProfiler20GetRelatedMemorySizeEPKv(HEAP32[gb + 1163236 >> 2] | 0, i1) | 0;
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx3Ext13RevoluteJoint28getProjectionLinearToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 124 >> 2]);
}

function __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75648 + (i2 << 2) >> 2] | 0;
}

function __ZN9GfxDevice29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8WindZoneD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN8GUILayerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN7Texture8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_(i1, i2);
 return;
}

function __ZN6detail13OffsetPointerIfEC2EPKfj(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i3 >> 2] = i2;
 HEAP32[i3 + 4 >> 2] = i1;
 return;
}

function __ZN5physx2Sq17SceneQueryManager30blockingSPURaycastOverlapSweepEPNS_12NpBatchQueryEPb(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN4FMOD8ChannelI17get3DDopplerLevelEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 148 >> 2];
 return 0;
}

function __ZN23ControllerContactFilter27setCharacterControllerShapeEPKN5physx7PxShapeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN17ParticleLightNodeD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 33936 + 8;
 __ZN19RenderEventsContextD2Ev(i1 + 208 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN15dtPathQueryInfo11setAgentIdxEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (!i1) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN14SphereCollider22FetchPoseFromTransformEv(i1) {
 i1 = i1 | 0;
 __ZN8Collider29FetchPoseFromTransformUtilityERK8Vector3f(i1, i1 + 64 | 0);
 return;
}

function __ZN14GfxDeviceStats15BeginFrameStatsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 280 >> 0] = 1;
 HEAPF64[i1 + 264 >> 3] = +__Z19GetTimeSinceStartupv();
 return;
}

function __ZN13ScreenManager22SetResolutionImmediateEiibi(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN13MemoryManager23StartLoggingAllocationsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 1548 >> 0] = 1;
 HEAP32[i1 + 3816 >> 2] = i2;
 return;
}

function __ZN11NavMeshData17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager9PurgeDataEPK11NavMeshData(HEAP32[gb + 1459032 >> 2] | 0, i1);
 return;
}

function __ZL23StereoDisplayInitializeR34UnityVRDeviceSpecificConfiguration(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 156 >> 0] = 1;
 HEAP8[i1 + 157 >> 0] = 1;
 return 1;
}

function __Z7b2Alloci(i1) {
 i1 = i1 | 0;
 return __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci(i1, 16, gb + 63408 | 0, 0, gb + 797846 | 0, 32) | 0;
}

function __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddExplosionForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785764 | 0, fb + 1 | 0);
 return;
}

function __Z62Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783660 | 0, fb + 1 | 0);
 return;
}

function __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813097 | 0, fb + 3 | 0);
 return;
}

function __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Linecastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811420 | 0, fb + 1 | 0);
 return;
}

function __Z61Register_UnityEngine_Animator_SetIKHintPositionWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920736 | 0, fb + 71 | 0);
 return;
}

function __Z60Register_UnityEngine_WheelCollider_set_forceAppPointDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836529 | 0, fb + 569 | 0);
 return;
}

function __Z60Register_UnityEngine_WheelCollider_get_forceAppPointDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836476 | 0, fb + 656 | 0);
 return;
}

function __Z60Register_UnityEngine_Transform_INTERNAL_CALL_TransformVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578517 | 0, fb + 687 | 0);
 return;
}

function __Z60Register_UnityEngine_TerrainData_Internal_SetHeightsDelayLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939044 | 0, fb + 193 | 0);
 return;
}

function __Z60Register_UnityEngine_SortingLayer_GetSortingLayerIDsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567695 | 0, fb + 209 | 0);
 return;
}

function __Z60Register_UnityEngine_Rendering_CommandBuffer_SetGlobalBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560309 | 0, fb + 642 | 0);
 return;
}

function __Z60Register_UnityEngine_Rendering_CommandBuffer_Blit_Identifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559398 | 0, fb + 133 | 0);
 return;
}

function __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_FromToRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544768 | 0, fb + 623 | 0);
 return;
}

function __Z60Register_UnityEngine_Profiling_Profiler_GetTempAllocatorSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554077 | 0, fb + 195 | 0);
 return;
}

function __Z60Register_UnityEngine_PlatformEffector2D_set_rotationalOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826139 | 0, fb + 507 | 0);
 return;
}

function __Z60Register_UnityEngine_PlatformEffector2D_get_rotationalOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826086 | 0, fb + 586 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629536 | 0, fb + 231 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629589 | 0, fb + 288 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640132 | 0, fb + 261 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640185 | 0, fb + 318 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_EmissionModule_SetBurstsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627492 | 0, fb + 753 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627545 | 0, fb + 811 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_CollisionModule_SetPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644100 | 0, fb + 754 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystem_CollisionModule_GetPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644153 | 0, fb + 812 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystemRenderer_set_sortingFudgev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654728 | 0, fb + 300 | 0);
 return;
}

function __Z60Register_UnityEngine_ParticleSystemRenderer_get_sortingFudgev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654675 | 0, fb + 357 | 0);
 return;
}

function __Z60Register_UnityEngine_Material_INTERNAL_CALL_SetTextureOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565370 | 0, fb + 650 | 0);
 return;
}

function __Z60Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531546 | 0, fb + 607 | 0);
 return;
}

function __Z60Register_UnityEngine_GL_INTERNAL_CALL_GetGPUProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535834 | 0, fb + 619 | 0);
 return;
}

function __Z60Register_UnityEngine_ComputeShader_Internal_DispatchIndirectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509678 | 0, fb + 230 | 0);
 return;
}

function __Z60Register_UnityEngine_ComputeShader_GetKernelThreadGroupSizesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509255 | 0, fb + 119 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_CALL_WorldToScreenPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506678 | 0, fb + 559 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ViewportPointToRayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507006 | 0, fb + 565 | 0);
 return;
}

function __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToWorldPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506841 | 0, fb + 562 | 0);
 return;
}

function __Z60Register_UnityEngine_AudioHighPassFilter_set_cutoffFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891322 | 0, fb + 626 | 0);
 return;
}

function __Z60Register_UnityEngine_AudioHighPassFilter_get_cutoffFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891269 | 0, fb + 716 | 0);
 return;
}

function __Z60Register_UnityEngine_Animator_IsParameterControlledByCurveIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924053 | 0, fb + 976 | 0);
 return;
}

function __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596609 | 0, fb + 261 | 0);
 return;
}

function __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593200 | 0, fb + 698 | 0);
 return;
}

function __Z59Register_UnityEngine_WebGLInput_set_captureAllKeyboardInputv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597536 | 0, fb + 3676 | 0);
 return;
}

function __Z59Register_UnityEngine_Texture2D_LoadRawTextureData_ImplArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572396 | 0, fb + 3117 | 0);
 return;
}

function __Z59Register_UnityEngine_TerrainData_UpgradeScaledTreePrototypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940707 | 0, fb + 3829 | 0);
 return;
}

function __Z59Register_UnityEngine_SystemInfo_SupportsRenderTextureFormatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499416 | 0, fb + 1601 | 0);
 return;
}

function __Z59Register_UnityEngine_Sprite_get_associatedAlphaSplitTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568984 | 0, fb + 1874 | 0);
 return;
}

function __Z59Register_UnityEngine_ShaderVariantCollection_get_isWarmedUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567599 | 0, fb + 1867 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_set_solverVelocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787283 | 0, fb + 3705 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_get_solverVelocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787231 | 0, fb + 2288 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_INTERNAL_set_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784680 | 0, fb + 3682 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_INTERNAL_get_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784628 | 0, fb + 3681 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody2D_set_collisionDetectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815276 | 0, fb + 3855 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody2D_get_collisionDetectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815224 | 0, fb + 2335 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MovePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813382 | 0, fb + 3838 | 0);
 return;
}

function __Z59Register_UnityEngine_ReflectionProbe_set_customBakedTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557681 | 0, fb + 3050 | 0);
 return;
}

function __Z59Register_UnityEngine_ReflectionProbe_get_customBakedTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557629 | 0, fb + 1829 | 0);
 return;
}

function __Z59Register_UnityEngine_QualitySettings_set_masterTextureLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522115 | 0, fb + 3538 | 0);
 return;
}

function __Z59Register_UnityEngine_Profiling_Profiler_set_enableBinaryLogv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553367 | 0, fb + 3620 | 0);
 return;
}

function __Z59Register_UnityEngine_PlatformEffector2D_set_useSideFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825752 | 0, fb + 3921 | 0);
 return;
}

function __Z59Register_UnityEngine_PlatformEffector2D_get_useSideFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825700 | 0, fb + 2377 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_TriggerModule_SetInsidev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644373 | 0, fb + 3390 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_TriggerModule_GetInsidev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644425 | 0, fb + 2033 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649692 | 0, fb + 3420 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649744 | 0, fb + 3421 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_LightsModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648104 | 0, fb + 3408 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_LightsModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648156 | 0, fb + 2048 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_INTERNAL_set_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652322 | 0, fb + 3436 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_INTERNAL_get_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652270 | 0, fb + 3435 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641904 | 0, fb + 3375 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642008 | 0, fb + 3376 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641956 | 0, fb + 2023 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 642060 | 0, fb + 2024 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleRenderer_set_uvAnimationCyclesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053370 | 0, fb + 715 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleRenderer_get_uvAnimationCyclesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053318 | 0, fb + 817 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleEmitter_set_rndAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051269 | 0, fb + 707 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleEmitter_get_rndAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051217 | 0, fb + 810 | 0);
 return;
}

function __Z59Register_UnityEngine_MonoBehaviour_Internal_CancelInvokeAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549212 | 0, fb + 3614 | 0);
 return;
}

function __Z59Register_UnityEngine_Joint_set_autoConfigureConnectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788160 | 0, fb + 3713 | 0);
 return;
}

function __Z59Register_UnityEngine_Joint_get_autoConfigureConnectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788108 | 0, fb + 2290 | 0);
 return;
}

function __Z59Register_UnityEngine_GUIStyle_INTERNAL_CALL_SetMouseTooltipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023751 | 0, fb + 992 | 0);
 return;
}

function __Z59Register_UnityEngine_CullingGroup_SetDistanceReferencePointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511072 | 0, fb + 2822 | 0);
 return;
}

function __Z59Register_UnityEngine_BillboardAsset_SetVerticesInternalListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501319 | 0, fb + 2770 | 0);
 return;
}

function __Z59Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496966 | 0, fb + 1596 | 0);
 return;
}

function __Z59Register_UnityEngine_Animator_set_runtimeAnimatorControllerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923159 | 0, fb + 4138 | 0);
 return;
}

function __Z59Register_UnityEngine_Animator_get_runtimeAnimatorControllerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923107 | 0, fb + 2567 | 0);
 return;
}

function __Z59Register_UnityEngine_AnimationClip_INTERNAL_set_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915944 | 0, fb + 4091 | 0);
 return;
}

function __Z59Register_UnityEngine_AnimationClip_INTERNAL_get_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915892 | 0, fb + 4090 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToDoubleArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595702 | 0, fb + 3187 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_PopLocalFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591861 | 0, fb + 3174 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewShortArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596351 | 0, fb + 3191 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewFloatArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596504 | 0, fb + 3194 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetSuperclassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591494 | 0, fb + 3173 | 0);
 return;
}

function __Z59Register_UnityEngine_AI_OffMeshLink_set_autoUpdatePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852948 | 0, fb + 4043 | 0);
 return;
}

function __Z59Register_UnityEngine_AI_OffMeshLink_get_autoUpdatePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852896 | 0, fb + 2469 | 0);
 return;
}

function __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851757 | 0, fb + 4036 | 0);
 return;
}

function __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851705 | 0, fb + 4035 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationYTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053267 | 0, fb + 4461 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationXTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053165 | 0, fb + 4460 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationYTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053216 | 0, fb + 2780 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationXTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053114 | 0, fb + 2779 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleAnimator_set_doesAnimateColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051753 | 0, fb + 4448 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleAnimator_get_doesAnimateColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051702 | 0, fb + 2775 | 0);
 return;
}

function __Z58Register_UnityEngine_Networking_UnityWebRequest_get_isDonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032801 | 0, fb + 2754 | 0);
 return;
}

function __Z58Register_UnityEngine_Networking_DownloadHandler_get_isDonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1028477 | 0, fb + 2735 | 0);
 return;
}

function __Z58Register_UnityEngine_Connect_UnityAdsSettings_set_testModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043412 | 0, fb + 3946 | 0);
 return;
}

function __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_SetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013296 | 0, fb + 4241 | 0);
 return;
}

function __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_GetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013347 | 0, fb + 4242 | 0);
 return;
}

function __Z48getPxVehicleWheelsSimData_MinLongSlipDenominatorPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 60 >> 2]);
}

function __Z48getPxVehicleTireLoadFilterDataMMinNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z41setPxVehicleClutchDataMEstimateIterationsPN5physx19PxVehicleClutchDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z40GUIUtility_Set_Custom_PropTextFieldInputh(i1) {
 i1 = i1 | 0;
 HEAP8[(__Z15GetInputManagerv() | 0) + 168 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z39Profiler_Set_Custom_PropEnableBinaryLogh(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[gb + 1451e3 >> 2] | 0) + 104 >> 0] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z34Time_Set_Custom_PropFixedDeltaTimef(f1) {
 f1 = Math_fround(f1);
 __ZN11TimeManager17SetFixedDeltaTimeEf(__Z14GetTimeManagerv() | 0, f1);
 return;
}

function __Z33AndroidJNI_CUSTOM_CallFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return Math_fround(0.0);
}

function __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_class_is_subclass_of(i1 | 0, i2 | 0, 1) | 0;
}

function __Z30getNbPxScene_BroadPhaseRegionsPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 372 >> 2] | 0, i1 | 0) | 0;
}

function __Z29getNbPxPhysics_TriangleMeshesPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function __Z26getPxAggregate_MaxNbActorsPKN5physx11PxAggregateE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __Z24getNbPxRigidActor_ShapesPKN5physx12PxRigidActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getPxArticulation_ScenePKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __Z22getPxArticulation_NamePKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0;
}

function __Z18getPxD6Joint_TwistPKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return Math_fround(+mftCall_fi(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0));
}

function _UNITY_FT_Destroy_Class_pscmaps_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function mftCall_d(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) >= (fb | 0) & (i1 | 0) < (fb + 1 | 0)) return +FUNCTION_TABLE_d[i1 - fb & 1]();
 return +ftCall_d(i1 | 0);
}

function b97(i1, i2, i3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 nullFunc_fiiiif(97);
 return Math_fround(0);
}

function _wcstol(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, -2147483648, 0) | 0;
 getTempRet0() | 0;
 return i3 | 0;
}

function _strtol(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, -2147483648, 0) | 0;
 getTempRet0() | 0;
 return i3 | 0;
}

function _isFinf(f1) {
 f1 = Math_fround(f1);
 return ((HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) & 2139095040) >>> 0 < 2139095040 | 0;
}

function _gzdirect(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else if ((HEAP8[i1 + 92 >> 0] | 0) == 114) i1 = HEAP32[i1 + 88 >> 2] | 0; else i1 = 0;
 return i1 | 0;
}

function _glProgramBinary__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glProgramBinary(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glBufferSubData__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glBufferSubData(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _freeifaddrs(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 if (i1 | 0) do {
  i2 = i1;
  i1 = HEAP32[i1 >> 2] | 0;
  _free(i2);
 } while ((i1 | 0) != 0);
 return;
}

function _emscripten_glUniform2f__wrapper(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 _emscripten_glUniform2f(i1 | 0, +f2, +f3);
}

function _cff_cmap_encoding_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = (HEAP32[(HEAP32[i1 >> 2] | 0) + 656 >> 2] | 0) + 640;
 return 0;
}

function __ZThn4_N5physx5cloth8SwSolver26setInterCollisionStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + -4 + 84 >> 2] = f1;
 return;
}

function __ZNSt3__211char_traitsIwE6assignEPwjw(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i2) i1 = _wmemset(i1, i3, i2) | 0;
 return i1 | 0;
}

function __ZNSt3__211char_traitsIwE4copyEPwPKwj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3) i1 = _wmemcpy(i1, i2, i3) | 0;
 return i1 | 0;
}

function __ZNK5physx7NpCloth26getNbSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore26getNbSeparationConstraintsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx7NpCloth26getNbParticleAccelerationsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore26getNbParticleAccelerationsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK24RendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(0.0);
}

function __ZNK16b2PrismaticJoint13GetMotorForceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 116 >> 2]) * f2);
}

function __ZNK13WheelCollider17HasActorRigidBodyEv(i1) {
 i1 = i1 | 0;
 return (mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0) != 0 | 0;
}

function __ZNK12b2WheelJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 112 >> 2]) * f2);
}

function __ZNK10GameObject22GetComponentPtrAtIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + (i2 << 3) + 4 >> 2] | 0;
}

function __ZN9Texture3D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 return;
}

function __ZN9Texture2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 return;
}

function __ZN9Scripting26RaiseArgumentNullExceptionEPKc(i1) {
 i1 = i1 | 0;
 _il2cpp_raise_exception(_il2cpp_get_exception_argument_null(i1 | 0) | 0);
 return;
}

function __ZN9Rigidbody5SleepEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 52 >> 2] | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 288 >> 2] | 0, i1 | 0);
 return;
}

function __ZN9Polygon2DC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 __ZN9Polygon2D5ResetEv(i1);
 return;
}

function __ZN8VRDevice37SetCustomSplashScreenCreationCallbackEPFP14VRSplashScreenvE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 364 >> 2] = i2;
 return;
}

function __ZN7Hash1285ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZN5physx2Sq10AABBPruner11preallocateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 __ZN5physx2Sq11PruningPool11preallocateEj(i2 + 7760 | 0, i1);
 return;
}

function __ZN5physx16PxsBroadPhaseMBP7destroyEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN5Umbra5Query11setSpuUsageENS0_8SpuUsageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 88 >> 2] = i2;
 return;
}

function __ZN4FMOD7SystemI18getChannelsPlayingEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 36 >> 2];
 return 0;
}

function __ZN29UnityWebRequestAsyncOperation6IsDoneEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[(HEAP32[i1 + 24 >> 2] | 0) + 108 >> 2] | 0) + -3 | 0) >>> 0 < 2 | 0;
}

function __ZN19AudioHighPassFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(5.0e3);
 HEAPF32[i1 + 48 >> 2] = Math_fround(1.0);
 return;
}

function __ZN17PolygonCollider2D15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 802541 | 0, gb + 807484 | 0, gb + 802559 | 0);
 return;
}

function __ZN15ResourceManager6GetAllEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 44 >> 2];
 HEAP32[i1 + 4 >> 2] = i2 + 48;
 return;
}

function __ZN14DetailDatabase13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14DetailDatabase17RefreshPrototypesEv(i1);
 return;
}

function __ZN13GfxDeviceNull15ImmediateVertexEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 return;
}

function __ZN13GfxDeviceNull15ImmediateNormalEfff(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 return;
}

function __ZN13AnimationClip24SetDidModifyClipCallbackEPFvPS_R4ListI8ListNodeI14AnimationStateEEE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1466576 >> 2] = i1;
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl6addRefEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 244 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN11MonoManager25GetImageFromAssemblyIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 224 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __Z61Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelBilinearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572196 | 0, fb + 1 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812619 | 0, fb + 2 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811524 | 0, fb + 1 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811578 | 0, fb + 1 | 0);
 return;
}

function __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_BoxCastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811897 | 0, fb + 1 | 0);
 return;
}

function __Z60Register_UnityEngine_SkinnedMeshRenderer_SetBlendShapeWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524678 | 0, fb + 40 | 0);
 return;
}

function __Z60Register_UnityEngine_SkinnedMeshRenderer_GetBlendShapeWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524625 | 0, fb + 12 | 0);
 return;
}

function __Z60Register_UnityEngine_QualitySettings_set_shadowCascade2Splitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521886 | 0, fb + 13 | 0);
 return;
}

function __Z60Register_UnityEngine_QualitySettings_get_shadowCascade2Splitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521833 | 0, fb + 13 | 0);
 return;
}

function __Z60Register_UnityEngine_LODGroup_set_crossFadeAnimationDurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540621 | 0, fb + 15 | 0);
 return;
}

function __Z60Register_UnityEngine_LODGroup_get_crossFadeAnimationDurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540568 | 0, fb + 16 | 0);
 return;
}

function __Z60Register_UnityEngine_Joint2D_INTERNAL_CALL_GetReactionTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818353 | 0, fb + 14 | 0);
 return;
}

function __Z60Register_UnityEngine_Graphics_Internal_DrawMeshInstancedListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532530 | 0, fb + 11 | 0);
 return;
}

function __Z59Register_UnityEngine_WebGLInput_get_captureAllKeyboardInputv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597484 | 0, fb + 225 | 0);
 return;
}

function __Z59Register_UnityEngine_Transform_INTERNAL_CALL_TransformPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578630 | 0, fb + 689 | 0);
 return;
}

function __Z59Register_UnityEngine_ShaderVariantCollection_RemoveInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567450 | 0, fb + 152 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_set_maxDepenetrationVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785114 | 0, fb + 426 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody_get_maxDepenetrationVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785062 | 0, fb + 493 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_OverlapPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815406 | 0, fb + 894 | 0);
 return;
}

function __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MoveRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813434 | 0, fb + 458 | 0);
 return;
}

function __Z59Register_UnityEngine_QualitySettings_get_masterTextureLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522063 | 0, fb + 128 | 0);
 return;
}

function __Z59Register_UnityEngine_Profiling_Profiler_get_enableBinaryLogv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553315 | 0, fb + 189 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystemRenderer_set_lengthScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653975 | 0, fb + 296 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystemRenderer_get_lengthScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653923 | 0, fb + 353 | 0);
 return;
}

function __Z59Register_UnityEngine_Material_INTERNAL_CALL_SetTextureScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565423 | 0, fb + 651 | 0);
 return;
}

function __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_SetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530025 | 0, fb + 595 | 0);
 return;
}

function __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_GetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530077 | 0, fb + 596 | 0);
 return;
}

function __Z59Register_UnityEngine_LightProbeProxyVolume_set_probeDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543806 | 0, fb + 195 | 0);
 return;
}

function __Z59Register_UnityEngine_LightProbeProxyVolume_get_probeDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543754 | 0, fb + 246 | 0);
 return;
}

function __Z59Register_UnityEngine_GUIStyle_Internal_GetCursorFlashOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023864 | 0, fb + 53 | 0);
 return;
}

function __Z59Register_UnityEngine_GUIElement_INTERNAL_CALL_GetScreenRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514253 | 0, fb + 590 | 0);
 return;
}

function __Z59Register_UnityEngine_Component_GetComponentsForListInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508912 | 0, fb + 573 | 0);
 return;
}

function __Z59Register_UnityEngine_CharacterController_get_collisionFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797e3 | 0, fb + 2319 | 0);
 return;
}

function __Z59Register_UnityEngine_CharacterController_INTERNAL_CALL_Movev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796845 | 0, fb + 858 | 0);
 return;
}

function __Z59Register_UnityEngine_Camera_Internal_RenderToCubemapTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507795 | 0, fb + 361 | 0);
 return;
}

function __Z59Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_Containsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545694 | 0, fb + 649 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioSettings_get_profilerCaptureFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885013 | 0, fb + 246 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893277 | 0, fb + 647 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893381 | 0, fb + 648 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893225 | 0, fb + 737 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893329 | 0, fb + 738 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioLowPassFilter_set_cutoffFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891001 | 0, fb + 624 | 0);
 return;
}

function __Z59Register_UnityEngine_AudioLowPassFilter_get_cutoffFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890949 | 0, fb + 714 | 0);
 return;
}

function __Z59Register_UnityEngine_AssetBundleManifest_GetAllDependenciesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497202 | 0, fb + 618 | 0);
 return;
}

function __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToObjectArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595754 | 0, fb + 715 | 0);
 return;
}

function __Z58Register_UnityEngine_TrailRenderer_INTERNAL_set_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528587 | 0, fb + 2909 | 0);
 return;
}

function __Z58Register_UnityEngine_TrailRenderer_INTERNAL_get_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528536 | 0, fb + 2908 | 0);
 return;
}

function __Z58Register_UnityEngine_Terrain_SetSplatMaterialPropertyBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944234 | 0, fb + 4198 | 0);
 return;
}

function __Z58Register_UnityEngine_Terrain_INTERNAL_CALL_AddTreeInstancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943756 | 0, fb + 4194 | 0);
 return;
}

function __Z58Register_UnityEngine_TerrainData_RecalculateBasemapIfDirtyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941114 | 0, fb + 3830 | 0);
 return;
}

function __Z58Register_UnityEngine_TargetJoint2D_set_autoConfigureTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821746 | 0, fb + 3901 | 0);
 return;
}

function __Z58Register_UnityEngine_TargetJoint2D_get_autoConfigureTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821695 | 0, fb + 2363 | 0);
 return;
}

function __Z58Register_UnityEngine_SurfaceEffector2D_set_useContactForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826517 | 0, fb + 3923 | 0);
 return;
}

function __Z58Register_UnityEngine_SurfaceEffector2D_get_useContactForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826466 | 0, fb + 2379 | 0);
 return;
}

function __Z58Register_UnityEngine_Screen_set_autorotateToLandscapeRightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534908 | 0, fb + 3571 | 0);
 return;
}

function __Z58Register_UnityEngine_SceneManagement_Scene_SetNameInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561128 | 0, fb + 3057 | 0);
 return;
}

function __Z58Register_UnityEngine_SceneManagement_Scene_IsValidInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560975 | 0, fb + 1836 | 0);
 return;
}

function __Z58Register_UnityEngine_SceneManagement_Scene_GetPathInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561026 | 0, fb + 1837 | 0);
 return;
}

function __Z58Register_UnityEngine_SceneManagement_Scene_GetNameInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 561077 | 0, fb + 1838 | 0);
 return;
}

function __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_set_centerOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813959 | 0, fb + 3844 | 0);
 return;
}

function __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_get_centerOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813908 | 0, fb + 3843 | 0);
 return;
}

function __Z58Register_UnityEngine_Rendering_CommandBuffer_ReleaseBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558575 | 0, fb + 3636 | 0);
 return;
}

function __Z58Register_UnityEngine_Renderer_set_staticBatchRootTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525082 | 0, fb + 2873 | 0);
 return;
}

function __Z58Register_UnityEngine_Renderer_get_staticBatchRootTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525031 | 0, fb + 1688 | 0);
 return;
}

function __Z58Register_UnityEngine_RenderTexture_SetGlobalShaderPropertyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576266 | 0, fb + 3137 | 0);
 return;
}

function __Z58Register_UnityEngine_RenderTexture_INTERNAL_CALL_IsCreatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575851 | 0, fb + 1923 | 0);
 return;
}

function __Z58Register_UnityEngine_Profiling_Profiler_SetSamplersEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554393 | 0, fb + 3625 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics2D_set_queriesStartInCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809023 | 0, fb + 3737 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_TriggerModule_SetEnterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644583 | 0, fb + 3392 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_TriggerModule_GetEnterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644634 | 0, fb + 2035 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_TrailModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649492 | 0, fb + 3419 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_TrailModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649543 | 0, fb + 2055 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636072 | 0, fb + 3330 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635970 | 0, fb + 3328 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635868 | 0, fb + 3326 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636123 | 0, fb + 3331 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 636021 | 0, fb + 3329 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 635919 | 0, fb + 3327 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_ShapeModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627598 | 0, fb + 3265 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_ShapeModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 627649 | 0, fb + 1985 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetQualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640680 | 0, fb + 3364 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639222 | 0, fb + 3354 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetDampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640238 | 0, fb + 3362 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetQualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640731 | 0, fb + 2020 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 639273 | 0, fb + 2016 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetDampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 640289 | 0, fb + 2018 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystemRenderer_set_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653872 | 0, fb + 3446 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystemRenderer_get_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653821 | 0, fb + 2078 | 0);
 return;
}

function __Z58Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547693 | 0, fb + 3608 | 0);
 return;
}

function __Z58Register_UnityEngine_LightProbeProxyVolume_set_refreshModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543703 | 0, fb + 2982 | 0);
 return;
}

function __Z58Register_UnityEngine_LightProbeProxyVolume_get_refreshModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 543652 | 0, fb + 1775 | 0);
 return;
}

function __Z58Register_UnityEngine_Input_set_eatKeyPressOnTextFieldFocusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539030 | 0, fb + 3594 | 0);
 return;
}

function __Z58Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_Draw2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023700 | 0, fb + 162 | 0);
 return;
}

function __Z58Register_UnityEngine_GL_INTERNAL_CALL_LoadProjectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535582 | 0, fb + 3579 | 0);
 return;
}

function __Z58Register_UnityEngine_Diagnostics_PlayerConnection_SendFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552647 | 0, fb + 3016 | 0);
 return;
}

function __Z58Register_UnityEngine_DebugLogHandler_Internal_LogExceptionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511512 | 0, fb + 2823 | 0);
 return;
}

function __Z58Register_UnityEngine_Connect_UnityAdsSettings_get_testModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043361 | 0, fb + 294 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_zDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792751 | 0, fb + 3775 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_yDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792649 | 0, fb + 3773 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_xDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792547 | 0, fb + 3771 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_zDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792700 | 0, fb + 3774 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_yDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792598 | 0, fb + 3772 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_xDrivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 792496 | 0, fb + 3770 | 0);
 return;
}

function __Z58Register_UnityEngine_Cloth_INTERNAL_set_randomAccelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840522 | 0, fb + 3990 | 0);
 return;
}

function __Z58Register_UnityEngine_Cloth_INTERNAL_get_randomAccelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840471 | 0, fb + 3989 | 0);
 return;
}

function __Z58Register_UnityEngine_CharacterJoint_INTERNAL_set_swingAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789601 | 0, fb + 3728 | 0);
 return;
}

function __Z58Register_UnityEngine_CharacterJoint_INTERNAL_get_swingAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789550 | 0, fb + 3727 | 0);
 return;
}

function __Z58Register_UnityEngine_Canvas_GetETC1SupportedCanvasMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016282 | 0, fb + 269 | 0);
 return;
}

function __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ResetFieldOfViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505367 | 0, fb + 3476 | 0);
 return;
}

function __Z58Register_UnityEngine_Caching_set_maximumAvailableDiskSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502284 | 0, fb + 2775 | 0);
 return;
}

function __Z58Register_UnityEngine_BillboardAsset_SetIndicesInternalListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501496 | 0, fb + 2773 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_set_spatializePostEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887984 | 0, fb + 4059 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_set_outputAudioMixerGroupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886761 | 0, fb + 4052 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_set_bypassListenerEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888338 | 0, fb + 4061 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_get_spatializePostEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887933 | 0, fb + 2500 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_get_outputAudioMixerGroupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886710 | 0, fb + 2491 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioSource_get_bypassListenerEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888287 | 0, fb + 2502 | 0);
 return;
}

function __Z58Register_UnityEngine_Animator_INTERNAL_get_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919173 | 0, fb + 4117 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToShortArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595501 | 0, fb + 3183 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToFloatArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595651 | 0, fb + 3186 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewStringUTFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592572 | 0, fb + 3179 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLongArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596453 | 0, fb + 3193 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewGlobalRefv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591913 | 0, fb + 3175 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewCharArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596300 | 0, fb + 3190 | 0);
 return;
}

function __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewByteArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596249 | 0, fb + 3189 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_set_avoidancePriorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849834 | 0, fb + 4028 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_get_avoidancePriorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849783 | 0, fb + 2455 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847001 | 0, fb + 4009 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846950 | 0, fb + 4008 | 0);
 return;
}

function __Z57Register_UnityEngine_Networking_UnityWebRequest_get_errorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1032348 | 0, fb + 2749 | 0);
 return;
}

function __Z57Register_UnityEngine_GUIStyleState_INTERNAL_set_textColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022082 | 0, fb + 4284 | 0);
 return;
}

function __Z57Register_UnityEngine_GUIStyleState_INTERNAL_get_textColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022032 | 0, fb + 4283 | 0);
 return;
}

function __Z57Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Vector2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025749 | 0, fb + 3911 | 0);
 return;
}

function __Z57Register_UnityEngine_Connect_UnityAdsSettings_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043074 | 0, fb + 3944 | 0);
 return;
}

function __Z57Register_UnityEngine_Canvas_set_sortingGridNormalizedSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015844 | 0, fb + 4261 | 0);
 return;
}

function __Z57Register_UnityEngine_Canvas_get_sortingGridNormalizedSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015794 | 0, fb + 2700 | 0);
 return;
}

function __Z57Register_UnityEngine_CanvasRenderer_set_hasPopInstructionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013757 | 0, fb + 4245 | 0);
 return;
}

function __Z57Register_UnityEngine_CanvasRenderer_get_hasPopInstructionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013707 | 0, fb + 2684 | 0);
 return;
}

function __Z46getPxVehicleSuspensionData_RecipMaxCompressionPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __Z42getPxVehicleTireLoadFilterData_DenominatorPKN5physx27PxVehicleTireLoadFilterDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z42Application_Get_Custom_PropSubmitAnalyticsv() {
 return (__ZNK14PlayerSettings18GetSubmitAnalyticsEv(__Z17GetPlayerSettingsv() | 0) | 0) & 1 | 0;
}

function __Z41getPxClothMotionConstraintConfigStiffnessPKN5physx29PxClothMotionConstraintConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z40RenderBufferHelper_CUSTOM_GetStoreActionP21ScriptingRenderBuffer(i1) {
 i1 = i1 | 0;
 return HEAPU8[(HEAP32[i1 + 4 >> 2] | 0) + 29 >> 0] | 0 | 0;
}

function __Z40GUIUtility_CUSTOM_Internal_SetHotControli(i1) {
 i1 = i1 | 0;
 HEAP32[(HEAP32[(__Z11GetGUIStatev() | 0) + 276 >> 2] | 0) + 4 >> 2] = i1;
 return;
}

function __Z37setPxSceneDescFrictionOffsetThresholdPN5physx11PxSceneDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 96 >> 2] = f1;
 return;
}

function __Z37setPxSceneDescBounceThresholdVelocityPN5physx11PxSceneDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 92 >> 2] = f1;
 return;
}

function __Z30setPxVehicleWheelDataMToeAnglePN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 32 >> 2] = f1;
 return;
}

function __Z30setPxVehicleWheelDataMMaxSteerPN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 28 >> 2] = f1;
 return;
}

function __Z30getPxActor_ClientBehaviorFlagsPKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 76 >> 2] | 0, i1 | 0) | 0;
}

function __Z29getPxD6Joint_ConcreteTypeNamePKN5physx9PxD6JointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z29Application_CUSTOM_CancelQuitv() {
 var i1 = 0;
 i1 = __Z15GetInputManagerv() | 0;
 HEAP8[i1 + 189 >> 0] = 0;
 HEAP8[i1 + 188 >> 0] = 0;
 return;
}

function __Z28setPxVehicleChassisDataMMassPN5physx20PxVehicleChassisDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z28getPxPhysics_TolerancesScalePKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getNbPxClothFabric_SetsPKN5physx13PxClothFabricE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __Z20dtAllocPathQueryInfov() {
 var i1 = 0;
 i1 = __Z7dtAlloci(4) | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 HEAP32[i1 >> 2] = 0;
 return i1 | 0;
}

function _UNITY_png_reset_zstream(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -2;
  return i1 | 0;
 }
 i1 = _unity_z_inflateReset(i1 + 220 | 0) | 0;
 return i1 | 0;
}

function _UNITY_FT_Destroy_Class_tt_cmap_classes(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function _pthread_cond_timedwait__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _pthread_cond_timedwait(i1 | 0, i2 | 0, i3 | 0) | 0;
}

function __ZTv0_n12_NSt3__210ostrstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210ostrstreamD1Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__210ostrstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210ostrstreamD0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__210istrstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210istrstreamD1Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__210istrstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210istrstreamD0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwSolver25setInterCollisionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + -4 + 80 >> 2] = f1;
 return;
}

function __ZNSt3__26locale5facet16__on_zero_sharedEv(i1) {
 i1 = i1 | 0;
 if (i1 | 0) mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0);
 return;
}

function __ZNSt3__26futureIvED2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 if (i1 | 0) __ZNSt3__214__shared_count16__release_sharedEv(i1) | 0;
 return;
}

function __ZNSt11logic_erroraSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__218__libcpp_refstringaSERKS0_(i1 + 4 | 0, i2 + 4 | 0) | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__get_long_capEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] & 2147483647 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__get_long_capEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] & 2147483647 | 0;
}

function __ZNK7Cubemap16GetSourceTextureE11CubemapFace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 152 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK5physx9NpPhysics17getNbClothFabricsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx9NpFactory17getNbClothFabricsEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK22GenericPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -8 >> 2] | 0) >>> 1 | 0;
}

function __ZNK15b2RevoluteJoint14GetMotorTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 96 >> 2]) * f2);
}

function __ZNK12b2MotorJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 88 >> 2]) * f2);
}

function __ZNK11b2WeldJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 112 >> 2]) * f2);
}

function __ZN8Collider18SelfPointerToWordsERjS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i3 >> 2] = 0;
 return;
}

function __ZN7mecanim12statemachine27IsCurrentTransitionAnyStateEPKNS0_18StateMachineMemoryE(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 24 >> 2] | 0) == -1 | 0;
}

function __ZN6SkyboxD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN6Shader15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[gb + 1166240 >> 2] | 0) != (i1 | 0)) return;
 HEAP32[gb + 1166240 >> 2] = 0;
 return;
}

function __ZN5physx9NpPhysics18createArticulationEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx9NpFactory18createArticulationEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZN5physx7NpScene5flushEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i2 >> 2] | 0) + 244 >> 2] | 0, i2 | 0, i1 | 0);
 return;
}

function __ZN5physx3Cct26CharacterControllerManager24setOverlapRecoveryModuleEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 133 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 32 >> 2] = 0;
 return i2 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN5physx14NpSpatialIndex7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 48 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Umbra10StatsAlloc10deallocateEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i1 = i1 + -16 | 0;
 if (!i1) return;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN4gles10InvalidateER20TextureUnitStateGLES(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 4 >> 2] = 4;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN4FMOD6SoundI8readDataEPvjPj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _memset(i2 | 0, 0, i3 | 0) | 0;
 return 0;
}

function __ZN20HardwareInfoReporter24ReportHardwareInfoStaticEv() {
 __ZN20HardwareInfoReporter18ReportHardwareInfoEv(HEAP32[gb + 1468944 >> 2] | 0);
 return;
}

function __ZN15SharedLightDataD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 33936 + 8;
 __ZN19RenderEventsContextD2Ev(i1 + 208 | 0);
 __ZdlPv(i1);
 return;
}

function __ZN14TerrainManager12GetWorldAABBEP7Terrain(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZNK7Terrain12GetWorldAABBEv(i1, i3);
 return;
}

function __ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] & 16777215 | 0) == 524383 | 0;
}

function __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_SlerpUnclampedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544916 | 0, fb + 7 | 0);
 return;
}

function __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811680 | 0, fb + 1 | 0);
 return;
}

function __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812457 | 0, fb + 2 | 0);
 return;
}

function __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811999 | 0, fb + 1 | 0);
 return;
}

function __Z60Register_UnityEngine_Collider_INTERNAL_CALL_Internal_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794939 | 0, fb + 1 | 0);
 return;
}

function __Z60Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_SamplePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850245 | 0, fb + 6 | 0);
 return;
}

function __Z59Register_UnityEngine_SystemInfo_get_usesOpenGLTextureCoordsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498412 | 0, fb + 53 | 0);
 return;
}

function __Z59Register_UnityEngine_SystemInfo_get_supportsRenderToCubemapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498816 | 0, fb + 61 | 0);
 return;
}

function __Z59Register_UnityEngine_SystemInfo_get_supportsLocationServicev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499780 | 0, fb + 79 | 0);
 return;
}

function __Z59Register_UnityEngine_SystemInfo_get_supports2DArrayTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498964 | 0, fb + 64 | 0);
 return;
}

function __Z59Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559628 | 0, fb + 46 | 0);
 return;
}

function __Z59Register_UnityEngine_Rendering_CommandBuffer_GetTemporaryRTv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559451 | 0, fb + 13 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics2D_set_minPenetrationForPenaltyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809684 | 0, fb + 34 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics2D_get_minPenetrationForPenaltyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809632 | 0, fb + 43 | 0);
 return;
}

function __Z59Register_UnityEngine_ParticleSystem_Particle_GetCurrentSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651244 | 0, fb + 20 | 0);
 return;
}

function __Z59Register_UnityEngine_Audio_AudioMixer_TransitionToSnapshotsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894499 | 0, fb + 25 | 0);
 return;
}

function __Z59Register_UnityEngine_Animator_GetHintWeightPositionInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920684 | 0, fb + 36 | 0);
 return;
}

function __Z58Register_UnityEngine_Screen_get_autorotateToLandscapeRightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534857 | 0, fb + 157 | 0);
 return;
}

function __Z58Register_UnityEngine_Rendering_SplashScreen_get_isFinishedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568186 | 0, fb + 210 | 0);
 return;
}

function __Z58Register_UnityEngine_Quaternion_INTERNAL_CALL_LookRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544821 | 0, fb + 624 | 0);
 return;
}

function __Z58Register_UnityEngine_QualitySettings_get_desiredColorSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523273 | 0, fb + 139 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics2D_get_queriesStartInCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808972 | 0, fb + 236 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_MainModule_SetDurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 622949 | 0, fb + 210 | 0);
 return;
}

function __Z58Register_UnityEngine_Object_Internal_CloneSingleWithParentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579539 | 0, fb + 373 | 0);
 return;
}

function __Z58Register_UnityEngine_Input_get_eatKeyPressOnTextFieldFocusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538979 | 0, fb + 174 | 0);
 return;
}

function __Z58Register_UnityEngine_GUIUtility_Internal_GetPixelsPerPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024460 | 0, fb + 54 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_set_projectionAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793761 | 0, fb + 441 | 0);
 return;
}

function __Z58Register_UnityEngine_ConfigurableJoint_get_projectionAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793710 | 0, fb + 510 | 0);
 return;
}

function __Z58Register_UnityEngine_ComputeShader_INTERNAL_CALL_SetVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509378 | 0, fb + 575 | 0);
 return;
}

function __Z58Register_UnityEngine_Collider2D_INTERNAL_CALL_OverlapPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816925 | 0, fb + 897 | 0);
 return;
}

function __Z58Register_UnityEngine_CharacterJoint_set_projectionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790467 | 0, fb + 438 | 0);
 return;
}

function __Z58Register_UnityEngine_CharacterJoint_get_projectionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790416 | 0, fb + 507 | 0);
 return;
}

function __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ScreenPointToRayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507059 | 0, fb + 566 | 0);
 return;
}

function __Z58Register_UnityEngine_Caching_INTERNAL_CALL_IsVersionCachedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502070 | 0, fb + 619 | 0);
 return;
}

function __Z58Register_UnityEngine_BillboardAsset_MakeMaterialPropertiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501547 | 0, fb + 550 | 0);
 return;
}

function __Z58Register_UnityEngine_Audio_AudioMixerSnapshot_TransitionTov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894863 | 0, fb + 656 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioReverbZone_set_roomRolloffFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890730 | 0, fb + 621 | 0);
 return;
}

function __Z58Register_UnityEngine_AudioReverbZone_get_roomRolloffFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890679 | 0, fb + 711 | 0);
 return;
}

function __Z58Register_UnityEngine_Application_GetStreamProgressForLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493218 | 0, fb + 200 | 0);
 return;
}

function __Z58Register_UnityEngine_Animator_GetNextAnimatorClipInfoCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921594 | 0, fb + 965 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_get_remainingDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847277 | 0, fb + 675 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848553 | 0, fb + 425 | 0);
 return;
}

function __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_set_suspensionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822308 | 0, fb + 3903 | 0);
 return;
}

function __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_get_suspensionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822258 | 0, fb + 3902 | 0);
 return;
}

function __Z57Register_UnityEngine_WebCamTexture_get_videoRotationAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 896071 | 0, fb + 2523 | 0);
 return;
}

function __Z57Register_UnityEngine_WebCamTexture_get_didUpdateThisFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 896176 | 0, fb + 2525 | 0);
 return;
}

function __Z57Register_UnityEngine_UnityLogWriter_WriteStringToUnityLogv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581286 | 0, fb + 3663 | 0);
 return;
}

function __Z57Register_UnityEngine_Transform_INTERNAL_set_localRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577925 | 0, fb + 3145 | 0);
 return;
}

function __Z57Register_UnityEngine_Transform_INTERNAL_set_localPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577621 | 0, fb + 3141 | 0);
 return;
}

function __Z57Register_UnityEngine_Transform_INTERNAL_get_localRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577875 | 0, fb + 3144 | 0);
 return;
}

function __Z57Register_UnityEngine_Transform_INTERNAL_get_localPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577571 | 0, fb + 3140 | 0);
 return;
}

function __Z57Register_UnityEngine_TerrainData_get_alphamapTextureCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941250 | 0, fb + 2604 | 0);
 return;
}

function __Z57Register_UnityEngine_TerrainData_RecalculateTreePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940553 | 0, fb + 3828 | 0);
 return;
}

function __Z57Register_UnityEngine_Sprite_Internal_GetTextureRectOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569188 | 0, fb + 3097 | 0);
 return;
}

function __Z57Register_UnityEngine_SliderJoint2D_set_autoConfigureAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820802 | 0, fb + 3890 | 0);
 return;
}

function __Z57Register_UnityEngine_SliderJoint2D_get_autoConfigureAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820752 | 0, fb + 2359 | 0);
 return;
}

function __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564085 | 0, fb + 3068 | 0);
 return;
}

function __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564556 | 0, fb + 3077 | 0);
 return;
}

function __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564655 | 0, fb + 3079 | 0);
 return;
}

function __Z57Register_UnityEngine_Screen_set_autorotateToLandscapeLeftv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534807 | 0, fb + 3570 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_set_collisionDetectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785456 | 0, fb + 3687 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_get_collisionDetectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785406 | 0, fb + 2282 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786311 | 0, fb + 3694 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786261 | 0, fb + 3693 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MoveRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786765 | 0, fb + 3702 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MovePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786715 | 0, fb + 3701 | 0);
 return;
}

function __Z57Register_UnityEngine_RenderSettings_set_reflectionBouncesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519962 | 0, fb + 3522 | 0);
 return;
}

function __Z57Register_UnityEngine_RenderSettings_INTERNAL_set_fogColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518722 | 0, fb + 3510 | 0);
 return;
}

function __Z57Register_UnityEngine_RenderSettings_INTERNAL_get_fogColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518672 | 0, fb + 3509 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_set_sizeDeltav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555526 | 0, fb + 3027 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555212 | 0, fb + 3021 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMaxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555312 | 0, fb + 3023 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_get_sizeDeltav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555476 | 0, fb + 3026 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555162 | 0, fb + 3020 | 0);
 return;
}

function __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMaxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555262 | 0, fb + 3022 | 0);
 return;
}

function __Z57Register_UnityEngine_Random_INTERNAL_get_insideUnitSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554827 | 0, fb + 3630 | 0);
 return;
}

function __Z57Register_UnityEngine_QualitySettings_set_shadowResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521673 | 0, fb + 3535 | 0);
 return;
}

function __Z57Register_UnityEngine_QualitySettings_set_shadowProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521381 | 0, fb + 3533 | 0);
 return;
}

function __Z57Register_UnityEngine_Profiling_Profiler_AddFramesFromFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553507 | 0, fb + 3622 | 0);
 return;
}

function __Z57Register_UnityEngine_PolygonCollider2D_GetTotalPointCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817874 | 0, fb + 2348 | 0);
 return;
}

function __Z57Register_UnityEngine_PlatformEffector2D_set_useSideBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825854 | 0, fb + 3922 | 0);
 return;
}

function __Z57Register_UnityEngine_PlatformEffector2D_get_useSideBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825804 | 0, fb + 2378 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_set_useAutoRandomSeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653178 | 0, fb + 3443 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_get_useAutoRandomSeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653128 | 0, fb + 2073 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_TriggerModule_SetExitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644685 | 0, fb + 3393 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_TriggerModule_GetExitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 644735 | 0, fb + 2036 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641334 | 0, fb + 3372 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641234 | 0, fb + 3370 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641134 | 0, fb + 3368 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641384 | 0, fb + 3373 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641284 | 0, fb + 3371 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 641184 | 0, fb + 3369 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_MainModule_SetPrewarmv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623145 | 0, fb + 3230 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_MainModule_SetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 622849 | 0, fb + 3228 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_MainModule_GetPrewarmv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623195 | 0, fb + 1975 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_MainModule_GetEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 622899 | 0, fb + 1973 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648928 | 0, fb + 3414 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648978 | 0, fb + 3415 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystemRenderer_set_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654417 | 0, fb + 3447 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystemRenderer_get_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654367 | 0, fb + 2079 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleRenderer_set_maxParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053064 | 0, fb + 714 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleRenderer_get_maxParticleSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053014 | 0, fb + 816 | 0);
 return;
}

function __Z57Register_UnityEngine_Object_DoesObjectWithInstanceIDExistv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580253 | 0, fb + 1940 | 0);
 return;
}

function __Z57Register_UnityEngine_MonoBehaviour_Internal_IsInvokingAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549264 | 0, fb + 1796 | 0);
 return;
}

function __Z57Register_UnityEngine_Material_set_globalIlluminationFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567118 | 0, fb + 3092 | 0);
 return;
}

function __Z57Register_UnityEngine_Material_get_globalIlluminationFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567068 | 0, fb + 1864 | 0);
 return;
}

function __Z57Register_UnityEngine_Material_Internal_CreateWithMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566775 | 0, fb + 3087 | 0);
 return;
}

function __Z57Register_UnityEngine_LineRenderer_INTERNAL_set_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529705 | 0, fb + 2919 | 0);
 return;
}

function __Z57Register_UnityEngine_LineRenderer_INTERNAL_get_startColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529655 | 0, fb + 2918 | 0);
 return;
}

function __Z57Register_UnityEngine_GameObject_Internal_CreateGameObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516025 | 0, fb + 2844 | 0);
 return;
}

function __Z57Register_UnityEngine_Effector2D_get_designedForNonTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823446 | 0, fb + 2369 | 0);
 return;
}

function __Z57Register_UnityEngine_DynamicGI_UpdateMaterialsForRendererv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512893 | 0, fb + 3494 | 0);
 return;
}

function __Z57Register_UnityEngine_Connect_UnityAdsSettings_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043024 | 0, fb + 292 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_set_projectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793552 | 0, fb + 3787 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_set_angularZMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791238 | 0, fb + 3749 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_set_angularYMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791138 | 0, fb + 3748 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_set_angularXMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791038 | 0, fb + 3747 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_get_projectionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793502 | 0, fb + 2304 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_get_angularZMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791188 | 0, fb + 2302 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_get_angularYMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 791088 | 0, fb + 2301 | 0);
 return;
}

function __Z57Register_UnityEngine_ConfigurableJoint_get_angularXMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790988 | 0, fb + 2300 | 0);
 return;
}

function __Z57Register_UnityEngine_Canvas_set_normalizedSortingGridSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015944 | 0, fb + 695 | 0);
 return;
}

function __Z57Register_UnityEngine_Canvas_get_normalizedSortingGridSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015894 | 0, fb + 794 | 0);
 return;
}

function __Z57Register_UnityEngine_Camera_ResetStereoProjectionMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506552 | 0, fb + 3478 | 0);
 return;
}

function __Z57Register_UnityEngine_Camera_INTERNAL_set_projectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504943 | 0, fb + 2794 | 0);
 return;
}

function __Z57Register_UnityEngine_Camera_INTERNAL_get_projectionMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504893 | 0, fb + 2793 | 0);
 return;
}

function __Z57Register_UnityEngine_Audio_AudioMixerGroup_get_audioMixerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894760 | 0, fb + 2517 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioSource_set_ignoreListenerVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887365 | 0, fb + 4054 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioSource_get_ignoreListenerVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887315 | 0, fb + 2495 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioListener_set_velocityUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886204 | 0, fb + 4048 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioListener_get_velocityUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886154 | 0, fb + 2488 | 0);
 return;
}

function __Z57Register_UnityEngine_Application_RequestUserAuthorizationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495561 | 0, fb + 1587 | 0);
 return;
}

function __Z57Register_UnityEngine_Application_CanStreamedLevelBeLoadedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493368 | 0, fb + 1582 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_INTERNAL_get_targetRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922397 | 0, fb + 4135 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_INTERNAL_get_targetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922347 | 0, fb + 4134 | 0);
 return;
}

function __Z57Register_UnityEngine_AnimationState_RemoveMixingTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918394 | 0, fb + 4111 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToLongArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595601 | 0, fb + 3185 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToCharArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595451 | 0, fb + 3182 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToByteArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595401 | 0, fb + 3181 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLocalRefv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592004 | 0, fb + 3176 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewIntArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596403 | 0, fb + 3192 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_AllocObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592174 | 0, fb + 3177 | 0);
 return;
}

function __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851859 | 0, fb + 4038 | 0);
 return;
}

function __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851809 | 0, fb + 4037 | 0);
 return;
}

function __Z56getPxSimulationStatisticsRequiredContactConstraintMemoryPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __Z56Register_UnityEngine_TextGenerator_GetCharactersInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011068 | 0, fb + 4235 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleAnimator_set_colorAnimationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052563 | 0, fb + 4458 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleAnimator_get_colorAnimationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052514 | 0, fb + 2777 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_set_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052287 | 0, fb + 4456 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_get_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052238 | 0, fb + 4455 | 0);
 return;
}

function __Z56Register_UnityEngine_GUIStyle_INTERNAL_set_contentOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022807 | 0, fb + 4292 | 0);
 return;
}

function __Z56Register_UnityEngine_GUIStyle_INTERNAL_get_contentOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022758 | 0, fb + 4291 | 0);
 return;
}

function __Z56Register_UnityEngine_GUIStyleState_SetBackgroundInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021866 | 0, fb + 4282 | 0);
 return;
}

function __Z56Register_UnityEngine_GUIStyleState_GetBackgroundInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021983 | 0, fb + 2719 | 0);
 return;
}

function __Z56Register_UnityEngine_CanvasRenderer_set_popMaterialCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014028 | 0, fb + 4247 | 0);
 return;
}

function __Z56Register_UnityEngine_CanvasRenderer_get_popMaterialCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013979 | 0, fb + 2686 | 0);
 return;
}

function __Z52Application_Get_Custom_PropBackgroundLoadingPriorityv() {
 return __ZNK14PreloadManager17GetThreadPriorityEv(__Z17GetPreloadManagerv() | 0) | 0;
}

function __Z44Profiler_CUSTOM_GetTotalUnusedReservedMemoryv() {
 return __ZN13MemoryManager28GetTotalUnusedReservedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
}

function __Z42Canvas_CUSTOM_GetDefaultCanvasTextMaterialv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN2UI20GetDefaultUIMaterialEv() | 0) | 0;
}

function __Z41getPxVehicleDifferential4WDataMCentreBiasPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z39RenderBufferHelper_CUSTOM_GetLoadActionP21ScriptingRenderBuffer(i1) {
 i1 = i1 | 0;
 return HEAPU8[(HEAP32[i1 + 4 >> 2] | 0) + 28 >> 0] | 0 | 0;
}

function __Z36setPxVehicleDriveDynData_CurrentGearPN5physx21PxVehicleDriveDynDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 68 >> 2] = i1;
 return;
}

function __Z36setPxVehicleDriveDynDataMCurrentGearPN5physx21PxVehicleDriveDynDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 68 >> 2] = i1;
 return;
}

function __Z35setPxSceneDescWakeCounterResetValuePN5physx11PxSceneDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 156 >> 2] = f1;
 return;
}

function __Z33setPxVehicleDriveDynData_GearDownPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 66 >> 0] = i1 & 1;
 return;
}

function __Z32setPxClothStretchConfigStiffnessPN5physx20PxClothStretchConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z27getNbPxPhysics_HeightFieldsPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getNbPxPhysics_ConvexMeshesPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getNbPxPhysics_ClothFabricsPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getPxConstraint_IsValidPKN5physx12PxConstraintE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0) | 0;
}

function __Z19GL_CUSTOM_LoadOrthov() {
 __Z25LoadFullScreenOrthoMatrixffR9GfxDevice(Math_fround(-1.0), Math_fround(100.0), __Z12GetGfxDevicev() | 0);
 return;
}

function __Z17ShowErrorWithModei(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1450808 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function _PxAddCollectionToPhysics(i1) {
 i1 = i1 | 0;
 __ZN5physx9NpFactory13addCollectionERKNS_2Cm10CollectionE(HEAP32[gb + 1457204 >> 2] | 0, i1);
 return;
}

function b112(i1, i2, i3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 nullFunc_iiiiff(112);
 return 0;
}

function _strchr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = ___strchrnul(i1, i2) | 0;
 return ((HEAP8[i1 >> 0] | 0) == (i2 & 255) << 24 >> 24 ? i1 : 0) | 0;
}

function _psh_globals_funcs_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 455;
 HEAP32[i1 + 4 >> 2] = fb + 161;
 HEAP32[i1 + 8 >> 2] = fb + 3859;
 return;
}

function _glShaderSource__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glShaderSource(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glDrawElements__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glDrawElements(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glTexParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glTexParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glTexParameterfv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glTexParameterfv(i1 | 0, i2 | 0, i3 | 0);
}

function __ZThn32_N19SkinnedMeshRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 __ZN19SkinnedMeshRenderer19UpdateTransformInfoEv(i1 + -32 | 0);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZNSt3__210moneypunctIwLb1EEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 211804 + 8;
 return;
}

function __ZNSt3__210moneypunctIwLb0EEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 211748 + 8;
 return;
}

function __ZNSt3__210moneypunctIcLb1EEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 211692 + 8;
 return;
}

function __ZNSt3__210moneypunctIcLb0EEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 211636 + 8;
 return;
}

function __ZNK9InputAxis11GetValueRawEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((HEAP32[i1 + 76 >> 2] | 0) == 0 ? i1 + 84 | 0 : i1 + 80 | 0) >> 2]);
}

function __ZNK5physx9PxTaskMgr12getReferenceEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i2 + 76 >> 2] | 0) + (i1 * 20 | 0) + 4 >> 2] | 0;
}

function __ZNK5physx7NpScene8getFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[((HEAP32[i1 + 3388 >> 2] & 4 | 0) == 0 ? i1 + 1224 | 0 : i1 + 3364 | 0) >> 1] | 0;
}

function __ZNK5physx7NpScene27getCCDContactModifyCallbackEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene27getCCDContactModifyCallbackEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx7NpCloth25getNbSelfCollisionIndicesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore25getNbSelfCollisionIndicesEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx3Ext10FixedJoint29getProjectionAngularToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 76 >> 2]);
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK5Umbra20ObjectDistanceParams16getDistanceScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 >> 2]);
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetCurrentAllocatorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZN5physx9NpFactory15destroyInstanceEv() {
 __ZN5physx9NpFactory7releaseEv(HEAP32[gb + 1457204 >> 2] | 0);
 HEAP32[gb + 1457204 >> 2] = 0;
 return;
}

function __ZN5physx6shdfnd7FastIPC7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZN5physx2Sc21ArticulationJointCore22setTangentialStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 128 >> 2] = f1;
 return;
}

function __ZN5physx2Cm10Collection7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 64 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx22PxVehicleWheelsSimData25setMinLongSlipDenominatorEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 60 >> 2] = f1;
 return;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN5LightD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation6IsDoneEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[gb + 1178912 + 4 >> 2] | 0) == 0 | 0;
}

function __ZN23iPhoneLocalNotification12GetScheduledEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN18ProceduralMaterial12RebuildCloneEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + 172 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] & -9;
 return;
}

function __ZN17PersistentManager29HasThreadedObjectsToIntegrateEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 176 >> 2] | 0) != (HEAP32[i1 + 120 >> 2] | 0) | 0;
}

function __ZN17FileSystemHandler9MakeLocalER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN14ParticleSystem14SetSecPositionEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 40 >> 2] | 0) + 396 >> 2] = f2;
 return;
}

function __ZN14ParticleSystem14SetLengthInSecEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[(HEAP32[i1 + 36 >> 2] | 0) + 264 >> 2] = f2;
 return;
}

function __ZN13SplatDatabase4InitEii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 HEAP32[i1 + 40 >> 2] = i3;
 return;
}

function __ZN13GfxDeviceNull11SetTexturesE10ShaderTypeiPK15GfxTextureParam(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN11UnityEngine9Analytics16TransactionEventD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11UnityEngine9Analytics16TransactionEventD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10TagManager20GetSortingLayerCountEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 1072 >> 2] | 0) - (HEAP32[i1 + 1068 >> 2] | 0) | 0) / 40 | 0 | 0;
}

function __Z59Register_UnityEngine_WheelCollider_ConfigureVehicleSubstepsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837274 | 0, fb + 2 | 0);
 return;
}

function __Z59Register_UnityEngine_RenderSettings_set_reflectionIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519860 | 0, fb + 7 | 0);
 return;
}

function __Z59Register_UnityEngine_RenderSettings_get_reflectionIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519808 | 0, fb + 7 | 0);
 return;
}

function __Z59Register_UnityEngine_Quaternion_INTERNAL_CALL_LerpUnclampedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545012 | 0, fb + 9 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784325 | 0, fb + 3 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_BoxCastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784051 | 0, fb + 2 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsulev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813045 | 0, fb + 2 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812936 | 0, fb + 4 | 0);
 return;
}

function __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812110 | 0, fb + 1 | 0);
 return;
}

function __Z58Register_UnityEngine_SystemInfo_get_supportsSparseTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499218 | 0, fb + 69 | 0);
 return;
}

function __Z58Register_UnityEngine_SystemInfo_get_supportsRenderTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498715 | 0, fb + 59 | 0);
 return;
}

function __Z58Register_UnityEngine_SystemInfo_get_supportsComputeShadersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499120 | 0, fb + 67 | 0);
 return;
}

function __Z58Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498314 | 0, fb + 51 | 0);
 return;
}

function __Z58Register_UnityEngine_SystemInfo_get_deviceUniqueIdentifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499554 | 0, fb + 74 | 0);
 return;
}

function __Z58Register_UnityEngine_ParticleSystem_MainModule_GetDurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623e3 | 0, fb + 267 | 0);
 return;
}

function __Z58Register_UnityEngine_Caching_get_maximumAvailableDiskSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502233 | 0, fb + 88 | 0);
 return;
}

function __Z58Register_UnityEngine_Application_get_isShowingSplashScreenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495825 | 0, fb + 40 | 0);
 return;
}

function __Z58Register_UnityEngine_Application_get_genuineCheckAvailablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495510 | 0, fb + 37 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMesh_SetAvoidancePredictionTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850691 | 0, fb + 41 | 0);
 return;
}

function __Z58Register_UnityEngine_AI_NavMesh_GetAvoidancePredictionTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850742 | 0, fb + 50 | 0);
 return;
}

function __Z57Register_UnityEngine_WheelCollider_set_suspensionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836312 | 0, fb + 568 | 0);
 return;
}

function __Z57Register_UnityEngine_WheelCollider_get_suspensionDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836262 | 0, fb + 655 | 0);
 return;
}

function __Z57Register_UnityEngine_WebCamTexture_INTERNAL_CALL_GetPixelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895945 | 0, fb + 306 | 0);
 return;
}

function __Z57Register_UnityEngine_SurfaceEffector2D_set_speedVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826324 | 0, fb + 509 | 0);
 return;
}

function __Z57Register_UnityEngine_SurfaceEffector2D_get_speedVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826274 | 0, fb + 588 | 0);
 return;
}

function __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564e3 | 0, fb + 3067 | 0);
 return;
}

function __Z57Register_UnityEngine_Screen_get_autorotateToLandscapeLeftv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534757 | 0, fb + 156 | 0);
 return;
}

function __Z57Register_UnityEngine_Rendering_CommandBuffer_Blit_Texturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 559348 | 0, fb + 132 | 0);
 return;
}

function __Z57Register_UnityEngine_RenderSettings_get_reflectionBouncesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519912 | 0, fb + 113 | 0);
 return;
}

function __Z57Register_UnityEngine_QualitySettings_get_shadowResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521623 | 0, fb + 127 | 0);
 return;
}

function __Z57Register_UnityEngine_QualitySettings_get_shadowProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521331 | 0, fb + 125 | 0);
 return;
}

function __Z57Register_UnityEngine_QualitySettings_get_activeColorSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523324 | 0, fb + 140 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetRadiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628192 | 0, fb + 227 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628390 | 0, fb + 229 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetRadiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628242 | 0, fb + 284 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628440 | 0, fb + 286 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648208 | 0, fb + 280 | 0);
 return;
}

function __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 648258 | 0, fb + 337 | 0);
 return;
}

function __Z57Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531342 | 0, fb + 641 | 0);
 return;
}

function __Z57Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531450 | 0, fb + 642 | 0);
 return;
}

function __Z57Register_UnityEngine_Gyroscope_setUpdateInterval_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537232 | 0, fb + 182 | 0);
 return;
}

function __Z57Register_UnityEngine_Gyroscope_getUpdateInterval_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537182 | 0, fb + 228 | 0);
 return;
}

function __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824732 | 0, fb + 499 | 0);
 return;
}

function __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824632 | 0, fb + 498 | 0);
 return;
}

function __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824682 | 0, fb + 578 | 0);
 return;
}

function __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824582 | 0, fb + 577 | 0);
 return;
}

function __Z57Register_UnityEngine_Avatar_INTERNAL_CALL_GetPostRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929232 | 0, fb + 951 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioSettings_get_unityAudioDisabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885393 | 0, fb + 248 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioSettings_get_driverCapabilitiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 884877 | 0, fb + 244 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioReverbZone_set_reflectionsDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890279 | 0, fb + 617 | 0);
 return;
}

function __Z57Register_UnityEngine_AudioReverbZone_get_reflectionsDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890229 | 0, fb + 707 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_GetCurrentAnimatorStateInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921296 | 0, fb + 935 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_GetAnimatorClipInfoInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921544 | 0, fb + 309 | 0);
 return;
}

function __Z57Register_UnityEngine_AnimationCurve_INTERNAL_CALL_MoveKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546354 | 0, fb + 365 | 0);
 return;
}

function __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetMethodIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592362 | 0, fb + 253 | 0);
 return;
}

function __Z57Register_UnityEngine_AI_NavMeshAgent_set_stoppingDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846900 | 0, fb + 585 | 0);
 return;
}

function __Z57Register_UnityEngine_AI_NavMeshAgent_get_stoppingDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 846850 | 0, fb + 674 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_set_numCornerVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528963 | 0, fb + 2914 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_get_numCornerVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528914 | 0, fb + 1718 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_INTERNAL_set_endColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528687 | 0, fb + 2911 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_INTERNAL_get_endColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528638 | 0, fb + 2910 | 0);
 return;
}

function __Z56Register_UnityEngine_Terrain_set_treeMaximumFullLODCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942026 | 0, fb + 4177 | 0);
 return;
}

function __Z56Register_UnityEngine_Terrain_get_treeMaximumFullLODCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941977 | 0, fb + 2607 | 0);
 return;
}

function __Z56Register_UnityEngine_Terrain_INTERNAL_set_legacySpecularv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943354 | 0, fb + 4191 | 0);
 return;
}

function __Z56Register_UnityEngine_Terrain_INTERNAL_get_legacySpecularv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943305 | 0, fb + 4190 | 0);
 return;
}

function __Z56Register_UnityEngine_Shader_SetGlobalVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564264 | 0, fb + 3072 | 0);
 return;
}

function __Z56Register_UnityEngine_Shader_SetGlobalMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564358 | 0, fb + 3074 | 0);
 return;
}

function __Z56Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564606 | 0, fb + 3078 | 0);
 return;
}

function __Z56Register_UnityEngine_Shader_GetGlobalVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564834 | 0, fb + 3081 | 0);
 return;
}

function __Z56Register_UnityEngine_Shader_GetGlobalMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564928 | 0, fb + 3082 | 0);
 return;
}

function __Z56Register_UnityEngine_Rigidbody_INTERNAL_set_centerOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786042 | 0, fb + 3689 | 0);
 return;
}

function __Z56Register_UnityEngine_Rigidbody_INTERNAL_get_centerOfMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785993 | 0, fb + 3688 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderTexture_set_enableRandomWritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575705 | 0, fb + 3133 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderTexture_get_enableRandomWritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575656 | 0, fb + 1921 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderTexture_Internal_SetDimensionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575271 | 0, fb + 3128 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderTexture_Internal_GetDimensionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575222 | 0, fb + 1916 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderTexture_INTERNAL_CALL_Releasev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575802 | 0, fb + 3651 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_set_customReflectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520715 | 0, fb + 3527 | 0);
 return;
}

function __Z56Register_UnityEngine_RelativeJoint2D_INTERNAL_get_targetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820703 | 0, fb + 3889 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_set_timeSlicingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557488 | 0, fb + 3048 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_get_timeSlicingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557439 | 0, fb + 1827 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556149 | 0, fb + 3037 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556100 | 0, fb + 3036 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557136 | 0, fb + 3044 | 0);
 return;
}

function __Z56Register_UnityEngine_Random_INTERNAL_get_rotationUniformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555005 | 0, fb + 3634 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_set_pixelLightCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521200 | 0, fb + 3531 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_set_maximumLODLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522406 | 0, fb + 3540 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_set_maxQueuedFramesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523044 | 0, fb + 3546 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics_set_defaultSolverIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782878 | 0, fb + 3724 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystemRenderer_set_sortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654626 | 0, fb + 3450 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystemRenderer_get_sortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 654577 | 0, fb + 2080 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleEmitter_set_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051168 | 0, fb + 706 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleEmitter_get_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051119 | 0, fb + 809 | 0);
 return;
}

function __Z56Register_UnityEngine_Material_CopyPropertiesFromMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566825 | 0, fb + 3088 | 0);
 return;
}

function __Z56Register_UnityEngine_LocationService_get_isEnabledByUserv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537282 | 0, fb + 1737 | 0);
 return;
}

function __Z56Register_UnityEngine_Input_INTERNAL_get_mouseScrollDeltav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538478 | 0, fb + 3591 | 0);
 return;
}

function __Z56Register_UnityEngine_DynamicGI_INTERNAL_CALL_SetEmissivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512844 | 0, fb + 2826 | 0);
 return;
}

function __Z56Register_UnityEngine_DistanceJoint2D_set_maxDistanceOnlyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819343 | 0, fb + 3879 | 0);
 return;
}

function __Z56Register_UnityEngine_DistanceJoint2D_get_maxDistanceOnlyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819294 | 0, fb + 2354 | 0);
 return;
}

function __Z56Register_UnityEngine_CullingGroup_SetBoundingSphereCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510757 | 0, fb + 2818 | 0);
 return;
}

function __Z56Register_UnityEngine_ContactPoint_ColliderFromInstanceIdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784489 | 0, fb + 2277 | 0);
 return;
}

function __Z56Register_UnityEngine_CharacterJoint_set_enableProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790367 | 0, fb + 3741 | 0);
 return;
}

function __Z56Register_UnityEngine_CharacterJoint_get_enableProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790318 | 0, fb + 2296 | 0);
 return;
}

function __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795711 | 0, fb + 3813 | 0);
 return;
}

function __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795662 | 0, fb + 3812 | 0);
 return;
}

function __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817483 | 0, fb + 3866 | 0);
 return;
}

function __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817434 | 0, fb + 3865 | 0);
 return;
}

function __Z56Register_UnityEngine_Canvas_GetDefaultCanvasTextMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016333 | 0, fb + 270 | 0);
 return;
}

function __Z56Register_UnityEngine_Camera_INTERNAL_set_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504232 | 0, fb + 2784 | 0);
 return;
}

function __Z56Register_UnityEngine_Camera_INTERNAL_get_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504183 | 0, fb + 2783 | 0);
 return;
}

function __Z56Register_UnityEngine_AudioSource_set_ignoreListenerPausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887546 | 0, fb + 4056 | 0);
 return;
}

function __Z56Register_UnityEngine_AudioSource_get_ignoreListenerPausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887497 | 0, fb + 2497 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_set_linearVelocityBlendingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919549 | 0, fb + 4123 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_set_layersAffectMassCenterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924233 | 0, fb + 4144 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_get_linearVelocityBlendingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919500 | 0, fb + 2555 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_get_layersAffectMassCenterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924184 | 0, fb + 2572 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_INTERNAL_get_pivotPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921928 | 0, fb + 4132 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919080 | 0, fb + 4115 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919031 | 0, fb + 4114 | 0);
 return;
}

function __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToIntArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595552 | 0, fb + 3184 | 0);
 return;
}

function __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818455 | 0, fb + 3873 | 0);
 return;
}

function __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818406 | 0, fb + 3872 | 0);
 return;
}

function __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt64v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038743 | 0, fb + 199 | 0);
 return;
}

function __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038646 | 0, fb + 487 | 0);
 return;
}

function __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt16v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038549 | 0, fb + 485 | 0);
 return;
}

function __Z56Register_UnityEngine_Analytics_CustomEventData_AddStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038263 | 0, fb + 479 | 0);
 return;
}

function __Z56Register_UnityEngine_AI_NavMeshPath_ClearCornersInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852238 | 0, fb + 3780 | 0);
 return;
}

function __Z56Register_UnityEngine_AI_NavMeshAgent_get_isOnOffMeshLinkv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847416 | 0, fb + 2442 | 0);
 return;
}

function __Z56Register_UnityEngine_AI_NavMeshAgent_CompleteOffMeshLinkv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847644 | 0, fb + 3772 | 0);
 return;
}

function __Z55Register_UnityEngine_GUIUtility_Internal_GetDefaultSkinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025218 | 0, fb + 2733 | 0);
 return;
}

function __Z55Register_UnityEngine_GUIUtility_Internal_GetBuiltinSkinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025266 | 0, fb + 2734 | 0);
 return;
}

function __Z55Register_UnityEngine_GUIClip_INTERNAL_CALL_Clip_Vector2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025892 | 0, fb + 3914 | 0);
 return;
}

function __Z55Register_UnityEngine_Connect_UnityAdsSettings_SetGameIdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043511 | 0, fb + 4431 | 0);
 return;
}

function __Z55Register_UnityEngine_Connect_UnityAdsSettings_GetGameIdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1043463 | 0, fb + 2766 | 0);
 return;
}

function __Z55Register_UnityEngine_Canvas_get_cachedSortingLayerValuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016072 | 0, fb + 2702 | 0);
 return;
}

function __Z55Register_UnityEngine_CanvasRenderer_get_hasRectClippingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013659 | 0, fb + 2683 | 0);
 return;
}

function __Z55Register_UnityEngine_CanvasRenderer_DisableRectClippingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013611 | 0, fb + 3874 | 0);
 return;
}

function __Z55Register_UnityEngine_CanvasGroup_set_ignoreParentGroupsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013248 | 0, fb + 4240 | 0);
 return;
}

function __Z55Register_UnityEngine_CanvasGroup_get_ignoreParentGroupsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013200 | 0, fb + 2681 | 0);
 return;
}

function __Z50getPxVehicleTireDataMCamberStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z45getPxVehicleDifferential4WDataMFrontRearSplitPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z42getPxVehicleAckermannGeometryDataMAccuracyPKN5physx30PxVehicleAckermannGeometryDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z40getPxVehicleDifferential4WDataMFrontBiasPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z39setPxParticleReadDataValidParticleRangePN5physx18PxParticleReadDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z37Texture2D_Get_Custom_PropWhiteTexturev() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN10builtintex15GetWhiteTextureEv() | 0) | 0;
}

function __Z37Texture2D_Get_Custom_PropBlackTexturev() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN10builtintex15GetBlackTextureEv() | 0) | 0;
}

function __Z35setPxVehicleDriveDynData_TargetGearPN5physx21PxVehicleDriveDynDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 72 >> 2] = i1;
 return;
}

function __Z35setPxVehicleDriveDynData_GearChangePN5physx21PxVehicleDriveDynDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 72 >> 2] = i1;
 return;
}

function __Z35setPxVehicleDriveDynDataMTargetGearPN5physx21PxVehicleDriveDynDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 72 >> 2] = i1;
 return;
}

function __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp(i1) {
 i1 = i1 | 0;
 return _il2cpp_method_get_param_count(HEAP32[i1 >> 2] | 0) | 0;
}

function __Z33GameObject_CUSTOM_CreatePrimitivei(i1) {
 i1 = i1 | 0;
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z15CreatePrimitivei(i1) | 0) | 0;
}

function __Z30setPxVehicleTireDataMLatStiffYPN5physx17PxVehicleTireDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z30setPxCapsuleGeometryHalfHeightPN5physx17PxCapsuleGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z29setPxHeightFieldDescThicknessPN5physx17PxHeightFieldDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z27getPxScene_FilterShaderDataPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 196 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getPxScene_DynamicStructurePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 320 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getNbPxAggregate_ActorsPKN5physx11PxAggregateE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 40 >> 2] | 0, i1 | 0) | 0;
}

function _UNITY_FT_Destroy_Class_sfnt_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function _FT_Init_Class_sfnt_service_glyph_dict(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 192;
 HEAP32[i2 + 4 >> 2] = fb + 1101;
 return;
}

function _unzOpenCurrentFile2(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _unzOpenCurrentFile3(i1, i2, i3, i4, 0) | 0;
}

function __ZNK5physx3Ext10FixedJoint28getProjectionLinearToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 72 >> 2]);
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK20LightPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNK14SoundHandleAPI12GetLoadStateEv(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 return i1 | 0;
}

function __ZNK13TranslateGLES15FramebufferReadEN2gl15FramebufferReadE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75424 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES15FramebufferMaskEN2gl15FramebufferMaskE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75512 + (i2 << 2) >> 2] | 0;
}

function __ZNK13GfxDeviceNull25GetDeviceProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK12b2WheelJoint14GetMotorTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(Math_fround(HEAPF32[i1 + 112 >> 2]) * f2);
}

function __ZN9GfxDevice15BeginFrameStatsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 3896 >> 0] = 1;
 HEAPF64[i1 + 3880 >> 3] = +__Z19GetTimeSinceStartupv();
 return;
}

function __ZN8Remapper19ClearPreallocateIDsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 32 >> 2] = 0;
 HEAP32[i1 + 36 >> 2] = -1;
 return;
}

function __ZN7Hash1283SetEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i1 | 0, i2 | 0, (i3 >>> 0 > 16 ? 16 : i3) | 0) | 0;
 return;
}

function __ZN5physx3Ext15CpuWorkerThread10initializeEPNS0_20DefaultCpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __ZN5physx2Sc7BodySim30notifyClearSpatialAccelerationEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 146 | 0;
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | 2;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore21setInternalComplianceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 104 >> 2] = f1;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore21setExternalComplianceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 108 >> 2] = f1;
 return;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN4HaloD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 37748 + 8;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN4FMOD13ChannelGroupI9getVolumeEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 44 >> 2];
 return 0;
}

function __ZN22BaseUnityConnectClient31DonePreparingOnMainThreadStaticEPv(i1) {
 i1 = i1 | 0;
 __ZN22BaseUnityConnectClient15OnDonePreparingEv(i1);
 return;
}

function __ZN16NovodexAllocator10deallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63400 | 0);
 return;
}

function __ZN14PhysicMaterial17IsDefaultMaterialEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(__Z21GetManagerFromContexti(9) | 0) + 64 >> 2] | 0) == (i1 | 0) | 0;
}

function __ZN14PhysicMaterial15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 737107 | 0, gb + 781252 | 0, gb + 801720 | 0);
 return;
}

function __ZN14AreaEffector2D15InitializeClassEv() {
 __Z27RegisterAllowNameConversionPKcS0_S0_(gb + 800815 | 0, gb + 805115 | 0, gb + 800847 | 0);
 return;
}

function __ZN13SpeedTreeWind9SetOptionENS_8EOptionsEb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP8[i1 + 1348 + i2 >> 0] = i3 & 1;
 return;
}

function __ZN11AudioModule23SetProfilerCaptureFlagsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(__Z15GetAudioManagerv() | 0) + 292 >> 2] = i2;
 return;
}

function __ZN10DynamicVBO11SwapBuffersEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[gb + 1161252 >> 2] = 0;
 HEAP32[gb + 1161256 >> 2] = i2 + 1;
 return;
}

function __ZL19CleanupModule_Umbrav() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIUmbrav() | 0, gb + 63600 | 0);
 __Z9SetIUmbraP6IUmbra(0);
 return;
}

function __ZL19CleanupModule_Clothv() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIClothv() | 0, gb + 63400 | 0);
 __Z9SetIClothP6ICloth(0);
 return;
}

function __Z58Register_UnityEngine_TerrainData_INTERNAL_CALL_RemoveTreesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941423 | 0, fb + 7 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics_INTERNAL_CALL_RaycastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783345 | 0, fb + 2 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCirclev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812568 | 0, fb + 1 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812780 | 0, fb + 3 | 0);
 return;
}

function __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811790 | 0, fb + 1 | 0);
 return;
}

function __Z57Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579192 | 0, fb + 49 | 0);
 return;
}

function __Z57Register_UnityEngine_SystemInfo_get_supportsMotionVectorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498766 | 0, fb + 60 | 0);
 return;
}

function __Z57Register_UnityEngine_SystemInfo_get_supportsAccelerometerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499684 | 0, fb + 77 | 0);
 return;
}

function __Z57Register_UnityEngine_SystemInfo_get_operatingSystemFamilyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497899 | 0, fb + 42 | 0);
 return;
}

function __Z57Register_UnityEngine_SystemInfo_get_graphicsMultiThreadedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498562 | 0, fb + 56 | 0);
 return;
}

function __Z57Register_UnityEngine_SystemInfo_get_graphicsDeviceVersionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498464 | 0, fb + 54 | 0);
 return;
}

function __Z57Register_UnityEngine_Physics_set_minPenetrationForPenaltyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782347 | 0, fb + 21 | 0);
 return;
}

function __Z57Register_UnityEngine_Physics_get_minPenetrationForPenaltyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782297 | 0, fb + 30 | 0);
 return;
}

function __Z57Register_UnityEngine_Application_get_isHumanControllingUsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493870 | 0, fb + 13 | 0);
 return;
}

function __Z57Register_UnityEngine_Application_get_internetReachabilityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495423 | 0, fb + 35 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_SetIKRotationWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920510 | 0, fb + 70 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_SetIKPositionWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920410 | 0, fb + 69 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_GetIKRotationWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920460 | 0, fb + 35 | 0);
 return;
}

function __Z57Register_UnityEngine_Animator_GetIKPositionWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920360 | 0, fb + 34 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_set_minVertexDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529153 | 0, fb + 178 | 0);
 return;
}

function __Z56Register_UnityEngine_TrailRenderer_get_minVertexDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529104 | 0, fb + 224 | 0);
 return;
}

function __Z56Register_UnityEngine_TerrainData_set_wavingGrassStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939286 | 0, fb + 672 | 0);
 return;
}

function __Z56Register_UnityEngine_TerrainData_get_wavingGrassStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939237 | 0, fb + 771 | 0);
 return;
}

function __Z56Register_UnityEngine_ShaderVariantCollection_AddInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567401 | 0, fb + 151 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_get_customReflectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520666 | 0, fb + 118 | 0);
 return;
}

function __Z56Register_UnityEngine_RelativeJoint2D_set_correctionScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820344 | 0, fb + 477 | 0);
 return;
}

function __Z56Register_UnityEngine_RelativeJoint2D_get_correctionScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820295 | 0, fb + 550 | 0);
 return;
}

function __Z56Register_UnityEngine_ReflectionProbe_IsFinishedRenderingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557815 | 0, fb + 668 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_get_pixelLightCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521151 | 0, fb + 123 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_get_maximumLODLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522357 | 0, fb + 130 | 0);
 return;
}

function __Z56Register_UnityEngine_QualitySettings_get_maxQueuedFramesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522995 | 0, fb + 136 | 0);
 return;
}

function __Z56Register_UnityEngine_Profiling_Profiler_get_usedHeapSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553817 | 0, fb + 192 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics_get_defaultSolverIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782829 | 0, fb + 229 | 0);
 return;
}

function __Z56Register_UnityEngine_PhysicMaterial_set_dynamicFriction2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796454 | 0, fb + 450 | 0);
 return;
}

function __Z56Register_UnityEngine_PhysicMaterial_get_dynamicFriction2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796405 | 0, fb + 519 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystem_TrailModule_SetRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649594 | 0, fb + 283 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystem_TrailModule_GetRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 649643 | 0, fb + 340 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystem_ShapeModule_SetAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628292 | 0, fb + 228 | 0);
 return;
}

function __Z56Register_UnityEngine_ParticleSystem_ShapeModule_GetAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628341 | 0, fb + 285 | 0);
 return;
}

function __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Determinantv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545512 | 0, fb + 247 | 0);
 return;
}

function __Z56Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531235 | 0, fb + 640 | 0);
 return;
}

function __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516190 | 0, fb + 165 | 0);
 return;
}

function __Z56Register_UnityEngine_BuoyancyEffector2D_set_surfaceLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824163 | 0, fb + 493 | 0);
 return;
}

function __Z56Register_UnityEngine_BuoyancyEffector2D_get_surfaceLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824114 | 0, fb + 572 | 0);
 return;
}

function __Z56Register_UnityEngine_Avatar_INTERNAL_CALL_GetPreRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929183 | 0, fb + 950 | 0);
 return;
}

function __Z56Register_UnityEngine_Audio_AudioMixer_FindMatchingGroupsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894407 | 0, fb + 942 | 0);
 return;
}

function __Z56Register_UnityEngine_AudioListener_GetSpectrumDataHelperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886301 | 0, fb + 908 | 0);
 return;
}

function __Z56Register_UnityEngine_AssetBundle_LoadAssetAsync_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496682 | 0, fb + 357 | 0);
 return;
}

function __Z56Register_UnityEngine_Animator_GetCurrentAnimatorClipInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921495 | 0, fb + 964 | 0);
 return;
}

function __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetFieldIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592412 | 0, fb + 254 | 0);
 return;
}

function __Z55Register_UnityEngine_WWW_enforceWebSecurityRestrictionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580787 | 0, fb + 1941 | 0);
 return;
}

function __Z55Register_UnityEngine_VR_VRSettings_get_supportedDevicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045738 | 0, fb + 305 | 0);
 return;
}

function __Z55Register_UnityEngine_VR_VRSettings_get_loadedDeviceNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045646 | 0, fb + 304 | 0);
 return;
}

function __Z55Register_UnityEngine_VR_VRSettings_get_eyeTextureHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045480 | 0, fb + 303 | 0);
 return;
}

function __Z55Register_UnityEngine_SphereCollider_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795216 | 0, fb + 3808 | 0);
 return;
}

function __Z55Register_UnityEngine_SphereCollider_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795168 | 0, fb + 3807 | 0);
 return;
}

function __Z55Register_UnityEngine_SortingLayer_GetLayerValueFromNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567794 | 0, fb + 1869 | 0);
 return;
}

function __Z55Register_UnityEngine_SkinnedMeshRenderer_set_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524189 | 0, fb + 2864 | 0);
 return;
}

function __Z55Register_UnityEngine_SkinnedMeshRenderer_get_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524141 | 0, fb + 1684 | 0);
 return;
}

function __Z55Register_UnityEngine_Shader_SetGlobalFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564172 | 0, fb + 3070 | 0);
 return;
}

function __Z55Register_UnityEngine_Shader_GetGlobalFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564742 | 0, fb + 3080 | 0);
 return;
}

function __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_IsSleepingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786940 | 0, fb + 2286 | 0);
 return;
}

function __Z55Register_UnityEngine_Rendering_CommandBuffer_InitBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558527 | 0, fb + 3635 | 0);
 return;
}

function __Z55Register_UnityEngine_Renderer_set_realtimeLightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526163 | 0, fb + 2886 | 0);
 return;
}

function __Z55Register_UnityEngine_Renderer_get_realtimeLightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526115 | 0, fb + 1700 | 0);
 return;
}

function __Z55Register_UnityEngine_RenderTexture_set_autoGenerateMipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575174 | 0, fb + 3127 | 0);
 return;
}

function __Z55Register_UnityEngine_RenderTexture_get_autoGenerateMipsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575126 | 0, fb + 1915 | 0);
 return;
}

function __Z55Register_UnityEngine_RenderTexture_INTERNAL_CALL_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575754 | 0, fb + 1922 | 0);
 return;
}

function __Z55Register_UnityEngine_RectTransform_set_drivenPropertiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555808 | 0, fb + 3031 | 0);
 return;
}

function __Z55Register_UnityEngine_RectTransform_get_drivenPropertiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555760 | 0, fb + 1817 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_set_softVegetationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522707 | 0, fb + 3543 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_set_shadowCascadesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521479 | 0, fb + 3534 | 0);
 return;
}

function __Z55Register_UnityEngine_Profiling_Profiler_BeginSampleOnlyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553601 | 0, fb + 3623 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_set_showColliderContactsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810414 | 0, fb + 3741 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_set_changeStopsCallbacksv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809122 | 0, fb + 3738 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_set_frictionCombinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796647 | 0, fb + 3816 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_get_frictionCombinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796599 | 0, fb + 2316 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_set_simulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652906 | 0, fb + 3440 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_get_simulationSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652858 | 0, fb + 2070 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628726 | 0, fb + 3271 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 628774 | 0, fb + 1989 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleRenderer_set_velocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052858 | 0, fb + 712 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleRenderer_get_velocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052810 | 0, fb + 814 | 0);
 return;
}

function __Z55Register_UnityEngine_Material_Internal_CreateWithStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566679 | 0, fb + 3085 | 0);
 return;
}

function __Z55Register_UnityEngine_Material_Internal_CreateWithShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566727 | 0, fb + 3086 | 0);
 return;
}

function __Z55Register_UnityEngine_MaterialPropertyBlock_DestroyBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530610 | 0, fb + 3554 | 0);
 return;
}

function __Z55Register_UnityEngine_LineRenderer_set_numCornerVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530343 | 0, fb + 2926 | 0);
 return;
}

function __Z55Register_UnityEngine_LineRenderer_get_numCornerVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530295 | 0, fb + 1725 | 0);
 return;
}

function __Z55Register_UnityEngine_LineRenderer_INTERNAL_set_endColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529803 | 0, fb + 2921 | 0);
 return;
}

function __Z55Register_UnityEngine_LineRenderer_INTERNAL_get_endColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529755 | 0, fb + 2920 | 0);
 return;
}

function __Z55Register_UnityEngine_LightmapSettings_set_lightmapsModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533927 | 0, fb + 3564 | 0);
 return;
}

function __Z55Register_UnityEngine_LightProbeGroup_set_probePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542971 | 0, fb + 2973 | 0);
 return;
}

function __Z55Register_UnityEngine_LightProbeGroup_get_probePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542923 | 0, fb + 1771 | 0);
 return;
}

function __Z55Register_UnityEngine_Joint_INTERNAL_set_connectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788060 | 0, fb + 3712 | 0);
 return;
}

function __Z55Register_UnityEngine_Joint_INTERNAL_get_connectedAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788012 | 0, fb + 3711 | 0);
 return;
}

function __Z55Register_UnityEngine_Input_set_simulateMouseWithTouchesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538611 | 0, fb + 3592 | 0);
 return;
}

function __Z55Register_UnityEngine_GUITexture_INTERNAL_set_pixelInsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514511 | 0, fb + 2836 | 0);
 return;
}

function __Z55Register_UnityEngine_GUITexture_INTERNAL_get_pixelInsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514463 | 0, fb + 2835 | 0);
 return;
}

function __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_set_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822944 | 0, fb + 3909 | 0);
 return;
}

function __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_get_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822896 | 0, fb + 3908 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterController_get_isGroundedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796897 | 0, fb + 2318 | 0);
 return;
}

function __Z55Register_UnityEngine_Camera_GetStereoProjectionMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506216 | 0, fb + 1637 | 0);
 return;
}

function __Z55Register_UnityEngine_BillboardAsset_GetVerticesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501231 | 0, fb + 2768 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioSource_set_velocityUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887643 | 0, fb + 4057 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioSource_get_velocityUpdateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887595 | 0, fb + 2498 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioSettings_set_outputSampleRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885152 | 0, fb + 3788 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioReverbFilter_set_reverbPresetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892645 | 0, fb + 4073 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioReverbFilter_get_reverbPresetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892597 | 0, fb + 2514 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_get_hasTransformHierarchyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919672 | 0, fb + 2557 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_INTERNAL_set_rootRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919368 | 0, fb + 4121 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_INTERNAL_set_rootPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919272 | 0, fb + 4119 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_INTERNAL_get_rootRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919320 | 0, fb + 4120 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_INTERNAL_get_rootPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919224 | 0, fb + 4118 | 0);
 return;
}

function __Z55Register_UnityEngine_Animation_set_animateOnlyIfVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917393 | 0, fb + 4104 | 0);
 return;
}

function __Z55Register_UnityEngine_Animation_get_animateOnlyIfVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917345 | 0, fb + 2540 | 0);
 return;
}

function __Z55Register_UnityEngine_Animation_INTERNAL_set_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917567 | 0, fb + 4107 | 0);
 return;
}

function __Z55Register_UnityEngine_Animation_INTERNAL_get_localBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917519 | 0, fb + 4106 | 0);
 return;
}

function __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FindClassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591220 | 0, fb + 3170 | 0);
 return;
}

function __Z55Register_UnityEngine_Analytics_CustomEventData_AddSBytev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038453 | 0, fb + 483 | 0);
 return;
}

function __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt64v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038695 | 0, fb + 198 | 0);
 return;
}

function __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038598 | 0, fb + 486 | 0);
 return;
}

function __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt16v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038501 | 0, fb + 484 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMesh_GetNavMeshLayerFromNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850372 | 0, fb + 2457 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_set_updateRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849465 | 0, fb + 4026 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_set_updatePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849369 | 0, fb + 4025 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_get_updateRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849417 | 0, fb + 2453 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_get_updatePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849321 | 0, fb + 2452 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Movev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848266 | 0, fb + 4021 | 0);
 return;
}

function __Z54getPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __Z54Register_UnityEngine_TextGenerator_GetVerticesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010931 | 0, fb + 4234 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleEmitter_set_useWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050982 | 0, fb + 4442 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleEmitter_get_useWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050935 | 0, fb + 2770 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleEmitter_get_particleCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051407 | 0, fb + 2773 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleAnimator_set_autodestructv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052467 | 0, fb + 4457 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleAnimator_get_autodestructv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052420 | 0, fb + 2776 | 0);
 return;
}

function __Z54Register_UnityEngine_GUIUtility_Internal_SetHotControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024706 | 0, fb + 3902 | 0);
 return;
}

function __Z54Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025845 | 0, fb + 3913 | 0);
 return;
}

function __Z49WebGLInput_Set_Custom_PropCaptureAllKeyboardInputh(i1) {
 i1 = i1 | 0;
 __Z33SetCaptureAllKeyboardInputEnabledb(i1 << 24 >> 24 != 0);
 return;
}

function __Z44getPxVehicleWheelsSimData_ThresholdLongSpeedPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __Z43setPxSceneDescContactReportStreamBufferSizePN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 144 >> 2] = i1;
 return;
}

function __Z43getPxVehicleSuspensionDataMCamberAtMaxDroopPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 28 >> 2]);
}

function __Z41Application_Get_Custom_PropIsLoadingLevelv() {
 return (__ZN14PreloadManager17IsLoadingOrQueuedEv(__Z17GetPreloadManagerv() | 0) | 0) & 1 | 0;
}

function __Z39getPxVehicleDifferential4WDataMRearBiasPKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z39GUIClip_CUSTOM_INTERNAL_get_visibleRectP5RectTIfE(i1) {
 i1 = i1 | 0;
 _memmove(i1 | 0, (__Z11GetGUIStatev() | 0) + 252 | 0, 16) | 0;
 return;
}

function __Z31setPxVehicleDriveDynData_GearUpPN5physx21PxVehicleDriveDynDataEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 65 >> 0] = i1 & 1;
 return;
}

function __Z31setPxVehicleClutchDataMStrengthPN5physx19PxVehicleClutchDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z31setPxClothTetherConfigStiffnessPN5physx19PxClothTetherConfigEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z26setPxVehicleEngineDataMMOIPN5physx19PxVehicleEngineDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __Z26getPxScene_StaticStructurePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 316 >> 2] | 0, i1 | 0) | 0;
}

function __Z26getPxScene_SolverBatchSizePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 428 >> 2] | 0, i1 | 0) | 0;
}

function __Z24getNbPxPhysics_MaterialsPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxConstraint_ScenePKN5physx12PxConstraintE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxConstraint_FlagsPKN5physx12PxConstraintE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 44 >> 2] | 0, i1 | 0) | 0;
}

function __Z16print_realstdoutPKci(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = HEAP32[gb + 191868 >> 2] | 0;
 _fputs(i1, i2) | 0;
 _fflush(i2) | 0;
 return;
}

function _UNITY_FT_Destroy_Class_cff_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function b128(i1, i2, f3, f4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 f5 = Math_fround(f5);
 nullFunc_viifff(128);
}

function _jpeg_write_m_byte(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 + 332 >> 2] | 0) + 24 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function _emscripten_glTexParameteri__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glTexParameteri(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glNormalPointer__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glNormalPointer(i1 | 0, i2 | 0, i3 | 0);
}

function _cabsf(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 return Math_fround(_hypotf(f2, Math_fround(HEAPF32[i1 + 4 >> 2])));
}

function ___assert_fail__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 ___assert_fail(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function __ZZN8VRModuleC1EvEN28playerLoadFirstScenePreAwake7ForwardEv() {
 __ZN8VRModule22StartRenderingToDeviceEv(HEAP32[gb + 1469188 >> 2] | 0);
 return;
}

function __ZThn8_NK12_GLOBAL__N_111StreamOwner11isConnectedEv(i1) {
 i1 = i1 | 0;
 return __ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv(i1 + -8 | 0) | 0;
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLL10initializeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc19ShapeInstancePairLL10initializeEv(i1 + -8 | 0);
 return;
}

function __ZThn4_NK12_GLOBAL__N_111StreamOwner11isConnectedEv(i1) {
 i1 = i1 | 0;
 return __ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv(i1 + -4 | 0) | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZSt15set_new_handlerPFvvE(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[gb + 1477008 >> 2] | 0;
 HEAP32[gb + 1477008 >> 2] = i1;
 return i2 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__get_short_sizeEv(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 8 + 3 >> 0] | 0 | 0;
}

function __ZNK5physx7NpScene26getNbContactDataBlocksUsedEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene26getNbContactDataBlocksUsedEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene15getFrictionTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 7600 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK27AnimationLayerMixerPlayable13GetParametersEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 100 >> 2] | 0) + (i2 * 12 | 0) | 0;
}

function __ZNK11ICallString6ToUTF8Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z24scripting_cpp_string_forP12Il2CppString(i1, HEAP32[i2 >> 2] | 0);
 return;
}

function __ZN9LensFlare16TransformChangedEv(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 68 >> 2] | 0) == -1) return;
 __ZN9LensFlare11UpdateFlareEv(i1);
 return;
}

function __ZN9GfxDevice13SetActiveTierE12GraphicsTier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] = i2;
 return;
}

function __ZN5physx6shdfnd15atomicDecrementEPVi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 - 1;
 return i2 + -1 | 0;
}

function __ZN5physx2Sc21ArticulationJointCore20setTangentialDampingEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 132 >> 2] = f1;
 return;
}

function __ZN5physx17PxMeshOverlapUtilC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = i1 + 4;
 HEAP32[i1 + 260 >> 2] = 0;
 HEAP32[i1 + 264 >> 2] = 64;
 return;
}

function __ZN5Unity17ConfigurableJointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD8ChannelI13getAudibilityEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 36 >> 2];
 return 0;
}

function __ZN4FMOD8ChannelI12getFrequencyEPf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 140 >> 2];
 return 0;
}

function __ZN38AssetBundleLoadFromCacheAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN38AssetBundleLoadFromCacheAsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN2UI11DoSyncDepthERNS_13UIInstructionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 480 >> 2] = i2;
 HEAP16[i1 + 664 >> 1] = 2;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 88 >> 2] | 0);
 return;
}

function __ZN20TextRenderingPrivate8TextMesh15DidAddComponentEv(i1) {
 i1 = i1 | 0;
 __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv(i1);
 return;
}

function __ZN17InternalIndexPool7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN17AudioCustomFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170700 + 8;
 __ZN17AudioCustomFilter7CleanupEv(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14MessageHandler15MessageIDToNameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 52 >> 2] | 0) + (i2 * 20 | 0) >> 2] | 0;
}

function __ZN13RuntimeStaticI18AssetBundleManagerE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 __ZN13RuntimeStaticI18AssetBundleManagerE7DestroyEv(i1);
 return;
}

function __ZN12FlareManager11DeleteFlareEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 12 >> 2] | 0) + (i2 * 52 | 0) + 49 >> 0] = 0;
 return;
}

function __ZN11AssetBundle6GetAllEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 + 68 >> 2];
 HEAP32[i1 + 4 >> 2] = i2 + 72;
 return;
}

function __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1165844 >> 2] = i1;
 return;
}

function __Z58Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784e3 | 0, fb + 1 | 0);
 return;
}

function __Z57Register_UnityEngine_Vector3_INTERNAL_CALL_SlerpUnclampedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544501 | 0, fb + 5 | 0);
 return;
}

function __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787736 | 0, fb + 3 | 0);
 return;
}

function __Z57Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsulev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783502 | 0, fb + 4 | 0);
 return;
}

function __Z57Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783610 | 0, fb + 1 | 0);
 return;
}

function __Z57Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812407 | 0, fb + 1 | 0);
 return;
}

function __Z56Register_UnityEngine_TerrainData_Internal_SetDetailLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940128 | 0, fb + 35 | 0);
 return;
}

function __Z56Register_UnityEngine_SystemInfo_get_supportsImageEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498868 | 0, fb + 62 | 0);
 return;
}

function __Z56Register_UnityEngine_SystemInfo_get_maxRenderTextureSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500002 | 0, fb + 84 | 0);
 return;
}

function __Z56Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498220 | 0, fb + 49 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics_set_penetrationPenaltyForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784152 | 0, fb + 28 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics_get_penetrationPenaltyForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784103 | 0, fb + 37 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics2D_set_angularSleepTolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810133 | 0, fb + 39 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics2D_get_angularSleepTolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810084 | 0, fb + 48 | 0);
 return;
}

function __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawGUITexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516507 | 0, fb + 25 | 0);
 return;
}

function __Z56Register_UnityEngine_Application_get_streamingAssetsPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494075 | 0, fb + 15 | 0);
 return;
}

function __Z56Register_UnityEngine_Analytics_CustomEventData_AddDoublev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038792 | 0, fb + 1 | 0);
 return;
}

function __Z55Register_UnityEngine_WheelCollider_set_wheelDampingRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836702 | 0, fb + 571 | 0);
 return;
}

function __Z55Register_UnityEngine_WheelCollider_get_wheelDampingRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836654 | 0, fb + 658 | 0);
 return;
}

function __Z55Register_UnityEngine_Texture2D_INTERNAL_CALL_ReadPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572793 | 0, fb + 134 | 0);
 return;
}

function __Z55Register_UnityEngine_SliderJoint2D_get_jointTranslationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821362 | 0, fb + 554 | 0);
 return;
}

function __Z55Register_UnityEngine_Rigidbody_set_sleepAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787465 | 0, fb + 428 | 0);
 return;
}

function __Z55Register_UnityEngine_Rigidbody_get_sleepAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787417 | 0, fb + 495 | 0);
 return;
}

function __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_SetDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784938 | 0, fb + 425 | 0);
 return;
}

function __Z55Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815502 | 0, fb + 871 | 0);
 return;
}

function __Z55Register_UnityEngine_ReflectionProbe_set_shadowDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556432 | 0, fb + 198 | 0);
 return;
}

function __Z55Register_UnityEngine_ReflectionProbe_get_shadowDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556384 | 0, fb + 254 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_get_softVegetationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522659 | 0, fb + 133 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_get_shadowCascadesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521431 | 0, fb + 126 | 0);
 return;
}

function __Z55Register_UnityEngine_Profiling_Profiler_GetSamplerNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554345 | 0, fb + 199 | 0);
 return;
}

function __Z55Register_UnityEngine_Profiling_Profiler_GetMonoUsedSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553967 | 0, fb + 194 | 0);
 return;
}

function __Z55Register_UnityEngine_Profiling_Profiler_GetMonoHeapSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553919 | 0, fb + 193 | 0);
 return;
}

function __Z55Register_UnityEngine_PointEffector2D_set_forceVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824926 | 0, fb + 501 | 0);
 return;
}

function __Z55Register_UnityEngine_PointEffector2D_set_forceMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824830 | 0, fb + 500 | 0);
 return;
}

function __Z55Register_UnityEngine_PointEffector2D_get_forceVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824878 | 0, fb + 580 | 0);
 return;
}

function __Z55Register_UnityEngine_PointEffector2D_get_forceMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824782 | 0, fb + 579 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_get_showColliderContactsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810366 | 0, fb + 240 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_get_changeStopsCallbacksv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809074 | 0, fb + 237 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_set_staticFriction2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796551 | 0, fb + 451 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_set_dynamicFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796177 | 0, fb + 447 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_get_staticFriction2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796503 | 0, fb + 520 | 0);
 return;
}

function __Z55Register_UnityEngine_PhysicMaterial_get_dynamicFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796129 | 0, fb + 516 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_set_gravityModifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652720 | 0, fb + 295 | 0);
 return;
}

function __Z55Register_UnityEngine_ParticleSystem_get_gravityModifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652672 | 0, fb + 352 | 0);
 return;
}

function __Z55Register_UnityEngine_LightmapSettings_get_lightmapsModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533879 | 0, fb + 148 | 0);
 return;
}

function __Z55Register_UnityEngine_Input_get_simulateMouseWithTouchesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538563 | 0, fb + 168 | 0);
 return;
}

function __Z55Register_UnityEngine_Display_SetRenderingResolutionImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512511 | 0, fb + 587 | 0);
 return;
}

function __Z55Register_UnityEngine_ComputeShader_SetTextureFromGlobalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509557 | 0, fb + 228 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterJoint_set_projectionAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790566 | 0, fb + 439 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterJoint_get_projectionAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790518 | 0, fb + 508 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterController_set_stepOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797478 | 0, fb + 455 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterController_set_slopeLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797382 | 0, fb + 454 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterController_get_stepOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797430 | 0, fb + 524 | 0);
 return;
}

function __Z55Register_UnityEngine_CharacterController_get_slopeLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797334 | 0, fb + 523 | 0);
 return;
}

function __Z55Register_UnityEngine_BuoyancyEffector2D_set_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824442 | 0, fb + 496 | 0);
 return;
}

function __Z55Register_UnityEngine_BuoyancyEffector2D_get_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824394 | 0, fb + 575 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioSettings_get_outputSampleRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885104 | 0, fb + 247 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioReverbFilter_set_decayHFRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893177 | 0, fb + 646 | 0);
 return;
}

function __Z55Register_UnityEngine_AudioReverbFilter_get_decayHFRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893129 | 0, fb + 736 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_get_rightFeetBottomHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924329 | 0, fb + 767 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_GetAnimatorTransitionInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921393 | 0, fb + 937 | 0);
 return;
}

function __Z55Register_UnityEngine_AnimationState_set_normalizedSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918147 | 0, fb + 664 | 0);
 return;
}

function __Z55Register_UnityEngine_AnimationState_get_normalizedSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918099 | 0, fb + 756 | 0);
 return;
}

function __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592224 | 0, fb + 252 | 0);
 return;
}

function __Z55Register_UnityEngine_AndroidJNI_CallStaticBooleanMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594087 | 0, fb + 386 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Warpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848218 | 0, fb + 915 | 0);
 return;
}

function __Z54Register_UnityEngine_WheelCollider_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836139 | 0, fb + 3980 | 0);
 return;
}

function __Z54Register_UnityEngine_WheelCollider_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836092 | 0, fb + 3979 | 0);
 return;
}

function __Z54Register_UnityEngine_WebCamTexture_set_requestedHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895859 | 0, fb + 4078 | 0);
 return;
}

function __Z54Register_UnityEngine_WebCamTexture_get_requestedHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895812 | 0, fb + 2522 | 0);
 return;
}

function __Z54Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Pausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895414 | 0, fb + 3795 | 0);
 return;
}

function __Z54Register_UnityEngine_VR_VRSettings_get_eyeTextureWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045433 | 0, fb + 302 | 0);
 return;
}

function __Z54Register_UnityEngine_Transform_INTERNAL_set_localScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578022 | 0, fb + 3147 | 0);
 return;
}

function __Z54Register_UnityEngine_Transform_INTERNAL_get_lossyScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579036 | 0, fb + 3152 | 0);
 return;
}

function __Z54Register_UnityEngine_Transform_INTERNAL_get_localScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577975 | 0, fb + 3146 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_set_realtimeLightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942644 | 0, fb + 4180 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_get_realtimeLightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942597 | 0, fb + 2610 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_GetPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944113 | 0, fb + 4197 | 0);
 return;
}

function __Z54Register_UnityEngine_TerrainData_get_treeInstanceCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940373 | 0, fb + 2598 | 0);
 return;
}

function __Z54Register_UnityEngine_TerrainData_RemoveDetailPrototypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940603 | 0, fb + 4170 | 0);
 return;
}

function __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_targetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821648 | 0, fb + 3900 | 0);
 return;
}

function __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821554 | 0, fb + 3898 | 0);
 return;
}

function __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_targetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821601 | 0, fb + 3899 | 0);
 return;
}

function __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821507 | 0, fb + 3897 | 0);
 return;
}

function __Z54Register_UnityEngine_SurfaceEffector2D_set_useFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826615 | 0, fb + 3924 | 0);
 return;
}

function __Z54Register_UnityEngine_SurfaceEffector2D_get_useFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826568 | 0, fb + 2380 | 0);
 return;
}

function __Z54Register_UnityEngine_SpriteRenderer_SetSprite_INTERNALv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569494 | 0, fb + 3100 | 0);
 return;
}

function __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569588 | 0, fb + 3102 | 0);
 return;
}

function __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569541 | 0, fb + 3101 | 0);
 return;
}

function __Z54Register_UnityEngine_SpriteRenderer_GetSprite_INTERNALv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569447 | 0, fb + 1881 | 0);
 return;
}

function __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_set_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821227 | 0, fb + 3896 | 0);
 return;
}

function __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_get_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821180 | 0, fb + 3895 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813533 | 0, fb + 3840 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813259 | 0, fb + 3837 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813486 | 0, fb + 3839 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813212 | 0, fb + 3836 | 0);
 return;
}

function __Z54Register_UnityEngine_Renderer_set_reflectionProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526990 | 0, fb + 2896 | 0);
 return;
}

function __Z54Register_UnityEngine_Renderer_get_reflectionProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526943 | 0, fb + 1707 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderBufferHelper_SetStoreActionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532060 | 0, fb + 2930 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderBufferHelper_GetStoreActionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532013 | 0, fb + 1730 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_set_boxProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557089 | 0, fb + 3043 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_get_boxProjectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557042 | 0, fb + 1823 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556053 | 0, fb + 3035 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556006 | 0, fb + 3034 | 0);
 return;
}

function __Z54Register_UnityEngine_QualitySettings_set_softParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522612 | 0, fb + 3542 | 0);
 return;
}

function __Z54Register_UnityEngine_PhysicsMaterial2D_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822669 | 0, fb + 3907 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_set_alwaysShowCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810229 | 0, fb + 3739 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleSystem_MainModule_SetLoopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623051 | 0, fb + 3229 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleSystem_MainModule_GetLoopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 623098 | 0, fb + 1974 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleSystem_INTERNAL_CALL_Emitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653687 | 0, fb + 3444 | 0);
 return;
}

function __Z54Register_UnityEngine_OcclusionArea_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518307 | 0, fb + 2854 | 0);
 return;
}

function __Z54Register_UnityEngine_OcclusionArea_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518260 | 0, fb + 2853 | 0);
 return;
}

function __Z54Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Transposev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545383 | 0, fb + 2991 | 0);
 return;
}

function __Z54Register_UnityEngine_MaterialPropertyBlock_get_isEmptyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530658 | 0, fb + 1728 | 0);
 return;
}

function __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireCubev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516284 | 0, fb + 2847 | 0);
 return;
}

function __Z54Register_UnityEngine_GameObject_FindGameObjectsWithTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515804 | 0, fb + 1673 | 0);
 return;
}

function __Z54Register_UnityEngine_GUIUtility_Internal_GetHotControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024659 | 0, fb + 282 | 0);
 return;
}

function __Z54Register_UnityEngine_GUIStyle_Internal_CalcMinMaxWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024413 | 0, fb + 326 | 0);
 return;
}

function __Z54Register_UnityEngine_Effector2D_get_designedForTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823399 | 0, fb + 2368 | 0);
 return;
}

function __Z54Register_UnityEngine_Debug_set_developerConsoleVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511748 | 0, fb + 3491 | 0);
 return;
}

function __Z54Register_UnityEngine_CullingGroup_SetBoundingDistancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510959 | 0, fb + 2820 | 0);
 return;
}

function __Z54Register_UnityEngine_ConstantForce_INTERNAL_set_torquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794267 | 0, fb + 3795 | 0);
 return;
}

function __Z54Register_UnityEngine_ConstantForce_INTERNAL_get_torquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794220 | 0, fb + 3794 | 0);
 return;
}

function __Z54Register_UnityEngine_Canvas_set_referencePixelsPerUnitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015241 | 0, fb + 693 | 0);
 return;
}

function __Z54Register_UnityEngine_Canvas_get_referencePixelsPerUnitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015194 | 0, fb + 792 | 0);
 return;
}

function __Z54Register_UnityEngine_Camera_INTERNAL_set_cullingMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507577 | 0, fb + 2806 | 0);
 return;
}

function __Z54Register_UnityEngine_Camera_INTERNAL_get_cullingMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507530 | 0, fb + 2805 | 0);
 return;
}

function __Z54Register_UnityEngine_BillboardAsset_GetIndicesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501410 | 0, fb + 2771 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSource_set_bypassReverbZonesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888436 | 0, fb + 4062 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSource_get_bypassReverbZonesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888389 | 0, fb + 2503 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSource_INTERNAL_CALL_UnPausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887085 | 0, fb + 3793 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSettings_INTERNAL_CALL_Resetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885346 | 0, fb + 2477 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioListener_GetOutputDataHelperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886254 | 0, fb + 4049 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_set_useGlobalAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823629 | 0, fb + 3914 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_get_useGlobalAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823582 | 0, fb + 2370 | 0);
 return;
}

function __Z54Register_UnityEngine_Application_set_stackTraceLogTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495174 | 0, fb + 3463 | 0);
 return;
}

function __Z54Register_UnityEngine_Application_SetLogCallbackDefinedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495080 | 0, fb + 3462 | 0);
 return;
}

function __Z54Register_UnityEngine_Application_Internal_ExternalCallv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494299 | 0, fb + 3458 | 0);
 return;
}

function __Z54Register_UnityEngine_Animation_INTERNAL_CALL_SyncLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917106 | 0, fb + 4102 | 0);
 return;
}

function __Z54Register_UnityEngine_Analytics_CustomEventData_AddCharv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038359 | 0, fb + 481 | 0);
 return;
}

function __Z54Register_UnityEngine_Analytics_CustomEventData_AddBytev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038406 | 0, fb + 482 | 0);
 return;
}

function __Z54Register_UnityEngine_Analytics_CustomEventData_AddBoolv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1038312 | 0, fb + 480 | 0);
 return;
}

function __Z54Register_UnityEngine_AI_OffMeshLink_set_startTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 853047 | 0, fb + 4044 | 0);
 return;
}

function __Z54Register_UnityEngine_AI_NavMeshPath_DestroyNavMeshPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852091 | 0, fb + 3779 | 0);
 return;
}

function __Z53getPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __Z53Register_UnityEngine_VR_VRSettings_set_showDeviceViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045301 | 0, fb + 3954 | 0);
 return;
}

function __Z53Register_UnityEngine_TextGenerator_get_characterCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011022 | 0, fb + 2674 | 0);
 return;
}

function __Z53Register_UnityEngine_TextGenerator_GetCharactersArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011117 | 0, fb + 2675 | 0);
 return;
}

function __Z53Register_UnityEngine_GUI_INTERNAL_set_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020380 | 0, fb + 3883 | 0);
 return;
}

function __Z53Register_UnityEngine_GUI_INTERNAL_get_backgroundColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020334 | 0, fb + 3882 | 0);
 return;
}

function __Z53Register_UnityEngine_GUIClip_INTERNAL_get_visibleRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1026113 | 0, fb + 3918 | 0);
 return;
}

function __Z53Register_UnityEngine_GUIClip_INTERNAL_get_topmostRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025799 | 0, fb + 3912 | 0);
 return;
}

function __Z53Register_UnityEngine_GUIClip_INTERNAL_CALL_GetTopRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025670 | 0, fb + 3910 | 0);
 return;
}

function __Z53Register_UnityEngine_CanvasRenderer_set_materialCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013853 | 0, fb + 4246 | 0);
 return;
}

function __Z53Register_UnityEngine_CanvasRenderer_get_relativeDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014487 | 0, fb + 2687 | 0);
 return;
}

function __Z53Register_UnityEngine_CanvasRenderer_get_materialCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013807 | 0, fb + 2685 | 0);
 return;
}

function __Z53Register_UnityEngine_CanvasRenderer_get_absoluteDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014607 | 0, fb + 2689 | 0);
 return;
}

function __Z46getPxVehicleEngineDataMDampingRateFullThrottlePKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 92 >> 2]);
}

function __Z44getPxVehicleDriveDynData_EngineRotationSpeedPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 76 >> 2]);
}

function __Z43getPxVehicleSuspensionDataMSpringDamperRatePKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z37setPxParticleReadDataNbValidParticlesPN5physx18PxParticleReadDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z29scripting_class_has_attributeP11Il2CppClassS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_class_has_attribute(i1 | 0, i2 | 0) | 0;
}

function __Z27setPxVehicleWheelDataMWidthPN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z27getPxShape_ConcreteTypeNamePKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z27getPxCloth_ConcreteTypeNamePKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 4 >> 2] | 0, i1 | 0) | 0;
}

function __Z26setPxJointLinearLimitValuePN5physx18PxJointLinearLimitEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z26getPxJoint_ConstraintFlagsPKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
}

function __Z26getNbPxScene_ArticulationsPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 84 >> 2] | 0, i1 | 0) | 0;
}

function __Z25getPxScene_FilterCallbackPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 208 >> 2] | 0, i1 | 0) | 0;
}

function __Z25getPxScene_BroadPhaseTypePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 364 >> 2] | 0, i1 | 0) | 0;
}

function __Z20profiler_begin_framev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) return;
 __ZN13UnityProfiler10BeginFrameEv(i1);
 return;
}

function __Z15GL_CUSTOM_Flushv() {
 var i1 = 0;
 i1 = __Z12GetGfxDevicev() | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 528 >> 2] | 0, i1 | 0);
 return;
}

function __Z12storeAlignedPfjRK8Scalar4f(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 __Z12storeAlignedPfRK8Scalar4f(i2 + i1 | 0, i3);
 return;
}

function __GLOBAL__sub_I_runtime_core_callbacks_lump_cpp() {
 __ZN15GlobalCallbacksC2Ev(gb + 1115728 | 0);
 _memset(gb + 1115296 | 0, 0, 432) | 0;
 return;
}

function _UNITY_FT_Destroy_Class_tt_services(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i2);
 return;
}

function _PxRegisterArticulations(i1) {
 i1 = i1 | 0;
 __ZN5physx24PxvRegisterArticulationsEv();
 __ZN5physx9NpFactory21registerArticulationsEv();
 return;
}

function b92(i1, f2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_vifiiii(92);
}

function b4(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_iiiiiii(4);
 return 0;
}

function b15(i1, i2, f3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_viifiii(15);
}

function ___syscall_ret(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 > 4294963200) {
  HEAP32[(___errno_location() | 0) >> 2] = 0 - i1;
  i1 = -1;
 }
 return i1 | 0;
}

function __ZTv0_n12_NSt3__29strstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD1Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZTv0_n12_NSt3__29strstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD0Ev(i1 + (HEAP32[(HEAP32[i1 >> 2] | 0) + -12 >> 2] | 0) | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + -4 + 92 >> 2] = i1;
 return;
}

function __ZThn32_NK8Renderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + -32 + 288 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNSt3__212__rs_defaultC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[gb + 1470900 >> 2] = (HEAP32[gb + 1470900 >> 2] | 0) + 1;
 return;
}

function __ZNK7Hash12812PackToUInt32Ev(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] ^ HEAP32[i1 >> 2] ^ HEAP32[i1 + 8 >> 2] ^ HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx3Ext7D6Joint29getProjectionAngularToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 380 >> 2]);
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK5physx13NpClothFabric12getPhaseTypeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i2 + 24 >> 2] | 0) + (i1 << 2) >> 2] | 0;
}

function __ZNK17ArchiveFileSystem12LastModifiedERK13FileEntryData(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __ZN8DateTimeC2Ev(i1);
 return;
}

function __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 8 + (i2 + -2 << 2) >> 2] | 0;
}

function __ZN7Hash128C2EPKcj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i1 | 0, i2 | 0, (i3 >>> 0 > 16 ? 16 : i3) | 0) | 0;
 return;
}

function __ZN5physx6shdfnd15atomicIncrementEPVi(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2 + 1;
 return i2 + 1 | 0;
}

function __ZN5physx2Sc7BodySim28notifyAddSpatialAccelerationEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 146 | 0;
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | 2;
 return;
}

function __ZN5physx29resetSerializationRegistryPtrEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1458444 >> 2] | 0;
 HEAP32[gb + 1458444 >> 2] = 0;
 return i1 | 0;
}

function __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx20PxsParticleSystemSim22setSimulationTimeStepVEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 1104 >> 2] = f2;
 return;
}

function __ZN4FMOD8ChannelI4stopEv(i1) {
 i1 = i1 | 0;
 _JS_Sound_Stop(HEAP32[i1 + 164 >> 2] | 0, 0.0);
 __ZN4FMOD8ChannelI11EndCallbackEv(i1);
 return 0;
}

function __ZN27AnimationLayerMixerPlayable13GetParametersEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 100 >> 2] | 0) + (i2 * 12 | 0) | 0;
}

function __ZN27AnimationLayerMixerPlayable13ClearBindingsEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0);
 return;
}

function __ZN19BaseConnectSettingsC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 189424 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return;
}

function __ZN17FileSystemHandler4CopyER13FileEntryDataS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN14UnityAnalyticsD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 188416 + 8;
 __ZN14UnityAnalytics25UnregisterGlobalCallbacksEv(i1);
 return;
}

function __ZN13PhysicsModule29GetColliderMaterialInstanceIDER8Collider(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN8Collider11GetMaterialEv(i2) | 0;
}

function __ZN13PhysicsModule20ConvertContactToMonoEP9Collision(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __Z20ConvertContactToMonoP9Collision(i2) | 0;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper14clearNameStackEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 28 >> 2] = 0;
 HEAP32[i1 + 52 >> 2] = 0;
 return;
}

function __ZN10GUIManager28GetDidGUIWindowsEatLastEventEi(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[gb + 1468156 >> 2] | 0) + 9 + i1 >> 0] | 0) != 0 | 0;
}

function __ZL15DebugInitializeR34UnityVRDeviceSpecificConfiguration(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 124 >> 2] = 1;
 HEAP32[i1 + 140 >> 2] = 3;
 return 1;
}

function __Z56Register_UnityEngine_Vector3_INTERNAL_CALL_RotateTowardsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544671 | 0, fb + 5 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_set_fogStartDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518907 | 0, fb + 4 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_set_ambientIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519651 | 0, fb + 6 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_get_fogStartDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518858 | 0, fb + 4 | 0);
 return;
}

function __Z56Register_UnityEngine_RenderSettings_get_ambientIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519602 | 0, fb + 6 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783396 | 0, fb + 2 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812887 | 0, fb + 3 | 0);
 return;
}

function __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811475 | 0, fb + 1 | 0);
 return;
}

function __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Perspectivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545645 | 0, fb + 1 | 0);
 return;
}

function __Z56Register_UnityEngine_Graphics_Internal_DrawMeshInstancedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532481 | 0, fb + 8 | 0);
 return;
}

function __Z55Register_UnityEngine_Terrain_INTERNAL_CALL_SampleHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943653 | 0, fb + 44 | 0);
 return;
}

function __Z55Register_UnityEngine_SystemInfo_get_usesReversedZBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499324 | 0, fb + 71 | 0);
 return;
}

function __Z55Register_UnityEngine_SystemInfo_get_graphicsShaderLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498514 | 0, fb + 55 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_set_shadowDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521575 | 0, fb + 11 | 0);
 return;
}

function __Z55Register_UnityEngine_QualitySettings_get_shadowDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521527 | 0, fb + 11 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_set_maxAngularCorrectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809402 | 0, fb + 31 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_set_linearSleepTolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810036 | 0, fb + 38 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_get_maxAngularCorrectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809354 | 0, fb + 40 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_get_linearSleepTolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809988 | 0, fb + 47 | 0);
 return;
}

function __Z55Register_UnityEngine_Application_get_webSecurityHostUrlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494829 | 0, fb + 30 | 0);
 return;
}

function __Z55Register_UnityEngine_Application_get_webSecurityEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494781 | 0, fb + 29 | 0);
 return;
}

function __Z55Register_UnityEngine_Application_get_temporaryCachePathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494172 | 0, fb + 17 | 0);
 return;
}

function __Z55Register_UnityEngine_Application_get_persistentDataPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494124 | 0, fb + 16 | 0);
 return;
}

function __Z54Register_UnityEngine_WheelJoint2D_get_jointTranslationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822526 | 0, fb + 562 | 0);
 return;
}

function __Z54Register_UnityEngine_TrailRenderer_set_widthMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528489 | 0, fb + 177 | 0);
 return;
}

function __Z54Register_UnityEngine_TrailRenderer_get_widthMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528442 | 0, fb + 223 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_set_treeLODBiasMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943888 | 0, fb + 683 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_set_treeBillboardDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941840 | 0, fb + 676 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_get_treeLODBiasMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943841 | 0, fb + 782 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_get_treeBillboardDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941793 | 0, fb + 775 | 0);
 return;
}

function __Z54Register_UnityEngine_TerrainData_set_wavingGrassAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939382 | 0, fb + 673 | 0);
 return;
}

function __Z54Register_UnityEngine_TerrainData_get_wavingGrassAmountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939335 | 0, fb + 772 | 0);
 return;
}

function __Z54Register_UnityEngine_TerrainData_Internal_SetAlphamapsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941067 | 0, fb + 194 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785606 | 0, fb + 855 | 0);
 return;
}

function __Z54Register_UnityEngine_RelativeJoint2D_set_angularOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820656 | 0, fb + 478 | 0);
 return;
}

function __Z54Register_UnityEngine_RelativeJoint2D_get_angularOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820609 | 0, fb + 551 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_set_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556245 | 0, fb + 196 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_set_blendDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556995 | 0, fb + 200 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_get_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556198 | 0, fb + 252 | 0);
 return;
}

function __Z54Register_UnityEngine_ReflectionProbe_get_blendDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556948 | 0, fb + 256 | 0);
 return;
}

function __Z54Register_UnityEngine_QualitySettings_get_softParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522565 | 0, fb + 132 | 0);
 return;
}

function __Z54Register_UnityEngine_PointEffector2D_set_distanceScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825021 | 0, fb + 502 | 0);
 return;
}

function __Z54Register_UnityEngine_PointEffector2D_get_distanceScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824974 | 0, fb + 581 | 0);
 return;
}

function __Z54Register_UnityEngine_PlatformEffector2D_set_surfaceArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825951 | 0, fb + 505 | 0);
 return;
}

function __Z54Register_UnityEngine_PlatformEffector2D_get_surfaceArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825904 | 0, fb + 584 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_get_alwaysShowCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810182 | 0, fb + 238 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_GetIgnoreLayerCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811209 | 0, fb + 889 | 0);
 return;
}

function __Z54Register_UnityEngine_PhysicMaterial_set_staticFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796272 | 0, fb + 448 | 0);
 return;
}

function __Z54Register_UnityEngine_PhysicMaterial_get_staticFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796225 | 0, fb + 517 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleSystem_ShapeModule_SetArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629642 | 0, fb + 232 | 0);
 return;
}

function __Z54Register_UnityEngine_ParticleSystem_ShapeModule_GetArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 629689 | 0, fb + 289 | 0);
 return;
}

function __Z54Register_UnityEngine_Mesh_GetAllocArrayFromChannelImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547785 | 0, fb + 146 | 0);
 return;
}

function __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516417 | 0, fb + 123 | 0);
 return;
}

function __Z54Register_UnityEngine_GameObject_GetComponentInChildrenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515016 | 0, fb + 363 | 0);
 return;
}

function __Z54Register_UnityEngine_Debug_get_developerConsoleVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511701 | 0, fb + 104 | 0);
 return;
}

function __Z54Register_UnityEngine_CharacterController_set_skinWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797573 | 0, fb + 456 | 0);
 return;
}

function __Z54Register_UnityEngine_CharacterController_get_skinWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797526 | 0, fb + 525 | 0);
 return;
}

function __Z54Register_UnityEngine_Camera_Internal_RenderToCubemapRTv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507748 | 0, fb + 360 | 0);
 return;
}

function __Z54Register_UnityEngine_BuoyancyEffector2D_set_linearDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824347 | 0, fb + 495 | 0);
 return;
}

function __Z54Register_UnityEngine_BuoyancyEffector2D_get_linearDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824300 | 0, fb + 574 | 0);
 return;
}

function __Z54Register_UnityEngine_Avatar_INTERNAL_CALL_GetLimitSignv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929371 | 0, fb + 952 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSource_GetSpectrumDataHelperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889074 | 0, fb + 305 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_set_roomRolloffv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892992 | 0, fb + 644 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_set_reverbLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893480 | 0, fb + 649 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_set_reverbDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893574 | 0, fb + 650 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_set_lfReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894022 | 0, fb + 655 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_set_hfReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893844 | 0, fb + 653 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_get_roomRolloffv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892945 | 0, fb + 734 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_get_reverbLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893433 | 0, fb + 739 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_get_reverbDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893527 | 0, fb + 740 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_get_lfReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893975 | 0, fb + 745 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioReverbFilter_get_hfReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893797 | 0, fb + 743 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_set_forceVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823817 | 0, fb + 490 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_set_forceMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823723 | 0, fb + 489 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_get_forceVariationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823770 | 0, fb + 569 | 0);
 return;
}

function __Z54Register_UnityEngine_AreaEffector2D_get_forceMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823676 | 0, fb + 568 | 0);
 return;
}

function __Z54Register_UnityEngine_Animator_get_leftFeetBottomHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924282 | 0, fb + 766 | 0);
 return;
}

function __Z54Register_UnityEngine_Animator_GetNextAnimatorStateInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921346 | 0, fb + 936 | 0);
 return;
}

function __Z54Register_UnityEngine_AnimationState_set_normalizedTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917976 | 0, fb + 662 | 0);
 return;
}

function __Z54Register_UnityEngine_AnimationState_get_normalizedTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917929 | 0, fb + 754 | 0);
 return;
}

function __Z54Register_UnityEngine_AnimationState_AddMixingTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918347 | 0, fb + 927 | 0);
 return;
}

function __Z54Register_UnityEngine_AndroidJNI_SetBooleanArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597080 | 0, fb + 717 | 0);
 return;
}

function __Z54Register_UnityEngine_AndroidJNI_GetBooleanArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596662 | 0, fb + 795 | 0);
 return;
}

function __Z54Register_UnityEngine_AndroidJNI_CallStaticStringMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593935 | 0, fb + 384 | 0);
 return;
}

function __Z54Register_UnityEngine_AI_OffMeshLink_get_startTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 853e3 | 0, fb + 2470 | 0);
 return;
}

function __Z54Register_UnityEngine_AI_NavMeshPath_GetCornersNonAllocv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852138 | 0, fb + 918 | 0);
 return;
}

function __Z53Register_UnityEngine_WebCamTexture_set_requestedWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895766 | 0, fb + 4077 | 0);
 return;
}

function __Z53Register_UnityEngine_WebCamTexture_get_requestedWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895720 | 0, fb + 2521 | 0);
 return;
}

function __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895461 | 0, fb + 3796 | 0);
 return;
}

function __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Playv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895368 | 0, fb + 3794 | 0);
 return;
}

function __Z53Register_UnityEngine_VR_VRSettings_get_showDeviceViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045255 | 0, fb + 301 | 0);
 return;
}

function __Z53Register_UnityEngine_VR_VRSettings_get_isDeviceActivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045209 | 0, fb + 300 | 0);
 return;
}

function __Z53Register_UnityEngine_TrailRenderer_set_numCapVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529058 | 0, fb + 2915 | 0);
 return;
}

function __Z53Register_UnityEngine_TrailRenderer_get_numCapVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529012 | 0, fb + 1719 | 0);
 return;
}

function __Z53Register_UnityEngine_Texture_set_anisotropicFilteringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571219 | 0, fb + 3648 | 0);
 return;
}

function __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_Compressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572711 | 0, fb + 3118 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_set_reflectionProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943043 | 0, fb + 4186 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_set_collectDetailPatchesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943981 | 0, fb + 4195 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_get_reflectionProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942997 | 0, fb + 2612 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_get_collectDetailPatchesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943935 | 0, fb + 2617 | 0);
 return;
}

function __Z53Register_UnityEngine_TerrainData_set_detailPrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939998 | 0, fb + 4166 | 0);
 return;
}

function __Z53Register_UnityEngine_TerrainData_get_detailResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939766 | 0, fb + 2594 | 0);
 return;
}

function __Z53Register_UnityEngine_TerrainData_get_detailPrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939952 | 0, fb + 2596 | 0);
 return;
}

function __Z53Register_UnityEngine_SystemInfo_SupportsTextureFormatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499468 | 0, fb + 1602 | 0);
 return;
}

function __Z53Register_UnityEngine_SortingLayer_GetLayerValueFromIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567748 | 0, fb + 1868 | 0);
 return;
}

function __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_set_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821134 | 0, fb + 3894 | 0);
 return;
}

function __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_get_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821088 | 0, fb + 3893 | 0);
 return;
}

function __Z53Register_UnityEngine_SkinnedMeshRenderer_set_rootBonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524005 | 0, fb + 2862 | 0);
 return;
}

function __Z53Register_UnityEngine_SkinnedMeshRenderer_get_rootBonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523959 | 0, fb + 1682 | 0);
 return;
}

function __Z53Register_UnityEngine_Rendering_CommandBuffer_set_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558672 | 0, fb + 3053 | 0);
 return;
}

function __Z53Register_UnityEngine_Rendering_CommandBuffer_get_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558626 | 0, fb + 1833 | 0);
 return;
}

function __Z53Register_UnityEngine_Renderer_get_isPartOfStaticBatchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525217 | 0, fb + 1690 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderTexture_Internal_SetHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574671 | 0, fb + 3121 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderTexture_Internal_GetHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574625 | 0, fb + 1909 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderBufferHelper_SetLoadActionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531967 | 0, fb + 2929 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderBufferHelper_GetLoadActionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531921 | 0, fb + 1729 | 0);
 return;
}

function __Z53Register_UnityEngine_ReflectionProbe_set_bakedTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557583 | 0, fb + 3049 | 0);
 return;
}

function __Z53Register_UnityEngine_ReflectionProbe_get_bakedTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557537 | 0, fb + 1828 | 0);
 return;
}

function __Z53Register_UnityEngine_RectTransform_set_drivenByObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555714 | 0, fb + 3030 | 0);
 return;
}

function __Z53Register_UnityEngine_RectTransform_get_drivenByObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555668 | 0, fb + 1816 | 0);
 return;
}

function __Z53Register_UnityEngine_RectTransform_INTERNAL_set_pivotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555622 | 0, fb + 3029 | 0);
 return;
}

function __Z53Register_UnityEngine_RectTransform_INTERNAL_get_pivotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555576 | 0, fb + 3028 | 0);
 return;
}

function __Z53Register_UnityEngine_Random_INTERNAL_get_onUnitSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554917 | 0, fb + 3632 | 0);
 return;
}

function __Z53Register_UnityEngine_Quaternion_INTERNAL_CALL_Inversev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545064 | 0, fb + 2987 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_set_currentLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521019 | 0, fb + 3528 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_set_blendWeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523420 | 0, fb + 3549 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_set_antiAliasingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523227 | 0, fb + 3548 | 0);
 return;
}

function __Z53Register_UnityEngine_PlatformEffector2D_set_useOneWayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825546 | 0, fb + 3919 | 0);
 return;
}

function __Z53Register_UnityEngine_PlatformEffector2D_get_useOneWayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825500 | 0, fb + 2375 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_set_velocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808654 | 0, fb + 3732 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_set_queriesHitTriggersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808926 | 0, fb + 3736 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_set_positionIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808746 | 0, fb + 3733 | 0);
 return;
}

function __Z53Register_UnityEngine_PhysicMaterial_set_bounceCombinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796741 | 0, fb + 3817 | 0);
 return;
}

function __Z53Register_UnityEngine_PhysicMaterial_get_bounceCombinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796695 | 0, fb + 2317 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_get_particleCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652054 | 0, fb + 2068 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleRenderer_set_lengthScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052764 | 0, fb + 711 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleRenderer_get_lengthScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052718 | 0, fb + 813 | 0);
 return;
}

function __Z53Register_UnityEngine_Object_EnsureRunningOnMainThreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579781 | 0, fb + 3661 | 0);
 return;
}

function __Z53Register_UnityEngine_Motion_INTERNAL_get_averageSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549930 | 0, fb + 3012 | 0);
 return;
}

function __Z53Register_UnityEngine_MonoBehaviour_StopCoroutine_Autov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549667 | 0, fb + 3010 | 0);
 return;
}

function __Z53Register_UnityEngine_LightmapSettings_set_lightProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534021 | 0, fb + 3565 | 0);
 return;
}

function __Z53Register_UnityEngine_Light_set_shadowCustomResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541516 | 0, fb + 2965 | 0);
 return;
}

function __Z53Register_UnityEngine_Light_get_shadowCustomResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541470 | 0, fb + 1762 | 0);
 return;
}

function __Z53Register_UnityEngine_Joint_INTERNAL_get_currentTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788559 | 0, fb + 3717 | 0);
 return;
}

function __Z53Register_UnityEngine_Input_INTERNAL_get_mousePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538432 | 0, fb + 3590 | 0);
 return;
}

function __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_set_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819856 | 0, fb + 3885 | 0);
 return;
}

function __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_get_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819810 | 0, fb + 3884 | 0);
 return;
}

function __Z53Register_UnityEngine_GameObject_get_isStaticBatchablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515613 | 0, fb + 1670 | 0);
 return;
}

function __Z53Register_UnityEngine_GameObject_get_activeInHierarchyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515448 | 0, fb + 1668 | 0);
 return;
}

function __Z53Register_UnityEngine_GameObject_FindGameObjectWithTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515758 | 0, fb + 1672 | 0);
 return;
}

function __Z53Register_UnityEngine_GUIUtility_GetPermanentControlIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024613 | 0, fb + 281 | 0);
 return;
}

function __Z53Register_UnityEngine_ConstantForce_INTERNAL_set_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794066 | 0, fb + 3791 | 0);
 return;
}

function __Z53Register_UnityEngine_ConstantForce_INTERNAL_get_forcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794020 | 0, fb + 3790 | 0);
 return;
}

function __Z53Register_UnityEngine_ConfigurableJoint_set_swapBodiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793974 | 0, fb + 3789 | 0);
 return;
}

function __Z53Register_UnityEngine_ConfigurableJoint_get_swapBodiesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 793928 | 0, fb + 2306 | 0);
 return;
}

function __Z53Register_UnityEngine_Collider2D_get_attachedRigidbodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816519 | 0, fb + 2338 | 0);
 return;
}

function __Z53Register_UnityEngine_Camera_INTERNAL_CALL_ResetAspectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505321 | 0, fb + 3475 | 0);
 return;
}

function __Z53Register_UnityEngine_BillboardAsset_SetImageTexCoordsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501087 | 0, fb + 2766 | 0);
 return;
}

function __Z53Register_UnityEngine_BillboardAsset_GetImageTexCoordsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500987 | 0, fb + 1611 | 0);
 return;
}

function __Z53Register_UnityEngine_Behaviour_get_isActiveAndEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500321 | 0, fb + 1606 | 0);
 return;
}

function __Z53Register_UnityEngine_AudioReverbZone_set_reverbPresetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889679 | 0, fb + 4066 | 0);
 return;
}

function __Z53Register_UnityEngine_AudioReverbZone_get_reverbPresetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889633 | 0, fb + 2507 | 0);
 return;
}

function __Z53Register_UnityEngine_AssetBundleRequest_get_allAssetsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496199 | 0, fb + 1591 | 0);
 return;
}

function __Z53Register_UnityEngine_Application_SetStackTraceLogTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495267 | 0, fb + 2758 | 0);
 return;
}

function __Z53Register_UnityEngine_Application_HasUserAuthorizationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495611 | 0, fb + 1588 | 0);
 return;
}

function __Z53Register_UnityEngine_Application_GetStackTraceLogTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495221 | 0, fb + 1586 | 0);
 return;
}

function __Z53Register_UnityEngine_Animator_CheckIfInIKPassInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923374 | 0, fb + 2571 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_OffMeshLink_set_biDirectionalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852642 | 0, fb + 4040 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_OffMeshLink_get_biDirectionalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852596 | 0, fb + 2466 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_set_walkableMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848929 | 0, fb + 4023 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_get_walkableMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848883 | 0, fb + 2450 | 0);
 return;
}

function __Z53AndroidJNIHelper_CUSTOM_INTERNAL_CALL_CreateJavaProxyP12Il2CppObjectRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z52Register_UnityEngine_TerrainCollider_set_terrainDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1017080 | 0, fb + 4264 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainCollider_get_terrainDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1017035 | 0, fb + 2705 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_set_rndRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051074 | 0, fb + 4443 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_get_rndRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051029 | 0, fb + 2771 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIUtility_set_systemCopyBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025173 | 0, fb + 3907 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIText_Internal_GetPixelOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008573 | 0, fb + 4210 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_SetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1026068 | 0, fb + 3917 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_GetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1026023 | 0, fb + 3916 | 0);
 return;
}

function __Z52Register_UnityEngine_Event_Internal_GetMousePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019455 | 0, fb + 4270 | 0);
 return;
}

function __Z52Register_UnityEngine_Canvas_set_overridePixelPerfectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015333 | 0, fb + 4256 | 0);
 return;
}

function __Z52Register_UnityEngine_Canvas_get_overridePixelPerfectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015288 | 0, fb + 2694 | 0);
 return;
}

function __Z40AndroidJNI_CUSTOM_CallStaticDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0.0;
}

function __Z38Canvas_CUSTOM_GetDefaultCanvasMaterialv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN2UI20GetDefaultUIMaterialEv() | 0) | 0;
}

function __Z36getPxClothMotionConstraintConfigBiasPKN5physx29PxClothMotionConstraintConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z35AudioListener_Set_Custom_PropVolumef(f1) {
 f1 = Math_fround(f1);
 __ZN12AudioManager9SetVolumeEf(__Z15GetAudioManagerv() | 0, f1);
 return;
}

function __Z26setPxVehicleWheelDataMMassPN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z25setPxVehicleWheelDataMMOIPN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z25getPxActor_DominanceGroupPKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
}

function __Z24getPxScene_SpuDispatcherPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 124 >> 2] | 0, i1 | 0) | 0;
}

function __Z24getPxScene_GpuDispatcherPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 120 >> 2] | 0, i1 | 0) | 0;
}

function __Z24getPxScene_CpuDispatcherPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0;
}

function __Z18CleanupUmbraModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIUmbrav() | 0, gb + 63600 | 0);
 __Z9SetIUmbraP6IUmbra(0);
 return;
}

function __Z18CleanupClothModulev() {
 __Z19free_alloc_internalPvRK10MemLabelId(__Z9GetIClothv() | 0, gb + 63400 | 0);
 __Z9SetIClothP6ICloth(0);
 return;
}

function __Z13GetCopyBufferv(i1) {
 i1 = i1 | 0;
 __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_(i1, gb + 1103764 | 0);
 return;
}

function _UNITY_png_get_current_row_number(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = -1;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 368 >> 2] | 0;
 return i1 | 0;
}

function _wcslen(i2) {
 i2 = i2 | 0;
 var i1 = 0;
 i1 = i2;
 while (1) if (!(HEAP32[i1 >> 2] | 0)) break; else i1 = i1 + 4 | 0;
 return i1 - i2 >> 2 | 0;
}

function _wcpncpy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = _wcsncpy(i1, i2, i3) | 0;
 return i1 + ((_wcsnlen(i2, i3) | 0) << 2) | 0;
}

function _glBufferData__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glBufferData(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glGetUniformiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetUniformiv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetUniformfv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetUniformfv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetProgramiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetProgramiv(i1 | 0, i2 | 0, i3 | 0);
}

function ___expo2(d1) {
 d1 = +d1;
 return +(+Math_exp(+(d1 + -1416.0996898839683)) * 2247116418577894884661631.0e283 * 2247116418577894884661631.0e283);
}

function __ZZ24InitializeNavMeshManagervEN23PreUpdateAIUpdatestruct7ForwardEv() {
 __ZN14NavMeshManager6UpdateEv(HEAP32[gb + 1459032 >> 2] | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 452 >> 0] | 0) != 0 | 0;
}

function __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn32_N17BillboardRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 __ZN17BillboardRenderer19UpdateTransformInfoEv(i1 + -32 | 0);
 return;
}

function __ZThn12_N12_GLOBAL__N_110ConnectionD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -12 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 return;
}

function __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210__time_putD2Ev(i1 + 8 | 0);
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE13thousands_sepEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE13decimal_pointEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIwLb0EE13thousands_sepEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIwLb0EE13decimal_pointEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb1EE13thousands_sepEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb1EE13decimal_pointEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb0EE13thousands_sepEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb0EE13decimal_pointEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx3Ext7D6Joint28getProjectionLinearToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 376 >> 2]);
}

function __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene26getVisualizationCullingBoxEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 6136 | 0;
}

function __ZNK5physx2Sc16ArticulationCore17getCacheLinkCountERKNS_9PxcFsDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAPU16[i1 + 8 >> 1] | 0 | 0;
}

function __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK13TranslateGLES17GetTextureSwizzleEN2gl18TextureSwizzleFuncE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 74636 + (i2 << 2 << 2) | 0;
}

function __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Eiiii(i1, 1, 1, 1, 1);
 return;
}

function __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2Eiiii(i1, 0, 0, 0, 0);
 return;
}

function __ZNK10__cxxabiv120__function_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9Texture2D30UpdateImageDataDontTouchMipmapEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 172 >> 2] | 0, i1 | 0);
 return;
}

function __ZN9Scripting30SetCachedPtrOnScriptingWrapperEP12Il2CppObjectP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN8Renderer16TransformChangedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN5physx9NpPhysics11unlockSceneEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[HEAP32[i1 + 16 >> 2] >> 2] | 0);
 return 1;
}

function __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Sc19ShapeInstancePairLLD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 101396 + 8;
 HEAP32[i1 + 8 >> 2] = gb + 101396 + 52;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore17notifyCpuFallbackEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 72 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -65;
 return;
}

function __ZN5physx10PxsContext18setSolverBatchSizeEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[(HEAP32[i2 + 12 >> 2] | 0) + 148 >> 2] = i1;
 return;
}

function __ZN5Umbra4Math5atan2ERKNS_6DoubleES3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+Math_atan2(+(+HEAPF64[i1 >> 3]), +(+HEAPF64[i2 >> 3])));
}

function __ZN4FMOD8ChannelI9isVirtualEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP8[i2 >> 0] = HEAP8[i1 + 162 >> 0] | 0;
 return 0;
}

function __ZN4FMOD8ChannelI9getPausedEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP8[i2 >> 0] = HEAP8[i1 + 161 >> 0] | 0;
 return 0;
}

function __ZN4FMOD8ChannelI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 return 0;
}

function __ZN37AssetBundleLoadFromFileAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN37AssetBundleLoadFromFileAsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN21WorldParticleColliderD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17AnimationPlayable19DeallocateResourcesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 72 >> 0] = 0;
 __ZN8Playable19DeallocateResourcesEv(i1);
 return;
}

function __ZN16MecanimAnimation40GetReadWriteGlobalSpaceSkeletonPoseFenceEPN5Unity9ComponentE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 + 188 | 0;
}

function __ZN14ParticleSystem17SetAutoRandomSeedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 276 >> 0] = i2 & 1;
 return;
}

function __ZN13PhysicsModule18ReleaseHeightFieldEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[HEAP32[i2 >> 2] >> 2] | 0, i2 | 0);
 return;
}

function __ZN13GfxDeviceGLES17BeginProfileEventEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN7ApiGLES15DebugPushMarkerEPKc(i1 + 4620 | 0, i2);
 return;
}

function __ZN11UmbraModule19GetUmbraObjectCountEPKN5Umbra4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5Umbra4Tome14getObjectCountEv(i2) | 0;
}

function __ZN11TimeManager11GetRealtimeEv(i1) {
 i1 = i1 | 0;
 var d2 = 0.0;
 d2 = +__Z19GetTimeSinceStartupv();
 return +(d2 - +HEAPF64[i1 + 160 >> 3]);
}

function __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AxisAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545290 | 0, fb + 6 | 0);
 return;
}

function __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AngleAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544720 | 0, fb + 1 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics_INTERNAL_CALL_CheckCapsulev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783762 | 0, fb + 5 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811632 | 0, fb + 1 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 812732 | 0, fb + 2 | 0);
 return;
}

function __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811951 | 0, fb + 1 | 0);
 return;
}

function __Z55Register_UnityEngine_Animator_INTERNAL_CALL_MatchTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921977 | 0, fb + 1 | 0);
 return;
}

function __Z55Register_UnityEngine_AI_NavMeshAgent_SamplePathPositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848669 | 0, fb + 5 | 0);
 return;
}

function __Z54Register_UnityEngine_Time_set_maximumParticleDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576958 | 0, fb + 18 | 0);
 return;
}

function __Z54Register_UnityEngine_Time_get_maximumParticleDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576911 | 0, fb + 27 | 0);
 return;
}

function __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_RemoveTreesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944187 | 0, fb + 11 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_supportsInstancingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499171 | 0, fb + 68 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_supports3DTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498917 | 0, fb + 63 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_processorFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497991 | 0, fb + 44 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_graphicsMemorySizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498126 | 0, fb + 47 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498365 | 0, fb + 52 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498173 | 0, fb + 48 | 0);
 return;
}

function __Z54Register_UnityEngine_SystemInfo_get_copyTextureSupportv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499073 | 0, fb + 66 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderSettings_set_flareFadeSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520241 | 0, fb + 10 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderSettings_get_flareFadeSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520194 | 0, fb + 10 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_set_maxTranslationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809497 | 0, fb + 32 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_set_maxLinearCorrectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809307 | 0, fb + 30 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_get_maxTranslationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809450 | 0, fb + 41 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics2D_get_maxLinearCorrectionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809260 | 0, fb + 39 | 0);
 return;
}

function __Z54Register_UnityEngine_Graphics_Internal_SetMRTFullSetupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532979 | 0, fb + 12 | 0);
 return;
}

function __Z54Register_UnityEngine_AudioSource_SetScheduledStartTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886918 | 0, fb + 10 | 0);
 return;
}

function __Z54Register_UnityEngine_Application_get_stackTraceLogTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495127 | 0, fb + 33 | 0);
 return;
}

function __Z53Register_UnityEngine_Texture_get_anisotropicFilteringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571173 | 0, fb + 212 | 0);
 return;
}

function __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_SetPixelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572104 | 0, fb + 241 | 0);
 return;
}

function __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572150 | 0, fb + 242 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_set_detailObjectDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942121 | 0, fb + 678 | 0);
 return;
}

function __Z53Register_UnityEngine_Terrain_get_detailObjectDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942075 | 0, fb + 777 | 0);
 return;
}

function __Z53Register_UnityEngine_TerrainData_set_wavingGrassSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939475 | 0, fb + 674 | 0);
 return;
}

function __Z53Register_UnityEngine_TerrainData_get_wavingGrassSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939429 | 0, fb + 773 | 0);
 return;
}

function __Z53Register_UnityEngine_SurfaceEffector2D_set_forceScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826420 | 0, fb + 510 | 0);
 return;
}

function __Z53Register_UnityEngine_SurfaceEffector2D_get_forceScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826374 | 0, fb + 589 | 0);
 return;
}

function __Z53Register_UnityEngine_SliderJoint2D_get_referenceAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821316 | 0, fb + 553 | 0);
 return;
}

function __Z53Register_UnityEngine_Rigidbody_set_maxAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787643 | 0, fb + 430 | 0);
 return;
}

function __Z53Register_UnityEngine_Rigidbody_get_maxAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787597 | 0, fb + 497 | 0);
 return;
}

function __Z53Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785506 | 0, fb + 853 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderSettings_GetRenderSettingsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520798 | 0, fb + 119 | 0);
 return;
}

function __Z53Register_UnityEngine_ReflectionProbe_set_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556338 | 0, fb + 197 | 0);
 return;
}

function __Z53Register_UnityEngine_ReflectionProbe_get_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556292 | 0, fb + 253 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_get_currentLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520973 | 0, fb + 122 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_get_blendWeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523374 | 0, fb + 141 | 0);
 return;
}

function __Z53Register_UnityEngine_QualitySettings_get_antiAliasingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523181 | 0, fb + 138 | 0);
 return;
}

function __Z53Register_UnityEngine_Profiling_Profiler_get_supportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553181 | 0, fb + 187 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783854 | 0, fb + 144 | 0);
 return;
}

function __Z53Register_UnityEngine_PhysicsMaterial2D_set_bouncinessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822762 | 0, fb + 485 | 0);
 return;
}

function __Z53Register_UnityEngine_PhysicsMaterial2D_get_bouncinessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822716 | 0, fb + 564 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_get_velocityIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808608 | 0, fb + 233 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_get_queriesHitTriggersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808880 | 0, fb + 235 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics2D_get_positionIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808700 | 0, fb + 234 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_set_startRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652420 | 0, fb + 293 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_set_startLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652626 | 0, fb + 294 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_set_playbackSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652008 | 0, fb + 290 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_get_startRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652374 | 0, fb + 350 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_get_startLifetimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652580 | 0, fb + 351 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_get_playbackSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651962 | 0, fb + 347 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystemRenderer_SetMeshesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655199 | 0, fb + 767 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystemRenderer_GetMeshesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655153 | 0, fb + 822 | 0);
 return;
}

function __Z53Register_UnityEngine_Material_INTERNAL_CALL_SetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565475 | 0, fb + 652 | 0);
 return;
}

function __Z53Register_UnityEngine_Material_INTERNAL_CALL_GetMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565521 | 0, fb + 653 | 0);
 return;
}

function __Z53Register_UnityEngine_MaterialPropertyBlock_SetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530925 | 0, fb + 600 | 0);
 return;
}

function __Z53Register_UnityEngine_MaterialPropertyBlock_GetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531500 | 0, fb + 643 | 0);
 return;
}

function __Z53Register_UnityEngine_LineRenderer_set_widthMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529609 | 0, fb + 181 | 0);
 return;
}

function __Z53Register_UnityEngine_LineRenderer_get_widthMultiplierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529563 | 0, fb + 227 | 0);
 return;
}

function __Z53Register_UnityEngine_LightmapSettings_get_lightProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533975 | 0, fb + 149 | 0);
 return;
}

function __Z53Register_UnityEngine_Input_get_touchPressureSupportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539081 | 0, fb + 175 | 0);
 return;
}

function __Z53Register_UnityEngine_Input_get_accelerationEventCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538857 | 0, fb + 172 | 0);
 return;
}

function __Z53Register_UnityEngine_HumanTrait_get_RequiredBoneCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929687 | 0, fb + 256 | 0);
 return;
}

function __Z53Register_UnityEngine_Hash128_Internal_Hash128ToStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580688 | 0, fb + 157 | 0);
 return;
}

function __Z53Register_UnityEngine_Graphics_Internal_DrawMeshMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532178 | 0, fb + 124 | 0);
 return;
}

function __Z53Register_UnityEngine_Graphics_ClearRandomWriteTargetsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533156 | 0, fb + 100 | 0);
 return;
}

function __Z53Register_UnityEngine_GUIElement_INTERNAL_CALL_HitTestv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514207 | 0, fb + 362 | 0);
 return;
}

function __Z53Register_UnityEngine_ComputeShader_Internal_SetFloatsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509429 | 0, fb + 576 | 0);
 return;
}

function __Z53Register_UnityEngine_ColorUtility_DoTryParseHtmlColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508661 | 0, fb + 623 | 0);
 return;
}

function __Z53Register_UnityEngine_Cloth_set_worldAccelerationScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841422 | 0, fb + 584 | 0);
 return;
}

function __Z53Register_UnityEngine_Cloth_set_useContinuousCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841034 | 0, fb + 581 | 0);
 return;
}

function __Z53Register_UnityEngine_Cloth_get_worldAccelerationScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841376 | 0, fb + 673 | 0);
 return;
}

function __Z53Register_UnityEngine_Cloth_get_useContinuousCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840988 | 0, fb + 670 | 0);
 return;
}

function __Z53Register_UnityEngine_Caching_INTERNAL_CALL_MarkAsUsedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502121 | 0, fb + 620 | 0);
 return;
}

function __Z53Register_UnityEngine_BuoyancyEffector2D_set_flowAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824536 | 0, fb + 497 | 0);
 return;
}

function __Z53Register_UnityEngine_BuoyancyEffector2D_get_flowAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824490 | 0, fb + 576 | 0);
 return;
}

function __Z53Register_UnityEngine_AvatarBuilder_BuildGenericAvatarv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930082 | 0, fb + 993 | 0);
 return;
}

function __Z53Register_UnityEngine_AudioReverbZone_set_decayHFRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890093 | 0, fb + 616 | 0);
 return;
}

function __Z53Register_UnityEngine_AudioReverbZone_get_decayHFRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890047 | 0, fb + 706 | 0);
 return;
}

function __Z53Register_UnityEngine_Animator_GetNextAnimatorClipInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921645 | 0, fb + 966 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_SetStaticBooleanFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594998 | 0, fb + 710 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_SetObjectArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597438 | 0, fb + 722 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_GetStaticBooleanFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594558 | 0, fb + 789 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_CallStaticShortMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594135 | 0, fb + 387 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850085 | 0, fb + 163 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_set_angularSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849183 | 0, fb + 588 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_set_accelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849275 | 0, fb + 589 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_get_angularSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849137 | 0, fb + 678 | 0);
 return;
}

function __Z53Register_UnityEngine_AI_NavMeshAgent_get_accelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849229 | 0, fb + 679 | 0);
 return;
}

function __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_set_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822481 | 0, fb + 3906 | 0);
 return;
}

function __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_get_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822436 | 0, fb + 3905 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_set_hierarchyCapacityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579411 | 0, fb + 3154 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_get_hierarchyCapacityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579366 | 0, fb + 1931 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_INTERNAL_set_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577830 | 0, fb + 3143 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_INTERNAL_set_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577526 | 0, fb + 3139 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_INTERNAL_get_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577785 | 0, fb + 3142 | 0);
 return;
}

function __Z52Register_UnityEngine_Transform_INTERNAL_get_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577481 | 0, fb + 3138 | 0);
 return;
}

function __Z52Register_UnityEngine_TrailRenderer_set_colorGradientv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528781 | 0, fb + 2912 | 0);
 return;
}

function __Z52Register_UnityEngine_TrailRenderer_get_colorGradientv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528736 | 0, fb + 1716 | 0);
 return;
}

function __Z52Register_UnityEngine_Texture2D_UpdateExternalTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571945 | 0, fb + 3116 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_set_heightmapMaximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942392 | 0, fb + 4178 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_set_drawTreesAndFoliagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943608 | 0, fb + 4193 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_get_heightmapMaximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942347 | 0, fb + 2608 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_get_drawTreesAndFoliagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943563 | 0, fb + 2616 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_CreateTerrainGameObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944424 | 0, fb + 2619 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_set_splatPrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941345 | 0, fb + 4174 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_get_splatPrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941300 | 0, fb + 2605 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_get_heightmapHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938458 | 0, fb + 2590 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_RemoveTreePrototypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940508 | 0, fb + 4169 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938758 | 0, fb + 4163 | 0);
 return;
}

function __Z52Register_UnityEngine_SurfaceEffector2D_set_useBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826707 | 0, fb + 3925 | 0);
 return;
}

function __Z52Register_UnityEngine_SurfaceEffector2D_get_useBouncev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826662 | 0, fb + 2381 | 0);
 return;
}

function __Z52Register_UnityEngine_Sprite_INTERNAL_get_textureRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569036 | 0, fb + 3096 | 0);
 return;
}

function __Z52Register_UnityEngine_SkinnedMeshRenderer_set_qualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524096 | 0, fb + 2863 | 0);
 return;
}

function __Z52Register_UnityEngine_SkinnedMeshRenderer_get_qualityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524051 | 0, fb + 1683 | 0);
 return;
}

function __Z52Register_UnityEngine_Shader_SetGlobalVectorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564313 | 0, fb + 3073 | 0);
 return;
}

function __Z52Register_UnityEngine_Shader_SetGlobalMatrixArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564407 | 0, fb + 3075 | 0);
 return;
}

function __Z52Register_UnityEngine_Shader_GetGlobalVectorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564883 | 0, fb + 1857 | 0);
 return;
}

function __Z52Register_UnityEngine_Shader_GetGlobalMatrixArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564977 | 0, fb + 1858 | 0);
 return;
}

function __Z52Register_UnityEngine_ScriptableObject_CreateInstancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500153 | 0, fb + 1603 | 0);
 return;
}

function __Z52Register_UnityEngine_Screen_set_autorotateToPortraitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534602 | 0, fb + 3568 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784583 | 0, fb + 3680 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786670 | 0, fb + 3700 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786580 | 0, fb + 3698 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784538 | 0, fb + 3679 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786625 | 0, fb + 3699 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_positionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786535 | 0, fb + 3697 | 0);
 return;
}

function __Z52Register_UnityEngine_RenderTexture_Internal_SetWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574580 | 0, fb + 3120 | 0);
 return;
}

function __Z52Register_UnityEngine_RenderTexture_Internal_GetWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574535 | 0, fb + 1908 | 0);
 return;
}

function __Z52Register_UnityEngine_ReflectionProbe_set_refreshModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557394 | 0, fb + 3047 | 0);
 return;
}

function __Z52Register_UnityEngine_ReflectionProbe_set_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556613 | 0, fb + 3039 | 0);
 return;
}

function __Z52Register_UnityEngine_ReflectionProbe_get_refreshModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557349 | 0, fb + 1826 | 0);
 return;
}

function __Z52Register_UnityEngine_ReflectionProbe_get_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556568 | 0, fb + 1821 | 0);
 return;
}

function __Z52Register_UnityEngine_RectTransform_INTERNAL_get_rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555117 | 0, fb + 3019 | 0);
 return;
}

function __Z52Register_UnityEngine_QualitySettings_SetQualityLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520928 | 0, fb + 2858 | 0);
 return;
}

function __Z52Register_UnityEngine_PolygonCollider2D_set_pathCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817829 | 0, fb + 3869 | 0);
 return;
}

function __Z52Register_UnityEngine_PolygonCollider2D_get_pathCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817784 | 0, fb + 2347 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_set_forceTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825369 | 0, fb + 3917 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_set_forceSourcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825279 | 0, fb + 3916 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_get_forceTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825324 | 0, fb + 2373 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_get_forceSourcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825234 | 0, fb + 2372 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics_set_queriesHitBackfacesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783254 | 0, fb + 3727 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_set_showColliderSleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810321 | 0, fb + 3740 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_SetLayerCollisionMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811256 | 0, fb + 3835 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_GetLayerCollisionMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811301 | 0, fb + 2322 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystem_set_maxParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652813 | 0, fb + 3439 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystem_get_maxParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652768 | 0, fb + 2069 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystem_Internal_IsAlivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653642 | 0, fb + 2077 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystem_Internal_EmitOldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653734 | 0, fb + 3445 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystemRenderer_set_meshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655050 | 0, fb + 3451 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleSystemRenderer_get_meshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 655005 | 0, fb + 2081 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_set_minEmissionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050360 | 0, fb + 703 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_set_maxEmissionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050450 | 0, fb + 704 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_get_minEmissionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050315 | 0, fb + 806 | 0);
 return;
}

function __Z52Register_UnityEngine_ParticleEmitter_get_maxEmissionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050405 | 0, fb + 807 | 0);
 return;
}

function __Z52Register_UnityEngine_OcclusionArea_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518399 | 0, fb + 2856 | 0);
 return;
}

function __Z52Register_UnityEngine_OcclusionArea_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518354 | 0, fb + 2855 | 0);
 return;
}

function __Z52Register_UnityEngine_MonoBehaviour_StopAllCoroutinesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549713 | 0, fb + 3615 | 0);
 return;
}

function __Z52Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Inversev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545338 | 0, fb + 2990 | 0);
 return;
}

function __Z52Register_UnityEngine_MaterialPropertyBlock_InitBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530565 | 0, fb + 3553 | 0);
 return;
}

function __Z52Register_UnityEngine_LineRenderer_set_numCapVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530436 | 0, fb + 2927 | 0);
 return;
}

function __Z52Register_UnityEngine_LineRenderer_get_numCapVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530391 | 0, fb + 1726 | 0);
 return;
}

function __Z52Register_UnityEngine_LODGroup_set_animateCrossFadingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540324 | 0, fb + 2956 | 0);
 return;
}

function __Z52Register_UnityEngine_LODGroup_get_animateCrossFadingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540279 | 0, fb + 1754 | 0);
 return;
}

function __Z52Register_UnityEngine_Joint_INTERNAL_get_currentForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788514 | 0, fb + 3716 | 0);
 return;
}

function __Z52Register_UnityEngine_Input_INTERNAL_get_accelerationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538758 | 0, fb + 3593 | 0);
 return;
}

function __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_set_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819765 | 0, fb + 3883 | 0);
 return;
}

function __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_get_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819720 | 0, fb + 3882 | 0);
 return;
}

function __Z52Register_UnityEngine_GameObject_SetActiveRecursivelyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515494 | 0, fb + 2841 | 0);
 return;
}

function __Z52Register_UnityEngine_GUI_InternalRepaintEditorWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021174 | 0, fb + 369 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIUtility_get_systemCopyBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025128 | 0, fb + 285 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIUtility_Internal_GetGUIDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025355 | 0, fb + 286 | 0);
 return;
}

function __Z52Register_UnityEngine_GUIStyle_Internal_GetLineHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023274 | 0, fb + 798 | 0);
 return;
}

function __Z52Register_UnityEngine_Font_RequestCharactersInTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010499 | 0, fb + 322 | 0);
 return;
}

function __Z52Register_UnityEngine_Font_Internal_CreateDynamicFontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010225 | 0, fb + 975 | 0);
 return;
}

function __Z52Register_UnityEngine_Effector2D_get_requiresColliderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823354 | 0, fb + 2367 | 0);
 return;
}

function __Z52Register_UnityEngine_CullingGroup_SetBoundingSpheresv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510712 | 0, fb + 2817 | 0);
 return;
}

function __Z52Register_UnityEngine_CapsuleCollider2D_set_directionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817577 | 0, fb + 3867 | 0);
 return;
}

function __Z52Register_UnityEngine_CapsuleCollider2D_get_directionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817532 | 0, fb + 2345 | 0);
 return;
}

function __Z52Register_UnityEngine_Canvas_GetDefaultCanvasMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016237 | 0, fb + 268 | 0);
 return;
}

function __Z52Register_UnityEngine_Camera_set_transparencySortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503832 | 0, fb + 2780 | 0);
 return;
}

function __Z52Register_UnityEngine_Camera_get_transparencySortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503787 | 0, fb + 1624 | 0);
 return;
}

function __Z52Register_UnityEngine_BoxCollider_INTERNAL_set_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795037 | 0, fb + 3804 | 0);
 return;
}

function __Z52Register_UnityEngine_BoxCollider_INTERNAL_get_centerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794992 | 0, fb + 3803 | 0);
 return;
}

function __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817192 | 0, fb + 3863 | 0);
 return;
}

function __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817147 | 0, fb + 3862 | 0);
 return;
}

function __Z52Register_UnityEngine_BillboardRenderer_set_billboardv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501643 | 0, fb + 2774 | 0);
 return;
}

function __Z52Register_UnityEngine_BillboardRenderer_get_billboardv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501598 | 0, fb + 1614 | 0);
 return;
}

function __Z52Register_UnityEngine_Audio_AudioMixer_set_updateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894596 | 0, fb + 4075 | 0);
 return;
}

function __Z52Register_UnityEngine_Audio_AudioMixer_get_updateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894551 | 0, fb + 2516 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioSource_INTERNAL_CALL_Pausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887040 | 0, fb + 3792 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_reflectionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890184 | 0, fb + 4070 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_reflectionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890139 | 0, fb + 2511 | 0);
 return;
}

function __Z52Register_UnityEngine_Application_set_targetFrameRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494991 | 0, fb + 3461 | 0);
 return;
}

function __Z52Register_UnityEngine_Application_set_runInBackgroundv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493662 | 0, fb + 3456 | 0);
 return;
}

function __Z52Register_UnityEngine_Animator_ApplyBuiltinRootMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924435 | 0, fb + 3817 | 0);
 return;
}

function __Z52Register_UnityEngine_Animation_set_playAutomaticallyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916358 | 0, fb + 4096 | 0);
 return;
}

function __Z52Register_UnityEngine_Animation_get_playAutomaticallyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916313 | 0, fb + 2534 | 0);
 return;
}

function __Z52Register_UnityEngine_Animation_Internal_RewindByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916560 | 0, fb + 4099 | 0);
 return;
}

function __Z52Register_UnityEngine_AnimationCurve_set_postWrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546787 | 0, fb + 2995 | 0);
 return;
}

function __Z52Register_UnityEngine_AnimationCurve_get_postWrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546742 | 0, fb + 1786 | 0);
 return;
}

function __Z52Register_UnityEngine_AnimationClip_SetEventsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916159 | 0, fb + 4094 | 0);
 return;
}

function __Z52Register_UnityEngine_AnimationClip_GetEventsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916204 | 0, fb + 2532 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_set_navMeshLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852777 | 0, fb + 4041 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_set_endTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 853139 | 0, fb + 4045 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_get_navMeshLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852732 | 0, fb + 2467 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_get_endTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 853094 | 0, fb + 2471 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_set_autoBrakingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847852 | 0, fb + 4018 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_get_pathPendingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848026 | 0, fb + 2447 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_get_isPathStalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848071 | 0, fb + 2448 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_get_isOnNavMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849885 | 0, fb + 2456 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_get_autoBrakingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847807 | 0, fb + 2444 | 0);
 return;
}

function __Z51getNbPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z51getNbPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z51Register_UnityEngine_VR_VRSettings_LoadDeviceByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045694 | 0, fb + 3955 | 0);
 return;
}

function __Z51Register_UnityEngine_TextGenerator_GetVerticesArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010978 | 0, fb + 2673 | 0);
 return;
}

function __Z51Register_UnityEngine_TextGenerator_GetLinesInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011204 | 0, fb + 4236 | 0);
 return;
}

function __Z51Register_UnityEngine_GUIUtility_set_keyboardControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025031 | 0, fb + 3905 | 0);
 return;
}

function __Z51Register_UnityEngine_CanvasRenderer_SetAlphaTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014202 | 0, fb + 4249 | 0);
 return;
}

function __Z51Register_UnityEngine_CanvasGroup_set_blocksRaycastsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013156 | 0, fb + 4239 | 0);
 return;
}

function __Z51Register_UnityEngine_CanvasGroup_get_blocksRaycastsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013112 | 0, fb + 2680 | 0);
 return;
}

function __Z50getPxSimulationStatisticsParticlesGpuMeshCacheUsedPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 880 >> 2] | 0;
}

function __Z50getPxSimulationStatisticsParticlesGpuMeshCacheSizePKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 876 >> 2] | 0;
}

function __Z45LightmapSettings_Get_Custom_PropLightmapsModev() {
 return HEAP32[(HEAP32[(__Z19GetLightmapSettingsv() | 0) + 28 >> 2] | 0) + 12 >> 2] | 0;
}

function __Z43GraphicsSettings_CUSTOM_GetGraphicsSettingsv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z19GetGraphicsSettingsv() | 0) | 0;
}

function __Z42getPxVehicleDriveDynData_AutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __Z42getPxVehicleDriveDynDataMAutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __Z41getPxVehicleSuspensionDataMMaxCompressionPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z41AndroidJNI_CUSTOM_CallStaticBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z40setPxSceneDescDynamicTreeRebuildRateHintPN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 124 >> 2] = i1;
 return;
}

function __Z40getPxVehicleSuspensionData_RecipMaxDroopPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 36 >> 2]);
}

function __Z38Physics_Get_Custom_PropBounceThresholdv() {
 return Math_fround(__ZN14PhysicsManager18GetBounceThresholdEv(__Z17GetPhysicsManagerv() | 0));
}

function __Z34GUIUtility_CUSTOM_GrabMouseControli(i1) {
 i1 = i1 | 0;
 HEAP32[(HEAP32[(__Z11GetGUIStatev() | 0) + 276 >> 2] | 0) + 4 >> 2] = i1;
 return;
}

function __Z31setPxSceneDescMeshContactMarginPN5physx11PxSceneDescEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __Z31scripting_method_get_returntype21ScriptingMethodIl2Cpp(i1) {
 i1 = i1 | 0;
 return _il2cpp_method_get_return_type(HEAP32[i1 >> 2] | 0) | 0;
}

function __Z30setPxVehicleTireDataMLatStiffXPN5physx17PxVehicleTireDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z30Compass_Get_Custom_PropEnabledP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return (__ZN15LocationService23IsHeadingUpdatesEnabledEv() | 0) & 1 | 0;
}

function __Z28AllocateNextLowestInstanceIDv() {
 var i1 = 0;
 i1 = (HEAP32[gb + 29188 >> 2] | 0) + -2 | 0;
 HEAP32[gb + 29188 >> 2] = i1;
 return i1 | 0;
}

function __Z27setPxClothParticleInvWeightPN5physx15PxClothParticleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 12 >> 2] = f1;
 return;
}

function __Z27scripting_array_length_safeP11Il2CppArray(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = _il2cpp_array_length(i1 | 0) | 0;
 return i1 | 0;
}

function __Z26setPxCapsuleGeometryRadiusPN5physx17PxCapsuleGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z24getNbPxScene_ConstraintsPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 92 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getPxScene_FrictionTypePKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 288 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getPxScene_FilterShaderPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 204 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getPxScene_CCDMaxPassesPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 268 >> 2] | 0, i1 | 0) | 0;
}

function __Z23getNbPxScene_AggregatesPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 100 >> 2] | 0, i1 | 0) | 0;
}

function __Z23Application_CUSTOM_Quitv() {
 var i1 = 0;
 i1 = __Z15GetInputManagerv() | 0;
 HEAP8[i1 + 189 >> 0] = 1;
 HEAP8[i1 + 188 >> 0] = 1;
 return;
}

function __Z22scripting_gchandle_newP12Il2CppObject(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = -1; else i1 = _il2cpp_gchandle_new(i1 | 0, 1) | 0;
 return i1 | 0;
}

function __Z21getNbPxPhysics_ShapesPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 128 >> 2] | 0, i1 | 0) | 0;
}

function _UNITY_png_get_user_transform_ptr(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 196 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_png_get_current_pass_number(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 8;
  return i1 | 0;
 }
 i1 = HEAP8[i1 + 429 >> 0] | 0;
 return i1 | 0;
}

function _FMOD_Memory_Initialize(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 return 0;
}

function ___cxx_global_var_init9() {
 __Z6simd4fffff(gb + 1097712 | 0, Math_fround(1.0), Math_fround(1.0), Math_fround(1.0), Math_fround(0.0));
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 432 >> 2] | 0) >>> 0) / 3 | 0 | 0;
}

function __ZThn4_N5physx5cloth8SwSolver29setInterCollisionNbIterationsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + -4 + 88 >> 2] = i1;
 return;
}

function __ZNSt13runtime_errorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216304 + 8;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__is_longEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 8 + 3 >> 0] | 0) < 0 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__get_short_sizeEv(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 11 >> 0] | 0 | 0;
}

function __ZNKSt3__211__libcpp_db6unlockEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__212_GLOBAL__N_13mutEv();
 __ZNSt3__25mutex6unlockEv(gb + 1473456 | 0);
 return;
}

function __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 276 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx7NpScene20getMeshContactMarginEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK5physx2Sc5Scene20getMeshContactMarginEv(i1 + 32 | 0));
}

function __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17ValidateIntegrityEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZNK16BaseVideoTexture20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 return Math_imul(HEAP32[i1 + 84 >> 2] << 2, HEAP32[i1 + 88 >> 2] | 0) | 0;
}

function __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 2296 + (i2 << 2) >> 2] | 0;
}

function __ZN9GfxDevice22CopyComputeBufferCountE15ComputeBufferIDS0_j(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN6Avatar17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN8UserList11SendMessageERK17MessageIdentifier(i1 + 76 | 0, gb + 1105876 | 0);
 return;
}

function __ZN5physx9PxTaskMgr7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 256 >> 2] | 0;
}

function __ZN5physx2Sn5ConvX13setReportModeENS_21PxConverterReportMode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 336 >> 2] = i1;
 return;
}

function __ZN5physx2Sc7BodySim26notifyClearSpatialVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 146 | 0;
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | 4;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore20setMaxMotionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 104 >> 2] = f1;
 return;
}

function __ZN5Unity14CharacterJointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN24UserAuthorizationManager33UserAuthorizationManagerOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16LightmapSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN16LightmapSettings7RebuildEv(i1);
 return;
}

function __ZN15ArchiveReadFileD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 70660 + 8;
 __ZN15ArchiveReadFile5CloseEv(i1) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14ParticleSystem18SetMaxNumParticlesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 2548 >> 2] = i2;
 return;
}

function __ZN14DataBufferGLES7ReleaseEv(i1) {
 i1 = i1 | 0;
 __ZN17BufferManagerGLES13ReleaseBufferEP14DataBufferGLES(HEAP32[i1 >> 2] | 0, i1);
 return;
}

function __ZN14DataBufferGLES15RecreateStorageEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14DataBufferGLES16RecreateWithDataEiPKv(i1, i2, 0);
 return;
}

function __ZN13SubstanceData25OnMaterialFinishedLoadingEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + -1;
 return;
}

function __ZN13EmscriptenWWW23HasDownloadedOrMayBlockEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
}

function __ZN11UnityEngine7Connect13ConfigHandler6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 16 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN10GUIManager18GetCursorFlashTimeEi(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[gb + 1468156 >> 2] | 0) + 40 + (i1 << 2) >> 2]);
}

function __Z54Register_UnityEngine_TerrainData_GetInterpolatedHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938916 | 0, fb + 2 | 0);
 return;
}

function __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787689 | 0, fb + 1 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderSettings_set_fogEndDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519003 | 0, fb + 5 | 0);
 return;
}

function __Z54Register_UnityEngine_RenderSettings_get_fogEndDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518956 | 0, fb + 5 | 0);
 return;
}

function __Z54Register_UnityEngine_Physics_INTERNAL_CALL_CheckSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783715 | 0, fb + 3 | 0);
 return;
}

function __Z54Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTry2Dv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508557 | 0, fb + 1 | 0);
 return;
}

function __Z54Register_UnityEngine_AndroidJNI_CallStaticDoubleMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594317 | 0, fb + 2 | 0);
 return;
}

function __Z53Register_UnityEngine_SystemInfo_get_supportsVibrationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499832 | 0, fb + 80 | 0);
 return;
}

function __Z53Register_UnityEngine_SystemInfo_get_supportsGyroscopev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499734 | 0, fb + 78 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_set_sleepAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782695 | 0, fb + 25 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_set_defaultContactOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782443 | 0, fb + 22 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_get_sleepAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782649 | 0, fb + 34 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_get_defaultContactOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782397 | 0, fb + 31 | 0);
 return;
}

function __Z53Register_UnityEngine_GameObject_GetComponentsInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515108 | 0, fb + 83 | 0);
 return;
}

function __Z53Register_UnityEngine_Application_get_bundleIdentifierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494468 | 0, fb + 23 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_CallStaticFloatMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594271 | 0, fb + 23 | 0);
 return;
}

function __Z52Register_UnityEngine_WindZone_set_windPulseMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581730 | 0, fb + 208 | 0);
 return;
}

function __Z52Register_UnityEngine_WindZone_set_windPulseFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581820 | 0, fb + 209 | 0);
 return;
}

function __Z52Register_UnityEngine_WindZone_get_windPulseMagnitudev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581685 | 0, fb + 265 | 0);
 return;
}

function __Z52Register_UnityEngine_WindZone_get_windPulseFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581775 | 0, fb + 266 | 0);
 return;
}

function __Z52Register_UnityEngine_VR_VRStats_get_gpuTimeLastFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045989 | 0, fb + 58 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_set_treeCrossFadeLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941932 | 0, fb + 677 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_set_heightmapPixelErrorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942302 | 0, fb + 680 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_set_detailObjectDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942212 | 0, fb + 679 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_get_treeCrossFadeLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941887 | 0, fb + 776 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_get_heightmapPixelErrorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942257 | 0, fb + 779 | 0);
 return;
}

function __Z52Register_UnityEngine_Terrain_get_detailObjectDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942167 | 0, fb + 778 | 0);
 return;
}

function __Z52Register_UnityEngine_TerrainData_Internal_SetHeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938999 | 0, fb + 192 | 0);
 return;
}

function __Z52Register_UnityEngine_Screen_get_autorotateToPortraitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534557 | 0, fb + 154 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody2D_set_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813625 | 0, fb + 459 | 0);
 return;
}

function __Z52Register_UnityEngine_Rigidbody2D_get_angularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813580 | 0, fb + 527 | 0);
 return;
}

function __Z52Register_UnityEngine_RectOffset_INTERNAL_CALL_Removev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514162 | 0, fb + 589 | 0);
 return;
}

function __Z52Register_UnityEngine_QualitySettings_GetQualityLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520883 | 0, fb + 121 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_set_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825189 | 0, fb + 504 | 0);
 return;
}

function __Z52Register_UnityEngine_PointEffector2D_get_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825144 | 0, fb + 583 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics_get_queriesHitBackfacesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783209 | 0, fb + 232 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics_GetIgnoreLayerCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784280 | 0, fb + 856 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_get_showColliderSleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810276 | 0, fb + 239 | 0);
 return;
}

function __Z52Register_UnityEngine_Mesh_GetBlendShapeFrameVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548301 | 0, fb + 172 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_SetVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565713 | 0, fb + 656 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_SetMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565883 | 0, fb + 660 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_INTERNAL_CALL_SetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565158 | 0, fb + 646 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_INTERNAL_CALL_GetColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565203 | 0, fb + 647 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_GetVectorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566053 | 0, fb + 663 | 0);
 return;
}

function __Z52Register_UnityEngine_Material_GetMatrixArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566223 | 0, fb + 665 | 0);
 return;
}

function __Z52Register_UnityEngine_MaterialPropertyBlock_SetBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530971 | 0, fb + 601 | 0);
 return;
}

function __Z52Register_UnityEngine_HingeJoint2D_get_referenceAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819943 | 0, fb + 545 | 0);
 return;
}

function __Z52Register_UnityEngine_Graphics_DrawProceduralIndirectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532377 | 0, fb + 615 | 0);
 return;
}

function __Z52Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawSpherev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516239 | 0, fb + 166 | 0);
 return;
}

function __Z52Register_UnityEngine_GameObject_GetComponentInParentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515063 | 0, fb + 634 | 0);
 return;
}

function __Z52Register_UnityEngine_GameObject_GetComponentFastPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514928 | 0, fb + 591 | 0);
 return;
}

function __Z52Register_UnityEngine_GameObject_AddComponentInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515154 | 0, fb + 635 | 0);
 return;
}

function __Z52Register_UnityEngine_GUI_INTERNAL_CALL_DoModalWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021219 | 0, fb + 37 | 0);
 return;
}

function __Z52Register_UnityEngine_FixedJoint2D_get_referenceAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822213 | 0, fb + 561 | 0);
 return;
}

function __Z52Register_UnityEngine_Display_GetRenderingBuffersImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512466 | 0, fb + 586 | 0);
 return;
}

function __Z52Register_UnityEngine_CombineInstance_InternalGetMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523828 | 0, fb + 638 | 0);
 return;
}

function __Z52Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYPostQv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929282 | 0, fb + 158 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioSource_GetSpatializerFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889408 | 0, fb + 434 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioSource_GetOutputDataHelperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889029 | 0, fb + 911 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_reverbDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890454 | 0, fb + 618 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889498 | 0, fb + 613 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889588 | 0, fb + 614 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_LFReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890634 | 0, fb + 620 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_set_HFReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890544 | 0, fb + 619 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_reverbDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890409 | 0, fb + 708 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889453 | 0, fb + 703 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889543 | 0, fb + 704 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_LFReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890589 | 0, fb + 710 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbZone_get_HFReferencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890499 | 0, fb + 709 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbFilter_set_diffusionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893666 | 0, fb + 651 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbFilter_set_decayTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893084 | 0, fb + 645 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbFilter_get_diffusionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893621 | 0, fb + 741 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioReverbFilter_get_decayTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893039 | 0, fb + 735 | 0);
 return;
}

function __Z52Register_UnityEngine_AssetBundle_LoadFromMemoryAsyncv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496326 | 0, fb + 613 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_SetStaticStringFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594908 | 0, fb + 708 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_SetStaticObjectFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594953 | 0, fb + 709 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_SetShortArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597215 | 0, fb + 720 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_GetStaticStringFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594454 | 0, fb + 788 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_GetShortArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596797 | 0, fb + 798 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_CallStaticVoidMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594409 | 0, fb + 706 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_CallStaticLongMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594364 | 0, fb + 390 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_CallStaticCharMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594226 | 0, fb + 389 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_CallStaticByteMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594181 | 0, fb + 388 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_set_costOverridev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852551 | 0, fb + 598 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_OffMeshLink_get_costOverridev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852506 | 0, fb + 688 | 0);
 return;
}

function __Z52Register_UnityEngine_AI_NavMeshAgent_FindClosestEdgev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848508 | 0, fb + 917 | 0);
 return;
}

function __Z51Register_UnityEngine_TrailRenderer_set_autodestructv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528870 | 0, fb + 2913 | 0);
 return;
}

function __Z51Register_UnityEngine_TrailRenderer_get_autodestructv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528826 | 0, fb + 1717 | 0);
 return;
}

function __Z51Register_UnityEngine_Texture_set_masterTextureLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571129 | 0, fb + 3647 | 0);
 return;
}

function __Z51Register_UnityEngine_Texture_INTERNAL_get_texelSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571728 | 0, fb + 3114 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_set_treePrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940464 | 0, fb + 4168 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_get_treePrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940420 | 0, fb + 2599 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_get_heightmapWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938414 | 0, fb + 2589 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_get_alphamapLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940759 | 0, fb + 2601 | 0);
 return;
}

function __Z51Register_UnityEngine_Shader_SetGlobalFloatArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564220 | 0, fb + 3071 | 0);
 return;
}

function __Z51Register_UnityEngine_Shader_GetGlobalFloatArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564790 | 0, fb + 1856 | 0);
 return;
}

function __Z51Register_UnityEngine_ShaderVariantCollection_WarmUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567651 | 0, fb + 3645 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody_set_solverIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787187 | 0, fb + 3704 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody_set_detectCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786405 | 0, fb + 3695 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody_get_solverIterationsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787143 | 0, fb + 2287 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody_get_detectCollisionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786361 | 0, fb + 2283 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody_INTERNAL_CALL_WakeUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786988 | 0, fb + 3729 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody2D_set_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813864 | 0, fb + 3842 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody2D_set_freezeRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814724 | 0, fb + 3850 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody2D_get_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813820 | 0, fb + 2324 | 0);
 return;
}

function __Z51Register_UnityEngine_Rigidbody2D_get_freezeRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814680 | 0, fb + 2328 | 0);
 return;
}

function __Z51Register_UnityEngine_Resources_FindObjectsOfTypeAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560508 | 0, fb + 1835 | 0);
 return;
}

function __Z51Register_UnityEngine_Renderer_set_shadowCastingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525483 | 0, fb + 2877 | 0);
 return;
}

function __Z51Register_UnityEngine_Renderer_get_shadowCastingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525439 | 0, fb + 1692 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderTexture_set_isPowerOfTwov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574888 | 0, fb + 3124 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderTexture_set_antiAliasingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575612 | 0, fb + 3132 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderTexture_get_isPowerOfTwov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574844 | 0, fb + 1911 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderTexture_get_antiAliasingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575568 | 0, fb + 1920 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderTexture_ReleaseTemporaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574491 | 0, fb + 3650 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderSettings_set_ambientModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519094 | 0, fb + 3511 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_set_resolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556524 | 0, fb + 3038 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_set_importancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557305 | 0, fb + 3046 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_set_clearFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556702 | 0, fb + 3040 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_get_resolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556480 | 0, fb + 1820 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_get_importancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557261 | 0, fb + 1825 | 0);
 return;
}

function __Z51Register_UnityEngine_ReflectionProbe_get_clearFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556658 | 0, fb + 1822 | 0);
 return;
}

function __Z51Register_UnityEngine_QualitySettings_set_vSyncCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523137 | 0, fb + 3547 | 0);
 return;
}

function __Z51Register_UnityEngine_Profiling_Profiler_set_logFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553271 | 0, fb + 3619 | 0);
 return;
}

function __Z51Register_UnityEngine_Profiling_Profiler_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553463 | 0, fb + 3621 | 0);
 return;
}

function __Z51Register_UnityEngine_Profiling_Profiler_BeginSamplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553557 | 0, fb + 3017 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics_set_queriesHitTriggersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783165 | 0, fb + 3726 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_set_showColliderAABBv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810506 | 0, fb + 3742 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_INTERNAL_set_gravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808836 | 0, fb + 3735 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_INTERNAL_get_gravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 808792 | 0, fb + 3734 | 0);
 return;
}

function __Z51Register_UnityEngine_ParticleSystem_set_scalingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652998 | 0, fb + 3441 | 0);
 return;
}

function __Z51Register_UnityEngine_ParticleSystem_set_playOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651803 | 0, fb + 3434 | 0);
 return;
}

function __Z51Register_UnityEngine_ParticleSystem_get_scalingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652954 | 0, fb + 2071 | 0);
 return;
}

function __Z51Register_UnityEngine_ParticleSystem_get_playOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651759 | 0, fb + 2067 | 0);
 return;
}

function __Z51Register_UnityEngine_MonoBehaviour_set_useGUILayoutv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549802 | 0, fb + 3011 | 0);
 return;
}

function __Z51Register_UnityEngine_MonoBehaviour_get_useGUILayoutv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549758 | 0, fb + 1797 | 0);
 return;
}

function __Z51Register_UnityEngine_LineRenderer_set_useWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530251 | 0, fb + 2925 | 0);
 return;
}

function __Z51Register_UnityEngine_LineRenderer_set_colorGradientv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529895 | 0, fb + 2922 | 0);
 return;
}

function __Z51Register_UnityEngine_LineRenderer_get_useWorldSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530207 | 0, fb + 1724 | 0);
 return;
}

function __Z51Register_UnityEngine_LineRenderer_get_colorGradientv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529851 | 0, fb + 1722 | 0);
 return;
}

function __Z51Register_UnityEngine_LightmapSettings_set_lightmapsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533727 | 0, fb + 3562 | 0);
 return;
}

function __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_springv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788823 | 0, fb + 3723 | 0);
 return;
}

function __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788735 | 0, fb + 3721 | 0);
 return;
}

function __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_springv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788779 | 0, fb + 3722 | 0);
 return;
}

function __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_limitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788691 | 0, fb + 3720 | 0);
 return;
}

function __Z51Register_UnityEngine_GUIUtility_get_keyboardControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024987 | 0, fb + 284 | 0);
 return;
}

function __Z51Register_UnityEngine_GUIUtility_ReleaseMouseControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024833 | 0, fb + 374 | 0);
 return;
}

function __Z51Register_UnityEngine_GL_INTERNAL_CALL_MultiTexCoordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535355 | 0, fb + 2937 | 0);
 return;
}

function __Z51Register_UnityEngine_Effector2D_set_useColliderMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823228 | 0, fb + 3912 | 0);
 return;
}

function __Z51Register_UnityEngine_Effector2D_get_useColliderMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823184 | 0, fb + 2365 | 0);
 return;
}

function __Z51Register_UnityEngine_Compass_INTERNAL_get_rawVectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537601 | 0, fb + 2949 | 0);
 return;
}

function __Z51Register_UnityEngine_Collider_get_attachedRigidbodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794492 | 0, fb + 2308 | 0);
 return;
}

function __Z51Register_UnityEngine_Collider2D_INTERNAL_set_offsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816475 | 0, fb + 3859 | 0);
 return;
}

function __Z51Register_UnityEngine_Collider2D_INTERNAL_get_offsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816431 | 0, fb + 3858 | 0);
 return;
}

function __Z51Register_UnityEngine_Collider2D_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816604 | 0, fb + 3860 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_set_useOcclusionCullingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507486 | 0, fb + 2804 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_get_useOcclusionCullingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507442 | 0, fb + 1641 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_get_actualRenderingPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503418 | 0, fb + 1619 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_ResetStereoViewMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506172 | 0, fb + 3477 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_RemoveAllCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508387 | 0, fb + 3484 | 0);
 return;
}

function __Z51Register_UnityEngine_Caching_set_compressionEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502641 | 0, fb + 3472 | 0);
 return;
}

function __Z51Register_UnityEngine_BillboardAsset_get_vertexCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500818 | 0, fb + 1608 | 0);
 return;
}

function __Z51Register_UnityEngine_BillboardAsset_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500499 | 0, fb + 3469 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioSettings_SetDSPBufferSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885244 | 0, fb + 4047 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioSettings_GetDSPBufferSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885200 | 0, fb + 4046 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioClip_get_preloadAudioDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885738 | 0, fb + 2485 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioClip_get_loadInBackgroundv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885819 | 0, fb + 2487 | 0);
 return;
}

function __Z51Register_UnityEngine_AsyncOperation_InternalDestroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497399 | 0, fb + 3466 | 0);
 return;
}

function __Z51Register_UnityEngine_AreaEffector2D_set_forceTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824070 | 0, fb + 3915 | 0);
 return;
}

function __Z51Register_UnityEngine_AreaEffector2D_get_forceTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824026 | 0, fb + 2371 | 0);
 return;
}

function __Z51Register_UnityEngine_Animator_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919129 | 0, fb + 4116 | 0);
 return;
}

function __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Samplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916649 | 0, fb + 3812 | 0);
 return;
}

function __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Rewindv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916605 | 0, fb + 3811 | 0);
 return;
}

function __Z51Register_UnityEngine_AnimationCurve_set_preWrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546698 | 0, fb + 2994 | 0);
 return;
}

function __Z51Register_UnityEngine_AnimationCurve_get_preWrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546654 | 0, fb + 1785 | 0);
 return;
}

function __Z51Register_UnityEngine_AnimationClip_AddEventInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916115 | 0, fb + 4093 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_EnsureLocalCapacityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592130 | 0, fb + 1954 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_OffMeshLink_UpdatePositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852688 | 0, fb + 3781 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshObstacle_set_carvingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851231 | 0, fb + 4032 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshObstacle_get_carvingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851187 | 0, fb + 2459 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshAgent_set_autoRepathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847941 | 0, fb + 4019 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshAgent_get_pathStatusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848116 | 0, fb + 2449 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshAgent_get_autoRepathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847897 | 0, fb + 2445 | 0);
 return;
}

function __Z51AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedMethod13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z50Register_UnityEngine_TextGenerator_get_vertexCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010888 | 0, fb + 2672 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_set_particlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051364 | 0, fb + 4444 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_get_particlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051321 | 0, fb + 2772 | 0);
 return;
}

function __Z50Register_UnityEngine_JsonUtility_FromJsonOverwritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1037097 | 0, fb + 4427 | 0);
 return;
}

function __Z50Register_UnityEngine_GUI_INTERNAL_set_contentColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020469 | 0, fb + 3885 | 0);
 return;
}

function __Z50Register_UnityEngine_GUI_INTERNAL_get_contentColorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020426 | 0, fb + 3884 | 0);
 return;
}

function __Z50Register_UnityEngine_GUIUtility_set_textFieldInputv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025562 | 0, fb + 3909 | 0);
 return;
}

function __Z50Register_UnityEngine_Event_Internal_SetNativeEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020054 | 0, fb + 3878 | 0);
 return;
}

function __Z50Register_UnityEngine_Canvas_INTERNAL_get_pixelRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015079 | 0, fb + 4255 | 0);
 return;
}

function __Z50Register_UnityEngine_CanvasRenderer_GetPopMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014120 | 0, fb + 1109 | 0);
 return;
}

function __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_DeterminantRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK10Matrix4x4f14GetDeterminantEv(i1));
}

function __Z40getPxJointLimitParametersContactDistancePKN5physx22PxJointLimitParametersE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z40AndroidJNI_CUSTOM_CallStaticStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z39getPxVehicleSuspensionDataMCamberAtRestPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z35RenderTexture_Get_Custom_PropActivev() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__ZN13RenderTexture9GetActiveEi(0) | 0) | 0;
}

function __Z35GUIUtility_Set_Custom_PropMouseUsedh(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) + 272 >> 2] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z29InputTracking_CUSTOM_Recenterv() {
 if (!(__Z12GetIVRDevicev() | 0)) return;
 __ZN8VRDevice8RecenterEv(__Z12GetIVRDevicev() | 0);
 return;
}

function __Z28setPxVehicleWheelDataMRadiusPN5physx18PxVehicleWheelDataEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z25setPxTolerancesScaleSpeedPN5physx17PxTolerancesScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z25setPxJointLimitConeZAnglePN5physx16PxJointLimitConeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 24 >> 2] = f1;
 return;
}

function __Z25setPxJointLimitConeYAnglePN5physx16PxJointLimitConeEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 20 >> 2] = f1;
 return;
}

function __Z23getPxShape_GeometryTypePKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0, i1 | 0) | 0;
}

function __Z22getPxShape_IsExclusivePKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
}

function __Z22getPxScene_TaskManagerPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 388 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getNbPxPhysics_ScenesPKN5physx9PxPhysicsE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 96 >> 2] | 0, i1 | 0) | 0;
}

function __Z19scripting_array_newP11Il2CppClassjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _il2cpp_array_new(i1 | 0, i3 | 0) | 0;
}

function __Z19getPxMaterial_FlagsPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 60 >> 2] | 0, i1 | 0) | 0;
}

function _PxRegisterUnifiedHeightFields(i1) {
 i1 = i1 | 0;
 __ZN5physx23PxvRegisterHeightFieldsEv();
 __ZN5physx2Gu20registerHeightFieldsEv();
 return;
}

function b1(i1, i2, i3, i4, i5, d6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 d6 = +d6;
 nullFunc_iiiiiid(1);
 return 0;
}

function _wcstoul(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _wcstox_528(i1, i2, i3, -1, 0) | 0;
 getTempRet0() | 0;
 return i3 | 0;
}

function _strtoul(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i3 = _strtox_519(i1, i2, i3, -1, 0) | 0;
 getTempRet0() | 0;
 return i3 | 0;
}

function _glFlushMappedBufferRange__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glFlushMappedBufferRange(i1 | 0, i2 | 0, i3 | 0);
}

function _glColorMask__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glColorMask(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glStencilFunc__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glStencilFunc(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGetShaderiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glGetShaderiv(i1 | 0, i2 | 0, i3 | 0);
}

function _dcngettext(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return ((i4 | 0) == 1 ? i2 : i3) | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 184 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 184 | 0;
}

function __ZThn8_N12_GLOBAL__N_110ConnectionD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -8 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn4_N12_GLOBAL__N_110DataStreamD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 __ZN12_GLOBAL__N_110DataStreamD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn4_N12_GLOBAL__N_110ConnectionD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -4 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn32_N16ParticleRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 __ZN16ParticleRenderer19UpdateTransformInfoEv(i1 + -32 | 0);
 return;
}

function __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -116 + 136 >> 2] | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE27__invalidate_iterators_pastEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE27__invalidate_iterators_pastEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__210moneypunctIwLb1EE11frac_digitsEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIwLb0EE11frac_digitsEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb1EE11frac_digitsEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNKSt3__210moneypunctIcLb0EE11frac_digitsEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx7NpScene24getContactModifyCallbackEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene24getContactModifyCallbackEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx7NpCloth22getNbMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore22getNbMotionConstraintsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4sizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx13NpClothFabric15getNbRestvaluesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore15getNbRestvaluesEv(i1 + 16 | 0) | 0;
}

function __ZNK32RendererMaterialAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK13TranslateGLES14GetShaderTitleEN2gl11ShaderStageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75376 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES14GetShaderStageEN2gl11ShaderStageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75352 + (i2 << 2) >> 2] | 0;
}

function __ZNK12CullingGroup11GetDistanceEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAPU8[(HEAP32[i1 + 28 >> 2] | 0) + i2 >> 0] | 0) & 127 | 0;
}

function __ZNK11RemoveByPtr16ShouldRemoveClipEP13AnimationClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) == (i2 | 0) | 0;
}

function __ZN9GfxDevice23IgnoreNextUnresolveOnRSE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 60 >> 2] = i2;
 return;
}

function __ZN6IDList23ShouldBeKeyboardControlE9FocusType(i1) {
 i1 = i1 | 0;
 if (i1 >>> 0 < 3) return (i1 & 1 | 0) != 0 | 0; else return 1;
 return 0;
}

function __ZN5physx6shdfnd10Foundation13setErrorLevelENS_11PxErrorCode4EnumE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 44 >> 2] = i1;
 return;
}

function __ZN5physx5cloth15getNextFabricIdEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1459012 >> 2] | 0;
 HEAP32[gb + 1459012 >> 2] = i1 + 1;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZN5physx2Sn5ConvX7releaseEv(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx2Sn5ConvX11exportInt64Ey(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx2Sn5ConvX6outputEy(i3, i1, i2);
 return;
}

function __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 32 >> 2] = f2;
 return;
}

function __ZN5physx2Sc16ArticulationCore22setSeparationToleranceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 20 >> 2] = f2;
 return;
}

function __ZN5physx2Gu5RTreeC2ERKNS_7PxEMPTYE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i2 = i2 + 84 | 0;
 HEAP32[i2 >> 2] = HEAP32[i2 >> 2] | 1;
 return;
}

function __ZN5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD8ChannelI7getMuteEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP8[i2 >> 0] = HEAP8[i1 + 160 >> 0] | 0;
 return 0;
}

function __ZN4FMOD6SoundI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 return 0;
}

function __ZN20BufferedSocketStream15WouldBlockErrorEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0, i1 | 0) | 0;
}

function __ZN17Physics2DSettings21SetVelocityIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 40 >> 2] = (i2 | 0) > 1 ? i2 : 1;
 return;
}

function __ZN17Physics2DSettings21SetPositionIterationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 44 >> 2] = (i2 | 0) > 1 ? i2 : 1;
 return;
}

function __ZN16Physics2DManager20IsRigidBodyKinematicERK11Rigidbody2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[i2 + 50 >> 0] | 0) != 0 | 0;
}

function __ZN12b2ChainShapeD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 151604 + 8;
 __Z6b2FreePv(HEAP32[i1 + 12 >> 2] | 0);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader13OnReceiveDataEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i3 | 0;
}

function __ZN11AudioSource8DoUpdateEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 33 >> 0] | 0)) return;
 __ZN11AudioSource16UpdateParametersEv(i1);
 return;
}

function __ZN10AtomicNode4LinkEPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 >> 2] = i2;
 return i3 | 0;
}

function __Z53Register_UnityEngine_RenderSettings_set_flareStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520148 | 0, fb + 9 | 0);
 return;
}

function __Z53Register_UnityEngine_RenderSettings_get_flareStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520102 | 0, fb + 9 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_INTERNAL_CALL_RaycastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783299 | 0, fb + 3 | 0);
 return;
}

function __Z53Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783954 | 0, fb + 1 | 0);
 return;
}

function __Z53Register_UnityEngine_ParticleSystem_Internal_Simulatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653426 | 0, fb + 1 | 0);
 return;
}

function __Z53Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawFrustumv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516714 | 0, fb + 5 | 0);
 return;
}

function __Z53Register_UnityEngine_Collider2D_INTERNAL_CALL_Raycastv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816976 | 0, fb + 4 | 0);
 return;
}

function __Z53Register_UnityEngine_Animator_SetLookAtWeightInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920852 | 0, fb + 1 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_SetDoubleArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597392 | 0, fb + 3 | 0);
 return;
}

function __Z53Register_UnityEngine_AndroidJNI_GetDoubleArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596974 | 0, fb + 3 | 0);
 return;
}

function __Z52Register_UnityEngine_SystemInfo_get_systemMemorySizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498081 | 0, fb + 46 | 0);
 return;
}

function __Z52Register_UnityEngine_SystemInfo_get_graphicsDeviceIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498269 | 0, fb + 50 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_set_velocityThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809215 | 0, fb + 29 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_set_contactArrowScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810595 | 0, fb + 40 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_set_baumgarteTOIScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809865 | 0, fb + 36 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_get_velocityThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809170 | 0, fb + 38 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_get_contactArrowScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810550 | 0, fb + 49 | 0);
 return;
}

function __Z52Register_UnityEngine_Physics2D_get_baumgarteTOIScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809820 | 0, fb + 45 | 0);
 return;
}

function __Z52Register_UnityEngine_GL_INTERNAL_CALL_Internal_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536111 | 0, fb + 22 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioSource_SetScheduledEndTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886965 | 0, fb + 11 | 0);
 return;
}

function __Z52Register_UnityEngine_Application_get_targetFrameRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494946 | 0, fb + 31 | 0);
 return;
}

function __Z52Register_UnityEngine_Application_get_submitAnalyticsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495780 | 0, fb + 39 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_SetFloatArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597347 | 0, fb + 53 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_GetFloatArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596929 | 0, fb + 19 | 0);
 return;
}

function __Z51Register_UnityEngine_WebCamTexture_set_requestedFPSv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895676 | 0, fb + 657 | 0);
 return;
}

function __Z51Register_UnityEngine_WebCamTexture_get_requestedFPSv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895632 | 0, fb + 746 | 0);
 return;
}

function __Z51Register_UnityEngine_Transform_INTERNAL_CALL_LookAtv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578354 | 0, fb + 684 | 0);
 return;
}

function __Z51Register_UnityEngine_Texture_get_masterTextureLimitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571085 | 0, fb + 211 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_GetSupportedLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940044 | 0, fb + 164 | 0);
 return;
}

function __Z51Register_UnityEngine_TerrainData_GetAlphamapTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941206 | 0, fb + 999 | 0);
 return;
}

function __Z51Register_UnityEngine_TargetJoint2D_set_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821921 | 0, fb + 481 | 0);
 return;
}

function __Z51Register_UnityEngine_TargetJoint2D_get_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821877 | 0, fb + 557 | 0);
 return;
}

function __Z51Register_UnityEngine_SpringJoint2D_set_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818974 | 0, fb + 470 | 0);
 return;
}

function __Z51Register_UnityEngine_SpringJoint2D_get_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818930 | 0, fb + 540 | 0);
 return;
}

function __Z51Register_UnityEngine_RuntimeUndo_SetTransformParentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560763 | 0, fb + 645 | 0);
 return;
}

function __Z51Register_UnityEngine_RenderSettings_get_ambientModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 519050 | 0, fb + 112 | 0);
 return;
}

function __Z51Register_UnityEngine_QualitySettings_get_vSyncCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523093 | 0, fb + 137 | 0);
 return;
}

function __Z51Register_UnityEngine_Projector_set_orthographicSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527860 | 0, fb + 173 | 0);
 return;
}

function __Z51Register_UnityEngine_Projector_get_orthographicSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527816 | 0, fb + 219 | 0);
 return;
}

function __Z51Register_UnityEngine_Profiling_Profiler_get_logFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553227 | 0, fb + 188 | 0);
 return;
}

function __Z51Register_UnityEngine_Profiling_Profiler_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553419 | 0, fb + 190 | 0);
 return;
}

function __Z51Register_UnityEngine_PlatformEffector2D_set_sideArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826042 | 0, fb + 506 | 0);
 return;
}

function __Z51Register_UnityEngine_PlatformEffector2D_get_sideArcv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825998 | 0, fb + 585 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics_get_queriesHitTriggersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783121 | 0, fb + 231 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics_INTERNAL_CALL_CheckBoxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783810 | 0, fb + 143 | 0);
 return;
}

function __Z51Register_UnityEngine_PhysicsMaterial2D_set_frictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822852 | 0, fb + 486 | 0);
 return;
}

function __Z51Register_UnityEngine_PhysicsMaterial2D_get_frictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822808 | 0, fb + 565 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_get_showColliderAABBv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 810462 | 0, fb + 241 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_IgnoreLayerCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811165 | 0, fb + 870 | 0);
 return;
}

function __Z51Register_UnityEngine_Motion_get_averageAngularSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549886 | 0, fb + 250 | 0);
 return;
}

function __Z51Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Invertv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545430 | 0, fb + 648 | 0);
 return;
}

function __Z51Register_UnityEngine_Material_SetFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565629 | 0, fb + 654 | 0);
 return;
}

function __Z51Register_UnityEngine_Material_SetColorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565799 | 0, fb + 658 | 0);
 return;
}

function __Z51Register_UnityEngine_Material_GetFloatArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565969 | 0, fb + 662 | 0);
 return;
}

function __Z51Register_UnityEngine_Material_GetColorArrayImplListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566139 | 0, fb + 664 | 0);
 return;
}

function __Z51Register_UnityEngine_LightmapSettings_get_lightmapsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533683 | 0, fb + 146 | 0);
 return;
}

function __Z51Register_UnityEngine_Input_get_stylusTouchSupportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539127 | 0, fb + 176 | 0);
 return;
}

function __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929769 | 0, fb + 768 | 0);
 return;
}

function __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMaxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929813 | 0, fb + 769 | 0);
 return;
}

function __Z51Register_UnityEngine_Graphics_Internal_SetMRTSimplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533026 | 0, fb + 127 | 0);
 return;
}

function __Z51Register_UnityEngine_Graphics_Internal_BlitMultiTapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532731 | 0, fb + 237 | 0);
 return;
}

function __Z51Register_UnityEngine_Graphics_Internal_BlitMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532687 | 0, fb + 125 | 0);
 return;
}

function __Z51Register_UnityEngine_GUILayer_INTERNAL_CALL_HitTestv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514629 | 0, fb + 631 | 0);
 return;
}

function __Z51Register_UnityEngine_Cursor_INTERNAL_CALL_SetCursorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511198 | 0, fb + 581 | 0);
 return;
}

function __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_SetPixelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572911 | 0, fb + 135 | 0);
 return;
}

function __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_GetPixelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572955 | 0, fb + 136 | 0);
 return;
}

function __Z51Register_UnityEngine_ComputeShader_Internal_SetIntsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509475 | 0, fb + 577 | 0);
 return;
}

function __Z51Register_UnityEngine_Component_GetComponentFastPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508832 | 0, fb + 572 | 0);
 return;
}

function __Z51Register_UnityEngine_CharacterController_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797096 | 0, fb + 452 | 0);
 return;
}

function __Z51Register_UnityEngine_CharacterController_set_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797184 | 0, fb + 453 | 0);
 return;
}

function __Z51Register_UnityEngine_CharacterController_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797052 | 0, fb + 521 | 0);
 return;
}

function __Z51Register_UnityEngine_CharacterController_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 797140 | 0, fb + 522 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_SetTargetBuffersMRTImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504560 | 0, fb + 552 | 0);
 return;
}

function __Z51Register_UnityEngine_BuoyancyEffector2D_set_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824256 | 0, fb + 494 | 0);
 return;
}

function __Z51Register_UnityEngine_BuoyancyEffector2D_get_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 824212 | 0, fb + 573 | 0);
 return;
}

function __Z51Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYRollv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929327 | 0, fb + 311 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioReverbFilter_set_dryLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892737 | 0, fb + 641 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioReverbFilter_get_dryLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892693 | 0, fb + 731 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioEchoFilter_set_decayRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891719 | 0, fb + 630 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioEchoFilter_get_decayRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891675 | 0, fb + 720 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioChorusFilter_set_feedbackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892553 | 0, fb + 640 | 0);
 return;
}

function __Z51Register_UnityEngine_AudioChorusFilter_get_feedbackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892509 | 0, fb + 730 | 0);
 return;
}

function __Z51Register_UnityEngine_AssetBundle_LoadAsset_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496638 | 0, fb + 356 | 0);
 return;
}

function __Z51Register_UnityEngine_AreaEffector2D_set_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823982 | 0, fb + 492 | 0);
 return;
}

function __Z51Register_UnityEngine_AreaEffector2D_get_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823938 | 0, fb + 571 | 0);
 return;
}

function __Z51Register_UnityEngine_Animator_set_recorderStartTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922938 | 0, fb + 668 | 0);
 return;
}

function __Z51Register_UnityEngine_Animator_get_recorderStartTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922894 | 0, fb + 764 | 0);
 return;
}

function __Z51Register_UnityEngine_Animation_PlayDefaultAnimationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917062 | 0, fb + 956 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_SetStaticShortFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595130 | 0, fb + 713 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_SetLongArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597303 | 0, fb + 262 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_SetCharArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597171 | 0, fb + 719 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_SetByteArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597127 | 0, fb + 718 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_GetStaticShortFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594690 | 0, fb + 792 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_GetLongArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596885 | 0, fb + 800 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_GetCharArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596753 | 0, fb + 797 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_GetByteArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596709 | 0, fb + 796 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_DetachCurrentThreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591141 | 0, fb + 223 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_CallStaticIntMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594043 | 0, fb + 385 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_AttachCurrentThreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591097 | 0, fb + 222 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMesh_TriangulateInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850532 | 0, fb + 242 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshAgent_set_baseOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847372 | 0, fb + 586 | 0);
 return;
}

function __Z51Register_UnityEngine_AI_NavMeshAgent_get_baseOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847328 | 0, fb + 676 | 0);
 return;
}

function __Z50Register_UnityEngine_WWW_get_responseHeadersStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580835 | 0, fb + 1942 | 0);
 return;
}

function __Z50Register_UnityEngine_TrailRenderer_set_textureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529245 | 0, fb + 2916 | 0);
 return;
}

function __Z50Register_UnityEngine_TrailRenderer_get_textureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529202 | 0, fb + 1720 | 0);
 return;
}

function __Z50Register_UnityEngine_Texture_Internal_GetDimensionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571401 | 0, fb + 1888 | 0);
 return;
}

function __Z50Register_UnityEngine_Terrain_set_editorRenderFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944070 | 0, fb + 4196 | 0);
 return;
}

function __Z50Register_UnityEngine_Terrain_get_editorRenderFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944027 | 0, fb + 2618 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_set_treeInstancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940220 | 0, fb + 4167 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_get_treeInstancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940177 | 0, fb + 2597 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_ResetDirtyDetailsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939866 | 0, fb + 3826 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_RefreshPrototypesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939909 | 0, fb + 3827 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938715 | 0, fb + 4162 | 0);
 return;
}

function __Z50Register_UnityEngine_TerrainData_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938672 | 0, fb + 4161 | 0);
 return;
}

function __Z50Register_UnityEngine_SkinnedMeshRenderer_set_bonesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523916 | 0, fb + 2861 | 0);
 return;
}

function __Z50Register_UnityEngine_SkinnedMeshRenderer_get_bonesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523873 | 0, fb + 1681 | 0);
 return;
}

function __Z50Register_UnityEngine_ShaderVariantCollection_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567556 | 0, fb + 3644 | 0);
 return;
}

function __Z50Register_UnityEngine_Rigidbody_set_useConeFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786492 | 0, fb + 3696 | 0);
 return;
}

function __Z50Register_UnityEngine_Rigidbody_get_useConeFrictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786449 | 0, fb + 2284 | 0);
 return;
}

function __Z50Register_UnityEngine_Rigidbody_INTERNAL_CALL_Sleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786897 | 0, fb + 3728 | 0);
 return;
}

function __Z50Register_UnityEngine_Rigidbody2D_set_interpolationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815103 | 0, fb + 3853 | 0);
 return;
}

function __Z50Register_UnityEngine_Rigidbody2D_get_interpolationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815060 | 0, fb + 2333 | 0);
 return;
}

function __Z50Register_UnityEngine_Rendering_CommandBuffer_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 558771 | 0, fb + 3637 | 0);
 return;
}

function __Z50Register_UnityEngine_Renderer_set_sortingLayerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527158 | 0, fb + 2899 | 0);
 return;
}

function __Z50Register_UnityEngine_Renderer_get_staticBatchIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525133 | 0, fb + 1689 | 0);
 return;
}

function __Z50Register_UnityEngine_Renderer_get_sortingLayerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527115 | 0, fb + 1708 | 0);
 return;
}

function __Z50Register_UnityEngine_RenderTexture_set_volumeDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575525 | 0, fb + 3131 | 0);
 return;
}

function __Z50Register_UnityEngine_RenderTexture_get_volumeDepthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575482 | 0, fb + 1919 | 0);
 return;
}

function __Z50Register_UnityEngine_RenderTexture_SupportsStencilv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576471 | 0, fb + 1924 | 0);
 return;
}

function __Z50Register_UnityEngine_QualitySettings_IncreaseLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521065 | 0, fb + 3529 | 0);
 return;
}

function __Z50Register_UnityEngine_QualitySettings_DecreaseLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521108 | 0, fb + 3530 | 0);
 return;
}

function __Z50Register_UnityEngine_Profiling_Sampler_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554527 | 0, fb + 3018 | 0);
 return;
}

function __Z50Register_UnityEngine_Profiling_Sampler_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554484 | 0, fb + 1815 | 0);
 return;
}

function __Z50Register_UnityEngine_Profiling_Profiler_GetSamplerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554302 | 0, fb + 1813 | 0);
 return;
}

function __Z50Register_UnityEngine_PointEffector2D_set_forceModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825457 | 0, fb + 3918 | 0);
 return;
}

function __Z50Register_UnityEngine_PointEffector2D_get_forceModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825414 | 0, fb + 2374 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_set_randomSeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653085 | 0, fb + 3442 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_get_randomSeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653042 | 0, fb + 2072 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_get_isEmittingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651559 | 0, fb + 2063 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_Internal_Pausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653556 | 0, fb + 2075 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_Internal_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653599 | 0, fb + 2076 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_set_minEnergyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050186 | 0, fb + 701 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_set_maxEnergyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050272 | 0, fb + 702 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_get_minEnergyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050143 | 0, fb + 804 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleEmitter_get_maxEnergyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050229 | 0, fb + 805 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleAnimator_set_sizeGrowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052091 | 0, fb + 709 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleAnimator_get_sizeGrowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052048 | 0, fb + 811 | 0);
 return;
}

function __Z50Register_UnityEngine_Object_FindSceneObjectsOfTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580128 | 0, fb + 1937 | 0);
 return;
}

function __Z50Register_UnityEngine_Mesh_PrintErrorCantAccessMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547544 | 0, fb + 2998 | 0);
 return;
}

function __Z50Register_UnityEngine_LineRenderer_set_numPositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529982 | 0, fb + 2923 | 0);
 return;
}

function __Z50Register_UnityEngine_LineRenderer_get_numPositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529939 | 0, fb + 1723 | 0);
 return;
}

function __Z50Register_UnityEngine_Light_RemoveAllCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542694 | 0, fb + 3601 | 0);
 return;
}

function __Z50Register_UnityEngine_Joint_set_enablePreprocessingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788471 | 0, fb + 3715 | 0);
 return;
}

function __Z50Register_UnityEngine_Joint_get_enablePreprocessingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788428 | 0, fb + 2292 | 0);
 return;
}

function __Z50Register_UnityEngine_Input_set_backButtonLeavesAppv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539643 | 0, fb + 3599 | 0);
 return;
}

function __Z50Register_UnityEngine_HingeJoint_INTERNAL_set_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788648 | 0, fb + 3719 | 0);
 return;
}

function __Z50Register_UnityEngine_HingeJoint_INTERNAL_get_motorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788605 | 0, fb + 3718 | 0);
 return;
}

function __Z50Register_UnityEngine_Gyroscope_setEnabled_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537139 | 0, fb + 2947 | 0);
 return;
}

function __Z50Register_UnityEngine_Gyroscope_getEnabled_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537096 | 0, fb + 1736 | 0);
 return;
}

function __Z50Register_UnityEngine_Graphics_GetActiveDepthBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533113 | 0, fb + 3559 | 0);
 return;
}

function __Z50Register_UnityEngine_Graphics_GetActiveColorBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533070 | 0, fb + 3558 | 0);
 return;
}

function __Z50Register_UnityEngine_Graphics_ExecuteCommandBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532617 | 0, fb + 3557 | 0);
 return;
}

function __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawLinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516147 | 0, fb + 2846 | 0);
 return;
}

function __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawCubev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516331 | 0, fb + 2848 | 0);
 return;
}

function __Z50Register_UnityEngine_GameObject_INTERNAL_get_scenev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516104 | 0, fb + 2845 | 0);
 return;
}

function __Z50Register_UnityEngine_GUIUtility_get_textFieldInputv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025519 | 0, fb + 289 | 0);
 return;
}

function __Z50Register_UnityEngine_GUIUtility_get_hasModalWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025476 | 0, fb + 288 | 0);
 return;
}

function __Z50Register_UnityEngine_GUITexture_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514348 | 0, fb + 2833 | 0);
 return;
}

function __Z50Register_UnityEngine_GUITexture_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514305 | 0, fb + 2832 | 0);
 return;
}

function __Z50Register_UnityEngine_EdgeCollider2D_get_pointCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817313 | 0, fb + 2343 | 0);
 return;
}

function __Z50Register_UnityEngine_DynamicGI_set_synchronousModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513090 | 0, fb + 3495 | 0);
 return;
}

function __Z50Register_UnityEngine_CullingGroup_set_targetCamerav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510669 | 0, fb + 2816 | 0);
 return;
}

function __Z50Register_UnityEngine_CullingGroup_get_targetCamerav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510626 | 0, fb + 1653 | 0);
 return;
}

function __Z50Register_UnityEngine_CullingGroup_FinalizerFailurev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511155 | 0, fb + 3488 | 0);
 return;
}

function __Z50Register_UnityEngine_CubemapArray_get_cubemapCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573809 | 0, fb + 1903 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_set_zMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790945 | 0, fb + 3746 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_set_yMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790859 | 0, fb + 3745 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_set_xMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790773 | 0, fb + 3744 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_get_zMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790902 | 0, fb + 2299 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_get_yMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790816 | 0, fb + 2298 | 0);
 return;
}

function __Z50Register_UnityEngine_ConfigurableJoint_get_xMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 790730 | 0, fb + 2297 | 0);
 return;
}

function __Z50Register_UnityEngine_ComputeBuffer_SetCounterValuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509928 | 0, fb + 2813 | 0);
 return;
}

function __Z50Register_UnityEngine_Collider2D_set_usedByEffectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816388 | 0, fb + 3857 | 0);
 return;
}

function __Z50Register_UnityEngine_Collider2D_set_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816730 | 0, fb + 3861 | 0);
 return;
}

function __Z50Register_UnityEngine_Collider2D_get_usedByEffectorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816345 | 0, fb + 2337 | 0);
 return;
}

function __Z50Register_UnityEngine_Collider2D_get_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816687 | 0, fb + 2341 | 0);
 return;
}

function __Z50Register_UnityEngine_CapsuleCollider_set_directionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795963 | 0, fb + 3814 | 0);
 return;
}

function __Z50Register_UnityEngine_CapsuleCollider_get_directionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795920 | 0, fb + 2315 | 0);
 return;
}

function __Z50Register_UnityEngine_CanvasRenderer_SetPopMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014077 | 0, fb + 984 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_set_layerCullSphericalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507976 | 0, fb + 2808 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_set_layerCullDistancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507890 | 0, fb + 2807 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_get_layerCullSphericalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507933 | 0, fb + 1643 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_get_layerCullDistancesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507847 | 0, fb + 1642 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_get_commandBufferCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508469 | 0, fb + 1646 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_INTERNAL_set_pixelRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504400 | 0, fb + 2788 | 0);
 return;
}

function __Z50Register_UnityEngine_Camera_INTERNAL_get_pixelRectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504357 | 0, fb + 2787 | 0);
 return;
}

function __Z50Register_UnityEngine_BoxCollider_INTERNAL_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795125 | 0, fb + 3806 | 0);
 return;
}

function __Z50Register_UnityEngine_BoxCollider_INTERNAL_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795082 | 0, fb + 3805 | 0);
 return;
}

function __Z50Register_UnityEngine_BillboardAsset_get_indexCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500862 | 0, fb + 1609 | 0);
 return;
}

function __Z50Register_UnityEngine_BillboardAsset_get_imageCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500775 | 0, fb + 1607 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_set_bypassEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888244 | 0, fb + 4060 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_get_bypassEffectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888201 | 0, fb + 2501 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSettings_set_speakerModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 884970 | 0, fb + 3787 | 0);
 return;
}

function __Z50Register_UnityEngine_Application_DontDestroyOnLoadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493994 | 0, fb + 3457 | 0);
 return;
}

function __Z50Register_UnityEngine_Application_CaptureScreenshotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493574 | 0, fb + 2757 | 0);
 return;
}

function __Z50Register_UnityEngine_Animator_get_isMatchingTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922068 | 0, fb + 2563 | 0);
 return;
}

function __Z50Register_UnityEngine_Animator_InterruptMatchTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922025 | 0, fb + 4133 | 0);
 return;
}

function __Z50Register_UnityEngine_Animation_Internal_StopByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916517 | 0, fb + 4098 | 0);
 return;
}

function __Z50Register_UnityEngine_AnimationClip_get_humanMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916072 | 0, fb + 2531 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_GetStringUTFLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592623 | 0, fb + 1955 | 0);
 return;
}

function __Z50Register_UnityEngine_AI_NavMeshObstacle_FitExtentsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851909 | 0, fb + 3777 | 0);
 return;
}

function __Z50AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedField13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z49Register_UnityEngine_ParticleRenderer_set_uvTilesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053464 | 0, fb + 4462 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleRenderer_get_uvTilesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1053422 | 0, fb + 2781 | 0);
 return;
}

function __Z49Register_UnityEngine_GUI_INTERNAL_CALL_DragWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021304 | 0, fb + 3892 | 0);
 return;
}

function __Z49Register_UnityEngine_Event_Internal_GetMouseDeltav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019556 | 0, fb + 4272 | 0);
 return;
}

function __Z49Register_UnityEngine_CanvasGroup_set_interactablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013070 | 0, fb + 4238 | 0);
 return;
}

function __Z49Register_UnityEngine_CanvasGroup_get_interactablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013028 | 0, fb + 2679 | 0);
 return;
}

function __Z42getPxClothStretchConfigStiffnessMultiplierPKN5physx20PxClothStretchConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z40getPxVehicleDriveDynDataMGearDownPressedPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 66 >> 0] | 0) != 0 | 0;
}

function __Z40getPxJointLimitParametersBounceThresholdPKN5physx22PxJointLimitParametersE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z40GUIUtility_Get_Custom_PropTextFieldInputv() {
 return (__ZN12InputManager17GetTextFieldInputEv(__Z15GetInputManagerv() | 0) | 0) & 1 | 0;
}

function __Z39AndroidJNI_CUSTOM_CallStaticShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z37setPxSceneLimitsMaxNbObjectsPerRegionPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 28 >> 2] = i1;
 return;
}

function __Z37getPxClothMotionConstraintConfigScalePKN5physx29PxClothMotionConstraintConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z37Physics_Get_Custom_PropSleepThresholdv() {
 return Math_fround(__ZN14PhysicsManager17GetSleepThresholdEv(__Z17GetPhysicsManagerv() | 0));
}

function __Z37AndroidJNI_CUSTOM_SetLongArrayElement13Il2Cpp_IntPtrix(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z36AndroidJNI_CUSTOM_SetStaticLongField13Il2Cpp_IntPtrS_x(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z34DynamicGI_CUSTOM_UpdateEnvironmentv() {
 __ZN14RenderSettings31CalculateAmbientProbeFromSkyboxEv(__Z17GetRenderSettingsv() | 0);
 return;
}

function __Z29scripting_profiler_install_gcPFvPviiEPFvS_xE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_profiler_install_gc(i1 | 0, i2 | 0);
 return;
}

function __Z27setPxD6JointDriveForceLimitPN5physx14PxD6JointDriveEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 8 >> 2] = f1;
 return;
}

function __Z26GetApplicationContentsPathv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem26GetApplicationContentsPathEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function __Z25setPxSphereGeometryRadiusPN5physx16PxSphereGeometryEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z24setPxTolerancesScaleMassPN5physx17PxTolerancesScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z22getPxCloth_NbParticlesPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 88 >> 2] | 0, i1 | 0) | 0;
}

function __Z22getPxActor_OwnerClientPKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 68 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxJoint_ConstraintPKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 104 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxCloth_IsSleepingPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 476 >> 2] | 0, i1 | 0) | 0;
}

function __Z21getPxCloth_ClothFlagsPKN5physx7PxClothE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function __Z20SetStackTraceLogType7LogType17StackTraceLogType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[gb + 73464 + (i1 << 2) >> 2] = i2;
 return;
}

function __Z20Event_CUSTOM_InitPtrP12Il2CppObject13Il2Cpp_IntPtr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __Z15CanChangeInputs9HPlayable(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] & 1 | 0) == 0 | 0;
}

function _UNITY_png_get_chunk_malloc_max(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 636 >> 2] | 0;
 return i1 | 0;
}

function _PxRegisterHeightFields(i1) {
 i1 = i1 | 0;
 __ZN5physx29PxvRegisterLegacyHeightFieldsEv();
 __ZN5physx2Gu20registerHeightFieldsEv();
 return;
}

function _emscripten_glGetUniformLocation__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _emscripten_glGetUniformLocation(i1 | 0, i2 | 0) | 0;
}

function ___fxstatat(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return _fstatat(i2, i3, i4, i5) | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateUpdateAllRenderersstruct7ForwardEv() {
 __ZN13RenderManager18UpdateAllRenderersEv();
 return;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 472 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 472 | 0;
}

function __ZNSt3__28messagesIwEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212228 + 8;
 return;
}

function __ZNSt3__28messagesIcEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 212196 + 8;
 return;
}

function __ZNSt11logic_errorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216284 + 8;
 __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev(i1 + 4 | 0);
 return;
}

function __ZNK9Texture2D20GetUnscaledTextureIDEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP8[i1 + 110 >> 0] | 0 ? i1 + 116 | 0 : i1 + 48 | 0) >> 2] | 0;
}

function __ZNK5physx2Gu10ConvexMesh11getVerticesEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 56 >> 2] | 0) + ((HEAPU8[i1 + 55 >> 0] | 0) * 20 | 0) | 0;
}

function __ZNK5physx2Cm10Collection9getObjectEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i2 + 48 >> 2] | 0) + (i1 << 4) >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i1 + (i2 << 2) >> 2]);
}

function __ZNK26PlayerSettingsSplashScreen40GetSplashScreenBackgroundLandscapeAspectEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 28 >> 2]);
}

function __ZNK10__cxxabiv117__array_type_info9can_catchEPKNS_16__shim_type_infoERPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9UdpSocket24WaitForAvailableRecvDataEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN6Socket24WaitForAvailableRecvDataEl(i1, i2) | 0;
}

function __ZN9ShaderLab10GrabPasses29DidClearAllTempRenderTexturesEv() {
 HEAP32[gb + 1166496 >> 2] = 0;
 HEAP32[gb + 1166496 + 16 >> 2] = 0;
 return;
}

function __ZN9GfxDevice20SetComputeBufferDataE15ComputeBufferIDPKvj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN9Animation6RewindER14AnimationState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14AnimationState7SetTimeEf(i2, Math_fround(0.0));
 return;
}

function __ZN5physx3Cct26CharacterControllerManager16setPreciseSweepsEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 134 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Sq10AABBPruner18updateBucketPrunerEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv(i1 + 144 | 0);
 return;
}

function __ZN5physx2Sn9PtrAccessINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEERKT_PS7_j(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return i2 + (i1 << 1) | 0;
}

function __ZN5physx2Sc7BodySim24notifyAddSpatialVelocityEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 146 | 0;
 HEAP8[i1 >> 0] = HEAPU8[i1 >> 0] | 0 | 4;
 return;
}

function __ZN5physx2Sc7BodySim22postSetKinematicTargetEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 144 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 4;
 return;
}

function __ZN5physx10PxsContext15setCCDMaxPassesEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[(HEAP32[i2 + 16 >> 2] | 0) + 260 >> 2] = i1;
 return;
}

function __ZN5physx10PxsContext14updateCCDBeginEv(i1) {
 i1 = i1 | 0;
 __ZN5physx13PxsCCDContext14updateCCDBeginEv(HEAP32[i1 + 16 >> 2] | 0);
 return;
}

function __ZN5Umbra5Query11setThreadIdEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 88 >> 2] = i2 + 1;
 return;
}

function __ZN4FMOD7SystemI17getRecordPositionEiPj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3 | 0) HEAP32[i3 >> 2] = 0;
 return 0;
}

function __ZN22UnityAnalyticsSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 1;
 HEAP8[i1 + 10 >> 0] = 0;
 return;
}

function __ZN14UnityWebStream14RetainDownloadEP3WWW(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 __ZN3WWW6RetainEv(i2);
 return;
}

function __ZN13PhysicsModule18DeleteMemoryStreamEP19PhysicsModuleStream(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 __ZdlPv(i2);
 return;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader9ClearDoneEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP8[i1 + 5 >> 0] = 0;
 return;
}

function __Z59Application_CUSTOM_GetUserAuthorizationRequestMode_Internalv() {
 return HEAP32[(__Z27GetUserAuthorizationManagerv() | 0) + 4 >> 2] | 0;
}

function __Z52Register_UnityEngine_RenderSettings_set_haloStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520057 | 0, fb + 8 | 0);
 return;
}

function __Z52Register_UnityEngine_RenderSettings_get_haloStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520012 | 0, fb + 8 | 0);
 return;
}

function __Z52Register_UnityEngine_Gradient_INTERNAL_CALL_Evaluatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517076 | 0, fb + 5 | 0);
 return;
}

function __Z52Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508512 | 0, fb + 2 | 0);
 return;
}

function __Z52Register_UnityEngine_AudioSource_SetSpatializerFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889363 | 0, fb + 5 | 0);
 return;
}

function __Z52Register_UnityEngine_Application_get_runInBackgroundv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493617 | 0, fb + 8 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_SetStaticDoubleFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595303 | 0, fb + 2 | 0);
 return;
}

function __Z52Register_UnityEngine_AndroidJNI_GetStaticDoubleFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594863 | 0, fb + 2 | 0);
 return;
}

function __Z51Register_UnityEngine_Texture2DArray_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573609 | 0, fb + 30 | 0);
 return;
}

function __Z51Register_UnityEngine_SystemInfo_get_supportsStencilv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499372 | 0, fb + 72 | 0);
 return;
}

function __Z51Register_UnityEngine_SystemInfo_get_supportsShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498612 | 0, fb + 57 | 0);
 return;
}

function __Z51Register_UnityEngine_SystemInfo_get_operatingSystemv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497855 | 0, fb + 41 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics_set_maxAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782785 | 0, fb + 26 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics_get_maxAngularVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782741 | 0, fb + 35 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_set_maxRotationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809588 | 0, fb + 33 | 0);
 return;
}

function __Z51Register_UnityEngine_Physics2D_get_maxRotationSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809544 | 0, fb + 42 | 0);
 return;
}

function __Z51Register_UnityEngine_MaterialPropertyBlock_SetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530705 | 0, fb + 41 | 0);
 return;
}

function __Z51Register_UnityEngine_MaterialPropertyBlock_GetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531016 | 0, fb + 13 | 0);
 return;
}

function __Z51Register_UnityEngine_Camera_get_PreviewCullingLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504071 | 0, fb + 96 | 0);
 return;
}

function __Z51Register_UnityEngine_Caching_get_compressionEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502597 | 0, fb + 94 | 0);
 return;
}

function __Z51Register_UnityEngine_Application_get_systemLanguagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495036 | 0, fb + 32 | 0);
 return;
}

function __Z51Register_UnityEngine_Application_get_cloudProjectIdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494678 | 0, fb + 28 | 0);
 return;
}

function __Z51Register_UnityEngine_Application_HasAdvancedLicensev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493746 | 0, fb + 10 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_SetStaticFloatFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595259 | 0, fb + 52 | 0);
 return;
}

function __Z51Register_UnityEngine_AndroidJNI_GetStaticFloatFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594819 | 0, fb + 18 | 0);
 return;
}

function __Z50Register_UnityEngine_WheelCollider_set_motorTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837019 | 0, fb + 572 | 0);
 return;
}

function __Z50Register_UnityEngine_WheelCollider_set_brakeTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837105 | 0, fb + 573 | 0);
 return;
}

function __Z50Register_UnityEngine_WheelCollider_get_motorTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836976 | 0, fb + 659 | 0);
 return;
}

function __Z50Register_UnityEngine_WheelCollider_get_brakeTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837062 | 0, fb + 660 | 0);
 return;
}

function __Z50Register_UnityEngine_VR_VRSettings_set_renderScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045390 | 0, fb + 43 | 0);
 return;
}

function __Z50Register_UnityEngine_VR_VRSettings_get_renderScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045347 | 0, fb + 55 | 0);
 return;
}

function __Z50Register_UnityEngine_SparseTexture_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574235 | 0, fb + 176 | 0);
 return;
}

function __Z50Register_UnityEngine_RenderTexture_DiscardContentsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575959 | 0, fb + 680 | 0);
 return;
}

function __Z50Register_UnityEngine_RelativeJoint2D_set_maxTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820252 | 0, fb + 476 | 0);
 return;
}

function __Z50Register_UnityEngine_RelativeJoint2D_get_maxTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820209 | 0, fb + 549 | 0);
 return;
}

function __Z50Register_UnityEngine_ReflectionProbe_set_intensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556905 | 0, fb + 199 | 0);
 return;
}

function __Z50Register_UnityEngine_ReflectionProbe_get_intensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 556862 | 0, fb + 255 | 0);
 return;
}

function __Z50Register_UnityEngine_PhysicMaterial_set_bouncinessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796362 | 0, fb + 449 | 0);
 return;
}

function __Z50Register_UnityEngine_PhysicMaterial_get_bouncinessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 796319 | 0, fb + 518 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_set_startSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652143 | 0, fb + 291 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_set_startDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651474 | 0, fb + 288 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_get_startSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652100 | 0, fb + 348 | 0);
 return;
}

function __Z50Register_UnityEngine_ParticleSystem_get_startDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651431 | 0, fb + 344 | 0);
 return;
}

function __Z50Register_UnityEngine_Motion_ValidateIfRetargetablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550117 | 0, fb + 660 | 0);
 return;
}

function __Z50Register_UnityEngine_Input_get_backButtonLeavesAppv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539600 | 0, fb + 183 | 0);
 return;
}

function __Z50Register_UnityEngine_Graphics_Internal_SetRTSimplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532936 | 0, fb + 126 | 0);
 return;
}

function __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516374 | 0, fb + 122 | 0);
 return;
}

function __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawIconv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516464 | 0, fb + 592 | 0);
 return;
}

function __Z50Register_UnityEngine_GameObject_SendMessageUpwardsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515851 | 0, fb + 233 | 0);
 return;
}

function __Z50Register_UnityEngine_GameObject_GetComponentByNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514973 | 0, fb + 633 | 0);
 return;
}

function __Z50Register_UnityEngine_FrictionJoint2D_set_maxTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819519 | 0, fb + 474 | 0);
 return;
}

function __Z50Register_UnityEngine_FrictionJoint2D_get_maxTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819476 | 0, fb + 544 | 0);
 return;
}

function __Z50Register_UnityEngine_FixedJoint2D_set_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822090 | 0, fb + 483 | 0);
 return;
}

function __Z50Register_UnityEngine_FixedJoint2D_get_dampingRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822047 | 0, fb + 559 | 0);
 return;
}

function __Z50Register_UnityEngine_DynamicGI_get_synchronousModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513047 | 0, fb + 106 | 0);
 return;
}

function __Z50Register_UnityEngine_ComputeBuffer_InternalSetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509885 | 0, fb + 578 | 0);
 return;
}

function __Z50Register_UnityEngine_ComputeBuffer_InternalGetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509971 | 0, fb + 579 | 0);
 return;
}

function __Z50Register_UnityEngine_Cloth_set_useVirtualParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841123 | 0, fb + 582 | 0);
 return;
}

function __Z50Register_UnityEngine_Cloth_set_stretchingStiffnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840260 | 0, fb + 577 | 0);
 return;
}

function __Z50Register_UnityEngine_Cloth_get_useVirtualParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841080 | 0, fb + 671 | 0);
 return;
}

function __Z50Register_UnityEngine_Cloth_get_stretchingStiffnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840217 | 0, fb + 666 | 0);
 return;
}

function __Z50Register_UnityEngine_Audio_AudioMixer_FindSnapshotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894456 | 0, fb + 943 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_set_rolloffFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889320 | 0, fb + 612 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_set_reverbZoneMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888158 | 0, fb + 605 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_get_rolloffFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889277 | 0, fb + 702 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSource_get_reverbZoneMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888115 | 0, fb + 695 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioSettings_get_speakerModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 884927 | 0, fb + 245 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbZone_set_diffusionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890824 | 0, fb + 622 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbZone_set_decayTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890004 | 0, fb + 615 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbZone_get_diffusionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890781 | 0, fb + 712 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbZone_get_decayTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889961 | 0, fb + 705 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbFilter_set_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893754 | 0, fb + 652 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioReverbFilter_get_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893711 | 0, fb + 742 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892222 | 0, fb + 636 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892136 | 0, fb + 635 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix1v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892050 | 0, fb + 634 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892179 | 0, fb + 726 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892093 | 0, fb + 725 | 0);
 return;
}

function __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix1v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892007 | 0, fb + 724 | 0);
 return;
}

function __Z50Register_UnityEngine_AssetBundle_LoadFromFileAsyncv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496245 | 0, fb + 143 | 0);
 return;
}

function __Z50Register_UnityEngine_AreaEffector2D_set_forceAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823539 | 0, fb + 488 | 0);
 return;
}

function __Z50Register_UnityEngine_AreaEffector2D_get_forceAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823496 | 0, fb + 567 | 0);
 return;
}

function __Z50Register_UnityEngine_Animator_set_recorderStopTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923025 | 0, fb + 669 | 0);
 return;
}

function __Z50Register_UnityEngine_Animator_get_recorderStopTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922982 | 0, fb + 765 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_SetStaticLongFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595216 | 0, fb + 260 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_SetStaticCharFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595087 | 0, fb + 712 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_SetStaticByteFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595044 | 0, fb + 711 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_SetIntArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 597260 | 0, fb + 721 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_GetStaticLongFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594776 | 0, fb + 794 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_GetStaticCharFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594647 | 0, fb + 791 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_GetStaticByteFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594604 | 0, fb + 790 | 0);
 return;
}

function __Z50Register_UnityEngine_AndroidJNI_GetIntArrayElementv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596842 | 0, fb + 799 | 0);
 return;
}

function __Z50Register_UnityEngine_AI_NavMeshObstacle_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851036 | 0, fb + 595 | 0);
 return;
}

function __Z50Register_UnityEngine_AI_NavMeshObstacle_set_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850950 | 0, fb + 594 | 0);
 return;
}

function __Z50Register_UnityEngine_AI_NavMeshObstacle_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850993 | 0, fb + 685 | 0);
 return;
}

function __Z50Register_UnityEngine_AI_NavMeshObstacle_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850907 | 0, fb + 684 | 0);
 return;
}

function __Z49Register_UnityEngine_WheelCollider_get_isGroundedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837232 | 0, fb + 2430 | 0);
 return;
}

function __Z49Register_UnityEngine_WebCamTexture_set_deviceNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895590 | 0, fb + 4076 | 0);
 return;
}

function __Z49Register_UnityEngine_WebCamTexture_get_deviceNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895548 | 0, fb + 2520 | 0);
 return;
}

function __Z49Register_UnityEngine_Transform_set_parentInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578111 | 0, fb + 3148 | 0);
 return;
}

function __Z49Register_UnityEngine_Transform_get_parentInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578069 | 0, fb + 1925 | 0);
 return;
}

function __Z49Register_UnityEngine_Transform_get_hierarchyCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579456 | 0, fb + 1932 | 0);
 return;
}

function __Z49Register_UnityEngine_TrailRenderer_set_widthCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528400 | 0, fb + 2907 | 0);
 return;
}

function __Z49Register_UnityEngine_TrailRenderer_get_widthCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528358 | 0, fb + 1715 | 0);
 return;
}

function __Z49Register_UnityEngine_Terrain_set_materialTemplatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943263 | 0, fb + 4189 | 0);
 return;
}

function __Z49Register_UnityEngine_Terrain_get_materialTemplatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943221 | 0, fb + 2614 | 0);
 return;
}

function __Z49Register_UnityEngine_TerrainData_get_detailHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939670 | 0, fb + 2593 | 0);
 return;
}

function __Z49Register_UnityEngine_SparseTexture_get_tileHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574152 | 0, fb + 1906 | 0);
 return;
}

function __Z49Register_UnityEngine_SliderJoint2D_get_limitStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821274 | 0, fb + 2362 | 0);
 return;
}

function __Z49Register_UnityEngine_SkinnedMeshRenderer_BakeMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524583 | 0, fb + 2869 | 0);
 return;
}

function __Z49Register_UnityEngine_Screen_get_currentResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534322 | 0, fb + 3566 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody_set_freezeRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785286 | 0, fb + 3685 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody_get_freezeRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785244 | 0, fb + 2280 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody2D_SetDragBehaviourv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814450 | 0, fb + 3847 | 0);
 return;
}

function __Z49Register_UnityEngine_Renderer_set_sharedMaterialsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525951 | 0, fb + 2883 | 0);
 return;
}

function __Z49Register_UnityEngine_Renderer_set_lightProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526713 | 0, fb + 2893 | 0);
 return;
}

function __Z49Register_UnityEngine_Renderer_get_sharedMaterialsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525909 | 0, fb + 1698 | 0);
 return;
}

function __Z49Register_UnityEngine_Renderer_get_lightProbeUsagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526671 | 0, fb + 1704 | 0);
 return;
}

function __Z49Register_UnityEngine_Renderer_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525993 | 0, fb + 2884 | 0);
 return;
}

function __Z49Register_UnityEngine_RenderTexture_GetDepthBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576159 | 0, fb + 3135 | 0);
 return;
}

function __Z49Register_UnityEngine_RenderTexture_GetColorBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576117 | 0, fb + 3134 | 0);
 return;
}

function __Z49Register_UnityEngine_Random_INTERNAL_get_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554963 | 0, fb + 3633 | 0);
 return;
}

function __Z49Register_UnityEngine_PolygonCollider2D_set_pointsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817664 | 0, fb + 3868 | 0);
 return;
}

function __Z49Register_UnityEngine_PolygonCollider2D_get_pointsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817622 | 0, fb + 2346 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics_INTERNAL_set_gravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782255 | 0, fb + 3723 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics_INTERNAL_get_gravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782213 | 0, fb + 3722 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_get_isStoppedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651602 | 0, fb + 2064 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_get_isPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651517 | 0, fb + 2062 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_Internal_Playv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653472 | 0, fb + 2074 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleAnimator_set_dampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052378 | 0, fb + 710 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleAnimator_get_dampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1052336 | 0, fb + 812 | 0);
 return;
}

function __Z49Register_UnityEngine_MeshCollider_set_inflateMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795540 | 0, fb + 3811 | 0);
 return;
}

function __Z49Register_UnityEngine_MeshCollider_get_inflateMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795498 | 0, fb + 2314 | 0);
 return;
}

function __Z49Register_UnityEngine_LocationService_get_lastDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537371 | 0, fb + 2948 | 0);
 return;
}

function __Z49Register_UnityEngine_LineRenderer_set_textureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530523 | 0, fb + 2928 | 0);
 return;
}

function __Z49Register_UnityEngine_LineRenderer_get_textureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530481 | 0, fb + 1727 | 0);
 return;
}

function __Z49Register_UnityEngine_Light_set_alreadyLightmappedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542368 | 0, fb + 2969 | 0);
 return;
}

function __Z49Register_UnityEngine_Light_get_commandBufferCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542774 | 0, fb + 1770 | 0);
 return;
}

function __Z49Register_UnityEngine_Light_get_alreadyLightmappedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542326 | 0, fb + 1766 | 0);
 return;
}

function __Z49Register_UnityEngine_LightProbeProxyVolume_Updatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544188 | 0, fb + 3603 | 0);
 return;
}

function __Z49Register_UnityEngine_LensFlare_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524989 | 0, fb + 2872 | 0);
 return;
}

function __Z49Register_UnityEngine_LensFlare_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524947 | 0, fb + 2871 | 0);
 return;
}

function __Z49Register_UnityEngine_Input_set_imeCompositionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539374 | 0, fb + 3596 | 0);
 return;
}

function __Z49Register_UnityEngine_Input_INTERNAL_CALL_GetTouchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538903 | 0, fb + 2952 | 0);
 return;
}

function __Z49Register_UnityEngine_GUI_Internal_GetMouseTooltipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020702 | 0, fb + 275 | 0);
 return;
}

function __Z49Register_UnityEngine_GUI_InitializeGUIClipTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020837 | 0, fb + 368 | 0);
 return;
}

function __Z49Register_UnityEngine_Font_GetOSInstalledFontNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010145 | 0, fb + 267 | 0);
 return;
}

function __Z49Register_UnityEngine_EdgeCollider2D_get_edgeCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817271 | 0, fb + 2342 | 0);
 return;
}

function __Z49Register_UnityEngine_Collider_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794897 | 0, fb + 3802 | 0);
 return;
}

function __Z49Register_UnityEngine_Camera_INTERNAL_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505418 | 0, fb + 2798 | 0);
 return;
}

function __Z49Register_UnityEngine_Camera_GetStereoViewMatricesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505886 | 0, fb + 1635 | 0);
 return;
}

function __Z49Register_UnityEngine_AssetBundle_GetAllScenePathsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496924 | 0, fb + 1595 | 0);
 return;
}

function __Z49Register_UnityEngine_AssetBundle_GetAllAssetNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496882 | 0, fb + 1594 | 0);
 return;
}

function __Z49Register_UnityEngine_AssetBundleRequest_get_assetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496157 | 0, fb + 1590 | 0);
 return;
}

function __Z49Register_UnityEngine_Animator_set_applyRootMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919458 | 0, fb + 4122 | 0);
 return;
}

function __Z49Register_UnityEngine_Animator_get_applyRootMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919416 | 0, fb + 2554 | 0);
 return;
}

function __Z49Register_UnityEngine_Animation_set_animatePhysicsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917303 | 0, fb + 4103 | 0);
 return;
}

function __Z49Register_UnityEngine_Animation_get_animatePhysicsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917261 | 0, fb + 2539 | 0);
 return;
}

function __Z49Register_UnityEngine_Animation_INTERNAL_CALL_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916475 | 0, fb + 3810 | 0);
 return;
}

function __Z49Register_UnityEngine_AnimationState_set_blendModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918560 | 0, fb + 4113 | 0);
 return;
}

function __Z49Register_UnityEngine_AnimationState_get_blendModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918518 | 0, fb + 2547 | 0);
 return;
}

function __Z49Register_UnityEngine_AndroidJNI_GetStringUTFCharsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592666 | 0, fb + 1956 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_OffMeshLink_set_activatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852423 | 0, fb + 4039 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_OffMeshLink_get_activatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852381 | 0, fb + 2464 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshObstacle_set_shapev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851663 | 0, fb + 4034 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshObstacle_get_shapev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 851621 | 0, fb + 2461 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshAgent_set_areaMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849017 | 0, fb + 4024 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshAgent_get_areaMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848975 | 0, fb + 2451 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshAgent_StopInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848314 | 0, fb + 3773 | 0);
 return;
}

function __Z48getPxSimulationStatisticsNbAxisSolverConstraintsPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __Z48getNbPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z48Register_UnityEngine_TextMesh_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010104 | 0, fb + 4228 | 0);
 return;
}

function __Z48Register_UnityEngine_TextMesh_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010063 | 0, fb + 4227 | 0);
 return;
}

function __Z48Register_UnityEngine_TextGenerator_get_lineCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011163 | 0, fb + 2676 | 0);
 return;
}

function __Z48Register_UnityEngine_TextGenerator_GetLinesArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1011248 | 0, fb + 2677 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051661 | 0, fb + 4447 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051620 | 0, fb + 2774 | 0);
 return;
}

function __Z48Register_UnityEngine_GUIUtility_GrabMouseControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024792 | 0, fb + 3903 | 0);
 return;
}

function __Z48Register_UnityEngine_Canvas_set_sortingLayerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016161 | 0, fb + 4263 | 0);
 return;
}

function __Z48Register_UnityEngine_Canvas_get_sortingLayerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016120 | 0, fb + 2703 | 0);
 return;
}

function __Z48Register_UnityEngine_CanvasRenderer_get_hasMovedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014653 | 0, fb + 2690 | 0);
 return;
}

function __Z48QualitySettings_Get_Custom_PropDesiredColorSpacev() {
 return __ZNK14PlayerSettings13GetColorSpaceEv(__Z17GetPlayerSettingsv() | 0) | 0;
}

function __Z44Application_Set_Custom_PropStackTraceLogTypei(i1) {
 i1 = i1 | 0;
 __Z20SetStackTraceLogType7LogType17StackTraceLogType(3, i1);
 return;
}

function __Z41scripting_type_get_class_or_element_classPK10Il2CppType(i1) {
 i1 = i1 | 0;
 return _il2cpp_type_get_class_or_element_class(i1 | 0) | 0;
}

function __Z39getPxVehicleDriveDynData_GearSwitchTimePKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __Z39getPxVehicleDriveDynDataMGearSwitchTimePKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __Z38AndroidJNI_CUSTOM_CallStaticCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z38AndroidJNI_CUSTOM_CallStaticByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z37getPxVehicleSuspensionDataMSprungMassPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z30setPxVehicleGearsDataMNbRatiosPN5physx18PxVehicleGearsDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 132 >> 2] = i1;
 return;
}

function __Z29Time_Set_Custom_PropTimeScalef(f1) {
 f1 = Math_fround(f1);
 __ZN11TimeManager12SetTimeScaleEf(__Z14GetTimeManagerv() | 0, f1);
 return;
}

function __Z21getPxActor_ActorFlagsPKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 52 >> 2] | 0, i1 | 0) | 0;
}

function __Z18profiler_end_framev() {
 var i1 = 0;
 i1 = HEAP32[gb + 1451e3 >> 2] | 0;
 if (!i1) return;
 __ZN13UnityProfiler8EndFrameEv(i1);
 return;
}

function _UNITY_png_get_user_height_max(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 628 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_png_get_chunk_cache_max(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 632 >> 2] | 0;
 return i1 | 0;
}

function _glViewport__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glViewport(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _glInvalidateFramebuffer__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glInvalidateFramebuffer(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform4iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform4iv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform4fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform4fv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform3iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform3iv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform3fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform3fv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform2iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform2iv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform2fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform2fv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform1iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform1iv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform1fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform1fv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glDrawArrays__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glDrawArrays(i1 | 0, i2 | 0, i3 | 0);
}

function __ZZN8VRModuleC1EvEN33InitializationVREarlyUpdatestruct7ForwardEv() {
 __ZN8VRModule11EarlyUpdateEv(HEAP32[gb + 1469188 >> 2] | 0);
 return;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 16 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 16 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 280 >> 2]);
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 492 >> 2]);
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 308 >> 2]);
}

function __ZThn32_N22ParticleSystemRendererD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN22ParticleSystemRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZNSt3__27collateIwEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209604 + 8;
 return;
}

function __ZNSt3__27collateIcEC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2 + -1;
 HEAP32[i1 >> 2] = gb + 209572 + 8;
 return;
}

function __ZNSt3__219__shared_weak_count12__add_sharedEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__is_longEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 11 >> 0] | 0) < 0 | 0;
}

function __ZNK5physx7NpShape11getAPISceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(HEAP32[i1 + 20 >> 2] | 0) | 0;
}

function __ZNK5physx3Scb5Scene22getNbBroadPhaseRegionsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene22getNbBroadPhaseRegionsEv(i1 + 16 | 0) | 0;
}

function __ZNK5physx3Ext13RevoluteJoint18getDriveForceLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 76 >> 2]);
}

function __ZNK5physx2Sn18RepXCollectionImpl3endEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + ((HEAP32[i1 + 24 >> 2] | 0) * 24 | 0) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE12getAggregateEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx7NpActor12getAggregateEv(i1 + 12 | 0) | 0;
}

function __ZNK5physx13NpClothFabric14getNbParticlesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore14getNbParticlesEv(i1 + 16 | 0) | 0;
}

function __ZNK26PlayerSettingsSplashScreen39GetSplashScreenBackgroundPortraitAspectEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __ZNK16TypeTreeIterator7GetNodeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[HEAP32[i1 >> 2] >> 2] | 0) + ((HEAP32[i1 + 4 >> 2] | 0) * 24 | 0) | 0;
}

function __ZNK13TranslateGLES10VertexTypeE19VertexChannelFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 2276 + (i2 << 2) >> 2] | 0;
}

function __ZNK13SpeedTreeWind15IsOptionEnabledENS_8EOptionsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[i1 + 1348 + i2 >> 0] | 0) != 0 | 0;
}

function __ZN9GfxDevice20GetComputeBufferDataE15ComputeBufferIDPvj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN7b2World22SetDestructionListenerEP21b2DestructionListener(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 102984 >> 2] = i2;
 return;
}

function __ZN5physx6shdfnd7PAUtils8rawEventEtjjh(i5, i4, i1, i2, i3) {
 i5 = i5 | 0;
 i4 = i4 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx5cloth8SwSolver26setInterCollisionStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 84 >> 2] = f1;
 return;
}

function __ZN5physx34PxsSolverConstraintPostProcessTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 84 >> 2] = f1;
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpActor7releaseERNS_7PxActorE(i1 + 12 | 0, i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN5Umbra7ImpTile23getAccurateFindDataSizeEPKS0_(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 76 >> 2] << 4) + (HEAP32[i1 + 68 >> 2] << 3) | 0;
}

function __ZN5Umbra4Math3powERKNS_6DoubleES3_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+Math_pow(+(+HEAPF64[i1 >> 3]), +(+HEAPF64[i2 >> 3])));
}

function __ZN4FMOD4DSPI11getUserDataEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 return 0;
}

function __ZN21AssetBundleFileSystem9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN20SphericalHarmonicsL26GetPtrEN18SphericalHarmonics12ColorChannelE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + (i2 * 9 << 2) | 0;
}

function __ZN18BackgroundJobQueue8ShutdownEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 21 | 0;
 if (!(HEAP8[i1 >> 0] | 0)) return;
 HEAP8[i1 >> 0] = 0;
 return;
}

function __ZN17AnimationPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15SharedLightData17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN19RenderEventsContext23RemoveAllCommandBuffersEv(i1 + 208 | 0);
 return;
}

function __ZN13RuntimeStaticI15ApplicationInfoE13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 __ZN13RuntimeStaticI15ApplicationInfoE7DestroyEv(i1);
 return;
}

function __ZN13GfxDeviceNull15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13AnimationClip16ClearCachedRangeEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 264 >> 2] = 2139095040;
 HEAP32[i1 + 268 >> 2] = -8388608;
 return;
}

function __Z55LightProbeProxyVolume_Get_Custom_PropIsFeatureSupportedv() {
 return (__ZN21LightProbeProxyVolume18HasHardwareSupportEv() | 0) & 1 | 0;
}

function __Z52Screen_Get_Custom_PropAutorotateToPortraitUpsideDownv() {
 return (HEAP32[(__Z16GetScreenManagerv() | 0) + 32 >> 2] | 0) >>> 1 & 1 | 0;
}

function __Z51Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Castv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815458 | 0, fb + 2 | 0);
 return;
}

function __Z51Register_UnityEngine_Quaternion_INTERNAL_CALL_Slerpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544872 | 0, fb + 6 | 0);
 return;
}

function __Z51Register_UnityEngine_Application_get_isLoadingLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493117 | 0, fb + 2 | 0);
 return;
}

function __Z50Register_UnityEngine_Time_get_realtimeSinceStartupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577143 | 0, fb + 29 | 0);
 return;
}

function __Z50Register_UnityEngine_SystemInfo_get_processorCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 498038 | 0, fb + 45 | 0);
 return;
}

function __Z50Register_UnityEngine_SystemInfo_get_maxTextureSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499959 | 0, fb + 83 | 0);
 return;
}

function __Z50Register_UnityEngine_Mesh_GetBlendShapeFrameWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548258 | 0, fb + 21 | 0);
 return;
}

function __Z50Register_UnityEngine_Application_get_installerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494425 | 0, fb + 22 | 0);
 return;
}

function __Z50Register_UnityEngine_AnimationCurve_SmoothTangentsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546611 | 0, fb + 42 | 0);
 return;
}

function __Z50Register_UnityEngine_AnimationClip_SampleAnimationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915355 | 0, fb + 68 | 0);
 return;
}

function __Z49Register_UnityEngine_WheelCollider_set_steerAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837190 | 0, fb + 574 | 0);
 return;
}

function __Z49Register_UnityEngine_WheelCollider_get_steerAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837148 | 0, fb + 661 | 0);
 return;
}

function __Z49Register_UnityEngine_WheelCollider_get_sprungMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837326 | 0, fb + 662 | 0);
 return;
}

function __Z49Register_UnityEngine_TrailRenderer_set_startWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528236 | 0, fb + 175 | 0);
 return;
}

function __Z49Register_UnityEngine_TrailRenderer_get_startWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528194 | 0, fb + 221 | 0);
 return;
}

function __Z49Register_UnityEngine_SliderJoint2D_get_jointSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821410 | 0, fb + 555 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody_set_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787555 | 0, fb + 429 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody_get_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787513 | 0, fb + 496 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody2D_set_gravityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814332 | 0, fb + 464 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody2D_get_gravityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814290 | 0, fb + 532 | 0);
 return;
}

function __Z49Register_UnityEngine_Rigidbody2D_IsTouchingLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815364 | 0, fb + 893 | 0);
 return;
}

function __Z49Register_UnityEngine_Resources_UnloadUnusedAssetsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560721 | 0, fb + 205 | 0);
 return;
}

function __Z49Register_UnityEngine_Resources_GetBuiltinResourcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560644 | 0, fb + 672 | 0);
 return;
}

function __Z49Register_UnityEngine_Rendering_SplashScreen_Beginv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568237 | 0, fb + 118 | 0);
 return;
}

function __Z49Register_UnityEngine_RelativeJoint2D_set_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820167 | 0, fb + 475 | 0);
 return;
}

function __Z49Register_UnityEngine_RelativeJoint2D_get_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820125 | 0, fb + 548 | 0);
 return;
}

function __Z49Register_UnityEngine_RectOffset_INTERNAL_CALL_Addv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514120 | 0, fb + 588 | 0);
 return;
}

function __Z49Register_UnityEngine_Profiling_Profiler_EndSamplev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553649 | 0, fb + 116 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics_IgnoreLayerCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784238 | 0, fb + 852 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics2D_GetIgnoreCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811123 | 0, fb + 888 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_set_startSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652228 | 0, fb + 292 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_get_startSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 652186 | 0, fb + 349 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_Internal_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653514 | 0, fb + 821 | 0);
 return;
}

function __Z49Register_UnityEngine_ParticleSystem_Internal_Emitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653779 | 0, fb + 766 | 0);
 return;
}

function __Z49Register_UnityEngine_MonoBehaviour_StartCoroutinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549525 | 0, fb + 366 | 0);
 return;
}

function __Z49Register_UnityEngine_Mesh_GetBlendShapeFrameCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548216 | 0, fb + 655 | 0);
 return;
}

function __Z49Register_UnityEngine_Mesh_GetArrayFromChannelImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547832 | 0, fb + 128 | 0);
 return;
}

function __Z49Register_UnityEngine_Light_set_shadowSoftnessFadev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541906 | 0, fb + 191 | 0);
 return;
}

function __Z49Register_UnityEngine_Light_get_shadowSoftnessFadev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541864 | 0, fb + 242 | 0);
 return;
}

function __Z49Register_UnityEngine_Input_mainGyroIndex_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537746 | 0, fb + 163 | 0);
 return;
}

function __Z49Register_UnityEngine_Input_get_imeCompositionModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539332 | 0, fb + 180 | 0);
 return;
}

function __Z49Register_UnityEngine_FrictionJoint2D_set_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819434 | 0, fb + 473 | 0);
 return;
}

function __Z49Register_UnityEngine_FrictionJoint2D_get_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819392 | 0, fb + 543 | 0);
 return;
}

function __Z49Register_UnityEngine_DistanceJoint2D_set_distancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819252 | 0, fb + 472 | 0);
 return;
}

function __Z49Register_UnityEngine_DistanceJoint2D_get_distancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819210 | 0, fb + 542 | 0);
 return;
}

function __Z49Register_UnityEngine_DebugLogHandler_Internal_Logv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511470 | 0, fb + 582 | 0);
 return;
}

function __Z49Register_UnityEngine_CubemapArray_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573921 | 0, fb + 175 | 0);
 return;
}

function __Z49Register_UnityEngine_Component_SendMessageUpwardsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508998 | 0, fb + 224 | 0);
 return;
}

function __Z49Register_UnityEngine_Cloth_set_worldVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841334 | 0, fb + 583 | 0);
 return;
}

function __Z49Register_UnityEngine_Cloth_set_collisionMassScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840946 | 0, fb + 580 | 0);
 return;
}

function __Z49Register_UnityEngine_Cloth_get_worldVelocityScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841292 | 0, fb + 672 | 0);
 return;
}

function __Z49Register_UnityEngine_Cloth_get_collisionMassScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840904 | 0, fb + 669 | 0);
 return;
}

function __Z49Register_UnityEngine_Camera_set_stereoConvergencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505692 | 0, fb + 164 | 0);
 return;
}

function __Z49Register_UnityEngine_Camera_get_stereoConvergencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505650 | 0, fb + 212 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioSource_set_spatialBlendv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887811 | 0, fb + 604 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioSource_set_dopplerLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888525 | 0, fb + 606 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioSource_get_spatialBlendv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887769 | 0, fb + 694 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioSource_get_dopplerLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888483 | 0, fb + 696 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioReverbFilter_set_roomLFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893933 | 0, fb + 654 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioReverbFilter_set_roomHFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892903 | 0, fb + 643 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioReverbFilter_get_roomLFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 893891 | 0, fb + 744 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioReverbFilter_get_roomHFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892861 | 0, fb + 733 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioClip_Construct_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885925 | 0, fb + 249 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioChorusFilter_set_dryMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891965 | 0, fb + 633 | 0);
 return;
}

function __Z49Register_UnityEngine_AudioChorusFilter_get_dryMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891923 | 0, fb + 723 | 0);
 return;
}

function __Z49Register_UnityEngine_Animator_set_feetPivotActivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921848 | 0, fb + 665 | 0);
 return;
}

function __Z49Register_UnityEngine_Animator_get_feetPivotActivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921806 | 0, fb + 760 | 0);
 return;
}

function __Z49Register_UnityEngine_AndroidJNI_SetStaticIntFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595174 | 0, fb + 714 | 0);
 return;
}

function __Z49Register_UnityEngine_AndroidJNI_GetStaticIntFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 594734 | 0, fb + 793 | 0);
 return;
}

function __Z49Register_UnityEngine_AndroidJNI_ExceptionDescribev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591706 | 0, fb + 183 | 0);
 return;
}

function __Z49Register_UnityEngine_AndroidJNI_CallBooleanMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592842 | 0, fb + 379 | 0);
 return;
}

function __Z48getPxSimulationStatisticsNbActiveKinematicBodiesPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z48Register_UnityEngine_WebCamTexture_get_isPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895507 | 0, fb + 2519 | 0);
 return;
}

function __Z48Register_UnityEngine_Transform_SetAsFirstSiblingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578849 | 0, fb + 3659 | 0);
 return;
}

function __Z48Register_UnityEngine_Texture2D_GetRawTextureDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572502 | 0, fb + 1895 | 0);
 return;
}

function __Z48Register_UnityEngine_TerrainData_get_detailWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939629 | 0, fb + 2592 | 0);
 return;
}

function __Z48Register_UnityEngine_TerrainData_SetBasemapDirtyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941165 | 0, fb + 4173 | 0);
 return;
}

function __Z48Register_UnityEngine_TerrainData_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938271 | 0, fb + 4156 | 0);
 return;
}

function __Z48Register_UnityEngine_SparseTexture_get_tileWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574111 | 0, fb + 1905 | 0);
 return;
}

function __Z48Register_UnityEngine_SparseTexture_get_isCreatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574194 | 0, fb + 1907 | 0);
 return;
}

function __Z48Register_UnityEngine_SliderJoint2D_set_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821047 | 0, fb + 3892 | 0);
 return;
}

function __Z48Register_UnityEngine_SliderJoint2D_get_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821006 | 0, fb + 2361 | 0);
 return;
}

function __Z48Register_UnityEngine_Shader_set_globalMaximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563883 | 0, fb + 3642 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody_set_interpolationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786856 | 0, fb + 3703 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody_get_interpolationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 786815 | 0, fb + 2285 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_set_useAutoMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813711 | 0, fb + 3841 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_set_constraintsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814809 | 0, fb + 3851 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_get_useAutoMassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813670 | 0, fb + 2323 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_get_constraintsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814768 | 0, fb + 2329 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_set_useLightProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526630 | 0, fb + 2892 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_set_sortingLayerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527242 | 0, fb + 2900 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_set_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525796 | 0, fb + 2881 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_set_receiveShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525644 | 0, fb + 2879 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_get_useLightProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526589 | 0, fb + 1703 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_get_sortingLayerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527201 | 0, fb + 1709 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_get_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525755 | 0, fb + 1696 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_get_receiveShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525603 | 0, fb + 1694 | 0);
 return;
}

function __Z48Register_UnityEngine_RenderTexture_set_useMipMapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575085 | 0, fb + 3126 | 0);
 return;
}

function __Z48Register_UnityEngine_RenderTexture_set_isCubemapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575361 | 0, fb + 3129 | 0);
 return;
}

function __Z48Register_UnityEngine_RenderTexture_get_useMipMapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575044 | 0, fb + 1914 | 0);
 return;
}

function __Z48Register_UnityEngine_RenderTexture_get_isCubemapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575320 | 0, fb + 1917 | 0);
 return;
}

function __Z48Register_UnityEngine_ReflectionProbe_get_texturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557733 | 0, fb + 1830 | 0);
 return;
}

function __Z48Register_UnityEngine_QualitySettings_set_shadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521290 | 0, fb + 3532 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleSystem_get_isPausedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651644 | 0, fb + 2065 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_set_minSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050020 | 0, fb + 699 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_set_maxSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050102 | 0, fb + 700 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_get_minSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1049979 | 0, fb + 802 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleEmitter_get_maxSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1050061 | 0, fb + 803 | 0);
 return;
}

function __Z48Register_UnityEngine_Object_Internal_CloneSinglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579498 | 0, fb + 1933 | 0);
 return;
}

function __Z48Register_UnityEngine_Motion_get_isAnimatorMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550160 | 0, fb + 1801 | 0);
 return;
}

function __Z48Register_UnityEngine_MonoBehaviour_StopCoroutinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549567 | 0, fb + 3008 | 0);
 return;
}

function __Z48Register_UnityEngine_MeshCollider_set_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795383 | 0, fb + 3809 | 0);
 return;
}

function __Z48Register_UnityEngine_MeshCollider_get_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795342 | 0, fb + 2312 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_set_shaderKeywordsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567027 | 0, fb + 3091 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_get_shaderKeywordsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566986 | 0, fb + 1863 | 0);
 return;
}

function __Z48Register_UnityEngine_MaterialPropertyBlock_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 531880 | 0, fb + 3555 | 0);
 return;
}

function __Z48Register_UnityEngine_LineRenderer_set_widthCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529522 | 0, fb + 2917 | 0);
 return;
}

function __Z48Register_UnityEngine_LineRenderer_get_widthCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529481 | 0, fb + 1721 | 0);
 return;
}

function __Z48Register_UnityEngine_LightProbes_set_bakedProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533568 | 0, fb + 2935 | 0);
 return;
}

function __Z48Register_UnityEngine_LightProbes_get_bakedProbesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533527 | 0, fb + 1732 | 0);
 return;
}

function __Z48Register_UnityEngine_Joint2D_set_enableCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818104 | 0, fb + 3871 | 0);
 return;
}

function __Z48Register_UnityEngine_Joint2D_get_enableCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818063 | 0, fb + 2350 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_set_multiTouchEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539250 | 0, fb + 3595 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_set_compensateSensorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538110 | 0, fb + 3589 | 0);
 return;
}

function __Z48Register_UnityEngine_HingeJoint2D_get_limitStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819902 | 0, fb + 2357 | 0);
 return;
}

function __Z48Register_UnityEngine_Hash128_INTERNAL_CALL_Parsev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580647 | 0, fb + 3158 | 0);
 return;
}

function __Z48Register_UnityEngine_GUI_GetNameOfFocusedControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021024 | 0, fb + 279 | 0);
 return;
}

function __Z48Register_UnityEngine_GUIUtility_Internal_ExitGUIv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025314 | 0, fb + 375 | 0);
 return;
}

function __Z48Register_UnityEngine_GL_IssuePluginEventInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536275 | 0, fb + 2939 | 0);
 return;
}

function __Z48Register_UnityEngine_GL_INTERNAL_CALL_MultMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535740 | 0, fb + 3582 | 0);
 return;
}

function __Z48Register_UnityEngine_Effector2D_set_colliderMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823313 | 0, fb + 3913 | 0);
 return;
}

function __Z48Register_UnityEngine_Effector2D_get_colliderMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823272 | 0, fb + 2366 | 0);
 return;
}

function __Z48Register_UnityEngine_Debug_GetDiagnosticSwitchesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511866 | 0, fb + 3492 | 0);
 return;
}

function __Z48Register_UnityEngine_ComputeBuffer_DestroyBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509769 | 0, fb + 3485 | 0);
 return;
}

function __Z48Register_UnityEngine_Collider_set_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794856 | 0, fb + 3801 | 0);
 return;
}

function __Z48Register_UnityEngine_Collider_get_sharedMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794815 | 0, fb + 2311 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_set_stereoMirrorModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505845 | 0, fb + 2801 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_set_depthTextureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508089 | 0, fb + 2810 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_get_stereoMirrorModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505804 | 0, fb + 1634 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_get_depthTextureModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508048 | 0, fb + 1644 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_RemoveCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508346 | 0, fb + 2812 | 0);
 return;
}

function __Z48Register_UnityEngine_Caching_set_expirationDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502490 | 0, fb + 3470 | 0);
 return;
}

function __Z48Register_UnityEngine_Caching_GetVersionFromCachev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502029 | 0, fb + 1617 | 0);
 return;
}

function __Z48Register_UnityEngine_BillboardAsset_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500946 | 0, fb + 2764 | 0);
 return;
}

function __Z48Register_UnityEngine_BillboardAsset_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500905 | 0, fb + 1610 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_set_timeSamplesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886601 | 0, fb + 4050 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_set_rolloffModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888988 | 0, fb + 4065 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_set_playOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887456 | 0, fb + 4055 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_get_timeSamplesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886560 | 0, fb + 2489 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_get_rolloffModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888947 | 0, fb + 2506 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_get_playOnAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887415 | 0, fb + 2496 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioClip_get_isReadyToPlayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885585 | 0, fb + 2481 | 0);
 return;
}

function __Z48Register_UnityEngine_AsyncOperation_set_priorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497564 | 0, fb + 2761 | 0);
 return;
}

function __Z48Register_UnityEngine_AsyncOperation_get_priorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497523 | 0, fb + 1599 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_GetValueForARGVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493953 | 0, fb + 1584 | 0);
 return;
}

function __Z48Register_UnityEngine_Animator_get_parameterCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921765 | 0, fb + 2562 | 0);
 return;
}

function __Z48Register_UnityEngine_Animator_ResetTriggerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923918 | 0, fb + 4142 | 0);
 return;
}

function __Z48Register_UnityEngine_AnimationState_set_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917814 | 0, fb + 4109 | 0);
 return;
}

function __Z48Register_UnityEngine_AnimationState_get_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917773 | 0, fb + 2543 | 0);
 return;
}

function __Z48Register_UnityEngine_AndroidJNI_FromBooleanArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595806 | 0, fb + 1957 | 0);
 return;
}

function __Z48Register_UnityEngine_AI_OffMeshLink_get_occupiedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852465 | 0, fb + 2465 | 0);
 return;
}

function __Z48Register_UnityEngine_AI_NavMeshAgent_get_hasPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 847985 | 0, fb + 2446 | 0);
 return;
}

function __Z47getNbPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z47Register_UnityEngine_GUIUtility_HasMouseControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024877 | 0, fb + 2732 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIText_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009257 | 0, fb + 4219 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIText_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009217 | 0, fb + 4218 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIStyle_set_stretchHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023234 | 0, fb + 4296 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIStyle_set_imagePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022506 | 0, fb + 4287 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIStyle_get_stretchHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023194 | 0, fb + 2726 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIStyle_get_imagePositionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022466 | 0, fb + 2721 | 0);
 return;
}

function __Z47Register_UnityEngine_Canvas_set_overrideSortingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015604 | 0, fb + 4258 | 0);
 return;
}

function __Z47Register_UnityEngine_Canvas_get_overrideSortingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015564 | 0, fb + 2697 | 0);
 return;
}

function __Z47Register_UnityEngine_CanvasRenderer_GetMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013939 | 0, fb + 1108 | 0);
 return;
}

function __Z47QualitySettings_Get_Custom_PropActiveColorSpacev() {
 return __ZNK14PlayerSettings13GetColorSpaceEv(__Z17GetPlayerSettingsv() | 0) | 0;
}

function __Z41getPxVehicleSuspensionDataMSpringStrengthPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z38getPxVehicleDriveDynDataMGearUpPressedPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 65 >> 0] | 0) != 0 | 0;
}

function __Z37AndroidJNI_CUSTOM_CallStaticIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z36setPxSceneDescMaxNbContactDataBlocksPN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 140 >> 2] = i1;
 return;
}

function __Z36Physics_Get_Custom_PropSleepVelocityv() {
 return Math_fround(__ZN14PhysicsManager16GetSleepVelocityEv(__Z17GetPhysicsManagerv() | 0));
}

function __Z34Display_CUSTOM_ActivateDisplayImpl13Il2Cpp_IntPtriii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z26setPxTolerancesScaleLengthPN5physx17PxTolerancesScaleEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function __Z26scripting_class_has_parentP11Il2CppClassS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_class_has_parent(i1 | 0, i2 | 0) | 0;
}

function __Z25GetApplicationManagedPathv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem25GetApplicationManagedPathEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function __Z20getPxScene_TimestampPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0) | 0;
}

function __Z20getPxActor_AggregatePKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0, i1 | 0) | 0;
}

function _UNITY_png_get_user_width_max(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 624 >> 2] | 0;
 return i1 | 0;
}

function _UNITY_png_app_warning(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 208 >> 2] & 2097152)) _UNITY_png_error(i1, i2); else return;
}

function b106(i1, i2, i3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 nullFunc_iiiifi(106);
 return 0;
}

function _wcsnlen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _wmemchr(i1, 0, i2) | 0;
 return ((i3 | 0) == 0 ? i2 : i3 - i1 >> 2) | 0;
}

function _versionsort(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strverscmp((HEAP32[i1 >> 2] | 0) + 11 | 0, (HEAP32[i2 >> 2] | 0) + 11 | 0) | 0;
}

function _emscripten_glGetAttribLocation__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _emscripten_glGetAttribLocation(i1 | 0, i2 | 0) | 0;
}

function __ZZN8VRModuleC1EvEN21enterPlayModePreAwake7ForwardEv() {
 __ZN8VRModule22StartRenderingToDeviceEv(HEAP32[gb + 1469188 >> 2] | 0);
 return;
}

function __ZZN10GUIManager14InitGUIManagerEvEN36PreUpdateIMGUISendQueuedEventsstruct7ForwardEv() {
 __ZN10GUIManager16SendQueuedEventsEv();
 return;
}

function __ZThn80_NK26AnimatorControllerPlayable24HasStateMachineBehaviourEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + -80 + 124 >> 2] | 0) != 0 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 312 >> 2]);
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRS3_S4_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_ii(i2 | 0, i1 | 0) | 0;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRS3_S4_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_ii(i2 | 0, i1 | 0) | 0;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRS3_S4_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_ii(i2 | 0, i1 | 0) | 0;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRS3_S4_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_ii(i2 | 0, i1 | 0) | 0;
}

function __ZNK5physx7NpScene22getNbBroadPhaseRegionsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx3Scb5Scene22getNbBroadPhaseRegionsEv(i1 + 16 | 0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 456 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx3Ext13RevoluteJoint17getDriveGearRatioEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 80 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK29ParticleSystemPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK29LineParametersPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK13TranslateGLES23VertexArraySizeBitfieldEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75612 + (i2 + -1 << 2) >> 2] | 0;
}

function __ZNK13RenderTexture14IsDepthTextureEv(i1) {
 i1 = i1 | 0;
 return __Z15IsDepthRTFormat19RenderTextureFormat(HEAP32[i1 + 96 >> 2] | 0) | 0;
}

function __ZN7mecanim5human12FullBodyMaskEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = -1;
 HEAP32[i1 >> 2] = -1;
 HEAP32[i1 + 8 >> 2] = 3;
 return;
}

function __ZN5physx6shdfnd13ReadWriteLock12unlockWriterEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_unlock(HEAP32[HEAP32[i1 >> 2] >> 2] | 0) | 0;
 return;
}

function __ZN5physx5cloth8SwSolver25setInterCollisionDistanceEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore20setTwistLimitEnabledEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 148 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore20setSwingLimitEnabledEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 124 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 88 >> 2] = f1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 112 >> 2] = f1;
 return;
}

function __ZN5physx2Sc10ElementSim8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0;
}

function __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + -32 + 16 | 0) | 0;
 return;
}

function __ZN5Unity10HingeJointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity10FixedJointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4Mesh21GetSharedPxConvexMeshEv(i1) {
 i1 = i1 | 0;
 return __ZN17CollisionMeshData21GetSharedNxConvexMeshER4Mesh(i1 + 204 | 0, i1) | 0;
}

function __ZN4FMOD8ChannelI7getModeEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 72 >> 2];
 return 0;
}

function __ZN2gl17GetCurrentContextEv() {
 var i1 = 0;
 i1 = __ZN2gl22WebGLGetCurrentContextEv() | 0;
 return ((i1 | 0) == 0 ? -559030611 : i1) | 0;
}

function __ZN21AnimationClipPlayable13ClearBindingsEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 56 >> 2] | 0, i1 | 0);
 return;
}

function __ZN20LocalFileSystemPosix8SetFlagsER13FileEntryDatajj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 1;
}

function __ZN18ProfilerConnection42HandleSetAutoInstrumentedAssembliesMessageEPKvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN16ParticleAnimatorD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13SubstanceData22OnMaterialBeginLoadingEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN12_GLOBAL__N_116MetaDataProvider6unlockEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd9MutexImpl6unlockEv(HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function __Z50Register_UnityEngine_RenderSettings_set_fogDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518815 | 0, fb + 3 | 0);
 return;
}

function __Z50Register_UnityEngine_RenderSettings_get_fogDensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518772 | 0, fb + 3 | 0);
 return;
}

function __Z50Register_UnityEngine_Quaternion_INTERNAL_CALL_Lerpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544969 | 0, fb + 8 | 0);
 return;
}

function __Z50Register_UnityEngine_MonoBehaviour_InvokeRepeatingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549348 | 0, fb + 1 | 0);
 return;
}

function __Z50Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Orthov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545602 | 0, fb + 1 | 0);
 return;
}

function __Z50Register_UnityEngine_DynamicGI_set_updateThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512801 | 0, fb + 2 | 0);
 return;
}

function __Z50Register_UnityEngine_DynamicGI_get_updateThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512758 | 0, fb + 2 | 0);
 return;
}

function __Z50Register_UnityEngine_Collider2D_INTERNAL_CALL_Castv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817022 | 0, fb + 2 | 0);
 return;
}

function __Z50Register_UnityEngine_Application_get_streamedBytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493269 | 0, fb + 3 | 0);
 return;
}

function __Z50Register_UnityEngine_Animator_CrossFadeInFixedTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922175 | 0, fb + 1 | 0);
 return;
}

function __Z49Register_UnityEngine_Texture2D_SetBlockOfPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572321 | 0, fb + 29 | 0);
 return;
}

function __Z49Register_UnityEngine_SystemInfo_get_supportsAudiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499878 | 0, fb + 81 | 0);
 return;
}

function __Z49Register_UnityEngine_SystemInfo_get_processorTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497949 | 0, fb + 43 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics2D_set_baumgarteScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809778 | 0, fb + 35 | 0);
 return;
}

function __Z49Register_UnityEngine_Physics2D_get_baumgarteScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809736 | 0, fb + 44 | 0);
 return;
}

function __Z49Register_UnityEngine_GUIStyle_Internal_CalcHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024371 | 0, fb + 1 | 0);
 return;
}

function __Z49Register_UnityEngine_Application_get_unityVersionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494346 | 0, fb + 20 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshAgent_SetLayerCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848717 | 0, fb + 65 | 0);
 return;
}

function __Z49Register_UnityEngine_AI_NavMeshAgent_GetLayerCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848759 | 0, fb + 32 | 0);
 return;
}

function __Z48Register_UnityEngine_WindZone_set_windTurbulencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581644 | 0, fb + 207 | 0);
 return;
}

function __Z48Register_UnityEngine_WindZone_get_windTurbulencev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581603 | 0, fb + 264 | 0);
 return;
}

function __Z48Register_UnityEngine_WheelJoint2D_get_jointSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822573 | 0, fb + 563 | 0);
 return;
}

function __Z48Register_UnityEngine_VR_VRDevice_get_refreshRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045896 | 0, fb + 57 | 0);
 return;
}

function __Z48Register_UnityEngine_Time_get_renderedFrameCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577102 | 0, fb + 218 | 0);
 return;
}

function __Z48Register_UnityEngine_Texture2D_Internal_ResizeWHv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572670 | 0, fb + 369 | 0);
 return;
}

function __Z48Register_UnityEngine_Terrain_set_legacyShininessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943444 | 0, fb + 682 | 0);
 return;
}

function __Z48Register_UnityEngine_Terrain_set_basemapDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942478 | 0, fb + 681 | 0);
 return;
}

function __Z48Register_UnityEngine_Terrain_get_legacyShininessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943403 | 0, fb + 781 | 0);
 return;
}

function __Z48Register_UnityEngine_Terrain_get_basemapDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942437 | 0, fb + 780 | 0);
 return;
}

function __Z48Register_UnityEngine_TerrainData_GetAdjustedSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939196 | 0, fb + 998 | 0);
 return;
}

function __Z48Register_UnityEngine_TargetJoint2D_set_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822006 | 0, fb + 482 | 0);
 return;
}

function __Z48Register_UnityEngine_TargetJoint2D_get_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821965 | 0, fb + 558 | 0);
 return;
}

function __Z48Register_UnityEngine_SurfaceEffector2D_set_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826233 | 0, fb + 508 | 0);
 return;
}

function __Z48Register_UnityEngine_SurfaceEffector2D_get_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 826192 | 0, fb + 587 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint_set_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789349 | 0, fb + 435 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint_set_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789431 | 0, fb + 436 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint_get_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789308 | 0, fb + 504 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint_get_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789390 | 0, fb + 505 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint2D_set_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819059 | 0, fb + 471 | 0);
 return;
}

function __Z48Register_UnityEngine_SpringJoint2D_get_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819018 | 0, fb + 541 | 0);
 return;
}

function __Z48Register_UnityEngine_SparseTexture_UpdateTileRawv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574316 | 0, fb + 140 | 0);
 return;
}

function __Z48Register_UnityEngine_Shader_get_globalMaximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563842 | 0, fb + 208 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody_set_sleepVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787376 | 0, fb + 427 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody_get_sleepVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787335 | 0, fb + 494 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_set_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814249 | 0, fb + 463 | 0);
 return;
}

function __Z48Register_UnityEngine_Rigidbody2D_get_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814208 | 0, fb + 531 | 0);
 return;
}

function __Z48Register_UnityEngine_Rendering_SplashScreen_Drawv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568279 | 0, fb + 119 | 0);
 return;
}

function __Z48Register_UnityEngine_Renderer_SetStaticBatchInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525176 | 0, fb + 594 | 0);
 return;
}

function __Z48Register_UnityEngine_ReflectionProbe_RenderProbev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557774 | 0, fb + 667 | 0);
 return;
}

function __Z48Register_UnityEngine_QualitySettings_get_shadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 521249 | 0, fb + 124 | 0);
 return;
}

function __Z48Register_UnityEngine_Projector_set_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527459 | 0, fb + 169 | 0);
 return;
}

function __Z48Register_UnityEngine_Projector_get_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527418 | 0, fb + 215 | 0);
 return;
}

function __Z48Register_UnityEngine_PlayerPrefs_TrySetSetStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552770 | 0, fb + 663 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleSystem_get_durationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651921 | 0, fb + 346 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleSystem_SetParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653228 | 0, fb + 764 | 0);
 return;
}

function __Z48Register_UnityEngine_ParticleSystem_GetParticlesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 653269 | 0, fb + 820 | 0);
 return;
}

function __Z48Register_UnityEngine_Mesh_SetArrayForChannelImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547744 | 0, fb + 170 | 0);
 return;
}

function __Z48Register_UnityEngine_Matrix4x4_INTERNAL_CALL_TRSv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545561 | 0, fb + 239 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_SetVectorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565758 | 0, fb + 657 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_SetMatrixArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565928 | 0, fb + 661 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_GetVectorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566098 | 0, fb + 675 | 0);
 return;
}

function __Z48Register_UnityEngine_Material_GetMatrixArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566268 | 0, fb + 677 | 0);
 return;
}

function __Z48Register_UnityEngine_LineRenderer_set_startWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529362 | 0, fb + 179 | 0);
 return;
}

function __Z48Register_UnityEngine_LineRenderer_get_startWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529321 | 0, fb + 225 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_get_multiTouchEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539209 | 0, fb + 178 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_get_deviceOrientationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539291 | 0, fb + 179 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_get_compositionStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539416 | 0, fb + 181 | 0);
 return;
}

function __Z48Register_UnityEngine_Input_get_compensateSensorsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538069 | 0, fb + 164 | 0);
 return;
}

function __Z48Register_UnityEngine_HingeJoint2D_get_jointSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820029 | 0, fb + 547 | 0);
 return;
}

function __Z48Register_UnityEngine_HingeJoint2D_get_jointAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819988 | 0, fb + 546 | 0);
 return;
}

function __Z48Register_UnityEngine_GameObject_BroadcastMessagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515930 | 0, fb + 235 | 0);
 return;
}

function __Z48Register_UnityEngine_Display_RelativeMouseAtImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512635 | 0, fb + 145 | 0);
 return;
}

function __Z48Register_UnityEngine_Display_GetRenderingExtImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512425 | 0, fb + 585 | 0);
 return;
}

function __Z48Register_UnityEngine_Display_ActivateDisplayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512559 | 0, fb + 232 | 0);
 return;
}

function __Z48Register_UnityEngine_Compass_get_magneticHeadingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537482 | 0, fb + 229 | 0);
 return;
}

function __Z48Register_UnityEngine_Compass_get_headingAccuracyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537560 | 0, fb + 231 | 0);
 return;
}

function __Z48Register_UnityEngine_Collider2D_IsTouchingLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816884 | 0, fb + 896 | 0);
 return;
}

function __Z48Register_UnityEngine_CircleCollider2D_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817106 | 0, fb + 466 | 0);
 return;
}

function __Z48Register_UnityEngine_CircleCollider2D_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817065 | 0, fb + 536 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_set_stereoSeparationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505609 | 0, fb + 163 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_set_orthographicSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503594 | 0, fb + 160 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_get_stereoSeparationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505568 | 0, fb + 211 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_get_orthographicSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503553 | 0, fb + 208 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_SetTargetBuffersImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504519 | 0, fb + 551 | 0);
 return;
}

function __Z48Register_UnityEngine_Camera_SetReplacementShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507344 | 0, fb + 568 | 0);
 return;
}

function __Z48Register_UnityEngine_Audio_AudioMixer_ClearFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894680 | 0, fb + 944 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_set_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888824 | 0, fb + 608 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_set_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888906 | 0, fb + 609 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_get_minDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888783 | 0, fb + 698 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioSource_get_maxDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888865 | 0, fb + 699 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioReverbZone_set_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890908 | 0, fb + 623 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioReverbZone_get_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890867 | 0, fb + 713 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioChorusFilter_set_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892468 | 0, fb + 639 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioChorusFilter_set_delayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892306 | 0, fb + 637 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioChorusFilter_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892427 | 0, fb + 729 | 0);
 return;
}

function __Z48Register_UnityEngine_AudioChorusFilter_get_delayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892265 | 0, fb + 727 | 0);
 return;
}

function __Z48Register_UnityEngine_AsyncOperation_get_progressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497482 | 0, fb + 201 | 0);
 return;
}

function __Z48Register_UnityEngine_AnimationClip_set_frameRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915614 | 0, fb + 659 | 0);
 return;
}

function __Z48Register_UnityEngine_AnimationClip_get_startTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915492 | 0, fb + 749 | 0);
 return;
}

function __Z48Register_UnityEngine_AnimationClip_get_frameRatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915573 | 0, fb + 751 | 0);
 return;
}

function __Z48Register_UnityEngine_AndroidJNI_IsAssignableFromv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591546 | 0, fb + 777 | 0);
 return;
}

function __Z48Register_UnityEngine_AndroidJNI_CallStringMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592708 | 0, fb + 377 | 0);
 return;
}

function __Z47Register_UnityEngine_Transform_SetAsLastSiblingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578890 | 0, fb + 3660 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture_Internal_GetHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571361 | 0, fb + 1887 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture_GetNativeTextureIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571827 | 0, fb + 1892 | 0);
 return;
}

function __Z47Register_UnityEngine_TextMesh_set_characterSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009809 | 0, fb + 687 | 0);
 return;
}

function __Z47Register_UnityEngine_TextMesh_get_characterSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009769 | 0, fb + 786 | 0);
 return;
}

function __Z47Register_UnityEngine_Sprite_get_packingRotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569148 | 0, fb + 1877 | 0);
 return;
}

function __Z47Register_UnityEngine_Sprite_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568836 | 0, fb + 3094 | 0);
 return;
}

function __Z47Register_UnityEngine_Sprite_INTERNAL_get_borderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569276 | 0, fb + 3099 | 0);
 return;
}

function __Z47Register_UnityEngine_SliderJoint2D_set_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820966 | 0, fb + 3891 | 0);
 return;
}

function __Z47Register_UnityEngine_SliderJoint2D_get_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820926 | 0, fb + 2360 | 0);
 return;
}

function __Z47Register_UnityEngine_Shader_get_disableBatchingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563960 | 0, fb + 1853 | 0);
 return;
}

function __Z47Register_UnityEngine_Rigidbody2D_set_fixedAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814640 | 0, fb + 3849 | 0);
 return;
}

function __Z47Register_UnityEngine_Rigidbody2D_get_fixedAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814600 | 0, fb + 2327 | 0);
 return;
}

function __Z47Register_UnityEngine_Renderer_set_lightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526075 | 0, fb + 2885 | 0);
 return;
}

function __Z47Register_UnityEngine_Renderer_get_lightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526035 | 0, fb + 1699 | 0);
 return;
}

function __Z47Register_UnityEngine_RenderTexture_set_isVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575442 | 0, fb + 3130 | 0);
 return;
}

function __Z47Register_UnityEngine_RenderTexture_get_isVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575402 | 0, fb + 1918 | 0);
 return;
}

function __Z47Register_UnityEngine_RenderSettings_set_fogModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518632 | 0, fb + 3508 | 0);
 return;
}

function __Z47Register_UnityEngine_Random_GetRandomUnitCirclev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554877 | 0, fb + 3631 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_set_orthographicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527776 | 0, fb + 2903 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_set_ignoreLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527944 | 0, fb + 2904 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_get_orthographicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527736 | 0, fb + 1711 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_get_ignoreLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527904 | 0, fb + 1712 | 0);
 return;
}

function __Z47Register_UnityEngine_Profiling_Sampler_get_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554444 | 0, fb + 1814 | 0);
 return;
}

function __Z47Register_UnityEngine_MonoBehaviour_CancelInvokev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549391 | 0, fb + 3007 | 0);
 return;
}

function __Z47Register_UnityEngine_Mesh_get_vertexBufferCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548383 | 0, fb + 1791 | 0);
 return;
}

function __Z47Register_UnityEngine_LocationService_get_statusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537331 | 0, fb + 1738 | 0);
 return;
}

function __Z47Register_UnityEngine_Light_set_shadowResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541430 | 0, fb + 2964 | 0);
 return;
}

function __Z47Register_UnityEngine_Light_get_shadowResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541390 | 0, fb + 1761 | 0);
 return;
}

function __Z47Register_UnityEngine_Light_RemoveCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542654 | 0, fb + 2972 | 0);
 return;
}

function __Z47Register_UnityEngine_LODGroup_RecalculateBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540437 | 0, fb + 3600 | 0);
 return;
}

function __Z47Register_UnityEngine_HingeJoint2D_set_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819680 | 0, fb + 3881 | 0);
 return;
}

function __Z47Register_UnityEngine_HingeJoint2D_get_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819640 | 0, fb + 2356 | 0);
 return;
}

function __Z47Register_UnityEngine_Graphics_SetupVertexLightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533388 | 0, fb + 3561 | 0);
 return;
}

function __Z47Register_UnityEngine_Gizmos_INTERNAL_set_matrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516674 | 0, fb + 3504 | 0);
 return;
}

function __Z47Register_UnityEngine_Gizmos_INTERNAL_get_matrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516634 | 0, fb + 3503 | 0);
 return;
}

function __Z47Register_UnityEngine_GameObject_CreatePrimitivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514851 | 0, fb + 1663 | 0);
 return;
}

function __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoTogglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021095 | 0, fb + 187 | 0);
 return;
}

function __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoButtonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020948 | 0, fb + 477 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIStyle_Internal_CalcSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024262 | 0, fb + 993 | 0);
 return;
}

function __Z47Register_UnityEngine_GUIClip_INTERNAL_CALL_Pushv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025605 | 0, fb + 327 | 0);
 return;
}

function __Z47Register_UnityEngine_CullingGroup_EraseSwapBackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510806 | 0, fb + 2819 | 0);
 return;
}

function __Z47Register_UnityEngine_Coroutine_ReleaseCoroutinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500051 | 0, fb + 3467 | 0);
 return;
}

function __Z47Register_UnityEngine_Cloth_set_capsuleCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841622 | 0, fb + 3996 | 0);
 return;
}

function __Z47Register_UnityEngine_Cloth_get_capsuleCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841582 | 0, fb + 2438 | 0);
 return;
}

function __Z47Register_UnityEngine_CanvasRenderer_SetMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013899 | 0, fb + 983 | 0);
 return;
}

function __Z47Register_UnityEngine_Camera_set_stereoTargetEyev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506022 | 0, fb + 2802 | 0);
 return;
}

function __Z47Register_UnityEngine_Camera_get_stereoTargetEyev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505982 | 0, fb + 1636 | 0);
 return;
}

function __Z47Register_UnityEngine_Camera_get_stereoActiveEyev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506446 | 0, fb + 1638 | 0);
 return;
}

function __Z47Register_UnityEngine_BillboardAsset_SetVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501279 | 0, fb + 2769 | 0);
 return;
}

function __Z47Register_UnityEngine_BillboardAsset_GetVerticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501191 | 0, fb + 1612 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioSource_set_spatializev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887893 | 0, fb + 4058 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioSource_get_spatializev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887853 | 0, fb + 2499 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_set_roomLFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889921 | 0, fb + 4069 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_set_roomHFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889841 | 0, fb + 4068 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_set_reverbv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890369 | 0, fb + 4071 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_get_roomLFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889881 | 0, fb + 2510 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_get_roomHFv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889801 | 0, fb + 2509 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbZone_get_reverbv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 890329 | 0, fb + 2512 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_set_stabilizeFeetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921074 | 0, fb + 4131 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_get_stabilizeFeetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921034 | 0, fb + 2559 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_get_isOptimizablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918771 | 0, fb + 2549 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_get_isInitializedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918991 | 0, fb + 2553 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_get_hasRootMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918845 | 0, fb + 2551 | 0);
 return;
}

function __Z47Register_UnityEngine_AnimationState_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917655 | 0, fb + 4108 | 0);
 return;
}

function __Z47Register_UnityEngine_AnimationState_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917615 | 0, fb + 2542 | 0);
 return;
}

function __Z47Register_UnityEngine_AnimationClip_set_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915852 | 0, fb + 4089 | 0);
 return;
}

function __Z47Register_UnityEngine_AnimationClip_get_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915812 | 0, fb + 2529 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_FromObjectArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596116 | 0, fb + 1965 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_FromDoubleArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596076 | 0, fb + 1964 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_DeleteGlobalRefv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591964 | 0, fb + 3674 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNIHelper_set_debugv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 590997 | 0, fb + 3671 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMesh_GetAreaFromNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850492 | 0, fb + 2458 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMeshAgent_CopyPathTov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848468 | 0, fb + 4022 | 0);
 return;
}

function __Z46getPxSimulationStatisticsCompressedContactSizePKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __Z46getNbPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __Z46getNbPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __Z46Register_UnityEngine_VR_VRSettings_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045170 | 0, fb + 3953 | 0);
 return;
}

function __Z46Register_UnityEngine_TextGenerator_Dispose_cppv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010734 | 0, fb + 3867 | 0);
 return;
}

function __Z46Register_UnityEngine_GUIStyle_set_stretchWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023155 | 0, fb + 4295 | 0);
 return;
}

function __Z46Register_UnityEngine_GUIStyle_get_stretchWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023116 | 0, fb + 2725 | 0);
 return;
}

function __Z46Register_UnityEngine_Canvas_set_sortingLayerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016033 | 0, fb + 4262 | 0);
 return;
}

function __Z46Register_UnityEngine_Canvas_get_sortingLayerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015994 | 0, fb + 2701 | 0);
 return;
}

function __Z46Register_UnityEngine_CanvasRenderer_set_isMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013511 | 0, fb + 4243 | 0);
 return;
}

function __Z46Register_UnityEngine_CanvasRenderer_get_isMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013472 | 0, fb + 2682 | 0);
 return;
}

function __Z46Register_UnityEngine_CanvasRenderer_SetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014163 | 0, fb + 4248 | 0);
 return;
}

function __Z42Application_Set_Custom_PropRunInBackgroundh(i1) {
 i1 = i1 | 0;
 __Z32SetPlayerSettingsRunInBackgroundb(i1 << 24 >> 24 != 0);
 return;
}

function __Z40getPxVehicleWheelDataMMaxHandBrakeTorquePKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z39getPxClothStretchConfigCompressionLimitPKN5physx20PxClothStretchConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z39Profiler_CUSTOM_GetTotalAllocatedMemoryv() {
 return __ZN13MemoryManager23GetTotalAllocatedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
}

function __Z38AndroidJNI_CUSTOM_CallStaticVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z37getPxVehicleDriveDynData_UseAutoGearsPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 64 >> 0] | 0) != 0 | 0;
}

function __Z37getPxVehicleDriveDynDataMUseAutoGearsPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 64 >> 0] | 0) != 0 | 0;
}

function __Z35getPxVehicleSuspensionDataMMaxDroopPKN5physx23PxVehicleSuspensionDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z34setPxSceneLimitsMaxNbDynamicShapesPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __Z34AndroidJNI_CUSTOM_CallDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0.0;
}

function __Z23DestroyMutexLockedStackP16MutexLockedStack(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63200 | 0);
 return;
}

function __Z17InitScreenManagerv() {
 var i1 = 0;
 i1 = __Znwj(72) | 0;
 __ZN18ScreenManagerWebGLC2Ev(i1);
 HEAP32[gb + 1158216 >> 2] = i1;
 return;
}

function __Z12CanSetWeight9HPlayable(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] & 2 | 0) == 0 | 0;
}

function __Z11stbFreeImplPvS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vii(HEAP32[i2 + 4 >> 2] | 0, i1 | 0, HEAP32[i2 + 8 >> 2] | 0);
 return;
}

function _UNITY_png_set_invert_alpha(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = i1 + 212 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 524288;
 return;
}

function _nearbyintf(f1) {
 f1 = Math_fround(f1);
 var i2 = 0;
 i2 = _fetestexcept(32) | 0;
 f1 = Math_fround(_rintf(f1));
 return Math_fround(f1);
}

function _glScissor__wrapper(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 _glScissor(i1 | 0, i2 | 0, i3 | 0, i4 | 0);
}

function _emscripten_glUniform2i__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glUniform2i(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glStencilOp__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _emscripten_glStencilOp(i1 | 0, i2 | 0, i3 | 0);
}

function ___cxa_guard_acquire(i1) {
 i1 = i1 | 0;
 if ((HEAP8[i1 >> 0] | 0) == 1) i1 = 0; else {
  HEAP8[i1 >> 0] = 1;
  i1 = 1;
 }
 return i1 | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateShaderHandleErrorsstruct7ForwardEv() {
 __ZN6Shader23HandleShadersWithErrorsEv();
 return;
}

function __ZThn8_N5physx2Sc19ShapeInstancePairLL7destroyEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc19ShapeInstancePairLL7destroyEv(i1 + -8 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 240 >> 2]);
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 544 >> 2] = i1;
 return;
}

function __ZSt17rethrow_exceptionSt13exception_ptr(i1) {
 i1 = i1 | 0;
 ___cxa_rethrow_primary_exception(HEAP32[i1 >> 2] | 0);
 __ZSt9terminatev();
}

function __ZNSt3__219__shared_weak_count10__add_weakEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 436 >> 2] | 0) >>> 0) / 3 | 0 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getConstraintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx3Ext13RevoluteJoint16getDriveVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 72 >> 2]);
}

function __ZNK5physx3Cct15ObstacleContext14getNbObstaclesEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + (HEAP32[i1 + 8 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc14ConstraintCore15getPxConstraintEv(i1) {
 i1 = i1 | 0;
 return __Z17NpGetPxConstraintRKN5physx2Sc14ConstraintCoreE(i1) | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK28RectTransformPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK28MonoBehaviourPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN9Rigidbody18ResetInertiaTensorEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 81 >> 0] = 1;
 __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 return;
}

function __ZN9GfxDevice26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8Material12CleanupClassEv() {
 HEAP32[gb + 1166352 >> 2] = 0;
 HEAP32[gb + 1166356 >> 2] = 0;
 HEAP32[gb + 1166360 >> 2] = 0;
 return;
}

function __ZN5physx5cloth13UserAllocatedD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZN5physx5cloth13UserAllocatedD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167276 + 8;
 __ZN5physx5cloth10deallocateEPv(i1);
 return;
}

function __ZN5physx3Cct17CapsuleController15invalidateCacheEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct9SweepTest13voidTestCacheEv(i1 + 96 | 0);
 return;
}

function __ZN5physx32PxsSolverConstraintPartitionTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Sc16ArticulationCore18setFreezeThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 28 >> 2] = f2;
 return;
}

function __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 32 >> 2];
 return;
}

function __ZN5physx25PxVehicleConstraintShader20getExternalReferenceERj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 1;
 return i1 | 0;
}

function __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN4FMOD7SystemI20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 368 >> 2] = i2;
 return 0;
}

function __ZN4FMOD4DSPI12getParameterEiPfPci(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN15UnityAdsManagerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15OcclusionPortalD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN15NavMeshSettingsD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28344 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13Simd4fFactoryIN6detail14AlignedPointerIfEEEC2ES2_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN12EventManager15DeallocateEntryEP10EventEntry(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN10MemoryPool10DeallocateEPv(i1, i2);
 return;
}

function __Z7anyTrueRK8Scalar4f(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | HEAP32[i1 >> 2] | HEAP32[i1 + 8 >> 2] | HEAP32[i1 + 12 >> 2] | 0;
}

function __Z6FTFreeP13FT_MemoryRec_Pv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i2, gb + 63392 | 0);
 return;
}

function __Z49Register_UnityEngine_ReflectionProbe_BlendCubemapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557864 | 0, fb + 2 | 0);
 return;
}

function __Z49Register_UnityEngine_Debug_INTERNAL_CALL_DrawLinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511563 | 0, fb + 7 | 0);
 return;
}

function __Z48Register_UnityEngine_Time_get_timeSinceLevelLoadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576541 | 0, fb + 19 | 0);
 return;
}

function __Z48Register_UnityEngine_QualitySettings_set_lodBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522316 | 0, fb + 14 | 0);
 return;
}

function __Z48Register_UnityEngine_QualitySettings_get_lodBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 522275 | 0, fb + 14 | 0);
 return;
}

function __Z48Register_UnityEngine_Physics_set_bounceThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782530 | 0, fb + 23 | 0);
 return;
}

function __Z48Register_UnityEngine_Physics_get_bounceThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782489 | 0, fb + 32 | 0);
 return;
}

function __Z48Register_UnityEngine_Graphics_Internal_SetNullRTv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532895 | 0, fb + 99 | 0);
 return;
}

function __Z48Register_UnityEngine_DynamicGI_UpdateEnvironmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513006 | 0, fb + 93 | 0);
 return;
}

function __Z48Register_UnityEngine_Debug_ClearDeveloperConsolev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511660 | 0, fb + 91 | 0);
 return;
}

function __Z48Register_UnityEngine_Caching_get_expirationDelayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502449 | 0, fb + 92 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_sandboxTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494555 | 0, fb + 25 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_productNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494596 | 0, fb + 26 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_isBatchmodev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493790 | 0, fb + 11 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_installModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494514 | 0, fb + 24 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_companyNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494637 | 0, fb + 27 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_absoluteURLv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494258 | 0, fb + 19 | 0);
 return;
}

function __Z48Register_UnityEngine_AI_NavMeshAgent_SetAreaCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848801 | 0, fb + 66 | 0);
 return;
}

function __Z48Register_UnityEngine_AI_NavMeshAgent_GetAreaCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848842 | 0, fb + 33 | 0);
 return;
}

function __Z47Register_UnityEngine_WheelCollider_GetWorldPosev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837408 | 0, fb + 901 | 0);
 return;
}

function __Z47Register_UnityEngine_WheelCollider_GetGroundHitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837368 | 0, fb + 902 | 0);
 return;
}

function __Z47Register_UnityEngine_TrailRenderer_set_endWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528318 | 0, fb + 176 | 0);
 return;
}

function __Z47Register_UnityEngine_TrailRenderer_get_endWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528278 | 0, fb + 222 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture2D_get_whiteTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572024 | 0, fb + 213 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture2D_get_blackTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572064 | 0, fb + 214 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture2DArray_SetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573691 | 0, fb + 246 | 0);
 return;
}

function __Z47Register_UnityEngine_Texture2DArray_GetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573769 | 0, fb + 372 | 0);
 return;
}

function __Z47Register_UnityEngine_Terrain_get_activeTerrainsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944384 | 0, fb + 266 | 0);
 return;
}

function __Z47Register_UnityEngine_TerrainData_GetDetailLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940088 | 0, fb + 144 | 0);
 return;
}

function __Z47Register_UnityEngine_TargetJoint2D_set_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821837 | 0, fb + 480 | 0);
 return;
}

function __Z47Register_UnityEngine_TargetJoint2D_get_maxForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 821797 | 0, fb + 556 | 0);
 return;
}

function __Z47Register_UnityEngine_SpringJoint2D_set_distancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818890 | 0, fb + 469 | 0);
 return;
}

function __Z47Register_UnityEngine_SpringJoint2D_get_distancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818850 | 0, fb + 539 | 0);
 return;
}

function __Z47Register_UnityEngine_RenderTexture_GetTemporaryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574451 | 0, fb + 135 | 0);
 return;
}

function __Z47Register_UnityEngine_RenderSettings_get_fogModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518592 | 0, fb + 111 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_set_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527540 | 0, fb + 170 | 0);
 return;
}

function __Z47Register_UnityEngine_Projector_get_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527500 | 0, fb + 216 | 0);
 return;
}

function __Z47Register_UnityEngine_Physics2D_IsTouchingLayersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811380 | 0, fb + 891 | 0);
 return;
}

function __Z47Register_UnityEngine_Motion_get_averageDurationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549846 | 0, fb + 249 | 0);
 return;
}

function __Z47Register_UnityEngine_MeshCollider_set_skinWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795622 | 0, fb + 444 | 0);
 return;
}

function __Z47Register_UnityEngine_MeshCollider_get_skinWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795582 | 0, fb + 513 | 0);
 return;
}

function __Z47Register_UnityEngine_Material_SetFloatArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565673 | 0, fb + 655 | 0);
 return;
}

function __Z47Register_UnityEngine_Material_SetColorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565843 | 0, fb + 659 | 0);
 return;
}

function __Z47Register_UnityEngine_Material_GetFloatArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566013 | 0, fb + 674 | 0);
 return;
}

function __Z47Register_UnityEngine_Material_GetColorArrayImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566183 | 0, fb + 676 | 0);
 return;
}

function __Z47Register_UnityEngine_Light_set_shadowNormalBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541670 | 0, fb + 188 | 0);
 return;
}

function __Z47Register_UnityEngine_Light_get_shadowNormalBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541630 | 0, fb + 239 | 0);
 return;
}

function __Z47Register_UnityEngine_HumanTrait_get_MuscleCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929418 | 0, fb + 252 | 0);
 return;
}

function __Z47Register_UnityEngine_Graphics_CopyTexture_Slicev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532814 | 0, fb + 169 | 0);
 return;
}

function __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021264 | 0, fb + 22 | 0);
 return;
}

function __Z47Register_UnityEngine_FixedJoint2D_set_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822173 | 0, fb + 484 | 0);
 return;
}

function __Z47Register_UnityEngine_FixedJoint2D_get_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822133 | 0, fb + 560 | 0);
 return;
}

function __Z47Register_UnityEngine_ConstantForce2D_set_torquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823144 | 0, fb + 487 | 0);
 return;
}

function __Z47Register_UnityEngine_ConstantForce2D_get_torquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823104 | 0, fb + 566 | 0);
 return;
}

function __Z47Register_UnityEngine_Component_BroadcastMessagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509075 | 0, fb + 226 | 0);
 return;
}

function __Z47Register_UnityEngine_Collider_set_contactOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794648 | 0, fb + 442 | 0);
 return;
}

function __Z47Register_UnityEngine_Collider_get_contactOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794608 | 0, fb + 511 | 0);
 return;
}

function __Z47Register_UnityEngine_Cloth_set_bendingStiffnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840177 | 0, fb + 576 | 0);
 return;
}

function __Z47Register_UnityEngine_Cloth_get_bendingStiffnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840137 | 0, fb + 665 | 0);
 return;
}

function __Z47Register_UnityEngine_CapsuleCollider_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795800 | 0, fb + 445 | 0);
 return;
}

function __Z47Register_UnityEngine_CapsuleCollider_set_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795880 | 0, fb + 446 | 0);
 return;
}

function __Z47Register_UnityEngine_CapsuleCollider_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795760 | 0, fb + 514 | 0);
 return;
}

function __Z47Register_UnityEngine_CapsuleCollider_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795840 | 0, fb + 515 | 0);
 return;
}

function __Z47Register_UnityEngine_Camera_get_allCamerasCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507206 | 0, fb + 100 | 0);
 return;
}

function __Z47Register_UnityEngine_Camera_RemoveCommandBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508306 | 0, fb + 570 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioSource_SetCustomCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888035 | 0, fb + 910 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioSource_GetCustomCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888075 | 0, fb + 941 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbFilter_set_roomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892821 | 0, fb + 642 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioReverbFilter_get_roomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892781 | 0, fb + 732 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioEchoFilter_set_wetMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891883 | 0, fb + 632 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioEchoFilter_set_dryMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891803 | 0, fb + 631 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioEchoFilter_get_wetMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891843 | 0, fb + 722 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioEchoFilter_get_dryMixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891763 | 0, fb + 721 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioChorusFilter_set_ratev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892387 | 0, fb + 638 | 0);
 return;
}

function __Z47Register_UnityEngine_AudioChorusFilter_get_ratev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 892347 | 0, fb + 728 | 0);
 return;
}

function __Z47Register_UnityEngine_AssetBundle_LoadFromMemoryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496371 | 0, fb + 614 | 0);
 return;
}

function __Z47Register_UnityEngine_Animator_get_gravityWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919848 | 0, fb + 759 | 0);
 return;
}

function __Z47Register_UnityEngine_AnimationClip_get_stopTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915533 | 0, fb + 750 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_SetBooleanFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593633 | 0, fb + 701 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_GetBooleanFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593253 | 0, fb + 782 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_CallShortMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592884 | 0, fb + 380 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNIHelper_get_debugv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 590957 | 0, fb + 221 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMesh_AddOffMeshLinksv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850612 | 0, fb + 270 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMeshAgent_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849553 | 0, fb + 590 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMeshAgent_set_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849633 | 0, fb + 591 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMeshAgent_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849513 | 0, fb + 680 | 0);
 return;
}

function __Z47Register_UnityEngine_AI_NavMeshAgent_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849593 | 0, fb + 681 | 0);
 return;
}

function __Z46getPxSimulationStatisticsNbActiveDynamicBodiesPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z46Register_UnityEngine_WheelJoint2D_set_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822397 | 0, fb + 3904 | 0);
 return;
}

function __Z46Register_UnityEngine_WheelJoint2D_get_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 822358 | 0, fb + 2364 | 0);
 return;
}

function __Z46Register_UnityEngine_VR_VRSettings_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045131 | 0, fb + 299 | 0);
 return;
}

function __Z46Register_UnityEngine_VR_VRDevice_get_isPresentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045786 | 0, fb + 306 | 0);
 return;
}

function __Z46Register_UnityEngine_VR_InputTracking_Recenterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1046156 | 0, fb + 410 | 0);
 return;
}

function __Z46Register_UnityEngine_Tree_get_hasSpeedTreeWindv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944523 | 0, fb + 2621 | 0);
 return;
}

function __Z46Register_UnityEngine_Transform_SetSiblingIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578930 | 0, fb + 3151 | 0);
 return;
}

function __Z46Register_UnityEngine_Transform_GetSiblingIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578969 | 0, fb + 1928 | 0);
 return;
}

function __Z46Register_UnityEngine_Time_set_captureFrameratev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577225 | 0, fb + 3657 | 0);
 return;
}

function __Z46Register_UnityEngine_Texture_Internal_GetWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571322 | 0, fb + 1886 | 0);
 return;
}

function __Z46Register_UnityEngine_Texture2D_get_mipmapCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571867 | 0, fb + 1893 | 0);
 return;
}

function __Z46Register_UnityEngine_Texture2DArray_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573536 | 0, fb + 1902 | 0);
 return;
}

function __Z46Register_UnityEngine_Terrain_set_lightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942558 | 0, fb + 4179 | 0);
 return;
}

function __Z46Register_UnityEngine_Terrain_set_drawHeightmapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943524 | 0, fb + 4192 | 0);
 return;
}

function __Z46Register_UnityEngine_Terrain_get_lightmapIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942519 | 0, fb + 2609 | 0);
 return;
}

function __Z46Register_UnityEngine_Terrain_get_drawHeightmapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943485 | 0, fb + 2615 | 0);
 return;
}

function __Z46Register_UnityEngine_RuntimeUndo_RecordObjectsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560845 | 0, fb + 3056 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_set_isKinematicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785205 | 0, fb + 3684 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_set_constraintsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785367 | 0, fb + 3686 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_get_isKinematicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785166 | 0, fb + 2279 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_get_constraintsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785328 | 0, fb + 2281 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody2D_set_sleepModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815185 | 0, fb + 3854 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody2D_set_simulatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815021 | 0, fb + 3852 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody2D_get_sleepModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815146 | 0, fb + 2334 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody2D_get_simulatedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814982 | 0, fb + 2332 | 0);
 return;
}

function __Z46Register_UnityEngine_Renderer_set_sortingOrderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527322 | 0, fb + 2901 | 0);
 return;
}

function __Z46Register_UnityEngine_Renderer_get_sortingOrderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527283 | 0, fb + 1710 | 0);
 return;
}

function __Z46Register_UnityEngine_Renderer_SetPropertyBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527037 | 0, fb + 2897 | 0);
 return;
}

function __Z46Register_UnityEngine_Renderer_GetPropertyBlockv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527076 | 0, fb + 2898 | 0);
 return;
}

function __Z46Register_UnityEngine_RenderTexture_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576432 | 0, fb + 3656 | 0);
 return;
}

function __Z46Register_UnityEngine_RenderSettings_set_skyboxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520327 | 0, fb + 3523 | 0);
 return;
}

function __Z46Register_UnityEngine_RectOffset_get_horizontalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514044 | 0, fb + 1659 | 0);
 return;
}

function __Z46Register_UnityEngine_Random_INTERNAL_set_statev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554697 | 0, fb + 3629 | 0);
 return;
}

function __Z46Register_UnityEngine_Random_INTERNAL_get_statev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554658 | 0, fb + 3628 | 0);
 return;
}

function __Z46Register_UnityEngine_Mesh_ExtractArrayFromListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547932 | 0, fb + 1789 | 0);
 return;
}

function __Z46Register_UnityEngine_MeshFilter_set_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523789 | 0, fb + 2860 | 0);
 return;
}

function __Z46Register_UnityEngine_MeshFilter_get_sharedMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523750 | 0, fb + 1680 | 0);
 return;
}

function __Z46Register_UnityEngine_LineRenderer_SetPositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530129 | 0, fb + 2924 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_set_pixelLightCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542855 | 0, fb + 3602 | 0);
 return;
}

function __Z46Register_UnityEngine_LightProbes_get_positionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533488 | 0, fb + 1731 | 0);
 return;
}

function __Z46Register_UnityEngine_LightProbes_get_cellCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533644 | 0, fb + 1734 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint_set_enableCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788389 | 0, fb + 3714 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint_get_enableCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788350 | 0, fb + 2291 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint_INTERNAL_set_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787973 | 0, fb + 3710 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint_INTERNAL_get_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787934 | 0, fb + 3709 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint2D_set_connectedBodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818024 | 0, fb + 3870 | 0);
 return;
}

function __Z46Register_UnityEngine_Joint2D_get_connectedBodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817985 | 0, fb + 2349 | 0);
 return;
}

function __Z46Register_UnityEngine_HumanTrait_BoneFromMusclev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929611 | 0, fb + 2585 | 0);
 return;
}

function __Z46Register_UnityEngine_HingeJoint2D_set_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819601 | 0, fb + 3880 | 0);
 return;
}

function __Z46Register_UnityEngine_HingeJoint2D_get_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 819562 | 0, fb + 2355 | 0);
 return;
}

function __Z46Register_UnityEngine_Graphics_CopyTexture_Fullv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532775 | 0, fb + 2933 | 0);
 return;
}

function __Z46Register_UnityEngine_Gizmos_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516595 | 0, fb + 3502 | 0);
 return;
}

function __Z46Register_UnityEngine_Gizmos_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516556 | 0, fb + 3501 | 0);
 return;
}

function __Z46Register_UnityEngine_GameObject_get_activeSelfv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515409 | 0, fb + 1667 | 0);
 return;
}

function __Z46Register_UnityEngine_GUI_get_usePageScrollbarsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021135 | 0, fb + 280 | 0);
 return;
}

function __Z46Register_UnityEngine_GUI_Internal_BeginWindowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021477 | 0, fb + 371 | 0);
 return;
}

function __Z46Register_UnityEngine_GUI_INTERNAL_CALL_DoLabelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020798 | 0, fb + 987 | 0);
 return;
}

function __Z46Register_UnityEngine_GUIUtility_UpdateUndoNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024753 | 0, fb + 373 | 0);
 return;
}

function __Z46Register_UnityEngine_GUIStyle_AssignStyleStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022335 | 0, fb + 989 | 0);
 return;
}

function __Z46Register_UnityEngine_GUIStyle_AssignRectOffsetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022427 | 0, fb + 991 | 0);
 return;
}

function __Z46Register_UnityEngine_GL_INTERNAL_set_modelviewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535701 | 0, fb + 3581 | 0);
 return;
}

function __Z46Register_UnityEngine_GL_INTERNAL_get_modelviewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535662 | 0, fb + 3580 | 0);
 return;
}

function __Z46Register_UnityEngine_GL_INTERNAL_CALL_Viewportv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535543 | 0, fb + 3578 | 0);
 return;
}

function __Z46Register_UnityEngine_GL_INTERNAL_CALL_TexCoordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535202 | 0, fb + 3576 | 0);
 return;
}

function __Z46Register_UnityEngine_EdgeCollider2D_set_pointsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817395 | 0, fb + 3864 | 0);
 return;
}

function __Z46Register_UnityEngine_EdgeCollider2D_get_pointsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817356 | 0, fb + 2344 | 0);
 return;
}

function __Z46Register_UnityEngine_Collider2D_get_shapeCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816565 | 0, fb + 2339 | 0);
 return;
}

function __Z46Register_UnityEngine_Collider2D_get_errorStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816648 | 0, fb + 2340 | 0);
 return;
}

function __Z46Register_UnityEngine_Cloth_set_sphereCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841701 | 0, fb + 3997 | 0);
 return;
}

function __Z46Register_UnityEngine_Cloth_set_solverFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841543 | 0, fb + 3995 | 0);
 return;
}

function __Z46Register_UnityEngine_Cloth_get_sphereCollidersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841662 | 0, fb + 2439 | 0);
 return;
}

function __Z46Register_UnityEngine_Cloth_get_solverFrequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841504 | 0, fb + 2437 | 0);
 return;
}

function __Z46Register_UnityEngine_Camera_set_opaqueSortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503748 | 0, fb + 2779 | 0);
 return;
}

function __Z46Register_UnityEngine_Camera_get_opaqueSortModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503709 | 0, fb + 1623 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_SetIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501457 | 0, fb + 2772 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_GetIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501371 | 0, fb + 1613 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_get_isVirtualv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887171 | 0, fb + 2493 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_get_isPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887132 | 0, fb + 2492 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioClip_UnloadAudioDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885699 | 0, fb + 2484 | 0);
 return;
}

function __Z46Register_UnityEngine_AsyncOperation_get_isDonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 497443 | 0, fb + 1598 | 0);
 return;
}

function __Z46Register_UnityEngine_AssetBundle_get_mainAssetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496411 | 0, fb + 1592 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_get_recorderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923068 | 0, fb + 2566 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_SetTriggerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923844 | 0, fb + 4140 | 0);
 return;
}

function __Z46Register_UnityEngine_Animation_set_cullingTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917480 | 0, fb + 4105 | 0);
 return;
}

function __Z46Register_UnityEngine_Animation_get_cullingTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917441 | 0, fb + 2541 | 0);
 return;
}

function __Z46Register_UnityEngine_AnimationCurve_get_lengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546442 | 0, fb + 1783 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_PushLocalFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591822 | 0, fb + 1953 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_GetArrayLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596156 | 0, fb + 1966 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_FromShortArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595923 | 0, fb + 1960 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_FromFloatArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 596037 | 0, fb + 1963 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_DeleteLocalRefv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592054 | 0, fb + 3675 | 0);
 return;
}

function __Z46Register_UnityEngine_AI_NavMeshPath_get_statusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852287 | 0, fb + 2463 | 0);
 return;
}

function __Z46Register_UnityEngine_AI_NavMeshAgent_ResetPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848392 | 0, fb + 3775 | 0);
 return;
}

function __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectClass13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z45getPxSimulationStatisticsPeakConstraintMemoryPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function __Z45getNbPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z45getNbPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z45getNbPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z45Register_UnityEngine_RemoteSettings_GetStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1042720 | 0, fb + 1128 | 0);
 return;
}

function __Z45Register_UnityEngine_ParticleEmitter_set_emitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1049941 | 0, fb + 4435 | 0);
 return;
}

function __Z45Register_UnityEngine_ParticleEmitter_get_emitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1049903 | 0, fb + 2769 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIUtility_set_mouseUsedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025438 | 0, fb + 3908 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIStyle_SetFontInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023319 | 0, fb + 4297 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIStyle_GetFontInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023414 | 0, fb + 2728 | 0);
 return;
}

function __Z45Register_UnityEngine_Font_Internal_CreateFontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010187 | 0, fb + 4229 | 0);
 return;
}

function __Z45Register_UnityEngine_Canvas_set_targetDisplayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015756 | 0, fb + 4260 | 0);
 return;
}

function __Z45Register_UnityEngine_Canvas_get_targetDisplayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015718 | 0, fb + 2699 | 0);
 return;
}

function __Z39scripting_free_captured_memory_snapshotP14MemorySnapshot(i1) {
 i1 = i1 | 0;
 _il2cpp_free_captured_memory_snapshot(i1 | 0);
 return;
}

function __Z39RenderSettings_CUSTOM_GetRenderSettingsv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z17GetRenderSettingsv() | 0) | 0;
}

function __Z39NavMeshPath_CUSTOM_ClearCornersInternalP12Il2CppObject(i1) {
 i1 = i1 | 0;
 HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 20 >> 2] = 0;
 return;
}

function __Z36getPxVehicleDriveDynDataMEnginespeedPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 76 >> 2]);
}

function __Z35AndroidJNI_CUSTOM_CallBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z29setPxClothFabricPhaseSetIndexPN5physx18PxClothFabricPhaseEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z29GUI_CUSTOM_BringWindowToFronti(i1) {
 i1 = i1 | 0;
 __ZN5IMGUI18BringWindowToFrontER8GUIStatei(__Z11GetGUIStatev() | 0, i1);
 return;
}

function __Z21GetScriptingArraySizeP11Il2CppArray(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = _il2cpp_array_length(i1 | 0) | 0;
 return i1 | 0;
}

function __Z19MainThreadSchedulerPFvPvES_10JobGroupID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 return;
}

function _UNITY_png_set_check_for_invalid_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 420 >> 2] = ((i2 | 0) < 1) << 31 >> 31;
 return;
}

function _UNITY_png_flush(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = HEAP32[i1 + 468 >> 2] | 0;
 if (!i2) return;
 mftCall_vi(i2 | 0, i1 | 0);
 return;
}

function _UNITY_png_app_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!(HEAP32[i1 + 208 >> 2] & 4194304)) _UNITY_png_error(i1, i2); else return;
}

function _UNITY_ft_mem_free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 mftCall_vii(HEAP32[i1 + 8 >> 2] | 0, i1 | 0, i2 | 0);
 return;
}

function b54(i1, f2, i3, i4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_iifiii(54);
 return 0;
}

function b43(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_iiifii(43);
 return 0;
}

function b130(i1, i2, f3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 nullFunc_viiffi(130);
}

function _strnlen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 var i3 = 0;
 i3 = _memchr(i1, 0, i2) | 0;
 return ((i3 | 0) == 0 ? i2 : i3 - i1 | 0) | 0;
}

function _ps_get_macintosh_name(i1) {
 i1 = i1 | 0;
 return (HEAP16[gb + 225266 + ((i1 >>> 0 > 257 ? 0 : i1) << 1) >> 1] | 0) + (gb + 947122) | 0;
}

function __ZZ29InitializeTextRenderingModulevEN16cleanupAfterLoad7ForwardEv() {
 __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv();
 return;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 520 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 508 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 496 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 532 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 520 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 508 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 496 | 0;
}

function __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 + 532 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 156 >> 2]);
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 456 >> 2]);
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 536 >> 2] = HEAP32[i1 + 528 >> 2];
 return;
}

function __ZNSt3__218shared_timed_mutex15try_lock_sharedEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__219__shared_mutex_base15try_lock_sharedEv(i1) | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__get_long_sizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__get_long_sizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx9NpPhysics11getNbShapesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx9NpFactory11getNbShapesEv(HEAP32[gb + 1457204 >> 2] | 0) | 0;
}

function __ZNK5physx2Sc8ShapeSim8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 36 >> 2] | 0) + 1008 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP24getNumOutOfBoundsObjectsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 84 >> 2] | 0) + 5240 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE8getSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE(i1) | 0;
}

function __ZNK13TranslateGLES9FilterMagE17TextureFilterMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75492 + (i2 << 2) >> 2] | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE10GetPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -4 >> 2] | 0) >>> 1 | 0;
}

function __ZN9Rigidbody17ResetCenterOfMassEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 82 >> 0] = 1;
 __ZN9Rigidbody22UpdateMassDistributionEv(i1);
 return;
}

function __ZN9GfxDevice12EndRecordingEPP14GfxDisplayListRK19ShaderPropertySheet(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN6Motion21AddSelfToDependenciesER8UserList(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList7AddUserERS_(i2, i1 + 32 | 0);
 return;
}

function __ZN5physx6shdfnd8SyncImplD2Ev(i1) {
 i1 = i1 | 0;
 _pthread_cond_destroy(i1 + 28 | 0) | 0;
 _pthread_mutex_destroy(i1 | 0) | 0;
 return;
}

function __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 12;
 return i1 | 0;
}

function __ZN5physx2Sc21ArticulationJointCore12setStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 88 >> 2] = f1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 48 >> 2] = f1;
 return;
}

function __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 24 >> 2] = f2;
 return;
}

function __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN4Mesh21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 __ZN17CollisionMeshData21AwakeFromLoadThreadedER4Mesh(i1 + 204 | 0, i1);
 return;
}

function __ZN27AnimationLayerMixerPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 32 >> 2] | 0;
}

function __ZN17ParticleLightNodeD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 33936 + 8;
 __ZN19RenderEventsContextD2Ev(i1 + 208 | 0);
 return;
}

function __ZN16b2ContactManager15FindNewContactsEv(i1) {
 i1 = i1 | 0;
 __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_(i1, i1);
 return;
}

function __ZN16BaseVideoTexture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 176 >> 2] | 0, i1 | 0);
 return;
}

function __ZN15GUIEventManager11ClearEventsEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__212__deque_baseI10InputEventNS_9allocatorIS1_EEE5clearEv(i1);
 return;
}

function __ZN15ArchiveReadFile5WriteEyPKvPy(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function __ZN14RenderSettingsD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28344 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14ParticleSystem10SetPrewarmEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 278 >> 0] = i2 & 1;
 return;
}

function __ZN14MemoryProfiler17PopAllocationRootEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1163244 >> 2] = (HEAP32[gb + 1163244 >> 2] | 0) + -4;
 return;
}

function __ZN13GfxDeviceNull14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13GfxDeviceGLES14GetFramebufferEv(i1) {
 i1 = i1 | 0;
 return __ZN14GfxContextGLES14GetFramebufferEv(HEAP32[i1 + 4616 >> 2] | 0) | 0;
}

function __ZN13DrawImmediate3EndEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 16 >> 2] | 0)) return;
 __ZN13DrawImmediate11FlushBufferEv(i1);
 return;
}

function __ZN13BitSetUtility10InitBitSetEPjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memset(i1 | 0, 0, (i2 + 31 | 0) >>> 5 << 2 | 0) | 0;
 return;
}

function __Z48Register_UnityEngine_Vector3_INTERNAL_CALL_Slerpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 544460 | 0, fb + 4 | 0);
 return;
}

function __Z48Register_UnityEngine_Sprite_INTERNAL_CALL_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568795 | 0, fb + 1 | 0);
 return;
}

function __Z48Register_UnityEngine_Graphics_CopyTexture_Regionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532854 | 0, fb + 3 | 0);
 return;
}

function __Z48Register_UnityEngine_DynamicGI_set_indirectScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512717 | 0, fb + 1 | 0);
 return;
}

function __Z48Register_UnityEngine_DynamicGI_get_indirectScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512676 | 0, fb + 1 | 0);
 return;
}

function __Z48Register_UnityEngine_Application_get_isWebPlayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493495 | 0, fb + 6 | 0);
 return;
}

function __Z48Register_UnityEngine_Animator_SetFloatStringDampv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924106 | 0, fb + 3 | 0);
 return;
}

function __Z48Register_UnityEngine_AndroidJNI_CallDoubleMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593042 | 0, fb + 1 | 0);
 return;
}

function __Z47Register_UnityEngine_Time_get_unscaledDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576681 | 0, fb + 23 | 0);
 return;
}

function __Z47Register_UnityEngine_SystemInfo_get_npotSupportv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499514 | 0, fb + 73 | 0);
 return;
}

function __Z47Register_UnityEngine_SystemInfo_get_deviceModelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499644 | 0, fb + 76 | 0);
 return;
}

function __Z47Register_UnityEngine_Physics_set_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783081 | 0, fb + 27 | 0);
 return;
}

function __Z47Register_UnityEngine_Physics_get_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 783041 | 0, fb + 36 | 0);
 return;
}

function __Z47Register_UnityEngine_Caching_get_spaceAvailablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502374 | 0, fb + 90 | 0);
 return;
}

function __Z47Register_UnityEngine_AndroidJNI_CallFloatMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593002 | 0, fb + 22 | 0);
 return;
}

function __Z46Register_UnityEngine_WebCamTexture_get_devicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895906 | 0, fb + 251 | 0);
 return;
}

function __Z46Register_UnityEngine_WebCamTexture_GetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 896032 | 0, fb + 945 | 0);
 return;
}

function __Z46Register_UnityEngine_Time_get_captureFrameratev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577186 | 0, fb + 219 | 0);
 return;
}

function __Z46Register_UnityEngine_Texture3D_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573459 | 0, fb + 174 | 0);
 return;
}

function __Z46Register_UnityEngine_Terrain_get_activeTerrainv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944345 | 0, fb + 265 | 0);
 return;
}

function __Z46Register_UnityEngine_TerrainData_set_thicknessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938842 | 0, fb + 671 | 0);
 return;
}

function __Z46Register_UnityEngine_TerrainData_get_thicknessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938803 | 0, fb + 770 | 0);
 return;
}

function __Z46Register_UnityEngine_SpringJoint_set_tolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789511 | 0, fb + 437 | 0);
 return;
}

function __Z46Register_UnityEngine_SpringJoint_get_tolerancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789472 | 0, fb + 506 | 0);
 return;
}

function __Z46Register_UnityEngine_SphereCollider_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795303 | 0, fb + 443 | 0);
 return;
}

function __Z46Register_UnityEngine_SphereCollider_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795264 | 0, fb + 512 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_set_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784835 | 0, fb + 423 | 0);
 return;
}

function __Z46Register_UnityEngine_Rigidbody_get_angularDragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784796 | 0, fb + 491 | 0);
 return;
}

function __Z46Register_UnityEngine_RenderTexture_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576393 | 0, fb + 216 | 0);
 return;
}

function __Z46Register_UnityEngine_RenderSettings_get_skyboxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520288 | 0, fb + 114 | 0);
 return;
}

function __Z46Register_UnityEngine_QualitySettings_get_namesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520844 | 0, fb + 120 | 0);
 return;
}

function __Z46Register_UnityEngine_Projector_set_fieldOfViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527619 | 0, fb + 171 | 0);
 return;
}

function __Z46Register_UnityEngine_Projector_set_aspectRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527697 | 0, fb + 172 | 0);
 return;
}

function __Z46Register_UnityEngine_Projector_get_fieldOfViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527580 | 0, fb + 217 | 0);
 return;
}

function __Z46Register_UnityEngine_Projector_get_aspectRatiov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527658 | 0, fb + 218 | 0);
 return;
}

function __Z46Register_UnityEngine_PolygonCollider2D_SetPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817745 | 0, fb + 879 | 0);
 return;
}

function __Z46Register_UnityEngine_PolygonCollider2D_GetPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817706 | 0, fb + 898 | 0);
 return;
}

function __Z46Register_UnityEngine_Physics2D_IgnoreCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811084 | 0, fb + 869 | 0);
 return;
}

function __Z46Register_UnityEngine_Material_IsKeywordEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566947 | 0, fb + 682 | 0);
 return;
}

function __Z46Register_UnityEngine_LineRenderer_set_endWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529442 | 0, fb + 180 | 0);
 return;
}

function __Z46Register_UnityEngine_LineRenderer_get_endWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529403 | 0, fb + 226 | 0);
 return;
}

function __Z46Register_UnityEngine_LineRenderer_GetPositionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 530168 | 0, fb + 639 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_set_shadowNearPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541749 | 0, fb + 189 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_set_bounceIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541213 | 0, fb + 185 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_get_shadowNearPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541710 | 0, fb + 240 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_get_pixelLightCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542816 | 0, fb + 184 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_get_bounceIntensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541174 | 0, fb + 236 | 0);
 return;
}

function __Z46Register_UnityEngine_Light_RemoveCommandBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542615 | 0, fb + 621 | 0);
 return;
}

function __Z46Register_UnityEngine_Input_get_isGyroAvailablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538151 | 0, fb + 165 | 0);
 return;
}

function __Z46Register_UnityEngine_HumanTrait_get_MuscleNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929458 | 0, fb + 253 | 0);
 return;
}

function __Z46Register_UnityEngine_HumanTrait_MuscleFromBonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929572 | 0, fb + 990 | 0);
 return;
}

function __Z46Register_UnityEngine_Debug_SetDiagnosticSwitchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511907 | 0, fb + 583 | 0);
 return;
}

function __Z46Register_UnityEngine_CullingGroup_QueryIndicesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510846 | 0, fb + 133 | 0);
 return;
}

function __Z46Register_UnityEngine_CrashReport_GetReportDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510147 | 0, fb + 628 | 0);
 return;
}

function __Z46Register_UnityEngine_Collider2D_get_bouncinessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816810 | 0, fb + 535 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_set_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500658 | 0, fb + 155 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_set_bottomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500736 | 0, fb + 156 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500619 | 0, fb + 203 | 0);
 return;
}

function __Z46Register_UnityEngine_BillboardAsset_get_bottomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500697 | 0, fb + 204 | 0);
 return;
}

function __Z46Register_UnityEngine_Audio_AudioMixer_GetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894721 | 0, fb + 435 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_set_panStereov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887730 | 0, fb + 603 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_set_minVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889160 | 0, fb + 610 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_set_maxVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889238 | 0, fb + 611 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_get_panStereov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887691 | 0, fb + 693 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_get_minVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889121 | 0, fb + 700 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_get_maxVolumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889199 | 0, fb + 701 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioEchoFilter_set_delayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891636 | 0, fb + 629 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioEchoFilter_get_delayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 891597 | 0, fb + 719 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_set_playbackTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922782 | 0, fb + 667 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_get_playbackTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922743 | 0, fb + 763 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_SetIntegerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923696 | 0, fb + 940 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_GetIntegerStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923770 | 0, fb + 973 | 0);
 return;
}

function __Z46Register_UnityEngine_Animator_GetBoneTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922557 | 0, fb + 970 | 0);
 return;
}

function __Z46Register_UnityEngine_Animation_GetStateAtIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917185 | 0, fb + 958 | 0);
 return;
}

function __Z46Register_UnityEngine_AnimationState_set_weightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917734 | 0, fb + 660 | 0);
 return;
}

function __Z46Register_UnityEngine_AnimationState_get_weightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917695 | 0, fb + 752 | 0);
 return;
}

function __Z46Register_UnityEngine_AnimationState_get_lengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918195 | 0, fb + 757 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_SetStringFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593555 | 0, fb + 699 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_SetObjectFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593594 | 0, fb + 700 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_GetStringFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593161 | 0, fb + 781 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_ExceptionClearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591748 | 0, fb + 184 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_CallVoidMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593122 | 0, fb + 697 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_CallLongMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593083 | 0, fb + 383 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_CallCharMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592963 | 0, fb + 382 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_CallByteMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592924 | 0, fb + 381 | 0);
 return;
}

function __Z46Register_UnityEngine_AI_NavMesh_RestoreNavMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850652 | 0, fb + 271 | 0);
 return;
}

function __Z46Register_UnityEngine_AI_NavMeshAgent_set_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849098 | 0, fb + 587 | 0);
 return;
}

function __Z46Register_UnityEngine_AI_NavMeshAgent_get_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 849059 | 0, fb + 677 | 0);
 return;
}

function __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_ToBooleanArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z45Register_UnityEngine_WWW_LoadImageIntoTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581024 | 0, fb + 3160 | 0);
 return;
}

function __Z45Register_UnityEngine_Transform_set_hasChangedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579154 | 0, fb + 3153 | 0);
 return;
}

function __Z45Register_UnityEngine_Transform_get_hasChangedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579116 | 0, fb + 1929 | 0);
 return;
}

function __Z45Register_UnityEngine_Transform_get_childCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578773 | 0, fb + 1927 | 0);
 return;
}

function __Z45Register_UnityEngine_Transform_DetachChildrenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578811 | 0, fb + 3658 | 0);
 return;
}

function __Z45Register_UnityEngine_Texture2DArray_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573498 | 0, fb + 1901 | 0);
 return;
}

function __Z45Register_UnityEngine_TextMesh_set_lineSpacingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009887 | 0, fb + 688 | 0);
 return;
}

function __Z45Register_UnityEngine_TextMesh_get_lineSpacingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009849 | 0, fb + 787 | 0);
 return;
}

function __Z45Register_UnityEngine_Terrain_set_materialTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943183 | 0, fb + 4188 | 0);
 return;
}

function __Z45Register_UnityEngine_Terrain_get_materialTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943145 | 0, fb + 2613 | 0);
 return;
}

function __Z45Register_UnityEngine_Sprite_Internal_GetPivotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569238 | 0, fb + 3098 | 0);
 return;
}

function __Z45Register_UnityEngine_Sprite_INTERNAL_get_rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568876 | 0, fb + 3095 | 0);
 return;
}

function __Z45Register_UnityEngine_SpriteRenderer_set_flipYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569749 | 0, fb + 3104 | 0);
 return;
}

function __Z45Register_UnityEngine_SpriteRenderer_set_flipXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569673 | 0, fb + 3103 | 0);
 return;
}

function __Z45Register_UnityEngine_SpriteRenderer_get_flipYv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569711 | 0, fb + 1883 | 0);
 return;
}

function __Z45Register_UnityEngine_SpriteRenderer_get_flipXv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569635 | 0, fb + 1882 | 0);
 return;
}

function __Z45Register_UnityEngine_RuntimeUndo_RecordObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560807 | 0, fb + 3055 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody_set_useGravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 785024 | 0, fb + 3683 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody_get_useGravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784986 | 0, fb + 2278 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody2D_set_bodyTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814412 | 0, fb + 3846 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody2D_get_bodyTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814374 | 0, fb + 2325 | 0);
 return;
}

function __Z45Register_UnityEngine_Renderer_set_probeAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526905 | 0, fb + 2895 | 0);
 return;
}

function __Z45Register_UnityEngine_Renderer_set_castShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525565 | 0, fb + 2878 | 0);
 return;
}

function __Z45Register_UnityEngine_Renderer_get_probeAnchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526867 | 0, fb + 1706 | 0);
 return;
}

function __Z45Register_UnityEngine_Renderer_get_castShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525527 | 0, fb + 1693 | 0);
 return;
}

function __Z45Register_UnityEngine_RenderTexture_set_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 575006 | 0, fb + 3125 | 0);
 return;
}

function __Z45Register_UnityEngine_RenderTexture_set_activev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576355 | 0, fb + 3655 | 0);
 return;
}

function __Z45Register_UnityEngine_RenderTexture_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574968 | 0, fb + 1913 | 0);
 return;
}

function __Z45Register_UnityEngine_ReflectionProbe_set_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555894 | 0, fb + 3032 | 0);
 return;
}

function __Z45Register_UnityEngine_ReflectionProbe_set_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557223 | 0, fb + 3045 | 0);
 return;
}

function __Z45Register_UnityEngine_ReflectionProbe_get_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555856 | 0, fb + 1818 | 0);
 return;
}

function __Z45Register_UnityEngine_ReflectionProbe_get_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 557185 | 0, fb + 1824 | 0);
 return;
}

function __Z45Register_UnityEngine_ParticleEmitter_Simulatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051582 | 0, fb + 708 | 0);
 return;
}

function __Z45Register_UnityEngine_OcclusionPortal_set_openv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518482 | 0, fb + 2857 | 0);
 return;
}

function __Z45Register_UnityEngine_OcclusionPortal_get_openv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518444 | 0, fb + 1678 | 0);
 return;
}

function __Z45Register_UnityEngine_Object_FindObjectsOfTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579892 | 0, fb + 1934 | 0);
 return;
}

function __Z45Register_UnityEngine_Object_DontDestroyOnLoadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579988 | 0, fb + 3662 | 0);
 return;
}

function __Z45Register_UnityEngine_Motion_get_isHumanMotionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550079 | 0, fb + 1800 | 0);
 return;
}

function __Z45Register_UnityEngine_Mesh_get_blendShapeCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548107 | 0, fb + 1790 | 0);
 return;
}

function __Z45Register_UnityEngine_Mesh_INTERNAL_set_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548574 | 0, fb + 3002 | 0);
 return;
}

function __Z45Register_UnityEngine_Mesh_INTERNAL_get_boundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548536 | 0, fb + 3001 | 0);
 return;
}

function __Z45Register_UnityEngine_Matrix4x4_get_isIdentityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545474 | 0, fb + 1779 | 0);
 return;
}

function __Z45Register_UnityEngine_Material_set_renderQueuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566641 | 0, fb + 3084 | 0);
 return;
}

function __Z45Register_UnityEngine_Material_get_renderQueuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566603 | 0, fb + 1862 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541070 | 0, fb + 2962 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541032 | 0, fb + 2961 | 0);
 return;
}

function __Z45Register_UnityEngine_Input_GetMouseButtonDownv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538324 | 0, fb + 1750 | 0);
 return;
}

function __Z45Register_UnityEngine_HumanTrait_GetParentBonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929857 | 0, fb + 2587 | 0);
 return;
}

function __Z45Register_UnityEngine_HumanPoseHandler_Disposev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 930245 | 0, fb + 3821 | 0);
 return;
}

function __Z45Register_UnityEngine_HingeJoint_set_useSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789055 | 0, fb + 3726 | 0);
 return;
}

function __Z45Register_UnityEngine_HingeJoint_set_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788979 | 0, fb + 3725 | 0);
 return;
}

function __Z45Register_UnityEngine_HingeJoint_get_useSpringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789017 | 0, fb + 2295 | 0);
 return;
}

function __Z45Register_UnityEngine_HingeJoint_get_useLimitsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788941 | 0, fb + 2294 | 0);
 return;
}

function __Z45Register_UnityEngine_GameObject_get_transformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515199 | 0, fb + 1664 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIUtility_get_mouseUsedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025400 | 0, fb + 287 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIStyle_set_fixedHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023078 | 0, fb + 698 | 0);
 return;
}

function __Z45Register_UnityEngine_GUIStyle_get_fixedHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023040 | 0, fb + 797 | 0);
 return;
}

function __Z45Register_UnityEngine_CullingGroup_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510588 | 0, fb + 2815 | 0);
 return;
}

function __Z45Register_UnityEngine_CullingGroup_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510550 | 0, fb + 1652 | 0);
 return;
}

function __Z45Register_UnityEngine_CrashReport_RemoveReportv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510186 | 0, fb + 1651 | 0);
 return;
}

function __Z45Register_UnityEngine_ComputeBuffer_get_stridev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509847 | 0, fb + 1650 | 0);
 return;
}

function __Z45Register_UnityEngine_Component_get_gameObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508794 | 0, fb + 1648 | 0);
 return;
}

function __Z45Register_UnityEngine_Collider2D_set_isTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816307 | 0, fb + 3856 | 0);
 return;
}

function __Z45Register_UnityEngine_Collider2D_get_isTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816269 | 0, fb + 2336 | 0);
 return;
}

function __Z45Register_UnityEngine_Canvas_set_planeDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015490 | 0, fb + 694 | 0);
 return;
}

function __Z45Register_UnityEngine_Canvas_get_planeDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015452 | 0, fb + 793 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_set_targetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504481 | 0, fb + 2789 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_set_targetDisplayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506640 | 0, fb + 2803 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_set_renderingPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503380 | 0, fb + 2776 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_get_targetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504443 | 0, fb + 1627 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_get_targetDisplayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 506602 | 0, fb + 1639 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_get_stereoEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505530 | 0, fb + 1632 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_get_renderingPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503342 | 0, fb + 1618 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_RenderDontRestorev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507677 | 0, fb + 3482 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_INTERNAL_set_rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504319 | 0, fb + 2786 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_INTERNAL_get_rectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504281 | 0, fb + 2785 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioSource_set_priorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888677 | 0, fb + 4063 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioSource_get_priorityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888639 | 0, fb + 2504 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioReverbZone_set_roomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889763 | 0, fb + 4067 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioReverbZone_get_roomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 889725 | 0, fb + 2508 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_set_logWarningsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924552 | 0, fb + 4145 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_set_cullingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922634 | 0, fb + 4136 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_get_logWarningsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924514 | 0, fb + 2573 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_get_cullingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922596 | 0, fb + 2565 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationState_set_layerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918272 | 0, fb + 4110 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationState_get_layerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918234 | 0, fb + 2544 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationCurve_RemoveKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546404 | 0, fb + 2992 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationClip_set_legacyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916034 | 0, fb + 4092 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationClip_get_legacyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915996 | 0, fb + 2530 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_FromLongArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595999 | 0, fb + 1962 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_FromCharArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595885 | 0, fb + 1959 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_FromByteArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595847 | 0, fb + 1958 | 0);
 return;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_PopLocalFrame13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_GetSuperclass13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44Register_UnityEngine_GUI_Internal_SetTooltipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020665 | 0, fb + 3888 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIUtility_GetControlIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024511 | 0, fb + 1113 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIStyle_SetDefaultFontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024025 | 0, fb + 3901 | 0);
 return;
}

function __Z44Register_UnityEngine_Event_GetTypeForControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019359 | 0, fb + 1112 | 0);
 return;
}

function __Z44Register_UnityEngine_Canvas_set_sortingOrderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015681 | 0, fb + 4259 | 0);
 return;
}

function __Z44Register_UnityEngine_Canvas_set_pixelPerfectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015415 | 0, fb + 4257 | 0);
 return;
}

function __Z44Register_UnityEngine_Canvas_get_sortingOrderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015644 | 0, fb + 2698 | 0);
 return;
}

function __Z44Register_UnityEngine_Canvas_get_pixelPerfectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015378 | 0, fb + 2695 | 0);
 return;
}

function __Z44Register_UnityEngine_Canvas_get_isRootCanvasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014970 | 0, fb + 2692 | 0);
 return;
}

function __Z44Register_UnityEngine_CanvasRenderer_set_cullv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014570 | 0, fb + 4252 | 0);
 return;
}

function __Z44Register_UnityEngine_CanvasRenderer_get_cullv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014533 | 0, fb + 2688 | 0);
 return;
}

function __Z43scripting_liveness_calculation_from_staticsPv(i1) {
 i1 = i1 | 0;
 _il2cpp_unity_liveness_calculation_from_statics(i1 | 0);
 return;
}

function __Z39getPxHeightFieldDescConvexEdgeThresholdPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z38Profiler_CUSTOM_GetTotalReservedMemoryv() {
 return __ZN13MemoryManager22GetTotalReservedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
}

function __Z36getPxVehicleEngineData_RecipMaxOmegaPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 108 >> 2]);
}

function __Z35getPxHeightFieldGeometryColumnScalePKN5physx21PxHeightFieldGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z34setPxSceneDescFilterShaderDataSizePN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 28 >> 2] = i1;
 return;
}

function __Z34AndroidJNI_CUSTOM_CallStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z33setPxSceneLimitsMaxNbStaticShapesPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z33setPxSceneDescNbContactDataBlocksPN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 136 >> 2] = i1;
 return;
}

function __Z32setPxSceneLimitsMaxNbConstraintsPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 return;
}

function __Z29setPxHeightFieldDescNbColumnsPN5physx17PxHeightFieldDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z28scripting_method_is_instance21ScriptingMethodIl2Cpp(i1) {
 i1 = i1 | 0;
 return _il2cpp_method_is_instance(HEAP32[i1 >> 2] | 0) | 0;
}

function __Z16getPxShape_FlagsPKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
}

function __Z16getPxJoint_ScenePKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 116 >> 2] | 0, i1 | 0) | 0;
}

function __Z14RunNativeTestsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z12stbAllocImpljPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[i2 >> 2] | 0, i1 | 0, HEAP32[i2 + 8 >> 2] | 0) | 0;
}

function __Z10bucketFreeP11BucketAllocPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 >> 2];
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z10CanDestroy9HPlayable(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[(HEAP32[i1 >> 2] | 0) + 20 >> 2] | 0) + 48 >> 2] & 4 | 0) == 0 | 0;
}

function _UNITY_png_set_swap_alpha(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = i1 + 212 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 131072;
 return;
}

function b29(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 nullFunc_iifff(29);
 return 0;
}

function b28(i1, i2, i3, i4, i5, i6) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 i6 = i6 | 0;
 nullFunc_viiiiii(28);
}

function b100(f1, f2, f3, f4) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 nullFunc_vffff(100);
}

function _wcspbrk(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + ((_wcscspn(i1, i2) | 0) << 2) | 0;
 return (HEAP32[i2 >> 2] | 0 ? i2 : 0) | 0;
}

function _glUniformBlockBinding__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniformBlockBinding(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glBlendEquationSeparate__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBlendEquationSeparate(i1 | 0, i2 | 0);
}

function __ZThn8_N5physx2Gu10ConvexMesh14onRefCountZeroEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu10ConvexMesh14onRefCountZeroEv(i1 + -8 | 0);
 return;
}

function __ZThn32_N13TrailRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 __ZN13TrailRenderer19UpdateTransformInfoEv(i1 + -32 | 0);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5clearEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base5clearEj(i1, i2);
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5clearEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZNSt3__28ios_base5clearEj(i1, i2);
 return;
}

function __ZNSt3__214codecvt_bynameIwc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNK7ApiGLES9IsEnabledEN2gl10EnabledCapE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 1592 >> 2] & 1 << i2 | 0) != 0 | 0;
}

function __ZNK5physx3Ext14SphericalJoint22getSphericalJointFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i1 + 80 >> 2] | 0) + 116 >> 1] | 0;
}

function __ZNK5physx3Ext14PrismaticJoint22getPrismaticJointFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i1 + 80 >> 2] | 0) + 108 >> 1] | 0;
}

function __ZNK5physx3Ext13DistanceJoint14getMinDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 72 >> 2]);
}

function __ZNK5physx3Ext13DistanceJoint14getMaxDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 76 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx13NpClothFabric12getNbTethersEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore12getNbTethersEv(i1 + 16 | 0) | 0;
}

function __ZNK5Umbra13TomeUserIdMap9getUserIdEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK5Umbra10Visibility24getOutputObjectDistancesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 20 >> 2] | 0;
}

function __ZNK19RenderEventsContext17GetCommandBuffersEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 >> 2] | 0) + (i2 * 20 | 0) | 0;
}

function __ZNK14DataBufferGLES14GetRecreateAgeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[HEAP32[i1 >> 2] >> 2] | 0) - (HEAP32[i1 + 24 >> 2] | 0) | 0;
}

function __ZNK13TranslateGLES9GetFormatE17DepthBufferFormat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 2264 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES16StencilOperationE9StencilOp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75132 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES10ObjectTypeEN2gl10ObjectTypeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 2336 + (i2 << 2) >> 2] | 0;
}

function __ZNK12CullingGroup9IsVisibleEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[(HEAP32[i1 + 48 >> 2] | 0) + i2 >> 0] | 0) < 0 | 0;
}

function __ZN9GfxDevice16DrawNullGeometryE16GfxPrimitiveTypeii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN5physx9PxTaskMgr16setSpuDispatcherERNS_15PxSpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN5physx9NpFactory21registerArticulationsEv() {
 HEAP32[gb + 1457340 >> 2] = fb + 228;
 HEAP32[gb + 1457328 >> 2] = fb + 407;
 return;
}

function __ZN5physx5cloth11SwCollisionI8Scalar4fE13CollisionDataC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 80 >> 2] = f1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 108 >> 2] = f1;
 return;
}

function __ZN5physx2Sc16ArticulationCore26setMaxProjectionIterationsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN5physx2Sc14ConstraintCore15getPxConstraintEv(i1) {
 i1 = i1 | 0;
 return __Z17NpGetPxConstraintRN5physx2Sc14ConstraintCoreE(i1) | 0;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx28PxTriangleMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN5Umbra6DoublepLERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i2 >> 3] + +HEAPF64[i1 >> 3];
 return i1 | 0;
}

function __ZN5Umbra6DoublemLERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i2 >> 3] * +HEAPF64[i1 >> 3];
 return i1 | 0;
}

function __ZN5Umbra6DoublemIERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] - +HEAPF64[i2 >> 3];
 return i1 | 0;
}

function __ZN5Umbra6DoubledVERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +HEAPF64[i1 >> 3] / +HEAPF64[i2 >> 3];
 return i1 | 0;
}

function __ZN33AssetBundleLoadFromAsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN33AssetBundleLoadFromAsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN26AnimatorControllerPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 48 >> 2] | 0;
}

function __ZN22CreateGpuProgramOutputC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN18ScriptingArguments13IncreaseCountEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 192 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN17FileSystemHandler8SetFlagsER13FileEntryDatajj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN17CircleCast2DQuery19InitializeCastShapeEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 380 >> 2] = HEAP32[i1 + 392 >> 2];
 return i1 + 372 | 0;
}

function __ZN17ArchiveFileSystem9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem8SetFlagsER13FileEntryDatajj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN15CacheWriterBase23WriteHeaderAndCloseFileEPvjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN14ParticleSystem13DidDeleteMeshEv(i1) {
 i1 = i1 | 0;
 __ZN11ShapeModule13DidDeleteMeshEP14ParticleSystem(i1 + 48 | 0, i1);
 return;
}

function __ZN13ScreenManager20SetScreenOrientationE17ScreenOrientation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 36 >> 2] = i2;
 return;
}

function __ZN13PhysicsModule20IsRigidBodyKinematicERK9Rigidbody(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[i2 + 84 >> 0] | 0) != 0 | 0;
}

function __ZN13OcclusionAreaD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN13GfxDeviceNull16BeginBufferWriteEP9GfxBufferjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN13AnimationClip36ClipWasModifiedAndUpdateClipSettingsEv(i1) {
 i1 = i1 | 0;
 __ZN13AnimationClip15ClipWasModifiedEb(i1, 1);
 return;
}

function __ZN12ImageDecoder8SetErrorEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 1;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN11UnityEngine15PlatformWrapper16GetVideoMemoryMBEv() {
 return ~~Math_fround(HEAPF32[(__Z15GetGraphicsCapsv() | 0) + 100 >> 2]) | 0;
}

function __ZN11UnityEngine15CloudWebService16SessionContainer18GetIndexFromDataIdEy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 & 65535 | 0;
}

function __ZN11IMGUIModule25GetGUIStyleScriptingClassEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z24GetIMGUIScriptingClassesv() | 0) + 20 >> 2] | 0;
}

function __ZN10HumanTrait15InitializeClassEv() {
 __ZN10HumanTrait20InitializeMuscleNameEv();
 __ZN10HumanTrait18InitializeBoneNameEv();
 return;
}

function __Z56ReflectionProbe_Get_Custom_PropMinBakedCubemapResolutionv() {
 return __ZN16ReflectionProbes28GetMinBakedCubemapResolutionEv() | 0;
}

function __Z56ReflectionProbe_Get_Custom_PropMaxBakedCubemapResolutionv() {
 return __ZN16ReflectionProbes28GetMaxBakedCubemapResolutionEv() | 0;
}

function __Z48Screen_Get_Custom_PropAutorotateToLandscapeRightv() {
 return (HEAP32[(__Z16GetScreenManagerv() | 0) + 32 >> 2] | 0) >>> 3 & 1 | 0;
}

function __Z46Register_UnityEngine_Time_set_maximumDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576834 | 0, fb + 17 | 0);
 return;
}

function __Z46Register_UnityEngine_Time_get_maximumDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576795 | 0, fb + 25 | 0);
 return;
}

function __Z46Register_UnityEngine_Texture2D_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571906 | 0, fb + 27 | 0);
 return;
}

function __Z46Register_UnityEngine_SystemInfo_get_deviceTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499920 | 0, fb + 82 | 0);
 return;
}

function __Z46Register_UnityEngine_SystemInfo_get_deviceNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 499605 | 0, fb + 75 | 0);
 return;
}

function __Z46Register_UnityEngine_Physics_set_sleepVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782610 | 0, fb + 24 | 0);
 return;
}

function __Z46Register_UnityEngine_Physics_get_sleepVelocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 782571 | 0, fb + 33 | 0);
 return;
}

function __Z46Register_UnityEngine_Physics2D_set_timeToSleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809949 | 0, fb + 37 | 0);
 return;
}

function __Z46Register_UnityEngine_Physics2D_get_timeToSleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 809910 | 0, fb + 46 | 0);
 return;
}

function __Z46Register_UnityEngine_Caching_get_spaceOccupiedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502335 | 0, fb + 89 | 0);
 return;
}

function __Z46Register_UnityEngine_Application_get_isTestRunv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493831 | 0, fb + 12 | 0);
 return;
}

function __Z45Register_UnityEngine_WheelCollider_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836224 | 0, fb + 567 | 0);
 return;
}

function __Z45Register_UnityEngine_WheelCollider_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836186 | 0, fb + 654 | 0);
 return;
}

function __Z45Register_UnityEngine_WWW_GetAudioClipInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580986 | 0, fb + 135 | 0);
 return;
}

function __Z45Register_UnityEngine_Texture2D_SetAllPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572283 | 0, fb + 671 | 0);
 return;
}

function __Z45Register_UnityEngine_Texture2DArray_SetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573653 | 0, fb + 245 | 0);
 return;
}

function __Z45Register_UnityEngine_Texture2DArray_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573731 | 0, fb + 371 | 0);
 return;
}

function __Z45Register_UnityEngine_Terrain_set_treeDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941755 | 0, fb + 675 | 0);
 return;
}

function __Z45Register_UnityEngine_Terrain_get_treeDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941717 | 0, fb + 774 | 0);
 return;
}

function __Z45Register_UnityEngine_TerrainData_GetAlphamapsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 940803 | 0, fb + 165 | 0);
 return;
}

function __Z45Register_UnityEngine_Sprite_get_pixelsPerUnitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568914 | 0, fb + 258 | 0);
 return;
}

function __Z45Register_UnityEngine_SparseTexture_UpdateTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574278 | 0, fb + 139 | 0);
 return;
}

function __Z45Register_UnityEngine_SparseTexture_UnloadTilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574357 | 0, fb + 247 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody2D_set_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813344 | 0, fb + 457 | 0);
 return;
}

function __Z45Register_UnityEngine_Rigidbody2D_get_rotationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813306 | 0, fb + 526 | 0);
 return;
}

function __Z45Register_UnityEngine_RenderTexture_get_activev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576317 | 0, fb + 215 | 0);
 return;
}

function __Z45Register_UnityEngine_PointEffector2D_set_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825106 | 0, fb + 503 | 0);
 return;
}

function __Z45Register_UnityEngine_PointEffector2D_get_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 825068 | 0, fb + 582 | 0);
 return;
}

function __Z45Register_UnityEngine_Motion_get_apparentSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549976 | 0, fb + 251 | 0);
 return;
}

function __Z45Register_UnityEngine_MonoBehaviour_IsInvokingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549431 | 0, fb + 658 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_set_shadowStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541352 | 0, fb + 186 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_set_shadowSoftnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541826 | 0, fb + 190 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_get_shadowStrengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541314 | 0, fb + 237 | 0);
 return;
}

function __Z45Register_UnityEngine_Light_get_shadowSoftnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541788 | 0, fb + 241 | 0);
 return;
}

function __Z45Register_UnityEngine_LensFlare_set_brightnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524835 | 0, fb + 167 | 0);
 return;
}

function __Z45Register_UnityEngine_LensFlare_get_brightnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524797 | 0, fb + 213 | 0);
 return;
}

function __Z45Register_UnityEngine_Input_get_touchSupportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539171 | 0, fb + 177 | 0);
 return;
}

function __Z45Register_UnityEngine_HumanTrait_get_BoneCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929497 | 0, fb + 254 | 0);
 return;
}

function __Z45Register_UnityEngine_Display_GetSystemExtImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512387 | 0, fb + 584 | 0);
 return;
}

function __Z45Register_UnityEngine_CullingGroup_GetDistancev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510921 | 0, fb + 630 | 0);
 return;
}

function __Z45Register_UnityEngine_CubemapArray_SetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573999 | 0, fb + 138 | 0);
 return;
}

function __Z45Register_UnityEngine_CubemapArray_GetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574073 | 0, fb + 155 | 0);
 return;
}

function __Z45Register_UnityEngine_ComputeShader_SetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509519 | 0, fb + 227 | 0);
 return;
}

function __Z45Register_UnityEngine_ComputeShader_FindKernelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509180 | 0, fb + 626 | 0);
 return;
}

function __Z45Register_UnityEngine_ComputeBuffer_InitBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509731 | 0, fb + 231 | 0);
 return;
}

function __Z45Register_UnityEngine_Cloth_set_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840099 | 0, fb + 575 | 0);
 return;
}

function __Z45Register_UnityEngine_Cloth_get_sleepThresholdv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840061 | 0, fb + 664 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_set_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503230 | 0, fb + 158 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_get_nearClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503192 | 0, fb + 206 | 0);
 return;
}

function __Z45Register_UnityEngine_Camera_GetCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508431 | 0, fb + 622 | 0);
 return;
}

function __Z45Register_UnityEngine_BillboardAsset_set_widthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500581 | 0, fb + 154 | 0);
 return;
}

function __Z45Register_UnityEngine_BillboardAsset_get_widthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500543 | 0, fb + 202 | 0);
 return;
}

function __Z45Register_UnityEngine_AssetBundle_LoadFromFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496288 | 0, fb + 144 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_get_pivotWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921890 | 0, fb + 761 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_IsBoneTransformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922482 | 0, fb + 969 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationState_set_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918061 | 0, fb + 663 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationState_get_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918023 | 0, fb + 755 | 0);
 return;
}

function __Z45Register_UnityEngine_AnimationClip_get_lengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915454 | 0, fb + 748 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_SetShortFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593747 | 0, fb + 704 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_GetShortFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593367 | 0, fb + 785 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_CallIntMethodv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592804 | 0, fb + 378 | 0);
 return;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToDoubleArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44Register_UnityEngine_WWW_get_bytesDownloadedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581156 | 0, fb + 1947 | 0);
 return;
}

function __Z44Register_UnityEngine_Transform_GetChildCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579329 | 0, fb + 1930 | 0);
 return;
}

function __Z44Register_UnityEngine_Terrain_set_terrainDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941680 | 0, fb + 4176 | 0);
 return;
}

function __Z44Register_UnityEngine_Terrain_set_castShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942960 | 0, fb + 4185 | 0);
 return;
}

function __Z44Register_UnityEngine_Terrain_get_terrainDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941643 | 0, fb + 2606 | 0);
 return;
}

function __Z44Register_UnityEngine_Terrain_get_castShadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 942923 | 0, fb + 2611 | 0);
 return;
}

function __Z44Register_UnityEngine_Shader_SetGlobalTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564135 | 0, fb + 3069 | 0);
 return;
}

function __Z44Register_UnityEngine_Shader_IsKeywordEnabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563735 | 0, fb + 1850 | 0);
 return;
}

function __Z44Register_UnityEngine_Shader_GetGlobalTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564705 | 0, fb + 1855 | 0);
 return;
}

function __Z44Register_UnityEngine_Screen_set_sleepTimeoutv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535068 | 0, fb + 3573 | 0);
 return;
}

function __Z44Register_UnityEngine_RenderTexture_set_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574807 | 0, fb + 3123 | 0);
 return;
}

function __Z44Register_UnityEngine_RenderTexture_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574770 | 0, fb + 1910 | 0);
 return;
}

function __Z44Register_UnityEngine_ReflectionProbe_set_hdrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555969 | 0, fb + 3033 | 0);
 return;
}

function __Z44Register_UnityEngine_ReflectionProbe_get_hdrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 555932 | 0, fb + 1819 | 0);
 return;
}

function __Z44Register_UnityEngine_RectOffset_get_verticalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514083 | 0, fb + 1660 | 0);
 return;
}

function __Z44Register_UnityEngine_ParticleSystem_set_loopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651722 | 0, fb + 3433 | 0);
 return;
}

function __Z44Register_UnityEngine_ParticleSystem_get_loopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651685 | 0, fb + 2066 | 0);
 return;
}

function __Z44Register_UnityEngine_Object_DestroyImmediatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579855 | 0, fb + 3155 | 0);
 return;
}

function __Z44Register_UnityEngine_Mesh_RecalculateNormalsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548648 | 0, fb + 3611 | 0);
 return;
}

function __Z44Register_UnityEngine_MeshCollider_set_convexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795461 | 0, fb + 3810 | 0);
 return;
}

function __Z44Register_UnityEngine_MeshCollider_get_convexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 795424 | 0, fb + 2313 | 0);
 return;
}

function __Z44Register_UnityEngine_Mathf_ClosestPowerOfTwov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545916 | 0, fb + 1780 | 0);
 return;
}

function __Z44Register_UnityEngine_Material_DisableKeywordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566910 | 0, fb + 3090 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint_set_connectedBodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787823 | 0, fb + 3706 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint_get_connectedBodyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787786 | 0, fb + 2289 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint_INTERNAL_set_axisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787897 | 0, fb + 3708 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint_INTERNAL_get_axisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 787860 | 0, fb + 3707 | 0);
 return;
}

function __Z44Register_UnityEngine_HumanTrait_RequiredBonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929650 | 0, fb + 2586 | 0);
 return;
}

function __Z44Register_UnityEngine_HingeJoint_set_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788904 | 0, fb + 3724 | 0);
 return;
}

function __Z44Register_UnityEngine_HingeJoint_get_useMotorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788867 | 0, fb + 2293 | 0);
 return;
}

function __Z44Register_UnityEngine_Graphics_set_activeTierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533351 | 0, fb + 3560 | 0);
 return;
}

function __Z44Register_UnityEngine_GameObject_set_isStaticv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515576 | 0, fb + 2842 | 0);
 return;
}

function __Z44Register_UnityEngine_GameObject_get_isStaticv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515539 | 0, fb + 1669 | 0);
 return;
}

function __Z44Register_UnityEngine_GUI_Internal_GetTooltipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020628 | 0, fb + 274 | 0);
 return;
}

function __Z44Register_UnityEngine_GUI_Internal_EndWindowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021516 | 0, fb + 372 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIText_set_lineSpacingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008908 | 0, fb + 684 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIText_get_lineSpacingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008871 | 0, fb + 783 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIStyle_set_fixedWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023003 | 0, fb + 697 | 0);
 return;
}

function __Z44Register_UnityEngine_GUIStyle_get_fixedWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022966 | 0, fb + 796 | 0);
 return;
}

function __Z44Register_UnityEngine_GL_INTERNAL_CALL_Vertexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535129 | 0, fb + 3574 | 0);
 return;
}

function __Z44Register_UnityEngine_Cubemap_get_mipmapCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573061 | 0, fb + 1897 | 0);
 return;
}

function __Z44Register_UnityEngine_CubemapArray_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573852 | 0, fb + 1904 | 0);
 return;
}

function __Z44Register_UnityEngine_ComputeBuffer_get_countv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509810 | 0, fb + 1649 | 0);
 return;
}

function __Z44Register_UnityEngine_Component_get_transformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508757 | 0, fb + 1647 | 0);
 return;
}

function __Z44Register_UnityEngine_Cloth_set_selfCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840678 | 0, fb + 3992 | 0);
 return;
}

function __Z44Register_UnityEngine_Cloth_get_selfCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840641 | 0, fb + 2432 | 0);
 return;
}

function __Z44Register_UnityEngine_CanvasRenderer_SetAlphav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013435 | 0, fb + 691 | 0);
 return;
}

function __Z44Register_UnityEngine_CanvasRenderer_GetAlphav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1013398 | 0, fb + 790 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_set_orthographicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503672 | 0, fb + 2778 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_get_orthographicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503635 | 0, fb + 1622 | 0);
 return;
}

function __Z44Register_UnityEngine_Caching_DeleteFromCachev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501992 | 0, fb + 1616 | 0);
 return;
}

function __Z44Register_UnityEngine_Caching_CleanNamedCachev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501955 | 0, fb + 1615 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioListener_set_pausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886117 | 0, fb + 3790 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioClip_get_loadStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885782 | 0, fb + 2486 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioClip_get_frequencyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885548 | 0, fb + 2480 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioClip_LoadAudioDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885662 | 0, fb + 2483 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_set_updateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919635 | 0, fb + 4124 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_set_fireEventsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924627 | 0, fb + 4146 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_updateModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 919598 | 0, fb + 2556 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_parametersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921728 | 0, fb + 2561 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_layerCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921114 | 0, fb + 2560 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_fireEventsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924590 | 0, fb + 2574 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_avatarRootv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922520 | 0, fb + 2564 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_StartRecordingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922821 | 0, fb + 4137 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_ResetTriggerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923959 | 0, fb + 4143 | 0);
 return;
}

function __Z44Register_UnityEngine_Animation_get_isPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916693 | 0, fb + 2536 | 0);
 return;
}

function __Z44Register_UnityEngine_Animation_GetStateCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917224 | 0, fb + 2538 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationState_set_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918481 | 0, fb + 4112 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationState_get_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918444 | 0, fb + 2546 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationState_get_clipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918310 | 0, fb + 2545 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_FromIntArrayv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 595962 | 0, fb + 1961 | 0);
 return;
}

function __Z44Register_UnityEngine_AI_OffMeshLink_set_areav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852859 | 0, fb + 4042 | 0);
 return;
}

function __Z44Register_UnityEngine_AI_OffMeshLink_get_areav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852822 | 0, fb + 2468 | 0);
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewGlobalRef13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43Register_UnityEngine_TextMesh_set_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009527 | 0, fb + 4223 | 0);
 return;
}

function __Z43Register_UnityEngine_TextMesh_set_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009667 | 0, fb + 4224 | 0);
 return;
}

function __Z43Register_UnityEngine_TextMesh_get_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009491 | 0, fb + 2661 | 0);
 return;
}

function __Z43Register_UnityEngine_TextMesh_get_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009631 | 0, fb + 2662 | 0);
 return;
}

function __Z43Register_UnityEngine_RemoteSettings_GetBoolv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1042758 | 0, fb + 1129 | 0);
 return;
}

function __Z43Register_UnityEngine_GUI_SetNextControlNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020988 | 0, fb + 3890 | 0);
 return;
}

function __Z43Register_UnityEngine_GUI_INTERNAL_set_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020298 | 0, fb + 3881 | 0);
 return;
}

function __Z43Register_UnityEngine_GUI_INTERNAL_get_colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020262 | 0, fb + 3880 | 0);
 return;
}

function __Z43Register_UnityEngine_GUI_BringWindowToFrontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021346 | 0, fb + 3893 | 0);
 return;
}

function __Z43Register_UnityEngine_GUIStyle_set_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023558 | 0, fb + 4299 | 0);
 return;
}

function __Z43Register_UnityEngine_GUIStyle_set_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022582 | 0, fb + 4288 | 0);
 return;
}

function __Z43Register_UnityEngine_GUIStyle_get_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023522 | 0, fb + 2730 | 0);
 return;
}

function __Z43Register_UnityEngine_GUIStyle_get_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022546 | 0, fb + 2722 | 0);
 return;
}

function __Z43Register_UnityEngine_GUIStyle_Internal_Drawv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023664 | 0, fb + 4301 | 0);
 return;
}

function __Z43Register_UnityEngine_Font_set_characterInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010463 | 0, fb + 4232 | 0);
 return;
}

function __Z43Register_UnityEngine_Font_get_characterInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010427 | 0, fb + 2667 | 0);
 return;
}

function __Z43Register_UnityEngine_Event_set_displayIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020133 | 0, fb + 4279 | 0);
 return;
}

function __Z43Register_UnityEngine_Event_get_displayIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020097 | 0, fb + 2716 | 0);
 return;
}

function __Z43Register_UnityEngine_Canvas_set_worldCamerav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015043 | 0, fb + 4254 | 0);
 return;
}

function __Z43Register_UnityEngine_Canvas_get_worldCamerav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015007 | 0, fb + 2693 | 0);
 return;
}

function __Z43Register_UnityEngine_Canvas_get_renderOrderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015528 | 0, fb + 2696 | 0);
 return;
}

function __Z43Register_UnityEngine_CanvasRenderer_SetMeshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014246 | 0, fb + 4250 | 0);
 return;
}

function __Z38VerifyNothingIsPersistentInLoadedSceneRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return;
}

function __Z35getPxHeightFieldGeometryHeightScalePKN5physx21PxHeightFieldGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z35getPxClothStretchConfigStretchLimitPKN5physx20PxClothStretchConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z34getPxJointLimitParametersStiffnessPKN5physx22PxJointLimitParametersE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z34AudioListener_Get_Custom_PropPausev() {
 return (__ZNK12AudioManager16GetListenerPauseEv(__Z15GetAudioManagerv() | 0) | 0) & 1 | 0;
}

function __Z33AndroidJNI_CUSTOM_CallShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z31setPxSceneLimitsMaxNbAggregatesPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 16 >> 2] = i1;
 return;
}

function __Z31Profiler_CUSTOM_GetMonoUsedSizev() {
 var i1 = 0;
 i1 = __Z26scripting_gc_get_used_sizev() | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __Z31Profiler_CUSTOM_GetMonoHeapSizev() {
 var i1 = 0;
 i1 = __Z26scripting_gc_get_heap_sizev() | 0;
 getTempRet0() | 0;
 return i1 | 0;
}

function __Z30AndroidJNI_CUSTOM_SetLongField13Il2Cpp_IntPtrS_x(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z28GUI_CUSTOM_BringWindowToBacki(i1) {
 i1 = i1 | 0;
 __ZN5IMGUI17BringWindowToBackER8GUIStatei(__Z11GetGUIStatev() | 0, i1);
 return;
}

function __Z27scripting_gc_collect_unsafei(i1) {
 i1 = i1 | 0;
 _il2cpp_gc_enable();
 _il2cpp_gc_collect(i1 | 0);
 _il2cpp_gc_disable();
 return;
}

function __Z26scripting_gc_get_used_sizev() {
 var i1 = 0;
 i1 = _il2cpp_gc_get_used_size() | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __Z26scripting_gc_get_heap_sizev() {
 var i1 = 0;
 i1 = _il2cpp_gc_get_heap_size() | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function __Z25scripting_array_class_getP11Il2CppClassj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_array_class_get(i1 | 0, i2 | 0) | 0;
}

function __Z20SetNoShadowsKeywordsR17ShaderPassContext(i1) {
 i1 = i1 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & -2017;
 return;
}

function __Z16getPxScene_FlagsPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 16 >> 2] | 0, i1 | 0) | 0;
}

function __Z16getPxActor_ScenePKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 28 >> 2] | 0, i1 | 0) | 0;
}

function __Z15getPxShape_NamePKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 148 >> 2] | 0, i1 | 0) | 0;
}

function __Z15getPxJoint_NamePKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 112 >> 2] | 0, i1 | 0) | 0;
}

function _FMOD_Memory_GetStats(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 >> 2] = 1e5;
 HEAP32[i2 >> 2] = 1e5;
 return 0;
}

function b80(i1, i2, f3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 nullFunc_viifif(80);
}

function _cf2_setError(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 if (HEAP32[i1 >> 2] | 0) return;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZNSt3__28ios_base6xallocEv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1473492 >> 2] | 0;
 HEAP32[gb + 1473492 >> 2] = i1 + 1;
 return i1 | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 12 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214__shared_count12__add_sharedEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNKSt3__25ctypeIwE9do_narrowEwc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i2 >>> 0 < 128 ? i2 & 255 : i3) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 284 >> 2]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 496 >> 2]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 312 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK25BlendshapePropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK16ReflectionProbes18GetPendingJobCountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 100 >> 2] | 0) + (HEAP32[i1 + 72 >> 2] | 0) | 0;
}

function __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75400 + (i2 << 2) >> 2] | 0;
}

function __ZN7mecanim9animation19ClearAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] & 4194304 | 0) != 0 | 0;
}

function __ZN6Object13ClassIDToRTTIEi(i1) {
 i1 = i1 | 0;
 return __ZN11TypeManager17ClassIDToTypeInfoEi(HEAP32[gb + 1110260 >> 2] | 0, i1) | 0;
}

function __ZN5physx9PxTaskMgr16setGpuDispatcherERNS_15PxGpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __ZN5physx9PxTaskMgr16setCpuDispatcherERNS_15PxCpuDispatcherE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd10Foundation24setReportAllocationNamesEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 40 >> 0] = i2 & 1;
 return;
}

function __ZN5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 92 >> 2] = i1;
 return;
}

function __ZN5physx2Sc8BodyCore24setCCDAdvanceCoefficientEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 76 >> 2] = f1;
 return;
}

function __ZN5physx2Sc21ArticulationJointCore10setDampingEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 92 >> 2] = f1;
 return;
}

function __ZN5physx2Sc18ParticleSystemCore12setStiffnessEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 100 >> 2] = f1;
 return;
}

function __ZN5physx2Sc16ArticulationCore26setInternalDriveIterationsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN5physx2Sc16ArticulationCore26setExternalDriveIterationsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = i2;
 return;
}

function __ZN5physx27PxHeightFieldRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx27PxClothFabricRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN5physx10PxsContext18createArticulationEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx19PxsSimObjectFactory18createArticulationEv(i1) | 0;
}

function __ZN5Umbra9IndexList7setSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 8 >> 2] = i2;
 return;
}

function __ZN5Umbra9FloatList7setSizeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 8 >> 2] = i2;
 return;
}

function __ZN31ThreadsafeLinearAllocatorHeader29CalculateNeededAllocationSizeEji(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + 11 + i2 | 0;
}

function __ZN17BillboardRenderer15OnBoundsChangedEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN15dtProximityGridD2Ev(i1) {
 i1 = i1 | 0;
 __Z6dtFreePv(HEAP32[i1 + 20 >> 2] | 0);
 __Z6dtFreePv(HEAP32[i1 + 8 >> 2] | 0);
 return;
}

function __ZN15SharedLightDataD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 33936 + 8;
 __ZN19RenderEventsContextD2Ev(i1 + 208 | 0);
 return;
}

function __ZN15ReflectionProbe19IsFinishedRenderingEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 148 >> 2] | 0) >= (i2 | 0) | 0;
}

function __ZN15PointEffector2D14SetForceTargetE19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 116 >> 2] = i2;
 return;
}

function __ZN15PointEffector2D14SetForceSourceE19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 112 >> 2] = i2;
 return;
}

function __ZN13AnimationClip35ClipWasModifiedAndUpdateMuscleRangeEv(i1) {
 i1 = i1 | 0;
 __ZN13AnimationClip15ClipWasModifiedEb(i1, 1);
 return;
}

function __ZN12_GLOBAL__N_112UserRenderer6addRefEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 36 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __Z49Physics2D_Get_Custom_PropMinPenetrationForPenaltyv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 68 >> 2]);
}

function __Z47Screen_Get_Custom_PropAutorotateToLandscapeLeftv() {
 return (HEAP32[(__Z16GetScreenManagerv() | 0) + 32 >> 2] | 0) >>> 2 & 1 | 0;
}

function __Z46Register_UnityEngine_Audio_AudioMixer_SetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 894641 | 0, fb + 6 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSource_PlayScheduledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886879 | 0, fb + 9 | 0);
 return;
}

function __Z46Register_UnityEngine_AudioSettings_get_dspTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885065 | 0, fb + 1 | 0);
 return;
}

function __Z46Register_UnityEngine_Application_get_isPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493418 | 0, fb + 4 | 0);
 return;
}

function __Z46Register_UnityEngine_Application_HasProLicensev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493707 | 0, fb + 9 | 0);
 return;
}

function __Z46Register_UnityEngine_Animation_CrossFadeQueuedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916853 | 0, fb + 7 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_SetDoubleFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593896 | 0, fb + 1 | 0);
 return;
}

function __Z46Register_UnityEngine_AndroidJNI_GetDoubleFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593516 | 0, fb + 1 | 0);
 return;
}

function __Z45Register_UnityEngine_Time_get_smoothDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576873 | 0, fb + 26 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioListener_set_volumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886042 | 0, fb + 42 | 0);
 return;
}

function __Z45Register_UnityEngine_AudioListener_get_volumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886004 | 0, fb + 51 | 0);
 return;
}

function __Z45Register_UnityEngine_Application_get_srcValuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494220 | 0, fb + 18 | 0);
 return;
}

function __Z45Register_UnityEngine_Application_get_dataPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494037 | 0, fb + 14 | 0);
 return;
}

function __Z45Register_UnityEngine_Animator_PlayInFixedTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922250 | 0, fb + 26 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_SetFloatFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593858 | 0, fb + 51 | 0);
 return;
}

function __Z45Register_UnityEngine_AndroidJNI_GetFloatFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593478 | 0, fb + 17 | 0);
 return;
}

function __Z44Register_UnityEngine_WebCamTexture_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 895995 | 0, fb + 162 | 0);
 return;
}

function __Z44Register_UnityEngine_Sprite_OverrideGeometryv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569410 | 0, fb + 670 | 0);
 return;
}

function __Z44Register_UnityEngine_SliderJoint2D_set_anglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820889 | 0, fb + 479 | 0);
 return;
}

function __Z44Register_UnityEngine_SliderJoint2D_get_anglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 820852 | 0, fb + 552 | 0);
 return;
}

function __Z44Register_UnityEngine_Shader_WarmupAllShadersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565055 | 0, fb + 117 | 0);
 return;
}

function __Z44Register_UnityEngine_Screen_get_sleepTimeoutv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535031 | 0, fb + 159 | 0);
 return;
}

function __Z44Register_UnityEngine_Rigidbody2D_set_inertiav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814103 | 0, fb + 461 | 0);
 return;
}

function __Z44Register_UnityEngine_Rigidbody2D_get_inertiav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814066 | 0, fb + 529 | 0);
 return;
}

function __Z44Register_UnityEngine_RemoteSettings_GetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1042683 | 0, fb + 19 | 0);
 return;
}

function __Z44Register_UnityEngine_Physics_IgnoreCollisionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784201 | 0, fb + 851 | 0);
 return;
}

function __Z44Register_UnityEngine_ParticleSystem_set_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651884 | 0, fb + 289 | 0);
 return;
}

function __Z44Register_UnityEngine_ParticleSystem_get_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 651847 | 0, fb + 345 | 0);
 return;
}

function __Z44Register_UnityEngine_Mesh_GetBlendShapeIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549073 | 0, fb + 657 | 0);
 return;
}

function __Z44Register_UnityEngine_Material_SetOverrideTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566408 | 0, fb + 667 | 0);
 return;
}

function __Z44Register_UnityEngine_Light_GetCommandBuffersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542737 | 0, fb + 646 | 0);
 return;
}

function __Z44Register_UnityEngine_LensFlare_set_fadeSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524910 | 0, fb + 168 | 0);
 return;
}

function __Z44Register_UnityEngine_LensFlare_get_fadeSpeedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524873 | 0, fb + 214 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint2D_set_breakTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818254 | 0, fb + 468 | 0);
 return;
}

function __Z44Register_UnityEngine_Joint2D_get_breakTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818217 | 0, fb + 538 | 0);
 return;
}

function __Z44Register_UnityEngine_Input_get_imeIsSelectedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 539457 | 0, fb + 182 | 0);
 return;
}

function __Z44Register_UnityEngine_HumanTrait_get_BoneNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929535 | 0, fb + 255 | 0);
 return;
}

function __Z44Register_UnityEngine_HingeJoint_get_velocityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789093 | 0, fb + 500 | 0);
 return;
}

function __Z44Register_UnityEngine_Graphics_get_activeTierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533314 | 0, fb + 145 | 0);
 return;
}

function __Z44Register_UnityEngine_Graphics_DrawProceduralv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532340 | 0, fb + 614 | 0);
 return;
}

function __Z44Register_UnityEngine_GameObject_GetComponentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514891 | 0, fb + 632 | 0);
 return;
}

function __Z44Register_UnityEngine_Cubemap_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573157 | 0, fb + 244 | 0);
 return;
}

function __Z44Register_UnityEngine_ComputeShader_SetBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509605 | 0, fb + 229 | 0);
 return;
}

function __Z44Register_UnityEngine_ComputeShader_HasKernelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509218 | 0, fb + 627 | 0);
 return;
}

function __Z44Register_UnityEngine_ComputeBuffer_CopyCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510014 | 0, fb + 580 | 0);
 return;
}

function __Z44Register_UnityEngine_Compass_get_trueHeadingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537523 | 0, fb + 230 | 0);
 return;
}

function __Z44Register_UnityEngine_Collider2D_get_frictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816773 | 0, fb + 534 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_set_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503305 | 0, fb + 159 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_get_farClipPlanev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503268 | 0, fb + 207 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_RenderWithShaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507307 | 0, fb + 567 | 0);
 return;
}

function __Z44Register_UnityEngine_Camera_AddCommandBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508269 | 0, fb + 569 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioSource_PlayDelayedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886842 | 0, fb + 602 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioListener_get_pausev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886080 | 0, fb + 250 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioClip_Init_Internalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885967 | 0, fb + 190 | 0);
 return;
}

function __Z44Register_UnityEngine_AreaEffector2D_set_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823901 | 0, fb + 491 | 0);
 return;
}

function __Z44Register_UnityEngine_AreaEffector2D_get_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 823864 | 0, fb + 570 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_get_humanScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918954 | 0, fb + 758 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_IsInTransitionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921691 | 0, fb + 967 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationState_set_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917892 | 0, fb + 661 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationState_get_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917855 | 0, fb + 753 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_SetLongFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593821 | 0, fb + 258 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_SetCharFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593710 | 0, fb + 703 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_SetByteFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593673 | 0, fb + 702 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_IsSameObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592093 | 0, fb + 779 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_IsInstanceOfv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 592325 | 0, fb + 780 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_GetLongFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593441 | 0, fb + 787 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_GetCharFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593330 | 0, fb + 784 | 0);
 return;
}

function __Z44Register_UnityEngine_AndroidJNI_GetByteFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593293 | 0, fb + 783 | 0);
 return;
}

function __Z44Register_UnityEngine_AI_NavMesh_SetLayerCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850298 | 0, fb + 592 | 0);
 return;
}

function __Z44Register_UnityEngine_AI_NavMesh_GetLayerCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850335 | 0, fb + 682 | 0);
 return;
}

function __Z44Register_UnityEngine_AI_NavMeshAgent_SetPathv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848431 | 0, fb + 916 | 0);
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToShortArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToFloatArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43Register_UnityEngine_VR_VRDevice_get_familyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045825 | 0, fb + 307 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_set_filterModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571480 | 0, fb + 3111 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_set_anisoLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571552 | 0, fb + 3112 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_get_filterModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571444 | 0, fb + 1889 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_get_anisoLevelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571516 | 0, fb + 1890 | 0);
 return;
}

function __Z43Register_UnityEngine_TerrainData_RemoveUserv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938378 | 0, fb + 4158 | 0);
 return;
}

function __Z43Register_UnityEngine_Sprite_get_packingModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569112 | 0, fb + 1876 | 0);
 return;
}

function __Z43Register_UnityEngine_Shader_get_renderQueuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563924 | 0, fb + 1852 | 0);
 return;
}

function __Z43Register_UnityEngine_Shader_get_isSupportedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563630 | 0, fb + 1849 | 0);
 return;
}

function __Z43Register_UnityEngine_Shader_SetGlobalBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564452 | 0, fb + 3076 | 0);
 return;
}

function __Z43Register_UnityEngine_Screen_set_orientationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534995 | 0, fb + 3572 | 0);
 return;
}

function __Z43Register_UnityEngine_Rigidbody2D_IsSleepingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814850 | 0, fb + 2330 | 0);
 return;
}

function __Z43Register_UnityEngine_Renderer_set_materialsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525873 | 0, fb + 2882 | 0);
 return;
}

function __Z43Register_UnityEngine_Renderer_get_materialsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525837 | 0, fb + 1697 | 0);
 return;
}

function __Z43Register_UnityEngine_Renderer_get_isVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 526553 | 0, fb + 1702 | 0);
 return;
}

function __Z43Register_UnityEngine_RenderTexture_get_sRGBv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574932 | 0, fb + 1912 | 0);
 return;
}

function __Z43Register_UnityEngine_RenderSettings_set_sunv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520402 | 0, fb + 3524 | 0);
 return;
}

function __Z43Register_UnityEngine_RenderSettings_set_fogv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518556 | 0, fb + 3507 | 0);
 return;
}

function __Z43Register_UnityEngine_Projector_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528020 | 0, fb + 2905 | 0);
 return;
}

function __Z43Register_UnityEngine_Projector_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 527984 | 0, fb + 1713 | 0);
 return;
}

function __Z43Register_UnityEngine_Mesh_RecalculateBoundsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548612 | 0, fb + 3610 | 0);
 return;
}

function __Z43Register_UnityEngine_Material_get_passCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566472 | 0, fb + 1861 | 0);
 return;
}

function __Z43Register_UnityEngine_Material_EnableKeywordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566874 | 0, fb + 3089 | 0);
 return;
}

function __Z43Register_UnityEngine_Input_GetMouseButtonUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538362 | 0, fb + 1751 | 0);
 return;
}

function __Z43Register_UnityEngine_Input_GetKeyDownStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537947 | 0, fb + 1745 | 0);
 return;
}

function __Z43Register_UnityEngine_Gradient_set_colorKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517157 | 0, fb + 2849 | 0);
 return;
}

function __Z43Register_UnityEngine_Gradient_set_alphaKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517229 | 0, fb + 2850 | 0);
 return;
}

function __Z43Register_UnityEngine_Gradient_get_colorKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517121 | 0, fb + 1675 | 0);
 return;
}

function __Z43Register_UnityEngine_Gradient_get_alphaKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517193 | 0, fb + 1676 | 0);
 return;
}

function __Z43Register_UnityEngine_GUITexture_set_texturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514427 | 0, fb + 2834 | 0);
 return;
}

function __Z43Register_UnityEngine_GUITexture_get_texturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514391 | 0, fb + 1661 | 0);
 return;
}

function __Z43Register_UnityEngine_GL_SetRevertBackfacingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536075 | 0, fb + 3586 | 0);
 return;
}

function __Z43Register_UnityEngine_GL_INTERNAL_CALL_Colorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535166 | 0, fb + 3575 | 0);
 return;
}

function __Z43Register_UnityEngine_Collider_set_isTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794572 | 0, fb + 3799 | 0);
 return;
}

function __Z43Register_UnityEngine_Collider_get_isTriggerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794536 | 0, fb + 2309 | 0);
 return;
}

function __Z43Register_UnityEngine_Cloth_set_coefficientsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841256 | 0, fb + 3994 | 0);
 return;
}

function __Z43Register_UnityEngine_Cloth_get_coefficientsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841220 | 0, fb + 2436 | 0);
 return;
}

function __Z43Register_UnityEngine_Canvas_set_scaleFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015158 | 0, fb + 692 | 0);
 return;
}

function __Z43Register_UnityEngine_Canvas_get_scaleFactorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1015122 | 0, fb + 791 | 0);
 return;
}

function __Z43Register_UnityEngine_Camera_set_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504035 | 0, fb + 2781 | 0);
 return;
}

function __Z43Register_UnityEngine_Camera_get_pixelHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504639 | 0, fb + 1629 | 0);
 return;
}

function __Z43Register_UnityEngine_Camera_get_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503999 | 0, fb + 1625 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioClip_get_loadTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885626 | 0, fb + 2482 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioClip_get_channelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885512 | 0, fb + 2479 | 0);
 return;
}

function __Z43Register_UnityEngine_Application_ForceCrashv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494910 | 0, fb + 3460 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_StopRecordingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922858 | 0, fb + 3815 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_StartPlaybackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922672 | 0, fb + 3813 | 0);
 return;
}

function __Z43Register_UnityEngine_Animation_set_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916439 | 0, fb + 4097 | 0);
 return;
}

function __Z43Register_UnityEngine_Animation_get_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916403 | 0, fb + 2535 | 0);
 return;
}

function __Z43Register_UnityEngine_Animation_GetClipCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916991 | 0, fb + 2537 | 0);
 return;
}

function __Z43Register_UnityEngine_AnimationCurve_SetKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546481 | 0, fb + 2993 | 0);
 return;
}

function __Z43Register_UnityEngine_AnimationCurve_GetKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546575 | 0, fb + 1784 | 0);
 return;
}

function __Z43Register_UnityEngine_AnimationCurve_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546188 | 0, fb + 3604 | 0);
 return;
}

function __Z43Register_UnityEngine_AI_NavMesh_Triangulatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850576 | 0, fb + 4029 | 0);
 return;
}

function __Z43Register_UnityEngine_AI_NavMeshAgent_Resumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 848356 | 0, fb + 3774 | 0);
 return;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewLocalRef13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_AllocObject13Il2Cpp_IntPtrRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z42getNbPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z42Register_UnityEngine_TextMesh_set_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010028 | 0, fb + 4226 | 0);
 return;
}

function __Z42Register_UnityEngine_TextMesh_set_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009456 | 0, fb + 4222 | 0);
 return;
}

function __Z42Register_UnityEngine_TextMesh_get_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009993 | 0, fb + 2664 | 0);
 return;
}

function __Z42Register_UnityEngine_TextMesh_get_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009421 | 0, fb + 2660 | 0);
 return;
}

function __Z42Register_UnityEngine_RemoteSettings_HasKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1042794 | 0, fb + 2764 | 0);
 return;
}

function __Z42Register_UnityEngine_RemoteSettings_GetIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1042648 | 0, fb + 1127 | 0);
 return;
}

function __Z42Register_UnityEngine_ParticleEmitter_Emit3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051547 | 0, fb + 4446 | 0);
 return;
}

function __Z42Register_UnityEngine_ParticleEmitter_Emit2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1051512 | 0, fb + 4445 | 0);
 return;
}

function __Z42Register_UnityEngine_GUI_BringWindowToBackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021382 | 0, fb + 3894 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIUtility_SetChangedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024952 | 0, fb + 3904 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIText_set_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009114 | 0, fb + 4216 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIText_set_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008772 | 0, fb + 4213 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIText_get_fontStylev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009079 | 0, fb + 2656 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIText_get_alignmentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008737 | 0, fb + 2653 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_set_wordWrapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022653 | 0, fb + 4289 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_set_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023629 | 0, fb + 4300 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_set_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023487 | 0, fb + 4298 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_set_clippingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022723 | 0, fb + 4290 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_get_wordWrapv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022618 | 0, fb + 2723 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_get_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023594 | 0, fb + 2731 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_get_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1023452 | 0, fb + 2729 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyle_get_clippingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022688 | 0, fb + 2724 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIStyleState_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021831 | 0, fb + 3898 | 0);
 return;
}

function __Z42Register_UnityEngine_Event_set_commandNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019957 | 0, fb + 4277 | 0);
 return;
}

function __Z42Register_UnityEngine_Event_get_commandNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019922 | 0, fb + 2714 | 0);
 return;
}

function __Z42Register_UnityEngine_Canvas_set_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014935 | 0, fb + 4253 | 0);
 return;
}

function __Z42Register_UnityEngine_Canvas_get_rootCanvasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1016202 | 0, fb + 2704 | 0);
 return;
}

function __Z42Register_UnityEngine_Canvas_get_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014900 | 0, fb + 2691 | 0);
 return;
}

function __Z38Caching_Get_Custom_PropExpirationDelayv() {
 return __ZN14CachingManager18GetExpirationDelayEv(__Z17GetCachingManagerv() | 0) | 0;
}

function __Z37LocationService_Get_Custom_PropStatusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return __ZN15LocationService17GetLocationStatusEv() | 0;
}

function __Z36getPxVehicleWheelDataMMaxBrakeTorquePKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z33getPxVehicleDriveDynData_GearDownPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 66 >> 0] | 0) != 0 | 0;
}

function __Z32getPxJointLimitParametersDampingPKN5physx22PxJointLimitParametersE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z32Random_CUSTOM_INTERNAL_set_stateRK9RandState(i1) {
 i1 = i1 | 0;
 _memmove(__Z16GetScriptingRandv() | 0, i1 | 0, 16) | 0;
 return;
}

function __Z32AndroidJNI_CUSTOM_CallCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z32AndroidJNI_CUSTOM_CallByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z31getPxJointAngularLimitPairUpperPKN5physx23PxJointAngularLimitPairE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z31getPxJointAngularLimitPairLowerPKN5physx23PxJointAngularLimitPairE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z30setPxSceneDescFilterShaderDataPN5physx11PxSceneDescEPKv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 return;
}

function __Z28GUIUtility_CUSTOM_SetChangedh(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) + 64 >> 2] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z16MainThreadRunnerPFvPvES_10JobGroupID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 return;
}

function __Z15getPxActor_NamePKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
}

function __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _Write_CVT(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[(HEAP32[i1 + 384 >> 2] | 0) + (i2 << 2) >> 2] = i3;
 return;
}

function _UNITY_tt_face_set_sbit_strike(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _UNITY_FT_Match_Size(i1, i2, 0, i3) | 0;
}

function _UNITY_png_set_text_compression_mem_level(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 316 >> 2] = i2;
 return;
}

function _UNITY_png_get_error_ptr(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 172 >> 2] | 0;
 return i1 | 0;
}

function _gray_line_to(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _gray_render_line(i2, HEAP32[i1 >> 2] << 2, HEAP32[i1 + 4 >> 2] << 2);
 return 0;
}

function _glBindAttribLocation__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glBindAttribLocation(i1 | 0, i2 | 0, i3 | 0);
}

function _alphasort(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strcoll((HEAP32[i1 >> 2] | 0) + 11 | 0, (HEAP32[i2 >> 2] | 0) + 11 | 0) | 0;
}

function __ZThn680_N18UnityConnectClientD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -680 | 0;
 __ZN18UnityConnectClientD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn4_NK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 88 >> 0] | 0) != 0 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 480 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 152 >> 2]);
}

function __ZThn32_N19SkinnedMeshRendererD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN19SkinnedMeshRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn32_N12LineRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 __ZN12LineRenderer19UpdateTransformInfoEv(i1 + -32 | 0);
 return;
}

function __ZNSt3__211__stdoutbufIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__211__stdoutbufIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__25ctypeIcE9do_narrowEcc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (i2 << 24 >> 24 > -1 ? i2 : i3) | 0;
}

function __ZNKSt3__212ctype_bynameIwE10do_toupperEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _towupper_l(i2, HEAP32[i1 + 8 >> 2] | 0) | 0;
}

function __ZNKSt3__212ctype_bynameIwE10do_tolowerEw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _towlower_l(i2, HEAP32[i1 + 8 >> 2] | 0) | 0;
}

function __ZNK5physx7NpCloth18getNbRestPositionsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore18getNbRestPositionsEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 316 >> 2]);
}

function __ZNK5physx3Ext13RevoluteJoint21getRevoluteJointFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i1 + 80 >> 2] | 0) + 132 >> 1] | 0;
}

function __ZNK5physx3Ext13DistanceJoint12getToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 80 >> 2]);
}

function __ZNK5physx3Ext13DistanceJoint12getStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 84 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP21getOutOfBoundsObjectsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 84 >> 2] | 0) + 5244 >> 2] | 0;
}

function __ZNK5physx13NpClothFabric11getNbPhasesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv(i1 + 16 | 0) | 0;
}

function __ZNK5physx10PxsContext18getBounceThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 12 >> 2] | 0) + 140 >> 2]);
}

function __ZNK5Umbra10Visibility22getOutputContributionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 28 >> 2] | 0;
}

function __ZNK17ArchiveFileSystem6TargetERK13FileEntryDataR15FileSystemEntry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK14DataBufferGLES12GetUpdateAgeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[HEAP32[i1 >> 2] >> 2] | 0) - (HEAP32[i1 + 28 >> 2] | 0) | 0;
}

function __ZNK14DataBufferGLES12GetRenderAgeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[HEAP32[i1 >> 2] >> 2] | 0) - (HEAP32[i1 + 32 >> 2] | 0) | 0;
}

function __ZN9Animation7SetClipE4PPtrI13AnimationClipE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 280 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] & 2097152 | 0) != 0 | 0;
}

function __ZN7Texture26SetUsageModeNoDirtyNoApplyE16TextureUsageMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 56 >> 2] = i2;
 return;
}

function __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx3Cct13BoxController15invalidateCacheEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct9SweepTest13voidTestCacheEv(i1 + 96 | 0);
 return;
}

function __ZN5physx2Sn12PointerRemapC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx2Sc8RigidSim10getPxActorEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9RigidCore10getPxActorEv(HEAP32[i1 + 52 >> 2] | 0) | 0;
}

function __ZN5physx2Sc18ParticleSystemCore12setViscosityEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 60 >> 2] = f1;
 return;
}

function __ZN5physx2Sc16ArticulationCore24setSolverIterationCountsEt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i1 + 16 >> 1] = i2;
 return;
}

function __ZN5physx2Sc16ArticulationCore14setWakeCounterEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 32 >> 2] = f2;
 return;
}

function __ZN5physx2Gu17RadixSortBufferedC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu9RadixSortC2Ev(i1);
 HEAP32[i1 >> 2] = gb + 86392 + 8;
 return;
}

function __ZN5physx26PxConvexMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx16PxBroadPhaseBase9addRegionERKNS_18PxBroadPhaseRegionEb(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZN4FMOD7SystemI11isRecordingEiPb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 if (i3 | 0) HEAP8[i3 >> 0] = 0;
 return 0;
}

function __ZN4FMOD13ChannelGroupI19setAudibilityFactorEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 40 >> 2] = f2;
 return 0;
}

function __ZN21LinearCollectionField26GetSizeFieldFromListObjectEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 12 >> 2] | 0;
}

function __ZN20LocalFileSystemPosix11CreateAsDirER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_mkdir(i2, 493) | 0) == 0 | 0;
}

function __ZN19TouchPhaseEmulation17PreprocessTouchesEv(i1) {
 i1 = i1 | 0;
 __ZN19TouchPhaseEmulation23DiscardRedundantTouchesEv(i1);
 return;
}

function __ZN18GlslGpuProgramGLES15ApplyGpuProgramERK20GpuProgramParametersPKh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN17GeneralConnection14NetworkMessage5SetIDENS_9MessageIDE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i1 + 2 >> 1] = i2;
 return;
}

function __ZN14AreaEffector2D14SetForceTargetE19EffectorSelection2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 112 >> 2] = i2;
 return;
}

function __ZN13ScreenManager18RequestOrientationE17ScreenOrientation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 40 >> 2] = i2;
 return;
}

function __ZN12SocketStream13OnSocketErrorEv(i1) {
 i1 = i1 | 0;
 mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 36 >> 2] | 0, i1 | 0) | 0;
 return;
}

function __ZN12MeshRenderer19DidModifyMeshBoundsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN11TimeManagerD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11Rigidbody2DD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11AudioSource17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1460020 >> 2] = (HEAP32[gb + 1460020 >> 2] | 0) + -1;
 return;
}

function __ZL24stbir__support_trapezoidf(f1) {
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(f1 * Math_fround(.5)) + Math_fround(.5));
}

function __Z56DynamicGI_CUSTOM_INTERNAL_CALL_UpdateMaterialsForTerrainP12Il2CppObjectRK5RectTIfE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z52Application_Set_Custom_PropBackgroundLoadingPriority14ThreadPriority(i1) {
 i1 = i1 | 0;
 __Z17GetPreloadManagerv() | 0;
 return;
}

function __Z50LODGroup_Get_Custom_PropCrossFadeAnimationDurationv() {
 return Math_fround(HEAPF32[(__Z18GetLODGroupManagerv() | 0) + 32 >> 2]);
}

function __Z45Register_UnityEngine_TerrainData_GetSteepnessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 939097 | 0, fb + 3 | 0);
 return;
}

function __Z45Register_UnityEngine_Mathf_LinearToGammaSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545991 | 0, fb + 6 | 0);
 return;
}

function __Z45Register_UnityEngine_Mathf_GammaToLinearSpacev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 545953 | 0, fb + 5 | 0);
 return;
}

function __Z45Register_UnityEngine_Application_get_platformv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493536 | 0, fb + 7 | 0);
 return;
}

function __Z45Register_UnityEngine_Application_get_isEditorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493457 | 0, fb + 5 | 0);
 return;
}

function __Z45Playable_CUSTOM_INTERNAL_CALL_IsValidInternalR9HPlayable(i1) {
 i1 = i1 | 0;
 return (__ZNK9HPlayable7IsValidEv(i1) | 0) & 1 | 0;
}

function __Z44Register_UnityEngine_Time_set_fixedDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576758 | 0, fb + 16 | 0);
 return;
}

function __Z44Register_UnityEngine_Time_get_fixedDeltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576721 | 0, fb + 24 | 0);
 return;
}

function __Z44Register_UnityEngine_AudioSource_PlayOneShotv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887210 | 0, fb + 67 | 0);
 return;
}

function __Z44Register_UnityEngine_Application_get_versionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494388 | 0, fb + 21 | 0);
 return;
}

function __Z44Register_UnityEngine_Application_get_genuinev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 495473 | 0, fb + 36 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_SetLayerWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921259 | 0, fb + 72 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_SetFloatStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923420 | 0, fb + 74 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_GetLayerWeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921222 | 0, fb + 37 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_GetFloatStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923490 | 0, fb + 38 | 0);
 return;
}

function __Z44Register_UnityEngine_AnimationCurve_Evaluatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546224 | 0, fb + 12 | 0);
 return;
}

function __Z43Register_UnityEngine_WheelCollider_set_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836618 | 0, fb + 570 | 0);
 return;
}

function __Z43Register_UnityEngine_WheelCollider_get_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 836582 | 0, fb + 657 | 0);
 return;
}

function __Z43Register_UnityEngine_WWW_get_uploadProgressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581120 | 0, fb + 261 | 0);
 return;
}

function __Z43Register_UnityEngine_TrailRenderer_set_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528158 | 0, fb + 174 | 0);
 return;
}

function __Z43Register_UnityEngine_TrailRenderer_get_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528122 | 0, fb + 220 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_set_mipMapBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571692 | 0, fb + 202 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture_get_mipMapBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571656 | 0, fb + 259 | 0);
 return;
}

function __Z43Register_UnityEngine_Texture2D_PackTexturesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572757 | 0, fb + 134 | 0);
 return;
}

function __Z43Register_UnityEngine_TerrainData_GetHeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938963 | 0, fb + 163 | 0);
 return;
}

function __Z43Register_UnityEngine_SpringJoint_set_springv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789200 | 0, fb + 433 | 0);
 return;
}

function __Z43Register_UnityEngine_SpringJoint_set_damperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789272 | 0, fb + 434 | 0);
 return;
}

function __Z43Register_UnityEngine_SpringJoint_get_springv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789164 | 0, fb + 502 | 0);
 return;
}

function __Z43Register_UnityEngine_SpringJoint_get_damperv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789236 | 0, fb + 503 | 0);
 return;
}

function __Z43Register_UnityEngine_Screen_get_resolutionsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534286 | 0, fb + 150 | 0);
 return;
}

function __Z43Register_UnityEngine_Screen_get_orientationv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534959 | 0, fb + 158 | 0);
 return;
}

function __Z43Register_UnityEngine_Rigidbody2D_IsTouchingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815328 | 0, fb + 892 | 0);
 return;
}

function __Z43Register_UnityEngine_RenderSettings_get_sunv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520366 | 0, fb + 115 | 0);
 return;
}

function __Z43Register_UnityEngine_RenderSettings_get_fogv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 518520 | 0, fb + 110 | 0);
 return;
}

function __Z43Register_UnityEngine_Mesh_GetBlendShapeNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548180 | 0, fb + 654 | 0);
 return;
}

function __Z43Register_UnityEngine_Material_SetBufferImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566309 | 0, fb + 666 | 0);
 return;
}

function __Z43Register_UnityEngine_LightmapSettings_Resetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534067 | 0, fb + 101 | 0);
 return;
}

function __Z43Register_UnityEngine_Light_AddCommandBufferv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542579 | 0, fb + 620 | 0);
 return;
}

function __Z43Register_UnityEngine_Joint2D_set_breakForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818181 | 0, fb + 467 | 0);
 return;
}

function __Z43Register_UnityEngine_Joint2D_get_breakForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 818145 | 0, fb + 537 | 0);
 return;
}

function __Z43Register_UnityEngine_Input_get_mousePresentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538527 | 0, fb + 167 | 0);
 return;
}

function __Z43Register_UnityEngine_Input_GetJoystickNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538254 | 0, fb + 166 | 0);
 return;
}

function __Z43Register_UnityEngine_HumanTrait_HasColliderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929733 | 0, fb + 991 | 0);
 return;
}

function __Z43Register_UnityEngine_GameObject_SendMessagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515894 | 0, fb + 234 | 0);
 return;
}

function __Z43Register_UnityEngine_GL_RenderTargetBarrierv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536316 | 0, fb + 110 | 0);
 return;
}

function __Z43Register_UnityEngine_Debug_get_isDebugBuildv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511795 | 0, fb + 105 | 0);
 return;
}

function __Z43Register_UnityEngine_CullingGroup_IsVisiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510885 | 0, fb + 629 | 0);
 return;
}

function __Z43Register_UnityEngine_CubemapArray_SetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573963 | 0, fb + 137 | 0);
 return;
}

function __Z43Register_UnityEngine_CubemapArray_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 574037 | 0, fb + 154 | 0);
 return;
}

function __Z43Register_UnityEngine_CrashReport_GetReportsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510111 | 0, fb + 101 | 0);
 return;
}

function __Z43Register_UnityEngine_ComputeShader_Dispatchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509642 | 0, fb + 120 | 0);
 return;
}

function __Z43Register_UnityEngine_Component_GetComponentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508876 | 0, fb + 624 | 0);
 return;
}

function __Z43Register_UnityEngine_Collider2D_set_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816233 | 0, fb + 465 | 0);
 return;
}

function __Z43Register_UnityEngine_Collider2D_get_densityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816197 | 0, fb + 533 | 0);
 return;
}

function __Z43Register_UnityEngine_Camera_set_fieldOfViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503156 | 0, fb + 157 | 0);
 return;
}

function __Z43Register_UnityEngine_Camera_get_fieldOfViewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503120 | 0, fb + 205 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioSource_set_volumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886386 | 0, fb + 599 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioSource_set_spreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888603 | 0, fb + 607 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioSource_get_volumev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886350 | 0, fb + 690 | 0);
 return;
}

function __Z43Register_UnityEngine_AudioSource_get_spreadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888567 | 0, fb + 697 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_SetBoolStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923560 | 0, fb + 938 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_GetLayerIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921186 | 0, fb + 962 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_GetBoolStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923628 | 0, fb + 971 | 0);
 return;
}

function __Z43Register_UnityEngine_Animator_GetBehavioursv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920998 | 0, fb + 960 | 0);
 return;
}

function __Z43Register_UnityEngine_AnimationClip_SetCurvev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 915655 | 0, fb + 156 | 0);
 return;
}

function __Z43Register_UnityEngine_AndroidJNI_SetIntFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593785 | 0, fb + 705 | 0);
 return;
}

function __Z43Register_UnityEngine_AndroidJNI_GetIntFieldv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 593405 | 0, fb + 786 | 0);
 return;
}

function __Z43Register_UnityEngine_AI_NavMesh_SetAreaCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850420 | 0, fb + 593 | 0);
 return;
}

function __Z43Register_UnityEngine_AI_NavMesh_GetAreaCostv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 850456 | 0, fb + 683 | 0);
 return;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToLongArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToCharArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToByteArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z42Register_UnityEngine_VR_VRDevice_get_modelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1045861 | 0, fb + 308 | 0);
 return;
}

function __Z42Register_UnityEngine_Texture2D_EncodeToPNGv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572841 | 0, fb + 1896 | 0);
 return;
}

function __Z42Register_UnityEngine_SortingLayer_NameToIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567842 | 0, fb + 1870 | 0);
 return;
}

function __Z42Register_UnityEngine_SortingLayer_IDToNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567877 | 0, fb + 1871 | 0);
 return;
}

function __Z42Register_UnityEngine_Shader_set_maximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563807 | 0, fb + 3066 | 0);
 return;
}

function __Z42Register_UnityEngine_Shader_get_maximumLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563772 | 0, fb + 1851 | 0);
 return;
}

function __Z42Register_UnityEngine_Shader_DisableKeywordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563700 | 0, fb + 3641 | 0);
 return;
}

function __Z42Register_UnityEngine_Screen_set_fullScreenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534522 | 0, fb + 3567 | 0);
 return;
}

function __Z42Register_UnityEngine_Resources_UnloadAssetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560686 | 0, fb + 3638 | 0);
 return;
}

function __Z42Register_UnityEngine_Renderer_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525720 | 0, fb + 2880 | 0);
 return;
}

function __Z42Register_UnityEngine_Renderer_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525685 | 0, fb + 1695 | 0);
 return;
}

function __Z42Register_UnityEngine_RectOffset_set_bottomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514009 | 0, fb + 2831 | 0);
 return;
}

function __Z42Register_UnityEngine_RectOffset_get_bottomv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513974 | 0, fb + 1658 | 0);
 return;
}

function __Z42Register_UnityEngine_PlayerPrefs_DeleteKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552944 | 0, fb + 3618 | 0);
 return;
}

function __Z42Register_UnityEngine_Mesh_set_subMeshCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548811 | 0, fb + 3003 | 0);
 return;
}

function __Z42Register_UnityEngine_Mesh_get_subMeshCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548776 | 0, fb + 1793 | 0);
 return;
}

function __Z42Register_UnityEngine_Mesh_ClearBlendShapesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548145 | 0, fb + 3609 | 0);
 return;
}

function __Z42Register_UnityEngine_Light_set_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542544 | 0, fb + 2971 | 0);
 return;
}

function __Z42Register_UnityEngine_Light_get_cullingMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542509 | 0, fb + 1769 | 0);
 return;
}

function __Z42Register_UnityEngine_LightProbes_get_countv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 533609 | 0, fb + 1733 | 0);
 return;
}

function __Z42Register_UnityEngine_LayerMask_NameToLayerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540709 | 0, fb + 1758 | 0);
 return;
}

function __Z42Register_UnityEngine_LayerMask_LayerToNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540674 | 0, fb + 1757 | 0);
 return;
}

function __Z42Register_UnityEngine_LODGroup_set_fadeModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540244 | 0, fb + 2955 | 0);
 return;
}

function __Z42Register_UnityEngine_LODGroup_get_lodCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540174 | 0, fb + 1752 | 0);
 return;
}

function __Z42Register_UnityEngine_LODGroup_get_fadeModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540209 | 0, fb + 1753 | 0);
 return;
}

function __Z42Register_UnityEngine_GameObject_set_activev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515340 | 0, fb + 2839 | 0);
 return;
}

function __Z42Register_UnityEngine_GameObject_get_activev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515305 | 0, fb + 1666 | 0);
 return;
}

function __Z42Register_UnityEngine_GUI_get_blendMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020879 | 0, fb + 277 | 0);
 return;
}

function __Z42Register_UnityEngine_GUIUtility_GetChangedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1024917 | 0, fb + 283 | 0);
 return;
}

function __Z42Register_UnityEngine_GUITexture_set_borderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514594 | 0, fb + 2837 | 0);
 return;
}

function __Z42Register_UnityEngine_GUITexture_get_borderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 514559 | 0, fb + 1662 | 0);
 return;
}

function __Z42Register_UnityEngine_Font_GetCharacterInfov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010544 | 0, fb + 186 | 0);
 return;
}

function __Z42Register_UnityEngine_Collider_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794723 | 0, fb + 3800 | 0);
 return;
}

function __Z42Register_UnityEngine_Collider_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794688 | 0, fb + 2310 | 0);
 return;
}

function __Z42Register_UnityEngine_CanvasGroup_set_alphav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1012993 | 0, fb + 690 | 0);
 return;
}

function __Z42Register_UnityEngine_CanvasGroup_get_alphav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1012958 | 0, fb + 789 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_set_clearFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505495 | 0, fb + 2799 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_set_cameraTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505769 | 0, fb + 2800 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_get_pixelWidthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504604 | 0, fb + 1628 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_get_clearFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505460 | 0, fb + 1631 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_get_cameraTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 505734 | 0, fb + 1633 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_GetHDRWarningsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503518 | 0, fb + 1621 | 0);
 return;
}

function __Z42Register_UnityEngine_Behaviour_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500286 | 0, fb + 2763 | 0);
 return;
}

function __Z42Register_UnityEngine_Behaviour_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 500251 | 0, fb + 1605 | 0);
 return;
}

function __Z42Register_UnityEngine_AudioClip_get_samplesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885477 | 0, fb + 2478 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_StringToHashv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923242 | 0, fb + 2568 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_StopPlaybackv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922708 | 0, fb + 3814 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_SetTriggerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923883 | 0, fb + 4141 | 0);
 return;
}

function __Z42Register_UnityEngine_Animation_RemoveClip2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917027 | 0, fb + 4101 | 0);
 return;
}

function __Z42Register_UnityEngine_AndroidJNI_FatalErrorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591787 | 0, fb + 3673 | 0);
 return;
}

function __Z41Register_UnityEngine_JsonUtility_FromJsonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1037063 | 0, fb + 1117 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_set_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009183 | 0, fb + 4217 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008539 | 0, fb + 4209 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_set_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009045 | 0, fb + 4215 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_get_richTextv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009149 | 0, fb + 2657 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008505 | 0, fb + 2651 | 0);
 return;
}

function __Z41Register_UnityEngine_GUIText_get_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009011 | 0, fb + 2655 | 0);
 return;
}

function __Z41Register_UnityEngine_Event_set_clickCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019822 | 0, fb + 4275 | 0);
 return;
}

function __Z41Register_UnityEngine_Event_get_clickCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019788 | 0, fb + 2712 | 0);
 return;
}

function __Z41Register_UnityEngine_CanvasRenderer_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1014282 | 0, fb + 3875 | 0);
 return;
}

function __Z40Time_Get_Custom_PropRealtimeSinceStartupv() {
 return Math_fround(+__ZN11TimeManager11GetRealtimeEv(__Z14GetTimeManagerv() | 0));
}

function __Z38AndroidJNI_CUSTOM_SetFloatArrayElement13Il2Cpp_IntPtrif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __Z37AndroidJNI_CUSTOM_SetStaticFloatField13Il2Cpp_IntPtrS_f(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __Z36getPxJointLimitParametersRestitutionPKN5physx22PxJointLimitParametersE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z32getPxHeightFieldGeometryRowScalePKN5physx21PxHeightFieldGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z32HumanTrait_CUSTOM_MuscleFromBoneii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZN10HumanTrait14MuscleFromBoneEii(i1, i2) | 0;
}

function __Z31Input_Get_Custom_PropAnyKeyDownv() {
 return (__ZN12InputManager18GetAnyKeyThisFrameEv(__Z15GetInputManagerv() | 0) | 0) & 1 | 0;
}

function __Z31AndroidJNI_CUSTOM_CallIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __Z25setPxVehicleTireDataMTypePN5physx17PxVehicleTireDataEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 40 >> 2] = i1;
 return;
}

function _UNITY_png_set_text_compression_strategy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 320 >> 2] = i2;
 return;
}

function _PxRegisterParticles(i1) {
 i1 = i1 | 0;
 __ZN5physx20PxvRegisterParticlesEv();
 __ZN5physx9NpFactory17registerParticlesEv();
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 324 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 348 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 532 >> 2]);
}

function __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 + -12 | 0;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i1 | 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6setbufEPci(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i1 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 4 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 8 | 0);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212__rs_defaultC2Ev(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(gb + 1470904 | 0) | 0;
 HEAP32[gb + 1470900 >> 2] = 1;
 return;
}

function __ZNSt3__210__stdinbufIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210__stdinbufIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] & 4 | 0) == 0 ? 4 : 7) | 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] & 4 | 0) == 0 ? 4 : 7) | 0;
}

function __ZNK8Renderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 288 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 244 >> 2]);
}

function __ZNK5physx3Ext13DistanceJoint21getDistanceJointFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i1 + 80 >> 2] | 0) + 92 >> 1] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11getNbShapesEv(i1) {
 i1 = i1 | 0;
 return HEAPU16[i1 + 24 >> 1] | 0 | 0;
}

function __ZNK5Umbra4Tome10getVersionEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 return ((i1 | 0) == -1163018018 ? 1 : i1 & 65535) | 0;
}

function __ZNK5Umbra15CameraTransform15getMatrixFormatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 432 >> 2] | 0;
}

function __ZNK16MemoryFileSystem6TargetERK13FileEntryDataR15FileSystemEntry(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNK14ParticleSystem18GetGravityModifierEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 2356 >> 2]);
}

function __ZNK13b2DynamicTree13ComputeHeightEv(i1) {
 i1 = i1 | 0;
 return __ZNK13b2DynamicTree13ComputeHeightEi(i1, HEAP32[i1 >> 2] | 0) | 0;
}

function __ZNK13Lz4Compressor29CalculateCompressedBufferSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _UNITY_LZ4_compressBound(i2) | 0;
}

function __ZN8Animator22SupportsOnAnimatorMoveEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 60 >> 2] & 64 | 0) != 0 | 0;
}

function __ZN7Joint2D17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 mftCall_vii(HEAP32[(HEAP32[i1 >> 2] | 0) + 144 >> 2] | 0, i1 | 0, 0);
 return;
}

function __ZN6Camera16ResetFieldOfViewEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1087 >> 0] = 1;
 HEAPF32[i1 + 292 >> 2] = Math_fround(60.0);
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 548 >> 2] = i1;
 return;
}

function __ZN5physx5cloth8SwSolver29setInterCollisionNbIterationsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 88 >> 2] = i1;
 return;
}

function __ZN5physx2Sc8ClothSim12updateBoundsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc10ClothShape21updateBoundsInAABBMgrEv(i1 + 56 | 0);
 return;
}

function __ZN5physx27setSerializationRegistryPtrEPKNS_23PxSerializationRegistryE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1458444 >> 2] = i1;
 return;
}

function __ZN5physx25PxAggregateRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx22PxDefaultFileInputData4seekEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 _fseek(HEAP32[i2 + 4 >> 2] | 0, i1, 0) | 0;
 return;
}

function __ZN5physx14NpShapeManagerC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Cm8PtrTableC2Ev(i1);
 __ZN5physx2Cm8PtrTableC2Ev(i1 + 8 | 0);
 return;
}

function __ZN5physx11PxHitBufferINS_12PxRaycastHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN5physx11PxHitBufferINS_12PxOverlapHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN5physx10PxsContext11swapStreamsEv(i1) {
 i1 = i1 | 0;
 __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv(i1 + 44 | 0);
 return;
}

function __ZN5Unity5JointD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN5Umbra10QueryState15importRemoteObjERNS_10StackAllocEPKvj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i2 | 0;
}

function __ZN23AnimationOffsetPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 40 >> 2] | 0;
}

function __ZN18ProfilerConnection36HandleBeginInstrumentFunctionMessageEPKvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN15PointEffector2D12SetForceModeE19EffectorForceMode2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 120 >> 2] = i2;
 return;
}

function __ZN14SafeBinaryRead10SetVersionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[(HEAP32[i1 + 80 >> 2] | 0) + 16 >> 2] = i2;
 return;
}

function __ZN14ParticleSystem7SetLoopEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 277 >> 0] = i2 & 1;
 return;
}

function __ZN12_GLOBAL__N_110DataStream6addRefEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 68 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN10MeshFilterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZL18NavMeshUnloadScenei(i1) {
 i1 = i1 | 0;
 __ZN14NavMeshManager17UnloadNavMeshDataEi(HEAP32[gb + 1459032 >> 2] | 0, i1);
 return;
}

function __Z49RenderSettings_Get_Custom_PropReflectionIntensityv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 364 >> 2]);
}

function __Z44Register_UnityEngine_PlayerPrefs_TrySetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552733 | 0, fb + 6 | 0);
 return;
}

function __Z44Register_UnityEngine_Mesh_AddBlendShapeFramev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548346 | 0, fb + 2 | 0);
 return;
}

function __Z44Register_UnityEngine_Animator_SetFloatIDDampv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924147 | 0, fb + 4 | 0);
 return;
}

function __Z43Register_UnityEngine_ComputeShader_SetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509308 | 0, fb + 39 | 0);
 return;
}

function __Z43Register_UnityEngine_Cloth_SetEnabledFadingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 841468 | 0, fb + 64 | 0);
 return;
}

function __Z43Register_UnityEngine_Application_CancelQuitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493049 | 0, fb + 87 | 0);
 return;
}

function __Z42Register_UnityEngine_WindZone_set_windMainv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581568 | 0, fb + 206 | 0);
 return;
}

function __Z42Register_UnityEngine_WindZone_get_windMainv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581533 | 0, fb + 263 | 0);
 return;
}

function __Z42Register_UnityEngine_WheelCollider_get_rpmv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 837448 | 0, fb + 663 | 0);
 return;
}

function __Z42Register_UnityEngine_WWW_INTERNAL_CALL_WWWv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581251 | 0, fb + 249 | 0);
 return;
}

function __Z42Register_UnityEngine_Texture3D_SetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573361 | 0, fb + 676 | 0);
 return;
}

function __Z42Register_UnityEngine_Texture3D_GetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573293 | 0, fb + 686 | 0);
 return;
}

function __Z42Register_UnityEngine_Texture2D_GetPixels32v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572576 | 0, fb + 683 | 0);
 return;
}

function __Z42Register_UnityEngine_Texture2D_EncodeToJPGv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572876 | 0, fb + 684 | 0);
 return;
}

function __Z42Register_UnityEngine_Shader_SetGlobalFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564050 | 0, fb + 201 | 0);
 return;
}

function __Z42Register_UnityEngine_Shader_GetGlobalFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564488 | 0, fb + 257 | 0);
 return;
}

function __Z42Register_UnityEngine_Screen_get_fullScreenv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534487 | 0, fb + 153 | 0);
 return;
}

function __Z42Register_UnityEngine_Random_RandomRangeIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554762 | 0, fb + 666 | 0);
 return;
}

function __Z42Register_UnityEngine_PlayerPrefs_TrySetIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552698 | 0, fb + 662 | 0);
 return;
}

function __Z42Register_UnityEngine_PlayerPrefs_GetStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552877 | 0, fb + 665 | 0);
 return;
}

function __Z42Register_UnityEngine_PlayerPrefs_DeleteAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552979 | 0, fb + 114 | 0);
 return;
}

function __Z42Register_UnityEngine_Mesh_SetTrianglesImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548039 | 0, fb + 129 | 0);
 return;
}

function __Z42Register_UnityEngine_Mesh_GetTrianglesImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547971 | 0, fb + 652 | 0);
 return;
}

function __Z42Register_UnityEngine_Joint_set_breakTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788315 | 0, fb + 432 | 0);
 return;
}

function __Z42Register_UnityEngine_Joint_get_breakTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788280 | 0, fb + 499 | 0);
 return;
}

function __Z42Register_UnityEngine_Input_get_inputStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538723 | 0, fb + 171 | 0);
 return;
}

function __Z42Register_UnityEngine_GameObject_CompareTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515723 | 0, fb + 636 | 0);
 return;
}

function __Z42Register_UnityEngine_Display_SetParamsImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 512600 | 0, fb + 121 | 0);
 return;
}

function __Z42Register_UnityEngine_Component_SendMessagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509040 | 0, fb + 225 | 0);
 return;
}

function __Z42Register_UnityEngine_Collider2D_IsTouchingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 816849 | 0, fb + 895 | 0);
 return;
}

function __Z42Register_UnityEngine_AudioSource_set_pitchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886457 | 0, fb + 600 | 0);
 return;
}

function __Z42Register_UnityEngine_AudioSource_get_pitchv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886422 | 0, fb + 691 | 0);
 return;
}

function __Z42Register_UnityEngine_AssetBundle_LoadAsyncv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496570 | 0, fb + 355 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_SetIntegerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923735 | 0, fb + 941 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_IsControlledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922447 | 0, fb + 968 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_GetLayerNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 921151 | 0, fb + 961 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_GetIntegerIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923809 | 0, fb + 974 | 0);
 return;
}

function __Z42Register_UnityEngine_Animator_GetBehaviourv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 920963 | 0, fb + 959 | 0);
 return;
}

function __Z42Register_UnityEngine_AndroidJNI_GetVersionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591185 | 0, fb + 224 | 0);
 return;
}

function __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_ToIntArrayP11Il2CppArrayRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z41Register_UnityEngine_Texture_set_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571622 | 0, fb + 3113 | 0);
 return;
}

function __Z41Register_UnityEngine_Texture_get_wrapModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571588 | 0, fb + 1891 | 0);
 return;
}

function __Z41Register_UnityEngine_Texture3D_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573425 | 0, fb + 1900 | 0);
 return;
}

function __Z41Register_UnityEngine_Texture2D_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 571990 | 0, fb + 1894 | 0);
 return;
}

function __Z41Register_UnityEngine_TextMesh_set_tabSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009959 | 0, fb + 689 | 0);
 return;
}

function __Z41Register_UnityEngine_TextMesh_set_offsetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009597 | 0, fb + 686 | 0);
 return;
}

function __Z41Register_UnityEngine_TextMesh_get_tabSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009925 | 0, fb + 788 | 0);
 return;
}

function __Z41Register_UnityEngine_TextMesh_get_offsetZv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009563 | 0, fb + 785 | 0);
 return;
}

function __Z41Register_UnityEngine_Sprite_get_trianglesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569349 | 0, fb + 1879 | 0);
 return;
}

function __Z41Register_UnityEngine_SortingLayer_IsValidv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 567912 | 0, fb + 1872 | 0);
 return;
}

function __Z41Register_UnityEngine_Shader_EnableKeywordv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563666 | 0, fb + 3640 | 0);
 return;
}

function __Z41Register_UnityEngine_Renderer_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525405 | 0, fb + 2876 | 0);
 return;
}

function __Z41Register_UnityEngine_Renderer_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 525371 | 0, fb + 1691 | 0);
 return;
}

function __Z41Register_UnityEngine_RectOffset_set_rightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513876 | 0, fb + 2829 | 0);
 return;
}

function __Z41Register_UnityEngine_RectOffset_get_rightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513842 | 0, fb + 1656 | 0);
 return;
}

function __Z41Register_UnityEngine_Object_set_hideFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580060 | 0, fb + 3157 | 0);
 return;
}

function __Z41Register_UnityEngine_Object_get_hideFlagsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580026 | 0, fb + 1936 | 0);
 return;
}

function __Z41Register_UnityEngine_Motion_get_isLoopingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550014 | 0, fb + 1798 | 0);
 return;
}

function __Z41Register_UnityEngine_Mesh_set_boneWeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548912 | 0, fb + 3004 | 0);
 return;
}

function __Z41Register_UnityEngine_Mesh_get_vertexCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548742 | 0, fb + 1792 | 0);
 return;
}

function __Z41Register_UnityEngine_Mesh_get_boneWeightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548878 | 0, fb + 1794 | 0);
 return;
}

function __Z41Register_UnityEngine_Mesh_Internal_Createv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547421 | 0, fb + 3605 | 0);
 return;
}

function __Z41Register_UnityEngine_Mathf_NextPowerOfTwov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546061 | 0, fb + 1782 | 0);
 return;
}

function __Z41Register_UnityEngine_LocationService_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537448 | 0, fb + 3588 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_set_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542292 | 0, fb + 2968 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_set_bakedIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542444 | 0, fb + 2970 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_get_renderModev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542258 | 0, fb + 1765 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_get_bakedIndexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542410 | 0, fb + 1767 | 0);
 return;
}

function __Z41Register_UnityEngine_LODGroup_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540403 | 0, fb + 2957 | 0);
 return;
}

function __Z41Register_UnityEngine_LODGroup_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540369 | 0, fb + 1755 | 0);
 return;
}

function __Z41Register_UnityEngine_Input_GetMouseButtonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538290 | 0, fb + 1749 | 0);
 return;
}

function __Z41Register_UnityEngine_Input_GetKeyUpStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537880 | 0, fb + 1743 | 0);
 return;
}

function __Z41Register_UnityEngine_Graphics_DrawTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532583 | 0, fb + 3556 | 0);
 return;
}

function __Z41Register_UnityEngine_GameObject_set_layerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515271 | 0, fb + 2838 | 0);
 return;
}

function __Z41Register_UnityEngine_GameObject_get_layerv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515237 | 0, fb + 1665 | 0);
 return;
}

function __Z41Register_UnityEngine_GameObject_SetActivev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515375 | 0, fb + 2840 | 0);
 return;
}

function __Z41Register_UnityEngine_GUI_get_blitMaterialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020914 | 0, fb + 278 | 0);
 return;
}

function __Z41Register_UnityEngine_GL_set_invertCullingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536041 | 0, fb + 3585 | 0);
 return;
}

function __Z41Register_UnityEngine_EdgeCollider2D_Resetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 817237 | 0, fb + 3753 | 0);
 return;
}

function __Z41Register_UnityEngine_Cursor_set_lockStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511340 | 0, fb + 3490 | 0);
 return;
}

function __Z41Register_UnityEngine_CullingGroup_Disposev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 510516 | 0, fb + 3486 | 0);
 return;
}

function __Z41Register_UnityEngine_Collider_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794458 | 0, fb + 3798 | 0);
 return;
}

function __Z41Register_UnityEngine_Collider_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 794424 | 0, fb + 2307 | 0);
 return;
}

function __Z41Register_UnityEngine_Cloth_set_useGravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840607 | 0, fb + 3991 | 0);
 return;
}

function __Z41Register_UnityEngine_Cloth_get_useGravityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840573 | 0, fb + 2431 | 0);
 return;
}

function __Z41Register_UnityEngine_Camera_set_eventMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504149 | 0, fb + 2782 | 0);
 return;
}

function __Z41Register_UnityEngine_Camera_get_eventMaskv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 504115 | 0, fb + 1626 | 0);
 return;
}

function __Z41Register_UnityEngine_Camera_GetAllCamerasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507246 | 0, fb + 1640 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_set_mutev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888749 | 0, fb + 4064 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_set_loopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887281 | 0, fb + 4053 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_set_clipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886676 | 0, fb + 4051 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_get_mutev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 888715 | 0, fb + 2505 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_get_loopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887247 | 0, fb + 2494 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_get_clipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886642 | 0, fb + 2490 | 0);
 return;
}

function __Z41Register_UnityEngine_Animator_get_isHumanv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 918811 | 0, fb + 2550 | 0);
 return;
}

function __Z41Register_UnityEngine_Animation_RemoveClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916957 | 0, fb + 4100 | 0);
 return;
}

function __Z41Register_UnityEngine_AI_NavMeshPath__ctorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 852057 | 0, fb + 3778 | 0);
 return;
}

function __Z40getPxSimulationStatisticsNbDynamicBodiesPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __Z40Register_UnityEngine_TextMesh_set_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009736 | 0, fb + 4225 | 0);
 return;
}

function __Z40Register_UnityEngine_TextMesh_get_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009703 | 0, fb + 2663 | 0);
 return;
}

function __Z40Register_UnityEngine_Font_get_lineHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010638 | 0, fb + 2670 | 0);
 return;
}

function __Z40Register_UnityEngine_Event_set_modifiersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019691 | 0, fb + 4274 | 0);
 return;
}

function __Z40Register_UnityEngine_Event_set_characterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019889 | 0, fb + 4276 | 0);
 return;
}

function __Z40Register_UnityEngine_Event_get_modifiersv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019658 | 0, fb + 2711 | 0);
 return;
}

function __Z40Register_UnityEngine_Event_get_characterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019856 | 0, fb + 2713 | 0);
 return;
}

function __Z38Application_Get_Custom_PropSandboxTypev() {
 return __ZN15ApplicationInfo14GetSandboxTypeEv(__Z18GetApplicationInfov() | 0) | 0;
}

function __Z38Application_Get_Custom_PropInstallModev() {
 return __ZN15ApplicationInfo14GetInstallModeEv(__Z18GetApplicationInfov() | 0) | 0;
}

function __Z36Profiler_CUSTOM_GetTempAllocatorSizev() {
 return __ZN13MemoryManager20GetTempAllocatorSizeEv(__Z16GetMemoryManagerv() | 0) | 0;
}

function __Z35getPxVehicleDifferential4WDataMTypePKN5physx27PxVehicleDifferential4WDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __Z34getPxClothTetherConfigStretchLimitPKN5physx19PxClothTetherConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z33getPxVehicleEngineDataMPeakTorquePKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162112 >> 2] = i1;
 return;
}

function __Z32GUI_Get_Custom_PropBlendMaterialv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z19GetGUIBlendMaterialv() | 0) | 0;
}

function __Z32AndroidJNI_CUSTOM_CallVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z31getPxVehicleDriveDynData_GearUpPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 65 >> 0] | 0) != 0 | 0;
}

function __Z31getPxVehicleAutoBoxData_LatencyPKN5physx20PxVehicleAutoBoxDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 128 >> 2]);
}

function __Z30getPxJointLinearLimitPairUpperPKN5physx22PxJointLinearLimitPairE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z30getPxJointLinearLimitPairLowerPKN5physx22PxJointLinearLimitPairE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z30ParticleSystemCleanupAfterLoadv() {
 __ZN14ParticleSystem14BeginUpdateAllEv();
 __ZN14ParticleSystem12EndUpdateAllEv();
 return;
}

function __Z29setPxSceneDescSolverBatchSizePN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 132 >> 2] = i1;
 return;
}

function __Z28setPxSceneLimitsMaxNbRegionsPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 24 >> 2] = i1;
 return;
}

function __Z28LocationService_CUSTOM_StartP12Il2CppObjectff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 return;
}

function __Z26scripting_method_get_class21ScriptingMethodIl2Cpp(i1) {
 i1 = i1 | 0;
 return _il2cpp_method_get_class(HEAP32[i1 >> 2] | 0) | 0;
}

function __Z26GUI_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) + 60 >> 2] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function __Z26GUI_Set_Custom_PropChangedh(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) + 64 >> 2] = i1 << 24 >> 24 != 0 & 1;
 return;
}

function _UNITY_png_set_flush(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 472 >> 2] = (i2 | 0) < 0 ? 0 : i2;
 return;
}

function _UNITY_png_get_mem_ptr(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 604 >> 2] | 0;
 return i1 | 0;
}

function _glSamplerParameteri__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glSamplerParameteri(i1 | 0, i2 | 0, i3 | 0);
}

function _glProgramParameteri__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glProgramParameteri(i1 | 0, i2 | 0, i3 | 0);
}

function _glGetVertexAttribiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetVertexAttribiv(i1 | 0, i2 | 0, i3 | 0);
}

function _glGetTexParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetTexParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glVertexAttribDivisor__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glVertexAttribDivisor(i1 | 0, i2 | 0);
}

function _emscripten_glStencilMaskSeparate__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glStencilMaskSeparate(i1 | 0, i2 | 0);
}

function _emscripten_glPolygonOffset__wrapper(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 _emscripten_glPolygonOffset(+f1, +f2);
}

function _emscripten_glDeleteRenderbuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDeleteRenderbuffers(i1 | 0, i2 | 0);
}

function __ZThn8_N12_GLOBAL__N_117ConnectionManagerD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i1 + -8 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 504 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 260 >> 2] | 0;
}

function __ZThn4_N12_GLOBAL__N_117ConnectionManagerD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i1 + -4 | 0);
 return;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 16 >> 2] & 4 | 0) == 0 ? 4 : 7) | 0;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv(i1) {
 i1 = i1 | 0;
 return i1 + 184 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv(i1) {
 i1 = i1 | 0;
 return i1 + 184 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 160 >> 2]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 460 >> 2]);
}

function __ZNK5physx3Ext13DistanceJoint10getDampingEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 80 >> 2] | 0) + 88 >> 2]);
}

function __ZNK5physx27PxClothGeodesicTetherCooker15getCookerStatusEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 >> 2] | 0) + 80 >> 2] | 0;
}

function __ZNK5physx10PxsContext27getCCDContactModifyCallbackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 84 >> 2] | 0;
}

function __ZNK26LegacyTreeInstanceRenderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 276 >> 2] | 0) + 12 >> 2] | 0;
}

function __ZNK24TreeIntermediateRenderer12GetLayerMaskEv(i1) {
 i1 = i1 | 0;
 return 1 << HEAP32[(HEAP32[i1 + 268 >> 2] | 0) + 132 >> 2] | 0;
}

function __ZNK22GenericPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK14ParticleSystem18GetSimulationSpeedEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 36 >> 2] | 0) + 268 >> 2]);
}

function __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75528 + (i2 << 2) >> 2] | 0;
}

function __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2ERKS_(i1, i2);
 return;
}

function __ZN7b2World18SetContactListenerEP17b2ContactListener(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 102944 >> 2] = i2;
 return;
}

function __ZN6b2Draw11AppendFlagsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | i2;
 return;
}

function __ZN6b2Draw10ClearFlagsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] & ~i2;
 return;
}

function __ZN5physx9NpFactory17registerParticlesEv() {
 HEAP32[gb + 1457352 >> 2] = fb + 830;
 HEAP32[gb + 1457348 >> 2] = fb + 831;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 540 >> 2] = HEAP32[i1 + 532 >> 2];
 return;
}

function __ZN5physx3Ext20DefaultCpuDispatcher14setRunProfiledEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 33 >> 0] = i1 & 1;
 return;
}

function __ZN5physx3Cct17CapsuleController7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10Controller15releaseInternalEv(i1 + 8 | 0);
 return;
}

function __ZN5physx2Sq10AABBPruner5purgeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sq10AABBPruner7releaseEv(i1);
 HEAP8[i1 + 7809 >> 0] = 1;
 return;
}

function __ZN5physx2Sc5Scene15getRenderBufferEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) + 5924 | 0;
}

function __ZN5physx2Sc18ParticleSystemCore10setDampingEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 96 >> 2] = f1;
 return;
}

function __ZN5Unity17ConfigurableJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5Umbra15ShadowCullerExtC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Umbra15ShadowCullerExtaSERKS0_(i1, i2) | 0;
 return;
}

function __ZN5Umbra15OcclusionBufferC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Umbra15OcclusionBufferaSERKS0_(i1, i2) | 0;
 return;
}

function __ZN4File19GetCurrentDirectoryEv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem16CurrentDirectoryEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function __ZN26AnimatorControllerPlayable12SetPlayStateE9PlayState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN22BaseUnityConnectClient6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 284 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN22AnimationMixerPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 36 >> 2] | 0;
}

function __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19MemoryProfilerStats18ResetGCAllocationsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 116 >> 2] = 0;
 return;
}

function __ZN17AudioCustomFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 170700 + 8;
 __ZN17AudioCustomFilter7CleanupEv(i1);
 return;
}

function __ZN13UnityProfiler17AddFramesFromFileENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceGLES22ReleaseThreadOwnershipEv(i1) {
 i1 = i1 | 0;
 __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(i1 + 4620 | 0, 0);
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_117ConnectionManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine9Animation15IsPPtrAnimationERKNS0_14GenericBindingE(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 15 >> 0] | 0) != 0 | 0;
}

function __Z50getPxVehicleWheels4SimData_RecipTireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE(i1) {
 i1 = i1 | 0;
 return i1 + 848 | 0;
}

function __Z46Physics2D_Get_Custom_PropAngularSleepTolerancev() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 88 >> 2]);
}

function __Z44getPxSimulationStatisticsNbActiveConstraintsPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z44SystemInfo_Get_Custom_PropGraphicsMemorySizev() {
 return ~~Math_fround(HEAPF32[(__Z15GetGraphicsCapsv() | 0) + 100 >> 2]) | 0;
}

function __Z43Register_UnityEngine_GL_LoadPixelMatrixArgsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535507 | 0, fb + 1 | 0);
 return;
}

function __Z43Register_UnityEngine_Avatar_SetMuscleMinMaxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929080 | 0, fb + 3 | 0);
 return;
}

function __Z42Register_UnityEngine_Time_get_unscaledTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576646 | 0, fb + 22 | 0);
 return;
}

function __Z42Register_UnityEngine_TerrainData_GetHeightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938881 | 0, fb + 25 | 0);
 return;
}

function __Z42Register_UnityEngine_LocationService_Startv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537413 | 0, fb + 14 | 0);
 return;
}

function __Z42Register_UnityEngine_Debug_OpenConsoleFilev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511831 | 0, fb + 92 | 0);
 return;
}

function __Z42Register_UnityEngine_Camera_get_allCamerasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507171 | 0, fb + 99 | 0);
 return;
}

function __Z42Register_UnityEngine_Caching_get_spaceUsedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502414 | 0, fb + 91 | 0);
 return;
}

function __Z42Register_UnityEngine_Caching_get_spaceFreev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502198 | 0, fb + 87 | 0);
 return;
}

function __Z41Register_UnityEngine_Texture2DArray_Applyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573575 | 0, fb + 678 | 0);
 return;
}

function __Z41Register_UnityEngine_Terrain_SetNeighborsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 943807 | 0, fb + 159 | 0);
 return;
}

function __Z41Register_UnityEngine_Screen_SetResolutionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534364 | 0, fb + 238 | 0);
 return;
}

function __Z41Register_UnityEngine_Rigidbody2D_set_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813786 | 0, fb + 460 | 0);
 return;
}

function __Z41Register_UnityEngine_Rigidbody2D_set_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814174 | 0, fb + 462 | 0);
 return;
}

function __Z41Register_UnityEngine_Rigidbody2D_get_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 813752 | 0, fb + 528 | 0);
 return;
}

function __Z41Register_UnityEngine_Rigidbody2D_get_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814140 | 0, fb + 530 | 0);
 return;
}

function __Z41Register_UnityEngine_Physics2D_IsTouchingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 811346 | 0, fb + 890 | 0);
 return;
}

function __Z41Register_UnityEngine_Object_DestroyObjectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580094 | 0, fb + 204 | 0);
 return;
}

function __Z41Register_UnityEngine_Material_HasPropertyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566345 | 0, fb + 678 | 0);
 return;
}

function __Z41Register_UnityEngine_Material_GetPassNamev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566538 | 0, fb + 680 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_set_shadowBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541596 | 0, fb + 187 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_set_cookieSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542106 | 0, fb + 194 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_get_shadowBiasv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541562 | 0, fb + 238 | 0);
 return;
}

function __Z41Register_UnityEngine_Light_get_cookieSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542072 | 0, fb + 245 | 0);
 return;
}

function __Z41Register_UnityEngine_Joint_set_breakForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788246 | 0, fb + 431 | 0);
 return;
}

function __Z41Register_UnityEngine_Joint_get_breakForcev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 788212 | 0, fb + 498 | 0);
 return;
}

function __Z41Register_UnityEngine_Input_get_touchCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538945 | 0, fb + 173 | 0);
 return;
}

function __Z41Register_UnityEngine_Input_get_anyKeyDownv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538689 | 0, fb + 170 | 0);
 return;
}

function __Z41Register_UnityEngine_Input_ResetInputAxesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538398 | 0, fb + 111 | 0);
 return;
}

function __Z41Register_UnityEngine_HingeJoint_get_anglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 789130 | 0, fb + 501 | 0);
 return;
}

function __Z41Register_UnityEngine_GL_get_invertCullingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536007 | 0, fb + 162 | 0);
 return;
}

function __Z41Register_UnityEngine_Cursor_get_lockStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511306 | 0, fb + 103 | 0);
 return;
}

function __Z41Register_UnityEngine_ComputeShader_SetIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 509344 | 0, fb + 574 | 0);
 return;
}

function __Z41Register_UnityEngine_Component_CompareTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508964 | 0, fb + 625 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_set_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886526 | 0, fb + 601 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioSource_get_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886492 | 0, fb + 692 | 0);
 return;
}

function __Z41Register_UnityEngine_AudioClip_get_lengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885443 | 0, fb + 689 | 0);
 return;
}

function __Z41Register_UnityEngine_AssetBundle_Containsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496506 | 0, fb + 615 | 0);
 return;
}

function __Z41Register_UnityEngine_Animator_ResolveHashv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924480 | 0, fb + 977 | 0);
 return;
}

function __Z41Register_UnityEngine_Animation_PlayQueuedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916892 | 0, fb + 170 | 0);
 return;
}

function __Z40getPxSceneDescContactCorrelationDistancePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 88 >> 2]);
}

function __Z40Register_UnityEngine_WWW_get_assetBundlev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581218 | 0, fb + 1949 | 0);
 return;
}

function __Z40Register_UnityEngine_TrailRenderer_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 529288 | 0, fb + 3552 | 0);
 return;
}

function __Z40Register_UnityEngine_Texture3D_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573227 | 0, fb + 1899 | 0);
 return;
}

function __Z40Register_UnityEngine_TextAsset_get_bytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 570104 | 0, fb + 1885 | 0);
 return;
}

function __Z40Register_UnityEngine_TerrainData_AddUserv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938345 | 0, fb + 4157 | 0);
 return;
}

function __Z40Register_UnityEngine_TerrainData_AddTreev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 941390 | 0, fb + 4175 | 0);
 return;
}

function __Z40Register_UnityEngine_Sprite_get_verticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569316 | 0, fb + 1878 | 0);
 return;
}

function __Z40Register_UnityEngine_Skybox_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528089 | 0, fb + 2906 | 0);
 return;
}

function __Z40Register_UnityEngine_Skybox_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 528056 | 0, fb + 1714 | 0);
 return;
}

function __Z40Register_UnityEngine_Shader_PropertyToIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565022 | 0, fb + 1859 | 0);
 return;
}

function __Z40Register_UnityEngine_Shader_GetGlobalIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 564523 | 0, fb + 1854 | 0);
 return;
}

function __Z40Register_UnityEngine_Rigidbody2D_IsAwakev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814886 | 0, fb + 2331 | 0);
 return;
}

function __Z40Register_UnityEngine_RectOffset_set_leftv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513809 | 0, fb + 2828 | 0);
 return;
}

function __Z40Register_UnityEngine_RectOffset_get_leftv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513776 | 0, fb + 1655 | 0);
 return;
}

function __Z40Register_UnityEngine_Mesh_get_isReadablev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547479 | 0, fb + 1787 | 0);
 return;
}

function __Z40Register_UnityEngine_Mesh_UploadMeshDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549040 | 0, fb + 3006 | 0);
 return;
}

function __Z40Register_UnityEngine_MeshFilter_set_meshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523717 | 0, fb + 2859 | 0);
 return;
}

function __Z40Register_UnityEngine_MeshFilter_get_meshv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 523684 | 0, fb + 1679 | 0);
 return;
}

function __Z40Register_UnityEngine_Material_set_shaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565125 | 0, fb + 3083 | 0);
 return;
}

function __Z40Register_UnityEngine_Material_get_shaderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565092 | 0, fb + 1860 | 0);
 return;
}

function __Z40Register_UnityEngine_LensFlare_set_flarev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524764 | 0, fb + 2870 | 0);
 return;
}

function __Z40Register_UnityEngine_LensFlare_get_flarev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 524731 | 0, fb + 1687 | 0);
 return;
}

function __Z40Register_UnityEngine_Input_GetKeyDownIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537914 | 0, fb + 1744 | 0);
 return;
}

function __Z40Register_UnityEngine_Input_GetButtonDownv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538190 | 0, fb + 1747 | 0);
 return;
}

function __Z40Register_UnityEngine_GUIText_set_tabSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008978 | 0, fb + 685 | 0);
 return;
}

function __Z40Register_UnityEngine_GUIText_get_tabSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008945 | 0, fb + 784 | 0);
 return;
}

function __Z40Register_UnityEngine_GUIClip_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025716 | 0, fb + 290 | 0);
 return;
}

function __Z40Register_UnityEngine_GL_IssuePluginEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536242 | 0, fb + 3587 | 0);
 return;
}

function __Z40Register_UnityEngine_Event_GetEventCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020229 | 0, fb + 271 | 0);
 return;
}

function __Z40Register_UnityEngine_Cubemap_SmoothEdgesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573194 | 0, fb + 3119 | 0);
 return;
}

function __Z40Register_UnityEngine_Compass_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537713 | 0, fb + 2950 | 0);
 return;
}

function __Z40Register_UnityEngine_Compass_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537680 | 0, fb + 1739 | 0);
 return;
}

function __Z40Register_UnityEngine_Camera_SetupCurrentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507715 | 0, fb + 3483 | 0);
 return;
}

function __Z40Register_UnityEngine_Caching_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502564 | 0, fb + 3471 | 0);
 return;
}

function __Z40Register_UnityEngine_Application_OpenURLv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 494877 | 0, fb + 3459 | 0);
 return;
}

function __Z40Register_UnityEngine_Application_HasARGVv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493920 | 0, fb + 1583 | 0);
 return;
}

function __Z40Register_UnityEngine_Animator_set_avatarv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923310 | 0, fb + 4139 | 0);
 return;
}

function __Z40Register_UnityEngine_Animator_get_avatarv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923277 | 0, fb + 2569 | 0);
 return;
}

function __Z40Register_UnityEngine_AnimationCurve_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546832 | 0, fb + 2996 | 0);
 return;
}

function __Z39getPxSimulationStatisticsNbStaticBodiesPKN5physx22PxSimulationStatisticsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __Z39Register_UnityEngine_TextGenerator_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010702 | 0, fb + 3866 | 0);
 return;
}

function __Z39Register_UnityEngine_JsonUtility_ToJsonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1037031 | 0, fb + 1116 | 0);
 return;
}

function __Z39Register_UnityEngine_GUIText_set_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008839 | 0, fb + 4214 | 0);
 return;
}

function __Z39Register_UnityEngine_GUIText_get_anchorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008807 | 0, fb + 2654 | 0);
 return;
}

function __Z39Register_UnityEngine_GUIStyleState_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021799 | 0, fb + 3897 | 0);
 return;
}

function __Z39Register_UnityEngine_Font_set_fontNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010395 | 0, fb + 4231 | 0);
 return;
}

function __Z39Register_UnityEngine_Font_get_fontNamesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010363 | 0, fb + 2666 | 0);
 return;
}

function __Z39Register_UnityEngine_Event_Internal_Usev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020169 | 0, fb + 3879 | 0);
 return;
}

function __Z33getPxVehicleWheelData_RecipRadiusPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 36 >> 2]);
}

function __Z33getPxVehicleWheelDataMDampingRatePKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 16 >> 2]);
}

function __Z32getPxVehicleGearsDataMSwitchTimePKN5physx18PxVehicleGearsDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 136 >> 2]);
}

function __Z32getPxVehicleGearsDataMFinalRatioPKN5physx18PxVehicleGearsDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 128 >> 2]);
}

function __Z31getPxVehicleEngineData_RecipMOIPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 104 >> 2]);
}

function __Z22DelayedDestroyCallbackP6ObjectPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z22DestroyObjectHighLevelP6Objectb(i1, 0);
 return 0;
}

function __Z21GetUserAppCacheFolderv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem21GetUserAppCacheFolderEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function _UNITY_png_set_text_compression_method(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 308 >> 2] = i2;
 return;
}

function _UNITY_png_get_io_ptr(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + 184 >> 2] | 0;
 return i1 | 0;
}

function ___fwriting(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] & 4)) i1 = (HEAP32[i1 + 16 >> 2] | 0) != 0; else i1 = 1;
 return i1 & 1 | 0;
}

function __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + -8 + 12 | 0);
 return;
}

function __ZNSt3__218shared_timed_mutex13unlock_sharedEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__219__shared_mutex_base13unlock_sharedEv(i1);
 return;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv(i1) {
 i1 = i1 | 0;
 return i1 + 472 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv(i1) {
 i1 = i1 | 0;
 return i1 + 472 | 0;
}

function __ZNK8VRDevice25GetStereoscopicBackbufferEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 262 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5Unity10HingeJoint14CanWriteSpringEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[(HEAP32[i1 + 32 >> 2] | 0) + 4 >> 1] | 0) == 261 | 0;
}

function __ZNK5Umbra10Visibility19getOutputObjectMaskEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 24 >> 2] | 0;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 + -4 | 0;
}

function __ZNK17FileSystemHandler9IsSymLinkERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZNK14ParticleSystem17GetAutoRandomSeedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 276 >> 0] | 0) != 0 | 0;
}

function __ZNK14ParticleSystem16GetStartRotationEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 2092 >> 2]);
}

function __ZNK13TranslateGLES13BlendEquationE7BlendOp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75208 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES11BlendFactorE9BlendMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75164 + (i2 << 2) >> 2] | 0;
}

function __ZNK12b2MouseJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(f2 * Math_fround(0.0));
}

function __ZN9Texture2D21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 __ZN9Texture2D34CreateFileTextureUploadInstructionEv(i1) | 0;
 return;
}

function __ZN9GfxDevice16BeginBufferWriteEP9GfxBufferjj(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN9BehaviourD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN6SocketD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65564 + 8;
 _close(HEAP32[i1 + 4 >> 2] | 0) | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Scb5Scene18removeShapeFromPvdERNS0_5ShapeERNS_7PxActorE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc8BodyCore25invalidateKinematicTargetEv(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[i1 + 156 >> 2] | 0) + 28 >> 0] = 0;
 return;
}

function __ZN5physx11PxHitBufferINS_10PxSweepHitEE14processTouchesEPKS1_j(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN4Mesh25RebuildCollisionTrianglesEv(i1) {
 i1 = i1 | 0;
 __ZN17CollisionMeshData20VertexDataHasChangedEv(i1 + 204 | 0);
 return;
}

function __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation11GetProgressEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZN22UnityAnalyticsSettings22SetInitializeOnStartupEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 9 >> 0] = i2 & 1;
 return;
}

function __ZN21AnimationClipPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 28 >> 2] | 0;
}

function __ZN20UnityConnectSettings18InitializeDefaultsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 196 >> 0] = 0;
 HEAP8[i1 + 197 >> 0] = 0;
 return;
}

function __ZN18ProfilerConnection34HandleEndInstrumentFunctionMessageEPKvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN18MultiFrameGUIStateC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN17Physics2DSettings26SetQueriesStartInCollidersEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 93 >> 0] = i2 & 1;
 return;
}

function __ZN14DetailDatabase17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __Z19DestroySingleObjectP6Object(HEAP32[i1 + 56 >> 2] | 0);
 return;
}

function __ZN12MeshCollider13DidDeleteMeshEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 152 >> 2] | 0, i1 | 0);
 return;
}

function __ZN12HandlerChain9SetLengthER13FileEntryDatay(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN11dtPathQueue5clearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 HEAP32[i1 + 224 >> 2] = 0;
 return;
}

function __ZN10AtomicList4LoadERi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = HEAP32[i1 + 4 >> 2];
 return HEAP32[i1 >> 2] | 0;
}

function __Z57RenderSettings_Get_Custom_PropDefaultReflectionResolutionv() {
 return HEAP32[(__Z17GetRenderSettingsv() | 0) + 372 >> 2] | 0;
}

function __Z48SystemInfo_Get_Custom_PropSupportsSparseTexturesv() {
 return (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 524 >> 2] | 0) != 0 | 0;
}

function __Z45Physics2D_Get_Custom_PropMaxAngularCorrectionv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 56 >> 2]);
}

function __Z45Physics2D_Get_Custom_PropLinearSleepTolerancev() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 84 >> 2]);
}

function __Z42Register_UnityEngine_Rigidbody2D_AddTorquev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 815664 | 0, fb + 7 | 0);
 return;
}

function __Z42Register_UnityEngine_Compass_get_timestampv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537645 | 0, fb + 8 | 0);
 return;
}

function __Z42Register_UnityEngine_AnimationCurve_AddKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546261 | 0, fb + 1 | 0);
 return;
}

function __Z41Register_UnityEngine_RenderSettings_Resetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 520764 | 0, fb + 98 | 0);
 return;
}

function __Z41Register_UnityEngine_PlayerPrefs_GetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552843 | 0, fb + 13 | 0);
 return;
}

function __Z41Register_UnityEngine_MonoBehaviour_Invokev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549314 | 0, fb + 43 | 0);
 return;
}

function __Z41Register_UnityEngine_Avatar_GetAxisLengthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929149 | 0, fb + 43 | 0);
 return;
}

function __Z40getPxHeightFieldGeometryHeightFieldFlagsPKN5physx21PxHeightFieldGeometryE(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 20 >> 0] | 0;
}

function __Z40Register_UnityEngine_WindZone_set_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581500 | 0, fb + 205 | 0);
 return;
}

function __Z40Register_UnityEngine_WindZone_get_radiusv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581467 | 0, fb + 262 | 0);
 return;
}

function __Z40Register_UnityEngine_Transform_SetParentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578153 | 0, fb + 683 | 0);
 return;
}

function __Z40Register_UnityEngine_Transform_IsChildOfv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579083 | 0, fb + 688 | 0);
 return;
}

function __Z40Register_UnityEngine_Time_get_frameCountv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577069 | 0, fb + 217 | 0);
 return;
}

function __Z40Register_UnityEngine_Texture3D_SetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573328 | 0, fb + 675 | 0);
 return;
}

function __Z40Register_UnityEngine_Texture3D_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573260 | 0, fb + 685 | 0);
 return;
}

function __Z40Register_UnityEngine_Texture2D_LoadImagev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572363 | 0, fb + 368 | 0);
 return;
}

function __Z40Register_UnityEngine_Texture2D_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572543 | 0, fb + 134 | 0);
 return;
}

function __Z40Register_UnityEngine_TerrainData_HasUserv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 938312 | 0, fb + 997 | 0);
 return;
}

function __Z40Register_UnityEngine_Resources_LoadAsyncv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560580 | 0, fb + 670 | 0);
 return;
}

function __Z40Register_UnityEngine_Mesh_SetIndicesImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548074 | 0, fb + 171 | 0);
 return;
}

function __Z40Register_UnityEngine_Mesh_GetIndicesImplv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548006 | 0, fb + 653 | 0);
 return;
}

function __Z40Register_UnityEngine_Material_SetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565248 | 0, fb + 648 | 0);
 return;
}

function __Z40Register_UnityEngine_Material_GetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565281 | 0, fb + 673 | 0);
 return;
}

function __Z40Register_UnityEngine_Light_set_spotAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542039 | 0, fb + 193 | 0);
 return;
}

function __Z40Register_UnityEngine_Light_set_intensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541141 | 0, fb + 184 | 0);
 return;
}

function __Z40Register_UnityEngine_Light_get_spotAnglev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542006 | 0, fb + 244 | 0);
 return;
}

function __Z40Register_UnityEngine_Light_get_intensityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541108 | 0, fb + 235 | 0);
 return;
}

function __Z40Register_UnityEngine_AssetBundle_LoadAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496605 | 0, fb + 616 | 0);
 return;
}

function __Z40Register_UnityEngine_Animation_IsPlayingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916730 | 0, fb + 955 | 0);
 return;
}

function __Z40Register_UnityEngine_AndroidJNI_ThrowNewv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591617 | 0, fb + 778 | 0);
 return;
}

function __Z40GUIUtility_CUSTOM_Internal_GetHotControlv() {
 return HEAP32[(HEAP32[(__Z11GetGUIStatev() | 0) + 276 >> 2] | 0) + 4 >> 2] | 0;
}

function __Z39Register_UnityEngine_Transform_get_rootv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 578741 | 0, fb + 1926 | 0);
 return;
}

function __Z39Register_UnityEngine_TextAsset_get_textv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 570072 | 0, fb + 1884 | 0);
 return;
}

function __Z39Register_UnityEngine_Sprite_get_texturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 568952 | 0, fb + 1873 | 0);
 return;
}

function __Z39Register_UnityEngine_Shader_FindBuiltinv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563598 | 0, fb + 1848 | 0);
 return;
}

function __Z39Register_UnityEngine_Rigidbody2D_WakeUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814950 | 0, fb + 3752 | 0);
 return;
}

function __Z39Register_UnityEngine_RectOffset_set_topv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513942 | 0, fb + 2830 | 0);
 return;
}

function __Z39Register_UnityEngine_RectOffset_get_topv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513910 | 0, fb + 1657 | 0);
 return;
}

function __Z39Register_UnityEngine_RectOffset_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513744 | 0, fb + 3500 | 0);
 return;
}

function __Z39Register_UnityEngine_PlayerPrefs_HasKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552912 | 0, fb + 1810 | 0);
 return;
}

function __Z39Register_UnityEngine_Mesh_set_bindposesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548978 | 0, fb + 3005 | 0);
 return;
}

function __Z39Register_UnityEngine_Mesh_get_canAccessv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547512 | 0, fb + 1788 | 0);
 return;
}

function __Z39Register_UnityEngine_Mesh_get_bindposesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548946 | 0, fb + 1795 | 0);
 return;
}

function __Z39Register_UnityEngine_Mathf_IsPowerOfTwov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546029 | 0, fb + 1781 | 0);
 return;
}

function __Z39Register_UnityEngine_Input_GetKeyStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537817 | 0, fb + 1741 | 0);
 return;
}

function __Z39Register_UnityEngine_GameObject_set_tagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515691 | 0, fb + 2843 | 0);
 return;
}

function __Z39Register_UnityEngine_GameObject_get_tagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 515659 | 0, fb + 1671 | 0);
 return;
}

function __Z39Register_UnityEngine_GL_ClearWithSkyboxv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536156 | 0, fb + 2938 | 0);
 return;
}

function __Z39Register_UnityEngine_Event_set_pressurev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019756 | 0, fb + 696 | 0);
 return;
}

function __Z39Register_UnityEngine_Event_get_pressurev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019724 | 0, fb + 795 | 0);
 return;
}

function __Z39Register_UnityEngine_Cursor_set_visiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511274 | 0, fb + 3489 | 0);
 return;
}

function __Z39Register_UnityEngine_Cubemap_get_formatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573125 | 0, fb + 1898 | 0);
 return;
}

function __Z39Register_UnityEngine_Cloth_get_verticesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840777 | 0, fb + 2434 | 0);
 return;
}

function __Z39Register_UnityEngine_Avatar_get_isValidv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929016 | 0, fb + 2583 | 0);
 return;
}

function __Z39Register_UnityEngine_Avatar_get_isHumanv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929048 | 0, fb + 2584 | 0);
 return;
}

function __Z39Register_UnityEngine_AssetBundle_Unloadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496850 | 0, fb + 2760 | 0);
 return;
}

function __Z39Register_UnityEngine_Animation_set_clipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916281 | 0, fb + 4095 | 0);
 return;
}

function __Z39Register_UnityEngine_Animation_get_clipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916249 | 0, fb + 2533 | 0);
 return;
}

function __Z38Register_UnityEngine_TextMesh_set_textv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009328 | 0, fb + 4220 | 0);
 return;
}

function __Z38Register_UnityEngine_TextMesh_set_fontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009390 | 0, fb + 4221 | 0);
 return;
}

function __Z38Register_UnityEngine_TextMesh_get_textv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009297 | 0, fb + 2658 | 0);
 return;
}

function __Z38Register_UnityEngine_TextMesh_get_fontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1009359 | 0, fb + 2659 | 0);
 return;
}

function __Z38Register_UnityEngine_GUIStyle_set_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022251 | 0, fb + 4286 | 0);
 return;
}

function __Z38Register_UnityEngine_GUIStyle_get_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022220 | 0, fb + 2720 | 0);
 return;
}

function __Z38Register_UnityEngine_GUIStyle_InitCopyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022159 | 0, fb + 4285 | 0);
 return;
}

function __Z38Register_UnityEngine_Font_set_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010301 | 0, fb + 4230 | 0);
 return;
}

function __Z38Register_UnityEngine_Font_get_materialv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010270 | 0, fb + 2665 | 0);
 return;
}

function __Z38Register_UnityEngine_Font_get_fontSizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010671 | 0, fb + 2671 | 0);
 return;
}

function __Z38Register_UnityEngine_Font_HasCharacterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010332 | 0, fb + 1102 | 0);
 return;
}

function __Z38Register_UnityEngine_Event_set_keyCodev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020023 | 0, fb + 4278 | 0);
 return;
}

function __Z38Register_UnityEngine_Event_get_rawTypev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019272 | 0, fb + 2708 | 0);
 return;
}

function __Z38Register_UnityEngine_Event_get_keyCodev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019992 | 0, fb + 2715 | 0);
 return;
}

function __Z37SystemInfo_Get_Custom_PropDeviceModelv() {
 return __Z20scripting_string_newPKc(__ZN10systeminfo14GetDeviceModelEv() | 0) | 0;
}

function __Z31getPxVehicleEngineDataMMaxOmegaPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 88 >> 2]);
}

function __Z31GUI_Get_Custom_PropBlitMaterialv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z18GetGUIBlitMaterialv() | 0) | 0;
}

function __Z27setPxSceneLimitsMaxNbBodiesPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z25setPxArticulationUserDataPN5physx14PxArticulationEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z25scripting_method_get_name21ScriptingMethodIl2Cpp(i1) {
 i1 = i1 | 0;
 return _il2cpp_method_get_name(HEAP32[i1 >> 2] | 0) | 0;
}

function _UNITY_png_set_text_compression_level(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 304 >> 2] = i2;
 return;
}

function _ps_hinter_done(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 112 >> 2] = 0;
 HEAP32[i1 + 140 >> 2] = 0;
 _ps_hints_done(i1 + 12 | 0);
 return;
}

function _glTexParameterf__wrapper(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 _glTexParameterf(i1 | 0, i2 | 0, +f3);
}

function _emscripten_glDeleteVertexArrays__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDeleteVertexArrays(i1 | 0, i2 | 0);
}

function _emscripten_glDeleteFramebuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDeleteFramebuffers(i1 | 0, i2 | 0);
}

function ___udivdi3(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return ___udivmoddi4(i1, i2, i3, i4, 0) | 0;
}

function ___freading(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] & 8)) i1 = (HEAP32[i1 + 8 >> 2] | 0) != 0; else i1 = 1;
 return i1 & 1 | 0;
}

function __ZThn8_NK5physx3Cct13BoxController21getHalfHeightInternalEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + -8 + 496 >> 2]);
}

function __ZThn4_NK5physx5cloth8SwSolver26getInterCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + -4 + 84 >> 2]);
}

function __ZThn24_N5physx2Sc20ArticulationJointSimD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc20ArticulationJointSimD0Ev(i1 + -24 | 0);
 return;
}

function __ZSt15get_new_handlerv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1477008 >> 2] | 0;
 HEAP32[gb + 1477008 >> 2] = i1 + 0;
 return i1 | 0;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv(i1) {
 i1 = i1 | 0;
 return i1 + 16 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv(i1) {
 i1 = i1 | 0;
 return i1 + 16 | 0;
}

function __ZNK5physx3Scb5Scene17getBroadPhaseTypeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene17getBroadPhaseTypeEv(i1 + 16 | 0) | 0;
}

function __ZNK5physx25PxClothSimpleTetherCooker15getCookerStatusEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 >> 2] | 0) + 24 >> 2] | 0;
}

function __ZNK5physx15NpParticleFluid2isENS_11PxActorType4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((i2 | 0) == 3 ? i1 : 0) | 0;
}

function __ZNK5Unity10HingeJoint13CanWriteMotorEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[(HEAP32[i1 + 32 >> 2] | 0) + 4 >> 1] | 0) != 261 | 0;
}

function __ZNK5Umbra16LineSegmentQuery12getObjectSetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 28 >> 2] | 0;
}

function __ZNK5Umbra10PortalInfo18getNumHullVerticesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 72 >> 2] | 0;
}

function __ZNK20LightPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 + -4 | 0;
}

function __ZNK17FileSystemHandler8IsHiddenERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZNK13TranslateGLES4WrapE15TextureWrapMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75504 + (i2 << 2) >> 2] | 0;
}

function __ZNK13TranslateGLES4FuncE15CompareFunction(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[gb + 75096 + (i2 << 2) >> 2] | 0;
}

function __ZN9GfxDevice18BeforePluginRenderEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx8debugger4comm23EndPropertyMessageGroup9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth18unlockParticleDataEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc9ClothCore18unlockParticleDataEv(i1 + 32 | 0);
 return;
}

function __ZN5physx7NpCloth18clearInterpolationEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc9ClothCore18clearInterpolationEv(i1 + 32 | 0);
 return;
}

function __ZN5physx14PxsAABBManager4initEPNS_13PxvBroadPhaseE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 49828 >> 2] = i1;
 return;
}

function __ZN5Unity5Joint10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5Unity5Joint7CleanupEv(i1);
 return;
}

function __ZN5Umbra10StackAlloc10deallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i2) return;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function __ZN4FMOD13ChannelGroupI10getDSPHeadEPPNS_3DSPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN30RuntimeInitializeOnLoadManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN30RuntimeInitializeOnLoadManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN23UnityPurchasingSettings18InitializeDefaultsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 return;
}

function __ZN21WorldParticleColliderD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 73348 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN20ExternalForcesModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAPF32[i1 + 8 >> 2] = Math_fround(1.0);
 return;
}

function __ZN19CloudServiceHandler6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 1148 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN18LoadSceneOperation23SetAllowSceneActivationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 468 >> 0] = i2 & 1;
 return;
}

function __ZN17b2ContactListener9PostSolveEP9b2ContactPK16b2ContactImpulse(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN17FileSystemHandler11HasFastHashERK13FileEntryDataR7Hash128(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem11HasFastHashERK13FileEntryDataR7Hash128(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN14NullGpuProgram15ApplyGpuProgramERK20GpuProgramParametersPKh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13ScreenManager28RegisterDidSwitchResolutionsEPFvvE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 return;
}

function __ZN13MemoryManager18LowLevelReallocateEPvjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _realloc(i1, i2) | 0;
}

function __ZN12_GLOBAL__N_116CollectionSorterD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_116CollectionSorterD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_111StreamOwner11getInStreamEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 20 >> 2] | 0) == 0 ? 0 : i1 + 4 | 0) | 0;
}

function __ZN10systeminfo20IsPlatformStandaloneE15RuntimePlatform(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 13 | (i1 + -1 | 0) >>> 0 < 2 | 0;
}

function __ZL18OrientationHandleriPK32EmscriptenDeviceOrientationEventPv(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 1;
}

function __Z46RenderSettings_Get_Custom_PropFogStartDistancev() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 336 >> 2]);
}

function __Z46RenderSettings_Get_Custom_PropAmbientIntensityv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 184 >> 2]);
}

function __Z44Physics2D_Get_Custom_PropMaxTranslationSpeedv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 60 >> 2]);
}

function __Z44Physics2D_Get_Custom_PropMaxLinearCorrectionv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 52 >> 2]);
}

function __Z41getPxVehicleClutchDataMEstimateIterationsPKN5physx19PxVehicleClutchDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z41PlayerConnection_Get_Custom_PropConnectedv() {
 return (HEAP32[(__ZN16PlayerConnection3GetEv() | 0) + 96 >> 2] | 0) != 0 | 0;
}

function __Z40Register_UnityEngine_Texture2D_SetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572250 | 0, fb + 28 | 0);
 return;
}

function __Z40Register_UnityEngine_Caching_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502531 | 0, fb + 93 | 0);
 return;
}

function __Z40Register_UnityEngine_Avatar_SetParameterv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 929116 | 0, fb + 79 | 0);
 return;
}

function __Z40Register_UnityEngine_Animator_SetFloatIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923457 | 0, fb + 75 | 0);
 return;
}

function __Z40Register_UnityEngine_Animator_GetFloatIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923527 | 0, fb + 39 | 0);
 return;
}

function __Z40Register_UnityEngine_Animation_CrossFadev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916791 | 0, fb + 10 | 0);
 return;
}

function __Z39Register_UnityEngine_Transform_GetChildv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579297 | 0, fb + 689 | 0);
 return;
}

function __Z39Register_UnityEngine_Rigidbody_set_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784906 | 0, fb + 424 | 0);
 return;
}

function __Z39Register_UnityEngine_Rigidbody_set_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784764 | 0, fb + 422 | 0);
 return;
}

function __Z39Register_UnityEngine_Rigidbody_get_massv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784874 | 0, fb + 492 | 0);
 return;
}

function __Z39Register_UnityEngine_Rigidbody_get_dragv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 784732 | 0, fb + 490 | 0);
 return;
}

function __Z39Register_UnityEngine_PlayerPrefs_GetIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 552811 | 0, fb + 664 | 0);
 return;
}

function __Z39Register_UnityEngine_Mesh_CombineMeshesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548846 | 0, fb + 240 | 0);
 return;
}

function __Z39Register_UnityEngine_GL_LoadPixelMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535475 | 0, fb + 104 | 0);
 return;
}

function __Z39Register_UnityEngine_GL_InvalidateStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536210 | 0, fb + 109 | 0);
 return;
}

function __Z39Register_UnityEngine_Cursor_get_visiblev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511242 | 0, fb + 102 | 0);
 return;
}

function __Z39Register_UnityEngine_CubemapArray_Applyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573889 | 0, fb + 679 | 0);
 return;
}

function __Z39Register_UnityEngine_Cloth_set_frictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840872 | 0, fb + 579 | 0);
 return;
}

function __Z39Register_UnityEngine_Cloth_get_frictionv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840840 | 0, fb + 668 | 0);
 return;
}

function __Z39Register_UnityEngine_Animator_set_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922143 | 0, fb + 666 | 0);
 return;
}

function __Z39Register_UnityEngine_Animator_get_speedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922111 | 0, fb + 762 | 0);
 return;
}

function __Z39Register_UnityEngine_Animator_SetBoolIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923596 | 0, fb + 939 | 0);
 return;
}

function __Z39Register_UnityEngine_Animator_GetBoolIDv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923664 | 0, fb + 972 | 0);
 return;
}

function __Z39Register_UnityEngine_Animation_GetStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 917153 | 0, fb + 957 | 0);
 return;
}

function __Z39Input_Set_Custom_PropImeCompositionModei(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z15GetInputManagerv() | 0) + 172 >> 2] = i1;
 return;
}

function __Z38Register_UnityEngine_WindZone_set_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581436 | 0, fb + 3161 | 0);
 return;
}

function __Z38Register_UnityEngine_WindZone_get_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581405 | 0, fb + 1950 | 0);
 return;
}

function __Z38Register_UnityEngine_Sprite_get_packedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569081 | 0, fb + 1875 | 0);
 return;
}

function __Z38Register_UnityEngine_Rigidbody2D_Sleepv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 814919 | 0, fb + 3751 | 0);
 return;
}

function __Z38Register_UnityEngine_Motion_get_legacyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 550048 | 0, fb + 1799 | 0);
 return;
}

function __Z38Register_UnityEngine_Light_set_shadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541283 | 0, fb + 2963 | 0);
 return;
}

function __Z38Register_UnityEngine_Light_get_shadowsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541252 | 0, fb + 1760 | 0);
 return;
}

function __Z38Register_UnityEngine_Light_get_isBakedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542478 | 0, fb + 1768 | 0);
 return;
}

function __Z38Register_UnityEngine_LODGroup_ForceLODv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540537 | 0, fb + 2959 | 0);
 return;
}

function __Z38Register_UnityEngine_Input_GetKeyUpIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537849 | 0, fb + 1742 | 0);
 return;
}

function __Z38Register_UnityEngine_Input_GetButtonUpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538223 | 0, fb + 1748 | 0);
 return;
}

function __Z38Register_UnityEngine_Gradient_set_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517296 | 0, fb + 2851 | 0);
 return;
}

function __Z38Register_UnityEngine_Gradient_get_modev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517265 | 0, fb + 1677 | 0);
 return;
}

function __Z38Register_UnityEngine_GUI_UnfocusWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021446 | 0, fb + 370 | 0);
 return;
}

function __Z38Register_UnityEngine_CullingGroup_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511124 | 0, fb + 3487 | 0);
 return;
}

function __Z38Register_UnityEngine_Cloth_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840746 | 0, fb + 3993 | 0);
 return;
}

function __Z38Register_UnityEngine_Cloth_get_normalsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840809 | 0, fb + 2435 | 0);
 return;
}

function __Z38Register_UnityEngine_Cloth_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840715 | 0, fb + 2433 | 0);
 return;
}

function __Z38Register_UnityEngine_Animator_GetStatsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923343 | 0, fb + 2570 | 0);
 return;
}

function __Z37getPxTriangleMeshGeometryTriangleMeshPKN5physx22PxTriangleMeshGeometryE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __Z37getNbPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z37Register_UnityEngine_GUI_FocusControlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021065 | 0, fb + 3891 | 0);
 return;
}

function __Z37Register_UnityEngine_GUIText_set_textv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008475 | 0, fb + 4208 | 0);
 return;
}

function __Z37Register_UnityEngine_GUIText_set_fontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008707 | 0, fb + 4212 | 0);
 return;
}

function __Z37Register_UnityEngine_GUIText_get_textv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008445 | 0, fb + 2650 | 0);
 return;
}

function __Z37Register_UnityEngine_GUIText_get_fontv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1008677 | 0, fb + 2652 | 0);
 return;
}

function __Z37Register_UnityEngine_GUIStyle_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022190 | 0, fb + 3900 | 0);
 return;
}

function __Z37Register_UnityEngine_Font_get_dynamicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010579 | 0, fb + 2668 | 0);
 return;
}

function __Z37Register_UnityEngine_Event_set_buttonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019628 | 0, fb + 4273 | 0);
 return;
}

function __Z37Register_UnityEngine_Event_get_buttonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019598 | 0, fb + 2710 | 0);
 return;
}

function __Z37GUIUtility_CUSTOM_ReleaseMouseControlv() {
 HEAP32[(HEAP32[(__Z11GetGUIStatev() | 0) + 276 >> 2] | 0) + 4 >> 2] = 0;
 return;
}

function __Z34Display_CUSTOM_RelativeMouseAtImpliiPiS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __Z26setPxSceneDescCcdMaxPassesPN5physx11PxSceneDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 148 >> 2] = i1;
 return;
}

function __Z26setPxHeightFieldDescNbRowsPN5physx17PxHeightFieldDescEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z20GetUserAppDataFolderv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem20GetUserAppDataFolderEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function __Z20GetApplicationFolderv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem20GetApplicationFolderEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function __Z17GetConsoleLogPathv() {
 var i1 = 0;
 i1 = HEAP32[gb + 1450760 >> 2] | 0;
 return ((i1 | 0) == 0 ? gb + 1576256 | 0 : i1) | 0;
}

function __Z15setsockopt_stubiiiPKvj(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return 0;
}

function _UNITY_png_set_compression_mem_level(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 296 >> 2] = i2;
 return;
}

function b101(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 nullFunc_iiiff(101);
 return 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 288 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth8SwSolver25getInterCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + -4 + 80 >> 2]);
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] | 0) >>> 1 & 2) + 2 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] | 0) >>> 1 & 2) + 2 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13get_allocatorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13get_allocatorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 92 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx7NpScene17getBroadPhaseTypeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx3Scb5Scene17getBroadPhaseTypeEv(i1 + 16 | 0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 484 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 156 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11getNbShapesEv(i1) {
 i1 = i1 | 0;
 return HEAPU16[i1 + 24 >> 1] | 0 | 0;
}

function __ZNK23LODTreeInstanceRenderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 276 >> 2] | 0) + 12 >> 2] | 0;
}

function __ZNK20LocalFileSystemPosix6ExistsERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_access(i2, 0) | 0) == 0 | 0;
}

function __ZNK14ParticleSystem25GetSafeCollisionEventSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 632 >> 2] | 0;
}

function __ZNK14ParticleSystem16GetStartLifeTimeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 88 >> 2]);
}

function __ZNK13Lz4Compressor18CompressStreamInitEPPv16CompressionLevel(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9GfxDevice34SetStencilRefWhenStencilWasSkippedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4376 >> 2] = i2;
 return;
}

function __ZN9GfxDevice17AfterPluginRenderEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 return;
}

function __ZN6Motion13AddObjectUserER8UserList(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8UserList7AddUserERS_(i1 + 32 | 0, i2);
 return;
}

function __ZN5physx6shdfnd10ThreadImpl10signalQuitEv(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd15atomicIncrementEPVi(i1 + 8 | 0) | 0;
 return;
}

function __ZN5physx2Sq12BucketPruner6commitEv(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv(i1 + 16 | 0);
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm17FreeListAllocator9getQWSizeEj(i1) {
 i1 = i1 | 0;
 i1 = (i1 + 19 | 0) >>> 4;
 return ((i1 | 0) == 0 ? 1 : i1) | 0;
}

function __ZN5physx23PxsSolverSetupSolveTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5physx21PxShapeRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx21PxClothRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx15NpParticleFluid2isENS_11PxActorType4EnumE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((i2 | 0) == 3 ? i1 : 0) | 0;
}

function __ZN5physx14PxVehicleDrive15computeByteSizeEj(i1) {
 i1 = i1 | 0;
 return __ZN5physx15PxVehicleWheels15computeByteSizeEj(i1) | 0;
}

function __ZN5Unity14CharacterJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5Umbra15ShadowCullerExtC2Ev(i1) {
 i1 = i1 | 0;
 __ZN5Umbra15ImpShadowCullerC2Ev((i1 | 0) == 0 ? 0 : i1 + 15 & -16);
 return;
}

function __ZN5Umbra11PatchWriterC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return;
}

function __ZN4FMOD13ChannelGroupI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN20LocalFileSystemPosix5TouchER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_utime(i2 | 0, 0) | 0) == 0 | 0;
}

function __ZN18ScriptingArguments12GetBooleanAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP8[i1 + (i2 << 3) >> 0] | 0) == 1 | 0;
}

function __ZN18PlatformEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18BuoyancyEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17FileSystemHandler8IsLockedERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN16ReflectionProbes15ReleaseRendererEP13ProbeRenderer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i2 + 16 >> 0] = 1;
 return;
}

function __ZN16MemoryFileSystem11HasFastHashERK13FileEntryDataR7Hash128(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN15ArchiveReadFileD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 70660 + 8;
 __ZN15ArchiveReadFile5CloseEv(i1) | 0;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper24clearPropertyMessageArgsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 100 >> 2] = 0;
 return;
}

function __Z42Physics2D_Get_Custom_PropContactArrowScalev() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 100 >> 2]);
}

function __Z41GUIUtility_CUSTOM_Internal_GetDefaultSkini(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z14GetDefaultSkini(i1) | 0) + 20 >> 2] | 0;
}

function __Z41GUIUtility_CUSTOM_Internal_GetBuiltinSkini(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z14GetBuiltinSkini(i1) | 0) + 20 >> 2] | 0;
}

function __Z40getPxParticleReadDataValidParticleBitmapPKN5physx18PxParticleReadDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __Z39Register_UnityEngine_Time_set_timeScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577037 | 0, fb + 19 | 0);
 return;
}

function __Z39Register_UnityEngine_Time_get_timeScalev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 577005 | 0, fb + 28 | 0);
 return;
}

function __Z39Register_UnityEngine_Time_get_fixedTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576614 | 0, fb + 21 | 0);
 return;
}

function __Z39Register_UnityEngine_Time_get_deltaTimev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576582 | 0, fb + 20 | 0);
 return;
}

function __Z39Register_UnityEngine_Camera_get_currentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507139 | 0, fb + 98 | 0);
 return;
}

function __Z39Register_UnityEngine_Caching_CleanCachev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501923 | 0, fb + 85 | 0);
 return;
}

function __Z39Register_UnityEngine_Application_Unloadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493085 | 0, fb + 88 | 0);
 return;
}

function __Z39Register_UnityEngine_Animator_SetTargetv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922315 | 0, fb + 73 | 0);
 return;
}

function __Z38Register_UnityEngine_Screen_get_heightv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534428 | 0, fb + 152 | 0);
 return;
}

function __Z38Register_UnityEngine_Resources_LoadAllv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560613 | 0, fb + 671 | 0);
 return;
}

function __Z38Register_UnityEngine_Mathf_HalfToFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546157 | 0, fb + 248 | 0);
 return;
}

function __Z38Register_UnityEngine_Material_FindPassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566572 | 0, fb + 681 | 0);
 return;
}

function __Z38Register_UnityEngine_LODGroup_set_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540143 | 0, fb + 183 | 0);
 return;
}

function __Z38Register_UnityEngine_LODGroup_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540112 | 0, fb + 234 | 0);
 return;
}

function __Z38Register_UnityEngine_Cubemap_SetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573030 | 0, fb + 243 | 0);
 return;
}

function __Z38Register_UnityEngine_Cubemap_GetPixelsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572999 | 0, fb + 370 | 0);
 return;
}

function __Z38Register_UnityEngine_Cloth_set_dampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840334 | 0, fb + 578 | 0);
 return;
}

function __Z38Register_UnityEngine_Cloth_get_dampingv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 840303 | 0, fb + 667 | 0);
 return;
}

function __Z38Register_UnityEngine_Camera_set_aspectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503968 | 0, fb + 162 | 0);
 return;
}

function __Z38Register_UnityEngine_Camera_get_aspectv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503937 | 0, fb + 210 | 0);
 return;
}

function __Z38Register_UnityEngine_Camera_IsFilteredv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508238 | 0, fb + 621 | 0);
 return;
}

function __Z38Register_UnityEngine_Caching_Authorizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 501892 | 0, fb + 132 | 0);
 return;
}

function __Z38Register_UnityEngine_AudioClip_SetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885894 | 0, fb + 433 | 0);
 return;
}

function __Z38Register_UnityEngine_AudioClip_GetDatav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 885863 | 0, fb + 432 | 0);
 return;
}

function __Z38Register_UnityEngine_Animator_HasStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 923211 | 0, fb + 437 | 0);
 return;
}

function __Z38Register_UnityEngine_Animation_AddClipv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916926 | 0, fb + 191 | 0);
 return;
}

function __Z37getPxSceneDescFrictionOffsetThresholdPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 96 >> 2]);
}

function __Z37getPxSceneDescBounceThresholdVelocityPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 92 >> 2]);
}

function __Z37Register_UnityEngine_Random_InitStatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554628 | 0, fb + 3627 | 0);
 return;
}

function __Z37Register_UnityEngine_Mesh_MarkDynamicv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 549010 | 0, fb + 3613 | 0);
 return;
}

function __Z37Register_UnityEngine_Light_set_cookiev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542170 | 0, fb + 2966 | 0);
 return;
}

function __Z37Register_UnityEngine_Light_get_cookiev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542140 | 0, fb + 1763 | 0);
 return;
}

function __Z37Register_UnityEngine_LODGroup_SetLODsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540507 | 0, fb + 2958 | 0);
 return;
}

function __Z37Register_UnityEngine_LODGroup_GetLODsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540477 | 0, fb + 1756 | 0);
 return;
}

function __Z37Register_UnityEngine_Gradient_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517046 | 0, fb + 3506 | 0);
 return;
}

function __Z37Register_UnityEngine_GL_set_wireframev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535917 | 0, fb + 3583 | 0);
 return;
}

function __Z37Register_UnityEngine_GL_set_sRGBWritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535977 | 0, fb + 3584 | 0);
 return;
}

function __Z37Register_UnityEngine_GL_BeginInternalv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535399 | 0, fb + 3577 | 0);
 return;
}

function __Z37Register_UnityEngine_AudioSource_Stopv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 887010 | 0, fb + 3791 | 0);
 return;
}

function __Z37Register_UnityEngine_AndroidJNI_Throwv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 591587 | 0, fb + 1952 | 0);
 return;
}

function __Z37HumanTrait_CUSTOM_GetMuscleDefaultMini(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZN10HumanTrait19GetMuscleDefaultMinEi(i1));
}

function __Z37HumanTrait_CUSTOM_GetMuscleDefaultMaxi(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZN10HumanTrait19GetMuscleDefaultMaxEi(i1));
}

function __Z36getNbPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z36SystemInfo_Get_Custom_PropDeviceNamev() {
 return __Z20scripting_string_newPKc(__ZN10systeminfo13GetDeviceNameEv() | 0) | 0;
}

function __Z36Register_UnityEngine_GUI_set_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020599 | 0, fb + 3887 | 0);
 return;
}

function __Z36Register_UnityEngine_GUI_set_changedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020541 | 0, fb + 3886 | 0);
 return;
}

function __Z36Register_UnityEngine_GUI_FocusWindowv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1021417 | 0, fb + 3895 | 0);
 return;
}

function __Z36Register_UnityEngine_Font_get_ascentv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1010609 | 0, fb + 2669 | 0);
 return;
}

function __Z33NavMeshPath_Get_Custom_PropStatusP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 8 >> 2] | 0) + 4 >> 2] | 0;
}

function __Z30getPxVehicleWheelData_RecipMOIPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 40 >> 2]);
}

function __Z30getPxVehicleWheelDataMToeAnglePKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __Z30getPxVehicleWheelDataMMaxSteerPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 28 >> 2]);
}

function __Z28getPxVehicleChassisDataMMassPKN5physx20PxVehicleChassisDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z27scripting_add_internal_callPKcPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_add_internal_call(i1 | 0, i2 | 0);
 return;
}

function __Z26scripting_profiler_installPvPFvS_E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _il2cpp_profiler_install(i1 | 0, i2 | 0);
 return;
}

function __Z14OrthoNormalizeR10Matrix3x3f(i1) {
 i1 = i1 | 0;
 __Z14OrthoNormalizeP8Vector3fS0_S0_(i1, i1 + 36 | 0, i1 + 72 | 0);
 return;
}

function _UNITY_LZ4_uncompress(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _UNITY_LZ4_decompress_fast(i1, i2, i3) | 0;
}

function b64(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_iiiiii(64);
 return 0;
}

function b135(i1, i2, i3, f4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 i5 = i5 | 0;
 nullFunc_viiifi(135);
}

function _strpbrk(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i2 = i1 + (_strcspn(i1, i2) | 0) | 0;
 return (HEAP8[i2 >> 0] | 0 ? i2 : 0) | 0;
}

function _mbrlen(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _mbrtowc(0, i1, i2, i3 | 0 ? i3 : gb + 1469736 | 0) | 0;
}

function _emscripten_glVertexAttrib1f__wrapper(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 _emscripten_glVertexAttrib1f(i1 | 0, +f2);
}

function _emscripten_glSampleCoverage__wrapper(f1, i2) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 _emscripten_glSampleCoverage(+f1, i2 | 0);
}

function _emscripten_glDepthRangef__wrapper(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 _emscripten_glDepthRangef(+f1, +f2);
}

function __ZThn80_NK26AnimatorControllerPlayable13IsInitializedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + -80 + 100 >> 2] | 0) != 0 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 488 >> 2] | 0;
}

function __ZThn12_N5physx3Ext7D6Joint11prepareDataEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx3Ext7D6Joint11prepareDataEv(i1 + -12 | 0) | 0;
}

function __ZNSt3__27codecvtIwc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__220__codecvt_utf8_utf16IwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 328 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 352 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 536 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore17getPxArticulationEv(i1) {
 i1 = i1 | 0;
 return i1 + (HEAP32[gb + 1097392 + 16 >> 2] | 0) | 0;
}

function __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11getNbShapesEv(i1) {
 i1 = i1 | 0;
 return HEAPU16[i1 + 24 >> 1] | 0 | 0;
}

function __ZNK5physx13NpClothFabric9getNbSetsEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc15ClothFabricCore9getNbSetsEv(i1 + 16 | 0) | 0;
}

function __ZNK5Umbra18ReceiverMaskBuffer18getCameraTransformEv(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 0 ? 0 : i1 + 1 & -2) + 32768 | 0;
}

function __ZNK5Umbra10Visibility17getOutputClustersEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] | 0;
}

function __ZNK5Umbra10PortalInfo17getNumGateIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 8 >> 2] | 0;
}

function __ZNK14ParticleSystem24GetCustomSimulationSpaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 288 >> 2] | 0;
}

function __ZNK14ParticleSystem14GetSecPositionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 40 >> 2] | 0) + 396 >> 2]);
}

function __ZNK14ParticleSystem14GetPlayOnAwakeEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 279 >> 0] | 0) != 0 | 0;
}

function __ZNK14ParticleSystem14GetLengthInSecEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 36 >> 2] | 0) + 264 >> 2]);
}

function __ZN9GfxDevice28SetComputeBufferCounterValueE15ComputeBufferIDj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9GfxDevice14AddSetPassStatEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 3708 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN8VRDevice20SetDeviceViewTextureEP13RenderTexture(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 304 >> 2] = i2;
 return;
}

function __ZN7b2World16SetContactFilterEP15b2ContactFilter(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 102940 >> 2] = i2;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 136 >> 2] | 0;
}

function __ZN5physx7profile15ZoneManagerImplD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7profile15ZoneManagerImplD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx3Ext20ProfileZoneInterface16handleEventAddedERKNS_18PxProfileEventNameE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Ext19ProfileEventHandlerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Ext19ProfileEventHandlerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Cct13BoxController7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10Controller15releaseInternalEv(i1 + 8 | 0);
 return;
}

function __ZN5physx2Sn13XmlNodeReader19getCurrentItemValueEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 4 >> 2] | 0;
}

function __ZN5physx2Sc9ClothCore16setContactOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 64 >> 2] = f1;
 return;
}

function __ZN5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23PxsBroadPhaseContextSapD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx23PxsBroadPhaseContextSapD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxVehicleDriveTank14setToRestStateEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive14setToRestStateEv(i1);
 return;
}

function __ZN5physx15NpActorTemplateINS_7PxClothEE7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 12 >> 2] = i1;
 return;
}

function __ZN5physx14NpRigidDynamic13switchToNoSimEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Scb4Body17switchBodyToNoSimEv(i1 + 48 | 0);
 return;
}

function __ZN4FMOD7SystemI28GetSystemFromNonSystemHandleEPv(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1459872 + (i1 >>> 28 << 2) >> 2] | 0;
}

function __ZN29AssetBundleLoadAssetOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN29AssetBundleLoadAssetOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18ProfilerConnectionC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[gb + 66280 >> 2];
 HEAP32[i1 + 4 >> 2] = -2;
 return;
}

function __ZN17SurfaceEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17Physics2DSettings23SetShowColliderContactsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 97 >> 0] = i2 & 1;
 return;
}

function __ZN17Physics2DSettings23SetChangeStopsCallbacksEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 94 >> 0] = i2 & 1;
 return;
}

function __ZN17GeneralConnection14NetworkMessage11SetDataSizeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN16LightmapSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 236 >> 2] = 25;
 __ZN10GISettings5ResetEv(i1 + 76 | 0);
 return;
}

function __ZN15DistanceJoint2D24SetAutoConfigureDistanceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 101 >> 0] = i2 & 1;
 return;
}

function __ZN13MemoryManager19GetAllocatorAtIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 1568 + (i2 << 2) >> 2] | 0;
}

function __ZN12_GLOBAL__N_16qAtan2Eff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(+Math_atan2(+f1, +f2));
}

function __ZN12_GLOBAL__N_115StringTableImplD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_115StringTableImplD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12MeshRenderer13DidModifyMeshEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 272 >> 0] = 1;
 __ZN8Renderer13BoundsChangedEv(i1);
 return;
}

function __ZN11UnityEngine15PlatformWrapper25GetDeviceUniqueIdentifierEv() {
 return __ZN10systeminfo25GetDeviceUniqueIdentifierEv() | 0;
}

function __ZN11UnityEngine15PlatformWrapper13IsDebugDeviceEv() {
 return (HEAP8[(__Z16GetBuildSettingsv() | 0) + 119 >> 0] | 0) != 0 | 0;
}

function __ZN11UmbraModule11GetTomeSizeEPKN5Umbra4TomeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return __ZNK5Umbra4Tome7getSizeEv(i2) | 0;
}

function __Z54Physics_Get_Custom_PropDefaultSolverVelocityIterationsv() {
 return HEAP32[(__Z17GetPhysicsManagerv() | 0) + 172 >> 2] | 0;
}

function __Z49SystemInfo_Get_Custom_PropSupportsLocationServicev() {
 return (__ZN10systeminfo23SupportsLocationServiceEv() | 0) & 1 | 0;
}

function __Z46SystemInfo_Get_Custom_PropSupportsImageEffectsv() {
 return (HEAP32[(__Z15GetGraphicsCapsv() | 0) + 488 >> 2] | 0) > 0 | 0;
}

function __Z44RenderSettings_Get_Custom_PropFogEndDistancev() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 340 >> 2]);
}

function __Z44RenderSettings_Get_Custom_PropFlareFadeSpeedv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 308 >> 2]);
}

function __Z42Physics2D_Get_Custom_PropVelocityThresholdv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 48 >> 2]);
}

function __Z42Physics2D_Get_Custom_PropBaumgarteTOIScalev() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 76 >> 2]);
}

function __Z39getPxClothParticleDataPreviousParticlesPKN5physx19PxClothParticleDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z39Register_UnityEngine_Animator_CrossFadev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922218 | 0, fb + 2 | 0);
 return;
}

function __Z38Register_UnityEngine_Mathf_PerlinNoisev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546095 | 0, fb + 10 | 0);
 return;
}

function __Z38Register_UnityEngine_Material_SetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565567 | 0, fb + 47 | 0);
 return;
}

function __Z38Register_UnityEngine_Material_GetFloatv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 565598 | 0, fb + 16 | 0);
 return;
}

function __Z38Register_UnityEngine_GL_MultiTexCoord2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535293 | 0, fb + 13 | 0);
 return;
}

function __Z38Register_UnityEngine_Caching_get_readyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502685 | 0, fb + 95 | 0);
 return;
}

function __Z38Register_UnityEngine_Caching_get_indexv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 502167 | 0, fb + 86 | 0);
 return;
}

function __Z37Register_UnityEngine_WWW_get_progressv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581090 | 0, fb + 260 | 0);
 return;
}

function __Z37Register_UnityEngine_Texture2D_Resizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572640 | 0, fb + 133 | 0);
 return;
}

function __Z37Register_UnityEngine_Screen_get_widthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534398 | 0, fb + 151 | 0);
 return;
}

function __Z37Register_UnityEngine_PlayerPrefs_Savev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 553014 | 0, fb + 115 | 0);
 return;
}

function __Z37Register_UnityEngine_Mesh_GetTopologyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548712 | 0, fb + 656 | 0);
 return;
}

function __Z37Register_UnityEngine_Material_SetPassv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566508 | 0, fb + 679 | 0);
 return;
}

function __Z37Register_UnityEngine_Input_get_anyKeyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538659 | 0, fb + 169 | 0);
 return;
}

function __Z37Register_UnityEngine_Input_GetAxisRawv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538010 | 0, fb + 233 | 0);
 return;
}

function __Z37Register_UnityEngine_Gradient_SetKeysv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517327 | 0, fb + 593 | 0);
 return;
}

function __Z37Register_UnityEngine_GL_get_wireframev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535887 | 0, fb + 160 | 0);
 return;
}

function __Z37Register_UnityEngine_GL_get_sRGBWritev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535947 | 0, fb + 161 | 0);
 return;
}

function __Z37Register_UnityEngine_Camera_set_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503907 | 0, fb + 161 | 0);
 return;
}

function __Z37Register_UnityEngine_Camera_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503877 | 0, fb + 209 | 0);
 return;
}

function __Z37Register_UnityEngine_AudioSource_Playv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 886812 | 0, fb + 909 | 0);
 return;
}

function __Z37Register_UnityEngine_AssetBundle_Loadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 496540 | 0, fb + 354 | 0);
 return;
}

function __Z36getPxVehicleDriveDynData_CurrentGearPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 68 >> 2] | 0;
}

function __Z36getPxVehicleDriveDynDataMCurrentGearPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 68 >> 2] | 0;
}

function __Z36Register_UnityEngine_RectOffset_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 513715 | 0, fb + 3499 | 0);
 return;
}

function __Z36Register_UnityEngine_Random_set_seedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554599 | 0, fb + 3626 | 0);
 return;
}

function __Z36Register_UnityEngine_Object_set_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579959 | 0, fb + 3156 | 0);
 return;
}

function __Z36Register_UnityEngine_Object_get_namev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579930 | 0, fb + 1935 | 0);
 return;
}

function __Z36Register_UnityEngine_Object_ToStringv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580224 | 0, fb + 1939 | 0);
 return;
}

function __Z36Register_UnityEngine_Mesh_ResizeListv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547903 | 0, fb + 2999 | 0);
 return;
}

function __Z36Register_UnityEngine_Light_set_flarev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542229 | 0, fb + 2967 | 0);
 return;
}

function __Z36Register_UnityEngine_Light_get_flarev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542200 | 0, fb + 1764 | 0);
 return;
}

function __Z36Register_UnityEngine_Input_GetKeyIntv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537788 | 0, fb + 1740 | 0);
 return;
}

function __Z36Register_UnityEngine_Input_GetButtonv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 538040 | 0, fb + 1746 | 0);
 return;
}

function __Z36Register_UnityEngine_GameObject_Findv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 516075 | 0, fb + 1674 | 0);
 return;
}

function __Z36Register_UnityEngine_GUI_get_enabledv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020570 | 0, fb + 273 | 0);
 return;
}

function __Z36Register_UnityEngine_GUI_get_changedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020512 | 0, fb + 272 | 0);
 return;
}

function __Z36Register_UnityEngine_GUIClip_Reapplyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025994 | 0, fb + 377 | 0);
 return;
}

function __Z36Register_UnityEngine_Camera_CopyFromv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 508019 | 0, fb + 2809 | 0);
 return;
}

function __Z36Register_UnityEngine_Animator_Rebindv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924406 | 0, fb + 3816 | 0);
 return;
}

function __Z35getPxSceneDescWakeCounterResetValuePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 156 >> 2]);
}

function __Z35Register_UnityEngine_Event_set_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019331 | 0, fb + 4268 | 0);
 return;
}

function __Z35Register_UnityEngine_Event_get_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019303 | 0, fb + 2709 | 0);
 return;
}

function __Z35Register_UnityEngine_Event_PopEventv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020201 | 0, fb + 2717 | 0);
 return;
}

function __Z35Register_UnityEngine_Event_InitCopyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019217 | 0, fb + 4266 | 0);
 return;
}

function __Z35AudioListener_Get_Custom_PropVolumev() {
 return Math_fround(__ZNK12AudioManager9GetVolumeEv(__Z15GetAudioManagerv() | 0));
}

function __Z32getPxClothStretchConfigStiffnessPKN5physx20PxClothStretchConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z31AndroidJNI_CUSTOM_SetFloatField13Il2Cpp_IntPtrS_f(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function __Z22SetManagerPtrInContextiP6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[gb + 1104348 + (i1 << 2) >> 2] = i2;
 return;
}

function __Z19GetUserConfigFolderv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem19GetUserConfigFolderEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function _FT_Init_Class_cff_service_properties(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 472;
 HEAP32[i1 + 4 >> 2] = fb + 473;
 return;
}

function b11(i1, f2, f3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 nullFunc_iiffi(11);
 return 0;
}

function _tlsf_block_size(i1) {
 i1 = i1 | 0;
 if (!i1) {
  i1 = 0;
  return i1 | 0;
 }
 i1 = HEAP32[i1 + -4 >> 2] & -4;
 return i1 | 0;
}

function _reset_error_mgr(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 >> 2] | 0;
 HEAP32[i1 + 108 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function _fwrite_file_func(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _fwrite(i3, 1, i4, i2) | 0;
}

function _error_exit(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 8 >> 2] | 0, i1 | 0);
 _jpeg_destroy(i1);
 _exit(1);
}

function _cf2_getPpemY(i1) {
 i1 = i1 | 0;
 return (HEAPU16[(HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 88 >> 2] | 0) + 14 >> 1] | 0) << 16 | 0;
}

function ___signbitf(f1) {
 f1 = Math_fround(f1);
 return (HEAPF32[tempDoublePtr >> 2] = f1, HEAP32[tempDoublePtr >> 2] | 0) >>> 31 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 460 >> 2]);
}

function __ZSt14get_unexpectedv() {
 var i1 = 0;
 i1 = HEAP32[gb + 216180 >> 2] | 0;
 HEAP32[gb + 216180 >> 2] = i1 + 0;
 return i1 | 0;
}

function __ZNSt3__218shared_timed_mutex11lock_sharedEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__219__shared_mutex_base11lock_sharedEv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IwLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IwLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv(i1) {
 i1 = i1 | 0;
 return i1 + 520 | 0;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv(i1) {
 i1 = i1 | 0;
 return i1 + 508 | 0;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv(i1) {
 i1 = i1 | 0;
 return i1 + 496 | 0;
}

function __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv(i1) {
 i1 = i1 | 0;
 return i1 + 532 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv(i1) {
 i1 = i1 | 0;
 return i1 + 520 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv(i1) {
 i1 = i1 | 0;
 return i1 + 508 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv(i1) {
 i1 = i1 | 0;
 return i1 + 496 | 0;
}

function __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv(i1) {
 i1 = i1 | 0;
 return i1 + 532 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) >>> 1 & 2 | 4 | 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) >>> 1 & 2 | 4 | 0;
}

function __ZNKSt3__214__codecvt_utf8IDsE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] & 4 | 0) == 0 ? 3 : 6) | 0;
}

function __ZNKSt3__214__codecvt_utf8IDiE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 12 >> 2] & 4 | 0) == 0 ? 4 : 7) | 0;
}

function __ZNK9Transform17GetHierarchyCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 16 >> 2] >> 2] | 0;
}

function __ZNK9Animation12GetClipCountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 288 >> 2] | 0) - (HEAP32[i1 + 284 >> 2] | 0) >> 2 | 0;
}

function __ZNK7b2World14GetTreeQualityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZNK13b2DynamicTree12GetAreaRatioEv(i1 + 102872 | 0));
}

function __ZNK7Texture12GetGPUHeightEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 140 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx6shdfnd6Socket11isConnectedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 14 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 508 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 264 >> 2] | 0;
}

function __ZNK5Umbra10Visibility15getInputObjectsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 >> 2] | 0;
}

function __ZNK5Umbra10PortalInfo16getTargetClusterEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] | 0;
}

function __ZNK26AnimatorControllerPlayable24HasStateMachineBehaviourEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 124 >> 2] | 0) != 0 | 0;
}

function __ZNK19TextRenderingModule10TMGenFlushEv(i1) {
 i1 = i1 | 0;
 __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv();
 return;
}

function __ZNK14ParticleSystem13GetStartSpeedEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 352 >> 2]);
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl21getNbPropertyMessagesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 232 >> 2] | 0;
}

function __ZNK11AudioSource18GetSpatialBlendMixEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 92 >> 2] | 0) + 4 >> 2]);
}

function __ZN7mecanim12statemachine15GetMirrorOffsetEb(i1) {
 i1 = i1 | 0;
 return Math_fround(i1 ? Math_fround(.5) : Math_fround(0.0));
}

function __ZN5physx6shdfnd6TlsSetEjPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_pthread_setspecific(i1 | 0, i2 | 0) | 0) == 0 | 0;
}

function __ZN5physx2Sc16ArticulationCore17getPxArticulationEv(i1) {
 i1 = i1 | 0;
 return i1 + (HEAP32[gb + 1097392 + 16 >> 2] | 0) | 0;
}

function __ZN5physx26PxcFrictionPatchStreamPair5resetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN4Mesh15GetSharedPxMeshEv(i1) {
 i1 = i1 | 0;
 return __ZN17CollisionMeshData15GetSharedNxMeshER4Mesh(i1 + 204 | 0, i1) | 0;
}

function __ZN4FMOD8ChannelI19set3DMinMaxDistanceEff(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 return 0;
}

function __ZN4FMOD8ChannelI17set3DDopplerLevelEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 148 >> 2] = f2;
 return 0;
}

function __ZN4FMOD13ChannelGroupI11getWaveDataEPfii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN19SkinnedMeshRenderer13DidDeleteMeshEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 356 >> 2] = 0;
 HEAP32[i1 + 412 >> 2] = 0;
 return;
}

function __ZN18ScriptingArguments10GetFloatAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i1 + (i2 << 3) >> 2]);
}

function __ZN18ScreenManagerWebGL21SetCursorInsideWindowEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 27 >> 0] = i2 & 1;
 return;
}

function __ZN18DownloadHandlerVFS22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 2148 >> 2] = i2;
 return;
}

function __ZN18BaseUnityAnalytics6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN17Physics2DSettings22SetAlwaysShowCollidersEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 95 >> 0] = i2 & 1;
 return;
}

function __ZN17LowLevelAllocator4FreeEPvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN13MemoryManager12LowLevelFreeEPvj(i1, i2);
 return;
}

function __ZN17GeneralConnection14NetworkMessage20CheckMessageValidityEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[i1 >> 1] | 0) == 20111 | 0;
}

function __ZN17AudioCustomFilter21WaitForScriptCallbackEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP8[i1 + 12 >> 0] | 0)) return; else while (1) {}
}

function __ZN17AnimationPlayable7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z28GetAnimationScriptingClassesv() | 0) + 44 >> 2] | 0;
}

function __ZN14VehiclesModule19InitVehiclesManagerEv(i1) {
 i1 = i1 | 0;
 _PxInitVehicleSDK(__Z14GetDynamicsSDKv() | 0, 0) | 0;
 return;
}

function __ZN14VRSplashScreen22CleanupSplashMaterialsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN14BatchAllocatorC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 8 >> 2] = 4;
 return;
}

function __ZN13UpdateManager6UpdateEv(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManager12CommonUpdateI16BehaviourManagerEEvv(i1);
 return;
}

function __ZN13SpeedTreeWind9SetParamsERKNS_7SParamsE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(i1 | 0, i2 | 0, 1332) | 0;
 return;
}

function __ZN12b2MotorJoint19SetCorrectionFactorEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 100 >> 2] = f2;
 return;
}

function __ZN12GraphicsCaps25CleanupGraphicsCapsMemoryEv() {
 __ZN12GraphicsCaps11ClearMemoryEv(HEAP32[gb + 1166136 >> 2] | 0);
 return;
}

function __ZN12CubemapArray5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN7Texture5ResetEv(i1);
 __ZN15TextureSettings5ResetEv(i1 + 32 | 0);
 return;
}

function __ZN11AudioSource7UnPauseEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 532 >> 0] = 0;
 __ZN11AudioSource16UpdatePauseStateEv(i1);
 return;
}

function __ZN10UnityScene15SetLoadingStateENS_12LoadingStateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 80 >> 2] = i2;
 return;
}

function __Z9DoNothingRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z45getPxVehicleWheels4SimData_TireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE(i1) {
 i1 = i1 | 0;
 return i1 + 832 | 0;
}

function __Z43RenderSettings_Get_Custom_PropFlareStrengthv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 304 >> 2]);
}

function __Z41Physics2D_Get_Custom_PropMaxRotationSpeedv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 64 >> 2]);
}

function __Z40AndroidJNI_CUSTOM_SetBooleanArrayElement13Il2Cpp_IntPtrih(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z39getPxVehicleWheelsDynData_Wheel4DynDataPKN5physx22PxVehicleWheelsDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z39getPxParticleReadDataValidParticleRangePKN5physx18PxParticleReadDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z39AndroidJNI_CUSTOM_SetStaticBooleanField13Il2Cpp_IntPtrS_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z39AndroidJNI_CUSTOM_SetObjectArrayElement13Il2Cpp_IntPtriS_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z38Register_UnityEngine_Mathf_FloatToHalfv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 546126 | 0, fb + 1 | 0);
 return;
}

function __Z38Register_UnityEngine_GL_MultiTexCoord3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535324 | 0, fb + 7 | 0);
 return;
}

function __Z38AndroidJNI_CUSTOM_SetStaticObjectField13Il2Cpp_IntPtrS_S_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z37Register_UnityEngine_Random_get_valuev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554797 | 0, fb + 17 | 0);
 return;
}

function __Z37Register_UnityEngine_Debug_DebugBreakv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511630 | 0, fb + 90 | 0);
 return;
}

function __Z37Register_UnityEngine_Application_Quitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 493019 | 0, fb + 86 | 0);
 return;
}

function __Z36Register_UnityEngine_Texture3D_Applyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573396 | 0, fb + 677 | 0);
 return;
}

function __Z36Register_UnityEngine_Texture2D_Applyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 572611 | 0, fb + 673 | 0);
 return;
}

function __Z36Register_UnityEngine_Random_get_seedv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554570 | 0, fb + 200 | 0);
 return;
}

function __Z36Register_UnityEngine_Mesh_HasChannelv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547874 | 0, fb + 651 | 0);
 return;
}

function __Z36Register_UnityEngine_Material_GetTagv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566379 | 0, fb + 150 | 0);
 return;
}

function __Z36Register_UnityEngine_Light_set_rangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541977 | 0, fb + 192 | 0);
 return;
}

function __Z36Register_UnityEngine_Light_get_rangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541948 | 0, fb + 243 | 0);
 return;
}

function __Z36Register_UnityEngine_Light_GetLightsv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 542894 | 0, fb + 647 | 0);
 return;
}

function __Z36Register_UnityEngine_GL_LoadIdentityv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535633 | 0, fb + 105 | 0);
 return;
}

function __Z36Register_UnityEngine_Animator_Updatev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 924377 | 0, fb + 670 | 0);
 return;
}

function __Z35getPxVehicleDriveDynData_TargetGearPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __Z35getPxVehicleDriveDynData_GearChangePKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __Z35getPxVehicleDriveDynDataMTargetGearPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __Z35Register_UnityEngine_WWW_get_isDonev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581062 | 0, fb + 1946 | 0);
 return;
}

function __Z35Register_UnityEngine_WWW_DestroyWWWv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580734 | 0, fb + 3159 | 0);
 return;
}

function __Z35Register_UnityEngine_Light_set_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 541004 | 0, fb + 2960 | 0);
 return;
}

function __Z35Register_UnityEngine_Light_get_typev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 540976 | 0, fb + 1759 | 0);
 return;
}

function __Z35Register_UnityEngine_Camera_set_hdrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503490 | 0, fb + 2777 | 0);
 return;
}

function __Z35Register_UnityEngine_Camera_get_hdrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 503462 | 0, fb + 1620 | 0);
 return;
}

function __Z34scripting_class_get_declaring_typeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_declaring_type(i1 | 0) | 0;
}

function __Z34scripting_class_array_element_sizeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_array_element_size(i1 | 0) | 0;
}

function __Z34Register_UnityEngine_GUI_set_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020771 | 0, fb + 3889 | 0);
 return;
}

function __Z34Register_UnityEngine_GUIStyle_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1022132 | 0, fb + 3899 | 0);
 return;
}

function __Z34Register_UnityEngine_Event_InitPtrv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019245 | 0, fb + 4267 | 0);
 return;
}

function __Z34Register_UnityEngine_Event_Cleanupv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019190 | 0, fb + 3877 | 0);
 return;
}

function __Z30getPxVehicleTireDataMLatStiffYPKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z30getPxCapsuleGeometryHalfHeightPKN5physx17PxCapsuleGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z29getPxHeightFieldDescThicknessPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z28Caching_Get_Custom_PropReadyv() {
 return (__ZN14CachingManager10GetIsReadyEv(__Z17GetCachingManagerv() | 0) | 0) & 1 | 0;
}

function __Z27setPxSceneLimitsMaxNbActorsPN5physx13PxSceneLimitsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __Z22setPxSceneDescUserDataPN5physx11PxSceneDescEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 128 >> 2] = i1;
 return;
}

function __Z16InitClothManagerv() {
 _PxRegisterCloth(__Z14GetDynamicsSDKv() | 0);
 HEAP32[gb + 1115296 + 280 >> 2] = fb + 254;
 return;
}

function _UNITY_png_set_compression_method(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 288 >> 2] = i2;
 return;
}

function _FT_Init_Class_tt_service_properties(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 474;
 HEAP32[i1 + 4 >> 2] = fb + 475;
 return;
}

function b84(i1, f2, i3, i4, i5) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_vifiii(84);
}

function b78(i1, i2, f3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_viifii(78);
}

function b22(i1, i2, i3, i4, f5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 f5 = Math_fround(f5);
 nullFunc_viiiif(22);
}

function _wcsncasecmp_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _wcsncasecmp(i1, i2, i3) | 0;
}

function _strncasecmp_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _strncasecmp(i1, i2, i3) | 0;
}

function _srand(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = gb + 1099752 | 0;
 HEAP32[i2 >> 2] = i1 + -1;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function _glTexParameteriv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glTexParameteriv(i1 | 0, i2 | 0, i3 | 0);
}

function _glBindBufferBase__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glBindBufferBase(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glGenRenderbuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGenRenderbuffers(i1 | 0, i2 | 0);
}

function _emscripten_glBindRenderbuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBindRenderbuffer(i1 | 0, i2 | 0);
}

function ___freadptrinc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + i2;
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 524 >> 2] | 0;
}

function __ZSt13get_terminatev() {
 var i1 = 0;
 i1 = HEAP32[gb + 216092 >> 2] | 0;
 HEAP32[gb + 216092 >> 2] = i1 + 0;
 return i1 | 0;
}

function __ZNSt3__28__rs_getEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(gb + 1470904 | 0) | 0;
 HEAP32[gb + 1470900 >> 2] = 1;
 return;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) >>> 1 & 2 | 4 | 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) >>> 1 & 2 | 4 | 0;
}

function __ZNKSt3__214__codecvt_utf8IwE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 16 >> 2] & 4 | 0) == 0 ? 4 : 7) | 0;
}

function __ZNK7dtCrowd14getAgentFilterEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 24 >> 2] | 0) + (i2 * 132 | 0) | 0;
}

function __ZNK7Texture11GetGPUWidthEv(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[(HEAP32[i1 >> 2] | 0) + 136 >> 2] | 0, i1 | 0) | 0;
}

function __ZNK5physx7NpCloth14getNbParticlesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc9ClothCore14getNbParticlesEv(i1 + 32 | 0) | 0;
}

function __ZNK5Umbra16LineSegmentQuery9getResultEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 24 >> 2] | 0;
}

function __ZNK5Umbra10Visibility15getOutputBufferEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 8 >> 2] | 0;
}

function __ZNK5Umbra10Visibility14getInputBufferEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 16 >> 2] | 0;
}

function __ZNK14ParticleSystem13GetStartDelayEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 36 >> 2] | 0) + 80 >> 2]);
}

function __ZNK14ParticleSystem12GetStartSizeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 44 >> 2] | 0) + 772 >> 2]);
}

function __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + 28 + (i2 * 24 | 0) | 0;
}

function __ZNK13TextRendering4Font9GetAscentEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 48 >> 2] | 0) + 192 >> 2]);
}

function __ZNK11AudioSource16GetReverbZoneMixEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 180 >> 2] | 0) + 4 >> 2]);
}

function __ZN9GfxDevice26SetRandomWriteTargetBufferEi15ComputeBufferID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8Animator20GetRecorderStartTimeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZN14AvatarPlayback9StartTimeEv(i1 + 504 | 0));
}

function __ZN5physx8debugger4comm19EndSetPropertyValue9serializeERNS1_15EventSerializerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEC2EPKf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN5physx3Scb5Scene13addShapeToPvdERNS0_5ShapeERNS_7PxActorE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc9ShapeCore13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 128 >> 2] = f1;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxVehicleDriveNW14setToRestStateEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive14setToRestStateEv(i1);
 return;
}

function __ZN5physx16PxVehicleDrive4W14setToRestStateEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive14setToRestStateEv(i1);
 return;
}

function __ZN5physx14NpRigidDynamic10putToSleepEv(i1) {
 i1 = i1 | 0;
 __ZN5physx3Scb4Body18putToSleepInternalEv(i1 + 48 | 0);
 return;
}

function __ZN5physx13PxsCCDContext14updateCCDBeginEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 92 >> 2] = 0;
 HEAP32[i1 + 96 >> 2] = 0;
 return;
}

function __ZN4TreeD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD13ChannelGroupI14getNumChannelsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation11GetProgressEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZN23PreloadManagerOperation9SetStatusENS_6StatusE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 24 >> 2] = i2;
 return;
}

function __ZN20TextRenderingPrivate7GUITextD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20TextRenderingPrivate7GUITextD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18ProfilerConnection23HandleConnectionMessageEj(i1) {
 i1 = i1 | 0;
 HEAP32[HEAP32[gb + 1163256 >> 2] >> 2] = i1;
 return;
}

function __ZN18BuoyancyEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17Physics2DSettings21SetQueriesHitTriggersEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 92 >> 0] = i2 & 1;
 return;
}

function __ZN17ArchiveFileSystem4LockER13FileEntryData12FileLockMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN16UnityAdsSettings22SetInitializeOnStartupEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 16 >> 0] = i2 & 1;
 return;
}

function __ZN15RelativeJoint2D22SetAutoConfigureOffsetEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 100 >> 0] = i2 & 1;
 return;
}

function __ZN15PointEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13SpringJoint2D24SetAutoConfigureDistanceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 108 >> 0] = i2 & 1;
 return;
}

function __ZN13SpeedTreeWind16SetGustFrequencyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 1304 >> 2] = f2;
 return;
}

function __ZN11UnityEngine15PlatformWrapper24GetProcessorFrequencyMHzEv() {
 return __ZN10systeminfo24GetProcessorFrequencyMHzEv() | 0;
}

function __ZN11AudioModule11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 __ZN12AudioManager11FixedUpdateEv(__Z15GetAudioManagerv() | 0);
 return;
}

function __ZL7StbFreePvS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 return;
}

function __ZL25CleanupImageFilterGlobalsPv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1110912 >> 2] = 0;
 HEAP32[gb + 1110916 >> 2] = 0;
 return;
}

function __Z9dtReallocPvi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return mftCall_iii(HEAP32[gb + 1459040 >> 2] | 0, i1 | 0, i2 | 0) | 0;
}

function __Z45LightProbeGroup_Set_Custom_PropProbePositionsP12Il2CppObjectP11Il2CppArray(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z43getPxSceneDescContactReportStreamBufferSizePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 144 >> 2] | 0;
}

function __Z42RenderSettings_Get_Custom_PropHaloStrengthv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 300 >> 2]);
}

function __Z37scripting_produce_method_from_backendPK10MethodInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z36Time_Set_Custom_PropCaptureFrameratei(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z14GetTimeManagerv() | 0) + 144 >> 2] = i1;
 return;
}

function __Z36Register_UnityEngine_Camera_get_mainv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507110 | 0, fb + 97 | 0);
 return;
}

function __Z35getPxHeightFieldGeometryHeightFieldPKN5physx21PxHeightFieldGeometryE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z35Register_UnityEngine_WWW_GetTexturev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580958 | 0, fb + 690 | 0);
 return;
}

function __Z35Register_UnityEngine_Transform_Findv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579008 | 0, fb + 687 | 0);
 return;
}

function __Z35Register_UnityEngine_Resources_Loadv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 560552 | 0, fb + 669 | 0);
 return;
}

function __Z35Register_UnityEngine_Object_Destroyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 579827 | 0, fb + 203 | 0);
 return;
}

function __Z35Register_UnityEngine_Animation_Playv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916763 | 0, fb + 436 | 0);
 return;
}

function __Z34getPxTriangleMeshGeometryMeshFlagsPKN5physx22PxTriangleMeshGeometryE(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 32 >> 0] | 0;
}

function __Z34Register_UnityEngine_WWW_get_errorv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580931 | 0, fb + 1945 | 0);
 return;
}

function __Z34Register_UnityEngine_WWW_get_bytesv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580878 | 0, fb + 1943 | 0);
 return;
}

function __Z34Register_UnityEngine_Tree_set_datav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944496 | 0, fb + 4200 | 0);
 return;
}

function __Z34Register_UnityEngine_Tree_get_datav() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944469 | 0, fb + 2620 | 0);
 return;
}

function __Z34Register_UnityEngine_Terrain_Flushv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 944160 | 0, fb + 3832 | 0);
 return;
}

function __Z34Register_UnityEngine_Sprite_get_uvv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 569383 | 0, fb + 1880 | 0);
 return;
}

function __Z34Register_UnityEngine_Mesh_Optimizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 548685 | 0, fb + 3612 | 0);
 return;
}

function __Z34Register_UnityEngine_Graphics_Blitv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 532660 | 0, fb + 2932 | 0);
 return;
}

function __Z34Register_UnityEngine_Gradient_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 517019 | 0, fb + 3505 | 0);
 return;
}

function __Z34Register_UnityEngine_GUI_get_depthv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1020744 | 0, fb + 276 | 0);
 return;
}

function __Z34Register_UnityEngine_Camera_Renderv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 507280 | 0, fb + 3479 | 0);
 return;
}

function __Z31getPxVehicleClutchDataMStrengthPKN5physx19PxVehicleClutchDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z31getPxClothTetherConfigStiffnessPKN5physx19PxClothTetherConfigE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z28dtFreeObstacleAvoidanceQueryP24dtObstacleAvoidanceQuery(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 __Z6dtFreePv(i1);
 return;
}

function __Z26getPxVehicleEngineDataMMOIPKN5physx19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __Z18setPxSpringDampingPN5physx8PxSpringEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 4 >> 2] = f1;
 return;
}

function __Z18GetApplicationPathv(i1) {
 i1 = i1 | 0;
 __ZNK10FileSystem18GetApplicationPathEv(i1, __Z13GetFileSystemv() | 0);
 return;
}

function _UNITY_tt_slot_init(i1) {
 i1 = i1 | 0;
 return _UNITY_FT_GlyphLoader_CreateExtra(HEAP32[HEAP32[i1 + 156 >> 2] >> 2] | 0) | 0;
}

function _UNITY_png_set_compression_level(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 284 >> 2] = i2;
 return;
}

function _UNITY_png_free_default(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if ((i1 | 0) == 0 | (i2 | 0) == 0) return;
 _free(i2);
 return;
}

function b65(i1, i2, i3, i4, d5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 d5 = +d5;
 nullFunc_iiiiid(65);
 return 0;
}

function b49(i1, f2, f3, f4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 nullFunc_vifff(49);
}

function _llvm_bswap_i32(i1) {
 i1 = i1 | 0;
 return (i1 & 255) << 24 | (i1 >> 8 & 255) << 16 | (i1 >> 16 & 255) << 8 | i1 >>> 24 | 0;
}

function _fread_file_func(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _fread(i3, 1, i4, i2) | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 516 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) + 4 | 0;
}

function __ZNSt3__212_GLOBAL__N_13mutEv() {
 if (!(HEAP8[gb + 1099776 >> 0] | 0)) ___cxa_guard_acquire(gb + 1099776 | 0) | 0;
 return;
}

function __ZNK5physx2Sc18ParticleSystemCore23getRestParticleDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __ZNK5physx20PxsParticleSystemSim22getSimulationTimeStepVEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 1104 >> 2]);
}

function __ZNK26PlayerSettingsSplashScreen34GetSplashScreenBackgroundLandscapeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK22LocalFileSystemHandler21GetAvailableDiskSpaceEPKcRy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9ShaderLab27ComputeShaderKeywordSetHashERK16ShaderKeywordSet(i1) {
 i1 = i1 | 0;
 return _XXH32(i1, 32, -1756908921) | 0;
}

function __ZN9GfxDevice20UpdateConstantBufferEijPKv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __ZN9GfxDevice20SetRenderSurfaceNameEP17RenderSurfaceBasePKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8VRDevice9FocusLostEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 240 >> 2] | 0;
 if (!i1) return;
 mftCall_v(i1 | 0);
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl12getAllocatorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0;
}

function __ZN5physx2Sc9ClothCore13setRestOffsetEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 + 68 >> 2] = f1;
 return;
}

function __ZN5physx2Sc16ArticulationCore6wakeUpEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 32 >> 2] = f2;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity10HingeJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN5Unity10FixedJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN24ScriptingMethodFiltering17FilterOnSignatureENS_18MethodSearchFilterE(i1) {
 i1 = i1 | 0;
 return (i1 & 7 | 0) != 0 | 0;
}

function __ZN17Physics2DSettings20SetShowColliderSleepEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 96 >> 0] = i2 & 1;
 return;
}

function __ZN17FileSystemHandler5TouchER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 1056 >> 2] = 15;
 return 0;
}

function __ZN16ParticleAnimatorD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN16MemoryFileSystem4LockER13FileEntryData12FileLockMode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN14ParticleSystem21DisableUses3DRotationEv(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[i1 + 32 >> 2] | 0) + 870 >> 0] = 0;
 return;
}

function __ZN14AreaEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13SpeedTreeWind16CopySettingsFromEPKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memcpy(i1 | 0, i2 | 0, 1376) | 0;
 return;
}

function __ZN13GfxDeviceNull15SetStencilStateEPK18DeviceStencilStatei(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13GfxDeviceGLES15FinishRenderingEv(i1) {
 i1 = i1 | 0;
 __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(i1 + 4620 | 0, 1);
 return;
}

function __ZN12SocketStream4PollEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return (HEAP8[i1 + 18 >> 0] | 0) != 0 | 0;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader9IsAbortedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 5 >> 0] | 0) != 0 | 0;
}

function __ZN11MatrixStack5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 1024 >> 2] = 1;
 __ZN10Matrix4x4f11SetIdentityEv(i1) | 0;
 return;
}

function __ZN11ICallString5ClearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
 return;
}

function __ZN11ContextGLES7DestroyEv() {
 _emscripten_webgl_destroy_context(_emscripten_webgl_get_current_context() | 0) | 0;
 return;
}

function __ZN11AudioSource5PauseEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 532 >> 0] = 1;
 __ZN11AudioSource16UpdatePauseStateEv(i1);
 return;
}

function __ZN10builtintex17GetDefaultTextureE16TextureDimension(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1157936 + (i1 << 2) >> 2] | 0;
}

function __ZN10DynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN10AudioMixer5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 96 >> 2] = Math_fround(-80.0);
 HEAP8[i1 + 100 >> 0] = 1;
 return;
}

function __Z54SystemInfo_Get_Custom_PropSupportsCubemapArrayTexturesv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 483 >> 0] | 0;
}

function __Z51UnityAdsSettings_Get_Custom_PropInitializeOnStartupv() {
 return HEAP8[(__Z19GetUnityAdsSettingsv() | 0) + 16 >> 0] | 0;
}

function __Z51RenderSettings_Get_Custom_PropDefaultReflectionModev() {
 return HEAP32[(__Z17GetRenderSettingsv() | 0) + 368 >> 2] | 0;
}

function __Z47AndroidJNI_CUSTOM_INTERNAL_CALL_NewBooleanArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44Time_Get_Custom_PropMaximumParticleDeltaTimev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 204 >> 2]);
}

function __Z39Physics2D_Get_Custom_PropBaumgarteScalev() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 72 >> 2]);
}

function __Z38AndroidJNI_CUSTOM_SetShortArrayElement13Il2Cpp_IntPtris(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z37getPxParticleReadDataNbValidParticlesPKN5physx18PxParticleReadDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z37AndroidJNI_CUSTOM_SetStaticShortField13Il2Cpp_IntPtrS_s(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z36Register_UnityEngine_Animation_Blendv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 916824 | 0, fb + 2 | 0);
 return;
}

function __Z35Register_UnityEngine_Screen_get_dpiv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 534459 | 0, fb + 15 | 0);
 return;
}

function __Z34Register_UnityEngine_Input_GetAxisv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 537983 | 0, fb + 232 | 0);
 return;
}

function __Z34Register_UnityEngine_GL_PushMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535781 | 0, fb + 106 | 0);
 return;
}

function __Z34Register_UnityEngine_Cubemap_Applyv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 573098 | 0, fb + 674 | 0);
 return;
}

function __Z33VRSettings_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 __ZN8VRDevice16SetDeviceEnabledEb(i1 << 24 >> 24 != 0);
 return;
}

function __Z33Register_UnityEngine_WWW_get_sizev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580905 | 0, fb + 1944 | 0);
 return;
}

function __Z27getPxVehicleWheelDataMWidthPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z26getPxJointLinearLimitValuePKN5physx18PxJointLinearLimitE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z19scripting_value_boxP11Il2CppClassPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_value_box(i1 | 0, i2 | 0) | 0;
}

function _UNITY_png_set_chunk_malloc_max(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 636 >> 2] = i2;
 return;
}

function _UNITY_png_set_bgr(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 i1 = i1 + 212 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 1;
 return;
}

function _UNITY_png_get_signature(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ((i1 | 0) != 0 & (i2 | 0) != 0 ? i2 + 32 | 0 : 0) | 0;
}

function _recv(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _recvfrom(i1, i2, i3, i4, 0, 0) | 0;
}

function _jsimd_rgb_gray_convert(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jcopy_block_row(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i2 | 0, i1 | 0, i3 << 7 | 0) | 0;
 return;
}

function _glTexParameteri__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glTexParameteri(i1 | 0, i2 | 0, i3 | 0);
}

function _glGetIntegeri_v__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetIntegeri_v(i1 | 0, i2 | 0, i3 | 0);
}

function _fullsize_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = i3;
 return;
}

function _emscripten_glVertexAttrib4fv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glVertexAttrib4fv(i1 | 0, i2 | 0);
}

function _emscripten_glVertexAttrib3fv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glVertexAttrib3fv(i1 | 0, i2 | 0);
}

function _emscripten_glVertexAttrib2fv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glVertexAttrib2fv(i1 | 0, i2 | 0);
}

function _emscripten_glVertexAttrib1fv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glVertexAttrib1fv(i1 | 0, i2 | 0);
}

function _emscripten_glGenVertexArrays__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGenVertexArrays(i1 | 0, i2 | 0);
}

function _emscripten_glGenFramebuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGenFramebuffers(i1 | 0, i2 | 0);
}

function _emscripten_glBindFramebuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBindFramebuffer(i1 | 0, i2 | 0);
}

function __ZltRK15OrderedCallbackS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 >> 2] | 0) < (HEAP32[i2 >> 2] | 0) | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 528 >> 2] | 0;
}

function __ZThn32_N14SpriteRendererD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN14SpriteRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn28_N14PhysicsManagerD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -28 | 0;
 __ZN14PhysicsManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__26localeD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__214__shared_count16__release_sharedEv(HEAP32[i1 >> 2] | 0) | 0;
 return;
}

function __ZNSt12experimental15fundamentals_v112bad_any_castD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt8bad_castD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNK5physx7NpScene15getFrictionTypeEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene15getFrictionTypeEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx7NpScene15getCCDMaxPassesEv(i1) {
 i1 = i1 | 0;
 return __ZNK5physx2Sc5Scene15getCCDMaxPassesEv(i1 + 32 | 0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 292 >> 2] | 0;
}

function __ZNK5physx10PxsContext18getSolverBatchSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 12 >> 2] | 0) + 148 >> 2] | 0;
}

function __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZNK25SingleBlockMemoryFileData4SizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 28 >> 2] | 0;
 setTempRet0(0);
 return i1 | 0;
}

function __ZNK25MultiBlocksMemoryFileData4SizeEv(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 40 >> 2] | 0;
 setTempRet0(0);
 return i1 | 0;
}

function __ZNK14ParticleSystem10GetPrewarmEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 278 >> 0] | 0) != 0 | 0;
}

function __ZNK13GfxDeviceGLES18GetDefaultRTFormatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 632 >> 2] | 0;
}

function __ZN9GfxDevice21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8Animator19GetRecorderStopTimeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(__ZN14AvatarPlayback8StopTimeEv(i1 + 504 | 0));
}

function __ZN5physx6shdfnd7PAUtils10debugEventEtjj(i4, i3, i1, i2) {
 i4 = i4 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx3Cct17CapsuleController11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 88 >> 2] = i2;
 return;
}

function __ZN5physx18PxsSolverStartTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra11ArrayMapper4initEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 HEAP32[i1 + 20 >> 2] = i2;
 return;
}

function __ZN4FMOD8ChannelI10getDSPHeadEPPNS_3DSPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN4FMOD7SystemI19getRecordNumDriversEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 1;
 return 0;
}

function __ZN4FMOD13ChannelGroupI12getNumGroupsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN23UnityPurchasingSettings10InitializeER6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN23ControllerContactFilterC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 111320 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN17SurfaceEffector2D18SetUseContactForceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 104 >> 0] = i2 & 1;
 return;
}

function __ZN17Physics2DSettings19SetShowColliderAABBEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 98 >> 0] = i2 & 1;
 return;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15UnityAdsManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN15OcclusionPortalD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN15NavMeshSettingsD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28344 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN15DownloadHandler6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN14SerializedFile6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 144 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN14SerializedFile4Type10SetOldTypeEPK8TypeTree(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 44 >> 2] = i2;
 return;
}

function __ZN14PlayerSettings21SetMTRenderingRuntimeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 336 >> 0] = i2 & 1;
 return;
}

function __ZN14PlayerSettings13SetColorSpaceE10ColorSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 332 >> 2] = i2;
 return;
}

function __ZN13TargetJoint2D22SetAutoConfigureTargetEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 104 >> 0] = i2 & 1;
 return;
}

function __ZN13SplatDatabase21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 __ZN13SplatDatabase18RecalculateBasemapEb(i1, 1);
 return;
}

function __ZN11ShapeModule13DidDeleteMeshEP14ParticleSystem(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 72 >> 2] = 0;
 return;
}

function __ZN10GUIManager17GetMasterGUIStateEi(i1) {
 i1 = i1 | 0;
 return (HEAP32[gb + 1468156 >> 2] | 0) + 488 + (i1 * 20 | 0) | 0;
}

function __Z52SystemInfo_Get_Custom_PropSupportedRenderTargetCountv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 140 >> 2] | 0;
}

function __Z47SystemInfo_Get_Custom_PropSupportsAccelerometerv() {
 return (__ZN10systeminfo21SupportsAccelerometerEv() | 0) & 1 | 0;
}

function __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewDoubleArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z41Texture_Set_Custom_PropMasterTextureLimiti(i1) {
 i1 = i1 | 0;
 __ZN7Texture21SetMasterTextureLimitEib(i1, 1);
 return;
}

function __Z41NavMesh_CUSTOM_GetAvoidancePredictionTimev() {
 return Math_fround(HEAPF32[(__Z17GetNavMeshManagerv() | 0) + 32 >> 2]);
}

function __Z40RenderSettings_Get_Custom_PropFogDensityv() {
 return Math_fround(HEAPF32[(__Z17GetRenderSettingsv() | 0) + 344 >> 2]);
}

function __Z37AndroidJNI_CUSTOM_SetCharArrayElement13Il2Cpp_IntPtrit(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z37AndroidJNI_CUSTOM_SetByteArrayElement13Il2Cpp_IntPtria(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z37AndroidJNI_CUSTOM_GetLongArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __Z36AndroidJNI_CUSTOM_SetStaticCharField13Il2Cpp_IntPtrS_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z36AndroidJNI_CUSTOM_SetStaticByteField13Il2Cpp_IntPtrS_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z36AndroidJNI_CUSTOM_GetStaticLongField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __Z35getPxVehicleClutchDataMAccuracyModePKN5physx19PxVehicleClutchDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z34Register_UnityEngine_Time_get_timev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 576514 | 0, fb + 18 | 0);
 return;
}

function __Z34Register_UnityEngine_Material_Lerpv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 566445 | 0, fb + 23 | 0);
 return;
}

function __Z34Register_UnityEngine_Animator_Playv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 922288 | 0, fb + 27 | 0);
 return;
}

function __Z33getPxConvexMeshGeometryConvexMeshPKN5physx20PxConvexMeshGeometryE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __Z33Register_UnityEngine_GL_PopMatrixv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535808 | 0, fb + 107 | 0);
 return;
}

function __Z33Register_UnityEngine_GL_LoadOrthov() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535449 | 0, fb + 103 | 0);
 return;
}

function __Z32Register_UnityEngine_WWW_get_urlv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 581193 | 0, fb + 1948 | 0);
 return;
}

function __Z32Register_UnityEngine_Shader_Findv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 563573 | 0, fb + 1847 | 0);
 return;
}

function __Z32Register_UnityEngine_GUIClip_Popv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1025645 | 0, fb + 376 | 0);
 return;
}

function __Z31profiler_set_memory_record_mode24ProfilerMemoryRecordMode(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1163252 >> 2] = i1;
 return;
}

function __Z31Register_UnityEngine_Event_Initv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 1019166 | 0, fb + 4265 | 0);
 return;
}

function __Z27ConvertSeparatorsToPlatformRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return;
}

function __Z26getPxVehicleWheelDataMMassPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z25getPxVehicleWheelDataMMOIPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z22GUI_CUSTOM_FocusWindowi(i1) {
 i1 = i1 | 0;
 __ZN5IMGUI11FocusWindowER8GUIStatei(__Z11GetGUIStatev() | 0, i1);
 return;
}

function __Z20setPxSpringStiffnessPN5physx8PxSpringEf(i2, f1) {
 i2 = i2 | 0;
 f1 = Math_fround(f1);
 HEAPF32[i2 >> 2] = f1;
 return;
}

function _UNITY_png_set_write_status_fn(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 544 >> 2] = i2;
 return;
}

function _UNITY_png_set_chunk_cache_max(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 632 >> 2] = i2;
 return;
}

function _UNITY_png_save_uint_16(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = i2 >>> 8;
 HEAP8[i1 + 1 >> 0] = i2;
 return;
}

function _mempcpy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memcpy(i1 | 0, i2 | 0, i3 | 0) | 0;
 return i1 + i3 | 0;
}

function _jsimd_ycc_rgb_convert(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jsimd_rgb_ycc_convert(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _glGetUniformBlockIndex__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _glGetUniformBlockIndex(i1 | 0, i2 | 0) | 0;
}

function _emscripten_glCheckFramebufferStatus__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glCheckFramebufferStatus(i1 | 0) | 0;
}

function _dngettext(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return ((i4 | 0) == 1 ? i2 : i3) | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + 4 | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 536 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -4 + 88 >> 2] | 0;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE26__invalidate_all_iteratorsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE26__invalidate_all_iteratorsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNKSt3__212strstreambuf6pcountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 24 >> 2] | 0) - (HEAP32[i1 + 20 >> 2] | 0) | 0;
}

function __ZNK8Animator16IsMatchingTargetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 364 >> 2]) >= Math_fround(0.0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 492 >> 2] | 0;
}

function __ZNK5physx3Cct26CharacterControllerManager21getNbObstacleContextsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 120 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 104 >> 2]);
}

function __ZNK5physx2Sc10NPhaseCore39getDefaultContactReportStreamBufferSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZNK5Umbra10Visibility16getOutputObjectsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) >> 2] | 0;
}

function __ZNK14ParticleSystem18GetMaxNumParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 44 >> 2] | 0) + 2548 >> 2] | 0;
}

function __ZNK12_GLOBAL__N_123FStreamNetworkOutStream11isConnectedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 28 >> 0] | 0) != 0 | 0;
}

function __ZN9ShaderLab4Pass6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 748 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm8BaseTask3runEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5physx17MBPUpdateWorkTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN4crnd12symbol_codec13get_bits_initEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZN4Halo5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 36 >> 2] = -8355712;
 HEAPF32[i1 + 40 >> 2] = Math_fround(5.0);
 return;
}

function __ZN4FMOD6SoundI19getMusicNumChannelsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 2;
 return 0;
}

function __ZN4FMOD13ChannelGroupI9setVolumeEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 44 >> 2] = f2;
 return 0;
}

function __ZN2UI14CanvasRenderer40SetNextTransformChangedTriggeredByCanvasEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 200 >> 0] = 1;
 return;
}

function __ZN2UI13DoSyncCullingERNS_13UIInstructionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 670 >> 0] = i2 & 1;
 return;
}

function __ZN24RingBufferMemoryFileData11SetGrowableEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 97 >> 0] = i2 & 1;
 return;
}

function __ZN22UnityAnalyticsSettings10InitializeER6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN20TextRenderingPrivate8FontImpl19HasCharacterDynamicEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 >>> 0 > 31 | 0;
}

function __ZN19ControllerHitReport13onObstacleHitERKN5physx23PxControllerObstacleHitE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18ScriptingArguments11GetStringAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 96 + (i2 << 2) >> 2] | 0;
}

function __ZN18ScriptingArguments11GetObjectAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 96 + (i2 << 2) >> 2] | 0;
}

function __ZN17b2ContactListener8PreSolveEP9b2ContactPK10b2Manifold(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15b2FrictionJoint12SetMaxTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 100 >> 2] = f2;
 return;
}

function __ZN15PointEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14RenderSettingsD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28344 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN14PhysicsManager21SetQueriesHitTriggersEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 56 >> 0] = i2 & 1;
 return;
}

function __ZN13SliderJoint2D21SetAutoConfigureAngleEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 118 >> 0] = i2 & 1;
 return;
}

function __ZN13RendererScene26ClearIntermediateRenderersEv(i1) {
 i1 = i1 | 0;
 __ZN21IntermediateRenderers5ClearEj(i1, 0);
 return;
}

function __ZN13GfxDeviceNull18CreateStencilStateERK15GfxStencilState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 1451280 | 0;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11ICallString18SetScriptingStringEP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z49WebGLInput_Get_Custom_PropCaptureAllKeyboardInputv() {
 return (__Z32IsCaptureAllKeyboardInputEnabledv() | 0) & 1 | 0;
}

function __Z48Physics2D_Get_Custom_PropQueriesStartInCollidersv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 93 >> 0] | 0;
}

function __Z46PhysicMaterial_Set_Custom_PropDynamicFriction2P12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewShortArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewFloatArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44UnityConnectSettings_Get_Custom_PropTestModev() {
 return HEAP8[(__Z23GetUnityConnectSettingsv() | 0) + 197 >> 0] | 0;
}

function __Z43Gyroscope_CUSTOM_getUpdateInterval_Internali(i1) {
 i1 = i1 | 0;
 return Math_fround(__Z21GetGyroUpdateIntervali(i1));
}

function __Z42DynamicGI_CUSTOM_INTERNAL_CALL_SetEmissiveP12Il2CppObjectRK10ColorRGBAf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z40getPxSceneDescDynamicTreeRebuildRateHintPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 124 >> 2] | 0;
}

function __Z39Application_CUSTOM_GetStackTraceLogType7LogType(i1) {
 i1 = i1 | 0;
 return __Z20GetStackTraceLogType7LogType(i1) | 0;
}

function __Z39AndroidJNI_CUSTOM_SetDoubleArrayElement13Il2Cpp_IntPtrid(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 return;
}

function __Z38Input_Set_Custom_PropMultiTouchEnabledh(i1) {
 i1 = i1 | 0;
 __Z20SetMultiTouchEnabledb(i1 << 24 >> 24 != 0);
 return;
}

function __Z38AndroidJNI_CUSTOM_SetStaticDoubleField13Il2Cpp_IntPtrS_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 return;
}

function __Z38AndroidJNI_CUSTOM_GetFloatArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(0.0);
}

function __Z37AndroidJNI_CUSTOM_GetStaticFloatField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(0.0);
}

function __Z36getPxVehicleWheels_RigidDynamicActorPKN5physx15PxVehicleWheelsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __Z36AndroidJNI_CUSTOM_SetIntArrayElement13Il2Cpp_IntPtrii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z35AndroidJNI_CUSTOM_SetStaticIntField13Il2Cpp_IntPtrS_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z33Register_UnityEngine_Random_Rangev() {
 __Z27scripting_add_internal_callPKcPKv(gb + 554736 | 0, fb + 11 | 0);
 return;
}

function __Z32scripting_class_get_assemblynameP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_assemblyname(i1 | 0) | 0;
}

function __Z32Register_UnityEngine_WWW_InitWWWv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 580762 | 0, fb + 248 | 0);
 return;
}

function __Z31getPxSceneDescMeshContactMarginPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __Z31Register_UnityEngine_Mesh_Clearv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 547455 | 0, fb + 2997 | 0);
 return;
}

function __Z30getPxVehicleTireDataMLatStiffXPKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z27getPxClothParticleInvWeightPKN5physx15PxClothParticleE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 12 >> 2]);
}

function __Z26getPxCapsuleGeometryRadiusPKN5physx17PxCapsuleGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z23CalculateLightQuadFacSqRKf(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_fround(25.0) / Math_fround(HEAPF32[i1 >> 2]));
}

function __Z21setPxMaterialUserDataPN5physx10PxMaterialEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z14StringToUInt64PKc(i1) {
 i1 = i1 | 0;
 i1 = _strtoull(i1, 0, 10) | 0;
 setTempRet0(getTempRet0() | 0);
 return i1 | 0;
}

function _UNITY_png_set_read_status_fn(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 540 >> 2] = i2;
 return;
}

function _UNITY_FT_Init_Class_cff_service_get_cmap_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 1088;
 return;
}

function _send(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _sendto(i1, i2, i3, i4, 0, 0) | 0;
}

function _malloc_footprint_limit() {
 var i1 = 0;
 i1 = HEAP32[gb + 1470404 + 440 >> 2] | 0;
 return ((i1 | 0) == 0 ? -1 : i1) | 0;
}

function _glGetUniformiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetUniformiv(i1 | 0, i2 | 0, i3 | 0);
}

function _glGetProgramiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetProgramiv(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glDeleteTextures__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDeleteTextures(i1 | 0, i2 | 0);
}

function _emscripten_glBindProgramARB__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBindProgramARB(i1 | 0, i2 | 0);
}

function __ZThn32_N13TrailRendererD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN13TrailRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__214codecvt_bynameIwc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 return;
}

function __ZNSt3__214__codecvt_utf8IwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__27codecvtIwc11__mbstate_tED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK6Shader11IsSupportedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) != (HEAP32[gb + 1166244 >> 2] | 0) | 0;
}

function __ZNK5physx6shdfnd10Foundation24getReportAllocationNamesEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 40 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 464 >> 2]);
}

function __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) == (gb + 669663 | 0) | 0;
}

function __ZNK5physx2Sc5Scene7isValidEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i1 + 1204 >> 2] | 0) + 1e3 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 1e3 >> 2] | 0) + 6172 | 0;
}

function __ZNK5physx2Sc16ArticulationCore22getSeparationToleranceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7getTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK5physx16PxsBroadPhaseMBP12getNbRegionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 84 >> 2] | 0) + 8 >> 2] | 0;
}

function __ZNK5physx10PxsContext17getCurrentCCDPassEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 92 >> 2] | 0;
}

function __ZNK24TreeIntermediateRenderer8GetLayerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 268 >> 2] | 0) + 132 >> 2] | 0;
}

function __ZNK24MeshIntermediateRenderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 284 >> 2] | 0;
}

function __ZNK18AnimatorController28HasMultiThreadedStateMachineEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 152 >> 0] | 0) != 0 | 0;
}

function __ZNK14ParticleSystem18GetSimulationSpaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 280 >> 2] | 0;
}

function __ZN8Animator40GetAllowConstantClipSamplingOptimizationEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 560 >> 0] | 0) != 0 | 0;
}

function __ZN7mecanim9animation16ControllerMemory8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7ApiGLES11LinkProgramEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(HEAP32[i1 + 520 >> 2] | 0, i2 | 0);
 return;
}

function __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 20 >> 2] = i1;
 return;
}

function __ZN5physx6shdfnd7PAUtils9statEventEtjj(i4, i1, i3, i2) {
 i4 = i4 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx3Cct11SweptVolumeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 86080 + 8;
 HEAP32[i1 + 36 >> 2] = 2;
 return;
}

function __ZN5physx2Sn5ConvX16resetConvexFlagsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 HEAP32[i1 + 28 >> 2] = 0;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu13RTreeMidphaseC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 __ZN5physx2Gu5RTreeC2Ev(i1 + 16 | 0);
 return;
}

function __ZN5physx20PxcNpCacheStreamPair5resetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN5physx16PxsSolverEndTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra15SystemAllocator8allocateEjPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _malloc(i2) | 0;
}

function __ZN4FMOD8ChannelI19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN24AudioScriptBufferManager15DidReloadDomainEv(i1) {
 i1 = i1 | 0;
 __ZN24AudioScriptBufferManager4InitEv(i1);
 return;
}

function __ZN22BaseUnityConnectClient8SetStateENS_5StateE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN16ParticleRenderer22UpdateParticleRendererEv(i1) {
 i1 = i1 | 0;
 __ZN8Renderer18UpdateManagerStateEb(i1, 1);
 return;
}

function __ZN14UnityWebStream6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN14CachingManager21SetCompressionEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 9 >> 0] = i2 & 1;
 return;
}

function __ZN14AreaEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13TextRendering17SetITextRenderingEPNS_14ITextRenderingE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162168 >> 2] = i1;
 return;
}

function __ZN13ScreenManager20RequestSetFullscreenEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = i2 & 1;
 return;
}

function __ZN13OcclusionAreaD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN13GfxDeviceNull19SetUserBackfaceModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 4381 >> 0] = i2 & 1;
 return;
}

function __ZN12b2MouseJoint15SetDampingRatioEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 88 >> 2] = f2;
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15PlatformWrapper22GetDeviceSystemVersionEv() {
 return __ZN10systeminfo22GetDeviceSystemVersionEv() | 0;
}

function __ZN11UnityEngine15CloudWebService14RestDownloader6IsDoneEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 4 >> 0] | 0) != 0 | 0;
}

function __ZN10EventEntry9PreInvokeEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 12 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __Z45PhysicMaterial_Set_Custom_PropStaticFriction2P12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z44GUIUtility_CUSTOM_Internal_GetPixelsPerPointv() {
 return Math_fround(HEAPF32[(__Z11GetGUIStatev() | 0) + 344 >> 2]);
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewLongArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewCharArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewByteArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z43UnityConnectSettings_Get_Custom_PropEnabledv() {
 return HEAP8[(__Z23GetUnityConnectSettingsv() | 0) + 196 >> 0] | 0;
}

function __Z41GUIUtility_Set_Custom_PropKeyboardControli(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) >> 2] = i1;
 return;
}

function __Z36Physics2D_Get_Custom_PropTimeToSleepv() {
 return Math_fround(HEAPF32[(__Z20GetPhysics2DSettingsv() | 0) + 80 >> 2]);
}

function __Z36AudioSettings_Get_Custom_PropDspTimev() {
 return +(+__ZNK12AudioManager10GetDSPTimeEv(__Z15GetAudioManagerv() | 0));
}

function __Z33Register_UnityEngine_GL_TexCoord3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535267 | 0, fb + 2 | 0);
 return;
}

function __Z33Register_UnityEngine_GL_TexCoord2v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535241 | 0, fb + 1 | 0);
 return;
}

function __Z32getPxVehicleDriveTank_DriveModelPKN5physx18PxVehicleDriveTankE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 752 >> 2] | 0;
}

function __Z32Register_UnityEngine_Debug_Breakv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 511605 | 0, fb + 89 | 0);
 return;
}

function __Z32GUI_CUSTOM_Internal_BeginWindowsv() {
 __ZN5IMGUI12BeginWindowsER8GUIStatebb(__Z11GetGUIStatev() | 0, 0, 1);
 return;
}

function __Z28getPxVehicleWheelDataMRadiusPKN5physx18PxVehicleWheelDataE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z26Camera_Get_Custom_PropMainv() {
 return __ZN9Scripting19ScriptingWrapperForEP6Object(__Z14FindMainCamerav() | 0) | 0;
}

function __Z25getPxTolerancesScaleSpeedPKN5physx17PxTolerancesScaleE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z25getPxJointLimitConeZAnglePKN5physx16PxJointLimitConeE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __Z25getPxJointLimitConeYAnglePKN5physx16PxJointLimitConeE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 20 >> 2]);
}

function __Z22getPxSceneDesc_IsValidPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return __ZNK5physx11PxSceneDesc7isValidEv(i1) | 0;
}

function __Z21GetRenderModeSortBias15LightRenderMode(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[gb + 35304 + (i1 << 2) >> 2]);
}

function __Z15SampleEulerHintR9TransformR13AnimationClipf(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return;
}

function _UNITY_FT_Init_Class_tt_service_get_cmap_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 1063;
 return;
}

function __ZThn8_N5physx3Cct17CapsuleControllerD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + -8 + 8 | 0);
 return;
}

function __ZNSt3__218shared_timed_mutex8try_lockEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__219__shared_mutex_base8try_lockEv(i1) | 0;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 12 | 0);
 return;
}

function __ZNK5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4sizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 528 >> 2] | 0;
}

function __ZNK5physx10PxsContext15getCCDMaxPassesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 260 >> 2] | 0;
}

function __ZNK25ThreadsafeLinearAllocator10GetPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i2 + -12 >> 2] | 0;
}

function __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZNK21AssetBundleFileSystem8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __ZNK14StackAllocator10GetPtrSizeEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i2 + -4 >> 2] | 0) >>> 1 | 0;
}

function __ZNK14BillboardAsset9GetHeightEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 32 >> 2] | 0) + 20 >> 2]);
}

function __ZNK14BillboardAsset9GetBottomEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 32 >> 2] | 0) + 24 >> 2]);
}

function __ZNK12TLSAllocatorI14StackAllocatorE10IsAssignedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[gb + 1103852 >> 2] | 0) != 0 | 0;
}

function __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx2Sn5ConvX13resetNbErrorsEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 328 >> 2] = 0;
 HEAP32[i1 + 332 >> 2] = 0;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_ED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Umbra5FloatC2ERKd(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(+HEAPF64[i2 >> 3]);
 return;
}

function __ZN4FMOD8ChannelI19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN4FMOD8ChannelI11getWaveDataEPfii(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return 0;
}

function __ZN25RuntimeAnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23UnityPurchasingSettings11SetTestModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 9 >> 0] = i2 & 1;
 return;
}

function __ZN22UnityAnalyticsSettings11SetTestModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 10 >> 0] = i2 & 1;
 return;
}

function __ZN18ScriptingArguments9GetTypeAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 144 + (i2 << 2) >> 2] | 0;
}

function __ZN15b2FrictionJoint11SetMaxForceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 96 >> 2] = f2;
 return;
}

function __ZN14VehiclesModule14UpdateVehiclesEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 __Z14UpdateVehiclesf(f2);
 return;
}

function __ZN14ParticleSystem17DisableUsesTrailsEv(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[i1 + 32 >> 2] | 0) + 874 >> 0] = 0;
 return;
}

function __ZN14ParticleSystem17DisableUses3DSizeEv(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[i1 + 32 >> 2] | 0) + 871 >> 0] = 0;
 return;
}

function __ZN14CachingManager10GetIsReadyEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 4 >> 2] | 0) + 52 >> 0] | 0) != 0 | 0;
}

function __ZN14AnimationState12SetupFadeoutEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 48 >> 2] = f2;
 return;
}

function __ZN13UploadHandler6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 4 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN13SubstanceData6AddRefEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 8 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN13GfxDeviceNull17CreateRasterStateERK14GfxRasterState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 1451268 | 0;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStream5flushEv(i1) {
 i1 = i1 | 0;
 _fflush(HEAP32[i1 + 8 >> 2] | 0) | 0;
 return 0;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17PlayerLoopHandlerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11AudioModule20SuspendVideoTexturesEv(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTexture20SuspendVideoTexturesEv();
 return;
}

function __Z62UnityEventQueueSystem_CUSTOM_INTERNAL_CALL_GetGlobalEventQueueRPv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z49AudioSettings_Get_Custom_PropProfilerCaptureFlagsv() {
 return HEAP32[(__Z15GetAudioManagerv() | 0) + 292 >> 2] | 0;
}

function __Z47RenderSettings_Get_Custom_PropReflectionBouncesv() {
 return HEAP32[(__Z17GetRenderSettingsv() | 0) + 376 >> 2] | 0;
}

function __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewIntArrayiRPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z37getPxSceneLimitsMaxNbObjectsPerRegionPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __Z34Graphics_CUSTOM_Internal_SetNullRTv() {
 __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij(0, 0, -1, 0, 0);
 return;
}

function __Z33AndroidJNI_CUSTOM_SetBooleanField13Il2Cpp_IntPtrS_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z32AndroidJNI_CUSTOM_SetObjectField13Il2Cpp_IntPtrS_S_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z30getPxVehicleWheels_VehicleTypePKN5physx15PxVehicleWheelsE(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 113 >> 0] | 0 | 0;
}

function __Z27getPxD6JointDriveForceLimitPKN5physx14PxD6JointDriveE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 8 >> 2]);
}

function __Z26Event_CUSTOM_GetEventCountv() {
 return __ZNK15GUIEventManager13GetEventCountEv(__Z18GetGUIEventManagerv() | 0) | 0;
}

function __Z25getPxSphereGeometryRadiusPKN5physx16PxSphereGeometryE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z24getPxTolerancesScaleMassPKN5physx17PxTolerancesScaleE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function b126(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 nullFunc_iiifi(126);
 return 0;
}

function _llvm_ctpop_i64(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return (_llvm_ctpop_i32(i2) | 0) + (_llvm_ctpop_i32(i1) | 0) | 0;
}

function _iswgraph(i1) {
 i1 = i1 | 0;
 if (!(_iswspace(i1) | 0)) i1 = (_iswprint(i1) | 0) != 0; else i1 = 0;
 return i1 & 1 | 0;
}

function _iswalnum(i1) {
 i1 = i1 | 0;
 if (!(_iswdigit(i1) | 0)) i1 = (_iswalpha(i1) | 0) != 0; else i1 = 1;
 return i1 & 1 | 0;
}

function _glGetShaderiv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glGetShaderiv(i1 | 0, i2 | 0, i3 | 0);
}

function _glDeleteTransformFeedbacks__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteTransformFeedbacks(i1 | 0, i2 | 0);
}

function _fileno(i1) {
 i1 = i1 | 0;
 if ((HEAP32[i1 + 76 >> 2] | 0) > -1) ___lockfile(i1) | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function _emscripten_glDeleteBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDeleteBuffers(i1 | 0, i2 | 0);
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 396 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 360 >> 2] | 0;
}

function __ZThn12_N12_GLOBAL__N_110ConnectionD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1 + -12 | 0);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4failEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) != 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4failEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) != 0 | 0;
}

function __ZNKSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentrycvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 >> 0] | 0) != 0 | 0;
}

function __ZNKSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentrycvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 >> 0] | 0) != 0 | 0;
}

function __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentrycvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 >> 0] | 0) != 0 | 0;
}

function __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentrycvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 520 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + 4 | 0;
}

function __ZNK5physx5cloth8SwSolver26getInterCollisionStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZNK5physx3Cct13BoxController21getHalfHeightInternalEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 496 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore18getDynamicFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7getTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK5physx10PxsContext15getNumSweepHitsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 16 >> 2] | 0) + 96 >> 2] | 0;
}

function __ZNK5Umbra9IndexList11getCapacityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] | 0;
}

function __ZNK5Umbra9FloatList11getCapacityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] | 0;
}

function __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZNK14ParticleSystem8IsPausedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[(HEAP32[i1 + 40 >> 2] | 0) + 8 >> 2] | 0) == 2 | 0;
}

function __ZNK14ParticleSystem7GetLoopEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[(HEAP32[i1 + 36 >> 2] | 0) + 277 >> 0] | 0) != 0 | 0;
}

function __ZNK14BillboardAsset8GetWidthEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[(HEAP32[i1 + 32 >> 2] | 0) + 16 >> 2]);
}

function __ZNK13GfxDeviceGLES14GetDeviceLevelEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 540 >> 2] | 0;
}

function __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getStringTableEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 160 >> 2] | 0;
}

function __ZNK11b2EdgeShape9TestPointERK11b2TransformRK6b2Vec2(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9GfxDevice29GetNativeRenderSurfacePointerEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZN9GfxDevice27SetRandomWriteTargetTextureEi9TextureID(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9GfxDevice14ProfileControlENS_17GfxProfileControlEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN7mecanim9animation21GetMuscleCurveTQIndexEi(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) < 42 ? (i1 | 0) % 7 | 0 : -1) | 0;
}

function __ZN5physx9PxTaskMgr14emitStartEventERNS_10PxBaseTaskEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpActorC2EPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 HEAP32[i2 + 4 >> 2] = 0;
 return;
}

function __ZN5physx3Cct13BoxController11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 88 >> 2] = i2;
 return;
}

function __ZN5physx16PxsParticleShape12setUserDataVEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 48 >> 2] = i1;
 return;
}

function __ZN5physx14PxLightCpuTaskD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87404 + 8;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN5Umbra20SingleBlockAllocator10deallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 12 >> 0] = 0;
 return;
}

function __ZN25ThreadsafeLinearAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZN25ThreadsafeLinearAllocatorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN25RuntimeAnimatorControllerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN25RuntimeAnimatorControllerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN24PhysicsUpdateBehaviour2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN20UnityConnectSettings11SetTestModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 197 >> 0] = i2 & 1;
 return;
}

function __ZN19BaseConnectSettings10InitializeER6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN18AsyncUploadManager22WaitForActiveAsyncReadEv(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 8 >> 2] | 0)) return;
 return;
}

function __ZN17PrecomputeContextD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 96 >> 2] | 0;
 if (!i1) return;
 __ZdaPv(i1);
 return;
}

function __ZN17InternalIndexPool11freeIndicesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN16LightmapSettings17GetGIWorkflowModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 8 >> 2] | 0;
}

function __ZN14UnityAnalytics11GetTestModeEv() {
 return (HEAP8[(__Z25GetUnityAnalyticsSettingsv() | 0) + 10 >> 0] | 0) != 0 | 0;
}

function __ZN14ParticleSystem13DidModifyMeshEv(i1) {
 i1 = i1 | 0;
 __ZN11ShapeModule17DidModifyMeshDataEv(i1 + 48 | 0);
 return;
}

function __ZN14AreaEffector2D17SetUseGlobalAngleEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 116 >> 0] = i2 & 1;
 return;
}

function __ZN12_GLOBAL__N_124PropertyDefinitionHelper16clearNamedValuesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 76 >> 2] = 0;
 return;
}

function __ZN12MeshRenderer13DidDeleteMeshEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 340 >> 2] = 0;
 HEAP32[i1 + 344 >> 2] = 0;
 return;
}

function __ZN12AudioManager32ScriptBufferManagerIsInitializedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 296 >> 2] | 0) != 0 | 0;
}

function __ZN11TimeManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28648 + 8;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN11Rigidbody2DD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __Z52Object_CUSTOM_GetOffsetOfInstanceIDInCPlusPlusObjectv() {
 return __ZN6Object27GetOffsetOfInstanceIdMemberEv() | 0;
}

function __Z49SystemInfo_Get_Custom_PropUsesOpenGLTextureCoordsv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 104 >> 0] | 0;
}

function __Z49SystemInfo_Get_Custom_PropSupportsRenderToCubemapv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 500 >> 0] | 0;
}

function __Z49SystemInfo_Get_Custom_PropSupports2DArrayTexturesv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 482 >> 0] | 0;
}

function __Z48Application_Get_Custom_PropIsShowingSplashScreenv() {
 return (__Z26IsSplashScreenFadeCompletev() | 0) & 1 ^ 1 | 0;
}

function __Z47NavMesh_CUSTOM_GetPathfindingIterationsPerFramev() {
 return HEAP32[(__Z17GetNavMeshManagerv() | 0) + 36 >> 2] | 0;
}

function __Z46Physics_Get_Custom_PropDefaultSolverIterationsv() {
 return HEAP32[(__Z17GetPhysicsManagerv() | 0) + 168 >> 2] | 0;
}

function __Z45Physics2D_Get_Custom_PropShowColliderContactsv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 97 >> 0] | 0;
}

function __Z45Physics2D_Get_Custom_PropChangeStopsCallbacksv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 94 >> 0] | 0;
}

function __Z38getPxSceneDescCcdContactModifyCallbackPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __Z38Shader_Set_Custom_PropGlobalMaximumLODi(i1) {
 i1 = i1 | 0;
 __ZN6Shader25SetGlobalMaximumShaderLODEi(i1);
 return;
}

function __Z33getNbPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __Z33getNbPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __Z31getPxClothParticleDataParticlesPKN5physx19PxClothParticleDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z31Register_UnityEngine_GL_Vertex3v() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535105 | 0, fb + 1 | 0);
 return;
}

function __Z30getPxVehicleGearsDataMNbRatiosPKN5physx18PxVehicleGearsDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 132 >> 2] | 0;
}

function __Z29Register_UnityEngine_GL_Flushv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 536188 | 0, fb + 108 | 0);
 return;
}

function __Z27Input_Get_Custom_PropAnyKeyv() {
 return (__ZN12InputManager9GetAnyKeyEv(__Z15GetInputManagerv() | 0) | 0) & 1 | 0;
}

function __Z25GfxDeviceAdvanceFrameGLESv() {
 __ZN17BufferManagerGLES12AdvanceFrameEv(__Z20GetBufferManagerGLESv() | 0);
 return;
}

function b2(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 nullFunc_fiff(2);
 return Math_fround(0);
}

function _noop_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 HEAP32[i4 >> 2] = 0;
 return;
}

function _glGetUniformLocation__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _glGetUniformLocation(i1 | 0, i2 | 0) | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 372 >> 2] | 0;
}

function __ZThn28_N14PhysicsManager7onSleepEPPN5physx7PxActorEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 4 | 0);
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 8 | 0);
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1 + 8 | 0);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3eofEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 2 | 0) != 0 | 0;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3badEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 1 | 0) != 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3eofEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 2 | 0) != 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3badEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 1 | 0) != 0 | 0;
}

function __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK9dtNavMesh7getTileEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + (i2 * 56 | 0) | 0;
}

function __ZNK7dtCrowd26getObstacleAvoidanceParamsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + 264 + (i2 * 20 | 0) | 0;
}

function __ZNK7b2World14GetTreeBalanceEv(i1) {
 i1 = i1 | 0;
 return __ZNK13b2DynamicTree13GetMaxBalanceEv(i1 + 102872 | 0) | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 532 >> 2] | 0;
}

function __ZNK5physx5cloth8SwSolver25getInterCollisionDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __ZNK5physx3Ext20DefaultCpuDispatcher14getRunProfiledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 33 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx3Cct13BoxController20getHalfForwardExtentEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 504 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore17getStaticFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 88 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 112 >> 2]);
}

function __ZNK5physx2Sc15ArticulationSim28debugCheckWakeCounterOfLinksEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZNK14ParticleSystem16GetParticleCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 12 >> 2] | 0;
}

function __ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1103852 >> 2] | 0;
}

function __ZN9GfxDevice17SetComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx9PxTaskMgr13emitStopEventERNS_10PxBaseTaskEj(i2, i1, i3) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE15clearCachedDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm4Task3runEv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[(HEAP32[i1 >> 2] | 0) + 32 >> 2] | 0, i1 | 0);
 return;
}

function __ZN5Unity5JointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN4FMOD6SoundI15getNumSubSoundsEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN23PreloadManagerOperation11SetPriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 56 >> 2] = i2;
 return;
}

function __ZN21AssetBundleFileSystem6DeleteER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN20UnityConnectSettings10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 196 >> 0] = i2 & 1;
 return;
}

function __ZN18ScriptingArguments11GetDoubleAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+HEAPF64[i1 + (i2 << 3) >> 3]);
}

function __ZN14PlayerSettings19SetWiiUTVResolutionEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 504 >> 2] = i2;
 return;
}

function __ZN14DataBufferGLES12RecordUpdateEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 28 >> 2] = HEAP32[HEAP32[i1 >> 2] >> 2];
 return;
}

function __ZN14DataBufferGLES12RecordRenderEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = HEAP32[HEAP32[i1 >> 2] >> 2];
 return;
}

function __ZN14CachingManager18GetExpirationDelayEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 48 >> 2] | 0;
}

function __ZN13GfxDeviceNull16CreateDepthStateERK13GfxDepthState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 1548981 | 0;
}

function __ZN13GfxDeviceNull16CreateBlendStateERK13GfxBlendState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 1451292 | 0;
}

function __ZN12b2MouseJoint12SetFrequencyEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 84 >> 2] = f2;
 return;
}

function __ZN12b2MouseJoint11SetMaxForceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 104 >> 2] = f2;
 return;
}

function __ZN12b2MotorJoint12SetMaxTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 96 >> 2] = f2;
 return;
}

function __ZN11AudioModule19UpdateVideoTexturesEv(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTexture19UpdateVideoTexturesEv();
 return;
}

function __ZN11AudioModule19ResumeVideoTexturesEv(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTexture19ResumeVideoTexturesEv();
 return;
}

function __ZN10MeshFilterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZL19UnityDetourFreeTempPv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 64016 | 0);
 return;
}

function __Z69ThreadAndSerializationSafeCheckSetMonoBehaviourConstructorBeingCalledP13MonoBehaviour(i1) {
 i1 = i1 | 0;
 return;
}

function __Z48SystemInfo_Get_Custom_PropSupportsComputeShadersv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 494 >> 0] | 0;
}

function __Z48SystemInfo_Get_Custom_PropGraphicsDeviceVendorIDv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 80 >> 2] | 0;
}

function __Z48Application_Get_Custom_PropGenuineCheckAvailablev() {
 return (__Z29IsApplicationGenuineAvailablev() | 0) & 1 | 0;
}

function __Z47AudioSettings_Get_Custom_PropDriverCapabilitiesv() {
 return HEAP32[(__Z15GetAudioManagerv() | 0) + 116 >> 2] | 0;
}

function __Z44Physics2D_Get_Custom_PropAlwaysShowCollidersv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 95 >> 0] | 0;
}

function __Z43Physics_Set_Custom_PropSleepAngularVelocityf(f1) {
 f1 = Math_fround(f1);
 __Z17GetPhysicsManagerv() | 0;
 return;
}

function __Z43Physics2D_Get_Custom_PropVelocityIterationsv() {
 return HEAP32[(__Z20GetPhysics2DSettingsv() | 0) + 40 >> 2] | 0;
}

function __Z43Physics2D_Get_Custom_PropPositionIterationsv() {
 return HEAP32[(__Z20GetPhysics2DSettingsv() | 0) + 44 >> 2] | 0;
}

function __Z37getPxSceneDescSimulationEventCallbackPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __Z37Time_Get_Custom_PropUnscaledDeltaTimev() {
 return Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 184 >> 3]);
}

function __Z36getPxSceneDescMaxNbContactDataBlocksPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 140 >> 2] | 0;
}

function __Z34scripting_liveness_calculation_endPv(i1) {
 i1 = i1 | 0;
 _il2cpp_unity_liveness_calculation_end(i1 | 0);
 return;
}

function __Z32getNbPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __Z31AndroidJNI_CUSTOM_SetShortField13Il2Cpp_IntPtrS_s(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z26getPxTolerancesScaleLengthPKN5physx17PxTolerancesScaleE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z23scripting_gchandle_freej(i1) {
 i1 = i1 | 0;
 if ((i1 | 0) == -1) return;
 _il2cpp_gchandle_free(i1 | 0);
 return;
}

function __Z21CalculateLightQuadFacf(f1) {
 f1 = Math_fround(f1);
 return Math_fround(Math_fround(25.0) / Math_fround(f1 * f1));
}

function __Z20scripting_string_newPKcj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _il2cpp_string_new_len(i1 | 0, i2 | 0) | 0;
}

function __Z14ComputeMD5HashPKhjPh(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 __Z3md5PhiS_(i1, i2, i3);
 return 1;
}

function b35(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 nullFunc_iiiif(35);
 return 0;
}

function b32(d1, d2, d3, d4, d5, d6) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 d4 = +d4;
 d5 = +d5;
 d6 = +d6;
 nullFunc_vdddddd(32);
}

function b30(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 nullFunc_iifii(30);
 return 0;
}

function _tt_cmap14_get_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 + 4 >> 2] = 14;
 HEAP32[i2 >> 2] = -1;
 return 0;
}

function _strtoul_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _strtoul(i1, i2, i3) | 0;
}

function _setbuffer(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _setvbuf(i1, i2, i2 | 0 ? 0 : 2, i3) | 0;
 return;
}

function _jsimd_idct_islow(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jsimd_idct_ifast(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jsimd_idct_float(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _iswspace(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 0; else i1 = (_wcschr(gb + 206544 | 0, i1) | 0) != 0;
 return i1 & 1 | 0;
}

function _glUniform4iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform4iv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform4fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform4fv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform3iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform3iv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform3fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform3fv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform2iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform2iv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform2fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform2fv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform1iv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform1iv(i1 | 0, i2 | 0, i3 | 0);
}

function _glUniform1fv__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glUniform1fv(i1 | 0, i2 | 0, i3 | 0);
}

function _glDrawArrays__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _glDrawArrays(i1 | 0, i2 | 0, i3 | 0);
}

function _emscripten_glUniform1f__wrapper(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 _emscripten_glUniform1f(i1 | 0, +f2);
}

function _emscripten_glDetachShader__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDetachShader(i1 | 0, i2 | 0);
}

function _emscripten_glAttachShader__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glAttachShader(i1 | 0, i2 | 0);
}

function __ZThn8_N12_GLOBAL__N_110ConnectionD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1 + -8 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 408 >> 2] | 0;
}

function __ZThn4_N12_GLOBAL__N_110DataStreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110DataStreamD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn4_N12_GLOBAL__N_110ConnectionD1Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn28_N14PhysicsManager6onWakeEPPN5physx7PxActorEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt12experimental19bad_optional_accessD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEcvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) == 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEcvbEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) == 0 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + 4 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 540 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore18getFreezeThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 28 >> 2]);
}

function __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK20BufferedSocketStream23IsArtificiallyConnectedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 19 >> 0] | 0) != 0 | 0;
}

function __ZNK19TouchPhaseEmulation24IsTouchPressureSupportedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 20 >> 0] | 0) != 0 | 0;
}

function __ZNK14PhysicsManager23GetPvdConnectionEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[gb + 1457416 >> 2] | 0) != 0 | 0;
}

function __ZNK14ParticleSystem14GetScalingModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 284 >> 2] | 0;
}

function __ZNK13GfxDeviceGLES26HasActiveRandomWriteTargetEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 7196 >> 2] | 0) != -1 | 0;
}

function __ZN7mecanim9animation12AvatarMemory8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7Texture16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 __ZN15TextureSettings16CheckConsistencyEv(i1 + 32 | 0);
 return;
}

function __ZN5physx6shdfnd6Socket6listenEtPNS1_10ConnectionE(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx19NpArticulationJoint8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx12NpBatchQuery11setRunOnSpuEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 128 >> 0] = i1 & 1;
 return;
}

function __ZN4FMOD7SystemI13getNumDriversEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 1;
 return 0;
}

function __ZN30RuntimeInitializeOnLoadManager13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN26AnimatorControllerPlayable17IsMultithreadableEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 152 >> 0] | 0) != 0 | 0;
}

function __ZN24RingBufferMemoryFileDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN24RingBufferMemoryFileDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19CharacterController24GetEnableOverlapRecoveryEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 152 >> 0] | 0) != 0 | 0;
}

function __ZN18ScriptingArguments11GetIntPtrAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + (i2 << 3) >> 2] | 0;
}

function __ZN17ArchiveFileSystem9MakeLocalER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN15ConstantForce2D9SetTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 64 >> 2] = f2;
 return;
}

function __ZN13WebCamTexture16CaptureNextFrameEP28PlatformDependentCaptureData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13SpeedTreeWind20AdvanceWithoutUpdateEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 HEAPF64[i1 + 1392 >> 3] = d2;
 return;
}

function __ZN12b2MotorJoint11SetMaxForceEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 92 >> 2] = f2;
 return;
}

function __ZN12_GLOBAL__N_110DataStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110DataStreamD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_110ConnectionD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12_GLOBAL__N_110ConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE12NeedsPollingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN10GISettings14SetAlbedoBoostEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 8 >> 2] = f2;
 return;
}

function __ZL35FindAndLoadUnityPluginIl2CppWrapperPKc(i1) {
 i1 = i1 | 0;
 return __Z22FindAndLoadUnityPluginPKcPPv(i1, 0) | 0;
}

function __Z47AudioSettings_Get_Custom_PropUnityAudioDisabledv() {
 return HEAP8[(__Z15GetAudioManagerv() | 0) + 224 >> 0] | 0;
}

function __Z46SystemInfo_Get_Custom_PropMaxRenderTextureSizev() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 132 >> 2] | 0;
}

function __Z43Physics2D_Get_Custom_PropQueriesHitTriggersv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 92 >> 0] | 0;
}

function __Z42Screen_Get_Custom_PropAutorotateToPortraitv() {
 return HEAP32[(__Z16GetScreenManagerv() | 0) + 32 >> 2] & 1 | 0;
}

function __Z41AudioChorusFilter_Set_Custom_PropFeedbackP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z41Animator_Set_Custom_PropRecorderStartTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z3sqrIfET_RKS0_(i1) {
 i1 = i1 | 0;
 var f2 = f0;
 f2 = Math_fround(HEAPF32[i1 >> 2]);
 return Math_fround(f2 * f2);
}

function __Z34getPxSceneLimitsMaxNbDynamicShapesPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __Z30AndroidJNI_CUSTOM_SetCharField13Il2Cpp_IntPtrS_t(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z30AndroidJNI_CUSTOM_SetByteField13Il2Cpp_IntPtrS_h(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z30AndroidJNI_CUSTOM_GetLongField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __Z27Register_UnityEngine_GL_Endv() {
 __Z27scripting_add_internal_callPKcPKv(gb + 535429 | 0, fb + 102 | 0);
 return;
}

function __Z22Mesh_CUSTOM_ResizeListP12Il2CppObjecti(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 12 >> 2] = i2;
 return;
}

function _UNITY_FT_Outline_Embolden(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _UNITY_FT_Outline_EmboldenXY(i1, i2, i2) | 0;
}

function _UNITY_FT_Init_Class_sfnt_service_ps_name(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 2631;
 return;
}

function b68(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 nullFunc_viiiii(68);
}

function _ispunct(i1) {
 i1 = i1 | 0;
 if (!(_isgraph(i1) | 0)) i1 = 0; else i1 = (_isalnum(i1) | 0) == 0;
 return i1 & 1 | 0;
}

function _glGetAttribLocation__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _glGetAttribLocation(i1 | 0, i2 | 0) | 0;
}

function __ZThn8_N5physx3Cct13BoxControllerD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + -8 + 8 | 0);
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 544 >> 2] | 0;
}

function __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEntEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) != 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEntEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] & 5 | 0) != 0 | 0;
}

function __ZNK8LODGroup6GetLODEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (HEAP32[i1 + 56 >> 2] | 0) + (i2 * 28 | 0) | 0;
}

function __ZNK8Gradient16GetConstantColorEv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = HEAP32[i2 >> 2];
 return;
}

function __ZNK7WeakPtrIN11SoundHandle8InstanceEE10SharedData9GetRawPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK6Shader23GetActiveSubShaderIndexEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 48 >> 2] | 0;
}

function __ZNK5physx3Cct26CharacterControllerManager16getNbControllersEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 68 >> 2] | 0;
}

function __ZNK5physx31PxClothGeodesicTetherCookerImpl15getCookerStatusEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 132 >> 1] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore17getSleepThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 24 >> 2]);
}

function __ZNK5physx2Gu11HeightField22getConvexEdgeThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 44 >> 2]);
}

function __ZNK5physx10NpMaterial25getRestitutionCombineModeEv(i1) {
 i1 = i1 | 0;
 return (HEAPU8[i1 + 46 >> 0] | 0) & 15 | 0;
}

function __ZNK21AssetBundleFileSystem4SizeERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __ZNK14ParticleSystem13GetRandomSeedEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 272 >> 2] | 0;
}

function __ZNK14BillboardAsset14GetNumVerticesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 60 >> 2] | 0;
}

function __ZNK13WheelCollider29GetGlobalSpringTargetPositionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZN9BehaviourD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN6SocketD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65564 + 8;
 _close(HEAP32[i1 + 4 >> 2] | 0) | 0;
 return;
}

function __ZN5physx9NpPhysics13getFoundationEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx6shdfnd10Foundation11getInstanceEv() | 0;
}

function __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Ext23DefaultBufferedProfiler21getProfileZoneManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN5physx2Sn5ConvX9exportIntEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN5physx2Sn5ConvX6outputEi(i1, i2);
 return;
}

function __ZN5physx2Sn13XmlNodeReader18getCurrentItemNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[i1 + 12 >> 2] >> 2] | 0;
}

function __ZN5physx2Sc16ArticulationCore10putToSleepEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 32 >> 2] = Math_fround(0.0);
 return;
}

function __ZN5physx2Sc14ConstraintCore10breakApartEv(i1) {
 i1 = i1 | 0;
 HEAP16[i1 >> 1] = HEAPU16[i1 >> 1] | 0 | 1;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD7SystemI19setSoftwareChannelsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 40 >> 2] = i2;
 return 0;
}

function __ZN19StreamedBinaryWriteILb1EE5AlignEv(i1) {
 i1 = i1 | 0;
 __ZN12CachedWriter11Align4WriteEv(i1 + 16 | 0);
 return;
}

function __ZN19StreamedBinaryWriteILb0EE5AlignEv(i1) {
 i1 = i1 | 0;
 __ZN12CachedWriter11Align4WriteEv(i1 + 16 | 0);
 return;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17MemoryCacheReader13GetFileLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 2] | 0;
}

function __ZN16UnityAdsSettings10InitializeER6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN16MemoryFileSystem9MakeLocalER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN14ComplementExprI8Scalar4fEC2ERKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2ERKS_(i1, i2);
 return;
}

function __ZN13MonoBehaviour15SetUseGUILayoutEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 142 >> 0] = i2 & 1;
 return;
}

function __ZN13GfxDeviceNull28DestroyRenderSurfacePlatformEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull25SetShaderPropertiesCopiedERK19ShaderPropertySheet(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12InputManager30GetEatKeyPressOnTextFieldFocusEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 169 >> 0] | 0) != 0 | 0;
}

function __ZN11AudioModule18PauseVideoTexturesEv(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTexture18PauseVideoTexturesEv();
 return;
}

function __Z47SystemInfo_Get_Custom_PropOperatingSystemFamilyv() {
 return __ZN10systeminfo24GetOperatingSystemFamilyEv() | 0;
}

function __Z43QualitySettings_Get_Custom_PropCurrentLevelv() {
 return HEAP32[(__Z18GetQualitySettingsv() | 0) + 44 >> 2] | 0;
}

function __Z42Physics2D_Get_Custom_PropShowColliderSleepv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 96 >> 0] | 0;
}

function __Z40Animator_Set_Custom_PropRecorderStopTimeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z36Time_Get_Custom_PropMaximumDeltaTimev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 200 >> 2]);
}

function __Z35getPxSceneDescContactModifyCallbackPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __Z32AndroidJNI_CUSTOM_SetDoubleField13Il2Cpp_IntPtrS_d(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 return;
}

function __Z31AndroidJNI_CUSTOM_GetFloatField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(0.0);
}

function __Z29scripting_class_instance_sizeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_instance_size(i1 | 0) | 0;
}

function __Z29scripting_class_get_namespaceP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_namespace(i1 | 0) | 0;
}

function __Z29scripting_class_enum_basetypeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_enum_basetype(i1 | 0) | 0;
}

function __Z29getPxClothFabricPhaseSetIndexPKN5physx18PxClothFabricPhaseE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z29AndroidJNI_CUSTOM_SetIntField13Il2Cpp_IntPtrS_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _UNITY_FT_Init_Class_cff_service_ps_name(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = fb + 2643;
 return;
}

function b90(i1, i2, f3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 f4 = Math_fround(f4);
 nullFunc_viiff(90);
}

function b46(i1, f2, f3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 nullFunc_viffi(46);
}

function _unzOpenCurrentFilePassword(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _unzOpenCurrentFile3(i1, 0, 0, 0, i2) | 0;
}

function _unity_z_zcalloc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _malloc(Math_imul(i3, i2) | 0) | 0;
}

function _strtol_l(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _strtol(i1, i2, i3) | 0;
}

function _jsimd_idct_4x4(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jsimd_idct_2x2(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return;
}

function _jround_up(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = i1 + -1 + i2 | 0;
 return i1 - ((i1 | 0) % (i2 | 0) | 0) | 0;
}

function _emscripten_glPixelStorei__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glPixelStorei(i1 | 0, i2 | 0);
}

function _emscripten_glGetPointerv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGetPointerv(i1 | 0, i2 | 0);
}

function _emscripten_glGetIntegerv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGetIntegerv(i1 | 0, i2 | 0);
}

function _emscripten_glGetBooleanv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGetBooleanv(i1 | 0, i2 | 0);
}

function _emscripten_glGenTextures__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGenTextures(i1 | 0, i2 | 0);
}

function _emscripten_glDrawBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glDrawBuffers(i1 | 0, i2 | 0);
}

function _emscripten_glDisableVertexAttribArray__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDisableVertexAttribArray(i1 | 0);
}

function _emscripten_glBindTexture__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBindTexture(i1 | 0, i2 | 0);
}

function ___cxa_throw__wrapper(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 ___cxa_throw(i1 | 0, i2 | 0, i3 | 0);
}

function __ZThn8_N5physx19TriangleMeshBuilderD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu12TriangleMeshD2Ev(i1 + -8 | 0);
 return;
}

function __ZThn80_NK26AnimatorControllerPlayable25GetStateMachineBehavioursEv(i1) {
 i1 = i1 | 0;
 return i1 + -80 + 112 | 0;
}

function __ZThn32_N22ParticleSystemRendererD1Ev(i1) {
 i1 = i1 | 0;
 __ZN22ParticleSystemRendererD2Ev(i1 + -32 | 0);
 return;
}

function __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217__assoc_sub_stateD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__217__assoc_sub_stateD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214collate_bynameIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__214collate_bynameIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214collate_bynameIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__214collate_bynameIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4goodEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) == 0 | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4goodEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) == 0 | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8max_sizeEv(i1) {
 i1 = i1 | 0;
 return 1073741807;
}

function __ZNK5physx3Cct13BoxController17getHalfSideExtentEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 500 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore14getRestitutionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 108 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore26getMaxProjectionIterationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 172 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK26AnimatorControllerPlayable13IsInitializedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 100 >> 2] | 0) != 0 | 0;
}

function __ZNK19TouchPhaseEmulation22IsStylusTouchSupportedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 21 >> 0] | 0) != 0 | 0;
}

function __ZNK15b2DistanceJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(0.0);
}

function __ZNK14BillboardAsset13GetNumIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 80 >> 2] | 0;
}

function __ZN9Coroutine22CompareCoroutineDirectEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 | 0) == (i2 | 0) | 0;
}

function __ZN8Renderer23NotifySceneHandleChangeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 284 >> 2] = i2;
 return;
}

function __ZN6Camera16TransformChangedEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1076 >> 0] = 1;
 HEAP8[i1 + 1078 >> 0] = 1;
 return;
}

function __ZN5physx9PxTaskMgr19initializeProfilingERNS_20PxProfileZoneManagerE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd10checkValidERKf(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] & 2139095040) >>> 0 < 2139095040 | 0;
}

function __ZN5physx6shdfnd10FoundationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd10FoundationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 834990 | 0;
}

function __ZN5Umbra4Math5floorENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_floor(Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math4atanENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_atan(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math4asinENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_asin(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math4acosENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_acos(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN4gles14IsDummySurfaceEP17RenderSurfaceBase(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 20 >> 2] & 64 | 0) != 0 | 0;
}

function __ZN23iPhoneLocalNotification17SetRepeatCalendarE18CalendarIdentifier(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN23UnityPurchasingSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 HEAP8[i1 + 9 >> 0] = 0;
 return;
}

function __ZN23ForwardShaderRenderLoopD0Ev(i1) {
 i1 = i1 | 0;
 __ZN23ForwardShaderRenderLoopD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN23CloudWebServicesManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN23CloudWebServicesManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN22MemoryCacherReadBlocks18GetAddressOfMemoryEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 73348 + 8;
 return;
}

function __ZN19BaseConnectSettings10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 8 >> 0] = i2 & 1;
 return;
}

function __ZN18LoadSceneOperation23GetAllowSceneActivationEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 468 >> 0] | 0) != 0 | 0;
}

function __ZN17GlobalGameManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15NavMeshSettings17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN11GameManager17MainThreadCleanupEv(i1);
 return;
}

function __ZN13SpeedTreeWind13EnableGustingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 1400 >> 0] = i2 & 1;
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE7hasDataEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN11UnityEngine15PlatformWrapper9IsAndroidEv() {
 return (__ZN10systeminfo18GetRuntimePlatformEv() | 0) == 11 | 0;
}

function __ZN11UnityEngine15PlatformWrapper20GetRuntimePlatformIdEv() {
 return __ZN10systeminfo18GetRuntimePlatformEv() | 0;
}

function __ZN11UnityEngine15PlatformWrapper19GetPhysicalMemoryMBEv() {
 return __ZN10systeminfo19GetPhysicalMemoryMBEv() | 0;
}

function __ZN11UnityEngine15PlatformWrapper19GetDeviceSystemNameEv() {
 return __ZN10systeminfo19GetDeviceSystemNameEv() | 0;
}

function __ZN11UnityEngine15PlatformWrapper13GetShaderCapsEv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0;
}

function __ZN10GCProfiler18PrintDetailedStatsEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 20 >> 0] = i2 & 1;
 return;
}

function __ZN10AudioMixer21UpdateCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZL30MonoBehaviourGetObjectGUIStatePv(i1) {
 i1 = i1 | 0;
 return __ZN13MonoBehaviour17GetObjectGUIStateEv(i1) | 0;
}

function __Z46QualitySettings_Get_Custom_PropMaxQueuedFramesv() {
 return HEAP32[(__Z12GetGfxDevicev() | 0) + 4392 >> 2] | 0;
}

function __Z45SystemInfo_Get_Custom_PropUsesReversedZBufferv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 105 >> 0] | 0;
}

function __Z45SystemInfo_Get_Custom_PropGraphicsShaderLevelv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 88 >> 2] | 0;
}

function __Z45Input_Get_Custom_PropSimulateMouseWithTouchesv() {
 return HEAP8[(__Z15GetInputManagerv() | 0) + 190 >> 0] | 0;
}

function __Z44SystemInfo_Get_Custom_PropCopyTextureSupportv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 528 >> 2] | 0;
}

function __Z43SystemInfo_Get_Custom_PropSupportsVibrationv() {
 return (__ZN10systeminfo17SupportsVibrationEv() | 0) & 1 | 0;
}

function __Z42Application_Get_Custom_PropRunInBackgroundv() {
 return (__Z32GetPlayerSettingsRunInBackgroundv() | 0) & 1 | 0;
}

function __Z41Physics2D_Get_Custom_PropShowColliderAABBv() {
 return HEAP8[(__Z20GetPhysics2DSettingsv() | 0) + 98 >> 0] | 0;
}

function __Z39Light_Set_Custom_PropShadowSoftnessFadeP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z35Time_Get_Custom_PropSmoothDeltaTimev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 116 >> 2]);
}

function __Z34getPxSceneDescFilterShaderDataSizePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __Z33getPxSceneLimitsMaxNbStaticShapesPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z33getPxSceneDescNbContactDataBlocksPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 136 >> 2] | 0;
}

function __Z32getPxSceneLimitsMaxNbConstraintsPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __Z30HumanTrait_CUSTOM_RequiredBonei(i1) {
 i1 = i1 | 0;
 return (__ZN10HumanTrait12RequiredBoneEi(i1) | 0) & 1 | 0;
}

function __Z29getPxHeightFieldDescNbColumnsPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z27AsyncReadForceCloseAllFilesv() {
 __ZN13OpenFileCache13ForceCloseAllEv(HEAP32[gb + 1155100 >> 2] | 0);
 return;
}

function __Z22ValidateTlsfAllocationPvjiS_(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function __Z18setPxShapeUserDataPN5physx7PxShapeEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z18setPxSceneUserDataPN5physx7PxSceneEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return;
}

function __Z18setPxJointUserDataPN5physx7PxJointEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z18setPxActorUserDataPN5physx7PxActorEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 8 >> 2] = i1;
 return;
}

function __Z15IsFloatRTFormat19RenderTextureFormat(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 14 | (i1 + -11 | 0) >>> 0 < 2 | 0;
}

function _UNITY_LZ4_createStream() {
 var i1 = 0;
 i1 = _calloc(8, 2052) | 0;
 _memset(i1 | 0, 0, 16416) | 0;
 return i1 | 0;
}

function _UNITY_FT_Outline_GetOutsideBorder(i1) {
 i1 = i1 | 0;
 return (_UNITY_FT_Outline_Get_Orientation(i1) | 0) != 0 | 0;
}

function _wcpcpy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i1 = _wcscpy(i1, i2) | 0;
 return i1 + ((_wcslen(i2) | 0) << 2) | 0;
}

function _ft_realloc(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return _realloc(i4, i3) | 0;
}

function _ft_outline_glyph_bbox(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _UNITY_FT_Outline_Get_CBox(i1 + 20 | 0, i2);
 return;
}

function _cf2_buf_isEnd(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) >>> 0 >= (HEAP32[i1 + 8 >> 2] | 0) >>> 0 | 0;
}

function __ZThn32_NK8Renderer8GetLayerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + -32 + 28 >> 2] | 0) + 48 >> 2] | 0;
}

function __ZNSt3__218shared_timed_mutex6unlockEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__219__shared_mutex_base6unlockEv(i1);
 return;
}

function __ZNSt3__215__time_get_tempIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212ctype_bynameIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__time_get_tempIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212ctype_bynameIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210__stdinbufIwE9underflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__210__stdinbufIwE9__getcharEb(i1, 0) | 0;
}

function __ZNSt3__210__stdinbufIcE9underflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__210__stdinbufIcE9__getcharEb(i1, 0) | 0;
}

function __ZNK7WeakPtrI20SoundChannelInstanceE10SharedData9GetRawPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 400 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 364 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController13getStepOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 56 >> 2]);
}

function __ZNK5physx3Cct17CapsuleController13getSlopeLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore12getStiffnessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 100 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore26getInternalDriveIterationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Sc16ArticulationCore26getExternalDriveIterationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx29PxClothSimpleTetherCookerImpl15getCookerStatusEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 204;
}

function __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx10NpMaterial22getFrictionCombineModeEv(i1) {
 i1 = i1 | 0;
 return (HEAPU8[i1 + 46 >> 0] | 0) >>> 4 | 0;
}

function __ZNK5Umbra4Path11getCapacityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 4 >> 2] | 0;
}

function __ZNK24DownloadHandlerAudioClip13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] & 2147483647 | 0;
}

function __ZNK23ArchiveStorageConverter17IsHeaderProcessedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 56 >> 0] | 0) != 0 | 0;
}

function __ZNK20IntermediateRenderer11GetMaterialEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 252 >> 2] | 0;
}

function __ZNK14BillboardAsset12GetNumImagesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 40 >> 2] | 0;
}

function __ZN9GfxDevice20SetMaxBufferedFramesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4392 >> 2] = i2;
 return;
}

function __ZN9GfxDevice18InsertCustomMarkerEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z19PluginsRenderMarkeri(i2);
 return;
}

function __ZN9GfxDevice17SetGpuProgramNameEP10GpuProgramPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN7Texture6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 64 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd16MemoryMappedFile14getBaseAddressEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[i1 >> 2] >> 2] | 0;
}

function __ZN5physx30PxPlaneGeometryGeneratedValuesC2EPKNS_15PxPlaneGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16NpParticleSystem8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN4crnd10dxt5_block15unpack_endpointEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 >>> (i2 << 3) & 255 | 0;
}

function __ZN23iPhoneLocalNotificationC2EP11objc_object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN22UnityWebRequestManager31UnregisterDownloadScriptHandlerEP21DownloadHandlerScript(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19SkinnedMeshRenderer10SetQualityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 460 >> 2] = i2;
 return;
}

function __ZN19ParticleSystemState8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18StreamedBinaryReadILb1EE5AlignEv(i1) {
 i1 = i1 | 0;
 __ZN12CachedReader10Align4ReadEv(i1 + 16 | 0);
 return;
}

function __ZN18StreamedBinaryReadILb0EE5AlignEv(i1) {
 i1 = i1 | 0;
 __ZN12CachedReader10Align4ReadEv(i1 + 16 | 0);
 return;
}

function __ZN18ProceduralMaterial17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN8Material17MainThreadCleanupEv(i1);
 return;
}

function __ZN17ProceduralTexture22UploadSubstanceTextureER17SubstanceTexture_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17GeneralConnection14NetworkMessage17InitializeMessageEv(i1) {
 i1 = i1 | 0;
 HEAP16[i1 >> 1] = 20111;
 return;
}

function __ZN17ArchiveFileSystem6DeleteER13FileEntryDatab(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem4CopyER13FileEntryDataS1_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN16UnityAdsSettings11SetTestModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 17 >> 0] = i2 & 1;
 return;
}

function __ZN16LevelGameManager23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14PreloadManager16EndProfilerFrameEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 52 >> 2] = i2;
 return;
}

function __ZN13GfxDeviceGLES15EndProfileEventEv(i1) {
 i1 = i1 | 0;
 __ZN7ApiGLES14DebugPopMarkerEv(i1 + 4620 | 0);
 return;
}

function __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE6isGoodEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN11dtNodeQueueD2Ev(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, HEAP32[i1 >> 2] | 0);
 return;
}

function __ZN11AudioModule17StopVideoTexturesEv(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTexture17StopVideoTexturesEv();
 return;
}

function __ZN10builtintex16GetDefaultTexEnvE16TextureDimension(i1) {
 i1 = i1 | 0;
 return gb + 1157964 + (i1 * 20 | 0) | 0;
}

function __ZL15UnityDetourFreePv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63704 | 0);
 return;
}

function __Z45Application_Get_Custom_PropWebSecurityHostUrlv() {
 return __Z20scripting_string_newPKc(gb + 1576256 | 0) | 0;
}

function __Z44SystemInfo_Get_Custom_PropSupports3DTexturesv() {
 return HEAP8[(__Z15GetGraphicsCapsv() | 0) + 481 >> 0] | 0;
}

function __Z42Physics_Get_Custom_PropQueriesHitBackfacesv() {
 return HEAP8[(__Z17GetPhysicsManagerv() | 0) + 798 >> 0] | 0;
}

function __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawWireSphereRK8Vector3ff(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z41RenderSettings_Get_Custom_PropAmbientModev() {
 return HEAP32[(__Z17GetRenderSettingsv() | 0) + 188 >> 2] | 0;
}

function __Z31getPxSceneLimitsMaxNbAggregatesPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __Z28scripting_class_is_valuetypeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_valuetype(i1 | 0) | 0;
}

function __Z28scripting_class_is_interfaceP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_interface(i1 | 0) | 0;
}

function __Z28scripting_array_element_sizeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_array_element_size(i1 | 0) | 0;
}

function __Z21GetContainerArraySizeRK16TypeTreeIteratorPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i2 >> 2] | 0;
}

function __Z15GetVideoCardIDsRiS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i2 >> 2] = 0;
 return;
}

function __Z15GetUsedHeapSizev() {
 return __ZN13MemoryManager23GetTotalAllocatedMemoryEv(__Z16GetMemoryManagerv() | 0) | 0;
}

function _UNITY_FT_Outline_GetInsideBorder(i1) {
 i1 = i1 | 0;
 return (_UNITY_FT_Outline_Get_Orientation(i1) | 0) == 0 | 0;
}

function _wctomb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) i1 = 0; else i1 = _wcrtomb(i1, i2, 0) | 0;
 return i1 | 0;
}

function _wcscat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _wcscpy(i1 + ((_wcslen(i1) | 0) << 2) | 0, i2) | 0;
 return i1 | 0;
}

function _png_get_uint_16(i1) {
 i1 = i1 | 0;
 return ((HEAPU8[i1 >> 0] | 0) << 8 | (HEAPU8[i1 + 1 >> 0] | 0)) & 65535 | 0;
}

function _lrint(d1) {
 d1 = +d1;
 var i2 = 0;
 i2 = _fetestexcept(32) | 0;
 d1 = +_rint(d1);
 if (!i2) {}
 return ~~d1 | 0;
}

function _glGenTransformFeedbacks__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenTransformFeedbacks(i1 | 0, i2 | 0);
}

function _glBlendEquationSeparate__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBlendEquationSeparate(i1 | 0, i2 | 0);
}

function _glBindTransformFeedback__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindTransformFeedback(i1 | 0, i2 | 0);
}

function _ft_outline_glyph_done(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Outline_Done(HEAP32[i1 >> 2] | 0, i1 + 20 | 0) | 0;
 return;
}

function _emscripten_glGenBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGenBuffers(i1 | 0, i2 | 0);
}

function _emscripten_glEnableVertexAttribArray__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glEnableVertexAttribArray(i1 | 0);
}

function _emscripten_glBindBuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBindBuffer(i1 | 0, i2 | 0);
}

function ___dn_comp(i1, i2, i3, i4, i5) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 i5 = i5 | 0;
 return -1;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 376 >> 2] | 0;
}

function __ZNK5physx3Cct13BoxController16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __ZNK5physx2Sc8ActorSim8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 36 >> 2] | 0) + 1008 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore12getViscosityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 60 >> 2]);
}

function __ZNK5physx2Sc16ArticulationCore24getSolverIterationCountsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 16 >> 1] | 0;
}

function __ZNK5physx2Sc16ArticulationCore14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 768;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 336;
}

function __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK13b2PulleyJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(0.0);
}

function __ZN8Animator18AutoMecanimDataSetD2Ev(i1) {
 i1 = i1 | 0;
 __ZN8Animator18AutoMecanimDataSet5ResetEv(i1);
 return;
}

function __ZN7b2World12SetDebugDrawEP6b2Draw(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 102988 >> 2] = i2;
 return;
}

function __ZN5physx3Cct26CharacterControllerManager14getControllersEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZN5physx2Sn13XmlNodeWriter12addAttributeEPKcS3_(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx2Sc9ShapeCoreC2ERKNS_7PxEMPTYE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 132 >> 0] = 0;
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_ED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu12TriangleMesh8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx20GetNbTorqueCurvePairEPKNS_19PxVehicleEngineDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 833702 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 834943 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 835156 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765091 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765058 | 0;
}

function __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764992 | 0;
}

function __ZN5physx18PxSetAssertHandlerERNS_15PxAssertHandlerE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 151084 >> 2] = i1;
 return;
}

function __ZN5physx15NpParticleFluid8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx14NpArticulation7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 104 >> 2] = i1;
 return;
}

function __ZN5Umbra4Math4sqrtENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_sqrt(Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math4ceilENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_ceil(Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math3tanENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_tan(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math3sinENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_sin(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math3logENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_log(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math3expENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_exp(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN5Umbra4Math3cosENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(+Math_cos(+Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN2UI13RectTransform19SetDrivenPropertiesENS0_16DrivenPropertiesE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN26PlayerSettingsSplashScreen37GetSplashScreenBackgroundLandscapeUvsEv(i1) {
 i1 = i1 | 0;
 return i1 + 40 | 0;
}

function __ZN22RenderingCommandBufferD0Ev(i1) {
 i1 = i1 | 0;
 __ZN22RenderingCommandBufferD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN22ParticleSystemRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN22ParticleSystemRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN22BaseUnityConnectClientD0Ev(i1) {
 i1 = i1 | 0;
 __ZN22BaseUnityConnectClientD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19ParticleSystemState8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18ScriptingArguments8GetIntAtEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + (i2 << 3) >> 2] | 0;
}

function __ZN18LoadSceneOperation21MustCompleteNextFrameEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 470 >> 0] | 0) != 0 | 0;
}

function __ZN13UnityProfiler19SetupProfilerEventsEv(i1) {
 i1 = i1 | 0;
 __Z29scripting_profiler_set_eventsi(384);
 return;
}

function __ZN13GfxDeviceGLES5FlushEv(i1) {
 i1 = i1 | 0;
 __ZN7ApiGLES6SubmitEN2gl10SubmitModeE(i1 + 4620 | 0, 0);
 return;
}

function __ZN13GfxDeviceGLES14SetBarrierMaskEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 7380 >> 2] = i2;
 return;
}

function __ZN11b2GearJoint8SetRatioEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 152 >> 2] = f2;
 return;
}

function __Z44SystemInfo_Get_Custom_PropProcessorFrequencyv() {
 return __ZN10systeminfo24GetProcessorFrequencyMHzEv() | 0;
}

function __Z44SystemInfo_Get_Custom_PropGraphicsDeviceTypev() {
 return HEAP32[(__Z12GetGfxDevicev() | 0) + 4388 >> 2] | 0;
}

function __Z40UnityAdsSettings_Get_Custom_PropTestModev() {
 return HEAP8[(__Z19GetUnityAdsSettingsv() | 0) + 17 >> 0] | 0;
}

function __Z35GUIUtility_Get_Custom_PropMouseUsedv() {
 return (HEAP32[(__Z11GetGUIStatev() | 0) + 272 >> 2] | 0) != 0 | 0;
}

function __Z34Time_Get_Custom_PropFixedDeltaTimev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 48 >> 2]);
}

function __Z32getPxSceneDescBroadPhaseCallbackPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __Z32Time_Get_Custom_PropUnscaledTimev() {
 return Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 176 >> 3]);
}

function __Z30getPxClothFabricPhasePhaseTypePKN5physx18PxClothFabricPhaseE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z30GUI_CUSTOM_Internal_EndWindowsv() {
 __ZN5IMGUI10EndWindowsER8GUIStateb(__Z11GetGUIStatev() | 0, 1);
 return;
}

function __Z25GetBytesFromTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 45784 + (i1 << 2) >> 2] | 0;
}

function __Z24SplashScreen_CUSTOM_Drawv() {
 __Z16DrawSplashScreenb((__Z26IsSplashScreenFadeCompletev() | 0) ^ 1);
 return;
}

function __Z20IsHumanControllingUsv() {
 return (HEAP8[gb + 1546620 >> 0] | HEAP8[gb + 1546618 >> 0]) << 24 >> 24 == 0 | 0;
}

function __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE(i1) {
 i1 = i1 | 0;
 return 0;
}

function _vsprintf(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _vsnprintf(i1, 2147483647, i2, i3) | 0;
}

function _pthread_cond_wait__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _pthread_cond_wait(i1 | 0, i2 | 0) | 0;
}

function _independent_comalloc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _ialloc(i1, i2, 0, i3) | 0;
}

function __ZcoRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN14ComplementExprI8Scalar4fEC2ERKS0_(i1, i2);
 return;
}

function __ZNSt13exception_ptrD2Ev(i1) {
 i1 = i1 | 0;
 ___cxa_decrement_exception_refcount(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbaseEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5epptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5egptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbaseEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5epptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5egptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK7b2World13GetTreeHeightEv(i1) {
 i1 = i1 | 0;
 return __ZNK13b2DynamicTree9GetHeightEv(i1 + 102872 | 0) | 0;
}

function __ZNK6Shader19GetMaximumShaderLODEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 32 >> 2] | 0) + 56 >> 2] | 0;
}

function __ZNK5physx7NpShape25getScRigidObjectExclusiveEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 20 >> 2] | 0) + 64 | 0;
}

function __ZNK5physx7NpScene24getWakeCounterResetValueEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 2876 >> 2]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 412 >> 2] | 0;
}

function __ZNK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 76 >> 2] | 0) + -16 | 0;
}

function __ZNK5physx2Sc9ShapeCore10getPxShapeEv(i1) {
 i1 = i1 | 0;
 return i1 + (HEAP32[gb + 1097392 + 12 >> 2] | 0) | 0;
}

function __ZNK5physx27PxVehicleDifferentialNWData20getDrivenWheelStatusEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 84;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 84;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx23PxsBroadPhaseContextSap18getNumDeletedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 248 >> 2] | 0;
}

function __ZNK5physx23PxsBroadPhaseContextSap18getNumCreatedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 236 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK22ParticleSystemRenderer15GetSortingFudgeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 364 >> 2]);
}

function __ZNK22DownloadHandlerTexture13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] & 2147483647 | 0;
}

function __ZNK18VertexChannelsInfoltERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_memcmp(i1, i2, 32) | 0) < 0 | 0;
}

function __ZNK16SpriteRenderData22IsUVCalculationPendingEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 52 >> 0] | 0) != 0 | 0;
}

function __ZNK11ICallString16GetRawCharBufferEv(i1) {
 i1 = i1 | 0;
 return _il2cpp_string_chars(HEAP32[i1 >> 2] | 0) | 0;
}

function __ZN8GUIState10BeginFrameEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 HEAPF32[i1 + 344 >> 2] = f2;
 return;
}

function __ZN5physx2Sq17SceneQueryManager12freeSPUTasksEPNS_12NpBatchQueryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sn5ConvX11setNoOutputEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 325 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu11HeightField8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx25PxVehicleConstraintShader13onOriginShiftERKNS_6PxVec3E(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765075 | 0;
}

function __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765009 | 0;
}

function __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 742891 | 0;
}

function __ZN4FMOD7SystemI9getDriverEPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN26PlayerSettingsSplashScreen36GetSplashScreenBackgroundPortraitUvsEv(i1) {
 i1 = i1 | 0;
 return i1 + 56 | 0;
}

function __ZN22UnityWebRequestManager29RegisterDownloadScriptHandlerEP21DownloadHandlerScript(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22BaseUnityConnectClient16IsConnectEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 112 >> 0] | 0) != 0 | 0;
}

function __ZN21GfxDeviceAsyncCommand10ArgScratch15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 8 >> 2] = 0;
 return;
}

function __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17GlobalGameManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15b2FrictionJoint24SolvePositionConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN14PhysicsManager7onSleepEPPN5physx7PxActorEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13GfxDeviceNull20GetVertexDeclarationERK18VertexChannelsInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13GfxDeviceNull14EndBufferWriteEP9GfxBufferj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN10InputEventD2Ev(i1) {
 i1 = i1 | 0;
 i1 = HEAP32[i1 + 44 >> 2] | 0;
 if (!i1) return;
 __ZdaPv(i1);
 return;
}

function __ZN10GameObject25RegisterSetGONameCallbackEPFvPS_E(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1104576 >> 2] = i1;
 return;
}

function __ZN10GameObject25RegisterDestroyedCallbackEPFvPS_E(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1104572 >> 2] = i1;
 return;
}

function __Z42SystemInfo_Get_Custom_PropGraphicsDeviceIDv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 84 >> 2] | 0;
}

function __Z41Physics_Get_Custom_PropQueriesHitTriggersv() {
 return HEAP8[(__Z17GetPhysicsManagerv() | 0) + 56 >> 0] | 0;
}

function __Z32GL_CUSTOM_INTERNAL_CALL_ViewportRK5RectTIfE(i1) {
 i1 = i1 | 0;
 __Z13SetGLViewportRK5RectTIfE(i1);
 return;
}

function __Z30getPxSceneDescDynamicStructurePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 120 >> 2] | 0;
}

function __Z27scripting_class_is_inflatedP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_inflated(i1 | 0) | 0;
}

function __Z27scripting_class_is_abstractP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_abstract(i1 | 0) | 0;
}

function __Z26getPxHeightFieldDescFormatPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z25getPxVehicleTireDataMTypePKN5physx17PxVehicleTireDataE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z25getPxHeightFieldDescFlagsPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 28 >> 1] | 0;
}

function __Z25IsManagerContextAvailablei(i1) {
 i1 = i1 | 0;
 return (HEAP32[gb + 1104348 + (i1 << 2) >> 2] | 0) != 0 | 0;
}

function __Z19pop_allocation_rootv() {
 __ZN14MemoryProfiler17PopAllocationRootEv(HEAP32[gb + 1163236 >> 2] | 0);
 return;
}

function _Read_CVT(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[(HEAP32[i1 + 384 >> 2] | 0) + (i2 << 2) >> 2] | 0;
}

function b55(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 nullFunc_fiif(55);
 return Math_fround(0);
}

function _srandom(i1) {
 i1 = i1 | 0;
 ___lock(gb + 1470376 | 0);
 ___srandom(i1);
 ___unlock(gb + 1470376 | 0);
 return;
}

function _ft_bitmap_glyph_done(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Bitmap_Done(HEAP32[i1 >> 2] | 0, i1 + 28 | 0) | 0;
 return;
}

function _emscripten_glUniform1i__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glUniform1i(i1 | 0, i2 | 0);
}

function _emscripten_glGetFloatv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glGetFloatv(i1 | 0, i2 | 0);
}

function _emscripten_glBlendFunc__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glBlendFunc(i1 | 0, i2 | 0);
}

function __ZZ23InitPlayerLoopCallbacksvEN29EarlyUpdateGpuTimestampstruct7ForwardEv() {
 __Z15gpu_time_samplev();
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv(i1) {
 i1 = i1 | 0;
 return i1 + 44 | 0;
}

function __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 536 >> 2] = 0;
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208648 + 8;
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 208616 + 8;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__212ctype_bynameIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212ctype_bynameIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212ctype_bynameIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212ctype_bynameIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5ebackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4pptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4gptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5ebackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4pptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4gptrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx6shdfnd6Socket7getPortEv(i1) {
 i1 = i1 | 0;
 return HEAP16[(HEAP32[i1 + 4 >> 2] | 0) + 12 >> 1] | 0;
}

function __ZNK5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4sizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 548 >> 2] | 0;
}

function __ZNK5physx3Cct13BoxController13getHalfHeightEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 496 >> 2]);
}

function __ZNK5physx2Sc18ParticleSystemCore10getDampingEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 96 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 84;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 84;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 144;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 768;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 800;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 200;
}

function __ZNK5Umbra4Tome16getGateStateSizeEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 104 >> 2] | 0) + 31 >> 5 << 2 | 0;
}

function __ZNK26AnimatorOverrideController21GetAnimatorControllerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK21DownloadHandlerBuffer13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] & 2147483647 | 0;
}

function __ZNK18AnimatorController41GetStateMachineBehaviourVectorDescriptionEv(i1) {
 i1 = i1 | 0;
 return i1 + 156 | 0;
}

function __ZNK12_GLOBAL__N_112UserRenderer10hasClientsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 56 >> 2] | 0) != 0 | 0;
}

function __ZNK12HandlerChain8PositionERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(0);
 return 0;
}

function __ZNK11b2RopeJoint17GetReactionTorqueEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return Math_fround(0.0);
}

function __ZN9GfxDevice29GetNativeComputeBufferPointerE15ComputeBufferID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN9BlobWrite24ValidateSerializedLayoutEPKvPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN7mecanim5human12RequiredBoneEj(i1) {
 i1 = i1 | 0;
 return i1 >>> 0 < 24 & (517375 >>> i1 & 1 | 0) != 0 | 0;
}

function __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx6shdfnd9MutexImpl7trylockEv(i1) {
 i1 = i1 | 0;
 return (_pthread_mutex_trylock(i1 | 0) | 0) == 0 | 0;
}

function __ZN5physx3Scb5Scene23addStaticAndShapesToPvdERNS0_11RigidStaticE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Scb5Scene10getPxSceneEv(i1) {
 i1 = i1 | 0;
 return __ZN5physx12NpGetPxSceneERNS_3Scb5SceneE(i1) | 0;
}

function __ZN5physx2Sn5ConvX10setNullPtrEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP8[i2 + 324 >> 0] = i1 & 1;
 return;
}

function __ZN5physx2Sn20SerializationContext18getTotalStoredSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 196 >> 2] | 0;
}

function __ZN5physx2Sc9ShapeCore10getPxShapeEv(i1) {
 i1 = i1 | 0;
 return i1 + (HEAP32[gb + 1097392 + 12 >> 2] | 0) | 0;
}

function __ZN5physx2Sc9ClothCore10getPxClothEv(i1) {
 i1 = i1 | 0;
 return i1 + (HEAP32[gb + 1097392 + 32 >> 2] | 0) | 0;
}

function __ZN5physx2Gu10ConvexMesh8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Cm12RenderOutputlsEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 4 >> 2] = i1;
 return i2 | 0;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753858 | 0;
}

function __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 832257 | 0;
}

function __ZN5physx18RepXSerializerImplINS_14PxArticulationEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765118 | 0;
}

function __ZN5physx15PxVehicleWheels15computeByteSizeEj(i1) {
 i1 = i1 | 0;
 return (i1 << 5 | 16) + (i1 * 1552 | 0) | 0;
}

function __ZN5physx13NpClothFabric8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra4Math3absENS_5FloatE(i1) {
 i1 = i1 | 0;
 return Math_fround(Math_abs(Math_fround(HEAPF32[i1 >> 2])));
}

function __ZN4TreeD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 29060 + 8;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN21RotationBySpeedModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN21RotationBySpeedModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN21AudioDistortionFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioFilter12AddToManagerEv(i1);
 return;
}

function __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16LevelGameManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN16BaseVideoTexture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN14PhysicsManager6onWakeEPPN5physx7PxActorEj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13MonoBehaviour11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 __ZN13MonoBehaviour16CallUpdateMethodEi(i1, 2);
 return;
}

function __ZN12_GLOBAL__N_123FStreamNetworkOutStream10disconnectEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 28 >> 0] = 0;
 return;
}

function __ZN12_GLOBAL__N_117ConnectionManager23nullDeallocationHandlerEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN12WWWDelayCall14MatchForCancelEPvS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 | 0) == (i2 | 0) | 0;
}

function __ZN11UnityEngine15PlatformWrapper17GetProcessorCountEv() {
 return __ZN10systeminfo17GetProcessorCountEv() | 0;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient18GetEditableHeadersEv(i1) {
 i1 = i1 | 0;
 return i1 + 44 | 0;
}

function __ZN10systeminfo19IsPlatformWebPlayerE15RuntimePlatform(i1) {
 i1 = i1 | 0;
 return (i1 + -3 | 0) >>> 0 < 3 | 0;
}

function __ZN10TagManager5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv(i1);
 return;
}

function __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv() {
 return HEAP32[gb + 1165844 >> 2] | 0;
}

function __Z46PhysicMaterial_Get_Custom_PropDynamicFriction2P12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __Z41Caching_Get_Custom_PropCompressionEnabledv() {
 return HEAP8[(__Z17GetCachingManagerv() | 0) + 9 >> 0] | 0;
}

function __Z40SystemInfo_Get_Custom_PropMaxTextureSizev() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 124 >> 2] | 0;
}

function __Z40AudioSettings_Get_Custom_PropSpeakerModev() {
 return HEAP32[(__Z15GetAudioManagerv() | 0) + 120 >> 2] | 0;
}

function __Z39UnityAdsSettings_Get_Custom_PropEnabledv() {
 return HEAP8[(__Z19GetUnityAdsSettingsv() | 0) + 8 >> 0] | 0;
}

function __Z38QualitySettings_CUSTOM_GetQualityLevelv() {
 return HEAP32[(__Z18GetQualitySettingsv() | 0) + 44 >> 2] | 0;
}

function __Z36Physics_Set_Custom_PropSleepVelocityf(f1) {
 f1 = Math_fround(f1);
 __Z17GetPhysicsManagerv() | 0;
 return;
}

function __Z35Light_Set_Custom_PropShadowSoftnessP12Il2CppObjectf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z31ManagerContextInitializeClassesv() {
 __ZN14ManagerContext17InitializeClassesEv(gb + 1104348 | 0);
 return;
}

function __Z30getPxSceneDescFilterShaderDataPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __Z29getPxSceneDescStaticStructurePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 116 >> 2] | 0;
}

function __Z29getPxSceneDescSolverBatchSizePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 132 >> 2] | 0;
}

function __Z29getPxSceneDescSimulationOrderPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 152 >> 2] | 0;
}

function __Z28getPxSceneLimitsMaxNbRegionsPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __Z26scripting_object_get_classP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return _il2cpp_object_get_class(i1 | 0) | 0;
}

function __Z23profiler_get_group_name13ProfilerGroup(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 66352 + (i1 << 2) >> 2] | 0;
}

function __Z22RecreatePhysicsWorld2Dv() {
 __ZN14Physics2DState13RecreateWorldEv(HEAP32[gb + 1458412 >> 2] | 0);
 return;
}

function _UNITY_png_init_io(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!i1) return;
 HEAP32[i1 + 184 >> 2] = i2;
 return;
}

function _UNITY_png_default_flush(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 _fflush(HEAP32[i1 + 184 >> 2] | 0) | 0;
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv(i1) {
 i1 = i1 | 0;
 return i1 + 56 | 0;
}

function __ZThn264_N24MeshIntermediateRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZNSt3__218shared_timed_mutex4lockEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__219__shared_mutex_base4lockEv(i1);
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8overflowEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8overflowEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNSt3__210__stdinbufIwE5uflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__210__stdinbufIwE9__getcharEb(i1, 1) | 0;
}

function __ZNSt3__210__stdinbufIcE5uflowEv(i1) {
 i1 = i1 | 0;
 return __ZNSt3__210__stdinbufIcE9__getcharEb(i1, 1) | 0;
}

function __ZNKSt3__219__shared_weak_count13__get_deleterERKSt9type_info(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6gcountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6gcountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNK5physx6shdfnd6Socket7getHostEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 4 >> 2] | 0) + 8 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController9getRadiusEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 496 >> 2]);
}

function __ZNK5physx3Cct17CapsuleController9getHeightEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 500 >> 2]);
}

function __ZNK5physx3Cct13BoxController13getStepOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 56 >> 2]);
}

function __ZNK5physx3Cct13BoxController13getSlopeLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZNK5physx2Sn22DeserializationContext15getPhysXVersionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 240;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 200;
}

function __ZNK30RuntimeInitializeOnLoadManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31472 | 0;
}

function __ZNK20TextRenderingPrivate8TextMesh26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 185320 | 0;
}

function __ZNK17ArchiveFileSystem18HasMountedArchivesEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) != 0 | 0;
}

function __ZNK13ScreenManager22HasFullscreenRequestedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) == 1 | 0;
}

function __ZNK12CullingGroup13GetUpdateTypeEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 96 >> 2] | 0) == 0 ? 1 : 3) | 0;
}

function __ZNK11AudioSource24GetSpatializePostEffectsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 423 >> 0] | 0) != 0 | 0;
}

function __ZNK11AudioSource24GetBypassListenerEffectsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 425 >> 0] | 0) != 0 | 0;
}

function __ZN6Object23VirtualRedirectTransferER24GenerateTypeTreeTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb1EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb0EE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEE7executeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx5PxMaxIjEET_S1_S1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 >>> 0 < i2 >>> 0 ? i2 : i1) | 0;
}

function __ZN5physx3Cct17CapsuleControllerD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 return;
}

function __ZN5physx2Sc8ActorSim19postActorFlagChangeEjj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx25PxDefaultFileOutputStream7isValidEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) != 0 | 0;
}

function __ZN5physx23NpParticleFluidReadData18getDataAccessFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 201 >> 0] | 0;
}

function __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 701374 | 0;
}

function __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753780 | 0;
}

function __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764826 | 0;
}

function __ZN5physx18AdjacenciesBuilderC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN5physx12NpConstraint8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN3WWW6RetainEv(i1) {
 i1 = i1 | 0;
 i1 = i1 + 76 | 0;
 HEAP32[i1 >> 2] = (HEAP32[i1 >> 2] | 0) + 1;
 return;
}

function __ZN27UnloadUnusedAssetsOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN23ShaderVariantCollection13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN21FixedBehaviourManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17MemoryCacheReader18GetAddressOfMemoryEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[i1 + 4 >> 2] >> 2] | 0;
}

function __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15ParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15EditorExtension7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15AnchoredJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN14PhysicsManager23GetDefaultContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZN14FileCacherRead21DebugLinearFileAccessEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN14CachingManager10SetEnabledEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 8 >> 0] = i2 & 1;
 return;
}

function __ZN13UnityProfiler13UpdateEnabledEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 24 >> 2] = HEAP32[i1 + 28 >> 2];
 return;
}

function __ZN13MonoBehaviour10LateUpdateEv(i1) {
 i1 = i1 | 0;
 __ZN13MonoBehaviour16CallUpdateMethodEi(i1, 1);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EE6isGoodEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 16 >> 0] | 0) != 0 | 0;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EE6isGoodEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 16 >> 0] | 0) != 0 | 0;
}

function __ZN12StatusHelper13SetStatusCodeEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return 0;
}

function __ZN11UnityEngine9Animation15IsTransformTypeEi(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 4 | (i1 | 0) == 224 | 0;
}

function __ZN11ContextGLES7PresentEv() {
 if (!(_JS_SystemInfo_HasWebGL() | 0)) return;
 _SDL_GL_SwapBuffers();
 return;
}

function __ZN10PngDecoder13SetComputeCrcEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 40 >> 0] = i2 & 1;
 return;
}

function __Z45PhysicMaterial_Get_Custom_PropStaticFriction2P12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __Z39Profiler_Get_Custom_PropEnableBinaryLogv() {
 return HEAP8[(HEAP32[gb + 1451e3 >> 2] | 0) + 104 >> 0] | 0;
}

function __Z39Input_Get_Custom_PropImeCompositionModev() {
 return HEAP32[(__Z15GetInputManagerv() | 0) + 172 >> 2] | 0;
}

function __Z39AndroidJNI_CUSTOM_GetDoubleArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0.0;
}

function __Z38Gizmos_CUSTOM_INTERNAL_CALL_DrawSphereRK8Vector3ff(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z38AndroidJNI_CUSTOM_GetStaticDoubleField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0.0;
}

function __Z37RenderSettings_Get_Custom_PropFogModev() {
 return HEAP32[(__Z17GetRenderSettingsv() | 0) + 316 >> 2] | 0;
}

function __Z26scripting_class_is_genericP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_generic(i1 | 0) | 0;
}

function __Z26scripting_class_get_parentP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_parent(i1 | 0) | 0;
}

function __Z25scripting_raise_exceptionP15Il2CppException(i1) {
 i1 = i1 | 0;
 _il2cpp_raise_exception(i1 | 0);
 return;
}

function b114(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 nullFunc_iiff(114);
 return 0;
}

function _llrintl(d1) {
 d1 = +d1;
 var i2 = 0;
 i2 = _llrint(d1) | 0;
 setTempRet0(getTempRet0() | 0);
 return i2 | 0;
}

function _jsimd_h2v2_merged_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _jsimd_h2v1_merged_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _glPolygonOffset__wrapper(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 _glPolygonOffset(+f1, +f2);
}

function _glDeleteRenderbuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteRenderbuffers(i1 | 0, i2 | 0);
}

function _bcopy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _memmove(i2 | 0, i1 | 0, i3 | 0) | 0;
 return;
}

function __ZThn680_N18UnityConnectClientD1Ev(i1) {
 i1 = i1 | 0;
 __ZN18UnityConnectClientD2Ev(i1 + -680 | 0);
 return;
}

function __ZThn4_NK5physx5cloth8SwFabric10getNumSetsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 32 >> 2] | 0) + -1 | 0;
}

function __ZThn32_N8RendererD0Ev(i1) {
 i1 = i1 | 0;
 i1 = i1 + -32 | 0;
 __ZN8RendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZThn32_N19SkinnedMeshRendererD1Ev(i1) {
 i1 = i1 | 0;
 __ZN19SkinnedMeshRendererD2Ev(i1 + -32 | 0);
 return;
}

function __ZNSt3__215numpunct_bynameIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28numpunctIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215numpunct_bynameIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28numpunctIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK8Animator19ValidateHasPlayableEv(i1) {
 i1 = i1 | 0;
 return __ZNK9HPlayable7IsValidEv(i1 + 628 | 0) | 0;
}

function __ZNK8Animator17GetTimeUpdateModeEv(i1) {
 i1 = i1 | 0;
 return ((HEAP32[i1 + 96 >> 2] | 0) == 2 ? 2 : 1) | 0;
}

function __ZNK5physx3Cct17CapsuleController18getNonWalkableModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx3Cct15ObstacleContext20getControllerManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 116;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 288;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 108;
}

function __ZNK5physx14NpRigidDynamic14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 276 >> 2]);
}

function __ZNK5Umbra9IndexList6getPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) >> 2] | 0;
}

function __ZNK5Umbra9FloatList6getPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) >> 2] | 0;
}

function __ZNK5Umbra16LineSegmentQuery6getEndEv(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) + 12 | 0;
}

function __ZNK20TextRenderingPrivate7GUIText26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 185592 | 0;
}

function __ZNK18ScreenManagerWebGL9GetHeightEv(i1) {
 i1 = i1 | 0;
 return _JS_SystemInfo_GetCurrentCanvasHeight() | 0;
}

function __ZN6Socket16SetIgnoreSIGPIPEEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 8 >> 2] = 16384;
 return 1;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_ED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 742907 | 0;
}

function __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753930 | 0;
}

function __ZN5Umbra5FloatC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(i2 >>> 0);
 return;
}

function __ZN4FMOD8ChannelI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return 0;
}

function __ZN4FMOD6SoundI7getModeEPj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP32[i2 >> 2] = 0;
 return 0;
}

function __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation6IsDoneEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN22NavMeshProjectSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN22LocalFileSystemHandler16DestroyFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN20UnityConnectSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20UnityConnectSettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20SoundChannelInstanceD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20SoundChannelInstanceD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20LateBehaviourManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20BufferedSocketStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BufferedSocketStreamD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20BaseBehaviourManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN20ArchiveStorageReaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20ArchiveStorageReaderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19TransportJavaScript7PrepareEv(i1) {
 i1 = i1 | 0;
 return ((HEAP8[i1 + 16 >> 0] | 0) == 0 ? 0 : 17) | 0;
}

function __ZN19AudioHighPassFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioFilter12AddToManagerEv(i1);
 return;
}

function __ZN16UnityAdsSettings5ResetEv(i1) {
 i1 = i1 | 0;
 __ZN16UnityAdsSettings18InitializeDefaultsEv(i1);
 return;
}

function __ZN14VehiclesModule23ShutdownVehiclesManagerEv(i1) {
 i1 = i1 | 0;
 __Z23ShutdownVehiclesManagerv();
 return;
}

function __ZN14PlayerSettings21GetMTRenderingRuntimeEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 336 >> 0] | 0) != 0 | 0;
}

function __ZN14DirectorPlayer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN14AudioBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13AnimationClip9SetLegacyEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 212 >> 0] = i2 & 1;
 return;
}

function __ZN12b2MouseJoint24SolvePositionConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN12b2MotorJoint24SolvePositionConstraintsERK12b2SolverData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN11UnityEngine15PlatformWrapper19GetEnabledVRDevicesEv() {
 return (__Z16GetBuildSettingsv() | 0) + 64 | 0;
}

function __Z47SystemInfo_Get_Custom_PropSupportsMotionVectorsv() {
 return (__Z21SupportsMotionVectorsv() | 0) & 1 | 0;
}

function __Z40AndroidJNI_CUSTOM_GetBooleanArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z39AndroidJNI_CUSTOM_GetStaticBooleanField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z32HumanTrait_CUSTOM_BoneFromMusclei(i1) {
 i1 = i1 | 0;
 return __ZN10HumanTrait14BoneFromMuscleEi(i1) | 0;
}

function __Z29Time_Get_Custom_PropTimeScalev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 196 >> 2]);
}

function __Z29Time_Get_Custom_PropFixedTimev() {
 return Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 32 >> 3]);
}

function __Z29Time_Get_Custom_PropDeltaTimev() {
 return Math_fround(HEAPF32[(__Z14GetTimeManagerv() | 0) + 112 >> 2]);
}

function __Z28getPxSceneDescFilterCallbackPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __Z28getPxSceneDescBroadPhaseTypePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __Z27getPxSceneLimitsMaxNbBodiesPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z27getPxSceneDescSpuDispatcherPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 112 >> 2] | 0;
}

function __Z27getPxSceneDescGpuDispatcherPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 108 >> 2] | 0;
}

function __Z27getPxSceneDescCpuDispatcherPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __Z25scripting_object_get_sizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return _il2cpp_object_get_size(i1 | 0) | 0;
}

function __Z24GUI_Set_Custom_PropDepthi(i1) {
 i1 = i1 | 0;
 HEAP32[(__Z11GetGUIStatev() | 0) + 68 >> 2] = i1;
 return;
}

function __Z24GUI_CUSTOM_UnfocusWindowv() {
 __ZN5IMGUI11FocusWindowER8GUIStatei(__Z11GetGUIStatev() | 0, -1);
 return;
}

function __Z12storeAlignedPfRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z5storePfRK8Scalar4f(i1, i2);
 return;
}

function __GLOBAL__sub_I_half_cpp() {
 __ZN11prophecysdk4half8selftestEv() | 0;
 HEAP8[gb + 1548961 >> 0] = 1;
 return;
}

function b41(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 nullFunc_iiiii(41);
 return 0;
}

function b121(i1, i2, i3, f4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 f4 = Math_fround(f4);
 nullFunc_viiif(121);
}

function b115(i1, i2, f3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 i4 = i4 | 0;
 nullFunc_viifi(115);
}

function _vwprintf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _vfwprintf(HEAP32[gb + 191868 >> 2] | 0, i1, i2) | 0;
}

function _strncpy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 ___stpncpy(i1, i2, i3) | 0;
 return i1 | 0;
}

function _mkfifoat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _mknodat(i1, i2, i3 | 4096, 0) | 0;
}

function _jsimd_h2v2_fancy_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _jsimd_h2v1_fancy_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _jpeg_mem_available(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return i3 | 0;
}

function _iswxdigit(i1) {
 i1 = i1 | 0;
 return ((i1 + -48 | 0) >>> 0 < 10 | ((i1 | 32) + -97 | 0) >>> 0 < 6) & 1 | 0;
}

function _fesetround(i1) {
 i1 = i1 | 0;
 if (!(i1 & -3073)) i1 = ___fesetround(i1) | 0; else i1 = -1;
 return i1 | 0;
}

function _closedir(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = _close(HEAP32[i1 >> 2] | 0) | 0;
 _free(i1);
 return i2 | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarker12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZNSt3__28ios_base7failureD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212system_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__217moneypunct_bynameIwLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZNKSt3__217moneypunct_bynameIwLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 9 >> 0] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 8 >> 0] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 9 >> 0] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 8 >> 0] | 0;
}

function __ZNKSt3__217moneypunct_bynameIcLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8max_sizeEv(i1) {
 i1 = i1 | 0;
 return -17;
}

function __ZNK9Rigidbody17GetFreezeRotationEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 88 >> 2] & 112 | 0) == 112 | 0;
}

function __ZNK5physx3Ext20DefaultCpuDispatcher14getWorkerCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx2Sc15ArticulationSim27debugCheckSleepStateOfLinksEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 84;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 132;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 112;
}

function __ZNK5physx22PxDefaultFileInputData7isValidEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx20PxsParticleSystemSim12isSimulatedVEv(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 1108 >> 0] | 0 | 0;
}

function __ZNK5physx17PxcNpMemBlockPool20getMaxUsedBlockCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 156 >> 2] | 0;
}

function __ZNK5physx14NpArticulation14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 60 >> 2]);
}

function __ZNK5physx10NpMaterial18getDynamicFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __ZNK14ParticleSystem12GetParticlesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK13ScreenManager21GetCursorInsideWindowEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 27 >> 0] | 0) != 0 | 0;
}

function __ZNK12_GLOBAL__N_118LegacySerialStream13getCollectionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK11MatrixStack9GetMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + ((HEAP32[i1 + 1024 >> 2] | 0) + -1 << 6) | 0;
}

function __ZN9GfxDevice25GenerateRenderSurfaceMipsEP17RenderSurfaceBase(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN9GfxDevice14SetTextureNameE9TextureIDPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9GfxDevice13SetBufferNameEP9GfxBufferPKc(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN9Behaviour8TransferI30ReportScriptingObjectsTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx27PxLockedDataGeneratedValuesC2EPKNS_12PxLockedDataE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23PxsBroadPhaseContextSap15getDeletedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 244 >> 2] | 0;
}

function __ZN5physx23PxsBroadPhaseContextSap15getCreatedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 232 >> 2] | 0;
}

function __ZN5physx18RepXSerializerImplINS_11PxAggregateEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 747736 | 0;
}

function __ZN5physx10NpMaterial8requiresERNS_23PxProcessPxBaseCallbackE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD8ChannelI7setMuteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 160 >> 0] = i2 & 1;
 return 0;
}

function __ZN4FMOD4DSPI9getBypassEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP8[i2 >> 0] = 0;
 return 0;
}

function __ZN4FMOD4DSPI9getActiveEPb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i2 | 0) HEAP8[i2 >> 0] = 0;
 return 0;
}

function __ZN3WWW12SetAudioClipEP9AudioClip(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 return;
}

function __ZN23iPhoneLocalNotification29SetApplicationIconBadgeNumberEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN22BaseUnityConnectClient12IsNewSessionEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 108 >> 0] | 0) != 0 | 0;
}

function __ZN21AssetBundleFileSystem16DestroyFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19CharacterController10IsGroundedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 140 >> 2] & 4 | 0) != 0 | 0;
}

function __ZN18ProceduralMaterial27SetProceduralProcessorUsageE24ProceduralProcessorUsage(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AudioLowPassFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioFilter12AddToManagerEv(i1);
 return;
}

function __ZN17LowLevelAllocator6MallocEj(i1) {
 i1 = i1 | 0;
 return __ZN13MemoryManager16LowLevelAllocateEj(i1) | 0;
}

function __ZN16DeveloperConsole7SetOpenEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 >> 0] = i2 & 1 ^ 1;
 return;
}

function __ZN13TextRendering4Font15InitializeClassEv() {
 __ZN20TextRenderingPrivate18InitializeFreeTypeEv();
 return;
}

function __ZN12_GLOBAL__N_15qNullEff(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return Math_fround(0.0);
}

function __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10GUITexture12CleanupClassEv() {
 HEAP32[gb + 1114520 >> 2] = 0;
 HEAP32[gb + 1114516 >> 2] = 0;
 return;
}

function __Z47Application_Get_Custom_PropIsHumanControllingUsv() {
 return (__Z20IsHumanControllingUsv() | 0) & 1 | 0;
}

function __Z43Input_Get_Custom_PropTouchPressureSupportedv() {
 return (__Z24IsTouchPressureSupportedv() | 0) & 1 | 0;
}

function __Z41RenderTexture_Set_Custom_PropIsPowerOfTwoP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z39Application_Get_Custom_PropUnityVersionv() {
 return __Z20scripting_string_newPKc(gb + 1040146 | 0) | 0;
}

function __Z38Time_Get_Custom_PropRenderedFrameCountv() {
 return HEAP32[(__Z14GetTimeManagerv() | 0) + 136 >> 2] | 0;
}

function __Z38SceneManager_Get_Custom_PropSceneCountv() {
 return HEAP32[(__Z15GetSceneManagerv() | 0) + 16 >> 2] | 0;
}

function __Z38AndroidJNI_CUSTOM_GetStaticStringField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z37SystemInfo_Get_Custom_PropNpotSupportv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 484 >> 2] | 0;
}

function __Z37Application_CUSTOM_HasAdvancedLicensev() {
 return HEAP8[(__Z16GetBuildSettingsv() | 0) + 109 >> 0] | 0;
}

function __Z36Gyroscope_CUSTOM_getEnabled_Internali(i1) {
 i1 = i1 | 0;
 return (__Z13IsGyroEnabledi(i1) | 0) & 1 | 0;
}

function __Z30GUIClip_Get_Custom_PropEnabledv() {
 return (HEAP32[(__Z11GetGUIStatev() | 0) + 268 >> 2] | 0) != 0 | 0;
}

function __Z26getPxSceneDescCcdMaxPassesPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 148 >> 2] | 0;
}

function __Z26getPxHeightFieldDescNbRowsPKN5physx17PxHeightFieldDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z25scripting_class_get_imageP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_image(i1 | 0) | 0;
}

function __Z25scripting_class_get_flagsP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_flags(i1 | 0) | 0;
}

function __Z25scripting_class_from_typePK10Il2CppType(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_from_type(i1 | 0) | 0;
}

function __Z25getPxArticulationUserDataPKN5physx14PxArticulationE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function _isxdigit(i1) {
 i1 = i1 | 0;
 return ((i1 + -48 | 0) >>> 0 < 10 | ((i1 | 32) + -97 | 0) >>> 0 < 6) & 1 | 0;
}

function _glDeleteVertexArrays__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteVertexArrays(i1 | 0, i2 | 0);
}

function _glDeleteFramebuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteFramebuffers(i1 | 0, i2 | 0);
}

function _cf2_stack_free(i1) {
 i1 = i1 | 0;
 if (!i1) return;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i1);
 return;
}

function __ZThn4_NK5physx5cloth8SwFabric10getFactoryEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 8 >> 2] | 0) + 4 | 0;
}

function __ZThn4_N5physx5cloth8SwSolverD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwSolverD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwSolverD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwSolverD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwFabricD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwFabricD2Ev(i1 + -4 | 0);
 return;
}

function __ZThn4_N5physx5cloth8SwFabricD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwFabricD2Ev(i1 + -4 | 0);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE7rdstateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE7rdstateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK9BlobWrite25AllowDataLayoutValidationEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 26 >> 0] | 0) == 0 | 0;
}

function __ZNK8VRDevice25GetStereoRenderingEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 300 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx7NpScene29getDynamicTreeRebuildRateHintEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3464 >> 2] | 0;
}

function __ZNK5physx6shdfnd10Foundation20getAllocatorCallbackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController15getClimbingModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 504 >> 2] | 0;
}

function __ZNK5physx2Sn20SerializationContext13getCollectionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 176 >> 2] | 0;
}

function __ZNK5physx2Sc9ClothCore16getContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 64 >> 2]);
}

function __ZNK5physx2Sc5Scene18hasParticleSystemsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 148 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore16getInternalFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 36;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 132;
}

function __ZNK5physx11NpAggregate16getSelfCollisionEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 32 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx10NpMaterial17getStaticFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 36 >> 2]);
}

function __ZNK26AnimatorOverrideController30GetAnimationClipOverrideVectorEv(i1) {
 i1 = i1 | 0;
 return i1 + 84 | 0;
}

function __ZNK26AnimatorOverrideController26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 178624 | 0;
}

function __ZNK18ScreenManagerWebGL8GetWidthEv(i1) {
 i1 = i1 | 0;
 return _JS_SystemInfo_GetCurrentCanvasWidth() | 0;
}

function __ZNK14RedirectHelper11RevertToGetEl(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i2 & -2 | 0) == 302 | 0;
}

function __ZNK14PlayerSettings18GetSubmitAnalyticsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 392 >> 0] | 0) != 0 | 0;
}

function __ZNK13SpeedTreeWind18GetMaxBranchLengthEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 1344 >> 2]);
}

function __ZN9GfxDevice20GetVertexDeclarationERK18VertexChannelsInfo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN9GfxDevice20CreateComputeProgramEPKhj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN9GfxDevice14EndBufferWriteEP9GfxBufferj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN5physx6shdfnd9SListImplC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN5physx3Scb5Scene22removeAggregateFromPvdERNS0_9AggregateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Cm10FanoutTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Cm10FanoutTaskD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18RepXSerializerImplINS_10PxMaterialEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 763461 | 0;
}

function __ZN5Umbra5FloatC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF32[i1 >> 2] = Math_fround(i2 | 0);
 return;
}

function __ZN4FMOD7SystemI19setStreamBufferSizeEjj(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN4FMOD7ReverbI13setPropertiesEPK22FMOD_REVERB_PROPERTIES(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN4FMOD6SoundI11setUserDataEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return 0;
}

function __ZN23PreloadManagerOperation11GetProgressEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 60 >> 2]);
}

function __ZN22BuiltinResourceManager23AreResourcesInitializedEv() {
 return (HEAP8[gb + 1546595 >> 0] | 0) != 0 | 0;
}

function __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN20OcclusionCullingData13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN20NavMeshBuildSettings8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN20HardwareInfoReporterD2Ev(i1) {
 i1 = i1 | 0;
 __ZN20HardwareInfoReporter12CleanupClassEv(i1);
 return;
}

function __ZN19SkinnedMeshRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN19SkinnedMeshRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19SharedRendererSceneD0Ev(i1) {
 i1 = i1 | 0;
 __ZN19SharedRendererSceneD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19ClampVelocityModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN19ClampVelocityModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19AssetBundleManifestD0Ev(i1) {
 i1 = i1 | 0;
 __ZN19AssetBundleManifestD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18AnimatorController8GetAssetEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 128 >> 2] | 0;
}

function __ZN17AudioChorusFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioFilter12AddToManagerEv(i1);
 return;
}

function __ZN15DirectorManager14ConnectionPoolC2Ev(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 return;
}

function __ZN14VehiclesModule22CleanupVehiclesManagerEv(i1) {
 i1 = i1 | 0;
 __Z22CleanupVehiclesManagerv();
 return;
}

function __ZN14ParticleSystem12GetParticlesEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZN13MemoryManager12LowLevelFreeEPvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (i1 | 0) _free(i1);
 return;
}

function __ZN13AudioListener14OnAddComponentEv(i1) {
 i1 = i1 | 0;
 __ZN13AudioListener12ApplyFiltersEv(i1);
 return;
}

function __ZN12NavMeshAgent18GetInternalNavMeshEv() {
 return HEAP32[(__Z17GetNavMeshManagerv() | 0) + 108 >> 2] | 0;
}

function __ZN11NoiseModule13AwakeFromLoadEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 1088 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10builtintex21GetBlackCubeTextureIDEv() {
 return HEAP32[(HEAP32[gb + 1158180 >> 2] | 0) + 48 >> 2] | 0;
}

function __Z6recipTILi1EE8Scalar4fRKS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __Z5recipRK8Scalar4f(i1, i2);
 return;
}

function __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ExceptionOccurredRPv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z42Application_Set_Custom_PropTargetFrameRatei(i1) {
 i1 = i1 | 0;
 __Z18SetTargetFrameRatei(i1);
 return;
}

function __Z39SystemInfo_Get_Custom_PropSupportsAudiov() {
 return (__ZN10systeminfo13SupportsAudioEv() | 0) & 1 | 0;
}

function __Z38getNbPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataE(i1) {
 i1 = i1 | 0;
 return 16;
}

function __Z38AndroidJNI_CUSTOM_GetShortArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z37AndroidJNI_CUSTOM_GetStaticShortField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z36RegisterRemoveImportErrorFromConsolePFviE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1450804 >> 2] = i1;
 return;
}

function __Z26scripting_field_get_parentP9FieldInfo(i1) {
 i1 = i1 | 0;
 return _il2cpp_field_get_parent(i1 | 0) | 0;
}

function __Z26scripting_field_get_offsetP9FieldInfo(i1) {
 i1 = i1 | 0;
 return _il2cpp_field_get_offset(i1 | 0) | 0;
}

function __Z26getPxSceneDescFrictionTypePKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __Z26getPxSceneDescFilterShaderPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __Z21scripting_object_initP12Il2CppObject(i1) {
 i1 = i1 | 0;
 _il2cpp_runtime_object_init(i1 | 0);
 return;
}

function _UNITY_tt_size_done(i1) {
 i1 = i1 | 0;
 _tt_size_done_bytecode(i1);
 HEAP8[i1 + 72 + 36 >> 0] = 0;
 return;
}

function b94(i1, f2, i3, i4) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 i4 = i4 | 0;
 nullFunc_vifii(94);
}

function _wrap_write(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___stdio_write(i1, i2, i3) | 0;
}

function _vwscanf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _vfwscanf(HEAP32[gb + 191748 >> 2] | 0, i1, i2) | 0;
}

function _vprintf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _vfprintf(HEAP32[gb + 191868 >> 2] | 0, i1, i2) | 0;
}

function _strtof_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return Math_fround(+_strtox(i1, i2, 0));
}

function _strcat(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _strcpy(i1 + (_strlen(i1) | 0) | 0, i2) | 0;
 return i1 | 0;
}

function _fegetexceptflag(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP16[i1 >> 1] = _fetestexcept(i2) | 0;
 return 0;
}

function _emscripten_glIsRenderbuffer__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsRenderbuffer(i1 | 0) | 0;
}

function _cf2_getNominalWidthX(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 736 >> 2] | 0) + 532 >> 2] << 16 | 0;
}

function _cf2_getDefaultWidthX(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 736 >> 2] | 0) + 528 >> 2] << 16 | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarker10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv(i1) {
 i1 = i1 | 0;
 return i1 + 176 | 0;
}

function __ZThn4_NK5physx5cloth8SwFabric13getNumIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] << 1 | 0;
}

function __ZNK5physx7NpScene28getSceneQueryStaticTimestampEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3412 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv(i1) {
 i1 = i1 | 0;
 return i1 + 48 | 0;
}

function __ZNK5physx3Cct26CharacterControllerManager8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] & 65535 | 0;
}

function __ZNK5physx2Gu11HeightField12getThicknessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 40 >> 2]);
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx22PxDefaultFileInputData4tellEv(i1) {
 i1 = i1 | 0;
 return _ftell(HEAP32[i1 + 4 >> 2] | 0) | 0;
}

function __ZNK5physx14NpRigidDynamic10isSleepingEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 280 >> 2] | 0) != 0 | 0;
}

function __ZNK5Umbra4Path8getNodesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[((i1 | 0) == 0 ? 0 : i1 + 3 & -4) >> 2] | 0;
}

function __ZNK5Umbra16LineSegmentQuery8getStartEv(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 0 ? 0 : i1 + 3 & -4) | 0;
}

function __ZNK25RuntimeAnimatorController26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 178436 | 0;
}

function __ZNK18PhysxJobDispatcher14getWorkerCountEv(i1) {
 i1 = i1 | 0;
 return __Z22GetJobQueueThreadCountv() | 0;
}

function __ZNK14PhysicMaterial18GetDynamicFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 40 >> 2]);
}

function __ZNK12b2MotorJoint19GetCorrectionFactorEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 100 >> 2]);
}

function __ZNK12CubemapArray20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 84 >> 2] | 0) * 6 | 0;
}

function __ZNK11AudioSource20GetBypassReverbZonesEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 426 >> 0] | 0) != 0 | 0;
}

function __ZN9GfxDevice23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 540 >> 2] = 0;
 return;
}

function __ZN5physx48PCMCapsuleVsHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Cct13BoxControllerD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx3Cct10ControllerD2Ev(i1 + 8 | 0);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_14NpArticulationEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx15PxVehicleWheels7releaseEv(i1) {
 i1 = i1 | 0;
 __ZN5physx15PxVehicleWheels4freeEv(i1);
 return;
}

function __ZN4Mesh15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN17CollisionMeshData7CleanupEv(i1 + 204 | 0);
 return;
}

function __ZN4FMOD4DSPI12setParameterEif(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 return 0;
}

function __ZN24RingBufferMemoryFileData9SetLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN23PreloadManagerOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14AsyncOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19SkinnedMeshRenderer12CleanupClassEv() {
 __Z42CleanupBlendShapeAnimationBindingInterfacev();
 return;
}

function __ZN19SharedBillboardData8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19ParticleSystemState8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19GCProfilerCallbacksL10OnGCResizeEPvx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN17GeneralConnection14NetworkMessage11GetDataSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN15DownloadHandler21OnBindScriptingObjectEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14SpriteRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN8Renderer15ThreadedCleanupEv(i1);
 return;
}

function __ZN14DirectorPlayer17SetTimeUpdateModeE18DirectorUpdateMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13BaseAllocator17GetUsedBlockCountEPii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN13BaseAllocator17GetFreeBlockCountEPii(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN12TreeRenderer11ReloadTreesEv(i1) {
 i1 = i1 | 0;
 __ZN12TreeRenderer11ReloadTreesEi(i1, 500);
 return;
}

function __ZN11NamedObject7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN11GameManager7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN11ColorModule5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4 >> 0] = 0;
 HEAP16[i1 + 160 >> 1] = 1;
 return;
}

function __ZN11AudioSource18IsPlayingScriptingEv(i1) {
 i1 = i1 | 0;
 return __ZNK11AudioSource9IsPlayingEv(i1) | 0;
}

function __ZN11AudioFilter7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN10GameObject5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 48 >> 2] = 0;
 HEAP16[i1 + 52 >> 1] = 0;
 return;
}

function __ZN10Effector2D5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 56 >> 0] = 1;
 HEAP32[i1 + 60 >> 2] = -1;
 return;
}

function __Z42SystemInfo_Get_Custom_PropSystemMemorySizev() {
 return __ZN10systeminfo19GetPhysicalMemoryMBEv() | 0;
}

function __Z41AudioChorusFilter_Get_Custom_PropFeedbackP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __Z37AndroidJNI_CUSTOM_GetCharArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z37AndroidJNI_CUSTOM_GetByteArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z36Time_Get_Custom_PropCaptureFrameratev() {
 return HEAP32[(__Z14GetTimeManagerv() | 0) + 144 >> 2] | 0;
}

function __Z36AndroidJNI_CUSTOM_GetStaticCharField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z36AndroidJNI_CUSTOM_GetStaticByteField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z31Profiler_Get_Custom_PropEnabledv() {
 return HEAP32[(HEAP32[gb + 1451e3 >> 2] | 0) + 24 >> 2] & 1 | 0;
}

function __Z24scripting_class_get_typeP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_type(i1 | 0) | 0;
}

function __Z24scripting_class_get_nameP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_get_name(i1 | 0) | 0;
}

function __Z22getPxD6JointDriveFlagsPKN5physx14PxD6JointDriveE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __Z11heapReallocPvS_j(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _realloc(i2, i3) | 0;
}

function b71(i1, i2, d3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 i4 = i4 | 0;
 nullFunc_iiidi(71);
 return 0;
}

function b24(f1, f2, f3) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 nullFunc_vfff(24);
}

function _sort(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strcmp(HEAP32[i1 >> 2] | 0, HEAP32[i2 >> 2] | 0) | 0;
}

function _setresuid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___setxid(208, i1, i2, i3) | 0;
}

function _setresgid(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___setxid(210, i1, i2, i3) | 0;
}

function _emscripten_glClientActiveTexture__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glClientActiveTexture(i1 | 0);
}

function __ZThn32_N17BillboardRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17BillboardRendererD0Ev(i1 + -32 | 0);
 return;
}

function __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1);
 return;
}

function __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1);
 return;
}

function __ZNSt3__28__sp_mut6unlockEv(i1) {
 i1 = i1 | 0;
 __ZNSt3__25mutex6unlockEv(HEAP32[i1 >> 2] | 0);
 return;
}

function __ZNSt3__212strstreambufD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212strstreambufD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt16nested_exceptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt16nested_exceptionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK9Transform20GetHierarchyCapacityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[HEAP32[i1 + 32 >> 2] >> 2] | 0;
}

function __ZNK7Terrain24GetTreeLODBiasMultiplierEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 196 >> 2]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv(i1) {
 i1 = i1 | 0;
 return i1 + 60 | 0;
}

function __ZNK5physx3Cct13BoxController18getNonWalkableModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx38PxsSolverCreateFinalizeConstraintsTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720403 | 0;
}

function __ZNK5physx2Sc8BodyCore14getWakeCounterEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 152 >> 2]);
}

function __ZNK5physx2Gu12TriangleMesh20getTriangleMeshFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 172 >> 0] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 44;
}

function __ZNK5physx17PxcNpMemBlockPool17getUsedBlockCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 152 >> 2] | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP18getNumDeletedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 112 >> 2] | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP18getNumCreatedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK5physx15NpActorTemplateINS_7PxClothEE7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx12NpBatchQuery23getFilterShaderDataSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __ZNK25UnityWebRequestJavaScript16GetDownloadBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK24PhysicsUpdateBehaviour2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 154956 | 0;
}

function __ZNK24EllipsoidParticleEmitter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 190404 | 0;
}

function __ZNK21AnimationClipPlayable7GetTimeEv(i1) {
 i1 = i1 | 0;
 return +(+Math_fround(HEAPF32[i1 + 96 >> 2]));
}

function __ZNK18ScreenManagerWebGL13GetShowCursorEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 24 >> 0] | 0) != 0 | 0;
}

function __ZNK16b2PrismaticJoint14IsMotorEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 137 >> 0] | 0) != 0 | 0;
}

function __ZNK16b2PrismaticJoint14IsLimitEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 136 >> 0] | 0) != 0 | 0;
}

function __ZNK14PhysicMaterial17GetStaticFrictionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 44 >> 2]);
}

function __ZNK13GfxDeviceNull26GetActiveRenderTargetCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4908 >> 2] | 0;
}

function __ZNK13GfxDeviceGLES16IsScissorEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 7185 >> 0] | 0) != 0 | 0;
}

function __ZNK10UnityScene7IsEmptyEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 104 >> 2] | 0) == (i1 + 100 | 0) | 0;
}

function __ZN9GfxDevice11CopyTextureE9TextureIDS0_(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __ZN8TToArray5IndexIfEEfRKT_i(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __ZN6detail14AlignedPointerIfEC2EPKf(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 >> 2] = i1;
 return;
}

function __ZN6b2DrawC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 158524 + 8;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN6Object25RegisterDestroyedCallbackEPFviE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1104580 >> 2] = i1;
 return;
}

function __ZN5physx7NpShape7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 HEAP32[i2 + 192 >> 2] = i1;
 return;
}

function __ZN5physx47PCMSphereVsHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx47PCMConvexVsHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_ED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu13RTreeMidphaseD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu5RTree7releaseEv(i1 + 16 | 0);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20PxsParticleSystemSim17getParticleStateVEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15switchFromNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx19NpClothParticleData18getDataAccessFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 20 >> 0] | 0;
}

function __ZN5physx18RepXSerializerImplINS_9PxD6JointEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765108 | 0;
}

function __ZN5physx18PxVehicleDriveTank4freeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive4freeEv(i1);
 return;
}

function __ZN5Unity5Joint7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN26AnimatorControllerPlayable15GetRecorderDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZN23ArchiveStorageConverter11SetPriorityE14ThreadPriority(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN21AudioDistortionFilter5ResetEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 44 >> 2] = Math_fround(.5);
 return;
}

function __ZN21AssetBundleFileSystem11CreateAsDirER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN20SoundChannelInstance15ParameterBufferC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 148) | 0;
 return;
}

function __ZN19CharacterController13GetStepOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZN19CharacterController13GetSlopeLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 80 >> 2]);
}

function __ZN18UnityConnectClientD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18UnityConnectClientD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18SharedMaterialDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18SharedMaterialDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18ShadowMapJobHeaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18ShadowMapJobHeaderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18GlslGpuProgramGLESD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18GlslGpuProgramGLESD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18DeferredRenderLoopD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18DeferredRenderLoopD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18ColorBySpeedModuleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83528 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN18AnimatorControllerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN18AnimatorControllerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN18AnimatorController23GetAnimationSetBindingsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 136 >> 2] | 0;
}

function __ZN16BehaviourManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN15NavMeshObstacle10SmartResetEv(i1) {
 i1 = i1 | 0;
 __ZN15NavMeshObstacle10FitExtentsEv(i1);
 return;
}

function __ZN15AudioEchoFilter12AddToManagerEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioFilter12AddToManagerEv(i1);
 return;
}

function __ZN14UnityAnalytics18IsAnalyticsEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 28 >> 0] | 0) != 0 | 0;
}

function __ZN14PhysicsManager18GetBounceThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __ZN14CompressedMesh10GetQualityE15MeshCompression(i1) {
 i1 = i1 | 0;
 return gb + 58120 + (i1 << 4) | 0;
}

function __ZN13TextRendering4FontD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13TextRendering4FontD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13MonoBehaviour6UpdateEv(i1) {
 i1 = i1 | 0;
 __ZN13MonoBehaviour16CallUpdateMethodEi(i1, 0);
 return;
}

function __ZN12_GLOBAL__N_110Connection17getConnectionTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 112 >> 2] | 0;
}

function __ZN11NoiseModule11ResetScrollEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 1088 >> 2] = Math_fround(0.0);
 return;
}

function __ZN10GUIElement7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN10Effector2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN10Collider2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZL18ShouldCancelInvokePvS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_strcmp(i1, i2) | 0) == 0 | 0;
}

function __Z55ParticleSystem_TriggerModule_CUSTOM_GetMaxColliderCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 6;
}

function __Z43HumanTrait_Get_Custom_PropRequiredBoneCountv() {
 return __ZN10HumanTrait17RequiredBoneCountEv() | 0;
}

function __Z43Gyroscope_CUSTOM_setUpdateInterval_Internalif(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireCubeRK8Vector3fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z38GUIUtility_CUSTOM_Internal_GetGUIDepthv() {
 return HEAP32[(__Z11GetGUIStatev() | 0) + 340 >> 2] | 0;
}

function __Z36Motion_CUSTOM_ValidateIfRetargetableP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z36AndroidJNI_CUSTOM_GetIntArrayElement13Il2Cpp_IntPtri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z35AndroidJNI_CUSTOM_GetStaticIntField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z33RenderSettings_Get_Custom_PropFogv() {
 return HEAP8[(__Z17GetRenderSettingsv() | 0) + 312 >> 0] | 0;
}

function __Z30TryGetManagedStackFrameDetailsPvR17ManagedStackFrame(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z28GUIUtility_CUSTOM_GetChangedv() {
 return (HEAP32[(__Z11GetGUIStatev() | 0) + 64 >> 2] | 0) != 0 | 0;
}

function __Z27getPxSceneLimitsMaxNbActorsPKN5physx13PxSceneLimitsE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z25scripting_field_get_flagsP9FieldInfo(i1) {
 i1 = i1 | 0;
 return _il2cpp_field_get_flags(i1 | 0) | 0;
}

function __Z23scripting_thread_attachP12Il2CppDomain(i1) {
 i1 = i1 | 0;
 return _il2cpp_thread_attach(i1 | 0) | 0;
}

function _TT_Forget_Glyph_Frame(i1) {
 i1 = i1 | 0;
 _UNITY_FT_Stream_ExitFrame(HEAP32[i1 + 24 >> 2] | 0);
 return;
}

function setThrew(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 if (!__THREW__) {
  __THREW__ = i1;
  threwValue = i2;
 }
}

function _wcsxfrm(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___wcsxfrm_l(i1, i2, i3, 0) | 0;
}

function _vscanf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _vfscanf(HEAP32[gb + 191748 >> 2] | 0, i1, i2) | 0;
}

function _toupper(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (_islower(i1) | 0) == 0;
 return (i2 ? i1 : i1 & 95) | 0;
}

function _tolower(i1) {
 i1 = i1 | 0;
 var i2 = 0;
 i2 = (_isupper(i1) | 0) == 0;
 return (i2 ? i1 : i1 | 32) | 0;
}

function _strrchr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___memrchr(i1, i2, (_strlen(i1) | 0) + 1 | 0) | 0;
}

function _jsimd_h2v2_downsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _jsimd_h2v1_downsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _emscripten_glIsFramebuffer__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsFramebuffer(i1 | 0) | 0;
}

function _clock_gettime__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _clock_gettime(i1 | 0, i2 | 0) | 0;
}

function __ZThn4_NK5physx5cloth8SwFabric16getNumRestvaluesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNKSt12experimental15fundamentals_v112bad_any_cast4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1076114 | 0;
}

function __ZNK8VRDevice22GetRenderViewportScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 312 >> 2]);
}

function __ZNK8VRDevice22GetDidPauseApplicationEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 328 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx5cloth8SwSolver22CpuClothSimulationTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 838465 | 0;
}

function __ZNK5physx5cloth8SwFabric10getNumSetsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 36 >> 2] | 0) + -1 | 0;
}

function __ZNK5physx2Sc9ClothCore13getRestOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 68 >> 2]);
}

function __ZNK5physx2Sc13ConstraintSim8isBrokenEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 88;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 64;
}

function __ZNK5physx18NpArticulationLink15getInboundJointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 292 >> 2] | 0;
}

function __ZNK5physx18NpArticulationLink15getArticulationEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 288 >> 2] | 0;
}

function __ZNK5physx14NpArticulation10isSleepingEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 64 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx10NpMaterial14getRestitutionEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 40 >> 2]);
}

function __ZNK5Unity17ConfigurableJoint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 111956 | 0;
}

function __ZNK26LegacyTreeInstanceRenderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZNK24OcclusionCullingSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 35088 | 0;
}

function __ZNK23CloudWebServicesManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 189852 | 0;
}

function __ZNK18ProceduralMaterial45CheckIfInputModificationIsAllowedAndWarnIfNotEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK17ArchiveFileSystem8FilenameERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZNK16b2PrismaticJoint13GetUpperLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 124 >> 2]);
}

function __ZNK16b2PrismaticJoint13GetLowerLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 120 >> 2]);
}

function __ZNK15b2RevoluteJoint14IsMotorEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 100 >> 0] | 0) != 0 | 0;
}

function __ZNK15b2RevoluteJoint14IsLimitEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 112 >> 0] | 0) != 0 | 0;
}

function __ZNK13EmscriptenWWW17IsDownloadingDoneEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 96 >> 0] | 0) != 0 | 0;
}

function __ZNK13EmscriptenWWW17GetUploadProgressEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZN9ShaderLab20ParserStateStackSizeEv() {
 return HEAP32[(HEAP32[gb + 1166560 >> 2] | 0) + 20 >> 2] | 0;
}

function __ZN9GfxDevice28GetNativeVertexBufferPointerEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN8Animator24StopGraphsAndClearObjectEv(i1) {
 i1 = i1 | 0;
 __ZN8Animator11ClearObjectEv(i1);
 return;
}

function __ZN7mecanim4hand14BoneFromMuscleEi(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179592 + (i1 << 2) >> 2] | 0;
}

function __ZN6Sprite19CanAccessFromScriptEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 112 >> 2] & 64 | 0) != 0 | 0;
}

function __ZN6Object18RegisterInstanceIDEPS_(i1) {
 i1 = i1 | 0;
 __ZN6Object17InsertObjectInMapEPS_(i1);
 return;
}

function __ZN6Camera14SetCullingMaskEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 880 >> 2] = i2;
 return;
}

function __ZN5physx6shdfnd7PAUtils10startEventEtt(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_12NpConstraintEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx25PxGeometryGeneratedValuesC2EPKNS_10PxGeometryE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxVehicleNoDrive4freeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx15PxVehicleWheels4freeEv(i1);
 return;
}

function __ZN4crnd10dxt1_block14pack_endpointsEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 << 16 | i1 | 0;
}

function __ZN4FMOD22FakeModChannelCallbackEPv(i1) {
 i1 = i1 | 0;
 __ZN4FMOD8ChannelI11EndCallbackEv(i1);
 return;
}

function __ZN29BillboardTreeInstanceRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20IntermediateRendererD2Ev(i1);
 return;
}

function __ZN26DownloadHandlerAssetBundle22OnReceiveContentLengthEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN24MeshIntermediateRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 280 >> 2] = 0;
 return;
}

function __ZN24DownloadHandlerAudioClip17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 1;
 return;
}

function __ZN23iPhoneLocalNotificationC2ERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN23iPhoneLocalNotification11SetUserInfoEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19CharacterController12GetSkinWidthEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 76 >> 2]);
}

function __ZN18PlatformEffector2D21ContactUpdateCallbackEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZN17MemoryCacheWriterD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65660 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17MemoryCacheReaderD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 67168 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17GeneralConnection14NetworkMessage5GetIDEv(i1) {
 i1 = i1 | 0;
 return HEAPU16[i1 + 2 >> 1] | 0 | 0;
}

function __ZN17CollisionMeshData13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17ArchiveFileSystem16DestroyFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16DeveloperConsole14HasLogMessagesEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) != 0 | 0;
}

function __ZN14PhysicsManager17GetSleepThresholdEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 44 >> 2]);
}

function __ZN13UploadHandler21OnBindScriptingObjectEP12Il2CppObject(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12SocketStream16InterruptedErrorEv(i1) {
 i1 = i1 | 0;
 return __ZN6Socket16InterruptedErrorEv() | 0;
}

function __ZN11UnityEngine9Animation31GetGenericAnimationBindingCacheEv() {
 return HEAP32[gb + 1466544 >> 2] | 0;
}

function __ZN11ICallStringC2EP12Il2CppString(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __Z54ParticleSystem_CollisionModule_CUSTOM_GetMaxPlaneCountP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 6;
}

function __Z41Input_Get_Custom_PropStylusTouchSupportedv() {
 return (__Z22IsStylusTouchSupportedv() | 0) & 1 | 0;
}

function __Z39Light_Get_Custom_PropShadowSoftnessFadeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(1.0);
}

function __Z34Input_Get_Custom_PropImeIsSelectedv() {
 return HEAP8[(__Z15GetInputManagerv() | 0) + 176 >> 0] | 0;
}

function __Z34Graphics_Get_Custom_PropActiveTierv() {
 return HEAP32[(__Z15GetGraphicsCapsv() | 0) + 92 >> 2] | 0;
}

function __Z34AndroidJNI_CUSTOM_IsAssignableFrom13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z33Debug_Get_Custom_PropIsDebugBuildv() {
 return HEAP8[(__Z16GetBuildSettingsv() | 0) + 119 >> 0] | 0;
}

function __Z32AndroidJNI_CUSTOM_GetDoubleField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0.0;
}

function __Z24Time_Get_Custom_PropTimev() {
 return Math_fround(+HEAPF64[(__Z14GetTimeManagerv() | 0) + 96 >> 3]);
}

function __Z23scripting_type_get_typePK10Il2CppType(i1) {
 i1 = i1 | 0;
 return _il2cpp_type_get_type(i1 | 0) | 0;
}

function __Z23scripting_type_get_namePK10Il2CppType(i1) {
 i1 = i1 | 0;
 return _il2cpp_type_get_name(i1 | 0) | 0;
}

function __Z23scripting_class_is_enumP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_class_is_enum(i1 | 0) | 0;
}

function __Z22getPxSceneDescUserDataPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 128 >> 2] | 0;
}

function __Z19SetIClusterRendererP16IClusterRenderer(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162128 >> 2] = i1;
 return;
}

function __Z18getPxSpringDampingPKN5physx8PxSpringE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function __Z17IsValidScriptType14MonoScriptType(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 1 | (i1 | 2 | 0) == 2 | 0;
}

function __Z15GetSoundManagerv() {
 return __ZN12AudioManager15GetSoundManagerEv(__Z15GetAudioManagerv() | 0) | 0;
}

function _significandf(f1) {
 f1 = Math_fround(f1);
 return Math_fround(_scalbnf(f1, 0 - (_ilogbf(f1) | 0) | 0));
}

function _ngettext(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ((i3 | 0) == 1 ? i1 : i2) | 0;
}

function _mbsinit(i1) {
 i1 = i1 | 0;
 if (!i1) i1 = 1; else i1 = (HEAP32[i1 >> 2] | 0) == 0;
 return i1 & 1 | 0;
}

function _glGenRenderbuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenRenderbuffers(i1 | 0, i2 | 0);
}

function _glBindRenderbuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindRenderbuffer(i1 | 0, i2 | 0);
}

function _fputs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (_fwrite(i1, _strlen(i1) | 0, 1, i2) | 0) + -1 | 0;
}

function _emscripten_longjmp__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_longjmp(i1 | 0, i2 | 0);
}

function _do_read(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___string_read(i1, i2, i3) | 0;
}

function __ZZ23InitPlayerLoopCallbacksvEN47InitializationAsyncUploadTimeSlicedUpdatestruct7ForwardEv() {
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv(i1) {
 i1 = i1 | 0;
 return i1 + 160 | 0;
}

function __ZThn4_NK5physx5cloth8SwFabric15getNumParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZThn340_N17BillboardRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__26locale5__impD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__26locale5__impD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt12experimental19bad_optional_accessD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 return;
}

function __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNK5physx5cloth8SwFabric10getFactoryEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) + 4 | 0;
}

function __ZNK5physx2Gu12TriangleMesh17getTrianglesRemapEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 180 >> 2] | 0;
}

function __ZNK5physx27PxDefaultMemoryOutputStream7getSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx20PxsParticleSystemSim24getExternalAccelerationVEv(i1) {
 i1 = i1 | 0;
 return i1 + 1112 | 0;
}

function __ZNK5physx14NpSpatialIndex9getBoundsEj(i2, i3, i1) {
 i2 = i2 | 0;
 i3 = i3 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNK26AnimatorControllerPlayable25GetStateMachineBehavioursEv(i1) {
 i1 = i1 | 0;
 return i1 + 112 | 0;
}

function __ZNK25UnityWebRequestJavaScript14GetUploadBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK25ThreadsafeLinearAllocator17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK23ShaderVariantCollection26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31592 | 0;
}

function __ZNK22NavMeshProjectSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 169664 | 0;
}

function __ZNK15b2RevoluteJoint13GetUpperLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 124 >> 2]);
}

function __ZNK15b2RevoluteJoint13GetLowerLimitEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 120 >> 2]);
}

function __ZNK15AudioReverbZone14GetMinDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZNK15AudioReverbZone14GetMaxDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 52 >> 2]);
}

function __ZNK13RendererScene26GetIntermediateObjectCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK13BaseAllocator26GetPeakAllocatedMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK11LightProbes14LightProbeData12GetNumProbesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNK10SampleClip19GetPreloadAudioDataEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 64 >> 0] | 0) != 0 | 0;
}

function __ZN9GfxDevice27GetNativeIndexBufferPointerEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN9Behaviour7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN7mecanim4hand13FingerDoFNameEj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179268 + (i1 << 2) >> 2] | 0;
}

function __ZN6Socket8SetErrorEi(i1) {
 i1 = i1 | 0;
 HEAP32[(___errno_location() | 0) >> 2] = i1;
 return i1 | 0;
}

function __ZN6Object23VirtualRedirectTransferER17RemapPPtrTransfer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Camera13SetClearFlagsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 844 >> 2] = i2;
 return;
}

function __ZN5physx2Sc24ElementInteractionMarker12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_11NpAggregateEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx21PxcArticulationHelper13getFsDataSizeEj(i1) {
 i1 = i1 | 0;
 return (i1 * 160 | 0) + 144 | 0;
}

function __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13switchToNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx18RepXSerializerImplINS_7PxShapeEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 690295 | 0;
}

function __ZN5physx18RepXSerializerImplINS_7PxClothEE11getTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764818 | 0;
}

function __ZN5physx16PxVehicleDriveNW4freeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive4freeEv(i1);
 return;
}

function __ZN5physx16PxVehicleDrive4W4freeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx14PxVehicleDrive4freeEv(i1);
 return;
}

function __ZN5physx13NpVolumeCache21getMaxNbDynamicShapesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZN5physx12NpBatchQuery11getRunOnSpuEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 128 >> 0] | 0) != 0 | 0;
}

function __ZN5physx11AdjacenciesC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN4crnd10dxt5_block14pack_endpointsEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 << 8 | i1 | 0;
}

function __ZN4FMOD8ChannelI20set3DConeOrientationEP11FMOD_VECTOR(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN2UI14CanvasRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN2UI14CanvasRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN22CrashReportingSettings18InitializeDefaultsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return;
}

function __ZN21LoadResourceOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13LoadOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN19ParticleSystemState8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17SizeBySpeedModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17SizeBySpeedModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17ProceduralTextureD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17ProceduralTextureD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17PolygonCollider2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17PolygonCollider2DD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17PersistentManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17PersistentManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17GenericDynamicVBOD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17GenericDynamicVBOD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17GeneralConnectionD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17GeneralConnectionD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17ArchiveFileSystemD0Ev(i1) {
 i1 = i1 | 0;
 __ZN17ArchiveFileSystemD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16StreamedResource8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16MemoryFileSystem16DestroyFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16GraphicsSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14VehiclesModule20SetupVehiclesManagerEv(i1) {
 i1 = i1 | 0;
 __Z20SetupVehiclesManagerv();
 return;
}

function __ZN14RenderSettings19PostInitializeClassEv() {
 __ZN10builtintex23GenerateBuiltinTexturesEv();
 return;
}

function __ZN13MonoBehaviour12CleanupClassEv() {
 __Z45CleanupMonoBehaviourAnimationBindingInterfacev();
 return;
}

function __ZN13GfxDeviceNull14SetRasterStateEPK17DeviceRasterState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12NavMeshAgent14GetCrowdSystemEv() {
 return HEAP32[(__Z17GetNavMeshManagerv() | 0) + 100 >> 2] | 0;
}

function __ZN12InputManager17GetTextFieldInputEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 168 >> 0] | 0) != 0 | 0;
}

function __ZN11AudioSource14OnAddComponentEv(i1) {
 i1 = i1 | 0;
 __ZN11AudioSource12ApplyFiltersEv(i1);
 return;
}

function __ZN10builtintex17GetBlackTextureIDEv() {
 return HEAP32[(HEAP32[gb + 1157932 >> 2] | 0) + 48 >> 2] | 0;
}

function __Z6b2FreePv(i1) {
 i1 = i1 | 0;
 __Z19free_alloc_internalPvRK10MemLabelId(i1, gb + 63408 | 0);
 return;
}

function __Z44Application_Get_Custom_PropStackTraceLogTypev() {
 return __Z20GetStackTraceLogType7LogType(3) | 0;
}

function __Z41Texture_Get_Custom_PropMasterTextureLimitv() {
 return __ZN7Texture21GetMasterTextureLimitEv() | 0;
}

function __Z41Application_Get_Custom_PropSystemLanguagev() {
 return __ZN10systeminfo17GetSystemLanguageEv() | 0;
}

function __Z40Input_Get_Custom_PropBackButtonLeavesAppv() {
 return (__Z22GetBackButtonLeavesAppv() | 0) & 1 | 0;
}

function __Z38Shader_Get_Custom_PropGlobalMaximumLODv() {
 return __ZN6Shader25GetGlobalMaximumShaderLODEv() | 0;
}

function __Z36CanvasRenderer_Set_Custom_PropIsMaskP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z33AndroidJNI_CUSTOM_GetBooleanField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z32Application_CUSTOM_HasProLicensev() {
 return HEAP8[(__Z16GetBuildSettingsv() | 0) + 108 >> 0] | 0;
}

function __Z26GUI_Get_Custom_PropEnabledv() {
 return (HEAP32[(__Z11GetGUIStatev() | 0) + 60 >> 2] | 0) != 0 | 0;
}

function __Z26GUI_Get_Custom_PropChangedv() {
 return (HEAP32[(__Z11GetGUIStatev() | 0) + 64 >> 2] | 0) != 0 | 0;
}

function __Z24scripting_field_get_typeP9FieldInfo(i1) {
 i1 = i1 | 0;
 return _il2cpp_field_get_type(i1 | 0) | 0;
}

function __Z24scripting_field_get_nameP9FieldInfo(i1) {
 i1 = i1 | 0;
 return _il2cpp_field_get_name(i1 | 0) | 0;
}

function __Z23scripting_thread_detachP12Il2CppThread(i1) {
 i1 = i1 | 0;
 _il2cpp_thread_detach(i1 | 0);
 return;
}

function __Z22scripting_string_charsP12Il2CppString(i1) {
 i1 = i1 | 0;
 return _il2cpp_string_chars(i1 | 0) | 0;
}

function __Z22scripting_object_unboxP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return _il2cpp_object_unbox(i1 | 0) | 0;
}

function b51(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 nullFunc_fiii(51);
 return Math_fround(0);
}

function _jsimd_h2v2_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _jsimd_h2v1_upsample(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return;
}

function _glGetStringi__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _glGetStringi(i1 | 0, i2 | 0) | 0;
}

function _getline(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _getdelim(i1, i2, 10, i3) | 0;
}

function _emscripten_glCreateShader__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glCreateShader(i1 | 0) | 0;
}

function __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__26threadD2Ev(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return; else __ZSt9terminatev();
}

function __ZNSt3__212system_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK9Rigidbody19GetDetectCollisionsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 100 >> 0] | 0) != 0 | 0;
}

function __ZNK8Renderer8GetLayerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 28 >> 2] | 0) + 48 >> 2] | 0;
}

function __ZNK5physx6shdfnd10Foundation16getErrorCallbackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController11getUserDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK5physx2Gu12TriangleMesh17getReferenceCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx27PxDefaultMemoryOutputStream7getDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx18NpArticulationLink13getNbChildrenEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 324 >> 2] | 0;
}

function __ZNK5physx15PxsParticleData17getParticleCountVEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK22ParticleSystemRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 80260 | 0;
}

function __ZNK21WorldParticleCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 191360 | 0;
}

function __ZNK21UnityAnalyticsManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 188588 | 0;
}

function __ZNK21AudioDistortionFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 170864 | 0;
}

function __ZNK20LocalFileSystemPosix8IsHiddenERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK20IntermediateRenderer12GetLayerMaskEv(i1) {
 i1 = i1 | 0;
 return 1 << HEAP32[i1 + 260 >> 2] | 0;
}

function __ZNK20DynamicPropertySheet7IsDirtyEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 124 >> 2] | 0) != 0 | 0;
}

function __ZNK15b2FrictionJoint12GetMaxTorqueEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 100 >> 2]);
}

function __ZNK14GfxContextGLES14GetFramebufferEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + 8 | 0;
}

function __ZNK13ScreenManager14HasBlitTextureEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 44 >> 2] | 0) != 0 | 0;
}

function __ZNK12b2MotorJoint16GetAngularOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 76 >> 2]);
}

function __ZNK12AudioManager16GetListenerPauseEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 40 >> 0] | 0) != 0 | 0;
}

function __ZNK11AudioSource16GetBypassEffectsEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 424 >> 0] | 0) != 0 | 0;
}

function __ZN8keywords20GetTotalKeywordCountEv() {
 return HEAP32[(HEAP32[gb + 1166252 >> 2] | 0) + 8 >> 2] | 0;
}

function __ZN8Renderer7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN8Collider7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN7mecanim4hand12PhalangeNameEj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179140 + (i1 << 2) >> 2] | 0;
}

function __ZN7Texture5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 56 >> 2] = 0;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __ZN6Camera12SetEventMaskEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 884 >> 2] = i2;
 return;
}

function __ZN5physx6shdfnd7PAUtils9stopEventEtt(i3, i2, i1) {
 i3 = i3 | 0;
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd7PAUtils9statEventEtj(i3, i1, i2) {
 i3 = i3 | 0;
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx3Scb5Scene17addAggregateToPvdERNS0_9AggregateE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_10NpMaterialEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx22XmlMemoryAllocatorImpl12getAllocatorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN5physx14PxVehicleDrive4freeEv(i1) {
 i1 = i1 | 0;
 __ZN5physx15PxVehicleWheels4freeEv(i1);
 return;
}

function __ZN5physx13NpVolumeCache20getMaxNbStaticShapesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZN5physx10PxsContext11beginUpdateEv(i1) {
 i1 = i1 | 0;
 _memset(i1 + 6980 | 0, 0, 620) | 0;
 return;
}

function __ZN4FMOD6SoundI7setModeEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 44 >> 2] = i2;
 return 0;
}

function __ZN23PreloadManagerOperation6IsDoneEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 24 >> 2] | 0) == 2 | 0;
}

function __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17FileSystemHandler12CreateAsFileER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem12CreateAsFileER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15NavMeshSettings13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN15EditorExtensionD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN14PreloadManager17SetThreadPriorityE14ThreadPriority(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14PhysicsManager23SetSleepAngularVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZN13UpdateManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20BaseBehaviourManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13TextRendering4Font12CleanupClassEv() {
 __ZN20TextRenderingPrivate15CleanupFreeTypeEv();
 return;
}

function __ZN13MonoBehaviour15GetUseGUILayoutEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 142 >> 0] | 0) != 0 | 0;
}

function __ZN12SocketStream15WouldBlockErrorEv(i1) {
 i1 = i1 | 0;
 return __ZN6Socket15WouldBlockErrorEv() | 0;
}

function __ZN10GameObject27InvalidateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 60 >> 2] = 0;
 return;
}

function __Z41GUIUtility_Get_Custom_PropKeyboardControlv() {
 return HEAP32[(__Z11GetGUIStatev() | 0) >> 2] | 0;
}

function __Z40SystemInfo_Get_Custom_PropProcessorCountv() {
 return __ZN10systeminfo17GetProcessorCountEv() | 0;
}

function __Z32AndroidJNI_CUSTOM_GetStringField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z31HumanTrait_CUSTOM_GetParentBonei(i1) {
 i1 = i1 | 0;
 return __ZN10HumanTrait9GetParentEi(i1) | 0;
}

function __Z25GetSubstanceTextureFormat21SubstanceOutputFormatb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 4;
}

function __Z22scripting_array_lengthP11Il2CppArray(i1) {
 i1 = i1 | 0;
 return _il2cpp_array_length(i1 | 0) | 0;
}

function __Z20getPxSpringStiffnessPKN5physx8PxSpringE(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function __Z20GetChannelFormatSizeh(i1) {
 i1 = i1 | 0;
 return HEAPU8[(i1 & 255) + (gb + 430676) >> 0] | 0 | 0;
}

function __Z18SetITerrainPhysicsP15ITerrainPhysics(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162164 >> 2] = i1;
 return;
}

function __Z18SetITerrainManagerP15ITerrainManager(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162160 >> 2] = i1;
 return;
}

function __Z18SetIParticleSystemP15IParticleSystem(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162144 >> 2] = i1;
 return;
}

function _UNITY_png_reset_crc(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 408 >> 2] = _unity_z_crc32(0, 0, 0) | 0;
 return;
}

function _UNITY_FT_Init_Class_tt_service_truetype_glyf(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = fb + 471;
 return;
}

function _wcscasecmp_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _wcscasecmp(i1, i2) | 0;
}

function _strcasecmp_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _strcasecmp(i1, i2) | 0;
}

function _glGenVertexArrays__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenVertexArrays(i1 | 0, i2 | 0);
}

function _glGenFramebuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenFramebuffers(i1 | 0, i2 | 0);
}

function _glBindFramebuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindFramebuffer(i1 | 0, i2 | 0);
}

function _emscripten_glHint__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _emscripten_glHint(i1 | 0, i2 | 0);
}

function _emscripten_glEnableClientState__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glEnableClientState(i1 | 0);
}

function _emscripten_glDepthRange__wrapper(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 _emscripten_glDepthRange(+d1, +d2);
}

function __ZZ23InitPlayerLoopCallbacksvEN45PostLateUpdateExecuteOneJobInMainThreadstruct7ForwardEv() {
 return;
}

function __ZThn4_NK5physx5cloth8SwFabric13getNumTethersEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 68 >> 2] | 0;
}

function __ZNSt3__28numpunctIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28numpunctIwED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28numpunctIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28numpunctIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__211regex_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210ostrstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210ostrstreamD1Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210istrstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__210istrstreamD1Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt15underflow_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK9WWWCached17IsDownloadingDoneEv(i1) {
 i1 = i1 | 0;
 return __ZN9WWWCached10IsDoneImplEv(i1) | 0;
}

function __ZNK6Camera20IsCurrentlyRenderingEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 1116 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx7NpScene23getFilterShaderDataSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1144 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv(i1) {
 i1 = i1 | 0;
 return i1 + 180 | 0;
}

function __ZNK5physx5cloth8SwSolver19StartSimulationTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 838109 | 0;
}

function __ZNK5physx5cloth8SwFabric13getNumIndicesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] << 1 | 0;
}

function __ZNK5physx34PxsSolverConstraintPostProcessTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720591 | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv(i1) {
 i1 = i1 | 0;
 return i1 + 20 | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv(i1) {
 i1 = i1 | 0;
 return i1 + 36 | 0;
}

function __ZNK5physx2Gu11HeightField17getReferenceCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 208;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12getClassSizeEv(i1) {
 i1 = i1 | 0;
 return 152;
}

function __ZNK5physx24PxDefaultMemoryInputData9getLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx12NpBatchQuery19getPostFilterShaderEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZNK5physx12NpBatchQuery19getFilterShaderDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __ZNK5Unity14CharacterJoint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 111756 | 0;
}

function __ZNK23LODTreeInstanceRenderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZNK21LightProbeProxyVolume26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30592 | 0;
}

function __ZNK21IntermediateRenderers16GetBoundingBoxesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK21AssetBundleFileSystem6ExistsERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK20UnityConnectSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 189244 | 0;
}

function __ZNK14TerrainManager31GetSplatBaseMaterialTextureNameEv(i1) {
 i1 = i1 | 0;
 return gb + 1467248 | 0;
}

function __ZNK14PhysicMaterial13GetBouncinessEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 48 >> 2]);
}

function __ZNK13UnityProfiler19GetEnabledThisFrameEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 >> 0] | 0) != 0 | 0;
}

function __ZNK13BaseAllocator24GetBookKeepingMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK12b2WheelJoint14IsMotorEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 128 >> 0] | 0) != 0 | 0;
}

function __ZNK12b2MouseJoint15GetDampingRatioEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 88 >> 2]);
}

function __ZNK11AudioSource15GetDopplerLevelEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 392 >> 2]);
}

function __ZN9ShaderLab7ProgramD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9ShaderLab7ProgramD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN8VRDevice29ApplyExpensiveQualitySettingsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 303 >> 0] = 1;
 return;
}

function __ZN7mecanim9animation18GetMuscleCurveNameEi(i1) {
 i1 = i1 | 0;
 return gb + 1553740 + (i1 << 7) | 0;
}

function __ZN7mecanim5human10MuscleNameEj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179284 + (i1 << 2) >> 2] | 0;
}

function __ZN7Texture7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN7Joint2D7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN5physx6shdfnd10ThreadImpl4quitEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 2;
 _pthread_exit(0);
}

function __ZN5physx3Scb5Scene21addBodyAndShapesToPvdERNS0_4BodyE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sn18RepXCollectionImpl10getVersionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 156 >> 2] | 0;
}

function __ZN5physx2Sc24ElementInteractionMarker10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx22PxDefaultErrorCallbackC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 87316 + 8;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15switchFromNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxsBroadPhaseMBP15getDeletedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 108 >> 2] | 0;
}

function __ZN5Unity9Component13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN2gl8GetLabelENS_10ObjectTypeE(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 77272 + (i1 << 2) >> 2] | 0;
}

function __ZN26LegacyTreeInstanceRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20IntermediateRendererD2Ev(i1);
 return;
}

function __ZN21DownloadHandlerBuffer17OnCompleteContentEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 1;
 return;
}

function __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17ArchiveFileSystem11MoveToTrashER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem11CreateAsDirER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN16SubstanceArchiveD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16SubstanceArchiveD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16ScriptingManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16ScriptingManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16MemoryFileSystemD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16MemoryFileSystemD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16LightmapSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16LightmapSettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16GraphicsSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16GraphicsSettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN16BaseVideoTextureD0Ev(i1) {
 i1 = i1 | 0;
 __ZN16BaseVideoTextureD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14TerrainManager21GetEnlightenProxyMeshEP7Terrain(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14GfxContextGLES14GetFramebufferEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + 8 | 0;
}

function __ZN13MemoryManager22StopLoggingAllocationsEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1548 >> 0] = 0;
 return;
}

function __ZN13GfxDeviceNull29RenderSurfaceStructMemorySizeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 32;
}

function __ZN13GfxDeviceNull19SetProjectionMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull13SetDepthStateEPK16DeviceDepthState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull13SetBlendStateEPK16DeviceBlendState(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLES29RenderSurfaceStructMemorySizeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 48;
}

function __ZN11TimeManager8SetPauseEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 129 >> 0] = 1;
 return;
}

function __ZN10Collider2D17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 __ZN10Collider2D7CleanupEb(i1, 0);
 return;
}

function __Z47Application_Get_Custom_PropInternetReachabilityv() {
 return __Z23GetInternetReachabilityv() | 0;
}

function __Z38SplashScreen_Get_Custom_PropIsFinishedv() {
 return (__Z22IsSplashScreenFinishedv() | 0) & 1 | 0;
}

function __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawCubeRK8Vector3fS1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z34Cloth_Set_Custom_PropSelfCollisionP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z31AndroidJNI_CUSTOM_GetShortField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z29scripting_profiler_set_eventsi(i1) {
 i1 = i1 | 0;
 _il2cpp_profiler_set_events(i1 | 0);
 return;
}

function __Z20GetStackTraceLogType7LogType(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 73464 + (i1 << 2) >> 2] | 0;
}

function __Z19getPxSceneDescFlagsPKN5physx11PxSceneDescE(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 100 >> 1] | 0;
}

function __Z18SetLogEntryHandlerPFb7LogTypePKcPiE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1450788 >> 2] = i1;
 return;
}

function b132(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 nullFunc_iiif(132);
 return 0;
}

function b119(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 nullFunc_iifi(119);
 return 0;
}

function _glFenceSync__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _glFenceSync(i1 | 0, i2 | 0) | 0;
}

function _glCheckFramebufferStatus__wrapper(i1) {
 i1 = i1 | 0;
 return _glCheckFramebufferStatus(i1 | 0) | 0;
}

function _getmntent(i1) {
 i1 = i1 | 0;
 return _getmntent_r(i1, gb + 1469700 | 0, gb + 1575798 | 0, 256) | 0;
}

function _cf2_getLanguageGroup(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 736 >> 2] | 0) + 512 >> 2] | 0;
}

function __ZThn4_NK5physx5cloth8SwFabric12getNumPhasesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZThn32_NK8Renderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + -32 + 300 >> 2] | 0;
}

function __ZNSt3__212future_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt16invalid_argumentD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt14overflow_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK8VRDevice18GetDeviceConnectedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 297 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx6shdfnd7FastIPC8isServerEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 12 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx6shdfnd10Foundation13getErrorLevelEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __ZNK5physx2Sc20ArticulationJointSim9getParentEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Gu10ConvexMesh17getReferenceCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx2Gu10ConvexMesh13getNbVerticesEv(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 54 >> 0] | 0 | 0;
}

function __ZNK5physx2Gu10ConvexMesh13getNbPolygonsEv(i1) {
 i1 = i1 | 0;
 return HEAPU8[i1 + 55 >> 0] | 0 | 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx15PxsParticleData16getMaxParticlesVEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx13NpClothFabric17getReferenceCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx12NpBatchQuery18getPreFilterShaderEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __ZNK21AssetBundleFileSystem5IsDirERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK20OcclusionCullingData26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30992 | 0;
}

function __ZNK19MeshParticleEmitter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 190748 | 0;
}

function __ZNK19CharacterController26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 111552 | 0;
}

function __ZNK19AudioHighPassFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171240 | 0;
}

function __ZNK17ProceduralTexture9HasMipMapEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 96 >> 2] | 0) != 1 | 0;
}

function __ZNK17ArchiveFileSystem9IsSymLinkERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK16b2StackAllocator16GetMaxAllocationEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 102408 >> 2] | 0;
}

function __ZNK15b2FrictionJoint11GetMaxForceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 96 >> 2]);
}

function __ZNK15ParticleEmitter10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 204 >> 0] | 0) != 0 | 0;
}

function __ZNK12b2ChainShape13GetChildCountEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) + -1 | 0;
}

function __ZNK11AudioSource14GetMinDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 396 >> 2]);
}

function __ZNK11AudioSource14GetMaxDistanceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 400 >> 2]);
}

function __ZN9GfxDevice20DestroyComputeBufferE15ComputeBufferID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN9GfxDevice19SetSinglePassStereoE16SinglePassStereo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8Playable11SetDurationEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 HEAPF64[i1 + 40 >> 3] = d2;
 return;
}

function __ZN7mecanim4hand10FingerNameEj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179152 + (i1 << 2) >> 2] | 0;
}

function __ZN6prcore11GetValue1p0ERN11prophecysdk4halfE(i1) {
 i1 = i1 | 0;
 HEAP16[i1 >> 1] = 15360;
 return;
}

function __ZN6Object8TransferI19StreamedBinaryWriteILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object23VirtualRedirectTransferER14SafeBinaryRead(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Motion7PRODUCEE10MemLabelId18ObjectCreationMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN6Camera29ResetStereoProjectionMatricesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1084 >> 0] = 1;
 return;
}

function __ZN5physx8debugger4comm28SendPropertyMessageFromGroupD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd9MutexImpl6unlockEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_unlock(i1 | 0) | 0;
 return;
}

function __ZN5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15switchFromNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxsBroadPhaseMBP15getCreatedPairsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZN5Unity9Component10DeactivateE19DeactivateOperation(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5Umbra6DoubleC2Ej(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +(i2 >>> 0);
 return;
}

function __ZN5Umbra4Math5floorERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_floor(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra15SystemAllocator10deallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _free(i2);
 return;
}

function __ZN4FMOD7SystemI14setSpeakerModeE16FMOD_SPEAKERMODE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23iPhoneLocalNotification19SetAlertLaunchImageEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN23PreloadManagerOperation19IntegrateTimeSlicedEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN16MemoryFileSystem11MoveToTrashER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull16DeleteTimerQueryEP13GfxTimerQuery(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12_GLOBAL__N_115StringTableImpl9getNbStrsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZN12_GLOBAL__N_110DataStream11enableCacheEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 408 >> 0] = 1;
 return;
}

function __ZN12LightManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 return;
}

function __Z38Input_Get_Custom_PropCompensateSensorsv() {
 return (__Z21IsCompensatingSensorsv() | 0) & 1 | 0;
}

function __Z35Light_Get_Custom_PropShadowSoftnessP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return Math_fround(4.0);
}

function __Z33GetParticleSystemScriptingClassesv() {
 return __Z36GetParticleSystemScriptingClassesPtrv() | 0;
}

function __Z30Time_Get_Custom_PropFrameCountv() {
 return HEAP32[(__Z14GetTimeManagerv() | 0) + 132 >> 2] | 0;
}

function __Z30Caching_Get_Custom_PropEnabledv() {
 return HEAP8[(__Z17GetCachingManagerv() | 0) + 8 >> 0] | 0;
}

function __Z30AndroidJNI_CUSTOM_IsSameObject13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z30AndroidJNI_CUSTOM_IsInstanceOf13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z30AndroidJNI_CUSTOM_GetCharField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z30AndroidJNI_CUSTOM_GetByteField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z24GetManagerPtrFromContexti(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1104348 + (i1 << 2) >> 2] | 0;
}

function __Z23IsInitializedRenderLoopR10RenderLoop(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) != 0 | 0;
}

function __Z21getPxMaterialUserDataPKN5physx10PxMaterialE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z17SetUnityWebStreamP14UnityWebStream(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1451264 >> 2] = i1;
 return;
}

function __Z15CreateJobSystemv() {
 __Z14CreateJobQueuePKcS0_i(gb + 441791 | 0, gb + 441808 | 0, -1);
 return;
}

function _UnityReplayKitShowCameraPreviewAt(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 return 0;
}

function b7(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 nullFunc_fff(7);
 return Math_fround(0);
}

function _towctrans_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _towctrans(i1, i2) | 0;
}

function _nearbyint(d1) {
 d1 = +d1;
 var i2 = 0;
 i2 = _fetestexcept(32) | 0;
 d1 = +_rint(d1);
 return +d1;
}

function _glDeleteTextures__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteTextures(i1 | 0, i2 | 0);
}

function _glDeleteSamplers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteSamplers(i1 | 0, i2 | 0);
}

function ___freadahead(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 8 >> 2] | 0) - (HEAP32[i1 + 4 >> 2] | 0) | 0;
}

function __ZThn32_N14SpriteRendererD1Ev(i1) {
 i1 = i1 | 0;
 __ZN14SpriteRendererD2Ev(i1 + -32 | 0);
 return;
}

function __ZThn28_N14PhysicsManagerD1Ev(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManagerD2Ev(i1 + -28 | 0);
 return;
}

function __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt13runtime_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK8VRDevice17GetShowDeviceViewEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 302 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx5cloth8SwSolver17EndSimulationTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 838080 | 0;
}

function __ZNK5physx5cloth8SwFabric16getNumRestvaluesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK5physx3Cct17CapsuleController8getActorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 408 >> 2] | 0;
}

function __ZNK5physx32PxsSolverConstraintPartitionTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720138 | 0;
}

function __ZNK5physx2Sc20ArticulationJointSim8getChildEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx2Gu12TriangleMesh14getNbTrianglesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer14getNbTrianglesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK5physx22PxDefaultFileInputData9getLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx19PxArticulationJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 686453 | 0;
}

function __ZNK23TransformChangeDispatch37AssertUnnecessaryTransformHierarchiesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK19SkinnedMeshRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31632 | 0;
}

function __ZNK19AssetBundleManifest26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28028 | 0;
}

function __ZNK18PlatformEffector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 156664 | 0;
}

function __ZNK18CrashReportManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 188780 | 0;
}

function __ZNK18BuoyancyEffector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 154156 | 0;
}

function __ZNK18AudioMixerSnapshot26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 174940 | 0;
}

function __ZNK18AudioLowPassFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171428 | 0;
}

function __ZNK18AnimatorController26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 178256 | 0;
}

function __ZNK17FileSystemHandler8FilenameERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK17ArchiveFileSystem8IsHiddenERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK16MemoryFileSystem9IsSymLinkERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK14Texture2DArray20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK14Texture2DArray20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK14StackAllocatorILj16EE9getHeaderEPv(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return i1 + -8 | 0;
}

function __ZNK13ScreenManager12IsFullScreenEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 28 >> 0] | 0) != 0 | 0;
}

function __ZNK13RendererScene22GetStaticBoundingBoxesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK13RenderTexture21GetShadowSamplingModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 108 >> 2] | 0;
}

function __ZNK13BaseAllocator22GetNumberOfAllocationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK13BaseAllocator22GetAllocatedMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK11AudioSource13GetSpatializeEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 422 >> 0] | 0) != 0 | 0;
}

function __ZN9GfxDevice19SetNextDrawCallTypeE15GfxDrawCallType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN9GfxDevice19FreeComputeBufferIDE15ComputeBufferID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8Animator19ValidateTargetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 >>> 0 < 6 | 0;
}

function __ZN6Object8TransferI24GenerateTypeTreeTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object8TransferI18StreamedBinaryReadILb1EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object8TransferI18StreamedBinaryReadILb0EEEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx9NpPhysics21getProfileZoneManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 124 >> 2] | 0;
}

function __ZN5physx41PCMCapsuleVsMeshContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc20ArticulationJointSim12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13switchToNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE15GetOverheadSizeEPv(i1) {
 i1 = i1 | 0;
 return 23;
}

function __ZN21LinearCollectionField15GetElementClassEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZN16ShapeCast2DQuery19InitializeCastShapeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 372 >> 2] | 0;
}

function __ZN15TerrainColliderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN15TerrainColliderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN15SkyboxGenerator28GetSixFaceSkyboxVertexFormatEv() {
 return HEAP32[gb + 1113464 + 4 >> 2] | 0;
}

function __ZN15ResourceManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN15ResourceManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN15QualitySettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN15QualitySettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN15CollisionModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN15CollisionModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN15ArchiveReadFile9SetLengthEy(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN13Simd4iFactoryIRKiEC2ES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13Simd4fFactoryIRKfEC2ES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN13Simd4fFactoryIPKfEC2ES1_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 >> 2] = i2;
 return;
}

function __ZN12HandlerChain16DestroyFileEntryER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11WindManagerC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = i1;
 HEAP32[i1 + 4 >> 2] = i1;
 return;
}

function __ZN11MatrixStack13GetMatrix4x4fEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + (i2 << 6) | 0;
}

function __ZN10AtomicList4InitEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZL26default_unexpected_handlerv() {
 HEAP32[gb + 216096 >> 2] = gb + 1085276;
 __ZSt9terminatev();
}

function __Z43SystemInfo_Get_Custom_PropSupportsGyroscopev() {
 return (__Z15IsGyroAvailablev() | 0) & 1 | 0;
}

function __Z31RegisterStaticallyLinkedModulesv() {
 __Z39RegisterStaticallyLinkedModulesGranularv();
 return;
}

function __Z31GL_Get_Custom_PropInvertCullingv() {
 return HEAP8[(__Z12GetGfxDevicev() | 0) + 4381 >> 0] | 0;
}

function __Z29TextureColorSpaceToColorSpace17TextureColorSpace(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 0 | 0;
}

function __Z29AndroidJNI_CUSTOM_GetIntField13Il2Cpp_IntPtrS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z28Animator_CUSTOM_IsControlledP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z20SetPlayerPauseDirect11PlayerPause(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162856 >> 2] = i1;
 return;
}

function __Z11dtAllocTempi(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[gb + 1459528 >> 2] | 0, i1 | 0) | 0;
}

function _UNITY_ft_validator_error(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 return;
}

function _setbuf(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _setvbuf(i1, i2, i2 | 0 ? 0 : 2, 1024) | 0;
 return;
}

function _jdiv_round_up(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 + -1 + i2 | 0) / (i2 | 0) | 0 | 0;
}

function _isalnum(i1) {
 i1 = i1 | 0;
 return ((i1 + -48 | 0) >>> 0 < 10 | (_isalpha(i1) | 0) != 0) & 1 | 0;
}

function _hasmntopt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strstr(HEAP32[i1 + 12 >> 2] | 0, i2) | 0;
}

function _cf2_getStdVW(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 736 >> 2] | 0) + 388 >> 2] << 16 | 0;
}

function _cf2_getStdHW(i1) {
 i1 = i1 | 0;
 return HEAP32[(HEAP32[i1 + 736 >> 2] | 0) + 384 >> 2] << 16 | 0;
}

function __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED2Ev(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK9Transform26GetTransformHierarchyIndexEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZNK5physx7NpShape11isExclusiveEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 196 >> 0] & 1) != 0 | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv(i1) {
 i1 = i1 | 0;
 return i1 + 164 | 0;
}

function __ZNK5physx5cloth8SwFabric15getNumParticlesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx3Cct13BoxController11getUserDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene20getNbParticleSystemsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 136 >> 2] | 0;
}

function __ZNK5physx2Gu12TriangleMesh13getNbVerticesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx18PxVehicleDriveTank19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 834990 | 0;
}

function __ZNK5physx18PxArticulationLink19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 687162 | 0;
}

function __ZNK5physx16PxsParticleShape12getUserDataVEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __ZNK5Unity11SpringJoint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 113868 | 0;
}

function __ZNK2UI14CanvasRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 187020 | 0;
}

function __ZNK18SpeedTreeWindAsset26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31752 | 0;
}

function __ZNK18ProceduralMaterial26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31152 | 0;
}

function __ZNK18DelayedCallManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30032 | 0;
}

function __ZNK17SurfaceEffector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 158068 | 0;
}

function __ZNK17PolygonCollider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 157088 | 0;
}

function __ZNK17PhysicsMaterial2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 156288 | 0;
}

function __ZNK17Physics2DSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 156440 | 0;
}

function __ZNK17CapsuleCollider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 154352 | 0;
}

function __ZNK17AudioReverbFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 175128 | 0;
}

function __ZNK17AudioChorusFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 170164 | 0;
}

function __ZNK16BaseVideoTexture9IsPlayingEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 92 >> 0] | 0) != 0 | 0;
}

function __ZNK14Texture2DArray20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK14SplatMaterials20GetSplatBaseMaterialEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNK14CompletionTask10IsFinishedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 20 >> 0] | 0) != 0 | 0;
}

function __ZNK13TextRendering4Font26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 64868 | 0;
}

function __ZNK13BaseAllocator21GetReservedMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK12b2MouseJoint12GetFrequencyEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZNK12b2MouseJoint11GetMaxForceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 104 >> 2]);
}

function __ZNK12b2MotorJoint12GetMaxTorqueEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 96 >> 2]);
}

function __ZNK11AudioSource12GetStereoPanEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 404 >> 2]);
}

function __ZN9GfxDevice25GetBackBufferDepthSurfaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4404 >> 2] | 0;
}

function __ZN9GfxDevice25GetBackBufferColorSurfaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4400 >> 2] | 0;
}

function __ZN9GfxDevice23GetNativeTexturePointerE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN8Playable17IsMultithreadableEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[i1 + 24 >> 1] | 0) == 0 | 0;
}

function __ZN7mecanim6memory16InPlaceAllocator10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7mecanim6memory16ChainedAllocator10DeallocateEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7mecanim5human8BoneNameEj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 179172 + (i1 << 2) >> 2] | 0;
}

function __ZN7ApiGLES13CreateProgramEv(i1) {
 i1 = i1 | 0;
 return mftCall_i(HEAP32[i1 + 504 >> 2] | 0) | 0;
}

function __ZN5physx40PCMSphereVsMeshContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx40PCMConvexVsMeshContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Cct17CapsuleController8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 464 >> 2] | 0;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_7NpShapeEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx26PxSerializerDefaultAdapterINS_7NpClothEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23NpParticleFluidReadData6unlockEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 72 >> 0] = 0;
 return;
}

function __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13switchToNoSimEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx19NpArticulationJointD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 91416 + 8;
 return;
}

function __ZN5Unity5Joint17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN5Unity5Joint7CleanupEv(i1);
 return;
}

function __ZN5Umbra6DoubleC2Ei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAPF64[i1 >> 3] = +(i2 | 0);
 return;
}

function __ZN5Umbra4Math4sqrtERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_sqrt(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math4ceilERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_ceil(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math4atanERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_atan(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math4asinERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_asin(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math4acosERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_acos(+(+HEAPF64[i1 >> 3])));
}

function __ZN4FMOD4DSPI13disconnectAllEbb(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZN23LODTreeInstanceRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN20IntermediateRendererD2Ev(i1);
 return;
}

function __ZN21AssetBundleFileSystem5CloseER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN17ArchiveFileSystem8IsLockedERK13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN12LightManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN11NavMeshData13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11LightProbes13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11ColorModuleD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83368 + 8;
 __ZdlPv(i1);
 return;
}

function __ZN11ClothModule17SetupClothManagerEv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1459016 >> 2] = 0;
 return;
}

function __ZL32InitializeModule_UnityWebRequestv() {
 __ZN22UnityWebRequestManager10InitializeEv();
 return;
}

function __Z6simd4iRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2ERKS_(i1, i2);
 return;
}

function __Z6simd4fRK8Scalar4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZN8Scalar4fC2ERKS_(i1, i2);
 return;
}

function __Z38Input_Get_Custom_PropMultiTouchEnabledv() {
 return (__Z19IsMultiTouchEnabledv() | 0) & 1 | 0;
}

function __Z35Application_Get_Custom_PropPlatformv() {
 return __ZN10systeminfo18GetRuntimePlatformEv() | 0;
}

function __Z32GetTextRenderingScriptingClassesv() {
 return __Z35GetTextRenderingScriptingClassesPtrv() | 0;
}

function __Z27RegisterModuleClasses_Umbrav() {
 __Z13RegisterClassI24OcclusionCullingSettingsEvv();
 return;
}

function __Z22GetGameManagerIfExistsi(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1104348 + (i1 << 2) >> 2] | 0;
}

function __Z20scripting_object_newP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return _il2cpp_object_new(i1 | 0) | 0;
}

function __Z17TimeToNanosecondsy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 setTempRet0(i2 | 0);
 return i1 | 0;
}

function __Z17NpGetPxConstraintRKN5physx2Sc14ConstraintCoreE(i1) {
 i1 = i1 | 0;
 return i1 + -16 + -12 | 0;
}

function b67(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 nullFunc_viiii(67);
}

function _strtold_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return +(+_strtox(i1, i2, 2));
}

function _iswlower(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 223 | (_towupper(i1) | 0) != (i1 | 0)) & 1 | 0;
}

function _iswctype_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _iswctype(i1, i2) | 0;
}

function _glDeleteQueries__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteQueries(i1 | 0, i2 | 0);
}

function _glDeleteBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDeleteBuffers(i1 | 0, i2 | 0);
}

function _emscripten_glValidateProgram__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glValidateProgram(i1 | 0);
}

function _emscripten_glDeleteObjectARB__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDeleteObjectARB(i1 | 0);
}

function _emscripten_glBindVertexArray__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glBindVertexArray(i1 | 0);
}

function _catgets(i1, i2, i3, i4) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 i4 = i4 | 0;
 return i4 | 0;
}

function __ZThn8_NSt3__29strstreamD1Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD1Ev(i1 + -8 | 0);
 return;
}

function __ZThn8_NSt3__29strstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD0Ev(i1 + -8 | 0);
 return;
}

function __ZThn8_N5physx3Cct17CapsuleController15getPxControllerEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 | 0;
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10initializeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZThn32_N13TrailRendererD1Ev(i1) {
 i1 = i1 | 0;
 __ZN13TrailRendererD2Ev(i1 + -32 | 0);
 return;
}

function __ZNSt3__29strstreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__29strstreamD1Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt11range_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNK9ShaderLab7Program29BeginWriteUnsupportedVariantsEv(i1) {
 i1 = i1 | 0;
 return i1 + 172 | 0;
}

function __ZNK8Collider16GetContactOffsetEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 56 >> 2]);
}

function __ZNK5physx9NpFactory17getNbClothFabricsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3948 >> 2] | 0;
}

function __ZNK5physx7NpScene19getFilterShaderDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1140 >> 2] | 0;
}

function __ZNK5physx7NpScene19getDynamicStructureEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3460 >> 2] | 0;
}

function __ZNK5physx6PxBase12isReleasableEv(i1) {
 i1 = i1 | 0;
 return (HEAP16[i1 + 6 >> 1] & 2) != 0 | 0;
}

function __ZNK5physx3Cct17CapsuleController7getTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene9hasClothsEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 160 >> 2] | 0) != 0 | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore18getProjectionPlaneEv(i1) {
 i1 = i1 | 0;
 return i1 + 116 | 0;
}

function __ZNK5physx2Gu12TriangleMesh12getTrianglesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer12getTrianglesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK5physx24PxDefaultMemoryInputData4tellEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx14NpArticulation12getAggregateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK5physx10NpMaterial17getReferenceCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5Unity10HingeJoint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 112544 | 0;
}

function __ZNK5Unity10FixedJoint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 112344 | 0;
}

function __ZNK27AnimatorControllerParameter7GetTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK26AnimatorControllerPlayable8GetAssetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK18GfxFramebufferGLES15GetSamplesCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK17ProceduralTexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31192 | 0;
}

function __ZNK17GlobalGameManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28760 | 0;
}

function __ZNK17BillboardRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29752 | 0;
}

function __ZNK16ParticleRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 191192 | 0;
}

function __ZNK16ParticleAnimator26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 190916 | 0;
}

function __ZNK16MemoryFileSystem7IsEmptyEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 16 >> 2] | 0) == 1 | 0;
}

function __ZNK16CircleCollider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 154548 | 0;
}

function __ZNK13b2PulleyJoint10GetLengthBEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 88 >> 2]);
}

function __ZNK13b2PulleyJoint10GetLengthAEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZNK13ScreenManager20GetScreenOrientationEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZNK13GfxDeviceNull14IsShaderActiveE10ShaderType(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK13BaseAllocator15WalkAllocationsEPFvPKvjPKPvjE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK12b2MotorJoint11GetMaxForceEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 92 >> 2]);
}

function __ZNK12SocketStream11IsConnectedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 18 >> 0] | 0) != 0 | 0;
}

function __ZNK11b2RopeJoint12GetMaxLengthEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 84 >> 2]);
}

function __ZN8Animator17ValidateGoalIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 >>> 0 < 4 | 0;
}

function __ZN6Socket16InterruptedErrorEv() {
 return (HEAP32[(___errno_location() | 0) >> 2] | 0) == 4 | 0;
}

function __ZN6Motion17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 __ZN8UserList5ClearEv(i1 + 32 | 0);
 return;
}

function __ZN5physx9PxTaskMgr13decrReferenceERNS_9PxSpuTaskE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx8debugger4comm25BeginPropertyMessageGroupD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn5ConvX20getCurrentOutputSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 312 >> 2] | 0;
}

function __ZN5physx2Gu9ContainerD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Gu9Container5EmptyEv(i1) | 0;
 return;
}

function __ZN5physx2Gu16SupportLocalImplINS0_11ConvexHullVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm17enableNVTXSupportEb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 778770 >> 0] = i1 & 1;
 return;
}

function __ZN5physx25PxVehicleConstraintShader10onComShiftEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN4gles19GetProcAddress_coreEPKc(i1) {
 i1 = i1 | 0;
 return _emscripten_GetProcAddress(i1) | 0;
}

function __ZN2UI13RectTransform17SetDrivenByObjectEPK6Object(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN25ThreadsafeLinearAllocator16PrintAllocationsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN23PreloadManagerOperation11GetPriorityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZN23AnimationOffsetPlayable20GetPlayableClassNameEv(i1) {
 i1 = i1 | 0;
 return gb + 906895 | 0;
}

function __ZN22MemoryCacherReadBlocks13GetFileLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZN22MemoryCacherReadBlocks12GetCacheSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZN22BlockMemoryCacheWriter13GetFileLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN17BillboardRenderer14OnAssetDeletedEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 360 >> 2] = 0;
 return;
}

function __ZN15ParticlesModule8SyncJobsEv(i1) {
 i1 = i1 | 0;
 __ZN14ParticleSystem8SyncJobsEb(1);
 return;
}

function __ZN15Lz4Decompressor18ValidateBufferSizeEj(i1) {
 i1 = i1 | 0;
 return i1 >>> 0 < 2147483647 | 0;
}

function __ZN14VelocityModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14VelocityModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14Texture2DArrayD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14Texture2DArrayD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14TerrainManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14TerrainManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14SpriteRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14SpriteRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14SharedMeshDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14SharedMeshDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14RotationModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14RotationModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14PlayerSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14PlayerSettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14PhysicsManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14ParticleSystemD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14ParticleSystemD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14EdgeCollider2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14EdgeCollider2DD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14DetailDatabase24SetDetailPrototypesDirtyEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 1;
 return;
}

function __ZN14AvatarPlaybackD0Ev(i1) {
 i1 = i1 | 0;
 __ZN14AvatarPlaybackD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13ScreenManager13SetLockCursorE14CursorLockMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLES12IsValidStateEv(i1) {
 i1 = i1 | 0;
 return __ZN11ContextGLES7IsValidEv() | 0;
}

function __Z43Texture_Get_Custom_PropAnisotropicFilteringv() {
 return __ZN7Texture13GetAnisoLimitEv() | 0;
}

function __Z30Compass_Set_Custom_PropEnabledP12Il2CppObjecth(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z27SetProfilerEnabledThisFrameb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 1546599 >> 0] = i1 & 1;
 return;
}

function __Z26AssetBundle_CUSTOM_LoadAllP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z21GetManagerFromContexti(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1104348 + (i1 << 2) >> 2] | 0;
}

function __Z17NpGetPxConstraintRN5physx2Sc14ConstraintCoreE(i1) {
 i1 = i1 | 0;
 return i1 + -16 + -12 | 0;
}

function __Z15return_overrideRK21AnimationClipOverride(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z10dtFreeTempPv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[gb + 1459524 >> 2] | 0, i1 | 0);
 return;
}

function b20(i1, f2, f3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 f3 = Math_fround(f3);
 nullFunc_viff(20);
}

function _strtod_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return +(+_strtox(i1, i2, 1));
}

function _pthread_cond_broadcast__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_cond_broadcast(i1 | 0) | 0;
}

function _fsetpos(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___fseeko(i1, HEAP32[i2 >> 2] | 0, 0) | 0;
}

function _fseek(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return ___fseeko(i1, i2, i3) | 0;
}

function _emscripten_glIsTexture__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsTexture(i1 | 0) | 0;
}

function _emscripten_glIsProgram__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsProgram(i1 | 0) | 0;
}

function _emscripten_glIsEnabled__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsEnabled(i1 | 0) | 0;
}

function _emscripten_glGetString__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glGetString(i1 | 0) | 0;
}

function _carg(i1) {
 i1 = i1 | 0;
 return +(+Math_atan2(+(+HEAPF64[i1 + 8 >> 3]), +(+HEAPF64[i1 >> 3])));
}

function ___wcscoll_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _wcscmp(i1, i2) | 0;
}

function ___strcoll_l(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _strcmp(i1, i2) | 0;
}

function ___clang_call_terminate(i1) {
 i1 = i1 | 0;
 ___cxa_begin_catch(i1 | 0) | 0;
 __ZSt9terminatev();
}

function __ZNSt20bad_array_new_lengthC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216204 + 8;
 return;
}

function __ZNSt12out_of_rangeD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt12length_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt12domain_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__28numpunctIwE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNKSt3__25ctypeIwE8do_widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 << 24 >> 24 | 0;
}

function __ZNK9ShaderLab7Program28BeginReadUnsupportedVariantsEv(i1) {
 i1 = i1 | 0;
 return i1 + 172 | 0;
}

function __ZNK9Rigidbody14GetIsKinematicEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 84 >> 0] | 0) != 0 | 0;
}

function __ZNK8VRDevice14GetRenderScaleEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 308 >> 2]);
}

function __ZNK8Renderer12GetTransformEv(i1) {
 i1 = i1 | 0;
 return __ZN8Renderer12GetTransformEv(i1) | 0;
}

function __ZNK5physx7NpScene18getStaticStructureEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3456 >> 2] | 0;
}

function __ZNK5physx7NpScene18getNbArticulationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3568 >> 2] | 0;
}

function __ZNK5physx7NpCloth9getFabricEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 64 >> 2] | 0) + -16 | 0;
}

function __ZNK5physx5cloth8SwFabric13getNumTethersEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene18getNbArticulationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 124 >> 2] | 0;
}

function __ZNK5physx2Sc17ParticleSystemSim7getCoreEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __ZNK5physx2Gu12TriangleMesh11getVerticesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx2Gu11HeightField12getNbColumnsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK5physx29BroadPhaseBatchUpdateWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 716854 | 0;
}

function __ZNK5physx16PxVehicleNoDrive19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 833702 | 0;
}

function __ZNK5physx16PxVehicleDriveNW19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 834943 | 0;
}

function __ZNK5physx16PxVehicleDrive4W19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 835156 | 0;
}

function __ZNK5physx16PxSphericalJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765091 | 0;
}

function __ZNK5physx16PxPrismaticJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765058 | 0;
}

function __ZNK5physx16PxParticleSystem19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764992 | 0;
}

function __ZNK5physx14PxLightCpuTask12getReferenceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK4Mesh19CanAccessFromScriptEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 41 >> 0] | 0) != 0 | 0;
}

function __ZNK2UI13RectTransform26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28980 | 0;
}

function __ZNK25RuntimeAnimatorController30GetAnimationClipOverrideVectorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK24DownloadHandlerAudioClip9GetLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK19LowerResBlitTexture13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK16SubstanceArchive26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31872 | 0;
}

function __ZNK16LightmapSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30672 | 0;
}

function __ZNK16LevelGameManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28456 | 0;
}

function __ZNK16GraphicsSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30192 | 0;
}

function __ZNK16BaseVideoTexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 26532 | 0;
}

function __ZNK15UnityAdsManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 188356 | 0;
}

function __ZNK15TerrainCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 151564 | 0;
}

function __ZNK15RelativeJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 157292 | 0;
}

function __ZNK15PointEffector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 156888 | 0;
}

function __ZNK15ParticleEmitter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 190576 | 0;
}

function __ZNK15NavMeshSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 169816 | 0;
}

function __ZNK15NavMeshObstacle26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 168936 | 0;
}

function __ZNK15Lz4Decompressor20DecompressStreamInitEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK15FrictionJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 155788 | 0;
}

function __ZNK15DistanceJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 155168 | 0;
}

function __ZNK15ConstantForce2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 154768 | 0;
}

function __ZNK15AudioReverbZone26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 174088 | 0;
}

function __ZNK15AudioMixerGroup26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 174800 | 0;
}

function __ZNK15AudioEchoFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171052 | 0;
}

function __ZNK15AnchoredJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 152968 | 0;
}

function __ZNK14ParticleSystem18GetStartDelayCurveEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZNK13WebCamTexture9IsRunningEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 120 >> 0] | 0) != 0 | 0;
}

function __ZNK13RendererScene19GetStaticSceneNodesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function __ZNK12SocketStream10IsBlockingEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 17 >> 0] | 0) != 0 | 0;
}

function __ZNK12CubemapArray20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZNK12CubemapArray20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZN9Rigidbody23SetSleepAngularVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZN8GUIState8EndFrameEv(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 + 344 >> 2] = Math_fround(1.0);
 return;
}

function __ZN8Animator10IsInIKPassEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 100 >> 2] & 4 | 0) != 0 | 0;
}

function __ZN5physx6shdfnd9MutexImplD2Ev(i1) {
 i1 = i1 | 0;
 _pthread_mutex_destroy(i1 | 0) | 0;
 return;
}

function __ZN5physx6shdfnd9MutexImpl4lockEv(i1) {
 i1 = i1 | 0;
 _pthread_mutex_lock(i1 | 0) | 0;
 return;
}

function __ZN5physx6shdfnd10Foundation19AlignCheckAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20PxsParticleSystemSim32flushBufferedInteractionUpdatesVEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity9Component26SupportedMessagesDidChangeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5Umbra4Math3tanERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_tan(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math3sinERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_sin(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math3logERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_log(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math3expERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_exp(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math3cosERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_cos(+(+HEAPF64[i1 >> 3])));
}

function __ZN5Umbra4Math3absERKNS_6DoubleE(i1) {
 i1 = i1 | 0;
 return +(+Math_abs(+(+HEAPF64[i1 >> 3])));
}

function __ZN44ConvexVsHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23iPhoneLocalNotification17SetRepeatIntervalEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN22AnimationMixerPlayable20GetPlayableClassNameEv(i1) {
 i1 = i1 | 0;
 return gb + 900116 | 0;
}

function __ZN21LinearCollectionField7IsValidEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) != 0 | 0;
}

function __ZN19GfxThreadableDeviceD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9GfxDeviceD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN17ProceduralTexture39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN16GraphicsSettings15InitializeClassEv() {
 __ZN13RenderManager15InitializeClassEv();
 return;
}

function __ZN13GfxDeviceNull14SetWorldMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12ImageFilters21GetTargetBeforeOpaqueEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZN11UnityEngine15CloudWebService14RestDownloaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __Z31InitializeUnityWebRequestModulev() {
 __ZN22UnityWebRequestManager10InitializeEv();
 return;
}

function __Z25RegisterShowErrorWithModePFviE(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1450808 >> 2] = i1;
 return;
}

function __Z20DumpCallstackConsolePKcS0_i(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z19IsHalfTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 return (i1 + -15 | 0) >>> 0 < 3 | 0;
}

function __Z15SetIApplicationP12IApplication(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162116 >> 2] = i1;
 return;
}

function __Z11IsFenceDoneRK8JobFence(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 >> 2] | 0)) return 1;
 return 1;
}

function _PxInitExtensions(i1) {
 i1 = i1 | 0;
 __ZN5physx6shdfnd10Foundation11incRefCountEv();
 return 1;
}

function _glAttachShader__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glAttachShader(i1 | 0, i2 | 0);
}

function _finish_input_pass(i1) {
 i1 = i1 | 0;
 HEAP32[HEAP32[i1 + 400 >> 2] >> 2] = fb + 1558;
 return;
}

function _emscripten_glGenerateMipmap__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glGenerateMipmap(i1 | 0);
}

function _emscripten_glClearDepthf__wrapper(f1) {
 f1 = Math_fround(f1);
 _emscripten_glClearDepthf(+f1);
}

function __ZThn32_N12MeshRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12MeshRendererD0Ev(i1 + -32 | 0);
 return;
}

function __ZThn32_N12LineRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12LineRendererD0Ev(i1 + -32 | 0);
 return;
}

function __ZThn12_N5physx7NpShapeD1Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx7NpShapeD2Ev(i1 + -12 | 0);
 return;
}

function __ZNSt3__28ios_baseD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28ios_baseD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28__c_nodeD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__28__c_nodeD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt3__25ctypeIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__25ctypeIcED2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNSt11logic_errorD0Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__28numpunctIwE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK8VRDevice14GetFieldOfViewEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 72 >> 2]);
}

function __ZNK6Camera21CalculateCanDoShadowsEv(i1) {
 i1 = i1 | 0;
 return __Z16ShouldUseShadowsb(1) | 0;
}

function __ZNK5physx7NpScene17getFilterCallbackEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1152 >> 2] | 0;
}

function __ZNK5physx5cloth8SwFabric12getNumPhasesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZNK5physx3Cct13BoxController8getActorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 408 >> 2] | 0;
}

function __ZNK5physx2Sn18RepXCollectionImpl5beginEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK5physx2Sc18ParticleSystemCore6getSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer11getNbPointsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer10getNbTextsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer10getNbLinesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK5physx2Cm10FanoutTask12getReferenceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx2Cm10Collection12getNbObjectsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK5physx15PxVehicleWheels19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 828315 | 0;
}

function __ZNK5physx15PxRevoluteJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765075 | 0;
}

function __ZNK5physx15PxParticleFluid19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765009 | 0;
}

function __ZNK5physx15PxDistanceJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 742891 | 0;
}

function __ZNK5physx12NpBatchQuery14getOwnerClientEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 76 >> 0] | 0;
}

function __ZNK5physx11NpAggregate14getMaxNbActorsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZNK2UI11CanvasGroup26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 186852 | 0;
}

function __ZNK24DownloadHandlerAudioClip8GetBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK19LowerResBlitTexture12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK18DownloadHandlerVFS13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK18AudioLowPassFilter26GetCustomLowpassLevelCurveEv(i1) {
 i1 = i1 | 0;
 return i1 + 44 | 0;
}

function __ZNK17ProceduralTexture14GetMipmapCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZNK15ResourceManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31432 | 0;
}

function __ZNK15ReflectionProbe26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31272 | 0;
}

function __ZNK15QualitySettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32192 | 0;
}

function __ZNK15OcclusionPortal26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31032 | 0;
}

function __ZNK15Lz4Decompressor22DecompressStreamDeinitEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK15LightProbeGroup26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30552 | 0;
}

function __ZNK15EditorExtension26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 26492 | 0;
}

function __ZNK15CapsuleCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 64328 | 0;
}

function __ZNK14UnityWebStream8IsCachedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 21 >> 0] | 0) != 0 | 0;
}

function __ZNK14SphereCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 113668 | 0;
}

function __ZNK14PhysicsManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 113316 | 0;
}

function __ZNK14PhysicMaterial26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 113108 | 0;
}

function __ZNK14EdgeCollider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 155364 | 0;
}

function __ZNK14AudioBehaviour26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 175648 | 0;
}

function __ZNK14AreaEffector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 153356 | 0;
}

function __ZNK13b2PulleyJoint8GetRatioEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 112 >> 2]);
}

function __ZNK13AnimationClip8IsLegacyEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 212 >> 0] | 0) != 0 | 0;
}

function __ZNK10SampleClip20GetCompressionFormatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __ZN9TextAsset13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN9GfxDevice15SetStereoTargetE15StereoscopicEye(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6prcore24DefaultIntegerBlitFormatEN14ImageReference8BlitModeE(i1) {
 i1 = i1 | 0;
 return 5;
}

function __ZN6b2Draw8SetFlagsEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 4 >> 2] = i2;
 return;
}

function __ZN5physx8debugger4comm23EndPropertyMessageGroupD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm23AppendPropertyValueDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd10Foundation20getWarnOnceTimestampEv() {
 return HEAP32[gb + 1457400 >> 2] | 0;
}

function __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Scb5ClothD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc9ClothCoreD2Ev(i1 + 12 | 0);
 return;
}

function __ZN5physx2Sc5Scene18getParticleSystemsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 132 >> 2] | 0;
}

function __ZN5physx2GuL18gPCMHullPrefetchCBEjPKNS_6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx2Gu22SupportMapRelativeImplINS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN43CapsuleHeightfieldContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23iPhoneLocalNotification14SetAlertActionEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17b2ContactListener12BeginContactEP9b2Contact(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14PhysicsManager16SetSleepVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZN14ParticleSystem18GetStartDelayCurveEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZN14InputInterface11PerformDragER10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13TrailRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13TrailRendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13MonoBehaviourD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13MonoBehaviourD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13MemoryManager17GetAllocatorCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1544 >> 2] | 0;
}

function __ZN13LoadOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13LoadOperationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13InitialModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13InitialModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13GfxDeviceNull13SetViewMatrixERK10Matrix4x4f(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLESD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13GfxDeviceGLESD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13ComputeShaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13ComputeShaderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13BuildSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13BuildSettingsD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN13AnimationClipD0Ev(i1) {
 i1 = i1 | 0;
 __ZN13AnimationClipD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient12NeedsPollingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE5CheckEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10EventEntry12CanBeInvokedEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 12 >> 2] | 0) > 1 | 0;
}

function __Z34Application_Get_Custom_PropGenuinev() {
 return (__Z20IsApplicationGenuinev() | 0) & 1 | 0;
}

function __Z24Camera_CUSTOM_IsFilteredP12Il2CppObjectS0_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __Z20tessGetVertexIndicesP14TESStesselator(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __Z20scripting_string_newPKc(i1) {
 i1 = i1 | 0;
 return _il2cpp_string_new_wrapper(i1 | 0) | 0;
}

function __Z19tessGetElementCountP14TESStesselator(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __Z19SetRaycastInterfaceP8IRaycast(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162156 >> 2] = i1;
 return;
}

function __Z19GetSpecificGUIStatei(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1468832 + (i1 << 2) >> 2] | 0;
}

function _scalblnf(f1, i2) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 return Math_fround(_scalbnf(f1, i2));
}

function _pthread_mutex_trylock__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_trylock(i1 | 0) | 0;
}

function _pthread_mutex_destroy__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_destroy(i1 | 0) | 0;
}

function _emscripten_glIsShader__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsShader(i1 | 0) | 0;
}

function _emscripten_glIsBuffer__wrapper(i1) {
 i1 = i1 | 0;
 return _emscripten_glIsBuffer(i1 | 0) | 0;
}

function _cff_slot_done(i1) {
 i1 = i1 | 0;
 HEAP32[(HEAP32[i1 + 156 >> 2] | 0) + 36 >> 2] = 0;
 return;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__28ios_base7failureD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt3__212system_errorD2Ev(i1);
 return;
}

function __ZNSt3__214error_categoryC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 215928 + 8;
 return;
}

function __ZNKSt3__28numpunctIcE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 9 >> 0] | 0;
}

function __ZNKSt3__28numpunctIcE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 8 >> 0] | 0;
}

function __ZNK8Animator28WarningStringIfLoggingActiveEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK5physx9PxTaskMgr16getSpuDispatcherEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx7NpScene16getNbConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3544 >> 2] | 0;
}

function __ZNK5physx2Sc9ClothCore13getClothFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 60 >> 1] | 0;
}

function __ZNK5physx2Sc21ElementSimInteraction23isLastFilterInteractionEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx23PxVehicleWheels4SimData7isValidEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx14PxVehicleDrive19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 828300 | 0;
}

function __ZNK5physx14PxTriangleMesh19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753858 | 0;
}

function __ZNK5physx14PxRigidDynamic19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 832257 | 0;
}

function __ZNK5physx14PxArticulation19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765118 | 0;
}

function __ZNK5physx14NpArticulation10getNbLinksEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK5Unity9Component26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29020 | 0;
}

function __ZNK24iPhoneRemoteNotification29GetApplicationIconBadgeNumberEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK22DownloadHandlerTexture9GetLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK17ProceduralTexture13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK17GeneralConnection12GetLocalGuidEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 136 >> 2] | 0;
}

function __ZNK16BaseVideoTexture14GetImageBufferEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK15AudioReverbZone15GetReverbPresetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZNK15ArchiveReadFile6IsOpenEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) != 0 | 0;
}

function __ZNK14Texture2DArray26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32072 | 0;
}

function __ZNK14SpriteRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31792 | 0;
}

function __ZNK14RenderSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31352 | 0;
}

function __ZNK14PlayerSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31072 | 0;
}

function __ZNK14ParticleSystem26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 80300 | 0;
}

function __ZNK14DirectorPlayer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30072 | 0;
}

function __ZNK14BillboardAsset26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29712 | 0;
}

function __ZNK13WheelCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 159176 | 0;
}

function __ZNK13TargetJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 158272 | 0;
}

function __ZNK13SpringJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 157844 | 0;
}

function __ZNK13SliderJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 157632 | 0;
}

function __ZNK13ConstantForce26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 112144 | 0;
}

function __ZNK13BoxCollider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 153776 | 0;
}

function __ZNK13AudioListener26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171468 | 0;
}

function __ZNK12TextureInput8HasImageEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 28 >> 2] | 0) != 0 | 0;
}

function __ZNK12AudioManager9GetVolumeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 32 >> 2]);
}

function __ZNK11AudioSource9GetVolumeEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 412 >> 2]);
}

function __ZNK10GpuProgram11IsSupportedEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 8 >> 0] | 0) == 0 | 0;
}

function __ZN8Gradient8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Camera23ResetStereoViewMatricesEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 1083 >> 0] = 1;
 return;
}

function __ZN5physx3Cct13BoxController8getSceneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 464 >> 2] | 0;
}

function __ZN5physx2Gu16SupportLocalImplINS0_9TriangleVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20PxvRegisterParticlesEv() {
 __ZN5physx10PxsContext17registerParticlesEv();
 return;
}

function __ZN5Umbra18ReceiverMaskBufferC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 34816) | 0;
 return;
}

function __ZN22MemoryCacherReadBlocks16UnlockCacheBlockEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN19LowerResBlitTexture19UnloadFromGfxDeviceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17ArchiveFileSystem5TouchER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15SkyboxGenerator27GetCubemapSkyboxVertexCountEv() {
 return HEAP32[gb + 1114340 >> 2] | 0;
}

function __ZN15ResourceManager39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN14SpriteRenderer14OnDeleteSpriteEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 364 >> 2] = 0;
 return;
}

function __ZN14InputInterface10UpdateDragER10InputEvent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13GfxDeviceNull25SetInvertProjectionMatrixEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLES25SetInvertProjectionMatrixEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11ClothModule16GetClothingSceneEv(i1) {
 i1 = i1 | 0;
 return __Z16GetClothingScenev() | 0;
}

function __Z7dtAlloci(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[gb + 1459036 >> 2] | 0, i1 | 0) | 0;
}

function __Z43Input_Get_Custom_PropAccelerationEventCountv() {
 return __Z20GetAccelerationCountv() | 0;
}

function __Z25SetNeedToPerformRenderingb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 452442 >> 0] = i1 & 1;
 return;
}

function _lgammaf(f1) {
 f1 = Math_fround(f1);
 return Math_fround(___lgammaf_r(f1, gb + 1469516 | 0));
}

function _glPixelStorei__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glPixelStorei(i1 | 0, i2 | 0);
}

function _glGetIntegerv__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGetIntegerv(i1 | 0, i2 | 0);
}

function _glGenTextures__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenTextures(i1 | 0, i2 | 0);
}

function _glGenSamplers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenSamplers(i1 | 0, i2 | 0);
}

function _glDrawBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glDrawBuffers(i1 | 0, i2 | 0);
}

function _glDisableVertexAttribArray__wrapper(i1) {
 i1 = i1 | 0;
 _glDisableVertexAttribArray(i1 | 0);
}

function _glBindTexture__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindTexture(i1 | 0, i2 | 0);
}

function _glBindSampler__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindSampler(i1 | 0, i2 | 0);
}

function _fmal(d1, d2, d3) {
 d1 = +d1;
 d2 = +d2;
 d3 = +d3;
 return +(+_llvm_fma_f64(+d1, +d2, +d3));
}

function _emscripten_glDeleteProgram__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDeleteProgram(i1 | 0);
}

function _emscripten_glCompileShader__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glCompileShader(i1 | 0);
}

function _emscripten_glBlendEquation__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glBlendEquation(i1 | 0);
}

function _emscripten_glActiveTexture__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glActiveTexture(i1 | 0);
}

function _crypt(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___crypt_r(i1, i2, gb + 1575663 | 0) | 0;
}

function _cleanup_387(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 68 >> 2] | 0)) ___unlockfile(i1);
 return;
}

function _cleanup_382(i1) {
 i1 = i1 | 0;
 if (!(HEAP32[i1 + 68 >> 2] | 0)) ___unlockfile(i1);
 return;
}

function _bcmp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _memcmp(i1, i2, i3) | 0;
}

function __ZThn8_N5physx3Cct13BoxController15getPxControllerEv(i1) {
 i1 = i1 | 0;
 return i1 + -8 | 0;
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction7destroyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9underflowEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNK9Texture3D20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK9Texture3D20GetRuntimeMemorySizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK8Animator21GetControllerPlayableEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 624 >> 2] | 0;
}

function __ZNK5physx9PxTaskMgr16getGpuDispatcherEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx9PxTaskMgr16getCpuDispatcherEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx7NpScene15getNbAggregatesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3580 >> 2] | 0;
}

function __ZNK5physx7NpScene15getFilterShaderEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1148 >> 2] | 0;
}

function __ZNK5physx3Cct13BoxController7getTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK5physx2Sc5Scene16getNbConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK5physx13PxRigidStatic19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 701374 | 0;
}

function __ZNK5physx13PxHeightField19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753780 | 0;
}

function __ZNK5physx13PxClothFabric19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764826 | 0;
}

function __ZNK27UnloadUnusedAssetsOperation25GetAllowParallelExecutionEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification29GetApplicationIconBadgeNumberEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK22DownloadHandlerTexture8GetBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK21IntermediateRenderers13GetSceneNodesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNK21DownloadHandlerBuffer9GetLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK21AnimationClipPlayable8GetAssetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 164 >> 2] | 0;
}

function __ZNK17ProceduralTexture12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK16BaseVideoTexture13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK15DownloadHandler6IsDoneEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 8 >> 0] | 0) != 0 | 0;
}

function __ZNK13WebCamTexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 26112 | 0;
}

function __ZNK13TrailRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32152 | 0;
}

function __ZNK13TextRendering4Font11GetMaterialEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __ZNK13SparseTexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31712 | 0;
}

function __ZNK13RenderTexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31392 | 0;
}

function __ZNK13OcclusionArea26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30952 | 0;
}

function __ZNK13MonoBehaviour26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 27592 | 0;
}

function __ZNK13ComputeShader26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29872 | 0;
}

function __ZNK13BuildSettings26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29792 | 0;
}

function __ZNK13AnimationClip26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 65780 | 0;
}

function __ZNK12WheelJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 158484 | 0;
}

function __ZNK12StatusHelper7IsErrorEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) > 399 | 0;
}

function __ZNK12NavMeshAgent26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 168976 | 0;
}

function __ZNK12MeshCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 112968 | 0;
}

function __ZNK12FixedJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 155576 | 0;
}

function __ZNK12AudioManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171808 | 0;
}

function __ZNK11b2GearJoint8GetRatioEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 152 >> 2]);
}

function __ZNK11AudioSource8GetPitchEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 408 >> 2]);
}

function __ZN8VRDevice21EnableStereoRenderingEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 300 >> 0] = 1;
 return;
}

function __ZN8DateTimeC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN8BitArrayC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN6prcore11GetValue1p0ERf(i1) {
 i1 = i1 | 0;
 HEAPF32[i1 >> 2] = Math_fround(1.0);
 return;
}

function __ZN5physx8debugger4comm21CreatePropertyMessageD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm21BeginSetPropertyValueD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger26PropertyMessageDescriptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd7PAUtils13registerEventEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return -1;
}

function __ZN5physx5cloth8SwSolverD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwSolverD2Ev(i1);
 return;
}

function __ZN5physx5cloth8SwFabricD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx5cloth8SwFabricD2Ev(i1);
 return;
}

function __ZN5physx2Sc8SimStats5clearEv(i1) {
 i1 = i1 | 0;
 _memset(i1 + 24 | 0, 0, 164) | 0;
 return;
}

function __ZN5physx2Sc5Scene16getArticulationsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 120 >> 2] | 0;
}

function __ZN5physx15PxSetFilterBoolEb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 1551035 >> 0] = i1 & 1;
 return;
}

function __ZN4FMOD7SystemI9setOutputE15FMOD_OUTPUTTYPE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23iPhoneLocalNotification12SetSoundNameEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN23iPhoneLocalNotification12SetAlertBodyEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17b2ContactListener10EndContactEP9b2Contact(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16MemoryFileSystem5TouchER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN15ReflectionProbe13SetProbeDirtyEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 160 >> 0] = 1;
 return;
}

function __ZN14AsyncOperation23SetAllowSceneActivationEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13ScreenManager24SetAllowLayeredRenderingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull16SetForceCullModeE8CullMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull14SetScissorRectERK5RectTIiE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12InputManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12InputManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12CubemapArrayD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12CubemapArrayD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12AudioManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN12AudioManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv129__pointer_to_member_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZL21LibpngReadWarningFuncP14png_struct_defPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z36GetRuntimeInitializeOnLoadManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(19) | 0;
}

function __Z22GetPhysicsGroundBody2Dv() {
 return HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 8 >> 2] | 0;
}

function __Z18tessGetVertexCountP14TESStesselator(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __Z18getPxShapeUserDataPKN5physx7PxShapeE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z18getPxSceneUserDataPKN5physx7PxSceneE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z18getPxJointUserDataPKN5physx7PxJointE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z18getPxActorUserDataPKN5physx7PxActorE(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __Z15return_originalRK21AnimationClipOverride(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function b14(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 nullFunc_fif(14);
 return Math_fround(0);
}

function _pthread_mutex_unlock__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_unlock(i1 | 0) | 0;
}

function _pthread_cond_destroy__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_cond_destroy(i1 | 0) | 0;
}

function _ldexpf(f1, i2) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 return Math_fround(_scalbnf(f1, i2));
}

function _jpeg_free_small(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _free(i2);
 return;
}

function _jpeg_free_large(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 _free(i2);
 return;
}

function _cf2_stack_count(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 392 >> 2] | 0) - (i1 + 8) >> 3 | 0;
}

function _cf2_hintmask_setNew(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP8[i1 + 5 >> 0] = i2;
 return;
}

function _cf2_glyphpath_finalize(i1) {
 i1 = i1 | 0;
 _cf2_arrstack_finalize(i1 + 11612 | 0);
 return;
}

function ___lxstat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _lstat(i2, i3) | 0;
}

function ___fxstat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _fstat(i2, i3) | 0;
}

function __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9showmanycEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt16bad_array_lengthC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216224 + 8;
 return;
}

function __ZNK9Texture3D20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK9Behaviour10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 32 >> 0] | 0) != 0 | 0;
}

function __ZNK8VRDevice10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 296 >> 0] | 0) != 0 | 0;
}

function __ZNK8Renderer10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 328 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx7NpShape15getGeometryTypeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 116 >> 2] | 0;
}

function __ZNK5physx7NpScene14getTaskManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3720 >> 2] | 0;
}

function __ZNK5physx2Gu11HeightField9getNbRowsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx2Gu11HeightField9getFormatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer9getPointsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer8getTextsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __ZNK5physx2Cm12RenderBuffer8getLinesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5physx12PxFixedJoint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 742907 | 0;
}

function __ZNK5physx12PxConvexMesh19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 753930 | 0;
}

function __ZNK5physx12PxConstraint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 829242 | 0;
}

function __ZNK5physx11NpAggregate11getNbActorsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __ZNK21DownloadHandlerBuffer8GetBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK20IntermediateRenderer8GetLayerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 260 >> 2] | 0;
}

function __ZNK17GPUSkinPoseBuffer12GetBoneCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK16UploadHandlerRaw12GetBytesSentEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK16LightmapSettings24GetEnlightenSceneMappingEv(i1) {
 i1 = i1 | 0;
 return i1 + 100 | 0;
}

function __ZNK16BaseVideoTexture12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK15GUIEventManager13GetEventCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK14StackAllocator17GetProfilerHeaderEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNK14PlayerSettings13GetColorSpaceEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 332 >> 2] | 0;
}

function __ZNK12ScriptMapper26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31512 | 0;
}

function __ZNK12MeshRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30912 | 0;
}

function __ZNK12LineRenderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30712 | 0;
}

function __ZNK12InputManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30432 | 0;
}

function __ZNK12HingeJoint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 156e3 | 0;
}

function __ZNK12CubemapArray26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29952 | 0;
}

function __ZNK11OffMeshLink26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 169336 | 0;
}

function __ZNK11NavMeshData26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 169504 | 0;
}

function __ZNK11BoxCollider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 110912 | 0;
}

function __ZNK11AudioSource7GetMuteEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 421 >> 0] | 0) != 0 | 0;
}

function __ZNK11AudioSource7GetLoopEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 420 >> 0] | 0) != 0 | 0;
}

function __ZNK11AudioSource26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 171656 | 0;
}

function __ZNK11AudioFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 170352 | 0;
}

function __ZN8Collider12GetIsTriggerEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 40 >> 0] | 0) != 0 | 0;
}

function __ZN7mecanim5human10GetAxeInfoEj(i1) {
 i1 = i1 | 0;
 return gb + 181416 + (i1 * 88 | 0) | 0;
}

function __ZN6Object8TransferI17RemapPPtrTransferEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN6Object13AwakeFromLoadE17AwakeFromLoadMode(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx9NpPhysics14getProfileZoneEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 120 >> 2] | 0;
}

function __ZN5physx8debugger4comm20StreamPropMessageArgD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm20StreamInitializationD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger22PvdObjectModelMetaData31getCurrentPvdObjectModelVersionEv() {
 return 1;
}

function __ZN5physx5cloth8SwSolver19StartSimulationTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx34PxsSolverConstraintPostProcessTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn13XmlNodeWriter8tabCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21PxcArticulationHelper14getLtbDataSizeEj(i1) {
 i1 = i1 | 0;
 return i1 * 400 | 0;
}

function __ZN5physx16PxBroadPhaseBase12removeRegionEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN4gles14GetProcAddressEPKc(i1) {
 i1 = i1 | 0;
 return _emscripten_GetProcAddress(i1) | 0;
}

function __ZN4FMOD13ChannelGroupI8setPitchEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return 0;
}

function __ZN23iPhoneLocalNotification11SetTimeZoneEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18MultiQueryCallbackIN5physx10PxSweepHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17ProceduralTexture10InvalidateEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 224 >> 0] = 0;
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxRaycastHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16PxOverflowBufferIN5physx12PxOverlapHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14PhysicsManager23GetSleepAngularVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZN13BitSetUtility17GetNumberOfBlocksEj(i1) {
 i1 = i1 | 0;
 return (i1 + 31 | 0) >>> 5 | 0;
}

function __ZN12SoundManager26OnCreateSoundPopAllocationEv() {
 __Z19pop_allocation_rootv();
 return 0;
}

function __ZN12AdsIdHandler15FetchAsyncAdsIdEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 44 >> 2] = 1;
 return;
}

function __ZN11GPUProfiler19IsCollectingSamplesEv() {
 return (HEAP8[gb + 1546603 >> 0] | 0) != 0 | 0;
}

function __ZL24CleanupPrepassRenderLoopPv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1115112 >> 2] = 0;
 return;
}

function __Z6dtFreePv(i1) {
 i1 = i1 | 0;
 mftCall_vi(HEAP32[gb + 1459028 >> 2] | 0, i1 | 0);
 return;
}

function __Z37CalculateJobCountWithMinIndicesPerJobii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __Z36Input_Get_Custom_PropIsGyroAvailablev() {
 return (__Z15IsGyroAvailablev() | 0) & 1 | 0;
}

function __Z35Input_Get_Custom_PropTouchSupportedv() {
 return (__Z16IsTouchSupportedv() | 0) & 1 | 0;
}

function __Z30ConvertLegacyShaderChannelMaskj(i1) {
 i1 = i1 | 0;
 return i1 << 2 & 128 | i1 & 31 | 0;
}

function __Z29ColorSpaceToTextureColorSpace10ColorSpace(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 0 | 0;
}

function __Z26Random_Get_Custom_PropSeedv() {
 return HEAP32[(__Z16GetScriptingRandv() | 0) >> 2] | 0;
}

function __Z19InitVehiclesManagerv() {
 _PxInitVehicleSDK(__Z14GetDynamicsSDKv() | 0, 0) | 0;
 return;
}

function __Z13SetIPhysics2DP10IPhysics2D(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162152 >> 2] = i1;
 return;
}

function __Z13SetIEnlightenP10IEnlighten(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162132 >> 2] = i1;
 return;
}

function __Z13SetIAnimationP10IAnimation(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162108 >> 2] = i1;
 return;
}

function b61(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 nullFunc_diii(61);
 return 0.0;
}

function b127(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 nullFunc_iiii(127);
 return 0;
}

function _gzputs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _gzwrite(i1, i2, _strlen(i2) | 0) | 0;
}

function _gray_raster_done(i1) {
 i1 = i1 | 0;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i1);
 return;
}

function _glGenQueries__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenQueries(i1 | 0, i2 | 0);
}

function _glGenBuffers__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glGenBuffers(i1 | 0, i2 | 0);
}

function _glEnableVertexAttribArray__wrapper(i1) {
 i1 = i1 | 0;
 _glEnableVertexAttribArray(i1 | 0);
}

function _glBindBuffer__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBindBuffer(i1 | 0, i2 | 0);
}

function _glBeginQuery__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glBeginQuery(i1 | 0, i2 | 0);
}

function _emscripten_glLineWidth__wrapper(f1) {
 f1 = Math_fround(f1);
 _emscripten_glLineWidth(+f1);
}

function _emscripten_glDeleteShader__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDeleteShader(i1 | 0);
}

function _emscripten_glClearStencil__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glClearStencil(i1 | 0);
}

function _cff_ps_has_glyph_names(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 8 >> 2] | 0) >>> 9 & 1 | 0;
}

function __ZNK8LODGroup10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 72 >> 0] | 0) != 0 | 0;
}

function __ZNK8Collider10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 41 >> 0] | 0) != 0 | 0;
}

function __ZNK5physx2Gu11HeightField8getFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 48 >> 1] | 0;
}

function __ZNK5physx14NpArticulation7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __ZNK5physx11PxAggregate19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 747736 | 0;
}

function __ZNK5Unity5Joint26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 112744 | 0;
}

function __ZNK5Unity5Cloth26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 168704 | 0;
}

function __ZNK22LocalFileSystemHandler9CanHandleEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZNK14Texture2DArray13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK13Lz4Compressor20CompressStreamDeinitEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK13EmscriptenWWW14GetPartialSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK13EmscriptenWWW14GetPartialDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK13BaseAllocator17ValidateIntegrityEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZNK12CubemapArray15GetCubemapCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK11TimeManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31952 | 0;
}

function __ZNK11TerrainData26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 66968 | 0;
}

function __ZNK11Rigidbody2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 67088 | 0;
}

function __ZNK11PreloadData26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31112 | 0;
}

function __ZNK11NamedObject26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28068 | 0;
}

function __ZNK11MonoManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32272 | 0;
}

function __ZNK11LightProbes26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30632 | 0;
}

function __ZNK11GameManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28608 | 0;
}

function __ZNK11AssetBundle26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 27368 | 0;
}

function __ZNK10SampleClip26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 170496 | 0;
}

function __ZNK10Effector2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 153580 | 0;
}

function __ZNK10AudioMixer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 174128 | 0;
}

function __ZN7mecanim4hand10GetAxeInfoEj(i1) {
 i1 = i1 | 0;
 return gb + 180096 + (i1 * 88 | 0) | 0;
}

function __ZN5physx9NpPhysics27getPhysicsInsertionCallbackEv(i1) {
 i1 = i1 | 0;
 return i1 + 60 | 0;
}

function __ZN5physx8debugger4comm19EndSetPropertyValueD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm19AddProfileZoneEventD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpScene14getTaskManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 3720 >> 2] | 0;
}

function __ZN5physx6shdfnd7PAUtils14isEventEnabledEt(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx5cloth6FabricD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167224 + 8;
 return;
}

function __ZN5physx5cloth6FabricD0Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 167224 + 8;
 return;
}

function __ZN5physx2Sn9XmlParser14processCommentEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx2Sc5Scene13getErrorStateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1276 >> 2] | 0;
}

function __ZN5physx25PxVehicleConstraintShader11prepareDataEv(i1) {
 i1 = i1 | 0;
 return i1 + 4 | 0;
}

function __ZN5physx12NpConstraint9markDirtyEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 128 >> 0] = 1;
 return;
}

function __ZN4UNET16ScriptingUpdater4InitEv() {
 HEAP32[gb + 1115296 + 236 >> 2] = fb + 388;
 return;
}

function __ZN4Tree11SetTreeDataE4PPtrI13MonoBehaviourE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN24RingBufferMemoryFileData11SetBlockingEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN18ColorBySpeedModuleD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83528 + 8;
 return;
}

function __ZN17AnimationPlayable20GetPlayableClassNameEv(i1) {
 i1 = i1 | 0;
 return gb + 899910 | 0;
}

function __ZN16LightmapSettings24GetEnlightenSceneMappingEv(i1) {
 i1 = i1 | 0;
 return i1 + 100 | 0;
}

function __ZN16BaseVideoTexture19UnloadFromGfxDeviceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN14UnityAnalytics21GetUnityConnectClientEv() {
 return __Z21GetUnityConnectClientv() | 0;
}

function __ZN14CachingManager15GetCurrentCacheEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN14AnimationState15InitializeClassEv() {
 HEAP32[gb + 1466576 >> 2] = fb + 4079;
 return;
}

function __ZN13b2DynamicTreeD2Ev(i1) {
 i1 = i1 | 0;
 __Z6b2FreePv(HEAP32[i1 + 4 >> 2] | 0);
 return;
}

function __ZN13GfxDeviceNull13DeleteTextureE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12AudioManager15GetSoundManagerEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 220 >> 2] | 0;
}

function __ZN11TrailModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11TrailModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11TerrainDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11TerrainDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11PreloadDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11PreloadDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11NoiseModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11NoiseModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11NavMeshDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11NavMeshDataD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11MonoManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11MonoManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11LightProbesD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11LightProbesD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11ForceModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11ForceModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11ContextGLES18HandleInvalidStateEPb(i1) {
 i1 = i1 | 0;
 HEAP8[i1 >> 0] = 0;
 return 1;
}

function __ZN11BoxColliderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11BoxColliderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11AudioSourceD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11AudioSourceD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN11AssetBundleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN11AssetBundleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZL29CleanupModule_UnityWebRequestv() {
 __ZN22UnityWebRequestManager7CleanupEv();
 return;
}

function __Z43GIDebugVisualisation_Set_Custom_PropTexType13GITextureType(i1) {
 i1 = i1 | 0;
 return;
}

function __Z43DynamicGI_CUSTOM_UpdateMaterialsForRendererP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return;
}

function __Z42Application_Get_Custom_PropTargetFrameRatev() {
 return __Z18GetTargetFrameRatev() | 0;
}

function __Z41WWW_CUSTOM_enforceWebSecurityRestrictionsP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z36Application_Get_Custom_PropIsPlayingv() {
 return (__Z14IsWorldPlayingv() | 0) & 1 | 0;
}

function __Z32IsCaptureAllKeyboardInputEnabledv() {
 return (HEAP32[gb + 1103744 >> 2] | 0) == 1 | 0;
}

function __Z26GetUnityPurchasingSettingsv() {
 return (__Z23GetUnityConnectSettingsv() | 0) + 56 | 0;
}

function __Z15IsDepthRTFormat19RenderTextureFormat(i1) {
 i1 = i1 | 0;
 return (i1 | 2 | 0) == 3 | 0;
}

function _unity_z_compressBound(i1) {
 i1 = i1 | 0;
 return i1 + 11 + (i1 >>> 12) + (i1 >>> 14) | 0;
}

function _tt_cmap14_char_next(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i2 >> 2] = 0;
 return 0;
}

function _remquol(d1, d2, i3) {
 d1 = +d1;
 d2 = +d2;
 i3 = i3 | 0;
 return +(+_remquo(d1, d2, i3));
}

function _pthread_getspecific__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_getspecific(i1 | 0) | 0;
}

function _pthread_cond_signal__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_cond_signal(i1 | 0) | 0;
}

function _init_source(i1) {
 i1 = i1 | 0;
 HEAP8[(HEAP32[i1 + 24 >> 2] | 0) + 36 >> 0] = 1;
 return;
}

function ___xstat(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return _stat(i2, i3) | 0;
}

function __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214codecvt_bynameIDic11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK8VRDevice9GetActiveEv(i1) {
 i1 = i1 | 0;
 return (HEAP8[i1 + 299 >> 0] | 0) != 0 | 0;
}

function __ZNK7Texture20GetUnscaledTextureIDEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __ZNK5physx9NpFactory11getNbShapesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 640 >> 2] | 0;
}

function __ZNK5physx7NpScene15SceneCompletion7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 703212 | 0;
}

function __ZNK5physx3Cct17CapsuleController11getPositionEv(i1) {
 i1 = i1 | 0;
 return i1 + 416 | 0;
}

function __ZNK5physx2Cm10Collection8getNbIdsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 40 >> 2] | 0;
}

function __ZNK5physx23PxsSolverSetupSolveTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720339 | 0;
}

function __ZNK5physx23PxsFluidDynamicsSphTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 769718 | 0;
}

function __ZNK5physx23AggregateAABBUpdateTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718263 | 0;
}

function __ZNK5physx10PxMaterial19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 763461 | 0;
}

function __ZNK29PxsCreateFinalizeContactsTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720368 | 0;
}

function __ZNK18ScriptingArguments8GetCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 192 >> 2] | 0;
}

function __ZNK18DownloadHandlerVFS9GetLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK14Texture2DArray12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK13WheelCollider12GetRigidbodyEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 144 >> 2] | 0;
}

function __ZNK13SparseTexture13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK13RenderTexture13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK13RenderTexture12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __ZNK12MeshRenderer13GetSharedMeshEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 376 >> 2] | 0;
}

function __ZNK12BaseRenderer14GetSubsetIndexEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZNK11AudioSource14GetRolloffModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 416 >> 2] | 0;
}

function __ZNK10TagManager26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31912 | 0;
}

function __ZNK10MonoScript26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 27480 | 0;
}

function __ZNK10MeshFilter26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30872 | 0;
}

function __ZNK10GameObject26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28900 | 0;
}

function __ZNK10GUITexture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30312 | 0;
}

function __ZNK10GUIElement26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30232 | 0;
}

function __ZNK10FlareLayer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30152 | 0;
}

function __ZNK10Collider2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32588 | 0;
}

function __ZN5physx8debugger4comm18SetPropertyMessageD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpScene10getPhysicsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 1457324 >> 2] | 0;
}

function __ZN5physx5cloth8SwSolver17EndSimulationTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx32PxsSolverConstraintPartitionTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn5ConvX11closeOutputEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 304 >> 2] = 0;
 return;
}

function __ZN5physx2Sc5Scene14getConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZN5physx2Sc11Interaction12onDeactivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx2Cm29ConstraintImmediateVisualizerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13PxHitCallbackINS_12PxRaycastHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx13PxHitCallbackINS_12PxOverlapHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD8ChannelI11set3DSpreadEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return 0;
}

function __ZN3WWW17SetThreadPriorityE14ThreadPriority(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN24iPhoneRemoteNotificationaSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 | 0;
}

function __ZN19GfxThreadableDevice15OnDeviceCreatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN17MessageIdentifier21GetRegisteredMessagesEv() {
 return HEAP32[gb + 1104732 >> 2] | 0;
}

function __ZN17MemoryCacheWriterD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 65660 + 8;
 return;
}

function __ZN17MemoryCacheReaderD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 67168 + 8;
 return;
}

function __ZN17GlobalGameManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN16PxOverflowBufferIN5physx10PxSweepHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16GraphicsSettings12CleanupClassEv() {
 __ZN13RenderManager12CleanupClassEv();
 return;
}

function __ZN14AssetReference24GetAssetReferenceStorageEv() {
 return HEAP32[gb + 1162408 >> 2] | 0;
}

function __ZN13GfxDeviceNull11SetViewportERK5RectTIiE(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12_GLOBAL__N_124HfTrianglesEntityReport2D0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12MeshCollider13DidModifyMeshEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 120 >> 0] = 1;
 return;
}

function __ZN11PreloadData39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN11AssetBundle39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __Z47Physics_Set_Custom_PropMinPenetrationForPenaltyf(f1) {
 f1 = Math_fround(f1);
 return;
}

function __Z38Application_Get_Custom_PropIsBatchmodev() {
 return (__Z11IsBatchmodev() | 0) & 1 | 0;
}

function __Z28GetPhysics2DScriptingClassesv() {
 return __Z31GetPhysics2DScriptingClassesPtrv() | 0;
}

function __Z25GetUnityAnalyticsSettingsv() {
 return (__Z23GetUnityConnectSettingsv() | 0) + 68 | 0;
}

function __Z25GetCrashReportingSettingsv() {
 return (__Z23GetUnityConnectSettingsv() | 0) + 28 | 0;
}

function __Z24IsAlphaOnlyTextureFormat13TextureFormat(i1) {
 i1 = i1 | 0;
 return (i1 | 0) == 1 | 0;
}

function __Z24GUI_Get_Custom_PropDepthv() {
 return HEAP32[(__Z11GetGUIStatev() | 0) + 68 >> 2] | 0;
}

function __Z15tessGetVerticesP14TESStesselator(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __Z15tessGetElementsP14TESStesselator(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function establishStackSpace(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 STACKTOP = i1;
 STACK_MAX = i2;
}

function b105(i1, i2, f3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 f3 = Math_fround(f3);
 nullFunc_viif(105);
}

function _tt_cmap_init(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 HEAP32[i1 + 16 >> 2] = i2;
 return 0;
}

function _jzero_far(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memset(i1 | 0, 0, i2 | 0) | 0;
 return;
}

function _glUniform1i__wrapper(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _glUniform1i(i1 | 0, i2 | 0);
}

function _glBeginTransformFeedback__wrapper(i1) {
 i1 = i1 | 0;
 _glBeginTransformFeedback(i1 | 0);
}

function _emscripten_glStencilMask__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glStencilMask(i1 | 0);
}

function _emscripten_glLoadMatrixf__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glLoadMatrixf(i1 | 0);
}

function _emscripten_glLinkProgram__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glLinkProgram(i1 | 0);
}

function ___fclose_ca(i1) {
 i1 = i1 | 0;
 return mftCall_ii(HEAP32[i1 + 12 >> 2] | 0, i1 | 0) | 0;
}

function __ZNSt3__214codecvt_bynameIcc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__224__generic_error_category4nameEv(i1) {
 i1 = i1 | 0;
 return gb + 1084678 | 0;
}

function __ZNKSt3__210moneypunctIwLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__210moneypunctIwLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__210moneypunctIwLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNKSt3__210moneypunctIwLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 2147483647;
}

function __ZNK9AudioClip26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 170640 | 0;
}

function __ZNK9Animation26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 176192 | 0;
}

function __ZNK8VRDevice9GetAspectEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 76 >> 2]);
}

function __ZNK8VRDevice19GetStereoSeparationEv(i1) {
 i1 = i1 | 0;
 return Math_fround(.064000003);
}

function __ZNK8Animator8GetSpeedEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 420 >> 2]);
}

function __ZNK5physx7NpScene12getTimestampEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 108 >> 2] | 0;
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK5physx2Sn5ConvX11getNbErrorsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 328 >> 2] | 0;
}

function __ZNK5physx2Cm10FanoutTask7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK5Umbra4Tome15getClusterCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 124 >> 2] | 0;
}

function __ZNK23PreloadManagerOperation25GetAllowParallelExecutionEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK18PlayableController7GetTimeEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 96 >> 3]);
}

function __ZNK13SparseTexture12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK13RenderTexture12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK12MeshCollider13GetSharedMeshEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZNK12CubemapArray13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK11b2RopeJoint13GetLimitStateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 164 >> 2] | 0;
}

function __ZNK10MemoryFile6IsOpenEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 4 >> 2] | 0) != 0 | 0;
}

function __ZN9Rigidbody16SetSleepVelocityEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __ZN6Object8TransferI14SafeBinaryReadEEvRT_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx8debugger4comm17StringHandleEventD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm17PushBackObjectRefD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd7TlsFreeEj(i1) {
 i1 = i1 | 0;
 _pthread_key_delete(i1 | 0) | 0;
 return;
}

function __ZN5physx2Gu16SupportLocalImplINS0_4BoxVEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx11PxHitBufferINS_12PxRaycastHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx11PxHitBufferINS_12PxOverlapHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity5ClothD0Ev(i1) {
 i1 = i1 | 0;
 __ZN5Unity5ClothD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5Umbra11PatchWriter11computeSizeEi(i1) {
 i1 = i1 | 0;
 return (i1 * 12 | 0) + 12 | 0;
}

function __ZN5Umbra10unmapArrayEPNS_10StackAllocEPKv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN37ConvexVsMeshContactGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN2gl22WebGLGetCurrentContextEv() {
 return _emscripten_webgl_get_current_context() | 0;
}

function __ZN24iPhoneRemoteNotification14SetDeviceTokenEP11objc_object(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23iPhoneLocalNotificationaSERKS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 | 0;
}

function __ZN22CrashReportingSettings5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 8 >> 0] = 0;
 return;
}

function __ZN16LevelGameManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN15MulticastSocketD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6SocketD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN14FileCacherRead13GetFileLengthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZN14CachingManagerD2Ev(i1) {
 i1 = i1 | 0;
 __ZN14CachingManager7DisposeEv(i1);
 return;
}

function __ZN13GfxDeviceNull10BeginFrameEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4192 >> 0] = 1;
 return;
}

function __ZN12ImageFilters14GetTargetFinalEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZN12HandlerChain5TouchER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN12HandlerChain5CloseER13FileEntryData(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN12AdsIdHandler10FetchAdsIdEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 44 >> 2] = 1;
 return 0;
}

function __ZN10TagManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZN10TagManagerD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10TagManager39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN10SizeModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZN10SizeModuleD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10MonoScriptD0Ev(i1) {
 i1 = i1 | 0;
 __ZN10MonoScriptD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10MonoScript39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZL30InitializeModule_TextRenderingv() {
 __Z29InitializeTextRenderingModulev();
 return;
}

function __ZL16sample_gc_resizePvx(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function __Z46Physics_Set_Custom_PropPenetrationPenaltyForcef(f1) {
 f1 = Math_fround(f1);
 return;
}

function __Z36Gyroscope_CUSTOM_setEnabled_Internalih(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z33scripting_capture_memory_snapshotv() {
 return _il2cpp_capture_memory_snapshot() | 0;
}

function __Z33Input_Get_Custom_PropMousePresentv() {
 return (__Z15GetMousePresentv() | 0) & 1 | 0;
}

function __Z28Debug_CUSTOM_OpenConsoleFilev() {
 __Z32DeveloperConsole_OpenConsoleFilev();
 return;
}

function __Z28CleanupUnityWebRequestModulev() {
 __ZN22UnityWebRequestManager7CleanupEv();
 return;
}

function __Z25GetHostBroadcastAddressesP7in_addri(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __Z24SetTargetFrameRateDirecti(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 64864 >> 2] = i1;
 return;
}

function __Z20SetMultiTouchEnabledb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 363160 >> 0] = i1 & 1;
 return;
}

function __Z20SetHasFrameToPresentb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 452441 >> 0] = i1 & 1;
 return;
}

function __Z18SetTargetFrameRatei(i1) {
 i1 = i1 | 0;
 __Z24SetTargetFrameRateDirecti(i1);
 return;
}

function __Z12SetIVehiclesP9IVehicles(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162180 >> 2] = i1;
 return;
}

function __Z12SetIVRDeviceP9IVRDevice(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162176 >> 2] = i1;
 return;
}

function __Z12SetGfxDeviceP9GfxDevice(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1157628 >> 2] = i1;
 return;
}

function _UNITY_png_gamma_significant(i1) {
 i1 = i1 | 0;
 return (i1 + -95e3 | 0) >>> 0 > 1e4 | 0;
}

function _UNITY_ft_pic_container_destroy(i1) {
 i1 = i1 | 0;
 _UNITY_ft_base_pic_free(i1);
 return;
}

function b131(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 nullFunc_iiid(131);
 return 0;
}

function _unzOpenCurrentFile(i1) {
 i1 = i1 | 0;
 return _unzOpenCurrentFile3(i1, 0, 0, 0, 0) | 0;
}

function _pthread_mutex_lock__wrapper(i1) {
 i1 = i1 | 0;
 return _pthread_mutex_lock(i1 | 0) | 0;
}

function _ft_black_done(i1) {
 i1 = i1 | 0;
 _UNITY_ft_mem_free(HEAP32[i1 >> 2] | 0, i1);
 return;
}

function __ZNSt3__212system_errorD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 return;
}

function __ZNKSt3__223__system_error_category4nameEv(i1) {
 i1 = i1 | 0;
 return gb + 1084721 | 0;
}

function __ZNKSt3__223__future_error_category4nameEv(i1) {
 i1 = i1 | 0;
 return gb + 1077116 | 0;
}

function __ZNK9Transform26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28940 | 0;
}

function __ZNK9Texture3D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32112 | 0;
}

function __ZNK9Texture2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32032 | 0;
}

function __ZNK9TextAsset26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31992 | 0;
}

function __ZNK9Rigidbody26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 67048 | 0;
}

function __ZNK9Projector26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31232 | 0;
}

function __ZNK9LensFlare26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30472 | 0;
}

function __ZNK9HaloLayer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30392 | 0;
}

function __ZNK9CGProgram26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29992 | 0;
}

function __ZNK9Behaviour26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29672 | 0;
}

function __ZNK8Renderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 300 >> 2] | 0;
}

function __ZNK7Texture9HasMipMapEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 76 >> 2] | 0) > 1 | 0;
}

function __ZNK5physx9PxD6Joint19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 765108 | 0;
}

function __ZNK5physx21SapPostUpdateWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 717057 | 0;
}

function __ZNK5physx21PxsFluidCollisionTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 769685 | 0;
}

function __ZNK5physx21MBPPostUpdateWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 717395 | 0;
}

function __ZNK5physx11HullLibrary7checkitEPNS_3TriE(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZNK5Umbra13TomeUserIdMap7getSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK2UI6Canvas26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 67128 | 0;
}

function __ZNK14GfxContextGLES10GetCurrentEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK13RenderTexture10GetVRUsageEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 112 >> 2] | 0;
}

function __ZNK12StatusHelper13GetStatusCodeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK12CubemapArray12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK10FileSystem15LocalFileSystemEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN5physx9NpPhysics20MeshDeletionListenerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm16SetPropertyValueD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc8BodyCoreD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc9RigidCoreD2Ev(i1);
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc11Interaction10onActivateEj(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx2Cm20isNVTXSupportEnabledEv() {
 return (HEAP8[gb + 778770 >> 0] | 0) != 0 | 0;
}

function __ZN5physx13PxHitCallbackINS_10PxSweepHitEE13finalizeQueryEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx12_GLOBAL__N_116LocationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN3WWW8GetErrorEv(i1) {
 i1 = i1 | 0;
 return __ZN3WWW20GetCachedErrorStringEv(i1) | 0;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15EditorExtensionD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN14FileCacherRead12GetCacheSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN13RenderTexture19UnloadFromGfxDeviceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12_GLOBAL__N_117ProfileZoneClient19handleClientRemovedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12_GLOBAL__N_117MemoryEventClient19handleClientRemovedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12SocketStream18CanSendNonblockingEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 1;
}

function __ZN10Collider2D12SetPolygon2DEP9Polygon2D(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z42UNetWebGlHelpers_CUSTOM_InitUpdateFunctionv() {
 _InitUNetUpdateFunction();
 return;
}

function __Z38Motion_Get_Custom_PropIsAnimatorMotionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z35GUI_CUSTOM_InitializeGUIClipTexturev() {
 __Z24InitializeGUIClipTexturev();
 return;
}

function __Z20CleanupStdConvertersv() {
 __ZN14SafeBinaryRead21CleanupConverterTableEv();
 return;
}

function __Z17GetPhysicsWorld2Dv() {
 return HEAP32[(HEAP32[gb + 1458412 >> 2] | 0) + 4 >> 2] | 0;
}

function _UNITY_png_zfree(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _UNITY_png_free(i1, i2);
 return;
}

function b48(i1, f2, i3) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 i3 = i3 | 0;
 nullFunc_vifi(48);
}

function b37(f1, i2, i3) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 i3 = i3 | 0;
 nullFunc_vfii(37);
}

function _unity_z_zError(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 16328 + (2 - i1 << 2) >> 2] | 0;
}

function _roundf(d1) {
 d1 = +d1;
 return d1 >= 0.0 ? +Math_floor(d1 + .5) : +Math_ceil(d1 - .5);
}

function _isspace(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 32 | (i1 + -9 | 0) >>> 0 < 5) & 1 | 0;
}

function _gray_raster_set_mode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function _emscripten_glUseProgram__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glUseProgram(i1 | 0);
}

function _emscripten_glReleaseShaderCompiler__wrapper() {
 _emscripten_glReleaseShaderCompiler();
}

function _emscripten_glMatrixMode__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glMatrixMode(i1 | 0);
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD0Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4syncEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__214__get_const_dbEv() {
 __ZNSt3__28__get_dbEv() | 0;
 return gb + 1473432 | 0;
}

function __ZNSt3__211regex_errorD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt13runtime_errorD2Ev(i1);
 return;
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9Rigidbody23GetSleepAngularVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZNK8WindZone26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32232 | 0;
}

function __ZNK8Renderer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31312 | 0;
}

function __ZNK8Material26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30792 | 0;
}

function __ZNK8LODGroup26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30752 | 0;
}

function __ZNK8GUILayer26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30272 | 0;
}

function __ZNK8Collider26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32548 | 0;
}

function __ZNK8Animator26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 67008 | 0;
}

function __ZNK8Animator15GetRecorderModeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 548 >> 2] | 0;
}

function __ZNK7b2World13GetProxyCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 102900 >> 2] | 0;
}

function __ZNK6Sprite13GetRenderDataEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 + 80 | 0;
}

function __ZNK5physx6shdfnd4Time11getLastTimeEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 >> 3]);
}

function __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK5physx2Sc10StaticCore6getSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx20SingleAABBUpdateTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718383 | 0;
}

function __ZNK5physx20ProcessBPResultsTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718193 | 0;
}

function __ZNK5physx20AggregateOverlapTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718075 | 0;
}

function __ZNK5physx16PxBroadPhaseBase24getNumOutOfBoundsObjectsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx10NpMaterial8getFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP16[i1 + 44 >> 1] | 0;
}

function __ZNK5Umbra4Tome14getObjectCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZNK14GfxContextGLES8Instance14GetFramebufferEv(i1) {
 i1 = i1 | 0;
 return i1 + 8 | 0;
}

function __ZNK13b2DynamicTree17ValidateStructureEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK11AudioSource11GetPriorityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 388 >> 2] | 0;
}

function __ZNK10UnityScene13GetBuildIndexEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZN9Scripting18IsFieldFlagsPublicEi(i1) {
 i1 = i1 | 0;
 return (i1 & 15 | 0) == 6 | 0;
}

function __ZN5physx8debugger4comm15RemoveObjectRefD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm15NameHandleValueD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm15DestroyInstanceD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7profile21NullEventNameProviderD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd6TlsGetEj(i1) {
 i1 = i1 | 0;
 return _pthread_getspecific(i1 | 0) | 0;
}

function __ZN5physx6shdfnd10ThreadImpl7setNameEPKc(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Ext20ProfileZoneInterface19handleClientRemovedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Cct17CapsuleController15getPxControllerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx29EntityReportContainerCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx29BroadPhaseBatchUpdateWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx12_GLOBAL__N_115OverlapCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx11PxHitBufferINS_10PxSweepHitEED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity9ComponentD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 26392 + 8;
 return;
}

function __ZN4UNET16ScriptingUpdater7CleanupEv() {
 HEAP32[gb + 1115296 + 236 >> 2] = 0;
 return;
}

function __ZN25SingleBlockMemoryFileData6UnlockEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN24RingBufferMemoryFileData4LockEPPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23iPhoneLocalNotification9HasActionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN23iPhoneLocalNotification11SetFireDateEd(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 return;
}

function __ZN19PlayerLoopCallbacksC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 432) | 0;
 return;
}

function __ZN17GeneralConnection14OnDisconnectedEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16SpriteRenderData8SetDirtyEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 52 >> 0] = 1;
 return;
}

function __ZN14AsyncOperationD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 64168 + 8;
 return;
}

function __ZN13WebCamTexture19GetCameraProjectionEv(i1) {
 i1 = i1 | 0;
 return gb + 1162292 | 0;
}

function __ZN13GfxDeviceGLES16SetDisplayTargetEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN13BaseAllocator16ThreadInitializeEPS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11ICallString18GetScriptingStringEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZN10__cxxabiv123__fundamental_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10GameObject21SetIsStaticDeprecatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z53ThreadAndSerializationSafeCheckAllowRecursiveTransferb(i1) {
 i1 = i1 | 0;
 return;
}

function __Z39Object_CUSTOM_EnsureRunningOnMainThreadP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return;
}

function __Z33GetRuntimeInitializeOnLoadManagerv() {
 return __Z21GetManagerFromContexti(19) | 0;
}

function __Z30GetOcclusionCullingSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(24) | 0;
}

function __Z25Mathf_CUSTOM_IsPowerOfTwoi(i1) {
 i1 = i1 | 0;
 return (i1 + -1 & i1 | 0) == 0 | 0;
}

function __Z11SetIPhysicsP8IPhysics(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162148 >> 2] = i1;
 return;
}

function __Z11SetINetworkP8INetwork(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162140 >> 2] = i1;
 return;
}

function _wcstof(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(+_wcstox(i1, i2, 0));
}

function _wcscasecmp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _wcsncasecmp(i1, i2, -1) | 0;
}

function _strtof(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return Math_fround(+_strtox(i1, i2, 0));
}

function _round(d1) {
 d1 = +d1;
 return d1 >= 0.0 ? +Math_floor(d1 + .5) : +Math_ceil(d1 - .5);
}

function _lchmod(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _fchmodat(-100, i1, i2, 256) | 0;
}

function _isdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return (i1 + -48 | 0) >>> 0 < 10 | 0;
}

function _cabs(i1) {
 i1 = i1 | 0;
 return +(+_hypot(+HEAPF64[i1 >> 3], +HEAPF64[i1 + 8 >> 3]));
}

function ___synccall(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 mftCall_vi(i1 | 0, i2 | 0);
 return;
}

function __ZNSt3__212future_errorD2Ev(i1) {
 i1 = i1 | 0;
 __ZNSt11logic_errorD2Ev(i1);
 return;
}

function __ZNSt10bad_typeidC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216484 + 8;
 return;
}

function __ZNKSt3__27codecvtIwc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9Rigidbody14GetConstraintsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK9GfxDevice25GetDeviceProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 1764 | 0;
}

function __ZNK7Texture26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 26572 | 0;
}

function __ZNK7Terrain26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 35740 | 0;
}

function __ZNK7Joint2D26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 32628 | 0;
}

function __ZNK7Cubemap26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29912 | 0;
}

function __ZNK6Motion26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 176524 | 0;
}

function __ZNK6Camera7GetNearEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 920 >> 2]);
}

function __ZNK6Avatar7IsValidEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 + 56 >> 2] | 0) != 0 | 0;
}

function __ZNK6Avatar26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 178860 | 0;
}

function __ZNK5physx7PxShape19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 690295 | 0;
}

function __ZNK5physx7PxCloth19getConcreteTypeNameEv(i1) {
 i1 = i1 | 0;
 return gb + 764818 | 0;
}

function __ZNK5physx3Cct13BoxController11getPositionEv(i1) {
 i1 = i1 | 0;
 return i1 + 416 | 0;
}

function __ZNK5physx2Sc8ShapeSim8getRbSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function __ZNK5physx2Sc8ClothSim7getCoreEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 52 >> 2] | 0;
}

function __ZNK5physx19ActorAABBUpdateTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718327 | 0;
}

function __ZNK5Umbra4Tome12getTileCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 144 >> 2] | 0;
}

function __ZNK5Umbra4Tome12getGateCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 104 >> 2] | 0;
}

function __ZNK11ICallString6IsNullEv(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) == 0 | 0;
}

function __ZN9GfxDevice40IgnoreNextUnresolveOnCurrentRenderTargetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice13FreeTextureIDE9TextureID(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN9GfxDevice12DeleteBufferEP9GfxBuffer(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8Animator13StopRecordingEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 548 >> 2] = 0;
 return;
}

function __ZN5physx8debugger4comm14CreatePropertyD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm14CreateInstanceD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm14AddProfileZoneD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger19PvdNetworkOutStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger19PropertyDescriptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd10Foundation11getInstanceEv() {
 return HEAP32[gb + 1452348 >> 2] | 0;
}

function __ZN5physx25PxVehicleConstraintShader15getSerializableEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5Light12CleanupClassEv() {
 __Z37CleanupLightAnimationBindingInterfacev();
 return;
}

function __ZN24RingBufferMemoryFileData6UnlockEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16UploadHandlerRaw8GetBytesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 24 >> 2] | 0;
}

function __ZN14GfxContextGLES8Instance14GetFramebufferEv(i1) {
 i1 = i1 | 0;
 return i1 + 8 | 0;
}

function __ZN13TextRendering17TextMeshGenerator15GetVertexFormatEv() {
 return gb + 1467900 | 0;
}

function __ZN13GfxDeviceNull8EndFrameEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 4192 >> 0] = 0;
 return;
}

function __ZN13GfxDeviceGLES15ActivateDisplayEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN12_GLOBAL__N_120DefaultAssertHandlerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12SocketStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6SocketD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN12ServerSocketD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6SocketD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN10MeshFilter13GetSharedMeshEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __Z36CanvasRenderer_Get_Custom_PropIsMaskP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z36AndroidJNI_CUSTOM_GetStringUTFLength13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z33GetHasChangedDeprecatedSystemMaskv() {
 return 1 << HEAP32[gb + 1477024 >> 2] | 0;
}

function __Z29GetCloudWebServicesManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(20) | 0;
}

function __Z26GetTerrainScriptingClassesv() {
 return __Z29GetTerrainScriptingClassesPtrv() | 0;
}

function __Z21CompleteFenceInternalR8JobFence(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z21ClearFenceWithoutSyncR8JobFence(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __Z17SetIsWorldPlayingb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 370093 >> 0] = i1 & 1;
 return;
}

function _Horizontal_Sweep_Init(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _setreuid(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___setxid(203, i1, i2, 0) | 0;
}

function _setregid(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___setxid(204, i1, i2, 0) | 0;
}

function _jsimd_quantize_float(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _jsimd_convsamp_float(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _emscripten_glFrontFace__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glFrontFace(i1 | 0);
}

function _emscripten_glDepthMask__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDepthMask(i1 | 0);
}

function _emscripten_glDepthFunc__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDepthFunc(i1 | 0);
}

function _bzero(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _memset(i1 | 0, 0, i2 | 0) | 0;
 return;
}

function __ZThn32_N8RendererD1Ev(i1) {
 i1 = i1 | 0;
 __ZN8RendererD2Ev(i1 + -32 | 0);
 return;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9Texture3D13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK9Texture2D13GetDataHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZNK9Texture2D13GetDataFormatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZNK9Texture2D12GetGPUHeightEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 100 >> 2] | 0;
}

function __ZNK6Sprite26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31832 | 0;
}

function __ZNK6Skybox26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31672 | 0;
}

function __ZNK6Shader26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 31552 | 0;
}

function __ZNK6Object26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 28304 | 0;
}

function __ZNK6Camera6GetFarEv(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 924 >> 2]);
}

function __ZNK6Camera26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 29832 | 0;
}

function __ZNK5physx6shdfnd10Foundation12getAllocatorEv(i1) {
 i1 = i1 | 0;
 return i1 + 8 | 0;
}

function __ZNK5physx2Sc9RigidCore6getSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx2Sc9ClothCore6getSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx18PxsSolverStartTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 721455 | 0;
}

function __ZNK5Umbra15GateStateVector6getPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNK20GpuProgramParameters14GetValueParamsEv(i1) {
 i1 = i1 | 0;
 return i1 + 16 | 0;
}

function __ZNK13b2DynamicTree15ValidateMetricsEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNK13GfxDeviceNull19GetProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 4744 | 0;
}

function __ZN9Texture3DD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9Texture3DD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN9Texture2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9Texture2DD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN9TextAssetD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9TextAssetD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN9GfxDeviceD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9GfxDeviceD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN9AudioClipD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9AudioClipD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN9AnimationD0Ev(i1) {
 i1 = i1 | 0;
 __ZN9AnimationD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN8Collider14WordsToPointerEjj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 | 0;
}

function __ZN7Texture39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx8debugger4comm13SetIsTopLevelD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd12getAllocatorEv() {
 return (HEAP32[gb + 1452348 >> 2] | 0) + 8 | 0;
}

function __ZN2UI6CanvasD0Ev(i1) {
 i1 = i1 | 0;
 __ZN2UI6CanvasD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN26AnimatorControllerPlayable6MemoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17Physics2DSettings12CleanupClassEv() {
 __Z23CleanupPhysicsManager2Dv();
 return;
}

function __ZN16UploadHandlerRaw5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZN14PhysicsManager16GetSleepVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZN13ScreenManager16SetScreenTimeoutEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13BaseAllocator16FrameMaintenanceEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN11UnityEngine15CloudWebService13WWWRestClient5AbortEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11Rigidbody2D11GetMaterialEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 72 >> 2] | 0;
}

function __ZN10systeminfo25GetDeviceUniqueIdentifierEv() {
 return HEAP32[gb + 64908 >> 2] | 0;
}

function __ZN10__cxxabiv121__vmi_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZL15gHullPrefetchCBjPKN5physx6PxVec3E(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z51LightmapSettings_Set_Custom_PropLightmapsModeLegacyi(i1) {
 i1 = i1 | 0;
 return;
}

function __Z36Application_Get_Custom_PropIsTestRunv() {
 return (__Z9IsTestRunv() | 0) & 1 | 0;
}

function __Z35AndroidJNI_CUSTOM_GetStringUTFChars13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z30scripting_cast_object_to_arrayP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __Z24RegisterAllInternalCallsv() {
 __Z32RegisterAllStrippedInternalCallsv();
 return;
}

function __Z19GetUnityAdsSettingsv() {
 return (__Z23GetUnityConnectSettingsv() | 0) + 112 | 0;
}

function _strcpy(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 ___stpcpy(i1, i2) | 0;
 return i1 | 0;
}

function _futimens(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _utimensat(i1, 0, i2, 0) | 0;
}

function _ft_black_set_mode(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return 0;
}

function __ZNSt9bad_allocC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216184 + 8;
 return;
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNKSt3__25ctypeIcE8do_widenEc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function __ZNKSt3__219__iostream_category4nameEv(i1) {
 i1 = i1 | 0;
 return gb + 1077737 | 0;
}

function __ZNK9Texture3D12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK9Texture2D12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK9Texture2D12GetDataWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 84 >> 2] | 0;
}

function __ZNK8Material13GetShaderPPtrEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK7Texture14GetMipmapCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 76 >> 2] | 0;
}

function __ZNK5physx2Sc8BodyCore6getSimEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx17SapUpdateWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 717082 | 0;
}

function __ZNK5physx17PxsCCDAdvanceTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 716470 | 0;
}

function __ZNK5physx17MBPUpdateWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 717417 | 0;
}

function __ZNK5physx17AggregateAABBTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718298 | 0;
}

function __ZNK5physx16PxBroadPhaseBase21getOutOfBoundsObjectsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5Light26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30512 | 0;
}

function __ZNK5Flare26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30112 | 0;
}

function __ZNK4Tree26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 184796 | 0;
}

function __ZNK23PxsCMDiscreteUpdateTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 719836 | 0;
}

function __ZNK13GfxDeviceNull18GetWorldViewMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 4808 | 0;
}

function __ZNK12TextureInput9GetBufferEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZNK11AudioSource21GetCustomRolloffCurveEv(i1) {
 i1 = i1 | 0;
 return i1 + 300 | 0;
}

function __ZN6Object39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx8debugger4comm12ErrorMessageD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm12BeginSectionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger17MemPvdInputStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc8SimStatsC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 188) | 0;
 return;
}

function __ZN5physx2Sc8ActorSimD2Ev(i1) {
 i1 = i1 | 0;
 __ZN5physx2Sc5ActorD2Ev(i1);
 return;
}

function __ZN5physx26NpPhysicsInsertionCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD8ChannelI6setPanEf(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return 0;
}

function __ZN4FMOD13ChannelGroupI9setPausedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23PreloadManagerOperation21MustCompleteNextFrameEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN17AudioCustomFilter6GetDSPEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZN16GraphicsCapsGLESC2Ev(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 196) | 0;
 return;
}

function __ZN16BaseVideoTexture5PauseEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN15CollisionEvents5ClearEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 12 >> 2] = 0;
 return;
}

function __ZN13GfxDeviceNull15SetBackfaceModeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLES15OnDeviceCreatedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN12_GLOBAL__N_118LegacySerialStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12TLSAllocatorI14StackAllocatorE14CheckIntegrityEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN11UnityEngine15PlatformWrapper17GameEngineVersionEv() {
 return gb + 1040146 | 0;
}

function __ZN11GameManagerD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 28496 + 8;
 return;
}

function __ZN11ColorModuleD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 83368 + 8;
 return;
}

function __ZN10builtintex22GetDitherMaskTexture3DEv() {
 return HEAP32[gb + 1158156 >> 2] | 0;
}

function __ZN10builtintex22GetDitherMaskTexture2DEv() {
 return HEAP32[gb + 1158152 >> 2] | 0;
}

function __ZN10__cxxabiv120__si_class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv120__function_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10Collider2D11GetMaterialEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 36 >> 2] | 0;
}

function __Z62TerrainData_CUSTOM_Internal_GetMaximumDetailResolutionPerPatchv() {
 return 1e3;
}

function __Z50Profiler_Set_Custom_PropMaxNumberOfSamplesPerFramei(i1) {
 i1 = i1 | 0;
 return;
}

function __Z41Physics_Set_Custom_PropMaxAngularVelocityf(f1) {
 f1 = Math_fround(f1);
 return;
}

function __Z34Cloth_Get_Custom_PropSelfCollisionP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z34AndroidJNI_CUSTOM_FromBooleanArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z27GetUnityAnalyticsManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(21) | 0;
}

function __Z26IsSplashScreenFadeCompletev() {
 return (HEAP32[gb + 1157848 >> 2] | 0) > 1 | 0;
}

function __Z26IsProfilerEnabledThisFramev() {
 return (HEAP8[gb + 1546599 >> 0] | 0) != 0 | 0;
}

function __Z15SetIsFirstFrameb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 452440 >> 0] = i1 & 1;
 return;
}

function __Z14SetIsBatchmodeb(i1) {
 i1 = i1 | 0;
 HEAP8[gb + 1546618 >> 0] = i1 & 1;
 return;
}

function b16(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 nullFunc_fii(16);
 return Math_fround(0);
}

function _putwchar(i1) {
 i1 = i1 | 0;
 return _fputwc(i1, HEAP32[gb + 191868 >> 2] | 0) | 0;
}

function _mkstemps(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___mkostemps(i1, i2, 0) | 0;
}

function _mkostemp(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return ___mkostemps(i1, 0, i2) | 0;
}

function _emscripten_glCullFace__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glCullFace(i1 | 0);
}

function _cf2_hint_lock(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 16;
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN27FixedUpdateClearLinesstruct7ForwardEv() {
 return;
}

function __ZZ23InitPlayerLoopCallbacksvEN27EarlyUpdateClearLinesstruct7ForwardEv() {
 return;
}

function __ZNSt8bad_castC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = gb + 216464 + 8;
 return;
}

function __ZNSt3__221undeclare_no_pointersEPcj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE13do_max_lengthEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK9dtNavMesh11getMaxTilesEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK9Texture2D11GetGPUWidthEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 96 >> 2] | 0;
}

function __ZNK8Playable12GetPlayStateEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 12 >> 2] | 0;
}

function __ZNK8Playable11GetDurationEv(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 40 >> 3]);
}

function __ZNK6IDList14GetSearchIndexEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __ZNK5physx9NpPhysics18getTolerancesScaleEv(i1) {
 i1 = i1 | 0;
 return i1 + 20 | 0;
}

function __ZNK5physx7NpShape8getActorEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNK5physx7NpShape7getNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 192 >> 2] | 0;
}

function __ZNK5physx30PxVehicleAckermannGeometryData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16PxsSolverEndTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720447 | 0;
}

function __ZNK4Mesh26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30832 | 0;
}

function __ZNK4Halo26GetTypeInfoVirtualInternalEv(i1) {
 i1 = i1 | 0;
 return gb + 30352 | 0;
}

function __ZNK3WWW17GetThreadPriorityEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 60 >> 2] | 0;
}

function __ZNK23iPhoneLocalNotification19GetAlertLaunchImageEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK22ScAfterIntegrationTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 722177 | 0;
}

function __ZNK18AnimatorController13GetBehavioursEv(i1) {
 i1 = i1 | 0;
 return i1 + 192 | 0;
}

function __ZN9GfxDevice17BeginProfileEventEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8RendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZN8RendererD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN8MaterialD0Ev(i1) {
 i1 = i1 | 0;
 __ZN8MaterialD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN8LODGroupD0Ev(i1) {
 i1 = i1 | 0;
 __ZN8LODGroupD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN8AnimatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZN8AnimatorD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm11SetPickableD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm11OriginShiftD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm11DeriveClassD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm11CreateClassD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger16ClassDescriptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd18BufferedSocketImplD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx3Cct13BoxController15getPxControllerEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx25PxVehicleConstraintShaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN30RuntimeInitializeOnLoadManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23iPhoneLocalNotificationD2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN23iPhoneLocalNotificationC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN20SpeedTreeWindManager11GetInstanceEv() {
 return HEAP32[gb + 1170600 >> 2] | 0;
}

function __ZN18ProceduralMaterial9ReloadAllEbb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN16DeveloperConsole17GetObjectGUIStateEv(i1) {
 i1 = i1 | 0;
 return i1 + 28 | 0;
}

function __ZN16BaseVideoTexture4StopEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN16BaseVideoTexture4PlayEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 92 >> 0] = 1;
 return;
}

function __ZN14DataBufferGLES6DisownEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 4 >> 2] = 0;
 return;
}

function __ZN13MemoryManager16LowLevelAllocateEj(i1) {
 i1 = i1 | 0;
 return _malloc(i1) | 0;
}

function __ZN10builtintex21GetAttenuationTextureEv() {
 return HEAP32[gb + 1158196 >> 2] | 0;
}

function __ZN10__cxxabiv119__pointer_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE5CheckEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL27CleanupModule_TextRenderingv() {
 __Z26CleanupTextRenderingModulev();
 return;
}

function __Z40DynamicGI_Set_Custom_PropUpdateThresholdf(f1) {
 f1 = Math_fround(f1);
 return;
}

function __Z38Input_Get_Custom_PropDeviceOrientationv() {
 return __Z14GetOrientationv() | 0;
}

function __Z33AndroidJNI_CUSTOM_FromObjectArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z33AndroidJNI_CUSTOM_FromDoubleArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z26GetUnityConnectSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(22) | 0;
}

function __Z25GetRenderLoopImageFiltersR10RenderLoop(i1) {
 i1 = i1 | 0;
 return i1 + 68 | 0;
}

function __Z21SetGyroUpdateIntervalif(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 return;
}

function __Z20scripting_gc_collecti(i1) {
 i1 = i1 | 0;
 _il2cpp_gc_collect(i1 | 0);
 return;
}

function _UNITY_FT_RoundFix(i1) {
 i1 = i1 | 0;
 return i1 + 32768 + (i1 >> 31) & -65536 | 0;
}

function _zipOpen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _zipOpen2(i1, i2, 0, 0) | 0;
}

function _zipCloseFileInZip(i1) {
 i1 = i1 | 0;
 return _zipCloseFileInZipRaw(i1, 0, 0) | 0;
}

function _mkfifo(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _mknod(i1, i2 | 4096, 0) | 0;
}

function _gray_raster_reset(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _glIsVertexArray__wrapper(i1) {
 i1 = i1 | 0;
 return _glIsVertexArray(i1 | 0) | 0;
}

function _emscripten_glCreateProgram__wrapper() {
 return _emscripten_glCreateProgram() | 0;
}

function ___flbf(i1) {
 i1 = i1 | 0;
 return (HEAPU8[i1 + 75 >> 0] | 0) >>> 7 & 255 ^ 1 | 0;
}

function __ZNSt3__27codecvtIDsc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27codecvtIDic11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__224__generic_error_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__220__codecvt_utf8_utf16IDsED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__220__codecvt_utf8_utf16IDiED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217__widen_from_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__217__widen_from_utf8ILj16EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__27codecvtIDsc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__27codecvtIDic11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDsE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__220__codecvt_utf8_utf16IDiE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__210moneypunctIcLb1EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__210moneypunctIcLb1EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__210moneypunctIcLb0EE16do_thousands_sepEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNKSt3__210moneypunctIcLb0EE16do_decimal_pointEv(i1) {
 i1 = i1 | 0;
 return 127;
}

function __ZNK9ShaderLab7Program27EndWriteUnsupportedVariantsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK7ApiGLES10GetContextEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 1988 >> 2] | 0;
}

function __ZNK5physx15PxsCCDSweepTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 722734 | 0;
}

function __ZNK3WWW17GetUnityWebStreamEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK21PxsParallelSolverTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 720176 | 0;
}

function __ZNK16BaseVideoTexture25IsVideoVerticallyMirroredEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14UnityWebStream26GetTotalBytesUntilLoadableEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNK10AudioMixer31AllowSnapshotTransitionsFromAPIEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN9Rigidbody18SetUseConeFrictionEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8TToArray5IndexIfEERfRT_i(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i1 | 0;
}

function __ZN7StriperD2Ev(i1) {
 i1 = i1 | 0;
 __ZN7Striper11FreeUsedRamEv(i1) | 0;
 return;
}

function __ZN6Shader25GetGlobalMaximumShaderLODEv() {
 return HEAP32[gb + 1166412 >> 2] | 0;
}

function __ZN5physx8debugger4comm10EventGroupD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm10EndSectionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sc5Scene11getSceneGpuEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx2Sc35ParticleElementRbElementInteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc35ParticleElementRbElementInteractionD0Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu15MeshHitCallbackINS_12PxRaycastHitEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx24PxDefaultMemoryInputDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4Mesh39ShouldIgnoreInGarbageDependencyTrackingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN4FMOD13ChannelGroupI7setMuteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN24iPhoneRemoteNotification8SetErrorEP11objc_object(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22UnityProfilerPerThread22DomainReloadedCallbackEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20TextRenderingPrivate8TextMesh15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial26RebuildTexturesImmediatelyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial26FreezeAndReleaseSourceDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshObstacle26CalculateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 return 32;
}

function __ZN13WebCamTexture14GetWorldOffsetEv(i1) {
 i1 = i1 | 0;
 return gb + 1162292 | 0;
}

function __ZN13TextRendering17GetITextRenderingEv() {
 return HEAP32[gb + 1162168 >> 2] | 0;
}

function __ZN13ScreenManager13SetShowCursorEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13MemoryManager31DisallowAllocationsOnThisThreadEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13EmscriptenWWW7GetSizeEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 88 >> 2] | 0;
}

function __ZN13EmscriptenWWW7GetDataEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 92 >> 2] | 0;
}

function __ZN12_GLOBAL__N_116RequiresCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12_GLOBAL__N_116CompleteCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11UnityEngine15CloudWebService14RestDownloaderD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo22GetDeviceSystemVersionEv() {
 return HEAP32[gb + 64908 >> 2] | 0;
}

function __ZN10systeminfo19GetPhysicalMemoryMBEv() {
 return _JS_SystemInfo_GetMemory() | 0;
}

function __ZL14CleanupShadowsPv(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1113156 >> 2] = 0;
 return;
}

function __Z9SetIUmbraP6IUmbra(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162172 >> 2] = i1;
 return;
}

function __Z9SetIIMGUIP6IIMGUI(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162136 >> 2] = i1;
 return;
}

function __Z9SetIClothP6ICloth(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162124 >> 2] = i1;
 return;
}

function __Z9SetIAudioP6IAudio(i1) {
 i1 = i1 | 0;
 HEAP32[gb + 1162120 >> 2] = i1;
 return;
}

function __Z9EndJobSetR8JobFence11JobPriority(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z62TerrainData_CUSTOM_Internal_GetMinimumDetailResolutionPerPatchv() {
 return 8;
}

function __Z47Physics_Get_Custom_PropMinPenetrationForPenaltyv() {
 return Math_fround(0.0);
}

function __Z47GUISettings_CUSTOM_Internal_GetCursorFlashSpeedv() {
 return Math_fround(2.0);
}

function __Z36Profiler_Get_Custom_PropUsedHeapSizev() {
 return __Z15GetUsedHeapSizev() | 0;
}

function __Z34GetLightProbeProxyVolumeManagerPtrv() {
 return HEAP32[gb + 1110944 >> 2] | 0;
}

function __Z34Debug_CUSTOM_GetDiagnosticSwitchesP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return;
}

function __Z32AndroidJNI_CUSTOM_GetArrayLength13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z32AndroidJNI_CUSTOM_FromShortArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z32AndroidJNI_CUSTOM_FromFloatArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z24GetAudioScriptingClassesv() {
 return __Z27GetAudioScriptingClassesPtrv() | 0;
}

function __Z15GetAccelerationjR12Acceleration(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_png_get_io_chunk_type(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 372 >> 2] | 0;
}

function _UNITY_LZ4_resetStream(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 16416) | 0;
 return;
}

function _putchar(i1) {
 i1 = i1 | 0;
 return _fputc(i1, HEAP32[gb + 191868 >> 2] | 0) | 0;
}

function _emscripten_glDisable__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glDisable(i1 | 0);
}

function _emscripten_glClearDepth__wrapper(d1) {
 d1 = +d1;
 _emscripten_glClearDepth(+d1);
}

function _dcgettext(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i2 | 0;
}

function _cf2_hint_isBottom(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] & 5 | 0) != 0 | 0;
}

function __ZdlPvRKSt9nothrow_t(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZdlPv(i1);
 return;
}

function __ZdaPvRKSt9nothrow_t(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZdaPv(i1);
 return;
}

function __ZNSt3__27codecvtIcc11__mbstate_tED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__223__system_error_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__223__future_error_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__219declare_no_pointersEPcj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNSt3__216__narrow_to_utf8ILj32EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__216__narrow_to_utf8ILj16EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IDsLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IDsLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IDiLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215__codecvt_utf16IDiLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__27codecvtIcc11__mbstate_tE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNKSt3__220__codecvt_utf8_utf16IwE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb1EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDsLb0EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb1EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IDiLb0EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__214__codecvt_utf8IDsE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__214__codecvt_utf8IDiE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt20bad_array_new_length4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085405 | 0;
}

function __ZNKSt13runtime_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK9WWWCached17GetUploadProgressEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZNK9ShaderLab7Program26EndReadUnsupportedVariantsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK5physx14SingleAABBTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718415 | 0;
}

function __ZNK23iPhoneLocalNotification17GetRepeatIntervalEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification17GetRepeatCalendarEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK20PxsAtomIntegrateTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 721055 | 0;
}

function __ZNK15MonoScriptCache8RefCountEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNK14TerrainManager17GetActiveTerrainsEv(i1) {
 i1 = i1 | 0;
 return i1 + 4 | 0;
}

function __ZNK13SpeedTreeWind15GetBranchAnchorEv(i1) {
 i1 = i1 | 0;
 return i1 + 1332 | 0;
}

function __ZNK11NamedObject7GetNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZN9GfxDevice16SetActiveContextEPv(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN8Collider11GetMaterialEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 32 >> 2] | 0;
}

function __ZN7b2Joint11ShiftOriginERK6b2Vec2(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN7CubemapD0Ev(i1) {
 i1 = i1 | 0;
 __ZN7CubemapD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpScene15SceneCompletionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23PxsSolverSetupSolveTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23PxsFluidDynamicsSphTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23PxCapsuleControllerDescD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23NpVolumeCacheSqCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx23AggregateAABBUpdateTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxsFluidDynamics4initEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxsArticulationC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN5physx15PxGetFilterBoolEv() {
 return (HEAP8[gb + 1551035 >> 0] | 0) != 0 | 0;
}

function __ZN5physx12NpGetPxSceneERNS_3Scb5SceneE(i1) {
 i1 = i1 | 0;
 return i1 + -16 | 0;
}

function __ZN5physx12NpBatchQuery13getUserMemoryEv(i1) {
 i1 = i1 | 0;
 return i1 + 80 | 0;
}

function __ZN5Umbra15GateStateVectorC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN4FMOD8ChannelI11setPriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN29PxsCreateFinalizeContactsTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN20TextRenderingPrivate7GUIText15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18LoadSceneOperation25RetainSceneSerializedFileEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14AsyncOperation11SetPriorityEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13WebCamTexture5PauseEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 92 >> 0] = 0;
 return;
}

function __ZN13ScreenManager12SetIsFocusedEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13MemoryManager30ReallowAllocationsOnThisThreadEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull12SetWireframeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceNull12SetSRGBWriteEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN13GfxDeviceGLES12SetWireframeEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN10__cxxabiv117__pbase_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv117__class_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv117__array_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE5CheckEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL33DeveloperConsoleGetObjectGUIStatePv(i1) {
 i1 = i1 | 0;
 return i1 + 28 | 0;
}

function __Z46Physics_Get_Custom_PropPenetrationPenaltyForcev() {
 return Math_fround(0.0);
}

function __Z38DynamicGI_Set_Custom_PropIndirectScalef(f1) {
 f1 = Math_fround(f1);
 return;
}

function __Z33GetIAnimationStateNetworkProviderv() {
 return HEAP32[gb + 1162112 >> 2] | 0;
}

function __Z33AndroidJNI_CUSTOM_DeleteGlobalRef13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return;
}

function __Z31AndroidJNI_CUSTOM_FromLongArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z31AndroidJNI_CUSTOM_FromCharArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z31AndroidJNI_CUSTOM_FromByteArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z29scripting_gc_collect_a_littlev() {
 return _il2cpp_gc_collect_a_little() | 0;
}

function __Z27GetOcclusionCullingSettingsv() {
 return __Z21GetManagerFromContexti(24) | 0;
}

function __Z27GenerateMonoScriptCacheHashP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __Z24GetCrashReportManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(23) | 0;
}

function __Z23IsWorldPlayingThisFramev() {
 return (HEAP8[gb + 1546598 >> 0] | 0) != 0 | 0;
}

function _Project_y(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i3 | 0;
}

function _Project_x(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return i2 | 0;
}

function b102(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 nullFunc_viii(102);
}

function _glCreateShader__wrapper(i1) {
 i1 = i1 | 0;
 return _glCreateShader(i1 | 0) | 0;
}

function ___fwritable(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) >>> 3 & 1 ^ 1 | 0;
}

function ___freadable(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) >>> 2 & 1 ^ 1 | 0;
}

function __ZNKSt3__28messagesIwE8do_closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__28messagesIcE8do_closeEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZNKSt3__215__codecvt_utf16IwLb1EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__215__codecvt_utf16IwLb0EE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__214__codecvt_utf8IwE16do_always_noconvEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9Rigidbody16GetSleepVelocityEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZNK9GfxDevice19GetProjectionMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 3484 | 0;
}

function __ZNK6Sprite24GetRenderDataForPlayModeEv(i1) {
 i1 = i1 | 0;
 return i1 + 80 | 0;
}

function __ZNK5physx27PxVehicleTireLoadFilterData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx27PxVehicleDifferentialNWData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx27PxVehicleDifferential4WData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx13ActorAABBTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718358 | 0;
}

function __ZNK19LowerResBlitTexture20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK18PlatformEffector2D21DesignedForNonTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK18BuoyancyEffector2D21DesignedForNonTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14RenderSettings15GetAmbientProbeEv(i1) {
 i1 = i1 | 0;
 return i1 + 76 | 0;
}

function __ZNK13SpeedTreeWind14GetShaderTableEv(i1) {
 i1 = i1 | 0;
 return i1 + 1628 | 0;
}

function __ZNK13GfxDeviceNull14GetWorldMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 4616 | 0;
}

function __ZNK10GameObject7GetNameEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 64 >> 2] | 0;
}

function __ZN9Scripting19ScriptingObjectNULLEP11Il2CppClass(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx8debugger4comm9SetCameraD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7NpScene10startWriteEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx2Cm19CmEventNameProviderD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx22PxDefaultErrorCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxOverlapBufferNILi1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity9Component26CalculateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN23PreloadManagerOperation19IntegrateMainThreadEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21AnimationClipPlayable6MemoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18ScriptingArguments12InMonoFormatEv(i1) {
 i1 = i1 | 0;
 return i1 + 96 | 0;
}

function __ZN18PlayableController12GetFrameDataEv(i1) {
 i1 = i1 | 0;
 return i1 + 88 | 0;
}

function __ZN15LocationService18SetDesiredAccuracyEf(f1) {
 f1 = Math_fround(f1);
 return;
}

function __ZN14CompletionTask3runEv(i1) {
 i1 = i1 | 0;
 HEAP8[i1 + 20 >> 0] = 1;
 return;
}

function __ZN14AnimationState12CleanupClassEv() {
 HEAP32[gb + 1466576 >> 2] = 0;
 return;
}

function __ZN10__cxxabiv116__shim_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10__cxxabiv116__enum_type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZL19stbir__support_zerof(f1) {
 f1 = Math_fround(f1);
 return Math_fround(0.0);
}

function __Z6getBitj(i1) {
 i1 = i1 | 0;
 return HEAP32[gb + 106028 + (i1 << 2) >> 2] | 0;
}

function __Z46GIDebugVisualisation_CUSTOM_CycleSkipInstancesi(i1) {
 i1 = i1 | 0;
 return;
}

function __Z33Gizmos_CUSTOM_INTERNAL_set_matrixRK10Matrix4x4f(i1) {
 i1 = i1 | 0;
 return;
}

function __Z32AndroidJNI_CUSTOM_DeleteLocalRef13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return;
}

function __Z30AndroidJNI_CUSTOM_FromIntArray13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z28PlayerPrefs_CUSTOM_DeleteAllv() {
 __ZN11PlayerPrefs9DeleteAllEv();
 return;
}

function __Z26GetCloudWebServicesManagerv() {
 return __Z21GetManagerFromContexti(20) | 0;
}

function __Z23GetPhysics2DSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(16) | 0;
}

function __Z19GetPhysicsManager2Dv() {
 return HEAP32[HEAP32[gb + 1458412 >> 2] >> 2] | 0;
}

function _InitUNetUpdateFunction() {
 HEAP32[gb + 1115296 + 236 >> 2] = fb + 388;
 return;
}

function b91(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 nullFunc_iif(91);
 return 0;
}

function b145(f1, f2) {
 f1 = Math_fround(f1);
 f2 = Math_fround(f2);
 nullFunc_vff(145);
}

function _significand(d1) {
 d1 = +d1;
 return +(+_scalbn(d1, 0 - (_ilogb(d1) | 0) | 0));
}

function _llvm_bswap_i16(i1) {
 i1 = i1 | 0;
 return (i1 & 255) << 8 | i1 >> 8 & 255 | 0;
}

function _jsimd_quantize(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _jsimd_convsamp(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _ft_black_reset(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return;
}

function _ferror_file_func(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _ferror(i2) | 0;
}

function _fclose_file_func(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _fclose(i2) | 0;
}

function _ether_ntoa(i1) {
 i1 = i1 | 0;
 return _ether_ntoa_r(i1, gb + 1576114 | 0) | 0;
}

function _ether_aton(i1) {
 i1 = i1 | 0;
 return _ether_aton_r(i1, gb + 1576108 | 0) | 0;
}

function _emscripten_glEnable__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glEnable(i1 | 0);
}

function _cf2_hint_isTop(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] & 10 | 0) != 0 | 0;
}

function ___lgammal_r(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+___lgamma_r(d1, i2));
}

function ___fseterr(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = HEAP32[i1 >> 2] | 32;
 return;
}

function __ZNKSt11logic_error4whatEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx19NpArticulationJoint13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK24MeshIntermediateRenderer14AllowsBatchingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK23AnimationOffsetPlayable15GetApplyMotionXEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK18ScBeforeSolverTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 721841 | 0;
}

function __ZNK17SurfaceEffector2D21DesignedForNonTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK16BaseVideoTexture22GetBufferTextureFormatEv(i1) {
 i1 = i1 | 0;
 return 5;
}

function __ZNK13MonoBehaviour25GetNeedsPerObjectTypeTreeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13GfxDeviceNull13GetViewMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 4680 | 0;
}

function __ZNK10PngDecoder6GetCrcEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 44 >> 2] | 0;
}

function __ZNK10MonoScript18GetScriptClassNameEv(i1) {
 i1 = i1 | 0;
 return i1 + 92 | 0;
}

function __ZN7Texture21GetMasterTextureLimitEv() {
 return HEAP32[gb + 1158376 >> 2] | 0;
}

function __ZN6ShaderD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6ShaderD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN6CameraD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6CameraD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN6AvatarD0Ev(i1) {
 i1 = i1 | 0;
 __ZN6AvatarD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger4comm8SetColorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx8debugger26PropertyMessageDescriptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21SapPostUpdateWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx21PxsFluidCollisionTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxsIslandManager19finishSolverIslandsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra21UserCallbackAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN27GenericSlowGarbageCollectorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN27ConvexVsMeshOverlapCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN22LocalFileSystemHandler4NameEv(i1) {
 i1 = i1 | 0;
 return gb + 363438 | 0;
}

function __ZN15LocationService17SetDistanceFilterEf(f1) {
 f1 = Math_fround(f1);
 return;
}

function __ZN13UploadHandler10OnSentDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN10systeminfo19GetDeviceSystemNameEv() {
 return HEAP32[gb + 64908 >> 2] | 0;
}

function __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE5CheckEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10MemoryPool5ResetEv(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 32 >> 2] = 0;
 return;
}

function __ZL18stbir__support_twof(f1) {
 f1 = Math_fround(f1);
 return Math_fround(2.0);
}

function __ZL18stbir__support_onef(f1) {
 f1 = Math_fround(f1);
 return Math_fround(1.0);
}

function __Z56TerrainData_CUSTOM_Internal_GetMaximumAlphamapResolutionv() {
 return 2048;
}

function __Z32Gizmos_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf(i1) {
 i1 = i1 | 0;
 return;
}

function __Z31profiler_get_memory_record_modev() {
 return HEAP32[gb + 1163252 >> 2] | 0;
}

function __Z31GetLightProbeProxyVolumeManagerv() {
 return HEAP32[gb + 1110944 >> 2] | 0;
}

function __Z25GetNavMeshProjectSettingsv() {
 return __Z21GetManagerFromContexti(15) | 0;
}

function __Z22NeedToPerformRenderingv() {
 return (HEAP8[gb + 452442 >> 0] | 0) != 0 | 0;
}

function __Z22GetLightmapSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(26) | 0;
}

function _UNITY_tt_driver_init(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 64 >> 2] = 35;
 return 0;
}

function _PxCloseExtensions() {
 __ZN5physx6shdfnd10Foundation11decRefCountEv();
 return;
}

function _lroundf(f1) {
 f1 = Math_fround(f1);
 return ~~Math_fround(+_roundf(+f1)) | 0;
}

function _iscntrl(i1) {
 i1 = i1 | 0;
 return (i1 >>> 0 < 32 | (i1 | 0) == 127) & 1 | 0;
}

function _gzopen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _gz_open(i1, i2, -1) | 0;
}

function _glUnmapBuffer__wrapper(i1) {
 i1 = i1 | 0;
 return _glUnmapBuffer(i1 | 0) | 0;
}

function _ether_line(i1, i2, i3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 i3 = i3 | 0;
 return -1;
}

function _cff_cmap_encoding_done(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 16 >> 2] = 0;
 return;
}

function __ZSt10unexpectedv() {
 __ZSt12__unexpectedPFvvE(__ZSt14get_unexpectedv() | 0);
}

function __ZNKSt3__210moneypunctIwLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__210moneypunctIwLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__210moneypunctIcLb1EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__210moneypunctIcLb0EE14do_frac_digitsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx25PxVehicleGraphChannelDesc7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx18NpArticulationLink13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK3WWW12GetAudioClipEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 16 >> 2] | 0;
}

function __ZNK23iPhoneLocalNotification14GetAlertActionEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK16BaseVideoTexture21GetVideoRotationAngleEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13ScreenManager24GetAllowLayeredRenderingEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK12b2MotorJoint15GetLinearOffsetEv(i1) {
 i1 = i1 | 0;
 return i1 + 68 | 0;
}

function __ZN9GfxDevice14WaitOnCPUFenceEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx8debugger8renderer16RenderSerializerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpScene15SceneCompletion11runInternalEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth28sendPvdSeparationConstraintsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd11printStringEPKc(i1) {
 i1 = i1 | 0;
 _puts(i1) | 0;
 return;
}

function __ZN5physx20SingleAABBUpdateTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20PxsSolverCoreGeneralD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20ProcessBPResultsTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx20AggregateOverlapTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Umbra20SingleBlockAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26b2PolygonAndCapsuleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26PxcContactCellMeshCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26ContactCapsuleMeshCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25ShadowMapJobHeaderScratch15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN25RuntimeAnimatorController15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21AssetBundleFileSystem4NameEv(i1) {
 i1 = i1 | 0;
 return gb + 585732 | 0;
}

function __ZN11UnityEngine15PlatformWrapper26GetUnityAdsTrackingEnabledEv() {
 return 0;
}

function __Z9heapAllocPvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _malloc(i2) | 0;
}

function __Z55TerrainData_CUSTOM_Internal_GetMaximumBaseMapResolutionv() {
 return 2048;
}

function __Z44GIDebugVisualisation_CUSTOM_CycleSkipSystemsi(i1) {
 i1 = i1 | 0;
 return;
}

function __Z24GetUnityAnalyticsManagerv() {
 return __Z21GetManagerFromContexti(21) | 0;
}

function __Z22GetGraphicsSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(6) | 0;
}

function __Z21GetUnityAdsManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(17) | 0;
}

function __Z21GetQualitySettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(11) | 0;
}

function __Z19IsConsoleLogPathSetv() {
 return (HEAP32[gb + 1450760 >> 2] | 0) != 0 | 0;
}

function __Z19FileSystemIsMountedv() {
 return (HEAP32[gb + 1179016 >> 2] | 0) != 0 | 0;
}

function _UNITY_png_unity_get_crc(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 408 >> 2] | 0;
}

function b104(i1, i2, d3) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 d3 = +d3;
 nullFunc_viid(104);
}

function _wcstold(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+_wcstox(i1, i2, 2));
}

function _strtold(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+_strtox(i1, i2, 2));
}

function _jpeg_get_small(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _malloc(i2) | 0;
}

function _jpeg_get_large(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _malloc(i2) | 0;
}

function _iswxdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswxdigit(i1) | 0;
}

function _isblank(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) == 32 | (i1 | 0) == 9) & 1 | 0;
}

function _ftell_file_func(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _ftell(i2) | 0;
}

function _emscripten_glClear__wrapper(i1) {
 i1 = i1 | 0;
 _emscripten_glClear(i1 | 0);
}

function _cf2_stack_clear(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 392 >> 2] = i1 + 8;
 return;
}

function __ZNSt3__219__shared_weak_countD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__219__iostream_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__212bad_weak_ptr4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1082229 | 0;
}

function __ZNKSt16bad_array_length4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085451 | 0;
}

function __ZNK9WWWCached6GetUrlEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 80 >> 2] | 0;
}

function __ZNK9CGProgram18GetScriptClassNameEv(i1) {
 i1 = i1 | 0;
 return i1 + 80 | 0;
}

function __ZNK7b2Timer15GetMillisecondsEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZNK5physx10BPWorkTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 718233 | 0;
}

function __ZNK24iPhoneRemoteNotification12GetSoundNameEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK24iPhoneRemoteNotification12GetAlertBodyEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification11GetFireDateEv(i1) {
 i1 = i1 | 0;
 return 0.0;
}

function __ZNK20IntermediateRenderer16GetMaterialCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK18PlatformEffector2D18DesignedForTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK18BuoyancyEffector2D18DesignedForTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK15PointEffector2D21DesignedForNonTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9ShaderLab16CleanupShaderLabEv() {
 HEAP8[gb + 1546616 >> 0] = 0;
 return;
}

function __ZN6Socket8GetErrorEv() {
 return HEAP32[(___errno_location() | 0) >> 2] | 0;
}

function __ZN5physx9NpPhysics23getPvdConnectionManagerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx7NpCloth27sendPvdSelfCollisionIndicesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx5cloth16SwInterCollisionI8Scalar4fED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sq8populateEPKNS0_10ActorShapeE(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx2Sn14RepXCollection16getLatestVersionEv() {
 return gb + 766707 | 0;
}

function __ZN5physx19PxCapsuleControllerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx19ActorAABBUpdateTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13PxHitCallbackINS_12PxRaycastHitEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx13PxHitCallbackINS_12PxOverlapHitEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD7SystemI9setDriverEi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN4FMOD7ReverbI9setActiveEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN33AssetBundleLoadFromAsyncOperation7PerformEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN25b2PolygonAndCircleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25b2CapsuleAndCircleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25PostFilteredUserCollectorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25MeshMTDGenerationCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25ConvexVsMeshSweepCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN25CapsuleTraceSegmentReportD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24PhysicsUpdateBehaviour2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24OcclusionCullingSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24EllipsoidParticleEmitter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20IntermediateRenderer19UpdateTransformInfoEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService24SetHeadingUpdatesEnabledEb(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14AsyncOperation23GetAllowSceneActivationEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN13MemoryManager24InitializeDebugAllocatorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN10builtintex15GetWhiteTextureEv() {
 return HEAP32[gb + 1158160 >> 2] | 0;
}

function __ZN10builtintex15GetBlackTextureEv() {
 return HEAP32[gb + 1157932 >> 2] | 0;
}

function __ZL27ForwardInvokeDelayedCleanupPv(i1) {
 i1 = i1 | 0;
 _free(i1);
 return 0;
}

function __Z57ThreadAndSerializationSafeCheckIsRecursiveTransferAllowedv() {
 return 1;
}

function __Z56TerrainData_CUSTOM_Internal_GetMinimumAlphamapResolutionv() {
 return 16;
}

function __Z39ScriptingInstantiateObjectFromClassNamePKc(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z29GetGlobalAllowNameConversionsv() {
 return HEAP32[gb + 1166132 >> 2] | 0;
}

function __Z24RegisterForNotificationsib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z23GetUnityConnectSettingsv() {
 return __Z21GetManagerFromContexti(22) | 0;
}

function __Z18IsScreenshotQueuedv() {
 return (HEAP32[gb + 1162560 >> 2] | 0) != 0 | 0;
}

function _UNITY_png_get_io_state(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 656 >> 2] | 0;
}

function _wcstod(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+_wcstox(i1, i2, 1));
}

function _strtod(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return +(+_strtox(i1, i2, 1));
}

function _nexttowardl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_nextafterl(d1, d2));
}

function _inet_network(i1) {
 i1 = i1 | 0;
 return _ntohl(_inet_addr(i1 | 0) | 0) | 0;
}

function _cf2_hint_isValid(i1) {
 i1 = i1 | 0;
 return (HEAP32[i1 >> 2] | 0) != 0 | 0;
}

function _cf2_arrstack_getBuffer(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 28 >> 2] | 0;
}

function __ZThn8_N5physx2Sc24ElementInteractionMarkerD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZSt17current_exceptionv() {
 return ___cxa_current_primary_exception() | 0;
}

function __ZNSt3__215messages_bynameIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215messages_bynameIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__214codecvt_bynameIDic11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__214__codecvt_utf8IDsED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214__codecvt_utf8IDiED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__214__codecvt_utf8IDsE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNKSt3__214__codecvt_utf8IDiE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK6Avatar8GetAssetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZNK5physx2Sc19ParticlePacketShape8isActiveEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx2Gu11HeightField15getSampleStrideEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNK5physx23PxsBroadPhaseContextSap7getTypeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx23PxVehicleSuspensionData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx23PxVehicleDriveSimDataNW7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx23PxVehicleDriveSimData4W7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK2UI13RectTransform19GetDrivenPropertiesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK24iPhoneRemoteNotification11GetUserInfoEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification12GetSoundNameEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification12GetAlertBodyEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK17SurfaceEffector2D18DesignedForTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14AreaEffector2D21DesignedForNonTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13WebCamTexture22GetBufferTextureFormatEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNK12SocketStream23IsArtificiallyConnectedEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx8debugger4comm18EventSerializeableD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpScene9stopWriteEb(i2, i1) {
 i2 = i2 | 0;
 i1 = i1 | 0;
 return;
}

function __ZN5physx5cloth15SwSelfCollisionI8Scalar4fED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc15CoreInteractionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxsSolverStartTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxVehicleDriveTankD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxArticulationLinkD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity17ConfigurableJoint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24b2ChainAndPolygonContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24b2ChainAndCapsuleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24MidPhaseQueryLocalReportD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24ConvexVsHeightfieldSweepD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24ControllerFilterCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23ShaderVariantCollection15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22NavMeshProjectSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22BlockMemoryCacheWriter12GetCacheSizeEv(i1) {
 i1 = i1 | 0;
 return 256;
}

function __ZN15DownloadHandler23OnUnbindScriptingObjectEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10builtintex14GetHaloTextureEv() {
 return HEAP32[gb + 1158192 >> 2] | 0;
}

function __Z6GetIPsPA16_c(i1) {
 i1 = i1 | 0;
 _memset(i1 | 0, 0, 160) | 0;
 return 0;
}

function __Z56DrivenRectTransformTracker_CUSTOM_CanRecordModificationsv() {
 return 1;
}

function __Z55TerrainData_CUSTOM_Internal_GetMinimumBaseMapResolutionv() {
 return 16;
}

function __Z54TerrainData_CUSTOM_Internal_GetMaximumDetailPatchCountv() {
 return 1e4;
}

function __Z41Physics_Get_Custom_PropMaxAngularVelocityv() {
 return Math_fround(0.0);
}

function __Z20GetPlayerSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(0) | 0;
}

function __Z20GetPhysicsManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(9) | 0;
}

function __Z19IsMultiTouchEnabledv() {
 return (HEAP8[gb + 363160 >> 0] | 0) != 0 | 0;
}

function __Z19GetBuildSettingsPtrv() {
 return __Z24GetManagerPtrFromContexti(10) | 0;
}

function __Z18LoadPluginFunctionPvPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __Z18IsInsidePlayerLoopv() {
 return (HEAP8[gb + 1546597 >> 0] | 0) != 0 | 0;
}

function __Z14GetDefaultSkini(i1) {
 i1 = i1 | 0;
 return __Z14GetBuiltinSkini(0) | 0;
}

function b137(f1) {
 f1 = Math_fround(f1);
 nullFunc_ff(137);
 return Math_fround(0);
}

function _towupper_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _towupper(i1) | 0;
}

function _towlower_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _towlower(i1) | 0;
}

function _strerror_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strerror(i1) | 0;
}

function _setmntent(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _fopen(i1, i2) | 0;
}

function _mblen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _mbtowc(0, i1, i2) | 0;
}

function _isxdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isxdigit(i1) | 0;
}

function _iswupper_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswupper(i1) | 0;
}

function _iswspace_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswspace(i1) | 0;
}

function _iswpunct_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswpunct(i1) | 0;
}

function _iswprint_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswprint(i1) | 0;
}

function _iswlower_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswlower(i1) | 0;
}

function _iswgraph_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswgraph(i1) | 0;
}

function _iswdigit_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswdigit(i1) | 0;
}

function _iswcntrl_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswcntrl(i1) | 0;
}

function _iswblank_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswblank(i1) | 0;
}

function _iswalpha_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswalpha(i1) | 0;
}

function _iswalnum_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iswalnum(i1) | 0;
}

function _glValidateProgram__wrapper(i1) {
 i1 = i1 | 0;
 _glValidateProgram(i1 | 0);
}

function _glBindVertexArray__wrapper(i1) {
 i1 = i1 | 0;
 _glBindVertexArray(i1 | 0);
}

function __ZThn8_N5physx2Sc23ElementActorInteractionD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__214codecvt_bynameIcc11__mbstate_tED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__210moneypunctIwLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210moneypunctIwLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210moneypunctIcLb1EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210moneypunctIcLb0EED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt3__214__codecvt_utf8IwE11do_encodingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9GfxDevice26ShouldJobsSyncAtEndOfFrameEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK9GfxDevice26HasActiveRandomWriteTargetEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9GfxDevice14GetWorldMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 3420 | 0;
}

function __ZNK6b2Draw8GetFlagsEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __ZNK5physx22PxVehicleWheelsDynData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16PxBroadPhaseBase12getNbRegionsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx12NpBatchQuery7getDescEv(i1) {
 i1 = i1 | 0;
 return i1 + 44 | 0;
}

function __ZNK5Umbra18ReceiverMaskBuffer9getHeightEv(i1) {
 i1 = i1 | 0;
 return 128;
}

function __ZNK23iPhoneLocalNotification11GetUserInfoEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK23iPhoneLocalNotification11GetTimeZoneEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK21DownloadHandlerScript13GetMemorySizeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK19TouchPhaseEmulation15GetMousePresentEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK18PlatformEffector2D16UseContactUpdateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK18BuoyancyEffector2D16UseContactUpdateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK17PolygonCollider2D7GetPolyEv(i1) {
 i1 = i1 | 0;
 return i1 + 160 | 0;
}

function __ZNK14PreloadManager19GetTimeSliceTimeoutEv(i1) {
 i1 = i1 | 0;
 return 10;
}

function __ZNK14CompletionTask7getNameEv(i1) {
 i1 = i1 | 0;
 return gb + 662548 | 0;
}

function __ZNK13ScreenManager21IsMultiDisplayEnabledEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN6Avatar8GetAssetEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 56 >> 2] | 0;
}

function __ZN5physx7NpCloth25sendPvdCollisionTrianglesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd10SocketImplD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx17SapUpdateWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx17PxsCCDAdvanceTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx17AggregateAABBTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13PxHitCallbackINS_10PxSweepHitEED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4MeshD0Ev(i1) {
 i1 = i1 | 0;
 __ZN4MeshD2Ev(i1);
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD6SoundI8seekDataEj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN23b2EdgeAndPolygonContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23b2EdgeAndCapsuleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23b2ChainAndCircleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23UnityPurchasingSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23SweepBoxMeshHitCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23SharedMeshRenderingDataD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23RaycastCallbackNonAllocD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23RayMeshColliderCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23PxsCMDiscreteUpdateTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23OverlapCallbackNonAllocD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23ControllerContactFilterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN22ParticleSystemRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22NavMeshProjectSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21BillboardBatchManager3GetEv() {
 return HEAP32[gb + 1159948 >> 2] | 0;
}

function __ZN20IntermediateRenderer17UnsharePropertiesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15dtPathQueryInfoC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN14ParticleSystem23OnGeometryJobsScheduledEj(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE5CheckEv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z52Graphics_CUSTOM_Internal_GetMaxDrawMeshInstanceCountv() {
 return 1023;
}

function __Z40DynamicGI_Get_Custom_PropUpdateThresholdv() {
 return Math_fround(0.0);
}

function __Z31Input_Get_Custom_PropTouchCountv() {
 return __Z13GetTouchCountv() | 0;
}

function __Z30Shader_CUSTOM_WarmupAllShadersv() {
 __Z16WarmupAllShadersv();
 return;
}

function __Z27LocationService_CUSTOM_StopP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return;
}

function __Z21GetCrashReportManagerv() {
 return __Z21GetManagerFromContexti(23) | 0;
}

function __Z21CalculateNumberOfJobsRK15UpdateCrowdInfo(i1) {
 i1 = i1 | 0;
 return 1;
}

function _wcscoll(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _wcscmp(i1, i2) | 0;
}

function _strcoll(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strcmp(i1, i2) | 0;
}

function _start_output_pass(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 136 >> 2] = 0;
 return;
}

function _rindex(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strrchr(i1, i2) | 0;
}

function _remainderl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_remainder(d1, d2));
}

function _nexttoward(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_nextafter(d1, d2));
}

function _nextafterl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_nextafter(d1, d2));
}

function _lrintf(f1) {
 f1 = Math_fround(f1);
 return ~~Math_fround(_rintf(f1)) | 0;
}

function _glIsEnabled__wrapper(i1) {
 i1 = i1 | 0;
 return _glIsEnabled(i1 | 0) | 0;
}

function _glGetString__wrapper(i1) {
 i1 = i1 | 0;
 return _glGetString(i1 | 0) | 0;
}

function _cf2_arrstack_clear(i1) {
 i1 = i1 | 0;
 HEAP32[i1 + 20 >> 2] = 0;
 return;
}

function __ZNSt20bad_array_new_lengthD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt13bad_exception4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085504 | 0;
}

function __ZNK9GfxDevice13GetViewMatrixEv(i1) {
 i1 = i1 | 0;
 return i1 + 1828 | 0;
}

function __ZNK6Shader18GetScriptClassNameEv(i1) {
 i1 = i1 | 0;
 return i1 + 44 | 0;
}

function __ZNK5physx21PxVehicleDriveSimData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx21PxVehicleDriveDynData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5Umbra18ReceiverMaskBuffer8getWidthEv(i1) {
 i1 = i1 | 0;
 return 128;
}

function __ZNK2UI13RectTransform17GetDrivenByObjectEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK26DownloadHandlerAssetBundle8GetBytesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK17SurfaceEffector2D16UseContactUpdateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK15PointEffector2D18DesignedForTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13WebCamTexture20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13SparseTexture20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13ScreenManager6GetDPIEv(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __ZNK13RenderTexture20GetStorageMemorySizeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx7NpCloth24sendPvdMotionConstraintsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth24sendPvdCollisionCapsulesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv() {
 return gb + 400 | 0;
}

function __ZN5physx3Cct12SweptCapsuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn13XmlNodeWriterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxsSolverEndTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxsParticleShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxVehicleNoDriveD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxVehicleDriveNWD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxVehicleDrive4WD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx16PxParticleSystemD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4FMOD4DSPI9setBypassEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN4FMOD4DSPI9setActiveEb(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22b2EdgeAndCircleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN22ScAfterIntegrationTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN22MemoryCacherReadBlocksD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN22LocalFileSystemHandlerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN21WorldParticleCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21LightProbeProxyVolume15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21AudioDistortionFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20UnityConnectSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19LowerResBlitTexture17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17ArchiveFileSystem4NameEv(i1) {
 i1 = i1 | 0;
 return gb + 489546 | 0;
}

function __ZN14AssetReferenceC2Ev(i1) {
 i1 = i1 | 0;
 HEAP32[i1 >> 2] = 0;
 return;
}

function __ZN13UploadHandler23OnUnbindScriptingObjectEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11WindManager11GetInstanceEv() {
 return HEAP32[gb + 1170608 >> 2] | 0;
}

function __ZN10builtintex12GetBlackCubeEv() {
 return HEAP32[gb + 1158180 >> 2] | 0;
}

function __ZN10AudioMixer26OnEditingInPlayModeChangedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10AtomicList3TagEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function __Z8heapFreePvS_(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _free(i2);
 return;
}

function __Z40Input_Set_Custom_PropBackButtonLeavesApph(i1) {
 i1 = i1 | 0;
 return;
}

function __Z40DynamicGI_Set_Custom_PropSynchronousModeh(i1) {
 i1 = i1 | 0;
 return;
}

function __Z26GetMeshVertexFormatManagerv() {
 return HEAP32[gb + 1161716 >> 2] | 0;
}

function __Z26GetManagedAttributeManagerv() {
 return HEAP32[gb + 1165824 >> 2] | 0;
}

function __Z21GetDelayedCallManagerv() {
 return __Z21GetManagerFromContexti(8) | 0;
}

function __Z20GetPhysics2DSettingsv() {
 return __Z21GetManagerFromContexti(16) | 0;
}

function __Z18GetScriptMapperPtrv() {
 return __Z24GetManagerPtrFromContexti(4) | 0;
}

function __Z18GetInputManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(1) | 0;
}

function __Z18GetAudioManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(3) | 0;
}

function __Z17HasFrameToPresentv() {
 return (HEAP8[gb + 452441 >> 0] | 0) != 0 | 0;
}

function __Z15JobQueueCreatedv() {
 return (HEAP32[gb + 1162216 >> 2] | 0) != 0 | 0;
}

function __Z14StringToUInt32PKc(i1) {
 i1 = i1 | 0;
 return _strtoul(i1, 0, 10) | 0;
}

function __Z13GetGISettingsv() {
 return (__Z19GetLightmapSettingsv() | 0) + 76 | 0;
}

function _wctrans_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _wctrans(i1) | 0;
}

function _wcswcs(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _wcsstr(i1, i2) | 0;
}

function _unity_z_zcfree(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _free(i2);
 return;
}

function _toupper_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _toupper(i1) | 0;
}

function _tolower_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _tolower(i1) | 0;
}

function _setlocale(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return gb + 1073765 | 0;
}

function _scalblnl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbln(d1, i2));
}

function _posix_close(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _close(i1) | 0;
}

function _iswupper(i1) {
 i1 = i1 | 0;
 return (_towlower(i1) | 0) != (i1 | 0) | 0;
}

function _isupper_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isupper(i1) | 0;
}

function _isspace_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isspace(i1) | 0;
}

function _ispunct_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _ispunct(i1) | 0;
}

function _isprint_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isprint(i1) | 0;
}

function _islower_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _islower(i1) | 0;
}

function _isgraph_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isgraph(i1) | 0;
}

function _iscntrl_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _iscntrl(i1) | 0;
}

function _isblank_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isblank(i1) | 0;
}

function _isalpha_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isalpha(i1) | 0;
}

function _isalpha(i1) {
 i1 = i1 | 0;
 return ((i1 | 32) + -97 | 0) >>> 0 < 26 | 0;
}

function _isalnum_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _isalnum(i1) | 0;
}

function _glGenerateMipmap__wrapper(i1) {
 i1 = i1 | 0;
 _glGenerateMipmap(i1 | 0);
}

function _glClearDepthf__wrapper(f1) {
 f1 = Math_fround(f1);
 _glClearDepthf(+f1);
}

function __ZThn8_N5physx2Sc21ElementSimInteractionD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK7Texture26CanReuploadDataToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx20PxVehicleChassisData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx20PxVehicleAutoBoxData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK24iPhoneRemoteNotification9HasActionEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14AreaEffector2D18DesignedForTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN8Material28ApplyMaterialPropertyDrawersEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8GUIStyle14GetClipTextureEv() {
 return HEAP32[gb + 1468868 >> 2] | 0;
}

function __ZN6Shader16GetDefaultOrNullEv() {
 return HEAP32[gb + 1166240 >> 2] | 0;
}

function __ZN5physx8debugger4comm15EventSerializerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth23sendPvdVirtualParticlesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth23sendPvdSimplePropertiesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7NpCloth23sendPvdCollisionSpheresEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Cct11SweptVolumeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Cm12RefCountableD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx18PxGetAssertHandlerEv() {
 return HEAP32[gb + 151084 >> 2] | 0;
}

function __ZN5physx15PxsCCDSweepTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx15PxVehicleWheelsD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx15PxParticleFluidD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx15PxBoxControllerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx12NpBatchQuery17checkForSPUErrorsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity14CharacterJoint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra15SystemAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4crnd10crnd_traceEPKcPi(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN30RuntimeInitializeOnLoadManager6UpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21VertexDeclarationGLESD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN21SweepCallbackNonAllocD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN21PxsParallelSolverTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN21OverlapCapsuleQuery2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN21BoxTraceSegmentReportD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN20OcclusionCullingData15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16MemoryFileSystem4NameEv(i1) {
 i1 = i1 | 0;
 return gb + 492269 | 0;
}

function __ZN13GfxDeviceGLES22AcquireThreadOwnershipEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11GameManager24NetworkOnApplicationQuitEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo13GetDeviceNameEv() {
 return HEAP32[gb + 64908 >> 2] | 0;
}

function __Z38DynamicGI_Get_Custom_PropIndirectScalev() {
 return Math_fround(0.0);
}

function __Z37AndroidJNI_CUSTOM_EnsureLocalCapacityi(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z25GetUncheckedRealGfxDevicev() {
 return HEAP32[gb + 1157628 >> 2] | 0;
}

function __Z25GetRenderBufferManagerPtrv() {
 return HEAP32[gb + 1158348 >> 2] | 0;
}

function __Z25GetBuiltinResourceManagerv() {
 return HEAP32[gb + 1162852 >> 2] | 0;
}

function __Z23AndroidJNI_CUSTOM_Throw13Il2Cpp_IntPtr(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z19GetLightmapSettingsv() {
 return __Z21GetManagerFromContexti(26) | 0;
}

function __Z17GetMonoManagerPtrv() {
 return __Z24GetManagerPtrFromContexti(5) | 0;
}

function __Z11BeginJobSetR8JobFencei(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function _UNITY_png_get_header_version(i1) {
 i1 = i1 | 0;
 return gb + 350660 | 0;
}

function b26(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 nullFunc_dii(26);
 return 0.0;
}

function b12(i1, d2, d3) {
 i1 = i1 | 0;
 d2 = +d2;
 d3 = +d3;
 nullFunc_vidd(12);
}

function _tgammaf(f1) {
 f1 = Math_fround(f1);
 return Math_fround(+_tgamma(+f1));
}

function _putwc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _fputwc(i1, i2) | 0;
}

function _jpeg_destroy_decompress(i1) {
 i1 = i1 | 0;
 _jpeg_destroy(i1);
 return;
}

function _index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _strchr(i1, i2) | 0;
}

function _emscripten_glGetError__wrapper() {
 return _emscripten_glGetError() | 0;
}

function _copysignl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_copysign(d1, d2));
}

function _cf2_hintmask_isValid(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 4 >> 0] | 0;
}

function __ZThn4_NK5physx5cloth8SwSolver8hasErrorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNSt3__214error_categoryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__214__shared_countD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK5physx2Sc5Scene9getLimitsEv(i1) {
 i1 = i1 | 0;
 return i1 + 16 | 0;
}

function __ZNK5physx19PxVehicleEngineData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx19PxVehicleClutchData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx12NpConstraint13isSubordinateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK23iPhoneLocalNotification9HasActionEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK19LowerResBlitTexture12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK15PointEffector2D16UseContactUpdateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK14PreloadManager17GetThreadPriorityEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK14DirectorPlayer17GetTimeUpdateModeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK12BaseRenderer19GetStaticBatchIndexEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK10SampleClip11GetResourceEv(i1) {
 i1 = i1 | 0;
 return i1 + 72 | 0;
}

function __ZN5physx8debugger19PvdNetworkOutStreamD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx8debugger19PropertyDescriptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd10ThreadImpl19getDefaultStackSizeEv() {
 return 2097152;
}

function __ZN5physx28PxPlaneGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx14SingleAABBTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx14PxVehicleDriveD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx14PxTriangleMeshD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx14PxRigidDynamicD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx14PxLightCpuTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5Unity9Component20WillDestroyComponentEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra14MemInputStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4crnd10crnd_traceEPKcz(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN20SweepCapsuleCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN20PxsAtomIntegrateTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN20OverlapCircleQuery2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN20ExternalForcesModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN19MeshParticleEmitter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19CharacterController15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19BaseConnectSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19AudioHighPassFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19AssetBundleManifest15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AsyncUploadManager16TimeSlicedUpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AnimatorController16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshObstacle19OnNavMeshInitializeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13WebCamTexture21HandleCaptureRequestsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13ScreenManager21OnWindowRegainedFocusEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13AnimationClip21UpdateMuscleClipRangeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z48TerrainData_CUSTOM_Internal_GetMaximumResolutionv() {
 return 34816;
}

function __Z38Input_Set_Custom_PropCompensateSensorsh(i1) {
 i1 = i1 | 0;
 return;
}

function __Z35Input_CUSTOM_mainGyroIndex_Internalv() {
 return __Z7GetGyrov() | 0;
}

function __Z24GetFixedBehaviourManagerv() {
 return HEAP32[gb + 1155108 >> 2] | 0;
}

function __Z24GetExecutionRestrictionsv() {
 return HEAP32[gb + 1104728 >> 2] | 0;
}

function __Z24GetExecutionOrderManagerv() {
 return HEAP32[gb + 1163032 >> 2] | 0;
}

function __Z21GetGyroUpdateIntervali(i1) {
 i1 = i1 | 0;
 return Math_fround(0.0);
}

function __Z19GetScriptingManagerv() {
 return __Z21GetManagerFromContexti(5) | 0;
}

function __Z19GetGraphicsSettingsv() {
 return __Z21GetManagerFromContexti(6) | 0;
}

function __Z18GetUnityAdsManagerv() {
 return __Z21GetManagerFromContexti(17) | 0;
}

function __Z18GetResourceManagerv() {
 return __Z21GetManagerFromContexti(12) | 0;
}

function __Z18GetQualitySettingsv() {
 return __Z21GetManagerFromContexti(11) | 0;
}

function __Z18GetNavMeshSettingsv() {
 return __Z21GetManagerFromContexti(27) | 0;
}

function __Z15gpu_time_samplev() {
 __ZN11GPUProfiler13GPUTimeSampleEv();
 return;
}

function _UNITY_FT_Stream_Pos(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] | 0;
}

function _Current_Ppem(i1) {
 i1 = i1 | 0;
 return HEAPU16[i1 + 252 >> 1] | 0 | 0;
}

function _wctype_l(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _wctype(i1) | 0;
}

function _scalbnl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbn(d1, i2));
}

function _scalbln(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbn(d1, i2));
}

function _lgammal(d1) {
 d1 = +d1;
 return +(+___lgamma_r(d1, gb + 1469516 | 0));
}

function _ldexpl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbnl(d1, i2));
}

function _glDeleteProgram__wrapper(i1) {
 i1 = i1 | 0;
 _glDeleteProgram(i1 | 0);
}

function _glCompileShader__wrapper(i1) {
 i1 = i1 | 0;
 _glCompileShader(i1 | 0);
}

function _glBlendEquation__wrapper(i1) {
 i1 = i1 | 0;
 _glBlendEquation(i1 | 0);
}

function _glActiveTexture__wrapper(i1) {
 i1 = i1 | 0;
 _glActiveTexture(i1 | 0);
}

function _ft_alloc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return _malloc(i2) | 0;
}

function _cfgetospeed(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] & 4111 | 0;
}

function _cfgetispeed(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 8 >> 2] & 4111 | 0;
}

function _cf2_arrstack_size(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 20 >> 2] | 0;
}

function __ZNSt3__221__undeclare_reachableEPv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNKSt10bad_typeid4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085728 | 0;
}

function __ZNK6Object25GetNeedsPerObjectTypeTreeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK6Camera25GetRenderImmediateObjectsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx18PxVehicleWheelData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx18PxVehicleGraphDesc7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx18PxVehicleGearsData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx18PxVehicleDriveTank7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx18NpArticulationLink7getTypeEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNK5Umbra15OcclusionBuffer9getHeightEv(i1) {
 i1 = i1 | 0;
 return 64;
}

function __ZNK20BufferedSocketStream10IsBlockingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK15TerrainCollider15SupportsTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14AreaEffector2D16UseContactUpdateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13ScreenManager16GetScreenTimeoutEv(i1) {
 i1 = i1 | 0;
 return -1;
}

function __ZNK12b2MouseJoint9GetTargetEv(i1) {
 i1 = i1 | 0;
 return i1 + 76 | 0;
}

function __ZNK11GameManager19ShouldWriteForBuildEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK10__cxxabiv116__shim_type_info5noop2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK10__cxxabiv116__shim_type_info5noop1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice23CreateGPUSkinPoseBufferEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx9NpPhysics17getVisualDebuggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx5cloth5arrayERKNS_6PxVec3E(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx13PxsCCDContext14verifyCCDBeginEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx13PxRigidStaticD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13PxHeightFieldD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13PxClothFabricD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx13ActorAABBTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN26PlayerSettingsSplashScreen8SetDirtyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26AnimatorControllerPlayable6MemoryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23iPhoneLocalNotification10PresentNowEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19OverlapPointQuery2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN19GCProfilerCallbacksL12OnGCShutdownEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19BaseConnectSettingsD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18SpeedTreeWindAsset15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial15RebuildTexturesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18PlatformEffector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18DelayedCallManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18BuoyancyEffector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AudioMixerSnapshot15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AudioLowPassFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18AnimatorController15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17MemoryCacheWriter12GetCacheSizeEv(i1) {
 i1 = i1 | 0;
 return 256;
}

function __ZN17MemoryCacheReader12GetCacheSizeEv(i1) {
 i1 = i1 | 0;
 return 256;
}

function __ZN16ReflectionProbes28GetMaxBakedCubemapResolutionEv() {
 return 2048;
}

function __ZN16BaseVideoTexture17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10GameObject21GetIsStaticDeprecatedEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN10AtomicList4PeekEv(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __Z53GIDebugVisualisation_CUSTOM_ResetRuntimeInputTexturesv() {
 return;
}

function __Z51LightmapSettings_Get_Custom_PropLightmapsModeLegacyv() {
 return 0;
}

function __Z37AndroidJNIHelper_Set_Custom_PropDebugh(i1) {
 i1 = i1 | 0;
 return;
}

function __Z25SplashScreen_CUSTOM_Beginv() {
 __Z17BeginSplashScreenv();
 return;
}

function __Z24scripting_thread_currentv() {
 return _il2cpp_thread_current() | 0;
}

function __Z23GetPersistentManagerPtrv() {
 return HEAP32[gb + 1166040 >> 2] | 0;
}

function __Z23GetLateBehaviourManagerv() {
 return HEAP32[gb + 1155112 >> 2] | 0;
}

function __Z23GetHardwareInfoReporterv() {
 return HEAP32[gb + 1468944 >> 2] | 0;
}

function __Z21ExecuteOneJobQueueJobv() {
 __Z15JobQueueCreatedv() | 0;
 return 0;
}

function __Z20FinishUnquantizeBC6Hi(i1) {
 i1 = i1 | 0;
 return i1 * 31 >> 6 | 0;
}

function __Z17MainLoopKeepalivePv(i1) {
 i1 = i1 | 0;
 __ZL8MainLoopv();
 return;
}

function __Z17GetRenderSettingsv() {
 return __Z21GetManagerFromContexti(25) | 0;
}

function __Z14IsWorldPlayingv() {
 return (HEAP8[gb + 370093 >> 0] | 0) != 0 | 0;
}

function b96(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 nullFunc_iii(96);
 return 0;
}

function b142(f1, i2) {
 f1 = Math_fround(f1);
 i2 = i2 | 0;
 nullFunc_vfi(142);
}

function _lgamma(d1) {
 d1 = +d1;
 return +(+___lgamma_r(d1, gb + 1469516 | 0));
}

function _labs(i1) {
 i1 = i1 | 0;
 return ((i1 | 0) > 0 ? i1 : 0 - i1 | 0) | 0;
}

function _jpeg_destroy_compress(i1) {
 i1 = i1 | 0;
 _jpeg_destroy(i1);
 return;
}

function _cf2_hintmask_isNew(i1) {
 i1 = i1 | 0;
 return HEAP8[i1 + 5 >> 0] | 0;
}

function ___nl_langinfo(i1) {
 i1 = i1 | 0;
 return ___nl_langinfo_l(i1, 0) | 0;
}

function __ZThn8_N5physx2Sc18TriggerInteractionD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__220__vector_base_commonILb1EEC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__212bad_weak_ptrD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__212__do_messageD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt16bad_array_lengthD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK9GfxDevice21GetDefaultHDRRTFormatEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK5physx17PxVehicleTireData7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5Umbra15OcclusionBuffer8getWidthEv(i1) {
 i1 = i1 | 0;
 return 64;
}

function __ZNK21DownloadHandlerScript9GetLengthEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK17ProceduralTexture12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK15DownloadHandler14HasPendingDataEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK14PreloadManager15IsThreadRunningEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13WheelCollider16SupportsMaterialEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13TargetJoint2D16UseConnectedBodyEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13GfxDeviceNull16IsScissorEnabledEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13BaseAllocator16IsDelayedReleaseEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx7NpCloth20sendPvdRestPositionsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd10ThreadImpl5yieldEv() {
 _sched_yield() | 0;
 return;
}

function __ZN5physx5cloth5arrayERNS_6PxVec3E(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx26PxPhysicsInsertionCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx26PxControllerFilterCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx12PxConvexMeshD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx11RTreeCooker13RemapCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity11SpringJoint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra12OutputStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN4Tree26CalculateSupportedMessagesEv(i1) {
 i1 = i1 | 0;
 return 16;
}

function __ZN2UI14CanvasRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN22LocalFileSystemHandler9LastErrorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN19TransportJavaScript11PostRequestEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN19SkinnedMeshRenderer13DidModifyMeshEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19LowerResBlitTexture13ApplySettingsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ScreenManagerWebGLD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18ScBeforeSolverTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18ProceduralMaterial14StopProcessingEb(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18PhysxJobDispatcherD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18IDCollectorFunctorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN18BaseUnityAnalyticsD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17SurfaceEffector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17ProceduralTexture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17PolygonCollider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17PhysicsMaterial2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17Physics2DSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17GlobalGameManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17CapsuleCollider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17BillboardRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17AudioReverbFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17AudioChorusFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16PlayerConnection3GetEv() {
 return HEAP32[gb + 1163120 >> 2] | 0;
}

function __ZN16LightmapSettings16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15TerrainRenderer17ReloadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12_GLOBAL__N_112RenderReaderILb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL11term_sourceP22jpeg_decompress_struct(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL11init_sourceP22jpeg_decompress_struct(i1) {
 i1 = i1 | 0;
 return;
}

function __Z50Profiler_Get_Custom_PropMaxNumberOfSamplesPerFramev() {
 return 0;
}

function __Z50GIDebugVisualisation_Get_Custom_PropPauseCycleModev() {
 return 0;
}

function __Z36RenderTexture_Set_Custom_PropEnabledh(i1) {
 i1 = i1 | 0;
 return;
}

function __Z23PlayerPrefs_CUSTOM_Savev() {
 __ZN11PlayerPrefs4SyncEv();
 return;
}

function __Z22GetShaderCachePathGLESv() {
 return HEAP32[gb + 1451144 >> 2] | 0;
}

function __Z22GetRenderBufferManagerv() {
 return HEAP32[gb + 1158348 >> 2] | 0;
}

function __Z22GetMemoryProfilerStatsv() {
 return HEAP32[gb + 1163248 >> 2] | 0;
}

function __Z22GetMainThreadGfxDevicev() {
 return HEAP32[gb + 1157628 >> 2] | 0;
}

function __Z22GetDeveloperConsolePtrv() {
 return HEAP32[gb + 1468316 >> 2] | 0;
}

function __Z19GetMaxBytesPerPixel13TextureFormat(i1) {
 i1 = i1 | 0;
 return 16;
}

function __Z17GetPlayerSettingsv() {
 return __Z21GetManagerFromContexti(0) | 0;
}

function __Z17GetPhysicsManagerv() {
 return __Z21GetManagerFromContexti(9) | 0;
}

function __Z16GetBuildSettingsv() {
 return __Z21GetManagerFromContexti(10) | 0;
}

function __Z11IsGfxDevicev() {
 return (HEAP32[gb + 1157628 >> 2] | 0) != 0 | 0;
}

function _tt_cmap14_char_index(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _malloc_max_footprint() {
 return HEAP32[gb + 1470404 + 436 >> 2] | 0;
}

function _ldexp(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_scalbn(d1, i2));
}

function _glDeleteShader__wrapper(i1) {
 i1 = i1 | 0;
 _glDeleteShader(i1 | 0);
}

function _glClearStencil__wrapper(i1) {
 i1 = i1 | 0;
 _glClearStencil(i1 | 0);
}

function _frexpl(d1, i2) {
 d1 = +d1;
 i2 = i2 | 0;
 return +(+_frexp(d1, i2));
}

function _emscripten_glLoadIdentity__wrapper() {
 _emscripten_glLoadIdentity();
}

function _cimagf(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 + 4 >> 2]);
}

function _cf2_getSubfont(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 736 >> 2] | 0;
}

function __ZThn24_N5physx2Sc16ActorInteractionD1Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__26locale5facetD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt9exception4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085489 | 0;
}

function __ZNKSt9bad_alloc4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085377 | 0;
}

function __ZNK5physx16PxsBroadPhaseMBP7getTypeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16PxVehicleNoDrive7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16PxVehicleDriveNW7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16PxVehicleDrive4W7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx16NpParticleSystem7getTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK24RingBufferMemoryFileData5CloneEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK21DownloadHandlerScript8GetBytesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK16BaseVideoTexture12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZN9Transform23UpdateAllChildrenOrdersEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice23ClearRandomWriteTargetsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Material10GetDefaultEv() {
 return HEAP32[gb + 1166352 >> 2] | 0;
}

function __ZN7Texture13GetAnisoLimitEv() {
 return HEAP32[gb + 55816 >> 2] | 0;
}

function __ZN6Object7SetNameEPKc(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __ZN5physx8debugger16ClassDescriptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7Cooking9getParamsEv(i1) {
 i1 = i1 | 0;
 return i1 + 4 | 0;
}

function __ZN5physx6shdfnd10ThreadImpl5getIdEv() {
 return _pthread_self() | 0;
}

function __ZN5physx3Ext21InertiaTensorComputerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Cct8SweptBoxD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Sn9XmlParserD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu9RadixSortD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx2Gu25GetGeomOverlapMethodTableEv() {
 return gb + 90332 | 0;
}

function __ZN5physx25PxLockedDataGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx24PxsParticleSystemBatcher17registerParticlesEv() {
 return;
}

function __ZN5Unity10HingeJoint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity10FixedJoint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2UI16GetCanvasManagerEv() {
 return HEAP32[gb + 1467948 >> 2] | 0;
}

function __ZN2UI13RectTransform15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24iPhoneRemoteNotification8RegisterEi(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial27GetProceduralProcessorUsageEv() {
 return 0;
}

function __ZN17b2ContactListenerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17OverlapBoxQuery2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN17GlobalGameManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16ReflectionProbes28GetMinBakedCubemapResolutionEv() {
 return 16;
}

function __ZN16ParticleAnimator15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16LevelGameManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16GraphicsSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16CircleCollider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15UnityAdsManager16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshObstacle16OnNavMeshCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15DirectorManager14ConnectionPoolD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ApplicationInfo14GetSandboxTypeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN15ApplicationInfo14GetInstallModeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN14PhysicsManager17RefreshWhenPausedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14MemoryProfiler17ShrinkMemoryUsageEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14DirectorPlayer17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14DLHAudioHelper17UnlockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull16CreateTimerQueryEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN12HandlerChain4NameEv(i1) {
 i1 = i1 | 0;
 return gb + 491454 | 0;
}

function __ZN11UnityEngine15PlatformWrapper17IsUnityAdsEnabledEv() {
 return 0;
}

function __ZN11UnityEngine15PlatformWrapper17IsInternetAllowedEv() {
 return 1;
}

function __Z33__audio_mainthread_check_internalPKc(i1) {
 i1 = i1 | 0;
 return;
}

function __Z23GetInvalidFilenameCharsv() {
 return HEAP32[gb + 70304 >> 2] | 0;
}

function __Z21GetUncheckedGfxDevicev() {
 return HEAP32[gb + 1157628 >> 2] | 0;
}

function __Z21GetLODGroupManagerPtrv() {
 return HEAP32[gb + 1161200 >> 2] | 0;
}

function __Z21GetAsyncUploadManagerv() {
 return HEAP32[gb + 1157732 >> 2] | 0;
}

function __Z21GetAssetBundleManagerv() {
 return HEAP32[gb + 1104056 >> 2] | 0;
}

function __Z17AsyncReadWaitDoneP16AsyncReadCommand(i1) {
 i1 = i1 | 0;
 return;
}

function __Z12IsFirstFramev() {
 return (HEAP8[gb + 452440 >> 0] | 0) != 0 | 0;
}

function __Z11IsBatchmodev() {
 return (HEAP8[gb + 1546618 >> 0] | 0) != 0 | 0;
}

function _UNITY_png_get_libpng_ver(i1) {
 i1 = i1 | 0;
 return gb + 402099 | 0;
}

function _UNITY_png_get_header_ver(i1) {
 i1 = i1 | 0;
 return gb + 402099 | 0;
}

function _UNITY_LZ4_freeStreamDecode(i1) {
 i1 = i1 | 0;
 _free(i1);
 return 0;
}

function _UNITY_FT_CeilFix(i1) {
 i1 = i1 | 0;
 return i1 + 65535 & -65536 | 0;
}

function b69(i1, f2) {
 i1 = i1 | 0;
 f2 = Math_fround(f2);
 nullFunc_vif(69);
}

function _pshinter_get_globals_funcs(i1) {
 i1 = i1 | 0;
 return i1 + 100 | 0;
}

function _jpeg_abort_decompress(i1) {
 i1 = i1 | 0;
 _jpeg_abort(i1);
 return;
}

function __ZdlPvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZdlPv(i1);
 return;
}

function __ZdaPvj(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 __ZdaPv(i1);
 return;
}

function __ZNSt3__28messagesIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__28messagesIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNKSt8bad_cast4whatEv(i1) {
 i1 = i1 | 0;
 return gb + 1085702 | 0;
}

function __ZNKSt3__213random_device7entropyEv(i1) {
 i1 = i1 | 0;
 return 0.0;
}

function __ZNK9Animation21SetTransformsSetDirtyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK7Texture21GetShadowSamplingModeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK5physx15PxVehicleWheels7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx15NpParticleFluid7getTypeEv(i1) {
 i1 = i1 | 0;
 return 3;
}

function __ZNK14b2PolygonShape13GetChildCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK14b2CapsuleShape13GetChildCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13ScreenManager14IsStereoscopicEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK10GameObject17IsStaticBatchableEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9GfxDevice22ReleaseThreadOwnershipEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice22AcquireThreadOwnershipEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice20TimerQueriesIsActiveEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx2Sc21ElementSimInteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc21ArticulationJointCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Cm10FanoutTask11runInternalEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx24PxDeserializationContextD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx10PxMaterialD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx10PxBaseTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx10BPWorkTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN24iPhoneRemoteNotification20GetDeviceTokenLengthEv() {
 return 0;
}

function __ZN23iPhoneLocalNotification8ScheduleEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20IntermediateRenderer10UpdateAABBEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16b2PrismaticJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16b2PolygonContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16b2CapsuleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16RTreeCookerRemapD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16NullVertexBufferD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16NovodexAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16MecanimAnimationD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16LevelGameManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN16ControllerFilterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15UnityAdsManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15UniformTFMethod15UnmapBoneBufferEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15TerrainCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ResourceManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15RelativeJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ReflectionProbe29GetTimeSlicedJobCountPerProbeEv() {
 return 8;
}

function __ZN15ReflectionProbe15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15QualitySettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15PointEffector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ParticleEmitter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15OcclusionPortal15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshObstacle15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LightProbeGroup15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15FrictionJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15EditorExtension15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15DistanceJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ConstantForce2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15CapsuleCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15AudioReverbZone15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15AudioMixerGroup15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15AudioEchoFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15AnchoredJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13SparseTexture17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13RenderTexture17UploadToGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull17BeginTimerQueriesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13EmscriptenWWW17UnlockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10AudioMixer18BuildMixerConstantEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZL17PngWriteFlushFuncP14png_struct_def(i1) {
 i1 = i1 | 0;
 return;
}

function __Z48SystemInfo_Get_Custom_PropSupportsRenderTexturesv() {
 return 1;
}

function __Z32AndroidJNI_CUSTOM_PushLocalFramei(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z20Mesh_CUSTOM_OptimizeP12Il2CppObject(i1) {
 i1 = i1 | 0;
 return;
}

function __Z20LastParsedShaderNamev() {
 return HEAP32[gb + 1166416 >> 2] | 0;
}

function __Z20GetPersistentManagerv() {
 return HEAP32[gb + 1166040 >> 2] | 0;
}

function __Z20GetIdentityTransformv() {
 return HEAP32[gb + 1158204 >> 2] | 0;
}

function __Z20GetGameObjectManagerv() {
 return HEAP32[gb + 1104660 >> 2] | 0;
}

function __Z20GetCommonStringTablev() {
 return HEAP32[gb + 1115292 >> 2] | 0;
}

function __Z15GetScriptMapperv() {
 return __Z21GetManagerFromContexti(4) | 0;
}

function __Z15GetInputManagerv() {
 return __Z21GetManagerFromContexti(1) | 0;
}

function __Z15GetAudioManagerv() {
 return __Z21GetManagerFromContexti(3) | 0;
}

function __Z13shutdown_stubii(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _UNITY_png_get_copyright(i1) {
 i1 = i1 | 0;
 return gb + 350477 | 0;
}

function _setlinebuf(i1) {
 i1 = i1 | 0;
 _setvbuf(i1, 0, 1, 0) | 0;
 return;
}

function _seteuid(i1) {
 i1 = i1 | 0;
 return ___setxid(208, -1, i1, -1) | 0;
}

function _setegid(i1) {
 i1 = i1 | 0;
 return ___setxid(210, -1, i1, -1) | 0;
}

function _iswdigit(i1) {
 i1 = i1 | 0;
 return (i1 + -48 | 0) >>> 0 < 10 | 0;
}

function _glStencilMask__wrapper(i1) {
 i1 = i1 | 0;
 _glStencilMask(i1 | 0);
}

function _glLinkProgram__wrapper(i1) {
 i1 = i1 | 0;
 _glLinkProgram(i1 | 0);
}

function __ZNSt3__27collateIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__27collateIcED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt13bad_exceptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK9Rigidbody18GetUseConeFrictionEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9GfxDevice18GetDefaultRTFormatEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK7Texture20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK7Cubemap20GetTextureLayerCountEv(i1) {
 i1 = i1 | 0;
 return 6;
}

function __ZNK6Object7GetNameEv(i1) {
 i1 = i1 | 0;
 return gb + 1576256 | 0;
}

function __ZNK5physx5cloth8SwSolver8hasErrorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx5cloth11SwClothData6verifyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK5physx2Sc10ClothShape8isActiveEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5physx14PxVehicleDrive7isValidEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx14NpRigidDynamic7getTypeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK14Texture2DArray12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 5;
}

function __ZNK13b2CircleShape13GetChildCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13SpeedTreeWind9GetParamsEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNK13ScreenManager13GetShowCursorEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13ScreenManager13GetLockCursorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK10Effector2D16RequiresColliderEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN9GfxDevice21ResetDynamicResourcesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx8debugger14PvdInputStreamD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd7PAUtils9isEnabledEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx6shdfnd10ThreadImpl7getSizeEv() {
 return gb + 114060 | 0;
}

function __ZN5physx6shdfnd10SocketImpl5flushEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx3Scb5Scene13isUpdatingPvdEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx23PxProcessPxBaseCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx23PxGeometryGeneratedInfoC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity9Component15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4crnd24crnd_output_debug_stringEPKc(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2UI11CanvasGroup15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15b2RevoluteJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15b2FrictionJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15b2DistanceJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15b2ContactFilterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15b2CircleContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15TerrainCollider12GetIsTriggerEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN15RaycastCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15OverlapCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15NullIndexBufferD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15Lz4DecompressorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15ContactFilter2DD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15CacheWriterBaseD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN15CacheReaderBaseD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14SphereCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14RenderSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14PlayerSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14PhysicsManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14PhysicMaterial15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14EdgeCollider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14DirectorPlayer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14DLHAudioHelper15LockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14BillboardAsset15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14AudioBehaviour15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14AreaEffector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull14GetPresentModeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN13GfxDeviceGLES14GetPresentModeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN13BaseAllocator14CheckIntegrityEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN13AnimationClip16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL19InitializeModule_VRv() {
 __Z18InitializeVRModulev();
 return;
}

function __Z49ThreadAndSerializationSafeCheckInitFromMainThreadv() {
 return;
}

function __Z47SystemInfo_Get_Custom_PropGraphicsMultiThreadedv() {
 return 0;
}

function __Z31Scene_CUSTOM_GetIsDirtyInternali(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z19GetScreenManagerPtrv() {
 return HEAP32[gb + 1158216 >> 2] | 0;
}

function __Z19GetRenderManagerPtrv() {
 return HEAP32[gb + 1112268 >> 2] | 0;
}

function __Z19GetReflectionProbesv() {
 return HEAP32[gb + 1112272 >> 2] | 0;
}

function __Z19GetRaycastInterfacev() {
 return HEAP32[gb + 1162156 >> 2] | 0;
}

function __Z19GetIClusterRendererv() {
 return HEAP32[gb + 1162128 >> 2] | 0;
}

function __Z19GetDeveloperConsolev() {
 return HEAP32[gb + 1468316 >> 2] | 0;
}

function __Z19GetBehaviourManagerv() {
 return HEAP32[gb + 1155104 >> 2] | 0;
}

function __Z19GetAnimationManagerv() {
 return HEAP32[gb + 1465160 >> 2] | 0;
}

function __Z17SetupClothManagerv() {
 HEAP32[gb + 1459016 >> 2] = 0;
 return;
}

function __Z14SetGyroEnabledib(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __Z14GetTimeManagerv() {
 return __Z21GetManagerFromContexti(7) | 0;
}

function __Z14GetMonoManagerv() {
 return __Z21GetManagerFromContexti(5) | 0;
}

function _sysconf__wrapper(i1) {
 i1 = i1 | 0;
 return _sysconf(i1 | 0) | 0;
}

function _jpeg_abort_compress(i1) {
 i1 = i1 | 0;
 _jpeg_abort(i1);
 return;
}

function _isupper(i1) {
 i1 = i1 | 0;
 return (i1 + -65 | 0) >>> 0 < 26 | 0;
}

function _isprint(i1) {
 i1 = i1 | 0;
 return (i1 + -32 | 0) >>> 0 < 95 | 0;
}

function _islower(i1) {
 i1 = i1 | 0;
 return (i1 + -97 | 0) >>> 0 < 26 | 0;
}

function _isgraph(i1) {
 i1 = i1 | 0;
 return (i1 + -33 | 0) >>> 0 < 94 | 0;
}

function _isdigit(i1) {
 i1 = i1 | 0;
 return (i1 + -48 | 0) >>> 0 < 10 | 0;
}

function _hypotl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_hypot(d1, d2));
}

function _ft_free(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 _free(i2);
 return;
}

function __ZNK5physx13NpRigidStatic7getTypeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK19ShaderPropertySheet7IsDirtyEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK18DownloadHandlerVFS8GetBytesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK15ParticleEmitter10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13SparseTexture12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK13ScreenManager12GetIsFocusedEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13GfxDeviceNull12GetWireframeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13GfxDeviceGLES12GetWireframeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9GfxDevice18HandleInvalidStateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN9GfxDevice18GetNativeGfxDeviceEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9GfxDevice18CreateVertexBufferEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx6shdfnd7FastXml8CallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu5RTree8Callback7profileEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx22PxSerializationContextD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx22PxDefaultErrorCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx22PxConstraintVisualizerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity9ComponentD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN23iPhoneLocalNotification6CancelEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23iPhoneLocalNotification19GetDefaultSoundNameEv() {
 return 0;
}

function __ZN22UnityWebRequestManager22ScriptsChangedCallbackEv() {
 return;
}

function __ZN22UnityWebRequestManager22InitializationCallbackEv() {
 return;
}

function __ZN21AnimationClipPlayable6MemoryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial10ClearCacheEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15UniformTFMethod13DoneRenderingEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14b2PolygonShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14b2CapsuleShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14VRSplashScreenD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14Raycast2DQueryD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14NullGpuProgramD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14InputInterfaceD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14CompletionTaskD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN14CachingManager17GenerateTimeStampEv() {
 return _time(0) | 0;
}

function __ZN14AsyncOperationD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13WheelCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13TargetJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13SpringJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13SliderJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13OcclusionArea15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull15ReloadResourcesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull15FinishRenderingEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull15EndTimerQueriesEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13EmscriptenWWW15LockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13ConstantForce15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13BuildSettings15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13BoxCollider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13AudioListener15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10__cxxabiv116__shim_type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __Z9IsTestRunv() {
 return (HEAP8[gb + 1546619 >> 0] | 0) != 0 | 0;
}

function __Z33ShouldWarnOnSlowSerializationPathI9JSONWriteEbv() {
 return 0;
}

function __Z18GetLogEntryHandlerv() {
 return HEAP32[gb + 1450788 >> 2] | 0;
}

function __Z18GetLODGroupManagerv() {
 return HEAP32[gb + 1161200 >> 2] | 0;
}

function __Z18GetITerrainPhysicsv() {
 return HEAP32[gb + 1162164 >> 2] | 0;
}

function __Z18GetITerrainManagerv() {
 return HEAP32[gb + 1162160 >> 2] | 0;
}

function __Z18GetIParticleSystemv() {
 return HEAP32[gb + 1162144 >> 2] | 0;
}

function __Z18GetGUIEventManagerv() {
 return HEAP32[gb + 1161936 >> 2] | 0;
}

function __Z18GetDirectorManagerv() {
 return HEAP32[gb + 1188524 >> 2] | 0;
}

function __Z18GetApplicationInfov() {
 return HEAP32[gb + 1103964 >> 2] | 0;
}

function __Z18GetAnimationBinderv() {
 return HEAP32[gb + 1465224 >> 2] | 0;
}

function __Z13GetTagManagerv() {
 return __Z21GetManagerFromContexti(2) | 0;
}

function _wctob(i1) {
 i1 = i1 | 0;
 return (i1 >>> 0 < 128 ? i1 : -1) | 0;
}

function _malloc_footprint() {
 return HEAP32[gb + 1470404 + 432 >> 2] | 0;
}

function _glUseProgram__wrapper(i1) {
 i1 = i1 | 0;
 _glUseProgram(i1 | 0);
}

function _glReadBuffer__wrapper(i1) {
 i1 = i1 | 0;
 _glReadBuffer(i1 | 0);
}

function _glDeleteSync__wrapper(i1) {
 i1 = i1 | 0;
 _glDeleteSync(i1 | 0);
}

function _crealf(i1) {
 i1 = i1 | 0;
 return Math_fround(HEAPF32[i1 >> 2]);
}

function _btowc(i1) {
 i1 = i1 | 0;
 return (i1 >>> 0 < 128 ? i1 : -1) | 0;
}

function ___towrite_needs_stdio_exit() {
 mftCall_v(fb + 456 | 0);
 return;
}

function __ZNSt3__25ctypeIwED0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK6Camera19GetSinglePassStereoEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5Unity9Component10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK5Unity9Component10GetEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK17AnimationPlayable8GetAssetEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK12CubemapArray12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 6;
}

function __ZNK11b2EdgeShape13GetChildCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK10Effector2D14IgnoreContactsEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9GfxDevice19RenderTargetBarrierEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice17CreateIndexBufferEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx6shdfnd9SListImpl7getSizeEv() {
 return gb + 105564 | 0;
}

function __ZN5physx6shdfnd9MutexImpl7getSizeEv() {
 return gb + 101852 | 0;
}

function __ZN5physx2Sn18RecursiveTraversalD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc18TriggerInteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21PxQueryFilterCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21PxProfileNameProviderD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21PxConstraintConnectorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21GuMeshFactoryListenerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4Mesh24UnshareMeshRenderingDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN27GenericSlowGarbageCollectorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN27ConvexVsMeshOverlapCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16SpriteRenderData11UnshareDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16LightmapSettings11UnshareDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15TerrainCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14AsyncOperation11GetPriorityEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN13b2PulleyJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13b2CircleShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13TriggerModuleD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13SweepCallbackD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13ScreenManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13Lz4CompressorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN13GfxDeviceNull14DisableScissorEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull14BeforeDrawCallEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull12IsValidStateEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN13GfxDeviceNull12GetSRGBWriteEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN13BaseAllocatorD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12WheelJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12ScriptMapper15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12NavMeshAgent15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12MeshRenderer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12MeshCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12InputManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12HingeJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12HandlerChain5LinksEv(i1) {
 i1 = i1 | 0;
 return i1 + 4 | 0;
}

function __ZN12FixedJoint2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12AudioManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11UnityEngine15PlatformWrapper13GetUnityAdsIdEv() {
 return 0;
}

function __ZN10FileSystem16StaticInitializeEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z45GIDebugVisualisation_Get_Custom_PropCycleModev() {
 return 0;
}

function __Z45Application_Get_Custom_PropWebSecurityEnabledv() {
 return 0;
}

function __Z33ShouldWarnOnSlowSerializationPathI8JSONReadEbv() {
 return 0;
}

function __Z31ValidateNoSceneObjectsAreLoadedb(i1) {
 i1 = i1 | 0;
 return;
}

function __Z17GetNavMeshManagerv() {
 return HEAP32[gb + 1459032 >> 2] | 0;
}

function _UnityReplayKitSetMicrophoneEnabled(i1) {
 i1 = i1 | 0;
 return 0;
}

function b79(i1) {
 i1 = i1 | 0;
 nullFunc_fi(79);
 return Math_fround(0);
}

function _setuid(i1) {
 i1 = i1 | 0;
 return ___setxid(213, i1, 0, 0) | 0;
}

function _setgid(i1) {
 i1 = i1 | 0;
 return ___setxid(214, i1, 0, 0) | 0;
}

function _fmodl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_fmod(d1, d2));
}

function _fminl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_fmin(d1, d2));
}

function _fmaxl(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_fmax(d1, d2));
}

function _fesetexceptflag(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _fdiml(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 return +(+_fdim(d1, d2));
}

function _cf2_hintmask_getMaskPtr(i1) {
 i1 = i1 | 0;
 return i1 + 16 | 0;
}

function ___toread_needs_stdio_exit() {
 mftCall_v(fb + 456 | 0);
 return;
}

function ___fbufsize(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 48 >> 2] | 0;
}

function __ZNSt10bad_typeidD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNK8Collider16SupportsMaterialEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK15FileSystemEntry4PathEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZNK13TargetJoint2D10SwapBodiesEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13MonoBehaviour10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK13BaseAllocator10IsAssignedEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN9GfxDevice16GetMultiGPUCountEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN8Material19UnshareMaterialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object21AwakeFromLoadThreadedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7PxShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx7PxClothD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd8SyncImpl7getSizeEv() {
 return gb + 101472 | 0;
}

function __ZN5physx2Gu17EPASupportMapPairD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx20BigConvexDataBuilderD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20UnloadSceneOperation7PerformEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19TransportJavaScript8FinalizeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14DirectorPlayer12AddToManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13BaseAllocator13ThreadCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12b2WheelJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12b2MouseJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12b2MotorJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12PhysXRaycastD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12ImageDecoderD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12IFileAdapterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN12BaseRendererD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11TimeManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11TerrainData15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11Rigidbody2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11PreloadData15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11OffMeshLink15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11NavMeshData15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11NamedObject15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11LightProbes15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11GameManager15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11BoxCollider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11AudioSource15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11AudioFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11AssetBundle15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10AudioMixer16OnRuntimeChangedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL28InitializeSparseTexturesGLESPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL14OnWorldStoppedv() {
 __Z16GetMemoryManagerv() | 0;
 return;
}

function __ZL14OnWorldStartedv() {
 __Z16GetMemoryManagerv() | 0;
 return;
}

function __Z44SystemInfo_Get_Custom_PropSupportsInstancingv() {
 return 0;
}

function __Z29GetOcclusionPortalManagerListv() {
 return gb + 1111068 | 0;
}

function __Z20SetThreadedGfxDeviceP9GfxDevice(i1) {
 i1 = i1 | 0;
 return;
}

function __Z18GetTargetFrameRatev() {
 return HEAP32[gb + 64864 >> 2] | 0;
}

function __Z16GetUpdateManagerv() {
 return HEAP32[gb + 1155116 >> 2] | 0;
}

function __Z16GetScreenManagerv() {
 return HEAP32[gb + 1158216 >> 2] | 0;
}

function __Z16GetRendererScenev() {
 return HEAP32[gb + 1112704 >> 2] | 0;
}

function __Z16GetRenderManagerv() {
 return HEAP32[gb + 1112268 >> 2] | 0;
}

function __Z16GetRealGfxDevicev() {
 return HEAP32[gb + 1157628 >> 2] | 0;
}

function __Z16GetGUIManagerPtrv() {
 return HEAP32[gb + 1468156 >> 2] | 0;
}

function __Z16GetDynamicsScenev() {
 return HEAP32[gb + 1457404 >> 2] | 0;
}

function __Z11SetActuatorij(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return;
}

function __GLOBAL__I_000101() {
 __ZNSt3__28ios_base4InitC2Ev(0);
 return;
}

function _pshinter_get_t2_funcs(i1) {
 i1 = i1 | 0;
 return i1 + 140 | 0;
}

function _pshinter_get_t1_funcs(i1) {
 i1 = i1 | 0;
 return i1 + 112 | 0;
}

function _mkstemp(i1) {
 i1 = i1 | 0;
 return ___mkostemps(i1, 0, 0) | 0;
}

function _glFrontFace__wrapper(i1) {
 i1 = i1 | 0;
 _glFrontFace(i1 | 0);
}

function _glEndTransformFeedback__wrapper() {
 _glEndTransformFeedback();
}

function _glDepthMask__wrapper(i1) {
 i1 = i1 | 0;
 _glDepthMask(i1 | 0);
}

function _glDepthFunc__wrapper(i1) {
 i1 = i1 | 0;
 _glDepthFunc(i1 | 0);
}

function _getwchar() {
 return _fgetwc(HEAP32[gb + 191748 >> 2] | 0) | 0;
}

function _ether_ntohost(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function _ether_hostton(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1;
}

function __ZNK9GfxDevice14IsPureThreadedEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9GfxDevice14GetDeviceLevelEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK8Collider15SupportsTriggerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK7Joint2D16UseConnectedBodyEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK15DownloadHandler8GetErrorEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9WWWCached17UnlockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9HaloLayer17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice17CommitVertexDeclsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice15GetNextCPUFenceEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx2Sc5Actor12onDeactivateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc16ArticulationCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc16ActorInteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu19GetRaycastFuncTableEv() {
 return gb + 85964 | 0;
}

function __ZN5physx19PxAllocatorCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity5Joint15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN25ConvexVsMeshSweepCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24iPhoneRemoteNotification15GetEnabledTypesEv() {
 return 0;
}

function __ZN20TextRenderingPrivate8TextMesh12CleanupClassEv() {
 return;
}

function __ZN16PlayerConnection8IsServerEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN14BillboardAsset11UnshareDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13WheelCollider12ScaleChangedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull12PresentFrameEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13GfxDeviceNull12ImmediateEndEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11b2WeldJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11b2RopeJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11b2GearJointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11b2EdgeShapeD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11GameManagerD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN11ErrorStreamD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10SampleClip15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10MonoScript15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10MeshFilter15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10GameObject15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10GUIElement15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10FlareLayer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10Effector2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10Collider2D15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10AudioMixer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z45Playables_CUSTOM_BeginIgnoreAllocationTrackerv() {
 return;
}

function __Z45InitializeSerializationByCodeGenerationThreadv() {
 return;
}

function __Z43GIDebugVisualisation_Get_Custom_PropTexTypev() {
 return 0;
}

function __Z20scripting_get_corlibv() {
 return _il2cpp_get_corlib() | 0;
}

function __Z20scripting_domain_getv() {
 return _il2cpp_domain_get() | 0;
}

function __Z15GetSceneManagerv() {
 return HEAP32[gb + 1164172 >> 2] | 0;
}

function __Z15GetLightManagerv() {
 return HEAP32[gb + 1112264 >> 2] | 0;
}

function __Z15GetIApplicationv() {
 return HEAP32[gb + 1162116 >> 2] | 0;
}

function __Z15GetGraphicsCapsv() {
 return HEAP32[gb + 1166136 >> 2] | 0;
}

function __Z15GetEventManagerv() {
 return HEAP32[gb + 1104268 >> 2] | 0;
}

function __Z15GetAdsIdHandlerv() {
 return HEAP32[gb + 1103884 >> 2] | 0;
}

function _UNITY_LZ4_freeStream(i1) {
 i1 = i1 | 0;
 _free(i1);
 return 0;
}

function b120(f1) {
 f1 = Math_fround(f1);
 nullFunc_if(120);
 return 0;
}

function _ntohs(i1) {
 i1 = i1 | 0;
 return _llvm_bswap_i16(i1 | 0) | 0;
}

function _ntohl(i1) {
 i1 = i1 | 0;
 return _llvm_bswap_i32(i1 | 0) | 0;
}

function _htons(i1) {
 i1 = i1 | 0;
 return _llvm_bswap_i16(i1 | 0) | 0;
}

function _htonl(i1) {
 i1 = i1 | 0;
 return _llvm_bswap_i32(i1 | 0) | 0;
}

function _dgettext(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return i2 | 0;
}

function ___fsetlocking(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function __ZNSt9type_infoD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt9exceptionD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt9bad_allocD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__215messages_bynameIwED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__215messages_bynameIcED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK15Lz4Decompressor7GetTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZN9GfxDevice16WakeRenderThreadEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice16SynchronizeStatsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice14InsertCPUFenceEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9GfxDevice14BeginRecordingEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN8TToArray15CoordinateCountI11QuaternionfEEiv() {
 return 4;
}

function __ZN8GUILayer17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Socket5CloseEi(i1) {
 i1 = i1 | 0;
 return _close(i1) | 0;
}

function __ZN5simdi5arrayER8Scalar4f(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN5physx2Sn15SimpleXmlWriterD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc15CoreInteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu12EntityReportIjED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx18PxVehicleDriveTankD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24iPhoneRemoteNotification14GetDeviceTokenEv() {
 return 0;
}

function __ZN24dtObstacleAvoidanceQueryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24ConvexVsHeightfieldSweepD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24AudioScriptBufferManagerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService23IsHeadingUpdatesEnabledEv() {
 return 0;
}

function __ZN14PlayerSettings10SmartResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13UnityProfiler11EndGPUFrameEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11WindManager7GetListEv(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __ZN11GameManager13NetworkUpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10HumanTrait11RightFinger14GetMuscleCountEv() {
 return 20;
}

function __ZN10GpuProgramD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN10FileSystem13StaticDestroyEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10CastFilterD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZL15GetRendererImplv() {
 return HEAP32[gb + 65704 >> 2] | 0;
}

function __Z41Camera_Get_Custom_PropPreviewCullingLayerv() {
 return 31;
}

function __Z27GetUserAuthorizationManagerv() {
 return gb + 1178912 | 0;
}

function __Z27ConvertSeparatorsToPlatformPc(i1) {
 i1 = i1 | 0;
 return;
}

function __Z14GetPlayerPausev() {
 return HEAP32[gb + 1162856 >> 2] | 0;
}

function __Z14GetHaloManagerv() {
 return HEAP32[gb + 1110376 >> 2] | 0;
}

function __Z14GetDynamicsSDKv() {
 return HEAP32[gb + 1457408 >> 2] | 0;
}

function _UNITY_FT_FloorFix(i1) {
 i1 = i1 | 0;
 return i1 & -65536 | 0;
}

function _glEndQuery__wrapper(i1) {
 i1 = i1 | 0;
 _glEndQuery(i1 | 0);
}

function _glCullFace__wrapper(i1) {
 i1 = i1 | 0;
 _glCullFace(i1 | 0);
}

function _getnetbyaddr(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _getchar() {
 return _fgetc(HEAP32[gb + 191748 >> 2] | 0) | 0;
}

function _catopen(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return -1 | 0;
}

function __ZNSt8bad_castD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZNSt3__210moneypunctIwLb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__210moneypunctIwLb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__210moneypunctIcLb1EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__210moneypunctIcLb0EED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK9Texture3D12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 3;
}

function __ZNK8Animator13GetPlayerTypeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK7Texture14IsDepthTextureEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK6Avatar6GetTOSEv(i1) {
 i1 = i1 | 0;
 return i1 + 60 | 0;
}

function __ZNK5physx7NpScene9startReadEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13EmscriptenWWW6GetETAEv(i1) {
 i1 = i1 | 0;
 return 1.0;
}

function __ZN9WWWCached15LockPartialDataEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9Transform15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9TextAsset15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9Rigidbody15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9Projector15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9LensFlare15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9HaloLayer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice15EndProfileEventEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice13GetCurrentGPUEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9CGProgram15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9Behaviour15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9AudioClip15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9AssetUser15OnBoundsChangedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Animator16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd10SocketImplD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sq14PrunerCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc5Actor10onActivateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc14ConstraintCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu17GetGeomSweepFuncsEv() {
 return gb + 84516 | 0;
}

function __ZN5physx17PxsContactManagerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra4AABB14validateBoundsEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2UI6Canvas15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24OcclusionCullingSettings15InitializeClassEv() {
 return;
}

function __ZN23SweepBoxMeshHitCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23SharedMeshRenderingDataD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23ManagedAttributeManagerC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN23ControllerContactFilterD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19BaseConnectSettings5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService22IsServiceEnabledByUserEv() {
 return 1;
}

function __ZN15DownloadHandler7PrepareEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN15DirectorManager9OnDisableEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10HumanTrait10LeftFinger14GetMuscleCountEv() {
 return 20;
}

function __ZL16CleanupModule_VRv() {
 __Z15CleanupVRModulev();
 return;
}

function __Z43Playables_CUSTOM_EndIgnoreAllocationTrackerv() {
 return;
}

function __Z41SystemInfo_Get_Custom_PropSupportsStencilv() {
 return 1;
}

function __Z20scripting_gc_disablev() {
 _il2cpp_gc_disable();
 return;
}

function __Z13GetTouchCountv() {
 return HEAP32[gb + 1101424 >> 2] | 0;
}

function __Z13GetIPhysics2Dv() {
 return HEAP32[gb + 1162152 >> 2] | 0;
}

function __Z13GetIEnlightenv() {
 return HEAP32[gb + 1162132 >> 2] | 0;
}

function __Z13GetIAnimationv() {
 return HEAP32[gb + 1162108 >> 2] | 0;
}

function __Z13GetFileSystemv() {
 return HEAP32[gb + 1179016 >> 2] | 0;
}

function __Z11StringToIntPKc(i1) {
 i1 = i1 | 0;
 return _atol(i1) | 0;
}

function _UnityReplayKitSetCameraEnabled(i1) {
 i1 = i1 | 0;
 return 0;
}

function _UNITY_FT_Done_Memory(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function _telldir(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 + 4 >> 2] | 0;
}

function _glCreateProgram__wrapper() {
 return _glCreateProgram() | 0;
}

function _cimagl(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 8 >> 3]);
}

function __ZNSt3__217declare_reachableEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK7Texture13IsNPOTAllowedEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK13Lz4Compressor7GetTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZNK13EmscriptenWWW7GetTypeEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN9b2ContactD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN9BoxPruner14optimizeMemoryEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8WindZone15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Renderer15UpdateLocalAABBEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8LODGroup15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8GUILayer15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Collider15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Animator15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Skybox17RemoveFromManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object17MainThreadCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx7PxvTermEv() {
 __Z17PxcPoolMallocTermv();
 return;
}

function __ZN5physx3Cct12SweptCapsuleD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sn20getBinaryPlatformTagEv() {
 return 1128484165;
}

function __ZN5physx2Gu13MeshInterfaceD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxsParticleShapeD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxVehicleDriveNWD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxVehicleDrive4WD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxRepXSerializerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx16PxControllerDescD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity17ConfigurableJoint15InitializeClassEv() {
 return;
}

function __ZN5Mutex18BlockUntilUnlockedEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN26AnimatorOverrideController12CleanupClassEv() {
 return;
}

function __ZN18ProceduralMaterial5CleanEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17PersistentManager6UnlockEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16BaseVideoTexture7SuspendEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15DirectorManager8OnEnableEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10HumanTrait11RightFinger12GetBoneCountEv() {
 return 15;
}

function __Z42GIDebugVisualisation_CUSTOM_PauseCycleModev() {
 return;
}

function __Z42CleanupSerializationByCodeGenerationThreadv() {
 return;
}

function __Z40DynamicGI_Get_Custom_PropSynchronousModev() {
 return 0;
}

function __Z40Application_Get_Custom_PropStreamedBytesv() {
 return 0;
}

function __Z16SyncFenceNoClearRK8JobFence(i1) {
 i1 = i1 | 0;
 return;
}

function __Z16DestroyJobSystemv() {
 __Z15DestroyJobQueuev();
 return;
}

function __Z12GetIVehiclesv() {
 return HEAP32[gb + 1162180 >> 2] | 0;
}

function __Z12GetIVRDevicev() {
 return HEAP32[gb + 1162176 >> 2] | 0;
}

function __Z12GetGfxDevicev() {
 return HEAP32[gb + 1157628 >> 2] | 0;
}

function _UNITY_LZ4_createStreamDecode() {
 return _calloc(1, 32) | 0;
}

function b72(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 nullFunc_vii(72);
}

function _towupper(i1) {
 i1 = i1 | 0;
 return ___towcase(i1, 0) | 0;
}

function _towlower(i1) {
 i1 = i1 | 0;
 return ___towcase(i1, 1) | 0;
}

function _ignore_err(i1, i2) {
 i1 = i1 | 0;
 i2 = i2 | 0;
 return 0;
}

function _glDisable__wrapper(i1) {
 i1 = i1 | 0;
 _glDisable(i1 | 0);
}

function _cimag(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 + 8 >> 3]);
}

function __ZNK9Behaviour10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK7Cubemap12GetDimensionEv(i1) {
 i1 = i1 | 0;
 return 4;
}

function __ZNK5physx7NpCloth7getTypeEv(i1) {
 i1 = i1 | 0;
 return 5;
}

function __ZN9GfxDevice24GetMaxStaticBatchIndicesEv() {
 return 64e3;
}

function __ZN9GfxDevice13AfterDrawCallEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8VRDeviceD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN7Texture15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7Terrain15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7Cubemap15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object16CheckConsistencyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd9SListImplD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Scb5Scene6getPvdEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN5physx3Cct11SweptVolumeD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc12MaterialCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu12SupportLocalD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Cm12RefCountableD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxsArticulationD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxVehicleWheelsD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxErrorCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxCpuDispatcherD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx15PxAssertHandlerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN25RuntimeAnimatorController12CleanupClassEv() {
 return;
}

function __ZN21OverlapCapsuleQuery2DD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21BillboardBatchManagerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN21BillboardBatchManagerC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18ProceduralMaterial19PostInitializeClassEv() {
 return;
}

function __ZN16BaseVideoTexture6ResumeEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15DownloadHandler7OnAbortEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15ArchiveReadFile5FlushEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN14DetailDatabase8SetDirtyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11OffMeshLink10SmartResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo25GetPhysicalProcessorCountEv() {
 return 1;
}

function __ZN10HumanTrait10LeftFinger12GetBoneCountEv() {
 return 15;
}

function __Z41GIDebugVisualisation_CUSTOM_StopCycleModev() {
 return;
}

function __Z41GIDebugVisualisation_CUSTOM_PlayCycleModev() {
 return;
}

function __Z19scripting_gc_enablev() {
 _il2cpp_gc_enable();
 return;
}

function __Z11GetJobQueuev() {
 return HEAP32[gb + 1162216 >> 2] | 0;
}

function __Z11GetIPhysicsv() {
 return HEAP32[gb + 1162148 >> 2] | 0;
}

function __Z11GetINetworkv() {
 return HEAP32[gb + 1162140 >> 2] | 0;
}

function _UnityReplayKitStartRecording(i1) {
 i1 = i1 | 0;
 return 0;
}

function _endmntent(i1) {
 i1 = i1 | 0;
 _fclose(i1) | 0;
 return 1;
}

function __ZNSt3__214error_categoryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__214__shared_countD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__211__money_putIwEC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__211__money_putIcEC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__211__money_getIwEC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__211__money_getIcEC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK8Renderer10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK8LODGroup10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK8Collider10HasEnabledEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZNK5physx7NpScene8stopReadEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9HaloLayer12AddToManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8TToArray15CoordinateCountI8Vector3fEEiv() {
 return 3;
}

function __ZN7b2JointD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN6Sprite15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Skybox15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Motion15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Avatar15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd8FPUGuardD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd8FPUGuardC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc11InteractionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx14SapPairManagerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx14PxVehicleGraphD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN24OcclusionCullingSettings12CleanupClassEv() {
 return;
}

function __ZN22UnityWebRequestManager14BackendReleaseEv() {
 return;
}

function __ZN20ParticleSystemModuleD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN20OverlapCircleQuery2DD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17PersistentManager4LockEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService21StartUpdatingLocationEv() {
 return;
}

function __ZN10systeminfo24GetProcessorFrequencyMHzEv() {
 return 0;
}

function __ZL22StaticInitializeShaderPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL22StaticInitializePlayerPv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z37HumanTrait_Get_Custom_PropMuscleCountv() {
 return 92;
}

function __Z22CopyRemoteNotificationj(i1) {
 i1 = i1 | 0;
 return 0;
}

function __Z10GetCookingv() {
 return HEAP32[gb + 1457456 >> 2] | 0;
}

function _XXH64_freeState(i1) {
 i1 = i1 | 0;
 _free(i1);
 return 0;
}

function _XXH32_freeState(i1) {
 i1 = i1 | 0;
 _free(i1);
 return 0;
}

function _PxGetFoundation() {
 return HEAP32[gb + 1452348 >> 2] | 0;
}

function _unzOpen(i1) {
 i1 = i1 | 0;
 return _unzOpen2(i1, 0) | 0;
}

function _if_freenameindex(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function _gztell(i1) {
 i1 = i1 | 0;
 return _gzseek(i1, 0, 1) | 0;
}

function _glEnable__wrapper(i1) {
 i1 = i1 | 0;
 _glEnable(i1 | 0);
}

function _emscripten_glFinish__wrapper() {
 _emscripten_glFinish();
}

function __ZNK7Texture10GetVRUsageEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK7Joint2D10SwapBodiesEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN9Behaviour11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Playable28BeginIgnoreAllocationTrackerEv() {
 return;
}

function __ZN8GUILayer12AddToManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6b2DrawD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN6ObjectD0Ev(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6shdfnd7PAUtilsD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd7PAUtilsC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu10SupportMapD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx13PxsSolverCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx13PxInputStreamD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Unity17ConfigurableJoint12CleanupClassEv() {
 return;
}

function __ZN5Light15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Flare15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD7SystemI7releaseEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN22UnityWebRequestManager13BackendRetainEv() {
 return;
}

function __ZN19FileAccessorHandlerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN19BaseConnectSettingsD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15UnityAdsManager5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15NavMeshSettings5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService20StopUpdatingLocationEv() {
 return;
}

function __ZN15LocationService18IsHeadingAvailableEv() {
 return 0;
}

function __ZN10systeminfo23SupportsLocationServiceEv() {
 return 0;
}

function __ZN10HumanTrait11RightFinger10IsLeftHandEv() {
 return 0;
}

function __Z39PostprocessSceneGenerateGUITextureAtlasv() {
 return;
}

function __Z37AndroidJNI_CUSTOM_DetachCurrentThreadv() {
 return 0;
}

function __Z37AndroidJNI_CUSTOM_AttachCurrentThreadv() {
 return 0;
}

function __Z37AndroidJNIHelper_Get_Custom_PropDebugv() {
 return 0;
}

function __Z22GetRegisteredVRDevicesv() {
 return gb + 1469348 | 0;
}

function __Z21CopyLocalNotificationj(i1) {
 i1 = i1 | 0;
 return 0;
}

function b70(i1, d2) {
 i1 = i1 | 0;
 d2 = +d2;
 nullFunc_vid(70);
}

function _creall(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 >> 3]);
}

function __ZNSt3__212bad_weak_ptrD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK8Playable7GetTimeEv(i1) {
 i1 = i1 | 0;
 return 0.0;
}

function __ZN9Behaviour10LateUpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8Animator11FixedUpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object27GetOffsetOfInstanceIdMemberEv() {
 return 4;
}

function __ZN5physx2Gu11getBoxEdgesEv() {
 return gb + 656163 | 0;
}

function __ZN5physx12PxSerializerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx12PxLockedDataD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx12PxControllerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra12OutputStreamD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4Tree15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4Halo15ThreadedCleanupEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD7SystemI6updateEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN24iPhoneRemoteNotification10UnregisterEv() {
 return;
}

function __ZN18IDCollectorFunctorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18BaseUnityAnalyticsD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService17GetLocationStatusEv() {
 return 0;
}

function __ZN15GlobalCallbacks3GetEv() {
 return gb + 1115728 | 0;
}

function __ZN14SpriteRenderer5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13EmscriptenWWW6CancelEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo22GetUsedVirtualMemoryMBEv() {
 return 0;
}

function __ZN10HumanTrait10LeftFinger10IsLeftHandEv() {
 return 1;
}

function __ZL37RegisterModuleICalls_CloudWebServicesv() {
 return;
}

function __ZL20sample_mono_shutdownPv(i1) {
 i1 = i1 | 0;
 return;
}

function __Z9GetIUmbrav() {
 return HEAP32[gb + 1162172 >> 2] | 0;
}

function __Z9GetIIMGUIv() {
 return HEAP32[gb + 1162136 >> 2] | 0;
}

function __Z9GetIClothv() {
 return HEAP32[gb + 1162124 >> 2] | 0;
}

function __Z9GetIAudiov() {
 return HEAP32[gb + 1162120 >> 2] | 0;
}

function __Z38GUI_CUSTOM_InternalRepaintEditorWindowv() {
 return;
}

function __Z36SystemInfo_Get_Custom_PropDeviceTypev() {
 return 3;
}

function __Z36RenderTexture_Get_Custom_PropEnabledv() {
 return 1;
}

function __Z36GUI_Get_Custom_PropUsePageScrollbarsv() {
 return 1;
}

function __Z35HumanTrait_Get_Custom_PropBoneCountv() {
 return 54;
}

function __Z22SetCompensatingSensorsb(i1) {
 i1 = i1 | 0;
 return;
}

function __Z22SetBackButtonLeavesAppb(i1) {
 i1 = i1 | 0;
 return;
}

function _nearbyintl(d1) {
 d1 = +d1;
 return +(+_nearbyint(d1));
}

function _isascii(i1) {
 i1 = i1 | 0;
 return i1 >>> 0 < 128 | 0;
}

function _glClear__wrapper(i1) {
 i1 = i1 | 0;
 _glClear(i1 | 0);
}

function _emscripten_glFlush__wrapper() {
 _emscripten_glFlush();
}

function _creal(i1) {
 i1 = i1 | 0;
 return +(+HEAPF64[i1 >> 3]);
}

function ___cxa_pure_virtual__wrapper() {
 ___cxa_pure_virtual();
}

function __ZNSt3__26locale5facetD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__212__do_nothingEPv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK9WWWCached7GetTypeEv(i1) {
 i1 = i1 | 0;
 return 2;
}

function __ZN8Playable26EndIgnoreAllocationTrackerEv() {
 return;
}

function __ZN6Skybox12AddToManagerEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx3Cct8SweptBoxD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc9RigidCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Sc9ActorCoreD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx2Gu9RadixSortD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra11PatchReaderC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra11InputStreamD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD7SystemI5closeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN24iPhoneRemoteNotification8GetErrorEv() {
 return 0;
}

function __ZN18SpeedTreeWindAsset15InitializeClassEv() {
 return;
}

function __ZN18ProceduralMaterial15InitializeClassEv() {
 return;
}

function __ZN17b2RayCastCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17b2ContactListenerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17VertexDeclarationD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17OverlapBoxQuery2DD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15LocationService16GetHeadingStatusEv() {
 return 0;
}

function __ZN14MessageHandler3GetEv() {
 return gb + 1104584 | 0;
}

function __ZN10systeminfo21SupportsAccelerometerEv() {
 return 0;
}

function __ZL36RegisterModuleICalls_UnityWebRequestv() {
 return;
}

function __ZL36RegisterModuleICalls_ParticlesLegacyv() {
 return;
}

function __Z37RegisterModuleClasses_UnityWebRequestv() {
 return;
}

function __Z37InitializeUnityCloudWebServicesModulev() {
 return;
}

function __Z35Application_Get_Custom_PropIsEditorv() {
 return 0;
}

function _PxGetPhysics() {
 return HEAP32[gb + 1457324 >> 2] | 0;
}

function _iswblank(i1) {
 i1 = i1 | 0;
 return _isblank(i1) | 0;
}

function _dirfd(i1) {
 i1 = i1 | 0;
 return HEAP32[i1 >> 2] | 0;
}

function __ZNSt3__28messagesIwED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__28messagesIcED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNK9GfxBuffer6IsLostEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZNK9DebugGLES6VerifyEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN5physx2Cm8PtrTableD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx10PxBaseTaskD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4Tree11GetTreeDataEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN2UI8SubBatch7DestroyEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16b2StackAllocatorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN16MecanimAnimationD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10MemoryFile5FlushEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN10HumanTrait4Body14GetMuscleCountEv() {
 return 52;
}

function __ZL35RegisterModuleICalls_UnityAnalyticsv() {
 return;
}

function __ZL35RegisterModuleICalls_TerrainPhysicsv() {
 return;
}

function __ZL35RegisterModuleICalls_ParticleSystemv() {
 return;
}

function __ZL35RegisterModuleICalls_CrashReportingv() {
 return;
}

function __Z7GetArgvv() {
 return HEAP32[gb + 1170796 >> 2] | 0;
}

function __Z7GetArgcv() {
 return HEAP32[gb + 1170792 >> 2] | 0;
}

function __Z5arrayR8Scalar4f(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function __Z19GetLightProbeGroupsv() {
 return gb + 1157924 | 0;
}

function __Z19GetCpuDispatcherPtrv() {
 return gb + 1452436 | 0;
}

function _UNITY_ft_validator_run(i1) {
 i1 = i1 | 0;
 return -1;
}

function b34(d1, d2) {
 d1 = +d1;
 d2 = +d2;
 nullFunc_vdd(34);
}

function b19(i1) {
 i1 = i1 | 0;
 nullFunc_di(19);
 return 0.0;
}

function b113(i1) {
 i1 = i1 | 0;
 nullFunc_ii(113);
 return 0;
}

function _pthread_cond_broadcast(i1) {
 i1 = i1 | 0;
 return 0;
}

function _freeaddrinfo(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function _cleanup(i1) {
 i1 = i1 | 0;
 _close(i1) | 0;
 return;
}

function __ZNSt3__27collateIwED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__27collateIcED2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object10SmartResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra5Query6deinitEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN4FMOD4DSPI6removeEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN23iPhoneLocalNotification9CancelAllEv() {
 return;
}

function __ZN19CharacterController12CleanupClassEv() {
 return;
}

function __ZN15dtLocalBoundaryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15b2QueryCallbackD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15b2ContactFilterD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15CacheWriterBaseD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN15CacheReaderBaseD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN11OffMeshLink5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo19GetExecutableSizeMBEv() {
 return 0;
}

function __ZN10systeminfo18GetRuntimePlatformEv() {
 return 17;
}

function __ZN10EventEntry6CreateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL34RegisterModuleICalls_TextRenderingv() {
 return;
}

function __ZL34RegisterModuleICalls_JSONSerializev() {
 return;
}

function __Z35RegisterModuleClasses_JSONSerializev() {
 return;
}

function __Z35AndroidJNI_CUSTOM_ExceptionDescribev() {
 return;
}

function __Z33Profiler_Get_Custom_PropSupportedv() {
 return 1;
}

function __Z18GetUnityInterfacesv() {
 return gb + 1163140 | 0;
}

function _UnityReplayKitBroadcastingAPIAvailable() {
 return 0;
}

function _sched_yield__wrapper() {
 return _sched_yield() | 0;
}

function _pthread_mutex_trylock(i1) {
 i1 = i1 | 0;
 return 0;
}

function _lroundl(d1) {
 d1 = +d1;
 return ~~+_roundl(d1) | 0;
}

function _ftell(i1) {
 i1 = i1 | 0;
 return ___ftello(i1) | 0;
}

function _atof(i1) {
 i1 = i1 | 0;
 return +(+_strtod(i1, 0));
}

function __ZN7ApiGLES9InitDebugEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx9PxCookingD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd19disableFPExceptionsEv() {
 return;
}

function __ZN5Umbra9AllocatorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN18SpeedTreeWindAsset12CleanupClassEv() {
 return;
}

function __ZN18ProceduralMaterial12CleanupClassEv() {
 return;
}

function __ZN18PlatformEffector2D12CleanupClassEv() {
 return;
}

function __ZN15UnityAdsManager15InitializeClassEv() {
 return;
}

function __ZN15ReflectionProbe15InitializeClassEv() {
 return;
}

function __ZN15QualitySettings15InitializeClassEv() {
 return;
}

function __ZN14b2CapsuleShapeD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14VRSplashScreenD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN14InputInterfaceD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo18IsHandheldPlatformEv() {
 return 0;
}

function __ZN10HumanTrait4Body12GetBoneCountEv() {
 return 24;
}

function __ZL33RegisterModuleICalls_UnityConnectv() {
 return;
}

function __ZL33InitializeModule_CloudWebServicesv() {
 return;
}

function __ZL31StereoDisplayGetDeviceConnectedv() {
 return 1;
}

function __Z34GUIUtility_CUSTOM_Internal_ExitGUIv() {
 return;
}

function __Z34CleanupUnityCloudWebServicesModulev() {
 return;
}

function __Z17GetManagerContextv() {
 return gb + 1104348 | 0;
}

function b109(f1) {
 f1 = Math_fround(f1);
 nullFunc_vf(109);
}

function _pthread_mutex_unlock(i1) {
 i1 = i1 | 0;
 return 0;
}

function _lround(d1) {
 d1 = +d1;
 return ~~+_round(+d1) | 0;
}

function _getlogin() {
 return _getenv(gb + 1076028 | 0) | 0;
}

function _freelocale(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function __ZN9Behaviour6UpdateEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd18enableFPExceptionsEv() {
 return;
}

function __ZN5Mutex8IsLockedEv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN4crnd24crnd_is_debugger_presentEv() {
 return 0;
}

function __ZN2UI14CanvasRenderer12CleanupClassEv() {
 return;
}

function __ZN13ScreenManagerD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13IDecompressorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13BaseAllocatorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10systeminfo17SupportsVibrationEv() {
 return 0;
}

function __ZN10systeminfo17GetProcessorCountEv() {
 return 1;
}

function __Z16GetScriptingRandv() {
 return gb + 1162392 | 0;
}

function _start_pass_downsample(i1) {
 i1 = i1 | 0;
 return;
}

function _nanf(i1) {
 i1 = i1 | 0;
 return Math_fround(nan);
}

function _glGetError__wrapper() {
 return _glGetError() | 0;
}

function _getwc(i1) {
 i1 = i1 | 0;
 return _fgetwc(i1) | 0;
}

function __ZNSt10bad_typeidD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxDevice5FlushEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxBuffer5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8TToArray15CoordinateCountIfEEiv() {
 return 1;
}

function __ZN5physx7NpActorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx21NpShapeGetScPtrOffsetEv() {
 return 48;
}

function __ZN5Mutex7TryLockEv(i1) {
 i1 = i1 | 0;
 return 1;
}

function __ZN14ParticleSystem14SyncRenderJobsEv() {
 return;
}

function __ZN13OcclusionArea15InitializeClassEv() {
 return;
}

function __ZN12ImageDecoderD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12CachedReaderD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN12BaseRendererD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL31InitializeModule_UnityAnalyticsv() {
 return;
}

function __ZL31InitializeModule_CrashReportingv() {
 return;
}

function __Z32GUIUtility_CUSTOM_UpdateUndoNamev() {
 return;
}

function __Z32AndroidJNI_CUSTOM_ExceptionClearv() {
 return;
}

function __Z30scripting_is_debugger_attachedv() {
 return 0;
}

function _UNITY_png_access_version_number() {
 return 10610;
}

function _Horizontal_Sweep_Step(i1) {
 i1 = i1 | 0;
 return;
}

function _FMOD_Debug_SetLevel(i1) {
 i1 = i1 | 0;
 return 0;
}

function _FMOD_Debug_GetLevel(i1) {
 i1 = i1 | 0;
 return 0;
}

function _unity_z_get_crc_table() {
 return gb + 16960 | 0;
}

function _toascii(i1) {
 i1 = i1 | 0;
 return i1 & 127 | 0;
}

function _tgammal(d1) {
 d1 = +d1;
 return +(+_tgamma(d1));
}

function _pthread_mutex_lock(i1) {
 i1 = i1 | 0;
 return 0;
}

function _init_mem_destination(i1) {
 i1 = i1 | 0;
 return;
}

function _dummy_consume_data(i1) {
 i1 = i1 | 0;
 return 0;
}

function ___cxa_end_catch__wrapper() {
 ___cxa_end_catch();
}

function __Znaj(i1) {
 i1 = i1 | 0;
 return __Znwj(i1) | 0;
}

function __ZdaPv(i1) {
 i1 = i1 | 0;
 __ZdlPv(i1);
 return;
}

function __ZN5physx6PxBaseD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17GeneralConnection10InitializeEv() {
 return;
}

function __ZN15UnityAdsManager12CleanupClassEv() {
 return;
}

function __ZN15TerrainCollider12CleanupClassEv() {
 return;
}

function __ZN15ReflectionProbe12CleanupClassEv() {
 return;
}

function __ZN15QualitySettings12CleanupClassEv() {
 return;
}

function __ZN15NavMeshObstacle12CleanupClassEv() {
 return;
}

function __ZN12AudioManager15InitializeClassEv() {
 return;
}

function __ZN11ICompressorD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL30RegisterModuleICalls_Physics2Dv() {
 return;
}

function __ZL30RegisterModuleICalls_Animationv() {
 return;
}

function __ZL30CleanupModule_CloudWebServicesv() {
 return;
}

function __Z31RunNativeTestsIfRequiredAndExitv() {
 return;
}

function __Z29IsApplicationGenuineAvailablev() {
 return 0;
}

function __Z13IsGyroEnabledi(i1) {
 i1 = i1 | 0;
 return 0;
}

function _UNITY_tt_driver_done(i1) {
 i1 = i1 | 0;
 return;
}

function _unity_z_zlibVersion() {
 return gb + 362978 | 0;
}

function _roundl(d1) {
 d1 = +d1;
 return +(+_round(+d1));
}

function ___h_errno_location() {
 return gb + 1469536 | 0;
}

function ___cxa_guard_release(i1) {
 i1 = i1 | 0;
 return;
}

function ___ctype_toupper_loc() {
 return gb + 205004 | 0;
}

function ___ctype_tolower_loc() {
 return gb + 203464 | 0;
}

function __ZNSt9type_infoD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9exceptionD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt9bad_allocD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7b2Timer5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Umbra5QueryD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN2UI11CanvasGroup12CleanupClassEv() {
 return;
}

function __ZN14PlayerSettings12CleanupClassEv() {
 return;
}

function __ZN14PhysicMaterial12CleanupClassEv() {
 return;
}

function __ZN14AreaEffector2D12CleanupClassEv() {
 return;
}

function __ZN11LightProbes15InitializeClassEv() {
 return;
}

function __ZN10GpuProgramD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL29RegisterModuleICalls_Vehiclesv() {
 return;
}

function __ZL29RegisterModuleICalls_UnityAdsv() {
 return;
}

function __ZL29InitializeModule_UnityConnectv() {
 return;
}

function __ZL29CleanupModule_ParticlesLegacyv() {
 return;
}

function __Z7CRCDonej(i1) {
 i1 = i1 | 0;
 return ~i1 | 0;
}

function __Z30NavMesh_CUSTOM_AddOffMeshLinksv() {
 return;
}

function __Z28Caching_Get_Custom_PropIndexv() {
 return 0;
}

function __Z28AndroidJNI_CUSTOM_GetVersionv() {
 return 0;
}

function __Z13GetFrameStatsv() {
 return gb + 1098184 | 0;
}

function _UnityReplayKitIsMicrophoneEnabled() {
 return 0;
}

function stackRestore(i1) {
 i1 = i1 | 0;
 STACKTOP = i1;
}

function b99() {
 nullFunc_f(99);
 return Math_fround(0);
}

function _truncl(d1) {
 d1 = +d1;
 return +(+_trunc(d1));
}

function _lrintl(d1) {
 d1 = +d1;
 return _lrint(d1) | 0;
}

function _log1pl(d1) {
 d1 = +d1;
 return +(+_log1p(d1));
}

function _log10l(d1) {
 d1 = +d1;
 return +(+_log10(d1));
}

function _ilogbl(d1) {
 d1 = +d1;
 return _ilogb(d1) | 0;
}

function _expm1l(d1) {
 d1 = +d1;
 return +(+_expm1(d1));
}

function _atanhl(d1) {
 d1 = +d1;
 return +(+_atanh(d1));
}

function _asinhl(d1) {
 d1 = +d1;
 return +(+_asinh(d1));
}

function _acoshl(d1) {
 d1 = +d1;
 return +(+_acosh(d1));
}

function __ZdlPv(i1) {
 i1 = i1 | 0;
 _free(i1);
 return;
}

function __ZNSt8bad_castD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6Object5ResetEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Mutex6UnlockEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN13WheelCollider12CleanupClassEv() {
 return;
}

function __ZN13OcclusionArea12CleanupClassEv() {
 return;
}

function __ZN13AudioListener12CleanupClassEv() {
 return;
}

function __ZN13AnimationClip12CleanupClassEv() {
 return;
}

function __ZN10SampleClip15InitializeClassEv() {
 return;
}

function __ZN10GUITexture15InitializeClassEv() {
 return;
}

function __ZL28RegisterModuleICalls_Terrainv() {
 return;
}

function __ZL28RegisterModuleICalls_Physicsv() {
 return;
}

function __ZL28CleanupModule_UnityAnalyticsv() {
 return;
}

function __ZL28CleanupModule_CrashReportingv() {
 return;
}

function __Z29NavMesh_CUSTOM_RestoreNavMeshv() {
 return;
}

function __Z27GetEnabledNotificationTypesv() {
 return 0;
}

function _UnityReplayKitRecordingAvailable() {
 return 0;
}

function _start_pass_dcolor(i1) {
 i1 = i1 | 0;
 return;
}

function _cf2_free_instance(i1) {
 i1 = i1 | 0;
 return;
}

function ___cxa_guard_abort(i1) {
 i1 = i1 | 0;
 return;
}

function __ZNSt3__218get_pointer_safetyEv() {
 return 0;
}

function __ZN9b2ContactD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9IVRDeviceD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9GfxBufferD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN9CoroutineD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5physx6shdfnd3Cpu8getCpuIdEv() {
 return 0;
}

function __ZN5Umbra9RasterOps10debugStatsEv() {
 return;
}

function __ZN12NavMeshAgent12CleanupClassEv() {
 return;
}

function __ZN12MeshCollider12CleanupClassEv() {
 return;
}

function __ZN12AudioManager12CleanupClassEv() {
 return;
}

function __Z26scripting_gc_maxgenerationv() {
 return 0;
}

function __Z26IsRealGfxDeviceThreadOwnerv() {
 return 1;
}

function __Z26GetRemoteNotificationCountv() {
 return 0;
}

function _XXH64_createState() {
 return _malloc(88) | 0;
}

function _XXH32_createState() {
 return _malloc(48) | 0;
}

function _UnityAudioSupportsPositiveGains() {
 return 1;
}

function _UNITY_LZ4_sizeofStreamState() {
 return 16416;
}

function _tanhl(d1) {
 d1 = +d1;
 return +(+_tanh(d1));
}

function _sinhl(d1) {
 d1 = +d1;
 return +(+_sinh(d1));
}

function _rintl(d1) {
 d1 = +d1;
 return +(+_rint(d1));
}

function _log2l(d1) {
 d1 = +d1;
 return +(+_log2(d1));
}

function _jsimd_fdct_islow(i1) {
 i1 = i1 | 0;
 return;
}

function _jsimd_fdct_ifast(i1) {
 i1 = i1 | 0;
 return;
}

function _jsimd_fdct_float(i1) {
 i1 = i1 | 0;
 return;
}

function _jsimd_can_h2v2_merged_upsample() {
 return 0;
}

function _jsimd_can_h2v1_merged_upsample() {
 return 0;
}

function _exp2l(d1) {
 d1 = +d1;
 return +(+_exp2(d1));
}

function _erfcl(d1) {
 d1 = +d1;
 return +(+_erfc(d1));
}

function _coshl(d1) {
 d1 = +d1;
 return +(+_cosh(d1));
}

function _cbrtl(d1) {
 d1 = +d1;
 return +(+_cbrt(d1));
}

function ___cxa_rethrow__wrapper() {
 ___cxa_rethrow();
}

function __ZN9Texture2D15InitializeClassEv() {
 return;
}

function __ZN9AudioClip15InitializeClassEv() {
 return;
}

function __ZN8IRaycastD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN8GradientD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5Mutex4LockEv(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN17GeneralConnection7CleanupEv() {
 return;
}

function __ZN11Rigidbody2D12CleanupClassEv() {
 return;
}

function __ZN11LightProbes12CleanupClassEv() {
 return;
}

function __ZN11AudioSource12CleanupClassEv() {
 return;
}

function __ZL26RegisterModuleICalls_WebGLv() {
 return;
}

function __ZL26RegisterModuleICalls_Umbrav() {
 return;
}

function __ZL26RegisterModuleICalls_IMGUIv() {
 return;
}

function __ZL26RegisterModuleICalls_Clothv() {
 return;
}

function __ZL26RegisterModuleICalls_Audiov() {
 return;
}

function __ZL26CleanupModule_UnityConnectv() {
 return;
}

function __Z27RegisterModuleClasses_WebGLv() {
 return;
}

function __Z27RegisterModuleClasses_IMGUIv() {
 return;
}

function __Z27PxcDisplayContactCacheStatsv() {
 return;
}

function __Z27Input_CUSTOM_ResetInputAxesv() {
 return;
}

function __Z25GetLocalNotificationCountv() {
 return 0;
}

function __Z25ExecuteOneJobInMainThreadv() {
 return 0;
}

function _jsimd_can_h2v2_fancy_upsample() {
 return 0;
}

function _jsimd_can_h2v1_fancy_upsample() {
 return 0;
}

function _jpeg_mem_init(i1) {
 i1 = i1 | 0;
 return 0;
}

function _init_mem_source(i1) {
 i1 = i1 | 0;
 return;
}

function _feraiseexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function _feclearexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function _cff_driver_done(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7b2TimerC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7b2ShapeD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN7b2JointD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN10SampleClip12CleanupClassEv() {
 return;
}

function __ZN10MeshFilter12CleanupClassEv() {
 return;
}

function __ZN10Collider2D12CleanupClassEv() {
 return;
}

function __ZL25InitializeModule_UnityAdsv() {
 return;
}

function __ZL23DebugGetDeviceConnectedv() {
 return 1;
}

function __Z26FinishAllCaptureScreenshotv() {
 return;
}

function __Z24IsTouchPressureSupportedv() {
 return 0;
}

function _UnityReplayKitIsCameraEnabled() {
 return 0;
}

function _UnityReplayKitHideCameraPreview() {
 return;
}

function _UnityReplayKitGetBroadcastURL() {
 return 0;
}

function _gettext(i1) {
 i1 = i1 | 0;
 return i1 | 0;
}

function _getnetbyname(i1) {
 i1 = i1 | 0;
 return 0;
}

function _fetestexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function _feholdexcept(i1) {
 i1 = i1 | 0;
 return 0;
}

function _erfl(d1) {
 d1 = +d1;
 return +(+_erf(d1));
}

function ___fesetround(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN7Terrain15InitializeClassEv() {
 return;
}

function __ZN6b2DrawD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6b2BodyD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN6ObjectD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __Z25PxcClearContactCacheStatsv() {
 return;
}

function __Z23GetInternetReachabilityv() {
 return 2;
}

function _UnityReplayKitStopBroadcasting() {
 return;
}

function _UnityReplayKitIsBroadcasting() {
 return 0;
}

function b110(i1) {
 i1 = i1 | 0;
 nullFunc_vi(110);
}

function _jpeg_mem_term(i1) {
 i1 = i1 | 0;
 return;
}

function _iconv_close(i1) {
 i1 = i1 | 0;
 return 0;
}

function _feupdateenv(i1) {
 i1 = i1 | 0;
 return 0;
}

function __exit(i1) {
 i1 = i1 | 0;
 __Exit(i1 | 0);
}

function ___ctype_b_loc() {
 return gb + 203460 | 0;
}

function __ZN9Texture2D12CleanupClassEv() {
 return;
}

function __ZN9Rigidbody12CleanupClassEv() {
 return;
}

function __ZN9Projector12CleanupClassEv() {
 return;
}

function __ZN9LensFlare12CleanupClassEv() {
 return;
}

function __ZN9AudioClip12CleanupClassEv() {
 return;
}

function __ZN7Cursors14CleanupCursorsEv() {
 return;
}

function __ZN5MutexD2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZN5MutexC2Ev(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL23RegisterModuleICalls_VRv() {
 return;
}

function __ZL23RegisterModuleICalls_UIv() {
 return;
}

function __ZL23RegisterModuleICalls_AIv() {
 return;
}

function __Z24RegisterModuleClasses_VRv() {
 return;
}

function __Z24ClearRemoteNotificationsv() {
 return;
}

function __Z22IsStylusTouchSupportedv() {
 return 0;
}

function __Z22GetJobQueueThreadCountv() {
 return 0;
}

function __Z22GetBackButtonLeavesAppv() {
 return 0;
}

function _UnityReplayKitStopRecording() {
 return 0;
}

function _UNITY_LZ4_versionNumber() {
 return 10600;
}

function _tlsf_destroy(i1) {
 i1 = i1 | 0;
 return;
}

function ___unlockfile(i1) {
 i1 = i1 | 0;
 return;
}

function ___res_state() {
 return gb + 1469864 | 0;
}

function ___lockfile(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZN8LODGroup12CleanupClassEv() {
 return;
}

function __ZN8Collider12CleanupClassEv() {
 return;
}

function __ZN4crnd16crnd_debug_breakEv() {
 return;
}

function __ZN11ContextGLES7IsValidEv() {
 return 1;
}

function __ZN11ContextGLES7AcquireEv() {
 return 1;
}

function __ZL22InitializeModule_WebGLv() {
 return;
}

function __ZL22CleanupModule_UnityAdsv() {
 return;
}

function __Z23Debug_CUSTOM_DebugBreakv() {
 return;
}

function __Z23ClearLocalNotificationsv() {
 return;
}

function __Z21IsCompensatingSensorsv() {
 return 0;
}

function _UnityReplayKitAPIAvailable() {
 return 0;
}

function _wms_close(i1) {
 i1 = i1 | 0;
 return 0;
}

function _unity_z_zlibCompileFlags() {
 return 85;
}

function _term_source(i1) {
 i1 = i1 | 0;
 return;
}

function _null_method(i1) {
 i1 = i1 | 0;
 return;
}

function _jsimd_can_h2v2_downsample() {
 return 0;
}

function _jsimd_can_h2v1_downsample() {
 return 0;
}

function __ZN7Terrain12CleanupClassEv() {
 return;
}

function __ZN7Joint2D12CleanupClassEv() {
 return;
}

function __ZN5Umbra5Query9deinitSpuEv() {
 return;
}

function __Z20IsSubstanceSupportedv() {
 return 0;
}

function __Z20IsRunningNativeTestsv() {
 return 0;
}

function __Z20IsApplicationGenuinev() {
 return 1;
}

function __Z20GetThreadedGfxDevicev() {
 return 0;
}

function __Z20GetAccelerationCountv() {
 return 0;
}

function __GLOBAL__sub_I_iostream_cpp() {
 return;
}

function _UnityReplayKitIsRecording() {
 return 0;
}

function _UNITY_LZ4_sizeofState() {
 return 16416;
}

function b108(d1) {
 d1 = +d1;
 nullFunc_vd(108);
}

function _setservent(i1) {
 i1 = i1 | 0;
 return;
}

function _setpgrp() {
 return _setpgid(0, 0) | 0;
}

function _sethostent(i1) {
 i1 = i1 | 0;
 return;
}

function _ms_close(i1) {
 i1 = i1 | 0;
 return 0;
}

function _localeconv() {
 return gb + 206672 | 0;
}

function _jsimd_can_quantize_float() {
 return 0;
}

function _jsimd_can_convsamp_float() {
 return 0;
}

function _fesetenv(i1) {
 i1 = i1 | 0;
 return 0;
}

function _fegetenv(i1) {
 i1 = i1 | 0;
 return 0;
}

function _catclose(i1) {
 i1 = i1 | 0;
 return 0;
}

function __flushlbf() {
 _fflush(0) | 0;
 return;
}

function __ZN6Camera12CleanupClassEv() {
 return;
}

function __ZN11ContextGLES7ReleaseEv() {
 return;
}

function __Z21InitializeVideoModulev() {
 return;
}

function __Z21InitializeBatchDeletev() {
 return;
}

function __Z19IsGearVRApplicationv() {
 return 0;
}

function _nanl(i1) {
 i1 = i1 | 0;
 return +nan;
}

function _jsimd_can_h2v2_upsample() {
 return 0;
}

function _jsimd_can_h2v1_upsample() {
 return 0;
}

function _grantpt(i1) {
 i1 = i1 | 0;
 return 0;
}

function __ZL19InitializeModule_UIv() {
 return;
}

function __ZL19InitializeModule_AIv() {
 return;
}

function __ZL19CleanupModule_WebGLv() {
 return;
}

function __Z20UnlockObjectCreationv() {
 return;
}

function __Z20ResetInputAfterPausev() {
 return;
}

function _UnityReplayKitLastError() {
 return 0;
}

function _nan(i1) {
 i1 = i1 | 0;
 return +nan;
}

function _mclose(i1) {
 i1 = i1 | 0;
 return 0;
}

function ___ctype_get_mb_cur_max() {
 return 4;
}

function __ZN4Tree12CleanupClassEv() {
 return;
}

function __ZN4Halo12CleanupClassEv() {
 return;
}

function __Z19InitFloatExceptionsv() {
 return;
}

function __Z17NetworkInitializev() {
 return 1;
}

function b76() {
 nullFunc_d(76);
 return 0.0;
}

function b144() {
 nullFunc_i(144);
 return 0;
}

function __ZN5Umbra10bitOpsTestEv() {
 return;
}

function __ZN10AtomicList5RelaxEv() {
 return;
}

function __Z18LockObjectCreationv() {
 return;
}

function __Z18Debug_CUSTOM_Breakv() {
 return;
}

function __Z18CleanupVideoModulev() {
 return;
}

function __Z18CleanupBatchDeletev() {
 return;
}

function __Z16IsTouchSupportedv() {
 return 1;
}

function _UnityReplayKitPreview() {
 return 0;
}

function _UnityReplayKitDiscard() {
 return 0;
}

function _jsimd_can_idct_islow() {
 return 0;
}

function _jsimd_can_idct_ifast() {
 return 0;
}

function _jsimd_can_idct_float() {
 return 0;
}

function _jsimd_can_fdct_islow() {
 return 0;
}

function _jsimd_can_fdct_ifast() {
 return 0;
}

function _jsimd_can_fdct_float() {
 return 0;
}

function _glFinish__wrapper() {
 _glFinish();
}

function _dummy1(i1) {
 i1 = i1 | 0;
 return;
}

function __ZL16CleanupModule_UIv() {
 return;
}

function __ZL16CleanupModule_AIv() {
 return;
}

function __Z15IsGyroAvailablev() {
 return 0;
}

function __Z15GetMousePresentv() {
 return 1;
}

function stackSave() {
 return STACKTOP | 0;
}

function __Z16SceneLoadingLoopv() {
 return;
}

function __Z16PostprocessScenev() {
 return;
}

function __Z16InitializeMemoryv() {
 return;
}

function __Z14RunNativeTestsv() {
 return 0;
}

function __Z14GetOrientationv() {
 return 0;
}

function _XXH_versionNumber() {
 return 600;
}

function _jsimd_can_rgb_gray() {
 return 0;
}

function _jsimd_can_quantize() {
 return 0;
}

function _jsimd_can_idct_4x4() {
 return 0;
}

function _jsimd_can_idct_2x2() {
 return 0;
}

function _jsimd_can_convsamp() {
 return 0;
}

function _glFlush__wrapper() {
 _glFlush();
}

function _jsimd_can_ycc_rgb() {
 return 0;
}

function _jsimd_can_rgb_ycc() {
 return 0;
}

function __Z14NetworkCleanupv() {
 return;
}

function __Z14CurlGlobalInitv() {
 return;
}

function _tlsf_overhead() {
 return 3196;
}

function __Z13InitDebugGLESv() {
 return;
}

function _abort__wrapper() {
 _abort();
}

function __Z11ResetStdoutv() {
 return;
}

function __Z8CRCBeginv() {
 return -1;
}

function __Z10ResetInputv() {
 return;
}

function _pthread_self() {
 return 0;
}

function __Z7GetGyrov() {
 return 0;
}

function b103() {
 nullFunc_v(103);
}

function _getservent() {
 return 0;
}

function _gethostent() {
 return 0;
}

function _fegetround() {
 return 0;
}

function _gethostid() {
 return 0;
}

function _res_init() {
 return 0;
}

function _endservent() {
 return;
}

function _endhostent() {
 return;
}

function _dummy0() {
 return;
}

// EMSCRIPTEN_END_FUNCS
var FUNCTION_TABLE_viiifiii = [b0,__ZN5physx3Ext19ProfileEventHandler19onCUDAProfileBufferEyfPKhjj];
var FUNCTION_TABLE_iiiiiid = [b1,__ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce,__ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe,b1];
var FUNCTION_TABLE_fiff = [b2,__ZNK5physx2Gu11HeightField9getHeightEff,__Z40TerrainData_CUSTOM_GetInterpolatedHeightP12Il2CppObjectff,__Z31TerrainData_CUSTOM_GetSteepnessP12Il2CppObjectff];
var FUNCTION_TABLE_iiififii = [b3,__Z43Physics_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK8Vector3fS1_fS1_fi23QueryTriggerInteraction];
var FUNCTION_TABLE_iiiiiii = [b4,__ZN20LocalFileSystemPosix4ReadER13FileEntryDatayPvPy,__ZN20LocalFileSystemPosix5WriteER13FileEntryDatayPvPy,__ZNK20LocalFileSystemPosix9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag,__ZN10DynamicVBO8GetChunkEjjj16GfxPrimitiveTypeP21DynamicVBOChunkHandle,__ZNK13Lz4Compressor14CompressMemoryEPKvjPvPj16CompressionLevel,__ZN17ArchiveFileSystem4ReadER13FileEntryDatayPvPy,__ZN17ArchiveFileSystem5WriteER13FileEntryDatayPvPy,__ZNK17ArchiveFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag,__ZN12IFileAdapter4ReadER13FileEntryDatayPvPy,__ZN12IFileAdapter5WriteER13FileEntryDatayPvPy,__ZN12HandlerChain4ReadER13FileEntryDatayPvPy,__ZN12HandlerChain5WriteER13FileEntryDatayPvPy,__ZNK12HandlerChain9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag,__ZN16MemoryFileSystem4ReadER13FileEntryDatayPvPy,__ZN16MemoryFileSystem5WriteER13FileEntryDatayPvPy,__ZNK16MemoryFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag,__ZNK25MultiBlocksMemoryFileData4ReadEyyPv,__ZN25MultiBlocksMemoryFileData5WriteEyyPKv,__ZNK24RingBufferMemoryFileData4ReadEyyPv,__ZN24RingBufferMemoryFileData5WriteEyyPKv,__ZNK25SingleBlockMemoryFileData4ReadEyyPv,__ZN25SingleBlockMemoryFileData5WriteEyyPKv,__ZN21AssetBundleFileSystem4ReadER13FileEntryDatayPvPy,__ZN21AssetBundleFileSystem5WriteER13FileEntryDatayPvPy,__ZNK21AssetBundleFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag,__ZN13GfxDeviceGLES17CaptureScreenshotEiiiiPh,__ZN13GfxDeviceNull17CaptureScreenshotEiiiiPh,__ZN11UmbraModule21QueryPortalVisibilityEPN5Umbra10VisibilityEPK22SceneCullingParametersjii
,__ZL15SweepBoxUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL19SweepBoxUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL12SweepBoxMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL11SweepBoxBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL14SweepBoxSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL15SweepBoxCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL19SweepCapsuleUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL23SweepCapsuleUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL16SweepCapsuleMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL15SweepCapsuleBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL18SweepCapsuleSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL19SweepCapsuleCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE,__ZL28GeomMTDCallback_SphereSphereRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL27GeomMTDCallback_SpherePlaneRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL29GeomMTDCallback_SphereCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL25GeomMTDCallback_SphereBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL28GeomMTDCallback_SphereConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL26GeomMTDCallback_SphereMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL33GeomMTDCallback_SphereHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL28GeomMTDCallback_NotSupportedRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL28GeomMTDCallback_PlaneCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL24GeomMTDCallback_PlaneBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL27GeomMTDCallback_PlaneConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL30GeomMTDCallback_CapsuleCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL26GeomMTDCallback_CapsuleBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL29GeomMTDCallback_CapsuleConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL27GeomMTDCallback_CapsuleMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL34GeomMTDCallback_CapsuleHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL22GeomMTDCallback_BoxBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL25GeomMTDCallback_BoxConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_
,__ZL23GeomMTDCallback_BoxMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL30GeomMTDCallback_BoxHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL28GeomMTDCallback_ConvexConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL26GeomMTDCallback_ConvexMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZL33GeomMTDCallback_ConvexHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_,__ZN5physx18RepXSerializerImplINS_10PxMaterialEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_7PxShapeEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_14PxArticulationEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_11PxAggregateEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_13PxClothFabricEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_7PxClothEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx9NpPhysics11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtbNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__ZN5physx9NpPhysics16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj,__ZNK5physx14NpSceneQueries7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE,__ZNK5physx13NpVolumeCache7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE,__ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_12PxFixedJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_9PxD6JointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE
,__ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN11AudioModule22CreateAudioClipFromWWWEP10IWWWStreamPKcbbi,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe,__ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm
,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm,__ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE,_request_virt_sarray,_request_virt_barray,__Z24Caching_CUSTOM_AuthorizeP12Il2CppStringS0_xiS0_,__Z32CullingGroup_CUSTOM_QueryIndicesP12Il2CppObjecthiN12CullingGroup12QueryOptionsEP11Il2CppArrayi,__Z26Texture2D_CUSTOM_GetPixelsP12Il2CppObjectiiiii,__Z33RenderTexture_CUSTOM_GetTemporaryiii19RenderTextureFormat22RenderTextureReadWritei,__Z47Physics_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK8Vector3fS1_P11Il2CppArrayRK11Quaternionfi23QueryTriggerInteraction,__Z29AudioMasterDSPProcessCallbackP21UnityAudioEffectStatePfS1_jii,__ZL37UnityAudioEffect_InternalReadCallbackP14FMOD_DSP_STATEPfS1_jii,__Z29AudioMixerSendProcessCallbackP21UnityAudioEffectStatePfS1_jii,__Z32AudioMixerReceiveProcessCallbackP21UnityAudioEffectStatePfS1_jii,__Z32AudioMixerDuckingProcessCallbackP21UnityAudioEffectStatePfS1_jii,__Z30AudioMixerFaderProcessCallbackP21UnityAudioEffectStatePfS1_jii,__ZN17AudioCustomFilter12readCallbackEP14FMOD_DSP_STATEPfS2_jii,__Z33TerrainData_CUSTOM_GetDetailLayerP12Il2CppObjectiiiii,_ps_unicodes_init,__ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_,__ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4
,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4,b4];
var FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiii = [b5,__ZNK5physx20PxsSolverCoreGeneral13solveV_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj,__ZNK5physx20PxsSolverCoreGeneral20solveVCoulomb_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj,__ZN5physx26solveVBlockDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj,__ZN5physx26solveVBlockCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj,b5,b5,b5];
var FUNCTION_TABLE_viiiiiiiiiii = [b6,__ZN9GfxDevice20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceGLES22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace,__ZN13GfxDeviceGLES20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceNull22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace,_glTexSubImage3D__wrapper,_glCompressedTexSubImage3D__wrapper,b6];
var FUNCTION_TABLE_fff = [b7,__ZN12_GLOBAL__N_16qAtan2Eff,__ZN12_GLOBAL__N_15qAsinEff,__ZL23stbir__filter_trapezoidff,__ZL22stbir__filter_triangleff,__ZL19stbir__filter_cubicff,__ZL24stbir__filter_catmullromff,__ZL22stbir__filter_mitchellff,__ZL31stbir__filter_mitchell_modifiedff,__ZN12_GLOBAL__N_15qNullEff,__Z24Mathf_CUSTOM_PerlinNoiseff,__Z19Random_CUSTOM_Rangeff,b7,b7,b7,b7];
var FUNCTION_TABLE_fiiiiiifiiiiiif = [b8,__ZN5physxL23PxcSweepSphereTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf,__ZN5physxL29PxcUnimplementedTriangleSweepERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf,__ZN5physxL24PxcSweepCapsuleTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf,__ZN5physxL20PxcSweepBoxTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf,__ZN5physxL23PxcSweepConvexTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf,b8,b8];
var FUNCTION_TABLE_iiiiifiif = [b9,__Z23sweepCapsule_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z22sweepCapsule_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z24sweepCapsule_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z20sweepCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z23sweepCapsule_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z21sweepCapsule_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z28sweepCapsule_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z23sweepCCTCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z19sweepBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z18sweepBox_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z20sweepBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z16sweepBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z19sweepBox_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z17sweepBox_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z24sweepBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z22sweepCCTBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z23sweepCCTBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z19sweepCCTBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,b9,b9,b9,b9,b9,b9,b9,b9,b9
,b9,b9,b9];
var FUNCTION_TABLE_iiiiifii = [b10,__Z39Physics_CUSTOM_INTERNAL_CALL_BoxCastAllRK8Vector3fS1_S1_RK11Quaternionffi23QueryTriggerInteraction];
var FUNCTION_TABLE_iiffi = [b11];
var FUNCTION_TABLE_vidd = [b12,_UNITY_png_set_gamma];
var FUNCTION_TABLE_iiiiiiiiiiii = [b13,__ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_,__ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_,b13];
var FUNCTION_TABLE_fif = [b14,__ZNK15b2DistanceJoint17GetReactionTorqueEf,__ZNK15b2FrictionJoint17GetReactionTorqueEf,__ZNK11b2GearJoint17GetReactionTorqueEf,__ZNK12b2MotorJoint17GetReactionTorqueEf,__ZNK12b2MouseJoint17GetReactionTorqueEf,__ZNK16b2PrismaticJoint17GetReactionTorqueEf,__ZNK13b2PulleyJoint17GetReactionTorqueEf,__ZNK15b2RevoluteJoint17GetReactionTorqueEf,__ZNK11b2RopeJoint17GetReactionTorqueEf,__ZNK11b2WeldJoint17GetReactionTorqueEf,__ZNK12b2WheelJoint17GetReactionTorqueEf,__Z30AnimationCurve_CUSTOM_EvaluateP12Il2CppObjectf,__Z27PlayerPrefs_CUSTOM_GetFloatP12Il2CppStringf,__Z46Joint2D_CUSTOM_INTERNAL_CALL_GetReactionTorqueP12Il2CppObjectf,__Z48HingeJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf,__Z48SliderJoint2D_CUSTOM_INTERNAL_CALL_GetMotorForceP12Il2CppObjectf,__Z48WheelJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf,__ZN11AudioSource15rolloffCallbackEP12FMOD_CHANNELf,__Z30RemoteSettings_CUSTOM_GetFloatP12Il2CppStringf,b14,b14,b14,b14,b14,b14,b14,b14,b14
,b14,b14,b14];
var FUNCTION_TABLE_viifiii = [b15,__ZN12PhysXRaycast10RaycastAllERK3Rayfi23QueryTriggerInteractionR13dynamic_arrayI10RaycastHitLj4EE,__Z30Mesh_CUSTOM_AddBlendShapeFrameP12Il2CppObjectP12Il2CppStringfP11Il2CppArrayS4_S4_,b15];
var FUNCTION_TABLE_fii = [b16,__ZNK20LightPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK29LineParametersPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK28RectTransformPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK24RendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK32RendererMaterialAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK25BlendshapePropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK30SpriteRendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK22GenericPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK28MonoBehaviourPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK29ParticleSystemPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK5physx7NpScene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE,__Z46SkinnedMeshRenderer_CUSTOM_GetBlendShapeWeightP12Il2CppObjecti,__Z37MaterialPropertyBlock_CUSTOM_GetFloatP12Il2CppObjecti,__Z48Bounds_CUSTOM_INTERNAL_CALL_Internal_SqrDistanceRK4AABBRK8Vector3f,__Z52Playable_CUSTOM_INTERNAL_CALL_GetInputWeightInternalR9HPlayablei,__Z24Material_CUSTOM_GetFloatP12Il2CppObjecti,__Z31AndroidJNI_CUSTOM_GetFloatField13Il2Cpp_IntPtrS_,__Z37AndroidJNI_CUSTOM_GetStaticFloatField13Il2Cpp_IntPtrS_,__Z38AndroidJNI_CUSTOM_GetFloatArrayElement13Il2Cpp_IntPtri,__Z45ParticleSystem_Particle_CUSTOM_GetCurrentSizeP12Il2CppObjectR22ParticleSystemParticle,__Z44getPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataEj,__Z44getPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataEj,__Z31getPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveEj,__Z31getPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveEj,__Z30getPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveEj,__Z32getPxVehicleAutoBoxData_UpRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE,__Z34getPxVehicleAutoBoxData_DownRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE,__Z31getPxVehicleGearsData_GearRatioPKN5physx18PxVehicleGearsDataENS0_4EnumE
,__ZN5physx19getXTorqueCurvePairEPKNS_19PxVehicleEngineDataEj,__ZN5physx19getYTorqueCurvePairEPKNS_19PxVehicleEngineDataEj,__Z36getPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataEj,__Z32NavMeshAgent_CUSTOM_GetLayerCostP12Il2CppObjecti,__Z31NavMeshAgent_CUSTOM_GetAreaCostP12Il2CppObjecti,__Z43Animator_CUSTOM_GetIKPositionWeightInternalP12Il2CppObjecti,__Z43Animator_CUSTOM_GetIKRotationWeightInternalP12Il2CppObjecti,__Z45Animator_CUSTOM_GetHintWeightPositionInternalP12Il2CppObjecti,__Z30Animator_CUSTOM_GetLayerWeightP12Il2CppObjecti,__Z30Animator_CUSTOM_GetFloatStringP12Il2CppObjectP12Il2CppString,__Z26Animator_CUSTOM_GetFloatIDP12Il2CppObjecti,__Z56AnimatorControllerPlayable_CUSTOM_GetLayerWeightInternalR9HPlayablei,__Z48AnimatorControllerPlayable_CUSTOM_GetFloatStringR9HPlayableP12Il2CppString,__Z44AnimatorControllerPlayable_CUSTOM_GetFloatIDR9HPlayablei,__Z27Avatar_CUSTOM_GetAxisLengthP12Il2CppObjecti,__Z41Terrain_CUSTOM_INTERNAL_CALL_SampleHeightP12Il2CppObjectRK8Vector3f,_wcstof,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16,b16
,b16,b16,b16,b16,b16];
var FUNCTION_TABLE_viiiiiff = [b17,__Z41Animator_CUSTOM_INTERNAL_CALL_MatchTargetP12Il2CppObjectRK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff];
var FUNCTION_TABLE_viiiiiifiii = [b18,__ZN13GfxDeviceGLES16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode,__ZN13GfxDeviceNull16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode,b18];
var FUNCTION_TABLE_di = [b19,__ZNK13EmscriptenWWW6GetETAEv,__ZNK14DirectorPlayer7GetTimeEv,__ZNK8Playable11GetDurationEv,__ZNK8Playable7GetTimeEv,__ZNK9WWWCached6GetETAEv,__ZNK21AnimationClipPlayable7GetTimeEv,__Z29DirectorPlayer_CUSTOM_GetTimeP12Il2CppObject,__Z32Compass_Get_Custom_PropTimestampP12Il2CppObject,__Z45Playable_CUSTOM_INTERNAL_CALL_GetTimeInternalR9HPlayable,__Z49Playable_CUSTOM_INTERNAL_CALL_GetDurationInternalR9HPlayable,b19,b19,b19,b19,b19];
var FUNCTION_TABLE_viff = [b20,__ZN9GfxDevice18SetGlobalDepthBiasEff,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13setBreakForceEff,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13setBreakForceEff,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13setBreakForceEff,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13setBreakForceEff,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13setBreakForceEff,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13setBreakForceEff,__ZN5physx19NpArticulationJoint13setSwingLimitEff,__ZN5physx19NpArticulationJoint13setTwistLimitEff,__ZN5physx12NpConstraint13setBreakForceEff,__ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff,__Z24GL_CUSTOM_MultiTexCoord2iff,__Z28LocationService_CUSTOM_StartP12Il2CppObjectff,__Z33setPxArticulationJoint_SwingLimitPN5physx19PxArticulationJointEff,__Z33setPxArticulationJoint_TwistLimitPN5physx19PxArticulationJointEff,__Z21setPxJoint_BreakForcePN5physx7PxJointEff,__Z26setPxConstraint_BreakForcePN5physx12PxConstraintEff,__ZN5physx18addTorqueCurvePairEPNS_19PxVehicleEngineDataEff,_emscripten_glUniform2f__wrapper,_emscripten_glVertexAttrib2f__wrapper,b20,b20,b20,b20,b20,b20,b20
,b20,b20,b20];
var FUNCTION_TABLE_iiifiii = [b21,__ZN12PhysXRaycast7RaycastERK3Rayfi23QueryTriggerInteractionR10RaycastHit,__Z51Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK8Vector3fS1_fP11Il2CppArrayi23QueryTriggerInteraction,b21];
var FUNCTION_TABLE_viiiif = [b22,__Z52CommandBuffer_CUSTOM_INTERNAL_CALL_ClearRenderTargetP12Il2CppObjecthhRK10ColorRGBAff,__Z46AnimatorControllerPlayable_CUSTOM_PlayInternal9HPlayableRS_iif,b22];
var FUNCTION_TABLE_viffff = [b23,__ZN23PreloadManagerOperation14SetFinalTimingEffff,__ZN9GfxDevice14ImmediateColorEffff,__ZN18LoadSceneOperation14SetFinalTimingEffff,__ZN13GfxDeviceNull14ImmediateColorEffff,__Z39Gizmos_CUSTOM_INTERNAL_CALL_DrawFrustumRK8Vector3fffff,_glVertexAttrib4f__wrapper,_emscripten_glUniform4f__wrapper,_emscripten_glVertexAttrib4f__wrapper,b23,b23,b23,b23,b23,b23,b23];
var FUNCTION_TABLE_vfff = [b24,__Z17GL_CUSTOM_Vertex3fff,__Z19GL_CUSTOM_TexCoord3fff,b24];
var FUNCTION_TABLE_vififfi = [b25,__Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddExplosionForceP12Il2CppObjectfRK8Vector3fffi];
var FUNCTION_TABLE_dii = [b26,__Z32AndroidJNI_CUSTOM_GetDoubleField13Il2Cpp_IntPtrS_,__Z38AndroidJNI_CUSTOM_GetStaticDoubleField13Il2Cpp_IntPtrS_,__Z39AndroidJNI_CUSTOM_GetDoubleArrayElement13Il2Cpp_IntPtri,_wcstod,_wcstold,b26,b26];
var FUNCTION_TABLE_iiifiiff = [b27,__Z49Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK13Vector2fIcallS1_fP11Il2CppArrayiff];
var FUNCTION_TABLE_viiiiii = [b28,__ZN9GfxDevice30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb,__ZN9GfxDevice23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii,__ZN9GfxDevice12ExecuteAsyncEiPFvPN21GfxDeviceAsyncCommand10ArgScratchEPKNS0_3ArgEEPS2_S5_R8JobFence,__ZN13GfxDeviceGLES30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb,__ZN13GfxDeviceGLES23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii,__ZL17ProgramUniform1fvPK7ApiGLESjiihPKv,__ZL17ProgramUniform2fvPK7ApiGLESjiihPKv,__ZL17ProgramUniform3fvPK7ApiGLESjiihPKv,__ZL17ProgramUniform4fvPK7ApiGLESjiihPKv,__ZL23ProgramUniformMatrix2fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix2x3fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix2x4fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix3x2fvPK7ApiGLESjiihPKv,__ZL23ProgramUniformMatrix3fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix3x4fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix4x2fvPK7ApiGLESjiihPKv,__ZL25ProgramUniformMatrix4x3fvPK7ApiGLESjiihPKv,__ZL23ProgramUniformMatrix4fvPK7ApiGLESjiihPKv,__ZL17ProgramUniform1ivPK7ApiGLESjiihPKv,__ZL17ProgramUniform2ivPK7ApiGLESjiihPKv,__ZL17ProgramUniform3ivPK7ApiGLESjiihPKv,__ZL17ProgramUniform4ivPK7ApiGLESjiihPKv,__ZL18ProgramUniform1uivPK7ApiGLESjiihPKv,__ZL18ProgramUniform2uivPK7ApiGLESjiihPKv,__ZL18ProgramUniform3uivPK7ApiGLESjiihPKv,__ZL18ProgramUniform4uivPK7ApiGLESjiihPKv,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_
,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZN5physx18RepXSerializerImplINS_10PxMaterialEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_10PxMaterialEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_10PxMaterialEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_7PxShapeEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxShapeRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_7PxShapeEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx28PxTriangleMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx28PxTriangleMeshRepXSerializer16objectToFileImplEPKNS_14PxTriangleMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx27PxHeightFieldRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx27PxHeightFieldRepXSerializer16objectToFileImplEPKNS_13PxHeightFieldEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx26PxConvexMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx26PxConvexMeshRepXSerializer16objectToFileImplEPKNS_12PxConvexMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_14PxArticulationEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_14PxArticulationEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx28PxArticulationRepXSerializer16objectToFileImplEPKNS_14PxArticulationEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE
,__ZN5physx18RepXSerializerImplINS_11PxAggregateEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx25PxAggregateRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx25PxAggregateRepXSerializer16objectToFileImplEPKNS_11PxAggregateEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_13PxClothFabricEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx27PxClothFabricRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx27PxClothFabricRepXSerializer16objectToFileImplEPKNS_13PxClothFabricEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_7PxClothEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxClothRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxClothRepXSerializer16objectToFileImplEPKNS_7PxClothEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZNK5physx7NpCloth16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES3_PNS_24PxClothCollisionTriangleE,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_,__ZN5physx33solveContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx21solve1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx41solveContactCoulomb_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx37solveContactCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx43solveContactCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx23solve1D4Block_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx27solveFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx35solveFriction_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx38solveFrictionCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx44solveFrictionCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx26solveContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx34solveContact_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx30solveContactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx36solveContactPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi
,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZN5physx20PxsParticleSystemSim15addInteractionVERKNS_16PxvParticleShapeEjjbb,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx,__ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_12PxFixedJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_9PxD6JointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx7profile32PxProfileMemoryEventRecorderImpl12onAllocationEjPKcS3_iPv,__ZN5physx7profile19MemoryEventRecorder12onAllocationEjPKcS3_iPv
,__ZN5physx7profile30PxProfileMemoryEventBufferImpl12onAllocationEjPKcS3_iPv,__ZN12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv,__ZThn8_N12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj,__ZN12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv,__ZThn8_N12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_,__ZN13PhysicsModule29BakeNxMeshStreamFromUnityMeshEP4MeshbbbR13dynamic_arrayIhLj1EE,__ZN16Physics2DManager14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEji,__ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj,__ZNKSt3__28messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNKSt3__28messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE,__ZNSt3__212strstreambuf7seekoffExNS_8ios_base7seekdirEj,__ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib
,__ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib,__ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv,__ZN8Playable19PrepareFrameVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv,__ZN8Playable14ProcessVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv,__Z14EmptyNormalMapP9Texture2DPhiiii,__Z5WhiteP9Texture2DPhiiii,__Z5BlackP9Texture2DPhiiii,__Z14RandomRotationP9Texture2DPhiiii,__Z3RedP9Texture2DPhiiii,__Z4GrayP9Texture2DPhiiii,__Z13GrayscaleRampP9Texture2DPhiiii,__Z7HaloTexP9Texture2DPhiiii,__Z16LightAttenuationItEvP9Texture2DPT_iiii,__Z16LightAttenuationIA4_tEvP9Texture2DPT_iiii,__Z16LightAttenuationIhEvP9Texture2DPT_iiii,__Z7Empty2DP9Texture2DPhiiii,__Z12NHxRoughnessItEvP9Texture2DPT_iiii,__Z12NHxRoughnessIA4_tEvP9Texture2DPT_iiii,__Z12NHxRoughnessIhEvP9Texture2DPT_iiii,__Z33Graphics_CUSTOM_CopyTexture_SliceP12Il2CppObjectiiS0_ii,__Z34Mesh_CUSTOM_SetArrayForChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi,__Z26Mesh_CUSTOM_SetIndicesImplP12Il2CppObjecti16GfxPrimitiveTypeP11Il2CppArrayih,__Z38Mesh_CUSTOM_GetBlendShapeFrameVerticesP12Il2CppObjectiiP11Il2CppArrayS2_S2_,__Z45CommandBuffer_CUSTOM_SetRenderTarget_ColDepthP12Il2CppObjectR26MonoRenderTargetIdentifierS2_iii,__Z32Texture3D_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormath,__Z35CubemapArray_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh,__Z36SparseTexture_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormatih,_glVertexAttribPointer__wrapper,_glTexStorage3D__wrapper,__ZL28HullProjectionCB_SmallConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_,__ZL26HullProjectionCB_BigConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_,__ZL20HullProjectionCB_BoxRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_,__ZN5physx29solveExtContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx24solveExt1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx36solveExtContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN5physx30solveExtFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi,__ZN12_GLOBAL__N_117ConnectionManager21nullAllocationHandlerEjPKcS2_iPv,__ZN12_GLOBAL__N_117ConnectionManager23recordAllocationHandlerEjPKcS2_iPv,__ZN12_GLOBAL__N_117ConnectionManager27connectionAllocationHandlerEjPKcS2_iPv,__Z56RaycastHit_CUSTOM_INTERNAL_CALL_CalculateRaycastTexCoordP13Vector2fIcallP12Il2CppObjectRKS_RK8Vector3fii,__Z30AudioClip_CUSTOM_Init_InternalP12Il2CppObjectP12Il2CppStringiiih,__Z24Animation_CUSTOM_AddClipP12Il2CppObjectS0_P12Il2CppStringiih,__Z38TerrainData_CUSTOM_Internal_SetHeightsP12Il2CppObjectiiiiP11Il2CppArray,__Z46TerrainData_CUSTOM_Internal_SetHeightsDelayLODP12Il2CppObjectiiiiP11Il2CppArray,__Z40TerrainData_CUSTOM_Internal_SetAlphamapsP12Il2CppObjectiiiiP11Il2CppArray,_Vertical_Sweep_Span,_Vertical_Sweep_Drop,_Horizontal_Sweep_Span,_Horizontal_Sweep_Drop,__ZN21UnityAnalyticsManager33OnPlayerSessionStateChangedStaticEPS_jyy,__ZN18UnityConnectClient33OnPlayerSessionStateChangedStaticEPS_jyy,_emscripten_glDrawRangeElements__wrapper,_emscripten_glVertexAttribPointer__wrapper,__ZNSt3__2L10__init_patIcEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_,__ZNSt3__2L10__init_patIwEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_,b28,b28,b28,b28
,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28
,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28,b28];
var FUNCTION_TABLE_iifff = [b29,__ZN5physx9NpPhysics14createMaterialEfff];
var FUNCTION_TABLE_iifii = [b30,__Z39ParticleSystem_CUSTOM_Internal_SimulateP12Il2CppObjectfhh,__Z42Physics_CUSTOM_INTERNAL_CALL_OverlapSphereRK8Vector3ffi23QueryTriggerInteraction,__Z40Physics_CUSTOM_INTERNAL_CALL_CheckSphereRK8Vector3ffi23QueryTriggerInteraction];
var FUNCTION_TABLE_iiiiiiiiii = [b31,__ZN9GfxDevice24CreateRenderColorSurfaceE9TextureIDiiii16TextureDimension19RenderTextureFormatj,__ZN5physx7Cooking19computeHullPolygonsERKNS_20PxSimpleTriangleMeshERNS_19PxAllocatorCallbackERjRPNS_6PxVec3ES6_RPjS6_RPNS_13PxHullPolygonE,_UNITY_png_get_IHDR];
var FUNCTION_TABLE_vdddddd = [b32,_emscripten_glFrustum__wrapper];
var FUNCTION_TABLE_iiiiiiiiiiiiffffii = [b33,__ZN5physx28createFinalizeSolverContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE,__ZN5physx35createFinalizeSolverContactsCoulombERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE,b33];
var FUNCTION_TABLE_vdd = [b34,_emscripten_glDepthRange__wrapper];
var FUNCTION_TABLE_iiiif = [b35,__Z46Collider_CUSTOM_INTERNAL_CALL_Internal_RaycastP12Il2CppObjectRK3RayP10RaycastHitf,__Z37Rigidbody2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayf,b35];
var FUNCTION_TABLE_iiiiiiii = [b36,__ZNK13Lz4Compressor14CompressStreamEPvPKvPjS0_S3_b,__ZNK15Lz4Decompressor16DecompressStreamEPvPKvPjS0_S3_b,__ZN15ArchiveReadFile4ReadEyyPvPy,__ZN15ArchiveReadFile5WriteEyyPKvPy,__ZN10MemoryFile4ReadEyyPvPy,__ZN10MemoryFile5WriteEyyPKvPy,__ZN11UmbraModule21BuildMaskShadowCullerERN5Umbra15ShadowCullerExtEPKNS0_10VisibilityEPK22SceneCullingParametersPK8Vector3fSB_i,__ZN37ConvexVsMeshContactGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN26ContactCapsuleMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_Scale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN25MeshMTDGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN25ConvexVsMeshSweepCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN23SweepBoxMeshHitCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN20SweepCapsuleCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi0ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi0ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi1ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi1ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi2ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN26IntersectAnyVsMeshCallbackILi2ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj,__ZN23RayMeshColliderCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,_D6JointSolverPrep,_DistanceJointSolverPrep,_FixedJointSolverPrep,_PrismaticJointSolverPrep,_RevoluteJointSolverPrep,_SphericalJointSolverPrep
,__ZN27ConvexVsMeshOverlapCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CB10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ESF_SF_RfPKj,__ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallback10processHitERKNS_12PxRaycastHitERKS9_SK_SK_RfPKj,__ZN5physx22PxcContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx21PxcContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx23PxcContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx19PxcContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx22PxcContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx20PxcContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physxL21PxcInvalidContactPairERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx22PxcContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx18PxcContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx21PxcContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx24PxcContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx20PxcContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx23PxcContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx21PxcContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx16PxcContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx19PxcContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx17PxcContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx22PxcContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx21PxcContactConvexMesh2ERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx25PxcPCMContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx24PxcPCMContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx26PxcPCMContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx22PxcPCMContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx25PxcPCMContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx23PxcPCMContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx25PxcPCMContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx21PxcPCMContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE
,__ZN5physx24PxcPCMContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx27PxcPCMContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx23PxcPCMContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx26PxcPCMContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx24PxcPCMContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx19PxcPCMContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx22PxcPCMContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx20PxcPCMContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx25PxcPCMContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx23PxcPCMContactConvexMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMConvexVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj,__ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_41PCMCapsuleVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj,__ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMSphereVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj,__ZN26PxcContactCellMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj,__ZN12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE,__ZThn4_N12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE,__ZN5physx25PxVehicleConstraintShader36vehicleSuspLimitConstraintSolverPrepEPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvRKNS_11PxTransformESB_,__ZN11IMGUIModule18MonoBehaviourDoGUIEiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS2_E,__ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc,__ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc,__ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE,__ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe,__ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE,__Z39GameObject_CUSTOM_GetComponentsInternalP12Il2CppObjectS0_hhhhS0_,__ZN5physx34PxcContactSphereHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx35PxcContactCapsuleHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx31PxcContactBoxHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx34PxcContactConvexHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx30PxcPCMContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE
,__ZN5physx31PxcPCMContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx27PxcPCMContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx30PxcPCMContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx27PxcContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx28PxcContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx24PxcContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__ZN5physx27PxcContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE,__Z23_SimulationFilterShaderjN5physx12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj,__ZN5physx31PxDefaultSimulationFilterShaderEjNS_12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj,_UNITY_tt_face_load_sbit_image,__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb,__ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb,__ZNSt3__214__scan_keywordIPcPNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SC_SB_SB_RKT1_Rjb,__ZNSt3__214__scan_keywordIPwPNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SC_SB_SB_RKT1_Rjb,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36,b36
,b36,b36,b36,b36,b36,b36,b36,b36,b36];
var FUNCTION_TABLE_vfii = [b37,__Z41Quaternion_CUSTOM_INTERNAL_CALL_AngleAxisfRK8Vector3fR11Quaternionf];
var FUNCTION_TABLE_vifiiiiiiiiiiiii = [b38,__ZNK5physx20PxsSolverCoreGeneral6solveVEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE,__ZNK5physx20PxsSolverCoreGeneral13solveVCoulombEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE,__ZN5physx21solveVDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE,__ZN5physx21solveVCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE,b38,b38,b38];
var FUNCTION_TABLE_viiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiiii = [b39,__ZN5physx28solveParallelDefaultFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj,__ZN5physx28solveParallelCouloumFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj,b39];
var FUNCTION_TABLE_iiiiiiif = [b40,__ZN13PhysicsModule25CreateNxMeshFromUnityMeshEP4MeshbbRK10Matrix4x4f13TransformTypef];
var FUNCTION_TABLE_iiiii = [b41,__ZN20LocalFileSystemPosix4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN20LocalFileSystemPosix9SetLengthER13FileEntryDatay,__ZN20LocalFileSystemPosix8SetFlagsER13FileEntryDatajj,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10ReallocateEPvji,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10ReallocateEPvji,__ZN14StackAllocator10ReallocateEPvji,__ZN12TLSAllocatorI14StackAllocatorE10ReallocateEPvji,__ZN25ThreadsafeLinearAllocator10ReallocateEPvji,__ZNK20LightPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK20LightPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZN15CacheWriterBase23WriteHeaderAndCloseFileEPvjj,__ZN9GfxDevice16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput,__ZN9GfxDevice16BeginBufferWriteEP9GfxBufferjj,__ZNK29LineParametersPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK29LineParametersPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK28RectTransformPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK28RectTransformPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK24RendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK24RendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK32RendererMaterialAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK32RendererMaterialAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK25BlendshapePropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK25BlendshapePropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK30SpriteRendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK30SpriteRendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZNK22GenericPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK22GenericPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZN13MonoBehaviour5DoGUIENS_13GUILayoutTypeEii
,__ZNK28MonoBehaviourPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK28MonoBehaviourPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZN17ArchiveFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN17ArchiveFileSystem9SetLengthER13FileEntryDatay,__ZN17ArchiveFileSystem8SetFlagsER13FileEntryDatajj,__ZN15ArchiveReadFile4SeekEx10FileOrigin,__ZN12IFileAdapter4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN12IFileAdapter9SetLengthER13FileEntryDatay,__ZN12HandlerChain4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN12HandlerChain9SetLengthER13FileEntryDatay,__ZN12HandlerChain8SetFlagsER13FileEntryDatajj,__ZN17FileSystemHandler8SetFlagsER13FileEntryDatajj,__ZN10MemoryFile4SeekEx10FileOrigin,__ZN16MemoryFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN16MemoryFileSystem9SetLengthER13FileEntryDatay,__ZN16MemoryFileSystem8SetFlagsER13FileEntryDatajj,__ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10ReallocateEPvji,__ZN21AssetBundleFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior,__ZN21AssetBundleFileSystem9SetLengthER13FileEntryDatay,__ZN13GfxDeviceGLES16BeginBufferWriteEP9GfxBufferjj,__ZN13GfxDeviceNull16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput,__ZN13GfxDeviceNull16BeginBufferWriteEP9GfxBufferjj,__ZN11UmbraModule18AllocateVisibilityEPKN5Umbra4TomeEPiRK10MemLabelId,__ZN11UmbraModule34CullShadowCastersWithUmbraThreadedER20ShadowCullingJobDataR10BlockRangei,__ZNK29ParticleSystemPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE,__ZNK29ParticleSystemPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE,__ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf,__ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf,__ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf,__ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf
,__ZN5physx3Cct26CharacterControllerManager16createControllerERNS_9PxPhysicsEPNS_7PxSceneERKNS_16PxControllerDescE,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZThn12_NK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZN5physx2Sn5ConvX7convertERNS_13PxInputStreamEjRNS_14PxOutputStreamE,__ZNK5physx11NpAggregate9getActorsEPPNS_7PxActorEjj,__ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE9getShapesEPPNS_7PxShapeEjj,__ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getConstraintsEPPNS_12PxConstraintEjj,__ZN18MultiQueryCallbackIN5physx10PxSweepHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj,__ZN18MultiQueryCallbackIN5physx12PxOverlapHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj,__ZN18MultiQueryCallbackIN5physx12PxRaycastHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj,__ZNK5physx9NpPhysics17getTriangleMeshesEPPNS_14PxTriangleMeshEjj,__ZNK5physx9NpPhysics15getHeightFieldsEPPNS_13PxHeightFieldEjj,__ZNK5physx9NpPhysics15getConvexMeshesEPPNS_12PxConvexMeshEjj,__ZNK5physx9NpPhysics9getScenesEPPNS_7PxSceneEjj,__ZNK5physx9NpPhysics9getShapesEPPNS_7PxShapeEjj,__ZNK5physx9NpPhysics12getMaterialsEPPNS_10PxMaterialEjj,__ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE9getShapesEPPNS_7PxShapeEjj,__ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getConstraintsEPPNS_12PxConstraintEjj,__ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE9getShapesEPPNS_7PxShapeEjj,__ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getConstraintsEPPNS_12PxConstraintEjj
,__ZNK5physx7NpScene16getArticulationsEPPNS_14PxArticulationEjj,__ZNK5physx7NpScene14getConstraintsEPPNS_12PxConstraintEjj,__ZNK5physx7NpScene13getAggregatesEPPNS_11PxAggregateEjj,__ZNK5physx7NpScene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj,__ZN5physx19PxcGetMaterialShapeEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZN5physx18PxcGetMaterialMeshEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZN5physx25PxcGetMaterialHeightFieldEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZNK5physx16PxBroadPhaseBase10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj,__ZNK5physx16PxsBroadPhaseMBP10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj,__ZN5physx24PxcGetMaterialShapeShapeEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZN5physx23PxcGetMaterialShapeMeshEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZN5physx30PxcGetMaterialShapeHeightFieldEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE,__ZN5physx9PxTaskMgr15submitNamedTaskEPNS_6PxTaskEPKcNS_10PxTaskType4EnumE,__ZN5physx12_GLOBAL__N_116LocationCallback6invokeERfPKNS_2Sq13PrunerPayloadEj,__ZN5physx12_GLOBAL__N_115OverlapCallback6invokeERfPKNS_2Sq13PrunerPayloadEj,__ZN5physx7Cooking14cookConvexMeshERKNS_16PxConvexMeshDescERNS_14PxOutputStreamEPNS_25PxConvexMeshCookingResult4EnumE,__ZNK5physx2Cm10Collection10getObjectsEPPNS_6PxBaseEjj,__ZNK5physx2Cm10Collection6getIdsEPyjj,__ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcNS_14PxProfileNamesEj,__ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcPNS_21PxProfileNameProviderEj,__ZN5physx2Sn9XmlParser12processCloseEPKcjRb,__ZN5physx6shdfnd7FastXml8Callback21processXmlDeclarationERKNS1_14AttributePairsEPKci,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl10getClassesEPN5physx8debugger16ClassDescriptionEjj,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19getPropertyMessagesEPN5physx8debugger26PropertyMessageDescriptionEjj,__ZN12_GLOBAL__N_115StringTableImpl7getStrsEPPKcjj,__ZN12_GLOBAL__N_110DataStream21beginSetPropertyValueEPKvPKcRKN5physx8debugger14NamespacedNameE,__ZN12_GLOBAL__N_110DataStream18setPropertyMessageEPKvRKN5physx8debugger14NamespacedNameENS4_7DataRefIKhEE,__ZN12_GLOBAL__N_110DataStream17pushBackObjectRefEPKvPKcS2_,__ZN12_GLOBAL__N_110DataStream15removeObjectRefEPKvPKcS2_,__ZN5physx6shdfnd7FastIPC8sendDataEPKvjb
,__ZN13PhysicsModule24CreateNxMeshFromNxStreamEbPKvj,__ZN16Physics2DManager16BatchOverlapInitEPK4PPtrIN5Unity9ComponentEEPP10Collider2Dj,__ZNK5physx25PxVehicleConstraintShader19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE,__ZNK14TerrainManager17CreateMeshPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP4MeshLj4EE,__ZNK19TextRenderingModule29TMGenGetCursorIndexAtPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfERK8Vector2f,__Z9FTReallocP13FT_MemoryRec_llPv,__ZN16UploadHandlerRaw13TransmitBytesEPvjj,__ZNK8VRDevice18SetCompositorLayerEP7TextureRK8Vector3fS4_,__ZNKSt3__25ctypeIcE8do_widenEPKcS3_Pc,__ZNKSt3__212ctype_bynameIwE5do_isEPKwS3_Pt,__ZNKSt3__212ctype_bynameIwE10do_scan_isEtPKwS3_,__ZNKSt3__212ctype_bynameIwE11do_scan_notEtPKwS3_,__ZNKSt3__212ctype_bynameIwE8do_widenEPKcS3_Pw,__ZNKSt3__25ctypeIwE5do_isEPKwS3_Pt,__ZNKSt3__25ctypeIwE10do_scan_isEtPKwS3_,__ZNKSt3__25ctypeIwE11do_scan_notEtPKwS3_,__ZNKSt3__25ctypeIwE8do_widenEPKcS3_Pw,_alloc_sarray,_alloc_barray,_fread_file_func,_fwrite_file_func,_fseek_file_func,_UNITY_png_create_read_struct,_UNITY_png_create_write_struct,__Z36AssetBundle_CUSTOM_LoadFromFileAsyncP12Il2CppStringjy,__Z31AssetBundle_CUSTOM_LoadFromFileP12Il2CppStringjy,__Z34Display_CUSTOM_RelativeMouseAtImpliiPiS_,__Z40Mesh_CUSTOM_GetAllocArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei,__Z46Playables_CUSTOM_INTERNAL_CALL_ConnectInternalR9HPlayableS0_ii,__Z51SceneManager_CUSTOM_LoadSceneAsyncNameIndexInternalP12Il2CppStringihh
,__Z48SceneManager_CUSTOM_UnloadSceneNameIndexInternalP12Il2CppStringihPh,__Z22Material_CUSTOM_GetTagP12Il2CppObjectP12Il2CppStringhS2_,__Z42ShaderVariantCollection_CUSTOM_AddInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray,__Z45ShaderVariantCollection_CUSTOM_RemoveInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray,__Z47ShaderVariantCollection_CUSTOM_ContainsInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray,__Z29CubemapArray_CUSTOM_GetPixelsP12Il2CppObjectiii,__Z31CubemapArray_CUSTOM_GetPixels32P12Il2CppObjectiii,__Z64Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleWithParentP12Il2CppObjectS0_RK8Vector3fRK11Quaternionf,__Z39Hash128_CUSTOM_Internal_Hash128ToStringjjjj,_glMapBufferRange__wrapper,_glClientWaitSync__wrapper,__ZN12_GLOBAL__N_111createClothERKN5physx11PxTransformERNS0_13PxClothFabricEPKNS0_15PxClothParticleENS0_7PxFlagsINS0_11PxClothFlag4EnumEtEE,__ZN5physx10PxsContext21addParticleSystemImplEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb,__Z17getPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEj,__Z36NavMesh_CUSTOM_INTERNAL_CALL_RaycastRK8Vector3fS1_P10NavMeshHiti,__Z50NavMesh_CUSTOM_INTERNAL_CALL_CalculatePathInternalRK8Vector3fS1_iP12Il2CppObject,__ZN9AudioClip28ScriptPCMSetPositionCallbackEP10FMOD_SOUNDijj,__ZN12AudioManager14systemCallbackEP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS3_,__ZN20SoundChannelInstance19FMODChannelCallbackEP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS3_,__ZL50UnityAudioEffect_InternalGetFloatParameterCallbackP14FMOD_DSP_STATEiPfPc,__Z39AudioMixerDuckingGetFloatBufferCallbackP21UnityAudioEffectStatePKcPfi,__Z27Animation_CUSTOM_PlayQueuedP12Il2CppObjectP12Il2CppStringii,__Z66AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoCountInternal9HPlayableRS_ih,__Z50AnimatorControllerPlayable_CUSTOM_HasStateInternal9HPlayableRS_ii,__Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_GetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray,__Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_SetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray,_ft_ansi_stream_io,_tt_glyph_load,_tt_get_kerning,_cff_glyph_load
,_cff_get_kerning,_ft_raster1_render,_ft_raster1_transform,_ft_smooth_render,_ft_smooth_transform,_gray_cubic_to,_tt_cmap14_char_var_index,_UNITY_tt_face_goto_table,_ps_hints_apply,_cff_get_glyph_name,_cff_get_ros,_TT_Access_Glyph_Frame,_ft_realloc,_sfnt_get_glyph_name,_ft_smooth_render_lcd,_ft_smooth_render_lcd_v,__ZL18MonoBehaviourDoGUIPvN13MonoBehaviour13GUILayoutTypeEii,__ZL21DeveloperConsoleDoGUIPvN13MonoBehaviour13GUILayoutTypeEii,__Z59GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorStringIndex13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectRK13Vector2fIcall,__Z31CustomEventData_CUSTOM_AddInt64P12Il2CppObjectP12Il2CppStringx,__Z32CustomEventData_CUSTOM_AddUInt64P12Il2CppObjectP12Il2CppStringy,__ZNSt3__217__libcpp_sscanf_lEPKcP15__locale_structS1_z,__ZNSt3__227__num_get_unsigned_integralIyEET_PKcS3_Rji,__ZNSt3__227__num_get_unsigned_integralImEET_PKcS3_Rji,__ZNSt3__227__num_get_unsigned_integralIjEET_PKcS3_Rji,__ZNSt3__227__num_get_unsigned_integralItEET_PKcS3_Rji,__ZNSt3__225__num_get_signed_integralIxEET_PKcS3_Rji,__ZNSt3__225__num_get_signed_integralIlEET_PKcS3_Rji,__ZNSt3__219__libcpp_asprintf_lEPPcP15__locale_structPKcz,_mbsrtowcs
,_catgets,_mbrtowc,___strxfrm_l,___wcsxfrm_l,__ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFlPKcPPciEEET_RKS7_RKT0_PjiT1_,__ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPFlPKwPPwiEEET_RKNS2_IcNS3_IcEENS5_IcEEEERKT0_PjiT1_,_swprintf,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKcj,__ZN10__cxxabiv112_GLOBAL__N_123parse_binary_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_,__ZN10__cxxabiv112_GLOBAL__N_123parse_prefix_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_,__ZN10__cxxabiv112_GLOBAL__N_121parse_integer_literalINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41
,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41,b41];
var FUNCTION_TABLE_vifififfi = [b42,__Z50Physics2D_CUSTOM_INTERNAL_CALL_Internal_CircleCastRK13Vector2fIcallfS1_fiffP12RaycastHit2D];
var FUNCTION_TABLE_iiifii = [b43,__ZN16Physics2DManager7RaycastERK3RayfiR12RaycastHit2D,__Z38Camera_CUSTOM_INTERNAL_CALL_RaycastTryP12Il2CppObjectRK3Rayfi23QueryTriggerInteraction,__Z39Physics_CUSTOM_INTERNAL_CALL_RaycastAllRK8Vector3fS1_fi23QueryTriggerInteraction,__Z43Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction,__Z41Physics_CUSTOM_INTERNAL_CALL_CheckCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction,__Z49Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastTestRK8Vector3fS1_fi23QueryTriggerInteraction,__Z32Animation_CUSTOM_CrossFadeQueuedP12Il2CppObjectP12Il2CppStringfii];
var FUNCTION_TABLE_viiiiiiiiiiiiiiiii = [b44,__ZN9GfxDevice22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_,__ZN13GfxDeviceGLES22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_,b44];
var FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiiiiiiiiiiiii = [b45,__ZNK5physx20PxsSolverCoreGeneral33solveVCoulombParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESI_RNSD_IjNSF_IjEEEESL_PNS_2Cm13SpatialVectorERiSP_j];
var FUNCTION_TABLE_viffi = [b46,__Z47Texture2D_CUSTOM_INTERNAL_CALL_GetPixelBilinearP12Il2CppObjectffR10ColorRGBAf,__Z54TerrainData_CUSTOM_INTERNAL_CALL_GetInterpolatedNormalP12Il2CppObjectffR8Vector3f,b46];
var FUNCTION_TABLE_iiiifiiii = [b47,__ZNK5physx13NpVolumeCache7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE];
var FUNCTION_TABLE_vifi = [b48,__ZN5physx3Cct26CharacterControllerManager19computeInteractionsEfPNS_26PxControllerFilterCallbackE,__ZN17AnimationPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE,__ZN27AnimationLayerMixerPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE,__ZN21AnimationClipPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE,__Z38Gradient_CUSTOM_INTERNAL_CALL_EvaluateP12Il2CppObjectfR10ColorRGBAf,__Z41Quaternion_CUSTOM_INTERNAL_CALL_AxisAngleRK8Vector3ffR11Quaternionf,__Z28Rigidbody2D_CUSTOM_AddTorqueP12Il2CppObjectfN11Rigidbody2D9ForceModeE,__Z55Joint2D_CUSTOM_Joint2D_CUSTOM_INTERNAL_GetReactionForceP12Il2CppObjectfP13Vector2fIcall,b48,b48,b48,b48,b48,b48,b48];
var FUNCTION_TABLE_vifff = [b49,__ZN9GfxDevice15ImmediateVertexEfff,__ZN9GfxDevice15ImmediateNormalEfff,__ZN9GfxDevice20ImmediateTexCoordAllEfff,__ZN13GfxDeviceNull15ImmediateVertexEfff,__ZN13GfxDeviceNull15ImmediateNormalEfff,__ZN13GfxDeviceNull20ImmediateTexCoordAllEfff,__Z24GL_CUSTOM_MultiTexCoord3ifff,_emscripten_glUniform3f__wrapper,_emscripten_glVertexAttrib3f__wrapper,b49,b49,b49,b49,b49,b49];
var FUNCTION_TABLE_viifififfi = [b50,__Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK13Vector2fIcallS1_fS1_fiffP12RaycastHit2D];
var FUNCTION_TABLE_fiii = [b51,__ZN35ClampVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN31CollisionModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN34ColorBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN27ColorModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN30EmissionModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN36ExternalForcesModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN27ForceModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN37InheritVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN29InitialModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN28LightsModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN27NoiseModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN37RotationBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN30RotationModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN27ShapeModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN33SizeBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN26SizeModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN27TrailModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN29TriggerModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN24UVModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__ZN30VelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi,__Z36Mesh_CUSTOM_GetBlendShapeFrameWeightP12Il2CppObjectii,__Z33AndroidJNI_CUSTOM_CallFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z39AndroidJNI_CUSTOM_CallStaticFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__ZN5physx23GetMFrictionVsSlipGraphEPKNS_17PxVehicleTireDataEjj,__Z28TerrainData_CUSTOM_GetHeightP12Il2CppObjectii,__ZNSt3__215__num_get_floatIfEET_PKcS3_Rj,b51,b51
,b51,b51,b51];
var FUNCTION_TABLE_iiiiiifffiiifii = [b52,__ZNK19TextRenderingModule8TMGenGetERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii];
var FUNCTION_TABLE_iifiiff = [b53,__Z52Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleNonAllocRK13Vector2fIcallfP11Il2CppArrayiff];
var FUNCTION_TABLE_iifiii = [b54,__Z50Physics_CUSTOM_INTERNAL_CALL_OverlapSphereNonAllocRK8Vector3ffP11Il2CppArrayi23QueryTriggerInteraction];
var FUNCTION_TABLE_fiif = [b55,__Z35GUIStyle_CUSTOM_Internal_CalcHeight13Il2Cpp_IntPtrP12Il2CppObjectf];
var FUNCTION_TABLE_iiiiifiiiif = [b56,__ZNK5physx13NpVolumeCache5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf];
var FUNCTION_TABLE_iiidiiii = [b57,__Z48UnityAnalyticsHandler_CUSTOM_InternalTransactionP12Il2CppObjectP12Il2CppStringdS2_S2_S2_h];
var FUNCTION_TABLE_iiifiifii = [b58,__Z48Physics_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK8Vector3fS1_fS1_P11Il2CppArrayfi23QueryTriggerInteraction,__Z49Physics_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK8Vector3fS1_fS1_P10RaycastHitfi23QueryTriggerInteraction,b58];
var FUNCTION_TABLE_viiiiiiiiii = [b59,__ZN9GfxDevice22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceGLES17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceGLES15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij,__ZN13GfxDeviceGLES22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceNull17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace,__ZN13GfxDeviceNull15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij,__ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_24PxsConstraintBatchHeaderEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvS3_jRNS_16PxcSolverContextES7_jPiE,__Z42Graphics_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectiS0_P11Il2CppArrayiS0_17ShadowCastingModehiS0_,_glTexImage3D__wrapper,_glBlitFramebuffer__wrapper,__ZNSt3__211__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri,__ZNSt3__211__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri,__ZNSt3__211__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri,__ZNSt3__211__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri,b59];
var FUNCTION_TABLE_iiiiiiffiiiiiiiiiffffiii = [b60,__Z56TextGenerator_CUSTOM_INTERNAL_CALL_Populate_Internal_cppP12Il2CppObjectP12Il2CppStringS0_RK10ColorRGBAfiffihhiiiihiffffhhPj];
var FUNCTION_TABLE_diii = [b61,__Z34AndroidJNI_CUSTOM_CallDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z40AndroidJNI_CUSTOM_CallStaticDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__ZNSt3__215__num_get_floatIeEET_PKcS3_Rj,__ZNSt3__215__num_get_floatIdEET_PKcS3_Rj,b61,b61,b61];
var FUNCTION_TABLE_iifififf = [b62,__Z44Physics2D_CUSTOM_INTERNAL_CALL_CircleCastAllRK13Vector2fIcallfS1_fiff];
var FUNCTION_TABLE_viiiiiiiiiiii = [b63,__ZN13GfxDeviceGLES15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace,__ZN13GfxDeviceNull15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace,__Z34Graphics_CUSTOM_CopyTexture_RegionP12Il2CppObjectiiiiiiS0_iiii];
var FUNCTION_TABLE_iiiiii = [b64,__ZN18ScreenManagerWebGL22SetResolutionImmediateEiibi,__ZN20LocalFileSystemPosix4SeekER13FileEntryDatax10FileOrigin,__ZNK16BaseVideoTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZN9GfxDevice25IsRenderTargetConfigValidEjj19RenderTextureFormat17DepthBufferFormat,__ZNK12CubemapArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK9Texture2D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZN4crndL20crnd_default_reallocEPvjPjbS0_,__ZNK13RenderTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZN13ScreenManager22SetResolutionImmediateEiibi,__ZNK19LowerResBlitTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK13SparseTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK14Texture2DArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK9Texture3D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK17ProceduralTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi,__ZNK15Lz4Decompressor16DecompressMemoryEPKvPjPvS2_,__ZN17ArchiveFileSystem4SeekER13FileEntryDatax10FileOrigin,__ZN15ArchiveReadFile4ReadEyPvPy,__ZN15ArchiveReadFile5WriteEyPKvPy,__ZN12IFileAdapter4SeekER13FileEntryDatax10FileOrigin,__ZN12HandlerChain4SeekER13FileEntryDatax10FileOrigin,__ZN10MemoryFile4ReadEyPvPy,__ZN10MemoryFile5WriteEyPKvPy,__ZN16MemoryFileSystem4SeekER13FileEntryDatax10FileOrigin,__ZN21AssetBundleFileSystem4SeekER13FileEntryDatax10FileOrigin,__ZN16ControllerFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE,__ZN16NovodexAllocator8allocateEjPKcS1_i,__ZL32GeomOverlapCallback_SphereSphereRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL31GeomOverlapCallback_SpherePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE
,__ZL33GeomOverlapCallback_SphereCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL29GeomOverlapCallback_SphereBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL32GeomOverlapCallback_SphereConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z30GeomOverlapCallback_SphereMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL43GeomOverlapCallback_HeightfieldUnregisteredRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL30GeomOverlapCallback_PlanePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL32GeomOverlapCallback_PlaneCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL28GeomOverlapCallback_PlaneBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL31GeomOverlapCallback_PlaneConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL29GeomOverlapCallback_PlaneMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL34GeomOverlapCallback_CapsuleCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL30GeomOverlapCallback_CapsuleBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL33GeomOverlapCallback_CapsuleConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z31GeomOverlapCallback_CapsuleMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL26GeomOverlapCallback_BoxBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL29GeomOverlapCallback_BoxConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z27GeomOverlapCallback_BoxMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL32GeomOverlapCallback_ConvexConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z30GeomOverlapCallback_ConvexMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL28GeomOverlapCallback_MeshMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__ZN5physx9NpPhysics11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__ZN5physx13NpRigidStatic11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__ZNK5physx7NpScene9getActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEjj,__ZN5physx2Sq12BucketPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj,__ZNK5physx2Sq12BucketPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE,__ZNK5physx2Sq12BucketPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE,__ZN5physx2Sq10AABBPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj,__ZNK5physx2Sq10AABBPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE
,__ZNK5physx2Sq10AABBPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE,__ZN5physx2Gu11HeightField13modifySamplesEiiRKNS_17PxHeightFieldDescEb,__ZN5physx6shdfnd10Foundation19AlignCheckAllocator8allocateEjPKcS4_i,__ZN5physx2Cm17FreeListAllocator8allocateEjPKcS3_i,__ZN23ControllerContactFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE,__ZN10CastFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE,__ZN24CollectBroadphaseTerrain9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE,__ZN5physx2Sn9XmlParser14processElementEPKcS3_RKNS_6shdfnd7FastXml14AttributePairsEi,__ZN5physx6shdfnd7FastXml8Callback14processDoctypeEPKcS4_S4_S4_,__ZN12_GLOBAL__N_117EventBufferClient15sendEventBufferEN5physx8debugger7DataRefIKhEEjy,__ZN12_GLOBAL__N_117EventBufferClient4lockEjjy,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13getPropertiesEN5physx8debugger18NonNegativeIntegerEPNS2_19PropertyDescriptionEjj,__ZN12_GLOBAL__N_110DataStream16setPropertyValueEPKvPKcN5physx8debugger7DataRefIKhEERKNS6_14NamespacedNameE,__ZN12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj,__ZThn4_N12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj,__ZN12_GLOBAL__N_117ConnectionManager13connectAddRefEPN5physx8debugger18PvdNetworkInStreamERNS2_19PvdNetworkOutStreamENS1_7PxFlagsINS2_17PvdConnectionType4EnumEjEEb,__ZNK12b2ChainShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi,__ZNK11b2EdgeShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi,__ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi,__ZNK14b2PolygonShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi,__ZNK13b2CircleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi,__ZN16MecanimAnimation19PathHashesToIndicesERN5Unity9ComponentEPKjjPt,__ZNK14TerrainManager21GetInterpolatedHeightEPK6ObjectRK8Vector3fS5_Rf,__ZNK14TerrainManager27CreateSharedMeshDataPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB,__ZN8VRDevice25CreateEyeTextureResourcesEPvP17RenderSurfaceBaseS0_PS0_,__ZNKSt3__27collateIcE10do_compareEPKcS3_S3_S3_,__ZNKSt3__27collateIwE10do_compareEPKwS3_S3_S3_,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm
,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv,__ZNKSt3__27codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__27codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__27codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__27codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__27codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__27codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__27codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_,__ZNKSt3__27codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j,__ZNKSt3__214collate_bynameIcE10do_compareEPKcS3_S3_S3_,__ZNKSt3__214collate_bynameIwE10do_compareEPKwS3_S3_S3_,__ZNKSt3__25ctypeIcE9do_narrowEPKcS3_cPc,__ZNKSt3__212ctype_bynameIwE9do_narrowEPKwS3_cPc,__ZNKSt3__25ctypeIwE9do_narrowEPKwS3_cPc,__ZNKSt3__214__codecvt_utf8IwE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__214__codecvt_utf8IwE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__214__codecvt_utf8IDsE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__214__codecvt_utf8IDsE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__214__codecvt_utf8IDiE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__214__codecvt_utf8IDiE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__215__codecvt_utf16IwLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IwLb0EE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__215__codecvt_utf16IwLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IwLb1EE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__215__codecvt_utf16IDsLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IDsLb0EE9do_lengthER11__mbstate_tPKcS5_j
,__ZNKSt3__215__codecvt_utf16IDsLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IDsLb1EE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__215__codecvt_utf16IDiLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IDiLb0EE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__215__codecvt_utf16IDiLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__215__codecvt_utf16IDiLb1EE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__220__codecvt_utf8_utf16IwE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__220__codecvt_utf8_utf16IwE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__220__codecvt_utf8_utf16IDiE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__220__codecvt_utf8_utf16IDiE9do_lengthER11__mbstate_tPKcS5_j,__ZNKSt3__220__codecvt_utf8_utf16IDsE10do_unshiftER11__mbstate_tPcS4_RS4_,__ZNKSt3__220__codecvt_utf8_utf16IDsE9do_lengthER11__mbstate_tPKcS5_j,_access_virt_sarray,_access_virt_barray,__Z23Texture2D_CUSTOM_ResizeP12Il2CppObjectii13TextureFormath,__Z29Texture2D_CUSTOM_PackTexturesP12Il2CppObjectP11Il2CppArrayiih,__Z31WWW_CUSTOM_GetAudioClipInternalP12Il2CppObjecthhhi,__Z37GeomOverlapCallback_SphereHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z36GeomOverlapCallback_PlaneHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z38GeomOverlapCallback_CapsuleHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z34GeomOverlapCallback_BoxHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z37GeomOverlapCallback_ConvexHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL35GeomOverlapCallback_MeshHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__ZL42GeomOverlapCallback_HeightfieldHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE,__Z37Physics_CUSTOM_INTERNAL_CALL_CheckBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction,__Z39Physics_CUSTOM_INTERNAL_CALL_OverlapBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction,__ZN15b2CircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN25b2PolygonAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN16b2PolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN22b2EdgeAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator
,__ZN23b2EdgeAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN23b2ChainAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN24b2ChainAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN16b2CapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN25b2CapsuleAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN26b2PolygonAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN23b2EdgeAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZN24b2ChainAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator,__ZL28VehicleWheelRaycastPreFilterN5physx12PxFilterDataES0_PKvjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEE,__ZN9AudioClip7WWWOpenEPKciPjPPvS4_,__ZN9AudioClip7WWWReadEPvS0_jPjS0_,__Z14FMOD_FILE_OpenPKciPjPPvS3_,__Z14FMOD_FILE_ReadPvS_jPjS_,__Z30WebCamTexture_CUSTOM_GetPixelsP12Il2CppObjectiiii,__Z29TerrainData_CUSTOM_GetHeightsP12Il2CppObjectiiii,__Z37TerrainData_CUSTOM_GetSupportedLayersP12Il2CppObjectiiii,__Z31TerrainData_CUSTOM_GetAlphamapsP12Il2CppObjectiiii,_raccess_guess_apple_double,_raccess_guess_apple_single,_raccess_guess_darwin_ufs_export,_raccess_guess_darwin_newvfs,_raccess_guess_darwin_hfsplus,_raccess_guess_vfat,_raccess_guess_linux_cap,_raccess_guess_linux_double,_raccess_guess_linux_netatalk,_UNITY_tt_face_init,_tt_get_advances,_cff_face_init,_cff_get_advances
,_UNITY_tt_face_load_any,_sfnt_table_info,_sfnt_init_face,_sfnt_load_face,_tt_sbit_decoder_load_byte_aligned,_tt_sbit_decoder_load_bit_aligned,_tt_sbit_decoder_load_compound,__Z28Font_CUSTOM_GetCharacterInfoP12Il2CppObjecttPN20TextRenderingPrivate22ScriptingCharacterInfoEii,__Z33GUI_CUSTOM_INTERNAL_CALL_DoToggleRK5RectTIfEihP12Il2CppObject13Il2Cpp_IntPtr,_wcsnrtombs,_mbsnrtowcs,__ZNSt3__220__get_up_to_n_digitsIcPcEEiRT0_S2_RjRKNS_5ctypeIT_EEi,__ZNSt3__220__get_up_to_n_digitsIwPwEEiRT0_S2_RjRKNS_5ctypeIT_EEi,__ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj,__ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64
,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64
,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64,b64];
var FUNCTION_TABLE_iiiiid = [b65,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd,__ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd,__ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe,b65,b65,b65];
var FUNCTION_TABLE_iiiiiifiif = [b66,__Z22sweepConvex_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z21sweepConvex_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z23sweepConvex_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z19sweepConvex_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z22sweepConvex_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z20sweepConvex_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf,__Z27sweepConvex_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf];
var FUNCTION_TABLE_viiii = [b67,__ZN13ScreenManager14GetResolutionsEib,__ZNK20LightPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__ZN14DirectorPlayer38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei,__ZN8Playable7SetDataEyPv,__ZN22BlockMemoryCacheWriter14LockCacheBlockEjPPhS1_,__ZNK9GfxDevice31CalculateDeviceProjectionMatrixER10Matrix4x4fbb,__ZN9GfxDevice20UpdateConstantBufferEijPKv,__ZN9GfxDevice28ScheduleGeometryJobsInternalEPFvP15GeometryJobDataEPK22GeometryJobInstructionj,__ZN9GfxDevice20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi,__ZN9GfxDevice21RegisterNativeTextureE9TextureIDi16TextureDimension,__ZN9GfxDevice20SetComputeBufferDataE15ComputeBufferIDPKvj,__ZN9GfxDevice20GetComputeBufferDataE15ComputeBufferIDPvj,__ZN9GfxDevice22CopyComputeBufferCountE15ComputeBufferIDS0_j,__ZN9GfxDevice28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE,__ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj,__ZN9GfxDevice16DrawNullGeometryE16GfxPrimitiveTypeii,__ZN9GfxDevice24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj,__ZN9GfxDevice19AsyncResourceUploadEii9TextureID,__ZN9GfxDevice23SyncAsyncResourceUploadE9TextureID10AsyncFencei,__ZN19GfxThreadableDevice20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_,__ZN19GfxThreadableDevice20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh,__ZNK29LineParametersPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__ZNK28RectTransformPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__ZNK17IAnimationBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__ZN6prcoreL11inner_clearILj1EEEvPhjjj,__ZN6prcoreL11inner_clearILj2EEEvPhjjj,__ZN6prcoreL11inner_clearILj3EEEvPhjjj,__ZN6prcoreL11inner_clearILj4EEEvPhjjj
,__ZN10DynamicVBO12ReleaseChunkER21DynamicVBOChunkHandlejj,__ZN17GenericDynamicVBO20ReleaseChunkInternalERK21DynamicVBOChunkHandlejj,__ZNK25BlendshapePropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__Z33RenderImageFilterValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object,__Z31AudioFilterReadValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object,__ZN17MemoryCacheWriter14LockCacheBlockEjPPhS1_,__ZN17MemoryCacheReader10DirectReadEPvjj,__ZN17MemoryCacheReader14LockCacheBlockEjPPhS1_,__ZN14FileCacherRead10DirectReadEPvjj,__ZN14FileCacherRead14LockCacheBlockEjPPhS1_,__ZN22MemoryCacherReadBlocks10DirectReadEPvjj,__ZN22MemoryCacherReadBlocks14LockCacheBlockEjPPhS1_,__ZN13GfxDeviceGLES11SetTexturesE10ShaderTypeiPK15GfxTextureParam,__ZN13GfxDeviceGLES20UpdateConstantBufferEijPKv,__ZN13GfxDeviceGLES20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi,__ZN13GfxDeviceGLES15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj,__ZN13GfxDeviceGLES21RegisterNativeTextureE9TextureIDi16TextureDimension,__ZN13GfxDeviceGLES20SetComputeBufferDataE15ComputeBufferIDPKvj,__ZN13GfxDeviceGLES20GetComputeBufferDataE15ComputeBufferIDPvj,__ZN13GfxDeviceGLES22CopyComputeBufferCountE15ComputeBufferIDS0_j,__ZN13GfxDeviceGLES28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE,__ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj,__ZN13GfxDeviceGLES16DrawNullGeometryE16GfxPrimitiveTypeii,__ZN13GfxDeviceGLES24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj,__ZN13GfxDeviceGLES20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZN13GfxDeviceNull11SetTexturesE10ShaderTypeiPK15GfxTextureParam,__ZN13GfxDeviceNull20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_,__ZN13GfxDeviceNull15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj,__ZN11UmbraModule14FreeVisibilityEPN5Umbra10VisibilityEbRK10MemLabelId
,__ZN11UmbraModule23CullDynamicObjectsUmbraEPK4AABBPKN5Umbra15OcclusionBufferER9IndexList,__ZNK29ParticleSystemPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc,__ZN5physx3Cct10Controller9onReleaseEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE,__ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_,__ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_,__ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_,__ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_,__ZN12_GLOBAL__N_114D6JointProjectEPKvRN5physx11PxTransformES4_b,__ZN12_GLOBAL__N_120DistanceJointProjectEPKvRN5physx11PxTransformES4_b,__ZN12_GLOBAL__N_117FixedJointProjectEPKvRN5physx11PxTransformES4_b,__ZN12_GLOBAL__N_121PrismaticJointProjectEPKvRN5physx11PxTransformES4_b,__ZN12_GLOBAL__N_120RevoluteJointProjectEPKvRN5physx11PxTransformES4_b,__ZN12_GLOBAL__N_121SphericalJointProjectEPKvRN5physx11PxTransformES4_b,__ZN5physx2Sn20SerializationContext17registerReferenceERNS_6PxBaseEjj,__ZN5physx18NpArticulationLink8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb,__ZN5physx18NpArticulationLink9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb,__ZN5physx9NpPhysics24registerDeletionListenerERNS_18PxDeletionListenerERKNS_7PxFlagsINS_19PxDeletionEventFlag4EnumEhEEb,__ZN5physx9NpPhysics31registerDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj,__ZN5physx9NpPhysics33unregisterDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE,__ZNK5physx15PxsParticleData13getParticlesVERNS_30PxvParticleSystemStateDataDescEbb,__ZN5physx15PxsParticleData13setPositionsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE,__ZN5physx15PxsParticleData14setVelocitiesVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE,__ZN5physx15PxsParticleData15setRestOffsetsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKfEE,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE,__ZN5physx14NpRigidDynamic8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb
,__ZN5physx14NpRigidDynamic9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb,__ZN5physx7NpScene12removeActorsEPKPNS_7PxActorEjb,__ZN5physx7NpScene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE,__ZNK5physx7NpScene21getDominanceGroupPairEhh,__ZN5physx7NpScene14resetFilteringERNS_12PxRigidActorEPKPNS_7PxShapeEj,__ZN5physx2Sq12BucketPruner13updateObjectsEPKjPKNS_9PxBounds3Ej,__ZN5physx2Sq10AABBPruner13updateObjectsEPKjPKNS_9PxBounds3Ej,__ZNK5physx2Gu10ConvexMesh18getMassInformationERfRNS_7PxMat33ERNS_6PxVec3E,__ZN5physx20PxsParticleSystemSim16onRbShapeChangeVERKNS_16PxvParticleShapeEjj,__ZN16RTreeCookerRemap5remapEPjjj,__ZN5physx2Cm10Collection3addERNS_6PxBaseEy,__ZN5physx2Cm10Collection5addIdERNS_6PxBaseEy,__ZNK5Unity14CharacterJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_,__ZNK5Unity17ConfigurableJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_,__ZNK5Unity5Joint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_,__ZN14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj,__ZThn28_N14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj,__ZNK12PhysXRaycast12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP8Colliderj,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty,__ZN12_GLOBAL__N_118LegacySerialStream17registerReferenceERN5physx6PxBaseEjj,__ZN5physx9NpPhysics20MeshDeletionListener28onGuMeshFactoryBufferReleaseEPKNS_6PxBaseEtb,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_,__ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_,__ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyERKN5physx8debugger14NamespacedNameEPKc
,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyEN5physx8debugger18NonNegativeIntegerEPKc,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl16checkMarshallingEN5physx8debugger18NonNegativeIntegerES3_,__ZN12_GLOBAL__N_124PropertyDefinitionHelper17pushBracketedNameEPKcS2_S2_,__ZN12_GLOBAL__N_124PropertyDefinitionHelper21addPropertyMessageArgERKN5physx8debugger14NamespacedNameEjj,__ZN12_GLOBAL__N_124PropertyDefinitionHelper18addPropertyMessageERKN5physx8debugger14NamespacedNameES5_j,__ZN25b2CapsuleAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN16b2CapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN24b2ChainAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN23b2ChainAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN24b2ChainAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN15b2CircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN23b2EdgeAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN22b2EdgeAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN23b2EdgeAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN26b2PolygonAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN25b2PolygonAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN16b2PolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_,__ZN16Physics2DManager12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP10Collider2Dj,__ZNK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE,__ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv,__ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv,__ZThn4_NK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE,__ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv,__ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j
,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j,__ZN8Animator38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei,__ZN17AnimationPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN27AnimationLayerMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN22AnimationMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN21AnimationPosePlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN21AnimationClipPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN26AnimatorControllerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN16MecanimAnimation25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding,__ZN23AnimationOffsetPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput,__ZN29AnimationStateNetworkProvider24GetNetworkAnimationStateER9AnimationP24AnimationStateForNetworki,__ZN29AnimationStateNetworkProvider24SetNetworkAnimationStateER9AnimationPK24AnimationStateForNetworki,__ZN14TerrainManager20CollectTreeRenderersEPK6CameraR13dynamic_arrayI9SceneNodeLj4EERS3_I4AABBLj4EE,__ZNK14TerrainManager23CollectLODGroupManagersEPK6CameraPP15LODGroupManagerj,__ZN14TerrainManager21OffsetLightmapIndicesER18AwakeFromLoadQueueii,__ZN22BaseUnityConnectClient22OnRestoreFileAsyncDoneERK8UnityStrS2_b,__ZN18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_,__ZThn680_N18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_,__ZN19UnityConnectService18OnAdsIdRequestDoneERK8UnityStrbS2_,__ZN8VRDevice21SetStereoRenderTargetEP6Camera15StereoscopicEye16SinglePassStereo,__ZNK8VRDevice13GetViewMatrixEPK6Camera21MonoOrStereoscopicEye,__ZNK8VRDevice19GetProjectionMatrixEPK6Camera21MonoOrStereoscopicEye,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj,__ZNKSt3__27collateIcE12do_transformEPKcS3_
,__ZNKSt3__27collateIwE12do_transformEPKwS3_,__ZNKSt3__214collate_bynameIcE12do_transformEPKcS3_,__ZNKSt3__214collate_bynameIwE12do_transformEPKwS3_,__ZNSt3__212strstreambuf7seekposENS_4fposI11__mbstate_tEEj,__ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,__ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi,_UNITY_png_set_mem_fn,_UNITY_png_set_error_fn,_fullsize_smooth_downsample,_fullsize_downsample,_jsimd_h2v1_downsample,_h2v1_downsample,_h2v2_smooth_downsample,_jsimd_h2v2_downsample,_h2v2_downsample,_int_downsample,_process_data_simple_main,_noop_upsample,_fullsize_upsample,_jsimd_h2v1_fancy_upsample,_h2v1_fancy_upsample,_jsimd_h2v1_upsample,_h2v1_upsample,_h2v2_fancy_upsample,_jsimd_h2v2_fancy_upsample,_jsimd_h2v2_upsample,_h2v2_upsample,_int_upsample,_process_data_context_main
,_process_data_simple_main_30,__Z22ValidateTlsfAllocationPvjiS_,__ZN8DrawUtil24DrawMeshRawFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi,__Z38CanvasBatchIntermediateRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi,__ZN12_GLOBAL__N_1L37PostProcessCullResultsForSkyboxProbesEPK9SceneNodePK4AABBR9IndexListPv,_UNITY_png_read_rows,_UNITY_png_set_write_fn,__ZN8DrawUtil28DrawLineOrTrailFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi,__ZN12LineRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f,__ZN13TrailRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f,__Z24BillboardRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi,__Z26SkinnedMeshRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi,__Z42SkinnedMeshRenderer_RenderWithLastPositionRK15RenderNodeQueuejRK14ChannelAssignsi,__Z21SpriteRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi,__ZL25LogCallbackImplementationRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib,__Z35Component_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i,__Z28Component_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i,__Z33Component_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i,__Z31ComputeShader_CUSTOM_SetTextureP12Il2CppObjectiiS0_,__Z41ComputeShader_CUSTOM_SetTextureFromGlobalP12Il2CppObjectiii,__Z30ComputeShader_CUSTOM_SetBufferP12Il2CppObjectiiS0_,__Z46ComputeShader_CUSTOM_Internal_DispatchIndirectP12Il2CppObjectiS0_j,__Z31ComputeBuffer_CUSTOM_InitBufferP12Il2CppObjectiij,__Z34Display_CUSTOM_ActivateDisplayImpl13Il2Cpp_IntPtriii,__Z36GameObject_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i,__Z29GameObject_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i,__Z34GameObject_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i,__Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow1P12Il2CppObjectRK8Vector3fRK11Quaternionfi,__Z37Graphics_CUSTOM_Internal_BlitMultiTapP12Il2CppObjectS0_S0_P11Il2CppArray,__Z27Screen_CUSTOM_SetResolutioniihi
,__Z34Matrix4x4_CUSTOM_INTERNAL_CALL_TRSRK8Vector3fRK11QuaternionfS1_R10Matrix4x4f,__Z25Mesh_CUSTOM_CombineMeshesP12Il2CppObjectP11Il2CppArrayhh,__Z39Texture2D_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiRK10ColorRGBAf,__Z39Texture2D_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf,__Z24Cubemap_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii,__Z30Cubemap_CUSTOM_Internal_CreateP12Il2CppObjecti13TextureFormath,__Z31Texture2DArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii,__Z33Texture2DArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayii,__Z31SparseTexture_CUSTOM_UnloadTileP12Il2CppObjectiii,__Z18WWW_CUSTOM_InitWWWP12Il2CppObjectP12Il2CppStringP11Il2CppArrayS4_,__Z28WWW_CUSTOM_INTERNAL_CALL_WWWP12Il2CppObjectP12Il2CppStringRK7Hash128j,__Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedMethod13Il2Cpp_IntPtrS_hRPv,__Z48AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedField13Il2Cpp_IntPtrS_hRPv,__Z41AndroidJNI_CUSTOM_INTERNAL_CALL_NewObject13Il2Cpp_IntPtrS_P11Il2CppArrayRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_GetMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv,__Z42AndroidJNI_CUSTOM_INTERNAL_CALL_GetFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv,__Z49AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv,__Z48AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv,__Z48AndroidJNI_CUSTOM_INTERNAL_CALL_CallObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv,__Z30AndroidJNI_CUSTOM_SetLongField13Il2Cpp_IntPtrS_x,__Z54AndroidJNI_CUSTOM_INTERNAL_CALL_CallStaticObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv,__Z36AndroidJNI_CUSTOM_SetStaticLongField13Il2Cpp_IntPtrS_x,__Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewObjectArrayi13Il2Cpp_IntPtrS_RPv,__Z37AndroidJNI_CUSTOM_SetLongArrayElement13Il2Cpp_IntPtrix,_default_walker,_glBlendFuncSeparate__wrapper,_glBufferData__wrapper,_glBufferSubData__wrapper,_glColorMask__wrapper,_glDrawElements__wrapper,_glFramebufferRenderbuffer__wrapper,_glGetFramebufferAttachmentParameteriv__wrapper,_glGetProgramInfoLog__wrapper,_glGetShaderSource__wrapper,_glGetShaderInfoLog__wrapper,_glGetShaderPrecisionFormat__wrapper,_glRenderbufferStorage__wrapper,_glScissor__wrapper,_glShaderSource__wrapper,_glStencilFuncSeparate__wrapper,_glStencilOpSeparate__wrapper,_glUniformMatrix3fv__wrapper,_glUniformMatrix4fv__wrapper,_glViewport__wrapper,_glTransformFeedbackVaryings__wrapper,_glDrawArraysInstanced__wrapper,_glGetActiveUniformBlockiv__wrapper,_glProgramBinary__wrapper,__Z35ParticleSystemRenderer_RenderMeshesRK15RenderNodeQueuejRK14ChannelAssignsi,__Z39ParticleSystemRenderer_RenderBillboardsRK15RenderNodeQueuejRK14ChannelAssignsi,__ZN14ParticleSystem26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f,__Z53ParticleSystem_SubEmittersModule_CUSTOM_AddSubEmitterP12Il2CppObjectS0_ii,__ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX8convert8EPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX9convert16EPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX9convert32EPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX9convert64EPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX12convertFloatEPKcRKNS0_15PxMetaDataEntryES6_,__ZN5physx2Sn5ConvX11convertPad8EPKcRKNS0_15PxMetaDataEntryES6_,__Z17SetNbTriggerPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j
,__Z13SetNbCCDPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j,__Z25SetNbModifiedContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j,__Z25SetNbDiscreteContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j,__Z49Rigidbody_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK8Vector3fS3_i,__Z51Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK13Vector2fIcallS3_N11Rigidbody2D9ForceModeE,__Z54PolygonCollider2D_CUSTOM_INTERNAL_CALL_CreatePrimitiveP12Il2CppObjectiRK13Vector2fIcallS3_,__Z40AudioSource_CUSTOM_GetSpectrumDataHelperP12Il2CppObjectP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW,__Z43WebCamTexture_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf,__Z27StateChangeValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object,__Z28StateMachineValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object,__Z43Animator_CUSTOM_GetAnimatorClipInfoInternalP12Il2CppObjectihS0_,__Z50AnimatorOverrideController_CUSTOM_Internal_SetClipP12Il2CppObjectS0_S0_h,__Z37Avatar_CUSTOM_INTERNAL_CALL_GetZYRollP12Il2CppObjectiRK8Vector3fR11Quaternionf,__Z27QuadTreeNodeRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi,_gray_render_span,_t2_hints_stems,_ps_hints_t2mask,_Direct_Move,_Direct_Move_Orig,_Direct_Move_X,_Direct_Move_Orig_X,_Direct_Move_Y,_Direct_Move_Orig_Y,__Z38Font_CUSTOM_RequestCharactersInTextureP12Il2CppObjectP12Il2CppStringii,__Z58RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustPointRK13Vector2fIcallP12Il2CppObjectS3_RS_,__Z34DeveloperConsole_HandleLogFunctionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib,__Z62GUIStyle_CUSTOM_INTERNAL_CALL_Internal_CalcSizeWithConstraints13Il2Cpp_IntPtrP12Il2CppObjectRK13Vector2fIcallPS2_,__Z40GUIStyle_CUSTOM_Internal_CalcMinMaxWidth13Il2Cpp_IntPtrP12Il2CppObjectPfS2_,__Z33GUIClip_CUSTOM_INTERNAL_CALL_PushRK5RectTIfERK13Vector2fIcallS5_h,__Z62DownloadHandler_CUSTOM_INTERNAL_CALL_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringRK7Hash128j
,__ZN14UnityAnalytics29OnSceneLoadedAfterAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZN19UnityConnectService30OnSceneLoadedBeforeAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZL26DrawParticlesFromNodeQueueRK15RenderNodeQueuejRK14ChannelAssignsi,_emscripten_glBufferData__wrapper,_emscripten_glBufferSubData__wrapper,_emscripten_glUniform3i__wrapper,_emscripten_glUniformMatrix2fv__wrapper,_emscripten_glUniformMatrix3fv__wrapper,_emscripten_glUniformMatrix4fv__wrapper,_emscripten_glGetAttachedShaders__wrapper,_emscripten_glShaderSource__wrapper,_emscripten_glGetShaderSource__wrapper,_emscripten_glGetShaderInfoLog__wrapper,_emscripten_glGetShaderPrecisionFormat__wrapper,_emscripten_glGetProgramInfoLog__wrapper,_emscripten_glFramebufferRenderbuffer__wrapper,_emscripten_glGetFramebufferAttachmentParameteriv__wrapper,_emscripten_glGetInfoLogARB__wrapper,_emscripten_glVertexPointer__wrapper,_emscripten_glTexCoordPointer__wrapper,_emscripten_glColorPointer__wrapper,_emscripten_glDrawElements__wrapper,_emscripten_glDrawArraysInstanced__wrapper,_emscripten_glViewport__wrapper,_emscripten_glScissor__wrapper,_emscripten_glColorMask__wrapper,_emscripten_glRenderbufferStorage__wrapper,_emscripten_glBlendFuncSeparate__wrapper,_emscripten_glStencilFuncSeparate__wrapper,_emscripten_glStencilOpSeparate__wrapper,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj,__ZNSt3__26locale5__impC2ERKS1_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi,__ZNSt3__26locale5__impC2ERKS1_S3_i,__ZNSt3__26locale5__impC2ERKS1_PNS0_5facetEl,___assert_fail__wrapper,__ZN10__cxxabiv112_GLOBAL__N_18demangleINS0_2DbEEEvPKcS4_RT_Ri,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcjj,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67
,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67
,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67
,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67
,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67,b67
,b67,b67,b67];
var FUNCTION_TABLE_viiiii = [b68,__ZN13ScreenManager17RequestResolutionEiibi,__ZN8Playable7ProcessEiRK9FrameDataP14DirectorPlayerPv,__ZN9GfxDevice19CreateComputeBufferE15ComputeBufferIDjjj,__ZN9GfxDevice17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv,__ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj,__ZN9GfxDevice31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj,__ZN10PngDecoder16DecodePixelsImplEPhjb13TextureFormat,__ZN11JpegDecoder16DecodePixelsImplEPhjb13TextureFormat,__ZN13GfxDeviceGLES19CreateComputeBufferE15ComputeBufferIDjjj,__ZN13GfxDeviceGLES17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv,__ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj,__ZN13GfxDeviceGLES31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj,__ZN11UmbraModule25SetOcclusionPortalEnabledEPKN5Umbra4TomeEPvjb,__ZN11UmbraModule38RemoveDuplicatesFromMultipleIndexListsER13CullingOutputPKN5Umbra4TomeEPPNS2_10VisibilityEi,__ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx3Cct8SweptBox18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E,__ZNK5physx3Cct12SweptCapsule18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E,__ZN12_GLOBAL__N_116D6JointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j
,__ZN5physx22PxDefaultErrorCallback11reportErrorENS_11PxErrorCode4EnumEPKcS4_i,__ZN11ErrorStream11reportErrorEN5physx11PxErrorCode4EnumEPKcS4_i,__ZN12_GLOBAL__N_122DistanceJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j,__ZN12_GLOBAL__N_119FixedJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j,__ZN12_GLOBAL__N_123PrismaticJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j,__ZN12_GLOBAL__N_122RevoluteJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j,__ZN12_GLOBAL__N_123SphericalJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j,__ZN5physx14NpArticulation12applyImpulseEPNS_18PxArticulationLinkERKNS_24PxArticulationDriveCacheERKNS_6PxVec3ES8_,__ZN5physx7NpCloth19setVirtualParticlesEjPKjjPKNS_6PxVec3E,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_,__ZN5physx23PxsBroadPhaseContextSap6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE,__ZN5physx16PxsBroadPhaseMBP6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj,__ZN5physx2Sn18RepXCollectionImpl25addRepXObjectToCollectionERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_23PxRepXInstantiationArgsE,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE,__ZN12_GLOBAL__N_110Connection9setCameraEPKcRKN5physx6PxVec3ES6_S6_,__ZN12_GLOBAL__N_110Connection16sendErrorMessageEjPKcS2_j
,__ZN12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i,__ZThn12_N12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i,__ZN12_GLOBAL__N_110DataStream19addProfileZoneEventEPvPKctb,__ZN12_GLOBAL__N_124PropertyDefinitionHelper14createPropertyERKN5physx8debugger14NamespacedNameEPKcS5_NS2_12PropertyType4EnumE,__ZN12_GLOBAL__N_112UserRenderer8drawTextEN5physx6PxVec3ENS1_8debugger8PvdColorEPKcz,__ZN12_GLOBAL__N_117ConnectionManager9setCameraEPKcRKN5physx6PxVec3ES6_S6_,__ZN12_GLOBAL__N_117ConnectionManager16sendErrorMessageEN5physx11PxErrorCode4EnumEPKcS5_j,__ZN12_GLOBAL__N_120DefaultAssertHandlerclEPKcS2_iRb,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_,__ZN13PhysicsModule31GetColliderComponentsInChildrenERK10GameObjectbbR13dynamic_arrayIPN5Unity9ComponentELj4EE,__ZNK12b2ChainShape11ComputeAABBEP6b2AABBRK11b2Transformib,__ZNK11b2EdgeShape11ComputeAABBEP6b2AABBRK11b2Transformib,__ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib,__ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib,__ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib,__ZN5physx25PxVehicleConstraintShader19visualiseConstraintERNS_22PxConstraintVisualizerEPKvRKNS_11PxTransformES7_j,__ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st,__ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st,__ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st,__ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st,__ZZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi,__ZZNK9dtNavMesh15findNearestPolyEPKfS1_PfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi,__ZZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPiiEN12PolygonQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi,__ZZL16BuildDetailHullsRNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEERK13dynamic_arrayI5PlaneLj4EERK10MinMaxAABBRK10DetailMeshPK10dtMeshTileEN12ClipCallback7processESI_RK14DetailMeshPolyPKii,__ZZL20PickDetailPolyHeightRK10DetailMeshiRK8Vector3fEN18PickHeightCallback7processES1_RK14DetailMeshPolyPKii,__ZZL16ClipDetailMeshesR13dynamic_arrayIP17ClippedDetailMeshLj4EERK11DynamicMeshRK10DetailMeshPK10dtMeshTileRK8Vector3ffEN12ClipCallback7processES9_RK14DetailMeshPolyPKii,__ZN11AudioModule12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE
,__ZNK19TextRenderingModule22TMGenGetCursorPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfEi,__ZN22BaseUnityConnectClient24OnSaveFileFromServerDoneERK8UnityStrS2_bi,__ZNK8VRDevice20GetCullingParametersEPK6CameraR10Matrix4x4fS4_Rf,__ZN24EllipsoidParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi,__ZN19MeshParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi,__ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,__ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib,_grayscale_convert,_jsimd_rgb_gray_convert,_rgb_gray_convert,_null_convert,_rgb_rgb_convert,_jsimd_rgb_ycc_convert,_rgb_ycc_convert,_cmyk_ycck_convert,_sep_downsample,_grayscale_convert_21,_rgb_gray_convert_22,_jsimd_ycc_rgb_convert,_ycc_rgb_convert,_gray_rgb_convert,_null_convert_24,_rgb_rgb_convert_25,_ycck_cmyk_convert,_jpeg_idct_islow,_jsimd_idct_islow,_jpeg_idct_ifast,_jsimd_idct_ifast,__ZN13EmscriptenWWW10OnResponseEPviS0_jPc
,__Z46ComputeShader_CUSTOM_GetKernelThreadGroupSizesP12Il2CppObjectiPjS1_S1_,__Z29ComputeShader_CUSTOM_DispatchP12Il2CppObjectiiii,__Z28Display_CUSTOM_SetParamsImpl13Il2Cpp_IntPtriiii,__Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_,__Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_,__Z39Graphics_CUSTOM_Internal_DrawMeshMatrixR36MonoInternal_DrawMeshMatrixArgumentsP12Il2CppObjectS2_S2_S2_,__Z37Graphics_CUSTOM_Internal_BlitMaterialP12Il2CppObjectS0_S0_ih,__Z36Graphics_CUSTOM_Internal_SetRTSimpleP21ScriptingRenderBufferS0_iii,__Z37Graphics_CUSTOM_Internal_SetMRTSimpleP11Il2CppArrayP21ScriptingRenderBufferiii,__Z35Mesh_CUSTOM_GetArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray,__Z28Mesh_CUSTOM_SetTrianglesImplP12Il2CppObjectiP11Il2CppArrayih,__Z42CommandBuffer_CUSTOM_Internal_DrawRendererP12Il2CppObjectS0_S0_ii,__Z43CommandBuffer_CUSTOM_SetRenderTarget_SingleP12Il2CppObjectR26MonoRenderTargetIdentifieriii,__Z33CommandBuffer_CUSTOM_Blit_TextureP12Il2CppObjectS0_R26MonoRenderTargetIdentifierS0_i,__Z36CommandBuffer_CUSTOM_Blit_IdentifierP12Il2CppObjectR26MonoRenderTargetIdentifierS2_S0_i,__Z41Texture2D_CUSTOM_INTERNAL_CALL_ReadPixelsP12Il2CppObjectRK5RectTIfEiih,__Z37Cubemap_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiiRK10ColorRGBAf,__Z37Cubemap_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiiR10ColorRGBAf,__Z29CubemapArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayiii,__Z31CubemapArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayiii,__Z31SparseTexture_CUSTOM_UpdateTileP12Il2CppObjectiiiP11Il2CppArray,__Z34SparseTexture_CUSTOM_UpdateTileRawP12Il2CppObjectiiiP11Il2CppArray,__ZN13MemoryManager22LogAllocationToConsoleEPvjPKcS2_i,_glFramebufferTexture2D__wrapper,_glTexStorage2D__wrapper,_glRenderbufferStorageMultisample__wrapper,_glDrawElementsInstanced__wrapper,_glCopyBufferSubData__wrapper,_glFramebufferTextureLayer__wrapper,_glGetActiveUniformsiv__wrapper,_glGetActiveUniformBlockName__wrapper,_glVertexAttribIPointer__wrapper,_glGetProgramBinary__wrapper,_glGetInternalformativ__wrapper,__ZN14ParticleSystem15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType,__Z55ParticleSystemExtensionsImpl_CUSTOM_SetTriggerParticlesP12Il2CppObjectiS0_ii,__Z49WebCamTexture_CUSTOM_Internal_CreateWebCamTextureP12Il2CppObjectP12Il2CppStringiii,__Z29AnimationClip_CUSTOM_SetCurveP12Il2CppObjectP12Il2CppStringS0_S2_S0_,__Z61AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoInternal9HPlayableRS_ihP12Il2CppObject,__Z38Avatar_CUSTOM_INTERNAL_CALL_GetZYPostQP12Il2CppObjectiRK11QuaternionfS3_RS1_,__Z27Terrain_CUSTOM_SetNeighborsP12Il2CppObjectS0_S0_S0_S0_,_UNITY_tt_face_get_metrics,_psh_globals_set_scale,__Z44GUIStyle_CUSTOM_INTERNAL_CALL_Internal_Draw213Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih,__Z54GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawPrefixLabel13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih,__Z49GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawCursor13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiRK10ColorRGBAf,__Z61GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorPixelPosition13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiP13Vector2fIcall,__ZN19TransportJavaScript10OnResponseEPviS0_jPc,__ZN18CrashReportManager33OnPlayerSessionStateChangedStaticEjyy,__ZN18CrashReportHandler17HandleLogCallbackEPS_RKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_ib,_emscripten_glUniform4i__wrapper,_emscripten_glFramebufferTexture2D__wrapper,_emscripten_glShaderBinary__wrapper,_emscripten_glDrawElementsInstanced__wrapper,b68,b68,b68,b68,b68,b68
,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68
,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68
,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68,b68];
var FUNCTION_TABLE_vif = [b69,__ZN5physx3Cct13BoxController13setStepOffsetEf,__ZN5physx3Cct13BoxController16setContactOffsetEf,__ZN5physx3Cct13BoxController13setSlopeLimitEf,__ZN5physx3Cct13BoxController6resizeEf,__ZN5physx3Cct17CapsuleController13setStepOffsetEf,__ZN5physx3Cct17CapsuleController16setContactOffsetEf,__ZN5physx3Cct17CapsuleController13setSlopeLimitEf,__ZN5physx3Cct17CapsuleController6resizeEf,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext7D6Joint28setProjectionLinearToleranceEf,__ZN5physx3Ext7D6Joint29setProjectionAngularToleranceEf,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext13DistanceJoint14setMinDistanceEf,__ZN5physx3Ext13DistanceJoint14setMaxDistanceEf,__ZN5physx3Ext13DistanceJoint12setToleranceEf,__ZN5physx3Ext13DistanceJoint12setStiffnessEf,__ZN5physx3Ext13DistanceJoint10setDampingEf,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext10FixedJoint28setProjectionLinearToleranceEf
,__ZN5physx3Ext10FixedJoint29setProjectionAngularToleranceEf,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext14PrismaticJoint28setProjectionLinearToleranceEf,__ZN5physx3Ext14PrismaticJoint29setProjectionAngularToleranceEf,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext13RevoluteJoint16setDriveVelocityEf,__ZN5physx3Ext13RevoluteJoint18setDriveForceLimitEf,__ZN5physx3Ext13RevoluteJoint17setDriveGearRatioEf,__ZN5physx3Ext13RevoluteJoint28setProjectionLinearToleranceEf,__ZN5physx3Ext13RevoluteJoint29setProjectionAngularToleranceEf,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale0Ef,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale0Ef,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale1Ef,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale1Ef,__ZN5physx3Ext14SphericalJoint28setProjectionLinearToleranceEf,__ZN5physx14NpArticulation22setSeparationToleranceEf,__ZN5physx14NpArticulation17setSleepThresholdEf,__ZN5physx14NpArticulation25setStabilizationThresholdEf,__ZN5physx14NpArticulation14setWakeCounterEf,__ZN5physx19NpArticulationJoint12setStiffnessEf,__ZN5physx19NpArticulationJoint10setDampingEf,__ZN5physx19NpArticulationJoint21setInternalComplianceEf,__ZN5physx19NpArticulationJoint21setExternalComplianceEf,__ZN5physx19NpArticulationJoint22setTangentialStiffnessEf
,__ZN5physx19NpArticulationJoint20setTangentialDampingEf,__ZN5physx19NpArticulationJoint28setSwingLimitContactDistanceEf,__ZN5physx19NpArticulationJoint28setTwistLimitContactDistanceEf,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7setMassEf,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMinCCDAdvanceCoefficientEf,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMaxDepenetrationVelocityEf,__ZN5physx12NpConstraint23setMinResponseThresholdEf,__ZN5physx10NpMaterial18setDynamicFrictionEf,__ZN5physx10NpMaterial17setStaticFrictionEf,__ZN5physx10NpMaterial14setRestitutionEf,__ZN5physx7NpShape16setContactOffsetEf,__ZN5physx7NpShape13setRestOffsetEf,__ZN5physx7NpCloth18setSolverFrequencyEf,__ZN5physx7NpCloth21setStiffnessFrequencyEf,__ZN5physx7NpCloth15setInertiaScaleEf,__ZN5physx7NpCloth18setDragCoefficientEf,__ZN5physx7NpCloth22setFrictionCoefficientEf,__ZN5physx7NpCloth21setCollisionMassScaleEf,__ZN5physx7NpCloth24setSelfCollisionDistanceEf,__ZN5physx7NpCloth25setSelfCollisionStiffnessEf,__ZN5physx7NpCloth16setContactOffsetEf,__ZN5physx7NpCloth13setRestOffsetEf,__ZN5physx7NpCloth22setSleepLinearVelocityEf,__ZN5physx7NpCloth14setWakeCounterEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10setDampingEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15setParticleMassEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestitutionEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setDynamicFrictionEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17setStaticFrictionEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20setMaxMotionDistanceEf
,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setRestOffsetEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16setContactOffsetEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11setGridSizeEf,__ZN5physx15NpParticleFluid12setStiffnessEf,__ZN5physx15NpParticleFluid12setViscosityEf,__ZN5physx15NpParticleFluid23setRestParticleDistanceEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10setDampingEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15setParticleMassEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestitutionEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setDynamicFrictionEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17setStaticFrictionEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20setMaxMotionDistanceEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setRestOffsetEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16setContactOffsetEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11setGridSizeEf,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7setMassEf,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMinCCDAdvanceCoefficientEf,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMaxDepenetrationVelocityEf,__ZN5physx14NpRigidDynamic16setLinearDampingEf,__ZN5physx14NpRigidDynamic17setAngularDampingEf,__ZN5physx14NpRigidDynamic21setMaxAngularVelocityEf,__ZN5physx14NpRigidDynamic17setSleepThresholdEf,__ZN5physx14NpRigidDynamic25setStabilizationThresholdEf,__ZN5physx14NpRigidDynamic14setWakeCounterEf,__ZN5physx14NpRigidDynamic25setContactReportThresholdEf,__ZN5physx7NpScene30setClothInterCollisionDistanceEf,__ZN5physx7NpScene31setClothInterCollisionStiffnessEf,__ZN5physx7NpScene26setBounceThresholdVelocityEf,__ZN5physx13NpClothFabric16scaleRestlengthsEf,__ZN5physx20PxsParticleSystemSim22setSimulationTimeStepVEf
,__ZN14AreaEffector2D21ContactUpdateCallbackEf,__ZN18BuoyancyEffector2D21ContactUpdateCallbackEf,__ZN18PlatformEffector2D21ContactUpdateCallbackEf,__ZN15PointEffector2D21ContactUpdateCallbackEf,__ZN17SurfaceEffector2D21ContactUpdateCallbackEf,__ZN14VehiclesModule14UpdateVehiclesEf,__ZN5physx5cloth8SwFabric15scaleRestvaluesEf,__ZN5physx5cloth8SwFabric18scaleTetherLengthsEf,__ZThn4_N5physx5cloth8SwFabric15scaleRestvaluesEf,__ZThn4_N5physx5cloth8SwFabric18scaleTetherLengthsEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf,__ZN5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf
,__ZN5physx5cloth8SwSolver25setInterCollisionDistanceEf,__ZN5physx5cloth8SwSolver26setInterCollisionStiffnessEf,__ZThn4_N5physx5cloth8SwSolver25setInterCollisionDistanceEf,__ZThn4_N5physx5cloth8SwSolver26setInterCollisionStiffnessEf,__ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13SetFloatValueEPvf,__Z35BillboardAsset_Set_Custom_PropWidthP12Il2CppObjectf,__Z36BillboardAsset_Set_Custom_PropHeightP12Il2CppObjectf,__Z36BillboardAsset_Set_Custom_PropBottomP12Il2CppObjectf,__Z33Camera_Set_Custom_PropFieldOfViewP12Il2CppObjectf,__Z35Camera_Set_Custom_PropNearClipPlaneP12Il2CppObjectf,__Z34Camera_Set_Custom_PropFarClipPlaneP12Il2CppObjectf,__Z38Camera_Set_Custom_PropOrthographicSizeP12Il2CppObjectf,__Z27Camera_Set_Custom_PropDepthP12Il2CppObjectf,__Z28Camera_Set_Custom_PropAspectP12Il2CppObjectf,__Z38Camera_Set_Custom_PropStereoSeparationP12Il2CppObjectf,__Z39Camera_Set_Custom_PropStereoConvergenceP12Il2CppObjectf,__Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawWireSphereRK8Vector3ff,__Z38Gizmos_CUSTOM_INTERNAL_CALL_DrawSphereRK8Vector3ff,__Z35LensFlare_Set_Custom_PropBrightnessP12Il2CppObjectf,__Z34LensFlare_Set_Custom_PropFadeSpeedP12Il2CppObjectf,__Z38Projector_Set_Custom_PropNearClipPlaneP12Il2CppObjectf,__Z37Projector_Set_Custom_PropFarClipPlaneP12Il2CppObjectf,__Z36Projector_Set_Custom_PropFieldOfViewP12Il2CppObjectf,__Z36Projector_Set_Custom_PropAspectRatioP12Il2CppObjectf,__Z41Projector_Set_Custom_PropOrthographicSizeP12Il2CppObjectf,__Z33TrailRenderer_Set_Custom_PropTimeP12Il2CppObjectf,__Z39TrailRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf,__Z37TrailRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf,__Z44TrailRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf,__Z46TrailRenderer_Set_Custom_PropMinVertexDistanceP12Il2CppObjectf
,__Z38LineRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf,__Z36LineRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf,__Z43LineRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf,__Z43Gyroscope_CUSTOM_setUpdateInterval_Internalif,__Z28LODGroup_Set_Custom_PropSizeP12Il2CppObjectf,__Z30Light_Set_Custom_PropIntensityP12Il2CppObjectf,__Z36Light_Set_Custom_PropBounceIntensityP12Il2CppObjectf,__Z35Light_Set_Custom_PropShadowStrengthP12Il2CppObjectf,__Z31Light_Set_Custom_PropShadowBiasP12Il2CppObjectf,__Z37Light_Set_Custom_PropShadowNormalBiasP12Il2CppObjectf,__Z36Light_Set_Custom_PropShadowNearPlaneP12Il2CppObjectf,__Z35Light_Set_Custom_PropShadowSoftnessP12Il2CppObjectf,__Z39Light_Set_Custom_PropShadowSoftnessFadeP12Il2CppObjectf,__Z26Light_Set_Custom_PropRangeP12Il2CppObjectf,__Z30Light_Set_Custom_PropSpotAngleP12Il2CppObjectf,__Z31Light_Set_Custom_PropCookieSizeP12Il2CppObjectf,__Z49LightProbeProxyVolume_Set_Custom_PropProbeDensityP12Il2CppObjectf,__Z44ReflectionProbe_Set_Custom_PropNearClipPlaneP12Il2CppObjectf,__Z43ReflectionProbe_Set_Custom_PropFarClipPlaneP12Il2CppObjectf,__Z45ReflectionProbe_Set_Custom_PropShadowDistanceP12Il2CppObjectf,__Z40ReflectionProbe_Set_Custom_PropIntensityP12Il2CppObjectf,__Z44ReflectionProbe_Set_Custom_PropBlendDistanceP12Il2CppObjectf,__Z28Shader_CUSTOM_SetGlobalFloatif,__Z33Texture_Set_Custom_PropMipMapBiasP12Il2CppObjectf,__Z21Object_CUSTOM_DestroyP12Il2CppObjectf,__Z27Object_CUSTOM_DestroyObjectP12Il2CppObjectf,__Z30WindZone_Set_Custom_PropRadiusP12Il2CppObjectf,__Z32WindZone_Set_Custom_PropWindMainP12Il2CppObjectf,__Z38WindZone_Set_Custom_PropWindTurbulenceP12Il2CppObjectf,__Z42WindZone_Set_Custom_PropWindPulseMagnitudeP12Il2CppObjectf
,__Z42WindZone_Set_Custom_PropWindPulseFrequencyP12Il2CppObjectf,__Z44ParticleSystem_MainModule_CUSTOM_SetDurationP12Il2CppObjectf,__Z56ParticleSystem_MainModule_CUSTOM_SetStartDelayMultiplierP12Il2CppObjectf,__Z59ParticleSystem_MainModule_CUSTOM_SetStartLifetimeMultiplierP12Il2CppObjectf,__Z56ParticleSystem_MainModule_CUSTOM_SetStartSpeedMultiplierP12Il2CppObjectf,__Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeXMultiplierP12Il2CppObjectf,__Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeYMultiplierP12Il2CppObjectf,__Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeZMultiplierP12Il2CppObjectf,__Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationXMultiplierP12Il2CppObjectf,__Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationYMultiplierP12Il2CppObjectf,__Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationZMultiplierP12Il2CppObjectf,__Z62ParticleSystem_MainModule_CUSTOM_SetRandomizeRotationDirectionP12Il2CppObjectf,__Z61ParticleSystem_MainModule_CUSTOM_SetGravityModifierMultiplierP12Il2CppObjectf,__Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpeedP12Il2CppObjectf,__Z62ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeMultiplierP12Il2CppObjectf,__Z66ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceMultiplierP12Il2CppObjectf,__Z58ParticleSystem_ShapeModule_CUSTOM_SetRandomDirectionAmountP12Il2CppObjectf,__Z61ParticleSystem_ShapeModule_CUSTOM_SetSphericalDirectionAmountP12Il2CppObjectf,__Z43ParticleSystem_ShapeModule_CUSTOM_SetRadiusP12Il2CppObjectf,__Z42ParticleSystem_ShapeModule_CUSTOM_SetAngleP12Il2CppObjectf,__Z43ParticleSystem_ShapeModule_CUSTOM_SetLengthP12Il2CppObjectf,__Z49ParticleSystem_ShapeModule_CUSTOM_SetNormalOffsetP12Il2CppObjectf,__Z46ParticleSystem_ShapeModule_CUSTOM_SetMeshScaleP12Il2CppObjectf,__Z40ParticleSystem_ShapeModule_CUSTOM_SetArcP12Il2CppObjectf,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf
,__Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeMultiplierP12Il2CppObjectf,__Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetDampenP12Il2CppObjectf,__Z62ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveMultiplierP12Il2CppObjectf,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf,__Z56ParticleSystem_ExternalForcesModule_CUSTOM_SetMultiplierP12Il2CppObjectf,__Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthXMultiplierP12Il2CppObjectf,__Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthYMultiplierP12Il2CppObjectf,__Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthZMultiplierP12Il2CppObjectf,__Z46ParticleSystem_NoiseModule_CUSTOM_SetFrequencyP12Il2CppObjectf,__Z53ParticleSystem_NoiseModule_CUSTOM_SetOctaveMultiplierP12Il2CppObjectf,__Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveScaleP12Il2CppObjectf,__Z58ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedMultiplierP12Il2CppObjectf,__Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapXMultiplierP12Il2CppObjectf,__Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapYMultiplierP12Il2CppObjectf,__Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapZMultiplierP12Il2CppObjectf,__Z57ParticleSystem_CollisionModule_CUSTOM_SetDampenMultiplierP12Il2CppObjectf
,__Z57ParticleSystem_CollisionModule_CUSTOM_SetBounceMultiplierP12Il2CppObjectf,__Z63ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossMultiplierP12Il2CppObjectf,__Z53ParticleSystem_CollisionModule_CUSTOM_SetMinKillSpeedP12Il2CppObjectf,__Z53ParticleSystem_CollisionModule_CUSTOM_SetMaxKillSpeedP12Il2CppObjectf,__Z50ParticleSystem_CollisionModule_CUSTOM_SetVoxelSizeP12Il2CppObjectf,__Z52ParticleSystem_CollisionModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf,__Z50ParticleSystem_TriggerModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf,__Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeMultiplierP12Il2CppObjectf,__Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameMultiplierP12Il2CppObjectf,__Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipUP12Il2CppObjectf,__Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipVP12Il2CppObjectf,__Z43ParticleSystem_LightsModule_CUSTOM_SetRatioP12Il2CppObjectf,__Z53ParticleSystem_LightsModule_CUSTOM_SetRangeMultiplierP12Il2CppObjectf,__Z57ParticleSystem_LightsModule_CUSTOM_SetIntensityMultiplierP12Il2CppObjectf,__Z42ParticleSystem_TrailModule_CUSTOM_SetRatioP12Il2CppObjectf,__Z55ParticleSystem_TrailModule_CUSTOM_SetLifetimeMultiplierP12Il2CppObjectf,__Z54ParticleSystem_TrailModule_CUSTOM_SetMinVertexDistanceP12Il2CppObjectf,__Z48ParticleSystem_TrailModule_CUSTOM_SetTextureModeP12Il2CppObjectf,__Z61ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailMultiplierP12Il2CppObjectf,__Z40ParticleSystem_Set_Custom_PropStartDelayP12Il2CppObjectf,__Z34ParticleSystem_Set_Custom_PropTimeP12Il2CppObjectf,__Z43ParticleSystem_Set_Custom_PropPlaybackSpeedP12Il2CppObjectf,__Z40ParticleSystem_Set_Custom_PropStartSpeedP12Il2CppObjectf,__Z39ParticleSystem_Set_Custom_PropStartSizeP12Il2CppObjectf,__Z43ParticleSystem_Set_Custom_PropStartRotationP12Il2CppObjectf,__Z43ParticleSystem_Set_Custom_PropStartLifetimeP12Il2CppObjectf,__Z45ParticleSystem_Set_Custom_PropGravityModifierP12Il2CppObjectf,__Z49ParticleSystemRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf,__Z51ParticleSystemRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf,__Z57ParticleSystemRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf
,__Z53ParticleSystemRenderer_Set_Custom_PropNormalDirectionP12Il2CppObjectf,__Z50ParticleSystemRenderer_Set_Custom_PropSortingFudgeP12Il2CppObjectf,__Z53ParticleSystemRenderer_Set_Custom_PropMinParticleSizeP12Il2CppObjectf,__Z53ParticleSystemRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf,__Z29setPxMaterial_DynamicFrictionPN5physx10PxMaterialEf,__Z28setPxMaterial_StaticFrictionPN5physx10PxMaterialEf,__Z25setPxMaterial_RestitutionPN5physx10PxMaterialEf,__Z24setPxShape_ContactOffsetPN5physx7PxShapeEf,__Z21setPxShape_RestOffsetPN5physx7PxShapeEf,__Z35setPxHeightFieldGeometryHeightScalePN5physx21PxHeightFieldGeometryEf,__Z32setPxHeightFieldGeometryRowScalePN5physx21PxHeightFieldGeometryEf,__Z35setPxHeightFieldGeometryColumnScalePN5physx21PxHeightFieldGeometryEf,__Z26setPxCapsuleGeometryRadiusPN5physx17PxCapsuleGeometryEf,__Z30setPxCapsuleGeometryHalfHeightPN5physx17PxCapsuleGeometryEf,__Z25setPxSphereGeometryRadiusPN5physx16PxSphereGeometryEf,__Z29setPxHeightFieldDescThicknessPN5physx17PxHeightFieldDescEf,__Z39setPxHeightFieldDescConvexEdgeThresholdPN5physx17PxHeightFieldDescEf,__Z31setPxRigidDynamic_LinearDampingPN5physx14PxRigidDynamicEf,__Z32setPxRigidDynamic_AngularDampingPN5physx14PxRigidDynamicEf,__Z36setPxRigidDynamic_MaxAngularVelocityPN5physx14PxRigidDynamicEf,__Z32setPxRigidDynamic_SleepThresholdPN5physx14PxRigidDynamicEf,__Z40setPxRigidDynamic_StabilizationThresholdPN5physx14PxRigidDynamicEf,__Z29setPxRigidDynamic_WakeCounterPN5physx14PxRigidDynamicEf,__Z40setPxRigidDynamic_ContactReportThresholdPN5physx14PxRigidDynamicEf,__Z19setPxRigidBody_MassPN5physx11PxRigidBodyEf,__Z39setPxRigidBody_MinCCDAdvanceCoefficientPN5physx11PxRigidBodyEf,__Z39setPxRigidBody_MaxDepenetrationVelocityPN5physx11PxRigidBodyEf,__Z32setPxArticulationJoint_StiffnessPN5physx19PxArticulationJointEf,__Z30setPxArticulationJoint_DampingPN5physx19PxArticulationJointEf,__Z41setPxArticulationJoint_InternalCompliancePN5physx19PxArticulationJointEf
,__Z41setPxArticulationJoint_ExternalCompliancePN5physx19PxArticulationJointEf,__Z42setPxArticulationJoint_TangentialStiffnessPN5physx19PxArticulationJointEf,__Z40setPxArticulationJoint_TangentialDampingPN5physx19PxArticulationJointEf,__Z48setPxArticulationJoint_SwingLimitContactDistancePN5physx19PxArticulationJointEf,__Z48setPxArticulationJoint_TwistLimitContactDistancePN5physx19PxArticulationJointEf,__Z37setPxArticulation_SeparationTolerancePN5physx14PxArticulationEf,__Z32setPxArticulation_SleepThresholdPN5physx14PxArticulationEf,__Z40setPxArticulation_StabilizationThresholdPN5physx14PxArticulationEf,__Z29setPxArticulation_WakeCounterPN5physx14PxArticulationEf,__Z31setPxClothTetherConfigStiffnessPN5physx19PxClothTetherConfigEf,__Z34setPxClothTetherConfigStretchLimitPN5physx19PxClothTetherConfigEf,__Z32setPxClothStretchConfigStiffnessPN5physx20PxClothStretchConfigEf,__Z42setPxClothStretchConfigStiffnessMultiplierPN5physx20PxClothStretchConfigEf,__Z39setPxClothStretchConfigCompressionLimitPN5physx20PxClothStretchConfigEf,__Z35setPxClothStretchConfigStretchLimitPN5physx20PxClothStretchConfigEf,__Z37setPxClothMotionConstraintConfigScalePN5physx29PxClothMotionConstraintConfigEf,__Z36setPxClothMotionConstraintConfigBiasPN5physx29PxClothMotionConstraintConfigEf,__Z41setPxClothMotionConstraintConfigStiffnessPN5physx29PxClothMotionConstraintConfigEf,__Z26setPxCloth_SolverFrequencyPN5physx7PxClothEf,__Z29setPxCloth_StiffnessFrequencyPN5physx7PxClothEf,__Z23setPxCloth_InertiaScalePN5physx7PxClothEf,__Z26setPxCloth_DragCoefficientPN5physx7PxClothEf,__Z30setPxCloth_FrictionCoefficientPN5physx7PxClothEf,__Z29setPxCloth_CollisionMassScalePN5physx7PxClothEf,__Z32setPxCloth_SelfCollisionDistancePN5physx7PxClothEf,__Z33setPxCloth_SelfCollisionStiffnessPN5physx7PxClothEf,__Z24setPxCloth_ContactOffsetPN5physx7PxClothEf,__Z21setPxCloth_RestOffsetPN5physx7PxClothEf,__Z30setPxCloth_SleepLinearVelocityPN5physx7PxClothEf,__Z22setPxCloth_WakeCounterPN5physx7PxClothEf
,__Z36setPxJointLimitParametersRestitutionPN5physx22PxJointLimitParametersEf,__Z40setPxJointLimitParametersBounceThresholdPN5physx22PxJointLimitParametersEf,__Z34setPxJointLimitParametersStiffnessPN5physx22PxJointLimitParametersEf,__Z32setPxJointLimitParametersDampingPN5physx22PxJointLimitParametersEf,__Z40setPxJointLimitParametersContactDistancePN5physx22PxJointLimitParametersEf,__Z25setPxJointLimitConeYAnglePN5physx16PxJointLimitConeEf,__Z25setPxJointLimitConeZAnglePN5physx16PxJointLimitConeEf,__Z24setPxJoint_InvMassScale0PN5physx7PxJointEf,__Z27setPxJoint_InvInertiaScale0PN5physx7PxJointEf,__Z24setPxJoint_InvMassScale1PN5physx7PxJointEf,__Z27setPxJoint_InvInertiaScale1PN5physx7PxJointEf,__Z45setPxSphericalJoint_ProjectionLinearTolerancePN5physx16PxSphericalJointEf,__Z31setPxJointAngularLimitPairUpperPN5physx23PxJointAngularLimitPairEf,__Z31setPxJointAngularLimitPairLowerPN5physx23PxJointAngularLimitPairEf,__Z32setPxRevoluteJoint_DriveVelocityPN5physx15PxRevoluteJointEf,__Z34setPxRevoluteJoint_DriveForceLimitPN5physx15PxRevoluteJointEf,__Z33setPxRevoluteJoint_DriveGearRatioPN5physx15PxRevoluteJointEf,__Z44setPxRevoluteJoint_ProjectionLinearTolerancePN5physx15PxRevoluteJointEf,__Z45setPxRevoluteJoint_ProjectionAngularTolerancePN5physx15PxRevoluteJointEf,__Z30setPxJointLinearLimitPairUpperPN5physx22PxJointLinearLimitPairEf,__Z30setPxJointLinearLimitPairLowerPN5physx22PxJointLinearLimitPairEf,__Z45setPxPrismaticJoint_ProjectionLinearTolerancePN5physx16PxPrismaticJointEf,__Z46setPxPrismaticJoint_ProjectionAngularTolerancePN5physx16PxPrismaticJointEf,__Z20setPxSpringStiffnessPN5physx8PxSpringEf,__Z18setPxSpringDampingPN5physx8PxSpringEf,__Z27setPxD6JointDriveForceLimitPN5physx14PxD6JointDriveEf,__Z26setPxJointLinearLimitValuePN5physx18PxJointLinearLimitEf,__Z38setPxD6Joint_ProjectionLinearTolerancePN5physx9PxD6JointEf,__Z39setPxD6Joint_ProjectionAngularTolerancePN5physx9PxD6JointEf,__Z30setPxDistanceJoint_MinDistancePN5physx15PxDistanceJointEf
,__Z30setPxDistanceJoint_MaxDistancePN5physx15PxDistanceJointEf,__Z28setPxDistanceJoint_TolerancePN5physx15PxDistanceJointEf,__Z28setPxDistanceJoint_StiffnessPN5physx15PxDistanceJointEf,__Z26setPxDistanceJoint_DampingPN5physx15PxDistanceJointEf,__Z41setPxFixedJoint_ProjectionLinearTolerancePN5physx12PxFixedJointEf,__Z42setPxFixedJoint_ProjectionAngularTolerancePN5physx12PxFixedJointEf,__Z28setPxParticleFluid_StiffnessPN5physx15PxParticleFluidEf,__Z28setPxParticleFluid_ViscosityPN5physx15PxParticleFluidEf,__Z39setPxParticleFluid_RestParticleDistancePN5physx15PxParticleFluidEf,__Z25setPxParticleBase_DampingPN5physx14PxParticleBaseEf,__Z30setPxParticleBase_ParticleMassPN5physx14PxParticleBaseEf,__Z29setPxParticleBase_RestitutionPN5physx14PxParticleBaseEf,__Z33setPxParticleBase_DynamicFrictionPN5physx14PxParticleBaseEf,__Z32setPxParticleBase_StaticFrictionPN5physx14PxParticleBaseEf,__Z35setPxParticleBase_MaxMotionDistancePN5physx14PxParticleBaseEf,__Z28setPxParticleBase_RestOffsetPN5physx14PxParticleBaseEf,__Z31setPxParticleBase_ContactOffsetPN5physx14PxParticleBaseEf,__Z26setPxParticleBase_GridSizePN5physx14PxParticleBaseEf,__Z26setPxTolerancesScaleLengthPN5physx17PxTolerancesScaleEf,__Z24setPxTolerancesScaleMassPN5physx17PxTolerancesScaleEf,__Z25setPxTolerancesScaleSpeedPN5physx17PxTolerancesScaleEf,__ZN5physx21PxcArticulationHelper12updateBodiesERKNS_25PxcArticulationSolverDescEf,__Z36setPxConstraint_MinResponseThresholdPN5physx12PxConstraintEf,__Z38setPxScene_ClothInterCollisionDistancePN5physx7PxSceneEf,__Z39setPxScene_ClothInterCollisionStiffnessPN5physx7PxSceneEf,__Z34setPxScene_BounceThresholdVelocityPN5physx7PxSceneEf,__Z27setPxClothParticleInvWeightPN5physx15PxClothParticleEf,__Z31setPxSceneDescMeshContactMarginPN5physx11PxSceneDescEf,__Z40setPxSceneDescContactCorrelationDistancePN5physx11PxSceneDescEf,__Z37setPxSceneDescBounceThresholdVelocityPN5physx11PxSceneDescEf
,__Z37setPxSceneDescFrictionOffsetThresholdPN5physx11PxSceneDescEf,__Z35setPxSceneDescWakeCounterResetValuePN5physx11PxSceneDescEf,__Z53setPxSimulationStatisticsParticlesGpuMeshCacheHitratePN5physx22PxSimulationStatisticsEf,__Z29Rigidbody_Set_Custom_PropDragP12Il2CppObjectf,__Z36Rigidbody_Set_Custom_PropAngularDragP12Il2CppObjectf,__Z29Rigidbody_Set_Custom_PropMassP12Il2CppObjectf,__Z41Rigidbody_CUSTOM_INTERNAL_CALL_SetDensityP12Il2CppObjectf,__Z49Rigidbody_Set_Custom_PropMaxDepenetrationVelocityP12Il2CppObjectf,__Z38Rigidbody_Set_Custom_PropSleepVelocityP12Il2CppObjectf,__Z45Rigidbody_Set_Custom_PropSleepAngularVelocityP12Il2CppObjectf,__Z39Rigidbody_Set_Custom_PropSleepThresholdP12Il2CppObjectf,__Z43Rigidbody_Set_Custom_PropMaxAngularVelocityP12Il2CppObjectf,__Z31Joint_Set_Custom_PropBreakForceP12Il2CppObjectf,__Z32Joint_Set_Custom_PropBreakTorqueP12Il2CppObjectf,__Z33SpringJoint_Set_Custom_PropSpringP12Il2CppObjectf,__Z33SpringJoint_Set_Custom_PropDamperP12Il2CppObjectf,__Z38SpringJoint_Set_Custom_PropMinDistanceP12Il2CppObjectf,__Z38SpringJoint_Set_Custom_PropMaxDistanceP12Il2CppObjectf,__Z36SpringJoint_Set_Custom_PropToleranceP12Il2CppObjectf,__Z48CharacterJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf,__Z45CharacterJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf,__Z51ConfigurableJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf,__Z48ConfigurableJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf,__Z37Collider_Set_Custom_PropContactOffsetP12Il2CppObjectf,__Z36SphereCollider_Set_Custom_PropRadiusP12Il2CppObjectf,__Z37MeshCollider_Set_Custom_PropSkinWidthP12Il2CppObjectf,__Z37CapsuleCollider_Set_Custom_PropRadiusP12Il2CppObjectf,__Z37CapsuleCollider_Set_Custom_PropHeightP12Il2CppObjectf,__Z45PhysicMaterial_Set_Custom_PropDynamicFrictionP12Il2CppObjectf,__Z44PhysicMaterial_Set_Custom_PropStaticFrictionP12Il2CppObjectf
,__Z40PhysicMaterial_Set_Custom_PropBouncinessP12Il2CppObjectf,__Z46PhysicMaterial_Set_Custom_PropDynamicFriction2P12Il2CppObjectf,__Z45PhysicMaterial_Set_Custom_PropStaticFriction2P12Il2CppObjectf,__Z41CharacterController_Set_Custom_PropRadiusP12Il2CppObjectf,__Z41CharacterController_Set_Custom_PropHeightP12Il2CppObjectf,__Z45CharacterController_Set_Custom_PropSlopeLimitP12Il2CppObjectf,__Z45CharacterController_Set_Custom_PropStepOffsetP12Il2CppObjectf,__Z44CharacterController_Set_Custom_PropSkinWidthP12Il2CppObjectf,__Z35Rigidbody2D_Set_Custom_PropRotationP12Il2CppObjectf,__Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectf,__Z42Rigidbody2D_Set_Custom_PropAngularVelocityP12Il2CppObjectf,__Z31Rigidbody2D_Set_Custom_PropMassP12Il2CppObjectf,__Z34Rigidbody2D_Set_Custom_PropInertiaP12Il2CppObjectf,__Z31Rigidbody2D_Set_Custom_PropDragP12Il2CppObjectf,__Z38Rigidbody2D_Set_Custom_PropAngularDragP12Il2CppObjectf,__Z39Rigidbody2D_Set_Custom_PropGravityScaleP12Il2CppObjectf,__Z33Collider2D_Set_Custom_PropDensityP12Il2CppObjectf,__Z38CircleCollider2D_Set_Custom_PropRadiusP12Il2CppObjectf,__Z33Joint2D_Set_Custom_PropBreakForceP12Il2CppObjectf,__Z34Joint2D_Set_Custom_PropBreakTorqueP12Il2CppObjectf,__Z37SpringJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf,__Z41SpringJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf,__Z38SpringJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf,__Z39DistanceJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf,__Z39FrictionJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf,__Z40FrictionJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf,__Z39RelativeJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf,__Z40RelativeJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf,__Z46RelativeJoint2D_Set_Custom_PropCorrectionScaleP12Il2CppObjectf,__Z44RelativeJoint2D_Set_Custom_PropAngularOffsetP12Il2CppObjectf
,__Z34SliderJoint2D_Set_Custom_PropAngleP12Il2CppObjectf,__Z37TargetJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf,__Z41TargetJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf,__Z38TargetJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf,__Z40FixedJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf,__Z37FixedJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf,__Z43PhysicsMaterial2D_Set_Custom_PropBouncinessP12Il2CppObjectf,__Z41PhysicsMaterial2D_Set_Custom_PropFrictionP12Il2CppObjectf,__Z37ConstantForce2D_Set_Custom_PropTorqueP12Il2CppObjectf,__Z40AreaEffector2D_Set_Custom_PropForceAngleP12Il2CppObjectf,__Z44AreaEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf,__Z44AreaEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf,__Z34AreaEffector2D_Set_Custom_PropDragP12Il2CppObjectf,__Z41AreaEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf,__Z46BuoyancyEffector2D_Set_Custom_PropSurfaceLevelP12Il2CppObjectf,__Z41BuoyancyEffector2D_Set_Custom_PropDensityP12Il2CppObjectf,__Z44BuoyancyEffector2D_Set_Custom_PropLinearDragP12Il2CppObjectf,__Z45BuoyancyEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf,__Z43BuoyancyEffector2D_Set_Custom_PropFlowAngleP12Il2CppObjectf,__Z47BuoyancyEffector2D_Set_Custom_PropFlowMagnitudeP12Il2CppObjectf,__Z47BuoyancyEffector2D_Set_Custom_PropFlowVariationP12Il2CppObjectf,__Z45PointEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf,__Z45PointEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf,__Z44PointEffector2D_Set_Custom_PropDistanceScaleP12Il2CppObjectf,__Z35PointEffector2D_Set_Custom_PropDragP12Il2CppObjectf,__Z42PointEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf,__Z44PlatformEffector2D_Set_Custom_PropSurfaceArcP12Il2CppObjectf,__Z41PlatformEffector2D_Set_Custom_PropSideArcP12Il2CppObjectf,__Z50PlatformEffector2D_Set_Custom_PropRotationalOffsetP12Il2CppObjectf,__Z38SurfaceEffector2D_Set_Custom_PropSpeedP12Il2CppObjectf
,__Z47SurfaceEffector2D_Set_Custom_PropSpeedVariationP12Il2CppObjectf,__Z43SurfaceEffector2D_Set_Custom_PropForceScaleP12Il2CppObjectf,__Z48setPxVehicleTireLoadFilterDataMMinNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf,__Z56setPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf,__Z48setPxVehicleTireLoadFilterDataMMaxNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf,__Z56setPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf,__Z30setPxVehicleTireDataMLatStiffXPN5physx17PxVehicleTireDataEf,__Z30setPxVehicleTireDataMLatStiffYPN5physx17PxVehicleTireDataEf,__Z56setPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf,__Z50setPxVehicleTireDataMCamberStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf,__Z28setPxVehicleWheelDataMRadiusPN5physx18PxVehicleWheelDataEf,__Z27setPxVehicleWheelDataMWidthPN5physx18PxVehicleWheelDataEf,__Z26setPxVehicleWheelDataMMassPN5physx18PxVehicleWheelDataEf,__Z25setPxVehicleWheelDataMMOIPN5physx18PxVehicleWheelDataEf,__Z33setPxVehicleWheelDataMDampingRatePN5physx18PxVehicleWheelDataEf,__Z36setPxVehicleWheelDataMMaxBrakeTorquePN5physx18PxVehicleWheelDataEf,__Z40setPxVehicleWheelDataMMaxHandBrakeTorquePN5physx18PxVehicleWheelDataEf,__Z30setPxVehicleWheelDataMMaxSteerPN5physx18PxVehicleWheelDataEf,__Z30setPxVehicleWheelDataMToeAnglePN5physx18PxVehicleWheelDataEf,__Z58setPxVehicleSuspensionData_MassAndPreserveNaturalFrequencyPN5physx23PxVehicleSuspensionDataEf,__Z41setPxVehicleSuspensionDataMSpringStrengthPN5physx23PxVehicleSuspensionDataEf,__Z43setPxVehicleSuspensionDataMSpringDamperRatePN5physx23PxVehicleSuspensionDataEf,__Z41setPxVehicleSuspensionDataMMaxCompressionPN5physx23PxVehicleSuspensionDataEf,__Z35setPxVehicleSuspensionDataMMaxDroopPN5physx23PxVehicleSuspensionDataEf,__Z37setPxVehicleSuspensionDataMSprungMassPN5physx23PxVehicleSuspensionDataEf,__Z39setPxVehicleSuspensionDataMCamberAtRestPN5physx23PxVehicleSuspensionDataEf,__Z49setPxVehicleSuspensionDataMCamberAtMaxCompressionPN5physx23PxVehicleSuspensionDataEf,__Z43setPxVehicleSuspensionDataMCamberAtMaxDroopPN5physx23PxVehicleSuspensionDataEf,__Z37setPxVehicleWheelsSimData_ChassisMassPN5physx22PxVehicleWheelsSimDataEf,__Z48setPxVehicleWheelsSimData_MinLongSlipDenominatorPN5physx22PxVehicleWheelsSimDataEf
,__Z44setPxVehicleWheelsSimData_ThresholdLongSpeedPN5physx22PxVehicleWheelsSimDataEf,__Z42setPxVehicleAckermannGeometryDataMAccuracyPN5physx30PxVehicleAckermannGeometryDataEf,__Z44setPxVehicleAckermannGeometryDataMFrontWidthPN5physx30PxVehicleAckermannGeometryDataEf,__Z43setPxVehicleAckermannGeometryDataMRearWidthPN5physx30PxVehicleAckermannGeometryDataEf,__Z48setPxVehicleAckermannGeometryDataMAxleSeparationPN5physx30PxVehicleAckermannGeometryDataEf,__Z45setPxVehicleDifferential4WDataMFrontRearSplitPN5physx27PxVehicleDifferential4WDataEf,__Z50setPxVehicleDifferential4WDataMFrontLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf,__Z49setPxVehicleDifferential4WDataMRearLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf,__Z41setPxVehicleDifferential4WDataMCentreBiasPN5physx27PxVehicleDifferential4WDataEf,__Z40setPxVehicleDifferential4WDataMFrontBiasPN5physx27PxVehicleDifferential4WDataEf,__Z39setPxVehicleDifferential4WDataMRearBiasPN5physx27PxVehicleDifferential4WDataEf,__Z31setPxVehicleAutoBoxData_LatencyPN5physx20PxVehicleAutoBoxDataEf,__Z31setPxVehicleClutchDataMStrengthPN5physx19PxVehicleClutchDataEf,__Z32setPxVehicleGearsDataMFinalRatioPN5physx18PxVehicleGearsDataEf,__Z32setPxVehicleGearsDataMSwitchTimePN5physx18PxVehicleGearsDataEf,__Z26setPxVehicleEngineDataMMOIPN5physx19PxVehicleEngineDataEf,__Z33setPxVehicleEngineDataMPeakTorquePN5physx19PxVehicleEngineDataEf,__Z31setPxVehicleEngineDataMMaxOmegaPN5physx19PxVehicleEngineDataEf,__Z46setPxVehicleEngineDataMDampingRateFullThrottlePN5physx19PxVehicleEngineDataEf,__Z59setPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPN5physx19PxVehicleEngineDataEf,__Z62setPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPN5physx19PxVehicleEngineDataEf,__Z44setPxVehicleDriveDynData_EngineRotationSpeedPN5physx21PxVehicleDriveDynDataEf,__Z39setPxVehicleDriveDynData_GearSwitchTimePN5physx21PxVehicleDriveDynDataEf,__Z42setPxVehicleDriveDynData_AutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf,__Z36setPxVehicleDriveDynDataMEnginespeedPN5physx21PxVehicleDriveDynDataEf,__Z39setPxVehicleDriveDynDataMGearSwitchTimePN5physx21PxVehicleDriveDynDataEf,__Z42setPxVehicleDriveDynDataMAutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf,__Z28setPxVehicleChassisDataMMassPN5physx20PxVehicleChassisDataEf,__Z35WheelCollider_Set_Custom_PropRadiusP12Il2CppObjectf,__Z47WheelCollider_Set_Custom_PropSuspensionDistanceP12Il2CppObjectf
,__Z50WheelCollider_Set_Custom_PropForceAppPointDistanceP12Il2CppObjectf,__Z33WheelCollider_Set_Custom_PropMassP12Il2CppObjectf,__Z45WheelCollider_Set_Custom_PropWheelDampingRateP12Il2CppObjectf,__Z40WheelCollider_Set_Custom_PropMotorTorqueP12Il2CppObjectf,__Z40WheelCollider_Set_Custom_PropBrakeTorqueP12Il2CppObjectf,__Z39WheelCollider_Set_Custom_PropSteerAngleP12Il2CppObjectf,__Z35Cloth_Set_Custom_PropSleepThresholdP12Il2CppObjectf,__Z37Cloth_Set_Custom_PropBendingStiffnessP12Il2CppObjectf,__Z40Cloth_Set_Custom_PropStretchingStiffnessP12Il2CppObjectf,__Z28Cloth_Set_Custom_PropDampingP12Il2CppObjectf,__Z29Cloth_Set_Custom_PropFrictionP12Il2CppObjectf,__Z39Cloth_Set_Custom_PropCollisionMassScaleP12Il2CppObjectf,__Z43Cloth_Set_Custom_PropUseContinuousCollisionP12Il2CppObjectf,__Z40Cloth_Set_Custom_PropUseVirtualParticlesP12Il2CppObjectf,__Z39Cloth_Set_Custom_PropWorldVelocityScaleP12Il2CppObjectf,__Z43Cloth_Set_Custom_PropWorldAccelerationScaleP12Il2CppObjectf,__Z44NavMeshAgent_Set_Custom_PropStoppingDistanceP12Il2CppObjectf,__Z38NavMeshAgent_Set_Custom_PropBaseOffsetP12Il2CppObjectf,__Z33NavMeshAgent_Set_Custom_PropSpeedP12Il2CppObjectf,__Z40NavMeshAgent_Set_Custom_PropAngularSpeedP12Il2CppObjectf,__Z40NavMeshAgent_Set_Custom_PropAccelerationP12Il2CppObjectf,__Z34NavMeshAgent_Set_Custom_PropRadiusP12Il2CppObjectf,__Z34NavMeshAgent_Set_Custom_PropHeightP12Il2CppObjectf,__Z27NavMesh_CUSTOM_SetLayerCostif,__Z26NavMesh_CUSTOM_SetAreaCostif,__Z37NavMeshObstacle_Set_Custom_PropHeightP12Il2CppObjectf,__Z37NavMeshObstacle_Set_Custom_PropRadiusP12Il2CppObjectf,__Z51NavMeshObstacle_Set_Custom_PropCarvingMoveThresholdP12Il2CppObjectf,__Z54NavMeshObstacle_Set_Custom_PropCarvingTimeToStationaryP12Il2CppObjectf,__Z39OffMeshLink_Set_Custom_PropCostOverrideP12Il2CppObjectf
,__Z33AudioSource_Set_Custom_PropVolumeP12Il2CppObjectf,__Z32AudioSource_Set_Custom_PropPitchP12Il2CppObjectf,__Z31AudioSource_Set_Custom_PropTimeP12Il2CppObjectf,__Z30AudioSource_CUSTOM_PlayDelayedP12Il2CppObjectf,__Z36AudioSource_Set_Custom_PropPanStereoP12Il2CppObjectf,__Z39AudioSource_Set_Custom_PropSpatialBlendP12Il2CppObjectf,__Z40AudioSource_Set_Custom_PropReverbZoneMixP12Il2CppObjectf,__Z39AudioSource_Set_Custom_PropDopplerLevelP12Il2CppObjectf,__Z33AudioSource_Set_Custom_PropSpreadP12Il2CppObjectf,__Z38AudioSource_Set_Custom_PropMinDistanceP12Il2CppObjectf,__Z38AudioSource_Set_Custom_PropMaxDistanceP12Il2CppObjectf,__Z36AudioSource_Set_Custom_PropMinVolumeP12Il2CppObjectf,__Z36AudioSource_Set_Custom_PropMaxVolumeP12Il2CppObjectf,__Z40AudioSource_Set_Custom_PropRolloffFactorP12Il2CppObjectf,__Z42AudioReverbZone_Set_Custom_PropMinDistanceP12Il2CppObjectf,__Z42AudioReverbZone_Set_Custom_PropMaxDistanceP12Il2CppObjectf,__Z40AudioReverbZone_Set_Custom_PropDecayTimeP12Il2CppObjectf,__Z43AudioReverbZone_Set_Custom_PropDecayHFRatioP12Il2CppObjectf,__Z47AudioReverbZone_Set_Custom_PropReflectionsDelayP12Il2CppObjectf,__Z42AudioReverbZone_Set_Custom_PropReverbDelayP12Il2CppObjectf,__Z42AudioReverbZone_Set_Custom_PropHFReferenceP12Il2CppObjectf,__Z42AudioReverbZone_Set_Custom_PropLFReferenceP12Il2CppObjectf,__Z48AudioReverbZone_Set_Custom_PropRoomRolloffFactorP12Il2CppObjectf,__Z40AudioReverbZone_Set_Custom_PropDiffusionP12Il2CppObjectf,__Z38AudioReverbZone_Set_Custom_PropDensityP12Il2CppObjectf,__Z49AudioLowPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf,__Z51AudioLowPassFilter_Set_Custom_PropLowpassResonanceQP12Il2CppObjectf,__Z50AudioHighPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf,__Z53AudioHighPassFilter_Set_Custom_PropHighpassResonanceQP12Il2CppObjectf,__Z52AudioDistortionFilter_Set_Custom_PropDistortionLevelP12Il2CppObjectf
,__Z36AudioEchoFilter_Set_Custom_PropDelayP12Il2CppObjectf,__Z41AudioEchoFilter_Set_Custom_PropDecayRatioP12Il2CppObjectf,__Z37AudioEchoFilter_Set_Custom_PropDryMixP12Il2CppObjectf,__Z37AudioEchoFilter_Set_Custom_PropWetMixP12Il2CppObjectf,__Z39AudioChorusFilter_Set_Custom_PropDryMixP12Il2CppObjectf,__Z40AudioChorusFilter_Set_Custom_PropWetMix1P12Il2CppObjectf,__Z40AudioChorusFilter_Set_Custom_PropWetMix2P12Il2CppObjectf,__Z40AudioChorusFilter_Set_Custom_PropWetMix3P12Il2CppObjectf,__Z38AudioChorusFilter_Set_Custom_PropDelayP12Il2CppObjectf,__Z37AudioChorusFilter_Set_Custom_PropRateP12Il2CppObjectf,__Z38AudioChorusFilter_Set_Custom_PropDepthP12Il2CppObjectf,__Z41AudioChorusFilter_Set_Custom_PropFeedbackP12Il2CppObjectf,__Z41AudioReverbFilter_Set_Custom_PropDryLevelP12Il2CppObjectf,__Z37AudioReverbFilter_Set_Custom_PropRoomP12Il2CppObjectf,__Z39AudioReverbFilter_Set_Custom_PropRoomHFP12Il2CppObjectf,__Z44AudioReverbFilter_Set_Custom_PropRoomRolloffP12Il2CppObjectf,__Z42AudioReverbFilter_Set_Custom_PropDecayTimeP12Il2CppObjectf,__Z45AudioReverbFilter_Set_Custom_PropDecayHFRatioP12Il2CppObjectf,__Z49AudioReverbFilter_Set_Custom_PropReflectionsLevelP12Il2CppObjectf,__Z49AudioReverbFilter_Set_Custom_PropReflectionsDelayP12Il2CppObjectf,__Z44AudioReverbFilter_Set_Custom_PropReverbLevelP12Il2CppObjectf,__Z44AudioReverbFilter_Set_Custom_PropReverbDelayP12Il2CppObjectf,__Z42AudioReverbFilter_Set_Custom_PropDiffusionP12Il2CppObjectf,__Z40AudioReverbFilter_Set_Custom_PropDensityP12Il2CppObjectf,__Z44AudioReverbFilter_Set_Custom_PropHfReferenceP12Il2CppObjectf,__Z39AudioReverbFilter_Set_Custom_PropRoomLFP12Il2CppObjectf,__Z44AudioReverbFilter_Set_Custom_PropLfReferenceP12Il2CppObjectf,__Z38AudioMixerSnapshot_CUSTOM_TransitionToP12Il2CppObjectf,__Z41WebCamTexture_Set_Custom_PropRequestedFPSP12Il2CppObjectf,__Z37AnimationClipPlayable_CUSTOM_SetSpeedR9HPlayablef
,__Z38AnimationClip_Set_Custom_PropFrameRateP12Il2CppObjectf,__Z36AnimationState_Set_Custom_PropWeightP12Il2CppObjectf,__Z34AnimationState_Set_Custom_PropTimeP12Il2CppObjectf,__Z44AnimationState_Set_Custom_PropNormalizedTimeP12Il2CppObjectf,__Z35AnimationState_Set_Custom_PropSpeedP12Il2CppObjectf,__Z45AnimationState_Set_Custom_PropNormalizedSpeedP12Il2CppObjectf,__Z39Animator_Set_Custom_PropFeetPivotActiveP12Il2CppObjectf,__Z29Animator_Set_Custom_PropSpeedP12Il2CppObjectf,__Z36Animator_Set_Custom_PropPlaybackTimeP12Il2CppObjectf,__Z41Animator_Set_Custom_PropRecorderStartTimeP12Il2CppObjectf,__Z40Animator_Set_Custom_PropRecorderStopTimeP12Il2CppObjectf,__Z22Animator_CUSTOM_UpdateP12Il2CppObjectf,__Z36TerrainData_Set_Custom_PropThicknessP12Il2CppObjectf,__Z46TerrainData_Set_Custom_PropWavingGrassStrengthP12Il2CppObjectf,__Z44TerrainData_Set_Custom_PropWavingGrassAmountP12Il2CppObjectf,__Z43TerrainData_Set_Custom_PropWavingGrassSpeedP12Il2CppObjectf,__Z35Terrain_Set_Custom_PropTreeDistanceP12Il2CppObjectf,__Z44Terrain_Set_Custom_PropTreeBillboardDistanceP12Il2CppObjectf,__Z42Terrain_Set_Custom_PropTreeCrossFadeLengthP12Il2CppObjectf,__Z43Terrain_Set_Custom_PropDetailObjectDistanceP12Il2CppObjectf,__Z42Terrain_Set_Custom_PropDetailObjectDensityP12Il2CppObjectf,__Z42Terrain_Set_Custom_PropHeightmapPixelErrorP12Il2CppObjectf,__Z38Terrain_Set_Custom_PropBasemapDistanceP12Il2CppObjectf,__Z38Terrain_Set_Custom_PropLegacyShininessP12Il2CppObjectf,__Z44Terrain_Set_Custom_PropTreeLODBiasMultiplierP12Il2CppObjectf,__Z34GUIText_Set_Custom_PropLineSpacingP12Il2CppObjectf,__Z30GUIText_Set_Custom_PropTabSizeP12Il2CppObjectf,__Z31TextMesh_Set_Custom_PropOffsetZP12Il2CppObjectf,__Z37TextMesh_Set_Custom_PropCharacterSizeP12Il2CppObjectf,__Z35TextMesh_Set_Custom_PropLineSpacingP12Il2CppObjectf
,__Z31TextMesh_Set_Custom_PropTabSizeP12Il2CppObjectf,__Z32CanvasGroup_Set_Custom_PropAlphaP12Il2CppObjectf,__Z30CanvasRenderer_CUSTOM_SetAlphaP12Il2CppObjectf,__Z33Canvas_Set_Custom_PropScaleFactorP12Il2CppObjectf,__Z44Canvas_Set_Custom_PropReferencePixelsPerUnitP12Il2CppObjectf,__Z35Canvas_Set_Custom_PropPlaneDistanceP12Il2CppObjectf,__Z47Canvas_Set_Custom_PropNormalizedSortingGridSizeP12Il2CppObjectf,__Z29Event_Set_Custom_PropPressureP12Il2CppObjectf,__Z34GUIStyle_Set_Custom_PropFixedWidthP12Il2CppObjectf,__Z35GUIStyle_Set_Custom_PropFixedHeightP12Il2CppObjectf,__Z38ParticleEmitter_Set_Custom_PropMinSizeP12Il2CppObjectf,__Z38ParticleEmitter_Set_Custom_PropMaxSizeP12Il2CppObjectf,__Z40ParticleEmitter_Set_Custom_PropMinEnergyP12Il2CppObjectf,__Z40ParticleEmitter_Set_Custom_PropMaxEnergyP12Il2CppObjectf,__Z42ParticleEmitter_Set_Custom_PropMinEmissionP12Il2CppObjectf,__Z42ParticleEmitter_Set_Custom_PropMaxEmissionP12Il2CppObjectf,__Z51ParticleEmitter_Set_Custom_PropEmitterVelocityScaleP12Il2CppObjectf,__Z46ParticleEmitter_Set_Custom_PropAngularVelocityP12Il2CppObjectf,__Z49ParticleEmitter_Set_Custom_PropRndAngularVelocityP12Il2CppObjectf,__Z31ParticleEmitter_CUSTOM_SimulateP12Il2CppObjectf,__Z40ParticleAnimator_Set_Custom_PropSizeGrowP12Il2CppObjectf,__Z39ParticleAnimator_Set_Custom_PropDampingP12Il2CppObjectf,__Z43ParticleRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf,__Z45ParticleRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf,__Z51ParticleRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf,__Z47ParticleRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf,__Z49ParticleRenderer_Set_Custom_PropUvAnimationCyclesP12Il2CppObjectf,_emscripten_glUniform1f__wrapper,_emscripten_glVertexAttrib1f__wrapper,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69,b69
,b69,b69,b69,b69,b69];
var FUNCTION_TABLE_vid = [b70,__ZN14DirectorPlayer7SetTimeEd,__ZN8Playable11SetDurationEd,__ZN8Playable7SetTimeEd,__ZN21AnimationClipPlayable11SetDurationEd,__ZN21AnimationClipPlayable7SetTimeEd,__Z29DirectorPlayer_CUSTOM_SetTimeP12Il2CppObjectd,__Z45Playable_CUSTOM_INTERNAL_CALL_SetTimeInternalR9HPlayabled,__Z49Playable_CUSTOM_INTERNAL_CALL_SetDurationInternalR9HPlayabled,__Z32AudioSource_CUSTOM_PlayScheduledP12Il2CppObjectd,__Z40AudioSource_CUSTOM_SetScheduledStartTimeP12Il2CppObjectd,__Z38AudioSource_CUSTOM_SetScheduledEndTimeP12Il2CppObjectd,b70,b70,b70,b70];
var FUNCTION_TABLE_iiidi = [b71,__Z40UnityAnalyticsHandler_CUSTOM_TransactionP12Il2CppObjectP12Il2CppStringdS2_];
var FUNCTION_TABLE_vii = [b72,__Z8heapFreePvS_,__ZN3WWW8SetErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE,__ZN3WWW18GetResponseHeadersEv,__ZN3WWW17SetThreadPriorityE14ThreadPriority,__ZN3WWW12SetAudioClipEP9AudioClip,__ZNK13ScreenManager19GetSystemResolutionEv,__ZNK18ScreenManagerWebGL20GetCurrentResolutionEv,__ZN18ScreenManagerWebGL13SetShowCursorEb,__ZN18ScreenManagerWebGL13SetLockCursorE14CursorLockMode,__ZN13ScreenManager24SetAllowLayeredRenderingEb,__ZN13ScreenManager16SetScreenTimeoutEi,__ZN13ScreenManager12SetIsFocusedEb,__ZN18ScreenManagerWebGL21SetCursorInsideWindowEb,__ZN13ScreenManager18RequestOrientationE17ScreenOrientation,__ZN13ScreenManager20SetScreenOrientationE17ScreenOrientation,__ZN22LocalFileSystemHandler19InitializeFileEntryER13FileEntryData,__ZN22LocalFileSystemHandler16DestroyFileEntryER13FileEntryData,__ZNK20LocalFileSystemPosix18GetApplicationPathEv,__ZNK20LocalFileSystemPosix20GetApplicationFolderEv,__ZNK20LocalFileSystemPosix25GetApplicationManagedPathEv,__ZNK20LocalFileSystemPosix26GetApplicationContentsPathEv,__ZNK20LocalFileSystemPosix21GetUserAppCacheFolderEv,__ZNK20LocalFileSystemPosix20GetUserAppDataFolderEv,__ZNK20LocalFileSystemPosix19GetUserConfigFolderEv,__ZN22LocalFileSystemHandler16LastErrorMessageEv,__ZN16BaseVideoTexture13AwakeFromLoadE17AwakeFromLoadMode,__ZN11NamedObject7SetNameEPKc,__ZN6Object12SetHideFlagsEi
,__ZN6Object24SetCachedScriptingObjectEP12Il2CppObject,__ZN7Texture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN7Texture23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN7Texture23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN7Texture23VirtualRedirectTransferER14SafeBinaryRead,__ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb1EE,__ZNK7Texture16GetNpotTexelSizeEv,__ZN16BaseVideoTexture19UnloadFromGfxDeviceEb,__ZN6Object13AwakeFromLoadE17AwakeFromLoadMode,__ZN6Object7SetNameEPKc,__ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Object23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Object23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN6Object23VirtualRedirectTransferER14SafeBinaryRead,__ZN13BaseAllocator16ThreadInitializeEPS_,__ZN13BaseAllocator16FrameMaintenanceEb,__ZNK13BaseAllocator15WalkAllocationsEPFvPKvjPKPvjE,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10DeallocateEPv,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE16FrameMaintenanceEb,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10DeallocateEPv,__ZN14StackAllocator10DeallocateEPv,__ZN14StackAllocator16FrameMaintenanceEb,__ZNK14StackAllocator15WalkAllocationsEPFvPKvjPKPvjE,__ZN12TLSAllocatorI14StackAllocatorE10DeallocateEPv,__ZN12TLSAllocatorI14StackAllocatorE16ThreadInitializeEP13BaseAllocator,__ZN12TLSAllocatorI14StackAllocatorE16FrameMaintenanceEb
,__ZNK12TLSAllocatorI14StackAllocatorE15WalkAllocationsEPFvPKvjPKPvjE,__ZN25ThreadsafeLinearAllocator10DeallocateEPv,__ZN25ThreadsafeLinearAllocator16FrameMaintenanceEb,__ZN11AssetBundle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11AssetBundle23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11AssetBundle23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11AssetBundle23VirtualRedirectTransferER14SafeBinaryRead,__ZN23PreloadManagerOperation11SetPriorityEi,__ZN14AsyncOperation23SetAllowSceneActivationEb,__ZN13LoadOperation12GetDebugNameEv,__ZN33AssetBundleLoadFromAsyncOperation12GetDebugNameEv,__ZN39AssetBundleLoadFromStreamAsyncOperation11SetPriorityEi,__ZN19AssetBundleManifest23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN19AssetBundleManifest23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN19AssetBundleManifest23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN19AssetBundleManifest23VirtualRedirectTransferER14SafeBinaryRead,__ZN16LevelGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16LevelGameManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16LevelGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16LevelGameManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN17GlobalGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17GlobalGameManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17GlobalGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer
,__ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17GlobalGameManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN10GameObject13AwakeFromLoadE17AwakeFromLoadMode,__ZN10GameObject7SetNameEPKc,__ZN10GameObject12SetHideFlagsEi,__ZN10GameObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10GameObject23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10GameObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10GameObject23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity9Component13AwakeFromLoadE17AwakeFromLoadMode,__ZN5Unity9Component7SetNameEPKc,__ZN5Unity9Component23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity9Component23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity9Component23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity9Component23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity9Component26SupportedMessagesDidChangeEi,__ZN5Unity9Component10DeactivateE19DeactivateOperation,__ZN5Unity9Component10SetEnabledEb,__ZN11NamedObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11NamedObject23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11NamedObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11NamedObject23VirtualRedirectTransferER14SafeBinaryRead,__ZN10TagManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN10TagManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10TagManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10TagManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN6Camera13AwakeFromLoadE17AwakeFromLoadMode,__ZN6Camera23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Camera23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Camera23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN6Camera23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Behaviour10DeactivateE19DeactivateOperation,__ZN9Behaviour10SetEnabledEb,__ZN5Flare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Flare23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Flare23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Flare23VirtualRedirectTransferER14SafeBinaryRead,__ZN9LensFlare13AwakeFromLoadE17AwakeFromLoadMode,__ZN9LensFlare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9LensFlare23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9LensFlare23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9LensFlare23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode,__ZN9Behaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Behaviour23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN9Behaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Behaviour23VirtualRedirectTransferER14SafeBinaryRead,__ZN16GraphicsSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN16GraphicsSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16GraphicsSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16GraphicsSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16GraphicsSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN4Halo13AwakeFromLoadE17AwakeFromLoadMode,__ZN4Halo23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN4Halo23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN4Halo23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN4Halo23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Light13AwakeFromLoadE17AwakeFromLoadMode,__ZN5Light23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Light23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Light23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Light23VirtualRedirectTransferER14SafeBinaryRead,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN21LightProbeProxyVolume23VirtualRedirectTransferER14SafeBinaryRead
,__ZN11LightProbes13AwakeFromLoadE17AwakeFromLoadMode,__ZN11LightProbes23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11LightProbes23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11LightProbes23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11LightProbes23VirtualRedirectTransferER14SafeBinaryRead,__ZN13OcclusionArea23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13OcclusionArea23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13OcclusionArea23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13OcclusionArea23VirtualRedirectTransferER14SafeBinaryRead,__ZN20OcclusionCullingData13AwakeFromLoadE17AwakeFromLoadMode,__ZN20OcclusionCullingData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN20OcclusionCullingData23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN20OcclusionCullingData23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN20OcclusionCullingData23VirtualRedirectTransferER14SafeBinaryRead,__ZN24OcclusionCullingSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN24OcclusionCullingSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN15OcclusionPortal13AwakeFromLoadE17AwakeFromLoadMode,__ZN15OcclusionPortal23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN15OcclusionPortal23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15OcclusionPortal23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15OcclusionPortal23VirtualRedirectTransferER14SafeBinaryRead,__ZN15OcclusionPortal10DeactivateE19DeactivateOperation,__ZN9Projector23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Projector23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Projector23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Projector23VirtualRedirectTransferER14SafeBinaryRead,__ZN15ReflectionProbe13AwakeFromLoadE17AwakeFromLoadMode,__ZN15ReflectionProbe23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15ReflectionProbe23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15ReflectionProbe23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15ReflectionProbe23VirtualRedirectTransferER14SafeBinaryRead,__ZN14RenderSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN14RenderSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14RenderSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14RenderSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14RenderSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN6Skybox23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Skybox23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Skybox23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb1EE
,__ZN6Skybox23VirtualRedirectTransferER14SafeBinaryRead,__ZN10GUITexture13AwakeFromLoadE17AwakeFromLoadMode,__ZN10GUITexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10GUITexture23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10GUITexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10GUITexture23VirtualRedirectTransferER14SafeBinaryRead,__ZN14DirectorPlayer13AwakeFromLoadE17AwakeFromLoadMode,__ZN14DirectorPlayer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14DirectorPlayer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14DirectorPlayer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14DirectorPlayer23VirtualRedirectTransferER14SafeBinaryRead,__ZN14DirectorPlayer9GetStagesER13dynamic_arrayI9StageDescLj4EE,__ZN14DirectorPlayer17SetTimeUpdateModeE18DirectorUpdateMode,__ZN8Playable12SetPlayStateE9PlayState,__ZN18DelayedCallManager6UpdateEi,__ZN22BlockMemoryCacheWriter16UnlockCacheBlockEj,__ZN22BlockMemoryCacheWriter11GetPathNameEv,__ZN9GfxDevice13SetActiveTierE12GraphicsTier,__ZN9GfxDevice20SetMaxBufferedFramesEi,__ZN9GfxDevice25SetInvertProjectionMatrixEb,__ZN9GfxDevice34SetStencilRefWhenStencilWasSkippedEi,__ZN9GfxDevice14SetWorldMatrixERK10Matrix4x4f,__ZN9GfxDevice13SetViewMatrixERK10Matrix4x4f,__ZN9GfxDevice19SetProjectionMatrixERK10Matrix4x4f,__ZN9GfxDevice25SetShaderPropertiesSharedERK19ShaderPropertySheet,__ZN9GfxDevice17DestroyGpuProgramEPK10GpuProgram
,__ZN9GfxDevice12DeleteBufferEP9GfxBuffer,__ZN9GfxDevice19PutGeometryJobFenceE13UniqueSmallID,__ZN9GfxDevice18EndDynamicBatchingE13TransformType,__ZN9GfxDevice21ReleaseSharedMeshDataEP14SharedMeshData,__ZN9GfxDevice24ReleaseSharedTextureDataEP17SharedTextureData,__ZN9GfxDevice25ReleaseAsyncCommandHeaderEPN21GfxDeviceAsyncCommand3ArgE,__ZN9GfxDevice23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer,__ZN9GfxDevice20DestroyRenderSurfaceER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE,__ZN9GfxDevice23IgnoreNextUnresolveOnRSE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE,__ZN9GfxDevice20DeallocRenderSurfaceEP17RenderSurfaceBase,__ZN9GfxDevice13FreeTextureIDE9TextureID,__ZN9GfxDevice23UnregisterNativeTextureE9TextureID,__ZN9GfxDevice25GenerateRenderSurfaceMipsEP17RenderSurfaceBase,__ZN9GfxDevice12PresentFrameEPK14ChannelAssigns,__ZN9GfxDevice21SwapDynamicVBOBuffersEj,__ZN9GfxDevice14WaitOnCPUFenceEj,__ZN9GfxDevice16SetActiveContextEPv,__ZN9GfxDevice17BeginProfileEventEPKc,__ZN9GfxDevice19SetNextDrawCallTypeE15GfxDrawCallType,__ZN9GfxDevice18InsertCustomMarkerEi,__ZN9GfxDevice19FreeComputeBufferIDE15ComputeBufferID,__ZN9GfxDevice21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE,__ZN9GfxDevice20DestroyComputeBufferE15ComputeBufferID,__ZN9GfxDevice17SetComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE,__ZN9GfxDevice15SetStereoTargetE15StereoscopicEye,__ZN9GfxDevice19SetSinglePassStereoE16SinglePassStereo,__ZN9GfxDevice19CopyContextDataFromEPKS_,__ZN19GfxThreadableDevice15OnDeviceCreatedEb,__ZN12CubemapArray13AwakeFromLoadE17AwakeFromLoadMode,__ZN12CubemapArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12CubemapArray23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12CubemapArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12CubemapArray23VirtualRedirectTransferER14SafeBinaryRead,__ZN12CubemapArray19UnloadFromGfxDeviceEb,__ZN9Texture2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN7Cubemap23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN7Cubemap23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN7Cubemap23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN7Cubemap23VirtualRedirectTransferER14SafeBinaryRead,__ZNK9Texture2D16GetNpotTexelSizeEv,__ZN9Texture2D19UnloadFromGfxDeviceEb,__ZN7Cubemap34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction,__ZN9Texture2D13GetAsyncFenceEv,__ZN15LightProbeGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15LightProbeGroup23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15LightProbeGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15LightProbeGroup23VirtualRedirectTransferER14SafeBinaryRead,__ZN16LightmapSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN16LightmapSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16LightmapSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16LightmapSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16LightmapSettings23VirtualRedirectTransferER14SafeBinaryRead
,__ZN12LineRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN12LineRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12LineRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12LineRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12LineRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN8Renderer26SupportedMessagesDidChangeEi,__ZN8Renderer10DeactivateE19DeactivateOperation,__ZN8Renderer10SetEnabledEb,__ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN8Renderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8Renderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8Renderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8Renderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN15QualitySettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN15QualitySettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15QualitySettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15QualitySettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15QualitySettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN2UI13RectTransform13AwakeFromLoadE17AwakeFromLoadMode,__ZN2UI13RectTransform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN2UI13RectTransform23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN2UI13RectTransform23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE
,__ZN2UI13RectTransform23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Transform26SupportedMessagesDidChangeEi,__ZN2UI13RectTransform10DeactivateE19DeactivateOperation,__ZN13RenderTexture13AwakeFromLoadE17AwakeFromLoadMode,__ZN13RenderTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13RenderTexture23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13RenderTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13RenderTexture23VirtualRedirectTransferER14SafeBinaryRead,__ZN13RenderTexture19UnloadFromGfxDeviceEb,__ZNK13ScreenManager20GetCurrentResolutionEv,__ZN13ScreenManager13SetShowCursorEb,__ZN13ScreenManager13SetLockCursorE14CursorLockMode,__ZN13ScreenManager21SetCursorInsideWindowEb,__ZN19LowerResBlitTexture19UnloadFromGfxDeviceEb,__ZN13SparseTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13SparseTexture23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13SparseTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13SparseTexture23VirtualRedirectTransferER14SafeBinaryRead,__ZN13SparseTexture19UnloadFromGfxDeviceEb,__ZN6Sprite13AwakeFromLoadE17AwakeFromLoadMode,__ZN6Sprite23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Sprite23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Sprite23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN6Sprite23VirtualRedirectTransferER14SafeBinaryRead
,__ZN9Texture2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Texture2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Texture2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Texture2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Texture2D34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction,__ZN14Texture2DArray13AwakeFromLoadE17AwakeFromLoadMode,__ZN14Texture2DArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14Texture2DArray23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14Texture2DArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14Texture2DArray23VirtualRedirectTransferER14SafeBinaryRead,__ZN14Texture2DArray19UnloadFromGfxDeviceEb,__ZN9Texture3D13AwakeFromLoadE17AwakeFromLoadMode,__ZN9Texture3D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Texture3D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Texture3D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Texture3D23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Texture3D19UnloadFromGfxDeviceEb,__ZN13TrailRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13TrailRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13TrailRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13TrailRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Transform13AwakeFromLoadE17AwakeFromLoadMode
,__ZN9Transform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Transform23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Transform23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Transform23VirtualRedirectTransferER14SafeBinaryRead,__ZN14BillboardAsset13AwakeFromLoadE17AwakeFromLoadMode,__ZN14BillboardAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14BillboardAsset23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14BillboardAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14BillboardAsset23VirtualRedirectTransferER14SafeBinaryRead,__ZN17BillboardRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN17BillboardRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17BillboardRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17BillboardRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17BillboardRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN8LODGroup13AwakeFromLoadE17AwakeFromLoadMode,__ZN8LODGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8LODGroup23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8LODGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8LODGroup23VirtualRedirectTransferER14SafeBinaryRead,__ZN8LODGroup10DeactivateE19DeactivateOperation,__ZN8LODGroup10SetEnabledEb,__ZN10DynamicVBO11SwapBuffersEj
,__ZN17GenericDynamicVBO11SwapBuffersEj,__ZN4Mesh13AwakeFromLoadE17AwakeFromLoadMode,__ZN4Mesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN4Mesh23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN4Mesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN4Mesh23VirtualRedirectTransferER14SafeBinaryRead,__ZN10MeshFilter13AwakeFromLoadE17AwakeFromLoadMode,__ZN10MeshFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10MeshFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10MeshFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10MeshFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN12MeshRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN12MeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12MeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12MeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12MeshRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN12MeshRenderer10DeactivateE19DeactivateOperation,__ZN19SkinnedMeshRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN19SkinnedMeshRenderer23VirtualRedirectTransferER14SafeBinaryRead
,__ZN19SkinnedMeshRenderer10DeactivateE19DeactivateOperation,__ZN14SpriteRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN14SpriteRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14SpriteRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14SpriteRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14SpriteRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN18ProceduralMaterial13AwakeFromLoadE17AwakeFromLoadMode,__ZN18ProceduralMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18ProceduralMaterial23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18ProceduralMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18ProceduralMaterial23VirtualRedirectTransferER14SafeBinaryRead,__ZN17ProceduralTexture13AwakeFromLoadE17AwakeFromLoadMode,__ZN17ProceduralTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17ProceduralTexture23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17ProceduralTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17ProceduralTexture23VirtualRedirectTransferER14SafeBinaryRead,__ZN17ProceduralTexture19UnloadFromGfxDeviceEb,__ZN16SubstanceArchive13AwakeFromLoadE17AwakeFromLoadMode,__ZN16SubstanceArchive23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16SubstanceArchive23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16SubstanceArchive23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16SubstanceArchive23VirtualRedirectTransferER14SafeBinaryRead
,__ZN12InputManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12InputManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12InputManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12InputManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN11TimeManager13AwakeFromLoadE17AwakeFromLoadMode,__ZN11TimeManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11TimeManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11TimeManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11TimeManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN14AsyncOperation11SetPriorityEi,__ZN13BuildSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN13BuildSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13BuildSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13BuildSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13BuildSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN14PlayerSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN14PlayerSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14PlayerSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14PlayerSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14PlayerSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN15ResourceManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN15ResourceManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15ResourceManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15ResourceManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN30RuntimeInitializeOnLoadManager13AwakeFromLoadE17AwakeFromLoadMode,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN9WWWCached17SetThreadPriorityE14ThreadPriority,__ZN10MonoScript13AwakeFromLoadE17AwakeFromLoadMode,__ZN10MonoScript23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10MonoScript23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10MonoScript23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10MonoScript23VirtualRedirectTransferER14SafeBinaryRead,__ZN13MonoBehaviour13AwakeFromLoadE17AwakeFromLoadMode,__ZN13MonoBehaviour7SetNameEPKc,__ZN13MonoBehaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13MonoBehaviour23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13MonoBehaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13MonoBehaviour23VirtualRedirectTransferER14SafeBinaryRead,__ZN13MonoBehaviour10DeactivateE19DeactivateOperation,__ZN17GeneralConnection14OnDisconnectedEj,__ZN17MemoryCacheWriter16UnlockCacheBlockEj
,__ZN17MemoryCacheWriter11GetPathNameEv,__ZN18LoadSceneOperation23SetAllowSceneActivationEb,__ZN23PreloadManagerOperation12GetDebugNameEv,__ZN20UnloadSceneOperation12GetDebugNameEv,__ZN11PreloadData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11PreloadData23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11PreloadData23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11PreloadData23VirtualRedirectTransferER14SafeBinaryRead,__ZN27UnloadUnusedAssetsOperation12GetDebugNameEv,__ZN11MonoManager13AwakeFromLoadE17AwakeFromLoadMode,__ZN11MonoManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11MonoManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11MonoManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11MonoManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN9TextAsset13AwakeFromLoadE17AwakeFromLoadMode,__ZN9TextAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9TextAsset23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9TextAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9TextAsset23VirtualRedirectTransferER14SafeBinaryRead,__ZN17MemoryCacheReader16UnlockCacheBlockEj,__ZN17MemoryCacheReader11GetPathNameEv,__ZN14FileCacherRead16UnlockCacheBlockEj,__ZN14FileCacherRead11GetPathNameEv,__ZN22MemoryCacherReadBlocks16UnlockCacheBlockEj
,__ZN22MemoryCacherReadBlocks11GetPathNameEv,__ZN13ComputeShader13AwakeFromLoadE17AwakeFromLoadMode,__ZN13ComputeShader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13ComputeShader23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13ComputeShader23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13ComputeShader23VirtualRedirectTransferER14SafeBinaryRead,__ZN8Material13AwakeFromLoadE17AwakeFromLoadMode,__ZN8Material23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8Material23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8Material23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8Material23VirtualRedirectTransferER14SafeBinaryRead,__ZN6Shader13AwakeFromLoadE17AwakeFromLoadMode,__ZN6Shader7SetNameEPKc,__ZN6Shader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Shader23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Shader23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN6Shader23VirtualRedirectTransferER14SafeBinaryRead,__ZN12ScriptMapper23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12ScriptMapper23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12ScriptMapper23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12ScriptMapper23VirtualRedirectTransferER14SafeBinaryRead,__ZN23ShaderVariantCollection13AwakeFromLoadE17AwakeFromLoadMode
,__ZN23ShaderVariantCollection23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN23ShaderVariantCollection23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN23ShaderVariantCollection23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN23ShaderVariantCollection23VirtualRedirectTransferER14SafeBinaryRead,__ZN18SpeedTreeWindAsset13AwakeFromLoadE17AwakeFromLoadMode,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18SpeedTreeWindAsset23VirtualRedirectTransferER14SafeBinaryRead,__ZN8WindZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8WindZone23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8WindZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8WindZone23VirtualRedirectTransferER14SafeBinaryRead,__ZNK13Lz4Compressor20CompressStreamDeinitEPv,__ZNK15Lz4Decompressor22DecompressStreamDeinitEPv,__ZN17ArchiveFileSystem19InitializeFileEntryER13FileEntryData,__ZN17ArchiveFileSystem16DestroyFileEntryER13FileEntryData,__ZN12HandlerChain19InitializeFileEntryER13FileEntryData,__ZN12HandlerChain16DestroyFileEntryER13FileEntryData,__ZNK22LocalFileSystemHandler25GetApplicationManagedPathEv,__ZNK22LocalFileSystemHandler26GetApplicationContentsPathEv,__ZNK22LocalFileSystemHandler21GetUserAppCacheFolderEv,__ZNK22LocalFileSystemHandler20GetUserAppDataFolderEv,__ZNK22LocalFileSystemHandler19GetUserConfigFolderEv
,__ZN16MemoryFileSystem19InitializeFileEntryER13FileEntryData,__ZN16MemoryFileSystem16DestroyFileEntryER13FileEntryData,__ZN25MultiBlocksMemoryFileData6UnlockEPv,__ZN24RingBufferMemoryFileData6UnlockEPv,__ZN25SingleBlockMemoryFileData6UnlockEPv,__ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10DeallocateEPv,__ZN21AssetBundleFileSystem19InitializeFileEntryER13FileEntryData,__ZN21AssetBundleFileSystem16DestroyFileEntryER13FileEntryData,__ZN13GfxDeviceGLES25SetInvertProjectionMatrixEb,__ZN13GfxDeviceGLES13SetBlendStateEPK16DeviceBlendState,__ZN13GfxDeviceGLES14SetRasterStateEPK17DeviceRasterState,__ZN13GfxDeviceGLES13SetDepthStateEPK16DeviceDepthState,__ZN13GfxDeviceGLES12SetSRGBWriteEb,__ZN13GfxDeviceGLES19SetUserBackfaceModeEb,__ZN13GfxDeviceGLES16SetForceCullModeE8CullMode,__ZN13GfxDeviceGLES12SetWireframeEb,__ZN13GfxDeviceGLES14SetWorldMatrixERK10Matrix4x4f,__ZN13GfxDeviceGLES13SetViewMatrixERK10Matrix4x4f,__ZN13GfxDeviceGLES19SetProjectionMatrixERK10Matrix4x4f,__ZN13GfxDeviceGLES15SetBackfaceModeEb,__ZN13GfxDeviceGLES11SetViewportERK5RectTIiE,__ZNK13GfxDeviceGLES11GetViewportEv,__ZN13GfxDeviceGLES14SetScissorRectERK5RectTIiE,__ZNK13GfxDeviceGLES14GetScissorRectEv,__ZN13GfxDeviceGLES25SetShaderPropertiesCopiedERK19ShaderPropertySheet,__ZN13GfxDeviceGLES17DestroySubProgramEPN9ShaderLab10SubProgramE,__ZN13GfxDeviceGLES17DestroyGpuProgramEPK10GpuProgram,__ZN13GfxDeviceGLES12DeleteBufferEP9GfxBuffer,__ZN13GfxDeviceGLES23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer,__ZN13GfxDeviceGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE
,__ZN13GfxDeviceGLES28DestroyRenderSurfacePlatformEP17RenderSurfaceBase,__ZN13GfxDeviceGLES23UnregisterNativeTextureE9TextureID,__ZN13GfxDeviceGLES13DeleteTextureE9TextureID,__ZN13GfxDeviceGLES25GenerateRenderSurfaceMipsEP17RenderSurfaceBase,__ZN13GfxDeviceGLES16SetActiveContextEPv,__ZN13GfxDeviceGLES17BeginProfileEventEPKc,__ZN13GfxDeviceGLES16DeleteTimerQueryEP13GfxTimerQuery,__ZN13GfxDeviceGLES21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE,__ZN13GfxDeviceGLES20DestroyComputeBufferE15ComputeBufferID,__ZN13GfxDeviceGLES15SetStereoTargetE15StereoscopicEye,__ZN13GfxDeviceGLES20SetRenderTargetsImplERK20GfxRenderTargetSetup,__ZN13GfxDeviceGLES15OnDeviceCreatedEb,__ZN13GfxDeviceGLES16SetAntiAliasFlagEb,__ZN26VertexDeclarationCacheGLES24DestroyVertexDeclarationEP17VertexDeclaration,__ZN15UniformTFMethod16BindForRenderingEj,__ZN21UniformBufferTFMethod16BindForRenderingEj,__ZN15TextureTFMethod16BindForRenderingEj,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE,__ZN13GfxDeviceNull25SetInvertProjectionMatrixEb,__ZN13GfxDeviceNull13SetBlendStateEPK16DeviceBlendState,__ZN13GfxDeviceNull14SetRasterStateEPK17DeviceRasterState,__ZN13GfxDeviceNull13SetDepthStateEPK16DeviceDepthState,__ZN13GfxDeviceNull12SetSRGBWriteEb,__ZN13GfxDeviceNull19SetUserBackfaceModeEb,__ZN13GfxDeviceNull16SetForceCullModeE8CullMode,__ZN13GfxDeviceNull12SetWireframeEb,__ZN13GfxDeviceNull14SetWorldMatrixERK10Matrix4x4f,__ZN13GfxDeviceNull13SetViewMatrixERK10Matrix4x4f,__ZN13GfxDeviceNull19SetProjectionMatrixERK10Matrix4x4f,__ZN13GfxDeviceNull15SetBackfaceModeEb
,__ZN13GfxDeviceNull11SetViewportERK5RectTIiE,__ZNK13GfxDeviceNull11GetViewportEv,__ZN13GfxDeviceNull14SetScissorRectERK5RectTIiE,__ZNK13GfxDeviceNull14GetScissorRectEv,__ZN13GfxDeviceNull25SetShaderPropertiesCopiedERK19ShaderPropertySheet,__ZN13GfxDeviceNull17DestroySubProgramEPN9ShaderLab10SubProgramE,__ZN13GfxDeviceNull17DestroyGpuProgramEPK10GpuProgram,__ZN13GfxDeviceNull12DeleteBufferEP9GfxBuffer,__ZN13GfxDeviceNull15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE,__ZN13GfxDeviceNull28DestroyRenderSurfacePlatformEP17RenderSurfaceBase,__ZN13GfxDeviceNull13DeleteTextureE9TextureID,__ZN13GfxDeviceNull16DeleteTimerQueryEP13GfxTimerQuery,__ZN13GfxDeviceNull20SetRenderTargetsImplERK20GfxRenderTargetSetup,__ZN11UmbraModule20CleanupUmbraTomeDataEPKN5Umbra4TomeE,__ZN11UmbraModule18DeleteShadowCullerEPN5Umbra15ShadowCullerExtE,__ZN5Umbra15SystemAllocator10deallocateEPv,__ZN5Umbra21UserCallbackAllocator10deallocateEPv,__ZN5Umbra20SingleBlockAllocator10deallocateEPv,__ZN35ClampVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN31CollisionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN34ColorBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN27ColorModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN30EmissionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN36ExternalForcesModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN27ForceModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN37InheritVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN29InitialModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN28LightsModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN27NoiseModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN37RotationBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE
,__ZN30RotationModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN27ShapeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN33SizeBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN26SizeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN27TrailModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN29TriggerModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN24UVModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN30VelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE,__ZN14ParticleSystem13AwakeFromLoadE17AwakeFromLoadMode,__ZN14ParticleSystem23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14ParticleSystem23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14ParticleSystem23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14ParticleSystem23VirtualRedirectTransferER14SafeBinaryRead,__ZN14ParticleSystem10DeactivateE19DeactivateOperation,__ZN22ParticleSystemRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN22ParticleSystemRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN22ParticleSystemRenderer12GetLocalAABBER4AABB,__ZN22ParticleSystemRenderer12GetWorldAABBER4AABB,__ZNK5physx3Cct13BoxController15getFootPositionEv,__ZN5physx3Cct13BoxController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE,__ZNK5physx3Cct13BoxController14getUpDirectionEv,__ZN5physx3Cct13BoxController14setUpDirectionERKNS_6PxVec3E,__ZN5physx3Cct13BoxController11setUserDataEPv
,__ZNK5physx3Cct13BoxController8getStateERNS_17PxControllerStateE,__ZNK5physx3Cct13BoxController8getStatsERNS_17PxControllerStatsE,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E6getDirEv,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E6getDirEv,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv,__ZNK5physx3Cct17CapsuleController15getFootPositionEv,__ZN5physx3Cct17CapsuleController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE,__ZNK5physx3Cct17CapsuleController14getUpDirectionEv,__ZN5physx3Cct17CapsuleController14setUpDirectionERKNS_6PxVec3E,__ZN5physx3Cct17CapsuleController11setUserDataEPv,__ZNK5physx3Cct17CapsuleController8getStateERNS_17PxControllerStateE,__ZNK5physx3Cct17CapsuleController8getStatsERNS_17PxControllerStatsE,__ZN5physx3Cct26CharacterControllerManager22setDebugRenderingFlagsENS_7PxFlagsINS_27PxControllerDebugRenderFlag4EnumEjEE,__ZN5physx3Cct26CharacterControllerManager24setOverlapRecoveryModuleEb,__ZN5physx3Cct26CharacterControllerManager16setPreciseSweepsEb,__ZN5physx3Cct26CharacterControllerManager39setPreventVerticalSlidingAgainstCeilingEb,__ZN5physx3Cct26CharacterControllerManager11shiftOriginERKNS_6PxVec3E,__ZN5physx2Cm12RenderBuffer6appendERKNS_14PxRenderBufferE,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7setNameEPKc,__ZN5physx3Ext7D6Joint14setLinearLimitERKNS_18PxJointLinearLimitE,__ZNK5physx3Ext7D6Joint14getLinearLimitEv,__ZN5physx3Ext7D6Joint13setTwistLimitERKNS_23PxJointAngularLimitPairE
,__ZNK5physx3Ext7D6Joint13getTwistLimitEv,__ZN5physx3Ext7D6Joint13setSwingLimitERKNS_16PxJointLimitConeE,__ZNK5physx3Ext7D6Joint13getSwingLimitEv,__ZN5physx3Ext7D6Joint16setDrivePositionERKNS_11PxTransformE,__ZNK5physx3Ext7D6Joint16getDrivePositionEv,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext7D6Joint15exportExtraDataERNS_22PxSerializationContextE,__ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext20ProfileZoneInterface16handleEventAddedERKNS_18PxProfileEventNameE,__ZN5physx3Ext23DefaultBufferedProfiler27addBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE,__ZN5physx3Ext23DefaultBufferedProfiler30removeBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE,__ZN5physx3Ext18ProfileZoneHandler11onZoneAddedERNS_13PxProfileZoneE,__ZN5physx3Ext18ProfileZoneHandler13onZoneRemovedERNS_13PxProfileZoneE,__ZN5physx3Ext20DefaultCpuDispatcher10submitTaskERNS_10PxBaseTaskE,__ZN5physx3Ext20DefaultCpuDispatcher14setRunProfiledEb,__ZN16NovodexAllocator10deallocateEPv,__ZN18PhysxJobDispatcher10submitTaskERN5physx10PxBaseTaskE,__ZN19ControllerHitReport10onShapeHitERKN5physx20PxControllerShapeHitE,__ZN19ControllerHitReport15onControllerHitERKN5physx16PxControllersHitE,__ZN19ControllerHitReport13onObstacleHitERKN5physx23PxControllerObstacleHitE,__ZN5physx24PxDefaultMemoryInputData4seekEj,__ZN5physx22PxDefaultFileInputData4seekEj,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7setNameEPKc
,__ZN5physx3Ext13DistanceJoint21setDistanceJointFlagsENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext13DistanceJoint15exportExtraDataERNS_22PxSerializationContextE,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7setNameEPKc,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZNK5physx3Ext10FixedJoint15exportExtraDataERNS_22PxSerializationContextE,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7setNameEPKc,__ZN5physx3Ext14PrismaticJoint8setLimitERKNS_22PxJointLinearLimitPairE,__ZNK5physx3Ext14PrismaticJoint8getLimitEv,__ZN5physx3Ext14PrismaticJoint22setPrismaticJointFlagsENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext14PrismaticJoint15exportExtraDataERNS_22PxSerializationContextE
,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7setNameEPKc,__ZN5physx3Ext13RevoluteJoint8setLimitERKNS_23PxJointAngularLimitPairE,__ZNK5physx3Ext13RevoluteJoint8getLimitEv,__ZN5physx3Ext13RevoluteJoint21setRevoluteJointFlagsENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext13RevoluteJoint15exportExtraDataERNS_22PxSerializationContextE,__ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getRelativeTransformEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE25getRelativeLinearVelocityEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE26getRelativeAngularVelocityEv,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7setNameEPKc,__ZNK5physx3Ext14SphericalJoint12getLimitConeEv,__ZN5physx3Ext14SphericalJoint12setLimitConeERKNS_16PxJointLimitConeE,__ZN5physx3Ext14SphericalJoint22setSphericalJointFlagsENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E,__ZN5physx3Ext14SphericalJoint15exportExtraDataERNS_22PxSerializationContextE,__ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj,__ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E
,__ZN5physx2Sn21SerializationRegistry30registerBinaryMetaDataCallbackEPFvRNS_14PxOutputStreamEE,__ZN5physx2Sn5ConvX13setReportModeENS_21PxConverterReportMode4EnumE,__ZN5physx2Sn20SerializationContext9alignDataEj,__ZN5physx2Sn20SerializationContext9writeNameEPKc,__ZN5physx11NpAggregate15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx11NpAggregate8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx2Sc21ConstraintInteraction11updateStateEb,__ZThn24_N5physx2Sc21ConstraintInteraction11updateStateEb,__ZN5physx2Sc15CoreInteraction11updateStateEb,__ZN5physx14NpArticulation26setMaxProjectionIterationsEj,__ZN5physx14NpArticulation26setInternalDriveIterationsEj,__ZN5physx14NpArticulation26setExternalDriveIterationsEj,__ZN5physx14NpArticulation7setNameEPKc,__ZNK5physx14NpArticulation17releaseDriveCacheERNS_24PxArticulationDriveCacheE,__ZN5physx14NpArticulation15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx14NpArticulation8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx19NpArticulationJoint13setParentPoseERKNS_11PxTransformE,__ZNK5physx19NpArticulationJoint13getParentPoseEv,__ZN5physx19NpArticulationJoint12setChildPoseERKNS_11PxTransformE,__ZNK5physx19NpArticulationJoint12getChildPoseEv,__ZN5physx19NpArticulationJoint20setTargetOrientationERKNS_6PxQuatE,__ZNK5physx19NpArticulationJoint20getTargetOrientationEv,__ZN5physx19NpArticulationJoint17setTargetVelocityERKNS_6PxVec3E,__ZNK5physx19NpArticulationJoint17getTargetVelocityEv,__ZN5physx19NpArticulationJoint12setDriveTypeENS_28PxArticulationJointDriveType4EnumE,__ZN5physx19NpArticulationJoint20setSwingLimitEnabledEb,__ZN5physx19NpArticulationJoint20setTwistLimitEnabledEb,__ZN5physx19NpArticulationJoint17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx19NpArticulationJoint8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7setNameEPKc
,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE14setOwnerClientEh,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getCMassLocalPoseEv,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setMassSpaceInertiaTensorERKNS_6PxVec3E,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25getMassSpaceInertiaTensorEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE28getMassSpaceInvInertiaTensorEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getLinearVelocityEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE18getAngularVelocityEv,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE,__ZNK5physx18NpArticulationLink13getGlobalPoseEv,__ZN5physx18NpArticulationLink17setCMassLocalPoseERKNS_11PxTransformE,__ZN5physx18NpArticulationLink10clearForceENS_11PxForceMode4EnumE,__ZN5physx18NpArticulationLink11clearTorqueENS_11PxForceMode4EnumE,__ZN5physx18NpArticulationLink15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx18NpArticulationLink17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx18NpArticulationLink8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx12NpBatchQuery13setUserMemoryERKNS_18PxBatchQueryMemoryE
,__ZN5physx12NpBatchQuery11setRunOnSpuEb,__ZN5physx12NpConstraint8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__ZN5physx12NpConstraint8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx10NpMaterial8setFlagsENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE,__ZN5physx10NpMaterial22setFrictionCombineModeENS_13PxCombineMode4EnumE,__ZN5physx10NpMaterial25setRestitutionCombineModeENS_13PxCombineMode4EnumE,__ZN5physx10NpMaterial17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx10NpMaterial8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx9NpPhysics26unregisterDeletionListenerERNS_18PxDeletionListenerE,__ZN5physx7NpShape11setGeometryERKNS_10PxGeometryE,__ZNK5physx7NpShape11getGeometryEv,__ZN5physx7NpShape12setLocalPoseERKNS_11PxTransformE,__ZNK5physx7NpShape12getLocalPoseEv,__ZN5physx7NpShape23setSimulationFilterDataERKNS_12PxFilterDataE,__ZNK5physx7NpShape23getSimulationFilterDataEv,__ZN5physx7NpShape18setQueryFilterDataERKNS_12PxFilterDataE,__ZNK5physx7NpShape18getQueryFilterDataEv,__ZN5physx7NpShape8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__ZN5physx7NpShape7setNameEPKc,__ZN5physx7NpShape15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx7NpShape8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_7PxClothEE7setNameEPKc,__ZN5physx15NpActorTemplateINS_7PxClothEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_7PxClothEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_7PxClothEE14setOwnerClientEh,__ZN5physx15NpActorTemplateINS_7PxClothEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx7NpCloth13setClothFlagsENS_7PxFlagsINS_11PxClothFlag4EnumEtEE,__ZN5physx7NpCloth13setTargetPoseERKNS_11PxTransformE,__ZN5physx7NpCloth13setGlobalPoseERKNS_11PxTransformE,__ZNK5physx7NpCloth13getGlobalPoseEv
,__ZN5physx7NpCloth21setLinearInertiaScaleENS_6PxVec3E,__ZNK5physx7NpCloth21getLinearInertiaScaleEv,__ZN5physx7NpCloth22setAngularInertiaScaleENS_6PxVec3E,__ZNK5physx7NpCloth22getAngularInertiaScaleEv,__ZN5physx7NpCloth26setCentrifugalInertiaScaleENS_6PxVec3E,__ZNK5physx7NpCloth26getCentrifugalInertiaScaleEv,__ZN5physx7NpCloth21setDampingCoefficientENS_6PxVec3E,__ZNK5physx7NpCloth21getDampingCoefficientEv,__ZN5physx7NpCloth24setLinearDragCoefficientENS_6PxVec3E,__ZNK5physx7NpCloth24getLinearDragCoefficientEv,__ZN5physx7NpCloth25setAngularDragCoefficientENS_6PxVec3E,__ZNK5physx7NpCloth25getAngularDragCoefficientEv,__ZN5physx7NpCloth23setExternalAccelerationENS_6PxVec3E,__ZNK5physx7NpCloth23getExternalAccelerationEv,__ZN5physx7NpCloth24setParticleAccelerationsEPKNS_6PxVec4E,__ZN5physx7NpCloth20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE,__ZN5physx7NpCloth25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE,__ZNK5physx7NpCloth25getMotionConstraintConfigEv,__ZN5physx7NpCloth24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE,__ZN5physx7NpCloth15setTetherConfigERKNS_19PxClothTetherConfigE,__ZNK5physx7NpCloth15getTetherConfigEv,__ZN5physx7NpCloth18addCollisionSphereERKNS_22PxClothCollisionSphereE,__ZN5physx7NpCloth21removeCollisionSphereEj,__ZN5physx7NpCloth22removeCollisionCapsuleEj,__ZN5physx7NpCloth17addCollisionPlaneERKNS_21PxClothCollisionPlaneE,__ZN5physx7NpCloth20removeCollisionPlaneEj,__ZN5physx7NpCloth18addCollisionConvexEj,__ZN5physx7NpCloth21removeCollisionConvexEj,__ZN5physx7NpCloth20addCollisionTriangleERKNS_24PxClothCollisionTriangleE,__ZN5physx7NpCloth23removeCollisionTriangleEj
,__ZNK5physx7NpCloth19getVirtualParticlesEPj,__ZNK5physx7NpCloth25getVirtualParticleWeightsEPNS_6PxVec3E,__ZN5physx7NpCloth16setRestPositionsEPKNS_6PxVec4E,__ZN5physx7NpCloth23setSimulationFilterDataERKNS_12PxFilterDataE,__ZNK5physx7NpCloth23getSimulationFilterDataEv,__ZN5physx7NpCloth15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx7NpCloth17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx7NpCloth8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_7PxClothEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_7PxClothEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7setNameEPKc,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE14setOwnerClientEh,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getExternalAccelerationEv,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setExternalAccelerationERKNS_6PxVec3E,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setSimulationFilterDataERKNS_12PxFilterDataE,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getSimulationFilterDataEv,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx15NpParticleFluid15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpParticleFluid8requiresERNS_23PxProcessPxBaseCallbackE,__ZNK5physx15PxsParticleData15getWorldBoundsVEv,__ZN5physx23NpParticleFluidReadData18setDataAccessFlagsENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7setNameEPKc,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE14setOwnerClientEh,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE
,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getExternalAccelerationEv,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setExternalAccelerationERKNS_6PxVec3E,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setSimulationFilterDataERKNS_12PxFilterDataE,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getSimulationFilterDataEv,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx16NpParticleSystem15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx16NpParticleSystem8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7setNameEPKc,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE14setOwnerClientEh,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getCMassLocalPoseEv,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setMassSpaceInertiaTensorERKNS_6PxVec3E,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25getMassSpaceInertiaTensorEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE28getMassSpaceInvInertiaTensorEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getLinearVelocityEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE18getAngularVelocityEv,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE,__ZNK5physx14NpRigidDynamic13getGlobalPoseEv,__ZN5physx14NpRigidDynamic17setCMassLocalPoseERKNS_11PxTransformE,__ZN5physx14NpRigidDynamic10clearForceENS_11PxForceMode4EnumE,__ZN5physx14NpRigidDynamic11clearTorqueENS_11PxForceMode4EnumE
,__ZN5physx14NpRigidDynamic18setKinematicTargetERKNS_11PxTransformE,__ZN5physx14NpRigidDynamic8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7setNameEPKc,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17setDominanceGroupEh,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE14setOwnerClientEh,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11attachShapeERNS_7PxShapeE,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE8requiresERNS_23PxProcessPxBaseCallbackE,__ZNK5physx13NpRigidStatic13getGlobalPoseEv,__ZN5physx13NpRigidStatic8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE,__ZN5physx7NpScene9setLimitsERKNS_13PxSceneLimitsE,__ZNK5physx7NpScene9getLimitsEv,__ZN5physx7NpScene15addArticulationERNS_14PxArticulationE,__ZN5physx7NpScene8addActorERNS_7PxActorE,__ZN5physx7NpScene12addAggregateERNS_11PxAggregateE,__ZN5physx7NpScene13addCollectionERKNS_12PxCollectionE,__ZN5physx7NpScene34setClothInterCollisionNbIterationsEj,__ZN5physx7NpScene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE,__ZN5physx7NpScene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE
,__ZN5physx7NpScene14resetFilteringERNS_7PxActorE,__ZN5physx7NpScene5flushEb,__ZN5physx7NpScene15flushSimulationEb,__ZN5physx7NpScene10setGravityERKNS_6PxVec3E,__ZNK5physx7NpScene10getGravityEv,__ZN5physx7NpScene15setCCDMaxPassesEj,__ZN5physx7NpScene15setFrictionTypeENS_14PxFrictionType4EnumE,__ZN5physx7NpScene26setVisualizationCullingBoxERKNS_9PxBounds3E,__ZNK5physx7NpScene23getSimulationStatisticsERNS_22PxSimulationStatisticsE,__ZN5physx7NpScene29setDynamicTreeRebuildRateHintEj,__ZN5physx7NpScene22setNbContactDataBlocksEj,__ZN5physx7NpScene18setSolverBatchSizeEj,__ZN5physx7NpScene11shiftOriginERKNS_6PxVec3E,__ZN5physx2Sc24ElementInteractionMarker11updateStateEb,__ZN5physx2Sc19ShapeInstancePairLL11updateStateEb,__ZN5physx13NpVolumeCache7forEachERNS_13PxVolumeCache8IteratorE,__ZN5physx13NpVolumeCache20setMaxNbStaticShapesEj,__ZN5physx13NpVolumeCache21setMaxNbDynamicShapesEj,__ZN5physx23ArticulationRootManager6resizeEj,__ZN5physx13IslandManager6resizeEj,__ZN5physx11EdgeManager6resizeEj,__ZN5physx11NodeManager6resizeEj,__ZN5physx2Sq12BucketPruner11preallocateEj,__ZN5physx2Sq12BucketPruner11shiftOriginERKNS_6PxVec3E,__ZN5physx2Sq11PruningPool11shiftOriginERKNS_6PxVec3E,__ZN5physx2Sq10AABBPruner11preallocateEj,__ZN5physx2Sq10AABBPruner11shiftOriginERKNS_6PxVec3E,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE6getDirEv
,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E6getDirEv,__ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx10conclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx15concludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx23PxsBroadPhaseContextSap11shiftOriginERKNS_6PxVec3E,__ZN5physx16PxsBroadPhaseMBP11shiftOriginERKNS_6PxVec3E,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE6getDirEv,__ZN5physx9PxTaskMgr16setCpuDispatcherERNS_15PxCpuDispatcherE,__ZN5physx9PxTaskMgr16setGpuDispatcherERNS_15PxGpuDispatcherE,__ZN5physx9PxTaskMgr16setSpuDispatcherERNS_15PxSpuDispatcherE,__ZN5physx9PxTaskMgr19initializeProfilingERNS_20PxProfileZoneManagerE,__ZN5physx9PxTaskMgr13taskCompletedERNS_6PxTaskE,__ZN5physx9PxTaskMgr12addReferenceEj,__ZN5physx9PxTaskMgr13decrReferenceEj,__ZN5physx9PxTaskMgr13decrReferenceERNS_14PxLightCpuTaskE,__ZN5physx9PxTaskMgr12addReferenceERNS_14PxLightCpuTaskE,__ZN5physx9PxTaskMgr13decrReferenceERNS_9PxSpuTaskE,__ZN5physx2Sc35ParticleElementRbElementInteraction11updateStateEb,__ZN5physx13NpClothFabric15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx13NpClothFabric8requiresERNS_23PxProcessPxBaseCallbackE,__ZNK5physx2Gu10ConvexMesh14getLocalBoundsEv
,__ZN5physx2Gu10ConvexMesh15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx2Gu10ConvexMesh8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx2Gu11HeightField15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx2Gu11HeightField8requiresERNS_23PxProcessPxBaseCallbackE,__ZNK5physx2Gu12TriangleMesh14getLocalBoundsEv,__ZN5physx2Gu12TriangleMesh15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx2Gu12TriangleMesh8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx14NpSpatialIndex6removeEj,__ZN5physx14NpSpatialIndex25setIncrementalRebuildRateEj,__ZNK5physx16PxsParticleShape10getBoundsVEv,__ZN5physx16PxsParticleShape12setUserDataVEPv,__ZNK5physx20PxsParticleSystemSim16getShapesUpdateVERNS_29PxvParticleShapeUpdateResultsE,__ZN5physx20PxsParticleSystemSim24setExternalAccelerationVERKNS_6PxVec3E,__ZN5physx20PxsParticleSystemSim13setSimulatedVEb,__ZN5physx20PxsParticleSystemSim19passCollisionInputVENS_31PxvParticleCollisionUpdateInputE,__ZN5physx7Cooking9setParamsERKNS_15PxCookingParamsE,__ZN5physx6shdfnd10Foundation13setErrorLevelENS_11PxErrorCode4EnumE,__ZN5physx6shdfnd10Foundation24setReportAllocationNamesEb,__ZN5physx6shdfnd10Foundation19AlignCheckAllocator10deallocateEPv,__ZN5physx6shdfnd10Foundation19AlignCheckAllocator26registerAllocationListenerERNS_20PxAllocationListenerE,__ZN5physx6shdfnd10Foundation19AlignCheckAllocator28deregisterAllocationListenerERNS_20PxAllocationListenerE,__ZN5physx2Cm10Collection6removeERNS_6PxBaseE,__ZN5physx2Cm10Collection3addERNS_12PxCollectionE,__ZN5physx2Cm10Collection6removeERNS_12PxCollectionE,__ZNK5physx2Cm19CmEventNameProvider15getProfileNamesEv,__ZN5physx2Cm17FreeListAllocator10deallocateEPv,__ZN11BoxCollider13AwakeFromLoadE17AwakeFromLoadMode,__ZN11BoxCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11BoxCollider23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN11BoxCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11BoxCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN8Collider26SupportedMessagesDidChangeEi,__ZN8Collider10DeactivateE19DeactivateOperation,__ZN8Collider10SetEnabledEb,__ZN8Collider12SetIsTriggerEb,__ZN8Collider9GetBoundsEv,__ZN11BoxCollider6CreateEPK9Rigidbody,__ZN11BoxCollider16TransformChangedEi,__ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode,__ZN8Collider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8Collider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8Collider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8Collider23VirtualRedirectTransferER14SafeBinaryRead,__ZN8Collider16TransformChangedEi,__ZN15CapsuleCollider13AwakeFromLoadE17AwakeFromLoadMode,__ZN15CapsuleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15CapsuleCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15CapsuleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15CapsuleCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN15CapsuleCollider9GetBoundsEv,__ZN15CapsuleCollider6CreateEPK9Rigidbody,__ZN15CapsuleCollider16TransformChangedEi,__ZN19CharacterController13AwakeFromLoadE17AwakeFromLoadMode,__ZN19CharacterController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN19CharacterController23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN19CharacterController23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN19CharacterController23VirtualRedirectTransferER14SafeBinaryRead,__ZN19CharacterController12SetIsTriggerEb,__ZN19CharacterController9GetBoundsEv,__ZN19CharacterController6CreateEPK9Rigidbody,__ZN19CharacterController16TransformChangedEi,__ZN5Unity5Joint13AwakeFromLoadE17AwakeFromLoadMode,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity14CharacterJoint23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity5Joint10DeactivateE19DeactivateOperation,__ZN5Unity5Joint7SetAxisERK8Vector3f,__ZN5Unity5Joint9SetAnchorERK8Vector3f,__ZN5Unity5Joint18SetConnectedAnchorERK8Vector3f,__ZN5Unity5Joint31SetAutoConfigureConnectedAnchorEb,__ZN5Unity5Joint18SetEnableCollisionEb,__ZN5Unity14CharacterJoint20ApplySetupAxesToDescEi,__ZN5Unity14CharacterJoint12SetSwingAxisERK8Vector3f,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER14SafeBinaryRead
,__ZN5Unity17ConfigurableJoint20ApplySetupAxesToDescEi,__ZN13ConstantForce23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13ConstantForce23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13ConstantForce23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13ConstantForce23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity10FixedJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity10FixedJoint23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity10FixedJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity10FixedJoint23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity10FixedJoint20ApplySetupAxesToDescEi,__ZN5Unity10HingeJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity10HingeJoint23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity10HingeJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity10HingeJoint23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity10HingeJoint20ApplySetupAxesToDescEi,__ZN12MeshCollider13AwakeFromLoadE17AwakeFromLoadMode,__ZN12MeshCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12MeshCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12MeshCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12MeshCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN12MeshCollider12SetIsTriggerEb,__ZN12MeshCollider6CreateEPK9Rigidbody
,__ZN12MeshCollider16TransformChangedEi,__ZN14PhysicMaterial13AwakeFromLoadE17AwakeFromLoadMode,__ZN14PhysicMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14PhysicMaterial23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14PhysicMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14PhysicMaterial23VirtualRedirectTransferER14SafeBinaryRead,__ZN14PhysicsManager13AwakeFromLoadE17AwakeFromLoadMode,__ZN14PhysicsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14PhysicsManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14PhysicsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14PhysicsManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Rigidbody13AwakeFromLoadE17AwakeFromLoadMode,__ZN9Rigidbody23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9Rigidbody23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Rigidbody23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Rigidbody23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Rigidbody26SupportedMessagesDidChangeEi,__ZN9Rigidbody10DeactivateE19DeactivateOperation,__ZN14SphereCollider13AwakeFromLoadE17AwakeFromLoadMode,__ZN14SphereCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14SphereCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14SphereCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE
,__ZN14SphereCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN14SphereCollider9GetBoundsEv,__ZN14SphereCollider6CreateEPK9Rigidbody,__ZN14SphereCollider16TransformChangedEi,__ZN5Unity11SpringJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity11SpringJoint23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity11SpringJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity11SpringJoint23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity11SpringJoint20ApplySetupAxesToDescEi,__ZN5physx7profile15ZoneManagerImpl14addProfileZoneERNS_13PxProfileZoneE,__ZN5physx7profile15ZoneManagerImpl17removeProfileZoneERNS_13PxProfileZoneE,__ZN5physx7profile15ZoneManagerImpl21addProfileZoneHandlerERNS_20PxProfileZoneHandlerE,__ZN5physx7profile15ZoneManagerImpl24removeProfileZoneHandlerERNS_20PxProfileZoneHandlerE,__ZN5physx7profile15ZoneManagerImpl21setUserCustomProfilerEPNS_20PxUserCustomProfilerE,__ZNK5physx7profile21NullEventNameProvider15getProfileNamesEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE,__ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE,__ZThn120_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_
,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZN12_GLOBAL__N_116RequiresCallback7processERN5physx6PxBaseE,__ZN12_GLOBAL__N_116CompleteCallback7processERN5physx6PxBaseE,__ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_,__ZN12_GLOBAL__N_116CollectionSorter7processERN5physx6PxBaseE,__ZN12_GLOBAL__N_118LegacySerialStream9alignDataEj,__ZN12_GLOBAL__N_118LegacySerialStream9writeNameEPKc,__ZN5physx22XmlMemoryAllocatorImpl10deallocateEPh,__ZN5physx2Sn18RepXCollectionImpl18setTolerancesScaleERKNS_17PxTolerancesScaleE,__ZNK5physx2Sn18RepXCollectionImpl18getTolerancesScaleEv,__ZN5physx2Sn18RepXCollectionImpl11setUpVectorERKNS_6PxVec3E,__ZNK5physx2Sn18RepXCollectionImpl11getUpVectorEv,__ZN5physx2Sn18RepXCollectionImpl17addCollectionItemENS0_18RepXCollectionItemE
,__ZN5physx2Sn18RepXCollectionImpl4saveERNS_14PxOutputStreamE,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8beginTagEPKc,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE10addContentEPKc,__ZN5physx2Sn13XmlWriterImpl15addAndGotoChildEPKc,__ZN5physx2Sn13XmlNodeWriter8beginTagEPKc,__ZN5physx2Sn13XmlNodeWriter10addContentEPKc,__ZN5physx2Sn13XmlNodeReader7setNodeERNS0_7XmlNodeE,__ZN5physx2Sn13XmlNodeReader14addOrGotoChildEPKc,__ZN5physx2Sn13XmlNodeReader19setCurrentItemValueEPKc,__ZN5physx2Sn9XmlParser10deallocateEPv,__ZN5physx20solveConcludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx15solveConclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx28solveConcludeContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx27solveConcludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx35solveConcludeContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx7profile32PxProfileMemoryEventRecorderImpl14onDeallocationEPv,__ZN5physx7profile32PxProfileMemoryEventRecorderImpl11setListenerEPNS_20PxAllocationListenerE,__ZN5physx7profile19MemoryEventRecorder14onDeallocationEPv,__ZN5physx7profile30PxProfileMemoryEventBufferImpl14onDeallocationEPv,__ZN5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE,__ZN5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE,__ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE,__ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE,__ZN12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE,__ZN12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE,__ZN12_GLOBAL__N_110Connection14onDeallocationEPv,__ZThn4_N12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE,__ZThn4_N12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE,__ZThn8_N12_GLOBAL__N_110Connection14onDeallocationEPv,__ZN12_GLOBAL__N_116MetaDataProvider15destroyInstanceEPKv
,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl9lockClassEN5physx8debugger18NonNegativeIntegerE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5writeERN5physx8debugger15PvdOutputStreamE,__ZN5physx8debugger4comm10EventGroup9serializeERNS1_15EventSerializerE,__ZN12_GLOBAL__N_110DataStream14pushPvdCommandERN5physx8debugger4comm21PvdInstanceDataStream10PvdCommandE,__ZN12_GLOBAL__N_124PropertyDefinitionHelper14getNamedValuesEv,__ZN5physx8debugger4comm11DeriveClass9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERh,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERt,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERj,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERf,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERy,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERPKc,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefIKhEE,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERt,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERj,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERf,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERy,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERPKc,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefIKhEE,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERh,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERt,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERj,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERf
,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERy,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERPKc,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefIKhEE,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE,__ZN5physx8debugger4comm17StringHandleEvent9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm11CreateClass9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm20StreamPropMessageArg9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm21CreatePropertyMessage9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm15NameHandleValue9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm14CreateProperty9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm19AddProfileZoneEvent9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm14AddProfileZone9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm11OriginShift9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm10EndSection9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm12BeginSection9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm15DestroyInstance9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm15RemoveObjectRef9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm17PushBackObjectRef9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm23EndPropertyMessageGroup9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm28SendPropertyMessageFromGroup9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm25BeginPropertyMessageGroup9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm18SetPropertyMessage9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm19EndSetPropertyValue9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm23AppendPropertyValueData9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm21BeginSetPropertyValue9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm16SetPropertyValue9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm14CreateInstance9serializeERNS1_15EventSerializerE,__ZN12_GLOBAL__N_117ProfileZoneClient16handleEventAddedERKN5physx18PxProfileEventNameE
,__ZN5physx8debugger4comm20StreamInitialization9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm13SetIsTopLevel9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm12ErrorMessage9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm9SetCamera9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm8SetColor9serializeERNS1_15EventSerializerE,__ZN5physx8debugger4comm11SetPickable9serializeERNS1_15EventSerializerE,__ZN12_GLOBAL__N_112UserRenderer9addClientERN5physx26PxProfileEventBufferClientE,__ZN12_GLOBAL__N_112UserRenderer12removeClientERN5physx26PxProfileEventBufferClientE,__ZN12_GLOBAL__N_112UserRenderer13setInstanceIdEPKv,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERy,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERf,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERh,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefIhEE,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer8PvdPointEEE,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer7PvdLineEEE,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer11PvdTriangleEEE,__ZN12_GLOBAL__N_117ConnectionManager21setProfileZoneManagerERN5physx20PxProfileZoneManagerE,__ZN12_GLOBAL__N_117ConnectionManager10addHandlerERN5physx8debugger4comm20PvdConnectionHandlerE,__ZN12_GLOBAL__N_117ConnectionManager13removeHandlerERN5physx8debugger4comm20PvdConnectionHandlerE,__ZN12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE,__ZN12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv,__ZN12_GLOBAL__N_117ConnectionManager14onDeallocationEPv,__ZThn4_N12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE,__ZThn4_N12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv,__ZThn8_N12_GLOBAL__N_117ConnectionManager14onDeallocationEPv,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERy,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERf,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERh,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefIhEE,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE
,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE,__ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERy,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERf,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERh,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefIhEE,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE,__ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE6getDirEv,__ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE6getDirEv,__ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv,__ZN13PhysicsModule10GetGravityEv,__ZN13PhysicsModule16GetProfilerStatsER12PhysicsStats,__ZN13PhysicsModule18ReleaseHeightFieldEPv,__ZN13PhysicsModule21ReleaseNxTriangleMeshEP17PhysicsModuleMesh,__ZN13PhysicsModule19ReleaseNxConvexMeshEP17PhysicsModuleMesh,__ZN13PhysicsModule18DeleteMemoryStreamEP19PhysicsModuleStream,__ZNK15b2DistanceJoint10GetAnchorAEv,__ZNK15b2DistanceJoint10GetAnchorBEv,__ZN7b2Joint11ShiftOriginERK6b2Vec2,__ZN15b2DistanceJoint23InitVelocityConstraintsERK12b2SolverData,__ZN15b2DistanceJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK15b2FrictionJoint10GetAnchorAEv,__ZNK15b2FrictionJoint10GetAnchorBEv,__ZN15b2FrictionJoint23InitVelocityConstraintsERK12b2SolverData,__ZN15b2FrictionJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK11b2GearJoint10GetAnchorAEv,__ZNK11b2GearJoint10GetAnchorBEv
,__ZN11b2GearJoint23InitVelocityConstraintsERK12b2SolverData,__ZN11b2GearJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK12b2MotorJoint10GetAnchorAEv,__ZNK12b2MotorJoint10GetAnchorBEv,__ZN12b2MotorJoint23InitVelocityConstraintsERK12b2SolverData,__ZN12b2MotorJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK12b2MouseJoint10GetAnchorAEv,__ZNK12b2MouseJoint10GetAnchorBEv,__ZN12b2MouseJoint11ShiftOriginERK6b2Vec2,__ZN12b2MouseJoint23InitVelocityConstraintsERK12b2SolverData,__ZN12b2MouseJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK16b2PrismaticJoint10GetAnchorAEv,__ZNK16b2PrismaticJoint10GetAnchorBEv,__ZN16b2PrismaticJoint23InitVelocityConstraintsERK12b2SolverData,__ZN16b2PrismaticJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK13b2PulleyJoint10GetAnchorAEv,__ZNK13b2PulleyJoint10GetAnchorBEv,__ZN13b2PulleyJoint11ShiftOriginERK6b2Vec2,__ZN13b2PulleyJoint23InitVelocityConstraintsERK12b2SolverData,__ZN13b2PulleyJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK15b2RevoluteJoint10GetAnchorAEv,__ZNK15b2RevoluteJoint10GetAnchorBEv,__ZN15b2RevoluteJoint23InitVelocityConstraintsERK12b2SolverData,__ZN15b2RevoluteJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK11b2RopeJoint10GetAnchorAEv,__ZNK11b2RopeJoint10GetAnchorBEv,__ZN11b2RopeJoint23InitVelocityConstraintsERK12b2SolverData,__ZN11b2RopeJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK11b2WeldJoint10GetAnchorAEv,__ZNK11b2WeldJoint10GetAnchorBEv
,__ZN11b2WeldJoint23InitVelocityConstraintsERK12b2SolverData,__ZN11b2WeldJoint24SolveVelocityConstraintsERK12b2SolverData,__ZNK12b2WheelJoint10GetAnchorAEv,__ZNK12b2WheelJoint10GetAnchorBEv,__ZN12b2WheelJoint23InitVelocityConstraintsERK12b2SolverData,__ZN12b2WheelJoint24SolveVelocityConstraintsERK12b2SolverData,__ZN17b2ContactListener12BeginContactEP9b2Contact,__ZN17b2ContactListener10EndContactEP9b2Contact,__ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN15AnchoredJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15AnchoredJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15AnchoredJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15AnchoredJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN7Joint2D10DeactivateE19DeactivateOperation,__ZN7Joint2D7CleanupEb,__ZN15AnchoredJoint2D9SetAnchorERK8Vector2f,__ZN15AnchoredJoint2D18SetConnectedAnchorERK8Vector2f,__ZN7Joint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN7Joint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN7Joint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN7Joint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN10Effector2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN14AreaEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14AreaEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14AreaEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer
,__ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14AreaEffector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN14AreaEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE,__ZN14AreaEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE,__ZN10Effector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10Effector2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10Effector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10Effector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN10Collider2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN13BoxCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13BoxCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13BoxCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13BoxCollider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN10Collider2D10DeactivateE19DeactivateOperation,__ZN13BoxCollider2D14CreateInternalEP11Rigidbody2D,__ZN13BoxCollider2D12SetPolygon2DEP9Polygon2D,__ZN10Collider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10Collider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10Collider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10Collider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN10Collider2D12SetPolygon2DEP9Polygon2D,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18BuoyancyEffector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN18BuoyancyEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE,__ZN18BuoyancyEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE,__ZN17CapsuleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17CapsuleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17CapsuleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17CapsuleCollider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN17CapsuleCollider2D14CreateInternalEP11Rigidbody2D,__ZN16CircleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16CircleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16CircleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16CircleCollider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN16CircleCollider2D14CreateInternalEP11Rigidbody2D,__ZN19CollisionListener2D12BeginContactEP9b2Contact,__ZN19CollisionListener2D10EndContactEP9b2Contact,__ZN15ConstantForce2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15ConstantForce2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15ConstantForce2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15ConstantForce2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN15DistanceJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN15DistanceJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN15DistanceJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15DistanceJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15DistanceJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN14EdgeCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN14EdgeCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN14EdgeCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN14EdgeCollider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN14EdgeCollider2D14CreateInternalEP11Rigidbody2D,__ZN14EdgeCollider2D12SetPolygon2DEP9Polygon2D,__ZN12FixedJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN12FixedJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12FixedJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12FixedJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12FixedJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN12FixedJoint2D7CleanupEb,__ZN15FrictionJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN15FrictionJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15FrictionJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15FrictionJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15FrictionJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN12HingeJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN12HingeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN12HingeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12HingeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12HingeJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN12HingeJoint2D7CleanupEb,__ZN16Physics2DManager16GetProfilerStatsER14Physics2DStats,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17PhysicsMaterial2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN17Physics2DSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN17Physics2DSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17Physics2DSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17Physics2DSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17Physics2DSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN18PlatformEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18PlatformEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18PlatformEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18PlatformEffector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN18PlatformEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE,__ZN18PlatformEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE,__ZN15PointEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15PointEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN15PointEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15PointEffector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN15PointEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE,__ZN15PointEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE,__ZN17PolygonCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17PolygonCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17PolygonCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17PolygonCollider2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN17PolygonCollider2D14CreateInternalEP11Rigidbody2D,__ZN17PolygonCollider2D12SetPolygon2DEP9Polygon2D,__ZN15RelativeJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN15RelativeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15RelativeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15RelativeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15RelativeJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN11Rigidbody2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN11Rigidbody2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11Rigidbody2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11Rigidbody2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11Rigidbody2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN11Rigidbody2D10DeactivateE19DeactivateOperation,__ZN13SliderJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN13SliderJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13SliderJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13SliderJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13SliderJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN13SliderJoint2D7CleanupEb,__ZN13SpringJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN13SpringJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13SpringJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13SpringJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13SpringJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN17SurfaceEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17SurfaceEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17SurfaceEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17SurfaceEffector2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN17SurfaceEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE,__ZN17SurfaceEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE,__ZN13TargetJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN13TargetJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13TargetJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13TargetJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13TargetJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN12WheelJoint2D13AwakeFromLoadE17AwakeFromLoadMode,__ZN12WheelJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12WheelJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12WheelJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12WheelJoint2D23VirtualRedirectTransferER14SafeBinaryRead,__ZN5physx15PxVehicleWheels8requiresERNS_23PxProcessPxBaseCallbackE,__ZN5physx16PxVehicleNoDrive15exportExtraDataERNS_22PxSerializationContextE,__ZN5physx15PxVehicleWheels15exportExtraDataERNS_22PxSerializationContextE,__ZN13WheelCollider13AwakeFromLoadE17AwakeFromLoadMode,__ZN13WheelCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13WheelCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13WheelCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13WheelCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN13WheelCollider10DeactivateE19DeactivateOperation,__ZN13WheelCollider6CreateEPK9Rigidbody,__ZN13WheelCollider16TransformChangedEi,__ZN5physx25PxVehicleConstraintShader10onComShiftEj,__ZN5physx25PxVehicleConstraintShader13onOriginShiftERKNS_6PxVec3E,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_,__ZN14VehiclesModule33ResetWheelQueriesTouchingColliderEP8Collider,__ZN14VehiclesModule17InvalidateVehicleEj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv
,__ZN5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E,__ZN5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE,__ZN5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E,__ZN5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE,__ZN5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb,__ZN5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE,__ZN5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE,__ZN5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj,__ZN5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv
,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj
,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv,__ZN5physx5cloth8SwSolver8addClothEPNS0_5ClothE,__ZN5physx5cloth8SwSolver11removeClothEPNS0_5ClothE,__ZN5physx5cloth8SwSolver29setInterCollisionNbIterationsEj,__ZN5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E,__ZThn4_N5physx5cloth8SwSolver8addClothEPNS0_5ClothE,__ZThn4_N5physx5cloth8SwSolver11removeClothEPNS0_5ClothE,__ZThn4_N5physx5cloth8SwSolver29setInterCollisionNbIterationsEj,__ZThn4_N5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E,__ZN5Unity5Cloth13AwakeFromLoadE17AwakeFromLoadMode,__ZN5Unity5Cloth23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN5Unity5Cloth23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN5Unity5Cloth23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN5Unity5Cloth23VirtualRedirectTransferER14SafeBinaryRead,__ZN5Unity5Cloth10DeactivateE19DeactivateOperation,__ZN5Unity5Cloth10SetEnabledEb,__ZN11ClothModule23SetClothingSceneGravityERK8Vector3f,__ZN12NavMeshAgent13AwakeFromLoadE17AwakeFromLoadMode,__ZN12NavMeshAgent23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12NavMeshAgent23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12NavMeshAgent23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12NavMeshAgent23VirtualRedirectTransferER14SafeBinaryRead,__ZN15NavMeshObstacle13AwakeFromLoadE17AwakeFromLoadMode,__ZN15NavMeshObstacle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN15NavMeshObstacle23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15NavMeshObstacle23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15NavMeshObstacle23VirtualRedirectTransferER14SafeBinaryRead,__ZN11OffMeshLink13AwakeFromLoadE17AwakeFromLoadMode,__ZN11OffMeshLink23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11OffMeshLink23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11OffMeshLink23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11OffMeshLink23VirtualRedirectTransferER14SafeBinaryRead,__ZN11NavMeshData13AwakeFromLoadE17AwakeFromLoadMode,__ZN11NavMeshData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11NavMeshData23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11NavMeshData23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11NavMeshData23VirtualRedirectTransferER14SafeBinaryRead,__ZN22NavMeshProjectSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN22NavMeshProjectSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN15NavMeshSettings13AwakeFromLoadE17AwakeFromLoadMode,__ZN15NavMeshSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15NavMeshSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15NavMeshSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer
,__ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15NavMeshSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN11AudioFilter13AwakeFromLoadE17AwakeFromLoadMode,__ZN17AudioChorusFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17AudioChorusFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17AudioChorusFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17AudioChorusFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN11AudioFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11AudioFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11AudioFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11AudioFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN10SampleClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10SampleClip23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10SampleClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10SampleClip23VirtualRedirectTransferER14SafeBinaryRead,__ZN9AudioClip13AwakeFromLoadE17AwakeFromLoadMode,__ZN9AudioClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN9AudioClip23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9AudioClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9AudioClip23VirtualRedirectTransferER14SafeBinaryRead,__ZN21AudioDistortionFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN21AudioDistortionFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN21AudioDistortionFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN21AudioDistortionFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN15AudioEchoFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15AudioEchoFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15AudioEchoFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15AudioEchoFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN19AudioHighPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN19AudioHighPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN19AudioHighPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN19AudioHighPassFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN13AudioListener13AwakeFromLoadE17AwakeFromLoadMode,__ZN13AudioListener23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13AudioListener23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13AudioListener23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13AudioListener23VirtualRedirectTransferER14SafeBinaryRead,__ZN18AudioLowPassFilter13AwakeFromLoadE17AwakeFromLoadMode,__ZN18AudioLowPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18AudioLowPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18AudioLowPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18AudioLowPassFilter23VirtualRedirectTransferER14SafeBinaryRead
,__ZN12AudioManager13AwakeFromLoadE17AwakeFromLoadMode,__ZN12AudioManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN12AudioManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN12AudioManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN12AudioManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN10AudioMixer13AwakeFromLoadE17AwakeFromLoadMode,__ZN10AudioMixer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN10AudioMixer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN10AudioMixer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN10AudioMixer23VirtualRedirectTransferER14SafeBinaryRead,__ZN10AudioMixer21UpdateCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE,__ZN15AudioMixerGroup13AwakeFromLoadE17AwakeFromLoadMode,__ZN15AudioMixerGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15AudioMixerGroup23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15AudioMixerGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15AudioMixerGroup23VirtualRedirectTransferER14SafeBinaryRead,__ZN18AudioMixerSnapshot13AwakeFromLoadE17AwakeFromLoadMode,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18AudioMixerSnapshot23VirtualRedirectTransferER14SafeBinaryRead,__ZN17AudioReverbFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN17AudioReverbFilter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN17AudioReverbFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN17AudioReverbFilter23VirtualRedirectTransferER14SafeBinaryRead,__ZN15AudioReverbZone13AwakeFromLoadE17AwakeFromLoadMode,__ZN15AudioReverbZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15AudioReverbZone23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15AudioReverbZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15AudioReverbZone23VirtualRedirectTransferER14SafeBinaryRead,__ZN11AudioSource13AwakeFromLoadE17AwakeFromLoadMode,__ZN11AudioSource23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11AudioSource23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11AudioSource23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11AudioSource23VirtualRedirectTransferER14SafeBinaryRead,__ZN7mecanim6memory16MecanimAllocator10DeallocateEPv,__ZN11AudioModule16SetListenerPauseEb,__ZN11AudioModule19SetApplicationPauseEb,__ZN11AudioModule23DeleteAudioCustomFilterEP17AudioCustomFilter,__ZN11AudioModule16GetProfilerStatsER10AudioStats,__ZN11AudioModule23SetProfilerCaptureFlagsEi,__ZN11AudioModule25AudioManagerAwakeFromLoadE17AwakeFromLoadMode,__ZN11AudioModule26SetDefaultMicrophoneDriverEPv,__ZN9Animation13AwakeFromLoadE17AwakeFromLoadMode,__ZN9Animation23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb0EE
,__ZN9Animation23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN9Animation23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN9Animation23VirtualRedirectTransferER14SafeBinaryRead,__ZN9Animation10DeactivateE19DeactivateOperation,__ZN13AnimationClip13AwakeFromLoadE17AwakeFromLoadMode,__ZN13AnimationClip7SetNameEPKc,__ZN13AnimationClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13AnimationClip23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13AnimationClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13AnimationClip23VirtualRedirectTransferER14SafeBinaryRead,__ZNK13AnimationClip15GetAverageSpeedEv,__ZN6Motion21AddSelfToDependenciesER8UserList,__ZNK13AnimationClip17GetAnimationClipsEv,__ZN7mecanim6memory16ChainedAllocator10DeallocateEPv,__ZN8Animator13AwakeFromLoadE17AwakeFromLoadMode,__ZN8Animator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN8Animator23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN8Animator23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN8Animator23VirtualRedirectTransferER14SafeBinaryRead,__ZN8Animator10DeactivateE19DeactivateOperation,__ZN8Animator9GetStagesER13dynamic_arrayI9StageDescLj4EE,__ZN8Animator16TransformChangedEi,__ZN17AnimationPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant,__ZN17AnimationPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE,__ZN17AnimationPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIP26AnimatorControllerPlayableLj4EE
,__ZN17AnimationPlayable13AddObjectUserER8UserList,__ZN17AnimationPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE,__ZN17AnimationPlayable16DestroyRecursiveERN7mecanim6memory16MecanimAllocatorE,__ZN17AnimationPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE,__ZN27AnimationLayerMixerPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant,__ZN21AnimationPosePlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant,__ZN21AnimationClipPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant,__ZN21AnimationClipPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE,__ZN21AnimationClipPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE,__ZN7mecanim6memory16InPlaceAllocator10DeallocateEPv,__ZN26AnimatorControllerPlayable12SetPlayStateE9PlayState,__ZN26AnimatorControllerPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE,__ZN26AnimatorControllerPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIPS_Lj4EE,__ZN26AnimatorControllerPlayable13AddObjectUserER8UserList,__ZN26AnimatorControllerPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE,__ZN18AnimatorController13AwakeFromLoadE17AwakeFromLoadMode,__ZN18AnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18AnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18AnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18AnimatorController23VirtualRedirectTransferER14SafeBinaryRead,__ZNK18AnimatorController27GetAnimationClipsToRegisterEv,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN25RuntimeAnimatorController23VirtualRedirectTransferER14SafeBinaryRead,__ZN26AnimatorOverrideController13AwakeFromLoadE17AwakeFromLoadMode
,__ZN26AnimatorOverrideController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN26AnimatorOverrideController23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN26AnimatorOverrideController23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN26AnimatorOverrideController23VirtualRedirectTransferER14SafeBinaryRead,__ZNK26AnimatorOverrideController27GetAnimationClipsToRegisterEv,__ZN6Avatar13AwakeFromLoadE17AwakeFromLoadMode,__ZN6Avatar23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN6Avatar23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN6Avatar23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN6Avatar23VirtualRedirectTransferER14SafeBinaryRead,__ZN7Terrain23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN7Terrain23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN7Terrain23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN7Terrain23VirtualRedirectTransferER14SafeBinaryRead,__ZN11TerrainData13AwakeFromLoadE17AwakeFromLoadMode,__ZN11TerrainData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN11TerrainData23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN11TerrainData23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN11TerrainData23VirtualRedirectTransferER14SafeBinaryRead,__ZN14TerrainManager10AddTerrainEP7Terrain,__ZN14TerrainManager13RemoveTerrainEP7Terrain,__ZN4Tree23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE
,__ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN4Tree23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN4Tree23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN4Tree23VirtualRedirectTransferER14SafeBinaryRead,__ZN13TextRendering4Font13AwakeFromLoadE17AwakeFromLoadMode,__ZN13TextRendering4Font23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN13TextRendering4Font23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN13TextRendering4Font23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN13TextRendering4Font23VirtualRedirectTransferER14SafeBinaryRead,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER14SafeBinaryRead,__ZN20TextRenderingPrivate8TextMesh13AwakeFromLoadE17AwakeFromLoadMode,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER14SafeBinaryRead,__Z6FTFreeP13FT_MemoryRec_Pv,__ZN2UI6Canvas13AwakeFromLoadE17AwakeFromLoadMode,__ZN2UI6Canvas23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN2UI6Canvas23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN2UI6Canvas23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN2UI6Canvas23VirtualRedirectTransferER14SafeBinaryRead,__ZN2UI11CanvasGroup13AwakeFromLoadE17AwakeFromLoadMode,__ZN2UI11CanvasGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN2UI11CanvasGroup23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN2UI11CanvasGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN2UI11CanvasGroup23VirtualRedirectTransferER14SafeBinaryRead,__ZN2UI14CanvasRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN2UI14CanvasRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN15TerrainCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15TerrainCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15TerrainCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15TerrainCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZN15TerrainCollider12SetIsTriggerEb,__ZN15TerrainCollider6CreateEPK9Rigidbody,__ZN15TerrainCollider16TransformChangedEi,__ZN11IMGUIModule12AddGUIScriptER8ListNodeI13MonoBehaviourE,__ZN11IMGUIModule26SetDeveloperConsoleVisibleEb,__ZN15DownloadHandler21OnBindScriptingObjectEP12Il2CppObject,__ZN26DownloadHandlerAssetBundle22OnReceiveContentLengthEj
,__ZN24DownloadHandlerAudioClip22OnReceiveContentLengthEj,__ZN21DownloadHandlerBuffer22OnReceiveContentLengthEj,__ZN21DownloadHandlerScript21OnBindScriptingObjectEP12Il2CppObject,__ZN21DownloadHandlerScript22OnReceiveContentLengthEj,__ZN22DownloadHandlerTexture22OnReceiveContentLengthEj,__ZN18DownloadHandlerVFS22OnReceiveContentLengthEj,__ZN13UploadHandler21OnBindScriptingObjectEP12Il2CppObject,__ZN13UploadHandler10OnSentDataEj,__ZN15UnityAdsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15UnityAdsManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15UnityAdsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15UnityAdsManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN11UnityEngine9Analytics9PerfEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine9Analytics15UserCustomEvent12ToJsonStringER9JSONWrite,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN21UnityAnalyticsManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN11UnityEngine9Analytics16TransactionEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine9Analytics13UserInfoEvent12ToJsonStringER9JSONWrite,__ZN18CrashReportManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN18CrashReportManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN18CrashReportManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN18CrashReportManager23VirtualRedirectTransferER14SafeBinaryRead
,__ZN11UnityEngine7Connect15AppRunningEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine7Connect15AppInstallEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine7Connect15DeviceInfoEvent12ToJsonStringER9JSONWrite,__ZN11UnityEngine7Connect20BasePersistentValues13RestoreValuesER8JSONRead,__ZN11UnityEngine7Connect20BasePersistentValues10SaveValuesER9JSONWrite,__ZN20UnityConnectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN20UnityConnectSettings23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN20UnityConnectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN20UnityConnectSettings23VirtualRedirectTransferER14SafeBinaryRead,__ZN16UnityAdsSettings10InitializeER6Object,__ZN22UnityAnalyticsSettings10InitializeER6Object,__ZN19BaseConnectSettings10InitializeER6Object,__ZN11UnityEngine7Connect16PersistentValues13RestoreValuesER8JSONRead,__ZN11UnityEngine7Connect16PersistentValues10SaveValuesER9JSONWrite,__ZN23UnityPurchasingSettings10InitializeER6Object,__ZN8VRDevice8SetPauseEb,__ZN8VRDevice10PostRenderEPK6Camera,__ZNK8VRDevice13GetDeviceNameEv,__ZNK8VRDevice14GetDeviceModelEv,__ZN23CloudWebServicesManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN23CloudWebServicesManager23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN23CloudWebServicesManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN23CloudWebServicesManager23VirtualRedirectTransferER14SafeBinaryRead,__ZN11UnityEngine15CloudWebService14DataDispatcher26OnSessionContainerArchivedERNS0_16SessionContainerE,__ZN11UnityEngine15CloudWebService14DataDispatcher34OnSessionContainerArchivedAndReadyERNS0_16SessionContainerE
,__ZN11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE,__ZThn4_N11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE6SetUrlERK8UnityStr,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE13SetDownloaderERNS0_14RestDownloaderE,__ZN11UnityEngine15CloudWebService18RestFileDownloader22OnReceiveContentLengthEj,__ZN11UnityEngine15CloudWebService14RestDownloader22OnReceiveContentLengthEj,__ZN15ParticleEmitter13AwakeFromLoadE17AwakeFromLoadMode,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead,__ZN15ParticleEmitter10DeactivateE19DeactivateOperation,__ZN15ParticleEmitter10SetEnabledEb,__ZN15ParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN15ParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN15ParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN15ParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead,__ZN19MeshParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN19MeshParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN19MeshParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN19MeshParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead,__ZN16ParticleAnimator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16ParticleAnimator23VirtualRedirectTransferER17RemapPPtrTransfer
,__ZN16ParticleAnimator23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16ParticleAnimator23VirtualRedirectTransferER14SafeBinaryRead,__ZN16ParticleRenderer13AwakeFromLoadE17AwakeFromLoadMode,__ZN16ParticleRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN16ParticleRenderer23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN16ParticleRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN16ParticleRenderer23VirtualRedirectTransferER14SafeBinaryRead,__ZN21WorldParticleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE,__ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE,__ZN21WorldParticleCollider23VirtualRedirectTransferER17RemapPPtrTransfer,__ZN21WorldParticleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer,__ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE,__ZN21WorldParticleCollider23VirtualRedirectTransferER14SafeBinaryRead,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE,__ZNSt3__211__stdoutbufIwE5imbueERKNS_6localeE,__ZNSt3__211__stdoutbufIcE5imbueERKNS_6localeE,__ZNSt3__210__stdinbufIwE5imbueERKNS_6localeE,__ZNSt3__210__stdinbufIcE5imbueERKNS_6localeE,__ZNKSt3__210moneypunctIcLb0EE11do_groupingEv,__ZNKSt3__210moneypunctIcLb0EE14do_curr_symbolEv,__ZNKSt3__210moneypunctIcLb0EE16do_positive_signEv,__ZNKSt3__210moneypunctIcLb0EE16do_negative_signEv,__ZNKSt3__210moneypunctIcLb0EE13do_pos_formatEv,__ZNKSt3__210moneypunctIcLb0EE13do_neg_formatEv,__ZNKSt3__210moneypunctIcLb1EE11do_groupingEv,__ZNKSt3__210moneypunctIcLb1EE14do_curr_symbolEv,__ZNKSt3__210moneypunctIcLb1EE16do_positive_signEv
,__ZNKSt3__210moneypunctIcLb1EE16do_negative_signEv,__ZNKSt3__210moneypunctIcLb1EE13do_pos_formatEv,__ZNKSt3__210moneypunctIcLb1EE13do_neg_formatEv,__ZNKSt3__210moneypunctIwLb0EE11do_groupingEv,__ZNKSt3__210moneypunctIwLb0EE14do_curr_symbolEv,__ZNKSt3__210moneypunctIwLb0EE16do_positive_signEv,__ZNKSt3__210moneypunctIwLb0EE16do_negative_signEv,__ZNKSt3__210moneypunctIwLb0EE13do_pos_formatEv,__ZNKSt3__210moneypunctIwLb0EE13do_neg_formatEv,__ZNKSt3__210moneypunctIwLb1EE11do_groupingEv,__ZNKSt3__210moneypunctIwLb1EE14do_curr_symbolEv,__ZNKSt3__210moneypunctIwLb1EE16do_positive_signEv,__ZNKSt3__210moneypunctIwLb1EE16do_negative_signEv,__ZNKSt3__210moneypunctIwLb1EE13do_pos_formatEv,__ZNKSt3__210moneypunctIwLb1EE13do_neg_formatEv,__ZNKSt3__217moneypunct_bynameIcLb0EE11do_groupingEv,__ZNKSt3__217moneypunct_bynameIcLb0EE14do_curr_symbolEv,__ZNKSt3__217moneypunct_bynameIcLb0EE16do_positive_signEv,__ZNKSt3__217moneypunct_bynameIcLb0EE16do_negative_signEv,__ZNKSt3__217moneypunct_bynameIcLb0EE13do_pos_formatEv,__ZNKSt3__217moneypunct_bynameIcLb0EE13do_neg_formatEv,__ZNKSt3__217moneypunct_bynameIcLb1EE11do_groupingEv,__ZNKSt3__217moneypunct_bynameIcLb1EE14do_curr_symbolEv,__ZNKSt3__217moneypunct_bynameIcLb1EE16do_positive_signEv,__ZNKSt3__217moneypunct_bynameIcLb1EE16do_negative_signEv,__ZNKSt3__217moneypunct_bynameIcLb1EE13do_pos_formatEv,__ZNKSt3__217moneypunct_bynameIcLb1EE13do_neg_formatEv,__ZNKSt3__217moneypunct_bynameIwLb0EE11do_groupingEv,__ZNKSt3__217moneypunct_bynameIwLb0EE14do_curr_symbolEv,__ZNKSt3__217moneypunct_bynameIwLb0EE16do_positive_signEv
,__ZNKSt3__217moneypunct_bynameIwLb0EE16do_negative_signEv,__ZNKSt3__217moneypunct_bynameIwLb0EE13do_pos_formatEv,__ZNKSt3__217moneypunct_bynameIwLb0EE13do_neg_formatEv,__ZNKSt3__217moneypunct_bynameIwLb1EE11do_groupingEv,__ZNKSt3__217moneypunct_bynameIwLb1EE14do_curr_symbolEv,__ZNKSt3__217moneypunct_bynameIwLb1EE16do_positive_signEv,__ZNKSt3__217moneypunct_bynameIwLb1EE16do_negative_signEv,__ZNKSt3__217moneypunct_bynameIwLb1EE13do_pos_formatEv,__ZNKSt3__217moneypunct_bynameIwLb1EE13do_neg_formatEv,__ZNKSt3__28messagesIcE8do_closeEi,__ZNKSt3__28messagesIwE8do_closeEi,__ZNKSt3__28numpunctIcE11do_groupingEv,__ZNKSt3__28numpunctIcE11do_truenameEv,__ZNKSt3__28numpunctIcE12do_falsenameEv,__ZNKSt3__28numpunctIwE11do_groupingEv,__ZNKSt3__28numpunctIwE11do_truenameEv,__ZNKSt3__28numpunctIwE12do_falsenameEv,_emscripten_longjmp__wrapper,_UNITY_png_zfree,_UNITY_png_free,_free_pool,_write_marker_byte,_start_pass_prep,_start_pass_huff,_start_pass_coef,_start_pass_main,_start_pass_coef_19,_start_pass_dpost,_start_pass_main_29,_skip_input_data
,_emit_message,_unity_z_zcfree,__ZN8DrawUtil31CleanupDrawMeshRawFromNodeQueueER15RenderNodeQueuej,__Z39CanvasBatchIntermediateRenderer_CleanupR15RenderNodeQueuej,__ZL22ScheduleSceneNodesJobsP25ScheduleSceneNodesJobDataj,__ZL20PrepareSceneNodesJobP24PrepareSceneNodesJobDataj,__ZN11HaloManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj,__ZN12FlareManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj,__ZL38FrustumAndOcculusionCullLocalLightsJobP21LocalLightCullJobDataj,__ZL19BlendLightProbesJobP19BlendProbesJobInputj,__ZN13RendererScene28SceneAfterCullingOutputReadyEPK9IndexListPK16RendererCullData,__Z17Projector_CleanupR15RenderNodeQueuej,__ZN16ReflectionProbes20DidChangeActiveSceneEP10UnitySceneS1_,__ZL21ExecuteRenderQueueJobP29RenderNodeQueuePrepareContextj,__ZL20DidChangeActiveSceneP10UnitySceneS0_,__ZL21CullDynamicObjectsJobP14CullingJobDataj,__ZL24QueryPortalVisibilityJobP28QueryPortalVisibilityJobDataj,__ZL25CullLocalShadowCastersJobP25LocalShadowCullingJobDataj,__Z31CullDirectionalShadowCastersJobP20ShadowCullingJobDataj,__ZL12ShadowMapJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__ZL12CullGroupJobP20CullingGroupsJobDataj,__ZL25CullAllPerObjectLightsJobP29CullAllPerObjectLightsJobDataj,__ZL21DeferredRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__ZL20ForwardRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__ZL25MotionVectorRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__ZL18ReplacementPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__ZL12DepthPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE,__Z30ProcessDynamicBatchGeometryJobP25DynamicVBOGeometryJobDataj,__ZL21LibpngReadWarningFuncP14png_struct_defPKc,_UNITY_png_read_info
,_UNITY_png_read_update_info,_UNITY_png_read_end,__ZL15skip_input_dataP22jpeg_decompress_structl,__ZN16LightmapSettings20DidChangeActiveSceneEP10UnitySceneS1_,__ZL7StbFreePvS_,__ZL22SRGB_GammaToLinear_JobP17ImageSliceJobDataj,__ZL22SRGB_LinearToGamma_JobP17ImageSliceJobDataj,__ZL22ConvertImageToRGBM_JobP17ImageSliceJobDataj,_UNITY_png_destroy_write_struct,_UNITY_png_set_compression_level,_UNITY_png_write_info,_UNITY_png_write_end,_UNITY_png_write_row,__ZN12LineRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj,__ZN13TrailRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj,__Z25BillboardRenderer_CleanupR15RenderNodeQueuej,__ZN21BillboardBatchManager17BillboardBatchJobEP25DynamicVBOGeometryJobDataj,__Z22SpriteRenderer_CleanupR15RenderNodeQueuej,__ZN14SpriteRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj,__ZL12InvokeMethodI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI14SafeBinaryReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI14SafeBinaryReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI14SafeBinaryReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI17RemapPPtrTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI17RemapPPtrTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z30TransferField_LinearCollectionI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL21RegisterInterfaceImpl18UnityInterfaceGUIDP15IUnityInterface,__Z48AddToTimeSliceAwakeFromLoadQueueProgressCallbackR6ObjectPv,__ZL18ActiveSceneChangedP10UnitySceneS0_,__Z36Application_CUSTOM_CaptureScreenshotP12Il2CppStringi,__Z39Application_CUSTOM_SetStackTraceLogType7LogTypei
,__Z50Application_CUSTOM_ReplyToUserAuthorizationRequesthh,__Z25AssetBundle_CUSTOM_UnloadP12Il2CppObjecth,__Z38AsyncOperation_Set_Custom_PropPriorityP12Il2CppObjecti,__Z50AsyncOperation_Set_Custom_PropAllowSceneActivationP12Il2CppObjecth,__Z32Behaviour_Set_Custom_PropEnabledP12Il2CppObjecth,__Z38BillboardAsset_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z47BillboardAsset_CUSTOM_GetImageTexCoordsInternalP12Il2CppObjectS0_,__Z39BillboardAsset_CUSTOM_SetImageTexCoordsP12Il2CppObjectP11Il2CppArray,__Z51BillboardAsset_CUSTOM_SetImageTexCoordsInternalListP12Il2CppObjectS0_,__Z41BillboardAsset_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_,__Z33BillboardAsset_CUSTOM_SetVerticesP12Il2CppObjectP11Il2CppArray,__Z45BillboardAsset_CUSTOM_SetVerticesInternalListP12Il2CppObjectS0_,__Z40BillboardAsset_CUSTOM_GetIndicesInternalP12Il2CppObjectS0_,__Z32BillboardAsset_CUSTOM_SetIndicesP12Il2CppObjectP11Il2CppArray,__Z44BillboardAsset_CUSTOM_SetIndicesInternalListP12Il2CppObjectS0_,__Z42BillboardRenderer_Set_Custom_PropBillboardP12Il2CppObjectS0_,__Z48Caching_Set_Custom_PropMaximumAvailableDiskSpacex,__Z35Camera_Set_Custom_PropRenderingPathP12Il2CppObject13RenderingPath,__Z25Camera_Set_Custom_PropHdrP12Il2CppObjecth,__Z34Camera_Set_Custom_PropOrthographicP12Il2CppObjecth,__Z36Camera_Set_Custom_PropOpaqueSortModeP12Il2CppObjectN6Camera14OpaqueSortModeE,__Z42Camera_Set_Custom_PropTransparencySortModeP12Il2CppObjectN6Camera20TransparencySortModeE,__Z33Camera_Set_Custom_PropCullingMaskP12Il2CppObjecti,__Z31Camera_Set_Custom_PropEventMaskP12Il2CppObjecti,__Z42Camera_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf,__Z42Camera_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf,__Z31Camera_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE,__Z31Camera_CUSTOM_INTERNAL_set_rectP12Il2CppObjectRK5RectTIfE,__Z36Camera_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE,__Z36Camera_CUSTOM_INTERNAL_set_pixelRectP12Il2CppObjectRK5RectTIfE
,__Z35Camera_Set_Custom_PropTargetTextureP12Il2CppObjectS0_,__Z46Camera_CUSTOM_INTERNAL_get_cameraToWorldMatrixP12Il2CppObjectP10Matrix4x4f,__Z46Camera_CUSTOM_INTERNAL_get_worldToCameraMatrixP12Il2CppObjectP10Matrix4x4f,__Z46Camera_CUSTOM_INTERNAL_set_worldToCameraMatrixP12Il2CppObjectRK10Matrix4x4f,__Z43Camera_CUSTOM_INTERNAL_get_projectionMatrixP12Il2CppObjectP10Matrix4x4f,__Z43Camera_CUSTOM_INTERNAL_set_projectionMatrixP12Il2CppObjectRK10Matrix4x4f,__Z54Camera_CUSTOM_INTERNAL_get_nonJitteredProjectionMatrixP12Il2CppObjectP10Matrix4x4f,__Z54Camera_CUSTOM_INTERNAL_set_nonJitteredProjectionMatrixP12Il2CppObjectRK10Matrix4x4f,__Z72Camera_Set_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObjecth,__Z35Camera_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z32Camera_Set_Custom_PropClearFlagsP12Il2CppObjecti,__Z32Camera_Set_Custom_PropCameraTypeP12Il2CppObject10CameraType,__Z38Camera_Set_Custom_PropStereoMirrorModeP12Il2CppObjecth,__Z37Camera_Set_Custom_PropStereoTargetEyeP12Il2CppObject13TargetEyeMask,__Z35Camera_Set_Custom_PropTargetDisplayP12Il2CppObjecti,__Z41Camera_Set_Custom_PropUseOcclusionCullingP12Il2CppObjecth,__Z40Camera_CUSTOM_INTERNAL_get_cullingMatrixP12Il2CppObjectP10Matrix4x4f,__Z40Camera_CUSTOM_INTERNAL_set_cullingMatrixP12Il2CppObjectRK10Matrix4x4f,__Z40Camera_Set_Custom_PropLayerCullDistancesP12Il2CppObjectP11Il2CppArray,__Z40Camera_Set_Custom_PropLayerCullSphericalP12Il2CppObjecth,__Z22Camera_CUSTOM_CopyFromP12Il2CppObjectS0_,__Z38Camera_Set_Custom_PropDepthTextureModeP12Il2CppObjecti,__Z51Camera_Set_Custom_PropClearStencilAfterLightingPassP12Il2CppObjecth,__Z34Camera_CUSTOM_RemoveCommandBuffersP12Il2CppObject21RenderCameraEventType,__Z36ComputeBuffer_CUSTOM_SetCounterValueP12Il2CppObjectj,__Z53ComputeBuffer_CUSTOM_INTERNAL_CALL_GetNativeBufferPtrP12Il2CppObjectRPv,__Z35CullingGroup_Set_Custom_PropEnabledP12Il2CppObjecth,__Z40CullingGroup_Set_Custom_PropTargetCameraP12Il2CppObjectS0_,__Z38CullingGroup_CUSTOM_SetBoundingSpheresP12Il2CppObjectP11Il2CppArray,__Z42CullingGroup_CUSTOM_SetBoundingSphereCountP12Il2CppObjecti
,__Z33CullingGroup_CUSTOM_EraseSwapBackP12Il2CppObjecti,__Z40CullingGroup_CUSTOM_SetBoundingDistancesP12Il2CppObjectP11Il2CppArray,__Z59CullingGroup_CUSTOM_INTERNAL_CALL_SetDistanceReferencePointP12Il2CppObjectRK8Vector3f,__Z45CullingGroup_CUSTOM_SetDistanceReferencePointP12Il2CppObjectS0_,__Z44DebugLogHandler_CUSTOM_Internal_LogExceptionP15Il2CppExceptionP12Il2CppObject,__Z54DirectorPlayer_CUSTOM_INTERNAL_CALL_PlayStructInternalP12Il2CppObjectRK9HPlayable,__Z39DirectorPlayer_CUSTOM_SetTimeUpdateModeP12Il2CppObject18DirectorUpdateMode,__Z42DynamicGI_CUSTOM_INTERNAL_CALL_SetEmissiveP12Il2CppObjectRK10ColorRGBAf,__Z56DynamicGI_CUSTOM_INTERNAL_CALL_UpdateMaterialsForTerrainP12Il2CppObjectRK5RectTIfE,__Z30RectOffset_Set_Custom_PropLeftP12Il2CppObjecti,__Z31RectOffset_Set_Custom_PropRightP12Il2CppObjecti,__Z29RectOffset_Set_Custom_PropTopP12Il2CppObjecti,__Z32RectOffset_Set_Custom_PropBottomP12Il2CppObjecti,__Z36GUITexture_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z36GUITexture_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf,__Z33GUITexture_Set_Custom_PropTextureP12Il2CppObjectS0_,__Z41GUITexture_CUSTOM_INTERNAL_get_pixelInsetP12Il2CppObjectP5RectTIfE,__Z41GUITexture_CUSTOM_INTERNAL_set_pixelInsetP12Il2CppObjectRK5RectTIfE,__Z32GUITexture_Set_Custom_PropBorderP12Il2CppObjectS0_,__Z31GameObject_Set_Custom_PropLayerP12Il2CppObjecti,__Z32GameObject_Set_Custom_PropActiveP12Il2CppObjecth,__Z27GameObject_CUSTOM_SetActiveP12Il2CppObjecth,__Z38GameObject_CUSTOM_SetActiveRecursivelyP12Il2CppObjecth,__Z34GameObject_Set_Custom_PropIsStaticP12Il2CppObjecth,__Z29GameObject_Set_Custom_PropTagP12Il2CppObjectP12Il2CppString,__Z43GameObject_CUSTOM_Internal_CreateGameObjectP12Il2CppObjectP12Il2CppString,__Z36GameObject_CUSTOM_INTERNAL_get_sceneP12Il2CppObjectPi,__Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_,__Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireCubeRK8Vector3fS1_,__Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawCubeRK8Vector3fS1_
,__Z33Gradient_Set_Custom_PropColorKeysP12Il2CppObjectP11Il2CppArray,__Z33Gradient_Set_Custom_PropAlphaKeysP12Il2CppObjectP11Il2CppArray,__Z28Gradient_Set_Custom_PropModeP12Il2CppObject12GradientMode,__ZL17LightmapDataToCppR16LightmapDataMonoR12LightmapData,__Z40OcclusionArea_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z40OcclusionArea_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z38OcclusionArea_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f,__Z38OcclusionArea_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f,__Z35OcclusionPortal_Set_Custom_PropOpenP12Il2CppObjecth,__Z38QualitySettings_CUSTOM_SetQualityLevelih,__Z30MeshFilter_Set_Custom_PropMeshP12Il2CppObjectS0_,__Z36MeshFilter_Set_Custom_PropSharedMeshP12Il2CppObjectS0_,__Z40SkinnedMeshRenderer_Set_Custom_PropBonesP12Il2CppObjectP11Il2CppArray,__Z43SkinnedMeshRenderer_Set_Custom_PropRootBoneP12Il2CppObjectS0_,__Z42SkinnedMeshRenderer_Set_Custom_PropQualityP12Il2CppObjecti,__Z45SkinnedMeshRenderer_Set_Custom_PropSharedMeshP12Il2CppObjectS0_,__Z54SkinnedMeshRenderer_Set_Custom_PropUpdateWhenOffscreenP12Il2CppObjecth,__Z55SkinnedMeshRenderer_Set_Custom_PropSkinnedMotionVectorsP12Il2CppObjecth,__Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB,__Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB,__Z35SkinnedMeshRenderer_CUSTOM_BakeMeshP12Il2CppObjectS0_,__Z30LensFlare_Set_Custom_PropFlareP12Il2CppObjectS0_,__Z35LensFlare_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z35LensFlare_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf,__Z48Renderer_Set_Custom_PropStaticBatchRootTransformP12Il2CppObjectS0_,__Z47Renderer_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f,__Z47Renderer_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f,__Z31Renderer_Set_Custom_PropEnabledP12Il2CppObjecth,__Z41Renderer_Set_Custom_PropShadowCastingModeP12Il2CppObject17ShadowCastingMode,__Z35Renderer_Set_Custom_PropCastShadowsP12Il2CppObjecth
,__Z38Renderer_Set_Custom_PropReceiveShadowsP12Il2CppObjecth,__Z32Renderer_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z38Renderer_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_,__Z33Renderer_Set_Custom_PropMaterialsP12Il2CppObjectP11Il2CppArray,__Z39Renderer_Set_Custom_PropSharedMaterialsP12Il2CppObjectP11Il2CppArray,__Z35Renderer_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z37Renderer_Set_Custom_PropLightmapIndexP12Il2CppObjecti,__Z45Renderer_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti,__Z48Renderer_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f,__Z48Renderer_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f,__Z50Renderer_Set_Custom_PropMotionVectorGenerationModeP12Il2CppObject26MotionVectorGenerationMode,__Z56Renderer_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f,__Z56Renderer_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f,__Z38Renderer_Set_Custom_PropUseLightProbesP12Il2CppObjecth,__Z39Renderer_Set_Custom_PropLightProbeUsageP12Il2CppObject15LightProbeUsage,__Z53Renderer_Set_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObjectS0_,__Z35Renderer_Set_Custom_PropProbeAnchorP12Il2CppObjectS0_,__Z44Renderer_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti,__Z32Renderer_CUSTOM_SetPropertyBlockP12Il2CppObjectS0_,__Z32Renderer_CUSTOM_GetPropertyBlockP12Il2CppObjectS0_,__Z40Renderer_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString,__Z38Renderer_Set_Custom_PropSortingLayerIDP12Il2CppObjecti,__Z36Renderer_Set_Custom_PropSortingOrderP12Il2CppObjecti,__Z50Renderer_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_,__Z37Projector_Set_Custom_PropOrthographicP12Il2CppObjecth,__Z37Projector_Set_Custom_PropIgnoreLayersP12Il2CppObjecti,__Z33Projector_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z30Skybox_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z39TrailRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_,__Z44TrailRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf
,__Z44TrailRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf,__Z42TrailRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf,__Z42TrailRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf,__Z42TrailRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_,__Z41TrailRenderer_Set_Custom_PropAutodestructP12Il2CppObjecth,__Z46TrailRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti,__Z43TrailRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti,__Z40TrailRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode,__Z38LineRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_,__Z43LineRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf,__Z43LineRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf,__Z41LineRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf,__Z41LineRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf,__Z41LineRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_,__Z40LineRenderer_Set_Custom_PropNumPositionsP12Il2CppObjecti,__Z32LineRenderer_CUSTOM_SetPositionsP12Il2CppObjectP11Il2CppArray,__Z41LineRenderer_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth,__Z45LineRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti,__Z42LineRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti,__Z39LineRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode,__Z39RenderBufferHelper_CUSTOM_SetLoadActionP21ScriptingRenderBufferi,__Z40RenderBufferHelper_CUSTOM_SetStoreActionP21ScriptingRenderBufferi,__Z64RenderBufferHelper_CUSTOM_INTERNAL_CALL_GetNativeRenderBufferPtr13Il2Cpp_IntPtrRPv,__Z20Graphics_CUSTOM_BlitP12Il2CppObjectS0_,__Z32Graphics_CUSTOM_CopyTexture_FullP12Il2CppObjectS0_,__Z47Graphics_CUSTOM_Internal_SetRandomWriteTargetRTiP12Il2CppObject,__Z38LightProbes_Set_Custom_PropBakedProbesP12Il2CppObjectP11Il2CppArray,__Z59GeometryUtility_CUSTOM_INTERNAL_CALL_Internal_ExtractPlanesP11Il2CppArrayRK10Matrix4x4f,__Z37GL_CUSTOM_INTERNAL_CALL_MultiTexCoordiRK8Vector3f,__Z25GL_CUSTOM_ClearWithSkyboxhP12Il2CppObject
,__Z34GL_CUSTOM_IssuePluginEventInternal13Il2Cpp_IntPtri,__Z51MeshRenderer_Set_Custom_PropAdditionalVertexStreamsP12Il2CppObjectS0_,__Z51StaticBatchingUtility_CUSTOM_InternalCombineIndicesP11Il2CppArrayP12Il2CppObject,__Z52Gyroscope_CUSTOM_INTERNAL_CALL_rotationRate_InternaliR8Vector3f,__Z60Gyroscope_CUSTOM_INTERNAL_CALL_rotationRateUnbiased_InternaliR8Vector3f,__Z47Gyroscope_CUSTOM_INTERNAL_CALL_gravity_InternaliR8Vector3f,__Z56Gyroscope_CUSTOM_INTERNAL_CALL_userAcceleration_InternaliR8Vector3f,__Z48Gyroscope_CUSTOM_INTERNAL_CALL_attitude_InternaliR11Quaternionf,__Z36Gyroscope_CUSTOM_setEnabled_Internalih,__Z39LocationService_Get_Custom_PropLastDataP12Il2CppObject,__Z37Compass_CUSTOM_INTERNAL_get_rawVectorP12Il2CppObjectP8Vector3f,__Z30Compass_Set_Custom_PropEnabledP12Il2CppObjecth,__Z47Input_CUSTOM_INTERNAL_CALL_GetAccelerationEventiR12Acceleration,__Z35Input_CUSTOM_INTERNAL_CALL_GetTouchiR5Touch,__Z48LODGroup_CUSTOM_INTERNAL_get_localReferencePointP12Il2CppObjectP8Vector3f,__Z48LODGroup_CUSTOM_INTERNAL_set_localReferencePointP12Il2CppObjectRK8Vector3f,__Z32LODGroup_Set_Custom_PropFadeModeP12Il2CppObjectN8LODGroup11LODFadeModeE,__Z42LODGroup_Set_Custom_PropAnimateCrossFadingP12Il2CppObjecth,__Z31LODGroup_Set_Custom_PropEnabledP12Il2CppObjecth,__Z23LODGroup_CUSTOM_SetLODsP12Il2CppObjectP11Il2CppArray,__Z24LODGroup_CUSTOM_ForceLODP12Il2CppObjecti,__Z25Light_Set_Custom_PropTypeP12Il2CppObject9LightType,__Z31Light_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z31Light_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf,__Z28Light_Set_Custom_PropShadowsP12Il2CppObjecti,__Z37Light_Set_Custom_PropShadowResolutionP12Il2CppObjecti,__Z43Light_Set_Custom_PropShadowCustomResolutionP12Il2CppObjecti,__Z27Light_Set_Custom_PropCookieP12Il2CppObjectS0_,__Z26Light_Set_Custom_PropFlareP12Il2CppObjectS0_,__Z31Light_Set_Custom_PropRenderModeP12Il2CppObjecti
,__Z39Light_Set_Custom_PropAlreadyLightmappedP12Il2CppObjecth,__Z31Light_Set_Custom_PropBakedIndexP12Il2CppObjecti,__Z32Light_Set_Custom_PropCullingMaskP12Il2CppObjecti,__Z33Light_CUSTOM_RemoveCommandBuffersP12Il2CppObject20RenderLightEventType,__Z45LightProbeGroup_Set_Custom_PropProbePositionsP12Il2CppObjectP11Il2CppArray,__Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_boundsGlobalP12Il2CppObjectP4AABB,__Z52LightProbeProxyVolume_CUSTOM_INTERNAL_get_sizeCustomP12Il2CppObjectP8Vector3f,__Z52LightProbeProxyVolume_CUSTOM_INTERNAL_set_sizeCustomP12Il2CppObjectRK8Vector3f,__Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_originCustomP12Il2CppObjectP8Vector3f,__Z54LightProbeProxyVolume_CUSTOM_INTERNAL_set_originCustomP12Il2CppObjectRK8Vector3f,__Z52LightProbeProxyVolume_Set_Custom_PropBoundingBoxModeP12Il2CppObjecti,__Z51LightProbeProxyVolume_Set_Custom_PropResolutionModeP12Il2CppObjecti,__Z54LightProbeProxyVolume_Set_Custom_PropProbePositionModeP12Il2CppObjecti,__Z48LightProbeProxyVolume_Set_Custom_PropRefreshModeP12Il2CppObjecti,__Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionXP12Il2CppObjecti,__Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionYP12Il2CppObjecti,__Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionZP12Il2CppObjecti,__Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize2R8Vector3fS0_,__Z39Quaternion_CUSTOM_INTERNAL_CALL_InverseRK11QuaternionfRS_,__Z51Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToEulerRadRK11QuaternionfR8Vector3f,__Z53Quaternion_CUSTOM_INTERNAL_CALL_Internal_FromEulerRadRK8Vector3fR11Quaternionf,__Z38Matrix4x4_CUSTOM_INTERNAL_CALL_InverseRK10Matrix4x4fRS_,__Z40Matrix4x4_CUSTOM_INTERNAL_CALL_TransposeRK10Matrix4x4fRS_,__Z31AnimationCurve_CUSTOM_RemoveKeyP12Il2CppObjecti,__Z29AnimationCurve_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArray,__Z41AnimationCurve_Set_Custom_PropPreWrapModeP12Il2CppObjecti,__Z42AnimationCurve_Set_Custom_PropPostWrapModeP12Il2CppObjecti,__Z26AnimationCurve_CUSTOM_InitP12Il2CppObjectP11Il2CppArray,__Z17Mesh_CUSTOM_ClearP12Il2CppObjecth,__Z36Mesh_CUSTOM_PrintErrorCantAccessMeshP12Il2CppObject30InternalScriptingShaderChannel
,__Z22Mesh_CUSTOM_ResizeListP12Il2CppObjecti,__Z49Mesh_CUSTOM_INTERNAL_CALL_GetNativeIndexBufferPtrP12Il2CppObjectRPv,__Z31Mesh_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z31Mesh_CUSTOM_INTERNAL_set_boundsP12Il2CppObjectRK4AABB,__Z32Mesh_Set_Custom_PropSubMeshCountP12Il2CppObjecti,__Z31Mesh_Set_Custom_PropBoneWeightsP12Il2CppObjectP11Il2CppArray,__Z29Mesh_Set_Custom_PropBindposesP12Il2CppObjectP11Il2CppArray,__Z26Mesh_CUSTOM_UploadMeshDataP12Il2CppObjecth,__Z33MonoBehaviour_CUSTOM_CancelInvokeP12Il2CppObjectP12Il2CppString,__Z34MonoBehaviour_CUSTOM_StopCoroutineP12Il2CppObjectP12Il2CppString,__Z52MonoBehaviour_CUSTOM_StopCoroutineViaEnumerator_AutoP12Il2CppObjectS0_,__Z39MonoBehaviour_CUSTOM_StopCoroutine_AutoP12Il2CppObjectS0_,__Z41MonoBehaviour_Set_Custom_PropUseGUILayoutP12Il2CppObjecth,__Z39Motion_CUSTOM_INTERNAL_get_averageSpeedP12Il2CppObjectP8Vector3f,__Z50Playable_CUSTOM_INTERNAL_CALL_SetPlayStateInternalR9HPlayable9PlayState,__Z49Playables_CUSTOM_INTERNAL_CALL_DisconnectInternalR9HPlayablei,__Z60Playables_CUSTOM_INTERNAL_CALL_SetPlayableDeleteOnDisconnectR9HPlayableh,__Z32PlayerConnection_CUSTOM_SendFileP12Il2CppStringP11Il2CppArray,__Z27Profiler_CUSTOM_BeginSampleP12Il2CppStringP12Il2CppObject,__Z30Sampler_Set_Custom_PropEnabledP12Il2CppObjecth,__Z38RectTransform_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE,__Z43RectTransform_CUSTOM_INTERNAL_get_anchorMinP12Il2CppObjectP13Vector2fIcall,__Z43RectTransform_CUSTOM_INTERNAL_set_anchorMinP12Il2CppObjectRK13Vector2fIcall,__Z43RectTransform_CUSTOM_INTERNAL_get_anchorMaxP12Il2CppObjectP13Vector2fIcall,__Z43RectTransform_CUSTOM_INTERNAL_set_anchorMaxP12Il2CppObjectRK13Vector2fIcall,__Z50RectTransform_CUSTOM_INTERNAL_get_anchoredPositionP12Il2CppObjectP13Vector2fIcall,__Z50RectTransform_CUSTOM_INTERNAL_set_anchoredPositionP12Il2CppObjectRK13Vector2fIcall,__Z43RectTransform_CUSTOM_INTERNAL_get_sizeDeltaP12Il2CppObjectP13Vector2fIcall,__Z43RectTransform_CUSTOM_INTERNAL_set_sizeDeltaP12Il2CppObjectRK13Vector2fIcall,__Z39RectTransform_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP13Vector2fIcall
,__Z39RectTransform_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK13Vector2fIcall,__Z43RectTransform_Set_Custom_PropDrivenByObjectP12Il2CppObjectS0_,__Z45RectTransform_Set_Custom_PropDrivenPropertiesP12Il2CppObjectN2UI13RectTransform16DrivenPropertiesE,__Z35ReflectionProbe_Set_Custom_PropTypeP12Il2CppObjecti,__Z34ReflectionProbe_Set_Custom_PropHdrP12Il2CppObjecth,__Z40ReflectionProbe_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f,__Z40ReflectionProbe_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f,__Z42ReflectionProbe_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z42ReflectionProbe_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z41ReflectionProbe_Set_Custom_PropResolutionP12Il2CppObjecti,__Z42ReflectionProbe_Set_Custom_PropCullingMaskP12Il2CppObjecti,__Z41ReflectionProbe_Set_Custom_PropClearFlagsP12Il2CppObjecti,__Z51ReflectionProbe_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf,__Z51ReflectionProbe_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf,__Z44ReflectionProbe_Set_Custom_PropBoxProjectionP12Il2CppObjecth,__Z42ReflectionProbe_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z35ReflectionProbe_Set_Custom_PropModeP12Il2CppObjecti,__Z41ReflectionProbe_Set_Custom_PropImportanceP12Il2CppObjecti,__Z42ReflectionProbe_Set_Custom_PropRefreshModeP12Il2CppObjecti,__Z46ReflectionProbe_Set_Custom_PropTimeSlicingModeP12Il2CppObjecti,__Z43ReflectionProbe_Set_Custom_PropBakedTextureP12Il2CppObjectS0_,__Z49ReflectionProbe_Set_Custom_PropCustomBakedTextureP12Il2CppObjectS0_,__Z37GraphicsSettings_CUSTOM_SetShaderModeN16GraphicsSettings17BuiltinShaderTypeEN21BuiltinShaderSettings17BuiltinShaderModeE,__Z39GraphicsSettings_CUSTOM_SetCustomShaderN16GraphicsSettings17BuiltinShaderTypeEP12Il2CppObject,__Z33CommandBuffer_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString,__Z39CommandBuffer_CUSTOM_ReleaseTemporaryRTP12Il2CppObjecti,__Z31RuntimeUndo_CUSTOM_RecordObjectP12Il2CppObjectP12Il2CppString,__Z32RuntimeUndo_CUSTOM_RecordObjectsP11Il2CppArrayP12Il2CppString,__Z28Scene_CUSTOM_SetNameInternaliP12Il2CppString,__Z39Scene_CUSTOM_GetRootGameObjectsInternaliP12Il2CppObject
,__Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByPathP12Il2CppStringRi,__Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByNameP12Il2CppStringRi,__Z54SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByBuildIndexiRi,__Z44SceneManager_CUSTOM_INTERNAL_CALL_GetSceneAtiRi,__Z45SceneManager_CUSTOM_INTERNAL_CALL_CreateSceneP12Il2CppStringRi,__Z45SceneManager_CUSTOM_INTERNAL_CALL_MergeScenesRKiS0_,__Z55SceneManager_CUSTOM_INTERNAL_CALL_MoveGameObjectToSceneP12Il2CppObjectRKi,__Z32Shader_Set_Custom_PropMaximumLODP12Il2CppObjecti,__Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalVectoriRK8Vector4f,__Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalMatrixiRK10Matrix4x4f,__Z30Shader_CUSTOM_SetGlobalTextureiP12Il2CppObject,__Z41Shader_CUSTOM_SetGlobalFloatArrayImplListiP12Il2CppObject,__Z37Shader_CUSTOM_SetGlobalFloatArrayImpliP11Il2CppArray,__Z42Shader_CUSTOM_SetGlobalVectorArrayImplListiP12Il2CppObject,__Z38Shader_CUSTOM_SetGlobalVectorArrayImpliP11Il2CppArray,__Z42Shader_CUSTOM_SetGlobalMatrixArrayImplListiP12Il2CppObject,__Z38Shader_CUSTOM_SetGlobalMatrixArrayImpliP11Il2CppArray,__Z29Shader_CUSTOM_SetGlobalBufferiP12Il2CppObject,__Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalVectoriR8Vector4f,__Z42Shader_CUSTOM_INTERNAL_CALL_GetGlobalColoriR10ColorRGBAf,__Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalMatrixiR10Matrix4x4f,__Z41Shader_CUSTOM_GetGlobalFloatArrayImplListiP12Il2CppObject,__Z42Shader_CUSTOM_GetGlobalVectorArrayImplListiP12Il2CppObject,__Z42Shader_CUSTOM_GetGlobalMatrixArrayImplListiP12Il2CppObject,__Z30Material_Set_Custom_PropShaderP12Il2CppObjectS0_,__Z35Material_Set_Custom_PropRenderQueueP12Il2CppObjecti,__Z41Material_CUSTOM_Internal_CreateWithStringP12Il2CppObjectP12Il2CppString,__Z41Material_CUSTOM_Internal_CreateWithShaderP12Il2CppObjectS0_,__Z43Material_CUSTOM_Internal_CreateWithMaterialP12Il2CppObjectS0_,__Z42Material_CUSTOM_CopyPropertiesFromMaterialP12Il2CppObjectS0_
,__Z29Material_CUSTOM_EnableKeywordP12Il2CppObjectP12Il2CppString,__Z30Material_CUSTOM_DisableKeywordP12Il2CppObjectP12Il2CppString,__Z38Material_Set_Custom_PropShaderKeywordsP12Il2CppObjectP11Il2CppArray,__Z47Material_Set_Custom_PropGlobalIlluminationFlagsP12Il2CppObject31MaterialGlobalIlluminationFlags,__Z65SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddAmbientLightInternalRK10ColorRGBAfR20SphericalHarmonicsL2,__Z33Sprite_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z31Sprite_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE,__Z38Sprite_CUSTOM_INTERNAL_get_textureRectP12Il2CppObjectP5RectTIfE,__Z43Sprite_CUSTOM_Internal_GetTextureRectOffsetP12Il2CppObjectP13Vector2fIcall,__Z31Sprite_CUSTOM_Internal_GetPivotP12Il2CppObjectP13Vector2fIcall,__Z33Sprite_CUSTOM_INTERNAL_get_borderP12Il2CppObjectP8Vector4f,__Z40SpriteRenderer_CUSTOM_SetSprite_INTERNALP12Il2CppObjectS0_,__Z40SpriteRenderer_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z40SpriteRenderer_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf,__Z35SpriteRenderer_Set_Custom_PropFlipXP12Il2CppObjecth,__Z35SpriteRenderer_Set_Custom_PropFlipYP12Il2CppObjecth,__Z51SpriteRenderer_CUSTOM_INTERNAL_CALL_GetSpriteBoundsP12Il2CppObjectR4AABB,__Z43DataUtility_CUSTOM_INTERNAL_CALL_GetInnerUVP12Il2CppObjectR8Vector4f,__Z43DataUtility_CUSTOM_INTERNAL_CALL_GetOuterUVP12Il2CppObjectR8Vector4f,__Z43DataUtility_CUSTOM_INTERNAL_CALL_GetPaddingP12Il2CppObjectR8Vector4f,__Z38DataUtility_CUSTOM_Internal_GetMinSizeP12Il2CppObjectP13Vector2fIcall,__Z50Texture_CUSTOM_SetGlobalAnisotropicFilteringLimitsii,__Z33Texture_Set_Custom_PropFilterModeP12Il2CppObjecti,__Z33Texture_Set_Custom_PropAnisoLevelP12Il2CppObjecti,__Z31Texture_Set_Custom_PropWrapModeP12Il2CppObjecti,__Z37Texture_CUSTOM_INTERNAL_get_texelSizeP12Il2CppObjectP13Vector2fIcall,__Z48Texture_CUSTOM_INTERNAL_CALL_GetNativeTexturePtrP12Il2CppObjectRPv,__Z38Texture2D_CUSTOM_UpdateExternalTextureP12Il2CppObject13Il2Cpp_IntPtr,__Z45Texture2D_CUSTOM_LoadRawTextureData_ImplArrayP12Il2CppObjectP11Il2CppArray,__Z39Texture2D_CUSTOM_INTERNAL_CALL_CompressP12Il2CppObjecth
,__Z26Cubemap_CUSTOM_SmoothEdgesP12Il2CppObjecti,__Z38RenderTexture_CUSTOM_Internal_SetWidthP12Il2CppObjecti,__Z39RenderTexture_CUSTOM_Internal_SetHeightP12Il2CppObjecti,__Z46RenderTexture_CUSTOM_Internal_SetSRGBReadWriteP12Il2CppObjecth,__Z34RenderTexture_Set_Custom_PropDepthP12Il2CppObjecti,__Z41RenderTexture_Set_Custom_PropIsPowerOfTwoP12Il2CppObjecth,__Z35RenderTexture_Set_Custom_PropFormatP12Il2CppObject19RenderTextureFormat,__Z38RenderTexture_Set_Custom_PropUseMipMapP12Il2CppObjecth,__Z45RenderTexture_Set_Custom_PropAutoGenerateMipsP12Il2CppObjecth,__Z42RenderTexture_CUSTOM_Internal_SetDimensionP12Il2CppObject16TextureDimension,__Z38RenderTexture_Set_Custom_PropIsCubemapP12Il2CppObjecth,__Z37RenderTexture_Set_Custom_PropIsVolumeP12Il2CppObjecth,__Z40RenderTexture_Set_Custom_PropVolumeDepthP12Il2CppObjecti,__Z41RenderTexture_Set_Custom_PropAntiAliasingP12Il2CppObjecti,__Z46RenderTexture_Set_Custom_PropEnableRandomWriteP12Il2CppObjecth,__Z35RenderTexture_CUSTOM_GetColorBufferP12Il2CppObjectP21ScriptingRenderBuffer,__Z35RenderTexture_CUSTOM_GetDepthBufferP12Il2CppObjectP21ScriptingRenderBuffer,__Z58RenderTexture_CUSTOM_INTERNAL_CALL_GetNativeDepthBufferPtrP12Il2CppObjectRPv,__Z44RenderTexture_CUSTOM_SetGlobalShaderPropertyP12Il2CppObjectP12Il2CppString,__Z38Transform_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f,__Z38Transform_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f,__Z43Transform_CUSTOM_INTERNAL_get_localPositionP12Il2CppObjectP8Vector3f,__Z43Transform_CUSTOM_INTERNAL_set_localPositionP12Il2CppObjectRK8Vector3f,__Z38Transform_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf,__Z38Transform_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf,__Z43Transform_CUSTOM_INTERNAL_get_localRotationP12Il2CppObjectP11Quaternionf,__Z43Transform_CUSTOM_INTERNAL_set_localRotationP12Il2CppObjectRK11Quaternionf,__Z40Transform_CUSTOM_INTERNAL_get_localScaleP12Il2CppObjectP8Vector3f,__Z40Transform_CUSTOM_INTERNAL_set_localScaleP12Il2CppObjectRK8Vector3f,__Z39Transform_Set_Custom_PropParentInternalP12Il2CppObjectS0_
,__Z48Transform_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f,__Z48Transform_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f,__Z32Transform_CUSTOM_SetSiblingIndexP12Il2CppObjecti,__Z40Transform_CUSTOM_INTERNAL_get_lossyScaleP12Il2CppObjectP8Vector3f,__Z35Transform_Set_Custom_PropHasChangedP12Il2CppObjecth,__Z42Transform_Set_Custom_PropHierarchyCapacityP12Il2CppObjecti,__Z30Object_CUSTOM_DestroyImmediateP12Il2CppObjecth,__Z26Object_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString,__Z31Object_Set_Custom_PropHideFlagsP12Il2CppObjecti,__Z34Hash128_CUSTOM_INTERNAL_CALL_ParseP12Il2CppStringR7Hash128,__Z21WWW_CUSTOM_DestroyWWWP12Il2CppObjecth,__Z31WWW_CUSTOM_LoadImageIntoTextureP12Il2CppObjectS0_,__Z28WindZone_Set_Custom_PropModeP12Il2CppObjectN8WindZone12WindZoneModeE,__ZN15DirectorManager15AdvanceTimeFuncEP14AdvanceTimeJobj,__ZN15DirectorManager20FixedAdvanceTimeFuncEP14AdvanceTimeJobj,__ZN15DirectorManager16PrepareFrameFuncEP11DirectorJobj,__ZL20InternalErrorConsolePKcz,__ZL21InternalAssertConsolePKcz,__ZL18InternalLogConsolePKcz,__ZL22InternalWarningConsolePKcz,__Z53AndroidJNIHelper_CUSTOM_INTERNAL_CALL_CreateJavaProxyP12Il2CppObjectRPv,__Z41AndroidJNI_CUSTOM_INTERNAL_CALL_FindClassP12Il2CppStringRPv,__Z51AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedMethod13Il2Cpp_IntPtrRPv,__Z50AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedField13Il2Cpp_IntPtrRPv,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_GetSuperclass13Il2Cpp_IntPtrRPv,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_PopLocalFrame13Il2Cpp_IntPtrRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewGlobalRef13Il2Cpp_IntPtrRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewLocalRef13Il2Cpp_IntPtrRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_AllocObject13Il2Cpp_IntPtrRPv,__Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectClass13Il2Cpp_IntPtrRPv
,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewStringUTFP12Il2CppStringRPv,__Z46AndroidJNI_CUSTOM_INTERNAL_CALL_ToBooleanArrayP11Il2CppArrayRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToByteArrayP11Il2CppArrayRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToCharArrayP11Il2CppArrayRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToShortArrayP11Il2CppArrayRPv,__Z42AndroidJNI_CUSTOM_INTERNAL_CALL_ToIntArrayP11Il2CppArrayRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToLongArrayP11Il2CppArrayRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToFloatArrayP11Il2CppArrayRPv,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToDoubleArrayP11Il2CppArrayRPv,__Z47AndroidJNI_CUSTOM_INTERNAL_CALL_NewBooleanArrayiRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewByteArrayiRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewCharArrayiRPv,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewShortArrayiRPv,__Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewIntArrayiRPv,__Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewLongArrayiRPv,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewFloatArrayiRPv,__Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewDoubleArrayiRPv,_glAttachShader__wrapper,_glBindBuffer__wrapper,_glBindFramebuffer__wrapper,_glBindRenderbuffer__wrapper,_glBindTexture__wrapper,_glBlendEquationSeparate__wrapper,_glDeleteBuffers__wrapper,_glDeleteFramebuffers__wrapper,_glDeleteRenderbuffers__wrapper,_glDeleteTextures__wrapper,_glGenBuffers__wrapper,_glGenFramebuffers__wrapper,_glGenRenderbuffers__wrapper,_glGenTextures__wrapper,_glGetIntegerv__wrapper,_glPixelStorei__wrapper,_glUniform1i__wrapper,_glGenQueries__wrapper,_glDeleteQueries__wrapper,_glBeginQuery__wrapper,_glDeleteVertexArrays__wrapper,_glGenVertexArrays__wrapper,_glBindTransformFeedback__wrapper,_glDeleteTransformFeedbacks__wrapper,_glGenTransformFeedbacks__wrapper,_glDrawBuffers__wrapper,_glGenSamplers__wrapper,_glDeleteSamplers__wrapper,_glBindSampler__wrapper,__ZN12_GLOBAL__N_137BuggyBindElementArrayBufferWorkaround17BindBufferWrapperEjj,__ZN25ParticleSystemGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj,__ZN30ParticleSystemTrailGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj,__Z43ParticleSystem_MainModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z40ParticleSystem_MainModule_CUSTOM_SetLoopP12Il2CppObjecth,__Z43ParticleSystem_MainModule_CUSTOM_SetPrewarmP12Il2CppObjecth,__Z46ParticleSystem_MainModule_CUSTOM_SetStartDelayP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_GetStartDelayP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_MainModule_CUSTOM_SetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_MainModule_CUSTOM_GetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_SetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_GetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_MainModule_CUSTOM_SetStartSize3DP12Il2CppObjecth,__Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve
,__Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve,__Z51ParticleSystem_MainModule_CUSTOM_SetStartRotation3DP12Il2CppObjecth,__Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_MainModule_CUSTOM_SetStartColorP12Il2CppObjectR18MonoMinMaxGradient,__Z46ParticleSystem_MainModule_CUSTOM_GetStartColorP12Il2CppObjectR18MonoMinMaxGradient,__Z51ParticleSystem_MainModule_CUSTOM_SetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve,__Z51ParticleSystem_MainModule_CUSTOM_GetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve,__Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace,__Z57ParticleSystem_MainModule_CUSTOM_SetCustomSimulationSpaceP12Il2CppObjectS0_,__Z47ParticleSystem_MainModule_CUSTOM_SetScalingModeP12Il2CppObject25ParticleSystemScalingMode,__Z47ParticleSystem_MainModule_CUSTOM_SetPlayOnAwakeP12Il2CppObjecth,__Z48ParticleSystem_MainModule_CUSTOM_SetMaxParticlesP12Il2CppObjecti,__Z47ParticleSystem_EmissionModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z52ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve,__Z52ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve,__Z56ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve,__Z56ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_ShapeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z46ParticleSystem_ShapeModule_CUSTOM_SetShapeTypeP12Il2CppObjecti,__Z53ParticleSystem_ShapeModule_CUSTOM_SetAlignToDirectionP12Il2CppObjecth,__Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_SetBoxP12Il2CppObjectRK8Vector3f
,__Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_GetBoxP12Il2CppObjectR8Vector3f,__Z50ParticleSystem_ShapeModule_CUSTOM_SetMeshShapeTypeP12Il2CppObjecti,__Z41ParticleSystem_ShapeModule_CUSTOM_SetMeshP12Il2CppObjectS0_,__Z49ParticleSystem_ShapeModule_CUSTOM_SetMeshRendererP12Il2CppObjectS0_,__Z56ParticleSystem_ShapeModule_CUSTOM_SetSkinnedMeshRendererP12Il2CppObjectS0_,__Z57ParticleSystem_ShapeModule_CUSTOM_SetUseMeshMaterialIndexP12Il2CppObjecth,__Z54ParticleSystem_ShapeModule_CUSTOM_SetMeshMaterialIndexP12Il2CppObjecti,__Z50ParticleSystem_ShapeModule_CUSTOM_SetUseMeshColorsP12Il2CppObjecth,__Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth,__Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve,__Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve,__Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth,__Z54ParticleSystem_InheritVelocityModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z51ParticleSystem_InheritVelocityModule_CUSTOM_SetModeP12Il2CppObjecti,__Z52ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveP12Il2CppObjectR15MonoMinMaxCurve
,__Z52ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveP12Il2CppObjectR15MonoMinMaxCurve,__Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth,__Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetRandomizedP12Il2CppObjecth,__Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient,__Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient,__Z51ParticleSystem_ColorBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z49ParticleSystem_ColorBySpeedModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient,__Z49ParticleSystem_ColorBySpeedModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient,__Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall,__Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall,__Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z50ParticleSystem_SizeBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve
,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z55ParticleSystem_SizeBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall,__Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall,__Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z54ParticleSystem_RotationBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve,__Z59ParticleSystem_RotationBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall,__Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall,__Z53ParticleSystem_ExternalForcesModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z44ParticleSystem_NoiseModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z49ParticleSystem_NoiseModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth,__Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthXP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthXP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthYP12Il2CppObjectR15MonoMinMaxCurve
,__Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthYP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthZP12Il2CppObjectR15MonoMinMaxCurve,__Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthZP12Il2CppObjectR15MonoMinMaxCurve,__Z44ParticleSystem_NoiseModule_CUSTOM_SetDampingP12Il2CppObjecth,__Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveCountP12Il2CppObjecti,__Z44ParticleSystem_NoiseModule_CUSTOM_SetQualityP12Il2CppObjecti,__Z48ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve,__Z49ParticleSystem_NoiseModule_CUSTOM_SetRemapEnabledP12Il2CppObjecth,__Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapXP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapXP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapYP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapYP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapZP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapZP12Il2CppObjectR15MonoMinMaxCurve,__Z48ParticleSystem_CollisionModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z45ParticleSystem_CollisionModule_CUSTOM_SetTypeP12Il2CppObjecti,__Z45ParticleSystem_CollisionModule_CUSTOM_SetModeP12Il2CppObjecti,__Z47ParticleSystem_CollisionModule_CUSTOM_SetDampenP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_CollisionModule_CUSTOM_GetDampenP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_CollisionModule_CUSTOM_SetBounceP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_CollisionModule_CUSTOM_GetBounceP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve,__Z53ParticleSystem_CollisionModule_CUSTOM_SetCollidesWithP12Il2CppObjecti,__Z63ParticleSystem_CollisionModule_CUSTOM_SetEnableDynamicCollidersP12Il2CppObjecth,__Z65ParticleSystem_CollisionModule_CUSTOM_SetEnableInteriorCollisionsP12Il2CppObjecth,__Z59ParticleSystem_CollisionModule_CUSTOM_SetMaxCollisionShapesP12Il2CppObjecti,__Z48ParticleSystem_CollisionModule_CUSTOM_SetQualityP12Il2CppObjecti,__Z62ParticleSystem_CollisionModule_CUSTOM_SetUsesCollisionMessagesP12Il2CppObjecth
,__Z46ParticleSystem_TriggerModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z45ParticleSystem_TriggerModule_CUSTOM_SetInsideP12Il2CppObjecti,__Z46ParticleSystem_TriggerModule_CUSTOM_SetOutsideP12Il2CppObjecti,__Z44ParticleSystem_TriggerModule_CUSTOM_SetEnterP12Il2CppObjecti,__Z43ParticleSystem_TriggerModule_CUSTOM_SetExitP12Il2CppObjecti,__Z50ParticleSystem_SubEmittersModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z56ParticleSystem_SubEmittersModule_CUSTOM_RemoveSubEmitterP12Il2CppObjecti,__Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesXP12Il2CppObjecti,__Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesYP12Il2CppObjecti,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetAnimationTypeP12Il2CppObjecti,__Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUseRandomRowP12Il2CppObjecth,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve,__Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameP12Il2CppObjectR15MonoMinMaxCurve,__Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameP12Il2CppObjectR15MonoMinMaxCurve,__Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetCycleCountP12Il2CppObjecti,__Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetRowIndexP12Il2CppObjecti,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUVChannelMaskP12Il2CppObjecti,__Z45ParticleSystem_LightsModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z59ParticleSystem_LightsModule_CUSTOM_SetUseRandomDistributionP12Il2CppObjecth,__Z49ParticleSystem_LightsModule_CUSTOM_SetLightPrefabP12Il2CppObjectS0_,__Z54ParticleSystem_LightsModule_CUSTOM_SetUseParticleColorP12Il2CppObjecth,__Z54ParticleSystem_LightsModule_CUSTOM_SetSizeAffectsRangeP12Il2CppObjecth,__Z59ParticleSystem_LightsModule_CUSTOM_SetAlphaAffectsIntensityP12Il2CppObjecth,__Z43ParticleSystem_LightsModule_CUSTOM_SetRangeP12Il2CppObjectR15MonoMinMaxCurve,__Z43ParticleSystem_LightsModule_CUSTOM_GetRangeP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_LightsModule_CUSTOM_SetIntensityP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_LightsModule_CUSTOM_GetIntensityP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_LightsModule_CUSTOM_SetMaxLightsP12Il2CppObjecti
,__Z44ParticleSystem_TrailModule_CUSTOM_SetEnabledP12Il2CppObjecth,__Z45ParticleSystem_TrailModule_CUSTOM_SetLifetimeP12Il2CppObjectR15MonoMinMaxCurve,__Z45ParticleSystem_TrailModule_CUSTOM_GetLifetimeP12Il2CppObjectR15MonoMinMaxCurve,__Z47ParticleSystem_TrailModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth,__Z53ParticleSystem_TrailModule_CUSTOM_SetDieWithParticlesP12Il2CppObjecth,__Z53ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsWidthP12Il2CppObjecth,__Z56ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsLifetimeP12Il2CppObjecth,__Z57ParticleSystem_TrailModule_CUSTOM_SetInheritParticleColorP12Il2CppObjecth,__Z54ParticleSystem_TrailModule_CUSTOM_SetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient,__Z54ParticleSystem_TrailModule_CUSTOM_GetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient,__Z51ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve,__Z51ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve,__Z51ParticleSystem_TrailModule_CUSTOM_SetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient,__Z51ParticleSystem_TrailModule_CUSTOM_GetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient,__Z34ParticleSystem_Set_Custom_PropLoopP12Il2CppObjecth,__Z41ParticleSystem_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth,__Z45ParticleSystem_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf,__Z45ParticleSystem_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf,__Z50ParticleSystem_CUSTOM_INTERNAL_get_startRotation3DP12Il2CppObjectP8Vector3f,__Z50ParticleSystem_CUSTOM_INTERNAL_set_startRotation3DP12Il2CppObjectRK8Vector3f,__Z42ParticleSystem_Set_Custom_PropMaxParticlesP12Il2CppObjecti,__Z45ParticleSystem_Set_Custom_PropSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace,__Z41ParticleSystem_Set_Custom_PropScalingModeP12Il2CppObject25ParticleSystemScalingMode,__Z40ParticleSystem_Set_Custom_PropRandomSeedP12Il2CppObjectj,__Z47ParticleSystem_Set_Custom_PropUseAutoRandomSeedP12Il2CppObjecth,__Z40ParticleSystem_CUSTOM_INTERNAL_CALL_EmitP12Il2CppObjecti,__Z38ParticleSystem_CUSTOM_Internal_EmitOldP12Il2CppObjectR22ParticleSystemParticle,__Z48ParticleSystemRenderer_Set_Custom_PropRenderModeP12Il2CppObject24ParticleSystemRenderMode,__Z47ParticleSystemRenderer_Set_Custom_PropAlignmentP12Il2CppObject25ParticleSystemRenderSpace,__Z48ParticleSystemRenderer_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP8Vector3f
,__Z48ParticleSystemRenderer_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK8Vector3f,__Z46ParticleSystemRenderer_Set_Custom_PropSortModeP12Il2CppObject22ParticleSystemSortMode,__Z42ParticleSystemRenderer_Set_Custom_PropMeshP12Il2CppObjectS0_,__Z51ParticleSystemRenderer_Set_Custom_PropTrailMaterialP12Il2CppObjectS0_,__ZL15gHullPrefetchCBjPKN5physx6PxVec3E,__ZN5physx2GuL18gPCMHullPrefetchCBEjPKNS_6PxVec3E,__Z19setPxMaterial_FlagsPN5physx10PxMaterialENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE,__Z33setPxMaterial_FrictionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE,__Z36setPxMaterial_RestitutionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE,__Z21setPxMaterialUserDataPN5physx10PxMaterialEPv,__Z19setPxShape_GeometryPN5physx7PxShapeERKNS_10PxGeometryE,__Z20getPxShape_LocalPosePKN5physx7PxShapeE,__Z20setPxShape_LocalPosePN5physx7PxShapeERKNS_11PxTransformE,__Z31getPxShape_SimulationFilterDataPKN5physx7PxShapeE,__Z31setPxShape_SimulationFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE,__Z26getPxShape_QueryFilterDataPKN5physx7PxShapeE,__Z26setPxShape_QueryFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE,__Z16setPxShape_FlagsPN5physx7PxShapeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE,__Z15setPxShape_NamePN5physx7PxShapeEPKc,__Z18setPxShapeUserDataPN5physx7PxShapeEPv,__Z35setPxHeightFieldGeometryHeightFieldPN5physx21PxHeightFieldGeometryEPNS_13PxHeightFieldE,__Z40setPxHeightFieldGeometryHeightFieldFlagsPN5physx21PxHeightFieldGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE,__Z19getPxMeshScaleScalePKN5physx11PxMeshScaleE,__Z19setPxMeshScaleScalePN5physx11PxMeshScaleENS_6PxVec3E,__Z22getPxMeshScaleRotationPKN5physx11PxMeshScaleE,__Z22setPxMeshScaleRotationPN5physx11PxMeshScaleENS_6PxQuatE,__Z30getPxTriangleMeshGeometryScalePKN5physx22PxTriangleMeshGeometryE,__Z30setPxTriangleMeshGeometryScalePN5physx22PxTriangleMeshGeometryENS_11PxMeshScaleE,__Z34setPxTriangleMeshGeometryMeshFlagsPN5physx22PxTriangleMeshGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE,__Z37setPxTriangleMeshGeometryTriangleMeshPN5physx22PxTriangleMeshGeometryEPNS_14PxTriangleMeshE
,__Z28getPxConvexMeshGeometryScalePKN5physx20PxConvexMeshGeometryE,__Z28setPxConvexMeshGeometryScalePN5physx20PxConvexMeshGeometryENS_11PxMeshScaleE,__Z33setPxConvexMeshGeometryConvexMeshPN5physx20PxConvexMeshGeometryEPNS_12PxConvexMeshE,__Z27getPxBoxGeometryHalfExtentsPKN5physx13PxBoxGeometryE,__Z27setPxBoxGeometryHalfExtentsPN5physx13PxBoxGeometryENS_6PxVec3E,__Z26setPxHeightFieldDescNbRowsPN5physx17PxHeightFieldDescEj,__Z29setPxHeightFieldDescNbColumnsPN5physx17PxHeightFieldDescEj,__Z26setPxHeightFieldDescFormatPN5physx17PxHeightFieldDescENS_19PxHeightFieldFormat4EnumE,__Z27getPxHeightFieldDescSamplesPKN5physx17PxHeightFieldDescE,__Z27setPxHeightFieldDescSamplesPN5physx17PxHeightFieldDescENS_13PxStridedDataE,__Z25setPxHeightFieldDescFlagsPN5physx17PxHeightFieldDescENS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEE,__Z15setPxActor_NamePN5physx7PxActorEPKc,__Z21setPxActor_ActorFlagsPN5physx7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEE,__Z25setPxActor_DominanceGroupPN5physx7PxActorEh,__Z22setPxActor_OwnerClientPN5physx7PxActorEh,__Z30setPxActor_ClientBehaviorFlagsPN5physx7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE,__Z18setPxActorUserDataPN5physx7PxActorEPv,__Z26getPxRigidActor_GlobalPosePKN5physx12PxRigidActorE,__Z26setPxRigidActor_GlobalPosePN5physx12PxRigidActorERKNS_11PxTransformE,__Z33setPxRigidDynamic_KinematicTargetPN5physx14PxRigidDynamicERKNS_11PxTransformE,__Z29getPxRigidBody_CMassLocalPosePKN5physx11PxRigidBodyE,__Z29setPxRigidBody_CMassLocalPosePN5physx11PxRigidBodyERKNS_11PxTransformE,__Z37getPxRigidBody_MassSpaceInertiaTensorPKN5physx11PxRigidBodyE,__Z37setPxRigidBody_MassSpaceInertiaTensorPN5physx11PxRigidBodyERKNS_6PxVec3E,__Z40getPxRigidBody_MassSpaceInvInertiaTensorPKN5physx11PxRigidBodyE,__Z29getPxRigidBody_LinearVelocityPKN5physx11PxRigidBodyE,__Z29setPxRigidBody_LinearVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E,__Z30getPxRigidBody_AngularVelocityPKN5physx11PxRigidBodyE,__Z30setPxRigidBody_AngularVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E,__Z32setPxRigidBody_RigidDynamicFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE
,__Z29setPxRigidBody_RigidBodyFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE,__Z33getPxArticulationJoint_ParentPosePKN5physx19PxArticulationJointE,__Z33setPxArticulationJoint_ParentPosePN5physx19PxArticulationJointERKNS_11PxTransformE,__Z32getPxArticulationJoint_ChildPosePKN5physx19PxArticulationJointE,__Z32setPxArticulationJoint_ChildPosePN5physx19PxArticulationJointERKNS_11PxTransformE,__Z40getPxArticulationJoint_TargetOrientationPKN5physx19PxArticulationJointE,__Z40setPxArticulationJoint_TargetOrientationPN5physx19PxArticulationJointERKNS_6PxQuatE,__Z37getPxArticulationJoint_TargetVelocityPKN5physx19PxArticulationJointE,__Z37setPxArticulationJoint_TargetVelocityPN5physx19PxArticulationJointERKNS_6PxVec3E,__Z32setPxArticulationJoint_DriveTypePN5physx19PxArticulationJointENS_28PxArticulationJointDriveType4EnumE,__Z40setPxArticulationJoint_SwingLimitEnabledPN5physx19PxArticulationJointEb,__Z40setPxArticulationJoint_TwistLimitEnabledPN5physx19PxArticulationJointEb,__Z41setPxArticulation_MaxProjectionIterationsPN5physx14PxArticulationEj,__Z41setPxArticulation_InternalDriveIterationsPN5physx14PxArticulationEj,__Z41setPxArticulation_ExternalDriveIterationsPN5physx14PxArticulationEj,__Z22setPxArticulation_NamePN5physx14PxArticulationEPKc,__Z25setPxArticulationUserDataPN5physx14PxArticulationEPv,__Z21setPxCloth_ClothFlagsPN5physx7PxClothENS_7PxFlagsINS_11PxClothFlag4EnumEtEE,__Z21setPxCloth_TargetPosePN5physx7PxClothERKNS_11PxTransformE,__Z21getPxCloth_GlobalPosePKN5physx7PxClothE,__Z21setPxCloth_GlobalPosePN5physx7PxClothERKNS_11PxTransformE,__Z29getPxCloth_LinearInertiaScalePKN5physx7PxClothE,__Z29setPxCloth_LinearInertiaScalePN5physx7PxClothENS_6PxVec3E,__Z30getPxCloth_AngularInertiaScalePKN5physx7PxClothE,__Z30setPxCloth_AngularInertiaScalePN5physx7PxClothENS_6PxVec3E,__Z34getPxCloth_CentrifugalInertiaScalePKN5physx7PxClothE,__Z34setPxCloth_CentrifugalInertiaScalePN5physx7PxClothENS_6PxVec3E,__Z29getPxCloth_DampingCoefficientPKN5physx7PxClothE,__Z29setPxCloth_DampingCoefficientPN5physx7PxClothENS_6PxVec3E,__Z32getPxCloth_LinearDragCoefficientPKN5physx7PxClothE
,__Z32setPxCloth_LinearDragCoefficientPN5physx7PxClothENS_6PxVec3E,__Z33getPxCloth_AngularDragCoefficientPKN5physx7PxClothE,__Z33setPxCloth_AngularDragCoefficientPN5physx7PxClothENS_6PxVec3E,__Z31getPxCloth_ExternalAccelerationPKN5physx7PxClothE,__Z31setPxCloth_ExternalAccelerationPN5physx7PxClothENS_6PxVec3E,__Z33getPxCloth_MotionConstraintConfigPKN5physx7PxClothE,__Z33setPxCloth_MotionConstraintConfigPN5physx7PxClothERKNS_29PxClothMotionConstraintConfigE,__Z23getPxCloth_TetherConfigPKN5physx7PxClothE,__Z23setPxCloth_TetherConfigPN5physx7PxClothERKNS_19PxClothTetherConfigE,__Z31getPxCloth_SimulationFilterDataPKN5physx7PxClothE,__Z31setPxCloth_SimulationFilterDataPN5physx7PxClothERKNS_12PxFilterDataE,__Z28getPxJoint_RelativeTransformPKN5physx7PxJointE,__Z33getPxJoint_RelativeLinearVelocityPKN5physx7PxJointE,__Z34getPxJoint_RelativeAngularVelocityPKN5physx7PxJointE,__Z26setPxJoint_ConstraintFlagsPN5physx7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__Z15setPxJoint_NamePN5physx7PxJointEPKc,__Z18setPxJointUserDataPN5physx7PxJointEPv,__Z29getPxSphericalJoint_LimitConePKN5physx16PxSphericalJointE,__Z29setPxSphericalJoint_LimitConePN5physx16PxSphericalJointERKNS_16PxJointLimitConeE,__Z39setPxSphericalJoint_SphericalJointFlagsPN5physx16PxSphericalJointENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE,__Z24getPxRevoluteJoint_LimitPKN5physx15PxRevoluteJointE,__Z24setPxRevoluteJoint_LimitPN5physx15PxRevoluteJointERKNS_23PxJointAngularLimitPairE,__Z37setPxRevoluteJoint_RevoluteJointFlagsPN5physx15PxRevoluteJointENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE,__Z25getPxPrismaticJoint_LimitPKN5physx16PxPrismaticJointE,__Z25setPxPrismaticJoint_LimitPN5physx16PxPrismaticJointERKNS_22PxJointLinearLimitPairE,__Z39setPxPrismaticJoint_PrismaticJointFlagsPN5physx16PxPrismaticJointENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE,__Z22setPxD6JointDriveFlagsPN5physx14PxD6JointDriveENS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEE,__Z24getPxD6Joint_LinearLimitPKN5physx9PxD6JointE,__Z24setPxD6Joint_LinearLimitPN5physx9PxD6JointERKNS_18PxJointLinearLimitE,__Z23getPxD6Joint_TwistLimitPKN5physx9PxD6JointE
,__Z23setPxD6Joint_TwistLimitPN5physx9PxD6JointERKNS_23PxJointAngularLimitPairE,__Z23getPxD6Joint_SwingLimitPKN5physx9PxD6JointE,__Z23setPxD6Joint_SwingLimitPN5physx9PxD6JointERKNS_16PxJointLimitConeE,__Z26getPxD6Joint_DrivePositionPKN5physx9PxD6JointE,__Z26setPxD6Joint_DrivePositionPN5physx9PxD6JointERKNS_11PxTransformE,__Z37setPxDistanceJoint_DistanceJointFlagsPN5physx15PxDistanceJointENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE,__Z38getPxParticleBase_ExternalAccelerationPKN5physx14PxParticleBaseE,__Z38setPxParticleBase_ExternalAccelerationPN5physx14PxParticleBaseERKNS_6PxVec3E,__Z38getPxParticleBase_SimulationFilterDataPKN5physx14PxParticleBaseE,__Z38setPxParticleBase_SimulationFilterDataPN5physx14PxParticleBaseERKNS_12PxFilterDataE,__Z18GetProjectionPlanePKN5physx14PxParticleBaseE,__Z18SetProjectionPlanePN5physx14PxParticleBaseENS_15PxMetaDataPlaneE,__ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx23solveConcludeExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx18solveConcludeExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx30solveConcludeExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE,__Z21setPxConstraint_FlagsPN5physx12PxConstraintENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE,__Z17getPxScene_LimitsPKN5physx7PxSceneE,__Z17setPxScene_LimitsPN5physx7PxSceneERKNS_13PxSceneLimitsE,__Z42setPxScene_ClothInterCollisionNbIterationsPN5physx7PxSceneEj,__Z32setPxScene_ContactModifyCallbackPN5physx7PxSceneEPNS_23PxContactModifyCallbackE,__Z35setPxScene_CCDContactModifyCallbackPN5physx7PxSceneEPNS_26PxCCDContactModifyCallbackE,__Z18getPxScene_GravityPKN5physx7PxSceneE,__Z18setPxScene_GravityPN5physx7PxSceneERKNS_6PxVec3E,__Z23setPxScene_CCDMaxPassesPN5physx7PxSceneEj,__Z23setPxScene_FrictionTypePN5physx7PxSceneENS_14PxFrictionType4EnumE,__Z34setPxScene_VisualizationCullingBoxPN5physx7PxSceneERKNS_9PxBounds3E
,__Z37setPxScene_DynamicTreeRebuildRateHintPN5physx7PxSceneEj,__Z30setPxScene_NbContactDataBlocksPN5physx7PxSceneEj,__Z26setPxScene_SolverBatchSizePN5physx7PxSceneEj,__Z18setPxSceneUserDataPN5physx7PxSceneEPv,__Z8GetStatsPKN5physx7PxSceneE,__Z21getPxClothParticlePosPKN5physx15PxClothParticleE,__Z21setPxClothParticlePosPN5physx15PxClothParticleENS_6PxVec3E,__Z30setPxClothFabricPhasePhaseTypePN5physx18PxClothFabricPhaseENS_22PxClothFabricPhaseType4EnumE,__Z29setPxClothFabricPhaseSetIndexPN5physx18PxClothFabricPhaseEj,__Z27setPxSceneLimitsMaxNbActorsPN5physx13PxSceneLimitsEj,__Z27setPxSceneLimitsMaxNbBodiesPN5physx13PxSceneLimitsEj,__Z33setPxSceneLimitsMaxNbStaticShapesPN5physx13PxSceneLimitsEj,__Z34setPxSceneLimitsMaxNbDynamicShapesPN5physx13PxSceneLimitsEj,__Z31setPxSceneLimitsMaxNbAggregatesPN5physx13PxSceneLimitsEj,__Z32setPxSceneLimitsMaxNbConstraintsPN5physx13PxSceneLimitsEj,__Z28setPxSceneLimitsMaxNbRegionsPN5physx13PxSceneLimitsEj,__Z37setPxSceneLimitsMaxNbObjectsPerRegionPN5physx13PxSceneLimitsEj,__Z24setPxSceneDesc_ToDefaultPN5physx11PxSceneDescERKNS_17PxTolerancesScaleE,__Z21getPxSceneDescGravityPKN5physx11PxSceneDescE,__Z21setPxSceneDescGravityPN5physx11PxSceneDescENS_6PxVec3E,__Z37setPxSceneDescSimulationEventCallbackPN5physx11PxSceneDescEPNS_25PxSimulationEventCallbackE,__Z35setPxSceneDescContactModifyCallbackPN5physx11PxSceneDescEPNS_23PxContactModifyCallbackE,__Z38setPxSceneDescCcdContactModifyCallbackPN5physx11PxSceneDescEPNS_26PxCCDContactModifyCallbackE,__Z30setPxSceneDescFilterShaderDataPN5physx11PxSceneDescEPKv,__Z34setPxSceneDescFilterShaderDataSizePN5physx11PxSceneDescEj,__Z26setPxSceneDescFilterShaderPN5physx11PxSceneDescEPFNS_7PxFlagsINS_12PxFilterFlag4EnumEtEEjNS_12PxFilterDataEjS6_RNS2_INS_10PxPairFlag4EnumEtEEPKvjE,__Z28setPxSceneDescFilterCallbackPN5physx11PxSceneDescEPNS_26PxSimulationFilterCallbackE,__Z28setPxSceneDescBroadPhaseTypePN5physx11PxSceneDescENS_16PxBroadPhaseType4EnumE,__Z32setPxSceneDescBroadPhaseCallbackPN5physx11PxSceneDescEPNS_20PxBroadPhaseCallbackE,__Z20getPxSceneDescLimitsPKN5physx11PxSceneDescE
,__Z20setPxSceneDescLimitsPN5physx11PxSceneDescENS_13PxSceneLimitsE,__Z26setPxSceneDescFrictionTypePN5physx11PxSceneDescENS_14PxFrictionType4EnumE,__Z19setPxSceneDescFlagsPN5physx11PxSceneDescENS_7PxFlagsINS_11PxSceneFlag4EnumEtEE,__Z27setPxSceneDescCpuDispatcherPN5physx11PxSceneDescEPNS_15PxCpuDispatcherE,__Z27setPxSceneDescGpuDispatcherPN5physx11PxSceneDescEPNS_15PxGpuDispatcherE,__Z27setPxSceneDescSpuDispatcherPN5physx11PxSceneDescEPNS_15PxSpuDispatcherE,__Z29setPxSceneDescStaticStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE,__Z30setPxSceneDescDynamicStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE,__Z40setPxSceneDescDynamicTreeRebuildRateHintPN5physx11PxSceneDescEj,__Z22setPxSceneDescUserDataPN5physx11PxSceneDescEPv,__Z29setPxSceneDescSolverBatchSizePN5physx11PxSceneDescEj,__Z33setPxSceneDescNbContactDataBlocksPN5physx11PxSceneDescEj,__Z36setPxSceneDescMaxNbContactDataBlocksPN5physx11PxSceneDescEj,__Z43setPxSceneDescContactReportStreamBufferSizePN5physx11PxSceneDescEj,__Z26setPxSceneDescCcdMaxPassesPN5physx11PxSceneDescEj,__Z29setPxSceneDescSimulationOrderPN5physx11PxSceneDescENS_17PxSimulationOrder4EnumE,__Z26getPxSceneDescSanityBoundsPKN5physx11PxSceneDescE,__Z26setPxSceneDescSanityBoundsPN5physx11PxSceneDescENS_9PxBounds3E,__Z44setPxSimulationStatisticsNbActiveConstraintsPN5physx22PxSimulationStatisticsEj,__Z46setPxSimulationStatisticsNbActiveDynamicBodiesPN5physx22PxSimulationStatisticsEj,__Z48setPxSimulationStatisticsNbActiveKinematicBodiesPN5physx22PxSimulationStatisticsEj,__Z39setPxSimulationStatisticsNbStaticBodiesPN5physx22PxSimulationStatisticsEj,__Z40setPxSimulationStatisticsNbDynamicBodiesPN5physx22PxSimulationStatisticsEj,__Z48setPxSimulationStatisticsNbAxisSolverConstraintsPN5physx22PxSimulationStatisticsEj,__Z46setPxSimulationStatisticsCompressedContactSizePN5physx22PxSimulationStatisticsEj,__Z56setPxSimulationStatisticsRequiredContactConstraintMemoryPN5physx22PxSimulationStatisticsEj,__Z45setPxSimulationStatisticsPeakConstraintMemoryPN5physx22PxSimulationStatisticsEj,__Z58setPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePN5physx22PxSimulationStatisticsEj,__Z50setPxSimulationStatisticsParticlesGpuMeshCacheSizePN5physx22PxSimulationStatisticsEj,__Z50setPxSimulationStatisticsParticlesGpuMeshCacheUsedPN5physx22PxSimulationStatisticsEj
,__Z37setPxParticleReadDataNbValidParticlesPN5physx18PxParticleReadDataEj,__Z39setPxParticleReadDataValidParticleRangePN5physx18PxParticleReadDataEj,__Z40setPxParticleReadDataValidParticleBitmapPN5physx18PxParticleReadDataEPKj,__Z35getPxParticleReadDataPositionBufferPKN5physx18PxParticleReadDataE,__Z35setPxParticleReadDataPositionBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE,__Z35getPxParticleReadDataVelocityBufferPKN5physx18PxParticleReadDataE,__Z35setPxParticleReadDataVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE,__Z37getPxParticleReadDataRestOffsetBufferPKN5physx18PxParticleReadDataE,__Z37setPxParticleReadDataRestOffsetBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKfEE,__Z32getPxParticleReadDataFlagsBufferPKN5physx18PxParticleReadDataE,__Z32setPxParticleReadDataFlagsBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEE,__Z42getPxParticleReadDataCollisionNormalBufferPKN5physx18PxParticleReadDataE,__Z42setPxParticleReadDataCollisionNormalBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE,__Z44getPxParticleReadDataCollisionVelocityBufferPKN5physx18PxParticleReadDataE,__Z44setPxParticleReadDataCollisionVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE,__Z31setPxClothParticleDataParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE,__Z39setPxClothParticleDataPreviousParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE,__ZN12_GLOBAL__N_117ConnectionManager23nullDeallocationHandlerEPv,__ZN12_GLOBAL__N_117ConnectionManager25recordDeallocationHandlerEPv,__ZN12_GLOBAL__N_117ConnectionManager29connectionDeallocationHandlerEPv,__Z38Rigidbody_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z38Rigidbody_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f,__Z45Rigidbody_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f,__Z45Rigidbody_CUSTOM_INTERNAL_set_angularVelocityP12Il2CppObjectRK8Vector3f,__Z35Rigidbody_Set_Custom_PropUseGravityP12Il2CppObjecth,__Z36Rigidbody_Set_Custom_PropIsKinematicP12Il2CppObjecth,__Z39Rigidbody_Set_Custom_PropFreezeRotationP12Il2CppObjecth,__Z36Rigidbody_Set_Custom_PropConstraintsP12Il2CppObjecti,__Z47Rigidbody_Set_Custom_PropCollisionDetectionModeP12Il2CppObjecti,__Z42Rigidbody_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP8Vector3f
,__Z42Rigidbody_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK8Vector3f,__Z47Rigidbody_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP8Vector3f,__Z51Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorRotationP12Il2CppObjectP11Quaternionf,__Z51Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorRotationP12Il2CppObjectRK11Quaternionf,__Z43Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorP12Il2CppObjectP8Vector3f,__Z43Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorP12Il2CppObjectRK8Vector3f,__Z41Rigidbody_Set_Custom_PropDetectCollisionsP12Il2CppObjecth,__Z40Rigidbody_Set_Custom_PropUseConeFrictionP12Il2CppObjecth,__Z38Rigidbody_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f,__Z38Rigidbody_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f,__Z38Rigidbody_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf,__Z38Rigidbody_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf,__Z43Rigidbody_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK8Vector3f,__Z43Rigidbody_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectRK11Quaternionf,__Z38Rigidbody_Set_Custom_PropInterpolationP12Il2CppObject22RigidbodyInterpolation,__Z41Rigidbody_Set_Custom_PropSolverIterationsP12Il2CppObjecti,__Z49Rigidbody_Set_Custom_PropSolverVelocityIterationsP12Il2CppObjecti,__Z34Joint_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_,__Z30Joint_CUSTOM_INTERNAL_get_axisP12Il2CppObjectP8Vector3f,__Z30Joint_CUSTOM_INTERNAL_set_axisP12Il2CppObjectRK8Vector3f,__Z32Joint_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP8Vector3f,__Z32Joint_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK8Vector3f,__Z41Joint_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP8Vector3f,__Z41Joint_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK8Vector3f,__Z49Joint_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth,__Z36Joint_Set_Custom_PropEnableCollisionP12Il2CppObjecth,__Z40Joint_Set_Custom_PropEnablePreprocessingP12Il2CppObjecth,__Z38Joint_CUSTOM_INTERNAL_get_currentForceP12Il2CppObjectP8Vector3f,__Z39Joint_CUSTOM_INTERNAL_get_currentTorqueP12Il2CppObjectP8Vector3f,__Z36HingeJoint_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP10JointMotor
,__Z36HingeJoint_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK10JointMotor,__Z37HingeJoint_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP11JointLimits,__Z37HingeJoint_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK11JointLimits,__Z37HingeJoint_CUSTOM_INTERNAL_get_springP12Il2CppObjectP11JointSpring,__Z37HingeJoint_CUSTOM_INTERNAL_set_springP12Il2CppObjectRK11JointSpring,__Z34HingeJoint_Set_Custom_PropUseMotorP12Il2CppObjecth,__Z35HingeJoint_Set_Custom_PropUseLimitsP12Il2CppObjecth,__Z35HingeJoint_Set_Custom_PropUseSpringP12Il2CppObjecth,__Z44CharacterJoint_CUSTOM_INTERNAL_get_swingAxisP12Il2CppObjectP8Vector3f,__Z44CharacterJoint_CUSTOM_INTERNAL_set_swingAxisP12Il2CppObjectRK8Vector3f,__Z51CharacterJoint_CUSTOM_INTERNAL_get_twistLimitSpringP12Il2CppObjectP20SoftJointLimitSpring,__Z51CharacterJoint_CUSTOM_INTERNAL_set_twistLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring,__Z51CharacterJoint_CUSTOM_INTERNAL_get_swingLimitSpringP12Il2CppObjectP20SoftJointLimitSpring,__Z51CharacterJoint_CUSTOM_INTERNAL_set_swingLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring,__Z48CharacterJoint_CUSTOM_INTERNAL_get_lowTwistLimitP12Il2CppObjectP14SoftJointLimit,__Z48CharacterJoint_CUSTOM_INTERNAL_set_lowTwistLimitP12Il2CppObjectRK14SoftJointLimit,__Z49CharacterJoint_CUSTOM_INTERNAL_get_highTwistLimitP12Il2CppObjectP14SoftJointLimit,__Z49CharacterJoint_CUSTOM_INTERNAL_set_highTwistLimitP12Il2CppObjectRK14SoftJointLimit,__Z46CharacterJoint_CUSTOM_INTERNAL_get_swing1LimitP12Il2CppObjectP14SoftJointLimit,__Z46CharacterJoint_CUSTOM_INTERNAL_set_swing1LimitP12Il2CppObjectRK14SoftJointLimit,__Z46CharacterJoint_CUSTOM_INTERNAL_get_swing2LimitP12Il2CppObjectP14SoftJointLimit,__Z46CharacterJoint_CUSTOM_INTERNAL_set_swing2LimitP12Il2CppObjectRK14SoftJointLimit,__Z46CharacterJoint_Set_Custom_PropEnableProjectionP12Il2CppObjecth,__Z51ConfigurableJoint_CUSTOM_INTERNAL_get_secondaryAxisP12Il2CppObjectP8Vector3f,__Z51ConfigurableJoint_CUSTOM_INTERNAL_set_secondaryAxisP12Il2CppObjectRK8Vector3f,__Z40ConfigurableJoint_Set_Custom_PropXMotionP12Il2CppObjecti,__Z40ConfigurableJoint_Set_Custom_PropYMotionP12Il2CppObjecti,__Z40ConfigurableJoint_Set_Custom_PropZMotionP12Il2CppObjecti,__Z47ConfigurableJoint_Set_Custom_PropAngularXMotionP12Il2CppObjecti,__Z47ConfigurableJoint_Set_Custom_PropAngularYMotionP12Il2CppObjecti
,__Z47ConfigurableJoint_Set_Custom_PropAngularZMotionP12Il2CppObjecti,__Z55ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitSpringP12Il2CppObjectP20SoftJointLimitSpring,__Z55ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring,__Z57ConfigurableJoint_CUSTOM_INTERNAL_get_angularXLimitSpringP12Il2CppObjectP20SoftJointLimitSpring,__Z57ConfigurableJoint_CUSTOM_INTERNAL_set_angularXLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring,__Z58ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZLimitSpringP12Il2CppObjectP20SoftJointLimitSpring,__Z58ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring,__Z49ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitP12Il2CppObjectP14SoftJointLimit,__Z49ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitP12Il2CppObjectRK14SoftJointLimit,__Z54ConfigurableJoint_CUSTOM_INTERNAL_get_lowAngularXLimitP12Il2CppObjectP14SoftJointLimit,__Z54ConfigurableJoint_CUSTOM_INTERNAL_set_lowAngularXLimitP12Il2CppObjectRK14SoftJointLimit,__Z55ConfigurableJoint_CUSTOM_INTERNAL_get_highAngularXLimitP12Il2CppObjectP14SoftJointLimit,__Z55ConfigurableJoint_CUSTOM_INTERNAL_set_highAngularXLimitP12Il2CppObjectRK14SoftJointLimit,__Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularYLimitP12Il2CppObjectP14SoftJointLimit,__Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularYLimitP12Il2CppObjectRK14SoftJointLimit,__Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularZLimitP12Il2CppObjectP14SoftJointLimit,__Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularZLimitP12Il2CppObjectRK14SoftJointLimit,__Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f,__Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetPositionP12Il2CppObjectRK8Vector3f,__Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetVelocityP12Il2CppObjectP8Vector3f,__Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetVelocityP12Il2CppObjectRK8Vector3f,__Z44ConfigurableJoint_CUSTOM_INTERNAL_get_xDriveP12Il2CppObjectP10JointDrive,__Z44ConfigurableJoint_CUSTOM_INTERNAL_set_xDriveP12Il2CppObjectRK10JointDrive,__Z44ConfigurableJoint_CUSTOM_INTERNAL_get_yDriveP12Il2CppObjectP10JointDrive,__Z44ConfigurableJoint_CUSTOM_INTERNAL_set_yDriveP12Il2CppObjectRK10JointDrive,__Z44ConfigurableJoint_CUSTOM_INTERNAL_get_zDriveP12Il2CppObjectP10JointDrive,__Z44ConfigurableJoint_CUSTOM_INTERNAL_set_zDriveP12Il2CppObjectRK10JointDrive,__Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf,__Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetRotationP12Il2CppObjectRK11Quaternionf,__Z59ConfigurableJoint_CUSTOM_INTERNAL_get_targetAngularVelocityP12Il2CppObjectP8Vector3f
,__Z59ConfigurableJoint_CUSTOM_INTERNAL_set_targetAngularVelocityP12Il2CppObjectRK8Vector3f,__Z50ConfigurableJoint_Set_Custom_PropRotationDriveModeP12Il2CppObjecti,__Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularXDriveP12Il2CppObjectP10JointDrive,__Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularXDriveP12Il2CppObjectRK10JointDrive,__Z52ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZDriveP12Il2CppObjectP10JointDrive,__Z52ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZDriveP12Il2CppObjectRK10JointDrive,__Z48ConfigurableJoint_CUSTOM_INTERNAL_get_slerpDriveP12Il2CppObjectP10JointDrive,__Z48ConfigurableJoint_CUSTOM_INTERNAL_set_slerpDriveP12Il2CppObjectRK10JointDrive,__Z47ConfigurableJoint_Set_Custom_PropProjectionModeP12Il2CppObjecti,__Z55ConfigurableJoint_Set_Custom_PropConfiguredInWorldSpaceP12Il2CppObjecth,__Z43ConfigurableJoint_Set_Custom_PropSwapBodiesP12Il2CppObjecth,__Z39ConstantForce_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f,__Z39ConstantForce_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f,__Z47ConstantForce_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP8Vector3f,__Z47ConstantForce_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK8Vector3f,__Z40ConstantForce_CUSTOM_INTERNAL_get_torqueP12Il2CppObjectP8Vector3f,__Z40ConstantForce_CUSTOM_INTERNAL_set_torqueP12Il2CppObjectRK8Vector3f,__Z48ConstantForce_CUSTOM_INTERNAL_get_relativeTorqueP12Il2CppObjectP8Vector3f,__Z48ConstantForce_CUSTOM_INTERNAL_set_relativeTorqueP12Il2CppObjectRK8Vector3f,__Z31Collider_Set_Custom_PropEnabledP12Il2CppObjecth,__Z33Collider_Set_Custom_PropIsTriggerP12Il2CppObjecth,__Z32Collider_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z38Collider_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_,__Z35Collider_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z38BoxCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z38BoxCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z36BoxCollider_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f,__Z36BoxCollider_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f,__Z41SphereCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z41SphereCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f
,__Z38MeshCollider_Set_Custom_PropSharedMeshP12Il2CppObjectS0_,__Z34MeshCollider_Set_Custom_PropConvexP12Il2CppObjecth,__Z39MeshCollider_Set_Custom_PropInflateMeshP12Il2CppObjecth,__Z42CapsuleCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z42CapsuleCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z40CapsuleCollider_Set_Custom_PropDirectionP12Il2CppObjecti,__Z53PhysicMaterial_CUSTOM_Internal_CreateDynamicsMaterialP12Il2CppObjectP12Il2CppString,__Z45PhysicMaterial_Set_Custom_PropFrictionCombineP12Il2CppObjecti,__Z43PhysicMaterial_Set_Custom_PropBounceCombineP12Il2CppObjecti,__Z48CharacterController_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z46CharacterController_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z46CharacterController_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z51CharacterController_Set_Custom_PropDetectCollisionsP12Il2CppObjecth,__Z56CharacterController_Set_Custom_PropEnableOverlapRecoveryP12Il2CppObjecth,__ZN15b2CircleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN25b2PolygonAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN16b2PolygonContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN22b2EdgeAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN23b2EdgeAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN23b2ChainAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN24b2ChainAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN16b2CapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN25b2CapsuleAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN26b2PolygonAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN23b2EdgeAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator,__ZN24b2ChainAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator,__Z38Physics2D_CUSTOM_SetLayerCollisionMaskii,__Z40Rigidbody2D_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP13Vector2fIcall,__Z40Rigidbody2D_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK13Vector2fIcall,__Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK13Vector2fIcall
,__Z40Rigidbody2D_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP13Vector2fIcall,__Z40Rigidbody2D_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK13Vector2fIcall,__Z38Rigidbody2D_Set_Custom_PropUseAutoMassP12Il2CppObjecth,__Z41Rigidbody2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_,__Z44Rigidbody2D_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP13Vector2fIcall,__Z44Rigidbody2D_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK13Vector2fIcall,__Z49Rigidbody2D_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP13Vector2fIcall,__Z35Rigidbody2D_Set_Custom_PropBodyTypeP12Il2CppObjectN11Rigidbody2D8BodyTypeE,__Z35Rigidbody2D_CUSTOM_SetDragBehaviourP12Il2CppObjecth,__Z51Rigidbody2D_Set_Custom_PropUseFullKinematicContactsP12Il2CppObjecth,__Z37Rigidbody2D_Set_Custom_PropFixedAngleP12Il2CppObjecth,__Z41Rigidbody2D_Set_Custom_PropFreezeRotationP12Il2CppObjecth,__Z38Rigidbody2D_Set_Custom_PropConstraintsP12Il2CppObjectN11Rigidbody2D11ConstraintsE,__Z36Rigidbody2D_Set_Custom_PropSimulatedP12Il2CppObjecth,__Z40Rigidbody2D_Set_Custom_PropInterpolationP12Il2CppObjectN11Rigidbody2D13InterpolationE,__Z36Rigidbody2D_Set_Custom_PropSleepModeP12Il2CppObjectN11Rigidbody2D9SleepModeE,__Z49Rigidbody2D_Set_Custom_PropCollisionDetectionModeP12Il2CppObjectN11Rigidbody2D22CollisionDetectionModeE,__Z35Collider2D_Set_Custom_PropIsTriggerP12Il2CppObjecth,__Z40Collider2D_Set_Custom_PropUsedByEffectorP12Il2CppObjecth,__Z37Collider2D_CUSTOM_INTERNAL_get_offsetP12Il2CppObjectP13Vector2fIcall,__Z37Collider2D_CUSTOM_INTERNAL_set_offsetP12Il2CppObjectRK13Vector2fIcall,__Z37Collider2D_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z40Collider2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_,__Z38BoxCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall,__Z38BoxCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall,__Z36EdgeCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray,__Z42CapsuleCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall,__Z42CapsuleCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall,__Z42CapsuleCollider2D_Set_Custom_PropDirectionP12Il2CppObjectN17CapsuleCollider2D16CapsuleDirectionE,__Z39PolygonCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray
,__Z42PolygonCollider2D_Set_Custom_PropPathCountP12Il2CppObjecti,__Z36Joint2D_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_,__Z38Joint2D_Set_Custom_PropEnableCollisionP12Il2CppObjecth,__Z42AnchoredJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall,__Z42AnchoredJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall,__Z51AnchoredJoint2D_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP13Vector2fIcall,__Z51AnchoredJoint2D_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK13Vector2fIcall,__Z59AnchoredJoint2D_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth,__Z50SpringJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth,__Z52DistanceJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth,__Z46DistanceJoint2D_Set_Custom_PropMaxDistanceOnlyP12Il2CppObjecth,__Z36HingeJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth,__Z37HingeJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth,__Z38HingeJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D,__Z38HingeJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D,__Z39HingeJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP18JointAngleLimits2D,__Z39HingeJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK18JointAngleLimits2D,__Z50RelativeJoint2D_Set_Custom_PropAutoConfigureOffsetP12Il2CppObjecth,__Z48RelativeJoint2D_CUSTOM_INTERNAL_get_linearOffsetP12Il2CppObjectP13Vector2fIcall,__Z48RelativeJoint2D_CUSTOM_INTERNAL_set_linearOffsetP12Il2CppObjectRK13Vector2fIcall,__Z42RelativeJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall,__Z47SliderJoint2D_Set_Custom_PropAutoConfigureAngleP12Il2CppObjecth,__Z37SliderJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth,__Z38SliderJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth,__Z39SliderJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D,__Z39SliderJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D,__Z40SliderJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP24JointTranslationLimits2D,__Z40SliderJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK24JointTranslationLimits2D,__Z40TargetJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall,__Z40TargetJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall
,__Z40TargetJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall,__Z40TargetJoint2D_CUSTOM_INTERNAL_set_targetP12Il2CppObjectRK13Vector2fIcall,__Z48TargetJoint2D_Set_Custom_PropAutoConfigureTargetP12Il2CppObjecth,__Z43WheelJoint2D_CUSTOM_INTERNAL_get_suspensionP12Il2CppObjectP17JointSuspension2D,__Z43WheelJoint2D_CUSTOM_INTERNAL_set_suspensionP12Il2CppObjectRK17JointSuspension2D,__Z36WheelJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth,__Z38WheelJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D,__Z38WheelJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D,__Z40PhysicsMaterial2D_CUSTOM_Internal_CreateP12Il2CppObjectP12Il2CppString,__Z41ConstantForce2D_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP13Vector2fIcall,__Z41ConstantForce2D_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK13Vector2fIcall,__Z49ConstantForce2D_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP13Vector2fIcall,__Z49ConstantForce2D_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK13Vector2fIcall,__Z41Effector2D_Set_Custom_PropUseColliderMaskP12Il2CppObjecth,__Z38Effector2D_Set_Custom_PropColliderMaskP12Il2CppObjecti,__Z44AreaEffector2D_Set_Custom_PropUseGlobalAngleP12Il2CppObjecth,__Z41AreaEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D,__Z42PointEffector2D_Set_Custom_PropForceSourceP12Il2CppObject19EffectorSelection2D,__Z42PointEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D,__Z40PointEffector2D_Set_Custom_PropForceModeP12Il2CppObject19EffectorForceMode2D,__Z43PlatformEffector2D_Set_Custom_PropUseOneWayP12Il2CppObjecth,__Z51PlatformEffector2D_Set_Custom_PropUseOneWayGroupingP12Il2CppObjecth,__Z49PlatformEffector2D_Set_Custom_PropUseSideFrictionP12Il2CppObjecth,__Z47PlatformEffector2D_Set_Custom_PropUseSideBounceP12Il2CppObjecth,__Z48SurfaceEffector2D_Set_Custom_PropUseContactForceP12Il2CppObjecth,__Z44SurfaceEffector2D_Set_Custom_PropUseFrictionP12Il2CppObjecth,__Z42SurfaceEffector2D_Set_Custom_PropUseBounceP12Il2CppObjecth,__Z49setPxVehicleWheelsDynData_TireForceShaderFunctionPN5physx22PxVehicleWheelsDynDataEPFvPKvffffffffffffRfS4_S4_S4_E,__Z25setPxVehicleTireDataMTypePN5physx17PxVehicleTireDataEj,__Z44getPxVehicleWheelsSimData_TireLoadFilterDataPKN5physx22PxVehicleWheelsSimDataE
,__Z44setPxVehicleWheelsSimData_TireLoadFilterDataPN5physx22PxVehicleWheelsSimDataERKNS_27PxVehicleTireLoadFilterDataE,__Z53setPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj,__Z54setPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj,__Z32getPxVehicleWheelsMWheelsSimDataPKN5physx15PxVehicleWheelsE,__Z32setPxVehicleWheelsMWheelsSimDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsSimDataE,__Z32getPxVehicleWheelsMWheelsDynDataPKN5physx15PxVehicleWheelsE,__Z32setPxVehicleWheelsMWheelsDynDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsDynDataE,__Z35setPxVehicleDifferential4WDataMTypePN5physx27PxVehicleDifferential4WDataENS0_4EnumE,__Z35setPxVehicleClutchDataMAccuracyModePN5physx19PxVehicleClutchDataENS_27PxVehicleClutchAccuracyMode4EnumE,__Z41setPxVehicleClutchDataMEstimateIterationsPN5physx19PxVehicleClutchDataEj,__Z30setPxVehicleGearsDataMNbRatiosPN5physx18PxVehicleGearsDataEj,__Z35getPxVehicleDriveSimData_EngineDataPKN5physx21PxVehicleDriveSimDataE,__Z35setPxVehicleDriveSimData_EngineDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataE,__Z34getPxVehicleDriveSimData_GearsDataPKN5physx21PxVehicleDriveSimDataE,__Z34setPxVehicleDriveSimData_GearsDataPN5physx21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataE,__Z35getPxVehicleDriveSimData_ClutchDataPKN5physx21PxVehicleDriveSimDataE,__Z35setPxVehicleDriveSimData_ClutchDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataE,__Z36getPxVehicleDriveSimData_AutoBoxDataPKN5physx21PxVehicleDriveSimDataE,__Z36setPxVehicleDriveSimData_AutoBoxDataPN5physx21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataE,__Z35getPxVehicleDriveSimData4W_DiffDataPKN5physx23PxVehicleDriveSimData4WE,__Z35setPxVehicleDriveSimData4W_DiffDataPN5physx23PxVehicleDriveSimData4WERKNS_27PxVehicleDifferential4WDataE,__Z48getPxVehicleDriveSimData4W_AckermannGeometryDataPKN5physx23PxVehicleDriveSimData4WE,__Z48setPxVehicleDriveSimData4W_AckermannGeometryDataPN5physx23PxVehicleDriveSimData4WERKNS_30PxVehicleAckermannGeometryDataE,__Z48setPxVehicleDifferentialNWData_DrivenWheelStatusPN5physx27PxVehicleDifferentialNWDataEj,__Z35getPxVehicleDriveSimDataNW_DiffDataPKN5physx23PxVehicleDriveSimDataNWE,__Z35setPxVehicleDriveSimDataNW_DiffDataPN5physx23PxVehicleDriveSimDataNWERKNS_27PxVehicleDifferentialNWDataE,__Z31setPxVehicleDriveDynData_GearUpPN5physx21PxVehicleDriveDynDataEb,__Z33setPxVehicleDriveDynData_GearDownPN5physx21PxVehicleDriveDynDataEb,__Z37setPxVehicleDriveDynData_UseAutoGearsPN5physx21PxVehicleDriveDynDataEb,__Z36setPxVehicleDriveDynData_CurrentGearPN5physx21PxVehicleDriveDynDataEj
,__Z35setPxVehicleDriveDynData_TargetGearPN5physx21PxVehicleDriveDynDataEj,__Z35setPxVehicleDriveDynData_GearChangePN5physx21PxVehicleDriveDynDataEj,__Z37setPxVehicleDriveDynDataMUseAutoGearsPN5physx21PxVehicleDriveDynDataEb,__Z38setPxVehicleDriveDynDataMGearUpPressedPN5physx21PxVehicleDriveDynDataEb,__Z40setPxVehicleDriveDynDataMGearDownPressedPN5physx21PxVehicleDriveDynDataEb,__Z36setPxVehicleDriveDynDataMCurrentGearPN5physx21PxVehicleDriveDynDataEj,__Z35setPxVehicleDriveDynDataMTargetGearPN5physx21PxVehicleDriveDynDataEj,__Z30getPxVehicleDriveMDriveDynDataPKN5physx14PxVehicleDriveE,__Z30setPxVehicleDriveMDriveDynDataPN5physx14PxVehicleDriveENS_21PxVehicleDriveDynDataE,__Z32getPxVehicleDriveNWMDriveSimDataPKN5physx16PxVehicleDriveNWE,__Z32setPxVehicleDriveNWMDriveSimDataPN5physx16PxVehicleDriveNWENS_23PxVehicleDriveSimDataNWE,__Z32setPxVehicleDriveTank_DriveModelPN5physx18PxVehicleDriveTankENS_30PxVehicleDriveTankControlModel4EnumE,__Z34getPxVehicleDriveTankMDriveSimDataPKN5physx18PxVehicleDriveTankE,__Z34setPxVehicleDriveTankMDriveSimDataPN5physx18PxVehicleDriveTankENS_21PxVehicleDriveSimDataE,__Z32getPxVehicleDrive4WMDriveSimDataPKN5physx16PxVehicleDrive4WE,__Z32setPxVehicleDrive4WMDriveSimDataPN5physx16PxVehicleDrive4WENS_23PxVehicleDriveSimData4WE,__Z27getPxVehicleChassisDataMMOIPKN5physx20PxVehicleChassisDataE,__Z27setPxVehicleChassisDataMMOIPN5physx20PxVehicleChassisDataENS_6PxVec3E,__Z32getPxVehicleChassisDataMCMOffsetPKN5physx20PxVehicleChassisDataE,__Z32setPxVehicleChassisDataMCMOffsetPN5physx20PxVehicleChassisDataENS_6PxVec3E,__Z40WheelCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z40WheelCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z50WheelCollider_CUSTOM_INTERNAL_get_suspensionSpringP12Il2CppObjectP11JointSpring,__Z50WheelCollider_CUSTOM_INTERNAL_set_suspensionSpringP12Il2CppObjectRK11JointSpring,__Z49WheelCollider_CUSTOM_INTERNAL_get_forwardFrictionP12Il2CppObjectP18WheelFrictionCurve,__Z49WheelCollider_CUSTOM_INTERNAL_set_forwardFrictionP12Il2CppObjectRK18WheelFrictionCurve,__Z50WheelCollider_CUSTOM_INTERNAL_get_sidewaysFrictionP12Il2CppObjectP18WheelFrictionCurve,__Z50WheelCollider_CUSTOM_INTERNAL_set_sidewaysFrictionP12Il2CppObjectRK18WheelFrictionCurve,__Z46Cloth_CUSTOM_INTERNAL_get_externalAccelerationP12Il2CppObjectP8Vector3f,__Z46Cloth_CUSTOM_INTERNAL_set_externalAccelerationP12Il2CppObjectRK8Vector3f
,__Z44Cloth_CUSTOM_INTERNAL_get_randomAccelerationP12Il2CppObjectP8Vector3f,__Z44Cloth_CUSTOM_INTERNAL_set_randomAccelerationP12Il2CppObjectRK8Vector3f,__Z31Cloth_Set_Custom_PropUseGravityP12Il2CppObjecth,__Z34Cloth_Set_Custom_PropSelfCollisionP12Il2CppObjecth,__Z28Cloth_Set_Custom_PropEnabledP12Il2CppObjecth,__Z33Cloth_Set_Custom_PropCoefficientsP12Il2CppObjectP11Il2CppArray,__Z36Cloth_Set_Custom_PropSolverFrequencyP12Il2CppObjecth,__Z37Cloth_Set_Custom_PropCapsuleCollidersP12Il2CppObjectP11Il2CppArray,__Z36Cloth_Set_Custom_PropSphereCollidersP12Il2CppObjectP11Il2CppArray,__Z13UpdatePathJobP9CrowdInfoj,__Z18UpdateProximityJobP9CrowdInfoj,__Z17UpdateSteeringJobP9CrowdInfoj,__Z18UpdateAvoidanceJobP9CrowdInfoj,__Z13UpdateMoveJobP9CrowdInfoj,__Z17UpdateVelocityJobP9CrowdInfoj,__ZL21CarveJobMultithreadedP12CarveJobInfoj,__ZL40UpdateTransformsGetMessagesMultiThreadedP30UpdateTransformGetMessagesInfoj,__Z44NavMeshAgent_CUSTOM_INTERNAL_get_destinationP12Il2CppObjectP8Vector3f,__Z44NavMeshAgent_CUSTOM_INTERNAL_set_destinationP12Il2CppObjectRK8Vector3f,__Z41NavMeshAgent_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z41NavMeshAgent_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f,__Z45NavMeshAgent_CUSTOM_INTERNAL_get_nextPositionP12Il2CppObjectP8Vector3f,__Z45NavMeshAgent_CUSTOM_INTERNAL_set_nextPositionP12Il2CppObjectRK8Vector3f,__Z47NavMeshAgent_CUSTOM_INTERNAL_get_steeringTargetP12Il2CppObjectP8Vector3f,__Z48NavMeshAgent_CUSTOM_INTERNAL_get_desiredVelocityP12Il2CppObjectP8Vector3f,__Z46NavMeshAgent_CUSTOM_ActivateCurrentOffMeshLinkP12Il2CppObjecth,__Z53NavMeshAgent_CUSTOM_GetCurrentOffMeshLinkDataInternalP12Il2CppObject,__Z50NavMeshAgent_CUSTOM_GetNextOffMeshLinkDataInternalP12Il2CppObject,__Z51NavMeshAgent_Set_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObjecth,__Z39NavMeshAgent_Set_Custom_PropAutoBrakingP12Il2CppObjecth
,__Z38NavMeshAgent_Set_Custom_PropAutoRepathP12Il2CppObjecth,__Z48NavMeshAgent_CUSTOM_INTERNAL_get_pathEndPositionP12Il2CppObjectP8Vector3f,__Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f,__Z30NavMeshAgent_CUSTOM_CopyPathToP12Il2CppObjectS0_,__Z40NavMeshAgent_Set_Custom_PropWalkableMaskP12Il2CppObjecti,__Z36NavMeshAgent_Set_Custom_PropAreaMaskP12Il2CppObjecti,__Z42NavMeshAgent_Set_Custom_PropUpdatePositionP12Il2CppObjecth,__Z42NavMeshAgent_Set_Custom_PropUpdateRotationP12Il2CppObjecth,__Z49NavMeshAgent_Set_Custom_PropObstacleAvoidanceTypeP12Il2CppObject21ObstacleAvoidanceType,__Z45NavMeshAgent_Set_Custom_PropAvoidancePriorityP12Il2CppObjecti,__Z26NavMesh_CUSTOM_TriangulatePP11Il2CppArrayS1_,__Z44NavMeshObstacle_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z44NavMeshObstacle_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f,__Z38NavMeshObstacle_Set_Custom_PropCarvingP12Il2CppObjecth,__Z50NavMeshObstacle_Set_Custom_PropCarveOnlyStationaryP12Il2CppObjecth,__Z36NavMeshObstacle_Set_Custom_PropShapeP12Il2CppObject20NavMeshObstacleShape,__Z42NavMeshObstacle_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f,__Z42NavMeshObstacle_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f,__Z40NavMeshObstacle_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f,__Z40NavMeshObstacle_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f,__Z36OffMeshLink_Set_Custom_PropActivatedP12Il2CppObjecth,__Z40OffMeshLink_Set_Custom_PropBiDirectionalP12Il2CppObjecth,__Z39OffMeshLink_Set_Custom_PropNavMeshLayerP12Il2CppObjecti,__Z31OffMeshLink_Set_Custom_PropAreaP12Il2CppObjecti,__Z46OffMeshLink_Set_Custom_PropAutoUpdatePositionsP12Il2CppObjecth,__Z41OffMeshLink_Set_Custom_PropStartTransformP12Il2CppObjectS0_,__Z39OffMeshLink_Set_Custom_PropEndTransformP12Il2CppObjectS0_,__Z37AudioSettings_CUSTOM_GetDSPBufferSizePiS_,__Z37AudioSettings_CUSTOM_SetDSPBufferSizeii,__Z47AudioListener_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti
,__Z40AudioListener_CUSTOM_GetOutputDataHelperP11Il2CppArrayi,__Z38AudioSource_Set_Custom_PropTimeSamplesP12Il2CppObjecti,__Z31AudioSource_Set_Custom_PropClipP12Il2CppObjectS0_,__Z48AudioSource_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_,__Z31AudioSource_Set_Custom_PropLoopP12Il2CppObjecth,__Z47AudioSource_Set_Custom_PropIgnoreListenerVolumeP12Il2CppObjecth,__Z38AudioSource_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth,__Z46AudioSource_Set_Custom_PropIgnoreListenerPauseP12Il2CppObjecth,__Z45AudioSource_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti,__Z37AudioSource_Set_Custom_PropSpatializeP12Il2CppObjecth,__Z48AudioSource_Set_Custom_PropSpatializePostEffectsP12Il2CppObjecth,__Z40AudioSource_Set_Custom_PropBypassEffectsP12Il2CppObjecth,__Z48AudioSource_Set_Custom_PropBypassListenerEffectsP12Il2CppObjecth,__Z44AudioSource_Set_Custom_PropBypassReverbZonesP12Il2CppObjecth,__Z35AudioSource_Set_Custom_PropPriorityP12Il2CppObjecti,__Z31AudioSource_Set_Custom_PropMuteP12Il2CppObjecth,__Z38AudioSource_Set_Custom_PropRolloffModeP12Il2CppObject11RolloffMode,__Z43AudioReverbZone_Set_Custom_PropReverbPresetP12Il2CppObjecti,__Z35AudioReverbZone_Set_Custom_PropRoomP12Il2CppObjecti,__Z37AudioReverbZone_Set_Custom_PropRoomHFP12Il2CppObjecti,__Z37AudioReverbZone_Set_Custom_PropRoomLFP12Il2CppObjecti,__Z42AudioReverbZone_Set_Custom_PropReflectionsP12Il2CppObjecti,__Z37AudioReverbZone_Set_Custom_PropReverbP12Il2CppObjecti,__Z51AudioLowPassFilter_Set_Custom_PropCustomCutoffCurveP12Il2CppObjectS0_,__Z45AudioReverbFilter_Set_Custom_PropReverbPresetP12Il2CppObjecti,__Z47AudioMixer_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_,__Z36AudioMixer_Set_Custom_PropUpdateModeP12Il2CppObject20AudioMixerUpdateMode,__Z39WebCamTexture_Set_Custom_PropDeviceNameP12Il2CppObjectP12Il2CppString,__Z43WebCamTexture_Set_Custom_PropRequestedWidthP12Il2CppObjecti,__Z44WebCamTexture_Set_Custom_PropRequestedHeightP12Il2CppObjecti
,__ZN14AnimationState22DidModifyAnimationClipEP13AnimationClipR4ListI8ListNodeIS_EE,__Z20SkeletonBoneFromMonoRK16MonoSkeletonBoneR12SkeletonBone,__Z17HumanBoneFromMonoRK13MonoHumanBoneR9HumanBone,__Z43AnimationClipPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable,__Z43AnimationClipPlayable_CUSTOM_SetApplyFootIKR9HPlayableh,__Z49AnimationClipPlayable_CUSTOM_SetRemoveStartOffsetR9HPlayableh,__Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetPositionR9HPlayableR8Vector3f,__Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetPositionR9HPlayableRK8Vector3f,__Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetRotationR9HPlayableR11Quaternionf,__Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetRotationR9HPlayableRK11Quaternionf,__Z37AnimationClip_Set_Custom_PropWrapModeP12Il2CppObjecti,__Z45AnimationClip_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB,__Z45AnimationClip_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB,__Z35AnimationClip_Set_Custom_PropLegacyP12Il2CppObjecth,__Z37AnimationClip_CUSTOM_AddEventInternalP12Il2CppObjectS0_,__Z38AnimationClip_CUSTOM_SetEventsInternalP12Il2CppObjectP11Il2CppArray,__Z29Animation_Set_Custom_PropClipP12Il2CppObjectS0_,__Z42Animation_Set_Custom_PropPlayAutomaticallyP12Il2CppObjecth,__Z33Animation_Set_Custom_PropWrapModeP12Il2CppObjecti,__Z36Animation_CUSTOM_Internal_StopByNameP12Il2CppObjectP12Il2CppString,__Z38Animation_CUSTOM_Internal_RewindByNameP12Il2CppObjectP12Il2CppString,__Z27Animation_CUSTOM_RemoveClipP12Il2CppObjectS0_,__Z28Animation_CUSTOM_RemoveClip2P12Il2CppObjectP12Il2CppString,__Z40Animation_CUSTOM_INTERNAL_CALL_SyncLayerP12Il2CppObjecti,__Z39Animation_Set_Custom_PropAnimatePhysicsP12Il2CppObjecth,__Z45Animation_Set_Custom_PropAnimateOnlyIfVisibleP12Il2CppObjecth,__Z36Animation_Set_Custom_PropCullingTypeP12Il2CppObjectN9Animation11CullingTypeE,__Z41Animation_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB,__Z41Animation_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB,__Z37AnimationState_Set_Custom_PropEnabledP12Il2CppObjecth
,__Z38AnimationState_Set_Custom_PropWrapModeP12Il2CppObjecti,__Z35AnimationState_Set_Custom_PropLayerP12Il2CppObjecti,__Z43AnimationState_CUSTOM_RemoveMixingTransformP12Il2CppObjectS0_,__Z34AnimationState_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString,__Z39AnimationState_Set_Custom_PropBlendModeP12Il2CppObjecti,__Z42Animator_CUSTOM_INTERNAL_get_deltaPositionP12Il2CppObjectP8Vector3f,__Z42Animator_CUSTOM_INTERNAL_get_deltaRotationP12Il2CppObjectP11Quaternionf,__Z37Animator_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f,__Z44Animator_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f,__Z41Animator_CUSTOM_INTERNAL_get_rootPositionP12Il2CppObjectP8Vector3f,__Z41Animator_CUSTOM_INTERNAL_set_rootPositionP12Il2CppObjectRK8Vector3f,__Z41Animator_CUSTOM_INTERNAL_get_rootRotationP12Il2CppObjectP11Quaternionf,__Z41Animator_CUSTOM_INTERNAL_set_rootRotationP12Il2CppObjectRK11Quaternionf,__Z39Animator_Set_Custom_PropApplyRootMotionP12Il2CppObjecth,__Z46Animator_Set_Custom_PropLinearVelocityBlendingP12Il2CppObjecth,__Z34Animator_Set_Custom_PropUpdateModeP12Il2CppObjectN8Animator10UpdateModeE,__Z61Animator_Set_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObjecth,__Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyPositionInternalP12Il2CppObjectR8Vector3f,__Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyPositionInternalP12Il2CppObjectRK8Vector3f,__Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyRotationInternalP12Il2CppObjectR11Quaternionf,__Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyRotationInternalP12Il2CppObjectRK11Quaternionf,__Z55Animator_CUSTOM_INTERNAL_CALL_SetLookAtPositionInternalP12Il2CppObjectRK8Vector3f,__Z37Animator_Set_Custom_PropStabilizeFeetP12Il2CppObjecth,__Z42Animator_CUSTOM_INTERNAL_get_pivotPositionP12Il2CppObjectP8Vector3f,__Z36Animator_CUSTOM_InterruptMatchTargetP12Il2CppObjecth,__Z43Animator_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f,__Z43Animator_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf,__Z35Animator_Set_Custom_PropCullingModeP12Il2CppObjectN8Animator11CullingModeE,__Z30Animator_CUSTOM_StartRecordingP12Il2CppObjecti,__Z49Animator_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_
,__Z30Animator_Set_Custom_PropAvatarP12Il2CppObjectS0_,__Z32Animator_CUSTOM_SetTriggerStringP12Il2CppObjectP12Il2CppString,__Z28Animator_CUSTOM_SetTriggerIDP12Il2CppObjecti,__Z34Animator_CUSTOM_ResetTriggerStringP12Il2CppObjectP12Il2CppString,__Z30Animator_CUSTOM_ResetTriggerIDP12Il2CppObjecti,__Z46Animator_Set_Custom_PropLayersAffectMassCenterP12Il2CppObjecth,__Z35Animator_Set_Custom_PropLogWarningsP12Il2CppObjecth,__Z34Animator_Set_Custom_PropFireEventsP12Il2CppObjecth,__Z48AnimatorControllerPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable,__Z50AnimatorControllerPlayable_CUSTOM_SetTriggerStringR9HPlayableP12Il2CppString,__Z46AnimatorControllerPlayable_CUSTOM_SetTriggerIDR9HPlayablei,__Z52AnimatorControllerPlayable_CUSTOM_ResetTriggerStringR9HPlayableP12Il2CppString,__Z48AnimatorControllerPlayable_CUSTOM_ResetTriggerIDR9HPlayablei,__Z67AnimatorOverrideController_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_,__Z49AnimatorUtility_CUSTOM_OptimizeTransformHierarchyP12Il2CppObjectP11Il2CppArray,__Z28QuadTreeNodeRenderer_CleanupR15RenderNodeQueuej,__ZN14TerrainManager23AfterCullingOutputReadyEPK9IndexListPK16RendererCullData,__Z34TerrainData_CUSTOM_Internal_CreateP12Il2CppObjectS0_,__Z26TerrainData_CUSTOM_AddUserP12Il2CppObjectS0_,__Z29TerrainData_CUSTOM_RemoveUserP12Il2CppObjectS0_,__Z55TerrainData_Set_Custom_PropInternal_heightmapResolutionP12Il2CppObjecti,__Z46TerrainData_CUSTOM_INTERNAL_get_heightmapScaleP12Il2CppObjectP8Vector3f,__Z36TerrainData_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f,__Z36TerrainData_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f,__Z38TerrainData_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB,__Z47TerrainData_CUSTOM_INTERNAL_get_wavingGrassTintP12Il2CppObjectP10ColorRGBAf,__Z47TerrainData_CUSTOM_INTERNAL_set_wavingGrassTintP12Il2CppObjectRK10ColorRGBAf,__Z43TerrainData_Set_Custom_PropDetailPrototypesP12Il2CppObjectP11Il2CppArray,__Z40TerrainData_Set_Custom_PropTreeInstancesP12Il2CppObjectP11Il2CppArray,__Z41TerrainData_Set_Custom_PropTreePrototypesP12Il2CppObjectP11Il2CppArray
,__Z38TerrainData_CUSTOM_RemoveTreePrototypeP12Il2CppObjecti,__Z40TerrainData_CUSTOM_RemoveDetailPrototypeP12Il2CppObjecti,__Z54TerrainData_Set_Custom_PropInternal_alphamapResolutionP12Il2CppObjecti,__Z53TerrainData_Set_Custom_PropInternal_baseMapResolutionP12Il2CppObjecti,__Z34TerrainData_CUSTOM_SetBasemapDirtyP12Il2CppObjecth,__Z42TerrainData_Set_Custom_PropSplatPrototypesP12Il2CppObjectP11Il2CppArray,__Z26TerrainData_CUSTOM_AddTreeP12Il2CppObjectP12TreeInstance,__Z34Terrain_Set_Custom_PropTerrainDataP12Il2CppObjectS0_,__Z46Terrain_Set_Custom_PropTreeMaximumFullLODCountP12Il2CppObjecti,__Z42Terrain_Set_Custom_PropHeightmapMaximumLODP12Il2CppObjecti,__Z36Terrain_Set_Custom_PropLightmapIndexP12Il2CppObjecti,__Z44Terrain_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti,__Z47Terrain_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f,__Z47Terrain_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f,__Z55Terrain_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f,__Z55Terrain_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f,__Z34Terrain_Set_Custom_PropCastShadowsP12Il2CppObjecth,__Z43Terrain_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti,__Z49Terrain_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_,__Z35Terrain_Set_Custom_PropMaterialTypeP12Il2CppObjectN7Terrain12MaterialTypeE,__Z39Terrain_Set_Custom_PropMaterialTemplateP12Il2CppObjectS0_,__Z42Terrain_CUSTOM_INTERNAL_get_legacySpecularP12Il2CppObjectP10ColorRGBAf,__Z42Terrain_CUSTOM_INTERNAL_set_legacySpecularP12Il2CppObjectRK10ColorRGBAf,__Z36Terrain_Set_Custom_PropDrawHeightmapP12Il2CppObjecth,__Z42Terrain_Set_Custom_PropDrawTreesAndFoliageP12Il2CppObjecth,__Z44Terrain_CUSTOM_INTERNAL_CALL_AddTreeInstanceP12Il2CppObjectRK12TreeInstance,__Z43Terrain_Set_Custom_PropCollectDetailPatchesP12Il2CppObjecth,__Z40Terrain_Set_Custom_PropEditorRenderFlagsP12Il2CppObjectN7Terrain11RenderFlagsE,__Z40Terrain_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectR8Vector3f,__Z44Terrain_CUSTOM_SetSplatMaterialPropertyBlockP12Il2CppObjectS0_
,__Z53Terrain_CUSTOM_Internal_GetSplatMaterialPropertyBlockP12Il2CppObjectS0_,__Z24Tree_Set_Custom_PropDataP12Il2CppObjectS0_,_ft_outline_glyph_bbox,_ft_bitmap_glyph_bbox,_ps_hints_t1reset,_cf2_builder_moveTo,_cf2_builder_lineTo,_cf2_builder_cubeTo,_ft_free,__Z27GUIText_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString,__Z31GUIText_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z38GUIText_CUSTOM_Internal_GetPixelOffsetP12Il2CppObjectP13Vector2fIcall,__Z52GUIText_CUSTOM_INTERNAL_CALL_Internal_SetPixelOffsetP12Il2CppObjectRK13Vector2fIcall,__Z27GUIText_Set_Custom_PropFontP12Il2CppObjectS0_,__Z32GUIText_Set_Custom_PropAlignmentP12Il2CppObjecti,__Z29GUIText_Set_Custom_PropAnchorP12Il2CppObjecti,__Z31GUIText_Set_Custom_PropFontSizeP12Il2CppObjecti,__Z32GUIText_Set_Custom_PropFontStyleP12Il2CppObjecti,__Z31GUIText_Set_Custom_PropRichTextP12Il2CppObjecth,__Z33GUIText_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z33GUIText_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf,__Z28TextMesh_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString,__Z28TextMesh_Set_Custom_PropFontP12Il2CppObjectS0_,__Z32TextMesh_Set_Custom_PropFontSizeP12Il2CppObjecti,__Z33TextMesh_Set_Custom_PropFontStyleP12Il2CppObjecti,__Z33TextMesh_Set_Custom_PropAlignmentP12Il2CppObjecti,__Z30TextMesh_Set_Custom_PropAnchorP12Il2CppObjecti,__Z32TextMesh_Set_Custom_PropRichTextP12Il2CppObjecth,__Z34TextMesh_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf,__Z34TextMesh_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf
,__Z31Font_CUSTOM_Internal_CreateFontP12Il2CppObjectP12Il2CppString,__Z28Font_Set_Custom_PropMaterialP12Il2CppObjectS0_,__Z29Font_Set_Custom_PropFontNamesP12Il2CppObjectP11Il2CppArray,__Z33Font_Set_Custom_PropCharacterInfoP12Il2CppObjectP11Il2CppArray,__Z45TextGenerator_CUSTOM_INTERNAL_get_rectExtentsP12Il2CppObjectP5RectTIfE,__Z40TextGenerator_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_,__Z42TextGenerator_CUSTOM_GetCharactersInternalP12Il2CppObjectS0_,__Z37TextGenerator_CUSTOM_GetLinesInternalP12Il2CppObjectS0_,__ZN2UIL31GenerateRenderableUIInstructionEPNS_28PreprocessUIInstructionsDataEj,__Z39CanvasGroup_Set_Custom_PropInteractableP12Il2CppObjecth,__Z41CanvasGroup_Set_Custom_PropBlocksRaycastsP12Il2CppObjecth,__Z45CanvasGroup_Set_Custom_PropIgnoreParentGroupsP12Il2CppObjecth,__Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectRK10ColorRGBAf,__Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectR10ColorRGBAf,__Z36CanvasRenderer_Set_Custom_PropIsMaskP12Il2CppObjecth,__Z54CanvasRenderer_CUSTOM_INTERNAL_CALL_EnableRectClippingP12Il2CppObjectRK5RectTIfE,__Z47CanvasRenderer_Set_Custom_PropHasPopInstructionP12Il2CppObjecth,__Z43CanvasRenderer_Set_Custom_PropMaterialCountP12Il2CppObjecti,__Z46CanvasRenderer_Set_Custom_PropPopMaterialCountP12Il2CppObjecti,__Z32CanvasRenderer_CUSTOM_SetTextureP12Il2CppObjectS0_,__Z37CanvasRenderer_CUSTOM_SetAlphaTextureP12Il2CppObjectS0_,__Z29CanvasRenderer_CUSTOM_SetMeshP12Il2CppObjectS0_,__Z50CanvasRenderer_CUSTOM_SplitIndiciesStreamsInternalP12Il2CppObjectS0_,__Z34CanvasRenderer_Set_Custom_PropCullP12Il2CppObjecth,__Z32Canvas_Set_Custom_PropRenderModeP12Il2CppObjectN2UI6Canvas10RenderModeE,__Z33Canvas_Set_Custom_PropWorldCameraP12Il2CppObjectS0_,__Z36Canvas_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE,__Z42Canvas_Set_Custom_PropOverridePixelPerfectP12Il2CppObjecth,__Z34Canvas_Set_Custom_PropPixelPerfectP12Il2CppObjecth,__Z37Canvas_Set_Custom_PropOverrideSortingP12Il2CppObjecth
,__Z34Canvas_Set_Custom_PropSortingOrderP12Il2CppObjecti,__Z35Canvas_Set_Custom_PropTargetDisplayP12Il2CppObjecti,__Z47Canvas_Set_Custom_PropSortingGridNormalizedSizeP12Il2CppObjecti,__Z36Canvas_Set_Custom_PropSortingLayerIDP12Il2CppObjecti,__Z38Canvas_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString,__Z42TerrainCollider_Set_Custom_PropTerrainDataP12Il2CppObjectS0_,__Z17Event_CUSTOM_InitP12Il2CppObjecti,__Z21Event_CUSTOM_InitCopyP12Il2CppObjectS0_,__Z20Event_CUSTOM_InitPtrP12Il2CppObject13Il2Cpp_IntPtr,__Z25Event_Set_Custom_PropTypeP12Il2CppObjecti,__Z52Event_CUSTOM_INTERNAL_CALL_Internal_SetMousePositionP12Il2CppObjectRK13Vector2fIcall,__Z38Event_CUSTOM_Internal_GetMousePositionP12Il2CppObjectP13Vector2fIcall,__Z49Event_CUSTOM_INTERNAL_CALL_Internal_SetMouseDeltaP12Il2CppObjectRK13Vector2fIcall,__Z35Event_CUSTOM_Internal_GetMouseDeltaP12Il2CppObjectP13Vector2fIcall,__Z27Event_Set_Custom_PropButtonP12Il2CppObjecti,__Z30Event_Set_Custom_PropModifiersP12Il2CppObjecti,__Z31Event_Set_Custom_PropClickCountP12Il2CppObjecti,__Z30Event_Set_Custom_PropCharacterP12Il2CppObjectt,__Z32Event_Set_Custom_PropCommandNameP12Il2CppObjectP12Il2CppString,__Z28Event_Set_Custom_PropKeyCodeP12Il2CppObjecti,__Z33Event_Set_Custom_PropDisplayIndexP12Il2CppObjecti,__Z60GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_GetWindowRectiR5RectTIfE,__Z57GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_MoveWindowiRK5RectTIfE,__Z42GUIStyleState_CUSTOM_SetBackgroundInternalP12Il2CppObjectS0_,__Z43GUIStyleState_CUSTOM_INTERNAL_get_textColorP12Il2CppObjectP10ColorRGBAf,__Z43GUIStyleState_CUSTOM_INTERNAL_set_textColorP12Il2CppObjectRK10ColorRGBAf,__Z24GUIStyle_CUSTOM_InitCopyP12Il2CppObjectS0_,__Z28GUIStyle_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString,__Z37GUIStyle_Set_Custom_PropImagePositionP12Il2CppObjecti,__Z33GUIStyle_Set_Custom_PropAlignmentP12Il2CppObjecti
,__Z32GUIStyle_Set_Custom_PropWordWrapP12Il2CppObjecth,__Z32GUIStyle_Set_Custom_PropClippingP12Il2CppObjecti,__Z42GUIStyle_CUSTOM_INTERNAL_get_contentOffsetP12Il2CppObjectP13Vector2fIcall,__Z42GUIStyle_CUSTOM_INTERNAL_set_contentOffsetP12Il2CppObjectRK13Vector2fIcall,__Z48GUIStyle_CUSTOM_INTERNAL_get_Internal_clipOffsetP12Il2CppObjectP13Vector2fIcall,__Z48GUIStyle_CUSTOM_INTERNAL_set_Internal_clipOffsetP12Il2CppObjectRK13Vector2fIcall,__Z36GUIStyle_Set_Custom_PropStretchWidthP12Il2CppObjecth,__Z37GUIStyle_Set_Custom_PropStretchHeightP12Il2CppObjecth,__Z31GUIStyle_CUSTOM_SetFontInternalP12Il2CppObjectS0_,__Z32GUIStyle_Set_Custom_PropFontSizeP12Il2CppObjecti,__Z33GUIStyle_Set_Custom_PropFontStyleP12Il2CppObjecti,__Z32GUIStyle_Set_Custom_PropRichTextP12Il2CppObjecth,__Z29GUIStyle_CUSTOM_Internal_DrawP12Il2CppObjectR26MonoInternal_DrawArguments,__Z46GUIStyle_CUSTOM_Internal_DrawWithTextSelectionP12Il2CppObjectR43MonoInternal_DrawWithTextSelectionArguments,__Z44DownloadHandler_CUSTOM_InternalCreateTextureP12Il2CppObjecth,__Z58DownloadHandlerScript_CUSTOM_InternalSetPreallocatedBufferP12Il2CppObjectP11Il2CppArray,__Z38UploadHandler_CUSTOM_InternalCreateRawP12Il2CppObjectP11Il2CppArray,__Z46UploadHandlerRaw_CUSTOM_InternalSetContentTypeP12Il2CppObjectP12Il2CppString,__Z40UnityWebRequest_CUSTOM_InternalSetMethodP12Il2CppObject21UnityWebRequestMethod,__Z46UnityWebRequest_CUSTOM_InternalSetCustomMethodP12Il2CppObjectP12Il2CppString,__Z46UnityWebRequest_Set_Custom_PropUseHttpContinueP12Il2CppObjecth,__Z37UnityWebRequest_CUSTOM_InternalSetUrlP12Il2CppObjectP12Il2CppString,__Z44UnityWebRequest_Set_Custom_PropRedirectLimitP12Il2CppObjecti,__Z46UnityWebRequest_Set_Custom_PropChunkedTransferP12Il2CppObjecth,__Z44UnityWebRequest_Set_Custom_PropUploadHandlerP12Il2CppObjectS0_,__Z46UnityWebRequest_Set_Custom_PropDownloadHandlerP12Il2CppObjectS0_,__ZL12InvokeMethodI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI8JSONReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI8JSONReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI8JSONReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL12InvokeMethodI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z30TransferField_LinearCollectionI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI9JSONWriteLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z15Transfer_StringI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo
,__Z18Transfer_BlittableI9JSONWriteLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z18Transfer_BlittableI9JSONWriteLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL17Transfer_GUIStyleI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z26Transfer_UnityEngineObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__ZL22Transfer_ManagedObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo,__Z36JsonUtility_CUSTOM_FromJsonOverwriteP12Il2CppStringP12Il2CppObject,__Z37CustomEventData_CUSTOM_InternalCreateP12Il2CppObjectP12Il2CppString,__ZN19UnityConnectService20OnPlayerPausedStaticEPS_b,__Z42UnityAdsSettings_CUSTOM_SetPlatformEnabledih,__Z33UnityAdsSettings_CUSTOM_SetGameIdiP12Il2CppString,__Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalPositioniR8Vector3f,__Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalRotationiR11Quaternionf,__Z29CleanupParticlesFromNodeQueueR15RenderNodeQueuej,__Z35ParticleEmitter_Set_Custom_PropEmitP12Il2CppObjecth,__Z49ParticleEmitter_CUSTOM_INTERNAL_get_worldVelocityP12Il2CppObjectP8Vector3f,__Z49ParticleEmitter_CUSTOM_INTERNAL_set_worldVelocityP12Il2CppObjectRK8Vector3f,__Z49ParticleEmitter_CUSTOM_INTERNAL_get_localVelocityP12Il2CppObjectP8Vector3f
,__Z49ParticleEmitter_CUSTOM_INTERNAL_set_localVelocityP12Il2CppObjectRK8Vector3f,__Z47ParticleEmitter_CUSTOM_INTERNAL_get_rndVelocityP12Il2CppObjectP8Vector3f,__Z47ParticleEmitter_CUSTOM_INTERNAL_set_rndVelocityP12Il2CppObjectRK8Vector3f,__Z44ParticleEmitter_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth,__Z42ParticleEmitter_Set_Custom_PropRndRotationP12Il2CppObjecth,__Z40ParticleEmitter_Set_Custom_PropParticlesP12Il2CppObjectP11Il2CppArray,__Z28ParticleEmitter_CUSTOM_Emit2P12Il2CppObjecti,__Z28ParticleEmitter_CUSTOM_Emit3P12Il2CppObjectR33MonoInternalEmitParticleArguments,__Z38ParticleEmitter_Set_Custom_PropEnabledP12Il2CppObjecth,__Z48ParticleAnimator_Set_Custom_PropDoesAnimateColorP12Il2CppObjecth,__Z54ParticleAnimator_CUSTOM_INTERNAL_get_worldRotationAxisP12Il2CppObjectP8Vector3f,__Z54ParticleAnimator_CUSTOM_INTERNAL_set_worldRotationAxisP12Il2CppObjectRK8Vector3f,__Z54ParticleAnimator_CUSTOM_INTERNAL_get_localRotationAxisP12Il2CppObjectP8Vector3f,__Z54ParticleAnimator_CUSTOM_INTERNAL_set_localRotationAxisP12Il2CppObjectRK8Vector3f,__Z45ParticleAnimator_CUSTOM_INTERNAL_get_rndForceP12Il2CppObjectP8Vector3f,__Z45ParticleAnimator_CUSTOM_INTERNAL_set_rndForceP12Il2CppObjectRK8Vector3f,__Z42ParticleAnimator_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f,__Z42ParticleAnimator_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f,__Z44ParticleAnimator_Set_Custom_PropAutodestructP12Il2CppObjecth,__Z46ParticleAnimator_Set_Custom_PropColorAnimationP12Il2CppObjectP11Il2CppArray,__Z50ParticleRenderer_Set_Custom_PropParticleRenderModeP12Il2CppObject18ParticleRenderMode,__Z48ParticleRenderer_Set_Custom_PropUvAnimationXTileP12Il2CppObjecti,__Z48ParticleRenderer_Set_Custom_PropUvAnimationYTileP12Il2CppObjecti,__Z39ParticleRenderer_Set_Custom_PropUvTilesP12Il2CppObjectP11Il2CppArray,_emscripten_glPixelStorei__wrapper,_emscripten_glGetIntegerv__wrapper,_emscripten_glGetFloatv__wrapper,_emscripten_glGetBooleanv__wrapper,_emscripten_glGenTextures__wrapper,_emscripten_glDeleteTextures__wrapper,_emscripten_glBindTexture__wrapper,_emscripten_glGenBuffers__wrapper,_emscripten_glDeleteBuffers__wrapper,_emscripten_glGenRenderbuffers__wrapper,_emscripten_glDeleteRenderbuffers__wrapper,_emscripten_glBindRenderbuffer__wrapper,_emscripten_glUniform1i__wrapper,_emscripten_glBindBuffer__wrapper,_emscripten_glVertexAttrib1fv__wrapper,_emscripten_glVertexAttrib2fv__wrapper,_emscripten_glVertexAttrib3fv__wrapper,_emscripten_glVertexAttrib4fv__wrapper,_emscripten_glAttachShader__wrapper,_emscripten_glDetachShader__wrapper,_emscripten_glBindFramebuffer__wrapper,_emscripten_glGenFramebuffers__wrapper,_emscripten_glDeleteFramebuffers__wrapper,_emscripten_glBindProgramARB__wrapper,_emscripten_glGetPointerv__wrapper,_emscripten_glGenVertexArrays__wrapper,_emscripten_glDeleteVertexArrays__wrapper,_emscripten_glVertexAttribDivisor__wrapper,_emscripten_glBlendFunc__wrapper,_emscripten_glBlendEquationSeparate__wrapper,_emscripten_glStencilMaskSeparate__wrapper,_emscripten_glHint__wrapper,_emscripten_glDrawBuffers__wrapper,__ZNSt3__220__throw_system_errorEiPKc,__ZNSt3__28__c_node5__addEPNS_8__i_nodeE,__ZNSt3__28__c_node8__removeEPNS_8__i_nodeE
,__ZNSt3__212future_errorC2ENS_10error_codeE,__ZNSt11logic_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE,__ZNSt3__215__thread_struct27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE,__ZNSt3__217__assoc_sub_state10__sub_waitERNS_11unique_lockINS_5mutexEEE,__ZNSt3__217__assoc_sub_state13set_exceptionESt13exception_ptr,__ZNSt3__217__assoc_sub_state28set_exception_at_thread_exitESt13exception_ptr,__ZNSt13runtime_errorC2EPKc,__ZNSt3__28ios_base16__call_callbacksENS0_5eventE,__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_,__ZNSt3__28ios_base5clearEj,__ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_,__ZNSt3__28ios_base4initEPv,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj,__ZNSt3__218__time_get_storageIcEC2EPKc,__ZNSt3__215__time_get_tempIcEC2EPKc,__ZNSt3__218__time_get_storageIcE4initERKNS_5ctypeIcEE,__ZNSt13runtime_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE,__ZNSt3__218__time_get_storageIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__215__time_get_tempIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__218__time_get_storageIwEC2EPKc,__ZNSt3__215__time_get_tempIwEC2EPKc,__ZNSt3__218__time_get_storageIwE4initERKNS_5ctypeIwEE,__ZNSt3__218__time_get_storageIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__215__time_get_tempIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__210__time_putC2EPKc,__ZNSt3__210__time_putC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__217moneypunct_bynameIcLb0EE4initEPKc
,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_,__ZNSt3__217moneypunct_bynameIcLb1EE4initEPKc,__ZNSt3__217moneypunct_bynameIwLb0EE4initEPKc,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_,__ZNSt3__217moneypunct_bynameIwLb1EE4initEPKc,__ZNSt11logic_errorC2EPKc,__ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej,__ZNSt3__26locale5__imp7installINS_7collateIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7collateIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_5ctypeIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_5ctypeIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_,__ZNSt3__27codecvtIwc11__mbstate_tEC2Ej,__ZNSt3__26locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8numpunctIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8numpunctIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_
,__ZNSt3__26locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8messagesIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_8messagesIwEEEEvPT_,__ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj,__ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj,__ZNSt3__26locale5__imp7installINS_14collate_bynameIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_14collate_bynameIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_12ctype_bynameIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_12ctype_bynameIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_14codecvt_bynameIcc11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_14codecvt_bynameIwc11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDsc11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDic11__mbstate_tEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15numpunct_bynameIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15numpunct_bynameIwEEEEvPT_,__ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb0EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb1EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb0EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb1EEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15messages_bynameIcEEEEvPT_,__ZNSt3__26locale5__imp7installINS_15messages_bynameIwEEEEvPT_,__ZNSt3__215numpunct_bynameIcE6__initEPKc,__ZNSt3__215numpunct_bynameIwE6__initEPKc
,__ZNSt3__26locale5__imp12install_fromINS_7collateIcEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7collateIwEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_5ctypeIcEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_5ctypeIwEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7codecvtIcc11__mbstate_tEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7codecvtIDsc11__mbstate_tEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7codecvtIDic11__mbstate_tEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7codecvtIwc11__mbstate_tEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb0EEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb1EEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb0EEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb1EEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8numpunctIcEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8numpunctIwEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8messagesIcEEEEvRKS1_,__ZNSt3__26locale5__imp12install_fromINS_8messagesIwEEEEvRKS1_,__ZNSt3__218__libcpp_refstringC2EPKc,_abort_message
,__ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEaSERKS7_,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72,b72
,b72,b72,b72];
var FUNCTION_TABLE_iiiifififf = [b73,__Z45Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiff];
var FUNCTION_TABLE_iiiiiifii = [b74,__Z44Physics_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK8Vector3fS1_S1_P11Il2CppArrayRK11Quaternionffi23QueryTriggerInteraction,__Z45Physics_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK8Vector3fS1_RK11QuaternionfS1_P10RaycastHitfi23QueryTriggerInteraction,b74];
var FUNCTION_TABLE_iiifiififf = [b75,__Z46Physics2D_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK13Vector2fIcallS1_fS1_P11Il2CppArrayfiff];
var FUNCTION_TABLE_d = [b76,__Z36AudioSettings_Get_Custom_PropDspTimev];
var FUNCTION_TABLE_viiifififfi = [b77,__Z51Physics2D_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiffP12RaycastHit2D];
var FUNCTION_TABLE_viifii = [b78,__Z59Camera_CUSTOM_INTERNAL_CALL_CalculateFrustumCornersInternalP12Il2CppObjectRK5RectTIfEf21MonoOrStereoscopicEyeP11Il2CppArray];
var FUNCTION_TABLE_fi = [b79,__ZNK13EmscriptenWWW11GetProgressEv,__ZNK13EmscriptenWWW17GetUploadProgressEv,__ZNK13ScreenManager6GetDPIEv,__ZN23PreloadManagerOperation11GetProgressEv,__ZN39AssetBundleLoadFromStreamAsyncOperation11GetProgressEv,__ZNK9WWWCached11GetProgressEv,__ZNK9WWWCached17GetUploadProgressEv,__ZN24UserAuthorizationManager33UserAuthorizationManagerOperation11GetProgressEv,__ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation11GetProgressEv,__ZNK22ParticleSystemRenderer15GetSortingFudgeEv,__ZNK5physx3Cct13BoxController13getStepOffsetEv,__ZNK5physx3Cct13BoxController16getContactOffsetEv,__ZNK5physx3Cct13BoxController13getSlopeLimitEv,__ZNK5physx3Cct13BoxController13getHalfHeightEv,__ZNK5physx3Cct13BoxController17getHalfSideExtentEv,__ZNK5physx3Cct13BoxController20getHalfForwardExtentEv,__ZNK5physx3Cct13BoxController21getHalfHeightInternalEv,__ZThn8_NK5physx3Cct13BoxController21getHalfHeightInternalEv,__ZNK5physx3Cct17CapsuleController13getStepOffsetEv,__ZNK5physx3Cct17CapsuleController16getContactOffsetEv,__ZNK5physx3Cct17CapsuleController13getSlopeLimitEv,__ZNK5physx3Cct17CapsuleController9getRadiusEv,__ZNK5physx3Cct17CapsuleController9getHeightEv,__ZNK5physx3Cct17CapsuleController21getHalfHeightInternalEv,__ZThn8_NK5physx3Cct17CapsuleController21getHalfHeightInternalEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale1Ev
,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext7D6Joint8getTwistEv,__ZNK5physx3Ext7D6Joint14getSwingYAngleEv,__ZNK5physx3Ext7D6Joint14getSwingZAngleEv,__ZNK5physx3Ext7D6Joint28getProjectionLinearToleranceEv,__ZNK5physx3Ext7D6Joint29getProjectionAngularToleranceEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale1Ev,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext13DistanceJoint11getDistanceEv,__ZNK5physx3Ext13DistanceJoint14getMinDistanceEv,__ZNK5physx3Ext13DistanceJoint14getMaxDistanceEv,__ZNK5physx3Ext13DistanceJoint12getToleranceEv,__ZNK5physx3Ext13DistanceJoint12getStiffnessEv,__ZNK5physx3Ext13DistanceJoint10getDampingEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale1Ev,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext10FixedJoint28getProjectionLinearToleranceEv,__ZNK5physx3Ext10FixedJoint29getProjectionAngularToleranceEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale1Ev,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext14PrismaticJoint11getPositionEv,__ZNK5physx3Ext14PrismaticJoint11getVelocityEv,__ZNK5physx3Ext14PrismaticJoint28getProjectionLinearToleranceEv,__ZNK5physx3Ext14PrismaticJoint29getProjectionAngularToleranceEv
,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale1Ev,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext13RevoluteJoint8getAngleEv,__ZNK5physx3Ext13RevoluteJoint11getVelocityEv,__ZNK5physx3Ext13RevoluteJoint16getDriveVelocityEv,__ZNK5physx3Ext13RevoluteJoint18getDriveForceLimitEv,__ZNK5physx3Ext13RevoluteJoint17getDriveGearRatioEv,__ZNK5physx3Ext13RevoluteJoint28getProjectionLinearToleranceEv,__ZNK5physx3Ext13RevoluteJoint29getProjectionAngularToleranceEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale0Ev,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale0Ev,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale1Ev,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale1Ev,__ZNK5physx3Ext14SphericalJoint28getProjectionLinearToleranceEv,__ZNK5physx14NpArticulation22getSeparationToleranceEv,__ZNK5physx14NpArticulation17getSleepThresholdEv,__ZNK5physx14NpArticulation25getStabilizationThresholdEv,__ZNK5physx14NpArticulation14getWakeCounterEv,__ZNK5physx19NpArticulationJoint12getStiffnessEv,__ZNK5physx19NpArticulationJoint10getDampingEv,__ZNK5physx19NpArticulationJoint21getInternalComplianceEv,__ZNK5physx19NpArticulationJoint21getExternalComplianceEv,__ZNK5physx19NpArticulationJoint22getTangentialStiffnessEv,__ZNK5physx19NpArticulationJoint20getTangentialDampingEv,__ZNK5physx19NpArticulationJoint28getSwingLimitContactDistanceEv,__ZNK5physx19NpArticulationJoint28getTwistLimitContactDistanceEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7getMassEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE10getInvMassEv
,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMinCCDAdvanceCoefficientEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMaxDepenetrationVelocityEv,__ZNK5physx12NpConstraint23getMinResponseThresholdEv,__ZNK5physx10NpMaterial18getDynamicFrictionEv,__ZNK5physx10NpMaterial17getStaticFrictionEv,__ZNK5physx10NpMaterial14getRestitutionEv,__ZNK5physx7NpShape16getContactOffsetEv,__ZNK5physx7NpShape13getRestOffsetEv,__ZNK5physx7NpCloth18getSolverFrequencyEv,__ZNK5physx7NpCloth19getPreviousTimeStepEv,__ZNK5physx7NpCloth21getStiffnessFrequencyEv,__ZNK5physx7NpCloth22getFrictionCoefficientEv,__ZNK5physx7NpCloth21getCollisionMassScaleEv,__ZNK5physx7NpCloth24getSelfCollisionDistanceEv,__ZNK5physx7NpCloth25getSelfCollisionStiffnessEv,__ZNK5physx7NpCloth16getContactOffsetEv,__ZNK5physx7NpCloth13getRestOffsetEv,__ZNK5physx7NpCloth22getSleepLinearVelocityEv,__ZNK5physx7NpCloth14getWakeCounterEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10getDampingEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getParticleMassEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getRestitutionEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getDynamicFrictionEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17getStaticFrictionEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getMaxMotionDistanceEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13getRestOffsetEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16getContactOffsetEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11getGridSizeEv,__ZNK5physx15NpParticleFluid12getStiffnessEv,__ZNK5physx15NpParticleFluid12getViscosityEv
,__ZNK5physx15NpParticleFluid23getRestParticleDistanceEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10getDampingEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getParticleMassEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getRestitutionEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getDynamicFrictionEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17getStaticFrictionEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getMaxMotionDistanceEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13getRestOffsetEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16getContactOffsetEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11getGridSizeEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7getMassEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE10getInvMassEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMinCCDAdvanceCoefficientEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMaxDepenetrationVelocityEv,__ZNK5physx14NpRigidDynamic16getLinearDampingEv,__ZNK5physx14NpRigidDynamic17getAngularDampingEv,__ZNK5physx14NpRigidDynamic21getMaxAngularVelocityEv,__ZNK5physx14NpRigidDynamic17getSleepThresholdEv,__ZNK5physx14NpRigidDynamic25getStabilizationThresholdEv,__ZNK5physx14NpRigidDynamic14getWakeCounterEv,__ZNK5physx14NpRigidDynamic25getContactReportThresholdEv,__ZNK5physx7NpScene30getClothInterCollisionDistanceEv,__ZNK5physx7NpScene31getClothInterCollisionStiffnessEv,__ZNK5physx7NpScene26getBounceThresholdVelocityEv,__ZNK5physx7NpScene29getContactCorrelationDistanceEv,__ZNK5physx7NpScene26getFrictionOffsetThresholdEv,__ZNK5physx7NpScene20getMeshContactMarginEv,__ZNK5physx7NpScene24getWakeCounterResetValueEv,__ZNK5physx2Gu11HeightField12getThicknessEv,__ZNK5physx2Gu11HeightField22getConvexEdgeThresholdEv
,__ZNK5physx20PxsParticleSystemSim22getSimulationTimeStepVEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv,__ZNK5physx5cloth8SwSolver25getInterCollisionDistanceEv,__ZNK5physx5cloth8SwSolver26getInterCollisionStiffnessEv,__ZThn4_NK5physx5cloth8SwSolver25getInterCollisionDistanceEv
,__ZThn4_NK5physx5cloth8SwSolver26getInterCollisionStiffnessEv,__ZNK13AnimationClip18GetAverageDurationEv,__ZNK13AnimationClip22GetAverageAngularSpeedEv,__ZNK13AnimationClip16GetApparentSpeedEv,__ZNK26DownloadHandlerAssetBundle11GetProgressEv,__ZNK24DownloadHandlerAudioClip11GetProgressEv,__ZNK21DownloadHandlerBuffer11GetProgressEv,__ZNK21DownloadHandlerScript11GetProgressEv,__ZNK22DownloadHandlerTexture11GetProgressEv,__ZNK18DownloadHandlerVFS11GetProgressEv,__ZNK16UploadHandlerRaw11GetProgressEv,__ZNK25UnityWebRequestJavaScript19GetDownloadProgressEv,__ZNK25UnityWebRequestJavaScript17GetUploadProgressEv,__ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19GetDownloadProgressEv,__ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE17GetUploadProgressEv,__ZN29UnityWebRequestAsyncOperation11GetProgressEv,__ZNK8VRDevice14GetFieldOfViewEv,__ZNK8VRDevice9GetAspectEv,__ZNK8VRDevice19GetStereoSeparationEv,__ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13GetFloatValueEPv,__Z50Application_CUSTOM_GetStreamProgressForLevelByNameP12Il2CppString,__Z44Application_CUSTOM_GetStreamProgressForLeveli,__Z38AsyncOperation_Get_Custom_PropProgressP12Il2CppObject,__Z35BillboardAsset_Get_Custom_PropWidthP12Il2CppObject,__Z36BillboardAsset_Get_Custom_PropHeightP12Il2CppObject,__Z36BillboardAsset_Get_Custom_PropBottomP12Il2CppObject,__Z33Camera_Get_Custom_PropFieldOfViewP12Il2CppObject,__Z35Camera_Get_Custom_PropNearClipPlaneP12Il2CppObject,__Z34Camera_Get_Custom_PropFarClipPlaneP12Il2CppObject,__Z38Camera_Get_Custom_PropOrthographicSizeP12Il2CppObject
,__Z27Camera_Get_Custom_PropDepthP12Il2CppObject,__Z28Camera_Get_Custom_PropAspectP12Il2CppObject,__Z38Camera_Get_Custom_PropStereoSeparationP12Il2CppObject,__Z39Camera_Get_Custom_PropStereoConvergenceP12Il2CppObject,__Z35LensFlare_Get_Custom_PropBrightnessP12Il2CppObject,__Z34LensFlare_Get_Custom_PropFadeSpeedP12Il2CppObject,__Z38Projector_Get_Custom_PropNearClipPlaneP12Il2CppObject,__Z37Projector_Get_Custom_PropFarClipPlaneP12Il2CppObject,__Z36Projector_Get_Custom_PropFieldOfViewP12Il2CppObject,__Z36Projector_Get_Custom_PropAspectRatioP12Il2CppObject,__Z41Projector_Get_Custom_PropOrthographicSizeP12Il2CppObject,__Z33TrailRenderer_Get_Custom_PropTimeP12Il2CppObject,__Z39TrailRenderer_Get_Custom_PropStartWidthP12Il2CppObject,__Z37TrailRenderer_Get_Custom_PropEndWidthP12Il2CppObject,__Z44TrailRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject,__Z46TrailRenderer_Get_Custom_PropMinVertexDistanceP12Il2CppObject,__Z38LineRenderer_Get_Custom_PropStartWidthP12Il2CppObject,__Z36LineRenderer_Get_Custom_PropEndWidthP12Il2CppObject,__Z43LineRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject,__Z43Gyroscope_CUSTOM_getUpdateInterval_Internali,__Z38Compass_Get_Custom_PropMagneticHeadingP12Il2CppObject,__Z34Compass_Get_Custom_PropTrueHeadingP12Il2CppObject,__Z38Compass_Get_Custom_PropHeadingAccuracyP12Il2CppObject,__Z20Input_CUSTOM_GetAxisP12Il2CppString,__Z23Input_CUSTOM_GetAxisRawP12Il2CppString,__Z28LODGroup_Get_Custom_PropSizeP12Il2CppObject,__Z30Light_Get_Custom_PropIntensityP12Il2CppObject,__Z36Light_Get_Custom_PropBounceIntensityP12Il2CppObject,__Z35Light_Get_Custom_PropShadowStrengthP12Il2CppObject,__Z31Light_Get_Custom_PropShadowBiasP12Il2CppObject
,__Z37Light_Get_Custom_PropShadowNormalBiasP12Il2CppObject,__Z36Light_Get_Custom_PropShadowNearPlaneP12Il2CppObject,__Z35Light_Get_Custom_PropShadowSoftnessP12Il2CppObject,__Z39Light_Get_Custom_PropShadowSoftnessFadeP12Il2CppObject,__Z26Light_Get_Custom_PropRangeP12Il2CppObject,__Z30Light_Get_Custom_PropSpotAngleP12Il2CppObject,__Z31Light_Get_Custom_PropCookieSizeP12Il2CppObject,__Z49LightProbeProxyVolume_Get_Custom_PropProbeDensityP12Il2CppObject,__Z42Matrix4x4_CUSTOM_INTERNAL_CALL_DeterminantRK10Matrix4x4f,__Z24Mathf_CUSTOM_HalfToFloatt,__Z37Motion_Get_Custom_PropAverageDurationP12Il2CppObject,__Z41Motion_Get_Custom_PropAverageAngularSpeedP12Il2CppObject,__Z35Motion_Get_Custom_PropApparentSpeedP12Il2CppObject,__Z44ReflectionProbe_Get_Custom_PropNearClipPlaneP12Il2CppObject,__Z43ReflectionProbe_Get_Custom_PropFarClipPlaneP12Il2CppObject,__Z45ReflectionProbe_Get_Custom_PropShadowDistanceP12Il2CppObject,__Z40ReflectionProbe_Get_Custom_PropIntensityP12Il2CppObject,__Z44ReflectionProbe_Get_Custom_PropBlendDistanceP12Il2CppObject,__Z28Shader_CUSTOM_GetGlobalFloati,__Z35Sprite_Get_Custom_PropPixelsPerUnitP12Il2CppObject,__Z33Texture_Get_Custom_PropMipMapBiasP12Il2CppObject,__Z27WWW_Get_Custom_PropProgressP12Il2CppObject,__Z33WWW_Get_Custom_PropUploadProgressP12Il2CppObject,__Z30WindZone_Get_Custom_PropRadiusP12Il2CppObject,__Z32WindZone_Get_Custom_PropWindMainP12Il2CppObject,__Z38WindZone_Get_Custom_PropWindTurbulenceP12Il2CppObject,__Z42WindZone_Get_Custom_PropWindPulseMagnitudeP12Il2CppObject,__Z42WindZone_Get_Custom_PropWindPulseFrequencyP12Il2CppObject,__Z44ParticleSystem_MainModule_CUSTOM_GetDurationP12Il2CppObject,__Z56ParticleSystem_MainModule_CUSTOM_GetStartDelayMultiplierP12Il2CppObject
,__Z59ParticleSystem_MainModule_CUSTOM_GetStartLifetimeMultiplierP12Il2CppObject,__Z56ParticleSystem_MainModule_CUSTOM_GetStartSpeedMultiplierP12Il2CppObject,__Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeXMultiplierP12Il2CppObject,__Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeYMultiplierP12Il2CppObject,__Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeZMultiplierP12Il2CppObject,__Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationXMultiplierP12Il2CppObject,__Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationYMultiplierP12Il2CppObject,__Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationZMultiplierP12Il2CppObject,__Z62ParticleSystem_MainModule_CUSTOM_GetRandomizeRotationDirectionP12Il2CppObject,__Z61ParticleSystem_MainModule_CUSTOM_GetGravityModifierMultiplierP12Il2CppObject,__Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpeedP12Il2CppObject,__Z62ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeMultiplierP12Il2CppObject,__Z66ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceMultiplierP12Il2CppObject,__Z58ParticleSystem_ShapeModule_CUSTOM_GetRandomDirectionAmountP12Il2CppObject,__Z61ParticleSystem_ShapeModule_CUSTOM_GetSphericalDirectionAmountP12Il2CppObject,__Z43ParticleSystem_ShapeModule_CUSTOM_GetRadiusP12Il2CppObject,__Z42ParticleSystem_ShapeModule_CUSTOM_GetAngleP12Il2CppObject,__Z43ParticleSystem_ShapeModule_CUSTOM_GetLengthP12Il2CppObject,__Z49ParticleSystem_ShapeModule_CUSTOM_GetNormalOffsetP12Il2CppObject,__Z46ParticleSystem_ShapeModule_CUSTOM_GetMeshScaleP12Il2CppObject,__Z40ParticleSystem_ShapeModule_CUSTOM_GetArcP12Il2CppObject,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeMultiplierP12Il2CppObject,__Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetDampenP12Il2CppObject,__Z62ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveMultiplierP12Il2CppObject
,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject,__Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject,__Z56ParticleSystem_ExternalForcesModule_CUSTOM_GetMultiplierP12Il2CppObject,__Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthXMultiplierP12Il2CppObject,__Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthYMultiplierP12Il2CppObject,__Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthZMultiplierP12Il2CppObject,__Z46ParticleSystem_NoiseModule_CUSTOM_GetFrequencyP12Il2CppObject,__Z53ParticleSystem_NoiseModule_CUSTOM_GetOctaveMultiplierP12Il2CppObject,__Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveScaleP12Il2CppObject,__Z58ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedMultiplierP12Il2CppObject,__Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapXMultiplierP12Il2CppObject,__Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapYMultiplierP12Il2CppObject,__Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapZMultiplierP12Il2CppObject,__Z57ParticleSystem_CollisionModule_CUSTOM_GetDampenMultiplierP12Il2CppObject,__Z57ParticleSystem_CollisionModule_CUSTOM_GetBounceMultiplierP12Il2CppObject,__Z63ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossMultiplierP12Il2CppObject,__Z53ParticleSystem_CollisionModule_CUSTOM_GetMinKillSpeedP12Il2CppObject
,__Z53ParticleSystem_CollisionModule_CUSTOM_GetMaxKillSpeedP12Il2CppObject,__Z50ParticleSystem_CollisionModule_CUSTOM_GetVoxelSizeP12Il2CppObject,__Z52ParticleSystem_CollisionModule_CUSTOM_GetRadiusScaleP12Il2CppObject,__Z50ParticleSystem_TriggerModule_CUSTOM_GetRadiusScaleP12Il2CppObject,__Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeMultiplierP12Il2CppObject,__Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameMultiplierP12Il2CppObject,__Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipUP12Il2CppObject,__Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipVP12Il2CppObject,__Z43ParticleSystem_LightsModule_CUSTOM_GetRatioP12Il2CppObject,__Z53ParticleSystem_LightsModule_CUSTOM_GetRangeMultiplierP12Il2CppObject,__Z57ParticleSystem_LightsModule_CUSTOM_GetIntensityMultiplierP12Il2CppObject,__Z42ParticleSystem_TrailModule_CUSTOM_GetRatioP12Il2CppObject,__Z55ParticleSystem_TrailModule_CUSTOM_GetLifetimeMultiplierP12Il2CppObject,__Z54ParticleSystem_TrailModule_CUSTOM_GetMinVertexDistanceP12Il2CppObject,__Z61ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailMultiplierP12Il2CppObject,__Z40ParticleSystem_Get_Custom_PropStartDelayP12Il2CppObject,__Z34ParticleSystem_Get_Custom_PropTimeP12Il2CppObject,__Z38ParticleSystem_Get_Custom_PropDurationP12Il2CppObject,__Z43ParticleSystem_Get_Custom_PropPlaybackSpeedP12Il2CppObject,__Z40ParticleSystem_Get_Custom_PropStartSpeedP12Il2CppObject,__Z39ParticleSystem_Get_Custom_PropStartSizeP12Il2CppObject,__Z43ParticleSystem_Get_Custom_PropStartRotationP12Il2CppObject,__Z43ParticleSystem_Get_Custom_PropStartLifetimeP12Il2CppObject,__Z45ParticleSystem_Get_Custom_PropGravityModifierP12Il2CppObject,__Z49ParticleSystemRenderer_Get_Custom_PropLengthScaleP12Il2CppObject,__Z51ParticleSystemRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject,__Z57ParticleSystemRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject,__Z53ParticleSystemRenderer_Get_Custom_PropNormalDirectionP12Il2CppObject,__Z50ParticleSystemRenderer_Get_Custom_PropSortingFudgeP12Il2CppObject,__Z53ParticleSystemRenderer_Get_Custom_PropMinParticleSizeP12Il2CppObject
,__Z53ParticleSystemRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject,__Z29getPxMaterial_DynamicFrictionPKN5physx10PxMaterialE,__Z28getPxMaterial_StaticFrictionPKN5physx10PxMaterialE,__Z25getPxMaterial_RestitutionPKN5physx10PxMaterialE,__Z24getPxShape_ContactOffsetPKN5physx7PxShapeE,__Z21getPxShape_RestOffsetPKN5physx7PxShapeE,__Z35getPxHeightFieldGeometryHeightScalePKN5physx21PxHeightFieldGeometryE,__Z32getPxHeightFieldGeometryRowScalePKN5physx21PxHeightFieldGeometryE,__Z35getPxHeightFieldGeometryColumnScalePKN5physx21PxHeightFieldGeometryE,__Z26getPxCapsuleGeometryRadiusPKN5physx17PxCapsuleGeometryE,__Z30getPxCapsuleGeometryHalfHeightPKN5physx17PxCapsuleGeometryE,__Z25getPxSphereGeometryRadiusPKN5physx16PxSphereGeometryE,__Z29getPxHeightFieldDescThicknessPKN5physx17PxHeightFieldDescE,__Z39getPxHeightFieldDescConvexEdgeThresholdPKN5physx17PxHeightFieldDescE,__Z31getPxRigidDynamic_LinearDampingPKN5physx14PxRigidDynamicE,__Z32getPxRigidDynamic_AngularDampingPKN5physx14PxRigidDynamicE,__Z36getPxRigidDynamic_MaxAngularVelocityPKN5physx14PxRigidDynamicE,__Z32getPxRigidDynamic_SleepThresholdPKN5physx14PxRigidDynamicE,__Z40getPxRigidDynamic_StabilizationThresholdPKN5physx14PxRigidDynamicE,__Z29getPxRigidDynamic_WakeCounterPKN5physx14PxRigidDynamicE,__Z40getPxRigidDynamic_ContactReportThresholdPKN5physx14PxRigidDynamicE,__Z19getPxRigidBody_MassPKN5physx11PxRigidBodyE,__Z22getPxRigidBody_InvMassPKN5physx11PxRigidBodyE,__Z39getPxRigidBody_MinCCDAdvanceCoefficientPKN5physx11PxRigidBodyE,__Z39getPxRigidBody_MaxDepenetrationVelocityPKN5physx11PxRigidBodyE,__Z32getPxArticulationJoint_StiffnessPKN5physx19PxArticulationJointE,__Z30getPxArticulationJoint_DampingPKN5physx19PxArticulationJointE,__Z41getPxArticulationJoint_InternalCompliancePKN5physx19PxArticulationJointE,__Z41getPxArticulationJoint_ExternalCompliancePKN5physx19PxArticulationJointE,__Z42getPxArticulationJoint_TangentialStiffnessPKN5physx19PxArticulationJointE
,__Z40getPxArticulationJoint_TangentialDampingPKN5physx19PxArticulationJointE,__Z48getPxArticulationJoint_SwingLimitContactDistancePKN5physx19PxArticulationJointE,__Z48getPxArticulationJoint_TwistLimitContactDistancePKN5physx19PxArticulationJointE,__Z37getPxArticulation_SeparationTolerancePKN5physx14PxArticulationE,__Z32getPxArticulation_SleepThresholdPKN5physx14PxArticulationE,__Z40getPxArticulation_StabilizationThresholdPKN5physx14PxArticulationE,__Z29getPxArticulation_WakeCounterPKN5physx14PxArticulationE,__Z31getPxClothTetherConfigStiffnessPKN5physx19PxClothTetherConfigE,__Z34getPxClothTetherConfigStretchLimitPKN5physx19PxClothTetherConfigE,__Z32getPxClothStretchConfigStiffnessPKN5physx20PxClothStretchConfigE,__Z42getPxClothStretchConfigStiffnessMultiplierPKN5physx20PxClothStretchConfigE,__Z39getPxClothStretchConfigCompressionLimitPKN5physx20PxClothStretchConfigE,__Z35getPxClothStretchConfigStretchLimitPKN5physx20PxClothStretchConfigE,__Z37getPxClothMotionConstraintConfigScalePKN5physx29PxClothMotionConstraintConfigE,__Z36getPxClothMotionConstraintConfigBiasPKN5physx29PxClothMotionConstraintConfigE,__Z41getPxClothMotionConstraintConfigStiffnessPKN5physx29PxClothMotionConstraintConfigE,__Z26getPxCloth_SolverFrequencyPKN5physx7PxClothE,__Z27getPxCloth_PreviousTimeStepPKN5physx7PxClothE,__Z29getPxCloth_StiffnessFrequencyPKN5physx7PxClothE,__Z30getPxCloth_FrictionCoefficientPKN5physx7PxClothE,__Z29getPxCloth_CollisionMassScalePKN5physx7PxClothE,__Z32getPxCloth_SelfCollisionDistancePKN5physx7PxClothE,__Z33getPxCloth_SelfCollisionStiffnessPKN5physx7PxClothE,__Z24getPxCloth_ContactOffsetPKN5physx7PxClothE,__Z21getPxCloth_RestOffsetPKN5physx7PxClothE,__Z30getPxCloth_SleepLinearVelocityPKN5physx7PxClothE,__Z22getPxCloth_WakeCounterPKN5physx7PxClothE,__Z36getPxJointLimitParametersRestitutionPKN5physx22PxJointLimitParametersE,__Z40getPxJointLimitParametersBounceThresholdPKN5physx22PxJointLimitParametersE,__Z34getPxJointLimitParametersStiffnessPKN5physx22PxJointLimitParametersE
,__Z32getPxJointLimitParametersDampingPKN5physx22PxJointLimitParametersE,__Z40getPxJointLimitParametersContactDistancePKN5physx22PxJointLimitParametersE,__Z25getPxJointLimitConeYAnglePKN5physx16PxJointLimitConeE,__Z25getPxJointLimitConeZAnglePKN5physx16PxJointLimitConeE,__Z24getPxJoint_InvMassScale0PKN5physx7PxJointE,__Z27getPxJoint_InvInertiaScale0PKN5physx7PxJointE,__Z24getPxJoint_InvMassScale1PKN5physx7PxJointE,__Z27getPxJoint_InvInertiaScale1PKN5physx7PxJointE,__Z45getPxSphericalJoint_ProjectionLinearTolerancePKN5physx16PxSphericalJointE,__Z31getPxJointAngularLimitPairUpperPKN5physx23PxJointAngularLimitPairE,__Z31getPxJointAngularLimitPairLowerPKN5physx23PxJointAngularLimitPairE,__Z24getPxRevoluteJoint_AnglePKN5physx15PxRevoluteJointE,__Z27getPxRevoluteJoint_VelocityPKN5physx15PxRevoluteJointE,__Z32getPxRevoluteJoint_DriveVelocityPKN5physx15PxRevoluteJointE,__Z34getPxRevoluteJoint_DriveForceLimitPKN5physx15PxRevoluteJointE,__Z33getPxRevoluteJoint_DriveGearRatioPKN5physx15PxRevoluteJointE,__Z44getPxRevoluteJoint_ProjectionLinearTolerancePKN5physx15PxRevoluteJointE,__Z45getPxRevoluteJoint_ProjectionAngularTolerancePKN5physx15PxRevoluteJointE,__Z30getPxJointLinearLimitPairUpperPKN5physx22PxJointLinearLimitPairE,__Z30getPxJointLinearLimitPairLowerPKN5physx22PxJointLinearLimitPairE,__Z28getPxPrismaticJoint_PositionPKN5physx16PxPrismaticJointE,__Z28getPxPrismaticJoint_VelocityPKN5physx16PxPrismaticJointE,__Z45getPxPrismaticJoint_ProjectionLinearTolerancePKN5physx16PxPrismaticJointE,__Z46getPxPrismaticJoint_ProjectionAngularTolerancePKN5physx16PxPrismaticJointE,__Z20getPxSpringStiffnessPKN5physx8PxSpringE,__Z18getPxSpringDampingPKN5physx8PxSpringE,__Z27getPxD6JointDriveForceLimitPKN5physx14PxD6JointDriveE,__Z26getPxJointLinearLimitValuePKN5physx18PxJointLinearLimitE,__Z18getPxD6Joint_TwistPKN5physx9PxD6JointE,__Z24getPxD6Joint_SwingYAnglePKN5physx9PxD6JointE
,__Z24getPxD6Joint_SwingZAnglePKN5physx9PxD6JointE,__Z38getPxD6Joint_ProjectionLinearTolerancePKN5physx9PxD6JointE,__Z39getPxD6Joint_ProjectionAngularTolerancePKN5physx9PxD6JointE,__Z27getPxDistanceJoint_DistancePKN5physx15PxDistanceJointE,__Z30getPxDistanceJoint_MinDistancePKN5physx15PxDistanceJointE,__Z30getPxDistanceJoint_MaxDistancePKN5physx15PxDistanceJointE,__Z28getPxDistanceJoint_TolerancePKN5physx15PxDistanceJointE,__Z28getPxDistanceJoint_StiffnessPKN5physx15PxDistanceJointE,__Z26getPxDistanceJoint_DampingPKN5physx15PxDistanceJointE,__Z41getPxFixedJoint_ProjectionLinearTolerancePKN5physx12PxFixedJointE,__Z42getPxFixedJoint_ProjectionAngularTolerancePKN5physx12PxFixedJointE,__Z28getPxParticleFluid_StiffnessPKN5physx15PxParticleFluidE,__Z28getPxParticleFluid_ViscosityPKN5physx15PxParticleFluidE,__Z39getPxParticleFluid_RestParticleDistancePKN5physx15PxParticleFluidE,__Z25getPxParticleBase_DampingPKN5physx14PxParticleBaseE,__Z30getPxParticleBase_ParticleMassPKN5physx14PxParticleBaseE,__Z29getPxParticleBase_RestitutionPKN5physx14PxParticleBaseE,__Z33getPxParticleBase_DynamicFrictionPKN5physx14PxParticleBaseE,__Z32getPxParticleBase_StaticFrictionPKN5physx14PxParticleBaseE,__Z35getPxParticleBase_MaxMotionDistancePKN5physx14PxParticleBaseE,__Z28getPxParticleBase_RestOffsetPKN5physx14PxParticleBaseE,__Z31getPxParticleBase_ContactOffsetPKN5physx14PxParticleBaseE,__Z26getPxParticleBase_GridSizePKN5physx14PxParticleBaseE,__Z26getPxTolerancesScaleLengthPKN5physx17PxTolerancesScaleE,__Z24getPxTolerancesScaleMassPKN5physx17PxTolerancesScaleE,__Z25getPxTolerancesScaleSpeedPKN5physx17PxTolerancesScaleE,__Z36getPxConstraint_MinResponseThresholdPKN5physx12PxConstraintE,__Z38getPxScene_ClothInterCollisionDistancePKN5physx7PxSceneE,__Z39getPxScene_ClothInterCollisionStiffnessPKN5physx7PxSceneE,__Z34getPxScene_BounceThresholdVelocityPKN5physx7PxSceneE
,__Z37getPxScene_ContactCorrelationDistancePKN5physx7PxSceneE,__Z34getPxScene_FrictionOffsetThresholdPKN5physx7PxSceneE,__Z28getPxScene_MeshContactMarginPKN5physx7PxSceneE,__Z32getPxScene_WakeCounterResetValuePKN5physx7PxSceneE,__Z27getPxClothParticleInvWeightPKN5physx15PxClothParticleE,__Z31getPxSceneDescMeshContactMarginPKN5physx11PxSceneDescE,__Z40getPxSceneDescContactCorrelationDistancePKN5physx11PxSceneDescE,__Z37getPxSceneDescBounceThresholdVelocityPKN5physx11PxSceneDescE,__Z37getPxSceneDescFrictionOffsetThresholdPKN5physx11PxSceneDescE,__Z35getPxSceneDescWakeCounterResetValuePKN5physx11PxSceneDescE,__Z53getPxSimulationStatisticsParticlesGpuMeshCacheHitratePKN5physx22PxSimulationStatisticsE,__Z29Rigidbody_Get_Custom_PropDragP12Il2CppObject,__Z36Rigidbody_Get_Custom_PropAngularDragP12Il2CppObject,__Z29Rigidbody_Get_Custom_PropMassP12Il2CppObject,__Z49Rigidbody_Get_Custom_PropMaxDepenetrationVelocityP12Il2CppObject,__Z38Rigidbody_Get_Custom_PropSleepVelocityP12Il2CppObject,__Z45Rigidbody_Get_Custom_PropSleepAngularVelocityP12Il2CppObject,__Z39Rigidbody_Get_Custom_PropSleepThresholdP12Il2CppObject,__Z43Rigidbody_Get_Custom_PropMaxAngularVelocityP12Il2CppObject,__Z31Joint_Get_Custom_PropBreakForceP12Il2CppObject,__Z32Joint_Get_Custom_PropBreakTorqueP12Il2CppObject,__Z34HingeJoint_Get_Custom_PropVelocityP12Il2CppObject,__Z31HingeJoint_Get_Custom_PropAngleP12Il2CppObject,__Z33SpringJoint_Get_Custom_PropSpringP12Il2CppObject,__Z33SpringJoint_Get_Custom_PropDamperP12Il2CppObject,__Z38SpringJoint_Get_Custom_PropMinDistanceP12Il2CppObject,__Z38SpringJoint_Get_Custom_PropMaxDistanceP12Il2CppObject,__Z36SpringJoint_Get_Custom_PropToleranceP12Il2CppObject,__Z48CharacterJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject,__Z45CharacterJoint_Get_Custom_PropProjectionAngleP12Il2CppObject
,__Z51ConfigurableJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject,__Z48ConfigurableJoint_Get_Custom_PropProjectionAngleP12Il2CppObject,__Z37Collider_Get_Custom_PropContactOffsetP12Il2CppObject,__Z36SphereCollider_Get_Custom_PropRadiusP12Il2CppObject,__Z37MeshCollider_Get_Custom_PropSkinWidthP12Il2CppObject,__Z37CapsuleCollider_Get_Custom_PropRadiusP12Il2CppObject,__Z37CapsuleCollider_Get_Custom_PropHeightP12Il2CppObject,__Z45PhysicMaterial_Get_Custom_PropDynamicFrictionP12Il2CppObject,__Z44PhysicMaterial_Get_Custom_PropStaticFrictionP12Il2CppObject,__Z40PhysicMaterial_Get_Custom_PropBouncinessP12Il2CppObject,__Z46PhysicMaterial_Get_Custom_PropDynamicFriction2P12Il2CppObject,__Z45PhysicMaterial_Get_Custom_PropStaticFriction2P12Il2CppObject,__Z41CharacterController_Get_Custom_PropRadiusP12Il2CppObject,__Z41CharacterController_Get_Custom_PropHeightP12Il2CppObject,__Z45CharacterController_Get_Custom_PropSlopeLimitP12Il2CppObject,__Z45CharacterController_Get_Custom_PropStepOffsetP12Il2CppObject,__Z44CharacterController_Get_Custom_PropSkinWidthP12Il2CppObject,__Z35Rigidbody2D_Get_Custom_PropRotationP12Il2CppObject,__Z42Rigidbody2D_Get_Custom_PropAngularVelocityP12Il2CppObject,__Z31Rigidbody2D_Get_Custom_PropMassP12Il2CppObject,__Z34Rigidbody2D_Get_Custom_PropInertiaP12Il2CppObject,__Z31Rigidbody2D_Get_Custom_PropDragP12Il2CppObject,__Z38Rigidbody2D_Get_Custom_PropAngularDragP12Il2CppObject,__Z39Rigidbody2D_Get_Custom_PropGravityScaleP12Il2CppObject,__Z33Collider2D_Get_Custom_PropDensityP12Il2CppObject,__Z34Collider2D_Get_Custom_PropFrictionP12Il2CppObject,__Z36Collider2D_Get_Custom_PropBouncinessP12Il2CppObject,__Z38CircleCollider2D_Get_Custom_PropRadiusP12Il2CppObject,__Z33Joint2D_Get_Custom_PropBreakForceP12Il2CppObject,__Z34Joint2D_Get_Custom_PropBreakTorqueP12Il2CppObject
,__Z37SpringJoint2D_Get_Custom_PropDistanceP12Il2CppObject,__Z41SpringJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject,__Z38SpringJoint2D_Get_Custom_PropFrequencyP12Il2CppObject,__Z39DistanceJoint2D_Get_Custom_PropDistanceP12Il2CppObject,__Z39FrictionJoint2D_Get_Custom_PropMaxForceP12Il2CppObject,__Z40FrictionJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject,__Z42HingeJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject,__Z38HingeJoint2D_Get_Custom_PropJointAngleP12Il2CppObject,__Z38HingeJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject,__Z39RelativeJoint2D_Get_Custom_PropMaxForceP12Il2CppObject,__Z40RelativeJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject,__Z46RelativeJoint2D_Get_Custom_PropCorrectionScaleP12Il2CppObject,__Z44RelativeJoint2D_Get_Custom_PropAngularOffsetP12Il2CppObject,__Z34SliderJoint2D_Get_Custom_PropAngleP12Il2CppObject,__Z43SliderJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject,__Z45SliderJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject,__Z39SliderJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject,__Z37TargetJoint2D_Get_Custom_PropMaxForceP12Il2CppObject,__Z41TargetJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject,__Z38TargetJoint2D_Get_Custom_PropFrequencyP12Il2CppObject,__Z40FixedJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject,__Z37FixedJoint2D_Get_Custom_PropFrequencyP12Il2CppObject,__Z42FixedJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject,__Z44WheelJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject,__Z38WheelJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject,__Z43PhysicsMaterial2D_Get_Custom_PropBouncinessP12Il2CppObject,__Z41PhysicsMaterial2D_Get_Custom_PropFrictionP12Il2CppObject,__Z37ConstantForce2D_Get_Custom_PropTorqueP12Il2CppObject,__Z40AreaEffector2D_Get_Custom_PropForceAngleP12Il2CppObject,__Z44AreaEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject
,__Z44AreaEffector2D_Get_Custom_PropForceVariationP12Il2CppObject,__Z34AreaEffector2D_Get_Custom_PropDragP12Il2CppObject,__Z41AreaEffector2D_Get_Custom_PropAngularDragP12Il2CppObject,__Z46BuoyancyEffector2D_Get_Custom_PropSurfaceLevelP12Il2CppObject,__Z41BuoyancyEffector2D_Get_Custom_PropDensityP12Il2CppObject,__Z44BuoyancyEffector2D_Get_Custom_PropLinearDragP12Il2CppObject,__Z45BuoyancyEffector2D_Get_Custom_PropAngularDragP12Il2CppObject,__Z43BuoyancyEffector2D_Get_Custom_PropFlowAngleP12Il2CppObject,__Z47BuoyancyEffector2D_Get_Custom_PropFlowMagnitudeP12Il2CppObject,__Z47BuoyancyEffector2D_Get_Custom_PropFlowVariationP12Il2CppObject,__Z45PointEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject,__Z45PointEffector2D_Get_Custom_PropForceVariationP12Il2CppObject,__Z44PointEffector2D_Get_Custom_PropDistanceScaleP12Il2CppObject,__Z35PointEffector2D_Get_Custom_PropDragP12Il2CppObject,__Z42PointEffector2D_Get_Custom_PropAngularDragP12Il2CppObject,__Z44PlatformEffector2D_Get_Custom_PropSurfaceArcP12Il2CppObject,__Z41PlatformEffector2D_Get_Custom_PropSideArcP12Il2CppObject,__Z50PlatformEffector2D_Get_Custom_PropRotationalOffsetP12Il2CppObject,__Z38SurfaceEffector2D_Get_Custom_PropSpeedP12Il2CppObject,__Z47SurfaceEffector2D_Get_Custom_PropSpeedVariationP12Il2CppObject,__Z43SurfaceEffector2D_Get_Custom_PropForceScaleP12Il2CppObject,__Z42getPxVehicleTireLoadFilterData_DenominatorPKN5physx27PxVehicleTireLoadFilterDataE,__Z48getPxVehicleTireLoadFilterDataMMinNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE,__Z56getPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE,__Z48getPxVehicleTireLoadFilterDataMMaxNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE,__Z56getPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE,__Z61getPxVehicleTireData_RecipLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE,__Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx1Minusx0PKN5physx17PxVehicleTireDataE,__Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx2Minusx1PKN5physx17PxVehicleTireDataE,__Z30getPxVehicleTireDataMLatStiffXPKN5physx17PxVehicleTireDataE
,__Z30getPxVehicleTireDataMLatStiffYPKN5physx17PxVehicleTireDataE,__Z56getPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE,__Z50getPxVehicleTireDataMCamberStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE,__Z33getPxVehicleWheelData_RecipRadiusPKN5physx18PxVehicleWheelDataE,__Z30getPxVehicleWheelData_RecipMOIPKN5physx18PxVehicleWheelDataE,__Z28getPxVehicleWheelDataMRadiusPKN5physx18PxVehicleWheelDataE,__Z27getPxVehicleWheelDataMWidthPKN5physx18PxVehicleWheelDataE,__Z26getPxVehicleWheelDataMMassPKN5physx18PxVehicleWheelDataE,__Z25getPxVehicleWheelDataMMOIPKN5physx18PxVehicleWheelDataE,__Z33getPxVehicleWheelDataMDampingRatePKN5physx18PxVehicleWheelDataE,__Z36getPxVehicleWheelDataMMaxBrakeTorquePKN5physx18PxVehicleWheelDataE,__Z40getPxVehicleWheelDataMMaxHandBrakeTorquePKN5physx18PxVehicleWheelDataE,__Z30getPxVehicleWheelDataMMaxSteerPKN5physx18PxVehicleWheelDataE,__Z30getPxVehicleWheelDataMToeAnglePKN5physx18PxVehicleWheelDataE,__Z46getPxVehicleSuspensionData_RecipMaxCompressionPKN5physx23PxVehicleSuspensionDataE,__Z40getPxVehicleSuspensionData_RecipMaxDroopPKN5physx23PxVehicleSuspensionDataE,__Z41getPxVehicleSuspensionDataMSpringStrengthPKN5physx23PxVehicleSuspensionDataE,__Z43getPxVehicleSuspensionDataMSpringDamperRatePKN5physx23PxVehicleSuspensionDataE,__Z41getPxVehicleSuspensionDataMMaxCompressionPKN5physx23PxVehicleSuspensionDataE,__Z35getPxVehicleSuspensionDataMMaxDroopPKN5physx23PxVehicleSuspensionDataE,__Z37getPxVehicleSuspensionDataMSprungMassPKN5physx23PxVehicleSuspensionDataE,__Z39getPxVehicleSuspensionDataMCamberAtRestPKN5physx23PxVehicleSuspensionDataE,__Z49getPxVehicleSuspensionDataMCamberAtMaxCompressionPKN5physx23PxVehicleSuspensionDataE,__Z43getPxVehicleSuspensionDataMCamberAtMaxDroopPKN5physx23PxVehicleSuspensionDataE,__Z48getPxVehicleWheelsSimData_MinLongSlipDenominatorPKN5physx22PxVehicleWheelsSimDataE,__Z44getPxVehicleWheelsSimData_ThresholdLongSpeedPKN5physx22PxVehicleWheelsSimDataE,__Z42getPxVehicleAckermannGeometryDataMAccuracyPKN5physx30PxVehicleAckermannGeometryDataE,__Z44getPxVehicleAckermannGeometryDataMFrontWidthPKN5physx30PxVehicleAckermannGeometryDataE,__Z43getPxVehicleAckermannGeometryDataMRearWidthPKN5physx30PxVehicleAckermannGeometryDataE,__Z48getPxVehicleAckermannGeometryDataMAxleSeparationPKN5physx30PxVehicleAckermannGeometryDataE
,__Z45getPxVehicleDifferential4WDataMFrontRearSplitPKN5physx27PxVehicleDifferential4WDataE,__Z50getPxVehicleDifferential4WDataMFrontLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE,__Z49getPxVehicleDifferential4WDataMRearLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE,__Z41getPxVehicleDifferential4WDataMCentreBiasPKN5physx27PxVehicleDifferential4WDataE,__Z40getPxVehicleDifferential4WDataMFrontBiasPKN5physx27PxVehicleDifferential4WDataE,__Z39getPxVehicleDifferential4WDataMRearBiasPKN5physx27PxVehicleDifferential4WDataE,__Z31getPxVehicleAutoBoxData_LatencyPKN5physx20PxVehicleAutoBoxDataE,__Z31getPxVehicleClutchDataMStrengthPKN5physx19PxVehicleClutchDataE,__Z32getPxVehicleGearsDataMFinalRatioPKN5physx18PxVehicleGearsDataE,__Z32getPxVehicleGearsDataMSwitchTimePKN5physx18PxVehicleGearsDataE,__Z31getPxVehicleEngineData_RecipMOIPKN5physx19PxVehicleEngineDataE,__Z36getPxVehicleEngineData_RecipMaxOmegaPKN5physx19PxVehicleEngineDataE,__Z26getPxVehicleEngineDataMMOIPKN5physx19PxVehicleEngineDataE,__Z33getPxVehicleEngineDataMPeakTorquePKN5physx19PxVehicleEngineDataE,__Z31getPxVehicleEngineDataMMaxOmegaPKN5physx19PxVehicleEngineDataE,__Z46getPxVehicleEngineDataMDampingRateFullThrottlePKN5physx19PxVehicleEngineDataE,__Z59getPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPKN5physx19PxVehicleEngineDataE,__Z62getPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPKN5physx19PxVehicleEngineDataE,__Z44getPxVehicleDriveDynData_EngineRotationSpeedPKN5physx21PxVehicleDriveDynDataE,__Z39getPxVehicleDriveDynData_GearSwitchTimePKN5physx21PxVehicleDriveDynDataE,__Z42getPxVehicleDriveDynData_AutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE,__Z36getPxVehicleDriveDynDataMEnginespeedPKN5physx21PxVehicleDriveDynDataE,__Z39getPxVehicleDriveDynDataMGearSwitchTimePKN5physx21PxVehicleDriveDynDataE,__Z42getPxVehicleDriveDynDataMAutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE,__Z28getPxVehicleChassisDataMMassPKN5physx20PxVehicleChassisDataE,__Z35WheelCollider_Get_Custom_PropRadiusP12Il2CppObject,__Z47WheelCollider_Get_Custom_PropSuspensionDistanceP12Il2CppObject,__Z50WheelCollider_Get_Custom_PropForceAppPointDistanceP12Il2CppObject,__Z33WheelCollider_Get_Custom_PropMassP12Il2CppObject,__Z45WheelCollider_Get_Custom_PropWheelDampingRateP12Il2CppObject
,__Z40WheelCollider_Get_Custom_PropMotorTorqueP12Il2CppObject,__Z40WheelCollider_Get_Custom_PropBrakeTorqueP12Il2CppObject,__Z39WheelCollider_Get_Custom_PropSteerAngleP12Il2CppObject,__Z39WheelCollider_Get_Custom_PropSprungMassP12Il2CppObject,__Z32WheelCollider_Get_Custom_PropRpmP12Il2CppObject,__Z35Cloth_Get_Custom_PropSleepThresholdP12Il2CppObject,__Z37Cloth_Get_Custom_PropBendingStiffnessP12Il2CppObject,__Z40Cloth_Get_Custom_PropStretchingStiffnessP12Il2CppObject,__Z28Cloth_Get_Custom_PropDampingP12Il2CppObject,__Z29Cloth_Get_Custom_PropFrictionP12Il2CppObject,__Z39Cloth_Get_Custom_PropCollisionMassScaleP12Il2CppObject,__Z43Cloth_Get_Custom_PropUseContinuousCollisionP12Il2CppObject,__Z40Cloth_Get_Custom_PropUseVirtualParticlesP12Il2CppObject,__Z39Cloth_Get_Custom_PropWorldVelocityScaleP12Il2CppObject,__Z43Cloth_Get_Custom_PropWorldAccelerationScaleP12Il2CppObject,__Z44NavMeshAgent_Get_Custom_PropStoppingDistanceP12Il2CppObject,__Z45NavMeshAgent_Get_Custom_PropRemainingDistanceP12Il2CppObject,__Z38NavMeshAgent_Get_Custom_PropBaseOffsetP12Il2CppObject,__Z33NavMeshAgent_Get_Custom_PropSpeedP12Il2CppObject,__Z40NavMeshAgent_Get_Custom_PropAngularSpeedP12Il2CppObject,__Z40NavMeshAgent_Get_Custom_PropAccelerationP12Il2CppObject,__Z34NavMeshAgent_Get_Custom_PropRadiusP12Il2CppObject,__Z34NavMeshAgent_Get_Custom_PropHeightP12Il2CppObject,__Z27NavMesh_CUSTOM_GetLayerCosti,__Z26NavMesh_CUSTOM_GetAreaCosti,__Z37NavMeshObstacle_Get_Custom_PropHeightP12Il2CppObject,__Z37NavMeshObstacle_Get_Custom_PropRadiusP12Il2CppObject,__Z51NavMeshObstacle_Get_Custom_PropCarvingMoveThresholdP12Il2CppObject,__Z54NavMeshObstacle_Get_Custom_PropCarvingTimeToStationaryP12Il2CppObject,__Z39OffMeshLink_Get_Custom_PropCostOverrideP12Il2CppObject
,__Z31AudioClip_Get_Custom_PropLengthP12Il2CppObject,__Z33AudioSource_Get_Custom_PropVolumeP12Il2CppObject,__Z32AudioSource_Get_Custom_PropPitchP12Il2CppObject,__Z31AudioSource_Get_Custom_PropTimeP12Il2CppObject,__Z36AudioSource_Get_Custom_PropPanStereoP12Il2CppObject,__Z39AudioSource_Get_Custom_PropSpatialBlendP12Il2CppObject,__Z40AudioSource_Get_Custom_PropReverbZoneMixP12Il2CppObject,__Z39AudioSource_Get_Custom_PropDopplerLevelP12Il2CppObject,__Z33AudioSource_Get_Custom_PropSpreadP12Il2CppObject,__Z38AudioSource_Get_Custom_PropMinDistanceP12Il2CppObject,__Z38AudioSource_Get_Custom_PropMaxDistanceP12Il2CppObject,__Z36AudioSource_Get_Custom_PropMinVolumeP12Il2CppObject,__Z36AudioSource_Get_Custom_PropMaxVolumeP12Il2CppObject,__Z40AudioSource_Get_Custom_PropRolloffFactorP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropMinDistanceP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropMaxDistanceP12Il2CppObject,__Z40AudioReverbZone_Get_Custom_PropDecayTimeP12Il2CppObject,__Z43AudioReverbZone_Get_Custom_PropDecayHFRatioP12Il2CppObject,__Z47AudioReverbZone_Get_Custom_PropReflectionsDelayP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropReverbDelayP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropHFReferenceP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropLFReferenceP12Il2CppObject,__Z48AudioReverbZone_Get_Custom_PropRoomRolloffFactorP12Il2CppObject,__Z40AudioReverbZone_Get_Custom_PropDiffusionP12Il2CppObject,__Z38AudioReverbZone_Get_Custom_PropDensityP12Il2CppObject,__Z49AudioLowPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject,__Z51AudioLowPassFilter_Get_Custom_PropLowpassResonanceQP12Il2CppObject,__Z50AudioHighPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject,__Z53AudioHighPassFilter_Get_Custom_PropHighpassResonanceQP12Il2CppObject,__Z52AudioDistortionFilter_Get_Custom_PropDistortionLevelP12Il2CppObject
,__Z36AudioEchoFilter_Get_Custom_PropDelayP12Il2CppObject,__Z41AudioEchoFilter_Get_Custom_PropDecayRatioP12Il2CppObject,__Z37AudioEchoFilter_Get_Custom_PropDryMixP12Il2CppObject,__Z37AudioEchoFilter_Get_Custom_PropWetMixP12Il2CppObject,__Z39AudioChorusFilter_Get_Custom_PropDryMixP12Il2CppObject,__Z40AudioChorusFilter_Get_Custom_PropWetMix1P12Il2CppObject,__Z40AudioChorusFilter_Get_Custom_PropWetMix2P12Il2CppObject,__Z40AudioChorusFilter_Get_Custom_PropWetMix3P12Il2CppObject,__Z38AudioChorusFilter_Get_Custom_PropDelayP12Il2CppObject,__Z37AudioChorusFilter_Get_Custom_PropRateP12Il2CppObject,__Z38AudioChorusFilter_Get_Custom_PropDepthP12Il2CppObject,__Z41AudioChorusFilter_Get_Custom_PropFeedbackP12Il2CppObject,__Z41AudioReverbFilter_Get_Custom_PropDryLevelP12Il2CppObject,__Z37AudioReverbFilter_Get_Custom_PropRoomP12Il2CppObject,__Z39AudioReverbFilter_Get_Custom_PropRoomHFP12Il2CppObject,__Z44AudioReverbFilter_Get_Custom_PropRoomRolloffP12Il2CppObject,__Z42AudioReverbFilter_Get_Custom_PropDecayTimeP12Il2CppObject,__Z45AudioReverbFilter_Get_Custom_PropDecayHFRatioP12Il2CppObject,__Z49AudioReverbFilter_Get_Custom_PropReflectionsLevelP12Il2CppObject,__Z49AudioReverbFilter_Get_Custom_PropReflectionsDelayP12Il2CppObject,__Z44AudioReverbFilter_Get_Custom_PropReverbLevelP12Il2CppObject,__Z44AudioReverbFilter_Get_Custom_PropReverbDelayP12Il2CppObject,__Z42AudioReverbFilter_Get_Custom_PropDiffusionP12Il2CppObject,__Z40AudioReverbFilter_Get_Custom_PropDensityP12Il2CppObject,__Z44AudioReverbFilter_Get_Custom_PropHfReferenceP12Il2CppObject,__Z39AudioReverbFilter_Get_Custom_PropRoomLFP12Il2CppObject,__Z44AudioReverbFilter_Get_Custom_PropLfReferenceP12Il2CppObject,__Z41WebCamTexture_Get_Custom_PropRequestedFPSP12Il2CppObject,__Z37AnimationClipPlayable_CUSTOM_GetSpeedR9HPlayable,__Z35AnimationClip_Get_Custom_PropLengthP12Il2CppObject
,__Z38AnimationClip_Get_Custom_PropStartTimeP12Il2CppObject,__Z37AnimationClip_Get_Custom_PropStopTimeP12Il2CppObject,__Z38AnimationClip_Get_Custom_PropFrameRateP12Il2CppObject,__Z36AnimationState_Get_Custom_PropWeightP12Il2CppObject,__Z34AnimationState_Get_Custom_PropTimeP12Il2CppObject,__Z44AnimationState_Get_Custom_PropNormalizedTimeP12Il2CppObject,__Z35AnimationState_Get_Custom_PropSpeedP12Il2CppObject,__Z45AnimationState_Get_Custom_PropNormalizedSpeedP12Il2CppObject,__Z36AnimationState_Get_Custom_PropLengthP12Il2CppObject,__Z34Animator_Get_Custom_PropHumanScaleP12Il2CppObject,__Z37Animator_Get_Custom_PropGravityWeightP12Il2CppObject,__Z39Animator_Get_Custom_PropFeetPivotActiveP12Il2CppObject,__Z35Animator_Get_Custom_PropPivotWeightP12Il2CppObject,__Z29Animator_Get_Custom_PropSpeedP12Il2CppObject,__Z36Animator_Get_Custom_PropPlaybackTimeP12Il2CppObject,__Z41Animator_Get_Custom_PropRecorderStartTimeP12Il2CppObject,__Z40Animator_Get_Custom_PropRecorderStopTimeP12Il2CppObject,__Z44Animator_Get_Custom_PropLeftFeetBottomHeightP12Il2CppObject,__Z45Animator_Get_Custom_PropRightFeetBottomHeightP12Il2CppObject,__Z37HumanTrait_CUSTOM_GetMuscleDefaultMini,__Z37HumanTrait_CUSTOM_GetMuscleDefaultMaxi,__Z36TerrainData_Get_Custom_PropThicknessP12Il2CppObject,__Z46TerrainData_Get_Custom_PropWavingGrassStrengthP12Il2CppObject,__Z44TerrainData_Get_Custom_PropWavingGrassAmountP12Il2CppObject,__Z43TerrainData_Get_Custom_PropWavingGrassSpeedP12Il2CppObject,__Z35Terrain_Get_Custom_PropTreeDistanceP12Il2CppObject,__Z44Terrain_Get_Custom_PropTreeBillboardDistanceP12Il2CppObject,__Z42Terrain_Get_Custom_PropTreeCrossFadeLengthP12Il2CppObject,__Z43Terrain_Get_Custom_PropDetailObjectDistanceP12Il2CppObject,__Z42Terrain_Get_Custom_PropDetailObjectDensityP12Il2CppObject
,__Z42Terrain_Get_Custom_PropHeightmapPixelErrorP12Il2CppObject,__Z38Terrain_Get_Custom_PropBasemapDistanceP12Il2CppObject,__Z38Terrain_Get_Custom_PropLegacyShininessP12Il2CppObject,__Z44Terrain_Get_Custom_PropTreeLODBiasMultiplierP12Il2CppObject,__Z34GUIText_Get_Custom_PropLineSpacingP12Il2CppObject,__Z30GUIText_Get_Custom_PropTabSizeP12Il2CppObject,__Z31TextMesh_Get_Custom_PropOffsetZP12Il2CppObject,__Z37TextMesh_Get_Custom_PropCharacterSizeP12Il2CppObject,__Z35TextMesh_Get_Custom_PropLineSpacingP12Il2CppObject,__Z31TextMesh_Get_Custom_PropTabSizeP12Il2CppObject,__Z32CanvasGroup_Get_Custom_PropAlphaP12Il2CppObject,__Z30CanvasRenderer_CUSTOM_GetAlphaP12Il2CppObject,__Z33Canvas_Get_Custom_PropScaleFactorP12Il2CppObject,__Z44Canvas_Get_Custom_PropReferencePixelsPerUnitP12Il2CppObject,__Z35Canvas_Get_Custom_PropPlaneDistanceP12Il2CppObject,__Z47Canvas_Get_Custom_PropNormalizedSortingGridSizeP12Il2CppObject,__Z29Event_Get_Custom_PropPressureP12Il2CppObject,__Z34GUIStyle_Get_Custom_PropFixedWidthP12Il2CppObject,__Z35GUIStyle_Get_Custom_PropFixedHeightP12Il2CppObject,__Z38GUIStyle_CUSTOM_Internal_GetLineHeight13Il2Cpp_IntPtr,__Z43UploadHandlerRaw_CUSTOM_InternalGetProgressP12Il2CppObject,__Z45UnityWebRequest_Get_Custom_PropUploadProgressP12Il2CppObject,__Z47UnityWebRequest_Get_Custom_PropDownloadProgressP12Il2CppObject,__Z38ParticleEmitter_Get_Custom_PropMinSizeP12Il2CppObject,__Z38ParticleEmitter_Get_Custom_PropMaxSizeP12Il2CppObject,__Z40ParticleEmitter_Get_Custom_PropMinEnergyP12Il2CppObject,__Z40ParticleEmitter_Get_Custom_PropMaxEnergyP12Il2CppObject,__Z42ParticleEmitter_Get_Custom_PropMinEmissionP12Il2CppObject,__Z42ParticleEmitter_Get_Custom_PropMaxEmissionP12Il2CppObject,__Z51ParticleEmitter_Get_Custom_PropEmitterVelocityScaleP12Il2CppObject
,__Z46ParticleEmitter_Get_Custom_PropAngularVelocityP12Il2CppObject,__Z49ParticleEmitter_Get_Custom_PropRndAngularVelocityP12Il2CppObject,__Z40ParticleAnimator_Get_Custom_PropSizeGrowP12Il2CppObject,__Z39ParticleAnimator_Get_Custom_PropDampingP12Il2CppObject,__Z43ParticleRenderer_Get_Custom_PropLengthScaleP12Il2CppObject,__Z45ParticleRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject,__Z51ParticleRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject,__Z47ParticleRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject,__Z49ParticleRenderer_Get_Custom_PropUvAnimationCyclesP12Il2CppObject,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79,b79
,b79,b79,b79,b79,b79];
var FUNCTION_TABLE_viifif = [b80,__Z36Animator_CUSTOM_CrossFadeInFixedTimeP12Il2CppObjectifif,__Z25Animator_CUSTOM_CrossFadeP12Il2CppObjectifif,__Z62AnimatorControllerPlayable_CUSTOM_CrossFadeInFixedTimeInternalR9HPlayableifif,__Z51AnimatorControllerPlayable_CUSTOM_CrossFadeInternalR9HPlayableifif,b80,b80,b80];
var FUNCTION_TABLE_fiiiiiiiifiiiif = [b81,__ZN5physx20PxcSweepSphereSphereERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx21PxcUnimplementedSweepERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx22PxcSweepCapsuleCapsuleERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx17PxcSweepSphereBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx21PxcSweepCapsuleConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx18PxcSweepConvexMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx25PxcSweepConvexHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx18PxcSweepCapsuleBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx14PxcSweepBoxBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx17PxcSweepBoxConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,__ZN5physx20PxcSweepConvexConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf,b81,b81,b81,b81];
var FUNCTION_TABLE_viiifiiiii = [b82,__ZN5physx12NpBatchQuery7raycastERKNS_6PxVec3ES3_ftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE];
var FUNCTION_TABLE_iiiififf = [b83,__Z46Physics2D_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayfiff,__Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff,__Z48Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff,__Z39Collider2D_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfiff,b83,b83,b83];
var FUNCTION_TABLE_vifiii = [b84,__ZN5physx7NpScene7collideEfPNS_10PxBaseTaskEPvj,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj];
var FUNCTION_TABLE_viiiifiiiiif = [b85,__ZN5physx12NpBatchQuery5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheEf];
var FUNCTION_TABLE_viiiiiiiiiiiiiii = [b86,__ZN9GfxDevice11CopyTextureE9TextureIDiiiiiiiS0_iiiii,__ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiiiiiS0_iiiii,__ZNSt3__211__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i,__ZNSt3__211__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i,b86,b86,b86];
var FUNCTION_TABLE_iiiiiiiiiiffffii = [b87,__ZN5physx29createFinalizeSolverContacts4EPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE,__ZN5physx36createFinalizeSolverContacts4CoulombEPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE,b87];
var FUNCTION_TABLE_iiiiiff = [b88,__Z47Physics2D_CUSTOM_INTERNAL_CALL_LinecastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff,__Z50Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff,b88];
var FUNCTION_TABLE_viiiiiiii = [b89,__ZN9GfxDevice11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns,__ZN9GfxDevice20BeginDynamicBatchingERK14ChannelAssignsjjP17VertexDeclarationjj16GfxPrimitiveType,__ZN9GfxDevice16DynamicBatchMeshERK10Matrix4x4fRK16VertexBufferDatajjPKtj25GfxTransformVerticesFlags,__ZN9GfxDevice19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace,__ZN9GfxDevice23UploadSparseTextureTileE9TextureIDiiiPKhii,__ZN17GenericDynamicVBO17DrawChunkInternalERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationP16DrawBuffersRangeij,__ZN13GfxDeviceGLES11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns,__ZN13GfxDeviceGLES19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace,__ZN13GfxDeviceGLES23UploadSparseTextureTileE9TextureIDiiiPKhii,__ZN11UmbraModule24CullBoundingSpheresUmbraEPK8Vector4fPKN5Umbra15OcclusionBufferEjjPhhb,__ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvRS2_RNS_16PxcSolverContextERS7_SC_E,__ZNK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_,__ZThn4_NK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_,__Z17ExtractStacktraceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_Piii,__Z58CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeiiS0_,__Z66CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralIndirectP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeS0_iS0_,__Z47CommandBuffer_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectS0_iS0_iP11Il2CppArrayiS0_,_glCompressedTexImage2D__wrapper,_glCopyTexImage2D__wrapper,_glCopyTexSubImage2D__wrapper,__Z50CanvasRenderer_CUSTOM_CreateUIVertexStreamInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_S0_,__Z33GUI_CUSTOM_INTERNAL_CALL_DoWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_hRS0_,_emscripten_glCompressedTexImage2D__wrapper,_emscripten_glCopyTexImage2D__wrapper,_emscripten_glCopyTexSubImage2D__wrapper,b89,b89,b89
,b89,b89,b89];
var FUNCTION_TABLE_viiff = [b90,__Z36MonoBehaviour_CUSTOM_InvokeRepeatingP12Il2CppObjectP12Il2CppStringff,__Z22Animation_CUSTOM_BlendP12Il2CppObjectP12Il2CppStringff,__Z29Avatar_CUSTOM_SetMuscleMinMaxP12Il2CppObjectiff];
var FUNCTION_TABLE_iif = [b91,__ZN5physx3Cct13BoxController13setHalfHeightEf,__ZN5physx3Cct13BoxController17setHalfSideExtentEf,__ZN5physx3Cct13BoxController20setHalfForwardExtentEf,__ZN5physx3Cct17CapsuleController9setRadiusEf,__ZN5physx3Cct17CapsuleController9setHeightEf,__Z30PlayerPrefs_CUSTOM_TrySetFloatP12Il2CppStringf,b91];
var FUNCTION_TABLE_vifiiii = [b92,__ZN5physx7NpScene8simulateEfPNS_10PxBaseTaskEPvjb,__ZN5physx7NpScene5solveEfPNS_10PxBaseTaskEPvjb,b92];
var FUNCTION_TABLE_viiiiiii = [b93,__ZN9GfxDevice12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj,__ZN9GfxDevice38ScheduleDynamicVBOGeometryJobsInternalEPFvP25DynamicVBOGeometryJobDatajEPFvS1_ES1_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle,__ZN9GfxDevice13AddBatchStatsE17GfxBatchStatsTypeiiiy,__ZN14GfxDeviceStats15SetScreenParamsEiiiiii,__ZN10DynamicVBO9DrawChunkERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationPKNS_10DrawParamsEi,__ZN13GfxDeviceGLES12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj,__ZN13GfxDeviceGLES21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii,__ZN13GfxDeviceNull12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj,__ZN13GfxDeviceNull21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii,__ZN5physx3Ext19ProfileEventHandler12onEventValueERKNS_16PxProfileEventIdEjyx,__ZNK5physx14NpArticulation22computeImpulseResponseEPNS_18PxArticulationLinkERNS_6PxVec3ES4_RKNS_24PxArticulationDriveCacheERKS3_S9_,__ZN5physx12NpBatchQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformEtRKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE,__ZN5physx20PxsParticleSystemSim18removeInteractionVERKNS_16PxvParticleShapeEjjbbb,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl14createPropertyEN5physx8debugger18NonNegativeIntegerEPKcS5_S3_NS2_12PropertyType4EnumE,__ZN13PhysicsModule21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE,__ZNK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE,__ZThn4_NK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE,__ZN11ClothModule33SetUpSkinnedBuffersOnSkinnedClothEPN5Unity5ClothEPvS3_S3_jb,_pre_process_context,_pre_process_data,_forward_DCT,_sep_upsample,_post_process_1pass,__ZL20ShaderWarmupFuncImplP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContext,__Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawGUITextureRK5RectTIfEP12Il2CppObjectiiiiS4_,__Z52CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawMeshP12Il2CppObjectS0_RK10Matrix4x4fS0_iiS0_,__Z32Texture2D_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh13Il2Cpp_IntPtr,__Z26Texture2D_CUSTOM_SetPixelsP12Il2CppObjectiiiiP11Il2CppArrayi
,__Z35Texture2D_CUSTOM_SetBlockOfPixels32P12Il2CppObjectiiiiP11Il2CppArrayi,__Z37Texture2DArray_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormathh,__ZN12_GLOBAL__N_123DebugKHRDefaultCallbackEjjjjiPKcPKv,_glGetActiveAttrib__wrapper,_glGetActiveUniform__wrapper,_glReadPixels__wrapper,__Z42TerrainData_CUSTOM_Internal_SetDetailLayerP12Il2CppObjectiiiiiP11Il2CppArray,__Z50CanvasRenderer_CUSTOM_SplitUIVertexStreamsInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_,__Z38GUI_CUSTOM_INTERNAL_CALL_DoModalWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_RS0_,_emscripten_glReadPixels__wrapper,_emscripten_glGetActiveUniform__wrapper,_emscripten_glGetActiveAttrib__wrapper,__ZNSt3__29__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE,__ZNSt3__29__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE,__ZNSt3__29__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE,__ZNSt3__29__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE,b93,b93,b93,b93,b93,b93,b93,b93,b93,b93,b93,b93,b93,b93
,b93,b93,b93,b93,b93];
var FUNCTION_TABLE_vifii = [b94,__Z58Physics2D_CUSTOM_INTERNAL_CALL_Internal_GetRayIntersectionRK3RayfiP12RaycastHit2D,__Z45WheelCollider_CUSTOM_ConfigureVehicleSubstepsP12Il2CppObjectfii,b94];
var FUNCTION_TABLE_viiiiiiiii = [b95,__ZN9GfxDevice9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb,__ZN9GfxDevice11CopyTextureE9TextureIDiiiS0_iii,__ZN9GfxDevice28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi,__ZN13GfxDeviceGLES9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb,__ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiS0_iii,__ZN13GfxDeviceGLES28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi,__ZN5physx3Ext19ProfileEventHandler12onStartEventERKNS_16PxProfileEventIdEjyhhy,__ZN5physx3Ext19ProfileEventHandler11onStopEventERKNS_16PxProfileEventIdEjyhhy,__ZNK12PhysXRaycast14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEjbi23QueryTriggerInteractionb,_UNITY_png_set_IHDR,__Z46Graphics_CUSTOM_Internal_DrawMeshInstancedListP12Il2CppObjectiS0_S0_S0_17ShadowCastingModehiS0_,__Z40Graphics_CUSTOM_Internal_SetMRTFullSetupP11Il2CppArrayP21ScriptingRenderBufferiiiS0_S0_ii,__Z35CommandBuffer_CUSTOM_GetTemporaryRTP12Il2CppObjectiiiii19RenderTextureFormat22RenderTextureReadWritei,_glCompressedTexSubImage2D__wrapper,_glTexImage2D__wrapper,_glTexSubImage2D__wrapper,_emscripten_glCompressedTexSubImage2D__wrapper,_emscripten_glTexImage2D__wrapper,_emscripten_glTexSubImage2D__wrapper,b95,b95,b95,b95,b95,b95,b95,b95,b95
,b95,b95,b95];
var FUNCTION_TABLE_iii = [b96,_deflate_stored,_deflate_fast,_deflate_slow,__Z9heapAllocPvj,__ZN20LocalFileSystemWebGL5CloseER13FileEntryData,__ZNK20LocalFileSystemPosix8PositionERK13FileEntryData,__ZNK20LocalFileSystemPosix4SizeERK13FileEntryData,__ZNK22LocalFileSystemHandler9CanHandleEPKc,__ZN22LocalFileSystemHandler18IsAbsoluteFilePathEPKc,__ZNK20LocalFileSystemPosix8FilenameERK13FileEntryData,__ZNK20LocalFileSystemPosix5IsDirERK13FileEntryData,__ZNK20LocalFileSystemPosix8IsHiddenERK13FileEntryData,__ZNK20LocalFileSystemPosix9IsSymLinkERK13FileEntryData,__ZN20LocalFileSystemPosix8IsLockedERK13FileEntryData,__ZN20LocalFileSystemPosix12CreateAsFileER13FileEntryData,__ZN20LocalFileSystemPosix11CreateAsDirER13FileEntryData,__ZN17FileSystemHandler11MoveToTrashER13FileEntryData,__ZN20LocalFileSystemPosix5TouchER13FileEntryData,__ZNK20LocalFileSystemPosix6ExistsERK13FileEntryData,__ZN13WebCamTexture16CaptureNextFrameEP28PlatformDependentCaptureData,__ZN13BaseAllocator13TryDeallocateEPv,__ZNK13BaseAllocator17ValidateIntegrityEPKv,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13TryDeallocateEPv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8ContainsEPKv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10GetPtrSizeEPKv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17GetProfilerHeaderEPKv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetRequestedPtrSizeEPKv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17ValidateIntegrityEPKv
,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv,__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv,__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv,__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv,__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv,__ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv,__ZN14StackAllocator13TryDeallocateEPv,__ZNK14StackAllocator8ContainsEPKv,__ZNK14StackAllocator10GetPtrSizeEPKv,__ZNK14StackAllocator17GetProfilerHeaderEPKv,__ZNK14StackAllocator19GetRequestedPtrSizeEPKv,__ZN12TLSAllocatorI14StackAllocatorE13TryDeallocateEPv,__ZNK12TLSAllocatorI14StackAllocatorE8ContainsEPKv,__ZNK12TLSAllocatorI14StackAllocatorE10GetPtrSizeEPKv,__ZNK12TLSAllocatorI14StackAllocatorE17GetProfilerHeaderEPKv,__ZNK12TLSAllocatorI14StackAllocatorE19GetRequestedPtrSizeEPKv,__ZN25ThreadsafeLinearAllocator13TryDeallocateEPv,__ZNK25ThreadsafeLinearAllocator8ContainsEPKv,__ZNK25ThreadsafeLinearAllocator10GetPtrSizeEPKv,__ZNK25ThreadsafeLinearAllocator17GetProfilerHeaderEPKv,__ZNK25ThreadsafeLinearAllocator19GetRequestedPtrSizeEPKv,__ZN13LoadOperation19IntegrateTimeSlicedEi,__ZN23PreloadManagerOperation19IntegrateTimeSlicedEi,__ZNK12BaseRenderer14GetSubsetIndexEi,__ZNK20IntermediateRenderer11GetMaterialEi,__ZNK24MeshIntermediateRenderer14GetSubsetIndexEi,__ZNK20LightPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZN8Playable11DerivesFromEP11Il2CppClass,__ZN22BlockMemoryCacheWriter15CompleteWritingEj,__ZN9GfxDevice20GetVertexDeclarationERK18VertexChannelsInfo
,__ZN9GfxDevice18AllocRenderSurfaceEb,__ZN9GfxDevice23GetNativeTexturePointerE9TextureID,__ZN9GfxDevice28GetNativeVertexBufferPointerEP9GfxBuffer,__ZN9GfxDevice27GetNativeIndexBufferPointerEP9GfxBuffer,__ZN9GfxDevice29GetNativeComputeBufferPointerE15ComputeBufferID,__ZN9GfxDevice29GetNativeRenderSurfacePointerEP17RenderSurfaceBase,__ZN22VertexDeclarationCache13GetVertexDeclERK18VertexChannelsInfo,__ZN4crndL18crnd_default_msizeEPvS0_,__ZNK29LineParametersPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK8Renderer11GetMaterialEi,__ZNK8Renderer14GetSubsetIndexEi,__ZThn32_NK8Renderer11GetMaterialEi,__ZThn32_NK8Renderer14GetSubsetIndexEi,__ZNK28RectTransformPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK24RendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK32RendererMaterialAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK17BillboardRenderer11GetMaterialEi,__ZThn32_NK17BillboardRenderer11GetMaterialEi,__ZNK25BlendshapePropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK30SpriteRendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZNK22GenericPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZN14InputInterface11PerformDragER10InputEvent,__ZN14InputInterface10UpdateDragER10InputEvent,__ZN9TextAsset9SetScriptERK8UnityStr,__ZNK28MonoBehaviourPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZN17MemoryCacheWriter15CompleteWritingEj,__ZN18LoadSceneOperation19IntegrateTimeSlicedEi,__ZN19RuntimeSceneManager8GetSceneEi,__ZN16ScriptingManager14IsTrustedTokenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE,__ZNK13Lz4Compressor29CalculateCompressedBufferSizeEj
,__ZNK15Lz4Decompressor20DecompressStreamInitEPPv,__ZN17ArchiveFileSystem5CloseER13FileEntryData,__ZNK17ArchiveFileSystem8PositionERK13FileEntryData,__ZNK17ArchiveFileSystem4SizeERK13FileEntryData,__ZNK17ArchiveFileSystem9CanHandleEPKc,__ZN17ArchiveFileSystem18IsAbsoluteFilePathEPKc,__ZNK17ArchiveFileSystem8FilenameERK13FileEntryData,__ZNK17ArchiveFileSystem5IsDirERK13FileEntryData,__ZNK17ArchiveFileSystem8IsHiddenERK13FileEntryData,__ZNK17ArchiveFileSystem9IsSymLinkERK13FileEntryData,__ZN17ArchiveFileSystem8IsLockedERK13FileEntryData,__ZN17ArchiveFileSystem12CreateAsFileER13FileEntryData,__ZN17ArchiveFileSystem11CreateAsDirER13FileEntryData,__ZN17ArchiveFileSystem11MoveToTrashER13FileEntryData,__ZN17ArchiveFileSystem5TouchER13FileEntryData,__ZNK17ArchiveFileSystem6ExistsERK13FileEntryData,__ZN12IFileAdapter5CloseER13FileEntryData,__ZNK12IFileAdapter8PositionERK13FileEntryData,__ZNK12IFileAdapter4SizeERK13FileEntryData,__ZN12HandlerChain5CloseER13FileEntryData,__ZNK12HandlerChain8PositionERK13FileEntryData,__ZNK12HandlerChain4SizeERK13FileEntryData,__ZNK12HandlerChain9CanHandleEPKc,__ZN12HandlerChain18IsAbsoluteFilePathEPKc,__ZNK12HandlerChain8FilenameERK13FileEntryData,__ZNK12HandlerChain5IsDirERK13FileEntryData,__ZNK12HandlerChain8IsHiddenERK13FileEntryData,__ZNK12HandlerChain9IsSymLinkERK13FileEntryData,__ZN12HandlerChain8IsLockedERK13FileEntryData,__ZN12HandlerChain12CreateAsFileER13FileEntryData
,__ZN12HandlerChain11CreateAsDirER13FileEntryData,__ZN12HandlerChain11MoveToTrashER13FileEntryData,__ZN12HandlerChain5TouchER13FileEntryData,__ZNK12HandlerChain6ExistsERK13FileEntryData,__ZNK17FileSystemHandler8FilenameERK13FileEntryData,__ZNK17FileSystemHandler8IsHiddenERK13FileEntryData,__ZNK17FileSystemHandler9IsSymLinkERK13FileEntryData,__ZN17FileSystemHandler8IsLockedERK13FileEntryData,__ZN17FileSystemHandler12CreateAsFileER13FileEntryData,__ZN17FileSystemHandler5TouchER13FileEntryData,__ZN20LocalFileSystemPosix5CloseER13FileEntryData,__ZN16MemoryFileSystem5CloseER13FileEntryData,__ZNK16MemoryFileSystem8PositionERK13FileEntryData,__ZNK16MemoryFileSystem4SizeERK13FileEntryData,__ZNK16MemoryFileSystem9CanHandleEPKc,__ZN16MemoryFileSystem18IsAbsoluteFilePathEPKc,__ZNK16MemoryFileSystem8FilenameERK13FileEntryData,__ZNK16MemoryFileSystem5IsDirERK13FileEntryData,__ZNK16MemoryFileSystem8IsHiddenERK13FileEntryData,__ZNK16MemoryFileSystem9IsSymLinkERK13FileEntryData,__ZN16MemoryFileSystem8IsLockedERK13FileEntryData,__ZN16MemoryFileSystem12CreateAsFileER13FileEntryData,__ZN16MemoryFileSystem11CreateAsDirER13FileEntryData,__ZN16MemoryFileSystem11MoveToTrashER13FileEntryData,__ZN16MemoryFileSystem5TouchER13FileEntryData,__ZNK16MemoryFileSystem6ExistsERK13FileEntryData,__ZN25MultiBlocksMemoryFileData4LockEPPv,__ZN24RingBufferMemoryFileData4LockEPPv,__ZN25SingleBlockMemoryFileData4LockEPPv,__ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE8ContainsEPKv
,__ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv,__ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv,__ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv,__ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv,__ZN12SocketStream18CanSendNonblockingEj,__ZN20BufferedSocketStream18CanSendNonblockingEj,__ZN21AssetBundleFileSystem5CloseER13FileEntryData,__ZNK21AssetBundleFileSystem8PositionERK13FileEntryData,__ZNK21AssetBundleFileSystem4SizeERK13FileEntryData,__ZNK21AssetBundleFileSystem9CanHandleEPKc,__ZN21AssetBundleFileSystem18IsAbsoluteFilePathEPKc,__ZNK21AssetBundleFileSystem5IsDirERK13FileEntryData,__ZN21AssetBundleFileSystem11CreateAsDirER13FileEntryData,__ZNK21AssetBundleFileSystem6ExistsERK13FileEntryData,__ZN13GfxDeviceGLES16CreateBlendStateERK13GfxBlendState,__ZN13GfxDeviceGLES16CreateDepthStateERK13GfxDepthState,__ZN13GfxDeviceGLES18CreateStencilStateERK15GfxStencilState,__ZN13GfxDeviceGLES17CreateRasterStateERK14GfxRasterState,__ZNK13GfxDeviceGLES14IsShaderActiveE10ShaderType,__ZN13GfxDeviceGLES20GetVertexDeclarationERK18VertexChannelsInfo,__ZNK13GfxDeviceGLES27GetActiveRenderColorSurfaceEi,__ZN13GfxDeviceGLES29RenderSurfaceStructMemorySizeEb,__ZN13GfxDeviceGLES23GetNativeTexturePointerE9TextureID,__ZN13GfxDeviceGLES28GetNativeVertexBufferPointerEP9GfxBuffer,__ZN13GfxDeviceGLES27GetNativeIndexBufferPointerEP9GfxBuffer,__ZN13GfxDeviceGLES29GetNativeComputeBufferPointerE15ComputeBufferID,__ZN13GfxDeviceGLES4InitE16GfxDeviceLevelGL,__ZN13GfxDeviceGLES15ActivateDisplayEj,__ZN13GfxDeviceGLES16SetDisplayTargetEj,__ZN26VertexDeclarationCacheGLES23CreateVertexDeclarationERK18VertexChannelsInfo
,__ZN14TimerQueryGLES10GetElapsedEj,__ZN15UniformTFMethod13MapBoneBufferEj,__ZN15UniformTFMethod20IsBoneCountSupportedEi,__ZN21UniformBufferTFMethod13MapBoneBufferEj,__ZN21UniformBufferTFMethod20IsBoneCountSupportedEi,__ZN15TextureTFMethod13MapBoneBufferEj,__ZN15TextureTFMethod20IsBoneCountSupportedEi,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi,__ZN13GfxDeviceNull16CreateBlendStateERK13GfxBlendState,__ZN13GfxDeviceNull16CreateDepthStateERK13GfxDepthState,__ZN13GfxDeviceNull18CreateStencilStateERK15GfxStencilState,__ZN13GfxDeviceNull17CreateRasterStateERK14GfxRasterState,__ZNK13GfxDeviceNull14IsShaderActiveE10ShaderType,__ZN13GfxDeviceNull20GetVertexDeclarationERK18VertexChannelsInfo,__ZNK13GfxDeviceNull27GetActiveRenderColorSurfaceEi,__ZN13GfxDeviceNull29RenderSurfaceStructMemorySizeEb,__ZN11UmbraModule11GetTomeSizeEPKN5Umbra4TomeE,__ZN11UmbraModule19GetUmbraObjectCountEPKN5Umbra4TomeE,__ZN11UmbraModule30GetUmbraVisibilityOutputBufferEPKN5Umbra10VisibilityE,__ZN11UmbraModule12SetupPortalsEPKN5Umbra4TomeE,__ZNK29ParticleSystemPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE,__ZN5physx3Cct13BoxController11setPositionERKNS_14PxExtendedVec3E,__ZN5physx3Cct13BoxController15setFootPositionERKNS_14PxExtendedVec3E,__ZNK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E,__ZThn8_NK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E,__ZN5physx3Cct17CapsuleController11setPositionERKNS_14PxExtendedVec3E,__ZN5physx3Cct17CapsuleController15setFootPositionERKNS_14PxExtendedVec3E,__ZN5physx3Cct17CapsuleController15setClimbingModeENS_21PxCapsuleClimbingMode4EnumE,__ZNK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E
,__ZThn8_NK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E,__ZN5physx3Cct26CharacterControllerManager13getControllerEj,__ZN5physx3Cct26CharacterControllerManager16createControllerERKNS_16PxControllerDescE,__ZN5physx3Cct26CharacterControllerManager18getObstacleContextEj,__ZN5physx3Cct15ObstacleContext11addObstacleERKNS_10PxObstacleE,__ZN5physx3Cct15ObstacleContext14removeObstacleEj,__ZNK5physx3Cct15ObstacleContext11getObstacleEj,__ZNK5physx3Cct15ObstacleContext19getObstacleByHandleEj,__ZNK5physx9PxD6Joint8isKindOfEPKc,__ZNK5physx3Ext7D6Joint9getMotionENS_8PxD6Axis4EnumE,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj,__ZNK5physx15PxDistanceJoint8isKindOfEPKc,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj,__ZNK5physx12PxFixedJoint8isKindOfEPKc,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj,__ZNK5physx16PxPrismaticJoint8isKindOfEPKc,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj,__ZNK5physx15PxRevoluteJoint8isKindOfEPKc,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj,__ZNK5physx16PxSphericalJoint8isKindOfEPKc,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj,__ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj,__ZN5physx2Sn21SerializationRegistry20unregisterSerializerEt,__ZNK5physx2Sn21SerializationRegistry13getSerializerEt,__ZN5physx2Sn21SerializationRegistry24unregisterRepXSerializerEt
,__ZNK5physx2Sn21SerializationRegistry17getRepXSerializerEPKc,__ZN5physx24PxMaterialRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxShapeRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx28PxTriangleMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx27PxHeightFieldRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx26PxConvexMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx27PxRigidStaticRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx28PxRigidDynamicRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx28PxArticulationRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx25PxAggregateRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx27PxClothFabricRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxClothRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZNK5physx11PxAggregate8isKindOfEPKc,__ZN5physx11NpAggregate8addActorERNS_7PxActorE,__ZN5physx11NpAggregate11removeActorERNS_7PxActorE,__ZN5physx11NpAggregate15addArticulationERNS_14PxArticulationE,__ZN5physx11NpAggregate18removeArticulationERNS_14PxArticulationE,__ZN5physx2Sc21ConstraintInteraction10onActivateEj,__ZN5physx2Sc21ConstraintInteraction12onDeactivateEj,__ZN5physx2Sc11Interaction10onActivateEj,__ZN5physx2Sc11Interaction12onDeactivateEj,__ZN5physx2Sc20ArticulationJointSim10onActivateEj,__ZN5physx2Sc20ArticulationJointSim12onDeactivateEj,__ZNK5physx14PxArticulation8isKindOfEPKc,__ZNK5physx19PxArticulationJoint8isKindOfEPKc,__ZNK5physx18PxArticulationLink8isKindOfEPKc,__ZNK5physx12PxConstraint8isKindOfEPKc,__ZN5physx12NpConstraint20getExternalReferenceERj,__ZNK5physx10PxMaterial8isKindOfEPKc,__ZN5physx9NpPhysics18createTriangleMeshERNS_13PxInputStreamE
,__ZN5physx9NpPhysics17createHeightFieldERKNS_17PxHeightFieldDescE,__ZN5physx9NpPhysics17createHeightFieldERNS_13PxInputStreamE,__ZN5physx9NpPhysics16createConvexMeshERNS_13PxInputStreamE,__ZN5physx9NpPhysics17createClothFabricERNS_13PxInputStreamE,__ZN5physx9NpPhysics17createClothFabricERKNS_17PxClothFabricDescE,__ZN5physx9NpPhysics11createSceneERKNS_11PxSceneDescE,__ZN5physx9NpPhysics17createRigidStaticERKNS_11PxTransformE,__ZN5physx9NpPhysics18createRigidDynamicERKNS_11PxTransformE,__ZNK5physx7PxShape8isKindOfEPKc,__ZNK5physx7NpShape14getBoxGeometryERNS_13PxBoxGeometryE,__ZNK5physx7NpShape17getSphereGeometryERNS_16PxSphereGeometryE,__ZNK5physx7NpShape18getCapsuleGeometryERNS_17PxCapsuleGeometryE,__ZNK5physx7NpShape16getPlaneGeometryERNS_15PxPlaneGeometryE,__ZNK5physx7NpShape21getConvexMeshGeometryERNS_20PxConvexMeshGeometryE,__ZNK5physx7NpShape23getTriangleMeshGeometryERNS_22PxTriangleMeshGeometryE,__ZNK5physx7NpShape22getHeightFieldGeometryERNS_21PxHeightFieldGeometryE,__ZNK5physx7NpShape32getMaterialFromInternalFaceIndexEj,__ZNK5physx7PxCloth8isKindOfEPKc,__ZN5physx7NpCloth16lockParticleDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE,__ZNK5physx7NpCloth24getParticleAccelerationsEPNS_6PxVec4E,__ZNK5physx7NpCloth20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE,__ZNK5physx7NpCloth24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE,__ZNK5physx7NpCloth23getSelfCollisionIndicesEPj,__ZNK5physx7NpCloth16getRestPositionsEPNS_6PxVec4E,__ZNK5physx15PxParticleFluid8isKindOfEPKc,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15createParticlesERKNS_22PxParticleCreationDataE,__ZN5physx15NpParticleFluid25lockParticleFluidReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE,__ZN5physx15NpParticleFluid2isENS_11PxActorType4EnumE,__ZNK5physx15NpParticleFluid2isENS_11PxActorType4EnumE
,__ZN5physx15PxsParticleData13addParticlesVERKNS_22PxParticleCreationDataE,__ZNK5physx16PxParticleSystem8isKindOfEPKc,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15createParticlesERKNS_22PxParticleCreationDataE,__ZNK5physx14PxRigidDynamic8isKindOfEPKc,__ZN5physx14NpRigidDynamic18getKinematicTargetERNS_11PxTransformE,__ZNK5physx13PxRigidStatic8isKindOfEPKc,__ZNK5physx7NpScene11getNbActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE,__ZNK5physx7NpScene22getClientBehaviorFlagsEh,__ZNK5physx7NpScene26getSimulationEventCallbackEh,__ZNK5physx7NpScene21getBroadPhaseCallbackEh,__ZN5physx7NpScene12checkResultsEb,__ZN5physx7NpScene16createBatchQueryERKNS_16PxBatchQueryDescE,__ZNK5physx7NpScene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE,__ZN5physx7NpScene22removeBroadPhaseRegionEj,__ZN5physx7NpScene14checkCollisionEb,__ZN5physx2Sc24ElementInteractionMarker10onActivateEj,__ZN5physx2Sc24ElementInteractionMarker12onDeactivateEj,__ZThn8_N5physx2Sc24ElementInteractionMarker10onActivateEj,__ZThn8_N5physx2Sc24ElementInteractionMarker12onDeactivateEj,__ZN5physx2Sc18TriggerInteraction10onActivateEj,__ZN5physx2Sc18TriggerInteraction12onDeactivateEj,__ZThn8_N5physx2Sc18TriggerInteraction10onActivateEj,__ZThn8_N5physx2Sc18TriggerInteraction12onDeactivateEj,__ZN5physx2Sc19ShapeInstancePairLL10onActivateEj,__ZN5physx2Sc19ShapeInstancePairLL12onDeactivateEj,__ZThn8_N5physx2Sc19ShapeInstancePairLL10onActivateEj,__ZThn8_N5physx2Sc19ShapeInstancePairLL12onDeactivateEj,__ZNK5physx2Sq12BucketPruner10getPayloadERKj,__ZNK5physx2Sq11PruningPool10getPayloadERKj
,__ZNK5physx2Sq10AABBPruner10getPayloadERKj,__ZNK5physx16PxBroadPhaseBase7getCapsERNS_16PxBroadPhaseCapsE,__ZN5physx16PxBroadPhaseBase12removeRegionEj,__ZNK5physx16PxsBroadPhaseMBP7getCapsERNS_16PxBroadPhaseCapsE,__ZN5physx16PxsBroadPhaseMBP12removeRegionEj,__ZN5physx9PxTaskMgr12getNamedTaskEPKc,__ZN5physx9PxTaskMgr13getTaskFromIDEj,__ZNK5physx9PxTaskMgr12getReferenceEj,__ZN5physx2Sc35ParticleElementRbElementInteraction10onActivateEj,__ZN5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj,__ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10onActivateEj,__ZThn8_N5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj,__ZNK5physx13PxClothFabric8isKindOfEPKc,__ZNK5physx13NpClothFabric12getPhaseTypeEj,__ZNK5physx12PxConvexMesh8isKindOfEPKc,__ZNK5physx13PxHeightField8isKindOfEPKc,__ZNK5physx2Gu11HeightField24getTriangleMaterialIndexEj,__ZNK5physx14PxTriangleMesh8isKindOfEPKc,__ZNK5physx2Gu12TriangleMesh24getTriangleMaterialIndexEj,__ZN5physx7Cooking20validateTriangleMeshERKNS_18PxTriangleMeshDescE,__ZNK5physx2Cm10Collection8containsERNS_6PxBaseE,__ZNK5physx2Cm10Collection9getObjectEj,__ZNK5physx2Cm10Collection5getIdERKNS_6PxBaseE,__ZN12PhysXRaycast26GetGameObjectForRaycastHitERK10RaycastHit,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc,__ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE
,__ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx17PxStringTableImpl11allocateStrEPKc,__ZN5physx22XmlMemoryAllocatorImpl8allocateEj,__ZN5physx2Sn18RepXCollectionImpl12copyRepXNodeEPKNS0_7XmlNodeE,__ZN5physx2Sn18RepXCollectionImpl14createRepXNodeEPKc,__ZN5physx2Sn18RepXCollectionImpl16createCollectionEPKc,__ZN5physx2Sn13XmlNodeReader9gotoChildEPKc,__ZN5physx2Sn13XmlNodeReader11removeChildEPKc,__ZN5physx2Sn9XmlParser14processCommentEPKc,__ZN5physx2Sn9XmlParser8allocateEj,__ZN12_GLOBAL__N_19MyFastXml8getErrorERi,__ZN5physx24NpPtrTableStorageManager8allocateEj,__ZN5physx26NpPhysicsInsertionCallback12insertObjectERNS_6PxBaseE,__ZN12_GLOBAL__N_116MetaDataProvider15isInstanceValidEPKv,__ZN12_GLOBAL__N_116MetaDataProvider20getInstanceClassTypeEPKv,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl15getNbPropertiesEN5physx8debugger18NonNegativeIntegerE,__ZN12_GLOBAL__N_115StringTableImpl11strToHandleEPKc,__ZN12_GLOBAL__N_115StringTableImpl11handleToStrEj,__ZN12_GLOBAL__N_110DataStream15isInstanceValidEPKv,__ZN12_GLOBAL__N_110DataStream23appendPropertyValueDataEN5physx8debugger7DataRefIKhEE,__ZN12_GLOBAL__N_110DataStream25beginPropertyMessageGroupERKN5physx8debugger14NamespacedNameE,__ZN12_GLOBAL__N_110DataStream15destroyInstanceEPKv,__ZN12_GLOBAL__N_110DataStream17allocateMemForCmdEj,__ZN12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE,__ZThn4_N12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE,__ZN5physx6shdfnd7FastIPC11receiveDataERj,__ZN5physx6shdfnd7FastIPC7canSendEj
,__ZN13PhysicsModule20IsRigidBodyKinematicERK9Rigidbody,__ZN13PhysicsModule20ConvertContactToMonoEP9Collision,__ZN13PhysicsModule29GetColliderMaterialInstanceIDER8Collider,__ZN13PhysicsModule31GetColliderSharedMeshInstanceIDER12MeshCollider,__ZN13PhysicsModule19CreateNxHeightFieldEPv,__ZNK12b2ChainShape5CloneEP16b2BlockAllocator,__ZNK11b2EdgeShape5CloneEP16b2BlockAllocator,__ZNK14b2CapsuleShape5CloneEP16b2BlockAllocator,__ZNK14b2PolygonShape5CloneEP16b2BlockAllocator,__ZNK13b2CircleShape5CloneEP16b2BlockAllocator,__ZN15b2DistanceJoint24SolvePositionConstraintsERK12b2SolverData,__ZN15b2FrictionJoint24SolvePositionConstraintsERK12b2SolverData,__ZN11b2GearJoint24SolvePositionConstraintsERK12b2SolverData,__ZN12b2MotorJoint24SolvePositionConstraintsERK12b2SolverData,__ZN12b2MouseJoint24SolvePositionConstraintsERK12b2SolverData,__ZN16b2PrismaticJoint24SolvePositionConstraintsERK12b2SolverData,__ZN13b2PulleyJoint24SolvePositionConstraintsERK12b2SolverData,__ZN15b2RevoluteJoint24SolvePositionConstraintsERK12b2SolverData,__ZN11b2RopeJoint24SolvePositionConstraintsERK12b2SolverData,__ZN11b2WeldJoint24SolvePositionConstraintsERK12b2SolverData,__ZN12b2WheelJoint24SolvePositionConstraintsERK12b2SolverData,__ZN16Physics2DManager29ConvertCollision2DToScriptingEP11Collision2D,__ZN16Physics2DManager26GetGameObjectForRaycastHitERK12RaycastHit2D,__ZN16Physics2DManager20IsRigidBodyKinematicERK11Rigidbody2D,__ZN15Cast2DQueryBase18ReportFixtureProxyEPK14b2FixtureProxy,__ZN19OverlapPointQuery2D13ReportFixtureEP9b2Fixture,__ZN20OverlapCircleQuery2D13ReportFixtureEP9b2Fixture,__ZN17OverlapBoxQuery2D13ReportFixtureEP9b2Fixture,__ZN21OverlapCapsuleQuery2D13ReportFixtureEP9b2Fixture,__ZNK5physx16PxVehicleNoDrive8isKindOfEPKc
,__ZNK5physx15PxVehicleWheels8isKindOfEPKc,__ZN5physx25PxVehicleConstraintShader20getExternalReferenceERj,__ZNK5physx14PxVehicleDrive8isKindOfEPKc,__ZNK5physx16PxVehicleDrive4W8isKindOfEPKc,__ZNK5physx16PxVehicleDriveNW8isKindOfEPKc,__ZNK5physx18PxVehicleDriveTank8isKindOfEPKc,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE14allocateObjectERNS_23PxRepXInstantiationArgsE,__ZN5physx5cloth9SwFactory5cloneERKNS0_5ClothE,__ZThn4_N5physx5cloth9SwFactory5cloneERKNS0_5ClothE,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE,__ZN10AudioMixer10ClearFloatEPKc,__ZN11AudioModule27IsFormatSupportedByPlatformEPKc,__ZN11AudioModule30GetOrCreateDSPFromCustomFilterEP17AudioCustomFilter,__ZN11AudioModule23CreateAudioCustomFilterEP13MonoBehaviour,__ZN11AudioModule27GetDSPFromAudioCustomFilterEP17AudioCustomFilter,__ZN11AudioModule21SetActiveOutputDriverEPv,__ZN17AnimationPlayable11DerivesFromEP11Il2CppClass,__ZN17AnimationPlayable27SetupStateMachineBehavioursEP6Object,__ZN27AnimationLayerMixerPlayable11DerivesFromEP11Il2CppClass,__ZN27AnimationLayerMixerPlayable13GetParametersEj,__ZNK27AnimationLayerMixerPlayable13GetParametersEj,__ZN22AnimationMixerPlayable11DerivesFromEP11Il2CppClass,__ZN21AnimationClipPlayable11DerivesFromEP11Il2CppClass,__ZN26AnimatorControllerPlayable11DerivesFromEP11Il2CppClass,__ZN26AnimatorControllerPlayable27SetupStateMachineBehavioursEP6Object,__ZN26AnimatorControllerPlayable12ResetTriggerEi
,__ZN26AnimatorControllerPlayable10SetTriggerEi,__ZN18AnimatorController8GetAssetEb,__ZN26AnimatorOverrideController8GetAssetEb,__ZN16MecanimAnimation40GetReadWriteGlobalSpaceSkeletonPoseFenceEPN5Unity9ComponentE,__ZN23AnimationOffsetPlayable11DerivesFromEP11Il2CppClass,__ZN29AnimationStateNetworkProvider29GetNetworkAnimationStateCountER9Animation,__ZNK12RemoveByName16ShouldRemoveClipEP13AnimationClip,__ZNK12RemoveByName17ShouldRemoveStateEP14AnimationState,__ZNK11RemoveByPtr16ShouldRemoveClipEP13AnimationClip,__ZNK11RemoveByPtr17ShouldRemoveStateEP14AnimationState,__ZN14TerrainManager26Heightmap_GetPxHeightFieldER9Heightmap,__ZN14TerrainManager23TryGetSplatBaseMaterialEP7Terrain,__ZN14TerrainManager14GetTerrainDataEP7Terrain,__ZN14TerrainManager21GetEnlightenProxyMeshEP7Terrain,__ZN14TerrainManager23CreateTerrainGameObjectEP11TerrainData,__ZNK26LegacyTreeInstanceRenderer11GetMaterialEi,__ZNK26LegacyTreeInstanceRenderer14GetSubsetIndexEi,__ZNK23LODTreeInstanceRenderer11GetMaterialEi,__ZNK23LODTreeInstanceRenderer14GetSubsetIndexEi,__Z7FTAllocP13FT_MemoryRec_l,__ZN11IMGUIModule21QueryGUIDisplayTargetEP11Il2CppClass,__ZN12StatusHelper13SetStatusCodeEl,__ZNK8VRDevice22CanSetPlayerPauseValueE11PlayerPause,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16GetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17GetResponseHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE,__ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr,__ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStr,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8overflowEi,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj
,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8overflowEj,__ZNSt3__211__stdoutbufIwE8overflowEj,__ZNSt3__211__stdoutbufIcE8overflowEi,__ZNSt3__210__stdinbufIwE9pbackfailEj,__ZNSt3__210__stdinbufIcE9pbackfailEi,__ZNKSt3__25ctypeIcE10do_toupperEc,__ZNKSt3__25ctypeIcE10do_tolowerEc,__ZNKSt3__25ctypeIcE8do_widenEc,__ZNKSt3__212ctype_bynameIcE10do_toupperEc,__ZNKSt3__212ctype_bynameIcE10do_tolowerEc,__ZNKSt3__212ctype_bynameIwE10do_toupperEw,__ZNKSt3__212ctype_bynameIwE10do_tolowerEw,__ZNKSt3__212ctype_bynameIwE8do_widenEc,__ZNKSt3__25ctypeIwE10do_toupperEw,__ZNKSt3__25ctypeIwE10do_tolowerEw,__ZNKSt3__25ctypeIwE8do_widenEc,__ZNKSt3__219__shared_weak_count13__get_deleterERKSt9type_info,__ZNSt3__212strstreambuf9pbackfailEi,__ZNSt3__212strstreambuf8overflowEi,_UNITY_png_malloc_warn,_compress_data,_compress_first_pass,_compress_output,_encode_mcu_gather,_encode_mcu_huff,_compress_output_20,_decode_mcu,_decompress_data,_decompress_onepass,_decode_mcu_DC_first
,_decode_mcu_AC_first,_decode_mcu_DC_refine,_decode_mcu_AC_refine,_jpeg_resync_to_restart,___fdopen,_ftell_file_func,_fclose_file_func,_ferror_file_func,__Z10tesvertLeqP10TESSvertexS0_,__ZN13WebCamTexture7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11AssetBundle7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN19AssetBundleManifest7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15EditorExtension7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10GameObject7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11GameManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17GlobalGameManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16LevelGameManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity9Component7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11NamedObject7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10TagManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Camera7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9LensFlare7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10FlareLayer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Flare7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16GraphicsSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN4Halo7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9HaloLayer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Light7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN21LightProbeProxyVolume7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11LightProbes7PRODUCEE10MemLabelId18ObjectCreationMode
,__ZN13OcclusionArea7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN20OcclusionCullingData7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN24OcclusionCullingSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15OcclusionPortal7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Projector7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15ReflectionProbe7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14RenderSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Skybox7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10GUIElement7PRODUCEE10MemLabelId18ObjectCreationMode,__Z14SortGUIByDepthP10GUIElementS0_,__ZN8GUILayer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10GUITexture7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14DirectorPlayer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Behaviour7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18DelayedCallManager7PRODUCEE10MemLabelId18ObjectCreationMode,__Z22DelayedDestroyCallbackP6ObjectPv,__ZN12CubemapArray7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN7Cubemap7PRODUCEE10MemLabelId18ObjectCreationMode,_jpeg_read_header,__ZL8StbAllocjPv,__ZN15LightProbeGroup7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16LightmapSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12LineRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15QualitySettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN2UI13RectTransform7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13RenderTexture7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8Renderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13SparseTexture7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Sprite7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN7Texture7PRODUCEE10MemLabelId18ObjectCreationMode
,__ZN9Texture2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14Texture2DArray7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Texture3D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13TrailRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Transform7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14BillboardAsset7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17BillboardRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8LODGroup7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN4Mesh7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10MeshFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__Z28CompareBlendShapeVertexIndexRK16BlendShapeVertexS1_,__ZN12MeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN19SkinnedMeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14SpriteRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18ProceduralMaterial7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17ProceduralTexture7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16SubstanceArchive7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12InputManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11TimeManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13BuildSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14PlayerSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15ResourceManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN30RuntimeInitializeOnLoadManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Coroutine17ContinueCoroutineEP6ObjectPv,__ZN10MonoScript7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11PreloadData7PRODUCEE10MemLabelId18ObjectCreationMode,__ZL20ForwardInvokeDelayedP6ObjectPv,__ZL18ShouldCancelInvokePvS_,__ZN11MonoManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9TextAsset7PRODUCEE10MemLabelId18ObjectCreationMode
,__ZL20SortItemByInstanceIDRKN18AwakeFromLoadQueue4ItemES2_,__ZL53SortBehaviourItemByExecutionOrderAndReverseInstanceIDRKN18AwakeFromLoadQueue4ItemES2_,__ZN13ComputeShader7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8Material7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Shader7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12ScriptMapper7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9CGProgram7PRODUCEE10MemLabelId18ObjectCreationMode,__ZL13SortTexByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES7_,__ZL15SortFloatByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEfEES5_,__ZL15SortColorByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES6_,__ZN23ShaderVariantCollection7PRODUCEE10MemLabelId18ObjectCreationMode,__ZL22SortFloatArrayFunctionPKvS0_,__ZN18SpeedTreeWindAsset7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8WindZone7PRODUCEE10MemLabelId18ObjectCreationMode,__Z38AssetBundle_CUSTOM_LoadFromMemoryAsyncP11Il2CppArrayj,__Z33AssetBundle_CUSTOM_LoadFromMemoryP11Il2CppArrayj,__Z27AssetBundle_CUSTOM_ContainsP12Il2CppObjectP12Il2CppString,__Z26AssetBundle_CUSTOM_LoadAllP12Il2CppObjectS0_,__Z48AssetBundleManifest_CUSTOM_GetDirectDependenciesP12Il2CppObjectP12Il2CppString,__Z45AssetBundleManifest_CUSTOM_GetAllDependenciesP12Il2CppObjectP12Il2CppString,__Z44Caching_CUSTOM_INTERNAL_CALL_IsVersionCachedP12Il2CppStringRK7Hash128,__Z39Caching_CUSTOM_INTERNAL_CALL_MarkAsUsedP12Il2CppStringRK7Hash128,__Z24Camera_CUSTOM_IsFilteredP12Il2CppObjectS0_,__Z31Camera_CUSTOM_GetCommandBuffersP12Il2CppObject21RenderCameraEventType,__Z39ColorUtility_CUSTOM_DoTryParseHtmlColorP12Il2CppStringP16ColorRGBA32Icall,__Z29Component_CUSTOM_GetComponentP12Il2CppObjectP12Il2CppString,__Z27Component_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString,__Z31ComputeShader_CUSTOM_FindKernelP12Il2CppObjectP12Il2CppString,__Z30ComputeShader_CUSTOM_HasKernelP12Il2CppObjectP12Il2CppString,__Z32CrashReport_CUSTOM_GetReportDataP12Il2CppStringPd
,__Z29CullingGroup_CUSTOM_IsVisibleP12Il2CppObjecti,__Z31CullingGroup_CUSTOM_GetDistanceP12Il2CppObjecti,__Z37GUILayer_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3f,__Z30GameObject_CUSTOM_GetComponentP12Il2CppObjectS0_,__Z36GameObject_CUSTOM_GetComponentByNameP12Il2CppObjectP12Il2CppString,__Z38GameObject_CUSTOM_GetComponentInParentP12Il2CppObjectS0_,__Z38GameObject_CUSTOM_AddComponentInternalP12Il2CppObjectP12Il2CppString,__Z28GameObject_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString,__Z47GameObject_CUSTOM_Internal_AddComponentWithTypeP12Il2CppObjectS0_,__Z38CombineInstance_CUSTOM_InternalGetMeshP12Il2CppObjecti,__Z32LineRenderer_CUSTOM_GetPositionsP12Il2CppObjectP11Il2CppArray,__Z42MaterialPropertyBlock_CUSTOM_GetFloatArrayP12Il2CppObjecti,__Z43MaterialPropertyBlock_CUSTOM_GetVectorArrayP12Il2CppObjecti,__Z43MaterialPropertyBlock_CUSTOM_GetMatrixArrayP12Il2CppObjecti,__Z39MaterialPropertyBlock_CUSTOM_GetTextureP12Il2CppObjecti,__Z51GeometryUtility_CUSTOM_INTERNAL_CALL_TestPlanesAABBP11Il2CppArrayRK4AABB,__Z52StaticBatchingUtility_CUSTOM_InternalCombineVerticesP11Il2CppArrayP12Il2CppString,__Z30Light_CUSTOM_GetCommandBuffersP12Il2CppObject20RenderLightEventType,__Z22Light_CUSTOM_GetLights9LightTypei,__Z37Matrix4x4_CUSTOM_INTERNAL_CALL_InvertRK10Matrix4x4fPS_,__Z45Bounds_CUSTOM_INTERNAL_CALL_Internal_ContainsRK4AABBRK8Vector3f,__Z51AnimationCurve_CUSTOM_INTERNAL_CALL_AddKey_InternalP12Il2CppObjectRK16KeyframeTplFloat,__Z22Mesh_CUSTOM_HasChannelP12Il2CppObject30InternalScriptingShaderChannel,__Z28Mesh_CUSTOM_GetTrianglesImplP12Il2CppObjecti,__Z26Mesh_CUSTOM_GetIndicesImplP12Il2CppObjecti,__Z29Mesh_CUSTOM_GetBlendShapeNameP12Il2CppObjecti,__Z35Mesh_CUSTOM_GetBlendShapeFrameCountP12Il2CppObjecti,__Z23Mesh_CUSTOM_GetTopologyP12Il2CppObjecti,__Z30Mesh_CUSTOM_GetBlendShapeIndexP12Il2CppObjectP12Il2CppString,__Z31MonoBehaviour_CUSTOM_IsInvokingP12Il2CppObjectP12Il2CppString
,__Z49MonoBehaviour_CUSTOM_StartCoroutine_Auto_InternalP12Il2CppObjectS0_,__Z36Motion_CUSTOM_ValidateIfRetargetableP12Il2CppObjecth,__Z34Playables_CUSTOM_GetTypeOfInternal13Il2Cpp_IntPtri,__Z28PlayerPrefs_CUSTOM_TrySetIntP12Il2CppStringi,__Z34PlayerPrefs_CUSTOM_TrySetSetStringP12Il2CppStringS0_,__Z25PlayerPrefs_CUSTOM_GetIntP12Il2CppStringi,__Z28PlayerPrefs_CUSTOM_GetStringP12Il2CppStringS0_,__Z28Random_CUSTOM_RandomRangeIntii,__Z34ReflectionProbe_CUSTOM_RenderProbeP12Il2CppObjectS0_,__Z42ReflectionProbe_CUSTOM_IsFinishedRenderingP12Il2CppObjecti,__Z21Resources_CUSTOM_LoadP12Il2CppStringP12Il2CppObject,__Z26Resources_CUSTOM_LoadAsyncP12Il2CppStringP12Il2CppObject,__Z24Resources_CUSTOM_LoadAllP12Il2CppStringP12Il2CppObject,__Z35Resources_CUSTOM_GetBuiltinResourceP12Il2CppObjectP12Il2CppString,__Z26Material_CUSTOM_GetTextureP12Il2CppObjecti,__Z33Material_CUSTOM_GetFloatArrayImplP12Il2CppObjecti,__Z34Material_CUSTOM_GetVectorArrayImplP12Il2CppObjecti,__Z33Material_CUSTOM_GetColorArrayImplP12Il2CppObjecti,__Z34Material_CUSTOM_GetMatrixArrayImplP12Il2CppObjecti,__Z27Material_CUSTOM_HasPropertyP12Il2CppObjecti,__Z23Material_CUSTOM_SetPassP12Il2CppObjecti,__Z27Material_CUSTOM_GetPassNameP12Il2CppObjecti,__Z24Material_CUSTOM_FindPassP12Il2CppObjectP12Il2CppString,__Z32Material_CUSTOM_IsKeywordEnabledP12Il2CppObjectP12Il2CppString,__Z28Texture2D_CUSTOM_GetPixels32P12Il2CppObjecti,__Z28Texture2D_CUSTOM_EncodeToJPGP12Il2CppObjecti,__Z26Texture3D_CUSTOM_GetPixelsP12Il2CppObjecti,__Z28Texture3D_CUSTOM_GetPixels32P12Il2CppObjecti,__Z21Transform_CUSTOM_FindP12Il2CppObjectP12Il2CppString,__Z26Transform_CUSTOM_IsChildOfP12Il2CppObjectS0_
,__Z25Transform_CUSTOM_GetChildP12Il2CppObjecti,__Z21WWW_CUSTOM_GetTextureP12Il2CppObjecth,__ZN12WWWDelayCall8CallbackEP6ObjectPv,__ZN12WWWDelayCall14MatchForCancelEPvS0_,__ZN13MonoBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13MonoBehaviour16DelayedStartCallEP6ObjectPv,__ZN9Coroutine26CompareCoroutineMethodNameEPvS0_,__ZN9Coroutine26CompareCoroutineEnumeratorEPvS0_,__ZN9Coroutine22CompareCoroutineDirectEPvS0_,__Z29StdTemplateConversionFunctionIfdEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIdfEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIifEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIytEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIysEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyhEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIyaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIybEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIiyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIixEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIiiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIijEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIitEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIisEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIihEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIiaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIibEbPvR14SafeBinaryRead
,__Z29StdTemplateConversionFunctionIjyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjtEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjsEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjhEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIjbEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIttEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItsEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIthEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionItbEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIstEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIssEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIshEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIsbEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhiEbPvR14SafeBinaryRead
,__Z29StdTemplateConversionFunctionIhjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhtEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhsEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhhEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIhbEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIayEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIaxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIaiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIajEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIatEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIasEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIahEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIaaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIabEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbyEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbxEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbiEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbjEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbtEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbsEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbhEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbaEbPvR14SafeBinaryRead,__Z29StdTemplateConversionFunctionIbbEbPvR14SafeBinaryRead,__Z23ConvertIntegerToTypePtrIsEbPvR14SafeBinaryRead,__Z23ConvertIntegerToTypePtrItEbPvR14SafeBinaryRead,__Z23ConvertIntegerToTypePtrIiEbPvR14SafeBinaryRead,__Z23ConvertIntegerToTypePtrIjEbPvR14SafeBinaryRead,__Z34AndroidJNI_CUSTOM_IsAssignableFrom13Il2Cpp_IntPtrS_,__Z26AndroidJNI_CUSTOM_ThrowNew13Il2Cpp_IntPtrP12Il2CppString
,__Z30AndroidJNI_CUSTOM_IsSameObject13Il2Cpp_IntPtrS_,__Z30AndroidJNI_CUSTOM_IsInstanceOf13Il2Cpp_IntPtrS_,__Z32AndroidJNI_CUSTOM_GetStringField13Il2Cpp_IntPtrS_,__Z33AndroidJNI_CUSTOM_GetBooleanField13Il2Cpp_IntPtrS_,__Z30AndroidJNI_CUSTOM_GetByteField13Il2Cpp_IntPtrS_,__Z30AndroidJNI_CUSTOM_GetCharField13Il2Cpp_IntPtrS_,__Z31AndroidJNI_CUSTOM_GetShortField13Il2Cpp_IntPtrS_,__Z29AndroidJNI_CUSTOM_GetIntField13Il2Cpp_IntPtrS_,__Z30AndroidJNI_CUSTOM_GetLongField13Il2Cpp_IntPtrS_,__Z38AndroidJNI_CUSTOM_GetStaticStringField13Il2Cpp_IntPtrS_,__Z39AndroidJNI_CUSTOM_GetStaticBooleanField13Il2Cpp_IntPtrS_,__Z36AndroidJNI_CUSTOM_GetStaticByteField13Il2Cpp_IntPtrS_,__Z36AndroidJNI_CUSTOM_GetStaticCharField13Il2Cpp_IntPtrS_,__Z37AndroidJNI_CUSTOM_GetStaticShortField13Il2Cpp_IntPtrS_,__Z35AndroidJNI_CUSTOM_GetStaticIntField13Il2Cpp_IntPtrS_,__Z36AndroidJNI_CUSTOM_GetStaticLongField13Il2Cpp_IntPtrS_,__Z40AndroidJNI_CUSTOM_GetBooleanArrayElement13Il2Cpp_IntPtri,__Z37AndroidJNI_CUSTOM_GetByteArrayElement13Il2Cpp_IntPtri,__Z37AndroidJNI_CUSTOM_GetCharArrayElement13Il2Cpp_IntPtri,__Z38AndroidJNI_CUSTOM_GetShortArrayElement13Il2Cpp_IntPtri,__Z36AndroidJNI_CUSTOM_GetIntArrayElement13Il2Cpp_IntPtri,__Z37AndroidJNI_CUSTOM_GetLongArrayElement13Il2Cpp_IntPtri,_glGetAttribLocation__wrapper,_glGetUniformLocation__wrapper,_glGetStringi__wrapper,_glGetUniformBlockIndex__wrapper,_glFenceSync__wrapper,__ZN9SubModule14SubEmitterData8LessThanEPKS0_S2_,__ZL23CompareMeshTriangleDataRK16MeshTriangleDataS1_,__ZN16ParticleSortData12CompareValueERKS_S1_
,__ZN14ParticleSystem7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN22ParticleSystemRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__Z46ParticleSystem_EmissionModule_CUSTOM_GetBurstsP12Il2CppObjectP11Il2CppArray,__Z46ParticleSystem_CollisionModule_CUSTOM_GetPlaneP12Il2CppObjecti,__Z47ParticleSystem_TriggerModule_CUSTOM_GetColliderP12Il2CppObjecti,__Z48ParticleSystem_SubEmittersModule_CUSTOM_GetBirthP12Il2CppObjecti,__Z52ParticleSystem_SubEmittersModule_CUSTOM_GetCollisionP12Il2CppObjecti,__Z48ParticleSystem_SubEmittersModule_CUSTOM_GetDeathP12Il2CppObjecti,__Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterSystemP12Il2CppObjecti,__Z57ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterTypeP12Il2CppObjecti,__Z63ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterPropertiesP12Il2CppObjecti,__Z34ParticleSystem_CUSTOM_GetParticlesP12Il2CppObjectP11Il2CppArray,__Z35ParticleSystem_CUSTOM_Internal_StopP12Il2CppObject26ParticleSystemStopBehavior,__Z39ParticleSystemRenderer_CUSTOM_GetMeshesP12Il2CppObjectP11Il2CppArray,__Z62ParticleSystemRenderer_CUSTOM_Internal_GetEnabledVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlags,__Z63ParticleSystemExtensionsImpl_CUSTOM_GetSafeTriggerParticlesSizeP12Il2CppObjecti,__ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareClassesEPKvS7_,__ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareEntriesEPKvS7_,__ZN5physx2Sc32DefaultClothInterCollisionFilterEPvS1_,__Z19getPxD6Joint_MotionPKN5physx9PxD6JointENS_8PxD6Axis4EnumE,__ZN5physx2Sn9PtrAccessINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEERKT_PS7_j,__ZN12_GLOBAL__N_120createParticleSystemEjb,__ZN12_GLOBAL__N_119createParticleFluidEjb,__Z30createPxPhysics_TriangleMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE,__Z28createPxPhysics_HeightFieldsPN5physx9PxPhysicsERNS_13PxInputStreamE,__Z28createPxPhysics_ConvexMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE,__Z22createPxPhysics_ScenesPN5physx9PxPhysicsERKNS_11PxSceneDescE,__Z19getNbPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE,__Z10GetNbShapePKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumE,__Z21GetNbBroadPhaseRemovePKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE
,__Z18GetNbBroadPhaseAddPKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE,__ZN11BoxCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15CapsuleCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN19CharacterController7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity14CharacterJoint7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8Collider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity17ConfigurableJoint7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13ConstantForce7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity10FixedJoint7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity10HingeJoint7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity5Joint7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12MeshCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14PhysicMaterial7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14PhysicsManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9Rigidbody7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14SphereCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5Unity11SpringJoint7PRODUCEE10MemLabelId18ObjectCreationMode,__Z38Physics_CUSTOM_GetIgnoreLayerCollisionii,__Z51CharacterController_CUSTOM_INTERNAL_CALL_SimpleMoveP12Il2CppObjectRK8Vector3f,__Z45CharacterController_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f,__Z14b2PairLessThanRK6b2PairS1_,__ZN15AnchoredJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN14AreaEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13BoxCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18BuoyancyEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17CapsuleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16CircleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10Collider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15ConstantForce2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15DistanceJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode
,__ZN14EdgeCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10Effector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12FixedJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15FrictionJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12HingeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN7Joint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17PhysicsMaterial2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17Physics2DSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11Rigidbody2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17PolygonCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15RelativeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13SliderJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13SpringJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13TargetJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN24PhysicsUpdateBehaviour2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15PointEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18PlatformEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17SurfaceEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12WheelJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode,__Z35Physics2D_CUSTOM_GetIgnoreCollisionP12Il2CppObjectS0_,__Z40Physics2D_CUSTOM_GetIgnoreLayerCollisionii,__Z27Physics2D_CUSTOM_IsTouchingP12Il2CppObjectS0_,__Z33Physics2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti,__Z29Rigidbody2D_CUSTOM_IsTouchingP12Il2CppObjectS0_,__Z35Rigidbody2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti,__Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall,__Z28Collider2D_CUSTOM_IsTouchingP12Il2CppObjectS0_,__Z34Collider2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti,__Z44Collider2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall,__Z32PolygonCollider2D_CUSTOM_GetPathP12Il2CppObjecti
,__Z43getPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataEj,__Z43getPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataEj,__ZN13WheelCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__Z33WheelCollider_CUSTOM_GetGroundHitP12Il2CppObjectP12MonoWheelHit,__ZN12_GLOBAL__N_116clothSizeGreaterIN5physx5cloth8SwSolver22CpuClothSimulationTaskEEEbRKT_S7_,__ZN5Unity5Cloth7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12NavMeshAgent7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15NavMeshObstacle7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11OffMeshLink7PRODUCEE10MemLabelId18ObjectCreationMode,__ZL15CompareVerticesRK8Vector2fS1_,__ZN11NavMeshData7PRODUCEE10MemLabelId18ObjectCreationMode,__ZL18UnityDetourReallocPvi,__ZL16CompareCarveDataRK16NavMeshCarveDataS1_,__ZN22NavMeshProjectSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15NavMeshSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__Z48NavMeshAgent_CUSTOM_INTERNAL_CALL_SetDestinationP12Il2CppObjectRK8Vector3f,__Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_WarpP12Il2CppObjectRK8Vector3f,__Z27NavMeshAgent_CUSTOM_SetPathP12Il2CppObjectS0_,__Z35NavMeshAgent_CUSTOM_FindClosestEdgeP12Il2CppObjectP10NavMeshHit,__Z37NavMeshPath_CUSTOM_GetCornersNonAllocP12Il2CppObjectP11Il2CppArray,__Z45OffMeshLinkData_CUSTOM_GetOffMeshLinkInternalP12Il2CppObjecti,__ZN9AudioClip8WWWCloseEPvS0_,__Z15FMOD_FILE_ClosePvS_,__ZL44UnityAudioEffect_InternalSetPositionCallbackP14FMOD_DSP_STATEj,__ZN14AudioBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17AudioChorusFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10SampleClip7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN9AudioClip7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN21AudioDistortionFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15AudioEchoFilter7PRODUCEE10MemLabelId18ObjectCreationMode
,__ZN19AudioHighPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13AudioListener7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18AudioLowPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN12AudioManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN10AudioMixer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15AudioMixerGroup7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18AudioMixerSnapshot7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11AudioSource7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN17AudioReverbFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15AudioReverbZone7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11AudioFilter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16BaseVideoTexture7PRODUCEE10MemLabelId18ObjectCreationMode,__Z33AudioSource_CUSTOM_GetCustomCurveP12Il2CppObject24MonoAudioSourceCurveType,__Z36AudioMixer_CUSTOM_FindMatchingGroupsP12Il2CppObjectP12Il2CppString,__Z30AudioMixer_CUSTOM_FindSnapshotP12Il2CppObjectP12Il2CppString,__Z28AudioMixer_CUSTOM_ClearFloatP12Il2CppObjectP12Il2CppString,__Z32WebCamTexture_CUSTOM_GetPixels32P12Il2CppObjectP11Il2CppArray,__ZN9Animation7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN13AnimationClip7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN18AnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN8Animator7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN25RuntimeAnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Avatar7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN6Motion7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN26AnimatorOverrideController7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN7mecanim9animationL25MuscleIndexIdSortFunctionENS0_13MuscleIndexIdES1_,__Z26Animation_CUSTOM_IsPlayingP12Il2CppObjectP12Il2CppString,__Z37Animation_CUSTOM_PlayDefaultAnimationP12Il2CppObjecti,__Z25Animation_CUSTOM_GetStateP12Il2CppObjectP12Il2CppString,__Z32Animation_CUSTOM_GetStateAtIndexP12Il2CppObjecti
,__Z28Animator_CUSTOM_GetBehaviourP12Il2CppObjectS0_,__Z29Animator_CUSTOM_GetBehavioursP12Il2CppObjectS0_,__Z28Animator_CUSTOM_GetLayerNameP12Il2CppObjecti,__Z29Animator_CUSTOM_GetLayerIndexP12Il2CppObjectP12Il2CppString,__Z47Animator_CUSTOM_GetCurrentAnimatorClipInfoCountP12Il2CppObjecti,__Z42Animator_CUSTOM_GetCurrentAnimatorClipInfoP12Il2CppObjecti,__Z44Animator_CUSTOM_GetNextAnimatorClipInfoCountP12Il2CppObjecti,__Z39Animator_CUSTOM_GetNextAnimatorClipInfoP12Il2CppObjecti,__Z30Animator_CUSTOM_IsInTransitionP12Il2CppObjecti,__Z28Animator_CUSTOM_IsControlledP12Il2CppObjectS0_,__Z31Animator_CUSTOM_IsBoneTransformP12Il2CppObjectS0_,__Z32Animator_CUSTOM_GetBoneTransformP12Il2CppObject14HumanBodyBones,__Z29Animator_CUSTOM_GetBoolStringP12Il2CppObjectP12Il2CppString,__Z25Animator_CUSTOM_GetBoolIDP12Il2CppObjecti,__Z32Animator_CUSTOM_GetIntegerStringP12Il2CppObjectP12Il2CppString,__Z28Animator_CUSTOM_GetIntegerIDP12Il2CppObjecti,__Z50Animator_CUSTOM_IsParameterControlledByCurveStringP12Il2CppObjectP12Il2CppString,__Z46Animator_CUSTOM_IsParameterControlledByCurveIDP12Il2CppObjecti,__Z27Animator_CUSTOM_ResolveHashP12Il2CppObjecti,__Z54AnimatorControllerPlayable_CUSTOM_GetLayerNameInternalR9HPlayablei,__Z55AnimatorControllerPlayable_CUSTOM_GetLayerIndexInternalR9HPlayableP12Il2CppString,__Z68AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorClipInfoInternalR9HPlayablei,__Z65AnimatorControllerPlayable_CUSTOM_GetNextAnimatorClipInfoInternalR9HPlayablei,__Z53AnimatorControllerPlayable_CUSTOM_ResolveHashInternalR9HPlayablei,__Z56AnimatorControllerPlayable_CUSTOM_IsInTransitionInternalR9HPlayablei,__Z47AnimatorControllerPlayable_CUSTOM_GetBoolStringR9HPlayableP12Il2CppString,__Z43AnimatorControllerPlayable_CUSTOM_GetBoolIDR9HPlayablei,__Z50AnimatorControllerPlayable_CUSTOM_GetIntegerStringR9HPlayableP12Il2CppString,__Z46AnimatorControllerPlayable_CUSTOM_GetIntegerIDR9HPlayablei,__Z68AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveStringR9HPlayableP12Il2CppString
,__Z64AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveIDR9HPlayablei,__Z32HumanTrait_CUSTOM_MuscleFromBoneii,__Z29HumanTrait_CUSTOM_HasColliderP12Il2CppObjecti,__Z55AvatarBuilder_CUSTOM_INTERNAL_CALL_BuildHumanAvatarMonoP12Il2CppObjectRK20MonoHumanDescription,__Z39AvatarBuilder_CUSTOM_BuildGenericAvatarP12Il2CppObjectP12Il2CppString,__ZN7Terrain7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN11TerrainData7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN4Tree7PRODUCEE10MemLabelId18ObjectCreationMode,__Z26TerrainData_CUSTOM_HasUserP12Il2CppObjectS0_,__Z34TerrainData_CUSTOM_GetAdjustedSizeP12Il2CppObjecti,__Z37TerrainData_CUSTOM_GetAlphamapTextureP12Il2CppObjecti,_ft_raccess_sort_ref_by_id,__ZN13TextRendering4Font7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN20TextRenderingPrivate7GUIText7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN20TextRenderingPrivate8TextMesh7PRODUCEE10MemLabelId18ObjectCreationMode,_ft_outline_glyph_init,_ft_outline_glyph_copy,_ft_outline_glyph_prepare,_ft_bitmap_glyph_init,_ft_bitmap_glyph_copy,_tt_get_interface,_tt_size_request,_tt_size_select,_cff_get_interface,_cff_size_request,_cff_size_select,_psnames_get_service,_sfnt_get_interface,_gray_raster_new,_gray_raster_render
,_gray_move_to,_gray_line_to,_tt_cmap_init,_tt_cmap0_char_index,_tt_cmap0_char_next,_tt_cmap0_validate,_tt_cmap0_get_info,_tt_cmap2_char_index,_tt_cmap2_char_next,_tt_cmap2_validate,_tt_cmap2_get_info,_tt_cmap4_init,_tt_cmap4_char_index,_tt_cmap4_char_next,_tt_cmap4_validate,_tt_cmap4_get_info,_tt_cmap6_char_index,_tt_cmap6_char_next,_tt_cmap6_validate,_tt_cmap6_get_info,_tt_cmap8_char_index,_tt_cmap8_char_next,_tt_cmap8_validate,_tt_cmap8_get_info,_tt_cmap10_char_index,_tt_cmap10_char_next,_tt_cmap10_validate,_tt_cmap10_get_info,_tt_cmap12_init,_tt_cmap12_char_index
,_tt_cmap12_char_next,_tt_cmap12_validate,_tt_cmap12_get_info,_tt_cmap13_init,_tt_cmap13_char_index,_tt_cmap13_char_next,_tt_cmap13_validate,_tt_cmap13_get_info,_tt_cmap14_init,_tt_cmap14_char_index,_tt_cmap14_char_next,_tt_cmap14_variants,_tt_cmap14_validate,_tt_cmap14_get_info,_UNITY_tt_get_cmap_info,_get_sfnt_table,_UNITY_tt_face_load_head,_UNITY_tt_face_load_cmap,_UNITY_tt_face_load_maxp,_UNITY_tt_face_load_os2,_UNITY_tt_face_load_post,_UNITY_tt_face_load_name,_UNITY_tt_face_load_kern,_UNITY_tt_face_load_gasp,_UNITY_tt_face_load_pclt,_UNITY_tt_face_load_bhed,_UNITY_tt_face_load_font_dir,_UNITY_tt_face_load_sbit,_compare_offsets,_tt_name_entry_ascii_from_utf16
,_tt_name_entry_ascii_from_other,_ft_black_new,_ft_black_render,_ps_hints_close,_ps_unicodes_char_index,_ps_unicodes_char_next,_compare_uni_maps,_cff_ps_get_font_info,_cff_get_name_index,_cff_get_cmap_info,_cff_get_is_cid,_cff_cmap_encoding_init,_cff_cmap_encoding_char_index,_cff_cmap_encoding_char_next,_cff_cmap_unicode_init,_cff_cmap_unicode_char_index,_cff_cmap_unicode_char_next,_cff_sid_to_glyph_name,_Read_CVT,_Read_CVT_Stretched,_UNITY_TT_Get_MM_Var,_ft_alloc,_sfnt_get_name_index,__Z24Font_CUSTOM_HasCharacterP12Il2CppObjectt,__ZN2UI11CompareFuncEPNS_6CanvasES1_,__ZN2UIL18CompareCanvasDepthEPNS_6CanvasES1_,__ZN2UI6Canvas7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN2UI11CanvasGroup7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN2UI14CanvasRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__Z33CanvasRenderer_CUSTOM_GetMaterialP12Il2CppObjecti
,__Z36CanvasRenderer_CUSTOM_GetPopMaterialP12Il2CppObjecti,__ZN15TerrainCollider7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN5IMGUIL14SortTwoWindowsEPKNS_9GUIWindowES2_,__Z30Event_CUSTOM_GetTypeForControlP12Il2CppObjecti,__Z30GUIUtility_CUSTOM_GetControlIDi9FocusType,__Z39UnityWebRequest_CUSTOM_GetRequestHeaderP12Il2CppObjectP12Il2CppString,__Z40UnityWebRequest_CUSTOM_GetResponseHeaderP12Il2CppObjectP12Il2CppString,__Z25JsonUtility_CUSTOM_ToJsonP12Il2CppObjecth,__Z27JsonUtility_CUSTOM_FromJsonP12Il2CppStringP12Il2CppObject,__ZN15UnityAdsManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN21UnityAnalyticsManager7PRODUCEE10MemLabelId18ObjectCreationMode,__Z38UnityAnalyticsHandler_CUSTOM_SetUserIdP12Il2CppObjectP12Il2CppString,__Z42UnityAnalyticsHandler_CUSTOM_SetUserGenderP12Il2CppObjectN14UnityAnalytics6GenderE,__Z45UnityAnalyticsHandler_CUSTOM_SetUserBirthYearP12Il2CppObjecti,__Z48UnityAnalyticsHandler_CUSTOM_SendCustomEventNameP12Il2CppObjectP12Il2CppString,__Z44UnityAnalyticsHandler_CUSTOM_SendCustomEventP12Il2CppObjectS0_,__ZN18CrashReportManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN20UnityConnectSettings7PRODUCEE10MemLabelId18ObjectCreationMode,__Z28RemoteSettings_CUSTOM_GetIntP12Il2CppStringi,__Z31RemoteSettings_CUSTOM_GetStringP12Il2CppStringS0_,__Z29RemoteSettings_CUSTOM_GetBoolP12Il2CppStringh,__ZN23CloudWebServicesManager7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN24EllipsoidParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN19MeshParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16ParticleAnimator7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN15ParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN16ParticleRenderer7PRODUCEE10MemLabelId18ObjectCreationMode,__ZN21WorldParticleCollider7PRODUCEE10MemLabelId18ObjectCreationMode,_emscripten_glGetUniformLocation__wrapper,_emscripten_glGetAttribLocation__wrapper,_ignore_err,_sort,_tre_compare_items,_clock_gettime__wrapper,_pthread_cond_wait__wrapper,__ZNSt3__211__libcpp_db17__insert_iteratorEPv,__ZNKSt3__26locale9use_facetERNS0_2idE,__ZNSt3__28ios_base5imbueERKNS_6localeE,_isxdigit_l,_isdigit_l,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEc,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96,b96
,b96,b96,b96,b96,b96,b96,b96,b96,b96];
var FUNCTION_TABLE_fiiiif = [b97,__ZN14Raycast2DQuery13ReportFixtureEP9b2FixtureRK6b2Vec2S4_f];
var FUNCTION_TABLE_iiiifii = [b98,__ZNK19TextRenderingModule38FontGetNumCharactersThatFitWithinWidthEPN13TextRendering4FontERK11UTF16Stringfij,__Z44Physics_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK8Vector3fS1_P11Il2CppArrayfi23QueryTriggerInteraction,__Z45Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastRK8Vector3fS1_P10RaycastHitfi23QueryTriggerInteraction];
var FUNCTION_TABLE_f = [b99,__Z38DynamicGI_Get_Custom_PropIndirectScalev,__Z40DynamicGI_Get_Custom_PropUpdateThresholdv,__Z40RenderSettings_Get_Custom_PropFogDensityv,__Z46RenderSettings_Get_Custom_PropFogStartDistancev,__Z44RenderSettings_Get_Custom_PropFogEndDistancev,__Z46RenderSettings_Get_Custom_PropAmbientIntensityv,__Z49RenderSettings_Get_Custom_PropReflectionIntensityv,__Z42RenderSettings_Get_Custom_PropHaloStrengthv,__Z43RenderSettings_Get_Custom_PropFlareStrengthv,__Z44RenderSettings_Get_Custom_PropFlareFadeSpeedv,__Z45QualitySettings_Get_Custom_PropShadowDistancev,__Z52QualitySettings_Get_Custom_PropShadowNearPlaneOffsetv,__Z50QualitySettings_Get_Custom_PropShadowCascade2Splitv,__Z38QualitySettings_Get_Custom_PropLodBiasv,__Z25Screen_Get_Custom_PropDpiv,__Z50LODGroup_Get_Custom_PropCrossFadeAnimationDurationv,__Z27Random_Get_Custom_PropValuev,__Z24Time_Get_Custom_PropTimev,__Z38Time_Get_Custom_PropTimeSinceLevelLoadv,__Z29Time_Get_Custom_PropDeltaTimev,__Z29Time_Get_Custom_PropFixedTimev,__Z32Time_Get_Custom_PropUnscaledTimev,__Z37Time_Get_Custom_PropUnscaledDeltaTimev,__Z34Time_Get_Custom_PropFixedDeltaTimev,__Z36Time_Get_Custom_PropMaximumDeltaTimev,__Z35Time_Get_Custom_PropSmoothDeltaTimev,__Z44Time_Get_Custom_PropMaximumParticleDeltaTimev,__Z29Time_Get_Custom_PropTimeScalev
,__Z40Time_Get_Custom_PropRealtimeSinceStartupv,__Z47Physics_Get_Custom_PropMinPenetrationForPenaltyv,__Z43Physics_Get_Custom_PropDefaultContactOffsetv,__Z38Physics_Get_Custom_PropBounceThresholdv,__Z36Physics_Get_Custom_PropSleepVelocityv,__Z43Physics_Get_Custom_PropSleepAngularVelocityv,__Z41Physics_Get_Custom_PropMaxAngularVelocityv,__Z37Physics_Get_Custom_PropSleepThresholdv,__Z46Physics_Get_Custom_PropPenetrationPenaltyForcev,__Z42Physics2D_Get_Custom_PropVelocityThresholdv,__Z44Physics2D_Get_Custom_PropMaxLinearCorrectionv,__Z45Physics2D_Get_Custom_PropMaxAngularCorrectionv,__Z44Physics2D_Get_Custom_PropMaxTranslationSpeedv,__Z41Physics2D_Get_Custom_PropMaxRotationSpeedv,__Z49Physics2D_Get_Custom_PropMinPenetrationForPenaltyv,__Z39Physics2D_Get_Custom_PropBaumgarteScalev,__Z42Physics2D_Get_Custom_PropBaumgarteTOIScalev,__Z36Physics2D_Get_Custom_PropTimeToSleepv,__Z45Physics2D_Get_Custom_PropLinearSleepTolerancev,__Z46Physics2D_Get_Custom_PropAngularSleepTolerancev,__Z42Physics2D_Get_Custom_PropContactArrowScalev,__Z41NavMesh_CUSTOM_GetAvoidancePredictionTimev,__Z35AudioListener_Get_Custom_PropVolumev,__Z47GUISettings_CUSTOM_Internal_GetCursorFlashSpeedv,__Z45GUIStyle_CUSTOM_Internal_GetCursorFlashOffsetv,__Z44GUIUtility_CUSTOM_Internal_GetPixelsPerPointv,__Z37VRSettings_Get_Custom_PropRenderScalev,__Z53VRSettings_Get_Custom_PropRenderViewportScaleInternalv,__Z35VRDevice_Get_Custom_PropRefreshRatev,__Z39VRStats_Get_Custom_PropGpuTimeLastFramev
,b99,b99,b99,b99,b99];
var FUNCTION_TABLE_vffff = [b100,__Z29GL_CUSTOM_LoadPixelMatrixArgsffff,_glClearColor__wrapper,_emscripten_glRotatef__wrapper,_emscripten_glClearColor__wrapper,_emscripten_glBlendColor__wrapper,b100,b100];
var FUNCTION_TABLE_iiiff = [b101,__Z43Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointRK13Vector2fIcalliff,__Z46Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointAllRK13Vector2fIcalliff,b101];
var FUNCTION_TABLE_viii = [b102,__ZN13ScreenManager23SetIsOrientationEnabledE18EnabledOrientationb,__ZN20LocalFileSystemPosix10ToAbsoluteEPKc,__ZNK20LocalFileSystemPosix12LastModifiedERK13FileEntryData,__ZNK17FileSystemHandler12GetAssetGUIDERK13FileEntryData,__ZN16BaseVideoTexture15InitVideoMemoryEii,__ZN13BaseAllocator17GetFreeBlockCountEPii,__ZN13BaseAllocator17GetUsedBlockCountEPii,__ZNK20LightPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK17IAnimationBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE,__ZN10GUITexture16RenderGUIElementERK5RectTIfER17ShaderPassContext,__ZN10GUITexture13GetScreenRectERK5RectTIfE,__ZN14DirectorPlayer4PlayE9HPlayableP12Il2CppObject,__ZN8Playable12PrepareFrameERK9FrameDataPS_,__ZN9GfxDevice21SetWorldMatrixAndTypeERK10Matrix4x4f13TransformType,__ZN9GfxDevice14EndBufferWriteEP9GfxBufferj,__ZN9GfxDevice23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_,__ZN9GfxDevice30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_,__ZN9GfxDevice21CopyRenderSurfaceDescEP17RenderSurfaceBasePKS0_,__ZN9GfxDevice26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID,__ZN9GfxDevice11CopyTextureE9TextureIDS0_,__ZN9GfxDevice14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns,__ZN9GfxDevice14ProfileControlENS_17GfxProfileControlEj,__ZN9GfxDevice14SetTextureNameE9TextureIDPKc,__ZN9GfxDevice20SetRenderSurfaceNameEP17RenderSurfaceBasePKc,__ZN9GfxDevice13SetBufferNameEP9GfxBufferPKc,__ZN9GfxDevice17SetGpuProgramNameEP10GpuProgramPKc,__ZN9GfxDevice26InsertCustomMarkerCallbackEPFviEi,__ZN9GfxDevice28SetComputeBufferCounterValueE15ComputeBufferIDj
,__ZN9GfxDevice27SetRandomWriteTargetTextureEi9TextureID,__ZN9GfxDevice26SetRandomWriteTargetBufferEi15ComputeBufferID,__ZN9GfxDevice29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE,__ZN9GfxDevice17SendVRDeviceEventEjj,__ZN12ImageDecoder11SetReadFuncEPvPFjS0_PhjE,__ZNK29LineParametersPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK28RectTransformPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK28RectTransformPropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE,__ZNK24RendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK32RendererMaterialAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK25BlendshapePropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK25BlendshapePropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE,__ZNK30SpriteRendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK22GenericPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK28MonoBehaviourPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZN19RuntimeSceneManager11MergeScenesER10UnitySceneS1_,__ZN25PathNamePersistentManager24PathIDToPathNameInternalEi,__ZN25PathNamePersistentManager30PathIDToFileIdentifierInternalEi,__ZN17ArchiveFileSystem10ToAbsoluteEPKc,__ZNK17ArchiveFileSystem12LastModifiedERK13FileEntryData,__ZNK17ArchiveFileSystem12GetAssetGUIDERK13FileEntryData,__ZN12HandlerChain10ToAbsoluteEPKc,__ZNK12HandlerChain12LastModifiedERK13FileEntryData,__ZNK12HandlerChain12GetAssetGUIDERK13FileEntryData,__ZN22LocalFileSystemHandler10ToAbsoluteEPKc,__ZNK17FileSystemHandler12LastModifiedERK13FileEntryData,__ZN16MemoryFileSystem10ToAbsoluteEPKc,__ZNK16MemoryFileSystem12LastModifiedERK13FileEntryData,__ZNK16MemoryFileSystem12GetAssetGUIDERK13FileEntryData,__ZN25MultiBlocksMemoryFileData9SetLengthEy
,__ZN24RingBufferMemoryFileData9SetLengthEy,__ZN25SingleBlockMemoryFileData9SetLengthEy,__ZN21AssetBundleFileSystem10ToAbsoluteEPKc,__ZN13GfxDeviceGLES15SetStencilStateEPK18DeviceStencilStatei,__ZN13GfxDeviceGLES14EndBufferWriteEP9GfxBufferj,__ZN13GfxDeviceGLES19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_,__ZN13GfxDeviceGLES23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_,__ZN13GfxDeviceGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_,__ZN13GfxDeviceGLES26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID,__ZN13GfxDeviceGLES11CopyTextureE9TextureIDS0_,__ZN13GfxDeviceGLES14SetTextureNameE9TextureIDPKc,__ZN13GfxDeviceGLES20SetRenderSurfaceNameEP17RenderSurfaceBasePKc,__ZN13GfxDeviceGLES13SetBufferNameEP9GfxBufferPKc,__ZN13GfxDeviceGLES17SetGpuProgramNameEP10GpuProgramPKc,__ZN13GfxDeviceGLES28SetComputeBufferCounterValueE15ComputeBufferIDj,__ZN13GfxDeviceGLES27SetRandomWriteTargetTextureEi9TextureID,__ZN13GfxDeviceGLES26SetRandomWriteTargetBufferEi15ComputeBufferID,__ZN13GfxDeviceGLES29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE,__ZN18GlslGpuProgramGLES15ApplyGpuProgramERK20GpuProgramParametersPKh,__ZN13GfxDeviceNull15SetStencilStateEPK18DeviceStencilStatei,__ZN13GfxDeviceNull14EndBufferWriteEP9GfxBufferj,__ZN13GfxDeviceNull19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_,__ZN13GfxDeviceNull14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns,__ZN14NullGpuProgram15ApplyGpuProgramERK20GpuProgramParametersPKh,__ZN11UmbraModule24OcclusionCullLocalLightsER21LocalLightCullJobDataR10BlockRange,__ZNK29ParticleSystemPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi,__ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE
,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN5physx3Ext7D6Joint9setMotionENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE,__ZN5physx3Ext7D6Joint8setDriveENS_9PxD6Drive4EnumERKNS_14PxD6JointDriveE,__ZNK5physx3Ext7D6Joint8getDriveENS_9PxD6Drive4EnumE,__ZN5physx3Ext7D6Joint16setDriveVelocityERKNS_6PxVec3ES4_,__ZNK5physx3Ext7D6Joint16getDriveVelocityERNS_6PxVec3ES3_,__ZN5physx3Ext20ProfileZoneInterface17handleBufferFlushEPKhj,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN5physx3Ext13DistanceJoint20setDistanceJointFlagENS_19PxDistanceJointFlag4EnumEb,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN17InternalIndexPool11freeIndicesEjRKN5physx16PxStrideIteratorIKjEE,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE
,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN5physx3Ext14PrismaticJoint21setPrismaticJointFlagENS_20PxPrismaticJointFlag4EnumEb,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN5physx3Ext13RevoluteJoint20setRevoluteJointFlagENS_19PxRevoluteJointFlag4EnumEb,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getBreakForceERfS5_,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb,__ZN5physx3Ext14SphericalJoint21setSphericalJointFlagENS_20PxSphericalJointFlag4EnumEb,__ZN5physx2Sn21SerializationRegistry18registerSerializerEtRNS_12PxSerializerE,__ZN5physx2Sn21SerializationRegistry22registerRepXSerializerEtRNS_16PxRepXSerializerE,__ZN5physx2Sn20SerializationContext9writeDataEPKvj,__ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Sc8ShapeSim13getFilterInfoERjRNS_12PxFilterDataE
,__ZN5physx2Sc7BodySim19postActorFlagChangeEjj,__ZN5physx2Sc8ActorSim19postActorFlagChangeEjj,__ZNK5physx2Sc10ClothShape13getFilterInfoERjRNS_12PxFilterDataE,__ZN5physx14NpArticulation24setSolverIterationCountsEjj,__ZNK5physx14NpArticulation24getSolverIterationCountsERjS1_,__ZNK5physx19NpArticulationJoint13getSwingLimitERfS1_,__ZNK5physx19NpArticulationJoint13getTwistLimitERfS1_,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11detachShapeERNS_7PxShapeEb,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb,__ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformEb,__ZN5physx18NpArticulationLink17setLinearVelocityERKNS_6PxVec3Eb,__ZN5physx18NpArticulationLink18setAngularVelocityERKNS_6PxVec3Eb,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZNK5physx12NpConstraint9getActorsERPNS_12PxRigidActorES3_,__ZN5physx12NpConstraint9setActorsEPNS_12PxRigidActorES2_,__ZN5physx12NpConstraint7setFlagENS_16PxConstraintFlag4EnumEb,__ZNK5physx12NpConstraint8getForceERNS_6PxVec3ES2_,__ZNK5physx12NpConstraint13getBreakForceERfS1_,__ZN5physx12NpConstraint22setConstraintFunctionsERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableE,__ZN5physx10NpMaterial7setFlagENS_14PxMaterialFlag4EnumEb,__ZN5physx7NpShape12setMaterialsEPKPNS_10PxMaterialEt,__ZN5physx7NpShape7setFlagENS_11PxShapeFlag4EnumEb,__ZN5physx7NpShape9visualizeERNS_2Cm12RenderOutputERKNS_12PxRigidActorE,__ZN5physx15NpActorTemplateINS_7PxClothEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx7NpCloth12setParticlesEPKNS_15PxClothParticleES3_,__ZN5physx7NpCloth12setClothFlagENS_11PxClothFlag4EnumEb,__ZN5physx7NpCloth16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE,__ZNK5physx7NpCloth16getStretchConfigENS_22PxClothFabricPhaseType4EnumE
,__ZN5physx7NpCloth19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj,__ZN5physx7NpCloth19addCollisionCapsuleEjj,__ZN5physx7NpCloth18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj,__ZN5physx7NpCloth21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj,__ZN5physx7NpCloth23setSelfCollisionIndicesEPKjj,__ZN5physx7NpCloth9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getProjectionPlaneERNS_6PxVec3ERf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb,__ZN5physx15PxsParticleData16removeParticlesVEjRKNS_16PxStrideIteratorIKjEE,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getProjectionPlaneERNS_6PxVec3ERf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb,__ZN5physx16NpParticleSystem23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11detachShapeERNS_7PxShapeEb,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb,__ZN5physx14NpRigidDynamic13setGlobalPoseERKNS_11PxTransformEb,__ZN5physx14NpRigidDynamic17setLinearVelocityERKNS_6PxVec3Eb,__ZN5physx14NpRigidDynamic18setAngularVelocityERKNS_6PxVec3Eb,__ZN5physx14NpRigidDynamic24setSolverIterationCountsEjj,__ZNK5physx14NpRigidDynamic24getSolverIterationCountsERjS1_,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11detachShapeERNS_7PxShapeEb
,__ZN5physx13NpRigidStatic13setGlobalPoseERKNS_11PxTransformEb,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb,__ZN5physx7NpScene7setFlagENS_11PxSceneFlag4EnumEb,__ZN5physx7NpScene18removeArticulationERNS_14PxArticulationEb,__ZN5physx7NpScene9addActorsEPKPNS_7PxActorEj,__ZN5physx7NpScene11removeActorERNS_7PxActorEb,__ZN5physx7NpScene15removeAggregateERNS_11PxAggregateEb,__ZN5physx7NpScene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE,__ZN5physx7NpScene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh,__ZN5physx7NpScene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh,__ZN5physx7NpScene23forceDynamicTreeRebuildEbb,__ZN5physx7NpScene8lockReadEPKcj,__ZN5physx7NpScene9lockWriteEPKcj,__ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeJointFramesERKNS_11PxTransformES4_,__ZN5physx2Sq12BucketPruner13removeObjectsEPKjj,__ZNK5physx2Sq12BucketPruner9visualizeERNS_2Cm12RenderOutputEj,__ZN5physx2Sq10AABBPruner13removeObjectsEPKjj,__ZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEj,__ZN5physx32solveContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx20solve1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx40solveContactCoulomb_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx36solveContactCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx42solveContactCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx22solve1D4Block_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx18solveFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx26solveFriction_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx37solveFrictionCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx43solveFrictionCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx24solveContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx12solve1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE
,__ZN5physx32solveContactCoulomb_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx27solveContactCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx34solveContactCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx14solve1D4_BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx28solveFrictionCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx35solveFrictionCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx25solveContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx33solveContact_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx29solveContactPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx35solveContactPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx17solveContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx25solveContact_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx20solveContactPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx27solveContactPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx9PxTaskMgr12finishBeforeERNS_6PxTaskEj,__ZN5physx9PxTaskMgr10startAfterERNS_6PxTaskEj,__ZN5physx9PxTaskMgr14emitStartEventERNS_10PxBaseTaskEj,__ZN5physx9PxTaskMgr13emitStopEventERNS_10PxBaseTaskEj,__ZNK5physx2Sc19ParticlePacketShape13getFilterInfoERjRNS_12PxFilterDataE,__ZNK5physx2Gu11HeightField17getTriangleNormalEj,__ZN5physx14NpSpatialIndex6updateEjRKNS_9PxBounds3E,__ZNK5physx14NpSpatialIndex7overlapERKNS_9PxBounds3ERNS_24PxSpatialOverlapCallbackE,__ZNK5physx14NpSpatialIndex9getBoundsEj,__ZNK5physx20PxsParticleSystemSim19getSimParticleDataVERNS_28PxvParticleSystemSimDataDescEb,__ZN5physx2Cm10Collection8removeIdEy,__ZN11BoxCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f,__ZN8Collider22GetPositionAndRotationERK9TransformR10Matrix4x4f,__ZN15CapsuleCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f,__ZN14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj,__ZN14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj
,__ZN14PhysicsManager6onWakeEPPN5physx7PxActorEj,__ZN14PhysicsManager7onSleepEPPN5physx7PxActorEj,__ZThn28_N14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj,__ZThn28_N14PhysicsManager6onWakeEPPN5physx7PxActorEj,__ZThn28_N14PhysicsManager7onSleepEPPN5physx7PxActorEj,__ZThn28_N14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj,__ZN14SphereCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f,__ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE17handleBufferFlushEPKhj,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj,__ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj,__ZN12_GLOBAL__N_1L4gANDERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L3gORERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L4gXORERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L5gNANDERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L4gNORERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L5gNXORERN5physx12PxGroupsMaskERKS1_S4_,__ZN12_GLOBAL__N_1L9gSWAP_ANDERN5physx12PxGroupsMaskERKS1_S4_,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE
,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE
,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE
,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZN12_GLOBAL__N_118LegacySerialStream9writeDataEPKvj,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE12addAttributeEPKcS5_,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE15writeContentTagEPKcS5_,__ZN5physx2Sn13XmlWriterImpl5writeEPKcS3_,__ZN5physx2Sn13XmlWriterImpl5writeEPKcRKNS_12PxRepXObjectE,__ZN5physx2Sn13XmlNodeWriter12addAttributeEPKcS3_,__ZN5physx2Sn13XmlNodeWriter15writeContentTagEPKcS3_,__ZN5physx24NpPtrTableStorageManager10deallocateEPPvj,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE,__ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE17handleBufferFlushEPKhj,__ZN12_GLOBAL__N_110Connection11setPickableEPKvb,__ZN12_GLOBAL__N_110Connection8setColorEPKvRKN5physx8debugger8PvdColorE,__ZN12_GLOBAL__N_110Connection22setIsTopLevelUIElementEPKvb
,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl16getOrCreateClassERKN5physx8debugger14NamespacedNameE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl9findClassERKN5physx8debugger14NamespacedNameE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl8getClassEN5physx8debugger18NonNegativeIntegerE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getParentClassEN5physx8debugger18NonNegativeIntegerE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl11getPropertyEN5physx8debugger18NonNegativeIntegerE,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl22setNamedPropertyValuesEN5physx8debugger7DataRefINS2_10NamedValueEEENS2_18NonNegativeIntegerE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl22getNamedPropertyValuesEN5physx8debugger18NonNegativeIntegerE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19findPropertyMessageERKN5physx8debugger14NamespacedNameE,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl18getPropertyMessageEN5physx8debugger18NonNegativeIntegerE,__ZN12_GLOBAL__N_117MemoryEventClient17handleBufferFlushEPKhj,__ZN12_GLOBAL__N_110DataStream14addProfileZoneEPvPKc,__ZN12_GLOBAL__N_124PropertyDefinitionHelper8pushNameEPKcS2_,__ZN12_GLOBAL__N_124PropertyDefinitionHelper13addNamedValueEPKcj,__ZN12_GLOBAL__N_117ProfileZoneClient17handleBufferFlushEPKhj,__ZN12_GLOBAL__N_119RendererEventClient17handleBufferFlushEPKhj,__ZN12_GLOBAL__N_112UserRenderer10drawPointsEPKN5physx8debugger8renderer8PvdPointEj,__ZN12_GLOBAL__N_112UserRenderer9drawLinesEPKN5physx8debugger8renderer7PvdLineEj,__ZN12_GLOBAL__N_112UserRenderer13drawTrianglesEPKN5physx8debugger8renderer11PvdTriangleEj,__ZN12_GLOBAL__N_112UserRenderer20visualizeJointFramesERKN5physx11PxTransformES4_,__ZN12_GLOBAL__N_117ConnectionManager11setPickableEPKvb,__ZN12_GLOBAL__N_117ConnectionManager8setColorEPKvRKN5physx8debugger8PvdColorE,__ZN12_GLOBAL__N_117ConnectionManager22setIsTopLevelUIElementEPKvb,__ZN12_GLOBAL__N_16ParserILb1EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE,__ZN12_GLOBAL__N_16ParserILb0EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE,__ZN13PhysicsModule17SetRigidBodyStateER9RigidbodyRKN8IPhysics14RigidBodyStateE,__ZN13PhysicsModule17GetRigidBodyStateERK9RigidbodyPN8IPhysics14RigidBodyStateE,__ZN13PhysicsModule20GetRigidBodyVelocityERK9Rigidbody,__ZN17b2ContactListener8PreSolveEP9b2ContactPK10b2Manifold,__ZN17b2ContactListener9PostSolveEP9b2ContactPK16b2ContactImpulse,__ZN19CollisionListener2D8PreSolveEP9b2ContactPK10b2Manifold
,__ZN16Physics2DManager20GetRigidBodyVelocityERK11Rigidbody2D,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE,__ZNK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZNK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZNK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZNK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE,__ZNK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZThn4_NK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZThn4_NK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZThn4_NK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZThn4_NK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE,__ZThn4_NK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE,__ZN5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE,__ZN11AudioModule14SetBypassOnDSPEPN4FMOD3DSPEb
,__ZN8Animator4PlayE9HPlayableP12Il2CppObject,__ZN17AnimationPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE,__ZN21AnimationPosePlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE,__ZN21AnimationClipPlayable12PrepareFrameERK9FrameDataP8Playable,__ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playable,__ZN26AnimatorControllerPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE,__ZNK18AnimatorController12StringFromIDEj,__ZNK26AnimatorOverrideController12StringFromIDEj,__ZN14TerrainManager17Heightmap_GetSizeER9Heightmap,__ZN14TerrainManager15CullAllTerrainsEP6CameraRK17CullingParameters,__ZN14TerrainManager12GetWorldAABBEP7Terrain,__ZN14TerrainManager12GetWorldAABBEPN5Unity9ComponentE,__ZN14TerrainManager18GetTerrainPositionEP7Terrain,__ZN14TerrainManager21OffsetLightmapIndicesE18RemapLightmapIndexS0_,__ZN20TextRenderingPrivate7GUIText16RenderGUIElementERK5RectTIfER17ShaderPassContext,__ZN20TextRenderingPrivate7GUIText13GetScreenRectERK5RectTIfE,__ZN20TerrainPhysicsModule21AttachTerrainColliderER10GameObjectP11TerrainData,__ZN8VRDevice7PreCullEP6Camerab,__ZN8VRDevice6EndEyeEPK6Camerai,__ZN8VRDevice17SendVRDeviceEventEjj,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE7SetDataEPKhj,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16SetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEESC_,__ZNKSt3__214error_category23default_error_conditionEi,__ZNKSt3__223__future_error_category7messageEi,__ZNKSt3__219__iostream_category7messageEi,__ZNKSt3__212__do_message7messageEi,__ZNKSt3__224__generic_error_category7messageEi,__ZNKSt3__223__system_error_category23default_error_conditionEi,__ZNKSt3__223__system_error_category7messageEi,_UNITY_png_default_read_data
,_UNITY_png_read_filter_row_sub,_UNITY_png_read_filter_row_up,_UNITY_png_read_filter_row_avg,_UNITY_png_read_filter_row_paeth_1byte_pixel,_UNITY_png_read_filter_row_paeth_multibyte_pixel,_UNITY_png_default_write_data,_write_marker_header,_convsamp,_jsimd_convsamp,_jsimd_quantize,_quantize,_format_message,__ZN13EmscriptenWWW10OnProgressEPvjj,__Z20RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns,__ZZN6Camera15InitializeClassEvEN31FunctorImpl_99kTransformChanged4CallEPviR11MessageData,__ZZN9LensFlare15InitializeClassEvEN32FunctorImpl_770kTransformChanged4CallEPviR11MessageData,__ZZN4Halo15InitializeClassEvEN31FunctorImpl_48kTransformChanged4CallEPviR11MessageData,__ZZN5Light15InitializeClassEvEN31FunctorImpl_36kTransformChanged4CallEPviR11MessageData,__Z16Projector_RenderRK15RenderNodeQueuejR17ShaderPassContext,_UNITY_png_destroy_read_struct,_UNITY_png_set_read_fn,__ZL21LibpngReadFuncWrapperP14png_struct_defPhj,_UNITY_png_set_add_alpha,_UNITY_png_set_crc_action,_jpeg_CreateDecompress,__ZL36PostLoadSceneStatic_LightmapSettingsiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZL21GetAllTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE,__ZL25GetSubmeshTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE,__ZL17WriteToBufferFuncPvPhj,__ZL20PngWriteToMemoryFuncP14png_struct_defPhj
,__ZL20JpgWriteToBufferFuncPvS_i,__ZN8DrawUtil36DrawLineOrTrailMultipleFromNodeQueueERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns,__ZZN2UI13RectTransform15InitializeClassEvEN31FunctorImpl_65kTransformChanged4CallEPviR11MessageData,__ZZN8Renderer15InitializeClassEvEN32FunctorImpl_130kTransformChanged4CallEPviR11MessageData,__ZZN8Renderer15InitializeClassEvEN28FunctorImpl_131kLayerChanged4CallEPviR11MessageData,__ZZN13TrailRenderer15InitializeClassEvEN31FunctorImpl_27kTransformChanged4CallEPviR11MessageData,__ZL23CheckAndClearChangedJobPiPK23TransformAccessReadOnlyj,__ZL31GetAndClearChangedTransformsJobP27GetChangedTransformsJobDataPK23TransformAccessReadOnlyj,__Z32BillboardRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns,__ZN6prcoreL10inner_flipILj2EEEvPhS1_j,__ZN6prcoreL10inner_flipILj4EEEvPhS1_j,__ZN6prcoreL10inner_flipILj1EEEvPhS1_j,__ZN6prcoreL10inner_flipILj3EEEvPhS1_j,__ZZN8LODGroup15InitializeClassEvEN32FunctorImpl_428kTransformChanged4CallEPviR11MessageData,__ZZN10MeshFilter15InitializeClassEvEN30FunctorImpl_84kDidAddComponent4CallEPviR11MessageData,__ZZN12MeshRenderer15InitializeClassEvEN30FunctorImpl_98kDidModifyBounds4CallEPviR11MessageData,__ZZN12MeshRenderer15InitializeClassEvEN28FunctorImpl_99kDidDeleteMesh4CallEPviR11MessageData,__ZZN12MeshRenderer15InitializeClassEvEN29FunctorImpl_100kDidModifyMesh4CallEPviR11MessageData,__ZN19SkinnedMeshRenderer24AnimatorModifiedCallbackEPvS0_i,__Z29SpriteRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns,__ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_788kBecameVisible4CallEPviR11MessageData,__ZZN19SkinnedMeshRenderer15InitializeClassEvEN31FunctorImpl_789kBecameInvisible4CallEPviR11MessageData,__ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_791kDidDeleteMesh4CallEPviR11MessageData,__ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_792kDidModifyMesh4CallEPviR11MessageData,__ZL30RegisterFilteredObjectCallbackPP12Il2CppObjectiPv,__ZL41RuntimeInitializeOnSceneLoadedBeforeAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZL40RuntimeInitializeOnSceneLoadedAfterAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZN19GCProfilerCallbacks9OnGCEventEPvii,__ZN19GCProfilerCallbacksL10OnGCResizeEPvx,__ZN18ProfilerConnection21EnableProfilerMessageEPKvjj
,__ZN18ProfilerConnection17GetMemorySnapshotEPKvjj,__ZN18ProfilerConnection22GetObjectMemoryProfileEPKvjj,__ZN18ProfilerConnection41HandleQueryInstrumentableFunctionsMessageEPKvjj,__ZN18ProfilerConnection33HandleQueryFunctionCalleesMessageEPKvjj,__ZN18ProfilerConnection36HandleBeginInstrumentFunctionMessageEPKvjj,__ZN18ProfilerConnection34HandleEndInstrumentFunctionMessageEPKvjj,__ZN18ProfilerConnection42HandleSetAutoInstrumentedAssembliesMessageEPKvjj,__ZN18ProfilerConnection32HandleSetMemoryRecordModeMessageEPKvjj,__ZN18ProfilerConnection26HandleSetAudioCaptureFlagsEPKvjj,__ZL14SceneWasLoadediR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__Z59AssetBundleManifest_CUSTOM_INTERNAL_CALL_GetAssetBundleHashP12Il2CppObjectP12Il2CppStringR7Hash128,__Z44BillboardAsset_CUSTOM_MakeMaterialPropertiesP12Il2CppObjectS0_S0_,__Z34Camera_CUSTOM_SetTargetBuffersImplP12Il2CppObjectP21ScriptingRenderBufferS2_,__Z37Camera_CUSTOM_SetTargetBuffersMRTImplP12Il2CppObjectP11Il2CppArrayP21ScriptingRenderBuffer,__Z47Camera_CUSTOM_INTERNAL_CALL_GetStereoViewMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f,__Z49Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatricesP12Il2CppObjectRK10Matrix4x4fS3_,__Z47Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f,__Z53Camera_CUSTOM_INTERNAL_CALL_GetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f,__Z53Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f,__Z55Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatricesP12Il2CppObjectRK10Matrix4x4fS3_,__Z46Camera_CUSTOM_INTERNAL_CALL_WorldToScreenPointP12Il2CppObjectRK8Vector3fRS1_,__Z48Camera_CUSTOM_INTERNAL_CALL_WorldToViewportPointP12Il2CppObjectRK8Vector3fRS1_,__Z48Camera_CUSTOM_INTERNAL_CALL_ViewportToWorldPointP12Il2CppObjectRK8Vector3fRS1_,__Z46Camera_CUSTOM_INTERNAL_CALL_ScreenToWorldPointP12Il2CppObjectRK8Vector3fRS1_,__Z49Camera_CUSTOM_INTERNAL_CALL_ScreenToViewportPointP12Il2CppObjectRK8Vector3fRS1_,__Z49Camera_CUSTOM_INTERNAL_CALL_ViewportToScreenPointP12Il2CppObjectRK8Vector3fRS1_,__Z46Camera_CUSTOM_INTERNAL_CALL_ViewportPointToRayP12Il2CppObjectRK8Vector3fR3Ray,__Z44Camera_CUSTOM_INTERNAL_CALL_ScreenPointToRayP12Il2CppObjectRK8Vector3fR3Ray,__Z30Camera_CUSTOM_RenderWithShaderP12Il2CppObjectS0_P12Il2CppString,__Z34Camera_CUSTOM_SetReplacementShaderP12Il2CppObjectS0_P12Il2CppString
,__Z30Camera_CUSTOM_AddCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_,__Z33Camera_CUSTOM_RemoveCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_,__Z50Camera_CUSTOM_INTERNAL_CALL_CalculateObliqueMatrixP12Il2CppObjectRK8Vector4fR10Matrix4x4f,__Z37Component_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr,__Z45Component_CUSTOM_GetComponentsForListInternalP12Il2CppObjectS0_S0_,__Z27ComputeShader_CUSTOM_SetIntP12Il2CppObjectii,__Z44ComputeShader_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f,__Z39ComputeShader_CUSTOM_Internal_SetFloatsP12Il2CppObjectiP11Il2CppArray,__Z37ComputeShader_CUSTOM_Internal_SetIntsP12Il2CppObjectiP11Il2CppArray,__Z36ComputeBuffer_CUSTOM_InternalSetDataP12Il2CppObjectP11Il2CppArrayi,__Z36ComputeBuffer_CUSTOM_InternalGetDataP12Il2CppObjectP11Il2CppArrayi,__Z30ComputeBuffer_CUSTOM_CopyCountP12Il2CppObjectS0_i,__Z37Cursor_CUSTOM_INTERNAL_CALL_SetCursorP12Il2CppObjectRK13Vector2fIcall10CursorMode,__Z35DebugLogHandler_CUSTOM_Internal_Log7LogTypeP12Il2CppStringP12Il2CppObject,__Z32Debug_CUSTOM_SetDiagnosticSwitchP12Il2CppStringP12Il2CppObjecth,__Z31Display_CUSTOM_GetSystemExtImpl13Il2Cpp_IntPtrPiS0_,__Z34Display_CUSTOM_GetRenderingExtImpl13Il2Cpp_IntPtrPiS0_,__Z38Display_CUSTOM_GetRenderingBuffersImpl13Il2Cpp_IntPtrP21ScriptingRenderBufferS1_,__Z41Display_CUSTOM_SetRenderingResolutionImpl13Il2Cpp_IntPtrii,__Z35RectOffset_CUSTOM_INTERNAL_CALL_AddP12Il2CppObjectRK5RectTIfERS2_,__Z38RectOffset_CUSTOM_INTERNAL_CALL_RemoveP12Il2CppObjectRK5RectTIfERS2_,__Z45GUIElement_CUSTOM_INTERNAL_CALL_GetScreenRectP12Il2CppObjectS0_R5RectTIfE,__Z38GameObject_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr,__Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawIconRK8Vector3fP12Il2CppStringh,__Z23Gradient_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArrayS2_,__Z34Renderer_CUSTOM_SetStaticBatchInfoP12Il2CppObjectii,__Z45LineRenderer_CUSTOM_INTERNAL_CALL_SetPositionP12Il2CppObjectiRK8Vector3f,__Z45LineRenderer_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectiR8Vector3f,__Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f,__Z51MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf
,__Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f,__Z39MaterialPropertyBlock_CUSTOM_SetTextureP12Il2CppObjectiS0_,__Z38MaterialPropertyBlock_CUSTOM_SetBufferP12Il2CppObjectiS0_,__Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetVectorP12Il2CppObjectiR8Vector4f,__Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f,__Z50MaterialPropertyBlock_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_,__Z51MaterialPropertyBlock_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_,__Z51MaterialPropertyBlock_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_,__Z46MaterialPropertyBlock_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray,__Z50MaterialPropertyBlock_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_,__Z47MaterialPropertyBlock_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray,__Z51MaterialPropertyBlock_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_,__Z47MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray,__Z51MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_,__Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow2P12Il2CppObjectRK10Matrix4x4fi,__Z30Graphics_CUSTOM_DrawProcedural16GfxPrimitiveTypeii,__Z38Graphics_CUSTOM_DrawProceduralIndirect16GfxPrimitiveTypeP12Il2CppObjecti,__Z51Graphics_CUSTOM_Internal_SetRandomWriteTargetBufferiP12Il2CppObjecth,__Z53LightProbes_CUSTOM_INTERNAL_CALL_GetInterpolatedProbeRK8Vector3fP12Il2CppObjectP20SphericalHarmonicsL2,__Z52GeometryUtility_CUSTOM_INTERNAL_CALL_CalculateBoundsP11Il2CppArrayRK10Matrix4x4fR4AABB,__Z46GL_CUSTOM_INTERNAL_CALL_GetGPUProjectionMatrixRK10Matrix4x4fhRS_,__Z29Light_CUSTOM_AddCommandBufferP12Il2CppObject20RenderLightEventTypeS0_,__Z32Light_CUSTOM_RemoveCommandBufferP12Il2CppObject20RenderLightEventTypeS0_,__Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize3R8Vector3fS0_S0_,__Z46Quaternion_CUSTOM_INTERNAL_CALL_FromToRotationRK8Vector3fS1_R11Quaternionf,__Z44Quaternion_CUSTOM_INTERNAL_CALL_LookRotationRK8Vector3fS1_R11Quaternionf,__Z55Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToAxisAngleRadRK11QuaternionfP8Vector3fPf,__Z52Bounds_CUSTOM_INTERNAL_CALL_Internal_GetClosestPointR4AABBR8Vector3fS2_,__Z51AnimationCurve_CUSTOM_INTERNAL_CALL_GetKey_InternalP12Il2CppObjectiR16KeyframeTplFloat,__Z50Mesh_CUSTOM_INTERNAL_CALL_GetNativeVertexBufferPtrP12Il2CppObjectiRPv
,__Z46Playable_CUSTOM_INTERNAL_CALL_GetInputInternalR9HPlayableiS0_,__Z47Playable_CUSTOM_INTERNAL_CALL_GetOutputInternalR9HPlayableiS0_,__Z45CommandBuffer_CUSTOM_SetRenderTarget_MultipleP12Il2CppObjectP11Il2CppArrayR26MonoRenderTargetIdentifier,__Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalVectorP12Il2CppObjectiRK8Vector4f,__Z49CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalColorP12Il2CppObjectiRK10ColorRGBAf,__Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalMatrixP12Il2CppObjectiRK10Matrix4x4f,__Z48CommandBuffer_CUSTOM_SetGlobalFloatArrayListImplP12Il2CppObjectiS0_,__Z40CommandBuffer_CUSTOM_SetGlobalFloatArrayP12Il2CppObjectiP11Il2CppArray,__Z49CommandBuffer_CUSTOM_SetGlobalVectorArrayListImplP12Il2CppObjectiS0_,__Z41CommandBuffer_CUSTOM_SetGlobalVectorArrayP12Il2CppObjectiP11Il2CppArray,__Z49CommandBuffer_CUSTOM_SetGlobalMatrixArrayListImplP12Il2CppObjectiS0_,__Z41CommandBuffer_CUSTOM_SetGlobalMatrixArrayP12Il2CppObjectiP11Il2CppArray,__Z42CommandBuffer_CUSTOM_SetGlobalTexture_ImplP12Il2CppObjectiR26MonoRenderTargetIdentifier,__Z36CommandBuffer_CUSTOM_SetGlobalBufferP12Il2CppObjectiS0_,__Z47CommandBuffer_CUSTOM_SetShadowSamplingMode_ImplP12Il2CppObjectR26MonoRenderTargetIdentifier18ShadowSamplingMode,__Z45CommandBuffer_CUSTOM_IssuePluginEventInternalP12Il2CppObject13Il2Cpp_IntPtri,__Z37RuntimeUndo_CUSTOM_SetTransformParentP12Il2CppObjectS0_P12Il2CppString,__Z38Material_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf,__Z38Material_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectiR10ColorRGBAf,__Z26Material_CUSTOM_SetTextureP12Il2CppObjectiS0_,__Z49Material_CUSTOM_Internal_GetTextureScaleAndOffsetP12Il2CppObjectP12Il2CppStringP8Vector4f,__Z46Material_CUSTOM_INTERNAL_CALL_SetTextureOffsetP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall,__Z45Material_CUSTOM_INTERNAL_CALL_SetTextureScaleP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall,__Z39Material_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f,__Z39Material_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f,__Z37Material_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_,__Z33Material_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray,__Z38Material_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_,__Z34Material_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray,__Z37Material_CUSTOM_SetColorArrayImplListP12Il2CppObjectiS0_
,__Z33Material_CUSTOM_SetColorArrayImplP12Il2CppObjectiP11Il2CppArray,__Z38Material_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_,__Z34Material_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray,__Z37Material_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_,__Z38Material_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_,__Z37Material_CUSTOM_GetColorArrayImplListP12Il2CppObjectiS0_,__Z38Material_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_,__Z29Material_CUSTOM_SetBufferImplP12Il2CppObjectiS0_,__Z30Material_CUSTOM_SetOverrideTagP12Il2CppObjectP12Il2CppStringS2_,__Z66ShaderVariantCollection_ShaderVariant_CUSTOM_Internal_CheckVariantP12Il2CppObject14ShaderPassTypeP11Il2CppArray,__Z69SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddDirectionalLightInternalRK8Vector3fRK10ColorRGBAfR20SphericalHarmonicsL2,__Z30Sprite_CUSTOM_OverrideGeometryP12Il2CppObjectP11Il2CppArrayS2_,__Z31Texture2D_CUSTOM_SetAllPixels32P12Il2CppObjectP11Il2CppArrayi,__Z47Texture2D_CUSTOM_LoadRawTextureData_ImplPointerP12Il2CppObject13Il2Cpp_IntPtri,__Z22Texture2D_CUSTOM_ApplyP12Il2CppObjecthh,__Z20Cubemap_CUSTOM_ApplyP12Il2CppObjecthh,__Z26Texture3D_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayi,__Z28Texture3D_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayi,__Z22Texture3D_CUSTOM_ApplyP12Il2CppObjecthh,__Z27Texture2DArray_CUSTOM_ApplyP12Il2CppObjecthh,__Z25CubemapArray_CUSTOM_ApplyP12Il2CppObjecthh,__Z36RenderTexture_CUSTOM_DiscardContentsP12Il2CppObjecthh,__Z50Transform_CUSTOM_INTERNAL_CALL_GetLocalEulerAnglesP12Il2CppObjectN4math13RotationOrderER8Vector3f,__Z50Transform_CUSTOM_INTERNAL_CALL_SetLocalEulerAnglesP12Il2CppObjectRK8Vector3fN4math13RotationOrderE,__Z26Transform_CUSTOM_SetParentP12Il2CppObjectS0_h,__Z37Transform_CUSTOM_INTERNAL_CALL_LookAtP12Il2CppObjectRK8Vector3fS3_,__Z49Transform_CUSTOM_INTERNAL_CALL_TransformDirectionP12Il2CppObjectRK8Vector3fRS1_,__Z56Transform_CUSTOM_INTERNAL_CALL_InverseTransformDirectionP12Il2CppObjectRK8Vector3fRS1_,__Z46Transform_CUSTOM_INTERNAL_CALL_TransformVectorP12Il2CppObjectRK8Vector3fRS1_,__Z53Transform_CUSTOM_INTERNAL_CALL_InverseTransformVectorP12Il2CppObjectRK8Vector3fRS1_
,__Z45Transform_CUSTOM_INTERNAL_CALL_TransformPointP12Il2CppObjectRK8Vector3fRS1_,__Z52Transform_CUSTOM_INTERNAL_CALL_InverseTransformPointP12Il2CppObjectRK8Vector3fRS1_,__ZN13MemoryManager24LogDeallocationToConsoleEPvjPKc,__ZN22UnityProfilerPerThread20SampleGCMonoCallbackEPvii,__ZL16sample_gc_resizePvx,__ZL17sample_allocationPvP12Il2CppObjectP11Il2CppClass,__ZN13MonoBehaviour19HandleNotificationsEPviR11MessageData,__ZN13MonoBehaviour17RenderImageFilterEPN5Unity9ComponentEP13RenderTextureS4_,__Z32AndroidJNI_CUSTOM_CallVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectField13Il2Cpp_IntPtrS_RPv,__Z32AndroidJNI_CUSTOM_SetStringField13Il2Cpp_IntPtrS_P12Il2CppString,__Z32AndroidJNI_CUSTOM_SetObjectField13Il2Cpp_IntPtrS_S_,__Z33AndroidJNI_CUSTOM_SetBooleanField13Il2Cpp_IntPtrS_h,__Z30AndroidJNI_CUSTOM_SetByteField13Il2Cpp_IntPtrS_h,__Z30AndroidJNI_CUSTOM_SetCharField13Il2Cpp_IntPtrS_t,__Z31AndroidJNI_CUSTOM_SetShortField13Il2Cpp_IntPtrS_s,__Z29AndroidJNI_CUSTOM_SetIntField13Il2Cpp_IntPtrS_i,__Z38AndroidJNI_CUSTOM_CallStaticVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z52AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticObjectField13Il2Cpp_IntPtrS_RPv,__Z38AndroidJNI_CUSTOM_SetStaticStringField13Il2Cpp_IntPtrS_P12Il2CppString,__Z38AndroidJNI_CUSTOM_SetStaticObjectField13Il2Cpp_IntPtrS_S_,__Z39AndroidJNI_CUSTOM_SetStaticBooleanField13Il2Cpp_IntPtrS_h,__Z36AndroidJNI_CUSTOM_SetStaticByteField13Il2Cpp_IntPtrS_h,__Z36AndroidJNI_CUSTOM_SetStaticCharField13Il2Cpp_IntPtrS_t,__Z37AndroidJNI_CUSTOM_SetStaticShortField13Il2Cpp_IntPtrS_s,__Z35AndroidJNI_CUSTOM_SetStaticIntField13Il2Cpp_IntPtrS_i,__Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToObjectArrayP11Il2CppArray13Il2Cpp_IntPtrRPv,__Z53AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectArrayElement13Il2Cpp_IntPtriRPv,__Z40AndroidJNI_CUSTOM_SetBooleanArrayElement13Il2Cpp_IntPtrih,__Z37AndroidJNI_CUSTOM_SetByteArrayElement13Il2Cpp_IntPtria
,__Z37AndroidJNI_CUSTOM_SetCharArrayElement13Il2Cpp_IntPtrit,__Z38AndroidJNI_CUSTOM_SetShortArrayElement13Il2Cpp_IntPtris,__Z36AndroidJNI_CUSTOM_SetIntArrayElement13Il2Cpp_IntPtrii,__Z39AndroidJNI_CUSTOM_SetObjectArrayElement13Il2Cpp_IntPtriS_,_glBindAttribLocation__wrapper,_glDrawArrays__wrapper,_glGetProgramiv__wrapper,_glGetShaderiv__wrapper,_glGetTexParameteriv__wrapper,_glGetUniformiv__wrapper,_glGetVertexAttribiv__wrapper,_glTexParameteri__wrapper,_glTexParameteriv__wrapper,_glUniform1fv__wrapper,_glUniform1iv__wrapper,_glUniform2fv__wrapper,_glUniform2iv__wrapper,_glUniform3fv__wrapper,_glUniform3iv__wrapper,_glUniform4fv__wrapper,_glUniform4iv__wrapper,_glGetIntegeri_v__wrapper,_glFlushMappedBufferRange__wrapper,_glInvalidateFramebuffer__wrapper,_glBindBufferBase__wrapper,_glUniformBlockBinding__wrapper,_glProgramParameteri__wrapper,_glSamplerParameteri__wrapper,__Z43ParticleSystemRenderer_RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns,__Z47ParticleSystemRenderer_RenderMultipleBillboardsRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns
,__ZZN14ParticleSystem15InitializeClassEvEN32FunctorImpl_241kTransformChanged4CallEPviR11MessageData,__ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_243kDidDeleteMesh4CallEPviR11MessageData,__ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_244kDidModifyMesh4CallEPviR11MessageData,__ZZN22ParticleSystemRenderer15InitializeClassEvEN29FunctorImpl_104kDidDeleteMesh4CallEPviR11MessageData,__Z46ParticleSystem_EmissionModule_CUSTOM_SetBurstsP12Il2CppObjectP11Il2CppArrayi,__Z46ParticleSystem_CollisionModule_CUSTOM_SetPlaneP12Il2CppObjectiS0_,__Z47ParticleSystem_TriggerModule_CUSTOM_SetColliderP12Il2CppObjectiS0_,__Z48ParticleSystem_SubEmittersModule_CUSTOM_SetBirthP12Il2CppObjectiS0_,__Z52ParticleSystem_SubEmittersModule_CUSTOM_SetCollisionP12Il2CppObjectiS0_,__Z48ParticleSystem_SubEmittersModule_CUSTOM_SetDeathP12Il2CppObjectiS0_,__Z59ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterSystemP12Il2CppObjectiS0_,__Z57ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterTypeP12Il2CppObjectii,__Z63ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterPropertiesP12Il2CppObjectii,__Z61ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentSize3DP12Il2CppObjectR22ParticleSystemParticleR8Vector3f,__Z60ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentColorP12Il2CppObjectR22ParticleSystemParticleR16ColorRGBA32Icall,__Z34ParticleSystem_CUSTOM_SetParticlesP12Il2CppObjectP11Il2CppArrayi,__Z51ParticleSystem_CUSTOM_SetCustomParticleDataInternalP12Il2CppObjectS0_i,__Z35ParticleSystem_CUSTOM_Internal_EmitP12Il2CppObjectR24ParticleSystemEmitParamsi,__Z39ParticleSystemRenderer_CUSTOM_SetMeshesP12Il2CppObjectP11Il2CppArrayi,__Z55ParticleSystemRenderer_CUSTOM_Internal_SetVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlagsh,__Z39setPxRigidDynamic_SolverIterationCountsPN5physx14PxRigidDynamicEjj,__Z39getPxRigidDynamic_SolverIterationCountsPKN5physx14PxRigidDynamicERjS3_,__Z33getPxArticulationJoint_SwingLimitPKN5physx19PxArticulationJointERfS3_,__Z33getPxArticulationJoint_TwistLimitPKN5physx19PxArticulationJointERfS3_,__Z39setPxArticulation_SolverIterationCountsPN5physx14PxArticulationEjj,__Z39getPxArticulation_SolverIterationCountsPKN5physx14PxArticulationERjS3_,__Z24setPxCloth_StretchConfigPN5physx7PxClothENS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigE,__Z24getPxCloth_StretchConfigPKN5physx7PxClothENS_22PxClothFabricPhaseType4EnumE,__Z17setPxJoint_ActorsPN5physx7PxJointEPNS_12PxRigidActorES3_,__Z17getPxJoint_ActorsPKN5physx7PxJointERPNS_12PxRigidActorES5_
,__Z20setPxJoint_LocalPosePN5physx7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformE,__Z20getPxJoint_LocalPosePKN5physx7PxJointENS_17PxJointActorIndex4EnumE,__Z21getPxJoint_BreakForcePKN5physx7PxJointERfS3_,__Z19setPxD6Joint_MotionPN5physx9PxD6JointENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE,__Z18setPxD6Joint_DrivePN5physx9PxD6JointENS_9PxD6Drive4EnumENS_14PxD6JointDriveE,__Z18getPxD6Joint_DrivePKN5physx9PxD6JointENS_9PxD6Drive4EnumE,__Z26setPxD6Joint_DriveVelocityPN5physx9PxD6JointENS_6PxVec3ES2_,__Z26getPxD6Joint_DriveVelocityPKN5physx9PxD6JointERNS_6PxVec3ES4_,__ZN5physx20solveExtContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx15solveExt1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx28solveExtContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx23solveExt1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx27solveExtContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx35solveExtContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__ZN5physx21solveExtFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE,__Z22setPxConstraint_ActorsPN5physx12PxConstraintEPNS_12PxRigidActorES3_,__Z22getPxConstraint_ActorsPKN5physx12PxConstraintERPNS_12PxRigidActorES5_,__Z26getPxConstraint_BreakForcePKN5physx12PxConstraintERfS3_,__Z10SetNbShapePN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumEj,__Z21SetNbBroadPhaseRemovePN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj,__Z18SetNbBroadPhaseAddPN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj,__ZN5physx8debugger14PvdMarshallingIasE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIatE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIaiE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIajE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIaxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIayE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIafE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIadE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhsE12marshalBlockEPKhPhj
,__ZN5physx8debugger14PvdMarshallingIhtE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhiE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhjE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhyE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhfE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIhdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsiE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsjE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsyE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsfE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIsdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItiE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItjE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItyE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItfE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingItdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIixE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIiyE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIifE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIidE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIjxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIjyE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIjfE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIjdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIxdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIydE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIfiE12marshalBlockEPKhPhj
,__ZN5physx8debugger14PvdMarshallingIfjE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIfdE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIdxE12marshalBlockEPKhPhj,__ZN5physx8debugger14PvdMarshallingIdyE12marshalBlockEPKhPhj,__ZZN19CharacterController15InitializeClassEvEN35FunctorImpl_589kAnimatorMoveBuiltin4CallEPviR11MessageData,__ZZN8Collider15InitializeClassEvEN28FunctorImpl_777kLayerChanged4CallEPviR11MessageData,__ZZN8Collider15InitializeClassEvEN37FunctorImpl_778kForceRecreateCollider4CallEPviR11MessageData,__ZZN8Collider15InitializeClassEvEN32FunctorImpl_779kTransformChanged4CallEPviR11MessageData,__ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_399kDidDeleteMesh4CallEPviR11MessageData,__ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_400kDidModifyMesh4CallEPviR11MessageData,__ZZN9Rigidbody15InitializeClassEvEN32FunctorImpl_464kTransformChanged4CallEPviR11MessageData,__ZZN9Rigidbody15InitializeClassEvEN35FunctorImpl_465kAnimatorMoveBuiltin4CallEPviR11MessageData,__Z30Physics_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h,__Z35Physics_CUSTOM_IgnoreLayerCollisioniih,__Z39Rigidbody_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK8Vector3fi,__Z47Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK8Vector3fi,__Z40Rigidbody_CUSTOM_INTERNAL_CALL_AddTorqueP12Il2CppObjectRK8Vector3fi,__Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeTorqueP12Il2CppObjectRK8Vector3fi,__Z51Rigidbody_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_,__Z55Rigidbody_CUSTOM_INTERNAL_CALL_GetRelativePointVelocityP12Il2CppObjectRK8Vector3fRS1_,__Z47Rigidbody_CUSTOM_INTERNAL_CALL_GetPointVelocityP12Il2CppObjectRK8Vector3fRS1_,__Z50Collider_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_,__ZZN10Collider2D15InitializeClassEvEN31FunctorImpl_79kTransformChanged4CallEPviR11MessageData,__ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_80kLayerChanged4CallEPviR11MessageData,__ZZN10Collider2D15InitializeClassEvEN30FunctorImpl_81kDidAddComponent4CallEPviR11MessageData,__ZZN10Collider2D15InitializeClassEvEN33FunctorImpl_82kDidRemoveComponent4CallEPviR11MessageData,__ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_83kSetPolygon2D4CallEPviR11MessageData,__ZZN11Rigidbody2D15InitializeClassEvEN32FunctorImpl_198kTransformChanged4CallEPviR11MessageData,__ZZN11Rigidbody2D15InitializeClassEvEN28FunctorImpl_199kLayerChanged4CallEPviR11MessageData,__ZZN11Rigidbody2D15InitializeClassEvEN35FunctorImpl_200kAnimatorMoveBuiltin4CallEPviR11MessageData
,__Z32Physics2D_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h,__Z37Physics2D_CUSTOM_IgnoreLayerCollisioniih,__Z41Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE,__Z49Rigidbody2D_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE,__Z69Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointP12Il2CppObjectRK13Vector2fIcallPS1_,__Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointP12Il2CppObjectRK13Vector2fIcallPS1_,__Z70Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorP12Il2CppObjectRK13Vector2fIcallPS1_,__Z78Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorP12Il2CppObjectRK13Vector2fIcallPS1_,__Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_,__Z85Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_,__Z32PolygonCollider2D_CUSTOM_SetPathP12Il2CppObjectiP11Il2CppArray,__Z40setPxVehicleWheelsSimData_SuspensionDataPN5physx22PxVehicleWheelsSimDataEjNS_23PxVehicleSuspensionDataE,__Z40getPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataEj,__Z35setPxVehicleWheelsSimData_WheelDataPN5physx22PxVehicleWheelsSimDataEjNS_18PxVehicleWheelDataE,__Z35getPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataEj,__Z34setPxVehicleWheelsSimData_TireDataPN5physx22PxVehicleWheelsSimDataEjNS_17PxVehicleTireDataE,__Z34getPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataEj,__Z45setPxVehicleWheelsSimData_SuspTravelDirectionPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E,__Z45getPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataEj,__Z49setPxVehicleWheelsSimData_SuspForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E,__Z49getPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj,__Z49setPxVehicleWheelsSimData_TireForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E,__Z49getPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj,__Z43setPxVehicleWheelsSimData_WheelCentreOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E,__Z43getPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataEj,__Z43setPxVehicleWheelsSimData_WheelShapeMappingPN5physx22PxVehicleWheelsSimDataEji,__Z46setPxVehicleWheelsSimData_SceneQueryFilterDataPN5physx22PxVehicleWheelsSimDataEjNS_12PxFilterDataE,__Z46getPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataEj,__Z43setPxVehicleWheelsSimData_WheelEnabledStatePN5physx22PxVehicleWheelsSimDataEjb,__ZZN13WheelCollider15InitializeClassEvEN29FunctorImpl_1262kLayerChanged4CallEPviR11MessageData
,__ZZN13WheelCollider15InitializeClassEvEN38FunctorImpl_1263kForceRecreateCollider4CallEPviR11MessageData,__ZZN13WheelCollider15InitializeClassEvEN33FunctorImpl_1264kTransformChanged4CallEPviR11MessageData,__Z33WheelCollider_CUSTOM_GetWorldPoseP12Il2CppObjectP8Vector3fP11Quaternionf,__ZZN12NavMeshAgent15InitializeClassEvEN32FunctorImpl_103kTransformChanged4CallEPviR11MessageData,__ZZN15NavMeshObstacle15InitializeClassEvEN32FunctorImpl_206kTransformChanged4CallEPviR11MessageData,__ZZN15NavMeshObstacle15InitializeClassEvEN33FunctorImpl_207kDidVelocityChange4CallEPviR11MessageData,__ZL16NavMeshLoadSceneiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZZN13AudioListener15InitializeClassEvEN31FunctorImpl_179kDidAddComponent4CallEPviR11MessageData,__ZZN11AudioSource15InitializeClassEvEN32FunctorImpl_2215kDidAddComponent4CallEPviR11MessageData,__Z42AudioListener_CUSTOM_GetSpectrumDataHelperP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW,__Z23AudioSource_CUSTOM_PlayP12Il2CppObjecty,__Z33AudioSource_CUSTOM_SetCustomCurveP12Il2CppObject24MonoAudioSourceCurveTypeS0_,__Z38AudioSource_CUSTOM_GetOutputDataHelperP12Il2CppObjectP11Il2CppArrayi,__ZL27AnimationVisibilityCallbackPvS_i,__ZN11UnityEngine9AnimationL22GenericBindingCallbackEPvS1_i,__ZN11UnityEngine9Animation21AvatarBindingCallbackEPvS1_i,__ZN8Animator26AnimatorVisibilityCallbackEPvS0_i,__ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_90kDidModifyMotion4CallEPviR11MessageData,__ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_91kDidDeleteMotion4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN32FunctorImpl_386kTransformChanged4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN43FunctorImpl_387kDidModifyAnimatorController4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN31FunctorImpl_388kDidModifyMotion4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN31FunctorImpl_389kDidDeleteMotion4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN31FunctorImpl_390kDidModifyAvatar4CallEPviR11MessageData,__ZZN8Animator15InitializeClassEvEN31FunctorImpl_395kDidAddComponent4CallEPviR11MessageData,__ZZN26AnimatorOverrideController15InitializeClassEvEN42FunctorImpl_63kDidModifyAnimatorController4CallEPviR11MessageData,__ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_64kDidModifyMotion4CallEPviR11MessageData,__ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_65kDidDeleteMotion4CallEPviR11MessageData,__Z40AnimationState_CUSTOM_AddMixingTransformP12Il2CppObjectS0_h,__Z51Animator_CUSTOM_INTERNAL_CALL_GetIKPositionInternalP12Il2CppObjectiR8Vector3f
,__Z51Animator_CUSTOM_INTERNAL_CALL_SetIKPositionInternalP12Il2CppObjectiRK8Vector3f,__Z51Animator_CUSTOM_INTERNAL_CALL_GetIKRotationInternalP12Il2CppObjectiR11Quaternionf,__Z51Animator_CUSTOM_INTERNAL_CALL_SetIKRotationInternalP12Il2CppObjectiRK11Quaternionf,__Z55Animator_CUSTOM_INTERNAL_CALL_GetIKHintPositionInternalP12Il2CppObjectiR8Vector3f,__Z55Animator_CUSTOM_INTERNAL_CALL_SetIKHintPositionInternalP12Il2CppObjectiRK8Vector3f,__Z58Animator_CUSTOM_INTERNAL_CALL_SetBoneLocalRotationInternalP12Il2CppObject14HumanBodyBonesRK11Quaternionf,__Z43Animator_CUSTOM_GetCurrentAnimatorStateInfoP12Il2CppObjecti,__Z40Animator_CUSTOM_GetNextAnimatorStateInfoP12Il2CppObjecti,__Z41Animator_CUSTOM_GetAnimatorTransitionInfoP12Il2CppObjecti,__Z29Animator_CUSTOM_SetBoolStringP12Il2CppObjectP12Il2CppStringh,__Z25Animator_CUSTOM_SetBoolIDP12Il2CppObjectih,__Z32Animator_CUSTOM_SetIntegerStringP12Il2CppObjectP12Il2CppStringi,__Z28Animator_CUSTOM_SetIntegerIDP12Il2CppObjectii,__Z69AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorStateInfoInternalR9HPlayablei,__Z66AnimatorControllerPlayable_CUSTOM_GetNextAnimatorStateInfoInternalR9HPlayablei,__Z67AnimatorControllerPlayable_CUSTOM_GetAnimatorTransitionInfoInternalR9HPlayablei,__Z47AnimatorControllerPlayable_CUSTOM_SetBoolStringR9HPlayableP12Il2CppStringh,__Z43AnimatorControllerPlayable_CUSTOM_SetBoolIDR9HPlayableih,__Z50AnimatorControllerPlayable_CUSTOM_SetIntegerStringR9HPlayableP12Il2CppStringi,__Z46AnimatorControllerPlayable_CUSTOM_SetIntegerIDR9HPlayableii,__Z56AnimatorOverrideController_CUSTOM_Internal_SetClipByNameP12Il2CppObjectP12Il2CppStringS0_,__Z42Avatar_CUSTOM_INTERNAL_CALL_GetPreRotationP12Il2CppObjectiR11Quaternionf,__Z43Avatar_CUSTOM_INTERNAL_CALL_GetPostRotationP12Il2CppObjectiR11Quaternionf,__Z40Avatar_CUSTOM_INTERNAL_CALL_GetLimitSignP12Il2CppObjectiR8Vector3f,__Z49HumanPoseHandler_CUSTOM_Internal_HumanPoseHandlerP12Il2CppObjectS0_S0_,__ZZN4Tree15InitializeClassEvEN33FunctorImpl_52kOnWillRenderObject4CallEPviR11MessageData,__Z47TerrainData_CUSTOM_Internal_SetDetailResolutionP12Il2CppObjectii,__Z48TerrainData_CUSTOM_INTERNAL_CALL_GetTreeInstanceP12Il2CppObjectiR12TreeInstance,__Z48TerrainData_CUSTOM_INTERNAL_CALL_SetTreeInstanceP12Il2CppObjectiRK12TreeInstance,_destroy_size
,__ZZN20TextRenderingPrivate8TextMesh15InitializeClassEvEN31FunctorImpl_293kDidAddComponent4CallEPviR11MessageData,_destroy_face,_ft_outline_glyph_transform,_ft_raster1_get_cbox,_ft_smooth_get_cbox,_gray_raster_reset,_ft_black_reset,_Vertical_Sweep_Init,_Horizontal_Sweep_Init,_t1_hints_stem,_ps_hints_t1stem3,_ps_hints_t2counter,_Write_CVT,_Write_CVT_Stretched,_Move_CVT,_Move_CVT_Stretched,__Z38Font_CUSTOM_Internal_CreateDynamicFontP12Il2CppObjectP11Il2CppArrayi,__ZZN2UI6Canvas15InitializeClassEvEN33FunctorImpl_1283kTransformChanged4CallEPviR11MessageData,__ZZN2UI6Canvas15InitializeClassEvEN39FunctorImpl_1284kCanvasHierarchyChanged4CallEPviR11MessageData,__ZZN2UI11CanvasGroup15InitializeClassEvEN38FunctorImpl_118kTransformParentChanged4CallEPviR11MessageData,__ZZN2UI11CanvasGroup15InitializeClassEvEN40FunctorImpl_119kTransformChildrenChanged4CallEPviR11MessageData,__ZZN2UI14CanvasRenderer15InitializeClassEvEN32FunctorImpl_801kTransformChanged4CallEPviR11MessageData,__ZZN2UI14CanvasRenderer15InitializeClassEvEN34FunctorImpl_802kCanvasGroupChanged4CallEPviR11MessageData,__ZZN2UI14CanvasRenderer15InitializeClassEvEN38FunctorImpl_803kCanvasHierarchyChanged4CallEPviR11MessageData,__Z33CanvasRenderer_CUSTOM_SetMaterialP12Il2CppObjectS0_i,__Z36CanvasRenderer_CUSTOM_SetPopMaterialP12Il2CppObjectS0_i,__Z57RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustRectP12Il2CppObjectS0_R5RectTIfE,__ZZN15TerrainCollider15InitializeClassEvEN30FunctorImpl_379kTerrainChanged4CallEPviR11MessageData,__Z32GUI_CUSTOM_INTERNAL_CALL_DoLabelRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr,__Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetStyleStatePtrP12Il2CppObjectiRPv
,__Z32GUIStyle_CUSTOM_AssignStyleStateP12Il2CppObjecti13Il2Cpp_IntPtr,__Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetRectOffsetPtrP12Il2CppObjectiRPv,__Z32GUIStyle_CUSTOM_AssignRectOffsetP12Il2CppObjecti13Il2Cpp_IntPtr,__Z45GUIStyle_CUSTOM_INTERNAL_CALL_SetMouseTooltipP12Il2CppObjectP12Il2CppStringRK5RectTIfE,__Z33GUIStyle_CUSTOM_Internal_CalcSize13Il2Cpp_IntPtrP12Il2CppObjectP13Vector2fIcall,__Z48DownloadHandler_CUSTOM_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringj,__Z46DownloadHandler_CUSTOM_InternalCreateAudioClipP12Il2CppObjectP12Il2CppStringi,__ZN19TransportJavaScript10OnProgressEPvjj,__Z47UnityWebRequest_CUSTOM_InternalSetRequestHeaderP12Il2CppObjectP12Il2CppStringS2_,__ZL39WriteQueueForTransferFunctionIntoCache2I8JSONReadEvP11Il2CppClassR23CachedSerializationDataRb,__ZL39WriteQueueForTransferFunctionIntoCache2I9JSONWriteEvP11Il2CppClassR23CachedSerializationDataRb,__ZN14UnityAnalytics27OnSceneTimingCallbackStaticEPS_RK15SceneLoadTimingRK8UnityStr,__ZN11UnityEngine9Analytics15AnalyticsConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead,__ZN11UnityEngine7Connect13ConnectConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead,__ZN11UnityEngine7ConnectL19ConfigChangedStaticEPNS0_14RemoteSettingsERK8UnityStrR8JSONRead,__ZN8VRModule11VRLoadSceneEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE,__ZZN19MeshParticleEmitter15InitializeClassEvEN33FunctorImpl_329kMeshFilterChanged4CallEPviR11MessageData,_emscripten_glGetTexParameterfv__wrapper,_emscripten_glGetTexParameteriv__wrapper,_emscripten_glTexParameterfv__wrapper,_emscripten_glTexParameteriv__wrapper,_emscripten_glGetBufferParameteriv__wrapper,_emscripten_glGetRenderbufferParameteriv__wrapper,_emscripten_glGetUniformfv__wrapper,_emscripten_glGetUniformiv__wrapper,_emscripten_glGetVertexAttribfv__wrapper,_emscripten_glGetVertexAttribiv__wrapper,_emscripten_glGetVertexAttribPointerv__wrapper,_emscripten_glUniform2i__wrapper,_emscripten_glUniform1iv__wrapper,_emscripten_glUniform2iv__wrapper,_emscripten_glUniform3iv__wrapper,_emscripten_glUniform4iv__wrapper,_emscripten_glUniform1fv__wrapper,_emscripten_glUniform2fv__wrapper,_emscripten_glUniform3fv__wrapper,_emscripten_glUniform4fv__wrapper,_emscripten_glGetShaderiv__wrapper,_emscripten_glGetProgramiv__wrapper,_emscripten_glBindAttribLocation__wrapper,_emscripten_glGetObjectParameterivARB__wrapper,_emscripten_glNormalPointer__wrapper,_emscripten_glDrawArrays__wrapper,_emscripten_glTexParameteri__wrapper,_emscripten_glStencilFunc__wrapper,_emscripten_glStencilOp__wrapper,___cxa_throw__wrapper,__ZNSt3__28ios_base7failureC2EPKcRKNS_10error_codeE,__ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b,__ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentryC2ERS3_b,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj,__ZNSt3__219__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__219__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__219__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw
,__ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EEPKS6_RKS9_,__ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_,__ZNSt3__214collate_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__214collate_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__212ctype_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__212ctype_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj,__ZNSt3__215numpunct_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__215numpunct_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__26locale5__imp7installEPNS0_5facetEl,__ZNSt3__26locale5__impC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEjw,__ZNSt3__212system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__212system_errorC2ENS_10error_codeEPKc,__ZNSt3__28valarrayIjE6resizeEjj,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj,__ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_,__ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EERKSB_PKS8_,__ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EEPKS8_RKSB_,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102,b102
,b102,b102,b102,b102,b102,b102,b102,b102,b102];
var FUNCTION_TABLE_v = [b103,___cxa_pure_virtual__wrapper,__ZL25default_terminate_handlerv,__ZL26default_unexpected_handlerv,__ZL28PostprocessWebGLGraphicsCapsv,__ZL8MainLoopv,__ZN10GameObject15InitializeClassEv,__ZN10GameObject12CleanupClassEv,__ZN6Camera15InitializeClassEv,__ZN6Camera12CleanupClassEv,__ZN9LensFlare15InitializeClassEv,__ZN9LensFlare12CleanupClassEv,__ZN16GraphicsSettings15InitializeClassEv,__ZN16GraphicsSettings12CleanupClassEv,__ZN4Halo15InitializeClassEv,__ZN4Halo12CleanupClassEv,__ZN5Light15InitializeClassEv,__ZN5Light12CleanupClassEv,__ZL19OnLightProbesUpdatev,__ZN11LightProbes15InitializeClassEv,__ZN11LightProbes12CleanupClassEv,__ZN13OcclusionArea15InitializeClassEv,__ZN13OcclusionArea12CleanupClassEv,__ZN24OcclusionCullingSettings15InitializeClassEv,__ZN24OcclusionCullingSettings12CleanupClassEv,__ZN9Projector15InitializeClassEv,__ZN9Projector12CleanupClassEv,__ZN15ReflectionProbe15InitializeClassEv,__ZN15ReflectionProbe12CleanupClassEv
,__ZN13RenderManager30RemoveAllIntermediateRenderersEv,__ZN14RenderSettings15InitializeClassEv,__ZN14RenderSettings19PostInitializeClassEv,__ZN14RenderSettings12CleanupClassEv,__ZN8GUILayer15InitializeClassEv,__ZN8GUILayer12CleanupClassEv,__ZN10GUITexture15InitializeClassEv,__ZN10GUITexture12CleanupClassEv,__ZN9Behaviour15InitializeClassEv,__ZN9Behaviour12CleanupClassEv,__ZZ19InitializeGfxDevicejEN38PreLateUpdateEndGraphicsJobsLatestruct7ForwardEv,__ZN12LineRenderer15InitializeClassEv,__ZN12LineRenderer12CleanupClassEv,__ZN15QualitySettings15InitializeClassEv,__ZN15QualitySettings12CleanupClassEv,__ZN2UI13RectTransform15InitializeClassEv,__ZN2UI13RectTransform12CleanupClassEv,__ZN8Renderer15InitializeClassEv,__ZN8Renderer19PostInitializeClassEv,__ZN8Renderer12CleanupClassEv,__ZL33AllowIdentityTransformDestructionv,__ZN7Texture15InitializeClassEv,__ZN7Texture12CleanupClassEv,__ZN9Texture2D15InitializeClassEv,__ZN9Texture2D12CleanupClassEv,__ZN13TrailRenderer15InitializeClassEv,__ZN13TrailRenderer12CleanupClassEv,__ZN9Transform15InitializeClassEv,__ZN9Transform12CleanupClassEv,__ZN8LODGroup15InitializeClassEv
,__ZN8LODGroup12CleanupClassEv,__ZN10MeshFilter15InitializeClassEv,__ZN10MeshFilter12CleanupClassEv,__ZN12MeshRenderer15InitializeClassEv,__ZN19SkinnedMeshRenderer15InitializeClassEv,__ZN19SkinnedMeshRenderer12CleanupClassEv,__ZN14SpriteRenderer15InitializeClassEv,__ZN14SpriteRenderer12CleanupClassEv,__ZN18ProceduralMaterial15InitializeClassEv,__ZN18ProceduralMaterial19PostInitializeClassEv,__ZN18ProceduralMaterial12CleanupClassEv,__ZN12InputManager15InitializeClassEv,__ZN12InputManager12CleanupClassEv,__ZZN13BuildSettingsC1E10MemLabelId18ObjectCreationModeEN27initializedPreloadedPlugins7ForwardEv,__ZL14OnWorldStartedv,__ZL14OnWorldStoppedv,__ZN14PlayerSettings15InitializeClassEv,__ZN14PlayerSettings19PostInitializeClassEv,__ZN14PlayerSettings12CleanupClassEv,__ZN30RuntimeInitializeOnLoadManager15InitializeClassEv,__ZN30RuntimeInitializeOnLoadManager12CleanupClassEv,__ZL25InitializeDefaultMaterialv,__ZN8Material15InitializeClassEv,__ZN8Material12CleanupClassEv,__ZZN20SpeedTreeWindManagerC1EvEN25PreUpdateWindUpdatestruct7ForwardEv,__ZN18SpeedTreeWindAsset15InitializeClassEv,__ZN18SpeedTreeWindAsset12CleanupClassEv,__Z23Application_CUSTOM_Quitv,__Z29Application_CUSTOM_CancelQuitv,__Z25Application_CUSTOM_Unloadv
,__Z18Debug_CUSTOM_Breakv,__Z23Debug_CUSTOM_DebugBreakv,__Z34Debug_CUSTOM_ClearDeveloperConsolev,__Z28Debug_CUSTOM_OpenConsoleFilev,__Z34DynamicGI_CUSTOM_UpdateEnvironmentv,__Z53GIDebugVisualisation_CUSTOM_ResetRuntimeInputTexturesv,__Z41GIDebugVisualisation_CUSTOM_PlayCycleModev,__Z42GIDebugVisualisation_CUSTOM_PauseCycleModev,__Z41GIDebugVisualisation_CUSTOM_StopCycleModev,__Z27RenderSettings_CUSTOM_Resetv,__Z34Graphics_CUSTOM_Internal_SetNullRTv,__Z39Graphics_CUSTOM_ClearRandomWriteTargetsv,__Z29LightmapSettings_CUSTOM_Resetv,__Z13GL_CUSTOM_Endv,__Z19GL_CUSTOM_LoadOrthov,__Z25GL_CUSTOM_LoadPixelMatrixv,__Z22GL_CUSTOM_LoadIdentityv,__Z20GL_CUSTOM_PushMatrixv,__Z19GL_CUSTOM_PopMatrixv,__Z15GL_CUSTOM_Flushv,__Z25GL_CUSTOM_InvalidateStatev,__Z29GL_CUSTOM_RenderTargetBarrierv,__Z27Input_CUSTOM_ResetInputAxesv,__Z45Playables_CUSTOM_BeginIgnoreAllocationTrackerv,__Z43Playables_CUSTOM_EndIgnoreAllocationTrackerv,__Z28PlayerPrefs_CUSTOM_DeleteAllv,__Z23PlayerPrefs_CUSTOM_Savev,__Z25Profiler_CUSTOM_EndSamplev,__Z30Shader_CUSTOM_WarmupAllShadersv,__Z25SplashScreen_CUSTOM_Beginv
,__Z24SplashScreen_CUSTOM_Drawv,__ZZN15DirectorManager15InitializeClassEvEN36EarlyUpdateDirectorAdvanceTimestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN41FixedUpdateDirectorFixedAdvanceTimestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN36FixedUpdateDirectorFixedUpdatestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN47FixedUpdateDirectorFixedUpdatePostPhysicsstruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN26UpdateDirectorUpdatestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN38PostLateUpdateDirectorLateUpdatestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN39PostLateUpdateDirectorRenderImagestruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN47PreLateUpdateDirectorUpdateAnimationBeginstruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN45PreLateUpdateDirectorUpdateAnimationEndstruct7ForwardEv,__ZZN15DirectorManager15InitializeClassEvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN47InitializationAsyncUploadTimeSlicedUpdatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36InitializationPlayerUpdateTimestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdatePollPlayerConnectionstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateProfilerStartFramestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN29EarlyUpdateGpuTimestampstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN38EarlyUpdateExecuteMainThreadJobsstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdateProcessMouseInWindowstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN27EarlyUpdateClearLinesstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36EarlyUpdatePresentBeforeUpdatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN44EarlyUpdateResetFrameStatsAfterPresentstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN41EarlyUpdateUpdateAllUnityWebStreamsstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN33EarlyUpdateUpdatePreloadingstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdateRendererNotifyInvisiblestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdatePlayerCleanupCachedDatastruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateUpdateInputManagerstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN27FixedUpdateClearLinesstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN33PreUpdateCheckTexFieldInputstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateResetInputAxisstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN30PreUpdateSendMouseEventsstruct7ForwardEv
,__ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdatePlayerSendFrameStartedstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdatePlayerUpdateCanvasesstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateUpdateAllRenderersstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateUpdateAllSkinnedMeshesstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN45PostLateUpdateExecuteOneJobInMainThreadstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdatePlayerEmitCanvasGeometrystruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdateFinishFrameRenderingstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN35PostLateUpdateBatchModeUpdatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdatePlayerSendFrameCompletestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN46PostLateUpdatePlayerSendFramePostPresentstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateUpdateCaptureScreenshotstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdatePresentAfterDrawstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateClearImmediateRenderersstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateUpdateResolutionstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN33PostLateUpdateInputEndFramestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateGUIClearEventsstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateShaderHandleErrorsstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdateProfilerSynchronizeStatsstruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateMemoryFrameMaintenancestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateProfilerEndFramestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN45EarlyUpdateScriptRunDelayedStartupFramestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN46FixedUpdateScriptRunBehaviourFixedUpdatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN47FixedUpdateScriptRunDelayedFixedFrameRatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN36UpdateScriptRunBehaviourUpdatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN44UpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN52PostLateUpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv,__ZZ23InitPlayerLoopCallbacksvEN47PreLateUpdateScriptRunBehaviourLateUpdatestruct7ForwardEv,__ZZ24InitializeEngineGraphicsbEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv,__ZN13UnityProfiler26BeforeDomainUnloadCallbackEv,__ZN13UnityProfiler22DomainReloadedCallbackEv
,__ZN13MonoBehaviour15InitializeClassEv,__ZN13MonoBehaviour12CleanupClassEv,__ZL30InitializeCoreScriptingClassesv,__ZL27CleanupCoreScriptingClassesv,__Z35AndroidJNI_CUSTOM_ExceptionDescribev,__Z32AndroidJNI_CUSTOM_ExceptionClearv,__ZL26RegisterModuleICalls_WebGLv,__ZL22InitializeModule_WebGLv,__ZL19CleanupModule_WebGLv,_glFinish__wrapper,_glFlush__wrapper,_glEndTransformFeedback__wrapper,__ZL26RegisterModuleICalls_Umbrav,__ZL22InitializeModule_Umbrav,__ZL19CleanupModule_Umbrav,__ZZN14ParticleSystem15InitializeClassEvEN47PreLateUpdateParticleSystemBeginUpdateAllstruct7ForwardEv,__ZZN14ParticleSystem15InitializeClassEvEN46PostLateUpdateParticleSystemEndUpdateAllstruct7ForwardEv,__ZZN14ParticleSystem15InitializeClassEvEN16cleanupAfterLoad7ForwardEv,__ZN14ParticleSystem15InitializeClassEv,__ZN14ParticleSystem12CleanupClassEv,__ZN22ParticleSystemRenderer15InitializeClassEv,__ZL35RegisterModuleICalls_ParticleSystemv,__ZL31InitializeModule_ParticleSystemv,__ZL28CleanupModule_ParticleSystemv,__ZL40InitializeParticleSystemScriptingClassesv,__ZL37CleanupParticleSystemScriptingClassesv,__ZL33InitializePhysicsScriptingClassesv,__ZL30CleanupPhysicsScriptingClassesv,__ZN19CharacterController15InitializeClassEv,__ZN19CharacterController12CleanupClassEv
,__ZN8Collider15InitializeClassEv,__ZN8Collider12CleanupClassEv,__ZN5Unity17ConfigurableJoint15InitializeClassEv,__ZN5Unity17ConfigurableJoint12CleanupClassEv,__ZN12MeshCollider15InitializeClassEv,__ZN12MeshCollider12CleanupClassEv,__ZN14PhysicMaterial15InitializeClassEv,__ZN14PhysicMaterial12CleanupClassEv,__ZZN14PhysicsManager15InitializeClassEvEN35FixedUpdatePhysicsFixedUpdatestruct7ForwardEv,__ZZN14PhysicsManager15InitializeClassEvEN28PreUpdatePhysicsUpdatestruct7ForwardEv,__ZZN14PhysicsManager15InitializeClassEvEN58EarlyUpdatePhysicsResetInterpolatedTransformPositionstruct7ForwardEv,__ZZN14PhysicsManager15InitializeClassEvEN15didDestroyWorld7ForwardEv,__ZN14PhysicsManager15InitializeClassEv,__ZN14PhysicsManager12CleanupClassEv,__ZN9Rigidbody15InitializeClassEv,__ZN9Rigidbody12CleanupClassEv,__ZL28RegisterModuleICalls_Physicsv,__ZL24InitializeModule_Physicsv,__ZL21CleanupModule_Physicsv,__ZL35InitializePhysics2DScriptingClassesv,__ZL32CleanupPhysics2DScriptingClassesv,__ZN14AreaEffector2D15InitializeClassEv,__ZN14AreaEffector2D12CleanupClassEv,__ZN10Collider2D15InitializeClassEv,__ZN10Collider2D12CleanupClassEv,__ZN7Joint2D15InitializeClassEv,__ZN7Joint2D12CleanupClassEv,__ZZN14Physics2DState10InitializeEvEN37FixedUpdatePhysics2DFixedUpdatestruct7ForwardEv,__ZZN14Physics2DState10InitializeEvEN30PreUpdatePhysics2DUpdatestruct7ForwardEv,__ZN17Physics2DSettings15InitializeClassEv
,__ZN17Physics2DSettings12CleanupClassEv,__ZN11Rigidbody2D15InitializeClassEv,__ZN11Rigidbody2D12CleanupClassEv,__ZN17PolygonCollider2D15InitializeClassEv,__ZN18PlatformEffector2D15InitializeClassEv,__ZN18PlatformEffector2D12CleanupClassEv,__ZZN17Physics2DSettings15InitializeClassEvEN15didDestroyWorld7ForwardEv,__ZL30RegisterModuleICalls_Physics2Dv,__ZL26InitializeModule_Physics2Dv,__ZL23CleanupModule_Physics2Dv,__ZN13WheelCollider15InitializeClassEv,__ZN13WheelCollider12CleanupClassEv,__ZL29RegisterModuleICalls_Vehiclesv,__ZL25InitializeModule_Vehiclesv,__ZL22CleanupModule_Vehiclesv,__ZZ16InitClothManagervEN45PostLateUpdatePhysicsSkinnedClothUpdatestruct7ForwardEv,__ZL26RegisterModuleICalls_Clothv,__ZL22InitializeModule_Clothv,__ZL19CleanupModule_Clothv,__ZL31InitializeClothScriptingClassesv,__ZL28CleanupClothScriptingClassesv,__ZN12NavMeshAgent15InitializeClassEv,__ZN12NavMeshAgent12CleanupClassEv,__ZN15NavMeshObstacle15InitializeClassEv,__ZN15NavMeshObstacle12CleanupClassEv,__ZZ24InitializeNavMeshManagervEN23PreUpdateAIUpdatestruct7ForwardEv,__ZZ24InitializeNavMeshManagervEN37PreLateUpdateAIUpdatePostScriptstruct7ForwardEv,__ZN15NavMeshSettings15InitializeClassEv,__ZN15NavMeshSettings12CleanupClassEv,__ZL28InitializeAIScriptingClassesv
,__ZL25CleanupAIScriptingClassesv,__Z30NavMesh_CUSTOM_AddOffMeshLinksv,__Z29NavMesh_CUSTOM_RestoreNavMeshv,__ZL23RegisterModuleICalls_AIv,__ZL19InitializeModule_AIv,__ZL16CleanupModule_AIv,__ZL31InitializeAudioScriptingClassesv,__ZL28CleanupAudioScriptingClassesv,__ZN12SoundManager20OnExitPlayModeStaticEv,__ZN10SampleClip15InitializeClassEv,__ZN10SampleClip12CleanupClassEv,__ZN9AudioClip15InitializeClassEv,__ZN9AudioClip12CleanupClassEv,__ZN13AudioListener15InitializeClassEv,__ZN13AudioListener12CleanupClassEv,__ZN12AudioManager15DidReloadDomainEv,__ZN12AudioManager15InitializeClassEv,__ZN12AudioManager12CleanupClassEv,__ZZL31InitializeAudioManagerCallbacksvEN33FixedUpdateAudioFixedUpdatestruct7ForwardEv,__ZZL31InitializeAudioManagerCallbacksvEN31PostLateUpdateUpdateAudiostruct7ForwardEv,__ZZL31InitializeAudioManagerCallbacksvEN39PostLateUpdateUpdateVideoTexturesstruct7ForwardEv,__ZN11AudioSource15InitializeClassEv,__ZN11AudioSource12CleanupClassEv,__ZL26RegisterModuleICalls_Audiov,__ZL22InitializeModule_Audiov,__ZL19CleanupModule_Audiov,__ZL35InitializeAnimationScriptingClassesv,__ZL32CleanupAnimationScriptingClassesv,__ZN11UnityEngine9Animation28GenericAnimationBindingCache15DidReloadDomainEv,__ZN9Animation15InitializeClassEv
,__ZN9Animation12CleanupClassEv,__ZZN16AnimationManager15InitializeClassEvEN43FixedUpdateLegacyFixedAnimationUpdatestruct7ForwardEv,__ZZN16AnimationManager15InitializeClassEvEN40PreLateUpdateLegacyAnimationUpdatestruct7ForwardEv,__ZN13AnimationClip15InitializeClassEv,__ZN13AnimationClip12CleanupClassEv,__ZN18AnimatorController15InitializeClassEv,__ZN25RuntimeAnimatorController12CleanupClassEv,__ZN8Animator15InitializeClassEv,__ZN8Animator12CleanupClassEv,__ZN8Animator27ClearBindingsOnDomainReloadEv,__ZN26AnimatorOverrideController15InitializeClassEv,__ZN26AnimatorOverrideController12CleanupClassEv,__ZL30RegisterModuleICalls_Animationv,__ZL26InitializeModule_Animationv,__ZL23CleanupModule_Animationv,__ZN7Terrain15InitializeClassEv,__ZN7Terrain12CleanupClassEv,__ZN11TerrainData15InitializeClassEv,__ZN11TerrainData12CleanupClassEv,__ZN11TerrainData14BeforeShutdownEv,__ZN4Tree15InitializeClassEv,__ZN4Tree12CleanupClassEv,__ZL28RegisterModuleICalls_Terrainv,__ZL24InitializeModule_Terrainv,__ZL21CleanupModule_Terrainv,__ZL33InitializeTerrainScriptingClassesv,__ZL30CleanupTerrainScriptingClassesv,__ZL39InitializeTextRenderingScriptingClassesv,__ZL36CleanupTextRenderingScriptingClassesv,__ZZ29InitializeTextRenderingModulevEN40CleanUpTextRenderingGarbageCollectstruct7ForwardEv
,__ZZ29InitializeTextRenderingModulevEN16cleanupAfterLoad7ForwardEv,__ZN20TextRenderingPrivate8FontImpl12LoadAllFontsEv,__ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv,__ZN13TextRendering4Font15InitializeClassEv,__ZN13TextRendering4Font12CleanupClassEv,__ZN20TextRenderingPrivate8TextMesh15InitializeClassEv,__ZN20TextRenderingPrivate8TextMesh12CleanupClassEv,__ZL34RegisterModuleICalls_TextRenderingv,__ZL30InitializeModule_TextRenderingv,__ZL27CleanupModule_TextRenderingv,__ZN2UIL17UnloadAllCanvasesEv,__ZZN2UI23InitializeCanvasManagerEvEN48UIEventsCanvasManagerEmitOffScreenGeometrystruct7ForwardEv,__ZZN2UI23InitializeCanvasManagerEvEN47UIEventsCanvasmanagerEmitOnScreenGeometrystruct7ForwardEv,__ZZN2UI23InitializeCanvasManagerEvEN42EarlyUpdateUpdateCanvasRectTransformstruct7ForwardEv,__ZZN2UI23InitializeCanvasManagerEvEN45PostLateUpdateUpdateCanvasRectTransformstruct7ForwardEv,__ZZN2UI23InitializeCanvasManagerEvEN48UIEventsAlignCanvasRectTransformWithCamerastruct7ForwardEv,__ZZN2UI23InitializeCanvasManagerEvEN32UIEventsWillRenderCanvasesstruct7ForwardEv,__ZL28InitializeUIScriptingClassesv,__ZL25CleanupUIScriptingClassesv,__ZN2UI6Canvas15InitializeClassEv,__ZN2UI6Canvas12CleanupClassEv,__ZN2UI11CanvasGroup15InitializeClassEv,__ZN2UI11CanvasGroup12CleanupClassEv,__ZN2UI14CanvasRenderer15InitializeClassEv,__ZN2UI14CanvasRenderer12CleanupClassEv,__ZL23RegisterModuleICalls_UIv,__ZL19InitializeModule_UIv,__ZL16CleanupModule_UIv,__ZN15TerrainCollider15InitializeClassEv,__ZN15TerrainCollider12CleanupClassEv
,__ZL35RegisterModuleICalls_TerrainPhysicsv,__ZL31InitializeModule_TerrainPhysicsv,__ZL28CleanupModule_TerrainPhysicsv,__ZZN10GUIManager14InitGUIManagerEvEN36PreUpdateIMGUISendQueuedEventsstruct7ForwardEv,__ZL31InitializeIMGUIScriptingClassesv,__ZL28CleanupIMGUIScriptingClassesv,__ZL26RegisterModuleICalls_IMGUIv,__ZL22InitializeModule_IMGUIv,__ZL19CleanupModule_IMGUIv,__Z35GUI_CUSTOM_InitializeGUIClipTexturev,__Z38GUI_CUSTOM_InternalRepaintEditorWindowv,__Z24GUI_CUSTOM_UnfocusWindowv,__Z32GUI_CUSTOM_Internal_BeginWindowsv,__Z30GUI_CUSTOM_Internal_EndWindowsv,__Z32GUIUtility_CUSTOM_UpdateUndoNamev,__Z37GUIUtility_CUSTOM_ReleaseMouseControlv,__Z34GUIUtility_CUSTOM_Internal_ExitGUIv,__Z18GUIClip_CUSTOM_Popv,__Z22GUIClip_CUSTOM_Reapplyv,__ZL41InitializeUnityWebRequestScriptingClassesv,__ZL38CleanupUnityWebRequestScriptingClassesv,__ZN22UnityWebRequestManager22ScriptsChangedCallbackEv,__ZN22UnityWebRequestManager22InitializationCallbackEv,__ZL36RegisterModuleICalls_UnityWebRequestv,__ZL32InitializeModule_UnityWebRequestv,__ZL29CleanupModule_UnityWebRequestv,__ZL34RegisterModuleICalls_JSONSerializev,__ZL30InitializeModule_JSONSerializev,__ZL27CleanupModule_JSONSerializev,__ZZN4UNET16ScriptingUpdater4InitEvEN29PreLateUpdateUNetUpdatestruct7ForwardEv
,__ZN4UNET16ScriptingUpdater16SetUpdatePointerEv,__ZN4UNET16ScriptingUpdater18ClearUpdatePointerEv,__Z42UNetWebGlHelpers_CUSTOM_InitUpdateFunctionv,__ZN15UnityAdsManager15InitializeClassEv,__ZN15UnityAdsManager12CleanupClassEv,__ZL29RegisterModuleICalls_UnityAdsv,__ZL25InitializeModule_UnityAdsv,__ZL22CleanupModule_UnityAdsv,__ZL35RegisterModuleICalls_UnityAnalyticsv,__ZL31InitializeModule_UnityAnalyticsv,__ZL28CleanupModule_UnityAnalyticsv,__ZL35RegisterModuleICalls_CrashReportingv,__ZL31InitializeModule_CrashReportingv,__ZL28CleanupModule_CrashReportingv,__ZN20HardwareInfoReporter24ReportHardwareInfoStaticEv,__ZL33RegisterModuleICalls_UnityConnectv,__ZL29InitializeModule_UnityConnectv,__ZL26CleanupModule_UnityConnectv,__ZL38InitializeUnityConnectScriptingClassesv,__ZL35CleanupUnityConnectScriptingClassesv,__ZL42RequestRecreateEyeTexturesBeforeNextUpdatev,__Z29InputTracking_CUSTOM_Recenterv,__ZL23RegisterModuleICalls_VRv,__ZL19InitializeModule_VRv,__ZL16CleanupModule_VRv,__ZZN8VRModuleC1EvEN30beforeInitializeEngineGraphics7ForwardEv,__ZZN8VRModuleC1EvEN10playerQuit7ForwardEv,__ZZN8VRModuleC1EvEN21enterPlayModePreAwake7ForwardEv,__ZZN8VRModuleC1EvEN28playerLoadFirstScenePreAwake7ForwardEv,__ZZN8VRModuleC1EvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv
,__ZZN8VRModuleC1EvEN11whilePaused7ForwardEv,__ZZN8VRModuleC1EvEN25audioConfigurationChanged7ForwardEv,__ZZN8VRModuleC1EvEN33InitializationVREarlyUpdatestruct7ForwardEv,__ZN8VRModule27CleanupGfxResourcesCallbackEv,__ZZN8VRDevice10InitializeEbEN30FixedUpdateVRFixedUpdatestruct7ForwardEv,__ZZN8VRDevice10InitializeEbEN25EarlyUpdateVRUpdatestruct7ForwardEv,__ZZN8VRDevice10InitializeEbEN29FrameEventsVRBeginFramestruct7ForwardEv,__ZZN8VRDevice10InitializeEbEN27FrameEventsVREndFramestruct7ForwardEv,__ZZN8VRDevice10InitializeEbEN33PostLateUpdateVRPostPresentstruct7ForwardEv,__ZZN23CloudWebServicesManagerC1E10MemLabelId18ObjectCreationModeEN39EarlyUpdateCloudWebServicesUpdatestruct7ForwardEv,__ZL37RegisterModuleICalls_CloudWebServicesv,__ZL33InitializeModule_CloudWebServicesv,__ZL30CleanupModule_CloudWebServicesv,__ZL25ResetEllipsoidEmitterRandv,__ZN24EllipsoidParticleEmitter15InitializeClassEv,__ZN24EllipsoidParticleEmitter12CleanupClassEv,__ZL35ResetRandSeedForMeshParticleEmitterv,__ZN19MeshParticleEmitter15InitializeClassEv,__ZN19MeshParticleEmitter12CleanupClassEv,__ZN16ParticleAnimator15InitializeClassEv,__ZN16ParticleAnimator12CleanupClassEv,__ZL13ResetRandSeedv,__ZL23ResetRandSeedForEmitterv,__ZN15ParticleEmitter15InitializeClassEv,__ZN15ParticleEmitter12CleanupClassEv,__ZL36RegisterModuleICalls_ParticlesLegacyv,__ZL32InitializeModule_ParticlesLegacyv,__ZL29CleanupModule_ParticlesLegacyv,__ZZL32InitializeModule_ParticlesLegacyvEN59PostLateUpdateParticlesLegacyUpdateAllParticleSystemsstruct7ForwardEv,__ZZL32InitializeModule_ParticlesLegacyvEN16cleanupAfterLoad7ForwardEv
,__ZL41InitializeParticlesLegacyScriptingClassesv,__ZL38CleanupParticlesLegacyScriptingClassesv,_emscripten_glLoadIdentity__wrapper,_emscripten_glReleaseShaderCompiler__wrapper,_emscripten_glFinish__wrapper,_emscripten_glFlush__wrapper,_dummy0,___stdio_exit,_abort__wrapper,___cxa_end_catch__wrapper,__ZSt17__throw_bad_allocv,___cxa_rethrow__wrapper,__ZN10__cxxabiv112_GLOBAL__N_110construct_Ev,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103
,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103,b103
,b103,b103,b103];
var FUNCTION_TABLE_viid = [b104,__Z32AndroidJNI_CUSTOM_SetDoubleField13Il2Cpp_IntPtrS_d,__Z38AndroidJNI_CUSTOM_SetStaticDoubleField13Il2Cpp_IntPtrS_d,__Z39AndroidJNI_CUSTOM_SetDoubleArrayElement13Il2Cpp_IntPtrid];
var FUNCTION_TABLE_viif = [b105,__ZNK20LightPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK29LineParametersPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK28RectTransformPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK24RendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK32RendererMaterialAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK25BlendshapePropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK30SpriteRendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK22GenericPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK28MonoBehaviourPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZNK29ParticleSystemPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf,__ZN5physx3Cct26CharacterControllerManager15setTessellationEbf,__ZNK5physx14NpArticulation14getWorldBoundsEf,__ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getWorldBoundsEf,__ZNK5physx7NpCloth14getWorldBoundsEf,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getWorldBoundsEf,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setProjectionPlaneERKNS_6PxVec3Ef,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getWorldBoundsEf,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setProjectionPlaneERKNS_6PxVec3Ef,__ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getWorldBoundsEf,__ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getWorldBoundsEf,__ZN13PhysicsModule24CapsuleColliderSetHeightER15CapsuleColliderf,__ZNK12b2ChainShape11ComputeMassEP10b2MassDataf,__ZNK11b2EdgeShape11ComputeMassEP10b2MassDataf,__ZNK14b2CapsuleShape11ComputeMassEP10b2MassDataf,__ZNK14b2PolygonShape11ComputeMassEP10b2MassDataf,__ZNK13b2CircleShape11ComputeMassEP10b2MassDataf,__ZNK15b2DistanceJoint16GetReactionForceEf,__ZNK15b2FrictionJoint16GetReactionForceEf
,__ZNK11b2GearJoint16GetReactionForceEf,__ZNK12b2MotorJoint16GetReactionForceEf,__ZNK12b2MouseJoint16GetReactionForceEf,__ZNK16b2PrismaticJoint16GetReactionForceEf,__ZNK13b2PulleyJoint16GetReactionForceEf,__ZNK15b2RevoluteJoint16GetReactionForceEf,__ZNK11b2RopeJoint16GetReactionForceEf,__ZNK11b2WeldJoint16GetReactionForceEf,__ZNK12b2WheelJoint16GetReactionForceEf,__ZN14VehiclesModule37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf,__Z29ComputeShader_CUSTOM_SetFloatP12Il2CppObjectif,__Z46SkinnedMeshRenderer_CUSTOM_SetBlendShapeWeightP12Il2CppObjectif,__Z37MaterialPropertyBlock_CUSTOM_SetFloatP12Il2CppObjectif,__Z36AnimationCurve_CUSTOM_SmoothTangentsP12Il2CppObjectif,__Z27MonoBehaviour_CUSTOM_InvokeP12Il2CppObjectP12Il2CppStringf,__Z61Playable_CUSTOM_INTERNAL_CALL_SetInputWeightFromIndexInternalR9HPlayableif,__Z52Playable_CUSTOM_INTERNAL_CALL_SetInputWeightInternalR9HPlayableRKS_f,__Z35CommandBuffer_CUSTOM_SetGlobalFloatP12Il2CppObjectif,__Z24Material_CUSTOM_SetFloatP12Il2CppObjectif,__Z51Transform_CUSTOM_INTERNAL_CALL_RotateAroundInternalP12Il2CppObjectRK8Vector3ff,__Z43Transform_CUSTOM_INTERNAL_CALL_RotateAroundP12Il2CppObjectRK8Vector3ff,__Z48Transform_CUSTOM_INTERNAL_CALL_RotateAroundLocalP12Il2CppObjectRK8Vector3ff,__Z31AndroidJNI_CUSTOM_SetFloatField13Il2Cpp_IntPtrS_f,__Z37AndroidJNI_CUSTOM_SetStaticFloatField13Il2Cpp_IntPtrS_f,__Z38AndroidJNI_CUSTOM_SetFloatArrayElement13Il2Cpp_IntPtrif,_glTexParameterf__wrapper,__Z44setPxVehicleWheelsDynData_WheelRotationSpeedPN5physx22PxVehicleWheelsDynDataEjf,__Z44setPxVehicleWheelsDynData_WheelRotationAnglePN5physx22PxVehicleWheelsDynDataEjf,__Z31setPxVehicleNoDrive_BrakeTorquePN5physx16PxVehicleNoDriveEjf,__Z31setPxVehicleNoDrive_DriveTorquePN5physx16PxVehicleNoDriveEjf
,__Z30setPxVehicleNoDrive_SteerAnglePN5physx16PxVehicleNoDriveEjf,__Z32setPxVehicleAutoBoxData_UpRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf,__Z34setPxVehicleAutoBoxData_DownRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf,__Z31setPxVehicleGearsData_GearRatioPN5physx18PxVehicleGearsDataENS0_4EnumEf,__Z36setPxVehicleDriveDynData_AnalogInputPN5physx21PxVehicleDriveDynDataEjf,__Z29Cloth_CUSTOM_SetEnabledFadingP12Il2CppObjecthf,__Z32NavMeshAgent_CUSTOM_SetLayerCostP12Il2CppObjectif,__Z31NavMeshAgent_CUSTOM_SetAreaCostP12Il2CppObjectif,__Z30AudioSource_CUSTOM_PlayOneShotP12Il2CppObjectS0_f,__Z36AnimationClip_CUSTOM_SampleAnimationP12Il2CppObjectS0_f,__Z43Animator_CUSTOM_SetIKPositionWeightInternalP12Il2CppObjectif,__Z43Animator_CUSTOM_SetIKRotationWeightInternalP12Il2CppObjectif,__Z47Animator_CUSTOM_SetIKHintPositionWeightInternalP12Il2CppObjectif,__Z30Animator_CUSTOM_SetLayerWeightP12Il2CppObjectif,__Z25Animator_CUSTOM_SetTargetP12Il2CppObjectif,__Z30Animator_CUSTOM_SetFloatStringP12Il2CppObjectP12Il2CppStringf,__Z26Animator_CUSTOM_SetFloatIDP12Il2CppObjectif,__Z56AnimatorControllerPlayable_CUSTOM_SetLayerWeightInternalR9HPlayableif,__Z48AnimatorControllerPlayable_CUSTOM_SetFloatStringR9HPlayableP12Il2CppStringf,__Z44AnimatorControllerPlayable_CUSTOM_SetFloatIDR9HPlayableif,__Z26Avatar_CUSTOM_SetParameterP12Il2CppObjectif,_emscripten_glTexParameterf__wrapper,b105,b105,b105,b105,b105,b105,b105,b105
,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105,b105
,b105,b105,b105,b105,b105,b105,b105,b105,b105];
var FUNCTION_TABLE_iiiifi = [b106,__Z40Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestP12Il2CppObjectRK8Vector3fP10RaycastHitf23QueryTriggerInteraction,__Z36Collider2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfh,b106];
var FUNCTION_TABLE_iiifififf = [b107,__Z41Physics2D_CUSTOM_INTERNAL_CALL_BoxCastAllRK13Vector2fIcallS1_fS1_fiff];
var FUNCTION_TABLE_vd = [b108,_emscripten_glClearDepth__wrapper];
var FUNCTION_TABLE_vf = [b109,__Z38DynamicGI_Set_Custom_PropIndirectScalef,__Z40DynamicGI_Set_Custom_PropUpdateThresholdf,__Z40RenderSettings_Set_Custom_PropFogDensityf,__Z46RenderSettings_Set_Custom_PropFogStartDistancef,__Z44RenderSettings_Set_Custom_PropFogEndDistancef,__Z46RenderSettings_Set_Custom_PropAmbientIntensityf,__Z49RenderSettings_Set_Custom_PropReflectionIntensityf,__Z42RenderSettings_Set_Custom_PropHaloStrengthf,__Z43RenderSettings_Set_Custom_PropFlareStrengthf,__Z44RenderSettings_Set_Custom_PropFlareFadeSpeedf,__Z45QualitySettings_Set_Custom_PropShadowDistancef,__Z52QualitySettings_Set_Custom_PropShadowNearPlaneOffsetf,__Z50QualitySettings_Set_Custom_PropShadowCascade2Splitf,__Z38QualitySettings_Set_Custom_PropLodBiasf,__Z50LODGroup_Set_Custom_PropCrossFadeAnimationDurationf,__Z34Time_Set_Custom_PropFixedDeltaTimef,__Z36Time_Set_Custom_PropMaximumDeltaTimef,__Z44Time_Set_Custom_PropMaximumParticleDeltaTimef,__Z29Time_Set_Custom_PropTimeScalef,_glClearDepthf__wrapper,__Z47Physics_Set_Custom_PropMinPenetrationForPenaltyf,__Z43Physics_Set_Custom_PropDefaultContactOffsetf,__Z38Physics_Set_Custom_PropBounceThresholdf,__Z36Physics_Set_Custom_PropSleepVelocityf,__Z43Physics_Set_Custom_PropSleepAngularVelocityf,__Z41Physics_Set_Custom_PropMaxAngularVelocityf,__Z37Physics_Set_Custom_PropSleepThresholdf,__Z46Physics_Set_Custom_PropPenetrationPenaltyForcef
,__Z42Physics2D_Set_Custom_PropVelocityThresholdf,__Z44Physics2D_Set_Custom_PropMaxLinearCorrectionf,__Z45Physics2D_Set_Custom_PropMaxAngularCorrectionf,__Z44Physics2D_Set_Custom_PropMaxTranslationSpeedf,__Z41Physics2D_Set_Custom_PropMaxRotationSpeedf,__Z49Physics2D_Set_Custom_PropMinPenetrationForPenaltyf,__Z39Physics2D_Set_Custom_PropBaumgarteScalef,__Z42Physics2D_Set_Custom_PropBaumgarteTOIScalef,__Z36Physics2D_Set_Custom_PropTimeToSleepf,__Z45Physics2D_Set_Custom_PropLinearSleepTolerancef,__Z46Physics2D_Set_Custom_PropAngularSleepTolerancef,__Z42Physics2D_Set_Custom_PropContactArrowScalef,__Z41NavMesh_CUSTOM_SetAvoidancePredictionTimef,__Z35AudioListener_Set_Custom_PropVolumef,__Z37VRSettings_Set_Custom_PropRenderScalef,__Z53VRSettings_Set_Custom_PropRenderViewportScaleInternalf,_emscripten_glClearDepthf__wrapper,_emscripten_glLineWidth__wrapper,b109,b109,b109,b109,b109,b109,b109,b109,b109,b109,b109,b109
,b109,b109,b109,b109,b109];
var FUNCTION_TABLE_vi = [b110,__ZN13EmscriptenWWW15LockPartialDataEv,__ZN13EmscriptenWWW17UnlockPartialDataEv,__ZN13EmscriptenWWW6CancelEv,__ZN13EmscriptenWWW14BlockUntilDoneEv,__ZN13EmscriptenWWWD2Ev,__ZN13EmscriptenWWWD0Ev,__ZN13ScreenManagerD2Ev,__ZN18ScreenManagerWebGLD0Ev,__ZN13ScreenManager26ReapplyRequestedResolutionEv,__ZN13ScreenManager21OnWindowRegainedFocusEv,__ZN20LocalFileSystemPosixD2Ev,__ZN20LocalFileSystemWebGLD0Ev,__ZN13WebCamTextureD2Ev,__ZN13WebCamTextureD0Ev,__ZN16BaseVideoTexture17MainThreadCleanupEv,__ZN6Object21AwakeFromLoadThreadedEv,__ZN7Texture16CheckConsistencyEv,__ZN7Texture5ResetEv,__ZN6Object10SmartResetEv,__ZN7Texture13ApplySettingsEv,__ZN16BaseVideoTexture17UploadToGfxDeviceEv,__ZN16BaseVideoTexture18ReleaseVideoMemoryEv,__ZN16BaseVideoTexture17UploadTextureDataEv,__ZN13WebCamTexture6UpdateEv,__ZN13WebCamTexture4PlayEv,__ZN13WebCamTexture5PauseEv,__ZN13WebCamTexture4StopEv,__ZN16BaseVideoTexture7SuspendEv
,__ZN16BaseVideoTexture6ResumeEv,__ZN13WebCamTexture21HandleCaptureRequestsEv,__ZN17BaseWebCamTextureD2Ev,__ZN17BaseWebCamTextureD0Ev,__ZN16BaseVideoTexture4PlayEv,__ZN16BaseVideoTexture5PauseEv,__ZN16BaseVideoTexture4StopEv,__ZN15EditorExtensionD2Ev,__ZN15EditorExtensionD0Ev,__ZN6Object17MainThreadCleanupEv,__ZN6Object16CheckConsistencyEv,__ZN6Object5ResetEv,__ZN13BaseAllocatorD2Ev,__ZN13BaseAllocatorD0Ev,__ZN13BaseAllocator13ThreadCleanupEv,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED2Ev,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED0Ev,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13ThreadCleanupEv,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorED2Ev,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorED0Ev,__ZN14StackAllocatorD2Ev,__ZN14StackAllocatorD0Ev,__ZN12TLSAllocatorI14StackAllocatorED2Ev,__ZN12TLSAllocatorI14StackAllocatorED0Ev,__ZN12TLSAllocatorI14StackAllocatorE13ThreadCleanupEv,__ZN25ThreadsafeLinearAllocatorD2Ev,__ZN25ThreadsafeLinearAllocatorD0Ev,__ZN11AssetBundleD2Ev,__ZN11AssetBundleD0Ev,__ZN29AssetBundleLoadAssetOperationD2Ev
,__ZN29AssetBundleLoadAssetOperationD0Ev,__ZNK14AsyncOperation7ReleaseEv,__ZN29AssetBundleLoadAssetOperation7PerformEv,__ZN13LoadOperation19IntegrateMainThreadEv,__ZN33AssetBundleLoadFromAsyncOperationD2Ev,__ZN33AssetBundleLoadFromAsyncOperationD0Ev,__ZN33AssetBundleLoadFromAsyncOperation7PerformEv,__ZN33AssetBundleLoadFromAsyncOperation19IntegrateMainThreadEv,__ZN38AssetBundleLoadFromCacheAsyncOperationD2Ev,__ZN38AssetBundleLoadFromCacheAsyncOperationD0Ev,__ZN39AssetBundleLoadFromStreamAsyncOperationD2Ev,__ZN39AssetBundleLoadFromStreamAsyncOperationD0Ev,__ZN37AssetBundleLoadFromFileAsyncOperationD2Ev,__ZN37AssetBundleLoadFromFileAsyncOperationD0Ev,__ZN19AssetBundleManifestD2Ev,__ZN19AssetBundleManifestD0Ev,__ZN39AssetBundleLoadFromMemoryAsyncOperationD0Ev,__ZN6ObjectD2Ev,__ZN6ObjectD0Ev,__ZN16LevelGameManagerD2Ev,__ZN16LevelGameManagerD0Ev,__ZN11GameManager17MainThreadCleanupEv,__ZN11GameManager24NetworkOnApplicationQuitEv,__ZN11GameManager13NetworkUpdateEv,__ZN11GameManagerD2Ev,__ZN11GameManagerD0Ev,__ZN17GlobalGameManagerD2Ev,__ZN17GlobalGameManagerD0Ev,__ZN10GameObjectD2Ev,__ZN10GameObjectD0Ev
,__ZN10GameObject16CheckConsistencyEv,__ZN10GameObject5ResetEv,__ZN5Unity9ComponentD2Ev,__ZN5Unity9ComponentD0Ev,__ZN5Unity9Component16CheckConsistencyEv,__ZN5Unity9Component20WillDestroyComponentEv,__ZN11NamedObjectD2Ev,__ZN11NamedObjectD0Ev,__ZN10TagManagerD2Ev,__ZN10TagManagerD0Ev,__ZN10TagManager5ResetEv,__ZN12BaseRendererD2Ev,__ZN12BaseRendererD0Ev,__ZN12BaseRenderer23RendererCullingCallbackEv,__ZN12BaseRenderer21RendererBecameVisibleEv,__ZN12BaseRenderer23RendererBecameInvisibleEv,__ZN12BaseRenderer23UpdatePreviousFrameDataEv,__ZN6CameraD2Ev,__ZN6CameraD0Ev,__ZN6Camera17MainThreadCleanupEv,__ZN6Camera16CheckConsistencyEv,__ZN6Camera5ResetEv,__ZN9Behaviour6UpdateEv,__ZN9Behaviour11FixedUpdateEv,__ZN9Behaviour10LateUpdateEv,__ZN6Camera12AddToManagerEv,__ZN6Camera17RemoveFromManagerEv,__ZN5FlareD2Ev,__ZN5FlareD0Ev,__ZN5Flare5ResetEv
,__ZN9LensFlareD2Ev,__ZN9LensFlareD0Ev,__ZN9LensFlare5ResetEv,__ZN9LensFlare12AddToManagerEv,__ZN9LensFlare17RemoveFromManagerEv,__ZN10FlareLayerD2Ev,__ZN10FlareLayerD0Ev,__ZN10FlareLayer12AddToManagerEv,__ZN10FlareLayer17RemoveFromManagerEv,__ZN16GraphicsSettingsD2Ev,__ZN16GraphicsSettingsD0Ev,__ZN16GraphicsSettings10SmartResetEv,__ZN4HaloD2Ev,__ZN4HaloD0Ev,__ZN4Halo5ResetEv,__ZN4Halo12AddToManagerEv,__ZN4Halo17RemoveFromManagerEv,__ZN20IntermediateRendererD2Ev,__ZN20IntermediateRendererD0Ev,__ZN20IntermediateRenderer19UpdateTransformInfoEv,__ZN20IntermediateRenderer10UpdateAABBEv,__ZN24MeshIntermediateRendererD2Ev,__ZN24MeshIntermediateRendererD0Ev,__ZN24MeshIntermediateRenderer14OnAssetDeletedEv,__ZThn264_N24MeshIntermediateRenderer14OnAssetDeletedEv,__ZN9AssetUser15OnBoundsChangedEv,__ZN31CanvasBatchIntermediateRendererD2Ev,__ZN31CanvasBatchIntermediateRendererD0Ev,__ZN31CanvasBatchIntermediateRenderer14OnAssetDeletedEv,__ZThn264_N31CanvasBatchIntermediateRenderer14OnAssetDeletedEv
,__ZN5LightD2Ev,__ZN5LightD0Ev,__ZN5Light17MainThreadCleanupEv,__ZN5Light16CheckConsistencyEv,__ZN5Light5ResetEv,__ZN5Light12AddToManagerEv,__ZN5Light17RemoveFromManagerEv,__ZN15SharedLightDataD2Ev,__ZN15SharedLightDataD0Ev,__ZN19ShaderPropertySheetD2Ev,__ZN19ShaderPropertySheetD0Ev,__ZN19SharedRendererSceneD2Ev,__ZN19SharedRendererSceneD0Ev,__ZN9HaloLayerD2Ev,__ZN9HaloLayerD0Ev,__ZN9HaloLayer12AddToManagerEv,__ZN9HaloLayer17RemoveFromManagerEv,__ZN21LightProbeProxyVolumeD2Ev,__ZN21LightProbeProxyVolumeD0Ev,__ZN21LightProbeProxyVolume17MainThreadCleanupEv,__ZN21LightProbeProxyVolume16CheckConsistencyEv,__ZN21LightProbeProxyVolume5ResetEv,__ZN21LightProbeProxyVolume12AddToManagerEv,__ZN21LightProbeProxyVolume17RemoveFromManagerEv,__ZN11LightProbesD2Ev,__ZN11LightProbesD0Ev,__ZN13OcclusionAreaD2Ev,__ZN13OcclusionAreaD0Ev,__ZN13OcclusionArea5ResetEv,__ZN20OcclusionCullingDataD2Ev
,__ZN20OcclusionCullingDataD0Ev,__ZN20OcclusionCullingData17MainThreadCleanupEv,__ZN24OcclusionCullingSettingsD2Ev,__ZN24OcclusionCullingSettingsD0Ev,__ZN24OcclusionCullingSettings17MainThreadCleanupEv,__ZN15OcclusionPortalD2Ev,__ZN15OcclusionPortalD0Ev,__ZN9ProjectorD2Ev,__ZN9ProjectorD0Ev,__ZN9Projector16CheckConsistencyEv,__ZN9Projector5ResetEv,__ZN9Projector12AddToManagerEv,__ZN9Projector17RemoveFromManagerEv,__ZN15ReflectionProbeD2Ev,__ZN15ReflectionProbeD0Ev,__ZN15ReflectionProbe16CheckConsistencyEv,__ZN15ReflectionProbe5ResetEv,__ZN15ReflectionProbe12AddToManagerEv,__ZN15ReflectionProbe17RemoveFromManagerEv,__ZN14RenderSettingsD2Ev,__ZN14RenderSettingsD0Ev,__ZN14RenderSettings16CheckConsistencyEv,__ZN14RenderSettings5ResetEv,__ZN18ShadowMapJobHeaderD2Ev,__ZN18ShadowMapJobHeaderD0Ev,__ZN25ShadowMapJobHeaderScratchD2Ev,__ZN25ShadowMapJobHeaderScratchD0Ev,__ZN25ShadowMapJobHeaderScratch15ThreadedCleanupEv,__ZN20DynamicPropertySheetD2Ev,__ZN20DynamicPropertySheetD0Ev
,__ZN6SkyboxD2Ev,__ZN6SkyboxD0Ev,__ZN6Skybox12AddToManagerEv,__ZN6Skybox17RemoveFromManagerEv,__ZN10GUIElementD2Ev,__ZN10GUIElementD0Ev,__ZN10GUIElement12AddToManagerEv,__ZN10GUIElement17RemoveFromManagerEv,__ZN10GUITextureD2Ev,__ZN10GUITextureD0Ev,__ZN10GUITexture5ResetEv,__ZN8GUILayerD2Ev,__ZN8GUILayerD0Ev,__ZN8GUILayer12AddToManagerEv,__ZN8GUILayer17RemoveFromManagerEv,__ZN25DeferredRenderLoopScratchD2Ev,__ZN25DeferredRenderLoopScratchD0Ev,__ZN25DeferredRenderLoopScratch15ThreadedCleanupEv,__ZN18DeferredRenderLoopD2Ev,__ZN18DeferredRenderLoopD0Ev,__ZN30ForwardShaderRenderLoopScratchD2Ev,__ZN30ForwardShaderRenderLoopScratchD0Ev,__ZN30ForwardShaderRenderLoopScratch15ThreadedCleanupEv,__ZN23ForwardShaderRenderLoopD2Ev,__ZN23ForwardShaderRenderLoopD0Ev,__ZN29MotionVectorRenderLoopScratchD2Ev,__ZN29MotionVectorRenderLoopScratchD0Ev,__ZN29MotionVectorRenderLoopScratch15ThreadedCleanupEv,__ZN22MotionVectorRenderLoopD2Ev,__ZN22MotionVectorRenderLoopD0Ev
,__ZN17RenderLoopContextD2Ev,__ZN17RenderLoopContextD0Ev,__ZN15ReplacementPassD2Ev,__ZN15ReplacementPassD0Ev,__ZN29DepthOrReplacementPassScratchD2Ev,__ZN29DepthOrReplacementPassScratchD0Ev,__ZN21GfxDeviceAsyncCommand10ArgScratch15ThreadedCleanupEv,__ZN9DepthPassD2Ev,__ZN9DepthPassD0Ev,__ZN14DirectorPlayerD2Ev,__ZN14DirectorPlayerD0Ev,__ZN14DirectorPlayer17MainThreadCleanupEv,__ZN14DirectorPlayer12AddToManagerEv,__ZN14DirectorPlayer17RemoveFromManagerEv,__ZN14DirectorPlayer4StopEv,__ZN14DirectorPlayer15SetPrepareStageEv,__ZN8PlayableD2Ev,__ZN8PlayableD0Ev,__ZN8Playable19DeallocateResourcesEv,__ZN20BaseBehaviourManagerD2Ev,__ZN20BaseBehaviourManagerD0Ev,__ZN18DelayedCallManagerD2Ev,__ZN18DelayedCallManagerD0Ev,__ZN18DelayedCallManager17MainThreadCleanupEv,__ZN9BehaviourD2Ev,__ZN9BehaviourD0Ev,__ZN16BehaviourManagerD0Ev,__ZN16BehaviourManager6UpdateEv,__ZN21FixedBehaviourManagerD0Ev,__ZN21FixedBehaviourManager6UpdateEv
,__ZN20LateBehaviourManagerD0Ev,__ZN20LateBehaviourManager6UpdateEv,__ZN13UpdateManagerD0Ev,__ZN13UpdateManager6UpdateEv,__ZN22BlockMemoryCacheWriterD2Ev,__ZN22BlockMemoryCacheWriterD0Ev,__ZN9GfxDeviceD2Ev,__ZN9GfxDeviceD0Ev,__ZN9GfxDevice15InvalidateStateEv,__ZN9GfxDevice18BeforePluginRenderEv,__ZN9GfxDevice17AfterPluginRenderEv,__ZN9GfxDevice19RenderTargetBarrierEv,__ZN9GfxDevice26UpdateViewProjectionMatrixEv,__ZN9GfxDevice19EndGeometryJobFrameEv,__ZN9GfxDevice16EndAsyncJobFrameEv,__ZN9GfxDevice14AddSetPassStatEv,__ZN9GfxDevice40IgnoreNextUnresolveOnCurrentRenderTargetEv,__ZN9GfxDevice17CommitVertexDeclsEv,__ZN9GfxDevice21ResetDynamicResourcesEv,__ZN9GfxDevice5FlushEv,__ZN9GfxDevice22AcquireThreadOwnershipEv,__ZN9GfxDevice22ReleaseThreadOwnershipEv,__ZN9GfxDevice12ImmediateEndEv,__ZN9GfxDevice13AfterDrawCallEv,__ZN9GfxDevice15ResetFrameStatsEv,__ZN9GfxDevice15BeginFrameStatsEv,__ZN9GfxDevice13EndFrameStatsEv,__ZN9GfxDevice13SaveDrawStatsEv,__ZN9GfxDevice16RestoreDrawStatsEv,__ZN9GfxDevice16SynchronizeStatsEv
,__ZN9GfxDevice15EndProfileEventEv,__ZN9GfxDevice16WakeRenderThreadEv,__ZN9GfxDevice23ClearRandomWriteTargetsEv,__ZN14GfxDeviceStats26AccumulateUsedTextureUsageEv,__ZN19GfxThreadableDeviceD0Ev,__ZN10GpuProgramD2Ev,__ZN10GpuProgramD0Ev,__ZN22VertexDeclarationCacheD2Ev,__ZN22VertexDeclarationCacheD0Ev,__ZN12CubemapArrayD2Ev,__ZN12CubemapArrayD0Ev,__ZN12CubemapArray17MainThreadCleanupEv,__ZN12CubemapArray5ResetEv,__ZN12CubemapArray17UploadToGfxDeviceEv,__ZN7CubemapD2Ev,__ZN7CubemapD0Ev,__ZN9Texture2D17MainThreadCleanupEv,__ZN9Texture2D21AwakeFromLoadThreadedEv,__ZN9Texture2D5ResetEv,__ZN9Texture2D13ApplySettingsEv,__ZN9Texture2D17UploadToGfxDeviceEv,__ZN7Cubemap13UploadTextureEv,__ZN9Texture2D15UpdateImageDataEv,__ZN9Texture2D30UpdateImageDataDontTouchMipmapEv,__ZN7Cubemap13RebuildMipMapEv,__ZN17SharedTextureDataD2Ev,__ZN17SharedTextureDataD0Ev,__ZN12ImageDecoderD2Ev,__ZN12ImageDecoderD0Ev,__ZN10PngDecoderD2Ev
,__ZN10PngDecoderD0Ev,__ZN10PngDecoder11InitDecoderEv,__ZN11JpegDecoderD2Ev,__ZN11JpegDecoderD0Ev,__ZN11JpegDecoder11InitDecoderEv,__ZN15LightProbeGroupD2Ev,__ZN15LightProbeGroupD0Ev,__ZN15LightProbeGroup12AddToManagerEv,__ZN15LightProbeGroup17RemoveFromManagerEv,__ZN16LightmapSettingsD2Ev,__ZN16LightmapSettingsD0Ev,__ZN16LightmapSettings16CheckConsistencyEv,__ZN16LightmapSettings5ResetEv,__ZN26SharedLightmapSettingsDataD2Ev,__ZN26SharedLightmapSettingsDataD0Ev,__ZN12LineRendererD2Ev,__ZN12LineRendererD0Ev,__ZN8Renderer17MainThreadCleanupEv,__ZN12LineRenderer16CheckConsistencyEv,__ZN12LineRenderer5ResetEv,__ZN8Renderer10SmartResetEv,__ZN8Renderer21RendererBecameVisibleEv,__ZN8Renderer23RendererBecameInvisibleEv,__ZN12LineRenderer19UpdateTransformInfoEv,__ZN8Renderer15UpdateLocalAABBEv,__ZN12LineRenderer14UpdateRendererEv,__ZN8Renderer10AddToSceneEv,__ZN8Renderer15RemoveFromSceneEv,__ZThn32_N12LineRendererD1Ev,__ZThn32_N12LineRendererD0Ev
,__ZThn32_N8Renderer21RendererBecameVisibleEv,__ZThn32_N8Renderer23RendererBecameInvisibleEv,__ZThn32_N12LineRenderer19UpdateTransformInfoEv,__ZN8RendererD2Ev,__ZN8RendererD0Ev,__ZN8Renderer16CheckConsistencyEv,__ZN8Renderer19UpdateTransformInfoEv,__ZN8Renderer14UpdateRendererEv,__ZThn32_N8RendererD1Ev,__ZThn32_N8RendererD0Ev,__ZThn32_N8Renderer19UpdateTransformInfoEv,__ZN15QualitySettingsD2Ev,__ZN15QualitySettingsD0Ev,__ZN15QualitySettings16CheckConsistencyEv,__ZN15QualitySettings5ResetEv,__ZN2UI13RectTransformD2Ev,__ZN2UI13RectTransformD0Ev,__ZN9Transform17MainThreadCleanupEv,__ZN9Transform16CheckConsistencyEv,__ZN2UI13RectTransform5ResetEv,__ZN2UI13RectTransform10SmartResetEv,__ZN13RenderTextureD2Ev,__ZN13RenderTextureD0Ev,__ZN13RenderTexture17MainThreadCleanupEv,__ZN13RenderTexture13ApplySettingsEv,__ZN13RenderTexture17UploadToGfxDeviceEv,__ZN13ScreenManagerD0Ev,__ZN12LineRenderer10LinePointsD2Ev,__ZN12LineRenderer10LinePointsD0Ev,__ZN14LineParametersD2Ev
,__ZN14LineParametersD0Ev,__ZN7TextureD2Ev,__ZN19LowerResBlitTextureD0Ev,__ZN19LowerResBlitTexture17MainThreadCleanupEv,__ZN19LowerResBlitTexture13ApplySettingsEv,__ZN19LowerResBlitTexture17UploadToGfxDeviceEv,__ZN13SparseTextureD2Ev,__ZN13SparseTextureD0Ev,__ZN13SparseTexture17MainThreadCleanupEv,__ZN13SparseTexture17UploadToGfxDeviceEv,__ZN6SpriteD2Ev,__ZN6SpriteD0Ev,__ZN6Sprite17MainThreadCleanupEv,__ZN22SharedSpriteRenderDataD2Ev,__ZN22SharedSpriteRenderDataD0Ev,__ZN7TextureD0Ev,__ZN7Texture17MainThreadCleanupEv,__ZN9Texture2DD2Ev,__ZN9Texture2DD0Ev,__ZN9Texture2D13UploadTextureEv,__ZN9Texture2D13RebuildMipMapEv,__ZN14Texture2DArrayD2Ev,__ZN14Texture2DArrayD0Ev,__ZN14Texture2DArray17MainThreadCleanupEv,__ZN14Texture2DArray5ResetEv,__ZN14Texture2DArray17UploadToGfxDeviceEv,__ZN9Texture3DD2Ev,__ZN9Texture3DD0Ev,__ZN9Texture3D17MainThreadCleanupEv,__ZN9Texture3D5ResetEv
,__ZN9Texture3D17UploadToGfxDeviceEv,__ZN13TrailRendererD2Ev,__ZN13TrailRendererD0Ev,__ZN13TrailRenderer16CheckConsistencyEv,__ZN13TrailRenderer5ResetEv,__ZN13TrailRenderer19UpdateTransformInfoEv,__ZN13TrailRenderer14UpdateRendererEv,__ZThn32_N13TrailRendererD1Ev,__ZThn32_N13TrailRendererD0Ev,__ZThn32_N13TrailRenderer19UpdateTransformInfoEv,__ZN9TransformD2Ev,__ZN9TransformD0Ev,__ZN9Transform5ResetEv,__ZN13TrailRenderer11TrailPointsD2Ev,__ZN13TrailRenderer11TrailPointsD0Ev,__ZN14BillboardAssetD2Ev,__ZN14BillboardAssetD0Ev,__ZN14BillboardAsset17MainThreadCleanupEv,__ZN14BillboardAsset5ResetEv,__ZN17BillboardRendererD2Ev,__ZN17BillboardRendererD0Ev,__ZN17BillboardRenderer17MainThreadCleanupEv,__ZN17BillboardRenderer19UpdateTransformInfoEv,__ZN17BillboardRenderer15UpdateLocalAABBEv,__ZN17BillboardRenderer14OnAssetDeletedEv,__ZN17BillboardRenderer15OnBoundsChangedEv,__ZThn32_N17BillboardRendererD1Ev,__ZThn32_N17BillboardRendererD0Ev,__ZThn32_N17BillboardRenderer19UpdateTransformInfoEv,__ZThn340_N17BillboardRenderer14OnAssetDeletedEv
,__ZThn340_N17BillboardRenderer15OnBoundsChangedEv,__ZN19SharedBillboardDataD2Ev,__ZN19SharedBillboardDataD0Ev,__ZN22RenderingCommandBufferD2Ev,__ZN22RenderingCommandBufferD0Ev,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE
,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf14TexFormatRHalfEEvPKNS_9InnerInfoE
,__ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI16TexFormatRGFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatRGBAFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatARGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI14TexFormatRHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRGHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBAHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB565EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB4444EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI11TexFormatA817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB56511TexFormatI8EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatRGB888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB4444EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatBGR888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB88811TexFormatI8EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB88815TexFormatRGB565EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB4444EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB444411TexFormatI8EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB565EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatABGR8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatI8EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatA8EEvPKNS_9InnerInfoE
,__ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB565EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatARGB4444EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatBGR888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatABGR8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA4444EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatBGRA8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI15TexFormatBGR88817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatABGR888817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatABGR8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatABGR8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatARGB8888EEvPKNS_9InnerInfoE,__ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatABGR8888EEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI16TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI14TexFormatRHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888816TexFormatRGFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatRGBAFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatARGBFloatEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888814TexFormatRHalfEEvPKNS_9InnerInfoE
,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRGHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBAHalfEEvPKNS_9InnerInfoE,__ZN6prcoreL13inner_stretchILj1ELj1EEEvPKNS_9InnerInfoE,__ZN6prcoreL13inner_stretchILj2ELj2EEEvPKNS_9InnerInfoE,__ZN6prcoreL13inner_stretchILj3ELj3EEEvPKNS_9InnerInfoE,__ZN6prcoreL13inner_stretchILj4ELj4EEEvPKNS_9InnerInfoE,__ZN6prcoreL25inner_stretch_i8_bilinearEPKNS_9InnerInfoE,__ZN6prcoreL29inner_stretch_rgb565_bilinearEPKNS_9InnerInfoE,__ZN6prcoreL29inner_stretch_rgb888_bilinearEPKNS_9InnerInfoE,__ZN6prcoreL31inner_stretch_argb4444_bilinearEPKNS_9InnerInfoE,__ZN6prcoreL31inner_stretch_argb8888_bilinearEPKNS_9InnerInfoE,__ZN8LODGroupD2Ev,__ZN8LODGroupD0Ev,__ZN8LODGroup16CheckConsistencyEv,__ZN8LODGroup5ResetEv,__ZN8LODGroup10SmartResetEv,__ZN10DynamicVBOD2Ev,__ZN10DynamicVBOD0Ev,__ZN17GenericDynamicVBOD2Ev,__ZN17GenericDynamicVBOD0Ev,__ZN4MeshD2Ev,__ZN4MeshD0Ev,__ZN4Mesh17MainThreadCleanupEv,__ZN4Mesh21AwakeFromLoadThreadedEv,__ZN14SharedMeshDataD2Ev,__ZN14SharedMeshDataD0Ev,__ZN10MeshFilterD2Ev,__ZN10MeshFilterD0Ev,__ZN10MeshFilter20WillDestroyComponentEv,__ZN12MeshRendererD2Ev
,__ZN12MeshRendererD0Ev,__ZN12MeshRenderer17MainThreadCleanupEv,__ZN12MeshRenderer15UpdateLocalAABBEv,__ZThn32_N12MeshRendererD1Ev,__ZThn32_N12MeshRendererD0Ev,__ZN23SharedMeshRenderingDataD2Ev,__ZN23SharedMeshRenderingDataD0Ev,__ZN19SkinnedMeshRendererD2Ev,__ZN19SkinnedMeshRendererD0Ev,__ZN19SkinnedMeshRenderer17MainThreadCleanupEv,__ZN19SkinnedMeshRenderer5ResetEv,__ZN19SkinnedMeshRenderer19UpdateTransformInfoEv,__ZN19SkinnedMeshRenderer14UpdateRendererEv,__ZN19SkinnedMeshRenderer13BecameVisibleEv,__ZN19SkinnedMeshRenderer15BecameInvisibleEv,__ZN19SkinnedMeshRenderer23UpdatePreviousFrameDataEv,__ZThn32_N19SkinnedMeshRendererD1Ev,__ZThn32_N19SkinnedMeshRendererD0Ev,__ZThn32_N19SkinnedMeshRenderer23UpdatePreviousFrameDataEv,__ZThn32_N19SkinnedMeshRenderer19UpdateTransformInfoEv,__ZN15SharedGfxBufferD2Ev,__ZN15SharedGfxBufferD0Ev,__ZN14SpriteRendererD2Ev,__ZN14SpriteRendererD0Ev,__ZN14SpriteRenderer17MainThreadCleanupEv,__ZN14SpriteRenderer5ResetEv,__ZN14SpriteRenderer10SmartResetEv,__ZN14SpriteRenderer19UpdateTransformInfoEv,__ZN14SpriteRenderer15UpdateLocalAABBEv,__ZThn32_N14SpriteRendererD1Ev
,__ZThn32_N14SpriteRendererD0Ev,__ZThn32_N14SpriteRenderer19UpdateTransformInfoEv,__ZN18ProceduralMaterialD2Ev,__ZN18ProceduralMaterialD0Ev,__ZN18ProceduralMaterial17MainThreadCleanupEv,__ZN18ProceduralMaterial21AwakeFromLoadThreadedEv,__ZN8Material5ResetEv,__ZN25SubstanceRawTextureSharedD2Ev,__ZN25SubstanceRawTextureSharedD0Ev,__ZN17ProceduralTextureD2Ev,__ZN17ProceduralTextureD0Ev,__ZN17ProceduralTexture17MainThreadCleanupEv,__ZN17ProceduralTexture21AwakeFromLoadThreadedEv,__ZN17ProceduralTexture17UploadToGfxDeviceEv,__ZN20SubstanceArchiveDataD2Ev,__ZN20SubstanceArchiveDataD0Ev,__ZN16SubstanceArchiveD2Ev,__ZN16SubstanceArchiveD0Ev,__ZN9InputAxis6UpdateEv,__ZN12InputManagerD2Ev,__ZN12InputManagerD0Ev,__ZN12InputManager16CheckConsistencyEv,__ZN12InputManager5ResetEv,__ZN11TimeManagerD2Ev,__ZN11TimeManagerD0Ev,__ZN11TimeManager16CheckConsistencyEv,__ZN11TimeManager5ResetEv,__ZN11TimeManager6UpdateEv,__ZN19TouchPhaseEmulationD2Ev,__ZN19TouchPhaseEmulationD0Ev
,__ZN14AsyncOperationD2Ev,__ZN14AsyncOperationD0Ev,__ZN13BuildSettingsD2Ev,__ZN13BuildSettingsD0Ev,__ZN14PlayerSettingsD2Ev,__ZN14PlayerSettingsD0Ev,__ZN14PlayerSettings16CheckConsistencyEv,__ZN14PlayerSettings5ResetEv,__ZN14PlayerSettings10SmartResetEv,__ZN15ResourceManagerD2Ev,__ZN15ResourceManagerD0Ev,__ZN30RuntimeInitializeOnLoadManagerD2Ev,__ZN30RuntimeInitializeOnLoadManagerD0Ev,__ZN30RuntimeInitializeOnLoadManager6UpdateEv,__ZN27GenericSlowGarbageCollectorD2Ev,__ZN27GenericSlowGarbageCollectorD0Ev,__ZN14InputInterfaceD2Ev,__ZN14InputInterfaceD0Ev,__ZN9WWWCached15LockPartialDataEv,__ZN9WWWCached17UnlockPartialDataEv,__ZN9WWWCached6CancelEv,__ZN9WWWCached14BlockUntilDoneEv,__ZN9WWWCachedD2Ev,__ZN9WWWCachedD0Ev,__ZN10MonoScriptD2Ev,__ZN10MonoScriptD0Ev,__ZN10MonoScript17MainThreadCleanupEv,__ZN10MonoScript21AwakeFromLoadThreadedEv,__ZN13MonoBehaviourD2Ev,__ZN13MonoBehaviourD0Ev
,__ZN13MonoBehaviour17MainThreadCleanupEv,__ZN13MonoBehaviour10SmartResetEv,__ZN13MonoBehaviour20WillDestroyComponentEv,__ZN13MonoBehaviour6UpdateEv,__ZN13MonoBehaviour11FixedUpdateEv,__ZN13MonoBehaviour10LateUpdateEv,__ZN13MonoBehaviour12AddToManagerEv,__ZN13MonoBehaviour17RemoveFromManagerEv,__ZN6SocketD2Ev,__ZN6SocketD0Ev,__ZN9UdpSocketD2Ev,__ZN9UdpSocketD0Ev,__ZN17GeneralConnectionD2Ev,__ZN17GeneralConnectionD0Ev,__ZN17GeneralConnection13WaitForFinishEv,__ZN16PlayerConnectionD2Ev,__ZN16PlayerConnectionD0Ev,__ZN17MemoryCacheWriterD2Ev,__ZN17MemoryCacheWriterD0Ev,__ZN13LoadOperationD2Ev,__ZN13LoadOperationD0Ev,__ZN13LoadOperation7PerformEv,__ZN18LoadSceneOperationD2Ev,__ZN18LoadSceneOperationD0Ev,__ZN18LoadSceneOperation7PerformEv,__ZN18LoadSceneOperation19IntegrateMainThreadEv,__ZN23PreloadManagerOperationD0Ev,__ZN23PreloadManagerOperation19IntegrateMainThreadEv,__ZN20UnloadSceneOperationD2Ev,__ZN20UnloadSceneOperationD0Ev
,__ZN20UnloadSceneOperation7PerformEv,__ZN20UnloadSceneOperation19IntegrateMainThreadEv,__ZN11PreloadDataD2Ev,__ZN11PreloadDataD0Ev,__ZN27UnloadUnusedAssetsOperationD0Ev,__ZN27UnloadUnusedAssetsOperation7PerformEv,__ZN27UnloadUnusedAssetsOperation19IntegrateMainThreadEv,__ZN21LoadResourceOperationD0Ev,__ZN19RuntimeSceneManagerD2Ev,__ZN19RuntimeSceneManagerD0Ev,__ZN10UnitySceneD2Ev,__ZN10UnitySceneD0Ev,__ZNK10UnityScene7ReleaseEv,__ZN11MonoManagerD2Ev,__ZN11MonoManagerD0Ev,__ZN16ScriptingManagerD2Ev,__ZN16ScriptingManagerD0Ev,__ZN9TextAssetD2Ev,__ZN9TextAssetD0Ev,__ZN17PersistentManagerD2Ev,__ZN17PersistentManagerD0Ev,__ZN25PathNamePersistentManagerD2Ev,__ZN25PathNamePersistentManagerD0Ev,__ZN17MemoryCacheReaderD2Ev,__ZN17MemoryCacheReaderD0Ev,__ZN18IDCollectorFunctorD2Ev,__ZN18IDCollectorFunctorD0Ev,__ZN14FileCacherReadD2Ev,__ZN14FileCacherReadD0Ev,__ZN15CacheReaderBaseD2Ev
,__ZN22MemoryCacherReadBlocksD0Ev,__ZN15CacheReaderBaseD0Ev,__ZN15CacheWriterBaseD2Ev,__ZN15CacheWriterBaseD0Ev,__ZN13ComputeShaderD2Ev,__ZN13ComputeShaderD0Ev,__ZN13ComputeShader17MainThreadCleanupEv,__ZN8MaterialD2Ev,__ZN8MaterialD0Ev,__ZN8Material17MainThreadCleanupEv,__ZN18SharedMaterialDataD2Ev,__ZN18SharedMaterialDataD0Ev,__ZN6ShaderD2Ev,__ZN6ShaderD0Ev,__ZN6Shader17MainThreadCleanupEv,__ZN6Shader21AwakeFromLoadThreadedEv,__ZN12ScriptMapperD2Ev,__ZN12ScriptMapperD0Ev,__ZN9CGProgramD2Ev,__ZN9CGProgramD0Ev,__ZN23ShaderVariantCollectionD2Ev,__ZN23ShaderVariantCollectionD0Ev,__ZN9ShaderLab7ProgramD2Ev,__ZN9ShaderLab7ProgramD0Ev,__ZN18SpeedTreeWindAssetD2Ev,__ZN18SpeedTreeWindAssetD0Ev,__ZN18SpeedTreeWindAsset17MainThreadCleanupEv,__ZN8WindZoneD2Ev,__ZN8WindZoneD0Ev,__ZN8WindZone5ResetEv
,__ZN8WindZone12AddToManagerEv,__ZN8WindZone17RemoveFromManagerEv,__ZN17WeakPtrSharedDataD2Ev,__ZN17WeakPtrSharedDataD0Ev,__ZN24UserAuthorizationManager33UserAuthorizationManagerOperationD0Ev,__ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperationD0Ev,__ZN11ICompressorD2Ev,__ZN13Lz4CompressorD0Ev,__ZN13IDecompressorD2Ev,__ZN15Lz4DecompressorD0Ev,__ZN17ArchiveFileSystemD2Ev,__ZN17ArchiveFileSystemD0Ev,__ZN15ArchiveReadFileD2Ev,__ZN15ArchiveReadFileD0Ev,__ZN19FileAccessorHandlerD2Ev,__ZN12IFileAdapterD0Ev,__ZN20ArchiveStorageReaderD2Ev,__ZN20ArchiveStorageReaderD0Ev,__ZN12FileAccessorD2Ev,__ZN12FileAccessorD0Ev,__ZN12HandlerChainD2Ev,__ZN12HandlerChainD0Ev,__ZN22LocalFileSystemHandlerD0Ev,__ZN20LocalFileSystemPosixD0Ev,__ZN10MemoryFileD2Ev,__ZN10MemoryFileD0Ev,__ZN16MemoryFileSystemD2Ev,__ZN16MemoryFileSystemD0Ev,__ZN25MultiBlocksMemoryFileDataD2Ev,__ZN25MultiBlocksMemoryFileDataD0Ev
,__ZN24RingBufferMemoryFileDataD2Ev,__ZN24RingBufferMemoryFileDataD0Ev,__ZN25SingleBlockMemoryFileDataD2Ev,__ZN25SingleBlockMemoryFileDataD0Ev,__ZN8WWWAudioD2Ev,__ZN8WWWAudioD0Ev,__ZN8WWWAudio15LockPartialDataEv,__ZN8WWWAudio17UnlockPartialDataEv,__ZN21UnityDefaultAllocatorI17LowLevelAllocatorED2Ev,__ZN21UnityDefaultAllocatorI17LowLevelAllocatorED0Ev,__ZN15MulticastSocketD0Ev,__ZN12ServerSocketD0Ev,__ZN12SocketStreamD0Ev,__ZN12SocketStream13OnSocketErrorEv,__ZN20BufferedSocketStreamD2Ev,__ZN20BufferedSocketStreamD0Ev,__ZN20BufferedSocketStream13OnSocketErrorEv,__ZN21AssetBundleFileSystemD2Ev,__ZN21AssetBundleFileSystemD0Ev,__ZN3WWWD2Ev,__ZN3WWWD0Ev,__ZN13GfxDeviceGLESD2Ev,__ZN13GfxDeviceGLESD0Ev,__ZN13GfxDeviceGLES15InvalidateStateEv,__ZN13GfxDeviceGLES18BeforePluginRenderEv,__ZN13GfxDeviceGLES17AfterPluginRenderEv,__ZN13GfxDeviceGLES19RenderTargetBarrierEv,__ZN13GfxDeviceGLES14DisableScissorEv,__ZN13GfxDeviceGLES10BeginFrameEv,__ZN13GfxDeviceGLES8EndFrameEv
,__ZN13GfxDeviceGLES12PresentFrameEv,__ZN13GfxDeviceGLES5FlushEv,__ZN13GfxDeviceGLES15FinishRenderingEv,__ZN13GfxDeviceGLES22AcquireThreadOwnershipEv,__ZN13GfxDeviceGLES22ReleaseThreadOwnershipEv,__ZN13GfxDeviceGLES14BeforeDrawCallEv,__ZN13GfxDeviceGLES15EndProfileEventEv,__ZN13GfxDeviceGLES17BeginTimerQueriesEv,__ZN13GfxDeviceGLES15EndTimerQueriesEv,__ZN13GfxDeviceGLES23ClearRandomWriteTargetsEv,__ZN13GfxDeviceGLES15ReloadResourcesEv,__ZN31TransformFeedbackSkinPoseBufferD2Ev,__ZN31TransformFeedbackSkinPoseBufferD0Ev,__ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED2Ev,__ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED0Ev,__ZN9GfxBuffer5ResetEv,__ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED2Ev,__ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED0Ev,__ZN26VertexDeclarationCacheGLESD0Ev,__ZN17VertexDeclarationD2Ev,__ZN21VertexDeclarationGLESD0Ev,__ZN18GlslGpuProgramGLESD2Ev,__ZN18GlslGpuProgramGLESD0Ev,__ZN14TimerQueryGLESD2Ev,__ZN14TimerQueryGLESD0Ev,__ZN14TimerQueryGLES7MeasureEv,__ZN13GfxTimerQueryD2Ev,__ZN13GfxTimerQueryD0Ev,__ZN15UniformTFMethodD2Ev,__ZN15UniformTFMethodD0Ev
,__ZN15UniformTFMethod15UnmapBoneBufferEv,__ZN15UniformTFMethod13DoneRenderingEv,__ZN21UniformBufferTFMethodD2Ev,__ZN21UniformBufferTFMethodD0Ev,__ZN21UniformBufferTFMethod15UnmapBoneBufferEv,__ZN21UniformBufferTFMethod13DoneRenderingEv,__ZN15TextureTFMethodD2Ev,__ZN15TextureTFMethodD0Ev,__ZN15TextureTFMethod15UnmapBoneBufferEv,__ZN15TextureTFMethod13DoneRenderingEv,__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,__ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev,__ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev,__ZN13GfxDeviceNullD2Ev,__ZN13GfxDeviceNullD0Ev,__ZN13GfxDeviceNull14DisableScissorEv,__ZN13GfxDeviceNull10BeginFrameEv,__ZN13GfxDeviceNull8EndFrameEv,__ZN13GfxDeviceNull12PresentFrameEv,__ZN13GfxDeviceNull15FinishRenderingEv,__ZN13GfxDeviceNull12ImmediateEndEv,__ZN13GfxDeviceNull14BeforeDrawCallEv,__ZN13GfxDeviceNull17BeginTimerQueriesEv
,__ZN13GfxDeviceNull15EndTimerQueriesEv,__ZN13GfxDeviceNull15ReloadResourcesEv,__ZN9GfxBufferD2Ev,__ZN16NullVertexBufferD0Ev,__ZN15NullIndexBufferD0Ev,__ZN14NullGpuProgramD0Ev,__ZN5Umbra15MemOutputStreamD2Ev,__ZN5Umbra15MemOutputStreamD0Ev,__ZN5Umbra11InputStreamD2Ev,__ZN5Umbra14MemInputStreamD0Ev,__ZN5Umbra12OutputStreamD2Ev,__ZN5Umbra12OutputStreamD0Ev,__ZN5Umbra9AllocatorD2Ev,__ZN5Umbra15SystemAllocatorD0Ev,__ZN5Umbra21UserCallbackAllocatorD0Ev,__ZN5Umbra20SingleBlockAllocatorD0Ev,__ZN17ParticleLightNodeD2Ev,__ZN17ParticleLightNodeD0Ev,__ZN14ParticleSystemD2Ev,__ZN14ParticleSystemD0Ev,__ZN14ParticleSystem17MainThreadCleanupEv,__ZN14ParticleSystem10SmartResetEv,__ZN14EmissionModuleD2Ev,__ZN14EmissionModuleD0Ev,__ZN11ShapeModuleD2Ev,__ZN11ShapeModuleD0Ev,__ZN22ParticleSystemRendererD2Ev,__ZN22ParticleSystemRendererD0Ev,__ZN22ParticleSystemRenderer17MainThreadCleanupEv,__ZN22ParticleSystemRenderer16CheckConsistencyEv
,__ZN22ParticleSystemRenderer5ResetEv,__ZN22ParticleSystemRenderer21RendererBecameVisibleEv,__ZN22ParticleSystemRenderer23RendererBecameInvisibleEv,__ZN22ParticleSystemRenderer19UpdateTransformInfoEv,__ZN22ParticleSystemRenderer15UpdateLocalAABBEv,__ZN22ParticleSystemRenderer14UpdateRendererEv,__ZThn32_N22ParticleSystemRendererD1Ev,__ZThn32_N22ParticleSystemRendererD0Ev,__ZThn32_N22ParticleSystemRenderer21RendererBecameVisibleEv,__ZThn32_N22ParticleSystemRenderer23RendererBecameInvisibleEv,__ZThn32_N22ParticleSystemRenderer19UpdateTransformInfoEv,__ZN10SizeModuleD2Ev,__ZN10SizeModuleD0Ev,__ZN14RotationModuleD2Ev,__ZN14RotationModuleD0Ev,__ZN11ColorModuleD2Ev,__ZN11ColorModuleD0Ev,__ZN8UVModuleD2Ev,__ZN8UVModuleD0Ev,__ZN14VelocityModuleD2Ev,__ZN14VelocityModuleD0Ev,__ZN21InheritVelocityModuleD2Ev,__ZN21InheritVelocityModuleD0Ev,__ZN11ForceModuleD2Ev,__ZN11ForceModuleD0Ev,__ZN20ParticleSystemModuleD2Ev,__ZN20ExternalForcesModuleD0Ev,__ZN19ClampVelocityModuleD2Ev,__ZN19ClampVelocityModuleD0Ev,__ZN11NoiseModuleD2Ev
,__ZN11NoiseModuleD0Ev,__ZN17SizeBySpeedModuleD2Ev,__ZN17SizeBySpeedModuleD0Ev,__ZN21RotationBySpeedModuleD2Ev,__ZN21RotationBySpeedModuleD0Ev,__ZN18ColorBySpeedModuleD2Ev,__ZN18ColorBySpeedModuleD0Ev,__ZN15CollisionModuleD2Ev,__ZN15CollisionModuleD0Ev,__ZN13TriggerModuleD0Ev,__ZN9SubModuleD2Ev,__ZN9SubModuleD0Ev,__ZN12LightsModuleD2Ev,__ZN12LightsModuleD0Ev,__ZN11TrailModuleD2Ev,__ZN11TrailModuleD0Ev,__ZN13InitialModuleD2Ev,__ZN13InitialModuleD0Ev,__ZN15ParticlesModule8SyncJobsEv,__ZN5physx3Cct13BoxController7releaseEv,__ZN5physx3Cct13BoxController15invalidateCacheEv,__ZN5physx3Cct13BoxControllerD2Ev,__ZN5physx3Cct13BoxControllerD0Ev,__ZThn8_N5physx3Cct13BoxControllerD1Ev,__ZThn8_N5physx3Cct13BoxControllerD0Ev,__ZN5physx3Cct10ControllerD2Ev,__ZN5physx3Cct10ControllerD0Ev,__ZN5physx2Gu12EntityReportIjED2Ev,__ZN44ConvexVsHeightfieldContactGenerationCallbackD0Ev,__ZN5physx2Gu15MeshHitCallbackINS_12PxRaycastHitEED2Ev
,__ZN37ConvexVsMeshContactGenerationCallbackD0Ev,__ZN16RayRTreeCallbackILi0ELb0EED2Ev,__ZN16RayRTreeCallbackILi0ELb0EED0Ev,__ZN5physx2Gu5RTree8Callback7profileEv,__ZThn4_N16RayRTreeCallbackILi0ELb0EED1Ev,__ZThn4_N16RayRTreeCallbackILi0ELb0EED0Ev,__ZN5physx2Gu12SupportLocalD2Ev,__ZN5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEED0Ev,__ZN5physx2Gu16SupportLocalImplINS0_11ConvexHullVEED0Ev,__ZN5physx2Gu16SupportLocalImplINS0_4BoxVEED0Ev,__ZN43CapsuleHeightfieldContactGenerationCallbackD0Ev,__ZN26ContactCapsuleMeshCallbackD0Ev,__ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallbackD0Ev,__ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD2Ev,__ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_ScaleD0Ev,__ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD0Ev,__ZN24MidPhaseQueryLocalReportD0Ev,__ZN5physx2Gu16SupportLocalImplINS0_9TriangleVEED0Ev,__ZN24ConvexVsHeightfieldSweepD2Ev,__ZN24ConvexVsHeightfieldSweepD0Ev,__ZN5physx2Gu17EPASupportMapPairD2Ev,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev,__ZN25MeshMTDGenerationCallbackD0Ev,__ZN25ConvexVsMeshSweepCallbackD2Ev,__ZN25ConvexVsMeshSweepCallbackD0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_ED0Ev,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev,__ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD2Ev,__ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD0Ev,__ZN21BoxTraceSegmentReportD0Ev
,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEED0Ev,__ZN23SweepBoxMeshHitCallbackD2Ev,__ZN23SweepBoxMeshHitCallbackD0Ev,__ZN16RayRTreeCallbackILi1ELb0EED2Ev,__ZN16RayRTreeCallbackILi1ELb0EED0Ev,__ZThn4_N16RayRTreeCallbackILi1ELb0EED1Ev,__ZThn4_N16RayRTreeCallbackILi1ELb0EED0Ev,__ZN16RayRTreeCallbackILi1ELb1EED2Ev,__ZN16RayRTreeCallbackILi1ELb1EED0Ev,__ZThn4_N16RayRTreeCallbackILi1ELb1EED1Ev,__ZThn4_N16RayRTreeCallbackILi1ELb1EED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_ED0Ev,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEED0Ev,__ZN25CapsuleTraceSegmentReportD0Ev,__ZN20SweepCapsuleCallbackD0Ev,__ZN5physx13PxHitCallbackINS_12PxOverlapHitEE13finalizeQueryEv,__ZN5physx13PxHitCallbackINS_12PxOverlapHitEED2Ev,__ZN5physx11PxHitBufferINS_12PxOverlapHitEED0Ev,__ZN12_GLOBAL__N_124HfTrianglesEntityReport2D0Ev,__ZN26IntersectAnyVsMeshCallbackILi0ELb1EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi0ELb1EED0Ev,__ZN26IntersectAnyVsMeshCallbackILi0ELb0EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi0ELb0EED0Ev,__ZN26IntersectAnyVsMeshCallbackILi1ELb1EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi1ELb1EED0Ev,__ZN26IntersectAnyVsMeshCallbackILi1ELb0EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi1ELb0EED0Ev,__ZN26IntersectAnyVsMeshCallbackILi2ELb1EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi2ELb1EED0Ev
,__ZN26IntersectAnyVsMeshCallbackILi2ELb0EED2Ev,__ZN26IntersectAnyVsMeshCallbackILi2ELb0EED0Ev,__ZN5physx21PxQueryFilterCallbackD2Ev,__ZN16ControllerFilterD0Ev,__ZN5physx13PxHitCallbackINS_12PxRaycastHitEE13finalizeQueryEv,__ZN5physx13PxHitCallbackINS_12PxRaycastHitEED2Ev,__ZN5physx11PxHitBufferINS_12PxRaycastHitEED0Ev,__ZN23RayMeshColliderCallbackD0Ev,__ZN16RayRTreeCallbackILi0ELb1EED2Ev,__ZN16RayRTreeCallbackILi0ELb1EED0Ev,__ZThn4_N16RayRTreeCallbackILi0ELb1EED1Ev,__ZThn4_N16RayRTreeCallbackILi0ELb1EED0Ev,__ZN5physx3Cct8SweptBoxD2Ev,__ZN5physx3Cct8SweptBoxD0Ev,__ZN5physx3Cct11SweptVolumeD2Ev,__ZN5physx3Cct11SweptVolumeD0Ev,__ZN5physx3Cct17CapsuleController7releaseEv,__ZN5physx3Cct17CapsuleController15invalidateCacheEv,__ZN5physx3Cct17CapsuleControllerD2Ev,__ZN5physx3Cct17CapsuleControllerD0Ev,__ZThn8_N5physx3Cct17CapsuleControllerD1Ev,__ZThn8_N5physx3Cct17CapsuleControllerD0Ev,__ZN5physx3Cct12SweptCapsuleD2Ev,__ZN5physx3Cct12SweptCapsuleD0Ev,__ZN5physx3Cct26CharacterControllerManager7releaseEv,__ZN5physx3Cct26CharacterControllerManager16purgeControllersEv,__ZN5physx3Cct26CharacterControllerManagerD2Ev,__ZN5physx3Cct26CharacterControllerManagerD0Ev,__ZN5physx2Gu17RadixSortBufferedD2Ev,__ZN5physx2Gu17RadixSortBufferedD0Ev
,__ZN5physx2Gu9RadixSortD2Ev,__ZN5physx2Gu9RadixSortD0Ev,__ZN5physx3Cct15ObstacleContextD2Ev,__ZN5physx3Cct15ObstacleContextD0Ev,__ZN5physx3Cct15ObstacleContext7releaseEv,__ZN5physx2Cm12RenderBufferD2Ev,__ZN5physx2Cm12RenderBufferD0Ev,__ZN5physx2Cm12RenderBuffer5clearEv,__ZN5physx12PxControllerD2Ev,__ZN5physx19PxCapsuleControllerD0Ev,__ZN5physx15PxBoxControllerD0Ev,__ZN5physx3Ext15CpuWorkerThreadD2Ev,__ZN5physx3Ext15CpuWorkerThreadD0Ev,__ZN5physx3Ext15CpuWorkerThread7executeEv,__ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED2Ev,__ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED0Ev,__ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEE7executeEv,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7releaseEv,__ZN5physx3Ext7D6JointD2Ev,__ZN5physx3Ext7D6JointD0Ev,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext7D6JointD1Ev,__ZThn12_N5physx3Ext7D6JointD0Ev,__ZN5physx3Ext19ProfileEventHandlerD2Ev,__ZN5physx3Ext19ProfileEventHandlerD0Ev,__ZN5physx3Ext20ProfileZoneInterfaceD2Ev,__ZN5physx3Ext20ProfileZoneInterfaceD0Ev,__ZN5physx3Ext20ProfileZoneInterface19handleClientRemovedEv,__ZN5physx3Ext23DefaultBufferedProfiler11flushEventsEv
,__ZN5physx3Ext23DefaultBufferedProfiler7releaseEv,__ZN5physx3Ext23DefaultBufferedProfilerD2Ev,__ZN5physx3Ext23DefaultBufferedProfilerD0Ev,__ZN5physx3Ext18ProfileZoneHandlerD2Ev,__ZN5physx3Ext18ProfileZoneHandlerD0Ev,__ZN5physx3Ext20DefaultCpuDispatcherD2Ev,__ZN5physx3Ext20DefaultCpuDispatcherD0Ev,__ZN5physx3Ext20DefaultCpuDispatcher7releaseEv,__ZN5physx22PxDefaultErrorCallbackD2Ev,__ZN5physx22PxDefaultErrorCallbackD0Ev,__ZN5physx15PxErrorCallbackD2Ev,__ZN11ErrorStreamD0Ev,__ZN5physx19PxAllocatorCallbackD2Ev,__ZN16NovodexAllocatorD0Ev,__ZN5physx15PxCpuDispatcherD2Ev,__ZN18PhysxJobDispatcherD0Ev,__ZN5physx14PxLightCpuTaskD2Ev,__ZN5physx14PxLightCpuTaskD0Ev,__ZN5physx14PxLightCpuTask12addReferenceEv,__ZN5physx14PxLightCpuTask15removeReferenceEv,__ZN5physx14PxLightCpuTask7releaseEv,__ZN14CompletionTaskD0Ev,__ZN14CompletionTask3runEv,__ZN5physx26PxControllerFilterCallbackD2Ev,__ZN24ControllerFilterCallbackD0Ev,__ZN19ControllerHitReportD2Ev,__ZN19ControllerHitReportD0Ev,__ZN5physx27PxDefaultMemoryOutputStreamD2Ev,__ZN5physx27PxDefaultMemoryOutputStreamD0Ev,__ZN5physx13PxInputStreamD2Ev
,__ZN5physx24PxDefaultMemoryInputDataD0Ev,__ZN5physx25PxDefaultFileOutputStreamD2Ev,__ZN5physx25PxDefaultFileOutputStreamD0Ev,__ZN5physx22PxDefaultFileInputDataD2Ev,__ZN5physx22PxDefaultFileInputDataD0Ev,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7releaseEv,__ZN5physx3Ext13DistanceJointD2Ev,__ZN5physx3Ext13DistanceJointD0Ev,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext13DistanceJointD1Ev,__ZThn12_N5physx3Ext13DistanceJointD0Ev,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7releaseEv,__ZN5physx3Ext10FixedJointD2Ev,__ZN5physx3Ext10FixedJointD0Ev,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext10FixedJointD1Ev,__ZThn12_N5physx3Ext10FixedJointD0Ev,__ZN17InternalIndexPool11freeIndicesEv,__ZN17InternalIndexPool7releaseEv,__ZN17InternalIndexPoolD2Ev,__ZN17InternalIndexPoolD0Ev,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7releaseEv,__ZN5physx3Ext14PrismaticJointD2Ev,__ZN5physx3Ext14PrismaticJointD0Ev,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext14PrismaticJointD1Ev,__ZThn12_N5physx3Ext14PrismaticJointD0Ev
,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7releaseEv,__ZN5physx3Ext13RevoluteJointD2Ev,__ZN5physx3Ext13RevoluteJointD0Ev,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext13RevoluteJointD1Ev,__ZThn12_N5physx3Ext13RevoluteJointD0Ev,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7releaseEv,__ZN5physx3Ext14SphericalJointD2Ev,__ZN5physx3Ext14SphericalJointD0Ev,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv,__ZThn12_N5physx3Ext14SphericalJointD1Ev,__ZThn12_N5physx3Ext14SphericalJointD0Ev,__ZN5physx2Sn21SerializationRegistry7releaseEv,__ZN5physx2Sn21SerializationRegistryD2Ev,__ZN5physx2Sn21SerializationRegistryD0Ev,__ZN5physx2Sn5ConvX7releaseEv,__ZN5physx2Sn5ConvXD2Ev,__ZN5physx2Sn5ConvXD0Ev,__ZN5physx24PxDeserializationContextD2Ev,__ZN5physx2Sn22DeserializationContextD0Ev,__ZN5physx2Sn20SerializationContextD2Ev,__ZN5physx2Sn20SerializationContextD0Ev,__ZN5physx16PxRepXSerializerD2Ev,__ZN5physx24PxMaterialRepXSerializerD0Ev,__ZN5physx21PxShapeRepXSerializerD0Ev,__ZN5physx28PxTriangleMeshRepXSerializerD0Ev,__ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED2Ev,__ZN5physx12MemoryBufferD0Ev
,__ZThn4_N5physx12MemoryBufferD1Ev,__ZThn4_N5physx12MemoryBufferD0Ev,__ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev,__ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED1Ev,__ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev,__ZN5physx27PxHeightFieldRepXSerializerD0Ev,__ZN5physx26PxConvexMeshRepXSerializerD0Ev,__ZN5physx27PxRigidStaticRepXSerializerD0Ev,__ZN5physx28PxRigidDynamicRepXSerializerD0Ev,__ZN5physx28PxArticulationRepXSerializerD0Ev,__ZN5physx25PxAggregateRepXSerializerD0Ev,__ZN5physx27PxClothFabricRepXSerializerD0Ev,__ZN5physx21PxClothRepXSerializerD0Ev,__ZN5physx11NpAggregate7releaseEv,__ZN5physx11NpAggregateD2Ev,__ZN5physx11NpAggregateD0Ev,__ZN27ConvexVsMeshOverlapCallbackD2Ev,__ZN27ConvexVsMeshOverlapCallbackD0Ev,__ZN5physx2Gu10SupportMapD2Ev,__ZN5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEED0Ev,__ZN5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEED0Ev,__ZN5physx2Gu22SupportMapRelativeImplINS0_4BoxVEED0Ev,__ZN5physx2Sc11Interaction10initializeEv,__ZN5physx2Sc21ConstraintInteraction7destroyEv,__ZN5physx2Sc21ConstraintInteractionD2Ev,__ZN5physx2Sc21ConstraintInteractionD0Ev,__ZThn24_N5physx2Sc21ConstraintInteractionD1Ev,__ZThn24_N5physx2Sc21ConstraintInteractionD0Ev,__ZN5physx2Sc11Interaction7destroyEv,__ZN5physx2Sc11InteractionD2Ev
,__ZN5physx2Sc11InteractionD0Ev,__ZN5physx2Sc20ArticulationJointSim7destroyEv,__ZN5physx2Sc20ArticulationJointSimD2Ev,__ZN5physx2Sc20ArticulationJointSimD0Ev,__ZThn24_N5physx2Sc20ArticulationJointSimD1Ev,__ZThn24_N5physx2Sc20ArticulationJointSimD0Ev,__ZN5physx2Sc7ElementD2Ev,__ZN5physx2Sc7ElementD0Ev,__ZN5physx2Sc8ShapeSimD2Ev,__ZN5physx2Sc8ShapeSimD0Ev,__ZN5physx2Sc7BodySimD2Ev,__ZN5physx2Sc7BodySimD0Ev,__ZN5physx2Sc7BodySim10onActivateEv,__ZN5physx2Sc7BodySim12onDeactivateEv,__ZN5physx2Sc8RigidSimD2Ev,__ZN5physx2Sc8RigidSimD0Ev,__ZN5physx2Sc5Actor10onActivateEv,__ZN5physx2Sc5Actor12onDeactivateEv,__ZN5physx2Sc5ActorD2Ev,__ZN5physx2Sc5ActorD0Ev,__ZN5physx2Sc8ActorSimD2Ev,__ZN5physx2Sc8ActorSimD0Ev,__ZN5physx2Sc8ClothSimD2Ev,__ZN5physx2Sc8ClothSimD0Ev,__ZN5physx2Sc10ClothShapeD2Ev,__ZN5physx2Sc10ClothShapeD0Ev,__ZN5physx2Sc17ParticleSystemSimD2Ev,__ZN5physx2Sc17ParticleSystemSimD0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm4Task3runEv
,__ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Sc9StaticSimD2Ev,__ZN5physx2Sc9StaticSimD0Ev,__ZN5physx14NpArticulation7releaseEv,__ZN5physx14NpArticulationD2Ev,__ZN5physx14NpArticulationD0Ev,__ZN5physx14NpArticulation6wakeUpEv,__ZN5physx14NpArticulation10putToSleepEv,__ZN5physx19NpArticulationJoint7releaseEv,__ZN5physx19NpArticulationJointD2Ev,__ZN5physx19NpArticulationJointD0Ev,__ZN5physx6PxBaseD2Ev,__ZN5physx18PxArticulationLinkD0Ev,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE7releaseEv,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED2Ev,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED0Ev,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13switchToNoSimEv,__ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15switchFromNoSimEv,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED2Ev,__ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED0Ev,__ZN5physx18NpArticulationLink7releaseEv,__ZN5physx18NpArticulationLinkD2Ev,__ZN5physx18NpArticulationLinkD0Ev,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7releaseEv,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED2Ev,__ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED0Ev,__ZN5physx12NpBatchQuery7executeEv,__ZN5physx12NpBatchQuery7releaseEv,__ZN5physx12NpBatchQueryD2Ev,__ZN5physx12NpBatchQueryD0Ev
,__ZN16PxOverflowBufferIN5physx12PxRaycastHitEE13finalizeQueryEv,__ZN16PxOverflowBufferIN5physx12PxRaycastHitEED0Ev,__ZN16PxOverflowBufferIN5physx12PxOverlapHitEE13finalizeQueryEv,__ZN16PxOverflowBufferIN5physx12PxOverlapHitEED0Ev,__ZN16PxOverflowBufferIN5physx10PxSweepHitEE13finalizeQueryEv,__ZN5physx13PxHitCallbackINS_10PxSweepHitEED2Ev,__ZN16PxOverflowBufferIN5physx10PxSweepHitEED0Ev,__ZN5physx2Sq14PrunerCallbackD2Ev,__ZN18MultiQueryCallbackIN5physx10PxSweepHitEED0Ev,__ZN5physx13PxHitCallbackINS_10PxSweepHitEE13finalizeQueryEv,__ZN5physx11PxHitBufferINS_10PxSweepHitEED0Ev,__ZN18MultiQueryCallbackIN5physx12PxOverlapHitEED0Ev,__ZN18MultiQueryCallbackIN5physx12PxRaycastHitEED0Ev,__ZN5physx12NpConstraint7releaseEv,__ZN5physx12NpConstraintD2Ev,__ZN5physx12NpConstraintD0Ev,__ZN5physx12NpConstraint9markDirtyEv,__ZN5physx9NpFactoryD2Ev,__ZN5physx9NpFactoryD0Ev,__ZN5physx13GuMeshFactoryD2Ev,__ZN5physx13GuMeshFactoryD0Ev,__ZN5physx10NpMaterial7releaseEv,__ZN5physx10NpMaterialD2Ev,__ZN5physx10NpMaterialD0Ev,__ZN5physx10NpMaterial14onRefCountZeroEv,__ZThn12_N5physx10NpMaterialD1Ev,__ZThn12_N5physx10NpMaterialD0Ev,__ZThn12_N5physx10NpMaterial14onRefCountZeroEv,__ZN5physx9NpPhysicsD2Ev,__ZN5physx9NpPhysicsD0Ev
,__ZN5physx9NpPhysics7releaseEv,__ZN5physx10PxMaterialD0Ev,__ZN5physx2Cm12RefCountableD2Ev,__ZN5physx2Cm12RefCountableD0Ev,__ZN5physx2Cm12RefCountable14onRefCountZeroEv,__ZN5physx7PxShapeD0Ev,__ZN5physx7NpShape7releaseEv,__ZN5physx7NpShapeD2Ev,__ZN5physx7NpShapeD0Ev,__ZN5physx7NpShape14resetFilteringEv,__ZN5physx7NpShape14onRefCountZeroEv,__ZThn12_N5physx7NpShapeD1Ev,__ZThn12_N5physx7NpShapeD0Ev,__ZThn12_N5physx7NpShape14onRefCountZeroEv,__ZN5physx7PxClothD0Ev,__ZN5physx7NpCloth7releaseEv,__ZN5physx7NpClothD2Ev,__ZN5physx7NpClothD0Ev,__ZN5physx7NpCloth18clearInterpolationEv,__ZN5physx7NpCloth6wakeUpEv,__ZN5physx7NpCloth10putToSleepEv,__ZN5physx19NpClothParticleData6unlockEv,__ZN5physx12PxLockedDataD2Ev,__ZN5physx19NpClothParticleDataD0Ev,__ZN5physx15NpActorTemplateINS_7PxClothEE7releaseEv,__ZN5physx15NpActorTemplateINS_7PxClothEED2Ev,__ZN5physx15NpActorTemplateINS_7PxClothEED0Ev,__ZN5physx15PxParticleFluidD0Ev,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7releaseEv,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED2Ev
,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED0Ev,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEv,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14resetFilteringEv,__ZN5physx15NpParticleFluidD2Ev,__ZN5physx15NpParticleFluidD0Ev,__ZN5physx15PxsParticleDataD2Ev,__ZN5physx15PxsParticleDataD0Ev,__ZN5physx15PxsParticleData16removeParticlesVEv,__ZN5physx23NpParticleFluidReadData6unlockEv,__ZN5physx23NpParticleFluidReadDataD0Ev,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7releaseEv,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEED2Ev,__ZN5physx15NpActorTemplateINS_15PxParticleFluidEED0Ev,__ZN5physx16PxParticleSystemD0Ev,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7releaseEv,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED2Ev,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED0Ev,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEv,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14resetFilteringEv,__ZN5physx16NpParticleSystemD2Ev,__ZN5physx16NpParticleSystemD0Ev,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7releaseEv,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEED2Ev,__ZN5physx15NpActorTemplateINS_16PxParticleSystemEED0Ev,__ZN5physx14PxRigidDynamicD0Ev,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE7releaseEv,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED2Ev,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED0Ev,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13switchToNoSimEv,__ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15switchFromNoSimEv
,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED2Ev,__ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED0Ev,__ZN5physx14NpRigidDynamic7releaseEv,__ZN5physx14NpRigidDynamicD2Ev,__ZN5physx14NpRigidDynamicD0Ev,__ZN5physx14NpRigidDynamic6wakeUpEv,__ZN5physx14NpRigidDynamic10putToSleepEv,__ZN5physx14NpRigidDynamic13switchToNoSimEv,__ZN5physx14NpRigidDynamic15switchFromNoSimEv,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7releaseEv,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED2Ev,__ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED0Ev,__ZN5physx13PxRigidStaticD0Ev,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE7releaseEv,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED2Ev,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED0Ev,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13switchToNoSimEv,__ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15switchFromNoSimEv,__ZN5physx13NpRigidStatic7releaseEv,__ZN5physx13NpRigidStaticD2Ev,__ZN5physx13NpRigidStaticD0Ev,__ZN5physx13NpRigidStatic13switchToNoSimEv,__ZN5physx13NpRigidStatic15switchFromNoSimEv,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7releaseEv,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEED2Ev,__ZN5physx15NpActorTemplateINS_13PxRigidStaticEED0Ev,__ZN5physx14NpSceneQueriesD2Ev,__ZN5physx14NpSceneQueriesD0Ev,__ZN5physx7NpSceneD2Ev,__ZN5physx7NpSceneD0Ev
,__ZN5physx7NpScene7releaseEv,__ZN5physx7NpScene17flushQueryUpdatesEv,__ZN5physx7NpScene10unlockReadEv,__ZN5physx7NpScene11unlockWriteEv,__ZN5physx7NpScene15SceneCompletionD0Ev,__ZN5physx7NpScene15SceneCompletion7releaseEv,__ZN5physx7NpScene15SceneCompletion11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx22PxConstraintVisualizerD2Ev,__ZN5physx2Cm29ConstraintImmediateVisualizerD0Ev,__ZN5physx2Sc15CoreInteractionD2Ev,__ZN5physx2Sc15CoreInteractionD0Ev,__ZN5physx2Sc21ElementSimInteractionD2Ev,__ZN5physx2Sc24ElementInteractionMarkerD0Ev,__ZN5physx2Sc24ElementInteractionMarker10initializeEv,__ZN5physx2Sc24ElementInteractionMarker7destroyEv,__ZThn8_N5physx2Sc24ElementInteractionMarker10initializeEv,__ZThn8_N5physx2Sc24ElementInteractionMarker7destroyEv,__ZThn8_N5physx2Sc24ElementInteractionMarkerD1Ev,__ZThn8_N5physx2Sc24ElementInteractionMarkerD0Ev,__ZN5physx2Sc18TriggerInteractionD2Ev,__ZN5physx2Sc18TriggerInteractionD0Ev,__ZN5physx2Sc18TriggerInteraction10initializeEv,__ZN5physx2Sc18TriggerInteraction7destroyEv,__ZThn8_N5physx2Sc18TriggerInteraction10initializeEv
,__ZThn8_N5physx2Sc18TriggerInteraction7destroyEv,__ZThn8_N5physx2Sc18TriggerInteractionD1Ev,__ZThn8_N5physx2Sc18TriggerInteractionD0Ev,__ZN5physx2Sc19ShapeInstancePairLLD2Ev,__ZN5physx2Sc19ShapeInstancePairLLD0Ev,__ZN5physx2Sc19ShapeInstancePairLL10initializeEv,__ZN5physx2Sc19ShapeInstancePairLL7destroyEv,__ZThn8_N5physx2Sc19ShapeInstancePairLL10initializeEv,__ZThn8_N5physx2Sc19ShapeInstancePairLL7destroyEv,__ZThn8_N5physx2Sc19ShapeInstancePairLLD1Ev,__ZThn8_N5physx2Sc19ShapeInstancePairLLD0Ev,__ZN5physx13NpVolumeCache10invalidateEv,__ZN5physx13NpVolumeCache7releaseEv,__ZN5physx13NpVolumeCacheD2Ev,__ZN5physx13NpVolumeCacheD0Ev,__ZN5physx23NpVolumeCacheSqCallbackD0Ev,__ZN5physx2Cm10FanoutTaskD2Ev,__ZN5physx2Cm10FanoutTaskD0Ev,__ZN5physx2Cm8BaseTask3runEv,__ZN5physx2Cm10FanoutTask12addReferenceEv,__ZN5physx2Cm10FanoutTask15removeReferenceEv,__ZN5physx2Cm10FanoutTask7releaseEv,__ZN5physx2Cm10FanoutTask11runInternalEv,__ZN5physx23ArticulationRootManagerD2Ev,__ZN5physx23ArticulationRootManagerD0Ev,__ZN5physx13IslandManagerD2Ev,__ZN5physx13IslandManagerD0Ev,__ZN5physx11EdgeManagerD2Ev,__ZN5physx11EdgeManagerD0Ev,__ZN5physx11NodeManagerD2Ev
,__ZN5physx11NodeManagerD0Ev,__ZN5physx2Sq12BucketPruner6commitEv,__ZN5physx2Sq12BucketPrunerD2Ev,__ZN5physx2Sq12BucketPrunerD0Ev,__ZN5physx2Sq11PruningPoolD2Ev,__ZN5physx2Sq11PruningPoolD0Ev,__ZN5physx2Sq10AABBPruner6commitEv,__ZN5physx2Sq10AABBPrunerD2Ev,__ZN5physx2Sq10AABBPrunerD0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEED0Ev
,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx17PxsCCDAdvanceTaskD0Ev,__ZN5physx17PxsCCDAdvanceTask11runInternalEv,__ZN5physx29EntityReportContainerCallbackD0Ev,__ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CBD0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEED0Ev
,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEED0Ev,__ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallbackD0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_ED0Ev,__ZN5physx20PxsSolverCoreGeneral8destroyVEv,__ZN5physx13PxsSolverCoreD2Ev,__ZN5physx20PxsSolverCoreGeneralD0Ev,__ZN5physx23PxsBroadPhaseContextSapD2Ev,__ZN5physx23PxsBroadPhaseContextSapD0Ev,__ZN5physx23PxsBroadPhaseContextSap7destroyEv,__ZN5physx23PxsBroadPhaseContextSap11freeBuffersEv,__ZN5physx17SapUpdateWorkTaskD0Ev,__ZN5physx17SapUpdateWorkTask11runInternalEv,__ZN5physx21SapPostUpdateWorkTaskD0Ev,__ZN5physx21SapPostUpdateWorkTask11runInternalEv,__ZN5physx29BroadPhaseBatchUpdateWorkTaskD0Ev,__ZN5physx29BroadPhaseBatchUpdateWorkTask11runInternalEv,__ZN5physx16PxsBroadPhaseMBPD2Ev,__ZN5physx16PxsBroadPhaseMBPD0Ev,__ZN5physx16PxsBroadPhaseMBP7destroyEv,__ZN5physx16PxsBroadPhaseMBP11freeBuffersEv,__ZN3MBPD2Ev,__ZN3MBPD0Ev,__ZN5physx21MBPPostUpdateWorkTaskD0Ev,__ZN5physx21MBPPostUpdateWorkTask11runInternalEv,__ZN5physx17MBPUpdateWorkTaskD2Ev,__ZN5physx17MBPUpdateWorkTaskD0Ev,__ZN5physx17MBPUpdateWorkTask11runInternalEv,__ZN5physx10BPWorkTaskD0Ev,__ZN5physx10BPWorkTask11runInternalEv
,__ZN5physx20ProcessBPResultsTaskD0Ev,__ZN5physx20ProcessBPResultsTask11runInternalEv,__ZN5physx20AggregateOverlapTaskD0Ev,__ZN5physx20AggregateOverlapTask11runInternalEv,__ZN5physx17AggregateAABBTaskD2Ev,__ZN5physx17AggregateAABBTaskD0Ev,__ZN5physx17AggregateAABBTask11runInternalEv,__ZN5physx23AggregateAABBUpdateTaskD0Ev,__ZN5physx23AggregateAABBUpdateTask11runInternalEv,__ZN5physx13ActorAABBTaskD2Ev,__ZN5physx13ActorAABBTaskD0Ev,__ZN5physx13ActorAABBTask11runInternalEv,__ZN5physx19ActorAABBUpdateTaskD0Ev,__ZN5physx19ActorAABBUpdateTask11runInternalEv,__ZN5physx14SingleAABBTaskD2Ev,__ZN5physx14SingleAABBTaskD0Ev,__ZN5physx14SingleAABBTask11runInternalEv,__ZN5physx20SingleAABBUpdateTaskD0Ev,__ZN5physx20SingleAABBUpdateTask11runInternalEv,__ZN5physx40PCMConvexVsMeshContactGenerationCallbackD0Ev,__ZN5physx41PCMCapsuleVsMeshContactGenerationCallbackD0Ev,__ZN5physx40PCMSphereVsMeshContactGenerationCallbackD0Ev,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEED0Ev,__ZN5physx9PxTaskMgr17resetDependenciesEv,__ZN5physx9PxTaskMgr15startSimulationEv,__ZN5physx9PxTaskMgr14stopSimulationEv,__ZN5physx9PxTaskMgr7releaseEv,__ZN5physx9PxTaskMgrD2Ev,__ZN5physx9PxTaskMgrD0Ev,__ZN5physx2Sc35ParticleElementRbElementInteractionD2Ev
,__ZN5physx2Sc35ParticleElementRbElementInteractionD0Ev,__ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEv,__ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEv,__ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10initializeEv,__ZThn8_N5physx2Sc35ParticleElementRbElementInteraction7destroyEv,__ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD1Ev,__ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD0Ev,__ZN23PxsCMDiscreteUpdateTaskD0Ev,__ZN15PxsCMUpdateTask7releaseEv,__ZN23PxsCMDiscreteUpdateTask11runInternalEv,__ZN5physx18PxsSolverStartTaskD2Ev,__ZN5physx18PxsSolverStartTaskD0Ev,__ZN5physx18PxsSolverStartTask11runInternalEv,__ZN5physx16PxsSolverEndTaskD2Ev,__ZN5physx16PxsSolverEndTaskD0Ev,__ZN5physx16PxsSolverEndTask11runInternalEv,__ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD2Ev,__ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD0Ev,__ZN5physx38PxsSolverCreateFinalizeConstraintsTask11runInternalEv,__ZN5physx23PxsSolverSetupSolveTaskD2Ev,__ZN5physx23PxsSolverSetupSolveTaskD0Ev,__ZN5physx23PxsSolverSetupSolveTask11runInternalEv,__ZN5physx32PxsSolverConstraintPartitionTaskD2Ev,__ZN5physx32PxsSolverConstraintPartitionTaskD0Ev,__ZN5physx32PxsSolverConstraintPartitionTask11runInternalEv,__ZN21PxsParallelSolverTaskD0Ev,__ZN21PxsParallelSolverTask11runInternalEv,__ZN29PxsCreateFinalizeContactsTaskD0Ev,__ZN29PxsCreateFinalizeContactsTask11runInternalEv,__ZN5physx34PxsSolverConstraintPostProcessTaskD2Ev
,__ZN5physx34PxsSolverConstraintPostProcessTaskD0Ev,__ZN5physx34PxsSolverConstraintPostProcessTask11runInternalEv,__ZN20PxsAtomIntegrateTaskD0Ev,__ZN20PxsAtomIntegrateTask11runInternalEv,__ZN18ScBeforeSolverTaskD0Ev,__ZN18ScBeforeSolverTask11runInternalEv,__ZN22ScAfterIntegrationTaskD0Ev,__ZN22ScAfterIntegrationTask11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx10PxBaseTaskD2Ev,__ZN5physx10PxBaseTaskD0Ev,__ZN5physx15PxsCCDSweepTaskD0Ev,__ZN5physx15PxsCCDSweepTask11runInternalEv,__ZN5physx2Sc19ParticlePacketShapeD2Ev,__ZN5physx2Sc19ParticlePacketShapeD0Ev,__ZN5physx13PxClothFabricD0Ev,__ZN5physx13NpClothFabric7releaseEv,__ZN5physx13NpClothFabricD2Ev,__ZN5physx13NpClothFabricD0Ev,__ZN5physx13NpClothFabric14onRefCountZeroEv,__ZThn8_N5physx13NpClothFabricD1Ev,__ZThn8_N5physx13NpClothFabricD0Ev,__ZThn8_N5physx13NpClothFabric14onRefCountZeroEv,__ZN5physx12PxConvexMeshD0Ev,__ZN5physx2Gu10ConvexMesh7releaseEv
,__ZN5physx2Gu10ConvexMeshD2Ev,__ZN5physx2Gu10ConvexMeshD0Ev,__ZN5physx2Gu10ConvexMesh14onRefCountZeroEv,__ZThn8_N5physx2Gu10ConvexMeshD1Ev,__ZThn8_N5physx2Gu10ConvexMeshD0Ev,__ZThn8_N5physx2Gu10ConvexMesh14onRefCountZeroEv,__ZN5physx13PxHeightFieldD0Ev,__ZN5physx2Gu11HeightField7releaseEv,__ZN5physx2Gu11HeightFieldD2Ev,__ZN5physx2Gu11HeightFieldD0Ev,__ZN5physx2Gu11HeightField14onRefCountZeroEv,__ZThn8_N5physx2Gu11HeightFieldD1Ev,__ZThn8_N5physx2Gu11HeightFieldD0Ev,__ZThn8_N5physx2Gu11HeightField14onRefCountZeroEv,__ZN5physx14PxTriangleMeshD0Ev,__ZN5physx2Gu12TriangleMesh7releaseEv,__ZN5physx2Gu12TriangleMeshD2Ev,__ZN5physx2Gu12TriangleMeshD0Ev,__ZN5physx2Gu12TriangleMesh14onRefCountZeroEv,__ZThn8_N5physx2Gu12TriangleMeshD1Ev,__ZThn8_N5physx2Gu12TriangleMeshD0Ev,__ZThn8_N5physx2Gu12TriangleMesh14onRefCountZeroEv,__ZN5physx14NpSpatialIndex5flushEv,__ZN5physx14NpSpatialIndex11rebuildFullEv,__ZN5physx14NpSpatialIndex11rebuildStepEv,__ZN5physx14NpSpatialIndex7releaseEv,__ZN5physx14NpSpatialIndexD2Ev,__ZN5physx14NpSpatialIndexD0Ev,__ZN5physx12_GLOBAL__N_116LocationCallbackD0Ev,__ZN5physx12_GLOBAL__N_115OverlapCallbackD0Ev
,__ZN5physx2Sc16ActorInteractionD2Ev,__ZN5physx2Sc16ActorInteractionD0Ev,__ZThn24_N5physx2Sc16ActorInteractionD1Ev,__ZThn24_N5physx2Sc16ActorInteractionD0Ev,__ZN5physx2Sc23ElementActorInteractionD0Ev,__ZThn8_N5physx2Sc23ElementActorInteractionD1Ev,__ZThn8_N5physx2Sc23ElementActorInteractionD0Ev,__ZN5physx2Sc21ElementSimInteractionD0Ev,__ZThn8_N5physx2Sc21ElementSimInteractionD1Ev,__ZThn8_N5physx2Sc21ElementSimInteractionD0Ev,__ZN5physx16PxsParticleShapeD2Ev,__ZN5physx16PxsParticleShapeD0Ev,__ZN5physx16PxsParticleShape8destroyVEv,__ZN5physx20PxsParticleSystemSim32flushBufferedInteractionUpdatesVEv,__ZN5physx20PxsParticleSystemSimD2Ev,__ZN5physx20PxsParticleSystemSimD0Ev,__ZN5physx7Cooking7releaseEv,__ZN5physx9PxCookingD2Ev,__ZN5physx7CookingD0Ev,__ZN5physx17ConvexMeshBuilderD2Ev,__ZN5physx17ConvexMeshBuilderD0Ev,__ZThn8_N5physx17ConvexMeshBuilderD1Ev,__ZThn8_N5physx17ConvexMeshBuilderD0Ev,__ZN5physx19TriangleMeshBuilderD0Ev,__ZThn8_N5physx19TriangleMeshBuilderD1Ev,__ZThn8_N5physx19TriangleMeshBuilderD0Ev,__ZN5physx11RTreeCooker13RemapCallbackD2Ev,__ZN16RTreeCookerRemapD0Ev,__ZN5physx6shdfnd10Foundation7releaseEv,__ZN5physx6shdfnd10FoundationD2Ev
,__ZN5physx6shdfnd10FoundationD0Ev,__ZN5physx6shdfnd10Foundation19AlignCheckAllocatorD0Ev,__ZN5physx2Cm10Collection7releaseEv,__ZN5physx2Cm10CollectionD2Ev,__ZN5physx2Cm10CollectionD0Ev,__ZN5physx21PxProfileNameProviderD2Ev,__ZN5physx2Cm19CmEventNameProviderD0Ev,__ZN5physx2Cm17FreeListAllocatorD2Ev,__ZN5physx2Cm17FreeListAllocatorD0Ev,__ZN5physx6shdfnd10SocketImplD2Ev,__ZN5physx6shdfnd18BufferedSocketImplD0Ev,__ZN5physx6shdfnd10SocketImplD0Ev,__ZN5physx6shdfnd6SocketD2Ev,__ZN5physx6shdfnd6SocketD0Ev,__ZN11BoxColliderD2Ev,__ZN11BoxColliderD0Ev,__ZN11BoxCollider17MainThreadCleanupEv,__ZN11BoxCollider5ResetEv,__ZN11BoxCollider10SmartResetEv,__ZN11BoxCollider12ScaleChangedEv,__ZN11BoxCollider7CleanupEv,__ZN8Collider8ReCreateEv,__ZN8Collider22CreatePhysXObjIfNeededEv,__ZN11BoxCollider22FetchPoseFromTransformEv,__ZN8ColliderD2Ev,__ZN8ColliderD0Ev,__ZN8Collider17MainThreadCleanupEv,__ZN8Collider7CleanupEv,__ZN8Collider22FetchPoseFromTransformEv,__ZN15CapsuleColliderD2Ev
,__ZN15CapsuleColliderD0Ev,__ZN15CapsuleCollider5ResetEv,__ZN15CapsuleCollider10SmartResetEv,__ZN15CapsuleCollider12ScaleChangedEv,__ZN15CapsuleCollider22FetchPoseFromTransformEv,__ZN23ControllerContactFilterD2Ev,__ZN23ControllerContactFilterD0Ev,__ZN19CharacterControllerD2Ev,__ZN19CharacterControllerD0Ev,__ZN19CharacterController5ResetEv,__ZN19CharacterController10SmartResetEv,__ZN19CharacterController12ScaleChangedEv,__ZN19CharacterController7CleanupEv,__ZN5physx16PxControllerDescD2Ev,__ZN5physx23PxCapsuleControllerDescD0Ev,__ZN5physx23PxCapsuleControllerDesc12setToDefaultEv,__ZN5Unity14CharacterJointD2Ev,__ZN5Unity14CharacterJointD0Ev,__ZN5Unity5Joint17MainThreadCleanupEv,__ZN5Unity14CharacterJoint16CheckConsistencyEv,__ZN5Unity14CharacterJoint5ResetEv,__ZN5Unity14CharacterJoint6CreateEv,__ZN5Unity17ConfigurableJointD2Ev,__ZN5Unity17ConfigurableJointD0Ev,__ZN5Unity17ConfigurableJoint16CheckConsistencyEv,__ZN5Unity17ConfigurableJoint5ResetEv,__ZN5Unity17ConfigurableJoint6CreateEv,__ZN13ConstantForceD2Ev,__ZN13ConstantForceD0Ev,__ZN13ConstantForce5ResetEv
,__ZN13ConstantForce11FixedUpdateEv,__ZN13ConstantForce12AddToManagerEv,__ZN13ConstantForce17RemoveFromManagerEv,__ZN5Unity10FixedJointD2Ev,__ZN5Unity10FixedJointD0Ev,__ZN5Unity5Joint16CheckConsistencyEv,__ZN5Unity10FixedJoint5ResetEv,__ZN5Unity10FixedJoint6CreateEv,__ZN5Unity10HingeJointD2Ev,__ZN5Unity10HingeJointD0Ev,__ZN5Unity10HingeJoint16CheckConsistencyEv,__ZN5Unity5Joint5ResetEv,__ZN5Unity10HingeJoint6CreateEv,__ZN5Unity5JointD2Ev,__ZN5Unity5JointD0Ev,__ZN12MeshColliderD2Ev,__ZN12MeshColliderD0Ev,__ZN12MeshCollider17MainThreadCleanupEv,__ZN12MeshCollider16CheckConsistencyEv,__ZN12MeshCollider5ResetEv,__ZN12MeshCollider12ScaleChangedEv,__ZN12MeshCollider7CleanupEv,__ZN14PhysicMaterialD2Ev,__ZN14PhysicMaterialD0Ev,__ZN14PhysicMaterial17MainThreadCleanupEv,__ZN14PhysicMaterial5ResetEv,__ZN14PhysicsManagerD2Ev,__ZN14PhysicsManagerD0Ev,__ZN14PhysicsManager17MainThreadCleanupEv,__ZN14PhysicsManager5ResetEv
,__ZThn28_N14PhysicsManagerD1Ev,__ZThn28_N14PhysicsManagerD0Ev,__ZN9RigidbodyD2Ev,__ZN9RigidbodyD0Ev,__ZN9Rigidbody17MainThreadCleanupEv,__ZN9Rigidbody16CheckConsistencyEv,__ZN9Rigidbody5ResetEv,__ZN14SphereColliderD2Ev,__ZN14SphereColliderD0Ev,__ZN14SphereCollider5ResetEv,__ZN14SphereCollider10SmartResetEv,__ZN14SphereCollider12ScaleChangedEv,__ZN14SphereCollider22FetchPoseFromTransformEv,__ZN5Unity11SpringJointD2Ev,__ZN5Unity11SpringJointD0Ev,__ZN5Unity11SpringJoint16CheckConsistencyEv,__ZN5Unity11SpringJoint5ResetEv,__ZN5Unity11SpringJoint6CreateEv,__ZN12MemoryStreamD2Ev,__ZN12MemoryStreamD0Ev,__ZThn4_N12MemoryStreamD1Ev,__ZThn4_N12MemoryStreamD0Ev,__ZN8IRaycastD2Ev,__ZN12PhysXRaycastD0Ev,__ZN15RaycastCallbackD0Ev,__ZN10CastFilterD0Ev,__ZN24CollectBroadphaseTerrainD2Ev,__ZN24CollectBroadphaseTerrainD0Ev,__ZN5physx7profile15ZoneManagerImplD2Ev,__ZN5physx7profile15ZoneManagerImplD0Ev
,__ZN5physx7profile15ZoneManagerImpl18flushProfileEventsEv,__ZN5physx7profile15ZoneManagerImpl7releaseEv,__ZN5physx7profile21NullEventNameProviderD0Ev,__ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev,__ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED0Ev,__ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE11flushEventsEv,__ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE15clearCachedDataEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE15clearCachedDataEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv,__ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev,__ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev,__ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev,__ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv,__ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev,__ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev,__ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv,__ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEED0Ev,__ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEED0Ev,__ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEED0Ev,__ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEED0Ev
,__ZN5physx21PxJointRepXSerializerINS_9PxD6JointEED0Ev,__ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEED0Ev,__ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEED0Ev,__ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEED0Ev,__ZN5physx12PxSerializerD2Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEED0Ev,__ZN5physx23PxProcessPxBaseCallbackD2Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZN5physx17PxStringTableImplD2Ev,__ZN5physx17PxStringTableImplD0Ev,__ZN5physx17PxStringTableImpl7releaseEv,__ZN12_GLOBAL__N_116RequiresCallbackD0Ev,__ZN12_GLOBAL__N_116CompleteCallbackD0Ev,__ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD2Ev,__ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEED0Ev
,__ZN5physx26PxSerializerDefaultAdapterINS_7NpShapeEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_10NpMaterialEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_12NpConstraintEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_11NpAggregateEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_14NpArticulationEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_7NpClothEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEED0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZN12_GLOBAL__N_116CollectionSorterD2Ev,__ZN12_GLOBAL__N_116CollectionSorterD0Ev,__ZN5physx22PxSerializationContextD2Ev
,__ZN12_GLOBAL__N_118LegacySerialStreamD0Ev,__ZN5physx22XmlMemoryAllocatorImplD2Ev,__ZN5physx22XmlMemoryAllocatorImplD0Ev,__ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffness10updateNodeEv,__ZN5physx2Sn18RecursiveTraversalD2Ev,__ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffnessD0Ev,__ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimit10updateNodeEv,__ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimitD0Ev,__ZN5physx2Sn18RepXCollectionImplD2Ev,__ZN5physx2Sn18RepXCollectionImplD0Ev,__ZN5physx2Sn18RepXCollectionImpl7destroyEv,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED2Ev,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED0Ev,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv,__ZN5physx2Sn13XmlWriterImplD2Ev,__ZN5physx2Sn13XmlWriterImplD0Ev,__ZN5physx2Sn13XmlWriterImpl10leaveChildEv,__ZN5physx2Sn15SimpleXmlWriterD2Ev,__ZN5physx2Sn13XmlNodeWriterD0Ev,__ZN5physx2Sn13XmlNodeWriter6endTagEv,__ZN5physx2Sn13XmlNodeReaderD2Ev,__ZN5physx2Sn13XmlNodeReaderD0Ev,__ZN5physx2Sn13XmlNodeReader18pushCurrentContextEv,__ZN5physx2Sn13XmlNodeReader17popCurrentContextEv,__ZN5physx2Sn13XmlNodeReader7releaseEv,__ZN5physx6shdfnd7FastXml8CallbackD2Ev,__ZN5physx2Sn9XmlParserD0Ev,__ZN12_GLOBAL__N_19MyFastXml7releaseEv,__ZN12_GLOBAL__N_19MyFastXmlD2Ev,__ZN12_GLOBAL__N_19MyFastXmlD0Ev
,__ZN5physx24NpPtrTableStorageManagerD2Ev,__ZN5physx24NpPtrTableStorageManagerD0Ev,__ZN5physx26PxPhysicsInsertionCallbackD2Ev,__ZN5physx26NpPhysicsInsertionCallbackD0Ev,__ZN5physx21GuMeshFactoryListenerD2Ev,__ZN5physx9NpPhysics20MeshDeletionListenerD0Ev,__ZN5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEED0Ev,__ZN5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEED0Ev,__ZN5physx47PCMConvexVsHeightfieldContactGenerationCallbackD0Ev,__ZN5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEED0Ev,__ZN5physx48PCMCapsuleVsHeightfieldContactGenerationCallbackD0Ev,__ZN5physx47PCMSphereVsHeightfieldContactGenerationCallbackD0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx21PxsFluidCollisionTaskD0Ev,__ZN5physx21PxsFluidCollisionTask11runInternalEv,__ZN26PxcContactCellMeshCallbackD0Ev,__ZN5physx23PxsFluidDynamicsSphTaskD0Ev,__ZN5physx23PxsFluidDynamicsSphTask11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEED0Ev
,__ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEED0Ev,__ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE11runInternalEv,__ZN5physx7profile32PxProfileMemoryEventRecorderImplD2Ev,__ZN5physx7profile32PxProfileMemoryEventRecorderImplD0Ev,__ZN5physx7profile32PxProfileMemoryEventRecorderImpl7releaseEv,__ZN5physx7profile19MemoryEventRecorderD2Ev,__ZN5physx7profile19MemoryEventRecorderD0Ev,__ZN5physx7profile30PxProfileMemoryEventBufferImplD2Ev,__ZN5physx7profile30PxProfileMemoryEventBufferImplD0Ev,__ZN5physx7profile30PxProfileMemoryEventBufferImpl7releaseEv,__ZN5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv,__ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev,__ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev,__ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev,__ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev,__ZThn8_N5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv,__ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev,__ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev,__ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE11flushEventsEv,__ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE15clearCachedDataEv,__ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev,__ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev,__ZN12_GLOBAL__N_110ConnectionD2Ev,__ZN12_GLOBAL__N_110ConnectionD0Ev,__ZN12_GLOBAL__N_110Connection6addRefEv,__ZN12_GLOBAL__N_110Connection7releaseEv,__ZN12_GLOBAL__N_110Connection15checkConnectionEv
,__ZN12_GLOBAL__N_110Connection10disconnectEv,__ZN12_GLOBAL__N_110Connection5flushEv,__ZN12_GLOBAL__N_110Connection15unlockOutStreamEv,__ZN12_GLOBAL__N_110Connection24sendStreamInitializationEv,__ZN12_GLOBAL__N_110Connection13sendStreamEndEv,__ZThn4_N12_GLOBAL__N_110ConnectionD1Ev,__ZThn4_N12_GLOBAL__N_110ConnectionD0Ev,__ZThn8_N12_GLOBAL__N_110ConnectionD1Ev,__ZThn8_N12_GLOBAL__N_110ConnectionD0Ev,__ZThn12_N12_GLOBAL__N_110ConnectionD1Ev,__ZThn12_N12_GLOBAL__N_110ConnectionD0Ev,__ZN12_GLOBAL__N_117EventBufferClientD2Ev,__ZN12_GLOBAL__N_117EventBufferClientD0Ev,__ZN12_GLOBAL__N_117EventBufferClient6addRefEv,__ZN12_GLOBAL__N_117EventBufferClient7releaseEv,__ZN12_GLOBAL__N_117EventBufferClient6unlockEv,__ZN12_GLOBAL__N_116MetaDataProviderD2Ev,__ZN12_GLOBAL__N_116MetaDataProviderD0Ev,__ZN12_GLOBAL__N_116MetaDataProvider6addRefEv,__ZN12_GLOBAL__N_116MetaDataProvider7releaseEv,__ZN12_GLOBAL__N_116MetaDataProvider6unlockEv,__ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_117ProfileZoneClientEED0Ev,__ZN12_GLOBAL__N_119PvdConnectionReaderD2Ev,__ZN12_GLOBAL__N_119PvdConnectionReaderD0Ev,__ZN12_GLOBAL__N_119PvdConnectionReader7executeEv
,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED0Ev,__ZN12_GLOBAL__N_113ClassDescImplD2Ev,__ZN12_GLOBAL__N_113ClassDescImplD0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_112PropDescImplEED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayINS0_9PtrOffsetEED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED0Ev,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD2Ev,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD0Ev,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl6addRefEv,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl7releaseEv,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_113ClassDescImplEED0Ev,__ZN12_GLOBAL__N_115StringTableImplD2Ev,__ZN12_GLOBAL__N_115StringTableImplD0Ev,__ZN12_GLOBAL__N_115StringTableImpl7releaseEv,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev
,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplEED0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx8debugger18MemPvdOutputStreamD2Ev,__ZN5physx8debugger18MemPvdOutputStreamD0Ev,__ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger22ForwardingMemoryBufferD0Ev,__ZN5physx8debugger14PvdInputStreamD2Ev,__ZN5physx8debugger17MemPvdInputStreamD0Ev,__ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIhED0Ev,__ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED0Ev,__ZN12_GLOBAL__N_112PropDescImplD2Ev,__ZN12_GLOBAL__N_112PropDescImplD0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayINS0_10NamedValueEED0Ev,__ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD2Ev,__ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD0Ev,__ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIN12_GLOBAL__N_124PropertyMessageEntryImplEED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayINS0_20PropertyMessageEntryEED0Ev,__ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIjED0Ev,__ZN5physx8debugger19PropertyDescriptionD2Ev,__ZN5physx8debugger19PropertyDescriptionD0Ev,__ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED0Ev
,__ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED0Ev,__ZN5physx8debugger26PropertyMessageDescriptionD2Ev,__ZN5physx8debugger26PropertyMessageDescriptionD0Ev,__ZN5physx8debugger16ClassDescriptionD2Ev,__ZN5physx8debugger16ClassDescriptionD0Ev,__ZN5physx8debugger4comm18EventSerializeableD2Ev,__ZN5physx8debugger4comm10EventGroupD0Ev,__ZN12_GLOBAL__N_111StreamOwnerD2Ev,__ZN12_GLOBAL__N_111StreamOwnerD0Ev,__ZN12_GLOBAL__N_111StreamOwner6addRefEv,__ZN12_GLOBAL__N_111StreamOwner7releaseEv,__ZN12_GLOBAL__N_111StreamOwner6unlockEv,__ZN12_GLOBAL__N_111StreamOwner10disconnectEv,__ZThn4_N12_GLOBAL__N_111StreamOwnerD1Ev,__ZThn4_N12_GLOBAL__N_111StreamOwnerD0Ev,__ZThn4_N12_GLOBAL__N_111StreamOwner10disconnectEv,__ZThn4_N12_GLOBAL__N_111StreamOwner7releaseEv,__ZThn8_N12_GLOBAL__N_111StreamOwnerD1Ev,__ZThn8_N12_GLOBAL__N_111StreamOwnerD0Ev,__ZThn8_N12_GLOBAL__N_111StreamOwner10disconnectEv,__ZThn8_N12_GLOBAL__N_111StreamOwner7releaseEv,__ZN5physx8debugger19PvdNetworkOutStreamD2Ev,__ZN5physx8debugger19PvdNetworkOutStreamD0Ev,__ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev,__ZN12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev,__ZN12_GLOBAL__N_123DoubleBufferedOutStream10disconnectEv,__ZN12_GLOBAL__N_123DoubleBufferedOutStream7releaseEv,__ZN12_GLOBAL__N_123DoubleBufferedOutStream7executeEv,__ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD1Ev
,__ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev,__ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStream7executeEv,__ZN12_GLOBAL__N_117MemoryEventClientD2Ev,__ZN12_GLOBAL__N_117MemoryEventClientD0Ev,__ZN12_GLOBAL__N_117MemoryEventClient19handleClientRemovedEv,__ZN12_GLOBAL__N_110DataStreamD2Ev,__ZN12_GLOBAL__N_110DataStreamD0Ev,__ZN12_GLOBAL__N_110DataStream15flushPvdCommandEv,__ZN12_GLOBAL__N_110DataStream6addRefEv,__ZN12_GLOBAL__N_110DataStream7releaseEv,__ZN12_GLOBAL__N_110DataStream11enableCacheEv,__ZN12_GLOBAL__N_110DataStream12disableCacheEv,__ZThn4_N12_GLOBAL__N_110DataStreamD1Ev,__ZThn4_N12_GLOBAL__N_110DataStreamD0Ev,__ZN12_GLOBAL__N_124PropertyDefinitionHelperD2Ev,__ZN12_GLOBAL__N_124PropertyDefinitionHelperD0Ev,__ZN12_GLOBAL__N_124PropertyDefinitionHelper7popNameEv,__ZN12_GLOBAL__N_124PropertyDefinitionHelper14clearNameStackEv,__ZN12_GLOBAL__N_124PropertyDefinitionHelper16clearNamedValuesEv,__ZN12_GLOBAL__N_124PropertyDefinitionHelper24clearPropertyMessageArgsEv,__ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIcED0Ev,__ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayINS0_18PropertyMessageArgEED0Ev,__ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPNS0_4comm21PvdInstanceDataStream10PvdCommandEED0Ev,__ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPhED0Ev,__ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED0Ev
,__ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED0Ev,__ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx8debugger4comm11DeriveClassD0Ev,__ZN5physx8debugger4comm15EventSerializerD2Ev,__ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEED0Ev,__ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEED0Ev,__ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEED0Ev,__ZN5physx8debugger4comm17StringHandleEventD0Ev,__ZN5physx8debugger4comm11CreateClassD0Ev,__ZN5physx8debugger4comm20StreamPropMessageArgD0Ev,__ZN5physx8debugger4comm21CreatePropertyMessageD0Ev,__ZN5physx8debugger4comm15NameHandleValueD0Ev,__ZN5physx8debugger4comm14CreatePropertyD0Ev,__ZN5physx8debugger4comm19AddProfileZoneEventD0Ev,__ZN5physx8debugger4comm14AddProfileZoneD0Ev,__ZN5physx8debugger4comm11OriginShiftD0Ev,__ZN5physx8debugger4comm10EndSectionD0Ev,__ZN5physx8debugger4comm12BeginSectionD0Ev,__ZN5physx8debugger4comm15DestroyInstanceD0Ev,__ZN5physx8debugger4comm15RemoveObjectRefD0Ev,__ZN5physx8debugger4comm17PushBackObjectRefD0Ev,__ZN5physx8debugger4comm23EndPropertyMessageGroupD0Ev,__ZN5physx8debugger4comm28SendPropertyMessageFromGroupD0Ev,__ZN5physx8debugger4comm25BeginPropertyMessageGroupD0Ev,__ZN5physx8debugger4comm18SetPropertyMessageD0Ev,__ZN5physx8debugger4comm19EndSetPropertyValueD0Ev,__ZN5physx8debugger4comm23AppendPropertyValueDataD0Ev,__ZN5physx8debugger4comm21BeginSetPropertyValueD0Ev,__ZN5physx8debugger4comm16SetPropertyValueD0Ev,__ZN5physx8debugger4comm14CreateInstanceD0Ev
,__ZN12_GLOBAL__N_117ProfileZoneClientD2Ev,__ZN12_GLOBAL__N_117ProfileZoneClientD0Ev,__ZN12_GLOBAL__N_117ProfileZoneClient19handleClientRemovedEv,__ZN5physx8debugger4comm20StreamInitializationD0Ev,__ZN5physx8debugger4comm13SetIsTopLevelD0Ev,__ZN5physx8debugger4comm12ErrorMessageD0Ev,__ZN5physx8debugger4comm9SetCameraD0Ev,__ZN5physx8debugger4comm8SetColorD0Ev,__ZN5physx8debugger4comm11SetPickableD0Ev,__ZN12_GLOBAL__N_119RendererEventClientD2Ev,__ZN12_GLOBAL__N_119RendererEventClientD0Ev,__ZN12_GLOBAL__N_119RendererEventClient19handleClientRemovedEv,__ZN12_GLOBAL__N_112UserRendererD2Ev,__ZN12_GLOBAL__N_112UserRendererD0Ev,__ZN12_GLOBAL__N_112UserRenderer6addRefEv,__ZN12_GLOBAL__N_112UserRenderer7releaseEv,__ZN12_GLOBAL__N_112UserRenderer17flushRenderEventsEv,__ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPNS_26PxProfileEventBufferClientEED0Ev,__ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED0Ev,__ZN5physx8debugger8renderer16RenderSerializerD2Ev,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEED0Ev,__ZN12_GLOBAL__N_117ConnectionManagerD2Ev,__ZN12_GLOBAL__N_117ConnectionManagerD0Ev,__ZN12_GLOBAL__N_117ConnectionManager13sendStreamEndEv,__ZN12_GLOBAL__N_117ConnectionManager10disconnectEv,__ZN12_GLOBAL__N_117ConnectionManager7releaseEv,__ZThn4_N12_GLOBAL__N_117ConnectionManagerD1Ev,__ZThn4_N12_GLOBAL__N_117ConnectionManagerD0Ev,__ZThn8_N12_GLOBAL__N_117ConnectionManagerD1Ev
,__ZThn8_N12_GLOBAL__N_117ConnectionManagerD0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev,__ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev,__ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED2Ev,__ZN5physx8debugger15ForwardingArrayIPNS0_4comm20PvdConnectionHandlerEED0Ev,__ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED0Ev,__ZN12_GLOBAL__N_123FStreamNetworkOutStreamD2Ev,__ZN12_GLOBAL__N_123FStreamNetworkOutStreamD0Ev,__ZN12_GLOBAL__N_123FStreamNetworkOutStream10disconnectEv,__ZN12_GLOBAL__N_123FStreamNetworkOutStream7releaseEv,__ZN12_GLOBAL__N_121SocketNetworkInStreamD2Ev,__ZN12_GLOBAL__N_121SocketNetworkInStreamD0Ev,__ZN12_GLOBAL__N_121SocketNetworkInStream10disconnectEv,__ZN12_GLOBAL__N_121SocketNetworkInStream7releaseEv,__ZN12_GLOBAL__N_122SocketNetworkOutStreamD2Ev,__ZN12_GLOBAL__N_122SocketNetworkOutStreamD0Ev,__ZN12_GLOBAL__N_122SocketNetworkOutStream10disconnectEv,__ZN12_GLOBAL__N_122SocketNetworkOutStream7releaseEv,__ZN12_GLOBAL__N_16ParserILb1EED2Ev,__ZN12_GLOBAL__N_16ParserILb1EED0Ev,__ZN12_GLOBAL__N_16ParserILb1EE7releaseEv,__ZN12_GLOBAL__N_112RenderReaderILb1EED2Ev,__ZN12_GLOBAL__N_112RenderReaderILb1EED0Ev,__ZN12_GLOBAL__N_16ParserILb0EED2Ev,__ZN12_GLOBAL__N_16ParserILb0EED0Ev,__ZN12_GLOBAL__N_16ParserILb0EE7releaseEv,__ZN12_GLOBAL__N_112RenderReaderILb0EED2Ev,__ZN12_GLOBAL__N_112RenderReaderILb0EED0Ev
,__ZN5physx15PxAssertHandlerD2Ev,__ZN12_GLOBAL__N_120DefaultAssertHandlerD0Ev,__ZN5physx6shdfnd7FastIPC7releaseEv,__ZN5physx6shdfnd7FastIPCD2Ev,__ZN5physx6shdfnd7FastIPCD0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_ED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEED0Ev,__ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEED0Ev,__ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEED0Ev,__ZN15OverlapCallbackD0Ev,__ZN23RaycastCallbackNonAllocD0Ev,__ZN13SweepCallbackD0Ev,__ZN21SweepCallbackNonAllocD0Ev,__ZN23OverlapCallbackNonAllocD0Ev,__ZN25PostFilteredUserCollectorD0Ev,__ZN5physx16PxOverlapBufferNILi1EED0Ev,__ZN12b2ChainShapeD2Ev,__ZN12b2ChainShapeD0Ev,__ZN7b2ShapeD2Ev,__ZN11b2EdgeShapeD0Ev,__ZN14b2CapsuleShapeD2Ev,__ZN14b2CapsuleShapeD0Ev,__ZN14b2PolygonShapeD0Ev,__ZN13b2CircleShapeD0Ev,__ZN9b2ContactD2Ev,__ZN25b2CapsuleAndCircleContactD0Ev,__ZN16b2CapsuleContactD0Ev,__ZN24b2ChainAndCapsuleContactD0Ev,__ZN23b2ChainAndCircleContactD0Ev,__ZN24b2ChainAndPolygonContactD0Ev
,__ZN15b2CircleContactD0Ev,__ZN23b2EdgeAndCapsuleContactD0Ev,__ZN22b2EdgeAndCircleContactD0Ev,__ZN23b2EdgeAndPolygonContactD0Ev,__ZN26b2PolygonAndCapsuleContactD0Ev,__ZN25b2PolygonAndCircleContactD0Ev,__ZN16b2PolygonContactD0Ev,__ZN15b2DistanceJoint4DumpEv,__ZN7b2JointD2Ev,__ZN15b2DistanceJointD0Ev,__ZN15b2FrictionJoint4DumpEv,__ZN15b2FrictionJointD0Ev,__ZN11b2GearJoint4DumpEv,__ZN11b2GearJointD0Ev,__ZN12b2MotorJoint4DumpEv,__ZN12b2MotorJointD0Ev,__ZN12b2MouseJoint4DumpEv,__ZN12b2MouseJointD0Ev,__ZN16b2PrismaticJoint4DumpEv,__ZN16b2PrismaticJointD0Ev,__ZN13b2PulleyJoint4DumpEv,__ZN13b2PulleyJointD0Ev,__ZN15b2RevoluteJoint4DumpEv,__ZN15b2RevoluteJointD0Ev,__ZN11b2RopeJoint4DumpEv,__ZN11b2RopeJointD0Ev,__ZN11b2WeldJoint4DumpEv,__ZN11b2WeldJointD0Ev,__ZN12b2WheelJoint4DumpEv,__ZN12b2WheelJointD0Ev
,__ZN15b2ContactFilterD2Ev,__ZN15b2ContactFilterD0Ev,__ZN17b2ContactListenerD2Ev,__ZN17b2ContactListenerD0Ev,__ZN15AnchoredJoint2DD2Ev,__ZN15AnchoredJoint2DD0Ev,__ZN15AnchoredJoint2D16CheckConsistencyEv,__ZN15AnchoredJoint2D5ResetEv,__ZN7Joint2D12AddToManagerEv,__ZN7Joint2D17RemoveFromManagerEv,__ZN7Joint2DD2Ev,__ZN7Joint2DD0Ev,__ZN7Joint2D16CheckConsistencyEv,__ZN7Joint2D5ResetEv,__ZN14AreaEffector2DD2Ev,__ZN14AreaEffector2DD0Ev,__ZN10Effector2D17MainThreadCleanupEv,__ZN14AreaEffector2D16CheckConsistencyEv,__ZN14AreaEffector2D5ResetEv,__ZN10Effector2D12AddToManagerEv,__ZN10Effector2D17RemoveFromManagerEv,__ZN10Effector2D19RecalculateContactsEv,__ZN10Effector2DD2Ev,__ZN10Effector2DD0Ev,__ZN10Effector2D5ResetEv,__ZN13BoxCollider2DD2Ev,__ZN13BoxCollider2DD0Ev,__ZN13BoxCollider2D16CheckConsistencyEv,__ZN13BoxCollider2D5ResetEv,__ZN13BoxCollider2D10SmartResetEv
,__ZN10Collider2D12AddToManagerEv,__ZN10Collider2D17RemoveFromManagerEv,__ZN10Collider2DD2Ev,__ZN10Collider2DD0Ev,__ZN10Collider2D16CheckConsistencyEv,__ZN10Collider2D5ResetEv,__ZN18BuoyancyEffector2DD2Ev,__ZN18BuoyancyEffector2DD0Ev,__ZN18BuoyancyEffector2D16CheckConsistencyEv,__ZN18BuoyancyEffector2D5ResetEv,__ZN17CapsuleCollider2DD2Ev,__ZN17CapsuleCollider2DD0Ev,__ZN17CapsuleCollider2D16CheckConsistencyEv,__ZN17CapsuleCollider2D5ResetEv,__ZN17CapsuleCollider2D10SmartResetEv,__ZN16CircleCollider2DD2Ev,__ZN16CircleCollider2DD0Ev,__ZN16CircleCollider2D16CheckConsistencyEv,__ZN16CircleCollider2D5ResetEv,__ZN16CircleCollider2D10SmartResetEv,__ZN19CollisionListener2DD2Ev,__ZN19CollisionListener2DD0Ev,__ZN15ConstantForce2DD2Ev,__ZN15ConstantForce2DD0Ev,__ZN15ConstantForce2D16CheckConsistencyEv,__ZN15ConstantForce2D5ResetEv,__ZN15ConstantForce2D11FixedUpdateEv,__ZN24PhysicsUpdateBehaviour2D12AddToManagerEv,__ZN24PhysicsUpdateBehaviour2D17RemoveFromManagerEv,__ZN24PhysicsUpdateBehaviour2DD2Ev
,__ZN24PhysicsUpdateBehaviour2DD0Ev,__ZN15DistanceJoint2DD2Ev,__ZN15DistanceJoint2DD0Ev,__ZN15DistanceJoint2D16CheckConsistencyEv,__ZN15DistanceJoint2D5ResetEv,__ZN15DistanceJoint2D6CreateEv,__ZN14EdgeCollider2DD2Ev,__ZN14EdgeCollider2DD0Ev,__ZN14EdgeCollider2D16CheckConsistencyEv,__ZN14EdgeCollider2D5ResetEv,__ZN14EdgeCollider2D10SmartResetEv,__ZN12FixedJoint2DD2Ev,__ZN12FixedJoint2DD0Ev,__ZN12FixedJoint2D16CheckConsistencyEv,__ZN12FixedJoint2D5ResetEv,__ZN12FixedJoint2D6CreateEv,__ZN15FrictionJoint2DD2Ev,__ZN15FrictionJoint2DD0Ev,__ZN15FrictionJoint2D16CheckConsistencyEv,__ZN15FrictionJoint2D5ResetEv,__ZN15FrictionJoint2D6CreateEv,__ZN12HingeJoint2DD2Ev,__ZN12HingeJoint2DD0Ev,__ZN12HingeJoint2D16CheckConsistencyEv,__ZN12HingeJoint2D5ResetEv,__ZN12HingeJoint2D6CreateEv,__ZN16Physics2DManagerD2Ev,__ZN16Physics2DManagerD0Ev,__ZN16Physics2DManager11FixedUpdateEv,__ZN16Physics2DManager13DynamicUpdateEv
,__ZN17CircleCast2DQueryD2Ev,__ZN17CircleCast2DQueryD0Ev,__ZN15Cast2DQueryBaseD2Ev,__ZN15Cast2DQueryBaseD0Ev,__ZN17b2RayCastCallbackD2Ev,__ZN14Raycast2DQueryD0Ev,__ZN15b2QueryCallbackD2Ev,__ZN19OverlapPointQuery2DD0Ev,__ZN17PhysicsMaterial2DD2Ev,__ZN17PhysicsMaterial2DD0Ev,__ZN17PhysicsMaterial2D16CheckConsistencyEv,__ZN17PhysicsMaterial2D5ResetEv,__ZN17Physics2DSettingsD2Ev,__ZN17Physics2DSettingsD0Ev,__ZN17Physics2DSettings16CheckConsistencyEv,__ZN17Physics2DSettings5ResetEv,__ZN18PlatformEffector2DD2Ev,__ZN18PlatformEffector2DD0Ev,__ZN18PlatformEffector2D16CheckConsistencyEv,__ZN18PlatformEffector2D5ResetEv,__ZN18PlatformEffector2D19RecalculateContactsEv,__ZN15PointEffector2DD2Ev,__ZN15PointEffector2DD0Ev,__ZN15PointEffector2D16CheckConsistencyEv,__ZN15PointEffector2D5ResetEv,__ZN17PolygonCollider2DD2Ev,__ZN17PolygonCollider2DD0Ev,__ZN17PolygonCollider2D16CheckConsistencyEv,__ZN17PolygonCollider2D5ResetEv,__ZN17PolygonCollider2D10SmartResetEv
,__ZN15RelativeJoint2DD2Ev,__ZN15RelativeJoint2DD0Ev,__ZN15RelativeJoint2D16CheckConsistencyEv,__ZN15RelativeJoint2D5ResetEv,__ZN15RelativeJoint2D6CreateEv,__ZN11Rigidbody2DD2Ev,__ZN11Rigidbody2DD0Ev,__ZN11Rigidbody2D16CheckConsistencyEv,__ZN11Rigidbody2D5ResetEv,__ZN13SliderJoint2DD2Ev,__ZN13SliderJoint2DD0Ev,__ZN13SliderJoint2D16CheckConsistencyEv,__ZN13SliderJoint2D5ResetEv,__ZN13SliderJoint2D6CreateEv,__ZN13SpringJoint2DD2Ev,__ZN13SpringJoint2DD0Ev,__ZN13SpringJoint2D16CheckConsistencyEv,__ZN13SpringJoint2D5ResetEv,__ZN13SpringJoint2D6CreateEv,__ZN17SurfaceEffector2DD2Ev,__ZN17SurfaceEffector2DD0Ev,__ZN17SurfaceEffector2D16CheckConsistencyEv,__ZN17SurfaceEffector2D5ResetEv,__ZN13TargetJoint2DD2Ev,__ZN13TargetJoint2DD0Ev,__ZN13TargetJoint2D16CheckConsistencyEv,__ZN13TargetJoint2D5ResetEv,__ZN13TargetJoint2D10SmartResetEv,__ZN13TargetJoint2D6CreateEv,__ZN12WheelJoint2DD2Ev
,__ZN12WheelJoint2DD0Ev,__ZN12WheelJoint2D16CheckConsistencyEv,__ZN12WheelJoint2D5ResetEv,__ZN12WheelJoint2D6CreateEv,__ZN6b2DrawD2Ev,__ZN6b2DrawD0Ev,__ZN9b2ContactD0Ev,__ZN7b2Joint4DumpEv,__ZN7b2JointD0Ev,__ZN16ShapeCast2DQueryD0Ev,__ZN15ContactFilter2DD0Ev,__ZN14BoxCast2DQueryD2Ev,__ZN14BoxCast2DQueryD0Ev,__ZN18CapsuleCast2DQueryD2Ev,__ZN18CapsuleCast2DQueryD0Ev,__ZN20OverlapCircleQuery2DD2Ev,__ZN20OverlapCircleQuery2DD0Ev,__ZN17OverlapBoxQuery2DD2Ev,__ZN17OverlapBoxQuery2DD0Ev,__ZN21OverlapCapsuleQuery2DD2Ev,__ZN21OverlapCapsuleQuery2DD0Ev,__ZN5physx15PxVehicleWheels7releaseEv,__ZN5physx15PxVehicleWheelsD2Ev,__ZN5physx16PxVehicleNoDriveD0Ev,__ZN5physx15PxVehicleWheelsD0Ev,__ZN13WheelColliderD2Ev,__ZN13WheelColliderD0Ev,__ZN13WheelCollider17MainThreadCleanupEv,__ZN13WheelCollider16CheckConsistencyEv,__ZN13WheelCollider5ResetEv
,__ZN13WheelCollider10SmartResetEv,__ZN13WheelCollider12ScaleChangedEv,__ZN13WheelCollider7CleanupEv,__ZN13WheelCollider22CreatePhysXObjIfNeededEv,__ZN5physx25PxVehicleConstraintShader19onConstraintReleaseEv,__ZN5physx21PxConstraintConnectorD2Ev,__ZN5physx25PxVehicleConstraintShaderD0Ev,__ZN5physx14PxVehicleDriveD0Ev,__ZN5physx16PxVehicleDrive4WD2Ev,__ZN5physx16PxVehicleDrive4WD0Ev,__ZN5physx16PxVehicleDriveNWD2Ev,__ZN5physx16PxVehicleDriveNWD0Ev,__ZN5physx18PxVehicleDriveTankD2Ev,__ZN5physx18PxVehicleDriveTankD0Ev,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEED0Ev,__ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEED0Ev,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEED0Ev,__ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEED0Ev,__ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEED0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev,__ZN14VehiclesModule19InitVehiclesManagerEv,__ZN14VehiclesModule20SetupVehiclesManagerEv,__ZN14VehiclesModule22CleanupVehiclesManagerEv,__ZN14VehiclesModule23ShutdownVehiclesManagerEv
,__ZN5physx5cloth8SwFabricD2Ev,__ZN5physx5cloth8SwFabricD0Ev,__ZThn4_N5physx5cloth8SwFabricD1Ev,__ZThn4_N5physx5cloth8SwFabricD0Ev,__ZN5physx5cloth6FabricD2Ev,__ZN5physx5cloth6FabricD0Ev,__ZN5physx5cloth13UserAllocatedD2Ev,__ZN5physx5cloth13UserAllocatedD0Ev,__ZN5physx5cloth9SwFactoryD2Ev,__ZN5physx5cloth9SwFactoryD0Ev,__ZThn4_N5physx5cloth9SwFactoryD1Ev,__ZThn4_N5physx5cloth9SwFactoryD0Ev,__ZN5physx5cloth9ClothImplINS0_7SwClothEED2Ev,__ZN5physx5cloth9ClothImplINS0_7SwClothEED0Ev,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv,__ZN5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED1Ev,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED0Ev,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv
,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv,__ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv,__ZN5physx5cloth8SwSolverD2Ev,__ZN5physx5cloth8SwSolverD0Ev,__ZThn4_N5physx5cloth8SwSolverD1Ev,__ZThn4_N5physx5cloth8SwSolverD0Ev,__ZN5physx5cloth8SwSolver19StartSimulationTaskD0Ev,__ZN5physx5cloth8SwSolver19StartSimulationTask11runInternalEv,__ZN5physx5cloth8SwSolver17EndSimulationTaskD0Ev,__ZN5physx5cloth8SwSolver17EndSimulationTask11runInternalEv,__ZN5physx5cloth8SwSolver22CpuClothSimulationTaskD0Ev,__ZN5physx5cloth8SwSolver22CpuClothSimulationTask7releaseEv,__ZN5physx5cloth8SwSolver22CpuClothSimulationTask11runInternalEv,__ZN5Unity5ClothD2Ev,__ZN5Unity5ClothD0Ev,__ZN5Unity5Cloth5ResetEv,__ZN5Unity5Cloth10LateUpdateEv,__ZN5Unity5Cloth12AddToManagerEv,__ZN5Unity5Cloth17RemoveFromManagerEv,__ZN11ClothModule16InitClothManagerEv,__ZN11ClothModule17SetupClothManagerEv,__ZN11ClothModule19CleanupClothManagerEv,__ZN12NavMeshAgentD2Ev,__ZN12NavMeshAgentD0Ev,__ZN12NavMeshAgent16CheckConsistencyEv,__ZN12NavMeshAgent5ResetEv,__ZN12NavMeshAgent10SmartResetEv,__ZN12NavMeshAgent12AddToManagerEv
,__ZN12NavMeshAgent17RemoveFromManagerEv,__ZN15NavMeshObstacleD2Ev,__ZN15NavMeshObstacleD0Ev,__ZN15NavMeshObstacle16CheckConsistencyEv,__ZN15NavMeshObstacle5ResetEv,__ZN15NavMeshObstacle10SmartResetEv,__ZN15NavMeshObstacle12AddToManagerEv,__ZN15NavMeshObstacle17RemoveFromManagerEv,__ZN11OffMeshLinkD2Ev,__ZN11OffMeshLinkD0Ev,__ZN11OffMeshLink5ResetEv,__ZN11OffMeshLink10SmartResetEv,__ZN11OffMeshLink12AddToManagerEv,__ZN11OffMeshLink17RemoveFromManagerEv,__ZN11NavMeshDataD2Ev,__ZN11NavMeshDataD0Ev,__ZN11NavMeshData17MainThreadCleanupEv,__ZN22NavMeshProjectSettingsD2Ev,__ZN22NavMeshProjectSettingsD0Ev,__ZN22NavMeshProjectSettings16CheckConsistencyEv,__ZN22NavMeshProjectSettings5ResetEv,__ZN15NavMeshSettingsD2Ev,__ZN15NavMeshSettingsD0Ev,__ZN15NavMeshSettings17MainThreadCleanupEv,__ZN15NavMeshSettings5ResetEv,__ZN15HeightMeshQueryD2Ev,__ZN15HeightMeshQueryD0Ev,__ZN17AudioChorusFilterD2Ev,__ZN17AudioChorusFilterD0Ev,__ZN11AudioFilter17MainThreadCleanupEv
,__ZN17AudioChorusFilter16CheckConsistencyEv,__ZN17AudioChorusFilter5ResetEv,__ZN17AudioChorusFilter6UpdateEv,__ZN17AudioChorusFilter12AddToManagerEv,__ZN11AudioFilter17RemoveFromManagerEv,__ZN11AudioFilterD2Ev,__ZN11AudioFilterD0Ev,__ZN11AudioFilter12AddToManagerEv,__ZN10SampleClipD2Ev,__ZN10SampleClipD0Ev,__ZN10SampleClip17MainThreadCleanupEv,__ZN9AudioClipD2Ev,__ZN9AudioClipD0Ev,__ZN9AudioClip17MainThreadCleanupEv,__ZN9AudioClip21AwakeFromLoadThreadedEv,__ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD2Ev,__ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD0Ev,__ZN17AudioCustomFilterD2Ev,__ZN17AudioCustomFilterD0Ev,__ZN21AudioDistortionFilterD2Ev,__ZN21AudioDistortionFilterD0Ev,__ZN21AudioDistortionFilter16CheckConsistencyEv,__ZN21AudioDistortionFilter5ResetEv,__ZN21AudioDistortionFilter6UpdateEv,__ZN21AudioDistortionFilter12AddToManagerEv,__ZN15AudioEchoFilterD2Ev,__ZN15AudioEchoFilterD0Ev,__ZN15AudioEchoFilter16CheckConsistencyEv,__ZN15AudioEchoFilter5ResetEv,__ZN15AudioEchoFilter6UpdateEv
,__ZN15AudioEchoFilter12AddToManagerEv,__ZN19AudioHighPassFilterD2Ev,__ZN19AudioHighPassFilterD0Ev,__ZN19AudioHighPassFilter16CheckConsistencyEv,__ZN19AudioHighPassFilter5ResetEv,__ZN19AudioHighPassFilter6UpdateEv,__ZN19AudioHighPassFilter12AddToManagerEv,__ZN13AudioListenerD2Ev,__ZN13AudioListenerD0Ev,__ZN13AudioListener6UpdateEv,__ZN13AudioListener11FixedUpdateEv,__ZN13AudioListener12AddToManagerEv,__ZN13AudioListener17RemoveFromManagerEv,__ZN18AudioLowPassFilterD2Ev,__ZN18AudioLowPassFilterD0Ev,__ZN18AudioLowPassFilter16CheckConsistencyEv,__ZN18AudioLowPassFilter5ResetEv,__ZN18AudioLowPassFilter6UpdateEv,__ZN18AudioLowPassFilter12AddToManagerEv,__ZN12AudioManagerD2Ev,__ZN12AudioManagerD0Ev,__ZN12AudioManager17MainThreadCleanupEv,__ZN12AudioManager16CheckConsistencyEv,__ZN12AudioManager5ResetEv,__ZN10AudioMixerD2Ev,__ZN10AudioMixerD0Ev,__ZN10AudioMixer17MainThreadCleanupEv,__ZN10AudioMixer16CheckConsistencyEv,__ZN10AudioMixer5ResetEv,__ZN10AudioMixer26OnEditingInPlayModeChangedEv
,__ZN10AudioMixer16OnRuntimeChangedEv,__ZN10AudioMixer23OnEnterPlayModePreStartEv,__ZN10AudioMixer14OnExitPlayModeEv,__ZN15AudioMixerGroupD2Ev,__ZN15AudioMixerGroupD0Ev,__ZN18AudioMixerSnapshotD2Ev,__ZN18AudioMixerSnapshotD0Ev,__ZN17AudioReverbFilterD2Ev,__ZN17AudioReverbFilterD0Ev,__ZN17AudioReverbFilter16CheckConsistencyEv,__ZN17AudioReverbFilter5ResetEv,__ZN17AudioReverbFilter6UpdateEv,__ZN17AudioReverbFilter12AddToManagerEv,__ZN15AudioReverbZoneD2Ev,__ZN15AudioReverbZoneD0Ev,__ZN15AudioReverbZone17MainThreadCleanupEv,__ZN15AudioReverbZone16CheckConsistencyEv,__ZN15AudioReverbZone5ResetEv,__ZN15AudioReverbZone6UpdateEv,__ZN15AudioReverbZone12AddToManagerEv,__ZN15AudioReverbZone17RemoveFromManagerEv,__ZN11AudioSourceD2Ev,__ZN11AudioSourceD0Ev,__ZN11AudioSource17MainThreadCleanupEv,__ZN11AudioSource16CheckConsistencyEv,__ZN11AudioSource5ResetEv,__ZN11AudioSource6UpdateEv,__ZN11AudioSource11FixedUpdateEv,__ZN11AudioSource12AddToManagerEv,__ZN11AudioSource17RemoveFromManagerEv
,__ZN20SoundChannelInstanceD2Ev,__ZN20SoundChannelInstanceD0Ev,__ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD2Ev,__ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD0Ev,__ZN14AudioBehaviourD2Ev,__ZN14AudioBehaviourD0Ev,__ZN16BaseVideoTextureD2Ev,__ZN16BaseVideoTextureD0Ev,__ZN11AudioModule11FixedUpdateEv,__ZN11AudioModule6UpdateEv,__ZN11AudioModule17StopVideoTexturesEv,__ZN11AudioModule19UpdateVideoTexturesEv,__ZN11AudioModule18PauseVideoTexturesEv,__ZN11AudioModule20SuspendVideoTexturesEv,__ZN11AudioModule19ResumeVideoTexturesEv,__ZN9AnimationD2Ev,__ZN9AnimationD0Ev,__ZN9Animation17MainThreadCleanupEv,__ZN9Animation12AddToManagerEv,__ZN9Animation17RemoveFromManagerEv,__ZN13AnimationClipD2Ev,__ZN13AnimationClipD0Ev,__ZN13AnimationClip17MainThreadCleanupEv,__ZN13AnimationClip16CheckConsistencyEv,__ZN6MotionD2Ev,__ZN6MotionD0Ev,__ZN6Motion17MainThreadCleanupEv,__ZN8AnimatorD2Ev,__ZN8AnimatorD0Ev,__ZN8Animator17MainThreadCleanupEv
,__ZN8Animator16CheckConsistencyEv,__ZN8Animator5ResetEv,__ZN8Animator11FixedUpdateEv,__ZN8Animator12AddToManagerEv,__ZN8Animator17RemoveFromManagerEv,__ZN8Animator15SetPrepareStageEv,__ZN8Animator17OnPlayableDestroyEv,__ZN17AnimationPlayableD2Ev,__ZN17AnimationPlayableD0Ev,__ZN17AnimationPlayable19DeallocateResourcesEv,__ZN17AnimationPlayable29CleanupStateMachineBehavioursEv,__ZN17AnimationPlayable13ClearBindingsEv,__ZN27AnimationLayerMixerPlayableD2Ev,__ZN27AnimationLayerMixerPlayableD0Ev,__ZN27AnimationLayerMixerPlayable19DeallocateResourcesEv,__ZN27AnimationLayerMixerPlayable13ClearBindingsEv,__ZN22AnimationMixerPlayableD0Ev,__ZN21AnimationPosePlayableD0Ev,__ZN21AnimationPosePlayable19DeallocateResourcesEv,__ZN21AnimationClipPlayableD2Ev,__ZN21AnimationClipPlayableD0Ev,__ZN21AnimationClipPlayable19DeallocateResourcesEv,__ZN21AnimationClipPlayable13ClearBindingsEv,__ZN21AnimationClipPlayable6MemoryD2Ev,__ZN21AnimationClipPlayable6MemoryD0Ev,__ZN26AnimatorControllerPlayableD2Ev,__ZN26AnimatorControllerPlayableD0Ev,__ZN26AnimatorControllerPlayable19DeallocateResourcesEv,__ZN26AnimatorControllerPlayable29CleanupStateMachineBehavioursEv,__ZN26AnimatorControllerPlayable13ClearBindingsEv
,__ZN26AnimatorControllerPlayable6MemoryD2Ev,__ZN26AnimatorControllerPlayable6MemoryD0Ev,__ZN14AvatarPlaybackD2Ev,__ZN14AvatarPlaybackD0Ev,__ZN18AnimatorControllerD2Ev,__ZN18AnimatorControllerD0Ev,__ZN18AnimatorController17MainThreadCleanupEv,__ZN18AnimatorController16CheckConsistencyEv,__ZN25RuntimeAnimatorController22RegisterAnimationClipsEv,__ZN25RuntimeAnimatorControllerD2Ev,__ZN25RuntimeAnimatorControllerD0Ev,__ZN25RuntimeAnimatorController17MainThreadCleanupEv,__ZN26AnimatorOverrideControllerD2Ev,__ZN26AnimatorOverrideControllerD0Ev,__ZN26AnimatorOverrideController17MainThreadCleanupEv,__ZN26AnimatorOverrideController10BuildAssetEv,__ZN26AnimatorOverrideController10ClearAssetEv,__ZN6AvatarD2Ev,__ZN6AvatarD0Ev,__ZN6Avatar17MainThreadCleanupEv,__ZN6Avatar16CheckConsistencyEv,__ZN16HumanPoseHandlerD2Ev,__ZN16HumanPoseHandlerD0Ev,__ZN16MecanimAnimationD2Ev,__ZN16MecanimAnimationD0Ev,__ZN23AnimationOffsetPlayableD0Ev,__ZN20QuadTreeNodeRendererD0Ev,__ZN7TerrainD2Ev,__ZN7TerrainD0Ev,__ZN7Terrain17MainThreadCleanupEv
,__ZN7Terrain5ResetEv,__ZN7Terrain10SmartResetEv,__ZN7Terrain12AddToManagerEv,__ZN7Terrain17RemoveFromManagerEv,__ZN11TerrainDataD2Ev,__ZN11TerrainDataD0Ev,__ZN11TerrainData17MainThreadCleanupEv,__ZN11TerrainData21AwakeFromLoadThreadedEv,__ZN11TerrainData16CheckConsistencyEv,__ZN14TerrainManagerD2Ev,__ZN14TerrainManagerD0Ev,__ZN14TerrainManager27ClearLightmapsOnAllTerrainsEv,__ZN14TerrainManager27UnloadTerrainsFromGfxDeviceEv,__ZN14TerrainManager25ReloadTerrainsToGfxDeviceEv,__ZN26LegacyTreeInstanceRendererD0Ev,__ZN29BillboardTreeInstanceRendererD0Ev,__ZN23LODTreeInstanceRendererD0Ev,__ZN4TreeD2Ev,__ZN4TreeD0Ev,__ZN4Tree20WillDestroyComponentEv,__ZN13TextRendering4FontD2Ev,__ZN13TextRendering4FontD0Ev,__ZN13TextRendering4Font5ResetEv,__ZN20TextRenderingPrivate7GUITextD2Ev,__ZN20TextRenderingPrivate7GUITextD0Ev,__ZN20TextRenderingPrivate7GUIText5ResetEv,__ZN20TextRenderingPrivate8TextMeshD2Ev,__ZN20TextRenderingPrivate8TextMeshD0Ev,__ZN20TextRenderingPrivate8TextMesh17MainThreadCleanupEv,__ZN20TextRenderingPrivate8TextMesh5ResetEv
,__ZNK19TextRenderingModule10TMGenFlushEv,__ZN2UI6CanvasD2Ev,__ZN2UI6CanvasD0Ev,__ZN2UI6Canvas17MainThreadCleanupEv,__ZN2UI6Canvas16CheckConsistencyEv,__ZN2UI6Canvas12AddToManagerEv,__ZN2UI6Canvas17RemoveFromManagerEv,__ZN2UI6Canvas19UnloadFromGfxDeviceEv,__ZN2UI11CanvasGroupD2Ev,__ZN2UI11CanvasGroupD0Ev,__ZN2UI11CanvasGroup16CheckConsistencyEv,__ZN2UI11CanvasGroup12AddToManagerEv,__ZN2UI11CanvasGroup17RemoveFromManagerEv,__ZN2UI14CanvasRendererD2Ev,__ZN2UI14CanvasRendererD0Ev,__ZN2UI14CanvasRenderer17MainThreadCleanupEv,__ZN2UI14CanvasRenderer16CheckConsistencyEv,__ZN2UI14CanvasRenderer20WillDestroyComponentEv,__ZN15TerrainColliderD2Ev,__ZN15TerrainColliderD0Ev,__ZN15TerrainCollider17MainThreadCleanupEv,__ZN15TerrainCollider12ScaleChangedEv,__ZN15TerrainCollider7CleanupEv,__ZN15TerrainCollider22FetchPoseFromTransformEv,__ZN11IMGUIModule21ClearDeveloperConsoleEv,__ZN26DownloadHandlerAssetBundleD2Ev,__ZN26DownloadHandlerAssetBundleD0Ev,__ZN15DownloadHandler23OnUnbindScriptingObjectEv,__ZN26DownloadHandlerAssetBundle17OnCompleteContentEv,__ZN26DownloadHandlerAssetBundle7OnAbortEv
,__ZN15DownloadHandlerD2Ev,__ZN15DownloadHandlerD0Ev,__ZN15DownloadHandler7OnAbortEv,__ZN24DownloadHandlerAudioClipD2Ev,__ZN24DownloadHandlerAudioClipD0Ev,__ZN24DownloadHandlerAudioClip17OnCompleteContentEv,__ZN21DownloadHandlerBufferD2Ev,__ZN21DownloadHandlerBufferD0Ev,__ZN21DownloadHandlerBuffer17OnCompleteContentEv,__ZN21DownloadHandlerScriptD2Ev,__ZN21DownloadHandlerScriptD0Ev,__ZN21DownloadHandlerScript23OnUnbindScriptingObjectEv,__ZN21DownloadHandlerScript17OnCompleteContentEv,__ZN22DownloadHandlerTextureD2Ev,__ZN22DownloadHandlerTextureD0Ev,__ZN22DownloadHandlerTexture17OnCompleteContentEv,__ZN18DownloadHandlerVFSD2Ev,__ZN18DownloadHandlerVFSD0Ev,__ZN18DownloadHandlerVFS17OnCompleteContentEv,__ZN16UploadHandlerRawD2Ev,__ZN16UploadHandlerRawD0Ev,__ZN13UploadHandler23OnUnbindScriptingObjectEv,__ZN16UploadHandlerRaw5ResetEv,__ZN13UploadHandlerD2Ev,__ZN13UploadHandlerD0Ev,__ZN15UnityWebRequestD2Ev,__ZN15UnityWebRequestD0Ev,__ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev,__ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED0Ev,__ZN29UnityWebRequestAsyncOperationD2Ev
,__ZN29UnityWebRequestAsyncOperationD0Ev,__ZNK29UnityWebRequestAsyncOperation7ReleaseEv,__ZN14DLHAudioHelperD2Ev,__ZN14DLHAudioHelperD0Ev,__ZN14DLHAudioHelper15LockPartialDataEv,__ZN14DLHAudioHelper17UnlockPartialDataEv,__ZN15UnityAdsManagerD2Ev,__ZN15UnityAdsManagerD0Ev,__ZN15UnityAdsManager16CheckConsistencyEv,__ZN15UnityAdsManager5ResetEv,__ZN18BaseUnityAnalyticsD2Ev,__ZN18BaseUnityAnalyticsD0Ev,__ZN14UnityAnalyticsD2Ev,__ZN14UnityAnalyticsD0Ev,__ZN11UnityEngine9Analytics9PerfEventD2Ev,__ZN11UnityEngine9Analytics9PerfEventD0Ev,__ZN11UnityEngine9Analytics15UserCustomEventD2Ev,__ZN11UnityEngine9Analytics15UserCustomEventD0Ev,__ZN21UnityAnalyticsManagerD2Ev,__ZN21UnityAnalyticsManagerD0Ev,__ZN11UnityEngine9Analytics16TransactionEventD2Ev,__ZN11UnityEngine9Analytics16TransactionEventD0Ev,__ZN11UnityEngine9Analytics13UserInfoEventD2Ev,__ZN11UnityEngine9Analytics13UserInfoEventD0Ev,__ZN18CrashReportManagerD2Ev,__ZN18CrashReportManagerD0Ev,__ZN22BaseUnityConnectClientD2Ev,__ZN22BaseUnityConnectClientD0Ev,__ZN22BaseUnityConnectClient17OnEnterStateReadyEv,__ZN22BaseUnityConnectClient20OnEnterStatePreparedEv
,__ZN22BaseUnityConnectClient19OnEnterStateStartedEv,__ZN22BaseUnityConnectClient30OnEnteringStatePausedOrStoppedEv,__ZN22BaseUnityConnectClient18OnEnterStatePausedEv,__ZN22BaseUnityConnectClient19OnEnterStateStoppedEv,__ZN22BaseUnityConnectClient19SendAppRunningEventEv,__ZN11UnityEngine15CloudWebService17CloudServiceEventD2Ev,__ZN11UnityEngine7Connect15AppRunningEventD0Ev,__ZN11UnityEngine7Connect12AppStopEventD0Ev,__ZN11UnityEngine7Connect15AppInstallEventD2Ev,__ZN11UnityEngine7Connect15AppInstallEventD0Ev,__ZN11UnityEngine7Connect15DeviceInfoEventD2Ev,__ZN11UnityEngine7Connect15DeviceInfoEventD0Ev,__ZN11UnityEngine7Connect14AppUpdateEventD0Ev,__ZN11UnityEngine7Connect13AppStartEventD0Ev,__ZN18UnityConnectClientD2Ev,__ZN18UnityConnectClientD0Ev,__ZThn680_N18UnityConnectClientD1Ev,__ZThn680_N18UnityConnectClientD0Ev,__ZN11UnityEngine7Connect20BasePersistentValuesD2Ev,__ZN11UnityEngine7Connect20BasePersistentValuesD0Ev,__ZN11UnityEngine7Connect20BasePersistentValues5ResetEv,__ZN19UnityConnectServiceD2Ev,__ZN19UnityConnectServiceD0Ev,__ZN20UnityConnectSettingsD2Ev,__ZN20UnityConnectSettingsD0Ev,__ZN20UnityConnectSettings16CheckConsistencyEv,__ZN20UnityConnectSettings5ResetEv,__ZN16UnityAdsSettingsD2Ev,__ZN16UnityAdsSettingsD0Ev,__ZN16UnityAdsSettings5ResetEv
,__ZN19BaseConnectSettings15ThreadedCleanupEv,__ZN22UnityAnalyticsSettingsD2Ev,__ZN22UnityAnalyticsSettingsD0Ev,__ZN22UnityAnalyticsSettings5ResetEv,__ZN22CrashReportingSettingsD2Ev,__ZN22CrashReportingSettingsD0Ev,__ZN22CrashReportingSettings5ResetEv,__ZN11UnityEngine7Connect16PersistentValuesD0Ev,__ZN11UnityEngine7Connect16PersistentValues5ResetEv,__ZN19BaseConnectSettingsD2Ev,__ZN23UnityPurchasingSettingsD0Ev,__ZN23UnityPurchasingSettings5ResetEv,__ZN19BaseConnectSettingsD0Ev,__ZN19BaseConnectSettings5ResetEv,__ZN9IVRDeviceD2Ev,__ZN8VRDeviceD0Ev,__ZN8VRDevice8ShutdownEv,__ZN8VRDevice19CleanupGfxResourcesEv,__ZN8VRDevice29ApplyExpensiveQualitySettingsEv,__ZN8VRDevice15BeforeRenderingEv,__ZN8VRDevice6UpdateEv,__ZN8VRDevice11FixedUpdateEv,__ZN8VRDevice19RenderOcclusionMeshEv,__ZN8VRDevice14AfterRenderingEv,__ZN8VRDevice11PostPresentEv,__ZN8VRDevice20CreateVRSplashScreenEv,__ZNK8VRDevice20ResetCompositorLayerEv,__ZN14VRSplashScreenD2Ev,__ZN14VRSplashScreenD0Ev,__ZN11UnityEngine15CloudWebService17CloudJobSchedulerD2Ev
,__ZN11UnityEngine15CloudWebService17CloudJobSchedulerD0Ev,__ZN23CloudWebServicesManagerD2Ev,__ZN23CloudWebServicesManagerD0Ev,__ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev,__ZN11UnityEngine15CloudWebService14DataDispatcherD0Ev,__ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD1Ev,__ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD0Ev,__ZN11UnityEngine15CloudWebService13WWWRestClient7CleanupEv,__ZN11UnityEngine15CloudWebService13WWWRestClient5AbortEv,__ZN11UnityEngine15CloudWebService13WWWRestClient17PlayerLoopHandlerEv,__ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev,__ZN11UnityEngine15CloudWebService13WWWRestClientD0Ev,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17PlayerLoopHandlerEv,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED2Ev,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED0Ev,__ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev,__ZN11UnityEngine15CloudWebService18RestFileDownloaderD0Ev,__ZN11UnityEngine15CloudWebService18RestFileDownloader17OnCompleteContentEv,__ZN11UnityEngine15CloudWebService18RestFileDownloader7OnAbortEv,__ZN11UnityEngine15CloudWebService14RestDownloader9ClearDoneEv,__ZN11UnityEngine15CloudWebService17CloudServiceEventD0Ev,__ZN11UnityEngine15CloudWebService14RestDownloaderD2Ev,__ZN11UnityEngine15CloudWebService14RestDownloaderD0Ev,__ZN11UnityEngine15CloudWebService14RestDownloader17OnCompleteContentEv,__ZN11UnityEngine15CloudWebService14RestDownloader7OnAbortEv,__ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED2Ev,__ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED0Ev,__ZN24EllipsoidParticleEmitterD2Ev,__ZN24EllipsoidParticleEmitterD0Ev,__ZN15ParticleEmitterD2Ev
,__ZN15ParticleEmitterD0Ev,__ZN19MeshParticleEmitterD2Ev,__ZN19MeshParticleEmitterD0Ev,__ZN19MeshParticleEmitter5ResetEv,__ZN16ParticleAnimatorD2Ev,__ZN16ParticleAnimatorD0Ev,__ZN16ParticleRendererD2Ev,__ZN16ParticleRendererD0Ev,__ZN16ParticleRenderer16CheckConsistencyEv,__ZN16ParticleRenderer5ResetEv,__ZN16ParticleRenderer19UpdateTransformInfoEv,__ZN16ParticleRenderer14UpdateRendererEv,__ZThn32_N16ParticleRendererD1Ev,__ZThn32_N16ParticleRendererD0Ev,__ZThn32_N16ParticleRenderer19UpdateTransformInfoEv,__ZN21WorldParticleColliderD2Ev,__ZN21WorldParticleColliderD0Ev,__ZN21WorldParticleCollider5ResetEv,__ZNSt8bad_castD2Ev,__ZNSt12experimental15fundamentals_v112bad_any_castD0Ev,__ZNSt3__28__c_nodeD2Ev,__ZNSt3__28__c_nodeD0Ev,__ZNSt16nested_exceptionD2Ev,__ZNSt16nested_exceptionD0Ev,__ZNSt3__212future_errorD2Ev,__ZNSt3__212future_errorD0Ev,__ZNSt3__217__assoc_sub_stateD2Ev,__ZNSt3__217__assoc_sub_stateD0Ev,__ZNSt3__217__assoc_sub_state16__on_zero_sharedEv,__ZNSt3__217__assoc_sub_state9__executeEv
,__ZNSt3__214error_categoryD2Ev,__ZNSt3__223__future_error_categoryD0Ev,__ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev,__ZNSt3__29basic_iosIcNS_11char_traitsIcEEED0Ev,__ZNSt3__28ios_baseD2Ev,__ZNSt3__28ios_baseD0Ev,__ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev,__ZNSt3__29basic_iosIwNS_11char_traitsIwEEED0Ev,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED0Ev,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED0Ev,__ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev,__ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev,__ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev,__ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev,__ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev,__ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev,__ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev
,__ZNSt3__28ios_base7failureD2Ev,__ZNSt3__28ios_base7failureD0Ev,__ZNSt3__219__iostream_categoryD0Ev,__ZNSt3__211__stdoutbufIwED0Ev,__ZNSt3__211__stdoutbufIcED0Ev,__ZNSt3__210__stdinbufIwED0Ev,__ZNSt3__210__stdinbufIcED0Ev,__ZNSt3__27collateIcED2Ev,__ZNSt3__27collateIcED0Ev,__ZNSt3__26locale5facet16__on_zero_sharedEv,__ZNSt3__27collateIwED2Ev,__ZNSt3__27collateIwED0Ev,__ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev
,__ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__210moneypunctIcLb0EED2Ev,__ZNSt3__210moneypunctIcLb0EED0Ev,__ZNSt3__210moneypunctIcLb1EED2Ev,__ZNSt3__210moneypunctIcLb1EED0Ev,__ZNSt3__210moneypunctIwLb0EED2Ev,__ZNSt3__210moneypunctIwLb0EED0Ev,__ZNSt3__210moneypunctIwLb1EED2Ev,__ZNSt3__210moneypunctIwLb1EED0Ev,__ZNSt3__217moneypunct_bynameIcLb0EED2Ev,__ZNSt3__217moneypunct_bynameIcLb0EED0Ev,__ZNSt3__217moneypunct_bynameIcLb1EED2Ev,__ZNSt3__217moneypunct_bynameIcLb1EED0Ev,__ZNSt3__217moneypunct_bynameIwLb0EED2Ev,__ZNSt3__217moneypunct_bynameIwLb0EED0Ev,__ZNSt3__217moneypunct_bynameIwLb1EED2Ev,__ZNSt3__217moneypunct_bynameIwLb1EED0Ev,__ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev,__ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev,__ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev,__ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev,__ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev
,__ZNSt3__28messagesIcED2Ev,__ZNSt3__28messagesIcED0Ev,__ZNSt3__28messagesIwED2Ev,__ZNSt3__28messagesIwED0Ev,__ZNSt3__26locale5facetD2Ev,__ZNSt3__216__narrow_to_utf8ILj32EED0Ev,__ZNSt3__217__widen_from_utf8ILj32EED0Ev,__ZNSt3__215messages_bynameIcED2Ev,__ZNSt3__215messages_bynameIcED0Ev,__ZNSt3__215messages_bynameIwED2Ev,__ZNSt3__215messages_bynameIwED0Ev,__ZNSt3__214codecvt_bynameIcc11__mbstate_tED2Ev,__ZNSt3__214codecvt_bynameIcc11__mbstate_tED0Ev,__ZNSt3__214codecvt_bynameIwc11__mbstate_tED2Ev,__ZNSt3__214codecvt_bynameIwc11__mbstate_tED0Ev,__ZNSt3__27codecvtIwc11__mbstate_tED2Ev,__ZNSt3__27codecvtIwc11__mbstate_tED0Ev,__ZNSt3__214codecvt_bynameIDsc11__mbstate_tED2Ev,__ZNSt3__214codecvt_bynameIDsc11__mbstate_tED0Ev,__ZNSt3__214codecvt_bynameIDic11__mbstate_tED2Ev,__ZNSt3__214codecvt_bynameIDic11__mbstate_tED0Ev,__ZNSt3__26locale5__impD2Ev,__ZNSt3__26locale5__impD0Ev,__ZNSt3__214collate_bynameIcED2Ev,__ZNSt3__214collate_bynameIcED0Ev,__ZNSt3__214collate_bynameIwED2Ev,__ZNSt3__214collate_bynameIwED0Ev,__ZNSt3__25ctypeIcED2Ev,__ZNSt3__25ctypeIcED0Ev,__ZNSt3__212ctype_bynameIcED2Ev
,__ZNSt3__212ctype_bynameIcED0Ev,__ZNSt3__212ctype_bynameIwED2Ev,__ZNSt3__212ctype_bynameIwED0Ev,__ZNSt3__28numpunctIcED2Ev,__ZNSt3__28numpunctIcED0Ev,__ZNSt3__28numpunctIwED2Ev,__ZNSt3__28numpunctIwED0Ev,__ZNSt3__215numpunct_bynameIcED0Ev,__ZNSt3__215numpunct_bynameIwED0Ev,__ZNSt3__26locale5facetD0Ev,__ZNSt3__25ctypeIwED0Ev,__ZNSt3__27codecvtIcc11__mbstate_tED0Ev,__ZNSt3__27codecvtIDsc11__mbstate_tED0Ev,__ZNSt3__27codecvtIDic11__mbstate_tED0Ev,__ZNSt3__216__narrow_to_utf8ILj16EED0Ev,__ZNSt3__217__widen_from_utf8ILj16EED0Ev,__ZNSt3__214__codecvt_utf8IwED0Ev,__ZNSt3__214__codecvt_utf8IDsED0Ev,__ZNSt3__214__codecvt_utf8IDiED0Ev,__ZNSt3__215__codecvt_utf16IwLb0EED0Ev,__ZNSt3__215__codecvt_utf16IwLb1EED0Ev,__ZNSt3__215__codecvt_utf16IDsLb0EED0Ev,__ZNSt3__215__codecvt_utf16IDsLb1EED0Ev,__ZNSt3__215__codecvt_utf16IDiLb0EED0Ev,__ZNSt3__215__codecvt_utf16IDiLb1EED0Ev,__ZNSt3__220__codecvt_utf8_utf16IwED0Ev,__ZNSt3__220__codecvt_utf8_utf16IDiED0Ev,__ZNSt3__220__codecvt_utf8_utf16IDsED0Ev,__ZNSt3__215__time_get_tempIcED0Ev,__ZNSt3__215__time_get_tempIwED0Ev
,__ZNSt3__214__shared_countD2Ev,__ZNSt3__214__shared_countD0Ev,__ZNSt3__219__shared_weak_countD0Ev,__ZNSt3__212bad_weak_ptrD2Ev,__ZNSt3__212bad_weak_ptrD0Ev,__ZNSt12experimental19bad_optional_accessD2Ev,__ZNSt12experimental19bad_optional_accessD0Ev,__ZNSt3__211regex_errorD2Ev,__ZNSt3__211regex_errorD0Ev,__ZNSt3__212strstreambufD2Ev,__ZNSt3__212strstreambufD0Ev,__ZNSt3__210istrstreamD1Ev,__ZNSt3__210istrstreamD0Ev,__ZTv0_n12_NSt3__210istrstreamD1Ev,__ZTv0_n12_NSt3__210istrstreamD0Ev,__ZNSt3__210ostrstreamD1Ev,__ZNSt3__210ostrstreamD0Ev,__ZTv0_n12_NSt3__210ostrstreamD1Ev,__ZTv0_n12_NSt3__210ostrstreamD0Ev,__ZNSt3__29strstreamD1Ev,__ZNSt3__29strstreamD0Ev,__ZThn8_NSt3__29strstreamD1Ev,__ZThn8_NSt3__29strstreamD0Ev,__ZTv0_n12_NSt3__29strstreamD1Ev,__ZTv0_n12_NSt3__29strstreamD0Ev,__ZNSt3__214error_categoryD0Ev,__ZNSt3__212system_errorD2Ev,__ZNSt3__212system_errorD0Ev,__ZNSt3__212__do_messageD0Ev,__ZNSt3__224__generic_error_categoryD0Ev
,__ZNSt3__223__system_error_categoryD0Ev,__ZN10__cxxabiv116__shim_type_infoD2Ev,__ZN10__cxxabiv117__class_type_infoD0Ev,__ZNK10__cxxabiv116__shim_type_info5noop1Ev,__ZNK10__cxxabiv116__shim_type_info5noop2Ev,__ZN10__cxxabiv120__si_class_type_infoD0Ev,__ZNSt9bad_allocD2Ev,__ZNSt9bad_allocD0Ev,__ZNSt20bad_array_new_lengthD0Ev,__ZNSt16bad_array_lengthD0Ev,__ZNSt9exceptionD2Ev,__ZNSt9exceptionD0Ev,__ZNSt13bad_exceptionD0Ev,__ZNSt11logic_errorD2Ev,__ZNSt11logic_errorD0Ev,__ZNSt13runtime_errorD2Ev,__ZNSt13runtime_errorD0Ev,__ZNSt12domain_errorD0Ev,__ZNSt16invalid_argumentD0Ev,__ZNSt12length_errorD0Ev,__ZNSt12out_of_rangeD0Ev,__ZNSt11range_errorD0Ev,__ZNSt14overflow_errorD0Ev,__ZNSt15underflow_errorD0Ev,__ZNSt8bad_castD0Ev,__ZNSt10bad_typeidD2Ev,__ZNSt10bad_typeidD0Ev,__ZNSt9type_infoD2Ev,__ZNSt9type_infoD0Ev,__ZN10__cxxabiv116__shim_type_infoD0Ev
,__ZN10__cxxabiv123__fundamental_type_infoD0Ev,__ZN10__cxxabiv119__pointer_type_infoD0Ev,__ZN10__cxxabiv117__array_type_infoD0Ev,__ZN10__cxxabiv120__function_type_infoD0Ev,__ZN10__cxxabiv116__enum_type_infoD0Ev,__ZN10__cxxabiv121__vmi_class_type_infoD0Ev,__ZN10__cxxabiv117__pbase_type_infoD0Ev,__ZN10__cxxabiv129__pointer_to_member_type_infoD0Ev,_UNITY_png_default_flush,_realize_virt_arrays,_self_destruct,_write_file_header,_write_frame_header,_write_scan_header,_write_file_trailer,_write_tables_only,_prepare_for_pass,_pass_startup,_finish_pass_master,_null_method,_rgb_ycc_start,_start_pass_downsample,_start_pass_fdctmgr,_jsimd_fdct_islow,_jpeg_fdct_islow,_jsimd_fdct_ifast,_jpeg_fdct_ifast,_finish_pass_gather,_finish_pass_huff,_reset_marker_reader
,_reset_input_controller,_start_input_pass_28,_finish_input_pass,_prepare_for_output_pass,_finish_output_pass,_start_pass_dcolor,_start_pass_upsample,_start_pass,_start_pass_phuff_decoder,_start_pass_huff_decoder,_start_input_pass,_start_output_pass,_init_destination,_term_destination,_init_mem_destination,_term_mem_destination,_init_source,_term_source,_init_mem_source,_error_exit,_output_message,_reset_error_mgr,__ZN12_GLOBAL__N_116StaticInitializeEPv,__ZN12_GLOBAL__N_113StaticDestroyEPv,__ZN21SystemInfoStringCache16StaticInitializeEPv,__ZN21SystemInfoStringCache13StaticDestroyEPv,__Z17MainLoopKeepalivePv,__ZN13RuntimeStaticI12AdsIdHandlerE16StaticInitializeEPv,__ZN13RuntimeStaticI12AdsIdHandlerE13StaticDestroyEPv,__ZN13RuntimeStaticI15ApplicationInfoE16StaticInitializeEPv
,__ZN13RuntimeStaticI15ApplicationInfoE13StaticDestroyEPv,__ZN12AdsIdHandler37ExecuteOnMainThreadAdsIdJobDoneStaticEPv,__ZN12AdsIdHandler31ExecuteAsyncFetchAdsIdJobStaticEPv,__ZN13RuntimeStaticI18AssetBundleManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI18AssetBundleManagerE13StaticDestroyEPv,__ZN13RuntimeStaticI18BackgroundJobQueueE13StaticDestroyEPv,__ZN38AssetBundleLoadFromCacheAsyncOperation20LoadCachedArchiveJobEPv,__ZN37AssetBundleLoadFromFileAsyncOperation14LoadArchiveJobEPv,__ZN37AssetBundleLoadFromFileAsyncOperation17ConvertArchiveJobEPv,__ZN39AssetBundleLoadFromMemoryAsyncOperation11FinalizeJobEPv,__ZN17BaseObjectManager16StaticInitializeEPv,__ZN17BaseObjectManager13StaticDestroyEPv,__ZN13RuntimeStaticI12EventManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI12EventManagerE13StaticDestroyEPv,__ZN17MessageIdentifier16StaticInitializeEPv,__ZN17MessageIdentifier13StaticDestroyEPv,__ZN13RuntimeStaticI12FlareManagerE13StaticDestroyEPv,__ZL25CleanupImageFilterGlobalsPv,__ZN24MeshIntermediateRenderer16StaticInitializeEPv,__ZN24MeshIntermediateRenderer13StaticDestroyEPv,__ZN31CanvasBatchIntermediateRenderer16StaticInitializeEPv,__ZN31CanvasBatchIntermediateRenderer13StaticDestroyEPv,__ZL16PresizeOutputJobP25ScheduleSceneNodesJobData,__ZL27PrepareSceneNodesJobCombineP25ScheduleSceneNodesJobData,__ZN11HaloManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData,__ZN12FlareManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData,__ZN12FlareManager9UpdateJobEP25FlareManagerUpdateJobData,__ZL45FrustumAndOcculusionCullLocalLightsCombineJobP21LocalLightCullJobData,__ZN13RuntimeStaticI13RendererSceneE16StaticInitializeEPv,__ZN13RuntimeStaticI13RendererSceneE13StaticDestroyEPv
,__ZL14CleanupShadowsPv,__ZL20CopyNodesIntoJobGapsP29RenderNodeQueuePrepareContext,__ZL35PrepareRenderNodesQueueToMainThreadR35RenderNodeQueuePrepareThreadContext,__ZL40PrepareRenderNodesOnMainThreadDeprecatedR35RenderNodeQueuePrepareThreadContext,__ZL26CullDynamicSceneCombineJobP14CullingJobData,__ZL31QueryPortalVisibilityCombineJobP28QueryPortalVisibilityJobData,__ZL54CombineLocalShadowCasterCullignIndexListsAndDestroyJobP25LocalShadowCullingJobData,__Z37GenerateCombinedDynamicVisibleListJobP11CullResults,__Z21CreateShadowCullerJobP30CreateUmbraShadowCullerJobData,__ZL60CombineDirectionalShadowCasterCullignIndexListsAndDestroyJobP20ShadowCullingJobData,__ZL20PrepareShadowMapsJobP18ShadowMapJobHeader,__ZN19CullingGroupManager15InitializeClassEPv,__ZN19CullingGroupManager12CleanupClassEPv,__ZL10CleanUpJobP20CullingGroupsJobData,__ZL32CullAllPerObjectLightsCombineJobP29CullAllPerObjectLightsJobData,__ZL24CleanupPrepassRenderLoopPv,__ZN14qsort_internal18QSortSingleJobDataIP16RenderObjectDatai26RenderDeferredObjectSorterE7SortJobEPS4_,__ZL24CollectForwardObjectsJobP27CollectForwardObjectsHeader,__ZL24AssignProjectorQueuesJobP30AssignProjectorQueuesJobHeader,__ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEE7SortJobEPS6_,__ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEE7SortJobEPS6_,__ZN14qsort_internal18QSortSingleJobDataIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEE7SortJobEPS5_,__ZN14qsort_internal18QSortSingleJobDataIP17RODataReplacementi19ROSorterReplacementE7SortJobEPS4_,__ZN14qsort_internal18QSortSingleJobDataIP15RODataDepthPassi17ROSorterDepthPassE7SortJobEPS4_,__ZN17CommonStringTable16StaticInitializeEPv,__ZN17CommonStringTable13StaticCleanupEPv,__ZN14DirectorPlayer14OnProcessStageERK13dynamic_arrayI11DirectorJobLj8EE,__Z30CleanupDynamicBatchGeometryJobP25DynamicVBOGeometryJobData,__ZN18AsyncUploadManager16StaticInitializeEPv,__ZN18AsyncUploadManager13StaticDestroyEPv
,__ZN18AsyncUploadManager17DoScaledPaddedJobEP28FileTextureUploadInstruction,__ZN18AsyncUploadManager15DoDeCruncherJobEP28FileTextureUploadInstruction,_UNITY_png_set_swap_alpha,_UNITY_png_set_bgr,_UNITY_png_set_strip_16,_UNITY_png_set_packing,_UNITY_png_set_expand,_UNITY_png_set_gray_to_rgb,__ZdaPv,__ZN11JpegDecoder9ErrorExitEP18jpeg_common_struct,_jpeg_destroy_decompress,__ZdlPv,__ZL11init_sourceP22jpeg_decompress_struct,__ZL11term_sourceP22jpeg_decompress_struct,__ZL50StaticRegisterSceneLoadedCallback_LightmapSettingsPv,__ZL52StaticUnregisterSceneLoadedCallback_LightmapSettingsPv,__ZL14DidUnloadScenei,__ZL17PngWriteFlushFuncP14png_struct_def,__ZL20dst_init_destinationP20jpeg_compress_struct,__ZL16term_destinationP20jpeg_compress_struct,__ZN12LineRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData,__ZN13TrailRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData,__ZL8BatchJobP18BatchJobDataSingle,__ZN21BillboardBatchManager24BillboardBatchFreeMemJobEP25DynamicVBOGeometryJobData,__ZN21BillboardBatchManager16StaticInitializeEPv,__ZN21BillboardBatchManager13StaticCleanupEPv,__Z25InitializeLODGroupManagerPv,__Z22CleanupLODGroupManagerPv,__ZN13RuntimeStaticI17UniqueIDGeneratorE16StaticInitializeEPv,__ZN13RuntimeStaticI17UniqueIDGeneratorE13StaticDestroyEPv
,__ZL22PrepareMeshRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext,__ZL22PrepareMeshRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext,__Z20DeformSkinnedMeshJobP12SkinMeshInfo,__ZN14SpriteRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData,__ZN13RuntimeStaticI23MeshVertexFormatManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI23MeshVertexFormatManagerE13StaticDestroyEPv,__ZL24PrepareSpriteRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext,__ZL24PrepareSpriteRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext,__ZN13RuntimeStaticI15GUIEventManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI15GUIEventManagerE13StaticDestroyEPv,__ZN13RuntimeStaticI22VirtualJoystickManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI22VirtualJoystickManagerE13StaticDestroyEPv,__ZL12InbetweenJobP16InbetweenJobData,__ZN20FloatToHalfConverter26InitializePrecomputeTablesEPv,__ZN13RuntimeStaticI21AssetReferenceStorageE16StaticInitializeEPv,__ZN13RuntimeStaticI21AssetReferenceStorageE13StaticDestroyEPv,__ZN21ComponentRequirements16StaticInitializeEPv,__ZN21ComponentRequirements13StaticDestroyEPv,__ZN21AssetReferenceStorage22GarbageCollectCallbackER27GarbageCollectorThreadState,__ZN13RuntimeStaticI19UnityPluginRegistryE16StaticInitializeEPv,__ZN13RuntimeStaticI19UnityPluginRegistryE13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE13StaticDestroyEPv,__ZN22BuiltinResourceManager16StaticInitializeEPv,__ZN22BuiltinResourceManager13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE16StaticInitializeES8_,__ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE13StaticDestroyES8_,__ZN13RuntimeStaticI13ModuleManagerE13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE13StaticDestroyEPv
,__ZL32StaticInitializeIUnityInterfacesPv,__ZL29StaticCleanupIUnityInterfacesPv,__ZL30StaticInitializeIUnityGraphicsPv,__Z31RegisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE,__Z33UnregisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE,__ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE16StaticInitializeEPv,__ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE13StaticDestroyEPv,__ZN19GCProfilerCallbacksL12OnGCShutdownEPv,__ZN18ProfilerConnection23HandleConnectionMessageEj,__ZL35StaticInitializeRuntimeSceneManagerPv,__ZL32StaticDestroyRuntimeSceneManagerPv,__ZL32MarkLevelGameManagerDependenciesR27GarbageCollectorThreadState,__ZL16SceneWasUnloadedi,__ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE16StaticInitializeES5_,__ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE13StaticDestroyES5_,__ZL30InitializeGlobalNameConversionPv,__ZL27CleanupGlobalNameConversionPv,__ZN13RuntimeStaticI12GraphicsCapsE16StaticInitializeEPv,__ZN13RuntimeStaticI12GraphicsCapsE13StaticDestroyEPv,__ZL22StaticInitializeShaderPv,__ZL19StaticDestroyShaderPv,__ZN9ShaderLab19CommonPropertyNames16StaticInitializeEPv,__ZN9ShaderLab19CommonPropertyNames13StaticCleanupEPv,__ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE13StaticDestroyEPv,__ZN9ShaderLabL25StaticInitializeShaderLabEPv,__ZN9ShaderLabL22StaticDestroyShaderLabEPv,__ZL30InitializeSpeedTreeWindManagerPv,__ZL27DestroySpeedTreeWindManagerPv,__ZN13RuntimeStaticI11WindManagerE16StaticInitializeEPv
,__ZN13RuntimeStaticI11WindManagerE13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE13StaticDestroyEPv,__ZN10MemoryPool16StaticInitializeEPv,__ZN10MemoryPool13StaticDestroyEPv,__ZN10FileSystem16StaticInitializeEPv,__ZN10FileSystem13StaticDestroyEPv,__Z42Application_Set_Custom_PropRunInBackgroundh,__Z36Application_CUSTOM_DontDestroyOnLoadP12Il2CppObject,__Z40Application_CUSTOM_Internal_ExternalCallP12Il2CppString,__Z26Application_CUSTOM_OpenURLP12Il2CppString,__Z29Application_CUSTOM_ForceCrashi,__Z42Application_Set_Custom_PropTargetFrameRatei,__Z40Application_CUSTOM_SetLogCallbackDefinedh,__Z44Application_Set_Custom_PropStackTraceLogTypei,__Z52Application_Set_Custom_PropBackgroundLoadingPriority14ThreadPriority,__Z58AssetBundleCreateRequest_CUSTOM_DisableCompatibilityChecksP12Il2CppObject,__Z37AsyncOperation_CUSTOM_InternalDestroyP12Il2CppObject,__Z33Coroutine_CUSTOM_ReleaseCoroutineP12Il2CppObject,__Z55ScriptableObject_CUSTOM_Internal_CreateScriptableObjectP12Il2CppObject,__Z37BillboardAsset_CUSTOM_Internal_CreateP12Il2CppObject,__Z38Caching_Set_Custom_PropExpirationDelayi,__Z30Caching_Set_Custom_PropEnabledh,__Z41Caching_Set_Custom_PropCompressionEnabledh,__Z52Camera_CUSTOM_INTERNAL_CALL_ResetWorldToCameraMatrixP12Il2CppObject,__Z49Camera_CUSTOM_INTERNAL_CALL_ResetProjectionMatrixP12Il2CppObject,__Z39Camera_CUSTOM_INTERNAL_CALL_ResetAspectP12Il2CppObject,__Z44Camera_CUSTOM_INTERNAL_CALL_ResetFieldOfViewP12Il2CppObject,__Z37Camera_CUSTOM_ResetStereoViewMatricesP12Il2CppObject,__Z43Camera_CUSTOM_ResetStereoProjectionMatricesP12Il2CppObject
,__Z20Camera_CUSTOM_RenderP12Il2CppObject,__Z50Camera_CUSTOM_INTERNAL_CALL_ResetReplacementShaderP12Il2CppObject,__Z46Camera_CUSTOM_INTERNAL_CALL_ResetCullingMatrixP12Il2CppObject,__Z31Camera_CUSTOM_RenderDontRestoreP12Il2CppObject,__Z26Camera_CUSTOM_SetupCurrentP12Il2CppObject,__Z37Camera_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject,__Z34ComputeBuffer_CUSTOM_DestroyBufferP12Il2CppObject,__Z27CullingGroup_CUSTOM_DisposeP12Il2CppObject,__Z24CullingGroup_CUSTOM_InitP12Il2CppObject,__Z36CullingGroup_CUSTOM_FinalizerFailureP12Il2CppObject,__Z29Cursor_Set_Custom_PropVisibleh,__Z31Cursor_Set_Custom_PropLockState14CursorLockMode,__Z44Debug_Set_Custom_PropDeveloperConsoleVisibleh,__Z34Debug_CUSTOM_GetDiagnosticSwitchesP12Il2CppObject,__Z26DirectorPlayer_CUSTOM_StopP12Il2CppObject,__Z43DynamicGI_CUSTOM_UpdateMaterialsForRendererP12Il2CppObject,__Z40DynamicGI_Set_Custom_PropSynchronousModeh,__Z43GIDebugVisualisation_Set_Custom_PropTexType13GITextureType,__Z46GIDebugVisualisation_CUSTOM_CycleSkipInstancesi,__Z44GIDebugVisualisation_CUSTOM_CycleSkipSystemsi,__Z22RectOffset_CUSTOM_InitP12Il2CppObject,__Z25RectOffset_CUSTOM_CleanupP12Il2CppObject,__Z32Gizmos_CUSTOM_INTERNAL_get_colorP10ColorRGBAf,__Z32Gizmos_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf,__Z33Gizmos_CUSTOM_INTERNAL_get_matrixP10Matrix4x4f,__Z33Gizmos_CUSTOM_INTERNAL_set_matrixRK10Matrix4x4f,__Z20Gradient_CUSTOM_InitP12Il2CppObject,__Z23Gradient_CUSTOM_CleanupP12Il2CppObject,__Z33RenderSettings_Set_Custom_PropFogh,__Z37RenderSettings_Set_Custom_PropFogMode7FogMode
,__Z43RenderSettings_CUSTOM_INTERNAL_get_fogColorP10ColorRGBAf,__Z43RenderSettings_CUSTOM_INTERNAL_set_fogColorRK10ColorRGBAf,__Z41RenderSettings_Set_Custom_PropAmbientModeN14RenderSettings11AmbientModeE,__Z50RenderSettings_CUSTOM_INTERNAL_get_ambientSkyColorP10ColorRGBAf,__Z50RenderSettings_CUSTOM_INTERNAL_set_ambientSkyColorRK10ColorRGBAf,__Z54RenderSettings_CUSTOM_INTERNAL_get_ambientEquatorColorP10ColorRGBAf,__Z54RenderSettings_CUSTOM_INTERNAL_set_ambientEquatorColorRK10ColorRGBAf,__Z53RenderSettings_CUSTOM_INTERNAL_get_ambientGroundColorP10ColorRGBAf,__Z53RenderSettings_CUSTOM_INTERNAL_set_ambientGroundColorRK10ColorRGBAf,__Z47RenderSettings_CUSTOM_INTERNAL_get_ambientLightP10ColorRGBAf,__Z47RenderSettings_CUSTOM_INTERNAL_set_ambientLightRK10ColorRGBAf,__Z47RenderSettings_CUSTOM_INTERNAL_get_ambientProbeP20SphericalHarmonicsL2,__Z47RenderSettings_CUSTOM_INTERNAL_set_ambientProbeRK20SphericalHarmonicsL2,__Z47RenderSettings_Set_Custom_PropReflectionBouncesi,__Z36RenderSettings_Set_Custom_PropSkyboxP12Il2CppObject,__Z33RenderSettings_Set_Custom_PropSunP12Il2CppObject,__Z51RenderSettings_Set_Custom_PropDefaultReflectionModeN14RenderSettings21DefaultReflectionModeE,__Z57RenderSettings_Set_Custom_PropDefaultReflectionResolutioni,__Z46RenderSettings_Set_Custom_PropCustomReflectionP12Il2CppObject,__Z43QualitySettings_Set_Custom_PropCurrentLeveli,__Z36QualitySettings_CUSTOM_IncreaseLevelh,__Z36QualitySettings_CUSTOM_DecreaseLevelh,__Z46QualitySettings_Set_Custom_PropPixelLightCounti,__Z38QualitySettings_Set_Custom_PropShadowsN15QualitySettings13ShadowQualityE,__Z47QualitySettings_Set_Custom_PropShadowProjection16ShadowProjection,__Z45QualitySettings_Set_Custom_PropShadowCascadesi,__Z47QualitySettings_Set_Custom_PropShadowResolutionN15QualitySettings16ShadowResolutionE,__Z55QualitySettings_CUSTOM_INTERNAL_get_shadowCascade4SplitP8Vector3f,__Z55QualitySettings_CUSTOM_INTERNAL_set_shadowCascade4SplitRK8Vector3f,__Z49QualitySettings_Set_Custom_PropMasterTextureLimiti
,__Z51QualitySettings_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE,__Z46QualitySettings_Set_Custom_PropMaximumLODLeveli,__Z52QualitySettings_Set_Custom_PropParticleRaycastBudgeti,__Z44QualitySettings_Set_Custom_PropSoftParticlesh,__Z45QualitySettings_Set_Custom_PropSoftVegetationh,__Z55QualitySettings_Set_Custom_PropRealtimeReflectionProbesh,__Z59QualitySettings_Set_Custom_PropBillboardsFaceCameraPositionh,__Z46QualitySettings_Set_Custom_PropMaxQueuedFramesi,__Z41QualitySettings_Set_Custom_PropVSyncCounti,__Z43QualitySettings_Set_Custom_PropAntiAliasingi,__Z43QualitySettings_Set_Custom_PropBlendWeightsi,__Z51QualitySettings_Set_Custom_PropAsyncUploadTimeSlicei,__Z52QualitySettings_Set_Custom_PropAsyncUploadBufferSizei,__Z26TrailRenderer_CUSTOM_ClearP12Il2CppObject,__Z38MaterialPropertyBlock_CUSTOM_InitBlockP12Il2CppObject,__Z41MaterialPropertyBlock_CUSTOM_DestroyBlockP12Il2CppObject,__Z34MaterialPropertyBlock_CUSTOM_ClearP12Il2CppObject,__Z27Graphics_CUSTOM_DrawTextureR32MonoInternalDrawTextureArguments,__Z36Graphics_CUSTOM_ExecuteCommandBufferP12Il2CppObject,__Z36Graphics_CUSTOM_GetActiveColorBufferP21ScriptingRenderBuffer,__Z36Graphics_CUSTOM_GetActiveDepthBufferP21ScriptingRenderBuffer,__Z34Graphics_Set_Custom_PropActiveTier12GraphicsTier,__Z33Graphics_CUSTOM_SetupVertexLightsP11Il2CppArray,__Z41LightmapSettings_Set_Custom_PropLightmapsP11Il2CppArray,__Z51LightmapSettings_Set_Custom_PropLightmapsModeLegacyi,__Z45LightmapSettings_Set_Custom_PropLightmapsModei,__Z43LightmapSettings_Set_Custom_PropLightProbesP12Il2CppObject,__Z39Screen_Get_Custom_PropCurrentResolutionv,__Z32Screen_Set_Custom_PropFullScreenh,__Z42Screen_Set_Custom_PropAutorotateToPortraith
,__Z52Screen_Set_Custom_PropAutorotateToPortraitUpsideDownh,__Z47Screen_Set_Custom_PropAutorotateToLandscapeLefth,__Z48Screen_Set_Custom_PropAutorotateToLandscapeRighth,__Z33Screen_Set_Custom_PropOrientation17ScreenOrientation,__Z34Screen_Set_Custom_PropSleepTimeouti,__Z30GL_CUSTOM_INTERNAL_CALL_VertexRK8Vector3f,__Z29GL_CUSTOM_INTERNAL_CALL_ColorRK10ColorRGBAf,__Z32GL_CUSTOM_INTERNAL_CALL_TexCoordRK8Vector3f,__Z23GL_CUSTOM_BeginInternali,__Z32GL_CUSTOM_INTERNAL_CALL_ViewportRK5RectTIfE,__Z44GL_CUSTOM_INTERNAL_CALL_LoadProjectionMatrixRK10Matrix4x4f,__Z32GL_CUSTOM_INTERNAL_get_modelviewP10Matrix4x4f,__Z32GL_CUSTOM_INTERNAL_set_modelviewRK10Matrix4x4f,__Z34GL_CUSTOM_INTERNAL_CALL_MultMatrixRK10Matrix4x4f,__Z27GL_Set_Custom_PropWireframeh,__Z27GL_Set_Custom_PropSRGBWriteh,__Z31GL_Set_Custom_PropInvertCullingh,__Z29GL_CUSTOM_SetRevertBackfacingh,__Z26GL_CUSTOM_IssuePluginEventi,__Z27LocationService_CUSTOM_StopP12Il2CppObject,__Z38Input_Set_Custom_PropCompensateSensorsh,__Z39Input_CUSTOM_INTERNAL_get_mousePositionP8Vector3f,__Z42Input_CUSTOM_INTERNAL_get_mouseScrollDeltaP13Vector2fIcall,__Z45Input_Set_Custom_PropSimulateMouseWithTouchesh,__Z38Input_CUSTOM_INTERNAL_get_accelerationP8Vector3f,__Z48Input_Set_Custom_PropEatKeyPressOnTextFieldFocush,__Z38Input_Set_Custom_PropMultiTouchEnabledh,__Z39Input_Set_Custom_PropImeCompositionModei,__Z46Input_CUSTOM_INTERNAL_get_compositionCursorPosP13Vector2fIcall,__Z46Input_CUSTOM_INTERNAL_set_compositionCursorPosRK13Vector2fIcall
,__Z40Input_Set_Custom_PropBackButtonLeavesApph,__Z33LODGroup_CUSTOM_RecalculateBoundsP12Il2CppObject,__Z36Light_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject,__Z36Light_Set_Custom_PropPixelLightCounti,__Z35LightProbeProxyVolume_CUSTOM_UpdateP12Il2CppObject,__Z29AnimationCurve_CUSTOM_CleanupP12Il2CppObject,__Z27Mesh_CUSTOM_Internal_CreateP12Il2CppObject,__Z46Mesh_CUSTOM_PrintErrorCantAccessMeshForIndicesP12Il2CppObject,__Z46Mesh_CUSTOM_PrintErrorBadSubmeshIndexTrianglesP12Il2CppObject,__Z44Mesh_CUSTOM_PrintErrorBadSubmeshIndexIndicesP12Il2CppObject,__Z28Mesh_CUSTOM_ClearBlendShapesP12Il2CppObject,__Z29Mesh_CUSTOM_RecalculateBoundsP12Il2CppObject,__Z30Mesh_CUSTOM_RecalculateNormalsP12Il2CppObject,__Z20Mesh_CUSTOM_OptimizeP12Il2CppObject,__Z23Mesh_CUSTOM_MarkDynamicP12Il2CppObject,__Z45MonoBehaviour_CUSTOM_Internal_CancelInvokeAllP12Il2CppObject,__Z38MonoBehaviour_CUSTOM_StopAllCoroutinesP12Il2CppObject,__Z42GenericMixerPlayable_CUSTOM_InternalCreateR9HPlayable,__Z46Playables_CUSTOM_INTERNAL_CALL_InternalDestroyR9HPlayable,__Z28PlayerPrefs_CUSTOM_DeleteKeyP12Il2CppString,__Z31Profiler_Set_Custom_PropLogFileP12Il2CppString,__Z39Profiler_Set_Custom_PropEnableBinaryLogh,__Z31Profiler_Set_Custom_PropEnabledh,__Z33Profiler_CUSTOM_AddFramesFromFileP12Il2CppString,__Z31Profiler_CUSTOM_BeginSampleOnlyP12Il2CppString,__Z50Profiler_Set_Custom_PropMaxNumberOfSamplesPerFramei,__Z34Profiler_CUSTOM_SetSamplersEnabledh,__Z26Random_Set_Custom_PropSeedi,__Z23Random_CUSTOM_InitStatei,__Z32Random_CUSTOM_INTERNAL_get_stateP9RandState
,__Z32Random_CUSTOM_INTERNAL_set_stateRK9RandState,__Z43Random_CUSTOM_INTERNAL_get_insideUnitSphereP8Vector3f,__Z33Random_CUSTOM_GetRandomUnitCircleP13Vector2fIcall,__Z39Random_CUSTOM_INTERNAL_get_onUnitSphereP8Vector3f,__Z35Random_CUSTOM_INTERNAL_get_rotationP11Quaternionf,__Z42Random_CUSTOM_INTERNAL_get_rotationUniformP11Quaternionf,__Z31CommandBuffer_CUSTOM_InitBufferP12Il2CppObject,__Z34CommandBuffer_CUSTOM_ReleaseBufferP12Il2CppObject,__Z26CommandBuffer_CUSTOM_ClearP12Il2CppObject,__Z28Resources_CUSTOM_UnloadAssetP12Il2CppObject,__Z48SceneManager_CUSTOM_INTERNAL_CALL_GetActiveSceneRi,__Z27Shader_CUSTOM_EnableKeywordP12Il2CppString,__Z28Shader_CUSTOM_DisableKeywordP12Il2CppString,__Z38Shader_Set_Custom_PropGlobalMaximumLODi,__Z46ShaderVariantCollection_CUSTOM_Internal_CreateP12Il2CppObject,__Z36ShaderVariantCollection_CUSTOM_ClearP12Il2CppObject,__Z37ShaderVariantCollection_CUSTOM_WarmUpP12Il2CppObject,__Z55SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_ClearInternalR20SphericalHarmonicsL2,__Z41Texture_Set_Custom_PropMasterTextureLimiti,__Z43Texture_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE,__Z49RenderTexture_CUSTOM_Internal_CreateRenderTextureP12Il2CppObject,__Z37RenderTexture_CUSTOM_ReleaseTemporaryP12Il2CppObject,__Z42RenderTexture_CUSTOM_INTERNAL_CALL_ReleaseP12Il2CppObject,__Z50RenderTexture_CUSTOM_INTERNAL_CALL_DiscardContentsP12Il2CppObject,__Z54RenderTexture_CUSTOM_INTERNAL_CALL_MarkRestoreExpectedP12Il2CppObject,__Z47RenderTexture_CUSTOM_INTERNAL_CALL_GenerateMipsP12Il2CppObject,__Z35RenderTexture_Set_Custom_PropActiveP12Il2CppObject,__Z36RenderTexture_Set_Custom_PropEnabledh,__Z36Time_Set_Custom_PropCaptureFrameratei,__Z31Transform_CUSTOM_DetachChildrenP12Il2CppObject
,__Z34Transform_CUSTOM_SetAsFirstSiblingP12Il2CppObject,__Z33Transform_CUSTOM_SetAsLastSiblingP12Il2CppObject,__Z39Object_CUSTOM_EnsureRunningOnMainThreadP12Il2CppObject,__Z31Object_CUSTOM_DontDestroyOnLoadP12Il2CppObject,__Z43UnityLogWriter_CUSTOM_WriteStringToUnityLogP12Il2CppString,__Z62UnityEventQueueSystem_CUSTOM_INTERNAL_CALL_GetGlobalEventQueueRPv,__ZN13RuntimeStaticI15DirectorManagerE16StaticInitializeEPv,__ZN13RuntimeStaticI15DirectorManagerE13StaticDestroyEPv,__ZL22StaticInitializePlayerPv,__ZL19StaticCleanupPlayerPv,__ZL20sample_mono_shutdownPv,__ZN12_GLOBAL__N_138ArchiveRedirectFileSystemStaticDestroyEPv,__Z37AndroidJNIHelper_Set_Custom_PropDebugh,__Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ExceptionOccurredRPv,__Z28AndroidJNI_CUSTOM_FatalErrorP12Il2CppString,__Z33AndroidJNI_CUSTOM_DeleteGlobalRef13Il2Cpp_IntPtr,__Z32AndroidJNI_CUSTOM_DeleteLocalRef13Il2Cpp_IntPtr,__Z49WebGLInput_Set_Custom_PropCaptureAllKeyboardInputh,_glActiveTexture__wrapper,_glBlendEquation__wrapper,_glClear__wrapper,_glClearStencil__wrapper,_glCompileShader__wrapper,_glCullFace__wrapper,_glDeleteProgram__wrapper,_glDeleteShader__wrapper,_glDepthFunc__wrapper,_glDepthMask__wrapper,_glDisable__wrapper,_glDisableVertexAttribArray__wrapper,_glEnable__wrapper,_glEnableVertexAttribArray__wrapper,_glFrontFace__wrapper,_glGenerateMipmap__wrapper,_glValidateProgram__wrapper,_glLinkProgram__wrapper,_glStencilMask__wrapper,_glUseProgram__wrapper,_glEndQuery__wrapper,_glBindVertexArray__wrapper,_glBeginTransformFeedback__wrapper,_glReadBuffer__wrapper,_glDeleteSync__wrapper,__ZL28InitializeSparseTexturesGLESPv,__ZL25DestroySparseTexturesGLESPv,__ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE13StaticDestroyEPv,__ZL25InitializeUnityWebStreamsPv,__ZL22CleanupUnityWebStreamsPv,__ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb1EEEvP12NoiseJobData,__ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb0EEEvP12NoiseJobData,__ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb1EEEvP12NoiseJobData,__ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb0EEEvP12NoiseJobData,__ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb1EEEvP12NoiseJobData,__ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb0EEEvP12NoiseJobData,__ZN11NoiseModule15PreviewNoiseJobILi1EEEvP19PreviewNoiseJobData,__ZN11NoiseModule15PreviewNoiseJobILi2EEEvP19PreviewNoiseJobData,__ZN11NoiseModule15PreviewNoiseJobILi3EEEvP19PreviewNoiseJobData,__ZN25ParticleSystemGeometryJob13ReleaseMemJobEP25DynamicVBOGeometryJobData,__ZL12PhysxJobFuncPN5physx10PxBaseTaskE
,_PxGetPhysicsBinaryMetaData,__ZN5physx3Ext27GetExtensionsBinaryMetaDataERNS_14PxOutputStreamE,__ZN5physx21PxcArticulationHelper12saveVelocityERKNS_25PxcArticulationSolverDescE,__Z35Physics_CUSTOM_INTERNAL_get_gravityP8Vector3f,__Z35Physics_CUSTOM_INTERNAL_set_gravityRK8Vector3f,__Z46Physics_Set_Custom_PropDefaultSolverIterationsi,__Z54Physics_Set_Custom_PropDefaultSolverVelocityIterationsi,__Z41Physics_Set_Custom_PropQueriesHitTriggersh,__Z42Physics_Set_Custom_PropQueriesHitBackfacesh,__Z36Rigidbody_CUSTOM_INTERNAL_CALL_SleepP12Il2CppObject,__Z37Rigidbody_CUSTOM_INTERNAL_CALL_WakeUpP12Il2CppObject,__Z48Rigidbody_CUSTOM_INTERNAL_CALL_ResetCenterOfMassP12Il2CppObject,__Z49Rigidbody_CUSTOM_INTERNAL_CALL_ResetInertiaTensorP12Il2CppObject,__Z43Physics2D_Set_Custom_PropVelocityIterationsi,__Z43Physics2D_Set_Custom_PropPositionIterationsi,__Z37Physics2D_CUSTOM_INTERNAL_get_gravityP13Vector2fIcall,__Z37Physics2D_CUSTOM_INTERNAL_set_gravityRK13Vector2fIcall,__Z43Physics2D_Set_Custom_PropQueriesHitTriggersh,__Z48Physics2D_Set_Custom_PropQueriesStartInCollidersh,__Z45Physics2D_Set_Custom_PropChangeStopsCallbacksh,__Z44Physics2D_Set_Custom_PropAlwaysShowCollidersh,__Z42Physics2D_Set_Custom_PropShowColliderSleeph,__Z45Physics2D_Set_Custom_PropShowColliderContactsh,__Z41Physics2D_Set_Custom_PropShowColliderAABBh,__Z48Physics2D_CUSTOM_INTERNAL_get_colliderAwakeColorP10ColorRGBAf,__Z48Physics2D_CUSTOM_INTERNAL_set_colliderAwakeColorRK10ColorRGBAf,__Z49Physics2D_CUSTOM_INTERNAL_get_colliderAsleepColorP10ColorRGBAf,__Z49Physics2D_CUSTOM_INTERNAL_set_colliderAsleepColorRK10ColorRGBAf,__Z50Physics2D_CUSTOM_INTERNAL_get_colliderContactColorP10ColorRGBAf,__Z50Physics2D_CUSTOM_INTERNAL_set_colliderContactColorRK10ColorRGBAf
,__Z47Physics2D_CUSTOM_INTERNAL_get_colliderAABBColorP10ColorRGBAf,__Z47Physics2D_CUSTOM_INTERNAL_set_colliderAABBColorRK10ColorRGBAf,__Z24Rigidbody2D_CUSTOM_SleepP12Il2CppObject,__Z25Rigidbody2D_CUSTOM_WakeUpP12Il2CppObject,__Z27EdgeCollider2D_CUSTOM_ResetP12Il2CppObject,__ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE13StaticDestroyEPv,__ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE13StaticDestroyEPv,__ZN13RuntimeStaticI14dynamic_bitsetE16StaticInitializeEPv,__ZN13RuntimeStaticI14dynamic_bitsetE13StaticDestroyEPv,__ZN5physx16PxVehicleDrive4W17getBinaryMetaDataERNS_14PxOutputStreamE,__ZN5physx18PxVehicleDriveTank17getBinaryMetaDataERNS_14PxOutputStreamE,__ZN5physx16PxVehicleNoDrive17getBinaryMetaDataERNS_14PxOutputStreamE,__ZN5physx16PxVehicleDriveNW17getBinaryMetaDataERNS_14PxOutputStreamE,__ZN5physx20clearTorqueCurvePairEPNS_19PxVehicleEngineDataE,__Z47Cloth_CUSTOM_INTERNAL_CALL_ClearTransformMotionP12Il2CppObject,__ZL15UnityDetourFreePv,__ZL19UnityDetourFreeTempPv,__ZL18NavMeshUnloadScenei,__ZL21NavMeshGarbageCollectR27GarbageCollectorThreadState,__Z39NavMeshAgent_CUSTOM_CompleteOffMeshLinkP12Il2CppObject,__Z32NavMeshAgent_CUSTOM_StopInternalP12Il2CppObject,__Z26NavMeshAgent_CUSTOM_ResumeP12Il2CppObject,__Z29NavMeshAgent_CUSTOM_ResetPathP12Il2CppObject,__Z47NavMesh_CUSTOM_SetPathfindingIterationsPerFramei,__Z33NavMeshObstacle_CUSTOM_FitExtentsP12Il2CppObject,__Z30NavMeshPath_CUSTOM_NavMeshPathP12Il2CppObject
,__Z37NavMeshPath_CUSTOM_DestroyNavMeshPathP12Il2CppObject,__Z39NavMeshPath_CUSTOM_ClearCornersInternalP12Il2CppObject,__Z34OffMeshLink_CUSTOM_UpdatePositionsP12Il2CppObject,__ZN4FMOD22FakeModChannelCallbackEPv,__ZL37StaticInitializeAudioCustomFilterRootPv,__ZL34StaticDestroyAudioCustomFilterRootPv,__ZL37StaticInitializeAudioSourceFilterRootPv,__ZL34StaticDestroyAudioSourceFilterRootPv,__Z40AudioSettings_Set_Custom_PropSpeakerMode16FMOD_SPEAKERMODE,__Z45AudioSettings_Set_Custom_PropOutputSampleRatei,__Z51AudioSettings_CUSTOM_INTERNAL_CALL_GetConfigurationR27AudioConfigurationScripting,__Z34AudioListener_Set_Custom_PropPauseh,__Z23AudioSource_CUSTOM_StopP12Il2CppObject,__Z38AudioSource_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject,__Z40AudioSource_CUSTOM_INTERNAL_CALL_UnPauseP12Il2CppObject,__Z39WebCamTexture_CUSTOM_INTERNAL_CALL_PlayP12Il2CppObject,__Z40WebCamTexture_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject,__Z39WebCamTexture_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject,__ZN8Animator13BatchedFKPassERK13dynamic_arrayI11DirectorJobLj8EE,__ZN8Animator13BatchedIKPassERK13dynamic_arrayI11DirectorJobLj8EE,__ZN13RuntimeStaticI15AnimationBinderE16StaticInitializeEPv,__ZN13RuntimeStaticI15AnimationBinderE13StaticDestroyEPv,__ZN11UnityEngine9Animation38InitializeGenericAnimationBindingCacheEPv,__ZN11UnityEngine9Animation35CleanupGenericAnimationBindingCacheEPv,__Z31DoCalculateAnimatorSkinMatricesP25CalculateSkinMatricesTask,__Z49AnimationLayerMixerPlayable_CUSTOM_InternalCreateR9HPlayable,__Z44AnimationMixerPlayable_CUSTOM_InternalCreateR9HPlayable,__Z45AnimationOffsetPlayable_CUSTOM_InternalCreateR9HPlayable,__Z49AnimationClip_CUSTOM_Internal_CreateAnimationClipP12Il2CppObject,__Z61AnimationClip_CUSTOM_INTERNAL_CALL_EnsureQuaternionContinuityP12Il2CppObject
,__Z46AnimationClip_CUSTOM_INTERNAL_CALL_ClearCurvesP12Il2CppObject,__Z35Animation_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject,__Z37Animation_CUSTOM_INTERNAL_CALL_RewindP12Il2CppObject,__Z37Animation_CUSTOM_INTERNAL_CALL_SampleP12Il2CppObject,__Z29Animator_CUSTOM_StartPlaybackP12Il2CppObject,__Z28Animator_CUSTOM_StopPlaybackP12Il2CppObject,__Z29Animator_CUSTOM_StopRecordingP12Il2CppObject,__Z22Animator_CUSTOM_RebindP12Il2CppObject,__Z38Animator_CUSTOM_ApplyBuiltinRootMotionP12Il2CppObject,__Z61AnimatorOverrideController_CUSTOM_Internal_CreateAnimationSetP12Il2CppObject,__Z51AnimatorOverrideController_CUSTOM_Internal_SetDirtyP12Il2CppObject,__Z51AnimatorUtility_CUSTOM_DeoptimizeTransformHierarchyP12Il2CppObject,__Z31HumanPoseHandler_CUSTOM_DisposeP12Il2CppObject,__ZN20QuadTreeNodeRenderer16StaticInitializeEPv,__ZN20QuadTreeNodeRenderer13StaticDestroyEPv,__ZL21InitializeCachedStripPv,__ZL18DestroyCachedStripPv,__Z36TerrainData_CUSTOM_ResetDirtyDetailsP12Il2CppObject,__Z36TerrainData_CUSTOM_RefreshPrototypesP12Il2CppObject,__Z43TerrainData_CUSTOM_RecalculateTreePositionsP12Il2CppObject,__Z45TerrainData_CUSTOM_UpgradeScaledTreePrototypeP12Il2CppObject,__Z44TerrainData_CUSTOM_RecalculateBasemapIfDirtyP12Il2CppObject,__Z48Terrain_CUSTOM_ApplyDelayedHeightmapModificationP12Il2CppObject,__Z20Terrain_CUSTOM_FlushP12Il2CppObject,_memory_stream_close,_ft_ansi_stream_close,__ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE16StaticInitializeEPv,__ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE13StaticDestroyEPv,_ft_outline_glyph_done,_ft_bitmap_glyph_done
,_UNITY_tt_driver_done,_UNITY_tt_face_done,_UNITY_tt_size_done,_cff_driver_done,_cff_face_done,_cff_size_done,_cff_slot_done,_ps_hinter_done,_gray_raster_done,_tt_cmap14_done,_sfnt_done_face,_UNITY_tt_face_free_name,_UNITY_tt_face_free_ps_names,_UNITY_tt_face_free_sbit,_sfnt_stream_close,_ft_black_done,_Vertical_Sweep_Step,_Horizontal_Sweep_Step,_Split_Conic,_Split_Cubic,_psh_globals_destroy,_t1_hints_open,_t2_hints_open,_cf2_free_instance,_cff_cmap_encoding_done,_cff_cmap_unicode_done,_TT_Forget_Glyph_Frame,__Z25TextGenerator_CUSTOM_InitP12Il2CppObject,__Z32TextGenerator_CUSTOM_Dispose_cppP12Il2CppObject,__ZN2UIL41GenerateRenderableUIInstructionCombineJobEPNS_28PreprocessUIInstructionsDataE
,__ZN2UI18SortForBatchingJobEPNS_14SortingJobDataE,__ZN2UI17PrepareBatchesJobEPNS_21PrepareBatchesJobDataE,__ZN2UIL13UIGeometryJobEPNS_17UIGeometryJobDataE,__ZZN2UI23InitializeCanvasManagerEvEN41UIEventsCanvasManagerRenderOverlaysstruct7ForwardEi,__ZN2UI13CanvasManager17EmitDataForCameraEP6Camera,__Z41CanvasRenderer_CUSTOM_DisableRectClippingP12Il2CppObject,__Z27CanvasRenderer_CUSTOM_ClearP12Il2CppObject,__ZZN10GUIManager14InitGUIManagerEvEN33UIEventsIMGUIRenderOverlaysstruct7ForwardEi,__Z20Event_CUSTOM_CleanupP12Il2CppObject,__Z36Event_CUSTOM_Internal_SetNativeEvent13Il2Cpp_IntPtr,__Z25Event_CUSTOM_Internal_UseP12Il2CppObject,__Z29GUI_CUSTOM_INTERNAL_get_colorP10ColorRGBAf,__Z29GUI_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf,__Z39GUI_CUSTOM_INTERNAL_get_backgroundColorP10ColorRGBAf,__Z39GUI_CUSTOM_INTERNAL_set_backgroundColorRK10ColorRGBAf,__Z36GUI_CUSTOM_INTERNAL_get_contentColorP10ColorRGBAf,__Z36GUI_CUSTOM_INTERNAL_set_contentColorRK10ColorRGBAf,__Z26GUI_Set_Custom_PropChangedh,__Z26GUI_Set_Custom_PropEnabledh,__Z30GUI_CUSTOM_Internal_SetTooltipP12Il2CppString,__Z24GUI_Set_Custom_PropDepthi,__Z29GUI_CUSTOM_SetNextControlNameP12Il2CppString,__Z23GUI_CUSTOM_FocusControlP12Il2CppString,__Z35GUI_CUSTOM_INTERNAL_CALL_DragWindowRK5RectTIfE,__Z29GUI_CUSTOM_BringWindowToFronti,__Z28GUI_CUSTOM_BringWindowToBacki,__Z22GUI_CUSTOM_FocusWindowi,__Z54GUILayoutUtility_CUSTOM_INTERNAL_CALL_GetWindowsBoundsR5RectTIfE,__Z25GUIStyleState_CUSTOM_InitP12Il2CppObject,__Z28GUIStyleState_CUSTOM_CleanupP12Il2CppObject
,__Z20GUIStyle_CUSTOM_InitP12Il2CppObject,__Z23GUIStyle_CUSTOM_CleanupP12Il2CppObject,__Z30GUIStyle_CUSTOM_SetDefaultFontP12Il2CppObject,__Z40GUIUtility_CUSTOM_Internal_SetHotControli,__Z34GUIUtility_CUSTOM_GrabMouseControli,__Z28GUIUtility_CUSTOM_SetChangedh,__Z41GUIUtility_Set_Custom_PropKeyboardControli,__Z46GUIUtility_CUSTOM_SetDidGUIWindowsEatLastEventh,__Z42GUIUtility_Set_Custom_PropSystemCopyBufferP12Il2CppString,__Z35GUIUtility_Set_Custom_PropMouseUsedh,__Z40GUIUtility_Set_Custom_PropTextFieldInputh,__Z39GUIClip_CUSTOM_INTERNAL_CALL_GetTopRectR5RectTIfE,__Z43GUIClip_CUSTOM_INTERNAL_CALL_Unclip_Vector2R13Vector2fIcall,__Z39GUIClip_CUSTOM_INTERNAL_get_topmostRectP5RectTIfE,__Z40GUIClip_CUSTOM_INTERNAL_CALL_Unclip_RectR5RectTIfE,__Z41GUIClip_CUSTOM_INTERNAL_CALL_Clip_Vector2R13Vector2fIcall,__Z47GUIClip_CUSTOM_INTERNAL_CALL_Internal_Clip_RectR5RectTIfE,__Z38GUIClip_CUSTOM_INTERNAL_CALL_GetMatrixR10Matrix4x4f,__Z38GUIClip_CUSTOM_INTERNAL_CALL_SetMatrixRK10Matrix4x4f,__Z39GUIClip_CUSTOM_INTERNAL_get_visibleRectP5RectTIfE,__Z48GUIClip_CUSTOM_Internal_GetAbsoluteMousePositionP13Vector2fIcall,__Z43DownloadHandler_CUSTOM_InternalCreateBufferP12Il2CppObject,__Z43DownloadHandler_CUSTOM_InternalCreateScriptP12Il2CppObject,__Z38DownloadHandler_CUSTOM_InternalDestroyP12Il2CppObject,__Z36UploadHandler_CUSTOM_InternalDestroyP12Il2CppObject,__ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19Job_InvokeCoroutineEPv,__Z37UnityWebRequest_CUSTOM_InternalCreateP12Il2CppObject,__Z38UnityWebRequest_CUSTOM_InternalDestroyP12Il2CppObject,__Z36UnityWebRequest_CUSTOM_InternalAbortP12Il2CppObject,__Z38CustomEventData_CUSTOM_InternalDestroyP12Il2CppObject
,__Z43UnityAnalyticsHandler_CUSTOM_InternalCreateP12Il2CppObject,__Z44UnityAnalyticsHandler_CUSTOM_InternalDestroyP12Il2CppObject,__ZN18CrashReportHandler18HandleFlushReportsEPS_,__ZN18CrashReportHandler27DidReloadMonoDomainCallbackEPS_,__Z57CrashReportHandler_Set_Custom_PropEnableCaptureExceptionsh,__ZN22BaseUnityConnectClient31DonePreparingOnMainThreadStaticEPv,__ZN11UnityEngine7ConnectL18StaticCallOnUpdateEPv,__ZN19UnityConnectService18OnPlayerQuitStaticEPS_,__ZN19UnityConnectService20OnExitPlayModeStaticEPS_,__ZN19UnityConnectService27OnDidReloadMonoDomainStaticEPS_,__ZN13RuntimeStaticI20HardwareInfoReporterE16StaticInitializeEPv,__ZN13RuntimeStaticI20HardwareInfoReporterE13StaticDestroyEPv,__ZN13RuntimeStaticI18UnityConnectClientE13StaticDestroyEPv,__ZN13RuntimeStaticI19UnityConnectServiceE16StaticInitializeEPv,__ZN13RuntimeStaticI19UnityConnectServiceE13StaticDestroyEPv,__Z39UnityAdsSettings_Set_Custom_PropEnabledh,__Z51UnityAdsSettings_Set_Custom_PropInitializeOnStartuph,__Z40UnityAdsSettings_Set_Custom_PropTestModeh,__Z43UnityConnectSettings_Set_Custom_PropEnabledh,__Z44UnityConnectSettings_Set_Custom_PropTestModeh,__Z48UnityConnectSettings_Set_Custom_PropTestEventUrlP12Il2CppString,__Z49UnityConnectSettings_Set_Custom_PropTestConfigUrlP12Il2CppString,__ZL24StaticInitializeIUnityVRPv,__ZL16RegisterVRDevice23UnityVRDeviceDefinition,__Z33VRSettings_Set_Custom_PropEnabledh,__Z40VRSettings_Set_Custom_PropShowDeviceViewh,__Z34VRSettings_CUSTOM_LoadDeviceByNameP11Il2CppArray,__Z42VRDevice_CUSTOM_INTERNAL_CALL_GetNativePtrRPv,__ZN11UnityEngine15CloudWebService14DataDispatcher25OnDataBlockConsumedStaticEPv,__ZN11UnityEngine15CloudWebService19SessionEventManager27ProcessFlushEventsJobStaticEPv
,__ZN11UnityEngine15CloudWebService14DataDispatcher37SetupSessionContainerToDispatchStaticEPv,__ZN11UnityEngine15CloudWebService19SessionEventManager26ProcessEventQueueJobStaticEPv,__ZN11UnityEngine15CloudWebService19SessionEventManager37OnTimerExpiredPerformArchiveJobStaticEPv,__ZN11UnityEngine15CloudWebService14DataDispatcher29PreformRetryWebDispatchStaticEPv,__Z51ParticleEmitter_CUSTOM_INTERNAL_CALL_ClearParticlesP12Il2CppObject,_emscripten_glDeleteShader__wrapper,_emscripten_glCompileShader__wrapper,_emscripten_glDeleteProgram__wrapper,_emscripten_glLinkProgram__wrapper,_emscripten_glUseProgram__wrapper,_emscripten_glValidateProgram__wrapper,_emscripten_glDeleteObjectARB__wrapper,_emscripten_glEnableClientState__wrapper,_emscripten_glClientActiveTexture__wrapper,_emscripten_glBindVertexArray__wrapper,_emscripten_glMatrixMode__wrapper,_emscripten_glLoadMatrixf__wrapper,_emscripten_glEnableVertexAttribArray__wrapper,_emscripten_glDisableVertexAttribArray__wrapper,_emscripten_glDepthFunc__wrapper,_emscripten_glEnable__wrapper,_emscripten_glDisable__wrapper,_emscripten_glFrontFace__wrapper,_emscripten_glCullFace__wrapper,_emscripten_glClear__wrapper,_emscripten_glClearStencil__wrapper,_emscripten_glDepthMask__wrapper,_emscripten_glStencilMask__wrapper,_emscripten_glGenerateMipmap__wrapper,_emscripten_glActiveTexture__wrapper,_emscripten_glBlendEquation__wrapper,_cleanup_387,_cleanup_382,_do_setrlimit,_dummy1,_cleanup,_do_setxid,__ZSt17rethrow_exceptionSt13exception_ptr,__ZNSt3__217__assoc_sub_state4copyEv,__ZNSt3__28ios_base33__set_badbit_and_consider_rethrowEv,__ZNSt3__28ios_base34__set_failbit_and_consider_rethrowEv,__ZNSt3__26locale2id6__initEv,__ZNSt3__217__call_once_proxyINS_5tupleIJONS_12_GLOBAL__N_111__fake_bindEEEEEEvPv,_freelocale,__ZNSt3__212__do_nothingEPv,__ZNSt3__221__throw_runtime_errorEPKc,_free,__ZNSt3__25mutex4lockEv,__ZNSt3__211unique_lockINS_5mutexEE6unlockEv,__ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE,__ZNSt3__221__thread_specific_ptrINS_15__thread_structEEC2Ev,__ZNSt3__221__thread_specific_ptrINS_15__thread_structEE16__at_thread_exitEPv,__ZNSt3__217__assoc_sub_state12__make_readyEv,__ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv,__ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv,__ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv,b110,b110,b110
,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110
,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110
,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110,b110];
var FUNCTION_TABLE_iiiiiiiiiii = [b111];
var FUNCTION_TABLE_iiiiff = [b112,__Z42Physics2D_CUSTOM_INTERNAL_CALL_LinecastAllRK13Vector2fIcallS1_iff,__Z51Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointNonAllocRK13Vector2fIcallP11Il2CppArrayiff,__Z42Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaRK13Vector2fIcallS1_iff,__Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaAllRK13Vector2fIcallS1_iff,b112,b112,b112];
var FUNCTION_TABLE_ii = [b113,__ZN13EmscriptenWWW7GetDataEv,__ZNK13EmscriptenWWW14GetPartialDataEv,__ZN13EmscriptenWWW7GetSizeEv,__ZNK13EmscriptenWWW14GetPartialSizeEv,__ZNK3WWW6IsDoneEv,__ZN3WWW8GetErrorEv,__ZNK13EmscriptenWWW6GetUrlEv,__ZN13EmscriptenWWW23HasDownloadedOrMayBlockEv,__ZNK13EmscriptenWWW7GetTypeEv,__ZNK3WWW17GetUnityWebStreamEv,__ZNK3WWW8IsCachedEv,__ZNK3WWW17GetThreadPriorityEv,__ZNK3WWW12GetAudioClipEv,__ZNK13EmscriptenWWW17IsDownloadingDoneEv,__ZN13ScreenManager22SetRequestedResolutionEv,__ZNK18ScreenManagerWebGL13GetShowCursorEv,__ZNK18ScreenManagerWebGL13GetLockCursorEv,__ZNK13ScreenManager24GetAllowLayeredRenderingEv,__ZNK13ScreenManager16GetScreenTimeoutEv,__ZNK13ScreenManager12GetIsFocusedEv,__ZNK13ScreenManager21GetCursorInsideWindowEv,__ZNK18ScreenManagerWebGL8GetWidthEv,__ZNK18ScreenManagerWebGL9GetHeightEv,__ZNK18ScreenManagerWebGL12IsFullScreenEv,__ZNK13ScreenManager14IsStereoscopicEv,__ZNK13ScreenManager21IsMultiDisplayEnabledEv,__ZNK13ScreenManager20GetScreenOrientationEv,__ZN22LocalFileSystemHandler4NameEv
,__ZN22LocalFileSystemHandler9LastErrorEv,__ZNK13WebCamTexture26GetTypeInfoVirtualInternalEv,__ZNK11NamedObject7GetNameEv,__ZN7Texture39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK16BaseVideoTexture20GetRuntimeMemorySizeEv,__ZNK6Object25GetNeedsPerObjectTypeTreeEv,__ZNK7Texture20GetUnscaledTextureIDEv,__ZNK7Texture11GetGPUWidthEv,__ZNK7Texture12GetGPUHeightEv,__ZNK7Texture9HasMipMapEv,__ZNK7Texture14GetMipmapCountEv,__ZNK7Texture21GetShadowSamplingModeEv,__ZNK7Texture14IsDepthTextureEv,__ZNK7Texture13IsNPOTAllowedEv,__ZNK7Texture26CanReuploadDataToGfxDeviceEv,__ZNK16BaseVideoTexture12GetDataWidthEv,__ZNK16BaseVideoTexture13GetDataHeightEv,__ZNK7Texture20GetTextureLayerCountEv,__ZNK16BaseVideoTexture12GetDimensionEv,__ZNK7Texture10GetVRUsageEv,__ZNK13WebCamTexture20GetStorageMemorySizeEv,__ZNK16BaseVideoTexture14GetImageBufferEv,__ZNK16BaseVideoTexture9IsPlayingEv,__ZNK16BaseVideoTexture21GetVideoRotationAngleEv,__ZNK16BaseVideoTexture25IsVideoVerticallyMirroredEv,__ZNK13WebCamTexture22GetBufferTextureFormatEv,__ZNK13WebCamTexture9IsRunningEv,__ZN13WebCamTexture14GetWorldOffsetEv,__ZN13WebCamTexture19GetCameraProjectionEv,__ZNK16BaseVideoTexture26GetTypeInfoVirtualInternalEv
,__ZNK16BaseVideoTexture22GetBufferTextureFormatEv,__ZNK15EditorExtension26GetTypeInfoVirtualInternalEv,__ZNK6Object7GetNameEv,__ZN6Object39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK6Object20GetRuntimeMemorySizeEv,__ZNK13BaseAllocator10IsAssignedEv,__ZN13BaseAllocator14CheckIntegrityEv,__ZNK13BaseAllocator22GetAllocatedMemorySizeEv,__ZNK13BaseAllocator21GetReservedMemorySizeEv,__ZNK13BaseAllocator26GetPeakAllocatedMemorySizeEv,__ZNK13BaseAllocator24GetBookKeepingMemorySizeEv,__ZNK13BaseAllocator22GetNumberOfAllocationsEv,__ZNK13BaseAllocator16IsDelayedReleaseEv,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE14CheckIntegrityEv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE22GetAllocatedMemorySizeEv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE21GetReservedMemorySizeEv,__ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE24GetBookKeepingMemorySizeEv,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv,__ZNK12TLSAllocatorI14StackAllocatorE10IsAssignedEv,__ZN12TLSAllocatorI14StackAllocatorE14CheckIntegrityEv,__ZNK12TLSAllocatorI14StackAllocatorE22GetAllocatedMemorySizeEv,__ZNK12TLSAllocatorI14StackAllocatorE21GetReservedMemorySizeEv,__ZNK12TLSAllocatorI14StackAllocatorE24GetBookKeepingMemorySizeEv,__ZNK25ThreadsafeLinearAllocator22GetAllocatedMemorySizeEv,__ZNK25ThreadsafeLinearAllocator21GetReservedMemorySizeEv,__ZNK11AssetBundle26GetTypeInfoVirtualInternalEv,__ZN11AssetBundle39ShouldIgnoreInGarbageDependencyTrackingEv,__ZN23PreloadManagerOperation6IsDoneEv,__ZN23PreloadManagerOperation11GetPriorityEv,__ZN14AsyncOperation23GetAllowSceneActivationEv
,__ZN23PreloadManagerOperation21MustCompleteNextFrameEv,__ZNK23PreloadManagerOperation25GetAllowParallelExecutionEv,__ZN33AssetBundleLoadFromAsyncOperation6IsDoneEv,__ZNK19AssetBundleManifest26GetTypeInfoVirtualInternalEv,__ZNK6Object26GetTypeInfoVirtualInternalEv,__ZNK16LevelGameManager26GetTypeInfoVirtualInternalEv,__ZNK16LevelGameManager7GetNameEv,__ZNK11GameManager19ShouldWriteForBuildEv,__ZNK11GameManager26GetTypeInfoVirtualInternalEv,__ZNK17GlobalGameManager26GetTypeInfoVirtualInternalEv,__ZNK17GlobalGameManager7GetNameEv,__ZNK10GameObject26GetTypeInfoVirtualInternalEv,__ZNK10GameObject7GetNameEv,__ZNK5Unity9Component26GetTypeInfoVirtualInternalEv,__ZNK5Unity9Component7GetNameEv,__ZN5Unity9Component26CalculateSupportedMessagesEv,__ZNK5Unity9Component10HasEnabledEv,__ZNK5Unity9Component10GetEnabledEv,__ZNK11NamedObject26GetTypeInfoVirtualInternalEv,__ZNK10TagManager26GetTypeInfoVirtualInternalEv,__ZN10TagManager39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK12BaseRenderer19GetStaticBatchIndexEv,__ZNK6Camera26GetTypeInfoVirtualInternalEv,__ZNK9Behaviour10HasEnabledEv,__ZNK9Behaviour10GetEnabledEv,__ZNK5Flare26GetTypeInfoVirtualInternalEv,__ZNK9LensFlare26GetTypeInfoVirtualInternalEv,__ZNK10FlareLayer26GetTypeInfoVirtualInternalEv,__ZNK16GraphicsSettings26GetTypeInfoVirtualInternalEv,__ZNK4Halo26GetTypeInfoVirtualInternalEv
,__ZNK20IntermediateRenderer8GetLayerEv,__ZNK20IntermediateRenderer16GetMaterialCountEv,__ZNK20IntermediateRenderer12GetLayerMaskEv,__ZNK24MeshIntermediateRenderer14AllowsBatchingEv,__ZNK5Light26GetTypeInfoVirtualInternalEv,__ZNK19ShaderPropertySheet7IsDirtyEv,__ZNK9HaloLayer26GetTypeInfoVirtualInternalEv,__ZNK21LightProbeProxyVolume26GetTypeInfoVirtualInternalEv,__ZNK11LightProbes26GetTypeInfoVirtualInternalEv,__ZNK13OcclusionArea26GetTypeInfoVirtualInternalEv,__ZNK20OcclusionCullingData26GetTypeInfoVirtualInternalEv,__ZNK24OcclusionCullingSettings26GetTypeInfoVirtualInternalEv,__ZNK24OcclusionCullingSettings19ShouldWriteForBuildEv,__ZNK15OcclusionPortal26GetTypeInfoVirtualInternalEv,__ZNK9Projector26GetTypeInfoVirtualInternalEv,__ZNK15ReflectionProbe26GetTypeInfoVirtualInternalEv,__ZNK14RenderSettings26GetTypeInfoVirtualInternalEv,__ZNK20DynamicPropertySheet7IsDirtyEv,__ZNK6Skybox26GetTypeInfoVirtualInternalEv,__ZNK10GUIElement26GetTypeInfoVirtualInternalEv,__ZNK10GUITexture26GetTypeInfoVirtualInternalEv,__ZNK8GUILayer26GetTypeInfoVirtualInternalEv,__ZNK14DirectorPlayer26GetTypeInfoVirtualInternalEv,__ZNK14DirectorPlayer17GetTimeUpdateModeEv,__ZN8Playable17IsMultithreadableEv,__ZNK8Playable12GetPlayStateEv,__ZN8Playable7GetTypeEv,__ZNK18DelayedCallManager26GetTypeInfoVirtualInternalEv,__ZNK9Behaviour26GetTypeInfoVirtualInternalEv,__ZN22BlockMemoryCacheWriter12GetCacheSizeEv
,__ZN15CacheWriterBase18GetAddressOfMemoryEv,__ZN22BlockMemoryCacheWriter13GetFileLengthEv,__ZNK9GfxDevice14GetDeviceLevelEv,__ZNK9GfxDevice18GetWorldViewMatrixEv,__ZNK9GfxDevice14GetWorldMatrixEv,__ZNK9GfxDevice13GetViewMatrixEv,__ZNK9GfxDevice19GetProjectionMatrixEv,__ZNK9GfxDevice25GetDeviceProjectionMatrixEv,__ZN9GfxDevice17CreateIndexBufferEv,__ZN9GfxDevice18CreateVertexBufferEv,__ZN9GfxDevice23CreateGPUSkinPoseBufferEv,__ZNK9GfxDevice27GetActiveRenderSurfaceWidthEv,__ZNK9GfxDevice28GetActiveRenderSurfaceHeightEv,__ZN9GfxDevice25GetBackBufferColorSurfaceEv,__ZN9GfxDevice25GetBackBufferDepthSurfaceEv,__ZN9GfxDevice15CreateTextureIDEv,__ZN9GfxDevice18HandleInvalidStateEv,__ZN9GfxDevice14InsertCPUFenceEv,__ZN9GfxDevice15GetNextCPUFenceEv,__ZN9GfxDevice14BeginRecordingEv,__ZN9GfxDevice20TimerQueriesIsActiveEv,__ZNK9GfxDevice18GetDefaultRTFormatEv,__ZNK9GfxDevice21GetDefaultHDRRTFormatEv,__ZN9GfxDevice18GetNativeGfxDeviceEv,__ZN9GfxDevice21CreateComputeBufferIDEv,__ZNK9GfxDevice26HasActiveRandomWriteTargetEv,__ZN9GfxDevice16GetMultiGPUCountEv,__ZN9GfxDevice13GetCurrentGPUEv,__ZNK9GfxDevice14IsPureThreadedEv,__ZNK9GfxDevice26ShouldJobsSyncAtEndOfFrameEv
,__ZNK10GpuProgram11IsSupportedEv,__ZNK12CubemapArray26GetTypeInfoVirtualInternalEv,__ZNK12CubemapArray20GetRuntimeMemorySizeEv,__ZNK12CubemapArray26CanReuploadDataToGfxDeviceEv,__ZNK12CubemapArray12GetDataWidthEv,__ZNK12CubemapArray13GetDataHeightEv,__ZNK12CubemapArray20GetTextureLayerCountEv,__ZNK12CubemapArray12GetDimensionEv,__ZNK12CubemapArray20GetStorageMemorySizeEv,__ZNK12CubemapArray15GetCubemapCountEv,__ZNK7Cubemap26GetTypeInfoVirtualInternalEv,__ZNK9Texture2D20GetRuntimeMemorySizeEv,__ZNK9Texture2D20GetUnscaledTextureIDEv,__ZNK9Texture2D11GetGPUWidthEv,__ZNK9Texture2D12GetGPUHeightEv,__ZNK9Texture2D13IsNPOTAllowedEv,__ZNK9Texture2D26CanReuploadDataToGfxDeviceEv,__ZNK9Texture2D12GetDataWidthEv,__ZNK9Texture2D13GetDataHeightEv,__ZNK7Cubemap20GetTextureLayerCountEv,__ZNK7Cubemap12GetDimensionEv,__ZNK9Texture2D20GetStorageMemorySizeEv,__ZNK9Texture2D13GetDataFormatEv,__ZNK15LightProbeGroup26GetTypeInfoVirtualInternalEv,__ZNK16LightmapSettings26GetTypeInfoVirtualInternalEv,__ZNK12LineRenderer26GetTypeInfoVirtualInternalEv,__ZNK8Renderer10HasEnabledEv,__ZNK8Renderer10GetEnabledEv,__ZNK8Renderer8GetLayerEv,__ZNK8Renderer16GetMaterialCountEv
,__ZThn32_NK8Renderer8GetLayerEv,__ZThn32_NK8Renderer16GetMaterialCountEv,__ZNK8Renderer26GetTypeInfoVirtualInternalEv,__ZNK15QualitySettings26GetTypeInfoVirtualInternalEv,__ZNK2UI13RectTransform26GetTypeInfoVirtualInternalEv,__ZN9Transform26CalculateSupportedMessagesEv,__ZNK13RenderTexture26GetTypeInfoVirtualInternalEv,__ZNK13RenderTexture20GetRuntimeMemorySizeEv,__ZNK13RenderTexture21GetShadowSamplingModeEv,__ZNK13RenderTexture14IsDepthTextureEv,__ZNK13RenderTexture12GetDataWidthEv,__ZNK13RenderTexture13GetDataHeightEv,__ZNK13RenderTexture20GetTextureLayerCountEv,__ZNK13RenderTexture12GetDimensionEv,__ZNK13RenderTexture10GetVRUsageEv,__ZNK13RenderTexture20GetStorageMemorySizeEv,__ZNK13ScreenManager13GetShowCursorEv,__ZNK13ScreenManager13GetLockCursorEv,__ZNK13ScreenManager12IsFullScreenEv,__ZNK7Texture26GetTypeInfoVirtualInternalEv,__ZNK19LowerResBlitTexture12GetDataWidthEv,__ZNK19LowerResBlitTexture13GetDataHeightEv,__ZNK19LowerResBlitTexture12GetDimensionEv,__ZNK19LowerResBlitTexture20GetStorageMemorySizeEv,__ZNK13SparseTexture26GetTypeInfoVirtualInternalEv,__ZNK13SparseTexture12GetDataWidthEv,__ZNK13SparseTexture13GetDataHeightEv,__ZNK13SparseTexture12GetDimensionEv,__ZNK13SparseTexture20GetStorageMemorySizeEv,__ZNK6Sprite26GetTypeInfoVirtualInternalEv
,__ZNK9Texture2D26GetTypeInfoVirtualInternalEv,__ZNK9Texture2D12GetDimensionEv,__ZNK14Texture2DArray26GetTypeInfoVirtualInternalEv,__ZNK14Texture2DArray20GetRuntimeMemorySizeEv,__ZNK14Texture2DArray26CanReuploadDataToGfxDeviceEv,__ZNK14Texture2DArray12GetDataWidthEv,__ZNK14Texture2DArray13GetDataHeightEv,__ZNK14Texture2DArray20GetTextureLayerCountEv,__ZNK14Texture2DArray12GetDimensionEv,__ZNK14Texture2DArray20GetStorageMemorySizeEv,__ZNK9Texture3D26GetTypeInfoVirtualInternalEv,__ZNK9Texture3D20GetRuntimeMemorySizeEv,__ZNK9Texture3D26CanReuploadDataToGfxDeviceEv,__ZNK9Texture3D12GetDataWidthEv,__ZNK9Texture3D13GetDataHeightEv,__ZNK9Texture3D20GetTextureLayerCountEv,__ZNK9Texture3D12GetDimensionEv,__ZNK9Texture3D20GetStorageMemorySizeEv,__ZNK13TrailRenderer26GetTypeInfoVirtualInternalEv,__ZNK9Transform26GetTypeInfoVirtualInternalEv,__ZNK14BillboardAsset26GetTypeInfoVirtualInternalEv,__ZNK17BillboardRenderer26GetTypeInfoVirtualInternalEv,__ZNK17BillboardRenderer16GetMaterialCountEv,__ZThn32_NK17BillboardRenderer16GetMaterialCountEv,__ZNK8LODGroup26GetTypeInfoVirtualInternalEv,__ZNK8LODGroup10HasEnabledEv,__ZNK8LODGroup10GetEnabledEv,__ZNK4Mesh26GetTypeInfoVirtualInternalEv,__ZN4Mesh39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK4Mesh20GetRuntimeMemorySizeEv
,__ZNK10MeshFilter26GetTypeInfoVirtualInternalEv,__ZNK12MeshRenderer26GetTypeInfoVirtualInternalEv,__ZNK12MeshRenderer19GetStaticBatchIndexEv,__ZThn32_NK12MeshRenderer19GetStaticBatchIndexEv,__ZNK19SkinnedMeshRenderer26GetTypeInfoVirtualInternalEv,__ZNK14SpriteRenderer26GetTypeInfoVirtualInternalEv,__ZNK18ProceduralMaterial26GetTypeInfoVirtualInternalEv,__ZNK8Material20GetRuntimeMemorySizeEv,__ZNK17ProceduralTexture26GetTypeInfoVirtualInternalEv,__ZN17ProceduralTexture39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK17ProceduralTexture9HasMipMapEv,__ZNK17ProceduralTexture14GetMipmapCountEv,__ZNK17ProceduralTexture12GetDataWidthEv,__ZNK17ProceduralTexture13GetDataHeightEv,__ZNK17ProceduralTexture12GetDimensionEv,__ZNK17ProceduralTexture20GetStorageMemorySizeEv,__ZNK16SubstanceArchive26GetTypeInfoVirtualInternalEv,__ZNK12InputManager26GetTypeInfoVirtualInternalEv,__ZNK11TimeManager26GetTypeInfoVirtualInternalEv,__ZN14AsyncOperation11GetPriorityEv,__ZNK13BuildSettings26GetTypeInfoVirtualInternalEv,__ZNK14PlayerSettings26GetTypeInfoVirtualInternalEv,__ZNK15ResourceManager26GetTypeInfoVirtualInternalEv,__ZN15ResourceManager39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK30RuntimeInitializeOnLoadManager26GetTypeInfoVirtualInternalEv,__ZN9WWWCached7GetDataEv,__ZNK9WWWCached14GetPartialDataEv,__ZN9WWWCached7GetSizeEv,__ZNK9WWWCached14GetPartialSizeEv,__ZN9WWWCached8GetErrorEv
,__ZNK9WWWCached6GetUrlEv,__ZN9WWWCached23HasDownloadedOrMayBlockEv,__ZNK9WWWCached7GetTypeEv,__ZNK9WWWCached17IsDownloadingDoneEv,__ZNK10MonoScript26GetTypeInfoVirtualInternalEv,__ZN10MonoScript39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK10MonoScript18GetScriptClassNameEv,__ZNK13MonoBehaviour26GetTypeInfoVirtualInternalEv,__ZNK13MonoBehaviour7GetNameEv,__ZNK13MonoBehaviour25GetNeedsPerObjectTypeTreeEv,__ZN13MonoBehaviour26CalculateSupportedMessagesEv,__ZNK13MonoBehaviour10HasEnabledEv,__ZN16PlayerConnection8IsServerEv,__ZN17MemoryCacheWriter12GetCacheSizeEv,__ZN18LoadSceneOperation23GetAllowSceneActivationEv,__ZN18LoadSceneOperation21MustCompleteNextFrameEv,__ZNK11PreloadData26GetTypeInfoVirtualInternalEv,__ZN11PreloadData39ShouldIgnoreInGarbageDependencyTrackingEv,__ZNK27UnloadUnusedAssetsOperation25GetAllowParallelExecutionEv,__ZNK11MonoManager26GetTypeInfoVirtualInternalEv,__ZNK9TextAsset26GetTypeInfoVirtualInternalEv,__ZNK9TextAsset18GetScriptClassNameEv,__ZN17MemoryCacheReader12GetCacheSizeEv,__ZN17MemoryCacheReader13GetFileLengthEv,__ZN17MemoryCacheReader18GetAddressOfMemoryEv,__ZN14FileCacherRead12GetCacheSizeEv,__ZN14FileCacherRead13GetFileLengthEv,__ZN15CacheReaderBase18GetAddressOfMemoryEv,__ZN22MemoryCacherReadBlocks12GetCacheSizeEv,__ZN22MemoryCacherReadBlocks13GetFileLengthEv
,__ZN22MemoryCacherReadBlocks18GetAddressOfMemoryEv,__ZNK13ComputeShader26GetTypeInfoVirtualInternalEv,__ZNK8Material26GetTypeInfoVirtualInternalEv,__ZNK6Shader26GetTypeInfoVirtualInternalEv,__ZNK6Shader7GetNameEv,__ZNK6Shader18GetScriptClassNameEv,__ZNK12ScriptMapper26GetTypeInfoVirtualInternalEv,__ZNK9CGProgram26GetTypeInfoVirtualInternalEv,__ZNK9CGProgram18GetScriptClassNameEv,__ZNK23ShaderVariantCollection26GetTypeInfoVirtualInternalEv,__ZNK18SpeedTreeWindAsset26GetTypeInfoVirtualInternalEv,__ZNK8WindZone26GetTypeInfoVirtualInternalEv,__ZN24UserAuthorizationManager33UserAuthorizationManagerOperation6IsDoneEv,__ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation6IsDoneEv,__ZNK13Lz4Compressor7GetTypeEv,__ZNK15Lz4Decompressor7GetTypeEv,__ZN17ArchiveFileSystem4NameEv,__ZNK15ArchiveReadFile6IsOpenEv,__ZN15ArchiveReadFile5CloseEv,__ZNK15ArchiveReadFile8PositionEv,__ZNK15ArchiveReadFile4SizeEv,__ZN15ArchiveReadFile5FlushEv,__ZN12HandlerChain4NameEv,__ZNK10MemoryFile6IsOpenEv,__ZN10MemoryFile5CloseEv,__ZNK10MemoryFile8PositionEv,__ZNK10MemoryFile4SizeEv,__ZN10MemoryFile5FlushEv,__ZN16MemoryFileSystem4NameEv,__ZNK25MultiBlocksMemoryFileData4SizeEv
,__ZNK25MultiBlocksMemoryFileData5CloneEv,__ZNK24RingBufferMemoryFileData4SizeEv,__ZNK24RingBufferMemoryFileData5CloneEv,__ZNK25SingleBlockMemoryFileData4SizeEv,__ZNK25SingleBlockMemoryFileData5CloneEv,__ZNK8WWWAudio6IsDoneEv,__ZNK8WWWAudio11GetCapacityEv,__ZNK8WWWAudio14GetPartialDataEv,__ZNK8WWWAudio14GetPartialSizeEv,__ZNK12SocketStream10IsBlockingEv,__ZNK12SocketStream11IsConnectedEv,__ZNK12SocketStream23IsArtificiallyConnectedEv,__ZN12SocketStream15WouldBlockErrorEv,__ZN12SocketStream16InterruptedErrorEv,__ZN12SocketStream8ShutdownEv,__ZNK20BufferedSocketStream10IsBlockingEv,__ZNK20BufferedSocketStream11IsConnectedEv,__ZNK20BufferedSocketStream23IsArtificiallyConnectedEv,__ZN20BufferedSocketStream15WouldBlockErrorEv,__ZN20BufferedSocketStream8ShutdownEv,__ZN21AssetBundleFileSystem4NameEv,__ZNK13GfxDeviceGLES14GetDeviceLevelEv,__ZN13GfxDeviceGLES12GetSRGBWriteEv,__ZNK13GfxDeviceGLES12GetWireframeEv,__ZNK13GfxDeviceGLES16IsScissorEnabledEv,__ZN13GfxDeviceGLES17CreateIndexBufferEv,__ZN13GfxDeviceGLES18CreateVertexBufferEv,__ZN13GfxDeviceGLES23CreateGPUSkinPoseBufferEv,__ZNK13GfxDeviceGLES27GetActiveRenderDepthSurfaceEv,__ZNK13GfxDeviceGLES26GetActiveRenderTargetCountEv
,__ZN13GfxDeviceGLES14GetPresentModeEv,__ZN13GfxDeviceGLES12IsValidStateEv,__ZN13GfxDeviceGLES18HandleInvalidStateEv,__ZN13GfxDeviceGLES16CreateTimerQueryEv,__ZNK13GfxDeviceGLES18GetDefaultRTFormatEv,__ZNK13GfxDeviceGLES21GetDefaultHDRRTFormatEv,__ZNK13GfxDeviceGLES26HasActiveRandomWriteTargetEv,__ZN13GfxDeviceGLES16CreateDynamicVBOEv,__ZNK13GfxDeviceGLES18GetCurrentTargetAAEv,__ZNK17GPUSkinPoseBuffer12GetBoneCountEv,__ZNK9GfxBuffer6IsLostEv,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4syncEv,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9showmanycEv,__ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5uflowEv,__ZN13GfxDeviceNull12GetSRGBWriteEv,__ZNK13GfxDeviceNull12GetWireframeEv,__ZNK13GfxDeviceNull18GetWorldViewMatrixEv,__ZNK13GfxDeviceNull14GetWorldMatrixEv,__ZNK13GfxDeviceNull13GetViewMatrixEv,__ZNK13GfxDeviceNull19GetProjectionMatrixEv,__ZNK13GfxDeviceNull25GetDeviceProjectionMatrixEv,__ZNK13GfxDeviceNull16IsScissorEnabledEv,__ZN13GfxDeviceNull17CreateIndexBufferEv,__ZN13GfxDeviceNull18CreateVertexBufferEv,__ZNK13GfxDeviceNull27GetActiveRenderDepthSurfaceEv,__ZNK13GfxDeviceNull26GetActiveRenderTargetCountEv,__ZN13GfxDeviceNull14GetPresentModeEv,__ZN13GfxDeviceNull12IsValidStateEv,__ZN13GfxDeviceNull16CreateTimerQueryEv
,__ZN13GfxDeviceNull16CreateDynamicVBOEv,__ZN11UmbraModule18CreateShadowCullerEv,__ZNK14ParticleSystem26GetTypeInfoVirtualInternalEv,__ZNK22ParticleSystemRenderer26GetTypeInfoVirtualInternalEv,__ZNK5physx3Cct13BoxController7getTypeEv,__ZNK5physx3Cct13BoxController11getPositionEv,__ZNK5physx3Cct13BoxController8getActorEv,__ZNK5physx3Cct13BoxController18getNonWalkableModeEv,__ZN5physx3Cct13BoxController8getSceneEv,__ZNK5physx3Cct13BoxController11getUserDataEv,__ZN5physx3Cct13BoxController15getPxControllerEv,__ZThn8_N5physx3Cct13BoxController15getPxControllerEv,__ZNK5physx3Cct17CapsuleController7getTypeEv,__ZNK5physx3Cct17CapsuleController11getPositionEv,__ZNK5physx3Cct17CapsuleController8getActorEv,__ZNK5physx3Cct17CapsuleController18getNonWalkableModeEv,__ZN5physx3Cct17CapsuleController8getSceneEv,__ZNK5physx3Cct17CapsuleController11getUserDataEv,__ZNK5physx3Cct17CapsuleController15getClimbingModeEv,__ZN5physx3Cct17CapsuleController15getPxControllerEv,__ZThn8_N5physx3Cct17CapsuleController15getPxControllerEv,__ZNK5physx3Cct26CharacterControllerManager8getSceneEv,__ZNK5physx3Cct26CharacterControllerManager16getNbControllersEv,__ZN5physx3Cct26CharacterControllerManager15getRenderBufferEv,__ZNK5physx3Cct26CharacterControllerManager21getNbObstacleContextsEv,__ZN5physx3Cct26CharacterControllerManager21createObstacleContextEv,__ZNK5physx3Cct15ObstacleContext20getControllerManagerEv,__ZNK5physx3Cct15ObstacleContext14getNbObstaclesEv,__ZNK5physx2Cm12RenderBuffer11getNbPointsEv,__ZNK5physx2Cm12RenderBuffer9getPointsEv
,__ZNK5physx2Cm12RenderBuffer10getNbLinesEv,__ZNK5physx2Cm12RenderBuffer8getLinesEv,__ZNK5physx2Cm12RenderBuffer14getNbTrianglesEv,__ZNK5physx2Cm12RenderBuffer12getTrianglesEv,__ZNK5physx2Cm12RenderBuffer10getNbTextsEv,__ZNK5physx2Cm12RenderBuffer8getTextsEv,__ZNK5physx9PxD6Joint19getConcreteTypeNameEv,__ZNK5physx6PxBase12isReleasableEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18getConstraintFlagsEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8getSceneEv,__ZN5physx3Ext7D6Joint11prepareDataEv,__ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext7D6Joint11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv,__ZN5physx3Ext23DefaultBufferedProfiler21getProfileZoneManagerEv,__ZNK5physx3Ext20DefaultCpuDispatcher14getWorkerCountEv,__ZNK5physx3Ext20DefaultCpuDispatcher14getRunProfiledEv,__ZNK18PhysxJobDispatcher14getWorkerCountEv,__ZNK5physx14PxLightCpuTask12getReferenceEv,__ZNK14CompletionTask7getNameEv,__ZNK5physx27PxDefaultMemoryOutputStream7getSizeEv,__ZNK5physx27PxDefaultMemoryOutputStream7getDataEv,__ZNK5physx24PxDefaultMemoryInputData9getLengthEv,__ZNK5physx24PxDefaultMemoryInputData4tellEv,__ZN5physx25PxDefaultFileOutputStream7isValidEv,__ZNK5physx22PxDefaultFileInputData9getLengthEv,__ZNK5physx22PxDefaultFileInputData4tellEv,__ZNK5physx15PxDistanceJoint19getConcreteTypeNameEv
,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18getConstraintFlagsEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8getSceneEv,__ZNK5physx3Ext13DistanceJoint21getDistanceJointFlagsEv,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv,__ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv,__ZNK5physx12PxFixedJoint19getConcreteTypeNameEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18getConstraintFlagsEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8getSceneEv,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv,__ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv,__ZNK5physx16PxPrismaticJoint19getConcreteTypeNameEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18getConstraintFlagsEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8getSceneEv,__ZNK5physx3Ext14PrismaticJoint22getPrismaticJointFlagsEv,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv,__ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv,__ZNK5physx15PxRevoluteJoint19getConcreteTypeNameEv,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18getConstraintFlagsEv
,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8getSceneEv,__ZNK5physx3Ext13RevoluteJoint21getRevoluteJointFlagsEv,__ZN5physx3Ext13RevoluteJoint11prepareDataEv,__ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext13RevoluteJoint11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv,__ZNK5physx16PxSphericalJoint19getConcreteTypeNameEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18getConstraintFlagsEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getConstraintEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7getNameEv,__ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8getSceneEv,__ZNK5physx3Ext14SphericalJoint22getSphericalJointFlagsEv,__ZN5physx3Ext14SphericalJoint11prepareDataEv,__ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv,__ZThn12_N5physx3Ext14SphericalJoint11prepareDataEv,__ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv,__ZNK5physx2Sn22DeserializationContext15getPhysXVersionEv,__ZNK5physx2Sn20SerializationContext13getCollectionEv,__ZN5physx2Sn20SerializationContext18getTotalStoredSizeEv,__ZN5physx18RepXSerializerImplINS_10PxMaterialEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_7PxShapeEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_14PxArticulationEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_11PxAggregateEE11getTypeNameEv
,__ZN5physx18RepXSerializerImplINS_13PxClothFabricEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_7PxClothEE11getTypeNameEv,__ZNK5physx11PxAggregate19getConcreteTypeNameEv,__ZNK5physx11NpAggregate11getNbActorsEv,__ZNK5physx11NpAggregate14getMaxNbActorsEv,__ZN5physx11NpAggregate8getSceneEv,__ZNK5physx11NpAggregate16getSelfCollisionEv,__ZNK5physx2Sc16ActorInteraction13getNPhaseCoreEv,__ZThn24_NK5physx2Sc16ActorInteraction13getNPhaseCoreEv,__ZNK5physx2Sc10ClothShape8isActiveEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx14PxArticulation19getConcreteTypeNameEv,__ZNK5physx14NpArticulation8getSceneEv,__ZNK5physx14NpArticulation26getMaxProjectionIterationsEv,__ZNK5physx14NpArticulation26getInternalDriveIterationsEv,__ZNK5physx14NpArticulation26getExternalDriveIterationsEv,__ZNK5physx14NpArticulation10isSleepingEv,__ZNK5physx14NpArticulation10getNbLinksEv,__ZNK5physx14NpArticulation7getNameEv,__ZNK5physx14NpArticulation12getAggregateEv,__ZNK5physx19PxArticulationJoint19getConcreteTypeNameEv,__ZNK5physx19NpArticulationJoint12getDriveTypeEv,__ZNK5physx19NpArticulationJoint20getSwingLimitEnabledEv,__ZNK5physx19NpArticulationJoint20getTwistLimitEnabledEv,__ZNK5physx19NpArticulationJoint13isSubordinateEv,__ZNK5physx18PxArticulationLink19getConcreteTypeNameEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE7getNameEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE17getDominanceGroupEv
,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE22getClientBehaviorFlagsEv,__ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE12getAggregateEv,__ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11getNbShapesEv,__ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE16getNbConstraintsEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20getRigidDynamicFlagsEv,__ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getRigidBodyFlagsEv,__ZNK5physx18NpArticulationLink7getTypeEv,__ZNK5physx18NpArticulationLink15getArticulationEv,__ZNK5physx18NpArticulationLink15getInboundJointEv,__ZNK5physx18NpArticulationLink13getNbChildrenEv,__ZNK5physx18NpArticulationLink13isSubordinateEv,__ZNK5physx12NpBatchQuery18getPreFilterShaderEv,__ZNK5physx12NpBatchQuery19getPostFilterShaderEv,__ZNK5physx12NpBatchQuery19getFilterShaderDataEv,__ZNK5physx12NpBatchQuery23getFilterShaderDataSizeEv,__ZNK5physx12NpBatchQuery14getOwnerClientEv,__ZN5physx12NpBatchQuery13getUserMemoryEv,__ZN5physx12NpBatchQuery11getRunOnSpuEv,__ZNK5physx12NpBatchQuery7getDescEv,__ZNK5physx12PxConstraint19getConcreteTypeNameEv,__ZNK5physx12NpConstraint8getSceneEv,__ZNK5physx12NpConstraint8getFlagsEv,__ZNK5physx12NpConstraint7isValidEv,__ZNK5physx12NpConstraint13isSubordinateEv,__ZNK5physx10PxMaterial19getConcreteTypeNameEv,__ZNK5physx10NpMaterial17getReferenceCountEv,__ZNK5physx10NpMaterial8getFlagsEv,__ZNK5physx10NpMaterial22getFrictionCombineModeEv,__ZNK5physx10NpMaterial25getRestitutionCombineModeEv
,__ZN5physx9NpPhysics13getFoundationEv,__ZN5physx9NpPhysics17getVisualDebuggerEv,__ZN5physx9NpPhysics23getPvdConnectionManagerEv,__ZN5physx9NpPhysics21getProfileZoneManagerEv,__ZNK5physx9NpPhysics18getTolerancesScaleEv,__ZNK5physx9NpPhysics19getNbTriangleMeshesEv,__ZNK5physx9NpPhysics17getNbHeightFieldsEv,__ZNK5physx9NpPhysics17getNbConvexMeshesEv,__ZNK5physx9NpPhysics17getNbClothFabricsEv,__ZNK5physx9NpPhysics11getNbScenesEv,__ZNK5physx9NpPhysics11getNbShapesEv,__ZN5physx9NpPhysics18createArticulationEv,__ZNK5physx9NpPhysics14getNbMaterialsEv,__ZN5physx9NpPhysics27getPhysicsInsertionCallbackEv,__ZN5physx9NpPhysics14getProfileZoneEv,__ZNK5physx7PxShape19getConcreteTypeNameEv,__ZNK5physx7NpShape15getGeometryTypeEv,__ZNK5physx7NpShape8getActorEv,__ZNK5physx7NpShape14getNbMaterialsEv,__ZNK5physx7NpShape8getFlagsEv,__ZNK5physx7NpShape11isExclusiveEv,__ZNK5physx7NpShape7getNameEv,__ZNK5physx7PxCloth19getConcreteTypeNameEv,__ZNK5physx7NpCloth7getTypeEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE7getNameEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE17getDominanceGroupEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_7PxClothEE22getClientBehaviorFlagsEv
,__ZNK5physx15NpActorTemplateINS_7PxClothEE12getAggregateEv,__ZNK5physx7NpCloth9getFabricEv,__ZNK5physx7NpCloth14getNbParticlesEv,__ZNK5physx7NpCloth16lockParticleDataEv,__ZNK5physx7NpCloth13getClothFlagsEv,__ZNK5physx7NpCloth26getNbParticleAccelerationsEv,__ZNK5physx7NpCloth22getNbMotionConstraintsEv,__ZNK5physx7NpCloth26getNbSeparationConstraintsEv,__ZNK5physx7NpCloth21getNbCollisionSpheresEv,__ZNK5physx7NpCloth22getNbCollisionCapsulesEv,__ZNK5physx7NpCloth20getNbCollisionPlanesEv,__ZNK5physx7NpCloth22getNbCollisionConvexesEv,__ZNK5physx7NpCloth23getNbCollisionTrianglesEv,__ZNK5physx7NpCloth21getNbVirtualParticlesEv,__ZNK5physx7NpCloth27getNbVirtualParticleWeightsEv,__ZNK5physx7NpCloth25getNbSelfCollisionIndicesEv,__ZNK5physx7NpCloth18getNbRestPositionsEv,__ZNK5physx7NpCloth10isSleepingEv,__ZN5physx19NpClothParticleData18getDataAccessFlagsEv,__ZNK5physx15PxParticleFluid19getConcreteTypeNameEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7getTypeEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE7getNameEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE17getDominanceGroupEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE22getClientBehaviorFlagsEv,__ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE12getAggregateEv,__ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getParticleBaseFlagsEv
,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getMaxParticlesEv,__ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE24getParticleReadDataFlagsEv,__ZNK5physx15NpParticleFluid7getTypeEv,__ZN5physx15NpParticleFluid25lockParticleFluidReadDataEv,__ZNK5physx15PxsParticleData16getMaxParticlesVEv,__ZNK5physx15PxsParticleData17getParticleCountVEv,__ZN5physx23NpParticleFluidReadData18getDataAccessFlagsEv,__ZNK5physx16PxParticleSystem19getConcreteTypeNameEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7getTypeEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE7getNameEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE17getDominanceGroupEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE22getClientBehaviorFlagsEv,__ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE12getAggregateEv,__ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getParticleBaseFlagsEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getMaxParticlesEv,__ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE24getParticleReadDataFlagsEv,__ZNK5physx16NpParticleSystem7getTypeEv,__ZNK5physx14PxRigidDynamic19getConcreteTypeNameEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE7getNameEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE17getDominanceGroupEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE22getClientBehaviorFlagsEv,__ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE12getAggregateEv,__ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11getNbShapesEv
,__ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE16getNbConstraintsEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20getRigidDynamicFlagsEv,__ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getRigidBodyFlagsEv,__ZNK5physx14NpRigidDynamic7getTypeEv,__ZNK5physx14NpRigidDynamic10isSleepingEv,__ZNK5physx13PxRigidStatic19getConcreteTypeNameEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE8getSceneEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE7getNameEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE13getActorFlagsEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE17getDominanceGroupEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE14getOwnerClientEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE22getClientBehaviorFlagsEv,__ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE12getAggregateEv,__ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11getNbShapesEv,__ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE16getNbConstraintsEv,__ZNK5physx13NpRigidStatic7getTypeEv,__ZNK5physx7NpScene8getFlagsEv,__ZN5physx7NpScene10getPhysicsEv,__ZNK5physx7NpScene12getTimestampEv,__ZNK5physx7NpScene18getNbArticulationsEv,__ZNK5physx7NpScene16getNbConstraintsEv,__ZNK5physx7NpScene15getNbAggregatesEv,__ZNK5physx7NpScene16getCpuDispatcherEv,__ZNK5physx7NpScene16getGpuDispatcherEv,__ZNK5physx7NpScene16getSpuDispatcherEv,__ZN5physx7NpScene12createClientEv,__ZNK5physx7NpScene34getClothInterCollisionNbIterationsEv,__ZNK5physx7NpScene24getContactModifyCallbackEv,__ZNK5physx7NpScene27getCCDContactModifyCallbackEv,__ZNK5physx7NpScene19getFilterShaderDataEv
,__ZNK5physx7NpScene23getFilterShaderDataSizeEv,__ZNK5physx7NpScene15getFilterShaderEv,__ZNK5physx7NpScene17getFilterCallbackEv,__ZNK5physx7NpScene15getCCDMaxPassesEv,__ZNK5physx7NpScene15getFrictionTypeEv,__ZNK5physx7NpScene26getVisualizationCullingBoxEv,__ZN5physx7NpScene15getRenderBufferEv,__ZNK5physx7NpScene18getStaticStructureEv,__ZNK5physx7NpScene19getDynamicStructureEv,__ZNK5physx7NpScene29getDynamicTreeRebuildRateHintEv,__ZNK5physx7NpScene28getSceneQueryStaticTimestampEv,__ZNK5physx7NpScene17getBroadPhaseTypeEv,__ZNK5physx7NpScene22getNbBroadPhaseRegionsEv,__ZNK5physx7NpScene14getTaskManagerEv,__ZNK5physx7NpScene26getNbContactDataBlocksUsedEv,__ZNK5physx7NpScene29getMaxNbContactDataBlocksUsedEv,__ZNK5physx7NpScene32getContactReportStreamBufferSizeEv,__ZNK5physx7NpScene18getSolverBatchSizeEv,__ZN5physx7NpScene14getTaskManagerEv,__ZNK5physx7NpScene15SceneCompletion7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Sc21ElementSimInteraction13getNPhaseCoreEv,__ZNK5physx2Sc21ElementSimInteraction23isLastFilterInteractionEv,__ZNK5physx13NpVolumeCache7isValidEv,__ZN5physx13NpVolumeCache17getNbCachedShapesEv,__ZN5physx13NpVolumeCache20getMaxNbStaticShapesEv,__ZN5physx13NpVolumeCache21getMaxNbDynamicShapesEv,__ZNK5physx2Cm10FanoutTask7getNameEv
,__ZNK5physx2Cm10FanoutTask12getReferenceEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx17PxsCCDAdvanceTask7getNameEv,__ZNK5physx16PxBroadPhaseBase12getNbRegionsEv,__ZNK5physx16PxBroadPhaseBase24getNumOutOfBoundsObjectsEv,__ZNK5physx16PxBroadPhaseBase21getOutOfBoundsObjectsEv,__ZNK5physx23PxsBroadPhaseContextSap7getTypeEv,__ZNK5physx23PxsBroadPhaseContextSap18getNumCreatedPairsEv,__ZN5physx23PxsBroadPhaseContextSap15getCreatedPairsEv,__ZNK5physx23PxsBroadPhaseContextSap18getNumDeletedPairsEv,__ZN5physx23PxsBroadPhaseContextSap15getDeletedPairsEv,__ZNK5physx17SapUpdateWorkTask7getNameEv
,__ZNK5physx21SapPostUpdateWorkTask7getNameEv,__ZNK5physx29BroadPhaseBatchUpdateWorkTask7getNameEv,__ZNK5physx16PxsBroadPhaseMBP12getNbRegionsEv,__ZNK5physx16PxsBroadPhaseMBP24getNumOutOfBoundsObjectsEv,__ZNK5physx16PxsBroadPhaseMBP21getOutOfBoundsObjectsEv,__ZNK5physx16PxsBroadPhaseMBP7getTypeEv,__ZNK5physx16PxsBroadPhaseMBP18getNumCreatedPairsEv,__ZN5physx16PxsBroadPhaseMBP15getCreatedPairsEv,__ZNK5physx16PxsBroadPhaseMBP18getNumDeletedPairsEv,__ZN5physx16PxsBroadPhaseMBP15getDeletedPairsEv,__ZNK5physx21MBPPostUpdateWorkTask7getNameEv,__ZNK5physx17MBPUpdateWorkTask7getNameEv,__ZNK5physx10BPWorkTask7getNameEv,__ZNK5physx20ProcessBPResultsTask7getNameEv,__ZNK5physx20AggregateOverlapTask7getNameEv,__ZNK5physx17AggregateAABBTask7getNameEv,__ZNK5physx23AggregateAABBUpdateTask7getNameEv,__ZNK5physx13ActorAABBTask7getNameEv,__ZNK5physx19ActorAABBUpdateTask7getNameEv,__ZNK5physx14SingleAABBTask7getNameEv,__ZNK5physx20SingleAABBUpdateTask7getNameEv,__ZNK5physx9PxTaskMgr16getCpuDispatcherEv,__ZNK5physx9PxTaskMgr16getGpuDispatcherEv,__ZNK5physx9PxTaskMgr16getSpuDispatcherEv,__ZNK5physx2Sc23ElementActorInteraction23isLastFilterInteractionEv,__ZNK23PxsCMDiscreteUpdateTask7getNameEv,__ZNK5physx18PxsSolverStartTask7getNameEv,__ZNK5physx16PxsSolverEndTask7getNameEv,__ZNK5physx38PxsSolverCreateFinalizeConstraintsTask7getNameEv,__ZNK5physx23PxsSolverSetupSolveTask7getNameEv
,__ZNK5physx32PxsSolverConstraintPartitionTask7getNameEv,__ZNK21PxsParallelSolverTask7getNameEv,__ZNK29PxsCreateFinalizeContactsTask7getNameEv,__ZNK5physx34PxsSolverConstraintPostProcessTask7getNameEv,__ZNK20PxsAtomIntegrateTask7getNameEv,__ZNK18ScBeforeSolverTask7getNameEv,__ZNK22ScAfterIntegrationTask7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx15PxsCCDSweepTask7getNameEv,__ZNK5physx2Sc19ParticlePacketShape8isActiveEv,__ZNK5physx13PxClothFabric19getConcreteTypeNameEv,__ZNK5physx13NpClothFabric14getNbParticlesEv,__ZNK5physx13NpClothFabric11getNbPhasesEv,__ZNK5physx13NpClothFabric15getNbRestvaluesEv,__ZNK5physx13NpClothFabric9getNbSetsEv,__ZNK5physx13NpClothFabric20getNbParticleIndicesEv,__ZNK5physx13NpClothFabric12getNbTethersEv,__ZNK5physx13NpClothFabric17getReferenceCountEv,__ZNK5physx12PxConvexMesh19getConcreteTypeNameEv,__ZNK5physx2Gu10ConvexMesh13getNbVerticesEv,__ZNK5physx2Gu10ConvexMesh11getVerticesEv,__ZNK5physx2Gu10ConvexMesh14getIndexBufferEv,__ZNK5physx2Gu10ConvexMesh13getNbPolygonsEv,__ZNK5physx2Gu10ConvexMesh17getReferenceCountEv,__ZNK5physx13PxHeightField19getConcreteTypeNameEv,__ZNK5physx2Gu11HeightField9getNbRowsEv,__ZNK5physx2Gu11HeightField12getNbColumnsEv,__ZNK5physx2Gu11HeightField9getFormatEv
,__ZNK5physx2Gu11HeightField15getSampleStrideEv,__ZNK5physx2Gu11HeightField8getFlagsEv,__ZNK5physx2Gu11HeightField17getReferenceCountEv,__ZNK5physx14PxTriangleMesh19getConcreteTypeNameEv,__ZNK5physx2Gu12TriangleMesh13getNbVerticesEv,__ZNK5physx2Gu12TriangleMesh11getVerticesEv,__ZNK5physx2Gu12TriangleMesh14getNbTrianglesEv,__ZNK5physx2Gu12TriangleMesh12getTrianglesEv,__ZNK5physx2Gu12TriangleMesh20getTriangleMeshFlagsEv,__ZNK5physx2Gu12TriangleMesh17getTrianglesRemapEv,__ZNK5physx2Gu12TriangleMesh17getReferenceCountEv,__ZNK5physx16PxsParticleShape12getUserDataVEv,__ZN5physx20PxsParticleSystemSim17getParticleStateVEv,__ZNK5physx20PxsParticleSystemSim24getExternalAccelerationVEv,__ZNK5physx20PxsParticleSystemSim12isSimulatedVEv,__ZN5physx7Cooking9getParamsEv,__ZN5physx7Cooking16platformMismatchEv,__ZNK5physx6shdfnd10Foundation16getErrorCallbackEv,__ZNK5physx6shdfnd10Foundation13getErrorLevelEv,__ZNK5physx6shdfnd10Foundation12getAllocatorEv,__ZNK5physx6shdfnd10Foundation20getAllocatorCallbackEv,__ZNK5physx6shdfnd10Foundation24getReportAllocationNamesEv,__ZNK5physx2Cm10Collection12getNbObjectsEv,__ZNK5physx2Cm10Collection8getNbIdsEv,__ZN5physx6shdfnd18BufferedSocketImpl5flushEv,__ZN5physx6shdfnd10SocketImpl5flushEv,__ZNK11BoxCollider26GetTypeInfoVirtualInternalEv,__ZNK8Collider10HasEnabledEv,__ZNK8Collider10GetEnabledEv,__ZNK8Collider16SupportsMaterialEv
,__ZNK8Collider15SupportsTriggerEv,__ZN8Collider12GetIsTriggerEv,__ZNK8Collider12GetRigidbodyEv,__ZNK8Collider26GetTypeInfoVirtualInternalEv,__ZNK15CapsuleCollider26GetTypeInfoVirtualInternalEv,__ZNK19CharacterController26GetTypeInfoVirtualInternalEv,__ZNK5physx23PxCapsuleControllerDesc7isValidEv,__ZNK5Unity14CharacterJoint26GetTypeInfoVirtualInternalEv,__ZNK5Unity17ConfigurableJoint26GetTypeInfoVirtualInternalEv,__ZNK13ConstantForce26GetTypeInfoVirtualInternalEv,__ZNK5Unity10FixedJoint26GetTypeInfoVirtualInternalEv,__ZNK5Unity10HingeJoint26GetTypeInfoVirtualInternalEv,__ZNK5Unity5Joint26GetTypeInfoVirtualInternalEv,__ZNK12MeshCollider26GetTypeInfoVirtualInternalEv,__ZNK14PhysicMaterial26GetTypeInfoVirtualInternalEv,__ZNK14PhysicsManager26GetTypeInfoVirtualInternalEv,__ZNK9Rigidbody26GetTypeInfoVirtualInternalEv,__ZNK14SphereCollider26GetTypeInfoVirtualInternalEv,__ZNK5Unity11SpringJoint26GetTypeInfoVirtualInternalEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv,__ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv,__ZThn116_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv,__ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_12PxFixedJointEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_9PxD6JointEE11getTypeNameEv
,__ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE11getTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12getClassSizeEv
,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12getClassSizeEv
,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12getClassSizeEv,__ZNK12_GLOBAL__N_118LegacySerialStream13getCollectionEv,__ZN5physx22XmlMemoryAllocatorImpl12getAllocatorEv,__ZN5physx2Sn12RepXUpgrader34upgrade10CollectionTo3_1CollectionERNS0_14RepXCollectionE,__ZN5physx2Sn12RepXUpgrader35upgrade3_1CollectionTo3_2CollectionERNS0_14RepXCollectionE,__ZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionE,__ZN5physx2Sn18RepXCollectionImpl10getVersionEv,__ZNK5physx2Sn18RepXCollectionImpl5beginEv,__ZNK5physx2Sn18RepXCollectionImpl3endEv,__ZN5physx2Sn18RepXCollectionImpl16createNodeEditorEv,__ZN5physx2Sn18RepXCollectionImpl12getAllocatorEv,__ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8tabCountEv,__ZN5physx2Sn13XmlNodeWriter8tabCountEv,__ZN5physx2Sn13XmlNodeReader14gotoFirstChildEv,__ZN5physx2Sn13XmlNodeReader15gotoNextSiblingEv,__ZN5physx2Sn13XmlNodeReader13countChildrenEv,__ZN5physx2Sn13XmlNodeReader18getCurrentItemNameEv,__ZN5physx2Sn13XmlNodeReader19getCurrentItemValueEv,__ZN5physx2Sn13XmlNodeReader10leaveChildEv,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE7getNameEv
,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx21PxsFluidCollisionTask7getNameEv,__ZNK5physx23PxsFluidDynamicsSphTask7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE7getNameEv,__ZNK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv,__ZThn4_NK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv,__ZN12_GLOBAL__N_110Connection16createDataStreamEv,__ZN12_GLOBAL__N_110Connection14createRendererEv,__ZN12_GLOBAL__N_110Connection18getConnectionStateEv,__ZN12_GLOBAL__N_110Connection17getConnectionTypeEv,__ZN12_GLOBAL__N_110Connection11isConnectedEv,__ZN12_GLOBAL__N_110Connection13lockOutStreamEv,__ZN12_GLOBAL__N_117EventBufferClient11isConnectedEv,__ZN12_GLOBAL__N_116MetaDataProvider4lockEv,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12getNbClassesEv,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl21getNbPropertyMessagesEv,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getStringTableEv,__ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5cloneEv,__ZN12_GLOBAL__N_115StringTableImpl9getNbStrsEv,__ZN12_GLOBAL__N_111StreamOwner4lockEv,__ZN12_GLOBAL__N_111StreamOwner11getInStreamEv,__ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv,__ZN12_GLOBAL__N_111StreamOwner5flushEv,__ZN12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv,__ZN12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv,__ZThn4_NK12_GLOBAL__N_111StreamOwner11isConnectedEv
,__ZThn4_N12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv,__ZThn8_NK12_GLOBAL__N_111StreamOwner11isConnectedEv,__ZThn8_N12_GLOBAL__N_111StreamOwner5flushEv,__ZThn8_N12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv,__ZNK12_GLOBAL__N_123DoubleBufferedOutStream11isConnectedEv,__ZN12_GLOBAL__N_123DoubleBufferedOutStream5flushEv,__ZN12_GLOBAL__N_123DoubleBufferedOutStream18getWrittenDataSizeEv,__ZN12_GLOBAL__N_110DataStream19endSetPropertyValueEv,__ZN12_GLOBAL__N_110DataStream23endPropertyMessageGroupEv,__ZN12_GLOBAL__N_110DataStream11isConnectedEv,__ZN12_GLOBAL__N_110DataStream27getPropertyDefinitionHelperEv,__ZN12_GLOBAL__N_110DataStream5flushEv,__ZN12_GLOBAL__N_124PropertyDefinitionHelper10getTopNameEv,__ZNK12_GLOBAL__N_112UserRenderer10hasClientsEv,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE6isGoodEv,__ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE7hasDataEv,__ZN12_GLOBAL__N_117ConnectionManager29getAndAddRefCurrentConnectionEv,__ZN12_GLOBAL__N_117ConnectionManager11isConnectedEv,__ZNK12_GLOBAL__N_123FStreamNetworkOutStream11isConnectedEv,__ZN12_GLOBAL__N_123FStreamNetworkOutStream5flushEv,__ZN12_GLOBAL__N_123FStreamNetworkOutStream18getWrittenDataSizeEv,__ZNK12_GLOBAL__N_121SocketNetworkInStream11isConnectedEv,__ZN12_GLOBAL__N_121SocketNetworkInStream17getLoadedDataSizeEv,__ZNK12_GLOBAL__N_122SocketNetworkOutStream11isConnectedEv,__ZN12_GLOBAL__N_122SocketNetworkOutStream5flushEv,__ZN12_GLOBAL__N_122SocketNetworkOutStream18getWrittenDataSizeEv,__ZN12_GLOBAL__N_112RenderReaderILb1EE6isGoodEv,__ZN12_GLOBAL__N_112RenderReaderILb1EE7hasDataEv,__ZN12_GLOBAL__N_112RenderReaderILb0EE6isGoodEv,__ZN12_GLOBAL__N_112RenderReaderILb0EE7hasDataEv
,__ZN5physx6shdfnd7FastIPC16pumpPendingSendsEv,__ZN5physx6shdfnd7FastIPC18receiveAcknowledgeEv,__ZNK5physx6shdfnd7FastIPC8isServerEv,__ZNK5physx6shdfnd7FastIPC14haveConnectionEv,__ZNK12b2ChainShape13GetChildCountEv,__ZNK11b2EdgeShape13GetChildCountEv,__ZNK14b2CapsuleShape13GetChildCountEv,__ZNK14b2PolygonShape13GetChildCountEv,__ZNK13b2CircleShape13GetChildCountEv,__ZNK15AnchoredJoint2D26GetTypeInfoVirtualInternalEv,__ZNK7Joint2D10SwapBodiesEv,__ZNK7Joint2D16UseConnectedBodyEv,__ZNK7Joint2D26GetTypeInfoVirtualInternalEv,__ZNK14AreaEffector2D26GetTypeInfoVirtualInternalEv,__ZNK14AreaEffector2D16UseContactUpdateEv,__ZNK10Effector2D14IgnoreContactsEv,__ZNK10Effector2D16RequiresColliderEv,__ZNK14AreaEffector2D18DesignedForTriggerEv,__ZNK14AreaEffector2D21DesignedForNonTriggerEv,__ZNK10Effector2D26GetTypeInfoVirtualInternalEv,__ZNK13BoxCollider2D26GetTypeInfoVirtualInternalEv,__ZNK10Collider2D26GetTypeInfoVirtualInternalEv,__ZNK18BuoyancyEffector2D26GetTypeInfoVirtualInternalEv,__ZNK18BuoyancyEffector2D16UseContactUpdateEv,__ZNK18BuoyancyEffector2D18DesignedForTriggerEv,__ZNK18BuoyancyEffector2D21DesignedForNonTriggerEv,__ZNK17CapsuleCollider2D26GetTypeInfoVirtualInternalEv,__ZNK16CircleCollider2D26GetTypeInfoVirtualInternalEv,__ZNK15ConstantForce2D26GetTypeInfoVirtualInternalEv,__ZNK24PhysicsUpdateBehaviour2D26GetTypeInfoVirtualInternalEv
,__ZNK15DistanceJoint2D26GetTypeInfoVirtualInternalEv,__ZNK14EdgeCollider2D26GetTypeInfoVirtualInternalEv,__ZNK12FixedJoint2D26GetTypeInfoVirtualInternalEv,__ZNK15FrictionJoint2D26GetTypeInfoVirtualInternalEv,__ZNK12HingeJoint2D26GetTypeInfoVirtualInternalEv,__ZN17CircleCast2DQuery19InitializeCastShapeEv,__ZNK17PhysicsMaterial2D26GetTypeInfoVirtualInternalEv,__ZNK17Physics2DSettings26GetTypeInfoVirtualInternalEv,__ZNK18PlatformEffector2D26GetTypeInfoVirtualInternalEv,__ZNK18PlatformEffector2D16UseContactUpdateEv,__ZNK18PlatformEffector2D18DesignedForTriggerEv,__ZNK18PlatformEffector2D21DesignedForNonTriggerEv,__ZNK15PointEffector2D26GetTypeInfoVirtualInternalEv,__ZNK15PointEffector2D16UseContactUpdateEv,__ZNK15PointEffector2D18DesignedForTriggerEv,__ZNK15PointEffector2D21DesignedForNonTriggerEv,__ZNK17PolygonCollider2D26GetTypeInfoVirtualInternalEv,__ZNK17PolygonCollider2D7GetPolyEv,__ZNK15RelativeJoint2D26GetTypeInfoVirtualInternalEv,__ZNK11Rigidbody2D26GetTypeInfoVirtualInternalEv,__ZNK13SliderJoint2D26GetTypeInfoVirtualInternalEv,__ZNK13SpringJoint2D26GetTypeInfoVirtualInternalEv,__ZNK17SurfaceEffector2D26GetTypeInfoVirtualInternalEv,__ZNK17SurfaceEffector2D16UseContactUpdateEv,__ZNK17SurfaceEffector2D18DesignedForTriggerEv,__ZNK17SurfaceEffector2D21DesignedForNonTriggerEv,__ZNK13TargetJoint2D26GetTypeInfoVirtualInternalEv,__ZNK13TargetJoint2D10SwapBodiesEv,__ZNK13TargetJoint2D16UseConnectedBodyEv,__ZNK12WheelJoint2D26GetTypeInfoVirtualInternalEv
,__ZN16ShapeCast2DQuery19InitializeCastShapeEv,__ZN14BoxCast2DQuery19InitializeCastShapeEv,__ZN18CapsuleCast2DQuery19InitializeCastShapeEv,__ZNK5physx16PxVehicleNoDrive19getConcreteTypeNameEv,__ZNK5physx15PxVehicleWheels19getConcreteTypeNameEv,__ZNK13WheelCollider26GetTypeInfoVirtualInternalEv,__ZNK13WheelCollider16SupportsMaterialEv,__ZNK13WheelCollider12GetRigidbodyEv,__ZN5physx25PxVehicleConstraintShader11prepareDataEv,__ZN5physx25PxVehicleConstraintShader15getSerializableEv,__ZNK5physx14PxVehicleDrive19getConcreteTypeNameEv,__ZNK5physx16PxVehicleDrive4W19getConcreteTypeNameEv,__ZNK5physx16PxVehicleDriveNW19getConcreteTypeNameEv,__ZNK5physx18PxVehicleDriveTank19getConcreteTypeNameEv,__ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE11getTypeNameEv,__ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE11getTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12getClassSizeEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE19getConcreteTypeNameEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE13isSubordinateEv,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12getClassSizeEv
,__ZNK14VehiclesModule19VehiclesNeedsUpdateEv,__ZNK5physx5cloth8SwFabric10getFactoryEv,__ZNK5physx5cloth8SwFabric12getNumPhasesEv,__ZNK5physx5cloth8SwFabric16getNumRestvaluesEv,__ZNK5physx5cloth8SwFabric10getNumSetsEv,__ZNK5physx5cloth8SwFabric13getNumIndicesEv,__ZNK5physx5cloth8SwFabric15getNumParticlesEv,__ZNK5physx5cloth8SwFabric13getNumTethersEv,__ZThn4_NK5physx5cloth8SwFabric10getFactoryEv,__ZThn4_NK5physx5cloth8SwFabric12getNumPhasesEv,__ZThn4_NK5physx5cloth8SwFabric16getNumRestvaluesEv,__ZThn4_NK5physx5cloth8SwFabric10getNumSetsEv,__ZThn4_NK5physx5cloth8SwFabric13getNumIndicesEv,__ZThn4_NK5physx5cloth8SwFabric15getNumParticlesEv,__ZThn4_NK5physx5cloth8SwFabric13getNumTethersEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv
,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv,__ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv
,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv,__ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv,__ZNK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv,__ZNK5physx5cloth8SwSolver8hasErrorEv,__ZThn4_NK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv,__ZThn4_NK5physx5cloth8SwSolver8hasErrorEv,__ZNK5physx5cloth8SwSolver19StartSimulationTask7getNameEv,__ZNK5physx5cloth8SwSolver17EndSimulationTask7getNameEv,__ZNK5physx5cloth8SwSolver22CpuClothSimulationTask7getNameEv,__ZNK5Unity5Cloth26GetTypeInfoVirtualInternalEv,__ZN11ClothModule16GetClothingSceneEv,__ZNK12NavMeshAgent26GetTypeInfoVirtualInternalEv,__ZNK15NavMeshObstacle26GetTypeInfoVirtualInternalEv,__ZN15NavMeshObstacle26CalculateSupportedMessagesEv,__ZNK11OffMeshLink26GetTypeInfoVirtualInternalEv,__ZNK11NavMeshData26GetTypeInfoVirtualInternalEv,__ZNK22NavMeshProjectSettings26GetTypeInfoVirtualInternalEv,__ZNK15NavMeshSettings26GetTypeInfoVirtualInternalEv,__ZNK15NavMeshSettings19ShouldWriteForBuildEv,__ZNK17AudioChorusFilter26GetTypeInfoVirtualInternalEv,__ZNK11AudioFilter26GetTypeInfoVirtualInternalEv,__ZNK10SampleClip26GetTypeInfoVirtualInternalEv,__ZNK10SampleClip12GetLoadStateEv,__ZNK9AudioClip26GetTypeInfoVirtualInternalEv,__ZNK7WeakPtrIN11SoundHandle8InstanceEE10SharedData9GetRawPtrEv
,__ZNK21AudioDistortionFilter26GetTypeInfoVirtualInternalEv,__ZNK15AudioEchoFilter26GetTypeInfoVirtualInternalEv,__ZNK19AudioHighPassFilter26GetTypeInfoVirtualInternalEv,__ZNK13AudioListener26GetTypeInfoVirtualInternalEv,__ZNK18AudioLowPassFilter26GetTypeInfoVirtualInternalEv,__ZNK12AudioManager26GetTypeInfoVirtualInternalEv,__ZNK10AudioMixer26GetTypeInfoVirtualInternalEv,__ZNK10AudioMixer31AllowSnapshotTransitionsFromAPIEv,__ZN10AudioMixer23GetInitialSnapshotIndexEv,__ZN10AudioMixer18BuildMixerConstantEv,__ZNK15AudioMixerGroup26GetTypeInfoVirtualInternalEv,__ZNK18AudioMixerSnapshot26GetTypeInfoVirtualInternalEv,__ZNK17AudioReverbFilter26GetTypeInfoVirtualInternalEv,__ZNK15AudioReverbZone26GetTypeInfoVirtualInternalEv,__ZNK11AudioSource26GetTypeInfoVirtualInternalEv,__ZNK7WeakPtrI20SoundChannelInstanceE10SharedData9GetRawPtrEv,__ZNK14AudioBehaviour26GetTypeInfoVirtualInternalEv,__ZN11AudioModule13GetNumDevicesEv,__ZN11AudioModule15IsAudioDisabledEv,__ZNK9Animation26GetTypeInfoVirtualInternalEv,__ZNK13AnimationClip26GetTypeInfoVirtualInternalEv,__ZNK13AnimationClip13IsHumanMotionEv,__ZNK13AnimationClip9IsLoopingEv,__ZNK13AnimationClip8IsLegacyEv,__ZNK6Motion26GetTypeInfoVirtualInternalEv,__ZNK8Animator26GetTypeInfoVirtualInternalEv,__ZNK8Animator17GetTimeUpdateModeEv,__ZNK8Animator25GetStateMachineBehavioursEv,__ZNK8Animator13GetPlayerTypeEv,__ZN17AnimationPlayable7GetTypeEv
,__ZN17AnimationPlayable20GetPlayableClassNameEv,__ZN17AnimationPlayable28ComputeNeedsBindingRebuildedEv,__ZNK17AnimationPlayable15GetApplyMotionXEv,__ZNK17AnimationPlayable8GetAssetEv,__ZN27AnimationLayerMixerPlayable7GetTypeEv,__ZN22AnimationMixerPlayable7GetTypeEv,__ZN22AnimationMixerPlayable20GetPlayableClassNameEv,__ZN21AnimationClipPlayable7GetTypeEv,__ZNK21AnimationClipPlayable8GetAssetEv,__ZN26AnimatorControllerPlayable17IsMultithreadableEv,__ZN26AnimatorControllerPlayable7GetTypeEv,__ZNK26AnimatorControllerPlayable8GetAssetEv,__ZNK26AnimatorControllerPlayable24HasStateMachineBehaviourEv,__ZNK26AnimatorControllerPlayable25GetStateMachineBehavioursEv,__ZNK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv,__ZNK26AnimatorControllerPlayable13IsInitializedEv,__ZThn80_NK26AnimatorControllerPlayable13IsInitializedEv,__ZThn80_NK26AnimatorControllerPlayable24HasStateMachineBehaviourEv,__ZThn80_NK26AnimatorControllerPlayable25GetStateMachineBehavioursEv,__ZThn80_NK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv,__ZNK18AnimatorController26GetTypeInfoVirtualInternalEv,__ZN18AnimatorController23GetAnimationSetBindingsEv,__ZNK18AnimatorController17GetAnimationClipsEv,__ZNK18AnimatorController13GetBehavioursEv,__ZNK18AnimatorController41GetStateMachineBehaviourVectorDescriptionEv,__ZNK18AnimatorController28HasMultiThreadedStateMachineEv,__ZNK25RuntimeAnimatorController30GetAnimationClipOverrideVectorEv,__ZNK25RuntimeAnimatorController26GetTypeInfoVirtualInternalEv,__ZNK26AnimatorOverrideController26GetTypeInfoVirtualInternalEv,__ZN26AnimatorOverrideController23GetAnimationSetBindingsEv
,__ZNK26AnimatorOverrideController17GetAnimationClipsEv,__ZNK26AnimatorOverrideController13GetBehavioursEv,__ZNK26AnimatorOverrideController41GetStateMachineBehaviourVectorDescriptionEv,__ZNK26AnimatorOverrideController28HasMultiThreadedStateMachineEv,__ZNK26AnimatorOverrideController30GetAnimationClipOverrideVectorEv,__ZNK6Avatar26GetTypeInfoVirtualInternalEv,__ZN23AnimationOffsetPlayable7GetTypeEv,__ZN23AnimationOffsetPlayable20GetPlayableClassNameEv,__ZNK23AnimationOffsetPlayable15GetApplyMotionXEv,__ZNK7Terrain26GetTypeInfoVirtualInternalEv,__ZNK11TerrainData26GetTypeInfoVirtualInternalEv,__ZNK14TerrainManager16GetActiveTerrainEv,__ZNK14TerrainManager17GetActiveTerrainsEv,__ZNK14TerrainManager31GetSplatBaseMaterialTextureNameEv,__ZNK24TreeIntermediateRenderer8GetLayerEv,__ZNK26LegacyTreeInstanceRenderer16GetMaterialCountEv,__ZNK24TreeIntermediateRenderer12GetLayerMaskEv,__ZNK23LODTreeInstanceRenderer16GetMaterialCountEv,__ZNK4Tree26GetTypeInfoVirtualInternalEv,__ZN4Tree26CalculateSupportedMessagesEv,__ZNK13TextRendering4Font26GetTypeInfoVirtualInternalEv,__ZNK20TextRenderingPrivate7GUIText26GetTypeInfoVirtualInternalEv,__ZNK20TextRenderingPrivate8TextMesh26GetTypeInfoVirtualInternalEv,__ZNK2UI6Canvas26GetTypeInfoVirtualInternalEv,__ZNK2UI11CanvasGroup26GetTypeInfoVirtualInternalEv,__ZNK2UI14CanvasRenderer26GetTypeInfoVirtualInternalEv,__ZNK15TerrainCollider26GetTypeInfoVirtualInternalEv,__ZNK15TerrainCollider15SupportsTriggerEv,__ZN15TerrainCollider12GetIsTriggerEv,__ZN11IMGUIModule25GetGUIStyleScriptingClassEv
,__ZN11IMGUIModule25IsDeveloperConsoleVisibleEv,__ZNK26DownloadHandlerAssetBundle8GetBytesEv,__ZNK26DownloadHandlerAssetBundle13GetMemorySizeEv,__ZNK26DownloadHandlerAssetBundle9GetLengthEv,__ZN26DownloadHandlerAssetBundle7PrepareEv,__ZNK26DownloadHandlerAssetBundle6IsDoneEv,__ZNK26DownloadHandlerAssetBundle8GetErrorEv,__ZNK15DownloadHandler14HasPendingDataEv,__ZN15DownloadHandler7PrepareEv,__ZNK15DownloadHandler6IsDoneEv,__ZNK15DownloadHandler8GetErrorEv,__ZNK24DownloadHandlerAudioClip8GetBytesEv,__ZNK24DownloadHandlerAudioClip13GetMemorySizeEv,__ZNK24DownloadHandlerAudioClip9GetLengthEv,__ZNK21DownloadHandlerBuffer8GetBytesEv,__ZNK21DownloadHandlerBuffer13GetMemorySizeEv,__ZNK21DownloadHandlerBuffer9GetLengthEv,__ZNK21DownloadHandlerScript8GetBytesEv,__ZNK21DownloadHandlerScript13GetMemorySizeEv,__ZNK21DownloadHandlerScript9GetLengthEv,__ZNK22DownloadHandlerTexture8GetBytesEv,__ZNK22DownloadHandlerTexture13GetMemorySizeEv,__ZNK22DownloadHandlerTexture9GetLengthEv,__ZNK18DownloadHandlerVFS8GetBytesEv,__ZNK18DownloadHandlerVFS13GetMemorySizeEv,__ZNK18DownloadHandlerVFS9GetLengthEv,__ZNK12StatusHelper13GetStatusCodeEv,__ZNK12StatusHelper7IsErrorEv,__ZNK12StatusHelper10IsCompleteEv,__ZNK12StatusHelper10IsRedirectEv
,__ZNK16UploadHandlerRaw15GetNumBytesLeftEv,__ZN16UploadHandlerRaw8GetBytesEv,__ZNK16UploadHandlerRaw12GetBytesSentEv,__ZNK25UnityWebRequestJavaScript16GetDownloadBytesEv,__ZNK25UnityWebRequestJavaScript14GetUploadBytesEv,__ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE16GetDownloadBytesEv,__ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE14GetUploadBytesEv,__ZN29UnityWebRequestAsyncOperation6IsDoneEv,__ZNK14DLHAudioHelper6IsDoneEv,__ZNK14DLHAudioHelper11GetCapacityEv,__ZNK14DLHAudioHelper14GetPartialDataEv,__ZNK14DLHAudioHelper14GetPartialSizeEv,__ZNK15UnityAdsManager26GetTypeInfoVirtualInternalEv,__ZN14UnityAnalytics18IsAnalyticsEnabledEv,__ZNK21UnityAnalyticsManager26GetTypeInfoVirtualInternalEv,__ZNK18CrashReportManager26GetTypeInfoVirtualInternalEv,__ZN18UnityConnectClient15GetCloudServiceEv,__ZNK20UnityConnectSettings26GetTypeInfoVirtualInternalEv,__ZNK8VRDevice9GetActiveEv,__ZN8VRDevice12GetAdapterIdEv,__ZNK8VRDevice24GetDisableBackBufferMSAAEv,__ZNK8VRDevice25GetStereoscopicBackbufferEv,__ZNK8VRDevice25GetStereoRenderingEnabledEv,__ZNK8VRDevice15GetDisableVSyncEv,__ZNK8VRDevice23GetIsParallelProjectionEv,__ZNK8VRDevice22GetOverrideFieldOfViewEv,__ZNK8VRDevice17GetOverrideAspectEv,__ZNK8VRDevice27GetOverrideStereoSeparationEv,__ZNK8VRDevice18GetEyeTextureWidthEv,__ZNK8VRDevice19GetEyeTextureHeightEv
,__ZNK8VRDevice16GetDroppedFramesEv,__ZNK8VRDevice16GetFramePresentsEv,__ZNK8VRDevice21GetShowVRSplashScreenEv,__ZNK8VRDevice27GetOverrideApplicationPauseEv,__ZN11UnityEngine15CloudWebService17CloudJobScheduler10InitializeEv,__ZN11UnityEngine15CloudWebService17CloudJobScheduler5CloseEv,__ZNK23CloudWebServicesManager26GetTypeInfoVirtualInternalEv,__ZN11UnityEngine15CloudWebService13WWWRestClient10PerformGetEv,__ZN11UnityEngine15CloudWebService13WWWRestClient11PerformPostEv,__ZN11UnityEngine15CloudWebService13WWWRestClient6IsDoneEv,__ZN11UnityEngine15CloudWebService13WWWRestClient12NeedsPollingEv,__ZN11UnityEngine15CloudWebService13WWWRestClient17GetResponseStatusEv,__ZN11UnityEngine15CloudWebService13WWWRestClient18GetEditableHeadersEv,__ZN11UnityEngine15CloudWebService13WWWRestClient18GetResponseHeadersEv,__ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE12NeedsPollingEv,__ZN11UnityEngine15CloudWebService14RestDownloader6IsDoneEv,__ZN11UnityEngine15CloudWebService14RestDownloader9IsAbortedEv,__ZNK24EllipsoidParticleEmitter26GetTypeInfoVirtualInternalEv,__ZNK15ParticleEmitter10HasEnabledEv,__ZNK15ParticleEmitter10GetEnabledEv,__ZNK15ParticleEmitter26GetTypeInfoVirtualInternalEv,__ZNK19MeshParticleEmitter26GetTypeInfoVirtualInternalEv,__ZNK16ParticleAnimator26GetTypeInfoVirtualInternalEv,__ZNK16ParticleRenderer26GetTypeInfoVirtualInternalEv,__ZNK21WorldParticleCollider26GetTypeInfoVirtualInternalEv,___stdio_close,__ZNKSt12experimental15fundamentals_v112bad_any_cast4whatEv,__ZNKSt11logic_error4whatEv,__ZNKSt3__223__future_error_category4nameEv,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9underflowEv
,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4syncEv,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9showmanycEv,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9underflowEv,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5uflowEv,__ZNKSt13runtime_error4whatEv,__ZNKSt3__219__iostream_category4nameEv,__ZNSt3__211__stdoutbufIwE4syncEv,__ZNSt3__211__stdoutbufIcE4syncEv,__ZNSt3__210__stdinbufIwE9underflowEv,__ZNSt3__210__stdinbufIwE5uflowEv,__ZNSt3__210__stdinbufIcE9underflowEv,__ZNSt3__210__stdinbufIcE5uflowEv,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,__ZNKSt3__220__time_get_c_storageIcE7__weeksEv,__ZNKSt3__220__time_get_c_storageIcE8__monthsEv,__ZNKSt3__220__time_get_c_storageIcE7__am_pmEv,__ZNKSt3__220__time_get_c_storageIcE3__cEv,__ZNKSt3__220__time_get_c_storageIcE3__rEv,__ZNKSt3__220__time_get_c_storageIcE3__xEv,__ZNKSt3__220__time_get_c_storageIcE3__XEv,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,__ZNKSt3__220__time_get_c_storageIwE7__weeksEv,__ZNKSt3__220__time_get_c_storageIwE8__monthsEv,__ZNKSt3__220__time_get_c_storageIwE7__am_pmEv,__ZNKSt3__220__time_get_c_storageIwE3__cEv,__ZNKSt3__220__time_get_c_storageIwE3__rEv,__ZNKSt3__220__time_get_c_storageIwE3__xEv,__ZNKSt3__220__time_get_c_storageIwE3__XEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv
,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv,__ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv,__ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv,__ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv,__ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv,__ZNKSt3__210moneypunctIcLb0EE16do_decimal_pointEv,__ZNKSt3__210moneypunctIcLb0EE16do_thousands_sepEv
,__ZNKSt3__210moneypunctIcLb0EE14do_frac_digitsEv,__ZNKSt3__210moneypunctIcLb1EE16do_decimal_pointEv,__ZNKSt3__210moneypunctIcLb1EE16do_thousands_sepEv,__ZNKSt3__210moneypunctIcLb1EE14do_frac_digitsEv,__ZNKSt3__210moneypunctIwLb0EE16do_decimal_pointEv,__ZNKSt3__210moneypunctIwLb0EE16do_thousands_sepEv,__ZNKSt3__210moneypunctIwLb0EE14do_frac_digitsEv,__ZNKSt3__210moneypunctIwLb1EE16do_decimal_pointEv,__ZNKSt3__210moneypunctIwLb1EE16do_thousands_sepEv,__ZNKSt3__210moneypunctIwLb1EE14do_frac_digitsEv,__ZNKSt3__217moneypunct_bynameIcLb0EE16do_decimal_pointEv,__ZNKSt3__217moneypunct_bynameIcLb0EE16do_thousands_sepEv,__ZNKSt3__217moneypunct_bynameIcLb0EE14do_frac_digitsEv,__ZNKSt3__217moneypunct_bynameIcLb1EE16do_decimal_pointEv,__ZNKSt3__217moneypunct_bynameIcLb1EE16do_thousands_sepEv,__ZNKSt3__217moneypunct_bynameIcLb1EE14do_frac_digitsEv,__ZNKSt3__217moneypunct_bynameIwLb0EE16do_decimal_pointEv,__ZNKSt3__217moneypunct_bynameIwLb0EE16do_thousands_sepEv,__ZNKSt3__217moneypunct_bynameIwLb0EE14do_frac_digitsEv,__ZNKSt3__217moneypunct_bynameIwLb1EE16do_decimal_pointEv,__ZNKSt3__217moneypunct_bynameIwLb1EE16do_thousands_sepEv,__ZNKSt3__217moneypunct_bynameIwLb1EE14do_frac_digitsEv,__ZNKSt3__27codecvtIDic11__mbstate_tE11do_encodingEv,__ZNKSt3__27codecvtIDic11__mbstate_tE16do_always_noconvEv,__ZNKSt3__27codecvtIDic11__mbstate_tE13do_max_lengthEv,__ZNKSt3__27codecvtIcc11__mbstate_tE11do_encodingEv,__ZNKSt3__27codecvtIcc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__27codecvtIcc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__27codecvtIwc11__mbstate_tE11do_encodingEv,__ZNKSt3__27codecvtIwc11__mbstate_tE16do_always_noconvEv
,__ZNKSt3__27codecvtIwc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__27codecvtIDsc11__mbstate_tE11do_encodingEv,__ZNKSt3__27codecvtIDsc11__mbstate_tE16do_always_noconvEv,__ZNKSt3__27codecvtIDsc11__mbstate_tE13do_max_lengthEv,__ZNKSt3__28numpunctIcE16do_decimal_pointEv,__ZNKSt3__28numpunctIcE16do_thousands_sepEv,__ZNKSt3__28numpunctIwE16do_decimal_pointEv,__ZNKSt3__28numpunctIwE16do_thousands_sepEv,__ZNKSt3__214__codecvt_utf8IwE11do_encodingEv,__ZNKSt3__214__codecvt_utf8IwE16do_always_noconvEv,__ZNKSt3__214__codecvt_utf8IwE13do_max_lengthEv,__ZNKSt3__214__codecvt_utf8IDsE11do_encodingEv,__ZNKSt3__214__codecvt_utf8IDsE16do_always_noconvEv,__ZNKSt3__214__codecvt_utf8IDsE13do_max_lengthEv,__ZNKSt3__214__codecvt_utf8IDiE11do_encodingEv,__ZNKSt3__214__codecvt_utf8IDiE16do_always_noconvEv,__ZNKSt3__214__codecvt_utf8IDiE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IwLb0EE11do_encodingEv,__ZNKSt3__215__codecvt_utf16IwLb0EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IwLb0EE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IwLb1EE11do_encodingEv,__ZNKSt3__215__codecvt_utf16IwLb1EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IwLb1EE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IDsLb0EE11do_encodingEv,__ZNKSt3__215__codecvt_utf16IDsLb0EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IDsLb0EE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IDsLb1EE11do_encodingEv,__ZNKSt3__215__codecvt_utf16IDsLb1EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IDsLb1EE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IDiLb0EE11do_encodingEv
,__ZNKSt3__215__codecvt_utf16IDiLb0EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IDiLb0EE13do_max_lengthEv,__ZNKSt3__215__codecvt_utf16IDiLb1EE11do_encodingEv,__ZNKSt3__215__codecvt_utf16IDiLb1EE16do_always_noconvEv,__ZNKSt3__215__codecvt_utf16IDiLb1EE13do_max_lengthEv,__ZNKSt3__220__codecvt_utf8_utf16IwE11do_encodingEv,__ZNKSt3__220__codecvt_utf8_utf16IwE16do_always_noconvEv,__ZNKSt3__220__codecvt_utf8_utf16IwE13do_max_lengthEv,__ZNKSt3__220__codecvt_utf8_utf16IDiE11do_encodingEv,__ZNKSt3__220__codecvt_utf8_utf16IDiE16do_always_noconvEv,__ZNKSt3__220__codecvt_utf8_utf16IDiE13do_max_lengthEv,__ZNKSt3__220__codecvt_utf8_utf16IDsE11do_encodingEv,__ZNKSt3__220__codecvt_utf8_utf16IDsE16do_always_noconvEv,__ZNKSt3__220__codecvt_utf8_utf16IDsE13do_max_lengthEv,__ZNKSt3__212bad_weak_ptr4whatEv,__ZNSt3__212strstreambuf9underflowEv,__ZNKSt3__224__generic_error_category4nameEv,__ZNKSt3__223__system_error_category4nameEv,__ZNKSt9bad_alloc4whatEv,__ZNKSt20bad_array_new_length4whatEv,__ZNKSt16bad_array_length4whatEv,__ZNKSt9exception4whatEv,__ZNKSt13bad_exception4whatEv,__ZNKSt8bad_cast4whatEv,__ZNKSt10bad_typeid4whatEv,_read_markers,_read_restart_marker,_skip_variable,_get_interesting_appn,_consume_markers
,_consume_data,_dummy_consume_data,_empty_output_buffer,_empty_mem_output_buffer,_fill_input_buffer,_fill_mem_input_buffer,_save_marker,_UNITY_png_create_info_struct,_UNITY_png_set_interlace_handling,__Znaj,_UNITY_png_unity_get_crc,__Znwj,_jpeg_std_error,__ZL17fill_input_bufferP22jpeg_decompress_struct,_jpeg_start_decompress,_jpeg_finish_decompress,__ZL19empty_output_bufferP20jpeg_compress_struct,___strdup,__ZN9Coroutine16CleanupCoroutineEPv,__ZL16GetInterfaceImpl18UnityInterfaceGUID,__ZL27ForwardInvokeDelayedCleanupPv,__ZL35FindAndLoadUnityPluginIl2CppWrapperPKc,__Z49Application_CUSTOM_CanStreamedLevelBeLoadedByNameP12Il2CppString,__Z43Application_CUSTOM_CanStreamedLevelBeLoadedi,__Z26Application_CUSTOM_HasARGVP12Il2CppString,__Z34Application_CUSTOM_GetValueForARGVP12Il2CppString,__Z52Application_CUSTOM_RequestAdvertisingIdentifierAsyncP12Il2CppObject,__Z39Application_CUSTOM_GetStackTraceLogType7LogType,__Z43Application_CUSTOM_RequestUserAuthorizationi,__Z39Application_CUSTOM_HasUserAuthorizationi
,__Z51AssetBundleCreateRequest_Get_Custom_PropAssetBundleP12Il2CppObject,__Z39AssetBundleRequest_Get_Custom_PropAssetP12Il2CppObject,__Z43AssetBundleRequest_Get_Custom_PropAllAssetsP12Il2CppObject,__Z36AssetBundle_Get_Custom_PropMainAssetP12Il2CppObject,__Z53AssetBundle_Get_Custom_PropIsStreamedSceneAssetBundleP12Il2CppObject,__Z35AssetBundle_CUSTOM_GetAllAssetNamesP12Il2CppObject,__Z35AssetBundle_CUSTOM_GetAllScenePathsP12Il2CppObject,__Z45AssetBundleManifest_CUSTOM_GetAllAssetBundlesP12Il2CppObject,__Z56AssetBundleManifest_CUSTOM_GetAllAssetBundlesWithVariantP12Il2CppObject,__Z36AsyncOperation_Get_Custom_PropIsDoneP12Il2CppObject,__Z38AsyncOperation_Get_Custom_PropPriorityP12Il2CppObject,__Z50AsyncOperation_Get_Custom_PropAllowSceneActivationP12Il2CppObject,__Z45SystemInfo_CUSTOM_SupportsRenderTextureFormat19RenderTextureFormat,__Z39SystemInfo_CUSTOM_SupportsTextureFormat13TextureFormat,__Z38ScriptableObject_CUSTOM_CreateInstanceP12Il2CppString,__Z46ScriptableObject_CUSTOM_CreateInstanceFromTypeP12Il2CppObject,__Z32Behaviour_Get_Custom_PropEnabledP12Il2CppObject,__Z43Behaviour_Get_Custom_PropIsActiveAndEnabledP12Il2CppObject,__Z40BillboardAsset_Get_Custom_PropImageCountP12Il2CppObject,__Z41BillboardAsset_Get_Custom_PropVertexCountP12Il2CppObject,__Z40BillboardAsset_Get_Custom_PropIndexCountP12Il2CppObject,__Z38BillboardAsset_Get_Custom_PropMaterialP12Il2CppObject,__Z39BillboardAsset_CUSTOM_GetImageTexCoordsP12Il2CppObject,__Z33BillboardAsset_CUSTOM_GetVerticesP12Il2CppObject,__Z32BillboardAsset_CUSTOM_GetIndicesP12Il2CppObject,__Z42BillboardRenderer_Get_Custom_PropBillboardP12Il2CppObject,__Z30Caching_CUSTOM_CleanNamedCacheP12Il2CppString,__Z30Caching_CUSTOM_DeleteFromCacheP12Il2CppString,__Z34Caching_CUSTOM_GetVersionFromCacheP12Il2CppString,__Z35Camera_Get_Custom_PropRenderingPathP12Il2CppObject
,__Z41Camera_Get_Custom_PropActualRenderingPathP12Il2CppObject,__Z25Camera_Get_Custom_PropHdrP12Il2CppObject,__Z28Camera_CUSTOM_GetHDRWarningsP12Il2CppObject,__Z34Camera_Get_Custom_PropOrthographicP12Il2CppObject,__Z36Camera_Get_Custom_PropOpaqueSortModeP12Il2CppObject,__Z42Camera_Get_Custom_PropTransparencySortModeP12Il2CppObject,__Z33Camera_Get_Custom_PropCullingMaskP12Il2CppObject,__Z31Camera_Get_Custom_PropEventMaskP12Il2CppObject,__Z35Camera_Get_Custom_PropTargetTextureP12Il2CppObject,__Z32Camera_Get_Custom_PropPixelWidthP12Il2CppObject,__Z33Camera_Get_Custom_PropPixelHeightP12Il2CppObject,__Z72Camera_Get_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObject,__Z32Camera_Get_Custom_PropClearFlagsP12Il2CppObject,__Z35Camera_Get_Custom_PropStereoEnabledP12Il2CppObject,__Z32Camera_Get_Custom_PropCameraTypeP12Il2CppObject,__Z38Camera_Get_Custom_PropStereoMirrorModeP12Il2CppObject,__Z35Camera_CUSTOM_GetStereoViewMatricesP12Il2CppObject,__Z37Camera_Get_Custom_PropStereoTargetEyeP12Il2CppObject,__Z41Camera_CUSTOM_GetStereoProjectionMatricesP12Il2CppObject,__Z37Camera_Get_Custom_PropStereoActiveEyeP12Il2CppObject,__Z35Camera_Get_Custom_PropTargetDisplayP12Il2CppObject,__Z27Camera_CUSTOM_GetAllCamerasP11Il2CppArray,__Z41Camera_Get_Custom_PropUseOcclusionCullingP12Il2CppObject,__Z40Camera_Get_Custom_PropLayerCullDistancesP12Il2CppObject,__Z40Camera_Get_Custom_PropLayerCullSphericalP12Il2CppObject,__Z38Camera_Get_Custom_PropDepthTextureModeP12Il2CppObject,__Z51Camera_Get_Custom_PropClearStencilAfterLightingPassP12Il2CppObject,__Z40Camera_Get_Custom_PropCommandBufferCountP12Il2CppObject,__Z34Component_Get_Custom_PropTransformP12Il2CppObject,__Z35Component_Get_Custom_PropGameObjectP12Il2CppObject
,__Z34ComputeBuffer_Get_Custom_PropCountP12Il2CppObject,__Z35ComputeBuffer_Get_Custom_PropStrideP12Il2CppObject,__Z31CrashReport_CUSTOM_RemoveReportP12Il2CppString,__Z35CullingGroup_Get_Custom_PropEnabledP12Il2CppObject,__Z40CullingGroup_Get_Custom_PropTargetCameraP12Il2CppObject,__Z39DirectorPlayer_CUSTOM_GetTimeUpdateModeP12Il2CppObject,__Z30RectOffset_Get_Custom_PropLeftP12Il2CppObject,__Z31RectOffset_Get_Custom_PropRightP12Il2CppObject,__Z29RectOffset_Get_Custom_PropTopP12Il2CppObject,__Z32RectOffset_Get_Custom_PropBottomP12Il2CppObject,__Z36RectOffset_Get_Custom_PropHorizontalP12Il2CppObject,__Z34RectOffset_Get_Custom_PropVerticalP12Il2CppObject,__Z33GUITexture_Get_Custom_PropTextureP12Il2CppObject,__Z32GUITexture_Get_Custom_PropBorderP12Il2CppObject,__Z33GameObject_CUSTOM_CreatePrimitivei,__Z35GameObject_Get_Custom_PropTransformP12Il2CppObject,__Z31GameObject_Get_Custom_PropLayerP12Il2CppObject,__Z32GameObject_Get_Custom_PropActiveP12Il2CppObject,__Z36GameObject_Get_Custom_PropActiveSelfP12Il2CppObject,__Z43GameObject_Get_Custom_PropActiveInHierarchyP12Il2CppObject,__Z34GameObject_Get_Custom_PropIsStaticP12Il2CppObject,__Z43GameObject_Get_Custom_PropIsStaticBatchableP12Il2CppObject,__Z29GameObject_Get_Custom_PropTagP12Il2CppObject,__Z39GameObject_CUSTOM_FindGameObjectWithTagP12Il2CppString,__Z40GameObject_CUSTOM_FindGameObjectsWithTagP12Il2CppString,__Z22GameObject_CUSTOM_FindP12Il2CppString,__Z33Gradient_Get_Custom_PropColorKeysP12Il2CppObject,__Z33Gradient_Get_Custom_PropAlphaKeysP12Il2CppObject,__Z28Gradient_Get_Custom_PropModeP12Il2CppObject,__Z35OcclusionPortal_Get_Custom_PropOpenP12Il2CppObject
,__Z30MeshFilter_Get_Custom_PropMeshP12Il2CppObject,__Z36MeshFilter_Get_Custom_PropSharedMeshP12Il2CppObject,__Z40SkinnedMeshRenderer_Get_Custom_PropBonesP12Il2CppObject,__Z43SkinnedMeshRenderer_Get_Custom_PropRootBoneP12Il2CppObject,__Z42SkinnedMeshRenderer_Get_Custom_PropQualityP12Il2CppObject,__Z45SkinnedMeshRenderer_Get_Custom_PropSharedMeshP12Il2CppObject,__Z54SkinnedMeshRenderer_Get_Custom_PropUpdateWhenOffscreenP12Il2CppObject,__Z55SkinnedMeshRenderer_Get_Custom_PropSkinnedMotionVectorsP12Il2CppObject,__Z30LensFlare_Get_Custom_PropFlareP12Il2CppObject,__Z48Renderer_Get_Custom_PropStaticBatchRootTransformP12Il2CppObject,__Z40Renderer_Get_Custom_PropStaticBatchIndexP12Il2CppObject,__Z43Renderer_Get_Custom_PropIsPartOfStaticBatchP12Il2CppObject,__Z31Renderer_Get_Custom_PropEnabledP12Il2CppObject,__Z41Renderer_Get_Custom_PropShadowCastingModeP12Il2CppObject,__Z35Renderer_Get_Custom_PropCastShadowsP12Il2CppObject,__Z38Renderer_Get_Custom_PropReceiveShadowsP12Il2CppObject,__Z32Renderer_Get_Custom_PropMaterialP12Il2CppObject,__Z38Renderer_Get_Custom_PropSharedMaterialP12Il2CppObject,__Z33Renderer_Get_Custom_PropMaterialsP12Il2CppObject,__Z39Renderer_Get_Custom_PropSharedMaterialsP12Il2CppObject,__Z37Renderer_Get_Custom_PropLightmapIndexP12Il2CppObject,__Z45Renderer_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject,__Z50Renderer_Get_Custom_PropMotionVectorGenerationModeP12Il2CppObject,__Z33Renderer_Get_Custom_PropIsVisibleP12Il2CppObject,__Z38Renderer_Get_Custom_PropUseLightProbesP12Il2CppObject,__Z39Renderer_Get_Custom_PropLightProbeUsageP12Il2CppObject,__Z53Renderer_Get_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObject,__Z35Renderer_Get_Custom_PropProbeAnchorP12Il2CppObject,__Z44Renderer_Get_Custom_PropReflectionProbeUsageP12Il2CppObject,__Z40Renderer_Get_Custom_PropSortingLayerNameP12Il2CppObject
,__Z38Renderer_Get_Custom_PropSortingLayerIDP12Il2CppObject,__Z36Renderer_Get_Custom_PropSortingOrderP12Il2CppObject,__Z37Projector_Get_Custom_PropOrthographicP12Il2CppObject,__Z37Projector_Get_Custom_PropIgnoreLayersP12Il2CppObject,__Z33Projector_Get_Custom_PropMaterialP12Il2CppObject,__Z30Skybox_Get_Custom_PropMaterialP12Il2CppObject,__Z39TrailRenderer_Get_Custom_PropWidthCurveP12Il2CppObject,__Z42TrailRenderer_Get_Custom_PropColorGradientP12Il2CppObject,__Z41TrailRenderer_Get_Custom_PropAutodestructP12Il2CppObject,__Z46TrailRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject,__Z43TrailRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject,__Z40TrailRenderer_Get_Custom_PropTextureModeP12Il2CppObject,__Z38LineRenderer_Get_Custom_PropWidthCurveP12Il2CppObject,__Z41LineRenderer_Get_Custom_PropColorGradientP12Il2CppObject,__Z40LineRenderer_Get_Custom_PropNumPositionsP12Il2CppObject,__Z41LineRenderer_Get_Custom_PropUseWorldSpaceP12Il2CppObject,__Z45LineRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject,__Z42LineRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject,__Z39LineRenderer_Get_Custom_PropTextureModeP12Il2CppObject,__Z44MaterialPropertyBlock_Get_Custom_PropIsEmptyP12Il2CppObject,__Z39RenderBufferHelper_CUSTOM_GetLoadActionP21ScriptingRenderBuffer,__Z40RenderBufferHelper_CUSTOM_GetStoreActionP21ScriptingRenderBuffer,__Z36LightProbes_Get_Custom_PropPositionsP12Il2CppObject,__Z38LightProbes_Get_Custom_PropBakedProbesP12Il2CppObject,__Z32LightProbes_Get_Custom_PropCountP12Il2CppObject,__Z36LightProbes_Get_Custom_PropCellCountP12Il2CppObject,__Z51MeshRenderer_Get_Custom_PropAdditionalVertexStreamsP12Il2CppObject,__Z36Gyroscope_CUSTOM_getEnabled_Internali,__Z46LocationService_Get_Custom_PropIsEnabledByUserP12Il2CppObject,__Z37LocationService_Get_Custom_PropStatusP12Il2CppObject
,__Z30Compass_Get_Custom_PropEnabledP12Il2CppObject,__Z22Input_CUSTOM_GetKeyInti,__Z25Input_CUSTOM_GetKeyStringP12Il2CppString,__Z24Input_CUSTOM_GetKeyUpInti,__Z27Input_CUSTOM_GetKeyUpStringP12Il2CppString,__Z26Input_CUSTOM_GetKeyDownInti,__Z29Input_CUSTOM_GetKeyDownStringP12Il2CppString,__Z22Input_CUSTOM_GetButtonP12Il2CppString,__Z26Input_CUSTOM_GetButtonDownP12Il2CppString,__Z24Input_CUSTOM_GetButtonUpP12Il2CppString,__Z27Input_CUSTOM_GetMouseButtoni,__Z31Input_CUSTOM_GetMouseButtonDowni,__Z29Input_CUSTOM_GetMouseButtonUpi,__Z32LODGroup_Get_Custom_PropLodCountP12Il2CppObject,__Z32LODGroup_Get_Custom_PropFadeModeP12Il2CppObject,__Z42LODGroup_Get_Custom_PropAnimateCrossFadingP12Il2CppObject,__Z31LODGroup_Get_Custom_PropEnabledP12Il2CppObject,__Z23LODGroup_CUSTOM_GetLODsP12Il2CppObject,__Z28LayerMask_CUSTOM_LayerToNamei,__Z28LayerMask_CUSTOM_NameToLayerP12Il2CppString,__Z25Light_Get_Custom_PropTypeP12Il2CppObject,__Z28Light_Get_Custom_PropShadowsP12Il2CppObject,__Z37Light_Get_Custom_PropShadowResolutionP12Il2CppObject,__Z43Light_Get_Custom_PropShadowCustomResolutionP12Il2CppObject,__Z27Light_Get_Custom_PropCookieP12Il2CppObject,__Z26Light_Get_Custom_PropFlareP12Il2CppObject,__Z31Light_Get_Custom_PropRenderModeP12Il2CppObject,__Z39Light_Get_Custom_PropAlreadyLightmappedP12Il2CppObject,__Z31Light_Get_Custom_PropBakedIndexP12Il2CppObject,__Z28Light_Get_Custom_PropIsBakedP12Il2CppObject
,__Z32Light_Get_Custom_PropCullingMaskP12Il2CppObject,__Z39Light_Get_Custom_PropCommandBufferCountP12Il2CppObject,__Z45LightProbeGroup_Get_Custom_PropProbePositionsP12Il2CppObject,__Z52LightProbeProxyVolume_Get_Custom_PropBoundingBoxModeP12Il2CppObject,__Z51LightProbeProxyVolume_Get_Custom_PropResolutionModeP12Il2CppObject,__Z54LightProbeProxyVolume_Get_Custom_PropProbePositionModeP12Il2CppObject,__Z48LightProbeProxyVolume_Get_Custom_PropRefreshModeP12Il2CppObject,__Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionXP12Il2CppObject,__Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionYP12Il2CppObject,__Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionZP12Il2CppObject,__Z35Matrix4x4_Get_Custom_PropIsIdentityRK10Matrix4x4f,__Z30Mathf_CUSTOM_ClosestPowerOfTwoi,__Z25Mathf_CUSTOM_IsPowerOfTwoi,__Z27Mathf_CUSTOM_NextPowerOfTwoi,__Z36AnimationCurve_Get_Custom_PropLengthP12Il2CppObject,__Z29AnimationCurve_CUSTOM_GetKeysP12Il2CppObject,__Z41AnimationCurve_Get_Custom_PropPreWrapModeP12Il2CppObject,__Z42AnimationCurve_Get_Custom_PropPostWrapModeP12Il2CppObject,__Z30Mesh_Get_Custom_PropIsReadableP12Il2CppObject,__Z29Mesh_Get_Custom_PropCanAccessP12Il2CppObject,__Z32Mesh_CUSTOM_ExtractArrayFromListP12Il2CppObject,__Z35Mesh_Get_Custom_PropBlendShapeCountP12Il2CppObject,__Z37Mesh_Get_Custom_PropVertexBufferCountP12Il2CppObject,__Z31Mesh_Get_Custom_PropVertexCountP12Il2CppObject,__Z32Mesh_Get_Custom_PropSubMeshCountP12Il2CppObject,__Z31Mesh_Get_Custom_PropBoneWeightsP12Il2CppObject,__Z29Mesh_Get_Custom_PropBindposesP12Il2CppObject,__Z43MonoBehaviour_CUSTOM_Internal_IsInvokingAllP12Il2CppObject,__Z41MonoBehaviour_Get_Custom_PropUseGUILayoutP12Il2CppObject,__Z31Motion_Get_Custom_PropIsLoopingP12Il2CppObject
,__Z28Motion_Get_Custom_PropLegacyP12Il2CppObject,__Z35Motion_Get_Custom_PropIsHumanMotionP12Il2CppObject,__Z38Motion_Get_Custom_PropIsAnimatorMotionP12Il2CppObject,__Z45Playable_CUSTOM_INTERNAL_CALL_IsValidInternalR9HPlayable,__Z30Playable_CUSTOM_InternalCreateP12Il2CppObject,__Z53Playable_CUSTOM_INTERNAL_CALL_CanChangeInputsInternalR9HPlayable,__Z51Playable_CUSTOM_INTERNAL_CALL_CanSetWeightsInternalR9HPlayable,__Z48Playable_CUSTOM_INTERNAL_CALL_CanDestroyInternalR9HPlayable,__Z50Playable_CUSTOM_INTERNAL_CALL_GetPlayStateInternalR9HPlayable,__Z51Playable_CUSTOM_INTERNAL_CALL_GetInputCountInternalR9HPlayable,__Z52Playable_CUSTOM_INTERNAL_CALL_GetOutputCountInternalR9HPlayable,__Z25PlayerPrefs_CUSTOM_HasKeyP12Il2CppString,__Z36Profiler_CUSTOM_GetRuntimeMemorySizeP12Il2CppObject,__Z45Profiler_CUSTOM_SetTempAllocatorRequestedSizej,__Z26Profiler_CUSTOM_GetSamplerP12Il2CppString,__Z27Sampler_Get_Custom_PropNameP12Il2CppObject,__Z30Sampler_Get_Custom_PropEnabledP12Il2CppObject,__Z43RectTransform_Get_Custom_PropDrivenByObjectP12Il2CppObject,__Z45RectTransform_Get_Custom_PropDrivenPropertiesP12Il2CppObject,__Z35ReflectionProbe_Get_Custom_PropTypeP12Il2CppObject,__Z34ReflectionProbe_Get_Custom_PropHdrP12Il2CppObject,__Z41ReflectionProbe_Get_Custom_PropResolutionP12Il2CppObject,__Z42ReflectionProbe_Get_Custom_PropCullingMaskP12Il2CppObject,__Z41ReflectionProbe_Get_Custom_PropClearFlagsP12Il2CppObject,__Z44ReflectionProbe_Get_Custom_PropBoxProjectionP12Il2CppObject,__Z35ReflectionProbe_Get_Custom_PropModeP12Il2CppObject,__Z41ReflectionProbe_Get_Custom_PropImportanceP12Il2CppObject,__Z42ReflectionProbe_Get_Custom_PropRefreshModeP12Il2CppObject,__Z46ReflectionProbe_Get_Custom_PropTimeSlicingModeP12Il2CppObject,__Z43ReflectionProbe_Get_Custom_PropBakedTextureP12Il2CppObject
,__Z49ReflectionProbe_Get_Custom_PropCustomBakedTextureP12Il2CppObject,__Z38ReflectionProbe_Get_Custom_PropTextureP12Il2CppObject,__Z37GraphicsSettings_CUSTOM_GetShaderModeN16GraphicsSettings17BuiltinShaderTypeE,__Z39GraphicsSettings_CUSTOM_GetCustomShaderN16GraphicsSettings17BuiltinShaderTypeE,__Z33CommandBuffer_Get_Custom_PropNameP12Il2CppObject,__Z40CommandBuffer_Get_Custom_PropSizeInBytesP12Il2CppObject,__Z37Resources_CUSTOM_FindObjectsOfTypeAllP12Il2CppObject,__Z28Scene_CUSTOM_IsValidInternali,__Z28Scene_CUSTOM_GetPathInternali,__Z28Scene_CUSTOM_GetNameInternali,__Z32Scene_CUSTOM_GetIsLoadedInternali,__Z36Scene_CUSTOM_GetLoadingStateInternali,__Z31Scene_CUSTOM_GetIsDirtyInternali,__Z34Scene_CUSTOM_GetBuildIndexInternali,__Z33Scene_CUSTOM_GetRootCountInternali,__Z48SceneManager_CUSTOM_INTERNAL_CALL_SetActiveSceneRKi,__Z44SceneUtility_CUSTOM_GetScenePathByBuildIndexi,__Z44SceneUtility_CUSTOM_GetBuildIndexByScenePathP12Il2CppString,__Z18Shader_CUSTOM_FindP12Il2CppString,__Z25Shader_CUSTOM_FindBuiltinP12Il2CppString,__Z33Shader_Get_Custom_PropIsSupportedP12Il2CppObject,__Z30Shader_CUSTOM_IsKeywordEnabledP12Il2CppString,__Z32Shader_Get_Custom_PropMaximumLODP12Il2CppObject,__Z33Shader_Get_Custom_PropRenderQueueP12Il2CppObject,__Z37Shader_Get_Custom_PropDisableBatchingP12Il2CppObject,__Z26Shader_CUSTOM_GetGlobalInti,__Z30Shader_CUSTOM_GetGlobalTexturei,__Z37Shader_CUSTOM_GetGlobalFloatArrayImpli,__Z38Shader_CUSTOM_GetGlobalVectorArrayImpli,__Z38Shader_CUSTOM_GetGlobalMatrixArrayImpli
,__Z26Shader_CUSTOM_PropertyToIDP12Il2CppString,__Z30Material_Get_Custom_PropShaderP12Il2CppObject,__Z33Material_Get_Custom_PropPassCountP12Il2CppObject,__Z35Material_Get_Custom_PropRenderQueueP12Il2CppObject,__Z38Material_Get_Custom_PropShaderKeywordsP12Il2CppObject,__Z47Material_Get_Custom_PropGlobalIlluminationFlagsP12Il2CppObject,__Z50ShaderVariantCollection_Get_Custom_PropShaderCountP12Il2CppObject,__Z51ShaderVariantCollection_Get_Custom_PropVariantCountP12Il2CppObject,__Z49ShaderVariantCollection_Get_Custom_PropIsWarmedUpP12Il2CppObject,__Z39SortingLayer_CUSTOM_GetLayerValueFromIDi,__Z41SortingLayer_CUSTOM_GetLayerValueFromNameP12Il2CppString,__Z28SortingLayer_CUSTOM_NameToIDP12Il2CppString,__Z28SortingLayer_CUSTOM_IDToNamei,__Z27SortingLayer_CUSTOM_IsValidi,__Z29Sprite_Get_Custom_PropTextureP12Il2CppObject,__Z49Sprite_Get_Custom_PropAssociatedAlphaSplitTextureP12Il2CppObject,__Z28Sprite_Get_Custom_PropPackedP12Il2CppObject,__Z33Sprite_Get_Custom_PropPackingModeP12Il2CppObject,__Z37Sprite_Get_Custom_PropPackingRotationP12Il2CppObject,__Z30Sprite_Get_Custom_PropVerticesP12Il2CppObject,__Z31Sprite_Get_Custom_PropTrianglesP12Il2CppObject,__Z24Sprite_Get_Custom_PropUvP12Il2CppObject,__Z40SpriteRenderer_CUSTOM_GetSprite_INTERNALP12Il2CppObject,__Z35SpriteRenderer_Get_Custom_PropFlipXP12Il2CppObject,__Z35SpriteRenderer_Get_Custom_PropFlipYP12Il2CppObject,__Z29TextAsset_Get_Custom_PropTextP12Il2CppObject,__Z30TextAsset_Get_Custom_PropBytesP12Il2CppObject,__Z32Texture_CUSTOM_Internal_GetWidthP12Il2CppObject,__Z33Texture_CUSTOM_Internal_GetHeightP12Il2CppObject,__Z36Texture_CUSTOM_Internal_GetDimensionP12Il2CppObject
,__Z33Texture_Get_Custom_PropFilterModeP12Il2CppObject,__Z33Texture_Get_Custom_PropAnisoLevelP12Il2CppObject,__Z31Texture_Get_Custom_PropWrapModeP12Il2CppObject,__Z33Texture_CUSTOM_GetNativeTextureIDP12Il2CppObject,__Z36Texture2D_Get_Custom_PropMipmapCountP12Il2CppObject,__Z31Texture2D_Get_Custom_PropFormatP12Il2CppObject,__Z34Texture2D_CUSTOM_GetRawTextureDataP12Il2CppObject,__Z28Texture2D_CUSTOM_EncodeToPNGP12Il2CppObject,__Z34Cubemap_Get_Custom_PropMipmapCountP12Il2CppObject,__Z29Cubemap_Get_Custom_PropFormatP12Il2CppObject,__Z30Texture3D_Get_Custom_PropDepthP12Il2CppObject,__Z31Texture3D_Get_Custom_PropFormatP12Il2CppObject,__Z35Texture2DArray_Get_Custom_PropDepthP12Il2CppObject,__Z36Texture2DArray_Get_Custom_PropFormatP12Il2CppObject,__Z40CubemapArray_Get_Custom_PropCubemapCountP12Il2CppObject,__Z34CubemapArray_Get_Custom_PropFormatP12Il2CppObject,__Z38SparseTexture_Get_Custom_PropTileWidthP12Il2CppObject,__Z39SparseTexture_Get_Custom_PropTileHeightP12Il2CppObject,__Z38SparseTexture_Get_Custom_PropIsCreatedP12Il2CppObject,__Z38RenderTexture_CUSTOM_Internal_GetWidthP12Il2CppObject,__Z39RenderTexture_CUSTOM_Internal_GetHeightP12Il2CppObject,__Z34RenderTexture_Get_Custom_PropDepthP12Il2CppObject,__Z41RenderTexture_Get_Custom_PropIsPowerOfTwoP12Il2CppObject,__Z33RenderTexture_Get_Custom_PropSRGBP12Il2CppObject,__Z35RenderTexture_Get_Custom_PropFormatP12Il2CppObject,__Z38RenderTexture_Get_Custom_PropUseMipMapP12Il2CppObject,__Z45RenderTexture_Get_Custom_PropAutoGenerateMipsP12Il2CppObject,__Z42RenderTexture_CUSTOM_Internal_GetDimensionP12Il2CppObject,__Z38RenderTexture_Get_Custom_PropIsCubemapP12Il2CppObject,__Z37RenderTexture_Get_Custom_PropIsVolumeP12Il2CppObject
,__Z40RenderTexture_Get_Custom_PropVolumeDepthP12Il2CppObject,__Z41RenderTexture_Get_Custom_PropAntiAliasingP12Il2CppObject,__Z46RenderTexture_Get_Custom_PropEnableRandomWriteP12Il2CppObject,__Z41RenderTexture_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObject,__Z44RenderTexture_CUSTOM_INTERNAL_CALL_IsCreatedP12Il2CppObject,__Z36RenderTexture_CUSTOM_SupportsStencilP12Il2CppObject,__Z39Transform_Get_Custom_PropParentInternalP12Il2CppObject,__Z29Transform_Get_Custom_PropRootP12Il2CppObject,__Z35Transform_Get_Custom_PropChildCountP12Il2CppObject,__Z32Transform_CUSTOM_GetSiblingIndexP12Il2CppObject,__Z35Transform_Get_Custom_PropHasChangedP12Il2CppObject,__Z30Transform_CUSTOM_GetChildCountP12Il2CppObject,__Z42Transform_Get_Custom_PropHierarchyCapacityP12Il2CppObject,__Z39Transform_Get_Custom_PropHierarchyCountP12Il2CppObject,__Z34Object_CUSTOM_Internal_CloneSingleP12Il2CppObject,__Z31Object_CUSTOM_FindObjectsOfTypeP12Il2CppObject,__Z26Object_Get_Custom_PropNameP12Il2CppObject,__Z31Object_Get_Custom_PropHideFlagsP12Il2CppObject,__Z36Object_CUSTOM_FindSceneObjectsOfTypeP12Il2CppObject,__Z46Object_CUSTOM_FindObjectsOfTypeIncludingAssetsP12Il2CppObject,__Z22Object_CUSTOM_ToStringP12Il2CppObject,__Z43Object_CUSTOM_DoesObjectWithInstanceIDExisti,__Z41WWW_CUSTOM_enforceWebSecurityRestrictionsP12Il2CppObject,__Z40WWW_Get_Custom_PropResponseHeadersStringP12Il2CppObject,__Z24WWW_Get_Custom_PropBytesP12Il2CppObject,__Z23WWW_Get_Custom_PropSizeP12Il2CppObject,__Z24WWW_Get_Custom_PropErrorP12Il2CppObject,__Z25WWW_Get_Custom_PropIsDoneP12Il2CppObject,__Z34WWW_Get_Custom_PropBytesDownloadedP12Il2CppObject,__Z22WWW_Get_Custom_PropUrlP12Il2CppObject
,__Z30WWW_Get_Custom_PropAssetBundleP12Il2CppObject,__Z28WindZone_Get_Custom_PropModeP12Il2CppObject,__ZN12WWWDelayCall7CleanupEPv,__Z23AndroidJNI_CUSTOM_Throw13Il2Cpp_IntPtr,__Z32AndroidJNI_CUSTOM_PushLocalFramei,__Z37AndroidJNI_CUSTOM_EnsureLocalCapacityi,__Z36AndroidJNI_CUSTOM_GetStringUTFLength13Il2Cpp_IntPtr,__Z35AndroidJNI_CUSTOM_GetStringUTFChars13Il2Cpp_IntPtr,__Z34AndroidJNI_CUSTOM_FromBooleanArray13Il2Cpp_IntPtr,__Z31AndroidJNI_CUSTOM_FromByteArray13Il2Cpp_IntPtr,__Z31AndroidJNI_CUSTOM_FromCharArray13Il2Cpp_IntPtr,__Z32AndroidJNI_CUSTOM_FromShortArray13Il2Cpp_IntPtr,__Z30AndroidJNI_CUSTOM_FromIntArray13Il2Cpp_IntPtr,__Z31AndroidJNI_CUSTOM_FromLongArray13Il2Cpp_IntPtr,__Z32AndroidJNI_CUSTOM_FromFloatArray13Il2Cpp_IntPtr,__Z33AndroidJNI_CUSTOM_FromDoubleArray13Il2Cpp_IntPtr,__Z33AndroidJNI_CUSTOM_FromObjectArray13Il2Cpp_IntPtr,__Z32AndroidJNI_CUSTOM_GetArrayLength13Il2Cpp_IntPtr,_glCheckFramebufferStatus__wrapper,_glCreateShader__wrapper,_glGetString__wrapper,_glIsEnabled__wrapper,_glIsVertexArray__wrapper,_glUnmapBuffer__wrapper,__Z43ParticleSystem_MainModule_CUSTOM_GetEnabledP12Il2CppObject,__Z40ParticleSystem_MainModule_CUSTOM_GetLoopP12Il2CppObject,__Z43ParticleSystem_MainModule_CUSTOM_GetPrewarmP12Il2CppObject,__Z47ParticleSystem_MainModule_CUSTOM_GetStartSize3DP12Il2CppObject,__Z51ParticleSystem_MainModule_CUSTOM_GetStartRotation3DP12Il2CppObject,__Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpaceP12Il2CppObject
,__Z57ParticleSystem_MainModule_CUSTOM_GetCustomSimulationSpaceP12Il2CppObject,__Z47ParticleSystem_MainModule_CUSTOM_GetScalingModeP12Il2CppObject,__Z47ParticleSystem_MainModule_CUSTOM_GetPlayOnAwakeP12Il2CppObject,__Z48ParticleSystem_MainModule_CUSTOM_GetMaxParticlesP12Il2CppObject,__Z47ParticleSystem_EmissionModule_CUSTOM_GetEnabledP12Il2CppObject,__Z50ParticleSystem_EmissionModule_CUSTOM_GetBurstCountP12Il2CppObject,__Z44ParticleSystem_ShapeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z46ParticleSystem_ShapeModule_CUSTOM_GetShapeTypeP12Il2CppObject,__Z53ParticleSystem_ShapeModule_CUSTOM_GetAlignToDirectionP12Il2CppObject,__Z50ParticleSystem_ShapeModule_CUSTOM_GetMeshShapeTypeP12Il2CppObject,__Z41ParticleSystem_ShapeModule_CUSTOM_GetMeshP12Il2CppObject,__Z49ParticleSystem_ShapeModule_CUSTOM_GetMeshRendererP12Il2CppObject,__Z56ParticleSystem_ShapeModule_CUSTOM_GetSkinnedMeshRendererP12Il2CppObject,__Z57ParticleSystem_ShapeModule_CUSTOM_GetUseMeshMaterialIndexP12Il2CppObject,__Z54ParticleSystem_ShapeModule_CUSTOM_GetMeshMaterialIndexP12Il2CppObject,__Z50ParticleSystem_ShapeModule_CUSTOM_GetUseMeshColorsP12Il2CppObject,__Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject,__Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject,__Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject,__Z54ParticleSystem_InheritVelocityModule_CUSTOM_GetEnabledP12Il2CppObject,__Z51ParticleSystem_InheritVelocityModule_CUSTOM_GetModeP12Il2CppObject,__Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject,__Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetRandomizedP12Il2CppObject,__Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z51ParticleSystem_ColorBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject,__Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject
,__Z50ParticleSystem_SizeBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject,__Z55ParticleSystem_SizeBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject,__Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject,__Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject,__Z54ParticleSystem_RotationBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject,__Z59ParticleSystem_RotationBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject,__Z53ParticleSystem_ExternalForcesModule_CUSTOM_GetEnabledP12Il2CppObject,__Z44ParticleSystem_NoiseModule_CUSTOM_GetEnabledP12Il2CppObject,__Z49ParticleSystem_NoiseModule_CUSTOM_GetSeparateAxesP12Il2CppObject,__Z44ParticleSystem_NoiseModule_CUSTOM_GetDampingP12Il2CppObject,__Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveCountP12Il2CppObject,__Z44ParticleSystem_NoiseModule_CUSTOM_GetQualityP12Il2CppObject,__Z49ParticleSystem_NoiseModule_CUSTOM_GetRemapEnabledP12Il2CppObject,__Z48ParticleSystem_CollisionModule_CUSTOM_GetEnabledP12Il2CppObject,__Z45ParticleSystem_CollisionModule_CUSTOM_GetTypeP12Il2CppObject,__Z45ParticleSystem_CollisionModule_CUSTOM_GetModeP12Il2CppObject,__Z53ParticleSystem_CollisionModule_CUSTOM_GetCollidesWithP12Il2CppObject,__Z63ParticleSystem_CollisionModule_CUSTOM_GetEnableDynamicCollidersP12Il2CppObject,__Z65ParticleSystem_CollisionModule_CUSTOM_GetEnableInteriorCollisionsP12Il2CppObject,__Z59ParticleSystem_CollisionModule_CUSTOM_GetMaxCollisionShapesP12Il2CppObject,__Z48ParticleSystem_CollisionModule_CUSTOM_GetQualityP12Il2CppObject,__Z62ParticleSystem_CollisionModule_CUSTOM_GetUsesCollisionMessagesP12Il2CppObject,__Z54ParticleSystem_CollisionModule_CUSTOM_GetMaxPlaneCountP12Il2CppObject,__Z46ParticleSystem_TriggerModule_CUSTOM_GetEnabledP12Il2CppObject,__Z45ParticleSystem_TriggerModule_CUSTOM_GetInsideP12Il2CppObject,__Z46ParticleSystem_TriggerModule_CUSTOM_GetOutsideP12Il2CppObject,__Z44ParticleSystem_TriggerModule_CUSTOM_GetEnterP12Il2CppObject,__Z43ParticleSystem_TriggerModule_CUSTOM_GetExitP12Il2CppObject,__Z55ParticleSystem_TriggerModule_CUSTOM_GetMaxColliderCountP12Il2CppObject,__Z50ParticleSystem_SubEmittersModule_CUSTOM_GetEnabledP12Il2CppObject
,__Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmittersCountP12Il2CppObject,__Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetEnabledP12Il2CppObject,__Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesXP12Il2CppObject,__Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesYP12Il2CppObject,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetAnimationTypeP12Il2CppObject,__Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUseRandomRowP12Il2CppObject,__Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetCycleCountP12Il2CppObject,__Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetRowIndexP12Il2CppObject,__Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUVChannelMaskP12Il2CppObject,__Z45ParticleSystem_LightsModule_CUSTOM_GetEnabledP12Il2CppObject,__Z59ParticleSystem_LightsModule_CUSTOM_GetUseRandomDistributionP12Il2CppObject,__Z49ParticleSystem_LightsModule_CUSTOM_GetLightPrefabP12Il2CppObject,__Z54ParticleSystem_LightsModule_CUSTOM_GetUseParticleColorP12Il2CppObject,__Z54ParticleSystem_LightsModule_CUSTOM_GetSizeAffectsRangeP12Il2CppObject,__Z59ParticleSystem_LightsModule_CUSTOM_GetAlphaAffectsIntensityP12Il2CppObject,__Z47ParticleSystem_LightsModule_CUSTOM_GetMaxLightsP12Il2CppObject,__Z44ParticleSystem_TrailModule_CUSTOM_GetEnabledP12Il2CppObject,__Z48ParticleSystem_TrailModule_CUSTOM_GetTextureModeP12Il2CppObject,__Z47ParticleSystem_TrailModule_CUSTOM_GetWorldSpaceP12Il2CppObject,__Z53ParticleSystem_TrailModule_CUSTOM_GetDieWithParticlesP12Il2CppObject,__Z53ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsWidthP12Il2CppObject,__Z56ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsLifetimeP12Il2CppObject,__Z57ParticleSystem_TrailModule_CUSTOM_GetInheritParticleColorP12Il2CppObject,__Z39ParticleSystem_Get_Custom_PropIsPlayingP12Il2CppObject,__Z40ParticleSystem_Get_Custom_PropIsEmittingP12Il2CppObject,__Z39ParticleSystem_Get_Custom_PropIsStoppedP12Il2CppObject,__Z38ParticleSystem_Get_Custom_PropIsPausedP12Il2CppObject,__Z34ParticleSystem_Get_Custom_PropLoopP12Il2CppObject,__Z41ParticleSystem_Get_Custom_PropPlayOnAwakeP12Il2CppObject,__Z43ParticleSystem_Get_Custom_PropParticleCountP12Il2CppObject
,__Z42ParticleSystem_Get_Custom_PropMaxParticlesP12Il2CppObject,__Z45ParticleSystem_Get_Custom_PropSimulationSpaceP12Il2CppObject,__Z41ParticleSystem_Get_Custom_PropScalingModeP12Il2CppObject,__Z40ParticleSystem_Get_Custom_PropRandomSeedP12Il2CppObject,__Z47ParticleSystem_Get_Custom_PropUseAutoRandomSeedP12Il2CppObject,__Z35ParticleSystem_CUSTOM_Internal_PlayP12Il2CppObject,__Z36ParticleSystem_CUSTOM_Internal_PauseP12Il2CppObject,__Z36ParticleSystem_CUSTOM_Internal_ClearP12Il2CppObject,__Z38ParticleSystem_CUSTOM_Internal_IsAliveP12Il2CppObject,__Z48ParticleSystemRenderer_Get_Custom_PropRenderModeP12Il2CppObject,__Z47ParticleSystemRenderer_Get_Custom_PropAlignmentP12Il2CppObject,__Z46ParticleSystemRenderer_Get_Custom_PropSortModeP12Il2CppObject,__Z42ParticleSystemRenderer_Get_Custom_PropMeshP12Il2CppObject,__Z51ParticleSystemRenderer_CUSTOM_Internal_GetMeshCountP12Il2CppObject,__Z51ParticleSystemRenderer_Get_Custom_PropTrailMaterialP12Il2CppObject,__Z50ParticleCollisionEvent_CUSTOM_InstanceIDToCollideri,__Z59ParticleCollisionEvent_CUSTOM_InstanceIDToColliderComponenti,__Z61ParticleSystemExtensionsImpl_CUSTOM_GetSafeCollisionEventSizeP12Il2CppObject,__Z28getPxMaterial_ReferenceCountPKN5physx10PxMaterialE,__Z19getPxMaterial_FlagsPKN5physx10PxMaterialE,__Z33getPxMaterial_FrictionCombineModePKN5physx10PxMaterialE,__Z36getPxMaterial_RestitutionCombineModePKN5physx10PxMaterialE,__Z30getPxMaterial_ConcreteTypeNamePKN5physx10PxMaterialE,__Z21getPxMaterialUserDataPKN5physx10PxMaterialE,__Z23getPxShape_GeometryTypePKN5physx7PxShapeE,__Z22getNbPxShape_MaterialsPKN5physx7PxShapeE,__Z16getPxShape_FlagsPKN5physx7PxShapeE,__Z22getPxShape_IsExclusivePKN5physx7PxShapeE,__Z15getPxShape_NamePKN5physx7PxShapeE,__Z27getPxShape_ConcreteTypeNamePKN5physx7PxShapeE
,__Z18getPxShapeUserDataPKN5physx7PxShapeE,__Z35getPxHeightFieldGeometryHeightFieldPKN5physx21PxHeightFieldGeometryE,__Z40getPxHeightFieldGeometryHeightFieldFlagsPKN5physx21PxHeightFieldGeometryE,__Z34getPxTriangleMeshGeometryMeshFlagsPKN5physx22PxTriangleMeshGeometryE,__Z37getPxTriangleMeshGeometryTriangleMeshPKN5physx22PxTriangleMeshGeometryE,__Z33getPxConvexMeshGeometryConvexMeshPKN5physx20PxConvexMeshGeometryE,__Z27getPxSphereGeometry_IsValidPKN5physx16PxSphereGeometryE,__Z28getPxHeightFieldDesc_IsValidPKN5physx17PxHeightFieldDescE,__Z26getPxHeightFieldDescNbRowsPKN5physx17PxHeightFieldDescE,__Z29getPxHeightFieldDescNbColumnsPKN5physx17PxHeightFieldDescE,__Z26getPxHeightFieldDescFormatPKN5physx17PxHeightFieldDescE,__Z25getPxHeightFieldDescFlagsPKN5physx17PxHeightFieldDescE,__Z16getPxActor_ScenePKN5physx7PxActorE,__Z15getPxActor_NamePKN5physx7PxActorE,__Z21getPxActor_ActorFlagsPKN5physx7PxActorE,__Z25getPxActor_DominanceGroupPKN5physx7PxActorE,__Z22getPxActor_OwnerClientPKN5physx7PxActorE,__Z30getPxActor_ClientBehaviorFlagsPKN5physx7PxActorE,__Z20getPxActor_AggregatePKN5physx7PxActorE,__Z18getPxActorUserDataPKN5physx7PxActorE,__Z24getNbPxRigidActor_ShapesPKN5physx12PxRigidActorE,__Z29getNbPxRigidActor_ConstraintsPKN5physx12PxRigidActorE,__Z33getPxRigidStatic_ConcreteTypeNamePKN5physx13PxRigidStaticE,__Z28getPxRigidDynamic_IsSleepingPKN5physx14PxRigidDynamicE,__Z34getPxRigidDynamic_ConcreteTypeNamePKN5physx14PxRigidDynamicE,__Z32getPxRigidBody_RigidDynamicFlagsPKN5physx11PxRigidBodyE,__Z29getPxRigidBody_RigidBodyFlagsPKN5physx11PxRigidBodyE,__Z32getPxArticulationJoint_DriveTypePKN5physx19PxArticulationJointE,__Z40getPxArticulationJoint_SwingLimitEnabledPKN5physx19PxArticulationJointE,__Z40getPxArticulationJoint_TwistLimitEnabledPKN5physx19PxArticulationJointE
,__Z39getPxArticulationJoint_ConcreteTypeNamePKN5physx19PxArticulationJointE,__Z34getPxArticulationLink_InboundJointPKN5physx18PxArticulationLinkE,__Z32getNbPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkE,__Z38getPxArticulationLink_ConcreteTypeNamePKN5physx18PxArticulationLinkE,__Z23getPxArticulation_ScenePKN5physx14PxArticulationE,__Z41getPxArticulation_MaxProjectionIterationsPKN5physx14PxArticulationE,__Z41getPxArticulation_InternalDriveIterationsPKN5physx14PxArticulationE,__Z41getPxArticulation_ExternalDriveIterationsPKN5physx14PxArticulationE,__Z28getPxArticulation_IsSleepingPKN5physx14PxArticulationE,__Z25getNbPxArticulation_LinksPKN5physx14PxArticulationE,__Z22getPxArticulation_NamePKN5physx14PxArticulationE,__Z27getPxArticulation_AggregatePKN5physx14PxArticulationE,__Z34getPxArticulation_ConcreteTypeNamePKN5physx14PxArticulationE,__Z25getPxArticulationUserDataPKN5physx14PxArticulationE,__Z26getPxAggregate_MaxNbActorsPKN5physx11PxAggregateE,__Z23getNbPxAggregate_ActorsPKN5physx11PxAggregateE,__Z28getPxAggregate_SelfCollisionPKN5physx11PxAggregateE,__Z31getPxAggregate_ConcreteTypeNamePKN5physx11PxAggregateE,__Z28getPxClothFabric_NbParticlesPKN5physx13PxClothFabricE,__Z25getNbPxClothFabric_PhasesPKN5physx13PxClothFabricE,__Z23getNbPxClothFabric_SetsPKN5physx13PxClothFabricE,__Z34getNbPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricE,__Z29getNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE,__Z31getPxClothFabric_ReferenceCountPKN5physx13PxClothFabricE,__Z33getPxClothFabric_ConcreteTypeNamePKN5physx13PxClothFabricE,__Z22getPxCloth_NbParticlesPKN5physx7PxClothE,__Z21getPxCloth_ClothFlagsPKN5physx7PxClothE,__Z21getPxCloth_IsSleepingPKN5physx7PxClothE,__Z27getPxCloth_ConcreteTypeNamePKN5physx7PxClothE,__ZN5physx6shdfnd12_GLOBAL__N_113PxThreadStartEPv
,__Z26getPxJoint_ConstraintFlagsPKN5physx7PxJointE,__Z21getPxJoint_ConstraintPKN5physx7PxJointE,__Z15getPxJoint_NamePKN5physx7PxJointE,__Z16getPxJoint_ScenePKN5physx7PxJointE,__Z18getPxJointUserDataPKN5physx7PxJointE,__Z39getPxSphericalJoint_SphericalJointFlagsPKN5physx16PxSphericalJointE,__Z36getPxSphericalJoint_ConcreteTypeNamePKN5physx16PxSphericalJointE,__Z37getPxRevoluteJoint_RevoluteJointFlagsPKN5physx15PxRevoluteJointE,__Z35getPxRevoluteJoint_ConcreteTypeNamePKN5physx15PxRevoluteJointE,__Z39getPxPrismaticJoint_PrismaticJointFlagsPKN5physx16PxPrismaticJointE,__Z36getPxPrismaticJoint_ConcreteTypeNamePKN5physx16PxPrismaticJointE,__Z22getPxD6JointDriveFlagsPKN5physx14PxD6JointDriveE,__Z29getPxD6Joint_ConcreteTypeNamePKN5physx9PxD6JointE,__Z37getPxDistanceJoint_DistanceJointFlagsPKN5physx15PxDistanceJointE,__Z35getPxDistanceJoint_ConcreteTypeNamePKN5physx15PxDistanceJointE,__Z32getPxFixedJoint_ConcreteTypeNamePKN5physx12PxFixedJointE,__Z35getPxParticleFluid_ConcreteTypeNamePKN5physx15PxParticleFluidE,__Z35getPxParticleBase_ParticleBaseFlagsPKN5physx14PxParticleBaseE,__Z30getPxParticleBase_MaxParticlesPKN5physx14PxParticleBaseE,__Z39getPxParticleBase_ParticleReadDataFlagsPKN5physx14PxParticleBaseE,__Z36getPxParticleSystem_ConcreteTypeNamePKN5physx16PxParticleSystemE,__Z28getPxTolerancesScale_IsValidPKN5physx17PxTolerancesScaleE,__ZN12_GLOBAL__N_117createClothFabricERN5physx13PxInputStreamE,__ZN12_GLOBAL__N_117createClothFabricERKN5physx17PxClothFabricDescE,__Z21getPxConstraint_ScenePKN5physx12PxConstraintE,__Z21getPxConstraint_FlagsPKN5physx12PxConstraintE,__Z23getPxConstraint_IsValidPKN5physx12PxConstraintE,__Z32getPxConstraint_ConcreteTypeNamePKN5physx12PxConstraintE,__Z28getPxPhysics_TolerancesScalePKN5physx9PxPhysicsE,__Z29getNbPxPhysics_TriangleMeshesPKN5physx9PxPhysicsE
,__Z27getNbPxPhysics_HeightFieldsPKN5physx9PxPhysicsE,__Z27getNbPxPhysics_ConvexMeshesPKN5physx9PxPhysicsE,__Z27getNbPxPhysics_ClothFabricsPKN5physx9PxPhysicsE,__Z21getNbPxPhysics_ScenesPKN5physx9PxPhysicsE,__Z21getNbPxPhysics_ShapesPKN5physx9PxPhysicsE,__Z24getNbPxPhysics_MaterialsPKN5physx9PxPhysicsE,__Z16getPxScene_FlagsPKN5physx7PxSceneE,__Z20getPxScene_TimestampPKN5physx7PxSceneE,__Z26getNbPxScene_ArticulationsPKN5physx7PxSceneE,__Z24getNbPxScene_ConstraintsPKN5physx7PxSceneE,__Z23getNbPxScene_AggregatesPKN5physx7PxSceneE,__Z24getPxScene_CpuDispatcherPKN5physx7PxSceneE,__Z24getPxScene_GpuDispatcherPKN5physx7PxSceneE,__Z24getPxScene_SpuDispatcherPKN5physx7PxSceneE,__Z42getPxScene_ClothInterCollisionNbIterationsPKN5physx7PxSceneE,__Z32getPxScene_ContactModifyCallbackPKN5physx7PxSceneE,__Z35getPxScene_CCDContactModifyCallbackPKN5physx7PxSceneE,__Z27getPxScene_FilterShaderDataPKN5physx7PxSceneE,__Z31getPxScene_FilterShaderDataSizePKN5physx7PxSceneE,__Z23getPxScene_FilterShaderPKN5physx7PxSceneE,__Z25getPxScene_FilterCallbackPKN5physx7PxSceneE,__Z23getPxScene_CCDMaxPassesPKN5physx7PxSceneE,__Z23getPxScene_FrictionTypePKN5physx7PxSceneE,__Z34getPxScene_VisualizationCullingBoxPKN5physx7PxSceneE,__Z26getPxScene_StaticStructurePKN5physx7PxSceneE,__Z27getPxScene_DynamicStructurePKN5physx7PxSceneE,__Z37getPxScene_DynamicTreeRebuildRateHintPKN5physx7PxSceneE,__Z36getPxScene_SceneQueryStaticTimestampPKN5physx7PxSceneE,__Z25getPxScene_BroadPhaseTypePKN5physx7PxSceneE,__Z30getNbPxScene_BroadPhaseRegionsPKN5physx7PxSceneE
,__Z22getPxScene_TaskManagerPKN5physx7PxSceneE,__Z37getPxScene_MaxNbContactDataBlocksUsedPKN5physx7PxSceneE,__Z40getPxScene_ContactReportStreamBufferSizePKN5physx7PxSceneE,__Z26getPxScene_SolverBatchSizePKN5physx7PxSceneE,__Z18getPxSceneUserDataPKN5physx7PxSceneE,__Z30getPxClothFabricPhasePhaseTypePKN5physx18PxClothFabricPhaseE,__Z29getPxClothFabricPhaseSetIndexPKN5physx18PxClothFabricPhaseE,__Z27getPxSceneLimitsMaxNbActorsPKN5physx13PxSceneLimitsE,__Z27getPxSceneLimitsMaxNbBodiesPKN5physx13PxSceneLimitsE,__Z33getPxSceneLimitsMaxNbStaticShapesPKN5physx13PxSceneLimitsE,__Z34getPxSceneLimitsMaxNbDynamicShapesPKN5physx13PxSceneLimitsE,__Z31getPxSceneLimitsMaxNbAggregatesPKN5physx13PxSceneLimitsE,__Z32getPxSceneLimitsMaxNbConstraintsPKN5physx13PxSceneLimitsE,__Z28getPxSceneLimitsMaxNbRegionsPKN5physx13PxSceneLimitsE,__Z37getPxSceneLimitsMaxNbObjectsPerRegionPKN5physx13PxSceneLimitsE,__Z22getPxSceneDesc_IsValidPKN5physx11PxSceneDescE,__Z37getPxSceneDescSimulationEventCallbackPKN5physx11PxSceneDescE,__Z35getPxSceneDescContactModifyCallbackPKN5physx11PxSceneDescE,__Z38getPxSceneDescCcdContactModifyCallbackPKN5physx11PxSceneDescE,__Z30getPxSceneDescFilterShaderDataPKN5physx11PxSceneDescE,__Z34getPxSceneDescFilterShaderDataSizePKN5physx11PxSceneDescE,__Z26getPxSceneDescFilterShaderPKN5physx11PxSceneDescE,__Z28getPxSceneDescFilterCallbackPKN5physx11PxSceneDescE,__Z28getPxSceneDescBroadPhaseTypePKN5physx11PxSceneDescE,__Z32getPxSceneDescBroadPhaseCallbackPKN5physx11PxSceneDescE,__Z26getPxSceneDescFrictionTypePKN5physx11PxSceneDescE,__Z19getPxSceneDescFlagsPKN5physx11PxSceneDescE,__Z27getPxSceneDescCpuDispatcherPKN5physx11PxSceneDescE,__Z27getPxSceneDescGpuDispatcherPKN5physx11PxSceneDescE,__Z27getPxSceneDescSpuDispatcherPKN5physx11PxSceneDescE
,__Z29getPxSceneDescStaticStructurePKN5physx11PxSceneDescE,__Z30getPxSceneDescDynamicStructurePKN5physx11PxSceneDescE,__Z40getPxSceneDescDynamicTreeRebuildRateHintPKN5physx11PxSceneDescE,__Z22getPxSceneDescUserDataPKN5physx11PxSceneDescE,__Z29getPxSceneDescSolverBatchSizePKN5physx11PxSceneDescE,__Z33getPxSceneDescNbContactDataBlocksPKN5physx11PxSceneDescE,__Z36getPxSceneDescMaxNbContactDataBlocksPKN5physx11PxSceneDescE,__Z43getPxSceneDescContactReportStreamBufferSizePKN5physx11PxSceneDescE,__Z26getPxSceneDescCcdMaxPassesPKN5physx11PxSceneDescE,__Z29getPxSceneDescSimulationOrderPKN5physx11PxSceneDescE,__Z44getPxSimulationStatisticsNbActiveConstraintsPKN5physx22PxSimulationStatisticsE,__Z46getPxSimulationStatisticsNbActiveDynamicBodiesPKN5physx22PxSimulationStatisticsE,__Z48getPxSimulationStatisticsNbActiveKinematicBodiesPKN5physx22PxSimulationStatisticsE,__Z39getPxSimulationStatisticsNbStaticBodiesPKN5physx22PxSimulationStatisticsE,__Z40getPxSimulationStatisticsNbDynamicBodiesPKN5physx22PxSimulationStatisticsE,__Z48getPxSimulationStatisticsNbAxisSolverConstraintsPKN5physx22PxSimulationStatisticsE,__Z46getPxSimulationStatisticsCompressedContactSizePKN5physx22PxSimulationStatisticsE,__Z56getPxSimulationStatisticsRequiredContactConstraintMemoryPKN5physx22PxSimulationStatisticsE,__Z45getPxSimulationStatisticsPeakConstraintMemoryPKN5physx22PxSimulationStatisticsE,__Z58getPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePKN5physx22PxSimulationStatisticsE,__Z50getPxSimulationStatisticsParticlesGpuMeshCacheSizePKN5physx22PxSimulationStatisticsE,__Z50getPxSimulationStatisticsParticlesGpuMeshCacheUsedPKN5physx22PxSimulationStatisticsE,__Z37getPxParticleReadDataNbValidParticlesPKN5physx18PxParticleReadDataE,__Z39getPxParticleReadDataValidParticleRangePKN5physx18PxParticleReadDataE,__Z40getPxParticleReadDataValidParticleBitmapPKN5physx18PxParticleReadDataE,__Z31getPxClothParticleDataParticlesPKN5physx19PxClothParticleDataE,__Z39getPxClothParticleDataPreviousParticlesPKN5physx19PxClothParticleDataE,__Z29GetNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE,__Z42ContactPoint_CUSTOM_ColliderFromInstanceIdi,__Z35Rigidbody_Get_Custom_PropUseGravityP12Il2CppObject
,__Z36Rigidbody_Get_Custom_PropIsKinematicP12Il2CppObject,__Z39Rigidbody_Get_Custom_PropFreezeRotationP12Il2CppObject,__Z36Rigidbody_Get_Custom_PropConstraintsP12Il2CppObject,__Z47Rigidbody_Get_Custom_PropCollisionDetectionModeP12Il2CppObject,__Z41Rigidbody_Get_Custom_PropDetectCollisionsP12Il2CppObject,__Z40Rigidbody_Get_Custom_PropUseConeFrictionP12Il2CppObject,__Z38Rigidbody_Get_Custom_PropInterpolationP12Il2CppObject,__Z41Rigidbody_CUSTOM_INTERNAL_CALL_IsSleepingP12Il2CppObject,__Z41Rigidbody_Get_Custom_PropSolverIterationsP12Il2CppObject,__Z49Rigidbody_Get_Custom_PropSolverVelocityIterationsP12Il2CppObject,__Z34Joint_Get_Custom_PropConnectedBodyP12Il2CppObject,__Z49Joint_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject,__Z36Joint_Get_Custom_PropEnableCollisionP12Il2CppObject,__Z40Joint_Get_Custom_PropEnablePreprocessingP12Il2CppObject,__Z34HingeJoint_Get_Custom_PropUseMotorP12Il2CppObject,__Z35HingeJoint_Get_Custom_PropUseLimitsP12Il2CppObject,__Z35HingeJoint_Get_Custom_PropUseSpringP12Il2CppObject,__Z46CharacterJoint_Get_Custom_PropEnableProjectionP12Il2CppObject,__Z40ConfigurableJoint_Get_Custom_PropXMotionP12Il2CppObject,__Z40ConfigurableJoint_Get_Custom_PropYMotionP12Il2CppObject,__Z40ConfigurableJoint_Get_Custom_PropZMotionP12Il2CppObject,__Z47ConfigurableJoint_Get_Custom_PropAngularXMotionP12Il2CppObject,__Z47ConfigurableJoint_Get_Custom_PropAngularYMotionP12Il2CppObject,__Z47ConfigurableJoint_Get_Custom_PropAngularZMotionP12Il2CppObject,__Z50ConfigurableJoint_Get_Custom_PropRotationDriveModeP12Il2CppObject,__Z47ConfigurableJoint_Get_Custom_PropProjectionModeP12Il2CppObject,__Z55ConfigurableJoint_Get_Custom_PropConfiguredInWorldSpaceP12Il2CppObject,__Z43ConfigurableJoint_Get_Custom_PropSwapBodiesP12Il2CppObject,__Z31Collider_Get_Custom_PropEnabledP12Il2CppObject,__Z41Collider_Get_Custom_PropAttachedRigidbodyP12Il2CppObject
,__Z33Collider_Get_Custom_PropIsTriggerP12Il2CppObject,__Z32Collider_Get_Custom_PropMaterialP12Il2CppObject,__Z38Collider_Get_Custom_PropSharedMaterialP12Il2CppObject,__Z38MeshCollider_Get_Custom_PropSharedMeshP12Il2CppObject,__Z34MeshCollider_Get_Custom_PropConvexP12Il2CppObject,__Z39MeshCollider_Get_Custom_PropInflateMeshP12Il2CppObject,__Z40CapsuleCollider_Get_Custom_PropDirectionP12Il2CppObject,__Z45PhysicMaterial_Get_Custom_PropFrictionCombineP12Il2CppObject,__Z43PhysicMaterial_Get_Custom_PropBounceCombineP12Il2CppObject,__Z45CharacterController_Get_Custom_PropIsGroundedP12Il2CppObject,__Z49CharacterController_Get_Custom_PropCollisionFlagsP12Il2CppObject,__Z51CharacterController_Get_Custom_PropDetectCollisionsP12Il2CppObject,__Z56CharacterController_Get_Custom_PropEnableOverlapRecoveryP12Il2CppObject,__Z38Physics2D_CUSTOM_GetLayerCollisionMaski,__Z38Rigidbody2D_Get_Custom_PropUseAutoMassP12Il2CppObject,__Z41Rigidbody2D_Get_Custom_PropSharedMaterialP12Il2CppObject,__Z35Rigidbody2D_Get_Custom_PropBodyTypeP12Il2CppObject,__Z51Rigidbody2D_Get_Custom_PropUseFullKinematicContactsP12Il2CppObject,__Z37Rigidbody2D_Get_Custom_PropFixedAngleP12Il2CppObject,__Z41Rigidbody2D_Get_Custom_PropFreezeRotationP12Il2CppObject,__Z38Rigidbody2D_Get_Custom_PropConstraintsP12Il2CppObject,__Z29Rigidbody2D_CUSTOM_IsSleepingP12Il2CppObject,__Z26Rigidbody2D_CUSTOM_IsAwakeP12Il2CppObject,__Z36Rigidbody2D_Get_Custom_PropSimulatedP12Il2CppObject,__Z40Rigidbody2D_Get_Custom_PropInterpolationP12Il2CppObject,__Z36Rigidbody2D_Get_Custom_PropSleepModeP12Il2CppObject,__Z49Rigidbody2D_Get_Custom_PropCollisionDetectionModeP12Il2CppObject,__Z35Collider2D_Get_Custom_PropIsTriggerP12Il2CppObject,__Z40Collider2D_Get_Custom_PropUsedByEffectorP12Il2CppObject,__Z43Collider2D_Get_Custom_PropAttachedRigidbodyP12Il2CppObject
,__Z36Collider2D_Get_Custom_PropShapeCountP12Il2CppObject,__Z36Collider2D_Get_Custom_PropErrorStateP12Il2CppObject,__Z40Collider2D_Get_Custom_PropSharedMaterialP12Il2CppObject,__Z39EdgeCollider2D_Get_Custom_PropEdgeCountP12Il2CppObject,__Z40EdgeCollider2D_Get_Custom_PropPointCountP12Il2CppObject,__Z36EdgeCollider2D_Get_Custom_PropPointsP12Il2CppObject,__Z42CapsuleCollider2D_Get_Custom_PropDirectionP12Il2CppObject,__Z39PolygonCollider2D_Get_Custom_PropPointsP12Il2CppObject,__Z42PolygonCollider2D_Get_Custom_PropPathCountP12Il2CppObject,__Z43PolygonCollider2D_CUSTOM_GetTotalPointCountP12Il2CppObject,__Z36Joint2D_Get_Custom_PropConnectedBodyP12Il2CppObject,__Z38Joint2D_Get_Custom_PropEnableCollisionP12Il2CppObject,__Z59AnchoredJoint2D_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject,__Z50SpringJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject,__Z52DistanceJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject,__Z46DistanceJoint2D_Get_Custom_PropMaxDistanceOnlyP12Il2CppObject,__Z36HingeJoint2D_Get_Custom_PropUseMotorP12Il2CppObject,__Z37HingeJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject,__Z38HingeJoint2D_Get_Custom_PropLimitStateP12Il2CppObject,__Z50RelativeJoint2D_Get_Custom_PropAutoConfigureOffsetP12Il2CppObject,__Z47SliderJoint2D_Get_Custom_PropAutoConfigureAngleP12Il2CppObject,__Z37SliderJoint2D_Get_Custom_PropUseMotorP12Il2CppObject,__Z38SliderJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject,__Z39SliderJoint2D_Get_Custom_PropLimitStateP12Il2CppObject,__Z48TargetJoint2D_Get_Custom_PropAutoConfigureTargetP12Il2CppObject,__Z36WheelJoint2D_Get_Custom_PropUseMotorP12Il2CppObject,__Z41Effector2D_Get_Custom_PropUseColliderMaskP12Il2CppObject,__Z38Effector2D_Get_Custom_PropColliderMaskP12Il2CppObject,__Z42Effector2D_Get_Custom_PropRequiresColliderP12Il2CppObject,__Z44Effector2D_Get_Custom_PropDesignedForTriggerP12Il2CppObject
,__Z47Effector2D_Get_Custom_PropDesignedForNonTriggerP12Il2CppObject,__Z44AreaEffector2D_Get_Custom_PropUseGlobalAngleP12Il2CppObject,__Z41AreaEffector2D_Get_Custom_PropForceTargetP12Il2CppObject,__Z42PointEffector2D_Get_Custom_PropForceSourceP12Il2CppObject,__Z42PointEffector2D_Get_Custom_PropForceTargetP12Il2CppObject,__Z40PointEffector2D_Get_Custom_PropForceModeP12Il2CppObject,__Z43PlatformEffector2D_Get_Custom_PropUseOneWayP12Il2CppObject,__Z51PlatformEffector2D_Get_Custom_PropUseOneWayGroupingP12Il2CppObject,__Z49PlatformEffector2D_Get_Custom_PropUseSideFrictionP12Il2CppObject,__Z47PlatformEffector2D_Get_Custom_PropUseSideBounceP12Il2CppObject,__Z48SurfaceEffector2D_Get_Custom_PropUseContactForceP12Il2CppObject,__Z44SurfaceEffector2D_Get_Custom_PropUseFrictionP12Il2CppObject,__Z42SurfaceEffector2D_Get_Custom_PropUseBounceP12Il2CppObject,__Z46getNbPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataE,__Z46getNbPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataE,__Z39getPxVehicleWheelsDynData_Wheel4DynDataPKN5physx22PxVehicleWheelsDynDataE,__Z25getPxVehicleTireDataMTypePKN5physx17PxVehicleTireDataE,__Z42getNbPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataE,__Z37getNbPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataE,__Z36getNbPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataE,__Z47getNbPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataE,__Z51getNbPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE,__Z51getNbPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE,__Z45getNbPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataE,__Z45getNbPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataE,__Z48getNbPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataE,__Z53getPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE,__Z54getPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE,__Z45getNbPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataE,__Z30getPxVehicleWheels_VehicleTypePKN5physx15PxVehicleWheelsE
,__Z36getPxVehicleWheels_RigidDynamicActorPKN5physx15PxVehicleWheelsE,__Z35getPxVehicleWheels_ConcreteTypeNamePKN5physx15PxVehicleWheelsE,__Z33getNbPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveE,__Z33getNbPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveE,__Z32getNbPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveE,__Z36getPxVehicleNoDrive_ConcreteTypeNamePKN5physx16PxVehicleNoDriveE,__Z35getPxVehicleDifferential4WDataMTypePKN5physx27PxVehicleDifferential4WDataE,__Z35getPxVehicleClutchDataMAccuracyModePKN5physx19PxVehicleClutchDataE,__Z41getPxVehicleClutchDataMEstimateIterationsPKN5physx19PxVehicleClutchDataE,__Z30getPxVehicleGearsDataMNbRatiosPKN5physx18PxVehicleGearsDataE,__ZN5physx20GetNbTorqueCurvePairEPKNS_19PxVehicleEngineDataE,__Z48getPxVehicleDifferentialNWData_DrivenWheelStatusPKN5physx27PxVehicleDifferentialNWDataE,__Z38getNbPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataE,__Z31getPxVehicleDriveDynData_GearUpPKN5physx21PxVehicleDriveDynDataE,__Z33getPxVehicleDriveDynData_GearDownPKN5physx21PxVehicleDriveDynDataE,__Z37getPxVehicleDriveDynData_UseAutoGearsPKN5physx21PxVehicleDriveDynDataE,__Z36getPxVehicleDriveDynData_CurrentGearPKN5physx21PxVehicleDriveDynDataE,__Z35getPxVehicleDriveDynData_TargetGearPKN5physx21PxVehicleDriveDynDataE,__Z35getPxVehicleDriveDynData_GearChangePKN5physx21PxVehicleDriveDynDataE,__Z37getPxVehicleDriveDynDataMUseAutoGearsPKN5physx21PxVehicleDriveDynDataE,__Z38getPxVehicleDriveDynDataMGearUpPressedPKN5physx21PxVehicleDriveDynDataE,__Z40getPxVehicleDriveDynDataMGearDownPressedPKN5physx21PxVehicleDriveDynDataE,__Z36getPxVehicleDriveDynDataMCurrentGearPKN5physx21PxVehicleDriveDynDataE,__Z35getPxVehicleDriveDynDataMTargetGearPKN5physx21PxVehicleDriveDynDataE,__Z34getPxVehicleDrive_ConcreteTypeNamePKN5physx14PxVehicleDriveE,__Z36getPxVehicleDriveNW_ConcreteTypeNamePKN5physx16PxVehicleDriveNWE,__Z32getPxVehicleDriveTank_DriveModelPKN5physx18PxVehicleDriveTankE,__Z38getPxVehicleDriveTank_ConcreteTypeNamePKN5physx18PxVehicleDriveTankE,__Z36getPxVehicleDrive4W_ConcreteTypeNamePKN5physx16PxVehicleDrive4WE,__Z45getPxVehicleWheels4SimData_TireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE
,__Z50getPxVehicleWheels4SimData_RecipTireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE,__Z39WheelCollider_Get_Custom_PropIsGroundedP12Il2CppObject,__Z31Cloth_Get_Custom_PropUseGravityP12Il2CppObject,__Z34Cloth_Get_Custom_PropSelfCollisionP12Il2CppObject,__Z28Cloth_Get_Custom_PropEnabledP12Il2CppObject,__Z29Cloth_Get_Custom_PropVerticesP12Il2CppObject,__Z28Cloth_Get_Custom_PropNormalsP12Il2CppObject,__Z33Cloth_Get_Custom_PropCoefficientsP12Il2CppObject,__Z36Cloth_Get_Custom_PropSolverFrequencyP12Il2CppObject,__Z37Cloth_Get_Custom_PropCapsuleCollidersP12Il2CppObject,__Z36Cloth_Get_Custom_PropSphereCollidersP12Il2CppObject,__ZL16UnityDetourAlloci,__ZL20UnityDetourAllocTempi,__Z43NavMeshAgent_Get_Custom_PropIsOnOffMeshLinkP12Il2CppObject,__Z51NavMeshAgent_Get_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObject,__Z39NavMeshAgent_Get_Custom_PropAutoBrakingP12Il2CppObject,__Z38NavMeshAgent_Get_Custom_PropAutoRepathP12Il2CppObject,__Z35NavMeshAgent_Get_Custom_PropHasPathP12Il2CppObject,__Z39NavMeshAgent_Get_Custom_PropPathPendingP12Il2CppObject,__Z39NavMeshAgent_Get_Custom_PropIsPathStaleP12Il2CppObject,__Z38NavMeshAgent_Get_Custom_PropPathStatusP12Il2CppObject,__Z40NavMeshAgent_Get_Custom_PropWalkableMaskP12Il2CppObject,__Z36NavMeshAgent_Get_Custom_PropAreaMaskP12Il2CppObject,__Z42NavMeshAgent_Get_Custom_PropUpdatePositionP12Il2CppObject,__Z42NavMeshAgent_Get_Custom_PropUpdateRotationP12Il2CppObject,__Z49NavMeshAgent_Get_Custom_PropObstacleAvoidanceTypeP12Il2CppObject,__Z45NavMeshAgent_Get_Custom_PropAvoidancePriorityP12Il2CppObject,__Z39NavMeshAgent_Get_Custom_PropIsOnNavMeshP12Il2CppObject,__Z38NavMesh_CUSTOM_GetNavMeshLayerFromNameP12Il2CppString,__Z30NavMesh_CUSTOM_GetAreaFromNameP12Il2CppString
,__Z38NavMeshObstacle_Get_Custom_PropCarvingP12Il2CppObject,__Z50NavMeshObstacle_Get_Custom_PropCarveOnlyStationaryP12Il2CppObject,__Z36NavMeshObstacle_Get_Custom_PropShapeP12Il2CppObject,__Z43NavMeshPath_CUSTOM_CalculateCornersInternalP12Il2CppObject,__Z33NavMeshPath_Get_Custom_PropStatusP12Il2CppObject,__Z36OffMeshLink_Get_Custom_PropActivatedP12Il2CppObject,__Z35OffMeshLink_Get_Custom_PropOccupiedP12Il2CppObject,__Z40OffMeshLink_Get_Custom_PropBiDirectionalP12Il2CppObject,__Z39OffMeshLink_Get_Custom_PropNavMeshLayerP12Il2CppObject,__Z31OffMeshLink_Get_Custom_PropAreaP12Il2CppObject,__Z46OffMeshLink_Get_Custom_PropAutoUpdatePositionsP12Il2CppObject,__Z41OffMeshLink_Get_Custom_PropStartTransformP12Il2CppObject,__Z39OffMeshLink_Get_Custom_PropEndTransformP12Il2CppObject,__ZL39UnityAudioEffect_InternalCreateCallbackP14FMOD_DSP_STATE,__ZL40UnityAudioEffect_InternalReleaseCallbackP14FMOD_DSP_STATE,__ZL38UnityAudioEffect_InternalResetCallbackP14FMOD_DSP_STATE,__Z31AudioMixerDuckingCreateCallbackP21UnityAudioEffectState,__Z32AudioMixerDuckingDestroyCallbackP21UnityAudioEffectState,__Z40AudioSettings_CUSTOM_INTERNAL_CALL_ResetRK27AudioConfigurationScripting,__Z32AudioClip_Get_Custom_PropSamplesP12Il2CppObject,__Z33AudioClip_Get_Custom_PropChannelsP12Il2CppObject,__Z34AudioClip_Get_Custom_PropFrequencyP12Il2CppObject,__Z38AudioClip_Get_Custom_PropIsReadyToPlayP12Il2CppObject,__Z33AudioClip_Get_Custom_PropLoadTypeP12Il2CppObject,__Z30AudioClip_CUSTOM_LoadAudioDataP12Il2CppObject,__Z32AudioClip_CUSTOM_UnloadAudioDataP12Il2CppObject,__Z41AudioClip_Get_Custom_PropPreloadAudioDataP12Il2CppObject,__Z34AudioClip_Get_Custom_PropLoadStateP12Il2CppObject,__Z41AudioClip_Get_Custom_PropLoadInBackgroundP12Il2CppObject,__Z47AudioListener_Get_Custom_PropVelocityUpdateModeP12Il2CppObject
,__Z38AudioSource_Get_Custom_PropTimeSamplesP12Il2CppObject,__Z31AudioSource_Get_Custom_PropClipP12Il2CppObject,__Z48AudioSource_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject,__Z36AudioSource_Get_Custom_PropIsPlayingP12Il2CppObject,__Z36AudioSource_Get_Custom_PropIsVirtualP12Il2CppObject,__Z31AudioSource_Get_Custom_PropLoopP12Il2CppObject,__Z47AudioSource_Get_Custom_PropIgnoreListenerVolumeP12Il2CppObject,__Z38AudioSource_Get_Custom_PropPlayOnAwakeP12Il2CppObject,__Z46AudioSource_Get_Custom_PropIgnoreListenerPauseP12Il2CppObject,__Z45AudioSource_Get_Custom_PropVelocityUpdateModeP12Il2CppObject,__Z37AudioSource_Get_Custom_PropSpatializeP12Il2CppObject,__Z48AudioSource_Get_Custom_PropSpatializePostEffectsP12Il2CppObject,__Z40AudioSource_Get_Custom_PropBypassEffectsP12Il2CppObject,__Z48AudioSource_Get_Custom_PropBypassListenerEffectsP12Il2CppObject,__Z44AudioSource_Get_Custom_PropBypassReverbZonesP12Il2CppObject,__Z35AudioSource_Get_Custom_PropPriorityP12Il2CppObject,__Z31AudioSource_Get_Custom_PropMuteP12Il2CppObject,__Z38AudioSource_Get_Custom_PropRolloffModeP12Il2CppObject,__Z43AudioReverbZone_Get_Custom_PropReverbPresetP12Il2CppObject,__Z35AudioReverbZone_Get_Custom_PropRoomP12Il2CppObject,__Z37AudioReverbZone_Get_Custom_PropRoomHFP12Il2CppObject,__Z37AudioReverbZone_Get_Custom_PropRoomLFP12Il2CppObject,__Z42AudioReverbZone_Get_Custom_PropReflectionsP12Il2CppObject,__Z37AudioReverbZone_Get_Custom_PropReverbP12Il2CppObject,__Z51AudioLowPassFilter_Get_Custom_PropCustomCutoffCurveP12Il2CppObject,__Z45AudioReverbFilter_Get_Custom_PropReverbPresetP12Il2CppObject,__Z47AudioMixer_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject,__Z36AudioMixer_Get_Custom_PropUpdateModeP12Il2CppObject,__Z41AudioMixerGroup_Get_Custom_PropAudioMixerP12Il2CppObject,__Z44AudioMixerSnapshot_Get_Custom_PropAudioMixerP12Il2CppObject
,__Z38WebCamTexture_Get_Custom_PropIsPlayingP12Il2CppObject,__Z39WebCamTexture_Get_Custom_PropDeviceNameP12Il2CppObject,__Z43WebCamTexture_Get_Custom_PropRequestedWidthP12Il2CppObject,__Z44WebCamTexture_Get_Custom_PropRequestedHeightP12Il2CppObject,__Z47WebCamTexture_Get_Custom_PropVideoRotationAngleP12Il2CppObject,__Z52WebCamTexture_Get_Custom_PropVideoVerticallyMirroredP12Il2CppObject,__Z47WebCamTexture_Get_Custom_PropDidUpdateThisFrameP12Il2CppObject,__Z45AnimationClipPlayable_CUSTOM_GetAnimationClipR9HPlayable,__Z43AnimationClipPlayable_CUSTOM_GetApplyFootIKR9HPlayable,__Z49AnimationClipPlayable_CUSTOM_GetRemoveStartOffsetR9HPlayable,__Z37AnimationClip_Get_Custom_PropWrapModeP12Il2CppObject,__Z35AnimationClip_Get_Custom_PropLegacyP12Il2CppObject,__Z40AnimationClip_Get_Custom_PropHumanMotionP12Il2CppObject,__Z38AnimationClip_CUSTOM_GetEventsInternalP12Il2CppObject,__Z29Animation_Get_Custom_PropClipP12Il2CppObject,__Z42Animation_Get_Custom_PropPlayAutomaticallyP12Il2CppObject,__Z33Animation_Get_Custom_PropWrapModeP12Il2CppObject,__Z34Animation_Get_Custom_PropIsPlayingP12Il2CppObject,__Z29Animation_CUSTOM_GetClipCountP12Il2CppObject,__Z30Animation_CUSTOM_GetStateCountP12Il2CppObject,__Z39Animation_Get_Custom_PropAnimatePhysicsP12Il2CppObject,__Z45Animation_Get_Custom_PropAnimateOnlyIfVisibleP12Il2CppObject,__Z36Animation_Get_Custom_PropCullingTypeP12Il2CppObject,__Z37AnimationState_Get_Custom_PropEnabledP12Il2CppObject,__Z38AnimationState_Get_Custom_PropWrapModeP12Il2CppObject,__Z35AnimationState_Get_Custom_PropLayerP12Il2CppObject,__Z34AnimationState_Get_Custom_PropClipP12Il2CppObject,__Z34AnimationState_Get_Custom_PropNameP12Il2CppObject,__Z39AnimationState_Get_Custom_PropBlendModeP12Il2CppObject,__Z53AnimatorClipInfo_CUSTOM_ClipInstanceToScriptingObjecti
,__Z37Animator_Get_Custom_PropIsOptimizableP12Il2CppObject,__Z31Animator_Get_Custom_PropIsHumanP12Il2CppObject,__Z37Animator_Get_Custom_PropHasRootMotionP12Il2CppObject,__Z66Animator_Get_Custom_PropIsRootPositionOrRotationControlledByCurvesP12Il2CppObject,__Z37Animator_Get_Custom_PropIsInitializedP12Il2CppObject,__Z39Animator_Get_Custom_PropApplyRootMotionP12Il2CppObject,__Z46Animator_Get_Custom_PropLinearVelocityBlendingP12Il2CppObject,__Z34Animator_Get_Custom_PropUpdateModeP12Il2CppObject,__Z45Animator_Get_Custom_PropHasTransformHierarchyP12Il2CppObject,__Z61Animator_Get_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObject,__Z37Animator_Get_Custom_PropStabilizeFeetP12Il2CppObject,__Z34Animator_Get_Custom_PropLayerCountP12Il2CppObject,__Z34Animator_Get_Custom_PropParametersP12Il2CppObject,__Z38Animator_Get_Custom_PropParameterCountP12Il2CppObject,__Z40Animator_Get_Custom_PropIsMatchingTargetP12Il2CppObject,__Z34Animator_Get_Custom_PropAvatarRootP12Il2CppObject,__Z35Animator_Get_Custom_PropCullingModeP12Il2CppObject,__Z36Animator_Get_Custom_PropRecorderModeP12Il2CppObject,__Z49Animator_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject,__Z28Animator_CUSTOM_StringToHashP12Il2CppString,__Z30Animator_Get_Custom_PropAvatarP12Il2CppObject,__Z24Animator_CUSTOM_GetStatsP12Il2CppObject,__Z39Animator_CUSTOM_CheckIfInIKPassInternalP12Il2CppObject,__Z46Animator_Get_Custom_PropLayersAffectMassCenterP12Il2CppObject,__Z35Animator_Get_Custom_PropLogWarningsP12Il2CppObject,__Z34Animator_Get_Custom_PropFireEventsP12Il2CppObject,__Z63AnimatorControllerPlayable_CUSTOM_GetAnimatorControllerInternalR9HPlayable,__Z55AnimatorControllerPlayable_CUSTOM_GetLayerCountInternalR9HPlayable,__Z59AnimatorControllerPlayable_CUSTOM_GetParameterCountInternalR9HPlayable,__Z60AnimatorControllerPlayable_CUSTOM_GetParametersArrayInternalR9HPlayable
,__Z46AnimatorControllerPlayable_CUSTOM_StringToHashP12Il2CppString,__Z67AnimatorOverrideController_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject,__Z50AnimatorOverrideController_CUSTOM_GetOriginalClipsP12Il2CppObject,__Z50AnimatorOverrideController_CUSTOM_GetOverrideClipsP12Il2CppObject,__Z29Avatar_Get_Custom_PropIsValidP12Il2CppObject,__Z29Avatar_Get_Custom_PropIsHumanP12Il2CppObject,__Z32HumanTrait_CUSTOM_BoneFromMusclei,__Z30HumanTrait_CUSTOM_RequiredBonei,__Z31HumanTrait_CUSTOM_GetParentBonei,__Z55RuntimeAnimatorController_Get_Custom_PropAnimationClipsP12Il2CppObject,__Z41TerrainData_Get_Custom_PropHeightmapWidthP12Il2CppObject,__Z42TerrainData_Get_Custom_PropHeightmapHeightP12Il2CppObject,__Z55TerrainData_Get_Custom_PropInternal_heightmapResolutionP12Il2CppObject,__Z38TerrainData_Get_Custom_PropDetailWidthP12Il2CppObject,__Z39TerrainData_Get_Custom_PropDetailHeightP12Il2CppObject,__Z43TerrainData_Get_Custom_PropDetailResolutionP12Il2CppObject,__Z51TerrainData_Get_Custom_PropDetailResolutionPerPatchP12Il2CppObject,__Z43TerrainData_Get_Custom_PropDetailPrototypesP12Il2CppObject,__Z40TerrainData_Get_Custom_PropTreeInstancesP12Il2CppObject,__Z44TerrainData_Get_Custom_PropTreeInstanceCountP12Il2CppObject,__Z41TerrainData_Get_Custom_PropTreePrototypesP12Il2CppObject,__Z50TerrainData_CUSTOM_NeedUpgradeScaledTreePrototypesP12Il2CppObject,__Z41TerrainData_Get_Custom_PropAlphamapLayersP12Il2CppObject,__Z54TerrainData_Get_Custom_PropInternal_alphamapResolutionP12Il2CppObject,__Z53TerrainData_Get_Custom_PropInternal_baseMapResolutionP12Il2CppObject,__Z47TerrainData_Get_Custom_PropAlphamapTextureCountP12Il2CppObject,__Z42TerrainData_Get_Custom_PropSplatPrototypesP12Il2CppObject,__Z34Terrain_Get_Custom_PropTerrainDataP12Il2CppObject,__Z46Terrain_Get_Custom_PropTreeMaximumFullLODCountP12Il2CppObject,__Z42Terrain_Get_Custom_PropHeightmapMaximumLODP12Il2CppObject
,__Z36Terrain_Get_Custom_PropLightmapIndexP12Il2CppObject,__Z44Terrain_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject,__Z34Terrain_Get_Custom_PropCastShadowsP12Il2CppObject,__Z43Terrain_Get_Custom_PropReflectionProbeUsageP12Il2CppObject,__Z35Terrain_Get_Custom_PropMaterialTypeP12Il2CppObject,__Z39Terrain_Get_Custom_PropMaterialTemplateP12Il2CppObject,__Z36Terrain_Get_Custom_PropDrawHeightmapP12Il2CppObject,__Z42Terrain_Get_Custom_PropDrawTreesAndFoliageP12Il2CppObject,__Z43Terrain_Get_Custom_PropCollectDetailPatchesP12Il2CppObject,__Z40Terrain_Get_Custom_PropEditorRenderFlagsP12Il2CppObject,__Z38Terrain_CUSTOM_CreateTerrainGameObjectP12Il2CppObject,__Z24Tree_Get_Custom_PropDataP12Il2CppObject,__Z36Tree_Get_Custom_PropHasSpeedTreeWindP12Il2CppObject,_UNITY_tt_driver_init,_UNITY_tt_size_init,_UNITY_tt_slot_init,_cff_driver_init,_cff_size_init,_cff_slot_init,_ps_hinter_init,_ft_raster1_init,_ft_smooth_init,_sfnt_get_ps_name,_pshinter_get_globals_funcs,_pshinter_get_t1_funcs,_pshinter_get_t2_funcs,_ps_unicode_value,_ps_get_macintosh_name,_ps_get_standard_strings,_cff_parse_font_matrix
,_cff_parse_font_bbox,_cff_parse_private_dict,_cff_parse_cid_ros,_cff_ps_has_glyph_names,_cff_get_ps_name,_UNITY_TT_RunIns,_Current_Ppem,_Current_Ppem_Stretched,_TT_Load_Glyph_Header,_TT_Load_Simple_Glyph,_TT_Load_Composite_Glyph,__Z27GUIText_Get_Custom_PropTextP12Il2CppObject,__Z31GUIText_Get_Custom_PropMaterialP12Il2CppObject,__Z27GUIText_Get_Custom_PropFontP12Il2CppObject,__Z32GUIText_Get_Custom_PropAlignmentP12Il2CppObject,__Z29GUIText_Get_Custom_PropAnchorP12Il2CppObject,__Z31GUIText_Get_Custom_PropFontSizeP12Il2CppObject,__Z32GUIText_Get_Custom_PropFontStyleP12Il2CppObject,__Z31GUIText_Get_Custom_PropRichTextP12Il2CppObject,__Z28TextMesh_Get_Custom_PropTextP12Il2CppObject,__Z28TextMesh_Get_Custom_PropFontP12Il2CppObject,__Z32TextMesh_Get_Custom_PropFontSizeP12Il2CppObject,__Z33TextMesh_Get_Custom_PropFontStyleP12Il2CppObject,__Z33TextMesh_Get_Custom_PropAlignmentP12Il2CppObject,__Z30TextMesh_Get_Custom_PropAnchorP12Il2CppObject,__Z32TextMesh_Get_Custom_PropRichTextP12Il2CppObject,__Z28Font_Get_Custom_PropMaterialP12Il2CppObject,__Z29Font_Get_Custom_PropFontNamesP12Il2CppObject,__Z33Font_Get_Custom_PropCharacterInfoP12Il2CppObject,__Z27Font_Get_Custom_PropDynamicP12Il2CppObject
,__Z26Font_Get_Custom_PropAscentP12Il2CppObject,__Z30Font_Get_Custom_PropLineHeightP12Il2CppObject,__Z28Font_Get_Custom_PropFontSizeP12Il2CppObject,__Z40TextGenerator_Get_Custom_PropVertexCountP12Il2CppObject,__Z37TextGenerator_CUSTOM_GetVerticesArrayP12Il2CppObject,__Z43TextGenerator_Get_Custom_PropCharacterCountP12Il2CppObject,__Z39TextGenerator_CUSTOM_GetCharactersArrayP12Il2CppObject,__Z38TextGenerator_Get_Custom_PropLineCountP12Il2CppObject,__Z34TextGenerator_CUSTOM_GetLinesArrayP12Il2CppObject,__Z51TextGenerator_Get_Custom_PropFontSizeUsedForBestFitP12Il2CppObject,__Z39CanvasGroup_Get_Custom_PropInteractableP12Il2CppObject,__Z41CanvasGroup_Get_Custom_PropBlocksRaycastsP12Il2CppObject,__Z45CanvasGroup_Get_Custom_PropIgnoreParentGroupsP12Il2CppObject,__Z36CanvasRenderer_Get_Custom_PropIsMaskP12Il2CppObject,__Z45CanvasRenderer_Get_Custom_PropHasRectClippingP12Il2CppObject,__Z47CanvasRenderer_Get_Custom_PropHasPopInstructionP12Il2CppObject,__Z43CanvasRenderer_Get_Custom_PropMaterialCountP12Il2CppObject,__Z46CanvasRenderer_Get_Custom_PropPopMaterialCountP12Il2CppObject,__Z43CanvasRenderer_Get_Custom_PropRelativeDepthP12Il2CppObject,__Z34CanvasRenderer_Get_Custom_PropCullP12Il2CppObject,__Z43CanvasRenderer_Get_Custom_PropAbsoluteDepthP12Il2CppObject,__Z38CanvasRenderer_Get_Custom_PropHasMovedP12Il2CppObject,__Z32Canvas_Get_Custom_PropRenderModeP12Il2CppObject,__Z34Canvas_Get_Custom_PropIsRootCanvasP12Il2CppObject,__Z33Canvas_Get_Custom_PropWorldCameraP12Il2CppObject,__Z42Canvas_Get_Custom_PropOverridePixelPerfectP12Il2CppObject,__Z34Canvas_Get_Custom_PropPixelPerfectP12Il2CppObject,__Z33Canvas_Get_Custom_PropRenderOrderP12Il2CppObject,__Z37Canvas_Get_Custom_PropOverrideSortingP12Il2CppObject,__Z34Canvas_Get_Custom_PropSortingOrderP12Il2CppObject
,__Z35Canvas_Get_Custom_PropTargetDisplayP12Il2CppObject,__Z47Canvas_Get_Custom_PropSortingGridNormalizedSizeP12Il2CppObject,__Z36Canvas_Get_Custom_PropSortingLayerIDP12Il2CppObject,__Z45Canvas_Get_Custom_PropCachedSortingLayerValueP12Il2CppObject,__Z38Canvas_Get_Custom_PropSortingLayerNameP12Il2CppObject,__Z32Canvas_Get_Custom_PropRootCanvasP12Il2CppObject,__Z42TerrainCollider_Get_Custom_PropTerrainDataP12Il2CppObject,__ZL30MonoBehaviourGetObjectGUIStatePv,__ZL33DeveloperConsoleGetObjectGUIStatePv,__Z28Event_Get_Custom_PropRawTypeP12Il2CppObject,__Z25Event_Get_Custom_PropTypeP12Il2CppObject,__Z27Event_Get_Custom_PropButtonP12Il2CppObject,__Z30Event_Get_Custom_PropModifiersP12Il2CppObject,__Z31Event_Get_Custom_PropClickCountP12Il2CppObject,__Z30Event_Get_Custom_PropCharacterP12Il2CppObject,__Z32Event_Get_Custom_PropCommandNameP12Il2CppObject,__Z28Event_Get_Custom_PropKeyCodeP12Il2CppObject,__Z33Event_Get_Custom_PropDisplayIndexP12Il2CppObject,__Z21Event_CUSTOM_PopEventP12Il2CppObject,__Z61GUIStyleState_CUSTOM_GetBackgroundInternalFromDeserializationP12Il2CppObject,__Z42GUIStyleState_CUSTOM_GetBackgroundInternalP12Il2CppObject,__Z28GUIStyle_Get_Custom_PropNameP12Il2CppObject,__Z37GUIStyle_Get_Custom_PropImagePositionP12Il2CppObject,__Z33GUIStyle_Get_Custom_PropAlignmentP12Il2CppObject,__Z32GUIStyle_Get_Custom_PropWordWrapP12Il2CppObject,__Z32GUIStyle_Get_Custom_PropClippingP12Il2CppObject,__Z36GUIStyle_Get_Custom_PropStretchWidthP12Il2CppObject,__Z37GUIStyle_Get_Custom_PropStretchHeightP12Il2CppObject,__Z50GUIStyle_CUSTOM_GetFontInternalDuringLoadingThreadP12Il2CppObject,__Z31GUIStyle_CUSTOM_GetFontInternalP12Il2CppObject
,__Z32GUIStyle_Get_Custom_PropFontSizeP12Il2CppObject,__Z33GUIStyle_Get_Custom_PropFontStyleP12Il2CppObject,__Z32GUIStyle_Get_Custom_PropRichTextP12Il2CppObject,__Z33GUIUtility_CUSTOM_HasMouseControli,__Z41GUIUtility_CUSTOM_Internal_GetDefaultSkini,__Z41GUIUtility_CUSTOM_Internal_GetBuiltinSkini,__Z37DownloadHandler_Get_Custom_PropIsDoneP12Il2CppObject,__Z44DownloadHandlerBuffer_CUSTOM_InternalGetDataP12Il2CppObject,__Z44DownloadHandlerBuffer_CUSTOM_InternalGetTextP12Il2CppObject,__Z48DownloadHandlerTexture_CUSTOM_InternalGetTextureP12Il2CppObject,__Z45DownloadHandlerTexture_CUSTOM_InternalGetDataP12Il2CppObject,__Z53DownloadHandlerAssetBundle_Get_Custom_PropAssetBundleP12Il2CppObject,__Z47DownloadHandlerAudioClip_CUSTOM_InternalGetDataP12Il2CppObject,__Z49DownloadHandlerAudioClip_Get_Custom_PropAudioClipP12Il2CppObject,__Z46UploadHandlerRaw_CUSTOM_InternalGetContentTypeP12Il2CppObject,__Z39UploadHandlerRaw_CUSTOM_InternalGetDataP12Il2CppObject,__Z36UnityWebRequest_CUSTOM_InternalBeginP12Il2CppObject,__Z40UnityWebRequest_CUSTOM_InternalGetMethodP12Il2CppObject,__Z46UnityWebRequest_CUSTOM_InternalGetCustomMethodP12Il2CppObject,__Z39UnityWebRequest_CUSTOM_InternalGetErrorP12Il2CppObject,__Z36UnityWebRequest_Get_Custom_PropErrorP12Il2CppObject,__Z46UnityWebRequest_Get_Custom_PropUseHttpContinueP12Il2CppObject,__Z37UnityWebRequest_CUSTOM_InternalGetUrlP12Il2CppObject,__Z43UnityWebRequest_Get_Custom_PropResponseCodeP12Il2CppObject,__Z43UnityWebRequest_Get_Custom_PropIsModifiableP12Il2CppObject,__Z37UnityWebRequest_Get_Custom_PropIsDoneP12Il2CppObject,__Z38UnityWebRequest_Get_Custom_PropIsErrorP12Il2CppObject,__Z44UnityWebRequest_Get_Custom_PropUploadedBytesP12Il2CppObject,__Z46UnityWebRequest_Get_Custom_PropDownloadedBytesP12Il2CppObject,__Z44UnityWebRequest_Get_Custom_PropRedirectLimitP12Il2CppObject
,__Z46UnityWebRequest_Get_Custom_PropChunkedTransferP12Il2CppObject,__Z52UnityWebRequest_CUSTOM_InternalGetResponseHeaderKeysP12Il2CppObject,__Z44UnityWebRequest_Get_Custom_PropUploadHandlerP12Il2CppObject,__Z46UnityWebRequest_Get_Custom_PropDownloadHandlerP12Il2CppObject,__Z40UnityAnalyticsHandler_CUSTOM_FlushEventsP12Il2CppObject,__Z28RemoteSettings_CUSTOM_HasKeyP12Il2CppString,__Z41UnityAdsSettings_CUSTOM_IsPlatformEnabledi,__Z33UnityAdsSettings_CUSTOM_GetGameIdi,__ZL23StereoDisplayInitializeR34UnityVRDeviceSpecificConfiguration,__ZL15DebugInitializeR34UnityVRDeviceSpecificConfiguration,__Z35ParticleEmitter_Get_Custom_PropEmitP12Il2CppObject,__Z44ParticleEmitter_Get_Custom_PropUseWorldSpaceP12Il2CppObject,__Z42ParticleEmitter_Get_Custom_PropRndRotationP12Il2CppObject,__Z40ParticleEmitter_Get_Custom_PropParticlesP12Il2CppObject,__Z44ParticleEmitter_Get_Custom_PropParticleCountP12Il2CppObject,__Z38ParticleEmitter_Get_Custom_PropEnabledP12Il2CppObject,__Z48ParticleAnimator_Get_Custom_PropDoesAnimateColorP12Il2CppObject,__Z44ParticleAnimator_Get_Custom_PropAutodestructP12Il2CppObject,__Z46ParticleAnimator_Get_Custom_PropColorAnimationP12Il2CppObject,__Z50ParticleRenderer_Get_Custom_PropParticleRenderModeP12Il2CppObject,__Z48ParticleRenderer_Get_Custom_PropUvAnimationXTileP12Il2CppObject,__Z48ParticleRenderer_Get_Custom_PropUvAnimationYTileP12Il2CppObject,__Z39ParticleRenderer_Get_Custom_PropUvTilesP12Il2CppObject,_emscripten_glGetString__wrapper,_emscripten_glIsTexture__wrapper,_emscripten_glIsBuffer__wrapper,_emscripten_glIsRenderbuffer__wrapper,_emscripten_glCreateShader__wrapper,_emscripten_glIsShader__wrapper,_emscripten_glIsProgram__wrapper,_emscripten_glIsFramebuffer__wrapper,_emscripten_glCheckFramebufferStatus__wrapper,_emscripten_glIsEnabled__wrapper,_mclose,_ms_close,_wms_close,_checker,_pthread_mutex_unlock__wrapper,_pthread_cond_destroy__wrapper,_pthread_cond_signal__wrapper,_pthread_cond_broadcast__wrapper,__ZNSt3__212__next_primeEj,_pthread_getspecific__wrapper,__ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv,__ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv,__ZNKSt3__28ios_base6getlocEv,_uselocale,_wcslen,_btowc,_wctob,_pthread_mutex_destroy__wrapper,_pthread_mutex_trylock__wrapper,_pthread_mutex_lock__wrapper,_close,_sysconf__wrapper,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113
,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113,b113];
var FUNCTION_TABLE_iiff = [b114,__Z28AnimationCurve_CUSTOM_AddKeyP12Il2CppObjectff];
var FUNCTION_TABLE_viifi = [b115,__ZNK5physx14NpArticulation16updateDriveCacheERNS_24PxArticulationDriveCacheEfj,__ZN5physx2Cm29ConstraintImmediateVisualizer19visualizeDoubleConeERKNS_11PxTransformEfb,__ZN12_GLOBAL__N_112UserRenderer19visualizeDoubleConeERKN5physx11PxTransformEfb,__Z34Vector3_CUSTOM_INTERNAL_CALL_SlerpRK8Vector3fS1_fRS_,__Z43Vector3_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK8Vector3fS1_fRS_,__Z37Quaternion_CUSTOM_INTERNAL_CALL_SlerpRK11QuaternionfS1_fRS_,__Z46Quaternion_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK11QuaternionfS1_fRS_,__Z36Quaternion_CUSTOM_INTERNAL_CALL_LerpRK11QuaternionfS1_fRS_,__Z45Quaternion_CUSTOM_INTERNAL_CALL_LerpUnclampedRK11QuaternionfS1_fRS_,__Z26Animation_CUSTOM_CrossFadeP12Il2CppObjectP12Il2CppStringfi,__Z40Terrain_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi,b115,b115,b115,b115];
var FUNCTION_TABLE_iiiiifiiiiii = [b116,__Z14raycast_sphereRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z13raycast_planeRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z15raycast_capsuleRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z11raycast_boxRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z18raycast_convexMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z20raycast_triangleMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_,__Z19raycast_heightFieldRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_];
var FUNCTION_TABLE_iiiiifiiiiif = [b117,__ZNK5physx14NpSceneQueries5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf];
var FUNCTION_TABLE_iiiifiiff = [b118,__Z53Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfP11Il2CppArrayiff];
var FUNCTION_TABLE_iifi = [b119,__ZNK5physx14NpArticulation16createDriveCacheEfj,__ZN5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE,__ZThn4_N5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE,__Z52Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionAllRK3Rayfi,b119,b119,b119];
var FUNCTION_TABLE_if = [b120,__Z24Mathf_CUSTOM_FloatToHalff];
var FUNCTION_TABLE_viiif = [b121,__ZN35ClampVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN31CollisionModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN34ColorBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN27ColorModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN30EmissionModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN36ExternalForcesModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN27ForceModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN37InheritVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN29InitialModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN28LightsModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN27NoiseModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN37RotationBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN30RotationModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN27ShapeModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN33SizeBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN26SizeModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN27TrailModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN29TriggerModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN24UVModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN30VelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif,__ZN5physx15PxsParticleData19addDeltaVelocitiesVERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef,__Z38GL_CUSTOM_INTERNAL_CALL_Internal_ClearhhRK10ColorRGBAff,__Z20Material_CUSTOM_LerpP12Il2CppObjectS0_S0_f,__ZN5physx23SetMFrictionVsSlipGraphEPNS_17PxVehicleTireDataEjjf,__Z39AudioMixer_CUSTOM_TransitionToSnapshotsP12Il2CppObjectP11Il2CppArrayS2_f,__Z31Animator_CUSTOM_PlayInFixedTimeP12Il2CppObjectiif,__Z20Animator_CUSTOM_PlayP12Il2CppObjectiif,__Z57AnimatorControllerPlayable_CUSTOM_PlayInFixedTimeInternalR9HPlayableiif
,b121,b121,b121];
var FUNCTION_TABLE_vffffi = [b122,__Z42Matrix4x4_CUSTOM_INTERNAL_CALL_PerspectiveffffR10Matrix4x4f];
var FUNCTION_TABLE_vifiiiiiiiiiiiiiiiiiiiiiii = [b123,__ZNK5physx20PxsSolverCoreGeneral26solveVParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RKNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESJ_RKNSD_IjNSF_IjEEEEPNS_2Cm13SpatialVectorERij];
var FUNCTION_TABLE_iiiffii = [b124,__ZN5physx3Cct13BoxController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE,__ZN5physx3Cct17CapsuleController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE,b124];
var FUNCTION_TABLE_iifiiiii = [b125,__ZN5physx21PxcArticulationHelper30computeUnconstrainedVelocitiesERKNS_25PxcArticulationSolverDescEfRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescERjRNS_2Cm13EventProfilerERNS_25PxsConstraintBlockManagerE];
var FUNCTION_TABLE_iiifi = [b126,__Z40Camera_CUSTOM_INTERNAL_CALL_RaycastTry2DP12Il2CppObjectRK3Rayfi,__Z35ReflectionProbe_CUSTOM_BlendCubemapP12Il2CppObjectS0_fS0_,__Z43Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestAllP12Il2CppObjectRK8Vector3ff23QueryTriggerInteraction,__Z57Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionNonAllocRK3RayP11Il2CppArrayfi,__Z38NavMeshAgent_CUSTOM_SamplePathPositionP12Il2CppObjectifP10NavMeshHit,__Z43NavMesh_CUSTOM_INTERNAL_CALL_SamplePositionRK8Vector3fP10NavMeshHitfi,__Z44TerrainData_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi];
var FUNCTION_TABLE_iiii = [b127,__Z11heapReallocPvS_j,__ZN20LocalFileSystemPosix6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE,__ZN17FileSystemHandler11HasFastHashERK13FileEntryDataR7Hash128,__ZN20LocalFileSystemWebGL6DeleteER13FileEntryDatab,__ZNK20LocalFileSystemPosix6TargetERK13FileEntryDataR15FileSystemEntry,__ZN20LocalFileSystemPosix4LockER13FileEntryData12FileLockMode,__ZN20LocalFileSystemWebGL4CopyER13FileEntryDataS1_,__ZN20LocalFileSystemWebGL10AtomicMoveER13FileEntryDataS1_,__ZN22LocalFileSystemHandler9MakeLocalER13FileEntryDatab,__ZNK20LocalFileSystemPosix21GetAvailableDiskSpaceEPKcRy,__ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8AllocateEji,__ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji,__ZN14StackAllocator8AllocateEji,__ZN12TLSAllocatorI14StackAllocatorE8AllocateEji,__ZN25ThreadsafeLinearAllocator8AllocateEji,__ZN39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader,__ZN39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader,__ZThn128_N39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader,__ZThn128_N39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader,__ZN12BaseRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN24MeshIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN31CanvasBatchIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN8Playable18SetInputConnectionEPS_i,__ZN8Playable19SetOutputConnectionEPS_i,__ZN26RemapFunctorTempRemapTable18GenerateInstanceIDEi17TransferMetaFlags,__ZN9GfxDevice12EndRecordingEPP14GfxDisplayListRK19ShaderPropertySheet,__ZN9GfxDevice20CreateComputeProgramEPKhj,__ZN12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData
,__ZThn32_N12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN10DynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb,__ZN17GenericDynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb,__ZN17GenericDynamicVBO10AllocateVBEjR21DynamicVBOChunkHandle,__ZN17GenericDynamicVBO10AllocateIBEjR21DynamicVBOChunkHandle,__ZN12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN27GenericSlowGarbageCollector18GenerateInstanceIDEi17TransferMetaFlags,__ZN9TextAsset9SetScriptERK8UnityStrb,__ZN25PathNamePersistentManager28InsertFileIdentifierInternalE14FileIdentifierb,__ZN25PathNamePersistentManager22InsertPathNameInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb,__ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags,__ZNK13Lz4Compressor18CompressStreamInitEPPv16CompressionLevel,__ZN17ArchiveFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE,__ZN17ArchiveFileSystem11HasFastHashERK13FileEntryDataR7Hash128,__ZN17ArchiveFileSystem6DeleteER13FileEntryDatab,__ZNK17ArchiveFileSystem6TargetERK13FileEntryDataR15FileSystemEntry,__ZN17ArchiveFileSystem4LockER13FileEntryData12FileLockMode,__ZN17ArchiveFileSystem4CopyER13FileEntryDataS1_,__ZN17FileSystemHandler10AtomicMoveER13FileEntryDataS1_,__ZN17ArchiveFileSystem9MakeLocalER13FileEntryDatab,__ZN15ArchiveReadFile9SetLengthEy
,__ZN12HandlerChain6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE,__ZN12HandlerChain11HasFastHashERK13FileEntryDataR7Hash128,__ZN12HandlerChain6DeleteER13FileEntryDatab,__ZNK12HandlerChain6TargetERK13FileEntryDataR15FileSystemEntry,__ZN12HandlerChain4LockER13FileEntryData12FileLockMode,__ZN12HandlerChain4CopyER13FileEntryDataS1_,__ZN12HandlerChain10AtomicMoveER13FileEntryDataS1_,__ZN12HandlerChain9MakeLocalER13FileEntryDatab,__ZN17FileSystemHandler6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE,__ZNK17FileSystemHandler6TargetERK13FileEntryDataR15FileSystemEntry,__ZN17FileSystemHandler4LockER13FileEntryData12FileLockMode,__ZN17FileSystemHandler4CopyER13FileEntryDataS1_,__ZNK22LocalFileSystemHandler21GetAvailableDiskSpaceEPKcRy,__ZN20LocalFileSystemPosix6DeleteER13FileEntryDatab,__ZN20LocalFileSystemPosix4CopyER13FileEntryDataS1_,__ZN20LocalFileSystemPosix10AtomicMoveER13FileEntryDataS1_,__ZN10MemoryFile9SetLengthEy,__ZN16MemoryFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE,__ZN16MemoryFileSystem11HasFastHashERK13FileEntryDataR7Hash128,__ZN16MemoryFileSystem6DeleteER13FileEntryDatab,__ZNK16MemoryFileSystem6TargetERK13FileEntryDataR15FileSystemEntry,__ZN16MemoryFileSystem4LockER13FileEntryData12FileLockMode,__ZN16MemoryFileSystem4CopyER13FileEntryDataS1_,__ZN16MemoryFileSystem10AtomicMoveER13FileEntryDataS1_,__ZN16MemoryFileSystem9MakeLocalER13FileEntryDatab,__ZN21UnityDefaultAllocatorI17LowLevelAllocatorE8AllocateEji,__ZN12SocketStream4SendEPKvj,__ZN12SocketStream4RecvEPvj,__ZN12SocketStream4PollEy,__ZN20BufferedSocketStream4SendEPKvj
,__ZN20BufferedSocketStream4RecvEPvj,__ZN20BufferedSocketStream4PollEy,__ZN21AssetBundleFileSystem6DeleteER13FileEntryDatab,__ZN17FileSystemHandler9MakeLocalER13FileEntryDatab,__ZN13GfxDeviceGLES32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat,__ZN13GfxDeviceGLES32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat,__ZN13GfxDeviceGLES20CreateComputeProgramEPKhj,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6setbufEPci,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci,__ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci,__ZN13GfxDeviceNull32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat,__ZN13GfxDeviceNull32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat,__ZN5Umbra15MemOutputStream5writeEPKvj,__ZN5Umbra14MemInputStream4readEPvj,__ZN11UmbraModule13LoadUmbraTomeEPKhj,__ZN11UmbraModule15GetObjectUserIDEPKN5Umbra4TomeEi,__ZN5Umbra15SystemAllocator8allocateEjPKc,__ZN5Umbra21UserCallbackAllocator8allocateEjPKc,__ZN5Umbra20SingleBlockAllocator8allocateEjPKc,__ZN22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN44ConvexVsHeightfieldContactGenerationCallback7onEventEjPj,__ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPj,__ZThn4_N16RayRTreeCallbackILi0ELb0EE14processResultsEjPj,__ZN43CapsuleHeightfieldContactGenerationCallback7onEventEjPj,__ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallback7onEventEjPj,__ZN24MidPhaseQueryLocalReport7onEventEjPj,__ZN24ConvexVsHeightfieldSweep7onEventEjPj,__ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReport7onEventEjPj,__ZN21BoxTraceSegmentReport7onEventEjPj
,__ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPj,__ZThn4_N16RayRTreeCallbackILi1ELb0EE14processResultsEjPj,__ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPj,__ZThn4_N16RayRTreeCallbackILi1ELb1EE14processResultsEjPj,__ZN25CapsuleTraceSegmentReport7onEventEjPj,__ZN5physx11PxHitBufferINS_12PxOverlapHitEE14processTouchesEPKS1_j,__ZN12_GLOBAL__N_124HfTrianglesEntityReport27onEventEjPj,__ZN16ControllerFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE,__ZN5physx11PxHitBufferINS_12PxRaycastHitEE14processTouchesEPKS1_j,__ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPj,__ZThn4_N16RayRTreeCallbackILi0ELb1EE14processResultsEjPj,__ZN5physx3Cct15ObstacleContext14updateObstacleEjRKNS_10PxObstacleE,__ZN24ControllerFilterCallback6filterERKN5physx12PxControllerES3_,__ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj,__ZN5physx24PxDefaultMemoryInputData4readEPvj,__ZN5physx25PxDefaultFileOutputStream5writeEPKvj,__ZN5physx22PxDefaultFileInputData4readEPvj,__ZN17InternalIndexPool15allocateIndicesEjRKN5physx16PxStrideIteratorIjEE,__ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamES3_,__ZNK5physx2Sn22DeserializationContext16resolveReferenceEjj,__ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE5writeEPKvj,__ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj,__ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj,__ZN5physx14NpArticulation10createLinkEPNS_18PxArticulationLinkERKNS_11PxTransformE,__ZNK5physx14NpArticulation8getLinksEPPNS_18PxArticulationLinkEj,__ZNK5physx18NpArticulationLink11getChildrenEPPNS_18PxArticulationLinkEj,__ZN16PxOverflowBufferIN5physx12PxRaycastHitEE14processTouchesEPKS1_j,__ZN16PxOverflowBufferIN5physx12PxOverlapHitEE14processTouchesEPKS1_j,__ZN16PxOverflowBufferIN5physx10PxSweepHitEE14processTouchesEPKS1_j,__ZN5physx11PxHitBufferINS_10PxSweepHitEE14processTouchesEPKS1_j
,__ZN5physx9NpPhysics15createAggregateEjb,__ZNK5physx9NpPhysics15getClothFabricsEPPNS_13PxClothFabricEj,__ZN5physx9NpPhysics20createParticleSystemEjb,__ZN5physx9NpPhysics19createParticleFluidEjb,__ZNK5physx7NpShape12getMaterialsEPPNS_10PxMaterialEj,__ZN5physx7NpScene19getActiveTransformsERjh,__ZN5physx7NpScene12fetchResultsEbPj,__ZN5physx7NpScene17createVolumeCacheEjj,__ZN5physx7NpScene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb,__ZN5physx13NpVolumeCache4fillERKNS_10PxGeometryERKNS_11PxTransformE,__ZN5physx13NpVolumeCache14getCacheVolumeERNS_16PxGeometryHolderERNS_11PxTransformE,__ZN5physx23NpVolumeCacheSqCallback14processTouchesEPKNS_12PxOverlapHitEj,__ZNK5physx2Sq12BucketPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE,__ZNK5physx2Sq10AABBPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE,__ZN5physx29EntityReportContainerCallback7onEventEjPj,__ZN5physx16PxBroadPhaseBase9addRegionERKNS_18PxBroadPhaseRegionEb,__ZN5physx16PxsBroadPhaseMBP9addRegionERKNS_18PxBroadPhaseRegionEb,__ZN5physx9PxTaskMgr17submitUnnamedTaskERNS_6PxTaskENS_10PxTaskType4EnumE,__ZNK5physx13NpClothFabric9getPhasesEPNS_18PxClothFabricPhaseEj,__ZNK5physx13NpClothFabric7getSetsEPjj,__ZNK5physx13NpClothFabric18getParticleIndicesEPjj,__ZNK5physx13NpClothFabric13getRestvaluesEPfj,__ZNK5physx13NpClothFabric16getTetherAnchorsEPjj,__ZNK5physx13NpClothFabric16getTetherLengthsEPfj,__ZNK5physx2Gu10ConvexMesh14getPolygonDataEjRNS_13PxHullPolygonE,__ZNK5physx2Gu11HeightField9saveCellsEPvj,__ZN5physx14NpSpatialIndex6insertERNS_18PxSpatialIndexItemERKNS_9PxBounds3E,__ZN5physx7Cooking16cookTriangleMeshERKNS_18PxTriangleMeshDescERNS_14PxOutputStreamE,__ZN5physx7Cooking18createTriangleMeshERKNS_18PxTriangleMeshDescERNS_26PxPhysicsInsertionCallbackE,__ZN5physx7Cooking15cookHeightFieldERKNS_17PxHeightFieldDescERNS_14PxOutputStreamE
,__ZN5physx7Cooking17createHeightFieldERKNS_17PxHeightFieldDescERNS_26PxPhysicsInsertionCallbackE,__ZNK5physx2Cm10Collection4findEy,__ZN5physx6shdfnd18BufferedSocketImpl5writeEPKhj,__ZN5physx6shdfnd10SocketImpl5writeEPKhj,__ZN23ControllerContactFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE,__ZN12MemoryStream5writeEPKvj,__ZN12MemoryStream4readEPvj,__ZThn4_N12MemoryStream4readEPvj,__ZN15RaycastCallback14processTouchesEPKN5physx12PxRaycastHitEj,__ZN10CastFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE,__ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj,__ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStream5writeEPKvj,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12createObjectERPhRNS_24PxDeserializationContextE
,__ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12createObjectERPhRNS_24PxDeserializationContextE,__ZN5physx2Sn18RepXCollectionImpl21instantiateCollectionERNS_23PxRepXInstantiationArgsERNS_12PxCollectionE,__ZN5physx2Sn13XmlNodeReader4readEPKcRS3_,__ZN5physx2Sn13XmlNodeReader4readEPKcRy,__ZN12_GLOBAL__N_19MyFastXml10processXmlERN5physx11PxInputDataEb,__ZN5physx24NpPtrTableStorageManager8canReuseEjj,__ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMConvexVsHeightfieldContactGenerationCallbackEE7onEventEjPj,__ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_48PCMCapsuleVsHeightfieldContactGenerationCallbackEE7onEventEjPj,__ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMSphereVsHeightfieldContactGenerationCallbackEE7onEventEjPj,__ZN12_GLOBAL__N_116MetaDataProvider14createInstanceERKN5physx8debugger14NamespacedNameEPKv,__ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl11deriveClassERKN5physx8debugger14NamespacedNameES5_,__ZN12_GLOBAL__N_115StringTableImpl11registerStrEPKcRb,__ZN5physx8debugger18MemPvdOutputStream5writeEPKhj,__ZN5physx8debugger18MemPvdOutputStream10directCopyERNS0_14PvdInputStreamEj,__ZN5physx8debugger17MemPvdInputStream4readEPhRj,__ZN12_GLOBAL__N_111StreamOwner5writeEPKhj,__ZN12_GLOBAL__N_111StreamOwner9readBytesEPhj,__ZThn4_N12_GLOBAL__N_111StreamOwner9readBytesEPhj,__ZThn8_N12_GLOBAL__N_111StreamOwner5writeEPKhj,__ZN12_GLOBAL__N_123DoubleBufferedOutStream5writeEPKhj,__ZN12_GLOBAL__N_110DataStream14createInstanceERKN5physx8debugger14NamespacedNameEPKv,__ZN12_GLOBAL__N_110DataStream28sendPropertyMessageFromGroupEPKvN5physx8debugger7DataRefIKhEE,__ZN12_GLOBAL__N_110DataStream12beginSectionEPKvPKc,__ZN12_GLOBAL__N_110DataStream10endSectionEPKvPKc,__ZN12_GLOBAL__N_110DataStream11originShiftEPKvN5physx6PxVec3E,__ZN12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_
,__ZThn4_N12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_,__ZN12_GLOBAL__N_123FStreamNetworkOutStream5writeEPKhj,__ZN12_GLOBAL__N_121SocketNetworkInStream9readBytesEPhj,__ZN12_GLOBAL__N_122SocketNetworkOutStream5writeEPKhj,__ZN15OverlapCallback14processTouchesEPKN5physx12PxOverlapHitEj,__ZN23RaycastCallbackNonAlloc14processTouchesEPKN5physx12PxRaycastHitEj,__ZN13SweepCallback14processTouchesEPKN5physx10PxSweepHitEj,__ZN21SweepCallbackNonAlloc14processTouchesEPKN5physx10PxSweepHitEj,__ZN23OverlapCallbackNonAlloc14processTouchesEPKN5physx12PxOverlapHitEj,__ZN25PostFilteredUserCollector10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE,__ZN13PhysicsModule28GetCollisionShapeForColliderEPKN5Unity9ComponentERN8IPhysics13ColliderShapeE,__ZNK12b2ChainShape9TestPointERK11b2TransformRK6b2Vec2,__ZNK11b2EdgeShape9TestPointERK11b2TransformRK6b2Vec2,__ZNK14b2CapsuleShape9TestPointERK11b2TransformRK6b2Vec2,__ZNK14b2PolygonShape9TestPointERK11b2TransformRK6b2Vec2,__ZNK13b2CircleShape9TestPointERK11b2TransformRK6b2Vec2,__ZN15b2ContactFilter13ShouldCollideEP9b2FixtureS1_,__ZN15ContactFilter2D13ShouldCollideEP9b2FixtureS1_,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12createObjectERPhRNS_24PxDeserializationContextE,__ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12createObjectERPhRNS_24PxDeserializationContextE,__ZN14VehiclesModule21GetColliderForVehicleEPN5physx16PxVehicleNoDriveEi,__ZN5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE,__ZN5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE,__ZThn4_N5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE,__ZThn4_N5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE,__ZN7mecanim6memory16MecanimAllocator8AllocateEjj,__ZN7mecanim6memory16ChainedAllocator8AllocateEjj,__ZN17AnimationPlayable18SetInputConnectionEP8Playablei
,__ZN27AnimationLayerMixerPlayable18SetInputConnectionEP8Playablei,__ZN22AnimationMixerPlayable18SetInputConnectionEP8Playablei,__ZN7mecanim6memory16InPlaceAllocator8AllocateEjj,__ZN26AnimatorControllerPlayable8GetFloatEiRf,__ZN26AnimatorControllerPlayable8SetFloatEiRKf,__ZN26AnimatorControllerPlayable10GetIntegerEiRi,__ZN26AnimatorControllerPlayable10SetIntegerEiRKi,__ZN26AnimatorControllerPlayable7GetBoolEiRb,__ZN26AnimatorControllerPlayable7SetBoolEiRKb,__ZN20QuadTreeNodeRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN26LegacyTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN29BillboardTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN23LODTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZN26DownloadHandlerAssetBundle13OnReceiveDataEPKvj,__ZN24DownloadHandlerAudioClip13OnReceiveDataEPKvj,__ZN21DownloadHandlerBuffer13OnReceiveDataEPKvj,__ZN21DownloadHandlerScript13OnReceiveDataEPKvj,__ZN22DownloadHandlerTexture13OnReceiveDataEPKvj,__ZN18DownloadHandlerVFS13OnReceiveDataEPKvj,__ZN8VRDevice26ReleaseEyeTextureResourcesEPvP17RenderSurfaceBase,__ZNK8VRDevice17GetViewportForEyeE15StereoscopicEyeR5RectTIfE,__ZN11UnityEngine15CloudWebService17CloudJobScheduler11ScheduleJobEPFvPvES2_,__ZN11UnityEngine15CloudWebService18RestFileDownloader13OnReceiveDataEPKvj,__ZN11UnityEngine15CloudWebService14RestDownloader13OnReceiveDataEPKvj,__ZN16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,__ZThn32_N16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData,___stdio_write,___stdio_seek,___stdio_read,___stdout_write
,_sn_write,__ZNKSt3__214error_category10equivalentEiRKNS_15error_conditionE,__ZNKSt3__214error_category10equivalentERKNS_10error_codeEi,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi,__ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi,__ZNSt3__211__stdoutbufIwE6xsputnEPKwi,__ZNSt3__211__stdoutbufIcE6xsputnEPKci,__ZNKSt3__27collateIcE7do_hashEPKcS3_,__ZNKSt3__27collateIwE7do_hashEPKwS3_,__ZNKSt3__28messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__28messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE,__ZNKSt3__25ctypeIcE10do_toupperEPcPKc,__ZNKSt3__25ctypeIcE10do_tolowerEPcPKc,__ZNKSt3__25ctypeIcE9do_narrowEcc,__ZNKSt3__212ctype_bynameIcE10do_toupperEPcPKc,__ZNKSt3__212ctype_bynameIcE10do_tolowerEPcPKc,__ZNKSt3__212ctype_bynameIwE5do_isEtw,__ZNKSt3__212ctype_bynameIwE10do_toupperEPwPKw,__ZNKSt3__212ctype_bynameIwE10do_tolowerEPwPKw,__ZNKSt3__212ctype_bynameIwE9do_narrowEwc,__ZNKSt3__25ctypeIwE5do_isEtw,__ZNKSt3__25ctypeIwE10do_toupperEPwPKw,__ZNKSt3__25ctypeIwE10do_tolowerEPwPKw,__ZNKSt3__25ctypeIwE9do_narrowEwc,__ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv117__array_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv120__function_type_info9can_catchEPKNS_16__shim_type_infoERPv
,__ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv,__ZNK10__cxxabiv117__pbase_type_info9can_catchEPKNS_16__shim_type_infoERPv,_UNITY_png_zalloc,_alloc_small,_alloc_large,_unity_z_zcalloc,_fopen_file_func,__ZL7EdgeLeqP14TESStesselatorP12ActiveRegionS2_,__ZL10KeyHandleriPK23EmscriptenKeyboardEventPv,__ZL11TextHandleriPK23EmscriptenKeyboardEventPv,__ZL18MouseButtonHandleriPK20EmscriptenMouseEventPv,__ZL16MouseMoveHandleriPK20EmscriptenMouseEventPv,__ZL17MouseWheelHandleriPK20EmscriptenWheelEventPv,__ZL12TouchHandleriPK20EmscriptenTouchEventPv,__ZL13MotionHandleriPK27EmscriptenDeviceMotionEventPv,__ZL18OrientationHandleriPK32EmscriptenDeviceOrientationEventPv,__Z24FullscreenChangeCallbackiPK31EmscriptenFullscreenChangeEventPv,__Z13FocusCallbackiPK20EmscriptenFocusEventPv,_UNITY_png_set_longjmp_fn,_UNITY_png_get_valid,_UNITY_png_get_gAMA,_jpeg_read_scanlines,__ZN12ImageDecoder14MemoryReadFuncEPvPhj,__Z26PlainLogToPlayerConnection7LogTypePKcPi,__Z26CleanLogToPlayerConnection7LogTypePKcPi,__Z23AssetBundle_CUSTOM_LoadP12Il2CppObjectP12Il2CppStringS0_,__Z28AssetBundle_CUSTOM_LoadAsyncP12Il2CppObjectP12Il2CppStringS0_,__Z37AssetBundle_CUSTOM_LoadAsset_InternalP12Il2CppObjectP12Il2CppStringS0_,__Z42AssetBundle_CUSTOM_LoadAssetAsync_InternalP12Il2CppObjectP12Il2CppStringS0_,__Z50AssetBundle_CUSTOM_LoadAssetWithSubAssets_InternalP12Il2CppObjectP12Il2CppStringS0_
,__Z55AssetBundle_CUSTOM_LoadAssetWithSubAssetsAsync_InternalP12Il2CppObjectP12Il2CppStringS0_,__Z40Camera_CUSTOM_Internal_RenderToCubemapRTP12Il2CppObjectS0_i,__Z45Camera_CUSTOM_Internal_RenderToCubemapTextureP12Il2CppObjectS0_i,__Z39GUIElement_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3fS0_,__Z40GameObject_CUSTOM_GetComponentInChildrenP12Il2CppObjectS0_h,__Z49Bounds_CUSTOM_INTERNAL_CALL_Internal_IntersectRayR3RayR4AABBPf,__Z43AnimationCurve_CUSTOM_INTERNAL_CALL_MoveKeyP12Il2CppObjectiRK16KeyframeTplFloat,__Z35MonoBehaviour_CUSTOM_StartCoroutineP12Il2CppObjectP12Il2CppStringS0_,__Z31Playables_CUSTOM_CastToInternalP12Il2CppObject13Il2Cpp_IntPtri,__Z26Texture2D_CUSTOM_LoadImageP12Il2CppObjectP11Il2CppArrayh,__Z34Texture2D_CUSTOM_Internal_ResizeWHP12Il2CppObjectii,__Z24Cubemap_CUSTOM_GetPixelsP12Il2CppObjectii,__Z31Texture2DArray_CUSTOM_GetPixelsP12Il2CppObjectii,__Z33Texture2DArray_CUSTOM_GetPixels32P12Il2CppObjectii,__Z44Object_CUSTOM_Internal_CloneSingleWithParentP12Il2CppObjectS0_h,__Z54Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleP12Il2CppObjectRK8Vector3fRK11Quaternionf,__Z23DefaultCleanLogHandlerv7LogTypePKcPi,__ZN13MonoBehaviour22CanHandleNotificationsEPviR11MessageData,__Z34AndroidJNI_CUSTOM_CallStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z31AndroidJNI_CUSTOM_CallIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z35AndroidJNI_CUSTOM_CallBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z33AndroidJNI_CUSTOM_CallShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z32AndroidJNI_CUSTOM_CallByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z32AndroidJNI_CUSTOM_CallCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z32AndroidJNI_CUSTOM_CallLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z40AndroidJNI_CUSTOM_CallStaticStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z37AndroidJNI_CUSTOM_CallStaticIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z41AndroidJNI_CUSTOM_CallStaticBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z39AndroidJNI_CUSTOM_CallStaticShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z38AndroidJNI_CUSTOM_CallStaticByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray
,__Z38AndroidJNI_CUSTOM_CallStaticCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z38AndroidJNI_CUSTOM_CallStaticLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray,__Z51ParticleSystem_CUSTOM_GetCustomParticleDataInternalP12Il2CppObjectS0_i,__Z64ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsDeprecatedP12Il2CppObjectS0_P11Il2CppArray,__Z54ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsP12Il2CppObjectS0_S0_,__Z55ParticleSystemExtensionsImpl_CUSTOM_GetTriggerParticlesP12Il2CppObjectiS0_,__ZL26SelectClosestEdgeCB_ConvexRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E,__ZL23SelectClosestEdgeCB_BoxRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E,__Z20getPxShape_MaterialsPKN5physx7PxShapeEPPNS_10PxMaterialEj,__Z22getPxRigidActor_ShapesPKN5physx12PxRigidActorEPPNS_7PxShapeEj,__Z27getPxRigidActor_ConstraintsPKN5physx12PxRigidActorEPPNS_12PxConstraintEj,__Z30getPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkEPPS0_j,__Z23getPxArticulation_LinksPKN5physx14PxArticulationEPPNS_18PxArticulationLinkEj,__Z21getPxAggregate_ActorsPKN5physx11PxAggregateEPPNS_7PxActorEj,__Z23getPxClothFabric_PhasesPKN5physx13PxClothFabricEPNS_18PxClothFabricPhaseEj,__Z21getPxClothFabric_SetsPKN5physx13PxClothFabricEPjj,__Z32getPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricEPjj,__Z27getPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj,__ZN12_GLOBAL__N_122createArticulationLinkERN5physx14NpArticulationEPNS0_18NpArticulationLinkERKNS0_11PxTransformE,__ZN5physx10PxsContext24removeParticleSystemImplEPNS_20PxvParticleSystemSimEb,__Z27getPxPhysics_TriangleMeshesPKN5physx9PxPhysicsEPPNS_14PxTriangleMeshEj,__Z25getPxPhysics_HeightFieldsPKN5physx9PxPhysicsEPPNS_13PxHeightFieldEj,__Z25getPxPhysics_ConvexMeshesPKN5physx9PxPhysicsEPPNS_12PxConvexMeshEj,__Z25getPxPhysics_ClothFabricsPKN5physx9PxPhysicsEPPNS_13PxClothFabricEj,__Z19getPxPhysics_ScenesPKN5physx9PxPhysicsEPPNS_7PxSceneEj,__Z19getPxPhysics_ShapesPKN5physx9PxPhysicsEPPNS_7PxShapeEj,__Z22getPxPhysics_MaterialsPKN5physx9PxPhysicsEPPNS_10PxMaterialEj,__Z24getPxScene_ArticulationsPKN5physx7PxSceneEPPNS_14PxArticulationEj,__Z22getPxScene_ConstraintsPKN5physx7PxSceneEPPNS_12PxConstraintEj,__Z21getPxScene_AggregatesPKN5physx7PxSceneEPPNS_11PxAggregateEj
,__Z28getPxScene_BroadPhaseRegionsPKN5physx7PxSceneEPNS_22PxBroadPhaseRegionInfoEj,__Z17GetNbTriggerPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_,__Z13GetNbCCDPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_,__Z25GetNbModifiedContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_,__Z25GetNbDiscreteContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_,__Z27GetPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj,__Z41NavMeshAgent_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK8Vector3fP10NavMeshHit,__Z55NavMeshAgent_CUSTOM_INTERNAL_CALL_CalculatePathInternalP12Il2CppObjectRK8Vector3fS0_,__Z44NavMesh_CUSTOM_INTERNAL_CALL_FindClosestEdgeRK8Vector3fP10NavMeshHiti,__ZN9AudioClip21ScriptPCMReadCallbackEP10FMOD_SOUNDPvj,__ZN9AudioClip7WWWSeekEPvjS0_,__ZN9AudioClip12moviepcmreadEP10FMOD_SOUNDPvj,__Z14FMOD_FILE_SeekPvjS_,__Z24AudioClip_CUSTOM_GetDataP12Il2CppObjectP11Il2CppArrayi,__Z24AudioClip_CUSTOM_SetDataP12Il2CppObjectP11Il2CppArrayi,__Z38AudioSource_CUSTOM_GetSpatializerFloatP12Il2CppObjectiPf,__Z26AudioMixer_CUSTOM_GetFloatP12Il2CppObjectP12Il2CppStringPf,__Z21Animation_CUSTOM_PlayP12Il2CppObjectP12Il2CppStringi,__Z24Animator_CUSTOM_HasStateP12Il2CppObjectii,__Z56AnimatorOverrideController_CUSTOM_Internal_GetClipByNameP12Il2CppObjectP12Il2CppStringh,__Z50AnimatorOverrideController_CUSTOM_Internal_GetClipP12Il2CppObjectS0_h,_ft_raster1_set_mode,_ft_smooth_set_mode,_gray_raster_set_mode,_gray_conic_to,_tt_cmap14_char_var_isdefault,_tt_cmap14_char_variants,_tt_cmap14_variant_chars,_UNITY_tt_face_load_hhea,_UNITY_tt_face_get_ps_name
,_UNITY_tt_face_get_kerning,_UNITY_tt_face_load_hmtx,_UNITY_tt_face_set_sbit_strike,_UNITY_tt_face_load_strike_metrics,_UNITY_tt_face_get_name,_ft_black_set_mode,_psh_globals_new,_cff_get_cid_from_glyph_index,_Round_None,_Round_To_Grid,_Round_Up_To_Grid,_Round_Down_To_Grid,_Round_To_Half_Grid,_Round_To_Double_Grid,_Round_Super,_Round_Super_45,_Project_x,_Project_y,_Project,_Dual_Project,_UNITY_TT_Set_MM_Blend,_UNITY_TT_Set_Var_Design,_UNITY_tt_face_get_location,_cff_property_set,_cff_property_get,_tt_property_set,_tt_property_get,__Z70RectTransformUtility_CUSTOM_INTERNAL_CALL_RectangleContainsScreenPointP12Il2CppObjectRK13Vector2fIcallS0_,__Z33GUI_CUSTOM_INTERNAL_CALL_DoButtonRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr,__Z58GUIUtility_CUSTOM_INTERNAL_CALL_Internal_GetNextControlID2i9FocusTypeRK5RectTIfE
,__Z32CustomEventData_CUSTOM_AddStringP12Il2CppObjectP12Il2CppStringS2_,__Z30CustomEventData_CUSTOM_AddBoolP12Il2CppObjectP12Il2CppStringh,__Z30CustomEventData_CUSTOM_AddCharP12Il2CppObjectP12Il2CppStringt,__Z30CustomEventData_CUSTOM_AddByteP12Il2CppObjectP12Il2CppStringh,__Z31CustomEventData_CUSTOM_AddSByteP12Il2CppObjectP12Il2CppStringa,__Z31CustomEventData_CUSTOM_AddInt16P12Il2CppObjectP12Il2CppStrings,__Z32CustomEventData_CUSTOM_AddUInt16P12Il2CppObjectP12Il2CppStringt,__Z31CustomEventData_CUSTOM_AddInt32P12Il2CppObjectP12Il2CppStringi,__Z32CustomEventData_CUSTOM_AddUInt32P12Il2CppObjectP12Il2CppStringj,_do_read,_wrap_write,_mread,_mwrite,_mseek,_ms_write,_ms_seek,_wms_write,_wms_seek,_sw_write,_wstring_read,_do_read_526,_do_read_529,_pthread_cond_timedwait__wrapper,_newlocale,_vasprintf,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_,_wcrtomb,_mbtowc,_mbrlen
,___strcoll_l,___wcscoll_l,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc,__ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj,__ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_,__ZNSt3__211char_traitsIwE4findEPKwjRS2_,__ZNSt3__211char_traitsIwE7compareEPKwS3_j,_wcstoul,_wcstoll,_wcstoull,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj,__ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc,__ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_,__ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_,__ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_,__ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_,__ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_,__ZN10__cxxabiv112_GLOBAL__N_118parse_template_argINS0_2DbEEEPKcS4_S4_RT_,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127,b127
,b127,b127,b127,b127,b127];
var FUNCTION_TABLE_viifff = [b128,__ZN9GfxDevice17ImmediateTexCoordEifff,__ZN13GfxDeviceNull17ImmediateTexCoordEifff,__Z34Animator_CUSTOM_SetFloatStringDampP12Il2CppObjectP12Il2CppStringfff,__Z30Animator_CUSTOM_SetFloatIDDampP12Il2CppObjectifff,b128,b128,b128];
var FUNCTION_TABLE_iifiififf = [b129,__Z49Physics2D_CUSTOM_INTERNAL_CALL_CircleCastNonAllocRK13Vector2fIcallfS1_P11Il2CppArrayfiff];
var FUNCTION_TABLE_viiffi = [b130,__ZN5physx2Cm29ConstraintImmediateVisualizer21visualizeAngularLimitERKNS_11PxTransformEffb,__ZN5physx2Cm29ConstraintImmediateVisualizer18visualizeLimitConeERKNS_11PxTransformEffb,__ZN12_GLOBAL__N_112UserRenderer21visualizeAngularLimitERKN5physx11PxTransformEffb,__ZN12_GLOBAL__N_112UserRenderer18visualizeLimitConeERKN5physx11PxTransformEffb,__Z42Vector3_CUSTOM_INTERNAL_CALL_RotateTowardsRK8Vector3fS1_ffRS_,b130,b130];
var FUNCTION_TABLE_iiid = [b131,__Z32CustomEventData_CUSTOM_AddDoubleP12Il2CppObjectP12Il2CppStringd];
var FUNCTION_TABLE_iiif = [b132,__ZN5physx7NpScene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf,__ZN10AudioMixer8SetFloatEPKcf,__ZL50UnityAudioEffect_InternalSetFloatParameterCallbackP14FMOD_DSP_STATEif,__Z37AudioMixerDuckingSetParameterCallbackP21UnityAudioEffectStateif,__Z38AudioSource_CUSTOM_SetSpatializerFloatP12Il2CppObjectif,__Z26AudioMixer_CUSTOM_SetFloatP12Il2CppObjectP12Il2CppStringf,__Z59GUIStyle_CUSTOM_Internal_GetNumCharactersThatFitWithinWidth13Il2Cpp_IntPtrP12Il2CppStringf];
var FUNCTION_TABLE_viiiffi = [b133,__Z48Physics2D_CUSTOM_INTERNAL_CALL_Internal_LinecastRK13Vector2fIcallS1_iffP12RaycastHit2D];
var FUNCTION_TABLE_vffffffi = [b134,__Z36Matrix4x4_CUSTOM_INTERNAL_CALL_OrthoffffffR10Matrix4x4f];
var FUNCTION_TABLE_viiifi = [b135,__ZN13GfxDeviceGLES5ClearEjRK10ColorRGBAffj,__ZN13GfxDeviceNull5ClearEjRK10ColorRGBAffj,__ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeLinearLimitERKNS_11PxTransformES4_fb,__ZNK5physx14NpSpatialIndex7raycastERKNS_6PxVec3ES3_fRNS_25PxSpatialLocationCallbackE,__ZNK5physx14NpSpatialIndex5sweepERKNS_9PxBounds3ERKNS_6PxVec3EfRNS_25PxSpatialLocationCallbackE,__ZN12_GLOBAL__N_112UserRenderer20visualizeLinearLimitERKN5physx11PxTransformES4_fb,__Z35Debug_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_RK10ColorRGBAffh];
var FUNCTION_TABLE_iiiifiii = [b136,__Z34Sprite_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObjectRK5RectTIfERK13Vector2fIcallfj14SpriteMeshTypeRK8Vector4f];
var FUNCTION_TABLE_ff = [b137,__ZL19stbir__support_zerof,__ZL24stbir__support_trapezoidf,__ZL18stbir__support_onef,__ZL18stbir__support_twof,__Z31Mathf_CUSTOM_GammaToLinearSpacef,__Z31Mathf_CUSTOM_LinearToGammaSpacef,b137];
var FUNCTION_TABLE_iiiifiiiii = [b138,__ZNK5physx14NpSceneQueries7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheE];
var FUNCTION_TABLE_iiiifiififf = [b139,__Z50Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_P11Il2CppArrayfiff];
var FUNCTION_TABLE_viififfi = [b140,__Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_RaycastRK13Vector2fIcallS1_fiffP12RaycastHit2D];
var FUNCTION_TABLE_viffffffffffffiiii = [b141,__Z23VehicleComputeTireForcePKvffffffffffffRfS1_S1_S1_,__ZN5physx32PxVehicleComputeTireForceDefaultEPKvffffffffffffRfS2_S2_S2_,b141];
var FUNCTION_TABLE_vfi = [b142,_emscripten_glSampleCoverage__wrapper];
var FUNCTION_TABLE_iififf = [b143,__Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleRK13Vector2fIcallfiff,__Z47Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleAllRK13Vector2fIcallfiff,b143];
var FUNCTION_TABLE_i = [b144,__ZL15GetRendererImplv,__Z41Application_Get_Custom_PropIsLoadingLevelv,__Z40Application_Get_Custom_PropStreamedBytesv,__Z36Application_Get_Custom_PropIsPlayingv,__Z35Application_Get_Custom_PropIsEditorv,__Z38Application_Get_Custom_PropIsWebPlayerv,__Z35Application_Get_Custom_PropPlatformv,__Z42Application_Get_Custom_PropRunInBackgroundv,__Z32Application_CUSTOM_HasProLicensev,__Z37Application_CUSTOM_HasAdvancedLicensev,__Z38Application_Get_Custom_PropIsBatchmodev,__Z36Application_Get_Custom_PropIsTestRunv,__Z47Application_Get_Custom_PropIsHumanControllingUsv,__Z35Application_Get_Custom_PropDataPathv,__Z46Application_Get_Custom_PropStreamingAssetsPathv,__Z45Application_Get_Custom_PropPersistentDataPathv,__Z45Application_Get_Custom_PropTemporaryCachePathv,__Z35Application_Get_Custom_PropSrcValuev,__Z38Application_Get_Custom_PropAbsoluteURLv,__Z39Application_Get_Custom_PropUnityVersionv,__Z34Application_Get_Custom_PropVersionv,__Z40Application_Get_Custom_PropInstallerNamev,__Z43Application_Get_Custom_PropBundleIdentifierv,__Z38Application_Get_Custom_PropInstallModev,__Z38Application_Get_Custom_PropSandboxTypev,__Z38Application_Get_Custom_PropProductNamev,__Z38Application_Get_Custom_PropCompanyNamev,__Z41Application_Get_Custom_PropCloudProjectIdv
,__Z45Application_Get_Custom_PropWebSecurityEnabledv,__Z45Application_Get_Custom_PropWebSecurityHostUrlv,__Z42Application_Get_Custom_PropTargetFrameRatev,__Z41Application_Get_Custom_PropSystemLanguagev,__Z44Application_Get_Custom_PropStackTraceLogTypev,__Z52Application_Get_Custom_PropBackgroundLoadingPriorityv,__Z47Application_Get_Custom_PropInternetReachabilityv,__Z34Application_Get_Custom_PropGenuinev,__Z48Application_Get_Custom_PropGenuineCheckAvailablev,__Z59Application_CUSTOM_GetUserAuthorizationRequestMode_Internalv,__Z42Application_Get_Custom_PropSubmitAnalyticsv,__Z48Application_Get_Custom_PropIsShowingSplashScreenv,__Z41SystemInfo_Get_Custom_PropOperatingSystemv,__Z47SystemInfo_Get_Custom_PropOperatingSystemFamilyv,__Z39SystemInfo_Get_Custom_PropProcessorTypev,__Z44SystemInfo_Get_Custom_PropProcessorFrequencyv,__Z40SystemInfo_Get_Custom_PropProcessorCountv,__Z42SystemInfo_Get_Custom_PropSystemMemorySizev,__Z44SystemInfo_Get_Custom_PropGraphicsMemorySizev,__Z44SystemInfo_Get_Custom_PropGraphicsDeviceNamev,__Z46SystemInfo_Get_Custom_PropGraphicsDeviceVendorv,__Z42SystemInfo_Get_Custom_PropGraphicsDeviceIDv,__Z48SystemInfo_Get_Custom_PropGraphicsDeviceVendorIDv,__Z44SystemInfo_Get_Custom_PropGraphicsDeviceTypev,__Z49SystemInfo_Get_Custom_PropUsesOpenGLTextureCoordsv,__Z47SystemInfo_Get_Custom_PropGraphicsDeviceVersionv,__Z45SystemInfo_Get_Custom_PropGraphicsShaderLevelv,__Z47SystemInfo_Get_Custom_PropGraphicsMultiThreadedv,__Z41SystemInfo_Get_Custom_PropSupportsShadowsv,__Z56SystemInfo_Get_Custom_PropSupportsRawShadowDepthSamplingv
,__Z48SystemInfo_Get_Custom_PropSupportsRenderTexturesv,__Z47SystemInfo_Get_Custom_PropSupportsMotionVectorsv,__Z49SystemInfo_Get_Custom_PropSupportsRenderToCubemapv,__Z46SystemInfo_Get_Custom_PropSupportsImageEffectsv,__Z44SystemInfo_Get_Custom_PropSupports3DTexturesv,__Z49SystemInfo_Get_Custom_PropSupports2DArrayTexturesv,__Z54SystemInfo_Get_Custom_PropSupportsCubemapArrayTexturesv,__Z44SystemInfo_Get_Custom_PropCopyTextureSupportv,__Z48SystemInfo_Get_Custom_PropSupportsComputeShadersv,__Z44SystemInfo_Get_Custom_PropSupportsInstancingv,__Z48SystemInfo_Get_Custom_PropSupportsSparseTexturesv,__Z52SystemInfo_Get_Custom_PropSupportedRenderTargetCountv,__Z45SystemInfo_Get_Custom_PropUsesReversedZBufferv,__Z41SystemInfo_Get_Custom_PropSupportsStencilv,__Z37SystemInfo_Get_Custom_PropNpotSupportv,__Z48SystemInfo_Get_Custom_PropDeviceUniqueIdentifierv,__Z36SystemInfo_Get_Custom_PropDeviceNamev,__Z37SystemInfo_Get_Custom_PropDeviceModelv,__Z47SystemInfo_Get_Custom_PropSupportsAccelerometerv,__Z43SystemInfo_Get_Custom_PropSupportsGyroscopev,__Z49SystemInfo_Get_Custom_PropSupportsLocationServicev,__Z43SystemInfo_Get_Custom_PropSupportsVibrationv,__Z39SystemInfo_Get_Custom_PropSupportsAudiov,__Z36SystemInfo_Get_Custom_PropDeviceTypev,__Z40SystemInfo_Get_Custom_PropMaxTextureSizev,__Z46SystemInfo_Get_Custom_PropMaxRenderTextureSizev,__Z25Caching_CUSTOM_CleanCachev,__Z28Caching_Get_Custom_PropIndexv,__Z32Caching_Get_Custom_PropSpaceFreev,__Z48Caching_Get_Custom_PropMaximumAvailableDiskSpacev
,__Z36Caching_Get_Custom_PropSpaceOccupiedv,__Z37Caching_Get_Custom_PropSpaceAvailablev,__Z32Caching_Get_Custom_PropSpaceUsedv,__Z38Caching_Get_Custom_PropExpirationDelayv,__Z30Caching_Get_Custom_PropEnabledv,__Z41Caching_Get_Custom_PropCompressionEnabledv,__Z28Caching_Get_Custom_PropReadyv,__Z41Camera_Get_Custom_PropPreviewCullingLayerv,__Z26Camera_Get_Custom_PropMainv,__Z29Camera_Get_Custom_PropCurrentv,__Z32Camera_Get_Custom_PropAllCamerasv,__Z37Camera_Get_Custom_PropAllCamerasCountv,__Z29CrashReport_CUSTOM_GetReportsv,__Z29Cursor_Get_Custom_PropVisiblev,__Z31Cursor_Get_Custom_PropLockStatev,__Z44Debug_Get_Custom_PropDeveloperConsoleVisiblev,__Z33Debug_Get_Custom_PropIsDebugBuildv,__Z40DynamicGI_Get_Custom_PropSynchronousModev,__Z45GIDebugVisualisation_Get_Custom_PropCycleModev,__Z50GIDebugVisualisation_Get_Custom_PropPauseCycleModev,__Z43GIDebugVisualisation_Get_Custom_PropTexTypev,__Z33RenderSettings_Get_Custom_PropFogv,__Z37RenderSettings_Get_Custom_PropFogModev,__Z41RenderSettings_Get_Custom_PropAmbientModev,__Z47RenderSettings_Get_Custom_PropReflectionBouncesv,__Z36RenderSettings_Get_Custom_PropSkyboxv,__Z33RenderSettings_Get_Custom_PropSunv,__Z51RenderSettings_Get_Custom_PropDefaultReflectionModev,__Z57RenderSettings_Get_Custom_PropDefaultReflectionResolutionv,__Z46RenderSettings_Get_Custom_PropCustomReflectionv
,__Z39RenderSettings_CUSTOM_GetRenderSettingsv,__Z36QualitySettings_Get_Custom_PropNamesv,__Z38QualitySettings_CUSTOM_GetQualityLevelv,__Z43QualitySettings_Get_Custom_PropCurrentLevelv,__Z46QualitySettings_Get_Custom_PropPixelLightCountv,__Z38QualitySettings_Get_Custom_PropShadowsv,__Z47QualitySettings_Get_Custom_PropShadowProjectionv,__Z45QualitySettings_Get_Custom_PropShadowCascadesv,__Z47QualitySettings_Get_Custom_PropShadowResolutionv,__Z49QualitySettings_Get_Custom_PropMasterTextureLimitv,__Z51QualitySettings_Get_Custom_PropAnisotropicFilteringv,__Z46QualitySettings_Get_Custom_PropMaximumLODLevelv,__Z52QualitySettings_Get_Custom_PropParticleRaycastBudgetv,__Z44QualitySettings_Get_Custom_PropSoftParticlesv,__Z45QualitySettings_Get_Custom_PropSoftVegetationv,__Z55QualitySettings_Get_Custom_PropRealtimeReflectionProbesv,__Z59QualitySettings_Get_Custom_PropBillboardsFaceCameraPositionv,__Z46QualitySettings_Get_Custom_PropMaxQueuedFramesv,__Z41QualitySettings_Get_Custom_PropVSyncCountv,__Z43QualitySettings_Get_Custom_PropAntiAliasingv,__Z48QualitySettings_Get_Custom_PropDesiredColorSpacev,__Z47QualitySettings_Get_Custom_PropActiveColorSpacev,__Z43QualitySettings_Get_Custom_PropBlendWeightsv,__Z51QualitySettings_Get_Custom_PropAsyncUploadTimeSlicev,__Z52QualitySettings_Get_Custom_PropAsyncUploadBufferSizev,__Z52Graphics_CUSTOM_Internal_GetMaxDrawMeshInstanceCountv,__Z34Graphics_Get_Custom_PropActiveTierv,__Z41LightmapSettings_Get_Custom_PropLightmapsv,__Z51LightmapSettings_Get_Custom_PropLightmapsModeLegacyv,__Z45LightmapSettings_Get_Custom_PropLightmapsModev
,__Z43LightmapSettings_Get_Custom_PropLightProbesv,__Z33Screen_Get_Custom_PropResolutionsv,__Z27Screen_Get_Custom_PropWidthv,__Z28Screen_Get_Custom_PropHeightv,__Z32Screen_Get_Custom_PropFullScreenv,__Z42Screen_Get_Custom_PropAutorotateToPortraitv,__Z52Screen_Get_Custom_PropAutorotateToPortraitUpsideDownv,__Z47Screen_Get_Custom_PropAutorotateToLandscapeLeftv,__Z48Screen_Get_Custom_PropAutorotateToLandscapeRightv,__Z33Screen_Get_Custom_PropOrientationv,__Z34Screen_Get_Custom_PropSleepTimeoutv,__Z27GL_Get_Custom_PropWireframev,__Z27GL_Get_Custom_PropSRGBWritev,__Z31GL_Get_Custom_PropInvertCullingv,__Z35Input_CUSTOM_mainGyroIndex_Internalv,__Z38Input_Get_Custom_PropCompensateSensorsv,__Z36Input_Get_Custom_PropIsGyroAvailablev,__Z29Input_CUSTOM_GetJoystickNamesv,__Z33Input_Get_Custom_PropMousePresentv,__Z45Input_Get_Custom_PropSimulateMouseWithTouchesv,__Z27Input_Get_Custom_PropAnyKeyv,__Z31Input_Get_Custom_PropAnyKeyDownv,__Z32Input_Get_Custom_PropInputStringv,__Z43Input_Get_Custom_PropAccelerationEventCountv,__Z31Input_Get_Custom_PropTouchCountv,__Z48Input_Get_Custom_PropEatKeyPressOnTextFieldFocusv,__Z43Input_Get_Custom_PropTouchPressureSupportedv,__Z41Input_Get_Custom_PropStylusTouchSupportedv,__Z35Input_Get_Custom_PropTouchSupportedv,__Z38Input_Get_Custom_PropMultiTouchEnabledv
,__Z38Input_Get_Custom_PropDeviceOrientationv,__Z39Input_Get_Custom_PropImeCompositionModev,__Z38Input_Get_Custom_PropCompositionStringv,__Z34Input_Get_Custom_PropImeIsSelectedv,__Z40Input_Get_Custom_PropBackButtonLeavesAppv,__Z36Light_Get_Custom_PropPixelLightCountv,__Z55LightProbeProxyVolume_Get_Custom_PropIsFeatureSupportedv,__Z41PlayerConnection_Get_Custom_PropConnectedv,__Z33Profiler_Get_Custom_PropSupportedv,__Z31Profiler_Get_Custom_PropLogFilev,__Z39Profiler_Get_Custom_PropEnableBinaryLogv,__Z31Profiler_Get_Custom_PropEnabledv,__Z50Profiler_Get_Custom_PropMaxNumberOfSamplesPerFramev,__Z36Profiler_Get_Custom_PropUsedHeapSizev,__Z31Profiler_CUSTOM_GetMonoHeapSizev,__Z31Profiler_CUSTOM_GetMonoUsedSizev,__Z36Profiler_CUSTOM_GetTempAllocatorSizev,__Z39Profiler_CUSTOM_GetTotalAllocatedMemoryv,__Z44Profiler_CUSTOM_GetTotalUnusedReservedMemoryv,__Z38Profiler_CUSTOM_GetTotalReservedMemoryv,__Z31Profiler_CUSTOM_GetSamplerNamesv,__Z26Random_Get_Custom_PropSeedv,__Z56DrivenRectTransformTracker_CUSTOM_CanRecordModificationsv,__Z56ReflectionProbe_Get_Custom_PropMinBakedCubemapResolutionv,__Z56ReflectionProbe_Get_Custom_PropMaxBakedCubemapResolutionv,__Z43GraphicsSettings_CUSTOM_GetGraphicsSettingsv,__Z35Resources_CUSTOM_UnloadUnusedAssetsv,__Z38SceneManager_Get_Custom_PropSceneCountv,__Z53SceneManager_Get_Custom_PropSceneCountInBuildSettingsv,__Z38Shader_Get_Custom_PropGlobalMaximumLODv
,__Z46SortingLayer_CUSTOM_GetSortingLayerIDsInternalv,__Z38SplashScreen_Get_Custom_PropIsFinishedv,__Z41Texture_Get_Custom_PropMasterTextureLimitv,__Z43Texture_Get_Custom_PropAnisotropicFilteringv,__Z37Texture2D_Get_Custom_PropWhiteTexturev,__Z37Texture2D_Get_Custom_PropBlackTexturev,__Z35RenderTexture_Get_Custom_PropActivev,__Z36RenderTexture_Get_Custom_PropEnabledv,__Z30Time_Get_Custom_PropFrameCountv,__Z38Time_Get_Custom_PropRenderedFrameCountv,__Z36Time_Get_Custom_PropCaptureFrameratev,__Z52Object_CUSTOM_GetOffsetOfInstanceIDInCPlusPlusObjectv,__Z37AndroidJNIHelper_Get_Custom_PropDebugv,__Z37AndroidJNI_CUSTOM_AttachCurrentThreadv,__Z37AndroidJNI_CUSTOM_DetachCurrentThreadv,__Z28AndroidJNI_CUSTOM_GetVersionv,__Z49WebGLInput_Get_Custom_PropCaptureAllKeyboardInputv,_glCreateProgram__wrapper,_glGetError__wrapper,__ZN12_GLOBAL__N_118createArticulationEv,__Z46Physics_Get_Custom_PropDefaultSolverIterationsv,__Z54Physics_Get_Custom_PropDefaultSolverVelocityIterationsv,__Z41Physics_Get_Custom_PropQueriesHitTriggersv,__Z42Physics_Get_Custom_PropQueriesHitBackfacesv,__Z43Physics2D_Get_Custom_PropVelocityIterationsv,__Z43Physics2D_Get_Custom_PropPositionIterationsv,__Z43Physics2D_Get_Custom_PropQueriesHitTriggersv,__Z48Physics2D_Get_Custom_PropQueriesStartInCollidersv,__Z45Physics2D_Get_Custom_PropChangeStopsCallbacksv,__Z44Physics2D_Get_Custom_PropAlwaysShowCollidersv
,__Z42Physics2D_Get_Custom_PropShowColliderSleepv,__Z45Physics2D_Get_Custom_PropShowColliderContactsv,__Z41Physics2D_Get_Custom_PropShowColliderAABBv,__Z34NavMesh_CUSTOM_TriangulateInternalv,__Z47NavMesh_CUSTOM_GetPathfindingIterationsPerFramev,__Z47AudioSettings_Get_Custom_PropDriverCapabilitiesv,__Z40AudioSettings_Get_Custom_PropSpeakerModev,__Z49AudioSettings_Get_Custom_PropProfilerCaptureFlagsv,__Z45AudioSettings_Get_Custom_PropOutputSampleRatev,__Z47AudioSettings_Get_Custom_PropUnityAudioDisabledv,__Z35AudioClip_CUSTOM_Construct_Internalv,__Z34AudioListener_Get_Custom_PropPausev,__Z36WebCamTexture_Get_Custom_PropDevicesv,__Z37HumanTrait_Get_Custom_PropMuscleCountv,__Z36HumanTrait_Get_Custom_PropMuscleNamev,__Z35HumanTrait_Get_Custom_PropBoneCountv,__Z34HumanTrait_Get_Custom_PropBoneNamev,__Z43HumanTrait_Get_Custom_PropRequiredBoneCountv,__Z48TerrainData_CUSTOM_Internal_GetMaximumResolutionv,__Z62TerrainData_CUSTOM_Internal_GetMinimumDetailResolutionPerPatchv,__Z62TerrainData_CUSTOM_Internal_GetMaximumDetailResolutionPerPatchv,__Z54TerrainData_CUSTOM_Internal_GetMaximumDetailPatchCountv,__Z56TerrainData_CUSTOM_Internal_GetMinimumAlphamapResolutionv,__Z56TerrainData_CUSTOM_Internal_GetMaximumAlphamapResolutionv,__Z55TerrainData_CUSTOM_Internal_GetMinimumBaseMapResolutionv,__Z55TerrainData_CUSTOM_Internal_GetMaximumBaseMapResolutionv,__Z36Terrain_Get_Custom_PropActiveTerrainv,__Z37Terrain_Get_Custom_PropActiveTerrainsv,__Z35Font_CUSTOM_GetOSInstalledFontNamesv,__Z38Canvas_CUSTOM_GetDefaultCanvasMaterialv
,__Z44Canvas_CUSTOM_GetETC1SupportedCanvasMaterialv,__Z42Canvas_CUSTOM_GetDefaultCanvasTextMaterialv,__Z26Event_CUSTOM_GetEventCountv,__Z26GUI_Get_Custom_PropChangedv,__Z26GUI_Get_Custom_PropEnabledv,__Z30GUI_CUSTOM_Internal_GetTooltipv,__Z35GUI_CUSTOM_Internal_GetMouseTooltipv,__Z24GUI_Get_Custom_PropDepthv,__Z32GUI_Get_Custom_PropBlendMaterialv,__Z31GUI_Get_Custom_PropBlitMaterialv,__Z34GUI_CUSTOM_GetNameOfFocusedControlv,__Z36GUI_Get_Custom_PropUsePageScrollbarsv,__Z39GUIUtility_CUSTOM_GetPermanentControlIDv,__Z40GUIUtility_CUSTOM_Internal_GetHotControlv,__Z28GUIUtility_CUSTOM_GetChangedv,__Z41GUIUtility_Get_Custom_PropKeyboardControlv,__Z42GUIUtility_Get_Custom_PropSystemCopyBufferv,__Z38GUIUtility_CUSTOM_Internal_GetGUIDepthv,__Z35GUIUtility_Get_Custom_PropMouseUsedv,__Z40GUIUtility_Get_Custom_PropHasModalWindowv,__Z40GUIUtility_Get_Custom_PropTextFieldInputv,__Z30GUIClip_Get_Custom_PropEnabledv,__Z57CrashReportHandler_Get_Custom_PropEnableCaptureExceptionsv,__Z39UnityAdsSettings_Get_Custom_PropEnabledv,__Z51UnityAdsSettings_Get_Custom_PropInitializeOnStartupv,__Z40UnityAdsSettings_Get_Custom_PropTestModev,__Z43UnityConnectSettings_Get_Custom_PropEnabledv,__Z44UnityConnectSettings_Get_Custom_PropTestModev,__Z48UnityConnectSettings_Get_Custom_PropTestEventUrlv,__Z49UnityConnectSettings_Get_Custom_PropTestConfigUrlv
,__Z33VRSettings_Get_Custom_PropEnabledv,__Z40VRSettings_Get_Custom_PropIsDeviceActivev,__Z40VRSettings_Get_Custom_PropShowDeviceViewv,__Z41VRSettings_Get_Custom_PropEyeTextureWidthv,__Z42VRSettings_Get_Custom_PropEyeTextureHeightv,__Z42VRSettings_Get_Custom_PropLoadedDeviceNamev,__Z42VRSettings_Get_Custom_PropSupportedDevicesv,__Z33VRDevice_Get_Custom_PropIsPresentv,__Z30VRDevice_Get_Custom_PropFamilyv,__Z29VRDevice_Get_Custom_PropModelv,__ZL31StereoDisplayGetDeviceConnectedv,__ZL23DebugGetDeviceConnectedv,_emscripten_glCreateProgram__wrapper,_emscripten_glGetError__wrapper,__ZNSt3__219__thread_local_dataEv,__ZNSt3__26__clocEv,___ctype_tolower_loc,___ctype_toupper_loc,___ctype_b_loc,_localeconv,__ZNSt3__26locale7classicEv,__ZNSt3__26locale5__imp12make_classicEv,__ZNSt3__26locale5__imp11make_globalEv,__ZNSt3__26locale8__globalEv,_sched_yield__wrapper,___cxa_get_globals_fast,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144,b144
,b144,b144,b144];
var FUNCTION_TABLE_vff = [b145,__Z19GL_CUSTOM_TexCoord2ff,_glPolygonOffset__wrapper,_emscripten_glDepthRangef__wrapper,_emscripten_glPolygonOffset__wrapper,b145,b145,b145];
var FUNCTION_TABLE_iiififf = [b146,__Z41Physics2D_CUSTOM_INTERNAL_CALL_RaycastAllRK13Vector2fIcallS1_fiff,__Z41Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxRK13Vector2fIcallS1_fiff,__Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxAllRK13Vector2fIcallS1_fiff];
var FUNCTION_TABLE_vifffff = [b147,__Z39Animator_CUSTOM_SetLookAtWeightInternalP12Il2CppObjectfffff];
var FUNCTION_TABLE_iiiiiiiii = [b148,__ZN20LocalFileSystemPosix4ReadER13FileEntryDatayyPvPy,__ZN20LocalFileSystemPosix5WriteER13FileEntryDatayyPvPy,__ZN9GfxDevice24CreateRenderDepthSurfaceE9TextureIDiii16TextureDimension17DepthBufferFormatj,__ZN7Cubemap11InitTextureEii13TextureFormatN9Texture2D10EInitFlagsEiii,__ZN9Texture2D11InitTextureEii13TextureFormatNS_10EInitFlagsEiii,__ZN17ArchiveFileSystem4ReadER13FileEntryDatayyPvPy,__ZN17ArchiveFileSystem5WriteER13FileEntryDatayyPvPy,__ZN12IFileAdapter4ReadER13FileEntryDatayyPvPy,__ZN12IFileAdapter5WriteER13FileEntryDatayyPvPy,__ZN12HandlerChain4ReadER13FileEntryDatayyPvPy,__ZN12HandlerChain5WriteER13FileEntryDatayyPvPy,__ZN16MemoryFileSystem4ReadER13FileEntryDatayyPvPy,__ZN16MemoryFileSystem5WriteER13FileEntryDatayyPvPy,__ZN21AssetBundleFileSystem4ReadER13FileEntryDatayyPvPy,__ZN21AssetBundleFileSystem5WriteER13FileEntryDatayyPvPy,__ZN13GfxDeviceGLES13ReadbackImageER14ImageReferenceiiiiii,__ZN13GfxDeviceNull13ReadbackImageER14ImageReferenceiiiiii,__ZN5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_,__ZThn4_N5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_,__ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc,__ZNKSt3__27codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_,__ZNKSt3__27codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_,__ZNKSt3__27codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__27codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_,__ZNKSt3__27codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_,__ZNKSt3__27codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_,__ZNKSt3__27codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_
,__ZNKSt3__27codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_,__ZNKSt3__214__codecvt_utf8IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_,__ZNKSt3__214__codecvt_utf8IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_,__ZNKSt3__214__codecvt_utf8IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_,__ZNKSt3__214__codecvt_utf8IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_,__ZNKSt3__214__codecvt_utf8IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_,__ZNKSt3__214__codecvt_utf8IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_,__ZNKSt3__215__codecvt_utf16IwLb0EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IwLb0EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_,__ZNKSt3__215__codecvt_utf16IwLb1EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IwLb1EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_,__ZNKSt3__215__codecvt_utf16IDsLb0EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IDsLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_,__ZNKSt3__215__codecvt_utf16IDsLb1EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IDsLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_,__ZNKSt3__215__codecvt_utf16IDiLb0EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IDiLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_,__ZNKSt3__215__codecvt_utf16IDiLb1EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_,__ZNKSt3__215__codecvt_utf16IDiLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_,__ZNKSt3__220__codecvt_utf8_utf16IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_,b148,b148,b148,b148,b148
,b148,b148,b148,b148,b148];
var FUNCTION_TABLE_viffffi = [b149,__ZN9GfxDevice14ImmediateShapeEffffNS_18ImmediateShapeTypeE];

  return { __ZN10SizeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10SizeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__212strstreambuf3strEv: __ZNSt3__212strstreambuf3strEv, __ZNK5Umbra20ObjectDistanceParams26getMinRelativeContributionEv: __ZNK5Umbra20ObjectDistanceParams26getMinRelativeContributionEv, _mbrlen: _mbrlen, __ZN12ShaderErrors21AddShaderCompileErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEib: __ZN12ShaderErrors21AddShaderCompileErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEib, __Z40FrictionJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf: __Z40FrictionJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf, __ZN5physx2Sn13XmlNodeWriter10addContentEPKc: __ZN5physx2Sn13XmlNodeWriter10addContentEPKc, __ZNKSt3__215__codecvt_utf16IDsLb1EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IDsLb1EE9do_lengthER11__mbstate_tPKcS5_j, __ZNK5physx3Ext14SphericalJoint22getSphericalJointFlagsEv: __ZNK5physx3Ext14SphericalJoint22getSphericalJointFlagsEv, __ZN15DownloadHandler7OnAbortEv: __ZN15DownloadHandler7OnAbortEv, __ZN9b2Fixture14DestroyProxiesEP12b2BroadPhase: __ZN9b2Fixture14DestroyProxiesEP12b2BroadPhase, _getpid: _getpid, __ZN7mecanim5human11CreateHumanEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEEjjRNS_6memory9AllocatorE: __ZN7mecanim5human11CreateHumanEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEEjjRNS_6memory9AllocatorE, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __Z37Renderer_Set_Custom_PropLightmapIndexP12Il2CppObjecti: __Z37Renderer_Set_Custom_PropLightmapIndexP12Il2CppObjecti, __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb: __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb, __ZN10StateRange8TransferI14SafeBinaryReadEEvRT_: __ZN10StateRange8TransferI14SafeBinaryReadEEvRT_, __ZN13SplatDatabase25RecalculateBasemapIfDirtyEv: __ZN13SplatDatabase25RecalculateBasemapIfDirtyEv, __Z21SourceMipLevelForBlitiiii: __Z21SourceMipLevelForBlitiiii, __ZN31CanvasBatchIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN31CanvasBatchIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physx8debugger4comm17PushBackObjectRefD0Ev: __ZN5physx8debugger4comm17PushBackObjectRefD0Ev, __Z51ParticleSystem_MainModule_CUSTOM_SetStartRotation3DP12Il2CppObjecth: __Z51ParticleSystem_MainModule_CUSTOM_SetStartRotation3DP12Il2CppObjecth, _UNITY_png_set_check_for_invalid_index: _UNITY_png_set_check_for_invalid_index, __ZN18UnityPropertySheetaSERKS_: __ZN18UnityPropertySheetaSERKS_, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj, __ZN11UnityEngine7Connect14AppUpdateEventD0Ev: __ZN11UnityEngine7Connect14AppUpdateEventD0Ev, __ZN4FMOD4DSPI9getBypassEPb: __ZN4FMOD4DSPI9getBypassEPb, __Z40Register_UnityEngine_GUIText_get_tabSizev: __Z40Register_UnityEngine_GUIText_get_tabSizev, __Z31getPxCloth_ExternalAccelerationPKN5physx7PxClothE: __Z31getPxCloth_ExternalAccelerationPKN5physx7PxClothE, __ZNK14ParticleSystem18GetSimulationSpaceEv: __ZNK14ParticleSystem18GetSimulationSpaceEv, __ZNK5physx2Sc5Scene24getContactModifyCallbackEv: __ZNK5physx2Sc5Scene24getContactModifyCallbackEv, __ZN4FMOD7SystemI17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER: __ZN4FMOD7SystemI17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER, __ZN23AnimationOffsetPlayable11SetRotationE11Quaternionf: __ZN23AnimationOffsetPlayable11SetRotationE11Quaternionf, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sq10AABBPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj: __ZN5physx2Sq10AABBPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj, __ZN9Animation6RewindER14AnimationState: __ZN9Animation6RewindER14AnimationState, __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf: __ZN15AnimationBinder13SetFloatValueERK20BoundCurveDeprecatedf, __ZN17GeneralConnection13MulticastInfoC2Ev: __ZN17GeneralConnection13MulticastInfoC2Ev, __ZN12_GLOBAL__N_112PropDescImplD2Ev: __ZN12_GLOBAL__N_112PropDescImplD2Ev, __ZN5physx8debugger14PvdMarshallingIhyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhyE12marshalBlockEPKhPhj, __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_destinationv: __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_destinationv, __ZN11OffMeshLink7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11OffMeshLink7PRODUCEE10MemLabelId18ObjectCreationMode, __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext: __Z18RestoreRenderStateR20CameraRenderOldStateR17ShaderPassContext, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeXMultiplierP12Il2CppObject: __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeXMultiplierP12Il2CppObject, __ZNK5physx20PxsParticleSystemSim24getExternalAccelerationVEv: __ZNK5physx20PxsParticleSystemSim24getExternalAccelerationVEv, __ZN5Umbra18CellGraphTraversal12prefetchNodeERKNS_10PortalNodeE: __ZN5Umbra18CellGraphTraversal12prefetchNodeERKNS_10PortalNodeE, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj, __Z21Object_CUSTOM_DestroyP12Il2CppObjectf: __Z21Object_CUSTOM_DestroyP12Il2CppObjectf, __Z44SystemInfo_Get_Custom_PropGraphicsDeviceNamev: __Z44SystemInfo_Get_Custom_PropGraphicsDeviceNamev, __ZN14VRSplashScreen6UpdateEPFvRK11QuaternionfRK8Vector3fS5_E: __ZN14VRSplashScreen6UpdateEPFvRK11QuaternionfRK8Vector3fS5_E, __ZN6IDList10BeginOnGUIEv: __ZN6IDList10BeginOnGUIEv, __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetRotationv: __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetRotationv, __ZN5physx2Sc14ConstraintCore10breakApartEv: __ZN5physx2Sc14ConstraintCore10breakApartEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_secondaryAxisv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_secondaryAxisv, __ZN6Socket11SetBlockingEib: __ZN6Socket11SetBlockingEib, __Z13RegisterClassI15CapsuleColliderEvv: __Z13RegisterClassI15CapsuleColliderEvv, __Z45LineRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject: __Z45LineRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject, __ZNKSt3__220__time_get_c_storageIcE3__XEv: __ZNKSt3__220__time_get_c_storageIcE3__XEv, __ZN11Rigidbody2D16SetInterpolationENS_13InterpolationE: __ZN11Rigidbody2D16SetInterpolationENS_13InterpolationE, __ZN5physx7Cooking20loadTriangleMeshDescERKNS_18PxTriangleMeshDescERNS_19TriangleMeshBuilderE: __ZN5physx7Cooking20loadTriangleMeshDescERKNS_18PxTriangleMeshDescERNS_19TriangleMeshBuilderE, __Z48getPxArticulationJoint_TwistLimitContactDistancePKN5physx19PxArticulationJointE: __Z48getPxArticulationJoint_TwistLimitContactDistancePKN5physx19PxArticulationJointE, __Z53AnimatorClipInfo_CUSTOM_ClipInstanceToScriptingObjecti: __Z53AnimatorClipInfo_CUSTOM_ClipInstanceToScriptingObjecti, __Z44Register_UnityEngine_AudioListener_set_pausev: __Z44Register_UnityEngine_AudioListener_set_pausev, __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE: __ZN5physx9NpFactory21releaseConnectorArrayEPNS_16NpConnectorArrayE, __ZN4Mesh27InitChannelsToDefaultValuesEjjj: __ZN4Mesh27InitChannelsToDefaultValuesEjjj, __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE6getDirEv, __ZN13RuntimeStaticI18BackgroundJobQueueE13StaticDestroyEPv: __ZN13RuntimeStaticI18BackgroundJobQueueE13StaticDestroyEPv, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEEC2ERNS_19PxAllocatorCallbackE, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEntEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEntEv, __ZN17PersistentManager22CheckInstanceIDsLoadedEPii: __ZN17PersistentManager22CheckInstanceIDsLoadedEPii, __ZNK5physx29PxJointLimitConeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j: __ZNK5physx29PxJointLimitConeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j, __ZN7ApiGLES17CopyBufferSubDataEjjlll: __ZN7ApiGLES17CopyBufferSubDataEjjlll, __ZN11UnityEngine15PlatformWrapper17GetCloudProjectIdEv: __ZN11UnityEngine15PlatformWrapper17GetCloudProjectIdEv, __ZN9DepthPass20AcquireRendererSceneERK19SharedRendererScene: __ZN9DepthPass20AcquireRendererSceneERK19SharedRendererScene, __Z41Register_UnityEngine_Camera_set_eventMaskv: __Z41Register_UnityEngine_Camera_set_eventMaskv, __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_: __ZN5physx21PxcArticulationHelper22getImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_jS6_S7_, _tt_driver_class_pic_free: _tt_driver_class_pic_free, __ZN15TextureTFMethod13DoneRenderingEv: __ZN15TextureTFMethod13DoneRenderingEv, __ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE: __ZN7mecanim5human19MaskHasLeftFootGoalERKNS_6bitsetILj66EEE, __ZN4Mesh18RecalculateNormalsEv: __ZN4Mesh18RecalculateNormalsEv, __ZN4FMOD3DSP16showConfigDialogEPvb: __ZN4FMOD3DSP16showConfigDialogEPvb, __Z48SceneManager_CUSTOM_INTERNAL_CALL_SetActiveSceneRKi: __Z48SceneManager_CUSTOM_INTERNAL_CALL_SetActiveSceneRKi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, _wmemmove: _wmemmove, __ZN5physx3Ext13DistanceJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext13DistanceJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __ZN5physx2Sc14ConstraintCore15getPxConstraintEv: __ZN5physx2Sc14ConstraintCore15getPxConstraintEv, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE22getClientBehaviorFlagsEv, __Z42PointEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf: __Z42PointEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf, __ZNK14Texture2DArray26CanReuploadDataToGfxDeviceEv: __ZNK14Texture2DArray26CanReuploadDataToGfxDeviceEv, __ZN17PrePassRenderLoop14RenderBasePassEP13RenderTextureRK14LightingLayersR13dynamic_arrayI16RenderObjectDataLj4EERbR10MinMaxAABB: __ZN17PrePassRenderLoop14RenderBasePassEP13RenderTextureRK14LightingLayersR13dynamic_arrayI16RenderObjectDataLj4EERbR10MinMaxAABB, __Z45setPxSphericalJoint_ProjectionLinearTolerancePN5physx16PxSphericalJointEf: __Z45setPxSphericalJoint_ProjectionLinearTolerancePN5physx16PxSphericalJointEf, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_, __ZN5physx16PxVehicleDrive4W6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj: __ZN5physx16PxVehicleDrive4W6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj, __ZN17GlobalGameManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17GlobalGameManager23VirtualRedirectTransferER17RemapPPtrTransfer, _sfnt_stream_close: _sfnt_stream_close, __Z46Register_UnityEngine_AudioSource_get_minVolumev: __Z46Register_UnityEngine_AudioSource_get_minVolumev, __ZN5IMGUI18RepaintModalWindowER8GUIState: __ZN5IMGUI18RepaintModalWindowER8GUIState, __Z54Register_UnityEngine_PlatformEffector2D_set_surfaceArcv: __Z54Register_UnityEngine_PlatformEffector2D_set_surfaceArcv, __ZN33AssetBundleLoadFromAsyncOperation19IntegrateMainThreadEv: __ZN33AssetBundleLoadFromAsyncOperation19IntegrateMainThreadEv, __Z57Register_UnityEngine_AudioSettings_get_driverCapabilitiesv: __Z57Register_UnityEngine_AudioSettings_get_driverCapabilitiesv, __ZNKSt3__220__time_get_c_storageIcE3__cEv: __ZNKSt3__220__time_get_c_storageIcE3__cEv, __ZN10Matrix3x3fmLERK10Matrix4x4f: __ZN10Matrix3x3fmLERK10Matrix4x4f, __ZN10OnGUIState10BeginOnGUIEv: __ZN10OnGUIState10BeginOnGUIEv, __ZN20ComputeShaderVariant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20ComputeShaderVariant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN14ParticleSystem12StartModulesERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK27ParticleSystemEmissionStatebRK8Vector3fRK10Matrix4x4fR23ParticleSystemParticlesjffjfjRjb: __ZN14ParticleSystem12StartModulesERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK27ParticleSystemEmissionStatebRK8Vector3fRK10Matrix4x4fR23ParticleSystemParticlesjffjfjRjb, __ZN7Texture13SetFilterModeEi: __ZN7Texture13SetFilterModeEi, __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI19StreamedBinaryWriteILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __Z46Register_UnityEngine_Application_get_isPlayingv: __Z46Register_UnityEngine_Application_get_isPlayingv, __Z26getPxShape_QueryFilterDataPKN5physx7PxShapeE: __Z26getPxShape_QueryFilterDataPKN5physx7PxShapeE, __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE7reserveEj: __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE7reserveEj, __Z28setPxParticleBase_RestOffsetPN5physx14PxParticleBaseEf: __Z28setPxParticleBase_RestOffsetPN5physx14PxParticleBaseEf, __ZNK5physx12PxFixedJoint19getConcreteTypeNameEv: __ZNK5physx12PxFixedJoint19getConcreteTypeNameEv, __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_PKc17TransferMetaFlags, __ZN13GfxDeviceGLES11SetViewportERK5RectTIiE: __ZN13GfxDeviceGLES11SetViewportERK5RectTIiE, __ZN21LightProbeProxyVolume21GetLocalToWorldMatrixER10Matrix4x4f: __ZN21LightProbeProxyVolume21GetLocalToWorldMatrixER10Matrix4x4f, __ZN13SplatDatabase16CheckConsistencyEv: __ZN13SplatDatabase16CheckConsistencyEv, __ZN21TreeBinaryTreeBuilder18CalculatePosBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERK8Vector3fSE_: __ZN21TreeBinaryTreeBuilder18CalculatePosBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERK8Vector3fSE_, __Z51Register_UnityEngine_BillboardAsset_Internal_Createv: __Z51Register_UnityEngine_BillboardAsset_Internal_Createv, __Z24Time_Get_Custom_PropTimev: __Z24Time_Get_Custom_PropTimev, __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN4File12CleanupClassEv: __ZN4File12CleanupClassEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE12readPropertyIfEEbRT_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE15growAndPushBackERKS2_, __Z70Register_UnityEngine_AnimatorOverrideController_Internal_GetClipByNamev: __Z70Register_UnityEngine_AnimatorOverrideController_Internal_GetClipByNamev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ES2_RKNS_19PxVehicleClutchDataES6_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ES2_RKNS_19PxVehicleClutchDataES6_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_, __ZN17MemoryCacheReader10DirectReadEPvjj: __ZN17MemoryCacheReader10DirectReadEPvjj, __Z52Register_UnityEngine_Terrain_get_drawTreesAndFoliagev: __Z52Register_UnityEngine_Terrain_get_drawTreesAndFoliagev, __Z40AudioReverbZone_Set_Custom_PropDecayTimeP12Il2CppObjectf: __Z40AudioReverbZone_Set_Custom_PropDecayTimeP12Il2CppObjectf, __ZN4crndL20crnd_default_reallocEPvjPjbS0_: __ZN4crndL20crnd_default_reallocEPvjPjbS0_, __ZN13BoxCollider2D7SetSizeERK8Vector2f: __ZN13BoxCollider2D7SetSizeERK8Vector2f, __ZN15CapsuleCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15CapsuleCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __Z39Screen_Get_Custom_PropCurrentResolutionv: __Z39Screen_Get_Custom_PropCurrentResolutionv, __ZN7Texture11SetWrapModeEi: __ZN7Texture11SetWrapModeEi, __ZNSt3__26locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __ZN5physx24PxsComputeAABBLocalSpaceERKNS_18PxcAABBDataDynamicERNS_9PxBounds3E: __ZN5physx24PxsComputeAABBLocalSpaceERKNS_18PxcAABBDataDynamicERNS_9PxBounds3E, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEPNS_13basic_ostreamIcS2_EE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEPNS_13basic_ostreamIcS2_EE, __ZN9BlobWrite23WritePtrValueAtLocationEjx: __ZN9BlobWrite23WritePtrValueAtLocationEjx, __ZN16PackedQuatVector9PackQuatsEP11Quaternionfi: __ZN16PackedQuatVector9PackQuatsEP11Quaternionfi, __Z33Texture_CUSTOM_Internal_GetHeightP12Il2CppObject: __Z33Texture_CUSTOM_Internal_GetHeightP12Il2CppObject, __Z55Register_UnityEngine_Display_SetRenderingResolutionImplv: __Z55Register_UnityEngine_Display_SetRenderingResolutionImplv, __Z42Register_UnityEngine_Texture3D_GetPixels32v: __Z42Register_UnityEngine_Texture3D_GetPixels32v, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb, __ZN7mecanim9animation18ClipMuscleConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation18ClipMuscleConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z22InverseTransformVector23TransformAccessReadOnlyRKN4math7_float3E: __Z22InverseTransformVector23TransformAccessReadOnlyRKN4math7_float3E, __ZL16FMOD_ErrorString11FMOD_RESULT_486: __ZL16FMOD_ErrorString11FMOD_RESULT_486, _UNITY_FT_Stream_GetChar: _UNITY_FT_Stream_GetChar, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15NavMeshSettings17MainThreadCleanupEv: __ZN15NavMeshSettings17MainThreadCleanupEv, __ZN5physx3Cct26CharacterControllerManagerC2ERNS_7PxSceneE: __ZN5physx3Cct26CharacterControllerManagerC2ERNS_7PxSceneE, __Z43WebCamTexture_Get_Custom_PropRequestedWidthP12Il2CppObject: __Z43WebCamTexture_Get_Custom_PropRequestedWidthP12Il2CppObject, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_, __ZNK19TextRenderingModule8TMGenGetERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii: __ZNK19TextRenderingModule8TMGenGetERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii, __Z50Register_UnityEngine_AudioReverbZone_set_decayTimev: __Z50Register_UnityEngine_AudioReverbZone_set_decayTimev, __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectPKcP12Il2CppObject: __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectPKcP12Il2CppObject, __Z40PointEffector2D_Set_Custom_PropForceModeP12Il2CppObject19EffectorForceMode2D: __Z40PointEffector2D_Set_Custom_PropForceModeP12Il2CppObject19EffectorForceMode2D, __Z47Register_UnityEngine_Camera_set_stereoTargetEyev: __Z47Register_UnityEngine_Camera_set_stereoTargetEyev, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE6createERS6_Rb, __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStylei: __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStylei, __ZN15CollisionModule5ResetEv: __ZN15CollisionModule5ResetEv, __Z19TestAndRemoveObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE: __Z19TestAndRemoveObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE, __ZN5Umbra10QueryState17findTomeByClusterEi: __ZN5Umbra10QueryState17findTomeByClusterEi, __ZN24PhysicsUpdateBehaviour2DD2Ev: __ZN24PhysicsUpdateBehaviour2DD2Ev, __Z33TextMesh_Set_Custom_PropFontStyleP12Il2CppObjecti: __Z33TextMesh_Set_Custom_PropFontStyleP12Il2CppObjecti, __ZN38AssetBundleLoadFromCacheAsyncOperationD2Ev: __ZN38AssetBundleLoadFromCacheAsyncOperationD2Ev, __ZN5physx2Sc9ShapeCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc9ShapeCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5Umbra4HashIjiE6rehashEj: __ZN5Umbra4HashIjiE6rehashEj, __Z37Texture2DArray_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormathh: __Z37Texture2DArray_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormathh, __Z45Register_UnityEngine_Camera_GetCommandBuffersv: __Z45Register_UnityEngine_Camera_GetCommandBuffersv, __ZN10FileSystem12MountHandlerEP17FileSystemHandler: __ZN10FileSystem12MountHandlerEP17FileSystemHandler, _UNITY_png_get_pixels_per_meter: _UNITY_png_get_pixels_per_meter, __ZNK14GfxContextGLES14GetFramebufferEv: __ZNK14GfxContextGLES14GetFramebufferEv, __ZN5physx8debugger4comm14AddProfileZoneD0Ev: __ZN5physx8debugger4comm14AddProfileZoneD0Ev, __Z46Register_UnityEngine_AndroidJNI_FromShortArrayv: __Z46Register_UnityEngine_AndroidJNI_FromShortArrayv, __Z9InitInputv: __Z9InitInputv, __ZThn12_NK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState: __ZN4gles10SetTextureER15DeviceStateGLESj16TextureDimensionj19BuiltinSamplerState, _UNITY_tt_face_build_cmaps: _UNITY_tt_face_build_cmaps, __Z37AndroidJNI_CUSTOM_SetLongArrayElement13Il2Cpp_IntPtrix: __Z37AndroidJNI_CUSTOM_SetLongArrayElement13Il2Cpp_IntPtrix, __ZNK5physx13GuMeshFactory15getConvexMeshesEPPNS_12PxConvexMeshEjj: __ZNK5physx13GuMeshFactory15getConvexMeshesEPPNS_12PxConvexMeshEjj, __Z26GetTextureColorSpaceString17TextureColorSpace: __Z26GetTextureColorSpaceString17TextureColorSpace, __ZN16MemoryFileSystem6DeleteER13FileEntryDatab: __ZN16MemoryFileSystem6DeleteER13FileEntryDatab, __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI9Texture3DEPT_17AwakeFromLoadMode10MemLabelId, _UNITY_png_set_background: _UNITY_png_set_background, __Z32Physics2D_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h: __Z32Physics2D_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h, __ZN5physx2Sn17readAllPropertiesINS_16PxSphericalJointENS_29PxSphericalJointGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_: __ZN5physx2Sn17readAllPropertiesINS_16PxSphericalJointENS_29PxSphericalJointGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_, __ZN10HumanTrait10LeftFinger12GetBoneCountEv: __ZN10HumanTrait10LeftFinger12GetBoneCountEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags, __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_: __ZNSt3__26__sortIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_, __ZNK5physx7NpScene19getFilterShaderDataEv: __ZNK5physx7NpScene19getFilterShaderDataEv, _jinit_marker_writer: _jinit_marker_writer, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _UNITY_png_icc_set_sRGB: _UNITY_png_icc_set_sRGB, __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE: __ZN20SoundChannelInstance15setChannelGroupEPN4FMOD12ChannelGroupE, __Z22IsStylusTouchSupportedv: __Z22IsStylusTouchSupportedv, __ZN5physx2Sc19ShapeInstancePairLL26onPoseChangedWhileSleepingEv: __ZN5physx2Sc19ShapeInstancePairLL26onPoseChangedWhileSleepingEv, __Z33Camera_CUSTOM_RemoveCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_: __Z33Camera_CUSTOM_RemoveCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_, __ZdlPv: __ZdlPv, __ZN12LightsModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState: __ZN12LightsModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState, __ZN5physx29PxVehicleUpdateCMassLocalPoseERKNS_11PxTransformES2_jPNS_15PxVehicleWheelsE: __ZN5physx29PxVehicleUpdateCMassLocalPoseERKNS_11PxTransformES2_jPNS_15PxVehicleWheelsE, __Z32AndroidJNI_CUSTOM_FromShortArray13Il2Cpp_IntPtr: __Z32AndroidJNI_CUSTOM_FromShortArray13Il2Cpp_IntPtr, __ZN5physx22PxcSweepCapsuleCapsuleERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx22PxcSweepCapsuleCapsuleERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E6getDirEv, __ZN14NavMeshManager12RemoveTileAtEiii: __ZN14NavMeshManager12RemoveTileAtEiii, __ZN20ArchiveStorageReader17MakeStorageUnusedEv: __ZN20ArchiveStorageReader17MakeStorageUnusedEv, __ZN43MultiWriterSingleReaderAtomicCircularBufferD2Ev: __ZN43MultiWriterSingleReaderAtomicCircularBufferD2Ev, __ZNK25MultiBlocksMemoryFileData5CloneEv: __ZNK25MultiBlocksMemoryFileData5CloneEv, __ZN11MatrixStack3PopEv: __ZN11MatrixStack3PopEv, __Z23setPxScene_FrictionTypePN5physx7PxSceneENS_14PxFrictionType4EnumE: __Z23setPxScene_FrictionTypePN5physx7PxSceneENS_14PxFrictionType4EnumE, __ZN5physx21PxQueryFilterCallbackD2Ev: __ZN5physx21PxQueryFilterCallbackD2Ev, __ZN5physx11AdjacenciesC2Ev: __ZN5physx11AdjacenciesC2Ev, __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_secondaryAxisP12Il2CppObjectP8Vector3f: __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_secondaryAxisP12Il2CppObjectP8Vector3f, __Z18GetCubeMapTexelPtrPfP13CImageSurface: __Z18GetCubeMapTexelPtrPfP13CImageSurface, __ZN5Umbra20ObjectDistanceParams26setMinRelativeContributionEf: __ZN5Umbra20ObjectDistanceParams26setMinRelativeContributionEf, __ZN17ArchiveFileSystem11CreateAsDirER13FileEntryData: __ZN17ArchiveFileSystem11CreateAsDirER13FileEntryData, __ZL30GeomOverlapCallback_CapsuleBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL30GeomOverlapCallback_CapsuleBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z38Application_Get_Custom_PropInstallModev: __Z38Application_Get_Custom_PropInstallModev, __Z38Rigidbody_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z38Rigidbody_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, _select: _select, __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi: __ZN26AnimatorControllerPlayable26ParameterControlledByCurveEi, __ZN22VertexDeclarationCacheD0Ev: __ZN22VertexDeclarationCacheD0Ev, __Z54Register_UnityEngine_Analytics_CustomEventData_AddCharv: __Z54Register_UnityEngine_Analytics_CustomEventData_AddCharv, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZNK21AssetBundleFileSystem8PositionERK13FileEntryData: __ZNK21AssetBundleFileSystem8PositionERK13FileEntryData, __ZN12AudioManager22CreateFMODSoundFromWWWEP10IWWWStream15FMOD_SOUND_TYPE17FMOD_SOUND_FORMATjjbbP10SampleClip: __ZN12AudioManager22CreateFMODSoundFromWWWEP10IWWWStream15FMOD_SOUND_TYPE17FMOD_SOUND_FORMATjjbbP10SampleClip, __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev: __ZN5physx31PxArticulationLinkGeneratedInfoC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN6b2Draw10ClearFlagsEj: __ZN6b2Draw10ClearFlagsEj, __ZN27AnimatorControllerParameter13SetControllerEP18AnimatorController: __ZN27AnimatorControllerParameter13SetControllerEP18AnimatorController, __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_: __ZN13dynamic_arrayI11Collision2DLj4EE9push_backERKS0_, __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier: __ZN8Remapper23GetOrGenerateInstanceIDERK26SerializedObjectIdentifier, __Z26TransformVerticesInnerLoopILb0ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb0ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __ZNSt3__210__stdinbufIcE9underflowEv: __ZNSt3__210__stdinbufIcE9underflowEv, __ZN17FileSystemHandler10AtomicMoveER13FileEntryDataS1_: __ZN17FileSystemHandler10AtomicMoveER13FileEntryDataS1_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags, __ZN9ShaderLab4PassD2Ev: __ZN9ShaderLab4PassD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj297ENS_22PxRepXPropertyAccessorILj297ES4_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj297ENS_22PxRepXPropertyAccessorILj297ES4_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESC_EEEEvRKT0_, __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev: __ZN5physx30PxCapsuleGeometryGeneratedInfoC2Ev, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE18RegisterAllocationEPKv: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE18RegisterAllocationEPKv, __Z24RegisterStrippedTypeInfoI16ParticleRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI16ParticleRendererEviPKcS2_, __Z32GUIStyle_Set_Custom_PropFontSizeP12Il2CppObjecti: __Z32GUIStyle_Set_Custom_PropFontSizeP12Il2CppObjecti, __ZN6Sprite8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN6Sprite8TransferI24GenerateTypeTreeTransferEEvRT_, __Z49Register_UnityEngine_AndroidJNI_GetStaticIntFieldv: __Z49Register_UnityEngine_AndroidJNI_GetStaticIntFieldv, __Z48Register_UnityEngine_Transform_SetAsFirstSiblingv: __Z48Register_UnityEngine_Transform_SetAsFirstSiblingv, __ZN5physx13NpClothFabric12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx13NpClothFabric12createObjectERPhRNS_24PxDeserializationContextE, __ZN7SubMesh8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7SubMesh8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE19getConcreteTypeNameEv, __Z34Animator_Get_Custom_PropAvatarRootP12Il2CppObject: __Z34Animator_Get_Custom_PropAvatarRootP12Il2CppObject, __Z48Register_UnityEngine_Application_get_absoluteURLv: __Z48Register_UnityEngine_Application_get_absoluteURLv, __ZN5physx3Cct10Controller6setPosERKNS_14PxExtendedVec3E: __ZN5physx3Cct10Controller6setPosERKNS_14PxExtendedVec3E, __ZN19GfxThreadableDevice20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh: __ZN19GfxThreadableDevice20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh, __ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_: __ZN5physx2GuL14testFaceNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RjRNS7_5Vec3VENS0_13FeatureStatusERSI_, __ZNK13SparseTexture13GetDataHeightEv: __ZNK13SparseTexture13GetDataHeightEv, __ZN9Animation18CleanupBoundCurvesEv: __ZN9Animation18CleanupBoundCurvesEv, __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46Mesh_CUSTOM_PrintErrorCantAccessMeshForIndicesP12Il2CppObject: __Z46Mesh_CUSTOM_PrintErrorCantAccessMeshForIndicesP12Il2CppObject, __Z55Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForcev: __Z55Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForcev, __ZN9Transform23SetSiblingIndexInternalEib: __ZN9Transform23SetSiblingIndexInternalEib, __Z55Register_UnityEngine_Profiling_Profiler_BeginSampleOnlyv: __Z55Register_UnityEngine_Profiling_Profiler_BeginSampleOnlyv, __Z20ExtractPPtrClassNameRK16TypeTreeIterator: __Z20ExtractPPtrClassNameRK16TypeTreeIterator, __ZN15DistanceJoint2D16CheckConsistencyEv: __ZN15DistanceJoint2D16CheckConsistencyEv, __ZN12TreeRenderer19LODTreeInstanceData21ReleaseWindPropertiesEv: __ZN12TreeRenderer19LODTreeInstanceData21ReleaseWindPropertiesEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj286ENS_22PxRepXPropertyAccessorILj286ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj286ENS_22PxRepXPropertyAccessorILj286ES4_ffEEEEvRKT0_, __ZN4FMOD7ReverbI13getPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD7ReverbI13getPropertiesEP22FMOD_REVERB_PROPERTIES, __ZN14RenderSettings6SetSunEP5Light: __ZN14RenderSettings6SetSunEP5Light, __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_: __ZN7mecanim5human12HumanPoseSubERNS0_9HumanPoseERKS1_S4_, __ZN7ApiGLES11BindTextureEjj16TextureDimension: __ZN7ApiGLES11BindTextureEjj16TextureDimension, __Z13GetFrameStatsv: __Z13GetFrameStatsv, __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib: __ZN14AnimationState4InitERK8UnityStrP13AnimationClipdib, __Z18Transfer_BlittableI14SafeBinaryReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z24GetFixedBehaviourManagerv: __Z24GetFixedBehaviourManagerv, __ZN12FlareManager9UpdateJobEP25FlareManagerUpdateJobData: __ZN12FlareManager9UpdateJobEP25FlareManagerUpdateJobData, __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize3R8Vector3fS0_S0_: __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize3R8Vector3fS0_S0_, __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDevice9TextureID: __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDevice9TextureID, _vfprintf: _vfprintf, __ZN10GUIManager12AddGUIScriptER8ListNodeI13MonoBehaviourE: __ZN10GUIManager12AddGUIScriptER8ListNodeI13MonoBehaviourE, __Z36setPxVehicleDriveDynData_CurrentGearPN5physx21PxVehicleDriveDynDataEj: __Z36setPxVehicleDriveDynData_CurrentGearPN5physx21PxVehicleDriveDynDataEj, __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_: __ZNSt3__26__sortIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_, __ZN15RelativeJoint2D16CheckConsistencyEv: __ZN15RelativeJoint2D16CheckConsistencyEv, __ZN17PrecomputeContextC2Ev: __ZN17PrecomputeContextC2Ev, __ZN20DynamicPropertySheetD0Ev: __ZN20DynamicPropertySheetD0Ev, __Z65Register_UnityEngine_ConfigurableJoint_get_configuredInWorldSpacev: __Z65Register_UnityEngine_ConfigurableJoint_get_configuredInWorldSpacev, __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E: __ZN14SafeBinaryRead17RegisterConverterEPKcS1_PFbPvRS_E, __Z28Shader_CUSTOM_DisableKeywordP12Il2CppString: __Z28Shader_CUSTOM_DisableKeywordP12Il2CppString, __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_: __ZN35RegisterRuntimeInitializeAndCleanup8RegisterEPFvPvES2_iS0_, __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeIPKvNS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13SetFloatValueEPvf: __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13SetFloatValueEPvf, __Z26setPxSceneDescFilterShaderPN5physx11PxSceneDescEPFNS_7PxFlagsINS_12PxFilterFlag4EnumEtEEjNS_12PxFilterDataEjS6_RNS2_INS_10PxPairFlag4EnumEtEEPKvjE: __Z26setPxSceneDescFilterShaderPN5physx11PxSceneDescEPFNS_7PxFlagsINS_12PxFilterFlag4EnumEtEEjNS_12PxFilterDataEjS6_RNS2_INS_10PxPairFlag4EnumEtEEPKvjE, __ZN7mecanim6memory16ChainedAllocator7ReserveEj: __ZN7mecanim6memory16ChainedAllocator7ReserveEj, __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN17AudioReverbFilter16CheckConsistencyEv: __ZN17AudioReverbFilter16CheckConsistencyEv, __ZN12ServerSocket14StartListeningEPK8sockaddrjb: __ZN12ServerSocket14StartListeningEPK8sockaddrjb, __ZN5physx29EntityReportContainerCallback7onEventEjPj: __ZN5physx29EntityReportContainerCallback7onEventEjPj, __Z22setPxActor_OwnerClientPN5physx7PxActorEh: __Z22setPxActor_OwnerClientPN5physx7PxActorEh, __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z46SortingLayer_CUSTOM_GetSortingLayerIDsInternalv: __Z46SortingLayer_CUSTOM_GetSortingLayerIDsInternalv, _UNITY_png_create_read_struct: _UNITY_png_create_read_struct, __Z47Register_UnityEngine_MeshCollider_get_skinWidthv: __Z47Register_UnityEngine_MeshCollider_get_skinWidthv, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx25PxcSweepConvexHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx25PxcSweepConvexHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE: __ZN5physx5cloth7SwCloth4pushERNS0_13SwConstraintsE, __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE, __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_TT_Get_MM_Var: _UNITY_TT_Get_MM_Var, __Z26AudioMixer_CUSTOM_SetFloatP12Il2CppObjectP12Il2CppStringf: __Z26AudioMixer_CUSTOM_SetFloatP12Il2CppObjectP12Il2CppStringf, __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZN5physx2Cm10Collection6removeERNS_6PxBaseE: __ZN5physx2Cm10Collection6removeERNS_6PxBaseE, __ZNK2UI6Canvas13GetRenderModeEv: __ZNK2UI6Canvas13GetRenderModeEv, __ZN4FMOD5Sound15getSystemObjectEPPNS_6SystemE: __ZN4FMOD5Sound15getSystemObjectEPPNS_6SystemE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead28TransitionInterruptionSourceEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead28TransitionInterruptionSourceEvRT_RT0_PKc17TransferMetaFlags, __Z18Transfer_BlittableI14SafeBinaryReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx14NpRigidDynamic7releaseEv: __ZN5physx14NpRigidDynamic7releaseEv, __Z20IsApplicationGenuinev: __Z20IsApplicationGenuinev, __ZN19CharacterController15ThreadedCleanupEv: __ZN19CharacterController15ThreadedCleanupEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKw, __ZN5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEED0Ev, __Z45AudioSource_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti: __Z45AudioSource_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti, __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z48Register_UnityEngine_AudioSource_get_playOnAwakev: __Z48Register_UnityEngine_AudioSource_get_playOnAwakev, __ZN14ParticleSystem18GetStartDelayCurveEv: __ZN14ParticleSystem18GetStartDelayCurveEv, __ZN12_GLOBAL__N_116RequiresCallbackD0Ev: __ZN12_GLOBAL__N_116RequiresCallbackD0Ev, __ZN12_GLOBAL__N_111StreamOwner4lockEv: __ZN12_GLOBAL__N_111StreamOwner4lockEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZNSt3__211__libcpp_db17__insert_iteratorEPv: __ZNSt3__211__libcpp_db17__insert_iteratorEPv, _j1f: _j1f, __ZN24DownloadHandlerAudioClip13OnReceiveDataEPKvj: __ZN24DownloadHandlerAudioClip13OnReceiveDataEPKvj, _gray_raster_reset: _gray_raster_reset, __ZNK5physx27PxRigidDynamicGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx27PxRigidDynamicGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j, __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE8__appendEj, __ZN14AnimationState21RemoveMixingTransformER9Transform: __ZN14AnimationState21RemoveMixingTransformER9Transform, __Z44Register_UnityEngine_Animator_GetFloatStringv: __Z44Register_UnityEngine_Animator_GetFloatStringv, __ZN12_GLOBAL__N_123FStreamNetworkOutStream10disconnectEv: __ZN12_GLOBAL__N_123FStreamNetworkOutStream10disconnectEv, __Z55Register_UnityEngine_MaterialPropertyBlock_DestroyBlockv: __Z55Register_UnityEngine_MaterialPropertyBlock_DestroyBlockv, __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, _UNITY_tt_face_load_pclt: _UNITY_tt_face_load_pclt, __ZN21ArchiveStorageCreator14StoreDirectoryEv: __ZN21ArchiveStorageCreator14StoreDirectoryEv, __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_yDriveP12Il2CppObjectRK10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_yDriveP12Il2CppObjectRK10JointDrive, __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE: __ZN5physx22PxJointGeneratedValuesC2EPKNS_7PxJointE, __Z58Register_UnityEngine_TargetJoint2D_set_autoConfigureTargetv: __Z58Register_UnityEngine_TargetJoint2D_set_autoConfigureTargetv, __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_: __ZN11TypeManager24RegisterStrippedTypeInfoEiP4RTTIPKcS3_, __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z46QualitySettings_Set_Custom_PropPixelLightCounti: __Z46QualitySettings_Set_Custom_PropPixelLightCounti, __Z32AddAllowComponentReplacementIMPLi: __Z32AddAllowComponentReplacementIMPLi, __ZNK6Camera18WorldToScreenPointERK8Vector3fPb: __ZNK6Camera18WorldToScreenPointERK8Vector3fPb, __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE11runInternalEv, __Z38Renderer_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_: __Z38Renderer_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_, __ZN14UnityAnalyticsD0Ev: __ZN14UnityAnalyticsD0Ev, __ZN13SpringJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13SpringJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx19TriangleMeshBuilder10importMeshERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb: __ZN5physx19TriangleMeshBuilder10importMeshERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb, __Z35CommandBuffer_CUSTOM_SetGlobalFloatP12Il2CppObjectif: __Z35CommandBuffer_CUSTOM_SetGlobalFloatP12Il2CppObjectif, __Z45Playable_CUSTOM_INTERNAL_CALL_IsValidInternalR9HPlayable: __Z45Playable_CUSTOM_INTERNAL_CALL_IsValidInternalR9HPlayable, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7setNameEPKc, __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f: __Z21CalculateInbetweenKeyI11QuaternionfE11KeyframeTplIT_ERKS3_S5_f, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZMultiplierv, __ZNK13MonoBehaviour6GetDSPEv: __ZNK13MonoBehaviour6GetDSPEv, __Z58Register_UnityEngine_Application_get_isShowingSplashScreenv: __Z58Register_UnityEngine_Application_get_isShowingSplashScreenv, __ZNSt3__227__insertion_sort_incompleteIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEbT0_S9_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEbT0_S9_T_, __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE11runInternalEv, __GLOBAL__sub_I_runtime_camera_culling_lump_cpp: __GLOBAL__sub_I_runtime_camera_culling_lump_cpp, __ZNK19VREyeTextureManager19GetEyeTextureHeightEv: __ZNK19VREyeTextureManager19GetEyeTextureHeightEv, __ZN5physx2Sc16ArticulationCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc16ArticulationCore17getBinaryMetaDataERNS_14PxOutputStreamE, __Z15Transfer_StringI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z34Animator_Get_Custom_PropUpdateModeP12Il2CppObject: __Z34Animator_Get_Custom_PropUpdateModeP12Il2CppObject, __ZN11UnityEngine9AnimationltERKNS0_13CachedBindingES3_: __ZN11UnityEngine9AnimationltERKNS0_13CachedBindingES3_, __ZN15LocationService21StartUpdatingLocationEv: __ZN15LocationService21StartUpdatingLocationEv, __Z16MarkObjectAsRootPK6ObjectR27GarbageCollectorThreadState: __Z16MarkObjectAsRootPK6ObjectR27GarbageCollectorThreadState, __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNK13MonoBehaviour17HaveAudioCallbackEv: __ZNK13MonoBehaviour17HaveAudioCallbackEv, __ZN26EnlightenSystemInformation8TransferI14SafeBinaryReadEEvRT_: __ZN26EnlightenSystemInformation8TransferI14SafeBinaryReadEEvRT_, __ZN13InitialModule5ResetEv: __ZN13InitialModule5ResetEv, __ZNK7Joint2D10SwapBodiesEv: __ZNK7Joint2D10SwapBodiesEv, __Z67Register_UnityEngine_RenderSettings_INTERNAL_set_ambientGroundColorv: __Z67Register_UnityEngine_RenderSettings_INTERNAL_set_ambientGroundColorv, __ZN5physx2Sc19ClothFabricBulkData15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc19ClothFabricBulkData15exportExtraDataERNS_22PxSerializationContextE, __Z62ParticleSystem_CollisionModule_CUSTOM_GetUsesCollisionMessagesP12Il2CppObject: __Z62ParticleSystem_CollisionModule_CUSTOM_GetUsesCollisionMessagesP12Il2CppObject, __ZN5physx2Sq17SceneQueryManager11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq17SceneQueryManager11shiftOriginERKNS_6PxVec3E, __ZN12MeshRendererD0Ev: __ZN12MeshRendererD0Ev, __ZN12AudioManager35GetCurrentSpatializerDefinitionNameEv: __ZN12AudioManager35GetCurrentSpatializerDefinitionNameEv, __ZN5physx2Gu16sweepBoxTriangleERKNS_10PxTriangleERKNS_9PxBounds3ERKNS_6PxVec3ES9_RS7_SA_Rf: __ZN5physx2Gu16sweepBoxTriangleERKNS_10PxTriangleERKNS_9PxBounds3ERKNS_6PxVec3ES9_RS7_SA_Rf, __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_, _posix_fadvise: _posix_fadvise, __ZN5physx10writeChunkEaaaaRNS_14PxOutputStreamE: __ZN5physx10writeChunkEaaaaRNS_14PxOutputStreamE, __ZN14UnityAnalytics21GetUnityConnectClientEv: __ZN14UnityAnalytics21GetUnityConnectClientEv, __Z20CreateObjectFromCodeI19LowerResBlitTextureEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI19LowerResBlitTextureEPT_17AwakeFromLoadMode10MemLabelId, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z62Register_UnityEngine_AudioDistortionFilter_set_distortionLevelv: __Z62Register_UnityEngine_AudioDistortionFilter_set_distortionLevelv, __ZN11UnityEngine15PlatformWrapper9IsAndroidEv: __ZN11UnityEngine15PlatformWrapper9IsAndroidEv, __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionYP12Il2CppObject: __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionYP12Il2CppObject, __ZNSt3__218__libcpp_refstringaSERKS0_: __ZNSt3__218__libcpp_refstringaSERKS0_, __Z37Caching_Get_Custom_PropSpaceAvailablev: __Z37Caching_Get_Custom_PropSpaceAvailablev, __ZN9CGProgram7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9CGProgram7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj593ENS_22PxRepXPropertyAccessorILj593ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj593ENS_22PxRepXPropertyAccessorILj593ES4_ffEEEEvRKT0_, __ZN12b2MouseJoint23InitVelocityConstraintsERK12b2SolverData: __ZN12b2MouseJoint23InitVelocityConstraintsERK12b2SolverData, __Z52Register_UnityEngine_Terrain_get_heightmapMaximumLODv: __Z52Register_UnityEngine_Terrain_get_heightmapMaximumLODv, __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, _stbir_resize_region: _stbir_resize_region, __ZNK6b2AABB7RayCastEP15b2RayCastOutputRK14b2RayCastInput: __ZNK6b2AABB7RayCastEP15b2RayCastOutputRK14b2RayCastInput, __ZNSt3__217moneypunct_bynameIwLb0EE4initEPKc: __ZNSt3__217moneypunct_bynameIwLb0EE4initEPKc, __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE: __ZN5physx2Sc9RigidCore13onShapeChangeERNS0_9ShapeCoreENS_7PxFlagsINS0_21ShapeChangeNotifyFlag4EnumEjEENS4_INS_11PxShapeFlag4EnumEhEE, __ZNK13b2PulleyJoint8GetRatioEv: __ZNK13b2PulleyJoint8GetRatioEv, __ZN7mecanim9animation22DestroyAvatarWorkspaceEPNS0_15AvatarWorkspaceERNS_6memory9AllocatorE: __ZN7mecanim9animation22DestroyAvatarWorkspaceEPNS0_15AvatarWorkspaceERNS_6memory9AllocatorE, __ZN4FMOD8ChannelI11getPositionEPjj: __ZN4FMOD8ChannelI11getPositionEPjj, __ZN12NavMeshAgent12AddToManagerEv: __ZN12NavMeshAgent12AddToManagerEv, __ZN27AnimationLayerMixerPlayableD0Ev: __ZN27AnimationLayerMixerPlayableD0Ev, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE12__move_rangeEPS1_S6_S6_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE12__move_rangeEPS1_S6_S6_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEE15growAndPushBackERKS2_, __ZN5physx17solveContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx17solveContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx6shdfnd10FoundationD2Ev: __ZN5physx6shdfnd10FoundationD2Ev, __ZN15LightmapSTCacheC2ER13BatchRendererR15RenderLoopStats: __ZN15LightmapSTCacheC2ER13BatchRendererR15RenderLoopStats, __ZN5Umbra11TileMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeES9_ii: __ZN5Umbra11TileMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeES9_ii, __ZN5physx2Sc17ParticleSystemSim19schedulePipelineGpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim19schedulePipelineGpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE, __Z36Mesh_CUSTOM_GetBlendShapeFrameWeightP12Il2CppObjectii: __Z36Mesh_CUSTOM_GetBlendShapeFrameWeightP12Il2CppObjectii, __ZN9ShaderLab11shaderprops9GetVectorEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE: __ZN9ShaderLab11shaderprops9GetVectorEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE, __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j: __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j, __ZN7mecanim9animation29MotionOutputGetDeltaTransformEPKNS0_12MotionOutputE: __ZN7mecanim9animation29MotionOutputGetDeltaTransformEPKNS0_12MotionOutputE, __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE5eraseENS_21__tree_const_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE5eraseENS_21__tree_const_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEE, __Z51Register_UnityEngine_AreaEffector2D_set_forceTargetv: __Z51Register_UnityEngine_AreaEffector2D_set_forceTargetv, __ZN24b2ChainAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN24b2ChainAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN8Animator14OnAddComponentEPN5Unity9ComponentE: __ZN8Animator14OnAddComponentEPN5Unity9ComponentE, __ZN43MultiWriterSingleReaderAtomicCircularBuffer15ReadNextPayloadEPhi: __ZN43MultiWriterSingleReaderAtomicCircularBuffer15ReadNextPayloadEPhi, __Z43Transform_CUSTOM_INTERNAL_get_localRotationP12Il2CppObjectP11Quaternionf: __Z43Transform_CUSTOM_INTERNAL_get_localRotationP12Il2CppObjectP11Quaternionf, __ZN5physx2Sc10NPhaseCoreD2Ev: __ZN5physx2Sc10NPhaseCoreD2Ev, __ZN5physx2Sc7BodySim18onConstraintDetachEv: __ZN5physx2Sc7BodySim18onConstraintDetachEv, __ZN5Unity5Cloth13AwakeFromLoadE17AwakeFromLoadMode: __ZN5Unity5Cloth13AwakeFromLoadE17AwakeFromLoadMode, _finish_output_pass: _finish_output_pass, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7setNameEPKc, __ZN15ConstantForce2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15ConstantForce2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5Umbra14MemInputStream4readEPvj: __ZN5Umbra14MemInputStream4readEPvj, __ZN5physx7NpScene8simulateEfPNS_10PxBaseTaskEPvjb: __ZN5physx7NpScene8simulateEfPNS_10PxBaseTaskEPvjb, __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE: __ZN5physx2Gu13GeometryUnion3setERKNS_10PxGeometryE, __Z47Canvas_Set_Custom_PropSortingGridNormalizedSizeP12Il2CppObjecti: __Z47Canvas_Set_Custom_PropSortingGridNormalizedSizeP12Il2CppObjecti, __Z50Register_UnityEngine_Animator_set_recorderStopTimev: __Z50Register_UnityEngine_Animator_set_recorderStopTimev, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j, __ZN9ShaderLab20SerializedSubProgram14ConstantBufferaSERKS1_: __ZN9ShaderLab20SerializedSubProgram14ConstantBufferaSERKS1_, __Z13RegisterClassI4MeshEvv: __Z13RegisterClassI4MeshEvv, __Z53Register_UnityEngine_Joint_INTERNAL_get_currentTorquev: __Z53Register_UnityEngine_Joint_INTERNAL_get_currentTorquev, __Z49Register_UnityEngine_LineRenderer_get_textureModev: __Z49Register_UnityEngine_LineRenderer_get_textureModev, __Z13tessTesselateP14TESStesselatoriiiiPKf: __Z13tessTesselateP14TESStesselatoriiiiPKf, __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_: __ZNSt3__24pairIK8UnityStrS1_EC2ERKS3_, __ZN11UnityEngine15CloudWebService19SessionEventManager4StopEv: __ZN11UnityEngine15CloudWebService19SessionEventManager4StopEv, __ZN9Rigidbody5SleepEv: __ZN9Rigidbody5SleepEv, __ZN12AudioManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12AudioManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z39TerrainData_Get_Custom_PropDetailHeightP12Il2CppObject: __Z39TerrainData_Get_Custom_PropDetailHeightP12Il2CppObject, __ZNK17CapsuleCollider2D26GetTypeInfoVirtualInternalEv: __ZNK17CapsuleCollider2D26GetTypeInfoVirtualInternalEv, __Z49Physics2D_Set_Custom_PropMinPenetrationForPenaltyf: __Z49Physics2D_Set_Custom_PropMinPenetrationForPenaltyf, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb, __ZN13dynamic_arrayIfLj4EEC2ERKS0_: __ZN13dynamic_arrayIfLj4EEC2ERKS0_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_, _fputwc: _fputwc, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj, __ZNK32RendererMaterialAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK32RendererMaterialAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z53Register_UnityEngine_AI_NavMeshAgent_set_accelerationv: __Z53Register_UnityEngine_AI_NavMeshAgent_set_accelerationv, __ZN5physx18NpArticulationLink10clearForceENS_11PxForceMode4EnumE: __ZN5physx18NpArticulationLink10clearForceENS_11PxForceMode4EnumE, __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_: __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6PxVec3ES3_S3_S3_S3_PfS4_S4_, __ZN16CircleCollider2D10SmartResetEv: __ZN16CircleCollider2D10SmartResetEv, __ZN2UI11CanvasGroup12CleanupClassEv: __ZN2UI11CanvasGroup12CleanupClassEv, __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __Z43QualitySettings_Set_Custom_PropAntiAliasingi: __Z43QualitySettings_Set_Custom_PropAntiAliasingi, __ZN22LocalFileSystemHandler9MakeLocalER13FileEntryDatab: __ZN22LocalFileSystemHandler9MakeLocalER13FileEntryDatab, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv, __ZN15FrictionJoint2D16CheckConsistencyEv: __ZN15FrictionJoint2D16CheckConsistencyEv, __Z11GetNicePathR15CacheReaderBase: __Z11GetNicePathR15CacheReaderBase, __ZN9AudioClip10ClearQueueEv: __ZN9AudioClip10ClearQueueEv, __ZN14SpriteRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData: __ZN14SpriteRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData, __ZNSt3__23mapIN20TextRenderingPrivate7FontRefENS1_6OSFontENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEixERS8_: __ZNSt3__23mapIN20TextRenderingPrivate7FontRefENS1_6OSFontENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEixERS8_, __ZN12NavMeshAgent20SetAvoidancePriorityEi: __ZN12NavMeshAgent20SetAvoidancePriorityEi, __ZN11MatrixStack4PushEv: __ZN11MatrixStack4PushEv, __ZN14PhysicsManager16GetSleepVelocityEv: __ZN14PhysicsManager16GetSleepVelocityEv, __ZN17GeneralConnection4PollEv: __ZN17GeneralConnection4PollEv, __ZN18ProceduralMaterial19SetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN18ProceduralMaterial19SetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZNK5physx15NpActorTemplateINS_7PxClothEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE12getAggregateEv, __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_: __ZNSt3__26__sortIRNS_4lessIiEEPiEEvT0_S5_T_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS2_9allocatorINS3_IS4_fEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS2_9allocatorINS3_IS4_fEEEEEEEvRT_17TransferMetaFlags, __Z13RegisterClassI15QualitySettingsEvv: __Z13RegisterClassI15QualitySettingsEvv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setpEPcS4_: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setpEPcS4_, __ZN14CompressedMesh10GetQualityE15MeshCompression: __ZN14CompressedMesh10GetQualityE15MeshCompression, __ZN25DeferredRenderLoopScratchD0Ev: __ZN25DeferredRenderLoopScratchD0Ev, __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI21ComputeShaderResourceNS0_9allocatorIS2_EEEEEvRT_j, __Z32getPxRevoluteJoint_DriveVelocityPKN5physx15PxRevoluteJointE: __Z32getPxRevoluteJoint_DriveVelocityPKN5physx15PxRevoluteJointE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj544ENS_22PxRepXPropertyAccessorILj544ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj544ENS_22PxRepXPropertyAccessorILj544ES4_ffEEEEvRKT0_, __ZN7mecanim9animation17EvaluateHumanPoseERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfRKNS0_12MotionOutputERNS_5human9HumanPoseE: __ZN7mecanim9animation17EvaluateHumanPoseERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfRKNS0_12MotionOutputERNS_5human9HumanPoseE, __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERSB_: __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERSB_, __ZN2UI6Canvas21WaitOnBatchGenerationEv: __ZN2UI6Canvas21WaitOnBatchGenerationEv, __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE7getNameEv, __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb: __ZL13RenderCastersiRK8Vector3fS1_RK13ShadowJobDataR17ShaderPassContextRKNSt3__26vectorI16ShadowCasterData13stl_allocatorIS9_L18MemLabelIdentifier2ELi16EEEERKNS8_I20ShadowCasterPartDataSA_ISG_LSB_2ELi16EEEERK15RenderNodeQueueb, __ZN5physx12NpWriteCheckD2Ev: __ZN5physx12NpWriteCheckD2Ev, __ZN21DownloadHandlerBufferD0Ev: __ZN21DownloadHandlerBufferD0Ev, __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED2Ev: __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED2Ev, __Z47Texture2D_CUSTOM_LoadRawTextureData_ImplPointerP12Il2CppObject13Il2Cpp_IntPtri: __Z47Texture2D_CUSTOM_LoadRawTextureData_ImplPointerP12Il2CppObject13Il2Cpp_IntPtri, __ZN6Camera11ResetAspectEv: __ZN6Camera11ResetAspectEv, __ZNSt3__227__insertion_sort_incompleteIRPFbP10GUIElementS2_EPS2_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbP10GUIElementS2_EPS2_EEbT0_S7_T_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIssEEPsEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIssEEPsEEbT0_S5_T_, __ZN22CreateGpuProgramOutputD2Ev: __ZN22CreateGpuProgramOutputD2Ev, __ZN19VREyeTextureManager18ReleaseEyeTexturesEv: __ZN19VREyeTextureManager18ReleaseEyeTexturesEv, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_, __ZNK5physx3Cct15ObstacleContext14getNbObstaclesEv: __ZNK5physx3Cct15ObstacleContext14getNbObstaclesEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv, __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFramev: __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFramev, __ZN5physx14PxVehicleGraph16setupEngineGraphEffffRKNS_6PxVec3ES3_S3_: __ZN5physx14PxVehicleGraph16setupEngineGraphEffffRKNS_6PxVec3ES3_S3_, __ZNSt3__211__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t: __ZNSt3__211__stdoutbufIwEC2EP8_IO_FILEP11__mbstate_t, __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN5physx16NpParticleSystem23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb: __ZN5physx16NpParticleSystem23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb, __ZN7mecanim9animation23BlendDirectDataConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation23BlendDirectDataConstant8TransferI14SafeBinaryReadEEvRT_, __ZZN11Rigidbody2D15InitializeClassEvEN35FunctorImpl_200kAnimatorMoveBuiltin4CallEPviR11MessageData: __ZZN11Rigidbody2D15InitializeClassEvEN35FunctorImpl_200kAnimatorMoveBuiltin4CallEPviR11MessageData, __Z47Register_UnityEngine_Material_SetColorArrayImplv: __Z47Register_UnityEngine_Material_SetColorArrayImplv, __Z41Register_UnityEngine_Material_GetPassNamev: __Z41Register_UnityEngine_Material_GetPassNamev, __Z52Register_UnityEngine_AI_OffMeshLink_set_costOverridev: __Z52Register_UnityEngine_AI_OffMeshLink_set_costOverridev, _pwritev: _pwritev, __ZN5physx7NpScene26removeFromParticleBaseListERNS_14PxParticleBaseE: __ZN5physx7NpScene26removeFromParticleBaseListERNS_14PxParticleBaseE, __ZN5physx2Sc9ClothCore23setSelfCollisionIndicesEPKjj: __ZN5physx2Sc9ClothCore23setSelfCollisionIndicesEPKjj, __ZThn32_NK8Renderer14GetSubsetIndexEi: __ZThn32_NK8Renderer14GetSubsetIndexEi, __ZN5Umbra20ObjectDistanceParamsC2ERKS0_: __ZN5Umbra20ObjectDistanceParamsC2ERKS0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj458ENS_22PxRepXPropertyAccessorILj458ES4_RKNS_22PxJointLinearLimitPairES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj458ENS_22PxRepXPropertyAccessorILj458ES4_RKNS_22PxJointLinearLimitPairES9_EEEEvRKT0_, __Z47Canvas_Set_Custom_PropNormalizedSortingGridSizeP12Il2CppObjectf: __Z47Canvas_Set_Custom_PropNormalizedSortingGridSizeP12Il2CppObjectf, __Z20LoadAndLookupSymbolsPKcz: __Z20LoadAndLookupSymbolsPKcz, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj, __Z48UnityConnectSettings_Get_Custom_PropTestEventUrlv: __Z48UnityConnectSettings_Get_Custom_PropTestEventUrlv, __ZN14FileCacherReadD2Ev: __ZN14FileCacherReadD2Ev, __ZN5physx6shdfnd10ThreadImpl7setNameEPKc: __ZN5physx6shdfnd10ThreadImpl7setNameEPKc, __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E: __ZN5physx22PxVehicleWheelsSimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E, __Z50Register_UnityEngine_CullingGroup_FinalizerFailurev: __Z50Register_UnityEngine_CullingGroup_FinalizerFailurev, __ZN16GUIKeyboardStateD2Ev: __ZN16GUIKeyboardStateD2Ev, __ZN5physx5cloth8SwSolverC2EPNS_13PxProfileZoneEPNS_13PxTaskManagerE: __ZN5physx5cloth8SwSolverC2EPNS_13PxProfileZoneEPNS_13PxTaskManagerE, __ZN27UnloadUnusedAssetsOperationD0Ev: __ZN27UnloadUnusedAssetsOperationD0Ev, __ZN6Camera15ThreadedCleanupEv: __ZN6Camera15ThreadedCleanupEv, __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags, __ZN26AnimatorControllerPlayable6MemoryD2Ev: __ZN26AnimatorControllerPlayable6MemoryD2Ev, __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE13StaticDestroyEPv, __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN14EdgeCollider2D12SetPolygon2DEP9Polygon2D: __ZN14EdgeCollider2D12SetPolygon2DEP9Polygon2D, __ZN17ProceduralTexture14SetAlphaSourceE20ProceduralOutputTypejbb: __ZN17ProceduralTexture14SetAlphaSourceE20ProceduralOutputTypejbb, ___crypt_r: ___crypt_r, __ZN5physx10PxsCCDPair12updateShapesEv: __ZN5physx10PxsCCDPair12updateShapesEv, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale1Ev, __Z44UnityAnalyticsHandler_CUSTOM_SendCustomEventP12Il2CppObjectS0_: __Z44UnityAnalyticsHandler_CUSTOM_SendCustomEventP12Il2CppObjectS0_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcj, __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN26AnimatorOverrideController23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN26AnimatorOverrideController23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN9ShaderLab9SubShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN5physx17PxcNpMemBlockPool7releaseERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPj: __ZN5physx17PxcNpMemBlockPool7releaseERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPj, __ZN5physx2Sn17readAllPropertiesINS_13PxRigidStaticEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_13PxRigidStaticEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN11OffMeshLink17RemoveFromManagerEv: __ZN11OffMeshLink17RemoveFromManagerEv, __ZN24GenerateTypeTreeTransfer8TransferIN11AssetBundle9AssetInfoEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN11AssetBundle9AssetInfoEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sc9ClothCore22removeCollisionCapsuleEj: __ZN5physx2Sc9ClothCore22removeCollisionCapsuleEj, __Z30getPxCloth_FrictionCoefficientPKN5physx7PxClothE: __Z30getPxCloth_FrictionCoefficientPKN5physx7PxClothE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEvRT_j, __Z59Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesv: __Z59Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesv, __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE: __ZN5physx16PxsFluidDynamics15schedulePacketsENS_16PxsSphUpdateTypeERNS_10PxBaseTaskE, __Z44AudioReverbFilter_Set_Custom_PropHfReferenceP12Il2CppObjectf: __Z44AudioReverbFilter_Set_Custom_PropHfReferenceP12Il2CppObjectf, __ZNK24RendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK24RendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN5physx2Sc10NPhaseCore39pool_deleteParticleElementRbElementPairEPNS0_35ParticleElementRbElementInteractionEjj: __ZN5physx2Sc10NPhaseCore39pool_deleteParticleElementRbElementPairEPNS0_35ParticleElementRbElementInteractionEjj, __ZN21AudioDistortionFilter8TransferI14SafeBinaryReadEEvRT_: __ZN21AudioDistortionFilter8TransferI14SafeBinaryReadEEvRT_, _UNITY_png_write_zTXt: _UNITY_png_write_zTXt, __ZN18ScreenManagerWebGL13SetShowCursorEb: __ZN18ScreenManagerWebGL13SetShowCursorEb, __Z38Camera_Get_Custom_PropStereoSeparationP12Il2CppObject: __Z38Camera_Get_Custom_PropStereoSeparationP12Il2CppObject, _frexp: _frexp, __ZN2UI13CanvasManager14GetRenderOrderEPKNS_6CanvasE: __ZN2UI13CanvasManager14GetRenderOrderEPKNS_6CanvasE, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_, __Z18Transfer_BlittableI14SafeBinaryReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv: __ZNK5physx2Sc18ParticleSystemCore15getParticleMassEv, _fmt_u: _fmt_u, __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_: __ZN6prcoreL21CreateRemapAnyBlitterE13TextureFormatS0_, __ZN17AnimationCurveTplIfE16StripInvalidKeysEv: __ZN17AnimationCurveTplIfE16StripInvalidKeysEv, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19Job_InvokeCoroutineEPv: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19Job_InvokeCoroutineEPv, __ZNK18PlayableController7GetTimeEv: __ZNK18PlayableController7GetTimeEv, __ZN13UnityProfiler26BeforeDomainUnloadCallbackEv: __ZN13UnityProfiler26BeforeDomainUnloadCallbackEv, __ZNK2UI6Canvas17GetSortingLayerIDEv: __ZNK2UI6Canvas17GetSortingLayerIDEv, __ZN14Raycast2DQuery8RunQueryEb: __ZN14Raycast2DQuery8RunQueryEb, __ZN20LocalFileSystemPosix4LockER13FileEntryData12FileLockMode: __ZN20LocalFileSystemPosix4LockER13FileEntryData12FileLockMode, __Z50Register_UnityEngine_Profiling_Profiler_GetSamplerv: __Z50Register_UnityEngine_Profiling_Profiler_GetSamplerv, __Z22createPxPhysics_ScenesPN5physx9PxPhysicsERKNS_11PxSceneDescE: __Z22createPxPhysics_ScenesPN5physx9PxPhysicsERKNS_11PxSceneDescE, __Z27scripting_array_length_safeP11Il2CppArray: __Z27scripting_array_length_safeP11Il2CppArray, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __Z42Register_UnityEngine_Animator_GetIntegerIDv: __Z42Register_UnityEngine_Animator_GetIntegerIDv, __ZN11UnityEngine15CloudWebService13WWWRestClient18GetEditableHeadersEv: __ZN11UnityEngine15CloudWebService13WWWRestClient18GetEditableHeadersEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv, __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI7TextureE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc8ClothSim16addCollisionMeshEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim16addCollisionMeshEPKNS0_8ShapeSimE, __Z52Screen_Set_Custom_PropAutorotateToPortraitUpsideDownh: __Z52Screen_Set_Custom_PropAutorotateToPortraitUpsideDownh, __ZN5physx21solveExtFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx21solveExtFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __ZN5physx17ConvexHullBuilder19ComputeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_: __ZN5physx17ConvexHullBuilder19ComputeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_, __Z35HumanTrait_Get_Custom_PropBoneCountv: __Z35HumanTrait_Get_Custom_PropBoneCountv, __ZN5physx6shdfnd5ArrayIPKNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPKNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED2Ev: __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED2Ev, __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortINS_2Cm19PreallocatingRegionENS0_4LessIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j, __ZNK5Umbra4Tome13getGateUserIDEi: __ZNK5Umbra4Tome13getGateUserIDEi, __ZN19UnityConnectService18OnPlayerQuitStaticEPS_: __ZN19UnityConnectService18OnPlayerQuitStaticEPS_, __Z45ParticleRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject: __Z45ParticleRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject, __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE8recreateEj, __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI27ComputeShaderBuiltinSamplerNS0_9allocatorIS2_EEEEEvRT_j, __ZNK26DownloadHandlerAssetBundle11GetProgressEv: __ZNK26DownloadHandlerAssetBundle11GetProgressEv, __ZN11Tetrahedron8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11Tetrahedron8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Unity10HingeJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity10HingeJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _UNITY_tt_get_cmap_info: _UNITY_tt_get_cmap_info, __Z8StripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __Z8StripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __ZN13AvatarBuilder19BuildAvatarInternalER6AvatarRKNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERK10GameObjectRK16HumanDescriptionNS_7OptionsEb: __ZN13AvatarBuilder19BuildAvatarInternalER6AvatarRKNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERK10GameObjectRK16HumanDescriptionNS_7OptionsEb, __ZN15ParticleEmitter15ResetEmitterPosEv: __ZN15ParticleEmitter15ResetEmitterPosEv, __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei: __ZN16ReflectionProbes8ScheduleEN18ReflectionProbeJob7JobTypeEP15ReflectionProbei, __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __GLOBAL__sub_I_LogAssert_cpp: __GLOBAL__sub_I_LogAssert_cpp, __ZN5physx3Ext20DefaultCpuDispatcher8stealJobEv: __ZN5physx3Ext20DefaultCpuDispatcher8stealJobEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE8pushNameEPKc, __ZNSt3__24stodERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj: __ZNSt3__24stodERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj, _iswalpha_l: _iswalpha_l, __ZN8DateTime25FromISO8601DateTimeStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8DateTime25FromISO8601DateTimeStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN15ResourceManager19ClearDependencyInfoEv: __ZN15ResourceManager19ClearDependencyInfoEv, __ZN16MessageForwarder13HandleMessageEPviR11MessageData: __ZN16MessageForwarder13HandleMessageEPviR11MessageData, _casin: _casin, __Z13RegisterClassI11AudioFilterEvv: __Z13RegisterClassI11AudioFilterEvv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __Z21setPxClothParticlePosPN5physx15PxClothParticleENS_6PxVec3E: __Z21setPxClothParticlePosPN5physx15PxClothParticleENS_6PxVec3E, __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEEEEEjT_j: __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEEEEEjT_j, __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN8Animator15SetGoalRotationEiRK11Quaternionf: __ZN8Animator15SetGoalRotationEiRK11Quaternionf, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxKillSpeedv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxKillSpeedv, __ZN8Collider23VirtualRedirectTransferER14SafeBinaryRead: __ZN8Collider23VirtualRedirectTransferER14SafeBinaryRead, _UNITY_FT_GlyphLoader_Done: _UNITY_FT_GlyphLoader_Done, __ZN7Terrain10SmartResetEv: __ZN7Terrain10SmartResetEv, __ZN13DrawImmediate11BeginBufferEv: __ZN13DrawImmediate11BeginBufferEv, __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState: __ZN5IMGUI14GUIWindowState20FindWindowUnderMouseER8GUIState, __ZN11UnityEngine7Connect13ConnectConfig13ConfigChangedERK8UnityStrR8JSONRead: __ZN11UnityEngine7Connect13ConnectConfig13ConfigChangedERK8UnityStrR8JSONRead, __ZN9Polygon2D16CheckConsistencyEv: __ZN9Polygon2D16CheckConsistencyEv, __ZN16BaseVideoTexture8YuvToRgbEPK8YuvFrame: __ZN16BaseVideoTexture8YuvToRgbEPK8YuvFrame, __ZN19CharacterController12SetIsTriggerEb: __ZN19CharacterController12SetIsTriggerEb, __ZN4FMOD6SoundI6getTagEPKciP8FMOD_TAG: __ZN4FMOD6SoundI6getTagEPKciP8FMOD_TAG, __Z50Register_UnityEngine_Renderer_get_staticBatchIndexv: __Z50Register_UnityEngine_Renderer_get_staticBatchIndexv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20setMaxMotionDistanceEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20setMaxMotionDistanceEf, __GLOBAL__sub_I_DirectorManager_cpp: __GLOBAL__sub_I_DirectorManager_cpp, ___fwriting: ___fwriting, __ZN5Cache10AddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN5Cache10AddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __Z59Register_UnityEngine_Rigidbody_INTERNAL_get_angularVelocityv: __Z59Register_UnityEngine_Rigidbody_INTERNAL_get_angularVelocityv, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToLongArrayP11Il2CppArrayRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToLongArrayP11Il2CppArrayRPv, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4gptrEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4gptrEv, __Z59Register_UnityEngine_GUIElement_INTERNAL_CALL_GetScreenRectv: __Z59Register_UnityEngine_GUIElement_INTERNAL_CALL_GetScreenRectv, __Z18SkinGenericMathLibILi2ELb1ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi2ELb1ELb0EEvR12SkinMeshInfo, __ZN5physx18ComputeSortedListsEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjPKjPPNS_8SapBox1DES7_PjSB_jRKNS_2Gu4AxesESB_RjSB_SG_RbSH_: __ZN5physx18ComputeSortedListsEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjPKjPPNS_8SapBox1DES7_PjSB_jRKNS_2Gu4AxesESB_RjSB_SG_RbSH_, __ZNK21IntermediateRenderers16GetBoundingBoxesEv: __ZNK21IntermediateRenderers16GetBoundingBoxesEv, __ZN5physx14SapPairManager7releaseEv: __ZN5physx14SapPairManager7releaseEv, __ZL28VehicleWheelRaycastPreFilterN5physx12PxFilterDataES0_PKvjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZL28VehicleWheelRaycastPreFilterN5physx12PxFilterDataES0_PKvjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEE, _tt_cmap14_char_var_index: _tt_cmap14_char_var_index, __Z48setPxVehicleTireLoadFilterDataMMaxNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf: __Z48setPxVehicleTireLoadFilterDataMMaxNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, _psh_globals_new: _psh_globals_new, __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIN16GeometryJobTasks15GeometryJobTaskELj4EE18resize_initializedEjRKS1_12ResizePolicy, __ZN5physx37PxJointLimitParametersGeneratedValuesC2EPKNS_22PxJointLimitParametersE: __ZN5physx37PxJointLimitParametersGeneratedValuesC2EPKNS_22PxJointLimitParametersE, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13setBreakForceEff, _getnetbyname: _getnetbyname, __ZN9GfxDevice20SetMaxBufferedFramesEi: __ZN9GfxDevice20SetMaxBufferedFramesEi, __ZNK7Terrain12SampleHeightE8Vector3f: __ZNK7Terrain12SampleHeightE8Vector3f, __Z45Register_UnityEngine_Mathf_GammaToLinearSpacev: __Z45Register_UnityEngine_Mathf_GammaToLinearSpacev, __ZN10Collider2D19WakeAllBodyContactsEv: __ZN10Collider2D19WakeAllBodyContactsEv, __ZNK19VREyeTextureManager22GetDeviceTextureFormatEv: __ZNK19VREyeTextureManager22GetDeviceTextureFormatEv, __Z34NavMeshAgent_Get_Custom_PropHeightP12Il2CppObject: __Z34NavMeshAgent_Get_Custom_PropHeightP12Il2CppObject, __ZNK5Umbra10Visibility15getOutputBufferEv: __ZNK5Umbra10Visibility15getOutputBufferEv, __ZN24AudioScriptBufferManagerD2Ev: __ZN24AudioScriptBufferManagerD2Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE8pushNameEPKc, __Z23ConvertIntegerToTypePtrIsEbPvR14SafeBinaryRead: __Z23ConvertIntegerToTypePtrIsEbPvR14SafeBinaryRead, __ZNK5physx2Cm10Collection4findEy: __ZNK5physx2Cm10Collection4findEy, __ZN12b2MouseJoint11ShiftOriginERK6b2Vec2: __ZN12b2MouseJoint11ShiftOriginERK6b2Vec2, __ZN12SocketStream4SendEPKvj: __ZN12SocketStream4SendEPKvj, __ZN5physx15computeTankDiffEffjPKbPfS2_S2_: __ZN5physx15computeTankDiffEffjPKbPfS2_S2_, __ZNK5physx14NpArticulation17releaseDriveCacheERNS_24PxArticulationDriveCacheE: __ZNK5physx14NpArticulation17releaseDriveCacheERNS_24PxArticulationDriveCacheE, __ZN18AwakeFromLoadQueue5ClearEv: __ZN18AwakeFromLoadQueue5ClearEv, __ZNSt3__26vectorI13dynamic_arrayI21TreePrototypeColliderLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEjRKS3_: __ZNSt3__26vectorI13dynamic_arrayI21TreePrototypeColliderLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEjRKS3_, __ZN15AudioMixerGroup23VirtualRedirectTransferER14SafeBinaryRead: __ZN15AudioMixerGroup23VirtualRedirectTransferER14SafeBinaryRead, __Z13RegisterClassI14BillboardAssetEvv: __Z13RegisterClassI14BillboardAssetEvv, __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx18collideWithCapsuleERNS_19PxsParticleCollDataERKNS_17PxCapsuleGeometryEf: __ZN5physx18collideWithCapsuleERNS_19PxsParticleCollDataERKNS_17PxCapsuleGeometryEf, __ZN6prcoreL29inner_stretch_rgb565_bilinearEPKNS_9InnerInfoE: __ZN6prcoreL29inner_stretch_rgb565_bilinearEPKNS_9InnerInfoE, __ZNK5physx2Sc9ClothCore25getSelfCollisionStiffnessEv: __ZNK5physx2Sc9ClothCore25getSelfCollisionStiffnessEv, __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_S6_T_, __ZN15NavMeshObstacle11UpdateStateEv: __ZN15NavMeshObstacle11UpdateStateEv, __Z36setPxMaterial_RestitutionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE: __Z36setPxMaterial_RestitutionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE, __ZN4FMOD7SystemI13set3DSettingsEfff: __ZN4FMOD7SystemI13set3DSettingsEfff, __ZNK5physx23PxVehicleSuspensionData7isValidEv: __ZNK5physx23PxVehicleSuspensionData7isValidEv, __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority: __Z32ScheduleJobForEachJobSetInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority, __ZNK14RenderSettings19GetFlatAmbientColorEv: __ZNK14RenderSettings19GetFlatAmbientColorEv, __ZN5physx7profile15ZoneManagerImpl24removeProfileZoneHandlerERNS_20PxProfileZoneHandlerE: __ZN5physx7profile15ZoneManagerImpl24removeProfileZoneHandlerERNS_20PxProfileZoneHandlerE, __Z60Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplv: __Z60Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags, __ZN16PlayerConnection21ConstructWhoamiStringEv: __ZN16PlayerConnection21ConstructWhoamiStringEv, __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj: __Z19CalculateVertexSizejRK20VertexChannelsLayoutPj, __ZN5physx7profile15ZoneManagerImpl7releaseEv: __ZN5physx7profile15ZoneManagerImpl7releaseEv, __Z51Register_UnityEngine_PhysicsMaterial2D_set_frictionv: __Z51Register_UnityEngine_PhysicsMaterial2D_set_frictionv, __Z40Register_UnityEngine_Transform_SetParentv: __Z40Register_UnityEngine_Transform_SetParentv, __ZN29DelayedPointerDeletionManager29AddPointerToMainThreadDeallocEPv: __ZN29DelayedPointerDeletionManager29AddPointerToMainThreadDeallocEPv, __Z53Register_UnityEngine_TrailRenderer_get_numCapVerticesv: __Z53Register_UnityEngine_TrailRenderer_get_numCapVerticesv, __Z84Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorv: __Z84Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorv, __Z54Register_UnityEngine_ReflectionProbe_set_boxProjectionv: __Z54Register_UnityEngine_ReflectionProbe_set_boxProjectionv, __ZN14Texture2DArray17UploadToGfxDeviceEv: __ZN14Texture2DArray17UploadToGfxDeviceEv, __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_, __Z14FMODMemoryFreePvjPKc: __Z14FMODMemoryFreePvjPKc, __ZN4FMOD5Sound6getTagEPKciP8FMOD_TAG: __ZN4FMOD5Sound6getTagEPKciP8FMOD_TAG, __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEED0Ev, _UNITY_FT_Reference_Library: _UNITY_FT_Reference_Library, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj6ENS_22PxRepXPropertyAccessorILj6ES4_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj6ENS_22PxRepXPropertyAccessorILj6ES4_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESC_EEEEvRKT0_, __ZN12NavMeshAgent10SmartResetEv: __ZN12NavMeshAgent10SmartResetEv, __ZN5physx29BroadPhaseBatchUpdateWorkTaskD0Ev: __ZN5physx29BroadPhaseBatchUpdateWorkTaskD0Ev, _cf2_glyphpath_moveTo: _cf2_glyphpath_moveTo, __ZN15ResourceManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15ResourceManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx3Scb4Body9syncStateEv: __ZN5physx3Scb4Body9syncStateEv, __ZN13SparseTextureC2E10MemLabelId18ObjectCreationMode: __ZN13SparseTextureC2E10MemLabelId18ObjectCreationMode, __ZN13RuntimeStaticI19UnityConnectServiceE16StaticInitializeEPv: __ZN13RuntimeStaticI19UnityConnectServiceE16StaticInitializeEPv, __ZN5physx20SingleAABBUpdateTaskD0Ev: __ZN5physx20SingleAABBUpdateTaskD0Ev, __ZN11OffMeshLink23VirtualRedirectTransferER14SafeBinaryRead: __ZN11OffMeshLink23VirtualRedirectTransferER14SafeBinaryRead, __Z77Register_UnityEngine_AnimatorOverrideController_get_runtimeAnimatorControllerv: __Z77Register_UnityEngine_AnimatorOverrideController_get_runtimeAnimatorControllerv, __ZN5physx12PxsRigidBody23updatePoseDependenciesVERNS_10PxsContextE: __ZN5physx12PxsRigidBody23updatePoseDependenciesVERNS_10PxsContextE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj653ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj653ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu12TriangleMesh4loadERNS_13PxInputStreamE: __ZN5physx2Gu12TriangleMesh4loadERNS_13PxInputStreamE, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputcEc: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputcEc, __Z16getPxShape_FlagsPKN5physx7PxShapeE: __Z16getPxShape_FlagsPKN5physx7PxShapeE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead25ProceduralLoadingBehaviorEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead25ProceduralLoadingBehaviorEvRT_RT0_PKc17TransferMetaFlags, __Z13RegisterClassI19AssetBundleManifestEvv: __Z13RegisterClassI19AssetBundleManifestEvv, __Z21PlayerStartFirstSceneb: __Z21PlayerStartFirstSceneb, __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_: __ZN7mecanim5human10RetargetToEPKNS0_5HumanEPKNS0_9HumanPoseES6_RKN4math4trsXEPS4_PNS_8skeleton13SkeletonPoseTIS8_EESF_, __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf: __ZN7mecanim9animation8SeekClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEf, __ZN12TreeDatabase19RemoveTreePrototypeEi: __ZN12TreeDatabase19RemoveTreePrototypeEi, __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE11getTypeNameEv, __ZN5physx21PxConstraintConnectorD2Ev: __ZN5physx21PxConstraintConnectorD2Ev, __Z46Register_UnityEngine_Rigidbody_get_constraintsv: __Z46Register_UnityEngine_Rigidbody_get_constraintsv, __Z53ParticleSystem_LightsModule_CUSTOM_SetRangeMultiplierP12Il2CppObjectf: __Z53ParticleSystem_LightsModule_CUSTOM_SetRangeMultiplierP12Il2CppObjectf, __ZN24CompressedAnimationCurveaSERKS_: __ZN24CompressedAnimationCurveaSERKS_, __ZN14AreaEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14AreaEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode, _ft_var_readpackeddeltas: _ft_var_readpackeddeltas, __ZN6Object15ClassIDToStringEi: __ZN6Object15ClassIDToStringEi, __Z18Transfer_BlittableI9JSONWriteLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9Heightmap16CheckConsistencyEv: __ZN9Heightmap16CheckConsistencyEv, __Z24RegisterStrippedTypeInfoI30RuntimeInitializeOnLoadManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI30RuntimeInitializeOnLoadManagerEviPKcS2_, __Z22getPxScene_TaskManagerPKN5physx7PxSceneE: __Z22getPxScene_TaskManagerPKN5physx7PxSceneE, __ZNSt3__217moneypunct_bynameIwLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__217moneypunct_bynameIwLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __Z24RegisterStrippedTypeInfoIN2UI11CanvasGroupEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN2UI11CanvasGroupEEviPKcS3_, __Z43Register_UnityEngine_AI_NavMeshAgent_Resumev: __Z43Register_UnityEngine_AI_NavMeshAgent_Resumev, __Z52Register_UnityEngine_AssetBundle_LoadFromMemoryAsyncv: __Z52Register_UnityEngine_AssetBundle_LoadFromMemoryAsyncv, __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbRK16BlendShapeVertexS3_EPS1_EEvT0_S8_T_, __ZN5physx8debugger4comm12ErrorMessage9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm12ErrorMessage9serializeERNS1_15EventSerializerE, __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef: __Z35GetTextureDecodeValuesWithIntensity16TextureUsageMode17TextureColorSpace10ColorSpacef, __ZNK12CullingGroup9IsVisibleEj: __ZNK12CullingGroup9IsVisibleEj, __Z40Register_UnityEngine_Animation_IsPlayingv: __Z40Register_UnityEngine_Animation_IsPlayingv, __ZNK5physx7NpShape16getContactOffsetEv: __ZNK5physx7NpShape16getContactOffsetEv, __Z48Register_UnityEngine_AI_OffMeshLink_get_occupiedv: __Z48Register_UnityEngine_AI_OffMeshLink_get_occupiedv, __Z28getPxVehicleWheelDataMRadiusPKN5physx18PxVehicleWheelDataE: __Z28getPxVehicleWheelDataMRadiusPKN5physx18PxVehicleWheelDataE, __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx14PxsAABBManager21processAggregatePairsEPKNS_19AggregateSortedDataE: __ZN5physx14PxsAABBManager21processAggregatePairsEPKNS_19AggregateSortedDataE, __ZNK12b2MouseJoint10GetAnchorAEv: __ZNK12b2MouseJoint10GetAnchorAEv, _PxCreateCooking: _PxCreateCooking, __ZNK21ExecutionOrderManager27GetDefaultExecutionOrderForEPKN5Unity4TypeE: __ZNK21ExecutionOrderManager27GetDefaultExecutionOrderForEPKN5Unity4TypeE, __Z31getPxAggregate_ConcreteTypeNamePKN5physx11PxAggregateE: __Z31getPxAggregate_ConcreteTypeNamePKN5physx11PxAggregateE, __ZN14SafeBinaryRead20OverrideRootTypeNameEPKc: __ZN14SafeBinaryRead20OverrideRootTypeNameEPKc, __ZN18ProceduralMaterial22CacheSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN18ProceduralMaterial22CacheSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZN9InputAxis7SetNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9InputAxis7SetNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN14FileCacherRead16UnlockCacheBlockEj: __ZN14FileCacherRead16UnlockCacheBlockEj, __ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu24contactConvexHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z47QualitySettings_Get_Custom_PropShadowProjectionv: __Z47QualitySettings_Get_Custom_PropShadowProjectionv, __Z43TerrainData_CUSTOM_RecalculateTreePositionsP12Il2CppObject: __Z43TerrainData_CUSTOM_RecalculateTreePositionsP12Il2CppObject, __ZN26AnimatorOverrideController8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN26AnimatorOverrideController8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatStringv: __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatStringv, __ZNK5physx12NpBatchQuery23getFilterShaderDataSizeEv: __ZNK5physx12NpBatchQuery23getFilterShaderDataSizeEv, __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_set_sizev: __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_set_sizev, __ZN18GfxFramebufferGLES25GetPendingFramebufferNameEv: __ZN18GfxFramebufferGLES25GetPendingFramebufferNameEv, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEEC2EPNS0_7SystemIEi: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEEC2EPNS0_7SystemIEi, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS0_9allocatorIS4_EEEEEvRT_j, ___fsetlocking: ___fsetlocking, __ZNK12StatusHelper13GetStatusCodeEv: __ZNK12StatusHelper13GetStatusCodeEv, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_17RelativeStopEventEEEvhtRKT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_17RelativeStopEventEEEvhtRKT_, __Z20ParseImageParametersR11UTF16StringRiRN20TextRenderingPrivate16TextFormatChangeE: __Z20ParseImageParametersR11UTF16StringRiRN20TextRenderingPrivate16TextFormatChangeE, __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, _gzeof: _gzeof, __Z49DownloadHandlerAudioClip_Get_Custom_PropAudioClipP12Il2CppObject: __Z49DownloadHandlerAudioClip_Get_Custom_PropAudioClipP12Il2CppObject, __Z39getPxRigidDynamic_SolverIterationCountsPKN5physx14PxRigidDynamicERjS3_: __Z39getPxRigidDynamic_SolverIterationCountsPKN5physx14PxRigidDynamicERjS3_, __ZN13MonoBehaviour9CallAwakeEv: __ZN13MonoBehaviour9CallAwakeEv, __ZN5physx2Sc19ShapeInstancePairLL23postIslandGenSecondPassEv: __ZN5physx2Sc19ShapeInstancePairLL23postIslandGenSecondPassEv, __Z32AndroidJNI_CUSTOM_GetDoubleField13Il2Cpp_IntPtrS_: __Z32AndroidJNI_CUSTOM_GetDoubleField13Il2Cpp_IntPtrS_, __ZN5physx3Cct26CharacterControllerManager16createControllerERKNS_16PxControllerDescE: __ZN5physx3Cct26CharacterControllerManager16createControllerERKNS_16PxControllerDescE, __ZN17SurfaceEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17SurfaceEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9ShaderLab16SerializedTagMapaSERKS0_: __ZN9ShaderLab16SerializedTagMapaSERKS0_, __Z55Register_UnityEngine_Animation_set_animateOnlyIfVisiblev: __Z55Register_UnityEngine_Animation_set_animateOnlyIfVisiblev, __ZN5physx26PxPhysicsInsertionCallbackD2Ev: __ZN5physx26PxPhysicsInsertionCallbackD2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN8Material28ApplyMaterialPropertyDrawersEv: __ZN8Material28ApplyMaterialPropertyDrawersEv, __ZN5physx2Sq16BucketPrunerCore12updateObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE: __ZN5physx2Sq16BucketPrunerCore12updateObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE, __ZN5physx18PxsDynamicsContext23atomIntegrationParallelEfPKPNS_11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPSA_RjSI_RNS_10PxBaseTaskE: __ZN5physx18PxsDynamicsContext23atomIntegrationParallelEfPKPNS_11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPSA_RjSI_RNS_10PxBaseTaskE, __ZN9Projector8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Projector8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN2UI14CanvasRenderer11GetSyncFlagEv: __ZN2UI14CanvasRenderer11GetSyncFlagEv, __ZN11UnityEngine9Animation27CreateAvatarBindingConstantER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE: __ZN11UnityEngine9Animation27CreateAvatarBindingConstantER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __Z43RenderSettings_Set_Custom_PropFlareStrengthf: __Z43RenderSettings_Set_Custom_PropFlareStrengthf, __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform: __ZN9BlobWriteC2ER13dynamic_arrayIhLj16EE24TransferInstructionFlags19BuildTargetPlatform, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE13isSubordinateEv, __ZN14MessageHandler3GetEv: __ZN14MessageHandler3GetEv, __ZNSt10bad_typeidD2Ev: __ZNSt10bad_typeidD2Ev, __Z49NavMeshAgent_Get_Custom_PropObstacleAvoidanceTypeP12Il2CppObject: __Z49NavMeshAgent_Get_Custom_PropObstacleAvoidanceTypeP12Il2CppObject, __ZL24AssignProjectorQueuesJobP30AssignProjectorQueuesJobHeader: __ZL24AssignProjectorQueuesJobP30AssignProjectorQueuesJobHeader, __Z16tesedgeIntersectP10TESSvertexS0_S0_S0_S0_: __Z16tesedgeIntersectP10TESSvertexS0_S0_S0_S0_, __ZN13UnityProfiler19RecordPreviousFrameE12ProfilerMode: __ZN13UnityProfiler19RecordPreviousFrameE12ProfilerMode, __ZN12TreeDatabase8TransferI14SafeBinaryReadEEvRT_: __ZN12TreeDatabase8TransferI14SafeBinaryReadEEvRT_, __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData: __Z40DebugStringToFilePostprocessedStacktraceRK21DebugStringToFileData, __ZN5IMGUI19NamedKeyControlList15AddNamedControlERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEii: __ZN5IMGUI19NamedKeyControlList15AddNamedControlERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEii, __ZN21AudioDistortionFilter12AddToManagerEv: __ZN21AudioDistortionFilter12AddToManagerEv, __Z42Animator_CUSTOM_INTERNAL_get_deltaPositionP12Il2CppObjectP8Vector3f: __Z42Animator_CUSTOM_INTERNAL_get_deltaPositionP12Il2CppObjectP8Vector3f, __ZN5physx2Gu19GetRaycastFuncTableEv: __ZN5physx2Gu19GetRaycastFuncTableEv, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __Z27GetDeepFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_: __Z27GetDeepFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_, __Z49Register_UnityEngine_MeshCollider_get_inflateMeshv: __Z49Register_UnityEngine_MeshCollider_get_inflateMeshv, __Z44getPxVehicleWheelsSimData_ThresholdLongSpeedPKN5physx22PxVehicleWheelsSimDataE: __Z44getPxVehicleWheelsSimData_ThresholdLongSpeedPKN5physx22PxVehicleWheelsSimDataE, _Write_CVT: _Write_CVT, __Z18Transfer_BlittableI14SafeBinaryReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK13EmscriptenWWW6GetUrlEv: __ZNK13EmscriptenWWW6GetUrlEv, __ZN13BoxCollider2D16CheckConsistencyEv: __ZN13BoxCollider2D16CheckConsistencyEv, __ZN5physx17EdgeChangeManager23cleanupBrokenEdgeEventsEPKNS_4EdgeE: __ZN5physx17EdgeChangeManager23cleanupBrokenEdgeEventsEPKNS_4EdgeE, __Z21BeginSplashScreenFadev: __Z21BeginSplashScreenFadev, _tlsf_walk_heap: _tlsf_walk_heap, __ZN19VREyeTextureManagerD2Ev: __ZN19VREyeTextureManagerD2Ev, __ZN9Animation23ClearContainedRenderersEv: __ZN9Animation23ClearContainedRenderersEv, __ZN3MBP12updateObjectEjP9BoxPruner: __ZN3MBP12updateObjectEjP9BoxPruner, __Z11SetActuatorij: __Z11SetActuatorij, __ZNK20UnityConnectSettings25IsConnectServiceAvailableEv: __ZNK20UnityConnectSettings25IsConnectServiceAvailableEv, __ZN11UnityEngine15PlatformWrapper17IsUnityAdsEnabledEv: __ZN11UnityEngine15PlatformWrapper17IsUnityAdsEnabledEv, __ZN19CharacterController13GetStepOffsetEv: __ZN19CharacterController13GetStepOffsetEv, __Z54Register_UnityEngine_ParticleEmitter_set_useWorldSpacev: __Z54Register_UnityEngine_ParticleEmitter_set_useWorldSpacev, __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout: __ZN14VertexDataInfo13UpdateStreamsEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout, __ZN12ServerSocket14StartListeningEPKctb: __ZN12ServerSocket14StartListeningEPKctb, __Z38Register_UnityEngine_TextMesh_get_fontv: __Z38Register_UnityEngine_TextMesh_get_fontv, __ZN20TextRenderingPrivate8FontImpl12SetFontNamesERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE: __ZN20TextRenderingPrivate8FontImpl12SetFontNamesERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE, __ZN5physx13NpVolumeCacheD2Ev: __ZN5physx13NpVolumeCacheD2Ev, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9getHandleEPKc: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9getHandleEPKc, _encode_mcu_huff: _encode_mcu_huff, __Z50Register_UnityEngine_CullingGroup_set_targetCamerav: __Z50Register_UnityEngine_CullingGroup_set_targetCamerav, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_, __ZN12TLSAllocatorI14StackAllocatorE16ThreadInitializeEP13BaseAllocator: __ZN12TLSAllocatorI14StackAllocatorE16ThreadInitializeEP13BaseAllocator, __ZN12AudioManager16RemoveAudioMixerEP10AudioMixer: __ZN12AudioManager16RemoveAudioMixerEP10AudioMixer, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv, __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplEED0Ev: __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplEED0Ev, __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z46Register_UnityEngine_AndroidJNI_CallByteMethodv: __Z46Register_UnityEngine_AndroidJNI_CallByteMethodv, __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj: __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj, __Z43Avatar_CUSTOM_INTERNAL_CALL_GetPostRotationP12Il2CppObjectiR11Quaternionf: __Z43Avatar_CUSTOM_INTERNAL_CALL_GetPostRotationP12Il2CppObjectiR11Quaternionf, __ZN17PolygonCollider2DC2E10MemLabelId18ObjectCreationMode: __ZN17PolygonCollider2DC2E10MemLabelId18ObjectCreationMode, __Z19sweepBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z19sweepBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __Z41CanvasRenderer_CUSTOM_DisableRectClippingP12Il2CppObject: __Z41CanvasRenderer_CUSTOM_DisableRectClippingP12Il2CppObject, __ZNK14DirectorPlayer7GetTimeEv: __ZNK14DirectorPlayer7GetTimeEv, __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE: __ZN5physx16PxsThreadContextC2EPNS_10PxsContextE, __ZNKSt3__27codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_: __ZNKSt3__27codecvtIwc11__mbstate_tE6do_outERS1_PKwS5_RS5_PcS7_RS7_, __ZN11AudioModule12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE: __ZN11AudioModule12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE, __Z39setPxD6Joint_ProjectionAngularTolerancePN5physx9PxD6JointEf: __Z39setPxD6Joint_ProjectionAngularTolerancePN5physx9PxD6JointEf, __ZN25SingleBlockMemoryFileDataD0Ev: __ZN25SingleBlockMemoryFileDataD0Ev, __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN8WindZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8WindZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z15UnloadGameScenev: __Z15UnloadGameScenev, __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE7reserveEj: __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE7reserveEj, __ZN20TextRenderingPrivate22ScriptingTextGenerator13GetTextOffsetERK8Vector2fRK5RectTIfEiS3_b: __ZN20TextRenderingPrivate22ScriptingTextGenerator13GetTextOffsetERK8Vector2fRK5RectTIfEiS3_b, __ZNK16BaseVideoTexture12GetDataWidthEv: __ZNK16BaseVideoTexture12GetDataWidthEv, __ZN16HeightMeshBVNode8TransferI14SafeBinaryReadEEvRT_: __ZN16HeightMeshBVNode8TransferI14SafeBinaryReadEEvRT_, __Z50Register_UnityEngine_FrictionJoint2D_get_maxTorquev: __Z50Register_UnityEngine_FrictionJoint2D_get_maxTorquev, __Z32AudioSource_Get_Custom_PropPitchP12Il2CppObject: __Z32AudioSource_Get_Custom_PropPitchP12Il2CppObject, __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN2UI6Canvas18RemoveNestedCanvasEPS0_: __ZN2UI6Canvas18RemoveNestedCanvasEPS0_, __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI19ComputeShaderKernelNS0_9allocatorIS2_EEEEEvRT_j, __Z31CalculateHierarchyTransformType23TransformAccessReadOnly: __Z31CalculateHierarchyTransformType23TransformAccessReadOnly, __Z41Texture2D_CUSTOM_INTERNAL_CALL_ReadPixelsP12Il2CppObjectRK5RectTIfEiih: __Z41Texture2D_CUSTOM_INTERNAL_CALL_ReadPixelsP12Il2CppObjectRK5RectTIfEiih, __Z13RegisterClassI11TimeManagerEvv: __Z13RegisterClassI11TimeManagerEvv, __ZN4FMOD8ChannelI11setPositionEjj: __ZN4FMOD8ChannelI11setPositionEjj, __Z40Register_UnityEngine_TextMesh_get_anchorv: __Z40Register_UnityEngine_TextMesh_get_anchorv, __ZN11UnityEngine15CloudWebService16SessionContainer27GetDeleteErrorJsonDataBlockERK8UnityStrS4_RS2_: __ZN11UnityEngine15CloudWebService16SessionContainer27GetDeleteErrorJsonDataBlockERK8UnityStrS4_RS2_, __ZN10Collider2D12SetPolygon2DEP9Polygon2D: __ZN10Collider2D12SetPolygon2DEP9Polygon2D, __ZN5Umbra11ShadowUtils22normalizePlaneEquationERKNS_7Vector4E: __ZN5Umbra11ShadowUtils22normalizePlaneEquationERKNS_7Vector4E, __ZN2UI13CanvasManager18WillRenderCanvasesEv: __ZN2UI13CanvasManager18WillRenderCanvasesEv, __ZN12PhysXRaycast12CleanupClassEv: __ZN12PhysXRaycast12CleanupClassEv, __Z50Register_UnityEngine_AI_NavMeshObstacle_set_radiusv: __Z50Register_UnityEngine_AI_NavMeshObstacle_set_radiusv, __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5Umbra9Matrix4x45scaleERKNS_7Vector3E: __ZN5Umbra9Matrix4x45scaleERKNS_7Vector3E, __ZN17BaseObjectManager13StaticDestroyEPv: __ZN17BaseObjectManager13StaticDestroyEPv, __ZNK20TextRenderingPrivate8FontImpl22GetFontSizeFromSpacingEf: __ZNK20TextRenderingPrivate8FontImpl22GetFontSizeFromSpacingEf, __Z40TrailRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode: __Z40TrailRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode, __ZNK29LineParametersPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK29LineParametersPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __Z53Register_UnityEngine_GUI_INTERNAL_get_backgroundColorv: __Z53Register_UnityEngine_GUI_INTERNAL_get_backgroundColorv, __ZN18PlayableController18DoesPlayableExistsEPK8Playable: __ZN18PlayableController18DoesPlayableExistsEPK8Playable, __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj: __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_Rj, __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEEC2INS_11__wrap_iterIPS2_EEEET_SB_RKS5_PNS_9enable_ifIXaasr21__is_forward_iteratorISB_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeE: __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEEC2INS_11__wrap_iterIPS2_EEEET_SB_RKS5_PNS_9enable_ifIXaasr21__is_forward_iteratorISB_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeE, __ZN12AudioManager14UpdateListenerERK8Vector3fS2_S2_S2_: __ZN12AudioManager14UpdateListenerERK8Vector3fS2_S2_S2_, __ZN5physx2Cm8PtrTableC2Ev: __ZN5physx2Cm8PtrTableC2Ev, __ZN17BufferManagerGLES16GetTotalFreeSizeEv: __ZN17BufferManagerGLES16GetTotalFreeSizeEv, __Z22setPxCloth_WakeCounterPN5physx7PxClothEf: __Z22setPxCloth_WakeCounterPN5physx7PxClothEf, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getRestitutionEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getRestitutionEv, _jsimd_can_h2v2_merged_upsample: _jsimd_can_h2v2_merged_upsample, __ZN5physx16PxsBroadPhaseMBP6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE: __ZN5physx16PxsBroadPhaseMBP6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE, __ZN5physx9NpPhysics18createRigidDynamicERKNS_11PxTransformE: __ZN5physx9NpPhysics18createRigidDynamicERKNS_11PxTransformE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE15growAndPushBackERKS2_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE12readPropertyIfEEbRT_, __ZN5physx15NpParticleFluid12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx15NpParticleFluid12createObjectERPhRNS_24PxDeserializationContextE, _finite: _finite, __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11AudioFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z18ExtractTagThrowingR11ICallString: __Z18ExtractTagThrowingR11ICallString, __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI6ShaderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdatePlayerCleanupCachedDatastruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdatePlayerCleanupCachedDatastruct7ForwardEv, __ZN5physx2Gu17intersectRayAABB2ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RKNS2_6FloatVERS6_S9_: __ZN5physx2Gu17intersectRayAABB2ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RKNS2_6FloatVERS6_S9_, __Z34CanvasRenderer_Get_Custom_PropCullP12Il2CppObject: __Z34CanvasRenderer_Get_Custom_PropCullP12Il2CppObject, __ZNK5physx7NpShape17getSphereGeometryERNS_16PxSphereGeometryE: __ZNK5physx7NpShape17getSphereGeometryERNS_16PxSphereGeometryE, __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults: __ZL18intersectAnyVsMeshILi1EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults, __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEvRT_j, __ZN15SharedLightDataC2E10MemLabelId: __ZN15SharedLightDataC2E10MemLabelId, __Z45GIDebugVisualisation_Get_Custom_PropCycleModev: __Z45GIDebugVisualisation_Get_Custom_PropCycleModev, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEE15growAndPushBackERKS2_, __ZN5Umbra15CameraTransform16setWorldToCameraERKNS_9Matrix4x4E: __ZN5Umbra15CameraTransform16setWorldToCameraERKNS_9Matrix4x4E, __ZN6Camera6SetFarEf: __ZN6Camera6SetFarEf, __Z45Register_UnityEngine_Light_INTERNAL_set_colorv: __Z45Register_UnityEngine_Light_INTERNAL_set_colorv, __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE: __ZNK17AnimationCurveTplI11QuaternionfE13EvaluateClampEfPNS1_5CacheE, __ZN6prcoreL12RemapGenericI17TexFormatABGR888817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatABGR888817TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN11GameManager17MainThreadCleanupEv: __ZN11GameManager17MainThreadCleanupEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z40Register_UnityEngine_Compass_get_enabledv: __Z40Register_UnityEngine_Compass_get_enabledv, __Z51Register_UnityEngine_MaterialPropertyBlock_SetFloatv: __Z51Register_UnityEngine_MaterialPropertyBlock_SetFloatv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE19getConcreteTypeNameEv, __ZN12TreeRenderer21ComputeWindPropertiesEib: __ZN12TreeRenderer21ComputeWindPropertiesEib, __ZN5Umbra9RasterOps13rasterizeQuadERNS_17BlockRasterBufferERKNS_8Vector4iERKS1_: __ZN5Umbra9RasterOps13rasterizeQuadERNS_17BlockRasterBufferERKNS_8Vector4iERKS1_, __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_rotationv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_rotationv, __ZN10Collider2D12AddToManagerEv: __ZN10Collider2D12AddToManagerEv, __ZN14ParticleSystem10ResetSeedsEv: __ZN14ParticleSystem10ResetSeedsEv, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE7copyfmtERKS3_: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE7copyfmtERKS3_, __ZNK5physx7NpCloth24getParticleAccelerationsEPNS_6PxVec4E: __ZNK5physx7NpCloth24getParticleAccelerationsEPNS_6PxVec4E, _UNITY_tt_slot_init: _UNITY_tt_slot_init, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataEv: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataEv, __ZN9GfxDevice20DestroyRenderSurfaceER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE: __ZN9GfxDevice20DestroyRenderSurfaceER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE, __ZL24PrepareSpriteRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext: __ZL24PrepareSpriteRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z38HingeJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D: __Z38HingeJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D, __ZN9GfxDevice22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_: __ZN9GfxDevice22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_, __ZN12_GLOBAL__N_15qAsinEff: __ZN12_GLOBAL__N_15qAsinEff, _UNITY_png_set_text_compression_level: _UNITY_png_set_text_compression_level, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZN12TLSAllocatorI14StackAllocatorE13ThreadCleanupEv: __ZN12TLSAllocatorI14StackAllocatorE13ThreadCleanupEv, __Z43NavMeshAgent_Get_Custom_PropIsOnOffMeshLinkP12Il2CppObject: __Z43NavMeshAgent_Get_Custom_PropIsOnOffMeshLinkP12Il2CppObject, __Z18GetAudioManagerPtrv: __Z18GetAudioManagerPtrv, __Z40CollectObjectHierarchyWithHideFlagFilterR10GameObjectiRNSt3__26vectorIP6ObjectNS1_9allocatorIS4_EEEE: __Z40CollectObjectHierarchyWithHideFlagFilterR10GameObjectiRNSt3__26vectorIP6ObjectNS1_9allocatorIS4_EEEE, __Z13RegisterClassI15AnchoredJoint2DEvv: __Z13RegisterClassI15AnchoredJoint2DEvv, __ZN4Mesh27SwizzleVertexColorsIfNeededEb: __ZN4Mesh27SwizzleVertexColorsIfNeededEb, __Z27FindActiveTransformWithPathPKc: __Z27FindActiveTransformWithPathPKc, __Z45Register_UnityEngine_Camera_INTERNAL_set_rectv: __Z45Register_UnityEngine_Camera_INTERNAL_set_rectv, __Z46ParticleSystem_TriggerModule_CUSTOM_SetOutsideP12Il2CppObjecti: __Z46ParticleSystem_TriggerModule_CUSTOM_SetOutsideP12Il2CppObjecti, __ZN5physx16PxsIslandManager14setEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_17PxsContactManagerE: __ZN5physx16PxsIslandManager14setEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_17PxsContactManagerE, __ZNK5physx2Sc9ClothCore10isSleepingEv: __ZNK5physx2Sc9ClothCore10isSleepingEv, __ZN12BaseRendererD0Ev: __ZN12BaseRendererD0Ev, __Z29StdTemplateConversionFunctionIbyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbyEbPvR14SafeBinaryRead, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3eofEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3eofEv, __ZN5physx14NpArticulation25setStabilizationThresholdEf: __ZN5physx14NpArticulation25setStabilizationThresholdEf, __ZN5physx2Gu11HeightField7releaseEv: __ZN5physx2Gu11HeightField7releaseEv, __ZNK6Camera7GetNearEv: __ZNK6Camera7GetNearEv, __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_get_sizev: __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_get_sizev, __ZN7ApiGLES11UnmapBufferEjN2gl12BufferTargetE: __ZN7ApiGLES11UnmapBufferEjN2gl12BufferTargetE, __Z25GetNextAllowedTextureSizeib13TextureFormat: __Z25GetNextAllowedTextureSizeib13TextureFormat, __ZN13AnimationClip21UpdateMuscleClipRangeEv: __ZN13AnimationClip21UpdateMuscleClipRangeEv, __ZNKSt3__217moneypunct_bynameIcLb1EE11do_groupingEv: __ZNKSt3__217moneypunct_bynameIcLb1EE11do_groupingEv, __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN19CloudServiceHandler6RetainEv: __ZN19CloudServiceHandler6RetainEv, __ZN15b2FrictionJointD0Ev: __ZN15b2FrictionJointD0Ev, __ZN5physx8debugger4comm13SetIsTopLevelD0Ev: __ZN5physx8debugger4comm13SetIsTopLevelD0Ev, __Z34AudioListener_Set_Custom_PropPauseh: __Z34AudioListener_Set_Custom_PropPauseh, __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData: __ZN12BaseRenderer20FlattenToRenderQueueER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physx2Sc8ClothSim23addCollisionHeightfieldEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim23addCollisionHeightfieldEPKNS0_8ShapeSimE, __Z40ParticleEmitter_Set_Custom_PropParticlesP12Il2CppObjectP11Il2CppArray: __Z40ParticleEmitter_Set_Custom_PropParticlesP12Il2CppObjectP11Il2CppArray, __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_boundsGlobalv: __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_boundsGlobalv, __Z34scripting_liveness_calculation_endPv: __Z34scripting_liveness_calculation_endPv, __ZN12MeshCollider19ExtractMeshGeometryER8Vector3f: __ZN12MeshCollider19ExtractMeshGeometryER8Vector3f, __ZN12ScriptMapper16AddBuiltinShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI6ShaderE: __ZN12ScriptMapper16AddBuiltinShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI6ShaderE, __Z43AudioReverbZone_Get_Custom_PropReverbPresetP12Il2CppObject: __Z43AudioReverbZone_Get_Custom_PropReverbPresetP12Il2CppObject, __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z59Register_UnityEngine_ReflectionProbe_set_customBakedTexturev: __Z59Register_UnityEngine_ReflectionProbe_set_customBakedTexturev, __ZZN6Camera15InitializeClassEvEN31FunctorImpl_99kTransformChanged4CallEPviR11MessageData: __ZZN6Camera15InitializeClassEvEN31FunctorImpl_99kTransformChanged4CallEPviR11MessageData, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv, __Z18Transfer_BlittableI8JSONReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18ProceduralMaterial7SetDataERK22ProceduralMaterialData: __ZN18ProceduralMaterial7SetDataERK22ProceduralMaterialData, _ctan: _ctan, _log2: _log2, __ZN4FMOD7SystemI21getMasterChannelGroupEPPNS_12ChannelGroupE: __ZN4FMOD7SystemI21getMasterChannelGroupEPPNS_12ChannelGroupE, _Render_Single_Pass: _Render_Single_Pass, __Z13TransferFieldI18StreamedBinaryReadILb1EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI18StreamedBinaryReadILb1EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __Z34Material_CUSTOM_GetMatrixArrayImplP12Il2CppObjecti: __Z34Material_CUSTOM_GetMatrixArrayImplP12Il2CppObjecti, __ZNK5physx22PxVehicleWheelsSimData11getTireDataEj: __ZNK5physx22PxVehicleWheelsSimData11getTireDataEj, __ZN5physx13GuMeshFactory16createConvexMeshERNS_13PxInputStreamE: __ZN5physx13GuMeshFactory16createConvexMeshERNS_13PxInputStreamE, __ZN20OcclusionCullingData15ThreadedCleanupEv: __ZN20OcclusionCullingData15ThreadedCleanupEv, __ZN7mecanim8skeleton30SkeletonBuildReverseIndexArrayEPiPKiPKNS0_8SkeletonES6_: __ZN7mecanim8skeleton30SkeletonBuildReverseIndexArrayEPiPKiPKNS0_8SkeletonES6_, __ZNK16ParticleAnimator29WillAutoDestructIfNoParticlesERK19PrivateParticleInfo: __ZNK16ParticleAnimator29WillAutoDestructIfNoParticlesERK19PrivateParticleInfo, __Z19GetGUIBlendMaterialv: __Z19GetGUIBlendMaterialv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z24CollectLevelGameManagersR13dynamic_arrayIiLj4EEb: __Z24CollectLevelGameManagersR13dynamic_arrayIiLj4EEb, __ZN5physx14SapPairManager12shrinkMemoryEv: __ZN5physx14SapPairManager12shrinkMemoryEv, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcb: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcb, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags, __ZN22BaseUnityConnectClient12IsNewSessionEv: __ZN22BaseUnityConnectClient12IsNewSessionEv, __ZNK5physx30PxCapsuleGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEEEEEjT_j: __ZNK5physx30PxCapsuleGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEEEEEjT_j, __ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags: __ZN15FileSystemEntry4MoveERS_23FileSystemCopyMoveFlags, __ZN18AnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18AnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z50Register_UnityEngine_Motion_ValidateIfRetargetablev: __Z50Register_UnityEngine_Motion_ValidateIfRetargetablev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z30getPxVehicleWheelDataMToeAnglePKN5physx18PxVehicleWheelDataE: __Z30getPxVehicleWheelDataMToeAnglePKN5physx18PxVehicleWheelDataE, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE12__move_rangeEPS1_S5_S5_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE12__move_rangeEPS1_S5_S5_, _md5_sum: _md5_sum, __Z24RegisterStrippedTypeInfoI18DelayedCallManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI18DelayedCallManagerEviPKcS2_, __ZN9GfxDevice27SetRandomWriteTargetTextureEi9TextureID: __ZN9GfxDevice27SetRandomWriteTargetTextureEi9TextureID, __ZNK16TypeTreeIterator10ByteOffsetEv: __ZNK16TypeTreeIterator10ByteOffsetEv, __ZNSt3__227__insertion_sort_incompleteIR11NodeYSorterP16HeightMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR11NodeYSorterP16HeightMeshBVNodeEEbT0_S5_T_, __Z33getPxRigidStatic_ConcreteTypeNamePKN5physx13PxRigidStaticE: __Z33getPxRigidStatic_ConcreteTypeNamePKN5physx13PxRigidStaticE, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcj: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcj, __Z30NavMesh_CUSTOM_GetAreaFromNameP12Il2CppString: __Z30NavMesh_CUSTOM_GetAreaFromNameP12Il2CppString, __ZN20GlobalCachingManager15GetCacheIndicesEv: __ZN20GlobalCachingManager15GetCacheIndicesEv, __ZNK14PlayerSettings22GetAutoRotationAllowedEi: __ZNK14PlayerSettings22GetAutoRotationAllowedEi, __ZL34GeomOverlapCallback_CapsuleCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL34GeomOverlapCallback_CapsuleCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z51AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedMethod13Il2Cpp_IntPtrRPv: __Z51AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedMethod13Il2Cpp_IntPtrRPv, __ZNK18ScreenManagerWebGL8GetWidthEv: __ZNK18ScreenManagerWebGL8GetWidthEv, __ZNK5physx7NpScene23getFilterShaderDataSizeEv: __ZNK5physx7NpScene23getFilterShaderDataSizeEv, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKci, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EOS3_: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EOS3_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEE, __ZN7mecanim5human21ComputeHierarchicMassEiPf: __ZN7mecanim5human21ComputeHierarchicMassEiPf, __ZN10SampleClipD2Ev: __ZN10SampleClipD2Ev, __ZN17BillboardRendererD0Ev: __ZN17BillboardRendererD0Ev, __Z40AudioSettings_Set_Custom_PropSpeakerMode16FMOD_SPEAKERMODE: __Z40AudioSettings_Set_Custom_PropSpeakerMode16FMOD_SPEAKERMODE, __ZN10AudioMixer14GetGroupVUInfoERK9UnityGUIDbPN5audio5mixer6VUInfoE: __ZN10AudioMixer14GetGroupVUInfoERK9UnityGUIDbPN5audio5mixer6VUInfoE, __Z13GetGISettingsv: __Z13GetGISettingsv, __ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf: __ZN19SpriteMeshGenerator7contourERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEERiRf, __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetPositionR9HPlayableR8Vector3f: __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetPositionR9HPlayableR8Vector3f, _cff_cmap_unicode_init: _cff_cmap_unicode_init, __Z31Font_CUSTOM_Internal_CreateFontP12Il2CppObjectP12Il2CppString: __Z31Font_CUSTOM_Internal_CreateFontP12Il2CppObjectP12Il2CppString, __ZThn4_N5physx5cloth8SwFabric18scaleTetherLengthsEf: __ZThn4_N5physx5cloth8SwFabric18scaleTetherLengthsEf, __ZN14FileCacherRead13GetFileLengthEv: __ZN14FileCacherRead13GetFileLengthEv, __Z46AnimatorControllerPlayable_CUSTOM_SetIntegerIDR9HPlayableii: __Z46AnimatorControllerPlayable_CUSTOM_SetIntegerIDR9HPlayableii, __Z36Event_CUSTOM_Internal_SetNativeEvent13Il2Cpp_IntPtr: __Z36Event_CUSTOM_Internal_SetNativeEvent13Il2Cpp_IntPtr, __ZN12SocketStream4PollEy: __ZN12SocketStream4PollEy, __Z33ShouldWarnOnSlowSerializationPathI8JSONReadEbv: __Z33ShouldWarnOnSlowSerializationPathI8JSONReadEbv, _readlink: _readlink, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE8__appendEj: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE8__appendEj, __ZN5physx7NpScene19removeParticleFluidERNS_15NpParticleFluidE: __ZN5physx7NpScene19removeParticleFluidERNS_15NpParticleFluidE, __ZN12_GLOBAL__N_117ConnectionManager10disconnectEv: __ZN12_GLOBAL__N_117ConnectionManager10disconnectEv, __ZN30ReportScriptingObjectsTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN30ReportScriptingObjectsTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, _consume_markers: _consume_markers, __ZNK6Sprite9GetBoundsE8Vector2fbb: __ZNK6Sprite9GetBoundsE8Vector2fbb, __ZN5physx15PxVehicleUpdate13updateNoDriveEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleNoDriveEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx15PxVehicleUpdate13updateNoDriveEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleNoDriveEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __ZN7mecanim12statemachine13StateConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine13StateConstant8TransferI14SafeBinaryReadEEvRT_, __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetScenePathByBuildIndexv: __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetScenePathByBuildIndexv, __ZN11ContextGLES6CreateEi: __ZN11ContextGLES6CreateEi, __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z27getPxShape_ConcreteTypeNamePKN5physx7PxShapeE: __Z27getPxShape_ConcreteTypeNamePKN5physx7PxShapeE, __ZNK17PolygonCollider2D7GetPolyEv: __ZNK17PolygonCollider2D7GetPolyEv, __Z53Register_UnityEngine_AndroidJNI_SetDoubleArrayElementv: __Z53Register_UnityEngine_AndroidJNI_SetDoubleArrayElementv, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z48Camera_CUSTOM_INTERNAL_CALL_ViewportToWorldPointP12Il2CppObjectRK8Vector3fRS1_: __Z48Camera_CUSTOM_INTERNAL_CALL_ViewportToWorldPointP12Il2CppObjectRK8Vector3fRS1_, __ZN14StackAllocator16FrameMaintenanceEb: __ZN14StackAllocator16FrameMaintenanceEb, __ZL11SweepBoxBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL11SweepBoxBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN4FMOD4DSPI13disconnectAllEbb: __ZN4FMOD4DSPI13disconnectAllEbb, __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE: __ZNK10GameObject20QueryComponentByTypeEPKN5Unity4TypeE, _jpeg_mem_available: _jpeg_mem_available, __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN26DownloadHandlerAssetBundle13OnReceiveDataEPKvj: __ZN26DownloadHandlerAssetBundle13OnReceiveDataEPKvj, __Z49Register_UnityEngine_AudioSource_set_spatialBlendv: __Z49Register_UnityEngine_AudioSource_set_spatialBlendv, __ZThn4_NK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE: __ZThn4_NK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE, __Z48Gyroscope_CUSTOM_INTERNAL_CALL_attitude_InternaliR11Quaternionf: __Z48Gyroscope_CUSTOM_INTERNAL_CALL_attitude_InternaliR11Quaternionf, __ZN11TextureData5ResetEv: __ZN11TextureData5ResetEv, __Z53Register_UnityEngine_GameObject_get_activeInHierarchyv: __Z53Register_UnityEngine_GameObject_get_activeInHierarchyv, __Z44Collider2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall: __Z44Collider2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall, __ZNK5physx29PxClothSimpleTetherCookerImpl13getTetherDataEPjPf: __ZNK5physx29PxClothSimpleTetherCookerImpl13getTetherDataEPjPf, __ZL30InitializeCoreScriptingClassesv: __ZL30InitializeCoreScriptingClassesv, __ZN15NullIndexBufferD0Ev: __ZN15NullIndexBufferD0Ev, __Z53Register_UnityEngine_Input_get_accelerationEventCountv: __Z53Register_UnityEngine_Input_get_accelerationEventCountv, __ZN17ArchiveFileSystem5TouchER13FileEntryData: __ZN17ArchiveFileSystem5TouchER13FileEntryData, __ZN5physx2Sq10AABBPrunerC2Eb: __ZN5physx2Sq10AABBPrunerC2Eb, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadhEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadhEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE, __Z26scripting_gc_get_used_sizev: __Z26scripting_gc_get_used_sizev, __ZNK4Mesh22CalculateStreamsLayoutEv: __ZNK4Mesh22CalculateStreamsLayoutEv, __Z57Register_UnityEngine_Material_set_globalIlluminationFlagsv: __Z57Register_UnityEngine_Material_set_globalIlluminationFlagsv, __ZN13dynamic_arrayI11CulledLightLj4EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI11CulledLightLj4EE6insertEPS0_PKS0_S4_, __ZN5physx5cloth9SwFactory5cloneERKNS0_5ClothE: __ZN5physx5cloth9SwFactory5cloneERKNS0_5ClothE, __Z38Register_UnityEngine_GUI_UnfocusWindowv: __Z38Register_UnityEngine_GUI_UnfocusWindowv, __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4FMOD12ChannelGroup14overrideVolumeEf: __ZN4FMOD12ChannelGroup14overrideVolumeEf, __Z42ReflectionProbe_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z42ReflectionProbe_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags, _UNITY_png_create_write_struct: _UNITY_png_create_write_struct, __ZN13InitialModuleD2Ev: __ZN13InitialModuleD2Ev, __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN7Texture23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN7Texture23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _UNITY_FT_Set_Transform: _UNITY_FT_Set_Transform, __ZNK32RendererMaterialAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK32RendererMaterialAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj209ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj209ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21LightProbeProxyVolumeD2Ev: __ZN21LightProbeProxyVolumeD2Ev, __ZN4crnd10dxt1_block12unpack_colorEtbj: __ZN4crnd10dxt1_block12unpack_colorEtbj, __ZN5physx37solveFrictionCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx37solveFrictionCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN20QuadTreeNodeRenderer16StaticInitializeEPv: __ZN20QuadTreeNodeRenderer16StaticInitializeEPv, __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_6PxVec3ES6_RS4_S7_: __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_6PxVec3ES6_RS4_S7_, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE14getOwnerClientEv, __ZN5physx25PxVehicleConstraintShader15getSerializableEv: __ZN5physx25PxVehicleConstraintShader15getSerializableEv, __Z39Animator_CUSTOM_GetNextAnimatorClipInfoP12Il2CppObjecti: __Z39Animator_CUSTOM_GetNextAnimatorClipInfoP12Il2CppObjecti, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE8ValidateEPS1_: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE8ValidateEPS1_, __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj: __ZN20TextRenderingPrivate19NativeTextGenerator13ProcessStringEPj, __ZN28EnlightenRendererInformation8TransferI14SafeBinaryReadEEvRT_: __ZN28EnlightenRendererInformation8TransferI14SafeBinaryReadEEvRT_, __Z39UnityWebRequest_CUSTOM_InternalGetErrorP12Il2CppObject: __Z39UnityWebRequest_CUSTOM_InternalGetErrorP12Il2CppObject, __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_: __ZN14qsort_internal6_QSortIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_, __ZN5physx12NpBatchQuery13getUserMemoryEv: __ZN5physx12NpBatchQuery13getUserMemoryEv, __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZNK15Lz4Decompressor16DecompressMemoryEPKvPjPvS2_: __ZNK15Lz4Decompressor16DecompressMemoryEPKvPjPvS2_, __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadHandlerv: __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadHandlerv, __Z55Register_UnityEngine_CharacterController_get_slopeLimitv: __Z55Register_UnityEngine_CharacterController_get_slopeLimitv, __ZN13InitialModule18SetInheritedParamsERK11ColorRGBA32RK8Vector3fS5_S5_: __ZN13InitialModule18SetInheritedParamsERK11ColorRGBA32RK8Vector3fS5_S5_, __Z44Register_UnityEngine_Animation_get_isPlayingv: __Z44Register_UnityEngine_Animation_get_isPlayingv, __ZN5physx18addTorqueCurvePairEPNS_19PxVehicleEngineDataEff: __ZN5physx18addTorqueCurvePairEPNS_19PxVehicleEngineDataEff, __ZN4FMOD8ChannelI12setLoopCountEi: __ZN4FMOD8ChannelI12setLoopCountEi, __ZN11Rigidbody2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11Rigidbody2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z26profiler_begin_instance_idP19ProfilerInformationi: __Z26profiler_begin_instance_idP19ProfilerInformationi, __Z35UnityPropertySheet_MakeSortedColorsRKNSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEER10vector_mapIS2_S3_S5_NS6_INS7_IS2_S3_EEEEE: __Z35UnityPropertySheet_MakeSortedColorsRKNSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S3_EEEEEER10vector_mapIS2_S3_S5_NS6_INS7_IS2_S3_EEEEE, __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv, _UNITY_tt_face_load_os2: _UNITY_tt_face_load_os2, __Z36MeshFilter_Get_Custom_PropSharedMeshP12Il2CppObject: __Z36MeshFilter_Get_Custom_PropSharedMeshP12Il2CppObject, __ZN5physx2GuL34fullContactsGenerationSphereConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESB_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb: __ZN5physx2GuL34fullContactsGenerationSphereConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESB_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb, __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf: __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb, __ZN15TerrainRenderer19UnloadFromGfxDeviceEv: __ZN15TerrainRenderer19UnloadFromGfxDeviceEv, __ZN5physx2Gu5Facet10silhouetteERKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE: __ZN5physx2Gu5Facet10silhouetteERKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __Z18Transfer_BlittableI9JSONWriteLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z37AndroidJNI_CUSTOM_EnsureLocalCapacityi: __Z37AndroidJNI_CUSTOM_EnsureLocalCapacityi, __ZThn8_N12_GLOBAL__N_110Connection14onDeallocationEPv: __ZThn8_N12_GLOBAL__N_110Connection14onDeallocationEPv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags, __Z43Register_UnityEngine_GL_RenderTargetBarrierv: __Z43Register_UnityEngine_GL_RenderTargetBarrierv, _tcflow: _tcflow, __Z43MaterialPropertyBlock_CUSTOM_GetVectorArrayP12Il2CppObjecti: __Z43MaterialPropertyBlock_CUSTOM_GetVectorArrayP12Il2CppObjecti, __Z25getPxScene_BroadPhaseTypePKN5physx7PxSceneE: __Z25getPxScene_BroadPhaseTypePKN5physx7PxSceneE, __ZN5physx3Cct8SweptBoxD2Ev: __ZN5physx3Cct8SweptBoxD2Ev, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEED0Ev, __Z36Rigidbody2D_Set_Custom_PropSleepModeP12Il2CppObjectN11Rigidbody2D9SleepModeE: __Z36Rigidbody2D_Set_Custom_PropSleepModeP12Il2CppObjectN11Rigidbody2D9SleepModeE, __ZN11JpegDecoderC2Ev: __ZN11JpegDecoderC2Ev, __ZN5physx2Sc9ClothCore16setContactOffsetEf: __ZN5physx2Sc9ClothCore16setContactOffsetEf, __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE: __ZN7mecanim9animation12EvaluateClipEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEPNS0_10ClipOutputE, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN13WheelCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13WheelCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx3Cct9SweepTest15onObstacleAddedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f: __ZN5physx3Cct9SweepTest15onObstacleAddedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f, __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv: __ZN20TextRenderingPrivate7GUIText18GetFontAndMaterialEv, __Z40Application_CUSTOM_SetLogCallbackDefinedh: __Z40Application_CUSTOM_SetLogCallbackDefinedh, __ZN5physx2Gu10SupportMapD2Ev: __ZN5physx2Gu10SupportMapD2Ev, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZMultiplierv, __ZN5physx2Sn5ConvX7convertEPKvi: __ZN5physx2Sn5ConvX7convertEPKvi, __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSESt16initializer_listIcE, __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_: __ZN13dynamic_arrayI5PlaneLj4EEC2ERKS1_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceIPKwEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceIPKwEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE22getClientBehaviorFlagsEv, __ZN9TextAsset8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9TextAsset8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN16Physics2DManager25DestroyColliderCollisionsEP10Collider2D: __ZN16Physics2DManager25DestroyColliderCollisionsEP10Collider2D, __ZN37AssetBundleLoadFromFileAsyncOperationD0Ev: __ZN37AssetBundleLoadFromFileAsyncOperationD0Ev, __ZN4FMOD7Channel16setSpeakerLevelsE12FMOD_SPEAKERPfi: __ZN4FMOD7Channel16setSpeakerLevelsE12FMOD_SPEAKERPfi, __ZN5physx10NpMaterial17setStaticFrictionEf: __ZN5physx10NpMaterial17setStaticFrictionEf, __ZN9InputAxisC2Ev: __ZN9InputAxisC2Ev, __ZN5physx8debugger14PvdMarshallingIydE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIydE12marshalBlockEPKhPhj, __ZN5physx21PxcArticulationHelper18computeJointDrivesERNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPKNS_19PxsArticulationLinkEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEPKNS4_6Mat33VEf: __ZN5physx21PxcArticulationHelper18computeJointDrivesERNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPKNS_19PxsArticulationLinkEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEPKNS4_6Mat33VEf, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE12getAggregateEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE, __ZN5Umbra9Matrix4x35identEv: __ZN5Umbra9Matrix4x35identEv, __Z15getPxActor_NamePKN5physx7PxActorE: __Z15getPxActor_NamePKN5physx7PxActorE, __Z41Register_UnityEngine_Light_set_renderModev: __Z41Register_UnityEngine_Light_set_renderModev, __ZN14EmissionModule5ResetEv: __ZN14EmissionModule5ResetEv, __Z36Animation_CUSTOM_Internal_StopByNameP12Il2CppObjectP12Il2CppString: __Z36Animation_CUSTOM_Internal_StopByNameP12Il2CppObjectP12Il2CppString, __ZNK5physx7NpScene18getStaticStructureEv: __ZNK5physx7NpScene18getStaticStructureEv, __ZN5physx13PxsCCDContext12postCCDSweepEPNS_10PxBaseTaskE: __ZN5physx13PxsCCDContext12postCCDSweepEPNS_10PxBaseTaskE, __Z13RegisterClassIN5Unity5ClothEEvv: __Z13RegisterClassIN5Unity5ClothEEvv, __Z47Register_UnityEngine_AI_NavMeshAgent_get_heightv: __Z47Register_UnityEngine_AI_NavMeshAgent_get_heightv, __Z25GL_CUSTOM_LoadPixelMatrixv: __Z25GL_CUSTOM_LoadPixelMatrixv, __ZN5physx6shdfnd10Foundation19AlignCheckAllocator28deregisterAllocationListenerERNS_20PxAllocationListenerE: __ZN5physx6shdfnd10Foundation19AlignCheckAllocator28deregisterAllocationListenerERNS_20PxAllocationListenerE, __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE: __ZN5physx2Sc21ArticulationJointCore12setChildPoseERKNS_11PxTransformE, __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUseRandomRowP12Il2CppObject: __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUseRandomRowP12Il2CppObject, __ZN4crnd25static_huffman_data_modelD2Ev: __ZN4crnd25static_huffman_data_modelD2Ev, __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __ZN9Scripting28CreateEnumInfoFromNativeEnumERKN10EnumTraits14ReflectionInfoE: __ZN9Scripting28CreateEnumInfoFromNativeEnumERKN10EnumTraits14ReflectionInfoE, __ZThn12_N5physx3Ext10FixedJointD1Ev: __ZThn12_N5physx3Ext10FixedJointD1Ev, __ZNK5Light8GetFlareEv: __ZNK5Light8GetFlareEv, __ZN8GUIState8EndOnGUIEv: __ZN8GUIState8EndOnGUIEv, __ZN11UnityEngine15PlatformWrapper16GetApplicationIdEv: __ZN11UnityEngine15PlatformWrapper16GetApplicationIdEv, __Z52QualitySettings_Get_Custom_PropShadowNearPlaneOffsetv: __Z52QualitySettings_Get_Custom_PropShadowNearPlaneOffsetv, _UNITY_TT_Get_VMetrics: _UNITY_TT_Get_VMetrics, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx33solveContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx33solveContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __Z18GetUnityAdsManagerv: __Z18GetUnityAdsManagerv, __Z54Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Transposev: __Z54Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Transposev, __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall: __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_OverlapPointP12Il2CppObjectRK13Vector2fIcall, __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx9PxTaskMgr17submitUnnamedTaskERNS_6PxTaskENS_10PxTaskType4EnumE: __ZN5physx9PxTaskMgr17submitUnnamedTaskERNS_6PxTaskENS_10PxTaskType4EnumE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv, __ZN7Texture21GetMasterTextureLimitEv: __ZN7Texture21GetMasterTextureLimitEv, __ZNK9Animation21SetTransformsSetDirtyEv: __ZNK9Animation21SetTransformsSetDirtyEv, _ycc_rgb_convert: _ycc_rgb_convert, __ZN10GameObject25RegisterSetGONameCallbackEPFvPS_E: __ZN10GameObject25RegisterSetGONameCallbackEPFvPS_E, _UNITY_png_write_sRGB: _UNITY_png_write_sRGB, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEEC2EPNS0_7SystemIEi: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEEC2EPNS0_7SystemIEi, __ZN9ShaderLabL25StaticInitializeShaderLabEPv: __ZN9ShaderLabL25StaticInitializeShaderLabEPv, __ZN12MeshCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12MeshCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z36Gyroscope_CUSTOM_setEnabled_Internalih: __Z36Gyroscope_CUSTOM_setEnabled_Internalih, __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_sizeCustomv: __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_sizeCustomv, __ZN15PointEffector2D12SetForceModeE19EffectorForceMode2D: __ZN15PointEffector2D12SetForceModeE19EffectorForceMode2D, __ZN5physx30NbModifiedContactPairsPropertyC2Ev: __ZN5physx30NbModifiedContactPairsPropertyC2Ev, __ZThn32_N14SpriteRenderer19UpdateTransformInfoEv: __ZThn32_N14SpriteRenderer19UpdateTransformInfoEv, __ZN5Umbra5FloatC2ERKd: __ZN5Umbra5FloatC2ERKd, __Z52Register_UnityEngine_RenderSettings_get_haloStrengthv: __Z52Register_UnityEngine_RenderSettings_get_haloStrengthv, __Z57Register_UnityEngine_DynamicGI_UpdateMaterialsForRendererv: __Z57Register_UnityEngine_DynamicGI_UpdateMaterialsForRendererv, __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewDoubleArrayiRPv: __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewDoubleArrayiRPv, __ZNKSt3__220__codecvt_utf8_utf16IDiE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__220__codecvt_utf8_utf16IDiE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS0_14NamedAllocatorEPKcEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_S9_SC_NS0_20NonTrackingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS0_14NamedAllocatorEPKcEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_S9_SC_NS0_20NonTrackingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj, __Z25RegisterShowErrorWithModePFviE: __Z25RegisterShowErrorWithModePFviE, __Z13RegisterClassI10MeshFilterEvv: __Z13RegisterClassI10MeshFilterEvv, __Z42WindZone_Get_Custom_PropWindPulseMagnitudeP12Il2CppObject: __Z42WindZone_Get_Custom_PropWindPulseMagnitudeP12Il2CppObject, __ZNK26AnimatorControllerPlayable24GetAnimatorClipInfoCountEib: __ZNK26AnimatorControllerPlayable24GetAnimatorClipInfoCountEib, __ZN10TagManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10TagManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z13RegisterClassI15ResourceManagerEvv: __Z13RegisterClassI15ResourceManagerEvv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj116ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN12NavMeshAgentC2ER10MemLabelId18ObjectCreationMode: __ZN12NavMeshAgentC2ER10MemLabelId18ObjectCreationMode, __ZNSt3__214collate_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214collate_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN6Sprite17MainThreadCleanupEv: __ZN6Sprite17MainThreadCleanupEv, __ZN19AssetBundleManifest18GetAllAssetBundlesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE: __ZN19AssetBundleManifest18GetAllAssetBundlesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE, __ZN10AudioMixer14UpdateMuteSoloEv: __ZN10AudioMixer14UpdateMuteSoloEv, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE6assignINS_11__wrap_iterIPS7_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISF_E9referenceEEE5valueEvE4typeESF_SF_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE6assignINS_11__wrap_iterIPS7_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISF_E9referenceEEE5valueEvE4typeESF_SF_, __Z17GetMonoManagerPtrv: __Z17GetMonoManagerPtrv, __Z40ParticleSystem_ShapeModule_CUSTOM_GetArcP12Il2CppObject: __Z40ParticleSystem_ShapeModule_CUSTOM_GetArcP12Il2CppObject, __Z28setPxDistanceJoint_TolerancePN5physx15PxDistanceJointEf: __Z28setPxDistanceJoint_TolerancePN5physx15PxDistanceJointEf, __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularYLimitP12Il2CppObjectRK14SoftJointLimit: __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularYLimitP12Il2CppObjectRK14SoftJointLimit, __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEOS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEOS5_, __ZN19TouchPhaseEmulation15CompactFingerIDEi: __ZN19TouchPhaseEmulation15CompactFingerIDEi, __ZN9ShaderLab10SubProgram7CompileEv: __ZN9ShaderLab10SubProgram7CompileEv, __ZNSt3__218__insertion_sort_3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_: __ZNSt3__218__insertion_sort_3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_, __ZNK5physx3Cct17CapsuleController21getHalfHeightInternalEv: __ZNK5physx3Cct17CapsuleController21getHalfHeightInternalEv, __ZN9GfxDevice12PresentFrameEPK14ChannelAssigns: __ZN9GfxDevice12PresentFrameEPK14ChannelAssigns, __ZN13CameraLODData9AddAtBackEhf: __ZN13CameraLODData9AddAtBackEhf, __Z30scripting_is_debugger_attachedv: __Z30scripting_is_debugger_attachedv, __ZN5physx2Sc5Scene11onBodySleepEPNS0_7BodySimE: __ZN5physx2Sc5Scene11onBodySleepEPNS0_7BodySimE, __ZN6Object12SetHideFlagsEi: __ZN6Object12SetHideFlagsEi, _acosh: _acosh, __ZN18ScriptingArguments11GetDoubleAtEi: __ZN18ScriptingArguments11GetDoubleAtEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8Playable14ProcessVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv: __ZN8Playable14ProcessVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv, __ZN19CloudServiceHandler11FlushEventsEv: __ZN19CloudServiceHandler11FlushEventsEv, __ZN15GlobalCallbacksC2Ev: __ZN15GlobalCallbacksC2Ev, __ZN11AssetBundle8TransferI14SafeBinaryReadEEvRT_: __ZN11AssetBundle8TransferI14SafeBinaryReadEEvRT_, __ZN7b2World10CreateBodyEPK9b2BodyDef: __ZN7b2World10CreateBodyEPK9b2BodyDef, _UNITY_FT_New_Memory_Face: _UNITY_FT_New_Memory_Face, __ZNK5physx10NpMaterial18getDynamicFrictionEv: __ZNK5physx10NpMaterial18getDynamicFrictionEv, __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdatePlayerSendFrameCompletestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdatePlayerSendFrameCompletestruct7ForwardEv, __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_: __ZNSt3__27__sort3IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_T_, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl22getNamedPropertyValuesEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl22getNamedPropertyValuesEN5physx8debugger18NonNegativeIntegerE, __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK8VRDevice19GetProjectionMatrixEPK6Camera21MonoOrStereoscopicEye: __ZNK8VRDevice19GetProjectionMatrixEPK6Camera21MonoOrStereoscopicEye, __ZN15ApplicationInfo14GetSandboxTypeEv: __ZN15ApplicationInfo14GetSandboxTypeEv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPNS_15basic_streambufIcS2_EE, __ZN5physx9NpPhysics16createConvexMeshERNS_13PxInputStreamE: __ZN5physx9NpPhysics16createConvexMeshERNS_13PxInputStreamE, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _llround: _llround, __ZN17RemapPPtrTransfer11AddMetaFlagE17TransferMetaFlags: __ZN17RemapPPtrTransfer11AddMetaFlagE17TransferMetaFlags, __ZN16ReflectionProbes40UpdateRealtimeReflectionProbesTimeslicedEv: __ZN16ReflectionProbes40UpdateRealtimeReflectionProbesTimeslicedEv, __ZN15RelativeJoint2D11SetMaxForceEf: __ZN15RelativeJoint2D11SetMaxForceEf, __Z79Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableInteriorCollisionsv: __Z79Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableInteriorCollisionsv, __ZN15OcclusionPortal15ThreadedCleanupEv: __ZN15OcclusionPortal15ThreadedCleanupEv, __Z32setPxParticleReadDataFlagsBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEE: __Z32setPxParticleReadDataFlagsBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEE, __ZN13RenderManager16SetCurrentCameraEP6Camera: __ZN13RenderManager16SetCurrentCameraEP6Camera, __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E: __ZN5physx2Sq17SceneQueryManager8addShapeERKNS_7NpShapeERKNS_12PxRigidActorEbPNS_9PxBounds3E, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv, __ZN14SpriteRenderer11GetGeometryEv: __ZN14SpriteRenderer11GetGeometryEv, __Z23GetVirtualJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE: __Z23GetVirtualJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE, __ZN16ReflectionProbes15InitializeClassEv: __ZN16ReflectionProbes15InitializeClassEv, _UNITY_FT_Destroy_Class_psnames_module_class: _UNITY_FT_Destroy_Class_psnames_module_class, __ZNK12b2WheelJoint17GetReactionTorqueEf: __ZNK12b2WheelJoint17GetReactionTorqueEf, __ZN5physx6shdfnd5ArrayINS_2Sc8BodyRankENS0_15InlineAllocatorILj768ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sc8BodyRankENS0_15InlineAllocatorILj768ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_, __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE: __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE, __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Ext13RevoluteJoint11prepareDataEv: __ZN5physx3Ext13RevoluteJoint11prepareDataEv, __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb1EEEEvRT_, _ft_bitmap_glyph_bbox: _ft_bitmap_glyph_bbox, __ZN5Unity14CharacterJoint16CheckConsistencyEv: __ZN5Unity14CharacterJoint16CheckConsistencyEv, __ZNK5physx15NpActorTemplateINS_7PxClothEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE14getOwnerClientEv, __Z33IntersectAABBPlaneBoundsOptimizedRK4AABBPKN4math7_float4Ei: __Z33IntersectAABBPlaneBoundsOptimizedRK4AABBPKN4math7_float4Ei, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYv, __ZN17Physics2DSettings21SetColliderAwakeColorERK10ColorRGBAf: __ZN17Physics2DSettings21SetColliderAwakeColorERK10ColorRGBAf, __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_: __ZN5physx10SubSortSAH5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjjPS4_, __ZN4FMOD6System19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS: __ZN4FMOD6System19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS, __Z33setPxArticulationJoint_ParentPosePN5physx19PxArticulationJointERKNS_11PxTransformE: __Z33setPxArticulationJoint_ParentPosePN5physx19PxArticulationJointERKNS_11PxTransformE, __Z66Register_UnityEngine_Graphics_Internal_GetMaxDrawMeshInstanceCountv: __Z66Register_UnityEngine_Graphics_Internal_GetMaxDrawMeshInstanceCountv, __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateProfilerStartFramestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateProfilerStartFramestruct7ForwardEv, __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity9Component8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14PhysicsManager10OverlapBoxERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction: __ZN14PhysicsManager10OverlapBoxERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction, __ZN5physx3Ext20DefaultCpuDispatcher10submitTaskERNS_10PxBaseTaskE: __ZN5physx3Ext20DefaultCpuDispatcher10submitTaskERNS_10PxBaseTaskE, _mbsinit: _mbsinit, __ZN5physx2Sc7PhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableE: __ZN5physx2Sc7PhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableE, __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10Effector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN2UI6Canvas17MainThreadCleanupEv: __ZN2UI6Canvas17MainThreadCleanupEv, __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_, __ZN20IntermediateRenderer27GetWritableSharedPropertiesEv: __ZN20IntermediateRenderer27GetWritableSharedPropertiesEv, __ZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_: __ZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3badEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3badEv, __ZN7ApiGLES13CreateProgramEv: __ZN7ApiGLES13CreateProgramEv, __ZN11HaloManager7AddHaloEv: __ZN11HaloManager7AddHaloEv, __Z13RegisterClassI22NavMeshProjectSettingsEvv: __Z13RegisterClassI22NavMeshProjectSettingsEvv, __ZN17AnimationCurveTplI11QuaternionfE14SetPreInfinityEi: __ZN17AnimationCurveTplI11QuaternionfE14SetPreInfinityEi, __ZN5physx2Sc8BodyCore7restoreEv: __ZN5physx2Sc8BodyCore7restoreEv, __ZN4crnd12crn_unpackerD2Ev: __ZN4crnd12crn_unpackerD2Ev, __Z19CreateWebCamTextureRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z19CreateWebCamTextureRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, _unzeof: _unzeof, _tt_driver_class_pic_init: _tt_driver_class_pic_init, __ZN18ScriptingArguments9AddStringEPKc: __ZN18ScriptingArguments9AddStringEPKc, __ZN6Camera21BeginSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera21BeginSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE, __ZN13AnimationClip26EnsureQuaternionContinuityEv: __ZN13AnimationClip26EnsureQuaternionContinuityEv, __Z19InterpolateKeyframeI11QuaternionfET_RK11KeyframeTplIS1_ES5_f: __Z19InterpolateKeyframeI11QuaternionfET_RK11KeyframeTplIS1_ES5_f, __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, runPostSets: runPostSets, __ZNK8LODGroup26GetTypeInfoVirtualInternalEv: __ZNK8LODGroup26GetTypeInfoVirtualInternalEv, __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace: __ZL23stbir__resize_arbitraryPvPKviiiS_iiiffffPfiij14stbir_datatype12stbir_filterS4_10stbir_edgeS5_16stbir_colorspace, __ZN23ParticleSystemParticles13array_reserveEj: __ZN23ParticleSystemParticles13array_reserveEj, __ZN19SpriteMeshGenerator4maskC2EP11ColorRGBA32iihj: __ZN19SpriteMeshGenerator4maskC2EP11ColorRGBA32iihj, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12_GLOBAL__N_117ConnectionManagerD2Ev: __ZN12_GLOBAL__N_117ConnectionManagerD2Ev, __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv: __ZNK24OptimizedPolynomialCurve26FindMinMaxDoubleIntegratedEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc, __ZN5physx8debugger4comm28SendPropertyMessageFromGroupD0Ev: __ZN5physx8debugger4comm28SendPropertyMessageFromGroupD0Ev, __ZN5physx11EdgeManager6resizeEj: __ZN5physx11EdgeManager6resizeEj, __Z30getPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkEPPS0_j: __Z30getPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkEPPS0_j, __Z36Light_Get_Custom_PropBounceIntensityP12Il2CppObject: __Z36Light_Get_Custom_PropBounceIntensityP12Il2CppObject, __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb0EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE, __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE8__appendEj, __GLOBAL__sub_I_runtime_misc3_lump_cpp: __GLOBAL__sub_I_runtime_misc3_lump_cpp, _llrintl: _llrintl, __ZNK13ScreenManager22HasFullscreenRequestedEv: __ZNK13ScreenManager22HasFullscreenRequestedEv, __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform: __ZN8Animator34RecomputeContainedRenderersRecurseER9Transform, _llrintf: _llrintf, __ZN9ShaderLab25SerializedTextureProperty8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab25SerializedTextureProperty8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9profiling14SamplerManagerD2Ev: __ZN9profiling14SamplerManagerD2Ev, __ZN12FixedJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN12FixedJoint2DC2E10MemLabelId18ObjectCreationMode, __ZN7Terrain10FlushDirtyEv: __ZN7Terrain10FlushDirtyEv, _tt_cmap14_char_next: _tt_cmap14_char_next, __Z41AreaEffector2D_Get_Custom_PropAngularDragP12Il2CppObject: __Z41AreaEffector2D_Get_Custom_PropAngularDragP12Il2CppObject, __Z57Register_UnityEngine_ParticleSystem_MainModule_GetPrewarmv: __Z57Register_UnityEngine_ParticleSystem_MainModule_GetPrewarmv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb: __ZN5physx2Sc5Scene12removeStaticERNS0_10StaticCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb, __Z52Register_UnityEngine_SkinnedMeshRenderer_get_qualityv: __Z52Register_UnityEngine_SkinnedMeshRenderer_get_qualityv, __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11NamedObject8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK17GPUSkinPoseBuffer12GetBoneCountEv: __ZNK17GPUSkinPoseBuffer12GetBoneCountEv, __ZN6Camera29ResetStereoProjectionMatricesEv: __ZN6Camera29ResetStereoProjectionMatricesEv, __Z32GUIStyle_Get_Custom_PropFontSizeP12Il2CppObject: __Z32GUIStyle_Get_Custom_PropFontSizeP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, __Z27ConvertToAlphaTextureFormat13TextureFormat: __Z27ConvertToAlphaTextureFormat13TextureFormat, __ZN18ProfilerConnection22GetObjectMemoryProfileEPKvjj: __ZN18ProfilerConnection22GetObjectMemoryProfileEPKvjj, __Z18Transfer_BlittableI8JSONReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_png_get_pixel_aspect_ratio_fixed: _UNITY_png_get_pixel_aspect_ratio_fixed, __Z42Animator_CUSTOM_INTERNAL_get_pivotPositionP12Il2CppObjectP8Vector3f: __Z42Animator_CUSTOM_INTERNAL_get_pivotPositionP12Il2CppObjectP8Vector3f, __Z45Register_UnityEngine_Material_get_renderQueuev: __Z45Register_UnityEngine_Material_get_renderQueuev, _unity_z_inflate: _unity_z_inflate, __ZN2UI6Canvas19SetProjectionMatrixERK10Matrix4x4f: __ZN2UI6Canvas19SetProjectionMatrixERK10Matrix4x4f, __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z22CalculateTransformPathRK9TransformPS0_: __Z22CalculateTransformPathRK9TransformPS0_, __ZNK5Umbra4Tome21getClusterPortalCountEv: __ZNK5Umbra4Tome21getClusterPortalCountEv, __ZN5physx2Sc10NPhaseCore25createShapeInstancePairLLERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE: __ZN5physx2Sc10NPhaseCore25createShapeInstancePairLLERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE, __ZN5physx2Cm10Collection3addERNS_12PxCollectionE: __ZN5physx2Cm10Collection3addERNS_12PxCollectionE, __ZN4FMOD6System17getNumCDROMDrivesEPi: __ZN4FMOD6System17getNumCDROMDrivesEPi, __ZN13WheelCollider16CheckConsistencyEv: __ZN13WheelCollider16CheckConsistencyEv, __Z24Mathf_CUSTOM_FloatToHalff: __Z24Mathf_CUSTOM_FloatToHalff, __Z33setPxCloth_AngularDragCoefficientPN5physx7PxClothENS_6PxVec3E: __Z33setPxCloth_AngularDragCoefficientPN5physx7PxClothENS_6PxVec3E, __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE8pushNameEPKc, __ZThn8_N5physx2Sc19ShapeInstancePairLL12onDeactivateEj: __ZThn8_N5physx2Sc19ShapeInstancePairLL12onDeactivateEj, __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEEEEjT_j: __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEEEEjT_j, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z50Register_UnityEngine_TerrainData_set_treeInstancesv: __Z50Register_UnityEngine_TerrainData_set_treeInstancesv, __ZN17CapsuleCollider2D12SetDirectionENS_16CapsuleDirectionE: __ZN17CapsuleCollider2D12SetDirectionENS_16CapsuleDirectionE, __ZN11LightProbes18ApplyFromSceneLoadEv: __ZN11LightProbes18ApplyFromSceneLoadEv, __Z40ConfigurableJoint_Set_Custom_PropXMotionP12Il2CppObjecti: __Z40ConfigurableJoint_Set_Custom_PropXMotionP12Il2CppObjecti, __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff: __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff, __Z51Register_UnityEngine_ReflectionProbe_get_clearFlagsv: __Z51Register_UnityEngine_ReflectionProbe_get_clearFlagsv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN19StreamedBinaryWriteILb1EE4InitE24TransferInstructionFlags20BuildTargetSelection: __ZN19StreamedBinaryWriteILb1EE4InitE24TransferInstructionFlags20BuildTargetSelection, __Z34PxVehicleWheels4SuspensionRaycastsPN5physx12PxBatchQueryERKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataEPKNS_17PxQueryFilterDataEPKbjPNS_14PxRigidDynamicE: __Z34PxVehicleWheels4SuspensionRaycastsPN5physx12PxBatchQueryERKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataEPKNS_17PxQueryFilterDataEPKbjPNS_14PxRigidDynamicE, __Z40CommandBuffer_CUSTOM_SetGlobalFloatArrayP12Il2CppObjectiP11Il2CppArray: __Z40CommandBuffer_CUSTOM_SetGlobalFloatArrayP12Il2CppObjectiP11Il2CppArray, _UNITY_FT_Get_Track_Kerning: _UNITY_FT_Get_Track_Kerning, __ZN9Rigidbody16ApplyConstraintsEv: __ZN9Rigidbody16ApplyConstraintsEv, __ZN14GfxDeviceStats16CopyAllDrawStatsERKS_: __ZN14GfxDeviceStats16CopyAllDrawStatsERKS_, __ZN10GameObject7SetNameEPKc: __ZN10GameObject7SetNameEPKc, __ZNK14ParticleSystem27CalculateMaxActiveParticlesEv: __ZNK14ParticleSystem27CalculateMaxActiveParticlesEv, __ZN14NavMeshManagerC2Ev: __ZN14NavMeshManagerC2Ev, __Z24InitializeIl2CppFromMainRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_iPPKc: __Z24InitializeIl2CppFromMainRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_iPPKc, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags, __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow1P12Il2CppObjectRK8Vector3fRK11Quaternionfi: __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow1P12Il2CppObjectRK8Vector3fRK11Quaternionfi, __ZN5physx2Sc17ParticleSystemSim8setFlagsEj: __ZN5physx2Sc17ParticleSystemSim8setFlagsEj, __ZN16GraphicsSettingsD0Ev: __ZN16GraphicsSettingsD0Ev, __Z12FormatBufferPciPKcz: __Z12FormatBufferPciPKcz, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags, __Z38Rigidbody2D_Set_Custom_PropUseAutoMassP12Il2CppObjecth: __Z38Rigidbody2D_Set_Custom_PropUseAutoMassP12Il2CppObjecth, __Z45Input_Get_Custom_PropSimulateMouseWithTouchesv: __Z45Input_Get_Custom_PropSimulateMouseWithTouchesv, __Z21GetGyroUpdateIntervali: __Z21GetGyroUpdateIntervali, _UNITY_FT_GlyphLoader_Add: _UNITY_FT_GlyphLoader_Add, _uselocale: _uselocale, __ZN5physx2Gu15EdgeListBuilder18CreateEdgesToFacesEjPKjPKt: __ZN5physx2Gu15EdgeListBuilder18CreateEdgesToFacesEjPKjPKt, __ZN5physx11PxMeshQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleERNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKjfb: __ZN5physx11PxMeshQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleERNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKjfb, __Z23RegisterModule_Vehiclesv: __Z23RegisterModule_Vehiclesv, __Z26Event_CUSTOM_GetEventCountv: __Z26Event_CUSTOM_GetEventCountv, __ZN13SubstanceData25SetProceduralMemoryBudgetE19ProceduralCacheSize: __ZN13SubstanceData25SetProceduralMemoryBudgetE19ProceduralCacheSize, __ZanRK8Scalar4fRK14ComplementExprIS_E: __ZanRK8Scalar4fRK14ComplementExprIS_E, __ZNK14ImageReference12IsValidImageEv: __ZNK14ImageReference12IsValidImageEv, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12getClassSizeEv, __Z37TargetJoint2D_Get_Custom_PropMaxForceP12Il2CppObject: __Z37TargetJoint2D_Get_Custom_PropMaxForceP12Il2CppObject, __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE6resizeEjRKj: __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE6resizeEjRKj, __ZN4Mesh21UnswizzleVertexColorsEb: __ZN4Mesh21UnswizzleVertexColorsEb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags, __ZN7mecanim9animation25InitClipMuscleDeltaValuesERNS0_18ClipMuscleConstantEb: __ZN7mecanim9animation25InitClipMuscleDeltaValuesERNS0_18ClipMuscleConstantEb, __Z42Register_UnityEngine_GUIText_set_fontStylev: __Z42Register_UnityEngine_GUIText_set_fontStylev, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwj, __Z40Register_UnityEngine_Light_set_intensityv: __Z40Register_UnityEngine_Light_set_intensityv, __ZN6Socket8GetErrorEv: __ZN6Socket8GetErrorEv, __ZThn28_N14PhysicsManagerD0Ev: __ZThn28_N14PhysicsManagerD0Ev, __Z35Application_Get_Custom_PropIsEditorv: __Z35Application_Get_Custom_PropIsEditorv, __Z41Register_UnityEngine_AudioSource_set_mutev: __Z41Register_UnityEngine_AudioSource_set_mutev, __Z14raycast_sphereRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z14raycast_sphereRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE13isSubordinateEv, __ZN5physx20solveExtContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx20solveExtContactBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_: __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_, __ZNK17AudioReverbFilter26GetTypeInfoVirtualInternalEv: __ZNK17AudioReverbFilter26GetTypeInfoVirtualInternalEv, __ZN4crnd19crnd_get_level_infoEPKvjjPNS_14crn_level_infoE: __ZN4crnd19crnd_get_level_infoEPKvjjPNS_14crn_level_infoE, __ZL40InitializeParticleSystemScriptingClassesv: __ZL40InitializeParticleSystemScriptingClassesv, __Z43Register_UnityEngine_Shader_get_renderQueuev: __Z43Register_UnityEngine_Shader_get_renderQueuev, ___ldexp_cexpf: ___ldexp_cexpf, __ZN11TerrainData8TransferI14SafeBinaryReadEEvRT_: __ZN11TerrainData8TransferI14SafeBinaryReadEEvRT_, __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode: __ZN18AwakeFromLoadQueue28InvokePersistentManagerAwakeEPNS_4ItemEj17AwakeFromLoadMode, __Z40Cloth_Set_Custom_PropStretchingStiffnessP12Il2CppObjectf: __Z40Cloth_Set_Custom_PropStretchingStiffnessP12Il2CppObjectf, __ZN4HaloC2E10MemLabelId18ObjectCreationMode: __ZN4HaloC2E10MemLabelId18ObjectCreationMode, __ZN12ServerSocketD0Ev: __ZN12ServerSocketD0Ev, __ZN5Umbra20RuntimeStructBuilder13reserveOutputEPNS_9AllocatorEj: __ZN5Umbra20RuntimeStructBuilder13reserveOutputEPNS_9AllocatorEj, __ZN16ReflectionProbes35ClearAllRuntimeReflectionSampleDataEv: __ZN16ReflectionProbes35ClearAllRuntimeReflectionSampleDataEv, __ZNK17AnimationPlayable27GetNextCompatibleDescendantEi: __ZNK17AnimationPlayable27GetNextCompatibleDescendantEi, __Z32Animator_CUSTOM_SetTriggerStringP12Il2CppObjectP12Il2CppString: __Z32Animator_CUSTOM_SetTriggerStringP12Il2CppObjectP12Il2CppString, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv, __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK6Camera23CalculateShadowDistanceEv: __ZNK6Camera23CalculateShadowDistanceEv, __ZN15FileSystemEntry10AtomicMoveERS_: __ZN15FileSystemEntry10AtomicMoveERS_, __ZN5physx32PxArticulationJointGeneratedInfoC2Ev: __ZN5physx32PxArticulationJointGeneratedInfoC2Ev, __Z19IsDirectoryWritableRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z19IsDirectoryWritableRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__26vectorI4PPtrIN5Unity5JointEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_: __ZNSt3__26vectorI4PPtrIN5Unity5JointEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_, __ZN8LODGroup18UpdateEnabledStateEb: __ZN8LODGroup18UpdateEnabledStateEb, __Z37ConstantForce2D_Get_Custom_PropTorqueP12Il2CppObject: __Z37ConstantForce2D_Get_Custom_PropTorqueP12Il2CppObject, __Z25SetNeedToPerformRenderingb: __Z25SetNeedToPerformRenderingb, _fcntl: _fcntl, __Z33CommandBuffer_CUSTOM_Blit_TextureP12Il2CppObjectS0_R26MonoRenderTargetIdentifierS0_i: __Z33CommandBuffer_CUSTOM_Blit_TextureP12Il2CppObjectS0_R26MonoRenderTargetIdentifierS0_i, __ZN10__cxxabiv116__shim_type_infoD2Ev: __ZN10__cxxabiv116__shim_type_infoD2Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE12readPropertyIfEEbRT_, __Z33getPxCloth_AngularDragCoefficientPKN5physx7PxClothE: __Z33getPxCloth_AngularDragCoefficientPKN5physx7PxClothE, __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEbT0_S5_T_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj85ENS_22PxRepXPropertyAccessorILj85ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj85ENS_22PxRepXPropertyAccessorILj85ES4_jjEEEEvjRKT0_, __ZN29InitialModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN29InitialModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN18PlayableController17SetTimeUpdateModeE18DirectorUpdateMode: __ZN18PlayableController17SetTimeUpdateModeE18DirectorUpdateMode, __Z48Physics2D_CUSTOM_INTERNAL_set_colliderAwakeColorRK10ColorRGBAf: __Z48Physics2D_CUSTOM_INTERNAL_set_colliderAwakeColorRK10ColorRGBAf, __Z51Register_UnityEngine_Renderer_get_shadowCastingModev: __Z51Register_UnityEngine_Renderer_get_shadowCastingModev, __ZN5physxL27PxcSweepAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE: __ZN5physxL27PxcSweepAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE, __ZN12CullingGroup10SendEventsEPK17CullingGroupEventj: __ZN12CullingGroup10SendEventsEPK17CullingGroupEventj, __ZN10InputEvent18CommandStringEventERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN10InputEvent18CommandStringEventERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z27getPxSceneLimitsMaxNbBodiesPKN5physx13PxSceneLimitsE: __Z27getPxSceneLimitsMaxNbBodiesPKN5physx13PxSceneLimitsE, __Z5slerpPfS_S_f: __Z5slerpPfS_S_f, __Z65Register_UnityEngine_AnimatorOverrideController_Internal_SetDirtyv: __Z65Register_UnityEngine_AnimatorOverrideController_Internal_SetDirtyv, __ZN15AudioReverbZone23VirtualRedirectTransferER14SafeBinaryRead: __ZN15AudioReverbZone23VirtualRedirectTransferER14SafeBinaryRead, __ZThn32_NK8Renderer8GetLayerEv: __ZThn32_NK8Renderer8GetLayerEv, __ZN7mecanim9animation12AvatarMemory8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK4Mesh17GetPrimitiveCountEv: __ZNK4Mesh17GetPrimitiveCountEv, __ZN5physx3Scb5SceneD2Ev: __ZN5physx3Scb5SceneD2Ev, __Z23CullDirectionalCascadesRNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEEEPK17ShadowCascadeInfoiRK10Matrix4x4fRK8Vector3fRK13ShadowJobData16ShadowProjection: __Z23CullDirectionalCascadesRNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEEEPK17ShadowCascadeInfoiRK10Matrix4x4fRK8Vector3fRK13ShadowJobData16ShadowProjection, __ZN17AnimationPlayable11DerivesFromEP11Il2CppClass: __ZN17AnimationPlayable11DerivesFromEP11Il2CppClass, __ZN6HelperI14SafeBinaryRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI14SafeBinaryRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii: __ZN7ApiGLES13CreateTextureEj16TextureDimensionN2gl9TexFormatEiiiii, __Z57Register_UnityEngine_Application_RequestUserAuthorizationv: __Z57Register_UnityEngine_Application_RequestUserAuthorizationv, __ZN5Umbra15PortalRayTracerD2Ev: __ZN5Umbra15PortalRayTracerD2Ev, __ZNK19TouchPhaseEmulation19GetActiveTouchCountEv: __ZNK19TouchPhaseEmulation19GetActiveTouchCountEv, _UNITY_FT_Vector_From_Polar: _UNITY_FT_Vector_From_Polar, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYv, __ZN11Rigidbody2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11Rigidbody2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z16GetDynamicsScenev: __Z16GetDynamicsScenev, __ZThn8_N5physx2Sc18TriggerInteraction7destroyEv: __ZThn8_N5physx2Sc18TriggerInteraction7destroyEv, __ZN5physx23PxsBroadPhaseContextSap15getDeletedPairsEv: __ZN5physx23PxsBroadPhaseContextSap15getDeletedPairsEv, __Z21AddComponentUncheckedR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z21AddComponentUncheckedR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN13RuntimeStaticI20HardwareInfoReporterE13StaticDestroyEPv: __ZN13RuntimeStaticI20HardwareInfoReporterE13StaticDestroyEPv, __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE: __ZN5Umbra15BufferAllocator13releaseBufferERNS_17BlockRasterBufferE, __ZN22BaseUnityConnectClient14AppRunningTickEj: __ZN22BaseUnityConnectClient14AppRunningTickEj, _ps_dimension_done: _ps_dimension_done, __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI7Hash128Lj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetSpeedv: __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetSpeedv, __ZN5physx2Cm9transformERKNS0_8Matrix34ERKNS_9PxBounds3E: __ZN5physx2Cm9transformERKNS0_8Matrix34ERKNS_9PxBounds3E, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9Animation11CullingTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9Animation11CullingTypeEEvRT_RT0_PKc17TransferMetaFlags, __ZN14SubstanceInputD2Ev: __ZN14SubstanceInputD2Ev, __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_: __ZN10__cxxabiv112_GLOBAL__N_112parse_numberEPKcS2_, __ZN13GfxDeviceNull11SetViewportERK5RectTIiE: __ZN13GfxDeviceNull11SetViewportERK5RectTIiE, __ZN16LightmapSettings8TransferI14SafeBinaryReadEEvRT_: __ZN16LightmapSettings8TransferI14SafeBinaryReadEEvRT_, __ZN17BufferManagerGLES13ReleaseBufferEP14DataBufferGLES: __ZN17BufferManagerGLES13ReleaseBufferEP14DataBufferGLES, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE15growAndPushBackERKS2_, __Z64scripting_unity_engine_object_new_and_invoke_default_constructorP11Il2CppClassP6ObjectPP15Il2CppException: __Z64scripting_unity_engine_object_new_and_invoke_default_constructorP11Il2CppClassP6ObjectPP15Il2CppException, __Z41Register_UnityEngine_AudioSource_get_loopv: __Z41Register_UnityEngine_AudioSource_get_loopv, __ZN5physx2Sq11PruningPool11preallocateEj: __ZN5physx2Sq11PruningPool11preallocateEj, _UNITY_FT_Reference_Face: _UNITY_FT_Reference_Face, __ZN5physx5cloth11SwCollisionI8Scalar4fE13CollisionDataC2Ev: __ZN5physx5cloth11SwCollisionI8Scalar4fE13CollisionDataC2Ev, __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN19VREyeTextureManager22SetDeviceTextureFormatERK30UnityVREyeTextureConfiguration: __ZN19VREyeTextureManager22SetDeviceTextureFormatERK30UnityVREyeTextureConfiguration, __ZThn12_N12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i: __ZThn12_N12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i, __ZN5UmbramlERKNS_9Matrix4x3ES2_: __ZN5UmbramlERKNS_9Matrix4x3ES2_, __ZN7dtCrowd19updateAgentPositionERK13dtCrowdHandlePKf: __ZN7dtCrowd19updateAgentPositionERK13dtCrowdHandlePKf, __ZN5physx24PxDefaultMemoryInputDataC2EPhj: __ZN5physx24PxDefaultMemoryInputDataC2EPhj, __ZN8VRDevice25CreateEyeTextureResourcesEPvP17RenderSurfaceBaseS0_PS0_: __ZN8VRDevice25CreateEyeTextureResourcesEPvP17RenderSurfaceBaseS0_PS0_, __Z56Register_UnityEngine_CullingGroup_SetBoundingSphereCountv: __Z56Register_UnityEngine_CullingGroup_SetBoundingSphereCountv, __ZN16BaseVideoTexture5PauseEv: __ZN16BaseVideoTexture5PauseEv, __ZN19CloudServiceHandler18SaveFileFromServerERK8UnityStrS2_PN11UnityEngine15CloudWebService16WWWRestHeaderMapE: __ZN19CloudServiceHandler18SaveFileFromServerERK8UnityStrS2_PN11UnityEngine15CloudWebService16WWWRestHeaderMapE, stackSave: stackSave, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev, __ZN12FixedJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN12FixedJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN5physx20PxSetFilterConstantsERKNS_12PxGroupsMaskES2_: __ZN5physx20PxSetFilterConstantsERKNS_12PxGroupsMaskES2_, __Z41Register_UnityEngine_Mesh_Internal_Createv: __Z41Register_UnityEngine_Mesh_Internal_Createv, __ZN16MemoryFileSystem5TouchER13FileEntryData: __ZN16MemoryFileSystem5TouchER13FileEntryData, __ZN14SpriteRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14SpriteRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_RaycastTestv: __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_RaycastTestv, __ZNK10SampleClip19GetPreloadAudioDataEv: __ZNK10SampleClip19GetPreloadAudioDataEv, ___res_state: ___res_state, __Z41Texture_Set_Custom_PropMasterTextureLimiti: __Z41Texture_Set_Custom_PropMasterTextureLimiti, __ZN11UmbraModule14FreeVisibilityEPN5Umbra10VisibilityEbRK10MemLabelId: __ZN11UmbraModule14FreeVisibilityEPN5Umbra10VisibilityEbRK10MemLabelId, __ZN6Camera9SetAspectEf: __ZN6Camera9SetAspectEf, __ZN17Physics2DSettings23SetLinearSleepToleranceEf: __ZN17Physics2DSettings23SetLinearSleepToleranceEf, __ZN16Physics2DManager13CircleCastAllERK8Vector2ffS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager13CircleCastAllERK8Vector2ffS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE, __Z3minRK8Scalar4fS1_: __Z3minRK8Scalar4fS1_, __Z6simd4fRK8Scalar4f: __Z6simd4fRK8Scalar4f, __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __ZN8UVModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8UVModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, _UNITY_png_set_write_fn: _UNITY_png_set_write_fn, __ZN4FMOD6System19getStreamBufferSizeEPjS1_: __ZN4FMOD6System19getStreamBufferSizeEPjS1_, __ZN5physx16PxVehicleDrive4WD0Ev: __ZN5physx16PxVehicleDrive4WD0Ev, __ZN12CubemapArray8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12CubemapArray8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26locale5__imp7installINS_8messagesIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8messagesIcEEEEvPT_, __ZN13UnityProfiler17AddFramesFromFileENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13UnityProfiler17AddFramesFromFileENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7GetFreeEi, __ZN9Transform37InitializeTransformHierarchyRecursiveER18TransformHierarchyRii: __ZN9Transform37InitializeTransformHierarchyRecursiveER18TransformHierarchyRii, __Z44Camera_CUSTOM_INTERNAL_CALL_ResetFieldOfViewP12Il2CppObject: __Z44Camera_CUSTOM_INTERNAL_CALL_ResetFieldOfViewP12Il2CppObject, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPKv: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPKv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_8ios_baseES5_E: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_8ios_baseES5_E, __Z28Cloth_Set_Custom_PropDampingP12Il2CppObjectf: __Z28Cloth_Set_Custom_PropDampingP12Il2CppObjectf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags, __ZN5IMGUI18BringWindowToFrontER8GUIStatei: __ZN5IMGUI18BringWindowToFrontER8GUIStatei, __Z42NavMeshAgent_Get_Custom_PropUpdateRotationP12Il2CppObject: __Z42NavMeshAgent_Get_Custom_PropUpdateRotationP12Il2CppObject, __ZN4FMOD7SystemI14getSpeakerModeEP16FMOD_SPEAKERMODE: __ZN4FMOD7SystemI14getSpeakerModeEP16FMOD_SPEAKERMODE, _XXH32_hashFromCanonical: _XXH32_hashFromCanonical, __ZN19SharedBillboardData8TransferI17RemapPPtrTransferEEvRT_: __ZN19SharedBillboardData8TransferI17RemapPPtrTransferEEvRT_, __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_: __ZN17MeshRenderingData4InitEP4MeshS1_iP15SharedGfxBufferS3_, __ZN15TerrainRenderer26CreateQuadTreeNodeRendererER12QuadTreeNodeRK10Matrix4x4fP8MaterialRKNS_22QuadTreeNodeParametersE: __ZN15TerrainRenderer26CreateQuadTreeNodeRendererER12QuadTreeNodeRK10Matrix4x4fP8MaterialRKNS_22QuadTreeNodeParametersE, __Z67Register_UnityEngine_RenderSettings_get_defaultReflectionResolutionv: __Z67Register_UnityEngine_RenderSettings_get_defaultReflectionResolutionv, __ZN9ShaderLab10GrabPasses29DidClearAllTempRenderTexturesEv: __ZN9ShaderLab10GrabPasses29DidClearAllTempRenderTexturesEv, __Z14GetMonoManagerv: __Z14GetMonoManagerv, __Z37TextGenerator_CUSTOM_GetVerticesArrayP12Il2CppObject: __Z37TextGenerator_CUSTOM_GetVerticesArrayP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z47Register_UnityEngine_LocationService_get_statusv: __Z47Register_UnityEngine_LocationService_get_statusv, __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE: __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxQuatE, __Z57Register_UnityEngine_Transform_INTERNAL_set_localPositionv: __Z57Register_UnityEngine_Transform_INTERNAL_set_localPositionv, __ZN13GfxDeviceGLES26SetRandomWriteTargetBufferEi15ComputeBufferID: __ZN13GfxDeviceGLES26SetRandomWriteTargetBufferEi15ComputeBufferID, __ZN9ShaderLab33GenerateFastPropertyName28BitHashEPKc: __ZN9ShaderLab33GenerateFastPropertyName28BitHashEPKc, __ZN18BlockRangeInternal16PopLastNodeIndexEP10BlockRangeji: __ZN18BlockRangeInternal16PopLastNodeIndexEP10BlockRangeji, __ZN14AsyncOperation16CleanupCoroutineEv: __ZN14AsyncOperation16CleanupCoroutineEv, __Z24Cubemap_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii: __Z24Cubemap_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEvPT_jRKT0_RKT1_j, __ZN5physx6shdfnd5ArrayIPNS_3Ext20ProfileZoneInterfaceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Ext20ProfileZoneInterfaceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, _jpeg_open_backing_store: _jpeg_open_backing_store, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __Z25GfxDeviceAdvanceFrameGLESv: __Z25GfxDeviceAdvanceFrameGLESv, __Z13RegisterClassI19SkinnedMeshRendererEvv: __Z13RegisterClassI19SkinnedMeshRendererEvv, __ZN18AssetBundleManager19RegisterAssetBundleEP11AssetBundle: __ZN18AssetBundleManager19RegisterAssetBundleEP11AssetBundle, __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_: __ZNSt3__27__sort3IR12RaycastHit2DPS1_EEjT0_S4_S4_T_, __ZN5physx20InternalTriangleMesh7releaseEv: __ZN5physx20InternalTriangleMesh7releaseEv, __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZNK5physx7NpShape8getFlagsEv: __ZNK5physx7NpShape8getFlagsEv, __ZN10MonoScript17GetPropertiesHashEv: __ZN10MonoScript17GetPropertiesHashEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf, __Z43Animator_CUSTOM_SetIKRotationWeightInternalP12Il2CppObjectif: __Z43Animator_CUSTOM_SetIKRotationWeightInternalP12Il2CppObjectif, __Z27setPxVehicleWheelDataMWidthPN5physx18PxVehicleWheelDataEf: __Z27setPxVehicleWheelDataMWidthPN5physx18PxVehicleWheelDataEf, __ZNK11ICallString6ToUTF8Ev: __ZNK11ICallString6ToUTF8Ev, __ZN5physx2Sc10ElementSim8getSceneEv: __ZN5physx2Sc10ElementSim8getSceneEv, __ZN15AudioReverbZone7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15AudioReverbZone7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx28MFrictionVsSlipGraphPropertyC2Ev: __ZN5physx28MFrictionVsSlipGraphPropertyC2Ev, __ZN18UnityPropertySheet11UnityTexEnvC2Ev: __ZN18UnityPropertySheet11UnityTexEnvC2Ev, __ZNK5physx7NpCloth16getContactOffsetEv: __ZNK5physx7NpCloth16getContactOffsetEv, __ZNSt3__214__split_bufferIPN9BlobWrite11TypeContextENS_9allocatorIS3_EEE10push_frontERKS3_: __ZNSt3__214__split_bufferIPN9BlobWrite11TypeContextENS_9allocatorIS3_EEE10push_frontERKS3_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_, __ZN17AnimationCurveTplI8Vector3fE6AssignEPK11KeyframeTplIS0_ES5_: __ZN17AnimationCurveTplI8Vector3fE6AssignEPK11KeyframeTplIS0_ES5_, __ZN10MonoScript13AwakeFromLoadE17AwakeFromLoadMode: __ZN10MonoScript13AwakeFromLoadE17AwakeFromLoadMode, __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI16ShaderKeywordSetLj4EE6insertEPS0_PKS0_S4_, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4peekEv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4peekEv, __ZN22ForwardLinearAllocatorD2Ev: __ZN22ForwardLinearAllocatorD2Ev, __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_: __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EE11Collision2DNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_S6_EEL18MemLabelIdentifier65ELi16EEE4findERSB_, __ZN12TextureInput10ClearImageEv: __ZN12TextureInput10ClearImageEv, __Z21GetSceneHierarchyPathPK6Object: __Z21GetSceneHierarchyPathPK6Object, __ZN5physx3Scb5Scene19bufferCreationErrorEPKc: __ZN5physx3Scb5Scene19bufferCreationErrorEPKc, __ZN7mecanim9animation10GetMotionXERKNS0_18ClipMuscleConstantEPKf: __ZN7mecanim9animation10GetMotionXERKNS0_18ClipMuscleConstantEPKf, __Z63Register_UnityEngine_RenderTexture_Internal_CreateRenderTexturev: __Z63Register_UnityEngine_RenderTexture_Internal_CreateRenderTexturev, __Z19getPxSceneDescFlagsPKN5physx11PxSceneDescE: __Z19getPxSceneDescFlagsPKN5physx11PxSceneDescE, __ZN11ClothModule17SetupClothManagerEv: __ZN11ClothModule17SetupClothManagerEv, __Z37setPxVehicleWheelsSimData_ChassisMassPN5physx22PxVehicleWheelsSimDataEf: __Z37setPxVehicleWheelsSimData_ChassisMassPN5physx22PxVehicleWheelsSimDataEf, __ZN13RenderTexture9SetHeightEi: __ZN13RenderTexture9SetHeightEi, __ZN12HingeJoint2D15ThreadedCleanupEv: __ZN12HingeJoint2D15ThreadedCleanupEv, __ZL40FlattenSkeletonTransformHierarchyRecurseRK13dynamic_arrayIPK9TransformLj4EERS0_S6_: __ZL40FlattenSkeletonTransformHierarchyRecurseRK13dynamic_arrayIPK9TransformLj4EERS0_S6_, __ZNKSt3__27collateIcE7do_hashEPKcS3_: __ZNKSt3__27collateIcE7do_hashEPKcS3_, __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsUInt64ERK8UnityStry: __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsUInt64ERK8UnityStry, __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_set_linearOffsetv: __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_set_linearOffsetv, __Z47SystemInfo_Get_Custom_PropSupportsAccelerometerv: __Z47SystemInfo_Get_Custom_PropSupportsAccelerometerv, __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16LevelGameManager8TransferI24GenerateTypeTreeTransferEEvRT_, __Z40DynamicGI_Set_Custom_PropSynchronousModeh: __Z40DynamicGI_Set_Custom_PropSynchronousModeh, __ZN10Effector2D19FindContactGroupEndEPKNS_15EffectorContactE: __ZN10Effector2D19FindContactGroupEndEPKNS_15EffectorContactE, __Z37AnimationClip_Get_Custom_PropStopTimeP12Il2CppObject: __Z37AnimationClip_Get_Custom_PropStopTimeP12Il2CppObject, __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEC2ERKSA_: __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEC2ERKSA_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_, _UNITY_png_get_error_ptr: _UNITY_png_get_error_ptr, __ZN5physx8debugger4comm18SetPropertyMessage9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm18SetPropertyMessage9serializeERNS1_15EventSerializerE, __ZL11init_sourceP22jpeg_decompress_struct: __ZL11init_sourceP22jpeg_decompress_struct, __Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge: __Z14tessMeshDeleteP8TESSmeshP12TESShalfEdge, __ZN8Animator8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Animator8TransferI24GenerateTypeTreeTransferEEvRT_, __Z55Register_UnityEngine_AndroidJNI_CallStaticBooleanMethodv: __Z55Register_UnityEngine_AndroidJNI_CallStaticBooleanMethodv, __ZN4FMOD12ChannelGroup24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD12ChannelGroup24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES, __Z45ParticleSystem_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf: __Z45ParticleSystem_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf, __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_, __Z52Register_UnityEngine_Shader_GetGlobalVectorArrayImplv: __Z52Register_UnityEngine_Shader_GetGlobalVectorArrayImplv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN21AudioDistortionFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN21AudioDistortionFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN23PreloadManagerOperationD0Ev: __ZN23PreloadManagerOperationD0Ev, __ZN4crnd10dxt1_block12unpack_colorERjS1_S1_tb: __ZN4crnd10dxt1_block12unpack_colorERjS1_S1_tb, __Z58Register_UnityEngine_Profiling_Profiler_SetSamplersEnabledv: __Z58Register_UnityEngine_Profiling_Profiler_SetSamplersEnabledv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN4FMOD7SystemI11registerDSPEP20FMOD_DSP_DESCRIPTIONPj: __ZN4FMOD7SystemI11registerDSPEP20FMOD_DSP_DESCRIPTIONPj, __ZNK5physx3Ext7D6Joint9getMotionENS_8PxD6Axis4EnumE: __ZNK5physx3Ext7D6Joint9getMotionENS_8PxD6Axis4EnumE, __ZN18ColorBySpeedModule8TransferI14SafeBinaryReadEEvRT_: __ZN18ColorBySpeedModule8TransferI14SafeBinaryReadEEvRT_, __ZN12FileAccessorC2Ev: __ZN12FileAccessorC2Ev, __Z60Register_UnityEngine_Joint2D_INTERNAL_CALL_GetReactionTorquev: __Z60Register_UnityEngine_Joint2D_INTERNAL_CALL_GetReactionTorquev, __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapZP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapZP12Il2CppObjectR15MonoMinMaxCurve, __Z47QualitySettings_Get_Custom_PropShadowResolutionv: __Z47QualitySettings_Get_Custom_PropShadowResolutionv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6setbufEPwi, __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E: __ZN9Transform35SetLocalPositionWithoutNotificationERKN4math7_float3E, __ZN16UnityAdsSettings9SetGameIdE15RuntimePlatformRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN16UnityAdsSettings9SetGameIdE15RuntimePlatformRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z31Camera_CUSTOM_RenderDontRestoreP12Il2CppObject: __Z31Camera_CUSTOM_RenderDontRestoreP12Il2CppObject, __ZN5physx2Sc15ArticulationSim12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_: __ZN5physx2Sc15ArticulationSim12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_, __ZN5physx8debugger14PvdMarshallingIhxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhxE12marshalBlockEPKhPhj, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7getTypeEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7getTypeEv, __ZN5Unity5Joint18SetConnectedAnchorERK8Vector3f: __ZN5Unity5Joint18SetConnectedAnchorERK8Vector3f, __Z49Register_UnityEngine_SliderJoint2D_get_limitStatev: __Z49Register_UnityEngine_SliderJoint2D_get_limitStatev, __ZN14ParticleSystem16AssignRayBudgetsEv: __ZN14ParticleSystem16AssignRayBudgetsEv, __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv: __ZNK13Simd4iFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv, __ZN14ParticleSystem12CleanupClassEv: __ZN14ParticleSystem12CleanupClassEv, __ZN17AudioReverbFilter15ThreadedCleanupEv: __ZN17AudioReverbFilter15ThreadedCleanupEv, __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z24CreateStreamClipConstantP19StreamedClipBuilderRN7mecanim9animation12StreamedClipERNS1_6memory9AllocatorE: __Z24CreateStreamClipConstantP19StreamedClipBuilderRN7mecanim9animation12StreamedClipERNS1_6memory9AllocatorE, __ZN13SplatDatabase16AllocateAlphamapERK10ColorRGBAf: __ZN13SplatDatabase16AllocateAlphamapERK10ColorRGBAf, __ZN12AudioManager9SetVolumeEf: __ZN12AudioManager9SetVolumeEf, __ZNK5physx14NpArticulation26getInternalDriveIterationsEv: __ZNK5physx14NpArticulation26getInternalDriveIterationsEv, __ZN16DeveloperConsole5DoGUIEv: __ZN16DeveloperConsole5DoGUIEv, __ZN6SkyboxD2Ev: __ZN6SkyboxD2Ev, __ZNSt3__26locale5facetD0Ev: __ZNSt3__26locale5facetD0Ev, __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudeMultiplierv: __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudeMultiplierv, __ZNK23CloudWebServicesManager26GetTypeInfoVirtualInternalEv: __ZNK23CloudWebServicesManager26GetTypeInfoVirtualInternalEv, __ZN14VelocityModule8TransferI14SafeBinaryReadEEvRT_: __ZN14VelocityModule8TransferI14SafeBinaryReadEEvRT_, __ZN13RenderManager22OnWindowSizeHasChangedEv: __ZN13RenderManager22OnWindowSizeHasChangedEv, __Z45Application_Get_Custom_PropPersistentDataPathv: __Z45Application_Get_Custom_PropPersistentDataPathv, __Z40BillboardAsset_Get_Custom_PropIndexCountP12Il2CppObject: __Z40BillboardAsset_Get_Custom_PropIndexCountP12Il2CppObject, __ZN13RenderManager18UpdateAllRenderersEv: __ZN13RenderManager18UpdateAllRenderersEv, __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb0EEEEvRT_: __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb0EEEEvRT_, __ZN12FixedJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12FixedJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN14EdgeCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14EdgeCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN22BaseUnityConnectClient30OnEnteringStatePausedOrStoppedEv: __ZN22BaseUnityConnectClient30OnEnteringStatePausedOrStoppedEv, __ZN5physx14SingleAABBTask22setNumFastMovingShapesEjj: __ZN5physx14SingleAABBTask22setNumFastMovingShapesEjj, __ZN5physx8debugger15ForwardingArrayIPNS_26PxProfileEventBufferClientEED0Ev: __ZN5physx8debugger15ForwardingArrayIPNS_26PxProfileEventBufferClientEED0Ev, __ZN16BaseVideoTexture10YUYVToRGBAEPti: __ZN16BaseVideoTexture10YUYVToRGBAEPti, __ZN12_GLOBAL__N_113ClassDescImplD2Ev: __ZN12_GLOBAL__N_113ClassDescImplD2Ev, __ZNK4Mesh14ExtractUvArrayEiPfi: __ZNK4Mesh14ExtractUvArrayEiPfi, __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev: __ZN5physx33PxClothStretchConfigGeneratedInfoC2Ev, __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __Z30Caching_CUSTOM_DeleteFromCacheP12Il2CppString: __Z30Caching_CUSTOM_DeleteFromCacheP12Il2CppString, __Z17BuildSmoothCornerjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_RK11ColorRGBA32: __Z17BuildSmoothCornerjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_RK11ColorRGBA32, __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIiN15HeightMeshQuery10HeightDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEED0Ev, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_EC2ERKSM_j, __Z24MergeTransformComponentsR9TransformS0_b: __Z24MergeTransformComponentsR9TransformS0_b, __ZThn24_N5physx2Sc20ArticulationJointSimD0Ev: __ZThn24_N5physx2Sc20ArticulationJointSimD0Ev, __Z49RenderSettings_Set_Custom_PropReflectionIntensityf: __Z49RenderSettings_Set_Custom_PropReflectionIntensityf, __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_GetRangev: __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_GetRangev, __ZNSt3__23mapIiN14NavMeshManager9LayerDataENS_4lessIiEENS_9allocatorINS_4pairIKiS2_EEEEEixERS7_: __ZNSt3__23mapIiN14NavMeshManager9LayerDataENS_4lessIiEENS_9allocatorINS_4pairIKiS2_EEEEEixERS7_, __Z59Register_UnityEngine_LightProbeProxyVolume_get_probeDensityv: __Z59Register_UnityEngine_LightProbeProxyVolume_get_probeDensityv, __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK9Rigidbody: __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK9Rigidbody, __ZNSt3__218shared_timed_mutex11lock_sharedEv: __ZNSt3__218shared_timed_mutex11lock_sharedEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_targetv: __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_targetv, __ZN9Animation6RewindERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation6RewindERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZN5Umbra9IndexList7setSizeEi: __ZN5Umbra9IndexList7setSizeEi, __Z44Register_UnityEngine_AudioClip_LoadAudioDatav: __Z44Register_UnityEngine_AudioClip_LoadAudioDatav, __ZN5physx14PxsAABBManager12createBPElemEv: __ZN5physx14PxsAABBManager12createBPElemEv, ___strxfrm_l: ___strxfrm_l, __ZN5physx2Cm17FreeListAllocator11findBestFitEjRj: __ZN5physx2Cm17FreeListAllocator11findBestFitEjRj, __ZThn12_N5physx7NpShape14onRefCountZeroEv: __ZThn12_N5physx7NpShape14onRefCountZeroEv, __ZNSt3__218__insertion_sort_3IRNS_6__lessIaaEEPaEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIaaEEPaEEvT0_S5_T_, __ZL26GeomMTDCallback_ConvexMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL26GeomMTDCallback_ConvexMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj600ENS_22PxRepXPropertyAccessorILj600ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj600ENS_22PxRepXPropertyAccessorILj600ES4_ffEEEEvRKT0_, __ZN15AnchoredJoint2D16CheckConsistencyEv: __ZN15AnchoredJoint2D16CheckConsistencyEv, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN17ProfilerFrameData10ThreadDataC2Ev: __ZN17ProfilerFrameData10ThreadDataC2Ev, __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi: __ZN14PreloadManager26UpdatePreloadingSingleStepENS_21UpdatePreloadingFlagsEi, __ZNK15TerrainRenderer27CreateSharedMeshDataPatchesER13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB: __ZNK15TerrainRenderer27CreateSharedMeshDataPatchesER13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB, __ZN13OcclusionAreaD2Ev: __ZN13OcclusionAreaD2Ev, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv, __ZNK8Animator13GetHumanScaleEv: __ZNK8Animator13GetHumanScaleEv, __Z19InitializeGfxDevicej: __Z19InitializeGfxDevicej, __ZN24RingBufferMemoryFileDataC2E10MemLabelId: __ZN24RingBufferMemoryFileDataC2E10MemLabelId, __Z17getPxScene_LimitsPKN5physx7PxSceneE: __Z17getPxScene_LimitsPKN5physx7PxSceneE, __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMinv: __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMinv, __ZL33GeomOverlapCallback_CapsuleConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL33GeomOverlapCallback_CapsuleConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN6prcoreL25inner_stretch_i8_bilinearEPKNS_9InnerInfoE: __ZN6prcoreL25inner_stretch_i8_bilinearEPKNS_9InnerInfoE, __ZN11UnityEngine15CloudWebService13WWWRestClient17GetResponseStatusEv: __ZN11UnityEngine15CloudWebService13WWWRestClient17GetResponseStatusEv, __ZN10__cxxabiv123__fundamental_type_infoD0Ev: __ZN10__cxxabiv123__fundamental_type_infoD0Ev, __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdateProfilerSynchronizeStatsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdateProfilerSynchronizeStatsstruct7ForwardEv, __Z51Register_UnityEngine_LightmapSettings_get_lightmapsv: __Z51Register_UnityEngine_LightmapSettings_get_lightmapsv, __Z23CleanupAsyncReadManagerv: __Z23CleanupAsyncReadManagerv, __ZN5physx20InternalTriangleMesh9loadRTreeERNS_13PxInputStreamEj: __ZN5physx20InternalTriangleMesh9loadRTreeERNS_13PxInputStreamEj, __Z23ConvertCacheToBuildKeysI11QuaternionfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder: __Z23ConvertCacheToBuildKeysI11QuaternionfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setCMassLocalPoseInternalERKNS_11PxTransformE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setCMassLocalPoseInternalERKNS_11PxTransformE, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE14getOwnerClientEv, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUVChannelMaskP12Il2CppObjecti: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUVChannelMaskP12Il2CppObjecti, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__grow_byEjjjjjj, __ZNK25RuntimeAnimatorController30GetAnimationClipOverrideVectorEv: __ZNK25RuntimeAnimatorController30GetAnimationClipOverrideVectorEv, __ZN13SpringJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13SpringJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEv: __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv, __ZN13WheelCollider9SetCenterERK8Vector3f: __ZN13WheelCollider9SetCenterERK8Vector3f, __ZN5physx2Gu20intersectTriangleBoxERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_: __ZN5physx2Gu20intersectTriangleBoxERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_, __ZN5physx5cloth10deallocateEPv: __ZN5physx5cloth10deallocateEPv, __ZN9Animation25GetClipWithNameSerializedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation25GetClipWithNameSerializedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos15PsMatTransformVEPNS6_5Vec3VEjj: __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos15PsMatTransformVEPNS6_5Vec3VEjj, _csin: _csin, __ZN15LocationService17SetDistanceFilterEf: __ZN15LocationService17SetDistanceFilterEf, __ZN6Shader17CreateAndPostLoadEv: __ZN6Shader17CreateAndPostLoadEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx16PxVehicleNoDrive14setBrakeTorqueEjf: __ZN5physx16PxVehicleNoDrive14setBrakeTorqueEjf, __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z37AndroidJNIHelper_Set_Custom_PropDebugh: __Z37AndroidJNIHelper_Set_Custom_PropDebugh, __ZN12AdsIdHandler13SetStateErrorER8UnityStr: __ZN12AdsIdHandler13SetStateErrorER8UnityStr, __Z49Register_UnityEngine_Collider_INTERNAL_get_boundsv: __Z49Register_UnityEngine_Collider_INTERNAL_get_boundsv, __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_: __ZN11ColorRGBA328TransferI14SafeBinaryReadEEvRT_, __ZN5physx17writeBack1D4BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx17writeBack1D4BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN5physx3Ext13RevoluteJoint15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx3Ext13RevoluteJoint15exportExtraDataERNS_22PxSerializationContextE, __Z47Register_UnityEngine_ConstantForce2D_get_torquev: __Z47Register_UnityEngine_ConstantForce2D_get_torquev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE15growAndPushBackERKS2_, __ZN24RingBufferMemoryFileData4LockEPPv: __ZN24RingBufferMemoryFileData4LockEPPv, __Z39Profiler_Set_Custom_PropEnableBinaryLogh: __Z39Profiler_Set_Custom_PropEnableBinaryLogh, __ZNK5physx6shdfnd7FastIPC14haveConnectionEv: __ZNK5physx6shdfnd7FastIPC14haveConnectionEv, __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetVectorP12Il2CppObjectiR8Vector4f: __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetVectorP12Il2CppObjectiR8Vector4f, __ZNK14dtNavMeshQuery16moveAlongSurfaceEyPKfS1_PK13dtQueryFilterPfPyPii: __ZNK14dtNavMeshQuery16moveAlongSurfaceEyPKfS1_PK13dtQueryFilterPfPyPii, __Z11IsHDRFormat13TextureFormat: __Z11IsHDRFormat13TextureFormat, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4copyIS3_EEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4copyIS3_EEvRKNS1_IS2_T_EE, __Z31Texture_Set_Custom_PropWrapModeP12Il2CppObjecti: __Z31Texture_Set_Custom_PropWrapModeP12Il2CppObjecti, __ZN8Playable12SetPlayStateE9PlayState: __ZN8Playable12SetPlayStateE9PlayState, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z13RegisterClassI12MeshColliderEvv: __Z13RegisterClassI12MeshColliderEvv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj574ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj574ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj: __ZNSt3__26vectorINS_4pairIPKN5Unity4TypeE7Hash128EENS_9allocatorIS7_EEE8__appendEj, __ZN6Skybox7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Skybox7PRODUCEE10MemLabelId18ObjectCreationMode, __Z48Register_UnityEngine_CircleCollider2D_get_radiusv: __Z48Register_UnityEngine_CircleCollider2D_get_radiusv, __Z29Font_Get_Custom_PropFontNamesP12Il2CppObject: __Z29Font_Get_Custom_PropFontNamesP12Il2CppObject, __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim13ValueConstantEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim13ValueConstantEEEvRT_PKc17TransferMetaFlags, _cff_font_load: _cff_font_load, __Z48Register_UnityEngine_Camera_get_stereoMirrorModev: __Z48Register_UnityEngine_Camera_get_stereoMirrorModev, __ZN8VRDevice9FocusLostEv: __ZN8VRDevice9FocusLostEv, __ZNK14MemoryProfiler22GetIgnoredMemoryLabelsER13dynamic_arrayIiLj4EE: __ZNK14MemoryProfiler22GetIgnoredMemoryLabelsER13dynamic_arrayIiLj4EE, __ZN5physx35solveContactPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx35solveContactPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii: __ZL22stbir__encode_scanlineP11stbir__infoiPvPfiii, __Z24IsTimeslicableSceneAssetPKN5Unity4TypeE: __Z24IsTimeslicableSceneAssetPKN5Unity4TypeE, __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE8recreateEj, __ZN14AudioBehaviourD2Ev: __ZN14AudioBehaviourD2Ev, __ZN9Transform12CleanupClassEv: __ZN9Transform12CleanupClassEv, __ZTv0_n12_NSt3__210ostrstreamD1Ev: __ZTv0_n12_NSt3__210ostrstreamD1Ev, __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE: __ZN5physxmlERKNS_11PxMeshScaleERKNS_11PxTransformE, __ZN5physx18PxsSolverStartTask13setupDescTaskEv: __ZN5physx18PxsSolverStartTask13setupDescTaskEv, _UNITY_FT_Set_Pixel_Sizes: _UNITY_FT_Set_Pixel_Sizes, __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE: __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE, __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, ___fclose_ca: ___fclose_ca, __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Cct13BoxController6resizeEf: __ZN5physx3Cct13BoxController6resizeEf, __ZN5physx8debugger4comm20StreamInitialization9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm20StreamInitialization9serializeERNS1_15EventSerializerE, __Z44Register_UnityEngine_AndroidJNI_GetCharFieldv: __Z44Register_UnityEngine_AndroidJNI_GetCharFieldv, __ZN13ComputeShader17MainThreadCleanupEv: __ZN13ComputeShader17MainThreadCleanupEv, _LZ4_compress_generic: _LZ4_compress_generic, __Z50Register_UnityEngine_ParticleAnimator_get_sizeGrowv: __Z50Register_UnityEngine_ParticleAnimator_get_sizeGrowv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj, __Z19GL_CUSTOM_PopMatrixv: __Z19GL_CUSTOM_PopMatrixv, __ZN5physx2Sn17readAllPropertiesINS_15PxDistanceJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_15PxDistanceJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj, __Z30ProcessDynamicBatchGeometryJobP25DynamicVBOGeometryJobDataj: __Z30ProcessDynamicBatchGeometryJobP25DynamicVBOGeometryJobDataj, __Z30ParticleSystemCleanupAfterLoadv: __Z30ParticleSystemCleanupAfterLoadv, __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_: __ZNSt3__27__sort4IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_T_, __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRNS_6__lessI11CulledLightS2_EEPS2_EEjT0_S6_S6_S6_T_, __ZN10AudioMixer16OnRuntimeChangedEv: __ZN10AudioMixer16OnRuntimeChangedEv, __Z45Register_UnityEngine_WWW_LoadImageIntoTexturev: __Z45Register_UnityEngine_WWW_LoadImageIntoTexturev, __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator3addERKS2_S6_S6_S6_S6_: __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator3addERKS2_S6_S6_S6_S6_, _finitef: _finitef, __ZN5physx2Sn13XmlNodeReader14gotoFirstChildEv: __ZN5physx2Sn13XmlNodeReader14gotoFirstChildEv, __Z11GetTypePathRK16TypeTreeIteratorRNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z11GetTypePathRK16TypeTreeIteratorRNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN13MemoryManager22LogAllocationToConsoleEPvjPKcS2_i: __ZN13MemoryManager22LogAllocationToConsoleEPvjPKcS2_i, __Z55Animator_CUSTOM_INTERNAL_CALL_SetIKHintPositionInternalP12Il2CppObjectiRK8Vector3f: __Z55Animator_CUSTOM_INTERNAL_CALL_SetIKHintPositionInternalP12Il2CppObjectiRK8Vector3f, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv, __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_: __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_, __ZN5physx34NpShapeGetScRigidObjectFromScbSLOWERKNS_3Scb5ShapeE: __ZN5physx34NpShapeGetScRigidObjectFromScbSLOWERKNS_3Scb5ShapeE, __Z30GUIClip_Get_Custom_PropEnabledv: __Z30GUIClip_Get_Custom_PropEnabledv, __ZNK14BillboardAsset12GetNumImagesEv: __ZNK14BillboardAsset12GetNumImagesEv, __ZN7b2World11ShiftOriginERK6b2Vec2: __ZN7b2World11ShiftOriginERK6b2Vec2, __Z52Register_UnityEngine_TrailRenderer_get_colorGradientv: __Z52Register_UnityEngine_TrailRenderer_get_colorGradientv, __Z71Register_UnityEngine_Rendering_CommandBuffer_SetShadowSamplingMode_Implv: __Z71Register_UnityEngine_Rendering_CommandBuffer_SetShadowSamplingMode_Implv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjS8_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjS8_, __Z48Register_UnityEngine_SparseTexture_UpdateTileRawv: __Z48Register_UnityEngine_SparseTexture_UpdateTileRawv, __ZN5physx2Sc16InteractionScene21swapActorArrayIndicesERNS_6shdfnd5ArrayIPNS0_5ActorENS2_19ReflectionAllocatorIS5_EEEEjj: __ZN5physx2Sc16InteractionScene21swapActorArrayIndicesERNS_6shdfnd5ArrayIPNS0_5ActorENS2_19ReflectionAllocatorIS5_EEEEjj, __Z46Register_UnityEngine_AI_NavMesh_RestoreNavMeshv: __Z46Register_UnityEngine_AI_NavMesh_RestoreNavMeshv, __ZN15TerrainCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN15TerrainCollider23VirtualRedirectTransferER14SafeBinaryRead, __ZN8Renderer34GetLightProbeInterpolationPositionEv: __ZN8Renderer34GetLightProbeInterpolationPositionEv, __Z44RenderSettings_Set_Custom_PropFogEndDistancef: __Z44RenderSettings_Set_Custom_PropFogEndDistancef, __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z13RegisterClassI23ShaderVariantCollectionEvv: __Z13RegisterClassI23ShaderVariantCollectionEvv, __Z32setPxCloth_LinearDragCoefficientPN5physx7PxClothENS_6PxVec3E: __Z32setPxCloth_LinearDragCoefficientPN5physx7PxClothENS_6PxVec3E, __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE: __ZN5physx2Sn17stringToFlagsTypeEPKcRNS_18XmlMemoryAllocatorERjPKNS_11PxU32ToNameE, __Z32getPxVehicleDrive4WMDriveSimDataPKN5physx16PxVehicleDrive4WE: __Z32getPxVehicleDrive4WMDriveSimDataPKN5physx16PxVehicleDrive4WE, __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_: __ZN9ShaderLab26SerializedShaderDependencyC2ERKS0_, __ZN22UnityAnalyticsSettings16SetTestConfigUrlE8UnityStr: __ZN22UnityAnalyticsSettings16SetTestConfigUrlE8UnityStr, __Z48Register_UnityEngine_SliderJoint2D_get_useLimitsv: __Z48Register_UnityEngine_SliderJoint2D_get_useLimitsv, _expm1f: _expm1f, __Z50Register_UnityEngine_GUITexture_INTERNAL_get_colorv: __Z50Register_UnityEngine_GUITexture_INTERNAL_get_colorv, __ZNK5Unity9Component7GetNameEv: __ZNK5Unity9Component7GetNameEv, __ZN10AudioMixer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10AudioMixer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij: __ZN13RenderTexture9SetActiveEPS_i11CubemapFaceij, __Z37AnimationState_Set_Custom_PropEnabledP12Il2CppObjecth: __Z37AnimationState_Set_Custom_PropEnabledP12Il2CppObjecth, __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing1LimitP12Il2CppObjectRK14SoftJointLimit: __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing1LimitP12Il2CppObjectRK14SoftJointLimit, __ZN5physx2Sn5ConvX13registerUnionEPKc: __ZN5physx2Sn5ConvX13registerUnionEPKc, __ZN44ConvexVsHeightfieldContactGenerationCallback7onEventEjPj: __ZN44ConvexVsHeightfieldContactGenerationCallback7onEventEjPj, __ZN8LODGroup11LODStruct508TransferI14SafeBinaryReadEEvRT_: __ZN8LODGroup11LODStruct508TransferI14SafeBinaryReadEEvRT_, __ZN8Animator13RetargeterJobEPPS_j: __ZN8Animator13RetargeterJobEPPS_j, __Z46Register_UnityEngine_VR_VRDevice_get_isPresentv: __Z46Register_UnityEngine_VR_VRDevice_get_isPresentv, __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi: __Z27LogRepeatingStringWithFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE15LogMessageFlagsi, __ZN13ScreenManagerD0Ev: __ZN13ScreenManagerD0Ev, _UNITY_png_set_error_fn: _UNITY_png_set_error_fn, __ZN21DownloadHandlerScript21InvokeCompleteContentEP12Il2CppObject: __ZN21DownloadHandlerScript21InvokeCompleteContentEP12Il2CppObject, _UNITY_FT_Library_Version: _UNITY_FT_Library_Version, __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_get_localBoundsv: __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_get_localBoundsv, __ZNK11b2RopeJoint16GetReactionForceEf: __ZNK11b2RopeJoint16GetReactionForceEf, __Z38Register_UnityEngine_LODGroup_ForceLODv: __Z38Register_UnityEngine_LODGroup_ForceLODv, __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii: __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii, _setbuffer: _setbuffer, __Z45AnimationClip_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB: __Z45AnimationClip_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB, __ZN8Material26ResetAllCachedMaterialDataEP6Shader: __ZN8Material26ResetAllCachedMaterialDataEP6Shader, __Z52Register_UnityEngine_WindZone_get_windPulseMagnitudev: __Z52Register_UnityEngine_WindZone_get_windPulseMagnitudev, __ZNK23iPhoneLocalNotification9HasActionEv: __ZNK23iPhoneLocalNotification9HasActionEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags, __Z69Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToAxisAngleRadv: __Z69Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToAxisAngleRadv, __ZNK8Material11GetPassNameEi: __ZNK8Material11GetPassNameEi, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEEC2EPNS0_7SystemIEi: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEEC2EPNS0_7SystemIEi, __ZN12_GLOBAL__N_117ConnectionManager7releaseEv: __ZN12_GLOBAL__N_117ConnectionManager7releaseEv, __ZN13TriggerModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13TriggerModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15RelativeJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN15RelativeJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv, __Z56Register_UnityEngine_AudioSource_set_ignoreListenerPausev: __Z56Register_UnityEngine_AudioSource_set_ignoreListenerPausev, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEE15growAndPushBackERKS2_, __Z40WebCamTexture_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject: __Z40WebCamTexture_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject, __ZNK24dtObstacleAvoidanceQuery13processSampleEPKfS1_S1_S1_f: __ZNK24dtObstacleAvoidanceQuery13processSampleEPKfS1_S1_S1_f, __ZN15QualitySettings24SetShadowNearPlaneOffsetEf: __ZN15QualitySettings24SetShadowNearPlaneOffsetEf, __ZN4FMOD6System7releaseEv: __ZN4FMOD6System7releaseEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, _conjl: _conjl, __Z20profiler_set_enabledb: __Z20profiler_set_enabledb, __Z31RuntimeUndo_CUSTOM_RecordObjectP12Il2CppObjectP12Il2CppString: __Z31RuntimeUndo_CUSTOM_RecordObjectP12Il2CppObjectP12Il2CppString, __ZN7mecanim4hand14MuscleFromBoneEii: __ZN7mecanim4hand14MuscleFromBoneEii, _conjf: _conjf, __Z45Register_UnityEngine_ReflectionProbe_get_modev: __Z45Register_UnityEngine_ReflectionProbe_get_modev, __Z32NavMeshAgent_CUSTOM_GetLayerCostP12Il2CppObjecti: __Z32NavMeshAgent_CUSTOM_GetLayerCostP12Il2CppObjecti, __ZN9AudioClip14QueueAudioDataEPKvj: __ZN9AudioClip14QueueAudioDataEPKvj, __ZN5physx28PxcContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx28PxcContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf: __ZN26RecursivePlayableTraverser8TraverseER9FrameDataP8PlayableS3_P14DirectorPlayeriPvf, __ZN21UnityAnalyticsManager15ThreadedCleanupEv: __ZN21UnityAnalyticsManager15ThreadedCleanupEv, __Z23TransferScriptingObjectI17RemapPPtrTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI17RemapPPtrTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4copyIS5_EEvRKNS1_IS2_T_EE, __ZN5physx7NpCloth25sendPvdCollisionTrianglesEv: __ZN5physx7NpCloth25sendPvdCollisionTrianglesEv, __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController: __ZN15DirectorManager18ScheduleForRemovalEP18PlayableController, __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh: __ZL31PointInConvexPolygon2D_OutCodesPKfjffffRh, __ZN13TargetJoint2D9SetTargetERK8Vector2f: __ZN13TargetJoint2D9SetTargetERK8Vector2f, __ZN12AudioManager16GetConfigurationEv: __ZN12AudioManager16GetConfigurationEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setDynamicFrictionEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setDynamicFrictionEf, __ZN4crnd25static_huffman_data_model4initEjPKhj: __ZN4crnd25static_huffman_data_model4initEjPKhj, __Z60Register_UnityEngine_SpringJoint2D_get_autoConfigureDistancev: __Z60Register_UnityEngine_SpringJoint2D_get_autoConfigureDistancev, __Z45Rigidbody_Get_Custom_PropSleepAngularVelocityP12Il2CppObject: __Z45Rigidbody_Get_Custom_PropSleepAngularVelocityP12Il2CppObject, _rewind: _rewind, __Z22Mesh_CUSTOM_HasChannelP12Il2CppObject30InternalScriptingShaderChannel: __Z22Mesh_CUSTOM_HasChannelP12Il2CppObject30InternalScriptingShaderChannel, __ZN2UI13CanvasManager30EmitScreenSpaceCamerasGeometryEv: __ZN2UI13CanvasManager30EmitScreenSpaceCamerasGeometryEv, __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_: __ZL15AccumulateNoiseILb1ELi1EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_, __Z28SetExposedSkeletonTransformsRKN11UnityEngine9Animation30AnimatorGenericBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNS6_INS7_7affineXEEERNS0_21AvatarBindingConstantE: __Z28SetExposedSkeletonTransformsRKN11UnityEngine9Animation30AnimatorGenericBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNS6_INS7_7affineXEEERNS0_21AvatarBindingConstantE, __ZN8Playable11SetDurationEd: __ZN8Playable11SetDurationEd, __ZN5physx2Sc21ArticulationJointCore21setInternalComplianceEf: __ZN5physx2Sc21ArticulationJointCore21setInternalComplianceEf, __Z55Register_UnityEngine_LightmapSettings_set_lightmapsModev: __Z55Register_UnityEngine_LightmapSettings_set_lightmapsModev, __ZZN14ParticleSystem15InitializeClassEvEN32FunctorImpl_241kTransformChanged4CallEPviR11MessageData: __ZZN14ParticleSystem15InitializeClassEvEN32FunctorImpl_241kTransformChanged4CallEPviR11MessageData, __Z16VectToTexelCoordPfiPiS0_S0_: __Z16VectToTexelCoordPfiPiS0_S0_, __ZN9Rigidbody12MoveRotationERK11Quaternionf: __ZN9Rigidbody12MoveRotationERK11Quaternionf, __ZNK5physx6shdfnd10Foundation13getErrorLevelEv: __ZNK5physx6shdfnd10Foundation13getErrorLevelEv, __Z50Register_UnityEngine_Quaternion_INTERNAL_CALL_Lerpv: __Z50Register_UnityEngine_Quaternion_INTERNAL_CALL_Lerpv, __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_InternalCreatev: __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_InternalCreatev, __ZN16GeometryJobTasks20ScheduleGeometryJobsER9GfxDevicePFvP15GeometryJobDataEPK22GeometryJobInstructionjb: __ZN16GeometryJobTasks20ScheduleGeometryJobsER9GfxDevicePFvP15GeometryJobDataEPK22GeometryJobInstructionjb, __Z82Register_UnityEngine_Camera_get_useJitteredProjectionMatrixForTransparentRenderingv: __Z82Register_UnityEngine_Camera_get_useJitteredProjectionMatrixForTransparentRenderingv, __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN16ReflectionProbes28GetMinBakedCubemapResolutionEv: __ZN16ReflectionProbes28GetMinBakedCubemapResolutionEv, __Z60Register_UnityEngine_Cloth_INTERNAL_set_externalAccelerationv: __Z60Register_UnityEngine_Cloth_INTERNAL_set_externalAccelerationv, __Z43Register_UnityEngine_Texture_get_mipMapBiasv: __Z43Register_UnityEngine_Texture_get_mipMapBiasv, __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_: __ZNK5physx2Gu11HeightField22computeCellCoordinatesEffRfS2_, __ZN5Umbra12QueryContextD2Ev: __ZN5Umbra12QueryContextD2Ev, __Z20ConvertContactToMonoP9Collision: __Z20ConvertContactToMonoP9Collision, __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_11djb2_hash_tIS6_ENS0_8equal_toIS6_EE13stl_allocatorINS0_4pairIKS6_S6_EEL18MemLabelIdentifier54ELi16EEEixERSD_: __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_11djb2_hash_tIS6_ENS0_8equal_toIS6_EE13stl_allocatorINS0_4pairIKS6_S6_EEL18MemLabelIdentifier54ELi16EEEixERSD_, __ZN15ReflectionProbe15InitializeClassEv: __ZN15ReflectionProbe15InitializeClassEv, __ZN4Mesh5SetUvEiPK8Vector2fj: __ZN4Mesh5SetUvEiPK8Vector2fj, __ZN8Animator25SetLinearVelocityBlendingEb: __ZN8Animator25SetLinearVelocityBlendingEb, __ZN17RemapPPtrTransfer8TransferI22ParticleSystemRendererEEvRT_PKc17TransferMetaFlags: __ZN17RemapPPtrTransfer8TransferI22ParticleSystemRendererEEvRT_PKc17TransferMetaFlags, __Z39Register_UnityEngine_Cloth_get_verticesv: __Z39Register_UnityEngine_Cloth_get_verticesv, __ZN5physx50solveDriveNWInternalDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE: __ZN5physx50solveDriveNWInternalDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE, __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv: __ZN5Unity10HingeJoint21ReleaseAndCreateJointEv, __ZSt12__unexpectedPFvvE: __ZSt12__unexpectedPFvvE, __Z43Register_UnityEngine_Input_GetKeyDownStringv: __Z43Register_UnityEngine_Input_GetKeyDownStringv, __Z29GetGlobalAllowNameConversionsv: __Z29GetGlobalAllowNameConversionsv, __ZNKSt3__27codecvtIDic11__mbstate_tE13do_max_lengthEv: __ZNKSt3__27codecvtIDic11__mbstate_tE13do_max_lengthEv, __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff: __ZNK5physx2Gu15HeightFieldUtil31getFaceIndexAtShapePointNoTest2Ejff, __ZN8WWWAudioD2Ev: __ZN8WWWAudioD2Ev, __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf: __ZN8Material8SetColorEN9ShaderLab16FastPropertyNameERK10ColorRGBAf, __ZN22ProceduralMaterialData19GetSubstancePackageEv: __ZN22ProceduralMaterialData19GetSubstancePackageEv, __ZN9AudioClip27IsFormatSupportedByPlatformERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9AudioClip27IsFormatSupportedByPlatformERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE6resizeEjRKS3_, __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb: __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb, __ZNK17BaseWebCamTexture8GetPixelEii: __ZNK17BaseWebCamTexture8GetPixelEii, __Z22getPxCloth_NbParticlesPKN5physx7PxClothE: __Z22getPxCloth_NbParticlesPKN5physx7PxClothE, __ZN20TextRenderingPrivate8FontImplC2E10MemLabelIdPN13TextRendering4FontE: __ZN20TextRenderingPrivate8FontImplC2E10MemLabelIdPN13TextRendering4FontE, __Z40ConfigurableJoint_Get_Custom_PropXMotionP12Il2CppObject: __Z40ConfigurableJoint_Get_Custom_PropXMotionP12Il2CppObject, __ZN21AssetReferenceStorageC2Ev: __ZN21AssetReferenceStorageC2Ev, __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10RectOffset8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE: __ZN7mecanim16CreateValueArrayEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE, __Z20buildActiveTransformPN5physx2Sc5ActorEPPNS0_6ClientEj: __Z20buildActiveTransformPN5physx2Sc5ActorEPPNS0_6ClientEj, __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEj: __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEj, __ZN5physx8debugger4comm13SetIsTopLevel9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm13SetIsTopLevel9serializeERNS1_15EventSerializerE, __ZN21ArchiveStorageCreatorC2Ev: __ZN21ArchiveStorageCreatorC2Ev, __Z30AndroidJNI_CUSTOM_GetCharField13Il2Cpp_IntPtrS_: __Z30AndroidJNI_CUSTOM_GetCharField13Il2Cpp_IntPtrS_, __Z28setPxSceneDescBroadPhaseTypePN5physx11PxSceneDescENS_16PxBroadPhaseType4EnumE: __Z28setPxSceneDescBroadPhaseTypePN5physx11PxSceneDescENS_16PxBroadPhaseType4EnumE, __Z53Register_UnityEngine_QualitySettings_set_currentLevelv: __Z53Register_UnityEngine_QualitySettings_set_currentLevelv, __ZN5physx2Sc5Scene21fireCallBacksPostSyncEv: __ZN5physx2Sc5Scene21fireCallBacksPostSyncEv, __ZN14GfxContextGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES: __ZN14GfxContextGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES, __Z29Shader_CUSTOM_SetGlobalBufferiP12Il2CppObject: __Z29Shader_CUSTOM_SetGlobalBufferiP12Il2CppObject, __ZN5physx17PxsCCDAdvanceTask11runInternalEv: __ZN5physx17PxsCCDAdvanceTask11runInternalEv, __ZN11NamedObject23VirtualRedirectTransferER14SafeBinaryRead: __ZN11NamedObject23VirtualRedirectTransferER14SafeBinaryRead, __ZNK8WWWAudio14GetPartialDataEv: __ZNK8WWWAudio14GetPartialDataEv, __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_: __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_, __ZN23PreloadManagerOperation6IsDoneEv: __ZN23PreloadManagerOperation6IsDoneEv, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetRotationv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetRotationv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx7NpScene23addArticulationLinkBodyERNS_18NpArticulationLinkE: __ZN5physx7NpScene23addArticulationLinkBodyERNS_18NpArticulationLinkE, __ZNK13WheelCollider14GetBrakeTorqueEv: __ZNK13WheelCollider14GetBrakeTorqueEv, __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS5_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS5_RT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj430ES2_RKNS_18PxJointLinearLimitES6_EEKNS_31PxJointLinearLimitGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj430ES2_RKNS_18PxJointLinearLimitES6_EEKNS_31PxJointLinearLimitGeneratedInfoEEEvPjRKT_RT0_, __Z33GetHasChangedDeprecatedSystemMaskv: __Z33GetHasChangedDeprecatedSystemMaskv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj442ENS_22PxRepXPropertyAccessorILj442ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj442ENS_22PxRepXPropertyAccessorILj442ES4_ffEEEEvRKT0_, __Z50Register_UnityEngine_ReflectionProbe_get_intensityv: __Z50Register_UnityEngine_ReflectionProbe_get_intensityv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj543ENS_22PxRepXPropertyAccessorILj543ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj543ENS_22PxRepXPropertyAccessorILj543ES4_ffEEEEvRKT0_, __ZN10Effector2D10EndContactEP9b2Contact: __ZN10Effector2D10EndContactEP9b2Contact, __ZN5physx3Cct26CharacterControllerManagerD2Ev: __ZN5physx3Cct26CharacterControllerManagerD2Ev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE, __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYMultiplierv, __ZNK5physx2Sn21SerializationRegistry13getSerializerEt: __ZNK5physx2Sn21SerializationRegistry13getSerializerEt, __ZN21LightProbeProxyVolume18HasHardwareSupportEv: __ZN21LightProbeProxyVolume18HasHardwareSupportEv, __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats: __ZN26LightProbeProxyVolumeCacheC2ER13BatchRendererR15RenderLoopStats, __ZN6prcoreL31inner_stretch_argb8888_bilinearEPKNS_9InnerInfoE: __ZN6prcoreL31inner_stretch_argb8888_bilinearEPKNS_9InnerInfoE, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4PPtrI14BillboardAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI14BillboardAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags: __ZN19VREyeTextureManager16ClearEyeTexturesE13GfxClearFlags, _UNITY_FT_Outline_Decompose: _UNITY_FT_Outline_Decompose, __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile17EventDeserializerILb1EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE, __Z24RegisterStrippedTypeInfoI14AreaEffector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI14AreaEffector2DEviPKcS2_, __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev: __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev, __ZN5FlareD0Ev: __ZN5FlareD0Ev, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED2Ev: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED2Ev, __Z31Display_CUSTOM_GetSystemExtImpl13Il2Cpp_IntPtrPiS0_: __Z31Display_CUSTOM_GetSystemExtImpl13Il2Cpp_IntPtrPiS0_, __ZN5Unity17ConfigurableJoint17SetTargetRotationERK11Quaternionf: __ZN5Unity17ConfigurableJoint17SetTargetRotationERK11Quaternionf, __ZL17Transfer_GUIStyleI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z58Register_UnityEngine_Object_Internal_CloneSingleWithParentv: __Z58Register_UnityEngine_Object_Internal_CloneSingleWithParentv, __ZN9Animation37SendTransformChangedToCachedTransformEv: __ZN9Animation37SendTransformChangedToCachedTransformEv, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXv, __ZN5physx2Sc5Scene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE: __ZN5physx2Sc5Scene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE, __ZN5Umbra10VisibilityC2EPNS_9IndexListEPNS_15OcclusionBufferE: __ZN5Umbra10VisibilityC2EPNS_9IndexListEPNS_15OcclusionBufferE, __ZN23PreloadManagerOperation21MustCompleteNextFrameEv: __ZN23PreloadManagerOperation21MustCompleteNextFrameEv, __ZN6Skybox17RemoveFromManagerEv: __ZN6Skybox17RemoveFromManagerEv, __ZN5Umbra8QueryExt20queryClusterForPointERKNS_7Vector3ERi: __ZN5Umbra8QueryExt20queryClusterForPointERKNS_7Vector3ERi, __Z19GetMaxBytesPerPixel13TextureFormat: __Z19GetMaxBytesPerPixel13TextureFormat, __Z9DoNothingRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z9DoNothingRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18PxFabricCookerImpl4cookERKNS_15PxClothMeshDescENS_6PxVec3Eb: __ZN5physx18PxFabricCookerImpl4cookERKNS_15PxClothMeshDescENS_6PxVec3Eb, __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_: __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_, __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji: __ZN5physx22PxVehicleWheelsSimData20setWheelShapeMappingEji, __ZN5Umbra4Math4acosERKNS_6DoubleE: __ZN5Umbra4Math4acosERKNS_6DoubleE, _wctype: _wctype, __ZN23ParticleSystemParticles22SetUsesCollisionEventsEb: __ZN23ParticleSystemParticles22SetUsesCollisionEventsEb, __ZN13UpdateManagerD0Ev: __ZN13UpdateManagerD0Ev, __Z42Register_UnityEngine_WWW_INTERNAL_CALL_WWWv: __Z42Register_UnityEngine_WWW_INTERNAL_CALL_WWWv, __Z43CanvasRenderer_Get_Custom_PropAbsoluteDepthP12Il2CppObject: __Z43CanvasRenderer_Get_Custom_PropAbsoluteDepthP12Il2CppObject, __ZN19AssetBundleManifest8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19AssetBundleManifest8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK9Heightmap21GetInterpolatedNormalEff: __ZNK9Heightmap21GetInterpolatedNormalEff, __ZN5physx14PxsAABBManager22computeAABBUpdateListsEPjjRKNS_20PxsComputeAABBParamsE: __ZN5physx14PxsAABBManager22computeAABBUpdateListsEPjjRKNS_20PxsComputeAABBParamsE, __Z52Register_UnityEngine_AudioSource_SetScheduledEndTimev: __Z52Register_UnityEngine_AudioSource_SetScheduledEndTimev, __Z45ReflectionProbe_Get_Custom_PropShadowDistanceP12Il2CppObject: __Z45ReflectionProbe_Get_Custom_PropShadowDistanceP12Il2CppObject, __ZN5physx7NpScene12loadFromDescERKNS_11PxSceneDescE: __ZN5physx7NpScene12loadFromDescERKNS_11PxSceneDescE, __Z55Register_UnityEngine_BillboardAsset_GetVerticesInternalv: __Z55Register_UnityEngine_BillboardAsset_GetVerticesInternalv, __ZNK10FileSystem16LastErrorMessageEv: __ZNK10FileSystem16LastErrorMessageEv, __Z38WindZone_Get_Custom_PropWindTurbulenceP12Il2CppObject: __Z38WindZone_Get_Custom_PropWindTurbulenceP12Il2CppObject, __ZN12TreeDatabase19UpdateTreeInstancesEv: __ZN12TreeDatabase19UpdateTreeInstancesEv, __ZN22RenderingCommandBuffer23AddSetGlobalVectorArrayERKN9ShaderLab16FastPropertyNameEPK8Vector4fi: __ZN22RenderingCommandBuffer23AddSetGlobalVectorArrayERKN9ShaderLab16FastPropertyNameEPK8Vector4fi, __ZNK15dtProximityGrid9getBoundsEPi: __ZNK15dtProximityGrid9getBoundsEPi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj389ENS_22PxRepXPropertyAccessorILj389ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj389ENS_22PxRepXPropertyAccessorILj389ES4_ffEEEEvRKT0_, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl11deriveClassERKN5physx8debugger14NamespacedNameES5_: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl11deriveClassERKN5physx8debugger14NamespacedNameES5_, __ZN11TimeManager16HasFixedTimeStepEv: __ZN11TimeManager16HasFixedTimeStepEv, __ZN22UnityWebRequestManager10InitializeEv: __ZN22UnityWebRequestManager10InitializeEv, __ZN17PersistentManager24GetTypeFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx: __ZN17PersistentManager24GetTypeFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx, __ZN13MonoBehaviour13AwakeFromLoadE17AwakeFromLoadMode: __ZN13MonoBehaviour13AwakeFromLoadE17AwakeFromLoadMode, __ZN5Unity17ConfigurableJoint19SetLowAngularXLimitERK14SoftJointLimit: __ZN5Unity17ConfigurableJoint19SetLowAngularXLimitERK14SoftJointLimit, __ZN16CircleCollider2D14CreateInternalEP11Rigidbody2D: __ZN16CircleCollider2D14CreateInternalEP11Rigidbody2D, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15Lz4Decompressor18ValidateBufferSizeEj: __ZN15Lz4Decompressor18ValidateBufferSizeEj, __ZL31InitializeClothScriptingClassesv: __ZL31InitializeClothScriptingClassesv, __ZN12CachedWriter9InitWriteER15CacheWriterBase: __ZN12CachedWriter9InitWriteER15CacheWriterBase, __Z21UnsignedInt64ToStringy: __Z21UnsignedInt64ToStringy, __Z56DynamicGI_CUSTOM_INTERNAL_CALL_UpdateMaterialsForTerrainP12Il2CppObjectRK5RectTIfE: __Z56DynamicGI_CUSTOM_INTERNAL_CALL_UpdateMaterialsForTerrainP12Il2CppObjectRK5RectTIfE, __Z58RenderTexture_CUSTOM_INTERNAL_CALL_GetNativeDepthBufferPtrP12Il2CppObjectRPv: __Z58RenderTexture_CUSTOM_INTERNAL_CALL_GetNativeDepthBufferPtrP12Il2CppObjectRPv, __ZN5physx14PxsAABBManager15createAggregateEPvb: __ZN5physx14PxsAABBManager15createAggregateEPvb, __ZL19InitializeModule_VRv: __ZL19InitializeModule_VRv, _alloc_sarray: _alloc_sarray, __Z66Register_UnityEngine_Application_RequestAdvertisingIdentifierAsyncv: __Z66Register_UnityEngine_Application_RequestAdvertisingIdentifierAsyncv, __Z44AudioReverbFilter_Get_Custom_PropHfReferenceP12Il2CppObject: __Z44AudioReverbFilter_Get_Custom_PropHfReferenceP12Il2CppObject, __ZN5Umbra21UserCallbackAllocatorD0Ev: __ZN5Umbra21UserCallbackAllocatorD0Ev, __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEEEvRT_j, __Z66Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformPointv: __Z66Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformPointv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv, __ZNK13SplatDatabase15GetAlphaTextureEi: __ZNK13SplatDatabase15GetAlphaTextureEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __ZN12LineRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN12LineRenderer8TransferI14SafeBinaryReadEEvRT_, __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI15ComputeShaderCBNS0_9allocatorIS2_EEEEEvRT_j, __ZN6Camera26ClearIntermediateRenderersEj: __ZN6Camera26ClearIntermediateRenderersEj, __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_23PxVehicleDriveSimData4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN13TargetJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN13TargetJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __Z62Register_UnityEngine_DistanceJoint2D_set_autoConfigureDistancev: __Z62Register_UnityEngine_DistanceJoint2D_set_autoConfigureDistancev, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZv, __ZN18ScriptingArguments8AddInt64Ex: __ZN18ScriptingArguments8AddInt64Ex, __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatBGR888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatBGR888EEvPKNS_9InnerInfoE, __Z73Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderComponentv: __Z73Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderComponentv, __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN17CollisionMeshData7CleanupEv: __ZN17CollisionMeshData7CleanupEv, __ZN23iPhoneLocalNotificationaSERKS_: __ZN23iPhoneLocalNotificationaSERKS_, __Z39TrailRenderer_Get_Custom_PropStartWidthP12Il2CppObject: __Z39TrailRenderer_Get_Custom_PropStartWidthP12Il2CppObject, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, __ZN10SampleClip8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10SampleClip8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Umbra9FloatListaSERKS0_: __ZN5Umbra9FloatListaSERKS0_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv: __ZNK13Simd4fFactoryIN6detail7IntTypeILi0EEEEcv8Scalar4fEv, __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z35Register_UnityEngine_Event_set_typev: __Z35Register_UnityEngine_Event_set_typev, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwjj, __Z46Register_UnityEngine_Rigidbody2D_get_sleepModev: __Z46Register_UnityEngine_Rigidbody2D_get_sleepModev, __ZN11JointSpring8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11JointSpring8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z29DirectorPlayer_CUSTOM_GetTimeP12Il2CppObject: __Z29DirectorPlayer_CUSTOM_GetTimeP12Il2CppObject, __ZN5physx2Gu30computeCapsule_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbRNS_10PxSweepHitE: __ZN5physx2Gu30computeCapsule_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbRNS_10PxSweepHitE, __Z34Display_CUSTOM_GetRenderingExtImpl13Il2Cpp_IntPtrPiS0_: __Z34Display_CUSTOM_GetRenderingExtImpl13Il2Cpp_IntPtrPiS0_, __Z47Canvas_Get_Custom_PropNormalizedSortingGridSizeP12Il2CppObject: __Z47Canvas_Get_Custom_PropNormalizedSortingGridSizeP12Il2CppObject, __Z40getPxRigidBody_MassSpaceInvInertiaTensorPKN5physx11PxRigidBodyE: __Z40getPxRigidBody_MassSpaceInvInertiaTensorPKN5physx11PxRigidBodyE, __ZN5physx2Sc21ArticulationJointCore22setTangentialStiffnessEf: __ZN5physx2Sc21ArticulationJointCore22setTangentialStiffnessEf, __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __Z49ParticleSystem_LightsModule_CUSTOM_SetLightPrefabP12Il2CppObjectS0_: __Z49ParticleSystem_LightsModule_CUSTOM_SetLightPrefabP12Il2CppObjectS0_, __Z27Light_Get_Custom_PropCookieP12Il2CppObject: __Z27Light_Get_Custom_PropCookieP12Il2CppObject, __ZNK5physx20SingleAABBUpdateTask7getNameEv: __ZNK5physx20SingleAABBUpdateTask7getNameEv, __ZN14ImageReference10FlipImageYEv: __ZN14ImageReference10FlipImageYEv, __Z29Input_CUSTOM_GetKeyDownStringP12Il2CppString: __Z29Input_CUSTOM_GetKeyDownStringP12Il2CppString, __Z8FileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z8FileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z43Register_UnityEngine_Animation_set_wrapModev: __Z43Register_UnityEngine_Animation_set_wrapModev, __ZN21InheritVelocityModule8TransferI17RemapPPtrTransferEEvRT_: __ZN21InheritVelocityModule8TransferI17RemapPPtrTransferEEvRT_, __ZN10Collider2D4CastERK8Vector2ffbP12RaycastHit2Di: __ZN10Collider2D4CastERK8Vector2ffbP12RaycastHit2Di, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TargetEyeMaskEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TargetEyeMaskEvRT_RT0_PKc17TransferMetaFlags, __Z14GetDefaultSkini: __Z14GetDefaultSkini, __Z44Register_UnityEngine_ParticleSystem_set_loopv: __Z44Register_UnityEngine_ParticleSystem_set_loopv, __Z54ParticleSystem_LightsModule_CUSTOM_SetSizeAffectsRangeP12Il2CppObjecth: __Z54ParticleSystem_LightsModule_CUSTOM_SetSizeAffectsRangeP12Il2CppObjecth, _erff: _erff, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _erfc: _erfc, __ZN4FMOD3DSP9setBypassEb: __ZN4FMOD3DSP9setBypassEb, _jsimd_h2v2_merged_upsample: _jsimd_h2v2_merged_upsample, __Z19NormalizeWheelInputf: __Z19NormalizeWheelInputf, __Z29StdTemplateConversionFunctionIsaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsaEbPvR14SafeBinaryRead, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE8ValidateEPS1_: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE8ValidateEPS1_, __ZN16BaseVideoTexture17MainThreadCleanupEv: __ZN16BaseVideoTexture17MainThreadCleanupEv, __Z29Transfer_Blittable_ArrayFieldI8JSONReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN11MonoManager25GetImageFromAssemblyIndexEi: __ZN11MonoManager25GetImageFromAssemblyIndexEi, __ZN5physx2Sc9ClothCore17addCollisionPlaneERKNS_21PxClothCollisionPlaneE: __ZN5physx2Sc9ClothCore17addCollisionPlaneERKNS_21PxClothCollisionPlaneE, __Z52QualitySettings_Get_Custom_PropAsyncUploadBufferSizev: __Z52QualitySettings_Get_Custom_PropAsyncUploadBufferSizev, __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateClearImmediateRenderersstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateClearImmediateRenderersstruct7ForwardEv, __Z18Transfer_BlittableI9JSONWriteLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j, __Z34MeshCollider_Get_Custom_PropConvexP12Il2CppObject: __Z34MeshCollider_Get_Custom_PropConvexP12Il2CppObject, __Z37Matrix4x4_CUSTOM_INTERNAL_CALL_InvertRK10Matrix4x4fPS_: __Z37Matrix4x4_CUSTOM_INTERNAL_CALL_InvertRK10Matrix4x4fPS_, __ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN5physx2Gu27pcmContactConvexHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu27pcmContactConvexHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNK5physx13PxHeightField8isKindOfEPKc: __ZNK5physx13PxHeightField8isKindOfEPKc, __ZN10HumanTrait19GetMuscleDefaultMinEi: __ZN10HumanTrait19GetMuscleDefaultMinEi, __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_: __ZNSt3__26__sortIRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_, __ZN5Unity5Cloth25SetUseContinuousCollisionEb: __ZN5Unity5Cloth25SetUseContinuousCollisionEb, __ZN16GraphicsSettings12CleanupClassEv: __ZN16GraphicsSettings12CleanupClassEv, _mclose: _mclose, __ZNK11AudioSource26GetTypeInfoVirtualInternalEv: __ZNK11AudioSource26GetTypeInfoVirtualInternalEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj42ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj42ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11MonoManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11MonoManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN17PersistentManager11GetPathNameEi: __ZN17PersistentManager11GetPathNameEi, __ZNK5physx2Sc18ParticleSystemCore16getInternalFlagsEv: __ZNK5physx2Sc18ParticleSystemCore16getInternalFlagsEv, __ZN18BackgroundJobQueue11ScheduleJobEPFvPvES0_: __ZN18BackgroundJobQueue11ScheduleJobEPFvPvES0_, __ZN19StreamedBinaryWriteILb0EE8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags, _unity_z_inflateSetDictionary: _unity_z_inflateSetDictionary, __ZNK13WheelCollider12GetLocalPoseER8Vector3fR11Quaternionf: __ZNK13WheelCollider12GetLocalPoseER8Vector3fR11Quaternionf, __Z28RemoteSettings_CUSTOM_GetIntP12Il2CppStringi: __Z28RemoteSettings_CUSTOM_GetIntP12Il2CppStringi, __ZN16ControllerFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE: __ZN16ControllerFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE, __ZN11UnityEngine15CloudWebService14DataDispatcher15SetupWebRequestEv: __ZN11UnityEngine15CloudWebService14DataDispatcher15SetupWebRequestEv, __ZN13TrailRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f: __ZN13TrailRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_S8_EEiEERKT_, __ZN11UnityEngine15PlatformWrapper13GetShaderCapsEv: __ZN11UnityEngine15PlatformWrapper13GetShaderCapsEv, __ZN10AudioMixer14OnExitPlayModeEv: __ZN10AudioMixer14OnExitPlayModeEv, __ZN18AssetBundleManager32AddAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation: __ZN18AssetBundleManager32AddAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation, __ZN16MBPOS_TmpBuffers16allocateSleepingEjj: __ZN16MBPOS_TmpBuffers16allocateSleepingEjj, __Z51Register_UnityEngine_TrailRenderer_set_autodestructv: __Z51Register_UnityEngine_TrailRenderer_set_autodestructv, __Z26getPxVehicleWheelDataMMassPKN5physx18PxVehicleWheelDataE: __Z26getPxVehicleWheelDataMMassPKN5physx18PxVehicleWheelDataE, __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f: __Z18QuaternionToMatrixRK11QuaternionfR10Matrix3x3f, __Z40RenderBufferHelper_CUSTOM_SetStoreActionP21ScriptingRenderBufferi: __Z40RenderBufferHelper_CUSTOM_SetStoreActionP21ScriptingRenderBufferi, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI24GenerateTypeTreeTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI24GenerateTypeTreeTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z24getPxRevoluteJoint_AnglePKN5physx15PxRevoluteJointE: __Z24getPxRevoluteJoint_AnglePKN5physx15PxRevoluteJointE, __ZN19CharacterController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN19CharacterController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14SplatPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14SplatPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_png_free_data: _UNITY_png_free_data, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5flushEv, __ZN13SliderJoint2D5ResetEv: __ZN13SliderJoint2D5ResetEv, __ZN15CollisionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15CollisionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx8debugger14PvdMarshallingIatE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIatE12marshalBlockEPKhPhj, __Z32LODGroup_Set_Custom_PropFadeModeP12Il2CppObjectN8LODGroup11LODFadeModeE: __Z32LODGroup_Set_Custom_PropFadeModeP12Il2CppObjectN8LODGroup11LODFadeModeE, __ZNK20TextRenderingPrivate7FontRefltERKS0_: __ZNK20TextRenderingPrivate7FontRefltERKS0_, __ZN19RuntimeSceneManager24BeginIntegrateMainThreadEP10UnityScene: __ZN19RuntimeSceneManager24BeginIntegrateMainThreadEP10UnityScene, __ZN5physx17PxsFluidCollision23updateOverflowParticlesEv: __ZN5physx17PxsFluidCollision23updateOverflowParticlesEv, __ZN5physx14NpArticulation26setExternalDriveIterationsEj: __ZN5physx14NpArticulation26setExternalDriveIterationsEj, __Z27getPxCloth_PreviousTimeStepPKN5physx7PxClothE: __Z27getPxCloth_PreviousTimeStepPKN5physx7PxClothE, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale1Ev, _jsimd_idct_2x2: _jsimd_idct_2x2, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERPv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERPv, __Z41BillboardAsset_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_: __Z41BillboardAsset_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_, __ZN9ShaderLab20SerializedSubProgramaSERKS0_: __ZN9ShaderLab20SerializedSubProgramaSERKS0_, _roundf: _roundf, __ZN9JSONWrite10SetVersionEi: __ZN9JSONWrite10SetVersionEi, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, _roundl: _roundl, __Z36setPxVehicleDriveDynData_AnalogInputPN5physx21PxVehicleDriveDynDataEjf: __Z36setPxVehicleDriveDynData_AnalogInputPN5physx21PxVehicleDriveDynDataEjf, __ZN16SubstanceArchive23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16SubstanceArchive23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx15PxBoxControllerD0Ev: __ZN5physx15PxBoxControllerD0Ev, __ZN8Animator15SetPrepareStageEv: __ZN8Animator15SetPrepareStageEv, __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_suspensionSpringv: __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_suspensionSpringv, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4trsXEEEclERS3_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4trsXEEEclERS3_17TransferMetaFlagsR9BlobWrite, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj158ENS_22PxRepXPropertyAccessorILj158ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj158ENS_22PxRepXPropertyAccessorILj158ES4_ffEEEEvRKT0_, __ZN8AnimatorC2E10MemLabelId18ObjectCreationMode: __ZN8AnimatorC2E10MemLabelId18ObjectCreationMode, _getegid: _getegid, __Z24RegisterStrippedTypeInfoI10TagManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI10TagManagerEviPKcS2_, __ZN6Socket10CheckErrorEiPKcii: __ZN6Socket10CheckErrorEiPKcii, __ZN9Scripting32GetScriptingArrayStringStartImplEP11Il2CppArray: __ZN9Scripting32GetScriptingArrayStringStartImplEP11Il2CppArray, __Z20CalculateLightMatrixRK15SharedLightDataP10Matrix4x4f: __Z20CalculateLightMatrixRK15SharedLightDataP10Matrix4x4f, __Z65SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddAmbientLightInternalRK10ColorRGBAfR20SphericalHarmonicsL2: __Z65SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddAmbientLightInternalRK10ColorRGBAfR20SphericalHarmonicsL2, _destroy_face: _destroy_face, __ZN7mecanim8skeleton8IdentityIN4math4trsXEEET_v: __ZN7mecanim8skeleton8IdentityIN4math4trsXEEET_v, __ZN7mecanim9animation19DestroyStreamedClipERNS0_12StreamedClipERNS_6memory9AllocatorE: __ZN7mecanim9animation19DestroyStreamedClipERNS0_12StreamedClipERNS_6memory9AllocatorE, __Z49Register_UnityEngine_AI_NavMeshAgent_StopInternalv: __Z49Register_UnityEngine_AI_NavMeshAgent_StopInternalv, __ZN5physx19PxAllocatorCallbackD2Ev: __ZN5physx19PxAllocatorCallbackD2Ev, __Z24RegisterStrippedTypeInfoI6ShaderEviPKcS2_: __Z24RegisterStrippedTypeInfoI6ShaderEviPKcS2_, __ZN21RotationBySpeedModuleD0Ev: __ZN21RotationBySpeedModuleD0Ev, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE17getDominanceGroupEv, __ZN20SoundChannelInstance7setMuteEb: __ZN20SoundChannelInstance7setMuteEb, __ZN7mecanim5human12BoneFromTDoFEi: __ZN7mecanim5human12BoneFromTDoFEi, __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI5LightE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Cct26CharacterControllerManager21createObstacleContextEv: __ZN5physx3Cct26CharacterControllerManager21createObstacleContextEv, __Z49Register_UnityEngine_RectOffset_INTERNAL_CALL_Addv: __Z49Register_UnityEngine_RectOffset_INTERNAL_CALL_Addv, __Z46Register_UnityEngine_Collider2D_get_errorStatev: __Z46Register_UnityEngine_Collider2D_get_errorStatev, __ZNSt3__210moneypunctIcLb0EED2Ev: __ZNSt3__210moneypunctIcLb0EED2Ev, __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26__sortIRNS_6__lessIyyEEPyEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIyyEEPyEEvT0_S5_T_, __Z30Compass_Set_Custom_PropEnabledP12Il2CppObjecth: __Z30Compass_Set_Custom_PropEnabledP12Il2CppObjecth, __ZN7b2World18SetContactListenerEP17b2ContactListener: __ZN7b2World18SetContactListenerEP17b2ContactListener, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7releaseEv: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7releaseEv, __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE8__appendEj, __ZN15ParticleEmitter14ClearParticlesEv: __ZN15ParticleEmitter14ClearParticlesEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN15OcclusionPortal8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15OcclusionPortal8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12CachedReader4ReadEPvj: __ZN12CachedReader4ReadEPvj, _cfgetispeed: _cfgetispeed, __ZN5physx21MBPPostUpdateWorkTaskD0Ev: __ZN5physx21MBPPostUpdateWorkTaskD0Ev, __ZN5Umbra15BufferAllocator11findFreeRunEi: __ZN5Umbra15BufferAllocator11findFreeRunEi, __Z9IsSymlinkRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z9IsSymlinkRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, _cf2_blues_init: _cf2_blues_init, __ZN5physx2Sc8BodyCore24clearSpatialAccelerationEbb: __ZN5physx2Sc8BodyCore24clearSpatialAccelerationEbb, __ZN8VRDevice10PostRenderEPK6Camera: __ZN8VRDevice10PostRenderEPK6Camera, __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12_GLOBAL__N_115StringTableImpl7getStrsEPPKcjj: __ZN12_GLOBAL__N_115StringTableImpl7getStrsEPPKcjj, __ZN13OpenFileCacheD2Ev: __ZN13OpenFileCacheD2Ev, __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f: __Z24CalculateLightShadowFadeRK6CamerafffR8Vector4f, __ZN19RuntimeSceneManagerD2Ev: __ZN19RuntimeSceneManagerD2Ev, __ZN10AtomicList5RelaxEv: __ZN10AtomicList5RelaxEv, __ZN9dtNavMesh14unconnectLinksEP10dtMeshTile: __ZN9dtNavMesh14unconnectLinksEP10dtMeshTile, __Z44Register_UnityEngine_Terrain_get_castShadowsv: __Z44Register_UnityEngine_Terrain_get_castShadowsv, __Z48Register_UnityEngine_LineRenderer_set_widthCurvev: __Z48Register_UnityEngine_LineRenderer_set_widthCurvev, __ZN6prcore17GetIntegerBlitterE13TextureFormatS0_N14ImageReference8BlitModeE: __ZN6prcore17GetIntegerBlitterE13TextureFormatS0_N14ImageReference8BlitModeE, __Z49ParticleRenderer_Get_Custom_PropUvAnimationCyclesP12Il2CppObject: __Z49ParticleRenderer_Get_Custom_PropUvAnimationCyclesP12Il2CppObject, __ZN5physx10PxsContext20createContactManagerERKNS_24PxvManagerDescRigidRigidEPNS_18PxsMaterialManagerE: __ZN5physx10PxsContext20createContactManagerERKNS_24PxvManagerDescRigidRigidEPNS_18PxsMaterialManagerE, __ZN13WheelCollider8TransferI14SafeBinaryReadEEvRT_: __ZN13WheelCollider8TransferI14SafeBinaryReadEEvRT_, __ZN13BoxCollider2DD0Ev: __ZN13BoxCollider2DD0Ev, __ZN5physx7profile15ZoneManagerImplD2Ev: __ZN5physx7profile15ZoneManagerImplD2Ev, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEED0Ev, __Z24RegisterStrippedTypeInfoI13OcclusionAreaEviPKcS2_: __Z24RegisterStrippedTypeInfoI13OcclusionAreaEviPKcS2_, __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE: __ZN5physx2Sc5Scene31removeActiveBreakableConstraintEPNS0_13ConstraintSimE, __ZN16BaseVideoTexture29CreateGfxTextureAndUploadDataEv: __ZN16BaseVideoTexture29CreateGfxTextureAndUploadDataEv, __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN12_GLOBAL__N_116MetaDataProvider15isInstanceValidEPKv: __ZN12_GLOBAL__N_116MetaDataProvider15isInstanceValidEPKv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm, __ZN17Physics2DSettings20SetBaumgarteTOIScaleEf: __ZN17Physics2DSettings20SetBaumgarteTOIScaleEf, __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj: __ZN9BlobWrite14ReduceCopyImplERK14ReduceCopyDataj, __ZN11AudioSource18IsPlayingScriptingEv: __ZN11AudioSource18IsPlayingScriptingEv, __Z60Register_UnityEngine_ParticleSystemRenderer_get_sortingFudgev: __Z60Register_UnityEngine_ParticleSystemRenderer_get_sortingFudgev, __ZNK12b2WheelJoint10GetAnchorAEv: __ZNK12b2WheelJoint10GetAnchorAEv, __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z32GetMousePositionFromInputManagerv: __Z32GetMousePositionFromInputManagerv, __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE: __ZNK22BuiltinResourceManager11GetResourceEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE, __ZN5physx2Gu27pcmContactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu27pcmContactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN19MeshParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN19MeshParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode, __Z32getPxHeightFieldGeometryRowScalePKN5physx21PxHeightFieldGeometryE: __Z32getPxHeightFieldGeometryRowScalePKN5physx21PxHeightFieldGeometryE, __ZN13TextRendering4Font8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13TextRendering4Font8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17CommonStringTableC2Ev: __ZN17CommonStringTableC2Ev, __Z40Register_UnityEngine_Animation_CrossFadev: __Z40Register_UnityEngine_Animation_CrossFadev, __Z37CleanupLightAnimationBindingInterfacev: __Z37CleanupLightAnimationBindingInterfacev, __Z33getPxClothFabric_ConcreteTypeNamePKN5physx13PxClothFabricE: __Z33getPxClothFabric_ConcreteTypeNamePKN5physx13PxClothFabricE, __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE: __ZN5physx8debugger8renderer22LinearLimitRenderEvent9serializeERNS1_16RenderSerializerE, __ZN13ComputeShader15SetTextureParamEjRKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension: __ZN13ComputeShader15SetTextureParamEjRKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension, __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_: __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_SC_EEiEESF_RKT_, __ZN15QualitySettings27SetRealtimeReflectionProbesEb: __ZN15QualitySettings27SetRealtimeReflectionProbesEb, __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx2Sc14ConstraintCore8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, _jpeg_consume_input: _jpeg_consume_input, __Z73Register_UnityEngine_GeometryUtility_INTERNAL_CALL_Internal_ExtractPlanesv: __Z73Register_UnityEngine_GeometryUtility_INTERNAL_CALL_Internal_ExtractPlanesv, __ZN15GUIEventManager10QueueEventERK10InputEvent: __ZN15GUIEventManager10QueueEventERK10InputEvent, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj86ENS_22PxRepXPropertyAccessorILj86ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj86ENS_22PxRepXPropertyAccessorILj86ES4_jjEEEEvjRKT0_, __Z52Register_UnityEngine_AudioReverbZone_set_reverbDelayv: __Z52Register_UnityEngine_AudioReverbZone_set_reverbDelayv, __ZN5physx2Gu13RTreeMidphase17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu13RTreeMidphase17getBinaryMetaDataERNS_14PxOutputStreamE, __Z27GL_Get_Custom_PropSRGBWritev: __Z27GL_Get_Custom_PropSRGBWritev, __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN21AnimationPosePlayableD0Ev: __ZN21AnimationPosePlayableD0Ev, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE6SetUrlERK8UnityStr: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE6SetUrlERK8UnityStr, __ZN5physx2Sq8AABBTree11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq8AABBTree11shiftOriginERKNS_6PxVec3E, __Z53Register_UnityEngine_AndroidJNI_GetStaticBooleanFieldv: __Z53Register_UnityEngine_AndroidJNI_GetStaticBooleanFieldv, __Z38Register_UnityEngine_Caching_get_readyv: __Z38Register_UnityEngine_Caching_get_readyv, __Z30ComputeShader_CUSTOM_HasKernelP12Il2CppObjectP12Il2CppString: __Z30ComputeShader_CUSTOM_HasKernelP12Il2CppObjectP12Il2CppString, __Z44Register_UnityEngine_RenderTexture_set_depthv: __Z44Register_UnityEngine_RenderTexture_set_depthv, _strrchr: _strrchr, __ZN5physx31PxClothGeodesicTetherCookerImplC2ERKNS_15PxClothMeshDescE: __ZN5physx31PxClothGeodesicTetherCookerImplC2ERKNS_15PxClothMeshDescE, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN5physx2Sc7BodySim6wakeUpEv: __ZN5physx2Sc7BodySim6wakeUpEv, __ZN11UnityEngine9Animation28GenericAnimationBindingCache25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding: __ZN11UnityEngine9Animation28GenericAnimationBindingCache25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding, __ZN5physx8debugger4comm19EndSetPropertyValueD0Ev: __ZN5physx8debugger4comm19EndSetPropertyValueD0Ev, __ZN12_GLOBAL__N_117EventBufferClient15sendEventBufferEN5physx8debugger7DataRefIKhEEjy: __ZN12_GLOBAL__N_117EventBufferClient15sendEventBufferEN5physx8debugger7DataRefIKhEEjy, __ZN5Cache28SetMaximumDiskSpaceAvailableEx: __ZN5Cache28SetMaximumDiskSpaceAvailableEx, __ZN5physx2Sc21ConstraintInteraction7destroyEv: __ZN5physx2Sc21ConstraintInteraction7destroyEv, __ZN14SphereCollider6CreateEPK9Rigidbody: __ZN14SphereCollider6CreateEPK9Rigidbody, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_, __Z33Register_UnityEngine_Random_Rangev: __Z33Register_UnityEngine_Random_Rangev, _recvfrom: _recvfrom, __Z27Object_CUSTOM_DestroyObjectP12Il2CppObjectf: __Z27Object_CUSTOM_DestroyObjectP12Il2CppObjectf, __ZN5physx13PxsSolverCoreD2Ev: __ZN5physx13PxsSolverCoreD2Ev, __ZN5physx3Ext7D6JointC2ERKNS_17PxTolerancesScaleEPNS_12PxRigidActorERKNS_11PxTransformES6_S9_: __ZN5physx3Ext7D6JointC2ERKNS_17PxTolerancesScaleEPNS_12PxRigidActorERKNS_11PxTransformES6_S9_, __ZN16MemoryFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN16MemoryFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK8VRDevice14GetRenderScaleEv: __ZNK8VRDevice14GetRenderScaleEv, __Z40ReflectionProbe_Get_Custom_PropIntensityP12Il2CppObject: __Z40ReflectionProbe_Get_Custom_PropIntensityP12Il2CppObject, __ZN19TouchPhaseEmulation13AddTouchEventEiffNS_10TouchPhaseExNS_8TimeUnitE: __ZN19TouchPhaseEmulation13AddTouchEventEiffNS_10TouchPhaseExNS_8TimeUnitE, __ZN13TrailRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13TrailRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx7NpScene16getNbConstraintsEv: __ZNK5physx7NpScene16getNbConstraintsEv, __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx3Ext14PrismaticJoint11getVelocityEv: __ZNK5physx3Ext14PrismaticJoint11getVelocityEv, __ZN5physx7NpCloth14setWakeCounterEf: __ZN5physx7NpCloth14setWakeCounterEf, __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_, __Z26Random_Set_Custom_PropSeedi: __Z26Random_Set_Custom_PropSeedi, __Z54Register_UnityEngine_Graphics_Internal_SetMRTFullSetupv: __Z54Register_UnityEngine_Graphics_Internal_SetMRTFullSetupv, __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13SpringJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_10StartEventEEEvtRKT_, __Z51Register_UnityEngine_ParticleSystem_get_scalingModev: __Z51Register_UnityEngine_ParticleSystem_get_scalingModev, __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE8recreateEj, _ps_hints_t2mask: _ps_hints_t2mask, __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs5setupEjjPPKNS_10PxMaterialEPKNS_28PxVehicleDrivableSurfaceTypeE: __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs5setupEjjPPKNS_10PxMaterialEPKNS_28PxVehicleDrivableSurfaceTypeE, __ZN5physx2Sc27ConstraintProjectionManager33markConnectedConstraintsForUpdateERNS0_7BodySimEPNS0_13ConstraintSimE: __ZN5physx2Sc27ConstraintProjectionManager33markConnectedConstraintsForUpdateERNS0_7BodySimEPNS0_13ConstraintSimE, __ZN5physx28PxArticulationRepXSerializerD0Ev: __ZN5physx28PxArticulationRepXSerializerD0Ev, __ZNK5physx2Gu18ConvexHullNoScaleV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_: __ZNK5physx2Gu18ConvexHullNoScaleV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_, __ZN18UnityConnectClient11HandleAdsIdEv: __ZN18UnityConnectClient11HandleAdsIdEv, __ZN10BlendShape8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10BlendShape8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib: __ZL4WalkRK16TypeTreeIteratorR12CachedReaderPib, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv, __ZNK5physx2Gu11HeightField17getReferenceCountEv: __ZNK5physx2Gu11HeightField17getReferenceCountEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip8LoadTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip8LoadTypeEEvRT_RT0_PKc17TransferMetaFlags, __Z19GetTimeSinceStartupv: __Z19GetTimeSinceStartupv, __Z45UnityWebRequest_Get_Custom_PropUploadProgressP12Il2CppObject: __Z45UnityWebRequest_Get_Custom_PropUploadProgressP12Il2CppObject, __ZN7Texture23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN7Texture23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9Animation22ReleaseAnimationStatesEv: __ZN9Animation22ReleaseAnimationStatesEv, __Z44Physics_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK8Vector3fS1_S1_P11Il2CppArrayRK11Quaternionffi23QueryTriggerInteraction: __Z44Physics_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK8Vector3fS1_S1_P11Il2CppArrayRK11Quaternionffi23QueryTriggerInteraction, _TT_Load_Composite_Glyph: _TT_Load_Composite_Glyph, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev, __ZN13ConstantForce23VirtualRedirectTransferER14SafeBinaryRead: __ZN13ConstantForce23VirtualRedirectTransferER14SafeBinaryRead, __Z53Register_UnityEngine_Texture_set_anisotropicFilteringv: __Z53Register_UnityEngine_Texture_set_anisotropicFilteringv, __Z27Physics2D_CUSTOM_IsTouchingP12Il2CppObjectS0_: __Z27Physics2D_CUSTOM_IsTouchingP12Il2CppObjectS0_, __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j: __Z33MultiplyMatrixArrayWithBase4x4REFPK10Matrix4x4fS1_S1_PS_j, __Z37AudioSettings_CUSTOM_SetDSPBufferSizeii: __Z37AudioSettings_CUSTOM_SetDSPBufferSizeii, __Z37Cubemap_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiiR10ColorRGBAf: __Z37Cubemap_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiiR10ColorRGBAf, _getc_unlocked: _getc_unlocked, __ZN24iPhoneRemoteNotification10UnregisterEv: __ZN24iPhoneRemoteNotification10UnregisterEv, __ZN15HeightMeshQueryD0Ev: __ZN15HeightMeshQueryD0Ev, __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb0EEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb0EEEEEvRKS1_, __ZN29RenderNodeQueuePrepareContextC2Ev: __ZN29RenderNodeQueuePrepareContextC2Ev, __ZNK5physx27PxClothGeodesicTetherCooker15getCookerStatusEv: __ZNK5physx27PxClothGeodesicTetherCooker15getCookerStatusEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Umbra6RandomC2Ev: __ZN5Umbra6RandomC2Ev, __ZN5physx27solveContactCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx27solveContactCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEj, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv, __ZN15dtLocalBoundary6updateEyPKffPK14dtNavMeshQueryPK13dtQueryFilter: __ZN15dtLocalBoundary6updateEyPKffPK14dtNavMeshQueryPK13dtQueryFilter, __ZNSt3__214__num_put_base12__format_intEPcPKcbj: __ZNSt3__214__num_put_base12__format_intEPcPKcbj, __Z41Register_UnityEngine_Animation_PlayQueuedv: __Z41Register_UnityEngine_Animation_PlayQueuedv, __ZL34GetComponentsImplementationRecurseILb1ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN5Unity14CharacterJoint5ResetEv: __ZN5Unity14CharacterJoint5ResetEv, __Z51MaterialPropertyBlock_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_: __Z51MaterialPropertyBlock_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_, __ZN5physx6shdfnd5ArrayINS_5cloth8SwSolver22CpuClothSimulationTaskENS0_9AllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth8SwSolver22CpuClothSimulationTaskENS0_9AllocatorEE15growAndPushBackERKS4_, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN18CrashReportManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN18CrashReportManager23VirtualRedirectTransferER14SafeBinaryRead, __ZNK13RenderTexture13GetDataHeightEv: __ZNK13RenderTexture13GetDataHeightEv, __ZN13RenderManager23AddRemoveCamerasDelayedEv: __ZN13RenderManager23AddRemoveCamerasDelayedEv, __Z60Register_UnityEngine_ParticleSystemRenderer_set_sortingFudgev: __Z60Register_UnityEngine_ParticleSystemRenderer_set_sortingFudgev, _UNITY_png_write_pHYs: _UNITY_png_write_pHYs, __ZN23PreloadManagerOperation11GetPriorityEv: __ZN23PreloadManagerOperation11GetPriorityEv, __ZThn4_N12_GLOBAL__N_110ConnectionD1Ev: __ZThn4_N12_GLOBAL__N_110ConnectionD1Ev, ___mremap: ___mremap, __ZN9Heightmap8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Heightmap8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __ZN5audio5mixer25FindAudioEffectDefinitionERKNS0_18AudioMixerConstantEj: __ZN5audio5mixer25FindAudioEffectDefinitionERKNS0_18AudioMixerConstantEj, __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_: __ZNK5Unity5Joint16GetCurrentForcesER8Vector3fS2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj69ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj69ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12LineRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN12LineRenderer13AwakeFromLoadE17AwakeFromLoadMode, __Z35getPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataEj: __Z35getPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataEj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags, __Z34ComputeBuffer_CUSTOM_DestroyBufferP12Il2CppObject: __Z34ComputeBuffer_CUSTOM_DestroyBufferP12Il2CppObject, __ZN10MemoryFile5WriteEyyPKvPy: __ZN10MemoryFile5WriteEyyPKvPy, __ZN13RenderTexture8SetWidthEi: __ZN13RenderTexture8SetWidthEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZNK28RectTransformPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK28RectTransformPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10MeshFilterD0Ev: __ZN10MeshFilterD0Ev, _UNITY_FT_GlyphLoader_CheckSubGlyphs: _UNITY_FT_GlyphLoader_CheckSubGlyphs, __Z50Register_UnityEngine_FrictionJoint2D_set_maxTorquev: __Z50Register_UnityEngine_FrictionJoint2D_set_maxTorquev, __ZNK11AudioSource25GetCustomRolloffCurveCopyEv: __ZNK11AudioSource25GetCustomRolloffCurveCopyEv, __ZN5physx6shdfnd7FastIPCD2Ev: __ZN5physx6shdfnd7FastIPCD2Ev, __ZN14DetailDatabase9BuildMeshEii8Vector3f16DetailRenderModef: __ZN14DetailDatabase9BuildMeshEii8Vector3f16DetailRenderModef, _UNITY_ft_validator_run: _UNITY_ft_validator_run, __ZN14NavMeshManager13RestoreTileAtEiii: __ZN14NavMeshManager13RestoreTileAtEiii, __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority: __Z26ScheduleJobDependsInternalR8JobFencePFvPvES1_RKS_11JobPriority, __ZN5physx15PxVehicleWheels14setToRestStateEv: __ZN5physx15PxVehicleWheels14setToRestStateEv, __Z42Register_UnityEngine_GUIStyle_set_fontSizev: __Z42Register_UnityEngine_GUIStyle_set_fontSizev, __Z62ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveMultiplierP12Il2CppObject: __Z62ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveMultiplierP12Il2CppObject, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6sbumpcEv, __ZNK5physx9NpFactory11getNbShapesEv: __ZNK5physx9NpFactory11getNbShapesEv, __ZN5physx2Sn5ConvX11getTypeNameEPKci: __ZN5physx2Sn5ConvX11getTypeNameEPKci, __Z13SetLocalEuler15TransformAccessRKN4math7_float3ENS0_13RotationOrderE: __Z13SetLocalEuler15TransformAccessRKN4math7_float3ENS0_13RotationOrderE, __Z58Physics2D_CUSTOM_INTERNAL_CALL_Internal_GetRayIntersectionRK3RayfiP12RaycastHit2D: __Z58Physics2D_CUSTOM_INTERNAL_CALL_Internal_GetRayIntersectionRK3RayfiP12RaycastHit2D, __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4PPtrI6AvatarE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI6AvatarE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_GetRangev: __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_GetRangev, __ZN5Umbra20RuntimeTomeGenerator21combineClusterPortalsEii: __ZN5Umbra20RuntimeTomeGenerator21combineClusterPortalsEii, __ZN9ShaderLab16FastPropertyName4InitEPKc: __ZN9ShaderLab16FastPropertyName4InitEPKc, __ZN11b2GearJointD0Ev: __ZN11b2GearJointD0Ev, __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18PathToAbsolutePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z13RegisterClassIN2UI13RectTransformEEvv: __Z13RegisterClassIN2UI13RectTransformEEvv, __Z29setPxCloth_CollisionMassScalePN5physx7PxClothEf: __Z29setPxCloth_CollisionMassScalePN5physx7PxClothEf, __Z39Register_UnityEngine_Avatar_get_isValidv: __Z39Register_UnityEngine_Avatar_get_isValidv, __ZN10VertexData8TransferI17RemapPPtrTransferEEvRT_: __ZN10VertexData8TransferI17RemapPPtrTransferEEvRT_, __ZN13RenderTexture9SetMipMapEb: __ZN13RenderTexture9SetMipMapEb, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRl, __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z28SetMatrixArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __ZL22CleanupModule_UnityAdsv: __ZL22CleanupModule_UnityAdsv, _UNITY_png_get_rowbytes: _UNITY_png_get_rowbytes, __ZN14RotationModule5ResetEv: __ZN14RotationModule5ResetEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRb, __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_: __Z19MultiplyMatrices3x4RK10Matrix4x4fS1_RS_, __ZN5physx2Sc10ClothShape21updateBoundsInAABBMgrEv: __ZN5physx2Sc10ClothShape21updateBoundsInAABBMgrEv, ___fopen_rb_ca: ___fopen_rb_ca, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRf, __ZNK10TagManager26GetTypeInfoVirtualInternalEv: __ZNK10TagManager26GetTypeInfoVirtualInternalEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRx, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRy, __Z38AudioSource_Get_Custom_PropMaxDistanceP12Il2CppObject: __Z38AudioSource_Get_Custom_PropMaxDistanceP12Il2CppObject, __Z38Transform_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf: __Z38Transform_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf, __ZN7dtCrowd26UpdateTopologyOptimizationEf: __ZN7dtCrowd26UpdateTopologyOptimizationEf, __Z44setPxVehicleWheelsSimData_TireLoadFilterDataPN5physx22PxVehicleWheelsSimDataERKNS_27PxVehicleTireLoadFilterDataE: __Z44setPxVehicleWheelsSimData_TireLoadFilterDataPN5physx22PxVehicleWheelsSimDataERKNS_27PxVehicleTireLoadFilterDataE, __Z24RegisterStrippedTypeInfoI14RenderSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI14RenderSettingsEviPKcS2_, __ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di: __ZN16Physics2DManager18GetRayIntersectionERK8Vector3fS2_fiPK10Collider2DP12RaycastHit2Di, __Z55Register_UnityEngine_Rendering_CommandBuffer_InitBufferv: __Z55Register_UnityEngine_Rendering_CommandBuffer_InitBufferv, __ZN8WindZoneD2Ev: __ZN8WindZoneD2Ev, __ZN7ApiGLES19UploadBufferSubDataEjN2gl12BufferTargetEllPKv: __ZN7ApiGLES19UploadBufferSubDataEjN2gl12BufferTargetEllPKv, __Z51Register_UnityEngine_Physics_get_maxAngularVelocityv: __Z51Register_UnityEngine_Physics_get_maxAngularVelocityv, __ZN5physx2Sc5Scene17createClothSolverEv: __ZN5physx2Sc5Scene17createClothSolverEv, __ZN17CapsuleCollider2D15ThreadedCleanupEv: __ZN17CapsuleCollider2D15ThreadedCleanupEv, __ZdaPv: __ZdaPv, __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT__4448: __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT__4448, __ZNK5physx15PxsParticleData16getMaxParticlesVEv: __ZNK5physx15PxsParticleData16getMaxParticlesVEv, __ZNK16b2PrismaticJoint19GetJointTranslationEv: __ZNK16b2PrismaticJoint19GetJointTranslationEv, __ZN5Umbra18ReceiverMaskBufferaSERKS0_: __ZN5Umbra18ReceiverMaskBufferaSERKS0_, __ZN13RuntimeStaticI21AssetReferenceStorageE13StaticDestroyEPv: __ZN13RuntimeStaticI21AssetReferenceStorageE13StaticDestroyEPv, __Z24RegisterStrippedTypeInfoI5FlareEviPKcS2_: __Z24RegisterStrippedTypeInfoI5FlareEviPKcS2_, __Z40SpriteRenderer_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z40SpriteRenderer_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, __GLOBAL__sub_I_runtime_serialize_lump_cpp: __GLOBAL__sub_I_runtime_serialize_lump_cpp, __Z51ParticleSystem_InheritVelocityModule_CUSTOM_GetModeP12Il2CppObject: __Z51ParticleSystem_InheritVelocityModule_CUSTOM_GetModeP12Il2CppObject, __ZN4FMOD7SystemI11getCPUUsageEPfS1_S1_S1_S1_: __ZN4FMOD7SystemI11getCPUUsageEPfS1_S1_S1_S1_, __ZN15MBP_PairManager17removeMarkedPairsEPK10MBP_ObjectPN5physx16PxsBroadPhaseMBPERK8BitArrayS8_: __ZN15MBP_PairManager17removeMarkedPairsEPK10MBP_ObjectPN5physx16PxsBroadPhaseMBPERK8BitArrayS8_, __ZNK5physx3Ext13RevoluteJoint17getDriveGearRatioEv: __ZNK5physx3Ext13RevoluteJoint17getDriveGearRatioEv, _start_pass_dcolor: _start_pass_dcolor, __ZNSt3__217moneypunct_bynameIcLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__217moneypunct_bynameIcLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN4FMOD5Sound18get3DCustomRolloffEPP11FMOD_VECTORPi: __ZN4FMOD5Sound18get3DCustomRolloffEPP11FMOD_VECTORPi, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13TryDeallocateEPv: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13TryDeallocateEPv, __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx15PxVehicleWheels19getConcreteTypeNameEv: __ZNK5physx15PxVehicleWheels19getConcreteTypeNameEv, __ZN4FMOD6System23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_: __ZN4FMOD6System23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_, __ZN18AudioLowPassFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN18AudioLowPassFilter23VirtualRedirectTransferER14SafeBinaryRead, __ZN18CrashReportManagerC2E10MemLabelId18ObjectCreationMode: __ZN18CrashReportManagerC2E10MemLabelId18ObjectCreationMode, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE13isSubordinateEv, __ZN14RenderSettings5ResetEv: __ZN14RenderSettings5ResetEv, __ZN8b2IslandC2EiiiP16b2StackAllocatorP17b2ContactListener: __ZN8b2IslandC2EiiiP16b2StackAllocatorP17b2ContactListener, __ZN5physx9NpPhysics33unregisterDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj: __ZN5physx9NpPhysics33unregisterDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj, __ZNK5physx2Sc9ClothCore22getAngularInertiaScaleEv: __ZNK5physx2Sc9ClothCore22getAngularInertiaScaleEv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN5physx2Sc10NPhaseCore32addToPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE: __ZN5physx2Sc10NPhaseCore32addToPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE, __ZN14RenderSettings28SetGeneratedSkyboxReflectionEP7Cubemap: __ZN14RenderSettings28SetGeneratedSkyboxReflectionEP7Cubemap, __ZN12InputManager10GetAxisRawERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager10GetAxisRawERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN8Collider10DeactivateE19DeactivateOperation: __ZN8Collider10DeactivateE19DeactivateOperation, __ZN8Gradient8TransferI9JSONWriteEEvRT_: __ZN8Gradient8TransferI9JSONWriteEEvRT_, __ZN5Umbra20SingleBlockAllocatorD0Ev: __ZN5Umbra20SingleBlockAllocatorD0Ev, __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesXv: __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesXv, _unity_z_compressBound: _unity_z_compressBound, __ZNK12TLSAllocatorI14StackAllocatorE22GetAllocatedMemorySizeEv: __ZNK12TLSAllocatorI14StackAllocatorE22GetAllocatedMemorySizeEv, __ZN7mecanim6memory16ChainedAllocator8AllocateEjj: __ZN7mecanim6memory16ChainedAllocator8AllocateEjj, __ZN11TerrainData16CheckConsistencyEv: __ZN11TerrainData16CheckConsistencyEv, __ZN5physx6shdfnd13createFastIPCERNS0_5PxIPC9ErrorCodeENS1_14ConnectionTypeEPKcjjbbj: __ZN5physx6shdfnd13createFastIPCERNS0_5PxIPC9ErrorCodeENS1_14ConnectionTypeEPKcjjbbj, __Z32GetSceneHierarchyPathDescriptivePK6Object: __Z32GetSceneHierarchyPathDescriptivePK6Object, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEC2ERKS5_: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEC2ERKS5_, __ZNK7WeakPtrI20SoundChannelInstanceE10SharedData9GetRawPtrEv: __ZNK7WeakPtrI20SoundChannelInstanceE10SharedData9GetRawPtrEv, __ZN12HandlerChain4NameEv: __ZN12HandlerChain4NameEv, __Z58Register_UnityEngine_AI_NavMesh_SetAvoidancePredictionTimev: __Z58Register_UnityEngine_AI_NavMesh_SetAvoidancePredictionTimev, __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD2Ev: __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD2Ev, __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE10deallocateEv: __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE10deallocateEv, __ZN5physx37setupFinalizeSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffjffff: __ZN5physx37setupFinalizeSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffjffff, __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_: __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIwEERNS_10unique_ptrIwPFvPvEEERPwSM_, __ZN12AudioManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12AudioManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z44Register_UnityEngine_CanvasRenderer_get_cullv: __Z44Register_UnityEngine_CanvasRenderer_get_cullv, __Z69Register_UnityEngine_ParticleSystem_TriggerModule_GetMaxColliderCountv: __Z69Register_UnityEngine_ParticleSystem_TriggerModule_GetMaxColliderCountv, __Z28Light_Get_Custom_PropShadowsP12Il2CppObject: __Z28Light_Get_Custom_PropShadowsP12Il2CppObject, _RevoluteJointSolverPrep: _RevoluteJointSolverPrep, __Z29StdTemplateConversionFunctionIbbEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbbEbPvR14SafeBinaryRead, __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN10AudioMixer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10AudioMixer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNKSt3__220__codecvt_utf8_utf16IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_, __Z62ParticleSystem_CollisionModule_CUSTOM_SetUsesCollisionMessagesP12Il2CppObjecth: __Z62ParticleSystem_CollisionModule_CUSTOM_SetUsesCollisionMessagesP12Il2CppObjecth, __ZN22ProceduralMaterialDataC2Ev: __ZN22ProceduralMaterialDataC2Ev, __ZN14UnityWebStream24UpdateAllUnityWebStreamsEv: __ZN14UnityWebStream24UpdateAllUnityWebStreamsEv, __ZN13OpenFileCache13ForceCloseAllEv: __ZN13OpenFileCache13ForceCloseAllEv, __ZN15SerializeTraitsINSt3__24pairIj8UnityStrEEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairIj8UnityStrEEE8TransferI14SafeBinaryReadEEvRS3_RT_, __Z47ConfigurableJoint_Set_Custom_PropAngularZMotionP12Il2CppObjecti: __Z47ConfigurableJoint_Set_Custom_PropAngularZMotionP12Il2CppObjecti, __Z31setPxParticleBase_ContactOffsetPN5physx14PxParticleBaseEf: __Z31setPxParticleBase_ContactOffsetPN5physx14PxParticleBaseEf, __ZN13WheelColliderC2E10MemLabelId18ObjectCreationMode: __ZN13WheelColliderC2E10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd10ThreadImpl10signalQuitEv: __ZN5physx6shdfnd10ThreadImpl10signalQuitEv, __ZN5physx31ComputeCreatedDeletedPairsListsEPKjS1_jRPNS_17PxcBroadPhasePairERjS5_S4_S5_S5_RNS_14SapPairManagerE: __ZN5physx31ComputeCreatedDeletedPairsListsEPKjS1_jRPNS_17PxcBroadPhasePairERjS5_S4_S5_S5_RNS_14SapPairManagerE, __ZN18LoadSceneOperation21MustCompleteNextFrameEv: __ZN18LoadSceneOperation21MustCompleteNextFrameEv, __Z27GenerateMonoScriptCacheHashP11Il2CppClass: __Z27GenerateMonoScriptCacheHashP11Il2CppClass, __ZN13SpeedTreeWind10SWindGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SpeedTreeWind10SWindGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK12AudioManager16GetAudioListenerEv: __ZNK12AudioManager16GetAudioListenerEv, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_, __Z50Register_UnityEngine_Collider2D_INTERNAL_CALL_Castv: __Z50Register_UnityEngine_Collider2D_INTERNAL_CALL_Castv, __ZNK7VRInput16GetLocalRotationERK8UnityStr4PPtrI9TransformE: __ZNK7VRInput16GetLocalRotationERK8UnityStr4PPtrI9TransformE, __ZN18AssetBundleManager30CollectPreloadDataDependenciesER4PPtrI11AssetBundleEbR13dynamic_arrayIiLj4EE: __ZN18AssetBundleManager30CollectPreloadDataDependenciesER4PPtrI11AssetBundleEbR13dynamic_arrayIiLj4EE, __ZN21BillboardBatchManager17BillboardBatchJobEP25DynamicVBOGeometryJobDataj: __ZN21BillboardBatchManager17BillboardBatchJobEP25DynamicVBOGeometryJobDataj, __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE, __Z55Register_UnityEngine_LineRenderer_INTERNAL_get_endColorv: __Z55Register_UnityEngine_LineRenderer_INTERNAL_get_endColorv, __ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE: __ZNK11Rigidbody2D20GetAttachedCollidersER13dynamic_arrayIP10Collider2DLj4EE, __ZN5physx2Gu16pcmContactBoxBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu16pcmContactBoxBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv: __ZNK5physx2Sc19ParticlePacketShape17getParticleSystemEv, __ZN13dynamic_arrayIPN9ShaderLab4PassELj4EEC2ERKS3_: __ZN13dynamic_arrayIPN9ShaderLab4PassELj4EEC2ERKS3_, __ZN6Camera22SetTargetBuffersScriptEiPK21ScriptingRenderBufferPS0_: __ZN6Camera22SetTargetBuffersScriptEiPK21ScriptingRenderBufferPS0_, __Z21getPxMaterialUserDataPKN5physx10PxMaterialE: __Z21getPxMaterialUserDataPKN5physx10PxMaterialE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z15reserve_trimmedINSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z15reserve_trimmedINSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEEvRT_j, __Z53Register_UnityEngine_Cloth_set_useContinuousCollisionv: __Z53Register_UnityEngine_Cloth_set_useContinuousCollisionv, __ZNK12HingeJoint2D13GetLimitStateEv: __ZNK12HingeJoint2D13GetLimitStateEv, __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE: __ZNK5Unity4Type21FindAllDerivedClassesER13dynamic_arrayIPKS0_Lj4EENS0_17TypeFilterOptionsE, __Z54Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Pausev: __Z54Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Pausev, __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIfEEvRT_PKc17TransferMetaFlags, __ZN10TagManager7GetTagsEv: __ZN10TagManager7GetTagsEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZN15RaycastCallback14processTouchesEPKN5physx12PxRaycastHitEj: __ZN15RaycastCallback14processTouchesEPKN5physx12PxRaycastHitEj, __ZN18CrashReportHandlerC2ERK8UnityStrS2_: __ZN18CrashReportHandlerC2ERK8UnityStrS2_, __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetPositionP12Il2CppObjectRK8Vector3f: __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetPositionP12Il2CppObjectRK8Vector3f, __ZNSt3__215__codecvt_utf16IDiLb1EED0Ev: __ZNSt3__215__codecvt_utf16IDiLb1EED0Ev, __ZN13PhysicsModule21ReleaseNxTriangleMeshEP17PhysicsModuleMesh: __ZN13PhysicsModule21ReleaseNxTriangleMeshEP17PhysicsModuleMesh, __ZN13Simd4fFactoryIPKfEC2ES1_: __ZN13Simd4fFactoryIPKfEC2ES1_, __Z37Material_CUSTOM_SetColorArrayImplListP12Il2CppObjectiS0_: __Z37Material_CUSTOM_SetColorArrayImplListP12Il2CppObjectiS0_, __ZNK21EnlightenSceneMapping30GetSystemIdFromInputSystemHashERK7Hash128: __ZNK21EnlightenSceneMapping30GetSystemIdFromInputSystemHashERK7Hash128, __ZN24RigidbodyMovementState2D21ResetAngularMoveStateEv: __ZN24RigidbodyMovementState2D21ResetAngularMoveStateEv, __ZN21ImposterRenderTexture14UpdateImposterERK5RectTIfERKN12TreeDatabase9PrototypeE: __ZN21ImposterRenderTexture14UpdateImposterERK5RectTIfERKN12TreeDatabase9PrototypeE, __ZThn32_N14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLERKS5_, __ZN5physx2Gu5RTree15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Gu5RTree15exportExtraDataERNS_22PxSerializationContextE, __ZN23ParticleSystemParticles13SetUsesLightsEv: __ZN23ParticleSystemParticles13SetUsesLightsEv, __Z22setPxConstraint_ActorsPN5physx12PxConstraintEPNS_12PxRigidActorES3_: __Z22setPxConstraint_ActorsPN5physx12PxConstraintEPNS_12PxRigidActorES3_, __ZNSt3__219__thread_struct_impD2Ev: __ZNSt3__219__thread_struct_impD2Ev, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv: __ZNSt3__210__list_impIN10GUIManager12SortedScriptE11memory_poolIS2_EE5clearEv, __Z50Register_UnityEngine_Rigidbody2D_set_interpolationv: __Z50Register_UnityEngine_Rigidbody2D_set_interpolationv, __ZThn32_N16ParticleRendererD1Ev: __ZThn32_N16ParticleRendererD1Ev, __Z29GetTextureSizeAllowedMultiple13TextureFormat: __Z29GetTextureSizeAllowedMultiple13TextureFormat, __ZNSt3__211__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri: __ZNSt3__211__money_putIwE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_Ri, __Z42CleanupSerializationByCodeGenerationThreadv: __Z42CleanupSerializationByCodeGenerationThreadv, __ZNK5physx2Sq10AABBPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE: __ZNK5physx2Sq10AABBPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE, __Z45CommandBuffer_CUSTOM_IssuePluginEventInternalP12Il2CppObject13Il2Cpp_IntPtri: __Z45CommandBuffer_CUSTOM_IssuePluginEventInternalP12Il2CppObject13Il2Cpp_IntPtri, __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb: __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb, __Z54Register_UnityEngine_Application_SetLogCallbackDefinedv: __Z54Register_UnityEngine_Application_SetLogCallbackDefinedv, __Z46CleanupSpriteRendererAnimationBindingInterfacev: __Z46CleanupSpriteRendererAnimationBindingInterfacev, __ZN21IntermediateRenderers3AddEP20IntermediateRenderer: __ZN21IntermediateRenderers3AddEP20IntermediateRenderer, __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __Z39RenderBufferHelper_CUSTOM_GetLoadActionP21ScriptingRenderBuffer: __Z39RenderBufferHelper_CUSTOM_GetLoadActionP21ScriptingRenderBuffer, __ZN13BuildSettings16GetScenePathNameEi: __ZN13BuildSettings16GetScenePathNameEi, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21SubstanceOutputFormatEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21SubstanceOutputFormatEvRT_RT0_PKc17TransferMetaFlags, __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN12NavMeshAgent24SetObstacleAvoidanceTypeE21ObstacleAvoidanceType: __ZN12NavMeshAgent24SetObstacleAvoidanceTypeE21ObstacleAvoidanceType, __ZN14DataBufferGLES14RecordRecreateEi: __ZN14DataBufferGLES14RecordRecreateEi, __Z61Register_UnityEngine_ParticleEmitter_get_emitterVelocityScalev: __Z61Register_UnityEngine_ParticleEmitter_get_emitterVelocityScalev, __Z53Register_UnityEngine_PhysicsMaterial2D_set_bouncinessv: __Z53Register_UnityEngine_PhysicsMaterial2D_set_bouncinessv, __Z31setPxJointAngularLimitPairLowerPN5physx23PxJointAngularLimitPairEf: __Z31setPxJointAngularLimitPairLowerPN5physx23PxJointAngularLimitPairEf, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN13SparseTexture17MainThreadCleanupEv: __ZN13SparseTexture17MainThreadCleanupEv, __ZN5physx6string9sprintf_sEPcjPKcz: __ZN5physx6string9sprintf_sEPcjPKcz, __ZNK15b2DistanceJoint17GetReactionTorqueEf: __ZNK15b2DistanceJoint17GetReactionTorqueEf, __ZThn8_N5physx19TriangleMeshBuilderD1Ev: __ZThn8_N5physx19TriangleMeshBuilderD1Ev, __Z35Animator_Set_Custom_PropLogWarningsP12Il2CppObjecth: __Z35Animator_Set_Custom_PropLogWarningsP12Il2CppObjecth, __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_: __Z19ConcatWithSeparatorRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_, __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_: __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_RfS4_, __ZN9Transform23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Transform23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN12HandlerChain6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN12HandlerChain6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z38Renderer_Set_Custom_PropSortingLayerIDP12Il2CppObjecti: __Z38Renderer_Set_Custom_PropSortingLayerIDP12Il2CppObjecti, __Z48LightProbeProxyVolume_Set_Custom_PropRefreshModeP12Il2CppObjecti: __Z48LightProbeProxyVolume_Set_Custom_PropRefreshModeP12Il2CppObjecti, __ZN19TouchPhaseEmulation20SetMultiTouchEnabledEb: __ZN19TouchPhaseEmulation20SetMultiTouchEnabledEb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE12readPropertyIfEEbRT_, __Z31AndroidJNI_CUSTOM_FromByteArray13Il2Cpp_IntPtr: __Z31AndroidJNI_CUSTOM_FromByteArray13Il2Cpp_IntPtr, __Z48Register_UnityEngine_AudioSource_get_rolloffModev: __Z48Register_UnityEngine_AudioSource_get_rolloffModev, __Z43TerrainData_Get_Custom_PropWavingGrassSpeedP12Il2CppObject: __Z43TerrainData_Get_Custom_PropWavingGrassSpeedP12Il2CppObject, __ZN5physx11NpReadCheckD2Ev: __ZN5physx11NpReadCheckD2Ev, __ZN5physx30setupFinalizeSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff: __ZN5physx30setupFinalizeSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_13PxcSolverBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff, __Z74Register_UnityEngine_Networking_DownloadHandlerAssetBundle_get_assetBundlev: __Z74Register_UnityEngine_Networking_DownloadHandlerAssetBundle_get_assetBundlev, __ZN4crnd15crnd_unpack_endEPv: __ZN4crnd15crnd_unpack_endEPv, __ZN7mecanim4hand8HandPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim4hand8HandPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z25getPxVehicleWheelDataMMOIPKN5physx18PxVehicleWheelDataE: __Z25getPxVehicleWheelDataMMOIPKN5physx18PxVehicleWheelDataE, __ZN12VertexWelderILi64EE4PushERK8Vector3f: __ZN12VertexWelderILi64EE4PushERK8Vector3f, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11attachShapeERNS_7PxShapeE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11attachShapeERNS_7PxShapeE, __ZN5physx26solveVBlockDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj: __ZN5physx26solveVBlockDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj, __Z32getPxArticulationJoint_DriveTypePKN5physx19PxArticulationJointE: __Z32getPxArticulationJoint_DriveTypePKN5physx19PxArticulationJointE, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE12__find_equalIS8_EERPNS_16__tree_node_baseIPvEESO_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE12__find_equalIS8_EERPNS_16__tree_node_baseIPvEESO_RKT_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN14AnimationEvent8TransferI14SafeBinaryReadEEvRT_: __ZN14AnimationEvent8TransferI14SafeBinaryReadEEvRT_, __Z63Register_UnityEngine_Audio_AudioMixer_get_outputAudioMixerGroupv: __Z63Register_UnityEngine_Audio_AudioMixer_get_outputAudioMixerGroupv, __ZN8Remapper6RemoveEi: __ZN8Remapper6RemoveEi, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj, __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_: __ZN5physx11writeBack1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_, __Z46Register_UnityEngine_RenderTexture_get_enabledv: __Z46Register_UnityEngine_RenderTexture_get_enabledv, __ZL36CleanupTextRenderingScriptingClassesv: __ZL36CleanupTextRenderingScriptingClassesv, __ZThn4_N16RayRTreeCallbackILi0ELb0EED0Ev: __ZThn4_N16RayRTreeCallbackILi0ELb0EED0Ev, __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer: __ZN15ReflectionProbe17UseRendererResultEP13ProbeRenderer, __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z34Mesh_CUSTOM_SetArrayForChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi: __Z34Mesh_CUSTOM_SetArrayForChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi, __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_, __Z33AudioSource_CUSTOM_SetCustomCurveP12Il2CppObject24MonoAudioSourceCurveTypeS0_: __Z33AudioSource_CUSTOM_SetCustomCurveP12Il2CppObject24MonoAudioSourceCurveTypeS0_, __ZN13GfxDeviceNull15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj: __ZN13GfxDeviceNull15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj, __ZN5physx22XmlMemoryAllocatorImplD0Ev: __ZN5physx22XmlMemoryAllocatorImplD0Ev, __ZNK5Umbra10PortalInfo18getNumHullVerticesEv: __ZNK5Umbra10PortalInfo18getNumHullVerticesEv, __ZN15AnchoredJoint2D5ResetEv: __ZN15AnchoredJoint2D5ResetEv, __ZNSt3__28ios_base4swapERS0_: __ZNSt3__28ios_base4swapERS0_, __ZNK5physx2Sc5Scene20getNbParticleSystemsEv: __ZNK5physx2Sc5Scene20getNbParticleSystemsEv, __Z26GetHaloVertexPositionsMonoP8Vector3fRKS_ff: __Z26GetHaloVertexPositionsMonoP8Vector3fRKS_ff, __ZN11UnityEngine9Animation21AvatarBindingCallbackEPvS1_i: __ZN11UnityEngine9Animation21AvatarBindingCallbackEPvS1_i, __Z45Register_UnityEngine_CrashReport_RemoveReportv: __Z45Register_UnityEngine_CrashReport_RemoveReportv, __ZN5Umbra13MatrixFactory7rotateXEf: __ZN5Umbra13MatrixFactory7rotateXEf, __ZN17TransformInternal19FreeTransformThreadER18TransformHierarchyjj: __ZN17TransformInternal19FreeTransformThreadER18TransformHierarchyjj, __Z37Quaternion_CUSTOM_INTERNAL_CALL_SlerpRK11QuaternionfS1_fRS_: __Z37Quaternion_CUSTOM_INTERNAL_CALL_SlerpRK11QuaternionfS1_fRS_, __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetBirthP12Il2CppObjectiS0_: __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetBirthP12Il2CppObjectiS0_, __ZN13BoxCollider2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13BoxCollider2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17ProfilerFrameData28SerializeProfilerInformationERK19ProfilerInformationR13dynamic_arrayIiLj4EE: __ZN17ProfilerFrameData28SerializeProfilerInformationERK19ProfilerInformationR13dynamic_arrayIiLj4EE, __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE17releaseEmptySlabsEv, __ZN4FMOD6System19setGeometrySettingsEf: __ZN4FMOD6System19setGeometrySettingsEf, __Z40AudioChorusFilter_Get_Custom_PropWetMix3P12Il2CppObject: __Z40AudioChorusFilter_Get_Custom_PropWetMix3P12Il2CppObject, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb, __Z44Register_UnityEngine_AndroidJNI_FromIntArrayv: __Z44Register_UnityEngine_AndroidJNI_FromIntArrayv, __ZN14UnityAnalytics25UnregisterGlobalCallbacksEv: __ZN14UnityAnalytics25UnregisterGlobalCallbacksEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZN16GraphicsSettings8TransferI17RemapPPtrTransferEEvRT_: __ZN16GraphicsSettings8TransferI17RemapPPtrTransferEEvRT_, __ZN8LODGroup8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8LODGroup8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN2UI6Canvas13UpdateBatchesEb: __ZN2UI6Canvas13UpdateBatchesEb, __Z28scripting_method_is_instance21ScriptingMethodIl2Cpp: __Z28scripting_method_is_instance21ScriptingMethodIl2Cpp, __Z51Register_UnityEngine_BillboardAsset_get_vertexCountv: __Z51Register_UnityEngine_BillboardAsset_get_vertexCountv, __ZN20SoundChannelInstance17set3DConeSettingsEfff: __ZN20SoundChannelInstance17set3DConeSettingsEfff, __ZN13AvatarBuilder10TPoseMatchERKN7mecanim9animation14AvatarConstantERKNSt3__26vectorINS_14NamedTransformENS5_9allocatorIS7_EEEERNS5_12basic_stringIcNS5_11char_traitsIcEENS8_IcEEEESI_: __ZN13AvatarBuilder10TPoseMatchERKN7mecanim9animation14AvatarConstantERKNSt3__26vectorINS_14NamedTransformENS5_9allocatorIS7_EEEERNS5_12basic_stringIcNS5_11char_traitsIcEENS8_IcEEEESI_, __ZN5physx2Gu5Debug9visualizeERKNS_13PxBoxGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_13PxBoxGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __Z28getPxPrismaticJoint_VelocityPKN5physx16PxPrismaticJointE: __Z28getPxPrismaticJoint_VelocityPKN5physx16PxPrismaticJointE, __Z24RegisterStrippedTypeInfoI8AnimatorEviPKcS2_: __Z24RegisterStrippedTypeInfoI8AnimatorEviPKcS2_, _jsimd_fdct_float: _jsimd_fdct_float, __ZNK13GfxDeviceGLES12GetWireframeEv: __ZNK13GfxDeviceGLES12GetWireframeEv, __ZN7mecanim12statemachine24CreateTransitionConstantEPPNS0_17ConditionConstantEjjfffbb28TransitionInterruptionSourcebbjjjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine24CreateTransitionConstantEPPNS0_17ConditionConstantEjjfffbb28TransitionInterruptionSourcebbjjjRNS_6memory9AllocatorE, __ZN5physx35PxVehicleAutoBoxDataGeneratedValuesC2EPKNS_20PxVehicleAutoBoxDataE: __ZN5physx35PxVehicleAutoBoxDataGeneratedValuesC2EPKNS_20PxVehicleAutoBoxDataE, __ZNK15AudioReverbZone14GetMinDistanceEv: __ZNK15AudioReverbZone14GetMinDistanceEv, __ZN17PhysicsMaterial2D13SetBouncinessEf: __ZN17PhysicsMaterial2D13SetBouncinessEf, __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx21PxsFluidCollisionTaskD0Ev: __ZN5physx21PxsFluidCollisionTaskD0Ev, __Z47Graphics_CUSTOM_Internal_SetRandomWriteTargetRTiP12Il2CppObject: __Z47Graphics_CUSTOM_Internal_SetRandomWriteTargetRTiP12Il2CppObject, __Z32GUIText_Set_Custom_PropAlignmentP12Il2CppObjecti: __Z32GUIText_Set_Custom_PropAlignmentP12Il2CppObjecti, __ZN9GfxDevice18AllocRenderSurfaceEb: __ZN9GfxDevice18AllocRenderSurfaceEb, __ZN5physx23PxVehicleWheels4SimData11setTireDataEjRKNS_17PxVehicleTireDataE: __ZN5physx23PxVehicleWheels4SimData11setTireDataEjRKNS_17PxVehicleTireDataE, __ZN5physx31setupFinalizeSolverConstraints4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRKNS_6shdfnd3aos5Vec4VES9_S9_S9_: __ZN5physx31setupFinalizeSolverConstraints4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRKNS_6shdfnd3aos5Vec4VES9_S9_S9_, __ZN5physx7NpScene5flushEb: __ZN5physx7NpScene5flushEb, __ZN10TagManager32GetSortingLayerUniqueIDFromValueEi: __ZN10TagManager32GetSortingLayerUniqueIDFromValueEi, __Z75Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailMultiplierv: __Z75Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailMultiplierv, __Z51ParticleSystem_MainModule_CUSTOM_GetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve: __Z51ParticleSystem_MainModule_CUSTOM_GetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx2Sc10NPhaseCore11narrowPhaseEv: __ZN5physx2Sc10NPhaseCore11narrowPhaseEv, __ZN5physx22PxVehicleWheelsSimData11enableWheelEj: __ZN5physx22PxVehicleWheelsSimData11enableWheelEj, __ZThn8_N5physx2Sc24ElementInteractionMarker10onActivateEj: __ZThn8_N5physx2Sc24ElementInteractionMarker10onActivateEj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj432ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj432ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_, __ZThn8_N5physx3Cct17CapsuleController15getPxControllerEv: __ZThn8_N5physx3Cct17CapsuleController15getPxControllerEv, __Z53ParticleSystem_ExternalForcesModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z53ParticleSystem_ExternalForcesModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN16ScriptingManager22GetAllMonoScriptCachesER13dynamic_arrayIP15MonoScriptCacheLj4EE: __ZN16ScriptingManager22GetAllMonoScriptCachesER13dynamic_arrayIP15MonoScriptCacheLj4EE, __Z26AnimationCurve_CUSTOM_InitP12Il2CppObjectP11Il2CppArray: __Z26AnimationCurve_CUSTOM_InitP12Il2CppObjectP11Il2CppArray, __ZNK14b2PolygonShape5CloneEP16b2BlockAllocator: __ZNK14b2PolygonShape5CloneEP16b2BlockAllocator, __ZNK27StateMachineBehaviourPlayer24FindStateBehavioursRangeERK8StateKey: __ZNK27StateMachineBehaviourPlayer24FindStateBehavioursRangeERK8StateKey, __ZN17PersistentManager26GetStreamNameSpaceInternalEi: __ZN17PersistentManager26GetStreamNameSpaceInternalEi, __Z40Rigidbody2D_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP13Vector2fIcall: __Z40Rigidbody2D_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP13Vector2fIcall, __ZN4FMOD6System11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE: __ZN4FMOD6System11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE, __ZN27ComputeShaderBuiltinSampler8TransferI14SafeBinaryReadEEvRT_: __ZN27ComputeShaderBuiltinSampler8TransferI14SafeBinaryReadEEvRT_, __ZN13SpeedTreeWind20AdvanceWithoutUpdateEd: __ZN13SpeedTreeWind20AdvanceWithoutUpdateEd, __ZN18PlatformEffector2D20SetUseOneWayGroupingEb: __ZN18PlatformEffector2D20SetUseOneWayGroupingEb, __ZN15dtPathQueryInfo11setAgentIdxEi: __ZN15dtPathQueryInfo11setAgentIdxEi, __Z41Register_UnityEngine_LODGroup_set_enabledv: __Z41Register_UnityEngine_LODGroup_set_enabledv, __Z24ConvertBufferToJPGBufferPKhjjjiPvPFvS1_PhjE: __Z24ConvertBufferToJPGBufferPKhjjjiPvPFvS1_PhjE, _UNITY_png_convert_from_time_t: _UNITY_png_convert_from_time_t, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXMultiplierv, __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev: __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev, __ZN9ShaderLab19CommonPropertyNames13StaticCleanupEPv: __ZN9ShaderLab19CommonPropertyNames13StaticCleanupEPv, __Z60Register_UnityEngine_TerrainData_INTERNAL_get_heightmapScalev: __Z60Register_UnityEngine_TerrainData_INTERNAL_get_heightmapScalev, __Z46ShaderVariantCollection_CUSTOM_Internal_CreateP12Il2CppObject: __Z46ShaderVariantCollection_CUSTOM_Internal_CreateP12Il2CppObject, __ZN5physx2Sq17AABBTreeUpdateMap10invalidateEjjRNS0_8AABBTreeE: __ZN5physx2Sq17AABBTreeUpdateMap10invalidateEjjRNS0_8AABBTreeE, __ZN12WheelJoint2D6CreateEv: __ZN12WheelJoint2D6CreateEv, _unity_z_zcfree: _unity_z_zcfree, __Z30GUI_CUSTOM_Internal_GetTooltipv: __Z30GUI_CUSTOM_Internal_GetTooltipv, __Z53Register_UnityEngine_LightmapSettings_set_lightProbesv: __Z53Register_UnityEngine_LightmapSettings_set_lightProbesv, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN15TerrainCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15TerrainCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi: __ZNK10__cxxabiv117__class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi, __ZN4Mesh5SetUvEiPKfjj: __ZN4Mesh5SetUvEiPKfjj, __ZN7Texture13SetAnisoLimitENS_20AnisotropicFilteringE: __ZN7Texture13SetAnisoLimitENS_20AnisotropicFilteringE, __ZN28LightProbeProxyVolumeManager25UpdateSHCoeffsTextureDataER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager25UpdateSHCoeffsTextureDataER21LightProbeProxyVolume, __ZN11AudioModule16SetListenerPauseEb: __ZN11AudioModule16SetListenerPauseEb, __Z52Register_UnityEngine_PointEffector2D_get_angularDragv: __Z52Register_UnityEngine_PointEffector2D_get_angularDragv, __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE: __ZN13GfxDeviceGLES22MemoryBarrierImmediateEyN2gl17MemoryBarrierTypeE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd13ReadWriteLockC2Ev: __ZN5physx6shdfnd13ReadWriteLockC2Ev, __Z48Register_UnityEngine_VR_VRDevice_get_refreshRatev: __Z48Register_UnityEngine_VR_VRDevice_get_refreshRatev, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN6Object27GetOffsetOfInstanceIdMemberEv: __ZN6Object27GetOffsetOfInstanceIdMemberEv, __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z66Register_UnityEngine_Camera_INTERNAL_CALL_ResetWorldToCameraMatrixv: __Z66Register_UnityEngine_Camera_INTERNAL_CALL_ResetWorldToCameraMatrixv, __ZN13WheelCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13WheelCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11AudioSource7UnPauseEv: __ZN11AudioSource7UnPauseEv, __ZN14RenderSettings17SetFlareFadeSpeedEf: __ZN14RenderSettings17SetFlareFadeSpeedEf, __ZN5physx15PxGetFilterBoolEv: __ZN5physx15PxGetFilterBoolEv, __ZN8PlayableD0Ev: __ZN8PlayableD0Ev, __ZN10SizeModule8TransferI17RemapPPtrTransferEEvRT_: __ZN10SizeModule8TransferI17RemapPPtrTransferEEvRT_, _UNITY_FT_Sin: _UNITY_FT_Sin, __Z40LineRenderer_Set_Custom_PropNumPositionsP12Il2CppObjecti: __Z40LineRenderer_Set_Custom_PropNumPositionsP12Il2CppObjecti, __Z44Register_UnityEngine_GUIStyle_SetDefaultFontv: __Z44Register_UnityEngine_GUIStyle_SetDefaultFontv, __ZN19SpriteMeshGenerator9MakeShapeEP11ColorRGBA32iifhbjfi: __ZN19SpriteMeshGenerator9MakeShapeEP11ColorRGBA32iifhbjfi, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_PKc17TransferMetaFlags, __Z31SparseTexture_CUSTOM_UpdateTileP12Il2CppObjectiiiP11Il2CppArray: __Z31SparseTexture_CUSTOM_UpdateTileP12Il2CppObjectiiiP11Il2CppArray, __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_S6_T_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZNK21LightProbeProxyVolume26GetTypeInfoVirtualInternalEv: __ZNK21LightProbeProxyVolume26GetTypeInfoVirtualInternalEv, __ZN5physx2Sc7BodySim37checkSleepReadinessBesidesWakeCounterEv: __ZN5physx2Sc7BodySim37checkSleepReadinessBesidesWakeCounterEv, __ZN5physx24PxClothMeshQuadifierImplC2ERKNS_15PxClothMeshDescE: __ZN5physx24PxClothMeshQuadifierImplC2ERKNS_15PxClothMeshDescE, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK11Rigidbody2D20GetWorldCenterOfMassEv: __ZNK11Rigidbody2D20GetWorldCenterOfMassEv, __Z57Register_UnityEngine_AudioReverbZone_set_reflectionsDelayv: __Z57Register_UnityEngine_AudioReverbZone_set_reflectionsDelayv, __ZN26AnimatorControllerPlayable17IsMultithreadableEv: __ZN26AnimatorControllerPlayable17IsMultithreadableEv, __ZN5physx22PxVehicleWheelsSimData21setTireLoadFilterDataERKNS_27PxVehicleTireLoadFilterDataE: __ZN5physx22PxVehicleWheelsSimData21setTireLoadFilterDataERKNS_27PxVehicleTireLoadFilterDataE, __ZN11SoundHandleC2EPNS_8InstanceE: __ZN11SoundHandleC2EPNS_8InstanceE, __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZL21SetAnisoLimitEnumImplN7Texture20AnisotropicFilteringEb: __ZL21SetAnisoLimitEnumImplN7Texture20AnisotropicFilteringEb, __ZN22BaseUnityConnectClient17OnEnterStateReadyEv: __ZN22BaseUnityConnectClient17OnEnterStateReadyEv, __ZN5physx2Sc16ArticulationCore14setWakeCounterEf: __ZN5physx2Sc16ArticulationCore14setWakeCounterEf, __ZN15SerializeTraitsINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEE8TransferI14SafeBinaryReadEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEE8TransferI14SafeBinaryReadEEvRS4_RT_, __ZN5physx2Sc10NPhaseCore24createTriggerInteractionERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE: __ZN5physx2Sc10NPhaseCore24createTriggerInteractionERNS0_8ShapeSimES3_NS_7PxFlagsINS_10PxPairFlag4EnumEtEE, __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj: __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_: __ZN8JSONRead18TransferStringDataI8UnityStrEEvRT_, __ZN5Umbra14MemInputStreamD0Ev: __ZN5Umbra14MemInputStreamD0Ev, __ZN23TransformChangeDispatchD2Ev: __ZN23TransformChangeDispatchD2Ev, __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv: __ZN5Unity5Cloth22ReadBackSkinnedBuffersEv, __ZN5physx2Gu9ContainerD2Ev: __ZN5physx2Gu9ContainerD2Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ProceduralOutputTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ProceduralOutputTypeEvRT_RT0_PKc17TransferMetaFlags, __ZN11JointLimits8TransferI14SafeBinaryReadEEvRT_: __ZN11JointLimits8TransferI14SafeBinaryReadEEvRT_, __Z29Input_CUSTOM_GetMouseButtonUpi: __Z29Input_CUSTOM_GetMouseButtonUpi, __ZN5physx2Gu12selectNormalEhff: __ZN5physx2Gu12selectNormalEhff, __ZN12_GLOBAL__N_122SocketNetworkOutStream5flushEv: __ZN12_GLOBAL__N_122SocketNetworkOutStream5flushEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj292ENS_22PxRepXPropertyAccessorILj292ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj292ENS_22PxRepXPropertyAccessorILj292ES4_jjEEEEvjRKT0_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getSleepTestIntervalEv, _UNITY_tt_face_load_maxp: _UNITY_tt_face_load_maxp, __Z39Register_UnityEngine_Event_Internal_Usev: __Z39Register_UnityEngine_Event_Internal_Usev, __ZNK12NavMeshAgent14DistanceToEdgeEP10NavMeshHit: __ZNK12NavMeshAgent14DistanceToEdgeEP10NavMeshHit, __ZN7mecanim5human12FullBodyMaskEv: __ZN7mecanim5human12FullBodyMaskEv, __ZN5physx3Scb14ParticleSystem16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE: __ZN5physx3Scb14ParticleSystem16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE, __ZN20GlobalCachingManager16RebuildAllCachesEv: __ZN20GlobalCachingManager16RebuildAllCachesEv, __ZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryE: __ZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryE, __ZN7dtCrowd5purgeEv: __ZN7dtCrowd5purgeEv, __Z37FixedJoint2D_Get_Custom_PropFrequencyP12Il2CppObject: __Z37FixedJoint2D_Get_Custom_PropFrequencyP12Il2CppObject, __ZN19ShaderPropertySheet11ComputeHashEv: __ZN19ShaderPropertySheet11ComputeHashEv, __ZNSt3__28ios_base4InitD2Ev: __ZNSt3__28ios_base4InitD2Ev, __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIxxEEPxEEjT0_S5_S5_T_, __ZN5physx2Sc5Scene21processLostTouchPairsEv: __ZN5physx2Sc5Scene21processLostTouchPairsEv, __ZN12b2EPCollider24ComputePolygonSeparationEv: __ZN12b2EPCollider24ComputePolygonSeparationEv, __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z20getPxActor_AggregatePKN5physx7PxActorE: __Z20getPxActor_AggregatePKN5physx7PxActorE, __Z23StringScriptingToVectorINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvP11Il2CppArrayRT_: __Z23StringScriptingToVectorINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvP11Il2CppArrayRT_, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZThn4_N5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE: __ZThn4_N5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE, __ZNKSt3__217moneypunct_bynameIwLb1EE14do_frac_digitsEv: __ZNKSt3__217moneypunct_bynameIwLb1EE14do_frac_digitsEv, __ZN5physx10PxGetGroupERKNS_7PxActorE: __ZN5physx10PxGetGroupERKNS_7PxActorE, __ZThn28_N14PhysicsManager7onSleepEPPN5physx7PxActorEj: __ZThn28_N14PhysicsManager7onSleepEPPN5physx7PxActorEj, __ZN5physx16PxsParticleShape4initEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE: __ZN5physx16PxsParticleShape4initEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE, __ZN24JointTranslationLimits2D8TransferI14SafeBinaryReadEEvRT_: __ZN24JointTranslationLimits2D8TransferI14SafeBinaryReadEEvRT_, __Z59Register_UnityEngine_PlatformEffector2D_get_useSideFrictionv: __Z59Register_UnityEngine_PlatformEffector2D_get_useSideFrictionv, __ZN5physx22PxcContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN5Umbra20RuntimeTomeGenerator16estimateTomeSizeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEE: __ZN5Umbra20RuntimeTomeGenerator16estimateTomeSizeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEE, __ZN11UnityEngine9Analytics13UserInfoEventC2Ev: __ZN11UnityEngine9Analytics13UserInfoEventC2Ev, __Z56Register_UnityEngine_ParticleEmitter_get_angularVelocityv: __Z56Register_UnityEngine_ParticleEmitter_get_angularVelocityv, __ZN21WorldParticleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN21WorldParticleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu11ConvexHullV12HillClimbingERKNS_6shdfnd3aos5Vec3VE, __Z56Register_UnityEngine_ParticleSystemRenderer_get_sortModev: __Z56Register_UnityEngine_ParticleSystemRenderer_get_sortModev, __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_: __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT_, __ZNK5physx2Sc17ParticleSystemSim7getCoreEv: __ZNK5physx2Sc17ParticleSystemSim7getCoreEv, __Z40Register_UnityEngine_Event_set_modifiersv: __Z40Register_UnityEngine_Event_set_modifiersv, __ZNSt3__211__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri: __ZNSt3__211__money_putIcE13__gather_infoEbbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_Ri, __ZN14SafeBinaryReadD2Ev: __ZN14SafeBinaryReadD2Ev, __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_: __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_, __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sc18ParticleSystemCore10setDampingEf: __ZN5physx2Sc18ParticleSystemCore10setDampingEf, __Z13RegisterClassI7TextureEvv: __Z13RegisterClassI7TextureEvv, __ZNK21AnimationClipPlayable7GetTimeEv: __ZNK21AnimationClipPlayable7GetTimeEv, __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Gradient8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7mecanim8dynamics10VectorDamp8EvaluateERKN4math7_float4Ef: __ZN7mecanim8dynamics10VectorDamp8EvaluateERKN4math7_float4Ef, __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf: __ZNK14dtNavMeshQuery13getPolyHeightEyPKfPf, __ZN5physx3Cct9SweepTest17onObstacleRemovedEj: __ZN5physx3Cct9SweepTest17onObstacleRemovedEj, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_St16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_St16initializer_listIcE, __ZN10Matrix4x4f14SetPerspectiveEffffff: __ZN10Matrix4x4f14SetPerspectiveEffffff, __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE: __ZN5physx2Sc10NPhaseCore16deleteFilterPairEPNS0_10FilterPairE, __ZN14ParticleSystem15ThreadedCleanupEv: __ZN14ParticleSystem15ThreadedCleanupEv, __ZN19CollisionListener2DD0Ev: __ZN19CollisionListener2DD0Ev, __ZN4crnd25static_huffman_data_modelC2Ev: __ZN4crnd25static_huffman_data_modelC2Ev, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_ED2Ev, __ZN14RenderSettings11SetFogColorERK10ColorRGBAf: __ZN14RenderSettings11SetFogColorERK10ColorRGBAf, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx27PxRigidStaticRepXSerializerD0Ev: __ZN5physx27PxRigidStaticRepXSerializerD0Ev, _PxCreateBasePhysics: _PxCreateBasePhysics, __Z40PhysicMaterial_Get_Custom_PropBouncinessP12Il2CppObject: __Z40PhysicMaterial_Get_Custom_PropBouncinessP12Il2CppObject, __ZN15RelativeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15RelativeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z40Register_UnityEngine_Event_set_characterv: __Z40Register_UnityEngine_Event_set_characterv, _malloc_trim: _malloc_trim, __ZN5physx23SetMFrictionVsSlipGraphEPNS_17PxVehicleTireDataEjjf: __ZN5physx23SetMFrictionVsSlipGraphEPNS_17PxVehicleTireDataEjjf, __Z48Register_UnityEngine_Camera_set_orthographicSizev: __Z48Register_UnityEngine_Camera_set_orthographicSizev, __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx2Sc5Scene28addActiveBreakableConstraintEPNS0_13ConstraintSimE: __ZN5physx2Sc5Scene28addActiveBreakableConstraintEPNS0_13ConstraintSimE, __ZN9ShaderLab19CommonPropertyNames16StaticInitializeEPv: __ZN9ShaderLab19CommonPropertyNames16StaticInitializeEPv, __Z47Animator_CUSTOM_SetIKHintPositionWeightInternalP12Il2CppObjectif: __Z47Animator_CUSTOM_SetIKHintPositionWeightInternalP12Il2CppObjectif, __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN13GfxDeviceNull15SetStencilStateEPK18DeviceStencilStatei: __ZN13GfxDeviceNull15SetStencilStateEPK18DeviceStencilStatei, __ZN13MemoryManager31DisallowAllocationsOnThisThreadEv: __ZN13MemoryManager31DisallowAllocationsOnThisThreadEv, __ZNK12RemoveByName17ShouldRemoveStateEP14AnimationState: __ZNK12RemoveByName17ShouldRemoveStateEP14AnimationState, __ZN13GfxDeviceGLES17BeginProfileEventEPKc: __ZN13GfxDeviceGLES17BeginProfileEventEPKc, __ZN7mecanim9animation18CreateAvatarOutputEPKNS0_14AvatarConstantEbbRNS_6memory9AllocatorE: __ZN7mecanim9animation18CreateAvatarOutputEPKNS0_14AvatarConstantEbbRNS_6memory9AllocatorE, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10eventValueEtyx: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10eventValueEtyx, __Z19GenerateSortIndicesP16ParticleSortDataRK5PlaneRK23ParticleSystemParticles22ParticleSystemSortMode: __Z19GenerateSortIndicesP16ParticleSortDataRK5PlaneRK23ParticleSystemParticles22ParticleSystemSortMode, __Z42SkinnedMeshRenderer_Set_Custom_PropQualityP12Il2CppObjecti: __Z42SkinnedMeshRenderer_Set_Custom_PropQualityP12Il2CppObjecti, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN11AudioSource23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11AudioSource23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx2Gu11getBoxEdgesEv: __ZN5physx2Gu11getBoxEdgesEv, __ZThn12_NK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN14UnityAnalytics15SendCustomEventERN11UnityEngine9Analytics15UserCustomEventE: __ZN14UnityAnalytics15SendCustomEventERN11UnityEngine9Analytics15UserCustomEventE, __ZN14Texture2DArray23VirtualRedirectTransferER14SafeBinaryRead: __ZN14Texture2DArray23VirtualRedirectTransferER14SafeBinaryRead, __ZNK6Camera21CalculateCanDoShadowsEv: __ZNK6Camera21CalculateCanDoShadowsEv, __ZNK5physx2Sc5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE: __ZNK5physx2Sc5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE, __Z27NavMesh_CUSTOM_GetLayerCosti: __Z27NavMesh_CUSTOM_GetLayerCosti, __ZN5physx9NpFactory14onActorReleaseEPNS_7PxActorE: __ZN5physx9NpFactory14onActorReleaseEPNS_7PxActorE, __ZN4FMOD7SystemI10getDSPHeadEPPNS_3DSPE: __ZN4FMOD7SystemI10getDSPHeadEPPNS_3DSPE, __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewStringUTFv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewStringUTFv, __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE: __ZN5physx2Sc5Actor15onElementAttachERNS0_7ElementE, __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI14ConstantStringNS0_9allocatorIS2_EEEEEvRT_j, __ZNK20ArchiveStorageReader15HasStreamBlocksEv: __ZNK20ArchiveStorageReader15HasStreamBlocksEv, __ZN6Socket24WaitForAvailableRecvDataEl: __ZN6Socket24WaitForAvailableRecvDataEl, __ZNK8Renderer16IsVisibleInSceneEv: __ZNK8Renderer16IsVisibleInSceneEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getGravityEv, __ZN14EdgeCollider2DD0Ev: __ZN14EdgeCollider2DD0Ev, __Z13VFormatBufferPciPKcz: __Z13VFormatBufferPciPKcz, __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx2Sc18ParticleSystemCore23setSimulationFilterDataERKNS_12PxFilterDataE, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__215__codecvt_utf16IDsLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_: __ZNKSt3__215__codecvt_utf16IDsLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_, __Z43Register_UnityEngine_Projector_get_materialv: __Z43Register_UnityEngine_Projector_get_materialv, __Z18dtDistancePtSegSqrPKfS0_S0_Rf: __Z18dtDistancePtSegSqrPKfS0_S0_Rf, __ZN5physx7profile32PxProfileMemoryEventRecorderImpl7releaseEv: __ZN5physx7profile32PxProfileMemoryEventRecorderImpl7releaseEv, __Z48CharacterJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf: __Z48CharacterJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf, __ZN22UnityAnalyticsSettings11SetTestModeEb: __ZN22UnityAnalyticsSettings11SetTestModeEb, __ZN17ProceduralTexture13RemoveTextureEv: __ZN17ProceduralTexture13RemoveTextureEv, __Z49PlatformEffector2D_Set_Custom_PropUseSideFrictionP12Il2CppObjecth: __Z49PlatformEffector2D_Set_Custom_PropUseSideFrictionP12Il2CppObjecth, __ZN5physx5cloth16SwInterCollisionI8Scalar4fE11getParticleEj: __ZN5physx5cloth16SwInterCollisionI8Scalar4fE11getParticleEj, __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN13ConstantForce11FixedUpdateEv: __ZN13ConstantForce11FixedUpdateEv, __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __Z64Register_UnityEngine_AI_NavMeshAgent_set_autoTraverseOffMeshLinkv: __Z64Register_UnityEngine_AI_NavMeshAgent_set_autoTraverseOffMeshLinkv, __ZN14VRSplashScreen23UpdateTagalongTransformEPFvRK11QuaternionfRK8Vector3fS5_E: __ZN14VRSplashScreen23UpdateTagalongTransformEPFvRK11QuaternionfRK8Vector3fS5_E, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN4core20StringStorageDefaultIcE6assignERKS1_: __ZN4core20StringStorageDefaultIcE6assignERKS1_, __ZN15SerializeTraitsINSt3__24pairIi14ConstantStringEEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairIi14ConstantStringEEE8TransferI14SafeBinaryReadEEvRS3_RT_, __ZN13WheelColliderD2Ev: __ZN13WheelColliderD2Ev, __ZN13RenderTexture20SetEnableRandomWriteEb: __ZN13RenderTexture20SetEnableRandomWriteEb, __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN39AssetBundleLoadFromStreamAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_, __Z13FormatOrderedPKcz: __Z13FormatOrderedPKcz, __Z14PadImageBorderR14ImageReferenceii: __Z14PadImageBorderR14ImageReferenceii, __ZN5physx2Sc18TriggerInteraction16isOneActorActiveEv: __ZN5physx2Sc18TriggerInteraction16isOneActorActiveEv, __ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_: __ZNK5Umbra11Transformer17frustumTestBoundsENS_12SIMDRegisterES1_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEE15growAndPushBackERKS2_, __ZN5physx2Sn17readAllPropertiesINS_16PxPrismaticJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_16PxPrismaticJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, _unzClose: _unzClose, __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_8CapsuleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN9Rigidbody14SetIsKinematicEb: __ZN9Rigidbody14SetIsKinematicEb, __Z43ParticleRenderer_Get_Custom_PropLengthScaleP12Il2CppObject: __Z43ParticleRenderer_Get_Custom_PropLengthScaleP12Il2CppObject, __ZN12_GLOBAL__N_112RenderReaderILb1EED2Ev: __ZN12_GLOBAL__N_112RenderReaderILb1EED2Ev, __ZN12AudioManager39HandlePendingAudioConfigurationCallbackEv: __ZN12AudioManager39HandlePendingAudioConfigurationCallbackEv, __ZNK8Material16MarkDependenciesER27GarbageCollectorThreadState: __ZNK8Material16MarkDependenciesER27GarbageCollectorThreadState, _islower_l: _islower_l, __ZNK14SplatMaterials20GetSplatBaseMaterialEv: __ZNK14SplatMaterials20GetSplatBaseMaterialEv, __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace: __ZNK13TranslateGLES9GetFormatE13TextureFormat17TextureColorSpace, __ZN12_GLOBAL__N_16qAtan2Eff: __ZN12_GLOBAL__N_16qAtan2Eff, __Z13RegisterClassI9RigidbodyEvv: __Z13RegisterClassI9RigidbodyEvv, __Z73Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxCollisionShapesv: __Z73Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxCollisionShapesv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__erase_to_endEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__erase_to_endEj, __ZN18AsyncUploadManager17CleanUpMemoryPoolEv: __ZN18AsyncUploadManager17CleanUpMemoryPoolEv, __Z45Register_UnityEngine_Texture2DArray_GetPixelsv: __Z45Register_UnityEngine_Texture2DArray_GetPixelsv, __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType: __ZN12BaseRenderer20SetLightmapSTNoDirtyERK8Vector4f12LightmapType, __ZN19ConstantBuffersGLES12RecordRenderEv: __ZN19ConstantBuffersGLES12RecordRenderEv, __ZN5physx13ActorAABBTaskD2Ev: __ZN5physx13ActorAABBTaskD2Ev, __ZN18AsyncUploadManager22UploadStreamingTextureEP28FileTextureUploadInstruction: __ZN18AsyncUploadManager22UploadStreamingTextureEP28FileTextureUploadInstruction, __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlags, _jnf: _jnf, __ZN4crnd12symbol_codec11decode_bitsEj: __ZN4crnd12symbol_codec11decode_bitsEj, __Z46QualitySettings_Get_Custom_PropPixelLightCountv: __Z46QualitySettings_Get_Custom_PropPixelLightCountv, __ZN15b2CircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN15b2CircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZv, __ZN16ParticleRenderer16GenerateUVFramesEv: __ZN16ParticleRenderer16GenerateUVFramesEv, __ZN21FixedBehaviourManagerD0Ev: __ZN21FixedBehaviourManagerD0Ev, __ZN10Matrix3x4f8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10Matrix3x4f8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17b2ContactListener12BeginContactEP9b2Contact: __ZN17b2ContactListener12BeginContactEP9b2Contact, __ZN5Umbra4Math3logERKNS_6DoubleE: __ZN5Umbra4Math3logERKNS_6DoubleE, __Z43PhysicsMaterial2D_Get_Custom_PropBouncinessP12Il2CppObject: __Z43PhysicsMaterial2D_Get_Custom_PropBouncinessP12Il2CppObject, __Z35setPxVehicleDriveSimData_EngineDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataE: __Z35setPxVehicleDriveSimData_EngineDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataE, __Z52Register_UnityEngine_AudioSource_GetOutputDataHelperv: __Z52Register_UnityEngine_AudioSource_GetOutputDataHelperv, __Z27AsyncReadForceCloseAllFilesv: __Z27AsyncReadForceCloseAllFilesv, __ZNK18GfxFramebufferGLES15GetSamplesCountEv: __ZNK18GfxFramebufferGLES15GetSamplesCountEv, __ZN4FMOD6System20getRecordDriverInfoWEiPsiP9FMOD_GUID: __ZN4FMOD6System20getRecordDriverInfoWEiPsiP9FMOD_GUID, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __Z43Animator_CUSTOM_GetIKPositionWeightInternalP12Il2CppObjecti: __Z43Animator_CUSTOM_GetIKPositionWeightInternalP12Il2CppObjecti, __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeTorqueP12Il2CppObjectRK8Vector3fi: __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeTorqueP12Il2CppObjectRK8Vector3fi, __ZN15CollisionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15CollisionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11TerrainData7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11TerrainData7PRODUCEE10MemLabelId18ObjectCreationMode, __Z16MarkDependenciesR27GarbageCollectorThreadStatej: __Z16MarkDependenciesR27GarbageCollectorThreadStatej, __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, _iconv: _iconv, __Z25setPxTolerancesScaleSpeedPN5physx17PxTolerancesScaleEf: __Z25setPxTolerancesScaleSpeedPN5physx17PxTolerancesScaleEf, _noop_upsample: _noop_upsample, __Z54ParticleAnimator_CUSTOM_INTERNAL_set_worldRotationAxisP12Il2CppObjectRK8Vector3f: __Z54ParticleAnimator_CUSTOM_INTERNAL_set_worldRotationAxisP12Il2CppObjectRK8Vector3f, __ZN5Umbra9BitVectoraSERKS0_: __ZN5Umbra9BitVectoraSERKS0_, __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy: __ZN22UnityProfilerPerThread9EndSampleEP19ProfilerInformationy, _UNITY_FT_Set_Charmap: _UNITY_FT_Set_Charmap, __ZNK9Transform11GetPositionEv: __ZNK9Transform11GetPositionEv, __ZN5physx12NpConstraint8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx12NpConstraint8requiresERNS_23PxProcessPxBaseCallbackE, __ZN5physx30PxVehicleWheelsGeneratedValuesC2EPKNS_15PxVehicleWheelsE: __ZN5physx30PxVehicleWheelsGeneratedValuesC2EPKNS_15PxVehicleWheelsE, __ZN23SharedMeshRenderingData18UnloadVertexStreamEi: __ZN23SharedMeshRenderingData18UnloadVertexStreamEi, __ZNK12HingeJoint2D13GetJointAngleEv: __ZNK12HingeJoint2D13GetJointAngleEv, __ZN5physx3Cct13HandleManager3AddEPv: __ZN5physx3Cct13HandleManager3AddEPv, __ZN17MemoryCacheWriterD2Ev: __ZN17MemoryCacheWriterD2Ev, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12getClassSizeEv, __ZN31CanvasBatchIntermediateRenderer11AddSubBatchERK16DrawBuffersRangePK19ShaderPropertySheet: __ZN31CanvasBatchIntermediateRenderer11AddSubBatchERK16DrawBuffersRangePK19ShaderPropertySheet, __ZN16ParticleAnimator23VirtualRedirectTransferER14SafeBinaryRead: __ZN16ParticleAnimator23VirtualRedirectTransferER14SafeBinaryRead, __Z21OrthoNormalVectorFastRK8Vector3f: __Z21OrthoNormalVectorFastRK8Vector3f, __ZN19RenderEventsContextC2Ei: __ZN19RenderEventsContextC2Ei, __Z6simd4fRKf: __Z6simd4fRKf, __Z33AndroidJNI_CUSTOM_CallFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z33AndroidJNI_CUSTOM_CallFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __Z30TextMesh_Get_Custom_PropAnchorP12Il2CppObject: __Z30TextMesh_Get_Custom_PropAnchorP12Il2CppObject, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx14PxSetFilterOpsERKNS_10PxFilterOp4EnumES3_S3_: __ZN5physx14PxSetFilterOpsERKNS_10PxFilterOp4EnumES3_S3_, __ZNK14ParticleSystem16GetParticleCountEv: __ZNK14ParticleSystem16GetParticleCountEv, __ZN10TagManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN10TagManager23VirtualRedirectTransferER14SafeBinaryRead, __ZNK5physx2Sc15ClothFabricCore9getNbSetsEv: __ZNK5physx2Sc15ClothFabricCore9getNbSetsEv, _UNITY_FT_Init_Class_ft_grays_raster: _UNITY_FT_Init_Class_ft_grays_raster, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv, __Z18getPxJointUserDataPKN5physx7PxJointE: __Z18getPxJointUserDataPKN5physx7PxJointE, __ZN5Unity5Cloth25SetWorldAccelerationScaleEf: __ZN5Unity5Cloth25SetWorldAccelerationScaleEf, __Z28RenderTextureSupportsStencilP13RenderTexture: __Z28RenderTextureSupportsStencilP13RenderTexture, __Z15InitLightMeshesv: __Z15InitLightMeshesv, __ZN20QuadTreeNodeRenderer5SetupEP15TerrainRendererP12QuadTreeNode20ReflectionProbeUsageP9Transform: __ZN20QuadTreeNodeRenderer5SetupEP15TerrainRendererP12QuadTreeNode20ReflectionProbeUsageP9Transform, __ZNK5physx7NpScene26getNbContactDataBlocksUsedEv: __ZNK5physx7NpScene26getNbContactDataBlocksUsedEv, __Z49SystemInfo_Get_Custom_PropSupportsLocationServicev: __Z49SystemInfo_Get_Custom_PropSupportsLocationServicev, __ZN4FMOD3DSP14disconnectFromEPS0_: __ZN4FMOD3DSP14disconnectFromEPS0_, __ZN5physx2Gu29computeCapsule_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbjRNS_10PxSweepHitE: __ZN5physx2Gu29computeCapsule_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERNS0_8CapsuleVEffbjRNS_10PxSweepHitE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj669ES2_RKNS_27PxVehicleDifferential4WDataES6_EEKNS_40PxVehicleDifferential4WDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj669ES2_RKNS_27PxVehicleDifferential4WDataES6_EEKNS_40PxVehicleDifferential4WDataGeneratedInfoEEEvPjRKT_RT0_, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE28CreateDelayedDeletionManagerEv: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE28CreateDelayedDeletionManagerEv, __ZN5physx2Gu11HeightField15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Gu11HeightField15exportExtraDataERNS_22PxSerializationContextE, __ZN14SplatMaterials22UpdateBaseMapMaterialsEP8Materialb: __ZN14SplatMaterials22UpdateBaseMapMaterialsEP8Materialb, _term_source: _term_source, _UNITY_png_reciprocal: _UNITY_png_reciprocal, __Z18Transfer_BlittableI9JSONWriteLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall: __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall, __ZN5physx9NpFactory14addClothFabricEPNS_13NpClothFabricEb: __ZN5physx9NpFactory14addClothFabricEPNS_13NpClothFabricEb, _cf2_arrstack_init: _cf2_arrstack_init, __ZN13TargetJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN13TargetJoint2D13AwakeFromLoadE17AwakeFromLoadMode, _pwrite: _pwrite, __Z16MonoAddComponentR10GameObjectPKc: __Z16MonoAddComponentR10GameObjectPKc, __Z15CleanLogHandler7LogTypePKcz: __Z15CleanLogHandler7LogTypePKcz, __Z49Rigidbody_Set_Custom_PropSolverVelocityIterationsP12Il2CppObjecti: __Z49Rigidbody_Set_Custom_PropSolverVelocityIterationsP12Il2CppObjecti, __ZN9ShaderLab19SerializedSubShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab19SerializedSubShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx10NpMaterialC2ERKNS_2Sc12MaterialCoreE: __ZN5physx10NpMaterialC2ERKNS_2Sc12MaterialCoreE, __Z68Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxPlaneCountv: __Z68Register_UnityEngine_ParticleSystem_CollisionModule_GetMaxPlaneCountv, __ZN14AudioBehaviour15ThreadedCleanupEv: __ZN14AudioBehaviour15ThreadedCleanupEv, __ZN5physx9PxTaskMgr10resolveRowEjb: __ZN5physx9PxTaskMgr10resolveRowEjb, __Z39NavMeshAgent_Get_Custom_PropIsPathStaleP12Il2CppObject: __Z39NavMeshAgent_Get_Custom_PropIsPathStaleP12Il2CppObject, __ZN10HumanTrait12CleanupClassEv: __ZN10HumanTrait12CleanupClassEv, __ZN6Camera17RemoveImageFilterERK11ImageFilter: __ZN6Camera17RemoveImageFilterERK11ImageFilter, __ZNSt3__218__insertion_sort_3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_, __ZNK11b2RopeJoint13GetLimitStateEv: __ZNK11b2RopeJoint13GetLimitStateEv, _stbir_resize_uint8: _stbir_resize_uint8, __ZN14AnimationState11SetWrapModeEi: __ZN14AnimationState11SetWrapModeEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z50Register_UnityEngine_ConfigurableJoint_get_xMotionv: __Z50Register_UnityEngine_ConfigurableJoint_get_xMotionv, __ZN11ShapeModule17MainThreadCleanupEv: __ZN11ShapeModule17MainThreadCleanupEv, __Z35setPxVehicleWheelsSimData_WheelDataPN5physx22PxVehicleWheelsSimDataEjNS_18PxVehicleWheelDataE: __Z35setPxVehicleWheelsSimData_WheelDataPN5physx22PxVehicleWheelsSimDataEjNS_18PxVehicleWheelDataE, __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev: __ZNSt3__214__split_bufferI20ComputeShaderVariantRNS_9allocatorIS1_EEED2Ev, __ZN8Collider12GetIsTriggerEv: __ZN8Collider12GetIsTriggerEv, __ZN12NavMeshAgent13SetBaseOffsetEf: __ZN12NavMeshAgent13SetBaseOffsetEf, __Z21CalculateLightQuadFacf: __Z21CalculateLightQuadFacf, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZNKSt3__210moneypunctIwLb1EE14do_curr_symbolEv: __ZNKSt3__210moneypunctIwLb1EE14do_curr_symbolEv, __Z40Renderer_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString: __Z40Renderer_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString, __ZNK5physx13NpClothFabric13getRestvaluesEPfj: __ZNK5physx13NpClothFabric13getRestvaluesEPfj, __Z50Register_UnityEngine_Rendering_CommandBuffer_Clearv: __Z50Register_UnityEngine_Rendering_CommandBuffer_Clearv, __ZN4FMOD12ChannelGroup20override3DAttributesEPK11FMOD_VECTORS3_: __ZN4FMOD12ChannelGroup20override3DAttributesEPK11FMOD_VECTORS3_, __ZNK8Playable11GetDurationEv: __ZNK8Playable11GetDurationEv, __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEEEEjT_j: __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEEEEjT_j, __ZN17AnimationPlayable28ComputeNeedsBindingRebuildedEv: __ZN17AnimationPlayable28ComputeNeedsBindingRebuildedEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetnEPci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetnEPci, __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14DetailDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__210moneypunctIwLb1EE16do_thousands_sepEv: __ZNKSt3__210moneypunctIwLb1EE16do_thousands_sepEv, __ZN5physx30PxcPCMContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx30PxcPCMContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN13b2DynamicTree15RebuildBottomUpEv: __ZN13b2DynamicTree15RebuildBottomUpEv, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv, __ZN15DistanceJoint2DD2Ev: __ZN15DistanceJoint2DD2Ev, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_, __ZN5physx23PxsBroadPhaseContextSap21batchUpdateFewUpdatesEjRPNS_17PxcBroadPhasePairERjS4_: __ZN5physx23PxsBroadPhaseContextSap21batchUpdateFewUpdatesEjRPNS_17PxcBroadPhasePairERjS4_, __ZN5physx3Cct17getSceneTimestampEPKNS0_30InternalCBData_FindTouchedGeomE: __ZN5physx3Cct17getSceneTimestampEPKNS0_30InternalCBData_FindTouchedGeomE, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5writeEPKwi: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5writeEPKwi, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale1Ev, __ZN6Sprite9ReloadAllEv: __ZN6Sprite9ReloadAllEv, __ZN18UnityConnectClient33OnPlayerSessionStateChangedStaticEPS_jyy: __ZN18UnityConnectClient33OnPlayerSessionStateChangedStaticEPS_jyy, __ZN5Umbra4Math3absERKNS_6DoubleE: __ZN5Umbra4Math3absERKNS_6DoubleE, __ZN25RuntimeAnimatorController12CleanupClassEv: __ZN25RuntimeAnimatorController12CleanupClassEv, __ZN14TerrainManager27UnloadTerrainsFromGfxDeviceEv: __ZN14TerrainManager27UnloadTerrainsFromGfxDeviceEv, __ZN5Umbra15CameraTransformC2ERKS0_: __ZN5Umbra15CameraTransformC2ERKS0_, __Z55ParticleSystem_TriggerModule_CUSTOM_GetMaxColliderCountP12Il2CppObject: __Z55ParticleSystem_TriggerModule_CUSTOM_GetMaxColliderCountP12Il2CppObject, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_, __ZN5physx2Sc17ParticleSystemSim20scheduleCollisionCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim20scheduleCollisionCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE, __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_yDriveP12Il2CppObjectP10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_yDriveP12Il2CppObjectP10JointDrive, __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_: __ZNK5physx2Gu15HeightFieldUtil7getEdgeEjjjjRNS_6PxVec3ES3_, __Z25PlayerPrefs_CUSTOM_GetIntP12Il2CppStringi: __Z25PlayerPrefs_CUSTOM_GetIntP12Il2CppStringi, __ZN7ApiGLES4LoadE16GfxDeviceLevelGL: __ZN7ApiGLES4LoadE16GfxDeviceLevelGL, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags, __ZNSt3__218condition_variable10notify_allEv: __ZNSt3__218condition_variable10notify_allEv, __ZN5physx9NpPhysics15createAggregateEjb: __ZN5physx9NpPhysics15createAggregateEjb, __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN17ProceduralTexture22UploadSubstanceTextureER17SubstanceTexture_: __ZN17ProceduralTexture22UploadSubstanceTextureER17SubstanceTexture_, __ZN13SparseTextureD0Ev: __ZN13SparseTextureD0Ev, __ZNKSt3__211__libcpp_db15__find_iteratorEPKv: __ZNKSt3__211__libcpp_db15__find_iteratorEPKv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_, __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib: __ZN8Material11SetPassFastEPN9ShaderLab4PassER17ShaderPassContextP6Shaderib, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj575ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj575ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN20ExternalForcesModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN20ExternalForcesModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState, __Z52Register_UnityEngine_Gradient_INTERNAL_CALL_Evaluatev: __Z52Register_UnityEngine_Gradient_INTERNAL_CALL_Evaluatev, __ZN11UnityEngine7Connect20BasePersistentValues10SaveValuesER9JSONWrite: __ZN11UnityEngine7Connect20BasePersistentValues10SaveValuesER9JSONWrite, __ZN15PolynomialCurve12IsValidCurveERK17AnimationCurveTplIfE: __ZN15PolynomialCurve12IsValidCurveERK17AnimationCurveTplIfE, __Z31Renderer_Set_Custom_PropEnabledP12Il2CppObjecth: __Z31Renderer_Set_Custom_PropEnabledP12Il2CppObjecth, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZNK4crnd25static_huffman_data_model26compute_decoder_table_bitsEv: __ZNK4crnd25static_huffman_data_model26compute_decoder_table_bitsEv, __ZNK5physx3Ext7D6Joint13getTwistLimitEv: __ZNK5physx3Ext7D6Joint13getTwistLimitEv, __ZN5Umbra9RasterOps5clearERNS_17BlockRasterBufferE: __ZN5Umbra9RasterOps5clearERNS_17BlockRasterBufferE, __ZN5physx9PxTaskMgr12addReferenceEj: __ZN5physx9PxTaskMgr12addReferenceEj, __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_, __ZN22VirtualJoystickManagerC2Ev: __ZN22VirtualJoystickManagerC2Ev, __ZN20GlobalCachingManager7DisposeEv: __ZN20GlobalCachingManager7DisposeEv, __Z12SetupLODFadeR9GfxDeviceR17ShaderPassContextf: __Z12SetupLODFadeR9GfxDeviceR17ShaderPassContextf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEclILj561ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN26b2PolygonAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN26b2PolygonAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, _UNITY_png_set_invert_alpha: _UNITY_png_set_invert_alpha, __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_, __Z44Physics2D_CUSTOM_INTERNAL_CALL_CircleCastAllRK13Vector2fIcallfS1_fiff: __Z44Physics2D_CUSTOM_INTERNAL_CALL_CircleCastAllRK13Vector2fIcallfS1_fiff, __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZL24CollectForwardObjectsJobP27CollectForwardObjectsHeader: __ZL24CollectForwardObjectsJobP27CollectForwardObjectsHeader, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev, __Z13IsNodeVisibleRK9SceneNodeRK4AABBRK22SceneCullingParameters: __Z13IsNodeVisibleRK9SceneNodeRK4AABBRK22SceneCullingParameters, __ZN12HingeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12HingeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5Umbra13MatrixFactory13transformBaseERKNS_7Vector3ES3_S3_S3_: __ZN5Umbra13MatrixFactory13transformBaseERKNS_7Vector3ES3_S3_S3_, __ZNSt3__27codecvtIDic11__mbstate_tED0Ev: __ZNSt3__27codecvtIDic11__mbstate_tED0Ev, __ZN12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv: __ZN12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv, __ZN11UnityEngine15CloudWebService16SessionContainer7RestoreERK8UnityStrPvy: __ZN11UnityEngine15CloudWebService16SessionContainer7RestoreERK8UnityStrPvy, __ZN12NavMeshAgent18GetInternalNavMeshEv: __ZN12NavMeshAgent18GetInternalNavMeshEv, _jsimd_quantize_float: _jsimd_quantize_float, __Z57RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustRectP12Il2CppObjectS0_R5RectTIfE: __Z57RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustRectP12Il2CppObjectS0_R5RectTIfE, __ZN5physx2Sc9ClothCore13setTargetPoseERKNS_11PxTransformE: __ZN5physx2Sc9ClothCore13setTargetPoseERKNS_11PxTransformE, __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_positionv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_positionv, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE15growAndPushBackERKS2_, __ZN4FMOD7SystemI9setOutputE15FMOD_OUTPUTTYPE: __ZN4FMOD7SystemI9setOutputE15FMOD_OUTPUTTYPE, __ZZ29InitializeTextRenderingModulevEN40CleanUpTextRenderingGarbageCollectstruct7ForwardEv: __ZZ29InitializeTextRenderingModulevEN40CleanUpTextRenderingGarbageCollectstruct7ForwardEv, __Z32AndroidJNI_CUSTOM_GetArrayLength13Il2Cpp_IntPtr: __Z32AndroidJNI_CUSTOM_GetArrayLength13Il2Cpp_IntPtr, _jpeg_get_small: _jpeg_get_small, __ZN15RenderNodeQueue7CleanupEv: __ZN15RenderNodeQueue7CleanupEv, __ZN14LineParameters8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14LineParameters8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn20ReaderNameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN16NovodexAllocator8allocateEjPKcS1_i: __ZN16NovodexAllocator8allocateEjPKcS1_i, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2Ev, __ZN14dtNavMeshQuery9initPoolsEPK9dtNavMeshi: __ZN14dtNavMeshQuery9initPoolsEPK9dtNavMeshi, __Z45NavMeshAgent_CUSTOM_INTERNAL_set_nextPositionP12Il2CppObjectRK8Vector3f: __Z45NavMeshAgent_CUSTOM_INTERNAL_set_nextPositionP12Il2CppObjectRK8Vector3f, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYMultiplierv, __ZN16b2StackAllocatorD2Ev: __ZN16b2StackAllocatorD2Ev, __ZN12InputManager7GetAxisERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager7GetAxisERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN9ShaderLab10GrabPassesD2Ev: __ZN9ShaderLab10GrabPassesD2Ev, __ZN14ParticleSystem11AutoPrewarmEv: __ZN14ParticleSystem11AutoPrewarmEv, __ZN14Texture2DArray13UploadTextureEv: __ZN14Texture2DArray13UploadTextureEv, __ZN9HeightmapC2EP11TerrainData: __ZN9HeightmapC2EP11TerrainData, _tt_cmap14_done: _tt_cmap14_done, __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv: __ZN18AwakeFromLoadQueue25RegisterObjectInstanceIDsEv, __ZNK14NavMeshCarving28CollectCarveDataAndOperationER15CarveDataArraysRK10MinMaxAABBRK13dynamic_arrayIS2_Lj4EE: __ZNK14NavMeshCarving28CollectCarveDataAndOperationER15CarveDataArraysRK10MinMaxAABBRK13dynamic_arrayIS2_Lj4EE, _LzmaProps_Decode: _LzmaProps_Decode, __Z42HingeJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject: __Z42HingeJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject, __Z44Register_UnityEngine_Mesh_AddBlendShapeFramev: __Z44Register_UnityEngine_Mesh_AddBlendShapeFramev, __Z33InitializeWebGLPersistentDataPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z33InitializeWebGLPersistentDataPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN20TextRenderingPrivate19NativeTextGenerator15InsertCharacterEiPj: __ZN20TextRenderingPrivate19NativeTextGenerator15InsertCharacterEiPj, __Z42Register_UnityEngine_Event_set_commandNamev: __Z42Register_UnityEngine_Event_set_commandNamev, __Z32setPxRevoluteJoint_DriveVelocityPN5physx15PxRevoluteJointEf: __Z32setPxRevoluteJoint_DriveVelocityPN5physx15PxRevoluteJointEf, __ZN5physx2Cm12RenderBuffer5clearEv: __ZN5physx2Cm12RenderBuffer5clearEv, __Z11SetLocalTRS15TransformAccessRKN4math7_float3ERKNS0_7_float4ES3_: __Z11SetLocalTRS15TransformAccessRKN4math7_float3ERKNS0_7_float4ES3_, __ZNK5physx2Sc9ClothCore21getStiffnessFrequencyEv: __ZNK5physx2Sc9ClothCore21getStiffnessFrequencyEv, __ZN11b2RopeJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN11b2RopeJoint24SolveVelocityConstraintsERK12b2SolverData, __ZNKSt3__215__codecvt_utf16IDiLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IDiLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_, __Z37Animator_Get_Custom_PropIsInitializedP12Il2CppObject: __Z37Animator_Get_Custom_PropIsInitializedP12Il2CppObject, __ZN5physx2Sc5Scene8addShapeERNS0_8RigidSimERNS0_9ShapeCoreE: __ZN5physx2Sc5Scene8addShapeERNS0_8RigidSimERNS0_9ShapeCoreE, __ZN14GfxDeviceStats15SetScreenParamsEiiiiii: __ZN14GfxDeviceStats15SetScreenParamsEiiiiii, __ZN17Physics2DSettings20SetVelocityThresholdEf: __ZN17Physics2DSettings20SetVelocityThresholdEf, __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf: __ZN24OptimizedPolynomialCurve19BuildOptimizedCurveERK17AnimationCurveTplIfEf, __Z65Register_UnityEngine_SpriteRenderer_INTERNAL_CALL_GetSpriteBoundsv: __Z65Register_UnityEngine_SpriteRenderer_INTERNAL_CALL_GetSpriteBoundsv, __ZN5physx13PxsCCDContext14postCCDAdvanceEPNS_10PxBaseTaskE: __ZN5physx13PxsCCDContext14postCCDAdvanceEPNS_10PxBaseTaskE, __ZN12_GLOBAL__N_112UserRendererD2Ev: __ZN12_GLOBAL__N_112UserRendererD2Ev, __ZN17AnimationPlayableD0Ev: __ZN17AnimationPlayableD0Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i: __Z15VerifySignatureNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_i, __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXLimitSpringv: __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXLimitSpringv, __Z12MurmurHash2APKvij: __Z12MurmurHash2APKvij, __Z29InputTracking_CUSTOM_Recenterv: __Z29InputTracking_CUSTOM_Recenterv, __Z53Register_UnityEngine_ReflectionProbe_get_bakedTexturev: __Z53Register_UnityEngine_ReflectionProbe_get_bakedTexturev, __Z43Physics2D_Get_Custom_PropPositionIterationsv: __Z43Physics2D_Get_Custom_PropPositionIterationsv, __Z41MonoBehaviour_Set_Custom_PropUseGUILayoutP12Il2CppObjecth: __Z41MonoBehaviour_Set_Custom_PropUseGUILayoutP12Il2CppObjecth, _UNITY_FT_Open_Face: _UNITY_FT_Open_Face, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj77ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj77ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8Animator18GetAngualrVelocityEv: __ZN8Animator18GetAngualrVelocityEv, __ZN2UI13RectTransform19SetDrivenPropertiesENS0_16DrivenPropertiesE: __ZN2UI13RectTransform19SetDrivenPropertiesENS0_16DrivenPropertiesE, __Z17RegisterModule_VRv: __Z17RegisterModule_VRv, __Z17GetWebErrorString8WebError: __Z17GetWebErrorString8WebError, __ZN14BillboardAsset23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14BillboardAsset23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx10BPWorkTask7getNameEv: __ZNK5physx10BPWorkTask7getNameEv, __ZN5Umbra20RuntimeTomeGenerator17generateEmptyTileERNS_7DataPtrERKNS_4AABBEi: __ZN5Umbra20RuntimeTomeGenerator17generateEmptyTileERNS_7DataPtrERKNS_4AABBEi, __ZN16ParticleAnimator23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16ParticleAnimator23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z33AndroidJNI_CUSTOM_SetBooleanField13Il2Cpp_IntPtrS_h: __Z33AndroidJNI_CUSTOM_SetBooleanField13Il2Cpp_IntPtrS_h, __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z58Register_UnityEngine_AI_NavMesh_GetAvoidancePredictionTimev: __Z58Register_UnityEngine_AI_NavMesh_GetAvoidancePredictionTimev, __Z48setPxSimulationStatisticsNbActiveKinematicBodiesPN5physx22PxSimulationStatisticsEj: __Z48setPxSimulationStatisticsNbActiveKinematicBodiesPN5physx22PxSimulationStatisticsEj, __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableDynamicCollidersv: __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetEnableDynamicCollidersv, __ZN5Umbra10PathFinder11reversePathEv: __ZN5Umbra10PathFinder11reversePathEv, __Z34Graphics_CUSTOM_Internal_SetNullRTv: __Z34Graphics_CUSTOM_Internal_SetNullRTv, __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetEnabledv: __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetEnabledv, __Z50ParticleRenderer_Get_Custom_PropParticleRenderModeP12Il2CppObject: __Z50ParticleRenderer_Get_Custom_PropParticleRenderModeP12Il2CppObject, __Z18Transfer_BlittableI9JSONWriteLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RestvaluesPropertyC2Ev: __ZN5physx18RestvaluesPropertyC2Ev, __Z11RequireTypePKcS0_S0_: __Z11RequireTypePKcS0_S0_, __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev: __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev, __Z9PrintARGVv: __Z9PrintARGVv, _fchmodat: _fchmodat, __ZN12HandlerChain4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN12HandlerChain4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_, __ZNSt3__217__assoc_sub_state4waitEv: __ZNSt3__217__assoc_sub_state4waitEv, __ZN5physx2Sc16ArticulationCore26setExternalDriveIterationsEj: __ZN5physx2Sc16ArticulationCore26setExternalDriveIterationsEj, __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj: __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj, __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetEnabledv: __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetEnabledv, __ZN5physx23PxVehicleWheels4SimData22setSuspTravelDirectionEjRKNS_6PxVec3E: __ZN5physx23PxVehicleWheels4SimData22setSuspTravelDirectionEjRKNS_6PxVec3E, __Z56DrivenRectTransformTracker_CUSTOM_CanRecordModificationsv: __Z56DrivenRectTransformTracker_CUSTOM_CanRecordModificationsv, __ZN9GfxDevice15ImmediateVertexEfff: __ZN9GfxDevice15ImmediateVertexEfff, __ZN27AnimatorControllerParameter7SetTypeE31AnimatorControllerParameterType: __ZN27AnimatorControllerParameter7SetTypeE31AnimatorControllerParameterType, __Z13RegisterClassI8MaterialEvv: __Z13RegisterClassI8MaterialEvv, __ZN5physx14NpRigidDynamic10clearForceENS_11PxForceMode4EnumE: __ZN5physx14NpRigidDynamic10clearForceENS_11PxForceMode4EnumE, __ZN13SpringJoint2D5ResetEv: __ZN13SpringJoint2D5ResetEv, __ZN16GraphicsSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN16GraphicsSettings13AwakeFromLoadE17AwakeFromLoadMode, __Z43Register_UnityEngine_Screen_get_orientationv: __Z43Register_UnityEngine_Screen_get_orientationv, _exp10f: _exp10f, __ZN6Object13AwakeFromLoadE17AwakeFromLoadMode: __ZN6Object13AwakeFromLoadE17AwakeFromLoadMode, __ZN13GfxDeviceGLES15SetStencilStateEPK18DeviceStencilStatei: __ZN13GfxDeviceGLES15SetStencilStateEPK18DeviceStencilStatei, __ZN18AsyncUploadManager15AcquireWritePtrEj: __ZN18AsyncUploadManager15AcquireWritePtrEj, __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cycle: _cycle, __ZN18AudioLowPassFilter12AddToManagerEv: __ZN18AudioLowPassFilter12AddToManagerEv, __Z11stbFreeImplPvS_: __Z11stbFreeImplPvS_, __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15b2DistanceProxy3SetEPK7b2Shapei: __ZN15b2DistanceProxy3SetEPK7b2Shapei, __ZN16MemoryFileSystemD2Ev: __ZN16MemoryFileSystemD2Ev, __Z36GameObject_CUSTOM_INTERNAL_get_sceneP12Il2CppObjectPi: __Z36GameObject_CUSTOM_INTERNAL_get_sceneP12Il2CppObjectPi, __ZNSt3__211__libcpp_db16__invalidate_allEPv: __ZNSt3__211__libcpp_db16__invalidate_allEPv, __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP9Texture2D7TextureET_RK4PPtrIT0_E, __ZN7mecanim14ValueArrayLoopERKNS_10ValueArrayES2_RS0_fRKNS_14ValueArrayMaskE: __ZN7mecanim14ValueArrayLoopERKNS_10ValueArrayES2_RS0_fRKNS_14ValueArrayMaskE, __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE12EnsureBufferEj: __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE12EnsureBufferEj, __ZNKSt3__214__codecvt_utf8IwE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__214__codecvt_utf8IwE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZN5physx2Sn25readStridedBufferPropertyINS0_8TriangleIjEEEEvRNS_9XmlReaderEPKcRPvRjSA_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS0_8TriangleIjEEEEvRNS_9XmlReaderEPKcRPvRjSA_RNS_18XmlMemoryAllocatorE, __ZThn12_N5physx3Ext7D6JointD1Ev: __ZThn12_N5physx3Ext7D6JointD1Ev, __ZN13RuntimeStaticI23MeshVertexFormatManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI23MeshVertexFormatManagerE13StaticDestroyEPv, __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv: __ZN7ApiGLES15TextureSubImageEj16TextureDimensionN2gl9TexFormatEiiiiiiiiPKv, __Z37Register_UnityEngine_Camera_get_depthv: __Z37Register_UnityEngine_Camera_get_depthv, __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE, __ZN13AnimationClip24SetDidModifyClipCallbackEPFvPS_R4ListI8ListNodeI14AnimationStateEEE: __ZN13AnimationClip24SetDidModifyClipCallbackEPFvPS_R4ListI8ListNodeI14AnimationStateEEE, __Z4loadPKf: __Z4loadPKf, __ZNK5physx16PxsBroadPhaseMBP18getNumDeletedPairsEv: __ZNK5physx16PxsBroadPhaseMBP18getNumDeletedPairsEv, __ZNSt3__215recursive_mutexD2Ev: __ZNSt3__215recursive_mutexD2Ev, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty, __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj, __ZN5physx10PxsCCDPair17sweepAdvanceToToiEfb: __ZN5physx10PxsCCDPair17sweepAdvanceToToiEfb, __Z45Register_UnityEngine_Animator_IsBoneTransformv: __Z45Register_UnityEngine_Animator_IsBoneTransformv, __Z23ConvertIntegerToTypePtrItEbPvR14SafeBinaryRead: __Z23ConvertIntegerToTypePtrItEbPvR14SafeBinaryRead, __ZN20BufferedSocketStream8ShutdownEv: __ZN20BufferedSocketStream8ShutdownEv, __ZN14StackAllocator12SetBlockSizeEj: __ZN14StackAllocator12SetBlockSizeEj, __Z36getPxVehicleDriveDynData_CurrentGearPKN5physx21PxVehicleDriveDynDataE: __Z36getPxVehicleDriveDynData_CurrentGearPKN5physx21PxVehicleDriveDynDataE, __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE: __ZN7mecanim5human29HumanGetGoalOrientationOffsetENS0_4GoalE, __Z38CustomEventData_CUSTOM_InternalDestroyP12Il2CppObject: __Z38CustomEventData_CUSTOM_InternalDestroyP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZN5physx16PxsIslandManager11freeBuffersEv: __ZN5physx16PxsIslandManager11freeBuffersEv, __ZN9ShaderLab4Pass15IsPassSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN9ShaderLab4Pass15IsPassSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN18AwakeFromLoadQueueD2Ev: __ZN18AwakeFromLoadQueueD2Ev, __ZN5Unity12PhysicsQuery21OverlapBoxUserCollectERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE: __ZN5Unity12PhysicsQuery21OverlapBoxUserCollectERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE, __Z40PointEffector2D_Get_Custom_PropForceModeP12Il2CppObject: __Z40PointEffector2D_Get_Custom_PropForceModeP12Il2CppObject, __Z44Register_UnityEngine_AI_NavMeshAgent_SetPathv: __Z44Register_UnityEngine_AI_NavMeshAgent_SetPathv, __ZN9ShaderLab20SerializedSubProgram14AddMatrixParamEPKcii15ShaderParamTypei: __ZN9ShaderLab20SerializedSubProgram14AddMatrixParamEPKcii15ShaderParamTypei, __Z44Register_UnityEngine_AnimationState_get_namev: __Z44Register_UnityEngine_AnimationState_get_namev, __ZThn12_N5physx3Ext13DistanceJointD0Ev: __ZThn12_N5physx3Ext13DistanceJointD0Ev, __ZN12ServerSocket6AcceptEv: __ZN12ServerSocket6AcceptEv, __ZN31CollisionModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN31CollisionModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN10Effector2D17ProcessEndContactEP10Collider2DP9b2Contact: __ZN10Effector2D17ProcessEndContactEP10Collider2DP9b2Contact, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6insertINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISF_E9referenceEEE5valueENS6_IPS1_EEE4typeENS6_IPKS1_EESF_SF_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6insertINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISF_E9referenceEEE5valueENS6_IPS1_EEE4typeENS6_IPKS1_EESF_SF_, __ZN4FMOD7SystemI16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E: __ZN4FMOD7SystemI16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E, __Z39Quaternion_CUSTOM_INTERNAL_CALL_InverseRK11QuaternionfRS_: __Z39Quaternion_CUSTOM_INTERNAL_CALL_InverseRK11QuaternionfRS_, __Z51Register_UnityEngine_ComputeShader_Internal_SetIntsv: __Z51Register_UnityEngine_ComputeShader_Internal_SetIntsv, __ZN2UI6Canvas25GetRootLocalToWorldMatrixEv: __ZN2UI6Canvas25GetRootLocalToWorldMatrixEv, __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetEnabledv: __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetEnabledv, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEaSEOS3_: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEaSEOS3_, __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEEEEEjT_j: __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEEEEEjT_j, __ZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPii: __ZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPii, _tt_delta_interpolate: _tt_delta_interpolate, _tt_cmap12_get_info: _tt_cmap12_get_info, __Z51Register_UnityEngine_AI_NavMeshAgent_get_pathStatusv: __Z51Register_UnityEngine_AI_NavMeshAgent_get_pathStatusv, __Z24LoadImageIntoTextureImplI11JpegDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE: __Z24LoadImageIntoTextureImplI11JpegDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE, __ZNK21AssetBundleFileSystem25GetRelativeFileSystemPathEPKc: __ZNK21AssetBundleFileSystem25GetRelativeFileSystemPathEPKc, __Z58Register_UnityEngine_Caching_INTERNAL_CALL_IsVersionCachedv: __Z58Register_UnityEngine_Caching_INTERNAL_CALL_IsVersionCachedv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN21LoadResourceOperation12LoadResourceERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN21LoadResourceOperation12LoadResourceERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx7NpScene9startReadEv: __ZNK5physx7NpScene9startReadEv, __ZNK17ProceduralTexture9HasMipMapEv: __ZNK17ProceduralTexture9HasMipMapEv, __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE: __ZN5physx26PxcFsComputeJointLoadsSimdERKNS_9PxcFsDataEPKNS_12PxcFsInertiaEPNS_6shdfnd3aos6Mat33VEPKfjjNS_21PxcFsScratchAllocatorE, __GLOBAL__sub_I_MemoryManager_cpp: __GLOBAL__sub_I_MemoryManager_cpp, __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6vectorIS5_NS3_IS5_EEEE: __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6vectorIS5_NS3_IS5_EEEE, __ZN5physx6shdfnd8SyncImpl7getSizeEv: __ZN5physx6shdfnd8SyncImpl7getSizeEv, __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs: __Z11BuildCurvesR25MinMaxOptimizedPolyCurvesRK21MinMaxAnimationCurvesfs, __Z46Register_UnityEngine_Joint_set_enableCollisionv: __Z46Register_UnityEngine_Joint_set_enableCollisionv, _UNITY_png_get_sRGB: _UNITY_png_get_sRGB, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SF_EEiEESI_RKT_: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SF_EEiEESI_RKT_, __Z33Screen_Set_Custom_PropOrientation17ScreenOrientation: __Z33Screen_Set_Custom_PropOrientation17ScreenOrientation, __ZN5physx11PxHitBufferINS_12PxRaycastHitEED0Ev: __ZN5physx11PxHitBufferINS_12PxRaycastHitEED0Ev, __ZN12_GLOBAL__N_116D6JointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_116D6JointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYv, __Z61Register_UnityEngine_ParticleSystem_EmissionModule_SetEnabledv: __Z61Register_UnityEngine_ParticleSystem_EmissionModule_SetEnabledv, __Z43Register_UnityEngine_Renderer_get_materialsv: __Z43Register_UnityEngine_Renderer_get_materialsv, __Z35setPxVehicleDriveSimDataNW_DiffDataPN5physx23PxVehicleDriveSimDataNWERKNS_27PxVehicleDifferentialNWDataE: __Z35setPxVehicleDriveSimDataNW_DiffDataPN5physx23PxVehicleDriveSimDataNWERKNS_27PxVehicleDifferentialNWDataE, __ZN20LocalFileSystemPosix20GetHomeDirectoryPathEv: __ZN20LocalFileSystemPosix20GetHomeDirectoryPathEv, __Z16ShouldUseShadowsb: __Z16ShouldUseShadowsb, __ZN12MeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12MeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z85Register_UnityEngine_Experimental_Director_AnimationLayerMixerPlayable_InternalCreatev: __Z85Register_UnityEngine_Experimental_Director_AnimationLayerMixerPlayable_InternalCreatev, __Z32LineRenderer_CUSTOM_GetPositionsP12Il2CppObjectP11Il2CppArray: __Z32LineRenderer_CUSTOM_GetPositionsP12Il2CppObjectP11Il2CppArray, __ZN9Projector8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Projector8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z43Register_UnityEngine_GUI_SetNextControlNamev: __Z43Register_UnityEngine_GUI_SetNextControlNamev, __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z43UnityConnectSettings_Set_Custom_PropEnabledh: __Z43UnityConnectSettings_Set_Custom_PropEnabledh, __ZN7ApiGLES10DrawArraysE16GfxPrimitiveTypejjj: __ZN7ApiGLES10DrawArraysE16GfxPrimitiveTypejjj, __Z43Light_Set_Custom_PropShadowCustomResolutionP12Il2CppObjecti: __Z43Light_Set_Custom_PropShadowCustomResolutionP12Il2CppObjecti, __ZN5physx3Cct13BoxController15getPxControllerEv: __ZN5physx3Cct13BoxController15getPxControllerEv, __Z45Register_UnityEngine_SpriteRenderer_set_flipXv: __Z45Register_UnityEngine_SpriteRenderer_set_flipXv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj645ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj645ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN10SampleClip13LoadBaseSoundEv: __ZN10SampleClip13LoadBaseSoundEv, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd10SocketImpl5flushEv: __ZN5physx6shdfnd10SocketImpl5flushEv, __ZN5Umbra9Matrix2x29transposeEv: __ZN5Umbra9Matrix2x29transposeEv, __Z47Register_UnityEngine_SliderJoint2D_get_useMotorv: __Z47Register_UnityEngine_SliderJoint2D_get_useMotorv, __ZN18ProfilerConnection41HandleQueryInstrumentableFunctionsMessageEPKvjj: __ZN18ProfilerConnection41HandleQueryInstrumentableFunctionsMessageEPKvjj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE15growAndPushBackERKS2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj652ENS_22PxRepXPropertyAccessorILj652ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj652ENS_22PxRepXPropertyAccessorILj652ES4_KffEEEEvRKT0_, __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetEnabledv: __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetEnabledv, __ZN7mecanim9animation4Clip8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation4Clip8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z48Register_UnityEngine_Canvas_set_sortingLayerNamev: __Z48Register_UnityEngine_Canvas_set_sortingLayerNamev, __ZN19SpriteMeshGenerator4mask6dilateEiR14dynamic_bitset: __ZN19SpriteMeshGenerator4mask6dilateEiR14dynamic_bitset, __ZN5physx2Sc19ParticlePacketShapeC2ERNS0_17ParticleSystemSimEjPNS_16PxvParticleShapeE: __ZN5physx2Sc19ParticlePacketShapeC2ERNS0_17ParticleSystemSimEjPNS_16PxvParticleShapeE, __Z46EmitSerializationCommandsForManagedObjectFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN18PlatformEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18PlatformEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN22DeviceMVPMatricesStateC2ER9GfxDevice: __ZN22DeviceMVPMatricesStateC2ER9GfxDevice, __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE: __ZN5physx14NpShapeManager11attachShapeERNS_7NpShapeERNS_12PxRigidActorE, __ZN5physx9NpPhysics18createTriangleMeshERNS_13PxInputStreamE: __ZN5physx9NpPhysics18createTriangleMeshERNS_13PxInputStreamE, __ZN6Object16StaticInitializeEv: __ZN6Object16StaticInitializeEv, __ZN15AudioReverbZone15SetReverbPresetEi: __ZN15AudioReverbZone15SetReverbPresetEi, __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE: __Z27GetFloatArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__set_long_pointerEPc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__set_long_pointerEPc, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEED0Ev, __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK8VRDevice10ShouldQuitEv: __ZNK8VRDevice10ShouldQuitEv, __ZN2UI11CanvasGroup15ThreadedCleanupEv: __ZN2UI11CanvasGroup15ThreadedCleanupEv, __ZN5physx41postProcessFrictionConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj: __ZN5physx41postProcessFrictionConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj, __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN14DetailDatabase8SetDirtyEv: __ZN14DetailDatabase8SetDirtyEv, __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRN15Cast2DQueryBase14FixtureContactEPS2_EEjT0_S5_S5_S5_T_, __ZNK11AssetBundle14GetPreloadDataEiR13dynamic_arrayIiLj4EE: __ZNK11AssetBundle14GetPreloadDataEiR13dynamic_arrayIiLj4EE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags, __Z43Register_UnityEngine_AndroidJNI_GetIntFieldv: __Z43Register_UnityEngine_AndroidJNI_GetIntFieldv, __Z57Register_UnityEngine_ParticleSystemRenderer_get_alignmentv: __Z57Register_UnityEngine_ParticleSystemRenderer_get_alignmentv, __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn14NameStackEntryENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN15LODGroupManager11AddLODGroupER8LODGroupRK8Vector3ff: __ZN15LODGroupManager11AddLODGroupER8LODGroupRK8Vector3ff, __ZN11UnityEngine15PlatformWrapper20GetRuntimePlatformIdEv: __ZN11UnityEngine15PlatformWrapper20GetRuntimePlatformIdEv, __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb: __ZL12ForcePreloadR11AssetBundleRKNS_9AssetInfoEb, __ZN5physx15NpParticleFluid25lockParticleFluidReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx15NpParticleFluid25lockParticleFluidReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __ZN16LightmapSettingsD2Ev: __ZN16LightmapSettingsD2Ev, __ZNK9Texture3D26CanReuploadDataToGfxDeviceEv: __ZNK9Texture3D26CanReuploadDataToGfxDeviceEv, __Z47Register_UnityEngine_AndroidJNI_SetBooleanFieldv: __Z47Register_UnityEngine_AndroidJNI_SetBooleanFieldv, __ZN17SurfaceEffector2D15ThreadedCleanupEv: __ZN17SurfaceEffector2D15ThreadedCleanupEv, _UNITY_png_get_current_row_number: _UNITY_png_get_current_row_number, __ZNK2UI13RectTransform23CalculateLocalPosition2Ev: __ZNK2UI13RectTransform23CalculateLocalPosition2Ev, __Z24RegisterStrippedTypeInfoI15TerrainColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI15TerrainColliderEviPKcS2_, __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_244kDidModifyMesh4CallEPviR11MessageData: __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_244kDidModifyMesh4CallEPviR11MessageData, __ZN5physx27PxHeightFieldRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx27PxHeightFieldRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z17PrepareSceneNodesP11CullResults: __Z17PrepareSceneNodesP11CullResults, __ZN5Unity17ConfigurableJoint16SetAngularYLimitERK14SoftJointLimit: __ZN5Unity17ConfigurableJoint16SetAngularYLimitERK14SoftJointLimit, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4failEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4failEv, __ZNK5physx7NpCloth14getNbParticlesEv: __ZNK5physx7NpCloth14getNbParticlesEv, __ZN18PlayableController7DestroyEv: __ZN18PlayableController7DestroyEv, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZMultiplierv, __Z36SpringJoint_Set_Custom_PropToleranceP12Il2CppObjectf: __Z36SpringJoint_Set_Custom_PropToleranceP12Il2CppObjectf, __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadHandlerv: __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadHandlerv, __Z24SetupActiveLightsContextR21ActiveLightingContextRK12ActiveLightsRK11CullResultsP14ShadowMapCacheRK10MinMaxAABB: __Z24SetupActiveLightsContextR21ActiveLightingContextRK12ActiveLightsRK11CullResultsP14ShadowMapCacheRK10MinMaxAABB, __ZNK5Umbra13TomeUserIdMap8getIndexEj: __ZNK5Umbra13TomeUserIdMap8getIndexEj, __ZThn80_NK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv: __ZThn80_NK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv, __Z38Sprite_CUSTOM_INTERNAL_get_textureRectP12Il2CppObjectP5RectTIfE: __Z38Sprite_CUSTOM_INTERNAL_get_textureRectP12Il2CppObjectP5RectTIfE, __ZN15PointEffector2D21ContactUpdateCallbackEf: __ZN15PointEffector2D21ContactUpdateCallbackEf, __Z19getPxShape_GeometryPKN5physx7PxShapeE: __Z19getPxShape_GeometryPKN5physx7PxShapeE, __ZN2UI13CanvasManager14RenderOverlaysEi: __ZN2UI13CanvasManager14RenderOverlaysEi, __ZN6Camera8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN6Camera8TransferI24GenerateTypeTreeTransferEEvRT_, _globfree: _globfree, __ZN13SliderJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN13SliderJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdateRendererNotifyInvisiblestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN40EarlyUpdateRendererNotifyInvisiblestruct7ForwardEv, __ZN7mecanim9animation15EvaluateAvatarXEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE: __ZN7mecanim9animation15EvaluateAvatarXEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE, __ZN24RingBufferMemoryFileData16ConsumeReadBytesEy: __ZN24RingBufferMemoryFileData16ConsumeReadBytesEy, __ZN5physx21SapPostUpdateWorkTaskD0Ev: __ZN5physx21SapPostUpdateWorkTaskD0Ev, __Z41Animator_Set_Custom_PropRecorderStartTimeP12Il2CppObjectf: __Z41Animator_Set_Custom_PropRecorderStartTimeP12Il2CppObjectf, __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE: __ZN5physx7NpActor18releaseConstraintsERNS_12PxRigidActorE, __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN21DownloadHandlerScript18GetBufferForScriptERP11Il2CppArrayRPhRj: __ZN21DownloadHandlerScript18GetBufferForScriptERP11Il2CppArrayRPhRj, __Z58Register_UnityEngine_ParticleSystem_TriggerModule_GetEnterv: __Z58Register_UnityEngine_ParticleSystem_TriggerModule_GetEnterv, __ZN4FMOD7Channel18getInputChannelMixEPfi: __ZN4FMOD7Channel18getInputChannelMixEPfi, __Z11GetPositioni: __Z11GetPositioni, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getMaxMotionDistanceEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getMaxMotionDistanceEv, _start_pass_coef: _start_pass_coef, __ZNK16BaseVideoTexture26GetTypeInfoVirtualInternalEv: __ZNK16BaseVideoTexture26GetTypeInfoVirtualInternalEv, __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei: __ZN19RenderBufferManager13GetTempBufferEii17DepthBufferFormat19RenderTextureFormatj22RenderTextureReadWrite14VRTextureUsagei, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags, __ZNK5physx14NpRigidDynamic25getContactReportThresholdEv: __ZNK5physx14NpRigidDynamic25getContactReportThresholdEv, __Z20GetUserAppDataFolderv: __Z20GetUserAppDataFolderv, __Z47Register_UnityEngine_Camera_get_allCamerasCountv: __Z47Register_UnityEngine_Camera_get_allCamerasCountv, __Z56Register_UnityEngine_RenderTexture_set_enableRandomWritev: __Z56Register_UnityEngine_RenderTexture_set_enableRandomWritev, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEv: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEv, __ZL29RegisterModuleICalls_Vehiclesv: __ZL29RegisterModuleICalls_Vehiclesv, __ZN14b2CapsuleShapeD2Ev: __ZN14b2CapsuleShapeD2Ev, __Z37Register_UnityEngine_Light_set_cookiev: __Z37Register_UnityEngine_Light_set_cookiev, __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8LODGroup11LODFadeModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8LODGroup11LODFadeModeEEvRT_RT0_PKc17TransferMetaFlags, __Z50Register_UnityEngine_AreaEffector2D_set_forceAnglev: __Z50Register_UnityEngine_AreaEffector2D_set_forceAnglev, __ZN8VRDevice12GetAdapterIdEv: __ZN8VRDevice12GetAdapterIdEv, __Z29StdTemplateConversionFunctionIsiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsiEbPvR14SafeBinaryRead, __Z22updateIslandsToProcessRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjRKNS_11NodeManagerERS4_: __Z22updateIslandsToProcessRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjRKNS_11NodeManagerERS4_, __Z48Register_UnityEngine_Rigidbody2D_set_useAutoMassv: __Z48Register_UnityEngine_Rigidbody2D_set_useAutoMassv, __Z56Register_UnityEngine_TrailRenderer_INTERNAL_get_endColorv: __Z56Register_UnityEngine_TrailRenderer_INTERNAL_get_endColorv, __ZN12InputManager13InputEndFrameEv: __ZN12InputManager13InputEndFrameEv, __Z56Register_UnityEngine_RenderSettings_get_ambientIntensityv: __Z56Register_UnityEngine_RenderSettings_get_ambientIntensityv, __Z39CommandBuffer_CUSTOM_ReleaseTemporaryRTP12Il2CppObjecti: __Z39CommandBuffer_CUSTOM_ReleaseTemporaryRTP12Il2CppObjecti, __ZN16MessageForwarderC2Ev: __ZN16MessageForwarderC2Ev, __ZNK5physx18PxVehicleGraphDesc7isValidEv: __ZNK5physx18PxVehicleGraphDesc7isValidEv, __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES17RenderSurfaceType16TextureDimension9TextureIDjN2gl9TexFormatEjRK17RenderSurfaceDesc: __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES17RenderSurfaceType16TextureDimension9TextureIDjN2gl9TexFormatEjRK17RenderSurfaceDesc, __ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f: __ZN8Collider30GetRelativePositionAndRotationERK9TransformR10Matrix4x4f, __ZN13GfxDeviceNull14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns: __ZN13GfxDeviceNull14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns, __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj: __ZN5physx3Ext5joint16ConstraintHelper17prepareLockedAxesERKNS_6PxQuatES5_RKNS_6PxVec3Ejj, __ZN5physx3Cct13BoxControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE: __ZN5physx3Cct13BoxControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEED0Ev: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEED0Ev, ___munmap: ___munmap, __ZN12GUIClipState7ReapplyER10InputEvent: __ZN12GUIClipState7ReapplyER10InputEvent, __Z34NavMeshAgent_Get_Custom_PropRadiusP12Il2CppObject: __Z34NavMeshAgent_Get_Custom_PropRadiusP12Il2CppObject, __Z50Register_UnityEngine_SystemInfo_get_maxTextureSizev: __Z50Register_UnityEngine_SystemInfo_get_maxTextureSizev, __ZN22RenderingCommandBuffer24PostExecuteCommandBufferER17ShaderPassContextP13RenderTexture: __ZN22RenderingCommandBuffer24PostExecuteCommandBufferER17ShaderPassContextP13RenderTexture, __Z31CalculateImageSizeForTypicalGPUii13TextureFormat: __Z31CalculateImageSizeForTypicalGPUii13TextureFormat, __ZN8Animator13SetUpdateModeENS_10UpdateModeE: __ZN8Animator13SetUpdateModeENS_10UpdateModeE, __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE: __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE, __ZN4FMOD5Sound11getDefaultsEPfS1_S1_Pi: __ZN4FMOD5Sound11getDefaultsEPfS1_S1_Pi, __ZN5physx2Sq8AABBTreeD2Ev: __ZN5physx2Sq8AABBTreeD2Ev, __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace: __ZN7Texture33SetStoredColorSpaceNoDirtyNoApplyE17TextureColorSpace, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERl: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERl, __ZN12FileAccessorD2Ev: __ZN12FileAccessorD2Ev, __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14VertexDataInfoC2Ev: __ZN14VertexDataInfoC2Ev, __ZN15PointEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE: __ZN15PointEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE, __Z33Light_CUSTOM_RemoveCommandBuffersP12Il2CppObject20RenderLightEventType: __Z33Light_CUSTOM_RemoveCommandBuffersP12Il2CppObject20RenderLightEventType, __Z103Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorTransitionInfoInternalv: __Z103Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorTransitionInfoInternalv, __ZNK21DownloadHandlerScript8GetBytesEv: __ZNK21DownloadHandlerScript8GetBytesEv, __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZNSt3__227__insertion_sort_incompleteIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEbT0_S5_T_, __ZN19AssetBundleManifest8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19AssetBundleManifest8TransferI24GenerateTypeTreeTransferEEvRT_, __Z30Physics_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h: __Z30Physics_CUSTOM_IgnoreCollisionP12Il2CppObjectS0_h, __Z42NavMeshAgent_Get_Custom_PropUpdatePositionP12Il2CppObject: __Z42NavMeshAgent_Get_Custom_PropUpdatePositionP12Il2CppObject, __Z26scripting_profiler_installPvPFvS_E: __Z26scripting_profiler_installPvPFvS_E, __Z58Register_UnityEngine_Application_GetStreamProgressForLevelv: __Z58Register_UnityEngine_Application_GetStreamProgressForLevelv, __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv: __ZNK13Simd4fFactoryIN6detail14AlignedPointerIfEEEcv8Scalar4fEv, __Z49Register_UnityEngine_Cloth_set_worldVelocityScalev: __Z49Register_UnityEngine_Cloth_set_worldVelocityScalev, __ZN9shadertag10InitializeEv: __ZN9shadertag10InitializeEv, __ZN5physx24NpPtrTableStorageManager8canReuseEjj: __ZN5physx24NpPtrTableStorageManager8canReuseEjj, __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetRotationv: __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetRotationv, __ZN15QualitySettings14QualitySetting8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15QualitySettings14QualitySetting8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE: __ZN5physx2Sc27ConstraintProjectionManager33processConstraintForGroupBuildingEPNS0_13ConstraintSimERNS0_20ScratchAllocatorListIS3_Lj64EEE, __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj: __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE15growAndPushBackERKj, __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI17RemapPPtrTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __ZN13SparseTexture15ThreadedCleanupEv: __ZN13SparseTexture15ThreadedCleanupEv, __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetMultiplierv: __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetMultiplierv, _do_read_526: _do_read_526, __Z44Register_UnityEngine_Object_DestroyImmediatev: __Z44Register_UnityEngine_Object_DestroyImmediatev, __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager25setArticulationLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_, __Z36NavMeshObstacle_Get_Custom_PropShapeP12Il2CppObject: __Z36NavMeshObstacle_Get_Custom_PropShapeP12Il2CppObject, __ZN22BlockMemoryCacheWriter14LockCacheBlockEjPPhS1_: __ZN22BlockMemoryCacheWriter14LockCacheBlockEjPPhS1_, __ZNSt3__218__insertion_sort_3IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_: __ZNSt3__218__insertion_sort_3IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8capacityEv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED2Ev: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED2Ev, __ZNKSt3__215__codecvt_utf16IDsLb1EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IDsLb1EE16do_always_noconvEv, __ZNK5Umbra10PortalInfo13getHullVertexEiRNS_7Vector3E: __ZNK5Umbra10PortalInfo13getHullVertexEiRNS_7Vector3E, __ZN5physx2Cm29ConstraintImmediateVisualizer19visualizeDoubleConeERKNS_11PxTransformEfb: __ZN5physx2Cm29ConstraintImmediateVisualizer19visualizeDoubleConeERKNS_11PxTransformEfb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx20ProcessBPResultsTask11runInternalEv: __ZN5physx20ProcessBPResultsTask11runInternalEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZN21BillboardBatchManager24BillboardBatchFreeMemJobEP25DynamicVBOGeometryJobData: __ZN21BillboardBatchManager24BillboardBatchFreeMemJobEP25DynamicVBOGeometryJobData, __Z43UnityConnectSettings_Get_Custom_PropEnabledv: __Z43UnityConnectSettings_Get_Custom_PropEnabledv, __Z13RegisterClassI10GameObjectEvv: __Z13RegisterClassI10GameObjectEvv, __ZN4FMOD13ChannelGroupI10getDSPHeadEPPNS_3DSPE: __ZN4FMOD13ChannelGroupI10getDSPHeadEPPNS_3DSPE, __Z57Register_UnityEngine_TerrainData_RecalculateTreePositionsv: __Z57Register_UnityEngine_TerrainData_RecalculateTreePositionsv, __ZN5Unity17ConfigurableJointD2Ev: __ZN5Unity17ConfigurableJointD2Ev, __ZL32AddMappedPPtrCurveToStreamedClipP19StreamedClipBuilderiRN11UnityEngine9Animation28AnimationClipBindingConstantERK13dynamic_arrayI12PPtrKeyframeLj4EE: __ZL32AddMappedPPtrCurveToStreamedClipP19StreamedClipBuilderiRN11UnityEngine9Animation28AnimationClipBindingConstantERK13dynamic_arrayI12PPtrKeyframeLj4EE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj648ENS_22PxRepXPropertyAccessorILj648ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj648ENS_22PxRepXPropertyAccessorILj648ES4_jjEEEEvjRKT0_, __Z36Terrain_Set_Custom_PropDrawHeightmapP12Il2CppObjecth: __Z36Terrain_Set_Custom_PropDrawHeightmapP12Il2CppObjecth, __ZN5physx7NpScene19getActiveTransformsERjh: __ZN5physx7NpScene19getActiveTransformsERjh, __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN4FMOD6SoundIC2EPNS_7SystemIE: __ZN4FMOD6SoundIC2EPNS_7SystemIE, __ZN7mecanim12statemachine13EvaluateStateERKNS_18ValueArrayConstantERKNS0_13StateConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_11StateOutputERNS0_14StateWorkspaceEbb: __ZN7mecanim12statemachine13EvaluateStateERKNS_18ValueArrayConstantERKNS0_13StateConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_11StateOutputERNS0_14StateWorkspaceEbb, __ZN8Animator15GetBodyPositionEv: __ZN8Animator15GetBodyPositionEv, _UNITY_png_set_palette_to_rgb: _UNITY_png_set_palette_to_rgb, __ZN16ReflectionProbes27IsRealtimeReflectionEnabledEv: __ZN16ReflectionProbes27IsRealtimeReflectionEnabledEv, __ZN9GfxDevice14EndBufferWriteEP9GfxBufferj: __ZN9GfxDevice14EndBufferWriteEP9GfxBufferj, __ZN14GfxContextGLES8InstanceC2EN2gl13ContextHandleER7ApiGLES: __ZN14GfxContextGLES8InstanceC2EN2gl13ContextHandleER7ApiGLES, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE12readPropertyIfEEbRT_, __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E: __ZN5Umbra12QueryContext14findNodeInTileEPKNS_7ImpTileERKNS_7Vector3E, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERi: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERi, __Z56Register_UnityEngine_TrailRenderer_get_numCornerVerticesv: __Z56Register_UnityEngine_TrailRenderer_get_numCornerVerticesv, _UNITY_FT_Attach_File: _UNITY_FT_Attach_File, __Z48Register_UnityEngine_Physics_get_bounceThresholdv: __Z48Register_UnityEngine_Physics_get_bounceThresholdv, __Z45Register_UnityEngine_Camera_set_renderingPathv: __Z45Register_UnityEngine_Camera_set_renderingPathv, __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRangev: __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRangev, __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj, __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv: __ZNK5physx2Sc16InteractionScene18getLLIslandManagerEv, __Z18getPxSpringDampingPKN5physx8PxSpringE: __Z18getPxSpringDampingPKN5physx8PxSpringE, __ZN8Material8TransferI14SafeBinaryReadEEvRT_: __ZN8Material8TransferI14SafeBinaryReadEEvRT_, __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj: __ZN5physx17PxcNpMemBlockPool34acquireExceptionalConstraintMemoryEj, __ZN12CubemapArray17UploadToGfxDeviceEv: __ZN12CubemapArray17UploadToGfxDeviceEv, __ZN18BackgroundJobQueueD2Ev: __ZN18BackgroundJobQueueD2Ev, __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshShapeTypev: __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshShapeTypev, __Z32Joint_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP8Vector3f: __Z32Joint_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP8Vector3f, __Z35Cloth_Set_Custom_PropSleepThresholdP12Il2CppObjectf: __Z35Cloth_Set_Custom_PropSleepThresholdP12Il2CppObjectf, __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z49UnityConnectSettings_Get_Custom_PropTestConfigUrlv: __Z49UnityConnectSettings_Get_Custom_PropTestConfigUrlv, __ZNK5physx7NpShape16getPlaneGeometryERNS_15PxPlaneGeometryE: __ZNK5physx7NpShape16getPlaneGeometryERNS_15PxPlaneGeometryE, __ZN11TerrainData24NotifyUsersOnTreeUpdatedEi: __ZN11TerrainData24NotifyUsersOnTreeUpdatedEi, __ZN5physx27InternalTriangleMeshBuilder14fillRemapTableEv: __ZN5physx27InternalTriangleMeshBuilder14fillRemapTableEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN13UnityProfiler24InitializeMemoryProfilerEv: __ZN13UnityProfiler24InitializeMemoryProfilerEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags, __Z33Gradient_Get_Custom_PropColorKeysP12Il2CppObject: __Z33Gradient_Get_Custom_PropColorKeysP12Il2CppObject, _UNITY_png_set_chunk_malloc_max: _UNITY_png_set_chunk_malloc_max, __ZNSt3__218__insertion_sort_3IR11EventSorterP14AnimationEventEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IR11EventSorterP14AnimationEventEEvT0_S5_T_, __Z25GetSplashScreenBackgroundRK5RectTIfE: __Z25GetSplashScreenBackgroundRK5RectTIfE, __ZN18GlslGpuProgramGLESD2Ev: __ZN18GlslGpuProgramGLESD2Ev, __ZN13RenderTexture14SetVolumeDepthEi: __ZN13RenderTexture14SetVolumeDepthEi, __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE: __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv, __ZThn116_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv: __ZThn116_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv, __ZN5physx2Gu20pcmContactCapsuleBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu20pcmContactCapsuleBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN25ScriptingVertexDataLayoutC2Ev: __ZN25ScriptingVertexDataLayoutC2Ev, __ZN10Matrix4x4f8TransferI8JSONReadEEvRT_: __ZN10Matrix4x4f8TransferI8JSONReadEEvRT_, __Z48Register_UnityEngine_SpringJoint_get_minDistancev: __Z48Register_UnityEngine_SpringJoint_get_minDistancev, __ZN5physx3Ext14PrismaticJoint21setPrismaticJointFlagENS_20PxPrismaticJointFlag4EnumEb: __ZN5physx3Ext14PrismaticJoint21setPrismaticJointFlagENS_20PxPrismaticJointFlag4EnumEb, __ZN22GenericPropertyBinding8RegisterEPKc11ClassIDTypePFfPvEPFvS3_fE: __ZN22GenericPropertyBinding8RegisterEPKc11ClassIDTypePFfPvEPFvS3_fE, __ZN14dense_hash_mapIPKcPK4RTTIN11TypeManager23ConstCharPtrHashFunctorENS5_19ConstCharPtrEqualToE13stl_allocatorINSt3__24pairIKS1_S4_EEL18MemLabelIdentifier6ELi16EEE5beginEv: __ZN14dense_hash_mapIPKcPK4RTTIN11TypeManager23ConstCharPtrHashFunctorENS5_19ConstCharPtrEqualToE13stl_allocatorINSt3__24pairIKS1_S4_EEL18MemLabelIdentifier6ELi16EEE5beginEv, __ZN15QualitySettings22ApplyExpensiveSettingsEv: __ZN15QualitySettings22ApplyExpensiveSettingsEv, _jsimd_h2v2_fancy_upsample: _jsimd_h2v2_fancy_upsample, __Z55Register_UnityEngine_AI_NavMeshAgent_set_updateRotationv: __Z55Register_UnityEngine_AI_NavMeshAgent_set_updateRotationv, __ZN17PersistentManager18ReadObjectThreadedEi: __ZN17PersistentManager18ReadObjectThreadedEi, __ZNK5Umbra10PortalInfo15getNumTrianglesEv: __ZNK5Umbra10PortalInfo15getNumTrianglesEv, __ZN25TransformFeedbackSkinning31CleanupTransformFeedbackShadersEv: __ZN25TransformFeedbackSkinning31CleanupTransformFeedbackShadersEv, __ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj: __ZNK20TextRenderingPrivate8FontImpl19GetCharacterAdvanceEjijfPj, __ZN19SkinnedMeshRenderer11GetAnimatorEv: __ZN19SkinnedMeshRenderer11GetAnimatorEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z32Gizmos_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf: __Z32Gizmos_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf, __ZN14TimerQueryGLES10GetElapsedEj: __ZN14TimerQueryGLES10GetElapsedEj, __Z16CalculateNormals14StrideIteratorI8Vector3fEPKjiiS1_: __Z16CalculateNormals14StrideIteratorI8Vector3fEPKjiiS1_, __ZN12_GLOBAL__N_19MyFastXml12processCloseEcPKcPciPS2_PN5physx6shdfnd7FastXml8CallbackERb: __ZN12_GLOBAL__N_19MyFastXml12processCloseEcPKcPciPS2_PN5physx6shdfnd7FastXml8CallbackERb, __ZN10VertexData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10VertexData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj: __ZN5physx2Sc5Scene9addStaticERNS0_10StaticCoreEPKPvjj, __Z39DeleteLastPathNameComponentWithAnySlashRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z39DeleteLastPathNameComponentWithAnySlashRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN15ReflectionProbe29GetTimeSlicedJobCountPerProbeEv: __ZN15ReflectionProbe29GetTimeSlicedJobCountPerProbeEv, __Z33setPxArticulationJoint_TwistLimitPN5physx19PxArticulationJointEff: __Z33setPxArticulationJoint_TwistLimitPN5physx19PxArticulationJointEff, __ZN6Avatar8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN6Avatar8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD0Ev: __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD0Ev, __ZN14PreloadManager16UpdatePreloadingEv: __ZN14PreloadManager16UpdatePreloadingEv, __ZN12BaseRendererD2Ev: __ZN12BaseRendererD2Ev, __ZN11NoiseModule8TransferI14SafeBinaryReadEEvRT_: __ZN11NoiseModule8TransferI14SafeBinaryReadEEvRT_, __Z46CharacterJoint_Get_Custom_PropEnableProjectionP12Il2CppObject: __Z46CharacterJoint_Get_Custom_PropEnableProjectionP12Il2CppObject, __Z50NavMeshAgent_CUSTOM_GetNextOffMeshLinkDataInternalP12Il2CppObject: __Z50NavMeshAgent_CUSTOM_GetNextOffMeshLinkDataInternalP12Il2CppObject, __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyERPNS0_8ShapeSimEPNS_9PxBounds3E: __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyERPNS0_8ShapeSimEPNS_9PxBounds3E, __Z46Quaternion_CUSTOM_INTERNAL_CALL_FromToRotationRK8Vector3fS1_R11Quaternionf: __Z46Quaternion_CUSTOM_INTERNAL_CALL_FromToRotationRK8Vector3fS1_R11Quaternionf, __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE11getTypeNameEv, __ZN5physx20updateCollDataStaticERNS_19PxsParticleCollDataERKNS_11PxTransformEf: __ZN5physx20updateCollDataStaticERNS_19PxsParticleCollDataERKNS_11PxTransformEf, __Z50Register_UnityEngine_RenderTexture_set_volumeDepthv: __Z50Register_UnityEngine_RenderTexture_set_volumeDepthv, __ZN5physx23PxcPCMContactConvexMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx23PxcPCMContactConvexMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN15AudioMixerGroup8TransferI14SafeBinaryReadEEvRT_: __ZN15AudioMixerGroup8TransferI14SafeBinaryReadEEvRT_, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE8ContainsEPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE8ContainsEPKv, __Z28Texture3D_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayi: __Z28Texture3D_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayi, __ZN12AdsIdHandler15FetchAsyncAdsIdEv: __ZN12AdsIdHandler15FetchAsyncAdsIdEv, _UNITY_FT_Init_FreeType: _UNITY_FT_Init_FreeType, __ZN19SkinnedMeshRenderer22GetBonesPerVertexCountEv: __ZN19SkinnedMeshRenderer22GetBonesPerVertexCountEv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15QualitySettings14QualitySettingENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN5physx27PxArticulationGeneratedInfoC2Ev: __ZN5physx27PxArticulationGeneratedInfoC2Ev, __Z22getPxPhysics_MaterialsPKN5physx9PxPhysicsEPPNS_10PxMaterialEj: __Z22getPxPhysics_MaterialsPKN5physx9PxPhysicsEPPNS_10PxMaterialEj, __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE8__appendEj, __ZN21ProceduralTextureData23SetSubstanceShuffledUIDEj: __ZN21ProceduralTextureData23SetSubstanceShuffledUIDEj, __Z42AnimationCurve_Set_Custom_PropPostWrapModeP12Il2CppObjecti: __Z42AnimationCurve_Set_Custom_PropPostWrapModeP12Il2CppObjecti, __Z53GIDebugVisualisation_CUSTOM_ResetRuntimeInputTexturesv: __Z53GIDebugVisualisation_CUSTOM_ResetRuntimeInputTexturesv, __Z35GetMinimumTextureMipHeightForFormat13TextureFormat: __Z35GetMinimumTextureMipHeightForFormat13TextureFormat, __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6resizeEj: __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6resizeEj, __ZNSt3__26vectorI25VirtualJoystickPropertiesNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI25VirtualJoystickPropertiesNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E: __ZNK15PolynomialCurve18EvaluateIntegratedERKN4math7_float4E, __ZN15TerrainRenderer7GetNodeEiii: __ZN15TerrainRenderer7GetNodeEiii, __Z48Application_Get_Custom_PropGenuineCheckAvailablev: __Z48Application_Get_Custom_PropGenuineCheckAvailablev, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv, __ZN7Terrain33ApplyDelayedHeightmapModificationEv: __ZN7Terrain33ApplyDelayedHeightmapModificationEv, __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev: __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev, __Z15ClearWithSkyboxbPK6Camera: __Z15ClearWithSkyboxbPK6Camera, __ZN15TerrainCollider6CreateEPK9Rigidbody: __ZN15TerrainCollider6CreateEPK9Rigidbody, __ZN4Halo23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN4Halo23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z40SystemInfo_Get_Custom_PropProcessorCountv: __Z40SystemInfo_Get_Custom_PropProcessorCountv, __ZN12_GLOBAL__N_117ConnectionManager13removeHandlerERN5physx8debugger4comm20PvdConnectionHandlerE: __ZN12_GLOBAL__N_117ConnectionManager13removeHandlerERN5physx8debugger4comm20PvdConnectionHandlerE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE8pushNameEPKc, __ZN22UnityProfilerPerThreadC2EPKcS1_: __ZN22UnityProfilerPerThreadC2EPKcS1_, __Z79Register_UnityEngine_Experimental_Director_Playables_EndIgnoreAllocationTrackerv: __Z79Register_UnityEngine_Experimental_Director_Playables_EndIgnoreAllocationTrackerv, __ZN5Unity5Cloth21SetWorldVelocityScaleEf: __ZN5Unity5Cloth21SetWorldVelocityScaleEf, __ZNK18ProceduralMaterial22GetSubstancePropertiesEv: __ZNK18ProceduralMaterial22GetSubstancePropertiesEv, __ZN18DeferredRenderLoopD2Ev: __ZN18DeferredRenderLoopD2Ev, __ZN9Scripting32GetScriptingArrayObjectStartImplEP11Il2CppArray: __ZN9Scripting32GetScriptingArrayObjectStartImplEP11Il2CppArray, __ZNK16TypeTreeIterator4NameEv: __ZNK16TypeTreeIterator4NameEv, __ZN4FMOD7Channel11get3DSpreadEPf: __ZN4FMOD7Channel11get3DSpreadEPf, __ZN15FileSystemEntry3SetEPKc: __ZN15FileSystemEntry3SetEPKc, __ZN5physx5cloth13MovingAverage4pushEjf: __ZN5physx5cloth13MovingAverage4pushEjf, __ZN8JSONRead14GetValueForKeyEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc: __ZN8JSONRead14GetValueForKeyEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc, __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN4FMOD3DSP8addInputEPS0_PPNS_13DSPConnectionE: __ZN4FMOD3DSP8addInputEPS0_PPNS_13DSPConnectionE, __Z52Register_UnityEngine_Application_set_targetFrameRatev: __Z52Register_UnityEngine_Application_set_targetFrameRatev, __ZN5physx14NpRigidDynamic8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx14NpRigidDynamic8requiresERNS_23PxProcessPxBaseCallbackE, __Z21Animation_CUSTOM_PlayP12Il2CppObjectP12Il2CppStringi: __Z21Animation_CUSTOM_PlayP12Il2CppObjectP12Il2CppStringi, _LzmaDec_AllocateProbs: _LzmaDec_AllocateProbs, __ZN5Unity5Cloth23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity5Cloth23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE: __ZN20SoundChannelInstance15ParameterBuffer5ApplyEPN4FMOD7ChannelE, _jinit_c_main_controller: _jinit_c_main_controller, __Z29getPxSceneDescSimulationOrderPKN5physx11PxSceneDescE: __Z29getPxSceneDescSimulationOrderPKN5physx11PxSceneDescE, __ZN23SharedMeshRenderingDataD0Ev: __ZN23SharedMeshRenderingDataD0Ev, __Z36setPxJointLimitParametersRestitutionPN5physx22PxJointLimitParametersEf: __Z36setPxJointLimitParametersRestitutionPN5physx22PxJointLimitParametersEf, __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev: __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev, __ZN20TextRenderingPrivate19NativeTextGenerator9InsertTabEv: __ZN20TextRenderingPrivate19NativeTextGenerator9InsertTabEv, _FT_Init_Class_tt_service_properties: _FT_Init_Class_tt_service_properties, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags, __ZN5physx10printShapeEPNS_12PxsRigidBodyENS_14PxGeometryType4EnumEPKcfjb: __ZN5physx10printShapeEPNS_12PxsRigidBodyENS_14PxGeometryType4EnumEPKcfjb, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4syncEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4syncEv, __ZN11UnityEngine15PlatformWrapper24GetRuntimePlatformStringEv: __ZN11UnityEngine15PlatformWrapper24GetRuntimePlatformStringEv, __ZN15CacheWriterBaseD2Ev: __ZN15CacheWriterBaseD2Ev, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMinKillSpeedv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMinKillSpeedv, __ZN5physx3Cct17CapsuleController15setFootPositionERKNS_14PxExtendedVec3E: __ZN5physx3Cct17CapsuleController15setFootPositionERKNS_14PxExtendedVec3E, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration13generateEEMTDERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj, _getlogin_r: _getlogin_r, __ZN18MultiQueryCallbackIN5physx10PxSweepHitEED0Ev: __ZN18MultiQueryCallbackIN5physx10PxSweepHitEED0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj678ENS_22PxRepXPropertyAccessorILj678ES4_NS_23PxVehicleDriveSimData4WES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj678ENS_22PxRepXPropertyAccessorILj678ES4_NS_23PxVehicleDriveSimData4WES9_EEEEvRKT0_, __ZN13SparseTexture8TransferI14SafeBinaryReadEEvRT_: __ZN13SparseTexture8TransferI14SafeBinaryReadEEvRT_, __ZN8UVModuleD0Ev: __ZN8UVModuleD0Ev, __Z61Register_UnityEngine_Networking_UploadHandler_InternalDestroyv: __Z61Register_UnityEngine_Networking_UploadHandler_InternalDestroyv, __ZNK15dtProximityGrid14getItemCountAtEii: __ZNK15dtProximityGrid14getItemCountAtEii, __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb1EEEEvRT_, __ZN24GenerateTypeTreeTransfer12TransferBaseI15TerrainColliderEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer12TransferBaseI15TerrainColliderEEvRT_17TransferMetaFlags, __Z65Register_UnityEngine_Rigidbody_INTERNAL_CALL_ClosestPointOnBoundsv: __Z65Register_UnityEngine_Rigidbody_INTERNAL_CALL_ClosestPointOnBoundsv, __ZN18JobBatchDispatcherD2Ev: __ZN18JobBatchDispatcherD2Ev, __ZN9Transform17MainThreadCleanupEv: __ZN9Transform17MainThreadCleanupEv, __Z41PhysicsMaterial2D_Set_Custom_PropFrictionP12Il2CppObjectf: __Z41PhysicsMaterial2D_Set_Custom_PropFrictionP12Il2CppObjectf, __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEED0Ev, __ZNK14ParticleSystem21GetCustomParticleDataEPN4math14float4_storageEii: __ZNK14ParticleSystem21GetCustomParticleDataEPN4math14float4_storageEii, _cff_fd_select_get: _cff_fd_select_get, __ZN19ShaderPropertySheet29PreallocateArrayUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEj: __ZN19ShaderPropertySheet29PreallocateArrayUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEj, __Z13RegisterClassI18AnimatorControllerEvv: __Z13RegisterClassI18AnimatorControllerEvv, __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_: __Z28CheckRenderBuffersFromScriptjPK21ScriptingRenderBufferS1_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED2Ev, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx2Sn25readStridedBufferPropertyINS_22PxClothCollisionSphereEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_22PxClothCollisionSphereEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __ZZ23InitPlayerLoopCallbacksvEN41EarlyUpdateUpdateAllUnityWebStreamsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN41EarlyUpdateUpdateAllUnityWebStreamsstruct7ForwardEv, __ZN5simdieqERK8Scalar4fS2_: __ZN5simdieqERK8Scalar4fS2_, __ZN5physx2Sc7BodySim10sleepCheckEffb: __ZN5physx2Sc7BodySim10sleepCheckEffb, __ZN13WheelCollider16RecreateColliderEPK9Rigidbody: __ZN13WheelCollider16RecreateColliderEPK9Rigidbody, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __Z21CountTrianglesInStripIjEiPKT_i: __Z21CountTrianglesInStripIjEiPKT_i, __ZN20QuadTreeNodeRenderer17SetLightmapParamsEtRK8Vector4f12LightmapType: __ZN20QuadTreeNodeRenderer17SetLightmapParamsEtRK8Vector4f12LightmapType, __ZN2UI6Canvas23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN2UI6Canvas23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__212ctype_bynameIwEC2EPKcj: __ZNSt3__212ctype_bynameIwEC2EPKcj, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN8VRDevice29ApplyExpensiveQualitySettingsEv: __ZN8VRDevice29ApplyExpensiveQualitySettingsEv, __ZN9Rigidbody16CheckConsistencyEv: __ZN9Rigidbody16CheckConsistencyEv, __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation6IsDoneEv: __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation6IsDoneEv, __ZN9GfxDevice21ReleaseSharedMeshDataEP14SharedMeshData: __ZN9GfxDevice21ReleaseSharedMeshDataEP14SharedMeshData, __ZN12TreeRenderer14RenderLODTreesER6Camerai: __ZN12TreeRenderer14RenderLODTreesER6Camerai, __Z46ParticleSystem_ShapeModule_CUSTOM_SetShapeTypeP12Il2CppObjecti: __Z46ParticleSystem_ShapeModule_CUSTOM_SetShapeTypeP12Il2CppObjecti, __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_: __ZNSt3__27__sort5IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_SC_T_, __Z44Register_UnityEngine_Shader_SetGlobalTexturev: __Z44Register_UnityEngine_Shader_SetGlobalTexturev, __ZN16SubstanceArchive23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16SubstanceArchive23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5Umbra10Visibility22setOutputContributionsEPf: __ZN5Umbra10Visibility22setOutputContributionsEPf, __ZN13ConstantForceD2Ev: __ZN13ConstantForceD2Ev, __ZZN8Animator15InitializeClassEvEN31FunctorImpl_389kDidDeleteMotion4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN31FunctorImpl_389kDidDeleteMotion4CallEPviR11MessageData, __ZN5physx2Gu10ConvexMesh15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Gu10ConvexMesh15importExtraDataERNS_24PxDeserializationContextE, __Z24Camera_CUSTOM_IsFilteredP12Il2CppObjectS0_: __Z24Camera_CUSTOM_IsFilteredP12Il2CppObjectS0_, __ZN17AudioChorusFilter12AddToManagerEv: __ZN17AudioChorusFilter12AddToManagerEv, __Z61Register_UnityEngine_ParticleSystem_TriggerModule_SetColliderv: __Z61Register_UnityEngine_ParticleSystem_TriggerModule_SetColliderv, __ZN19MeshParticleEmitter5ResetEv: __ZN19MeshParticleEmitter5ResetEv, __ZN20HardwareInfoReporter18ReportHardwareInfoEv: __ZN20HardwareInfoReporter18ReportHardwareInfoEv, __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMaxP12Il2CppObjectP13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMaxP12Il2CppObjectP13Vector2fIcall, __ZN9GfxDevice38ScheduleDynamicVBOGeometryJobsInternalEPFvP25DynamicVBOGeometryJobDatajEPFvS1_ES1_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle: __ZN9GfxDevice38ScheduleDynamicVBOGeometryJobsInternalEPFvP25DynamicVBOGeometryJobDatajEPFvS1_ES1_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle, __Z28Animator_CUSTOM_SetTriggerIDP12Il2CppObjecti: __Z28Animator_CUSTOM_SetTriggerIDP12Il2CppObjecti, __Z45Register_UnityEngine_Texture2DArray_SetPixelsv: __Z45Register_UnityEngine_Texture2DArray_SetPixelsv, __Z47MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray: __Z47MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE: __ZN8Material28UpdateHashesOnPropertyChangeEN9ShaderLab16FastPropertyNameE, __Z53Register_UnityEngine_SortingLayer_GetLayerValueFromIDv: __Z53Register_UnityEngine_SortingLayer_GetLayerValueFromIDv, __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionYv: __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionYv, __ZN14EdgeCollider2D14CreateInternalEP11Rigidbody2D: __ZN14EdgeCollider2D14CreateInternalEP11Rigidbody2D, __ZN9Animation5BlendER14AnimationStateff: __ZN9Animation5BlendER14AnimationStateff, __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN14ConstantStringaSEPKc: __ZN14ConstantStringaSEPKc, __Z29getPxArticulation_WakeCounterPKN5physx14PxArticulationE: __Z29getPxArticulation_WakeCounterPKN5physx14PxArticulationE, __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb: __Z27LoadMemoryBufferIntoTextureR9Texture2DPKhj20LoadImageCompressionb, __ZN8Animator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8Animator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN2UI11CanvasGroup8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN2UI11CanvasGroup8TransferI24GenerateTypeTreeTransferEEvRT_, __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv: __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv, __ZNK23ArchiveStorageConverter17IsHeaderProcessedEv: __ZNK23ArchiveStorageConverter17IsHeaderProcessedEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags, __Z6cross3RK8Scalar4fS1_: __Z6cross3RK8Scalar4fS1_, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __ZNK13OcclusionArea26GetTypeInfoVirtualInternalEv: __ZNK13OcclusionArea26GetTypeInfoVirtualInternalEv, __ZNK13GfxDeviceGLES26HasActiveRandomWriteTargetEv: __ZNK13GfxDeviceGLES26HasActiveRandomWriteTargetEv, __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE: __ZNK5physx2Sn5ConvX19_enumerateExtraDataEPKcPKNS0_9MetaClassEPNS0_14ExtraDataEntryERiiNS0_12MetaDataTypeE, __Z47BuoyancyEffector2D_Set_Custom_PropFlowVariationP12Il2CppObjectf: __Z47BuoyancyEffector2D_Set_Custom_PropFlowVariationP12Il2CppObjectf, __ZN13GfxDeviceNull15FinishRenderingEv: __ZN13GfxDeviceNull15FinishRenderingEv, __ZNK21AudioDistortionFilter26GetTypeInfoVirtualInternalEv: __ZNK21AudioDistortionFilter26GetTypeInfoVirtualInternalEv, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE7getNameEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE7getNameEv, __Z33GUIText_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z33GUIText_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __Z41PhysicsMaterial2D_Get_Custom_PropFrictionP12Il2CppObject: __Z41PhysicsMaterial2D_Get_Custom_PropFrictionP12Il2CppObject, __ZN14ComplementExprI8Scalar4fEC2ERKS0_: __ZN14ComplementExprI8Scalar4fEC2ERKS0_, __ZNK5physx3Cct10Controller16getInternalStateERNS_17PxControllerStateE: __ZNK5physx3Cct10Controller16getInternalStateERNS_17PxControllerStateE, __Z12profiler_endP19ProfilerInformation: __Z12profiler_endP19ProfilerInformation, __Z58Register_UnityEngine_Diagnostics_PlayerConnection_SendFilev: __Z58Register_UnityEngine_Diagnostics_PlayerConnection_SendFilev, __Z53ParticleSystemRenderer_Set_Custom_PropMinParticleSizeP12Il2CppObjectf: __Z53ParticleSystemRenderer_Set_Custom_PropMinParticleSizeP12Il2CppObjectf, __Z49ConstantForce2D_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP13Vector2fIcall: __Z49ConstantForce2D_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP13Vector2fIcall, __ZN4FMOD7SystemI13getDriverInfoEiPciP9FMOD_GUID: __ZN4FMOD7SystemI13getDriverInfoEiPciP9FMOD_GUID, __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_: __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_, __Z35getPxVehicleDriveSimData_EngineDataPKN5physx21PxVehicleDriveSimDataE: __Z35getPxVehicleDriveSimData_EngineDataPKN5physx21PxVehicleDriveSimDataE, __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewObjectArrayi13Il2Cpp_IntPtrS_RPv: __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_NewObjectArrayi13Il2Cpp_IntPtrS_RPv, __ZNK5physx2Sc9ClothCore24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE: __ZNK5physx2Sc9ClothCore24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE, __ZN17GeneralConnectionD2Ev: __ZN17GeneralConnectionD2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx10PxsContext15setScratchBlockEPvj: __ZN5physx10PxsContext15setScratchBlockEPvj, __Z52Register_UnityEngine_RectOffset_INTERNAL_CALL_Removev: __Z52Register_UnityEngine_RectOffset_INTERNAL_CALL_Removev, __Z39getPxArticulation_SolverIterationCountsPKN5physx14PxArticulationERjS3_: __Z39getPxArticulation_SolverIterationCountsPKN5physx14PxArticulationERjS3_, __ZN5physx2Cm10CollectionD2Ev: __ZN5physx2Cm10CollectionD2Ev, __Z24RegisterStrippedTypeInfoI15ResourceManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI15ResourceManagerEviPKcS2_, __ZN12_GLOBAL__N_110DataStream15removeObjectRefEPKvPKcS2_: __ZN12_GLOBAL__N_110DataStream15removeObjectRefEPKvPKcS2_, __ZN4PPtrI6SpriteE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI6SpriteE8TransferI14SafeBinaryReadEEvRT_, __ZNK14DLHAudioHelper11GetCapacityEv: __ZNK14DLHAudioHelper11GetCapacityEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale1Ev, __ZN5physx33PxVehicleDriveTankGeneratedValuesC2EPKNS_18PxVehicleDriveTankE: __ZN5physx33PxVehicleDriveTankGeneratedValuesC2EPKNS_18PxVehicleDriveTankE, __ZN5physx2Cm27getDynamicGlobalPoseAlignedERKNS_11PxTransformES3_S3_RS1_: __ZN5physx2Cm27getDynamicGlobalPoseAlignedERKNS_11PxTransformES3_S3_RS1_, __Z37Texture2D_Get_Custom_PropBlackTexturev: __Z37Texture2D_Get_Custom_PropBlackTexturev, __ZN15NavMeshSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN15NavMeshSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Sn25readStridedBufferPropertyINS_18PxClothFabricPhaseEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_18PxClothFabricPhaseEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE8__appendEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE15growAndPushBackERKS2_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale1Ef, __ZNK13MonoBehaviour33IsPersistentStateMachineBehaviourEv: __ZNK13MonoBehaviour33IsPersistentStateMachineBehaviourEv, __Z46Register_UnityEngine_Input_get_isGyroAvailablev: __Z46Register_UnityEngine_Input_get_isGyroAvailablev, __Z64RenderBufferHelper_CUSTOM_INTERNAL_CALL_GetNativeRenderBufferPtr13Il2Cpp_IntPtrRPv: __Z64RenderBufferHelper_CUSTOM_INTERNAL_CALL_GetNativeRenderBufferPtr13Il2Cpp_IntPtrRPv, __Z45Register_UnityEngine_Input_get_touchSupportedv: __Z45Register_UnityEngine_Input_get_touchSupportedv, __ZN5Mutex8IsLockedEv: __ZN5Mutex8IsLockedEv, __ZN12b2WheelJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN12b2WheelJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN13SpringJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13SpringJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10Collider2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4FMOD5Sound16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj: __ZN4FMOD5Sound16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj, __Z47AudioListener_Get_Custom_PropVelocityUpdateModeP12Il2CppObject: __Z47AudioListener_Get_Custom_PropVelocityUpdateModeP12Il2CppObject, __Z25CubemapArray_CUSTOM_ApplyP12Il2CppObjecthh: __Z25CubemapArray_CUSTOM_ApplyP12Il2CppObjecthh, __Z41NavMeshAgent_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK8Vector3fP10NavMeshHit: __Z41NavMeshAgent_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK8Vector3fP10NavMeshHit, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE15growAndPushBackERKS3_, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE, _jsimd_convsamp_float: _jsimd_convsamp_float, __ZN15AudioEchoFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15AudioEchoFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __Z14DecompressBC6HiiiPKjPj13TextureFormat: __Z14DecompressBC6HiiiPKjPj13TextureFormat, __ZN12_GLOBAL__N_110Connection13lockOutStreamEv: __ZN12_GLOBAL__N_110Connection13lockOutStreamEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv, __ZN11LightProbes14SetPendingDataERK13dynamic_arrayI13ProbeSetIndexLj8EE: __ZN11LightProbes14SetPendingDataERK13dynamic_arrayI13ProbeSetIndexLj8EE, __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjPjS1_bRNS_6memory9AllocatorE: __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjPjS1_bRNS_6memory9AllocatorE, __Z43Animator_CUSTOM_GetAnimatorClipInfoInternalP12Il2CppObjectihS0_: __Z43Animator_CUSTOM_GetAnimatorClipInfoInternalP12Il2CppObjectihS0_, __Z29getPxSceneDescSolverBatchSizePKN5physx11PxSceneDescE: __Z29getPxSceneDescSolverBatchSizePKN5physx11PxSceneDescE, _UNITY_png_get_compression_buffer_size: _UNITY_png_get_compression_buffer_size, __ZNSt3__28__c_nodeD0Ev: __ZNSt3__28__c_nodeD0Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags, __ZN5physx2Sc13ConstraintSim19destroyLLConstraintEv: __ZN5physx2Sc13ConstraintSim19destroyLLConstraintEv, __ZN5physx2Gu20registerHeightFieldsEv: __ZN5physx2Gu20registerHeightFieldsEv, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13set_empty_keyERKSC_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13set_empty_keyERKSC_, __Z33setPxSceneLimitsMaxNbStaticShapesPN5physx13PxSceneLimitsEj: __Z33setPxSceneLimitsMaxNbStaticShapesPN5physx13PxSceneLimitsEj, __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf: __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE6resizeEjRKf, __ZN5physx6shdfnd10SocketImpl11setBlockingEb: __ZN5physx6shdfnd10SocketImpl11setBlockingEb, __ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx22concludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK5physx15NpParticleFluid12getStiffnessEv: __ZNK5physx15NpParticleFluid12getStiffnessEv, __ZN13ComputeBuffer20ReloadAllToGfxDeviceEv: __ZN13ComputeBuffer20ReloadAllToGfxDeviceEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED0Ev: __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED0Ev, __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall: __Z62ParticleSystem_SizeBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE8__appendEj, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE8AllocateEji, __ZN11UnityEngine9Analytics15UserCustomEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine9Analytics15UserCustomEvent12ToJsonStringER9JSONWrite, __ZN12LineRenderer10LinePointsD0Ev: __ZN12LineRenderer10LinePointsD0Ev, __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE: __ZN20DynamicPropertySheet15SetVectorQueuedERKN9ShaderLab16FastPropertyNameERK8Vector4fN19ShaderPropertySheet8SetFlagsE, __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI16BlendShapeVertexLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN15AudioReverbZone8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15AudioReverbZone8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject: __ZN9Scripting20SendScriptingMessageER10GameObjectPKcP12Il2CppObject, __Z33Profiler_Get_Custom_PropSupportedv: __Z33Profiler_Get_Custom_PropSupportedv, __ZN9ShaderLab20SerializedProperties16AddFloatPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEf: __ZN9ShaderLab20SerializedProperties16AddFloatPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEf, __ZN8JSONRead13StartSequenceEv: __ZN8JSONRead13StartSequenceEv, __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26vectorI12QuadTreeNodeNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI12QuadTreeNodeNS_9allocatorIS1_EEE8__appendEj, __Z41Camera_CUSTOM_GetStereoProjectionMatricesP12Il2CppObject: __Z41Camera_CUSTOM_GetStereoProjectionMatricesP12Il2CppObject, __ZN17GenericDynamicVBO10AllocateVBEjR21DynamicVBOChunkHandle: __ZN17GenericDynamicVBO10AllocateVBEjR21DynamicVBOChunkHandle, __Z37HingeJoint_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK11JointLimits: __Z37HingeJoint_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK11JointLimits, __ZN4gles18CreateDummySurfaceEbRK17RenderSurfaceDesc: __ZN4gles18CreateDummySurfaceEbRK17RenderSurfaceDesc, __ZN23AnimationOffsetPlayable7GetTypeEv: __ZN23AnimationOffsetPlayable7GetTypeEv, __ZL27PxcTestFacesSepAxesBackfaceRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ERfRSB_RjPjSG_fSD_: __ZL27PxcTestFacesSepAxesBackfaceRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ERfRSB_RjPjSG_fSD_, __Z21getNbPxPhysics_ScenesPKN5physx9PxPhysicsE: __Z21getNbPxPhysics_ScenesPKN5physx9PxPhysicsE, __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN6Shader13GetDependencyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5Umbra12QueryContext13visualizeCellEPKNS_7ImpTileEi: __ZN5Umbra12QueryContext13visualizeCellEPKNS_7ImpTileEi, __ZL26InitializeModule_Animationv: __ZL26InitializeModule_Animationv, __Z33setPxVehicleWheelDataMDampingRatePN5physx18PxVehicleWheelDataEf: __Z33setPxVehicleWheelDataMDampingRatePN5physx18PxVehicleWheelDataEf, _strtold: _strtold, __ZN17AudioChorusFilter15ThreadedCleanupEv: __ZN17AudioChorusFilter15ThreadedCleanupEv, __Z48ParticleSystem_CollisionModule_CUSTOM_GetEnabledP12Il2CppObject: __Z48ParticleSystem_CollisionModule_CUSTOM_GetEnabledP12Il2CppObject, __Z33AndroidJNI_CUSTOM_FromDoubleArray13Il2Cpp_IntPtr: __Z33AndroidJNI_CUSTOM_FromDoubleArray13Il2Cpp_IntPtr, __Z49Animator_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_: __Z49Animator_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z31Input_CUSTOM_GetMouseButtonDowni: __Z31Input_CUSTOM_GetMouseButtonDowni, __Z39setPxSimulationStatisticsNbStaticBodiesPN5physx22PxSimulationStatisticsEj: __Z39setPxSimulationStatisticsNbStaticBodiesPN5physx22PxSimulationStatisticsEj, __ZNK5physx7NpCloth23getExternalAccelerationEv: __ZNK5physx7NpCloth23getExternalAccelerationEv, __ZN5audio5mixer25SetExposedParameterValuesERKNS0_18AudioMixerConstantEPKfiRNS0_16AudioMixerMemoryE: __ZN5audio5mixer25SetExposedParameterValuesERKNS0_18AudioMixerConstantEPKfiRNS0_16AudioMixerMemoryE, __ZNK9Transform16GetLocalPositionEv: __ZNK9Transform16GetLocalPositionEv, __Z19scripting_array_newP11Il2CppClassjj: __Z19scripting_array_newP11Il2CppClassjj, __ZN13LoadOperation19IntegrateTimeSlicedEi: __ZN13LoadOperation19IntegrateTimeSlicedEi, __ZNK15QualitySettings26GetTypeInfoVirtualInternalEv: __ZNK15QualitySettings26GetTypeInfoVirtualInternalEv, __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2: __Z33InterpolateLightProbeCoefficientsRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2, __Z39RenderBufferHelper_CUSTOM_SetLoadActionP21ScriptingRenderBufferi: __Z39RenderBufferHelper_CUSTOM_SetLoadActionP21ScriptingRenderBufferi, __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj: __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj, __ZN8Animator16GetStabilizeFeetEv: __ZN8Animator16GetStabilizeFeetEv, __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_: __Z17TransformAABBSlowRK4AABBRK10Matrix4x4fRS_, __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEvRT_j, __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI15NavMeshTileData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j, __Z43Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorP12Il2CppObjectP8Vector3f: __Z43Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorP12Il2CppObjectP8Vector3f, __ZN9ShaderLab21SerializedShaderState8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab21SerializedShaderState8TransferI14SafeBinaryReadEEvRT_, __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev: __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev, __Z24RegisterStrippedTypeInfoI10FlareLayerEviPKcS2_: __Z24RegisterStrippedTypeInfoI10FlareLayerEviPKcS2_, _ftruncate: _ftruncate, _UNITY_FT_Stream_ReadUOffset: _UNITY_FT_Stream_ReadUOffset, __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE13StaticDestroyEPv, __Z31getPxCloth_SimulationFilterDataPKN5physx7PxClothE: __Z31getPxCloth_SimulationFilterDataPKN5physx7PxClothE, _cf2_stack_pushInt: _cf2_stack_pushInt, __ZN7mecanim9animation20DestroyLayerConstantEPNS0_13LayerConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation20DestroyLayerConstantEPNS0_13LayerConstantERNS_6memory9AllocatorE, __ZN5physx2Sc18ParticleSystemCore23setRestParticleDistanceEf: __ZN5physx2Sc18ParticleSystemCore23setRestParticleDistanceEf, __Z21getPxShape_RestOffsetPKN5physx7PxShapeE: __Z21getPxShape_RestOffsetPKN5physx7PxShapeE, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm, __ZNK5Umbra9Matrix2x2eqERKS0_: __ZNK5Umbra9Matrix2x2eqERKS0_, __Z51Register_UnityEngine_Physics_set_maxAngularVelocityv: __Z51Register_UnityEngine_Physics_set_maxAngularVelocityv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputcEw: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputcEw, __ZN18PlatformEffector2D19RecalculateContactsEv: __ZN18PlatformEffector2D19RecalculateContactsEv, __Z48SceneManager_CUSTOM_UnloadSceneNameIndexInternalP12Il2CppStringihPh: __Z48SceneManager_CUSTOM_UnloadSceneNameIndexInternalP12Il2CppStringihPh, __ZN10GUITexture16RenderGUIElementERK5RectTIfER17ShaderPassContext: __ZN10GUITexture16RenderGUIElementERK5RectTIfER17ShaderPassContext, __ZN18ResourceImageGroup7CleanupEv: __ZN18ResourceImageGroup7CleanupEv, __ZN5physx2Gu36closestPtPointTetrahedronTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_RjRS3_S6_: __ZN5physx2Gu36closestPtPointTetrahedronTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_RjRS3_S6_, __ZN5physx2Gu28pcmContactCapsuleHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu28pcmContactCapsuleHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN5Umbra9Matrix3x3mLERKS0_: __ZN5Umbra9Matrix3x3mLERKS0_, __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11Quaternionf8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx25PxcPCMContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx25PxcPCMContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByPathv: __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByPathv, __ZN5Umbra9intersectERKNS_7Vector4ERKNS_8TriangleE: __ZN5Umbra9intersectERKNS_7Vector4ERKNS_8TriangleE, __ZNK9WWWCached14GetPartialDataEv: __ZNK9WWWCached14GetPartialDataEv, ___lgamma_r: ___lgamma_r, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEED0Ev, __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_twistLimitSpringv: __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_twistLimitSpringv, __ZN5physx7profile30PxProfileMemoryEventBufferImpl7releaseEv: __ZN5physx7profile30PxProfileMemoryEventBufferImpl7releaseEv, __ZN13OcclusionArea15InitializeClassEv: __ZN13OcclusionArea15InitializeClassEv, __ZN8Playable19SetOutputConnectionEPS_i: __ZN8Playable19SetOutputConnectionEPS_i, __Z42Rigidbody2D_Get_Custom_PropAngularVelocityP12Il2CppObject: __Z42Rigidbody2D_Get_Custom_PropAngularVelocityP12Il2CppObject, __Z40FixedJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf: __Z40FixedJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN7Texture13GetAnisoLimitEv: __ZN7Texture13GetAnisoLimitEv, __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei: __Z32BuildNormalizerSolidAngleCubemapiP13CImageSurfacei, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj43ENS_22PxRepXPropertyAccessorILj43ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj43ENS_22PxRepXPropertyAccessorILj43ES4_ffEEEEvRKT0_, __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceNamev: __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceNamev, __ZN20ComputeShaderVariant8TransferI14SafeBinaryReadEEvRT_: __ZN20ComputeShaderVariant8TransferI14SafeBinaryReadEEvRT_, __ZN5physx16PxsIslandManager17cleanupEdgeEventsEv: __ZN5physx16PxsIslandManager17cleanupEdgeEventsEv, __ZN7mecanim9animation12AvatarMemory8TransferI9BlobWriteEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI9BlobWriteEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN2UI14CanvasRenderer5ClearEv: __ZN2UI14CanvasRenderer5ClearEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZZ23InitPlayerLoopCallbacksvEN38EarlyUpdateExecuteMainThreadJobsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN38EarlyUpdateExecuteMainThreadJobsstruct7ForwardEv, __ZN11UnityEngine15PlatformWrapper20IsRootedOrJailbrokenEv: __ZN11UnityEngine15PlatformWrapper20IsRootedOrJailbrokenEv, __ZN19RuntimeSceneManager9LoadSceneERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeE: __ZN19RuntimeSceneManager9LoadSceneERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeE, __Z47Renderer_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f: __Z47Renderer_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f, __Z27scripting_add_internal_callPKcPKv: __Z27scripting_add_internal_callPKcPKv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj159ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj159ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjijPjP8Vector2fRNS_6memory9AllocatorE: __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjijPjP8Vector2fRNS_6memory9AllocatorE, __Z17GetPlayerSettingsv: __Z17GetPlayerSettingsv, __ZL21ContactReductionAllInRN5physx2Gu13ContactBufferEjjRKNS_7PxMat33EPKNS_6PxVec3EPKh: __ZL21ContactReductionAllInRN5physx2Gu13ContactBufferEjjRKNS_7PxMat33EPKNS_6PxVec3EPKh, __ZN12SoundManager19CaptureProfilerInfoER13dynamic_arrayI21AudioProfilerClipInfoLj4EERS0_IcLj1EE: __ZN12SoundManager19CaptureProfilerInfoER13dynamic_arrayI21AudioProfilerClipInfoLj4EERS0_IcLj1EE, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIiEEclERS1_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIiEEclERS1_17TransferMetaFlagsR9BlobWrite, __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj, __ZN2UI14CanvasRenderer9SyncColorENS0_8SyncFlagE: __ZN2UI14CanvasRenderer9SyncColorENS0_8SyncFlagE, __Z18LoadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18LoadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN12_GLOBAL__N_122SocketNetworkOutStreamD0Ev: __ZN12_GLOBAL__N_122SocketNetworkOutStreamD0Ev, __Z53AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectArrayElement13Il2Cpp_IntPtriRPv: __Z53AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectArrayElement13Il2Cpp_IntPtriRPv, __ZNK10UnityScene7IsEmptyEv: __ZNK10UnityScene7IsEmptyEv, __ZN29BillboardTreeInstanceRenderer10UpdateWindEv: __ZN29BillboardTreeInstanceRenderer10UpdateWindEv, __ZN6HelperI9JSONWrite18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI9JSONWrite18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __Z33EmitSerializationCommandsForFieldI8JSONReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI8JSONReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN13RenderTexture8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13RenderTexture8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx5cloth16TripletScheduler4warpEjj: __ZN5physx5cloth16TripletScheduler4warpEjj, __ZN14BillboardAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14BillboardAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E5clearEv: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E5clearEv, __ZN5Umbra15StartCellFinder23findStartCellsForObjectENS_12PortalCuller4TileERKNS_10MappedTileE: __ZN5Umbra15StartCellFinder23findStartCellsForObjectENS_12PortalCuller4TileERKNS_10MappedTileE, __Z48TerrainData_CUSTOM_INTERNAL_CALL_SetTreeInstanceP12Il2CppObjectiRK12TreeInstance: __Z48TerrainData_CUSTOM_INTERNAL_CALL_SetTreeInstanceP12Il2CppObjectiRK12TreeInstance, __ZN2UI14CanvasRenderer12SyncMaterialENS0_8SyncFlagE: __ZN2UI14CanvasRenderer12SyncMaterialENS0_8SyncFlagE, __ZN5physx16PxsFluidDynamics5clearEv: __ZN5physx16PxsFluidDynamics5clearEv, __ZN5Umbra4Math3cosENS_5FloatE: __ZN5Umbra4Math3cosENS_5FloatE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z37TextMesh_Get_Custom_PropCharacterSizeP12Il2CppObject: __Z37TextMesh_Get_Custom_PropCharacterSizeP12Il2CppObject, _UnityReplayKitPreview: _UnityReplayKitPreview, ___freadptr: ___freadptr, __ZN22b2EdgeAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN22b2EdgeAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator, __Z26scripting_object_get_classP12Il2CppObject: __Z26scripting_object_get_classP12Il2CppObject, __Z40GUIUtility_Get_Custom_PropTextFieldInputv: __Z40GUIUtility_Get_Custom_PropTextFieldInputv, __ZN5physx15PxsParticleData13fixupPointersEv: __ZN5physx15PxsParticleData13fixupPointersEv, __Z67Register_UnityEngine_AnimatorClipInfo_ClipInstanceToScriptingObjectv: __Z67Register_UnityEngine_AnimatorClipInfo_ClipInstanceToScriptingObjectv, __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj: __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEj, __Z36Time_Get_Custom_PropMaximumDeltaTimev: __Z36Time_Get_Custom_PropMaximumDeltaTimev, __Z20DumpCallstackConsolePKcS0_i: __Z20DumpCallstackConsolePKcS0_i, __Z56Register_UnityEngine_GUIStyle_INTERNAL_set_contentOffsetv: __Z56Register_UnityEngine_GUIStyle_INTERNAL_set_contentOffsetv, _ft_smooth_render_lcd: _ft_smooth_render_lcd, __ZNK11OffMeshLink11GetOccupiedEv: __ZNK11OffMeshLink11GetOccupiedEv, __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE13set_empty_keyERSF_: __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE13set_empty_keyERSF_, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE16setRigidBodyFlagENS_15PxRigidBodyFlag4EnumEb, __ZN8Renderer12LayerChangedEv: __ZN8Renderer12LayerChangedEv, __Z20RegisterModule_Umbrav: __Z20RegisterModule_Umbrav, __GLOBAL__sub_I_runtime_shaders_shaderimpl_lump_cpp: __GLOBAL__sub_I_runtime_shaders_shaderimpl_lump_cpp, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_, __ZN14AnimationEvent8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14AnimationEvent8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI9Texture2DE8TransferI14SafeBinaryReadEEvRT_, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv, __ZN5physx20updateAtomProgressesEPNS_23PxcSolverConstraintDescEjjj: __ZN5physx20updateAtomProgressesEPNS_23PxcSolverConstraintDescEjjj, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYLimitv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYLimitv, __ZNK5Umbra4Tome16getObjectUserIDsEiPji: __ZNK5Umbra4Tome16getObjectUserIDsEiPji, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4syncEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4syncEv, __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEii: __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEii, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z39setPxParticleReadDataValidParticleRangePN5physx18PxParticleReadDataEj: __Z39setPxParticleReadDataValidParticleRangePN5physx18PxParticleReadDataEj, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z41Register_UnityEngine_Input_ResetInputAxesv: __Z41Register_UnityEngine_Input_ResetInputAxesv, __Z36AnimationState_Get_Custom_PropWeightP12Il2CppObject: __Z36AnimationState_Get_Custom_PropWeightP12Il2CppObject, __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z4TrimRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZNK13SplatDatabase10GetBasemapEv: __ZNK13SplatDatabase10GetBasemapEv, __ZN4Node5ResetEv: __ZN4Node5ResetEv, __Z21DetailPrototypeToMonoRK15DetailPrototypeR19MonoDetailPrototype: __Z21DetailPrototypeToMonoRK15DetailPrototypeR19MonoDetailPrototype, __Z19scripting_gc_enablev: __Z19scripting_gc_enablev, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE9DoRequestEv: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE9DoRequestEv, __ZN11UTF16StringC2ERKS_10MemLabelId: __ZN11UTF16StringC2ERKS_10MemLabelId, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9stopEventEty: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9stopEventEty, __Z29StdTemplateConversionFunctionIihEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIihEbPvR14SafeBinaryRead, __ZN4PPtrI14BillboardAssetE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI14BillboardAssetE8TransferI14SafeBinaryReadEEvRT_, __ZN19SharedBillboardData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19SharedBillboardData8TransferI24GenerateTypeTreeTransferEEvRT_, __Z55Register_UnityEngine_CanvasRenderer_DisableRectClippingv: __Z55Register_UnityEngine_CanvasRenderer_DisableRectClippingv, _start_pass_huff_decoder: _start_pass_huff_decoder, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j, __Z16PostprocessScenev: __Z16PostprocessScenev, __ZN5physx5cloth4copyINS0_7SwClothES2_EEvRT_RKT0_: __ZN5physx5cloth4copyINS0_7SwClothES2_EEvRT_RKT0_, __ZNKSt3__210moneypunctIcLb1EE13do_pos_formatEv: __ZNKSt3__210moneypunctIcLb1EE13do_pos_formatEv, __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f: __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb0EEEbRKNS_8Vector2iES4_f, __ZN5physx22PxVehicleWheelsSimData25setMinLongSlipDenominatorEf: __ZN5physx22PxVehicleWheelsSimData25setMinLongSlipDenominatorEf, __Z42Terrain_Set_Custom_PropTreeCrossFadeLengthP12Il2CppObjectf: __Z42Terrain_Set_Custom_PropTreeCrossFadeLengthP12Il2CppObjectf, __Z40Register_UnityEngine_Sprite_get_verticesv: __Z40Register_UnityEngine_Sprite_get_verticesv, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZNSt3__210moneypunctIwLb0EED2Ev: __ZNSt3__210moneypunctIwLb0EED2Ev, __ZN4FMOD8ChannelI14setLowPassGainEf: __ZN4FMOD8ChannelI14setLowPassGainEf, __ZN4FMOD4DSPI14disconnectFromEPNS_3DSPE: __ZN4FMOD4DSPI14disconnectFromEPNS_3DSPE, __ZN9ShaderLab7Program27CreateFromSerializedProgramERKNS_17SerializedProgramE10ShaderTypeiP16PropertyNamesSetPK6Shader: __ZN9ShaderLab7Program27CreateFromSerializedProgramERKNS_17SerializedProgramE10ShaderTypeiP16PropertyNamesSetPK6Shader, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE26__invalidate_all_iteratorsEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE26__invalidate_all_iteratorsEv, __Z41Register_UnityEngine_AI_NavMeshPath__ctorv: __Z41Register_UnityEngine_AI_NavMeshPath__ctorv, __Z31checkOverlapSphere_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu6SphereE: __Z31checkOverlapSphere_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu6SphereE, __ZN10GUIManager17GetMasterGUIStateEi: __ZN10GUIManager17GetMasterGUIStateEi, __ZNSt3__217moneypunct_bynameIwLb0EEC2EPKcj: __ZNSt3__217moneypunct_bynameIwLb0EEC2EPKcj, __Z20GetPersistentManagerv: __Z20GetPersistentManagerv, _UNITY_TT_Set_Var_Design: _UNITY_TT_Set_Var_Design, _encrypt: _encrypt, __ZN21SystemInfoStringCache16StaticInitializeEPv: __ZN21SystemInfoStringCache16StaticInitializeEPv, __Z38NavMeshAgent_Get_Custom_PropBaseOffsetP12Il2CppObject: __Z38NavMeshAgent_Get_Custom_PropBaseOffsetP12Il2CppObject, __ZN5physx2Sc7BodySim18internalWakeUpBaseEf: __ZN5physx2Sc7BodySim18internalWakeUpBaseEf, __ZN14b2CapsuleShape13SetByExtentsYEff: __ZN14b2CapsuleShape13SetByExtentsYEff, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE21__grow_by_and_replaceEjjjjjjPKc, __ZNSt3__26vectorIP5CacheNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP5CacheNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z35DoesBuildTargetSupportBlobification19BuildTargetPlatform24TransferInstructionFlags: __Z35DoesBuildTargetSupportBlobification19BuildTargetPlatform24TransferInstructionFlags, __ZNK13MonoBehaviour7GetNameEv: __ZNK13MonoBehaviour7GetNameEv, __ZN18ProceduralMaterial18GetSubstanceHandleEv: __ZN18ProceduralMaterial18GetSubstanceHandleEv, __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv: __ZN19ScriptingInvocation28AdjustArgumentsToMatchMethodEv, __ZN17ProceduralTexture14OnSyncMaterialER21ProceduralTextureData: __ZN17ProceduralTexture14OnSyncMaterialER21ProceduralTextureData, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveMultiplierv, __ZN12NavMeshAgent23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12NavMeshAgent23VirtualRedirectTransferER17RemapPPtrTransfer, __Z15_CheckFMODError11FMOD_RESULTPKciS1_: __Z15_CheckFMODError11FMOD_RESULTPKciS1_, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZNK5physx2Sc9ClothCore26getCentrifugalInertiaScaleEv: __ZNK5physx2Sc9ClothCore26getCentrifugalInertiaScaleEv, __Z42WindZone_Get_Custom_PropWindPulseFrequencyP12Il2CppObject: __Z42WindZone_Get_Custom_PropWindPulseFrequencyP12Il2CppObject, __ZN14ParticleSystem18SetMaxNumParticlesEi: __ZN14ParticleSystem18SetMaxNumParticlesEi, __Z47Register_UnityEngine_Sprite_get_packingRotationv: __Z47Register_UnityEngine_Sprite_get_packingRotationv, __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypef: __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypef, __Z46Register_UnityEngine_RenderSettings_set_skyboxv: __Z46Register_UnityEngine_RenderSettings_set_skyboxv, __Z44TrailRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf: __Z44TrailRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf, __Z62Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserIdv: __Z62Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserIdv, __ZN15RelativeJoint2D16SetAngularOffsetEf: __ZN15RelativeJoint2D16SetAngularOffsetEf, __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR11EventSorterP14AnimationEventEEjT0_S5_S5_T_, __ZN11ShapeModule5ResetEv: __ZN11ShapeModule5ResetEv, __Z43ParticleSystem_Get_Custom_PropPlaybackSpeedP12Il2CppObject: __Z43ParticleSystem_Get_Custom_PropPlaybackSpeedP12Il2CppObject, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8getSceneEv, __Z38Material_Set_Custom_PropShaderKeywordsP12Il2CppObjectP11Il2CppArray: __Z38Material_Set_Custom_PropShaderKeywordsP12Il2CppObjectP11Il2CppArray, __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE13set_empty_keyERSG_: __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE13set_empty_keyERSG_, __ZN5physx13BigConvexData5VLoadERNS_13PxInputStreamE: __ZN5physx13BigConvexData5VLoadERNS_13PxInputStreamE, __ZN12b2BroadPhase10TouchProxyEi: __ZN12b2BroadPhase10TouchProxyEi, __Z38AndroidJNI_CUSTOM_CallStaticCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z38AndroidJNI_CUSTOM_CallStaticCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN7mecanim9animation10ValueDelta8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation10ValueDelta8TransferI14SafeBinaryReadEEvRT_, __ZN20OverlapCircleQuery2D13ReportFixtureEP9b2Fixture: __ZN20OverlapCircleQuery2D13ReportFixtureEP9b2Fixture, __ZN4FMOD7SystemI19getMasterSoundGroupEPPNS_10SoundGroupE: __ZN4FMOD7SystemI19getMasterSoundGroupEPPNS_10SoundGroupE, __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipUP12Il2CppObjectf: __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipUP12Il2CppObjectf, __ZN18AnimatorController19TransferRuntimeDataI24GenerateTypeTreeTransferEEvRT_: __ZN18AnimatorController19TransferRuntimeDataI24GenerateTypeTreeTransferEEvRT_, _jpeg_alloc_huff_table: _jpeg_alloc_huff_table, __ZN5physx3Ext7D6JointD2Ev: __ZN5physx3Ext7D6JointD2Ev, __ZN20SpeedTreeWindManagerD2Ev: __ZN20SpeedTreeWindManagerD2Ev, __ZN20LocalFileSystemPosix10ToAbsoluteEPKc: __ZN20LocalFileSystemPosix10ToAbsoluteEPKc, __ZN21ArchiveStorageCreator8FinalizeEPj: __ZN21ArchiveStorageCreator8FinalizeEPj, __ZNSt3__212strstreambuf4swapERS0_: __ZNSt3__212strstreambuf4swapERS0_, __ZN7mecanim5human10RemoveAxisEPKNS0_5HumanEiRKN4math7_float4E: __ZN7mecanim5human10RemoveAxisEPKNS0_5HumanEiRKN4math7_float4E, _UNITY_png_default_flush: _UNITY_png_default_flush, __ZN15RelativeJoint2D15SetLinearOffsetERK8Vector2f: __ZN15RelativeJoint2D15SetLinearOffsetERK8Vector2f, __ZN6Object17MainThreadCleanupEv: __ZN6Object17MainThreadCleanupEv, _wcstombs: _wcstombs, __ZN18ProceduralMaterial22CloneMaterialForExportEbb: __ZN18ProceduralMaterial22CloneMaterialForExportEbb, __ZNK12IFileAdapter8PositionERK13FileEntryData: __ZNK12IFileAdapter8PositionERK13FileEntryData, __Z55Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshv: __Z55Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshv, _UNITY_png_do_expand: _UNITY_png_do_expand, _getcwd: _getcwd, __Z43Terrain_Get_Custom_PropDetailObjectDistanceP12Il2CppObject: __Z43Terrain_Get_Custom_PropDetailObjectDistanceP12Il2CppObject, __ZN16b2CapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN16b2CapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN5physx16PxVehicleDriveNWD2Ev: __ZN5physx16PxVehicleDriveNWD2Ev, __ZN5physx18NpArticulationLinkD0Ev: __ZN5physx18NpArticulationLinkD0Ev, __ZN25ThreadsafeLinearAllocatorD2Ev: __ZN25ThreadsafeLinearAllocatorD2Ev, __ZN5physx2Sq10AABBPruner11preallocateEj: __ZN5physx2Sq10AABBPruner11preallocateEj, __ZN21BillboardBatchManager16StaticInitializeEPv: __ZN21BillboardBatchManager16StaticInitializeEPv, __Z51Register_UnityEngine_Camera_get_useOcclusionCullingv: __Z51Register_UnityEngine_Camera_get_useOcclusionCullingv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z41getPxVehicleDifferential4WDataMCentreBiasPKN5physx27PxVehicleDifferential4WDataE: __Z41getPxVehicleDifferential4WDataMCentreBiasPKN5physx27PxVehicleDifferential4WDataE, __ZN5physx2Sc19ShapeInstancePairLLC2ERNS0_8ShapeSimES3_RNS0_9ActorPairENS_7PxFlagsINS_10PxPairFlag4EnumEtEE: __ZN5physx2Sc19ShapeInstancePairLLC2ERNS0_8ShapeSimES3_RNS0_9ActorPairENS_7PxFlagsINS_10PxPairFlag4EnumEtEE, __Z44Register_UnityEngine_Animator_get_fireEventsv: __Z44Register_UnityEngine_Animator_get_fireEventsv, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE8ValidateEPS1_: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE8ValidateEPS1_, __ZN19RuntimeSceneManagerC2Ev: __ZN19RuntimeSceneManagerC2Ev, __ZN5physx23PxVehicleWheels4SimData12setWheelDataEjRKNS_18PxVehicleWheelDataE: __ZN5physx23PxVehicleWheels4SimData12setWheelDataEjRKNS_18PxVehicleWheelDataE, __ZNK16b2StackAllocator16GetMaxAllocationEv: __ZNK16b2StackAllocator16GetMaxAllocationEv, __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE: __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE, __Z37TextGenerator_CUSTOM_GetLinesInternalP12Il2CppObjectS0_: __Z37TextGenerator_CUSTOM_GetLinesInternalP12Il2CppObjectS0_, __Z45Register_UnityEngine_AndroidJNI_SetShortFieldv: __Z45Register_UnityEngine_AndroidJNI_SetShortFieldv, __ZN5physx3Ext21InertiaTensorComputerD2Ev: __ZN5physx3Ext21InertiaTensorComputerD2Ev, __ZN11AssetBundle8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11AssetBundle8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK10UnityScene13GetBuildIndexEv: __ZNK10UnityScene13GetBuildIndexEv, __Z36getPxVehicleWheels_RigidDynamicActorPKN5physx15PxVehicleWheelsE: __Z36getPxVehicleWheels_RigidDynamicActorPKN5physx15PxVehicleWheelsE, __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_: __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_, __ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_: __ZNSt3__23mapIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_NS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_, __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader: __ZN17ArchiveFileSystem10AddStorageEP20ArchiveStorageReader, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMaxDepenetrationVelocityEf: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMaxDepenetrationVelocityEf, __ZN5physx2Sc9ClothCore16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE: __ZN5physx2Sc9ClothCore16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN15RelativeJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN15RelativeJoint2DC2E10MemLabelId18ObjectCreationMode, __ZN9SubModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9SubModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN24iPhoneRemoteNotification8RegisterEi: __ZN24iPhoneRemoteNotification8RegisterEi, __Z14CopySerializedRK6ObjectRS_: __Z14CopySerializedRK6ObjectRS_, __ZNK12b2MotorJoint16GetReactionForceEf: __ZNK12b2MotorJoint16GetReactionForceEf, __ZN12_GLOBAL__N_112UploadFormatE13TextureFormat: __ZN12_GLOBAL__N_112UploadFormatE13TextureFormat, __ZN5physx23collideWithConvexPlanesERNS_19PxsParticleCollDataEPKNS_7PxPlaneEjf: __ZN5physx23collideWithConvexPlanesERNS_19PxsParticleCollDataEPKNS_7PxPlaneEjf, __Z44Caching_CUSTOM_INTERNAL_CALL_IsVersionCachedP12Il2CppStringRK7Hash128: __Z44Caching_CUSTOM_INTERNAL_CALL_IsVersionCachedP12Il2CppStringRK7Hash128, _decode_mcu_DC_refine: _decode_mcu_DC_refine, __Z64Register_UnityEngine_Application_GetStreamProgressForLevelByNamev: __Z64Register_UnityEngine_Application_GetStreamProgressForLevelByNamev, __ZNK9Heightmap21GetInterpolatedHeightEff: __ZNK9Heightmap21GetInterpolatedHeightEff, __ZN22ParticleSystemRenderer15UpdateLocalAABBEv: __ZN22ParticleSystemRenderer15UpdateLocalAABBEv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN21ExecutionOrderManager12CleanupClassEv: __ZN21ExecutionOrderManager12CleanupClassEv, __ZNK8WWWAudio14GetPartialSizeEv: __ZNK8WWWAudio14GetPartialSizeEv, __ZNK9Texture2D16GetNpotTexelSizeEv: __ZNK9Texture2D16GetNpotTexelSizeEv, __Z36Joint_Set_Custom_PropEnableCollisionP12Il2CppObjecth: __Z36Joint_Set_Custom_PropEnableCollisionP12Il2CppObjecth, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZZN20TextRenderingPrivate8TextMesh15InitializeClassEvEN31FunctorImpl_293kDidAddComponent4CallEPviR11MessageData: __ZZN20TextRenderingPrivate8TextMesh15InitializeClassEvEN31FunctorImpl_293kDidAddComponent4CallEPviR11MessageData, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j, __ZN13dynamic_arrayItLj2EE6insertEPtPKtS3_: __ZN13dynamic_arrayItLj2EE6insertEPtPKtS3_, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryD2Ev, __Z41LightmapSettings_Set_Custom_PropLightmapsP11Il2CppArray: __Z41LightmapSettings_Set_Custom_PropLightmapsP11Il2CppArray, __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN8Animator14GetMuscleValueEiPf: __ZN8Animator14GetMuscleValueEiPf, __ZN13SliderJoint2D8SetAngleEf: __ZN13SliderJoint2D8SetAngleEf, __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej: __ZN9GfxDevice22GetDefaultVertexBufferE26GfxDefaultVertexBufferTypej, __ZN19CharacterController13SetSlopeLimitEf: __ZN19CharacterController13SetSlopeLimitEf, __Z39Register_UnityEngine_GL_ClearWithSkyboxv: __Z39Register_UnityEngine_GL_ClearWithSkyboxv, ___fseeko_unlocked: ___fseeko_unlocked, __ZN16ParticleRenderer19UpdateTransformInfoEv: __ZN16ParticleRenderer19UpdateTransformInfoEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags, __ZN5physx3Cct17CapsuleControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE: __ZN5physx3Cct17CapsuleControllerC2ERKNS_16PxControllerDescERNS_9PxPhysicsEPNS_7PxSceneE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z17BeginSplashScreenv: __Z17BeginSplashScreenv, __ZN29RenderNodeQueuePrepareContextD2Ev: __ZN29RenderNodeQueuePrepareContextD2Ev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_, __ZN9ShaderLab16SerializedShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab16SerializedShader8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN7mecanim9animation18CreateAvatarMemoryEPKNS0_14AvatarConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation18CreateAvatarMemoryEPKNS0_14AvatarConstantERNS_6memory9AllocatorE, __Z36Collider2D_Get_Custom_PropErrorStateP12Il2CppObject: __Z36Collider2D_Get_Custom_PropErrorStateP12Il2CppObject, __ZN19MeshParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19MeshParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Gu19BipartiteBoxPruningEPKNS_9PxBounds3EjS3_jRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE: __ZN5physx2Gu19BipartiteBoxPruningEPKNS_9PxBounds3EjS3_jRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE, __ZL29GeomOverlapCallback_PlaneMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL29GeomOverlapCallback_PlaneMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN24iPhoneRemoteNotificationaSERKS_: __ZN24iPhoneRemoteNotificationaSERKS_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z18ConvertUTF8toUTF16RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayItLj2EE: __Z18ConvertUTF8toUTF16RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayItLj2EE, __Z23AndroidJNI_CUSTOM_Throw13Il2Cpp_IntPtr: __Z23AndroidJNI_CUSTOM_Throw13Il2Cpp_IntPtr, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEPKw: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEPKw, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup: __ZN18GfxFramebufferGLES18GetFramebufferNameERK20GfxRenderTargetSetup, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj546ENS_22PxRepXPropertyAccessorILj546ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj546ENS_22PxRepXPropertyAccessorILj546ES4_ffEEEEvRKT0_, __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI9TransformELj4EEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI9TransformELj4EEEiP11Il2CppArrayRKT_i, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE16FrameMaintenanceEb: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE16FrameMaintenanceEb, _processblock_41: _processblock_41, __Z45Register_UnityEngine_Transform_get_hasChangedv: __Z45Register_UnityEngine_Transform_get_hasChangedv, __Z30Event_Get_Custom_PropCharacterP12Il2CppObject: __Z30Event_Get_Custom_PropCharacterP12Il2CppObject, __ZN8Animator17IsAutoPlayingBackEv: __ZN8Animator17IsAutoPlayingBackEv, __ZN2UIL17UnloadAllCanvasesEv: __ZN2UIL17UnloadAllCanvasesEv, __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, _UNITY_png_set_flush: _UNITY_png_set_flush, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYv, _endservent: _endservent, __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode: __ZN8Collider13AwakeFromLoadE17AwakeFromLoadMode, __ZN17PersistentManager63RegisterAndAwakeThreadedObjectAndUnlockIntegrationMutexInternalERK17ThreadedAwakeData: __ZN17PersistentManager63RegisterAndAwakeThreadedObjectAndUnlockIntegrationMutexInternalERK17ThreadedAwakeData, __ZN14SafeBinaryRead20TransferTypelessDataEjPvi: __ZN14SafeBinaryRead20TransferTypelessDataEjPvi, __ZN12_GLOBAL__N_110DataStream19addProfileZoneEventEPvPKctb: __ZN12_GLOBAL__N_110DataStream19addProfileZoneEventEPvPKctb, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __Z24RegisterStrippedTypeInfoI7Joint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI7Joint2DEviPKcS2_, _Horizontal_Sweep_Init: _Horizontal_Sweep_Init, _openat: _openat, __Z24IsWebCamDeviceRegisteredRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24IsWebCamDeviceRegisteredRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN13OcclusionArea23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13OcclusionArea23VirtualRedirectTransferER17RemapPPtrTransfer, _wcscat: _wcscat, __ZN14SpriteRenderer18UpdateCachedSpriteEv: __ZN14SpriteRenderer18UpdateCachedSpriteEv, __ZNK10Collider2D13GetBouncinessEv: __ZNK10Collider2D13GetBouncinessEv, __ZN5physx8debugger14PvdMarshallingIjfE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIjfE12marshalBlockEPKhPhj, __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_: __Z12CombineCurveI8Vector3fEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_, __ZN19VREyeTextureManager22ReleaseEyeTextureStageERNS_12TextureStageE: __ZN19VREyeTextureManager22ReleaseEyeTextureStageERNS_12TextureStageE, __Z6StrCmpPKcS0_: __Z6StrCmpPKcS0_, __ZN16b2PrismaticJoint11EnableMotorEb: __ZN16b2PrismaticJoint11EnableMotorEb, __Z50Register_UnityEngine_ConfigurableJoint_get_zMotionv: __Z50Register_UnityEngine_ConfigurableJoint_get_zMotionv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE11getTypeNameEv, __Z21CheckGpuProgramUsable20ShaderGpuProgramType: __Z21CheckGpuProgramUsable20ShaderGpuProgramType, __ZN13BatchRenderer5FlushEv: __ZN13BatchRenderer5FlushEv, __ZNK5Umbra10PortalInfo11getTriangleEiRNS_7Vector3ES2_S2_: __ZNK5Umbra10PortalInfo11getTriangleEiRNS_7Vector3ES2_S2_, __ZNKSt8bad_cast4whatEv: __ZNKSt8bad_cast4whatEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_sidewaysFrictionv: __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_sidewaysFrictionv, __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv: __ZN20TextRenderingPrivate19NativeTextGenerator5SetupEv, __ZNK15SharedLightData24GetFinalShadowResolutionEv: __ZNK15SharedLightData24GetFinalShadowResolutionEv, __ZN21AssetBundleFileSystem30TryUnmountFromGlobalFileSystemEv: __ZN21AssetBundleFileSystem30TryUnmountFromGlobalFileSystemEv, __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN12AspectRatios8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12AspectRatios8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14PhysicsManager19CreatePvdConnectionEv: __ZN14PhysicsManager19CreatePvdConnectionEv, __Z66Register_UnityEngine_ReflectionProbe_get_minBakedCubemapResolutionv: __Z66Register_UnityEngine_ReflectionProbe_get_minBakedCubemapResolutionv, __ZN7Terrain21GetEnlightenProxyMeshEv: __ZN7Terrain21GetEnlightenProxyMeshEv, __ZN10GameObject14CopyPropertiesERS_: __ZN10GameObject14CopyPropertiesERS_, __Z44Register_UnityEngine_RenderTexture_get_depthv: __Z44Register_UnityEngine_RenderTexture_get_depthv, __ZNK13ScreenManager12IsFullScreenEv: __ZNK13ScreenManager12IsFullScreenEv, _rand: _rand, __ZNK8Collider16SupportsMaterialEv: __ZNK8Collider16SupportsMaterialEv, __Z46Register_UnityEngine_Animator_SetIntegerStringv: __Z46Register_UnityEngine_Animator_SetIntegerStringv, __ZNK5physx12NpConstraint9getActorsERPNS_12PxRigidActorES3_: __ZNK5physx12NpConstraint9getActorsERPNS_12PxRigidActorES3_, __ZN8GUILayerC2E10MemLabelId18ObjectCreationMode: __ZN8GUILayerC2E10MemLabelId18ObjectCreationMode, __ZNKSt3__28numpunctIwE16do_decimal_pointEv: __ZNKSt3__28numpunctIwE16do_decimal_pointEv, __Z37Rigidbody2D_Get_Custom_PropFixedAngleP12Il2CppObject: __Z37Rigidbody2D_Get_Custom_PropFixedAngleP12Il2CppObject, __ZN5physx24PxVehicleSetBasisVectorsERKNS_6PxVec3ES2_: __ZN5physx24PxVehicleSetBasisVectorsERKNS_6PxVec3ES2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z60Register_UnityEngine_AsyncOperation_set_allowSceneActivationv: __Z60Register_UnityEngine_AsyncOperation_set_allowSceneActivationv, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN15UnityAdsManager16CheckConsistencyEv: __ZN15UnityAdsManager16CheckConsistencyEv, __ZN9Rigidbody23UpdateInterpolationNodeEv: __ZN9Rigidbody23UpdateInterpolationNodeEv, __Z27CalculateShadowSphereOffsetbf: __Z27CalculateShadowSphereOffsetbf, __ZNSt3__26vectorIhNS_9allocatorIhEEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKhEES7_S7_: __ZNSt3__26vectorIhNS_9allocatorIhEEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueENS_11__wrap_iterIS5_EEE4typeENSB_IPKhEES7_S7_, __Z57Register_UnityEngine_QualitySettings_get_shadowResolutionv: __Z57Register_UnityEngine_QualitySettings_get_shadowResolutionv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z26ConstrainToPolynomialCurveR17AnimationCurveTplIfE: __Z26ConstrainToPolynomialCurveR17AnimationCurveTplIfE, __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E: __Z22PrepareOptimizedPlanesPK5PlaneiPKN4math7_float4E, __Z36GameObject_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i: __Z36GameObject_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i, __ZN11UnityEngine7Connect13ConfigHandler13ConfigChangedERK8UnityStr: __ZN11UnityEngine7Connect13ConfigHandler13ConfigChangedERK8UnityStr, __Z60Register_UnityEngine_ParticleSystem_CollisionModule_GetPlanev: __Z60Register_UnityEngine_ParticleSystem_CollisionModule_GetPlanev, __ZN17UniqueIDGenerator15CreatePureIndexEv: __ZN17UniqueIDGenerator15CreatePureIndexEv, __ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_: __ZN14dense_hash_mapI12TriangleEdgei16TriangleEdgeHashNSt3__28equal_toIS0_EENS2_9allocatorINS2_4pairIKS0_iEEEEEixERS7_, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14PhysicsManager10SetGravityERK8Vector3f: __ZN14PhysicsManager10SetGravityERK8Vector3f, __Z59Register_UnityEngine_GUIStyle_Internal_GetCursorFlashOffsetv: __Z59Register_UnityEngine_GUIStyle_Internal_GetCursorFlashOffsetv, __ZN11UnityEngine9Animation28GenericAnimationBindingCache15DidReloadDomainEv: __ZN11UnityEngine9Animation28GenericAnimationBindingCache15DidReloadDomainEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __Z41Motion_Get_Custom_PropAverageAngularSpeedP12Il2CppObject: __Z41Motion_Get_Custom_PropAverageAngularSpeedP12Il2CppObject, __ZNK5physx30PxShapeMaterialsPropertyHelper12setMaterialsEPNS_7PxShapeEPKPNS_10PxMaterialEt: __ZNK5physx30PxShapeMaterialsPropertyHelper12setMaterialsEPNS_7PxShapeEPKPNS_10PxMaterialEt, __ZN17GenericDynamicVBO19ReserveVertexBufferEjj: __ZN17GenericDynamicVBO19ReserveVertexBufferEjj, __ZN11dtPathQueue5purgeEv: __ZN11dtPathQueue5purgeEv, __ZN6HelperI18StreamedBinaryReadILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI18StreamedBinaryReadILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __Z48InitializeRectTransformAnimationBindingInterfacev: __Z48InitializeRectTransformAnimationBindingInterfacev, __ZN5physx7NpScene8addActorERNS_7PxActorE: __ZN5physx7NpScene8addActorERNS_7PxActorE, __ZN15TerrainCollider22FetchPoseFromTransformEv: __ZN15TerrainCollider22FetchPoseFromTransformEv, __ZNK18BuoyancyEffector2D21DesignedForNonTriggerEv: __ZNK18BuoyancyEffector2D21DesignedForNonTriggerEv, __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim9animation23BlendDirectDataConstantEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim9animation23BlendDirectDataConstantEEEvRT_PKc17TransferMetaFlags, __ZNK6Camera14GetHDRWarningsEv: __ZNK6Camera14GetHDRWarningsEv, __ZNK5physx33PxClothStretchConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEEEEEjT_j: __ZNK5physx33PxClothStretchConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEEEEEjT_j, __Z35setPxHeightFieldGeometryColumnScalePN5physx21PxHeightFieldGeometryEf: __Z35setPxHeightFieldGeometryColumnScalePN5physx21PxHeightFieldGeometryEf, __ZNK12b2MouseJoint17GetReactionTorqueEf: __ZNK12b2MouseJoint17GetReactionTorqueEf, __ZN4FMOD12ChannelGroup9getPausedEPb: __ZN4FMOD12ChannelGroup9getPausedEPb, __ZN4Mesh24UpdateSubMeshVertexRangeEi: __ZN4Mesh24UpdateSubMeshVertexRangeEi, __ZNK5Umbra18ImpOcclusionBuffer15isAARectVisibleERKNS_7Vector2ES3_f: __ZNK5Umbra18ImpOcclusionBuffer15isAARectVisibleERKNS_7Vector2ES3_f, __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags, __ZNKSt3__217moneypunct_bynameIcLb0EE16do_thousands_sepEv: __ZNKSt3__217moneypunct_bynameIcLb0EE16do_thousands_sepEv, __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, _Direct_Move_X: _Direct_Move_X, __ZN10EventEntry6CreateEv: __ZN10EventEntry6CreateEv, __ZN14BoxCast2DQueryD2Ev: __ZN14BoxCast2DQueryD2Ev, __ZNK9Transform18TransformDirectionERK8Vector3f: __ZNK9Transform18TransformDirectionERK8Vector3f, __ZN5physx21PxsBodyTransformVault6updateEv: __ZN5physx21PxsBodyTransformVault6updateEv, __ZNK17ArchiveFileSystem12GetAssetGUIDERK13FileEntryData: __ZNK17ArchiveFileSystem12GetAssetGUIDERK13FileEntryData, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv, __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE16StaticInitializeEPv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj690ES2_NS_23PxVehicleDriveSimDataNWES6_EEKNS_36PxVehicleDriveSimDataNWGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj690ES2_NS_23PxVehicleDriveSimDataNWES6_EEKNS_36PxVehicleDriveSimDataNWGeneratedInfoEEEvPjRKT_RT0_, __ZL29GeomMTDCallback_CapsuleConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL29GeomMTDCallback_CapsuleConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z30setPxClothFabricPhasePhaseTypePN5physx18PxClothFabricPhaseENS_22PxClothFabricPhaseType4EnumE: __Z30setPxClothFabricPhasePhaseTypePN5physx18PxClothFabricPhaseENS_22PxClothFabricPhaseType4EnumE, __Z50Register_UnityEngine_Profiling_Sampler_get_enabledv: __Z50Register_UnityEngine_Profiling_Sampler_get_enabledv, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES6_NS_4lessIS6_EENS4_INS_4pairIKS6_S6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES6_NS_4lessIS6_EENS4_INS_4pairIKS6_S6_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_, __Z23Gradient_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArrayS2_: __Z23Gradient_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArrayS2_, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject, __Z60Register_UnityEngine_SkinnedMeshRenderer_SetBlendShapeWeightv: __Z60Register_UnityEngine_SkinnedMeshRenderer_SetBlendShapeWeightv, __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi: __ZNK10__cxxabiv120__si_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi, __Z39AndroidJNI_CUSTOM_GetStaticBooleanField13Il2Cpp_IntPtrS_: __Z39AndroidJNI_CUSTOM_GetStaticBooleanField13Il2Cpp_IntPtrS_, __ZN4PPtrI15CapsuleColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI15CapsuleColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE8__appendEj, _hypotl: _hypotl, __ZN24RingBufferMemoryFileData9SetLengthEy: __ZN24RingBufferMemoryFileData9SetLengthEy, __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_: __ZN13dynamic_arrayI16NavMeshCarveDataLj4EEC2ERKS1_, _hypotf: _hypotf, __Z21WriteImageAsyncThreadPv: __Z21WriteImageAsyncThreadPv, __ZL16GetInterfaceImpl18UnityInterfaceGUID: __ZL16GetInterfaceImpl18UnityInterfaceGUID, __Z15AngularDistanceRK11QuaternionfS1_: __Z15AngularDistanceRK11QuaternionfS1_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv, _ft_bitmap_glyph_done: _ft_bitmap_glyph_done, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE, __ZN13EmscriptenWWW7GetSizeEv: __ZN13EmscriptenWWW7GetSizeEv, __ZNK17AnimationCurveTplI8Vector3fE9FindIndexERKNS1_5CacheEf: __ZNK17AnimationCurveTplI8Vector3fE9FindIndexERKNS1_5CacheEf, __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_TT_Set_MM_Blend: _UNITY_TT_Set_MM_Blend, __Z44ParticleSystem_TriggerModule_CUSTOM_SetEnterP12Il2CppObjecti: __Z44ParticleSystem_TriggerModule_CUSTOM_SetEnterP12Il2CppObjecti, __ZNK5physx3Cct13BoxController11getPositionEv: __ZNK5physx3Cct13BoxController11getPositionEv, _ialloc: _ialloc, __ZN14PreloadManager35WaitForAllAsyncOperationsToCompleteEv: __ZN14PreloadManager35WaitForAllAsyncOperationsToCompleteEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5physx14NpRigidDynamicC2ERKNS_11PxTransformE: __ZN5physx14NpRigidDynamicC2ERKNS_11PxTransformE, __ZN5physx7NpScene12prepareSolveEfPvj: __ZN5physx7NpScene12prepareSolveEfPvj, __Z27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN8WindZone18ResetDefaultValuesEv: __ZN8WindZone18ResetDefaultValuesEv, __Z14SortGUIByDepthP10GUIElementS0_: __Z14SortGUIByDepthP10GUIElementS0_, __Z37getPxVehicleDriveDynData_UseAutoGearsPKN5physx21PxVehicleDriveDynDataE: __Z37getPxVehicleDriveDynData_UseAutoGearsPKN5physx21PxVehicleDriveDynDataE, __Z44PlatformEffector2D_Set_Custom_PropSurfaceArcP12Il2CppObjectf: __Z44PlatformEffector2D_Set_Custom_PropSurfaceArcP12Il2CppObjectf, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveEOS3_: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveEOS3_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEE14handleAccessorILj122ENS_22PxRepXPropertyAccessorILj122ES4_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEE14handleAccessorILj122ENS_22PxRepXPropertyAccessorILj122ES4_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESC_EEEEvRKT0_, __ZN12CullingGroup29SetDistanceReferenceTransformEPK9Transform: __ZN12CullingGroup29SetDistanceReferenceTransformEPK9Transform, __Z44setPxSimulationStatisticsNbActiveConstraintsPN5physx22PxSimulationStatisticsEj: __Z44setPxSimulationStatisticsNbActiveConstraintsPN5physx22PxSimulationStatisticsEj, __Z33RenderSettings_Set_Custom_PropSunP12Il2CppObject: __Z33RenderSettings_Set_Custom_PropSunP12Il2CppObject, __Z30CanvasRenderer_CUSTOM_GetAlphaP12Il2CppObject: __Z30CanvasRenderer_CUSTOM_GetAlphaP12Il2CppObject, __Z32GetPlayerSettingsRunInBackgroundv: __Z32GetPlayerSettingsRunInBackgroundv, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, _PxCloseExtensions: _PxCloseExtensions, __ZNK20LocalFileSystemPosix21GetAvailableDiskSpaceEPKcRy: __ZNK20LocalFileSystemPosix21GetAvailableDiskSpaceEPKcRy, __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE: __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE7destroyEPNS_11__tree_nodeIiPvEE, __Z43Register_UnityEngine_CubemapArray_GetPixelsv: __Z43Register_UnityEngine_CubemapArray_GetPixelsv, __ZN11ForceModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff: __ZN11ForceModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff, __ZNK9GfxDevice14GetWorldMatrixEv: __ZNK9GfxDevice14GetWorldMatrixEv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNK11Rigidbody2D16GetPointVelocityERK8Vector2f: __ZNK11Rigidbody2D16GetPointVelocityERK8Vector2f, ___string_read: ___string_read, __Z23GetHardwareInfoReporterv: __Z23GetHardwareInfoReporterv, __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetEnabledv: __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetEnabledv, __Z44Renderer_Get_Custom_PropReflectionProbeUsageP12Il2CppObject: __Z44Renderer_Get_Custom_PropReflectionProbeUsageP12Il2CppObject, __Z38HingeJoint2D_Get_Custom_PropJointAngleP12Il2CppObject: __Z38HingeJoint2D_Get_Custom_PropJointAngleP12Il2CppObject, __ZN11SoundHandle13CreateChannelEb: __ZN11SoundHandle13CreateChannelEb, __ZN4FMOD8ChannelID2Ev: __ZN4FMOD8ChannelID2Ev, __ZN22CrashReportingSettings8TransferI14SafeBinaryReadEEvRT_: __ZN22CrashReportingSettings8TransferI14SafeBinaryReadEEvRT_, __Z30CreateBoxedObjectFromPrimitivej: __Z30CreateBoxedObjectFromPrimitivej, __Z30CreateBoxedObjectFromPrimitivei: __Z30CreateBoxedObjectFromPrimitivei, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags, __ZNK8VRDevice19GetGPUTimeLastFrameEv: __ZNK8VRDevice19GetGPUTimeLastFrameEv, __ZN19CharacterController19SetDetectCollisionsEb: __ZN19CharacterController19SetDetectCollisionsEb, __ZN21AssetBundleFileSystem11CreateAsDirER13FileEntryData: __ZN21AssetBundleFileSystem11CreateAsDirER13FileEntryData, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz: __Z16CreateGameObjectRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcz, __Z47Register_UnityEngine_Material_GetColorArrayImplv: __Z47Register_UnityEngine_Material_GetColorArrayImplv, __Z51Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToEulerRadRK11QuaternionfR8Vector3f: __Z51Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToEulerRadRK11QuaternionfR8Vector3f, __Z45Register_UnityEngine_Rigidbody_get_useGravityv: __Z45Register_UnityEngine_Rigidbody_get_useGravityv, __Z27getPxHeightFieldDescSamplesPKN5physx17PxHeightFieldDescE: __Z27getPxHeightFieldDescSamplesPKN5physx17PxHeightFieldDescE, __Z40AudioSource_Get_Custom_PropBypassEffectsP12Il2CppObject: __Z40AudioSource_Get_Custom_PropBypassEffectsP12Il2CppObject, __ZNK22DownloadHandlerTexture11GetProgressEv: __ZNK22DownloadHandlerTexture11GetProgressEv, __ZN6prcoreL11inner_clearILj2EEEvPhjjj: __ZN6prcoreL11inner_clearILj2EEEvPhjjj, __ZN18GfxFramebufferGLES12ApplyScissorEv: __ZN18GfxFramebufferGLES12ApplyScissorEv, __ZN9Scripting36IsSystemCollectionsGenericDictionaryEP11Il2CppClass: __ZN9Scripting36IsSystemCollectionsGenericDictionaryEP11Il2CppClass, __Z50Register_UnityEngine_AudioReverbFilter_set_densityv: __Z50Register_UnityEngine_AudioReverbFilter_set_densityv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE8pushNameEPKc, __ZNK5physx2Sc9ClothCore20getNbCollisionPlanesEv: __ZNK5physx2Sc9ClothCore20getNbCollisionPlanesEv, __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx23PxsBroadPhaseContextSap7getTypeEv: __ZNK5physx23PxsBroadPhaseContextSap7getTypeEv, __ZNK5physx13GuMeshFactory17getNbHeightFieldsEv: __ZNK5physx13GuMeshFactory17getNbHeightFieldsEv, __Z50ParticleRenderer_Set_Custom_PropParticleRenderModeP12Il2CppObject18ParticleRenderMode: __Z50ParticleRenderer_Set_Custom_PropParticleRenderModeP12Il2CppObject18ParticleRenderMode, __ZNK29LineParametersPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK29LineParametersPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __ZN14PhysicsManager7BoxCastERK8Vector3fS2_S2_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction: __ZN14PhysicsManager7BoxCastERK8Vector3fS2_S2_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EOS3_: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EOS3_, __Z40AudioReverbZone_Get_Custom_PropDecayTimeP12Il2CppObject: __Z40AudioReverbZone_Get_Custom_PropDecayTimeP12Il2CppObject, __Z29Transfer_Blittable_ArrayFieldI8JSONRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN20LocalFileSystemPosix8SetFlagsER13FileEntryDatajj: __ZN20LocalFileSystemPosix8SetFlagsER13FileEntryDatajj, ___des_setkey: ___des_setkey, __Z45Register_UnityEngine_Camera_get_targetDisplayv: __Z45Register_UnityEngine_Camera_get_targetDisplayv, __Z34Terrain_Set_Custom_PropTerrainDataP12Il2CppObjectS0_: __Z34Terrain_Set_Custom_PropTerrainDataP12Il2CppObjectS0_, __Z15GetFlareManagerv: __Z15GetFlareManagerv, __ZN7mecanim4hand17Hand2SkeletonPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS0_8HandPoseEPNS4_13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim4hand17Hand2SkeletonPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS0_8HandPoseEPNS4_13SkeletonPoseTIN4math4trsXEEE, __ZN19ComputeShaderKernel8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19ComputeShaderKernel8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Behaviour8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx20PxsParticleSystemSim19getSimParticleDataVERNS_28PxvParticleSystemSimDataDescEb: __ZNK5physx20PxsParticleSystemSim19getSimParticleDataVERNS_28PxvParticleSystemSimDataDescEb, __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED2Ev, __ZN11OffMeshLink23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11OffMeshLink23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, ___toread: ___toread, __ZN19CloudServiceHandler10QueueEventEPN11UnityEngine15CloudWebService14CloudEventInfoE: __ZN19CloudServiceHandler10QueueEventEPN11UnityEngine15CloudWebService14CloudEventInfoE, __Z29ConvertDXT5nmNormalMapToPlainPhi: __Z29ConvertDXT5nmNormalMapToPlainPhi, ___cxa_is_pointer_type: ___cxa_is_pointer_type, __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES: __ZN4gles20DestroyRenderSurfaceEP7ApiGLESP17RenderSurfaceGLES, __ZNK23ParticleSystemParticles14ReadCustomDataEPN4math14float4_storageEii: __ZNK23ParticleSystemParticles14ReadCustomDataEPN4math14float4_storageEii, __ZNK8VRDevice14GetDeviceModelEv: __ZNK8VRDevice14GetDeviceModelEv, __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb: __ZN5physx3Scb9Aggregate11removeActorERNS0_5ActorEb, __ZN17MessageIdentifier13StaticDestroyEPv: __ZN17MessageIdentifier13StaticDestroyEPv, __Z34Transform_CUSTOM_SetAsFirstSiblingP12Il2CppObject: __Z34Transform_CUSTOM_SetAsFirstSiblingP12Il2CppObject, __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_ScaleD0Ev: __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_ScaleD0Ev, __ZNK18ProceduralMaterial19GetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial19GetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx3Cct17CapsuleController16setContactOffsetEf: __ZN5physx3Cct17CapsuleController16setContactOffsetEf, _iswxdigit_l: _iswxdigit_l, __ZN5Unity5Cloth5ResetEv: __ZN5Unity5Cloth5ResetEv, __ZN15ConstantForce2D9SetTorqueEf: __ZN15ConstantForce2D9SetTorqueEf, __ZN5physx35PxSimulationStatisticsGeneratedInfoC2Ev: __ZN5physx35PxSimulationStatisticsGeneratedInfoC2Ev, __ZN13BitSetUtility7SetBitsEPjjjb: __ZN13BitSetUtility7SetBitsEPjjjb, __ZN17PersistentManager40GlobalToLocalSerializedFileIndexInternalERK26SerializedObjectIdentifier: __ZN17PersistentManager40GlobalToLocalSerializedFileIndexInternalERK26SerializedObjectIdentifier, __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, __ZN12_GLOBAL__N_117EventBufferClient6addRefEv: __ZN12_GLOBAL__N_117EventBufferClient6addRefEv, __Z62Register_UnityEngine_CharacterController_INTERNAL_get_velocityv: __Z62Register_UnityEngine_CharacterController_INTERNAL_get_velocityv, __ZN12GeomQueryAnyIN5physx10PxSweepHitEE7geomHitERKNS0_2Sq17SceneQueryManagerERKNS0_15MultiQueryInputERKNS3_9ShapeDataERKNS0_10PxGeometryERKNS0_11PxTransformENS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEjPS1_fbPNS0_9PxBounds3E: __ZN12GeomQueryAnyIN5physx10PxSweepHitEE7geomHitERKNS0_2Sq17SceneQueryManagerERKNS0_15MultiQueryInputERKNS3_9ShapeDataERKNS0_10PxGeometryERKNS0_11PxTransformENS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEjPS1_fbPNS0_9PxBounds3E, __ZN13TranslateGLES4InitERK12GraphicsCaps16GfxDeviceLevelGL: __ZN13TranslateGLES4InitERK12GraphicsCaps16GfxDeviceLevelGL, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_: __ZN13dynamic_arrayI21TreePrototypeColliderLj4EEC2ERKS1_, __ZN43CapsuleHeightfieldContactGenerationCallback7onEventEjPj: __ZN43CapsuleHeightfieldContactGenerationCallback7onEventEjPj, __ZThn4_N12MemoryStream4readEPvj: __ZThn4_N12MemoryStream4readEPvj, __ZN5physx3Ext19ProfileEventHandler19onCUDAProfileBufferEyfPKhjj: __ZN5physx3Ext19ProfileEventHandler19onCUDAProfileBufferEyfPKhjj, __ZNSt3__211__libcpp_db11__insert_icEPvPKv: __ZNSt3__211__libcpp_db11__insert_icEPvPKv, __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_, __ZZ23InitPlayerLoopCallbacksvEN33PostLateUpdateInputEndFramestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN33PostLateUpdateInputEndFramestruct7ForwardEv, __Z32CustomEventData_CUSTOM_AddUInt32P12Il2CppObjectP12Il2CppStringj: __Z32CustomEventData_CUSTOM_AddUInt32P12Il2CppObjectP12Il2CppStringj, __ZN5Umbra17BasePoolAllocator12allocatePageEv: __ZN5Umbra17BasePoolAllocator12allocatePageEv, __ZN4FMOD8ChannelI17get3DDopplerLevelEPf: __ZN4FMOD8ChannelI17get3DDopplerLevelEPf, _bcopy: _bcopy, __Z45Register_UnityEngine_BillboardAsset_get_widthv: __Z45Register_UnityEngine_BillboardAsset_get_widthv, __ZN24RingBufferMemoryFileDataD0Ev: __ZN24RingBufferMemoryFileDataD0Ev, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj, __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_set_relativeForcev: __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_set_relativeForcev, __ZN6b2Rope8SetAngleEf: __ZN6b2Rope8SetAngleEf, __ZN10TagManager20GetSortingLayerCountEv: __ZN10TagManager20GetSortingLayerCountEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE6createERKS5_Rb, __ZN14EdgeCollider2D15TransformPointsERK10Matrix4x4fP6b2Vec2: __ZN14EdgeCollider2D15TransformPointsERK10Matrix4x4fP6b2Vec2, __ZN5physx28solveFrictionCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx28solveFrictionCoulombPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN8Animator24GetRightFeetBottomHeightEv: __ZN8Animator24GetRightFeetBottomHeightEv, __ZN9Animation8GetStateEP13AnimationClip: __ZN9Animation8GetStateEP13AnimationClip, __Z63ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterPropertiesP12Il2CppObjecti: __Z63ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterPropertiesP12Il2CppObjecti, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj526ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5flushEv, __ZN5Umbra5Query4initEPKNS_4TomeE: __ZN5Umbra5Query4initEPKNS_4TomeE, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12CubemapArray23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12CubemapArray23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN16BaseVideoTexture17UploadTextureDataEv: __ZN16BaseVideoTexture17UploadTextureDataEv, __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL27GetComponentsImplementationILb0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN26SharedLightmapSettingsDataD2Ev: __ZN26SharedLightmapSettingsDataD2Ev, __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDsc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDsc11__mbstate_tEEEEvPT_, __Z26Material_CUSTOM_SetTextureP12Il2CppObjectiS0_: __Z26Material_CUSTOM_SetTextureP12Il2CppObjectiS0_, __ZN12MeshRenderer19DidModifyMeshBoundsEv: __ZN12MeshRenderer19DidModifyMeshBoundsEv, __Z18BuildScriptClassIdP11Il2CppClass: __Z18BuildScriptClassIdP11Il2CppClass, __ZN14InputInterfaceD0Ev: __ZN14InputInterfaceD0Ev, __ZN5physx12NpConstraint12actorDeletedEPNS_12PxRigidActorE: __ZN5physx12NpConstraint12actorDeletedEPNS_12PxRigidActorE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags, __Z69Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetRelativePointVelocityv: __Z69Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetRelativePointVelocityv, __ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i: __ZL16ReadTypeTreeImplILb0EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i, __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv: __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEppEv, __ZN25RuntimeAnimatorControllerD2Ev: __ZN25RuntimeAnimatorControllerD2Ev, __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14SoftJointLimit8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN8LODGroup13AwakeFromLoadE17AwakeFromLoadMode: __ZN8LODGroup13AwakeFromLoadE17AwakeFromLoadMode, __ZN9ShaderLab7ProgramD0Ev: __ZN9ShaderLab7ProgramD0Ev, __ZN12WheelJoint2D15ThreadedCleanupEv: __ZN12WheelJoint2D15ThreadedCleanupEv, __ZN5physx2Sc8ShapeSim18reinsertBroadPhaseEv: __ZN5physx2Sc8ShapeSim18reinsertBroadPhaseEv, __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi: __ZN5Umbra20RuntimeTomeGenerator13findNeighborsERNS_5ArrayIiEERNS_6KDTreeEiRKNS_4AABBEi, __ZN10Effector2D5ResetEv: __ZN10Effector2D5ResetEv, __ZN5physx2Sc5Scene11removeShapeERNS0_8ShapeSimEb: __ZN5physx2Sc5Scene11removeShapeERNS0_8ShapeSimEb, _jpeg_write_m_header: _jpeg_write_m_header, __ZN28LightProbeProxyVolumeContext8CopyFromERKS_: __ZN28LightProbeProxyVolumeContext8CopyFromERKS_, __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy: __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedER18TransformHierarchy, __ZN18DeferredRenderLoop15RenderFinalPassEP13RenderTextureS1_: __ZN18DeferredRenderLoop15RenderFinalPassEP13RenderTextureS1_, __ZN13WheelCollider18SetForwardFrictionERK18WheelFrictionCurve: __ZN13WheelCollider18SetForwardFrictionERK18WheelFrictionCurve, __Z48Register_UnityEngine_RenderTexture_get_useMipMapv: __Z48Register_UnityEngine_RenderTexture_get_useMipMapv, __ZN7ApiGLES18DeleteRenderbufferERj: __ZN7ApiGLES18DeleteRenderbufferERj, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEE15growAndPushBackERKS2_, __ZN4FMOD8ChannelI15getCurrentSoundEPPNS_5SoundE: __ZN4FMOD8ChannelI15getCurrentSoundEPPNS_5SoundE, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewShortArrayiRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewShortArrayiRPv, __ZNK26AnimatorControllerPlayable20GetStateMachineMixerEi: __ZNK26AnimatorControllerPlayable20GetStateMachineMixerEi, __ZN5physx14SingleAABBTaskC2Ev: __ZN5physx14SingleAABBTaskC2Ev, __ZNSt3__215numpunct_bynameIwED0Ev: __ZNSt3__215numpunct_bynameIwED0Ev, __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI14SafeBinaryReadEEvRT_, __ZN10Effector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10Effector2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __Z45Register_UnityEngine_CubemapArray_SetPixels32v: __Z45Register_UnityEngine_CubemapArray_SetPixels32v, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6snextcEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6snextcEv, _UNITY_png_get_gAMA_fixed: _UNITY_png_get_gAMA_fixed, _InitUNetUpdateFunction: _InitUNetUpdateFunction, __Z29StdTemplateConversionFunctionIatEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIatEbPvR14SafeBinaryRead, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13setBreakForceEff, __ZN13RenderTexture7ReleaseEv: __ZN13RenderTexture7ReleaseEv, __ZN5physx22XmlMemoryAllocatorImpl10deallocateEPh: __ZN5physx22XmlMemoryAllocatorImpl10deallocateEPh, __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXLimitSpringv: __Z71Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXLimitSpringv, __ZN11OffMeshLink23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11OffMeshLink23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN10MeshFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN10MeshFilter23VirtualRedirectTransferER14SafeBinaryRead, __Z40Terrain_Set_Custom_PropEditorRenderFlagsP12Il2CppObjectN7Terrain11RenderFlagsE: __Z40Terrain_Set_Custom_PropEditorRenderFlagsP12Il2CppObjectN7Terrain11RenderFlagsE, __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E: __ZNK5physx2Cm23FastVertex2ShapeScaling20transformQueryBoundsERNS_6PxVec3ES3_RNS_7PxMat33E, __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalMatrixv: __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalMatrixv, __ZN19ControllerHitReport13onObstacleHitERKN5physx23PxControllerObstacleHitE: __ZN19ControllerHitReport13onObstacleHitERKN5physx23PxControllerObstacleHitE, __ZN4FMOD13ChannelGroupI11getUserDataEPPv: __ZN4FMOD13ChannelGroupI11getUserDataEPPv, __ZN22CreateGpuProgramOutput12CreateParamsEv: __ZN22CreateGpuProgramOutput12CreateParamsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj460ENS_22PxRepXPropertyAccessorILj460ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj460ENS_22PxRepXPropertyAccessorILj460ES4_ffEEEEvRKT0_, __ZN17InternalIndexPool11freeIndicesEv: __ZN17InternalIndexPool11freeIndicesEv, __ZNK5physx18NpArticulationLink11getChildrenEPPNS_18PxArticulationLinkEj: __ZNK5physx18NpArticulationLink11getChildrenEPPNS_18PxArticulationLinkEj, __ZNKSt3__220__codecvt_utf8_utf16IDiE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__220__codecvt_utf8_utf16IDiE9do_lengthER11__mbstate_tPKcS5_j, __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK14GfxContextGLES13GetDefaultFBOEv: __ZNK14GfxContextGLES13GetDefaultFBOEv, __ZN5physx3Scb14ParticleSystem18submitForceUpdatesEf: __ZN5physx3Scb14ParticleSystem18submitForceUpdatesEf, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12getClassSizeEv, __ZNK13ConstantForce26GetTypeInfoVirtualInternalEv: __ZNK13ConstantForce26GetTypeInfoVirtualInternalEv, __ZN18GfxFramebufferGLES31FallbackToValidFramebufferStateEv: __ZN18GfxFramebufferGLES31FallbackToValidFramebufferStateEv, __Z57ParticleSystem_LightsModule_CUSTOM_SetIntensityMultiplierP12Il2CppObjectf: __Z57ParticleSystem_LightsModule_CUSTOM_SetIntensityMultiplierP12Il2CppObjectf, __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z53Register_UnityEngine_GameObject_get_isStaticBatchablev: __Z53Register_UnityEngine_GameObject_get_isStaticBatchablev, __ZThn24_N5physx2Sc16ActorInteractionD1Ev: __ZThn24_N5physx2Sc16ActorInteractionD1Ev, __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve: __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve, __Z15atomIntegrationfPKPN5physx11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPS9_RjSH_: __Z15atomIntegrationfPKPN5physx11PxsBodyCoreEPKPNS_12PxsRigidBodyEjPKNS_2Cm13SpatialVectorEPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEPS9_RjSH_, __Z46QualitySettings_Set_Custom_PropMaximumLODLeveli: __Z46QualitySettings_Set_Custom_PropMaximumLODLeveli, __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_centerv: __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_centerv, __ZN5physx13NpRigidStatic11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx13NpRigidStatic11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags, __Z32Random_CUSTOM_INTERNAL_get_stateP9RandState: __Z32Random_CUSTOM_INTERNAL_get_stateP9RandState, __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_: __ZNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEixERS9_, __ZNSt3__29to_stringEi: __ZNSt3__29to_stringEi, __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb: __ZN5physx11NpAggregate22removeActorAndReinsertERNS_7PxActorEb, __ZNSt3__29to_stringEj: __ZNSt3__29to_stringEj, __ZNSt3__29to_stringEm: __ZNSt3__29to_stringEm, __ZNSt3__29to_stringEl: __ZNSt3__29to_stringEl, __ZN17AnimationCurveTplIfE15InvalidateCacheEv: __ZN17AnimationCurveTplIfE15InvalidateCacheEv, __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb: __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local9FloodFillES3_PKNS0_11AdjTriangleEjPb, __ZNSt3__29to_stringEe: __ZNSt3__29to_stringEe, __ZNSt3__29to_stringEd: __ZNSt3__29to_stringEd, __ZNSt3__29to_stringEf: __ZNSt3__29to_stringEf, __ZNSt3__29to_stringEy: __ZNSt3__29to_stringEy, __ZNSt3__29to_stringEx: __ZNSt3__29to_stringEx, __Z47Texture2D_CUSTOM_INTERNAL_CALL_GetPixelBilinearP12Il2CppObjectffR10ColorRGBAf: __Z47Texture2D_CUSTOM_INTERNAL_CALL_GetPixelBilinearP12Il2CppObjectffR10ColorRGBAf, __Z46Physics_Set_Custom_PropDefaultSolverIterationsi: __Z46Physics_Set_Custom_PropDefaultSolverIterationsi, __ZL28RegisterModuleICalls_Physicsv: __ZL28RegisterModuleICalls_Physicsv, __ZN8Animator19GetPerformanceHintsEv: __ZN8Animator19GetPerformanceHintsEv, __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE8__appendEj, __ZN4FMOD6SoundI12setLoopCountEi: __ZN4FMOD6SoundI12setLoopCountEi, __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z15tessGetElementsP14TESStesselator: __Z15tessGetElementsP14TESStesselator, __ZN11HaloManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData: __ZN11HaloManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData, __ZNK8VRDevice38GetProjectionMatrixWithClippingOffsetsEPK6Camera21MonoOrStereoscopicEyeffR10Matrix4x4f: __ZNK8VRDevice38GetProjectionMatrixWithClippingOffsetsEPK6Camera21MonoOrStereoscopicEyeffR10Matrix4x4f, __Z35RegisterModuleClasses_TextRenderingv: __Z35RegisterModuleClasses_TextRenderingv, __ZN5physx14NpArticulation26setMaxProjectionIterationsEj: __ZN5physx14NpArticulation26setMaxProjectionIterationsEj, __ZN5physx3Cct15ObstacleContext14removeObstacleEj: __ZN5physx3Cct15ObstacleContext14removeObstacleEj, __Z49Register_UnityEngine_Physics2D_get_baumgarteScalev: __Z49Register_UnityEngine_Physics2D_get_baumgarteScalev, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7pubsyncEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7pubsyncEv, __ZN17Physics2DSettings22SetAlwaysShowCollidersEb: __ZN17Physics2DSettings22SetAlwaysShowCollidersEb, __ZN7mecanim12statemachine24CreateStateMachineMemoryEPKNS0_20StateMachineConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine24CreateStateMachineMemoryEPKNS0_20StateMachineConstantERNS_6memory9AllocatorE, __ZN9GfxDevice18SetGlobalDepthBiasEff: __ZN9GfxDevice18SetGlobalDepthBiasEff, __ZN4PPtrI12MeshRendererE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI12MeshRendererE8TransferI14SafeBinaryReadEEvRT_, __ZN15CapsuleCollider9SetCenterERK8Vector3f: __ZN15CapsuleCollider9SetCenterERK8Vector3f, __ZNK13MonoBehaviour23IsStateMachineBehaviourEv: __ZNK13MonoBehaviour23IsStateMachineBehaviourEv, __Z32setPxArticulation_SleepThresholdPN5physx14PxArticulationEf: __Z32setPxArticulation_SleepThresholdPN5physx14PxArticulationEf, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE13getActorFlagsEv, __Z56Register_UnityEngine_ParticleSystem_ShapeModule_GetAnglev: __Z56Register_UnityEngine_ParticleSystem_ShapeModule_GetAnglev, __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb: __ZN5physx24updateCellsSubpacketPairENS_16PxsSphUpdateTypeEPNS_6PxVec3ES2_PNS_16PxsFluidParticleES4_PKNS_15PxsParticleCellES7_PKjS9_jjbRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersEb, __ZN8Animator22ApplyBuiltinRootMotionEv: __ZN8Animator22ApplyBuiltinRootMotionEv, __ZN4FMOD8ChannelI19get3DMinMaxDistanceEPfS1_: __ZN4FMOD8ChannelI19get3DMinMaxDistanceEPfS1_, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj, __ZN5physx5cloth21IterationStateFactoryC2INS0_7SwClothEEERT_f: __ZN5physx5cloth21IterationStateFactoryC2INS0_7SwClothEEERT_f, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm, __ZN7ApiGLES26BindDispatchIndirectBufferEj: __ZN7ApiGLES26BindDispatchIndirectBufferEj, __ZN5physx2Sc5ActorC2ERNS0_16InteractionSceneEhNS0_14IslandNodeInfo4TypeE: __ZN5physx2Sc5ActorC2ERNS0_16InteractionSceneEhNS0_14IslandNodeInfo4TypeE, __ZNK14AreaEffector2D16UseContactUpdateEv: __ZNK14AreaEffector2D16UseContactUpdateEv, __ZN15ParticleEmitter20UpdateParticleSystemEf: __ZN15ParticleEmitter20UpdateParticleSystemEf, __Z25getNbPxArticulation_LinksPKN5physx14PxArticulationE: __Z25getNbPxArticulation_LinksPKN5physx14PxArticulationE, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE, __ZN19VREyeTextureManager16SetRenderSurfaceEP17RenderSurfaceBasePiS2_Pb: __ZN19VREyeTextureManager16SetRenderSurfaceEP17RenderSurfaceBasePiS2_Pb, __ZN5physx22PxVehicleTelemetryData5setupEffffPKfS2_RKNS_6PxVec3ES5_S5_: __ZN5physx22PxVehicleTelemetryData5setupEffffPKfS2_RKNS_6PxVec3ES5_S5_, __ZN8Renderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN8Renderer23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __ZN5physx2Sc9ClothCore16setRestPositionsEPKNS_6PxVec4E: __ZN5physx2Sc9ClothCore16setRestPositionsEPKNS_6PxVec4E, __Z40setPxVehicleDifferential4WDataMFrontBiasPN5physx27PxVehicleDifferential4WDataEf: __Z40setPxVehicleDifferential4WDataMFrontBiasPN5physx27PxVehicleDifferential4WDataEf, __ZN5IMGUI14GUIWindowStateD2Ev: __ZN5IMGUI14GUIWindowStateD2Ev, __ZL13MotionHandleriPK27EmscriptenDeviceMotionEventPv: __ZL13MotionHandleriPK27EmscriptenDeviceMotionEventPv, __ZN18AudioMixerSnapshot8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18AudioMixerSnapshot8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Umbra9RasterOps8fillOnesERNS_17BlockRasterBufferE: __ZN5Umbra9RasterOps8fillOnesERNS_17BlockRasterBufferE, __ZN8Renderer10SetVisibleEb: __ZN8Renderer10SetVisibleEb, __ZN12AudioManager5ResetEv: __ZN12AudioManager5ResetEv, __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN5physx18RepXSerializerImplINS_7PxClothEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_7PxClothEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE11getTypeNameEv, __Z14SecondsBetweenRK8DateTimeS1_: __Z14SecondsBetweenRK8DateTimeS1_, __ZN19CloudServiceHandler20PauseEventDispatcherEv: __ZN19CloudServiceHandler20PauseEventDispatcherEv, __ZN7mecanim5human18HumanPoseBlendNodeERNS0_9HumanPoseEPS1_f: __ZN7mecanim5human18HumanPoseBlendNodeERNS0_9HumanPoseEPS1_f, _UNITY_FT_RoundFix: _UNITY_FT_RoundFix, __ZN9ShaderLab20SerializedSubProgram15AddTextureParamEPKcii16TextureDimension: __ZN9ShaderLab20SerializedSubProgram15AddTextureParamEPKcii16TextureDimension, __ZNK8Animator26GetTypeInfoVirtualInternalEv: __ZNK8Animator26GetTypeInfoVirtualInternalEv, __ZN23CloudWebServicesManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN23CloudWebServicesManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt12experimental19bad_optional_accessD2Ev: __ZNSt12experimental19bad_optional_accessD2Ev, __Z52Register_UnityEngine_AndroidJNI_SetFloatArrayElementv: __Z52Register_UnityEngine_AndroidJNI_SetFloatArrayElementv, __ZN5physx2Sc18ParticleSystemCore12setStiffnessEf: __ZN5physx2Sc18ParticleSystemCore12setStiffnessEf, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI24ConvexVsHeightfieldSweepLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI24ConvexVsHeightfieldSweepLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_, __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z23AppendPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZNK14ParticleSystem15AddNewParticlesER23ParticleSystemParticlesRjPj: __ZNK14ParticleSystem15AddNewParticlesER23ParticleSystemParticlesRjPj, __ZNK5physx12PxConvexMesh19getConcreteTypeNameEv: __ZNK5physx12PxConvexMesh19getConcreteTypeNameEv, __ZNSt3__28__c_node5__addEPNS_8__i_nodeE: __ZNSt3__28__c_node5__addEPNS_8__i_nodeE, __ZN17ProceduralTexture18UploadBakedTextureEv: __ZN17ProceduralTexture18UploadBakedTextureEv, __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci: __Z15malloc_internaljjRK10MemLabelId15AllocateOptionsPKci, __Z32SetPlayerSettingsRunInBackgroundb: __Z32SetPlayerSettingsRunInBackgroundb, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj, __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE16GetDownloadBytesEv: __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE16GetDownloadBytesEv, __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4FMOD6System17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER: __ZN4FMOD6System17setSoftwareFormatEi17FMOD_SOUND_FORMATii18FMOD_DSP_RESAMPLER, __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb: __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb, __ZN5physx18AdjacenciesBuilderC2Ev: __ZN5physx18AdjacenciesBuilderC2Ev, __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE: __ZN5physx2Sc13ShapeIterator4initERKNS0_8ActorSimE, __ZNK20LightPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK20LightPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __Z31setPxVehicleAutoBoxData_LatencyPN5physx20PxVehicleAutoBoxDataEf: __Z31setPxVehicleAutoBoxData_LatencyPN5physx20PxVehicleAutoBoxDataEf, __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi: __ZN2UI6Canvas27UpdateEventIndexesRecursiveERi, __ZN7mecanim9animation18EvaluateRootMotionERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfS8_RNS0_12MotionOutputEb: __ZN7mecanim9animation18EvaluateRootMotionERKNS0_18ClipMuscleConstantERKNS0_15ClipMuscleInputEPKfS8_RNS0_12MotionOutputEb, _UNITY_FT_Outline_New: _UNITY_FT_Outline_New, __Z54Register_UnityEngine_AndroidJNI_SetBooleanArrayElementv: __Z54Register_UnityEngine_AndroidJNI_SetBooleanArrayElementv, __ZN16UploadHandlerRaw13TransmitBytesEPvjj: __ZN16UploadHandlerRaw13TransmitBytesEPvjj, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z59Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimev: __Z59Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimev, __ZN17ProceduralTexture8SetOwnerEP18ProceduralMaterial: __ZN17ProceduralTexture8SetOwnerEP18ProceduralMaterial, _fegetround: _fegetround, __ZN5physx46solveTankInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPKbPKfPNS_20ImplicitSolverOutputE: __ZN5physx46solveTankInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPKbPKfPNS_20ImplicitSolverOutputE, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx14NpArticulationC2Ev: __ZN5physx14NpArticulationC2Ev, __ZNK19VREyeTextureManager21GetUnityTextureFormatEv: __ZNK19VREyeTextureManager21GetUnityTextureFormatEv, __ZN13WebCamTexture7CleanupEv: __ZN13WebCamTexture7CleanupEv, __ZNK13ScreenManager12GetIsFocusedEv: __ZNK13ScreenManager12GetIsFocusedEv, __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToBooleanArrayv: __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToBooleanArrayv, __ZN13UnityProfiler24BeginFrameSeparateThreadE12ProfilerMode: __ZN13UnityProfiler24BeginFrameSeparateThreadE12ProfilerMode, __Z18HumanLimitFromMonoRK14MonoHumanLimitR17SkeletonBoneLimit: __Z18HumanLimitFromMonoRK14MonoHumanLimitR17SkeletonBoneLimit, __ZN14DLHAudioHelper17UnlockPartialDataEv: __ZN14DLHAudioHelper17UnlockPartialDataEv, __Z50GUIStyle_CUSTOM_GetFontInternalDuringLoadingThreadP12Il2CppObject: __Z50GUIStyle_CUSTOM_GetFontInternalDuringLoadingThreadP12Il2CppObject, __ZN22ParticleSystemRenderer16UpdateCachedMeshEv: __ZN22ParticleSystemRenderer16UpdateCachedMeshEv, __ZN5physx19NpArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx19NpArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetEnabledv: __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetEnabledv, __ZN18PlatformEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE: __ZN18PlatformEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE, __ZN12LightsModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12LightsModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z32getPxParticleBase_StaticFrictionPKN5physx14PxParticleBaseE: __Z32getPxParticleBase_StaticFrictionPKN5physx14PxParticleBaseE, __Z37SpringJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf: __Z37SpringJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf, __Z28getPxRigidDynamic_IsSleepingPKN5physx14PxRigidDynamicE: __Z28getPxRigidDynamic_IsSleepingPKN5physx14PxRigidDynamicE, __ZN4FMOD13ChannelGroupI8getGroupEiPPNS_12ChannelGroupE: __ZN4FMOD13ChannelGroupI8getGroupEiPPNS_12ChannelGroupE, __ZNSt3__28ios_base34__set_failbit_and_consider_rethrowEv: __ZNSt3__28ios_base34__set_failbit_and_consider_rethrowEv, __Z35Renderer_Set_Custom_PropProbeAnchorP12Il2CppObjectS0_: __Z35Renderer_Set_Custom_PropProbeAnchorP12Il2CppObjectS0_, __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEED2Ev: __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEED2Ev, __ZNK12CubemapArray20GetRuntimeMemorySizeEv: __ZNK12CubemapArray20GetRuntimeMemorySizeEv, __Z58Register_UnityEngine_AI_NavMeshAgent_set_avoidancePriorityv: __Z58Register_UnityEngine_AI_NavMeshAgent_set_avoidancePriorityv, __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j: __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j, __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE: __ZN5physx2Sc18ParticleSystemCore18setProjectionPlaneERKNS_7PxPlaneE, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab18SerializedPropertyENS0_9allocatorIS3_EEEEEvRT_j, __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_PS2_RNS3_18ImpulseAccumulatorE: __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_PS2_RNS3_18ImpulseAccumulatorE, __ZNK8Animator18GetControllerInputEv: __ZNK8Animator18GetControllerInputEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7sungetcEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7sungetcEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_, __ZN14DetailDatabase15ValidateDetailsEv: __ZN14DetailDatabase15ValidateDetailsEv, _fdiml: _fdiml, __ZN10VertexData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10VertexData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv: __ZN19SkinnedMeshRenderer16UpdateCachedMeshEv, __ZN5physx20PxcContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx20PxcContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, _fdimf: _fdimf, __Z19SetIClusterRendererP16IClusterRenderer: __Z19SetIClusterRendererP16IClusterRenderer, __Z51AudioLowPassFilter_Set_Custom_PropLowpassResonanceQP12Il2CppObjectf: __Z51AudioLowPassFilter_Set_Custom_PropLowpassResonanceQP12Il2CppObjectf, __Z31getPxVehicleEngineDataMMaxOmegaPKN5physx19PxVehicleEngineDataE: __Z31getPxVehicleEngineDataMMaxOmegaPKN5physx19PxVehicleEngineDataE, __ZN5physx2Sn18RepXCollectionImpl11saveXmlNodeEPNS0_7XmlNodeERNS0_15SimpleXmlWriterE: __ZN5physx2Sn18RepXCollectionImpl11saveXmlNodeEPNS0_7XmlNodeERNS0_15SimpleXmlWriterE, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE19getConcreteTypeNameEv, __ZN14ParticleSystem13GetRootSystemEv: __ZN14ParticleSystem13GetRootSystemEv, __Z42MaterialPropertyBlock_CUSTOM_GetFloatArrayP12Il2CppObjecti: __Z42MaterialPropertyBlock_CUSTOM_GetFloatArrayP12Il2CppObjecti, __ZN8Playable28BeginIgnoreAllocationTrackerEv: __ZN8Playable28BeginIgnoreAllocationTrackerEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z42ParticleEmitter_Get_Custom_PropRndRotationP12Il2CppObject: __Z42ParticleEmitter_Get_Custom_PropRndRotationP12Il2CppObject, __Z48Register_UnityEngine_Rigidbody_set_interpolationv: __Z48Register_UnityEngine_Rigidbody_set_interpolationv, __ZN5physx3Scb5ClothD2Ev: __ZN5physx3Scb5ClothD2Ev, __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZZN14ParticleSystem15InitializeClassEvEN16cleanupAfterLoad7ForwardEv: __ZZN14ParticleSystem15InitializeClassEvEN16cleanupAfterLoad7ForwardEv, __ZN5physx7NpScene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE: __ZN5physx7NpScene21setDominanceGroupPairEhhRKNS_20PxDominanceGroupPairE, __ZN4FMOD7SystemI17get3DNumListenersEPi: __ZN4FMOD7SystemI17get3DNumListenersEPi, __Z40Register_UnityEngine_Texture2D_SetPixelsv: __Z40Register_UnityEngine_Texture2D_SetPixelsv, __Z40GetTemporaryCachePathApplicationSpecificv: __Z40GetTemporaryCachePathApplicationSpecificv, __ZN9GfxDevice16EndAsyncJobFrameEv: __ZN9GfxDevice16EndAsyncJobFrameEv, __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIP9TransformbEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZNKSt3__27codecvtIcc11__mbstate_tE11do_encodingEv: __ZNKSt3__27codecvtIcc11__mbstate_tE11do_encodingEv, _UNITY_tt_face_load_hhea: _UNITY_tt_face_load_hhea, __ZN24RingBufferMemoryFileData11SetGrowableEb: __ZN24RingBufferMemoryFileData11SetGrowableEb, __ZN5physx14PxRigidBodyExt27computeLinearAngularImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_: __ZN5physx14PxRigidBodyExt27computeLinearAngularImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE7getNameEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE7getNameEv, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPKv, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh, __ZN9GfxDevice15GetNextCPUFenceEv: __ZN9GfxDevice15GetNextCPUFenceEv, __Z55Register_UnityEngine_GUIClip_INTERNAL_CALL_Clip_Vector2v: __Z55Register_UnityEngine_GUIClip_INTERNAL_CALL_Clip_Vector2v, __Z37ConstantForce2D_Set_Custom_PropTorqueP12Il2CppObjectf: __Z37ConstantForce2D_Set_Custom_PropTorqueP12Il2CppObjectf, __ZN14AreaEffector2D8TransferI14SafeBinaryReadEEvRT_: __ZN14AreaEffector2D8TransferI14SafeBinaryReadEEvRT_, __Z16BuildLineSegmentjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_11ColorRGBA32: __Z16BuildLineSegmentjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfSA_11ColorRGBA32, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale0Ef, __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_: __ZNSt3__26__sortIR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_, __Z48Register_UnityEngine_DynamicGI_UpdateEnvironmentv: __Z48Register_UnityEngine_DynamicGI_UpdateEnvironmentv, __Z37AudioEchoFilter_Get_Custom_PropDryMixP12Il2CppObject: __Z37AudioEchoFilter_Get_Custom_PropDryMixP12Il2CppObject, __ZN5physx19NpArticulationJoint13setParentPoseERKNS_11PxTransformE: __ZN5physx19NpArticulationJoint13setParentPoseERKNS_11PxTransformE, __Z26GetScriptClassIdComponentsRK8UnityStrRS_S2_S2_: __Z26GetScriptClassIdComponentsRK8UnityStrRS_S2_S2_, __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb0EEEEvRT_, __ZNK20LocalFileSystemPosix6ExistsERK13FileEntryData: __ZNK20LocalFileSystemPosix6ExistsERK13FileEntryData, __ZN5physx15PxsParticleData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx15PxsParticleData17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK2UI13RectTransform19GetDrivenPropertiesEv: __ZNK2UI13RectTransform19GetDrivenPropertiesEv, __ZN5physx35NpArticulationJointGetBodiesFromScbERNS_3Scb17ArticulationJointERPNS0_4BodyES5_: __ZN5physx35NpArticulationJointGetBodiesFromScbERNS_3Scb17ArticulationJointERPNS0_4BodyES5_, __ZNK5physx2Sc15ClothFabricCore16getTetherLengthsEPfj: __ZNK5physx2Sc15ClothFabricCore16getTetherLengthsEPfj, __ZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPv: __ZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPv, __Z50Register_UnityEngine_BillboardAsset_get_indexCountv: __Z50Register_UnityEngine_BillboardAsset_get_indexCountv, __ZN8VRDevice33VRNodeToTrackedNodeNameDeprecatedEi: __ZN8VRDevice33VRNodeToTrackedNodeNameDeprecatedEi, __ZNK17Physics2DSettings26GetTypeInfoVirtualInternalEv: __ZNK17Physics2DSettings26GetTypeInfoVirtualInternalEv, _access_virt_sarray: _access_virt_sarray, __ZN7Joint2D10DeactivateE19DeactivateOperation: __ZN7Joint2D10DeactivateE19DeactivateOperation, __ZN4FMOD6SoundI11setDefaultsEfffi: __ZN4FMOD6SoundI11setDefaultsEfffi, __ZNK12HeaderHelper13GetAllHeadersEv: __ZNK12HeaderHelper13GetAllHeadersEv, __ZN11UnityEngine7Connect20BasePersistentValuesC2Ev: __ZN11UnityEngine7Connect20BasePersistentValuesC2Ev, __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN4FMOD8ChannelI9isVirtualEPb: __ZN4FMOD8ChannelI9isVirtualEPb, __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE: __Z17DebugStringToFilePKciS0_i15LogMessageFlagsiiPFvRK11CppLogEntryE, __ZTv0_n12_NSt3__29strstreamD1Ev: __ZTv0_n12_NSt3__29strstreamD1Ev, __ZNSt3__215__codecvt_utf16IwLb1EED0Ev: __ZNSt3__215__codecvt_utf16IwLb1EED0Ev, __Z40WWW_Get_Custom_PropResponseHeadersStringP12Il2CppObject: __Z40WWW_Get_Custom_PropResponseHeadersStringP12Il2CppObject, __ZN5physx2Sc13ConstraintSim8getForceERNS_6PxVec3ES3_: __ZN5physx2Sc13ConstraintSim8getForceERNS_6PxVec3ES3_, __Z48Register_UnityEngine_AI_NavMeshAgent_get_hasPathv: __Z48Register_UnityEngine_AI_NavMeshAgent_get_hasPathv, __ZNK5physx2Sc16ArticulationCore17getPxArticulationEv: __ZNK5physx2Sc16ArticulationCore17getPxArticulationEv, __Z53TerrainData_Get_Custom_PropInternal_baseMapResolutionP12Il2CppObject: __Z53TerrainData_Get_Custom_PropInternal_baseMapResolutionP12Il2CppObject, __ZN16LevelGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16LevelGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN21OverlapCapsuleQuery2DD0Ev: __ZN21OverlapCapsuleQuery2DD0Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16GfxPrimitiveTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16GfxPrimitiveTypeEvRT_RT0_PKc17TransferMetaFlags, __ZN24dtObstacleAvoidanceQuery22sampleVelocityAdaptiveEPKfS1_fffPffPK25dtObstacleAvoidanceParamsP21dtCrowdAgentDebugInfo: __ZN24dtObstacleAvoidanceQuery22sampleVelocityAdaptiveEPKfS1_fffPffPK25dtObstacleAvoidanceParamsP21dtCrowdAgentDebugInfo, __ZN12LineRenderer12SetPositionsEPK8Vector3fj: __ZN12LineRenderer12SetPositionsEPK8Vector3fj, __ZN10GameObject7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10GameObject7PRODUCEE10MemLabelId18ObjectCreationMode, __Z44Register_UnityEngine_AreaEffector2D_get_dragv: __Z44Register_UnityEngine_AreaEffector2D_get_dragv, __Z15GetChannelIndexRK14BlendShapeDataj: __Z15GetChannelIndexRK14BlendShapeDataj, __ZN7mecanim5human5HumanC2Ev: __ZN7mecanim5human5HumanC2Ev, __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags: __Z19WriteObjectToVectorRK6ObjectR13dynamic_arrayIhLj1EE24TransferInstructionFlags, __ZN18StreamedBinaryReadILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN18StreamedBinaryReadILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, _remquol: _remquol, __ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_: __ZN5physx15PxGeometryQuery18computePenetrationERNS_6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_, __ZNK5physx3Ext14PrismaticJoint11getPositionEv: __ZNK5physx3Ext14PrismaticJoint11getPositionEv, _remquof: _remquof, __Z49WebCamTexture_CUSTOM_Internal_CreateWebCamTextureP12Il2CppObjectP12Il2CppStringiii: __Z49WebCamTexture_CUSTOM_Internal_CreateWebCamTextureP12Il2CppObjectP12Il2CppStringiii, __ZN23ShaderVariantCollectionD0Ev: __ZN23ShaderVariantCollectionD0Ev, __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev: __ZN5physx35PxVehicleWheelsDynDataGeneratedInfoC2Ev, __ZN13AvatarBuilder12GetAllParentER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb: __ZN13AvatarBuilder12GetAllParentER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb, __ZN5Unity12PhysicsQueryC2Ev: __ZN5Unity12PhysicsQueryC2Ev, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__227__insertion_sort_incompleteIR26ColliderIdentityComparitorPP10Collider2DEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR26ColliderIdentityComparitorPP10Collider2DEEbT0_S6_T_, __ZN5physx10PxsContext13updateIslandsEfPNS_10PxBaseTaskE: __ZN5physx10PxsContext13updateIslandsEfPNS_10PxBaseTaskE, __Z39GameObject_CUSTOM_FindGameObjectWithTagP12Il2CppString: __Z39GameObject_CUSTOM_FindGameObjectWithTagP12Il2CppString, __Z31ScriptingToNativeVertexDataType23ScriptingVertexDataType: __Z31ScriptingToNativeVertexDataType23ScriptingVertexDataType, __ZN15RelativeJoint2D15ThreadedCleanupEv: __ZN15RelativeJoint2D15ThreadedCleanupEv, __ZN11ColorModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11ColorModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali: __Z14DrawGUITextureRK5RectTIfEP7Texture11ColorRGBA32P8Materiali, __Z30AddAllowsMultipleInclusionIMPLi: __Z30AddAllowsMultipleInclusionIMPLi, __Z20resizeCreatedDeletedRPN5physx17PxcBroadPhasePairERj: __Z20resizeCreatedDeletedRPN5physx17PxcBroadPhasePairERj, __Z42Register_UnityEngine_Texture2D_EncodeToPNGv: __Z42Register_UnityEngine_Texture2D_EncodeToPNGv, __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali: __ZN22RenderingCommandBuffer19AddBlitRenderTargetERK18RenderTextureParamS2_P8Materiali, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Cm10Collection5addIdERNS_6PxBaseEy: __ZN5physx2Cm10Collection5addIdERNS_6PxBaseEy, __Z40BillboardAsset_CUSTOM_GetIndicesInternalP12Il2CppObjectS0_: __Z40BillboardAsset_CUSTOM_GetIndicesInternalP12Il2CppObjectS0_, __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15TextureSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__211__money_putIcEC2Ev: __ZNSt3__211__money_putIcEC2Ev, __ZN9JSONWrite8TransferI4AABBEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI4AABBEEvRT_PKc17TransferMetaFlags, __ZNKSt3__25ctypeIcE10do_toupperEc: __ZNKSt3__25ctypeIcE10do_toupperEc, __ZN25MultiBlocksMemoryFileData9SetLengthEy: __ZN25MultiBlocksMemoryFileData9SetLengthEy, __Z30GetAudioSpatializerDefinitionsR13dynamic_arrayIP29AudioEffectInternalDefinitionLj4EE: __Z30GetAudioSpatializerDefinitionsR13dynamic_arrayIP29AudioEffectInternalDefinitionLj4EE, __ZN15ReflectionProbe17GetCachedRendererEv: __ZN15ReflectionProbe17GetCachedRendererEv, __ZN24DownloadHandlerAudioClipD0Ev: __ZN24DownloadHandlerAudioClipD0Ev, __ZNK18ScBeforeSolverTask7getNameEv: __ZNK18ScBeforeSolverTask7getNameEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN10Collider2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN10Collider2D13AwakeFromLoadE17AwakeFromLoadMode, __ZNK9Texture2D20GetRuntimeMemorySizeEv: __ZNK9Texture2D20GetRuntimeMemorySizeEv, __ZN5physx14solve1D4_BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx14solve1D4_BlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx2Sc8ShapeSim17onTransformChangeEv: __ZN5physx2Sc8ShapeSim17onTransformChangeEv, __ZL33GeomMTDCallback_ConvexHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL33GeomMTDCallback_ConvexHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, _UNITY_png_get_x_offset_inches: _UNITY_png_get_x_offset_inches, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj494ENS_22PxRepXPropertyAccessorILj494ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj494ENS_22PxRepXPropertyAccessorILj494ES4_ffEEEEvRKT0_, _UNITY_FT_Outline_Transform: _UNITY_FT_Outline_Transform, __Z60Register_UnityEngine_Sprites_DataUtility_Internal_GetMinSizev: __Z60Register_UnityEngine_Sprites_DataUtility_Internal_GetMinSizev, __ZNSt3__26vectorI5RectTIfENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorI5RectTIfENS_9allocatorIS2_EEE8__appendEj, __Z46Register_UnityEngine_AudioEchoFilter_set_delayv: __Z46Register_UnityEngine_AudioEchoFilter_set_delayv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __Z36AndroidJNI_CUSTOM_SetStaticByteField13Il2Cpp_IntPtrS_h: __Z36AndroidJNI_CUSTOM_SetStaticByteField13Il2Cpp_IntPtrS_h, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_, __Z24getPxTolerancesScaleMassPKN5physx17PxTolerancesScaleE: __Z24getPxTolerancesScaleMassPKN5physx17PxTolerancesScaleE, __Z42NavMeshObstacle_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z42NavMeshObstacle_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZZN8LODGroup15InitializeClassEvEN32FunctorImpl_428kTransformChanged4CallEPviR11MessageData: __ZZN8LODGroup15InitializeClassEvEN32FunctorImpl_428kTransformChanged4CallEPviR11MessageData, __Z23StringScriptingToVectorINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEEEvP11Il2CppArrayRT_: __Z23StringScriptingToVectorINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEEEvP11Il2CppArrayRT_, __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalMatrixP12Il2CppObjectiRK10Matrix4x4f: __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalMatrixP12Il2CppObjectiRK10Matrix4x4f, __Z54Register_UnityEngine_AudioSource_set_bypassReverbZonesv: __Z54Register_UnityEngine_AudioSource_set_bypassReverbZonesv, __ZN4FMOD7SystemI19getRecordDriverCapsEiPjPiS2_: __ZN4FMOD7SystemI19getRecordDriverCapsEiPjPiS2_, __ZN15UniformTFMethod13MapBoneBufferEj: __ZN15UniformTFMethod13MapBoneBufferEj, __ZN2UI14CanvasRendererD2Ev: __ZN2UI14CanvasRendererD2Ev, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXv, __Z45Register_UnityEngine_Camera_set_nearClipPlanev: __Z45Register_UnityEngine_Camera_set_nearClipPlanev, __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE: __ZN5physx7NpActor12setAggregateEPNS_11NpAggregateERNS_7PxActorE, __Z24RegisterStrippedTypeInfoI9Texture2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI9Texture2DEviPKcS2_, __Z34Playables_CUSTOM_GetTypeOfInternal13Il2Cpp_IntPtri: __Z34Playables_CUSTOM_GetTypeOfInternal13Il2Cpp_IntPtri, __ZN5physx28PxVehicleComputeSprungMassesEjPKNS_6PxVec3ERS1_fjPf: __ZN5physx28PxVehicleComputeSprungMassesEjPKNS_6PxVec3ERS1_fjPf, __Z9SetupArgviPPKc: __Z9SetupArgviPPKc, __ZN5physx8debugger14PvdMarshallingIdxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIdxE12marshalBlockEPKhPhj, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN5physx3Scb4Base17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb4Base17getBinaryMetaDataERNS_14PxOutputStreamE, __ZL31StereoDisplayGetDeviceConnectedv: __ZL31StereoDisplayGetDeviceConnectedv, __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MoveRotationv: __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MoveRotationv, __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEEC2ERNS_19PxAllocatorCallbackE, __ZN5physx10PxsContext17addParticleSystemEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb: __ZN5physx10PxsContext17addParticleSystemEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb, __ZN5physx3Scb5Scene13addRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene13addRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE, __ZN12ImmediatePtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12ImmediatePtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z28LayerMask_CUSTOM_LayerToNamei: __Z28LayerMask_CUSTOM_LayerToNamei, __Z21setPxCloth_ClothFlagsPN5physx7PxClothENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __Z21setPxCloth_ClothFlagsPN5physx7PxClothENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior: __ZN12FileAccessor4OpenER15FileSystemEntry14FilePermission16FileAutoBehavior, __ZNK13SpeedTreeWind15IsOptionEnabledENS_8EOptionsE: __ZNK13SpeedTreeWind15IsOptionEnabledENS_8EOptionsE, __ZN5physx30PxPlaneGeometryGeneratedValuesC2EPKNS_15PxPlaneGeometryE: __ZN5physx30PxPlaneGeometryGeneratedValuesC2EPKNS_15PxPlaneGeometryE, __ZN10Collider2D17SetUsedByEffectorEb: __ZN10Collider2D17SetUsedByEffectorEb, __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZL19sweepBoxVsTrianglesjPKN5physx10PxTriangleERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEbPKj: __ZL19sweepBoxVsTrianglesjPKN5physx10PxTriangleERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEbPKj, __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedERK15TransformAccess: __ZN23TransformChangeDispatch32QueueTransformChangeIfHasChangedERK15TransformAccess, __ZN4crnd24crnd_is_debugger_presentEv: __ZN4crnd24crnd_is_debugger_presentEv, __Z43BuoyancyEffector2D_Set_Custom_PropFlowAngleP12Il2CppObjectf: __Z43BuoyancyEffector2D_Set_Custom_PropFlowAngleP12Il2CppObjectf, __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_9allocatorIS6_EEE21__push_back_slow_pathIKS6_EEvRT_: __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_9allocatorIS6_EEE21__push_back_slow_pathIKS6_EEvRT_, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm, __ZN15AudioMixerGroupD0Ev: __ZN15AudioMixerGroupD0Ev, __ZN15ArchiveReadFile5WriteEyPKvPy: __ZN15ArchiveReadFile5WriteEyPKvPy, __Z56CharacterController_Set_Custom_PropEnableOverlapRecoveryP12Il2CppObjecth: __Z56CharacterController_Set_Custom_PropEnableOverlapRecoveryP12Il2CppObjecth, __Z44Register_UnityEngine_SliderJoint2D_get_anglev: __Z44Register_UnityEngine_SliderJoint2D_get_anglev, __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD2Ev: __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD2Ev, __ZNK21DownloadHandlerScript13GetMemorySizeEv: __ZNK21DownloadHandlerScript13GetMemorySizeEv, __ZNK12NavMeshAgent9GetFilterEv: __ZNK12NavMeshAgent9GetFilterEv, __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZDriveP12Il2CppObjectP10JointDrive: __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZDriveP12Il2CppObjectP10JointDrive, __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurvev: __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurvev, __ZN13RuntimeStaticI15ApplicationInfoE13StaticDestroyEPv: __ZN13RuntimeStaticI15ApplicationInfoE13StaticDestroyEPv, __Z58Register_UnityEngine_SurfaceEffector2D_set_useContactForcev: __Z58Register_UnityEngine_SurfaceEffector2D_set_useContactForcev, __Z42AudioReverbZone_Set_Custom_PropReverbDelayP12Il2CppObjectf: __Z42AudioReverbZone_Set_Custom_PropReverbDelayP12Il2CppObjectf, __Z31GUIStyle_CUSTOM_SetFontInternalP12Il2CppObjectS0_: __Z31GUIStyle_CUSTOM_SetFontInternalP12Il2CppObjectS0_, __Z29StdTemplateConversionFunctionIaiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIaiEbPvR14SafeBinaryRead, __ZN16TimerQueriesGLES15EndTimerQueriesEv: __ZN16TimerQueriesGLES15EndTimerQueriesEv, __Z45Register_UnityEngine_TextMesh_get_lineSpacingv: __Z45Register_UnityEngine_TextMesh_get_lineSpacingv, __ZN5physx36computeAckermannCorrectedSteerAnglesERKNS_23PxVehicleDriveSimData4WERKNS_23PxVehicleWheels4SimDataEfPf: __ZN5physx36computeAckermannCorrectedSteerAnglesERKNS_23PxVehicleDriveSimData4WERKNS_23PxVehicleWheels4SimDataEfPf, __ZN15QualitySettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15QualitySettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z29scripting_class_from_fullnamePKcS0_S0_: __Z29scripting_class_from_fullnamePKcS0_S0_, __ZN6Camera23ResetStereoViewMatricesEv: __ZN6Camera23ResetStereoViewMatricesEv, __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZZN8Animator15InitializeClassEvEN32FunctorImpl_386kTransformChanged4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN32FunctorImpl_386kTransformChanged4CallEPviR11MessageData, __ZN5physx23PxVehicleWheels4SimData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx23PxVehicleWheels4SimData17getBinaryMetaDataERNS_14PxOutputStreamE, __Z43AnimationClipPlayable_CUSTOM_GetApplyFootIKR9HPlayable: __Z43AnimationClipPlayable_CUSTOM_GetApplyFootIKR9HPlayable, __ZN12NavMeshAgent23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12NavMeshAgent23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13WebCamTexture15ThreadedCleanupEv: __ZN13WebCamTexture15ThreadedCleanupEv, __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv: __ZN5physx2Gu29ConvexVsMeshContactGeneration20generateLastContactsEv, __Z60Register_UnityEngine_TerrainData_Internal_SetHeightsDelayLODv: __Z60Register_UnityEngine_TerrainData_Internal_SetHeightsDelayLODv, __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE, __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi: __ZNSt3__220__get_up_to_n_digitsIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi, __ZN7mecanim24CreateValueArrayConstantEPjjRNS_6memory9AllocatorE: __ZN7mecanim24CreateValueArrayConstantEPjjRNS_6memory9AllocatorE, __ZN7dtCrowd8addAgentER13dtCrowdHandlePKfPK18dtCrowdAgentParams: __ZN7dtCrowd8addAgentER13dtCrowdHandlePKfPK18dtCrowdAgentParams, __ZN11AudioSource19CreateOpenALRolloffEfff: __ZN11AudioSource19CreateOpenALRolloffEfff, _UNITY_FT_Stream_ReadAt: _UNITY_FT_Stream_ReadAt, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv: __ZN5physx2Sc17ParticleSystemSim16getParticleStateEv, __Z53Register_UnityEngine_TerrainData_set_wavingGrassSpeedv: __Z53Register_UnityEngine_TerrainData_set_wavingGrassSpeedv, __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_25PxsCompoundContactManagerENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN5physx3Ext23DefaultBufferedProfiler11flushEventsEv: __ZN5physx3Ext23DefaultBufferedProfiler11flushEventsEv, __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj: __ZN5physx15PxVehicleWheels5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_21PxHeightFieldGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_21PxHeightFieldGeometryE, __Z35Camera_Get_Custom_PropStereoEnabledP12Il2CppObject: __Z35Camera_Get_Custom_PropStereoEnabledP12Il2CppObject, __ZN21BillboardBatchManagerC2Ev: __ZN21BillboardBatchManagerC2Ev, __ZN13MemoryManager18AddCustomAllocatorEP13BaseAllocator: __ZN13MemoryManager18AddCustomAllocatorEP13BaseAllocator, __Z38Application_Get_Custom_PropIsBatchmodev: __Z38Application_Get_Custom_PropIsBatchmodev, __Z26TransformVerticesInnerLoopILb1ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb1ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __ZN5physx14PxsAABBManagerC2ERNS_2Cm13EventProfilerERNS_19PxcScratchAllocatorE: __ZN5physx14PxsAABBManagerC2ERNS_2Cm13EventProfilerERNS_19PxcScratchAllocatorE, __ZN11AudioModule22CreateAudioClipFromWWWEP10IWWWStreamPKcbbi: __ZN11AudioModule22CreateAudioClipFromWWWEP10IWWWStreamPKcbbi, __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode: __ZN9Texture2DC2E10MemLabelId18ObjectCreationMode, __Z39Register_UnityEngine_Event_set_pressurev: __Z39Register_UnityEngine_Event_set_pressurev, __ZNK12SocketStream23IsArtificiallyConnectedEv: __ZNK12SocketStream23IsArtificiallyConnectedEv, __Z48getPxVehicleTireLoadFilterDataMMinNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE: __Z48getPxVehicleTireLoadFilterDataMMinNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE, __ZNK15RelativeJoint2D26GetTypeInfoVirtualInternalEv: __ZNK15RelativeJoint2D26GetTypeInfoVirtualInternalEv, __ZNKSt3__215__codecvt_utf16IDsLb0EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IDsLb0EE16do_always_noconvEv, __ZN4PPtrI20OcclusionCullingDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI20OcclusionCullingDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN6prcoreL11inner_clearILj4EEEvPhjjj: __ZN6prcoreL11inner_clearILj4EEEvPhjjj, __ZN7dtCrowd17requestMoveTargetEiyPKf: __ZN7dtCrowd17requestMoveTargetEiyPKf, __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5audio5mixer18AudioMixerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE15set_deleted_keyERSF_: __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReader11djb2_hash_tIS7_ENS0_8equal_toIS7_EES4_INS0_4pairIKS7_S9_EELS5_54ELi16EEE15set_deleted_keyERSF_, __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue: __ZN10UnityScene24ExtractLevelGameManagersER18AwakeFromLoadQueue, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE13isSubordinateEv, __Z34Camera_CUSTOM_SetTargetBuffersImplP12Il2CppObjectP21ScriptingRenderBufferS2_: __Z34Camera_CUSTOM_SetTargetBuffersImplP12Il2CppObjectP21ScriptingRenderBufferS2_, __Z24RegisterStrippedTypeInfoI15LightProbeGroupEviPKcS2_: __Z24RegisterStrippedTypeInfoI15LightProbeGroupEviPKcS2_, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERf: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERf, __ZN5physx8debugger4comm8SetColorD0Ev: __ZN5physx8debugger4comm8SetColorD0Ev, __ZN14MessageHandler28MessageIDToMessageIdentifierEi: __ZN14MessageHandler28MessageIDToMessageIdentifierEi, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERh, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERj: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERj, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERt: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERt, __Z48AudioSource_Get_Custom_PropSpatializePostEffectsP12Il2CppObject: __Z48AudioSource_Get_Custom_PropSpatializePostEffectsP12Il2CppObject, __ZN14UnityAnalytics16SetUserBirthYearEj: __ZN14UnityAnalytics16SetUserBirthYearEj, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERy: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERy, __Z23getPxScene_CCDMaxPassesPKN5physx7PxSceneE: __Z23getPxScene_CCDMaxPassesPKN5physx7PxSceneE, __Z18IsScreenshotQueuedv: __Z18IsScreenshotQueuedv, __Z44RelativeJoint2D_Set_Custom_PropAngularOffsetP12Il2CppObjectf: __Z44RelativeJoint2D_Set_Custom_PropAngularOffsetP12Il2CppObjectf, __ZN5physx2Gu19sweepCapsuleCapsuleERKNS0_7CapsuleES3_RKNS_6PxVec3EfRfRS4_S8_jRt: __ZN5physx2Gu19sweepCapsuleCapsuleERKNS0_7CapsuleES3_RKNS_6PxVec3EfRfRS4_S8_jRt, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13TextureFormatEvRT_RT0_PKc17TransferMetaFlags, __ZL10CleanUpJobP20CullingGroupsJobData: __ZL10CleanUpJobP20CullingGroupsJobData, _prepare_for_pass: _prepare_for_pass, __Z48AnimatorControllerPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable: __Z48AnimatorControllerPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable, __Z20IsRunningNativeTestsv: __Z20IsRunningNativeTestsv, __ZN11TimeManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11TimeManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPNS_15basic_streambufIcS2_EE, __Z23AddIntermediateRendererP20IntermediateRendererP6Camera: __Z23AddIntermediateRendererP20IntermediateRendererP6Camera, __ZN11UmbraModule18DeleteShadowCullerEPN5Umbra15ShadowCullerExtE: __ZN11UmbraModule18DeleteShadowCullerEPN5Umbra15ShadowCullerExtE, _jpeg_resync_to_restart: _jpeg_resync_to_restart, __ZN4FMOD4DSPI16getNumParametersEPi: __ZN4FMOD4DSPI16getNumParametersEPi, __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags, __Z36IsStreamedBinaryCompatibleAndIndicesRK16TypeTreeIteratorS1_: __Z36IsStreamedBinaryCompatibleAndIndicesRK16TypeTreeIteratorS1_, __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier: __ZN17PersistentManager51InstanceIDToLocalSerializedObjectIdentifierInternalEiR31LocalSerializedObjectIdentifier, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE13isSubordinateEv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpExNS_8ios_base7seekdirE: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpExNS_8ios_base7seekdirE, __ZN5physx2Sc8ActorSim24postDominanceGroupChangeEv: __ZN5physx2Sc8ActorSim24postDominanceGroupChangeEv, __ZN8GUIState12GetControlIDEi9FocusType: __ZN8GUIState12GetControlIDEi9FocusType, __Z47ConstantForce_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK8Vector3f: __Z47ConstantForce_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK8Vector3f, __Z46Register_UnityEngine_AndroidJNI_GetDoubleFieldv: __Z46Register_UnityEngine_AndroidJNI_GetDoubleFieldv, __ZN5physx31PxVehicleDriveNWGeneratedValuesC2EPKNS_16PxVehicleDriveNWE: __ZN5physx31PxVehicleDriveNWGeneratedValuesC2EPKNS_16PxVehicleDriveNWE, __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE: __ZN5physx2Cm8PtrTable5clearERNS0_22PtrTableStorageManagerE, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekoffExNS_8ios_base7seekdirEj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE8pushNameEPKc, __ZN5physx27PxVehicleDifferentialNWData20setDrivenWheelStatusEj: __ZN5physx27PxVehicleDifferentialNWData20setDrivenWheelStatusEj, __ZN5physx3Cct15ObstacleContext7releaseEv: __ZN5physx3Cct15ObstacleContext7releaseEv, __ZN5physx27solveFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx27solveFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __Z57ParticleSystem_CollisionModule_CUSTOM_SetDampenMultiplierP12Il2CppObjectf: __Z57ParticleSystem_CollisionModule_CUSTOM_SetDampenMultiplierP12Il2CppObjectf, __ZN9CoroutineD2Ev: __ZN9CoroutineD2Ev, _UNITY_ft_glyphslot_alloc_bitmap: _UNITY_ft_glyphslot_alloc_bitmap, __Z22getPxRigidActor_ShapesPKN5physx12PxRigidActorEPPNS_7PxShapeEj: __Z22getPxRigidActor_ShapesPKN5physx12PxRigidActorEPPNS_7PxShapeEj, __ZL36RegisterModuleICalls_ParticlesLegacyv: __ZL36RegisterModuleICalls_ParticlesLegacyv, __Z22getPxArticulation_NamePKN5physx14PxArticulationE: __Z22getPxArticulation_NamePKN5physx14PxArticulationE, __ZN17Physics2DSettings21SetLayerCollisionMaskEij: __ZN17Physics2DSettings21SetLayerCollisionMaskEij, __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowVariationv: __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowVariationv, __ZN22DownloadHandlerTexture17OnCompleteContentEv: __ZN22DownloadHandlerTexture17OnCompleteContentEv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5Unity17ConfigurableJoint10SetYMotionEi: __ZN5Unity17ConfigurableJoint10SetYMotionEi, __ZN15FrictionJoint2DD0Ev: __ZN15FrictionJoint2DD0Ev, __ZN5physx6shdfnd10Foundation19AlignCheckAllocator8allocateEjPKcS4_i: __ZN5physx6shdfnd10Foundation19AlignCheckAllocator8allocateEjPKcS4_i, __Z29LoadMainObjectFromAssetBundleR11AssetBundle: __Z29LoadMainObjectFromAssetBundleR11AssetBundle, __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMaxv: __Z57Register_UnityEngine_RectTransform_INTERNAL_set_anchorMaxv, __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_S8_T_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj490ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj490ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv: __ZNKSt3__221__basic_string_commonILb1EE20__throw_length_errorEv, __Z47UnityWebRequest_Get_Custom_PropDownloadProgressP12Il2CppObject: __Z47UnityWebRequest_Get_Custom_PropDownloadProgressP12Il2CppObject, __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerIDv: __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerIDv, __ZN18GfxFramebufferGLES13ReadbackImageER14ImageReferenceiiiiii: __ZN18GfxFramebufferGLES13ReadbackImageER14ImageReferenceiiiiii, __Z19GetLightProbeGroupsv: __Z19GetLightProbeGroupsv, __ZN5physx8debugger14PvdMarshallingIasE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIasE12marshalBlockEPKhPhj, __ZNK26AnimatorOverrideController15GetOriginalClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK26AnimatorOverrideController15GetOriginalClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN13RuntimeStaticI11WindManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI11WindManagerE13StaticDestroyEPv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB565EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB565EEvPKNS_9InnerInfoE, __ZN4FMOD7Channel19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD7Channel19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES, __ZN13MonoBehaviour22GetScriptFullClassNameEv: __ZN13MonoBehaviour22GetScriptFullClassNameEv, ___ldexp_cexp: ___ldexp_cexp, __ZN9Animation23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Animation23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx6shdfnd4sortIPNS_15PxsContactPatchENS_27SortBoundsPredicateManifoldENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPNS_15PxsContactPatchENS_27SortBoundsPredicateManifoldENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j, __Z48Register_UnityEngine_GameObject_BroadcastMessagev: __Z48Register_UnityEngine_GameObject_BroadcastMessagev, __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb: __ZN13BatchRendererC2ER15RenderLoopStatsRK15RenderNodeQueuebb, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_, __Z47Cloth_CUSTOM_INTERNAL_CALL_ClearTransformMotionP12Il2CppObject: __Z47Cloth_CUSTOM_INTERNAL_CALL_ClearTransformMotionP12Il2CppObject, __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetRandomizedv: __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetRandomizedv, __ZN20SphericalHarmonicsL211AddWeightedERKS_f: __ZN20SphericalHarmonicsL211AddWeightedERKS_f, __ZN5physx2Sc24ElementInteractionMarker12onDeactivateEj: __ZN5physx2Sc24ElementInteractionMarker12onDeactivateEj, __ZN12_GLOBAL__N_110DataStream18setPropertyMessageEPKvRKN5physx8debugger14NamespacedNameENS4_7DataRefIKhEE: __ZN12_GLOBAL__N_110DataStream18setPropertyMessageEPKvRKN5physx8debugger14NamespacedNameENS4_7DataRefIKhEE, __ZN9DepthPassD2Ev: __ZN9DepthPassD2Ev, __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN19GfxThreadableDevice20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_: __ZN19GfxThreadableDevice20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_, __Z22getPxActor_OwnerClientPKN5physx7PxActorE: __Z22getPxActor_OwnerClientPKN5physx7PxActorE, _h2v1_fancy_upsample: _h2v1_fancy_upsample, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_15AllocationEventEEEvT_: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_15AllocationEventEEEvT_, __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags, __Z48Register_UnityEngine_Debug_GetDiagnosticSwitchesv: __Z48Register_UnityEngine_Debug_GetDiagnosticSwitchesv, __Z51Register_UnityEngine_AreaEffector2D_get_forceTargetv: __Z51Register_UnityEngine_AreaEffector2D_get_forceTargetv, __ZN14PhysicsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14PhysicsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt13runtime_errorC2EPKc: __ZNSt13runtime_errorC2EPKc, __Z20dtAllocProximityGridv: __Z20dtAllocProximityGridv, __Z35Register_UnityEngine_Resources_Loadv: __Z35Register_UnityEngine_Resources_Loadv, __Z19TransferField_ArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, _pre_process_data: _pre_process_data, _rename: _rename, __Z32WheelCollider_Get_Custom_PropRpmP12Il2CppObject: __Z32WheelCollider_Get_Custom_PropRpmP12Il2CppObject, __Z43AnimationCurve_CUSTOM_INTERNAL_CALL_MoveKeyP12Il2CppObjectiRK16KeyframeTplFloat: __Z43AnimationCurve_CUSTOM_INTERNAL_CALL_MoveKeyP12Il2CppObjectiRK16KeyframeTplFloat, _stbir_resize_float: _stbir_resize_float, __ZN12CubemapArray11SetPixels32EiPK11ColorRGBA3211CubemapFaceii: __ZN12CubemapArray11SetPixels32EiPK11ColorRGBA3211CubemapFaceii, __Z16OffsetCurveValueR17AnimationCurveTplIfEf: __Z16OffsetCurveValueR17AnimationCurveTplIfEf, __ZNK5physx2Gu15OBBTriangleTest10obbTriTestERKNS_6PxVec3ES4_S4_: __ZNK5physx2Gu15OBBTriangleTest10obbTriTestERKNS_6PxVec3ES4_S4_, __Z20UnlockObjectCreationv: __Z20UnlockObjectCreationv, __Z27Camera_Set_Custom_PropDepthP12Il2CppObjectf: __Z27Camera_Set_Custom_PropDepthP12Il2CppObjectf, __Z38Effector2D_Get_Custom_PropColliderMaskP12Il2CppObject: __Z38Effector2D_Get_Custom_PropColliderMaskP12Il2CppObject, __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_set_pivotv: __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_set_pivotv, __ZN22UnityWebRequestManager13BackendRetainEv: __ZN22UnityWebRequestManager13BackendRetainEv, __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_set_localBoundsv: __Z65Register_UnityEngine_SkinnedMeshRenderer_INTERNAL_set_localBoundsv, __Z34scripting_class_array_element_sizeP11Il2CppClass: __Z34scripting_class_array_element_sizeP11Il2CppClass, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_PKc17TransferMetaFlags, __ZN18ProfilerConnection33HandleQueryFunctionCalleesMessageEPKvjj: __ZN18ProfilerConnection33HandleQueryFunctionCalleesMessageEPKvjj, _UNITY_ft_smooth_renderer_class_pic_free: _UNITY_ft_smooth_renderer_class_pic_free, __ZN5physx16clothPlaneWriterERNS_14PxOutputStreamERKNS_21PxClothCollisionPlaneE: __ZN5physx16clothPlaneWriterERNS_14PxOutputStreamERKNS_21PxClothCollisionPlaneE, __Z73Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimeMultiplierv: __Z73Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimeMultiplierv, __Z59Register_UnityEngine_ParticleEmitter_get_rndAngularVelocityv: __Z59Register_UnityEngine_ParticleEmitter_get_rndAngularVelocityv, __ZN15SkyboxGenerator28GetCubemapSkyboxVertexFormatEv: __ZN15SkyboxGenerator28GetCubemapSkyboxVertexFormatEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE9__grow_byEjjjjjj, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip17CompressionFormatEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN10SampleClip17CompressionFormatEEvRT_RT0_PKc17TransferMetaFlags, __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj: __ZN20TextRenderingPrivate15DynamicFontData36GetFaceForCharacterIfAvailableInFontERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEEj, __ZN5physx12PxControllerD2Ev: __ZN5physx12PxControllerD2Ev, __Z71Register_UnityEngine_Animator_set_allowConstantClipSamplingOptimizationv: __Z71Register_UnityEngine_Animator_set_allowConstantClipSamplingOptimizationv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, __Z49SystemInfo_Get_Custom_PropSupports2DArrayTexturesv: __Z49SystemInfo_Get_Custom_PropSupports2DArrayTexturesv, __Z57ParticleSystem_CollisionModule_CUSTOM_SetBounceMultiplierP12Il2CppObjectf: __Z57ParticleSystem_CollisionModule_CUSTOM_SetBounceMultiplierP12Il2CppObjectf, __ZN16MBPOS_TmpBuffersC2Ev: __ZN16MBPOS_TmpBuffersC2Ev, __ZNKSt3__210moneypunctIcLb1EE13positive_signEv: __ZNKSt3__210moneypunctIcLb1EE13positive_signEv, __ZN13WebCamTextureD0Ev: __ZN13WebCamTextureD0Ev, __ZNK8Animator29ValidateHasAnimatorControllerEv: __ZNK8Animator29ValidateHasAnimatorControllerEv, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI25CapsuleTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI25CapsuleTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_, __ZN5IMGUI16GetWindowsBoundsER8GUIState: __ZN5IMGUI16GetWindowsBoundsER8GUIState, _UNITY_png_read_filter_row_up: _UNITY_png_read_filter_row_up, __ZN18AudioLowPassFilter13AwakeFromLoadE17AwakeFromLoadMode: __ZN18AudioLowPassFilter13AwakeFromLoadE17AwakeFromLoadMode, __Z43Terrain_Set_Custom_PropDetailObjectDistanceP12Il2CppObjectf: __Z43Terrain_Set_Custom_PropDetailObjectDistanceP12Il2CppObjectf, __Z46BuoyancyEffector2D_Set_Custom_PropSurfaceLevelP12Il2CppObjectf: __Z46BuoyancyEffector2D_Set_Custom_PropSurfaceLevelP12Il2CppObjectf, __ZN5physx3Cct17CapsuleController13setStepOffsetEf: __ZN5physx3Cct17CapsuleController13setStepOffsetEf, __Z24RegisterStrippedTypeInfoI15AnchoredJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15AnchoredJoint2DEviPKcS2_, __ZN5physx10PxsContext23prepareCMDiscreteUpdateEPNS_10PxBaseTaskE: __ZN5physx10PxsContext23prepareCMDiscreteUpdateEPNS_10PxBaseTaskE, __ZN15SerializeTraitsIN4math14float3_storageEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN4math14float3_storageEE8TransferI14SafeBinaryReadEEvRS1_RT_, __Z43Register_UnityEngine_SpringJoint_set_damperv: __Z43Register_UnityEngine_SpringJoint_set_damperv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2Ev, __ZN16LightmapSettings15ThreadedCleanupEv: __ZN16LightmapSettings15ThreadedCleanupEv, __ZN10GameObject27InvalidateSupportedMessagesEv: __ZN10GameObject27InvalidateSupportedMessagesEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZN16GUIKeyboardStateC2Ev: __ZN16GUIKeyboardStateC2Ev, __Z14FMOD_FILE_SeekPvjS_: __Z14FMOD_FILE_SeekPvjS_, _unzStringFileNameCompare: _unzStringFileNameCompare, __Z46Register_UnityEngine_Application_get_isTestRunv: __Z46Register_UnityEngine_Application_get_isTestRunv, __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZZN19MeshParticleEmitter15InitializeClassEvEN33FunctorImpl_329kMeshFilterChanged4CallEPviR11MessageData: __ZZN19MeshParticleEmitter15InitializeClassEvEN33FunctorImpl_329kMeshFilterChanged4CallEPviR11MessageData, __ZN7TextureC2E10MemLabelId18ObjectCreationMode: __ZN7TextureC2E10MemLabelId18ObjectCreationMode, __ZThn4_N16RayRTreeCallbackILi1ELb1EE14processResultsEjPj: __ZThn4_N16RayRTreeCallbackILi1ELb1EE14processResultsEjPj, __ZNK13RenderTexture32CalculateNeedsInvertedProjectionEv: __ZNK13RenderTexture32CalculateNeedsInvertedProjectionEv, __ZN10systeminfo18GetOperatingSystemEv: __ZN10systeminfo18GetOperatingSystemEv, __ZN14UnityAnalytics15SendCustomEventERK8UnityStr: __ZN14UnityAnalytics15SendCustomEventERK8UnityStr, __Z58Register_UnityEngine_Animator_INTERNAL_get_angularVelocityv: __Z58Register_UnityEngine_Animator_INTERNAL_get_angularVelocityv, __ZN6prcoreL18BlitIntegerToFloatERK14ImageReferenceRS0_: __ZN6prcoreL18BlitIntegerToFloatERK14ImageReferenceRS0_, __Z13RegisterClassI12CubemapArrayEvv: __Z13RegisterClassI12CubemapArrayEvv, __ZZ23InitPlayerLoopCallbacksvEN33PreUpdateCheckTexFieldInputstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN33PreUpdateCheckTexFieldInputstruct7ForwardEv, __Z31getPxSceneDescMeshContactMarginPKN5physx11PxSceneDescE: __Z31getPxSceneDescMeshContactMarginPKN5physx11PxSceneDescE, __ZN5FlareC2E10MemLabelId18ObjectCreationMode: __ZN5FlareC2E10MemLabelId18ObjectCreationMode, __Z12CollectPPtrsRK6ObjectRNSt3__26vectorIPS_NS2_9allocatorIS4_EEEE: __Z12CollectPPtrsRK6ObjectRNSt3__26vectorIPS_NS2_9allocatorIS4_EEEE, __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_GetBoxP12Il2CppObjectR8Vector3f: __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_GetBoxP12Il2CppObjectR8Vector3f, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z26ValidateAllocatorIntegrity10MemLabelId: __Z26ValidateAllocatorIntegrity10MemLabelId, __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE: __ZN17GeneralConnection22RegisterMessageHandlerENS_9MessageIDEPFvPKvjjE, __ZN27ConvexVsMeshOverlapCallbackC2ERKN5physx2Gu10ConvexMeshERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_bRKNS1_3BoxE: __ZN27ConvexVsMeshOverlapCallbackC2ERKN5physx2Gu10ConvexMeshERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_bRKNS1_3BoxE, __Z18SetIParticleSystemP15IParticleSystem: __Z18SetIParticleSystemP15IParticleSystem, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__212strstreambufC2EPFPvjEPFvS1_E: __ZNSt3__212strstreambufC2EPFPvjEPFvS1_E, __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf: __ZN7mecanim5human13HumanFixTwistEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iiRKf, __Z46Register_UnityEngine_SpringJoint_set_tolerancev: __Z46Register_UnityEngine_SpringJoint_set_tolerancev, __ZN11AudioSource7CleanupEv: __ZN11AudioSource7CleanupEv, __Z19InitVehiclesManagerv: __Z19InitVehiclesManagerv, __Z45PointEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf: __Z45PointEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf, __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareClassesEPKvS7_: __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareClassesEPKvS7_, __ZNK4Mesh11HasTopologyE16GfxPrimitiveType: __ZNK4Mesh11HasTopologyE16GfxPrimitiveType, __ZN9ShaderLab20SerializedSubProgram14SetConstBufferEPKci: __ZN9ShaderLab20SerializedSubProgram14SetConstBufferEPKci, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetAnimationTypeP12Il2CppObjecti: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetAnimationTypeP12Il2CppObjecti, __ZN11ShapeModule9ResetSeedERK27ParticleSystemReadOnlyState: __ZN11ShapeModule9ResetSeedERK27ParticleSystemReadOnlyState, __ZN5physx2Sn18checkCompatibilityEjj: __ZN5physx2Sn18checkCompatibilityEjj, __Z52Register_UnityEngine_GameObject_GetComponentFastPathv: __Z52Register_UnityEngine_GameObject_GetComponentFastPathv, __ZN13PhysicsModule17SetRigidBodyStateER9RigidbodyRKN8IPhysics14RigidBodyStateE: __ZN13PhysicsModule17SetRigidBodyStateER9RigidbodyRKN8IPhysics14RigidBodyStateE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18NbCCDPairsPropertyC2Ev: __ZN5physx18NbCCDPairsPropertyC2Ev, __ZN15DistanceJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN15DistanceJoint2DC2E10MemLabelId18ObjectCreationMode, _cf2_getStdVW: _cf2_getStdVW, __Z29NeedUpdateLODGroupBoundingBoxRK8LODGroup: __Z29NeedUpdateLODGroupBoundingBoxRK8LODGroup, __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform: __ZN19SkinnedMeshRenderer11SetRootBoneEP9Transform, _jpeg_set_marker_processor: _jpeg_set_marker_processor, __ZN8Animator6SampleER13AnimationClipf: __ZN8Animator6SampleER13AnimationClipf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_, __Z29getPxRigidBody_LinearVelocityPKN5physx11PxRigidBodyE: __Z29getPxRigidBody_LinearVelocityPKN5physx11PxRigidBodyE, __ZN9GfxDevice13SetActiveTierE12GraphicsTier: __ZN9GfxDevice13SetActiveTierE12GraphicsTier, __ZN5physx2Sq12BucketPruner11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq12BucketPruner11shiftOriginERKNS_6PxVec3E, __ZN14RenderSettings16SetUseFogNoDirtyEb: __ZN14RenderSettings16SetUseFogNoDirtyEb, _UNITY_png_get_x_offset_inches_fixed: _UNITY_png_get_x_offset_inches_fixed, __ZN10BlendShape11UpdateFlagsERK13dynamic_arrayI16BlendShapeVertexLj4EE: __ZN10BlendShape11UpdateFlagsERK13dynamic_arrayI16BlendShapeVertexLj4EE, _do_setxid: _do_setxid, __ZN5physx6shdfnd5ArrayIPNS_2Sc16ArticulationCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc16ArticulationCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_S7_S5_: __ZZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_S7_S5_, __Z10bucketFreeP11BucketAllocPv: __Z10bucketFreeP11BucketAllocPv, __Z46ParticleSystem_MainModule_CUSTOM_SetStartDelayP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_SetStartDelayP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, __ZNK12NavMeshAgent21GetCurrentPolygonMaskEv: __ZNK12NavMeshAgent21GetCurrentPolygonMaskEv, _UNITY_FT_List_Find: _UNITY_FT_List_Find, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SE_EEiEESH_RKT_: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SE_EEiEESH_RKT_, __Z40Matrix4x4_CUSTOM_INTERNAL_CALL_TransposeRK10Matrix4x4fRS_: __Z40Matrix4x4_CUSTOM_INTERNAL_CALL_TransposeRK10Matrix4x4fRS_, __ZN5physx19normalizePartitionsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_: __ZN5physx19normalizePartitionsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_, __Z52Application_Get_Custom_PropBackgroundLoadingPriorityv: __Z52Application_Get_Custom_PropBackgroundLoadingPriorityv, __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z22SetShaderGlobalTextureN9ShaderLab16FastPropertyNameEP7Texture: __Z22SetShaderGlobalTextureN9ShaderLab16FastPropertyNameEP7Texture, __Z52Register_UnityEngine_AudioReverbZone_get_LFReferencev: __Z52Register_UnityEngine_AudioReverbZone_get_LFReferencev, __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z12SetGfxDeviceP9GfxDevice: __Z12SetGfxDeviceP9GfxDevice, __Z46DistanceJoint2D_Get_Custom_PropMaxDistanceOnlyP12Il2CppObject: __Z46DistanceJoint2D_Get_Custom_PropMaxDistanceOnlyP12Il2CppObject, __ZN11TimeManager11GetRealtimeEv: __ZN11TimeManager11GetRealtimeEv, __Z39getPxHeightFieldDescConvexEdgeThresholdPKN5physx17PxHeightFieldDescE: __Z39getPxHeightFieldDescConvexEdgeThresholdPKN5physx17PxHeightFieldDescE, __ZN19AssetBundleManifestD0Ev: __ZN19AssetBundleManifestD0Ev, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_119VertexDistanceCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE: __ZN5physx2Sc16InteractionScene25removeFromActiveActorListERNS0_5ActorE, __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_I13BoneInfluenceLj16EERS_ItLj2EES7_: __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_I13BoneInfluenceLj16EERS_ItLj2EES7_, __ZN10MemoryPool13DeallocateAllEv: __ZN10MemoryPool13DeallocateAllEv, __ZN13TargetJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13TargetJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK11MinMaxCurve20FindMinMaxIntegratedEv: __ZNK11MinMaxCurve20FindMinMaxIntegratedEv, __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E: __ZN5physx3Ext21InertiaTensorComputer6rotateERKNS_7PxMat33E, __Z24RegisterStrippedTypeInfoI14BillboardAssetEviPKcS2_: __Z24RegisterStrippedTypeInfoI14BillboardAssetEviPKcS2_, __ZN17TransformInternal22CalculateTransformTypeE15TransformAccess: __ZN17TransformInternal22CalculateTransformTypeE15TransformAccess, __ZN12LineRenderer15InitializeClassEv: __ZN12LineRenderer15InitializeClassEv, _asinh: _asinh, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj565ENS_22PxRepXPropertyAccessorILj565ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj565ENS_22PxRepXPropertyAccessorILj565ES4_ffEEEEvRKT0_, _PrismaticJointSolverPrep: _PrismaticJointSolverPrep, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLESt16initializer_listIwE, _stbir_resize: _stbir_resize, __Z29Event_Set_Custom_PropPressureP12Il2CppObjectf: __Z29Event_Set_Custom_PropPressureP12Il2CppObjectf, __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI4MeshE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx23PxcPCMContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx23PxcPCMContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN9Animation4PlayERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN9Animation4PlayERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __ZNSt12experimental15fundamentals_v112bad_any_castD0Ev: __ZNSt12experimental15fundamentals_v112bad_any_castD0Ev, __Z51CharacterJoint_CUSTOM_INTERNAL_set_swingLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring: __Z51CharacterJoint_CUSTOM_INTERNAL_set_swingLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8max_sizeEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8max_sizeEv, __ZN14ParticleSystem31PlaybackSubEmitterCommandBufferERKS_R19ParticleSystemStateb: __ZN14ParticleSystem31PlaybackSubEmitterCommandBufferERKS_R19ParticleSystemStateb, __Z37ReadDirectoryInfo_UnityWebAndUnityRawR12FileAccessorRKN20ArchiveStorageHeader6HeaderERNS1_13DirectoryInfoE: __Z37ReadDirectoryInfo_UnityWebAndUnityRawR12FileAccessorRKN20ArchiveStorageHeader6HeaderERNS1_13DirectoryInfoE, __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_15compare_tstringIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN5Unity5Cloth8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity5Cloth8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_, __Z38Register_UnityEngine_WindZone_get_modev: __Z38Register_UnityEngine_WindZone_get_modev, __ZNSt3__26locale5__imp7installINS_5ctypeIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_5ctypeIcEEEEvPT_, __ZN9dtNavMesh17removeLinkBetweenEyy: __ZN9dtNavMesh17removeLinkBetweenEyy, _gzseek: _gzseek, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc, __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv: __ZN2UI6Canvas26MarkAllNestedCanvasesDirtyEv, __ZN5physx2Sn14sortCollectionERNS_2Cm10CollectionERNS0_21SerializationRegistryEb: __ZN5physx2Sn14sortCollectionERNS_2Cm10CollectionERNS0_21SerializationRegistryEb, __Z34setPxCloth_CentrifugalInertiaScalePN5physx7PxClothENS_6PxVec3E: __Z34setPxCloth_CentrifugalInertiaScalePN5physx7PxClothENS_6PxVec3E, __ZN25PathNamePersistentManagerD2Ev: __ZN25PathNamePersistentManagerD2Ev, __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi: __ZN17PersistentManager48IntegrateObjectAndUnlockIntegrationMutexInternalEi, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend2dDataConstantEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend2dDataConstantEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_, __ZN5Umbra6Random3getEv: __ZN5Umbra6Random3getEv, __Z40Avatar_CUSTOM_INTERNAL_CALL_GetLimitSignP12Il2CppObjectiR8Vector3f: __Z40Avatar_CUSTOM_INTERNAL_CALL_GetLimitSignP12Il2CppObjectiR8Vector3f, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEntEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEntEv, __ZN14PhysicsManager22OverlapCapsuleNonAllocERK8Vector3fS2_fPP8Colliderii23QueryTriggerInteraction: __ZN14PhysicsManager22OverlapCapsuleNonAllocERK8Vector3fS2_fPP8Colliderii23QueryTriggerInteraction, __ZNK15b2FrictionJoint11GetMaxForceEv: __ZNK15b2FrictionJoint11GetMaxForceEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj432ENS_22PxRepXPropertyAccessorILj432ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj432ENS_22PxRepXPropertyAccessorILj432ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_, __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE: __ZN19SkinnedMeshRenderer8SetBonesERK13dynamic_arrayI4PPtrI9TransformELj4EE, __ZN9Rigidbody23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Rigidbody23VirtualRedirectTransferER14SafeBinaryRead, _UNITY_png_set_chunk_cache_max: _UNITY_png_set_chunk_cache_max, __ZN13RendererScene15InitializeUmbraEv: __ZN13RendererScene15InitializeUmbraEv, __Z49Register_UnityEngine_GUI_InitializeGUIClipTexturev: __Z49Register_UnityEngine_GUI_InitializeGUIClipTexturev, __Z28CalculateGlobalMatrixInverse23TransformAccessReadOnly: __Z28CalculateGlobalMatrixInverse23TransformAccessReadOnly, _lchmod: _lchmod, __ZN20SphericalHarmonicsL26GetPtrEN18SphericalHarmonics12ColorChannelE: __ZN20SphericalHarmonicsL26GetPtrEN18SphericalHarmonics12ColorChannelE, __Z41TerrainData_Get_Custom_PropAlphamapLayersP12Il2CppObject: __Z41TerrainData_Get_Custom_PropAlphamapLayersP12Il2CppObject, __ZN4gles15UpdateDepthTestER15DeviceStateGLESPK20DeviceDepthStateGLESb: __ZN4gles15UpdateDepthTestER15DeviceStateGLESPK20DeviceDepthStateGLESb, ___ctype_toupper_loc: ___ctype_toupper_loc, __ZNK5physx15PxsParticleData15getWorldBoundsVEv: __ZNK5physx15PxsParticleData15getWorldBoundsVEv, _UNITY_png_write_sCAL_s: _UNITY_png_write_sCAL_s, __ZN13MonoBehaviour19ReleaseMonoInstanceEv: __ZN13MonoBehaviour19ReleaseMonoInstanceEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj49ES2_jEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj49ES2_jEEEEvjRT_, __ZN4FMOD8ChannelI17get3DConeSettingsEPfS1_S1_: __ZN4FMOD8ChannelI17get3DConeSettingsEPfS1_S1_, __GLOBAL__sub_I_ExtDefaultSimulationFilterShader_cpp: __GLOBAL__sub_I_ExtDefaultSimulationFilterShader_cpp, __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeMultiplierP12Il2CppObject: __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetMagnitudeMultiplierP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPhNS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPhNS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z29setPxSceneDescSolverBatchSizePN5physx11PxSceneDescEj: __Z29setPxSceneDescSolverBatchSizePN5physx11PxSceneDescEj, __Z42WindZone_Set_Custom_PropWindPulseFrequencyP12Il2CppObjectf: __Z42WindZone_Set_Custom_PropWindPulseFrequencyP12Il2CppObjectf, __ZN8WindZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8WindZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx17PxsContactManager16resetCachedStateEv: __ZN5physx17PxsContactManager16resetCachedStateEv, __ZNSt3__25ctypeIcE13classic_tableEv: __ZNSt3__25ctypeIcE13classic_tableEv, __ZN15CollisionModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN15CollisionModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState, __ZN4FMOD6SoundI7releaseEv: __ZN4FMOD6SoundI7releaseEv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15setActorSimFlagEb: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15setActorSimFlagEb, __ZN14SpriteRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN14SpriteRenderer13AwakeFromLoadE17AwakeFromLoadMode, __ZNKSt3__27codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_: __ZNKSt3__27codecvtIDic11__mbstate_tE5do_inERS1_PKcS5_RS5_PDiS7_RS7_, __ZN5audio5mixer13GroupConstant8TransferI14SafeBinaryReadEEvRT_: __ZN5audio5mixer13GroupConstant8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__210__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t: __ZNSt3__210__stdinbufIcEC2EP8_IO_FILEP11__mbstate_t, __Z35getPxClothStretchConfigStretchLimitPKN5physx20PxClothStretchConfigE: __Z35getPxClothStretchConfigStretchLimitPKN5physx20PxClothStretchConfigE, __ZN10MemoryFile9SetLengthEy: __ZN10MemoryFile9SetLengthEy, __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim10ValueArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZL24StaticInitializeIUnityVRPv: __ZL24StaticInitializeIUnityVRPv, __ZNK15b2RevoluteJoint10GetAnchorBEv: __ZNK15b2RevoluteJoint10GetAnchorBEv, __ZNK5physx3Cct26CharacterControllerManager16getNbControllersEv: __ZNK5physx3Cct26CharacterControllerManager16getNbControllersEv, __Z73Register_UnityEngine_Application_GetUserAuthorizationRequestMode_Internalv: __Z73Register_UnityEngine_Application_GetUserAuthorizationRequestMode_Internalv, __Z40Register_UnityEngine_Light_get_spotAnglev: __Z40Register_UnityEngine_Light_get_spotAnglev, __ZN16ParticleRenderer11UVAnimation8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16ParticleRenderer11UVAnimation8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sc19ShapeInstancePairLL19getContactPointDataERPKvRjS5_RPKfj: __ZN5physx2Sc19ShapeInstancePairLL19getContactPointDataERPKvRjS5_RPKfj, __ZNK9ShaderLab10SubProgram14EnsureCompiledEv: __ZNK9ShaderLab10SubProgram14EnsureCompiledEv, __ZN5Flare23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Flare23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_: __ZNSt3__27__sort3IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_T_, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6resizeEj: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6resizeEj, __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE17handleBufferFlushEPKhj: __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE17handleBufferFlushEPKhj, __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_S5_T_, __ZNK16LevelGameManager7GetNameEv: __ZNK16LevelGameManager7GetNameEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE, __Z11bucketAllocP11BucketAlloc: __Z11bucketAllocP11BucketAlloc, __Z40getPxArticulationJoint_TwistLimitEnabledPKN5physx19PxArticulationJointE: __Z40getPxArticulationJoint_TwistLimitEnabledPKN5physx19PxArticulationJointE, __Z34FindAncestorComponentExactTypeImplR10GameObjecti: __Z34FindAncestorComponentExactTypeImplR10GameObjecti, __ZN18UnityConnectClient15GetCloudServiceEv: __ZN18UnityConnectClient15GetCloudServiceEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx20PxsConstraintProjectEPKNS_13PxsConstraintEbf: __ZN5physx20PxsConstraintProjectEPKNS_13PxsConstraintEbf, __ZN5physx7NpShape7setFlagENS_11PxShapeFlag4EnumEb: __ZN5physx7NpShape7setFlagENS_11PxShapeFlag4EnumEb, __ZThn8_N12_GLOBAL__N_117ConnectionManagerD1Ev: __ZThn8_N12_GLOBAL__N_117ConnectionManagerD1Ev, __ZNSt3__215system_categoryEv: __ZNSt3__215system_categoryEv, __ZN15b2CircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN15b2CircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv: __ZN10TagManager32RegisterDefaultTagsAndLayerMasksEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE: __ZN5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE, __ZL11term_sourceP22jpeg_decompress_struct: __ZL11term_sourceP22jpeg_decompress_struct, __Z50Register_UnityEngine_WheelCollider_set_motorTorquev: __Z50Register_UnityEngine_WheelCollider_set_motorTorquev, __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_119parse_operator_nameINS0_2DbEEEPKcS4_S4_RT_, __ZN5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj: __ZN5physx2Sc35ParticleElementRbElementInteraction12onDeactivateEj, __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j: __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j, __ZN10GameObject28IsActiveIgnoreImplicitPrefabEv: __ZN10GameObject28IsActiveIgnoreImplicitPrefabEv, __Z44AreaEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject: __Z44AreaEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject, __ZNK6Shader19GetMaximumShaderLODEv: __ZNK6Shader19GetMaximumShaderLODEv, __ZN5physx2Gu30checkOverlapCapsule_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu30checkOverlapCapsule_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, __ZN16RenderTextureMap7CleanupEv: __ZN16RenderTextureMap7CleanupEv, __Z40getPxArticulationJoint_SwingLimitEnabledPKN5physx19PxArticulationJointE: __Z40getPxArticulationJoint_SwingLimitEnabledPKN5physx19PxArticulationJointE, __Z36getPxVehicleDrive4W_ConcreteTypeNamePKN5physx16PxVehicleDrive4WE: __Z36getPxVehicleDrive4W_ConcreteTypeNamePKN5physx16PxVehicleDrive4WE, __ZNK5physx7NpCloth18getNbRestPositionsEv: __ZNK5physx7NpCloth18getNbRestPositionsEv, __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE: __ZN5physx23PxVehicleWheels4SimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE, __ZN19MeshParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN19MeshParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _fmemopen: _fmemopen, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj47ENS_22PxRepXPropertyAccessorILj47ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj47ENS_22PxRepXPropertyAccessorILj47ES4_ffEEEEvRKT0_, __ZN4gles8InitCapsEP7ApiGLESP12GraphicsCapsR16GfxDeviceLevelGL: __ZN4gles8InitCapsEP7ApiGLESP12GraphicsCapsR16GfxDeviceLevelGL, __ZNK9Heightmap9GetHeightEii: __ZNK9Heightmap9GetHeightEii, __ZNKSt3__217moneypunct_bynameIwLb1EE16do_decimal_pointEv: __ZNKSt3__217moneypunct_bynameIwLb1EE16do_decimal_pointEv, __ZN6prcore14BlitImageFloatERK14ImageReferenceRS0_NS0_8BlitModeE: __ZN6prcore14BlitImageFloatERK14ImageReferenceRS0_NS0_8BlitModeE, __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEce: __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEce, __Z24CalculateVertexLightDataRK15SharedLightDataR14GfxVertexLight: __Z24CalculateVertexLightDataRK15SharedLightDataR14GfxVertexLight, __ZL35ResetRandSeedForMeshParticleEmitterv: __ZL35ResetRandSeedForMeshParticleEmitterv, __Z34CleanupUnityCloudWebServicesModulev: __Z34CleanupUnityCloudWebServicesModulev, __ZNK9ShaderLab7Program28BeginReadUnsupportedVariantsEv: __ZNK9ShaderLab7Program28BeginReadUnsupportedVariantsEv, __Z16InitializeMemoryv: __Z16InitializeMemoryv, __ZN12b2MouseJoint11SetMaxForceEf: __ZN12b2MouseJoint11SetMaxForceEf, __ZN5physx2Sq8AABBTreeC2Ev: __ZN5physx2Sq8AABBTreeC2Ev, __Z48Register_UnityEngine_ReflectionProbe_RenderProbev: __Z48Register_UnityEngine_ReflectionProbe_RenderProbev, __ZN11TrailModuleD2Ev: __ZN11TrailModuleD2Ev, __ZN13MonoBehaviour22StartCoroutineManaged2EP12Il2CppObject: __ZN13MonoBehaviour22StartCoroutineManaged2EP12Il2CppObject, __Z23getPxConstraint_IsValidPKN5physx12PxConstraintE: __Z23getPxConstraint_IsValidPKN5physx12PxConstraintE, _wcspbrk: _wcspbrk, __ZN5physx27PxRigidActorGeneratedValuesC2EPKNS_12PxRigidActorE: __ZN5physx27PxRigidActorGeneratedValuesC2EPKNS_12PxRigidActorE, __ZN18PlatformEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18PlatformEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode, _LzmaDec_Allocate: _LzmaDec_Allocate, __ZN5Umbra16testBitRangeFullEPKjii: __ZN5Umbra16testBitRangeFullEPKjii, __ZN14UnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventE: __ZN14UnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventE, __Z44Register_UnityEngine_SliderJoint2D_set_anglev: __Z44Register_UnityEngine_SliderJoint2D_set_anglev, __Z68Register_UnityEngine_Networking_UnityWebRequest_get_downloadProgressv: __Z68Register_UnityEngine_Networking_UnityWebRequest_get_downloadProgressv, __ZNKSt3__212ctype_bynameIcE10do_toupperEPcPKc: __ZNKSt3__212ctype_bynameIcE10do_toupperEPcPKc, __ZN11UnityEngine7Connect15DeviceInfoEvent16CollectExtraInfoEv: __ZN11UnityEngine7Connect15DeviceInfoEvent16CollectExtraInfoEv, __ZN2UI15DoSyncTransformERNS_13UIInstructionERK10Matrix4x4f: __ZN2UI15DoSyncTransformERNS_13UIInstructionERK10Matrix4x4f, __ZN10HumanTrait11GetBoneNameEv: __ZN10HumanTrait11GetBoneNameEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKc, __ZN5physx2Gu10ConvexMeshD2Ev: __ZN5physx2Gu10ConvexMeshD2Ev, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, _atoi: _atoi, _atol: _atol, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartColorv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartColorv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev: __ZN5physx29PxVehicleDrive4WGeneratedInfoC2Ev, __ZNK17ProceduralTexture11GetPixels32EiiiiP11ColorRGBA32: __ZNK17ProceduralTexture11GetPixels32EiiiiP11ColorRGBA32, __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputENS_6PxVec3ES5_j: __ZN5physx2Gu33MultiplePersistentContactManifold8drawLineERNS_2Cm12RenderOutputENS_6PxVec3ES5_j, __Z43Register_UnityEngine_GUITexture_get_texturev: __Z43Register_UnityEngine_GUITexture_get_texturev, __ZNK6Sprite24GetRenderDataForPlayModeEv: __ZNK6Sprite24GetRenderDataForPlayModeEv, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7ReleaseEPS2_: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7ReleaseEPS2_, __ZN5Unity14CharacterJointD0Ev: __ZN5Unity14CharacterJointD0Ev, __ZN12LineRenderer12CleanupClassEv: __ZN12LineRenderer12CleanupClassEv, __Z52Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYPostQv: __Z52Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYPostQv, __ZNK5physx2Sc8ShapeSim10getBodySimEv: __ZNK5physx2Sc8ShapeSim10getBodySimEv, __ZN13SpeedTreeWind16CopySettingsFromEPKS_: __ZN13SpeedTreeWind16CopySettingsFromEPKS_, ___msl_assertion_failed: ___msl_assertion_failed, __ZL20JpgWriteToBufferFuncPvS_i: __ZL20JpgWriteToBufferFuncPvS_i, _strcasestr: _strcasestr, _UNITY_tt_face_free_hdmx: _UNITY_tt_face_free_hdmx, __Z43Register_UnityEngine_HumanTrait_HasColliderv: __Z43Register_UnityEngine_HumanTrait_HasColliderv, __Z45Register_UnityEngine_Mesh_get_blendShapeCountv: __Z45Register_UnityEngine_Mesh_get_blendShapeCountv, __Z35Canvas_Set_Custom_PropPlaneDistanceP12Il2CppObjectf: __Z35Canvas_Set_Custom_PropPlaneDistanceP12Il2CppObjectf, _getppid: _getppid, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __Z36Time_Get_Custom_PropCaptureFrameratev: __Z36Time_Get_Custom_PropCaptureFrameratev, _fwprintf: _fwprintf, __ZN21BillboardBatchManager24FillInstanceDataFromNodeERNS_17BillboardInstanceERK15RenderNodeQueueRK18RenderMultipleDataj: __ZN21BillboardBatchManager24FillInstanceDataFromNodeERNS_17BillboardInstanceERK15RenderNodeQueueRK18RenderMultipleDataj, __ZN5Umbra10Visibility14setInputBufferEPKNS_15OcclusionBufferE: __ZN5Umbra10Visibility14setInputBufferEPKNS_15OcclusionBufferE, __Z59Register_UnityEngine_ReflectionProbe_get_customBakedTexturev: __Z59Register_UnityEngine_ReflectionProbe_get_customBakedTexturev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEE15growAndPushBackERKS2_, __ZN23UnityPurchasingSettingsC2Ev: __ZN23UnityPurchasingSettingsC2Ev, __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE: __ZN5physx2Gu27findRotationMatrixFromZAxisERKNS_6shdfnd3aos5Vec3VE, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE7reserveEj, __Z65Register_UnityEngine_StaticBatchingUtility_InternalCombineIndicesv: __Z65Register_UnityEngine_StaticBatchingUtility_InternalCombineIndicesv, __ZN5physx9NpPhysics20MeshDeletionListenerD0Ev: __ZN5physx9NpPhysics20MeshDeletionListenerD0Ev, __ZN22RenderingCommandBuffer18AddSetGlobalBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferID: __ZN22RenderingCommandBuffer18AddSetGlobalBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferID, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE6getDirEv, __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorERKNS_7NpShapeE: __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorERKNS_7NpShapeE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZZN9Rigidbody15InitializeClassEvEN35FunctorImpl_465kAnimatorMoveBuiltin4CallEPviR11MessageData: __ZZN9Rigidbody15InitializeClassEvEN35FunctorImpl_465kAnimatorMoveBuiltin4CallEPviR11MessageData, __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_: __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_, __ZN26AnimatorOverrideControllerC2E10MemLabelId18ObjectCreationMode: __ZN26AnimatorOverrideControllerC2E10MemLabelId18ObjectCreationMode, __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf: __ZL37stbir__resample_horizontal_downsampleP11stbir__infoiPf, __Z71Register_UnityEngine_ParticleSystem_MainModule_SetCustomSimulationSpacev: __Z71Register_UnityEngine_ParticleSystem_MainModule_SetCustomSimulationSpacev, __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState: __ZNK5Unity9Component38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState, __Z53ComputeBuffer_CUSTOM_INTERNAL_CALL_GetNativeBufferPtrP12Il2CppObjectRPv: __Z53ComputeBuffer_CUSTOM_INTERNAL_CALL_GetNativeBufferPtrP12Il2CppObjectRPv, __ZN22ScAfterIntegrationTask11runInternalEv: __ZN22ScAfterIntegrationTask11runInternalEv, __ZNSt3__212system_errorC2EiRKNS_14error_categoryE: __ZNSt3__212system_errorC2EiRKNS_14error_categoryE, __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv: __ZNK5physx2Sc9ClothCore23getExternalAccelerationEv, _UNITY_png_write_data: _UNITY_png_write_data, __ZNK7Texture21GetShadowSamplingModeEv: __ZNK7Texture21GetShadowSamplingModeEv, __ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE: __ZN5physx2Gu13coarseCullingERKNS_6PxVec3ES3_ffRKNS_10PxTriangleE, __ZN13ScreenManager21OnWindowRegainedFocusEv: __ZN13ScreenManager21OnWindowRegainedFocusEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5Unity10HingeJoint14WriteUseLimitsEv: __ZN5Unity10HingeJoint14WriteUseLimitsEv, __Z56Register_UnityEngine_Camera_INTERNAL_get_backgroundColorv: __Z56Register_UnityEngine_Camera_INTERNAL_get_backgroundColorv, __ZN5physx6shdfnd4sortINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS3_25SortCUDAProfileOccurencesENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS3_25SortCUDAProfileOccurencesENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j, __ZNSt3__25stoldERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj: __ZNSt3__25stoldERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj, __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IR12GCHandleLessPNS_4pairIyiEEEEjT0_S6_S6_S6_T_, _UNITY_png_get_x_offset_pixels: _UNITY_png_get_x_offset_pixels, __ZN5physx2Sc5Scene29processNarrowPhaseTouchEventsEv: __ZN5physx2Sc5Scene29processNarrowPhaseTouchEventsEv, __ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE: __ZN4crnd12symbol_codec32decode_receive_static_data_modelERNS_25static_huffman_data_modelE, __ZN18ScriptingArguments8AddFloatEf: __ZN18ScriptingArguments8AddFloatEf, __ZN12NavMeshAgent16AddToCrowdSystemEv: __ZN12NavMeshAgent16AddToCrowdSystemEv, __ZN12AdsIdHandler10FetchAdsIdEv: __ZN12AdsIdHandler10FetchAdsIdEv, __ZN8RemapperC2Ev: __ZN8RemapperC2Ev, __Z71Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshMaterialIndexv: __Z71Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshMaterialIndexv, _UNITY_png_set_sCAL: _UNITY_png_set_sCAL, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEE15growAndPushBackERKS2_, __Z18Transfer_BlittableI9JSONWriteLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z53Register_UnityEngine_AI_NavMeshAgent_set_walkableMaskv: __Z53Register_UnityEngine_AI_NavMeshAgent_set_walkableMaskv, __ZN5Unity11SpringJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity11SpringJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine15CloudWebService14DataDispatcher34OnSessionContainerArchivedAndReadyERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher34OnSessionContainerArchivedAndReadyERNS0_16SessionContainerE, __ZN5physx7NpCloth23sendPvdSimplePropertiesEv: __ZN5physx7NpCloth23sendPvdSimplePropertiesEv, __ZN7b2World11CreateJointEPK10b2JointDef: __ZN7b2World11CreateJointEPK10b2JointDef, __ZN5physx16PxsBroadPhaseMBP7destroyEv: __ZN5physx16PxsBroadPhaseMBP7destroyEv, __ZN13EmscriptenWWW10OnResponseEPviS0_jPc: __ZN13EmscriptenWWW10OnResponseEPviS0_jPc, __ZNSt13runtime_errorD0Ev: __ZNSt13runtime_errorD0Ev, __ZN23ParticleSystemParticles20SetUsesTriggerEventsEb: __ZN23ParticleSystemParticles20SetUsesTriggerEventsEb, __ZNK5physx3Cct15ObstacleContext11getObstacleEj: __ZNK5physx3Cct15ObstacleContext11getObstacleEj, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUVChannelMaskv: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUVChannelMaskv, __ZN5physx6shdfnd7PAUtils14isEventEnabledEt: __ZN5physx6shdfnd7PAUtils14isEventEnabledEt, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15TerrainRenderer13BuildRendererER12QuadTreeNodebi: __ZN15TerrainRenderer13BuildRendererER12QuadTreeNodebi, __ZN5physx12NpBatchQueryC2ERNS_7NpSceneERKNS_16PxBatchQueryDescE: __ZN5physx12NpBatchQueryC2ERNS_7NpSceneERKNS_16PxBatchQueryDescE, __ZN14PreloadManagerD2Ev: __ZN14PreloadManagerD2Ev, _gray_move_to: _gray_move_to, __Z34GetNonInterpolatedLightAttenuationRK17LightProbeContextjPK15SharedLightData: __Z34GetNonInterpolatedLightAttenuationRK17LightProbeContextjPK15SharedLightData, __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __Z63Register_UnityEngine_TerrainData_set_Internal_baseMapResolutionv: __Z63Register_UnityEngine_TerrainData_set_Internal_baseMapResolutionv, __ZN15LightProbeGroup23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15LightProbeGroup23VirtualRedirectTransferER17RemapPPtrTransfer, __Z42Register_UnityEngine_Animation_RemoveClip2v: __Z42Register_UnityEngine_Animation_RemoveClip2v, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __Z61Register_UnityEngine_ParticleSystem_MainModule_SetPlayOnAwakev: __Z61Register_UnityEngine_ParticleSystem_MainModule_SetPlayOnAwakev, __ZN13MemoryManager21RemoveCustomAllocatorERK10MemLabelId: __ZN13MemoryManager21RemoveCustomAllocatorERK10MemLabelId, __ZN20LocalFileSystemPosixD0Ev: __ZN20LocalFileSystemPosixD0Ev, __Z23GetGlobalBoolPreferencePKcb: __Z23GetGlobalBoolPreferencePKcb, __ZNK7Terrain12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE: __ZNK7Terrain12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE, __Z29DirectorPlayer_CUSTOM_SetTimeP12Il2CppObjectd: __Z29DirectorPlayer_CUSTOM_SetTimeP12Il2CppObjectd, __ZNK5Umbra10PortalInfo17getNumGateIndicesEv: __ZNK5Umbra10PortalInfo17getNumGateIndicesEv, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z25GetTransformationMatricesPN4math8float3x3ES1_bbRK10Matrix4x4fS4_: __Z25GetTransformationMatricesPN4math8float3x3ES1_bbRK10Matrix4x4fS4_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13setBreakForceEff, __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayPvPy: __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayPvPy, __ZN4PPtrI14ParticleSystemE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI14ParticleSystemE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZL22DrawParticlesWithPivotILb1EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL22DrawParticlesWithPivotILb1EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZN5physx13IslandManager6resizeEj: __ZN5physx13IslandManager6resizeEj, __ZN4PPtrI6CameraE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI6CameraE8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekoffExNS_8ios_base7seekdirEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekoffExNS_8ios_base7seekdirEj, __ZNK5Unity10HingeJoint14GetLocalFramesERN5physx11PxTransformES3_: __ZNK5Unity10HingeJoint14GetLocalFramesERN5physx11PxTransformES3_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_, __ZL25ProgramUniformMatrix4x2fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix4x2fvPK7ApiGLESjiihPKv, __Z21IsCompensatingSensorsv: __Z21IsCompensatingSensorsv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags, __ZN4FMOD5Sound15deleteSyncPointEP14FMOD_SYNCPOINT: __ZN4FMOD5Sound15deleteSyncPointEP14FMOD_SYNCPOINT, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEjw, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv, __Z43Register_UnityEngine_Application_CancelQuitv: __Z43Register_UnityEngine_Application_CancelQuitv, __ZN7Terrain13OnTreeUpdatedEi: __ZN7Terrain13OnTreeUpdatedEi, __ZN9AudioClip7CleanupEv: __ZN9AudioClip7CleanupEv, __ZN14AvatarPlaybackD0Ev: __ZN14AvatarPlaybackD0Ev, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorINS2_12basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES7_ISA_LS8_1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorINS2_12basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES7_ISA_LS8_1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN8VRDevice7PreCullEP6Camerab: __ZN8VRDevice7PreCullEP6Camerab, __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIjPNS_11__tree_nodeIjS8_EEiEESB_RKT_: __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIjPNS_11__tree_nodeIjS8_EEiEESB_RKT_, __Z31getPxClothTetherConfigStiffnessPKN5physx19PxClothTetherConfigE: __Z31getPxClothTetherConfigStiffnessPKN5physx19PxClothTetherConfigE, __ZN7mecanim9animation9xformCondEbRKN4math4trsXES4_: __ZN7mecanim9animation9xformCondEbRKN4math4trsXES4_, __ZL20updateMassAndInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb: __ZL20updateMassAndInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb, __Z18Transfer_BlittableI8JSONReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx24NpPtrTableStorageManagerC2Ev: __ZN5physx24NpPtrTableStorageManagerC2Ev, __ZN7mecanim9animation21BlendTreeNodeConstant35Transfer_4_0_BackwardsCompatibilityI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant35Transfer_4_0_BackwardsCompatibilityI14SafeBinaryReadEEvRT_, __Z42Application_Get_Custom_PropSubmitAnalyticsv: __Z42Application_Get_Custom_PropSubmitAnalyticsv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE12readPropertyIfEEbRT_, __ZN4FMOD8ChannelI13getLoopPointsEPjjS1_j: __ZN4FMOD8ChannelI13getLoopPointsEPjjS1_j, __ZN5Umbra12QueryContext10isGateOpenERKNS_10MappedTileERKNS_6PortalE: __ZN5Umbra12QueryContext10isGateOpenERKNS_10MappedTileERKNS_6PortalE, __ZNK9GfxDevice13GetViewMatrixEv: __ZNK9GfxDevice13GetViewMatrixEv, __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb: __ZN17RemapPPtrTransferC2E24TransferInstructionFlagsb, __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN8TypeTree8BlobReadERPKhS1_ib: __ZN8TypeTree8BlobReadERPKhS1_ib, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8ContainsEPKv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8ContainsEPKv, _UNITY_FT_Stroker_GetCounts: _UNITY_FT_Stroker_GetCounts, __Z48Register_UnityEngine_Input_set_multiTouchEnabledv: __Z48Register_UnityEngine_Input_set_multiTouchEnabledv, __Z36CreateScriptingArrayFromUnityObjectsI13dynamic_arrayIP6ObjectLj4EEEP11Il2CppArrayRKT_i: __Z36CreateScriptingArrayFromUnityObjectsI13dynamic_arrayIP6ObjectLj4EEEP11Il2CppArrayRKT_i, __Z44Register_UnityEngine_AudioClip_Init_Internalv: __Z44Register_UnityEngine_AudioClip_Init_Internalv, __ZN5physx3Ext23DefaultBufferedProfilerD2Ev: __ZN5physx3Ext23DefaultBufferedProfilerD2Ev, __ZN18LoadSceneOperation23GetAllowSceneActivationEv: __ZN18LoadSceneOperation23GetAllowSceneActivationEv, __Z42Register_UnityEngine_SortingLayer_IDToNamev: __Z42Register_UnityEngine_SortingLayer_IDToNamev, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_, __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN11prophecysdk4half7convertEi: __ZN11prophecysdk4half7convertEi, __ZN4Mesh26CreateDefaultFormatChannelE13ShaderChannel: __ZN4Mesh26CreateDefaultFormatChannelE13ShaderChannel, _UNITY_png_set_bKGD: _UNITY_png_set_bKGD, _FT_Init_Class_cff_service_properties: _FT_Init_Class_cff_service_properties, __ZN6CameraD0Ev: __ZN6CameraD0Ev, __Z48Register_UnityEngine_Material_GetMatrixArrayImplv: __Z48Register_UnityEngine_Material_GetMatrixArrayImplv, _jpeg_finish_output: _jpeg_finish_output, __ZN31CanvasBatchIntermediateRenderer16StaticInitializeEPv: __ZN31CanvasBatchIntermediateRenderer16StaticInitializeEPv, __ZNK15RelativeJoint2D9GetTargetEv: __ZNK15RelativeJoint2D9GetTargetEv, __Z16CollectDrawStatsR9DrawStats: __Z16CollectDrawStatsR9DrawStats, __ZN5physx3Cct10Controller4moveERNS0_11SweptVolumeERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextEb: __ZN5physx3Cct10Controller4moveERNS0_11SweptVolumeERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextEb, __ZN13MemoryManager16GetAllocatorNameEi: __ZN13MemoryManager16GetAllocatorNameEi, __Z52Register_UnityEngine_CapsuleCollider2D_set_directionv: __Z52Register_UnityEngine_CapsuleCollider2D_set_directionv, _raccess_guess_apple_double: _raccess_guess_apple_double, __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddExplosionForceP12Il2CppObjectfRK8Vector3fffi: __Z48Rigidbody_CUSTOM_INTERNAL_CALL_AddExplosionForceP12Il2CppObjectfRK8Vector3fffi, __ZL18ProgramUniform1uivPK7ApiGLESjiihPKv: __ZL18ProgramUniform1uivPK7ApiGLESjiihPKv, __ZN27ShapeModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN27ShapeModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN14Texture2DArray13RebuildMipMapEv: __ZN14Texture2DArray13RebuildMipMapEv, __ZNK5Umbra4Tome15getClusterCountEv: __ZNK5Umbra4Tome15getClusterCountEv, __Z18Transfer_BlittableI14SafeBinaryReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__217moneypunct_bynameIwLb1EE11do_groupingEv: __ZNKSt3__217moneypunct_bynameIwLb1EE11do_groupingEv, __ZN9ShaderLab20SerializedSubProgram14AddVectorParamEPKcii15ShaderParamTypei: __ZN9ShaderLab20SerializedSubProgram14AddVectorParamEPKcii15ShaderParamTypei, __Z34AnimationState_Get_Custom_PropClipP12Il2CppObject: __Z34AnimationState_Get_Custom_PropClipP12Il2CppObject, __Z57Register_UnityEngine_Connect_UnityAdsSettings_set_enabledv: __Z57Register_UnityEngine_Connect_UnityAdsSettings_set_enabledv, __ZN8VRDevice18ReleaseEyeTexturesEv: __ZN8VRDevice18ReleaseEyeTexturesEv, __Z46Register_UnityEngine_Cloth_get_sphereCollidersv: __Z46Register_UnityEngine_Cloth_get_sphereCollidersv, __ZN2UI14CanvasRenderer12CleanupClassEv: __ZN2UI14CanvasRenderer12CleanupClassEv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMinCCDAdvanceCoefficientEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMinCCDAdvanceCoefficientEv, __ZN12_GLOBAL__N_111storeBoundsI8Scalar4fEEvPfRKN5physx5cloth11BoundingBoxIT_EE: __ZN12_GLOBAL__N_111storeBoundsI8Scalar4fEEvPfRKN5physx5cloth11BoundingBoxIT_EE, __ZN16ParticleRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16ParticleRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx19ext1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx19ext1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN9ShaderLab9IntShader19SetMaximumShaderLODEP6Shaderi: __ZN9ShaderLab9IntShader19SetMaximumShaderLODEP6Shaderi, __Z16getPxActor_ScenePKN5physx7PxActorE: __Z16getPxActor_ScenePKN5physx7PxActorE, __ZN11dtPathQueueC2Ev: __ZN11dtPathQueueC2Ev, __Z41Animator_CUSTOM_INTERNAL_CALL_MatchTargetP12Il2CppObjectRK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff: __Z41Animator_CUSTOM_INTERNAL_CALL_MatchTargetP12Il2CppObjectRK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff, __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb1EE: __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb1EE, __ZN13ScreenManager18SetAllowCursorLockEb: __ZN13ScreenManager18SetAllowCursorLockEb, __ZN4FMOD6System13get3DSettingsEPfS1_S1_: __ZN4FMOD6System13get3DSettingsEPfS1_S1_, __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI14SafeBinaryReadEEvRT_: __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__217moneypunct_bynameIcLb1EE13do_neg_formatEv: __ZNKSt3__217moneypunct_bynameIcLb1EE13do_neg_formatEv, __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_set_motorv: __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_set_motorv, __ZNK5physx2Sc10ClothShape8isActiveEv: __ZNK5physx2Sc10ClothShape8isActiveEv, __ZN23ParticleSystemParticles14element_assignEjj: __ZN23ParticleSystemParticles14element_assignEjj, __ZN9TextAsset8TransferI14SafeBinaryReadEEvRT_: __ZN9TextAsset8TransferI14SafeBinaryReadEEvRT_, __ZN18AudioLowPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18AudioLowPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z29ColorSpaceToTextureColorSpace10ColorSpace: __Z29ColorSpaceToTextureColorSpace10ColorSpace, __ZN5physx8debugger4comm10EndSectionD0Ev: __ZN5physx8debugger4comm10EndSectionD0Ev, __ZN5physx2Sq11PruningPoolD0Ev: __ZN5physx2Sq11PruningPoolD0Ev, __ZN16Physics2DManager13DynamicUpdateEv: __ZN16Physics2DManager13DynamicUpdateEv, __ZN16MemoryFileSystem8IsLockedERK13FileEntryData: __ZN16MemoryFileSystem8IsLockedERK13FileEntryData, __ZN3MBP15removeBoxPrunerEj: __ZN3MBP15removeBoxPrunerEj, __Z40DynamicGI_Get_Custom_PropUpdateThresholdv: __Z40DynamicGI_Get_Custom_PropUpdateThresholdv, __ZN5physx35PxClothStretchConfigGeneratedValuesC2EPKNS_20PxClothStretchConfigE: __ZN5physx35PxClothStretchConfigGeneratedValuesC2EPKNS_20PxClothStretchConfigE, __ZN14ParticleSystem23OnGeometryJobsScheduledEj: __ZN14ParticleSystem23OnGeometryJobsScheduledEj, __Z69Register_UnityEngine_AssetBundle_LoadAssetWithSubAssetsAsync_Internalv: __Z69Register_UnityEngine_AssetBundle_LoadAssetWithSubAssetsAsync_Internalv, __ZNK26DownloadHandlerAssetBundle22ShouldDiscardOperationEv: __ZNK26DownloadHandlerAssetBundle22ShouldDiscardOperationEv, __Z53ParticleSystemRenderer_Get_Custom_PropNormalDirectionP12Il2CppObject: __Z53ParticleSystemRenderer_Get_Custom_PropNormalDirectionP12Il2CppObject, __Z46Register_UnityEngine_MeshFilter_get_sharedMeshv: __Z46Register_UnityEngine_MeshFilter_get_sharedMeshv, __Z41GIDebugVisualisation_CUSTOM_StopCycleModev: __Z41GIDebugVisualisation_CUSTOM_StopCycleModev, __ZN13GfxDeviceNull11SetTexturesE10ShaderTypeiPK15GfxTextureParam: __ZN13GfxDeviceNull11SetTexturesE10ShaderTypeiPK15GfxTextureParam, __Z26CstToAnimationClipSettingsPKN7mecanim9animation18ClipMuscleConstantER21AnimationClipSettings: __Z26CstToAnimationClipSettingsPKN7mecanim9animation18ClipMuscleConstantER21AnimationClipSettings, __ZN11UnityEngine7Connect14RemoteSettings9GetStringERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEES8_: __ZN11UnityEngine7Connect14RemoteSettings9GetStringERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEES8_, __ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE: __ZN5physx2Sn5ConvX12loadMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE, ___openlog: ___openlog, __ZL15SweepBoxCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL15SweepBoxCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb: __ZN6Object17FindObjectsOfTypeEPKN5Unity4TypeER13dynamic_arrayIPS_Lj4EEb, __Z43Register_UnityEngine_Event_get_displayIndexv: __Z43Register_UnityEngine_Event_get_displayIndexv, __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5Umbra11InputStreamD2Ev: __ZN5Umbra11InputStreamD2Ev, __ZN5physx22getImpulseResponseSlowERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_: __ZN5physx22getImpulseResponseSlowERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_, __Z35Texture2D_CUSTOM_SetBlockOfPixels32P12Il2CppObjectiiiiP11Il2CppArrayi: __Z35Texture2D_CUSTOM_SetBlockOfPixels32P12Il2CppObjectiiiiP11Il2CppArrayi, __ZNKSt3__220__time_get_c_storageIwE7__weeksEv: __ZNKSt3__220__time_get_c_storageIwE7__weeksEv, __ZN13MonoBehaviour17RemoveFromManagerEv: __ZN13MonoBehaviour17RemoveFromManagerEv, __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext: __ZN14GraphicsHelper5ClearEjRK10ColorRGBAffjR17ShaderPassContext, __ZN12ImageFilters14AddImageFilterERK11ImageFilter: __ZN12ImageFilters14AddImageFilterERK11ImageFilter, __Z49Register_UnityEngine_LocationService_get_lastDatav: __Z49Register_UnityEngine_LocationService_get_lastDatav, __ZN10systeminfo18IsHandheldPlatformEv: __ZN10systeminfo18IsHandheldPlatformEv, __ZcoRK8Scalar4f: __ZcoRK8Scalar4f, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE5eraseEjj, __Z20ReadObjectFromVectorILb0EEvR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags: __Z20ReadObjectFromVectorILb0EEvR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags, __ZN13MemoryManagerC2Ev: __ZN13MemoryManagerC2Ev, __ZNKSt3__220__codecvt_utf8_utf16IwE16do_always_noconvEv: __ZNKSt3__220__codecvt_utf8_utf16IwE16do_always_noconvEv, __ZN12SkinMeshInfo10DeallocateEPS_: __ZN12SkinMeshInfo10DeallocateEPS_, __ZN5Umbra10Visibility15setInputObjectsEPKNS_9IndexListE: __ZN5Umbra10Visibility15setInputObjectsEPKNS_9IndexListE, __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_: __ZN15SerializeTraitsI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_, __Z24RegisterStrippedTypeInfoI16LevelGameManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI16LevelGameManagerEviPKcS2_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6substrEjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6substrEjj, __ZN20ArchiveStorageReader28AcquireAndPrefillUnusedBlockEjPNS_11CacheResultE: __ZN20ArchiveStorageReader28AcquireAndPrefillUnusedBlockEjPNS_11CacheResultE, __Z12NHxRoughnessIA4_tEvP9Texture2DPT_iiii: __Z12NHxRoughnessIA4_tEvP9Texture2DPT_iiii, __Z24RegisterStrippedTypeInfoI14SpriteRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI14SpriteRendererEviPKcS2_, __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRatiov: __Z57Register_UnityEngine_ParticleSystem_LightsModule_GetRatiov, __ZN16ScriptingManager27NativeTypeForScriptingClassEP11Il2CppClass: __ZN16ScriptingManager27NativeTypeForScriptingClassEP11Il2CppClass, __ZN13TrailRenderer19UpdateTransformInfoEv: __ZN13TrailRenderer19UpdateTransformInfoEv, __ZN18AsyncUploadManagerD2Ev: __ZN18AsyncUploadManagerD2Ev, __ZN9Transform5ResetEv: __ZN9Transform5ResetEv, __ZNSt3__212strstreambufC2EPKci: __ZNSt3__212strstreambufC2EPKci, __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z13RegisterClassI13OcclusionAreaEvv: __Z13RegisterClassI13OcclusionAreaEvv, __ZN29ParticleSystemPropertyBinding49InitializeParticleSystemAnimationBindingInterfaceEv: __ZN29ParticleSystemPropertyBinding49InitializeParticleSystemAnimationBindingInterfaceEv, __ZN9TextAsset9SetScriptERK8UnityStr: __ZN9TextAsset9SetScriptERK8UnityStr, __Z44Register_UnityEngine_Graphics_get_activeTierv: __Z44Register_UnityEngine_Graphics_get_activeTierv, __ZL35RegisterModuleICalls_ParticleSystemv: __ZL35RegisterModuleICalls_ParticleSystemv, __ZN15NavMeshObstacle8TransferI14SafeBinaryReadEEvRT_: __ZN15NavMeshObstacle8TransferI14SafeBinaryReadEEvRT_, __Z17MainLoopKeepalivePv: __Z17MainLoopKeepalivePv, __ZN5physx7NpScene16addActorInternalERNS_7PxActorE: __ZN5physx7NpScene16addActorInternalERNS_7PxActorE, __ZN5physx2Sn18writeAllPropertiesINS_18PxVehicleDriveTankEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_18PxVehicleDriveTankEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __ZN18CrashReportHandler25UnregisterGlobalCallbacksEv: __ZN18CrashReportHandler25UnregisterGlobalCallbacksEv, __Z24ScheduleCullingAllGroupsR8JobFenceRK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK13dynamic_arrayIP12CullingGroupLj4EERKS_: __Z24ScheduleCullingAllGroupsR8JobFenceRK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK13dynamic_arrayIP12CullingGroupLj4EERKS_, __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z32Texture_CUSTOM_Internal_GetWidthP12Il2CppObject: __Z32Texture_CUSTOM_Internal_GetWidthP12Il2CppObject, __Z57Register_UnityEngine_ConfigurableJoint_set_angularXMotionv: __Z57Register_UnityEngine_ConfigurableJoint_set_angularXMotionv, __ZN17SurfaceEffector2DD0Ev: __ZN17SurfaceEffector2DD0Ev, __Z105Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorStateInfoInternalv: __Z105Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorStateInfoInternalv, __Z29Animation_Get_Custom_PropClipP12Il2CppObject: __Z29Animation_Get_Custom_PropClipP12Il2CppObject, __Z14CalcHullBoundsPK8Vector3fPKhhRK5PlaneRK10Matrix4x4fR10MinMaxAABB: __Z14CalcHullBoundsPK8Vector3fPKhhRK5PlaneRK10Matrix4x4fR10MinMaxAABB, __Z42Application_Get_Custom_PropTargetFrameRatev: __Z42Application_Get_Custom_PropTargetFrameRatev, __ZN9Rigidbody18SetUseConeFrictionEb: __ZN9Rigidbody18SetUseConeFrictionEb, __Z19SetupLODFadeKeywordR17ShaderPassContexti: __Z19SetupLODFadeKeywordR17ShaderPassContexti, _UNITY_FT_Stream_ReadFields: _UNITY_FT_Stream_ReadFields, __ZNK16ParticleAnimator26GetTypeInfoVirtualInternalEv: __ZNK16ParticleAnimator26GetTypeInfoVirtualInternalEv, __ZNK5physx2Sn18RepXCollectionImpl11getUpVectorEv: __ZNK5physx2Sn18RepXCollectionImpl11getUpVectorEv, __ZN24UVModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN24UVModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKc, __ZN13dynamic_arrayI26EnlightenSystemInformationLj8EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI26EnlightenSystemInformationLj8EE6insertEPS0_PKS0_S4_, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13ThreadCleanupEv: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE13ThreadCleanupEv, __Z30getPxVehicleGearsDataMNbRatiosPKN5physx18PxVehicleGearsDataE: __Z30getPxVehicleGearsDataMNbRatiosPKN5physx18PxVehicleGearsDataE, __Z46Register_UnityEngine_GUI_Internal_BeginWindowsv: __Z46Register_UnityEngine_GUI_Internal_BeginWindowsv, __ZNSt3__219__shared_mutex_base11lock_sharedEv: __ZNSt3__219__shared_mutex_base11lock_sharedEv, __ZN13AvatarBuilder12GetAllParentER9TransformS1_RNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb: __ZN13AvatarBuilder12GetAllParentER9TransformS1_RNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEEb, __ZNK5physx2Sc5Scene20getMeshContactMarginEv: __ZNK5physx2Sc5Scene20getMeshContactMarginEv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z13RegisterClassI15OcclusionPortalEvv: __Z13RegisterClassI15OcclusionPortalEvv, __ZN4FMOD7SystemI9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE: __ZN4FMOD7SystemI9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE, __Z42Register_UnityEngine_AudioSource_set_pitchv: __Z42Register_UnityEngine_AudioSource_set_pitchv, __ZN13PhysicsModule31GetColliderComponentsInChildrenERK10GameObjectbbR13dynamic_arrayIPN5Unity9ComponentELj4EE: __ZN13PhysicsModule31GetColliderComponentsInChildrenERK10GameObjectbbR13dynamic_arrayIPN5Unity9ComponentELj4EE, __ZN24CompressedAnimationCurve18DecompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E: __ZN24CompressedAnimationCurve18DecompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E, __GLOBAL__sub_I_runtime_graphics_mesh2_lump_cpp: __GLOBAL__sub_I_runtime_graphics_mesh2_lump_cpp, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN8Animator12HasParameterEi: __ZN8Animator12HasParameterEi, __ZN17PhysicsMaterial2D5ResetEv: __ZN17PhysicsMaterial2D5ResetEv, __ZN22UnityWebRequestManager29RegisterDownloadScriptHandlerEP21DownloadHandlerScript: __ZN22UnityWebRequestManager29RegisterDownloadScriptHandlerEP21DownloadHandlerScript, _unzLocateFile: _unzLocateFile, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags, __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z46Register_UnityEngine_Random_INTERNAL_get_statev: __Z46Register_UnityEngine_Random_INTERNAL_get_statev, _realloc: _realloc, __ZN27ColorModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN27ColorModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __Z57Register_UnityEngine_Transform_INTERNAL_get_localRotationv: __Z57Register_UnityEngine_Transform_INTERNAL_get_localRotationv, __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetMatrixv: __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetMatrixv, __ZN5Unity17ConfigurableJointD0Ev: __ZN5Unity17ConfigurableJointD0Ev, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE4swapERS3_: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE4swapERS3_, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER17RemapPPtrTransfer, __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetCenterOfMassv: __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetCenterOfMassv, __ZN4crnd31crnd_get_fundamental_dxt_formatE10crn_format: __ZN4crnd31crnd_get_fundamental_dxt_formatE10crn_format, __ZN17GeneralConnection13MulticastInfo16SetLocalhostFlagEv: __ZN17GeneralConnection13MulticastInfo16SetLocalhostFlagEv, __ZN11AudioSource21SetCustomRolloffCurveERK17AnimationCurveTplIfE: __ZN11AudioSource21SetCustomRolloffCurveERK17AnimationCurveTplIfE, __GLOBAL__sub_I_PxsFluidDynamics_cpp: __GLOBAL__sub_I_PxsFluidDynamics_cpp, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i: __ZN17AnimationPlayable26DisconnectNoTopologyChangeEPS_i, __ZNK5physx12NpBatchQuery14getOwnerClientEv: __ZNK5physx12NpBatchQuery14getOwnerClientEv, __ZN4FMOD4DSPI8getInputEiPPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD4DSPI8getInputEiPPNS_3DSPEPPNS_13DSPConnectionE, __Z43DestroyWithoutLoadingButDontDestroyFromFilei: __Z43DestroyWithoutLoadingButDontDestroyFromFilei, __ZN5physx2Sc21ArticulationJointCore28setSwingLimitContactDistanceEf: __ZN5physx2Sc21ArticulationJointCore28setSwingLimitContactDistanceEf, __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient: __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient, __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getConstraintsEPPNS_12PxConstraintEjj: __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getConstraintsEPPNS_12PxConstraintEjj, __ZZN2UI14CanvasRenderer15InitializeClassEvEN34FunctorImpl_802kCanvasGroupChanged4CallEPviR11MessageData: __ZZN2UI14CanvasRenderer15InitializeClassEvEN34FunctorImpl_802kCanvasGroupChanged4CallEPviR11MessageData, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __Z28Shader_CUSTOM_SetGlobalFloatif: __Z28Shader_CUSTOM_SetGlobalFloatif, __Z13RegisterClassI15DistanceJoint2DEvv: __Z13RegisterClassI15DistanceJoint2DEvv, __Z44Register_UnityEngine_Animator_get_avatarRootv: __Z44Register_UnityEngine_Animator_get_avatarRootv, __ZN5audio5mixer23GetExposedPropertyValueERKNS0_16AudioMixerMemoryEi: __ZN5audio5mixer23GetExposedPropertyValueERKNS0_16AudioMixerMemoryEi, __Z46ParticleSystem_MainModule_CUSTOM_GetStartColorP12Il2CppObjectR18MonoMinMaxGradient: __Z46ParticleSystem_MainModule_CUSTOM_GetStartColorP12Il2CppObjectR18MonoMinMaxGradient, __ZL8ClipPolyPK8Vector3fiPS_RS0_f: __ZL8ClipPolyPK8Vector3fiPS_RS0_f, __Z20scripting_string_newPKc: __Z20scripting_string_newPKc, __Z21EvalTriUVUsingEdgeLenRK8Vector3fS1_S1_RK8Vector2fS4_S4_ff: __Z21EvalTriUVUsingEdgeLenRK8Vector3fS1_S1_RK8Vector2fS4_S4_ff, __Z50ParticleSystem_CUSTOM_INTERNAL_set_startRotation3DP12Il2CppObjectRK8Vector3f: __Z50ParticleSystem_CUSTOM_INTERNAL_set_startRotation3DP12Il2CppObjectRK8Vector3f, __Z43Material_CUSTOM_Internal_CreateWithMaterialP12Il2CppObjectS0_: __Z43Material_CUSTOM_Internal_CreateWithMaterialP12Il2CppObjectS0_, __Z45Register_UnityEngine_BillboardAsset_set_widthv: __Z45Register_UnityEngine_BillboardAsset_set_widthv, __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetPlayStateInternalv: __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetPlayStateInternalv, __Z47Register_UnityEngine_TargetJoint2D_get_maxForcev: __Z47Register_UnityEngine_TargetJoint2D_get_maxForcev, __ZN29AssetBundleLoadAssetOperation34CollectFullPreloadDataDependenciesER13dynamic_arrayIiLj4EE: __ZN29AssetBundleLoadAssetOperation34CollectFullPreloadDataDependenciesER13dynamic_arrayIiLj4EE, __ZNSt3__227__num_get_unsigned_integralIjEET_PKcS3_Rji: __ZNSt3__227__num_get_unsigned_integralIjEET_PKcS3_Rji, __Z13PlayerCleanupb: __Z13PlayerCleanupb, __ZN5physx2Gu17intersectPlaneBoxERKNS_7PxPlaneERKNS0_3BoxE: __ZN5physx2Gu17intersectPlaneBoxERKNS_7PxPlaneERKNS0_3BoxE, __Z44Register_UnityEngine_Joint_set_connectedBodyv: __Z44Register_UnityEngine_Joint_set_connectedBodyv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMaxDepenetrationVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27getMaxDepenetrationVelocityEv, __ZN6Avatar23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Avatar23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN15NavMeshObstacle8SetShapeE20NavMeshObstacleShape: __ZN15NavMeshObstacle8SetShapeE20NavMeshObstacleShape, _init_mem_destination: _init_mem_destination, __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb1EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb1EEEEEvPT_, __ZThn8_N5physx2Gu11HeightFieldD1Ev: __ZThn8_N5physx2Gu11HeightFieldD1Ev, __Z20SetPlayerPauseDirect11PlayerPause: __Z20SetPlayerPauseDirect11PlayerPause, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED0Ev: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED0Ev, __ZN5physx6shdfnd5ArrayINS_2Sn15ImportReferenceENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn15ImportReferenceENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, _unity_z_deflateInit_: _unity_z_deflateInit_, __ZN11IMGUIModule26SetDeveloperConsoleVisibleEb: __ZN11IMGUIModule26SetDeveloperConsoleVisibleEb, __ZN5physx20PxsParticleSystemSim24setCollisionCacheInvalidERKNS_16PxsParticleShapeERKNS_2Gu13GeometryUnionE: __ZN5physx20PxsParticleSystemSim24setCollisionCacheInvalidERKNS_16PxsParticleShapeERKNS_2Gu13GeometryUnionE, __Z59Register_UnityEngine_ParticleEmitter_set_rndAngularVelocityv: __Z59Register_UnityEngine_ParticleEmitter_set_rndAngularVelocityv, __Z28Animator_CUSTOM_GetBehaviourP12Il2CppObjectS0_: __Z28Animator_CUSTOM_GetBehaviourP12Il2CppObjectS0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj470ENS_22PxRepXPropertyAccessorILj470ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj470ENS_22PxRepXPropertyAccessorILj470ES4_ffEEEEvRKT0_, __ZNK8GUIStyle13GetLineHeightEv: __ZNK8GUIStyle13GetLineHeightEv, __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES: __ZN18GfxFramebufferGLES18ReleaseFramebufferEP17RenderSurfaceBaseP14GfxContextGLES, __ZN9Scripting40InstantiateScriptingWrapperForNativeTypeEPKN5Unity4TypeE: __ZN9Scripting40InstantiateScriptingWrapperForNativeTypeEPKN5Unity4TypeE, __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE: __ZNK7ApiGLES15GetDriverStringEN2gl11DriverQueryE, __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_SlerpUnclampedv: __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_SlerpUnclampedv, __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv: __ZN19CloudServiceHandler34HandleSaveFileWebRequestPlayerLoopEv, __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi: __ZN5Umbra20RuntimeTomeGenerator15copyLeafPortalsEiiiRNS_5ArrayIjEERi, __ZN7mecanim21ValueArrayReverseCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi: __ZN7mecanim21ValueArrayReverseCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi, __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE: __Z31GetParentSampleClipFromInstancePN11SoundHandle8InstanceE, __ZNK28RectTransformPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK28RectTransformPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN5physx11PxHitBufferINS_12PxOverlapHitEE14processTouchesEPKS1_j: __ZN5physx11PxHitBufferINS_12PxOverlapHitEE14processTouchesEPKS1_j, __Z45Register_UnityEngine_Animator_get_pivotWeightv: __Z45Register_UnityEngine_Animator_get_pivotWeightv, __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_14PxTriangleMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZL22addOrRemoveRigidObjectILb0ELb0ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b: __ZL22addOrRemoveRigidObjectILb0ELb0ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b, ___h_errno_location: ___h_errno_location, __Z52Register_UnityEngine_AudioReverbZone_get_minDistancev: __Z52Register_UnityEngine_AudioReverbZone_get_minDistancev, __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_: __ZNKSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS8_, __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Scb14ParticleSystemD2Ev: __ZN5physx3Scb14ParticleSystemD2Ev, __Z52Object_CUSTOM_GetOffsetOfInstanceIDInCPlusPlusObjectv: __Z52Object_CUSTOM_GetOffsetOfInstanceIDInCPlusPlusObjectv, __ZN4FMOD6Reverb13setPropertiesEPK22FMOD_REVERB_PROPERTIES: __ZN4FMOD6Reverb13setPropertiesEPK22FMOD_REVERB_PROPERTIES, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEvPT_jRKT0_RKT1_j, __ZN9AudioClip15InitializeClassEv: __ZN9AudioClip15InitializeClassEv, __ZNK5physx9NpPhysics11getNbShapesEv: __ZNK5physx9NpPhysics11getNbShapesEv, setThrew: setThrew, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwjRKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwjRKS4_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN13RuntimeStaticI20HardwareInfoReporterE10InitializeEv: __ZN13RuntimeStaticI20HardwareInfoReporterE10InitializeEv, __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE: __ZN20TextRenderingPrivate19NativeTextGeneratorC2ERK11UTF16StringPNS_8FontImplE11ColorRGBA32ifRK8Vector2fbifiibffbbbP13dynamic_arrayIN2UI8UIVertexELj4EE, __Z20getPxShape_MaterialsPKN5physx7PxShapeEPPNS_10PxMaterialEj: __Z20getPxShape_MaterialsPKN5physx7PxShapeEPPNS_10PxMaterialEj, __Z35Light_Set_Custom_PropShadowStrengthP12Il2CppObjectf: __Z35Light_Set_Custom_PropShadowStrengthP12Il2CppObjectf, __Z50Register_UnityEngine_Animator_InterruptMatchTargetv: __Z50Register_UnityEngine_Animator_InterruptMatchTargetv, __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE: __Z25DoForwardShaderRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERK11CullResultsbbbN6Camera10RenderFlagE, __ZN5Umbra5Query16setGatePathCostsEPKfb: __ZN5Umbra5Query16setGatePathCostsEPKfb, __Z31AudioClip_Get_Custom_PropLengthP12Il2CppObject: __Z31AudioClip_Get_Custom_PropLengthP12Il2CppObject, __ZN4FMOD7Channel9getPausedEPb: __ZN4FMOD7Channel9getPausedEPb, __Z35Application_Get_Custom_PropSrcValuev: __Z35Application_Get_Custom_PropSrcValuev, __ZN17AudioChorusFilter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17AudioChorusFilter8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_ft_service_list_lookup: _UNITY_ft_service_list_lookup, __ZN11CustomArrayD2Ev: __ZN11CustomArrayD2Ev, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _init_source: _init_source, __ZN4FMOD12ChannelGroup15getSystemObjectEPPNS_6SystemE: __ZN4FMOD12ChannelGroup15getSystemObjectEPPNS_6SystemE, __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE: __ZN5physx14NpShapeManagerC2ERKNS_7PxEMPTYE, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZv, __ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_: __ZN5physx2Gu20intersectTriangleBoxERKNS_6PxVec3ES3_S3_S3_S3_, __ZNK26AnimatorControllerPlayable17ValidateGoToStateERiS0_: __ZNK26AnimatorControllerPlayable17ValidateGoToStateERiS0_, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __Z43DynamicGI_CUSTOM_UpdateMaterialsForRendererP12Il2CppObject: __Z43DynamicGI_CUSTOM_UpdateMaterialsForRendererP12Il2CppObject, __ZN5physx10NpMaterial8setFlagsENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE: __ZN5physx10NpMaterial8setFlagsENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE, __ZN13BaseAllocator13TryDeallocateEPv: __ZN13BaseAllocator13TryDeallocateEPv, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z52Register_UnityEngine_Physics2D_get_contactArrowScalev: __Z52Register_UnityEngine_Physics2D_get_contactArrowScalev, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv, __ZN16MemoryFileSystem5WriteER13FileEntryDatayPvPy: __ZN16MemoryFileSystem5WriteER13FileEntryDatayPvPy, __ZNK12b2MotorJoint17GetReactionTorqueEf: __ZNK12b2MotorJoint17GetReactionTorqueEf, __ZNSt3__26vectorIN12FlareManager10FlareEntryENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN12FlareManager10FlareEntryENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, _sprintf: _sprintf, __ZZN9LensFlare15InitializeClassEvEN32FunctorImpl_770kTransformChanged4CallEPviR11MessageData: __ZZN9LensFlare15InitializeClassEvEN32FunctorImpl_770kTransformChanged4CallEPviR11MessageData, __Z35RandomQuaternionUniformDistributionR4Rand: __Z35RandomQuaternionUniformDistributionR4Rand, __Z41Physics_CUSTOM_INTERNAL_CALL_CheckCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction: __Z41Physics_CUSTOM_INTERNAL_CALL_CheckCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction, __ZN13AudioListener17RemoveFromManagerEv: __ZN13AudioListener17RemoveFromManagerEv, __Z54Register_UnityEngine_BillboardAsset_GetIndicesInternalv: __Z54Register_UnityEngine_BillboardAsset_GetIndicesInternalv, __Z21IsThreadableGfxDevice17GfxDeviceRenderer: __Z21IsThreadableGfxDevice17GfxDeviceRenderer, __Z28Scene_CUSTOM_IsValidInternali: __Z28Scene_CUSTOM_IsValidInternali, __ZN5physx23PxsFluidDynamicsSphTaskD0Ev: __ZN5physx23PxsFluidDynamicsSphTaskD0Ev, __ZNK6Camera19GetProjectionMatrixEv: __ZNK6Camera19GetProjectionMatrixEv, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE7getNameEv, __ZNK5physx7NpScene24getWakeCounterResetValueEv: __ZNK5physx7NpScene24getWakeCounterResetValueEv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN9allocutil14BuddyAllocator5AllocEj: __ZN9allocutil14BuddyAllocator5AllocEj, __ZN11prophecysdk4half8overflowEv: __ZN11prophecysdk4half8overflowEv, __Z47Register_UnityEngine_Renderer_get_lightmapIndexv: __Z47Register_UnityEngine_Renderer_get_lightmapIndexv, __Z33GUI_CUSTOM_INTERNAL_CALL_DoButtonRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr: __Z33GUI_CUSTOM_INTERNAL_CALL_DoButtonRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr, __ZN17BillboardRendererC2E10MemLabelId18ObjectCreationMode: __ZN17BillboardRendererC2E10MemLabelId18ObjectCreationMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj188ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj188ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration20generateLastContactsEv: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration20generateLastContactsEv, __Z38PreallocateObjectFromPersistentManagerib: __Z38PreallocateObjectFromPersistentManagerib, __ZN15ReflectionProbe23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15ReflectionProbe23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__211__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri: __ZNSt3__211__money_getIwE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERwS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS9_IwNSA_IwEENSC_IwEEEESJ_SJ_Ri, __ZThn12_N5physx10NpMaterialD0Ev: __ZThn12_N5physx10NpMaterialD0Ev, __ZN5physx14PxVehicleGraphC2Ev: __ZN5physx14PxVehicleGraphC2Ev, __Z11scalePlanesPN5physx7PxPlaneEPKNS_2Gu14ConvexHullDataERKNS_7PxMat33E: __Z11scalePlanesPN5physx7PxPlaneEPKNS_2Gu14ConvexHullDataERKNS_7PxMat33E, _wcsdup: _wcsdup, __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIjNS_19SortBoundsPredicateENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j, __ZThn4_N12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE: __ZThn4_N12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE, __ZN5physx7NpShape14onRefCountZeroEv: __ZN5physx7NpShape14onRefCountZeroEv, __ZN13ComputeBufferC2Ejjj: __ZN13ComputeBufferC2Ejjj, __ZNK14ParticleSystem7GetLoopEv: __ZNK14ParticleSystem7GetLoopEv, _fopen_file_func: _fopen_file_func, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEED0Ev, __Z40getPxVehicleWheelDataMMaxHandBrakeTorquePKN5physx18PxVehicleWheelDataE: __Z40getPxVehicleWheelDataMMaxHandBrakeTorquePKN5physx18PxVehicleWheelDataE, __ZN5physx20PxsParticleSystemSim18packetShapesUpdateEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim18packetShapesUpdateEPNS_10PxBaseTaskE, __ZNK9Texture2D26CanReuploadDataToGfxDeviceEv: __ZNK9Texture2D26CanReuploadDataToGfxDeviceEv, __ZN5Umbra11NodeLocator8findNodeERKNS_6KDTreeERKNS_4AABBERKNS_7Vector3ERNS1_4NodeE: __ZN5Umbra11NodeLocator8findNodeERKNS_6KDTreeERKNS_4AABBERKNS_7Vector3ERNS1_4NodeE, __ZN10Matrix3x3f8SetBasisERK8Vector3fS2_S2_: __ZN10Matrix3x3f8SetBasisERK8Vector3fS2_S2_, __ZN19ParticleSystemState4TickERK27ParticleSystemReadOnlyStatef: __ZN19ParticleSystemState4TickERK27ParticleSystemReadOnlyStatef, __ZN8Animator19ClearPlayableMemoryEv: __ZN8Animator19ClearPlayableMemoryEv, __Z29ClearRepeatingLogMessageStatev: __Z29ClearRepeatingLogMessageStatev, __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE: __ZN13TextRendering17TextMeshGenerator13GetTextOffsetERK5RectTIfE, __ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj: __ZN5Umbra20RuntimeTomeGenerator18constructInputTreeERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorEiRNS_6KDTreeEiRKNS_4AABBEijj, __ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb: __ZN5physx2Gu11HeightField12loadFromDescERKNS_17PxHeightFieldDescEb, __ZN15QualitySettings12CleanupClassEv: __ZN15QualitySettings12CleanupClassEv, __ZNK12b2MotorJoint15GetLinearOffsetEv: __ZNK12b2MotorJoint15GetLinearOffsetEv, __ZN21EnlightenSceneMappingaSERKS_: __ZN21EnlightenSceneMappingaSERKS_, __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapYP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapYP12Il2CppObjectR15MonoMinMaxCurve, _PxRegisterCloth: _PxRegisterCloth, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5crendEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5crendEv, __Z47Register_UnityEngine_Projector_set_farClipPlanev: __Z47Register_UnityEngine_Projector_set_farClipPlanev, __Z30Light_Set_Custom_PropSpotAngleP12Il2CppObjectf: __Z30Light_Set_Custom_PropSpotAngleP12Il2CppObjectf, __ZN7ApiGLESD2Ev: __ZN7ApiGLESD2Ev, _mlockall: _mlockall, __ZN9Transform47ClearTransformHierarchyAndApplyToSerializedDataEv: __ZN9Transform47ClearTransformHierarchyAndApplyToSerializedDataEv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_, __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __Z41Material_CUSTOM_Internal_CreateWithShaderP12Il2CppObjectS0_: __Z41Material_CUSTOM_Internal_CreateWithShaderP12Il2CppObjectS0_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleClutchDataEE8pushNameEPKc, __ZN17PersistentManager9AddStreamEv: __ZN17PersistentManager9AddStreamEv, __Z47Register_UnityEngine_GUIStyle_set_imagePositionv: __Z47Register_UnityEngine_GUIStyle_set_imagePositionv, __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE: __ZN5physx20getVertexEdgeIndicesERKNS_2Gu11HeightFieldEjjjPNS_8EdgeDataE, __Z49GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawCursor13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiRK10ColorRGBAf: __Z49GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawCursor13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiRK10ColorRGBAf, __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetEnabledv: __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetEnabledv, __ZN12_GLOBAL__N_117ConnectionManagerD0Ev: __ZN12_GLOBAL__N_117ConnectionManagerD0Ev, __Z66Register_UnityEngine_VR_VRSettings_get_renderViewportScaleInternalv: __Z66Register_UnityEngine_VR_VRSettings_get_renderViewportScaleInternalv, __ZN5physx3Cct26CharacterControllerManager16createControllerERNS_9PxPhysicsEPNS_7PxSceneERKNS_16PxControllerDescE: __ZN5physx3Cct26CharacterControllerManager16createControllerERNS_9PxPhysicsEPNS_7PxSceneERKNS_16PxControllerDescE, __ZN11UnityEngine15CloudWebService14RestDownloaderD2Ev: __ZN11UnityEngine15CloudWebService14RestDownloaderD2Ev, __Z29StdTemplateConversionFunctionIjhEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjhEbPvR14SafeBinaryRead, __ZN15RenderNodeQueue9EraseNodeEj: __ZN15RenderNodeQueue9EraseNodeEj, _scandir: _scandir, __ZNK12PhysXRaycast12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP8Colliderj: __ZNK12PhysXRaycast12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP8Colliderj, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx14PxsAABBManager9visualizeERNS_2Cm12RenderOutputE: __ZN5physx14PxsAABBManager9visualizeERNS_2Cm12RenderOutputE, __ZNK13MonoBehaviour13GetScriptTypeEv: __ZNK13MonoBehaviour13GetScriptTypeEv, __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, _inet_aton: _inet_aton, __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN22RenderingCommandBuffer12AddGetTempRTERKN9ShaderLab16FastPropertyNameEii19RenderTextureFormat17DepthBufferFormat17TextureFilterMode22RenderTextureReadWritei: __ZN22RenderingCommandBuffer12AddGetTempRTERKN9ShaderLab16FastPropertyNameEii19RenderTextureFormat17DepthBufferFormat17TextureFilterMode22RenderTextureReadWritei, __ZNSt3__26vectorI14ResponseHelperNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI14ResponseHelperNS_9allocatorIS1_EEE8__appendEj, __ZN4FMOD7SystemI9getOutputEP15FMOD_OUTPUTTYPE: __ZN4FMOD7SystemI9getOutputEP15FMOD_OUTPUTTYPE, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj590ENS_22PxRepXPropertyAccessorILj590ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj590ENS_22PxRepXPropertyAccessorILj590ES4_ffEEEEvRKT0_, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentryC2ERS3_b: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentryC2ERS3_b, __ZN5physx3Scb14ParticleSystem14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE: __ZN5physx3Scb14ParticleSystem14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE, __ZN5Umbra12getAllocatorEv: __ZN5Umbra12getAllocatorEv, __ZN12MeshCollider11CreateShapeEPvPK9RigidbodyRK8Vector3f: __ZN12MeshCollider11CreateShapeEPvPK9RigidbodyRK8Vector3f, __ZN20SoundChannelInstance8getDelayE14FMOD_DELAYTYPEPjS1_: __ZN20SoundChannelInstance8getDelayE14FMOD_DELAYTYPEPjS1_, __ZN21AssetBundleFileSystemC2EPKc: __ZN21AssetBundleFileSystemC2EPKc, __ZN4Halo7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN4Halo7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN4FMOD7SystemI17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_: __ZN4FMOD7SystemI17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_, __ZN10UnitySceneD0Ev: __ZN10UnitySceneD0Ev, __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE8__appendEj, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE7reserveEj, __ZNSt3__210ostrstreamD0Ev: __ZNSt3__210ostrstreamD0Ev, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags, __ZSt11__terminatePFvvE: __ZSt11__terminatePFvvE, __ZN5physx13NpVolumeCacheC2EPNS_2Sq17SceneQueryManagerEjj: __ZN5physx13NpVolumeCacheC2EPNS_2Sq17SceneQueryManagerEjj, __ZN24CompressedAnimationCurve16CompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E: __ZN24CompressedAnimationCurve16CompressTimeKeysI11QuaternionfEEvR17AnimationCurveTplIT_E, __ZThn24_N5physx2Sc20ArticulationJointSimD1Ev: __ZThn24_N5physx2Sc20ArticulationJointSimD1Ev, __Z57ParticleSystem_CollisionModule_CUSTOM_GetDampenMultiplierP12Il2CppObject: __Z57ParticleSystem_CollisionModule_CUSTOM_GetDampenMultiplierP12Il2CppObject, __ZNK6b2Rope4DrawEP6b2Draw: __ZNK6b2Rope4DrawEP6b2Draw, __ZN12AudioManager14systemCallbackEP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS3_: __ZN12AudioManager14systemCallbackEP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS3_, __ZN14ParticleSystem22SetUsesRotationalSpeedEv: __ZN14ParticleSystem22SetUsesRotationalSpeedEv, __ZN5physx2Sc18ParticleSystemCore14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE: __ZN5physx2Sc18ParticleSystemCore14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKfEE, __Z30IsComponentSubclassOfMonoClassRN5Unity9ComponentEP11Il2CppClass: __Z30IsComponentSubclassOfMonoClassRN5Unity9ComponentEP11Il2CppClass, __Z24CheckValidFileNameDetailRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24CheckValidFileNameDetailRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN16ReflectionProbes16UpdateSampleDataEv: __ZN16ReflectionProbes16UpdateSampleDataEv, _if_nameindex: _if_nameindex, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E, __ZN5physx2Sc17ParticleSystemSimD0Ev: __ZN5physx2Sc17ParticleSystemSimD0Ev, __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEED2Ev: __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEED2Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS4_EE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS4_EE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags, _getsubopt: _getsubopt, __ZN18ProceduralMaterial23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18ProceduralMaterial23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__212future_errorD2Ev: __ZNSt3__212future_errorD2Ev, __ZN14Texture2DArray5ResetEv: __ZN14Texture2DArray5ResetEv, __ZNKSt3__210moneypunctIwLb1EE16do_positive_signEv: __ZNKSt3__210moneypunctIwLb1EE16do_positive_signEv, __Z46Register_UnityEngine_Collider2D_get_bouncinessv: __Z46Register_UnityEngine_Collider2D_get_bouncinessv, _cbrtl: _cbrtl, __Z26CommandBuffer_CUSTOM_ClearP12Il2CppObject: __Z26CommandBuffer_CUSTOM_ClearP12Il2CppObject, __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI14OcclusionSceneLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN5Umbra12ReceiverMask7addAABBERKNS_7Vector3ES3_: __ZN5Umbra12ReceiverMask7addAABBERKNS_7Vector3ES3_, __ZN39AssetBundleLoadFromStreamAsyncOperation24TryInitializeMemoryCacheEv: __ZN39AssetBundleLoadFromStreamAsyncOperation24TryInitializeMemoryCacheEv, _cbrtf: _cbrtf, __Z18ConvertUTF16toUTF8RK13dynamic_arrayItLj2EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z18ConvertUTF16toUTF8RK13dynamic_arrayItLj2EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN13UploadHandler23OnUnbindScriptingObjectEv: __ZN13UploadHandler23OnUnbindScriptingObjectEv, __ZN10PngDecoder13SetComputeCrcEb: __ZN10PngDecoder13SetComputeCrcEb, __ZNSt3__219__libcpp_asprintf_lEPPcP15__locale_structPKcz: __ZNSt3__219__libcpp_asprintf_lEPPcP15__locale_structPKcz, __ZN5physx7NpCloth23removeCollisionTriangleEj: __ZN5physx7NpCloth23removeCollisionTriangleEj, __ZN14PhysicMaterial17IsDefaultMaterialEv: __ZN14PhysicMaterial17IsDefaultMaterialEv, __Z58ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedMultiplierP12Il2CppObject: __Z58ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedMultiplierP12Il2CppObject, __ZN9ShaderLab16SerializedShader8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab16SerializedShader8TransferI14SafeBinaryReadEEvRT_, __ZN5Mutex7TryLockEv: __ZN5Mutex7TryLockEv, __Z35NavMeshAgent_Get_Custom_PropHasPathP12Il2CppObject: __Z35NavMeshAgent_Get_Custom_PropHasPathP12Il2CppObject, __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_: __ZN19ShaderPropertySheetC2ERK10MemLabelIdRKS_, __ZN26AnimatorOverrideController17MainThreadCleanupEv: __ZN26AnimatorOverrideController17MainThreadCleanupEv, __ZN13MemoryManager15GetLargestAllocERK10MemLabelId: __ZN13MemoryManager15GetLargestAllocERK10MemLabelId, __ZN23CloudWebServicesManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN23CloudWebServicesManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i: __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonERKN4math7_float4ES7_i, __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags, __ZN14RenderSettings22SetReflectionIntensityEf: __ZN14RenderSettings22SetReflectionIntensityEf, __ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo: __ZNK26AnimatorControllerPlayable34GetAnimatorStateInfoFromStateIndexEiiR17AnimatorStateInfo, __Z34profiler_end_frame_separate_threadi: __Z34profiler_end_frame_separate_threadi, __ZN5physx34PxcContactSphereHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx34PxcContactSphereHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE13isSubordinateEv, __Z29StdTemplateConversionFunctionIayEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIayEbPvR14SafeBinaryRead, __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getConstraintsEPPNS_12PxConstraintEjj: __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getConstraintsEPPNS_12PxConstraintEjj, __ZN25MeshMTDGenerationCallbackD0Ev: __ZN25MeshMTDGenerationCallbackD0Ev, __ZN19SkinnedMeshRenderer7SetMeshEP4Mesh: __ZN19SkinnedMeshRenderer7SetMeshEP4Mesh, __ZN9Rigidbody12SweepTestAllERK8Vector3ff23QueryTriggerInteraction: __ZN9Rigidbody12SweepTestAllERK8Vector3ff23QueryTriggerInteraction, __ZN5physx25PxClothSimpleTetherCookerD2Ev: __ZN5physx25PxClothSimpleTetherCookerD2Ev, __ZThn8_N5physx2Sc21ElementSimInteractionD0Ev: __ZThn8_N5physx2Sc21ElementSimInteractionD0Ev, __ZN15CollisionModule16CheckConsistencyEv: __ZN15CollisionModule16CheckConsistencyEv, __Z40Register_UnityEngine_Light_get_intensityv: __Z40Register_UnityEngine_Light_get_intensityv, __ZN11UnityEngine9Analytics13UserInfoEventD2Ev: __ZN11UnityEngine9Analytics13UserInfoEventD2Ev, __Z45Register_UnityEngine_Application_get_srcValuev: __Z45Register_UnityEngine_Application_get_srcValuev, __ZN12WheelJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12WheelJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE8__appendEj, __Z42CapsuleCollider2D_Get_Custom_PropDirectionP12Il2CppObject: __Z42CapsuleCollider2D_Get_Custom_PropDirectionP12Il2CppObject, __ZN22BaseUnityConnectClient24OnSaveFileFromServerDoneERK8UnityStrS2_bi: __ZN22BaseUnityConnectClient24OnSaveFileFromServerDoneERK8UnityStrS2_bi, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags, __Z47Material_Set_Custom_PropGlobalIlluminationFlagsP12Il2CppObject31MaterialGlobalIlluminationFlags: __Z47Material_Set_Custom_PropGlobalIlluminationFlagsP12Il2CppObject31MaterialGlobalIlluminationFlags, __ZN18BuoyancyEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18BuoyancyEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKi: __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKi, __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv: __ZNK17AnimationCurveTplI11QuaternionfE8GetRangeEv, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev, __ZNK8VRDevice20GetDeviceRefreshRateEv: __ZNK8VRDevice20GetDeviceRefreshRateEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN19CharacterController12CleanupClassEv: __ZN19CharacterController12CleanupClassEv, __Z47Register_UnityEngine_AudioEchoFilter_set_dryMixv: __Z47Register_UnityEngine_AudioEchoFilter_set_dryMixv, __Z33EmitSerializationCommandsForFieldI9JSONWriteEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI9JSONWriteEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN2UI14CanvasRenderer14AttachToCanvasER8JobFencePNS_6CanvasENS0_15InstructionTypeE: __ZN2UI14CanvasRenderer14AttachToCanvasER8JobFencePNS_6CanvasENS0_15InstructionTypeE, __ZN11OffMeshLink7SetAreaEj: __ZN11OffMeshLink7SetAreaEj, __ZN5physx8debugger18MemPvdOutputStreamD0Ev: __ZN5physx8debugger18MemPvdOutputStreamD0Ev, __Z24RegisterStrippedTypeInfoI9ProjectorEviPKcS2_: __Z24RegisterStrippedTypeInfoI9ProjectorEviPKcS2_, __Z23TransferScriptingObjectI19StreamedBinaryWriteILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI19StreamedBinaryWriteILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN5Unity5Cloth13SetUseTethersEb: __ZN5Unity5Cloth13SetUseTethersEb, __Z21HasAlphaTextureFormat13TextureFormat: __Z21HasAlphaTextureFormat13TextureFormat, __ZN12AudioManager6UpdateEv: __ZN12AudioManager6UpdateEv, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZN5physx7NpCloth26setCentrifugalInertiaScaleENS_6PxVec3E: __ZN5physx7NpCloth26setCentrifugalInertiaScaleENS_6PxVec3E, __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE: __ZN14ImageReference9BlitImageERKS_NS_8BlitModeE, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEPNS_15basic_streambufIcS2_EE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEPNS_15basic_streambufIcS2_EE, __ZN8Animator12AddToManagerEv: __ZN8Animator12AddToManagerEv, __Z26ApplyBlendShapesToVerticesR12SkinMeshInfoRKN4math5_int4EPNS1_8floatNx3ES6_: __Z26ApplyBlendShapesToVerticesR12SkinMeshInfoRKN4math5_int4EPNS1_8floatNx3ES6_, __ZNK9ShaderLab9IntShader6GetTagEib: __ZNK9ShaderLab9IntShader6GetTagEib, __ZNSt3__214__split_bufferI14HeightMeshDataR13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev: __ZNSt3__214__split_bufferI14HeightMeshDataR13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation23BlendDirectDataConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation23BlendDirectDataConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_, __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_: __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_, __ZN23CachedSerializationDataD2Ev: __ZN23CachedSerializationDataD2Ev, __ZNK5physx3Cct13BoxController8getActorEv: __ZNK5physx3Cct13BoxController8getActorEv, __ZN14RenderSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN14RenderSettings23VirtualRedirectTransferER14SafeBinaryRead, __Z22RegisterModule_Terrainv: __Z22RegisterModule_Terrainv, __ZN11PlayerPrefs8GetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf: __ZN11PlayerPrefs8GetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN16ReflectionProbes16GetClosestProbesERK4AABBP9Transform20ReflectionProbeUsageR13dynamic_arrayI24ReflectionProbeBlendInfoLj4EE: __ZN16ReflectionProbes16GetClosestProbesERK4AABBP9Transform20ReflectionProbeUsageR13dynamic_arrayI24ReflectionProbeBlendInfoLj4EE, __ZNK13b2CircleShape5CloneEP16b2BlockAllocator: __ZNK13b2CircleShape5CloneEP16b2BlockAllocator, _UNITY_png_get_sCAL_s: _UNITY_png_get_sCAL_s, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv, __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD0Ev: __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD0Ev, __Z36Renderer_Set_Custom_PropSortingOrderP12Il2CppObjecti: __Z36Renderer_Set_Custom_PropSortingOrderP12Il2CppObjecti, __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter: __ZN14dtNavMeshQuery18initSlicedFindPathEyyPKfS1_PK13dtQueryFilter, __Z47Terrain_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f: __Z47Terrain_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f, __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_: __ZN17GlobalGameManager8TransferI17RemapPPtrTransferEEvRT_, __Z59Register_UnityEngine_PlatformEffector2D_set_useSideFrictionv: __Z59Register_UnityEngine_PlatformEffector2D_set_useSideFrictionv, __ZN6b2RopeC2Ev: __ZN6b2RopeC2Ev, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetCycleCountv: __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetCycleCountv, __ZN5Unity17ConfigurableJoint13SetSlerpDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint13SetSlerpDriveERK10JointDrive, __ZN10Collider2DC2E10MemLabelId18ObjectCreationMode: __ZN10Collider2DC2E10MemLabelId18ObjectCreationMode, __ZNK11OffMeshLink17HasEndpointsMovedEv: __ZNK11OffMeshLink17HasEndpointsMovedEv, __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, _UNITY_tt_face_load_fpgm: _UNITY_tt_face_load_fpgm, __Z17IsObjectAvailablei: __Z17IsObjectAvailablei, __ZN12InputManagerD0Ev: __ZN12InputManagerD0Ev, __ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di: __ZN16Physics2DManager10CircleCastERK8Vector2ffS2_fiffPK10Collider2DbP12RaycastHit2Di, _ferror_file_func: _ferror_file_func, __ZN5physx2Sc9RigidCore20removeShapeFromSceneERNS0_9ShapeCoreEb: __ZN5physx2Sc9RigidCore20removeShapeFromSceneERNS0_9ShapeCoreEb, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofERKS5_j, ___ctype_b_loc: ___ctype_b_loc, __ZN13RuntimeStaticI11WindManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI11WindManagerE16StaticInitializeEPv, __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi: __ZNK19RenderEventsContext21ExecuteCommandBuffersEiR17ShaderPassContextRK15RenderNodeQueueP19ProfilerInformationi, _jsimd_can_h2v1_fancy_upsample: _jsimd_can_h2v1_fancy_upsample, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE22handleGeometryPropertyERKNS_23PxShapeGeometryPropertyE: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE22handleGeometryPropertyERKNS_23PxShapeGeometryPropertyE, __Z61Register_UnityEngine_AssetBundleCreateRequest_get_assetBundlev: __Z61Register_UnityEngine_AssetBundleCreateRequest_get_assetBundlev, __ZN5Umbra7ImpTile19getViewTreeDataSizeEPKS0_: __ZN5Umbra7ImpTile19getViewTreeDataSizeEPKS0_, __Z58Register_UnityEngine_CharacterJoint_INTERNAL_set_swingAxisv: __Z58Register_UnityEngine_CharacterJoint_INTERNAL_set_swingAxisv, __Z40Register_UnityEngine_Caching_get_enabledv: __Z40Register_UnityEngine_Caching_get_enabledv, __ZNK15MonoScriptCache7ReleaseEv: __ZNK15MonoScriptCache7ReleaseEv, __Z58Register_UnityEngine_BillboardAsset_MakeMaterialPropertiesv: __Z58Register_UnityEngine_BillboardAsset_MakeMaterialPropertiesv, __ZN5physx9PxTaskMgrC2EPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE: __ZN5physx9PxTaskMgrC2EPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE, __ZN11AudioSource24SetSpatializePostEffectsEb: __ZN11AudioSource24SetSpatializePostEffectsEb, _snprintf: _snprintf, __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5Umbra12PortalCuller9enterTileERKNS0_4TileE: __ZN5Umbra12PortalCuller9enterTileERKNS0_4TileE, __ZN5physx3Ext19ProfileEventHandlerD0Ev: __ZN5physx3Ext19ProfileEventHandlerD0Ev, __Z43PolygonCollider2D_CUSTOM_GetTotalPointCountP12Il2CppObject: __Z43PolygonCollider2D_CUSTOM_GetTotalPointCountP12Il2CppObject, __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode: __ZN16LevelGameManagerC2E10MemLabelId18ObjectCreationMode, __Z45Register_UnityEngine_AudioSource_get_priorityv: __Z45Register_UnityEngine_AudioSource_get_priorityv, __ZN16UniformCacheGLES6CreateERK20GpuProgramParameters: __ZN16UniformCacheGLES6CreateERK20GpuProgramParameters, __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_set_suspensionv: __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_set_suspensionv, __ZN7mecanim12statemachine13StateConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim12statemachine13StateConstant8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_png_get_text: _UNITY_png_get_text, __ZN5physx2Sn17readAllPropertiesINS_14PxRigidDynamicENS_27PxRigidDynamicGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_: __ZN5physx2Sn17readAllPropertiesINS_14PxRigidDynamicENS_27PxRigidDynamicGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_, __Z44ParticleSystem_ShapeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z44ParticleSystem_ShapeModule_CUSTOM_GetEnabledP12Il2CppObject, __ZNKSt3__214__codecvt_utf8IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_: __ZNKSt3__214__codecvt_utf8IDsE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_, __Z34GetLightProbeProxyVolumeManagerPtrv: __Z34GetLightProbeProxyVolumeManagerPtrv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj490ENS_22PxRepXPropertyAccessorILj490ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj490ENS_22PxRepXPropertyAccessorILj490ES4_ffEEEEvRKT0_, __ZN8Animator20InterruptMatchTargetEb: __ZN8Animator20InterruptMatchTargetEb, __Z44AnimatorControllerPlayable_CUSTOM_GetFloatIDR9HPlayablei: __Z44AnimatorControllerPlayable_CUSTOM_GetFloatIDR9HPlayablei, __ZN17PersistentManager23DestroyFromFileInternalEi: __ZN17PersistentManager23DestroyFromFileInternalEi, __ZN5physx17AggregateAABBTask22setNumFastMovingShapesEjj: __ZN5physx17AggregateAABBTask22setNumFastMovingShapesEjj, __ZN13GfxDeviceGLES16CreateTimerQueryEv: __ZN13GfxDeviceGLES16CreateTimerQueryEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44CharacterJoint_CUSTOM_INTERNAL_get_swingAxisP12Il2CppObjectP8Vector3f: __Z44CharacterJoint_CUSTOM_INTERNAL_get_swingAxisP12Il2CppObjectP8Vector3f, __Z43Register_UnityEngine_GUIStyle_get_alignmentv: __Z43Register_UnityEngine_GUIStyle_get_alignmentv, __ZN11JSONUtility28DeserializeObjectOverwritingERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP12Il2CppObjectS5_24TransferInstructionFlags: __ZN11JSONUtility28DeserializeObjectOverwritingERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP12Il2CppObjectS5_24TransferInstructionFlags, __ZN18ProceduralMaterial27GetProceduralProcessorUsageEv: __ZN18ProceduralMaterial27GetProceduralProcessorUsageEv, __ZN19AutoOffMeshLinkData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19AutoOffMeshLinkData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, ___sin: ___sin, __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE: __ZN26AnimatorControllerPlayable18PrepareForPlaybackERN7mecanim6memory9AllocatorE, __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_: __ZN5physx19PxsMaterialCombiner24combineIsotropicFrictionERKNS_15PxsMaterialDataES3_, __Z13RegisterClassI15ParticleEmitterEvv: __Z13RegisterClassI15ParticleEmitterEvv, __Z45Register_UnityEngine_Camera_get_stereoEnabledv: __Z45Register_UnityEngine_Camera_get_stereoEnabledv, __ZN7Terrain18SetLegacyShininessEf: __ZN7Terrain18SetLegacyShininessEf, __ZN8Animator21SetGoalWeightPositionEif: __ZN8Animator21SetGoalWeightPositionEif, __ZN5audio5mixer11GetCPUUsageERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID: __ZN5audio5mixer11GetCPUUsageERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID, __ZN10MonoScriptC2E10MemLabelId18ObjectCreationMode: __ZN10MonoScriptC2E10MemLabelId18ObjectCreationMode, __Z31profiler_get_memory_record_modev: __Z31profiler_get_memory_record_modev, __ZN4Tree26CalculateSupportedMessagesEv: __ZN4Tree26CalculateSupportedMessagesEv, __ZN13GfxTimerQueryD2Ev: __ZN13GfxTimerQueryD2Ev, __ZN22CreateGpuProgramOutputC2Ev: __ZN22CreateGpuProgramOutputC2Ev, __Z11SkinGenericILi2ELb1ELb1EEvR12SkinMeshInfo: __Z11SkinGenericILi2ELb1ELb1EEvR12SkinMeshInfo, __ZN11UnityEngine15CloudWebService13WWWRestClient18GetResponseHeadersEv: __ZN11UnityEngine15CloudWebService13WWWRestClient18GetResponseHeadersEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj577ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj577ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx15PxVehicleWheels15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15PxVehicleWheels15exportExtraDataERNS_22PxSerializationContextE, _UNITY_png_set_text_2: _UNITY_png_set_text_2, __ZN5physx2Sc24ConstraintProjectionTree14rankConstraintERNS0_13ConstraintSimERNS0_8BodyRankERj: __ZN5physx2Sc24ConstraintProjectionTree14rankConstraintERNS0_13ConstraintSimERNS0_8BodyRankERj, __Z28LocationService_CUSTOM_StartP12Il2CppObjectff: __Z28LocationService_CUSTOM_StartP12Il2CppObjectff, __ZN4FMOD7SystemI13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj: __ZN4FMOD7SystemI13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj, __ZN4FMOD7Channel10getDSPHeadEPPNS_3DSPE: __ZN4FMOD7Channel10getDSPHeadEPPNS_3DSPE, __ZN5physx7Cooking16cookTriangleMeshERKNS_18PxTriangleMeshDescERNS_14PxOutputStreamE: __ZN5physx7Cooking16cookTriangleMeshERKNS_18PxTriangleMeshDescERNS_14PxOutputStreamE, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale1Ev, __ZN14CompletionTask4InitEPN5physx7PxSceneE: __ZN14CompletionTask4InitEPN5physx7PxSceneE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, __Z62Register_UnityEngine_ParticleSystem_MainModule_GetMaxParticlesv: __Z62Register_UnityEngine_ParticleSystem_MainModule_GetMaxParticlesv, __ZN5physx6shdfnd10Foundation7releaseEv: __ZN5physx6shdfnd10Foundation7releaseEv, __Z50Register_UnityEngine_ParticleEmitter_get_minEnergyv: __Z50Register_UnityEngine_ParticleEmitter_get_minEnergyv, __ZNSt3__213random_deviceC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__213random_deviceC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z27CleanupTerrainPhysicsModulev: __Z27CleanupTerrainPhysicsModulev, __ZNK15GUIEventManager15GetEventAtIndexEi: __ZNK15GUIEventManager15GetEventAtIndexEi, __ZN2UI14CanvasRenderer17SyncDirtyElementsER8JobFence: __ZN2UI14CanvasRenderer17SyncDirtyElementsER8JobFence, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z35getPxVehicleSuspensionDataMMaxDroopPKN5physx23PxVehicleSuspensionDataE: __Z35getPxVehicleSuspensionDataMMaxDroopPKN5physx23PxVehicleSuspensionDataE, _ms_close: _ms_close, __Z43SystemInfo_Get_Custom_PropSupportsGyroscopev: __Z43SystemInfo_Get_Custom_PropSupportsGyroscopev, __Z58Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastNonAllocv: __Z58Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastNonAllocv, __Z35AssetBundle_CUSTOM_GetAllScenePathsP12Il2CppObject: __Z35AssetBundle_CUSTOM_GetAllScenePathsP12Il2CppObject, __ZNK9ShaderLab21ShaderRasterStateDesc16ToGfxRasterStateEPK19ShaderPropertySheetS3_R14GfxRasterState: __ZNK9ShaderLab21ShaderRasterStateDesc16ToGfxRasterStateEPK19ShaderPropertySheetS3_R14GfxRasterState, __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext: __Z16RenderShadowMapsPK18ShadowMapJobHeaderR17ShaderPassContext, __Z12RangedRandomR5RandNRKiS2_: __Z12RangedRandomR5RandNRKiS2_, _UNITY_FT_Done_FreeType: _UNITY_FT_Done_FreeType, __Z50Profiler_Set_Custom_PropMaxNumberOfSamplesPerFramei: __Z50Profiler_Set_Custom_PropMaxNumberOfSamplesPerFramei, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXMultiplierv, __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN4PPtrI13MonoBehaviourE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI13MonoBehaviourE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Umbra9RasterOps10debugStatsEv: __ZN5Umbra9RasterOps10debugStatsEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12FlareManager12RemoveCameraER6Camera: __ZN12FlareManager12RemoveCameraER6Camera, __Z20IsMatrixBuiltinParamPKcPi: __Z20IsMatrixBuiltinParamPKcPi, __ZN18StreamedBinaryReadILb1EE5AlignEv: __ZN18StreamedBinaryReadILb1EE5AlignEv, __Z49Register_UnityEngine_AI_NavMeshAgent_get_areaMaskv: __Z49Register_UnityEngine_AI_NavMeshAgent_get_areaMaskv, __ZN8Renderer19PostInitializeClassEv: __ZN8Renderer19PostInitializeClassEv, __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE16StaticInitializeEPv, _XXH64_digest: _XXH64_digest, __ZN5Umbra11Transformer4initEPKNS_7Vector4Ei: __ZN5Umbra11Transformer4initEPKNS_7Vector4Ei, __Z54Camera_CUSTOM_INTERNAL_set_nonJitteredProjectionMatrixP12Il2CppObjectRK10Matrix4x4f: __Z54Camera_CUSTOM_INTERNAL_set_nonJitteredProjectionMatrixP12Il2CppObjectRK10Matrix4x4f, __ZN6Camera24RemovePostRenderCallbackEPFvRS_PvES1_: __ZN6Camera24RemovePostRenderCallbackEPFvRS_PvES1_, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIcEE, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev, __ZN18DelayedCallManager18CancelCallDelayed2E4PPtrI6ObjectEPF15CallObjectStatePS1_PvES7_: __ZN18DelayedCallManager18CancelCallDelayed2E4PPtrI6ObjectEPF15CallObjectStatePS1_PvES7_, __ZN19SpriteMeshGenerator5traceE8Vector2fS0_RS0_: __ZN19SpriteMeshGenerator5traceE8Vector2fS0_RS0_, __ZN25ThreadsafeLinearAllocator10ReallocateEPvji: __ZN25ThreadsafeLinearAllocator10ReallocateEPvji, __Z18Transfer_BlittableI14SafeBinaryReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx18PxArticulationLink8isKindOfEPKc: __ZNK5physx18PxArticulationLink8isKindOfEPKc, __ZN14DetailDatabase12GenerateMeshER4Meshii8Vector3f16DetailRenderModefii: __ZN14DetailDatabase12GenerateMeshER4Meshii8Vector3f16DetailRenderModefii, __ZN7mecanim9animation10SampleClipERKNS0_12ConstantClipEjPf: __ZN7mecanim9animation10SampleClipERKNS0_12ConstantClipEjPf, __Z25getNbPxClothFabric_PhasesPKN5physx13PxClothFabricE: __Z25getNbPxClothFabric_PhasesPKN5physx13PxClothFabricE, __ZN5physx13NpVolumeCache13onOriginShiftERKNS_6PxVec3E: __ZN5physx13NpVolumeCache13onOriginShiftERKNS_6PxVec3E, __Z25CreatePxMeshFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypef: __Z25CreatePxMeshFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypef, __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_: __ZN10Matrix4x4f8TransferI14SafeBinaryReadEEvRT_, __ZN5physx9NpFactory11createShapeERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKPNS_10PxMaterialEtb: __ZN5physx9NpFactory11createShapeERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKPNS_10PxMaterialEtb, __ZN12LineRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f: __ZN12LineRenderer26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f, __ZN7ApiGLES11VertexArrayC2Ev: __ZN7ApiGLES11VertexArrayC2Ev, __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation: __ZN14PreloadManager10AddToQueueEP23PreloadManagerOperation, __ZN14AvatarPlayback8StopTimeEv: __ZN14AvatarPlayback8StopTimeEv, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIeeEEPeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIeeEEPeEEbT0_S5_T_, __Z21GetMiniMemoryOverviewv: __Z21GetMiniMemoryOverviewv, __ZN4FMOD13ChannelGroupIC2EPNS_7SystemIE: __ZN4FMOD13ChannelGroupIC2EPNS_7SystemIE, __Z57Register_UnityEngine_Camera_ResetStereoProjectionMatricesv: __Z57Register_UnityEngine_Camera_ResetStereoProjectionMatricesv, __ZN19ShaderPropertySheet16SetVectorIndexedERKN9ShaderLab16FastPropertyNameEifRK8Vector4fNS_8SetFlagsE: __ZN19ShaderPropertySheet16SetVectorIndexedERKN9ShaderLab16FastPropertyNameEifRK8Vector4fNS_8SetFlagsE, __Z41Rigidbody2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_: __Z41Rigidbody2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_, __ZL14OnWorldStoppedv: __ZL14OnWorldStoppedv, __ZN4FMOD6SoundI12getOpenStateEP14FMOD_OPENSTATEPjPbS4_: __ZN4FMOD6SoundI12getOpenStateEP14FMOD_OPENSTATEPjPbS4_, __Z64Register_UnityEngine_RenderSettings_INTERNAL_get_ambientSkyColorv: __Z64Register_UnityEngine_RenderSettings_INTERNAL_get_ambientSkyColorv, __Z64Register_UnityEngine_ParticleSystem_INTERNAL_get_startRotation3Dv: __Z64Register_UnityEngine_ParticleSystem_INTERNAL_get_startRotation3Dv, __ZN13TextRendering4Font15ThreadedCleanupEv: __ZN13TextRendering4Font15ThreadedCleanupEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z40ConfigurableJoint_Get_Custom_PropZMotionP12Il2CppObject: __Z40ConfigurableJoint_Get_Custom_PropZMotionP12Il2CppObject, __ZN7mecanim5human21HumanComputeRootXformEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human21HumanComputeRootXformEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EjcRKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EjcRKS4_, __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv: __ZN5physx3Scb14ParticleSystem12ForceUpdates7destroyEv, __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN9b2Contact7AddTypeEPFPS_P9b2FixtureiS2_iP16b2BlockAllocatorEPFvS0_S4_EN7b2Shape4TypeESA_: __ZN9b2Contact7AddTypeEPFPS_P9b2FixtureiS2_iP16b2BlockAllocatorEPFvS0_S4_EN7b2Shape4TypeESA_, __ZNSt3__214codecvt_bynameIDic11__mbstate_tED2Ev: __ZNSt3__214codecvt_bynameIDic11__mbstate_tED2Ev, __ZN5Unity14CharacterJoint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity14CharacterJoint7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN7ApiGLES18ClearBufferSubDataEjN2gl12BufferTargetEll: __ZN7ApiGLES18ClearBufferSubDataEjN2gl12BufferTargetEll, __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_: __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_T_, __ZN8Animator7SetBoolEib: __ZN8Animator7SetBoolEib, __Z37Camera_Get_Custom_PropAllCamerasCountv: __Z37Camera_Get_Custom_PropAllCamerasCountv, __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED2Ev: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED2Ev, __Z38Register_UnityEngine_GUIStyle_get_namev: __Z38Register_UnityEngine_GUIStyle_get_namev, __ZN17PersistentManager18SetActiveNameSpaceEiNS_19ActiveNameSpaceTypeE: __ZN17PersistentManager18SetActiveNameSpaceEiNS_19ActiveNameSpaceTypeE, __ZN16DeveloperConsole13InitGUIStylesEv: __ZN16DeveloperConsole13InitGUIStylesEv, _Split_Cubic: _Split_Cubic, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE, __ZN17AudioReverbFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN17AudioReverbFilter23VirtualRedirectTransferER14SafeBinaryRead, __ZThn8_N5physx3Cct17CapsuleControllerD1Ev: __ZThn8_N5physx3Cct17CapsuleControllerD1Ev, _UNITY_png_chunk_report: _UNITY_png_chunk_report, __ZN9BlobWrite8TransferIN4math8ColliderEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN4math8ColliderEEEvRT_PKc17TransferMetaFlags, __Z19ExtractDataFromMeshR4MeshR13dynamic_arrayI8Vector3fLj4EERS1_ItLj2EES6_: __Z19ExtractDataFromMeshR4MeshR13dynamic_arrayI8Vector3fLj4EERS1_ItLj2EES6_, __ZN15CarveDataArrays8PushBackERK16NavMeshCarveData: __ZN15CarveDataArrays8PushBackERK16NavMeshCarveData, __ZN11AssetBundle18DebugPrintContentsEv: __ZN11AssetBundle18DebugPrintContentsEv, __ZN21AudioDistortionFilter16CheckConsistencyEv: __ZN21AudioDistortionFilter16CheckConsistencyEv, __ZN5physx6shdfnd16MemoryMappedFileD2Ev: __ZN5physx6shdfnd16MemoryMappedFileD2Ev, __ZNKSt3__25ctypeIcE9do_narrowEPKcS3_cPc: __ZNKSt3__25ctypeIcE9do_narrowEPKcS3_cPc, __ZN5physx2Sc16ArticulationCore26setMaxProjectionIterationsEj: __ZN5physx2Sc16ArticulationCore26setMaxProjectionIterationsEj, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl11getPropertyEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl11getPropertyEN5physx8debugger18NonNegativeIntegerE, __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED2Ev, __ZN6Skybox12AddToManagerEv: __ZN6Skybox12AddToManagerEv, __ZN15ContactFilter2D13ShouldCollideEP9b2FixtureS1_: __ZN15ContactFilter2D13ShouldCollideEP9b2FixtureS1_, _ft_black_render: _ft_black_render, __ZN18GfxFramebufferGLES20ActiveContextChangedEPP17RenderSurfaceBaseS2_: __ZN18GfxFramebufferGLES20ActiveContextChangedEPP17RenderSurfaceBaseS2_, __Z28Scene_CUSTOM_SetNameInternaliP12Il2CppString: __Z28Scene_CUSTOM_SetNameInternaliP12Il2CppString, __Z19PluginsRenderMarkeri: __Z19PluginsRenderMarkeri, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj, __ZN10HumanTrait18InitializeBoneNameEv: __ZN10HumanTrait18InitializeBoneNameEv, __ZN8LODGroup5ResetEv: __ZN8LODGroup5ResetEv, __Z61Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_FindClosestEdgev: __Z61Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_FindClosestEdgev, __Z14CreateMemLabel18MemLabelIdentifierP24ProfilerAllocationHeader: __Z14CreateMemLabel18MemLabelIdentifierP24ProfilerAllocationHeader, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv, __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_: __ZN14qsort_internal6_QSortIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_, __Z34HingeJoint_Get_Custom_PropVelocityP12Il2CppObject: __Z34HingeJoint_Get_Custom_PropVelocityP12Il2CppObject, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE6resizeEjRKS2_, __ZN5Image13ReformatImageERK14ImageReferenceii13TextureFormatNS0_8BlitModeE: __ZN5Image13ReformatImageERK14ImageReferenceii13TextureFormatNS0_8BlitModeE, __Z31getPxJointAngularLimitPairUpperPKN5physx23PxJointAngularLimitPairE: __Z31getPxJointAngularLimitPairUpperPKN5physx23PxJointAngularLimitPairE, __ZN5physx7NpCloth16setRestPositionsEPKNS_6PxVec4E: __ZN5physx7NpCloth16setRestPositionsEPKNS_6PxVec4E, __Z45Register_UnityEngine_Terrain_set_materialTypev: __Z45Register_UnityEngine_Terrain_set_materialTypev, __ZN12AudioManager17RemoveAudioSourceEP11AudioSource: __ZN12AudioManager17RemoveAudioSourceEP11AudioSource, __Z55Register_UnityEngine_PhysicMaterial_get_frictionCombinev: __Z55Register_UnityEngine_PhysicMaterial_get_frictionCombinev, __Z49Register_UnityEngine_Renderer_set_sharedMaterialsv: __Z49Register_UnityEngine_Renderer_set_sharedMaterialsv, __Z61Register_UnityEngine_QualitySettings_set_anisotropicFilteringv: __Z61Register_UnityEngine_QualitySettings_set_anisotropicFilteringv, __ZN5Unity5Cloth19SetUpSkinnedBuffersEPvS1_S1_j: __ZN5Unity5Cloth19SetUpSkinnedBuffersEPvS1_S1_j, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE15growAndPushBackERKS3_, __Z55Register_UnityEngine_Shader_SetGlobalFloatArrayImplListv: __Z55Register_UnityEngine_Shader_SetGlobalFloatArrayImplListv, __ZN18ProfilerConnection23HandleConnectionMessageEj: __ZN18ProfilerConnection23HandleConnectionMessageEj, __ZNK5physx2Gu10ConvexMesh17getReferenceCountEv: __ZNK5physx2Gu10ConvexMesh17getReferenceCountEv, __ZNSt3__26vectorIP11GameManagerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP11GameManagerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx8debugger4comm18SetPropertyMessageD0Ev: __ZN5physx8debugger4comm18SetPropertyMessageD0Ev, __ZN5physx2Sc5Scene22setNbContactDataBlocksEj: __ZN5physx2Sc5Scene22setNbContactDataBlocksEj, __Z38getNbPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataE: __Z38getNbPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataE, __ZN5physx14PxLightCpuTask12addReferenceEv: __ZN5physx14PxLightCpuTask12addReferenceEv, __Z10b2DistanceP16b2DistanceOutputP14b2SimplexCachePK15b2DistanceInput: __Z10b2DistanceP16b2DistanceOutputP14b2SimplexCachePK15b2DistanceInput, __ZN21EnlightenSceneMapping8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN21EnlightenSceneMapping8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE26getRelativeAngularVelocityEv, __ZN5physx2Sc5Scene10removeBodyERNS0_7BodySimE: __ZN5physx2Sc5Scene10removeBodyERNS0_7BodySimE, __ZN4FMOD6SoundI11getDefaultsEPfS1_S1_Pi: __ZN4FMOD6SoundI11getDefaultsEPfS1_S1_Pi, __Z20GetApplicationFolderv: __Z20GetApplicationFolderv, __ZN11UnityEngine15CloudWebService14DataDispatcher24StartJobRetryWebDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher24StartJobRetryWebDispatchEv, __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetPointVelocityv: __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_GetPointVelocityv, __Z54Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Rectv: __Z54Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Rectv, __ZN20OcclusionCullingDataD2Ev: __ZN20OcclusionCullingDataD2Ev, __ZN2UI13RectTransformC2E10MemLabelId18ObjectCreationMode: __ZN2UI13RectTransformC2E10MemLabelId18ObjectCreationMode, __Z20CalculateSqrDistanceRK8Vector3fRK4AABB: __Z20CalculateSqrDistanceRK8Vector3fRK4AABB, __ZN5Flare8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Flare8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN23LODTreeInstanceRendererC2ER12TreeRendereriR12MeshRendererRK10Matrix4x4fi: __ZN23LODTreeInstanceRendererC2ER12TreeRendereriR12MeshRendererRK10Matrix4x4fi, __ZN5physx3Ext19ProfileEventHandler5clearEv: __ZN5physx3Ext19ProfileEventHandler5clearEv, __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z20GetAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN9LensFlare8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9LensFlare8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD2Ev: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD2Ev, __ZN21BoxTraceSegmentReport7onEventEjPj: __ZN21BoxTraceSegmentReport7onEventEjPj, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject, __ZN14RenderSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14RenderSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx15PxD6JointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __ZL20HullProjectionCB_BoxRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_: __ZL20HullProjectionCB_BoxRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_, __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_120parse_template_paramINS0_2DbEEEPKcS4_S4_RT_, __ZN5physx17PxcNpMemBlockPool19releaseUnusedBlocksEv: __ZN5physx17PxcNpMemBlockPool19releaseUnusedBlocksEv, __Z32Input_Get_Custom_PropInputStringv: __Z32Input_Get_Custom_PropInputStringv, __Z41Register_UnityEngine_Cloth_get_useGravityv: __Z41Register_UnityEngine_Cloth_get_useGravityv, __ZN5physx14PxsAABBManager21selfCollideAggregatesEPKNS_19AggregateSortedDataE: __ZN5physx14PxsAABBManager21selfCollideAggregatesEPKNS_19AggregateSortedDataE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj73ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj73ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj451ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj451ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI4MeshEPT_17AwakeFromLoadMode10MemLabelId, __Z25GetBytesFromTextureFormat13TextureFormat: __Z25GetBytesFromTextureFormat13TextureFormat, __ZN9Texture3D19UnloadFromGfxDeviceEb: __ZN9Texture3D19UnloadFromGfxDeviceEb, __ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE: __ZN5physx12_GLOBAL__N_112innerProductERKNS_14Px1DConstraintERS1_RKNS0_9MassPropsE, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7Cubemap23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN7Cubemap23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j: __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags, __Z26FindForwardLightsForObjectR13dynamic_arrayIhLj1EEPK11CulledLightjRK12ActiveLightsRK10RenderNodebRK23FindForwardLightsParams: __Z26FindForwardLightsForObjectR13dynamic_arrayIhLj1EEPK11CulledLightjRK12ActiveLightsRK10RenderNodebRK23FindForwardLightsParams, __Z61Register_UnityEngine_Animator_SetIKHintPositionWeightInternalv: __Z61Register_UnityEngine_Animator_SetIKHintPositionWeightInternalv, __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZN2UI13CanvasManager8SortListEv: __ZN2UI13CanvasManager8SortListEv, __ZN11UnityEngine15PlatformWrapper15GetVRDeviceNameEv: __ZN11UnityEngine15PlatformWrapper15GetVRDeviceNameEv, __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix1v: __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix1v, __Z34Screen_Get_Custom_PropSleepTimeoutv: __Z34Screen_Get_Custom_PropSleepTimeoutv, __ZN5physx26PxcFrictionPatchStreamPairC2ERNS_17PxcNpMemBlockPoolE: __ZN5physx26PxcFrictionPatchStreamPairC2ERNS_17PxcNpMemBlockPoolE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEjw, __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j: __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPNS0_7ElementES3_j, __ZN9GfxDevice21RegisterNativeTextureE9TextureIDi16TextureDimension: __ZN9GfxDevice21RegisterNativeTextureE9TextureIDi16TextureDimension, __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatIDv: __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatIDv, __ZN13SliderJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN13SliderJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN20LocalFileSystemWebGL4CopyER13FileEntryDataS1_: __ZN20LocalFileSystemWebGL4CopyER13FileEntryDataS1_, __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12ScriptMapper10FindShaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx25PxAggregateRepXSerializer16objectToFileImplEPKNS_11PxAggregateEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx25PxAggregateRepXSerializer16objectToFileImplEPKNS_11PxAggregateEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN11TypeManager15CleanupAllTypesEv: __ZN11TypeManager15CleanupAllTypesEv, _lroundl: _lroundl, __ZN3WWW20GetCachedErrorStringEv: __ZN3WWW20GetCachedErrorStringEv, __ZN12ScriptMapperD2Ev: __ZN12ScriptMapperD2Ev, __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z51Register_UnityEngine_Physics2D_IgnoreLayerCollisionv: __Z51Register_UnityEngine_Physics2D_IgnoreLayerCollisionv, __ZN9Rigidbody13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Rigidbody13AwakeFromLoadE17AwakeFromLoadMode, __ZN9SubModule8TransferI14SafeBinaryReadEEvRT_: __ZN9SubModule8TransferI14SafeBinaryReadEEvRT_, __ZN16BaseVideoTexture4PlayEv: __ZN16BaseVideoTexture4PlayEv, __ZN14ParticleSystem15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType: __ZN14ParticleSystem15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType, __ZNK5physx14NpSceneQueries10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE: __ZNK5physx14NpSceneQueries10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE, __ZNK13b2PulleyJoint16GetReactionForceEf: __ZNK13b2PulleyJoint16GetReactionForceEf, __ZL21GetMeshLocationDetailR4Mesh: __ZL21GetMeshLocationDetailR4Mesh, __ZNK11AudioSource14GetRolloffModeEv: __ZNK11AudioSource14GetRolloffModeEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead7FogModeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead7FogModeEvRT_RT0_PKc17TransferMetaFlags, __Z52Register_UnityEngine_RenderTexture_Internal_GetWidthv: __Z52Register_UnityEngine_RenderTexture_Internal_GetWidthv, __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_S5_T_, __ZN14ParticleSystem23RendererBecameInvisibleEv: __ZN14ParticleSystem23RendererBecameInvisibleEv, __ZNK7Hash12812PackToUInt32Ev: __ZNK7Hash12812PackToUInt32Ev, __Z44ParticleSystem_NoiseModule_CUSTOM_GetDampingP12Il2CppObject: __Z44ParticleSystem_NoiseModule_CUSTOM_GetDampingP12Il2CppObject, __ZN5physx3Scb5Scene22removeAggregateFromPvdERNS0_9AggregateE: __ZN5physx3Scb5Scene22removeAggregateFromPvdERNS0_9AggregateE, __Z50Register_UnityEngine_AudioSource_set_rolloffFactorv: __Z50Register_UnityEngine_AudioSource_set_rolloffFactorv, __ZN11UnityEngine15CloudWebService16SessionContainer8AddEventEPNS0_14CloudEventInfoE: __ZN11UnityEngine15CloudWebService16SessionContainer8AddEventEPNS0_14CloudEventInfoE, __Z45Register_UnityEngine_Camera_set_targetTexturev: __Z45Register_UnityEngine_Camera_set_targetTexturev, __ZNK16SubstanceArchive26GetTypeInfoVirtualInternalEv: __ZNK16SubstanceArchive26GetTypeInfoVirtualInternalEv, __ZN5physx33PxArticulationLinkGeneratedValuesC2EPKNS_18PxArticulationLinkE: __ZN5physx33PxArticulationLinkGeneratedValuesC2EPKNS_18PxArticulationLinkE, __Z51Register_UnityEngine_AudioEchoFilter_get_decayRatiov: __Z51Register_UnityEngine_AudioEchoFilter_get_decayRatiov, __Z39Register_UnityEngine_Caching_CleanCachev: __Z39Register_UnityEngine_Caching_CleanCachev, __ZN10VertexData8TransferI14SafeBinaryReadEEvRT_: __ZN10VertexData8TransferI14SafeBinaryReadEEvRT_, __Z25GL_CUSTOM_ClearWithSkyboxhP12Il2CppObject: __Z25GL_CUSTOM_ClearWithSkyboxhP12Il2CppObject, __ZN4FMOD8ChannelI8setDelayE14FMOD_DELAYTYPEjj: __ZN4FMOD8ChannelI8setDelayE14FMOD_DELAYTYPEjj, __ZN5physx9NpPhysics14createInstanceEjRNS_12PxFoundationERKNS_17PxTolerancesScaleEbPNS_20PxProfileZoneManagerE: __ZN5physx9NpPhysics14createInstanceEjRNS_12PxFoundationERKNS_17PxTolerancesScaleEbPNS_20PxProfileZoneManagerE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_, __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_Raycastv: __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_Raycastv, __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE: __ZN6prcore9BlitImageERK14ImageReferenceRS0_NS0_8BlitModeE, __Z30setPxCloth_FrictionCoefficientPN5physx7PxClothEf: __Z30setPxCloth_FrictionCoefficientPN5physx7PxClothEf, __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E, __ZNK5physx7NpScene17getFilterCallbackEv: __ZNK5physx7NpScene17getFilterCallbackEv, __ZNK19ShaderPropertySheet13GetFloatArrayEi: __ZNK19ShaderPropertySheet13GetFloatArrayEi, __ZNKSt3__210moneypunctIwLb0EE14do_frac_digitsEv: __ZNKSt3__210moneypunctIwLb0EE14do_frac_digitsEv, __ZL20SortItemByInstanceIDRKN18AwakeFromLoadQueue4ItemES2_: __ZL20SortItemByInstanceIDRKN18AwakeFromLoadQueue4ItemES2_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEE15growAndPushBackERKS2_, __Z46getPxVehicleEngineDataMDampingRateFullThrottlePKN5physx19PxVehicleEngineDataE: __Z46getPxVehicleEngineDataMDampingRateFullThrottlePKN5physx19PxVehicleEngineDataE, __Z26SkinVerticesGenericMathLibILi1ELb1ELb1EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi1ELb1ELb1EEvPKhiiiiPhiPKvS4_, _jpeg_free_small: _jpeg_free_small, __ZN20UnityConnectSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20UnityConnectSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8getSceneEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNK5physx2Sc5Scene39getDefaultContactReportStreamBufferSizeEv: __ZNK5physx2Sc5Scene39getDefaultContactReportStreamBufferSizeEv, __ZN26ProbeSetTetrahedralizationaSERKS_: __ZN26ProbeSetTetrahedralizationaSERKS_, __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP6ObjectNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z48ParticleSystem_MainModule_CUSTOM_GetMaxParticlesP12Il2CppObject: __Z48ParticleSystem_MainModule_CUSTOM_GetMaxParticlesP12Il2CppObject, __Z13PxcPoolMallocj: __Z13PxcPoolMallocj, __ZN12NavMeshAgent5ResetEv: __ZN12NavMeshAgent5ResetEv, __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_48PCMCapsuleVsHeightfieldContactGenerationCallbackEE7onEventEjPj: __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_48PCMCapsuleVsHeightfieldContactGenerationCallbackEE7onEventEjPj, _setreuid: _setreuid, __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3EjRKNS_9AABBMgrIdERNS0_8ShapeSimE: __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3EjRKNS_9AABBMgrIdERNS0_8ShapeSimE, __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z63ParticleSystem_CollisionModule_CUSTOM_GetEnableDynamicCollidersP12Il2CppObject: __Z63ParticleSystem_CollisionModule_CUSTOM_GetEnableDynamicCollidersP12Il2CppObject, __ZN12b2BroadPhase12UnBufferMoveEi: __ZN12b2BroadPhase12UnBufferMoveEi, __ZN13GfxDeviceNull14GetPresentModeEv: __ZN13GfxDeviceNull14GetPresentModeEv, __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb: __ZN5physxL11getTriangleERKNS_2Gu12TriangleMeshEjPNS_6PxVec3EPKS4_PKvRKNS_2Cm8Matrix34Eb, __ZN13WebCamTexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13WebCamTexture7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN13AudioListener12CleanupClassEv: __ZN13AudioListener12CleanupClassEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIjNS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIjNS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags, __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE: __ZNSt3__26__treeINS_12__value_typeIiNS_4pairIP4ListI8ListNodeI9BehaviourEES8_EEEENS_19__map_value_compareIiSA_NS_4lessIiEELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE, __ZN11UnityEngine15CloudWebService17SessionEventQueue8AddEventEPNS0_14CloudEventInfoE: __ZN11UnityEngine15CloudWebService17SessionEventQueue8AddEventEPNS0_14CloudEventInfoE, __ZN15StreamNameSpace11IsDestroyedEx: __ZN15StreamNameSpace11IsDestroyedEx, __ZNK5physx7NpCloth16lockParticleDataEv: __ZNK5physx7NpCloth16lockParticleDataEv, _iswblank_l: _iswblank_l, __ZN19ShaderPropertySheet24SetTextureHDRDecodeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f: __ZN19ShaderPropertySheet24SetTextureHDRDecodeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f, __Z58Register_UnityEngine_Renderer_set_staticBatchRootTransformv: __Z58Register_UnityEngine_Renderer_set_staticBatchRootTransformv, __Z42Register_UnityEngine_TerrainData_GetHeightv: __Z42Register_UnityEngine_TerrainData_GetHeightv, __ZN11TimeManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11TimeManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE12readPropertyIfEEbRT_, __ZN5physx2Sc9ShapeCore10getPxShapeEv: __ZN5physx2Sc9ShapeCore10getPxShapeEv, __ZNK5Umbra18ImpOcclusionBuffer20isAARectFullyVisibleERKNS_7Vector2ES3_f: __ZNK5Umbra18ImpOcclusionBuffer20isAARectFullyVisibleERKNS_7Vector2ES3_f, __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN12HandlerChain10PopHandlerEP17FileSystemHandler: __ZN12HandlerChain10PopHandlerEP17FileSystemHandler, __Z46Register_UnityEngine_Animation_set_cullingTypev: __Z46Register_UnityEngine_Animation_set_cullingTypev, __Z41Register_UnityEngine_GL_set_invertCullingv: __Z41Register_UnityEngine_GL_set_invertCullingv, _compare_uni_maps: _compare_uni_maps, __Z23setPxD6Joint_TwistLimitPN5physx9PxD6JointERKNS_23PxJointAngularLimitPairE: __Z23setPxD6Joint_TwistLimitPN5physx9PxD6JointERKNS_23PxJointAngularLimitPairE, __ZN6Socket15SetReuseAddressEb: __ZN6Socket15SetReuseAddressEb, __ZNSt3__218__insertion_sort_3IRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_: __ZNSt3__218__insertion_sort_3IRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_, __ZL14DidUnloadScenei: __ZL14DidUnloadScenei, __Z48setPxSimulationStatisticsNbAxisSolverConstraintsPN5physx22PxSimulationStatisticsEj: __Z48setPxSimulationStatisticsNbAxisSolverConstraintsPN5physx22PxSimulationStatisticsEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj207ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj207ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z32Renderer_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z32Renderer_Set_Custom_PropMaterialP12Il2CppObjectS0_, __ZN9Rigidbody27SetSolverVelocityIterationsEi: __ZN9Rigidbody27SetSolverVelocityIterationsEi, __ZN5physx13NpRigidStatic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx13NpRigidStatic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __ZN12NativeBufferI16Converter_StringE15SetupForWritingER9ArrayInfo: __ZN12NativeBufferI16Converter_StringE15SetupForWritingER9ArrayInfo, __ZThn32_N19SkinnedMeshRendererD1Ev: __ZThn32_N19SkinnedMeshRendererD1Ev, __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEED0Ev, __ZN13UnityProfiler18ClearPendingFramesEv: __ZN13UnityProfiler18ClearPendingFramesEv, __Z22CleanupVehiclesManagerv: __Z22CleanupVehiclesManagerv, __ZN14UnityWebStream14RetainDownloadEP3WWW: __ZN14UnityWebStream14RetainDownloadEP3WWW, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13getRestOffsetEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13getRestOffsetEv, __ZN15ParticleEmitter7SetEmitEb: __ZN15ParticleEmitter7SetEmitEb, __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z24ShaderPassContextCleanupv: __Z24ShaderPassContextCleanupv, __ZN13MonoBehaviour22DoScriptRebuildWarningEv: __ZN13MonoBehaviour22DoScriptRebuildWarningEv, __Z28WWW_CUSTOM_INTERNAL_CALL_WWWP12Il2CppObjectP12Il2CppStringRK7Hash128j: __Z28WWW_CUSTOM_INTERNAL_CALL_WWWP12Il2CppObjectP12Il2CppStringRK7Hash128j, __ZN5physx2Sn8MetaDataD2Ev: __ZN5physx2Sn8MetaDataD2Ev, __ZNK14PreloadManager17GetThreadPriorityEv: __ZNK14PreloadManager17GetThreadPriorityEv, __ZN5physx6shdfnd7PAUtils10startEventEtt: __ZN5physx6shdfnd7PAUtils10startEventEtt, __ZNK10GameObject22GetComponentPtrAtIndexEi: __ZNK10GameObject22GetComponentPtrAtIndexEi, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE3putEc: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE3putEc, __ZN14PlayerSettings19SetWiiUTVResolutionEi: __ZN14PlayerSettings19SetWiiUTVResolutionEi, __Z38TextGenerator_Get_Custom_PropLineCountP12Il2CppObject: __Z38TextGenerator_Get_Custom_PropLineCountP12Il2CppObject, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEED0Ev, _llvm_cttz_i32: _llvm_cttz_i32, __ZN11IMGUIModule25GetGUIStyleScriptingClassEv: __ZN11IMGUIModule25GetGUIStyleScriptingClassEv, _tt_get_interface: _tt_get_interface, __Z52Register_UnityEngine_Texture2D_UpdateExternalTexturev: __Z52Register_UnityEngine_Texture2D_UpdateExternalTexturev, __Z46Register_UnityEngine_Rigidbody_set_isKinematicv: __Z46Register_UnityEngine_Rigidbody_set_isKinematicv, __Z45setPxPrismaticJoint_ProjectionLinearTolerancePN5physx16PxPrismaticJointEf: __Z45setPxPrismaticJoint_ProjectionLinearTolerancePN5physx16PxPrismaticJointEf, __ZZN2UI14CanvasRenderer15InitializeClassEvEN32FunctorImpl_801kTransformChanged4CallEPviR11MessageData: __ZZN2UI14CanvasRenderer15InitializeClassEvEN32FunctorImpl_801kTransformChanged4CallEPviR11MessageData, __ZN5physx14PxsAABBManager16processBPResultsERKNS_20PxsComputeAABBParamsE: __ZN5physx14PxsAABBManager16processBPResultsERKNS_20PxsComputeAABBParamsE, __ZN9JSONWrite8TransferI13dynamic_arrayIiLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIiLj4EEEEvRT_PKc17TransferMetaFlags, __ZN5physx23PxsBroadPhaseContextSapD2Ev: __ZN5physx23PxsBroadPhaseContextSapD2Ev, __ZN9ShaderLab20SerializedSubProgram15VectorParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei: __ZN9ShaderLab20SerializedSubProgram15VectorParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei, __ZN14NavMeshManager9PurgeDataEPK11NavMeshData: __ZN14NavMeshManager9PurgeDataEPK11NavMeshData, __ZNK5physx15PxDistanceJoint19getConcreteTypeNameEv: __ZNK5physx15PxDistanceJoint19getConcreteTypeNameEv, __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z15CanAddComponentR10GameObjecti: __Z15CanAddComponentR10GameObjecti, _png_get_uint_16: _png_get_uint_16, __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PtS3_RS3_mNS_12codecvt_modeE, __Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags: __Z18ConvertUTF16toUTF8PPKtS0_PPhS2_15ConversionFlags, __Z24GetActualTargetFrameRatev: __Z24GetActualTargetFrameRatev, __Z59Register_UnityEngine_TextGenerator_INTERNAL_get_rectExtentsv: __Z59Register_UnityEngine_TextGenerator_INTERNAL_get_rectExtentsv, __Z66ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceMultiplierP12Il2CppObjectf: __Z66ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceMultiplierP12Il2CppObjectf, __Z20DeformSkinnedMeshJobP12SkinMeshInfo: __Z20DeformSkinnedMeshJobP12SkinMeshInfo, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZN17PersistentManager19UnloadMemoryStreamsEv: __ZN17PersistentManager19UnloadMemoryStreamsEv, __ZNK12ShaderErrors11ShaderErrorltERKS0_: __ZNK12ShaderErrors11ShaderErrorltERKS0_, __Z42AnchoredJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall: __Z42AnchoredJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall, __Z42Graphics_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectiS0_P11Il2CppArrayiS0_17ShadowCastingModehiS0_: __Z42Graphics_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectiS0_P11Il2CppArrayiS0_17ShadowCastingModehiS0_, __Z35NavMeshAgent_CUSTOM_FindClosestEdgeP12Il2CppObjectP10NavMeshHit: __Z35NavMeshAgent_CUSTOM_FindClosestEdgeP12Il2CppObjectP10NavMeshHit, __ZN13ComputeBuffer19UnloadFromGfxDeviceEv: __ZN13ComputeBuffer19UnloadFromGfxDeviceEv, __Z56Register_UnityEngine_RenderTexture_get_enableRandomWritev: __Z56Register_UnityEngine_RenderTexture_get_enableRandomWritev, __Z23SetupStereoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK10Matrix4x4fRK8Vector3fb: __Z23SetupStereoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK10Matrix4x4fRK8Vector3fb, __ZN4FMOD7SystemI20set3DSpeakerPositionE12FMOD_SPEAKERffb: __ZN4FMOD7SystemI20set3DSpeakerPositionE12FMOD_SPEAKERffb, __Z54Register_UnityEngine_ParticleSystem_ShapeModule_SetArcv: __Z54Register_UnityEngine_ParticleSystem_ShapeModule_SetArcv, __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetUseParticleColorv: __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetUseParticleColorv, __ZN15TerrainCollider12GetIsTriggerEv: __ZN15TerrainCollider12GetIsTriggerEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN16ReflectionProbes15BlurMipmapLevelEP15ReflectionProbei: __ZN16ReflectionProbes15BlurMipmapLevelEP15ReflectionProbei, __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj: __ZL29FindStartOfNextNthPathElementNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj, __ZN9rapidjson8internal6u64toaEyPc: __ZN9rapidjson8internal6u64toaEyPc, __ZN15OcclusionPortalC2E10MemLabelId18ObjectCreationMode: __ZN15OcclusionPortalC2E10MemLabelId18ObjectCreationMode, __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z55Register_UnityEngine_AnimationState_get_normalizedSpeedv: __Z55Register_UnityEngine_AnimationState_get_normalizedSpeedv, __ZNK5physx2Sc9ClothCore16getRestPositionsEPNS_6PxVec4E: __ZNK5physx2Sc9ClothCore16getRestPositionsEPNS_6PxVec4E, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv, __ZN5physx20PxcSweepConvexConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx20PxcSweepConvexConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4Effffff: __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4Effffff, __ZN5physx15PxsParticleDataD0Ev: __ZN5physx15PxsParticleDataD0Ev, __ZL19BlitFramebufferImplRN4gles23BlitFramebufferDrawQuadER9GfxDevice9TextureIDRK8Vector4f: __ZL19BlitFramebufferImplRN4gles23BlitFramebufferDrawQuadER9GfxDevice9TextureIDRK8Vector4f, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEE15growAndPushBackERKS2_, __Z57ParticleSystem_ShapeModule_CUSTOM_GetUseMeshMaterialIndexP12Il2CppObject: __Z57ParticleSystem_ShapeModule_CUSTOM_GetUseMeshMaterialIndexP12Il2CppObject, __ZNSt3__219__shared_mutex_base4lockEv: __ZNSt3__219__shared_mutex_base4lockEv, __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpeedP12Il2CppObjectf: __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpeedP12Il2CppObjectf, __Z28CalculateAllObjectReferencesR13dynamic_arrayIP6ObjectLj4EERS_IPKcLj4EERS_IjLj4EES9_b: __Z28CalculateAllObjectReferencesR13dynamic_arrayIP6ObjectLj4EERS_IPKcLj4EERS_IjLj4EES9_b, _nftw: _nftw, __ZN13AnimationClip12Vector3Curve8TransferI14SafeBinaryReadEEvRT_: __ZN13AnimationClip12Vector3Curve8TransferI14SafeBinaryReadEEvRT_, __ZN18PlayableController12GetFrameDataEv: __ZN18PlayableController12GetFrameDataEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN14Texture2DArray11InitTextureEiii13TextureFormatb: __ZN14Texture2DArray11InitTextureEiii13TextureFormatb, __ZN5physx7profile19MemoryEventRecorder12onAllocationEjPKcS3_iPv: __ZN5physx7profile19MemoryEventRecorder12onAllocationEjPKcS3_iPv, __Z64Register_UnityEngine_Renderer_GetClosestReflectionProbesInternalv: __Z64Register_UnityEngine_Renderer_GetClosestReflectionProbesInternalv, __ZN12_GLOBAL__N_110DataStream28sendPropertyMessageFromGroupEPKvN5physx8debugger7DataRefIKhEE: __ZN12_GLOBAL__N_110DataStream28sendPropertyMessageFromGroupEPKvN5physx8debugger7DataRefIKhEE, __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf: __ZN5physx15PxGeometryQuery14getWorldBoundsERKNS_10PxGeometryERKNS_11PxTransformEf, __Z22getPxSceneDesc_IsValidPKN5physx11PxSceneDescE: __Z22getPxSceneDesc_IsValidPKN5physx11PxSceneDescE, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEclEv: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEclEv, __ZN5physx2Sc9ClothCore18setSolverFrequencyEf: __ZN5physx2Sc9ClothCore18setSolverFrequencyEf, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetZMultiplierv, __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterSystemP12Il2CppObjecti: __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterSystemP12Il2CppObjecti, __ZN8ColliderC2E10MemLabelId18ObjectCreationMode: __ZN8ColliderC2E10MemLabelId18ObjectCreationMode, __Z5SlerpRK8Vector3fS1_f: __Z5SlerpRK8Vector3fS1_f, __ZN9InputAxis8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9InputAxis8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN11ForceModule8TransferI14SafeBinaryReadEEvRT_: __ZN11ForceModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Gu16buildPartialHullERKNS0_13PolygonalDataEPNS0_12SupportLocalERNS0_14SeparatingAxesERKNS_6shdfnd3aos5Vec3VESC_: __ZN5physx2Gu16buildPartialHullERKNS0_13PolygonalDataEPNS0_12SupportLocalERNS0_14SeparatingAxesERKNS_6shdfnd3aos5Vec3VESC_, __ZN8VRDevice11PostPresentEv: __ZN8VRDevice11PostPresentEv, __Z18Transfer_BlittableI14SafeBinaryReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E, __Z44ParticleSystem_NoiseModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z44ParticleSystem_NoiseModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb1EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb1EEEvP12NoiseJobData, __ZN7TerrainD2Ev: __ZN7TerrainD2Ev, __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZNK5physx2Sc16ArticulationCore17releaseDriveCacheERNS_9PxcFsDataE: __ZNK5physx2Sc16ArticulationCore17releaseDriveCacheERNS_9PxcFsDataE, _hashmd_48: _hashmd_48, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_, __Z62ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeMultiplierP12Il2CppObjectf: __Z62ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeMultiplierP12Il2CppObjectf, _UNITY_FT_List_Iterate: _UNITY_FT_List_Iterate, __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17GlobalGameManager8TransferI24GenerateTypeTreeTransferEEvRT_, __Z38Register_UnityEngine_GL_MultiTexCoord2v: __Z38Register_UnityEngine_GL_MultiTexCoord2v, __Z30scripting_method_has_attribute21ScriptingMethodIl2CppP11Il2CppClass: __Z30scripting_method_has_attribute21ScriptingMethodIl2CppP11Il2CppClass, __ZN5physx11NpAggregate7releaseEv: __ZN5physx11NpAggregate7releaseEv, __ZN5physx2Sn5ConvX16resetConvexFlagsEv: __ZN5physx2Sn5ConvX16resetConvexFlagsEv, __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetVectorv: __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetVectorv, __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags, __Z20SyncFenceCullResultsR11CullResults: __Z20SyncFenceCullResultsR11CullResults, __ZN15TextureTFMethod20IsBoneCountSupportedEi: __ZN15TextureTFMethod20IsBoneCountSupportedEi, __ZN26AnimatorControllerPlayable9GotoStateEiifff: __ZN26AnimatorControllerPlayable9GotoStateEiifff, __ZN10__cxxabiv112_GLOBAL__N_121parse_integer_literalINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_: __ZN10__cxxabiv112_GLOBAL__N_121parse_integer_literalINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_, __Z39Animator_Get_Custom_PropApplyRootMotionP12Il2CppObject: __Z39Animator_Get_Custom_PropApplyRootMotionP12Il2CppObject, __Z66Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_GetClosestPointv: __Z66Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_GetClosestPointv, __ZN5physx21MaterialIndicesStruct17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx21MaterialIndicesStruct17getBinaryMetaDataERNS_14PxOutputStreamE, __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEEjj, __ZN5physx7NpShape12setMaterialsEPKPNS_10PxMaterialEt: __ZN5physx7NpShape12setMaterialsEPKPNS_10PxMaterialEt, __ZN18PlayableController4StopEv: __ZN18PlayableController4StopEv, __ZNK17AnimationCurveTplIfE20EvaluateWithoutCacheEfRf: __ZNK17AnimationCurveTplIfE20EvaluateWithoutCacheEfRf, __ZNK5physx18NpArticulationLink13isSubordinateEv: __ZNK5physx18NpArticulationLink13isSubordinateEv, __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z37AnimationClipPlayable_CUSTOM_GetSpeedR9HPlayable: __Z37AnimationClipPlayable_CUSTOM_GetSpeedR9HPlayable, __ZNKSt3__25ctypeIcE9do_narrowEcc: __ZNKSt3__25ctypeIcE9do_narrowEcc, __ZN24RingBufferMemoryFileData26SetMaxAllocatedBlocksCountEj: __ZN24RingBufferMemoryFileData26SetMaxAllocatedBlocksCountEj, __Z36AssetBundle_Get_Custom_PropMainAssetP12Il2CppObject: __Z36AssetBundle_Get_Custom_PropMainAssetP12Il2CppObject, __ZN17InternalIndexPool11freeIndicesEjRKN5physx16PxStrideIteratorIKjEE: __ZN17InternalIndexPool11freeIndicesEjRKN5physx16PxStrideIteratorIKjEE, __ZN4crndL18crnd_default_msizeEPvS0_: __ZN4crndL18crnd_default_msizeEPvS0_, __ZN14Texture2DArray15ThreadedCleanupEv: __ZN14Texture2DArray15ThreadedCleanupEv, __ZNSt13runtime_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNSt13runtime_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionAllv: __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionAllv, __Z41CharacterController_Set_Custom_PropRadiusP12Il2CppObjectf: __Z41CharacterController_Set_Custom_PropRadiusP12Il2CppObjectf, __Z24RegisterStrippedTypeInfoI15NavMeshSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI15NavMeshSettingsEviPKcS2_, __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_: __ZN17AnimationCurveTplIfE8TransferI14SafeBinaryReadEEvRT_, __Z37RenderTexture_Get_Custom_PropIsVolumeP12Il2CppObject: __Z37RenderTexture_Get_Custom_PropIsVolumeP12Il2CppObject, __ZN14AvatarPlayback4InitEi: __ZN14AvatarPlayback4InitEi, __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc: __ZN19VREyeTextureManager13CreateTextureEPP13RenderTextureb14VRTextureUsageiiib15StereoscopicEyePKc, __Z40CleanupRendererAnimationBindingInterfacev: __Z40CleanupRendererAnimationBindingInterfacev, __ZN22ParticleSystemRenderer15InitializeClassEv: __ZN22ParticleSystemRenderer15InitializeClassEv, __ZThn4_NK12_GLOBAL__N_111StreamOwner11isConnectedEv: __ZThn4_NK12_GLOBAL__N_111StreamOwner11isConnectedEv, __ZN9Polygon2D8CopyFromERKS_: __ZN9Polygon2D8CopyFromERKS_, __ZN19TouchPhaseEmulationC2Efbb: __ZN19TouchPhaseEmulationC2Efbb, __ZN14CachingManager14MoveTempFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN14CachingManager14MoveTempFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __ZNK11AudioSource9IsPlayingEv: __ZNK11AudioSource9IsPlayingEv, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z36getPxVehicleDriveNW_ConcreteTypeNamePKN5physx16PxVehicleDriveNWE: __Z36getPxVehicleDriveNW_ConcreteTypeNamePKN5physx16PxVehicleDriveNWE, __ZN5physx8debugger19PropertyDescriptionD2Ev: __ZN5physx8debugger19PropertyDescriptionD2Ev, __ZNK5Unity9Component10GetEnabledEv: __ZNK5Unity9Component10GetEnabledEv, __Z15raycast_capsuleRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z15raycast_capsuleRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __ZNK19ShaderPropertySheet11HasPropertyERKN9ShaderLab16FastPropertyNameE: __ZNK19ShaderPropertySheet11HasPropertyERKN9ShaderLab16FastPropertyNameE, __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE8EndWriteEj: __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE8EndWriteEj, __ZN5physx6shdfnd10Foundation20getWarnOnceTimestampEv: __ZN5physx6shdfnd10Foundation20getWarnOnceTimestampEv, __ZN4FMOD7SystemI11setUserDataEPv: __ZN4FMOD7SystemI11setUserDataEPv, __Z15CanChangeInputs9HPlayable: __Z15CanChangeInputs9HPlayable, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE14getOwnerClientEv, __Z23getPxD6Joint_SwingLimitPKN5physx9PxD6JointE: __Z23getPxD6Joint_SwingLimitPKN5physx9PxD6JointE, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12createObjectERPhRNS_24PxDeserializationContextE, __Z16AsyncReadRequestP16AsyncReadCommand: __Z16AsyncReadRequestP16AsyncReadCommand, __Z44Register_UnityEngine_ParticleSystem_get_timev: __Z44Register_UnityEngine_ParticleSystem_get_timev, __ZNK5physx34PxsSolverConstraintPostProcessTask7getNameEv: __ZNK5physx34PxsSolverConstraintPostProcessTask7getNameEv, __ZN9dtNavMesh32setOffMeshConnectionCostModifierEyf: __ZN9dtNavMesh32setOffMeshConnectionCostModifierEyf, __Z57RenderSettings_Get_Custom_PropDefaultReflectionResolutionv: __Z57RenderSettings_Get_Custom_PropDefaultReflectionResolutionv, __ZNK18ProceduralMaterial19GetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial19GetSubstanceBooleanERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_: __ZN5physx2Gu23distancePointBoxSquaredERKNS_6PxVec3ES3_S3_RKNS_7PxMat33EPS1_, __ZN5physx9NpPhysics20MeshDeletionListener28onGuMeshFactoryBufferReleaseEPKNS_6PxBaseEtb: __ZN5physx9NpPhysics20MeshDeletionListener28onGuMeshFactoryBufferReleaseEPKNS_6PxBaseEtb, __Z46Register_UnityEngine_AndroidJNI_GetArrayLengthv: __Z46Register_UnityEngine_AndroidJNI_GetArrayLengthv, __Z24GetUnityAnalyticsManagerv: __Z24GetUnityAnalyticsManagerv, __Z52Register_UnityEngine_AndroidJNI_SetStaticObjectFieldv: __Z52Register_UnityEngine_AndroidJNI_SetStaticObjectFieldv, __ZN7mecanim9animation11DestroyClipEPNS0_4ClipERNS_6memory9AllocatorE: __ZN7mecanim9animation11DestroyClipEPNS0_4ClipERNS_6memory9AllocatorE, __ZN9InputAxis8TransferI14SafeBinaryReadEEvRT_: __ZN9InputAxis8TransferI14SafeBinaryReadEEvRT_, __ZNK21ExecutionOrderManager30GetCustomAwakeFromLoadQueueForEPKN5Unity4TypeE: __ZNK21ExecutionOrderManager30GetCustomAwakeFromLoadQueueForEPKN5Unity4TypeE, __ZNK5physx7NpScene9getActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEjj: __ZNK5physx7NpScene9getActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEjj, __ZN5physx6shdfnd10ThreadImpl7getSizeEv: __ZN5physx6shdfnd10ThreadImpl7getSizeEv, __ZN5physx2Cm8PtrTable17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Cm8PtrTable17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx15PxParticleFluidD0Ev: __ZN5physx15PxParticleFluidD0Ev, __ZN5physx11NodeManagerD0Ev: __ZN5physx11NodeManagerD0Ev, __ZNK14DetailDatabase18GetSupportedLayersEiiiiPi: __ZNK14DetailDatabase18GetSupportedLayersEiiiiPi, __ZN24OcclusionCullingSettingsD0Ev: __ZN24OcclusionCullingSettingsD0Ev, __ZN5Umbra9BitVectorC2EjPNS_9AllocatorE: __ZN5Umbra9BitVectorC2EjPNS_9AllocatorE, __Z19InterpolateKeyframeIfET_RK11KeyframeTplIS0_ES4_f: __Z19InterpolateKeyframeIfET_RK11KeyframeTplIS0_ES4_f, __Z44NavMesh_CUSTOM_INTERNAL_CALL_FindClosestEdgeRK8Vector3fP10NavMeshHiti: __Z44NavMesh_CUSTOM_INTERNAL_CALL_FindClosestEdgeRK8Vector3fP10NavMeshHiti, __ZN13GfxDeviceNull14EndBufferWriteEP9GfxBufferj: __ZN13GfxDeviceNull14EndBufferWriteEP9GfxBufferj, __ZN17AudioReverbFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17AudioReverbFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx2Sc8BodyCore6getSimEv: __ZNK5physx2Sc8BodyCore6getSimEv, __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_: __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEEC2EjjS6_, __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj: __ZNK5physx2Gu15HeightFieldUtil18getVertexFaceIndexEjjj, __ZN14AreaEffector2D15ThreadedCleanupEv: __ZN14AreaEffector2D15ThreadedCleanupEv, __ZN4PPtrI14SphereColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI14SphereColliderE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx16PxVehicleDriveNW12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx16PxVehicleDriveNW12createObjectERPhRNS_24PxDeserializationContextE, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7SetSizeEi: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7SetSizeEi, __Z6dtFreePv: __Z6dtFreePv, __Z44Register_UnityEngine_AI_NavMesh_GetLayerCostv: __Z44Register_UnityEngine_AI_NavMesh_GetLayerCostv, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZv, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE5CheckEv: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE5CheckEv, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z38Material_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_: __Z38Material_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_, __Z20SetThreadedGfxDeviceP9GfxDevice: __Z20SetThreadedGfxDeviceP9GfxDevice, __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_: __ZNSt3__26__sortIR26ColliderIdentityComparitorPP10Collider2DEEvT0_S6_T_, __ZN9GfxDevice8OnDeleteEv: __ZN9GfxDevice8OnDeleteEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj395ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj395ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags, __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Polygon2D7SetPathEiRK13dynamic_arrayI8Vector2fLj4EE: __ZN9Polygon2D7SetPathEiRK13dynamic_arrayI8Vector2fLj4EE, __ZN5physx56PxVehicleDriveNWSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE: __ZN5physx56PxVehicleDriveNWSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE, __Z22ValidateTlsfAllocationPvjiS_: __Z22ValidateTlsfAllocationPvjiS_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx31PxJointLimitConeGeneratedValuesC2EPKNS_16PxJointLimitConeE: __ZN5physx31PxJointLimitConeGeneratedValuesC2EPKNS_16PxJointLimitConeE, __ZN5physx2Cm12RefCountable14onRefCountZeroEv: __ZN5physx2Cm12RefCountable14onRefCountZeroEv, __ZN7mecanim9animation16ControllerMemory8TransferI8BlobSizeEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI8BlobSizeEEvRT_, __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI14SafeBinaryReadEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI14SafeBinaryReadEEvRS4_RT_, __Z30setPxScene_NbContactDataBlocksPN5physx7PxSceneEj: __Z30setPxScene_NbContactDataBlocksPN5physx7PxSceneEj, __ZNK5physx7NpCloth25getMotionConstraintConfigEv: __ZNK5physx7NpCloth25getMotionConstraintConfigEv, __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEvRT_j, __Z55ParticleSystemRenderer_CUSTOM_Internal_SetVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlagsh: __Z55ParticleSystemRenderer_CUSTOM_Internal_SetVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlagsh, __Z12GUIDToStringRK9UnityGUID: __Z12GUIDToStringRK9UnityGUID, __ZN10CastFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE: __ZN10CastFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE, __Z33CanvasRenderer_CUSTOM_GetMaterialP12Il2CppObjecti: __Z33CanvasRenderer_CUSTOM_GetMaterialP12Il2CppObjecti, __ZNSt3__211__stdoutbufIwE6xsputnEPKwi: __ZNSt3__211__stdoutbufIwE6xsputnEPKwi, __ZN9Projector8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Projector8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN22UnityAnalyticsSettingsC2Ev: __ZN22UnityAnalyticsSettingsC2Ev, __ZN16b2PrismaticJoint16SetMaxMotorForceEf: __ZN16b2PrismaticJoint16SetMaxMotorForceEf, __ZThn8_N5physx2Sc24ElementInteractionMarker7destroyEv: __ZThn8_N5physx2Sc24ElementInteractionMarker7destroyEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm, __Z29StdTemplateConversionFunctionItxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItxEbPvR14SafeBinaryRead, __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector3Ei: __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector3Ei, __Z29Transfer_Blittable_ArrayFieldI9JSONWritexEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritexEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesEPKNS0_12TriangleDataEPS2_RNS3_18ImpulseAccumulatorE: __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesEPKNS0_12TriangleDataEPS2_RNS3_18ImpulseAccumulatorE, __ZNK5Umbra4Tome14getObjectCountEv: __ZNK5Umbra4Tome14getObjectCountEv, __ZN5physx3Cct26CharacterControllerManager24setOverlapRecoveryModuleEb: __ZN5physx3Cct26CharacterControllerManager24setOverlapRecoveryModuleEb, __Z71Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshMaterialIndexv: __Z71Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshMaterialIndexv, __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_: __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6resizeEjc, __Z46ParticleSystem_NoiseModule_CUSTOM_SetFrequencyP12Il2CppObjectf: __Z46ParticleSystem_NoiseModule_CUSTOM_SetFrequencyP12Il2CppObjectf, __ZThn32_N16ParticleRenderer19UpdateTransformInfoEv: __ZThn32_N16ParticleRenderer19UpdateTransformInfoEv, __Z59Register_UnityEngine_Joint_set_autoConfigureConnectedAnchorv: __Z59Register_UnityEngine_Joint_set_autoConfigureConnectedAnchorv, __ZN14RenderSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_: __ZN14RenderSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E, __ZN17PhysicsMaterial2D15ThreadedCleanupEv: __ZN17PhysicsMaterial2D15ThreadedCleanupEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Flare23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Flare23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK11AudioSource8IsPausedEv: __ZNK11AudioSource8IsPausedEv, __ZN4FMOD6System15getNetworkProxyEPci: __ZN4FMOD6System15getNetworkProxyEPci, __ZN12TLSAllocatorI14StackAllocatorE8AllocateEji: __ZN12TLSAllocatorI14StackAllocatorE8AllocateEji, __ZN16ScriptingManager18GetMonoScriptCacheEi: __ZN16ScriptingManager18GetMonoScriptCacheEi, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_, _wms_write: _wms_write, __ZN14PhysicsManager21SetQueriesHitTriggersEb: __ZN14PhysicsManager21SetQueriesHitTriggersEb, __ZN20ArchiveStorageHeader13GetDataOffsetERKNS_6HeaderE: __ZN20ArchiveStorageHeader13GetDataOffsetERKNS_6HeaderE, __ZNK21ScriptingObjectOfTypeI10AudioMixerEptEv: __ZNK21ScriptingObjectOfTypeI10AudioMixerEptEv, __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS4_L18MemLabelIdentifier52ELi16EEEEEvRT_j, __Z51Register_UnityEngine_Renderer_set_shadowCastingModev: __Z51Register_UnityEngine_Renderer_set_shadowCastingModev, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15AudioEchoFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15AudioEchoFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv, __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_S5_T_, __ZN5physx6shdfnd5ArrayINS_17PxTaskDepTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_17PxTaskDepTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIfEEvRT_PKc17TransferMetaFlagsb, __Z45BuoyancyEffector2D_Get_Custom_PropAngularDragP12Il2CppObject: __Z45BuoyancyEffector2D_Get_Custom_PropAngularDragP12Il2CppObject, _pthread_mutex_trylock: _pthread_mutex_trylock, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIwEE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi155EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi155EEEEvRT_17TransferMetaFlags, __ZN13AnimationClip9PPtrCurve8TransferI14SafeBinaryReadEEvRT_: __ZN13AnimationClip9PPtrCurve8TransferI14SafeBinaryReadEEvRT_, __ZN9ShaderLab7Program22ComputeSupportsShadowsEv: __ZN9ShaderLab7Program22ComputeSupportsShadowsEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKcj, __Z64Register_UnityEngineInternal_GIDebugVisualisation_PauseCycleModev: __Z64Register_UnityEngineInternal_GIDebugVisualisation_PauseCycleModev, __ZN5physx7NpCloth25setSelfCollisionStiffnessEf: __ZN5physx7NpCloth25setSelfCollisionStiffnessEf, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN26SizeModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN26SizeModulePropertyBindings13GetFloatValueERK14ParticleSystemi, _logb: _logb, __ZN13Simd4iFactoryIN6detail9FourTupleEEC2Eiiii: __ZN13Simd4iFactoryIN6detail9FourTupleEEC2Eiiii, __Z54SystemInfo_Get_Custom_PropSupportsCubemapArrayTexturesv: __Z54SystemInfo_Get_Custom_PropSupportsCubemapArrayTexturesv, _int_downsample: _int_downsample, __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZL41FileEntryInfoListToFolderContentsAbsoluteRK13dynamic_arrayI13FileEntryInfoLj8EERNSt3__23setINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS4_4lessISB_EENS9_ISB_EEEE: __ZL41FileEntryInfoListToFolderContentsAbsoluteRK13dynamic_arrayI13FileEntryInfoLj8EERNSt3__23setINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS4_4lessISB_EENS9_ISB_EEEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE: __ZN10Collider2D14FinalizeCreateERK10Matrix4x4fR12b2FixtureDefP6b2BodyPK13dynamic_arrayIP7b2ShapeLj4EE, __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateShaderHandleErrorsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateShaderHandleErrorsstruct7ForwardEv, __ZN15SerializeTraitsI33EnlightenTerrainChunksInformationE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI33EnlightenTerrainChunksInformationE8TransferI14SafeBinaryReadEEvRS0_RT_, __Z26BeginRenderQueueExtractionR15RenderNodeQueueRK11CullResults15ExtractionFlags: __Z26BeginRenderQueueExtractionR15RenderNodeQueueRK11CullResults15ExtractionFlags, __ZN5physx2Sc14ConstraintCoreD2Ev: __ZN5physx2Sc14ConstraintCoreD2Ev, __ZN6b2Body12SetTransformERK6b2Vec2f: __ZN6b2Body12SetTransformERK6b2Vec2f, __ZNK32RendererMaterialAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK32RendererMaterialAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetSeparateAxesv: __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetSeparateAxesv, __ZN5physx15PxVehicleWheels17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx15PxVehicleWheels17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __Z13GetIAnimationv: __Z13GetIAnimationv, __ZL18stbir__support_onef: __ZL18stbir__support_onef, __Z50RenderSettings_CUSTOM_INTERNAL_get_ambientSkyColorP10ColorRGBAf: __Z50RenderSettings_CUSTOM_INTERNAL_get_ambientSkyColorP10ColorRGBAf, __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __ZN12FileAccessor5WriteEyyPKvPy: __ZN12FileAccessor5WriteEyyPKvPy, __ZN20TextRenderingPrivate8TextMesh11SetFontSizeEi: __ZN20TextRenderingPrivate8TextMesh11SetFontSizeEi, __Z42Terrain_Get_Custom_PropHeightmapMaximumLODP12Il2CppObject: __Z42Terrain_Get_Custom_PropHeightmapMaximumLODP12Il2CppObject, __ZN14VelocityModuleD2Ev: __ZN14VelocityModuleD2Ev, __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_: __ZNSt3__27__sort5IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_S7_T_, _UNITY_FT_DivFix: _UNITY_FT_DivFix, __Z47ConfigurableJoint_Get_Custom_PropAngularYMotionP12Il2CppObject: __Z47ConfigurableJoint_Get_Custom_PropAngularYMotionP12Il2CppObject, __ZN17PolygonCollider2D12SetPolygon2DEP9Polygon2D: __ZN17PolygonCollider2D12SetPolygon2DEP9Polygon2D, __ZN16ParticleRendererD2Ev: __ZN16ParticleRendererD2Ev, __Z15CreateUdpSocketPKctRi: __Z15CreateUdpSocketPKctRi, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE21__grow_by_and_replaceEjjjjjjPKc, __ZN5Umbra10bitOpsTestEv: __ZN5Umbra10bitOpsTestEv, __ZNK17PolygonCollider2D26GetTypeInfoVirtualInternalEv: __ZNK17PolygonCollider2D26GetTypeInfoVirtualInternalEv, __ZN5physx8debugger4comm18EventSerializeableD2Ev: __ZN5physx8debugger4comm18EventSerializeableD2Ev, __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNK30SpriteRendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK30SpriteRendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __ZNKSt3__220__time_get_c_storageIcE7__am_pmEv: __ZNKSt3__220__time_get_c_storageIcE7__am_pmEv, __ZN20NavMeshBuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20NavMeshBuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx9PxTaskMgr14emitStartEventERNS_10PxBaseTaskEj: __ZN5physx9PxTaskMgr14emitStartEventERNS_10PxBaseTaskEj, __ZN7mecanim14ValueArrayCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi: __ZN7mecanim14ValueArrayCopyEPKNS_18ValueArrayConstantEPKNS_10ValueArrayES2_PS3_PKi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN5physx5cloth16SwInterCollisionI8Scalar4fEclEv: __ZN5physx5cloth16SwInterCollisionI8Scalar4fEclEv, __Z22ConvertAddressToStringP8sockaddrj: __Z22ConvertAddressToStringP8sockaddrj, __ZN4FMOD6System13setPluginPathEPKc: __ZN4FMOD6System13setPluginPathEPKc, __Z14RandomRotationP9Texture2DPhiiii: __Z14RandomRotationP9Texture2DPhiiii, __ZN23ShaderVariantCollection23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN23ShaderVariantCollection23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z45Register_UnityEngine_AndroidJNI_CallIntMethodv: __Z45Register_UnityEngine_AndroidJNI_CallIntMethodv, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI17RemapPPtrTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI17RemapPPtrTransferEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZNK4Mesh15ExtractTriangleEjPj: __ZNK4Mesh15ExtractTriangleEjPj, __ZNK8VRDevice23GetIsParallelProjectionEv: __ZNK8VRDevice23GetIsParallelProjectionEv, __ZN5physx22XmlMemoryAllocatorImpl12getAllocatorEv: __ZN5physx22XmlMemoryAllocatorImpl12getAllocatorEv, __Z43DownloadHandler_CUSTOM_InternalCreateScriptP12Il2CppObject: __Z43DownloadHandler_CUSTOM_InternalCreateScriptP12Il2CppObject, __ZN5physx7NpScene22removeBroadPhaseRegionEj: __ZN5physx7NpScene22removeBroadPhaseRegionEj, __ZN5physx7NpScene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE: __ZN5physx7NpScene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE, __ZNK5physx17ConvexHullBuilder17ComputeGeomCenterERNS_6PxVec3E: __ZNK5physx17ConvexHullBuilder17ComputeGeomCenterERNS_6PxVec3E, __ZN12_GLOBAL__N_116MetaDataProvider7releaseEv: __ZN12_GLOBAL__N_116MetaDataProvider7releaseEv, __ZN13GfxDeviceNull22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace: __ZN13GfxDeviceNull22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace, __ZN3MBPD0Ev: __ZN3MBPD0Ev, __ZNK13EmscriptenWWW14GetPartialDataEv: __ZNK13EmscriptenWWW14GetPartialDataEv, __Z50Register_UnityEngine_Camera_INTERNAL_get_pixelRectv: __Z50Register_UnityEngine_Camera_INTERNAL_get_pixelRectv, __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene: __ZN19RuntimeSceneManager14LoadSceneAsyncERK8UnityStrS2_S2_RK9UnityGUIDiNS_11LoadingModeEbRP10UnityScene, __Z24RegisterStrippedTypeInfoI14AudioBehaviourEviPKcS2_: __Z24RegisterStrippedTypeInfoI14AudioBehaviourEviPKcS2_, __ZN21AnimationClipPlayable12PrepareFrameERK9FrameDataP8Playable: __ZN21AnimationClipPlayable12PrepareFrameERK9FrameDataP8Playable, __ZNSt3__26locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __Z51Register_UnityEngine_Caching_get_compressionEnabledv: __Z51Register_UnityEngine_Caching_get_compressionEnabledv, __ZN8Animator13StartPlaybackEv: __ZN8Animator13StartPlaybackEv, __ZNK5physx10PxsContext18getBounceThresholdEv: __ZNK5physx10PxsContext18getBounceThresholdEv, __ZNSt3__217__widen_from_utf8ILj32EED0Ev: __ZNSt3__217__widen_from_utf8ILj32EED0Ev, __Z13GetIPhysics2Dv: __Z13GetIPhysics2Dv, __ZN11UnityEngine15CloudWebService14RestDownloader17OnCompleteContentEv: __ZN11UnityEngine15CloudWebService14RestDownloader17OnCompleteContentEv, __ZNK6Camera18ViewportPointToRayERK8Vector2f: __ZNK6Camera18ViewportPointToRayERK8Vector2f, __Z39scripting_free_captured_memory_snapshotP14MemorySnapshot: __Z39scripting_free_captured_memory_snapshotP14MemorySnapshot, __ZN13RendererScene25SetOcclusionPortalEnabledEjb: __ZN13RendererScene25SetOcclusionPortalEnabledEjb, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEE15growAndPushBackERKS2_, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN11ColorModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32: __ZN11ColorModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32, __Z51Register_UnityEngine_CharacterController_set_radiusv: __Z51Register_UnityEngine_CharacterController_set_radiusv, __Z41Register_UnityEngine_GameObject_set_layerv: __Z41Register_UnityEngine_GameObject_set_layerv, __ZN5physx6shdfnd6Socket10disconnectEv: __ZN5physx6shdfnd6Socket10disconnectEv, __ZN5physx15NpParticleFluid15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpParticleFluid15exportExtraDataERNS_22PxSerializationContextE, __ZN5physx2Gu11HeightField17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu11HeightField17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx6shdfnd15atomicDecrementEPVi: __ZN5physx6shdfnd15atomicDecrementEPVi, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEED0Ev, __Z40AreaEffector2D_Get_Custom_PropForceAngleP12Il2CppObject: __Z40AreaEffector2D_Get_Custom_PropForceAngleP12Il2CppObject, __Z46setPxSimulationStatisticsNbActiveDynamicBodiesPN5physx22PxSimulationStatisticsEj: __Z46setPxSimulationStatisticsNbActiveDynamicBodiesPN5physx22PxSimulationStatisticsEj, __ZN20LocalFileSystemWebGL6DeleteER13FileEntryDatab: __ZN20LocalFileSystemWebGL6DeleteER13FileEntryDatab, __ZN6Sprite19CanAccessFromScriptEv: __ZN6Sprite19CanAccessFromScriptEv, __ZN8Animator24SetHasTransformHierarchyEb: __ZN8Animator24SetHasTransformHierarchyEb, __Z37AudioEchoFilter_Set_Custom_PropWetMixP12Il2CppObjectf: __Z37AudioEchoFilter_Set_Custom_PropWetMixP12Il2CppObjectf, __Z23PlayerPrefs_CUSTOM_Savev: __Z23PlayerPrefs_CUSTOM_Savev, __ZN8Collider18SelfPointerToWordsERjS0_: __ZN8Collider18SelfPointerToWordsERjS0_, __ZN13SliderJoint2D12SetUseLimitsEb: __ZN13SliderJoint2D12SetUseLimitsEb, __Z39HingeJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK18JointAngleLimits2D: __Z39HingeJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK18JointAngleLimits2D, __ZN9Projector23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Projector23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_, __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi: __ZN4gles23ClearCurrentFramebufferEP7ApiGLESbbbRK10ColorRGBAffi, __ZN7mecanim12statemachine20CreateStateWorkspaceEjjjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine20CreateStateWorkspaceEjjjRNS_6memory9AllocatorE, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E5clearEv: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E5clearEv, __ZN5physx2Gu11HeightField13releaseMemoryEb: __ZN5physx2Gu11HeightField13releaseMemoryEb, __ZNK8WWWAudio6IsDoneEv: __ZNK8WWWAudio6IsDoneEv, __Z39Light_Set_Custom_PropShadowSoftnessFadeP12Il2CppObjectf: __Z39Light_Set_Custom_PropShadowSoftnessFadeP12Il2CppObjectf, __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN10FileSystem25MountDataFolderFileSystemERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN10FileSystem25MountDataFolderFileSystemERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __Z55TerrainData_CUSTOM_Internal_GetMaximumBaseMapResolutionv: __Z55TerrainData_CUSTOM_Internal_GetMaximumBaseMapResolutionv, __Z47Playable_CUSTOM_INTERNAL_CALL_GetOutputInternalR9HPlayableiS0_: __Z47Playable_CUSTOM_INTERNAL_CALL_GetOutputInternalR9HPlayableiS0_, __ZN5physx27PxVehicleSuspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb: __ZN5physx27PxVehicleSuspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb, __Z32Graphics_CUSTOM_CopyTexture_FullP12Il2CppObjectS0_: __Z32Graphics_CUSTOM_CopyTexture_FullP12Il2CppObjectS0_, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN17Physics2DSettings15ThreadedCleanupEv: __ZN17Physics2DSettings15ThreadedCleanupEv, __ZNK8GUIStyle21DrawWithTextSelectionER8GUIStateRK5RectTIfER10GUIContentbbbbbiiRK10ColorRGBAfSA_: __ZNK8GUIStyle21DrawWithTextSelectionER8GUIStateRK5RectTIfER10GUIContentbbbbbiiRK10ColorRGBAfSA_, __ZN10systeminfo21SupportsAccelerometerEv: __ZN10systeminfo21SupportsAccelerometerEv, __Z14GetBuiltinSkini: __Z14GetBuiltinSkini, __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKjNS0_27EventStreamCompressionFlags4EnumE, _jsimd_convsamp: _jsimd_convsamp, __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_localVelocityv: __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_localVelocityv, __ZN2UI13RectTransform23VirtualRedirectTransferER14SafeBinaryRead: __ZN2UI13RectTransform23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx7NpScene17flushQueryUpdatesEv: __ZN5physx7NpScene17flushQueryUpdatesEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __ZN5physx19NpArticulationJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx19NpArticulationJoint12createObjectERPhRNS_24PxDeserializationContextE, __ZN14ImageReference9BlitImageEiiRKS_: __ZN14ImageReference9BlitImageEiiRKS_, __ZZL31InitializeAudioManagerCallbacksvEN33FixedUpdateAudioFixedUpdatestruct7ForwardEv: __ZZL31InitializeAudioManagerCallbacksvEN33FixedUpdateAudioFixedUpdatestruct7ForwardEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN5physx48PCMCapsuleVsHeightfieldContactGenerationCallbackD0Ev: __ZN5physx48PCMCapsuleVsHeightfieldContactGenerationCallbackD0Ev, __ZN17BufferManagerGLES14InsertIntoLiveEP14DataBufferGLES: __ZN17BufferManagerGLES14InsertIntoLiveEP14DataBufferGLES, __ZN17PersistentManagerC2Eii: __ZN17PersistentManagerC2Eii, __ZZN14ParticleSystem15InitializeClassEvEN46PostLateUpdateParticleSystemEndUpdateAllstruct7ForwardEv: __ZZN14ParticleSystem15InitializeClassEvEN46PostLateUpdateParticleSystemEndUpdateAllstruct7ForwardEv, __Z46Register_UnityEngine_GUI_get_usePageScrollbarsv: __Z46Register_UnityEngine_GUI_get_usePageScrollbarsv, __ZN5physx8debugger15ForwardingArrayINS0_18PropertyMessageArgEED0Ev: __ZN5physx8debugger15ForwardingArrayINS0_18PropertyMessageArgEED0Ev, __ZN5physx22PxSerializationContextD2Ev: __ZN5physx22PxSerializationContextD2Ev, __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _cff_builder_add_point1: _cff_builder_add_point1, __ZN5physx9PxTaskMgr10startAfterERNS_6PxTaskEj: __ZN5physx9PxTaskMgr10startAfterERNS_6PxTaskEj, __Z8GetStatsPKN5physx7PxSceneE: __Z8GetStatsPKN5physx7PxSceneE, __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_: __ZN11TypeManager20RegisterNonClassTypeEiP4RTTIPKcS3_, __ZN12PhysXRaycast15InitializeClassEv: __ZN12PhysXRaycast15InitializeClassEv, __Z30getPxDistanceJoint_MaxDistancePKN5physx15PxDistanceJointE: __Z30getPxDistanceJoint_MaxDistancePKN5physx15PxDistanceJointE, __ZN5physx7NpScene10unlockReadEv: __ZN5physx7NpScene10unlockReadEv, __Z61Register_UnityEngine_AudioLowPassFilter_get_customCutoffCurvev: __Z61Register_UnityEngine_AudioLowPassFilter_get_customCutoffCurvev, __ZN5physx2Gu31SinglePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_: __ZN5physx2Gu31SinglePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_, __ZN9ShaderLab14SerializedPass8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab14SerializedPass8TransferI14SafeBinaryReadEEvRT_, __Z41Register_UnityEngine_Texture2DArray_Applyv: __Z41Register_UnityEngine_Texture2DArray_Applyv, __ZNK12TextureInput9GetBufferEv: __ZNK12TextureInput9GetBufferEv, __ZNSt3__221undeclare_no_pointersEPcj: __ZNSt3__221undeclare_no_pointersEPcj, __Z51Register_UnityEngine_AudioEchoFilter_set_decayRatiov: __Z51Register_UnityEngine_AudioEchoFilter_set_decayRatiov, __ZN4FMOD8ChannelI9getPausedEPb: __ZN4FMOD8ChannelI9getPausedEPb, __ZN13MemoryManager20SetTempAllocatorSizeEj: __ZN13MemoryManager20SetTempAllocatorSizeEj, __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc: __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPK2tmcc, __ZN14SplatMaterials14SetTerrainDataERK4PPtrI11TerrainDataE: __ZN14SplatMaterials14SetTerrainDataERK4PPtrI11TerrainDataE, __ZN12TreeRenderer22CleanupBillboardMeshesEv: __ZN12TreeRenderer22CleanupBillboardMeshesEv, __ZNK15AudioMixerGroup26GetTypeInfoVirtualInternalEv: __ZNK15AudioMixerGroup26GetTypeInfoVirtualInternalEv, __ZN16Physics2DManager22RemoveRigidbodyUpdatesEP11Rigidbody2D: __ZN16Physics2DManager22RemoveRigidbodyUpdatesEP11Rigidbody2D, __ZNK9Projector26GetTypeInfoVirtualInternalEv: __ZNK9Projector26GetTypeInfoVirtualInternalEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _btowc: _btowc, __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthYP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthYP12Il2CppObjectR15MonoMinMaxCurve, __Z20GetStackTraceLogType7LogType: __Z20GetStackTraceLogType7LogType, __Z19GL_CUSTOM_TexCoord2ff: __Z19GL_CUSTOM_TexCoord2ff, __Z56Register_UnityEngine_Analytics_CustomEventData_AddDoublev: __Z56Register_UnityEngine_Analytics_CustomEventData_AddDoublev, __ZN11ChannelInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11ChannelInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN12WheelJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN12WheelJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN23ArchiveStorageConverter24ReadHeaderFromMemoryFileEv: __ZN23ArchiveStorageConverter24ReadHeaderFromMemoryFileEv, __ZN22UnityAnalyticsSettingsD2Ev: __ZN22UnityAnalyticsSettingsD2Ev, __ZN5physx2Sc9ClothCore22setFrictionCoefficientEf: __ZN5physx2Sc9ClothCore22setFrictionCoefficientEf, __Z54Register_UnityEngine_AreaEffector2D_set_forceMagnitudev: __Z54Register_UnityEngine_AreaEffector2D_set_forceMagnitudev, __Z18Transfer_BlittableI8JSONReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx9NpPhysics17getNbConvexMeshesEv: __ZNK5physx9NpPhysics17getNbConvexMeshesEv, __ZNK5physx7NpScene29getContactCorrelationDistanceEv: __ZNK5physx7NpScene29getContactCorrelationDistanceEv, __Z34Register_UnityEngine_Gradient_Initv: __Z34Register_UnityEngine_Gradient_Initv, _setstate: _setstate, __ZN13InitialModule8TransferI17RemapPPtrTransferEEvRT_: __ZN13InitialModule8TransferI17RemapPPtrTransferEEvRT_, __Z26TransformVerticesInnerLoopILb1ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb1ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __ZN14VRSplashScreen19CreateSplashObjectsE4PPtrI9Texture2DEf: __ZN14VRSplashScreen19CreateSplashObjectsE4PPtrI9Texture2DEf, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev, __Z24RegisterStrippedTypeInfoIN5Unity10FixedJointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity10FixedJointEEviPKcS3_, __ZNK6Camera17GetStereoEyeBeginEv: __ZNK6Camera17GetStereoEyeBeginEv, __Z23AssignGlobalGameManagerP6Object: __Z23AssignGlobalGameManagerP6Object, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN9Animation13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Animation13AwakeFromLoadE17AwakeFromLoadMode, _cacos: _cacos, __ZL23CheckAndClearChangedJobPiPK23TransformAccessReadOnlyj: __ZL23CheckAndClearChangedJobPiPK23TransformAccessReadOnlyj, __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferERNS_19PxAllocatorCallbackEj: __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferERNS_19PxAllocatorCallbackEj, __ZN12LineRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12LineRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9InputAxis8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9InputAxis8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx16PxsIslandManager16clearEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager16clearEdgeRigidCMERKNS_20PxsIslandManagerHookIjLj4294967295EEE, __Z47ConfigurableJoint_Get_Custom_PropAngularXMotionP12Il2CppObject: __Z47ConfigurableJoint_Get_Custom_PropAngularXMotionP12Il2CppObject, __Z45Register_UnityEngine_GUIStyle_GetFontInternalv: __Z45Register_UnityEngine_GUIStyle_GetFontInternalv, __ZN8Animator8InitStepEf: __ZN8Animator8InitStepEf, __Z53Register_UnityEngine_AudioReverbZone_get_decayHFRatiov: __Z53Register_UnityEngine_AudioReverbZone_get_decayHFRatiov, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj594ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj594ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z45SliderJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject: __Z45SliderJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject, __ZN5physx6shdfnd8SyncImpl4waitEj: __ZN5physx6shdfnd8SyncImpl4waitEj, __Z53Register_UnityEngine_QualitySettings_get_blendWeightsv: __Z53Register_UnityEngine_QualitySettings_get_blendWeightsv, __ZN5physx31PxDefaultBufferedProfilerCreateERNS_12PxFoundationEPKc: __ZN5physx31PxDefaultBufferedProfilerCreateERNS_12PxFoundationEPKc, __Z13RegisterClassI13WebCamTextureEvv: __Z13RegisterClassI13WebCamTextureEvv, __Z51Register_UnityEngine_Rigidbody2D_set_freezeRotationv: __Z51Register_UnityEngine_Rigidbody2D_set_freezeRotationv, __Z50Physics_CUSTOM_INTERNAL_CALL_OverlapSphereNonAllocRK8Vector3ffP11Il2CppArrayi23QueryTriggerInteraction: __Z50Physics_CUSTOM_INTERNAL_CALL_OverlapSphereNonAllocRK8Vector3ffP11Il2CppArrayi23QueryTriggerInteraction, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9push_backEc, __ZNK24MeshIntermediateRenderer14GetSubsetIndexEi: __ZNK24MeshIntermediateRenderer14GetSubsetIndexEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj93ENS_22PxRepXPropertyAccessorILj93ES4_PKcSA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj93ENS_22PxRepXPropertyAccessorILj93ES4_PKcSA_EEEEvRKT0_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZNSt3__214__split_bufferIN9ShaderLab20SerializedSubProgramERNS_9allocatorIS2_EEE18__construct_at_endEj: __ZNSt3__214__split_bufferIN9ShaderLab20SerializedSubProgramERNS_9allocatorIS2_EEE18__construct_at_endEj, __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutjS1_P11ChannelInfo: __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutjS1_P11ChannelInfo, __ZN17Physics2DSettings21UpdateBox2DPropertiesEv: __ZN17Physics2DSettings21UpdateBox2DPropertiesEv, __ZN33SizeBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN33SizeBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN18AnimatorControllerD0Ev: __ZN18AnimatorControllerD0Ev, __ZN11UmbraModule19GetUmbraObjectCountEPKN5Umbra4TomeE: __ZN11UmbraModule19GetUmbraObjectCountEPKN5Umbra4TomeE, _rgb_rgb_convert: _rgb_rgb_convert, __ZN5physx6PxVec3C2Efff: __ZN5physx6PxVec3C2Efff, __Z45Register_UnityEngine_Motion_get_isHumanMotionv: __Z45Register_UnityEngine_Motion_get_isHumanMotionv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj505ENS_22PxRepXPropertyAccessorILj505ENS_8PxSpringEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj505ENS_22PxRepXPropertyAccessorILj505ENS_8PxSpringEffEEEEvRKT0_, __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26locale5__impC2ERKS1_: __ZNSt3__26locale5__impC2ERKS1_, __Z46Register_UnityEngine_SystemInfo_get_deviceNamev: __Z46Register_UnityEngine_SystemInfo_get_deviceNamev, __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEixEj: __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEixEj, __Z37AudioSource_Set_Custom_PropSpatializeP12Il2CppObjecth: __Z37AudioSource_Set_Custom_PropSpatializeP12Il2CppObjecth, __Z35AudioListener_Set_Custom_PropVolumef: __Z35AudioListener_Set_Custom_PropVolumef, __ZN5physx17PxsFluidCollisionC2ERNS_20PxsParticleSystemSimE: __ZN5physx17PxsFluidCollisionC2ERNS_20PxsParticleSystemSimE, __ZN14ParticleSystem8TransferI17RemapPPtrTransferEEvRT_: __ZN14ParticleSystem8TransferI17RemapPPtrTransferEEvRT_, __ZNSt3__24stolERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji: __ZNSt3__24stolERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji, __ZN26AnimatorControllerPlayable14SetLayerWeightEif: __ZN26AnimatorControllerPlayable14SetLayerWeightEif, __Z52QualitySettings_Set_Custom_PropShadowNearPlaneOffsetf: __Z52QualitySettings_Set_Custom_PropShadowNearPlaneOffsetf, _fdatasync: _fdatasync, __ZN15NavMeshSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15NavMeshSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEbjPKNS_16HullTriangleDataE: __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEbjPKNS_16HullTriangleDataE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7crbeginEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7crbeginEv, __ZN13BuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13BuildSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx13NpVolumeCache17getNbCachedShapesEv: __ZN5physx13NpVolumeCache17getNbCachedShapesEv, __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj390ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj390ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZL21CompileFragmentShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb: __ZL21CompileFragmentShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb, __ZN15dtPathQueryInfoC2Ev: __ZN15dtPathQueryInfoC2Ev, __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4FMOD12ChannelGroup17overrideFrequencyEf: __ZN4FMOD12ChannelGroup17overrideFrequencyEf, __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN17PersistentManager12UnloadStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZN8Playable12PrepareFrameERK9FrameDataPS_: __ZN8Playable12PrepareFrameERK9FrameDataPS_, __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24CreateDirectoryRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14AreaEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14AreaEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z54setPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj: __Z54setPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj, __ZN26AnimatorControllerPlayable27SetupStateMachineBehavioursEP6Object: __ZN26AnimatorControllerPlayable27SetupStateMachineBehavioursEP6Object, __Z38Joint2D_Get_Custom_PropEnableCollisionP12Il2CppObject: __Z38Joint2D_Get_Custom_PropEnableCollisionP12Il2CppObject, __ZN22RenderingCommandBuffer22AddSetGlobalFloatArrayERKN9ShaderLab16FastPropertyNameEPKfi: __ZN22RenderingCommandBuffer22AddSetGlobalFloatArrayERKN9ShaderLab16FastPropertyNameEPKfi, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __ZNK24OcclusionCullingSettings26GetTypeInfoVirtualInternalEv: __ZNK24OcclusionCullingSettings26GetTypeInfoVirtualInternalEv, __Z30CalculateAABBFromPositionArrayRK10Matrix4x4fPK8Vector3fj: __Z30CalculateAABBFromPositionArrayRK10Matrix4x4fPK8Vector3fj, __ZN6HelperI9JSONWrite23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI9JSONWrite23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN5physx2Sc5Scene15getRenderBufferEv: __ZN5physx2Sc5Scene15getRenderBufferEv, __ZN12ImageFilters8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE: __ZN12ImageFilters8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE, __Z37getPxDistanceJoint_DistanceJointFlagsPKN5physx15PxDistanceJointE: __Z37getPxDistanceJoint_DistanceJointFlagsPKN5physx15PxDistanceJointE, __Z36getPxVehicleDriveSimData_AutoBoxDataPKN5physx21PxVehicleDriveSimDataE: __Z36getPxVehicleDriveSimData_AutoBoxDataPKN5physx21PxVehicleDriveSimDataE, __ZN20UnityConnectSettings10InitializeEv: __ZN20UnityConnectSettings10InitializeEv, __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_64kDidModifyMotion4CallEPviR11MessageData: __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_64kDidModifyMotion4CallEPviR11MessageData, __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_SetTreeInstancev: __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_SetTreeInstancev, __Z49ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitP12Il2CppObjectRK14SoftJointLimit: __Z49ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitP12Il2CppObjectRK14SoftJointLimit, __Z18get_root_referencePvRK10MemLabelId: __Z18get_root_referencePvRK10MemLabelId, __ZN5physx2Sc15CoreInteractionD0Ev: __ZN5physx2Sc15CoreInteractionD0Ev, __ZN9AudioClip11CreateSoundEv: __ZN9AudioClip11CreateSoundEv, __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE: __ZN5physx17PxcNpMemBlockPool23releaseConstraintBlocksERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE, __ZN5physx2Gu34checkOverlapSphere_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu34checkOverlapSphere_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __Z36Terrain_Get_Custom_PropActiveTerrainv: __Z36Terrain_Get_Custom_PropActiveTerrainv, __Z27setPxBoxGeometryHalfExtentsPN5physx13PxBoxGeometryENS_6PxVec3E: __Z27setPxBoxGeometryHalfExtentsPN5physx13PxBoxGeometryENS_6PxVec3E, __Z55Register_UnityEngine_LightProbeGroup_get_probePositionsv: __Z55Register_UnityEngine_LightProbeGroup_get_probePositionsv, __ZN2UI13RectTransform15ThreadedCleanupEv: __ZN2UI13RectTransform15ThreadedCleanupEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN11UnityEngine7Connect16PersistentValues13RestoreValuesER8JSONRead: __ZN11UnityEngine7Connect16PersistentValues13RestoreValuesER8JSONRead, __ZN14SphereCollider22FetchPoseFromTransformEv: __ZN14SphereCollider22FetchPoseFromTransformEv, __ZN5Umbra10VisibilityaSERKS0_: __ZN5Umbra10VisibilityaSERKS0_, __Z24RegisterStrippedTypeInfoI11Rigidbody2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI11Rigidbody2DEviPKcS2_, __Z45Register_UnityEngine_Rigidbody2D_set_rotationv: __Z45Register_UnityEngine_Rigidbody2D_set_rotationv, __ZNK5physx2Gu11HeightField17getHeightInternalEff: __ZNK5physx2Gu11HeightField17getHeightInternalEff, __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_: __ZN5physx2Gu32closestPtPointSegmentTesselationERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_, __ZNK5physx7NpScene22getClientBehaviorFlagsEh: __ZNK5physx7NpScene22getClientBehaviorFlagsEh, __ZN5physx3Ext20ProfileZoneInterfaceC2ERNS_13PxProfileZoneEPNS0_23DefaultBufferedProfilerE: __ZN5physx3Ext20ProfileZoneInterfaceC2ERNS_13PxProfileZoneEPNS0_23DefaultBufferedProfilerE, __ZN5physx9NpFactory14createMaterialEfff: __ZN5physx9NpFactory14createMaterialEfff, __ZNK5physx3Cct13BoxController8getStatsERNS_17PxControllerStatsE: __ZNK5physx3Cct13BoxController8getStatsERNS_17PxControllerStatsE, __Z38Register_UnityEngine_Animator_HasStatev: __Z38Register_UnityEngine_Animator_HasStatev, __ZN5physx5cloth11PhaseConfigC2Et: __ZN5physx5cloth11PhaseConfigC2Et, __Z36getPxPrismaticJoint_ConcreteTypeNamePKN5physx16PxPrismaticJointE: __Z36getPxPrismaticJoint_ConcreteTypeNamePKN5physx16PxPrismaticJointE, __ZN13PhysicsModule21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE: __ZN13PhysicsModule21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE, __ZN5physx3Cct13BoxControllerD2Ev: __ZN5physx3Cct13BoxControllerD2Ev, __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags, __Z41Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE: __Z41Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE, __ZN22ParticleSystemRenderer23UpdateVertexInputLayoutEv: __ZN22ParticleSystemRenderer23UpdateVertexInputLayoutEv, __ZNK5physx13NpClothFabric9getNbSetsEv: __ZNK5physx13NpClothFabric9getNbSetsEv, __ZThn8_N5physx2Sc19ShapeInstancePairLLD0Ev: __ZThn8_N5physx2Sc19ShapeInstancePairLLD0Ev, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, __ZN5physx19PxcContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx19PxcContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN18ProceduralMaterial19PostInitializeClassEv: __ZN18ProceduralMaterial19PostInitializeClassEv, __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z32ScriptingArrayToPPtrDynamicArrayI18AudioMixerSnapshotEvP11Il2CppArrayR13dynamic_arrayI4PPtrIT_EXsr11AlignOfTypeIS6_EE5alignEE: __Z32ScriptingArrayToPPtrDynamicArrayI18AudioMixerSnapshotEvP11Il2CppArrayR13dynamic_arrayI4PPtrIT_EXsr11AlignOfTypeIS6_EE5alignEE, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE9set_rdbufEPNS_15basic_streambufIwS2_EE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE9set_rdbufEPNS_15basic_streambufIwS2_EE, __ZN22ParticleSystemRenderer12GetLocalAABBER4AABB: __ZN22ParticleSystemRenderer12GetLocalAABBER4AABB, __Z42Register_UnityEngine_Animator_StringToHashv: __Z42Register_UnityEngine_Animator_StringToHashv, __Z59Register_UnityEngine_Rigidbody2D_get_collisionDetectionModev: __Z59Register_UnityEngine_Rigidbody2D_get_collisionDetectionModev, __ZNK5physx2Sc15ArticulationSim11checkResizeEv: __ZNK5physx2Sc15ArticulationSim11checkResizeEv, __Z37MeshCollider_Get_Custom_PropSkinWidthP12Il2CppObject: __Z37MeshCollider_Get_Custom_PropSkinWidthP12Il2CppObject, __Z57Register_UnityEngine_RenderSettings_INTERNAL_get_fogColorv: __Z57Register_UnityEngine_RenderSettings_INTERNAL_get_fogColorv, __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_worldVelocityv: __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_get_worldVelocityv, __ZN14GraphicsHelper16SetRenderTargetsER9GfxDeviceiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_i11CubemapFaceij: __ZN14GraphicsHelper16SetRenderTargetsER9GfxDeviceiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_i11CubemapFaceij, __ZN8keywords6CreateEPKc: __ZN8keywords6CreateEPKc, __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE, __ZN5physx16PxVehicleNoDrive14setDriveTorqueEjf: __ZN5physx16PxVehicleNoDrive14setDriveTorqueEjf, __Z20dtDistancePtSegSqr2DPKfS0_S0_Rf: __Z20dtDistancePtSegSqr2DPKfS0_S0_Rf, __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetUseRandomDistributionv: __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetUseRandomDistributionv, __ZN17AnimationCurveTplIfE8TransferI9JSONWriteEEvRT_: __ZN17AnimationCurveTplIfE8TransferI9JSONWriteEEvRT_, ___dns_doqueries: ___dns_doqueries, __ZN5Unity5Joint22JointTransferPreNoAxisI14SafeBinaryReadEEvRT_: __ZN5Unity5Joint22JointTransferPreNoAxisI14SafeBinaryReadEEvRT_, __Z60Register_UnityEngine_ParticleSystem_EmissionModule_SetBurstsv: __Z60Register_UnityEngine_ParticleSystem_EmissionModule_SetBurstsv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev, __ZN5physx18RepXSerializerImplINS_10PxMaterialEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_10PxMaterialEE11getTypeNameEv, __ZN14SpriteRenderer15SetupPropertiesEv: __ZN14SpriteRenderer15SetupPropertiesEv, __Z48Register_UnityEngine_Input_get_deviceOrientationv: __Z48Register_UnityEngine_Input_get_deviceOrientationv, _munlockall: _munlockall, _wcstox: _wcstox, __Z45TextGenerator_CUSTOM_INTERNAL_get_rectExtentsP12Il2CppObjectP5RectTIfE: __Z45TextGenerator_CUSTOM_INTERNAL_get_rectExtentsP12Il2CppObjectP5RectTIfE, __ZN14BestStripCacheD2Ev: __ZN14BestStripCacheD2Ev, __Z60Register_UnityEngine_Animator_IsParameterControlledByCurveIDv: __Z60Register_UnityEngine_Animator_IsParameterControlledByCurveIDv, _wcstod: _wcstod, _wcstok: _wcstok, __Z45Register_UnityEngine_Application_get_dataPathv: __Z45Register_UnityEngine_Application_get_dataPathv, _wcstol: _wcstol, __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE7getNameEv, __ZN11AudioSource12SetAudioClipEP9AudioClip: __ZN11AudioSource12SetAudioClipEP9AudioClip, __Z37Register_UnityEngine_Mesh_MarkDynamicv: __Z37Register_UnityEngine_Mesh_MarkDynamicv, __ZN9Texture3D16DeleteGfxTextureEv: __ZN9Texture3D16DeleteGfxTextureEv, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __Z46Register_UnityEngine_HumanTrait_MuscleFromBonev: __Z46Register_UnityEngine_HumanTrait_MuscleFromBonev, __Z57CrashReportHandler_Set_Custom_PropEnableCaptureExceptionsh: __Z57CrashReportHandler_Set_Custom_PropEnableCaptureExceptionsh, __Z39CanvasGroup_Get_Custom_PropInteractableP12Il2CppObject: __Z39CanvasGroup_Get_Custom_PropInteractableP12Il2CppObject, __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZL38InitializeUnityConnectScriptingClassesv: __ZL38InitializeUnityConnectScriptingClassesv, __ZN12HeaderHelper13SetAllHeadersEPKc: __ZN12HeaderHelper13SetAllHeadersEPKc, __Z57Register_UnityEngine_AudioListener_set_velocityUpdateModev: __Z57Register_UnityEngine_AudioListener_set_velocityUpdateModev, __ZN13dynamic_arrayI4PPtrI13AnimationClipELj4EEC2ERKS3_: __ZN13dynamic_arrayI4PPtrI13AnimationClipELj4EEC2ERKS3_, __ZN13ProbeRenderer8ConvolveEbijjb: __ZN13ProbeRenderer8ConvolveEbijjb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj443ENS_22PxRepXPropertyAccessorILj443ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj443ENS_22PxRepXPropertyAccessorILj443ES4_ffEEEEvRKT0_, __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj: __ZN17GenericDynamicVBOC2ER9GfxDevice13GfxBufferModejj, __Z28GetPhysics2DScriptingClassesv: __Z28GetPhysics2DScriptingClassesv, __ZN14DetailDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14DetailDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN24MeshIntermediateRendererD2Ev: __ZN24MeshIntermediateRendererD2Ev, __ZNK5physx2Sc5Scene7isValidEv: __ZNK5physx2Sc5Scene7isValidEv, __ZN8Collider15IgnoreCollisionEPS_b: __ZN8Collider15IgnoreCollisionEPS_b, __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_SetRangev: __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_SetRangev, __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeItemsEj: __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeItemsEj, __ZN5physx2Sq17SceneQueryManager29setDynamicTreeRebuildRateHintEj: __ZN5physx2Sq17SceneQueryManager29setDynamicTreeRebuildRateHintEj, __Z42AudioReverbFilter_Get_Custom_PropDiffusionP12Il2CppObject: __Z42AudioReverbFilter_Get_Custom_PropDiffusionP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj7ENS_22PxRepXPropertyAccessorILj7ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj7ENS_22PxRepXPropertyAccessorILj7ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_, __ZN16LevelGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16LevelGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9UdpSocket24WaitForAvailableRecvDataEl: __ZN9UdpSocket24WaitForAvailableRecvDataEl, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKS2_, _jpeg_mem_src: _jpeg_mem_src, __Z53Register_UnityEngine_Application_GetStackTraceLogTypev: __Z53Register_UnityEngine_Application_GetStackTraceLogTypev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, _unity_z_deflateEnd: _unity_z_deflateEnd, __ZN5audio5mixer14EffectConstant8TransferI14SafeBinaryReadEEvRT_: __ZN5audio5mixer14EffectConstant8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx3Cct10Controller12getKineShapeEv: __ZNK5physx3Cct10Controller12getKineShapeEv, _UNITY_png_set_text_compression_window_bits: _UNITY_png_set_text_compression_window_bits, __ZN15DirectorManager10CreateNodeEv: __ZN15DirectorManager10CreateNodeEv, __ZN20ExternalForcesModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20ExternalForcesModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEvPT_jRKT0_RKT1_j, ___dns_get_rr: ___dns_get_rr, __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZN20TextRenderingPrivate12GetFontPathsERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __ZNSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z44AudioReverbFilter_Get_Custom_PropReverbDelayP12Il2CppObject: __Z44AudioReverbFilter_Get_Custom_PropReverbDelayP12Il2CppObject, __Z42Terrain_Get_Custom_PropTreeCrossFadeLengthP12Il2CppObject: __Z42Terrain_Get_Custom_PropTreeCrossFadeLengthP12Il2CppObject, __ZN12BaseRenderer23RendererBecameInvisibleEv: __ZN12BaseRenderer23RendererBecameInvisibleEv, __ZNK5physx2Sc8BodyCore14getMaxAngVelSqEv: __ZNK5physx2Sc8BodyCore14getMaxAngVelSqEv, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN21BillboardBatchManager18MakeTempPropertiesER19ShaderPropertySheetRK6CameraRK19SharedBillboardData: __ZN21BillboardBatchManager18MakeTempPropertiesER19ShaderPropertySheetRK6CameraRK19SharedBillboardData, __ZN15DistanceJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15DistanceJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5Umbra15OcclusionBuffer7combineERKS0_: __ZN5Umbra15OcclusionBuffer7combineERKS0_, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN10__cxxabiv112_GLOBAL__N_120parse_function_paramINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_120parse_function_paramINS0_2DbEEEPKcS4_S4_RT_, __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_: __ZN8Gradient8TransferI14SafeBinaryReadEEvRT_, __Z59QualitySettings_Set_Custom_PropBillboardsFaceCameraPositionh: __Z59QualitySettings_Set_Custom_PropBillboardsFaceCameraPositionh, _vfscanf: _vfscanf, __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawMeshv: __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawMeshv, __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_SetPositionv: __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_SetPositionv, __ZN5physx6shdfnd7PAUtils9isEnabledEv: __ZN5physx6shdfnd7PAUtils9isEnabledEv, __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_, __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEED2Ev: __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEED2Ev, __ZN16MeshVertexFormat23CreateVertexDeclarationEjPKS_: __ZN16MeshVertexFormat23CreateVertexDeclarationEjPKS_, __Z37setPxParticleReadDataNbValidParticlesPN5physx18PxParticleReadDataEj: __Z37setPxParticleReadDataNbValidParticlesPN5physx18PxParticleReadDataEj, __Z38Rigidbody_Get_Custom_PropSleepVelocityP12Il2CppObject: __Z38Rigidbody_Get_Custom_PropSleepVelocityP12Il2CppObject, __Z24scripting_thread_currentv: __Z24scripting_thread_currentv, __ZN17AmbientProbeBaker16BakeAmbientProbeEP8MaterialR20SphericalHarmonicsL2: __ZN17AmbientProbeBaker16BakeAmbientProbeEP8MaterialR20SphericalHarmonicsL2, __ZN9GfxDevice9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb: __ZN9GfxDevice9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb, _XXH64_reset: _XXH64_reset, __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEjT0_S7_S7_S7_T_, __Z54TerrainData_CUSTOM_INTERNAL_CALL_GetInterpolatedNormalP12Il2CppObjectffR8Vector3f: __Z54TerrainData_CUSTOM_INTERNAL_CALL_GetInterpolatedNormalP12Il2CppObjectffR8Vector3f, __ZN19ShaderPropertySheet15UpdateTextureSTEiRKN9ShaderLab16FastPropertyNameEffff: __ZN19ShaderPropertySheet15UpdateTextureSTEiRKN9ShaderLab16FastPropertyNameEffff, __Z28RenderTextureDiscardContentsP13RenderTexturebb: __Z28RenderTextureDiscardContentsP13RenderTexturebb, __ZN8Animator19SetLookAtEyesWeightEf: __ZN8Animator19SetLookAtEyesWeightEf, __Z13RegisterClassI10Effector2DEvv: __Z13RegisterClassI10Effector2DEvv, __GLOBAL__sub_I_runtime_ai_internal_obstacles_lump_cpp: __GLOBAL__sub_I_runtime_ai_internal_obstacles_lump_cpp, __ZN18IDCollectorFunctorD0Ev: __ZN18IDCollectorFunctorD0Ev, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj, __ZN23ManagedAttributeManager21GetRequiredComponentsEP11Il2CppClass: __ZN23ManagedAttributeManager21GetRequiredComponentsEP11Il2CppClass, __ZThn12_N5physx3Ext13RevoluteJoint11prepareDataEv: __ZThn12_N5physx3Ext13RevoluteJoint11prepareDataEv, __Z15IntersectTriTriRK8Vector3fS1_S1_S1_S1_S1_PS_S2_Pb: __Z15IntersectTriTriRK8Vector3fS1_S1_S1_S1_S1_PS_S2_Pb, _UNITY_FT_Outline_Get_Bitmap: _UNITY_FT_Outline_Get_Bitmap, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4swapERS3_: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4swapERS3_, __ZN7VRInput35InsertReferenceTransformIfNecessaryE4PPtrI9TransformE: __ZN7VRInput35InsertReferenceTransformIfNecessaryE4PPtrI9TransformE, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __ZN15b2MotorJointDef10InitializeEP6b2BodyS1_: __ZN15b2MotorJointDef10InitializeEP6b2BodyS1_, __Z11FitTangentsI8Vector3fEvR11KeyframeTplIT_ES4_ffRKS2_S6_: __Z11FitTangentsI8Vector3fEvR11KeyframeTplIT_ES4_ffRKS2_S6_, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration31generatePolyDataContactManifoldERNS0_9TriangleVEjjhPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNS8_5Vec3VE: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration31generatePolyDataContactManifoldERNS0_9TriangleVEjjhPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNS8_5Vec3VE, __Z26setPxHeightFieldDescNbRowsPN5physx17PxHeightFieldDescEj: __Z26setPxHeightFieldDescNbRowsPN5physx17PxHeightFieldDescEj, __ZN24EllipsoidParticleEmitterD2Ev: __ZN24EllipsoidParticleEmitterD2Ev, __ZN5physx10SubSortSAH5splitEPjj: __ZN5physx10SubSortSAH5splitEPjj, __Z41setPxVehicleSuspensionDataMSpringStrengthPN5physx23PxVehicleSuspensionDataEf: __Z41setPxVehicleSuspensionDataMSpringStrengthPN5physx23PxVehicleSuspensionDataEf, __ZN25RuntimeAnimatorController8TransferI14SafeBinaryReadEEvRT_: __ZN25RuntimeAnimatorController8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE14__count_uniqueIS7_EEjRKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE14__count_uniqueIS7_EEjRKT_, __ZN5physx2Sn18RepXCollectionImpl16createNodeEditorEv: __ZN5physx2Sn18RepXCollectionImpl16createNodeEditorEv, __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4gles20GetShaderTargetLevelE16GfxDeviceLevelGL: __ZN4gles20GetShaderTargetLevelE16GfxDeviceLevelGL, __Z40Rigidbody2D_Set_Custom_PropInterpolationP12Il2CppObjectN11Rigidbody2D13InterpolationE: __Z40Rigidbody2D_Set_Custom_PropInterpolationP12Il2CppObjectN11Rigidbody2D13InterpolationE, __ZN9Animation4PlayER14AnimationStatei: __ZN9Animation4PlayER14AnimationStatei, __Z52Register_UnityEngine_Terrain_set_heightmapMaximumLODv: __Z52Register_UnityEngine_Terrain_set_heightmapMaximumLODv, __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __Z49Register_UnityEngine_AndroidJNI_GetStringUTFCharsv: __Z49Register_UnityEngine_AndroidJNI_GetStringUTFCharsv, __Z21ClearFenceWithoutSyncR8JobFence: __Z21ClearFenceWithoutSyncR8JobFence, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj554ENS_22PxRepXPropertyAccessorILj554ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj554ENS_22PxRepXPropertyAccessorILj554ES4_ffEEEEvRKT0_, __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_: __ZN5physx2Gu3EPA8addFacetEjjjRKNS_6shdfnd3aos6FloatVES6_, __ZN14RotationModule8TransferI17RemapPPtrTransferEEvRT_: __ZN14RotationModule8TransferI17RemapPPtrTransferEEvRT_, __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId: __ZN13MemoryManager18GetAllocatedMemoryERK10MemLabelId, __ZNK14BillboardAsset14GetNumVerticesEv: __ZNK14BillboardAsset14GetNumVerticesEv, __Z21FormatScriptTypeError14MonoScriptTypeRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __Z21FormatScriptTypeError14MonoScriptTypeRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN25MultiBlocksMemoryFileData4LockEPPv: __ZN25MultiBlocksMemoryFileData4LockEPPv, __Z50Register_UnityEngine_TrailRenderer_set_textureModev: __Z50Register_UnityEngine_TrailRenderer_set_textureModev, __ZN4crnd13prefix_coding14decoder_tablesaSERKS1_: __ZN4crnd13prefix_coding14decoder_tablesaSERKS1_, __ZN11AudioSource4PlayEd: __ZN11AudioSource4PlayEd, __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE: __Z26scripting_class_get_fieldsP11Il2CppClassRNSt3__26vectorIP9FieldInfo13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE, __Z32getPxArticulation_SleepThresholdPKN5physx14PxArticulationE: __Z32getPxArticulation_SleepThresholdPKN5physx14PxArticulationE, __ZZN8Animator15InitializeClassEvEN31FunctorImpl_388kDidModifyMotion4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN31FunctorImpl_388kDidModifyMotion4CallEPviR11MessageData, __ZN15DistanceJoint2D11SetDistanceEf: __ZN15DistanceJoint2D11SetDistanceEf, __ZThn8_NSt3__29strstreamD1Ev: __ZThn8_NSt3__29strstreamD1Ev, __ZN5physx3Cct9CCTParamsC2Ev: __ZN5physx3Cct9CCTParamsC2Ev, __ZNKSt3__210moneypunctIcLb0EE13thousands_sepEv: __ZNKSt3__210moneypunctIcLb0EE13thousands_sepEv, __Z27getPxScene_FilterShaderDataPKN5physx7PxSceneE: __Z27getPxScene_FilterShaderDataPKN5physx7PxSceneE, __Z55Register_UnityEngine_CharacterJoint_get_projectionAnglev: __Z55Register_UnityEngine_CharacterJoint_get_projectionAnglev, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv, __ZNK5physx2Sc23ElementActorInteraction23isLastFilterInteractionEv: __ZNK5physx2Sc23ElementActorInteraction23isLastFilterInteractionEv, __ZNK20LocalFileSystemPosix8IsHiddenERK13FileEntryData: __ZNK20LocalFileSystemPosix8IsHiddenERK13FileEntryData, __Z37Transform_CUSTOM_INTERNAL_CALL_LookAtP12Il2CppObjectRK8Vector3fS3_: __Z37Transform_CUSTOM_INTERNAL_CALL_LookAtP12Il2CppObjectRK8Vector3fS3_, __ZN5physx26PxcInvalidSweptContactPairERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx26PxcInvalidSweptContactPairERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, _wms_seek: _wms_seek, __ZThn8_N5physx2Gu11HeightField14onRefCountZeroEv: __ZThn8_N5physx2Gu11HeightField14onRefCountZeroEv, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE, __ZN5physx2Sc5Actor9setActiveEbj: __ZN5physx2Sc5Actor9setActiveEbj, __ZN13WheelCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13WheelCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj: __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE8__appendEj, __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj: __ZN12_GLOBAL__N_127SphereMeshContactGeneration15processTriangleEjRKN5physx6PxVec3ES4_S4_PKj, __Z36RegisterModuleClasses_CrashReportingv: __Z36RegisterModuleClasses_CrashReportingv, __Z51Register_UnityEngine_AndroidJNI_AttachCurrentThreadv: __Z51Register_UnityEngine_AndroidJNI_AttachCurrentThreadv, __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN23PreloadManagerOperation11GetProgressEv: __ZN23PreloadManagerOperation11GetProgressEv, __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEjT0_S7_S7_S7_T_, _Read_CVT: _Read_CVT, __ZN5physx2Sc10NPhaseCore28reserveContactReportPairDataEjjRj: __ZN5physx2Sc10NPhaseCore28reserveContactReportPairDataEjjRj, __Z78Register_UnityEngine_SceneManagement_SceneManager_UnloadSceneNameIndexInternalv: __Z78Register_UnityEngine_SceneManagement_SceneManager_UnloadSceneNameIndexInternalv, __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVE: __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVE, __ZN12FileAccessor4SeekEx10FileOrigin: __ZN12FileAccessor4SeekEx10FileOrigin, __ZN12ImageDecoderD2Ev: __ZN12ImageDecoderD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14dtPathCorridor28optimizePathVisibilitySimpleEPKfPK14dtNavMeshQueryPK13dtQueryFilter: __ZN14dtPathCorridor28optimizePathVisibilitySimpleEPKfPK14dtNavMeshQueryPK13dtQueryFilter, _tre_tag_order: _tre_tag_order, __ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb: __ZL18TestUnifiedNormalsjPKN5physx6PxVec3EjPNS_2Gu9TriangleTIjEEb, __Z46ParticleAnimator_Set_Custom_PropColorAnimationP12Il2CppObjectP11Il2CppArray: __Z46ParticleAnimator_Set_Custom_PropColorAnimationP12Il2CppObjectP11Il2CppArray, __ZN16LightmapSettings20DidChangeActiveSceneEP10UnitySceneS1_: __ZN16LightmapSettings20DidChangeActiveSceneEP10UnitySceneS1_, __Z33GUITexture_Get_Custom_PropTextureP12Il2CppObject: __Z33GUITexture_Get_Custom_PropTextureP12Il2CppObject, __Z37Physics_Get_Custom_PropSleepThresholdv: __Z37Physics_Get_Custom_PropSleepThresholdv, __ZN14SplatMaterials16DestroyMaterialsEv: __ZN14SplatMaterials16DestroyMaterialsEv, __Z39Register_UnityEngine_Time_get_timeScalev: __Z39Register_UnityEngine_Time_get_timeScalev, __ZN15AudioReverbZone13AwakeFromLoadE17AwakeFromLoadMode: __ZN15AudioReverbZone13AwakeFromLoadE17AwakeFromLoadMode, __ZN10AudioMixer11SetupGroupsEv: __ZN10AudioMixer11SetupGroupsEv, __ZNK13WebCamTexture25GetDeviceIdFromDeviceListERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK13WebCamTexture25GetDeviceIdFromDeviceListERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN18BaseUnityAnalyticsD0Ev: __ZN18BaseUnityAnalyticsD0Ev, __Z38AndroidJNI_CUSTOM_CallStaticLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z38AndroidJNI_CUSTOM_CallStaticLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __Z48LightProbeProxyVolume_Get_Custom_PropRefreshModeP12Il2CppObject: __Z48LightProbeProxyVolume_Get_Custom_PropRefreshModeP12Il2CppObject, __Z35Register_UnityEngine_Event_get_typev: __Z35Register_UnityEngine_Event_get_typev, __ZN20SoundChannelInstance13GetPositionMSEPj: __ZN20SoundChannelInstance13GetPositionMSEPj, __Z61AnimationClip_CUSTOM_INTERNAL_CALL_EnsureQuaternionContinuityP12Il2CppObject: __Z61AnimationClip_CUSTOM_INTERNAL_CALL_EnsureQuaternionContinuityP12Il2CppObject, __Z38AudioSource_CUSTOM_SetSpatializerFloatP12Il2CppObjectif: __Z38AudioSource_CUSTOM_SetSpatializerFloatP12Il2CppObjectif, __ZN5Umbra15BufferAllocator8allocateEib: __ZN5Umbra15BufferAllocator8allocateEib, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv, __ZN5Unity11AdjacenciesC2EPKtPKji: __ZN5Unity11AdjacenciesC2EPKtPKji, _UNITY_png_free: _UNITY_png_free, __ZN4NodeD2Ev: __ZN4NodeD2Ev, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5gbumpEi: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5gbumpEi, __ZNK5physx13GuMeshFactory17getNbConvexMeshesEv: __ZNK5physx13GuMeshFactory17getNbConvexMeshesEv, __ZN14ParticleSystem15InitializeClassEv: __ZN14ParticleSystem15InitializeClassEv, __ZN13GfxDeviceNullC2Ev: __ZN13GfxDeviceNullC2Ev, __Z33Scene_CUSTOM_GetRootCountInternali: __Z33Scene_CUSTOM_GetRootCountInternali, __Z25SetNameAndResetGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z25SetNameAndResetGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z26getPxScene_StaticStructurePKN5physx7PxSceneE: __Z26getPxScene_StaticStructurePKN5physx7PxSceneE, __ZNK12NavMeshAgent18GetDesiredVelocityEv: __ZNK12NavMeshAgent18GetDesiredVelocityEv, __ZN14LineParametersD2Ev: __ZN14LineParametersD2Ev, __Z21SetMaterialFloatArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z21SetMaterialFloatArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __Z37Register_UnityEngine_Input_GetAxisRawv: __Z37Register_UnityEngine_Input_GetAxisRawv, __Z44SceneUtility_CUSTOM_GetBuildIndexByScenePathP12Il2CppString: __Z44SceneUtility_CUSTOM_GetBuildIndexByScenePathP12Il2CppString, __ZN14NavMeshManager16RegisterObstacleER15NavMeshObstacleRi: __ZN14NavMeshManager16RegisterObstacleER15NavMeshObstacleRi, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __Z40getPxArticulation_StabilizationThresholdPKN5physx14PxArticulationE: __Z40getPxArticulation_StabilizationThresholdPKN5physx14PxArticulationE, _setdomainname: _setdomainname, __ZN11AudioSource5ResetEv: __ZN11AudioSource5ResetEv, __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE: __ZNSt3__26vectorINS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS7_EE, __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_centerv: __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_centerv, __ZN14NavMeshManager8LoadDataEPK11NavMeshData: __ZN14NavMeshManager8LoadDataEPK11NavMeshData, __ZN13dynamic_arrayIN12TreeRenderer15RendererLODInfoELj4EEC2ERKS2_: __ZN13dynamic_arrayIN12TreeRenderer15RendererLODInfoELj4EEC2ERKS2_, __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13AnimationClip12Vector3Curve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14DetailDatabase8SetLayerEiiiiiPKi: __ZN14DetailDatabase8SetLayerEiiiiiPKi, __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN13TrailRenderer5ResetEv: __ZN13TrailRenderer5ResetEv, __Z40Register_UnityEngine_Event_GetEventCountv: __Z40Register_UnityEngine_Event_GetEventCountv, __ZN2UI13RectTransform13AwakeFromLoadE17AwakeFromLoadMode: __ZN2UI13RectTransform13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_jj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_jj, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __ZL27GetDestRenderTargetSurfacesP13RenderTextureR12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_: __ZL27GetDestRenderTargetSurfacesP13RenderTextureR12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_, __Z30Light_Set_Custom_PropIntensityP12Il2CppObjectf: __Z30Light_Set_Custom_PropIntensityP12Il2CppObjectf, __ZN5physx23PxsSolverSetupSolveTaskD2Ev: __ZN5physx23PxsSolverSetupSolveTaskD2Ev, __ZN5physx23PxVehicleWheels4SimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E: __ZN5physx23PxVehicleWheels4SimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E, __Z18Transfer_BlittableI14SafeBinaryReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN14PreloadManagerC2Ev: __ZN14PreloadManagerC2Ev, __ZN19CloudServiceHandler17PlayerLoopHandlerEv: __ZN19CloudServiceHandler17PlayerLoopHandlerEv, __ZN5physx27NbBroadPhaseRemovesPropertyC2Ev: __ZN5physx27NbBroadPhaseRemovesPropertyC2Ev, __ZN9Transform30SendTransformParentingMessagesEi: __ZN9Transform30SendTransformParentingMessagesEi, _UNITY_LZ4_resetStreamState: _UNITY_LZ4_resetStreamState, __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE21__push_back_slow_pathIKS8_EEvRT_: __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE21__push_back_slow_pathIKS8_EEvRT_, __Z52Register_UnityEngine_LineRenderer_set_numCapVerticesv: __Z52Register_UnityEngine_LineRenderer_set_numCapVerticesv, __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __ZN5physx25PxVehicleConstraintShader20getExternalReferenceERj: __ZN5physx25PxVehicleConstraintShader20getExternalReferenceERj, __Z24RegisterStrippedTypeInfoI12InputManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI12InputManagerEviPKcS2_, __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj: __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj, __ZN14SphereColliderD0Ev: __ZN14SphereColliderD0Ev, __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVES2_NS0_10ShrunkBoxVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVES2_NS0_10ShrunkBoxVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb, __ZN14ParticleSystem4CullEv: __ZN14ParticleSystem4CullEv, __Z14WorldCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjibibRKf: __Z14WorldCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjibibRKf, __Z51ParticleSystem_MainModule_CUSTOM_GetStartRotation3DP12Il2CppObject: __Z51ParticleSystem_MainModule_CUSTOM_GetStartRotation3DP12Il2CppObject, __Z67Register_UnityEngine_Networking_UnityWebRequest_get_useHttpContinuev: __Z67Register_UnityEngine_Networking_UnityWebRequest_get_useHttpContinuev, _UNITY_FT_Create_Class_ft_smooth_lcd_renderer_class: _UNITY_FT_Create_Class_ft_smooth_lcd_renderer_class, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SG_EEiEESJ_RKT_: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS6_PNS_11__tree_nodeIS6_SG_EEiEESJ_RKT_, __ZThn8_N5physx2Gu10ConvexMeshD0Ev: __ZThn8_N5physx2Gu10ConvexMeshD0Ev, __ZNSt3__27collateIwED0Ev: __ZNSt3__27collateIwED0Ev, __ZNK21EnlightenSceneMapping17GetRenderersBeginEi: __ZNK21EnlightenSceneMapping17GetRenderersBeginEi, __Z21setPxCloth_TargetPosePN5physx7PxClothERKNS_11PxTransformE: __Z21setPxCloth_TargetPosePN5physx7PxClothERKNS_11PxTransformE, __ZN15RelativeJoint2D5ResetEv: __ZN15RelativeJoint2D5ResetEv, __Z20scripting_gc_collecti: __Z20scripting_gc_collecti, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj50ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj50ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18ColorBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18ColorBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4FMOD7Channel15getSystemObjectEPPNS_6SystemE: __ZN4FMOD7Channel15getSystemObjectEPPNS_6SystemE, __ZN8Animator9WriteStepEv: __ZN8Animator9WriteStepEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4swapERS3_: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4swapERS3_, __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFramev: __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFramev, __ZN13ScreenManager16SetScreenTimeoutEi: __ZN13ScreenManager16SetScreenTimeoutEi, __Z29Animator_CUSTOM_StopRecordingP12Il2CppObject: __Z29Animator_CUSTOM_StopRecordingP12Il2CppObject, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK24PhysicsUpdateBehaviour2D26GetTypeInfoVirtualInternalEv: __ZNK24PhysicsUpdateBehaviour2D26GetTypeInfoVirtualInternalEv, __Z60Register_UnityEngine_Graphics_Internal_DrawMeshInstancedListv: __Z60Register_UnityEngine_Graphics_Internal_DrawMeshInstancedListv, __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z38Register_UnityEngine_Font_HasCharacterv: __Z38Register_UnityEngine_Font_HasCharacterv, __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i: __Z35IntersectSpherePlaneBoundsOptimizedRKN4math7_float4EPS1_i, __ZNK17ProceduralTexture14GetMipmapCountEv: __ZNK17ProceduralTexture14GetMipmapCountEv, __ZN13ScreenManager18SetAllowCursorHideEb: __ZN13ScreenManager18SetAllowCursorHideEb, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcx, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcy, __ZN5physx2Sc8ShapeSim20createLowLevelVolumeEjRKNS_9PxBounds3EjNS_9AABBMgrIdE: __ZN5physx2Sc8ShapeSim20createLowLevelVolumeEjRKNS_9PxBounds3EjNS_9AABBMgrIdE, __ZN19SharedBillboardDataD0Ev: __ZN19SharedBillboardDataD0Ev, __ZThn4_NK5physx5cloth8SwSolver8hasErrorEv: __ZThn4_NK5physx5cloth8SwSolver8hasErrorEv, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcl, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcm, __ZN11AudioSource14SetSecPositionEf: __ZN11AudioSource14SetSecPositionEf, __ZNK5physx7NpCloth22getAngularInertiaScaleEv: __ZNK5physx7NpCloth22getAngularInertiaScaleEv, __ZN7mecanim6memory16ChainedAllocator10DeallocateEPv: __ZN7mecanim6memory16ChainedAllocator10DeallocateEPv, __ZThn32_N12MeshRendererD0Ev: __ZThn32_N12MeshRendererD0Ev, __ZN26IntersectAnyVsMeshCallbackILi1ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi1ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __ZNK12ShaderErrors9LogErrorsEPKcS1_P6Objecti: __ZNK12ShaderErrors9LogErrorsEPKcS1_P6Objecti, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcb, __ZN9ShaderLab20SerializedProperties18AddTexturePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERKNS_25SerializedTexturePropertyE: __ZN9ShaderLab20SerializedProperties18AddTexturePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERKNS_25SerializedTexturePropertyE, __Z22CleanupLODGroupManagerPv: __Z22CleanupLODGroupManagerPv, __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNSt3__218__insertion_sort_3IRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_, __Z49AudioLowPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf: __Z49AudioLowPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf, __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv: __ZNK16LightmapSettings31GetRealtimeLightmapDecodeValuesEv, __ZN5audio5mixer12SetSuspendedERNS0_16AudioMixerMemoryEb: __ZN5audio5mixer12SetSuspendedERNS0_16AudioMixerMemoryEb, __ZN17PersistentManager21UnloadNonDirtyStreamsEv: __ZN17PersistentManager21UnloadNonDirtyStreamsEv, __ZNK5physx2Cm10Collection6getIdsEPyjj: __ZNK5physx2Cm10Collection6getIdsEPyjj, __ZN5physx2Sn5ConvX17checkPaddingBytesEPKci: __ZN5physx2Sn5ConvX17checkPaddingBytesEPKci, __ZN19AssetBundleManifest18GetAssetBundleHashERK8UnityStr: __ZN19AssetBundleManifest18GetAssetBundleHashERK8UnityStr, __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZThn264_N24MeshIntermediateRenderer14OnAssetDeletedEv: __ZThn264_N24MeshIntermediateRenderer14OnAssetDeletedEv, __Z52Register_UnityEngine_GameObject_AddComponentInternalv: __Z52Register_UnityEngine_GameObject_AddComponentInternalv, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z34Register_UnityEngine_GUI_set_depthv: __Z34Register_UnityEngine_GUI_set_depthv, __ZN5physx2Sc5Scene13ccdBroadPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene13ccdBroadPhaseEPNS_10PxBaseTaskE, __Z12KillParticleRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRj: __Z12KillParticleRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRj, __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass: __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass, __ZN18LoadSceneOperationD0Ev: __ZN18LoadSceneOperationD0Ev, __Z33Debug_Get_Custom_PropIsDebugBuildv: __Z33Debug_Get_Custom_PropIsDebugBuildv, __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb: __ZN5physx2Gu24PCMMeshContactGeneration15processContactsEhb, __ZN9LensFlare12CleanupClassEv: __ZN9LensFlare12CleanupClassEv, __ZN4crnd25static_huffman_data_model22prepare_decoder_tablesEv: __ZN4crnd25static_huffman_data_model22prepare_decoder_tablesEv, __ZN9Texture2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Texture2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9doAddNameEPKctb, __Z38NavMeshObstacle_Get_Custom_PropCarvingP12Il2CppObject: __Z38NavMeshObstacle_Get_Custom_PropCarvingP12Il2CppObject, __ZN4FMOD6Reverb11setUserDataEPv: __ZN4FMOD6Reverb11setUserDataEPv, __Z23GUIStatePopDisplayIndexv: __Z23GUIStatePopDisplayIndexv, __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __ZL22CleanupUnityWebStreamsPv: __ZL22CleanupUnityWebStreamsPv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z28Animation_CUSTOM_RemoveClip2P12Il2CppObjectP12Il2CppString: __Z28Animation_CUSTOM_RemoveClip2P12Il2CppObjectP12Il2CppString, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Znaj: __Znaj, __ZN6Object15StringToClassIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN6Object15StringToClassIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, _UnityReplayKitDiscard: _UnityReplayKitDiscard, __ZN5physx6shdfnd13createFastXmlEPNS0_7FastXml8CallbackE: __ZN5physx6shdfnd13createFastXmlEPNS0_7FastXml8CallbackE, __ZN5simdi8allEqualERK8Scalar4fS2_: __ZN5simdi8allEqualERK8Scalar4fS2_, __Z18computeSweptBoundsPKN5physx12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_: __Z18computeSweptBoundsPKN5physx12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_, __Z40ReflectionProbe_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f: __Z40ReflectionProbe_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f, __ZN11GameManager15ThreadedCleanupEv: __ZN11GameManager15ThreadedCleanupEv, __ZN13BoxCollider2DC2E10MemLabelId18ObjectCreationMode: __ZN13BoxCollider2DC2E10MemLabelId18ObjectCreationMode, __ZN18PlatformEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE: __ZN18PlatformEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE, __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL26solveFriction4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED2Ev: __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED2Ev, __Z24RegisterStrippedTypeInfoI12CubemapArrayEviPKcS2_: __Z24RegisterStrippedTypeInfoI12CubemapArrayEviPKcS2_, __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI14ConstantStringEEvRT_PKc17TransferMetaFlags, __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi: __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEi, __ZN5physx30PxcGetMaterialShapeHeightFieldEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx30PxcGetMaterialShapeHeightFieldEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, __ZNK6Camera16GetStereoEnabledEv: __ZNK6Camera16GetStereoEnabledEv, __Z43Register_UnityEngine_TrailRenderer_get_timev: __Z43Register_UnityEngine_TrailRenderer_get_timev, __Z48ConfigurableJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf: __Z48ConfigurableJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf, __ZN13AnimationClip9PPtrCurveaSERKS0_: __ZN13AnimationClip9PPtrCurveaSERKS0_, __ZN12LightManager15InitializeClassEv: __ZN12LightManager15InitializeClassEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN18ScriptingArgumentsC2Ev: __ZN18ScriptingArgumentsC2Ev, __ZN5physx5cloth16SwInterCollisionI8Scalar4fED2Ev: __ZN5physx5cloth16SwInterCollisionI8Scalar4fED2Ev, __ZN14SerializedFile12FinalizeInitE24TransferInstructionFlags: __ZN14SerializedFile12FinalizeInitE24TransferInstructionFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj592ENS_22PxRepXPropertyAccessorILj592ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj592ENS_22PxRepXPropertyAccessorILj592ES4_ffEEEEvRKT0_, __Z54AndroidJNI_CUSTOM_INTERNAL_CALL_CallStaticObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv: __Z54AndroidJNI_CUSTOM_INTERNAL_CALL_CallStaticObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv, __Z48Register_UnityEngine_Shader_set_globalMaximumLODv: __Z48Register_UnityEngine_Shader_set_globalMaximumLODv, __ZN5Umbra15PortalRayTracer5traceEv: __ZN5Umbra15PortalRayTracer5traceEv, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERy: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERy, __ZZN8VRDevice10InitializeEbEN25EarlyUpdateVRUpdatestruct7ForwardEv: __ZZN8VRDevice10InitializeEbEN25EarlyUpdateVRUpdatestruct7ForwardEv, __Z42CullingGroup_CUSTOM_SetBoundingSphereCountP12Il2CppObjecti: __Z42CullingGroup_CUSTOM_SetBoundingSphereCountP12Il2CppObjecti, __ZNK14TerrainManager17GetActiveTerrainsEv: __ZNK14TerrainManager17GetActiveTerrainsEv, __ZNK5physx2Gu18ConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVE: __ZNK5physx2Gu18ConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVE, _realloc_in_place: _realloc_in_place, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERf: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERf, __Z31TextMesh_Get_Custom_PropOffsetZP12Il2CppObject: __Z31TextMesh_Get_Custom_PropOffsetZP12Il2CppObject, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERh: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERh, __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyRotationInternalP12Il2CppObjectRK11Quaternionf: __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyRotationInternalP12Il2CppObjectRK11Quaternionf, __ZN7mecanim9animation26InitClipMuscleAverageSpeedERNS0_18ClipMuscleConstantEi: __ZN7mecanim9animation26InitClipMuscleAverageSpeedERNS0_18ClipMuscleConstantEi, __Z50Register_UnityEngine_Camera_get_layerCullSphericalv: __Z50Register_UnityEngine_Camera_get_layerCullSphericalv, __ZNK12b2WheelJoint13GetJointSpeedEv: __ZNK12b2WheelJoint13GetJointSpeedEv, _process_data_simple_main: _process_data_simple_main, __Z48AudioSource_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject: __Z48AudioSource_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEESt16initializer_listIwE, __ZNKSt3__27collateIwE9transformEPKwS3_: __ZNKSt3__27collateIwE9transformEPKwS3_, __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_: __ZN8Vector3f8TransferI14SafeBinaryReadEEvRT_, __ZThn4_N12_GLOBAL__N_111StreamOwner10disconnectEv: __ZThn4_N12_GLOBAL__N_111StreamOwner10disconnectEv, __ZN10TagManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10TagManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4FMOD4DSPI6removeEv: __ZN4FMOD4DSPI6removeEv, __ZN20TextRenderingPrivate8TextMesh13AwakeFromLoadE17AwakeFromLoadMode: __ZN20TextRenderingPrivate8TextMesh13AwakeFromLoadE17AwakeFromLoadMode, __Z13RegisterClassI9HaloLayerEvv: __Z13RegisterClassI9HaloLayerEvv, __ZNK5Umbra9Matrix2x211getMaxScaleEv: __ZNK5Umbra9Matrix2x211getMaxScaleEv, __Z35scripting_class_get_field_from_nameP11Il2CppClassPKc: __Z35scripting_class_get_field_from_nameP11Il2CppClassPKc, __Z64Register_UnityEngine_AnimatorOverrideController_Internal_GetClipv: __Z64Register_UnityEngine_AnimatorOverrideController_Internal_GetClipv, __ZN26SizeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN26SizeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z42Register_UnityEngine_TextMesh_set_richTextv: __Z42Register_UnityEngine_TextMesh_set_richTextv, __ZN22RenderingCommandBufferC2ERK10MemLabelId: __ZN22RenderingCommandBufferC2ERK10MemLabelId, __Z58Register_UnityEngine_Connect_UnityAdsSettings_set_testModev: __Z58Register_UnityEngine_Connect_UnityAdsSettings_set_testModev, __ZL17sweepVolumeVsMeshPKN5physx3Cct9SweepTestEPKNS0_11TouchedMeshERNS0_12SweptContactERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleEj: __ZL17sweepVolumeVsMeshPKN5physx3Cct9SweepTestEPKNS0_11TouchedMeshERNS0_12SweptContactERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEjPKNS_10PxTriangleEj, __ZN12ShaderErrors18ClearRuntimeErrorsEv: __ZN12ShaderErrors18ClearRuntimeErrorsEv, __ZNK5physx12NpBatchQuery19getFilterShaderDataEv: __ZNK5physx12NpBatchQuery19getFilterShaderDataEv, __ZN5physx2Gu31checkOverlapOBB_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu31checkOverlapOBB_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __ZN2UI7Batches7DestroyEv: __ZN2UI7Batches7DestroyEv, __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4Mesh13GetVertexDataEPvjji: __ZN4Mesh13GetVertexDataEPvjji, __ZN12_GLOBAL__N_117EventBufferClient7releaseEv: __ZN12_GLOBAL__N_117EventBufferClient7releaseEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERw: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERw, __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E: __ZN5physx2Gu23findRotationMatrixFromZERKNS_6PxVec3E, __ZN11AudioSource23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11AudioSource23VirtualRedirectTransferER17RemapPPtrTransfer, __Z50GIDebugVisualisation_Get_Custom_PropPauseCycleModev: __Z50GIDebugVisualisation_Get_Custom_PropPauseCycleModev, __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE: __ZN2UI13CanvasManager9AddCanvasEPNS_6CanvasE, __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_: __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_, __ZNK6Camera22CalculateRenderingPathEv: __ZNK6Camera22CalculateRenderingPathEv, __ZN22UnityProfilerPerThread10BeginFrameE12ProfilerMode: __ZN22UnityProfilerPerThread10BeginFrameE12ProfilerMode, __ZN9JSONWrite8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags, __ZNSt3__26vectorINS_4pairI7Hash12813ProbeSetIndexEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_: __ZNSt3__26vectorINS_4pairI7Hash12813ProbeSetIndexEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_, __ZNK9WWWCached17GetUploadProgressEv: __ZNK9WWWCached17GetUploadProgressEv, __Z42Register_UnityEngine_Joint_set_breakTorquev: __Z42Register_UnityEngine_Joint_set_breakTorquev, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIKN4math7_float4EE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZL12InvokeMethodI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__210moneypunctIwLb0EE13positive_signEv: __ZNKSt3__210moneypunctIwLb0EE13positive_signEv, __ZN13AnimationClip18AddQuaternionCurveERK17AnimationCurveTplI11QuaternionfERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN13AnimationClip18AddQuaternionCurveERK17AnimationCurveTplI11QuaternionfERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZN7ApiGLES14DebugPopMarkerEv: __ZN7ApiGLES14DebugPopMarkerEv, _tt_sbit_decoder_load_image: _tt_sbit_decoder_load_image, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_, __Z14IsHalfRTFormat19RenderTextureFormat: __Z14IsHalfRTFormat19RenderTextureFormat, __ZNK13OcclusionArea16GetGlobalExtentsEv: __ZNK13OcclusionArea16GetGlobalExtentsEv, __Z23Debug_CUSTOM_DebugBreakv: __Z23Debug_CUSTOM_DebugBreakv, __ZN13WebCamTexture4StopEv: __ZN13WebCamTexture4StopEv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE, __Z47Register_UnityEngine_WheelCollider_GetGroundHitv: __Z47Register_UnityEngine_WheelCollider_GetGroundHitv, __Z66CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralIndirectP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeS0_iS0_: __Z66CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralIndirectP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeS0_iS0_, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZDrivev: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZDrivev, __ZN11TimeManager7SetTimeEd: __ZN11TimeManager7SetTimeEd, __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_: __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE6__sortI13OldSortScriptEENS_15__list_iteratorIS2_PvEESA_SA_jRT_, __Z51getNbPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE: __Z51getNbPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEE15growAndPushBackERKS2_, _iswctype_l: _iswctype_l, __Z35Camera_Get_Custom_PropRenderingPathP12Il2CppObject: __Z35Camera_Get_Custom_PropRenderingPathP12Il2CppObject, __Z39Register_UnityEngine_PlayerPrefs_HasKeyv: __Z39Register_UnityEngine_PlayerPrefs_HasKeyv, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE8recreateEj, __ZN5physx8debugger14PvdMarshallingIfdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIfdE12marshalBlockEPKhPhj, __ZNK9Behaviour26GetTypeInfoVirtualInternalEv: __ZNK9Behaviour26GetTypeInfoVirtualInternalEv, __Z38Shader_CUSTOM_GetGlobalMatrixArrayImpli: __Z38Shader_CUSTOM_GetGlobalMatrixArrayImpli, __ZN12LineRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12LineRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN18DeferredRenderLoop13RenderGBufferEP13RenderTexturePS1_b8JobFencePK25DeferredRenderLoopScratchRi: __ZN18DeferredRenderLoop13RenderGBufferEP13RenderTexturePS1_b8JobFencePK25DeferredRenderLoopScratchRi, __ZN5Umbra12QueryContext17addQueryDebugLineERKNS_7Vector3ES3_RKNS_7Vector4E: __ZN5Umbra12QueryContext17addQueryDebugLineERKNS_7Vector3ES3_RKNS_7Vector4E, __ZNSt3__219__iostream_categoryD0Ev: __ZNSt3__219__iostream_categoryD0Ev, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN13AnimationClip8TransferI17RemapPPtrTransferEEvRT_: __ZN13AnimationClip8TransferI17RemapPPtrTransferEEvRT_, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc13ConstraintSim17updateRelatedSIPsEv: __ZN5physx2Sc13ConstraintSim17updateRelatedSIPsEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclERKNS_27PxRigidActorShapeCollectionEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclERKNS_27PxRigidActorShapeCollectionEj, __ZN9GfxDevice12DeleteBufferEP9GfxBuffer: __ZN9GfxDevice12DeleteBufferEP9GfxBuffer, __Z30Texture3D_Get_Custom_PropDepthP12Il2CppObject: __Z30Texture3D_Get_Custom_PropDepthP12Il2CppObject, __ZN12_GLOBAL__N_116CompleteCallback7processERN5physx6PxBaseE: __ZN12_GLOBAL__N_116CompleteCallback7processERN5physx6PxBaseE, __ZN8Animator13ClearBindingsEv: __ZN8Animator13ClearBindingsEv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP15RODataDepthPassi17ROSorterDepthPassEEvT_S4_T0_T1_, __ZNK5Unity14CharacterJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_: __ZNK5Unity14CharacterJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_, __Z97Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightFromIndexInternalv: __Z97Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightFromIndexInternalv, __ZN12CachedReader10Align4ReadEv: __ZN12CachedReader10Align4ReadEv, __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f: __ZN15b2WorldManifold10InitializeEPK10b2ManifoldRK11b2TransformfS5_f, __ZNK5Umbra20ObjectDistanceParams16getDistanceScaleEv: __ZNK5Umbra20ObjectDistanceParams16getDistanceScaleEv, __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawCubeRK8Vector3fS1_: __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawCubeRK8Vector3fS1_, __Z58Register_UnityEngine_AudioSource_get_bypassListenerEffectsv: __Z58Register_UnityEngine_AudioSource_get_bypassListenerEffectsv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, __Z52Register_UnityEngine_PointEffector2D_set_forceSourcev: __Z52Register_UnityEngine_PointEffector2D_set_forceSourcev, __ZN8Animator6IKStepEv: __ZN8Animator6IKStepEv, __ZN5physx25PxMaterialGeneratedValuesC2EPKNS_10PxMaterialE: __ZN5physx25PxMaterialGeneratedValuesC2EPKNS_10PxMaterialE, __Z15TransformVector23TransformAccessReadOnlyRKN4math7_float3E: __Z15TransformVector23TransformAccessReadOnlyRKN4math7_float3E, __Z13SetNbCCDPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j: __Z13SetNbCCDPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j, __ZN5physx2Sc14ConstraintCore13setBreakForceEff: __ZN5physx2Sc14ConstraintCore13setBreakForceEff, __Z34setPxVehicleAutoBoxData_DownRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf: __Z34setPxVehicleAutoBoxData_DownRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf, __Z49ParticleSystemRenderer_Get_Custom_PropLengthScaleP12Il2CppObject: __Z49ParticleSystemRenderer_Get_Custom_PropLengthScaleP12Il2CppObject, __Z26scripting_class_is_genericP11Il2CppClass: __Z26scripting_class_is_genericP11Il2CppClass, __ZNK28MonoBehaviourPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK28MonoBehaviourPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, _fullsize_downsample: _fullsize_downsample, __ZN20TextRenderingPrivate8FontImpl8TransferI14SafeBinaryReadEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI14SafeBinaryReadEEvRT_, __ZN16SubstanceArchiveC2E10MemLabelId18ObjectCreationMode: __ZN16SubstanceArchiveC2E10MemLabelId18ObjectCreationMode, __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_: __ZNSt3__27__sort4IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEjT0_SD_SD_SD_T_, __Z46Register_UnityEngine_LineRenderer_SetPositionsv: __Z46Register_UnityEngine_LineRenderer_SetPositionsv, __Z56Register_UnityEngine_Graphics_Internal_DrawMeshInstancedv: __Z56Register_UnityEngine_Graphics_Internal_DrawMeshInstancedv, __Z32NavMeshAgent_CUSTOM_SetLayerCostP12Il2CppObjectif: __Z32NavMeshAgent_CUSTOM_SetLayerCostP12Il2CppObjectif, __Z32getPxFixedJoint_ConcreteTypeNamePKN5physx12PxFixedJointE: __Z32getPxFixedJoint_ConcreteTypeNamePKN5physx12PxFixedJointE, __ZN2UI11CanvasGroup28SendCanvasGroupChangedAlwaysEv: __ZN2UI11CanvasGroup28SendCanvasGroupChangedAlwaysEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2ERKS3_: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2ERKS3_, __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo: __ZN9Scripting35ErrorMessageForUnsupportedEnumFieldEP9FieldInfo, __Z38Rigidbody2D_Get_Custom_PropUseAutoMassP12Il2CppObject: __Z38Rigidbody2D_Get_Custom_PropUseAutoMassP12Il2CppObject, __ZN5physx7NpScene15removeAggregateERNS_11PxAggregateEb: __ZN5physx7NpScene15removeAggregateERNS_11PxAggregateEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj473ENS_22PxRepXPropertyAccessorILj473ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj473ENS_22PxRepXPropertyAccessorILj473ES4_ffEEEEvRKT0_, __Z30AudioClip_CUSTOM_Init_InternalP12Il2CppObjectP12Il2CppStringiiih: __Z30AudioClip_CUSTOM_Init_InternalP12Il2CppObjectP12Il2CppStringiiih, __Z36HingeJoint2D_Get_Custom_PropUseMotorP12Il2CppObject: __Z36HingeJoint2D_Get_Custom_PropUseMotorP12Il2CppObject, __ZN20BufferedSocketStream14FillRecvbufferEv: __ZN20BufferedSocketStream14FillRecvbufferEv, __ZN13WheelCollider14SetMotorTorqueEf: __ZN13WheelCollider14SetMotorTorqueEf, __ZN7Terrain23VirtualRedirectTransferER14SafeBinaryRead: __ZN7Terrain23VirtualRedirectTransferER14SafeBinaryRead, __ZN5Unity17ConfigurableJoint10SetZMotionEi: __ZN5Unity17ConfigurableJoint10SetZMotionEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_, __ZN18AsyncUploadManagerC2Ev: __ZN18AsyncUploadManagerC2Ev, __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_typeINS0_2DbEEEPKcS4_S4_RT_, _ft_black_new: _ft_black_new, __Z62Register_UnityEngine_SystemInfo_get_supportedRenderTargetCountv: __Z62Register_UnityEngine_SystemInfo_get_supportedRenderTargetCountv, __ZNK5physx25PxFixedJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j: __ZNK5physx25PxFixedJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, __ZN5physx22PxShapeGeneratedValuesC2EPKNS_7PxShapeE: __ZN5physx22PxShapeGeneratedValuesC2EPKNS_7PxShapeE, __Z44SurfaceEffector2D_Get_Custom_PropUseFrictionP12Il2CppObject: __Z44SurfaceEffector2D_Get_Custom_PropUseFrictionP12Il2CppObject, __ZNKSt3__212strstreambuf6pcountEv: __ZNKSt3__212strstreambuf6pcountEv, __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv: __ZNK21ScriptingObjectOfTypeI9Texture3DEptEv, __Z51Register_UnityEngine_Camera_get_actualRenderingPathv: __Z51Register_UnityEngine_Camera_get_actualRenderingPathv, __Z42TrailRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf: __Z42TrailRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf, __ZN17FileSystemHandler4CopyER13FileEntryDataS1_: __ZN17FileSystemHandler4CopyER13FileEntryDataS1_, __Z42VRSettings_Get_Custom_PropSupportedDevicesv: __Z42VRSettings_Get_Custom_PropSupportedDevicesv, __Z48Register_UnityEngine_Rigidbody_get_interpolationv: __Z48Register_UnityEngine_Rigidbody_get_interpolationv, __Z61ParticleSystemExtensionsImpl_CUSTOM_GetSafeCollisionEventSizeP12Il2CppObject: __Z61ParticleSystemExtensionsImpl_CUSTOM_GetSafeCollisionEventSizeP12Il2CppObject, __Z47Register_UnityEngine_Gizmos_INTERNAL_get_matrixv: __Z47Register_UnityEngine_Gizmos_INTERNAL_get_matrixv, __Z40Register_UnityEngine_WWW_get_assetBundlev: __Z40Register_UnityEngine_WWW_get_assetBundlev, __ZN7dtCrowd9OccupyRefEy: __ZN7dtCrowd9OccupyRefEy, __ZN13SpringJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN13SpringJoint2DC2E10MemLabelId18ObjectCreationMode, __ZNSt3__26threadD2Ev: __ZNSt3__26threadD2Ev, __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5eraseERS7_: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5eraseERS7_, __Z27getPxSphereGeometry_IsValidPKN5physx16PxSphereGeometryE: __Z27getPxSphereGeometry_IsValidPKN5physx16PxSphereGeometryE, __Z57Register_UnityEngine_AnimationCurve_INTERNAL_CALL_MoveKeyv: __Z57Register_UnityEngine_AnimationCurve_INTERNAL_CALL_MoveKeyv, __ZNK6Camera16GetProjectionFarEv: __ZNK6Camera16GetProjectionFarEv, __Z24InverseTransformRotationRK23TransformAccessReadOnlyRKN4math7_float4E: __Z24InverseTransformRotationRK23TransformAccessReadOnlyRKN4math7_float4E, __Z39getPxSphericalJoint_SphericalJointFlagsPKN5physx16PxSphericalJointE: __Z39getPxSphericalJoint_SphericalJointFlagsPKN5physx16PxSphericalJointE, _jpeg_stdio_src: _jpeg_stdio_src, __ZN11AudioSource6UpdateEv: __ZN11AudioSource6UpdateEv, __ZN16ParticleAnimator14UpdateAnimatorERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof: __ZN16ParticleAnimator14UpdateAnimatorERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof, __Z23NormalizeInputCharactert: __Z23NormalizeInputCharactert, __ZN4crnd19crnd_get_level_dataEPKvjjPj: __ZN4crnd19crnd_get_level_dataEPKvjjPj, __ZN9GfxDevice21ResetDynamicResourcesEv: __ZN9GfxDevice21ResetDynamicResourcesEv, __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13ComputeShader14SetBufferParamEjRKN9ShaderLab16FastPropertyNameE15ComputeBufferID: __ZN13ComputeShader14SetBufferParamEjRKN9ShaderLab16FastPropertyNameE15ComputeBufferID, __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaAllRK13Vector2fIcallS1_iff: __Z45Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaAllRK13Vector2fIcallS1_iff, __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN2UI13RectTransform27SendReapplyDrivenPropertiesEv: __ZN2UI13RectTransform27SendReapplyDrivenPropertiesEv, __ZN13PhysicsModule17GetRigidBodyStateERK9RigidbodyPN8IPhysics14RigidBodyStateE: __ZN13PhysicsModule17GetRigidBodyStateERK9RigidbodyPN8IPhysics14RigidBodyStateE, __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb: __ZN25SingleBlockMemoryFileDataC2E10MemLabelIdPvjb, __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_: __ZN20ParticleSystemModule8TransferI17RemapPPtrTransferEEvRT_, __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev: __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev, __Z61Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplv: __Z61Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplv, __ZN19RuntimeSceneManager37ClearAndUnloadWaitingForLoadingScenesEv: __ZN19RuntimeSceneManager37ClearAndUnloadWaitingForLoadingScenesEv, __ZNKSt3__212ctype_bynameIcE10do_tolowerEPcPKc: __ZNKSt3__212ctype_bynameIcE10do_tolowerEPcPKc, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags, __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sc17ParticleSystemSim7releaseEb: __ZN5physx2Sc17ParticleSystemSim7releaseEb, __ZNK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE: __ZNK5physx5cloth9SwFactory20extractCollisionDataERKNS0_5ClothENS0_5RangeINS_6PxVec4EEENS5_IjEES7_S8_NS5_INS_6PxVec3EEE, __ZN13SubstanceData7ReleaseEv: __ZN13SubstanceData7ReleaseEv, __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE: __ZNK13TranslateGLES6EnableEN2gl10EnabledCapE, __ZN17AnimationPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIP26AnimatorControllerPlayableLj4EE: __ZN17AnimationPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIP26AnimatorControllerPlayableLj4EE, __ZN16BaseVideoTexture19UpdateVideoTexturesEv: __ZN16BaseVideoTexture19UpdateVideoTexturesEv, __Z36AudioSource_Set_Custom_PropPanStereoP12Il2CppObjectf: __Z36AudioSource_Set_Custom_PropPanStereoP12Il2CppObjectf, __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetSizeAffectsRangev: __Z68Register_UnityEngine_ParticleSystem_LightsModule_SetSizeAffectsRangev, __Z51Register_UnityEngine_Projector_get_orthographicSizev: __Z51Register_UnityEngine_Projector_get_orthographicSizev, __ZNK16LightmapSettings23HasLightProbeTetrahedraEv: __ZNK16LightmapSettings23HasLightProbeTetrahedraEv, __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32: __ZNK18ColorBySpeedModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32, __ZN6Sprite23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Sprite23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _getgid: _getgid, __Z38Transform_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f: __Z38Transform_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXMultiplierv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4cendEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4cendEv, __ZN5Unity11SpringJointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity11SpringJointC2E10MemLabelId18ObjectCreationMode, __ZN21DownloadHandlerBufferC2Ej: __ZN21DownloadHandlerBufferC2Ej, __ZN5physx12processGearsEfRKNS_18PxVehicleGearsDataERNS_21PxVehicleDriveDynDataE: __ZN5physx12processGearsEfRKNS_18PxVehicleGearsDataERNS_21PxVehicleDriveDynDataE, __ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE: __ZNK9ShaderLab7Program19HasMatchingVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE, __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_: __ZN15SerializeTraitsIN4math4trsXEE8TransferI8BlobSizeEEvRS1_RT_, __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI20DeviceDepthStateGLES11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZN14ParticleSystem22SetUsesEmitAccumulatorEi: __ZN14ParticleSystem22SetUsesEmitAccumulatorEi, __Z17GetFrustumPortionPK8Vector3fffPS_: __Z17GetFrustumPortionPK8Vector3fffPS_, __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE, __ZN23ManagedAttributeManager32CallManagedGetRequiredComponentsEP11Il2CppClass: __ZN23ManagedAttributeManager32CallManagedGetRequiredComponentsEP11Il2CppClass, __Z13RegisterClassI17BillboardRendererEvv: __Z13RegisterClassI17BillboardRendererEvv, __Z59Register_UnityEngine_VR_VRDevice_INTERNAL_CALL_GetNativePtrv: __Z59Register_UnityEngine_VR_VRDevice_INTERNAL_CALL_GetNativePtrv, __ZNK5Unity10HingeJoint22BuildUseSpringInternalEv: __ZNK5Unity10HingeJoint22BuildUseSpringInternalEv, __ZN5Light13AwakeFromLoadE17AwakeFromLoadMode: __ZN5Light13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx19PxsFluidSpatialHash29reorderParticleIndicesToCellsEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjjPt: __ZN5physx19PxsFluidSpatialHash29reorderParticleIndicesToCellsEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjjPt, __ZN16ReflectionProbes19CleanupRendererPoolEb: __ZN16ReflectionProbes19CleanupRendererPoolEb, _telldir: _telldir, __Z21InitializeClothModulev: __Z21InitializeClothModulev, __ZNKSt3__212ctype_bynameIwE10do_scan_isEtPKwS3_: __ZNKSt3__212ctype_bynameIwE10do_scan_isEtPKwS3_, __ZN7dtCrowd12stopExplicitERK13dtCrowdHandleb: __ZN7dtCrowd12stopExplicitERK13dtCrowdHandleb, __Z24getPxD6Joint_SwingYAnglePKN5physx9PxD6JointE: __Z24getPxD6Joint_SwingYAnglePKN5physx9PxD6JointE, __ZN4crnd15crnd_get_headerERNS_10crn_headerEPKvj: __ZN4crnd15crnd_get_headerERNS_10crn_headerEPKvj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE7reserveEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE7reserveEj, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __Z44Register_UnityEngine_Shader_GetGlobalTexturev: __Z44Register_UnityEngine_Shader_GetGlobalTexturev, __ZN15UnityAdsManagerD0Ev: __ZN15UnityAdsManagerD0Ev, __ZN37InheritVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN37InheritVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z7GetGyrov: __Z7GetGyrov, _strsep: _strsep, __Z65Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierv: __Z65Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierv, __Z44Register_UnityEngine_Transform_GetChildCountv: __Z44Register_UnityEngine_Transform_GetChildCountv, __Z56setPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf: __Z56setPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale0Ev, __ZN6Camera17MultiCustomRenderER11CullResultsPKPFvRS_R10RenderLoopRK15RenderNodeQueueEPKPS6_jb: __ZN6Camera17MultiCustomRenderER11CullResultsPKPFvRS_R10RenderLoopRK15RenderNodeQueueEPKPS6_jb, __Z51AudioLowPassFilter_Get_Custom_PropLowpassResonanceQP12Il2CppObject: __Z51AudioLowPassFilter_Get_Custom_PropLowpassResonanceQP12Il2CppObject, __ZN16StreamedResource8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16StreamedResource8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11b2GearJoint4DumpEv: __ZN11b2GearJoint4DumpEv, __Z26TerrainData_CUSTOM_AddTreeP12Il2CppObjectP12TreeInstance: __Z26TerrainData_CUSTOM_AddTreeP12Il2CppObjectP12TreeInstance, __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8UnityStr4PPtrI6ObjectEEEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8UnityStr4PPtrI6ObjectEEEEEvRT_PKc17TransferMetaFlags, __Z44Profiler_CUSTOM_GetTotalUnusedReservedMemoryv: __Z44Profiler_CUSTOM_GetTotalUnusedReservedMemoryv, _setresuid: _setresuid, __ZN5physx3Cct10Controller13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Cct10Controller13onOriginShiftERKNS_6PxVec3E, __ZN10Matrix3x3f15InvertTransposeEv: __ZN10Matrix3x3f15InvertTransposeEv, __ZN16Physics2DManager21RemoveEffectorUpdatesEP10Effector2D: __ZN16Physics2DManager21RemoveEffectorUpdatesEP10Effector2D, __ZL21ConnectLeftDegenerateP14TESStesselatorP12ActiveRegionP10TESSvertex: __ZL21ConnectLeftDegenerateP14TESStesselatorP12ActiveRegionP10TESSvertex, __ZN5physx16PxVehicleDriveNW14setToRestStateEv: __ZN5physx16PxVehicleDriveNW14setToRestStateEv, __ZN4Mesh24RecalculateSubmeshBoundsEj: __ZN4Mesh24RecalculateSubmeshBoundsEj, __ZN5physx3Ext15CpuWorkerThreadD0Ev: __ZN5physx3Ext15CpuWorkerThreadD0Ev, __ZN14EmissionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14EmissionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN6HelperI8JSONRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI8JSONRead23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __Z11IsBatchmodev: __Z11IsBatchmodev, __ZN8Animator20OnCullingModeChangedEv: __ZN8Animator20OnCullingModeChangedEv, __ZN12ServerSocket7GetPortEv: __ZN12ServerSocket7GetPortEv, __ZN15ResourceManagerD2Ev: __ZN15ResourceManagerD2Ev, __ZNK10GameObject17IsStaticBatchableEv: __ZNK10GameObject17IsStaticBatchableEv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z18Transfer_BlittableI8JSONReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z40DynamicGI_Get_Custom_PropSynchronousModev: __Z40DynamicGI_Get_Custom_PropSynchronousModev, __ZN12_GLOBAL__N_118createArticulationEv: __ZN12_GLOBAL__N_118createArticulationEv, __ZN10systeminfo24GetRuntimePlatformStringE15RuntimePlatform: __ZN10systeminfo24GetRuntimePlatformStringE15RuntimePlatform, ___rem_pio2: ___rem_pio2, __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv: __ZN20TextRenderingPrivate8FontImpl18ResetCachedTextureEv, __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaPositionv: __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaPositionv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5tellgEv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5tellgEv, __ZN12_GLOBAL__N_124PropertyDefinitionHelper14getNamedValuesEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper14getNamedValuesEv, __ZNK6Shader17GetOutputFilenameEv: __ZNK6Shader17GetOutputFilenameEv, __Z30getPxVehicleWheels_VehicleTypePKN5physx15PxVehicleWheelsE: __Z30getPxVehicleWheels_VehicleTypePKN5physx15PxVehicleWheelsE, __ZN5physx2Sq8AABBTree12markForRefitEj: __ZN5physx2Sq8AABBTree12markForRefitEj, _init_mem_source: _init_mem_source, __ZNK12b2WheelJoint10GetAnchorBEv: __ZNK12b2WheelJoint10GetAnchorBEv, __ZN5physx2Sn12PointerRemap12setObjectRefEyj: __ZN5physx2Sn12PointerRemap12setObjectRefEyj, __Z53Register_UnityEngine_Behaviour_get_isActiveAndEnabledv: __Z53Register_UnityEngine_Behaviour_get_isActiveAndEnabledv, __ZNK13MonoBehaviour26GetTypeInfoVirtualInternalEv: __ZNK13MonoBehaviour26GetTypeInfoVirtualInternalEv, __ZN5Umbra12QueryContext17addQueryDebugAABBERKNS_7Vector3ES3_RKNS_7Vector4Eb: __ZN5Umbra12QueryContext17addQueryDebugAABBERKNS_7Vector3ES3_RKNS_7Vector4Eb, __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE8__appendEj: __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE8__appendEj, __ZNKSt3__210moneypunctIwLb0EE13do_pos_formatEv: __ZNKSt3__210moneypunctIwLb0EE13do_pos_formatEv, __ZN3WWW7DestroyEPS_b: __ZN3WWW7DestroyEPS_b, __ZN26PlayerSettingsSplashScreen8TransferI17RemapPPtrTransferEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI17RemapPPtrTransferEEvRT_, __ZN20TextRenderingPrivate8FontImpl8TransferI17RemapPPtrTransferEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI17RemapPPtrTransferEEvRT_, __Z39GetPathWithPlatformSpecificDllExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z39GetPathWithPlatformSpecificDllExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN7SubMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7SubMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx7NpScene14resetFilteringERNS_12PxRigidActorEPKPNS_7PxShapeEj: __ZN5physx7NpScene14resetFilteringERNS_12PxRigidActorEPKPNS_7PxShapeEj, __Z13GetTagManagerv: __Z13GetTagManagerv, __Z33Font_Set_Custom_PropCharacterInfoP12Il2CppObjectP11Il2CppArray: __Z33Font_Set_Custom_PropCharacterInfoP12Il2CppObjectP11Il2CppArray, __ZN4FMOD6System17getOutputByPluginEPj: __ZN4FMOD6System17getOutputByPluginEPj, __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEC2ERKS3_: __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEC2ERKS3_, __ZN5physx3Ext14SphericalJoint22setSphericalJointFlagsENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE: __ZN5physx3Ext14SphericalJoint22setSphericalJointFlagsENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE, __ZN11UnityEngine9Animation37HasGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantEb: __ZN11UnityEngine9Animation37HasGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantEb, __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD0Ev: __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD0Ev, __ZN15CapsuleCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN15CapsuleCollider23VirtualRedirectTransferER14SafeBinaryRead, __ZN18LoadSceneOperation7PerformEv: __ZN18LoadSceneOperation7PerformEv, __Z52Register_UnityEngine_OcclusionArea_INTERNAL_set_sizev: __Z52Register_UnityEngine_OcclusionArea_INTERNAL_set_sizev, __ZN17PersistentManager22HasPreallocatedObjectsEv: __ZN17PersistentManager22HasPreallocatedObjectsEv, __Z18CalculateWorldAABBR10GameObject: __Z18CalculateWorldAABBR10GameObject, __ZL22SortFloatArrayFunctionPKvS0_: __ZL22SortFloatArrayFunctionPKvS0_, __ZNK5physx2Sn21SerializationRegistry17getBinaryMetaDataERNS_14PxOutputStreamE: __ZNK5physx2Sn21SerializationRegistry17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK14NavMeshManager11TriangulateERNS_13TriangulationE: __ZNK14NavMeshManager11TriangulateERNS_13TriangulationE, __ZL30GeomMTDCallback_CapsuleCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL30GeomMTDCallback_CapsuleCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN5physx7NpScene23forceDynamicTreeRebuildEbb: __ZN5physx7NpScene23forceDynamicTreeRebuildEbb, __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults: __ZL18intersectAnyVsMeshILi0EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults, __ZN11CustomArray8CollapseEPv: __ZN11CustomArray8CollapseEPv, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEcvbEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEEcvbEv, __Z49ParticleEmitter_CUSTOM_INTERNAL_set_worldVelocityP12Il2CppObjectRK8Vector3f: __Z49ParticleEmitter_CUSTOM_INTERNAL_set_worldVelocityP12Il2CppObjectRK8Vector3f, __ZN11UnityEngine7Connect14RemoteSettings8GetFloatERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEf: __ZN11UnityEngine7Connect14RemoteSettings8GetFloatERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEf, _checker: _checker, __Z21CleanupGlobalGUIStatev: __Z21CleanupGlobalGUIStatev, _creal: _creal, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_yearERiRS4_S4_RjRKNS_5ctypeIwEE, __ZL23AddConflictingClassIMPL11ClassIDTypeS_: __ZL23AddConflictingClassIMPL11ClassIDTypeS_, __ZN10SampleClip23VirtualRedirectTransferER14SafeBinaryRead: __ZN10SampleClip23VirtualRedirectTransferER14SafeBinaryRead, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags, __ZN5physx14NpArticulation6wakeUpEv: __ZN5physx14NpArticulation6wakeUpEv, __Z8pqDeleteP9PriorityQi: __Z8pqDeleteP9PriorityQi, __ZN12_GLOBAL__N_110DataStreamD2Ev: __ZN12_GLOBAL__N_110DataStreamD2Ev, __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionXP12Il2CppObject: __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionXP12Il2CppObject, __ZN15ParticlesModule8SyncJobsEv: __ZN15ParticlesModule8SyncJobsEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputnEPKci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sputnEPKci, __ZN18AudioLowPassFilter16CheckConsistencyEv: __ZN18AudioLowPassFilter16CheckConsistencyEv, __Z47Application_Get_Custom_PropInternetReachabilityv: __Z47Application_Get_Custom_PropInternetReachabilityv, __Z44ParticleSystem_TrailModule_CUSTOM_GetEnabledP12Il2CppObject: __Z44ParticleSystem_TrailModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN4FMOD7SystemI18createChannelGroupEPKcPPNS_12ChannelGroupE: __ZN4FMOD7SystemI18createChannelGroupEPKcPPNS_12ChannelGroupE, __ZN6Camera24PrepareCullingParametersERK23CameraCullingParameters13RenderingPathR11CullResults: __ZN6Camera24PrepareCullingParametersERK23CameraCullingParameters13RenderingPathR11CullResults, __Z35Font_CUSTOM_GetOSInstalledFontNamesv: __Z35Font_CUSTOM_GetOSInstalledFontNamesv, __ZN13WheelCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13WheelCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z68Register_UnityEngine_PolygonCollider2D_INTERNAL_CALL_CreatePrimitivev: __Z68Register_UnityEngine_PolygonCollider2D_INTERNAL_CALL_CreatePrimitivev, __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObjectPP15Il2CppException: __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObjectPP15Il2CppException, __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN19VREyeTextureManager21SetUnityTextureFormatE28UnityVREyeTextureLayoutFlagsbi: __ZN19VREyeTextureManager21SetUnityTextureFormatE28UnityVREyeTextureLayoutFlagsbi, __ZN17WeakPtrSharedDataD0Ev: __ZN17WeakPtrSharedDataD0Ev, __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetSeparateAxesv: __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetSeparateAxesv, __Z9pqMinimumP9PriorityQ: __Z9pqMinimumP9PriorityQ, __Z47AudioMixer_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_: __Z47AudioMixer_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_, __ZNKSt3__217moneypunct_bynameIcLb1EE14do_frac_digitsEv: __ZNKSt3__217moneypunct_bynameIcLb1EE14do_frac_digitsEv, __ZNK24iPhoneRemoteNotification11GetUserInfoEv: __ZNK24iPhoneRemoteNotification11GetUserInfoEv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN26AnimatorOverrideController15InitializeClassEv: __ZN26AnimatorOverrideController15InitializeClassEv, _scalb: _scalb, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5physx20InternalTriangleMesh16allocateVerticesEj: __ZN5physx20InternalTriangleMesh16allocateVerticesEj, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIaaEEPaEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIaaEEPaEEbT0_S5_T_, __ZN20SoundChannelInstance13SetPositionMSEj: __ZN20SoundChannelInstance13SetPositionMSEj, __Z44Register_UnityEngine_Shader_WarmupAllShadersv: __Z44Register_UnityEngine_Shader_WarmupAllShadersv, __Z39Register_UnityEngine_Animator_CrossFadev: __Z39Register_UnityEngine_Animator_CrossFadev, __ZN13b2PulleyJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN13b2PulleyJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN20UnloadSceneOperation12GetDebugNameEv: __ZN20UnloadSceneOperation12GetDebugNameEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZN19StreamedBinaryWriteILb1EE8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb1EE8TransferI8UnityStrEEvRT_PKc17TransferMetaFlags, __ZThn4_N5physx5cloth8SwSolverD1Ev: __ZThn4_N5physx5cloth8SwSolverD1Ev, _modff: _modff, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv, __ZN5Unity10HingeJoint13WriteUseMotorEv: __ZN5Unity10HingeJoint13WriteUseMotorEv, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_21PxHeightFieldGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_21PxHeightFieldGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __ZThn4_N16RayRTreeCallbackILi1ELb0EED1Ev: __ZThn4_N16RayRTreeCallbackILi1ELb0EED1Ev, __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveScaleP12Il2CppObject: __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveScaleP12Il2CppObject, __ZN18BuoyancyEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE: __ZN18BuoyancyEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE, __ZN24EllipsoidParticleEmitter15InitializeClassEv: __ZN24EllipsoidParticleEmitter15InitializeClassEv, __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E: __ZN20SphericalHarmonicsL219AddDirectionalLightERKN4math7_float3ERKNS0_7_float4E, __ZN5physx13BigConvexDataD2Ev: __ZN5physx13BigConvexDataD2Ev, __ZNK24EllipsoidParticleEmitter26GetTypeInfoVirtualInternalEv: __ZNK24EllipsoidParticleEmitter26GetTypeInfoVirtualInternalEv, __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority: __Z26ScheduleJobForEachInternalR8JobFencePFvPvjES1_iPFvS1_E11JobPriority, _LzmaDec_DecodeReal2: _LzmaDec_DecodeReal2, __Z53Register_UnityEngine_BuoyancyEffector2D_get_flowAnglev: __Z53Register_UnityEngine_BuoyancyEffector2D_get_flowAnglev, __ZN9Scripting18RaiseMonoExceptionEPKcz: __ZN9Scripting18RaiseMonoExceptionEPKcz, __ZN10GameObject17WillHandleMessageERK17MessageIdentifier: __ZN10GameObject17WillHandleMessageERK17MessageIdentifier, __ZN24RingBufferMemoryFileData6UnlockEPv: __ZN24RingBufferMemoryFileData6UnlockEPv, __ZN16ParticleRenderer11SetUVFramesEPK5RectTIfEi: __ZN16ParticleRenderer11SetUVFramesEPK5RectTIfEi, __Z12calculateMTDRKN5physx2Gu13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos12PsTransformVERKNS7_15PsMatTransformVEbRKNS7_6FloatVEPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS7_5Vec3VESN_SN_SL_RSD_: __Z12calculateMTDRKN5physx2Gu13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos12PsTransformVERKNS7_15PsMatTransformVEbRKNS7_6FloatVEPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS7_5Vec3VESN_SN_SL_RSD_, __ZNK5physx6shdfnd6Socket10isBlockingEv: __ZNK5physx6shdfnd6Socket10isBlockingEv, __Z24getPxScene_GpuDispatcherPKN5physx7PxSceneE: __Z24getPxScene_GpuDispatcherPKN5physx7PxSceneE, __ZN9ShaderLab16FastPropertyName15InitBy28BitHashEj: __ZN9ShaderLab16FastPropertyName15InitBy28BitHashEj, __ZN14NavMeshManager17UnloadNavMeshDataEi: __ZN14NavMeshManager17UnloadNavMeshDataEi, __Z49Rigidbody2D_Set_Custom_PropCollisionDetectionModeP12Il2CppObjectN11Rigidbody2D22CollisionDetectionModeE: __Z49Rigidbody2D_Set_Custom_PropCollisionDetectionModeP12Il2CppObjectN11Rigidbody2D22CollisionDetectionModeE, __Z41AudioChorusFilter_Get_Custom_PropFeedbackP12Il2CppObject: __Z41AudioChorusFilter_Get_Custom_PropFeedbackP12Il2CppObject, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_jj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_jj, __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z34TextMesh_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z34TextMesh_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, __ZNKSt3__220__codecvt_utf8_utf16IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_, __Z23tessMeshDiscardExteriorP8TESSmesh: __Z23tessMeshDiscardExteriorP8TESSmesh, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_17PxcAABBDataStaticEPNS_11IntegerAABBEj: __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_17PxcAABBDataStaticEPNS_11IntegerAABBEj, __Z46Register_UnityEngine_Cloth_set_solverFrequencyv: __Z46Register_UnityEngine_Cloth_set_solverFrequencyv, __Z57Register_UnityEngine_Application_CanStreamedLevelBeLoadedv: __Z57Register_UnityEngine_Application_CanStreamedLevelBeLoadedv, __ZNK8VRDevice21GetCurrentEyeTexturesEPP13RenderTextureS2_: __ZNK8VRDevice21GetCurrentEyeTexturesEPP13RenderTextureS2_, __ZN9Transform17RotateAroundLocalERK8Vector3ff: __ZN9Transform17RotateAroundLocalERK8Vector3ff, __ZNSt3__26locale5__imp11make_globalEv: __ZNSt3__26locale5__imp11make_globalEv, __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, _UNITY_png_handle_IHDR: _UNITY_png_handle_IHDR, __ZN13GfxDeviceGLES21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE: __ZN13GfxDeviceGLES21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE, __Z51Register_UnityEngine_CharacterController_set_heightv: __Z51Register_UnityEngine_CharacterController_set_heightv, __Z5recipRK8Scalar4f: __Z5recipRK8Scalar4f, __Z33AndroidJNI_CUSTOM_CallShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z33AndroidJNI_CUSTOM_CallShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv, __ZN17UniqueIDGenerator16DestroyPureIndexEj: __ZN17UniqueIDGenerator16DestroyPureIndexEj, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z55Register_UnityEngine_AudioSettings_set_outputSampleRatev: __Z55Register_UnityEngine_AudioSettings_set_outputSampleRatev, __ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj: __ZN5physx27PxDefaultMemoryOutputStream5writeEPKvj, __Z32Joint_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK8Vector3f: __Z32Joint_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK8Vector3f, __ZN6Camera19EndSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera19EndSinglePassStereoER9GfxDeviceR17ShaderPassContextNS_10RenderFlagE, __ZNK13BaseAllocator10IsAssignedEv: __ZNK13BaseAllocator10IsAssignedEv, __ZN10GameObject15ThreadedCleanupEv: __ZN10GameObject15ThreadedCleanupEv, __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKRotationInternalv: __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKRotationInternalv, __ZN5physx7NpCloth22removeCollisionCapsuleEj: __ZN5physx7NpCloth22removeCollisionCapsuleEj, __ZN16MinMaxPolyCurves26FindMinMaxDoubleIntegratedEv: __ZN16MinMaxPolyCurves26FindMinMaxDoubleIntegratedEv, __Z64Register_UnityEngine_AI_NavMesh_SetPathfindingIterationsPerFramev: __Z64Register_UnityEngine_AI_NavMesh_SetPathfindingIterationsPerFramev, __ZN5Mutex6UnlockEv: __ZN5Mutex6UnlockEv, __Z60Register_UnityEngine_RenderTexture_Internal_SetSRGBReadWritev: __Z60Register_UnityEngine_RenderTexture_Internal_SetSRGBReadWritev, __ZN20TextRenderingPrivate8TextMesh16SetCharacterSizeEf: __ZN20TextRenderingPrivate8TextMesh16SetCharacterSizeEf, __ZN5physx2Sn24isBinaryPlatformTagValidEj: __ZN5physx2Sn24isBinaryPlatformTagValidEj, __ZNK13SparseTexture12GetDataWidthEv: __ZNK13SparseTexture12GetDataWidthEv, __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK8Renderer8GetLayerEv: __ZNK8Renderer8GetLayerEv, __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b: __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPSA_SQ_b, __ZN5physx3Cct17CapsuleController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE: __ZN5physx3Cct17CapsuleController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE, __ZNK23iPhoneLocalNotification11GetFireDateEv: __ZNK23iPhoneLocalNotification11GetFireDateEv, __ZN5physx2Sc11InteractionD2Ev: __ZN5physx2Sc11InteractionD2Ev, __ZN12FlareManager11DeleteFlareEi: __ZN12FlareManager11DeleteFlareEi, __ZN7mecanim9animation22DestroyBlendTreeOutputEPNS0_15BlendTreeOutputERNS_6memory9AllocatorE: __ZN7mecanim9animation22DestroyBlendTreeOutputEPNS0_15BlendTreeOutputERNS_6memory9AllocatorE, __ZNK6Camera20GetReplacementShaderEv: __ZNK6Camera20GetReplacementShaderEv, __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj: __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj, __ZNK9Rigidbody16GetPointVelocityERK8Vector3f: __ZNK9Rigidbody16GetPointVelocityERK8Vector3f, ___rand48_step: ___rand48_step, __ZL23stbir__calculate_memoryP11stbir__info: __ZL23stbir__calculate_memoryP11stbir__info, __Z51CharacterJoint_CUSTOM_INTERNAL_get_swingLimitSpringP12Il2CppObjectP20SoftJointLimitSpring: __Z51CharacterJoint_CUSTOM_INTERNAL_get_swingLimitSpringP12Il2CppObjectP20SoftJointLimitSpring, __ZN19MemoryProfilerStats20RegisterGCAllocationEj: __ZN19MemoryProfilerStats20RegisterGCAllocationEj, _UNITY_png_handle_sRGB: _UNITY_png_handle_sRGB, __ZN5physx18AdjacenciesBuilder4InitERKNS_17ADJACENCIESCREATEE: __ZN5physx18AdjacenciesBuilder4InitERKNS_17ADJACENCIESCREATEE, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv, __Z38OcclusionArea_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f: __Z38OcclusionArea_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN15QualitySettings22SetShadowCascade2SplitEf: __ZN15QualitySettings22SetShadowCascade2SplitEf, __ZNK11LightProbes47GetNonTetrahedralizedProbeSetIndexOffsetAndSizeERK7Hash128: __ZNK11LightProbes47GetNonTetrahedralizedProbeSetIndexOffsetAndSizeERK7Hash128, __ZNK30RuntimeInitializeOnLoadManager26GetTypeInfoVirtualInternalEv: __ZNK30RuntimeInitializeOnLoadManager26GetTypeInfoVirtualInternalEv, __ZN8Renderer18SetStaticBatchInfoEii: __ZN8Renderer18SetStaticBatchInfoEii, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYv, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE, __ZN19SpriteMeshGenerator4path9clip_isecE8Vector2fS1_i: __ZN19SpriteMeshGenerator4path9clip_isecE8Vector2fS1_i, __Z54DirectorPlayer_CUSTOM_INTERNAL_CALL_PlayStructInternalP12Il2CppObjectRK9HPlayable: __Z54DirectorPlayer_CUSTOM_INTERNAL_CALL_PlayStructInternalP12Il2CppObjectRK9HPlayable, __Z42ReflectionProbe_CUSTOM_IsFinishedRenderingP12Il2CppObjecti: __Z42ReflectionProbe_CUSTOM_IsFinishedRenderingP12Il2CppObjecti, __ZN9ShaderLab20SerializedProperties17AddVectorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f: __ZN9ShaderLab20SerializedProperties17AddVectorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f, __Z36getPxScene_SceneQueryStaticTimestampPKN5physx7PxSceneE: __Z36getPxScene_SceneQueryStaticTimestampPKN5physx7PxSceneE, __Z32Camera_Get_Custom_PropPixelWidthP12Il2CppObject: __Z32Camera_Get_Custom_PropPixelWidthP12Il2CppObject, __Z28Texture2D_CUSTOM_GetPixels32P12Il2CppObjecti: __Z28Texture2D_CUSTOM_GetPixels32P12Il2CppObjecti, __ZN16b2ContactManager15FindNewContactsEv: __ZN16b2ContactManager15FindNewContactsEv, __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectRK10ColorRGBAf: __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectRK10ColorRGBAf, __ZN18ScriptingArguments10GetFloatAtEi: __ZN18ScriptingArguments10GetFloatAtEi, __ZN7mecanim12statemachine18TransitionConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim12statemachine18TransitionConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12InputManager9GetAnyKeyEv: __ZN12InputManager9GetAnyKeyEv, __ZN13ComputeShader30HasStaticallyResolvedResourcesE17GfxDeviceRendereri: __ZN13ComputeShader30HasStaticallyResolvedResourcesE17GfxDeviceRendereri, __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E: __ZN5physx2Gu27computeBoundsAroundVerticesERNS_9PxBounds3EjPKNS_6PxVec3E, __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESG_RKT_: __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESG_RKT_, __Z18Transfer_BlittableI9JSONWriteLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _cleanup: _cleanup, __ZNK5physx7NpScene9getLimitsEv: __ZNK5physx7NpScene9getLimitsEv, __Z48Register_UnityEngine_SpringJoint2D_set_frequencyv: __Z48Register_UnityEngine_SpringJoint2D_set_frequencyv, __Z33SetUpSkinnedBuffersOnSkinnedClothPN5Unity5ClothEPvS2_S2_jb: __Z33SetUpSkinnedBuffersOnSkinnedClothPN5Unity5ClothEPvS2_S2_jb, __Z48UnityAnalyticsHandler_CUSTOM_SendCustomEventNameP12Il2CppObjectP12Il2CppString: __Z48UnityAnalyticsHandler_CUSTOM_SendCustomEventNameP12Il2CppObjectP12Il2CppString, __ZN6ObjectD2Ev: __ZN6ObjectD2Ev, __ZN9Transform16SetLocalRotationERK11Quaternionf: __ZN9Transform16SetLocalRotationERK11Quaternionf, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z57Register_UnityEngine_Rigidbody_set_collisionDetectionModev: __Z57Register_UnityEngine_Rigidbody_set_collisionDetectionModev, __Z21GetCameraOrWindowRectPK6Camera: __Z21GetCameraOrWindowRectPK6Camera, __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE: __ZN13AnimationClip16DecompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE, __ZN14NavMeshManager20CalculatePathCornersEP8Vector3fiRK11NavMeshPath: __ZN14NavMeshManager20CalculatePathCornersEP8Vector3fiRK11NavMeshPath, __ZN12AdsIdHandler22InvokeAllAdsIdDelegateEv: __ZN12AdsIdHandler22InvokeAllAdsIdDelegateEv, __ZN3MBP12updateObjectEjRK5IAABB: __ZN3MBP12updateObjectEjRK5IAABB, __Z40Transform_CUSTOM_INTERNAL_get_lossyScaleP12Il2CppObjectP8Vector3f: __Z40Transform_CUSTOM_INTERNAL_get_lossyScaleP12Il2CppObjectP8Vector3f, __ZNK21ArchiveStorageCreator23CheckBlockIsInitializedEv: __ZNK21ArchiveStorageCreator23CheckBlockIsInitializedEv, __GLOBAL__sub_I_runtime_graphics5_lump_cpp: __GLOBAL__sub_I_runtime_graphics5_lump_cpp, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii: __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_ii, __GLOBAL__I_000101: __GLOBAL__I_000101, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_, __Z57Register_UnityEngine_ConfigurableJoint_get_angularYMotionv: __Z57Register_UnityEngine_ConfigurableJoint_get_angularYMotionv, __Z21IntersectSphereSphereRK6SphereS1_: __Z21IntersectSphereSphereRK6SphereS1_, __Z39Graphics_CUSTOM_ClearRandomWriteTargetsv: __Z39Graphics_CUSTOM_ClearRandomWriteTargetsv, __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb: __Z30GetOrCreateObjectStoredInFieldP9FieldInfoRK17GeneralMonoObjectb, __ZN5physx2Sc5Scene20fireTriggerCallbacksEv: __ZN5physx2Sc5Scene20fireTriggerCallbacksEv, ___cxa_can_catch: ___cxa_can_catch, __ZN5physx2Sc5Scene28scheduleParticleCollisionCpuERNS_10PxBaseTaskE: __ZN5physx2Sc5Scene28scheduleParticleCollisionCpuERNS_10PxBaseTaskE, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED0Ev: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED0Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE8pushNameEPKc, __Z53Register_UnityEngine_QualitySettings_set_antiAliasingv: __Z53Register_UnityEngine_QualitySettings_set_antiAliasingv, __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E, __Z36Register_UnityEngine_GUI_set_enabledv: __Z36Register_UnityEngine_GUI_set_enabledv, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeMultiplierP12Il2CppObjectf: __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeMultiplierP12Il2CppObjectf, __ZN14VehiclesModule21GetColliderForVehicleEPN5physx16PxVehicleNoDriveEi: __ZN14VehiclesModule21GetColliderForVehicleEPN5physx16PxVehicleNoDriveEi, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN6Camera21PostMultiCustomRenderENS_10RenderFlagEb: __ZN6Camera21PostMultiCustomRenderENS_10RenderFlagEb, __Z24dtClosestPtPointTrianglePfPKfS1_S1_S1_: __Z24dtClosestPtPointTrianglePfPKfS1_S1_S1_, __Z56Register_UnityEngine_CharacterJoint_get_enableProjectionv: __Z56Register_UnityEngine_CharacterJoint_get_enableProjectionv, __Z20Camera_CUSTOM_RenderP12Il2CppObject: __Z20Camera_CUSTOM_RenderP12Il2CppObject, __Z56Register_UnityEngine_QualitySettings_set_pixelLightCountv: __Z56Register_UnityEngine_QualitySettings_set_pixelLightCountv, __ZNK8TypeTree9BlobWriteER13dynamic_arrayIhLj1EEb: __ZNK8TypeTree9BlobWriteER13dynamic_arrayIhLj1EEb, __ZN5physx15PxsArticulationD2Ev: __ZN5physx15PxsArticulationD2Ev, __Z13GetSocketPorti: __Z13GetSocketPorti, __Z35Matrix4x4_Get_Custom_PropIsIdentityRK10Matrix4x4f: __Z35Matrix4x4_Get_Custom_PropIsIdentityRK10Matrix4x4f, _UNITY_FT_Outline_Embolden: _UNITY_FT_Outline_Embolden, __ZN23ShaderVariantCollection13WarmupShadersEv: __ZN23ShaderVariantCollection13WarmupShadersEv, __ZN15NavMeshObstacle10SetExtentsERK8Vector3f: __ZN15NavMeshObstacle10SetExtentsERK8Vector3f, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUVChannelMaskP12Il2CppObject: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetUVChannelMaskP12Il2CppObject, __ZN13UnityProfiler22DomainReloadedCallbackEv: __ZN13UnityProfiler22DomainReloadedCallbackEv, __Z27scripting_gc_collect_unsafei: __Z27scripting_gc_collect_unsafei, __Z35Rigidbody2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti: __Z35Rigidbody2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti, __ZN11AudioModule20SuspendVideoTexturesEv: __ZN11AudioModule20SuspendVideoTexturesEv, __Z59Register_UnityEngine_Animator_GetHintWeightPositionInternalv: __Z59Register_UnityEngine_Animator_GetHintWeightPositionInternalv, __Z51Register_UnityEngine_AudioSettings_GetDSPBufferSizev: __Z51Register_UnityEngine_AudioSettings_GetDSPBufferSizev, __ZZN15DirectorManager15InitializeClassEvEN38PostLateUpdateDirectorLateUpdatestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN38PostLateUpdateDirectorLateUpdatestruct7ForwardEv, __Z59Register_UnityEngine_CharacterController_INTERNAL_CALL_Movev: __Z59Register_UnityEngine_CharacterController_INTERNAL_CALL_Movev, __ZN5Unity12PhysicsQuery14OverlapCapsuleERK8Vector3fS3_fi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery14OverlapCapsuleERK8Vector3fS3_fi23QueryTriggerInteraction, __ZN5physx13NpRigidStaticC2ERKNS_11PxTransformE: __ZN5physx13NpRigidStaticC2ERKNS_11PxTransformE, __ZN7Terrain17SetLegacySpecularERK11ColorRGBA32: __ZN7Terrain17SetLegacySpecularERK11ColorRGBA32, __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47ParticleSystem_MainModule_CUSTOM_SetStartSize3DP12Il2CppObjecth: __Z47ParticleSystem_MainModule_CUSTOM_SetStartSize3DP12Il2CppObjecth, _UNITY_FT_GlyphLoader_CheckPoints: _UNITY_FT_GlyphLoader_CheckPoints, __Z45Register_UnityEngine_ComputeBuffer_get_stridev: __Z45Register_UnityEngine_ComputeBuffer_get_stridev, __ZN16b2PolygonContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN16b2PolygonContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN5physx2Sc16InteractionScene27swapInteractionArrayIndicesEjjNS0_15InteractionTypeE: __ZN5physx2Sc16InteractionScene27swapInteractionArrayIndicesEjjNS0_15InteractionTypeE, __ZN5physxL20PxcSweepBoxTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf: __ZN5physxL20PxcSweepBoxTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf, __ZN5physx3Cct15ObstacleContextD0Ev: __ZN5physx3Cct15ObstacleContextD0Ev, __ZN15SharedLightData7PrecalcEv: __ZN15SharedLightData7PrecalcEv, __ZN10Matrix4x4fmLERKS_: __ZN10Matrix4x4fmLERKS_, __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __ZN17TransformInternal12InitLocalTRSE15TransformAccessRKN4math7_float3ERKNS1_7_float4ES4_: __ZN17TransformInternal12InitLocalTRSE15TransformAccessRKN4math7_float3ERKNS1_7_float4ES4_, __ZN4File13GetFileLengthEv: __ZN4File13GetFileLengthEv, __ZN5Light16TransformChangedEv: __ZN5Light16TransformChangedEv, __ZNSt3__221recursive_timed_mutexC2Ev: __ZNSt3__221recursive_timed_mutexC2Ev, __ZN5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEED0Ev, __ZN10GUITexture5ResetEv: __ZN10GUITexture5ResetEv, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_, __ZN15ArchiveReadFileD0Ev: __ZN15ArchiveReadFileD0Ev, __ZN14NavMeshManager13RegisterAgentER12NavMeshAgentRi: __ZN14NavMeshManager13RegisterAgentER12NavMeshAgentRi, __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_boundsv: __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_get_boundsv, __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv: __ZN18ConcurrentFreeListI28FileTextureUploadInstructionE7CleanUpEv, __ZN11DynamicMesh24RemoveDegeneratePolygonsEv: __ZN11DynamicMesh24RemoveDegeneratePolygonsEv, __ZNSt3__26vectorIP14DataBufferGLESNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP14DataBufferGLESNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE: __ZN5physx3Scb9Aggregate9syncStateERNS0_5SceneE, __ZN5physx10PxsContext28runModifiableContactManagersEv: __ZN5physx10PxsContext28runModifiableContactManagersEv, __Z54Register_UnityEngine_Animator_GetNextAnimatorStateInfov: __Z54Register_UnityEngine_Animator_GetNextAnimatorStateInfov, __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetEnabledv: __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetEnabledv, __Z44ParticleSystem_TrailModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z44ParticleSystem_TrailModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN12LineRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData: __ZN12LineRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData, __Z40SpriteRenderer_CUSTOM_GetSprite_INTERNALP12Il2CppObject: __Z40SpriteRenderer_CUSTOM_GetSprite_INTERNALP12Il2CppObject, __ZNSt8bad_castD0Ev: __ZNSt8bad_castD0Ev, __ZN16Physics2DManager12OverlapPointERK8Vector2fiffPK10Collider2D: __ZN16Physics2DManager12OverlapPointERK8Vector2fiffPK10Collider2D, __Z17mono_profiler_endi: __Z17mono_profiler_endi, _FT_MSB: _FT_MSB, __Z32TextMesh_Set_Custom_PropRichTextP12Il2CppObjecth: __Z32TextMesh_Set_Custom_PropRichTextP12Il2CppObjecth, __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS9_PvEE, __ZN29AnimationStateNetworkProvider24SetNetworkAnimationStateER9AnimationPK24AnimationStateForNetworki: __ZN29AnimationStateNetworkProvider24SetNetworkAnimationStateER9AnimationPK24AnimationStateForNetworki, _logbf: _logbf, __Z34getPxClothTetherConfigStretchLimitPKN5physx19PxClothTetherConfigE: __Z34getPxClothTetherConfigStretchLimitPKN5physx19PxClothTetherConfigE, __Z14ClipAnimationsIfN13AnimationClip10FloatCurveE13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRS9_: __Z14ClipAnimationsIfN13AnimationClip10FloatCurveE13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRS9_, __Z49Register_UnityEngine_RenderTexture_GetDepthBufferv: __Z49Register_UnityEngine_RenderTexture_GetDepthBufferv, __ZNK19ShaderPropertySheet11SerializeToEPh: __ZNK19ShaderPropertySheet11SerializeToEPh, _logbl: _logbl, __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx7NpActor17resolveReferencesERNS_24PxDeserializationContextE, __ZN9Rigidbody15InitializeClassEv: __ZN9Rigidbody15InitializeClassEv, _UNITY_FT_Stroker_ExportBorder: _UNITY_FT_Stroker_ExportBorder, __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZv: __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZv, __ZN5physx2Sn25readStridedBufferPropertyINS_24PxClothCollisionTriangleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_24PxClothCollisionTriangleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44ReflectionProbe_Get_Custom_PropBlendDistanceP12Il2CppObject: __Z44ReflectionProbe_Get_Custom_PropBlendDistanceP12Il2CppObject, __ZN19PlayerLoopCallbacksC2Ev: __ZN19PlayerLoopCallbacksC2Ev, __ZN9Transform23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Transform23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN14UnityAnalytics22HandleCustomEventLimitERN11UnityEngine9Analytics15UserCustomEventE: __ZN14UnityAnalytics22HandleCustomEventLimitERN11UnityEngine9Analytics15UserCustomEventE, __ZN13InitialModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13InitialModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN9TransformC2E10MemLabelId18ObjectCreationMode: __ZN9TransformC2E10MemLabelId18ObjectCreationMode, __Z41Register_UnityEngine_Light_set_bakedIndexv: __Z41Register_UnityEngine_Light_set_bakedIndexv, __ZN15LODGroupManager26CalculateAnimatedCrossFadeENS_11LODFadeDataEhfPhPf: __ZN15LODGroupManager26CalculateAnimatedCrossFadeENS_11LODFadeDataEhfPhPf, __ZN13GfxDeviceGLES14SetRasterStateEPK17DeviceRasterState: __ZN13GfxDeviceGLES14SetRasterStateEPK17DeviceRasterState, __ZN15b2DistanceJoint24SolvePositionConstraintsERK12b2SolverData: __ZN15b2DistanceJoint24SolvePositionConstraintsERK12b2SolverData, __ZNK13TranslateGLES11BlendFactorE9BlendMode: __ZNK13TranslateGLES11BlendFactorE9BlendMode, __Z30TransferField_LinearCollectionI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE5eraseERS8_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE5eraseERS8_, __Z23TransferScriptingObjectI14SafeBinaryReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI14SafeBinaryReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN5physx5Elems17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE: __ZN5physx5Elems17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE, _fnmatch_internal: _fnmatch_internal, __ZN14SafeBinaryRead11EndTransferEv: __ZN14SafeBinaryRead11EndTransferEv, __ZN17AudioReverbFilter6UpdateEv: __ZN17AudioReverbFilter6UpdateEv, __ZNK3WWW12GetAudioClipEv: __ZNK3WWW12GetAudioClipEv, __ZN14SafeBinaryRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags, __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_get_lowAngularXLimitv: __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_get_lowAngularXLimitv, __ZN21UniformBufferTFMethod13MapBoneBufferEj: __ZN21UniformBufferTFMethod13MapBoneBufferEj, __ZN5Umbra14TomeCollectionD2Ev: __ZN5Umbra14TomeCollectionD2Ev, __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz: __ZN9Scripting24RaiseOutOfRangeExceptionEPKcz, __ZN4FMOD5Sound12setLoopCountEi: __ZN4FMOD5Sound12setLoopCountEi, _cosh: _cosh, __ZN13RenderTexture15SetAntiAliasingEi: __ZN13RenderTexture15SetAntiAliasingEi, __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEED2Ev: __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEED2Ev, __Z30Light_CUSTOM_GetCommandBuffersP12Il2CppObject20RenderLightEventType: __Z30Light_CUSTOM_GetCommandBuffersP12Il2CppObject20RenderLightEventType, __ZN7mecanim9animation13LayerConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation13LayerConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __Z61Register_UnityEngine_Physics2D_INTERNAL_get_colliderAABBColorv: __Z61Register_UnityEngine_Physics2D_INTERNAL_get_colliderAABBColorv, __Z40Register_UnityEngine_Input_GetKeyDownIntv: __Z40Register_UnityEngine_Input_GetKeyDownIntv, __Z46Register_UnityEngine_AudioSource_get_isVirtualv: __Z46Register_UnityEngine_AudioSource_get_isVirtualv, __Z42Register_UnityEngine_VR_VRDevice_get_modelv: __Z42Register_UnityEngine_VR_VRDevice_get_modelv, __ZN9TextAsset15ThreadedCleanupEv: __ZN9TextAsset15ThreadedCleanupEv, __ZN14DirectorPlayer8TransferI14SafeBinaryReadEEvRT_: __ZN14DirectorPlayer8TransferI14SafeBinaryReadEEvRT_, __Z11FormatBytesx: __Z11FormatBytesx, __ZN14SerializedFileD2Ev: __ZN14SerializedFileD2Ev, __Z19MainThreadSchedulerPFvPvES_10JobGroupID: __Z19MainThreadSchedulerPFvPvES_10JobGroupID, __Z21CompleteFenceInternalR8JobFence: __Z21CompleteFenceInternalR8JobFence, __Z30Event_Get_Custom_PropModifiersP12Il2CppObject: __Z30Event_Get_Custom_PropModifiersP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15growAndPushBackERKS2_, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5writeERN5physx8debugger15PvdOutputStreamE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5writeERN5physx8debugger15PvdOutputStreamE, __ZN18ColorBySpeedModule8TransferI17RemapPPtrTransferEEvRT_: __ZN18ColorBySpeedModule8TransferI17RemapPPtrTransferEEvRT_, __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE: __ZN7mecanim9animation16CreateClipOutputEPKNS0_4ClipERNS_6memory9AllocatorE, __ZNKSt3__214__codecvt_utf8IDsE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__214__codecvt_utf8IDsE9do_lengthER11__mbstate_tPKcS5_j, __Z39DirectorPlayer_CUSTOM_GetTimeUpdateModeP12Il2CppObject: __Z39DirectorPlayer_CUSTOM_GetTimeUpdateModeP12Il2CppObject, __ZN15AudioReverbZone17GetReverbPropertyEi: __ZN15AudioReverbZone17GetReverbPropertyEi, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEwj, __ZN2UI6Canvas20SetupOverlayMatricesEv: __ZN2UI6Canvas20SetupOverlayMatricesEv, __ZN5physx23PxcFsGetImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_: __ZN5physx23PxcFsGetImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_, __ZN11Rigidbody2D14SetConstraintsENS_11ConstraintsE: __ZN11Rigidbody2D14SetConstraintsENS_11ConstraintsE, __ZN18AsyncUploadManager17DoScaledPaddedJobEP28FileTextureUploadInstruction: __ZN18AsyncUploadManager17DoScaledPaddedJobEP28FileTextureUploadInstruction, __ZN5physx3Cct12SweptCapsuleC2Ev: __ZN5physx3Cct12SweptCapsuleC2Ev, __ZN14NavMeshCarving17ApplyCarveResultsEv: __ZN14NavMeshCarving17ApplyCarveResultsEv, __ZN6Shader21AwakeFromLoadThreadedEv: __ZN6Shader21AwakeFromLoadThreadedEv, __ZN13AnimationClip15QuaternionCurveaSERKS0_: __ZN13AnimationClip15QuaternionCurveaSERKS0_, __ZN16CircleCollider2D15ThreadedCleanupEv: __ZN16CircleCollider2D15ThreadedCleanupEv, __ZN6Shader8PostLoadEv: __ZN6Shader8PostLoadEv, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE5CheckEv: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE5CheckEv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERPv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERPv, __ZN5physx24PxcContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx24PxcContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z45PointEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject: __Z45PointEffector2D_Get_Custom_PropForceMagnitudeP12Il2CppObject, __ZN13UploadHandler10OnSentDataEj: __ZN13UploadHandler10OnSentDataEj, __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj, __Z38Input_Get_Custom_PropDeviceOrientationv: __Z38Input_Get_Custom_PropDeviceOrientationv, __ZN15UniformTFMethod20IsBoneCountSupportedEi: __ZN15UniformTFMethod20IsBoneCountSupportedEi, __ZNK5physx23AggregateAABBUpdateTask7getNameEv: __ZNK5physx23AggregateAABBUpdateTask7getNameEv, __ZN5physx3Scb13ObjectTracker6insertERNS0_4BaseE: __ZN5physx3Scb13ObjectTracker6insertERNS0_4BaseE, __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j: __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_, __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iiiPKiS3_ii: __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iiiPKiS3_ii, __ZNK5physx5cloth8SwFabric10getNumSetsEv: __ZNK5physx5cloth8SwFabric10getNumSetsEv, __ZNSt3__25alignEjjRPvRj: __ZNSt3__25alignEjjRPvRj, __Z24getNbPxRigidActor_ShapesPKN5physx12PxRigidActorE: __Z24getNbPxRigidActor_ShapesPKN5physx12PxRigidActorE, __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_SetPixelv: __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_SetPixelv, __ZN24ScriptingMethodFiltering17FilterOnSignatureENS_18MethodSearchFilterE: __ZN24ScriptingMethodFiltering17FilterOnSignatureENS_18MethodSearchFilterE, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EOS3_: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EOS3_, __ZN11TrailModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11TrailModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx2Sq12BucketPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE: __ZNK5physx2Sq12BucketPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE, __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEEEEjT_j: __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEEEEjT_j, __ZNK7b2Joint8IsActiveEv: __ZNK7b2Joint8IsActiveEv, __ZN18ScreenManagerWebGL13SetLockCursorE14CursorLockMode: __ZN18ScreenManagerWebGL13SetLockCursorE14CursorLockMode, _cf2_arrstack_finalize: _cf2_arrstack_finalize, __ZNK9AudioClip14GetSampleCountEv: __ZNK9AudioClip14GetSampleCountEv, __Z33GUIUtility_CUSTOM_HasMouseControli: __Z33GUIUtility_CUSTOM_HasMouseControli, __ZNK29ParticleSystemPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK29ParticleSystemPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __ZN13MonoBehaviour19HandleNotificationsEPviR11MessageData: __ZN13MonoBehaviour19HandleNotificationsEPviR11MessageData, __ZN17ProceduralTextureD2Ev: __ZN17ProceduralTextureD2Ev, __ZN13SubstanceData22OnMaterialBeginLoadingEv: __ZN13SubstanceData22OnMaterialBeginLoadingEv, __ZN5physx10PxsContext21processContactManagerEPNS_17PxsContactManagerEjPv: __ZN5physx10PxsContext21processContactManagerEPNS_17PxsContactManagerEjPv, __ZN24iPhoneRemoteNotification20GetDeviceTokenLengthEv: __ZN24iPhoneRemoteNotification20GetDeviceTokenLengthEv, __Z22scripting_array_new_2dP11Il2CppClassjjj: __Z22scripting_array_new_2dP11Il2CppClassjjj, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2Ev: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2Ev, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN19MeshParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi: __ZN19MeshParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi, __ZN39AssetBundleLoadFromMemoryAsyncOperationC2Ev: __ZN39AssetBundleLoadFromMemoryAsyncOperationC2Ev, __Z49Terrain_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_: __Z49Terrain_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_, _UnityReplayKitIsBroadcasting: _UnityReplayKitIsBroadcasting, __Z54Register_UnityEngine_RenderSettings_get_flareFadeSpeedv: __Z54Register_UnityEngine_RenderSettings_get_flareFadeSpeedv, __ZNK11NamedObject26GetTypeInfoVirtualInternalEv: __ZNK11NamedObject26GetTypeInfoVirtualInternalEv, __Z20SignedTriangleArea2DRK8Vector2fS1_S1_: __Z20SignedTriangleArea2DRK8Vector2fS1_S1_, __Z59ParticleSystem_LightsModule_CUSTOM_SetAlphaAffectsIntensityP12Il2CppObjecth: __Z59ParticleSystem_LightsModule_CUSTOM_SetAlphaAffectsIntensityP12Il2CppObjecth, __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f: __ZNK5Umbra18ImpOcclusionBuffer20isPixelAARectVisibleILb1EEEbRKNS_8Vector2iES4_f, __ZN5physx9PxTaskMgrD0Ev: __ZN5physx9PxTaskMgrD0Ev, __Z29Animator_Get_Custom_PropSpeedP12Il2CppObject: __Z29Animator_Get_Custom_PropSpeedP12Il2CppObject, __ZN19CharacterController8TransferI14SafeBinaryReadEEvRT_: __ZN19CharacterController8TransferI14SafeBinaryReadEEvRT_, __ZN13TrailRenderer11TrailPointsD0Ev: __ZN13TrailRenderer11TrailPointsD0Ev, __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI15AudioMixerGroupE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Ext14SphericalJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext14SphericalJoint17resolveReferencesERNS_24PxDeserializationContextE, __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_: __ZNSt3__24listIP15UnityWebRequestNS_9allocatorIS2_EEE6removeERKS2_, __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_114parse_decltypeINS0_2DbEEEPKcS4_S4_RT_, __ZN7mecanim4hand10GetAxeInfoEj: __ZN7mecanim4hand10GetAxeInfoEj, __ZN10GameObject12CleanupClassEv: __ZN10GameObject12CleanupClassEv, __ZN5physx3Scb5Scene13addRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene13addRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE, __ZN4FMOD7Channel13setLoopPointsEjjjj: __ZN4FMOD7Channel13setLoopPointsEjjjj, __ZN9GfxDevice25SetShaderPropertiesSharedERK19ShaderPropertySheet: __ZN9GfxDevice25SetShaderPropertiesSharedERK19ShaderPropertySheet, __ZN9b2Contact19InitializeRegistersEv: __ZN9b2Contact19InitializeRegistersEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi: __ZN18StreamedBinaryReadILb1EE20TransferTypelessDataEjPvi, __ZN10MonoScript17MainThreadCleanupEv: __ZN10MonoScript17MainThreadCleanupEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxHeightFieldGeometryEE8pushNameEPKc, __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij: __ZN13RenderTexture9SetActiveEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PPS_i11CubemapFaceij, __ZN19SpriteMeshGenerator4path9clip_edgeEi: __ZN19SpriteMeshGenerator4path9clip_edgeEi, __ZN5physx8debugger4comm11OriginShiftD0Ev: __ZN5physx8debugger4comm11OriginShiftD0Ev, __Z22GetShaderGlobalTextureN9ShaderLab16FastPropertyNameE: __Z22GetShaderGlobalTextureN9ShaderLab16FastPropertyNameE, __ZNSt3__218__time_get_storageIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__218__time_get_storageIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator: __ZN9b2Contact7DestroyEPS_P16b2BlockAllocator, __ZN21ArchiveStorageCreatorD2Ev: __ZN21ArchiveStorageCreatorD2Ev, __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetSeparateAxesv: __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetSeparateAxesv, __ZN19FileAccessorHandlerD2Ev: __ZN19FileAccessorHandlerD2Ev, __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpeedv: __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpeedv, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19getPropertyMessagesEPN5physx8debugger26PropertyMessageDescriptionEjj: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19getPropertyMessagesEPN5physx8debugger26PropertyMessageDescriptionEjj, __Z56Register_UnityEngine_Material_CopyPropertiesFromMaterialv: __Z56Register_UnityEngine_Material_CopyPropertiesFromMaterialv, __Z26IsRealGfxDeviceThreadOwnerv: __Z26IsRealGfxDeviceThreadOwnerv, __Z14UpdateVehiclesf: __Z14UpdateVehiclesf, __ZN6Object25RegisterDestroyedCallbackEPFviE: __ZN6Object25RegisterDestroyedCallbackEPFviE, __ZN18StreamedBinaryReadILb1EE8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_, __ZN13ScreenManager17RequestResolutionEiibi: __ZN13ScreenManager17RequestResolutionEiibi, __ZN15MemorySnapshots21CaptureMemorySnapshotER13dynamic_arrayIhLj1EE: __ZN15MemorySnapshots21CaptureMemorySnapshotER13dynamic_arrayIhLj1EE, __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED2Ev, __Z46Register_UnityEngine_CanvasRenderer_set_isMaskv: __Z46Register_UnityEngine_CanvasRenderer_set_isMaskv, __ZN6Skybox11SetMaterialEP8Material: __ZN6Skybox11SetMaterialEP8Material, __Z24RegisterStrippedTypeInfoI6SpriteEviPKcS2_: __Z24RegisterStrippedTypeInfoI6SpriteEviPKcS2_, __ZN12NavMeshAgent29UpdateTransformGetMessageMaskEfPP9Transform: __ZN12NavMeshAgent29UpdateTransformGetMessageMaskEfPP9Transform, __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_: __ZN8Renderer8TransferI17RemapPPtrTransferEEvRT_, __ZThn8_N12_GLOBAL__N_111StreamOwner7releaseEv: __ZThn8_N12_GLOBAL__N_111StreamOwner7releaseEv, __ZN5physx23PxCapsuleControllerDesc12setToDefaultEv: __ZN5physx23PxCapsuleControllerDesc12setToDefaultEv, __Z42Register_UnityEngine_Debug_OpenConsoleFilev: __Z42Register_UnityEngine_Debug_OpenConsoleFilev, __ZN15NavMeshSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15NavMeshSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev: __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD0Ev, __Z22Input_CUSTOM_GetKeyInti: __Z22Input_CUSTOM_GetKeyInti, __Z47AudioSource_Set_Custom_PropIgnoreListenerVolumeP12Il2CppObjecth: __Z47AudioSource_Set_Custom_PropIgnoreListenerVolumeP12Il2CppObjecth, __ZNK5physx2Sc9ClothCore16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES4_PNS_24PxClothCollisionTriangleE: __ZNK5physx2Sc9ClothCore16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES4_PNS_24PxClothCollisionTriangleE, __Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf: __Z24LookRotationToQuaternionRK8Vector3fS1_P11Quaternionf, __ZN16ReflectionProbes9GetCameraEv: __ZN16ReflectionProbes9GetCameraEv, __ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader: __ZL18IsGpuProgramUsable20ShaderGpuProgramTypePK6Shader, __ZN22ParticleSystemRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN22ParticleSystemRenderer8TransferI14SafeBinaryReadEEvRT_, __ZN2UI6Canvas17SetSortingLayerIDEi: __ZN2UI6Canvas17SetSortingLayerIDEi, __Z37Avatar_CUSTOM_INTERNAL_CALL_GetZYRollP12Il2CppObjectiRK8Vector3fR11Quaternionf: __Z37Avatar_CUSTOM_INTERNAL_CALL_GetZYRollP12Il2CppObjectiRK8Vector3fR11Quaternionf, __ZN5Umbra20RuntimeTomeGenerator13getParentCellEiii: __ZN5Umbra20RuntimeTomeGenerator13getParentCellEiii, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__set_long_sizeEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__set_long_sizeEj, __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleAllv: __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleAllv, __ZN5Umbra14TomeCollection16findClusterIndexEiRiS1_: __ZN5Umbra14TomeCollection16findClusterIndexEiRiS1_, __ZThn8_N5physx2Sc23ElementActorInteractionD0Ev: __ZThn8_N5physx2Sc23ElementActorInteractionD0Ev, __ZN5physx6shdfnd10ThreadImpl11getPriorityEj: __ZN5physx6shdfnd10ThreadImpl11getPriorityEj, __ZN13SplatDatabaseD2Ev: __ZN13SplatDatabaseD2Ev, __ZN12_GLOBAL__N_110DataStream14pushPvdCommandERN5physx8debugger4comm21PvdInstanceDataStream10PvdCommandE: __ZN12_GLOBAL__N_110DataStream14pushPvdCommandERN5physx8debugger4comm21PvdInstanceDataStream10PvdCommandE, __Z83Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputInternalv: __Z83Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputInternalv, __ZN5physx10BPWorkTaskD0Ev: __ZN5physx10BPWorkTaskD0Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags, __ZNK9Transform26GetTransformHierarchyIndexEv: __ZNK9Transform26GetTransformHierarchyIndexEv, __ZN14SplatMaterialsC2ERK4PPtrI11TerrainDataERKS0_I8MaterialEPPKcRK11ColorRGBA32f: __ZN14SplatMaterialsC2ERK4PPtrI11TerrainDataERKS0_I8MaterialEPPKcRK11ColorRGBA32f, __ZN18UnityPropertySheet8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18UnityPropertySheet8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z45Register_UnityEngine_AnimationClip_get_legacyv: __Z45Register_UnityEngine_AnimationClip_get_legacyv, __Z38ScheduleDifferentJobsConcurrentDependsR8JobFencePK3JobiRKS_11JobPriority: __Z38ScheduleDifferentJobsConcurrentDependsR8JobFencePK3JobiRKS_11JobPriority, __Z44Register_UnityEngine_WebCamTexture_GetPixelsv: __Z44Register_UnityEngine_WebCamTexture_GetPixelsv, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE15writeContentTagEPKcS5_: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE15writeContentTagEPKcS5_, __Z27WWW_Get_Custom_PropProgressP12Il2CppObject: __Z27WWW_Get_Custom_PropProgressP12Il2CppObject, __ZNK12NavMeshAgent11IsPathStaleEv: __ZNK12NavMeshAgent11IsPathStaleEv, __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__214__split_bufferI14SubstanceInputRNS_9allocatorIS1_EEE18__construct_at_endEj: __ZNSt3__214__split_bufferI14SubstanceInputRNS_9allocatorIS1_EEE18__construct_at_endEj, __ZNKSt3__212ctype_bynameIwE9do_narrowEPKwS3_cPc: __ZNKSt3__212ctype_bynameIwE9do_narrowEPKwS3_cPc, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj, __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z43Register_UnityEngine_RenderTexture_get_sRGBv: __Z43Register_UnityEngine_RenderTexture_get_sRGBv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN15AnchoredJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN22UnityProfilerPerThread18BeginSampleDynamicERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN22UnityProfilerPerThread18BeginSampleDynamicERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10DeallocateEPv: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10DeallocateEPv, _UNITY_png_get_channels: _UNITY_png_get_channels, __GLOBAL__sub_I_runtime_camera2_lump_cpp: __GLOBAL__sub_I_runtime_camera2_lump_cpp, __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_: __ZN15PackedIntVector8TransferI14SafeBinaryReadEEvRT_, __ZN17SharedTextureDataD0Ev: __ZN17SharedTextureDataD0Ev, __ZN10FlareLayerC2E10MemLabelId18ObjectCreationMode: __ZN10FlareLayerC2E10MemLabelId18ObjectCreationMode, __ZNK5physx19NpArticulationJoint20getTangentialDampingEv: __ZNK5physx19NpArticulationJoint20getTangentialDampingEv, __Z36RenderTexture_CUSTOM_SupportsStencilP12Il2CppObject: __Z36RenderTexture_CUSTOM_SupportsStencilP12Il2CppObject, __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E: __ZN5physx3Cct10Controller22setUpDirectionInternalERKNS_6PxVec3E, __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags, __Z48Register_UnityEngine_Animator_SetFloatStringDampv: __Z48Register_UnityEngine_Animator_SetFloatStringDampv, __ZN17BaseObjectManager16StaticInitializeEPv: __ZN17BaseObjectManager16StaticInitializeEPv, __Z51Register_UnityEngine_AI_NavMeshAgent_set_autoRepathv: __Z51Register_UnityEngine_AI_NavMeshAgent_set_autoRepathv, ___freadptrinc: ___freadptrinc, __Z50Register_UnityEngine_Animator_get_isMatchingTargetv: __Z50Register_UnityEngine_Animator_get_isMatchingTargetv, __ZN13TrailRenderer18TransferDeprecatedI14SafeBinaryReadEEvRT_: __ZN13TrailRenderer18TransferDeprecatedI14SafeBinaryReadEEvRT_, __Z28Motion_Get_Custom_PropLegacyP12Il2CppObject: __Z28Motion_Get_Custom_PropLegacyP12Il2CppObject, __Z17GetUniqueTempPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z17GetUniqueTempPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN8Scalar4fC2ERKS_: __ZN8Scalar4fC2ERKS_, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_ED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_ED0Ev, __Z42AnimationCurve_Get_Custom_PropPostWrapModeP12Il2CppObject: __Z42AnimationCurve_Get_Custom_PropPostWrapModeP12Il2CppObject, __ZN8Animator22SetLayerParametersMaskEv: __ZN8Animator22SetLayerParametersMaskEv, __ZN4FMOD7SystemI17getOutputByPluginEPj: __ZN4FMOD7SystemI17getOutputByPluginEPj, __ZN9Behaviour23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Behaviour23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNKSt3__217moneypunct_bynameIwLb1EE16do_negative_signEv: __ZNKSt3__217moneypunct_bynameIwLb1EE16do_negative_signEv, __Z55Register_UnityEngine_QualitySettings_set_shadowCascadesv: __Z55Register_UnityEngine_QualitySettings_set_shadowCascadesv, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z18Transfer_BlittableI9JSONWriteLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13RenderTexture15ThreadedCleanupEv: __ZN13RenderTexture15ThreadedCleanupEv, __Z43Input_Get_Custom_PropAccelerationEventCountv: __Z43Input_Get_Custom_PropAccelerationEventCountv, __Z36RegisterModuleClasses_TerrainPhysicsv: __Z36RegisterModuleClasses_TerrainPhysicsv, __Z34HingeJoint_Set_Custom_PropUseMotorP12Il2CppObjecth: __Z34HingeJoint_Set_Custom_PropUseMotorP12Il2CppObjecth, __ZN12CubemapArray23VirtualRedirectTransferER14SafeBinaryRead: __ZN12CubemapArray23VirtualRedirectTransferER14SafeBinaryRead, __ZN15TerrainRenderer17ReloadToGfxDeviceEv: __ZN15TerrainRenderer17ReloadToGfxDeviceEv, __ZNK5physx2Sc9ClothCore23getNbCollisionTrianglesEv: __ZNK5physx2Sc9ClothCore23getNbCollisionTrianglesEv, _erfcf: _erfcf, __ZN5physx7NpShape16setFlagsInternalENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx7NpShape16setFlagsInternalENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN7mecanim9animation19GetMuscleCurveValueERKNS_5human9HumanPoseERKN4math4trsXEi: __ZN7mecanim9animation19GetMuscleCurveValueERKNS_5human9HumanPoseERKN4math4trsXEi, __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx1Minusx0PKN5physx17PxVehicleTireDataE: __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx1Minusx0PKN5physx17PxVehicleTireDataE, __ZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeE: __ZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeE, _erfcl: _erfcl, __Z48Register_UnityEngine_MeshCollider_get_sharedMeshv: __Z48Register_UnityEngine_MeshCollider_get_sharedMeshv, __ZN5physx28PxSceneLimitsGeneratedValuesC2EPKNS_13PxSceneLimitsE: __ZN5physx28PxSceneLimitsGeneratedValuesC2EPKNS_13PxSceneLimitsE, __ZN21WorldParticleColliderD0Ev: __ZN21WorldParticleColliderD0Ev, __ZN18ProceduralMaterial9ReloadAllEbb: __ZN18ProceduralMaterial9ReloadAllEbb, __Z43RectTransform_CUSTOM_INTERNAL_set_sizeDeltaP12Il2CppObjectRK13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_set_sizeDeltaP12Il2CppObjectRK13Vector2fIcall, __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_: __ZN5physx2Gu30distanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RS3_S6_, __Z40Animator_CUSTOM_GetNextAnimatorStateInfoP12Il2CppObjecti: __Z40Animator_CUSTOM_GetNextAnimatorStateInfoP12Il2CppObjecti, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags, __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer18BeginArrayTransferEPKcS1_Ri17TransferMetaFlags, __ZN6Object15StringToClassIDEPKc: __ZN6Object15StringToClassIDEPKc, __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __ZNK15DistanceJoint2D26GetTypeInfoVirtualInternalEv: __ZNK15DistanceJoint2D26GetTypeInfoVirtualInternalEv, __ZN4Mesh17VerifyBoneIndicesEj: __ZN4Mesh17VerifyBoneIndicesEj, __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_GetFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv: __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_GetFieldID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv, __Z55Register_UnityEngine_Profiling_Profiler_GetMonoUsedSizev: __Z55Register_UnityEngine_Profiling_Profiler_GetMonoUsedSizev, __Z40Register_UnityEngine_GUIClip_get_enabledv: __Z40Register_UnityEngine_GUIClip_get_enabledv, __Z39OffMeshLink_Get_Custom_PropEndTransformP12Il2CppObject: __Z39OffMeshLink_Get_Custom_PropEndTransformP12Il2CppObject, __ZNKSt3__215__codecvt_utf16IDiLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_: __ZNKSt3__215__codecvt_utf16IDiLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags, _erfc2: _erfc2, __ZN5physx16NbShapesPropertyC2Ev: __ZN5physx16NbShapesPropertyC2Ev, __ZN4FMOD8ChannelI7setMuteEb: __ZN4FMOD8ChannelI7setMuteEb, __ZN8WindZone5ResetEv: __ZN8WindZone5ResetEv, __Z13RegisterClassI20OcclusionCullingDataEvv: __Z13RegisterClassI20OcclusionCullingDataEvv, __ZN9ShaderLab9SubShader19CreateFromSubShaderERKS0_: __ZN9ShaderLab9SubShader19CreateFromSubShaderERKS0_, __Z29RenderForwardObjectsIntoDepthRK17RenderLoopContextP13RenderTextureP13dynamic_arrayI16RenderObjectDataLj4EE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseESC_iib: __Z29RenderForwardObjectsIntoDepthRK17RenderLoopContextP13RenderTextureP13dynamic_arrayI16RenderObjectDataLj4EE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseESC_iib, __ZNK8Animator20IsAnyRendererVisibleEv: __ZNK8Animator20IsAnyRendererVisibleEv, __ZN13SpringJoint2D6CreateEv: __ZN13SpringJoint2D6CreateEv, __Z39setPxVehicleDifferential4WDataMRearBiasPN5physx27PxVehicleDifferential4WDataEf: __Z39setPxVehicleDifferential4WDataMRearBiasPN5physx27PxVehicleDifferential4WDataEf, __ZN18JointAngleLimits2D8TransferI14SafeBinaryReadEEvRT_: __ZN18JointAngleLimits2D8TransferI14SafeBinaryReadEEvRT_, __Z18Transfer_BlittableI14SafeBinaryReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv, __ZN21InheritVelocityModuleD2Ev: __ZN21InheritVelocityModuleD2Ev, __ZN5physx2Cm8PtrTableD2Ev: __ZN5physx2Cm8PtrTableD2Ev, __Z35setPxParticleBase_MaxMotionDistancePN5physx14PxParticleBaseEf: __Z35setPxParticleBase_MaxMotionDistancePN5physx14PxParticleBaseEf, __Z13RegisterClassI9ProjectorEvv: __Z13RegisterClassI9ProjectorEvv, __Z67Register_UnityEngine_Networking_UnityWebRequest_set_useHttpContinuev: __Z67Register_UnityEngine_Networking_UnityWebRequest_set_useHttpContinuev, __Z39BillboardAsset_CUSTOM_SetImageTexCoordsP12Il2CppObjectP11Il2CppArray: __Z39BillboardAsset_CUSTOM_SetImageTexCoordsP12Il2CppObjectP11Il2CppArray, __Z24ClearRemoteNotificationsv: __Z24ClearRemoteNotificationsv, __Z33IsNonMonoBehaviourUnityEngineTypeP11Il2CppClass: __Z33IsNonMonoBehaviourUnityEngineTypeP11Il2CppClass, __Z53Register_UnityEngine_PhysicsMaterial2D_get_bouncinessv: __Z53Register_UnityEngine_PhysicsMaterial2D_get_bouncinessv, __ZNK7Texture10GetVRUsageEv: __ZNK7Texture10GetVRUsageEv, _UNITY_png_set_compression_window_bits: _UNITY_png_set_compression_window_bits, __Z31Transform_CUSTOM_DetachChildrenP12Il2CppObject: __Z31Transform_CUSTOM_DetachChildrenP12Il2CppObject, __ZN5physx17PxStringTableImpl11allocateStrEPKc: __ZN5physx17PxStringTableImpl11allocateStrEPKc, __Z50Register_UnityEngine_Terrain_get_editorRenderFlagsv: __Z50Register_UnityEngine_Terrain_get_editorRenderFlagsv, __ZN18LoadSceneOperation19IntegrateTimeSlicedEi: __ZN18LoadSceneOperation19IntegrateTimeSlicedEi, __ZN5physx36solveContactPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx36solveContactPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __Z45SkinnedMeshRenderer_Set_Custom_PropSharedMeshP12Il2CppObjectS0_: __Z45SkinnedMeshRenderer_Set_Custom_PropSharedMeshP12Il2CppObjectS0_, __ZN16ScriptingManager24NotifyScriptCacheReleaseEi: __ZN16ScriptingManager24NotifyScriptCacheReleaseEi, __Z55Register_UnityEngine_Terrain_INTERNAL_CALL_SampleHeightv: __Z55Register_UnityEngine_Terrain_INTERNAL_CALL_SampleHeightv, __Z47Register_UnityEngine_Coroutine_ReleaseCoroutinev: __Z47Register_UnityEngine_Coroutine_ReleaseCoroutinev, __Z24Animator_CUSTOM_GetStatsP12Il2CppObject: __Z24Animator_CUSTOM_GetStatsP12Il2CppObject, __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6insertERNS0_2Sc5SceneERS2_: __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6insertERNS0_2Sc5SceneERS2_, __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Determinantv: __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Determinantv, __Z13RegisterClassI15LightProbeGroupEvv: __Z13RegisterClassI15LightProbeGroupEvv, __ZN19ScriptingInvocationC2Ev: __ZN19ScriptingInvocationC2Ev, __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f: __ZNK17SizeBySpeedModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f, __Z38GUI_CUSTOM_InternalRepaintEditorWindowv: __Z38GUI_CUSTOM_InternalRepaintEditorWindowv, __ZNK14b2PolygonShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi: __ZNK14b2PolygonShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj567ENS_22PxRepXPropertyAccessorILj567ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj567ENS_22PxRepXPropertyAccessorILj567ES4_ffEEEEvRKT0_, __ZN10EventEntry7DestroyEP12EventManager: __ZN10EventEntry7DestroyEP12EventManager, __ZN22MotionVectorRenderLoopD2Ev: __ZN22MotionVectorRenderLoopD2Ev, _wcscpy: _wcscpy, __ZN4FMOD7SystemI12createReverbEPPNS_6ReverbE: __ZN4FMOD7SystemI12createReverbEPPNS_6ReverbE, __Z44Register_UnityEngine_CubemapArray_get_formatv: __Z44Register_UnityEngine_CubemapArray_get_formatv, __Z60Register_UnityEngine_GL_INTERNAL_CALL_GetGPUProjectionMatrixv: __Z60Register_UnityEngine_GL_INTERNAL_CALL_GetGPUProjectionMatrixv, __ZN5physx2Gu15OBBTriangleTestC2ERKNS0_3BoxE: __ZN5physx2Gu15OBBTriangleTestC2ERKNS0_3BoxE, _swab: _swab, __ZN8LODGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8LODGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK6b2Body13ShouldCollideEPKS_: __ZNK6b2Body13ShouldCollideEPKS_, __ZN5physx9NpFactory19createNpClothFabricEv: __ZN5physx9NpFactory19createNpClothFabricEv, __ZN12_GLOBAL__N_112UserRenderer20visualizeLinearLimitERKN5physx11PxTransformES4_fb: __ZN12_GLOBAL__N_112UserRenderer20visualizeLinearLimitERKN5physx11PxTransformES4_fb, __ZN17PersistentManager38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier: __ZN17PersistentManager38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier, __ZNSt3__211__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri: __ZNSt3__211__money_getIcE13__gather_infoEbRKNS_6localeERNS_10money_base7patternERcS8_RNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESF_SF_SF_Ri, __ZN5physx2Gu21computeMTD_SphereMeshERNS_6PxVec3ERfRKNS0_6SphereERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu21computeMTD_SphereMeshERNS_6PxVec3ERfRKNS0_6SphereERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE, __ZN14BillboardAsset13AwakeFromLoadE17AwakeFromLoadMode: __ZN14BillboardAsset13AwakeFromLoadE17AwakeFromLoadMode, __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17PackedFloatVector8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN7Cubemap23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN7Cubemap23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx5cloth11BoundingBoxI8Scalar4fEaSERKS3_: __ZN5physx5cloth11BoundingBoxI8Scalar4fEaSERKS3_, _UNITY_FT_Init_Class_tt_cmap0_class_rec: _UNITY_FT_Init_Class_tt_cmap0_class_rec, __ZN5physx12SubSortQuick5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjRNS_10PxBounds3VEj: __ZN5physx12SubSortQuick5sort4EPjjRNS_6shdfnd5ArrayINS_11RTreeNodeNQENS2_19ReflectionAllocatorIS4_EEEERjRNS_10PxBounds3VEj, __Z37Register_UnityEngine_Screen_get_widthv: __Z37Register_UnityEngine_Screen_get_widthv, __ZNK5Umbra18ImpOcclusionBuffer8dump8bppEPhRKNS_15OcclusionBuffer10BufferDescE: __ZNK5Umbra18ImpOcclusionBuffer8dump8bppEPhRKNS_15OcclusionBuffer10BufferDescE, __Z22PerformPlaneCollisionsRK13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesRK33ParticleSystemCollisionParametersR5RandNRKf: __Z22PerformPlaneCollisionsRK13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesRK33ParticleSystemCollisionParametersR5RandNRKf, __ZN9GfxDevice19FlipRectForViewportER5RectTIiEi: __ZN9GfxDevice19FlipRectForViewportER5RectTIiEi, __ZN12_GLOBAL__N_113generateConesEPN5physx5cloth8ConeDataEPKNS1_10SphereDataEPKNS1_9IndexPairEj: __ZN12_GLOBAL__N_113generateConesEPN5physx5cloth8ConeDataEPKNS1_10SphereDataEPKNS1_9IndexPairEj, __ZN18SpeedTreeWindAssetC2E10MemLabelId18ObjectCreationMode: __ZN18SpeedTreeWindAssetC2E10MemLabelId18ObjectCreationMode, __ZN22BlockMemoryCacheWriter11GetPathNameEv: __ZN22BlockMemoryCacheWriter11GetPathNameEv, __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN4math4trsXEEEvRT_PKc17TransferMetaFlags, __ZN14PhysicsManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN14PhysicsManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN6Avatar23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Avatar23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx25PxVehicleConstraintShader36vehicleSuspLimitConstraintSolverPrepEPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvRKNS_11PxTransformESB_: __ZN5physx25PxVehicleConstraintShader36vehicleSuspLimitConstraintSolverPrepEPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvRKNS_11PxTransformESB_, __ZN11SoundHandle8Instance22ReleaseIfNotReferencedEv: __ZN11SoundHandle8Instance22ReleaseIfNotReferencedEv, __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetInertiaTensorv: __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_ResetInertiaTensorv, __ZNSt3__212system_errorC2ENS_10error_codeEPKc: __ZNSt3__212system_errorC2ENS_10error_codeEPKc, __ZN18ScriptingArguments18AddScriptingStringEP12Il2CppString: __ZN18ScriptingArguments18AddScriptingStringEP12Il2CppString, __ZN13WheelCollider13AwakeFromLoadE17AwakeFromLoadMode: __ZN13WheelCollider13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE: __ZN5physx7NpActor14onActorReleaseEPNS_7PxActorE, __Z56Register_UnityEngine_TrailRenderer_set_numCornerVerticesv: __Z56Register_UnityEngine_TrailRenderer_set_numCornerVerticesv, _UNITY_png_reset_zstream: _UNITY_png_reset_zstream, __Z33AnimatorControllerParameterToMonoRK27AnimatorControllerParameterR31MonoAnimatorControllerParameter: __Z33AnimatorControllerParameterToMonoRK27AnimatorControllerParameterR31MonoAnimatorControllerParameter, __ZN5physx3Cct26CharacterControllerManager19computeInteractionsEfPNS_26PxControllerFilterCallbackE: __ZN5physx3Cct26CharacterControllerManager19computeInteractionsEfPNS_26PxControllerFilterCallbackE, _append: _append, __ZN8Playable18SetInputConnectionEPS_i: __ZN8Playable18SetInputConnectionEPS_i, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, __ZN6HelperI19StreamedBinaryWriteILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI19StreamedBinaryWriteILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __ZN25SingleBlockMemoryFileData4LockEPPv: __ZN25SingleBlockMemoryFileData4LockEPPv, __ZN12HandlerChain5TouchER13FileEntryData: __ZN12HandlerChain5TouchER13FileEntryData, __ZN8LODGroup19SyncLODGroupManagerEv: __ZN8LODGroup19SyncLODGroupManagerEv, __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj, __ZN17PersistentManager23PostReadActivationQueueEiPK8TypeTreeb: __ZN17PersistentManager23PostReadActivationQueueEiPK8TypeTreeb, __ZN15ParticleEmitter9TimedEmitEf: __ZN15ParticleEmitter9TimedEmitEf, __Z32RectOffset_Get_Custom_PropBottomP12Il2CppObject: __Z32RectOffset_Get_Custom_PropBottomP12Il2CppObject, __Z19SplatPrototypeToCppRK18MonoSplatPrototypeR14SplatPrototype: __Z19SplatPrototypeToCppRK18MonoSplatPrototypeR14SplatPrototype, __ZN9InputAxis9DoGravityEf: __ZN9InputAxis9DoGravityEf, _freeifaddrs: _freeifaddrs, __Z54Register_UnityEngine_RelativeJoint2D_get_angularOffsetv: __Z54Register_UnityEngine_RelativeJoint2D_get_angularOffsetv, __Z40Register_UnityEngine_Material_SetTexturev: __Z40Register_UnityEngine_Material_SetTexturev, _stat: _stat, __Z65Register_UnityEngine_AnimatorUtility_DeoptimizeTransformHierarchyv: __Z65Register_UnityEngine_AnimatorUtility_DeoptimizeTransformHierarchyv, __Z57Register_UnityEngine_TerrainData_get_alphamapTextureCountv: __Z57Register_UnityEngine_TerrainData_get_alphamapTextureCountv, __ZN5physx7NpCloth24sendPvdMotionConstraintsEv: __ZN5physx7NpCloth24sendPvdMotionConstraintsEv, __ZN11UnityEngine9Analytics16TransactionEventD2Ev: __ZN11UnityEngine9Analytics16TransactionEventD2Ev, __ZN23iPhoneLocalNotification17SetRepeatIntervalEj: __ZN23iPhoneLocalNotification17SetRepeatIntervalEj, __ZN15b2DistanceJoint23InitVelocityConstraintsERK12b2SolverData: __ZN15b2DistanceJoint23InitVelocityConstraintsERK12b2SolverData, __ZN7ApiGLES16SetPatchVerticesEi: __ZN7ApiGLES16SetPatchVerticesEi, __ZN5physx2Gu21findUniqueConvexEdgesEjPNS0_10ConvexEdgeEjPKNS0_15HullPolygonDataEPKh: __ZN5physx2Gu21findUniqueConvexEdgesEjPNS0_10ConvexEdgeEjPKNS0_15HullPolygonDataEPKh, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj161ES2_RKNS_12PxFilterDataES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj161ES2_RKNS_12PxFilterDataES6_EEEEvjRT_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags, __ZN10HumanTrait10LeftFinger10IsLeftHandEv: __ZN10HumanTrait10LeftFinger10IsLeftHandEv, __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb, _tre_set_one: _tre_set_one, __ZNSt3__211__stdoutbufIwE5imbueERKNS_6localeE: __ZNSt3__211__stdoutbufIwE5imbueERKNS_6localeE, __Z38Animation_CUSTOM_Internal_RewindByNameP12Il2CppObjectP12Il2CppString: __Z38Animation_CUSTOM_Internal_RewindByNameP12Il2CppObjectP12Il2CppString, __Z37Rigidbody_CUSTOM_INTERNAL_CALL_WakeUpP12Il2CppObject: __Z37Rigidbody_CUSTOM_INTERNAL_CALL_WakeUpP12Il2CppObject, __ZN5physx9NpFactory25createNpArticulationJointERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_: __ZN5physx9NpFactory25createNpArticulationJointERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_, __ZN9Rigidbody18ResetInertiaTensorEv: __ZN9Rigidbody18ResetInertiaTensorEv, __ZN5physx43solveContactCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx43solveContactCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN5physx3Ext20DefaultCpuDispatcher6getJobEv: __ZN5physx3Ext20DefaultCpuDispatcher6getJobEv, __Z29Texture2D_CUSTOM_PackTexturesP12Il2CppObjectP11Il2CppArrayiih: __Z29Texture2D_CUSTOM_PackTexturesP12Il2CppObjectP11Il2CppArrayiih, __ZN16ParticleAnimator12CleanupClassEv: __ZN16ParticleAnimator12CleanupClassEv, __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEEC2ERNS_7profile12ProfileArrayINS0_14NameStackEntryEEERNS_9XmlWriterEPKS2_RNS_12MemoryBufferERNS_12PxCollectionEPNS4_14ProfileHashMapIKyPKNS_18PxArticulationLinkENS_6shdfnd4HashISI_EEEE: __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEEC2ERNS_7profile12ProfileArrayINS0_14NameStackEntryEEERNS_9XmlWriterEPKS2_RNS_12MemoryBufferERNS_12PxCollectionEPNS4_14ProfileHashMapIKyPKNS_18PxArticulationLinkENS_6shdfnd4HashISI_EEEE, __ZN10CastFilterD0Ev: __ZN10CastFilterD0Ev, __ZN4FMOD7ReverbI15get3DAttributesEP11FMOD_VECTORPfS3_: __ZN4FMOD7ReverbI15get3DAttributesEP11FMOD_VECTORPfS3_, __ZN5physx2Sc5Scene23allocateConstraintBlockEj: __ZN5physx2Sc5Scene23allocateConstraintBlockEj, __ZN16ParticleRendererC2E10MemLabelId18ObjectCreationMode: __ZN16ParticleRendererC2E10MemLabelId18ObjectCreationMode, __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Transform25CompleteTransformTransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN16ScriptingManager14CreateInstanceEP11Il2CppClass: __ZN16ScriptingManager14CreateInstanceEP11Il2CppClass, __Z43Register_UnityEngine_GameObject_SendMessagev: __Z43Register_UnityEngine_GameObject_SendMessagev, __Z55Register_UnityEngine_RectTransform_get_drivenPropertiesv: __Z55Register_UnityEngine_RectTransform_get_drivenPropertiesv, __ZNKSt3__27codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_: __ZNKSt3__27codecvtIDic11__mbstate_tE6do_outERS1_PKDiS5_RS5_PcS7_RS7_, _UNITY_png_get_y_offset_microns: _UNITY_png_get_y_offset_microns, __ZN11AudioSourceD0Ev: __ZN11AudioSourceD0Ev, __ZN5physx2Sc5Actor15onElementDetachERNS0_7ElementE: __ZN5physx2Sc5Actor15onElementDetachERNS0_7ElementE, __ZN14NavMeshManager23InitializeCarvingSystemEv: __ZN14NavMeshManager23InitializeCarvingSystemEv, __ZNK8Material9GetShaderEv: __ZNK8Material9GetShaderEv, __ZN16MemoryFileSystem4NameEv: __ZN16MemoryFileSystem4NameEv, __ZN15ReflectionProbe8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15ReflectionProbe8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN28HasInvalidBehaviourPredicateclERK4PPtrI13MonoBehaviourE: __ZN28HasInvalidBehaviourPredicateclERK4PPtrI13MonoBehaviourE, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIyyEEPyEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIyyEEPyEEbT0_S5_T_, __ZN11AudioSource16UpdateParametersE12SoundChannel: __ZN11AudioSource16UpdateParametersE12SoundChannel, __ZN4gles19GetProcAddress_coreEPKc: __ZN4gles19GetProcAddress_coreEPKc, __Z37Canvas_Set_Custom_PropOverrideSortingP12Il2CppObjecth: __Z37Canvas_Set_Custom_PropOverrideSortingP12Il2CppObjecth, __ZNK8GUIStyle8CalcSizeER10GUIContent: __ZNK8GUIStyle8CalcSizeER10GUIContent, __ZNK11Rigidbody2D16IsTouchingLayersEi: __ZNK11Rigidbody2D16IsTouchingLayersEi, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEv, __ZN5physx3Cct13BoxController13setHalfHeightEf: __ZN5physx3Cct13BoxController13setHalfHeightEf, __ZNK5physx7NpCloth13getRestOffsetEv: __ZNK5physx7NpCloth13getRestOffsetEv, __ZN11NoiseModule13AwakeFromLoadEv: __ZN11NoiseModule13AwakeFromLoadEv, __ZN5physx3Scb13ObjectTracker5clearEv: __ZN5physx3Scb13ObjectTracker5clearEv, _UNITY_FT_New_Size: _UNITY_FT_New_Size, __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs: __Z42ScriptingGetComponentsOfTypeFromGameObjectRK26ScriptingGetComponentsArgs, __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewDoubleArrayv: __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewDoubleArrayv, __ZL28GeomMTDCallback_PlaneCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL28GeomMTDCallback_PlaneCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z46TrailRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject: __Z46TrailRenderer_Get_Custom_PropNumCornerVerticesP12Il2CppObject, __Z51Register_UnityEngine_CharacterController_get_heightv: __Z51Register_UnityEngine_CharacterController_get_heightv, __ZNKSt3__26locale9use_facetERNS0_2idE: __ZNKSt3__26locale9use_facetERNS0_2idE, __ZL23GeomMTDCallback_BoxMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL23GeomMTDCallback_BoxMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, _fegetenv: _fegetenv, __ZN13b2DynamicTree11ShiftOriginERK6b2Vec2: __ZN13b2DynamicTree11ShiftOriginERK6b2Vec2, __Z51Register_UnityEngine_AndroidJNI_GetCharArrayElementv: __Z51Register_UnityEngine_AndroidJNI_GetCharArrayElementv, __Z39Collider2D_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfiff: __Z39Collider2D_CUSTOM_INTERNAL_CALL_RaycastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfiff, __ZN13GfxDeviceNull13SetViewMatrixERK10Matrix4x4f: __ZN13GfxDeviceNull13SetViewMatrixERK10Matrix4x4f, __ZN13WheelCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13WheelCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZN35ClampVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN35ClampVelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZNK5physx7NpCloth22getNbCollisionCapsulesEv: __ZNK5physx7NpCloth22getNbCollisionCapsulesEv, __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_: __ZNSt3__27__sort4IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_T_, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_, __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb1EEEvRPT_PKcRjS9_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb1EEEvRPT_PKcRjS9_RT0_, _tcflush: _tcflush, _Line_Up: _Line_Up, __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorINS_10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEE: __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorINS_10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEE, __Z44Canvas_CUSTOM_GetETC1SupportedCanvasMaterialv: __Z44Canvas_CUSTOM_GetETC1SupportedCanvasMaterialv, __Z50ParticleSystem_ShapeModule_CUSTOM_GetMeshShapeTypeP12Il2CppObject: __Z50ParticleSystem_ShapeModule_CUSTOM_GetMeshShapeTypeP12Il2CppObject, __Z26NavMeshAgent_CUSTOM_ResumeP12Il2CppObject: __Z26NavMeshAgent_CUSTOM_ResumeP12Il2CppObject, __Z43Register_UnityEngine_Animator_GetLayerIndexv: __Z43Register_UnityEngine_Animator_GetLayerIndexv, __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv: __ZNK13Simd4fFactoryIN6detail9FourTupleEEcv8Scalar4fEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4crnd10crnd_traceEPKcz: __ZN4crnd10crnd_traceEPKcz, __ZN5physx24PxcArticulationFnsScalar13invertInertiaERKNS_9SpInertiaE: __ZN5physx24PxcArticulationFnsScalar13invertInertiaERKNS_9SpInertiaE, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpShapeEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpShapeEEEEEE15growAndPushBackERKS2_, __ZlsRK8Scalar4fi: __ZlsRK8Scalar4fi, __Z10GetGravityi: __Z10GetGravityi, __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z17CalculateGlobalRS23TransformAccessReadOnly: __Z17CalculateGlobalRS23TransformAccessReadOnly, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7releaseEv: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7releaseEv, __Z36Projector_Get_Custom_PropAspectRatioP12Il2CppObject: __Z36Projector_Get_Custom_PropAspectRatioP12Il2CppObject, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E6getDirEv, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToShortArrayv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToShortArrayv, __ZN23UnityPurchasingSettings10InitializeER6Object: __ZN23UnityPurchasingSettings10InitializeER6Object, _unity_z_deflateReset: _unity_z_deflateReset, __ZN5physx2Sc19ContactReportBuffer23reallocateNotThreadSafeEjRjjj: __ZN5physx2Sc19ContactReportBuffer23reallocateNotThreadSafeEjRjjj, _pipe2: _pipe2, __Z50Register_UnityEngine_Light_RemoveAllCommandBuffersv: __Z50Register_UnityEngine_Light_RemoveAllCommandBuffersv, __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __ZN5Umbra9crc32HashEPKhj: __ZN5Umbra9crc32HashEPKhj, __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE: __ZN5physx2Sc5Actor19registerInteractionEPNS0_11InteractionE, __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb1EEEEvRT_, _LzmaDec_DecodeToDic: _LzmaDec_DecodeToDic, __ZN22MemoryCacherReadBlocks14LockCacheBlockEjPPhS1_: __ZN22MemoryCacherReadBlocks14LockCacheBlockEjPPhS1_, __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12resize_deltaEjj, __Z43Physics2D_Set_Custom_PropVelocityIterationsi: __Z43Physics2D_Set_Custom_PropVelocityIterationsi, _decompress_onepass: _decompress_onepass, __ZN17ArchiveFileSystem24UnmountArchiveFromMemoryEPKv: __ZN17ArchiveFileSystem24UnmountArchiveFromMemoryEPKv, __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_119parse_template_argsINS0_2DbEEEPKcS4_S4_RT_, __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE: __ZN20TextRenderingPrivate8FontImpl16CacheFontForTextEPtiifjPK13dynamic_arrayINS_16TextFormatChangeELj4EE, __Z37BillboardAsset_CUSTOM_Internal_CreateP12Il2CppObject: __Z37BillboardAsset_CUSTOM_Internal_CreateP12Il2CppObject, __ZN13PhysicsModule19CreateNxHeightFieldEPv: __ZN13PhysicsModule19CreateNxHeightFieldEPv, __Z43Rigidbody_Set_Custom_PropMaxAngularVelocityP12Il2CppObjectf: __Z43Rigidbody_Set_Custom_PropMaxAngularVelocityP12Il2CppObjectf, __Z44Register_UnityEngine_Mathf_ClosestPowerOfTwov: __Z44Register_UnityEngine_Mathf_ClosestPowerOfTwov, __Z31GL_Get_Custom_PropInvertCullingv: __Z31GL_Get_Custom_PropInvertCullingv, __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_worldRotationAxisv: __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_worldRotationAxisv, __ZN5physx3Ext7D6Joint28setProjectionLinearToleranceEf: __ZN5physx3Ext7D6Joint28setProjectionLinearToleranceEf, __ZN17PhysicsMaterial2D16CheckConsistencyEv: __ZN17PhysicsMaterial2D16CheckConsistencyEv, __ZN5physx3Scb5Shape17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb5Shape17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEjc, __Z13TransferFieldI18StreamedBinaryReadILb0EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI18StreamedBinaryReadILb0EELb0E16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __ZN5physx15NpParticleFluid2isENS_11PxActorType4EnumE: __ZN5physx15NpParticleFluid2isENS_11PxActorType4EnumE, __Z27Random_Get_Custom_PropValuev: __Z27Random_Get_Custom_PropValuev, __Z48setPxVehicleDriveSimData4W_AckermannGeometryDataPN5physx23PxVehicleDriveSimData4WERKNS_30PxVehicleAckermannGeometryDataE: __Z48setPxVehicleDriveSimData4W_AckermannGeometryDataPN5physx23PxVehicleDriveSimData4WERKNS_30PxVehicleAckermannGeometryDataE, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11setGridSizeEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11setGridSizeEf, __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8MonoPPtr13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j, __Z59Register_UnityEngine_ParticleSystem_LightsModule_SetEnabledv: __Z59Register_UnityEngine_ParticleSystem_LightsModule_SetEnabledv, __ZN39AssetBundleLoadFromStreamAsyncOperation11GetProgressEv: __ZN39AssetBundleLoadFromStreamAsyncOperation11GetProgressEv, __Z30getPxCloth_SleepLinearVelocityPKN5physx7PxClothE: __Z30getPxCloth_SleepLinearVelocityPKN5physx7PxClothE, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewByteArrayiRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewByteArrayiRPv, __Z49Register_UnityEngine_AudioSource_get_spatialBlendv: __Z49Register_UnityEngine_AudioSource_get_spatialBlendv, __Z62ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveMultiplierP12Il2CppObjectf: __Z62ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveMultiplierP12Il2CppObjectf, __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7Hash1288TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11UnityEngine7Connect16PersistentValuesC2Ev: __ZN11UnityEngine7Connect16PersistentValuesC2Ev, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16collideParticlesEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16collideParticlesEv, __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __Z50Renderer_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_: __Z50Renderer_CUSTOM_GetClosestReflectionProbesInternalP12Il2CppObjectS0_, __ZNSt3__218shared_timed_mutex13unlock_sharedEv: __ZNSt3__218shared_timed_mutex13unlock_sharedEv, __ZN13EmscriptenWWW10OnProgressEPvjj: __ZN13EmscriptenWWW10OnProgressEPvjj, __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5audio5mixer14SetWeightedMixERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEPiPfif: __ZN5audio5mixer14SetWeightedMixERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEPiPfif, __ZNK5physx2Sc7BodySim13isConnectedToERKNS0_8RigidSimERb: __ZNK5physx2Sc7BodySim13isConnectedToERKNS0_8RigidSimERb, __ZNK5Umbra4AABB10getPlaneEqEi: __ZNK5Umbra4AABB10getPlaneEqEi, __ZNK14BillboardAsset9GetBottomEv: __ZNK14BillboardAsset9GetBottomEv, __Z54RenderSettings_CUSTOM_INTERNAL_set_ambientEquatorColorRK10ColorRGBAf: __Z54RenderSettings_CUSTOM_INTERNAL_set_ambientEquatorColorRK10ColorRGBAf, __ZN14RenderSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14RenderSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z24CrowdUpdateMultiThreadedRK17ReadonlyCrowdInfoR15UpdateCrowdInfoP7dtCrowdf: __Z24CrowdUpdateMultiThreadedRK17ReadonlyCrowdInfoR15UpdateCrowdInfoP7dtCrowdf, __ZN14PhysicsManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14PhysicsManager23VirtualRedirectTransferER17RemapPPtrTransfer, __Z32Shader_Set_Custom_PropMaximumLODP12Il2CppObjecti: __Z32Shader_Set_Custom_PropMaximumLODP12Il2CppObjecti, __ZN7mecanim5human20RetargetFromTDoFBaseEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3E: __ZN7mecanim5human20RetargetFromTDoFBaseEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3E, __Z39Light_Set_Custom_PropAlreadyLightmappedP12Il2CppObjecth: __Z39Light_Set_Custom_PropAlreadyLightmappedP12Il2CppObjecth, __Z10dictDeleteP4DictP8DictNode: __Z10dictDeleteP4DictP8DictNode, __ZN10systeminfo25GetPhysicalProcessorCountEv: __ZN10systeminfo25GetPhysicalProcessorCountEv, _longest_match_fast: _longest_match_fast, __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z20GetPathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx13BigConvexData15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx13BigConvexData15importExtraDataERNS_24PxDeserializationContextE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12createObjectERPhRNS_24PxDeserializationContextE, __Z26profiler_unregister_objectP6Object: __Z26profiler_unregister_objectP6Object, __ZN8GUIStyle14SetDefaultFontEPN13TextRendering4FontE: __ZN8GUIStyle14SetDefaultFontEPN13TextRendering4FontE, __ZN14SoundHandleAPI7SetDataEPKfjj: __ZN14SoundHandleAPI7SetDataEPKfjj, __ZN15QualitySettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15QualitySettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi52EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi52EEEEvRT_17TransferMetaFlags, __ZNK5Umbra14TomeCollection16getGateStateSizeEv: __ZNK5Umbra14TomeCollection16getGateStateSizeEv, __ZN8Collider22FetchPoseFromTransformEv: __ZN8Collider22FetchPoseFromTransformEv, __ZN5Umbra9FloatList11setCapacityEi: __ZN5Umbra9FloatList11setCapacityEi, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjPKjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSI_5Vec3VE: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjPKjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSI_5Vec3VE, __Z50Register_UnityEngine_TextGenerator_get_vertexCountv: __Z50Register_UnityEngine_TextGenerator_get_vertexCountv, __Z18SetNbBroadPhaseAddPN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj: __Z18SetNbBroadPhaseAddPN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj, __Z59Register_UnityEngine_MonoBehaviour_Internal_CancelInvokeAllv: __Z59Register_UnityEngine_MonoBehaviour_Internal_CancelInvokeAllv, __Z29InitializeMemoryProfilerStatsv: __Z29InitializeMemoryProfilerStatsv, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE9set_rdbufEPNS_15basic_streambufIcS2_EE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE9set_rdbufEPNS_15basic_streambufIcS2_EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags, __Z47Register_UnityEngine_Cloth_get_capsuleCollidersv: __Z47Register_UnityEngine_Cloth_get_capsuleCollidersv, __ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE: __ZNK16OBBAABBTest_SIMDclERKN5physx2Sq9BucketBoxE, __ZZN10Collider2D15InitializeClassEvEN33FunctorImpl_82kDidRemoveComponent4CallEPviR11MessageData: __ZZN10Collider2D15InitializeClassEvEN33FunctorImpl_82kDidRemoveComponent4CallEPviR11MessageData, __ZN5audio5mixer16GetSnapshotIndexERNS0_18AudioMixerConstantEPKc: __ZN5audio5mixer16GetSnapshotIndexERNS0_18AudioMixerConstantEPKc, __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7Texture8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z25Mathf_CUSTOM_IsPowerOfTwoi: __Z25Mathf_CUSTOM_IsPowerOfTwoi, __ZN13GfxDeviceNull5ClearEjRK10ColorRGBAffj: __ZN13GfxDeviceNull5ClearEjRK10ColorRGBAffj, __Z16PackTextureAtlasP9Texture2DiiPS0_P5RectTIfEiNS_10EInitFlagsE: __Z16PackTextureAtlasP9Texture2DiiPS0_P5RectTIfEiNS_10EInitFlagsE, __Z13RegisterClassI13AudioListenerEvv: __Z13RegisterClassI13AudioListenerEvv, __ZN23AnimationOffsetPlayable11GetPositionEv: __ZN23AnimationOffsetPlayable11GetPositionEv, __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNK5Umbra9Matrix2x28getScaleEv: __ZNK5Umbra9Matrix2x28getScaleEv, __Z45RectTransform_Set_Custom_PropDrivenPropertiesP12Il2CppObjectN2UI13RectTransform16DrivenPropertiesE: __Z45RectTransform_Set_Custom_PropDrivenPropertiesP12Il2CppObjectN2UI13RectTransform16DrivenPropertiesE, __Z45Input_Set_Custom_PropSimulateMouseWithTouchesh: __Z45Input_Set_Custom_PropSimulateMouseWithTouchesh, __ZN4FMOD4DSPI11getDefaultsEPfS1_S1_Pi: __ZN4FMOD4DSPI11getDefaultsEPfS1_S1_Pi, __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEbT0_SD_T_: __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEbT0_SD_T_, __ZN5physx8debugger4comm15NameHandleValueD0Ev: __ZN5physx8debugger4comm15NameHandleValueD0Ev, __ZNK5physx27PxsFluidParticleOpcodeCache4readERtRjPjRKNS_9PxBounds3ERKNS0_18QuantizationParamsEPKNS_2Gu13GeometryUnionEb: __ZNK5physx27PxsFluidParticleOpcodeCache4readERtRjPjRKNS_9PxBounds3ERKNS0_18QuantizationParamsEPKNS_2Gu13GeometryUnionEb, __ZN22ParticleSystemRenderer5ResetEv: __ZN22ParticleSystemRenderer5ResetEv, _UNITY_png_get_cHRM_XYZ: _UNITY_png_get_cHRM_XYZ, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9showmanycEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9showmanycEv, __ZN16RayRTreeCallbackILi0ELb1EED2Ev: __ZN16RayRTreeCallbackILi0ELb1EED2Ev, __ZN5physx14PxsAABBManager14promoteBitmapsEPNS_9AggregateE: __ZN5physx14PxsAABBManager14promoteBitmapsEPNS_9AggregateE, __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii: __Z13WriteIntArrayR13dynamic_arrayIiLj4EEPii, __ZorRK8Scalar4fS1_: __ZorRK8Scalar4fS1_, __ZN14SphereCollider10SmartResetEv: __ZN14SphereCollider10SmartResetEv, __ZN10GUIManager26ProcessEventForCursorFlashERK10InputEvent: __ZN10GUIManager26ProcessEventForCursorFlashERK10InputEvent, __Z44RenderTexture_CUSTOM_SetGlobalShaderPropertyP12Il2CppObjectP12Il2CppString: __Z44RenderTexture_CUSTOM_SetGlobalShaderPropertyP12Il2CppObjectP12Il2CppString, __Z46RenderTexture_CUSTOM_Internal_SetSRGBReadWriteP12Il2CppObjecth: __Z46RenderTexture_CUSTOM_Internal_SetSRGBReadWriteP12Il2CppObjecth, __ZN19AudioHighPassFilterC2E10MemLabelId18ObjectCreationMode: __ZN19AudioHighPassFilterC2E10MemLabelId18ObjectCreationMode, __ZN20SoundChannelInstance19setReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES: __ZN20SoundChannelInstance19setReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_10ShrunkBoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_10ShrunkBoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __Z66Register_UnityEngine_Experimental_Director_Playable_InternalCreatev: __Z66Register_UnityEngine_Experimental_Director_Playable_InternalCreatev, __Z36NavMeshObstacle_Set_Custom_PropShapeP12Il2CppObject20NavMeshObstacleShape: __Z36NavMeshObstacle_Set_Custom_PropShapeP12Il2CppObject20NavMeshObstacleShape, __ZNSt3__212strstreambuf6__initEPciS1_: __ZNSt3__212strstreambuf6__initEPciS1_, __Z44ParticleSystem_NoiseModule_CUSTOM_GetEnabledP12Il2CppObject: __Z44ParticleSystem_NoiseModule_CUSTOM_GetEnabledP12Il2CppObject, __Z17createBucketAllocP9TESSallocPKcjj: __Z17createBucketAllocP9TESSallocPKcjj, __Z46UnityWebRequest_Set_Custom_PropUseHttpContinueP12Il2CppObjecth: __Z46UnityWebRequest_Set_Custom_PropUseHttpContinueP12Il2CppObjecth, __ZNKSt3__215__codecvt_utf16IDiLb1EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IDiLb1EE13do_max_lengthEv, __ZNK26AnimatorControllerPlayable14IsInTransitionEi: __ZNK26AnimatorControllerPlayable14IsInTransitionEi, __Z40Register_UnityEngine_Transform_IsChildOfv: __Z40Register_UnityEngine_Transform_IsChildOfv, __Z61Register_UnityEngine_ParticleSystem_TriggerModule_GetColliderv: __Z61Register_UnityEngine_ParticleSystem_TriggerModule_GetColliderv, __ZN5physx6shdfnd9atomicAddEPVii: __ZN5physx6shdfnd9atomicAddEPVii, __ZN5physx2Sn5ConvX9convert32EPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX9convert32EPKcRKNS0_15PxMetaDataEntryES6_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE8pushNameEPKc, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi24EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi24EEEEvRT_17TransferMetaFlags, __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_: __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE7reserveEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE7reserveEj, __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN9GfxDevice31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj: __ZN9GfxDevice31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj, __ZNK5physx14SingleAABBTask25updateNumFastMovingShapesEv: __ZNK5physx14SingleAABBTask25updateNumFastMovingShapesEv, __ZNK27AnimatorControllerParameter7GetTypeEv: __ZNK27AnimatorControllerParameter7GetTypeEv, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S6_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __Z46GUIStyle_CUSTOM_Internal_DrawWithTextSelectionP12Il2CppObjectR43MonoInternal_DrawWithTextSelectionArguments: __Z46GUIStyle_CUSTOM_Internal_DrawWithTextSelectionP12Il2CppObjectR43MonoInternal_DrawWithTextSelectionArguments, _UNITY_png_get_io_state: _UNITY_png_get_io_state, __Z52Register_UnityEngine_AudioReverbZone_get_maxDistancev: __Z52Register_UnityEngine_AudioReverbZone_get_maxDistancev, __ZNSt3__218__insertion_sort_3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_, __ZN5physx17ConvexMeshBuilder16computeGaussMapsEv: __ZN5physx17ConvexMeshBuilder16computeGaussMapsEv, __ZN24BuiltinShaderParamValuesC2Ev: __ZN24BuiltinShaderParamValuesC2Ev, __ZN8JSONRead8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlagsb, __Z24SplashScreen_CUSTOM_Drawv: __Z24SplashScreen_CUSTOM_Drawv, __ZN11TimeManager6UpdateEv: __ZN11TimeManager6UpdateEv, __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AxisAnglev: __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AxisAnglev, __ZNK5physx2Sc16ArticulationCore22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_: __ZNK5physx2Sc16ArticulationCore22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_, __ZN5physx21PxsBodyTransformVaultC2Ev: __ZN5physx21PxsBodyTransformVaultC2Ev, __ZN19AssetBundleManifest7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN19AssetBundleManifest7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNKSt3__210moneypunctIcLb0EE10pos_formatEv: __ZNKSt3__210moneypunctIcLb0EE10pos_formatEv, __ZN9GfxDevice12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj: __ZN9GfxDevice12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj, __ZL6IsInYZffPPK10VertexInfo: __ZL6IsInYZffPPK10VertexInfo, __ZN5physx19TriangleMeshBuilderD0Ev: __ZN5physx19TriangleMeshBuilderD0Ev, _fflush: _fflush, __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings: __ZN17LightProbeContext4InitERK16LightmapSettingsRK14RenderSettings, __ZN23TransformChangeDispatchC2Ev: __ZN23TransformChangeDispatchC2Ev, __Z47Register_UnityEngine_AnimationClip_get_wrapModev: __Z47Register_UnityEngine_AnimationClip_get_wrapModev, __ZN4FMOD6System15getPluginHandleE15FMOD_PLUGINTYPEiPj: __ZN4FMOD6System15getPluginHandleE15FMOD_PLUGINTYPEiPj, __ZNK29ParticleSystemPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK29ParticleSystemPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __ZNK13MonoBehaviour30ShouldRunStateMachineBehaviourEv: __ZNK13MonoBehaviour30ShouldRunStateMachineBehaviourEv, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN9Texture3DD2Ev: __ZN9Texture3DD2Ev, __Z39ParticleSystem_Set_Custom_PropStartSizeP12Il2CppObjectf: __Z39ParticleSystem_Set_Custom_PropStartSizeP12Il2CppObjectf, __ZN18GfxFramebufferGLES13ApplyViewportEv: __ZN18GfxFramebufferGLES13ApplyViewportEv, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYMultiplierv, __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10ColorRGBAf8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15ParticleEmitter12CleanupClassEv: __ZN15ParticleEmitter12CleanupClassEv, __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE: __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugArrowE, __ZN15SerializeTraitsIN9SubModule14SubEmitterDataEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN9SubModule14SubEmitterDataEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags, __ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_: __ZN23CompareReflectionProbesclI24ReflectionProbeBlendInfoEEbRKT_S4_, __ZN8Playable15GetTypeInstanceEv: __ZN8Playable15GetTypeInstanceEv, __Z34ProcessIndexListIsNodeVisibleStep2RK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList: __Z34ProcessIndexListIsNodeVisibleStep2RK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList, __ZN10MonoScriptD2Ev: __ZN10MonoScriptD2Ev, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatBGRA8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatBGRA8888EEvPKNS_9InnerInfoE, __Z38ParticleEmitter_Get_Custom_PropEnabledP12Il2CppObject: __Z38ParticleEmitter_Get_Custom_PropEnabledP12Il2CppObject, __Z26setPxTolerancesScaleLengthPN5physx17PxTolerancesScaleEf: __Z26setPxTolerancesScaleLengthPN5physx17PxTolerancesScaleEf, __GLOBAL__sub_I_half_cpp: __GLOBAL__sub_I_half_cpp, __Z39Input_CUSTOM_INTERNAL_get_mousePositionP8Vector3f: __Z39Input_CUSTOM_INTERNAL_get_mousePositionP8Vector3f, _tt_cmap13_char_next: _tt_cmap13_char_next, __ZN9ShaderLab4Pass16SetupPassOptionsEv: __ZN9ShaderLab4Pass16SetupPassOptionsEv, __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject: __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject, __Z55SceneManager_CUSTOM_INTERNAL_CALL_MoveGameObjectToSceneP12Il2CppObjectRKi: __Z55SceneManager_CUSTOM_INTERNAL_CALL_MoveGameObjectToSceneP12Il2CppObjectRKi, __ZN13GfxDeviceGLES23MemoryBarrierBeforeDrawEyN2gl17MemoryBarrierTypeE: __ZN13GfxDeviceGLES23MemoryBarrierBeforeDrawEyN2gl17MemoryBarrierTypeE, __ZN5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEED0Ev: __ZN5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEED0Ev, __ZN5physx18RepXSerializerImplINS_11PxAggregateEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_11PxAggregateEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z55Register_UnityEngine_Material_Internal_CreateWithStringv: __Z55Register_UnityEngine_Material_Internal_CreateWithStringv, __ZNKSt3__27codecvtIDsc11__mbstate_tE16do_always_noconvEv: __ZNKSt3__27codecvtIDsc11__mbstate_tE16do_always_noconvEv, __Z61Register_UnityEngineInternal_GIDebugVisualisation_set_texTypev: __Z61Register_UnityEngineInternal_GIDebugVisualisation_set_texTypev, __Z47Register_UnityEngine_ConstantForce2D_set_torquev: __Z47Register_UnityEngine_ConstantForce2D_set_torquev, __ZN5physx16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE8pushBackEv: __ZN5physx16PxsCCDBlockArrayINS_13PxsCCDOverlapELi128EE8pushBackEv, __Z31AndroidJNI_CUSTOM_GetFloatField13Il2Cpp_IntPtrS_: __Z31AndroidJNI_CUSTOM_GetFloatField13Il2Cpp_IntPtrS_, __ZNK15TerrainRenderer8GetIndexEiii: __ZNK15TerrainRenderer8GetIndexEiii, __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb: __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEPKNS_12basic_stringIwS3_NS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SE_SD_SD_RKT1_Rjb, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z21Resources_CUSTOM_LoadP12Il2CppStringP12Il2CppObject: __Z21Resources_CUSTOM_LoadP12Il2CppStringP12Il2CppObject, __ZNK13TranslateGLES16GetTextureTargetEj: __ZNK13TranslateGLES16GetTextureTargetEj, __ZN5physx2Gu12TriangleMesh7releaseEv: __ZN5physx2Gu12TriangleMesh7releaseEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj568ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj568ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx5cloth8SwSolver25setInterCollisionDistanceEf: __ZN5physx5cloth8SwSolver25setInterCollisionDistanceEf, __ZN8GUILayerD2Ev: __ZN8GUILayerD2Ev, __Z42Register_UnityEngine_RectOffset_get_bottomv: __Z42Register_UnityEngine_RectOffset_get_bottomv, __ZN26DownloadHandlerAssetBundle7PrepareEv: __ZN26DownloadHandlerAssetBundle7PrepareEv, __ZN5physx14PxsAABBManagerD2Ev: __ZN5physx14PxsAABBManagerD2Ev, __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_sidewaysFrictionv: __Z64Register_UnityEngine_WheelCollider_INTERNAL_get_sidewaysFrictionv, __ZN8Renderer13SetLightmapSTERK8Vector4f12LightmapType: __ZN8Renderer13SetLightmapSTERK8Vector4f12LightmapType, __ZN10CBBoxInt325ClearEv: __ZN10CBBoxInt325ClearEv, __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE13StaticDestroyEPv: __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE13StaticDestroyEPv, __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f: __Z18QuaternionToMatrixRK11QuaternionfR10Matrix4x4f, __ZN9GfxDevice19ResetDynamicBuffersEv: __ZN9GfxDevice19ResetDynamicBuffersEv, __Z27ConvertSeparatorsToPlatformRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z27ConvertSeparatorsToPlatformRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z39Register_UnityEngine_Transform_get_rootv: __Z39Register_UnityEngine_Transform_get_rootv, __ZN5physx16PxsIslandManagerD2Ev: __ZN5physx16PxsIslandManagerD2Ev, __ZN14SpriteRenderer15ThreadedCleanupEv: __ZN14SpriteRenderer15ThreadedCleanupEv, __Z58Register_UnityEngine_ParticleSystem_MainModule_SetDurationv: __Z58Register_UnityEngine_ParticleSystem_MainModule_SetDurationv, __ZN9Projector16CheckConsistencyEv: __ZN9Projector16CheckConsistencyEv, __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev: __ZN5physx32PxClothTetherConfigGeneratedInfoC2Ev, __Z49WebGLInput_Get_Custom_PropCaptureAllKeyboardInputv: __Z49WebGLInput_Get_Custom_PropCaptureAllKeyboardInputv, __ZN15ReflectionProbe12AddToManagerEv: __ZN15ReflectionProbe12AddToManagerEv, __ZN2UI13RectTransform8TransferI14SafeBinaryReadEEvRT_: __ZN2UI13RectTransform8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn5ConvXD2Ev: __ZN5physx2Sn5ConvXD2Ev, __ZN5physx7NpScene24removeFromRigidActorListERKj: __ZN5physx7NpScene24removeFromRigidActorListERKj, __ZN34ColorBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN34ColorBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __Z20IsHumanControllingUsv: __Z20IsHumanControllingUsv, __Z51MeshRenderer_Get_Custom_PropAdditionalVertexStreamsP12Il2CppObject: __Z51MeshRenderer_Get_Custom_PropAdditionalVertexStreamsP12Il2CppObject, __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv: __ZNK11ICallStringcvNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEv, __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED0Ev, _round: _round, __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall: __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall, __ZN14SphereCollider5ResetEv: __ZN14SphereCollider5ResetEv, __ZN23ForwardShaderRenderLoop23RenderForwardShadowMapsEPK11ActiveLightbN6Camera10RenderFlagER17ShaderPassContext: __ZN23ForwardShaderRenderLoop23RenderForwardShadowMapsEPK11ActiveLightbN6Camera10RenderFlagER17ShaderPassContext, __ZN7mecanim5human9HumanGoal8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim5human9HumanGoal8TransferI14SafeBinaryReadEEvRT_, __ZN15NavMeshObstacle9SetRadiusEf: __ZN15NavMeshObstacle9SetRadiusEf, __ZN10systeminfo21GetPersistentDataPathEv: __ZN10systeminfo21GetPersistentDataPathEv, __ZN12_GLOBAL__N_121SocketNetworkInStreamD0Ev: __ZN12_GLOBAL__N_121SocketNetworkInStreamD0Ev, __ZN13GfxDeviceGLES17DestroyGpuProgramEPK10GpuProgram: __ZN13GfxDeviceGLES17DestroyGpuProgramEPK10GpuProgram, __Z38ParticleSystem_Get_Custom_PropIsPausedP12Il2CppObject: __Z38ParticleSystem_Get_Custom_PropIsPausedP12Il2CppObject, __ZNSt3__218__insertion_sort_3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_, __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo: __ZN12NativeBufferI27Converter_SimpleNativeClassI8GradientEE15SetupForWritingER9ArrayInfo, __ZN5IMGUI8DoWindowER8GUIStateiRK5RectTIfEP12Il2CppObjectR10GUIContentS7_S7_bb: __ZN5IMGUI8DoWindowER8GUIStateiRK5RectTIfEP12Il2CppObjectR10GUIContentS7_S7_bb, __Z45ParticleAnimator_CUSTOM_INTERNAL_set_rndForceP12Il2CppObjectRK8Vector3f: __Z45ParticleAnimator_CUSTOM_INTERNAL_set_rndForceP12Il2CppObjectRK8Vector3f, __ZN5physx47PCMConvexVsHeightfieldContactGenerationCallbackD0Ev: __ZN5physx47PCMConvexVsHeightfieldContactGenerationCallbackD0Ev, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb: __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentbbbb, __ZN14SphereCollider16TransformChangedEi: __ZN14SphereCollider16TransformChangedEi, __ZN19ScriptingInvocation6InvokeIP11Il2CppArrayEET_PP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeIP11Il2CppArrayEET_PP15Il2CppExceptionb, __Z38Register_UnityEngine_Mathf_FloatToHalfv: __Z38Register_UnityEngine_Mathf_FloatToHalfv, __Z41Physics2D_Get_Custom_PropShowColliderAABBv: __Z41Physics2D_Get_Custom_PropShowColliderAABBv, __ZNK9BoxPruner14retrieveBoundsER5IAABBt: __ZNK9BoxPruner14retrieveBoundsER5IAABBt, __ZN4FMOD4DSPI5resetEv: __ZN4FMOD4DSPI5resetEv, __ZN5Unity11AdjTriangle19FindEdgeDirectionalEjjb: __ZN5Unity11AdjTriangle19FindEdgeDirectionalEjjb, __Z32Mesh_CUSTOM_ExtractArrayFromListP12Il2CppObject: __Z32Mesh_CUSTOM_ExtractArrayFromListP12Il2CppObject, __ZN5physx3Cct17CapsuleController11setPositionERKNS_14PxExtendedVec3E: __ZN5physx3Cct17CapsuleController11setPositionERKNS_14PxExtendedVec3E, __ZN17AudioReverbFilter16ChangePropertiesEv: __ZN17AudioReverbFilter16ChangePropertiesEv, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z20scripting_object_newP11Il2CppClass: __Z20scripting_object_newP11Il2CppClass, __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_, __Z39Profiler_Get_Custom_PropEnableBinaryLogv: __Z39Profiler_Get_Custom_PropEnableBinaryLogv, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __Z78Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorP12Il2CppObjectRK13Vector2fIcallPS1_: __Z78Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorP12Il2CppObjectRK13Vector2fIcallPS1_, __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10RectOffset8TransferI24GenerateTypeTreeTransferEEvRT_, __Z18GetResourceManagerv: __Z18GetResourceManagerv, __Z48Register_UnityEngine_LightProbes_set_bakedProbesv: __Z48Register_UnityEngine_LightProbes_set_bakedProbesv, __ZN12_GLOBAL__N_123DoubleBufferedOutStream5writeEPKhj: __ZN12_GLOBAL__N_123DoubleBufferedOutStream5writeEPKhj, __ZNK10Collider2D15GetAttachedBodyEv: __ZNK10Collider2D15GetAttachedBodyEv, __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_, __Z50Transform_CUSTOM_INTERNAL_CALL_GetLocalEulerAnglesP12Il2CppObjectN4math13RotationOrderER8Vector3f: __Z50Transform_CUSTOM_INTERNAL_CALL_GetLocalEulerAnglesP12Il2CppObjectN4math13RotationOrderER8Vector3f, __ZN5physx7NpShape18setQueryFilterDataERKNS_12PxFilterDataE: __ZN5physx7NpShape18setQueryFilterDataERKNS_12PxFilterDataE, __ZNK11DynamicMesh20BuildEdgeConnectionsER13dynamic_arrayINS_4EdgeELj2EE: __ZNK11DynamicMesh20BuildEdgeConnectionsER13dynamic_arrayINS_4EdgeELj2EE, __ZN4FMOD7Channel11getPriorityEPi: __ZN4FMOD7Channel11getPriorityEPi, __Z39AndroidJNI_CUSTOM_SetStaticBooleanField13Il2Cpp_IntPtrS_h: __Z39AndroidJNI_CUSTOM_SetStaticBooleanField13Il2Cpp_IntPtrS_h, __ZN5physx2Sc8ShapeSim18onRestOffsetChangeEv: __ZN5physx2Sc8ShapeSim18onRestOffsetChangeEv, __ZN5physx20PxcNpCacheStreamPair5resetEv: __ZN5physx20PxcNpCacheStreamPair5resetEv, __ZN11JointLimits8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11JointLimits8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _LzmaDec_TryDummy: _LzmaDec_TryDummy, _UNITY_png_ascii_from_fixed: _UNITY_png_ascii_from_fixed, __Z46Register_UnityEngine_Light_get_shadowNearPlanev: __Z46Register_UnityEngine_Light_get_shadowNearPlanev, __ZN14ParticleSystem17RemoveFromManagerEv: __ZN14ParticleSystem17RemoveFromManagerEv, __ZN13dynamic_arrayIN2UI13UIInstructionELj4EE19push_back_constructEv: __ZN13dynamic_arrayIN2UI13UIInstructionELj4EE19push_back_constructEv, __ZL24PrepareSpriteRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext: __ZL24PrepareSpriteRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext, __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye: __ZNK6Camera19GetStereoViewMatrixE15StereoscopicEye, __ZNSt3__25ctypeIcED2Ev: __ZNSt3__25ctypeIcED2Ev, __ZN10HumanTrait19GetFingerMuscleNameEib: __ZN10HumanTrait19GetFingerMuscleNameEib, __ZNK19RenderEventsContext17GetCommandBuffersEi: __ZNK19RenderEventsContext17GetCommandBuffersEi, __ZNK10GameObject8IsActiveEv: __ZNK10GameObject8IsActiveEv, __Z34Component_Get_Custom_PropTransformP12Il2CppObject: __Z34Component_Get_Custom_PropTransformP12Il2CppObject, __ZN21InheritVelocityModule5ResetEv: __ZN21InheritVelocityModule5ResetEv, __ZN18GfxFramebufferGLES23SetupDefaultFramebufferEPP17RenderSurfaceBaseS2_N2gl6HandleILNS3_10ObjectTypeE9EEE: __ZN18GfxFramebufferGLES23SetupDefaultFramebufferEPP17RenderSurfaceBaseS2_N2gl6HandleILNS3_10ObjectTypeE9EEE, __Z19pop_allocation_rootv: __Z19pop_allocation_rootv, ___towrite_needs_stdio_exit: ___towrite_needs_stdio_exit, __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE: __ZN5physx2Sq16computeWorldAABBERKNS_3Scb5ShapeERKNS1_5ActorE, _UNITY_png_set_scale_16: _UNITY_png_set_scale_16, __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN5physx14PxsAABBManager31updateAggregateBPOverlapRecordsEv: __ZN5physx14PxsAABBManager31updateAggregateBPOverlapRecordsEv, __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED0Ev, __ZN13EmscriptenWWW14BlockUntilDoneEv: __ZN13EmscriptenWWW14BlockUntilDoneEv, __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE: __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE4copyIS3_EEvRKNS1_IjT_EE, __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_: __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator11addVelocityERKS2_S6_S6_S6_, __Z63Register_UnityEngine_ParticleSystemRenderer_get_minParticleSizev: __Z63Register_UnityEngine_ParticleSystemRenderer_get_minParticleSizev, __ZN5physx2Sn13XmlNodeReader9gotoChildEPKc: __ZN5physx2Sn13XmlNodeReader9gotoChildEPKc, __ZN20GlobalCachingManager21ClearAllExpiredCachesEv: __ZN20GlobalCachingManager21ClearAllExpiredCachesEv, __ZN5physx18RepXSerializerImplINS_7PxShapeEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_7PxShapeEE11getTypeNameEv, __GLOBAL__sub_I_NpActor_cpp: __GLOBAL__sub_I_NpActor_cpp, __Z34Application_Get_Custom_PropGenuinev: __Z34Application_Get_Custom_PropGenuinev, __ZNSt3__211char_traitsIwE4findEPKwjRS2_: __ZNSt3__211char_traitsIwE4findEPKwjRS2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj400ENS_22PxRepXPropertyAccessorILj400ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj400ENS_22PxRepXPropertyAccessorILj400ES4_ffEEEEvRKT0_, __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev: __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED2Ev, _getsockname: _getsockname, __Z50AnimatorControllerPlayable_CUSTOM_HasStateInternal9HPlayableRS_ii: __Z50AnimatorControllerPlayable_CUSTOM_HasStateInternal9HPlayableRS_ii, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj669ES3_RKNS_27PxVehicleDifferential4WDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj669ES3_RKNS_27PxVehicleDifferential4WDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx16PxsFluidDynamicsC2ERNS_20PxsParticleSystemSimE: __ZN5physx16PxsFluidDynamicsC2ERNS_20PxsParticleSystemSimE, __ZN15UnityAdsManager15ThreadedCleanupEv: __ZN15UnityAdsManager15ThreadedCleanupEv, __Z39Register_UnityEngine_Time_set_timeScalev: __Z39Register_UnityEngine_Time_set_timeScalev, __ZN8GUILayer12AddToManagerEv: __ZN8GUILayer12AddToManagerEv, __ZN9Rigidbody16AddNonConvexMeshER8ListNodeI12MeshColliderE: __ZN9Rigidbody16AddNonConvexMeshER8ListNodeI12MeshColliderE, __ZN22BaseUnityConnectClient31DonePreparingOnMainThreadStaticEPv: __ZN22BaseUnityConnectClient31DonePreparingOnMainThreadStaticEPv, __ZN23AnimationOffsetPlayable11GetRotationEv: __ZN23AnimationOffsetPlayable11GetRotationEv, __ZN13WheelCollider13SetSteerAngleEf: __ZN13WheelCollider13SetSteerAngleEf, __ZN18LoadSceneOperation22CompleteLoadFirstSceneEv: __ZN18LoadSceneOperation22CompleteLoadFirstSceneEv, __ZN22SharedSpriteRenderDataD0Ev: __ZN22SharedSpriteRenderDataD0Ev, __ZN13MemoryManager10ReallocateEPvjiRK10MemLabelId15AllocateOptionsPKci: __ZN13MemoryManager10ReallocateEPvjiRK10MemLabelId15AllocateOptionsPKci, __ZN13SplatDatabase18RecalculateBasemapEb: __ZN13SplatDatabase18RecalculateBasemapEb, __ZN9Transform30EnsureTransformHierarchyExistsEv: __ZN9Transform30EnsureTransformHierarchyExistsEv, __ZN11AudioModule26SetDefaultMicrophoneDriverEPv: __ZN11AudioModule26SetDefaultMicrophoneDriverEPv, __ZNK8Collider12GetRigidbodyEv: __ZNK8Collider12GetRigidbodyEv, __ZNKSt3__215__codecvt_utf16IDsLb0EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IDsLb0EE9do_lengthER11__mbstate_tPKcS5_j, __Z30NavMesh_CUSTOM_AddOffMeshLinksv: __Z30NavMesh_CUSTOM_AddOffMeshLinksv, __ZN4FMOD13ChannelGroupI9setPausedEb: __ZN4FMOD13ChannelGroupI9setPausedEb, __ZNK13b2DynamicTree13GetMaxBalanceEv: __ZNK13b2DynamicTree13GetMaxBalanceEv, __Z52Register_UnityEngine_AndroidJNI_SetShortArrayElementv: __Z52Register_UnityEngine_AndroidJNI_SetShortArrayElementv, __Z49Register_UnityEngine_AI_OffMeshLink_set_activatedv: __Z49Register_UnityEngine_AI_OffMeshLink_set_activatedv, __ZN11TimeManager19SetMaximumDeltaTimeEf: __ZN11TimeManager19SetMaximumDeltaTimeEf, __ZN13MonoBehaviour13StopCoroutineEPKc: __ZN13MonoBehaviour13StopCoroutineEPKc, __ZN12b2ChainShapeD0Ev: __ZN12b2ChainShapeD0Ev, __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_velocityv: __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_velocityv, __ZThn32_N22ParticleSystemRendererD1Ev: __ZThn32_N22ParticleSystemRendererD1Ev, __ZN15AudioReverbZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15AudioReverbZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z37AnimationState_Get_Custom_PropEnabledP12Il2CppObject: __Z37AnimationState_Get_Custom_PropEnabledP12Il2CppObject, __ZNK23LODTreeInstanceRenderer14GetSubsetIndexEi: __ZNK23LODTreeInstanceRenderer14GetSubsetIndexEi, __ZN8Scalar4fC2Ejjjj: __ZN8Scalar4fC2Ejjjj, __Z50Register_UnityEngine_Graphics_GetActiveDepthBufferv: __Z50Register_UnityEngine_Graphics_GetActiveDepthBufferv, __ZN17TransformInternal36OnScaleChangedCalculateTransformTypeE15TransformAccess: __ZN17TransformInternal36OnScaleChangedCalculateTransformTypeE15TransformAccess, __Z54Register_UnityEngine_SystemInfo_get_graphicsMemorySizev: __Z54Register_UnityEngine_SystemInfo_get_graphicsMemorySizev, __ZN2UI13RectTransform7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN2UI13RectTransform7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN17ArchiveFileSystem10ToAbsoluteEPKc: __ZN17ArchiveFileSystem10ToAbsoluteEPKc, __ZN22CrashReportingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN22CrashReportingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN7mecanim5human22HumanComputeMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human22HumanComputeMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZNKSt3__214__codecvt_utf8IwE13do_max_lengthEv: __ZNKSt3__214__codecvt_utf8IwE13do_max_lengthEv, __ZN4FMOD5Sound8seekDataEj: __ZN4FMOD5Sound8seekDataEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_RKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_RKS5_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEEEvRT_17TransferMetaFlags, __Z37DownloadHandler_Get_Custom_PropIsDoneP12Il2CppObject: __Z37DownloadHandler_Get_Custom_PropIsDoneP12Il2CppObject, __ZN7mecanim6CRCKeyENS_7eStringE: __ZN7mecanim6CRCKeyENS_7eStringE, __ZL13SortTexByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES7_: __ZL13SortTexByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES7_, __Z21GetShaderGlobalVectorN9ShaderLab16FastPropertyNameE: __Z21GetShaderGlobalVectorN9ShaderLab16FastPropertyNameE, __ZN13InitialModule18GenerateProceduralERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fRK8Vector3fRK24ParticleSystemEmitReplayRj: __ZN13InitialModule18GenerateProceduralERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fRK8Vector3fRK24ParticleSystemEmitReplayRj, __ZNK8VRDevice16GetLocalPositionERK8UnityStr: __ZNK8VRDevice16GetLocalPositionERK8UnityStr, __Z47ParticleSystem_CollisionModule_CUSTOM_SetBounceP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_CollisionModule_CUSTOM_SetBounceP12Il2CppObjectR15MonoMinMaxCurve, __ZN21ProceduralTextureDataC2Ev: __ZN21ProceduralTextureDataC2Ev, __ZN11ColorModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11ColorModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_png_zstream_error: _UNITY_png_zstream_error, __ZdlPvRK10MemLabelIdiPKcS4_S4_i: __ZdlPvRK10MemLabelIdiPKcS4_S4_i, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEED2Ev: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEED2Ev, __ZN5physx2Cm17FreeListAllocatorC2ERNS_19PxAllocatorCallbackE: __ZN5physx2Cm17FreeListAllocatorC2ERNS_19PxAllocatorCallbackE, __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z45LightProbeGroup_Set_Custom_PropProbePositionsP12Il2CppObjectP11Il2CppArray: __Z45LightProbeGroup_Set_Custom_PropProbePositionsP12Il2CppObjectP11Il2CppArray, __ZNSt3__212__deque_baseI18ReflectionProbeJobNS_9allocatorIS1_EEED2Ev: __ZNSt3__212__deque_baseI18ReflectionProbeJobNS_9allocatorIS1_EEED2Ev, __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE: __ZN11UnityEngine9Animation27DestroyAnimationSetBindingsEPNS0_20AnimationSetBindingsERN7mecanim6memory9AllocatorE, __ZN5physx2Sc9ShapeCore23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx2Sc9ShapeCore23setSimulationFilterDataERKNS_12PxFilterDataE, __Z31GetInterpolatedLightAttenuationRK17LightProbeContextRK29LightProbeSamplingCoordinatesPK15SharedLightData: __Z31GetInterpolatedLightAttenuationRK17LightProbeContextRK29LightProbeSamplingCoordinatesPK15SharedLightData, __Z53Register_UnityEngine_VR_VRSettings_get_isDeviceActivev: __Z53Register_UnityEngine_VR_VRSettings_get_isDeviceActivev, __ZN8Animator12CleanupClassEv: __ZN8Animator12CleanupClassEv, __ZN11AssetBundle9AssetInfo8TransferI14SafeBinaryReadEEvRT_: __ZN11AssetBundle9AssetInfo8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7profile12MemoryBufferINS0_21WrapperNamedAllocatorEE5writeIyEEvRKT_: __ZN5physx7profile12MemoryBufferINS0_21WrapperNamedAllocatorEE5writeIyEEvRKT_, __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_: __Z30scripting_class_is_subclass_ofP11Il2CppClassS0_, __Z21UpdateCollisionPlanesR13dynamic_arrayI20BatchedRaycastResultLj4EEbjbibRK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK33ParticleSystemCollisionParametersR23ParticleSystemParticlesjRKf: __Z21UpdateCollisionPlanesR13dynamic_arrayI20BatchedRaycastResultLj4EEbjbibRK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK33ParticleSystemCollisionParametersR23ParticleSystemParticlesjRKf, __ZN20TextRenderingPrivate19NativeTextGenerator15InsertLineBreakEv: __ZN20TextRenderingPrivate19NativeTextGenerator15InsertLineBreakEv, __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib: __ZNK8GUIStyle4DrawER8GUIStateRK5RectTIfER10GUIContentib, __ZNKSt12experimental15fundamentals_v112bad_any_cast4whatEv: __ZNKSt12experimental15fundamentals_v112bad_any_cast4whatEv, __Z24CalculateSpotLightBoundsffRK10Matrix4x4fR15SpotLightBounds: __Z24CalculateSpotLightBoundsffRK10Matrix4x4fR15SpotLightBounds, __ZNK13RenderTexture21GetShadowSamplingModeEv: __ZNK13RenderTexture21GetShadowSamplingModeEv, __ZN23CloudWebServicesManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN23CloudWebServicesManager23VirtualRedirectTransferER14SafeBinaryRead, __ZNK5physx2Sc5Scene18getNbArticulationsEv: __ZNK5physx2Sc5Scene18getNbArticulationsEv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_, __ZN5physx15PxAssertHandlerD2Ev: __ZN5physx15PxAssertHandlerD2Ev, _csinl: _csinl, __ZN16Physics2DManager15IgnoreCollisionEP10Collider2DS1_b: __ZN16Physics2DManager15IgnoreCollisionEP10Collider2DS1_b, _csinh: _csinh, _csinf: _csinf, __Z49ParticleSystem_NoiseModule_CUSTOM_SetRemapEnabledP12Il2CppObjecth: __Z49ParticleSystem_NoiseModule_CUSTOM_SetRemapEnabledP12Il2CppObjecth, __ZN5physx5cloth8SwSolver14interCollisionEv: __ZN5physx5cloth8SwSolver14interCollisionEv, __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetSpeedv: __Z73Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetSpeedv, __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf: __ZN5audio5mixer22UpdateAudioMixerMemoryERKNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryEfPN4FMOD6SystemEf, __ZL21InitializeCachedStripPv: __ZL21InitializeCachedStripPv, __ZN12TextureInput8GetImageEv: __ZN12TextureInput8GetImageEv, __ZN5physx7NpActor7OffsetsC2Ev: __ZN5physx7NpActor7OffsetsC2Ev, __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_PlayP12Il2CppObject: __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_PlayP12Il2CppObject, __ZNK6Camera22GetWorldToCameraMatrixEv: __ZNK6Camera22GetWorldToCameraMatrixEv, __ZNK26DownloadHandlerAssetBundle13GetMemorySizeEv: __ZNK26DownloadHandlerAssetBundle13GetMemorySizeEv, __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc: __ZN8JSONRead32GetValueForKeyWithNameConversionEPKN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKc, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_, __ZN13MonoBehaviour7SetNameEPKc: __ZN13MonoBehaviour7SetNameEPKc, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __ZN25b2PolygonAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN25b2PolygonAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN7mecanim5human18BoneParentFromTDoFEi: __ZN7mecanim5human18BoneParentFromTDoFEi, __Z96Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_SetPlayableDeleteOnDisconnectv: __Z96Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_SetPlayableDeleteOnDisconnectv, __Z49CommandBuffer_CUSTOM_SetGlobalMatrixArrayListImplP12Il2CppObjectiS0_: __Z49CommandBuffer_CUSTOM_SetGlobalMatrixArrayListImplP12Il2CppObjectiS0_, __Z30Sprite_CUSTOM_OverrideGeometryP12Il2CppObjectP11Il2CppArrayS2_: __Z30Sprite_CUSTOM_OverrideGeometryP12Il2CppObjectP11Il2CppArrayS2_, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetZv, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j, _UNITY_FT_Outline_GetOutsideBorder: _UNITY_FT_Outline_GetOutsideBorder, __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj: __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE8recreateEj, __Z40ParticleEmitter_Get_Custom_PropParticlesP12Il2CppObject: __Z40ParticleEmitter_Get_Custom_PropParticlesP12Il2CppObject, __ZN8Playable10DisconnectEPS_i: __ZN8Playable10DisconnectEPS_i, __ZN5physx2Sc18ParticleSystemCore12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE: __ZN5physx2Sc18ParticleSystemCore12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE, __ZN14FileCacherRead15DeallocateBlockERNS_10CacheBlockE: __ZN14FileCacherRead15DeallocateBlockERNS_10CacheBlockE, __ZN13LoadOperationD2Ev: __ZN13LoadOperationD2Ev, __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags, __Z55AnimatorControllerPlayable_CUSTOM_GetLayerIndexInternalR9HPlayableP12Il2CppString: __Z55AnimatorControllerPlayable_CUSTOM_GetLayerIndexInternalR9HPlayableP12Il2CppString, __ZN4FMOD3DSP7releaseEv: __ZN4FMOD3DSP7releaseEv, __ZN29TriggerModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN29TriggerModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN5Umbra18ReceiverMaskCuller4initERKNS_7Vector3ERKNS_9Matrix4x4ES6_S6_PKNS_18ImpOcclusionBufferEf: __ZN5Umbra18ReceiverMaskCuller4initERKNS_7Vector3ERKNS_9Matrix4x4ES6_S6_PKNS_18ImpOcclusionBufferEf, __Z56AnimatorOverrideController_CUSTOM_Internal_GetClipByNameP12Il2CppObjectP12Il2CppStringh: __Z56AnimatorOverrideController_CUSTOM_Internal_GetClipByNameP12Il2CppObjectP12Il2CppStringh, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZMultiplierv, __ZN4FMOD7SystemI13setPluginPathEPKc: __ZN4FMOD7SystemI13setPluginPathEPKc, __ZL29GeomOverlapCallback_SphereBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL29GeomOverlapCallback_SphereBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z48Register_UnityEngine_Material_set_shaderKeywordsv: __Z48Register_UnityEngine_Material_set_shaderKeywordsv, __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_: __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_SD_SD_T_, __Z57Register_UnityEngine_Connect_UnityAdsSettings_get_enabledv: __Z57Register_UnityEngine_Connect_UnityAdsSettings_get_enabledv, __ZN9Rigidbody6WakeUpEv: __ZN9Rigidbody6WakeUpEv, __ZNK7ApiGLES18GetExtensionStringEv: __ZNK7ApiGLES18GetExtensionStringEv, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE7getNameEv, __Z44Register_UnityEngine_Rigidbody2D_set_inertiav: __Z44Register_UnityEngine_Rigidbody2D_set_inertiav, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK12HandlerChain4SizeERK13FileEntryData: __ZNK12HandlerChain4SizeERK13FileEntryData, __Z18OrthoNormalizeFastP8Vector3fS0_S0_: __Z18OrthoNormalizeFastP8Vector3fS0_S0_, __ZN38AssetBundleLoadFromCacheAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN38AssetBundleLoadFromCacheAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx7NpCloth15setInertiaScaleEf: __ZN5physx7NpCloth15setInertiaScaleEf, __Z34DynamicGI_CUSTOM_UpdateEnvironmentv: __Z34DynamicGI_CUSTOM_UpdateEnvironmentv, __Z24GetComponentOrScriptNameRN5Unity9ComponentE: __Z24GetComponentOrScriptNameRN5Unity9ComponentE, __ZN5physx11NpAggregate15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx11NpAggregate15importExtraDataERNS_24PxDeserializationContextE, __Z22GetPhysicsGroundBody2Dv: __Z22GetPhysicsGroundBody2Dv, __ZN3WWW27SetErrorFromResponseHeadersEv: __ZN3WWW27SetErrorFromResponseHeadersEv, __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j: __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEEEvPT_jRKT0_RKT1_j, __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEEEvRT_j, __ZN5physx6shdfnd10ThreadImplC2EPFPvS2_ES2_: __ZN5physx6shdfnd10ThreadImplC2EPFPvS2_ES2_, __Z47ParticleSystem_TriggerModule_CUSTOM_SetColliderP12Il2CppObjectiS0_: __Z47ParticleSystem_TriggerModule_CUSTOM_SetColliderP12Il2CppObjectiS0_, __ZN22BaseUnityConnectClient19SendAppRunningEventEv: __ZN22BaseUnityConnectClient19SendAppRunningEventEv, __ZN5physx14NpRigidDynamic17setAngularDampingEf: __ZN5physx14NpRigidDynamic17setAngularDampingEf, __ZNK5physx13GuMeshFactory15getHeightFieldsEPPNS_13PxHeightFieldEjj: __ZNK5physx13GuMeshFactory15getHeightFieldsEPPNS_13PxHeightFieldEjj, __ZN26AnimatorControllerPlayable22SyncControllerConstantEv: __ZN26AnimatorControllerPlayable22SyncControllerConstantEv, __ZN7dtCrowd21initializeAgentFilterERK13dtCrowdHandlePKfi: __ZN7dtCrowd21initializeAgentFilterERK13dtCrowdHandlePKfi, __ZN22NavMeshProjectSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN22NavMeshProjectSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15CapsuleCollider9SetRadiusEf: __ZN15CapsuleCollider9SetRadiusEf, __ZN16MecanimAnimationD0Ev: __ZN16MecanimAnimationD0Ev, __ZNSt3__211__stdoutbufIwED0Ev: __ZNSt3__211__stdoutbufIwED0Ev, __Z66Register_UnityEngine_Rendering_CommandBuffer_SetGlobalTexture_Implv: __Z66Register_UnityEngine_Rendering_CommandBuffer_SetGlobalTexture_Implv, __Z28GetNonInterpolatedLightProbeRK17LightProbeContextjR20SphericalHarmonicsL2: __Z28GetNonInterpolatedLightProbeRK17LightProbeContextjR20SphericalHarmonicsL2, __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5Umbra6Random5resetEj: __ZN5Umbra6Random5resetEj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEOS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEOS5_, __Z31GUIText_Get_Custom_PropFontSizeP12Il2CppObject: __Z31GUIText_Get_Custom_PropFontSizeP12Il2CppObject, __ZN11CustomArray8NewBlockEPNS_10CustomCellEm: __ZN11CustomArray8NewBlockEPNS_10CustomCellEm, __Z67Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectArrayElementv: __Z67Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectArrayElementv, __Z36Renderer_Get_Custom_PropSortingOrderP12Il2CppObject: __Z36Renderer_Get_Custom_PropSortingOrderP12Il2CppObject, __ZN7Texture5ResetEv: __ZN7Texture5ResetEv, __ZNK12HingeJoint2D26GetTypeInfoVirtualInternalEv: __ZNK12HingeJoint2D26GetTypeInfoVirtualInternalEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN6HelperI18StreamedBinaryReadILb1EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI18StreamedBinaryReadILb1EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __Z35AudioReverbZone_Get_Custom_PropRoomP12Il2CppObject: __Z35AudioReverbZone_Get_Custom_PropRoomP12Il2CppObject, __ZN9Transform25CleanupTransformHierarchyEv: __ZN9Transform25CleanupTransformHierarchyEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEED0Ev, __ZN5physx3Cct17CapsuleController9setRadiusEf: __ZN5physx3Cct17CapsuleController9setRadiusEf, __ZN10VertexData10DeallocateEv: __ZN10VertexData10DeallocateEv, __ZN10Collider2D16TransformChangedEi: __ZN10Collider2D16TransformChangedEi, __ZN8Animator18GetFeetPivotActiveEv: __ZN8Animator18GetFeetPivotActiveEv, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN6prcore11GetValue1p0ERN11prophecysdk4halfE: __ZN6prcore11GetValue1p0ERN11prophecysdk4halfE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __ZnwjRKSt9nothrow_t: __ZnwjRKSt9nothrow_t, __ZN8Animator11ClearObjectEv: __ZN8Animator11ClearObjectEv, __ZN5Umbra16VisibilityResultC2ERNS_12QueryContextERKNS_10VisibilityERKNS_11TransformerEb: __ZN5Umbra16VisibilityResultC2ERNS_12QueryContextERKNS_10VisibilityERKNS_11TransformerEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj472ENS_22PxRepXPropertyAccessorILj472ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj472ENS_22PxRepXPropertyAccessorILj472ES4_ffEEEEvRKT0_, __Z60Register_UnityEngine_Audio_AudioMixerSnapshot_get_audioMixerv: __Z60Register_UnityEngine_Audio_AudioMixerSnapshot_get_audioMixerv, __ZN9Rigidbody17MainThreadCleanupEv: __ZN9Rigidbody17MainThreadCleanupEv, __Z49Register_UnityEngine_AI_NavMeshAgent_GetLayerCostv: __Z49Register_UnityEngine_AI_NavMeshAgent_GetLayerCostv, __Z20PlayerLoadFirstSceneb: __Z20PlayerLoadFirstSceneb, __Z31GUIText_Set_Custom_PropFontSizeP12Il2CppObjecti: __Z31GUIText_Set_Custom_PropFontSizeP12Il2CppObjecti, __ZN5physx22PxcHeightFieldAabbTestC2ERKNS_9PxBounds3ERKNS_2Gu15HeightFieldUtilE: __ZN5physx22PxcHeightFieldAabbTestC2ERKNS_9PxBounds3ERKNS_2Gu15HeightFieldUtilE, __Z45Register_UnityEngine_MonoBehaviour_IsInvokingv: __Z45Register_UnityEngine_MonoBehaviour_IsInvokingv, __ZNKSt3__27collateIwE7do_hashEPKwS3_: __ZNKSt3__27collateIwE7do_hashEPKwS3_, __Z43TerrainData_Get_Custom_PropDetailPrototypesP12Il2CppObject: __Z43TerrainData_Get_Custom_PropDetailPrototypesP12Il2CppObject, __ZN4FMOD7SystemI19setHardwareChannelsEi: __ZN4FMOD7SystemI19setHardwareChannelsEi, __ZN5physx9NpPhysics26unregisterDeletionListenerERNS_18PxDeletionListenerE: __ZN5physx9NpPhysics26unregisterDeletionListenerERNS_18PxDeletionListenerE, __Z30GetBuiltinVectorParamArraySize24BuiltinShaderVectorParam: __Z30GetBuiltinVectorParamArraySize24BuiltinShaderVectorParam, __ZN14PhysicsManager11CapsuleTestE8Vector3fS0_fi23QueryTriggerInteraction: __ZN14PhysicsManager11CapsuleTestE8Vector3fS0_fi23QueryTriggerInteraction, __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode: __ZN13RenderTextureC2E10MemLabelId18ObjectCreationMode, __ZN16b2ContactManagerC2Ev: __ZN16b2ContactManagerC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEclILj510ES3_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEclILj510ES3_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNKSt3__214collate_bynameIcE10do_compareEPKcS3_S3_S3_: __ZNKSt3__214collate_bynameIcE10do_compareEPKcS3_S3_S3_, __ZN16HumanPoseHandlerC2EP6AvatarP9Transform: __ZN16HumanPoseHandlerC2EP6AvatarP9Transform, __Z39Register_UnityEngine_Application_Unloadv: __Z39Register_UnityEngine_Application_Unloadv, __Z24RegisterStrippedTypeInfoI12HingeJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI12HingeJoint2DEviPKcS2_, __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmittersCountv: __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmittersCountv, _random: _random, __ZNK5physx18NpArticulationLink15getArticulationEv: __ZNK5physx18NpArticulationLink15getArticulationEv, __ZN5physx18RepXSerializerImplINS_7PxShapeEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_7PxShapeEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags, __ZN10GUITexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10GUITexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z50RelativeJoint2D_Get_Custom_PropAutoConfigureOffsetP12Il2CppObject: __Z50RelativeJoint2D_Get_Custom_PropAutoConfigureOffsetP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj622ES2_RKNS_27PxVehicleTireLoadFilterDataES6_EEKNS_40PxVehicleTireLoadFilterDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj622ES2_RKNS_27PxVehicleTireLoadFilterDataES6_EEKNS_40PxVehicleTireLoadFilterDataGeneratedInfoEEEvPjRKT_RT0_, __ZN13MonoBehaviour14SetByPassOnDSPEb: __ZN13MonoBehaviour14SetByPassOnDSPEb, __Z45Register_UnityEngine_RenderTexture_set_activev: __Z45Register_UnityEngine_RenderTexture_set_activev, _UNITY_ft_mem_dup: _UNITY_ft_mem_dup, __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN16LightmapSettings11UnshareDataEv: __ZN16LightmapSettings11UnshareDataEv, __ZN12HingeJoint2DD2Ev: __ZN12HingeJoint2DD2Ev, __Z52Register_UnityEngine_Physics2D_set_showColliderSleepv: __Z52Register_UnityEngine_Physics2D_set_showColliderSleepv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewCharArrayv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewCharArrayv, __ZN9GfxDevice19EndGeometryJobFrameEv: __ZN9GfxDevice19EndGeometryJobFrameEv, __ZN13GfxDeviceNull17CreateIndexBufferEv: __ZN13GfxDeviceNull17CreateIndexBufferEv, __ZN5physx7NpShape15incMeshRefCountEv: __ZN5physx7NpShape15incMeshRefCountEv, __ZNKSt3__212ctype_bynameIwE10do_toupperEw: __ZNKSt3__212ctype_bynameIwE10do_toupperEw, __ZN15UnityAdsManager15InitializeClassEv: __ZN15UnityAdsManager15InitializeClassEv, __ZN13TrailRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN13TrailRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv, __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE: __ZN5physx2Sc15CoreInteraction17isCoreInteractionEPNS0_11InteractionE, __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __ZN5physx3Cct13BoxController17setHalfSideExtentEf: __ZN5physx3Cct13BoxController17setHalfSideExtentEf, __ZN19ShaderPropertySheet21SerializeFromExternalEPhj: __ZN19ShaderPropertySheet21SerializeFromExternalEPhj, __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj, _UNITY_png_get_filter_type: _UNITY_png_get_filter_type, __Z28PlayerPrefs_CUSTOM_DeleteAllv: __Z28PlayerPrefs_CUSTOM_DeleteAllv, __Z56Register_UnityEngine_Canvas_GetDefaultCanvasTextMaterialv: __Z56Register_UnityEngine_Canvas_GetDefaultCanvasTextMaterialv, __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z33Camera_Set_Custom_PropFieldOfViewP12Il2CppObjectf: __Z33Camera_Set_Custom_PropFieldOfViewP12Il2CppObjectf, __ZN21InheritVelocityModule8TransferI14SafeBinaryReadEEvRT_: __ZN21InheritVelocityModule8TransferI14SafeBinaryReadEEvRT_, __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_121parse_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_, __ZNK9ShaderLab20ShaderDepthStateDesc15ToGfxDepthStateEPK19ShaderPropertySheetS3_R13GfxDepthState: __ZNK9ShaderLab20ShaderDepthStateDesc15ToGfxDepthStateEPK19ShaderPropertySheetS3_R13GfxDepthState, __ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE: __ZNK17AnimationCurveTplIfE8EvaluateEfPNS0_5CacheE, __Z31ManagerContextInitializeClassesv: __Z31ManagerContextInitializeClassesv, __Z37GetParticlesLegacyScriptingClassesPtrv: __Z37GetParticlesLegacyScriptingClassesPtrv, _ft_smooth_transform: _ft_smooth_transform, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE8getSceneEv, _UNITY_FT_List_Finalize: _UNITY_FT_List_Finalize, __ZN16ReflectionProbes15ReleaseRendererEP13ProbeRenderer: __ZN16ReflectionProbes15ReleaseRendererEP13ProbeRenderer, __ZThn32_N12LineRendererD1Ev: __ZThn32_N12LineRendererD1Ev, __Z48Register_UnityEngine_Caching_GetVersionFromCachev: __Z48Register_UnityEngine_Caching_GetVersionFromCachev, __ZNSt3__26vectorIP10MemoryPool13stl_allocatorIS2_L18MemLabelIdentifier72ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP10MemoryPool13stl_allocatorIS2_L18MemLabelIdentifier72ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZNK12AudioManager26GetTypeInfoVirtualInternalEv: __ZNK12AudioManager26GetTypeInfoVirtualInternalEv, __ZN13GfxDeviceGLES28GetNativeVertexBufferPointerEP9GfxBuffer: __ZN13GfxDeviceGLES28GetNativeVertexBufferPointerEP9GfxBuffer, __Z41PlayerConnection_Get_Custom_PropConnectedv: __Z41PlayerConnection_Get_Custom_PropConnectedv, __ZN17LowLevelAllocator6MallocEj: __ZN17LowLevelAllocator6MallocEj, __ZN5Umbra4Tome13updateVersionEPKS0_PNS_9AllocatorE: __ZN5Umbra4Tome13updateVersionEPKS0_PNS_9AllocatorE, _imaxabs: _imaxabs, __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE: __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE, __ZN13AnimationClip8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13AnimationClip8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN18AudioMixerSnapshotD2Ev: __ZN18AudioMixerSnapshotD2Ev, __ZN16b2PrismaticJoint4DumpEv: __ZN16b2PrismaticJoint4DumpEv, __ZN7mecanim5human16RetargetFromTDoFEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3EPNS0_9HumanPoseEPS8_SG_: __ZN7mecanim5human16RetargetFromTDoFEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPKNS6_7_float3EPNS0_9HumanPoseEPS8_SG_, __Z45Physics2D_Set_Custom_PropChangeStopsCallbacksh: __Z45Physics2D_Set_Custom_PropChangeStopsCallbacksh, __Z21getPxCloth_GlobalPosePKN5physx7PxClothE: __Z21getPxCloth_GlobalPosePKN5physx7PxClothE, __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z38Register_UnityEngine_Input_GetButtonUpv: __Z38Register_UnityEngine_Input_GetButtonUpv, __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStr: __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStr, __ZN7Terrain18SetLightmapIndicesE15LightmapIndices: __ZN7Terrain18SetLightmapIndicesE15LightmapIndices, __ZN13AnimationClip15QuaternionCurveC2ERKS0_: __ZN13AnimationClip15QuaternionCurveC2ERKS0_, __GLOBAL__sub_I_runtime_modules_lump_cpp: __GLOBAL__sub_I_runtime_modules_lump_cpp, __ZN4MeshD0Ev: __ZN4MeshD0Ev, __ZL42RequestRecreateEyeTexturesBeforeNextUpdatev: __ZL42RequestRecreateEyeTexturesBeforeNextUpdatev, __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE: __ZN5physx3Ext19ProfileEventHandler20reportCudaCollectionERNS_26PxBufferedProfilerCallbackE, __ZNK6Camera20IsCurrentlyRenderingEv: __ZNK6Camera20IsCurrentlyRenderingEv, __Z36CanvasRenderer_CUSTOM_SetPopMaterialP12Il2CppObjectS0_i: __Z36CanvasRenderer_CUSTOM_SetPopMaterialP12Il2CppObjectS0_i, _addmntent: _addmntent, __Z55Register_UnityEngine_GUITexture_INTERNAL_set_pixelInsetv: __Z55Register_UnityEngine_GUITexture_INTERNAL_set_pixelInsetv, __Z18Transfer_BlittableI9JSONWriteLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb, __ZN6Camera8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN6Camera8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z59Register_UnityEngine_BillboardAsset_SetVerticesInternalListv: __Z59Register_UnityEngine_BillboardAsset_SetVerticesInternalListv, __Z43Register_UnityEngine_Cloth_get_coefficientsv: __Z43Register_UnityEngine_Cloth_get_coefficientsv, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj261ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _wctomb: _wctomb, __Z47Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleAllRK13Vector2fIcallfiff: __Z47Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleAllRK13Vector2fIcallfiff, _jpeg_CreateDecompress: _jpeg_CreateDecompress, __ZN17CircleCast2DQueryD0Ev: __ZN17CircleCast2DQueryD0Ev, __Z27Camera_CUSTOM_GetAllCamerasP11Il2CppArray: __Z27Camera_CUSTOM_GetAllCamerasP11Il2CppArray, __ZNK13MonoBehaviour25GetNeedsPerObjectTypeTreeEv: __ZNK13MonoBehaviour25GetNeedsPerObjectTypeTreeEv, __ZNSt11logic_errorD0Ev: __ZNSt11logic_errorD0Ev, __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerIndexInternalv: __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerIndexInternalv, __Z62Register_UnityEngine_ParticleSystem_TrailModule_GetTextureModev: __Z62Register_UnityEngine_ParticleSystem_TrailModule_GetTextureModev, __ZN11ForceModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11ForceModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYv: __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationYv, __ZN5physx20InternalTriangleMesh17allocateFaceRemapEv: __ZN5physx20InternalTriangleMesh17allocateFaceRemapEv, __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurvev: __Z66Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurvev, __Z18Transfer_BlittableI8JSONReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z51Register_UnityEngine_Quaternion_INTERNAL_CALL_Slerpv: __Z51Register_UnityEngine_Quaternion_INTERNAL_CALL_Slerpv, __ZN10systeminfo23SupportsLocationServiceEv: __ZN10systeminfo23SupportsLocationServiceEv, __ZN18ProfilerConnection17GetMemorySnapshotEPKvjj: __ZN18ProfilerConnection17GetMemorySnapshotEPKvjj, __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes: __ZN20SpeedTreeWindManager18FillWindPropertiesER19ShaderPropertySheetbPK13SpeedTreeWindRK18SpeedTreeWindTimes, __ZN14PhysicsManager17RefreshWhenPausedEv: __ZN14PhysicsManager17RefreshWhenPausedEv, __ZN5physx18RepXSerializerImplINS_7PxClothEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_7PxClothEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z34HingeJoint_Get_Custom_PropUseMotorP12Il2CppObject: __Z34HingeJoint_Get_Custom_PropUseMotorP12Il2CppObject, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv, __ZNK5physx7NpScene26getBounceThresholdVelocityEv: __ZNK5physx7NpScene26getBounceThresholdVelocityEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z55Register_UnityEngine_ReflectionProbe_get_shadowDistancev: __Z55Register_UnityEngine_ReflectionProbe_get_shadowDistancev, __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayyPvPy: __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayyPvPy, __Z46Register_UnityEngine_Time_set_maximumDeltaTimev: __Z46Register_UnityEngine_Time_set_maximumDeltaTimev, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI20ComputeShaderVariantNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z29CompletedReadObjectFromVectorR6Object: __Z29CompletedReadObjectFromVectorR6Object, __ZN22BaseUnityConnectClient22OnRestoreFileAsyncDoneERK8UnityStrS2_b: __ZN22BaseUnityConnectClient22OnRestoreFileAsyncDoneERK8UnityStrS2_b, __ZN4Tree23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN4Tree23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13MonoBehaviour5DoGUIENS_13GUILayoutTypeEii: __ZN13MonoBehaviour5DoGUIENS_13GUILayoutTypeEii, __ZN8Animator17SetAvatarPositionERK8Vector3f: __ZN8Animator17SetAvatarPositionERK8Vector3f, __Z41SpringJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject: __Z41SpringJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject, __ZNK12TLSAllocatorI14StackAllocatorE8ContainsEPKv: __ZNK12TLSAllocatorI14StackAllocatorE8ContainsEPKv, __ZN11TimeManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11TimeManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, _tanhl: _tanhl, __ZThn4_NK5physx5cloth8SwFabric10getFactoryEv: __ZThn4_NK5physx5cloth8SwFabric10getFactoryEv, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcS3_: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcS3_, _tanhf: _tanhf, __ZN14BlendShapeData8TransferI14SafeBinaryReadEEvRT_: __ZN14BlendShapeData8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE: __ZN5physx2Gu15getPolygonIndexERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos5Vec3VE, __ZN14DirectorPlayer17RemoveFromManagerEv: __ZN14DirectorPlayer17RemoveFromManagerEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags, __ZN18SharedMaterialDataC2Ev: __ZN18SharedMaterialDataC2Ev, __ZN5physx36normalizePartitionsWithArticulationsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_Pjj: __ZN5physx36normalizePartitionsWithArticulationsERNS_6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEEEPNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyEjjS5_Pjj, __Z40setPxRigidDynamic_StabilizationThresholdPN5physx14PxRigidDynamicEf: __Z40setPxRigidDynamic_StabilizationThresholdPN5physx14PxRigidDynamicEf, __ZNK11NoiseModule22GeneratePreviewTextureEP9Texture2D: __ZNK11NoiseModule22GeneratePreviewTextureEP9Texture2D, __ZN7Texture25ReloadFromStorageIfNeededEPvb: __ZN7Texture25ReloadFromStorageIfNeededEPvb, __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii: __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii, __ZN11TerrainData15InitializeClassEv: __ZN11TerrainData15InitializeClassEv, __ZN12TreeDatabase8TransferI17RemapPPtrTransferEEvRT_: __ZN12TreeDatabase8TransferI17RemapPPtrTransferEEvRT_, __Z28TextMesh_Get_Custom_PropTextP12Il2CppObject: __Z28TextMesh_Get_Custom_PropTextP12Il2CppObject, __Z21GetNbBroadPhaseRemovePKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE: __Z21GetNbBroadPhaseRemovePKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE, __ZNKSt3__212ctype_bynameIwE11do_scan_notEtPKwS3_: __ZNKSt3__212ctype_bynameIwE11do_scan_notEtPKwS3_, __ZN5physx9NpPhysics20createParticleSystemEjb: __ZN5physx9NpPhysics20createParticleSystemEjb, __ZN5physx2Sq17SceneQueryManager17processSimUpdatesEv: __ZN5physx2Sq17SceneQueryManager17processSimUpdatesEv, __Z34getPxVehicleDriveSimData_GearsDataPKN5physx21PxVehicleDriveSimDataE: __Z34getPxVehicleDriveSimData_GearsDataPKN5physx21PxVehicleDriveSimDataE, _Update_Max: _Update_Max, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN14TerrainManager23AfterCullingOutputReadyEPK9IndexListPK16RendererCullData: __ZN14TerrainManager23AfterCullingOutputReadyEPK9IndexListPK16RendererCullData, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE15growAndPushBackERKS2_, __ZN15ParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15ParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK23TransformChangeDispatch24GetChangeMaskForInterestENS_12InterestTypeE: __ZNK23TransformChangeDispatch24GetChangeMaskForInterestENS_12InterestTypeE, __Z34Scene_CUSTOM_GetBuildIndexInternali: __Z34Scene_CUSTOM_GetBuildIndexInternali, __Z45Transform_CUSTOM_INTERNAL_CALL_TransformPointP12Il2CppObjectRK8Vector3fRS1_: __Z45Transform_CUSTOM_INTERNAL_CALL_TransformPointP12Il2CppObjectRK8Vector3fRS1_, __ZN5physx10PxsContext25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf: __ZN5physx10PxsContext25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf, __ZN23ShaderVariantCollection23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN23ShaderVariantCollection23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z52Register_UnityEngine_TerrainCollider_set_terrainDatav: __Z52Register_UnityEngine_TerrainCollider_set_terrainDatav, __ZL10KeyHandleriPK23EmscriptenKeyboardEventPv: __ZL10KeyHandleriPK23EmscriptenKeyboardEventPv, __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationYMultiplierP12Il2CppObject: __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationYMultiplierP12Il2CppObject, __ZN8Collider16TransformChangedEi: __ZN8Collider16TransformChangedEi, __ZN24ConvexVsHeightfieldSweepC2ERN5physx2Gu15HeightFieldUtilERKNS1_14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_11PxTransformESC_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEfbb: __ZN24ConvexVsHeightfieldSweepC2ERN5physx2Gu15HeightFieldUtilERKNS1_14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_11PxTransformESC_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEfbb, _tt_cmap4_char_index: _tt_cmap4_char_index, __ZN5physx20PxVehiclePostUpdatesEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE: __ZN5physx20PxVehiclePostUpdatesEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE, __ZN11UnityEngine15CloudWebService13SessionHeader5ResetEv: __ZN11UnityEngine15CloudWebService13SessionHeader5ResetEv, __ZNK12HandlerChain8IsHiddenERK13FileEntryData: __ZNK12HandlerChain8IsHiddenERK13FileEntryData, _faccessat: _faccessat, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z14ValidateFormatR13dynamic_arrayIN20TextRenderingPrivate16TextFormatChangeELj4EE: __Z14ValidateFormatR13dynamic_arrayIN20TextRenderingPrivate16TextFormatChangeELj4EE, __Z26GetTerrainScriptingClassesv: __Z26GetTerrainScriptingClassesv, __ZN5physx13GuMeshFactory17createHeightFieldERNS_13PxInputStreamE: __ZN5physx13GuMeshFactory17createHeightFieldERNS_13PxInputStreamE, __ZN12TreeRenderer17UpdateShaderPropsERK6Cameraf: __ZN12TreeRenderer17UpdateShaderPropsERK6Cameraf, __ZNK7VRInput16GetEyeSeparationEv: __ZNK7VRInput16GetEyeSeparationEv, __ZN5physx12PxcLtbFactorERNS_9PxcFsDataE: __ZN5physx12PxcLtbFactorERNS_9PxcFsDataE, __Z36Animator_Get_Custom_PropRecorderModeP12Il2CppObject: __Z36Animator_Get_Custom_PropRecorderModeP12Il2CppObject, __ZN21EnlightenSceneMapping16BuildRemapTablesEv: __ZN21EnlightenSceneMapping16BuildRemapTablesEv, __ZNK5physx2Cm12RenderBuffer8getTextsEv: __ZNK5physx2Cm12RenderBuffer8getTextsEv, __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy: __ZN21ArchiveStorageCreator13AppendRawNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEyy, __ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher16PrepareDataBlockERNS0_16SessionContainerE, __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXMultiplierv, __ZN18ComputeShaderParam8TransferI14SafeBinaryReadEEvRT_: __ZN18ComputeShaderParam8TransferI14SafeBinaryReadEEvRT_, __ZL17fill_input_bufferP22jpeg_decompress_struct: __ZL17fill_input_bufferP22jpeg_decompress_struct, __ZNK9ShaderLab20ShaderBlendStateDesc15ToGfxBlendStateEPK19ShaderPropertySheetS3_R13GfxBlendState: __ZNK9ShaderLab20ShaderBlendStateDesc15ToGfxBlendStateEPK19ShaderPropertySheetS3_R13GfxBlendState, __Z37Collider_Get_Custom_PropContactOffsetP12Il2CppObject: __Z37Collider_Get_Custom_PropContactOffsetP12Il2CppObject, __ZNK9dtNavMesh23getPolyEdgeDetailPointsEPK10dtMeshTileiiPfPii: __ZNK9dtNavMesh23getPolyEdgeDetailPointsEPK10dtMeshTileiiPfPii, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j, __ZL26AssertOptimizeTransferImplRK16TypeTreeIteratoriPi: __ZL26AssertOptimizeTransferImplRK16TypeTreeIteratoriPi, __ZN11UnityEngine9AnimationL22GenericBindingCallbackEPvS1_i: __ZN11UnityEngine9AnimationL22GenericBindingCallbackEPvS1_i, __Z43Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorP12Il2CppObjectRK8Vector3f: __Z43Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorP12Il2CppObjectRK8Vector3f, __ZNK5physx2Sc16ArticulationCore26getMaxProjectionIterationsEv: __ZNK5physx2Sc16ArticulationCore26getMaxProjectionIterationsEv, __ZN9ShaderLab9IntShaderC2Ev: __ZN9ShaderLab9IntShaderC2Ev, __ZN5physx11AdjacenciesD2Ev: __ZN5physx11AdjacenciesD2Ev, __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN14DetailDatabase13AddLayerIndexEiR11DetailPatch: __ZN14DetailDatabase13AddLayerIndexEiR11DetailPatch, __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12getClassSizeEv, __ZNK13RenderTexture20GetStorageMemorySizeEv: __ZNK13RenderTexture20GetStorageMemorySizeEv, __ZN27ParticleSystemReadOnlyState8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18ProceduralMaterial20HasNonVoidImageInputEv: __ZN18ProceduralMaterial20HasNonVoidImageInputEv, __ZNK22NavMeshProjectSettings11GetAreaCostEj: __ZNK22NavMeshProjectSettings11GetAreaCostEj, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZMultiplierv, __GLOBAL__sub_I_runtime_math_lump_cpp: __GLOBAL__sub_I_runtime_math_lump_cpp, __ZN4Mesh19ValidateVertexCountEjPKvj: __ZN4Mesh19ValidateVertexCountEjPKvj, __ZN16b2PrismaticJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN16b2PrismaticJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11NamedObject8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Cct15ObstacleContextD2Ev: __ZN5physx3Cct15ObstacleContextD2Ev, __ZN11UnityEngine15PlatformWrapper19GetPhysicalMemoryMBEv: __ZN11UnityEngine15PlatformWrapper19GetPhysicalMemoryMBEv, __Z33TextMesh_Get_Custom_PropAlignmentP12Il2CppObject: __Z33TextMesh_Get_Custom_PropAlignmentP12Il2CppObject, __Z48Rigidbody_CUSTOM_INTERNAL_CALL_ResetCenterOfMassP12Il2CppObject: __Z48Rigidbody_CUSTOM_INTERNAL_CALL_ResetCenterOfMassP12Il2CppObject, __Z21CalculateGlobalMatrix23TransformAccessReadOnly: __Z21CalculateGlobalMatrix23TransformAccessReadOnly, __Z45QualitySettings_Get_Custom_PropShadowDistancev: __Z45QualitySettings_Get_Custom_PropShadowDistancev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags, __ZNK5physx3Ext14PrismaticJoint22getPrismaticJointFlagsEv: __ZNK5physx3Ext14PrismaticJoint22getPrismaticJointFlagsEv, __Z39AndroidJNI_CUSTOM_CallStaticFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z39AndroidJNI_CUSTOM_CallStaticFloatMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN13MonoBehaviour20SetScriptingDataFromERKS_: __ZN13MonoBehaviour20SetScriptingDataFromERKS_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN24EllipsoidParticleEmitter12CleanupClassEv: __ZN24EllipsoidParticleEmitter12CleanupClassEv, __ZN5Unity9Component15ThreadedCleanupEv: __ZN5Unity9Component15ThreadedCleanupEv, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject, __ZN5physx2Cm10FanoutTaskC2EPKc: __ZN5physx2Cm10FanoutTaskC2EPKc, __Z52Graphics_CUSTOM_Internal_GetMaxDrawMeshInstanceCountv: __Z52Graphics_CUSTOM_Internal_GetMaxDrawMeshInstanceCountv, __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_8BodyCoreE: __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_8BodyCoreE, __Z13RegisterClassI14RenderSettingsEvv: __Z13RegisterClassI14RenderSettingsEvv, _UNITY_ft_destroy_default_module_classes: _UNITY_ft_destroy_default_module_classes, __ZNSt3__2L15utf16le_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L15utf16le_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE, __ZN5physx2Sc8RigidSimD2Ev: __ZN5physx2Sc8RigidSimD2Ev, __ZThn4_N5physx5cloth8SwSolver8addClothEPNS0_5ClothE: __ZThn4_N5physx5cloth8SwSolver8addClothEPNS0_5ClothE, __ZN11Rigidbody2D7SetMassEf: __ZN11Rigidbody2D7SetMassEf, __Z35Rigidbody2D_Get_Custom_PropBodyTypeP12Il2CppObject: __Z35Rigidbody2D_Get_Custom_PropBodyTypeP12Il2CppObject, __ZNK5physx15NpActorTemplateINS_7PxClothEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE13getActorFlagsEv, __ZN13UnityProfiler20DeserializeFrameDataEP17ProfilerFrameDataPKvi: __ZN13UnityProfiler20DeserializeFrameDataEP17ProfilerFrameDataPKvi, __ZN13SpringJoint2D24SetAutoConfigureDistanceEb: __ZN13SpringJoint2D24SetAutoConfigureDistanceEb, __Z23CalcCapsuleWorldExtentsPfPKfS1_S1_S1_: __Z23CalcCapsuleWorldExtentsPfPKfS1_S1_S1_, __ZN7mecanim12statemachine24CreateStateMachineOutputEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine24CreateStateMachineOutputEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE, __Z45Register_UnityEngine_ReflectionProbe_set_modev: __Z45Register_UnityEngine_ReflectionProbe_set_modev, __ZThn32_NK17BillboardRenderer11GetMaterialEi: __ZThn32_NK17BillboardRenderer11GetMaterialEi, __ZN15CollisionModuleD0Ev: __ZN15CollisionModuleD0Ev, __ZN5physx9NpFactory25releaseArticulationToPoolERNS_14NpArticulationE: __ZN5physx9NpFactory25releaseArticulationToPoolERNS_14NpArticulationE, __ZNK5physx13NpVolumeCache7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE: __ZNK5physx13NpVolumeCache7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE, __Z35HingeJoint_Set_Custom_PropUseSpringP12Il2CppObjecth: __Z35HingeJoint_Set_Custom_PropUseSpringP12Il2CppObjecth, __ZNK9GfxDevice27GetActiveRenderSurfaceWidthEv: __ZNK9GfxDevice27GetActiveRenderSurfaceWidthEv, __Z31ReadVersionedTypeTreeFromVectorR8TypeTreeRPKhS2_b: __Z31ReadVersionedTypeTreeFromVectorR8TypeTreeRPKhS2_b, __ZNK11AssetBundle26GetTypeInfoVirtualInternalEv: __ZNK11AssetBundle26GetTypeInfoVirtualInternalEv, __ZN14DataBufferGLESD2Ev: __ZN14DataBufferGLESD2Ev, __ZN5physx16PxsIslandManagerC2EjRNS_19PxcScratchAllocatorEPNS_2Cm13EventProfilerE: __ZN5physx16PxsIslandManagerC2EjRNS_19PxcScratchAllocatorEPNS_2Cm13EventProfilerE, __ZN11UnityEngine15PlatformWrapper28GetCleanGraphicsFixedVersionEv: __ZN11UnityEngine15PlatformWrapper28GetCleanGraphicsFixedVersionEv, __ZNKSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentrycvbEv: __ZNKSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentrycvbEv, __ZL12DepthPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL12DepthPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15QualitySettings14QualitySetting8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN10MemoryFile4ReadEyPvPy: __ZN10MemoryFile4ReadEyPvPy, __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_destinationv: __Z61Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_destinationv, __ZN18SpeedTreeWindAsset13AwakeFromLoadE17AwakeFromLoadMode: __ZN18SpeedTreeWindAsset13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx13ActorAABBTask11runInternalEv: __ZN5physx13ActorAABBTask11runInternalEv, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z53ParticleSystem_CollisionModule_CUSTOM_SetMaxKillSpeedP12Il2CppObjectf: __Z53ParticleSystem_CollisionModule_CUSTOM_SetMaxKillSpeedP12Il2CppObjectf, __ZNK5physx14NpArticulation13getOwnerSceneEv: __ZNK5physx14NpArticulation13getOwnerSceneEv, __Z26getPxSceneDescFrictionTypePKN5physx11PxSceneDescE: __Z26getPxSceneDescFrictionTypePKN5physx11PxSceneDescE, __ZN18ProceduralMaterial17MainThreadCleanupEv: __ZN18ProceduralMaterial17MainThreadCleanupEv, __ZN5physx26PxMeshScaleGeneratedValuesC2EPKNS_11PxMeshScaleE: __ZN5physx26PxMeshScaleGeneratedValuesC2EPKNS_11PxMeshScaleE, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12getClassSizeEv, __Z35Register_UnityEngine_WWW_GetTexturev: __Z35Register_UnityEngine_WWW_GetTexturev, __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightInternalv: __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetInputWeightInternalv, __ZN8Animator22SyncPlayStateToCullingEv: __ZN8Animator22SyncPlayStateToCullingEv, __ZNSt3__26locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7codecvtIwc11__mbstate_tEEEEvPT_, __ZN14ParticleSystem18SetSimulationSpeedEf: __ZN14ParticleSystem18SetSimulationSpeedEf, __ZN5physx13PxCreatePlaneERNS_9PxPhysicsERKNS_7PxPlaneERNS_10PxMaterialE: __ZN5physx13PxCreatePlaneERNS_9PxPhysicsERKNS_7PxPlaneERNS_10PxMaterialE, __Z32AudioClip_Get_Custom_PropSamplesP12Il2CppObject: __Z32AudioClip_Get_Custom_PropSamplesP12Il2CppObject, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN4PPtrI18ProceduralMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI18ProceduralMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx7PxShapeD0Ev: __ZN5physx7PxShapeD0Ev, __ZN16PxOverflowBufferIN5physx12PxOverlapHitEED0Ev: __ZN16PxOverflowBufferIN5physx12PxOverlapHitEED0Ev, __ZN5physx14NpRigidDynamic18setKinematicTargetERKNS_11PxTransformE: __ZN5physx14NpRigidDynamic18setKinematicTargetERKNS_11PxTransformE, __ZNK23iPhoneLocalNotification11GetUserInfoEv: __ZNK23iPhoneLocalNotification11GetUserInfoEv, __Z15StringToHash128PKcj: __Z15StringToHash128PKcj, __ZN10GISettings8TransferI14SafeBinaryReadEEvRT_: __ZN10GISettings8TransferI14SafeBinaryReadEEvRT_, __Z48Register_UnityEngine_HingeJoint2D_get_limitStatev: __Z48Register_UnityEngine_HingeJoint2D_get_limitStatev, __ZThn4_N12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE: __ZThn4_N12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE, __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z62Register_UnityEngine_CharacterJoint_INTERNAL_set_lowTwistLimitv: __Z62Register_UnityEngine_CharacterJoint_INTERNAL_set_lowTwistLimitv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj445ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj445ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18BackgroundJobQueueC2Ev: __ZN18BackgroundJobQueueC2Ev, __Z3sqrIfET_RKS0_: __Z3sqrIfET_RKS0_, __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayv: __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayv, __ZN5Umbra17ImpTomeCollection5buildEPPKNS_7ImpTomeEiRKNS_4AABBEPNS_9AllocatorEPKS0_: __ZN5Umbra17ImpTomeCollection5buildEPPKNS_7ImpTomeEiRKNS_4AABBEPNS_9AllocatorEPKS0_, __Z59Register_UnityEngine_SystemInfo_get_usesOpenGLTextureCoordsv: __Z59Register_UnityEngine_SystemInfo_get_usesOpenGLTextureCoordsv, __ZN13RenderTexture13ApplySettingsEv: __ZN13RenderTexture13ApplySettingsEv, __ZN6Shader23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Shader23VirtualRedirectTransferER14SafeBinaryRead, __Z27getPxSceneDescSpuDispatcherPKN5physx11PxSceneDescE: __Z27getPxSceneDescSpuDispatcherPKN5physx11PxSceneDescE, __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE: __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamENS0_12MetaDataTypeE, __ZN8Animator21SetGoalWeightRotationEif: __ZN8Animator21SetGoalWeightRotationEif, __Z55Register_UnityEngine_CanvasGroup_get_ignoreParentGroupsv: __Z55Register_UnityEngine_CanvasGroup_get_ignoreParentGroupsv, __ZNK14BillboardAsset8GetWidthEv: __ZNK14BillboardAsset8GetWidthEv, __Z49ParticleSystem_ShapeModule_CUSTOM_SetNormalOffsetP12Il2CppObjectf: __Z49ParticleSystem_ShapeModule_CUSTOM_SetNormalOffsetP12Il2CppObjectf, __ZN5Umbra4PathC2ERKS0_: __ZN5Umbra4PathC2ERKS0_, __ZN5physx2Sc11Interaction12onDeactivateEj: __ZN5physx2Sc11Interaction12onDeactivateEj, __ZN12EventManager11RemoveEventEP10EventEntryPFvPvS2_iES2_: __ZN12EventManager11RemoveEventEP10EventEntryPFvPvS2_iES2_, __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_: __ZN5physx17PxcFsApplyImpulseERNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES4_, __ZN5physx7NpCloth21setLinearInertiaScaleENS_6PxVec3E: __ZN5physx7NpCloth21setLinearInertiaScaleENS_6PxVec3E, __Z36LightProbes_Get_Custom_PropCellCountP12Il2CppObject: __Z36LightProbes_Get_Custom_PropCellCountP12Il2CppObject, __ZN5physx8debugger4comm10EventGroup9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm10EventGroup9serializeERNS1_15EventSerializerE, __ZNK5physx20PxVehicleChassisData7isValidEv: __ZNK5physx20PxVehicleChassisData7isValidEv, __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout: __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayoutRK19VertexStreamsLayout, __ZNK5physx22PxVehicleWheelsDynData7isValidEv: __ZNK5physx22PxVehicleWheelsDynData7isValidEv, __Z28GetHaloVertexPositionsStereoP8Vector3fRKS_S2_f: __Z28GetHaloVertexPositionsStereoP8Vector3fRKS_S2_f, __ZN17TriggerStayStates20executeDeferredEraseEv: __ZN17TriggerStayStates20executeDeferredEraseEv, __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRGHalfEEvPKNS_9InnerInfoE, __Z16return_effectiveRK21AnimationClipOverride: __Z16return_effectiveRK21AnimationClipOverride, __ZN5UmbramlERKNS_7Vector4ERKNS_9Matrix4x4E: __ZN5UmbramlERKNS_7Vector4ERKNS_9Matrix4x4E, __ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv116__enum_type_info9can_catchEPKNS_16__shim_type_infoERPv, __Z17UpdateVelocityJobP9CrowdInfoj: __Z17UpdateVelocityJobP9CrowdInfoj, __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv, __ZN4FMOD5Sound7getModeEPj: __ZN4FMOD5Sound7getModeEPj, __ZNK15NavMeshObstacle15GetWorldExtentsEv: __ZNK15NavMeshObstacle15GetWorldExtentsEv, __ZN7Terrain23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN7Terrain23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx14PxsAABBManager22processAggregateSingleERKNS_19AggregateSortedDataERKNS_9AggregateEjPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx14PxsAABBManager22processAggregateSingleERKNS_19AggregateSortedDataERKNS_9AggregateEjPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __ZNSt3__211__libcpp_db10__insert_cEPv: __ZNSt3__211__libcpp_db10__insert_cEPv, __Z53Register_UnityEngine_AvatarBuilder_BuildGenericAvatarv: __Z53Register_UnityEngine_AvatarBuilder_BuildGenericAvatarv, __ZN14dtPathCorridor18moveTargetPositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter: __ZN14dtPathCorridor18moveTargetPositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter, __ZN13RuntimeStaticI19UnityPluginRegistryE16StaticInitializeEPv: __ZN13RuntimeStaticI19UnityPluginRegistryE16StaticInitializeEPv, __ZL28InitializeSparseTexturesGLESPv: __ZL28InitializeSparseTexturesGLESPv, __ZNK5physx31PxVehicleWheelDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEEEEEjT_j: __ZNK5physx31PxVehicleWheelDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEEEEEjT_j, __Z49Register_UnityEngine_Resources_GetBuiltinResourcev: __Z49Register_UnityEngine_Resources_GetBuiltinResourcev, __Z56setPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf: __Z56setPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, _tt_cmap10_char_index: _tt_cmap10_char_index, __ZN9BlobWrite8TransferIN7mecanim5human5HumanEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim5human5HumanEEEvRT_PKc17TransferMetaFlags, __Z11SkinGenericILi4ELb0ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi4ELb0ELb0EEvR12SkinMeshInfo, __Z31setPxShape_SimulationFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE: __Z31setPxShape_SimulationFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE, __Z18GetITerrainManagerv: __Z18GetITerrainManagerv, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __ZN12AdsIdHandler16AddAdsIdDelegateEP12Il2CppObject: __ZN12AdsIdHandler16AddAdsIdDelegateEP12Il2CppObject, _UNITY_png_data_freer: _UNITY_png_data_freer, __Z31ReleaseInstanceBehaviourManagerv: __Z31ReleaseInstanceBehaviourManagerv, __Z41setPxArticulation_MaxProjectionIterationsPN5physx14PxArticulationEj: __Z41setPxArticulation_MaxProjectionIterationsPN5physx14PxArticulationEj, __ZN14PhysicsManager15BoxCastNonAllocERK8Vector3fS2_S2_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction: __ZN14PhysicsManager15BoxCastNonAllocERK8Vector3fS2_S2_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction, _UNITY_FT_Destroy_Class_cff_field_handlers: _UNITY_FT_Destroy_Class_cff_field_handlers, __ZNK16BaseVideoTexture14GetImageBufferEv: __ZNK16BaseVideoTexture14GetImageBufferEv, __ZN9ShaderLab22SerializedBindChannels8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab22SerializedBindChannels8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15PointEffector2D7SetDragEf: __ZN15PointEffector2D7SetDragEf, __ZN13ConstantForce17RemoveFromManagerEv: __ZN13ConstantForce17RemoveFromManagerEv, __ZN5IMGUI20MoveWindowFromLayoutER8GUIStateiRK5RectTIfE: __ZN5IMGUI20MoveWindowFromLayoutER8GUIStateiRK5RectTIfE, __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb: __ZN22VirtualJoystickManager30ConnectOrLookupVirtualJoystickEPKcb, _start_input_pass: _start_input_pass, __ZN5physx15NpParticleFluidD0Ev: __ZN5physx15NpParticleFluidD0Ev, __ZN5physx3Ext7D6Joint14setLinearLimitERKNS_18PxJointLinearLimitE: __ZN5physx3Ext7D6Joint14setLinearLimitERKNS_18PxJointLinearLimitE, __ZN5Umbra15SystemAllocator10deallocateEPv: __ZN5Umbra15SystemAllocator10deallocateEPv, _UNITY_FT_Stream_ReadUShort: _UNITY_FT_Stream_ReadUShort, __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIiPN17GeneralConnection10ConnectionEEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEED0Ev: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEED0Ev, __ZN5physx6shdfnd8internal9partitionINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceEKNS4_25SortCUDAProfileOccurencesEEEiPT_iiRT0_: __ZN5physx6shdfnd8internal9partitionINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceEKNS4_25SortCUDAProfileOccurencesEEEiPT_iiRT0_, __Z50Register_UnityEngine_Object_FindSceneObjectsOfTypev: __Z50Register_UnityEngine_Object_FindSceneObjectsOfTypev, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv, __ZN31CanvasBatchIntermediateRenderer14OnAssetDeletedEv: __ZN31CanvasBatchIntermediateRenderer14OnAssetDeletedEv, __ZN5physx5cloth8SwTetherC2Etf: __ZN5physx5cloth8SwTetherC2Etf, __ZN5physx14NpShapeManager30releaseExclusiveUserReferencesEv: __ZN5physx14NpShapeManager30releaseExclusiveUserReferencesEv, __ZN12AspectRatios8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12AspectRatios8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__2L15ucs4_to_utf16beEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L15ucs4_to_utf16beEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE, __Z50Register_UnityEngine_Collider2D_set_sharedMaterialv: __Z50Register_UnityEngine_Collider2D_set_sharedMaterialv, __Z29StdTemplateConversionFunctionIshEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIshEbPvR14SafeBinaryRead, __ZN9Animation23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Animation23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN37ConvexVsMeshContactGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN37ConvexVsMeshContactGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZNK17FileSystemHandler8IsHiddenERK13FileEntryData: __ZNK17FileSystemHandler8IsHiddenERK13FileEntryData, __ZN4FMOD7Channel7setModeEj: __ZN4FMOD7Channel7setModeEj, __ZN13EmscriptenWWW6CancelEv: __ZN13EmscriptenWWW6CancelEv, __ZN11IMGUIModule12AddGUIScriptER8ListNodeI13MonoBehaviourE: __ZN11IMGUIModule12AddGUIScriptER8ListNodeI13MonoBehaviourE, __Z47Register_UnityEngine_WheelCollider_GetWorldPosev: __Z47Register_UnityEngine_WheelCollider_GetWorldPosev, __ZL50StaticRegisterSceneLoadedCallback_LightmapSettingsPv: __ZL50StaticRegisterSceneLoadedCallback_LightmapSettingsPv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE19getConcreteTypeNameEv, __ZN29MotionVectorRenderLoopScratch15ThreadedCleanupEv: __ZN29MotionVectorRenderLoopScratch15ThreadedCleanupEv, __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE: __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIiPvEE, __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z42ParticleSystem_Get_Custom_PropMaxParticlesP12Il2CppObject: __Z42ParticleSystem_Get_Custom_PropMaxParticlesP12Il2CppObject, __ZN5physx2Sn21SerializationRegistryC2ERNS_9PxPhysicsE: __ZN5physx2Sn21SerializationRegistryC2ERNS_9PxPhysicsE, __ZNK5physx7NpCloth24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE: __ZNK5physx7NpCloth24getSeparationConstraintsEPNS_35PxClothParticleSeparationConstraintE, __Z56AnimatorOverrideController_CUSTOM_Internal_SetClipByNameP12Il2CppObjectP12Il2CppStringS0_: __Z56AnimatorOverrideController_CUSTOM_Internal_SetClipByNameP12Il2CppObjectP12Il2CppStringS0_, __ZN21GLESGpuProgramApplier11ApplyVectorERKN20GpuProgramParameters14ValueParameterEPK8Vector4ft: __ZN21GLESGpuProgramApplier11ApplyVectorERKN20GpuProgramParameters14ValueParameterEPK8Vector4ft, __ZN22BaseUnityConnectClient17SaveSessionValuesEv: __ZN22BaseUnityConnectClient17SaveSessionValuesEv, __ZN5physx2Sc5Scene18clothPreprocessingEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene18clothPreprocessingEPNS_10PxBaseTaskE, __Z43Register_UnityEngine_Rigidbody2D_IsSleepingv: __Z43Register_UnityEngine_Rigidbody2D_IsSleepingv, __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __Z32register_external_gfx_allocationPvjjPKci: __Z32register_external_gfx_allocationPvjjPKci, __ZN4UNET16ScriptingUpdater4InitEv: __ZN4UNET16ScriptingUpdater4InitEv, _cff_size_done: _cff_size_done, __ZNKSt3__27codecvtIDsc11__mbstate_tE13do_max_lengthEv: __ZNKSt3__27codecvtIDsc11__mbstate_tE13do_max_lengthEv, __ZNK12_GLOBAL__N_123FStreamNetworkOutStream11isConnectedEv: __ZNK12_GLOBAL__N_123FStreamNetworkOutStream11isConnectedEv, __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture: __ZN22RenderingCommandBuffer13GetAndCheckRTE24BuiltinRenderTextureTypeRKN9ShaderLab16FastPropertyNameEPKcPP13RenderTexture, __ZN6Camera34UpdatePreviousViewProjectionMatrixEv: __ZN6Camera34UpdatePreviousViewProjectionMatrixEv, __ZN9ShaderLab11ShaderState25RemoveUnsupportedProgramsEPK6Shader: __ZN9ShaderLab11ShaderState25RemoveUnsupportedProgramsEPK6Shader, __Z24RegisterStrippedTypeInfoI15AudioMixerGroupEviPKcS2_: __Z24RegisterStrippedTypeInfoI15AudioMixerGroupEviPKcS2_, __ZL23AddGpuProgramParametersR20GpuProgramParametersRKNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEERKNS2_INS4_15VectorParameterENS6_ISB_EEEEiP16PropertyNamesSet: __ZL23AddGpuProgramParametersR20GpuProgramParametersRKNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEERKNS2_INS4_15VectorParameterENS6_ISB_EEEEiP16PropertyNamesSet, __ZN11BoxCollider5ResetEv: __ZN11BoxCollider5ResetEv, __Z28Font_Get_Custom_PropMaterialP12Il2CppObject: __Z28Font_Get_Custom_PropMaterialP12Il2CppObject, __Z13RegisterClassI17SurfaceEffector2DEvv: __Z13RegisterClassI17SurfaceEffector2DEvv, __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_: __ZNSt3__26__sortIR12GreaterLayerPP14AnimationStateEEvT0_S6_T_, __ZNK18BuoyancyEffector2D16UseContactUpdateEv: __ZNK18BuoyancyEffector2D16UseContactUpdateEv, __Z47Register_UnityEngine_Component_BroadcastMessagev: __Z47Register_UnityEngine_Component_BroadcastMessagev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm, __ZN23AllocationRootReference15RemoveReferenceEP24ProfilerAllocationHeaderj: __ZN23AllocationRootReference15RemoveReferenceEP24ProfilerAllocationHeaderj, __ZN6detail14AlignedPointerIfEC2EPKf: __ZN6detail14AlignedPointerIfEC2EPKf, __ZNK5physx18PxVehicleDriveTank8isKindOfEPKc: __ZNK5physx18PxVehicleDriveTank8isKindOfEPKc, __ZNK8Animator20IsInMatchTargetStateEv: __ZNK8Animator20IsInMatchTargetStateEv, __Z36Register_UnityEngine_GUI_set_changedv: __Z36Register_UnityEngine_GUI_set_changedv, __ZNSt3__26localeC2ERKS0_S2_i: __ZNSt3__26localeC2ERKS0_S2_i, __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_zDriveP12Il2CppObjectP10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_zDriveP12Il2CppObjectP10JointDrive, __ZThn4_N5physx5cloth8SwFabricD0Ev: __ZThn4_N5physx5cloth8SwFabricD0Ev, __ZN14GrowableBufferC2ERK10MemLabelIdjj: __ZN14GrowableBufferC2ERK10MemLabelIdjj, __ZN13RuntimeStaticI12AdsIdHandlerE10InitializeEv: __ZN13RuntimeStaticI12AdsIdHandlerE10InitializeEv, __ZN12_GLOBAL__N_123DoubleBufferedOutStream10disconnectEv: __ZN12_GLOBAL__N_123DoubleBufferedOutStream10disconnectEv, __ZNK24DownloadHandlerAudioClip13GetMemorySizeEv: __ZNK24DownloadHandlerAudioClip13GetMemorySizeEv, __ZN11WindManagerC2Ev: __ZN11WindManagerC2Ev, __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx7NpCloth13setTargetPoseERKNS_11PxTransformE: __ZN5physx7NpCloth13setTargetPoseERKNS_11PxTransformE, __Z43ParticleSystem_Set_Custom_PropStartRotationP12Il2CppObjectf: __Z43ParticleSystem_Set_Custom_PropStartRotationP12Il2CppObjectf, __ZN27AnimationLayerMixerPlayable18SetInputConnectionEP8Playablei: __ZN27AnimationLayerMixerPlayable18SetInputConnectionEP8Playablei, __Z42Register_UnityEngine_GUIStyle_get_wordWrapv: __Z42Register_UnityEngine_GUIStyle_get_wordWrapv, __ZZ23InitPlayerLoopCallbacksvEN36InitializationPlayerUpdateTimestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36InitializationPlayerUpdateTimestruct7ForwardEv, __ZN15HeightMeshQueryC2Ev: __ZN15HeightMeshQueryC2Ev, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED2Ev, __Z51Register_UnityEngine_AndroidJNI_CallStaticIntMethodv: __Z51Register_UnityEngine_AndroidJNI_CallStaticIntMethodv, _getwchar: _getwchar, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv, __Z49AnimationClipPlayable_CUSTOM_GetRemoveStartOffsetR9HPlayable: __Z49AnimationClipPlayable_CUSTOM_GetRemoveStartOffsetR9HPlayable, __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESG_RKT_, __Z43Register_UnityEngine_Material_EnableKeywordv: __Z43Register_UnityEngine_Material_EnableKeywordv, __ZN12_GLOBAL__N_121SocketNetworkInStream10disconnectEv: __ZN12_GLOBAL__N_121SocketNetworkInStream10disconnectEv, _jsimd_h2v1_upsample: _jsimd_h2v1_upsample, _wcsrchr: _wcsrchr, __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetSeparateAxesv: __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetSeparateAxesv, __Z48Register_UnityEngine_SpringJoint2D_get_frequencyv: __Z48Register_UnityEngine_SpringJoint2D_get_frequencyv, __Z42PointEffector2D_Get_Custom_PropAngularDragP12Il2CppObject: __Z42PointEffector2D_Get_Custom_PropAngularDragP12Il2CppObject, _jsimd_rgb_gray_convert: _jsimd_rgb_gray_convert, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj70ENS_22PxRepXPropertyAccessorILj70ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj70ENS_22PxRepXPropertyAccessorILj70ES4_ffEEEEvRKT0_, __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv: __ZN11UnityEngine15PlatformWrapper28GetTextureFormatSupportFlagsEv, __Z63Register_UnityEngine_TerrainData_get_Internal_baseMapResolutionv: __Z63Register_UnityEngine_TerrainData_get_Internal_baseMapResolutionv, _UNITY_FT_Create_Class_pshinter_module_class: _UNITY_FT_Create_Class_pshinter_module_class, __ZN19RuntimeSceneManager9GetScenesERK13dynamic_arrayIiLj4EERS0_IP10UnitySceneLj4EE: __ZN19RuntimeSceneManager9GetScenesERK13dynamic_arrayIiLj4EERS0_IP10UnitySceneLj4EE, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEED2Ev: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEED2Ev, __Z47AudioSettings_Get_Custom_PropUnityAudioDisabledv: __Z47AudioSettings_Get_Custom_PropUnityAudioDisabledv, __ZNKSt3__210moneypunctIwLb0EE11frac_digitsEv: __ZNKSt3__210moneypunctIwLb0EE11frac_digitsEv, _cf2_setError: _cf2_setError, __ZNK5physx2Sc5Scene29getMaxNbContactDataBlocksUsedEv: __ZNK5physx2Sc5Scene29getMaxNbContactDataBlocksUsedEv, __Z53Register_UnityEngine_Physics_set_defaultContactOffsetv: __Z53Register_UnityEngine_Physics_set_defaultContactOffsetv, __ZN20TextRenderingPrivate7GUIText11SetMaterialEP8Material: __ZN20TextRenderingPrivate7GUIText11SetMaterialEP8Material, __Z46NavMeshAgent_CUSTOM_ActivateCurrentOffMeshLinkP12Il2CppObjecth: __Z46NavMeshAgent_CUSTOM_ActivateCurrentOffMeshLinkP12Il2CppObjecth, __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEEEEvRT_j, __ZN5Umbra8QueryExtC2Ev: __ZN5Umbra8QueryExtC2Ev, __ZN16Physics2DManager20IgnoreLayerCollisionEiib: __ZN16Physics2DManager20IgnoreLayerCollisionEiib, __ZN13SplatDatabase24DidCreateOnLoadingThreadEv: __ZN13SplatDatabase24DidCreateOnLoadingThreadEv, _llroundl: _llroundl, __ZThn12_NK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, _llroundf: _llroundf, __Z45ParticleSystem_Get_Custom_PropSimulationSpaceP12Il2CppObject: __Z45ParticleSystem_Get_Custom_PropSimulationSpaceP12Il2CppObject, __Z32PlayerConnection_CUSTOM_SendFileP12Il2CppStringP11Il2CppArray: __Z32PlayerConnection_CUSTOM_SendFileP12Il2CppStringP11Il2CppArray, __Z44Register_UnityEngine_Canvas_get_pixelPerfectv: __Z44Register_UnityEngine_Canvas_get_pixelPerfectv, _isalnum: _isalnum, __ZN19TouchPhaseEmulation9ExpireOldER9TouchImpl: __ZN19TouchPhaseEmulation9ExpireOldER9TouchImpl, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags, __ZN5physx3Ext13DistanceJoint15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx3Ext13DistanceJoint15exportExtraDataERNS_22PxSerializationContextE, __Z49Register_UnityEngine_AudioReverbFilter_get_roomLFv: __Z49Register_UnityEngine_AudioReverbFilter_get_roomLFv, __Z10DeleteFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z10DeleteFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx10getInverseERNS_7PxMat33ERNS_6PxVec3ERKS0_RKS2_: __ZN5physx10getInverseERNS_7PxMat33ERNS_6PxVec3ERKS0_RKS2_, __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorINS_4pairIyP17VertexDeclarationEENS_9allocatorIS4_EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z36AndroidJNI_CUSTOM_GetStringUTFLength13Il2Cpp_IntPtr: __Z36AndroidJNI_CUSTOM_GetStringUTFLength13Il2Cpp_IntPtr, __ZL27AnimationVisibilityCallbackPvS_i: __ZL27AnimationVisibilityCallbackPvS_i, __ZN5physx23PxVehicleWheels4SimDataC2Ev: __ZN5physx23PxVehicleWheels4SimDataC2Ev, __ZNK8Material12GetPassCountEv: __ZNK8Material12GetPassCountEv, __ZN9Transform24UpdateTransformAccessorsER18TransformHierarchyj: __ZN9Transform24UpdateTransformAccessorsER18TransformHierarchyj, _bitshift64Ashr: _bitshift64Ashr, __ZNK8Material26GetTypeInfoVirtualInternalEv: __ZNK8Material26GetTypeInfoVirtualInternalEv, __ZN5physx15PxVehicleWheels15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx15PxVehicleWheels15importExtraDataERNS_24PxDeserializationContextE, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8overflowEi: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8overflowEi, __ZN11Rigidbody2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN11Rigidbody2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx8debugger4comm21CreatePropertyMessageD0Ev: __ZN5physx8debugger4comm21CreatePropertyMessageD0Ev, _putwchar: _putwchar, _do_setrlimit: _do_setrlimit, __ZN21WorldParticleCollider22UpdateParticleColliderERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof: __ZN21WorldParticleCollider22UpdateParticleColliderERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof, __Z34getPxCloth_CentrifugalInertiaScalePKN5physx7PxClothE: __Z34getPxCloth_CentrifugalInertiaScalePKN5physx7PxClothE, __ZN18GfxFramebufferGLES19RegisterExternalFBOERK20GfxRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEE: __ZN18GfxFramebufferGLES19RegisterExternalFBOERK20GfxRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEE, __ZN4crnd12crn_unpacker22decode_alpha_endpointsEv: __ZN4crnd12crn_unpacker22decode_alpha_endpointsEv, __ZNK14ParticleSystem11GetNumTilesERiS0_: __ZNK14ParticleSystem11GetNumTilesERiS0_, __Z62Register_UnityEngine_Application_set_backgroundLoadingPriorityv: __Z62Register_UnityEngine_Application_set_backgroundLoadingPriorityv, __Z23CullDynamicObjectsUmbraPK4AABBPKN5Umbra15OcclusionBufferER9IndexList: __Z23CullDynamicObjectsUmbraPK4AABBPKN5Umbra15OcclusionBufferER9IndexList, __ZNK19ShaderPropertySheet14GetVectorArrayEi: __ZNK19ShaderPropertySheet14GetVectorArrayEi, __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j: __ZN13RenderTexture9SetActiveERK20GfxRenderTargetSetupPPS_j, __ZN21DownloadHandlerScript22OnReceiveContentLengthEj: __ZN21DownloadHandlerScript22OnReceiveContentLengthEj, _tt_cmap4_char_next: _tt_cmap4_char_next, __ZN8Animator19SetLookAtBodyWeightEf: __ZN8Animator19SetLookAtBodyWeightEf, __ZN11ForceModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E: __ZN11ForceModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E, __ZN8Scalar4fC2Ebbbb: __ZN8Scalar4fC2Ebbbb, __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j: __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags, __ZN7Terrain8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7Terrain8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__210istrstreamD2Ev: __ZNSt3__210istrstreamD2Ev, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE8recreateEj, __Z28getPxVehicleChassisDataMMassPKN5physx20PxVehicleChassisDataE: __Z28getPxVehicleChassisDataMMassPKN5physx20PxVehicleChassisDataE, __ZN5physx8debugger14PvdMarshallingIhsE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhsE12marshalBlockEPKhPhj, __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17CapsuleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f, __Z30GUIText_Set_Custom_PropTabSizeP12Il2CppObjectf: __Z30GUIText_Set_Custom_PropTabSizeP12Il2CppObjectf, __ZN5physx2Sc5Scene10postSolverEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene10postSolverEPNS_10PxBaseTaskE, __ZN4FMOD6SoundI11getSubSoundEiPPNS_5SoundE: __ZN4FMOD6SoundI11getSubSoundEiPPNS_5SoundE, __ZN9GfxDevice20SetComputeBufferDataE15ComputeBufferIDPKvj: __ZN9GfxDevice20SetComputeBufferDataE15ComputeBufferIDPKvj, __ZN4FMOD7Channel11setPositionEjj: __ZN4FMOD7Channel11setPositionEjj, __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z58Register_UnityEngine_TargetJoint2D_get_autoConfigureTargetv: __Z58Register_UnityEngine_TargetJoint2D_get_autoConfigureTargetv, __Z22CreateMutexLockedQueuev: __Z22CreateMutexLockedQueuev, __Z50Register_UnityEngine_GameObject_GetComponentByNamev: __Z50Register_UnityEngine_GameObject_GetComponentByNamev, __ZN5physx2Sc8BodyCore20clearSpatialVelocityEbb: __ZN5physx2Sc8BodyCore20clearSpatialVelocityEbb, _wcsncat: _wcsncat, __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZN15LightProbeGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15LightProbeGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK7VRInput21GetReferenceTransformE4PPtrI9TransformE: __ZNK7VRInput21GetReferenceTransformE4PPtrI9TransformE, __ZN5physx15PxSerialization21createSerialObjectIdsERNS_12PxCollectionEy: __ZN5physx15PxSerialization21createSerialObjectIdsERNS_12PxCollectionEy, __Z6GetBitPKhRj: __Z6GetBitPKhRj, __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIbEEvRT_PKc17TransferMetaFlagsb, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, _iswupper: _iswupper, __ZN13GfxDeviceNull15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace: __ZN13GfxDeviceNull15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace, __ZNK5physx7NpShape15getGeometryTypeEv: __ZNK5physx7NpShape15getGeometryTypeEv, _dirname: _dirname, __ZN4FMOD6System9unlockDSPEv: __ZN4FMOD6System9unlockDSPEv, __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv: __ZN5physx22PxVehicleWheelsDynData22setTireForceShaderDataEjPKv, __Z4SortRK10Matrix4x4fS1_R23ParticleSystemParticles22ParticleSystemSortModeR31ParticleSystemParticlesTempData: __Z4SortRK10Matrix4x4fS1_R23ParticleSystemParticles22ParticleSystemSortModeR31ParticleSystemParticlesTempData, __GLOBAL__sub_I_runtime_animation2_lump_cpp: __GLOBAL__sub_I_runtime_animation2_lump_cpp, __ZN19MemoryProfilerStats21AddDynamicObjectCountEP6Objecti: __ZN19MemoryProfilerStats21AddDynamicObjectCountEP6Objecti, __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j: __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j, __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE: __ZN19VREyeTextureManager21CreateEyeTextureStageEjbiiRNS_12TextureStageE, __ZN12_GLOBAL__N_115StringTableImpl11registerStrEPKcRb: __ZN12_GLOBAL__N_115StringTableImpl11registerStrEPKcRb, __ZN21UnityWebStream_Static11WriteStringERNSt3__26vectorIhNS0_9allocatorIhEEEERKNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEE: __ZN21UnityWebStream_Static11WriteStringERNSt3__26vectorIhNS0_9allocatorIhEEEERKNS0_12basic_stringIcNS0_11char_traitsIcEENS2_IcEEEE, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5widenEc: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5widenEc, __Z36AsyncOperation_Get_Custom_PropIsDoneP12Il2CppObject: __Z36AsyncOperation_Get_Custom_PropIsDoneP12Il2CppObject, __ZN18ScBeforeSolverTaskD0Ev: __ZN18ScBeforeSolverTaskD0Ev, __Z28ParticleEmitter_CUSTOM_Emit2P12Il2CppObjecti: __Z28ParticleEmitter_CUSTOM_Emit2P12Il2CppObjecti, __Z46Register_UnityEngine_AnimationState_get_weightv: __Z46Register_UnityEngine_AnimationState_get_weightv, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9underflowEv, __ZN11UnityEngine9Analytics9PerfEvent12SetSceneLoadERK8UnityStrdddd: __ZN11UnityEngine9Analytics9PerfEvent12SetSceneLoadERK8UnityStrdddd, __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2Ev: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK13TextRendering4Font9GetAscentEv: __ZNK13TextRendering4Font9GetAscentEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE, __ZN5Umbra4AABB14validateBoundsEv: __ZN5Umbra4AABB14validateBoundsEv, __ZNK5physx3Ext13DistanceJoint12getStiffnessEv: __ZNK5physx3Ext13DistanceJoint12getStiffnessEv, __Z32AndroidJNI_CUSTOM_CallVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z32AndroidJNI_CUSTOM_CallVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNK13TranslateGLES13GetFormatDescE17DepthBufferFormat: __ZNK13TranslateGLES13GetFormatDescE17DepthBufferFormat, __ZN10systeminfo24GetRuntimePlatformStringEv: __ZN10systeminfo24GetRuntimePlatformStringEv, __ZL26default_unexpected_handlerv: __ZL26default_unexpected_handlerv, __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_: __ZN11AudioFilter8TransferI17RemapPPtrTransferEEvRT_, __ZN13MonoBehaviour21StartCoroutineManagedEPKcP12Il2CppObject: __ZN13MonoBehaviour21StartCoroutineManagedEPKcP12Il2CppObject, __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL25solveContact4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z37setPxArticulation_SeparationTolerancePN5physx14PxArticulationEf: __Z37setPxArticulation_SeparationTolerancePN5physx14PxArticulationEf, __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE: __ZNK16MemoryFileSystem30GetRelativeCaseInsensitivePathEPKcRNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEE, __ZN5physx13printCCDDebugEPKcPKNS_12PxsRigidBodyENS_14PxGeometryType4EnumEb: __ZN5physx13printCCDDebugEPKcPKNS_12PxsRigidBodyENS_14PxGeometryType4EnumEb, __ZN17Physics2DSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17Physics2DSettings8TransferI24GenerateTypeTreeTransferEEvRT_, _null_convert_24: _null_convert_24, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE, __Z33WheelCollider_CUSTOM_GetWorldPoseP12Il2CppObjectP8Vector3fP11Quaternionf: __Z33WheelCollider_CUSTOM_GetWorldPoseP12Il2CppObjectP8Vector3fP11Quaternionf, __Z40ConfigurableJoint_Set_Custom_PropYMotionP12Il2CppObjecti: __Z40ConfigurableJoint_Set_Custom_PropYMotionP12Il2CppObjecti, __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularZLimitv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularZLimitv, __ZNKSt3__210__time_put8__do_putEPcRS1_PK2tmcc: __ZNKSt3__210__time_put8__do_putEPcRS1_PK2tmcc, __ZN5physx8debugger4comm14CreateProperty9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm14CreateProperty9serializeERNS1_15EventSerializerE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcj, __ZN5physx2Sn9StrToImplINS_18PxClothFabricPhaseEE5strtoERS2_RPKc: __ZN5physx2Sn9StrToImplINS_18PxClothFabricPhaseEE5strtoERS2_RPKc, __Z38Renderer_Get_Custom_PropReceiveShadowsP12Il2CppObject: __Z38Renderer_Get_Custom_PropReceiveShadowsP12Il2CppObject, __ZN5LightD2Ev: __ZN5LightD2Ev, __ZN10HumanTrait15InitializeClassEv: __ZN10HumanTrait15InitializeClassEv, __Z14GetTimeManagerv: __Z14GetTimeManagerv, __Z45Register_UnityEngine_Animator_get_cullingModev: __Z45Register_UnityEngine_Animator_get_cullingModev, __ZN5physx8debugger11StringTable6createERNS_19PxAllocatorCallbackE: __ZN5physx8debugger11StringTable6createERNS_19PxAllocatorCallbackE, __ZN19TransportJavaScript7CleanupEv: __ZN19TransportJavaScript7CleanupEv, __Z12GUIDToStringRK9UnityGUIDPc: __Z12GUIDToStringRK9UnityGUIDPc, __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor: __ZN15FileSystemEntry4LockE12FileLockModeP12FileAccessor, __Z48ParticleSystem_TrailModule_CUSTOM_GetTextureModeP12Il2CppObject: __Z48ParticleSystem_TrailModule_CUSTOM_GetTextureModeP12Il2CppObject, __ZN20TextRenderingPrivate8TextMesh17MainThreadCleanupEv: __ZN20TextRenderingPrivate8TextMesh17MainThreadCleanupEv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED2Ev, _png_get_uint_32: _png_get_uint_32, _UNITY_FT_Glyph_StrokeBorder: _UNITY_FT_Glyph_StrokeBorder, __Z53Register_UnityEngine_QualitySettings_get_antiAliasingv: __Z53Register_UnityEngine_QualitySettings_get_antiAliasingv, __ZN8Scalar4fC2Eiiii: __ZN8Scalar4fC2Eiiii, __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __Z51Register_UnityEngine_Shader_GetGlobalFloatArrayImplv: __Z51Register_UnityEngine_Shader_GetGlobalFloatArrayImplv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setProjectionPlaneERKNS_6PxVec3Ef: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setProjectionPlaneERKNS_6PxVec3Ef, __ZNK14ParticleSystem9IsStoppedEv: __ZNK14ParticleSystem9IsStoppedEv, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE7seekposENS_4fposI11__mbstate_tEEj, __ZL18getFrictionPatchesRN5physx26PxcFrictionPatchStreamPairERNS_20PxcCorrelationBufferEPKhjRKNS_11PxTransformES8_f: __ZL18getFrictionPatchesRN5physx26PxcFrictionPatchStreamPairERNS_20PxcCorrelationBufferEPKhjRKNS_11PxTransformES8_f, __ZN6Socket15SetSocketOptionEiiPvj: __ZN6Socket15SetSocketOptionEiiPvj, __Z41Register_UnityEngine_Cursor_get_lockStatev: __Z41Register_UnityEngine_Cursor_get_lockStatev, __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_SetBoxP12Il2CppObjectRK8Vector3f: __Z54ParticleSystem_ShapeModule_CUSTOM_INTERNAL_CALL_SetBoxP12Il2CppObjectRK8Vector3f, __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext: __Z14SetupLightmapsRK8Vector4fS1_R17ShaderPassContext, __Z58Register_UnityEngine_Screen_get_autorotateToLandscapeRightv: __Z58Register_UnityEngine_Screen_get_autorotateToLandscapeRightv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv, __Z50Register_UnityEngine_Mesh_GetBlendShapeFrameWeightv: __Z50Register_UnityEngine_Mesh_GetBlendShapeFrameWeightv, __Z20DestroyObjectDelayedP6Objectf: __Z20DestroyObjectDelayedP6Objectf, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED0Ev: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED0Ev, __Z45Register_UnityEngine_GUIUtility_set_mouseUsedv: __Z45Register_UnityEngine_GUIUtility_set_mouseUsedv, __ZN13GfxDeviceNull14DisableScissorEv: __ZN13GfxDeviceNull14DisableScissorEv, _UNITY_png_get_bit_depth: _UNITY_png_get_bit_depth, __ZN11TimeManagerC2E10MemLabelId18ObjectCreationMode: __ZN11TimeManagerC2E10MemLabelId18ObjectCreationMode, __ZN8Collider16RecreateColliderEPK9Rigidbody: __ZN8Collider16RecreateColliderEPK9Rigidbody, __ZN4FMOD7SystemI19setSoftwareChannelsEi: __ZN4FMOD7SystemI19setSoftwareChannelsEi, _jsimd_can_fdct_float: _jsimd_can_fdct_float, __Z53Register_UnityEngine_Renderer_get_isPartOfStaticBatchv: __Z53Register_UnityEngine_Renderer_get_isPartOfStaticBatchv, __ZN11AudioFilter6GetDSPEv: __ZN11AudioFilter6GetDSPEv, __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z56Register_UnityEngine_RenderTexture_Internal_SetDimensionv: __Z56Register_UnityEngine_RenderTexture_Internal_SetDimensionv, __ZN11UnityEngine9Analytics15AnalyticsConfig11ResetValuesEv: __ZN11UnityEngine9Analytics15AnalyticsConfig11ResetValuesEv, __ZNSt3__211__call_onceERVmPvPFvS2_E: __ZNSt3__211__call_onceERVmPvPFvS2_E, __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene: __ZN19RuntimeSceneManager14CanUnloadSceneEP10UnityScene, __Z22ExtractRenderNodeQueueRK11CullResults15ExtractionFlagsR15RenderNodeQueue: __Z22ExtractRenderNodeQueueRK11CullResults15ExtractionFlagsR15RenderNodeQueue, __Z64Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetDatav: __Z64Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetDatav, __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b: __ZN4Mesh14GetMeshBuffersER11MeshBuffersjPS_b, __Z42Register_UnityEngine_Animator_SetIntegerIDv: __Z42Register_UnityEngine_Animator_SetIntegerIDv, __ZN17SurfaceEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17SurfaceEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11TerrainData23SetLightmapIndexOnUsersEi: __ZN11TerrainData23SetLightmapIndexOnUsersEi, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, __ZN24AudioScriptBufferManagerC2Ev: __ZN24AudioScriptBufferManagerC2Ev, __Z12SHA1ToStringPh: __Z12SHA1ToStringPh, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier1ELi16EEE8__appendEj, __ZN4FMOD4DSPI12setParameterEif: __ZN4FMOD4DSPI12setParameterEif, __Z21InitializeAudioModulev: __Z21InitializeAudioModulev, __ZN20TextRenderingPrivate8FontImpl16ResetPackingDataEv: __ZN20TextRenderingPrivate8FontImpl16ResetPackingDataEv, __ZN7Texture19GetNativeTexturePtrEv: __ZN7Texture19GetNativeTexturePtrEv, __ZN17Physics2DSettings22SetMaxTranslationSpeedEf: __ZN17Physics2DSettings22SetMaxTranslationSpeedEf, __Z18Transfer_BlittableI9JSONWriteLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z21GetAsyncUploadManagerv: __Z21GetAsyncUploadManagerv, __ZN5physx14PxsAABBManager13setActorDirtyEj: __ZN5physx14PxsAABBManager13setActorDirtyEj, __ZN23AnimationOffsetPlayable20GetPlayableClassNameEv: __ZN23AnimationOffsetPlayable20GetPlayableClassNameEv, __ZNK19AudioHighPassFilter26GetTypeInfoVirtualInternalEv: __ZNK19AudioHighPassFilter26GetTypeInfoVirtualInternalEv, __ZZ19InitializeGfxDevicejEN38PreLateUpdateEndGraphicsJobsLatestruct7ForwardEv: __ZZ19InitializeGfxDevicejEN38PreLateUpdateEndGraphicsJobsLatestruct7ForwardEv, __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI9RigidbodyE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx2Sc15ArticulationSim16createDriveCacheEfj: __ZNK5physx2Sc15ArticulationSim16createDriveCacheEfj, __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesEPKS2_PS2_RNS3_18ImpulseAccumulatorE: __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesEPKS2_PS2_RNS3_18ImpulseAccumulatorE, __ZN17GenericDynamicVBO20ReleaseChunkInternalERK21DynamicVBOChunkHandlejj: __ZN17GenericDynamicVBO20ReleaseChunkInternalERK21DynamicVBOChunkHandlejj, __Z23CalculateLightingLayersRK12ActiveLights: __Z23CalculateLightingLayersRK12ActiveLights, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI7Hash128Lj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI7Hash128Lj8EEEEvRT_17TransferMetaFlags, _fmodl: _fmodl, __ZNKSt3__220__time_get_c_storageIcE8__monthsEv: __ZNKSt3__220__time_get_c_storageIcE8__monthsEv, _fmodf: _fmodf, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, _strtof_l: _strtof_l, __ZN12CachedWriter11Align4WriteEv: __ZN12CachedWriter11Align4WriteEv, __Z20DoDeferredRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb: __Z20DoDeferredRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb, __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_: __ZNSt3__26vectorIiNS_9allocatorIiEEE21__push_back_slow_pathIKiEEvRT_, __ZN5Umbra14TomeCollection4initEPNS_9AllocatorE: __ZN5Umbra14TomeCollection4initEPNS_9AllocatorE, __ZN19RuntimeSceneManager11CreateSceneEv: __ZN19RuntimeSceneManager11CreateSceneEv, __Z43Register_UnityEngine_CanvasRenderer_SetMeshv: __Z43Register_UnityEngine_CanvasRenderer_SetMeshv, __ZN5physx15PxsArticulationC2Ev: __ZN5physx15PxsArticulationC2Ev, __Z40RelativeJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf: __Z40RelativeJoint2D_Set_Custom_PropMaxTorqueP12Il2CppObjectf, _ps_get_standard_strings: _ps_get_standard_strings, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_RKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_RKS5_, __ZN5physx8debugger14PvdMarshallingIjdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIjdE12marshalBlockEPKhPhj, __Z35getPxParticleBase_MaxMotionDistancePKN5physx14PxParticleBaseE: __Z35getPxParticleBase_MaxMotionDistancePKN5physx14PxParticleBaseE, __ZNK5physx2Sc18ParticleSystemCore16getContactOffsetEv: __ZNK5physx2Sc18ParticleSystemCore16getContactOffsetEv, __ZNK18DownloadHandlerVFS8GetBytesEv: __ZNK18DownloadHandlerVFS8GetBytesEv, __ZN5physx7NpScene14removeMaterialERNS_10NpMaterialE: __ZN5physx7NpScene14removeMaterialERNS_10NpMaterialE, __ZN5physx16PxsIslandManager24setEdgeArticulationJointERKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager24setEdgeArticulationJointERKNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE, __Z48Register_UnityEngine_AudioSource_set_timeSamplesv: __Z48Register_UnityEngine_AudioSource_set_timeSamplesv, __ZN5physx2Sc10NPhaseCore25addToDirtyInteractionListEPNS0_15CoreInteractionE: __ZN5physx2Sc10NPhaseCore25addToDirtyInteractionListEPNS0_15CoreInteractionE, __ZN9ShaderLab6TexEnvC2ERKNS_25SerializedTexturePropertyE: __ZN9ShaderLab6TexEnvC2ERKNS_25SerializedTexturePropertyE, __ZNKSt3__27codecvtIcc11__mbstate_tE16do_always_noconvEv: __ZNKSt3__27codecvtIcc11__mbstate_tE16do_always_noconvEv, __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc: __ZN9Scripting16FindMethodCachedEP11Il2CppClassPKc, __ZN27ParticleSystemReadOnlyState5ResetEv: __ZN27ParticleSystemReadOnlyState5ResetEv, __ZNK5physx11PxSceneDesc7isValidEv: __ZNK5physx11PxSceneDesc7isValidEv, __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z59Register_UnityEngine_TerrainData_UpgradeScaledTreePrototypev: __Z59Register_UnityEngine_TerrainData_UpgradeScaledTreePrototypev, __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv: __ZN24dense_hashtable_iteratorINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E30advance_past_empty_and_deletedEv, __ZNK23ArchiveStorageConverter16GetDirectoryInfoEv: __ZNK23ArchiveStorageConverter16GetDirectoryInfoEv, __Z43CanvasRenderer_Get_Custom_PropMaterialCountP12Il2CppObject: __Z43CanvasRenderer_Get_Custom_PropMaterialCountP12Il2CppObject, __ZN10GameObjectD2Ev: __ZN10GameObjectD2Ev, __ZN10UnityScene23CreateLevelGameManagersEv: __ZN10UnityScene23CreateLevelGameManagersEv, __ZN5physx6shdfnd5ArrayIPKNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPKNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv, __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv: __ZNK9BlobWrite24HasOffsetPtrWithDebugPtrEv, __ZN15CollisionModule9ResetSeedERK27ParticleSystemReadOnlyState: __ZN15CollisionModule9ResetSeedERK27ParticleSystemReadOnlyState, __Z29getPxSceneDescStaticStructurePKN5physx11PxSceneDescE: __Z29getPxSceneDescStaticStructurePKN5physx11PxSceneDescE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags, __Z45Register_UnityEngine_AnimationState_get_speedv: __Z45Register_UnityEngine_AnimationState_get_speedv, __Z13RegisterClassI12NavMeshAgentEvv: __Z13RegisterClassI12NavMeshAgentEvv, __ZNK5physx27PxVehicleDifferential4WData7isValidEv: __ZNK5physx27PxVehicleDifferential4WData7isValidEv, __Z62ParticleSystem_MainModule_CUSTOM_GetRandomizeRotationDirectionP12Il2CppObject: __Z62ParticleSystem_MainModule_CUSTOM_GetRandomizeRotationDirectionP12Il2CppObject, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEvPT_jRKT0_RKT1_j, __ZN21DownloadHandlerScriptD0Ev: __ZN21DownloadHandlerScriptD0Ev, __ZN4Mesh12SetBindposesEPK10Matrix4x4fi: __ZN4Mesh12SetBindposesEPK10Matrix4x4fi, __ZN11UnityEngine7ConnectL18StaticCallOnUpdateEPv: __ZN11UnityEngine7ConnectL18StaticCallOnUpdateEPv, __ZN10InputEventD2Ev: __ZN10InputEventD2Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_secondaryAxisP12Il2CppObjectRK8Vector3f: __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_secondaryAxisP12Il2CppObjectRK8Vector3f, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED2Ev, __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_: __ZN15ParticleEmitter8TransferI14SafeBinaryReadEEvRT_, __Z50ShaderVariantCollection_Get_Custom_PropShaderCountP12Il2CppObject: __Z50ShaderVariantCollection_Get_Custom_PropShaderCountP12Il2CppObject, __ZN7mecanim4hand8HandPoseC2Ev: __ZN7mecanim4hand8HandPoseC2Ev, __ZN15OcclusionPortal9SetIsOpenEb: __ZN15OcclusionPortal9SetIsOpenEb, __Z44CharacterJoint_CUSTOM_INTERNAL_set_swingAxisP12Il2CppObjectRK8Vector3f: __Z44CharacterJoint_CUSTOM_INTERNAL_set_swingAxisP12Il2CppObjectRK8Vector3f, __Z23AssetBundle_CUSTOM_LoadP12Il2CppObjectP12Il2CppStringS0_: __Z23AssetBundle_CUSTOM_LoadP12Il2CppObjectP12Il2CppStringS0_, __ZN30ReportScriptingObjectsTransfer8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags: __ZN30ReportScriptingObjectsTransfer8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags, __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _isalpha: _isalpha, __Z43setPxVehicleWheelsSimData_WheelEnabledStatePN5physx22PxVehicleWheelsSimDataEjb: __Z43setPxVehicleWheelsSimData_WheelEnabledStatePN5physx22PxVehicleWheelsSimDataEjb, __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_10MemLabelId17TransferMetaFlags, _UNITY_png_read_filter_row_paeth_multibyte_pixel: _UNITY_png_read_filter_row_paeth_multibyte_pixel, __ZN17FileSystemHandler5TouchER13FileEntryData: __ZN17FileSystemHandler5TouchER13FileEntryData, __ZN14PhysicsManager7BoxTestERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction: __ZN14PhysicsManager7BoxTestERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteraction, __ZN14ParticleSystem14SyncRenderJobsEv: __ZN14ParticleSystem14SyncRenderJobsEv, __ZNK11AudioSource21AreAllChannelsVirtualEv: __ZNK11AudioSource21AreAllChannelsVirtualEv, __Z44setPxParticleReadDataCollisionVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE: __Z44setPxParticleReadDataCollisionVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE, __ZN9LensFlare23VirtualRedirectTransferER14SafeBinaryRead: __ZN9LensFlare23VirtualRedirectTransferER14SafeBinaryRead, __Z13RegisterClassI11Rigidbody2DEvv: __Z13RegisterClassI11Rigidbody2DEvv, __Z36AndroidJNI_CUSTOM_SetIntArrayElement13Il2Cpp_IntPtrii: __Z36AndroidJNI_CUSTOM_SetIntArrayElement13Il2Cpp_IntPtrii, __Z41Register_UnityEngine_GUI_get_blitMaterialv: __Z41Register_UnityEngine_GUI_get_blitMaterialv, __ZN6Camera23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Camera23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN16ParticleAnimator23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16ParticleAnimator23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9GfxDevice28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi: __ZN9GfxDevice28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi, __Z39setPxVehicleDriveDynData_GearSwitchTimePN5physx21PxVehicleDriveDynDataEf: __Z39setPxVehicleDriveDynData_GearSwitchTimePN5physx21PxVehicleDriveDynDataEf, __Z39Register_UnityEngine_Rigidbody_set_massv: __Z39Register_UnityEngine_Rigidbody_set_massv, __ZN29UnityWebRequestAsyncOperationD0Ev: __ZN29UnityWebRequestAsyncOperationD0Ev, __Z58CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeiiS0_: __Z58CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawProceduralP12Il2CppObjectRK10Matrix4x4fS0_i16GfxPrimitiveTypeiiS0_, __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN5Flare12FlareElementENS0_9allocatorIS3_EEEEEvRT_j, __ZNK13RenderManager28IsDisplayReferencedByCamerasEi: __ZNK13RenderManager28IsDisplayReferencedByCamerasEi, __ZN15SerializeTraitsIN7mecanim5human6HandleEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIN7mecanim5human6HandleEE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv: __ZNK5physx2Sc8ShapeSim15getPxsRigidCoreEv, __Z50Register_UnityEngine_SkinnedMeshRenderer_set_bonesv: __Z50Register_UnityEngine_SkinnedMeshRenderer_set_bonesv, __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPNS_17PxContactPairPoseEjRKNS0_8RigidSimEb: __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPNS_17PxContactPairPoseEjRKNS0_8RigidSimEb, __Z18SkinGenericMathLibILi2ELb0ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi2ELb0ELb0EEvR12SkinMeshInfo, _cf2_stack_free: _cf2_stack_free, __Z41VRSettings_Get_Custom_PropEyeTextureWidthv: __Z41VRSettings_Get_Custom_PropEyeTextureWidthv, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEED0Ev, __Z49ParticleSystem_ShapeModule_CUSTOM_GetMeshRendererP12Il2CppObject: __Z49ParticleSystem_ShapeModule_CUSTOM_GetMeshRendererP12Il2CppObject, __Z50ConfigurableJoint_Set_Custom_PropRotationDriveModeP12Il2CppObjecti: __Z50ConfigurableJoint_Set_Custom_PropRotationDriveModeP12Il2CppObjecti, __ZN12TreeRenderer16UpdateProbeIndexEii: __ZN12TreeRenderer16UpdateProbeIndexEii, __ZNSt3__26vectorIcNS_9allocatorIcEEE8__appendEj: __ZNSt3__26vectorIcNS_9allocatorIcEEE8__appendEj, __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj, __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE23handleArticulationLinksERKNS_32PxArticulationLinkCollectionPropE: __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE23handleArticulationLinksERKNS_32PxArticulationLinkCollectionPropE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE, __Z55TerrainData_Set_Custom_PropInternal_heightmapResolutionP12Il2CppObjecti: __Z55TerrainData_Set_Custom_PropInternal_heightmapResolutionP12Il2CppObjecti, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z42AudioReverbZone_Get_Custom_PropHFReferenceP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropHFReferenceP12Il2CppObject, __ZN5Unity5Cloth22SetStretchingStiffnessEf: __ZN5Unity5Cloth22SetStretchingStiffnessEf, __Z22AddCurveToStreamedClipI11QuaternionfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E: __Z22AddCurveToStreamedClipI11QuaternionfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E, __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_T_, __ZN19RuntimeSceneManager22EndIntegrateMainThreadEP10UnityScene: __ZN19RuntimeSceneManager22EndIntegrateMainThreadEP10UnityScene, __ZN7mecanim12statemachine19GetActiveChildCountERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEjb: __ZN7mecanim12statemachine19GetActiveChildCountERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEjb, __ZNKSt3__217moneypunct_bynameIwLb0EE14do_curr_symbolEv: __ZNKSt3__217moneypunct_bynameIwLb0EE14do_curr_symbolEv, __ZN29PxsCreateFinalizeContactsTaskD0Ev: __ZN29PxsCreateFinalizeContactsTaskD0Ev, __ZN5physx2Sc7BodySim10putToSleepEv: __ZN5physx2Sc7BodySim10putToSleepEv, __ZN14PhysicsManager7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction: __ZN14PhysicsManager7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction, __ZN23iPhoneLocalNotification11SetFireDateEd: __ZN23iPhoneLocalNotification11SetFireDateEd, __Z19getPxPhysics_ShapesPKN5physx9PxPhysicsEPPNS_7PxShapeEj: __Z19getPxPhysics_ShapesPKN5physx9PxPhysicsEPPNS_7PxShapeEj, __Z20GetTextureFormatInfo13TextureFormat: __Z20GetTextureFormatInfo13TextureFormat, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__set_long_sizeEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__set_long_sizeEj, __Z40InitializeLightAnimationBindingInterfacev: __Z40InitializeLightAnimationBindingInterfacev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags, __ZN26AnimatorControllerPlayable8GetFloatEiRf: __ZN26AnimatorControllerPlayable8GetFloatEiRf, __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt: __ZN5physx6shdfnd5ArrayItNS0_9AllocatorEE15growAndPushBackERKt, __ZN5physx24PxsParticleSystemBatcher19schedulePipelineGpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE: __ZN5physx24PxsParticleSystemBatcher19schedulePipelineGpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE, __Z61GUIStyleState_CUSTOM_GetBackgroundInternalFromDeserializationP12Il2CppObject: __Z61GUIStyleState_CUSTOM_GetBackgroundInternalFromDeserializationP12Il2CppObject, __ZN4FMOD6SoundI16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj: __ZN4FMOD6SoundI16getSyncPointInfoEP14FMOD_SYNCPOINTPciPjj, __Z28Cloth_Get_Custom_PropDampingP12Il2CppObject: __Z28Cloth_Get_Custom_PropDampingP12Il2CppObject, __Z47RenderSettings_Get_Custom_PropReflectionBouncesv: __Z47RenderSettings_Get_Custom_PropReflectionBouncesv, __ZN12_GLOBAL__N_117ConnectionManager21setProfileZoneManagerERN5physx20PxProfileZoneManagerE: __ZN12_GLOBAL__N_117ConnectionManager21setProfileZoneManagerERN5physx20PxProfileZoneManagerE, __Z44Debug_Set_Custom_PropDeveloperConsoleVisibleh: __Z44Debug_Set_Custom_PropDeveloperConsoleVisibleh, __ZN7mecanim12statemachine18GetTransitionArrayENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE: __ZN7mecanim12statemachine18GetTransitionArrayENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE, __ZNK14ParticleSystem27GetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticlei: __ZNK14ParticleSystem27GetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticlei, __ZN11SoundHandle8InstanceD2Ev: __ZN11SoundHandle8InstanceD2Ev, __ZNSt3__26futureIvEC2EPNS_17__assoc_sub_stateE: __ZNSt3__26futureIvEC2EPNS_17__assoc_sub_stateE, __ZN31CanvasBatchIntermediateRenderer13StaticDestroyEPv: __ZN31CanvasBatchIntermediateRenderer13StaticDestroyEPv, __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv: __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv, __ZNK11Rigidbody2D9GetVectorERK8Vector2f: __ZNK11Rigidbody2D9GetVectorERK8Vector2f, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj139ENS_22PxRepXPropertyAccessorILj139ES4_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj139ENS_22PxRepXPropertyAccessorILj139ES4_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESC_EEEEvRKT0_, __ZNK5physx2Sc5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj: __ZNK5physx2Sc5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj, __ZN15DistanceJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15DistanceJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE: __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE, __Z29Mesh_CUSTOM_RecalculateBoundsP12Il2CppObject: __Z29Mesh_CUSTOM_RecalculateBoundsP12Il2CppObject, __Z59Register_UnityEngine_Profiling_Profiler_set_enableBinaryLogv: __Z59Register_UnityEngine_Profiling_Profiler_set_enableBinaryLogv, __Z28AndroidJNI_CUSTOM_FatalErrorP12Il2CppString: __Z28AndroidJNI_CUSTOM_FatalErrorP12Il2CppString, __Z41Register_UnityEngine_CullingGroup_Disposev: __Z41Register_UnityEngine_CullingGroup_Disposev, __ZN5physx14NpShapeManagerD2Ev: __ZN5physx14NpShapeManagerD2Ev, __ZN14DirectorPlayer38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei: __ZN14DirectorPlayer38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei, __Z31Light_Set_Custom_PropBakedIndexP12Il2CppObjecti: __Z31Light_Set_Custom_PropBakedIndexP12Il2CppObjecti, __Z52Register_UnityEngine_ParticleEmitter_set_maxEmissionv: __Z52Register_UnityEngine_ParticleEmitter_set_maxEmissionv, __Z45Register_UnityEngine_AnimationState_set_layerv: __Z45Register_UnityEngine_AnimationState_set_layerv, __ZN5physx31PxVehicleNoDriveGeneratedValuesC2EPKNS_16PxVehicleNoDriveE: __ZN5physx31PxVehicleNoDriveGeneratedValuesC2EPKNS_16PxVehicleNoDriveE, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_, __Z19GetRenderManagerPtrv: __Z19GetRenderManagerPtrv, __Z34Cloth_Set_Custom_PropSelfCollisionP12Il2CppObjecth: __Z34Cloth_Set_Custom_PropSelfCollisionP12Il2CppObjecth, __Z37RenderSettings_Set_Custom_PropFogMode7FogMode: __Z37RenderSettings_Set_Custom_PropFogMode7FogMode, __ZN25MultiBlocksMemoryFileData5WriteEyyPKv: __ZN25MultiBlocksMemoryFileData5WriteEyyPKv, __ZN7mecanim19ReserveKeywordTableEv: __ZN7mecanim19ReserveKeywordTableEv, __ZN4FMOD6Reverb13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD6Reverb13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __Z26Rigidbody2D_CUSTOM_IsAwakeP12Il2CppObject: __Z26Rigidbody2D_CUSTOM_IsAwakeP12Il2CppObject, __Z32Animator_CUSTOM_GetBoneTransformP12Il2CppObject14HumanBodyBones: __Z32Animator_CUSTOM_GetBoneTransformP12Il2CppObject14HumanBodyBones, __ZZ23InitPlayerLoopCallbacksvEN47InitializationAsyncUploadTimeSlicedUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN47InitializationAsyncUploadTimeSlicedUpdatestruct7ForwardEv, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888814TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888814TexFormatRHalfEEvPKNS_9InnerInfoE, __Z35Component_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i: __Z35Component_CUSTOM_SendMessageUpwardsP12Il2CppObjectP12Il2CppStringS0_i, __ZN10MonoScript8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10MonoScript8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED2Ev, __ZL17ProgramUniform2fvPK7ApiGLESjiihPKv: __ZL17ProgramUniform2fvPK7ApiGLESjiihPKv, __ZL38CleanupUnityWebRequestScriptingClassesv: __ZL38CleanupUnityWebRequestScriptingClassesv, __ZN5physx2Sc5Scene16removeConstraintERNS0_14ConstraintCoreE: __ZN5physx2Sc5Scene16removeConstraintERNS0_14ConstraintCoreE, __ZN5physx20PxActorGeneratedInfoC2Ev: __ZN5physx20PxActorGeneratedInfoC2Ev, __ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj: __ZN20TextRenderingPrivate8FontImpl21HasCharacterInTextureEjijfPj, __ZN18LoadSceneOperation27GetTransferInstructionFlagsEN19RuntimeSceneManager11LoadingModeE: __ZN18LoadSceneOperation27GetTransferInstructionFlagsEN19RuntimeSceneManager11LoadingModeE, __ZN4FMOD7Channel11getPositionEPjj: __ZN4FMOD7Channel11getPositionEPjj, __Z17HumanBoneFromMonoRK13MonoHumanBoneR9HumanBone: __Z17HumanBoneFromMonoRK13MonoHumanBoneR9HumanBone, __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_sizev: __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_get_sizev, __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS8_EE: __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS6_RS8_EE, __ZN13Lz4CompressorD0Ev: __ZN13Lz4CompressorD0Ev, _htonl: _htonl, __Z7GetArgvv: __Z7GetArgvv, __Z20GetBufferManagerGLESv: __Z20GetBufferManagerGLESv, __ZN5physx26PxSerializerDefaultAdapterINS_7NpShapeEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_7NpShapeEED0Ev, __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_sizev: __Z57Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_sizev, __ZNK14ParticleSystem18GetGravityModifierEv: __ZNK14ParticleSystem18GetGravityModifierEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN5physx2Sc18ParticleSystemCore18addDeltaVelocitiesERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef: __ZN5physx2Sc18ParticleSystemCore18addDeltaVelocitiesERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef, __ZN10FlareLayer15ThreadedCleanupEv: __ZN10FlareLayer15ThreadedCleanupEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_, __Z26getPxVehicleEngineDataMMOIPKN5physx19PxVehicleEngineDataE: __Z26getPxVehicleEngineDataMMOIPKN5physx19PxVehicleEngineDataE, __ZN5Umbra4Math5floorENS_5FloatE: __ZN5Umbra4Math5floorENS_5FloatE, _htons: _htons, __Z18Transfer_BlittableI8JSONReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __Z46UnityWebRequest_Set_Custom_PropChunkedTransferP12Il2CppObjecth: __Z46UnityWebRequest_Set_Custom_PropChunkedTransferP12Il2CppObjecth, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setpEPwS4_: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setpEPwS4_, __Z28collideCellWithMeshTrianglesPN5physx19PxsParticleCollDataEPKjjRKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE: __Z28collideCellWithMeshTrianglesPN5physx19PxsParticleCollDataEPKjjRKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE, __ZN5physx2Sc5Scene15postNarrowPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene15postNarrowPhaseEPNS_10PxBaseTaskE, __ZN18ColorBySpeedModuleD0Ev: __ZN18ColorBySpeedModuleD0Ev, __ZN2UI14PrepareBatchesERNS_7BatchesEPKNS_23RenderableUIInstructionEPNS_28TransformGeometryInstructionEi10ColorRGBAf: __ZN2UI14PrepareBatchesERNS_7BatchesEPKNS_23RenderableUIInstructionEPNS_28TransformGeometryInstructionEi10ColorRGBAf, __ZNK7Cubemap20GetTextureLayerCountEv: __ZNK7Cubemap20GetTextureLayerCountEv, __ZNK5physx9NpPhysics17getNbClothFabricsEv: __ZNK5physx9NpPhysics17getNbClothFabricsEv, __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj, __ZN16BaseVideoTextureC2E10MemLabelId18ObjectCreationMode: __ZN16BaseVideoTextureC2E10MemLabelId18ObjectCreationMode, __ZN9Transform19SetLocalEulerAnglesERK8Vector3fN4math13RotationOrderE: __ZN9Transform19SetLocalEulerAnglesERK8Vector3fN4math13RotationOrderE, __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEEC2ERNS_19PxAllocatorCallbackE, __ZN6b2Body9SetActiveEb: __ZN6b2Body9SetActiveEb, __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_: __ZN16MeshVertexFormat20GetVertexDeclarationEjPKS_, __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectField13Il2Cpp_IntPtrS_RPv: __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectField13Il2Cpp_IntPtrS_RPv, __Z47ParticleSystemRenderer_Set_Custom_PropAlignmentP12Il2CppObject25ParticleSystemRenderSpace: __Z47ParticleSystemRenderer_Set_Custom_PropAlignmentP12Il2CppObject25ParticleSystemRenderSpace, __Z34setPxSceneDescFilterShaderDataSizePN5physx11PxSceneDescEj: __Z34setPxSceneDescFilterShaderDataSizePN5physx11PxSceneDescEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEED2Ev, __ZN12b2MouseJointC2EPK15b2MouseJointDef: __ZN12b2MouseJointC2EPK15b2MouseJointDef, __ZL10UpdateLinkjjjjPN5physx11AdjTriangleERKNS_17ADJACENCIESCREATEE: __ZL10UpdateLinkjjjjPN5physx11AdjTriangleERKNS_17ADJACENCIESCREATEE, __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_: __ZN5physx28collideWithCapsuleTestSphereERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_RKfS6_S6_S6_S6_S6_S6_, __ZN27AnimationLayerMixerPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE: __ZN27AnimationLayerMixerPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE, __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb: __ZN5physx2Sc16InteractionScene19registerInteractionEPNS0_11InteractionEb, __Z18Transfer_BlittableI14SafeBinaryReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx19solveContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPcEEEET_S4_S4_S4_: __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPcEEEET_S4_S4_S4_, __Z23ParameterValidityChecksRK9HPlayableb: __Z23ParameterValidityChecksRK9HPlayableb, __Z57Register_UnityEngine_Avatar_INTERNAL_CALL_GetPostRotationv: __Z57Register_UnityEngine_Avatar_INTERNAL_CALL_GetPostRotationv, __ZNK13ScreenManager16GetScreenTimeoutEv: __ZNK13ScreenManager16GetScreenTimeoutEv, __ZNK5physx2Sc9ActorPair23createContactReportDataEv: __ZNK5physx2Sc9ActorPair23createContactReportDataEv, __ZN14VelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14VelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14NavMeshManager16LoadDataInternalEPK11NavMeshData: __ZN14NavMeshManager16LoadDataInternalEPK11NavMeshData, __ZN9AudioClip7WWWOpenEPKciPjPPvS4_: __ZN9AudioClip7WWWOpenEPKciPjPPvS4_, __Z24RegisterStrippedTypeInfoI14Texture2DArrayEviPKcS2_: __Z24RegisterStrippedTypeInfoI14Texture2DArrayEviPKcS2_, __ZN5physx18NpArticulationLink18setAngularVelocityERKNS_6PxVec3Eb: __ZN5physx18NpArticulationLink18setAngularVelocityERKNS_6PxVec3Eb, __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Cm17enableNVTXSupportEb: __ZN5physx2Cm17enableNVTXSupportEb, __Z52Register_UnityEngine_Application_get_targetFrameRatev: __Z52Register_UnityEngine_Application_get_targetFrameRatev, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE4swapERS3_: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE4swapERS3_, __ZN12_GLOBAL__N_119PvdConnectionReaderD2Ev: __ZN12_GLOBAL__N_119PvdConnectionReaderD2Ev, __ZN13RuntimeStaticI15ApplicationInfoE10InitializeEv: __ZN13RuntimeStaticI15ApplicationInfoE10InitializeEv, __ZN13GfxDeviceGLES14SetBarrierMaskEj: __ZN13GfxDeviceGLES14SetBarrierMaskEj, __ZN5physx2Sc17ParticleSystemSim22createShapeUpdateInputERNS_28PxvParticleShapesUpdateInputE: __ZN5physx2Sc17ParticleSystemSim22createShapeUpdateInputERNS_28PxvParticleShapesUpdateInputE, __Z52Bounds_CUSTOM_INTERNAL_CALL_Internal_GetClosestPointR4AABBR8Vector3fS2_: __Z52Bounds_CUSTOM_INTERNAL_CALL_Internal_GetClosestPointR4AABBR8Vector3fS2_, __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram16TextureParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram16TextureParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_, __Z35WheelCollider_Get_Custom_PropRadiusP12Il2CppObject: __Z35WheelCollider_Get_Custom_PropRadiusP12Il2CppObject, __ZN16PlayerConnection10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN16PlayerConnection10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z53Register_UnityEngine_Input_INTERNAL_get_mousePositionv: __Z53Register_UnityEngine_Input_INTERNAL_get_mousePositionv, __ZN13SpringJoint2D15ThreadedCleanupEv: __ZN13SpringJoint2D15ThreadedCleanupEv, __ZNK8WindZone26GetTypeInfoVirtualInternalEv: __ZNK8WindZone26GetTypeInfoVirtualInternalEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZNSt3__29strstreamD2Ev: __ZNSt3__29strstreamD2Ev, __ZNK11AudioSource8GetPitchEv: __ZNK11AudioSource8GetPitchEv, __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E: __ZN5physx2Gu12PolygonalBoxC2ERKNS_6PxVec3E, __ZN15AudioReverbZone17RemoveFromManagerEv: __ZN15AudioReverbZone17RemoveFromManagerEv, __ZN4PPtrI20OcclusionCullingDataE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI20OcclusionCullingDataE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx30PxParticleFluidGeneratedValuesC2EPKNS_15PxParticleFluidE: __ZN5physx30PxParticleFluidGeneratedValuesC2EPKNS_15PxParticleFluidE, __Z43ParticleSystem_Get_Custom_PropStartRotationP12Il2CppObject: __Z43ParticleSystem_Get_Custom_PropStartRotationP12Il2CppObject, __Z38TerrainData_Get_Custom_PropDetailWidthP12Il2CppObject: __Z38TerrainData_Get_Custom_PropDetailWidthP12Il2CppObject, __ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE: __ZL30CollectComponentsWithoutAddingR10GameObjectiP11Il2CppClassR13dynamic_arrayI16AddComponentDataLj4EES6_PNSt3__212basic_stringIcNS7_11char_traitsIcEENS7_9allocatorIcEEEE, __Z35Canvas_Get_Custom_PropPlaneDistanceP12Il2CppObject: __Z35Canvas_Get_Custom_PropPlaneDistanceP12Il2CppObject, __Z38Terrain_Get_Custom_PropBasemapDistanceP12Il2CppObject: __Z38Terrain_Get_Custom_PropBasemapDistanceP12Il2CppObject, __ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf: __ZN5physx2Gu14sweepTriSphereERKNS_10PxTriangleERKNS_6PxVec3ES6_fS6_Rf, __ZN26AnimatorControllerPlayable12HasParameterEi: __ZN26AnimatorControllerPlayable12HasParameterEi, __ZN16UnityAdsSettings18SetPlatformEnabledE15RuntimePlatformb: __ZN16UnityAdsSettings18SetPlatformEnabledE15RuntimePlatformb, __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj: __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj, __ZN13dynamic_arrayIN4RTTI15DerivedFromInfoELj4EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIN4RTTI15DerivedFromInfoELj4EE18resize_initializedEjRKS1_12ResizePolicy, __Z31Camera_CUSTOM_INTERNAL_set_rectP12Il2CppObjectRK5RectTIfE: __Z31Camera_CUSTOM_INTERNAL_set_rectP12Il2CppObjectRK5RectTIfE, __Z38AudioChorusFilter_Set_Custom_PropDepthP12Il2CppObjectf: __Z38AudioChorusFilter_Set_Custom_PropDepthP12Il2CppObjectf, __ZN2UI14CanvasRenderer11SyncCullingENS0_8SyncFlagE: __ZN2UI14CanvasRenderer11SyncCullingENS0_8SyncFlagE, __Z57Register_UnityEngine_PlatformEffector2D_get_useSideBouncev: __Z57Register_UnityEngine_PlatformEffector2D_get_useSideBouncev, __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_: __ZNSt3__26__sortIRN15Cast2DQueryBase14FixtureContactEPS2_EEvT0_S5_T_, _UNITY_png_get_libpng_ver: _UNITY_png_get_libpng_ver, __ZN5Unity17ConfigurableJoint16SetSecondaryAxisERK8Vector3f: __ZN5Unity17ConfigurableJoint16SetSecondaryAxisERK8Vector3f, __Z21CreateShadowCullerJobP30CreateUmbraShadowCullerJobData: __Z21CreateShadowCullerJobP30CreateUmbraShadowCullerJobData, __ZNK5physx7NpCloth21getNbVirtualParticlesEv: __ZNK5physx7NpCloth21getNbVirtualParticlesEv, __ZN8Material14DisableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8Material14DisableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIxxEEPxEEbT0_S5_T_, __ZL18ProgramUniform2uivPK7ApiGLESjiihPKv: __ZL18ProgramUniform2uivPK7ApiGLESjiihPKv, __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx19NpArticulationJoint28getSwingLimitContactDistanceEv: __ZNK5physx19NpArticulationJoint28getSwingLimitContactDistanceEv, __ZN14ParticleSystem13SetStartSpeedEf: __ZN14ParticleSystem13SetStartSpeedEf, __Z56Register_UnityEngine_BuoyancyEffector2D_get_surfaceLevelv: __Z56Register_UnityEngine_BuoyancyEffector2D_get_surfaceLevelv, __Z35getPxVehicleClutchDataMAccuracyModePKN5physx19PxVehicleClutchDataE: __Z35getPxVehicleClutchDataMAccuracyModePKN5physx19PxVehicleClutchDataE, __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE: __ZN5physx2Sq17SceneQueryManager13markForUpdateEPNS0_10ActorShapeE, _cf2_computeDarkening: _cf2_computeDarkening, __GLOBAL__sub_I_runtime_gfxdevice_lump_cpp: __GLOBAL__sub_I_runtime_gfxdevice_lump_cpp, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIwEE, __ZN19TouchPhaseEmulation23DiscardRedundantTouchesEv: __ZN19TouchPhaseEmulation23DiscardRedundantTouchesEv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN12InputManager18GetAnyKeyThisFrameEv: __ZN12InputManager18GetAnyKeyThisFrameEv, __ZN11Rigidbody2D14SetAngularDragEf: __ZN11Rigidbody2D14SetAngularDragEf, __Z25Screen_Get_Custom_PropDpiv: __Z25Screen_Get_Custom_PropDpiv, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _strfmon: _strfmon, __Z29CullIntermediateRenderersOnlyRK22SceneCullingParametersR11CullResults: __Z29CullIntermediateRenderersOnlyRK22SceneCullingParametersR11CullResults, __Z48Register_UnityEngine_AudioSource_get_maxDistancev: __Z48Register_UnityEngine_AudioSource_get_maxDistancev, __Z24InitializeCleanedLogFileP8_IO_FILE: __Z24InitializeCleanedLogFileP8_IO_FILE, __ZNK13AnimationClip8IsLegacyEv: __ZNK13AnimationClip8IsLegacyEv, __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEEEEvRT_j, _jsimd_can_fdct_islow: _jsimd_can_fdct_islow, _jpeg_set_linear_quality: _jpeg_set_linear_quality, __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE7reserveEj, __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetCycleCountv: __Z77Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetCycleCountv, __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii: __ZN20TextRenderingPrivate19NativeTextGenerator23FixLineHorizontalOffsetEiii, __ZNK9Rigidbody26GetTypeInfoVirtualInternalEv: __ZNK9Rigidbody26GetTypeInfoVirtualInternalEv, __ZN8DateTime13GetDaysInYearEi: __ZN8DateTime13GetDaysInYearEi, __Z54Register_UnityEngine_GUIUtility_Internal_SetHotControlv: __Z54Register_UnityEngine_GUIUtility_Internal_SetHotControlv, __Z33Transform_CUSTOM_SetAsLastSiblingP12Il2CppObject: __Z33Transform_CUSTOM_SetAsLastSiblingP12Il2CppObject, __Z50Register_UnityEngine_Graphics_GetActiveColorBufferv: __Z50Register_UnityEngine_Graphics_GetActiveColorBufferv, __ZN7mecanim9animation19DestroyAnimationSetEPNS0_12AnimationSetERNS_6memory9AllocatorE: __ZN7mecanim9animation19DestroyAnimationSetEPNS0_12AnimationSetERNS_6memory9AllocatorE, __ZN5physx15PxsParticleData13clearSimStateEv: __ZN5physx15PxsParticleData13clearSimStateEv, __ZN14SerializedFile7ReleaseEv: __ZN14SerializedFile7ReleaseEv, __ZN5audio5mixer32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRNSt3__26vectorI9UnityGUIDNS6_9allocatorIS8_EEEE: __ZN5audio5mixer32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRNSt3__26vectorI9UnityGUIDNS6_9allocatorIS8_EEEE, __ZN16MemoryFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN16MemoryFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __ZNK18AnimatorController28HasMultiThreadedStateMachineEv: __ZNK18AnimatorController28HasMultiThreadedStateMachineEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, _jpeg_mem_dest: _jpeg_mem_dest, _fullsize_smooth_downsample: _fullsize_smooth_downsample, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_, __ZN12AudioManager12CleanupClassEv: __ZN12AudioManager12CleanupClassEv, __ZN5Light15InitializeClassEv: __ZN5Light15InitializeClassEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS5_EENS7_9allocatorINS7_4pairIS5_S6_EEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS5_EENS7_9allocatorINS7_4pairIS5_S6_EEEEEEEvRT_17TransferMetaFlags, __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_: __ZN12JointMotor2D8TransferI14SafeBinaryReadEEvRT_, __ZN9AudioClip18GetQueuedAudioDataEPPvj: __ZN9AudioClip18GetQueuedAudioDataEPPvj, __ZN12SkeletonBoneC2ERKS_: __ZN12SkeletonBoneC2ERKS_, __ZN5physx2Sn18RepXCollectionImpl4saveERNS_14PxOutputStreamE: __ZN5physx2Sn18RepXCollectionImpl4saveERNS_14PxOutputStreamE, __ZN16Physics2DManager26DestroyRigidbodyCollisionsEP11Rigidbody2D: __ZN16Physics2DManager26DestroyRigidbodyCollisionsEP11Rigidbody2D, __ZNK9Texture2D17CheckHasPixelDataEv: __ZNK9Texture2D17CheckHasPixelDataEv, __ZN15b2ContactSolver13StoreImpulsesEv: __ZN15b2ContactSolver13StoreImpulsesEv, __ZNK13WheelCollider13IsInitializedEv: __ZNK13WheelCollider13IsInitializedEv, __ZNK5physx7NpCloth16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES3_PNS_24PxClothCollisionTriangleE: __ZNK5physx7NpCloth16getCollisionDataEPNS_22PxClothCollisionSphereEPjPNS_21PxClothCollisionPlaneES3_PNS_24PxClothCollisionTriangleE, __ZN7mecanim9animation19DestroyConstantClipERNS0_12ConstantClipERNS_6memory9AllocatorE: __ZN7mecanim9animation19DestroyConstantClipERNS0_12ConstantClipERNS_6memory9AllocatorE, __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb: __Z18SetShadowsKeywordsR17ShaderPassContext9LightType10ShadowType16ShadowProjectionbb, __ZN5Umbra9Matrix4x411flushToZeroEv: __ZN5Umbra9Matrix4x411flushToZeroEv, __ZN17CollisionMeshDataC2Ev: __ZN17CollisionMeshDataC2Ev, __ZN4FMOD6System16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E: __ZN4FMOD6System16attachFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_E, __Z41Register_UnityEngine_TextMesh_set_tabSizev: __Z41Register_UnityEngine_TextMesh_set_tabSizev, __ZN8Animator13GetParametersEv: __ZN8Animator13GetParametersEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags, __ZN5physx2Sc5Scene15prepareSimulateEv: __ZN5physx2Sc5Scene15prepareSimulateEv, __Z56Register_UnityEngine_TrailRenderer_INTERNAL_set_endColorv: __Z56Register_UnityEngine_TrailRenderer_INTERNAL_set_endColorv, __Z38getBinaryMetaData_SerializationContextRN5physx14PxOutputStreamE: __Z38getBinaryMetaData_SerializationContextRN5physx14PxOutputStreamE, __ZN16LightmapSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16LightmapSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN19CollisionListener2DC2Ev: __ZN19CollisionListener2DC2Ev, __ZN5physx20PxsParticleSystemSim19passCollisionInputVENS_31PxvParticleCollisionUpdateInputE: __ZN5physx20PxsParticleSystemSim19passCollisionInputVENS_31PxvParticleCollisionUpdateInputE, __Z33getPxConvexMeshGeometryConvexMeshPKN5physx20PxConvexMeshGeometryE: __Z33getPxConvexMeshGeometryConvexMeshPKN5physx20PxConvexMeshGeometryE, __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev: __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev, __ZN5Unity12PhysicsQuery7BoxTestERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery7BoxTestERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction, __ZNSt3__220__throw_system_errorEiPKc: __ZNSt3__220__throw_system_errorEiPKc, __ZN7Cursors14CleanupCursorsEv: __ZN7Cursors14CleanupCursorsEv, __Z18Transfer_BlittableI8JSONReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN26ContactCapsuleMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN26ContactCapsuleMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags: __ZN18IDCollectorFunctor18GenerateInstanceIDEi17TransferMetaFlags, __ZN29UnityWebRequestAsyncOperation11GetProgressEv: __ZN29UnityWebRequestAsyncOperation11GetProgressEv, __ZN4crnd26crnd_create_segmented_fileEPKvjPvj: __ZN4crnd26crnd_create_segmented_fileEPKvjPvj, __Z41Camera_Set_Custom_PropUseOcclusionCullingP12Il2CppObjecth: __Z41Camera_Set_Custom_PropUseOcclusionCullingP12Il2CppObjecth, __ZN4FMOD7SystemI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD7SystemI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, __ZNSt3__212__do_messageD0Ev: __ZNSt3__212__do_messageD0Ev, _UNITY_FT_Stroker_ParseOutline: _UNITY_FT_Stroker_ParseOutline, __ZN11UmbraModule24CullBoundingSpheresUmbraEPK8Vector4fPKN5Umbra15OcclusionBufferEjjPhhb: __ZN11UmbraModule24CullBoundingSpheresUmbraEPK8Vector4fPKN5Umbra15OcclusionBufferEjjPhhb, __ZN15b2ContactSolver9WarmStartEv: __ZN15b2ContactSolver9WarmStartEv, __ZN15UnityAdsManagerC2E10MemLabelId18ObjectCreationMode: __ZN15UnityAdsManagerC2E10MemLabelId18ObjectCreationMode, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN11UnityEngine15CloudWebService16SessionContainer12IsDispatchedERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer12IsDispatchedERK8UnityStr, __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE: __ZN5physx2Sc17ParticleSystemSim15onRbShapeChangeERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimE, __ZN5physx26PxSerializerDefaultAdapterINS_7NpClothEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_7NpClothEED0Ev, __ZN14b2WeldJointDef10InitializeEP6b2BodyS1_RK6b2Vec2: __ZN14b2WeldJointDef10InitializeEP6b2BodyS1_RK6b2Vec2, __Z29NavMesh_CUSTOM_RestoreNavMeshv: __Z29NavMesh_CUSTOM_RestoreNavMeshv, _ft_smooth_init: _ft_smooth_init, __ZN17AnimationCurveTplI11QuaternionfE10RemoveKeysEP11KeyframeTplIS0_ES4_: __ZN17AnimationCurveTplI11QuaternionfE10RemoveKeysEP11KeyframeTplIS0_ES4_, _jpeg_finish_compress: _jpeg_finish_compress, __ZN5physx27updateIslandsSecondPassMainEjRNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjjRNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS0_13EventProfilerE: __ZN5physx27updateIslandsSecondPassMainEjRNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjjRNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS0_13EventProfilerE, __ZN14dtPathCorridor20updateTargetPositionEyPKf: __ZN14dtPathCorridor20updateTargetPositionEyPKf, __ZN8Animator8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8Animator8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE: __ZN5Umbra11Transformer10setScissorERKNS_8Vector4iE, __ZN11UnityEngine15CloudWebService13WWWRestClientD0Ev: __ZN11UnityEngine15CloudWebService13WWWRestClientD0Ev, __ZN19LowerResBlitTexture17UploadToGfxDeviceEv: __ZN19LowerResBlitTexture17UploadToGfxDeviceEv, __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEjT0_S5_S5_T_, __Z33getPxVehicleWheelDataMDampingRatePKN5physx18PxVehicleWheelDataE: __Z33getPxVehicleWheelDataMDampingRatePKN5physx18PxVehicleWheelDataE, __ZN18b2DistanceJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_: __ZN18b2DistanceJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_, __Z42GIDebugVisualisation_CUSTOM_PauseCycleModev: __Z42GIDebugVisualisation_CUSTOM_PauseCycleModev, __Z24RegisterStrippedTypeInfoI13ConstantForceEviPKcS2_: __Z24RegisterStrippedTypeInfoI13ConstantForceEviPKcS2_, __Z34Canvas_Set_Custom_PropPixelPerfectP12Il2CppObjecth: __Z34Canvas_Set_Custom_PropPixelPerfectP12Il2CppObjecth, __ZN17PersistentManager4LockEv: __ZN17PersistentManager4LockEv, _zipClose: _zipClose, __ZN12MeshCollider15ThreadedCleanupEv: __ZN12MeshCollider15ThreadedCleanupEv, __Z41Register_UnityEngine_Camera_GetAllCamerasv: __Z41Register_UnityEngine_Camera_GetAllCamerasv, __ZNK5physx6shdfnd6Socket7getPortEv: __ZNK5physx6shdfnd6Socket7getPortEv, __Z55Register_UnityEngine_ParticleSystem_set_simulationSpacev: __Z55Register_UnityEngine_ParticleSystem_set_simulationSpacev, __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN6Camera20SetReplacementShaderEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __ZN6Camera20SetReplacementShaderEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN4crnd12crn_unpacker10unpack_dxnEPPhjjjjjj: __ZN4crnd12crn_unpacker10unpack_dxnEPPhjjjjjj, __ZN8Animator16GetPivotPositionEv: __ZN8Animator16GetPivotPositionEv, __Z54Register_UnityEngine_QualitySettings_get_softParticlesv: __Z54Register_UnityEngine_QualitySettings_get_softParticlesv, ___ctype_tolower_loc: ___ctype_tolower_loc, __Z49ParticleSystem_MainModule_CUSTOM_SetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_MainModule_CUSTOM_SetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve, __ZN15CacheWriterBase18GetAddressOfMemoryEv: __ZN15CacheWriterBase18GetAddressOfMemoryEv, __ZN5physx10NpMaterial17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx10NpMaterial17resolveReferencesERNS_24PxDeserializationContextE, __Z37AudioReverbZone_Set_Custom_PropRoomHFP12Il2CppObjecti: __Z37AudioReverbZone_Set_Custom_PropRoomHFP12Il2CppObjecti, __ZN5physx2Sc9ClothCore12initLowLevelERKNS_11PxTransformEPKNS_15PxClothParticleE: __ZN5physx2Sc9ClothCore12initLowLevelERKNS_11PxTransformEPKNS_15PxClothParticleE, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN9Texture2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Texture2D13AwakeFromLoadE17AwakeFromLoadMode, __ZN26PxcContactCellMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN26PxcContactCellMeshCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __Z41Register_UnityEngine_EdgeCollider2D_Resetv: __Z41Register_UnityEngine_EdgeCollider2D_Resetv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES7_EEEEvjRT_, __ZNSt3__212__rs_defaultC2Ev: __ZNSt3__212__rs_defaultC2Ev, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIwwEEPwEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIwwEEPwEEbT0_S5_T_, __ZNK8Animator19ValidateHasPlayableEv: __ZNK8Animator19ValidateHasPlayableEv, __ZN24EllipsoidParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN24EllipsoidParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEED0Ev, __ZN5physx2Sn13XmlNodeWriterD0Ev: __ZN5physx2Sn13XmlNodeWriterD0Ev, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZNK21AssetBundleFileSystem4SizeERK13FileEntryData: __ZNK21AssetBundleFileSystem4SizeERK13FileEntryData, _reset_marker_reader: _reset_marker_reader, __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc: __ZN5physx7NpActor15removeConnectorERNS_7PxActorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc, __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx19ActorAABBUpdateTask11runInternalEv: __ZN5physx19ActorAABBUpdateTask11runInternalEv, __Z48Register_UnityEngine_AudioClip_get_isReadyToPlayv: __Z48Register_UnityEngine_AudioClip_get_isReadyToPlayv, __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode1EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf: __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode1EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf, __ZNSt13runtime_errorD2Ev: __ZNSt13runtime_errorD2Ev, __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats: __ZN20ReflectionProbeCacheC2ER13BatchRendererR15RenderLoopStats, __ZN12MemoryStream5writeEPKvj: __ZN12MemoryStream5writeEPKvj, __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags, __ZNK12HandlerChain6ExistsERK13FileEntryData: __ZNK12HandlerChain6ExistsERK13FileEntryData, __Z50Application_CUSTOM_ReplyToUserAuthorizationRequesthh: __Z50Application_CUSTOM_ReplyToUserAuthorizationRequesthh, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_, __Z15Transfer_StringI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47Register_UnityEngine_Sprite_INTERNAL_get_boundsv: __Z47Register_UnityEngine_Sprite_INTERNAL_get_boundsv, __ZN5physx3Ext13RevoluteJoint21setRevoluteJointFlagsENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE: __ZN5physx3Ext13RevoluteJoint21setRevoluteJointFlagsENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE, __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx3Ext23DefaultBufferedProfiler7releaseEv: __ZN5physx3Ext23DefaultBufferedProfiler7releaseEv, __ZN20TextRenderingPrivate8TextMesh14SetLineSpacingEf: __ZN20TextRenderingPrivate8TextMesh14SetLineSpacingEf, __ZN5physx21PxsBodyTransformVault7addBodyERKNS_11PxsBodyCoreE: __ZN5physx21PxsBodyTransformVault7addBodyERKNS_11PxsBodyCoreE, __Z18GetLODGroupManagerv: __Z18GetLODGroupManagerv, __ZN5physx8debugger4comm23AppendPropertyValueDataD0Ev: __ZN5physx8debugger4comm23AppendPropertyValueDataD0Ev, __Z51Register_UnityEngine_CanvasGroup_set_blocksRaycastsv: __Z51Register_UnityEngine_CanvasGroup_set_blocksRaycastsv, __Z58Register_UnityEngine_ParticleSystem_TrailModule_SetEnabledv: __Z58Register_UnityEngine_ParticleSystem_TrailModule_SetEnabledv, __ZNSt11logic_erroraSERKS_: __ZNSt11logic_erroraSERKS_, __ZN14TerrainManagerC2Ev: __ZN14TerrainManagerC2Ev, __ZN12GUIClipState10BeginOnGUIER10InputEvent: __ZN12GUIClipState10BeginOnGUIER10InputEvent, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN7mecanim4hand10CreateHandERNS_6memory9AllocatorE: __ZN7mecanim4hand10CreateHandERNS_6memory9AllocatorE, __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_35PxClothParticleSeparationConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx19PxClothFabricCookerD2Ev: __ZN5physx19PxClothFabricCookerD2Ev, __ZN5Umbra20RuntimeTomeGenerator12collectTilesEv: __ZN5Umbra20RuntimeTomeGenerator12collectTilesEv, __ZNSt3__227__num_get_unsigned_integralIyEET_PKcS3_Rji: __ZNSt3__227__num_get_unsigned_integralIyEET_PKcS3_Rji, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE8getSceneEv, _UNITY_tt_size_ready_bytecode: _UNITY_tt_size_ready_bytecode, __Z24RegisterModuleClasses_UIv: __Z24RegisterModuleClasses_UIv, __ZN5physx19PxCapsuleControllerD0Ev: __ZN5physx19PxCapsuleControllerD0Ev, __ZN13TextRendering4FontD2Ev: __ZN13TextRendering4FontD2Ev, __ZN27GenericSlowGarbageCollectorD2Ev: __ZN27GenericSlowGarbageCollectorD2Ev, __Z54NavMeshObstacle_Set_Custom_PropCarvingTimeToStationaryP12Il2CppObjectf: __Z54NavMeshObstacle_Set_Custom_PropCarvingTimeToStationaryP12Il2CppObjectf, __ZNK5physx14NpArticulation17getSleepThresholdEv: __ZNK5physx14NpArticulation17getSleepThresholdEv, __ZN4PPtrI15CapsuleColliderE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI15CapsuleColliderE8TransferI14SafeBinaryReadEEvRT_, _UNITY_FT_Stream_Open: _UNITY_FT_Stream_Open, __ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE: __ZNK5Umbra15IntersectFilter6filterERKNS_4AABBE, _ps_dimension_end: _ps_dimension_end, __ZZN11Rigidbody2D15InitializeClassEvEN32FunctorImpl_198kTransformChanged4CallEPviR11MessageData: __ZZN11Rigidbody2D15InitializeClassEvEN32FunctorImpl_198kTransformChanged4CallEPviR11MessageData, __GLOBAL__sub_I_AssetBundleFileSystem_cpp: __GLOBAL__sub_I_AssetBundleFileSystem_cpp, __GLOBAL__sub_I_runtime_ui_lump_cpp: __GLOBAL__sub_I_runtime_ui_lump_cpp, __ZN10SizeModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10SizeModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13RuntimeStaticI12AdsIdHandlerE13StaticDestroyEPv: __ZN13RuntimeStaticI12AdsIdHandlerE13StaticDestroyEPv, __Z44Register_UnityEngine_GameObject_get_isStaticv: __Z44Register_UnityEngine_GameObject_get_isStaticv, __ZN10MemoryFile4ReadEyyPvPy: __ZN10MemoryFile4ReadEyyPvPy, __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev: __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev, __Z38Terrain_Set_Custom_PropBasemapDistanceP12Il2CppObjectf: __Z38Terrain_Set_Custom_PropBasemapDistanceP12Il2CppObjectf, __Z43Register_UnityEngine_GL_LoadPixelMatrixArgsv: __Z43Register_UnityEngine_GL_LoadPixelMatrixArgsv, __ZNK21EnlightenSceneMapping22GetRendererInformationEi: __ZNK21EnlightenSceneMapping22GetRendererInformationEi, __Z80Register_UnityEngine_ShaderVariantCollection_ShaderVariant_Internal_CheckVariantv: __Z80Register_UnityEngine_ShaderVariantCollection_ShaderVariant_Internal_CheckVariantv, __ZN19AudioHighPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN19AudioHighPassFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMaxDepenetrationVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMaxDepenetrationVelocityEv, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4swapERS3_: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4swapERS3_, __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE: __ZN7mecanim9animation22CopyAnimationNodeStateEPKNS0_18AnimationNodeStateEPS1_bbRKNS_6bitsetILj66EEE, __ZN4FMOD3DSP12setParameterEif: __ZN4FMOD3DSP12setParameterEif, __ZN13MemoryManager16StaticInitializeEv: __ZN13MemoryManager16StaticInitializeEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE, __ZN19RenderEventsContext19RemoveCommandBufferEiP22RenderingCommandBuffer: __ZN19RenderEventsContext19RemoveCommandBufferEiP22RenderingCommandBuffer, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsputnEPKci, _UNITY_png_set_user_limits: _UNITY_png_set_user_limits, __GLOBAL__sub_I_GUIText_cpp: __GLOBAL__sub_I_GUIText_cpp, __ZN4FMOD22FakeModChannelCallbackEPv: __ZN4FMOD22FakeModChannelCallbackEPv, __Z42ParticleEmitter_Set_Custom_PropRndRotationP12Il2CppObjecth: __Z42ParticleEmitter_Set_Custom_PropRndRotationP12Il2CppObjecth, __ZZN12MeshRenderer15InitializeClassEvEN28FunctorImpl_99kDidDeleteMesh4CallEPviR11MessageData: __ZZN12MeshRenderer15InitializeClassEvEN28FunctorImpl_99kDidDeleteMesh4CallEPviR11MessageData, __ZN13BoneInfluence8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13BoneInfluence8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4Mesh10CreateMeshEv: __ZN4Mesh10CreateMeshEv, __ZN5physx9PxTaskMgr13decrReferenceERNS_9PxSpuTaskE: __ZN5physx9PxTaskMgr13decrReferenceERNS_9PxSpuTaskE, __ZN4FMOD7SystemI11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE: __ZN4FMOD7SystemI11createSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE, __ZN9BoxPrunerC2Ev: __ZN9BoxPrunerC2Ev, __ZN17CollisionMeshData21GetSharedNxConvexMeshER4Mesh: __ZN17CollisionMeshData21GetSharedNxConvexMeshER4Mesh, _cf2_stack_clear: _cf2_stack_clear, __ZN8VRDevice8SetPauseEb: __ZN8VRDevice8SetPauseEb, __ZNKSt3__210moneypunctIcLb1EE13negative_signEv: __ZNKSt3__210moneypunctIcLb1EE13negative_signEv, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN7Texture13SetAnisoLevelEi: __ZN7Texture13SetAnisoLevelEi, __Z34FillScriptingArrayFromUnityObjectsINSt3__26vectorI4PPtrI6ObjectENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsINSt3__26vectorI4PPtrI6ObjectENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i, __Z36ParticleSystem_CUSTOM_Internal_ClearP12Il2CppObject: __Z36ParticleSystem_CUSTOM_Internal_ClearP12Il2CppObject, __ZN5CacheC2Ev: __ZN5CacheC2Ev, __ZN15CapsuleCollider9GetBoundsEv: __ZN15CapsuleCollider9GetBoundsEv, __ZNK14StackAllocator19GetRequestedPtrSizeEPKv: __ZNK14StackAllocator19GetRequestedPtrSizeEPKv, __ZN9GfxDevice20GetComputeBufferDataE15ComputeBufferIDPvj: __ZN9GfxDevice20GetComputeBufferDataE15ComputeBufferIDPvj, __Z52Register_UnityEngine_Terrain_get_heightmapPixelErrorv: __Z52Register_UnityEngine_Terrain_get_heightmapPixelErrorv, __Z27CreateInstanceUpdateManagerv: __Z27CreateInstanceUpdateManagerv, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbaseEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbaseEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_, __Z51ParticleSystemRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject: __Z51ParticleSystemRenderer_Get_Custom_PropVelocityScaleP12Il2CppObject, __ZNK5physx2Gu11HeightField12isConvexEdgeEjjjj: __ZNK5physx2Gu11HeightField12isConvexEdgeEjjjj, __ZNK8Collider15SupportsTriggerEv: __ZNK8Collider15SupportsTriggerEv, __ZNSt3__214__rotate_rightINS_11__wrap_iterIPwEEEET_S4_S4_: __ZNSt3__214__rotate_rightINS_11__wrap_iterIPwEEEET_S4_S4_, _raccess_guess_vfat: _raccess_guess_vfat, _get_sof: _get_sof, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvRS2_S5_RKS2_S7_: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvRS2_S5_RKS2_S7_, __ZL28GeomMTDCallback_SphereSphereRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL28GeomMTDCallback_SphereSphereRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getParticleMassEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getParticleMassEv, __ZN5physx2Cm10Collection3addERNS_6PxBaseEy: __ZN5physx2Cm10Collection3addERNS_6PxBaseEy, __ZN13InitialModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13InitialModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z31Profiler_CUSTOM_GetSamplerNamesv: __Z31Profiler_CUSTOM_GetSamplerNamesv, __Z13RegisterClassIN20TextRenderingPrivate8TextMeshEEvv: __Z13RegisterClassIN20TextRenderingPrivate8TextMeshEEvv, __ZN5physx7NpScene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh: __ZN5physx7NpScene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh, __Z41ConstantForce2D_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP13Vector2fIcall: __Z41ConstantForce2D_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP13Vector2fIcall, __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj63ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEjjPKjjjj: __ZNK5physx2Gu15HeightFieldUtil15isCollisionEdgeEjjPKjjjj, __Z21DestroyShadowMapCacheP14ShadowMapCache: __Z21DestroyShadowMapCacheP14ShadowMapCache, __ZN7mecanim9animation25CreateControllerWorkspaceEPKNS0_18ControllerConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation25CreateControllerWorkspaceEPKNS0_18ControllerConstantERNS_6memory9AllocatorE, __ZN14LogBufferEntryC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType: __ZN14LogBufferEntryC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType, __ZNSt3__23mapIj17DetailPatchRenderNS_4lessIjEE11memory_poolINS_4pairIKjS1_EEEE25__construct_node_with_keyERS6_: __ZNSt3__23mapIj17DetailPatchRenderNS_4lessIjEE11memory_poolINS_4pairIKjS1_EEEE25__construct_node_with_keyERS6_, __Z16SetCullingPlanesR17CullingParametersPK5Planei: __Z16SetCullingPlanesR17CullingParametersPK5Planei, __ZN20OverlapCircleQuery2DD2Ev: __ZN20OverlapCircleQuery2DD2Ev, __Z53RenderSettings_CUSTOM_INTERNAL_set_ambientGroundColorRK10ColorRGBAf: __Z53RenderSettings_CUSTOM_INTERNAL_set_ambientGroundColorRK10ColorRGBAf, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEvPT_jRKT0_RKT1_j, __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi15EEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi15EEEEvRT_PKc17TransferMetaFlags, __ZN9JSONWrite8TransferI11KeyframeTplIfEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI11KeyframeTplIfEEEvRT_PKc17TransferMetaFlags, __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_swingLimitSpringv: __Z65Register_UnityEngine_CharacterJoint_INTERNAL_set_swingLimitSpringv, __Z49Register_UnityEngine_SkinnedMeshRenderer_BakeMeshv: __Z49Register_UnityEngine_SkinnedMeshRenderer_BakeMeshv, __ZN5physx2Gu15EdgeListBuilder18ComputeActiveEdgesEjPKjPKtPKNS_6PxVec3Ef: __ZN5physx2Gu15EdgeListBuilder18ComputeActiveEdgesEjPKjPKtPKNS_6PxVec3Ef, __ZN17AudioReverbFilter12AddToManagerEv: __ZN17AudioReverbFilter12AddToManagerEv, __ZNK11Rigidbody2D12OverlapPointERK8Vector2f: __ZNK11Rigidbody2D12OverlapPointERK8Vector2f, __ZN4gles27RenderSurfaceGLES_InitDummyER17RenderSurfaceGLESbRK17RenderSurfaceDesc: __ZN4gles27RenderSurfaceGLES_InitDummyER17RenderSurfaceGLESbRK17RenderSurfaceDesc, __ZN5physx31PxClothGeodesicTetherCookerImpl16findTriNeighborsEv: __ZN5physx31PxClothGeodesicTetherCookerImpl16findTriNeighborsEv, __ZN9Animation15InitializeClassEv: __ZN9Animation15InitializeClassEv, __ZN5Umbra10StackAllocC2EPvj: __ZN5Umbra10StackAllocC2EPvj, __ZN14RenderSettings22SetAmbientEquatorColorERK10ColorRGBAf: __ZN14RenderSettings22SetAmbientEquatorColorERK10ColorRGBAf, __Z42Register_UnityEngine_WheelCollider_get_rpmv: __Z42Register_UnityEngine_WheelCollider_get_rpmv, __ZN5physx17PxsContactManagerC2EPNS_10PxsContextEj: __ZN5physx17PxsContactManagerC2EPNS_10PxsContextEj, __ZNK13GfxDeviceNull14GetScissorRectEv: __ZNK13GfxDeviceNull14GetScissorRectEv, __Z44Renderer_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti: __Z44Renderer_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertINS_11__wrap_iterIPS6_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESC_E4typeENSA_IPKS6_EESE_SE_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertINS_11__wrap_iterIPS6_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISE_E9referenceEEE5valueESC_E4typeENSA_IPKS6_EESE_SE_, __Z23GetLateBehaviourManagerv: __Z23GetLateBehaviourManagerv, __ZN5physx2Sn20SerializationContextD2Ev: __ZN5physx2Sn20SerializationContextD2Ev, __Z46Register_UnityEngine_SphereCollider_get_radiusv: __Z46Register_UnityEngine_SphereCollider_get_radiusv, __Z66Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticObjectFieldv: __Z66Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticObjectFieldv, __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei: __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStylei, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZN10MemoryPool10DeallocateEPv: __ZN10MemoryPool10DeallocateEPv, __ZN8GUIState8SetEventERK10InputEvent: __ZN8GUIState8SetEventERK10InputEvent, __Z42Register_UnityEngine_AssetBundle_LoadAsyncv: __Z42Register_UnityEngine_AssetBundle_LoadAsyncv, __ZN5physx8debugger14PvdInputStreamD2Ev: __ZN5physx8debugger14PvdInputStreamD2Ev, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE10addContentEPKc: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE10addContentEPKc, __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe: __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwe, __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j: __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEEEEjT_j, __ZN13TranslateGLES16InitBufferTargetERK12GraphicsCaps16GfxDeviceLevelGL: __ZN13TranslateGLES16InitBufferTargetERK12GraphicsCaps16GfxDeviceLevelGL, __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf, __Z37Animation_CUSTOM_PlayDefaultAnimationP12Il2CppObjecti: __Z37Animation_CUSTOM_PlayDefaultAnimationP12Il2CppObjecti, __Z57Register_UnityEngine_CanvasRenderer_set_hasPopInstructionv: __Z57Register_UnityEngine_CanvasRenderer_set_hasPopInstructionv, __ZN5Unity14CharacterJoint6CreateEv: __ZN5Unity14CharacterJoint6CreateEv, __ZNSt20bad_array_new_lengthD0Ev: __ZNSt20bad_array_new_lengthD0Ev, __ZNSt3__214__shared_count16__release_sharedEv: __ZNSt3__214__shared_count16__release_sharedEv, __ZN17AnimationPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE: __ZN17AnimationPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE, __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_: __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_6WriterI16TempBufferWriterS2_S2_S3_EEEEbRT_, __ZN14PhysicsManager21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction: __ZN14PhysicsManager21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction, __Z56ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve: __Z56ParticleSystem_EmissionModule_CUSTOM_SetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve, __ZN10DynamicVBO9DrawChunkERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationPKNS_10DrawParamsEi: __ZN10DynamicVBO9DrawChunkERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationPKNS_10DrawParamsEi, __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN26PlayerSettingsSplashScreen8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Gu12TriangleMesh14onRefCountZeroEv: __ZN5physx2Gu12TriangleMesh14onRefCountZeroEv, __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z25FindConflictingComponentsi: __Z25FindConflictingComponentsi, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10AudioMixer6UpdateEf: __ZN10AudioMixer6UpdateEf, __ZN5Unity9Component16CheckConsistencyEv: __ZN5Unity9Component16CheckConsistencyEv, __ZN9BlobWrite8TransferIN7mecanim5human6HandleEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim5human6HandleEEEvRT_PKc17TransferMetaFlags, __ZN7ApiGLES11CheckShaderERjb: __ZN7ApiGLES11CheckShaderERjb, __ZN9BoxPruner17prepareBIPPruningERK16MBPOS_TmpBuffers: __ZN9BoxPruner17prepareBIPPruningERK16MBPOS_TmpBuffers, __Z46Camera_CUSTOM_INTERNAL_get_cameraToWorldMatrixP12Il2CppObjectP10Matrix4x4f: __Z46Camera_CUSTOM_INTERNAL_get_cameraToWorldMatrixP12Il2CppObjectP10Matrix4x4f, _coshf: _coshf, __Z49Register_UnityEngine_AudioChorusFilter_set_dryMixv: __Z49Register_UnityEngine_AudioChorusFilter_set_dryMixv, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx20PxcContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx20PxcContactCapsuleBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, _coshl: _coshl, __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularZLimitP12Il2CppObjectP14SoftJointLimit: __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularZLimitP12Il2CppObjectP14SoftJointLimit, __ZN9Animation13BlendAdditiveEv: __ZN9Animation13BlendAdditiveEv, __ZN7mecanim9animation14DeltasFromClipERKNS0_18ClipMuscleConstantERKNS0_12ClipBindingsERKNS_14ValueArrayMaskERNS_10ValueArrayESB_SB_: __ZN7mecanim9animation14DeltasFromClipERKNS0_18ClipMuscleConstantERKNS0_12ClipBindingsERKNS_14ValueArrayMaskERNS_10ValueArrayESB_SB_, __Z36Joint2D_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_: __Z36Joint2D_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_, __ZN13GfxDeviceGLES17SetGpuProgramNameEP10GpuProgramPKc: __ZN13GfxDeviceGLES17SetGpuProgramNameEP10GpuProgramPKc, __ZN13BuildSettings15ThreadedCleanupEv: __ZN13BuildSettings15ThreadedCleanupEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN21BuiltinShaderSettings17BuiltinShaderModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN21BuiltinShaderSettings17BuiltinShaderModeEEvRT_RT0_PKc17TransferMetaFlags, __ZN5Umbra9fillDWordEPjjj: __ZN5Umbra9fillDWordEPjjj, __ZN5Unity5Cloth12SetSuspendedEb: __ZN5Unity5Cloth12SetSuspendedEb, __ZN7ApiGLES18CreateRenderbufferEiN2gl9TexFormatEii: __ZN7ApiGLES18CreateRenderbufferEiN2gl9TexFormatEii, __ZN13GfxDeviceGLESC2Ev: __ZN13GfxDeviceGLESC2Ev, __ZN11TerrainData21AwakeFromLoadThreadedEv: __ZN11TerrainData21AwakeFromLoadThreadedEv, __ZN12_GLOBAL__N_110DataStream27getPropertyDefinitionHelperEv: __ZN12_GLOBAL__N_110DataStream27getPropertyDefinitionHelperEv, __ZN5Unity10FixedJoint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity10FixedJoint7PRODUCEE10MemLabelId18ObjectCreationMode, _save_marker: _save_marker, __ZNK5physx7NpScene8getFlagsEv: __ZNK5physx7NpScene8getFlagsEv, __ZN6Avatar8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN6Avatar8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z61Register_UnityEngine_ParticleSystemRenderer_set_trailMaterialv: __Z61Register_UnityEngine_ParticleSystemRenderer_set_trailMaterialv, __ZN15NavMeshObstacle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15NavMeshObstacle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN15PointEffector2D17SetForceVariationEf: __ZN15PointEffector2D17SetForceVariationEf, _UNITY_png_write_info_before_PLTE: _UNITY_png_write_info_before_PLTE, __ZN16UploadHandlerRawD0Ev: __ZN16UploadHandlerRawD0Ev, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, _sendto: _sendto, __Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_: __Z13sweepAABBAABBRKN5physx6PxVec3ES2_S2_S2_S2_S2_, __ZN24AudioScriptBufferManager7CleanupEv: __ZN24AudioScriptBufferManager7CleanupEv, __Z32setPxScene_ContactModifyCallbackPN5physx7PxSceneEPNS_23PxContactModifyCallbackE: __Z32setPxScene_ContactModifyCallbackPN5physx7PxSceneEPNS_23PxContactModifyCallbackE, __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_: __ZN15AnchoredJoint2D16ConfigureAnchorsER6b2Vec2S1_, __Z44Register_UnityEngine_Animator_StartRecordingv: __Z44Register_UnityEngine_Animator_StartRecordingv, __ZN14AnimationState13CleanupCurvesEv: __ZN14AnimationState13CleanupCurvesEv, __ZN18AnimatorController13GetBehavioursEP11Il2CppClass: __ZN18AnimatorController13GetBehavioursEP11Il2CppClass, __ZN9ShaderLab14SerializedPassC2ERKS0_: __ZN9ShaderLab14SerializedPassC2ERKS0_, __Z38ParticleEmitter_Set_Custom_PropMinSizeP12Il2CppObjectf: __Z38ParticleEmitter_Set_Custom_PropMinSizeP12Il2CppObjectf, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __ZN5physx18NpArticulationLink17setLinearVelocityERKNS_6PxVec3Eb: __ZN5physx18NpArticulationLink17setLinearVelocityERKNS_6PxVec3Eb, __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_S5_T_, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwiw: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwiw, __ZNK7Texture14IsDepthTextureEv: __ZNK7Texture14IsDepthTextureEv, _cff_get_name_index: _cff_get_name_index, __ZN5physx17ConvexHullBuilder14CreateEdgeListEv: __ZN5physx17ConvexHullBuilder14CreateEdgeListEv, __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE8__appendEj, __ZN17TransformInternal27UpdateDeepChildCountUpwardsER18TransformHierarchyii: __ZN17TransformInternal27UpdateDeepChildCountUpwardsER18TransformHierarchyii, __ZNK5physx12NpConstraint10getNpSceneEv: __ZNK5physx12NpConstraint10getNpSceneEv, __ZN7mecanim9animation22DestroyClipMuscleInputEPNS0_15ClipMuscleInputERNS_6memory9AllocatorE: __ZN7mecanim9animation22DestroyClipMuscleInputEPNS0_15ClipMuscleInputERNS_6memory9AllocatorE, __ZN5physx2Sq16BucketPrunerNodeC2Ev: __ZN5physx2Sq16BucketPrunerNodeC2Ev, __ZN13ComputeBuffer7GetDataEPvj: __ZN13ComputeBuffer7GetDataEPvj, __ZN5physxL24PxcSweepCapsuleTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf: __ZN5physxL24PxcSweepCapsuleTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf, __Z35HingeJoint_Get_Custom_PropUseLimitsP12Il2CppObject: __Z35HingeJoint_Get_Custom_PropUseLimitsP12Il2CppObject, __ZN5Unity17ConfigurableJoint22SetAngularXLimitSpringERK20SoftJointLimitSpring: __ZN5Unity17ConfigurableJoint22SetAngularXLimitSpringERK20SoftJointLimitSpring, __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE8__appendEj, __ZN14NavMeshManager6UpdateEv: __ZN14NavMeshManager6UpdateEv, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE12getAggregateEv, __ZN15NavMeshSettingsC2ER10MemLabelId18ObjectCreationMode: __ZN15NavMeshSettingsC2ER10MemLabelId18ObjectCreationMode, __Z43AudioReverbZone_Set_Custom_PropReverbPresetP12Il2CppObjecti: __Z43AudioReverbZone_Set_Custom_PropReverbPresetP12Il2CppObjecti, __Z38Camera_Get_Custom_PropOrthographicSizeP12Il2CppObject: __Z38Camera_Get_Custom_PropOrthographicSizeP12Il2CppObject, __ZN15LocationService20StopUpdatingLocationEv: __ZN15LocationService20StopUpdatingLocationEv, _open_face_PS_from_sfnt_stream: _open_face_PS_from_sfnt_stream, __Z40Register_UnityEngine_Font_get_lineHeightv: __Z40Register_UnityEngine_Font_get_lineHeightv, __ZN6Object18RegisterInstanceIDEPS_: __ZN6Object18RegisterInstanceIDEPS_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE: __ZN5physx3Scb5Scene20addArticulationJointERNS0_17ArticulationJointE, __ZNK9GfxDevice18GetWorldViewMatrixEv: __ZNK9GfxDevice18GetWorldViewMatrixEv, __Z22ConnectVirtualJoystickPKc: __Z22ConnectVirtualJoystickPKc, __ZN11AudioSource23SetIgnoreListenerVolumeEb: __ZN11AudioSource23SetIgnoreListenerVolumeEb, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv, __ZN5physx21solveVCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE: __ZN5physx21solveVCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE, __ZN5Umbra15OcclusionBufferaSERKS0_: __ZN5Umbra15OcclusionBufferaSERKS0_, __ZN13GfxDeviceNull13SetDepthStateEPK16DeviceDepthState: __ZN13GfxDeviceNull13SetDepthStateEPK16DeviceDepthState, __Z55Register_UnityEngine_Animator_INTERNAL_set_rootPositionv: __Z55Register_UnityEngine_Animator_INTERNAL_set_rootPositionv, __Z25computePacketSizeMultLog2ff: __Z25computePacketSizeMultLog2ff, __Z50Register_UnityEngine_AndroidJNI_GetIntArrayElementv: __Z50Register_UnityEngine_AndroidJNI_GetIntArrayElementv, __ZNK11BoxCollider26GetTypeInfoVirtualInternalEv: __ZNK11BoxCollider26GetTypeInfoVirtualInternalEv, __ZN11AudioSource15GetSpectrumDataEPfii19FMOD_DSP_FFT_WINDOW: __ZN11AudioSource15GetSpectrumDataEPfii19FMOD_DSP_FFT_WINDOW, _UNITY_png_handle_PLTE: _UNITY_png_handle_PLTE, __ZN5physx3Ext7D6Joint16setDriveVelocityERKNS_6PxVec3ES4_: __ZN5physx3Ext7D6Joint16setDriveVelocityERKNS_6PxVec3ES4_, __Z50ParticleSystem_TriggerModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf: __Z50ParticleSystem_TriggerModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration21generateEEContactsMTDERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration21generateEEContactsMTDERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z49Register_UnityEngine_SparseTexture_get_tileHeightv: __Z49Register_UnityEngine_SparseTexture_get_tileHeightv, __ZN5physx2Gu18pcmContactPlaneBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu18pcmContactPlaneBoxERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNK13MonoBehaviour18IsScriptableObjectEv: __ZNK13MonoBehaviour18IsScriptableObjectEv, __ZN5physx21updateCollDataDynamicERNS_19PxsParticleCollDataERKNS_11PxTransformERKNS_6PxVec3ES7_PKNS_11PxsBodyCoreES4_fRNS_25PxsFluidConstraintDynamicESC_: __ZN5physx21updateCollDataDynamicERNS_19PxsParticleCollDataERKNS_11PxTransformERKNS_6PxVec3ES7_PKNS_11PxsBodyCoreES4_fRNS_25PxsFluidConstraintDynamicESC_, __Z41Register_UnityEngine_Renderer_get_enabledv: __Z41Register_UnityEngine_Renderer_get_enabledv, __ZN20TextRenderingPrivate15DynamicFontDataD2Ev: __ZN20TextRenderingPrivate15DynamicFontDataD2Ev, __ZN14SphereCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14SphereCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f: __Z13EulerToMatrixRK8Vector3fR10Matrix3x3f, __ZN5physx3Cct9SweepTest18updateTouchedGeomsEPKNS0_30InternalCBData_FindTouchedGeomERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3ERKNS_19PxControllerFiltersERKNS_6PxVec3E: __ZN5physx3Cct9SweepTest18updateTouchedGeomsEPKNS0_30InternalCBData_FindTouchedGeomERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3ERKNS_19PxControllerFiltersERKNS_6PxVec3E, __Z27Shader_CUSTOM_EnableKeywordP12Il2CppString: __Z27Shader_CUSTOM_EnableKeywordP12Il2CppString, __ZN13RuntimeStaticI12EventManagerE10InitializeEv: __ZN13RuntimeStaticI12EventManagerE10InitializeEv, __Z55Register_UnityEngine_Physics2D_set_showColliderContactsv: __Z55Register_UnityEngine_Physics2D_set_showColliderContactsv, __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE: __ZN2UI39SendIgnoreNextTransformChangedRecursiveEPK9TransformPKNS_6CanvasE, __ZN27ColorModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN27ColorModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN5physx6shdfnd5ArrayIPNS_2Sq10ActorShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sq10ActorShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18WheelFrictionCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z55ConfigurableJoint_Get_Custom_PropConfiguredInWorldSpaceP12Il2CppObject: __Z55ConfigurableJoint_Get_Custom_PropConfiguredInWorldSpaceP12Il2CppObject, __ZNK9GfxDevice25GetDeviceProjectionMatrixEv: __ZNK9GfxDevice25GetDeviceProjectionMatrixEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv: __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteIndentEv, __ZNK11ICallStringcv8UnityStrEv: __ZNK11ICallStringcv8UnityStrEv, __ZN11UTF16StringC2EPKc10MemLabelId: __ZN11UTF16StringC2EPKc10MemLabelId, __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE: __ZL13midPhaseQueryRKN5physx22PxTriangleMeshGeometryERKNS_11PxTransformERNS_2Gu3BoxERNS6_9ContainerE, __ZN9JSONWrite8TransferI13dynamic_arrayI4AABBLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI4AABBLj4EEEEvRT_PKc17TransferMetaFlags, __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsWidthv: __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsWidthv, __ZN5physx14PxLightCpuTask15removeReferenceEv: __ZN5physx14PxLightCpuTask15removeReferenceEv, __Z71Register_UnityEngine_ParticleSystem_TrailModule_SetInheritParticleColorv: __Z71Register_UnityEngine_ParticleSystem_TrailModule_SetInheritParticleColorv, __ZN19SpriteMeshGenerator4path4bboxEv: __ZN19SpriteMeshGenerator4path4bboxEv, __ZN23ManagedAttributeManager41GetParentTypeDisallowingMultipleInclusionEP11Il2CppClass: __ZN23ManagedAttributeManager41GetParentTypeDisallowingMultipleInclusionEP11Il2CppClass, __ZN5physx14NpArticulation12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx14NpArticulation12createObjectERPhRNS_24PxDeserializationContextE, __ZN23ParticleSystemParticles17SetUses3DRotationEv: __ZN23ParticleSystemParticles17SetUses3DRotationEv, __ZN19SkinnedMeshRenderer17ReloadToGfxDeviceEv: __ZN19SkinnedMeshRenderer17ReloadToGfxDeviceEv, __Z61ParticleSystem_ShapeModule_CUSTOM_SetSphericalDirectionAmountP12Il2CppObjectf: __Z61ParticleSystem_ShapeModule_CUSTOM_SetSphericalDirectionAmountP12Il2CppObjectf, __Z62Register_UnityEngine_Renderer_INTERNAL_get_lightmapScaleOffsetv: __Z62Register_UnityEngine_Renderer_INTERNAL_get_lightmapScaleOffsetv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj121ENS_22PxRepXPropertyAccessorILj121ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj121ENS_22PxRepXPropertyAccessorILj121ES4_ffEEEEvRKT0_, __ZN5physx8debugger18MemPvdOutputStream10directCopyERNS0_14PvdInputStreamEj: __ZN5physx8debugger18MemPvdOutputStream10directCopyERNS0_14PvdInputStreamEj, __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState: __ZL16AssignBoundCurveRK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEERS7_P17AnimationCurveTplIfERK13dynamic_arrayI20BoundCurveDeprecatedLj4EER14AnimationState, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17getStaticFrictionEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17getStaticFrictionEv, __ZN5physx6shdfnd5ArrayINS_2Sn12PointerRemap12InternalDataENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_2Sn12PointerRemap12InternalDataENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z43GIDebugVisualisation_Set_Custom_PropTexType13GITextureType: __Z43GIDebugVisualisation_Set_Custom_PropTexType13GITextureType, __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z37TargetJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf: __Z37TargetJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf, __ZN27UnloadUnusedAssetsOperation12GetDebugNameEv: __ZN27UnloadUnusedAssetsOperation12GetDebugNameEv, __Z37RegisterModuleClasses_UnityWebRequestv: __Z37RegisterModuleClasses_UnityWebRequestv, __Z45SystemInfo_Get_Custom_PropGraphicsShaderLevelv: __Z45SystemInfo_Get_Custom_PropGraphicsShaderLevelv, __ZN19ShaderPropertySheet38CopyTextureWithAuxiliaryPropertiesFromERKN9ShaderLab16FastPropertyNameERKS_: __ZN19ShaderPropertySheet38CopyTextureWithAuxiliaryPropertiesFromERKN9ShaderLab16FastPropertyNameERKS_, __Z50Register_UnityEngine_AndroidJNI_GetStaticCharFieldv: __Z50Register_UnityEngine_AndroidJNI_GetStaticCharFieldv, __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev: __ZN20TextRenderingPrivate19NativeTextGeneratorD2Ev, __Z28getPxJoint_RelativeTransformPKN5physx7PxJointE: __Z28getPxJoint_RelativeTransformPKN5physx7PxJointE, __Z56Register_UnityEngine_Audio_AudioMixer_FindMatchingGroupsv: __Z56Register_UnityEngine_Audio_AudioMixer_FindMatchingGroupsv, __ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_: __ZNK9dtNavMesh29getOffMeshConnectionEndPointsEyyPfS0_, __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN20TextRenderingPrivate8FontImpl18GetCharacterBitmapERjS1_S1_R5RectTIfERfjifj: __ZN20TextRenderingPrivate8FontImpl18GetCharacterBitmapERjS1_S1_R5RectTIfERfjifj, __Z31Event_Set_Custom_PropClickCountP12Il2CppObjecti: __Z31Event_Set_Custom_PropClickCountP12Il2CppObjecti, __ZN14DirectorPlayer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14DirectorPlayer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _add_huff_table: _add_huff_table, __ZN23ControllerContactFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE: __ZN23ControllerContactFilter9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE, __Z14CurlGlobalInitv: __Z14CurlGlobalInitv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13get_allocatorEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13get_allocatorEv, __Z19GetCachedBinaryNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_S7_S7_R11fixed_arrayIcLj33EE: __Z19GetCachedBinaryNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_S7_S7_R11fixed_arrayIcLj33EE, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev, __ZL24InitializeModule_Terrainv: __ZL24InitializeModule_Terrainv, __Z57Register_UnityEngine_SliderJoint2D_set_autoConfigureAnglev: __Z57Register_UnityEngine_SliderJoint2D_set_autoConfigureAnglev, _inet_pton: _inet_pton, __ZNK9profiling14SamplerManager18SetSamplersEnabledEb: __ZNK9profiling14SamplerManager18SetSamplersEnabledEb, __Z47Register_UnityEngine_Animator_get_gravityWeightv: __Z47Register_UnityEngine_Animator_get_gravityWeightv, __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_: __ZN13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EE6insertEPS2_PKS2_S6_, __ZN15AudioReverbZone12VerifyValuesEv: __ZN15AudioReverbZone12VerifyValuesEv, __ZN5physx7NpScene12createClientEv: __ZN5physx7NpScene12createClientEv, __Z43Register_UnityEngine_Canvas_set_scaleFactorv: __Z43Register_UnityEngine_Canvas_set_scaleFactorv, __ZN5physx16PxStringTableExt17createStringTableERNS_19PxAllocatorCallbackE: __ZN5physx16PxStringTableExt17createStringTableERNS_19PxAllocatorCallbackE, __ZN8Animator19OnUpdateModeChangedEv: __ZN8Animator19OnUpdateModeChangedEv, __ZNSt3__214codecvt_bynameIwc11__mbstate_tED2Ev: __ZNSt3__214codecvt_bynameIwc11__mbstate_tED2Ev, __Z24scripting_field_get_nameP9FieldInfo: __Z24scripting_field_get_nameP9FieldInfo, __Z36Register_UnityEngine_Font_get_ascentv: __Z36Register_UnityEngine_Font_get_ascentv, _raccess_guess_linux_cap: _raccess_guess_linux_cap, __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j: __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fN5physx5cloth12LerpIteratorIS1_PKS1_EEEEvPT_RKT0_j, __Z36AudioSource_Get_Custom_PropIsPlayingP12Il2CppObject: __Z36AudioSource_Get_Custom_PropIsPlayingP12Il2CppObject, __ZN7mecanim5human7AddAxisEPKNS0_5HumanEiRKN4math7_float4E: __ZN7mecanim5human7AddAxisEPKNS0_5HumanEiRKN4math7_float4E, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYMultiplierv, __Z58Register_UnityEngine_QualitySettings_get_desiredColorSpacev: __Z58Register_UnityEngine_QualitySettings_get_desiredColorSpacev, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, _D6JointSolverPrep: _D6JointSolverPrep, __ZN5Light8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Light8TransferI24GenerateTypeTreeTransferEEvRT_, __Z62Register_UnityEngine_AI_OffMeshLinkData_GetOffMeshLinkInternalv: __Z62Register_UnityEngine_AI_OffMeshLinkData_GetOffMeshLinkInternalv, __Z33InitializeBuiltinShaderParamNamesv: __Z33InitializeBuiltinShaderParamNamesv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestv: __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestv, __ZN13PhysicsModule24CapsuleColliderSetHeightER15CapsuleColliderf: __ZN13PhysicsModule24CapsuleColliderSetHeightER15CapsuleColliderf, _ungetc: _ungetc, __ZN5physx14PxsAABBManager25removeAggregateSinglePairEjPNS_9AggregateEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx14PxsAABBManager25removeAggregateSinglePairEjPNS_9AggregateEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __ZNK16TypeTreeIterator4TypeEv: __ZNK16TypeTreeIterator4TypeEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEv, __Z28Animator_CUSTOM_SetIntegerIDP12Il2CppObjectii: __Z28Animator_CUSTOM_SetIntegerIDP12Il2CppObjectii, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEED0Ev: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEED0Ev, __ZN13GfxDeviceGLES32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat: __ZN13GfxDeviceGLES32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat, __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj: __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj, __ZN12AudioManager24CreateFMODSoundFromMovieEP9AudioClip: __ZN12AudioManager24CreateFMODSoundFromMovieEP9AudioClip, __ZN14PhysicMaterial16SetBounceCombineEi: __ZN14PhysicMaterial16SetBounceCombineEi, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE8WriteIntEi: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE8WriteIntEi, __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16LevelGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj, __Z70Register_UnityEngine_TerrainData_Internal_GetMaximumAlphamapResolutionv: __Z70Register_UnityEngine_TerrainData_Internal_GetMaximumAlphamapResolutionv, __ZNSt3__227__insertion_sort_incompleteIRN15Cast2DQueryBase14FixtureContactEPS2_EEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRN15Cast2DQueryBase14FixtureContactEPS2_EEbT0_S5_T_, __ZN12TreeDatabase9PrototypeC2Ev: __ZN12TreeDatabase9PrototypeC2Ev, __ZN6AvatarC2E10MemLabelId18ObjectCreationMode: __ZN6AvatarC2E10MemLabelId18ObjectCreationMode, __ZN15FrictionJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN15FrictionJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN5physx35integrateUndriveWheelRotationSpeedsEfffPKfS1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE: __ZN5physx35integrateUndriveWheelRotationSpeedsEfffPKfS1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE, __ZN5physx2Sc10NPhaseCore9visualizeERNS_2Cm12RenderOutputE: __ZN5physx2Sc10NPhaseCore9visualizeERNS_2Cm12RenderOutputE, __Z26setPxVehicleEngineDataMMOIPN5physx19PxVehicleEngineDataEf: __Z26setPxVehicleEngineDataMMOIPN5physx19PxVehicleEngineDataEf, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z21getPxActor_ActorFlagsPKN5physx7PxActorE: __Z21getPxActor_ActorFlagsPKN5physx7PxActorE, __ZN5physx2Gu12TriangleMesh15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Gu12TriangleMesh15exportExtraDataERNS_22PxSerializationContextE, __Z44UnityWebRequest_Set_Custom_PropRedirectLimitP12Il2CppObjecti: __Z44UnityWebRequest_Set_Custom_PropRedirectLimitP12Il2CppObjecti, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPKv: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPKv, _feof: _feof, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4dataEv, __ZNK14NavMeshManager11MapPositionEPyP8Vector3fRKS1_S4_RK13dtQueryFilter: __ZNK14NavMeshManager11MapPositionEPyP8Vector3fRKS1_S4_RK13dtQueryFilter, __ZN7mecanim9animation23CreateBlendTreeConstantEPPNS0_21BlendTreeNodeConstantEjRNS_6memory9AllocatorE: __ZN7mecanim9animation23CreateBlendTreeConstantEPPNS0_21BlendTreeNodeConstantEjRNS_6memory9AllocatorE, __Z24ConvertSeparatorsToUnityPc: __Z24ConvertSeparatorsToUnityPc, __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev: __ZNSt3__213__vector_baseI9InputAxisNS_9allocatorIS1_EEED2Ev, __ZN4PPtrI18AnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI18AnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN12_GLOBAL__N_116RequiresCallback7processERN5physx6PxBaseE: __ZN12_GLOBAL__N_116RequiresCallback7processERN5physx6PxBaseE, __Z41InitializeTransferFieldFromScriptingFieldR18TransferField_InfoPKS_P9FieldInfoP11Il2CppClassRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsRK20CoreScriptingClasses: __Z41InitializeTransferFieldFromScriptingFieldR18TransferField_InfoPKS_P9FieldInfoP11Il2CppClassRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsRK20CoreScriptingClasses, __ZN11ForceModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState: __ZN11ForceModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState, __ZN5physx35PxcContactCapsuleHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx35PxcContactCapsuleHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z43setPxSceneDescContactReportStreamBufferSizePN5physx11PxSceneDescEj: __Z43setPxSceneDescContactReportStreamBufferSizePN5physx11PxSceneDescEj, __ZNK8GUIStyle9ClampRectERK5RectTIfE: __ZNK8GUIStyle9ClampRectERK5RectTIfE, __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb: __ZN5physx2Sc8BodyCore17setupSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEbb, __ZNK5physx2Gu10ConvexMesh14getLocalBoundsEv: __ZNK5physx2Gu10ConvexMesh14getLocalBoundsEv, __Z49Register_UnityEngine_ParticleSystem_set_startSizev: __Z49Register_UnityEngine_ParticleSystem_set_startSizev, __ZN16Physics2DManager12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP10Collider2Dj: __ZN16Physics2DManager12BatchOverlapER13dynamic_arrayI15BatchedOverlapsLj4EEPP10Collider2Dj, _cf2_glyphpath_finalize: _cf2_glyphpath_finalize, __ZN5physx2Sc18ParticleSystemCore20returnStandaloneDataEPNS_15PxsParticleDataE: __ZN5physx2Sc18ParticleSystemCore20returnStandaloneDataEPNS_15PxsParticleDataE, __Z40AudioSettings_Get_Custom_PropSpeakerModev: __Z40AudioSettings_Get_Custom_PropSpeakerModev, __ZN9Animation4StopER14AnimationState: __ZN9Animation4StopER14AnimationState, __Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f: __Z20LookRotationToMatrixRK8Vector3fS1_P10Matrix3x3f, __Z27getPxRevoluteJoint_VelocityPKN5physx15PxRevoluteJointE: __Z27getPxRevoluteJoint_VelocityPKN5physx15PxRevoluteJointE, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEED0Ev, __Z24RegisterStrippedTypeInfoI16SubstanceArchiveEviPKcS2_: __Z24RegisterStrippedTypeInfoI16SubstanceArchiveEviPKcS2_, __ZN12WheelJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12WheelJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5Unity9Component26SupportedMessagesDidChangeEi: __ZN5Unity9Component26SupportedMessagesDidChangeEi, _wcstox_528: _wcstox_528, __ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di: __ZN16Physics2DManager7RaycastERK8Vector2fS2_fiffPK10Collider2DbP12RaycastHit2Di, __Z66Register_UnityEngine_CharacterController_get_enableOverlapRecoveryv: __Z66Register_UnityEngine_CharacterController_get_enableOverlapRecoveryv, __ZL32TransformParticleMeshAnimatedUVsILb0EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh: __ZL32TransformParticleMeshAnimatedUVsILb0EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh, __ZNK12b2MouseJoint15GetDampingRatioEv: __ZNK12b2MouseJoint15GetDampingRatioEv, __ZN5Umbra9Matrix2x29transposeERKS0_: __ZN5Umbra9Matrix2x29transposeERKS0_, __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZN17SurfaceEffector2D21ContactUpdateCallbackEf: __ZN17SurfaceEffector2D21ContactUpdateCallbackEf, _UNITY_FT_Stream_Free: _UNITY_FT_Stream_Free, __Z54Register_UnityEngine_AnimationState_get_normalizedTimev: __Z54Register_UnityEngine_AnimationState_get_normalizedTimev, __ZN4FMOD5Sound13setLoopPointsEjjjj: __ZN4FMOD5Sound13setLoopPointsEjjjj, __ZN10GpuProgramD0Ev: __ZN10GpuProgramD0Ev, __ZN13WheelCollider10SmartResetEv: __ZN13WheelCollider10SmartResetEv, __ZNK9Rigidbody23GetSleepAngularVelocityEv: __ZNK9Rigidbody23GetSleepAngularVelocityEv, __Z61Register_UnityEngine_AudioLowPassFilter_set_customCutoffCurvev: __Z61Register_UnityEngine_AudioLowPassFilter_set_customCutoffCurvev, __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj651ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj651ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44getPxVehicleDriveDynData_EngineRotationSpeedPKN5physx21PxVehicleDriveDynDataE: __Z44getPxVehicleDriveDynData_EngineRotationSpeedPKN5physx21PxVehicleDriveDynDataE, __ZN13WebCamTexture14GetWorldOffsetEv: __ZN13WebCamTexture14GetWorldOffsetEv, __ZN4FMOD8ChannelI14get3DOcclusionEPfS1_: __ZN4FMOD8ChannelI14get3DOcclusionEPfS1_, __Z35WheelCollider_Set_Custom_PropRadiusP12Il2CppObjectf: __Z35WheelCollider_Set_Custom_PropRadiusP12Il2CppObjectf, __Z41LineRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_: __Z41LineRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_, __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager18setEdgeUnconnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE: __ZN9ShaderLab18SerializedPropertyC2EPKcS2_NS0_22SerializedPropertyTypeERKNSt3__26vectorINS4_12basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEENS9_ISB_EEEE, __ZN11UnityEngine15CloudWebService14DataDispatcher25OnDataBlockConsumedStaticEPv: __ZN11UnityEngine15CloudWebService14DataDispatcher25OnDataBlockConsumedStaticEPv, __ZN9Animation20GetClipLegacyWarningEP13AnimationClip: __ZN9Animation20GetClipLegacyWarningEP13AnimationClip, __ZN15DownloadHandler7ReleaseEv: __ZN15DownloadHandler7ReleaseEv, __ZL27GeomMTDCallback_PlaneConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL27GeomMTDCallback_PlaneConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z26OptimizeTransformHierarchyR10GameObjectPK8UnityStrj: __Z26OptimizeTransformHierarchyR10GameObjectPK8UnityStrj, _writev: _writev, _wcstold: _wcstold, __Z24RegisterStrippedTypeInfoI10GUIElementEviPKcS2_: __Z24RegisterStrippedTypeInfoI10GUIElementEviPKcS2_, __ZN11AssetBundleC2E10MemLabelId18ObjectCreationMode: __ZN11AssetBundleC2E10MemLabelId18ObjectCreationMode, __ZN5physx21PxVehicleDriveSimData14setAutoBoxDataERKNS_20PxVehicleAutoBoxDataE: __ZN5physx21PxVehicleDriveSimData14setAutoBoxDataERKNS_20PxVehicleAutoBoxDataE, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _wcstoll: _wcstoll, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEED2Ev, __ZN12GUIClipState4ClipERK8Vector2f: __ZN12GUIClipState4ClipERK8Vector2f, _jsimd_can_ycc_rgb: _jsimd_can_ycc_rgb, __Z9EndJobSetR8JobFence11JobPriority: __Z9EndJobSetR8JobFence11JobPriority, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZN5physx2Sn12RepXUpgrader17upgradeCollectionERNS0_14RepXCollectionE: __ZN5physx2Sn12RepXUpgrader17upgradeCollectionERNS0_14RepXCollectionE, __Z59Register_UnityEngine_AnimationClip_INTERNAL_set_localBoundsv: __Z59Register_UnityEngine_AnimationClip_INTERNAL_set_localBoundsv, __ZN15QualitySettings22SetShadowCascade4SplitE8Vector3f: __ZN15QualitySettings22SetShadowCascade4SplitE8Vector3f, __ZN5physx24PxMeshScaleGeneratedInfoC2Ev: __ZN5physx24PxMeshScaleGeneratedInfoC2Ev, __ZN8Animator18SetApplyRootMotionEb: __ZN8Animator18SetApplyRootMotionEb, __ZNK5physx2Sc9ClothCore16getStretchConfigENS_22PxClothFabricPhaseType4EnumE: __ZNK5physx2Sc9ClothCore16getStretchConfigENS_22PxClothFabricPhaseType4EnumE, __Z39TrailRenderer_Get_Custom_PropWidthCurveP12Il2CppObject: __Z39TrailRenderer_Get_Custom_PropWidthCurveP12Il2CppObject, __Z69Register_UnityEngine_TerrainData_Internal_GetMaximumBaseMapResolutionv: __Z69Register_UnityEngine_TerrainData_Internal_GetMaximumBaseMapResolutionv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjPKcj, __ZN5physx2Sc13ClothBulkData15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc13ClothBulkData15exportExtraDataERNS_22PxSerializationContextE, __Z35SpriteRenderer_Set_Custom_PropFlipXP12Il2CppObjecth: __Z35SpriteRenderer_Set_Custom_PropFlipXP12Il2CppObjecth, __ZN17PhysicsMaterial2DD2Ev: __ZN17PhysicsMaterial2DD2Ev, __ZN15ReflectionProbe23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15ReflectionProbe23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_T_, __ZN17ArchiveFileSystem4CopyER13FileEntryDataS1_: __ZN17ArchiveFileSystem4CopyER13FileEntryDataS1_, __ZN12_GLOBAL__N_110DataStream15destroyInstanceEPKv: __ZN12_GLOBAL__N_110DataStream15destroyInstanceEPKv, __ZN9Rigidbody7SetDragEf: __ZN9Rigidbody7SetDragEf, _fdopendir: _fdopendir, _ungetwc: _ungetwc, _UNITY_png_set_sRGB: _UNITY_png_set_sRGB, __ZN4crnd12crn_unpacker11unpack_dxt5EPPhjjjjjj: __ZN4crnd12crn_unpacker11unpack_dxt5EPPhjjjjjj, __ZNSt3__215messages_bynameIcED0Ev: __ZNSt3__215messages_bynameIcED0Ev, __ZN2UI6Canvas7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN2UI6Canvas7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEvPT_jRKT0_RKT1_j, __ZN5physx13GuMeshFactory17createHeightFieldERKNS_17PxHeightFieldDescE: __ZN5physx13GuMeshFactory17createHeightFieldERKNS_17PxHeightFieldDescE, __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback: __Z14testBoundsMeshRKN5physx2Gu24InternalTriangleMeshDataERKNS_11PxTransformES6_RKNS_2Cm23FastVertex2ShapeScalingEbRKNS_9PxBounds3ER26PxcContactCellMeshCallback, __Z43Cloth_Set_Custom_PropUseContinuousCollisionP12Il2CppObjectf: __Z43Cloth_Set_Custom_PropUseContinuousCollisionP12Il2CppObjectf, __Z36AudioSource_Get_Custom_PropMinVolumeP12Il2CppObject: __Z36AudioSource_Get_Custom_PropMinVolumeP12Il2CppObject, __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev: __ZN12_GLOBAL__N_114__libcpp_nmstrD2Ev, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _cmyk_ycck_convert: _cmyk_ycck_convert, __Z31Cursor_Get_Custom_PropLockStatev: __Z31Cursor_Get_Custom_PropLockStatev, __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EENS_3setIS3_15compare_tstringIPKcENS_9allocatorIS3_EEEEEENS_19__map_value_compareIS4_SD_20smaller_tstring_pairIS8_ELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE, __Z52Register_UnityEngine_AudioReverbFilter_get_diffusionv: __Z52Register_UnityEngine_AudioReverbFilter_get_diffusionv, __ZNK14RenderSettings23GetFFAmbientDeviceColorEv: __ZNK14RenderSettings23GetFFAmbientDeviceColorEv, __Z52Register_UnityEngine_GameObject_GetComponentInParentv: __Z52Register_UnityEngine_GameObject_GetComponentInParentv, __ZN15SerializeTraitsINSt3__24pairIPKN5Unity4TypeE7Hash128EEE8TransferI14SafeBinaryReadEEvRS7_RT_: __ZN15SerializeTraitsINSt3__24pairIPKN5Unity4TypeE7Hash128EEE8TransferI14SafeBinaryReadEEvRS7_RT_, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __Z37GenerateCombinedDynamicVisibleListJobP11CullResults: __Z37GenerateCombinedDynamicVisibleListJobP11CullResults, __GLOBAL__sub_I_runtime_graphics_billboard_lump_cpp: __GLOBAL__sub_I_runtime_graphics_billboard_lump_cpp, __ZNK13ScreenManager21GetCursorInsideWindowEv: __ZNK13ScreenManager21GetCursorInsideWindowEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags, __Z60Register_UnityEngine_SpringJoint2D_set_autoConfigureDistancev: __Z60Register_UnityEngine_SpringJoint2D_set_autoConfigureDistancev, __ZNSt3__27promiseIvE24set_value_at_thread_exitEv: __ZNSt3__27promiseIvE24set_value_at_thread_exitEv, __Z20IntersectAABBFrustumRK4AABBPK5Planej: __Z20IntersectAABBFrustumRK4AABBPK5Planej, __ZN12AdsIdHandler17AddAdsIdListenersER14IAdsIdListener: __ZN12AdsIdHandler17AddAdsIdListenersER14IAdsIdListener, __Z53Register_UnityEngine_TextGenerator_GetCharactersArrayv: __Z53Register_UnityEngine_TextGenerator_GetCharactersArrayv, _sendmsg: _sendmsg, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZNK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_: __ZNK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_, __ZZN8VRModuleC1EvEN10playerQuit7ForwardEv: __ZZN8VRModuleC1EvEN10playerQuit7ForwardEv, __ZN6HelperI8JSONRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI8JSONRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN13RenderManager15InitializeClassEv: __ZN13RenderManager15InitializeClassEv, __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z57Register_UnityEngine_Animator_SetIKPositionWeightInternalv: __Z57Register_UnityEngine_Animator_SetIKPositionWeightInternalv, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13switchToNoSimEv: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13switchToNoSimEv, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setMassSpaceInertiaTensorERKNS_6PxVec3E: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setMassSpaceInertiaTensorERKNS_6PxVec3E, __ZNSt3__23mapIN19CloudServiceHandler11ServiceTypeEPS1_NS_4lessIS2_EE13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier85ELi16EEEixERS8_: __ZNSt3__23mapIN19CloudServiceHandler11ServiceTypeEPS1_NS_4lessIS2_EE13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier85ELi16EEEixERS8_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj573ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj573ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__set_short_sizeEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__set_short_sizeEj, __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults: __ZL18intersectAnyVsMeshILi2EEbPKN5physx2Gu6SphereEPKNS1_7CapsuleEPKNS1_3BoxERKNS1_13RTreeMidphaseERKNS0_11PxTransformERKNS0_11PxMeshScaleEP14LimitedResults, __ZN5physx2Sc8ClothSim20removeCollisionPlaneEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim20removeCollisionPlaneEPKNS0_8ShapeSimE, __ZN7mecanim5human17HumanPoseBlendEndERNS0_9HumanPoseERf: __ZN7mecanim5human17HumanPoseBlendEndERNS0_9HumanPoseERf, __ZN14ParticleSystem20EmitParticleExternalER22ParticleSystemParticle: __ZN14ParticleSystem20EmitParticleExternalER22ParticleSystemParticle, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __Z49Register_UnityEngine_ParticleRenderer_set_uvTilesv: __Z49Register_UnityEngine_ParticleRenderer_set_uvTilesv, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE10BeginWriteEjj: __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE10BeginWriteEjj, __Z59Camera_CUSTOM_INTERNAL_CALL_CalculateFrustumCornersInternalP12Il2CppObjectRK5RectTIfEf21MonoOrStereoscopicEyeP11Il2CppArray: __Z59Camera_CUSTOM_INTERNAL_CALL_CalculateFrustumCornersInternalP12Il2CppObjectRK5RectTIfEf21MonoOrStereoscopicEyeP11Il2CppArray, __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED0Ev: __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED0Ev, __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlags, __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN7mecanim8skeleton18SkeletonFindNodeUpEPKNS0_8SkeletonEij: __ZN7mecanim8skeleton18SkeletonFindNodeUpEPKNS0_8SkeletonEij, __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP8Vector3f: __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP8Vector3f, __ZN12FileAccessor4ReadEyyPvPy: __ZN12FileAccessor4ReadEyyPvPy, __ZN10MemoryFile21CreateFileSystemEntryE10MemLabelId14FilePermissionPvjb: __ZN10MemoryFile21CreateFileSystemEntryE10MemLabelId14FilePermissionPvjb, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv, __ZNK18GfxFramebufferGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE: __ZNK18GfxFramebufferGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv, _fchmod: _fchmod, __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb0EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __ZN2UI14CanvasRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN2UI14CanvasRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE8__appendEj, __ZN5physx21PxVehicleDriveSimData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx21PxVehicleDriveSimData17getBinaryMetaDataERNS_14PxOutputStreamE, __Z18Transfer_BlittableI9JSONWriteLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z43RectTransform_Set_Custom_PropDrivenByObjectP12Il2CppObjectS0_: __Z43RectTransform_Set_Custom_PropDrivenByObjectP12Il2CppObjectS0_, __ZN5physx2Sc13ConstraintSim15preBodiesChangeEv: __ZN5physx2Sc13ConstraintSim15preBodiesChangeEv, __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_: __ZN5physx2Gu19ConstructSkewMatrixERKNS_6shdfnd3aos5Vec3VERKNS2_5Vec4VERNS2_6Mat33VESA_, __ZNK19RenderEventsContext7CleanupEv: __ZNK19RenderEventsContext7CleanupEv, __ZN13SpeedTreeWind7SParams8TransferI14SafeBinaryReadEEvRT_: __ZN13SpeedTreeWind7SParams8TransferI14SafeBinaryReadEEvRT_, __ZN9Texture2DD2Ev: __ZN9Texture2DD2Ev, __Z32setPxVehicleChassisDataMCMOffsetPN5physx20PxVehicleChassisDataENS_6PxVec3E: __Z32setPxVehicleChassisDataMCMOffsetPN5physx20PxVehicleChassisDataENS_6PxVec3E, __Z20Mesh_CUSTOM_OptimizeP12Il2CppObject: __Z20Mesh_CUSTOM_OptimizeP12Il2CppObject, __GLOBAL__sub_I_runtime_geometry_lump_cpp: __GLOBAL__sub_I_runtime_geometry_lump_cpp, __Z27PlayerPrefs_CUSTOM_GetFloatP12Il2CppStringf: __Z27PlayerPrefs_CUSTOM_GetFloatP12Il2CppStringf, __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j, __ZNK15TerrainCollider26GetTypeInfoVirtualInternalEv: __ZNK15TerrainCollider26GetTypeInfoVirtualInternalEv, __ZN14PhysicsManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14PhysicsManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z27setPxSceneLimitsMaxNbBodiesPN5physx13PxSceneLimitsEj: __Z27setPxSceneLimitsMaxNbBodiesPN5physx13PxSceneLimitsEj, __ZN9allocutil14BuddyAllocator12InternalFreeEjh: __ZN9allocutil14BuddyAllocator12InternalFreeEjh, __ZN5physx2Sn5ConvX12getMetaClassENS_14PxConcreteType4EnumENS0_12MetaDataTypeE: __ZN5physx2Sn5ConvX12getMetaClassENS_14PxConcreteType4EnumENS0_12MetaDataTypeE, __ZL33GetNonSkeletonTransformsRecursiveRKN7mecanim8skeleton8SkeletonERK9TransformS6_R13dynamic_arrayIPS5_Lj4EE: __ZL33GetNonSkeletonTransformsRecursiveRKN7mecanim8skeleton8SkeletonERK9TransformS6_R13dynamic_arrayIPS5_Lj4EE, __ZN26AnimatorOverrideController12CleanupClassEv: __ZN26AnimatorOverrideController12CleanupClassEv, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEE15growAndPushBackERKS2_, __ZN8Animator15SetGoalPositionEiRK8Vector3f: __ZN8Animator15SetGoalPositionEiRK8Vector3f, __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj: __ZL17drawManifoldPointRKN5physx2Gu17PersistentContactERKNS_6shdfnd3aos12PsTransformVES8_RNS_2Cm12RenderOutputEj, __Z26DestroySoundHandleInstancePN11SoundHandle8InstanceE: __Z26DestroySoundHandleInstancePN11SoundHandle8InstanceE, __ZN12HandlerChain4CopyER13FileEntryDataS1_: __ZN12HandlerChain4CopyER13FileEntryDataS1_, _UNITY_png_set_bgr: _UNITY_png_set_bgr, __ZN5physx2Sc5Scene31setClothInterCollisionStiffnessEf: __ZN5physx2Sc5Scene31setClothInterCollisionStiffnessEf, __ZN7mecanim12statemachine13EndTransitionERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS_6memory16MecanimAllocatorE: __ZN7mecanim12statemachine13EndTransitionERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS_6memory16MecanimAllocatorE, _isgraph_l: _isgraph_l, __Z44SceneUtility_CUSTOM_GetScenePathByBuildIndexi: __Z44SceneUtility_CUSTOM_GetScenePathByBuildIndexi, _write_file_trailer: _write_file_trailer, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN23ManagedAttributeManager24GetDefaultExecutionOrderEP11Il2CppClass: __ZN23ManagedAttributeManager24GetDefaultExecutionOrderEP11Il2CppClass, __ZN5physx8debugger4comm12BeginSectionD0Ev: __ZN5physx8debugger4comm12BeginSectionD0Ev, __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE: __ZNSt3__218__time_get_storageIwE9__analyzeEcRKNS_5ctypeIwEE, __ZN22RenderingCommandBuffer17AddSetGlobalFloatERKN9ShaderLab16FastPropertyNameEf: __ZN22RenderingCommandBuffer17AddSetGlobalFloatERKN9ShaderLab16FastPropertyNameEf, __ZN14NavMeshManager22UpdateNavMeshObstaclesEv: __ZN14NavMeshManager22UpdateNavMeshObstaclesEv, _towlower_l: _towlower_l, __Z47Physics2D_CUSTOM_INTERNAL_get_colliderAABBColorP10ColorRGBAf: __Z47Physics2D_CUSTOM_INTERNAL_get_colliderAABBColorP10ColorRGBAf, __ZNK17ProceduralTexture12GetDataWidthEv: __ZNK17ProceduralTexture12GetDataWidthEv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEED0Ev, __Z59Register_UnityEngine_ParticleSystemRenderer_set_lengthScalev: __Z59Register_UnityEngine_ParticleSystemRenderer_set_lengthScalev, __ZN5physx8debugger14PvdMarshallingIsyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsyE12marshalBlockEPKhPhj, __ZN5Umbra9Matrix2x26invertERKS0_: __ZN5Umbra9Matrix2x26invertERKS0_, __ZN5physx2Sc13ConstraintSim11projectPoseEPNS0_7BodySimE: __ZN5physx2Sc13ConstraintSim11projectPoseEPNS0_7BodySimE, __ZL16SimplifyPolylineR13dynamic_arrayI8Vector2fLj4EEf: __ZL16SimplifyPolylineR13dynamic_arrayI8Vector2fLj4EEf, __Z21IntersectSegmentPlaneRK8Vector3fS1_RK5PlanePS_: __Z21IntersectSegmentPlaneRK8Vector3fS1_RK5PlanePS_, __Z49Application_CUSTOM_CanStreamedLevelBeLoadedByNameP12Il2CppString: __Z49Application_CUSTOM_CanStreamedLevelBeLoadedByNameP12Il2CppString, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairINS3_IttEEfEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairINS3_IttEEfEEEEvRT_PKc17TransferMetaFlags, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE6narrowEwc: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE6narrowEwc, __ZN5physx21PxcContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx21PxcContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN12AudioManager31GetCurrentSpatializerDefinitionEv: __ZN12AudioManager31GetCurrentSpatializerDefinitionEv, __Z18GetProjectionPlanePKN5physx14PxParticleBaseE: __Z18GetProjectionPlanePKN5physx14PxParticleBaseE, __ZN12MeshRenderer16UpdateCachedMeshEv: __ZN12MeshRenderer16UpdateCachedMeshEv, __ZN9Rigidbody11SetPositionERK8Vector3f: __ZN9Rigidbody11SetPositionERK8Vector3f, __ZNSt3__23mapI26SerializedObjectIdentifieriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEixERS6_: __ZNSt3__23mapI26SerializedObjectIdentifieriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEixERS6_, __ZN24EllipsoidParticleEmitter8TransferI14SafeBinaryReadEEvRT_: __ZN24EllipsoidParticleEmitter8TransferI14SafeBinaryReadEEvRT_, __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZThn32_N17BillboardRendererD1Ev: __ZThn32_N17BillboardRendererD1Ev, _creall: _creall, __ZN12_GLOBAL__N_111StreamOwner10disconnectEv: __ZN12_GLOBAL__N_111StreamOwner10disconnectEv, __ZN5Unity11Adjacencies11AddTriangleEjjj: __ZN5Unity11Adjacencies11AddTriangleEjjj, _crealf: _crealf, __ZNK27StateMachineBehaviourPlayer25FireStateMachineBehaviourEiiN7mecanim12statemachine19StateMachineMessageE: __ZNK27StateMachineBehaviourPlayer25FireStateMachineBehaviourEiiN7mecanim12statemachine19StateMachineMessageE, __Z36Projector_Get_Custom_PropFieldOfViewP12Il2CppObject: __Z36Projector_Get_Custom_PropFieldOfViewP12Il2CppObject, __Z34ProcessIndexListIsNodeVisibleStep1RK22SceneCullingParametersPK9SceneNodejjR9IndexList: __Z34ProcessIndexListIsNodeVisibleStep1RK22SceneCullingParametersPK9SceneNodejjR9IndexList, __Z34Terrain_Set_Custom_PropCastShadowsP12Il2CppObjecth: __Z34Terrain_Set_Custom_PropCastShadowsP12Il2CppObjecth, __ZNK17ProceduralTexture11IsGrayscaleEv: __ZNK17ProceduralTexture11IsGrayscaleEv, __Z24setPxSceneDesc_ToDefaultPN5physx11PxSceneDescERKNS_17PxTolerancesScaleE: __Z24setPxSceneDesc_ToDefaultPN5physx11PxSceneDescERKNS_17PxTolerancesScaleE, __Z24setPxRevoluteJoint_LimitPN5physx15PxRevoluteJointERKNS_23PxJointAngularLimitPairE: __Z24setPxRevoluteJoint_LimitPN5physx15PxRevoluteJointERKNS_23PxJointAngularLimitPairE, __ZNK18ProceduralMaterial18GetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial18GetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN20ParticleSystemModuleD2Ev: __ZN20ParticleSystemModuleD2Ev, _UNITY_FT_Stream_GetUShort: _UNITY_FT_Stream_GetUShort, __ZN13GfxDeviceGLES14DisableScissorEv: __ZN13GfxDeviceGLES14DisableScissorEv, __ZN12_GLOBAL__N_116CollectionSorter10AddElementERNS0_7ElementE: __ZN12_GLOBAL__N_116CollectionSorter10AddElementERNS0_7ElementE, __ZN22MemoryCacherReadBlocks13GetFileLengthEv: __ZN22MemoryCacherReadBlocks13GetFileLengthEv, __Z18MurmurHash3_x86_32PKvijPv: __Z18MurmurHash3_x86_32PKvijPv, __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj: __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj, __ZN13SplatDatabase23CheckResourcesAvailableEv: __ZN13SplatDatabase23CheckResourcesAvailableEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj284ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj284ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK7VRInput19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZNK7VRInput19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_: __ZNK5physx10PxsContext25getManagerTouchEventCountEPiS1_S1_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv, __Z30HumanTrait_CUSTOM_RequiredBonei: __Z30HumanTrait_CUSTOM_RequiredBonei, __Z39DistanceJoint2D_Get_Custom_PropDistanceP12Il2CppObject: __Z39DistanceJoint2D_Get_Custom_PropDistanceP12Il2CppObject, __ZN19RuntimeSceneManager15GetLoadedScenesER13dynamic_arrayIP10UnitySceneLj4EE: __ZN19RuntimeSceneManager15GetLoadedScenesER13dynamic_arrayIP10UnitySceneLj4EE, __ZN20ArchiveStorageReader18ReleaseCachedBlockEPNS_11CachedBlockE: __ZN20ArchiveStorageReader18ReleaseCachedBlockEPNS_11CachedBlockE, __ZNK5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE7getNameEv, __ZN13LoadOperationC2Ev: __ZN13LoadOperationC2Ev, __ZN12b2BroadPhase13QueryCallbackEi: __ZN12b2BroadPhase13QueryCallbackEi, __Z42Animator_CUSTOM_INTERNAL_get_deltaRotationP12Il2CppObjectP11Quaternionf: __Z42Animator_CUSTOM_INTERNAL_get_deltaRotationP12Il2CppObjectP11Quaternionf, __Z40Camera_CUSTOM_INTERNAL_get_cullingMatrixP12Il2CppObjectP10Matrix4x4f: __Z40Camera_CUSTOM_INTERNAL_get_cullingMatrixP12Il2CppObjectP10Matrix4x4f, __ZN22BaseUnityConnectClient22RestoreAsyncConfigFileEv: __ZN22BaseUnityConnectClient22RestoreAsyncConfigFileEv, __Z47Register_UnityEngine_HingeJoint2D_get_useLimitsv: __Z47Register_UnityEngine_HingeJoint2D_get_useLimitsv, __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorINS_4pairINS1_IttEEfEENS_9allocatorIS3_EEE8__appendEj, __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI14SafeBinaryReadEEvRT_, __ZNK16BaseVideoTexture22GetBufferTextureFormatEv: __ZNK16BaseVideoTexture22GetBufferTextureFormatEv, __ZN5audio5mixer20ClearExposedPropertyERKNS0_16AudioMixerMemoryEi: __ZN5audio5mixer20ClearExposedPropertyERKNS0_16AudioMixerMemoryEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj604ENS_22PxRepXPropertyAccessorILj604ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj604ENS_22PxRepXPropertyAccessorILj604ES4_jjEEEEvjRKT0_, __ZN13GfxDeviceNull8EndFrameEv: __ZN13GfxDeviceNull8EndFrameEv, __Z41TerrainData_Get_Custom_PropHeightmapWidthP12Il2CppObject: __Z41TerrainData_Get_Custom_PropHeightmapWidthP12Il2CppObject, __ZNKSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentrycvbEv: __ZNKSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentrycvbEv, __Z24GetAIScriptingClassesPtrv: __Z24GetAIScriptingClassesPtrv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_jw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_jw, __Z17SetupObjectMatrixRK10Matrix4x4fi: __Z17SetupObjectMatrixRK10Matrix4x4fi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZN14GrowableBufferD2Ev: __ZN14GrowableBufferD2Ev, __ZNK15MBP_PairManager8findPairEjj: __ZNK15MBP_PairManager8findPairEjj, __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_11NpAggregateENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZNSt3__24listIPFb7LogTypePKcPiE13stl_allocatorIS6_L18MemLabelIdentifier7ELi16EEE6removeERKS6_: __ZNSt3__24listIPFb7LogTypePKcPiE13stl_allocatorIS6_L18MemLabelIdentifier7ELi16EEE6removeERKS6_, __ZN4FMOD3DSP16getNumParametersEPi: __ZN4FMOD3DSP16getNumParametersEPi, __ZN4FMOD7ReverbI11getUserDataEPPv: __ZN4FMOD7ReverbI11getUserDataEPPv, _unity_z_crc32_combine: _unity_z_crc32_combine, __Z43Object_CUSTOM_DoesObjectWithInstanceIDExisti: __Z43Object_CUSTOM_DoesObjectWithInstanceIDExisti, _iswctype: _iswctype, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZNK5physx16PxVehicleNoDrive14getBrakeTorqueEj: __ZNK5physx16PxVehicleNoDrive14getBrakeTorqueEj, __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaAllv: __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaAllv, __ZN11ForceModule8TransferI17RemapPPtrTransferEEvRT_: __ZN11ForceModule8TransferI17RemapPPtrTransferEEvRT_, _open_face: _open_face, __Z35CullingGroup_Get_Custom_PropEnabledP12Il2CppObject: __Z35CullingGroup_Get_Custom_PropEnabledP12Il2CppObject, __ZN18CapsuleCast2DQueryD2Ev: __ZN18CapsuleCast2DQueryD2Ev, __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI6ObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z52Register_UnityEngine_Font_Internal_CreateDynamicFontv: __Z52Register_UnityEngine_Font_Internal_CreateDynamicFontv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofERKS5_j, __ZN5physx2Sc17ParticleSystemSim19unlinkParticleShapeEPNS0_19ParticlePacketShapeE: __ZN5physx2Sc17ParticleSystemSim19unlinkParticleShapeEPNS0_19ParticlePacketShapeE, __Z24Tree_Get_Custom_PropDataP12Il2CppObject: __Z24Tree_Get_Custom_PropDataP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z29CullingGroup_CUSTOM_IsVisibleP12Il2CppObjecti: __Z29CullingGroup_CUSTOM_IsVisibleP12Il2CppObjecti, __ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw: __ZNSt3__29__num_getIwE17__stage2_int_loopEwiPcRS2_RjwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_Pw, __ZN11PlayerPrefs8SetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf: __ZN11PlayerPrefs8SetFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf, __ZN4FMOD5Sound11setUserDataEPv: __ZN4FMOD5Sound11setUserDataEPv, __ZN7dtCrowd10setNavMeshEPK9dtNavMeshPK15HeightMeshQueryfi: __ZN7dtCrowd10setNavMeshEPK9dtNavMeshPK15HeightMeshQueryfi, __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN5physx34PxArticulationJointGeneratedValuesC2EPKNS_19PxArticulationJointE: __ZN5physx34PxArticulationJointGeneratedValuesC2EPKNS_19PxArticulationJointE, __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastNonAllocv: __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastNonAllocv, __Z24Material_CUSTOM_GetFloatP12Il2CppObjecti: __Z24Material_CUSTOM_GetFloatP12Il2CppObjecti, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_, __Z56Register_UnityEngine_CanvasRenderer_set_popMaterialCountv: __Z56Register_UnityEngine_CanvasRenderer_set_popMaterialCountv, __ZNK25SingleBlockMemoryFileData4SizeEv: __ZNK25SingleBlockMemoryFileData4SizeEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZNK23ArchiveStorageConverter26GetUncompressedArchiveSizeEv: __ZNK23ArchiveStorageConverter26GetUncompressedArchiveSizeEv, __Z29StdTemplateConversionFunctionItsEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItsEbPvR14SafeBinaryRead, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh, __ZN9BlobWrite8TransferIN7mecanim12statemachine18StateMachineMemoryEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim12statemachine18StateMachineMemoryEEEvRT_PKc17TransferMetaFlags, __Z54Register_UnityEngine_AudioReverbFilter_set_reverbLevelv: __Z54Register_UnityEngine_AudioReverbFilter_set_reverbLevelv, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE11runInternalEv, _UNITY_png_zfree: _UNITY_png_zfree, __ZL50UnityAudioEffect_InternalSetFloatParameterCallbackP14FMOD_DSP_STATEif: __ZL50UnityAudioEffect_InternalSetFloatParameterCallbackP14FMOD_DSP_STATEif, __ZNK15dtProximityGrid10queryItemsEPKfPti: __ZNK15dtProximityGrid10queryItemsEPKfPti, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE7rdstateEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE7rdstateEv, __ZN17LowLevelAllocator4FreeEPvj: __ZN17LowLevelAllocator4FreeEPvj, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx, __Z48Register_UnityEngine_ParticleSystem_GetParticlesv: __Z48Register_UnityEngine_ParticleSystem_GetParticlesv, _jsimd_can_h2v2_upsample: _jsimd_can_h2v2_upsample, __Z35Physics_CUSTOM_INTERNAL_get_gravityP8Vector3f: __Z35Physics_CUSTOM_INTERNAL_get_gravityP8Vector3f, _jpeg_start_output: _jpeg_start_output, __ZN7ApiGLES22BindDrawIndirectBufferEj: __ZN7ApiGLES22BindDrawIndirectBufferEj, __Z52Register_UnityEngine_ParticleEmitter_get_minEmissionv: __Z52Register_UnityEngine_ParticleEmitter_get_minEmissionv, __ZNK10GISettings29IsRealtimeEnvironmentLightingEv: __ZNK10GISettings29IsRealtimeEnvironmentLightingEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZL19StaticCleanupPlayerPv: __ZL19StaticCleanupPlayerPv, __ZN5physx8debugger4comm9SetCameraD0Ev: __ZN5physx8debugger4comm9SetCameraD0Ev, __Z44Register_UnityEngine_Joint_get_connectedBodyv: __Z44Register_UnityEngine_Joint_get_connectedBodyv, __ZN5physx24writeBackContactCoulomb4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_: __ZN5physx24writeBackContactCoulomb4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_, __Z52Register_UnityEngine_ParticleEmitter_get_maxEmissionv: __Z52Register_UnityEngine_ParticleEmitter_get_maxEmissionv, __Z47ConfigurableJoint_Get_Custom_PropProjectionModeP12Il2CppObject: __Z47ConfigurableJoint_Get_Custom_PropProjectionModeP12Il2CppObject, _UNITY_png_read_chunk_header: _UNITY_png_read_chunk_header, __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetDeathP12Il2CppObjecti: __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetDeathP12Il2CppObjecti, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9Behaviour10DeactivateE19DeactivateOperation: __ZN9Behaviour10DeactivateE19DeactivateOperation, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEjc, __ZN15FrictionJoint2D11SetMaxForceEf: __ZN15FrictionJoint2D11SetMaxForceEf, __ZN13StreamingInfo8TransferI14SafeBinaryReadEEvRT_: __ZN13StreamingInfo8TransferI14SafeBinaryReadEEvRT_, __ZN13WheelCollider14FinalizeCreateEPK9Rigidbody: __ZN13WheelCollider14FinalizeCreateEPK9Rigidbody, __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_, _start_pass_dpost: _start_pass_dpost, __GLOBAL__sub_I_runtime_dynamics_lump_cpp: __GLOBAL__sub_I_runtime_dynamics_lump_cpp, __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __Z23CalculateGlobalRotation23TransformAccessReadOnly: __Z23CalculateGlobalRotation23TransformAccessReadOnly, __ZNK5physx25PxClothSimpleTetherCooker13getTetherDataEPjPf: __ZNK5physx25PxClothSimpleTetherCooker13getTetherDataEPjPf, __ZN12CubemapArray16DeleteGfxTextureEv: __ZN12CubemapArray16DeleteGfxTextureEv, _UNITY_tt_face_get_location: _UNITY_tt_face_get_location, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE8ValidateEPS1_: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE8ValidateEPS1_, __ZN5physx2Cm10FanoutTaskD0Ev: __ZN5physx2Cm10FanoutTaskD0Ev, __ZL21LibpngReadFuncWrapperP14png_struct_defPhj: __ZL21LibpngReadFuncWrapperP14png_struct_defPhj, _wmemset: _wmemset, __ZN5physx9NpFactory24createNpArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE: __ZN5physx9NpFactory24createNpArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE, __ZN5physx8debugger4comm10EndSection9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm10EndSection9serializeERNS1_15EventSerializerE, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE13isSubordinateEv, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE14setOwnerClientEh, __ZN5physx2Sc21ConstraintInteractionD2Ev: __ZN5physx2Sc21ConstraintInteractionD2Ev, __Z43InitializeRendererAnimationBindingInterfacev: __Z43InitializeRendererAnimationBindingInterfacev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__set_long_pointerEPw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__set_long_pointerEPw, __ZNKSt9exception4whatEv: __ZNKSt9exception4whatEv, __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete: __ZL26DestroyGameObjectRecursiveR10GameObjectR11BatchDelete, __ZN9Coroutine16SetCurrentMethodE21ScriptingMethodIl2Cpp: __ZN9Coroutine16SetCurrentMethodE21ScriptingMethodIl2Cpp, __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI14SafeBinaryReadEEvRS5_RT_: __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI14SafeBinaryReadEEvRS5_RT_, __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z48Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff: __Z48Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfiff, __ZNK5physx6shdfnd6Socket7getHostEv: __ZNK5physx6shdfnd6Socket7getHostEv, __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNK5physx2Gu9Container8ContainsEjPj: __ZNK5physx2Gu9Container8ContainsEjPj, __ZNSt3__26locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __Z42Register_UnityEngine_GUI_get_blendMaterialv: __Z42Register_UnityEngine_GUI_get_blendMaterialv, __Z7HaloTexP9Texture2DPhiiii: __Z7HaloTexP9Texture2DPhiiii, __ZN5physx24PxvRegisterArticulationsEv: __ZN5physx24PxvRegisterArticulationsEv, __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetDatav: __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetDatav, _wordexp: _wordexp, __Z55Register_UnityEngine_Input_set_simulateMouseWithTouchesv: __Z55Register_UnityEngine_Input_set_simulateMouseWithTouchesv, __ZN17AudioCustomFilter4InitEv: __ZN17AudioCustomFilter4InitEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EOS3_: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EOS3_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags, __ZN5physx3Ext14SphericalJointD2Ev: __ZN5physx3Ext14SphericalJointD2Ev, __ZN15Cast2DQueryBase15InitializeQueryEv: __ZN15Cast2DQueryBase15InitializeQueryEv, __ZN12_GLOBAL__N_1L3gORERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L3gORERN5physx12PxGroupsMaskERKS1_S4_, __ZN13UnityProfiler10CleanupGfxEv: __ZN13UnityProfiler10CleanupGfxEv, __ZNK6Camera30GetNonJitteredProjectionMatrixEv: __ZNK6Camera30GetNonJitteredProjectionMatrixEv, __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv: __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10hasClientsEv, __Z48Register_UnityEngine_Application_get_sandboxTypev: __Z48Register_UnityEngine_Application_get_sandboxTypev, __ZN9ShaderLab22SerializedBindChannels9MergeWithERKS0_: __ZN9ShaderLab22SerializedBindChannels9MergeWithERKS0_, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z39Graphics_CUSTOM_Internal_DrawMeshMatrixR36MonoInternal_DrawMeshMatrixArgumentsP12Il2CppObjectS2_S2_S2_: __Z39Graphics_CUSTOM_Internal_DrawMeshMatrixR36MonoInternal_DrawMeshMatrixArgumentsP12Il2CppObjectS2_S2_S2_, __Z52Register_UnityEngine_AI_OffMeshLink_get_costOverridev: __Z52Register_UnityEngine_AI_OffMeshLink_get_costOverridev, __ZN6Camera23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Camera23VirtualRedirectTransferER14SafeBinaryRead, __ZN18ProfilerConnection26HandleSetAudioCaptureFlagsEPKvjj: __ZN18ProfilerConnection26HandleSetAudioCaptureFlagsEPKvjj, __ZN10Effector2D12AddToManagerEv: __ZN10Effector2D12AddToManagerEv, __ZN11UnityEngine7Connect13ConnectConfig11ConfigValueD2Ev: __ZN11UnityEngine7Connect13ConnectConfig11ConfigValueD2Ev, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17PlayerLoopHandlerEv: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17PlayerLoopHandlerEv, __ZNKSt16bad_array_length4whatEv: __ZNKSt16bad_array_length4whatEv, __ZN5physx14NpArticulationD0Ev: __ZN5physx14NpArticulationD0Ev, __Z76Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimeMultiplierv: __Z76Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimeMultiplierv, __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEjT0_S8_S8_S8_T_, __ZN17SurfaceEffector2D8TransferI14SafeBinaryReadEEvRT_: __ZN17SurfaceEffector2D8TransferI14SafeBinaryReadEEvRT_, __ZN18ProfilerConnection18PrepareConnectionsEv: __ZN18ProfilerConnection18PrepareConnectionsEv, __Z45AudioReverbFilter_Set_Custom_PropReverbPresetP12Il2CppObjecti: __Z45AudioReverbFilter_Set_Custom_PropReverbPresetP12Il2CppObjecti, __Z59Register_UnityEngine_SystemInfo_get_supportsLocationServicev: __Z59Register_UnityEngine_SystemInfo_get_supportsLocationServicev, __Z27GetClothScriptingClassesPtrv: __Z27GetClothScriptingClassesPtrv, __ZN18GfxFramebufferGLES24UpdateDefaultFramebufferEP17RenderSurfaceBaseS1_N2gl6HandleILNS2_10ObjectTypeE9EEE: __ZN18GfxFramebufferGLES24UpdateDefaultFramebufferEP17RenderSurfaceBaseS1_N2gl6HandleILNS2_10ObjectTypeE9EEE, __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorStateInfoInternalv: __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorStateInfoInternalv, __ZNK6Camera16GetCullingMatrixEv: __ZNK6Camera16GetCullingMatrixEv, __Z29AddIntegerCurveToStreamedClipP19StreamedClipBuilderiPfPii: __Z29AddIntegerCurveToStreamedClipP19StreamedClipBuilderiPfPii, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7getNameEv, __ZNK11Rigidbody2D8GetPointERK8Vector2f: __ZNK11Rigidbody2D8GetPointERK8Vector2f, __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_IsSleepingv: __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_IsSleepingv, __ZN10Effector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10Effector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN19AssetBundleManifest23VirtualRedirectTransferER14SafeBinaryRead: __ZN19AssetBundleManifest23VirtualRedirectTransferER14SafeBinaryRead, __ZN5Unity12PhysicsQuery22OverlapCapsuleNonAllocERK8Vector3fS3_fPP8Colliderii23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery22OverlapCapsuleNonAllocERK8Vector3fS3_fPP8Colliderii23QueryTriggerInteraction, __ZL60CombineDirectionalShadowCasterCullignIndexListsAndDestroyJobP20ShadowCullingJobData: __ZL60CombineDirectionalShadowCasterCullignIndexListsAndDestroyJobP20ShadowCullingJobData, __ZN19LowerResBlitTexture19UnloadFromGfxDeviceEb: __ZN19LowerResBlitTexture19UnloadFromGfxDeviceEb, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags, __ZN30AudioEffectInternalDescriptionC2EP20FMOD_DSP_DESCRIPTION: __ZN30AudioEffectInternalDescriptionC2EP20FMOD_DSP_DESCRIPTION, __ZN16LightmapSettings5ResetEv: __ZN16LightmapSettings5ResetEv, __ZN12FileAccessor4ReadEyPvPy: __ZN12FileAccessor4ReadEyPvPy, __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED2Ev: __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED2Ev, __Z42Register_UnityEngine_Event_get_commandNamev: __Z42Register_UnityEngine_Event_get_commandNamev, __Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z12AddComponentR10GameObjectPKcPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj590ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj590ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z12IsFirstFramev: __Z12IsFirstFramev, __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetRemoveStartOffsetv: __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetRemoveStartOffsetv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE13isSubordinateEv, __ZNK5physx2Sn21SerializationRegistry17getSerializerNameEj: __ZNK5physx2Sn21SerializationRegistry17getSerializerNameEj, __ZN18PlatformEffector2DC2E10MemLabelId18ObjectCreationMode: __ZN18PlatformEffector2DC2E10MemLabelId18ObjectCreationMode, __ZNK15FileSystemEntry6ExistsEv: __ZNK15FileSystemEntry6ExistsEv, __Z29StdTemplateConversionFunctionIsjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsjEbPvR14SafeBinaryRead, __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f: __ZNK9Transform21GetLocalToWorldMatrixER10Matrix4x4f, __Z52Register_UnityEngine_AnimationCurve_set_postWrapModev: __Z52Register_UnityEngine_AnimationCurve_set_postWrapModev, __Z62ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeMultiplierP12Il2CppObject: __Z62ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeMultiplierP12Il2CppObject, __ZZL16BuildDetailHullsRNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEERK13dynamic_arrayI5PlaneLj4EERK10MinMaxAABBRK10DetailMeshPK10dtMeshTileEN12ClipCallback7processESI_RK14DetailMeshPolyPKii: __ZZL16BuildDetailHullsRNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEERK13dynamic_arrayI5PlaneLj4EERK10MinMaxAABBRK10DetailMeshPK10dtMeshTileEN12ClipCallback7processESI_RK14DetailMeshPolyPKii, __ZN5physx2Gu10ConvexMesh4loadERNS_13PxInputStreamE: __ZN5physx2Gu10ConvexMesh4loadERNS_13PxInputStreamE, __ZNK5physx5cloth8SwFabric13getNumIndicesEv: __ZNK5physx5cloth8SwFabric13getNumIndicesEv, __Z45getPxVehicleWheels4SimData_TireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE: __Z45getPxVehicleWheels4SimData_TireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE, __ZNKSt3__217moneypunct_bynameIwLb0EE11do_groupingEv: __ZNKSt3__217moneypunct_bynameIwLb0EE11do_groupingEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKwj, __ZNK5Umbra18ImpOcclusionBuffer13isAABBVisibleERKNS_7Vector3ES3_Pf: __ZNK5Umbra18ImpOcclusionBuffer13isAABBVisibleERKNS_7Vector3ES3_Pf, __Z13RegisterClassI15UnityAdsManagerEvv: __Z13RegisterClassI15UnityAdsManagerEvv, __Z27profiler_change_persistancyibb: __Z27profiler_change_persistancyibb, __ZN13AudioListener23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13AudioListener23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__25stoulERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji: __ZNSt3__25stoulERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE15growAndPushBackERKS2_, __ZN13GfxDeviceGLES11CopyTextureE9TextureIDS0_: __ZN13GfxDeviceGLES11CopyTextureE9TextureIDS0_, __ZNK11AudioSource7GetLoopEv: __ZNK11AudioSource7GetLoopEv, __Z43RectTransform_Get_Custom_PropDrivenByObjectP12Il2CppObject: __Z43RectTransform_Get_Custom_PropDrivenByObjectP12Il2CppObject, __ZN9Animation9CrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfi: __ZN9Animation9CrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfi, __Z72Register_UnityEngine_AssetBundleCreateRequest_DisableCompatibilityChecksv: __Z72Register_UnityEngine_AssetBundleCreateRequest_DisableCompatibilityChecksv, __Z44Register_UnityEngine_ReflectionProbe_get_hdrv: __Z44Register_UnityEngine_ReflectionProbe_get_hdrv, __Z52Register_UnityEngine_ReflectionProbe_get_cullingMaskv: __Z52Register_UnityEngine_ReflectionProbe_get_cullingMaskv, __ZN6Motion17MainThreadCleanupEv: __ZN6Motion17MainThreadCleanupEv, __Z29getNbPxPhysics_TriangleMeshesPKN5physx9PxPhysicsE: __Z29getNbPxPhysics_TriangleMeshesPKN5physx9PxPhysicsE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIhNS1_9allocatorIhEEEEEEvRT_17TransferMetaFlags, __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi: __ZN9Scripting34GetScriptingArrayStringElementImplEP11Il2CppArrayi, __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadedBytesv: __Z65Register_UnityEngine_Networking_UnityWebRequest_get_uploadedBytesv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN8Animator13StopRecordingEv: __ZN8Animator13StopRecordingEv, __ZN16Physics2DManager20IsRigidBodyKinematicERK11Rigidbody2D: __ZN16Physics2DManager20IsRigidBodyKinematicERK11Rigidbody2D, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z35setPxVehicleClutchDataMAccuracyModePN5physx19PxVehicleClutchDataENS_27PxVehicleClutchAccuracyMode4EnumE: __Z35setPxVehicleClutchDataMAccuracyModePN5physx19PxVehicleClutchDataENS_27PxVehicleClutchAccuracyMode4EnumE, _realize_virt_arrays: _realize_virt_arrays, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj592ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj592ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_S5_T_, _tt_size_select: _tt_size_select, __ZN19CollisionListener2D10EndContactEP9b2Contact: __ZN19CollisionListener2D10EndContactEP9b2Contact, __Z45CharacterController_Get_Custom_PropIsGroundedP12Il2CppObject: __Z45CharacterController_Get_Custom_PropIsGroundedP12Il2CppObject, __ZN11UnityEngine15CloudWebService17SessionEventQueue15RestoreFromFileER12FileAccessorPvy: __ZN11UnityEngine15CloudWebService17SessionEventQueue15RestoreFromFileER12FileAccessorPvy, __ZThn4_NK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv: __ZThn4_NK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv, __Z59Register_UnityEngine_SystemInfo_get_supportsRenderToCubemapv: __Z59Register_UnityEngine_SystemInfo_get_supportsRenderToCubemapv, ___cxx_global_var_init4: ___cxx_global_var_init4, __ZN14PlayerSettingsD2Ev: __ZN14PlayerSettingsD2Ev, __ZN15MulticastSocket7SetLoopEb: __ZN15MulticastSocket7SetLoopEb, __ZN19CharacterController9GetBoundsEv: __ZN19CharacterController9GetBoundsEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags, __Z64Register_UnityEngine_AI_NavMeshObstacle_get_carvingMoveThresholdv: __Z64Register_UnityEngine_AI_NavMeshObstacle_get_carvingMoveThresholdv, __ZN14PhysicsManager17SetSleepThresholdEf: __ZN14PhysicsManager17SetSleepThresholdEf, __Z47ConstantForce_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP8Vector3f: __Z47ConstantForce_CUSTOM_INTERNAL_get_relativeForceP12Il2CppObjectP8Vector3f, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED0Ev: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED0Ev, __Z56ParticleSystem_MainModule_CUSTOM_SetStartSpeedMultiplierP12Il2CppObjectf: __Z56ParticleSystem_MainModule_CUSTOM_SetStartSpeedMultiplierP12Il2CppObjectf, __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyPositionInternalP12Il2CppObjectRK8Vector3f: __Z53Animator_CUSTOM_INTERNAL_CALL_SetBodyPositionInternalP12Il2CppObjectRK8Vector3f, __Z39Rigidbody2D_Set_Custom_PropGravityScaleP12Il2CppObjectf: __Z39Rigidbody2D_Set_Custom_PropGravityScaleP12Il2CppObjectf, __ZN16RayRTreeCallbackILi1ELb1EED0Ev: __ZN16RayRTreeCallbackILi1ELb1EED0Ev, __ZN13ComputeShader23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13ComputeShader23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL18PxcContactHullHullRKN5physx2Gu13PolygonalDataES3_RKNS_9PxBounds3ES6_RKNS_11PxTransformES9_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESF_bb: __ZL18PxcContactHullHullRKN5physx2Gu13PolygonalDataES3_RKNS_9PxBounds3ES6_RKNS_11PxTransformES9_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESF_bb, __Z73Register_UnityEngine_Camera_INTERNAL_CALL_CalculateFrustumCornersInternalv: __Z73Register_UnityEngine_Camera_INTERNAL_CALL_CalculateFrustumCornersInternalv, __Z46getPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataEj: __Z46getPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataEj, __ZNK5physx2Sc16ArticulationCore17getCacheLinkCountERKNS_9PxcFsDataE: __ZNK5physx2Sc16ArticulationCore17getCacheLinkCountERKNS_9PxcFsDataE, __ZN5simdi8anyEqualERK8Scalar4fS2_RS0_: __ZN5simdi8anyEqualERK8Scalar4fS2_RS0_, __Z29getPxCloth_DampingCoefficientPKN5physx7PxClothE: __Z29getPxCloth_DampingCoefficientPKN5physx7PxClothE, __Z38ParticleSystem_CUSTOM_Internal_IsAliveP12Il2CppObject: __Z38ParticleSystem_CUSTOM_Internal_IsAliveP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDBodyENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNK5physx35PxJointLinearLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j: __ZNK5physx35PxJointLinearLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j, __Z47TerrainData_CUSTOM_INTERNAL_get_wavingGrassTintP12Il2CppObjectP10ColorRGBAf: __Z47TerrainData_CUSTOM_INTERNAL_get_wavingGrassTintP12Il2CppObjectP10ColorRGBAf, __ZN9AudioClip16EnableLegacyModeEv: __ZN9AudioClip16EnableLegacyModeEv, __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv: __ZNK13Simd4fFactoryIPKfEcv8Scalar4fEv, __Z52Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTryv: __Z52Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTryv, _mkdir: _mkdir, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv, __Z51Register_UnityEngine_Rigidbody2D_get_freezeRotationv: __Z51Register_UnityEngine_Rigidbody2D_get_freezeRotationv, __Z50Register_UnityEngine_Cloth_set_stretchingStiffnessv: __Z50Register_UnityEngine_Cloth_set_stretchingStiffnessv, __ZN5physx9NpPhysics17getVisualDebuggerEv: __ZN5physx9NpPhysics17getVisualDebuggerEv, __Z41Physics_Set_Custom_PropMaxAngularVelocityf: __Z41Physics_Set_Custom_PropMaxAngularVelocityf, __Z33SpringJoint_Set_Custom_PropDamperP12Il2CppObjectf: __Z33SpringJoint_Set_Custom_PropDamperP12Il2CppObjectf, __Z20CreateObjectFromCodeI23ShaderVariantCollectionEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI23ShaderVariantCollectionEPT_17AwakeFromLoadMode10MemLabelId, __ZN5physx2Sn13XmlWriterImplD2Ev: __ZN5physx2Sn13XmlWriterImplD2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags, __ZN7ApiGLES16BindMemoryBufferEjN2gl12BufferTargetE: __ZN7ApiGLES16BindMemoryBufferEjN2gl12BufferTargetE, _ps_hints_close: _ps_hints_close, __Z16CreateRenderLoopR6Camera: __Z16CreateRenderLoopR6Camera, __ZN5physx20PxcNpCacheStreamPairC2ERNS_17PxcNpMemBlockPoolE: __ZN5physx20PxcNpCacheStreamPairC2ERNS_17PxcNpMemBlockPoolE, __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapYMultiplierP12Il2CppObjectf: __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapYMultiplierP12Il2CppObjectf, _tlsf_create: _tlsf_create, __Z45Register_UnityEngine_Animator_PlayInFixedTimev: __Z45Register_UnityEngine_Animator_PlayInFixedTimev, __Z31NavMeshAgent_CUSTOM_GetAreaCostP12Il2CppObjecti: __Z31NavMeshAgent_CUSTOM_GetAreaCostP12Il2CppObjecti, __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN9ShaderLab20SerializedSubProgramC2ERKS0_: __ZN9ShaderLab20SerializedSubProgramC2ERKS0_, __ZN9Texture3D17UploadToGfxDeviceEv: __ZN9Texture3D17UploadToGfxDeviceEv, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, _cargl: _cargl, __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE24ExtractResponseEtagValueEv: __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE24ExtractResponseEtagValueEv, __ZN4FMOD4DSPI16getParameterInfoEiPcS1_S1_iPfS2_: __ZN4FMOD4DSPI16getParameterInfoEiPcS1_S1_iPfS2_, __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi: __ZNK10__cxxabiv121__vmi_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi, _trunc: _trunc, __Z63Register_UnityEngine_CharacterJoint_INTERNAL_set_highTwistLimitv: __Z63Register_UnityEngine_CharacterJoint_INTERNAL_set_highTwistLimitv, __ZL28GeomOverlapCallback_MeshMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL28GeomOverlapCallback_MeshMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN17MemoryCacheWriter14LockCacheBlockEjPPhS1_: __ZN17MemoryCacheWriter14LockCacheBlockEjPPhS1_, __Z30getPxSceneDescFilterShaderDataPKN5physx11PxSceneDescE: __Z30getPxSceneDescFilterShaderDataPKN5physx11PxSceneDescE, __Z44Terrain_Get_Custom_PropTreeLODBiasMultiplierP12Il2CppObject: __Z44Terrain_Get_Custom_PropTreeLODBiasMultiplierP12Il2CppObject, __ZN15ParticleEmitter24UpdateAllParticleSystemsEv: __ZN15ParticleEmitter24UpdateAllParticleSystemsEv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE19getConcreteTypeNameEv, __Z22Animator_CUSTOM_RebindP12Il2CppObject: __Z22Animator_CUSTOM_RebindP12Il2CppObject, __ZN16ParticleRenderer19SetUVAnimationXTileEi: __ZN16ParticleRenderer19SetUVAnimationXTileEi, __ZN5physx2Gu11HeightField13modifySamplesEiiRKNS_17PxHeightFieldDescEb: __ZN5physx2Gu11HeightField13modifySamplesEiiRKNS_17PxHeightFieldDescEb, __Z41AudioEchoFilter_Get_Custom_PropDecayRatioP12Il2CppObject: __Z41AudioEchoFilter_Get_Custom_PropDecayRatioP12Il2CppObject, __ZN5physx12NpConstraint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx12NpConstraint17getBinaryMetaDataERNS_14PxOutputStreamE, __Z43Register_UnityEngine_Light_AddCommandBufferv: __Z43Register_UnityEngine_Light_AddCommandBufferv, __Z54Register_UnityEngine_SystemInfo_get_supportsInstancingv: __Z54Register_UnityEngine_SystemInfo_get_supportsInstancingv, __ZN5physx7Cooking16platformMismatchEv: __ZN5physx7Cooking16platformMismatchEv, __ZN13ModuleManager15AddInitCallbackEPFvRS_E: __ZN13ModuleManager15AddInitCallbackEPFvRS_E, __ZN5physx2Sn17readAllPropertiesINS_7PxShapeEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_7PxShapeEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEED0Ev, _jpeg_idct_islow: _jpeg_idct_islow, __Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses: __Z19ShouldTransferFieldR32SerializationCommandQueueBuilderP11Il2CppClassiR18TransferField_InfoRK20CoreScriptingClasses, __ZN5Light17MainThreadCleanupEv: __ZN5Light17MainThreadCleanupEv, __ZN14FileCacherRead12GetCacheSizeEv: __ZN14FileCacherRead12GetCacheSizeEv, __ZNK18MultiPointTraverse12filterPointsERKN5Umbra14KDTraverseNodeIjEEj: __ZNK18MultiPointTraverse12filterPointsERKN5Umbra14KDTraverseNodeIjEEj, __ZN5physx2Gu11HeightField4loadERNS_13PxInputStreamE: __ZN5physx2Gu11HeightField4loadERNS_13PxInputStreamE, __Z56TerrainData_CUSTOM_Internal_GetMinimumAlphamapResolutionv: __Z56TerrainData_CUSTOM_Internal_GetMinimumAlphamapResolutionv, __ZN5physx28solveParallelCouloumFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj: __ZN5physx28solveParallelCouloumFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj, __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE6resizeEjRKh: __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE6resizeEjRKh, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE13isSubordinateEv, __ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE: __ZN8Material8GetFloatEN9ShaderLab16FastPropertyNameE, __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb, _psnames_module_class_pic_free: _psnames_module_class_pic_free, __ZNK9Rigidbody16GetSleepVelocityEv: __ZNK9Rigidbody16GetSleepVelocityEv, __ZNK5physx3Ext14SphericalJoint12getLimitConeEv: __ZNK5physx3Ext14SphericalJoint12getLimitConeEv, __ZNK5physx5cloth21IterationStateFactory6createI8Scalar4fNS0_7SwClothEEENS0_14IterationStateIT_EERKT0_: __ZNK5physx5cloth21IterationStateFactory6createI8Scalar4fNS0_7SwClothEEENS0_14IterationStateIT_EERKT0_, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc8BodyCoreD2Ev: __ZN5physx2Sc8BodyCoreD2Ev, __ZN17SurfaceEffector2D12SetUseBounceEb: __ZN17SurfaceEffector2D12SetUseBounceEb, __ZN4FMOD8ChannelI18set3DCustomRolloffEP11FMOD_VECTORi: __ZN4FMOD8ChannelI18set3DCustomRolloffEP11FMOD_VECTORi, __ZNSt3__214collate_bynameIwEC2EPKcj: __ZNSt3__214collate_bynameIwEC2EPKcj, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getExternalAccelerationEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getExternalAccelerationEv, __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI10ColorRGBAfE8TransferI14SafeBinaryReadEEvRS0_RT_, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXv, __ZN12AudioManager18BeforeDomainUnloadEv: __ZN12AudioManager18BeforeDomainUnloadEv, __ZN5physx15PxCollectionExt14releaseObjectsERNS_12PxCollectionE: __ZN5physx15PxCollectionExt14releaseObjectsERNS_12PxCollectionE, __Z54SkinnedMeshRenderer_Get_Custom_PropUpdateWhenOffscreenP12Il2CppObject: __Z54SkinnedMeshRenderer_Get_Custom_PropUpdateWhenOffscreenP12Il2CppObject, __ZN15ReflectionProbeD2Ev: __ZN15ReflectionProbeD2Ev, __Z26setPxCapsuleGeometryRadiusPN5physx17PxCapsuleGeometryEf: __Z26setPxCapsuleGeometryRadiusPN5physx17PxCapsuleGeometryEf, __ZN7dtCrowd11AddObstacleER13dtCrowdHandle: __ZN7dtCrowd11AddObstacleER13dtCrowdHandle, __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi: __ZN9Scripting39GetScriptingArrayStringElementNoRefImplEP11Il2CppArrayi, __ZN10GameObject17GetComponentIndexEPN5Unity9ComponentE: __ZN10GameObject17GetComponentIndexEPN5Unity9ComponentE, __ZN5physx7NpCloth20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE: __ZN5physx7NpCloth20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE, __Z39Texture2D_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf: __Z39Texture2D_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE8setstateEj: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE8setstateEj, __ZNK13TextRendering4Font11GetMaterialEv: __ZNK13TextRendering4Font11GetMaterialEv, __Z19InitFloatExceptionsv: __Z19InitFloatExceptionsv, __Z51Register_UnityEngine_AreaEffector2D_set_angularDragv: __Z51Register_UnityEngine_AreaEffector2D_set_angularDragv, __ZN8LODGroup10SmartResetEv: __ZN8LODGroup10SmartResetEv, __Z52QualitySettings_Set_Custom_PropParticleRaycastBudgeti: __Z52QualitySettings_Set_Custom_PropParticleRaycastBudgeti, _UNITY_tt_face_vary_cvt: _UNITY_tt_face_vary_cvt, __ZN5physx16PxVehicleDrive4W12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx16PxVehicleDrive4W12createObjectERPhRNS_24PxDeserializationContextE, __Z47Register_UnityEngine_AndroidJNI_FromObjectArrayv: __Z47Register_UnityEngine_AndroidJNI_FromObjectArrayv, __Z39Animator_Set_Custom_PropApplyRootMotionP12Il2CppObjecth: __Z39Animator_Set_Custom_PropApplyRootMotionP12Il2CppObjecth, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputnEPKwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sputnEPKwi, __GLOBAL__sub_I_runtime_mono_serializationbackend_directmemoryaccess_lump_cpp: __GLOBAL__sub_I_runtime_mono_serializationbackend_directmemoryaccess_lump_cpp, __ZNK6Camera27GetImplicitProjectionMatrixEfR10Matrix4x4f: __ZNK6Camera27GetImplicitProjectionMatrixEfR10Matrix4x4f, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE13isSubordinateEv, __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ERKS5_: __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ERKS5_, __ZN11GPUProfiler19IsCollectingSamplesEv: __ZN11GPUProfiler19IsCollectingSamplesEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags, __ZNK5physx2Sc15ClothFabricCore9getPhasesEPNS_18PxClothFabricPhaseEj: __ZNK5physx2Sc15ClothFabricCore9getPhasesEPNS_18PxClothFabricPhaseEj, __Z44Debug_Get_Custom_PropDeveloperConsoleVisiblev: __Z44Debug_Get_Custom_PropDeveloperConsoleVisiblev, __ZN35RegisterRuntimeInitializeAndCleanup22ExecuteInitializationsEv: __ZN35RegisterRuntimeInitializeAndCleanup22ExecuteInitializationsEv, __Z14b2TimeOfImpactP11b2TOIOutputPK10b2TOIInput: __Z14b2TimeOfImpactP11b2TOIOutputPK10b2TOIInput, _default_walker: _default_walker, __Z52WebCamTexture_Get_Custom_PropVideoVerticallyMirroredP12Il2CppObject: __Z52WebCamTexture_Get_Custom_PropVideoVerticallyMirroredP12Il2CppObject, __Z24EncodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24EncodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE8recreateEj, __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI9RigidbodyE8TransferI14SafeBinaryReadEEvRT_, __ZN23PreloadManagerOperation14SetFinalTimingEffff: __ZN23PreloadManagerOperation14SetFinalTimingEffff, __ZN13UnityProfiler17ReturnFrameToPoolEP17ProfilerFrameData: __ZN13UnityProfiler17ReturnFrameToPoolEP17ProfilerFrameData, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead18SubstanceInputTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead18SubstanceInputTypeEvRT_RT0_PKc17TransferMetaFlags, __ZN15NavMeshObstacle17SnapshotTransformEv: __ZN15NavMeshObstacle17SnapshotTransformEv, __ZN14SerializedFile4Type21CompareAgainstNewTypeEP8TypeTree: __ZN14SerializedFile4Type21CompareAgainstNewTypeEP8TypeTree, __ZN11Rigidbody2D10SetInertiaEf: __ZN11Rigidbody2D10SetInertiaEf, __Z11CopyTextureP7TextureiiS0_ii: __Z11CopyTextureP7TextureiiS0_ii, __ZN13BuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13BuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, _ft_outline_glyph_transform: _ft_outline_glyph_transform, __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMSphereVsHeightfieldContactGenerationCallbackEE7onEventEjPj: __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMSphereVsHeightfieldContactGenerationCallbackEE7onEventEjPj, __ZN10GameObject15InitializeClassEv: __ZN10GameObject15InitializeClassEv, __Z16computeAABBNoCCDRKN5physx18PxcAABBDataDynamicERKNS_20PxsComputeAABBParamsE: __Z16computeAABBNoCCDRKN5physx18PxcAABBDataDynamicERKNS_20PxsComputeAABBParamsE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayIP13AnimationClipLj4EERNS1_6memory9AllocatorE: __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayIP13AnimationClipLj4EERNS1_6memory9AllocatorE, __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE: __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE, __Z38Renderer_Get_Custom_PropSortingLayerIDP12Il2CppObject: __Z38Renderer_Get_Custom_PropSortingLayerIDP12Il2CppObject, __ZN5physx17PxsThresholdTable5buildERKNS_18PxsThresholdStreamE: __ZN5physx17PxsThresholdTable5buildERKNS_18PxsThresholdStreamE, __ZN5physx8debugger15ForwardingArrayIcED0Ev: __ZN5physx8debugger15ForwardingArrayIcED0Ev, __Z50Register_UnityEngine_Animator_get_recorderStopTimev: __Z50Register_UnityEngine_Animator_get_recorderStopTimev, __ZN5physx2Sc21ArticulationJointCore13setSwingLimitEff: __ZN5physx2Sc21ArticulationJointCore13setSwingLimitEff, __ZNKSt3__214__codecvt_utf8IwE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__214__codecvt_utf8IwE9do_lengthER11__mbstate_tPKcS5_j, __ZN8VRDevice21UpdateCameraTransformERK6Camera: __ZN8VRDevice21UpdateCameraTransformERK6Camera, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK14DLHAudioHelper6IsDoneEv: __ZNK14DLHAudioHelper6IsDoneEv, __Z75Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeCollisionEventSizev: __Z75Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeCollisionEventSizev, __ZN13AnimationClip10FloatCurveC2ERKS0_: __ZN13AnimationClip10FloatCurveC2ERKS0_, __Z47Register_UnityEngine_AndroidJNI_CallFloatMethodv: __Z47Register_UnityEngine_AndroidJNI_CallFloatMethodv, __ZN9BoxPruner12updateObjectERK5IAABBt: __ZN9BoxPruner12updateObjectERK5IAABBt, __ZN5physx2Sc10NPhaseCore32createActorPairContactReportDataEv: __ZN5physx2Sc10NPhaseCore32createActorPairContactReportDataEv, __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi: __ZN10TagManager31GetSortingLayerNameFromUniqueIDEi, __ZN5physx2Gu22pcmContactPlaneCapsuleERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu22pcmContactPlaneCapsuleERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNK10__cxxabiv117__array_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv117__array_type_info9can_catchEPKNS_16__shim_type_infoERPv, __ZN15RelativeJoint2D22SetAutoConfigureOffsetEb: __ZN15RelativeJoint2D22SetAutoConfigureOffsetEb, __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_: __ZN16LevelGameManager8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__210moneypunctIcLb0EE16do_positive_signEv: __ZNKSt3__210moneypunctIcLb0EE16do_positive_signEv, __ZN29UnityWebRequestAsyncOperationC2EP15UnityWebRequest: __ZN29UnityWebRequestAsyncOperationC2EP15UnityWebRequest, __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_126parse_base_unresolved_nameINS0_2DbEEEPKcS4_S4_RT_, __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E: __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E, __Z44Register_UnityEngine_CanvasRenderer_SetAlphav: __Z44Register_UnityEngine_CanvasRenderer_SetAlphav, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEvPT_jRKT0_RKT1_j, __ZN7mecanim5human12HumanPoseAddERNS0_9HumanPoseERKS1_S4_: __ZN7mecanim5human12HumanPoseAddERNS0_9HumanPoseERKS1_S4_, __Z52Register_UnityEngine_AudioReverbZone_set_maxDistancev: __Z52Register_UnityEngine_AudioReverbZone_set_maxDistancev, __ZN5physx21PxcArticulationHelper16prepareLtbMatrixERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEf: __ZN5physx21PxcArticulationHelper16prepareLtbMatrixERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKNS_11PxTransformEPKNS_30PxcArticulationJointTransformsEf, __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE: __ZNK5physx2Sn5ConvX16_enumerateFieldsEPKNS0_9MetaClassEPNS0_15ExtraDataEntry2ERiiNS0_12MetaDataTypeE, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN15ResourceManager10Dependency8TransferI14SafeBinaryReadEEvRT_: __ZN15ResourceManager10Dependency8TransferI14SafeBinaryReadEEvRT_, __ZN3WWWD2Ev: __ZN3WWWD2Ev, __ZNK5physx29BroadPhaseBatchUpdateWorkTask7getNameEv: __ZNK5physx29BroadPhaseBatchUpdateWorkTask7getNameEv, __Z40NavMeshAgent_Get_Custom_PropWalkableMaskP12Il2CppObject: __Z40NavMeshAgent_Get_Custom_PropWalkableMaskP12Il2CppObject, __ZNSt3__26vectorIPKN5Unity4TypeENS_9allocatorIS4_EEE8__appendEjRKS4_: __ZNSt3__26vectorIPKN5Unity4TypeENS_9allocatorIS4_EEE8__appendEjRKS4_, __ZNKSt3__25ctypeIcE10do_tolowerEc: __ZNKSt3__25ctypeIcE10do_tolowerEc, __ZN9BlobWrite24ValidateSerializedLayoutEPKvPKc: __ZN9BlobWrite24ValidateSerializedLayoutEPKvPKc, __ZN4FMOD6System9setDriverEi: __ZN4FMOD6System9setDriverEi, __Z75Register_UnityEngine_ParticleSystem_ShapeModule_SetSphericalDirectionAmountv: __Z75Register_UnityEngine_ParticleSystem_ShapeModule_SetSphericalDirectionAmountv, __ZNK9Transform11GetRotationEv: __ZNK9Transform11GetRotationEv, __ZN5Unity10HingeJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity10HingeJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN10__cxxabiv112_GLOBAL__N_123parse_prefix_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_: __ZN10__cxxabiv112_GLOBAL__N_123parse_prefix_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_, __ZN5physx25PxDefaultFileOutputStream7isValidEv: __ZN5physx25PxDefaultFileOutputStream7isValidEv, __Z36Register_UnityEngine_GameObject_Findv: __Z36Register_UnityEngine_GameObject_Findv, __ZN5physx2Sc5Scene26setVisualizationCullingBoxERKNS_9PxBounds3E: __ZN5physx2Sc5Scene26setVisualizationCullingBoxERKNS_9PxBounds3E, _pshinter_get_globals_funcs: _pshinter_get_globals_funcs, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYMultiplierv, __ZNKSt3__211__libcpp_db17__dereferenceableEPKv: __ZNKSt3__211__libcpp_db17__dereferenceableEPKv, __ZNSt3__219__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_: __ZNSt3__219__double_or_nothingIjEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_, __Z50Register_UnityEngine_CanvasRenderer_GetPopMaterialv: __Z50Register_UnityEngine_CanvasRenderer_GetPopMaterialv, __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb: __ZN5physx15PxVehicleWheels15patchupPointersEPS0_Phjjb, __ZN5physx10PxBaseTaskD2Ev: __ZN5physx10PxBaseTaskD2Ev, __Z60Register_UnityEngine_AsyncOperation_get_allowSceneActivationv: __Z60Register_UnityEngine_AsyncOperation_get_allowSceneActivationv, __Z19TreePrototypeToMonoRK13TreePrototypeR17MonoTreePrototype: __Z19TreePrototypeToMonoRK13TreePrototypeR17MonoTreePrototype, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv, __ZN7dtCrowd13ReserveAgentsEi: __ZN7dtCrowd13ReserveAgentsEi, __Z49Register_UnityEngine_Application_get_unityVersionv: __Z49Register_UnityEngine_Application_get_unityVersionv, __Z31GUIStyle_CUSTOM_GetFontInternalP12Il2CppObject: __Z31GUIStyle_CUSTOM_GetFontInternalP12Il2CppObject, __ZN14ParticleSystem23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14ParticleSystem23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _tt_cmap12_char_map_binary: _tt_cmap12_char_map_binary, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi24EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi24EEEEvRT_17TransferMetaFlags, __Z27GetMeshAssetPathDescriptivePK4Mesh: __Z27GetMeshAssetPathDescriptivePK4Mesh, __ZN12AudioManager19RemoveAudioListenerEP13AudioListener: __ZN12AudioManager19RemoveAudioListenerEP13AudioListener, __ZN17ProceduralTexture17TextureParameters8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17ProceduralTexture17TextureParameters8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sq16BucketPrunerCore20allocateSortedMemoryEj: __ZN5physx2Sq16BucketPrunerCore20allocateSortedMemoryEj, __ZN9Animation17RemoveFromManagerEv: __ZN9Animation17RemoveFromManagerEv, __Z40ParticleEmitter_Get_Custom_PropMaxEnergyP12Il2CppObject: __Z40ParticleEmitter_Get_Custom_PropMaxEnergyP12Il2CppObject, __ZNK22DownloadHandlerTexture8GetBytesEv: __ZNK22DownloadHandlerTexture8GetBytesEv, __ZN14AreaEffector2D5ResetEv: __ZN14AreaEffector2D5ResetEv, __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZNSt3__212strstreambufD2Ev: __ZNSt3__212strstreambufD2Ev, __Z43Register_UnityEngine_Gradient_get_alphaKeysv: __Z43Register_UnityEngine_Gradient_get_alphaKeysv, __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_: __ZNSt3__27__sort5IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_S7_T_, __Z13RegisterClassI7Joint2DEvv: __Z13RegisterClassI7Joint2DEvv, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEj, __ZN7Cubemap10FixupEdgesEi: __ZN7Cubemap10FixupEdgesEi, __Z39MaterialPropertyBlock_CUSTOM_SetTextureP12Il2CppObjectiS0_: __Z39MaterialPropertyBlock_CUSTOM_SetTextureP12Il2CppObjectiS0_, __ZN11UnityEngine9Animation14GenericBinding8TransferI14SafeBinaryReadEEvRT_: __ZN11UnityEngine9Animation14GenericBinding8TransferI14SafeBinaryReadEEvRT_, __ZN16Physics2DManagerD0Ev: __ZN16Physics2DManagerD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj66ENS_22PxRepXPropertyAccessorILj66ES4_NS_28PxArticulationJointDriveType4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj66ENS_22PxRepXPropertyAccessorILj66ES4_NS_28PxArticulationJointDriveType4EnumESA_EEEEvRKT0_, __ZNK5physx14SingleAABBTask7getNameEv: __ZNK5physx14SingleAABBTask7getNameEv, __Z26GL_CUSTOM_IssuePluginEventi: __Z26GL_CUSTOM_IssuePluginEventi, __ZN11AudioSource7SetMuteEb: __ZN11AudioSource7SetMuteEb, __ZNK8VRDevice18SetCompositorLayerEP7TextureRK8Vector3fS4_: __ZNK8VRDevice18SetCompositorLayerEP7TextureRK8Vector3fS4_, __ZN13WheelCollider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13WheelCollider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif: __ZN5physx11HullLibrary11calchullgenEPNS_6float3Eiif, __ZNK5physx7NpScene13getAggregatesEPPNS_11PxAggregateEjj: __ZNK5physx7NpScene13getAggregatesEPPNS_11PxAggregateEjj, __Z11EvalSHBasisPKfPd: __Z11EvalSHBasisPKfPd, __Z32LODGroup_Get_Custom_PropFadeModeP12Il2CppObject: __Z32LODGroup_Get_Custom_PropFadeModeP12Il2CppObject, __ZN9GfxDevice20TimerQueriesIsActiveEv: __ZN9GfxDevice20TimerQueriesIsActiveEv, __ZNK7Joint2D26GetTypeInfoVirtualInternalEv: __ZNK7Joint2D26GetTypeInfoVirtualInternalEv, __ZN17CollisionMeshData20VertexDataHasChangedEv: __ZN17CollisionMeshData20VertexDataHasChangedEv, __Z27GetScriptingBuiltinResourceP12Il2CppObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z27GetScriptingBuiltinResourceP12Il2CppObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZNK8VRDevice17GetShowDeviceViewEv: __ZNK8VRDevice17GetShowDeviceViewEv, __ZN13GfxDeviceGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_: __ZN13GfxDeviceGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_, __Z11BeginJobSetR8JobFencei: __Z11BeginJobSetR8JobFencei, __Z52Register_UnityEngine_GUIUtility_get_systemCopyBufferv: __Z52Register_UnityEngine_GUIUtility_get_systemCopyBufferv, __ZN8Animator17ValidateGoalIndexEi: __ZN8Animator17ValidateGoalIndexEi, __ZN16StreamedResource8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16StreamedResource8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z49Register_UnityEngine_Input_get_imeCompositionModev: __Z49Register_UnityEngine_Input_get_imeCompositionModev, __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE14setOwnerClientEh, __ZN5physx8debugger4comm17PushBackObjectRef9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm17PushBackObjectRef9serializeERNS1_15EventSerializerE, __ZN15LightProbeGroup7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15LightProbeGroup7PRODUCEE10MemLabelId18ObjectCreationMode, __Z18HermiteCooficientsdRdS_S_S_: __Z18HermiteCooficientsdRdS_S_S_, __ZNK20OcclusionCullingData22GetStaticRendererCountEv: __ZNK20OcclusionCullingData22GetStaticRendererCountEv, __Z70Register_UnityEngine_RaycastHit_INTERNAL_CALL_CalculateRaycastTexCoordv: __Z70Register_UnityEngine_RaycastHit_INTERNAL_CALL_CalculateRaycastTexCoordv, __ZNK6Camera17GetSkyboxMaterialEv: __ZNK6Camera17GetSkyboxMaterialEv, __ZN17CapsuleCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17CapsuleCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine9AnimationL24GenerateComponentBindingEiP12Il2CppObjectP11Il2CppClassP6Object: __ZN11UnityEngine9AnimationL24GenerateComponentBindingEiP12Il2CppObjectP11Il2CppClassP6Object, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12HandlerChain13ClearHandlersEv: __ZN12HandlerChain13ClearHandlersEv, __Z30AudioClip_CUSTOM_LoadAudioDataP12Il2CppObject: __Z30AudioClip_CUSTOM_LoadAudioDataP12Il2CppObject, __ZN10AudioMixer10ClearFloatEPKc: __ZN10AudioMixer10ClearFloatEPKc, __ZN9Transform15ThreadedCleanupEv: __ZN9Transform15ThreadedCleanupEv, __ZN8Animator17GetAvatarPositionEv: __ZN8Animator17GetAvatarPositionEv, __ZZ29InitializeTextRenderingModulevEN16cleanupAfterLoad7ForwardEv: __ZZ29InitializeTextRenderingModulevEN16cleanupAfterLoad7ForwardEv, __Z40WheelCollider_Set_Custom_PropBrakeTorqueP12Il2CppObjectf: __Z40WheelCollider_Set_Custom_PropBrakeTorqueP12Il2CppObjectf, __ZN10OnGUIState28SetNameOfNextKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN10OnGUIState28SetNameOfNextKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z45Register_UnityEngine_TextMesh_set_lineSpacingv: __Z45Register_UnityEngine_TextMesh_set_lineSpacingv, __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_: __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_, __ZN5physx19PxsFluidSpatialHash16updatePacketHashERjPjPNS_16PxsFluidParticleERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjPNS_10PxBaseTaskE: __ZN5physx19PxsFluidSpatialHash16updatePacketHashERjPjPNS_16PxsFluidParticleERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjPNS_10PxBaseTaskE, __ZN12MeshRenderer18CalculateLocalAABBER4AABBRKS_RK4Mesh: __ZN12MeshRenderer18CalculateLocalAABBER4AABBRKS_RK4Mesh, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_RKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_RKS4_, __ZNKSt3__212ctype_bynameIwE5do_isEPKwS3_Pt: __ZNKSt3__212ctype_bynameIwE5do_isEPKwS3_Pt, __Z45Register_UnityEngine_PointEffector2D_get_dragv: __Z45Register_UnityEngine_PointEffector2D_get_dragv, __Z18SetITerrainManagerP15ITerrainManager: __Z18SetITerrainManagerP15ITerrainManager, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE8AllocateEji: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE8AllocateEji, __ZN15b2CircleContactD0Ev: __ZN15b2CircleContactD0Ev, __Z51Rigidbody_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_: __Z51Rigidbody_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_, _inet_lnaof: _inet_lnaof, __ZN5physx23PxcContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx23PxcContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZL28InitializeUIScriptingClassesv: __ZL28InitializeUIScriptingClassesv, __Z27GetPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj: __Z27GetPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj, __Z43AssetBundleRequest_Get_Custom_PropAllAssetsP12Il2CppObject: __Z43AssetBundleRequest_Get_Custom_PropAllAssetsP12Il2CppObject, __ZN5physx2Cm17FreeListAllocator10deallocateEPv: __ZN5physx2Cm17FreeListAllocator10deallocateEPv, __ZN27AnimatorControllerParameter13SetDefaultIntEi: __ZN27AnimatorControllerParameter13SetDefaultIntEi, __ZN10GameObject27SetComponentAtIndexInternalE4PPtrIN5Unity9ComponentEEi: __ZN10GameObject27SetComponentAtIndexInternalE4PPtrIN5Unity9ComponentEEi, __ZN13MonoBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13MonoBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN10UnityScene10ClearRootsEv: __ZN10UnityScene10ClearRootsEv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv, __ZN14PhysicMaterial8LoadDescERNS_18PhysicMaterialDescE: __ZN14PhysicMaterial8LoadDescERNS_18PhysicMaterialDescE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE8pushNameEPKc, __Z34setPxScene_BounceThresholdVelocityPN5physx7PxSceneEf: __Z34setPxScene_BounceThresholdVelocityPN5physx7PxSceneEf, __ZN4FMOD8ChannelI11get3DSpreadEPf: __ZN4FMOD8ChannelI11get3DSpreadEPf, _l64a: _l64a, __Z45AudioSource_Get_Custom_PropVelocityUpdateModeP12Il2CppObject: __Z45AudioSource_Get_Custom_PropVelocityUpdateModeP12Il2CppObject, __Z20CreateObjectFromCodeI13RenderTextureEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI13RenderTextureEPT_17AwakeFromLoadMode10MemLabelId, __Z43Register_UnityEngine_AndroidJNI_SetIntFieldv: __Z43Register_UnityEngine_AndroidJNI_SetIntFieldv, __Z50Register_UnityEngine_BoxCollider_INTERNAL_set_sizev: __Z50Register_UnityEngine_BoxCollider_INTERNAL_set_sizev, __ZN20SpeedTreeWindManager6UpdateEf: __ZN20SpeedTreeWindManager6UpdateEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN9GfxDevice19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace: __ZN9GfxDevice19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace, __ZN5physx2Gu26checkOverlapOBB_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu26checkOverlapOBB_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, _symlinkat: _symlinkat, __Z36Physics_Get_Custom_PropSleepVelocityv: __Z36Physics_Get_Custom_PropSleepVelocityv, __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalVectoriR8Vector4f: __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalVectoriR8Vector4f, __ZN7mecanim9animation20CreateAvatarConstantEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEES8_PNS_5human5HumanES3_iRKS6_RNS_6memory9AllocatorE: __ZN7mecanim9animation20CreateAvatarConstantEPNS_8skeleton8SkeletonEPNS1_13SkeletonPoseTIN4math4trsXEEES8_PNS_5human5HumanES3_iRKS6_RNS_6memory9AllocatorE, __ZNKSt3__25ctypeIcE8do_widenEc: __ZNKSt3__25ctypeIcE8do_widenEc, __Z24RegisterStrippedTypeInfoI4TreeEviPKcS2_: __Z24RegisterStrippedTypeInfoI4TreeEviPKcS2_, __Z42getPxScene_ClothInterCollisionNbIterationsPKN5physx7PxSceneE: __Z42getPxScene_ClothInterCollisionNbIterationsPKN5physx7PxSceneE, __ZN5physx8debugger4comm21BeginSetPropertyValueD0Ev: __ZN5physx8debugger4comm21BeginSetPropertyValueD0Ev, __Z20RegisterModule_WebGLv: __Z20RegisterModule_WebGLv, __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE: __ZN5physx12NpConstraint8comShiftEPNS_12PxRigidActorE, __ZN14CompressedMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14CompressedMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEE15growAndPushBackERKS2_, __ZN5physx5cloth8SwSolver26setInterCollisionStiffnessEf: __ZN5physx5cloth8SwSolver26setInterCollisionStiffnessEf, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z58AssetBundleCreateRequest_CUSTOM_DisableCompatibilityChecksP12Il2CppObject: __Z58AssetBundleCreateRequest_CUSTOM_DisableCompatibilityChecksP12Il2CppObject, __Z56Register_UnityEngine_ParticleSystem_TrailModule_GetRatiov: __Z56Register_UnityEngine_ParticleSystem_TrailModule_GetRatiov, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE7destroyEPNS_11__tree_nodeISA_PvEE, __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj, __ZNK5physx2Gu10ConvexMesh14getIndexBufferEv: __ZNK5physx2Gu10ConvexMesh14getIndexBufferEv, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE, __ZN8Scalar4faSERKS_: __ZN8Scalar4faSERKS_, __Z54Register_UnityEngine_CharacterController_set_skinWidthv: __Z54Register_UnityEngine_CharacterController_set_skinWidthv, __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv: __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv, __Z27GUIText_Set_Custom_PropFontP12Il2CppObjectS0_: __Z27GUIText_Set_Custom_PropFontP12Il2CppObjectS0_, __ZN5physx2Sc8SimStats5clearEv: __ZN5physx2Sc8SimStats5clearEv, __Z25Camera_Set_Custom_PropHdrP12Il2CppObjecth: __Z25Camera_Set_Custom_PropHdrP12Il2CppObjecth, __Z30PlayerPrefs_CUSTOM_TrySetFloatP12Il2CppStringf: __Z30PlayerPrefs_CUSTOM_TrySetFloatP12Il2CppStringf, __ZNSt3__28ios_base5pwordEi: __ZNSt3__28ios_base5pwordEi, __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient: __ZL18ReadMinMaxGradientR18MonoMinMaxGradientRK14MinMaxGradient, _cacoshl: _cacoshl, __ZN5physx5cloth9SwFactoryD0Ev: __ZN5physx5cloth9SwFactoryD0Ev, __ZNK5physx2Gu12TriangleMesh12getTrianglesEv: __ZNK5physx2Gu12TriangleMesh12getTrianglesEv, __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI13ProbeSetIndexLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj544ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj544ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZThn4_NK5physx5cloth8SwFabric15getNumParticlesEv: __ZThn4_NK5physx5cloth8SwFabric15getNumParticlesEv, __Z34RegisterModuleClasses_UnityConnectv: __Z34RegisterModuleClasses_UnityConnectv, __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalBeginv: __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalBeginv, __ZN23TransformChangeDispatch12CleanupClassEv: __ZN23TransformChangeDispatch12CleanupClassEv, __ZNSt3__26vectorIN19UnityPluginRegistry6PluginENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19UnityPluginRegistry6PluginENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z37UnityWebRequest_CUSTOM_InternalCreateP12Il2CppObject: __Z37UnityWebRequest_CUSTOM_InternalCreateP12Il2CppObject, __Z15getPxJoint_NamePKN5physx7PxJointE: __Z15getPxJoint_NamePKN5physx7PxJointE, __ZN26IntersectAnyVsMeshCallbackILi2ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi2ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __Z48SurfaceEffector2D_Set_Custom_PropUseContactForceP12Il2CppObjecth: __Z48SurfaceEffector2D_Set_Custom_PropUseContactForceP12Il2CppObjecth, __ZN4crnd25static_huffman_data_model5clearEv: __ZN4crnd25static_huffman_data_model5clearEv, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl16getOrCreateClassERKN5physx8debugger14NamespacedNameE: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl16getOrCreateClassERKN5physx8debugger14NamespacedNameE, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEED0Ev, _gets: _gets, _getw: _getw, __ZN5physx2Sc24ElementInteractionMarker11updateStateEb: __ZN5physx2Sc24ElementInteractionMarker11updateStateEb, __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_: __ZN13dynamic_arrayI8Vector3fLj4EE9push_backERKS0_, __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN5physx25solveContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx25solveContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass: __ZN9Scripting30IsSystemCollectionsGenericListEP11Il2CppClass, _getc: _getc, __ZN15FileSystemEntry11HasFastHashER7Hash128: __ZN15FileSystemEntry11HasFastHashER7Hash128, __ZL16MouseMoveHandleriPK20EmscriptenMouseEventPv: __ZL16MouseMoveHandleriPK20EmscriptenMouseEventPv, __ZN11AudioSource15InitializeClassEv: __ZN11AudioSource15InitializeClassEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK8Renderer12GetTransformEv: __ZNK8Renderer12GetTransformEv, __Z39setPxClothStretchConfigCompressionLimitPN5physx20PxClothStretchConfigEf: __Z39setPxClothStretchConfigCompressionLimitPN5physx20PxClothStretchConfigEf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE12readPropertyIfEEbRT_, __ZN11HaloManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj: __ZN11HaloManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj, __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj647ENS_22PxRepXPropertyAccessorILj647ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj647ENS_22PxRepXPropertyAccessorILj647ES4_jjEEEEvjRKT0_, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__227__insertion_sort_incompleteIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEbT0_S8_T_, __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj: __ZN5physx16PxsFluidDynamics17adjustTempBuffersEj, __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j: __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEEEEEjT_j, __Z13RegisterClassI4TreeEvv: __Z13RegisterClassI4TreeEvv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcj, __Z47Register_UnityEngine_GUIClip_INTERNAL_CALL_Pushv: __Z47Register_UnityEngine_GUIClip_INTERNAL_CALL_Pushv, __ZN5physx2Sc5Scene11preAllocateEjjjjj: __ZN5physx2Sc5Scene11preAllocateEjjjjj, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveERS3_: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4moveERS3_, __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZMultiplierv, __Z28getPxTolerancesScale_IsValidPKN5physx17PxTolerancesScaleE: __Z28getPxTolerancesScale_IsValidPKN5physx17PxTolerancesScaleE, __ZN11UnityEngine15CloudWebService14DataDispatcher22ResetNetworkRetryIndexEv: __ZN11UnityEngine15CloudWebService14DataDispatcher22ResetNetworkRetryIndexEv, __ZN5Unity11SpringJoint14SetMinDistanceEf: __ZN5Unity11SpringJoint14SetMinDistanceEf, __Z11MoveTowardsRK8Vector3fS1_f: __Z11MoveTowardsRK8Vector3fS1_f, __Z40CapsuleCollider_Get_Custom_PropDirectionP12Il2CppObject: __Z40CapsuleCollider_Get_Custom_PropDirectionP12Il2CppObject, __ZNK11UnityEngine9Animation28GenericAnimationBindingCache38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK11UnityEngine9Animation28GenericAnimationBindingCache38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __Z46Cloth_CUSTOM_INTERNAL_set_externalAccelerationP12Il2CppObjectRK8Vector3f: __Z46Cloth_CUSTOM_INTERNAL_set_externalAccelerationP12Il2CppObjectRK8Vector3f, _ctanhl: _ctanhl, __ZN11UnityEngine15CloudWebService19SessionEventManagerC2Ev: __ZN11UnityEngine15CloudWebService19SessionEventManagerC2Ev, __Z42Register_UnityEngine_TextMesh_get_fontSizev: __Z42Register_UnityEngine_TextMesh_get_fontSizev, __ZN12AudioManager27GroupGUIDHasDependentMixersERK9UnityGUID: __ZN12AudioManager27GroupGUIDHasDependentMixersERK9UnityGUID, __Z32getPxScene_WakeCounterResetValuePKN5physx7PxSceneE: __Z32getPxScene_WakeCounterResetValuePKN5physx7PxSceneE, __Z23RegisterModule_UnityAdsv: __Z23RegisterModule_UnityAdsv, __ZN19SkinnedMeshRenderer14PrepareSkinGPUEiP18JobBatchDispatcher: __ZN19SkinnedMeshRenderer14PrepareSkinGPUEiP18JobBatchDispatcher, __ZNK22RenderingCommandBuffer10FindTempRTERKN9ShaderLab16FastPropertyNameE: __ZNK22RenderingCommandBuffer10FindTempRTERKN9ShaderLab16FastPropertyNameE, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __Z29GUI_CUSTOM_BringWindowToFronti: __Z29GUI_CUSTOM_BringWindowToFronti, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv, __Z23getPxArticulation_ScenePKN5physx14PxArticulationE: __Z23getPxArticulation_ScenePKN5physx14PxArticulationE, __ZN23UnityPurchasingSettings11SetTestModeEb: __ZN23UnityPurchasingSettings11SetTestModeEb, __ZN18ScBeforeSolverTask11runInternalEv: __ZN18ScBeforeSolverTask11runInternalEv, __ZN7dtCrowdC2Ev: __ZN7dtCrowdC2Ev, __ZN20NavMeshBuildSettings8TransferI14SafeBinaryReadEEvRT_: __ZN20NavMeshBuildSettings8TransferI14SafeBinaryReadEEvRT_, __Z51ReflectionProbe_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf: __Z51ReflectionProbe_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf, __Z50Register_UnityEngine_AI_NavMeshObstacle_FitExtentsv: __Z50Register_UnityEngine_AI_NavMeshObstacle_FitExtentsv, __Z45Physics2D_Get_Custom_PropShowColliderContactsv: __Z45Physics2D_Get_Custom_PropShowColliderContactsv, _sinh: _sinh, __ZN13AnimationClip10FloatCurve8TransferI14SafeBinaryReadEEvRT_: __ZN13AnimationClip10FloatCurve8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj: __ZNK5physx22PxVehicleWheelsSimData23getSceneQueryFilterDataEj, __Z37Graphics_CUSTOM_Internal_SetMRTSimpleP11Il2CppArrayP21ScriptingRenderBufferiii: __Z37Graphics_CUSTOM_Internal_SetMRTSimpleP11Il2CppArrayP21ScriptingRenderBufferiii, __ZN4FMOD6SoundI12getSyncPointEiPP14FMOD_SYNCPOINT: __ZN4FMOD6SoundI12getSyncPointEiPP14FMOD_SYNCPOINT, __ZN14AreaEffector2DD2Ev: __ZN14AreaEffector2DD2Ev, __Z35AnimationState_Get_Custom_PropSpeedP12Il2CppObject: __Z35AnimationState_Get_Custom_PropSpeedP12Il2CppObject, __ZN5physx32PxsSolverConstraintPartitionTaskD2Ev: __ZN5physx32PxsSolverConstraintPartitionTaskD2Ev, __Z36SpringJoint_Get_Custom_PropToleranceP12Il2CppObject: __Z36SpringJoint_Get_Custom_PropToleranceP12Il2CppObject, __Z57Register_UnityEngine_ConfigurableJoint_set_projectionModev: __Z57Register_UnityEngine_ConfigurableJoint_set_projectionModev, __ZL19CleanupModule_Audiov: __ZL19CleanupModule_Audiov, __ZN17TransformInternal38OnTransformChangedMaskToSelfAndParentsE15TransformAccessj: __ZN17TransformInternal38OnTransformChangedMaskToSelfAndParentsE15TransformAccessj, __ZN5physx16PxsFluidDynamics9updateSphERNS_10PxBaseTaskE: __ZN5physx16PxsFluidDynamics9updateSphERNS_10PxBaseTaskE, __Z23scripting_method_invoke21ScriptingMethodIl2CppP12Il2CppObjectR18ScriptingArgumentsPP15Il2CppExceptionb: __Z23scripting_method_invoke21ScriptingMethodIl2CppP12Il2CppObjectR18ScriptingArgumentsPP15Il2CppExceptionb, __Z37AnimationClipPlayable_CUSTOM_SetSpeedR9HPlayablef: __Z37AnimationClipPlayable_CUSTOM_SetSpeedR9HPlayablef, __ZNK26DownloadHandlerAssetBundle9GetLengthEv: __ZNK26DownloadHandlerAssetBundle9GetLengthEv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z30Animator_CUSTOM_SetFloatStringP12Il2CppObjectP12Il2CppStringf: __Z30Animator_CUSTOM_SetFloatStringP12Il2CppObjectP12Il2CppStringf, __ZN9Texture2D15InitializeClassEv: __ZN9Texture2D15InitializeClassEv, __ZN15MBP_PairManager5purgeEv: __ZN15MBP_PairManager5purgeEv, __Z46Register_UnityEngine_Light_get_pixelLightCountv: __Z46Register_UnityEngine_Light_get_pixelLightCountv, __ZN4Mesh18CreateMeshIfNeededEv: __ZN4Mesh18CreateMeshIfNeededEv, __Z37TerrainData_CUSTOM_GetAlphamapTextureP12Il2CppObjecti: __Z37TerrainData_CUSTOM_GetAlphamapTextureP12Il2CppObjecti, __ZN12AudioManager13AddAudioMixerEP10AudioMixer: __ZN12AudioManager13AddAudioMixerEP10AudioMixer, __ZN18ScriptingArguments11GetObjectAtEi: __ZN18ScriptingArguments11GetObjectAtEi, __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE16StaticInitializeEPv, __ZN7ApiGLES18UnbindMemoryBufferEN2gl12BufferTargetE: __ZN7ApiGLES18UnbindMemoryBufferEN2gl12BufferTargetE, __Z41LineRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf: __Z41LineRenderer_CUSTOM_INTERNAL_set_endColorP12Il2CppObjectRK10ColorRGBAf, __ZN24b2ChainAndPolygonContactC2EP9b2FixtureiS1_i: __ZN24b2ChainAndPolygonContactC2EP9b2FixtureiS1_i, __Z54Physics_Get_Custom_PropDefaultSolverVelocityIterationsv: __Z54Physics_Get_Custom_PropDefaultSolverVelocityIterationsv, _XXH32_canonicalFromHash: _XXH32_canonicalFromHash, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9copy_fromERKSM_j: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9copy_fromERKSM_j, __Z37setPxVehicleDriveDynData_UseAutoGearsPN5physx21PxVehicleDriveDynDataEb: __Z37setPxVehicleDriveDynData_UseAutoGearsPN5physx21PxVehicleDriveDynDataEb, __ZNK28MonoBehaviourPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK28MonoBehaviourPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EEPS1_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EEPS1_, __Z51Register_UnityEngine_Profiling_Profiler_get_logFilev: __Z51Register_UnityEngine_Profiling_Profiler_get_logFilev, __Z72Register_UnityEngine_GUIUtility_INTERNAL_CALL_Internal_GetNextControlID2v: __Z72Register_UnityEngine_GUIUtility_INTERNAL_CALL_Internal_GetNextControlID2v, __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE6resizeEj: __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE6resizeEj, __Z33Camera_Get_Custom_PropFieldOfViewP12Il2CppObject: __Z33Camera_Get_Custom_PropFieldOfViewP12Il2CppObject, __ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_: __ZNK11UnityEngine9Animation11BindingSortclERKNSt3__24pairINS0_14GenericBindingEPNS0_10BoundIndexEEES9_, __ZN13GfxDeviceGLES32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat: __ZN13GfxDeviceGLES32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat, __ZN26AnimatorControllerPlayable13ClearBindingsEv: __ZN26AnimatorControllerPlayable13ClearBindingsEv, __Z33Texture_Set_Custom_PropAnisoLevelP12Il2CppObjecti: __Z33Texture_Set_Custom_PropAnisoLevelP12Il2CppObjecti, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_17TransferMetaFlags, __ZN5physx23PxsBroadPhaseContextSap7destroyEv: __ZN5physx23PxsBroadPhaseContextSap7destroyEv, __ZL30RegisterFilteredObjectCallbackPP12Il2CppObjectiPv: __ZL30RegisterFilteredObjectCallbackPP12Il2CppObjectiPv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47Register_UnityEngine_Material_GetFloatArrayImplv: __Z47Register_UnityEngine_Material_GetFloatArrayImplv, __ZN19LightProbeOcclusion8TransferI14SafeBinaryReadEEvRT_: __ZN19LightProbeOcclusion8TransferI14SafeBinaryReadEEvRT_, __ZN26AnimatorOverrideController13AwakeFromLoadE17AwakeFromLoadMode: __ZN26AnimatorOverrideController13AwakeFromLoadE17AwakeFromLoadMode, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_yDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_yDrivev, __Z35Animator_Set_Custom_PropCullingModeP12Il2CppObjectN8Animator11CullingModeE: __Z35Animator_Set_Custom_PropCullingModeP12Il2CppObjectN8Animator11CullingModeE, __ZN5physx19PxcGetMaterialShapeEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx19PxcGetMaterialShapeEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, _FMOD_Memory_GetStats: _FMOD_Memory_GetStats, __Z68Register_UnityEngine_Camera_INTERNAL_set_nonJitteredProjectionMatrixv: __Z68Register_UnityEngine_Camera_INTERNAL_set_nonJitteredProjectionMatrixv, __ZN2UI6Canvas29UpdateCachedSortingLayerValueEv: __ZN2UI6Canvas29UpdateCachedSortingLayerValueEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __Z37AndroidJNI_CUSTOM_SetStaticFloatField13Il2Cpp_IntPtrS_f: __Z37AndroidJNI_CUSTOM_SetStaticFloatField13Il2Cpp_IntPtrS_f, __ZNK14BillboardAsset13GetNumIndicesEv: __ZNK14BillboardAsset13GetNumIndicesEv, __ZN9GfxDevice25ReleaseAsyncCommandHeaderEPN21GfxDeviceAsyncCommand3ArgE: __ZN9GfxDevice25ReleaseAsyncCommandHeaderEPN21GfxDeviceAsyncCommand3ArgE, __Z37Animator_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z37Animator_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, __ZN4gles8internal21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS4_: __ZN4gles8internal21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS4_, __ZN9TextAsset8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9TextAsset8TransferI24GenerateTypeTreeTransferEEvRT_, __Z35GetHasLateBoundSceneFromAssetBundleRK8UnityStrRS_S2_: __Z35GetHasLateBoundSceneFromAssetBundleRK8UnityStrRS_S2_, __ZN13ScreenManager24SetAllowLayeredRenderingEb: __ZN13ScreenManager24SetAllowLayeredRenderingEb, __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z38NavMeshAgent_Get_Custom_PropPathStatusP12Il2CppObject: __Z38NavMeshAgent_Get_Custom_PropPathStatusP12Il2CppObject, __ZN17Physics2DSettings15InitializeClassEv: __ZN17Physics2DSettings15InitializeClassEv, __ZN21UniformBufferTFMethod20IsBoneCountSupportedEi: __ZN21UniformBufferTFMethod20IsBoneCountSupportedEi, __Z13RegisterClassI15AudioEchoFilterEvv: __Z13RegisterClassI15AudioEchoFilterEvv, __ZN16Physics2DManager21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE: __ZN16Physics2DManager21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE, __ZN5physx2Gu5Debug9visualizeERKNS_15PxPlaneGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_15PxPlaneGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __Z56Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSpherev: __Z56Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSpherev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _tt_cmap14_variant_chars: _tt_cmap14_variant_chars, __Z21SetBlendShapeVerticesPK8Vector3fS1_S1_R13dynamic_arrayI16BlendShapeVertexLj4EER10BlendShapei: __Z21SetBlendShapeVerticesPK8Vector3fS1_S1_R13dynamic_arrayI16BlendShapeVertexLj4EER10BlendShapei, __ZN17b2ContactListener9PostSolveEP9b2ContactPK16b2ContactImpulse: __ZN17b2ContactListener9PostSolveEP9b2ContactPK16b2ContactImpulse, __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj: __ZNSt3__26vectorIiNS_9allocatorIiEEE8__appendEj, __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeI9ShapePair16TriggerStayStateEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __Z39ParticleSystem_CUSTOM_Internal_SimulateP12Il2CppObjectfhh: __Z39ParticleSystem_CUSTOM_Internal_SimulateP12Il2CppObjectfhh, __ZN5physx30PxClothParticleGeneratedValuesC2EPKNS_15PxClothParticleE: __ZN5physx30PxClothParticleGeneratedValuesC2EPKNS_15PxClothParticleE, __ZNK5Umbra9Matrix3x38getScaleEv: __ZNK5Umbra9Matrix3x38getScaleEv, _zipOpenNewFileInZip2: _zipOpenNewFileInZip2, _UnityReplayKitTriggerBroadcastStatusCallback: _UnityReplayKitTriggerBroadcastStatusCallback, __Z13raycast_planeRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z13raycast_planeRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7SetSizeEi: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7SetSizeEi, __ZN16CircleCollider2D5ResetEv: __ZN16CircleCollider2D5ResetEv, __Z12UpdateClothsv: __Z12UpdateClothsv, __Z24RegisterStrippedTypeInfoI13WebCamTextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI13WebCamTextureEviPKcS2_, __Z28DeleteFirstPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z28DeleteFirstPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, _unity_z_tr_tally: _unity_z_tr_tally, _forkpty: _forkpty, __ZN10GameObject21EnsureUniqueTransformEbb: __ZN10GameObject21EnsureUniqueTransformEbb, __ZN15UnityWebRequestC2Ev: __ZN15UnityWebRequestC2Ev, __ZN20FileSystemEnumerator5MountEPKcP17FileSystemHandler: __ZN20FileSystemEnumerator5MountEPKcP17FileSystemHandler, __Z29RegisterModuleClasses_Terrainv: __Z29RegisterModuleClasses_Terrainv, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYLimitv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYLimitv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEaSERKS7_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEaSERKS7_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z18tessMeshDeleteMeshP9TESSallocP8TESSmesh: __Z18tessMeshDeleteMeshP9TESSallocP8TESSmesh, __ZL32GeomOverlapCallback_PlaneCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL32GeomOverlapCallback_PlaneCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5physx2Sc9ClothCore13setGlobalPoseERKNS_11PxTransformE: __ZN5physx2Sc9ClothCore13setGlobalPoseERKNS_11PxTransformE, _pshinter_module_class_pic_free: _pshinter_module_class_pic_free, __ZN5physx2Gu15MeshRayCollider7collideILi0ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_: __ZN5physx2Gu15MeshRayCollider7collideILi0ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_, __ZN18AnimatorController15ThreadedCleanupEv: __ZN18AnimatorController15ThreadedCleanupEv, __ZN5physx2Sc9ShapeCore13setRestOffsetEf: __ZN5physx2Sc9ShapeCore13setRestOffsetEf, __ZThn4_N5physx5cloth9SwFactoryD1Ev: __ZThn4_N5physx5cloth9SwFactoryD1Ev, __Z19CollectWorldObjectsR13dynamic_arrayIiLj4EEb: __Z19CollectWorldObjectsR13dynamic_arrayIiLj4EEb, __ZNK5Umbra15OcclusionBuffer9getHeightEv: __ZNK5Umbra15OcclusionBuffer9getHeightEv, __Z75Register_UnityEngineInternal_GIDebugVisualisation_ResetRuntimeInputTexturesv: __Z75Register_UnityEngineInternal_GIDebugVisualisation_ResetRuntimeInputTexturesv, __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E: __Z17CalculateGlobalSM23TransformAccessReadOnlyRKN4math7_float4E, __Z13RegisterClassI12WheelJoint2DEvv: __Z13RegisterClassI12WheelJoint2DEvv, __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZN5physx22PxVehicleTelemetryData4freeEv: __ZN5physx22PxVehicleTelemetryData4freeEv, __Z45Application_Get_Custom_PropTemporaryCachePathv: __Z45Application_Get_Custom_PropTemporaryCachePathv, __ZN7mecanim9animation16GetAllBlendValueEPNS0_17BlendTreeConstantER13dynamic_arrayIiLj4EE: __ZN7mecanim9animation16GetAllBlendValueEPNS0_17BlendTreeConstantER13dynamic_arrayIiLj4EE, __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject: __Z51ParticleSystem_ColorBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject, __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv: __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv, __Z51Register_UnityEngine_PlatformEffector2D_get_sideArcv: __Z51Register_UnityEngine_PlatformEffector2D_get_sideArcv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKw, __ZN6Shader16GetDefaultOrNullEv: __ZN6Shader16GetDefaultOrNullEv, __ZN11TerrainData23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11TerrainData23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE: __ZN5physx2Gu21sweepCapsuleTrianglesEjPKNS_10PxTriangleERKNS0_7CapsuleERKNS_6PxVec3EfPKjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEERfRS7_SI_RjSI_SF_bPKNS0_3BoxE, __Z24getNbPxPhysics_MaterialsPKN5physx9PxPhysicsE: __Z24getNbPxPhysics_MaterialsPKN5physx9PxPhysicsE, __ZN4AABB8TransferI14SafeBinaryReadEEvRT_: __ZN4AABB8TransferI14SafeBinaryReadEEvRT_, _UNITY_png_destroy_info_struct: _UNITY_png_destroy_info_struct, __Z27JsonUtility_CUSTOM_FromJsonP12Il2CppStringP12Il2CppObject: __Z27JsonUtility_CUSTOM_FromJsonP12Il2CppStringP12Il2CppObject, __ZN9Rigidbody14SetAngularDragEf: __ZN9Rigidbody14SetAngularDragEf, __ZN22UnityProfilerPerThread34CreateProfilerInformationForMethodEP12Il2CppObject21ScriptingMethodIl2CppPKcP11Il2CppClassS2_N19ProfilerInformation5FlagsE: __ZN22UnityProfilerPerThread34CreateProfilerInformationForMethodEP12Il2CppObject21ScriptingMethodIl2CppPKcP11Il2CppClassS2_N19ProfilerInformation5FlagsE, __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitSpringv: __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitSpringv, __Z44ParticleEmitter_Get_Custom_PropUseWorldSpaceP12Il2CppObject: __Z44ParticleEmitter_Get_Custom_PropUseWorldSpaceP12Il2CppObject, __ZN12MeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12MeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags, __Z49Register_UnityEngine_MonoBehaviour_StartCoroutinev: __Z49Register_UnityEngine_MonoBehaviour_StartCoroutinev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseEjj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj: __ZN5physx16PxcFsGetVelocityERNS_9PxcFsDataEj, __Z11MD5ToStringPh: __Z11MD5ToStringPh, __Z38Input_Get_Custom_PropCompositionStringv: __Z38Input_Get_Custom_PropCompositionStringv, __ZN11NavMeshPathD2Ev: __ZN11NavMeshPathD2Ev, __ZN5physx18collideWithCapsuleEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf: __ZN5physx18collideWithCapsuleEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj261ENS_22PxRepXPropertyAccessorILj261ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj261ENS_22PxRepXPropertyAccessorILj261ES4_ffEEEEvRKT0_, __Z38AnimationState_Set_Custom_PropWrapModeP12Il2CppObjecti: __Z38AnimationState_Set_Custom_PropWrapModeP12Il2CppObjecti, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE16__construct_nodeERKNS_4pairIKS2_S5_EE, _examine_app0: _examine_app0, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj124ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_: __ZNK5physx2Sc14ConstraintCore13getBreakForceERfS2_, __ZN5physx2Sc8ShapeSim21destroyLowLevelVolumeEv: __ZN5physx2Sc8ShapeSim21destroyLowLevelVolumeEv, __Z39Register_UnityEngine_Shader_FindBuiltinv: __Z39Register_UnityEngine_Shader_FindBuiltinv, __ZN7mecanim12statemachine18TransitionConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim12statemachine18TransitionConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _cf2_builder_moveTo: _cf2_builder_moveTo, __ZN9JSONWrite8TransferIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEEEvRT_PKc17TransferMetaFlags, __Z13ForceLODLevelRK8LODGroupi: __Z13ForceLODLevelRK8LODGroupi, __ZNK8VRDevice24GetDisableBackBufferMSAAEv: __ZNK8VRDevice24GetDisableBackBufferMSAAEv, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev, __ZN24b2ChainAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN24b2ChainAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEjc, __Z40AndroidJNI_CUSTOM_CallStaticDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z40AndroidJNI_CUSTOM_CallStaticDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN5physx2Sc8BodyCore17setAngularDampingEf: __ZN5physx2Sc8BodyCore17setAngularDampingEf, __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP9Texture2D6ObjectET_RK4PPtrIT0_E, __ZN14PlayerSettings16CheckConsistencyEv: __ZN14PlayerSettings16CheckConsistencyEv, __ZN5physx37PxVehicleWheelsSimDataGeneratedValuesC2EPKNS_22PxVehicleWheelsSimDataE: __ZN5physx37PxVehicleWheelsSimDataGeneratedValuesC2EPKNS_22PxVehicleWheelsSimDataE, __ZN19AtomicPageAllocatorD2Ev: __ZN19AtomicPageAllocatorD2Ev, _erand48: _erand48, __ZNK9Texture2D27IsSupportedReadPixelsFormatE13TextureFormat: __ZNK9Texture2D27IsSupportedReadPixelsFormatE13TextureFormat, __ZNK5physx2Gu12TriangleMesh24getTriangleMaterialIndexEj: __ZNK5physx2Gu12TriangleMesh24getTriangleMaterialIndexEj, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZN5physx31PxClothGeodesicTetherCookerImplD2Ev: __ZN5physx31PxClothGeodesicTetherCookerImplD2Ev, __ZN14HeightMeshDataaSERKS_: __ZN14HeightMeshDataaSERKS_, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE21__push_back_slow_pathIKS6_EEvRT_, __Z52SystemInfo_Get_Custom_PropSupportedRenderTargetCountv: __Z52SystemInfo_Get_Custom_PropSupportedRenderTargetCountv, __ZN5physx20PxsParticleSystemSim24clearParticleConstraintsEv: __ZN5physx20PxsParticleSystemSim24clearParticleConstraintsEv, __ZN5Umbra9BitVector4_andERKS0_: __ZN5Umbra9BitVector4_andERKS0_, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __Z40GUIUtility_Set_Custom_PropTextFieldInputh: __Z40GUIUtility_Set_Custom_PropTextFieldInputh, __Z47Register_UnityEngine_AndroidJNI_DeleteGlobalRefv: __Z47Register_UnityEngine_AndroidJNI_DeleteGlobalRefv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE7reserveEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE7reserveEj, __Z30AnimationPlayableEvaluateBeginP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __Z30AnimationPlayableEvaluateBeginP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __ZNK12CubemapArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK12CubemapArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __Z63Register_UnityEngine_MonoBehaviour_StartCoroutine_Auto_Internalv: __Z63Register_UnityEngine_MonoBehaviour_StartCoroutine_Auto_Internalv, __ZNK15b2FrictionJoint10GetAnchorAEv: __ZNK15b2FrictionJoint10GetAnchorAEv, __ZN12_GLOBAL__N_117EventBufferClientD2Ev: __ZN12_GLOBAL__N_117EventBufferClientD2Ev, __ZN10systeminfo24GetSystemLanguageCultureEi: __ZN10systeminfo24GetSystemLanguageCultureEi, __ZNK12SocketStream11IsConnectedEv: __ZNK12SocketStream11IsConnectedEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj531ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx17PxcNpMemBlockPool23releaseConstraintMemoryEv: __ZN5physx17PxcNpMemBlockPool23releaseConstraintMemoryEv, __Z36NavMeshAgent_Set_Custom_PropAreaMaskP12Il2CppObjecti: __Z36NavMeshAgent_Set_Custom_PropAreaMaskP12Il2CppObjecti, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN4PPtrI18SpeedTreeWindAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI18SpeedTreeWindAssetE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj, __Z36Texture2D_Get_Custom_PropMipmapCountP12Il2CppObject: __Z36Texture2D_Get_Custom_PropMipmapCountP12Il2CppObject, __ZN5physx13BigConvexData15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx13BigConvexData15exportExtraDataERNS_22PxSerializationContextE, __ZN22UnityProfilerPerThread16EndSampleDynamicEv: __ZN22UnityProfilerPerThread16EndSampleDynamicEv, _UNITY_FT_Outline_Get_CBox: _UNITY_FT_Outline_Get_CBox, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEclILj547ES3_NS3_4EnumES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEclILj547ES3_NS3_4EnumES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12b2MouseJoint9SetTargetERK6b2Vec2: __ZN12b2MouseJoint9SetTargetERK6b2Vec2, __Z68Register_UnityEngine_Profiling_Profiler_GetTotalUnusedReservedMemoryv: __Z68Register_UnityEngine_Profiling_Profiler_GetTotalUnusedReservedMemoryv, __ZN21ImposterRenderTexture12SetUseMipmapEb: __ZN21ImposterRenderTexture12SetUseMipmapEb, __ZN5physx16PxVehicleNoDriveD0Ev: __ZN5physx16PxVehicleNoDriveD0Ev, __ZN5physx21propagateVelocitySIMDERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE: __ZN5physx21propagateVelocitySIMDERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE, __ZN5Unity10HingeJoint16WriteJointLimitsEv: __ZN5Unity10HingeJoint16WriteJointLimitsEv, _ccosh: _ccosh, __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEE8TransferI14SafeBinaryReadEEvRS5_RT_: __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEE8TransferI14SafeBinaryReadEEvRS5_RT_, _ccosl: _ccosl, __ZN22PerThreadPageAllocator14AcquireNewPageEj: __ZN22PerThreadPageAllocator14AcquireNewPageEj, __ZN24AudioScriptBufferManager15DidReloadDomainEv: __ZN24AudioScriptBufferManager15DidReloadDomainEv, _ccosf: _ccosf, __Z37Register_UnityEngine_AssetBundle_Loadv: __Z37Register_UnityEngine_AssetBundle_Loadv, __ZL16DrawMeshInternalRK14ChannelAssignsR4MeshRK10Matrix4x4fi13TransformType: __ZL16DrawMeshInternalRK14ChannelAssignsR4MeshRK10Matrix4x4fi13TransformType, __ZN10RectOffset8TransferI9JSONWriteEEvRT_: __ZN10RectOffset8TransferI9JSONWriteEEvRT_, __ZNKSt3__27collateIcE10do_compareEPKcS3_S3_S3_: __ZNKSt3__27collateIcE10do_compareEPKcS3_S3_S3_, __ZN6Camera13ClearNoSkyboxEb: __ZN6Camera13ClearNoSkyboxEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj591ENS_22PxRepXPropertyAccessorILj591ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj591ENS_22PxRepXPropertyAccessorILj591ES4_ffEEEEvRKT0_, __Z44ReflectionProbe_Set_Custom_PropBoxProjectionP12Il2CppObjecth: __Z44ReflectionProbe_Set_Custom_PropBoxProjectionP12Il2CppObjecth, __ZNK13SliderJoint2D17GetReferenceAngleEv: __ZNK13SliderJoint2D17GetReferenceAngleEv, __ZN27AnimationLayerMixerPlayable6Memory21DestroyNodeStateArrayERN7mecanim6memory9AllocatorE: __ZN27AnimationLayerMixerPlayable6Memory21DestroyNodeStateArrayERN7mecanim6memory9AllocatorE, __ZN5physx6shdfnd21atomicCompareExchangeEPViii: __ZN5physx6shdfnd21atomicCompareExchangeEPViii, __Z40Register_UnityEngine_Material_GetTexturev: __Z40Register_UnityEngine_Material_GetTexturev, __ZNK13WheelCollider12GetWorldPoseEP8Vector3fP11Quaternionf: __ZNK13WheelCollider12GetWorldPoseEP8Vector3fP11Quaternionf, __ZN6Camera20PreMultiCustomRenderER11CullResultsNS_10RenderFlagEb: __ZN6Camera20PreMultiCustomRenderER11CullResultsNS_10RenderFlagEb, __Z11MurmurHash1PKvij: __Z11MurmurHash1PKvij, __Z53Register_UnityEngine_GUIClip_INTERNAL_CALL_GetTopRectv: __Z53Register_UnityEngine_GUIClip_INTERNAL_CALL_GetTopRectv, __ZN9Animation22ReleaseOwnedAnimationsEv: __ZN9Animation22ReleaseOwnedAnimationsEv, __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRT_RKS7_SA_j: __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRT_RKS7_SA_j, __ZNK5physx2Sc9ClothCore26getNbParticleAccelerationsEv: __ZNK5physx2Sc9ClothCore26getNbParticleAccelerationsEv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv, __ZNKSt3__210error_code7messageEv: __ZNKSt3__210error_code7messageEv, __ZN14RotationModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj: __ZN14RotationModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj, _UNITY_FT_Get_TrueType_Engine_Type: _UNITY_FT_Get_TrueType_Engine_Type, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18GfxFramebufferGLES10InvalidateEv: __ZN18GfxFramebufferGLES10InvalidateEv, __ZN5physx7NpCloth16lockParticleDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx7NpCloth16lockParticleDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __Z34TerrainData_CUSTOM_SetBasemapDirtyP12Il2CppObjecth: __Z34TerrainData_CUSTOM_SetBasemapDirtyP12Il2CppObjecth, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUVChannelMaskv: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUVChannelMaskv, __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI14SphereColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_tt_size_run_prep: _UNITY_tt_size_run_prep, __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_: __ZN4crnd11crnd_deleteINS_13prefix_coding14decoder_tablesEEEvPT_, __ZN12NavMeshAgent17RemoveFromManagerEv: __ZN12NavMeshAgent17RemoveFromManagerEv, __Z56Register_UnityEngine_QualitySettings_get_pixelLightCountv: __Z56Register_UnityEngine_QualitySettings_get_pixelLightCountv, __ZN12_GLOBAL__N_19MyFastXml10processXmlERN5physx11PxInputDataEb: __ZN12_GLOBAL__N_19MyFastXml10processXmlERN5physx11PxInputDataEb, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv, __ZN17AnimationCurveTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_: __ZN17AnimationCurveTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE: __ZN5physx7NpActor13getOwnerSceneERKNS_7PxActorE, __ZN5physx18PxcNpThreadContextC2EfffRKNS_2Cm12RenderOutputERNS_17PxcNpMemBlockPoolEb: __ZN5physx18PxcNpThreadContextC2EfffRKNS_2Cm12RenderOutputERNS_17PxcNpMemBlockPoolEb, __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByNameP12Il2CppStringRi: __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByNameP12Il2CppStringRi, __Z37Register_UnityEngine_GUIStyle_Cleanupv: __Z37Register_UnityEngine_GUIStyle_Cleanupv, __ZN3MBPC2EPN5physx14PxsAABBManagerE: __ZN3MBPC2EPN5physx14PxsAABBManagerE, __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN19SpriteMeshGenerator4path3decEi: __ZN19SpriteMeshGenerator4path3decEi, __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE21__grow_by_and_replaceEjjjjjjPKw, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity11SpringJoint9SetDamperEf: __ZN5Unity11SpringJoint9SetDamperEf, __ZN16ReflectionProbes24ScheduleAutomaticRefreshEv: __ZN16ReflectionProbes24ScheduleAutomaticRefreshEv, __Z44Register_UnityEngine_MeshCollider_get_convexv: __Z44Register_UnityEngine_MeshCollider_get_convexv, __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_10StartEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_10StartEventEEEbRT_, __ZN4FMOD8ChannelI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD8ChannelI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __ZN20ExternalForcesModuleD0Ev: __ZN20ExternalForcesModuleD0Ev, __Z33CommandBuffer_Get_Custom_PropNameP12Il2CppObject: __Z33CommandBuffer_Get_Custom_PropNameP12Il2CppObject, __ZNK13WheelCollider26GetTypeInfoVirtualInternalEv: __ZNK13WheelCollider26GetTypeInfoVirtualInternalEv, __ZN9Scripting26RaiseArgumentNullExceptionEPKc: __ZN9Scripting26RaiseArgumentNullExceptionEPKc, __ZN5physx2Gu5RTree4loadERNS_13PxInputStreamEj: __ZN5physx2Gu5RTree4loadERNS_13PxInputStreamEj, _UNITY_FT_GlyphLoader_Reset: _UNITY_FT_GlyphLoader_Reset, __Z40AudioChorusFilter_Get_Custom_PropWetMix2P12Il2CppObject: __Z40AudioChorusFilter_Get_Custom_PropWetMix2P12Il2CppObject, __Z47Register_UnityEngine_Mesh_get_vertexBufferCountv: __Z47Register_UnityEngine_Mesh_get_vertexBufferCountv, __Z43Cloth_Set_Custom_PropWorldAccelerationScaleP12Il2CppObjectf: __Z43Cloth_Set_Custom_PropWorldAccelerationScaleP12Il2CppObjectf, __Z43ParticleSystem_Set_Custom_PropPlaybackSpeedP12Il2CppObjectf: __Z43ParticleSystem_Set_Custom_PropPlaybackSpeedP12Il2CppObjectf, _LzmaDec_DecodeToBuf: _LzmaDec_DecodeToBuf, __ZL18InternalLogConsolePKcz: __ZL18InternalLogConsolePKcz, __ZN23CachedSerializationDataC2Ev: __ZN23CachedSerializationDataC2Ev, _lseek: _lseek, __ZN6MotionD2Ev: __ZN6MotionD2Ev, __ZN9GfxDevice29GetNativeComputeBufferPointerE15ComputeBufferID: __ZN9GfxDevice29GetNativeComputeBufferPointerE15ComputeBufferID, __Z60AnimatorControllerPlayable_CUSTOM_GetParametersArrayInternalR9HPlayable: __Z60AnimatorControllerPlayable_CUSTOM_GetParametersArrayInternalR9HPlayable, __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev: __ZN5physx40PxVehicleDifferential4WDataGeneratedInfoC2Ev, __ZNK14ParticleSystem12GetStartSizeEv: __ZNK14ParticleSystem12GetStartSizeEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __ZN4FMOD6System12unloadPluginEj: __ZN4FMOD6System12unloadPluginEj, __ZN11AudioSource16UpdatePauseStateEv: __ZN11AudioSource16UpdatePauseStateEv, __ZL52StaticUnregisterSceneLoadedCallback_LightmapSettingsPv: __ZL52StaticUnregisterSceneLoadedCallback_LightmapSettingsPv, __Z39GUIClip_CUSTOM_INTERNAL_get_topmostRectP5RectTIfE: __Z39GUIClip_CUSTOM_INTERNAL_get_topmostRectP5RectTIfE, __ZNKSt3__27collateIcE4hashEPKcS3_: __ZNKSt3__27collateIcE4hashEPKcS3_, __Z38Input_Set_Custom_PropCompensateSensorsh: __Z38Input_Set_Custom_PropCompensateSensorsh, __Z6AppendPKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z6AppendPKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z24RegisterStrippedTypeInfoI16CircleCollider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI16CircleCollider2DEviPKcS2_, __ZN5physx7NpCloth24setParticleAccelerationsEPKNS_6PxVec4E: __ZN5physx7NpCloth24setParticleAccelerationsEPKNS_6PxVec4E, __Z61GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorPixelPosition13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiP13Vector2fIcall: __Z61GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorPixelPosition13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectiP13Vector2fIcall, __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_: __ZN7mecanim9animation19AdjustPoseForMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKN4math4trsXERNS_10ValueArrayERNS_8skeleton13SkeletonPoseTIS8_EESG_, __ZN5physx3Scb5Shape18setMaterialsHelperEPKPNS_10PxMaterialEt: __ZN5physx3Scb5Shape18setMaterialsHelperEPKPNS_10PxMaterialEt, __ZN5physx22PxDefaultFileInputDataD0Ev: __ZN5physx22PxDefaultFileInputDataD0Ev, __Z43Terrain_Get_Custom_PropReflectionProbeUsageP12Il2CppObject: __Z43Terrain_Get_Custom_PropReflectionProbeUsageP12Il2CppObject, __Z24RegisterStrippedTypeInfoI17ProceduralTextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI17ProceduralTextureEviPKcS2_, __ZN27DeviceViewProjMatricesStateD2Ev: __ZN27DeviceViewProjMatricesStateD2Ev, __ZN15UnityAdsManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN15UnityAdsManager23VirtualRedirectTransferER14SafeBinaryRead, __Z47Register_UnityEngine_Projector_set_ignoreLayersv: __Z47Register_UnityEngine_Projector_set_ignoreLayersv, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale1Ef, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj7ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj7ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd5ArrayINS_19PxsArticulationLinkENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_19PxsArticulationLinkENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN16DeveloperConsole7DrawBoxEffR8GUIStateff: __ZN16DeveloperConsole7DrawBoxEffR8GUIStateff, __ZN9LensFlare8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9LensFlare8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__223__system_error_category23default_error_conditionEi: __ZNKSt3__223__system_error_category23default_error_conditionEi, __ZN9Texture3D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Texture3D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z35SpriteRenderer_Get_Custom_PropFlipXP12Il2CppObject: __Z35SpriteRenderer_Get_Custom_PropFlipXP12Il2CppObject, __Z38Camera_Set_Custom_PropDepthTextureModeP12Il2CppObjecti: __Z38Camera_Set_Custom_PropDepthTextureModeP12Il2CppObjecti, __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_13ToiPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_13ToiPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j, __Z41CommandBuffer_CUSTOM_SetGlobalMatrixArrayP12Il2CppObjectiP11Il2CppArray: __Z41CommandBuffer_CUSTOM_SetGlobalMatrixArrayP12Il2CppObjectiP11Il2CppArray, __ZN12WWWDelayCallD2Ev: __ZN12WWWDelayCallD2Ev, __Z44ReflectionProbe_Get_Custom_PropNearClipPlaneP12Il2CppObject: __Z44ReflectionProbe_Get_Custom_PropNearClipPlaneP12Il2CppObject, __Z46ParticleSystemRenderer_Set_Custom_PropSortModeP12Il2CppObject22ParticleSystemSortMode: __Z46ParticleSystemRenderer_Set_Custom_PropSortModeP12Il2CppObject22ParticleSystemSortMode, __Z67Register_UnityEngine_ParticleSystem_SubEmittersModule_AddSubEmitterv: __Z67Register_UnityEngine_ParticleSystem_SubEmittersModule_AddSubEmitterv, __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN11PlayerPrefs6GetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __ZNK3WWW6IsDoneEv: __ZNK3WWW6IsDoneEv, __Z45Register_UnityEngine_Application_get_platformv: __Z45Register_UnityEngine_Application_get_platformv, __ZN5physx2Sn18RepXCollectionImpl25addRepXObjectToCollectionERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_23PxRepXInstantiationArgsE: __ZN5physx2Sn18RepXCollectionImpl25addRepXObjectToCollectionERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_23PxRepXInstantiationArgsE, _wcwidth: _wcwidth, __ZN5physx3Cct13BoxController16setContactOffsetEf: __ZN5physx3Cct13BoxController16setContactOffsetEf, __Z43ParticleSystem_ShapeModule_CUSTOM_GetRadiusP12Il2CppObject: __Z43ParticleSystem_ShapeModule_CUSTOM_GetRadiusP12Il2CppObject, __ZN13CameraLODData5ClearEv: __ZN13CameraLODData5ClearEv, __ZN6prcoreL10inner_flipILj2EEEvPhS1_j: __ZN6prcoreL10inner_flipILj2EEEvPhS1_j, __ZN5Unity5Joint15ThreadedCleanupEv: __ZN5Unity5Joint15ThreadedCleanupEv, __ZN2UI6Canvas9SyncDepthEv: __ZN2UI6Canvas9SyncDepthEv, __ZNSt3__212strstreambufC2EPaiS1_: __ZNSt3__212strstreambufC2EPaiS1_, __ZNK14Texture2DArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK14Texture2DArray16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, _UNITY_png_text_compress: _UNITY_png_text_compress, __ZNSt3__29__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE: __ZNSt3__29__num_putIwE23__widen_and_group_floatEPcS2_S2_PwRS3_S4_RKNS_6localeE, __ZN12_GLOBAL__N_110DataStream12disableCacheEv: __ZN12_GLOBAL__N_110DataStream12disableCacheEv, __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIbEEvRT_PKc17TransferMetaFlags, __Z16jpeg_memory_destP20jpeg_compress_structPhiPi: __Z16jpeg_memory_destP20jpeg_compress_structPhiPi, __ZN5physx6shdfnd6Socket5writeEPKhj: __ZN5physx6shdfnd6Socket5writeEPKhj, __ZN4FMOD13ChannelGroupI9setVolumeEf: __ZN4FMOD13ChannelGroupI9setVolumeEf, __GLOBAL__sub_I_runtime_audio_lump_cpp: __GLOBAL__sub_I_runtime_audio_lump_cpp, __ZN8VRDevice17SendVRDeviceEventEjj: __ZN8VRDevice17SendVRDeviceEventEjj, __Z40Register_UnityEngine_Compass_set_enabledv: __Z40Register_UnityEngine_Compass_set_enabledv, __ZN4UNET16ScriptingUpdater16PlayerLoopUpdateEv: __ZN4UNET16ScriptingUpdater16PlayerLoopUpdateEv, __ZN5physx19updateCachedHitDataEPKjPKNS_6PxVec4EPKfS6_PNS_23PxVehicleWheels4DynDataE: __ZN5physx19updateCachedHitDataEPKjPKNS_6PxVec4EPKfS6_PNS_23PxVehicleWheels4DynDataE, __ZN4gles16AddForceCullModeER15DeviceStateGLESPK17DeviceRasterState8CullMode: __ZN4gles16AddForceCullModeER15DeviceStateGLESPK17DeviceRasterState8CullMode, __ZN11TimeManager16CheckConsistencyEv: __ZN11TimeManager16CheckConsistencyEv, __ZN13TargetJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13TargetJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb: __ZN5physx3Scb5Scene12addRigidBodyERNS0_4BodyEb, __ZN19CharacterController23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN19CharacterController23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__28ios_base15sync_with_stdioEb: __ZNSt3__28ios_base15sync_with_stdioEb, __Z25ExtractAllTerrainsInSceneR13dynamic_arrayIP7TerrainLj4EE: __Z25ExtractAllTerrainsInSceneR13dynamic_arrayIP7TerrainLj4EE, __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv, __ZN21GfxDeviceAsyncCommand10ArgScratch15ThreadedCleanupEv: __ZN21GfxDeviceAsyncCommand10ArgScratch15ThreadedCleanupEv, __ZN11GPUProfiler13GPUTimeSampleEv: __ZN11GPUProfiler13GPUTimeSampleEv, _fsetpos: _fsetpos, __ZN4Mesh16SetChannelsDirtyEjb: __ZN4Mesh16SetChannelsDirtyEjb, __Z14DoubleToStringd: __Z14DoubleToStringd, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion: __ZL19CheckForRightSpliceP14TESStesselatorP12ActiveRegion, __Z27setPxHeightFieldDescSamplesPN5physx17PxHeightFieldDescENS_13PxStridedDataE: __Z27setPxHeightFieldDescSamplesPN5physx17PxHeightFieldDescENS_13PxStridedDataE, __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_: __ZN14qsort_internal18_MedianOfThreeSwapIP18RPDataMotionVectorN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_S5_T0_, __Z20RegisterModule_Audiov: __Z20RegisterModule_Audiov, __ZN7Joint2DD2Ev: __ZN7Joint2DD2Ev, __Z47QualitySettings_Set_Custom_PropShadowResolutionN15QualitySettings16ShadowResolutionE: __Z47QualitySettings_Set_Custom_PropShadowResolutionN15QualitySettings16ShadowResolutionE, __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE: __ZNK5physx2Gu17ShrunkConvexHullV10planeShiftEjRKNS_6shdfnd3aos6FloatVE, __ZN5physx2GuL35fullContactsGenerationCapsuleConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVESE_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb: __ZN5physx2GuL35fullContactsGenerationCapsuleConvexERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVESE_PNS0_17PersistentContactERjRNS0_13ContactBufferEbRNS0_25PersistentContactManifoldERNS8_5Vec3VERKNS8_6FloatVEb, __ZNK5physx14PxArticulation19getConcreteTypeNameEv: __ZNK5physx14PxArticulation19getConcreteTypeNameEv, __ZNK13TranslateGLES13BlendEquationE7BlendOp: __ZNK13TranslateGLES13BlendEquationE7BlendOp, __ZN3MBP17populateNewRegionERK5IAABB: __ZN3MBP17populateNewRegionERK5IAABB, __Z39Material_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f: __Z39Material_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f, __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_: __ZN7ApiGLES17DeleteFramebufferERN2gl6HandleILNS0_10ObjectTypeE9EEES3_, __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j: __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEEEEjT_j, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetYMultiplierv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv, __ZN17AudioChorusFilter8TransferI14SafeBinaryReadEEvRT_: __ZN17AudioChorusFilter8TransferI14SafeBinaryReadEEvRT_, _isatty: _isatty, __ZN4FMOD7Channel19set3DDistanceFilterEbff: __ZN4FMOD7Channel19set3DDistanceFilterEbff, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetYv, _start_pass_upsample: _start_pass_upsample, __ZN11UnityEngine15CloudWebService17SessionEventQueue19GetEventsAsJsonDataEjR8UnityStrPj: __ZN11UnityEngine15CloudWebService17SessionEventQueue19GetEventsAsJsonDataEjR8UnityStrPj, _wprintf_core: _wprintf_core, __ZN19MeshParticleEmitter15InitializeClassEv: __ZN19MeshParticleEmitter15InitializeClassEv, _jsimd_can_rgb_ycc: _jsimd_can_rgb_ycc, __ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z48Physics2D_CUSTOM_INTERNAL_get_colliderAwakeColorP10ColorRGBAf: __Z48Physics2D_CUSTOM_INTERNAL_get_colliderAwakeColorP10ColorRGBAf, __Z35Transform_Set_Custom_PropHasChangedP12Il2CppObjecth: __Z35Transform_Set_Custom_PropHasChangedP12Il2CppObjecth, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE19getConcreteTypeNameEv, __Z18SkinGenericMathLibILi4ELb1ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi4ELb1ELb0EEvR12SkinMeshInfo, __ZN7mecanim12statemachine26CreateStateMachineConstantEPPNS0_13StateConstantEjjPPNS0_18TransitionConstantEjPPNS0_21SelectorStateConstantEjjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine26CreateStateMachineConstantEPPNS0_13StateConstantEjjPPNS0_18TransitionConstantEjPPNS0_21SelectorStateConstantEjjRNS_6memory9AllocatorE, __Z42Material_CUSTOM_CopyPropertiesFromMaterialP12Il2CppObjectS0_: __Z42Material_CUSTOM_CopyPropertiesFromMaterialP12Il2CppObjectS0_, __ZNK5physx3Cct17CapsuleController14getUpDirectionEv: __ZNK5physx3Cct17CapsuleController14getUpDirectionEv, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn18RepXCollectionItemENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z35Rigidbody_Get_Custom_PropUseGravityP12Il2CppObject: __Z35Rigidbody_Get_Custom_PropUseGravityP12Il2CppObject, __Z50Register_UnityEngine_GUI_INTERNAL_get_contentColorv: __Z50Register_UnityEngine_GUI_INTERNAL_get_contentColorv, __Z11raycast_boxRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z11raycast_boxRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, _Bezier_Up: _Bezier_Up, __ZN31CollisionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN31CollisionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN7mecanim23SetupValueArrayConstantEPNS_18ValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE: __ZN7mecanim23SetupValueArrayConstantEPNS_18ValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwjj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwjj, __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _link: _link, __ZN9TextAsset8TransferI17RemapPPtrTransferEEvRT_: __ZN9TextAsset8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z38AndroidJNI_CUSTOM_GetShortArrayElement13Il2Cpp_IntPtri: __Z38AndroidJNI_CUSTOM_GetShortArrayElement13Il2Cpp_IntPtri, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5cloneEv: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl5cloneEv, __ZN4FMOD8ChannelI13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_: __ZN4FMOD8ChannelI13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN17PersistentManager26GetLoadedInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE: __ZN17PersistentManager26GetLoadedInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE, __ZNK12b2WheelJoint16GetReactionForceEf: __ZNK12b2WheelJoint16GetReactionForceEf, __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii: __Z13GetImagePixelI10ColorRGBAfET_PKhii13TextureFormat15TextureWrapModeii, __ZN4FMOD7Channel17get3DDopplerLevelEPf: __ZN4FMOD7Channel17get3DDopplerLevelEPf, __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeEPP15Il2CppExceptionb, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEvPT_jRKT0_RKT1_j, __ZN14PlayerSettings20SetMacFullscreenModeEi: __ZN14PlayerSettings20SetMacFullscreenModeEi, __ZN7SubMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7SubMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN21AssetBundleFileSystem4NameEv: __ZN21AssetBundleFileSystem4NameEv, __ZN5physx2Gu14sweepBoxSphereERKNS0_3BoxEfRKNS_6PxVec3ES6_fRfRS4_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu14sweepBoxSphereERKNS0_3BoxEfRKNS_6PxVec3ES6_fRfRS4_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZN15SharedLightData17MainThreadCleanupEv: __ZN15SharedLightData17MainThreadCleanupEv, __ZN6Object15SetupWeakHandleEv: __ZN6Object15SetupWeakHandleEv, __ZN5physx14PxRigidBodyExt18addLocalForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb: __ZN5physx14PxRigidBodyExt18addLocalForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb, __ZNK7Terrain23TryGetSplatBaseMaterialEv: __ZNK7Terrain23TryGetSplatBaseMaterialEv, _vstrfmon_l: _vstrfmon_l, __ZNK11TerrainData7HasUserEP10GameObject: __ZNK11TerrainData7HasUserEP10GameObject, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags, __ZN5physx2Sn27getCompatibilityVersionsStrEPcj: __ZN5physx2Sn27getCompatibilityVersionsStrEPcj, __ZN5physx2Cm17FreeListAllocatorD0Ev: __ZN5physx2Cm17FreeListAllocatorD0Ev, __ZN13TargetJoint2D9SetAnchorERK8Vector2f: __ZN13TargetJoint2D9SetAnchorERK8Vector2f, __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastNonAllocv: __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastNonAllocv, __ZN7b2World12DestroyJointEP7b2Joint: __ZN7b2World12DestroyJointEP7b2Joint, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN13ComputeShader17CreateRuntimeDataEv: __ZN13ComputeShader17CreateRuntimeDataEv, __ZN5IMGUI8GUILabelER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle: __ZN5IMGUI8GUILabelER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle, __ZmiRK8Scalar4fS1_: __ZmiRK8Scalar4fS1_, __Z36AndroidJNI_CUSTOM_GetStaticByteField13Il2Cpp_IntPtrS_: __Z36AndroidJNI_CUSTOM_GetStaticByteField13Il2Cpp_IntPtrS_, __ZN11UnityEngine15CloudWebService19SessionEventManager26ProcessEventQueueJobStaticEPv: __ZN11UnityEngine15CloudWebService19SessionEventManager26ProcessEventQueueJobStaticEPv, __Z31ComputeShader_CUSTOM_FindKernelP12Il2CppObjectP12Il2CppString: __Z31ComputeShader_CUSTOM_FindKernelP12Il2CppObjectP12Il2CppString, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj174ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _UNITY_png_init_io: _UNITY_png_init_io, __ZN12FixedJoint2D7CleanupEb: __ZN12FixedJoint2D7CleanupEb, __Z27Input_Get_Custom_PropAnyKeyv: __Z27Input_Get_Custom_PropAnyKeyv, __Z35ComputeBuffer_Get_Custom_PropStrideP12Il2CppObject: __Z35ComputeBuffer_Get_Custom_PropStrideP12Il2CppObject, __ZNSt3__29__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE: __ZNSt3__29__num_putIcE23__widen_and_group_floatEPcS2_S2_S2_RS2_S3_RKNS_6localeE, __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe: __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe, __Z40Register_UnityEngine_TextMesh_set_anchorv: __Z40Register_UnityEngine_TextMesh_set_anchorv, _do_nftw: _do_nftw, __ZN5physx16PxsSolverEndTaskD0Ev: __ZN5physx16PxsSolverEndTaskD0Ev, __ZL19empty_output_bufferP20jpeg_compress_struct: __ZL19empty_output_bufferP20jpeg_compress_struct, __Z31CreateMissingGlobalGameManagersv: __Z31CreateMissingGlobalGameManagersv, __ZNK12NavMeshAgent11GetAreaCostEj: __ZNK12NavMeshAgent11GetAreaCostEj, __ZNK5physx9PxTaskMgr16getSpuDispatcherEv: __ZNK5physx9PxTaskMgr16getSpuDispatcherEv, __ZN15ParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15ParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb, __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEED0Ev, _unzGetLocalExtrafield: _unzGetLocalExtrafield, __ZN20QuadTreeNodeRenderer13StaticDestroyEPv: __ZN20QuadTreeNodeRenderer13StaticDestroyEPv, __ZL26RegisterModuleICalls_IMGUIv: __ZL26RegisterModuleICalls_IMGUIv, __ZN5physx7NpCloth21removeCollisionSphereEj: __ZN5physx7NpCloth21removeCollisionSphereEj, __Z35ParticleEmitter_Get_Custom_PropEmitP12Il2CppObject: __Z35ParticleEmitter_Get_Custom_PropEmitP12Il2CppObject, _iswpunct_l: _iswpunct_l, __ZN19MeshParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN19MeshParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN10builtintex15GetWhiteTextureEv: __ZN10builtintex15GetWhiteTextureEv, __Z42RenderTexture_CUSTOM_Internal_SetDimensionP12Il2CppObject16TextureDimension: __Z42RenderTexture_CUSTOM_Internal_SetDimensionP12Il2CppObject16TextureDimension, __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipEiRNS_6memory9AllocatorE: __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipEiRNS_6memory9AllocatorE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEE14handleAccessorILj681ENS_22PxRepXPropertyAccessorILj681ES4_KNS_30PxVehicleDriveTankControlModel4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEE14handleAccessorILj681ENS_22PxRepXPropertyAccessorILj681ES4_KNS_30PxVehicleDriveTankControlModel4EnumESA_EEEEvRKT0_, __ZN7mecanim12statemachine13GetStateIndexEPKNS0_20StateMachineConstantEj: __ZN7mecanim12statemachine13GetStateIndexEPKNS0_20StateMachineConstantEj, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__218__insertion_sort_3IRNS_6__lessIjjEEPjEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIjjEEPjEEvT0_S5_T_, __Z29GetOcclusionPortalManagerListv: __Z29GetOcclusionPortalManagerListv, __Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18IsDirectoryCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z39Register_UnityEngine_Sprite_get_texturev: __Z39Register_UnityEngine_Sprite_get_texturev, __ZThn32_N17BillboardRenderer19UpdateTransformInfoEv: __ZThn32_N17BillboardRenderer19UpdateTransformInfoEv, _UnityReplayKitSetCameraEnabled: _UnityReplayKitSetCameraEnabled, __ZN16CircleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16CircleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN13SpeedTreeWind16SBranchWindLevel8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SpeedTreeWind16SBranchWindLevel8TransferI24GenerateTypeTreeTransferEEvRT_, __Z48Register_UnityEngine_Graphics_Internal_SetNullRTv: __Z48Register_UnityEngine_Graphics_Internal_SetNullRTv, __ZN5physx25PxVehicleConstraintShader19onConstraintReleaseEv: __ZN5physx25PxVehicleConstraintShader19onConstraintReleaseEv, __Z35getPxVehicleDifferential4WDataMTypePKN5physx27PxVehicleDifferential4WDataE: __Z35getPxVehicleDifferential4WDataMTypePKN5physx27PxVehicleDifferential4WDataE, __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_S5_T_, __ZN9AudioClip7WWWSeekEPvjS0_: __ZN9AudioClip7WWWSeekEPvjS0_, __ZN5physx2Sc15ArticulationSimD2Ev: __ZN5physx2Sc15ArticulationSimD2Ev, __ZN13GfxDeviceGLES15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij: __ZN13GfxDeviceGLES15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij, __ZN11OffMeshLink16OnNavMeshCleanupEv: __ZN11OffMeshLink16OnNavMeshCleanupEv, __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthZP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthZP12Il2CppObjectR15MonoMinMaxCurve, __ZL32StaticInitializeIUnityInterfacesPv: __ZL32StaticInitializeIUnityInterfacesPv, __ZN11UnityEngine9Animation18CreateAvatarTQSMapEPKN7mecanim9animation14AvatarConstantERKNS0_20AnimationSetBindingsERNS1_6memory9AllocatorE: __ZN11UnityEngine9Animation18CreateAvatarTQSMapEPKN7mecanim9animation14AvatarConstantERKNS0_20AnimationSetBindingsERNS1_6memory9AllocatorE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv, __ZNK13TranslateGLES13GetFormatGLESEj: __ZNK13TranslateGLES13GetFormatGLESEj, __Z14GetOrientationv: __Z14GetOrientationv, __Z13CameraProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b: __Z13CameraProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b, __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z22CreateMutexLockedStackv: __Z22CreateMutexLockedStackv, __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_: __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_, __ZL36PostLoadSceneStatic_LightmapSettingsiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZL36PostLoadSceneStatic_LightmapSettingsiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, ___statfs: ___statfs, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv, __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_: __ZNSt3__27__sort5IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_S7_S7_T_, __ZNSt3__210__stdinbufIwE9underflowEv: __ZNSt3__210__stdinbufIwE9underflowEv, __ZN10SampleClipC2E10MemLabelId18ObjectCreationMode: __ZN10SampleClipC2E10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEE15growAndPushBackERKS2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z17RegisterModule_UIv: __Z17RegisterModule_UIv, __ZN15EditorExtension15ThreadedCleanupEv: __ZN15EditorExtension15ThreadedCleanupEv, __ZN11AssetBundleD2Ev: __ZN11AssetBundleD2Ev, __ZNK5physx15PxsArticulation11checkLimitsEv: __ZNK5physx15PxsArticulation11checkLimitsEv, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYMultiplierv, __Z19GetSpecificGUIStatei: __Z19GetSpecificGUIStatei, __ZN12_GLOBAL__N_16ParserILb0EED2Ev: __ZN12_GLOBAL__N_16ParserILb0EED2Ev, __ZN7mecanim10ValueArray8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim10ValueArray8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__26vectorINS_4pairIb4PPtrI10GUIElementEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_: __ZNSt3__26vectorINS_4pairIb4PPtrI10GUIElementEEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_, __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp: __ZN19ScriptingInvocationC2E21ScriptingMethodIl2Cpp, __Z50Register_UnityEngine_Camera_set_layerCullSphericalv: __Z50Register_UnityEngine_Camera_set_layerCullSphericalv, __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12createObjectERPhRNS_24PxDeserializationContextE, __Z54Register_UnityEngine_Avatar_INTERNAL_CALL_GetLimitSignv: __Z54Register_UnityEngine_Avatar_INTERNAL_CALL_GetLimitSignv, __Z44Register_UnityEngine_Compass_get_trueHeadingv: __Z44Register_UnityEngine_Compass_get_trueHeadingv, _UNITY_FT_Init_Class_tt_service_get_cmap_info: _UNITY_FT_Init_Class_tt_service_get_cmap_info, __ZN21DownloadHandlerScript23OnUnbindScriptingObjectEv: __ZN21DownloadHandlerScript23OnUnbindScriptingObjectEv, __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority: __Z19ScheduleJobInternalR8JobFencePFvPvES1_11JobPriority, __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN22BuiltinResourceManager19DestroyAllResourcesEv: __ZN22BuiltinResourceManager19DestroyAllResourcesEv, __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE11getTypeNameEv, __ZNK9ShaderLab9IntShader14GetRenderQueueEi: __ZNK9ShaderLab9IntShader14GetRenderQueueEi, __ZNSt3__211__libcpp_db9__erase_iEPv: __ZNSt3__211__libcpp_db9__erase_iEPv, __ZN13FileEntryDataaSERKS_: __ZN13FileEntryDataaSERKS_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj6ES3_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj6ES3_NS_7PxFlagsINS_14PxMaterialFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z32LODGroup_Get_Custom_PropLodCountP12Il2CppObject: __Z32LODGroup_Get_Custom_PropLodCountP12Il2CppObject, __Z51Register_UnityEngine_LightmapSettings_set_lightmapsv: __Z51Register_UnityEngine_LightmapSettings_set_lightmapsv, __ZN13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EE6insertEPS0_PKS0_S4_, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __Z45GUIElement_CUSTOM_INTERNAL_CALL_GetScreenRectP12Il2CppObjectS0_R5RectTIfE: __Z45GUIElement_CUSTOM_INTERNAL_CALL_GetScreenRectP12Il2CppObjectS0_R5RectTIfE, __ZN5audio5mixerL32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRKNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEiRNS6_6vectorI9UnityGUIDNSA_ISG_EEEE: __ZN5audio5mixerL32GetGroupGUIDsContainingSubStringERKNS0_18AudioMixerConstantEPKcRKNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEiRNS6_6vectorI9UnityGUIDNSA_ISG_EEEE, __Z42AudioListener_CUSTOM_GetSpectrumDataHelperP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW: __Z42AudioListener_CUSTOM_GetSpectrumDataHelperP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __ZNK5Umbra9Matrix4x38getScaleEv: __ZNK5Umbra9Matrix4x38getScaleEv, __Z35Sprite_Get_Custom_PropPixelsPerUnitP12Il2CppObject: __Z35Sprite_Get_Custom_PropPixelsPerUnitP12Il2CppObject, __ZN4FMOD8ChannelI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD8ChannelI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv: __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv, __Z55SkinnedMeshRenderer_Get_Custom_PropSkinnedMotionVectorsP12Il2CppObject: __Z55SkinnedMeshRenderer_Get_Custom_PropSkinnedMotionVectorsP12Il2CppObject, __Z46Register_UnityEngine_Animation_get_cullingTypev: __Z46Register_UnityEngine_Animation_get_cullingTypev, __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockEv: __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockEv, __ZN11PreloadDataD2Ev: __ZN11PreloadDataD2Ev, __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerEj: __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerEj, __Z48Register_UnityEngine_BillboardAsset_get_materialv: __Z48Register_UnityEngine_BillboardAsset_get_materialv, __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_: __ZN5physx2Gu31SinglePersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_, __ZN18DownloadHandlerVFSD0Ev: __ZN18DownloadHandlerVFSD0Ev, __ZN11NavMeshData7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11NavMeshData7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK16b2PrismaticJoint16GetReactionForceEf: __ZNK16b2PrismaticJoint16GetReactionForceEf, __ZN18CrashReportHandler10SendReportER16CrashReportEvent: __ZN18CrashReportHandler10SendReportER16CrashReportEvent, __Z36Register_UnityEngine_Light_get_flarev: __Z36Register_UnityEngine_Light_get_flarev, __ZN3WWW8GetErrorEv: __ZN3WWW8GetErrorEv, __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx7NpScene15getRenderBufferEv: __ZN5physx7NpScene15getRenderBufferEv, __Z51LightmapSettings_Set_Custom_PropLightmapsModeLegacyi: __Z51LightmapSettings_Set_Custom_PropLightmapsModeLegacyi, __ZNK5Unity10HingeJoint11GetVelocityEv: __ZNK5Unity10HingeJoint11GetVelocityEv, __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN15SharedLightData15UpdateTransformERK9Transform: __ZN15SharedLightData15UpdateTransformERK9Transform, _UNITY_FT_Init_Class_pscmaps_interface: _UNITY_FT_Init_Class_pscmaps_interface, __Z51ParticleSystem_MainModule_CUSTOM_SetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve: __Z51ParticleSystem_MainModule_CUSTOM_SetGravityModifierP12Il2CppObjectR15MonoMinMaxCurve, __ZN16ParticleRenderer15ThreadedCleanupEv: __ZN16ParticleRenderer15ThreadedCleanupEv, __ZN14NavMeshManager7AddTileEPhii: __ZN14NavMeshManager7AddTileEPhii, __ZNK17AnimationPlayable8GetAssetEv: __ZNK17AnimationPlayable8GetAssetEv, __ZN18AssetBundleManagerD2Ev: __ZN18AssetBundleManagerD2Ev, __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f: __ZN6Camera25SetStereoProjectionMatrixE15StereoscopicEyeRK10Matrix4x4f, __Z51Register_UnityEngine_Camera_SetTargetBuffersMRTImplv: __Z51Register_UnityEngine_Camera_SetTargetBuffersMRTImplv, __ZN14SpriteRenderer15SetupPropertiesER19ShaderPropertySheetRK16SpriteRenderData: __ZN14SpriteRenderer15SetupPropertiesER19ShaderPropertySheetRK16SpriteRenderData, __ZN13WebCamTexture16EnsureUniqueNameER16MonoWebCamDeviceRKNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier56ELi16EEEE: __ZN13WebCamTexture16EnsureUniqueNameER16MonoWebCamDeviceRKNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier56ELi16EEEE, __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv: __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv, __Z54NavMeshObstacle_Get_Custom_PropCarvingTimeToStationaryP12Il2CppObject: __Z54NavMeshObstacle_Get_Custom_PropCarvingTimeToStationaryP12Il2CppObject, __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7reserveEj: __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE7reserveEj, __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject: __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_GetEnabledP12Il2CppObject, __Z44Register_UnityEngine_RectOffset_get_verticalv: __Z44Register_UnityEngine_RectOffset_get_verticalv, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetYMultiplierP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getRelativeTransformEv, __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity9Component8TransferI14SafeBinaryReadEEvRT_, __Z48Camera_CUSTOM_INTERNAL_CALL_WorldToViewportPointP12Il2CppObjectRK8Vector3fRS1_: __Z48Camera_CUSTOM_INTERNAL_CALL_WorldToViewportPointP12Il2CppObjectRK8Vector3fRS1_, __ZN10SampleClip7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10SampleClip7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK15PointEffector2D26GetTypeInfoVirtualInternalEv: __ZNK15PointEffector2D26GetTypeInfoVirtualInternalEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E, __Z36RenderTexture_CUSTOM_DiscardContentsP12Il2CppObjecthh: __Z36RenderTexture_CUSTOM_DiscardContentsP12Il2CppObjecthh, __Z24RegisterStrippedTypeInfoIN5Unity14CharacterJointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity14CharacterJointEEviPKcS3_, __ZNKSt3__215__codecvt_utf16IDsLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IDsLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_, __Z50Register_UnityEngine_Graphics_Internal_SetRTSimplev: __Z50Register_UnityEngine_Graphics_Internal_SetRTSimplev, __ZN19TouchPhaseEmulation19UpdateActiveTouchesEv: __ZN19TouchPhaseEmulation19UpdateActiveTouchesEv, __Z61Register_UnityEngine_Terrain_INTERNAL_get_lightmapScaleOffsetv: __Z61Register_UnityEngine_Terrain_INTERNAL_get_lightmapScaleOffsetv, __Z39Terrain_Set_Custom_PropMaterialTemplateP12Il2CppObjectS0_: __Z39Terrain_Set_Custom_PropMaterialTemplateP12Il2CppObjectS0_, __ZN10HttpHelper24IsCommentAllowedInHeaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN10HttpHelper24IsCommentAllowedInHeaderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN8GUIState20FocusKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8GUIState20FocusKeyboardControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE, __Z12SetIVRDeviceP9IVRDevice: __Z12SetIVRDeviceP9IVRDevice, __Z34GUIStyle_Get_Custom_PropFixedWidthP12Il2CppObject: __Z34GUIStyle_Get_Custom_PropFixedWidthP12Il2CppObject, __Z35AnimationState_Set_Custom_PropSpeedP12Il2CppObjectf: __Z35AnimationState_Set_Custom_PropSpeedP12Il2CppObjectf, _UNITY_png_app_error: _UNITY_png_app_error, __Z36RegisterModuleClasses_ParticleSystemv: __Z36RegisterModuleClasses_ParticleSystemv, __ZN5physx2Sc19ShapeInstancePairLL10onActivateEj: __ZN5physx2Sc19ShapeInstancePairLL10onActivateEj, __ZN8Renderer17UpdateSceneHandleEv: __ZN8Renderer17UpdateSceneHandleEv, __ZN13EmscriptenWWW23HasDownloadedOrMayBlockEv: __ZN13EmscriptenWWW23HasDownloadedOrMayBlockEv, __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR11NodeXSorterP16HeightMeshBVNodeEEvT0_S5_T_, __ZN9GfxDevice16DrawNullGeometryE16GfxPrimitiveTypeii: __ZN9GfxDevice16DrawNullGeometryE16GfxPrimitiveTypeii, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZNK10GameObject23QueryComponentTransformEv: __ZNK10GameObject23QueryComponentTransformEv, __Z29StdTemplateConversionFunctionItyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItyEbPvR14SafeBinaryRead, __ZN14b2PolygonShape8SetAsBoxEffRK6b2Vec2f: __ZN14b2PolygonShape8SetAsBoxEffRK6b2Vec2f, __Z32LineRenderer_CUSTOM_SetPositionsP12Il2CppObjectP11Il2CppArray: __Z32LineRenderer_CUSTOM_SetPositionsP12Il2CppObjectP11Il2CppArray, __Z35getPxParticleReadDataVelocityBufferPKN5physx18PxParticleReadDataE: __Z35getPxParticleReadDataVelocityBufferPKN5physx18PxParticleReadDataE, __ZL26InitializeModule_Physics2Dv: __ZL26InitializeModule_Physics2Dv, __GLOBAL__sub_I_runtime_utilities3_lump_cpp: __GLOBAL__sub_I_runtime_utilities3_lump_cpp, __ZN9GfxDevice15BeginFrameStatsEv: __ZN9GfxDevice15BeginFrameStatsEv, __ZNSt3__217moneypunct_bynameIcLb0EED2Ev: __ZNSt3__217moneypunct_bynameIcLb0EED2Ev, __ZN5physx11EdgeManagerD0Ev: __ZN5physx11EdgeManagerD0Ev, __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES: __ZN4gles20EnsureTextureCreatedEP7ApiGLESP17RenderSurfaceGLES, __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData: __ZN15ReplacementPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __Z32AudioMeasurement_GetTimeConstantff: __Z32AudioMeasurement_GetTimeConstantff, __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferential4WDataEE8pushNameEPKc, __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED2Ev, __ZN2UIL20AddRenderersToCanvasER8JobFencePK9TransformPNS_6CanvasERi: __ZN2UIL20AddRenderersToCanvasER8JobFencePK9TransformPNS_6CanvasERi, __ZNK11b2GearJoint8GetRatioEv: __ZNK11b2GearJoint8GetRatioEv, __ZN7mecanim9animation21CreateControllerInputEPKNS0_18ControllerConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation21CreateControllerInputEPKNS0_18ControllerConstantERNS_6memory9AllocatorE, __ZN5physx3Ext14PrismaticJoint29setProjectionAngularToleranceEf: __ZN5physx3Ext14PrismaticJoint29setProjectionAngularToleranceEf, __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN13GfxDeviceGLESD2Ev: __ZN13GfxDeviceGLESD2Ev, __ZN14AreaEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14AreaEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z24Material_CUSTOM_FindPassP12Il2CppObjectP12Il2CppString: __Z24Material_CUSTOM_FindPassP12Il2CppObjectP12Il2CppString, __ZN18AsyncUploadManager13StaticDestroyEPv: __ZN18AsyncUploadManager13StaticDestroyEPv, __Z25UnloadGameObjectHierarchyR10GameObject: __Z25UnloadGameObjectHierarchyR10GameObject, __ZNK18CrashReportManager26GetTypeInfoVirtualInternalEv: __ZNK18CrashReportManager26GetTypeInfoVirtualInternalEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv, __ZN16Physics2DManager26GetGameObjectForRaycastHitERK12RaycastHit2D: __ZN16Physics2DManager26GetGameObjectForRaycastHitERK12RaycastHit2D, __ZN11UnityEngine15CloudWebService16SessionContainer25GetSessionHeaderJsonArrayERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN11UnityEngine15CloudWebService16SessionContainer25GetSessionHeaderJsonArrayERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZN19ShaderPropertySheet14LerpPropertiesERKS_S1_f: __ZN19ShaderPropertySheet14LerpPropertiesERKS_S1_f, __ZL27SetupActiveDirectionalLightRK5LightR11ActiveLight: __ZL27SetupActiveDirectionalLightRK5LightR11ActiveLight, __ZN6Shader7SetNameEPKc: __ZN6Shader7SetNameEPKc, __Z62Register_UnityEngine_AI_NavMeshAgent_get_obstacleAvoidanceTypev: __Z62Register_UnityEngine_AI_NavMeshAgent_get_obstacleAvoidanceTypev, __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcRNS_6vectorIS5_NS3_IS5_EEEEi: __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcRNS_6vectorIS5_NS3_IS5_EEEEi, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ES2_RKNS_19PxVehicleEngineDataES6_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ES2_RKNS_19PxVehicleEngineDataES6_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx8debugger18MemPvdOutputStream5writeEPKhj: __ZN5physx8debugger18MemPvdOutputStream5writeEPKhj, __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityv: __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityv, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN4FMOD12ChannelGroup7setMuteEb: __ZN4FMOD12ChannelGroup7setMuteEb, __Z43ParticleSystem_Set_Custom_PropStartLifetimeP12Il2CppObjectf: __Z43ParticleSystem_Set_Custom_PropStartLifetimeP12Il2CppObjectf, __Z50WheelCollider_CUSTOM_INTERNAL_get_suspensionSpringP12Il2CppObjectP11JointSpring: __Z50WheelCollider_CUSTOM_INTERNAL_get_suspensionSpringP12Il2CppObjectP11JointSpring, __ZN12NavMeshAgent9ResetPathEv: __ZN12NavMeshAgent9ResetPathEv, __Z13RegisterClassI19MeshParticleEmitterEvv: __Z13RegisterClassI19MeshParticleEmitterEvv, __ZN13WheelCollider6CreateEPK9Rigidbody: __ZN13WheelCollider6CreateEPK9Rigidbody, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEE15growAndPushBackERKS2_, __ZN5Umbra11checkStatusEPKNS_7ImpTomeEb: __ZN5Umbra11checkStatusEPKNS_7ImpTomeEb, __ZN8Animator22PrepareAnimationEventsEv: __ZN8Animator22PrepareAnimationEventsEv, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessImmEEPmEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessImmEEPmEEbT0_S5_T_, __ZN23ShaderVariantCollection11VariantInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN23ShaderVariantCollection11VariantInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS5_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z36FindComponentInGameObjectOrAncestorsR10GameObjecti: __Z36FindComponentInGameObjectOrAncestorsR10GameObjecti, __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetRandomizedP12Il2CppObject: __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetRandomizedP12Il2CppObject, __ZN5physx2Sc8ClothSim18addCollisionConvexEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim18addCollisionConvexEPKNS0_8ShapeSimE, __Z36Register_UnityEngine_Material_GetTagv: __Z36Register_UnityEngine_Material_GetTagv, __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye: __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf21MonoOrStereoscopicEye, __Z24GetManagerPtrFromContexti: __Z24GetManagerPtrFromContexti, __Z37CapsuleCollider_Get_Custom_PropRadiusP12Il2CppObject: __Z37CapsuleCollider_Get_Custom_PropRadiusP12Il2CppObject, _Direct_Move_Y: _Direct_Move_Y, __ZN21AnimationClipPlayable6MemoryD0Ev: __ZN21AnimationClipPlayable6MemoryD0Ev, __Z22scripting_gchandle_newP12Il2CppObject: __Z22scripting_gchandle_newP12Il2CppObject, __ZNKSt3__210moneypunctIwLb0EE13negative_signEv: __ZNKSt3__210moneypunctIwLb0EE13negative_signEv, __ZN19SkinnedMeshRenderer7GetMeshEv: __ZN19SkinnedMeshRenderer7GetMeshEv, __ZN9Rigidbody16TransformChangedEi: __ZN9Rigidbody16TransformChangedEi, __ZN19RuntimeSceneManager14GetActiveSceneEv: __ZN19RuntimeSceneManager14GetActiveSceneEv, __ZN5physx3Ext10FixedJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext10FixedJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN16ParticleRenderer5ResetEv: __ZN16ParticleRenderer5ResetEv, _getint: _getint, _PxGetPhysics: _PxGetPhysics, __ZN15AABBTreeOverlapIN5physx2Gu14SphereAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE: __ZN15AABBTreeOverlapIN5physx2Gu14SphereAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE, __Z42Camera_Get_Custom_PropTransparencySortModeP12Il2CppObject: __Z42Camera_Get_Custom_PropTransparencySortModeP12Il2CppObject, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __Z29RectOffset_Set_Custom_PropTopP12Il2CppObjecti: __Z29RectOffset_Set_Custom_PropTopP12Il2CppObjecti, __ZNK14MemoryProfiler21ReportAllocatedMemoryEv: __ZNK14MemoryProfiler21ReportAllocatedMemoryEv, __ZN9shadertag16GetShaderTagNameEi: __ZN9shadertag16GetShaderTagNameEi, __ZN13SpringJoint2D16CheckConsistencyEv: __ZN13SpringJoint2D16CheckConsistencyEv, __Z57Register_UnityEngine_Transform_INTERNAL_get_localPositionv: __Z57Register_UnityEngine_Transform_INTERNAL_get_localPositionv, __ZNK7ApiGLES5CheckEjPKcjS1_: __ZNK7ApiGLES5CheckEjPKcjS1_, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3tieEv, __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_S6_T_, __Z41Physics2D_Set_Custom_PropMaxRotationSpeedf: __Z41Physics2D_Set_Custom_PropMaxRotationSpeedf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI19LightProbeOcclusionLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI19LightProbeOcclusionLj4EEEEvRT_17TransferMetaFlags, __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt16v: __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt16v, __ZN12_GLOBAL__N_110Connection16createDataStreamEv: __ZN12_GLOBAL__N_110Connection16createDataStreamEv, __Z44Terrain_Get_Custom_PropTreeBillboardDistanceP12Il2CppObject: __Z44Terrain_Get_Custom_PropTreeBillboardDistanceP12Il2CppObject, __Z52Register_UnityEngine_Audio_AudioMixer_get_updateModev: __Z52Register_UnityEngine_Audio_AudioMixer_get_updateModev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE14handleAccessorILj536ENS_22PxRepXPropertyAccessorILj536ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE14handleAccessorILj536ENS_22PxRepXPropertyAccessorILj536ES4_KffEEEEvRKT0_, __ZNK14SplatMaterials11HasSpecularEv: __ZNK14SplatMaterials11HasSpecularEv, __ZN4FMOD7Channel14setLowPassGainEf: __ZN4FMOD7Channel14setLowPassGainEf, __Z40Register_UnityEngine_Application_OpenURLv: __Z40Register_UnityEngine_Application_OpenURLv, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE9pbackfailEi, __ZN5physx16PxsBroadPhaseMBPD2Ev: __ZN5physx16PxsBroadPhaseMBPD2Ev, __ZN15RelativeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15RelativeJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx28PxVehicle4WEnable3WDeltaModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE: __ZN5physx28PxVehicle4WEnable3WDeltaModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE, __GLOBAL__sub_I_runtime_terrain_lump_cpp_3661: __GLOBAL__sub_I_runtime_terrain_lump_cpp_3661, __Z47Register_UnityEngine_RenderSettings_get_fogModev: __Z47Register_UnityEngine_RenderSettings_get_fogModev, __Z37AnimationClip_Set_Custom_PropWrapModeP12Il2CppObjecti: __Z37AnimationClip_Set_Custom_PropWrapModeP12Il2CppObjecti, __ZN22UnityWebRequestManager10UnregisterEP15UnityWebRequest: __ZN22UnityWebRequestManager10UnregisterEP15UnityWebRequest, __ZN13SpeedTreeWind16SBranchWindLevel8TransferI14SafeBinaryReadEEvRT_: __ZN13SpeedTreeWind16SBranchWindLevel8TransferI14SafeBinaryReadEEvRT_, __Z38Renderer_Get_Custom_PropUseLightProbesP12Il2CppObject: __Z38Renderer_Get_Custom_PropUseLightProbesP12Il2CppObject, __ZNK14NavMeshManager16TileDataConformsEPK11NavMeshData: __ZNK14NavMeshManager16TileDataConformsEPK11NavMeshData, __Z40Camera_Set_Custom_PropLayerCullDistancesP12Il2CppObjectP11Il2CppArray: __Z40Camera_Set_Custom_PropLayerCullDistancesP12Il2CppObjectP11Il2CppArray, __ZNK28RectTransformPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK28RectTransformPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj89ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj89ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z47Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f: __Z47Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f, __Z50Register_UnityEngine_DynamicGI_get_synchronousModev: __Z50Register_UnityEngine_DynamicGI_get_synchronousModev, __ZN5physx3Scb5Scene12addAggregateERNS0_9AggregateE: __ZN5physx3Scb5Scene12addAggregateERNS0_9AggregateE, _next_marker: _next_marker, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsputnEPKwi, __ZN4Mesh14UploadMeshDataEb: __ZN4Mesh14UploadMeshDataEb, __ZN5physx7NpScene9addActorsEPKPNS_7PxActorEj: __ZN5physx7NpScene9addActorsEPKPNS_7PxActorEj, __Z55Register_UnityEngine_Canvas_get_cachedSortingLayerValuev: __Z55Register_UnityEngine_Canvas_get_cachedSortingLayerValuev, __ZN5physx2Sc8ShapeSimD0Ev: __ZN5physx2Sc8ShapeSimD0Ev, __ZNKSt3__27codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_: __ZNKSt3__27codecvtIDic11__mbstate_tE10do_unshiftERS1_PcS4_RS4_, __ZN4FMOD7SystemI19getStreamBufferSizeEPjS1_: __ZN4FMOD7SystemI19getStreamBufferSizeEPjS1_, __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_: __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_, __ZN19AssetBundleManifest29GetAllAssetBundlesWithVariantERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE: __ZN19AssetBundleManifest29GetAllAssetBundlesWithVariantERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE, __ZN5Umbra9Matrix3x39transposeEv: __ZN5Umbra9Matrix3x39transposeEv, __Z43Register_UnityEngine_Canvas_set_worldCamerav: __Z43Register_UnityEngine_Canvas_set_worldCamerav, __ZN11TypeManager23CallPostInitializeTypesEv: __ZN11TypeManager23CallPostInitializeTypesEv, __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetPaddingP12Il2CppObjectR8Vector4f: __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetPaddingP12Il2CppObjectR8Vector4f, __Z61Register_UnityEngine_ConfigurableJoint_set_projectionDistancev: __Z61Register_UnityEngine_ConfigurableJoint_set_projectionDistancev, __ZN9GfxDevice15ImmediateNormalEfff: __ZN9GfxDevice15ImmediateNormalEfff, __ZN5physx7NpActor7releaseERNS_7PxActorE: __ZN5physx7NpActor7releaseERNS_7PxActorE, __Z52Register_UnityEngine_Input_INTERNAL_get_accelerationv: __Z52Register_UnityEngine_Input_INTERNAL_get_accelerationv, __ZN5physx3Ext18computeCapsuleMassEfff: __ZN5physx3Ext18computeCapsuleMassEfff, __ZN20SoundChannelInstance19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES: __ZN20SoundChannelInstance19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES, __Z35setPxVehicleSuspensionDataMMaxDroopPN5physx23PxVehicleSuspensionDataEf: __Z35setPxVehicleSuspensionDataMMaxDroopPN5physx23PxVehicleSuspensionDataEf, __Z36HingeJoint_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP10JointMotor: __Z36HingeJoint_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP10JointMotor, __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13GUIStyleState8TransferI24GenerateTypeTreeTransferEEvRT_, __Z40ConfigurableJoint_Get_Custom_PropYMotionP12Il2CppObject: __Z40ConfigurableJoint_Get_Custom_PropYMotionP12Il2CppObject, __ZN9Texture3D23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Texture3D23VirtualRedirectTransferER14SafeBinaryRead, __ZN11UnityEngine9Analytics9PerfEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine9Analytics9PerfEvent12ToJsonStringER9JSONWrite, __ZN13TargetJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13TargetJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __GLOBAL__sub_I_runtime_jobs_lump_cpp: __GLOBAL__sub_I_runtime_jobs_lump_cpp, __ZNK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv: __ZNK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv, __ZN20TextRenderingPrivate7GUIText7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN20TextRenderingPrivate7GUIText7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE8__appendEj, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERj: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERj, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERh: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERh, __ZN9Texture2D13UploadTextureEv: __ZN9Texture2D13UploadTextureEv, __ZN4FMOD12ChannelGroup4stopEv: __ZN4FMOD12ChannelGroup4stopEv, __Z38NavMeshAgent_Set_Custom_PropBaseOffsetP12Il2CppObjectf: __Z38NavMeshAgent_Set_Custom_PropBaseOffsetP12Il2CppObjectf, __ZNK15NavMeshSettings26GetTypeInfoVirtualInternalEv: __ZNK15NavMeshSettings26GetTypeInfoVirtualInternalEv, __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_WarpP12Il2CppObjectRK8Vector3f: __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_WarpP12Il2CppObjectRK8Vector3f, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERt: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERt, __ZN18PlatformEffector2D13SetSurfaceArcEf: __ZN18PlatformEffector2D13SetSurfaceArcEf, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERy: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERy, __ZN14ParticleSystem17SetUses3DRotationEv: __ZN14ParticleSystem17SetUses3DRotationEv, __ZN4FMOD6System19setSoftwareChannelsEi: __ZN4FMOD6System19setSoftwareChannelsEi, __ZN9GfxDevice19SetSinglePassStereoE16SinglePassStereo: __ZN9GfxDevice19SetSinglePassStereoE16SinglePassStereo, __ZN5physx38PxsSolverCreateFinalizeConstraintsTask11runInternalEv: __ZN5physx38PxsSolverCreateFinalizeConstraintsTask11runInternalEv, __Z44Register_UnityEngine_AudioClip_get_loadStatev: __Z44Register_UnityEngine_AudioClip_get_loadStatev, __ZNK5physx21PxsBodyTransformVault12getTransformERKNS_11PxsBodyCoreE: __ZNK5physx21PxsBodyTransformVault12getTransformERKNS_11PxsBodyCoreE, __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetBirthv: __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetBirthv, __Z46Register_UnityEngine_AssetBundle_get_mainAssetv: __Z46Register_UnityEngine_AssetBundle_get_mainAssetv, __Z32PlatformGetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z32PlatformGetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z42WindZone_Set_Custom_PropWindPulseMagnitudeP12Il2CppObjectf: __Z42WindZone_Set_Custom_PropWindPulseMagnitudeP12Il2CppObjectf, _bitshift64Lshr: _bitshift64Lshr, __Z24RegisterForNotificationsib: __Z24RegisterForNotificationsib, _unzGetGlobalComment: _unzGetGlobalComment, __ZNSt3__25dequeIN9BlobWrite11TypeContextENS_9allocatorIS2_EEE19__add_back_capacityEv: __ZNSt3__25dequeIN9BlobWrite11TypeContextENS_9allocatorIS2_EEE19__add_back_capacityEv, __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeERK8UnityStrPjPt: __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeERK8UnityStrPjPt, __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E13find_positionERS9_: __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E13find_positionERS9_, __ZN19CharacterController13SetStepOffsetEf: __ZN19CharacterController13SetStepOffsetEf, _UNITY_png_handle_IEND: _UNITY_png_handle_IEND, __ZN5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEED0Ev: __ZN5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEED0Ev, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_FT_Outline_EmboldenXY: _UNITY_FT_Outline_EmboldenXY, __ZN5physx3Ext14SphericalJoint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext14SphericalJoint15importExtraDataERNS_24PxDeserializationContextE, __ZN5Umbra13DebugRenderer12addAABBLinesEPS0_RKNS_7Vector3ES4_RKNS_7Vector4E: __ZN5Umbra13DebugRenderer12addAABBLinesEPS0_RKNS_7Vector3ES4_RKNS_7Vector4E, __ZN5physx18NpArticulationLink15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx18NpArticulationLink15exportExtraDataERNS_22PxSerializationContextE, __ZNK9Rigidbody18GetUseConeFrictionEv: __ZNK9Rigidbody18GetUseConeFrictionEv, __Z13SetIEnlightenP10IEnlighten: __Z13SetIEnlightenP10IEnlighten, __Z40RenderSettings_Get_Custom_PropFogDensityv: __Z40RenderSettings_Get_Custom_PropFogDensityv, __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2EPKcj: __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2EPKcj, __Z60Register_UnityEngine_Input_INTERNAL_set_compositionCursorPosv: __Z60Register_UnityEngine_Input_INTERNAL_set_compositionCursorPosv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv, __ZN11AudioSource7SetLoopEb: __ZN11AudioSource7SetLoopEb, __Z11loadAlignedPKfj: __Z11loadAlignedPKfj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj509ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj509ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity5Cloth18SetSolverFrequencyEf: __ZN5Unity5Cloth18SetSolverFrequencyEf, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEwj, __ZN5physx19NpArticulationJoint20setTargetOrientationERKNS_6PxQuatE: __ZN5physx19NpArticulationJoint20setTargetOrientationERKNS_6PxQuatE, __ZNSt3__213__lower_boundIRNS_6__lessIjjEEPKjjEET0_S6_S6_RKT1_T_: __ZNSt3__213__lower_boundIRNS_6__lessIjjEEPKjjEET0_S6_S6_RKT1_T_, __ZNK15dtProximityGrid11getCellSizeEPf: __ZNK15dtProximityGrid11getCellSizeEPf, __Z16lineIntersectionRKN4math7_float2ES2_: __Z16lineIntersectionRKN4math7_float2ES2_, __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc: __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE6resizeEjRKc, _Cubic_To: _Cubic_To, _jcopy_sample_rows: _jcopy_sample_rows, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z37Register_UnityEngine_Application_Quitv: __Z37Register_UnityEngine_Application_Quitv, __Z44Register_UnityEngine_Camera_get_farClipPlanev: __Z44Register_UnityEngine_Camera_get_farClipPlanev, __Z25InverseTransformDirection23TransformAccessReadOnlyRKN4math7_float3Eb: __Z25InverseTransformDirection23TransformAccessReadOnlyRKN4math7_float3Eb, __ZNK12NavMeshAgent11IsPathValidEv: __ZNK12NavMeshAgent11IsPathValidEv, __ZNK5physx2Cm12RenderBuffer8getLinesEv: __ZNK5physx2Cm12RenderBuffer8getLinesEv, __ZN22CrashReportingSettings11SetEventUrlERK8UnityStr: __ZN22CrashReportingSettings11SetEventUrlERK8UnityStr, __ZNK17IAnimationBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE: __ZNK17IAnimationBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE, __Z56AnimatorControllerPlayable_CUSTOM_SetLayerWeightInternalR9HPlayableif: __Z56AnimatorControllerPlayable_CUSTOM_SetLayerWeightInternalR9HPlayableif, __ZN5physx16PxVehicleDriveNWD0Ev: __ZN5physx16PxVehicleDriveNWD0Ev, __ZN5physx9NpFactory17registerParticlesEv: __ZN5physx9NpFactory17registerParticlesEv, __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_AddKey_InternalP12Il2CppObjectRK16KeyframeTplFloat: __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_AddKey_InternalP12Il2CppObjectRK16KeyframeTplFloat, __Z13Int64ToStringx: __Z13Int64ToStringx, __ZN14ParticleSystem13SetStartColorE10ColorRGBAf: __ZN14ParticleSystem13SetStartColorE10ColorRGBAf, __ZN5physx2Gu33MultiplePersistentContactManifold10fromBufferEPh: __ZN5physx2Gu33MultiplePersistentContactManifold10fromBufferEPh, __Z44Register_UnityEngine_Physics_IgnoreCollisionv: __Z44Register_UnityEngine_Physics_IgnoreCollisionv, __ZNK18ProceduralMaterial17GetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial17GetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z55AssetBundle_CUSTOM_LoadAssetWithSubAssetsAsync_InternalP12Il2CppObjectP12Il2CppStringS0_: __Z55AssetBundle_CUSTOM_LoadAssetWithSubAssetsAsync_InternalP12Il2CppObjectP12Il2CppStringS0_, __ZN18ColorBySpeedModule16CheckConsistencyEv: __ZN18ColorBySpeedModule16CheckConsistencyEv, _isdigit_l: _isdigit_l, __Z39NavMeshAgent_CUSTOM_CompleteOffMeshLinkP12Il2CppObject: __Z39NavMeshAgent_CUSTOM_CompleteOffMeshLinkP12Il2CppObject, _expm1l: _expm1l, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEC2ERKS7_, __ZN16UnityAdsSettingsD0Ev: __ZN16UnityAdsSettingsD0Ev, __Z44RelativeJoint2D_Get_Custom_PropAngularOffsetP12Il2CppObject: __Z44RelativeJoint2D_Get_Custom_PropAngularOffsetP12Il2CppObject, __Z45Animator_CUSTOM_GetHintWeightPositionInternalP12Il2CppObjecti: __Z45Animator_CUSTOM_GetHintWeightPositionInternalP12Il2CppObjecti, __ZN3MBP5resetEv: __ZN3MBP5resetEv, __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib: __ZNK10__cxxabiv121__vmi_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib, __Z55TerrainData_Get_Custom_PropInternal_heightmapResolutionP12Il2CppObject: __Z55TerrainData_Get_Custom_PropInternal_heightmapResolutionP12Il2CppObject, __ZNK5Unity17ConfigurableJoint26GetTypeInfoVirtualInternalEv: __ZNK5Unity17ConfigurableJoint26GetTypeInfoVirtualInternalEv, __ZN5physx5cloth8allocateEj: __ZN5physx5cloth8allocateEj, __ZNK12FixedJoint2D17GetReferenceAngleEv: __ZNK12FixedJoint2D17GetReferenceAngleEv, __ZN11DynamicMeshC2Ef: __ZN11DynamicMeshC2Ef, __Z38DataUtility_CUSTOM_Internal_GetMinSizeP12Il2CppObjectP13Vector2fIcall: __Z38DataUtility_CUSTOM_Internal_GetMinSizeP12Il2CppObjectP13Vector2fIcall, __Z19AppendTransformPathRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc: __Z19AppendTransformPathRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc, __Z24RegisterStrippedTypeInfoI10GUITextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI10GUITextureEviPKcS2_, __ZN5physx2Gu12TriangleMesh18setupMeshInterfaceEv: __ZN5physx2Gu12TriangleMesh18setupMeshInterfaceEv, __ZN15b2DistanceJoint4DumpEv: __ZN15b2DistanceJoint4DumpEv, _futimesat: _futimesat, __Z59ParticleSystem_LightsModule_CUSTOM_GetAlphaAffectsIntensityP12Il2CppObject: __Z59ParticleSystem_LightsModule_CUSTOM_GetAlphaAffectsIntensityP12Il2CppObject, __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_: __ZN19MeshParticleEmitter13SetupParticleEiR8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_, __Z44ReflectionProbe_Get_Custom_PropBoxProjectionP12Il2CppObject: __Z44ReflectionProbe_Get_Custom_PropBoxProjectionP12Il2CppObject, __ZN18AudioMixerSnapshot7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18AudioMixerSnapshot7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN12IFileAdapter5WriteER13FileEntryDatayyPvPy: __ZN12IFileAdapter5WriteER13FileEntryDatayyPvPy, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeXv, __ZNK13AnimationClip17GetAnimationClipsEv: __ZNK13AnimationClip17GetAnimationClipsEv, __Z33Joint2D_Set_Custom_PropBreakForceP12Il2CppObjectf: __Z33Joint2D_Set_Custom_PropBreakForceP12Il2CppObjectf, __Z23CleanupPhysicsManager2Dv: __Z23CleanupPhysicsManager2Dv, _XXH_versionNumber: _XXH_versionNumber, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN16DeveloperConsole5ClearEv: __ZN16DeveloperConsole5ClearEv, __ZN8Animator27ClearBindingsOnDomainReloadEv: __ZN8Animator27ClearBindingsOnDomainReloadEv, __ZNK9ShaderLab7Program11IsSupportedEPK6Shader: __ZNK9ShaderLab7Program11IsSupportedEPK6Shader, __Z61Animator_Get_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObject: __Z61Animator_Get_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObject, __ZN9Rigidbody16SetInertiaTensorERK8Vector3f: __ZN9Rigidbody16SetInertiaTensorERK8Vector3f, __ZN2UI14CanvasRenderer13SyncVertexPtrER8JobFenceNS0_8SyncFlagE: __ZN2UI14CanvasRenderer13SyncVertexPtrER8JobFenceNS0_8SyncFlagE, __ZN5physx7NpShape23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx7NpShape23setSimulationFilterDataERKNS_12PxFilterDataE, __ZNK5physx2Cm12RenderBuffer9getPointsEv: __ZNK5physx2Cm12RenderBuffer9getPointsEv, __ZN5Umbra8QueryExtC2EPKNS_4TomeE: __ZN5Umbra8QueryExtC2EPKNS_4TomeE, __Z3maxRK8Scalar4fS1_: __Z3maxRK8Scalar4fS1_, __ZN5physx33PxVehicleWheelDataGeneratedValuesC2EPKNS_18PxVehicleWheelDataE: __ZN5physx33PxVehicleWheelDataGeneratedValuesC2EPKNS_18PxVehicleWheelDataE, __ZN13SpeedTreeWind9SetOptionENS_8EOptionsEb: __ZN13SpeedTreeWind9SetOptionENS_8EOptionsEb, __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z16GetValuesForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE8pushNameEPKc, __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIllEEPlEEjT0_S5_S5_T_, _FMOD_Memory_Initialize: _FMOD_Memory_Initialize, __ZN21ArchiveStorageCreator11StoreStreamEb: __ZN21ArchiveStorageCreator11StoreStreamEb, __ZNK8VRDevice26GetApplicationHasLostFocusEv: __ZNK8VRDevice26GetApplicationHasLostFocusEv, __Z48Register_UnityEngine_GUIUtility_Internal_ExitGUIv: __Z48Register_UnityEngine_GUIUtility_Internal_ExitGUIv, __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIddEEPdEEjT0_S5_S5_T_, __Z39EdgeCollider2D_Get_Custom_PropEdgeCountP12Il2CppObject: __Z39EdgeCollider2D_Get_Custom_PropEdgeCountP12Il2CppObject, __Z66Register_UnityEngine_Connect_UnityConnectSettings_set_testEventUrlv: __Z66Register_UnityEngine_Connect_UnityConnectSettings_set_testEventUrlv, __ZN12_GLOBAL__N_124PropertyDefinitionHelperD0Ev: __ZN12_GLOBAL__N_124PropertyDefinitionHelperD0Ev, __ZN5Umbra12QueryContext18addQueryDebugPointERKNS_7Vector3ERKNS_7Vector4E: __ZN5Umbra12QueryContext18addQueryDebugPointERKNS_7Vector3ERKNS_7Vector4E, __ZL21CullDynamicObjectsJobP14CullingJobDataj: __ZL21CullDynamicObjectsJobP14CullingJobDataj, __ZN2UI15ClearCanvasDataER8JobFenceRNS_10CanvasDataE: __ZN2UI15ClearCanvasDataER8JobFenceRNS_10CanvasDataE, __Z33GUITexture_Set_Custom_PropTextureP12Il2CppObjectS0_: __Z33GUITexture_Set_Custom_PropTextureP12Il2CppObjectS0_, __ZN19GCProfilerCallbacksL12OnGCShutdownEPv: __ZN19GCProfilerCallbacksL12OnGCShutdownEPv, __Z41Register_UnityEngine_Cursor_set_lockStatev: __Z41Register_UnityEngine_Cursor_set_lockStatev, __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EEPKS8_RKSB_: __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EEPKS8_RKSB_, __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj, __Z35RenderTexture_Set_Custom_PropFormatP12Il2CppObject19RenderTextureFormat: __Z35RenderTexture_Set_Custom_PropFormatP12Il2CppObject19RenderTextureFormat, __ZN9TransformD2Ev: __ZN9TransformD2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK28MonoBehaviourPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK28MonoBehaviourPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __Z50AnimatorOverrideController_CUSTOM_Internal_SetClipP12Il2CppObjectS0_S0_h: __Z50AnimatorOverrideController_CUSTOM_Internal_SetClipP12Il2CppObjectS0_S0_h, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN14ManagerContext17InitializeClassesEv: __ZN14ManagerContext17InitializeClassesEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj5ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj5ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKwj, __ZN15AnimationBinder19RemoveUnboundCurvesER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER13dynamic_arrayI20BoundCurveDeprecatedLj4EE: __ZN15AnimationBinder19RemoveUnboundCurvesER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER13dynamic_arrayI20BoundCurveDeprecatedLj4EE, __ZN13GfxDeviceGLES11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns: __ZN13GfxDeviceGLES11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns, __Z38Animator_Get_Custom_PropParameterCountP12Il2CppObject: __Z38Animator_Get_Custom_PropParameterCountP12Il2CppObject, __Z21SendMessageToEveryone17MessageIdentifier11MessageData: __Z21SendMessageToEveryone17MessageIdentifier11MessageData, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN5physx10NpMaterial14onRefCountZeroEv: __ZN5physx10NpMaterial14onRefCountZeroEv, __ZN5physx13GuMeshFactory14addHeightFieldEPNS_2Gu11HeightFieldEb: __ZN5physx13GuMeshFactory14addHeightFieldEPNS_2Gu11HeightFieldEb, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, __ZN17CollisionMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_R4Mesh: __ZN17CollisionMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_R4Mesh, __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE7destroyEv: __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE7destroyEv, _t1_hints_open: _t1_hints_open, __ZN5physx2Sc7BodySim24notifyAddSpatialVelocityEv: __ZN5physx2Sc7BodySim24notifyAddSpatialVelocityEv, __ZN7mecanim9animation19Blend2dDataConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation19Blend2dDataConstant8TransferI14SafeBinaryReadEEvRT_, __Z34LensFlare_Get_Custom_PropFadeSpeedP12Il2CppObject: __Z34LensFlare_Get_Custom_PropFadeSpeedP12Il2CppObject, __ZNKSt3__27codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_: __ZNKSt3__27codecvtIwc11__mbstate_tE5do_inERS1_PKcS5_RS5_PwS7_RS7_, __ZN5physx7NpShape15decMeshRefCountEv: __ZN5physx7NpShape15decMeshRefCountEv, __ZN19CharacterController8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19CharacterController8TransferI24GenerateTypeTreeTransferEEvRT_, __Z37setPxDistanceJoint_DistanceJointFlagsPN5physx15PxDistanceJointENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE: __Z37setPxDistanceJoint_DistanceJointFlagsPN5physx15PxDistanceJointENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE, __ZNK9Heightmap39CalculateNormalSobelRespectingNeighborsEiiPK15TerrainRenderer: __ZNK9Heightmap39CalculateNormalSobelRespectingNeighborsEiiPK15TerrainRenderer, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __Z60Register_UnityEngine_Camera_INTERNAL_CALL_WorldToScreenPointv: __Z60Register_UnityEngine_Camera_INTERNAL_CALL_WorldToScreenPointv, __ZN5physx7NpCloth23sendPvdCollisionSpheresEv: __ZN5physx7NpCloth23sendPvdCollisionSpheresEv, __ZN24iPhoneRemoteNotificationC2ERKS_: __ZN24iPhoneRemoteNotificationC2ERKS_, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE7PrepareEv: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE7PrepareEv, __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fjPS2_ji: __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fjPS2_ji, __ZN22UnityWebRequestManager21CreateUnityWebRequestEv: __ZN22UnityWebRequestManager21CreateUnityWebRequestEv, __Z38Register_UnityEngine_GUIStyle_InitCopyv: __Z38Register_UnityEngine_GUIStyle_InitCopyv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE19getConcreteTypeNameEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_, __Z29Transfer_Blittable_ArrayFieldI9JSONWritesEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritesEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx13NpClothFabric4loadERKNS_17PxClothFabricDescE: __ZN5physx13NpClothFabric4loadERKNS_17PxClothFabricDescE, __ZN4FMOD7Channel11getUserDataEPPv: __ZN4FMOD7Channel11getUserDataEPPv, __Z70Register_UnityEngine_Experimental_Director_Playables_GetTypeOfInternalv: __Z70Register_UnityEngine_Experimental_Director_Playables_GetTypeOfInternalv, _UNITY_tt_face_load_gasp: _UNITY_tt_face_load_gasp, __ZN14VelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14VelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18ProceduralMaterial15InitializeClassEv: __ZN18ProceduralMaterial15InitializeClassEv, __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi: __ZN4gles14UseGLSLProgramER15DeviceStateGLESjbi, __ZN8LODGroup7SetSizeEf: __ZN8LODGroup7SetSizeEf, __ZN12_GLOBAL__N_118LegacySerialStream17registerReferenceERN5physx6PxBaseEjj: __ZN12_GLOBAL__N_118LegacySerialStream17registerReferenceERN5physx6PxBaseEjj, __ZN11Rigidbody2D14SetUseAutoMassEb: __ZN11Rigidbody2D14SetUseAutoMassEb, __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN26AnimatorOverrideController30OnInvalidateAnimatorControllerEv: __ZN26AnimatorOverrideController30OnInvalidateAnimatorControllerEv, __Z34getPxScene_FrictionOffsetThresholdPKN5physx7PxSceneE: __Z34getPxScene_FrictionOffsetThresholdPKN5physx7PxSceneE, __Z44setPxVehicleAckermannGeometryDataMFrontWidthPN5physx30PxVehicleAckermannGeometryDataEf: __Z44setPxVehicleAckermannGeometryDataMFrontWidthPN5physx30PxVehicleAckermannGeometryDataEf, __ZN5physx13NpRigidStaticD0Ev: __ZN5physx13NpRigidStaticD0Ev, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale0Ev, __ZN11UnityEngine15PlatformWrapper16GenerateRandomIdEv: __ZN11UnityEngine15PlatformWrapper16GenerateRandomIdEv, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __Z25CalculateShadowCasterCullbPK5PlaneRK10Matrix4x4fRK8Vector3fff9LightTypeS7_R16ShadowCasterCullPKb: __Z25CalculateShadowCasterCullbPK5PlaneRK10Matrix4x4fRK8Vector3fff9LightTypeS7_R16ShadowCasterCullPKb, __Z13RegisterClassI13BoxCollider2DEvv: __Z13RegisterClassI13BoxCollider2DEvv, __Z22SpriteRenderer_CleanupR15RenderNodeQueuej: __Z22SpriteRenderer_CleanupR15RenderNodeQueuej, __ZNK5physx14PxVehicleDrive8isKindOfEPKc: __ZNK5physx14PxVehicleDrive8isKindOfEPKc, __ZN9GfxDevice18SetStereoActiveEyeE15StereoscopicEye: __ZN9GfxDevice18SetStereoActiveEyeE15StereoscopicEye, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbumpEi: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5pbumpEi, __ZNK5Umbra4AABB11getSideQuadEiPNS_7Vector3E: __ZNK5Umbra4AABB11getSideQuadEiPNS_7Vector3E, _cfmakeraw: _cfmakeraw, __Z53Register_UnityEngine_RenderSettings_set_flareStrengthv: __Z53Register_UnityEngine_RenderSettings_set_flareStrengthv, __ZN5physx13NpClothFabric14onRefCountZeroEv: __ZN5physx13NpClothFabric14onRefCountZeroEv, __Z37Graphics_CUSTOM_Internal_BlitMultiTapP12Il2CppObjectS0_S0_P11Il2CppArray: __Z37Graphics_CUSTOM_Internal_BlitMultiTapP12Il2CppObjectS0_S0_P11Il2CppArray, __ZN2UI14CanvasRenderer11SetMaterialEP8Materiali: __ZN2UI14CanvasRenderer11SetMaterialEP8Materiali, __ZNK14ParticleSystem20CalculateWorldBoundsEv: __ZNK14ParticleSystem20CalculateWorldBoundsEv, __ZN12HingeJoint2D8SetMotorERK12JointMotor2D: __ZN12HingeJoint2D8SetMotorERK12JointMotor2D, __Z9ReadPixelI10ColorRGBAfET_PKh13TextureFormat: __Z9ReadPixelI10ColorRGBAfET_PKh13TextureFormat, __Z44UnityAnalyticsHandler_CUSTOM_InternalDestroyP12Il2CppObject: __Z44UnityAnalyticsHandler_CUSTOM_InternalDestroyP12Il2CppObject, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11getGridSizeEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE11getGridSizeEv, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE, __ZN14UnityWebStream24GetAssetBundleInstanceIdEv: __ZN14UnityWebStream24GetAssetBundleInstanceIdEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIwEE, __Z40ParticleEmitter_Set_Custom_PropMaxEnergyP12Il2CppObjectf: __Z40ParticleEmitter_Set_Custom_PropMaxEnergyP12Il2CppObjectf, __ZN11IMGUIModule18MonoBehaviourDoGUIEiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS2_E: __ZN11IMGUIModule18MonoBehaviourDoGUIEiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS2_E, __ZN13AnimationClip15ThreadedCleanupEv: __ZN13AnimationClip15ThreadedCleanupEv, __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __Z32BillboardRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __Z32BillboardRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN9Scripting35DestroyObjectFromScriptingImmediateEP6Objectb: __ZN9Scripting35DestroyObjectFromScriptingImmediateEP6Objectb, __Z24SetMeshIndicesFromScriptR4Meshi16GfxPrimitiveTypeP11Il2CppArrayib: __Z24SetMeshIndicesFromScriptR4Meshi16GfxPrimitiveTypeP11Il2CppArrayib, __ZNK15NavMeshObstacle12GetCarveDataER16NavMeshCarveData: __ZNK15NavMeshObstacle12GetCarveDataER16NavMeshCarveData, __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing1LimitP12Il2CppObjectP14SoftJointLimit: __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing1LimitP12Il2CppObjectP14SoftJointLimit, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4sizeEv, _getnetbyaddr: _getnetbyaddr, __ZN5physx3Ext7D6Joint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext7D6Joint17resolveReferencesERNS_24PxDeserializationContextE, __Z39getPxScene_ClothInterCollisionStiffnessPKN5physx7PxSceneE: __Z39getPxScene_ClothInterCollisionStiffnessPKN5physx7PxSceneE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj588ENS_22PxRepXPropertyAccessorILj588ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj588ENS_22PxRepXPropertyAccessorILj588ES4_ffEEEEvRKT0_, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED2Ev, __ZN5physx2Sc27ConstraintProjectionManager21processPendingUpdatesERNS_19PxcScratchAllocatorE: __ZN5physx2Sc27ConstraintProjectionManager21processPendingUpdatesERNS_19PxcScratchAllocatorE, _UNITY_LZ4_createStreamDecode: _UNITY_LZ4_createStreamDecode, __ZN20TextRenderingPrivate22ScriptingTextGenerator9InitVertsEi: __ZN20TextRenderingPrivate22ScriptingTextGenerator9InitVertsEi, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIiEEEvRT_PKc17TransferMetaFlags, __GLOBAL__sub_I_GpuProgramParamsGLES_cpp: __GLOBAL__sub_I_GpuProgramParamsGLES_cpp, __ZN9Animation21RebuildBoundStateMaskEv: __ZN9Animation21RebuildBoundStateMaskEv, __ZN5physx41PCMCapsuleVsMeshContactGenerationCallbackD0Ev: __ZN5physx41PCMCapsuleVsMeshContactGenerationCallbackD0Ev, __ZN5physx2Gu23computePlane_CapsuleMTDERKNS_7PxPlaneERKNS0_7CapsuleERNS_10PxSweepHitE: __ZN5physx2Gu23computePlane_CapsuleMTDERKNS_7PxPlaneERKNS0_7CapsuleERNS_10PxSweepHitE, __ZN12AdsIdHandler20IsCachedAdsIdExpiredEv: __ZN12AdsIdHandler20IsCachedAdsIdExpiredEv, __ZN13TriggerModule8TransferI14SafeBinaryReadEEvRT_: __ZN13TriggerModule8TransferI14SafeBinaryReadEEvRT_, __Z23ConvertImageToJPGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EEi: __Z23ConvertImageToJPGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EEi, __Z57Register_UnityEngine_ParticleRenderer_set_maxParticleSizev: __Z57Register_UnityEngine_ParticleRenderer_set_maxParticleSizev, __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEvT0_S7_T_, __ZN2UI11CanvasGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN2UI11CanvasGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z48Register_UnityEngine_Camera_get_orthographicSizev: __Z48Register_UnityEngine_Camera_get_orthographicSizev, __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MergeScenesv: __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MergeScenesv, __ZNSt3__26localeD2Ev: __ZNSt3__26localeD2Ev, __ZN7Terrain19SetMaterialTemplateERK4PPtrI8MaterialE: __ZN7Terrain19SetMaterialTemplateERK4PPtrI8MaterialE, __ZNK20IntermediateRenderer8GetLayerEv: __ZNK20IntermediateRenderer8GetLayerEv, __Z26Cubemap_CUSTOM_SmoothEdgesP12Il2CppObjecti: __Z26Cubemap_CUSTOM_SmoothEdgesP12Il2CppObjecti, __ZN5physx22PxcPCMContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcPCMContactSphereBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z41Effector2D_Set_Custom_PropUseColliderMaskP12Il2CppObjecth: __Z41Effector2D_Set_Custom_PropUseColliderMaskP12Il2CppObjecth, __ZN15QualitySettings8TransferI14SafeBinaryReadEEvRT_: __ZN15QualitySettings8TransferI14SafeBinaryReadEEvRT_, __ZN5physx8debugger4comm21BeginSetPropertyValue9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm21BeginSetPropertyValue9serializeERNS1_15EventSerializerE, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18getConstraintFlagsEv, _div: _div, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E5clearEv: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E5clearEv, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j, __ZNSt3__24stofERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj: __ZNSt3__24stofERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPj, __Z39setPxClothParticleDataPreviousParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE: __Z39setPxClothParticleDataPreviousParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE, __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10initializeEv: __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10initializeEv, __ZNK14PhysicsManager23GetPvdConnectionEnabledEv: __ZNK14PhysicsManager23GetPvdConnectionEnabledEv, __Z43Register_UnityEngine_Mesh_RecalculateBoundsv: __Z43Register_UnityEngine_Mesh_RecalculateBoundsv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE12readPropertyIfEEbRT_, __ZN15UnityAdsManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15UnityAdsManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5eraseENS_21__list_const_iteratorIS9_PvEE: __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5eraseENS_21__list_const_iteratorIS9_PvEE, __ZThn8_N5physx2Sc19ShapeInstancePairLL10initializeEv: __ZThn8_N5physx2Sc19ShapeInstancePairLL10initializeEv, __ZN4FMOD8ChannelI19get3DDistanceFilterEPbPfS2_: __ZN4FMOD8ChannelI19get3DDistanceFilterEPbPfS2_, __ZN12_GLOBAL__N_124PropertyDefinitionHelper21addPropertyMessageArgERKN5physx8debugger14NamespacedNameEjj: __ZN12_GLOBAL__N_124PropertyDefinitionHelper21addPropertyMessageArgERKN5physx8debugger14NamespacedNameEjj, __ZN11NavMeshPathC2Ev: __ZN11NavMeshPathC2Ev, __Z46Register_UnityEngine_Terrain_get_activeTerrainv: __Z46Register_UnityEngine_Terrain_get_activeTerrainv, __ZN5physx21PxVehicleDriveDynDataC2Ev: __ZN5physx21PxVehicleDriveDynDataC2Ev, _UNITY_png_set_shift: _UNITY_png_set_shift, __Z21GetUnityAdsManagerPtrv: __Z21GetUnityAdsManagerPtrv, __Z40SliderJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK24JointTranslationLimits2D: __Z40SliderJoint2D_CUSTOM_INTERNAL_set_limitsP12Il2CppObjectRK24JointTranslationLimits2D, __Z38OcclusionArea_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f: __Z38OcclusionArea_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f, __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object: __ZN14SerializedFile10ReadObjectEx18ObjectCreationModebPPK8TypeTreePbR6Object, __ZN15ReflectionProbe5ResetEv: __ZN15ReflectionProbe5ResetEv, __ZN4Mesh12SetIndexDataEiiPKv16GfxPrimitiveTypei: __ZN4Mesh12SetIndexDataEiiPKv16GfxPrimitiveTypei, __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI15TexFormatRFloatEEvPKNS_9InnerInfoE, __Z31Light_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z31Light_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __ZN14dynamic_bitset6resizeEjb: __ZN14dynamic_bitset6resizeEjb, _tt_property_get: _tt_property_get, __Z44ParticleEmitter_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth: __Z44ParticleEmitter_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth, __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE13StaticDestroyEPv, __Z54ParticleSystem_LightsModule_CUSTOM_GetUseParticleColorP12Il2CppObject: __Z54ParticleSystem_LightsModule_CUSTOM_GetUseParticleColorP12Il2CppObject, __Z55Register_UnityEngine_CanvasRenderer_get_hasRectClippingv: __Z55Register_UnityEngine_CanvasRenderer_get_hasRectClippingv, __ZN6prcore24DefaultIntegerBlitFormatEN14ImageReference8BlitModeE: __ZN6prcore24DefaultIntegerBlitFormatEN14ImageReference8BlitModeE, __ZN9GfxDevice34SetStencilRefWhenStencilWasSkippedEi: __ZN9GfxDevice34SetStencilRefWhenStencilWasSkippedEi, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12AudioManager18AddAudioReverbZoneEP15AudioReverbZone: __ZN12AudioManager18AddAudioReverbZoneEP15AudioReverbZone, __ZL21InternalAssertConsolePKcz: __ZL21InternalAssertConsolePKcz, __ZN12_GLOBAL__N_117ProfileZoneClientD2Ev: __ZN12_GLOBAL__N_117ProfileZoneClientD2Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignESt16initializer_listIcE, __Z46AudioSource_Get_Custom_PropIgnoreListenerPauseP12Il2CppObject: __Z46AudioSource_Get_Custom_PropIgnoreListenerPauseP12Il2CppObject, __ZN5Unity5Cloth26ClothConstrainCoefficients8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity5Cloth26ClothConstrainCoefficients8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx2Sc9ClothCore19getVirtualParticlesEPj: __ZNK5physx2Sc9ClothCore19getVirtualParticlesEPj, __ZN12TreeRenderer11ReloadTreesEi: __ZN12TreeRenderer11ReloadTreesEi, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEbT0_S7_T_, __ZN5physx6shdfnd10checkValidERKNS_6PxVec3E: __ZN5physx6shdfnd10checkValidERKNS_6PxVec3E, __ZN5physx15PxSerialization23createCollectionFromXmlERNS_11PxInputDataERNS_9PxCookingERNS_23PxSerializationRegistryEPKNS_12PxCollectionEPNS_13PxStringTableEPNS0_18PxXmlMiscParameterE: __ZN5physx15PxSerialization23createCollectionFromXmlERNS_11PxInputDataERNS_9PxCookingERNS_23PxSerializationRegistryEPKNS_12PxCollectionEPNS_13PxStringTableEPNS0_18PxXmlMiscParameterE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwj, __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags, __ZN5Unity5Cloth23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity5Cloth23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx2Sc9ClothCore18getNbRestPositionsEv: __ZNK5physx2Sc9ClothCore18getNbRestPositionsEv, _fchdir: _fchdir, __ZN4FMOD6System17getCDROMDriveNameEiPciS1_iS1_i: __ZN4FMOD6System17getCDROMDriveNameEiPciS1_iS1_i, __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv: __ZN20TextRenderingPrivate8TextMesh11ApplyToMeshEv, __Z36Camera_Set_Custom_PropOpaqueSortModeP12Il2CppObjectN6Camera14OpaqueSortModeE: __Z36Camera_Set_Custom_PropOpaqueSortModeP12Il2CppObjectN6Camera14OpaqueSortModeE, __Z35GUIStyle_CUSTOM_Internal_CalcHeight13Il2Cpp_IntPtrP12Il2CppObjectf: __Z35GUIStyle_CUSTOM_Internal_CalcHeight13Il2Cpp_IntPtrP12Il2CppObjectf, __Z47ParticleSystem_EmissionModule_CUSTOM_GetEnabledP12Il2CppObject: __Z47ParticleSystem_EmissionModule_CUSTOM_GetEnabledP12Il2CppObject, ___signbitf: ___signbitf, __ZNSt3__215__codecvt_utf16IDiLb0EED0Ev: __ZNSt3__215__codecvt_utf16IDiLb0EED0Ev, __Z64Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_steeringTargetv: __Z64Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_steeringTargetv, __ZN13AnimationClip23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13AnimationClip23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN17MemoryCacheWriter15CompleteWritingEj: __ZN17MemoryCacheWriter15CompleteWritingEj, __Z47Register_UnityEngine_GUIStyle_get_stretchHeightv: __Z47Register_UnityEngine_GUIStyle_get_stretchHeightv, __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticMethodIDv: __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticMethodIDv, __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE19__add_back_capacityEv: __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE19__add_back_capacityEv, __ZN5physx7NpScene12removeActorsEPKPNS_7PxActorEjb: __ZN5physx7NpScene12removeActorsEPKPNS_7PxActorEjb, __Z42Register_UnityEngine_LODGroup_set_fadeModev: __Z42Register_UnityEngine_LODGroup_set_fadeModev, __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv: __ZN13ComputeShader13SetValueParamERKN9ShaderLab16FastPropertyNameEiPKv, __ZNSt3__219__shared_mutex_base15try_lock_sharedEv: __ZNSt3__219__shared_mutex_base15try_lock_sharedEv, __ZN11UnityEngine15PlatformWrapper17SetPlayerPrefsIntERK8UnityStri: __ZN11UnityEngine15PlatformWrapper17SetPlayerPrefsIntERK8UnityStri, __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev: __ZNSt3__213__vector_baseIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEED2Ev, __Z60Register_UnityEngine_SkinnedMeshRenderer_GetBlendShapeWeightv: __Z60Register_UnityEngine_SkinnedMeshRenderer_GetBlendShapeWeightv, __Z52Register_UnityEngine_AudioReverbZone_set_LFReferencev: __Z52Register_UnityEngine_AudioReverbZone_set_LFReferencev, __Z47CanvasRenderer_Set_Custom_PropHasPopInstructionP12Il2CppObjecth: __Z47CanvasRenderer_Set_Custom_PropHasPopInstructionP12Il2CppObjecth, __ZN16MemoryFileSystem4SeekER13FileEntryDatax10FileOrigin: __ZN16MemoryFileSystem4SeekER13FileEntryDatax10FileOrigin, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, __Z52Register_UnityEngine_ParticleSystem_Internal_EmitOldv: __Z52Register_UnityEngine_ParticleSystem_Internal_EmitOldv, __ZN5Image8SetImageEii13TextureFormatb: __ZN5Image8SetImageEii13TextureFormatb, __ZN5Umbra10VisibilityC2Ev: __ZN5Umbra10VisibilityC2Ev, __ZN17MessageIdentifier21GetRegisteredMessagesEv: __ZN17MessageIdentifier21GetRegisteredMessagesEv, _setrlimit: _setrlimit, __ZN14CachingManager15GetCurrentCacheEv: __ZN14CachingManager15GetCurrentCacheEv, __Z13RegisterClassI23CloudWebServicesManagerEvv: __Z13RegisterClassI23CloudWebServicesManagerEvv, __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE: __Z31GetAllScenePathsFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE, __ZN19UnityConnectService25UnregisterGlobalCallbacksEv: __ZN19UnityConnectService25UnregisterGlobalCallbacksEv, __ZN14AvatarPlayback5ClearEv: __ZN14AvatarPlayback5ClearEv, __Z38Register_UnityEngine_Cloth_set_dampingv: __Z38Register_UnityEngine_Cloth_set_dampingv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13shrink_to_fitEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13shrink_to_fitEv, __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_: __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_SB_SB_T_, __ZNK11Rigidbody2D26GetTypeInfoVirtualInternalEv: __ZNK11Rigidbody2D26GetTypeInfoVirtualInternalEv, __ZN17FileSystemHandler8SetFlagsER13FileEntryDatajj: __ZN17FileSystemHandler8SetFlagsER13FileEntryDatajj, __ZN7mecanim9animation17GetClipCurveCountERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation17GetClipCurveCountERKNS0_18ClipMuscleConstantE, __Z43WheelJoint2D_CUSTOM_INTERNAL_set_suspensionP12Il2CppObjectRK17JointSuspension2D: __Z43WheelJoint2D_CUSTOM_INTERNAL_set_suspensionP12Il2CppObjectRK17JointSuspension2D, __ZN4gles21InitRenderSurfaceGLESEP7ApiGLESR17RenderSurfaceGLESN2gl17TextureSrgbDecodeE: __ZN4gles21InitRenderSurfaceGLESEP7ApiGLESR17RenderSurfaceGLESN2gl17TextureSrgbDecodeE, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4dataEv, __ZN8Material25DidModifyShaderKeywordSetEv: __ZN8Material25DidModifyShaderKeywordSetEv, __Z49Register_UnityEngine_TrailRenderer_set_widthCurvev: __Z49Register_UnityEngine_TrailRenderer_set_widthCurvev, __ZN5Umbra9Matrix4x3mLEf: __ZN5Umbra9Matrix4x3mLEf, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE9__grow_byEjjjjjj, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN9Texture2D5ApplyEbb: __ZN9Texture2D5ApplyEbb, _futimens: _futimens, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx3Ext20DefaultCpuDispatcher15resetWakeSignalEv: __ZN5physx3Ext20DefaultCpuDispatcher15resetWakeSignalEv, _UNITY_FT_Face_GetVariantsOfChar: _UNITY_FT_Face_GetVariantsOfChar, _DistanceJointSolverPrep: _DistanceJointSolverPrep, __ZN20IntermediateRenderer17UnsharePropertiesEv: __ZN20IntermediateRenderer17UnsharePropertiesEv, __ZN13RenderTexture15OnUpdateExtentsEb: __ZN13RenderTexture15OnUpdateExtentsEb, __Z61Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatrixv: __Z61Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatrixv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE13isSubordinateEv, __Z46Register_UnityEngine_RectOffset_get_horizontalv: __Z46Register_UnityEngine_RectOffset_get_horizontalv, __Z15GetMeshForPatchiiiR9HeightmapPK15TerrainRenderer: __Z15GetMeshForPatchiiiR9HeightmapPK15TerrainRenderer, __ZN18DelayedCallManager8ClearAllEv: __ZN18DelayedCallManager8ClearAllEv, __Z16ReadConditionalyPPiRP19ProfilerInformationb: __Z16ReadConditionalyPPiRP19ProfilerInformationb, __Z27PxcDisplayContactCacheStatsv: __Z27PxcDisplayContactCacheStatsv, __ZN14dtPathCorridor12SetPathStaleEb: __ZN14dtPathCorridor12SetPathStaleEb, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetYv, __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_: __ZL17computeMeshBoundsRKN5physx11PxTransformEPKNS_9PxBounds3ERKNS_11PxMeshScaleERNS_6PxVec3ESA_, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedv, __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_: __ZNSt3__26__sortIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_, __Z50Register_UnityEngine_Rigidbody2D_get_interpolationv: __Z50Register_UnityEngine_Rigidbody2D_get_interpolationv, __ZNK5physx2Sc9ClothCore22getSleepLinearVelocityEv: __ZNK5physx2Sc9ClothCore22getSleepLinearVelocityEv, __ZN5physx9readDwordEbRNS_13PxInputStreamE: __ZN5physx9readDwordEbRNS_13PxInputStreamE, __ZN4FMOD13ChannelGroupI7setMuteEb: __ZN4FMOD13ChannelGroupI7setMuteEb, __Z52Register_UnityEngine_TerrainData_get_heightmapHeightv: __Z52Register_UnityEngine_TerrainData_get_heightmapHeightv, __ZN5Umbra5Query21queryPortalVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEffPKNS_20ObjectDistanceParamsEiii: __ZN5Umbra5Query21queryPortalVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEffPKNS_20ObjectDistanceParamsEiii, __ZN15DirectorManager14ConnectionPool8AllocateEi: __ZN15DirectorManager14ConnectionPool8AllocateEi, __ZN5physx5cloth8SwSolver19StartSimulationTaskD0Ev: __ZN5physx5cloth8SwSolver19StartSimulationTaskD0Ev, __ZN3MBP17prepareOverlapsMTEv: __ZN3MBP17prepareOverlapsMTEv, __Z64Register_UnityEngine_Networking_UnityWebRequest_get_responseCodev: __Z64Register_UnityEngine_Networking_UnityWebRequest_get_responseCodev, __ZN13ResourceImageC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13ResourceImageC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx6shdfnd10ThreadImpl4killEv: __ZN5physx6shdfnd10ThreadImpl4killEv, __Z25scripting_field_get_flagsP9FieldInfo: __Z25scripting_field_get_flagsP9FieldInfo, __Z37setPxSceneDescSimulationEventCallbackPN5physx11PxSceneDescEPNS_25PxSimulationEventCallbackE: __Z37setPxSceneDescSimulationEventCallbackPN5physx11PxSceneDescEPNS_25PxSimulationEventCallbackE, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEEEEjT_j, __Z13InitIndexListR9IndexListj: __Z13InitIndexListR9IndexListj, _UNITY_png_write_flush: _UNITY_png_write_flush, __ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i: __ZL16ReadTypeTreeImplILb1EEbR8TypeTreeRK16TypeTreeIteratorRPKhS6_i, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14resetFilteringEv: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14resetFilteringEv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z42Register_UnityEngine_Texture2D_EncodeToJPGv: __Z42Register_UnityEngine_Texture2D_EncodeToJPGv, __ZN5Umbra10PortalInfoC2Ev: __ZN5Umbra10PortalInfoC2Ev, __ZN20OcclusionCullingDataD0Ev: __ZN20OcclusionCullingDataD0Ev, __ZNK11b2WeldJoint10GetAnchorBEv: __ZNK11b2WeldJoint10GetAnchorBEv, __ZN13GfxDeviceGLES17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv: __ZN13GfxDeviceGLES17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv, __ZN5physx17ConvexMeshBuilderC2Ev: __ZN5physx17ConvexMeshBuilderC2Ev, __ZN9JSONWrite8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags, __ZNKSt3__212ctype_bynameIwE10do_toupperEPwPKw: __ZNKSt3__212ctype_bynameIwE10do_toupperEPwPKw, __Z13RegisterClassI16SubstanceArchiveEvv: __Z13RegisterClassI16SubstanceArchiveEvv, __ZN8VRDevice15BeforeRenderingEv: __ZN8VRDevice15BeforeRenderingEv, __Z13RegisterClassI13SparseTextureEvv: __Z13RegisterClassI13SparseTextureEvv, __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetPlayStateInternalv: __Z86Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetPlayStateInternalv, __ZN5physx20PxvRegisterParticlesEv: __ZN5physx20PxvRegisterParticlesEv, __ZN14PhysicsManager15IgnoreCollisionEiib: __ZN14PhysicsManager15IgnoreCollisionEiib, _gzwrite: _gzwrite, _casinl: _casinl, __ZN20ArchiveStorageHeader41GetSizeRequiredToParseHeaderAndBlocksInfoERKNS_6HeaderE: __ZN20ArchiveStorageHeader41GetSizeRequiredToParseHeaderAndBlocksInfoERKNS_6HeaderE, __ZN5physx14NpArticulation17setSleepThresholdEf: __ZN5physx14NpArticulation17setSleepThresholdEf, __Z39GetDefaultApplicationIdentifierForCachev: __Z39GetDefaultApplicationIdentifierForCachev, __ZN10GameObject18UpdateActiveGONodeEv: __ZN10GameObject18UpdateActiveGONodeEv, __Z35MonoBehaviour_CUSTOM_StartCoroutineP12Il2CppObjectP12Il2CppStringS0_: __Z35MonoBehaviour_CUSTOM_StartCoroutineP12Il2CppObjectP12Il2CppStringS0_, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_E6getDirEv, __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE: __ZN9ShaderLab7Program14RemoveVariantsERK13dynamic_arrayI16ShaderKeywordSetLj4EE, __Z57Register_UnityEngine_PolygonCollider2D_GetTotalPointCountv: __Z57Register_UnityEngine_PolygonCollider2D_GetTotalPointCountv, __ZN8Animator19GetRecorderStopTimeEv: __ZN8Animator19GetRecorderStopTimeEv, __ZN16b2PrismaticJointC2EPK19b2PrismaticJointDef: __ZN16b2PrismaticJointC2EPK19b2PrismaticJointDef, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERy: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERy, __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z12AddComponentR10GameObjectiP11Il2CppClassPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z44GL_CUSTOM_INTERNAL_CALL_LoadProjectionMatrixRK10Matrix4x4f: __Z44GL_CUSTOM_INTERNAL_CALL_LoadProjectionMatrixRK10Matrix4x4f, __ZN11AudioSource31UpdateEffectVirtualizationStateEb: __ZN11AudioSource31UpdateEffectVirtualizationStateEb, __ZN9ShaderLab26SerializedShaderDependency8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab26SerializedShaderDependency8TransferI24GenerateTypeTreeTransferEEvRT_, __Z89Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResolveHashInternalv: __Z89Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResolveHashInternalv, __ZN17AnimationPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant: __ZN17AnimationPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant, __ZN12AudioManager29ShutdownReinitializeAndReloadEv: __ZN12AudioManager29ShutdownReinitializeAndReloadEv, __ZN24PhysicsUpdateBehaviour2D12AddToManagerEv: __ZN24PhysicsUpdateBehaviour2D12AddToManagerEv, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __ZN5physx28computeVolumeIntegralsEberlyERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsERKNS_6PxVec3E: __ZN5physx28computeVolumeIntegralsEberlyERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsERKNS_6PxVec3E, _UNITY_FT_Match_Size: _UNITY_FT_Match_Size, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE19getConcreteTypeNameEv, __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE: __ZN7mecanim20CreateValueArrayMaskEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE, _free: _free, __ZN5physx6shdfnd7FastIPC11receiveDataERj: __ZN5physx6shdfnd7FastIPC11receiveDataERj, __ZN11UnityEngine7Connect14AppUpdateEventC2Ev: __ZN11UnityEngine7Connect14AppUpdateEventC2Ev, __ZNK10GameObject26GetTypeInfoVirtualInternalEv: __ZNK10GameObject26GetTypeInfoVirtualInternalEv, __ZN12ImageFilters17RemoveImageFilterERK11ImageFilter: __ZN12ImageFilters17RemoveImageFilterERK11ImageFilter, __Z49Rigidbody_Set_Custom_PropMaxDepenetrationVelocityP12Il2CppObjectf: __Z49Rigidbody_Set_Custom_PropMaxDepenetrationVelocityP12Il2CppObjectf, __Z56Register_UnityEngine_QualitySettings_set_maximumLODLevelv: __Z56Register_UnityEngine_QualitySettings_set_maximumLODLevelv, __ZN10GUITexture13GetScreenRectERK5RectTIfE: __ZN10GUITexture13GetScreenRectERK5RectTIfE, __ZNK5Unity5Joint26GetTypeInfoVirtualInternalEv: __ZNK5Unity5Joint26GetTypeInfoVirtualInternalEv, __Z41TerrainData_Get_Custom_PropTreePrototypesP12Il2CppObject: __Z41TerrainData_Get_Custom_PropTreePrototypesP12Il2CppObject, __Z17IsPathNameVisibleRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z17IsPathNameVisibleRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z38Rigidbody_Set_Custom_PropInterpolationP12Il2CppObject22RigidbodyInterpolation: __Z38Rigidbody_Set_Custom_PropInterpolationP12Il2CppObject22RigidbodyInterpolation, __Z46Register_UnityEngine_AI_NavMeshAgent_get_speedv: __Z46Register_UnityEngine_AI_NavMeshAgent_get_speedv, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZZN15DirectorManager15InitializeClassEvEN39PostLateUpdateDirectorRenderImagestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN39PostLateUpdateDirectorRenderImagestruct7ForwardEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj181ENS_22PxRepXPropertyAccessorILj181ENS_14PxParticleBaseEffEEEEvRKT0_, _nan: _nan, __ZN9HaloLayerC2E10MemLabelId18ObjectCreationMode: __ZN9HaloLayerC2E10MemLabelId18ObjectCreationMode, __ZNK14SerializedFile10GetClassIDEx: __ZNK14SerializedFile10GetClassIDEx, __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams: __ZN7dtCrowd21updateAgentParametersERK13dtCrowdHandlePK18dtCrowdAgentParams, __Z57Register_UnityEngine_Animator_SetIKRotationWeightInternalv: __Z57Register_UnityEngine_Animator_SetIKRotationWeightInternalv, __Z29CalculateBoxAreaRadialFrustumP8Vector3fffff: __Z29CalculateBoxAreaRadialFrustumP8Vector3fffff, __ZN5physx22solve1D4Block_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx22solve1D4Block_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _Horizontal_Sweep_Drop: _Horizontal_Sweep_Drop, __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesYv: __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesYv, __ZN13RuntimeStaticI13ModuleManagerE10InitializeEv: __ZN13RuntimeStaticI13ModuleManagerE10InitializeEv, __ZN4Mesh17NotifyObjectUsersERK17MessageIdentifier: __ZN4Mesh17NotifyObjectUsersERK17MessageIdentifier, __ZN15AudioReverbZone14SetMaxDistanceEf: __ZN15AudioReverbZone14SetMaxDistanceEf, __ZN5physx15PxSetFilterBoolEb: __ZN5physx15PxSetFilterBoolEb, __Z58Register_UnityEngine_CharacterJoint_get_projectionDistancev: __Z58Register_UnityEngine_CharacterJoint_get_projectionDistancev, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12getClassSizeEv, __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi: __ZNK10__cxxabiv117__class_type_info24process_found_base_classEPNS_19__dynamic_cast_infoEPvi, __ZN12CullingGroup18SetBoundingSpheresEP11Il2CppArray: __ZN12CullingGroup18SetBoundingSpheresEP11Il2CppArray, __ZN10Matrix3x3fC2ERK10Matrix4x4f: __ZN10Matrix3x3fC2ERK10Matrix4x4f, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetPositionv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetPositionv, __ZN17GeneralConnection10ConnectionC2Ei: __ZN17GeneralConnection10ConnectionC2Ei, __ZN5physx9NpFactory14addRigidStaticEPNS_13PxRigidStaticEb: __ZN5physx9NpFactory14addRigidStaticEPNS_13PxRigidStaticEb, __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK22LocalFileSystemHandler25GetApplicationManagedPathEv: __ZNK22LocalFileSystemHandler25GetApplicationManagedPathEv, __ZN17MemoryCacheReader16UnlockCacheBlockEj: __ZN17MemoryCacheReader16UnlockCacheBlockEj, __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx31collideWithCapsuleNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_S6_: __ZN5physx31collideWithCapsuleNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_S6_, __ZN8GUILayer15ThreadedCleanupEv: __ZN8GUILayer15ThreadedCleanupEv, __ZN5physx10PxsCCDPair16sweepEstimateToiEv: __ZN5physx10PxsCCDPair16sweepEstimateToiEv, __Z45Renderer_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti: __Z45Renderer_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti, _UNITY_png_write_PLTE: _UNITY_png_write_PLTE, __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZL22FindVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthXMultiplierP12Il2CppObject: __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthXMultiplierP12Il2CppObject, __ZN5physx14PxLightCpuTaskD2Ev: __ZN5physx14PxLightCpuTaskD2Ev, __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE6assignINS_11__wrap_iterIPS5_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS5_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_: __ZNSt3__26vectorIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEENS_9allocatorIS5_EEE6assignINS_11__wrap_iterIPS5_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS5_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_, __ZN13GfxDeviceNull28DestroyRenderSurfacePlatformEP17RenderSurfaceBase: __ZN13GfxDeviceNull28DestroyRenderSurfacePlatformEP17RenderSurfaceBase, __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI17PhysicsMaterial2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sc18ParticleSystemCore15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc18ParticleSystemCore15importExtraDataERNS_24PxDeserializationContextE, __ZN12LineRendererD2Ev: __ZN12LineRendererD2Ev, __ZL25ProgramUniformMatrix2x4fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix2x4fvPK7ApiGLESjiihPKv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertINS_11__wrap_iterIPcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISB_EE5valueES9_E4typeENS7_IPKcEESB_SB_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertINS_11__wrap_iterIPcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISB_EE5valueES9_E4typeENS7_IPKcEESB_SB_, __Z54Register_UnityEngine_Terrain_get_treeLODBiasMultiplierv: __Z54Register_UnityEngine_Terrain_get_treeLODBiasMultiplierv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE27__invalidate_iterators_pastEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE27__invalidate_iterators_pastEj, __Z35Register_UnityEngine_Screen_get_dpiv: __Z35Register_UnityEngine_Screen_get_dpiv, __ZNKSt3__219__iostream_category4nameEv: __ZNKSt3__219__iostream_category4nameEv, __ZN12AdsIdHandler31ExecuteAsyncFetchAdsIdJobStaticEPv: __ZN12AdsIdHandler31ExecuteAsyncFetchAdsIdJobStaticEPv, __ZNSt3__28ios_base5imbueERKNS_6localeE: __ZNSt3__28ios_base5imbueERKNS_6localeE, __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIxEEvRT_PKc17TransferMetaFlagsb, __ZN13SpeedTreeWind7AdvanceEbd: __ZN13SpeedTreeWind7AdvanceEbd, __ZN5physx5cloth12horizontalOrE8Scalar4f: __ZN5physx5cloth12horizontalOrE8Scalar4f, __ZN5physx6shdfnd18integrateTransformERKNS_11PxTransformERKNS_6PxVec3ES6_fRS1_: __ZN5physx6shdfnd18integrateTransformERKNS_11PxTransformERKNS_6PxVec3ES6_fRS1_, __ZN6b2Rope7SolveC2Ev: __ZN6b2Rope7SolveC2Ev, __ZNK5physx2Sc9ShapeCore10getPxShapeEv: __ZNK5physx2Sc9ShapeCore10getPxShapeEv, __ZN18GlslGpuProgramGLES19ApplyGpuProgramGLESERK20GpuProgramParametersPKh: __ZN18GlslGpuProgramGLES19ApplyGpuProgramGLESERK20GpuProgramParametersPKh, __ZN15CapsuleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15CapsuleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier58ELi16EEE21__grow_by_and_replaceEjjjjjjPKc, __Z36Scene_CUSTOM_GetLoadingStateInternali: __Z36Scene_CUSTOM_GetLoadingStateInternali, __ZN5physx8debugger14PvdMarshallingIajE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIajE12marshalBlockEPKhPhj, __ZN9Transform16SetLocalPositionERK8Vector3f: __ZN9Transform16SetLocalPositionERK8Vector3f, __ZN12MeshCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN12MeshCollider23VirtualRedirectTransferER14SafeBinaryRead, __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z15Transfer_StringI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12SoundManagerC2Ev: __ZN12SoundManagerC2Ev, _UNITY_tt_face_free_name: _UNITY_tt_face_free_name, __Z76Register_UnityEngine_ParticleSystem_MainModule_GetRandomizeRotationDirectionv: __Z76Register_UnityEngine_ParticleSystem_MainModule_GetRandomizeRotationDirectionv, _UNITY_FT_GlyphSlot_Own_Bitmap: _UNITY_FT_GlyphSlot_Own_Bitmap, __ZN8TypeTree14AppendChildrenERK16TypeTreeIterator: __ZN8TypeTree14AppendChildrenERK16TypeTreeIterator, __ZNK5physx7NpScene32getContactReportStreamBufferSizeEv: __ZNK5physx7NpScene32getContactReportStreamBufferSizeEv, __ZN4FMOD7SystemI14createGeometryEiiPPNS_8GeometryE: __ZN4FMOD7SystemI14createGeometryEiiPPNS_8GeometryE, __ZN12LineRenderer19UpdateTransformInfoEv: __ZN12LineRenderer19UpdateTransformInfoEv, __ZN11ShapeModule8TransferI17RemapPPtrTransferEEvRT_: __ZN11ShapeModule8TransferI17RemapPPtrTransferEEvRT_, __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture: __Z23AddRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureTypeP13RenderTexture, __ZNK19VREyeTextureManager43EstimateEyeTextureMemorySizeWithRenderScaleEP13RenderTexturef: __ZNK19VREyeTextureManager43EstimateEyeTextureMemorySizeWithRenderScaleEP13RenderTexturef, __ZN10ScSceneFnsIN5physx3Scb4BodyEE6removeERNS0_2Sc5SceneERS2_b: __ZN10ScSceneFnsIN5physx3Scb4BodyEE6removeERNS0_2Sc5SceneERS2_b, __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE9push_backERKS9_: __ZNSt3__24listINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE9push_backERKS9_, __ZN14SpriteRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14SpriteRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj154ES2_RKNS_29PxClothMotionConstraintConfigES6_EEKNS_42PxClothMotionConstraintConfigGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj154ES2_RKNS_29PxClothMotionConstraintConfigES6_EEKNS_42PxClothMotionConstraintConfigGeneratedInfoEEEvPjRKT_RT0_, __Z33Screen_Get_Custom_PropOrientationv: __Z33Screen_Get_Custom_PropOrientationv, __ZL17transformVerticesRfS_S_S_PfjPKN5physx6PxVec3EPKhRKNS1_7PxMat33E: __ZL17transformVerticesRfS_S_S_PfjPKN5physx6PxVec3EPKhRKNS1_7PxMat33E, __ZN13WheelCollider17MainThreadCleanupEv: __ZN13WheelCollider17MainThreadCleanupEv, __Z13RegisterClassI9TransformEvv: __Z13RegisterClassI9TransformEvv, __ZN11PlayerPrefs9DeleteKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN11PlayerPrefs9DeleteKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN14UnityAnalytics22HandleCustomEventCountEj: __ZN14UnityAnalytics22HandleCustomEventCountEj, __ZNK5physx11Adjacencies19GetBoundaryVerticesEjPbPKNS_2Gu9TriangleTIjEE: __ZNK5physx11Adjacencies19GetBoundaryVerticesEjPbPKNS_2Gu9TriangleTIjEE, __Z43Register_UnityEngine_Animator_StopRecordingv: __Z43Register_UnityEngine_Animator_StopRecordingv, __ZN18UnityPropertySheet11UnityTexEnv8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18UnityPropertySheet11UnityTexEnv8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z37RenderTexture_Set_Custom_PropIsVolumeP12Il2CppObjecth: __Z37RenderTexture_Set_Custom_PropIsVolumeP12Il2CppObjecth, __ZNK9Rigidbody11GetRotationEv: __ZNK9Rigidbody11GetRotationEv, __ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv: __ZNK6Camera33CalculateFarPlaneWorldSpaceLengthEv, __ZN11NavMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11NavMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN21AudioDistortionFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7mecanim9animation8GetGoalXERKNS0_18ClipMuscleConstantEPKfi: __ZN7mecanim9animation8GetGoalXERKNS0_18ClipMuscleConstantEPKfi, __ZNK25UnityWebRequestJavaScript19GetDownloadProgressEv: __ZNK25UnityWebRequestJavaScript19GetDownloadProgressEv, __ZNK5physx14NpArticulation14getWakeCounterEv: __ZNK5physx14NpArticulation14getWakeCounterEv, _nexttoward: _nexttoward, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, _sep_upsample: _sep_upsample, __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx3Ext13RevoluteJoint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext13RevoluteJoint15importExtraDataERNS_24PxDeserializationContextE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z22getPxShape_IsExclusivePKN5physx7PxShapeE: __Z22getPxShape_IsExclusivePKN5physx7PxShapeE, __ZN18ProceduralMaterial18SetMaterialsBrokenERNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE: __ZN18ProceduralMaterial18SetMaterialsBrokenERNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE, __Z62Register_UnityEngine_Camera_INTERNAL_CALL_WorldToViewportPointv: __Z62Register_UnityEngine_Camera_INTERNAL_CALL_WorldToViewportPointv, __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE: __ZN4FMOD3DSP8getInputEiPPS0_PPNS_13DSPConnectionE, __ZN20dynamic_block_vectorI14FileIdentifierE5clearEv: __ZN20dynamic_block_vectorI14FileIdentifierE5clearEv, __ZZN5Light15InitializeClassEvEN31FunctorImpl_36kTransformChanged4CallEPviR11MessageData: __ZZN5Light15InitializeClassEvEN31FunctorImpl_36kTransformChanged4CallEPviR11MessageData, __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj: __ZN5physx3Scb11RigidObject14resetFilteringEPKPNS0_5ShapeEj, __Z60Register_UnityEngine_SortingLayer_GetSortingLayerIDsInternalv: __Z60Register_UnityEngine_SortingLayer_GetSortingLayerIDsInternalv, __ZN13AudioListenerD2Ev: __ZN13AudioListenerD2Ev, __Z16InitClothManagerv: __Z16InitClothManagerv, _UNITY_FT_Done_Library: _UNITY_FT_Done_Library, __ZN5physx2Sq8AABBTree7releaseEv: __ZN5physx2Sq8AABBTree7releaseEv, __Z56AssetBundleManifest_CUSTOM_GetAllAssetBundlesWithVariantP12Il2CppObject: __Z56AssetBundleManifest_CUSTOM_GetAllAssetBundlesWithVariantP12Il2CppObject, __ZNK9DebugGLES19ProgramDeleteStatusEj: __ZNK9DebugGLES19ProgramDeleteStatusEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN5physx2Sc8ClothSim20clearCollisionShapesEv: __ZN5physx2Sc8ClothSim20clearCollisionShapesEv, __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_: __Z16b2CollideCirclesP10b2ManifoldPK13b2CircleShapeRK11b2TransformS3_S6_, __ZN4FMOD13ChannelGroupI8getPitchEPf: __ZN4FMOD13ChannelGroupI8getPitchEPf, __ZNKSt3__220__codecvt_utf8_utf16IDsE13do_max_lengthEv: __ZNKSt3__220__codecvt_utf8_utf16IDsE13do_max_lengthEv, __Z16SelectDataFolderv: __Z16SelectDataFolderv, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z45getPxVehicleDifferential4WDataMFrontRearSplitPKN5physx27PxVehicleDifferential4WDataE: __Z45getPxVehicleDifferential4WDataMFrontRearSplitPKN5physx27PxVehicleDifferential4WDataE, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8__monthsEv, __ZNK17BaseWebCamTexture9GetPixelsEiiiiP10ColorRGBAf: __ZNK17BaseWebCamTexture9GetPixelsEiiiiP10ColorRGBAf, __Z52DistanceJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject: __Z52DistanceJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject, __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIjEEvRT_PKc17TransferMetaFlags, __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_: __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE10insert_oneERKS2_, __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_: __ZNSt3__26vectorINS_4pairIi14ConstantStringEENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_, __ZN10AudioMixer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10AudioMixer23VirtualRedirectTransferER17RemapPPtrTransfer, __Z32getPxRigidBody_RigidDynamicFlagsPKN5physx11PxRigidBodyE: __Z32getPxRigidBody_RigidDynamicFlagsPKN5physx11PxRigidBodyE, __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_, __ZNSt3__27promiseIvE10get_futureEv: __ZNSt3__27promiseIvE10get_futureEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb, __Z25getPxScene_FilterCallbackPKN5physx7PxSceneE: __Z25getPxScene_FilterCallbackPKN5physx7PxSceneE, __ZN28ParticleSystemSubEmitterDataC2Ev: __ZN28ParticleSystemSubEmitterDataC2Ev, __Z47Register_UnityEngine_CanvasRenderer_SetMaterialv: __Z47Register_UnityEngine_CanvasRenderer_SetMaterialv, __ZN5physx6shdfnd10SocketImpl7connectEPKctj: __ZN5physx6shdfnd10SocketImpl7connectEPKctj, __ZN14MemoryProfiler22GetRootAllocationInfosER13dynamic_arrayINS_18RootAllocationInfoELj4EE: __ZN14MemoryProfiler22GetRootAllocationInfosER13dynamic_arrayINS_18RootAllocationInfoELj4EE, __Z45Register_UnityEngine_OcclusionPortal_set_openv: __Z45Register_UnityEngine_OcclusionPortal_set_openv, __Z53Register_UnityEngine_SkinnedMeshRenderer_set_rootBonev: __Z53Register_UnityEngine_SkinnedMeshRenderer_set_rootBonev, __ZN25CapsuleTraceSegmentReportD0Ev: __ZN25CapsuleTraceSegmentReportD0Ev, __ZN12_GLOBAL__N_117EventBufferClient11isConnectedEv: __ZN12_GLOBAL__N_117EventBufferClient11isConnectedEv, __Z46Register_UnityEngine_Texture3D_Internal_Createv: __Z46Register_UnityEngine_Texture3D_Internal_Createv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getLinearVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getLinearVelocityEv, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetQualityv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetQualityv, __Z13IsPathCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z13IsPathCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN13AudioListener23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13AudioListener23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZThn32_N12MeshRendererD1Ev: __ZThn32_N12MeshRendererD1Ev, __ZN15ParticleEmitter10DeactivateE19DeactivateOperation: __ZN15ParticleEmitter10DeactivateE19DeactivateOperation, __ZN13RenderTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13RenderTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z37Register_UnityEngine_GUIText_set_fontv: __Z37Register_UnityEngine_GUIText_set_fontv, _catan: _catan, __ZNK11ShapeModule25CalculateProceduralBoundsER10MinMaxAABBRK8Vector3f8Vector2f: __ZNK11ShapeModule25CalculateProceduralBoundsER10MinMaxAABBRK8Vector3f8Vector2f, __ZN3MBP12storeHandlesEP10MBP_ObjectjPK15BoxPrunerHandle: __ZN3MBP12storeHandlesEP10MBP_ObjectjPK15BoxPrunerHandle, ___cxa_guard_acquire: ___cxa_guard_acquire, __ZN7Joint2D13SetBreakForceEf: __ZN7Joint2D13SetBreakForceEf, __ZN11GPUProfiler14ComputeGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE: __ZN11GPUProfiler14ComputeGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE, __Z52Register_UnityEngine_AI_OffMeshLink_get_endTransformv: __Z52Register_UnityEngine_AI_OffMeshLink_get_endTransformv, __Z53Register_UnityEngine_ParticleSystem_get_playbackSpeedv: __Z53Register_UnityEngine_ParticleSystem_get_playbackSpeedv, __ZN8Renderer21RendererBecameVisibleEv: __ZN8Renderer21RendererBecameVisibleEv, __ZN10GCProfilerC2Ev: __ZN10GCProfilerC2Ev, __Z49ParticleRenderer_Set_Custom_PropUvAnimationCyclesP12Il2CppObjectf: __Z49ParticleRenderer_Set_Custom_PropUvAnimationCyclesP12Il2CppObjectf, __ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi: __ZNK14b2CapsuleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi, __Z35Register_UnityEngine_Camera_set_hdrv: __Z35Register_UnityEngine_Camera_set_hdrv, __Z13RegisterClassI18PlatformEffector2DEvv: __Z13RegisterClassI18PlatformEffector2DEvv, ___stpncpy: ___stpncpy, __Z43Light_Get_Custom_PropShadowCustomResolutionP12Il2CppObject: __Z43Light_Get_Custom_PropShadowCustomResolutionP12Il2CppObject, __ZNK8VRDevice27GetOverrideStereoSeparationEv: __ZNK8VRDevice27GetOverrideStereoSeparationEv, __ZN10MemoryPool16StaticInitializeEPv: __ZN10MemoryPool16StaticInitializeEPv, __ZN11TypeManager21CleanupGlobalInstanceEv: __ZN11TypeManager21CleanupGlobalInstanceEv, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv, __Z46QualitySettings_Set_Custom_PropMaxQueuedFramesi: __Z46QualitySettings_Set_Custom_PropMaxQueuedFramesi, __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD0Ev: __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD0Ev, _UNITY_LZ4_sizeofStreamState: _UNITY_LZ4_sizeofStreamState, __Z36Physics2D_Get_Custom_PropTimeToSleepv: __Z36Physics2D_Get_Custom_PropTimeToSleepv, __ZN43CapsuleHeightfieldContactGenerationCallbackD0Ev: __ZN43CapsuleHeightfieldContactGenerationCallbackD0Ev, __ZL41AssemblyNameMatchesWithOrWithoutExtensionPKcS0_: __ZL41AssemblyNameMatchesWithOrWithoutExtensionPKcS0_, __Z10md5_updateP11md5_contextPhi: __Z10md5_updateP11md5_contextPhi, __ZN13RendererScene28SceneAfterCullingOutputReadyEPK9IndexListPK16RendererCullData: __ZN13RendererScene28SceneAfterCullingOutputReadyEPK9IndexListPK16RendererCullData, __Z34Animator_Get_Custom_PropFireEventsP12Il2CppObject: __Z34Animator_Get_Custom_PropFireEventsP12Il2CppObject, __ZN4FMOD6SoundI12getLoopCountEPi: __ZN4FMOD6SoundI12getLoopCountEPi, __ZN5physx2Sc9ClothCore21setStiffnessFrequencyEf: __ZN5physx2Sc9ClothCore21setStiffnessFrequencyEf, __ZNK10SampleClip11GetResourceEv: __ZNK10SampleClip11GetResourceEv, __Z16dtAllocSetCustomPFPviEPFvS_ES1_S3_PFS_S_iE: __Z16dtAllocSetCustomPFPviEPFvS_ES1_S3_PFS_S_iE, _UNITY_png_set_filler: _UNITY_png_set_filler, __ZN11MonoManager19GetBuiltinMonoClassEPKcb: __ZN11MonoManager19GetBuiltinMonoClassEPKcb, __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE: __ZN14ParticleSystem8SimulateEfNS_13SimulateFlagsE, __Z43Register_UnityEngine_Event_set_displayIndexv: __Z43Register_UnityEngine_Event_set_displayIndexv, __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11AudioFilter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13SliderJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN13SliderJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx20PxVehicleShiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE: __ZN5physx20PxVehicleShiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7setMassEf: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7setMassEf, __GLOBAL__sub_I_CmEventProfiler_cpp: __GLOBAL__sub_I_CmEventProfiler_cpp, __ZN5Umbra9FloatList7setSizeEi: __ZN5Umbra9FloatList7setSizeEi, __ZN5physx19NpArticulationJoint13setSwingLimitEff: __ZN5physx19NpArticulationJoint13setSwingLimitEff, __Z17SetConsoleLogPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z17SetConsoleLogPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE7reserveEj: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE7reserveEj, __Z56Register_UnityEngine_ReflectionProbe_get_timeSlicingModev: __Z56Register_UnityEngine_ReflectionProbe_get_timeSlicingModev, __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEED0Ev: __ZN18MultiQueryCallbackIN5physx12PxOverlapHitEED0Ev, __ZN5physx2Sc21ArticulationJointCore17setTargetVelocityERKNS_6PxVec3E: __ZN5physx2Sc21ArticulationJointCore17setTargetVelocityERKNS_6PxVec3E, __ZN13BoxCollider2D15ThreadedCleanupEv: __ZN13BoxCollider2D15ThreadedCleanupEv, __Z56Register_UnityEngine_AudioSource_get_ignoreListenerPausev: __Z56Register_UnityEngine_AudioSource_get_ignoreListenerPausev, __ZN20UnloadSceneOperationC2EP10UnityScene: __ZN20UnloadSceneOperationC2EP10UnityScene, __ZThn8_N12_GLOBAL__N_111StreamOwner10disconnectEv: __ZThn8_N12_GLOBAL__N_111StreamOwner10disconnectEv, __ZN5physx23transformBoxOrthonormalERKNS_2Gu3BoxERKNS_11PxTransformE: __ZN5physx23transformBoxOrthonormalERKNS_2Gu3BoxERKNS_11PxTransformE, __ZN17GlobalGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17GlobalGameManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx6shdfnd10Foundation11incRefCountEv: __ZN5physx6shdfnd10Foundation11incRefCountEv, __ZN19UnityConnectServiceD0Ev: __ZN19UnityConnectServiceD0Ev, __ZN39AssetBundleLoadFromMemoryAsyncOperation11FinalizeJobEPv: __ZN39AssetBundleLoadFromMemoryAsyncOperation11FinalizeJobEPv, __Z60ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentColorP12Il2CppObjectR22ParticleSystemParticleR16ColorRGBA32Icall: __Z60ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentColorP12Il2CppObjectR22ParticleSystemParticleR16ColorRGBA32Icall, __Z43Physics_Set_Custom_PropSleepAngularVelocityf: __Z43Physics_Set_Custom_PropSleepAngularVelocityf, __ZNK17ArchiveFileSystem8IsHiddenERK13FileEntryData: __ZNK17ArchiveFileSystem8IsHiddenERK13FileEntryData, __Z42ReflectionProbe_Get_Custom_PropRefreshModeP12Il2CppObject: __Z42ReflectionProbe_Get_Custom_PropRefreshModeP12Il2CppObject, __Z54Register_UnityEngine_TerrainData_get_treeInstanceCountv: __Z54Register_UnityEngine_TerrainData_get_treeInstanceCountv, __ZN5physx11readIndicesEjjPjRNS_13PxInputStreamEb: __ZN5physx11readIndicesEjjPjRNS_13PxInputStreamEb, __ZN5physx2Sc9ClothCore14updateBulkDataERNS0_13ClothBulkDataE: __ZN5physx2Sc9ClothCore14updateBulkDataERNS0_13ClothBulkDataE, __ZNK10PngDecoder6GetCrcEv: __ZNK10PngDecoder6GetCrcEv, __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj, _UnityReplayKitGetBroadcastURL: _UnityReplayKitGetBroadcastURL, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12resize_deltaEjj, __Z61Register_UnityEngine_QualitySettings_get_asyncUploadTimeSlicev: __Z61Register_UnityEngine_QualitySettings_get_asyncUploadTimeSlicev, _start_input_pass_28: _start_input_pass_28, __ZN7mecanim9animation27GetWeightsSimpleDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb: __ZN7mecanim9animation27GetWeightsSimpleDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb, __ZN5physx14PxsAABBManager21setBPElemVolumeBoundsEjRKNS_11IntegerAABBE: __ZN5physx14PxsAABBManager21setBPElemVolumeBoundsEjRKNS_11IntegerAABBE, __ZN11AudioModule27IsFormatSupportedByPlatformEPKc: __ZN11AudioModule27IsFormatSupportedByPlatformEPKc, __Z33getPxArticulationJoint_ParentPosePKN5physx19PxArticulationJointE: __Z33getPxArticulationJoint_ParentPosePKN5physx19PxArticulationJointE, _UNITY_FT_Render_Glyph: _UNITY_FT_Render_Glyph, __ZN13SparseTexture17UploadTileColor32EiiiPK11ColorRGBA32j: __ZN13SparseTexture17UploadTileColor32EiiiPK11ColorRGBA32j, __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z14b2PairLessThanRK6b2PairS1_: __Z14b2PairLessThanRK6b2PairS1_, __Z48Register_UnityEngine_AsyncOperation_set_priorityv: __Z48Register_UnityEngine_AsyncOperation_set_priorityv, __ZNK8Collider10GetEnabledEv: __ZNK8Collider10GetEnabledEv, __ZN9Texture2D5ResetEv: __ZN9Texture2D5ResetEv, __ZN13DrawImmediateC2ER9GfxDevice: __ZN13DrawImmediateC2ER9GfxDevice, __ZN5physx7NpCloth19setVirtualParticlesEjPKjjPKNS_6PxVec3E: __ZN5physx7NpCloth19setVirtualParticlesEjPKjjPKNS_6PxVec3E, __Z46Register_UnityEngine_WheelJoint2D_set_useMotorv: __Z46Register_UnityEngine_WheelJoint2D_set_useMotorv, __ZN7dtCrowd19SetObstacleCylinderERK13dtCrowdHandlePKfS4_S4_S4_: __ZN7dtCrowd19SetObstacleCylinderERK13dtCrowdHandlePKfS4_S4_S4_, __ZN15b2WheelJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_: __ZN15b2WheelJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_, __ZNK25ThreadsafeLinearAllocator22GetAllocatedMemorySizeEv: __ZNK25ThreadsafeLinearAllocator22GetAllocatedMemorySizeEv, _cff_size_request: _cff_size_request, __ZN15DirectorManager14ConnectionPool12SwitchBucketEP14ConnectionList: __ZN15DirectorManager14ConnectionPool12SwitchBucketEP14ConnectionList, __ZN4FMOD5Sound21setMusicChannelVolumeEif: __ZN4FMOD5Sound21setMusicChannelVolumeEif, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __Z24Animator_CUSTOM_HasStateP12Il2CppObjectii: __Z24Animator_CUSTOM_HasStateP12Il2CppObjectii, __ZN17Physics2DSettings23SetChangeStopsCallbacksEb: __ZN17Physics2DSettings23SetChangeStopsCallbacksEb, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx21PxVehicleDriveSimData7isValidEv: __ZNK5physx21PxVehicleDriveSimData7isValidEv, __Z90Register_UnityEngine_Experimental_Director_DirectorPlayer_INTERNAL_CALL_PlayStructInternalv: __Z90Register_UnityEngine_Experimental_Director_DirectorPlayer_INTERNAL_CALL_PlayStructInternalv, _tre_add_tags: _tre_add_tags, __ZN2UI11CompareFuncEPNS_6CanvasES1_: __ZN2UI11CompareFuncEPNS_6CanvasES1_, __Z42ParticleAnimator_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f: __Z42ParticleAnimator_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f, __Z43ParticleSystem_MainModule_CUSTOM_GetPrewarmP12Il2CppObject: __Z43ParticleSystem_MainModule_CUSTOM_GetPrewarmP12Il2CppObject, __ZN5Umbra10StackAlloc10deallocateEPv: __ZN5Umbra10StackAlloc10deallocateEPv, __ZN4FMOD7Channel11set3DSpreadEf: __ZN4FMOD7Channel11set3DSpreadEf, __ZN19SkinnedMeshRenderer23UpdatePreviousFrameDataEv: __ZN19SkinnedMeshRenderer23UpdatePreviousFrameDataEv, _PxBuildSmoothNormals: _PxBuildSmoothNormals, __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb: __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_RKNS_4pix4ER5RandNffbb, __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer16TransferTypelessEPjPKc17TransferMetaFlags, __Z50MaterialPropertyBlock_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_: __Z50MaterialPropertyBlock_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_, __Z34CreateInstanceLateBehaviourManagerv: __Z34CreateInstanceLateBehaviourManagerv, __ZNSt3__27codecvtIwc11__mbstate_tEC2Ej: __ZNSt3__27codecvtIwc11__mbstate_tEC2Ej, __ZN9Animation4PlayEi: __ZN9Animation4PlayEi, __ZN17GenericDynamicVBO17DrawChunkInternalERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationP16DrawBuffersRangeij: __ZN17GenericDynamicVBO17DrawChunkInternalERK21DynamicVBOChunkHandleRK14ChannelAssignsjP17VertexDeclarationP16DrawBuffersRangeij, __ZL18ProgramUniform4uivPK7ApiGLESjiihPKv: __ZL18ProgramUniform4uivPK7ApiGLESjiihPKv, __ZN14b2CapsuleShape13SetByExtentsXEffRK6b2Vec2f: __ZN14b2CapsuleShape13SetByExtentsXEffRK6b2Vec2f, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf, __ZNKSt3__214__codecvt_utf8IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_: __ZNKSt3__214__codecvt_utf8IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_, __ZN11UnityEngine15CloudWebService14DataDispatcher10InitializeERK8UnityStrPvjRNS0_18ICloudJobSchedulerE: __ZN11UnityEngine15CloudWebService14DataDispatcher10InitializeERK8UnityStrPvjRNS0_18ICloudJobSchedulerE, __Z37Register_UnityEngine_GL_get_wireframev: __Z37Register_UnityEngine_GL_get_wireframev, __ZN5Light8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Light8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z17NetworkInitializev: __Z17NetworkInitializev, __ZN21ExecutionOrderManager27SetDefaultExecutionOrderForEPKN5Unity4TypeEii: __ZN21ExecutionOrderManager27SetDefaultExecutionOrderForEPKN5Unity4TypeEii, __ZN5physx9NpFactory18createRigidDynamicERKNS_11PxTransformE: __ZN5physx9NpFactory18createRigidDynamicERKNS_11PxTransformE, __Z29CalculatePolygonSubmergedAreaRK11b2TransformiPK6b2Vec2RK10b2MassDatafRS2_: __Z29CalculatePolygonSubmergedAreaRK11b2TransformiPK6b2Vec2RK10b2MassDatafRS2_, __ZN8Animator17GetTargetRotationEv: __ZN8Animator17GetTargetRotationEv, __ZN2UI11CanvasGroupD0Ev: __ZN2UI11CanvasGroupD0Ev, __Z46ParticleSystem_CollisionModule_CUSTOM_SetPlaneP12Il2CppObjectiS0_: __Z46ParticleSystem_CollisionModule_CUSTOM_SetPlaneP12Il2CppObjectiS0_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKwj, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetEnabledv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetEnabledv, __ZNSt3__26__sortIRNS_6__lessIffEEPfEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIffEEPfEEvT0_S5_T_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIjjEEPjEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIjjEEPjEEbT0_S5_T_, __ZN8Material26SetGlobalIlluminationFlagsE31MaterialGlobalIlluminationFlags: __ZN8Material26SetGlobalIlluminationFlagsE31MaterialGlobalIlluminationFlags, __Z40PhysicsMaterial2D_CUSTOM_Internal_CreateP12Il2CppObjectP12Il2CppString: __Z40PhysicsMaterial2D_CUSTOM_Internal_CreateP12Il2CppObjectP12Il2CppString, __ZNK4Mesh19CanAccessFromScriptEv: __ZNK4Mesh19CanAccessFromScriptEv, __ZNK5physx13PxRigidStatic19getConcreteTypeNameEv: __ZNK5physx13PxRigidStatic19getConcreteTypeNameEv, __Z41Renderer_Set_Custom_PropShadowCastingModeP12Il2CppObject17ShadowCastingMode: __Z41Renderer_Set_Custom_PropShadowCastingModeP12Il2CppObject17ShadowCastingMode, __Z15GetGraphicsCapsv: __Z15GetGraphicsCapsv, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13setBreakForceEff, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEED0Ev: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEED0Ev, __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_highAngularXLimitP12Il2CppObjectRK14SoftJointLimit: __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_highAngularXLimitP12Il2CppObjectRK14SoftJointLimit, __Z42setPxClothStretchConfigStiffnessMultiplierPN5physx20PxClothStretchConfigEf: __Z42setPxClothStretchConfigStiffnessMultiplierPN5physx20PxClothStretchConfigEf, __ZN24CompressedAnimationCurve17CompressQuatCurveERN13AnimationClip15QuaternionCurveE: __ZN24CompressedAnimationCurve17CompressQuatCurveERN13AnimationClip15QuaternionCurveE, __ZNSt3__26__sortIRNS_6__lessIaaEEPaEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIaaEEPaEEvT0_S5_T_, __ZN17AnimationPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE: __ZN17AnimationPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z41ReflectionProbe_Set_Custom_PropClearFlagsP12Il2CppObjecti: __Z41ReflectionProbe_Set_Custom_PropClearFlagsP12Il2CppObjecti, __ZN5physx2Sc8RigidSim25notifyShapeTranformChangeEv: __ZN5physx2Sc8RigidSim25notifyShapeTranformChangeEv, __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb: __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibb, __ZN5physx2Sc9ClothCoreC2ERKNS_11PxTransformERNS0_15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx2Sc9ClothCoreC2ERKNS_11PxTransformERNS0_15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN19TransportJavaScriptD2Ev: __ZN19TransportJavaScriptD2Ev, __ZN5Unity5Joint18SetEnableCollisionEb: __ZN5Unity5Joint18SetEnableCollisionEb, __Z58Register_UnityEngine_SceneManagement_Scene_GetPathInternalv: __Z58Register_UnityEngine_SceneManagement_Scene_GetPathInternalv, __Z52Register_UnityEngine_VR_VRStats_get_gpuTimeLastFramev: __Z52Register_UnityEngine_VR_VRStats_get_gpuTimeLastFramev, __ZN2UI11CanvasGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN2UI11CanvasGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sn12readPropertyERNS0_21RepXVisitorReaderBaseINS_14PxArticulationEEEPS2_RKNS_32PxArticulationLinkCollectionPropE: __ZN5physx2Sn12readPropertyERNS0_21RepXVisitorReaderBaseINS_14PxArticulationEEEPS2_RKNS_32PxArticulationLinkCollectionPropE, _iscntrl: _iscntrl, __Z18Transfer_BlittableI14SafeBinaryReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z63Register_UnityEngine_Application_CanStreamedLevelBeLoadedByNamev: __Z63Register_UnityEngine_Application_CanStreamedLevelBeLoadedByNamev, __ZN16Physics2DManager17OverlapCapsuleAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DP13dynamic_arrayIPS5_Lj4EE: __ZN16Physics2DManager17OverlapCapsuleAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DP13dynamic_arrayIPS5_Lj4EE, __ZN5physx16PxsIslandManager17setEdgeConstraintERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_13PxsConstraintE: __ZN5physx16PxsIslandManager17setEdgeConstraintERKNS_20PxsIslandManagerHookIjLj4294967295EEEPNS_13PxsConstraintE, __Z22GetGameManagerIfExistsi: __Z22GetGameManagerIfExistsi, __ZN13UnityProfiler8LogFrameEP17ProfilerFrameData: __ZN13UnityProfiler8LogFrameEP17ProfilerFrameData, __ZNK6Camera19GetStereoSeparationEv: __ZNK6Camera19GetStereoSeparationEv, __Z22DestroyObjectHighLevelP6Objectb: __Z22DestroyObjectHighLevelP6Objectb, __ZN5physx7NpScene11removeActorERNS_7PxActorEb: __ZN5physx7NpScene11removeActorERNS_7PxActorEb, __ZNK12b2MouseJoint10GetAnchorBEv: __ZNK12b2MouseJoint10GetAnchorBEv, __ZN11NamedObject15ThreadedCleanupEv: __ZN11NamedObject15ThreadedCleanupEv, __ZNK11b2EdgeShape5CloneEP16b2BlockAllocator: __ZNK11b2EdgeShape5CloneEP16b2BlockAllocator, __ZNK5physx2Sc9ClothCore27getNbVirtualParticleWeightsEv: __ZNK5physx2Sc9ClothCore27getNbVirtualParticleWeightsEv, __ZN7mecanim8skeleton19SkeletonMaskElement8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim8skeleton19SkeletonMaskElement8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx9NpPhysics9getScenesEPPNS_7PxSceneEjj: __ZNK5physx9NpPhysics9getScenesEPPNS_7PxSceneEjj, __ZNK5Umbra9Matrix3x3eqERKS0_: __ZNK5Umbra9Matrix3x3eqERKS0_, __ZNKSt3__210moneypunctIwLb0EE16do_negative_signEv: __ZNKSt3__210moneypunctIwLb0EE16do_negative_signEv, __ZN18JobBatchDispatcherC2E11JobPriorityi: __ZN18JobBatchDispatcherC2E11JobPriorityi, __ZN14MessageHandler24MessageIDToParameterTypeEi: __ZN14MessageHandler24MessageIDToParameterTypeEi, __ZThn32_N14SpriteRendererD0Ev: __ZThn32_N14SpriteRendererD0Ev, __ZN8GUIStyle14GetBuiltinFontEv: __ZN8GUIStyle14GetBuiltinFontEv, __Z38LineRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf: __Z38LineRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf, __ZN9GfxDevice13EndFrameStatsEv: __ZN9GfxDevice13EndFrameStatsEv, __ZN19ComputeShaderKernel8TransferI14SafeBinaryReadEEvRT_: __ZN19ComputeShaderKernel8TransferI14SafeBinaryReadEEvRT_, _fchown: _fchown, __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z14RunNativeTestsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZN6b2Body4DumpEv: __ZN6b2Body4DumpEv, __Z41PlatformEffector2D_Get_Custom_PropSideArcP12Il2CppObject: __Z41PlatformEffector2D_Get_Custom_PropSideArcP12Il2CppObject, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj11EEERAT__Kc, _load_post_names: _load_post_names, __ZL34StaticDestroyAudioCustomFilterRootPv: __ZL34StaticDestroyAudioCustomFilterRootPv, __ZN14CachingManager28SetMaximumDiskSpaceAvailableEx: __ZN14CachingManager28SetMaximumDiskSpaceAvailableEx, __ZN12MeshColliderD2Ev: __ZN12MeshColliderD2Ev, __ZN15AABBTreeOverlapIN5physx2Gu15CapsuleAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE: __ZN15AABBTreeOverlapIN5physx2Gu15CapsuleAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE, __ZN19ComputeShaderKernelD2Ev: __ZN19ComputeShaderKernelD2Ev, __ZN12_GLOBAL__N_110DataStream6addRefEv: __ZN12_GLOBAL__N_110DataStream6addRefEv, __Z52Register_UnityEngine_SurfaceEffector2D_set_useBouncev: __Z52Register_UnityEngine_SurfaceEffector2D_set_useBouncev, __ZN10systeminfo21GetTemporaryCachePathEv: __ZN10systeminfo21GetTemporaryCachePathEv, __ZN5physx10PxsContext21destroyContactManagerEPNS_17PxsContactManagerE: __ZN5physx10PxsContext21destroyContactManagerEPNS_17PxsContactManagerE, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __Z50Texture_CUSTOM_SetGlobalAnisotropicFilteringLimitsii: __Z50Texture_CUSTOM_SetGlobalAnisotropicFilteringLimitsii, __ZN5Umbra12QueryContext14visualizeTilesEv: __ZN5Umbra12QueryContext14visualizeTilesEv, __ZNSt3__26locale5__imp12install_fromINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN10HumanTrait10LeftFinger14GetMuscleCountEv: __ZN10HumanTrait10LeftFinger14GetMuscleCountEv, __ZN29AssetBundleLoadAssetOperation7PerformEv: __ZN29AssetBundleLoadAssetOperation7PerformEv, __Z45Register_UnityEngine_ComputeShader_FindKernelv: __Z45Register_UnityEngine_ComputeShader_FindKernelv, __ZN14BillboardAsset9SetBottomEf: __ZN14BillboardAsset9SetBottomEf, __Z46Register_UnityEngine_Projector_set_fieldOfViewv: __Z46Register_UnityEngine_Projector_set_fieldOfViewv, __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI11TerrainDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE: __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE12PrettyPrefixENS_4TypeE, __Z49Register_UnityEngine_AI_NavMeshAgent_SetLayerCostv: __Z49Register_UnityEngine_AI_NavMeshAgent_SetLayerCostv, __ZN14BatchAllocator6CommitERK10MemLabelId: __ZN14BatchAllocator6CommitERK10MemLabelId, __ZNKSt3__210moneypunctIcLb0EE14do_curr_symbolEv: __ZNKSt3__210moneypunctIcLb0EE14do_curr_symbolEv, __ZNKSt3__27codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j: __ZNKSt3__27codecvtIDsc11__mbstate_tE9do_lengthERS1_PKcS5_j, __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE: __ZNSt3__26__treeINS_12__value_typeIj17DetailPatchRenderEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE, __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10Effector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12ScriptMapper8TransferI14SafeBinaryReadEEvRT_: __ZN12ScriptMapper8TransferI14SafeBinaryReadEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10GUIElementD0Ev: __ZN10GUIElementD0Ev, __ZN13AvatarBuilder14NamedTransformaSERKS0_: __ZN13AvatarBuilder14NamedTransformaSERKS0_, __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E: __Z10SetLocalTR15TransformAccessRKN4math7_float3ERKNS0_7_float4E, __ZN18BuoyancyEffector2D10SetDensityEf: __ZN18BuoyancyEffector2D10SetDensityEf, __ZN7mecanim9animation18ClipMuscleConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation18ClipMuscleConstant8TransferI14SafeBinaryReadEEvRT_, __ZNK8VRDevice22CanSetPlayerPauseValueE11PlayerPause: __ZNK8VRDevice22CanSetPlayerPauseValueE11PlayerPause, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6insertENS_11__wrap_iterIPKhEEjRS6_: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6insertENS_11__wrap_iterIPKhEEjRS6_, __ZN12_GLOBAL__N_115StringTableImpl11handleToStrEj: __ZN12_GLOBAL__N_115StringTableImpl11handleToStrEj, __Z37setPxTriangleMeshGeometryTriangleMeshPN5physx22PxTriangleMeshGeometryEPNS_14PxTriangleMeshE: __Z37setPxTriangleMeshGeometryTriangleMeshPN5physx22PxTriangleMeshGeometryEPNS_14PxTriangleMeshE, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_, __ZN5physx7NpScene30setClothInterCollisionDistanceEf: __ZN5physx7NpScene30setClothInterCollisionDistanceEf, __ZN12IFileAdapterD0Ev: __ZN12IFileAdapterD0Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj647ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx28PxTriangleMeshRepXSerializerD0Ev: __ZN5physx28PxTriangleMeshRepXSerializerD0Ev, __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsI5RectTIfEE8TransferI14SafeBinaryReadEEvRS1_RT_, __Z12InitGUIStatei: __Z12InitGUIStatei, __Z70Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistancev: __Z70Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistancev, __ZN5physx7profile32PxProfileMemoryEventRecorderImplD2Ev: __ZN5physx7profile32PxProfileMemoryEventRecorderImplD2Ev, __Z41Register_UnityEngine_Texture_get_wrapModev: __Z41Register_UnityEngine_Texture_get_wrapModev, __Z63Register_UnityEngine_Diagnostics_PlayerConnection_get_connectedv: __Z63Register_UnityEngine_Diagnostics_PlayerConnection_get_connectedv, __Z52Playable_CUSTOM_INTERNAL_CALL_GetOutputCountInternalR9HPlayable: __Z52Playable_CUSTOM_INTERNAL_CALL_GetOutputCountInternalR9HPlayable, __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffness10updateNodeEv: __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffness10updateNodeEv, __Z15SkinMeshMathLibR12SkinMeshInfo: __Z15SkinMeshMathLibR12SkinMeshInfo, __ZThn32_NK8Renderer11GetMaterialEi: __ZThn32_NK8Renderer11GetMaterialEi, __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_: __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_, __Z68Register_UnityEngine_RenderSettings_INTERNAL_get_ambientEquatorColorv: __Z68Register_UnityEngine_RenderSettings_INTERNAL_get_ambientEquatorColorv, __Z41MaterialPropertyBlock_CUSTOM_DestroyBlockP12Il2CppObject: __Z41MaterialPropertyBlock_CUSTOM_DestroyBlockP12Il2CppObject, __ZL30CleanupTerrainScriptingClassesv: __ZL30CleanupTerrainScriptingClassesv, __ZN16PlayerConnection4PollEv: __ZN16PlayerConnection4PollEv, __Z55Register_UnityEngine_PointEffector2D_get_forceVariationv: __Z55Register_UnityEngine_PointEffector2D_get_forceVariationv, __Z24RegisterStrippedTypeInfoI14PhysicMaterialEviPKcS2_: __Z24RegisterStrippedTypeInfoI14PhysicMaterialEviPKcS2_, __ZNSt3__211__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i: __ZNSt3__211__money_putIcE8__formatEPcRS2_S3_jPKcS5_RKNS_5ctypeIcEEbRKNS_10money_base7patternEccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEESL_SL_i, __Z57Register_UnityEngine_WheelCollider_get_suspensionDistancev: __Z57Register_UnityEngine_WheelCollider_get_suspensionDistancev, __ZN17BlendShapeChannel8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17BlendShapeChannel8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4FMOD7SystemI4initEijPv: __ZN4FMOD7SystemI4initEijPv, __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim5human5HumanEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim5human5HumanEEEEvRT_PKc17TransferMetaFlags, __ZN5physx7profile16StringTableEvent9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_17MemoryEventHeaderE: __ZN5physx7profile16StringTableEvent9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_17MemoryEventHeaderE, __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN11PlayerPrefs6SetIntERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __ZN10DynamicVBOC2Ev: __ZN10DynamicVBOC2Ev, __ZNK13RendererScene21GetDynamicObjectCountEv: __ZNK13RendererScene21GetDynamicObjectCountEv, __ZNK12CubemapArray20GetStorageMemorySizeEv: __ZNK12CubemapArray20GetStorageMemorySizeEv, __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddTorquev: __Z54Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddTorquev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __Z53Register_UnityEngine_AndroidJNI_CallStaticShortMethodv: __Z53Register_UnityEngine_AndroidJNI_CallStaticShortMethodv, __ZN5physx15PxsParticleData16removeParticlesVEjRKNS_16PxStrideIteratorIKjEE: __ZN5physx15PxsParticleData16removeParticlesVEjRKNS_16PxStrideIteratorIKjEE, __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode2EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf: __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode2EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf, __ZN19CloudServiceHandler17StartEventHandlerERK8UnityStrii: __ZN19CloudServiceHandler17StartEventHandlerERK8UnityStrii, __Z41ParticleSystem_ShapeModule_CUSTOM_SetMeshP12Il2CppObjectS0_: __Z41ParticleSystem_ShapeModule_CUSTOM_SetMeshP12Il2CppObjectS0_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE15reserveInternalEj, __ZN14PhysicMaterial18GetFrictionCombineEv: __ZN14PhysicMaterial18GetFrictionCombineEv, __Z17GetRenderSettingsv: __Z17GetRenderSettingsv, __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI23ManagedObjectTransfererEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI23ManagedObjectTransfererEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_VR_InputTracking_Recenterv: __Z46Register_UnityEngine_VR_InputTracking_Recenterv, __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_110parse_typeINS0_2DbEEEPKcS4_S4_RT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj501ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj501ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu11HeightField8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx2Gu11HeightField8requiresERNS_23PxProcessPxBaseCallbackE, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveScalev: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveScalev, _compress_first_pass: _compress_first_pass, __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef: __ZN7Joint2D19FinalizeCreateJointEP10b2JointDef, _match_bracket: _match_bracket, __Z42Register_UnityEngine_GUIStyle_set_wordWrapv: __Z42Register_UnityEngine_GUIStyle_set_wordWrapv, _UNITY_FT_Destroy_Class_tt_driver_class: _UNITY_FT_Destroy_Class_tt_driver_class, _isprint_l: _isprint_l, __ZNK13SpeedTreeWind9GetParamsEv: __ZNK13SpeedTreeWind9GetParamsEv, __ZN9Behaviour6UpdateEv: __ZN9Behaviour6UpdateEv, __Z49Transform_CUSTOM_INTERNAL_CALL_TransformDirectionP12Il2CppObjectRK8Vector3fRS1_: __Z49Transform_CUSTOM_INTERNAL_CALL_TransformDirectionP12Il2CppObjectRK8Vector3fRS1_, __Z26Animator_CUSTOM_GetFloatIDP12Il2CppObjecti: __Z26Animator_CUSTOM_GetFloatIDP12Il2CppObjecti, __ZN5Umbra7ImpTome19getPrivateStatisticEPKS0_NS_16PrivateStatisticE: __ZN5Umbra7ImpTome19getPrivateStatisticEPKS0_NS_16PrivateStatisticE, __ZNK5physx10PxsContext15getNumSweepHitsEv: __ZNK5physx10PxsContext15getNumSweepHitsEv, __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv: __ZNK9Transform28GetLocalToWorldMatrixNoScaleEv, __ZN5physx12NpBatchQuery5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheEf: __ZN5physx12NpBatchQuery5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheEf, __Z42Register_UnityEngine_Behaviour_get_enabledv: __Z42Register_UnityEngine_Behaviour_get_enabledv, __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR17DetailNodeYSorterP16DetailMeshBVNodeEEvT0_S5_T_, __ZNK5physx2Gu12TriangleMesh14getNbTrianglesEv: __ZNK5physx2Gu12TriangleMesh14getNbTrianglesEv, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev, __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z51Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Invertv: __Z51Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Invertv, __ZNK5physx3Cct13HandleManager9GetObjectEj: __ZNK5physx3Cct13HandleManager9GetObjectEj, __Z21FindTypeTreeSeperatorPKc: __Z21FindTypeTreeSeperatorPKc, __ZN13AnimationClip9PPtrCurveC2ERKS0_: __ZN13AnimationClip9PPtrCurveC2ERKS0_, __Z38Caching_Set_Custom_PropExpirationDelayi: __Z38Caching_Set_Custom_PropExpirationDelayi, __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc20ArticulationJointSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __Z34Hash128_CUSTOM_INTERNAL_CALL_ParseP12Il2CppStringR7Hash128: __Z34Hash128_CUSTOM_INTERNAL_CALL_ParseP12Il2CppStringR7Hash128, __Z44SystemInfo_Get_Custom_PropGraphicsDeviceTypev: __Z44SystemInfo_Get_Custom_PropGraphicsDeviceTypev, __Z47Register_UnityEngine_Projector_set_orthographicv: __Z47Register_UnityEngine_Projector_set_orthographicv, __Z28Screen_Get_Custom_PropHeightv: __Z28Screen_Get_Custom_PropHeightv, __Z53Register_UnityEngine_Rendering_CommandBuffer_set_namev: __Z53Register_UnityEngine_Rendering_CommandBuffer_set_namev, __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI14SafeBinaryReadEEvRT_: __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI14SafeBinaryReadEEvRT_, __ZNK13SliderJoint2D13GetLimitStateEv: __ZNK13SliderJoint2D13GetLimitStateEv, __ZN30AudioEffectInternalDescriptionD2Ev: __ZN30AudioEffectInternalDescriptionD2Ev, __ZN5physx16correlatePatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjj: __ZN5physx16correlatePatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjj, __ZNK17ProceduralTexture26GetTypeInfoVirtualInternalEv: __ZNK17ProceduralTexture26GetTypeInfoVirtualInternalEv, __Z32AndroidJNI_CUSTOM_SetDoubleField13Il2Cpp_IntPtrS_d: __Z32AndroidJNI_CUSTOM_SetDoubleField13Il2Cpp_IntPtrS_d, __Z48CommandBuffer_CUSTOM_SetGlobalFloatArrayListImplP12Il2CppObjectiS0_: __Z48CommandBuffer_CUSTOM_SetGlobalFloatArrayListImplP12Il2CppObjectiS0_, __ZN5physx3Ext19ProfileEventHandler11onStopEventERKNS_16PxProfileEventIdEjyhhy: __ZN5physx3Ext19ProfileEventHandler11onStopEventERKNS_16PxProfileEventIdEjyhhy, __ZNK14ParticleSystem14GetSecPositionEv: __ZNK14ParticleSystem14GetSecPositionEv, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE19resizeUninitializedEj, _UNITY_ft_glyphslot_set_bitmap: _UNITY_ft_glyphslot_set_bitmap, __ZNKSt3__210moneypunctIcLb0EE16do_decimal_pointEv: __ZNKSt3__210moneypunctIcLb0EE16do_decimal_pointEv, __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader: __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader, __ZN5physx2Gu5RTree8Callback7profileEv: __ZN5physx2Gu5RTree8Callback7profileEv, __Z41LightmapSettings_Get_Custom_PropLightmapsv: __Z41LightmapSettings_Get_Custom_PropLightmapsv, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE14setOwnerClientEh, __Z40Rigidbody_Get_Custom_PropUseConeFrictionP12Il2CppObject: __Z40Rigidbody_Get_Custom_PropUseConeFrictionP12Il2CppObject, __ZNK29LineParametersPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK29LineParametersPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN6prcoreL11inner_clearILj3EEEvPhjjj: __ZN6prcoreL11inner_clearILj3EEEvPhjjj, __ZN5physx2Gu23computeMTD_SphereConvexERNS_6PxVec3ERfRKNS0_6SphereERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu23computeMTD_SphereConvexERNS_6PxVec3ERfRKNS0_6SphereERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE, __ZN8DrawUtil15DrawTextMeshRawERK14ChannelAssignsR4MeshR23DefaultMeshVertexFormat: __ZN8DrawUtil15DrawTextMeshRawERK14ChannelAssignsR4MeshR23DefaultMeshVertexFormat, __ZN11UnityEngine9Analytics9PerfEventD2Ev: __ZN11UnityEngine9Analytics9PerfEventD2Ev, __ZN5Mutex4LockEv: __ZN5Mutex4LockEv, __Z29FindReflectionProbeFromAnchorP9TransformRK4AABBRS1_RsS5_: __Z29FindReflectionProbeFromAnchorP9TransformRK4AABBRS1_RsS5_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj93ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj93ES3_PKcS8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getSimulationFilterDataEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getSimulationFilterDataEv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE10getInvMassEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE10getInvMassEv, __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13BoneInfluenceLj16EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13BoneInfluenceLj16EEEEvRT_17TransferMetaFlags, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEES9_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5eraseENS_11__wrap_iterIPKcEES9_, __ZNSt3__217moneypunct_bynameIwLb1EED0Ev: __ZNSt3__217moneypunct_bynameIwLb1EED0Ev, __ZN13GfxDeviceGLES20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi: __ZN13GfxDeviceGLES20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi, __Z14SetPlayerPause11PlayerPauseb: __Z14SetPlayerPause11PlayerPauseb, __ZN5physx14PxVehicleGraph15setupWheelGraphEffffRKNS_6PxVec3ES3_S3_: __ZN5physx14PxVehicleGraph15setupWheelGraphEffffRKNS_6PxVec3ES3_S3_, __Z33Collider2D_Get_Custom_PropDensityP12Il2CppObject: __Z33Collider2D_Get_Custom_PropDensityP12Il2CppObject, __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera: __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4Mesh4PPtrI8MaterialEi17ShadowCastingModebiP6Camera, __Z14DecompressBC45iiiPKjPjb: __Z14DecompressBC45iiiPKjPjb, __Z25setPxPrismaticJoint_LimitPN5physx16PxPrismaticJointERKNS_22PxJointLinearLimitPairE: __Z25setPxPrismaticJoint_LimitPN5physx16PxPrismaticJointERKNS_22PxJointLinearLimitPairE, __Z12LookupSymbolPvRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __Z12LookupSymbolPvRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZMultiplierv, __ZNK11LightProbes26GetTypeInfoVirtualInternalEv: __ZNK11LightProbes26GetTypeInfoVirtualInternalEv, __ZNSt3__28ios_base7failureD2Ev: __ZNSt3__28ios_base7failureD2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj446ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj446ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx11PxMeshQuery22findOverlapHeightFieldERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_PjjjRb: __ZN5physx11PxMeshQuery22findOverlapHeightFieldERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_PjjjRb, __Z36Animator_Get_Custom_PropPlaybackTimeP12Il2CppObject: __Z36Animator_Get_Custom_PropPlaybackTimeP12Il2CppObject, __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED0Ev, __ZN15NavMeshObstacle13AwakeFromLoadE17AwakeFromLoadMode: __ZN15NavMeshObstacle13AwakeFromLoadE17AwakeFromLoadMode, __ZN15b2RevoluteJoint9SetLimitsEff: __ZN15b2RevoluteJoint9SetLimitsEff, __Z50Register_UnityEngine_Application_get_streamedBytesv: __Z50Register_UnityEngine_Application_get_streamedBytesv, __ZN7mecanim5human5Human8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim5human5Human8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN8GradientD2Ev: __ZN8GradientD2Ev, __ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_: __ZN5physx2Gu18intersectRaySphereERKNS_6PxVec3ES3_fS3_fRfPS1_, __ZN18ShadowMapJobHeaderD0Ev: __ZN18ShadowMapJobHeaderD0Ev, __Z25Event_CUSTOM_Internal_UseP12Il2CppObject: __Z25Event_CUSTOM_Internal_UseP12Il2CppObject, __ZN15SkyboxGenerator18GetSixFaceSkyboxVBEv: __ZN15SkyboxGenerator18GetSixFaceSkyboxVBEv, __ZL28CleanupModule_ParticleSystemv: __ZL28CleanupModule_ParticleSystemv, __ZNK14UnityWebStream8IsCachedEv: __ZNK14UnityWebStream8IsCachedEv, __Z27setPxSceneLimitsMaxNbActorsPN5physx13PxSceneLimitsEj: __Z27setPxSceneLimitsMaxNbActorsPN5physx13PxSceneLimitsEj, __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetModev: __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetModev, __ZN14NavMeshManager23RemoveOffMeshConnectionEy: __ZN14NavMeshManager23RemoveOffMeshConnectionEy, __Z50Register_UnityEngine_CubemapArray_get_cubemapCountv: __Z50Register_UnityEngine_CubemapArray_get_cubemapCountv, __ZN5physx28PxRigidDynamicRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx28PxRigidDynamicRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN14MemoryProfiler18RegisterAllocationEPvRK10MemLabelIdPKcij: __ZN14MemoryProfiler18RegisterAllocationEPvRK10MemLabelIdPKcij, __ZNK14b2PolygonShape9TestPointERK11b2TransformRK6b2Vec2: __ZNK14b2PolygonShape9TestPointERK11b2TransformRK6b2Vec2, __Z19profiler_start_mode12ProfilerMode: __Z19profiler_start_mode12ProfilerMode, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmcc, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED0Ev: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendIPcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN5physx7NpCloth16setContactOffsetEf: __ZN5physx7NpCloth16setContactOffsetEf, __ZN7dtCrowdD2Ev: __ZN7dtCrowdD2Ev, __ZN5physx7NpCloth23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx7NpCloth23setSimulationFilterDataERKNS_12PxFilterDataE, __ZN15b2QueryCallbackD2Ev: __ZN15b2QueryCallbackD2Ev, _UNITY_png_write_bKGD: _UNITY_png_write_bKGD, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN15TextureSettings14GetAnisoLimitsERiS0_: __ZN15TextureSettings14GetAnisoLimitsERiS0_, _common_181: _common_181, __ZNK9dtNavMesh11getMaxTilesEv: __ZNK9dtNavMesh11getMaxTilesEv, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17resolveReferencesERNS_24PxDeserializationContextE, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPcic: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPcic, __Z44Register_UnityEngine_GUI_Internal_SetTooltipv: __Z44Register_UnityEngine_GUI_Internal_SetTooltipv, __ZN5physx2Sc5Scene23postIslandGenSecondPassEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene23postIslandGenSecondPassEPNS_10PxBaseTaskE, __ZN6HelperI24GenerateTypeTreeTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI24GenerateTypeTreeTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN4Mesh14ResizeVerticesEjj: __ZN4Mesh14ResizeVerticesEjj, __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv: __ZN5physx3Cct26CharacterControllerManager21resetObstaclesBuffersEv, __ZN14SubstanceInput8TransferI14SafeBinaryReadEEvRT_: __ZN14SubstanceInput8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj622ES3_RKNS_27PxVehicleTireLoadFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj622ES3_RKNS_27PxVehicleTireLoadFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN3MBP11shiftOriginERKN5physx6PxVec3E: __ZN3MBP11shiftOriginERKN5physx6PxVec3E, __Z23GUI_CUSTOM_FocusControlP12Il2CppString: __Z23GUI_CUSTOM_FocusControlP12Il2CppString, __ZN16b2ContactManager7CollideEv: __ZN16b2ContactManager7CollideEv, __Z51MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf: __Z51MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf, __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5audio5mixer14EffectConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26localeC2ERKS0_: __ZNSt3__26localeC2ERKS0_, __ZdlPvRKSt9nothrow_t: __ZdlPvRKSt9nothrow_t, __Z46ParticleSystem_CollisionModule_CUSTOM_GetPlaneP12Il2CppObjecti: __Z46ParticleSystem_CollisionModule_CUSTOM_GetPlaneP12Il2CppObjecti, __ZN5Unity5Joint10DeactivateE19DeactivateOperation: __ZN5Unity5Joint10DeactivateE19DeactivateOperation, __ZNK5physx11NpAggregate14getMaxNbActorsEv: __ZNK5physx11NpAggregate14getMaxNbActorsEv, __ZN15CapsuleCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f: __ZN15CapsuleCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20TextRenderingPrivate8TextMesh10SetTabSizeEf: __ZN20TextRenderingPrivate8TextMesh10SetTabSizeEf, __ZN7mecanim5human12DestroyHumanEPNS0_5HumanERNS_6memory9AllocatorE: __ZN7mecanim5human12DestroyHumanEPNS0_5HumanERNS_6memory9AllocatorE, __Z46Terrain_Get_Custom_PropTreeMaximumFullLODCountP12Il2CppObject: __Z46Terrain_Get_Custom_PropTreeMaximumFullLODCountP12Il2CppObject, __ZN9BoxPruner9addObjectERK5IAABBjb: __ZN9BoxPruner9addObjectERK5IAABBjb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN7Joint2D15ThreadedCleanupEv: __ZN7Joint2D15ThreadedCleanupEv, __ZN5physx14NpRigidDynamic11clearTorqueENS_11PxForceMode4EnumE: __ZN5physx14NpRigidDynamic11clearTorqueENS_11PxForceMode4EnumE, __Z25setPxActor_DominanceGroupPN5physx7PxActorEh: __Z25setPxActor_DominanceGroupPN5physx7PxActorEh, _jpeg_calc_output_dimensions: _jpeg_calc_output_dimensions, __Z12CancelInvokeR13MonoBehaviourR11ICallString: __Z12CancelInvokeR13MonoBehaviourR11ICallString, __ZN5Cache32GetCachingDiskSpaceFreeAndUsableEv: __ZN5Cache32GetCachingDiskSpaceFreeAndUsableEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EEw: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EEw, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZN2UI11DoSyncDepthERNS_13UIInstructionEi: __ZN2UI11DoSyncDepthERNS_13UIInstructionEi, __ZN5physx2Sc9ClothCore19setVirtualParticlesEjPKjjPKNS_6PxVec3E: __ZN5physx2Sc9ClothCore19setVirtualParticlesEjPKjjPKNS_6PxVec3E, __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z41Register_UnityEngine_PlayerPrefs_GetFloatv: __Z41Register_UnityEngine_PlayerPrefs_GetFloatv, __ZN9UdpSocket12SetBroadcastEv: __ZN9UdpSocket12SetBroadcastEv, __ZN11UnityEngine15CloudWebService13WWWRestClient6IsDoneEv: __ZN11UnityEngine15CloudWebService13WWWRestClient6IsDoneEv, __Z44getPxVehicleWheelsSimData_TireLoadFilterDataPKN5physx22PxVehicleWheelsSimDataE: __Z44getPxVehicleWheelsSimData_TireLoadFilterDataPKN5physx22PxVehicleWheelsSimDataE, __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetEnabledv: __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetEnabledv, __Z44Register_UnityEngine_Camera_get_orthographicv: __Z44Register_UnityEngine_Camera_get_orthographicv, __ZL28HullProjectionCB_SmallConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_: __ZL28HullProjectionCB_SmallConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z44Register_UnityEngine_AreaEffector2D_set_dragv: __Z44Register_UnityEngine_AreaEffector2D_set_dragv, __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z7HasARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z49getPxVehicleSuspensionDataMCamberAtMaxCompressionPKN5physx23PxVehicleSuspensionDataE: __Z49getPxVehicleSuspensionDataMCamberAtMaxCompressionPKN5physx23PxVehicleSuspensionDataE, __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN17CapsuleCollider2DC2E10MemLabelId18ObjectCreationMode: __ZN17CapsuleCollider2DC2E10MemLabelId18ObjectCreationMode, __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj, __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj: __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjjj, __ZN25PathNamePersistentManager28InsertFileIdentifierInternalE14FileIdentifierb: __ZN25PathNamePersistentManager28InsertFileIdentifierInternalE14FileIdentifierb, __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb: __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_4BoxVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb, __ZN13DrawImmediate6CreateEv: __ZN13DrawImmediate6CreateEv, __ZN21AnimationClipPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE: __ZN21AnimationClipPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE, __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv: __ZNK5physx2Sc15ClothFabricCore11getNbPhasesEv, __Z23dtMergeCorridorEndMovedPyiiPKyi: __Z23dtMergeCorridorEndMovedPyiiPKyi, __ZN27ForceModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN27ForceModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZNK5physx15PxsParticleData13getParticlesVERNS_30PxvParticleSystemStateDataDescEbb: __ZNK5physx15PxsParticleData13getParticlesVERNS_30PxvParticleSystemStateDataDescEbb, __ZNK13SparseTexture12GetDimensionEv: __ZNK13SparseTexture12GetDimensionEv, __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackEi: __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackEi, _putchar: _putchar, __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEiiRiS8_: __ZNK13ScreenManager21FindClosestResolutionERKNSt3__26vectorINS_10ResolutionENS0_9allocatorIS2_EEEEiiRiS8_, __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_: __ZN14dense_hash_mapIiP4RTTIN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEE4findERS9_, __Z48Register_UnityEngine_Canvas_get_sortingLayerNamev: __Z48Register_UnityEngine_Canvas_get_sortingLayerNamev, __ZNK13GfxDeviceNull14IsShaderActiveE10ShaderType: __ZNK13GfxDeviceNull14IsShaderActiveE10ShaderType, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKcj, _grantpt: _grantpt, __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_FT_Get_Next_Char: _UNITY_FT_Get_Next_Char, __ZNKSt3__210moneypunctIwLb0EE8groupingEv: __ZNKSt3__210moneypunctIwLb0EE8groupingEv, __ZN7Terrain14SetDynamicUVSTERK8Vector4fS2_: __ZN7Terrain14SetDynamicUVSTERK8Vector4fS2_, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags, __ZN6Object20NamespaceFromClassIDEi: __ZN6Object20NamespaceFromClassIDEi, __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __ZNK9dtNavMesh12getFirstLinkEy: __ZNK9dtNavMesh12getFirstLinkEy, __ZN21LightProbeProxyVolume16CheckConsistencyEv: __ZN21LightProbeProxyVolume16CheckConsistencyEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN19RuntimeSceneManager26IsLevelManagerOwnedBySceneEP11GameManager: __ZN19RuntimeSceneManager26IsLevelManagerOwnedBySceneEP11GameManager, __Z37getPxVehicleDriveDynDataMUseAutoGearsPKN5physx21PxVehicleDriveDynDataE: __Z37getPxVehicleDriveDynDataMUseAutoGearsPKN5physx21PxVehicleDriveDynDataE, __ZN17PersistentManager22CountInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager22CountInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZnwjRK10MemLabelIdiPKci: __ZnwjRK10MemLabelIdiPKci, __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_: __ZNSt3__26vectorINS_4pairIiiEE13stl_allocatorIS2_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_, __ZN10SizeModuleD2Ev: __ZN10SizeModuleD2Ev, __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_: __ZN4FMOD12ChannelGroup14getParentGroupEPPS0_, __ZN5physx2Sq17AABBTreeUpdateMap7initMapEjRKNS0_8AABBTreeE: __ZN5physx2Sq17AABBTreeUpdateMap7initMapEjRKNS0_8AABBTreeE, __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN7mecanim12statemachine20StateMachineConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim12statemachine20StateMachineConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN31ParticleSystemParticlesTempDataC2Ejbbb: __ZN31ParticleSystemParticlesTempDataC2Ejbbb, __ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii: __ZN9Texture2D22GetWriteImageReferenceEP14ImageReferenceii, __GLOBAL__sub_I_runtime_imgui_lump_cpp: __GLOBAL__sub_I_runtime_imgui_lump_cpp, __Z40Register_UnityEngine_Caching_set_enabledv: __Z40Register_UnityEngine_Caching_set_enabledv, __Z29StdTemplateConversionFunctionIsxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsxEbPvR14SafeBinaryRead, __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_: __ZN19ShaderPropertySheet24SetTextureScaleAndOffsetERKN9ShaderLab16FastPropertyNameE8Vector2fS4_, __Z67Register_UnityEngine_ComputeBuffer_INTERNAL_CALL_GetNativeBufferPtrv: __Z67Register_UnityEngine_ComputeBuffer_INTERNAL_CALL_GetNativeBufferPtrv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv, __ZN8DateTime21FromSecondsSinceEpochEy: __ZN8DateTime21FromSecondsSinceEpochEy, __ZNK14ImageReference9ClipImageEiiii: __ZNK14ImageReference9ClipImageEiiii, __ZN4MeshC2E10MemLabelId18ObjectCreationMode: __ZN4MeshC2E10MemLabelId18ObjectCreationMode, __Z47Register_UnityEngine_AudioReverbFilter_set_roomv: __Z47Register_UnityEngine_AudioReverbFilter_set_roomv, __ZN18DownloadHandlerVFS13OnReceiveDataEPKvj: __ZN18DownloadHandlerVFS13OnReceiveDataEPKvj, __Z30getPxParticleBase_ParticleMassPKN5physx14PxParticleBaseE: __Z30getPxParticleBase_ParticleMassPKN5physx14PxParticleBaseE, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEEEvPT_jRKT0_RKT1_j, __ZN10Matrix4x4f30SetPositionAndOrthoNormalBasisERK8Vector3fS2_S2_S2_: __ZN10Matrix4x4f30SetPositionAndOrthoNormalBasisERK8Vector3fS2_S2_S2_, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEvPT_jRKT0_RKT1_j, __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5RectTIfE8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7mecanim8skeleton8IdentityIN4math7affineXEEET_v: __ZN7mecanim8skeleton8IdentityIN4math7affineXEEET_v, __Z8allEqualRK8Scalar4fS1_: __Z8allEqualRK8Scalar4fS1_, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE25getRelativeLinearVelocityEv, __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj: __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj, __Z55Register_UnityEngine_LightProbeGroup_set_probePositionsv: __Z55Register_UnityEngine_LightProbeGroup_set_probePositionsv, __Z55Register_UnityEngine_QualitySettings_get_shadowDistancev: __Z55Register_UnityEngine_QualitySettings_get_shadowDistancev, __ZN22DownloadHandlerTextureD0Ev: __ZN22DownloadHandlerTextureD0Ev, __ZN19StreamedBinaryWriteILb0EE8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags, __Z25Mesh_CUSTOM_CombineMeshesP12Il2CppObjectP11Il2CppArrayhh: __Z25Mesh_CUSTOM_CombineMeshesP12Il2CppObjectP11Il2CppArrayhh, __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_: __Z16runNpPCMBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_, __Z14UsedBlockCountPvjiS_: __Z14UsedBlockCountPvjiS_, __Z53Register_UnityEngine_Terrain_set_collectDetailPatchesv: __Z53Register_UnityEngine_Terrain_set_collectDetailPatchesv, __ZN5physx7NpScene14resetFilteringERNS_7PxActorE: __ZN5physx7NpScene14resetFilteringERNS_7PxActorE, _UNITY_LZ4_resetStream: _UNITY_LZ4_resetStream, __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags, __ZN27GenericSlowGarbageCollector16ProcessReferenceEi: __ZN27GenericSlowGarbageCollector16ProcessReferenceEi, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZN5physx54PxVehicleDriveSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE: __ZN5physx54PxVehicleDriveSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE, __Z32Shader_Get_Custom_PropMaximumLODP12Il2CppObject: __Z32Shader_Get_Custom_PropMaximumLODP12Il2CppObject, __Z38Camera_Set_Custom_PropOrthographicSizeP12Il2CppObjectf: __Z38Camera_Set_Custom_PropOrthographicSizeP12Il2CppObjectf, __Z27setPxSceneDescSpuDispatcherPN5physx11PxSceneDescEPNS_15PxSpuDispatcherE: __Z27setPxSceneDescSpuDispatcherPN5physx11PxSceneDescEPNS_15PxSpuDispatcherE, __ZN11UnityEngine15CloudWebService14DataDispatcher19OnDataBlockConsumedEv: __ZN11UnityEngine15CloudWebService14DataDispatcher19OnDataBlockConsumedEv, _setservent: _setservent, __ZN10HumanTrait9GetParentEi: __ZN10HumanTrait9GetParentEi, __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10Collider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z48Register_UnityEngine_LineRenderer_get_startWidthv: __Z48Register_UnityEngine_LineRenderer_get_startWidthv, __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_S2_: __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_S2_, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYMultiplierv, __ZN21UnityWebStream_Static13ReadBigEndianERPKhS1_Rj: __ZN21UnityWebStream_Static13ReadBigEndianERPKhS1_Rj, __Z62UnityEventQueueSystem_CUSTOM_INTERNAL_CALL_GetGlobalEventQueueRPv: __Z62UnityEventQueueSystem_CUSTOM_INTERNAL_CALL_GetGlobalEventQueueRPv, __Z18FilterCubeSurfacesP13CImageSurfaceS0_fibfiiifR17PrecomputeContextR15ProgressContext: __Z18FilterCubeSurfacesP13CImageSurfaceS0_fibfiiifR17PrecomputeContextR15ProgressContext, __ZN8TToArray15CoordinateCountI8Vector3fEEiv: __ZN8TToArray15CoordinateCountI8Vector3fEEiv, __Z8heapFreePvS_: __Z8heapFreePvS_, __ZNK9AudioClip16GetMoviePlaybackEv: __ZNK9AudioClip16GetMoviePlaybackEv, __ZN19BaseConnectSettingsD0Ev: __ZN19BaseConnectSettingsD0Ev, _fopen: _fopen, __ZN20TextRenderingPrivate8FontImplD2Ev: __ZN20TextRenderingPrivate8FontImplD2Ev, __Z49Register_UnityEngine_Rigidbody_get_freezeRotationv: __Z49Register_UnityEngine_Rigidbody_get_freezeRotationv, __ZNK19TouchPhaseEmulation13GetTouchCountEv: __ZNK19TouchPhaseEmulation13GetTouchCountEv, __ZN14SafeBinaryRead4InitERS_: __ZN14SafeBinaryRead4InitERS_, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN15ConstantForce2D8TransferI14SafeBinaryReadEEvRT_: __ZN15ConstantForce2D8TransferI14SafeBinaryReadEEvRT_, __ZN5physx5cloth8SwFabric18scaleTetherLengthsEf: __ZN5physx5cloth8SwFabric18scaleTetherLengthsEf, __ZN5physx2Sc10NPhaseCore16createFilterPairEv: __ZN5physx2Sc10NPhaseCore16createFilterPairEv, __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowMagnitudev: __Z57Register_UnityEngine_BuoyancyEffector2D_get_flowMagnitudev, __ZN12TreeRenderer28UpdateBillboardAssetPointersEv: __ZN12TreeRenderer28UpdateBillboardAssetPointersEv, __Z23TransferScriptingObjectI18StreamedBinaryReadILb1EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI18StreamedBinaryReadILb1EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __Z8WrapTimefRKNSt3__24pairIffEEi: __Z8WrapTimefRKNSt3__24pairIffEEi, __Z52ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve: __Z52ParticleSystem_EmissionModule_CUSTOM_SetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve, __ZNK17AnimationCurveTplI8Vector3fE8EvaluateEfPNS1_5CacheE: __ZNK17AnimationCurveTplI8Vector3fE8EvaluateEfPNS1_5CacheE, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN5Umbra19getRuntimeInfoValueENS_9InfoValueE: __ZN5Umbra19getRuntimeInfoValueENS_9InfoValueE, __ZN5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEED0Ev, __ZN17MemoryCacheWriter12GetCacheSizeEv: __ZN17MemoryCacheWriter12GetCacheSizeEv, __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId, __ZN5Umbra6DoublepLERKd: __ZN5Umbra6DoublepLERKd, __ZN14RedirectHelper10OnRedirectEl: __ZN14RedirectHelper10OnRedirectEl, __Z19sweepCCTBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z19sweepCCTBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE7reserveEj, __ZN13BatchRenderer11RenderBatchEPK17BatchInstanceDatajRK14ChannelAssigns: __ZN13BatchRenderer11RenderBatchEPK17BatchInstanceDatajRK14ChannelAssigns, __Z13WriteTypeTreeRK8TypeTreeR13dynamic_arrayIhLj1EEb: __Z13WriteTypeTreeRK8TypeTreeR13dynamic_arrayIhLj1EEb, __ZN11Tetrahedron8TransferI14SafeBinaryReadEEvRT_: __ZN11Tetrahedron8TransferI14SafeBinaryReadEEvRT_, __Z80Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistanceMultiplierv: __Z80Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverDistanceMultiplierv, __ZN14RenderSettings20SetReflectionBouncesEi: __ZN14RenderSettings20SetReflectionBouncesEi, __ZN15ParticleEmitter15InitializeClassEv: __ZN15ParticleEmitter15InitializeClassEv, __Z52Application_CUSTOM_RequestAdvertisingIdentifierAsyncP12Il2CppObject: __Z52Application_CUSTOM_RequestAdvertisingIdentifierAsyncP12Il2CppObject, __ZN13RuntimeStaticI23MeshVertexFormatManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI23MeshVertexFormatManagerE16StaticInitializeEPv, __Z16ReleaseLightmapsR12LightmapData: __Z16ReleaseLightmapsR12LightmapData, __ZN9LensFlare11UpdateFlareEv: __ZN9LensFlare11UpdateFlareEv, __ZNK7b2World13GetProxyCountEv: __ZNK7b2World13GetProxyCountEv, __ZN5physx6shdfnd4Time18peekElapsedSecondsEv: __ZN5physx6shdfnd4Time18peekElapsedSecondsEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPNS_15basic_streambufIwS2_EE, _cf2_hintmask_getMaskPtr: _cf2_hintmask_getMaskPtr, __ZN16MemoryFileSystem11MoveToTrashER13FileEntryData: __ZN16MemoryFileSystem11MoveToTrashER13FileEntryData, __Z35Collider_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z35Collider_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv, _unzOpenCurrentFile: _unzOpenCurrentFile, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__set_short_sizeEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__set_short_sizeEj, __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv: __ZN11UnityEngine15CloudWebService16SessionContainer9ResetDataEv, __ZN5physx23PxVehicleDriveSimData4W17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx23PxVehicleDriveSimData4W17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN15MBP_PairManager12reallocPairsEv: __ZN15MBP_PairManager12reallocPairsEv, __ZN8Playable7SetTimeEd: __ZN8Playable7SetTimeEd, __ZN9AudioClip15ThreadedCleanupEv: __ZN9AudioClip15ThreadedCleanupEv, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZN9LDRColorAC2ERK9HDRColorA: __ZN9LDRColorAC2ERK9HDRColorA, __ZN12AdsIdHandler14SetCachedAdsIdERK8UnityStrb: __ZN12AdsIdHandler14SetCachedAdsIdERK8UnityStrb, _cff_cmap_unicode_done: _cff_cmap_unicode_done, __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj179ENS_22PxRepXPropertyAccessorILj179ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN5physx3Ext13RevoluteJointD0Ev: __ZN5physx3Ext13RevoluteJointD0Ev, __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim5human9HumanGoal8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_png_gamma_correct: _UNITY_png_gamma_correct, __Z26IsSplashScreenFadeCompletev: __Z26IsSplashScreenFadeCompletev, __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData: __Z17SendMessageDirectR6ObjectRK17MessageIdentifierR11MessageData, __ZNK18ProceduralMaterial25IsSubstancePropertyCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial25IsSubstancePropertyCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z49Register_UnityEngine_GUIStyle_Internal_CalcHeightv: __Z49Register_UnityEngine_GUIStyle_Internal_CalcHeightv, __Z42Register_UnityEngine_Camera_get_clearFlagsv: __Z42Register_UnityEngine_Camera_get_clearFlagsv, __Z56Register_UnityEngine_Profiling_Profiler_get_usedHeapSizev: __Z56Register_UnityEngine_Profiling_Profiler_get_usedHeapSizev, __Z33Profiler_CUSTOM_AddFramesFromFileP12Il2CppString: __Z33Profiler_CUSTOM_AddFramesFromFileP12Il2CppString, __Z43Register_UnityEngine_Renderer_set_materialsv: __Z43Register_UnityEngine_Renderer_set_materialsv, __ZN16ParticleRenderer14UpdateRendererEv: __ZN16ParticleRenderer14UpdateRendererEv, __Z53Register_UnityEngine_Texture_get_anisotropicFilteringv: __Z53Register_UnityEngine_Texture_get_anisotropicFilteringv, __Z57Register_UnityEngine_Screen_get_autorotateToLandscapeLeftv: __Z57Register_UnityEngine_Screen_get_autorotateToLandscapeLeftv, __Z30Compass_Get_Custom_PropEnabledP12Il2CppObject: __Z30Compass_Get_Custom_PropEnabledP12Il2CppObject, __ZN5physx3Cct11SweptVolumeC2Ev: __ZN5physx3Cct11SweptVolumeC2Ev, __ZN10HumanTrait11RightFinger14GetMuscleCountEv: __ZN10HumanTrait11RightFinger14GetMuscleCountEv, __ZN17ProceduralTexture17TextureParametersC2Ev: __ZN17ProceduralTexture17TextureParametersC2Ev, __Z24dtIntersectSegmentPoly2DPKfS0_S0_iRfS1_RiS2_: __Z24dtIntersectSegmentPoly2DPKfS0_S0_iRfS1_RiS2_, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z16IntersectRayAABBRK3RayRK4AABB: __Z16IntersectRayAABBRK3RayRK4AABB, __ZN13RenderManager27UpdatePreviousFrameMatricesEv: __ZN13RenderManager27UpdatePreviousFrameMatricesEv, __ZN8VRDevice6EndEyeEPK6Camerai: __ZN8VRDevice6EndEyeEPK6Camerai, __ZL18FindAllLiveObjectsR21GarbageCollectorState: __ZL18FindAllLiveObjectsR21GarbageCollectorState, __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev: __ZNSt3__213__vector_baseI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEED2Ev, __Z44Register_UnityEngine_Animator_get_layerCountv: __Z44Register_UnityEngine_Animator_get_layerCountv, __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults: __ZN6Camera10CustomCullERK23CameraCullingParametersR11CullResults, __ZN9GfxDevice27GetNativeIndexBufferPointerEP9GfxBuffer: __ZN9GfxDevice27GetNativeIndexBufferPointerEP9GfxBuffer, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags, __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE3AddERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEES4_: __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE3AddERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEES4_, __ZN11ForceModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles: __ZN11ForceModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles, __ZN10Collider2D7CleanupEb: __ZN10Collider2D7CleanupEb, __Z22SetManagerPtrInContextiP6Object: __Z22SetManagerPtrInContextiP6Object, __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN26AnimatorOverrideController11ClearMemoryEv: __ZN26AnimatorOverrideController11ClearMemoryEv, __ZN14PlayerSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14PlayerSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18Transfer_BlittableI8JSONReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD5Sound19set3DMinMaxDistanceEff: __ZN4FMOD5Sound19set3DMinMaxDistanceEff, __ZN4FMOD6SoundID2Ev: __ZN4FMOD6SoundID2Ev, __Z51Register_UnityEngine_Animator_INTERNAL_get_velocityv: __Z51Register_UnityEngine_Animator_INTERNAL_get_velocityv, __ZN5Umbra9IndexList6setPtrEPi: __ZN5Umbra9IndexList6setPtrEPi, __ZN4Mesh18SwapBlendShapeDataER14BlendShapeData: __ZN4Mesh18SwapBlendShapeDataER14BlendShapeData, __ZNKSt3__215__codecvt_utf16IDsLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_: __ZNKSt3__215__codecvt_utf16IDsLb1EE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_, __ZN9GfxDevice22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace: __ZN9GfxDevice22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace, __Z12SetupSteppedP11QuaternionfRK11KeyframeTplIS_ES4_: __Z12SetupSteppedP11QuaternionfRK11KeyframeTplIS_ES4_, _UNITY_png_read_transform_info: _UNITY_png_read_transform_info, __ZN15DirectorManagerD2Ev: __ZN15DirectorManagerD2Ev, _start_pass: _start_pass, __ZN13GfxDeviceNullD0Ev: __ZN13GfxDeviceNullD0Ev, __ZN5physx17EdgeChangeManager17cleanupEdgeEventsEPij: __ZN5physx17EdgeChangeManager17cleanupEdgeEventsEPij, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_17TransferMetaFlags, __ZN11UnityEngine15PlatformWrapper12GetInfoFlagsEv: __ZN11UnityEngine15PlatformWrapper12GetInfoFlagsEv, __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei: __ZN15TerrainRenderer12FindNeighborER12QuadTreeNodei, __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawLinev: __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawLinev, __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE: __ZNSt3__2L19utf8_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE, __ZN5physx22PxVehicleWheelsSimData14setChassisMassEf: __ZN5physx22PxVehicleWheelsSimData14setChassisMassEf, __ZN9GfxDevice23IgnoreNextUnresolveOnRSE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE: __ZN9GfxDevice23IgnoreNextUnresolveOnRSE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE, __ZN18PlayableController4TickEf: __ZN18PlayableController4TickEf, __ZN4crnd10dxt1_block17get_block_colors4EPNS_10color_quadIhiEEtt: __ZN4crnd10dxt1_block17get_block_colors4EPNS_10color_quadIhiEEtt, __ZN12AudioManager21RemoveAudioReverbZoneEP15AudioReverbZone: __ZN12AudioManager21RemoveAudioReverbZoneEP15AudioReverbZone, __ZN11AudioSource15ThreadedCleanupEv: __ZN11AudioSource15ThreadedCleanupEv, __ZNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __Z45AudioReverbFilter_Get_Custom_PropDecayHFRatioP12Il2CppObject: __Z45AudioReverbFilter_Get_Custom_PropDecayHFRatioP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj84ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj84ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z24RegisterStrippedTypeInfoI15DistanceJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15DistanceJoint2DEviPKcS2_, __ZN15TextureTFMethod16BindForRenderingEj: __ZN15TextureTFMethod16BindForRenderingEj, __ZN8Renderer14UpdateRendererEv: __ZN8Renderer14UpdateRendererEv, __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z30Caching_Get_Custom_PropEnabledv: __Z30Caching_Get_Custom_PropEnabledv, __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E: __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E, __ZN15PointEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15PointEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z45Register_UnityEngine_Terrain_get_materialTypev: __Z45Register_UnityEngine_Terrain_get_materialTypev, __ZN12MeshCollider16CheckConsistencyEv: __ZN12MeshCollider16CheckConsistencyEv, __ZN5physx10PxsContext22setCreateContactStreamEb: __ZN5physx10PxsContext22setCreateContactStreamEb, __ZN14ParticleSystem8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14ParticleSystem8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Cm12RefCountableD0Ev: __ZN5physx2Cm12RefCountableD0Ev, __ZNSt3__26locale5__imp12install_fromINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_9money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_16IslandPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPNS_10PxsCCDPairENS_16IslandPtrCompareENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEEN12_GLOBAL__N_14EdgeEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEEN12_GLOBAL__N_14EdgeEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZN18BaseUnityAnalytics16IsAnalyticsReadyEv: __ZN18BaseUnityAnalytics16IsAnalyticsReadyEv, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx14NpSpatialIndexD2Ev: __ZN5physx14NpSpatialIndexD2Ev, __Z36MonoBehaviour_CUSTOM_InvokeRepeatingP12Il2CppObjectP12Il2CppStringff: __Z36MonoBehaviour_CUSTOM_InvokeRepeatingP12Il2CppObjectP12Il2CppStringff, __ZN12ImageFilters12BlitMultiTapER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiPK8Vector2f11CubemapFace: __ZN12ImageFilters12BlitMultiTapER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiPK8Vector2f11CubemapFace, __Z24RegisterStrippedTypeInfoI12AudioManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI12AudioManagerEviPKcS2_, __Z49ShaderVariantCollection_Get_Custom_PropIsWarmedUpP12Il2CppObject: __Z49ShaderVariantCollection_Get_Custom_PropIsWarmedUpP12Il2CppObject, __ZN13TrailRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13TrailRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN10UnityScene18UnloadSceneObjectsEv: __ZN10UnityScene18UnloadSceneObjectsEv, __ZN4crnd18crnd_validate_fileEPKvjPNS_13crn_file_infoE: __ZN4crnd18crnd_validate_fileEPKvjPNS_13crn_file_infoE, __ZN7TerrainC2E10MemLabelId18ObjectCreationMode: __ZN7TerrainC2E10MemLabelId18ObjectCreationMode, __Z23DefaultCleanLogHandlerv7LogTypePKcPi: __Z23DefaultCleanLogHandlerv7LogTypePKcPi, __ZN8LODGroup23VirtualRedirectTransferER14SafeBinaryRead: __ZN8LODGroup23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_: __ZNSt3__27__sort4IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_SC_T_, __ZN5physx20ProcessBPResultsTaskD0Ev: __ZN5physx20ProcessBPResultsTaskD0Ev, __ZN14PhysicsManager13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction: __ZN14PhysicsManager13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToFloatArrayv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToFloatArrayv, __Z34Register_UnityEngine_Event_InitPtrv: __Z34Register_UnityEngine_Event_InitPtrv, __ZL22CreateReaderFromStringPKcbRN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE24TransferInstructionFlags: __ZL22CreateReaderFromStringPKcbRN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE24TransferInstructionFlags, __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase: __ZN16RenderTextureMap5QueryEPK17RenderSurfaceBase, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags, __ZNK6IDList16GetRectOfControlEiR5RectTIfE: __ZNK6IDList16GetRectOfControlEiR5RectTIfE, __ZN18MultiFrameGUIState15AddNamedControlERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiPN5IMGUI9GUIWindowE: __ZN18MultiFrameGUIState15AddNamedControlERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiPN5IMGUI9GUIWindowE, _sfnt_get_glyph_name: _sfnt_get_glyph_name, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv, __ZN10FlareLayerD2Ev: __ZN10FlareLayerD2Ev, __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallback10processHitERKNS_12PxRaycastHitERKS9_SK_SK_RfPKj: __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallback10processHitERKNS_12PxRaycastHitERKS9_SK_SK_RfPKj, __Z37GeomOverlapCallback_ConvexHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z37GeomOverlapCallback_ConvexHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZNKSt3__220__codecvt_utf8_utf16IDsE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__220__codecvt_utf8_utf16IDsE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZZ23InitPlayerLoopCallbacksvEN45PostLateUpdateExecuteOneJobInMainThreadstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN45PostLateUpdateExecuteOneJobInMainThreadstruct7ForwardEv, __ZN15ArchiveReadFileC2EP20ArchiveStorageReaderPKN20ArchiveStorageHeader4NodeE: __ZN15ArchiveReadFileC2EP20ArchiveStorageReaderPKN20ArchiveStorageHeader4NodeE, __ZNK8VRDevice19GetStereoSeparationEv: __ZNK8VRDevice19GetStereoSeparationEv, __ZN5physx6shdfnd9MutexImpl7trylockEv: __ZN5physx6shdfnd9MutexImpl7trylockEv, __ZN5physx8debugger4comm15RemoveObjectRefD0Ev: __ZN5physx8debugger4comm15RemoveObjectRefD0Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags, __ZN2UI12DoSyncBoundsERNS_13UIInstructionERK10MinMaxAABB: __ZN2UI12DoSyncBoundsERNS_13UIInstructionERK10MinMaxAABB, __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5Umbra16LineSegmentQuery12setObjectSetEPNS_9IndexListE: __ZN5Umbra16LineSegmentQuery12setObjectSetEPNS_9IndexListE, __Z35Camera_Set_Custom_PropNearClipPlaneP12Il2CppObjectf: __Z35Camera_Set_Custom_PropNearClipPlaneP12Il2CppObjectf, __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv: __ZNKSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strEv, __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ExceptionOccurredv: __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ExceptionOccurredv, __ZN5physx20addConstraintDynamicERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_PKNS_11PxsBodyCoreERNS_25PxsFluidConstraintDynamicES9_: __ZN5physx20addConstraintDynamicERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_S4_PKNS_11PxsBodyCoreERNS_25PxsFluidConstraintDynamicES9_, __ZN14BillboardAsset9SetImagesEPK8Vector4fj: __ZN14BillboardAsset9SetImagesEPK8Vector4fj, __Z60Register_UnityEngine_Cloth_INTERNAL_get_externalAccelerationv: __Z60Register_UnityEngine_Cloth_INTERNAL_get_externalAccelerationv, __ZNSt3__218shared_timed_mutex4lockEv: __ZNSt3__218shared_timed_mutex4lockEv, __Z42Avatar_CUSTOM_INTERNAL_CALL_GetPreRotationP12Il2CppObjectiR11Quaternionf: __Z42Avatar_CUSTOM_INTERNAL_CALL_GetPreRotationP12Il2CppObjectiR11Quaternionf, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7sungetcEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7sungetcEv, __ZNK8Material6GetTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEbS8_: __ZNK8Material6GetTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEbS8_, __ZN11UnityEngine15PlatformWrapper14GetCloudUserIdEv: __ZN11UnityEngine15PlatformWrapper14GetCloudUserIdEv, __Z47AudioSource_Get_Custom_PropIgnoreListenerVolumeP12Il2CppObject: __Z47AudioSource_Get_Custom_PropIgnoreListenerVolumeP12Il2CppObject, __ZN22ProceduralMaterialData23GetSubstancePackageNameEv: __ZN22ProceduralMaterialData23GetSubstancePackageNameEv, __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z54ParticleSystem_TrailModule_CUSTOM_GetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient: __Z54ParticleSystem_TrailModule_CUSTOM_GetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20AudioMixerUpdateModeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20AudioMixerUpdateModeEvRT_RT0_PKc17TransferMetaFlags, __Z30getPxVehicleWheelData_RecipMOIPKN5physx18PxVehicleWheelDataE: __Z30getPxVehicleWheelData_RecipMOIPKN5physx18PxVehicleWheelDataE, ___udivdi3: ___udivdi3, __Z51Register_UnityEngine_PlatformEffector2D_set_sideArcv: __Z51Register_UnityEngine_PlatformEffector2D_set_sideArcv, __Z59Register_UnityEngine_WebGLInput_set_captureAllKeyboardInputv: __Z59Register_UnityEngine_WebGLInput_set_captureAllKeyboardInputv, __ZN4FMOD6System10recordStopEi: __ZN4FMOD6System10recordStopEi, __Z51Register_UnityEngine_AudioReverbFilter_set_dryLevelv: __Z51Register_UnityEngine_AudioReverbFilter_set_dryLevelv, __ZN4PPtrI15OcclusionPortalE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI15OcclusionPortalE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx9NpPhysics11createSceneERKNS_11PxSceneDescE: __ZN5physx9NpPhysics11createSceneERKNS_11PxSceneDescE, __ZN8Animator23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8Animator23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState: __ZN4gles16CreateBlendStateER15DeviceStateGLESRK13GfxBlendState, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getWorldBoundsEf: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getWorldBoundsEf, __ZN13WheelCollider19SetWheelDampingRateEf: __ZN13WheelCollider19SetWheelDampingRateEf, __Z28SortingLayer_CUSTOM_IDToNamei: __Z28SortingLayer_CUSTOM_IDToNamei, __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDrive4WEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDrive4WEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __ZNK5physx16PxPrismaticJoint8isKindOfEPKc: __ZNK5physx16PxPrismaticJoint8isKindOfEPKc, __ZN8Material12CleanupClassEv: __ZN8Material12CleanupClassEv, __Z48QualitySettings_Get_Custom_PropDesiredColorSpacev: __Z48QualitySettings_Get_Custom_PropDesiredColorSpacev, __ZN5Umbra13MatrixFactory7rotateYEf: __ZN5Umbra13MatrixFactory7rotateYEf, __Z59Register_UnityEngine_Animator_set_runtimeAnimatorControllerv: __Z59Register_UnityEngine_Animator_set_runtimeAnimatorControllerv, __Z45LineRenderer_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectiR8Vector3f: __Z45LineRenderer_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectiR8Vector3f, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEEEE15growAndPushBackERKS2_, __ZN9GfxBuffer5ResetEv: __ZN9GfxBuffer5ResetEv, __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN6Avatar7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Avatar7PRODUCEE10MemLabelId18ObjectCreationMode, __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb: __Z21GetCachingManagerPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb, __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_: __ZNSt3__26__sortIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEvT0_SB_T_, __ZNK5physx7NpScene19getDynamicStructureEv: __ZNK5physx7NpScene19getDynamicStructureEv, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags, __Z38VerifyNothingIsPersistentInLoadedSceneRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z38VerifyNothingIsPersistentInLoadedSceneRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN4crnd10dxt5_block17get_block_values8EPNS_10color_quadIhiEEjj: __ZN4crnd10dxt5_block17get_block_values8EPNS_10color_quadIhiEEjj, _UNITY_png_write_pCAL: _UNITY_png_write_pCAL, __Z66Register_UnityEngine_SceneManagement_Scene_GetLoadingStateInternalv: __Z66Register_UnityEngine_SceneManagement_Scene_GetLoadingStateInternalv, __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI16SplashScreenLogoEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI16SplashScreenLogoEEvRT_17TransferMetaFlags, __ZNSt3__26locale5__impC2ERKS1_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi: __ZNSt3__26locale5__impC2ERKS1_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi, __ZNK5physx2Sc16ArticulationCore22getSeparationToleranceEv: __ZNK5physx2Sc16ArticulationCore22getSeparationToleranceEv, __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __Z46Material_CUSTOM_INTERNAL_CALL_SetTextureOffsetP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall: __Z46Material_CUSTOM_INTERNAL_CALL_SetTextureOffsetP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall, __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Movev: __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Movev, __ZL21CleanupModule_Physicsv: __ZL21CleanupModule_Physicsv, __Z25getPxVehicleTireDataMTypePKN5physx17PxVehicleTireDataE: __Z25getPxVehicleTireDataMTypePKN5physx17PxVehicleTireDataE, __ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_: __ZN5physx2Gu32distanceSegmentSegmentSquaredOLDERKNS_6PxVec3ES3_S3_S3_PfS4_, _memmove: _memmove, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff, __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE: __ZN5physx15PxcLtbComputeJvEPNS_6shdfnd3aos5Vec3VERKNS_9PxcFsDataEPKNS_14PxcSIMDSpatialE, __ZN5physx8debugger4comm20StreamInitializationD0Ev: __ZN5physx8debugger4comm20StreamInitializationD0Ev, __Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses: __Z11IsCoroutine21ScriptingMethodIl2CppRK22CommonScriptingClasses, __ZN5physx6shdfnd18BufferedSocketImplD0Ev: __ZN5physx6shdfnd18BufferedSocketImplD0Ev, __Z38AudioSource_Set_Custom_PropRolloffModeP12Il2CppObject11RolloffMode: __Z38AudioSource_Set_Custom_PropRolloffModeP12Il2CppObject11RolloffMode, __ZNSt3__211this_thread9sleep_forERKNS_6chrono8durationIxNS_5ratioILx1ELx1000000000EEEEE: __ZNSt3__211this_thread9sleep_forERKNS_6chrono8durationIxNS_5ratioILx1ELx1000000000EEEEE, __Z52Register_UnityEngine_ScriptableObject_CreateInstancev: __Z52Register_UnityEngine_ScriptableObject_CreateInstancev, __Z46Register_UnityEngine_AndroidJNI_DeleteLocalRefv: __Z46Register_UnityEngine_AndroidJNI_DeleteLocalRefv, __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableDynamicCollidersv: __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableDynamicCollidersv, __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi: __ZNSt3__213__stable_sortIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeEi, __ZNK5physx12NpConstraint8getFlagsEv: __ZNK5physx12NpConstraint8getFlagsEv, __ZN13SliderJoint2DD2Ev: __ZN13SliderJoint2DD2Ev, __ZNSt3__26locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZN22NavMeshProjectSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN22NavMeshProjectSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __Z39ConstantForce_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f: __Z39ConstantForce_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f, __ZNK5physx10PxsContext17getCurrentCCDPassEv: __ZNK5physx10PxsContext17getCurrentCCDPassEv, __ZN14Raycast2DQuery13ReportFixtureEP9b2FixtureRK6b2Vec2S4_f: __ZN14Raycast2DQuery13ReportFixtureEP9b2FixtureRK6b2Vec2S4_f, __ZN5physx29createFinalizeSolverContacts4EPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE: __ZN5physx29createFinalizeSolverContacts4EPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE, _UNITY_FT_Stream_GetUShortLE: _UNITY_FT_Stream_GetUShortLE, __ZNK5physx7NpCloth13getGlobalPoseEv: __ZNK5physx7NpCloth13getGlobalPoseEv, __ZN5physx9NpFactory18createArticulationEv: __ZN5physx9NpFactory18createArticulationEv, __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZN7ApiGLES10InvalidateERK14GfxContextGLES: __ZN7ApiGLES10InvalidateERK14GfxContextGLES, __ZNK5physx14NpRigidDynamic10isSleepingEv: __ZNK5physx14NpRigidDynamic10isSleepingEv, __ZN7mecanim9animation9DenseClip8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation9DenseClip8TransferI14SafeBinaryReadEEvRT_, __Z24RegisterStrippedTypeInfoI8GUILayerEviPKcS2_: __Z24RegisterStrippedTypeInfoI8GUILayerEviPKcS2_, __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_: __ZN18BackgroundJobQueue21ScheduleMainThreadJobEPFvPvES0_, __ZN5physx5cloth11SwCollisionI8Scalar4fE17mergeAccelerationEPj: __ZN5physx5cloth11SwCollisionI8Scalar4fE17mergeAccelerationEPj, __Z50Register_UnityEngine_Animator_CrossFadeInFixedTimev: __Z50Register_UnityEngine_Animator_CrossFadeInFixedTimev, __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E: __ZNK5physx2Gu15HeightFieldUtil18computeLocalBoundsERNS_9PxBounds3E, __ZN5physx9PxTaskMgr13taskCompletedERNS_6PxTaskE: __ZN5physx9PxTaskMgr13taskCompletedERNS_6PxTaskE, __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_FT_Init_Class_tt_service_truetype_glyf: _UNITY_FT_Init_Class_tt_service_truetype_glyf, __Z37scripting_profiler_install_allocationPFvPvP12Il2CppObjectP11Il2CppClassE: __Z37scripting_profiler_install_allocationPFvPvP12Il2CppObjectP11Il2CppClassE, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE4copyIS5_EEvRKNS1_IS4_T_EE: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE4copyIS5_EEvRKNS1_IS4_T_EE, __Z61Register_UnityEngine_Camera_set_clearStencilAfterLightingPassv: __Z61Register_UnityEngine_Camera_set_clearStencilAfterLightingPassv, __ZNK6Motion26GetTypeInfoVirtualInternalEv: __ZNK6Motion26GetTypeInfoVirtualInternalEv, __Z20IsVectorBuiltinParamPKcPi: __Z20IsVectorBuiltinParamPKcPi, __Z47Register_UnityEngine_TextMesh_set_characterSizev: __Z47Register_UnityEngine_TextMesh_set_characterSizev, __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b: __ZN5physx17PxcNpMemBlockPool7acquireERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEEPjS9_b, __Z58Register_UnityEngine_SceneManagement_Scene_GetNameInternalv: __Z58Register_UnityEngine_SceneManagement_Scene_GetNameInternalv, __ZNK12PhysXRaycast7OverlapERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_j: __ZNK12PhysXRaycast7OverlapERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_j, __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier27ELi16EEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueENS_11__wrap_iterIS6_EEE4typeENSC_IPKhEES8_S8_: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier27ELi16EEE6insertIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS8_E9referenceEEE5valueENS_11__wrap_iterIS6_EEE4typeENSC_IPKhEES8_S8_, __ZN5physx12NpBatchQuery13setUserMemoryERKNS_18PxBatchQueryMemoryE: __ZN5physx12NpBatchQuery13setUserMemoryERKNS_18PxBatchQueryMemoryE, __Z13RegisterClassI17Physics2DSettingsEvv: __Z13RegisterClassI17Physics2DSettingsEvv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags, __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi: __ZN8Renderer11SetMaterialE4PPtrI8MaterialEi, __ZN11AudioSource21SetScheduledStartTimeEd: __ZN11AudioSource21SetScheduledStartTimeEd, __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Ext29RegisterExtensionsSerializersERNS_23PxSerializationRegistryE: __ZN5physx3Ext29RegisterExtensionsSerializersERNS_23PxSerializationRegistryE, __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv, __Z49Rigidbody2D_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE: __Z49Rigidbody2D_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK13Vector2fIcallN11Rigidbody2D9ForceModeE, __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_: __ZN10__cxxabiv112_GLOBAL__N_111string_pairaSEOS1_, __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b: __ZN14ParticleSystem28SetPlayOnAwakeDirectChildrenEPS_b, __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetBouncev: __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetBouncev, __ZN15LightProbeGroup15ThreadedCleanupEv: __ZN15LightProbeGroup15ThreadedCleanupEv, __ZN8Collider17HasActorRigidbodyEv: __ZN8Collider17HasActorRigidbodyEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __Z46ParticleSystem_MainModule_CUSTOM_GetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_GetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve, __ZN12FlareManager9AddCameraER6Camera: __ZN12FlareManager9AddCameraER6Camera, __Z27UnityWebRequestJobSchedulerPFvPvES_: __Z27UnityWebRequestJobSchedulerPFvPvES_, __ZNK6Camera27GetUsesScreenForCompositingEb: __ZNK6Camera27GetUsesScreenForCompositingEb, __ZN11AudioSource8TransferI14SafeBinaryReadEEvRT_: __ZN11AudioSource8TransferI14SafeBinaryReadEEvRT_, __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei: __ZN4Mesh17SetIndicesComplexEPKvjj16GfxPrimitiveTypei, __ZN13RuntimeStaticI15DirectorManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI15DirectorManagerE13StaticDestroyEPv, __ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE: __ZN5physx2Gu11WriteHeaderEhhhhjbRNS_14PxOutputStreamE, __ZN12_GLOBAL__N_110ConnectionD2Ev: __ZN12_GLOBAL__N_110ConnectionD2Ev, __ZN5Unity10HingeJoint16WriteJointSpringEv: __ZN5Unity10HingeJoint16WriteJointSpringEv, __Z38AnimationClip_Get_Custom_PropFrameRateP12Il2CppObject: __Z38AnimationClip_Get_Custom_PropFrameRateP12Il2CppObject, __ZN13dynamic_arrayIN9ShaderLab16FastPropertyNameELj4EEC2ERKS2_RK10MemLabelId: __ZN13dynamic_arrayIN9ShaderLab16FastPropertyNameELj4EEC2ERKS2_RK10MemLabelId, __ZN13SplatDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SplatDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf: __ZNK9Transform22GetPositionAndRotationER8Vector3fR11Quaternionf, __ZNK5physx7PxShape19getConcreteTypeNameEv: __ZNK5physx7PxShape19getConcreteTypeNameEv, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN5physx17SapUpdateWorkTaskD0Ev: __ZN5physx17SapUpdateWorkTaskD0Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags, __ZN8Animator16TransformChangedEi: __ZN8Animator16TransformChangedEi, __ZL9refitNodePN5physx2Sq12AABBTreeNodeEjPKNS_9PxBounds3EPjRS2_S7_RNS_6shdfnd3aos7VecU32VERNS9_5Vec3VESD_SD_SD_SD_: __ZL9refitNodePN5physx2Sq12AABBTreeNodeEjPKNS_9PxBounds3EPjRS2_S7_RNS_6shdfnd3aos7VecU32VERNS9_5Vec3VESD_SD_SD_SD_, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToDoubleArrayv: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToDoubleArrayv, __ZN9ShaderLab9IntShader26CreateFromSerializedShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_: __ZN9ShaderLab9IntShader26CreateFromSerializedShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_, __Z46Register_UnityEngine_TerrainData_set_thicknessv: __Z46Register_UnityEngine_TerrainData_set_thicknessv, __ZN22BuiltinResourceManager13StaticDestroyEPv: __ZN22BuiltinResourceManager13StaticDestroyEPv, __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE: __ZN5physx2Sc8BodyCore13setBody2WorldERKNS_11PxTransformE, __ZNK19VREyeTextureManager16HasRenderSurfaceEP17RenderSurfaceBasePiS2_: __ZNK19VREyeTextureManager16HasRenderSurfaceEP17RenderSurfaceBasePiS2_, __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv: __ZNK21ScriptingObjectOfTypeI14Texture2DArrayEptEv, __ZNKSt3__27codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_: __ZNKSt3__27codecvtIcc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_, __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity9Component8TransferI19StreamedBinaryWriteILb0EEEEvRT_, ___fseterr: ___fseterr, __ZN11UnityEngine15CloudWebService14RestDownloader9IsAbortedEv: __ZN11UnityEngine15CloudWebService14RestDownloader9IsAbortedEv, __ZN7mecanim12statemachine28DestroyStateMachineWorkspaceEPNS0_21StateMachineWorkspaceERNS_6memory9AllocatorE: __ZN7mecanim12statemachine28DestroyStateMachineWorkspaceEPNS0_21StateMachineWorkspaceERNS_6memory9AllocatorE, __Z56Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorv: __Z56Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorv, __Z44ParticleSystem_ShapeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z44ParticleSystem_ShapeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z30GUIStyle_CUSTOM_SetDefaultFontP12Il2CppObject: __Z30GUIStyle_CUSTOM_SetDefaultFontP12Il2CppObject, _independent_comalloc: _independent_comalloc, _UNITY_png_get_pixels_per_inch: _UNITY_png_get_pixels_per_inch, __Z36GUI_CUSTOM_INTERNAL_get_contentColorP10ColorRGBAf: __Z36GUI_CUSTOM_INTERNAL_get_contentColorP10ColorRGBAf, _jinit_forward_dct: _jinit_forward_dct, __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_: __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESM_EERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESM_EERKT_, __ZNK14b2CapsuleShape11ComputeMassEP10b2MassDataf: __ZNK14b2CapsuleShape11ComputeMassEP10b2MassDataf, __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc: __ZN11TypeManager12RegisterTypeERK20TypeRegistrationDesc, __Z35RenderTexture_Get_Custom_PropFormatP12Il2CppObject: __Z35RenderTexture_Get_Custom_PropFormatP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj574ENS_22PxRepXPropertyAccessorILj574ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj574ENS_22PxRepXPropertyAccessorILj574ES4_ffEEEEvRKT0_, __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI17BlendShapeChannelNS_9allocatorIS1_EEE8__appendEj, __ZN5physx2Gu23intersectRaySphereBasicERKNS_6PxVec3ES3_fS3_fRfPS1_: __ZN5physx2Gu23intersectRaySphereBasicERKNS_6PxVec3ES3_fS3_fRfPS1_, _UNITY_png_set_gray_to_rgb: _UNITY_png_set_gray_to_rgb, __ZThn4_NK5physx5cloth8SwFabric12getNumPhasesEv: __ZThn4_NK5physx5cloth8SwFabric12getNumPhasesEv, __ZNKSt3__215__codecvt_utf16IDsLb1EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IDsLb1EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_, __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE: __ZL21AppendNestedClassNameP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE, __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32: __ZNK11ColorModule12UpdateSingleERK22ParticleSystemParticleR11ColorRGBA32, _SphericalJointSolverPrep: _SphericalJointSolverPrep, __ZN5physx3Ext20SharedQueueEntryPoolINS_6shdfnd19ReflectionAllocatorINS0_16SharedQueueEntryEEEEC2EjRKS5_: __ZN5physx3Ext20SharedQueueEntryPoolINS_6shdfnd19ReflectionAllocatorINS0_16SharedQueueEntryEEEEC2EjRKS5_, __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient: __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient, __ZN5physx2Sc8BodyCore22addSpatialAccelerationEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_: __ZN5physx2Sc8BodyCore22addSpatialAccelerationEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags, __ZN9BehaviourD2Ev: __ZN9BehaviourD2Ev, __ZNSt3__26locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZN9WWWCachedD0Ev: __ZN9WWWCachedD0Ev, __ZN5physx2Sn13XmlNodeReader7setNodeERNS0_7XmlNodeE: __ZN5physx2Sn13XmlNodeReader7setNodeERNS0_7XmlNodeE, __ZN17BaseWebCamTextureD0Ev: __ZN17BaseWebCamTextureD0Ev, __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN21LightProbeProxyVolume13GetRenderDataER27LightProbeProxyVolumeSample: __ZN21LightProbeProxyVolume13GetRenderDataER27LightProbeProxyVolumeSample, __ZN21AssetBundleFileSystem18IsAbsoluteFilePathEPKc: __ZN21AssetBundleFileSystem18IsAbsoluteFilePathEPKc, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj524ENS_22PxRepXPropertyAccessorILj524ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj524ENS_22PxRepXPropertyAccessorILj524ES4_ffEEEEvRKT0_, __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh: __ZNSt3__26vectorIhNS_9allocatorIhEEE8__appendEjRKh, __ZN5physx13PxsCCDContext7destroyEv: __ZN5physx13PxsCCDContext7destroyEv, __ZN15RelativeJoint2D12SetMaxTorqueEf: __ZN15RelativeJoint2D12SetMaxTorqueEf, __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId, __ZN11TimeManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11TimeManager8TransferI24GenerateTypeTreeTransferEEvRT_, _isxdigit: _isxdigit, __Z47ParticleSystem_MainModule_CUSTOM_SetPlayOnAwakeP12Il2CppObjecth: __Z47ParticleSystem_MainModule_CUSTOM_SetPlayOnAwakeP12Il2CppObjecth, __ZN5physx3Ext14SphericalJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext14SphericalJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE: __ZNK11UnityEngine9Animation28GenericAnimationBindingCache10BindCustomERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE, __ZN18UnityConnectClient17InitConnectClientEv: __ZN18UnityConnectClient17InitConnectClientEv, _memcmp: _memcmp, __Z54SkinnedMeshRenderer_Set_Custom_PropUpdateWhenOffscreenP12Il2CppObjecth: __Z54SkinnedMeshRenderer_Set_Custom_PropUpdateWhenOffscreenP12Il2CppObjecth, __ZN16BaseVideoTexture18ReleaseVideoMemoryEv: __ZN16BaseVideoTexture18ReleaseVideoMemoryEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, _accept: _accept, __ZN8LODGroup10SetEnabledEb: __ZN8LODGroup10SetEnabledEb, __ZN14DataBufferGLES12RecordRenderEv: __ZN14DataBufferGLES12RecordRenderEv, __ZNSt3__26futureIvED2Ev: __ZNSt3__26futureIvED2Ev, __ZN5physx15NpActorTemplateINS_7PxClothEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_7PxClothEE14setOwnerClientEh, __ZN2UI29ScheduleUIJobsForInstructionsERNS_7BatchesEjPKNS_13UIInstructionEfjjPNS_13CanvasJobDataE: __ZN2UI29ScheduleUIJobsForInstructionsERNS_7BatchesEjPKNS_13UIInstructionEfjjPNS_13CanvasJobDataE, __ZN14LineParameters8TransferI14SafeBinaryReadEEvRT_: __ZN14LineParameters8TransferI14SafeBinaryReadEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv, __Z39Application_CUSTOM_SetStackTraceLogType7LogTypei: __Z39Application_CUSTOM_SetStackTraceLogType7LogTypei, __Z18IntersectRaySphereRK3RayRK6SpherePfS5_: __Z18IntersectRaySphereRK3RayRK6SpherePfS5_, __ZN15AudioMixerGroup15ThreadedCleanupEv: __ZN15AudioMixerGroup15ThreadedCleanupEv, __ZN13SliderJoint2D6CreateEv: __ZN13SliderJoint2D6CreateEv, __ZN5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEED0Ev, ___tre_mem_alloc_impl: ___tre_mem_alloc_impl, __ZL22InitializeModule_Umbrav: __ZL22InitializeModule_Umbrav, __ZL38CleanupParticlesLegacyScriptingClassesv: __ZL38CleanupParticlesLegacyScriptingClassesv, __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv: __ZN5physx17PxcNpMemBlockPool19swapFrictionStreamsEv, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7GetFreeEi: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7GetFreeEi, __ZN7mecanim5human15HumanAdjustMassEPNS0_5HumanE: __ZN7mecanim5human15HumanAdjustMassEPNS0_5HumanE, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7pubsyncEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7pubsyncEv, __Z18SkinGenericMathLibILi2ELb1ELb1EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi2ELb1ELb1EEvR12SkinMeshInfo, _cpow: _cpow, __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIKN4math7_float3EE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZN12InputManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12InputManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z29Animator_CUSTOM_GetBoolStringP12Il2CppObjectP12Il2CppString: __Z29Animator_CUSTOM_GetBoolStringP12Il2CppObjectP12Il2CppString, __Z38BoxCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z38BoxCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __ZN7mecanim9animation14AvatarConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z40CapsuleCollider_Set_Custom_PropDirectionP12Il2CppObjecti: __Z40CapsuleCollider_Set_Custom_PropDirectionP12Il2CppObjecti, __ZN15NavMeshObstacle19SetTimeToStationaryEf: __ZN15NavMeshObstacle19SetTimeToStationaryEf, __ZNKSt3__220__codecvt_utf8_utf16IwE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__220__codecvt_utf8_utf16IwE10do_unshiftER11__mbstate_tPcS4_RS4_, __Z27getPxDistanceJoint_DistancePKN5physx15PxDistanceJointE: __Z27getPxDistanceJoint_DistancePKN5physx15PxDistanceJointE, __ZN23iPhoneLocalNotification9CancelAllEv: __ZN23iPhoneLocalNotification9CancelAllEv, __ZL20ShaderWarmupFuncImplP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContext: __ZL20ShaderWarmupFuncImplP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContext, __ZN7b2World4StepEfii: __ZN7b2World4StepEfii, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EOS3_: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC2EOS3_, __ZNSt3__212__rs_defaultclEv: __ZNSt3__212__rs_defaultclEv, __Z59Register_UnityEngine_RenderSettings_get_reflectionIntensityv: __Z59Register_UnityEngine_RenderSettings_get_reflectionIntensityv, __ZNK12FixedJoint2D26GetTypeInfoVirtualInternalEv: __ZNK12FixedJoint2D26GetTypeInfoVirtualInternalEv, __ZN16ReflectionProbes21IsSmoothnessSupportedEv: __ZN16ReflectionProbes21IsSmoothnessSupportedEv, __ZNK32RendererMaterialAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK32RendererMaterialAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZN5physx3Scb13ObjectTracker17scheduleForRemoveERNS0_4BaseE: __ZN5physx3Scb13ObjectTracker17scheduleForRemoveERNS0_4BaseE, __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __Z18UpdateAvoidanceJobP9CrowdInfoj: __Z18UpdateAvoidanceJobP9CrowdInfoj, __ZN4crnd12symbol_codec13get_bits_initEv: __ZN4crnd12symbol_codec13get_bits_initEv, __ZN5Unity12PhysicsQuery21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery21OverlapSphereNonAllocERK8Vector3ffPP8Colliderii23QueryTriggerInteraction, __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN5Cache9GetFolderERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZZN15NavMeshObstacle15InitializeClassEvEN32FunctorImpl_206kTransformChanged4CallEPviR11MessageData: __ZZN15NavMeshObstacle15InitializeClassEvEN32FunctorImpl_206kTransformChanged4CallEPviR11MessageData, _readlinkat: _readlinkat, __ZN14DataBufferGLES12RecordUpdateEv: __ZN14DataBufferGLES12RecordUpdateEv, _UNITY_FT_Create_Class_psnames_module_class: _UNITY_FT_Create_Class_psnames_module_class, __ZNSt3__26vectorI15QueuedAnimation13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI15QueuedAnimation13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNKSt3__210moneypunctIwLb0EE11do_groupingEv: __ZNKSt3__210moneypunctIwLb0EE11do_groupingEv, __ZN20TextRenderingPrivate15DynamicFontData28GetFaceForFontRefFromOSFontsERKNS_7FontRefE: __ZN20TextRenderingPrivate15DynamicFontData28GetFaceForFontRefFromOSFontsERKNS_7FontRefE, __ZN5physx2Gu33generateSphereFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalEPNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERNSC_5Vec3VEb: __ZN5physx2Gu33generateSphereFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalEPNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERNSC_5Vec3VEb, __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_GetPositionv: __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_GetPositionv, __ZN27ParticleSystemReadOnlyState8TransferI17RemapPPtrTransferEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI17RemapPPtrTransferEEvRT_, __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix2v: __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix2v, __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI13RenderTextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN10systeminfo19IsPlatformWebPlayerE15RuntimePlatform: __ZN10systeminfo19IsPlatformWebPlayerE15RuntimePlatform, __ZNK20LocalFileSystemPosix18GetApplicationPathEv: __ZNK20LocalFileSystemPosix18GetApplicationPathEv, __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev: __ZN19InstanceIDHashTableIPKN11AssetBundle9AssetInfoENSt3__24pairIKiS3_EEEC2Ev, __Z41SystemInfo_Get_Custom_PropSupportsShadowsv: __Z41SystemInfo_Get_Custom_PropSupportsShadowsv, __ZNSt3__26thread20hardware_concurrencyEv: __ZNSt3__26thread20hardware_concurrencyEv, __ZN12SkinMeshInfo8AllocateEiib: __ZN12SkinMeshInfo8AllocateEiib, __Z53getPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE: __Z53getPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE, __ZN5physx3Ext21InertiaTensorComputer9setSphereEf: __ZN5physx3Ext21InertiaTensorComputer9setSphereEf, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE8__appendEj, __ZN13GfxDeviceNull16CreateDynamicVBOEv: __ZN13GfxDeviceNull16CreateDynamicVBOEv, __ZN2UI23InitializeCanvasManagerEv: __ZN2UI23InitializeCanvasManagerEv, __ZN10GameObject16CheckConsistencyEv: __ZN10GameObject16CheckConsistencyEv, __ZN20ExternalForcesModule8TransferI17RemapPPtrTransferEEvRT_: __ZN20ExternalForcesModule8TransferI17RemapPPtrTransferEEvRT_, __ZN14RenderSettings15InitializeClassEv: __ZN14RenderSettings15InitializeClassEv, __Z34Time_Get_Custom_PropFixedDeltaTimev: __Z34Time_Get_Custom_PropFixedDeltaTimev, __Z42Register_UnityEngine_RemoteSettings_GetIntv: __Z42Register_UnityEngine_RemoteSettings_GetIntv, __ZN18ProfilerConnection21SendFrameDataToEditorER17ProfilerFrameData: __ZN18ProfilerConnection21SendFrameDataToEditorER17ProfilerFrameData, __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_: __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_9allocatorIS5_EEE21__push_back_slow_pathIKS5_EEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEE15growAndPushBackERKS2_, __Z46Register_UnityEngine_GameObject_get_activeSelfv: __Z46Register_UnityEngine_GameObject_get_activeSelfv, __ZN20ArchiveStorageHeader11WriteHeaderER12FileAccessorRKNS_6HeaderE: __ZN20ArchiveStorageHeader11WriteHeaderER12FileAccessorRKNS_6HeaderE, _TT_Load_Simple_Glyph: _TT_Load_Simple_Glyph, __ZN5physx9PxTaskMgr15startSimulationEv: __ZN5physx9PxTaskMgr15startSimulationEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj188ENS_22PxRepXPropertyAccessorILj188ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj188ENS_22PxRepXPropertyAccessorILj188ES4_ffEEEEvRKT0_, __ZNK5physx11PxTransform12transformInvERKS0_: __ZNK5physx11PxTransform12transformInvERKS0_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN4math14float3_storageELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN4math14float3_storageELj4EEEEvRT_17TransferMetaFlags, __ZN5physx22PxDefaultFileInputData4seekEj: __ZN5physx22PxDefaultFileInputData4seekEj, __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE: __ZN5physx2Sc16InteractionScene20addToActiveActorListERNS0_5ActorE, __ZNK8Playable12GetPlayStateEv: __ZNK8Playable12GetPlayStateEv, __ZNK14PlayerSettings21DoesSupportResolutionEii: __ZNK14PlayerSettings21DoesSupportResolutionEii, __ZN21LightProbeProxyVolume5ResetEv: __ZN21LightProbeProxyVolume5ResetEv, __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_T_, __Z39setPxPrismaticJoint_PrismaticJointFlagsPN5physx16PxPrismaticJointENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE: __Z39setPxPrismaticJoint_PrismaticJointFlagsPN5physx16PxPrismaticJointENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE, __ZN5physx15PxCpuDispatcherD2Ev: __ZN5physx15PxCpuDispatcherD2Ev, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetDampingv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_SetDampingv, __ZN2UI16GetCanvasManagerEv: __ZN2UI16GetCanvasManagerEv, __Z54ParticleSystem_ShapeModule_CUSTOM_SetMeshMaterialIndexP12Il2CppObjecti: __Z54ParticleSystem_ShapeModule_CUSTOM_SetMeshMaterialIndexP12Il2CppObjecti, __ZN8Collider13GetPxMaterialEv: __ZN8Collider13GetPxMaterialEv, __ZN15GUIEventManager8PopEventER10InputEvent: __ZN15GUIEventManager8PopEventER10InputEvent, __Z31RectOffset_Get_Custom_PropRightP12Il2CppObject: __Z31RectOffset_Get_Custom_PropRightP12Il2CppObject, __Z54Register_UnityEngine_TextGenerator_GetVerticesInternalv: __Z54Register_UnityEngine_TextGenerator_GetVerticesInternalv, __ZN5physx16PxVehicleNoDrive15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx16PxVehicleNoDrive15importExtraDataERNS_24PxDeserializationContextE, __ZN14DetailDatabaseD2Ev: __ZN14DetailDatabaseD2Ev, __Z36ReleaseInstanceFixedBehaviourManagerv: __Z36ReleaseInstanceFixedBehaviourManagerv, _UNITY_FT_Stroker_New: _UNITY_FT_Stroker_New, __ZN19SkinnedMeshRendererC2E10MemLabelId18ObjectCreationMode: __ZN19SkinnedMeshRendererC2E10MemLabelId18ObjectCreationMode, __Z50Register_UnityEngine_ParticleSystem_set_startSpeedv: __Z50Register_UnityEngine_ParticleSystem_set_startSpeedv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21UniformBufferTFMethodD2Ev: __ZN21UniformBufferTFMethodD2Ev, __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIwwEEPwEEjT0_S5_S5_T_, __ZN18LoadSceneOperation21PostLoadSceneAdditiveEv: __ZN18LoadSceneOperation21PostLoadSceneAdditiveEv, __ZN5physx9NpFactory24releaseClothFabricToPoolERNS_13NpClothFabricE: __ZN5physx9NpFactory24releaseClothFabricToPoolERNS_13NpClothFabricE, __ZN9ProjectorD2Ev: __ZN9ProjectorD2Ev, __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatRGB888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatRGB888EEvPKNS_9InnerInfoE, __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetUseParticleColorv: __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetUseParticleColorv, __Z26getPxSceneDescCcdMaxPassesPKN5physx11PxSceneDescE: __Z26getPxSceneDescCcdMaxPassesPKN5physx11PxSceneDescE, __Z36Profiler_Get_Custom_PropUsedHeapSizev: __Z36Profiler_Get_Custom_PropUsedHeapSizev, __ZN5physx14materialAccessEPKNS_14PxTriangleMeshEj: __ZN5physx14materialAccessEPKNS_14PxTriangleMeshEj, __ZNK17SizeBySpeedModule6UpdateERK23ParticleSystemParticlesPPf: __ZNK17SizeBySpeedModule6UpdateERK23ParticleSystemParticlesPPf, _UNITY_png_inflate_claim: _UNITY_png_inflate_claim, __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE8__appendEj, _iswupper_l: _iswupper_l, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_, __Z41CanvasGroup_Get_Custom_PropBlocksRaycastsP12Il2CppObject: __Z41CanvasGroup_Get_Custom_PropBlocksRaycastsP12Il2CppObject, __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE8__appendEj, __ZN14NavMeshManager9LayerDataaSERKS0_: __ZN14NavMeshManager9LayerDataaSERKS0_, __ZN12_GLOBAL__N_116MetaDataProvider4lockEv: __ZN12_GLOBAL__N_116MetaDataProvider4lockEv, __ZN19CharacterController6CreateEPK9Rigidbody: __ZN19CharacterController6CreateEPK9Rigidbody, __Z46Register_UnityEngine_AudioSource_get_isPlayingv: __Z46Register_UnityEngine_AudioSource_get_isPlayingv, __ZN20ArchiveStorageReader15GetDecompressorEj: __ZN20ArchiveStorageReader15GetDecompressorEj, __Z35TextMesh_Set_Custom_PropLineSpacingP12Il2CppObjectf: __Z35TextMesh_Set_Custom_PropLineSpacingP12Il2CppObjectf, __ZNSt3__26locale5__imp12install_fromINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, __ZN12TLSAllocatorI14StackAllocatorEC2EPKc: __ZN12TLSAllocatorI14StackAllocatorEC2EPKc, __ZN17AnimationCurveTplIfE15SetPostInfinityEi: __ZN17AnimationCurveTplIfE15SetPostInfinityEi, __ZN13AudioListener12ApplyFiltersEv: __ZN13AudioListener12ApplyFiltersEv, __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL32solveContactCoulomb4_StaticBlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, _ntohs: _ntohs, __ZN5physx2Sc9ClothCore18addCollisionSphereERKNS_22PxClothCollisionSphereE: __ZN5physx2Sc9ClothCore18addCollisionSphereERKNS_22PxClothCollisionSphereE, __Z34Register_UnityEngine_Cubemap_Applyv: __Z34Register_UnityEngine_Cubemap_Applyv, __Z29StdTemplateConversionFunctionIyjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyjEbPvR14SafeBinaryRead, __ZN16Physics2DManagerD2Ev: __ZN16Physics2DManagerD2Ev, __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE: __ZN5physx26PxcArticulationFnsSimdBase16translateInertiaENS_6shdfnd3aos5Vec3VERKNS_12PxcFsInertiaE, __ZNK23PxsCMDiscreteUpdateTask7getNameEv: __ZNK23PxsCMDiscreteUpdateTask7getNameEv, __ZNK16Physics2DManager10IsTouchingEPK10Collider2DS2_: __ZNK16Physics2DManager10IsTouchingEPK10Collider2DS2_, __ZNK9dtNavMesh14getPolyRefBaseEPK10dtMeshTile: __ZNK9dtNavMesh14getPolyRefBaseEPK10dtMeshTile, __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE: __ZN12PhysXRaycast7GetAABBER4AABBRKN5physx12PxOverlapHitE, __Z16print_realstdoutPKci: __Z16print_realstdoutPKci, __Z60Register_UnityEngine_PlatformEffector2D_set_rotationalOffsetv: __Z60Register_UnityEngine_PlatformEffector2D_set_rotationalOffsetv, __ZN5physx8debugger4comm9SetCamera9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm9SetCamera9serializeERNS1_15EventSerializerE, __ZN5physx6shdfnd5ArrayIPKcNS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPKcNS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetSeparateAxesv: __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetSeparateAxesv, __ZN15DirectorManager14ConnectionPool16GrowEmptyBucketsEv: __ZN15DirectorManager14ConnectionPool16GrowEmptyBucketsEv, __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue: __ZN17PersistentManager32CopyToAwakeFromLoadQueueInternalER18AwakeFromLoadQueue, __ZNK5Umbra9Matrix4x411getMaxScaleEv: __ZNK5Umbra9Matrix4x411getMaxScaleEv, __Z30TextAsset_Get_Custom_PropBytesP12Il2CppObject: __Z30TextAsset_Get_Custom_PropBytesP12Il2CppObject, __ZN4FMOD6SoundI4lockEjjPPvS2_PjS3_: __ZN4FMOD6SoundI4lockEjjPPvS2_PjS3_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZN10Collider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10Collider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx3Scb17ArticulationJoint9syncStateEv: __ZN5physx3Scb17ArticulationJoint9syncStateEv, __ZN16TimerQueriesGLES19AddActiveTimerQueryEP14TimerQueryGLES: __ZN16TimerQueriesGLES19AddActiveTimerQueryEP14TimerQueryGLES, __Z57Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayv: __Z57Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayv, __ZN13MonoBehaviour20RemoveNodesFromListsEv: __ZN13MonoBehaviour20RemoveNodesFromListsEv, __Z43TerrainData_Get_Custom_PropDetailResolutionP12Il2CppObject: __Z43TerrainData_Get_Custom_PropDetailResolutionP12Il2CppObject, __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb1EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb1EEEEEvPT_, _open: _open, __ZN5physx2Sc10NPhaseCore33releaseActorPairContactReportDataEPNS0_26ActorPairContactReportDataE: __ZN5physx2Sc10NPhaseCore33releaseActorPairContactReportDataEPNS0_26ActorPairContactReportDataE, __ZN6b2Body7SetTypeE10b2BodyType: __ZN6b2Body7SetTypeE10b2BodyType, __Z53Playable_CUSTOM_INTERNAL_CALL_CanChangeInputsInternalR9HPlayable: __Z53Playable_CUSTOM_INTERNAL_CALL_CanChangeInputsInternalR9HPlayable, __ZN21AssetBundleFileSystem5CloseER13FileEntryData: __ZN21AssetBundleFileSystem5CloseER13FileEntryData, __Z35Transform_Get_Custom_PropChildCountP12Il2CppObject: __Z35Transform_Get_Custom_PropChildCountP12Il2CppObject, __Z26getPxRigidActor_GlobalPosePKN5physx12PxRigidActorE: __Z26getPxRigidActor_GlobalPosePKN5physx12PxRigidActorE, __Z30GetPlayerShouldRunInBackgroundv: __Z30GetPlayerShouldRunInBackgroundv, __ZNK5physx16PxBroadPhaseBase21getOutOfBoundsObjectsEv: __ZNK5physx16PxBroadPhaseBase21getOutOfBoundsObjectsEv, __ZNSt3__26locale5__imp12install_fromINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, __Z13RegisterClassIN2UI6CanvasEEvv: __Z13RegisterClassIN2UI6CanvasEEvv, __ZNK5physx11HullLibrary7checkitEPNS_3TriE: __ZNK5physx11HullLibrary7checkitEPNS_3TriE, __ZN4FMOD7SystemI13getNumDriversEPi: __ZN4FMOD7SystemI13getNumDriversEPi, __Z45Register_UnityEngine_Sprite_Internal_GetPivotv: __Z45Register_UnityEngine_Sprite_Internal_GetPivotv, _fwrite_file_func: _fwrite_file_func, __ZN6Object15GetSuperClassIDEi: __ZN6Object15GetSuperClassIDEi, __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN9GfxDevice17BeginProfileEventEPKc: __ZN9GfxDevice17BeginProfileEventEPKc, __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE: __ZNK13TranslateGLES17FramebufferTargetEN2gl17FramebufferTargetE, __ZN5physx13PxParticleExt15createIndexPoolEjjPKj: __ZN5physx13PxParticleExt15createIndexPoolEjjPKj, __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17ProceduralTexture17TextureParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z40Register_UnityEngine_Camera_SetupCurrentv: __Z40Register_UnityEngine_Camera_SetupCurrentv, __ZN9GfxDevice14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns: __ZN9GfxDevice14ImmediateBeginE16GfxPrimitiveTypePK14ChannelAssigns, _funlockfile: _funlockfile, __ZN9AnimationD2Ev: __ZN9AnimationD2Ev, __ZN15MBP_PairManager12shrinkMemoryEv: __ZN15MBP_PairManager12shrinkMemoryEv, __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev: __ZNSt3__213__vector_baseINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEED2Ev, __ZNK15b2FrictionJoint17GetReactionTorqueEf: __ZNK15b2FrictionJoint17GetReactionTorqueEf, __ZN10systeminfo24GetProcessorFrequencyMHzEv: __ZN10systeminfo24GetProcessorFrequencyMHzEv, __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenv: __Z61Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenv, __Z38Rigidbody_Set_Custom_PropSleepVelocityP12Il2CppObjectf: __Z38Rigidbody_Set_Custom_PropSleepVelocityP12Il2CppObjectf, __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev: __ZN5physx26PxBoxGeometryGeneratedInfoC2Ev, __ZL10SweepEventP14TESStesselatorP10TESSvertex: __ZL10SweepEventP14TESStesselatorP10TESSvertex, __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE10InitializeEv: __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE10InitializeEv, __ZN21AssetBundleFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN21AssetBundleFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __Z44TrailRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf: __Z44TrailRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj37ENS_22PxRepXPropertyAccessorILj37ENS_11PxRigidBodyEffEEEEvRKT0_, __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_T_, __ZN5physx2Sc15ClothFabricCoreC2ERKNS_7PxEMPTYE: __ZN5physx2Sc15ClothFabricCoreC2ERKNS_7PxEMPTYE, __ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj: __ZN21ArchiveStorageCreator10BeginBlockEb15CompressionType16CompressionLevelj, __ZN5physx8debugger4comm14CreateInstanceD0Ev: __ZN5physx8debugger4comm14CreateInstanceD0Ev, __ZN5physx33setupFinalizeExtSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_16PxsSolverExtBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff: __ZN5physx33setupFinalizeExtSolverConstraintsERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_20PxcCorrelationBufferERKNS_11PxTransformESB_bPhRKNS_16PxsSolverExtBodyESF_RKNS_17PxcSolverBodyDataESI_ffffff, __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j: __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j, __Z45PhysicMaterial_Set_Custom_PropDynamicFrictionP12Il2CppObjectf: __Z45PhysicMaterial_Set_Custom_PropDynamicFrictionP12Il2CppObjectf, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE, __ZN5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEED0Ev: __ZN5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEED0Ev, __Z9SetIIMGUIP6IIMGUI: __Z9SetIIMGUIP6IIMGUI, __ZN15LightProbeGroupD2Ev: __ZN15LightProbeGroupD2Ev, __ZN12LineRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12LineRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z28SetupPixelCorrectCoordinatesv: __Z28SetupPixelCorrectCoordinatesv, __ZN17CapsuleCollider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN17CapsuleCollider2D23VirtualRedirectTransferER14SafeBinaryRead, _tt_cmap10_get_info: _tt_cmap10_get_info, __ZN15ReflectionProbeC2E10MemLabelId18ObjectCreationMode: __ZN15ReflectionProbeC2E10MemLabelId18ObjectCreationMode, __ZNSt3__218__insertion_sort_3IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_: __ZNSt3__218__insertion_sort_3IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_, __ZNK5physx2Sc9ClothCore22getNbCollisionConvexesEv: __ZNK5physx2Sc9ClothCore22getNbCollisionConvexesEv, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5Umbra9Matrix2x2mLEf: __ZN5Umbra9Matrix2x2mLEf, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE12getAggregateEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __Z44SurfaceEffector2D_Set_Custom_PropUseFrictionP12Il2CppObjecth: __Z44SurfaceEffector2D_Set_Custom_PropUseFrictionP12Il2CppObjecth, __Z18SkinGenericMathLibILi1ELb1ELb1EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi1ELb1ELb1EEvR12SkinMeshInfo, __ZN15LODGroupManager26CollectAllLODGroupManagersEPK6CameraR13dynamic_arrayIPS_Lj4EEb: __ZN15LODGroupManager26CollectAllLODGroupManagersEPK6CameraR13dynamic_arrayIPS_Lj4EEb, __ZN14PhysicsManager11CapsuleCastERK8Vector3fS2_fS2_fR10RaycastHiti23QueryTriggerInteraction: __ZN14PhysicsManager11CapsuleCastERK8Vector3fS2_fS2_fR10RaycastHiti23QueryTriggerInteraction, __ZNK5physx7NpShape14getNbMaterialsEv: __ZNK5physx7NpShape14getNbMaterialsEv, __ZN5Umbra14TomeCollectionC2EPNS_9AllocatorE: __ZN5Umbra14TomeCollectionC2EPNS_9AllocatorE, __Z40Register_UnityEngine_LensFlare_get_flarev: __Z40Register_UnityEngine_LensFlare_get_flarev, __Z42Register_UnityEngine_GUI_BringWindowToBackv: __Z42Register_UnityEngine_GUI_BringWindowToBackv, __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_: __ZN5physx14PxRigidBodyExt31computeVelocityDeltaFromImpulseERKNS_11PxRigidBodyERKNS_11PxTransformERKNS_6PxVec3ES9_ffRS7_SA_, __Z24RegisterStrippedTypeInfoI21WorldParticleColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI21WorldParticleColliderEviPKcS2_, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetYv, _XXH32_digest: _XXH32_digest, _gzgetc: _gzgetc, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj83ENS_22PxRepXPropertyAccessorILj83ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj83ENS_22PxRepXPropertyAccessorILj83ES4_jjEEEEvjRKT0_, __Z89Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanChangeInputsInternalv: __Z89Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanChangeInputsInternalv, __Z24sweepBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z24sweepBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN12_GLOBAL__N_123FStreamNetworkOutStream7releaseEv: __ZN12_GLOBAL__N_123FStreamNetworkOutStream7releaseEv, __Z59Register_UnityEngine_ParticleSystem_INTERNAL_get_startColorv: __Z59Register_UnityEngine_ParticleSystem_INTERNAL_get_startColorv, __ZN13ScreenManager40SetConcreteOrientationFromPlayerSettingsEi: __ZN13ScreenManager40SetConcreteOrientationFromPlayerSettingsEi, __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj4ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE: __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj4ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE, __ZN19AudioHighPassFilter15ThreadedCleanupEv: __ZN19AudioHighPassFilter15ThreadedCleanupEv, __Z13RegisterClassI17ProceduralTextureEvv: __Z13RegisterClassI17ProceduralTextureEvv, __Z47SystemInfo_Get_Custom_PropGraphicsDeviceVersionv: __Z47SystemInfo_Get_Custom_PropGraphicsDeviceVersionv, __ZN22RenderingCommandBuffer7CleanupEv: __ZN22RenderingCommandBuffer7CleanupEv, __ZN12AudioManagerD0Ev: __ZN12AudioManagerD0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE6appendERKS6_jj, __ZN12_GLOBAL__N_117ConnectionManager27connectionAllocationHandlerEjPKcS2_iPv: __ZN12_GLOBAL__N_117ConnectionManager27connectionAllocationHandlerEjPKcS2_iPv, __Z55Register_UnityEngine_Input_get_simulateMouseWithTouchesv: __Z55Register_UnityEngine_Input_get_simulateMouseWithTouchesv, __Z27CubicPolynomialRootsGenericPfdddd: __Z27CubicPolynomialRootsGenericPfdddd, _strcat: _strcat, __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab21SerializedShaderState8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__217moneypunct_bynameIwLb0EE14do_frac_digitsEv: __ZNKSt3__217moneypunct_bynameIwLb0EE14do_frac_digitsEv, __ZN17ArchiveFileSystem14UnmountArchiveEP20ArchiveStorageReader: __ZN17ArchiveFileSystem14UnmountArchiveEP20ArchiveStorageReader, __ZN14AsyncOperationD0Ev: __ZN14AsyncOperationD0Ev, __Z26SkinVerticesGenericMathLibILi4ELb1ELb0EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi4ELb1ELb0EEvPKhiiiiPhiPKvS4_, __ZN7mecanim12statemachine20DestroyStateConstantEPNS0_13StateConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine20DestroyStateConstantEPNS0_13StateConstantERNS_6memory9AllocatorE, __ZN12NavMeshAgent4StopEv: __ZN12NavMeshAgent4StopEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj48ENS_22PxRepXPropertyAccessorILj48ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj48ENS_22PxRepXPropertyAccessorILj48ES4_ffEEEEvRKT0_, __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture: __ZN16ReflectionProbes22ForceProbeToUseTextureER15ReflectionProbeP7Texture, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEbT0_S6_T_, __ZN12MeshCollider21IsScaleBakingRequiredEv: __ZN12MeshCollider21IsScaleBakingRequiredEv, __ZNK5physx6shdfnd10Foundation20getAllocatorCallbackEv: __ZNK5physx6shdfnd10Foundation20getAllocatorCallbackEv, __Z41Projector_Set_Custom_PropOrthographicSizeP12Il2CppObjectf: __Z41Projector_Set_Custom_PropOrthographicSizeP12Il2CppObjectf, _raccess_guess_darwin_ufs_export: _raccess_guess_darwin_ufs_export, _LzmaDec_InitDicAndState: _LzmaDec_InitDicAndState, __ZNKSt3__217moneypunct_bynameIcLb0EE16do_negative_signEv: __ZNKSt3__217moneypunct_bynameIcLb0EE16do_negative_signEv, __ZN15AnimationBinder17InitCurveIDLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEE: __ZN15AnimationBinder17InitCurveIDLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEE, __ZN23UnityPurchasingSettings18InitializeDefaultsEv: __ZN23UnityPurchasingSettings18InitializeDefaultsEv, __ZN11TypeManager18InitializeAllTypesEv: __ZN11TypeManager18InitializeAllTypesEv, __ZN13b2PulleyJointC2EPK16b2PulleyJointDef: __ZN13b2PulleyJointC2EPK16b2PulleyJointDef, __ZN11NavMeshData23VirtualRedirectTransferER14SafeBinaryRead: __ZN11NavMeshData23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE25__construct_node_with_keyERS6_: __ZNSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE25__construct_node_with_keyERS6_, __ZN4FMOD7Channel18get3DCustomRolloffEPP11FMOD_VECTORPi: __ZN4FMOD7Channel18get3DCustomRolloffEPP11FMOD_VECTORPi, __ZNSt3__2L15ucs4_to_utf16leEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L15ucs4_to_utf16leEPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE, __ZN8Renderer27CheckStaticBatchConsistencyEv: __ZN8Renderer27CheckStaticBatchConsistencyEv, __ZNK5physx3Ext13RevoluteJoint29getProjectionAngularToleranceEv: __ZNK5physx3Ext13RevoluteJoint29getProjectionAngularToleranceEv, __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE8__appendEj, __ZN9AudioClipD0Ev: __ZN9AudioClipD0Ev, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv: __ZNK12_GLOBAL__N_111StreamOwner11isConnectedEv, __ZN12CullingGroup25SetDistanceReferencePointERKN4math7_float3E: __ZN12CullingGroup25SetDistanceReferencePointERKN4math7_float3E, __ZN9Transform24MoveAfterSiblingInternalEPKS_b: __ZN9Transform24MoveAfterSiblingInternalEPKS_b, __Z49ParticleSystem_NoiseModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z49ParticleSystem_NoiseModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __Z46Register_UnityEngine_AndroidJNI_GetStringFieldv: __Z46Register_UnityEngine_AndroidJNI_GetStringFieldv, __Z45PhysicMaterial_Get_Custom_PropDynamicFrictionP12Il2CppObject: __Z45PhysicMaterial_Get_Custom_PropDynamicFrictionP12Il2CppObject, __Z49Register_UnityEngine_Light_get_commandBufferCountv: __Z49Register_UnityEngine_Light_get_commandBufferCountv, __ZN25ThreadsafeLinearAllocatorC2EiiPKc: __ZN25ThreadsafeLinearAllocatorC2EiiPKc, __Z36RenderSettings_Set_Custom_PropSkyboxP12Il2CppObject: __Z36RenderSettings_Set_Custom_PropSkyboxP12Il2CppObject, __Z81Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_InternalCreatev: __Z81Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_InternalCreatev, _UNITY_FT_Stream_GetUOffset: _UNITY_FT_Stream_GetUOffset, __ZN14GfxContextGLES11MakeCurrentER7ApiGLESN2gl13ContextHandleE: __ZN14GfxContextGLES11MakeCurrentER7ApiGLESN2gl13ContextHandleE, __Z51Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Castv: __Z51Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Castv, _UNITY_tt_glyphzone_new: _UNITY_tt_glyphzone_new, __ZN5Image13ReformatImageEii13TextureFormatN14ImageReference8BlitModeE: __ZN5Image13ReformatImageEii13TextureFormatN14ImageReference8BlitModeE, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZZ23InitPlayerLoopCallbacksvEN52PostLateUpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN52PostLateUpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv, __ZN5physx2Cm12RenderOutput13outputCapsuleEffRKNS0_8Matrix34E: __ZN5physx2Cm12RenderOutput13outputCapsuleEffRKNS0_8Matrix34E, __ZNSt3__211__sift_downIR26RenderDeferredObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_: __ZNSt3__211__sift_downIR26RenderDeferredObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_, _UNITY_png_get_gAMA: _UNITY_png_get_gAMA, __ZN6Camera20CleanupDepthTexturesEv: __ZN6Camera20CleanupDepthTexturesEv, __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher: __ZN19SkinnedMeshRenderer17PrepareSkinCommonEiP18JobBatchDispatcher, __Z55Register_UnityEngine_SortingLayer_GetLayerValueFromNamev: __Z55Register_UnityEngine_SortingLayer_GetLayerValueFromNamev, _UNITY_png_check_IHDR: _UNITY_png_check_IHDR, __ZN13RuntimeStaticI17UniqueIDGeneratorE10InitializeEv: __ZN13RuntimeStaticI17UniqueIDGeneratorE10InitializeEv, __ZN9GfxDevice19PutGeometryJobFenceE13UniqueSmallID: __ZN9GfxDevice19PutGeometryJobFenceE13UniqueSmallID, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv, __ZN16GraphicsSettings22WarmupPreloadedShadersEv: __ZN16GraphicsSettings22WarmupPreloadedShadersEv, __Z34Canvas_Set_Custom_PropSortingOrderP12Il2CppObjecti: __Z34Canvas_Set_Custom_PropSortingOrderP12Il2CppObjecti, __ZThn264_N31CanvasBatchIntermediateRenderer14OnAssetDeletedEv: __ZThn264_N31CanvasBatchIntermediateRenderer14OnAssetDeletedEv, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE18__construct_at_endEj, __ZNSt3__213__vector_baseINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEED2Ev: __ZNSt3__213__vector_baseINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEED2Ev, __ZN9ShaderLab4Pass6RetainEv: __ZN9ShaderLab4Pass6RetainEv, __Z40OcclusionArea_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z40OcclusionArea_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN19SpriteMeshGenerator11evaluateLODEff: __ZN19SpriteMeshGenerator11evaluateLODEff, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11detachShapeERNS_7PxShapeEb: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11detachShapeERNS_7PxShapeEb, _feholdexcept: _feholdexcept, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15unlockParticlesEv, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj: __ZNSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj, __ZNK27AnimatorControllerParameter15GetDefaultFloatEv: __ZNK27AnimatorControllerParameter15GetDefaultFloatEv, __ZN13UnityProfiler17GetAvailableFrameEv: __ZN13UnityProfiler17GetAvailableFrameEv, __ZN15DistanceJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15DistanceJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN2UI6Canvas8TransferI14SafeBinaryReadEEvRT_: __ZN2UI6Canvas8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z40AudioListener_CUSTOM_GetOutputDataHelperP11Il2CppArrayi: __Z40AudioListener_CUSTOM_GetOutputDataHelperP11Il2CppArrayi, __ZN38StateMachineBehaviourVectorDescription8TransferI14SafeBinaryReadEEvRT_: __ZN38StateMachineBehaviourVectorDescription8TransferI14SafeBinaryReadEEvRT_, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47WebCamTexture_Get_Custom_PropVideoRotationAngleP12Il2CppObject: __Z47WebCamTexture_Get_Custom_PropVideoRotationAngleP12Il2CppObject, __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN12LineRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12LineRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_: __ZN5physx10RemovePairEjjRNS_14SapPairManagerERPjRjS4_, __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeJointFramesERKNS_11PxTransformES4_: __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeJointFramesERKNS_11PxTransformES4_, __ZN21ExecutionOrderManager29SortBehaviourByExecutionOrderEii: __ZN21ExecutionOrderManager29SortBehaviourByExecutionOrderEii, __ZN4FMOD13ChannelGroupI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD13ChannelGroupI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi24EEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI19StaticArrayTransferIiLi24EEEEvRT_PKc17TransferMetaFlags, __Z18WWW_CUSTOM_InitWWWP12Il2CppObjectP12Il2CppStringP11Il2CppArrayS4_: __Z18WWW_CUSTOM_InitWWWP12Il2CppObjectP12Il2CppStringP11Il2CppArrayS4_, __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER9JSONWrite, __ZN10GUIManager7RepaintEi: __ZN10GUIManager7RepaintEi, __ZNK5physx9NpPhysics15getClothFabricsEPPNS_13PxClothFabricEj: __ZNK5physx9NpPhysics15getClothFabricsEPPNS_13PxClothFabricEj, __ZNK18VertexChannelsInfoltERKS_: __ZNK18VertexChannelsInfoltERKS_, __Z13RegisterClassI10AudioMixerEvv: __Z13RegisterClassI10AudioMixerEvv, __ZN5physx2Cm17FreeListAllocator14pushOnFreeListEPNS0_5ChunkEj: __ZN5physx2Cm17FreeListAllocator14pushOnFreeListEPNS0_5ChunkEj, __ZN13GfxDeviceNull12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj: __ZN13GfxDeviceNull12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj, __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc7BodySimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z18SetTargetFrameRatei: __Z18SetTargetFrameRatei, __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_: __ZN5physx7profile11EventHeader9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_, __Z24RegisterStrippedTypeInfoI6AvatarEviPKcS2_: __Z24RegisterStrippedTypeInfoI6AvatarEviPKcS2_, __ZN14ObjectGUIState10BeginOnGUIEv: __ZN14ObjectGUIState10BeginOnGUIEv, __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIfEEvRT_PKc17TransferMetaFlags, __Z22DetermineFilterExtentsPfiiP10CBBoxInt32: __Z22DetermineFilterExtentsPfiiP10CBBoxInt32, __ZN10MemoryFileD0Ev: __ZN10MemoryFileD0Ev, _FixedJointSolverPrep: _FixedJointSolverPrep, __Z57Register_UnityEngine_QualitySettings_get_shadowProjectionv: __Z57Register_UnityEngine_QualitySettings_get_shadowProjectionv, __Z43Register_UnityEngine_AnimationCurve_GetKeysv: __Z43Register_UnityEngine_AnimationCurve_GetKeysv, __Z56setPxSimulationStatisticsRequiredContactConstraintMemoryPN5physx22PxSimulationStatisticsEj: __Z56setPxSimulationStatisticsRequiredContactConstraintMemoryPN5physx22PxSimulationStatisticsEj, __Z54LightProbeProxyVolume_Set_Custom_PropProbePositionModeP12Il2CppObjecti: __Z54LightProbeProxyVolume_Set_Custom_PropProbePositionModeP12Il2CppObjecti, __ZN5Umbra10VisibilityC2ERKS0_: __ZN5Umbra10VisibilityC2ERKS0_, __ZN16PlayerConnectionD2Ev: __ZN16PlayerConnectionD2Ev, __ZN21FixedBehaviourManager6UpdateEv: __ZN21FixedBehaviourManager6UpdateEv, __ZNK9dtNavMesh15findNearestPolyEPKfS1_Pf: __ZNK9dtNavMesh15findNearestPolyEPKfS1_Pf, __ZN9Transform9SetParentEPS_NS_15SetParentOptionE: __ZN9Transform9SetParentEPS_NS_15SetParentOptionE, __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff: __Z29CalculatePointsFromClippedBoxR13dynamic_arrayI8Vector2fLj4EERKS_I8Vector3fLj4EEff, __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_: __ZN13GUIStyleState8TransferI14SafeBinaryReadEEvRT_, __ZN4FMOD6System12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE: __ZN4FMOD6System12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRb: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRb, __Z45Register_UnityEngine_TerrainData_GetAlphamapsv: __Z45Register_UnityEngine_TerrainData_GetAlphamapsv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRd: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRd, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRe: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRe, __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_: __ZN14qsort_internal6_QSortIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_, __ZN5physx20PxcSweepSphereSphereERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx20PxcSweepSphereSphereERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS0_9allocatorIS4_EEEEE16StaticInitializeEPv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRl: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRl, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRm: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRm, __ZN5IMGUI14GUIWindowState9GetWindowEi: __ZN5IMGUI14GUIWindowState9GetWindowEi, __Z50WheelCollider_CUSTOM_INTERNAL_set_suspensionSpringP12Il2CppObjectRK11JointSpring: __Z50WheelCollider_CUSTOM_INTERNAL_set_suspensionSpringP12Il2CppObjectRK11JointSpring, __ZN8Animator38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei: __ZN8Animator38PostProcessTopologyChangeMultithreadedERK9FrameDataP8Playablei, __Z48Register_UnityEngine_Rigidbody2D_get_useAutoMassv: __Z48Register_UnityEngine_Rigidbody2D_get_useAutoMassv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRt: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRt, __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE: __ZN5physx3Cct26CharacterControllerManager17releaseControllerERNS_12PxControllerE, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRx: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRx, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRy: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRy, __Z17InstantiateObjectR6ObjectR9TransformRK8Vector3fRK11Quaternionf: __Z17InstantiateObjectR6ObjectR9TransformRK8Vector3fRK11Quaternionf, __Z59Register_UnityEngine_Networking_UnityWebRequest_get_isErrorv: __Z59Register_UnityEngine_Networking_UnityWebRequest_get_isErrorv, __ZN14NavMeshManager7CleanupEv: __ZN14NavMeshManager7CleanupEv, __Z42VRSettings_Get_Custom_PropEyeTextureHeightv: __Z42VRSettings_Get_Custom_PropEyeTextureHeightv, __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpeedv: __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpeedv, __Z52Register_UnityEngine_Application_get_runInBackgroundv: __Z52Register_UnityEngine_Application_get_runInBackgroundv, __ZN5physx5cloth16TripletScheduler4simdEjj: __ZN5physx5cloth16TripletScheduler4simdEjj, __ZNK14SerializedFile12GetByteStartEx: __ZNK14SerializedFile12GetByteStartEx, _Round_To_Grid: _Round_To_Grid, __Z49Register_UnityEngine_LensFlare_INTERNAL_set_colorv: __Z49Register_UnityEngine_LensFlare_INTERNAL_set_colorv, __ZN16SpriteRenderDataaSERKS_: __ZN16SpriteRenderDataaSERKS_, __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cprojl: _cprojl, __Z41getPxArticulation_ExternalDriveIterationsPKN5physx14PxArticulationE: __Z41getPxArticulation_ExternalDriveIterationsPKN5physx14PxArticulationE, _tt_cmap8_get_info: _tt_cmap8_get_info, __ZN15CollisionEvents5ClearEv: __ZN15CollisionEvents5ClearEv, __ZN5physx2Sc17ParticleSystemSim21scheduleCollisionPrepERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim21scheduleCollisionPrepERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN19GCProfilerCallbacks9OnGCEventEPvii: __ZN19GCProfilerCallbacks9OnGCEventEPvii, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteBoolEb, __ZN6Object10SmartResetEv: __ZN6Object10SmartResetEv, __Z22Texture3D_CUSTOM_ApplyP12Il2CppObjecthh: __Z22Texture3D_CUSTOM_ApplyP12Il2CppObjecthh, __Z35DebugLogHandler_CUSTOM_Internal_Log7LogTypeP12Il2CppStringP12Il2CppObject: __Z35DebugLogHandler_CUSTOM_Internal_Log7LogTypeP12Il2CppStringP12Il2CppObject, __Z46UploadHandlerRaw_CUSTOM_InternalSetContentTypeP12Il2CppObjectP12Il2CppString: __Z46UploadHandlerRaw_CUSTOM_InternalSetContentTypeP12Il2CppObjectP12Il2CppString, __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIbEEvRT_PKc17TransferMetaFlags, __ZN16b2PrismaticJoint11EnableLimitEb: __ZN16b2PrismaticJoint11EnableLimitEb, __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold24addBatchManifoldContactsEPKNS0_17PersistentContactEj, __ZL17ProgramUniform3ivPK7ApiGLESjiihPKv: __ZL17ProgramUniform3ivPK7ApiGLESjiihPKv, __ZN5physx2Sc10NPhaseCore15fetchFilterPairEj: __ZN5physx2Sc10NPhaseCore15fetchFilterPairEj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleTireLoadFilterDataEE12readPropertyIfEEbRT_, __ZN5physx8debugger15ForwardingArrayIPNS0_4comm21PvdInstanceDataStream10PvdCommandEED0Ev: __ZN5physx8debugger15ForwardingArrayIPNS0_4comm21PvdInstanceDataStream10PvdCommandEED0Ev, __Z29StdTemplateConversionFunctionIhsEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhsEbPvR14SafeBinaryRead, __Z40WheelCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z40WheelCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __ZN9GfxDevice25GetBackBufferColorSurfaceEv: __ZN9GfxDevice25GetBackBufferColorSurfaceEv, __ZN23TransformChangeDispatch37InitTransformHierarchyTRSChangedMasksER18TransformHierarchy: __ZN23TransformChangeDispatch37InitTransformHierarchyTRSChangedMasksER18TransformHierarchy, __ZN15OcclusionPortal8TransferI14SafeBinaryReadEEvRT_: __ZN15OcclusionPortal8TransferI14SafeBinaryReadEEvRT_, __ZN16RayRTreeCallbackILi0ELb0EED0Ev: __ZN16RayRTreeCallbackILi0ELb0EED0Ev, __ZN21DownloadHandlerBuffer22OnReceiveContentLengthEj: __ZN21DownloadHandlerBuffer22OnReceiveContentLengthEj, __ZN5physx2Sc5Scene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE: __ZN5physx2Sc5Scene27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE, __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj632ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z13RegisterClassI6ShaderEvv: __Z13RegisterClassI6ShaderEvv, __ZNK5physx17ConvexMeshBuilder4saveERNS_14PxOutputStreamEb: __ZNK5physx17ConvexMeshBuilder4saveERNS_14PxOutputStreamEb, __ZN2UI14CanvasRenderer10SyncBoundsENS0_8SyncFlagE: __ZN2UI14CanvasRenderer10SyncBoundsENS0_8SyncFlagE, __Z18Transfer_BlittableI9JSONWriteLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc21ArticulationJointCore21setExternalComplianceEf: __ZN5physx2Sc21ArticulationJointCore21setExternalComplianceEf, __ZN5physx20PxsParticleSystemSim23scheduleCollisionUpdateERNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim23scheduleCollisionUpdateERNS_10PxBaseTaskE, __ZNSt3__211regex_errorD0Ev: __ZNSt3__211regex_errorD0Ev, __ZN9Texture3D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Texture3D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToDoubleArrayP11Il2CppArrayRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToDoubleArrayP11Il2CppArrayRPv, __ZN13LoadOperation13SetNoWorkToDoEv: __ZN13LoadOperation13SetNoWorkToDoEv, __Z13RegisterClassI10SampleClipEvv: __Z13RegisterClassI10SampleClipEvv, __Z37Motion_Get_Custom_PropAverageDurationP12Il2CppObject: __Z37Motion_Get_Custom_PropAverageDurationP12Il2CppObject, __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_: __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb1EEclERK21ForwardRenderPassDataS4_, __ZN22ProceduralMaterialDataC2ERKS_: __ZN22ProceduralMaterialDataC2ERKS_, __Z35getPxSceneDescContactModifyCallbackPKN5physx11PxSceneDescE: __Z35getPxSceneDescContactModifyCallbackPKN5physx11PxSceneDescE, __Z33EmitSerializationCommandsForFieldI24GenerateTypeTreeTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI24GenerateTypeTreeTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZNK5physx2Sc19ParticlePacketShape13getFilterInfoERjRNS_12PxFilterDataE: __ZNK5physx2Sc19ParticlePacketShape13getFilterInfoERjRNS_12PxFilterDataE, __ZN14TimerQueryGLES12MeasureBeginEv: __ZN14TimerQueryGLES12MeasureBeginEv, __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues: __ZN21BillboardBatchManager24AutoBillboardShaderPropsC2ER16ShaderKeywordSetR24BuiltinShaderParamValues, __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy: __ZN13dynamic_arrayIjLj4EE18resize_initializedEjRKj12ResizePolicy, __Z29Transfer_Blittable_ArrayFieldI9JSONWritetEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritetEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5Umbra15OcclusionBuffer18setCameraTransformERKNS_15CameraTransformE: __ZN5Umbra15OcclusionBuffer18setCameraTransformERKNS_15CameraTransformE, __ZN13ScreenManager15SetBlitMaterialEv: __ZN13ScreenManager15SetBlitMaterialEv, __ZN7ApiGLES11FlushBufferEjN2gl12BufferTargetEll: __ZN7ApiGLES11FlushBufferEjN2gl12BufferTargetEll, __ZN5physx6shdfnd4TimeC2Ev: __ZN5physx6shdfnd4TimeC2Ev, __ZNK8LODGroup10GetEnabledEv: __ZNK8LODGroup10GetEnabledEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags, __ZN12_GLOBAL__N_127PrepareReadback_ResolveMSAAER18GfxFramebufferGLESR7ApiGLESP17RenderSurfaceGLESS5_: __ZN12_GLOBAL__N_127PrepareReadback_ResolveMSAAER18GfxFramebufferGLESR7ApiGLESP17RenderSurfaceGLESS5_, __ZN7mecanim15InvertValueMaskEPNS_14ValueArrayMaskE: __ZN7mecanim15InvertValueMaskEPNS_14ValueArrayMaskE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_, __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Behaviour8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11ShapeModule13DidDeleteMeshEP14ParticleSystem: __ZN11ShapeModule13DidDeleteMeshEP14ParticleSystem, __ZNSt12experimental19bad_optional_accessD0Ev: __ZNSt12experimental19bad_optional_accessD0Ev, __ZNK24RendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK24RendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZN5physx8debugger14PvdMarshallingIsxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsxE12marshalBlockEPKhPhj, __ZN15QualitySettings18SetMaximumLODLevelEi: __ZN15QualitySettings18SetMaximumLODLevelEi, __ZN22BaseUnityConnectClient15OnDonePreparingEv: __ZN22BaseUnityConnectClient15OnDonePreparingEv, __ZN15CollisionModule8TransferI14SafeBinaryReadEEvRT_: __ZN15CollisionModule8TransferI14SafeBinaryReadEEvRT_, __ZN8GUIStyle8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8GUIStyle8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z51Register_UnityEngine_Material_SetColorArrayImplListv: __Z51Register_UnityEngine_Material_SetColorArrayImplListv, __ZN5Unity9Component20WillDestroyComponentEv: __ZN5Unity9Component20WillDestroyComponentEv, __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi: __ZNSt3__213__stable_sortIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeEi, _sha512crypt: _sha512crypt, __Z51Register_UnityEngine_Rigidbody_get_solverIterationsv: __Z51Register_UnityEngine_Rigidbody_get_solverIterationsv, __ZN11UnityEngine15PlatformWrapper14GetProductGUIDEv: __ZN11UnityEngine15PlatformWrapper14GetProductGUIDEv, __Z37AudioReverbZone_Get_Custom_PropRoomLFP12Il2CppObject: __Z37AudioReverbZone_Get_Custom_PropRoomLFP12Il2CppObject, __Z29Mesh_Set_Custom_PropBindposesP12Il2CppObjectP11Il2CppArray: __Z29Mesh_Set_Custom_PropBindposesP12Il2CppObjectP11Il2CppArray, __ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv: __ZNK27StateMachineBehaviourPlayer15IsSenderEnabledEv, __Z40getPxRigidDynamic_StabilizationThresholdPKN5physx14PxRigidDynamicE: __Z40getPxRigidDynamic_StabilizationThresholdPKN5physx14PxRigidDynamicE, __ZNKSt3__210moneypunctIwLb1EE16do_negative_signEv: __ZNKSt3__210moneypunctIwLb1EE16do_negative_signEv, __ZN11IMGUIModule21ClearDeveloperConsoleEv: __ZN11IMGUIModule21ClearDeveloperConsoleEv, __Z42Register_UnityEngine_PlayerPrefs_GetStringv: __Z42Register_UnityEngine_PlayerPrefs_GetStringv, __Z16GetBuildSettingsv: __Z16GetBuildSettingsv, __Z55Register_UnityEngine_VR_VRSettings_get_eyeTextureHeightv: __Z55Register_UnityEngine_VR_VRSettings_get_eyeTextureHeightv, __ZNK5physx2Sq12BucketPruner10getPayloadERKj: __ZNK5physx2Sq12BucketPruner10getPayloadERKj, __ZN14GfxContextGLES8InstanceD2Ev: __ZN14GfxContextGLES8InstanceD2Ev, __Z25GetBuiltinResourceManagerv: __Z25GetBuiltinResourceManagerv, __ZN4FMOD7Channel13set3DPanLevelEf: __ZN4FMOD7Channel13set3DPanLevelEf, _isupper: _isupper, __ZSt18make_exception_ptrINSt3__212future_errorEESt13exception_ptrT_: __ZSt18make_exception_ptrINSt3__212future_errorEESt13exception_ptrT_, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN5physx13NpVolumeCache21setMaxNbDynamicShapesEj: __ZN5physx13NpVolumeCache21setMaxNbDynamicShapesEj, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN12CachedReaderD2Ev: __ZN12CachedReaderD2Ev, __ZNK14UnityWebStream24GetEstimatedDownloadSizeEv: __ZNK14UnityWebStream24GetEstimatedDownloadSizeEv, __ZNKSt3__217moneypunct_bynameIcLb0EE13do_pos_formatEv: __ZNKSt3__217moneypunct_bynameIcLb0EE13do_pos_formatEv, __ZN13AnimationClip17MainThreadCleanupEv: __ZN13AnimationClip17MainThreadCleanupEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setRestOffsetEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE13setRestOffsetEf, __ZNK5physx3Ext13RevoluteJoint28getProjectionLinearToleranceEv: __ZNK5physx3Ext13RevoluteJoint28getProjectionLinearToleranceEv, __Z40getPxSceneDescContactCorrelationDistancePKN5physx11PxSceneDescE: __Z40getPxSceneDescContactCorrelationDistancePKN5physx11PxSceneDescE, __Z29RegisterModule_ParticleSystemv: __Z29RegisterModule_ParticleSystemv, __ZN6Motion21AddSelfToDependenciesER8UserList: __ZN6Motion21AddSelfToDependenciesER8UserList, __ZNK12b2ChainShape11ComputeAABBEP6b2AABBRK11b2Transformib: __ZNK12b2ChainShape11ComputeAABBEP6b2AABBRK11b2Transformib, __ZN13dynamic_arrayI12PPtrKeyframeLj4EEC2ERKS1_: __ZN13dynamic_arrayI12PPtrKeyframeLj4EEC2ERKS1_, __ZN7mecanim5human8BoneNameEj: __ZN7mecanim5human8BoneNameEj, __Z13RegisterClassI10MonoScriptEvv: __Z13RegisterClassI10MonoScriptEvv, __ZNSt3__26locale5__imp12install_fromINS_7codecvtIwc11__mbstate_tEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7codecvtIwc11__mbstate_tEEEEvRKS1_, __ZNK5physx3Cct10Controller16getInternalStatsERNS_17PxControllerStatsE: __ZNK5physx3Cct10Controller16getInternalStatsERNS_17PxControllerStatsE, __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZThn12_N5physx3Ext14PrismaticJointD0Ev: __ZThn12_N5physx3Ext14PrismaticJointD0Ev, _UNITY_FT_Select_Charmap: _UNITY_FT_Select_Charmap, __Z51ParticleSystem_InheritVelocityModule_CUSTOM_SetModeP12Il2CppObjecti: __Z51ParticleSystem_InheritVelocityModule_CUSTOM_SetModeP12Il2CppObjecti, __Z46UnityWebRequest_CUSTOM_InternalSetCustomMethodP12Il2CppObjectP12Il2CppString: __Z46UnityWebRequest_CUSTOM_InternalSetCustomMethodP12Il2CppObjectP12Il2CppString, __ZNSt3__214__shared_countD2Ev: __ZNSt3__214__shared_countD2Ev, __ZN11AudioSource16SetBypassEffectsEb: __ZN11AudioSource16SetBypassEffectsEb, __ZN4FMOD3DSP13getNumOutputsEPi: __ZN4FMOD3DSP13getNumOutputsEPi, __Z42Register_UnityEngine_Rigidbody2D_AddTorquev: __Z42Register_UnityEngine_Rigidbody2D_AddTorquev, __ZN5physx7CookingD0Ev: __ZN5physx7CookingD0Ev, __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE8__appendEj, __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE: __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseE, __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj: __ZN5physx2Sq16BucketPrunerNode13classifyBoxesEffjPNS0_9BucketBoxEPKNS0_13PrunerPayloadES3_PS4_bj, __Z52Register_UnityEngine_Camera_set_transparencySortModev: __Z52Register_UnityEngine_Camera_set_transparencySortModev, __Z58Register_UnityEngine_Connect_UnityAdsSettings_get_testModev: __Z58Register_UnityEngine_Connect_UnityAdsSettings_get_testModev, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZN7mecanim12statemachine25DestroyStateMachineMemoryEPNS0_18StateMachineMemoryERNS_6memory9AllocatorE: __ZN7mecanim12statemachine25DestroyStateMachineMemoryEPNS0_18StateMachineMemoryERNS_6memory9AllocatorE, __ZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_: __ZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_, __Z29setPxRigidBody_LinearVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E: __Z29setPxRigidBody_LinearVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E, __Z24RegisterStrippedTypeInfoI15ConstantForce2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15ConstantForce2DEviPKcS2_, __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev: __ZN5physx40PxVehicleDifferentialNWDataGeneratedInfoC2Ev, __ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE: __ZN5physx2Sc7Element20createLowLevelVolumeEjRKNS_9PxBounds3EjRKNS_9AABBMgrIdE, __Z35Light_Get_Custom_PropShadowStrengthP12Il2CppObject: __Z35Light_Get_Custom_PropShadowStrengthP12Il2CppObject, __Z35AnimationClip_Get_Custom_PropLegacyP12Il2CppObject: __Z35AnimationClip_Get_Custom_PropLegacyP12Il2CppObject, __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetSeparateAxesv: __Z83Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetSeparateAxesv, __ZN13RenderManager28AreCamerasUsingMotionVectorsEv: __ZN13RenderManager28AreCamerasUsingMotionVectorsEv, __Z16WarmupAllShadersv: __Z16WarmupAllShadersv, __Z24GetAssetBundleFileSystemv: __Z24GetAssetBundleFileSystemv, __Z25InitializeLODGroupManagerPv: __Z25InitializeLODGroupManagerPv, __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb: __ZN11UnityEngine9Animation31SetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERKN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEb, __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_: __ZNSt3__27__sort4IR11IndexSorterPiEEjT0_S4_S4_S4_T_, __Z48Application_Get_Custom_PropIsShowingSplashScreenv: __Z48Application_Get_Custom_PropIsShowingSplashScreenv, __ZN11UnityEngine7Connect15AppRunningEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine7Connect15AppRunningEvent12ToJsonStringER9JSONWrite, __Z48Register_UnityEngine_Application_get_companyNamev: __Z48Register_UnityEngine_Application_get_companyNamev, __ZNKSt20bad_array_new_length4whatEv: __ZNKSt20bad_array_new_length4whatEv, __Z45CanvasGroup_Set_Custom_PropIgnoreParentGroupsP12Il2CppObjecth: __Z45CanvasGroup_Set_Custom_PropIgnoreParentGroupsP12Il2CppObjecth, __ZN6Object17InsertObjectInMapEPS_: __ZN6Object17InsertObjectInMapEPS_, __ZNK6Camera11GetPositionEv: __ZNK6Camera11GetPositionEv, __ZNK5physx20PxsSolverCoreGeneral26solveVParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RKNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESJ_RKNSD_IjNSF_IjEEEEPNS_2Cm13SpatialVectorERij: __ZNK5physx20PxsSolverCoreGeneral26solveVParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RKNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESJ_RKNSD_IjNSF_IjEEEEPNS_2Cm13SpatialVectorERij, __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ExceptionOccurredRPv: __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ExceptionOccurredRPv, __Z65Register_UnityEngine_AudioSettings_INTERNAL_CALL_GetConfigurationv: __Z65Register_UnityEngine_AudioSettings_INTERNAL_CALL_GetConfigurationv, __Z74Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRateUnbiased_Internalv: __Z74Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRateUnbiased_Internalv, __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEESB_RKT_: __ZNSt3__26__treeIiNS_4lessIiEENS_9allocatorIiEEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS8_EEiEESB_RKT_, __ZNK16MemoryFileSystem8FilenameERK13FileEntryData: __ZNK16MemoryFileSystem8FilenameERK13FileEntryData, __ZN19TransportJavaScript8FinalizeEv: __ZN19TransportJavaScript8FinalizeEv, __ZN22ProceduralMaterialData14SetArchiveDataEP20SubstanceArchiveData: __ZN22ProceduralMaterialData14SetArchiveDataEP20SubstanceArchiveData, __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15ParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j, __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeI21GLESRenderTargetSetupN2gl6HandleILNS3_10ObjectTypeE9EEEEENS_19__map_value_compareIS2_S7_NS_4lessIS2_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN5Unity5Joint30CalculateGlobalConnectedAnchorEb: __ZN5Unity5Joint30CalculateGlobalConnectedAnchorEb, __Z21setPxConstraint_FlagsPN5physx12PxConstraintENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __Z21setPxConstraint_FlagsPN5physx12PxConstraintENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev: __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEED2Ev, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv, __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __ZN5physx15NpParticleFluid12setStiffnessEf: __ZN5physx15NpParticleFluid12setStiffnessEf, __ZN14DirectorPlayer17SetTimeUpdateModeE18DirectorUpdateMode: __ZN14DirectorPlayer17SetTimeUpdateModeE18DirectorUpdateMode, __Z34Collider2D_Get_Custom_PropFrictionP12Il2CppObject: __Z34Collider2D_Get_Custom_PropFrictionP12Il2CppObject, __Z18CleanupClothModulev: __Z18CleanupClothModulev, __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDeviceii9TextureIDiiiiiiii: __ZN4gles15BlitFramebufferERNS_23BlitFramebufferDrawQuadER9GfxDeviceii9TextureIDiiiiiiii, __Z22DelayedDestroyCallbackP6ObjectPv: __Z22DelayedDestroyCallbackP6ObjectPv, _alphasort: _alphasort, __ZN13DrawImmediate5BeginE16GfxPrimitiveTypePK14ChannelAssigns: __ZN13DrawImmediate5BeginE16GfxPrimitiveTypePK14ChannelAssigns, __ZN14GfxDeviceStats9DrawStats5ResetEv: __ZN14GfxDeviceStats9DrawStats5ResetEv, __ZN14Physics2DState7CleanupEv: __ZN14Physics2DState7CleanupEv, _UNITY_FT_Stroker_GetBorderCounts: _UNITY_FT_Stroker_GetBorderCounts, __ZN15b2ContactFilter13ShouldCollideEP9b2FixtureS1_: __ZN15b2ContactFilter13ShouldCollideEP9b2FixtureS1_, __ZN13AnimationClip15QuaternionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13AnimationClip15QuaternionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine9Animation28GenericAnimationBindingCacheD2Ev: __ZN11UnityEngine9Animation28GenericAnimationBindingCacheD2Ev, __Z36getPxVehicleEngineData_RecipMaxOmegaPKN5physx19PxVehicleEngineDataE: __Z36getPxVehicleEngineData_RecipMaxOmegaPKN5physx19PxVehicleEngineDataE, __ZNK2UI6Canvas26GetTypeInfoVirtualInternalEv: __ZNK2UI6Canvas26GetTypeInfoVirtualInternalEv, __ZNK5physx3Ext20DefaultCpuDispatcher14getWorkerCountEv: __ZNK5physx3Ext20DefaultCpuDispatcher14getWorkerCountEv, __ZN15ParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15ParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv, __ZN5physx2Sn29setMissingPropertiesToDefaultEPNS0_7XmlNodeERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEjRNS_7profile14ProfileHashMapIPKcjNS_6shdfnd4HashISB_EEEE: __ZN5physx2Sn29setMissingPropertiesToDefaultEPNS0_7XmlNodeERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEjRNS_7profile14ProfileHashMapIPKcjNS_6shdfnd4HashISB_EEEE, __ZN11TimeManagerD0Ev: __ZN11TimeManagerD0Ev, __ZN27AnimationLayerMixerPlayable11DerivesFromEP11Il2CppClass: __ZN27AnimationLayerMixerPlayable11DerivesFromEP11Il2CppClass, __Z69Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointP12Il2CppObjectRK13Vector2fIcallPS1_: __Z69Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointP12Il2CppObjectRK13Vector2fIcallPS1_, __ZN8LODGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8LODGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN12AudioManager33GetAudioEffectInternalDefinitionsEv: __ZN12AudioManager33GetAudioEffectInternalDefinitionsEv, __ZN9Scripting16GetInstanceIDForEP12Il2CppObject: __ZN9Scripting16GetInstanceIDForEP12Il2CppObject, __Z36Register_UnityEngine_Random_get_seedv: __Z36Register_UnityEngine_Random_get_seedv, __ZN20LocalFileSystemPosix4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN20LocalFileSystemPosix4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z37Animation_CUSTOM_INTERNAL_CALL_RewindP12Il2CppObject: __Z37Animation_CUSTOM_INTERNAL_CALL_RewindP12Il2CppObject, _res_init: _res_init, __ZN13dynamic_arrayItLj2EEC2ERKS0_: __ZN13dynamic_arrayItLj2EEC2ERKS0_, __ZN7ApiGLES11BindTextureEj16TextureDimension: __ZN7ApiGLES11BindTextureEj16TextureDimension, __Z63Register_UnityEngine_Material_Internal_GetTextureScaleAndOffsetv: __Z63Register_UnityEngine_Material_Internal_GetTextureScaleAndOffsetv, __Z40ParticleSystem_Set_Custom_PropStartSpeedP12Il2CppObjectf: __Z40ParticleSystem_Set_Custom_PropStartSpeedP12Il2CppObjectf, __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z51ParticleSystem_TrailModule_CUSTOM_GetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient: __Z51ParticleSystem_TrailModule_CUSTOM_GetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient, _fill_mem_input_buffer: _fill_mem_input_buffer, __ZNK14ParticleSystem34CalculateSubEmitterMaximumLifeTimeEfi: __ZNK14ParticleSystem34CalculateSubEmitterMaximumLifeTimeEfi, __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN2UI6Canvas12AddToManagerEv: __ZN2UI6Canvas12AddToManagerEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN23b2EdgeAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN23b2EdgeAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator, __Z17setPxScene_LimitsPN5physx7PxSceneERKNS_13PxSceneLimitsE: __Z17setPxScene_LimitsPN5physx7PxSceneERKNS_13PxSceneLimitsE, __ZN14CachingManager18GetExpirationDelayEv: __ZN14CachingManager18GetExpirationDelayEv, __Z37GetTransformFromComponentOrGameObjectP6Object: __Z37GetTransformFromComponentOrGameObjectP6Object, __ZN15PointEffector2D16SetDistanceScaleEf: __ZN15PointEffector2D16SetDistanceScaleEf, _cf2_hint_isTop: _cf2_hint_isTop, __Z53Register_UnityEngine_ReflectionProbe_set_farClipPlanev: __Z53Register_UnityEngine_ReflectionProbe_set_farClipPlanev, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEl: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEl, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN6Sprite10InitializeEP9Texture2DRK5RectTIfERK8Vector2ffj14SpriteMeshTypeRK8Vector4ffbPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENSD_9allocatorISG_EEEE: __ZN6Sprite10InitializeEP9Texture2DRK5RectTIfERK8Vector2ffj14SpriteMeshTypeRK8Vector4ffbPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENSD_9allocatorISG_EEEE, __ZN22RenderingCommandBuffer20ExecuteCommandBufferER17ShaderPassContextRK15RenderNodeQueue: __ZN22RenderingCommandBuffer20ExecuteCommandBufferER17ShaderPassContextRK15RenderNodeQueue, __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5Light8SetFlareEP5Flare: __ZN5Light8SetFlareEP5Flare, __ZN14DirectorPlayer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14DirectorPlayer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z49Register_UnityEngine_AnimationState_get_blendModev: __Z49Register_UnityEngine_AnimationState_get_blendModev, __ZN4FMOD13ChannelGroupI12getNumGroupsEPi: __ZN4FMOD13ChannelGroupI12getNumGroupsEPi, __ZN2UI15DoSyncMaterialsERNS_13UIInstructionER13dynamic_arrayI4PPtrI8MaterialELj4EERS2_I7SubMeshLj4EE9TextureIDSB_8Vector4fb: __ZN2UI15DoSyncMaterialsERNS_13UIInstructionER13dynamic_arrayI4PPtrI8MaterialELj4EERS2_I7SubMeshLj4EE9TextureIDSB_8Vector4fb, _ps_unicodes_init: _ps_unicodes_init, __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE7reserveEj, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEf: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEf, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv, __ZN13dynamic_arrayIjLj4EEC2ERKS0_RK10MemLabelId: __ZN13dynamic_arrayIjLj4EEC2ERKS0_RK10MemLabelId, __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_localRotationAxisv: __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_localRotationAxisv, __Z45Register_UnityEngine_Material_set_renderQueuev: __Z45Register_UnityEngine_Material_set_renderQueuev, __ZN4crnd12crn_unpacker22decode_color_endpointsEv: __ZN4crnd12crn_unpacker22decode_color_endpointsEv, __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb: __ZNK5physx2Gu15HeightFieldUtil11getTriangleERKNS_11PxTransformERNS_10PxTriangleEPjS7_jbb, __Z24RegisterStrippedTypeInfoI20UnityConnectSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI20UnityConnectSettingsEviPKcS2_, __ZN15CapsuleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15CapsuleCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx7NpShape23getTriangleMeshGeometryERNS_22PxTriangleMeshGeometryE: __ZNK5physx7NpShape23getTriangleMeshGeometryERNS_22PxTriangleMeshGeometryE, __ZN15FileSystemEntryC2EPKcR17FileSystemHandler: __ZN15FileSystemEntryC2EPKcR17FileSystemHandler, __ZN9Heightmap8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Heightmap8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z15tessMeshNewMeshP9TESSalloc: __Z15tessMeshNewMeshP9TESSalloc, _UNITY_png_get_user_transform_ptr: _UNITY_png_get_user_transform_ptr, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZN25PostFilteredUserCollectorD0Ev: __ZN25PostFilteredUserCollectorD0Ev, __Z43Register_UnityEngine_Animator_SetBoolStringv: __Z43Register_UnityEngine_Animator_SetBoolStringv, __ZN5physx2Sc11Interaction10initializeEv: __ZN5physx2Sc11Interaction10initializeEv, __ZN5physx7NpScene7releaseEv: __ZN5physx7NpScene7releaseEv, __ZNK5physx21PxsFluidCollisionTask7getNameEv: __ZNK5physx21PxsFluidCollisionTask7getNameEv, __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, _UNITY_FT_Create_Class_tt_cmap_classes: _UNITY_FT_Create_Class_tt_cmap_classes, __ZN21ArchiveStorageCreator10BeginBlockE15CompressionType16CompressionLevelj: __ZN21ArchiveStorageCreator10BeginBlockE15CompressionType16CompressionLevelj, __Z41Register_UnityEngine_Joint_set_breakForcev: __Z41Register_UnityEngine_Joint_set_breakForcev, __ZN13InitialModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13InitialModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sc18ParticleSystemCore15createParticlesERKNS_22PxParticleCreationDataE: __ZN5physx2Sc18ParticleSystemCore15createParticlesERKNS_22PxParticleCreationDataE, __ZN9Scripting18RaiseNullExceptionEPKcz: __ZN9Scripting18RaiseNullExceptionEPKcz, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE11runInternalEv, __Z59Register_UnityEngine_AssetBundleManifest_GetAllDependenciesv: __Z59Register_UnityEngine_AssetBundleManifest_GetAllDependenciesv, __ZN5physx6shdfnd7PAUtils8rawEventEtjjh: __ZN5physx6shdfnd7PAUtils8rawEventEtjjh, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE, __ZN14PhysicsManager11WakeUpSceneEv: __ZN14PhysicsManager11WakeUpSceneEv, __ZN5physx3Ext13DistanceJoint20setDistanceJointFlagENS_19PxDistanceJointFlag4EnumEb: __ZN5physx3Ext13DistanceJoint20setDistanceJointFlagENS_19PxDistanceJointFlag4EnumEb, __Z54Register_UnityEngine_AudioReverbFilter_set_reverbDelayv: __Z54Register_UnityEngine_AudioReverbFilter_set_reverbDelayv, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE6resizeEjRKS4_, __ZN5physx2Sn25readStridedBufferPropertyINS_19PxHeightFieldSampleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_19PxHeightFieldSampleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNSt3__215numpunct_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__215numpunct_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN15SkyboxGenerator26ReleaseSkyboxVertexBuffersEv: __ZN15SkyboxGenerator26ReleaseSkyboxVertexBuffersEv, __Z48Register_UnityEngine_AudioSource_get_minDistancev: __Z48Register_UnityEngine_AudioSource_get_minDistancev, __Z58Register_UnityEngine_TrailRenderer_INTERNAL_set_startColorv: __Z58Register_UnityEngine_TrailRenderer_INTERNAL_set_startColorv, __Z46SystemInfo_Get_Custom_PropMaxRenderTextureSizev: __Z46SystemInfo_Get_Custom_PropMaxRenderTextureSizev, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToFloatArrayP11Il2CppArrayRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToFloatArrayP11Il2CppArrayRPv, __Z54TerrainData_Set_Custom_PropInternal_alphamapResolutionP12Il2CppObjecti: __Z54TerrainData_Set_Custom_PropInternal_alphamapResolutionP12Il2CppObjecti, __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI17SortingLayerEntryEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementI17SortingLayerEntryEEvRT_17TransferMetaFlags, __Z10CanDestroy9HPlayable: __Z10CanDestroy9HPlayable, __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SpeedTreeWind7SParams8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z27Light_Set_Custom_PropCookieP12Il2CppObjectS0_: __Z27Light_Set_Custom_PropCookieP12Il2CppObjectS0_, __ZN5physx2Sc8RigidSimC2ERNS0_5SceneERNS0_9RigidCoreENS0_14IslandNodeInfo4TypeE: __ZN5physx2Sc8RigidSimC2ERNS0_5SceneERNS0_9RigidCoreENS0_14IslandNodeInfo4TypeE, __ZN7Joint2D12AddToManagerEv: __ZN7Joint2D12AddToManagerEv, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS_30PxcContactTraceSegmentCallbackELb1ELb1ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_, __ZN8UserList11SendMessageERK17MessageIdentifier: __ZN8UserList11SendMessageERK17MessageIdentifier, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev, __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetWorldSpacev: __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetWorldSpacev, __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z: __ZN5physx6shdfnd10Foundation5errorENS_11PxErrorCode4EnumEPKciS5_z, __ZN5physx12NpConstraint9markDirtyEv: __ZN5physx12NpConstraint9markDirtyEv, __ZN9HaloLayer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9HaloLayer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN17CapsuleCollider2DD0Ev: __ZN17CapsuleCollider2DD0Ev, __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI18UnityInterfaceGUIDP15IUnityInterfaceEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __Z37setPxVehicleSuspensionDataMSprungMassPN5physx23PxVehicleSuspensionDataEf: __Z37setPxVehicleSuspensionDataMSprungMassPN5physx23PxVehicleSuspensionDataEf, __ZN12AudioManager15GetProfilerDataER10AudioStats: __ZN12AudioManager15GetProfilerDataER10AudioStats, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx2Gu31generatedCapsuleBoxFaceContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE: __ZN5physx2Gu31generatedCapsuleBoxFaceContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE, __Z52Event_CUSTOM_INTERNAL_CALL_Internal_SetMousePositionP12Il2CppObjectRK13Vector2fIcall: __Z52Event_CUSTOM_INTERNAL_CALL_Internal_SetMousePositionP12Il2CppObjectRK13Vector2fIcall, __ZN8Renderer15SetSortingOrderEs: __ZN8Renderer15SetSortingOrderEs, __Z38Effector2D_Set_Custom_PropColliderMaskP12Il2CppObjecti: __Z38Effector2D_Set_Custom_PropColliderMaskP12Il2CppObjecti, __ZNK3WWW17GetThreadPriorityEv: __ZNK3WWW17GetThreadPriorityEv, __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN9JSONWriteC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE: __ZN18GfxFramebufferGLES22MakeCurrentFramebufferENS_7BuiltinE, __ZN14AnimationEvent8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14AnimationEvent8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK6Camera16GetTargetTextureEv: __ZNK6Camera16GetTargetTextureEv, __Z29DeleteCachedSerializationDataP23CachedSerializationData: __Z29DeleteCachedSerializationDataP23CachedSerializationData, __ZN20ArchiveStorageHeader13GetHeaderSizeERKNS_6HeaderE: __ZN20ArchiveStorageHeader13GetHeaderSizeERKNS_6HeaderE, __Z19dtOverlapPolyPoly2DPKfiS0_i: __Z19dtOverlapPolyPoly2DPKfiS0_i, __Z38Caching_Get_Custom_PropExpirationDelayv: __Z38Caching_Get_Custom_PropExpirationDelayv, __ZN18CrashReportManager33OnPlayerSessionStateChangedStaticEjyy: __ZN18CrashReportManager33OnPlayerSessionStateChangedStaticEjyy, __ZN10GUITexture8TransferI14SafeBinaryReadEEvRT_: __ZN10GUITexture8TransferI14SafeBinaryReadEEvRT_, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadyEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadyEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __Z34ParticleSystemRenderer_RenderTrailRK15RenderNodeQueueRK17BatchInstanceDataR21DynamicVBOChunkHandleR13dynamic_arrayIN10DynamicVBO10DrawParamsELj4EER9GfxDevice: __Z34ParticleSystemRenderer_RenderTrailRK15RenderNodeQueueRK17BatchInstanceDataR21DynamicVBOChunkHandleR13dynamic_arrayIN10DynamicVBO10DrawParamsELj4EER9GfxDevice, __Z39OffMeshLink_Set_Custom_PropCostOverrideP12Il2CppObjectf: __Z39OffMeshLink_Set_Custom_PropCostOverrideP12Il2CppObjectf, _recvmsg: _recvmsg, __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_: __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_, __Z33SpringJoint_Get_Custom_PropDamperP12Il2CppObject: __Z33SpringJoint_Get_Custom_PropDamperP12Il2CppObject, __Z49setPxVehicleWheelsSimData_TireForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E: __Z49setPxVehicleWheelsSimData_TireForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E, _UNITY_LZ4_decompress_safe_partial: _UNITY_LZ4_decompress_safe_partial, __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE: __ZN11UnityEngine9Animation28DestroyAvatarBindingConstantEPNS0_21AvatarBindingConstantERN7mecanim6memory9AllocatorE, __ZN16MemoryFileSystem16DestroyFileEntryER13FileEntryData: __ZN16MemoryFileSystem16DestroyFileEntryER13FileEntryData, __ZNK5Umbra4Path8getNodesEv: __ZNK5Umbra4Path8getNodesEv, __Z63Register_UnityEngine_Physics2D_INTERNAL_get_colliderAsleepColorv: __Z63Register_UnityEngine_Physics2D_INTERNAL_get_colliderAsleepColorv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z40AudioSource_Set_Custom_PropRolloffFactorP12Il2CppObjectf: __Z40AudioSource_Set_Custom_PropRolloffFactorP12Il2CppObjectf, __ZN16MessageForwarder23RegisterMessageCallbackEiPFvPviR11MessageDataEPKN5Unity4TypeE: __ZN16MessageForwarder23RegisterMessageCallbackEiPFvPviR11MessageDataEPKN5Unity4TypeE, __Z45setPxVehicleWheelsSimData_SuspTravelDirectionPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E: __Z45setPxVehicleWheelsSimData_SuspTravelDirectionPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_xDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_xDrivev, __ZN11ForceModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11ForceModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4Mesh30AcquireSharedMeshRenderingDataEv: __ZN4Mesh30AcquireSharedMeshRenderingDataEv, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadiEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadiEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __ZNK7ApiGLES10GetContextEv: __ZNK7ApiGLES10GetContextEv, __ZN5physx14NpRigidDynamic25setStabilizationThresholdEf: __ZN5physx14NpRigidDynamic25setStabilizationThresholdEf, __ZN5Cache18SetExpirationDelayEi: __ZN5Cache18SetExpirationDelayEi, __Z7b2Alloci: __Z7b2Alloci, __ZN5physx2Sc5Scene19addBrokenConstraintEPNS0_14ConstraintCoreE: __ZN5physx2Sc5Scene19addBrokenConstraintEPNS0_14ConstraintCoreE, __ZN15TextureSettings14SetAnisoLimitsEii: __ZN15TextureSettings14SetAnisoLimitsEii, __ZN5physx2Gu5RTree15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Gu5RTree15importExtraDataERNS_24PxDeserializationContextE, __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN14VRSplashScreen22CleanupSplashMaterialsEv: __ZN14VRSplashScreen22CleanupSplashMaterialsEv, __ZNSt3__26locale5__imp12install_fromINS_5ctypeIcEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_5ctypeIcEEEEvRKS1_, __ZN21AnimationClipPlayable6MemoryD2Ev: __ZN21AnimationClipPlayable6MemoryD2Ev, __ZN2UI6Canvas19GetProjectionMatrixEv: __ZN2UI6Canvas19GetProjectionMatrixEv, __ZNK5physx5cloth8SwFabric16getNumRestvaluesEv: __ZNK5physx5cloth8SwFabric16getNumRestvaluesEv, __Z53Register_UnityEngine_AI_NavMeshAgent_get_angularSpeedv: __Z53Register_UnityEngine_AI_NavMeshAgent_get_angularSpeedv, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSD_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSD_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxHeightFieldDescEE12readPropertyIfEEbRT_, __Z33Event_Get_Custom_PropDisplayIndexP12Il2CppObject: __Z33Event_Get_Custom_PropDisplayIndexP12Il2CppObject, __Z49Joint_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth: __Z49Joint_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth, __ZN14NavMeshManager20NotifyNavMeshCleanupEv: __ZN14NavMeshManager20NotifyNavMeshCleanupEv, __ZN12HandlerChain5FirstEP17FileSystemHandler: __ZN12HandlerChain5FirstEP17FileSystemHandler, __Z39AudioMixer_CUSTOM_TransitionToSnapshotsP12Il2CppObjectP11Il2CppArrayS2_f: __Z39AudioMixer_CUSTOM_TransitionToSnapshotsP12Il2CppObjectP11Il2CppArrayS2_f, __Z43setPxVehicleWheelsSimData_WheelShapeMappingPN5physx22PxVehicleWheelsSimDataEji: __Z43setPxVehicleWheelsSimData_WheelShapeMappingPN5physx22PxVehicleWheelsSimDataEji, __ZN5physx31PxPrismaticJointGeneratedValuesC2EPKNS_16PxPrismaticJointE: __ZN5physx31PxPrismaticJointGeneratedValuesC2EPKNS_16PxPrismaticJointE, __Z50Register_UnityEngine_AnimationClip_SampleAnimationv: __Z50Register_UnityEngine_AnimationClip_SampleAnimationv, __ZN5physx2Sc35ParticleElementRbElementInteraction21deactivateForLowLevelEbj: __ZN5physx2Sc35ParticleElementRbElementInteraction21deactivateForLowLevelEbj, __ZN15TerrainCollider11CreateTreesEv: __ZN15TerrainCollider11CreateTreesEv, __ZN36ExternalForcesModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN36ExternalForcesModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN5physx5cloth8SwSolverD0Ev: __ZN5physx5cloth8SwSolverD0Ev, __ZN5physx2Sq10AABBPruner22refitUpdatedAndRemovedEv: __ZN5physx2Sq10AABBPruner22refitUpdatedAndRemovedEv, __ZN13GfxDeviceNull18CreateStencilStateERK15GfxStencilState: __ZN13GfxDeviceNull18CreateStencilStateERK15GfxStencilState, __GLOBAL__sub_I_runtime_graphics_lod_lump_cpp: __GLOBAL__sub_I_runtime_graphics_lod_lump_cpp, __ZNK5physx2Sq16BucketPrunerCore9visualizeERNS_2Cm12RenderOutputEj: __ZNK5physx2Sq16BucketPrunerCore9visualizeERNS_2Cm12RenderOutputEj, __Z48Register_UnityEngine_AudioChorusFilter_set_depthv: __Z48Register_UnityEngine_AudioChorusFilter_set_depthv, __Z64Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountv: __Z64Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountv, __ZN5physx2Sc5Scene27prepareOutOfBoundsCallbacksEv: __ZN5physx2Sc5Scene27prepareOutOfBoundsCallbacksEv, _UNITY_png_convert_from_struct_tm: _UNITY_png_convert_from_struct_tm, __ZNK12TreeDatabase27NeedUpgradeScaledPrototypesEv: __ZNK12TreeDatabase27NeedUpgradeScaledPrototypesEv, __ZL22PrepareMeshRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext: __ZL22PrepareMeshRenderNodesILb1EEvR35RenderNodeQueuePrepareThreadContext, __Z48Register_UnityEngine_GL_INTERNAL_CALL_MultMatrixv: __Z48Register_UnityEngine_GL_INTERNAL_CALL_MultMatrixv, __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN20TextRenderingPrivate25ReadFontFileAndAddToCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN20LocalFileSystemPosix5TouchER13FileEntryData: __ZN20LocalFileSystemPosix5TouchER13FileEntryData, __ZN9JSONWrite8TransferI13dynamic_arrayItLj2EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayItLj2EEEEvRT_PKc17TransferMetaFlags, _strxfrm: _strxfrm, __ZN5physx14PxsAABBManager19createAggregateElemEv: __ZN5physx14PxsAABBManager19createAggregateElemEv, __ZN5physx3Ext21InertiaTensorComputer12setEllipsoidEfff: __ZN5physx3Ext21InertiaTensorComputer12setEllipsoidEfff, __Z22GUI_CUSTOM_FocusWindowi: __Z22GUI_CUSTOM_FocusWindowi, __ZN15PointEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15PointEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z53Register_UnityEngine_VR_VRSettings_set_showDeviceViewv: __Z53Register_UnityEngine_VR_VRSettings_set_showDeviceViewv, __ZN8LODGroup7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8LODGroup7PRODUCEE10MemLabelId18ObjectCreationMode, __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci: __Z16realloc_internalPvjiRK10MemLabelId15AllocateOptionsPKci, __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatRGBAFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatRGBAFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN10systeminfo19GetExecutableSizeMBEv: __ZN10systeminfo19GetExecutableSizeMBEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE: __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setPhaseConfigENS0_5RangeIKNS0_11PhaseConfigEEE, __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13AnimationClip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13AnimationClip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN10MonoScript27InitializeAndRegisterScriptERK8UnityStrRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_SB_b: __ZN10MonoScript27InitializeAndRegisterScriptERK8UnityStrRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEESB_SB_b, __ZN9BlobWriteD2Ev: __ZN9BlobWriteD2Ev, __ZN15OcclusionPortal23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15OcclusionPortal23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z33GetMinimumTextureMipSizeForFormat13TextureFormat: __Z33GetMinimumTextureMipSizeForFormat13TextureFormat, __ZNKSt3__210moneypunctIcLb0EE16do_thousands_sepEv: __ZNKSt3__210moneypunctIcLb0EE16do_thousands_sepEv, __ZNK5Umbra17BasePoolAllocator7isEmptyEv: __ZNK5Umbra17BasePoolAllocator7isEmptyEv, __Z37Material_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_: __Z37Material_CUSTOM_SetFloatArrayImplListP12Il2CppObjectiS0_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ReflectionProbeUsageEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20ReflectionProbeUsageEvRT_RT0_PKc17TransferMetaFlags, __Z41Register_UnityEngine_AudioSource_set_timev: __Z41Register_UnityEngine_AudioSource_set_timev, __ZN5Umbra15KDTraverseStackINS_10NoUserDataEE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbS1_S1_: __ZN5Umbra15KDTraverseStackINS_10NoUserDataEE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbS1_S1_, __Z47Register_UnityEngine_SystemInfo_get_npotSupportv: __Z47Register_UnityEngine_SystemInfo_get_npotSupportv, __ZN12_GLOBAL__N_16ParserILb0EED0Ev: __ZN12_GLOBAL__N_16ParserILb0EED0Ev, __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationXMultiplierP12Il2CppObjectf: __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationXMultiplierP12Il2CppObjectf, __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbPN2UI6CanvasES3_EPS3_EEvT0_S8_T_, __Z27Mathf_CUSTOM_NextPowerOfTwoi: __Z27Mathf_CUSTOM_NextPowerOfTwoi, __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __Z21sweepCapsule_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z21sweepCapsule_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5Unity17ConfigurableJoint30ApplyRebuildConfigurationSpaceEv: __ZN5Unity17ConfigurableJoint30ApplyRebuildConfigurationSpaceEv, __ZN8TToArray15CoordinateCountIfEEiv: __ZN8TToArray15CoordinateCountIfEEiv, __ZNSt3__27collateIwED2Ev: __ZNSt3__27collateIwED2Ev, __ZNK5physx2Cm10Collection9getObjectEj: __ZNK5physx2Cm10Collection9getObjectEj, __ZNK5physx7NpShape22getHeightFieldGeometryERNS_21PxHeightFieldGeometryE: __ZNK5physx7NpShape22getHeightFieldGeometryERNS_21PxHeightFieldGeometryE, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv, __ZN21EnlightenSceneMappingD2Ev: __ZN21EnlightenSceneMappingD2Ev, __Z47Register_UnityEngine_AudioSource_get_spatializev: __Z47Register_UnityEngine_AudioSource_get_spatializev, _UNITY_tt_face_lookup_table: _UNITY_tt_face_lookup_table, __Z19updateCollShapeDataRN5physx19PxsParticleCollDataERbjffRKNS_6PxVec3ES5_S5_S5_RKNS_11PxTransformE: __Z19updateCollShapeDataRN5physx19PxsParticleCollDataERbjffRKNS_6PxVec3ES5_S5_S5_RKNS_11PxTransformE, __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv: __ZNK5physx2Sc8ShapeSim14actorIsDynamicEv, __Z51QualitySettings_Set_Custom_PropAsyncUploadTimeSlicei: __Z51QualitySettings_Set_Custom_PropAsyncUploadTimeSlicei, __ZN17GeneralConnection18RegisterConnectionEji: __ZN17GeneralConnection18RegisterConnectionEji, __ZN5Umbra16TileTraverseTree4initINS_15StartCellFinderEEEbRKNS_11TransformerERKNS_15IntersectFilterET_f: __ZN5Umbra16TileTraverseTree4initINS_15StartCellFinderEEEbRKNS_11TransformerERKNS_15IntersectFilterET_f, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE12createObjectERPhRNS_24PxDeserializationContextE, _cf2_stack_pushFixed: _cf2_stack_pushFixed, __ZN9Texture3D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Texture3D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE12readPropertyIfEEbRT_, __ZN4crnd12crn_unpacker12unpack_dxt5aEPPhjjjjjj: __ZN4crnd12crn_unpacker12unpack_dxt5aEPPhjjjjjj, __ZN13GfxDeviceNull12SetSRGBWriteEb: __ZN13GfxDeviceNull12SetSRGBWriteEb, __ZN5physx34PxsSolverConstraintPostProcessTask13mergeContactsERNS_25PxsCompoundContactManagerERNS_16PxsThreadContextE: __ZN5physx34PxsSolverConstraintPostProcessTask13mergeContactsERNS_25PxsCompoundContactManagerERNS_16PxsThreadContextE, __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastRK8Vector3fS1_P10RaycastHitfi23QueryTriggerInteraction: __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastRK8Vector3fS1_P10RaycastHitfi23QueryTriggerInteraction, __Z54AnimatorControllerPlayable_CUSTOM_GetLayerNameInternalR9HPlayablei: __Z54AnimatorControllerPlayable_CUSTOM_GetLayerNameInternalR9HPlayablei, __Z15gpu_time_samplev: __Z15gpu_time_samplev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj70ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj70ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN6IDList23ShouldBeKeyboardControlE9FocusType: __ZN6IDList23ShouldBeKeyboardControlE9FocusType, __Z66AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoCountInternal9HPlayableRS_ih: __Z66AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoCountInternal9HPlayableRS_ih, __ZZ23InitPlayerLoopCallbacksvEN45EarlyUpdateScriptRunDelayedStartupFramestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN45EarlyUpdateScriptRunDelayedStartupFramestruct7ForwardEv, __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_: __ZNSt3__29__num_getIwE19__stage2_float_prepERNS_8ios_baseEPwRwS5_, __ZN5physx2Sc8ActorSimD2Ev: __ZN5physx2Sc8ActorSimD2Ev, __Z45Register_UnityEngine_Canvas_get_planeDistancev: __Z45Register_UnityEngine_Canvas_get_planeDistancev, __ZN5physx16PxVehicleDriveNW5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj: __ZN5physx16PxVehicleDriveNW5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj, _XXH64_freeState: _XXH64_freeState, __ZNK13WheelCollider15GetGlobalCenterEv: __ZNK13WheelCollider15GetGlobalCenterEv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx14SapPairManager11RemovePairsERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx14SapPairManager11RemovePairsERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z35Register_UnityEngine_WWW_DestroyWWWv: __Z35Register_UnityEngine_WWW_DestroyWWWv, __ZN5Unity17ConfigurableJoint16SetAngularZLimitERK14SoftJointLimit: __ZN5Unity17ConfigurableJoint16SetAngularZLimitERK14SoftJointLimit, __ZN9Rigidbody19SetSolverIterationsEi: __ZN9Rigidbody19SetSolverIterationsEi, __ZN17PrecomputeContextD2Ev: __ZN17PrecomputeContextD2Ev, __ZN7mecanim5human6Handle8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim5human6Handle8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN14GfxDeviceStatsC2Ev: __ZN14GfxDeviceStatsC2Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7mecanim12statemachine22StateMachineEvaluationEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7mecanim12statemachine22StateMachineEvaluationEEvRT_RT0_PKc17TransferMetaFlags, __ZN12NavMeshAgent18OnTransformChangedEi: __ZN12NavMeshAgent18OnTransformChangedEi, __ZN17SizeBySpeedModule8TransferI17RemapPPtrTransferEEvRT_: __ZN17SizeBySpeedModule8TransferI17RemapPPtrTransferEEvRT_, __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, _jpeg_free_large: _jpeg_free_large, __ZN24PhysicsUpdateBehaviour2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN24PhysicsUpdateBehaviour2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z45AnimationOffsetPlayable_CUSTOM_InternalCreateR9HPlayable: __Z45AnimationOffsetPlayable_CUSTOM_InternalCreateR9HPlayable, __ZN15LODGroupManager27GarbageCollectCameraLODDataEv: __ZN15LODGroupManager27GarbageCollectCameraLODDataEv, __Z27SetProfilerEnabledThisFrameb: __Z27SetProfilerEnabledThisFrameb, __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN19ShaderPropertySheet26GetOrCreateTexturePropertyERKN9ShaderLab16FastPropertyNameE: __ZN19ShaderPropertySheet26GetOrCreateTexturePropertyERKN9ShaderLab16FastPropertyNameE, __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN13ScreenManagerC2Ev: __ZN13ScreenManagerC2Ev, __Z38Register_UnityEngine_Cubemap_GetPixelsv: __Z38Register_UnityEngine_Cubemap_GetPixelsv, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_, __Z41SystemInfo_Get_Custom_PropSupportsStencilv: __Z41SystemInfo_Get_Custom_PropSupportsStencilv, __Z50WheelCollider_CUSTOM_INTERNAL_get_sidewaysFrictionP12Il2CppObjectP18WheelFrictionCurve: __Z50WheelCollider_CUSTOM_INTERNAL_get_sidewaysFrictionP12Il2CppObjectP18WheelFrictionCurve, __ZN12GUIClipState20CalculateMouseValuesER10InputEvent: __ZN12GUIClipState20CalculateMouseValuesER10InputEvent, __ZN5physx8debugger4comm12BeginSection9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm12BeginSection9serializeERNS1_15EventSerializerE, __ZN7ApiGLES4InitERK14GfxContextGLESR16GfxDeviceLevelGL: __ZN7ApiGLES4InitERK14GfxContextGLESR16GfxDeviceLevelGL, __Z15CreatePrimitivei: __Z15CreatePrimitivei, __ZN13GfxDeviceGLES25SetInvertProjectionMatrixEb: __ZN13GfxDeviceGLES25SetInvertProjectionMatrixEb, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIddEEPdEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIddEEPdEEbT0_S5_T_, __Z31CustomEventData_CUSTOM_AddSByteP12Il2CppObjectP12Il2CppStringa: __Z31CustomEventData_CUSTOM_AddSByteP12Il2CppObjectP12Il2CppStringa, __ZNK11LightProbes14LightProbeData33GetLightProbeInterpolationWeightsERK8Vector3fRiR8Vector4fRf: __ZNK11LightProbes14LightProbeData33GetLightProbeInterpolationWeightsERK8Vector3fRiR8Vector4fRf, __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle: __ZN5IMGUI9GUIButtonER8GUIStateRK5RectTIfER10GUIContentR8GUIStyle, __ZN5Unity5Joint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity5Joint7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj117ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj117ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z25CreateStreamedClipBuilderjj: __Z25CreateStreamedClipBuilderjj, __ZN6Object23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Object23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_, _ether_hostton: _ether_hostton, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEE15growAndPushBackERKS2_, __ZN19RuntimeSceneManager15FindSceneByPathERK8UnityStr: __ZN19RuntimeSceneManager15FindSceneByPathERK8UnityStr, __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh: __Z15ApplyBlendShapeRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoPh, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN15DistanceJoint2D6CreateEv: __ZN15DistanceJoint2D6CreateEv, __Z14DecodeBC7BlockP9HDRColorAPKh: __Z14DecodeBC7BlockP9HDRColorAPKh, __Z19BuildAngleWeightLUTPfiiff: __Z19BuildAngleWeightLUTPfiiff, __ZNK24RendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK24RendererAnimationBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, _UnityReplayKitStopRecording: _UnityReplayKitStopRecording, _seed48: _seed48, __ZN5physx2GuL18gPCMHullPrefetchCBEjPKNS_6PxVec3E: __ZN5physx2GuL18gPCMHullPrefetchCBEjPKNS_6PxVec3E, _UNITY_png_set_IHDR: _UNITY_png_set_IHDR, __ZN5physx20PxsParticleSystemSim19initializeParameterEv: __ZN5physx20PxsParticleSystemSim19initializeParameterEv, __ZN11UnityEngine7Connect18ConnectSessionInfo12ToJsonStringER8UnityStr: __ZN11UnityEngine7Connect18ConnectSessionInfo12ToJsonStringER8UnityStr, __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv: __ZN5physx2Sc19ShapeInstancePairLL13createManagerEv, __ZNSt3__26vectorI15RecordedTriggerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI15RecordedTriggerNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN17PolygonCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17PolygonCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sc9ClothCore20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE: __ZN5physx2Sc9ClothCore20setMotionConstraintsEPKNS_31PxClothParticleMotionConstraintE, _UNITY_FT_Init_Class_cff_service_glyph_dict: _UNITY_FT_Init_Class_cff_service_glyph_dict, _gethostname: _gethostname, __Z18ExtractAssetBundleR3WWW: __Z18ExtractAssetBundleR3WWW, __Z39SliderJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D: __Z39SliderJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D, __ZN9GfxDevice15ResetAllBuffersEv: __ZN9GfxDevice15ResetAllBuffersEv, __ZL24stbir__filter_catmullromff: __ZL24stbir__filter_catmullromff, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE, __ZN4Tree23VirtualRedirectTransferER14SafeBinaryRead: __ZN4Tree23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEED0Ev, __ZN5physx2Gu25computeCapsule_CapsuleMTDERKNS0_7CapsuleES3_RNS_10PxSweepHitE: __ZN5physx2Gu25computeCapsule_CapsuleMTDERKNS0_7CapsuleES3_RNS_10PxSweepHitE, __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15ConstantForce2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN20TextRenderingPrivate15GetFormatStringER11UTF16StringR13dynamic_arrayINS_16TextFormatChangeELj4EE: __ZN20TextRenderingPrivate15GetFormatStringER11UTF16StringR13dynamic_arrayINS_16TextFormatChangeELj4EE, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject, __Z54GUILayoutUtility_CUSTOM_INTERNAL_CALL_GetWindowsBoundsR5RectTIfE: __Z54GUILayoutUtility_CUSTOM_INTERNAL_CALL_GetWindowsBoundsR5RectTIfE, __Z90Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralIndirectv: __Z90Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralIndirectv, __Z37HingeJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth: __Z37HingeJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth, __ZN11TerrainData15ThreadedCleanupEv: __ZN11TerrainData15ThreadedCleanupEv, __ZN14SphereCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN14SphereCollider23VirtualRedirectTransferER14SafeBinaryRead, __Z38AudioSource_CUSTOM_GetSpatializerFloatP12Il2CppObjectiPf: __Z38AudioSource_CUSTOM_GetSpatializerFloatP12Il2CppObjectiPf, __Z31getPxClothParticleDataParticlesPKN5physx19PxClothParticleDataE: __Z31getPxClothParticleDataParticlesPKN5physx19PxClothParticleDataE, __ZN5Umbra12PortalCullerD2Ev: __ZN5Umbra12PortalCullerD2Ev, __ZN5Umbra9Matrix4x4mLEf: __ZN5Umbra9Matrix4x4mLEf, __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE: __ZN7mecanim9animation12GetHumanPoseIfEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE, __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13RenderManagerC2Ev: __ZN13RenderManagerC2Ev, __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE: __ZNK9ShaderLab11ShaderState17BuildDeviceStatesER9GfxDevicePK19ShaderPropertySheetS5_RNS0_12DeviceStatesE, __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E: __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E, __ZN15TerrainRenderer12RebuildNodesEv: __ZN15TerrainRenderer12RebuildNodesEv, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getCMassLocalPoseEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getCMassLocalPoseEv, __ZN11UnityEngine15CloudWebService19SessionEventManager14SetSessionInfoERK8UnityStr: __ZN11UnityEngine15CloudWebService19SessionEventManager14SetSessionInfoERK8UnityStr, __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEbEENS_19__map_value_compareIS4_S5_NS_4lessIS4_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __Z68Register_UnityEngine_RenderSettings_INTERNAL_set_ambientEquatorColorv: __Z68Register_UnityEngine_RenderSettings_INTERNAL_set_ambientEquatorColorv, __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev: __ZN5physx29PxVehicleNoDriveGeneratedInfoC2Ev, __ZN5physx2Gu11ReadIndicesEjjPjRNS_13PxInputStreamEb: __ZN5physx2Gu11ReadIndicesEjjPjRNS_13PxInputStreamEb, __Z41setPxArticulationJoint_ExternalCompliancePN5physx19PxArticulationJointEf: __Z41setPxArticulationJoint_ExternalCompliancePN5physx19PxArticulationJointEf, __Z54Register_UnityEngine_AreaEffector2D_get_forceMagnitudev: __Z54Register_UnityEngine_AreaEffector2D_get_forceMagnitudev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj391ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj391ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z27GL_Set_Custom_PropSRGBWriteh: __Z27GL_Set_Custom_PropSRGBWriteh, _ft_get_adobe_glyph_index: _ft_get_adobe_glyph_index, __Z30WindZone_Get_Custom_PropRadiusP12Il2CppObject: __Z30WindZone_Get_Custom_PropRadiusP12Il2CppObject, __ZNSt3__27codecvtIwc11__mbstate_tED2Ev: __ZNSt3__27codecvtIwc11__mbstate_tED2Ev, __ZNK14VertexDataInfo20GetActiveStreamCountEv: __ZNK14VertexDataInfo20GetActiveStreamCountEv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5ungetEv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5ungetEv, __ZN25MultiBlocksMemoryFileData17AdjustBlocksCountEj: __ZN25MultiBlocksMemoryFileData17AdjustBlocksCountEj, __ZNSt3__27codecvtIDsc11__mbstate_tED0Ev: __ZNSt3__27codecvtIDsc11__mbstate_tED0Ev, __ZNK5physx2Sc9ClothCore21getNbVirtualParticlesEv: __ZNK5physx2Sc9ClothCore21getNbVirtualParticlesEv, __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iii: __Z25SetRenderTargetFromScriptjPK21ScriptingRenderBufferS1_iii, __Z30Camera_CUSTOM_RenderWithShaderP12Il2CppObjectS0_P12Il2CppString: __Z30Camera_CUSTOM_RenderWithShaderP12Il2CppObjectS0_P12Il2CppString, __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_: __ZL29CanTransferTypeAsNestedObjectI23TransferArrayField_InfoEbRKT_, __ZN8GUIState12GetPushStateEi: __ZN8GUIState12GetPushStateEi, __ZN5physx9readFloatEbRNS_13PxInputStreamE: __ZN5physx9readFloatEbRNS_13PxInputStreamE, _pat_next: _pat_next, _unlockpt: _unlockpt, __Z50CanvasRenderer_CUSTOM_SplitUIVertexStreamsInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_: __Z50CanvasRenderer_CUSTOM_SplitUIVertexStreamsInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_, __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEC2EPKf: __ZN5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEC2EPKf, __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI6ShaderE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z10InAddrToIPP11sockaddr_in: __Z10InAddrToIPP11sockaddr_in, __ZN20HardwareInfoReporter24ReportHardwareInfoStaticEv: __ZN20HardwareInfoReporter24ReportHardwareInfoStaticEv, __Z35Renderer_Set_Custom_PropCastShadowsP12Il2CppObjecth: __Z35Renderer_Set_Custom_PropCastShadowsP12Il2CppObjecth, __ZNK14UnityWebStream26GetTotalBytesUntilLoadableEv: __ZNK14UnityWebStream26GetTotalBytesUntilLoadableEv, __ZN18BaseUnityAnalytics7ReleaseEv: __ZN18BaseUnityAnalytics7ReleaseEv, __Z18Transfer_BlittableI14SafeBinaryReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z37Camera_Get_Custom_PropStereoActiveEyeP12Il2CppObject: __Z37Camera_Get_Custom_PropStereoActiveEyeP12Il2CppObject, __ZN4FMOD7SystemI23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_: __ZN4FMOD7SystemI23get3DListenerAttributesEiP11FMOD_VECTORS2_S2_S2_, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_22PxTriangleMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_22PxTriangleMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE8ContainsEPKv, __ZNK13Lz4Compressor14CompressMemoryEPKvjPvPj16CompressionLevel: __ZNK13Lz4Compressor14CompressMemoryEPKvjPvPj16CompressionLevel, __ZNK9ShaderLab7Program29BeginWriteUnsupportedVariantsEv: __ZNK9ShaderLab7Program29BeginWriteUnsupportedVariantsEv, __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE: __ZNK5physx3Cct17CapsuleController10getCapsuleERNS_17PxExtendedCapsuleE, __ZN8Material23GetStencilWriteMaterialEv: __ZN8Material23GetStencilWriteMaterialEv, __ZN12_GLOBAL__N_121PrismaticJointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_121PrismaticJointProjectEPKvRN5physx11PxTransformES4_b, __Z47Register_UnityEngine_AnimationState_set_enabledv: __Z47Register_UnityEngine_AnimationState_set_enabledv, __ZN10AudioMixer25FindGroupsWithPartialPathEPKcR13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EE: __ZN10AudioMixer25FindGroupsWithPartialPathEPKcR13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EE, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYv, __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi: __ZN9Scripting24RaiseSystemExceptionImplEPKcS1_Pi, __ZN11LightProbes17SetLightProbeDataERKNS_14LightProbeDataE: __ZN11LightProbes17SetLightProbeDataERKNS_14LightProbeDataE, _UNITY_png_write_chunk_start: _UNITY_png_write_chunk_start, __Z39Application_Get_Custom_PropUnityVersionv: __Z39Application_Get_Custom_PropUnityVersionv, __ZN15CapsuleCollider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15CapsuleCollider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx15PxVehicleWheels19computeForwardSpeedEv: __ZNK5physx15PxVehicleWheels19computeForwardSpeedEv, __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize3v: __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize3v, __ZN10TagManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10TagManager8TransferI24GenerateTypeTreeTransferEEvRT_, __Z24RegisterStrippedTypeInfoI13SpringJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI13SpringJoint2DEviPKcS2_, __Z30getPxParticleBase_MaxParticlesPKN5physx14PxParticleBaseE: __Z30getPxParticleBase_MaxParticlesPKN5physx14PxParticleBaseE, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEED0Ev, __ZN16Physics2DManager11LinecastAllERK8Vector2fS2_iffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager11LinecastAllERK8Vector2fS2_iffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE, __ZThn4_N12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE: __ZThn4_N12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z52Register_UnityEngine_Physics_GetIgnoreLayerCollisionv: __Z52Register_UnityEngine_Physics_GetIgnoreLayerCollisionv, __Z50Register_UnityEngine_BoxCollider_INTERNAL_get_sizev: __Z50Register_UnityEngine_BoxCollider_INTERNAL_get_sizev, __ZN5physx2Sn5ConvX11resetUnionsEv: __ZN5physx2Sn5ConvX11resetUnionsEv, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationXTilev: __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationXTilev, __ZN17AudioReverbFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17AudioReverbFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __Z27CullingGroup_CUSTOM_DisposeP12Il2CppObject: __Z27CullingGroup_CUSTOM_DisposeP12Il2CppObject, __ZL24InitializeModule_Physicsv: __ZL24InitializeModule_Physicsv, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEEC2Ej, __Z35AllocExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei: __Z35AllocExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei, __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI6ShaderENS0_9allocatorIS4_EEEEEvRT_j, __ZN10TagManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10TagManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx14preprocessRowsEPPNS_14Px1DConstraintES1_jRKNS_17PxcSolverBodyDataES5_RKNS_24PxConstraintInvMassScaleEbb: __ZN5physx14preprocessRowsEPPNS_14Px1DConstraintES1_jRKNS_17PxcSolverBodyDataES5_RKNS_24PxConstraintInvMassScaleEbb, __Z49Register_UnityEngine_DistanceJoint2D_set_distancev: __Z49Register_UnityEngine_DistanceJoint2D_set_distancev, __ZN11AudioSource22SetIgnoreListenerPauseEb: __ZN11AudioSource22SetIgnoreListenerPauseEb, __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_, __ZNKSt3__211__libcpp_db22__less_than_comparableEPKvS2_: __ZNKSt3__211__libcpp_db22__less_than_comparableEPKvS2_, __ZL23stbir__filter_trapezoidff: __ZL23stbir__filter_trapezoidff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj: __ZN5physx14PxVehicleDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataEjj, __ZN20NavMeshBuildSettingsC2Ev: __ZN20NavMeshBuildSettingsC2Ev, __ZNK13AudioListener26GetTypeInfoVirtualInternalEv: __ZNK13AudioListener26GetTypeInfoVirtualInternalEv, __ZN14PhysicsManager21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE: __ZN14PhysicsManager21OverlapBoxUserCollectERK8Vector3fS2_RK11Quaternionfi23QueryTriggerInteractionRN8IPhysics12IUserCollectE, __ZN14ParticleSystem20GetParticlesExternalEP22ParticleSystemParticlei: __ZN14ParticleSystem20GetParticlesExternalEP22ParticleSystemParticlei, __Z27GetComponentsInChildrenImplILb1EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE: __Z27GetComponentsInChildrenImplILb1EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE, __ZNK6Camera31GetStereoSkyboxProjectionMatrixE15StereoscopicEyefR10Matrix4x4f: __ZNK6Camera31GetStereoSkyboxProjectionMatrixE15StereoscopicEyefR10Matrix4x4f, __ZN14SafeBinaryRead8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags, __Z37Register_UnityEngine_Material_SetPassv: __Z37Register_UnityEngine_Material_SetPassv, __ZN5physx25PxVehicleConstraintShader21VehicleConstraintDataaSERKS1_: __ZN5physx25PxVehicleConstraintShader21VehicleConstraintDataaSERKS1_, __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z40setPxHeightFieldGeometryHeightFieldFlagsPN5physx21PxHeightFieldGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE: __Z40setPxHeightFieldGeometryHeightFieldFlagsPN5physx21PxHeightFieldGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE, __ZN11UnityEngine15CloudWebService19SessionEventManager18HandleTimerExpiredEv: __ZN11UnityEngine15CloudWebService19SessionEventManager18HandleTimerExpiredEv, __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_: __ZN13dynamic_arrayI16HeightMeshBVNodeLj4EEC2ERKS1_, __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh: __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE6resizeEjRKh, __Z26Profiler_CUSTOM_GetSamplerP12Il2CppString: __Z26Profiler_CUSTOM_GetSamplerP12Il2CppString, _cimag: _cimag, __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD0Ev: __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD0Ev, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZNK5Umbra6Portal4getZERKNS_7Vector3ES3_: __ZNK5Umbra6Portal4getZERKNS_7Vector3ES3_, __Z18Transfer_BlittableI14SafeBinaryReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager31GetSortingLayerUniqueIDFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __ZN16LevelGameManagerD0Ev: __ZN16LevelGameManagerD0Ev, __ZN14PhysicsManager23GetDefaultContactOffsetEv: __ZN14PhysicsManager23GetDefaultContactOffsetEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj43ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj43ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E30advance_past_empty_and_deletedEv, __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb: __ZN5physx14NpShapeManager11detachShapeERNS_7NpShapeERNS_12PxRigidActorEb, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZNK5physx2Sc15ClothFabricCore20getNbParticleIndicesEv: __ZNK5physx2Sc15ClothFabricCore20getNbParticleIndicesEv, __ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE: __ZNK10GameObject25QueryComponentByExactTypeEPKN5Unity4TypeE, __ZNK9ShaderLab22ShaderStencilStateDesc17ToGfxStencilStateEPK19ShaderPropertySheetS3_RK14GfxRasterStateR15GfxStencilState: __ZNK9ShaderLab22ShaderStencilStateDesc17ToGfxStencilStateEPK19ShaderPropertySheetS3_RK14GfxRasterStateR15GfxStencilState, __Z41Register_UnityEngine_Renderer_set_enabledv: __Z41Register_UnityEngine_Renderer_set_enabledv, _tt_cmap0_char_next: _tt_cmap0_char_next, __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetRowIndexv: __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetRowIndexv, __Z15DecodeBC6HBlockP9HDRColorAPKh: __Z15DecodeBC6HBlockP9HDRColorAPKh, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN23iPhoneLocalNotificationD2Ev: __ZN23iPhoneLocalNotificationD2Ev, _msync: _msync, __Z48Register_UnityEngine_RenderTexture_set_isCubemapv: __Z48Register_UnityEngine_RenderTexture_set_isCubemapv, __Z13RegisterClassI10GUIElementEvv: __Z13RegisterClassI10GUIElementEvv, __Z55Register_UnityEngine_PointEffector2D_get_forceMagnitudev: __Z55Register_UnityEngine_PointEffector2D_get_forceMagnitudev, __Z17NpGetPxConstraintRKN5physx2Sc14ConstraintCoreE: __Z17NpGetPxConstraintRKN5physx2Sc14ConstraintCoreE, __ZN14PhysicsManager15ThreadedCleanupEv: __ZN14PhysicsManager15ThreadedCleanupEv, __ZN5Umbra15BufferAllocator12expandBufferERNS_17BlockRasterBufferERKNS_8Vector4iEb: __ZN5Umbra15BufferAllocator12expandBufferERNS_17BlockRasterBufferERKNS_8Vector4iEb, __Z56Register_UnityEngine_Rigidbody_INTERNAL_set_centerOfMassv: __Z56Register_UnityEngine_Rigidbody_INTERNAL_set_centerOfMassv, __Z35Material_Set_Custom_PropRenderQueueP12Il2CppObjecti: __Z35Material_Set_Custom_PropRenderQueueP12Il2CppObjecti, _lchown: _lchown, __Z54Register_UnityEngine_AudioSource_GetSpectrumDataHelperv: __Z54Register_UnityEngine_AudioSource_GetSpectrumDataHelperv, __ZN20ArchiveStorageHeader13IsArchiveFileER12FileAccessor: __ZN20ArchiveStorageHeader13IsArchiveFileER12FileAccessor, _cf2_buf_readByte: _cf2_buf_readByte, __Z47NavMesh_CUSTOM_GetPathfindingIterationsPerFramev: __Z47NavMesh_CUSTOM_GetPathfindingIterationsPerFramev, __ZN5physx16applyConstraintsERKNS_6PxVec3ERS0_S2_RPKNS_11PxsBodyCoreES3_S3_PKNS_18PxsFluidConstraintESA_S6_S6_S2_S2_jRKNS_27PxsFluidCollisionParametersERKNS_16PxvParticleFlagsE: __ZN5physx16applyConstraintsERKNS_6PxVec3ERS0_S2_RPKNS_11PxsBodyCoreES3_S3_PKNS_18PxsFluidConstraintESA_S6_S6_S2_S2_jRKNS_27PxsFluidCollisionParametersERKNS_16PxvParticleFlagsE, __ZN15LODGroupManagerD2Ev: __ZN15LODGroupManagerD2Ev, __ZN5physx15PxVehicleWheelsD0Ev: __ZN5physx15PxVehicleWheelsD0Ev, __ZNK5physx2Cm10FanoutTask12getReferenceEv: __ZNK5physx2Cm10FanoutTask12getReferenceEv, _UNITY_png_muldiv_warn: _UNITY_png_muldiv_warn, _wcsspn: _wcsspn, __ZN6AvatarD0Ev: __ZN6AvatarD0Ev, __ZN9LensFlare12SetFadeSpeedEf: __ZN9LensFlare12SetFadeSpeedEf, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSolverFrequencyEv, __ZN14VRSplashScreenC2Ebf10ColorRGBAfif8Vector3f: __ZN14VRSplashScreenC2Ebf10ColorRGBAfif8Vector3f, __ZN12IFileAdapter9SetLengthER13FileEntryDatay: __ZN12IFileAdapter9SetLengthER13FileEntryDatay, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z39LineRenderer_Get_Custom_PropTextureModeP12Il2CppObject: __Z39LineRenderer_Get_Custom_PropTextureModeP12Il2CppObject, _cff_cmap_encoding_init: _cff_cmap_encoding_init, __ZN5Umbra20SingleBlockAllocator8allocateEjPKc: __ZN5Umbra20SingleBlockAllocator8allocateEjPKc, __ZN14EdgeCollider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN14EdgeCollider2D23VirtualRedirectTransferER14SafeBinaryRead, __Z34GetUnityWebRequestScriptingClassesv: __Z34GetUnityWebRequestScriptingClassesv, __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE: __ZNK5physx2Sq17SceneQueryManager10getPayloadEPKNS0_10ActorShapeE, __ZNK6Camera25CalculateFarCullDistancesEPff: __ZNK6Camera25CalculateFarCullDistancesEPff, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIllEEPlEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIllEEPlEEbT0_S5_T_, __ZNK5physx2Gu5Facet15getClosestPointEPKNS_6shdfnd3aos5Vec3VES6_RS4_S7_: __ZNK5physx2Gu5Facet15getClosestPointEPKNS_6shdfnd3aos5Vec3VES6_RS4_S7_, __ZN5physx2Sn21SerializationRegistryD0Ev: __ZN5physx2Sn21SerializationRegistryD0Ev, __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN19RuntimeSceneManager24PrepareNewBootstrapSceneEv: __ZN19RuntimeSceneManager24PrepareNewBootstrapSceneEv, __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIjNS0_4LessIjEENS0_19ReflectionAllocatorIjEEEEvPT_jRKT0_RKT1_j, __ZNK5Umbra14TomeCollection16getObjectUserIDsEiPji: __ZNK5Umbra14TomeCollection16getObjectUserIDsEiPji, __ZN2UI11CanvasGroup17RemoveFromManagerEv: __ZN2UI11CanvasGroup17RemoveFromManagerEv, __ZN10SpookyHash7Hash128EPKvjPyS2_: __ZN10SpookyHash7Hash128EPKvjPyS2_, __ZThn8_N5physx3Cct13BoxControllerD1Ev: __ZThn8_N5physx3Cct13BoxControllerD1Ev, __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZL14MakeNiceFloat3RKN4math7_float3E: __ZL14MakeNiceFloat3RKN4math7_float3E, __ZN18ScriptingArguments27CheckArgumentsAgainstMethodE21ScriptingMethodIl2Cpp: __ZN18ScriptingArguments27CheckArgumentsAgainstMethodE21ScriptingMethodIl2Cpp, __Z40AudioSource_Get_Custom_PropReverbZoneMixP12Il2CppObject: __Z40AudioSource_Get_Custom_PropReverbZoneMixP12Il2CppObject, __ZN8WindZone7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8WindZone7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __Z38Register_UnityEngine_CullingGroup_Initv: __Z38Register_UnityEngine_CullingGroup_Initv, __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPKNS_6PxBaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb0EE6GetKeyES9_Lb0EE15reserveInternalEj, __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerWeightInternalv: __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerWeightInternalv, __ZN9Heightmap8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Heightmap8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj189ENS_22PxRepXPropertyAccessorILj189ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj189ENS_22PxRepXPropertyAccessorILj189ES4_ffEEEEvRKT0_, __ZN9ShaderLab18SerializedPropertyC2ERKS0_: __ZN9ShaderLab18SerializedPropertyC2ERKS0_, __Z38NavMeshAgent_Set_Custom_PropAutoRepathP12Il2CppObjecth: __Z38NavMeshAgent_Set_Custom_PropAutoRepathP12Il2CppObjecth, _cff_driver_init: _cff_driver_init, __ZN5physx9NpFactory13addConstraintEPNS_12PxConstraintEb: __ZN5physx9NpFactory13addConstraintEPNS_12PxConstraintEb, __ZNK5physx7NpShape25getScRigidObjectExclusiveEv: __ZNK5physx7NpShape25getScRigidObjectExclusiveEv, __ZThn28_N14PhysicsManager6onWakeEPPN5physx7PxActorEj: __ZThn28_N14PhysicsManager6onWakeEPPN5physx7PxActorEj, __ZN17ProceduralTexture17TextureParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17ProceduralTexture17TextureParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SpriteRenderer10SmartResetEv: __ZN14SpriteRenderer10SmartResetEv, __Z56Register_UnityEngine_ReflectionProbe_set_timeSlicingModev: __Z56Register_UnityEngine_ReflectionProbe_set_timeSlicingModev, __Z54getPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE: __Z54getPxVehicleWheelsSimData_HighForwardSpeedSubStepCountPKN5physx22PxVehicleWheelsSimDataE, __Z42getNbPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataE: __Z42getNbPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataE, __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii: __ZN17AnimationPlayable23ConnectNoTopologyChangeEPS_S0_ii, __ZN16ReflectionProbes20DidChangeActiveSceneEP10UnitySceneS1_: __ZN16ReflectionProbes20DidChangeActiveSceneEP10UnitySceneS1_, __ZN17GeneralConnection10InitializeEv: __ZN17GeneralConnection10InitializeEv, __ZN15MonoScriptCacheD2Ev: __ZN15MonoScriptCacheD2Ev, __ZN18UnityConnectClientC2Ev: __ZN18UnityConnectClientC2Ev, __ZN8JSONRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlagsb, __Z34RenderTexture_Set_Custom_PropDepthP12Il2CppObjecti: __Z34RenderTexture_Set_Custom_PropDepthP12Il2CppObjecti, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj5ENS_22PxRepXPropertyAccessorILj5ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj5ENS_22PxRepXPropertyAccessorILj5ES4_ffEEEEvRKT0_, __ZNK29LineParametersPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK29LineParametersPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN5Unity11SpringJointD0Ev: __ZN5Unity11SpringJointD0Ev, __Z40setPxArticulationJoint_TargetOrientationPN5physx19PxArticulationJointERKNS_6PxQuatE: __Z40setPxArticulationJoint_TargetOrientationPN5physx19PxArticulationJointERKNS_6PxQuatE, __ZNKSt3__220__time_get_c_storageIcE3__xEv: __ZNKSt3__220__time_get_c_storageIcE3__xEv, _UNITY_ft_base_pic_free: _UNITY_ft_base_pic_free, __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7mecanim8skeleton8Skeleton8TransferI8BlobSizeEEvRT_: __ZN7mecanim8skeleton8Skeleton8TransferI8BlobSizeEEvRT_, __Z50Register_UnityEngine_RenderTexture_DiscardContentsv: __Z50Register_UnityEngine_RenderTexture_DiscardContentsv, __ZL33InitializeModule_CloudWebServicesv: __ZL33InitializeModule_CloudWebServicesv, __ZNK4Mesh18ExtractNormalArrayEP8Vector3f: __ZNK4Mesh18ExtractNormalArrayEP8Vector3f, __ZN15NavMeshObstacle12CleanupClassEv: __ZN15NavMeshObstacle12CleanupClassEv, __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj: __ZN5physx6shdfnd5ArrayIjNS_7profile26WrapperReflectionAllocatorIjEEE15growAndPushBackERKj, _access_virt_barray: _access_virt_barray, __ZN5physx18solveFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx18solveFrictionBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, _unity_z_compress: _unity_z_compress, __Z51Register_UnityEngine_ParticleSystem_set_playOnAwakev: __Z51Register_UnityEngine_ParticleSystem_set_playOnAwakev, __ZN12InputManager15ConfigureButtonEPi: __ZN12InputManager15ConfigureButtonEPi, _isprint: _isprint, __Z64Register_UnityEngine_LightProbeProxyVolume_get_probePositionModev: __Z64Register_UnityEngine_LightProbeProxyVolume_get_probePositionModev, __ZN4crnd12crnd_reallocEPvjPjb: __ZN4crnd12crnd_reallocEPvjPjb, __Z41Register_UnityEngine_LODGroup_get_enabledv: __Z41Register_UnityEngine_LODGroup_get_enabledv, __Z48Input_Set_Custom_PropEatKeyPressOnTextFieldFocush: __Z48Input_Set_Custom_PropEatKeyPressOnTextFieldFocush, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN20LocalFileSystemPosix4CopyER13FileEntryDataS1_: __ZN20LocalFileSystemPosix4CopyER13FileEntryDataS1_, _UNITY_png_set_write_status_fn: _UNITY_png_set_write_status_fn, __ZL31SetRenderStateForStencilMarkingR9GfxDeviceR17ShaderPassContextjj: __ZL31SetRenderStateForStencilMarkingR9GfxDeviceR17ShaderPassContextjj, __ZN20ArchiveStorageReader20FillChunkCachedBlockEPNS_11CachedBlockE: __ZN20ArchiveStorageReader20FillChunkCachedBlockEPNS_11CachedBlockE, __Z38Register_UnityEngine_Mathf_PerlinNoisev: __Z38Register_UnityEngine_Mathf_PerlinNoisev, __ZN11TrailModule5ResetEv: __ZN11TrailModule5ResetEv, __ZltRK8DateTimeS1_: __ZltRK8DateTimeS1_, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISB_PvEE, __ZN10AudioMixer16ResumeProcessingEv: __ZN10AudioMixer16ResumeProcessingEv, __Z29StdTemplateConversionFunctionIjjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjjEbPvR14SafeBinaryRead, __Z25Animator_CUSTOM_SetBoolIDP12Il2CppObjectih: __Z25Animator_CUSTOM_SetBoolIDP12Il2CppObjectih, __ZN5physx38PxVehicleDriveSimDataNWGeneratedValuesC2EPKNS_23PxVehicleDriveSimDataNWE: __ZN5physx38PxVehicleDriveSimDataNWGeneratedValuesC2EPKNS_23PxVehicleDriveSimDataNWE, __ZNK19TouchPhaseEmulation17CalculateTapCountExRK8Vector2f: __ZNK19TouchPhaseEmulation17CalculateTapCountExRK8Vector2f, ___expo2: ___expo2, __ZN5physx2Sc8ClothSim20removeCollisionShapeEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim20removeCollisionShapeEPKNS0_8ShapeSimE, __Z24RegisterStrippedTypeInfoIN2UI13RectTransformEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN2UI13RectTransformEEviPKcS3_, __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj: __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __ZN22UnityProfilerPerThread18SampleGCAllocationEP12Il2CppObjectP11Il2CppClass: __ZN22UnityProfilerPerThread18SampleGCAllocationEP12Il2CppObjectP11Il2CppClass, __Z59Register_UnityEngine_ParticleSystem_LightsModule_GetEnabledv: __Z59Register_UnityEngine_ParticleSystem_LightsModule_GetEnabledv, __Z45Register_UnityEngine_AudioListener_set_volumev: __Z45Register_UnityEngine_AudioListener_set_volumev, __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj: __ZNSt3__216__check_groupingERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjS8_Rj, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwPKv, __ZN6MotionD0Ev: __ZN6MotionD0Ev, __ZN2UI13CanvasManager21EmitGeometryForCameraEP6Camera: __ZN2UI13CanvasManager21EmitGeometryForCameraEP6Camera, __Z24Resources_CUSTOM_LoadAllP12Il2CppStringP12Il2CppObject: __Z24Resources_CUSTOM_LoadAllP12Il2CppStringP12Il2CppObject, __ZN5Umbra10QueryState23findTomeByClusterPortalEi: __ZN5Umbra10QueryState23findTomeByClusterPortalEi, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __Z42ParticleSystemRenderer_Set_Custom_PropMeshP12Il2CppObjectS0_: __Z42ParticleSystemRenderer_Set_Custom_PropMeshP12Il2CppObjectS0_, __ZN12_GLOBAL__N_110DataStream19bufferPropertyValueEN5physx8debugger24ClassDescriptionSizeInfoENS2_7DataRefIKhEE: __ZN12_GLOBAL__N_110DataStream19bufferPropertyValueEN5physx8debugger24ClassDescriptionSizeInfoENS2_7DataRefIKhEE, __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab16SerializedTagMap8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx11NpAggregate15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx11NpAggregate15exportExtraDataERNS_22PxSerializationContextE, __ZN4FMOD12ChannelGroup11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD12ChannelGroup11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __ZN7mecanim5human30HumanPoseAdjustForMissingBonesEPKNS0_5HumanEPNS0_9HumanPoseE: __ZN7mecanim5human30HumanPoseAdjustForMissingBonesEPKNS0_5HumanEPNS0_9HumanPoseE, __ZN16PxOverflowBufferIN5physx10PxSweepHitEE14processTouchesEPKS1_j: __ZN16PxOverflowBufferIN5physx10PxSweepHitEE14processTouchesEPKS1_j, __Z42Physics2D_CUSTOM_INTERNAL_CALL_LinecastAllRK13Vector2fIcallS1_iff: __Z42Physics2D_CUSTOM_INTERNAL_CALL_LinecastAllRK13Vector2fIcallS1_iff, __Z55Register_UnityEngine_AnimationState_set_normalizedSpeedv: __Z55Register_UnityEngine_AnimationState_set_normalizedSpeedv, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale1Ev, __Z20IsSubstanceSupportedv: __Z20IsSubstanceSupportedv, __ZN5physx3Cct9SweepTest13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Cct9SweepTest13onOriginShiftERKNS_6PxVec3E, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__set_long_capEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__set_long_capEj, __Z55Register_UnityEngine_SkinnedMeshRenderer_get_sharedMeshv: __Z55Register_UnityEngine_SkinnedMeshRenderer_get_sharedMeshv, __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIiP14DataBufferGLESEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN5physx8debugger14PvdMarshallingIhiE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhiE12marshalBlockEPKhPhj, __Z22CullDirectionalShadowsR9IndexListPK9SceneNodePK4AABBR22DirectionalCullContext: __Z22CullDirectionalShadowsR9IndexListPK9SceneNodePK4AABBR22DirectionalCullContext, __ZN10MeshFilter19GetInstantiatedMeshEv: __ZN10MeshFilter19GetInstantiatedMeshEv, __Z44Register_UnityEngine_Camera_RenderWithShaderv: __Z44Register_UnityEngine_Camera_RenderWithShaderv, __Z43RenderSettings_CUSTOM_INTERNAL_set_fogColorRK10ColorRGBAf: __Z43RenderSettings_CUSTOM_INTERNAL_set_fogColorRK10ColorRGBAf, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv, __ZN5physx18PxsMaterialManager6resizeEj: __ZN5physx18PxsMaterialManager6resizeEj, __Z55Register_UnityEngine_BuoyancyEffector2D_set_angularDragv: __Z55Register_UnityEngine_BuoyancyEffector2D_set_angularDragv, __Z46TrailRenderer_Set_Custom_PropMinVertexDistanceP12Il2CppObjectf: __Z46TrailRenderer_Set_Custom_PropMinVertexDistanceP12Il2CppObjectf, __Z16CarveNavMeshTilePPhPiPKhijPK16NavMeshCarveDatafff: __Z16CarveNavMeshTilePPhPiPKhijPK16NavMeshCarveDatafff, __ZN14OcclusionScene8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14OcclusionScene8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9LensFlare13AwakeFromLoadE17AwakeFromLoadMode: __ZN9LensFlare13AwakeFromLoadE17AwakeFromLoadMode, __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN9GfxDevice16BeginBufferWriteEP9GfxBufferjj: __ZN9GfxDevice16BeginBufferWriteEP9GfxBufferjj, __ZN5physx3Ext20ProfileZoneInterface16handleEventAddedERKNS_18PxProfileEventNameE: __ZN5physx3Ext20ProfileZoneInterface16handleEventAddedERKNS_18PxProfileEventNameE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z37TrailRenderer_Get_Custom_PropEndWidthP12Il2CppObject: __Z37TrailRenderer_Get_Custom_PropEndWidthP12Il2CppObject, _gray_raster_new: _gray_raster_new, __Z24RegisterStrippedTypeInfoI4MeshEviPKcS2_: __Z24RegisterStrippedTypeInfoI4MeshEviPKcS2_, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15switchFromNoSimEv: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15switchFromNoSimEv, __Z38AssetBundle_CUSTOM_LoadFromMemoryAsyncP11Il2CppArrayj: __Z38AssetBundle_CUSTOM_LoadFromMemoryAsyncP11Il2CppArrayj, __Z48Register_UnityEngine_Application_get_isWebPlayerv: __Z48Register_UnityEngine_Application_get_isWebPlayerv, __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__213__vector_baseIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev, __ZN19ScriptingInvocation5CheckEv: __ZN19ScriptingInvocation5CheckEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_, __Z51Register_UnityEngine_AnimationCurve_get_preWrapModev: __Z51Register_UnityEngine_AnimationCurve_get_preWrapModev, __ZN29UnityWebRequestAsyncOperation6IsDoneEv: __ZN29UnityWebRequestAsyncOperation6IsDoneEv, __Z59Register_UnityEngine_Quaternion_INTERNAL_CALL_LerpUnclampedv: __Z59Register_UnityEngine_Quaternion_INTERNAL_CALL_LerpUnclampedv, __Z41CanvasGroup_Set_Custom_PropBlocksRaycastsP12Il2CppObjecth: __Z41CanvasGroup_Set_Custom_PropBlocksRaycastsP12Il2CppObjecth, __ZN13MonoBehaviour26WillUnloadScriptableObjectEv: __ZN13MonoBehaviour26WillUnloadScriptableObjectEv, __ZN12InputManager15ThreadedCleanupEv: __ZN12InputManager15ThreadedCleanupEv, __Z13VFormatBufferPciPKcPi: __Z13VFormatBufferPciPKcPi, __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z57Register_UnityEngine_ParticleSystem_set_useAutoRandomSeedv: __Z57Register_UnityEngine_ParticleSystem_set_useAutoRandomSeedv, __ZN10builtintex22GetDitherMaskTexture2DEv: __ZN10builtintex22GetDitherMaskTexture2DEv, __ZN12_GLOBAL__N_115StringTableImpl9getNbStrsEv: __ZN12_GLOBAL__N_115StringTableImpl9getNbStrsEv, __ZN18PlayableController12PrepareFrameEP8PlayableRy: __ZN18PlayableController12PrepareFrameEP8PlayableRy, __ZN14DetailDatabase19SetDetailPrototypesERKNSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEE: __ZN14DetailDatabase19SetDetailPrototypesERKNSt3__26vectorI15DetailPrototypeNS0_9allocatorIS2_EEEE, __ZN14AreaEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14AreaEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN11ClothModule23SetClothingSceneGravityERK8Vector3f: __ZN11ClothModule23SetClothingSceneGravityERK8Vector3f, __Z52Register_UnityEngine_CullingGroup_SetBoundingSpheresv: __Z52Register_UnityEngine_CullingGroup_SetBoundingSpheresv, __ZN4PPtrI16SubstanceArchiveE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI16SubstanceArchiveE8TransferI14SafeBinaryReadEEvRT_, __Z16CopyActiveLightsRK12ActiveLightsRS_: __Z16CopyActiveLightsRK12ActiveLightsRS_, _reset_error_mgr: _reset_error_mgr, __ZN17Physics2DSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17Physics2DSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15TerrainCollider17MainThreadCleanupEv: __ZN15TerrainCollider17MainThreadCleanupEv, __ZN4FMOD4DSPI12getParameterEiPfPci: __ZN4FMOD4DSPI12getParameterEiPfPci, __ZN13AnimationClip13AddFloatCurveERK17AnimationCurveTplIfERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEEiSC_: __ZN13AnimationClip13AddFloatCurveERK17AnimationCurveTplIfERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEEiSC_, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getMaxParticlesEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getMaxParticlesEv, __Z63Register_UnityEngine_ParticleSystemRenderer_set_normalDirectionv: __Z63Register_UnityEngine_ParticleSystemRenderer_set_normalDirectionv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIfLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN5physx8debugger4comm8SetColor9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm8SetColor9serializeERNS1_15EventSerializerE, __ZN16LightmapSettingsD0Ev: __ZN16LightmapSettingsD0Ev, __ZN19CharacterController23CreateControllerManagerEv: __ZN19CharacterController23CreateControllerManagerEv, __ZNK9ShaderLab11ShaderState34ShouldRemoveAnyUnsupportedProgramsEv: __ZNK9ShaderLab11ShaderState34ShouldRemoveAnyUnsupportedProgramsEv, __ZN5physx3Cct15ObstacleContext11addObstacleERKNS_10PxObstacleE: __ZN5physx3Cct15ObstacleContext11addObstacleERKNS_10PxObstacleE, __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_Ei: __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_Ei, __Z54Register_UnityEngine_AI_OffMeshLink_set_startTransformv: __Z54Register_UnityEngine_AI_OffMeshLink_set_startTransformv, __Z42Register_UnityEngine_Caching_get_spaceFreev: __Z42Register_UnityEngine_Caching_get_spaceFreev, __Z64Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderv: __Z64Register_UnityEngine_ParticleCollisionEvent_InstanceIDToColliderv, _UNITY_tt_face_load_cvt: _UNITY_tt_face_load_cvt, __ZN5physx12PxSerializerD2Ev: __ZN5physx12PxSerializerD2Ev, __ZN9Heightmap10SetHeightsEiiiiPKfb: __ZN9Heightmap10SetHeightsEiiiiPKfb, __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE: __ZNK5physx7NpActor15getNbConnectorsENS_15NpConnectorType4EnumE, __ZN14AssetReferenceC2E4PPtrI6ObjectE: __ZN14AssetReferenceC2E4PPtrI6ObjectE, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getRelativeTransformEv, __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev: __ZThn8_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE, __Z44Register_UnityEngine_Material_SetOverrideTagv: __Z44Register_UnityEngine_Material_SetOverrideTagv, __Z42ParticleEmitter_Set_Custom_PropMinEmissionP12Il2CppObjectf: __Z42ParticleEmitter_Set_Custom_PropMinEmissionP12Il2CppObjectf, __ZN20ArchiveStorageReaderD0Ev: __ZN20ArchiveStorageReaderD0Ev, __Z33GetAllowComponentReplacementClassi: __Z33GetAllowComponentReplacementClassi, __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE18__construct_at_endEj: __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE18__construct_at_endEj, _jpeg_write_m_byte: _jpeg_write_m_byte, __ZNK9DebugGLES19FramebufferBindingsEv: __ZNK9DebugGLES19FramebufferBindingsEv, __ZN13SplatDatabase29SetMaterialRequiresSmoothnessEb: __ZN13SplatDatabase29SetMaterialRequiresSmoothnessEb, __ZN15TerrainColliderD0Ev: __ZN15TerrainColliderD0Ev, __ZN5Umbra9Matrix2x25identEv: __ZN5Umbra9Matrix2x25identEv, __Z41setPxArticulation_ExternalDriveIterationsPN5physx14PxArticulationEj: __Z41setPxArticulation_ExternalDriveIterationsPN5physx14PxArticulationEj, __ZN19TransportJavaScript7PrepareEv: __ZN19TransportJavaScript7PrepareEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_, __Z43ParticleSystem_ShapeModule_CUSTOM_GetLengthP12Il2CppObject: __Z43ParticleSystem_ShapeModule_CUSTOM_GetLengthP12Il2CppObject, __ZN5physx20PxClothMeshQuadifierC2ERKNS_15PxClothMeshDescE: __ZN5physx20PxClothMeshQuadifierC2ERKNS_15PxClothMeshDescE, __ZN23ShaderVariantCollection23VirtualRedirectTransferER14SafeBinaryRead: __ZN23ShaderVariantCollection23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev: __ZNSt3__214__split_bufferI9InputAxisRNS_9allocatorIS1_EEED2Ev, __ZNSt3__217__call_once_proxyINS_5tupleIJONS_12_GLOBAL__N_111__fake_bindEEEEEEvPv: __ZNSt3__217__call_once_proxyINS_5tupleIJONS_12_GLOBAL__N_111__fake_bindEEEEEEvPv, __ZNK20LocalFileSystemPosix20GetApplicationFolderEv: __ZNK20LocalFileSystemPosix20GetApplicationFolderEv, __ZN5physx7profile30PxProfileMemoryEventBufferImplD2Ev: __ZN5physx7profile30PxProfileMemoryEventBufferImplD2Ev, __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher31SetupSessionContainerToDispatchEv, __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f: __ZN5physx2Gu29intersectRayTriangleNoCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f, __ZN5physx2Sc19ShapeInstancePairLL10initializeEv: __ZN5physx2Sc19ShapeInstancePairLL10initializeEv, __Z68Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSinglev: __Z68Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSinglev, __ZN19ShaderPropertySheet20ReservePropertyCountEj: __ZN19ShaderPropertySheet20ReservePropertyCountEj, __Z42RenderSettings_Set_Custom_PropHaloStrengthf: __Z42RenderSettings_Set_Custom_PropHaloStrengthf, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z31LODGroup_Set_Custom_PropEnabledP12Il2CppObjecth: __Z31LODGroup_Set_Custom_PropEnabledP12Il2CppObjecth, __Z38AndroidJNI_CUSTOM_GetStaticDoubleField13Il2Cpp_IntPtrS_: __Z38AndroidJNI_CUSTOM_GetStaticDoubleField13Il2Cpp_IntPtrS_, __ZN5physx25PxClothSimpleTetherCookerC2ERKNS_15PxClothMeshDescE: __ZN5physx25PxClothSimpleTetherCookerC2ERKNS_15PxClothMeshDescE, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE5CheckEv: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE5CheckEv, __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode: __ZN15TerrainRenderer21EnforceLodTransitionsER12QuadTreeNode, __ZN5physx3Cct26CharacterControllerManager13getControllerEj: __ZN5physx3Cct26CharacterControllerManager13getControllerEj, __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPj: __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPj, __ZNKSt3__25ctypeIcE10do_tolowerEPcPKc: __ZNKSt3__25ctypeIcE10do_tolowerEPcPKc, __ZN25RuntimeAnimatorController22RegisterAnimationClipsEv: __ZN25RuntimeAnimatorController22RegisterAnimationClipsEv, __ZN11NavMeshDataD0Ev: __ZN11NavMeshDataD0Ev, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16SetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEESC_: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16SetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEESC_, __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE: __ZN4FMOD12ChannelGroup10getDSPHeadEPPNS_3DSPE, __Z20FromInternalInfinityi: __Z20FromInternalInfinityi, __ZN10Collider2D9SetOffsetERK8Vector2f: __ZN10Collider2D9SetOffsetERK8Vector2f, __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNK6Camera18ScreenToWorldPointERK8Vector3f: __ZNK6Camera18ScreenToWorldPointERK8Vector3f, __Z65Register_UnityEngine_SkinnedMeshRenderer_get_skinnedMotionVectorsv: __Z65Register_UnityEngine_SkinnedMeshRenderer_get_skinnedMotionVectorsv, __ZN5physx2Sc5Scene6solverEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene6solverEPNS_10PxBaseTaskE, __ZN17ArchiveFileSystemD0Ev: __ZN17ArchiveFileSystemD0Ev, __ZN5physx2Sc21ElementSimInteractionD2Ev: __ZN5physx2Sc21ElementSimInteractionD2Ev, __Z27DestroyAllowNameConversionsP20AllowNameConversions: __Z27DestroyAllowNameConversionsP20AllowNameConversions, __ZNK5Unity10HingeJoint13CanWriteMotorEv: __ZNK5Unity10HingeJoint13CanWriteMotorEv, __ZN16CircleCollider2DC2E10MemLabelId18ObjectCreationMode: __ZN16CircleCollider2DC2E10MemLabelId18ObjectCreationMode, __ZN17RenderLoopContextD2Ev: __ZN17RenderLoopContextD2Ev, __Z41Register_UnityEngine_SortingLayer_IsValidv: __Z41Register_UnityEngine_SortingLayer_IsValidv, __ZN13MemoryManager10DeallocateEPv: __ZN13MemoryManager10DeallocateEPv, __ZN5physx20PxsParticleSystemSim22scheduleDynamicsUpdateERNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim22scheduleDynamicsUpdateERNS_10PxBaseTaskE, __Z19ComputeUniformScaleRK10Matrix4x4f: __Z19ComputeUniformScaleRK10Matrix4x4f, __ZN4FMOD6System20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_: __ZN4FMOD6System20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_, __ZN7ApiGLES11DeleteQueryERN2gl6HandleILNS0_10ObjectTypeE4EEE: __ZN7ApiGLES11DeleteQueryERN2gl6HandleILNS0_10ObjectTypeE4EEE, __ZN16GUIKeyboardState16SaveFromGUIStateER8GUIState: __ZN16GUIKeyboardState16SaveFromGUIStateER8GUIState, __ZN5physx15solveExt1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx15solveExt1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx5cloth11SwCollisionI8Scalar4fE23collideVirtualParticlesEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE23collideVirtualParticlesEv, __ZN5physx21PxVehicleDriveSimData13setClutchDataERKNS_19PxVehicleClutchDataE: __ZN5physx21PxVehicleDriveSimData13setClutchDataERKNS_19PxVehicleClutchDataE, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN4FMOD7SystemI7releaseEv: __ZN4FMOD7SystemI7releaseEv, __Z56ReflectionProbe_Get_Custom_PropMinBakedCubemapResolutionv: __Z56ReflectionProbe_Get_Custom_PropMinBakedCubemapResolutionv, __ZN9b2ContactD0Ev: __ZN9b2ContactD0Ev, __Z27GL_Set_Custom_PropWireframeh: __Z27GL_Set_Custom_PropWireframeh, __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj: __ZNK5physx14PxsAABBManager13promoteBitmapEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjjjj, __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_: __ZNSt3__27__sort3IRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEjT0_S7_S7_T_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZNK6Shader26GetTypeInfoVirtualInternalEv: __ZNK6Shader26GetTypeInfoVirtualInternalEv, __ZN5physx3Scb5Cloth9syncStateEv: __ZN5physx3Scb5Cloth9syncStateEv, __ZNKSt3__217moneypunct_bynameIwLb1EE16do_thousands_sepEv: __ZNKSt3__217moneypunct_bynameIwLb1EE16do_thousands_sepEv, __ZNK5physx3Ext7D6Joint16getDrivePositionEv: __ZNK5physx3Ext7D6Joint16getDrivePositionEv, __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalRotationiR11Quaternionf: __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalRotationiR11Quaternionf, __Z50Register_UnityEngine_VR_VRSettings_set_renderScalev: __Z50Register_UnityEngine_VR_VRSettings_set_renderScalev, __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrIN13TextRendering4FontEE8TransferI14SafeBinaryReadEEvRT_, __Z43Register_UnityEngine_Texture_get_anisoLevelv: __Z43Register_UnityEngine_Texture_get_anisoLevelv, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18getConstraintFlagsEv, __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14SafeBinaryRead8TransferIiEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIiEEvRT_PKc17TransferMetaFlags, __ZN5physx15NpActorTemplateINS_7PxClothEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_7PxClothEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __ZN13MonoBehaviourD0Ev: __ZN13MonoBehaviourD0Ev, __ZN2UI6Canvas18UpdateEventIndexesEv: __ZN2UI6Canvas18UpdateEventIndexesEv, __ZN5physx2Sn5ConvX6outputEy: __ZN5physx2Sn5ConvX6outputEy, _pipe: _pipe, __ZNK5Umbra6KDTree11getMaxDepthEv: __ZNK5Umbra6KDTree11getMaxDepthEv, __ZN9allocutil14BuddyAllocator4FreeENS_5ChunkE: __ZN9allocutil14BuddyAllocator4FreeENS_5ChunkE, __ZN5physx14NpRigidDynamic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx14NpRigidDynamic9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __Z50ParticleCollisionEvent_CUSTOM_InstanceIDToCollideri: __Z50ParticleCollisionEvent_CUSTOM_InstanceIDToCollideri, __ZNK12b2MotorJoint10GetAnchorBEv: __ZNK12b2MotorJoint10GetAnchorBEv, __Z50RectTransform_CUSTOM_INTERNAL_set_anchoredPositionP12Il2CppObjectRK13Vector2fIcall: __Z50RectTransform_CUSTOM_INTERNAL_set_anchoredPositionP12Il2CppObjectRK13Vector2fIcall, __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6resizeEj: __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6resizeEj, __ZN4FileC2Ev: __ZN4FileC2Ev, __ZN5Umbra18testAndSetBitRangeEPjii: __ZN5Umbra18testAndSetBitRangeEPjii, __Z63Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimev: __Z63Register_UnityEngine_ParticleSystem_MainModule_SetStartLifetimev, __ZdaPvRK10MemLabelIdiPKci: __ZdaPvRK10MemLabelIdiPKci, __ZN14BatchAllocator16AllocateInternalEPPvijjj: __ZN14BatchAllocator16AllocateInternalEPPvijjj, __ZN7VRInput27ResetAllReferenceTransformsEv: __ZN7VRInput27ResetAllReferenceTransformsEv, __ZN4FMOD6SoundI15StopAllChannelsEv: __ZN4FMOD6SoundI15StopAllChannelsEv, __ZNK15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E13find_positionERS3_: __ZNK15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E13find_positionERS3_, __Z13RegisterClassI6SpriteEvv: __Z13RegisterClassI6SpriteEvv, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNK5physx2Gu12TriangleMesh17getReferenceCountEv: __ZNK5physx2Gu12TriangleMesh17getReferenceCountEv, __ZN5physx20PxsParticleSystemSim24setExternalAccelerationVERKNS_6PxVec3E: __ZN5physx20PxsParticleSystemSim24setExternalAccelerationVERKNS_6PxVec3E, __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc: __ZN19ScriptingInvocationC2EP12Il2CppObjectPKc, __Z54Register_UnityEngine_RenderBufferHelper_SetStoreActionv: __Z54Register_UnityEngine_RenderBufferHelper_SetStoreActionv, __ZN12WheelJoint2DD0Ev: __ZN12WheelJoint2DD0Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead17GfxDeviceRendererEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead17GfxDeviceRendererEvRT_RT0_PKc17TransferMetaFlags, __Z57Register_UnityEngine_ConfigurableJoint_set_angularYMotionv: __Z57Register_UnityEngine_ConfigurableJoint_set_angularYMotionv, __ZNK13AudioListener19GetCurrentTransformEv: __ZNK13AudioListener19GetCurrentTransformEv, __Z46setPxVehicleWheelsSimData_SceneQueryFilterDataPN5physx22PxVehicleWheelsSimDataEjNS_12PxFilterDataE: __Z46setPxVehicleWheelsSimData_SceneQueryFilterDataPN5physx22PxVehicleWheelsSimDataEjNS_12PxFilterDataE, __ZNK5physx2Sc16ArticulationCore26getInternalDriveIterationsEv: __ZNK5physx2Sc16ArticulationCore26getInternalDriveIterationsEv, __ZN9Scripting22RaiseSecurityExceptionEPKcz: __ZN9Scripting22RaiseSecurityExceptionEPKcz, __ZNSt3__26locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __Z57Register_UnityEngine_MonoBehaviour_Internal_IsInvokingAllv: __Z57Register_UnityEngine_MonoBehaviour_Internal_IsInvokingAllv, __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR17DetailNodeYSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_T_, _tt_cmap13_char_index: _tt_cmap13_char_index, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags, __Z29Mesh_Get_Custom_PropCanAccessP12Il2CppObject: __Z29Mesh_Get_Custom_PropCanAccessP12Il2CppObject, __ZN12_GLOBAL__N_117ConnectionManager9setCameraEPKcRKN5physx6PxVec3ES6_S6_: __ZN12_GLOBAL__N_117ConnectionManager9setCameraEPKcRKN5physx6PxVec3ES6_S6_, __ZN6Sprite8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN6Sprite8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14PhysicsManagerC2E10MemLabelId18ObjectCreationMode: __ZN14PhysicsManagerC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sc18ParticleSystemCoreC2ERKNS_11PxActorType4EnumEjb: __ZN5physx2Sc18ParticleSystemCoreC2ERKNS_11PxActorType4EnumEjb, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSG_5Vec3VE: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration35generateTriangleFullContactManifoldERNS0_9TriangleVEjhRKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS2_EEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERNSG_5Vec3VE, __ZN14PhysicsManager27ExecuteDeferredTriggerEraseEv: __ZN14PhysicsManager27ExecuteDeferredTriggerEraseEv, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIccEEPcEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIccEEPcEEbT0_S5_T_, __Z50RelativeJoint2D_Set_Custom_PropAutoConfigureOffsetP12Il2CppObjecth: __Z50RelativeJoint2D_Set_Custom_PropAutoConfigureOffsetP12Il2CppObjecth, __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev: __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEED0Ev, __ZN5physx2Sc8BodyCore14setInverseMassEf: __ZN5physx2Sc8BodyCore14setInverseMassEf, __ZNK5physx3Ext10FixedJoint29getProjectionAngularToleranceEv: __ZNK5physx3Ext10FixedJoint29getProjectionAngularToleranceEv, __ZN10Collider2D27UpdateColliderMaterialStateEv: __ZN10Collider2D27UpdateColliderMaterialStateEv, __ZN9dtNavMesh26getOffMeshConnectionUnsafeEy: __ZN9dtNavMesh26getOffMeshConnectionUnsafeEy, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN14NullGpuProgram15ApplyGpuProgramERK20GpuProgramParametersPKh: __ZN14NullGpuProgram15ApplyGpuProgramERK20GpuProgramParametersPKh, __Z46Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointAllRK13Vector2fIcalliff: __Z46Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointAllRK13Vector2fIcalliff, __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev: __ZN5physx33PxConvexMeshGeometryGeneratedInfoC2Ev, __ZN7mecanim9animation18ControllerConstant15InitializeClassEv: __ZN7mecanim9animation18ControllerConstant15InitializeClassEv, __ZN9GfxDevice5FlushEv: __ZN9GfxDevice5FlushEv, __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_GetKey_InternalP12Il2CppObjectiR16KeyframeTplFloat: __Z51AnimationCurve_CUSTOM_INTERNAL_CALL_GetKey_InternalP12Il2CppObjectiR16KeyframeTplFloat, __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE: __ZN5audio5mixer25DestroyAudioMixerConstantEPNS0_18AudioMixerConstantERN7mecanim6memory9AllocatorE, _UNITY_LZ4_compress_continue: _UNITY_LZ4_compress_continue, __Z51Register_UnityEngine_Rigidbody_set_solverIterationsv: __Z51Register_UnityEngine_Rigidbody_set_solverIterationsv, _UNITY_png_set_compression_strategy: _UNITY_png_set_compression_strategy, __ZNK9ShaderLab6TexEnv11PrepareDataEiiP15GfxTextureParam: __ZNK9ShaderLab6TexEnv11PrepareDataEiiP15GfxTextureParam, __Z42Register_UnityEngine_Collider_set_materialv: __Z42Register_UnityEngine_Collider_set_materialv, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI9JSONWriteEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI9JSONWriteEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN3MBP21addToOutOfBoundsArrayEj: __ZN3MBP21addToOutOfBoundsArrayEj, __Z26getPxConstraint_BreakForcePKN5physx12PxConstraintERfS3_: __Z26getPxConstraint_BreakForcePKN5physx12PxConstraintERfS3_, __Z47Register_UnityEngine_Profiling_Sampler_get_namev: __Z47Register_UnityEngine_Profiling_Sampler_get_namev, __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j: __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j, __ZN20HardwareInfoReporterC2Ev: __ZN20HardwareInfoReporterC2Ev, __Z63Register_UnityEngine_Profiling_Profiler_GetTotalAllocatedMemoryv: __Z63Register_UnityEngine_Profiling_Profiler_GetTotalAllocatedMemoryv, __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE: __ZNK5physx2Gu15PCMPolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN5Umbra4Math4sqrtENS_5FloatE: __ZN5Umbra4Math4sqrtENS_5FloatE, __Z44ReflectionProbe_Set_Custom_PropBlendDistanceP12Il2CppObjectf: __Z44ReflectionProbe_Set_Custom_PropBlendDistanceP12Il2CppObjectf, __ZN20ArchiveStorageReader8FindNodeEPKc: __ZN20ArchiveStorageReader8FindNodeEPKc, __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData: __ZN29AudioEffectInternalDefinition9CreateDSPEPN4FMOD6SystemEPvPfPP25UnityAudioSpatializerData, __ZN17TransformInternal37SetSelfTransformHasChanged_DeprecatedE15TransformAccessjb: __ZN17TransformInternal37SetSelfTransformHasChanged_DeprecatedE15TransformAccessjb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj522ENS_22PxRepXPropertyAccessorILj522ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj522ENS_22PxRepXPropertyAccessorILj522ES4_ffEEEEvRKT0_, __ZN5physx11HullLibrary18CreateTriangleMeshERNS_10HullResultEPNS_27ConvexHullTriangleInterfaceE: __ZN5physx11HullLibrary18CreateTriangleMeshERNS_10HullResultEPNS_27ConvexHullTriangleInterfaceE, __ZN7mecanim12statemachine20EvaluateStateMachineERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_21StateMachineWorkspaceE: __ZN7mecanim12statemachine20EvaluateStateMachineERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryERNS0_21StateMachineWorkspaceE, __Z54Register_UnityEngine_Analytics_CustomEventData_AddBoolv: __Z54Register_UnityEngine_Analytics_CustomEventData_AddBoolv, _cff_parser_run: _cff_parser_run, __Z14IsStringNumberPKc: __Z14IsStringNumberPKc, __Z58ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedMultiplierP12Il2CppObjectf: __Z58ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedMultiplierP12Il2CppObjectf, __Z15GetMousePresentv: __Z15GetMousePresentv, __ZN5physx18PxVehicleDriveTank14setToRestStateEv: __ZN5physx18PxVehicleDriveTank14setToRestStateEv, __Z49Register_UnityEngine_AI_NavMeshAgent_set_areaMaskv: __Z49Register_UnityEngine_AI_NavMeshAgent_set_areaMaskv, __Z30Event_Set_Custom_PropModifiersP12Il2CppObjecti: __Z30Event_Set_Custom_PropModifiersP12Il2CppObjecti, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags, __ZN25ThreadsafeLinearAllocator15SelectFreeBlockEv: __ZN25ThreadsafeLinearAllocator15SelectFreeBlockEv, __Z40ParticleEmitter_Get_Custom_PropMinEnergyP12Il2CppObject: __Z40ParticleEmitter_Get_Custom_PropMinEnergyP12Il2CppObject, __ZNK5Umbra9BitVector4testERKS0_: __ZNK5Umbra9BitVector4testERKS0_, __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_: __ZNSt3__27__sort4IRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEjT0_SA_SA_SA_T_, __ZN12_GLOBAL__N_123FStreamNetworkOutStream5flushEv: __ZN12_GLOBAL__N_123FStreamNetworkOutStream5flushEv, __ZN15DirectorManagerC2Ev: __ZN15DirectorManagerC2Ev, _UNITY_png_icc_check_length: _UNITY_png_icc_check_length, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17GetResponseHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE17GetResponseHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE, __ZN16SpriteRenderData16GenerateFullMeshERK5RectTIfERK8Vector2fffjPS1_bPNSt3__26vectorI13dynamic_arrayIS4_Lj4EENS8_9allocatorISB_EEEE: __ZN16SpriteRenderData16GenerateFullMeshERK5RectTIfERK8Vector2fffjPS1_bPNSt3__26vectorI13dynamic_arrayIS4_Lj4EENS8_9allocatorISB_EEEE, __flushlbf: __flushlbf, __Z37Register_UnityEngine_LODGroup_GetLODsv: __Z37Register_UnityEngine_LODGroup_GetLODsv, __Z40ParticleSystem_Set_Custom_PropStartDelayP12Il2CppObjectf: __Z40ParticleSystem_Set_Custom_PropStartDelayP12Il2CppObjectf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_17TransferMetaFlags, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags, __Z17CircleHullOverlapPfRK13dynamic_arrayI8Vector2fLj4EERKS1_f: __Z17CircleHullOverlapPfRK13dynamic_arrayI8Vector2fLj4EERKS1_f, __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE8__appendEj, __ZN8Animator30FindAnimatorControllerPlayableEP18AnimatorController: __ZN8Animator30FindAnimatorControllerPlayableEP18AnimatorController, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10startEventEty: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10startEventEty, __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb0EEEEEvPT_, __Z31ValidateNoSceneObjectsAreLoadedb: __Z31ValidateNoSceneObjectsAreLoadedb, __Z34LensFlare_Set_Custom_PropFadeSpeedP12Il2CppObjectf: __Z34LensFlare_Set_Custom_PropFadeSpeedP12Il2CppObjectf, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE13isSubordinateEv, __Z50Register_UnityEngine_TerrainData_RefreshPrototypesv: __Z50Register_UnityEngine_TerrainData_RefreshPrototypesv, __Z47Register_UnityEngine_TargetJoint2D_set_maxForcev: __Z47Register_UnityEngine_TargetJoint2D_set_maxForcev, __Z29GUIText_Set_Custom_PropAnchorP12Il2CppObjecti: __Z29GUIText_Set_Custom_PropAnchorP12Il2CppObjecti, __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZNK5physx23PxCapsuleControllerDesc7isValidEv: __ZNK5physx23PxCapsuleControllerDesc7isValidEv, __ZN10TagManager23AddDefaultLayerIfNeededEv: __ZN10TagManager23AddDefaultLayerIfNeededEv, __ZN10FlareLayer12AddToManagerEv: __ZN10FlareLayer12AddToManagerEv, __ZN5physx23PxsBroadPhaseContextSapC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE: __ZN5physx23PxsBroadPhaseContextSapC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE, __ZN5physx17PxsFluidCollision15updateSubPacketEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheESA_RNS_21PxsFluidLocalCellHashERNS_9PxBounds3ERKS5_PKjjPKNS_31PxsParticleStreamContactManagerEPKNS_19PxsW2STransformTempEjPKf: __ZN5physx17PxsFluidCollision15updateSubPacketEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheESA_RNS_21PxsFluidLocalCellHashERNS_9PxBounds3ERKS5_PKjjPKNS_31PxsParticleStreamContactManagerEPKNS_19PxsW2STransformTempEjPKf, __ZN5physx29PxVehicleDriveGeneratedValuesC2EPKNS_14PxVehicleDriveE: __ZN5physx29PxVehicleDriveGeneratedValuesC2EPKNS_14PxVehicleDriveE, __ZNK5physx11NpAggregate11getAPISceneEv: __ZNK5physx11NpAggregate11getAPISceneEv, __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE6endTagEv, __Z47ParticleSystem_Get_Custom_PropUseAutoRandomSeedP12Il2CppObject: __Z47ParticleSystem_Get_Custom_PropUseAutoRandomSeedP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_, _setsid: _setsid, __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN5Umbra5Query22queryFrustumVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEfPKNS_20ObjectDistanceParamsEii: __ZN5Umbra5Query22queryFrustumVisibilityEjRKNS_10VisibilityERKNS_15CameraTransformEfPKNS_20ObjectDistanceParamsEii, __ZNK5physx2Sc5Scene18getSolverBatchSizeEv: __ZNK5physx2Sc5Scene18getSolverBatchSizeEv, __ZN13BuildSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13BuildSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZZN15DirectorManager15InitializeClassEvEN26UpdateDirectorUpdatestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN26UpdateDirectorUpdatestruct7ForwardEv, __ZN9Behaviour7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Behaviour7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN9Polygon2D9SetPointsEPK8Vector2fj: __ZN9Polygon2D9SetPointsEPK8Vector2fj, __ZN5physx16PxsBroadPhaseMBP15getCreatedPairsEv: __ZN5physx16PxsBroadPhaseMBP15getCreatedPairsEv, __Z16ApplySHConstantsI28ApplyBuiltinInstancePropertyEvRT_RK20SphericalHarmonicsL2: __Z16ApplySHConstantsI28ApplyBuiltinInstancePropertyEvRT_RK20SphericalHarmonicsL2, __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_3Scb13MaterialEventENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z18Transfer_BlittableI8JSONReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy: __ZN20ArchiveStorageReader15ReadFromStorageEyyPvPy, _unzGetFilePos: _unzGetFilePos, __ZN8Material43AddDefaultShaderPropertiesToSavedPropertiesEv: __ZN8Material43AddDefaultShaderPropertiesToSavedPropertiesEv, __ZNK17AnimationCurveTplIfE15GetPostInfinityEv: __ZNK17AnimationCurveTplIfE15GetPostInfinityEv, __ZN5physx3Scb5Scene17addAggregateToPvdERNS0_9AggregateE: __ZN5physx3Scb5Scene17addAggregateToPvdERNS0_9AggregateE, __ZN25ShadowMapJobHeaderScratch15ThreadedCleanupEv: __ZN25ShadowMapJobHeaderScratch15ThreadedCleanupEv, __ZN11BoxColliderD2Ev: __ZN11BoxColliderD2Ev, __Z19DoPrePassRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb: __Z19DoPrePassRenderLoopR17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EES4_RK11CullResultsRP13RenderTextureSA_Pb, __ZN13MemoryManager12LowLevelFreeEPvj: __ZN13MemoryManager12LowLevelFreeEPvj, __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12AspectRatios8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12AspectRatios8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN6Motion15ThreadedCleanupEv: __ZN6Motion15ThreadedCleanupEv, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN6HelperI18StreamedBinaryReadILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI18StreamedBinaryReadILb0EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __ZN10DynamicVBO19FillQuadIndexBufferER21DynamicVBOChunkHandle: __ZN10DynamicVBO19FillQuadIndexBufferER21DynamicVBOChunkHandle, __ZN18PlatformEffector2D21ContactUpdateCallbackEf: __ZN18PlatformEffector2D21ContactUpdateCallbackEf, __Z13MurmurHash64BPKviy: __Z13MurmurHash64BPKviy, __ZN5Umbra9Matrix4x45clearEv: __ZN5Umbra9Matrix4x45clearEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15QualitySettingsC2E10MemLabelId18ObjectCreationMode: __ZN15QualitySettingsC2E10MemLabelId18ObjectCreationMode, __Z35setPxVehicleDriveDynData_GearChangePN5physx21PxVehicleDriveDynDataEj: __Z35setPxVehicleDriveDynData_GearChangePN5physx21PxVehicleDriveDynDataEj, ___lxstat: ___lxstat, __ZNKSt3__220__codecvt_utf8_utf16IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_, __ZN26ContactCapsuleMeshCallbackD0Ev: __ZN26ContactCapsuleMeshCallbackD0Ev, __ZZN15TerrainCollider15InitializeClassEvEN30FunctorImpl_379kTerrainChanged4CallEPviR11MessageData: __ZZN15TerrainCollider15InitializeClassEvEN30FunctorImpl_379kTerrainChanged4CallEPviR11MessageData, __ZN22MotionVectorRenderLoop16PerformRenderingER8JobFence: __ZN22MotionVectorRenderLoop16PerformRenderingER8JobFence, __Z53Register_UnityEngine_PhysicMaterial_get_bounceCombinev: __Z53Register_UnityEngine_PhysicMaterial_get_bounceCombinev, __Z52AudioDistortionFilter_Get_Custom_PropDistortionLevelP12Il2CppObject: __Z52AudioDistortionFilter_Get_Custom_PropDistortionLevelP12Il2CppObject, __ZN12EventManager15DeallocateEntryEP10EventEntry: __ZN12EventManager15DeallocateEntryEP10EventEntry, __ZNSt3__28numpunctIcEC2Ej: __ZNSt3__28numpunctIcEC2Ej, __ZN10OnGUIState15SetMouseTooltipERK11UTF16String: __ZN10OnGUIState15SetMouseTooltipERK11UTF16String, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5imbueERKNS_6localeE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5imbueERKNS_6localeE, __Z44Cloth_CUSTOM_INTERNAL_set_randomAccelerationP12Il2CppObjectRK8Vector3f: __Z44Cloth_CUSTOM_INTERNAL_set_randomAccelerationP12Il2CppObjectRK8Vector3f, __ZN11UnityEngine15CloudWebService18RestFileDownloader13OnReceiveDataEPKvj: __ZN11UnityEngine15CloudWebService18RestFileDownloader13OnReceiveDataEPKvj, __ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_: __ZNSt3__23mapIjbNS_4lessIjEE13stl_allocatorINS_4pairIKjbEEL18MemLabelIdentifier77ELi16EEEixERS5_, __ZN17ArchiveFileSystem11HasFastHashERK13FileEntryDataR7Hash128: __ZN17ArchiveFileSystem11HasFastHashERK13FileEntryDataR7Hash128, __ZNK5physx27PxVehicleDifferentialNWData20getDrivenWheelStatusEv: __ZNK5physx27PxVehicleDifferentialNWData20getDrivenWheelStatusEv, __ZNK15b2RevoluteJoint13GetJointSpeedEv: __ZNK15b2RevoluteJoint13GetJointSpeedEv, __Z54Register_UnityEngine_ConstantForce_INTERNAL_get_torquev: __Z54Register_UnityEngine_ConstantForce_INTERNAL_get_torquev, __ZN13SpringJoint2D11SetDistanceEf: __ZN13SpringJoint2D11SetDistanceEf, _Current_Ppem: _Current_Ppem, __ZNK9Projector31GetProjectorToPerspectiveMatrixEv: __ZNK9Projector31GetProjectorToPerspectiveMatrixEv, __ZN5physx14PxsAABBManager11shiftOriginERKNS_6PxVec3E: __ZN5physx14PxsAABBManager11shiftOriginERKNS_6PxVec3E, __ZN4FMOD7SystemI13getNumPluginsE15FMOD_PLUGINTYPEPi: __ZN4FMOD7SystemI13getNumPluginsE15FMOD_PLUGINTYPEPi, __ZNK9Behaviour10HasEnabledEv: __ZNK9Behaviour10HasEnabledEv, _jsimd_can_convsamp_float: _jsimd_can_convsamp_float, __ZN26AnimatorOverrideController23VirtualRedirectTransferER14SafeBinaryRead: __ZN26AnimatorOverrideController23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj392ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj392ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z43ReflectionProbe_Set_Custom_PropFarClipPlaneP12Il2CppObjectf: __Z43ReflectionProbe_Set_Custom_PropFarClipPlaneP12Il2CppObjectf, __Z30GenerateDoubleIntegrationCacheR15PolynomialCurve: __Z30GenerateDoubleIntegrationCacheR15PolynomialCurve, __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEv: __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEv, _ctanhf: _ctanhf, __ZN17AnimationPlayable18SetInputConnectionEP8Playablei: __ZN17AnimationPlayable18SetInputConnectionEP8Playablei, __ZN5physx18PxsSolverStartTask11runInternalEv: __ZN5physx18PxsSolverStartTask11runInternalEv, __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_: __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_, __ZThn4_N5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE: __ZThn4_N5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE, __Z48Renderer_Set_Custom_PropStaticBatchRootTransformP12Il2CppObjectS0_: __Z48Renderer_Set_Custom_PropStaticBatchRootTransformP12Il2CppObjectS0_, __ZN12_GLOBAL__N_110DataStream8toStreamEPKc: __ZN12_GLOBAL__N_110DataStream8toStreamEPKc, __ZL25InitializeUnityWebStreamsPv: __ZL25InitializeUnityWebStreamsPv, __ZNK11dtPathQueue16getRequestStatusEj: __ZNK11dtPathQueue16getRequestStatusEj, __ZN6ShaderD0Ev: __ZN6ShaderD0Ev, __Z29getPxParticleBase_RestitutionPKN5physx14PxParticleBaseE: __Z29getPxParticleBase_RestitutionPKN5physx14PxParticleBaseE, __ZN5physx2Gu23pcmContactCapsuleConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu23pcmContactCapsuleConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN20LocalFileSystemPosix9SetLengthER13FileEntryDatay: __ZN20LocalFileSystemPosix9SetLengthER13FileEntryDatay, __ZN15AudioMixerGroup27GetGroupInGUIDListRecursiveERKNSt3__26vectorI9UnityGUIDNS0_9allocatorIS2_EEEER13dynamic_arrayI4PPtrIS_ELj4EE: __ZN15AudioMixerGroup27GetGroupInGUIDListRecursiveERKNSt3__26vectorI9UnityGUIDNS0_9allocatorIS2_EEEER13dynamic_arrayI4PPtrIS_ELj4EE, __ZN9JSONWrite8TransferIN11UnityEngine15CloudWebService17CloudServiceEvent8MsgValueEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIN11UnityEngine15CloudWebService17CloudServiceEvent8MsgValueEEEvRT_PKc17TransferMetaFlags, __Z51ParticleEmitter_CUSTOM_INTERNAL_CALL_ClearParticlesP12Il2CppObject: __Z51ParticleEmitter_CUSTOM_INTERNAL_CALL_ClearParticlesP12Il2CppObject, __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14BlendShapeData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Umbra13MatrixFactory7rotateZEf: __ZN5Umbra13MatrixFactory7rotateZEf, __ZN8WindZone8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8WindZone8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform: __ZN9Animation34RecomputeContainedRenderersRecurseER9Transform, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat14TexFormatRHalfEEvPKNS_9InnerInfoE, __Z4dot3RK8Scalar4fS1_: __Z4dot3RK8Scalar4fS1_, __ZThn12_N5physx3Ext14SphericalJoint11prepareDataEv: __ZThn12_N5physx3Ext14SphericalJoint11prepareDataEv, __Z25GetClassFromScriptClassIdRK8UnityStr: __Z25GetClassFromScriptClassIdRK8UnityStr, __ZN22ParticleSystemRenderer6UpdateERK4AABB: __ZN22ParticleSystemRenderer6UpdateERK4AABB, __ZN5physx28PxTriangleMeshRepXSerializer16objectToFileImplEPKNS_14PxTriangleMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx28PxTriangleMeshRepXSerializer16objectToFileImplEPKNS_14PxTriangleMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z59Register_UnityEngine_AnimationClip_INTERNAL_get_localBoundsv: __Z59Register_UnityEngine_AnimationClip_INTERNAL_get_localBoundsv, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZNK12_GLOBAL__N_118LegacySerialStream13getCollectionEv: __ZNK12_GLOBAL__N_118LegacySerialStream13getCollectionEv, __Z62Register_UnityEngine_ConstantForce_INTERNAL_get_relativeTorquev: __Z62Register_UnityEngine_ConstantForce_INTERNAL_get_relativeTorquev, _ffs: _ffs, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z42Register_UnityEngine_Collider_get_materialv: __Z42Register_UnityEngine_Collider_get_materialv, __Z38AsyncOperation_Set_Custom_PropPriorityP12Il2CppObjecti: __Z38AsyncOperation_Set_Custom_PropPriorityP12Il2CppObjecti, __Z28WindZone_Get_Custom_PropModeP12Il2CppObject: __Z28WindZone_Get_Custom_PropModeP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_10NpMaterialENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZNK5physx22PxDefaultFileInputData7isValidEv: __ZNK5physx22PxDefaultFileInputData7isValidEv, __Z44Register_UnityEngine_Material_DisableKeywordv: __Z44Register_UnityEngine_Material_DisableKeywordv, __ZN4FMOD8ChannelI19set3DDistanceFilterEbff: __ZN4FMOD8ChannelI19set3DDistanceFilterEbff, __ZN4FMOD7SystemI20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_: __ZN4FMOD7SystemI20getGeometryOcclusionEPK11FMOD_VECTORS3_PfS4_, __Z22getPxMeshScaleRotationPKN5physx11PxMeshScaleE: __Z22getPxMeshScaleRotationPKN5physx11PxMeshScaleE, __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E: __ZN5physx2Gu14SeparatingAxes7addAxisERKNS_6PxVec3E, __ZNKSt3__217moneypunct_bynameIcLb0EE14do_frac_digitsEv: __ZNKSt3__217moneypunct_bynameIcLb0EE14do_frac_digitsEv, __ZN5Umbra9Matrix4x3mLERKS0_: __ZN5Umbra9Matrix4x3mLERKS0_, __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj: __ZN4FMOD7Channel8setDelayE14FMOD_DELAYTYPEjj, __ZNSt3__210moneypunctIwLb0EEC2Ej: __ZNSt3__210moneypunctIwLb0EEC2Ej, __Z41Camera_Get_Custom_PropActualRenderingPathP12Il2CppObject: __Z41Camera_Get_Custom_PropActualRenderingPathP12Il2CppObject, __ZN5physx2Sc35ParticleElementRbElementInteractionD2Ev: __ZN5physx2Sc35ParticleElementRbElementInteractionD2Ev, __ZThn4_N12MemoryStreamD1Ev: __ZThn4_N12MemoryStreamD1Ev, __ZN19ControllerHitReportD2Ev: __ZN19ControllerHitReportD2Ev, __ZN11UnityEngine9Analytics15AnalyticsConfig13ConfigChangedERK8UnityStrR8JSONRead: __ZN11UnityEngine9Analytics15AnalyticsConfig13ConfigChangedERK8UnityStrR8JSONRead, __ZNSt3__25mutex8try_lockEv: __ZNSt3__25mutex8try_lockEv, __Z34GUIText_Set_Custom_PropLineSpacingP12Il2CppObjectf: __Z34GUIText_Set_Custom_PropLineSpacingP12Il2CppObjectf, __Z38TranslateQuadIndexBufferToTriangleListPtPKtj: __Z38TranslateQuadIndexBufferToTriangleListPtPKtj, __Z33Renderer_Get_Custom_PropIsVisibleP12Il2CppObject: __Z33Renderer_Get_Custom_PropIsVisibleP12Il2CppObject, __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB4444EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB4444EEvPKNS_9InnerInfoE, __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEED0Ev, __Z61Playable_CUSTOM_INTERNAL_CALL_SetInputWeightFromIndexInternalR9HPlayableif: __Z61Playable_CUSTOM_INTERNAL_CALL_SetInputWeightFromIndexInternalR9HPlayableif, __ZN14TerrainManager27ClearLightmapsOnAllTerrainsEv: __ZN14TerrainManager27ClearLightmapsOnAllTerrainsEv, __ZNK5physx2Sq11PruningPool10getPayloadERKj: __ZNK5physx2Sq11PruningPool10getPayloadERKj, __Z14CreateMemLabel18MemLabelIdentifierPv: __Z14CreateMemLabel18MemLabelIdentifierPv, __ZN5physx2Sc15ClothFabricCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc15ClothFabricCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx5cloth11SwCollisionI8Scalar4fE17buildAccelerationEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE17buildAccelerationEv, __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseE: __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseE, __ZN4FMOD8ChannelI17set3DConeSettingsEfff: __ZN4FMOD8ChannelI17set3DConeSettingsEfff, _wcsxfrm: _wcsxfrm, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseEjj, __ZN12NavMeshAgent12CleanupClassEv: __ZN12NavMeshAgent12CleanupClassEv, __ZN20TextRenderingPrivate15GetFontsManager16StaticInitializeEv: __ZN20TextRenderingPrivate15GetFontsManager16StaticInitializeEv, __ZN16CircleCollider2D16CheckConsistencyEv: __ZN16CircleCollider2D16CheckConsistencyEv, __ZN4crnd25static_huffman_data_modelaSERKS0_: __ZN4crnd25static_huffman_data_modelaSERKS0_, __Z23sweepCapsule_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z23sweepCapsule_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNK16b2PrismaticJoint13GetJointSpeedEv: __ZNK16b2PrismaticJoint13GetJointSpeedEv, __Z55Register_UnityEngine_AudioSource_set_velocityUpdateModev: __Z55Register_UnityEngine_AudioSource_set_velocityUpdateModev, __ZN5physx30PxcPCMContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx30PxcPCMContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN5physx9PxCookingD2Ev: __ZN5physx9PxCookingD2Ev, __Z46Register_UnityEngine_VR_VRSettings_set_enabledv: __Z46Register_UnityEngine_VR_VRSettings_set_enabledv, __ZNK22GenericPropertyBinding13FindHashIndexEj: __ZNK22GenericPropertyBinding13FindHashIndexEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj452ENS_22PxRepXPropertyAccessorILj452ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj452ENS_22PxRepXPropertyAccessorILj452ES4_ffEEEEvRKT0_, __ZN11UmbraModule20CleanupUmbraTomeDataEPKN5Umbra4TomeE: __ZN11UmbraModule20CleanupUmbraTomeDataEPKN5Umbra4TomeE, __Z15QueueScreenshotRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi: __Z15QueueScreenshotRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getMaxMotionDistanceEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getMaxMotionDistanceEv, __Z55Register_UnityEngine_Joint_INTERNAL_set_connectedAnchorv: __Z55Register_UnityEngine_Joint_INTERNAL_set_connectedAnchorv, __Z38Event_CUSTOM_Internal_GetMousePositionP12Il2CppObjectP13Vector2fIcall: __Z38Event_CUSTOM_Internal_GetMousePositionP12Il2CppObjectP13Vector2fIcall, __ZN5physx23PxVehicleWheels4SimData20setWheelCentreOffsetEjRKNS_6PxVec3E: __ZN5physx23PxVehicleWheels4SimData20setWheelCentreOffsetEjRKNS_6PxVec3E, __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE: __ZN5physx3Ext9MassProps13rotateInertiaERKNS_7PxMat33ERKNS_6PxQuatE, __ZN5physx11Adjacencies11MakeLastRefERNS_11AdjTriangleEjPNS_2Gu9TriangleTIjEE: __ZN5physx11Adjacencies11MakeLastRefERNS_11AdjTriangleEjPNS_2Gu9TriangleTIjEE, __ZN35RegisterRuntimeInitializeAndCleanup14ExecuteCleanupEv: __ZN35RegisterRuntimeInitializeAndCleanup14ExecuteCleanupEv, __Z44Cloth_CUSTOM_INTERNAL_get_randomAccelerationP12Il2CppObjectP8Vector3f: __Z44Cloth_CUSTOM_INTERNAL_get_randomAccelerationP12Il2CppObjectP8Vector3f, __Z41Register_UnityEngine_Camera_get_eventMaskv: __Z41Register_UnityEngine_Camera_get_eventMaskv, __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev: __ZTv0_n12_NSt3__213basic_istreamIwNS_11char_traitsIwEEED1Ev, __ZN9JSONWrite8TransferI13dynamic_arrayIdLj8EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIdLj8EEEEvRT_PKc17TransferMetaFlags, __Z44AnimationState_Set_Custom_PropNormalizedTimeP12Il2CppObjectf: __Z44AnimationState_Set_Custom_PropNormalizedTimeP12Il2CppObjectf, __ZN20LocalFileSystemWebGLD0Ev: __ZN20LocalFileSystemWebGLD0Ev, __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv: __ZN11UnityEngine15CloudWebService14DataDispatcher17PlayerLoopHandlerEv, __Z35CreateQuaternionFromAxisQuaternionsRK11QuaternionfS1_S1_RS_: __Z35CreateQuaternionFromAxisQuaternionsRK11QuaternionfS1_S1_RS_, __ZNK5physx7NpScene22getNbBroadPhaseRegionsEv: __ZNK5physx7NpScene22getNbBroadPhaseRegionsEv, _tlsf_destroy: _tlsf_destroy, __Z51Register_UnityEngine_Camera_get_PreviewCullingLayerv: __Z51Register_UnityEngine_Camera_get_PreviewCullingLayerv, __ZN5physx16PxsIslandManager12setKinematicERKNS_20PxsIslandManagerHookIjLj4294967295EEEb: __ZN5physx16PxsIslandManager12setKinematicERKNS_20PxsIslandManagerHookIjLj4294967295EEEb, __ZN7mecanim13ValueArraySubERKNS_10ValueArrayERS0_PKNS_14ValueArrayMaskE: __ZN7mecanim13ValueArraySubERKNS_10ValueArrayERS0_PKNS_14ValueArrayMaskE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags, __ZN4PPtrI18SpeedTreeWindAssetE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI18SpeedTreeWindAssetE8TransferI14SafeBinaryReadEEvRT_, __Z32Register_UnityEngine_Debug_Breakv: __Z32Register_UnityEngine_Debug_Breakv, __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI13AnimationClipE8TransferI14SafeBinaryReadEEvRT_, __ZN11UnityEngine7Connect15AppRunningEventC2Ejjjj: __ZN11UnityEngine7Connect15AppRunningEventC2Ejjjj, __ZN5Umbra4Math5floorERKNS_6DoubleE: __ZN5Umbra4Math5floorERKNS_6DoubleE, __ZNK5physx17ConvexHullBuilder4SaveERNS_14PxOutputStreamEb: __ZNK5physx17ConvexHullBuilder4SaveERNS_14PxOutputStreamEb, __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev: __ZNSt3__213__vector_baseIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEED2Ev, __Z15tessGetVerticesP14TESStesselator: __Z15tessGetVerticesP14TESStesselator, _UNITY_png_icc_check_header: _UNITY_png_icc_check_header, __ZN16Physics2DManager14OverlapCapsuleERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2D: __ZN16Physics2DManager14OverlapCapsuleERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2D, __ZNK12NavMeshAgent13GetPathStatusEv: __ZNK12NavMeshAgent13GetPathStatusEv, __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev: __ZN11UnityEngine9Analytics15AnalyticsConfigC2Ev, __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MovePositionv: __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_MovePositionv, __Z40Animator_Get_Custom_PropIsMatchingTargetP12Il2CppObject: __Z40Animator_Get_Custom_PropIsMatchingTargetP12Il2CppObject, __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve, __ZN19ComputeShaderKernelC2ERKS_: __ZN19ComputeShaderKernelC2ERKS_, __ZNK5physx27PxVehicleDifferentialNWData7isValidEv: __ZNK5physx27PxVehicleDifferentialNWData7isValidEv, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12createObjectERPhRNS_24PxDeserializationContextE, __Z28setPxSceneDescFilterCallbackPN5physx11PxSceneDescEPNS_26PxSimulationFilterCallbackE: __Z28setPxSceneDescFilterCallbackPN5physx11PxSceneDescEPNS_26PxSimulationFilterCallbackE, __ZN4Mesh14ClearSkinCacheEv: __ZN4Mesh14ClearSkinCacheEv, _consume_data: _consume_data, __Z18Transfer_BlittableI9JSONWriteLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z55Register_UnityEngine_AudioSource_get_velocityUpdateModev: __Z55Register_UnityEngine_AudioSource_get_velocityUpdateModev, __ZL23ComputeBoneBindPoseAABBPK10Matrix4x4fj14StrideIteratorI8Vector3fEPK13BoneInfluencejRK13dynamic_arrayI16BlendShapeVertexLj4EEP10MinMaxAABB: __ZL23ComputeBoneBindPoseAABBPK10Matrix4x4fj14StrideIteratorI8Vector3fEPK13BoneInfluencejRK13dynamic_arrayI16BlendShapeVertexLj4EEP10MinMaxAABB, __Z35VRDevice_Get_Custom_PropRefreshRatev: __Z35VRDevice_Get_Custom_PropRefreshRatev, __ZN11AudioSource13AwakeFromLoadE17AwakeFromLoadMode: __ZN11AudioSource13AwakeFromLoadE17AwakeFromLoadMode, __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalGetUrlv: __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalGetUrlv, __ZNK13EmscriptenWWW6GetETAEv: __ZNK13EmscriptenWWW6GetETAEv, __ZN12TreeInstance8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12TreeInstance8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine7Connect13ConnectConfigC2Ev: __ZN11UnityEngine7Connect13ConnectConfigC2Ev, __ZL31FindActiveTransformWithPathImplPKcR10GameObjectb: __ZL31FindActiveTransformWithPathImplPKcR10GameObjectb, __Z60Register_UnityEngine_Collider_INTERNAL_CALL_Internal_Raycastv: __Z60Register_UnityEngine_Collider_INTERNAL_CALL_Internal_Raycastv, __Z58Register_UnityEngine_ParticleAnimator_get_doesAnimateColorv: __Z58Register_UnityEngine_ParticleAnimator_get_doesAnimateColorv, __ZN5physx14NpRigidDynamic10putToSleepEv: __ZN5physx14NpRigidDynamic10putToSleepEv, __ZNK23ArchiveStorageConverter25ArchiveRequiresConversionE15CompressionType: __ZNK23ArchiveStorageConverter25ArchiveRequiresConversionE15CompressionType, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__get_pointerEv, __ZN4crnd25crnd_set_memory_callbacksEPFPvS0_jPjbS0_EPFjS0_S0_ES0_: __ZN4crnd25crnd_set_memory_callbacksEPFPvS0_jPjbS0_EPFjS0_S0_ES0_, _jsimd_quantize: _jsimd_quantize, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE, __Z41ReflectionProbe_Set_Custom_PropImportanceP12Il2CppObjecti: __Z41ReflectionProbe_Set_Custom_PropImportanceP12Il2CppObjecti, __ZN5physx14NpArticulation17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx14NpArticulation17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__erase_to_endEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__erase_to_endEj, __ZN5physx9PxTaskMgr13decrReferenceEj: __ZN5physx9PxTaskMgr13decrReferenceEj, __ZN4Mesh8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN4Mesh8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9JSONWrite8TransferI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_PKc17TransferMetaFlags, __Z29scripting_field_has_attributeP11Il2CppClassP9FieldInfoS0_: __Z29scripting_field_has_attributeP11Il2CppClassP9FieldInfoS0_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212system_errorC2EiRKNS_14error_categoryEPKc: __ZNSt3__212system_errorC2EiRKNS_14error_categoryEPKc, __ZN5physx9NpPhysics14getProfileZoneEv: __ZN5physx9NpPhysics14getProfileZoneEv, __Z29Animator_CUSTOM_GetLayerIndexP12Il2CppObjectP12Il2CppString: __Z29Animator_CUSTOM_GetLayerIndexP12Il2CppObjectP12Il2CppString, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj71ENS0_26PxPvdRangePropertyAccessorILj71ES4_fEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj71ENS0_26PxPvdRangePropertyAccessorILj71ES4_fEEEEvjRKT0_, _Vertical_Sweep_Step: _Vertical_Sweep_Step, __ZNKSt3__214__codecvt_utf8IDsE16do_always_noconvEv: __ZNKSt3__214__codecvt_utf8IDsE16do_always_noconvEv, __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb: __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_ffS2_S6_S7_ffb, __ZN19CloudServiceHandler17PauseEventHandlerEb: __ZN19CloudServiceHandler17PauseEventHandlerEb, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_xDriveP12Il2CppObjectP10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_get_xDriveP12Il2CppObjectP10JointDrive, __ZN19ShaderPropertySheetD0Ev: __ZN19ShaderPropertySheetD0Ev, __ZN13OcclusionArea23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13OcclusionArea23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z16GetClothingScenev: __Z16GetClothingScenev, __Z31Animator_Get_Custom_PropIsHumanP12Il2CppObject: __Z31Animator_Get_Custom_PropIsHumanP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, __Z28setPxDistanceJoint_StiffnessPN5physx15PxDistanceJointEf: __Z28setPxDistanceJoint_StiffnessPN5physx15PxDistanceJointEf, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx15PxVehicleWheels4freeEv: __ZN5physx15PxVehicleWheels4freeEv, __Z16IntersectRayAABBRK3RayRK4AABBPf: __Z16IntersectRayAABBRK3RayRK4AABBPf, __Z50AsyncOperation_Get_Custom_PropAllowSceneActivationP12Il2CppObject: __Z50AsyncOperation_Get_Custom_PropAllowSceneActivationP12Il2CppObject, __ZN11UnityEngine15CloudWebService18CloudServiceConfigD2Ev: __ZN11UnityEngine15CloudWebService18CloudServiceConfigD2Ev, __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZMultiplierv, __ZN11ColorModuleD0Ev: __ZN11ColorModuleD0Ev, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZNKSt3__214collate_bynameIwE10do_compareEPKwS3_S3_S3_: __ZNKSt3__214collate_bynameIwE10do_compareEPKwS3_S3_S3_, __Z42ParticleAnimator_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f: __Z42ParticleAnimator_CUSTOM_INTERNAL_get_forceP12Il2CppObjectP8Vector3f, __ZN2UI13RectTransform8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN2UI13RectTransform8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__214__split_bufferIN13AnimationClip9PPtrCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__214__split_bufferIN13AnimationClip9PPtrCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev, __Z37Physics_CUSTOM_INTERNAL_CALL_CheckBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction: __Z37Physics_CUSTOM_INTERNAL_CALL_CheckBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction, __ZN4FMOD8ChannelI15get3DAttributesEP11FMOD_VECTORS2_: __ZN4FMOD8ChannelI15get3DAttributesEP11FMOD_VECTORS2_, __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventNamev: __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventNamev, __ZN5physx14NpRigidDynamic13setGlobalPoseERKNS_11PxTransformEb: __ZN5physx14NpRigidDynamic13setGlobalPoseERKNS_11PxTransformEb, __ZN14SerializedFile14InitializeReadERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER18ResourceImageGroupjj24TransferInstructionFlagsjj: __ZN14SerializedFile14InitializeReadERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER18ResourceImageGroupjj24TransferInstructionFlagsjj, __Z51MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_: __Z51MaterialPropertyBlock_CUSTOM_SetMatrixArrayImplListP12Il2CppObjectiS0_, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _UNITY_png_get_cHRM_fixed: _UNITY_png_get_cHRM_fixed, __ZN10__cxxabiv112_GLOBAL__N_12DbD2Ev: __ZN10__cxxabiv112_GLOBAL__N_12DbD2Ev, __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE: __ZN20ArchiveStorageReader18DestroyCachedBlockEPNS_11CachedBlockE, __Z67Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_FromEulerRadv: __Z67Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_FromEulerRadv, __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf: __Z18MatrixToQuaternionRK10Matrix4x4fR11Quaternionf, __ZN5physx8debugger14PvdMarshallingIhdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhdE12marshalBlockEPKhPhj, __Z38getPxD6Joint_ProjectionLinearTolerancePKN5physx9PxD6JointE: __Z38getPxD6Joint_ProjectionLinearTolerancePKN5physx9PxD6JointE, __ZN9ShaderLab4Pass24CreateFromSerializedPassERKNS_14SerializedPassEPK6Shader: __ZN9ShaderLab4Pass24CreateFromSerializedPassERKNS_14SerializedPassEPK6Shader, __Z14DecompressDXT5iiiPKjPj: __Z14DecompressDXT5iiiPKjPj, __Z61Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelBilinearv: __Z61Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelBilinearv, __Z48setPxVehicleTireLoadFilterDataMMinNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf: __Z48setPxVehicleTireLoadFilterDataMMinNormalisedLoadPN5physx27PxVehicleTireLoadFilterDataEf, _chdir: _chdir, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl16checkMarshallingEN5physx8debugger18NonNegativeIntegerES3_: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl16checkMarshallingEN5physx8debugger18NonNegativeIntegerES3_, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17clearSpatialForceENS_11PxForceMode4EnumEbb: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17clearSpatialForceENS_11PxForceMode4EnumEbb, __ZN8Animator14GetAvatarScaleEv: __ZN8Animator14GetAvatarScaleEv, __ZN29AssetBundleLoadAssetOperation27PrepareMainAssetPreloadListER11AssetBundleR13dynamic_arrayIiLj4EE: __ZN29AssetBundleLoadAssetOperation27PrepareMainAssetPreloadListER11AssetBundleR13dynamic_arrayIiLj4EE, __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11getNbShapesEv: __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11getNbShapesEv, __ZN5physx57PxVehicleDriveTankSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE: __ZN5physx57PxVehicleDriveTankSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYMultiplierv, __ZN15NavMeshSettings12CleanupClassEv: __ZN15NavMeshSettings12CleanupClassEv, __ZN5Umbra12QueryContext16visualizeFrustumERKNS_11TransformerE: __ZN5Umbra12QueryContext16visualizeFrustumERKNS_11TransformerE, __ZNK5physx11AdjTriangle18ComputeNbNeighborsEv: __ZNK5physx11AdjTriangle18ComputeNbNeighborsEv, __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE: __ZN5Unity12PhysicsQuery19CapsuleCastInternalERK8Vector3fS3_fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_10PxSweepHitEEE, __Z42getPxVehicleDriveDynData_AutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE: __Z42getPxVehicleDriveDynData_AutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE, __ZN5physx19PxsFluidSpatialHash19buildPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEjPNS_16PxsFluidParticleEPj: __ZN5physx19PxsFluidSpatialHash19buildPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEjPNS_16PxsFluidParticleEPj, __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN6Skybox23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Skybox23VirtualRedirectTransferER14SafeBinaryRead, __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawMeshv: __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawMeshv, __ZN12AdsIdHandler37ExecuteOnMainThreadAdsIdJobDoneStaticEPv: __ZN12AdsIdHandler37ExecuteOnMainThreadAdsIdJobDoneStaticEPv, __ZN21TreeBinaryTreeBuilder17EncapsulateBoundsER10MinMaxAABBRK12TreeInstanceRKNSt3__26vectorIN12TreeDatabase9PrototypeENS5_9allocatorIS8_EEEERK8Vector3fSG_: __ZN21TreeBinaryTreeBuilder17EncapsulateBoundsER10MinMaxAABBRK12TreeInstanceRKNSt3__26vectorIN12TreeDatabase9PrototypeENS5_9allocatorIS8_EEEERK8Vector3fSG_, __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_: __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17ScriptingToNativeERP12Il2CppObjectPS1_, __ZN12AudioManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12AudioManager23VirtualRedirectTransferER17RemapPPtrTransfer, __Z37Shader_CUSTOM_SetGlobalFloatArrayImpliP11Il2CppArray: __Z37Shader_CUSTOM_SetGlobalFloatArrayImpliP11Il2CppArray, __ZN4Mesh17RecalculateBoundsEv: __ZN4Mesh17RecalculateBoundsEv, __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__26vectorIjNS0_9allocatorIjEEEEE16StaticInitializeEPv, __Z27getNbPxPhysics_HeightFieldsPKN5physx9PxPhysicsE: __Z27getNbPxPhysics_HeightFieldsPKN5physx9PxPhysicsE, __ZN12_GLOBAL__N_115StringTableImpl7releaseEv: __ZN12_GLOBAL__N_115StringTableImpl7releaseEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE8pushNameEPKc, __ZNK7b2Mat3315GetSymInverse33EPS_: __ZNK7b2Mat3315GetSymInverse33EPS_, __ZN21AudioDistortionFilter15ThreadedCleanupEv: __ZN21AudioDistortionFilter15ThreadedCleanupEv, __Z26getPxHeightFieldDescFormatPKN5physx17PxHeightFieldDescE: __Z26getPxHeightFieldDescFormatPKN5physx17PxHeightFieldDescE, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERf: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERf, __ZN11UnityEngine7Connect12AppStopEventD0Ev: __ZN11UnityEngine7Connect12AppStopEventD0Ev, __ZN16DeveloperConsole10DrawButtonER8GUIStateRK5RectTIfERK11UTF16String: __ZN16DeveloperConsole10DrawButtonER8GUIStateRK5RectTIfERK11UTF16String, __ZN16Physics2DManagerC2Ev: __ZN16Physics2DManagerC2Ev, __ZN22RenderingCommandBuffer25AddDrawProceduralIndirectERK10Matrix4x4fP8Materiali16GfxPrimitiveType15ComputeBufferIDiP19ShaderPropertySheet: __ZN22RenderingCommandBuffer25AddDrawProceduralIndirectERK10Matrix4x4fP8Materiali16GfxPrimitiveType15ComputeBufferIDiP19ShaderPropertySheet, __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fPKS1_EEvPT_RKT0_j: __ZN12_GLOBAL__N_115generateSpheresI8Scalar4fPKS1_EEvPT_RKT0_j, __ZN12TreeRenderer15WillRenderTreesERK9IndexListPK9SceneNodeR13dynamic_arrayIbLj1EE: __ZN12TreeRenderer15WillRenderTreesERK9IndexListPK9SceneNodeR13dynamic_arrayIbLj1EE, _wprintf: _wprintf, __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE: __ZN5physx27InternalTriangleMeshBuilderC2EPNS_20InternalTriangleMeshERKNS_15PxCookingParamsE, __Z54Register_UnityEngine_AreaEffector2D_get_useGlobalAnglev: __Z54Register_UnityEngine_AreaEffector2D_get_useGlobalAnglev, __ZN21ArchiveStorageCreator22GetEstimatedHeaderSizeEjyj: __ZN21ArchiveStorageCreator22GetEstimatedHeaderSizeEjyj, __ZN5physx19NpArticulationJoint17setTargetVelocityERKNS_6PxVec3E: __ZN5physx19NpArticulationJoint17setTargetVelocityERKNS_6PxVec3E, __ZN4crnd12crn_unpacker22decode_alpha_selectorsEv: __ZN4crnd12crn_unpacker22decode_alpha_selectorsEv, __ZN5physx25PxDefaultFileOutputStreamD2Ev: __ZN5physx25PxDefaultFileOutputStreamD2Ev, _scanexp: _scanexp, __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag: __ZNK10FileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEb19FileEnumerationFlag, __ZN18CrashReportManager27OnPlayerSessionStateChangedEjyy: __ZN18CrashReportManager27OnPlayerSessionStateChangedEjyy, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE: __ZN8Material10GetTextureEN9ShaderLab16FastPropertyNameE, __ZThn32_N8Renderer19UpdateTransformInfoEv: __ZThn32_N8Renderer19UpdateTransformInfoEv, __Z30GUIText_Get_Custom_PropTabSizeP12Il2CppObject: __Z30GUIText_Get_Custom_PropTabSizeP12Il2CppObject, __ZNK5physx7NpScene26getVisualizationCullingBoxEv: __ZNK5physx7NpScene26getVisualizationCullingBoxEv, __ZN13GfxDeviceGLES19SetUserBackfaceModeEb: __ZN13GfxDeviceGLES19SetUserBackfaceModeEb, __ZNK14DLHAudioHelper14GetPartialDataEv: __ZNK14DLHAudioHelper14GetPartialDataEv, __ZNK14SerializedFile22GetAllFileIDsUncheckedEP13dynamic_arrayIxLj8EE: __ZNK14SerializedFile22GetAllFileIDsUncheckedEP13dynamic_arrayIxLj8EE, __ZNK5physx2Sq16BucketPrunerCore7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE: __ZNK5physx2Sq16BucketPrunerCore7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE, __Z44Register_UnityEngine_Joint2D_get_breakTorquev: __Z44Register_UnityEngine_Joint2D_get_breakTorquev, __Z31AnimationCurve_CUSTOM_RemoveKeyP12Il2CppObjecti: __Z31AnimationCurve_CUSTOM_RemoveKeyP12Il2CppObjecti, __ZN10GameObject21GetIsStaticDeprecatedEv: __ZN10GameObject21GetIsStaticDeprecatedEv, _jsimd_ycc_rgb_convert: _jsimd_ycc_rgb_convert, __Z45AnimationClipPlayable_CUSTOM_GetAnimationClipR9HPlayable: __Z45AnimationClipPlayable_CUSTOM_GetAnimationClipR9HPlayable, __ZN5Umbra15StartCellFinder16processStartTileEii: __ZN5Umbra15StartCellFinder16processStartTileEii, __ZN20UnityConnectSettingsD0Ev: __ZN20UnityConnectSettingsD0Ev, __ZN5physx14NpSpatialIndex6removeEj: __ZN5physx14NpSpatialIndex6removeEj, __ZN5physx26PxcPCMContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx26PxcPCMContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z51NavMeshAgent_Set_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObjecth: __Z51NavMeshAgent_Set_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObjecth, __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z50Register_UnityEngine_ParticleSystem_Internal_Clearv: __Z50Register_UnityEngine_ParticleSystem_Internal_Clearv, __Z15GetLightManagerv: __Z15GetLightManagerv, __ZN18UnityPropertySheet21AddNewSerializedPropsERKS_: __ZN18UnityPropertySheet21AddNewSerializedPropsERKS_, __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_suspensionSpringv: __Z64Register_UnityEngine_WheelCollider_INTERNAL_set_suspensionSpringv, __ZN9GfxDevice24GetMaxStaticBatchIndicesEv: __ZN9GfxDevice24GetMaxStaticBatchIndicesEv, __ZN11TerrainData10RemoveUserEP10GameObject: __ZN11TerrainData10RemoveUserEP10GameObject, __Z11SkinGenericILi2ELb0ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi2ELb0ELb0EEvR12SkinMeshInfo, __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setStiffnessFrequencyEf, __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_: __ZN13dynamic_arrayI10MinMaxAABBLj4EE9push_backERKS0_, __ZN5physx9readChunkERaS0_S0_S0_RNS_13PxInputStreamE: __ZN5physx9readChunkERaS0_S0_S0_RNS_13PxInputStreamE, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE7getNameEv, __ZN9GfxDevice13SetViewMatrixERK10Matrix4x4f: __ZN9GfxDevice13SetViewMatrixERK10Matrix4x4f, __ZN5Unity17ConfigurableJoint21SetProjectionDistanceEf: __ZN5Unity17ConfigurableJoint21SetProjectionDistanceEf, __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE14__assign_multiINS_21__tree_const_iteratorIjPNS_11__tree_nodeIjPvEEiEEEEvT_SD_: __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE14__assign_multiINS_21__tree_const_iteratorIjPNS_11__tree_nodeIjPvEEiEEEEvT_SD_, __Z20FinishUnquantizeBC6Hi: __Z20FinishUnquantizeBC6Hi, __ZN17PersistentManager13UnloadStreamsEv: __ZN17PersistentManager13UnloadStreamsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj157ENS_22PxRepXPropertyAccessorILj157ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj157ENS_22PxRepXPropertyAccessorILj157ES4_ffEEEEvRKT0_, __ZNK5physx2Sq12BucketPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE: __ZNK5physx2Sq12BucketPruner7overlapERKNS0_9ShapeDataERNS0_14PrunerCallbackE, __ZN16LightmapSettings14SetSceneHandleEi: __ZN16LightmapSettings14SetSceneHandleEi, __ZN13CameraLODData7ReserveEj: __ZN13CameraLODData7ReserveEj, __ZN12MeshRenderer15UpdateLocalAABBEv: __ZN12MeshRenderer15UpdateLocalAABBEv, __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator9EmptyTileEE6updateEibbb: __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator9EmptyTileEE6updateEibbb, __Z31Sprite_Get_Custom_PropTrianglesP12Il2CppObject: __Z31Sprite_Get_Custom_PropTrianglesP12Il2CppObject, __ZN12CullingGroup20SetBoundingDistancesEPKfj: __ZN12CullingGroup20SetBoundingDistancesEPKfj, __ZNSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE25__construct_node_with_keyERSD_: __ZNSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemENS_4lessIS7_EES4_INS_4pairIKS7_S9_EELS5_54ELi16EEE25__construct_node_with_keyERSD_, __ZN11NavMeshPath15ReservePolygonsEi: __ZN11NavMeshPath15ReservePolygonsEi, __ZN12HandlerChain4ThenEP17FileSystemHandler: __ZN12HandlerChain4ThenEP17FileSystemHandler, _rintf: _rintf, __ZN9Animation8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Animation8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_: __ZNSt3__27__sort3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_T_, __ZNK5Umbra15OcclusionBuffer9getBufferEPvPKNS0_10BufferDescE: __ZNK5Umbra15OcclusionBuffer9getBufferEPvPKNS0_10BufferDescE, __ZN5physx14NpArticulation7setNameEPKc: __ZN5physx14NpArticulation7setNameEPKc, __ZN14InputInterface10UpdateDragER10InputEvent: __ZN14InputInterface10UpdateDragER10InputEvent, __Z55Register_UnityEngine_PhysicMaterial_get_staticFriction2v: __Z55Register_UnityEngine_PhysicMaterial_get_staticFriction2v, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignINS_11__wrap_iterIPK8UnityStrEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISG_E9referenceEEE5valueEvE4typeESG_SG_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignINS_11__wrap_iterIPK8UnityStrEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISG_E9referenceEEE5valueEvE4typeESG_SG_, __Z32setPxSceneLimitsMaxNbConstraintsPN5physx13PxSceneLimitsEj: __Z32setPxSceneLimitsMaxNbConstraintsPN5physx13PxSceneLimitsEj, __ZN14dense_hash_mapIiPKcN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEEixERS9_: __ZN14dense_hash_mapIiPKcN11TypeManager27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS4_4pairIKiS1_EEL18MemLabelIdentifier6ELi16EEEixERS9_, __ZN5physx20solveContactPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx20solveContactPreBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii: __ZN17SharedTextureData17GetImageReferenceEP14ImageReferenceii, __ZNSt3__2L13utf16_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L13utf16_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE, __Z46ParticleSystem_MainModule_CUSTOM_SetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_SetStartSpeedP12Il2CppObjectR15MonoMinMaxCurve, __ZN9ShaderLab21ClearParserStateStackEv: __ZN9ShaderLab21ClearParserStateStackEv, __Z49ParticleEmitter_Set_Custom_PropRndAngularVelocityP12Il2CppObjectf: __Z49ParticleEmitter_Set_Custom_PropRndAngularVelocityP12Il2CppObjectf, __ZN5physx6shdfnd13ReadWriteLock12unlockReaderEv: __ZN5physx6shdfnd13ReadWriteLock12unlockReaderEv, __ZN8Renderer16LayerMaskChangedEv: __ZN8Renderer16LayerMaskChangedEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj445ENS_22PxRepXPropertyAccessorILj445ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj445ENS_22PxRepXPropertyAccessorILj445ES4_ffEEEEvRKT0_, __ZN14Texture2DArray13AwakeFromLoadE17AwakeFromLoadMode: __ZN14Texture2DArray13AwakeFromLoadE17AwakeFromLoadMode, __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14NavMeshCarving14RemoveObstacleERi: __ZN14NavMeshCarving14RemoveObstacleERi, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_, __Z54ParticleAnimator_CUSTOM_INTERNAL_get_localRotationAxisP12Il2CppObjectP8Vector3f: __Z54ParticleAnimator_CUSTOM_INTERNAL_get_localRotationAxisP12Il2CppObjectP8Vector3f, __ZNSt3__215__codecvt_utf16IDsLb0EED0Ev: __ZNSt3__215__codecvt_utf16IDsLb0EED0Ev, __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring: __ZN13WheelCollider19SetSuspensionSpringERK11JointSpring, __ZN28InstanceIdToObjectPtrHashMapC2Ei: __ZN28InstanceIdToObjectPtrHashMapC2Ei, __ZN15ReflectionProbe23VirtualRedirectTransferER14SafeBinaryRead: __ZN15ReflectionProbe23VirtualRedirectTransferER14SafeBinaryRead, __Z44AreaEffector2D_Get_Custom_PropUseGlobalAngleP12Il2CppObject: __Z44AreaEffector2D_Get_Custom_PropUseGlobalAngleP12Il2CppObject, __ZNK6Camera20GetTemporarySettingsER23CameraTemporarySettings: __ZNK6Camera20GetTemporarySettingsER23CameraTemporarySettings, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv, __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ES4_S4_f: __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EC2ES4_S4_f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj121ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj121ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN6ObjectC2E10MemLabelId18ObjectCreationMode: __ZN6ObjectC2E10MemLabelId18ObjectCreationMode, __ZN16CircleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16CircleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN11UnityEngine15PlatformWrapper15GetBuildVersionEv: __ZN11UnityEngine15PlatformWrapper15GetBuildVersionEv, __Z34getPxJoint_RelativeAngularVelocityPKN5physx7PxJointE: __Z34getPxJoint_RelativeAngularVelocityPKN5physx7PxJointE, __Z54Register_UnityEngine_Physics2D_set_alwaysShowCollidersv: __Z54Register_UnityEngine_Physics2D_set_alwaysShowCollidersv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12__invariantsEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12__invariantsEv, __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags, _tcsetpgrp: _tcsetpgrp, __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE: __ZNK11DynamicMesh8FromPolyER13dynamic_arrayI8Vector3fLj4EERKNS_4PolyE, __Z51MeshRenderer_Set_Custom_PropAdditionalVertexStreamsP12Il2CppObjectS0_: __Z51MeshRenderer_Set_Custom_PropAdditionalVertexStreamsP12Il2CppObjectS0_, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13setBreakForceEff, __Z39ConstantForce_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f: __Z39ConstantForce_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK8Vector3f, __ZN5physx6shdfnd8internal9partitionINS_23PxcSolverConstraintDescEKNS_14ConstraintLessEEEiPT_iiRT0_: __ZN5physx6shdfnd8internal9partitionINS_23PxcSolverConstraintDescEKNS_14ConstraintLessEEEiPT_iiRT0_, __ZN18ScriptingArguments9AddIntPtrEPv: __ZN18ScriptingArguments9AddIntPtrEPv, __ZN5physx14NpRigidDynamicD0Ev: __ZN5physx14NpRigidDynamicD0Ev, __Z73Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorStringIndexv: __Z73Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorStringIndexv, __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE8recreateEj, _cf2_stack_getReal: _cf2_stack_getReal, __ZN24RingBufferMemoryFileData11SetBlockingEb: __ZN24RingBufferMemoryFileData11SetBlockingEb, __Z26TransformVerticesInnerLoopILb0ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb0ELb1ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __Z38Material_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf: __Z38Material_CUSTOM_INTERNAL_CALL_SetColorP12Il2CppObjectiRK10ColorRGBAf, __GLOBAL__sub_I_runtime_particlesystem_modules3_lump_cpp: __GLOBAL__sub_I_runtime_particlesystem_modules3_lump_cpp, __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE: __ZNSt3__26__treeINS_12__value_typeINS_4pairIPcS3_EEPFbPvR14SafeBinaryReadEEENS_19__map_value_compareIS4_SA_20smaller_tstring_pairIPKcELb1EEENS_9allocatorISA_EEE7destroyEPNS_11__tree_nodeISA_S5_EE, __Z36setPxSceneDescMaxNbContactDataBlocksPN5physx11PxSceneDescEj: __Z36setPxSceneDescMaxNbContactDataBlocksPN5physx11PxSceneDescEj, __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE: __ZN5physx14NpShapeManager21teardownAllSceneQueryERNS_2Sq17SceneQueryManagerE, __ZNK18ProceduralMaterial17GetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial17GetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, _iswcntrl_l: _iswcntrl_l, __ZN13TargetJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13TargetJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__227__insertion_sort_incompleteIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEbT0_SA_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEbT0_SA_T_, __ZN5physx16PxsBroadPhaseMBP15getDeletedPairsEv: __ZN5physx16PxsBroadPhaseMBP15getDeletedPairsEv, _iscntrl_l: _iscntrl_l, __ZN9SubModule8TransferI17RemapPPtrTransferEEvRT_: __ZN9SubModule8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx10PxsContext18setSolverBatchSizeEj: __ZN5physx10PxsContext18setSolverBatchSizeEj, __ZNK5physx2Cm10Collection8containsERNS_6PxBaseE: __ZNK5physx2Cm10Collection8containsERNS_6PxBaseE, _ccoshl: _ccoshl, __ZNK5physx14NpSpatialIndex5sweepERKNS_9PxBounds3ERKNS_6PxVec3EfRNS_25PxSpatialLocationCallbackE: __ZNK5physx14NpSpatialIndex5sweepERKNS_9PxBounds3ERKNS_6PxVec3EfRNS_25PxSpatialLocationCallbackE, __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationYTilev: __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationYTilev, __Z13RegisterClassI13TrailRendererEvv: __Z13RegisterClassI13TrailRendererEvv, _ccoshf: _ccoshf, __ZN21AnimationClipOverride8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21AnimationClipOverride8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj: __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKj, __ZN13TargetJoint2D16CheckConsistencyEv: __ZN13TargetJoint2D16CheckConsistencyEv, __Z31SetRelaunchApplicationArgumentsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE: __Z31SetRelaunchApplicationArgumentsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE, __ZN11LightProbes14LightProbeDataD2Ev: __ZN11LightProbes14LightProbeDataD2Ev, __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN12_GLOBAL__N_112RenderReaderILb1EE6isGoodEv: __ZN12_GLOBAL__N_112RenderReaderILb1EE6isGoodEv, __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_9StopEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_9StopEventEEEbRT_, __ZN17PersistentManager6UnlockEv: __ZN17PersistentManager6UnlockEv, __Z18Transfer_BlittableI14SafeBinaryReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z11CopyTextureP7TextureiiiiiiS0_iiii: __Z11CopyTextureP7TextureiiiiiiS0_iiii, __Z24RegisterStrippedTypeInfoI26AnimatorOverrideControllerEviPKcS2_: __Z24RegisterStrippedTypeInfoI26AnimatorOverrideControllerEviPKcS2_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findERKS5_j, __ZN13RuntimeStaticI15AnimationBinderE16StaticInitializeEPv: __ZN13RuntimeStaticI15AnimationBinderE16StaticInitializeEPv, __Z24setPxShape_ContactOffsetPN5physx7PxShapeEf: __Z24setPxShape_ContactOffsetPN5physx7PxShapeEf, __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE: __ZNSt3__26__treeINS_12__value_typeIPK6CameraNS_6vectorIfNS_9allocatorIfEEEEEENS_19__map_value_compareIS4_S9_NS_4lessIS4_EELb1EEENS6_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE, __Z24RegisterStrippedTypeInfoI21UnityAnalyticsManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI21UnityAnalyticsManagerEviPKcS2_, __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN20UnityConnectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN20UnityConnectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _llvm_bswap_i32: _llvm_bswap_i32, __ZN20FileSystemEnumerator5MountERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP17FileSystemHandler: __ZN20FileSystemEnumerator5MountERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP17FileSystemHandler, __Z40GUIUtility_CUSTOM_Internal_GetHotControlv: __Z40GUIUtility_CUSTOM_Internal_GetHotControlv, __ZN9AudioClip8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9AudioClip8TransferI24GenerateTypeTreeTransferEEvRT_, _clogf: _clogf, __ZN14PlayerSettings5ResetEv: __ZN14PlayerSettings5ResetEv, __ZN24OcclusionCullingSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN24OcclusionCullingSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __Z18GetDirectorManagerv: __Z18GetDirectorManagerv, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E, __ZNK5physx33PxConvexMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEEEEjT_j: __ZNK5physx33PxConvexMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEEEEjT_j, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRe, __ZN5Umbra15CameraTransformC2Ev: __ZN5Umbra15CameraTransformC2Ev, __ZNSt3__212future_errorC2ENS_10error_codeE: __ZNSt3__212future_errorC2ENS_10error_codeE, __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_SetMatrixv: __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_SetMatrixv, __ZNK28MonoBehaviourPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK28MonoBehaviourPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZNSt3__26locale5__imp12install_fromINS_8messagesIcEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8messagesIcEEEEvRKS1_, _conj: _conj, __Z39getPxClothParticleDataPreviousParticlesPKN5physx19PxClothParticleDataE: __Z39getPxClothParticleDataPreviousParticlesPKN5physx19PxClothParticleDataE, __ZN7mecanim9animation10SampleClipERKNS0_9DenseClipEfPf: __ZN7mecanim9animation10SampleClipERKNS0_9DenseClipEfPf, __ZN5physx7NpScene18updateDirtyShadersEv: __ZN5physx7NpScene18updateDirtyShadersEv, __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN18ProceduralMaterial8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18ProceduralMaterial8TransferI24GenerateTypeTreeTransferEEvRT_, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE8isAsleepEv, __ZL28PxcBruteForceOverlapBackfaceRKN5physx9PxBounds3ES2_RKNS_2Gu13PolygonalDataES6_RKNS_2Cm8Matrix34ESA_RKNS7_23FastVertex2ShapeScalingESD_SA_SA_RKNS_6PxVec3ERjSH_RfRSE_RNS3_14PxcSepAxisTypeEf: __ZL28PxcBruteForceOverlapBackfaceRKN5physx9PxBounds3ES2_RKNS_2Gu13PolygonalDataES6_RKNS_2Cm8Matrix34ESA_RKNS7_23FastVertex2ShapeScalingESD_SA_SA_RKNS_6PxVec3ERjSH_RfRSE_RNS3_14PxcSepAxisTypeEf, __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_, __ZNK12NavMeshAgent17GetGroundPositionEv: __ZNK12NavMeshAgent17GetGroundPositionEv, __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetDampenP12Il2CppObject: __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetDampenP12Il2CppObject, _sethostent: _sethostent, __ZN12_GLOBAL__N_110Connection9setCameraEPKcRKN5physx6PxVec3ES6_S6_: __ZN12_GLOBAL__N_110Connection9setCameraEPKcRKN5physx6PxVec3ES6_S6_, __ZN14RenderSettings8TransferI17RemapPPtrTransferEEvRT_: __ZN14RenderSettings8TransferI17RemapPPtrTransferEEvRT_, __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_get_centerv: __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_get_centerv, __Z62Register_UnityEngine_WheelJoint2D_INTERNAL_CALL_GetMotorTorquev: __Z62Register_UnityEngine_WheelJoint2D_INTERNAL_CALL_GetMotorTorquev, __Z29Animation_Set_Custom_PropClipP12Il2CppObjectS0_: __Z29Animation_Set_Custom_PropClipP12Il2CppObjectS0_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN24b2ChainAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN24b2ChainAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN5physx2Sn4peekEiPKci: __ZN5physx2Sn4peekEiPKci, _UNITY_ft_smooth_lcd_renderer_class_pic_free: _UNITY_ft_smooth_lcd_renderer_class_pic_free, __ZL19InitializeModule_AIv: __ZL19InitializeModule_AIv, __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE: __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15MatrixParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE, __ZN9Scripting28RaiseObjectDisposedExceptionEPKcS1_: __ZN9Scripting28RaiseObjectDisposedExceptionEPKcS1_, __Z48Register_UnityEngine_ReflectionProbe_get_texturev: __Z48Register_UnityEngine_ReflectionProbe_get_texturev, __ZN16b2BlockAllocator8AllocateEi: __ZN16b2BlockAllocator8AllocateEi, __Z45Register_UnityEngine_RemoteSettings_GetStringv: __Z45Register_UnityEngine_RemoteSettings_GetStringv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRt, __Z56setPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf: __Z56setPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf, __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE8__appendEj, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZN8Animator23VirtualRedirectTransferER14SafeBinaryRead: __ZN8Animator23VirtualRedirectTransferER14SafeBinaryRead, __ZN12GUIClipState5ApplyER10InputEventR7GUIClip: __ZN12GUIClipState5ApplyER10InputEventR7GUIClip, __ZN5physx16PxVehicleDriveNW17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx16PxVehicleDriveNW17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj617ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZv, __Z40AudioChorusFilter_Set_Custom_PropWetMix1P12Il2CppObjectf: __Z40AudioChorusFilter_Set_Custom_PropWetMix1P12Il2CppObjectf, __ZN13MonoBehaviour14GetOrCreateDSPEv: __ZN13MonoBehaviour14GetOrCreateDSPEv, __Z23scripting_type_get_namePK10Il2CppType: __Z23scripting_type_get_namePK10Il2CppType, __Z33setPxSceneDescNbContactDataBlocksPN5physx11PxSceneDescEj: __Z33setPxSceneDescNbContactDataBlocksPN5physx11PxSceneDescEj, __ZNKSt3__223__future_error_category7messageEi: __ZNKSt3__223__future_error_category7messageEi, __Z30TransferField_LinearCollectionI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN13MonoBehaviour34StopCoroutineFromEnumeratorManagedEP12Il2CppObject: __ZN13MonoBehaviour34StopCoroutineFromEnumeratorManagedEP12Il2CppObject, __ZN8Animator21ProcessAnimationsStepEv: __ZN8Animator21ProcessAnimationsStepEv, __Z38SpringJoint_Get_Custom_PropMinDistanceP12Il2CppObject: __Z38SpringJoint_Get_Custom_PropMinDistanceP12Il2CppObject, __ZN5physx3Scb5Shape11setGeometryERKNS_10PxGeometryE: __ZN5physx3Scb5Shape11setGeometryERKNS_10PxGeometryE, __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j: __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j, __Z52ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve: __Z52ParticleSystem_EmissionModule_CUSTOM_GetRateOverTimeP12Il2CppObjectR15MonoMinMaxCurve, __ZN13InitialModuleC2Ev: __ZN13InitialModuleC2Ev, __Z31getPxVehicleDriveDynData_GearUpPKN5physx21PxVehicleDriveDynDataE: __Z31getPxVehicleDriveDynData_GearUpPKN5physx21PxVehicleDriveDynDataE, __ZNK10SampleClip26GetTypeInfoVirtualInternalEv: __ZNK10SampleClip26GetTypeInfoVirtualInternalEv, __Z27getPxBoxGeometryHalfExtentsPKN5physx13PxBoxGeometryE: __Z27getPxBoxGeometryHalfExtentsPKN5physx13PxBoxGeometryE, __ZN5physx2Gu21intersectPlaneCapsuleERKNS0_7CapsuleERKNS_7PxPlaneE: __ZN5physx2Gu21intersectPlaneCapsuleERKNS0_7CapsuleERKNS_7PxPlaneE, __ZN14RenderSettings17SetSkyboxMaterialEP8Material: __ZN14RenderSettings17SetSkyboxMaterialEP8Material, __ZN13MonoBehaviour23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13MonoBehaviour23VirtualRedirectTransferER17RemapPPtrTransfer, _tt_sbit_decoder_load_compound: _tt_sbit_decoder_load_compound, __ZN12SoundManager10UnloadClipEP10SampleClip: __ZN12SoundManager10UnloadClipEP10SampleClip, __ZN11TypeManager32RegisterReservedPersistentTypeIDEiPKc: __ZN11TypeManager32RegisterReservedPersistentTypeIDEiPKc, __Z54Register_UnityEngine_Mesh_GetAllocArrayFromChannelImplv: __Z54Register_UnityEngine_Mesh_GetAllocArrayFromChannelImplv, __Z18Transfer_BlittableI8JSONReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx8debugger18MemPvdOutputStreamD2Ev: __ZN5physx8debugger18MemPvdOutputStreamD2Ev, __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11MinMaxCurve8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sn16writeStrideFlagsINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEPFRKS5_PS6_jEEEvRNS_9XmlWriterERNS_12MemoryBufferEjRNS_16PxStrideIteratorIKT_EET0_jPKcPKNS_11PxU32ToNameE: __ZN5physx2Sn16writeStrideFlagsINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEPFRKS5_PS6_jEEEvRNS_9XmlWriterERNS_12MemoryBufferEjRNS_16PxStrideIteratorIKT_EET0_jPKcPKNS_11PxU32ToNameE, __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE8recreateEj, __ZN13GfxDeviceNull19SetProjectionMatrixERK10Matrix4x4f: __ZN13GfxDeviceNull19SetProjectionMatrixERK10Matrix4x4f, __ZN5physx22PxVehicleWheelsDynData4copyERKS0_jj: __ZN5physx22PxVehicleWheelsDynData4copyERKS0_jj, __ZN10MonoScript7ReleaseEv: __ZN10MonoScript7ReleaseEv, __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE: __ZNK13TranslateGLES13GetFormatDescEN2gl9TexFormatE, _iswgraph_l: _iswgraph_l, __ZN8Animator18PrepareForPlaybackEv: __ZN8Animator18PrepareForPlaybackEv, __Z59Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_Containsv: __Z59Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_Containsv, __Z23AudioSource_CUSTOM_StopP12Il2CppObject: __Z23AudioSource_CUSTOM_StopP12Il2CppObject, __ZN5physx15NpParticleFluid23setRestParticleDistanceEf: __ZN5physx15NpParticleFluid23setRestParticleDistanceEf, __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekoffExNS_8ios_base7seekdirEj: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekoffExNS_8ios_base7seekdirEj, __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf: __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPjRf, __ZN11AssetBundle23VirtualRedirectTransferER14SafeBinaryRead: __ZN11AssetBundle23VirtualRedirectTransferER14SafeBinaryRead, __Z41AudioClip_Get_Custom_PropPreloadAudioDataP12Il2CppObject: __Z41AudioClip_Get_Custom_PropPreloadAudioDataP12Il2CppObject, __Z53Register_UnityEngine_PlatformEffector2D_get_useOneWayv: __Z53Register_UnityEngine_PlatformEffector2D_get_useOneWayv, __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalVectorP12Il2CppObjectiRK8Vector4f: __Z50CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalVectorP12Il2CppObjectiRK8Vector4f, _iconv_open: _iconv_open, __ZN5physx14SingleAABBTask11runInternalEv: __ZN5physx14SingleAABBTask11runInternalEv, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXv, __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj: __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj, __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab16FastPropertyName8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx6shdfnd7FastXml8Callback21processXmlDeclarationERKNS1_14AttributePairsEPKci: __ZN5physx6shdfnd7FastXml8Callback21processXmlDeclarationERKNS1_14AttributePairsEPKci, __ZN10AudioMixer7CleanupEv: __ZN10AudioMixer7CleanupEv, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13TargetJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13TargetJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19ParticleSystemState8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4FMOD12ChannelGroup7getMuteEPb: __ZN4FMOD12ChannelGroup7getMuteEPb, __ZN24GenerateTypeTreeTransfer22AssertOptimizeTransferEi: __ZN24GenerateTypeTreeTransfer22AssertOptimizeTransferEi, __ZN5physx13PxParticleExt15buildBoundsHashEPjPNS0_14ParticleBoundsERKNS_16PxStrideIteratorIKNS_6PxVec3EEEjPKjjjf: __ZN5physx13PxParticleExt15buildBoundsHashEPjPNS0_14ParticleBoundsERKNS_16PxStrideIteratorIKNS_6PxVec3EEEjPKjjjf, __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyIfEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE, __ZN17SizeBySpeedModule5ResetEv: __ZN17SizeBySpeedModule5ResetEv, __ZN10MonoScript15ThreadedCleanupEv: __ZN10MonoScript15ThreadedCleanupEv, __ZN11AudioSource24SetOutputAudioMixerGroupE4PPtrI15AudioMixerGroupE: __ZN11AudioSource24SetOutputAudioMixerGroupE4PPtrI15AudioMixerGroupE, __ZN13LoadOperation19IntegrateMainThreadEv: __ZN13LoadOperation19IntegrateMainThreadEv, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZN13MemoryManager16ThreadInitializeEj: __ZN13MemoryManager16ThreadInitializeEj, __ZN15TerrainCollider8TransferI14SafeBinaryReadEEvRT_: __ZN15TerrainCollider8TransferI14SafeBinaryReadEEvRT_, __Z48Register_UnityEngine_Renderer_get_receiveShadowsv: __Z48Register_UnityEngine_Renderer_get_receiveShadowsv, __ZN13dynamic_arrayI10ColorRGBAfLj4EEC2ERKS1_: __ZN13dynamic_arrayI10ColorRGBAfLj4EEC2ERKS1_, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags, __Z63Register_UnityEngine_Audio_AudioMixer_set_outputAudioMixerGroupv: __Z63Register_UnityEngine_Audio_AudioMixer_set_outputAudioMixerGroupv, __ZN11UnityEngine9Animation23SetBoundCurveFloatValueERKNS0_10BoundCurveEf: __ZN11UnityEngine9Animation23SetBoundCurveFloatValueERKNS0_10BoundCurveEf, _mkstemps: _mkstemps, __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN15ParticleEmitter10SetEnabledEb: __ZN15ParticleEmitter10SetEnabledEb, __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularZLimitP12Il2CppObjectRK14SoftJointLimit: __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularZLimitP12Il2CppObjectRK14SoftJointLimit, _fstatvfs: _fstatvfs, __ZN8Material14SetOverrideTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN8Material14SetOverrideTagERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE15growAndPushBackERKS6_: __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE15growAndPushBackERKS6_, __ZN15TerrainRenderer15GetNodePositionER12QuadTreeNode: __ZN15TerrainRenderer15GetNodePositionER12QuadTreeNode, __ZN7mecanim12statemachine20StateMachineConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine20StateMachineConstant8TransferI14SafeBinaryReadEEvRT_, __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12MeshCollider16TransformChangedEi: __ZN12MeshCollider16TransformChangedEi, __ZN11UnityEngine15PlatformWrapper32GetLocalTimeOffsetInMillisecondsEv: __ZN11UnityEngine15PlatformWrapper32GetLocalTimeOffsetInMillisecondsEv, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j, _setlocale: _setlocale, __ZN14PlayerSettings10SmartResetEv: __ZN14PlayerSettings10SmartResetEv, __Z54Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTry2Dv: __Z54Register_UnityEngine_Camera_INTERNAL_CALL_RaycastTry2Dv, __Z20MarkInstanceIDAsRootiR21GarbageCollectorState: __Z20MarkInstanceIDAsRootiR21GarbageCollectorState, __ZN2UI6Canvas13SetRenderModeENS0_10RenderModeE: __ZN2UI6Canvas13SetRenderModeENS0_10RenderModeE, __Z38HingeJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D: __Z38HingeJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D, __Z39AnimationState_Get_Custom_PropBlendModeP12Il2CppObject: __Z39AnimationState_Get_Custom_PropBlendModeP12Il2CppObject, __ZN5physx3Cct13HandleManager12UpdateObjectEjPv: __ZN5physx3Cct13HandleManager12UpdateObjectEjPv, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv, __ZN16BlendShapeVertex8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16BlendShapeVertex8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZL26GeomOverlapCallback_BoxBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL26GeomOverlapCallback_BoxBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_: __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES6_, __ZN5Umbra10StackAllocC2ERS0_: __ZN5Umbra10StackAllocC2ERS0_, __ZN6Shader27MarkShaderStateNotSupportedEPKS_: __ZN6Shader27MarkShaderStateNotSupportedEPKS_, __ZNK5physx12PxConstraint8isKindOfEPKc: __ZNK5physx12PxConstraint8isKindOfEPKc, __Z48HingeJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf: __Z48HingeJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEvPT_jRKT0_RKT1_j, __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI9JSONWriteEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __Z28DeoptimizeTransformHierarchyR10GameObject: __Z28DeoptimizeTransformHierarchyR10GameObject, __ZN9AudioClip8WWWCloseEPvS0_: __ZN9AudioClip8WWWCloseEPvS0_, __ZN12IFileAdapter4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN12IFileAdapter4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __ZN5physx24PxRigidBodyGeneratedInfoC2Ev: __ZN5physx24PxRigidBodyGeneratedInfoC2Ev, __Z62Register_UnityEngine_Transform_INTERNAL_get_localToWorldMatrixv: __Z62Register_UnityEngine_Transform_INTERNAL_get_localToWorldMatrixv, __Z31RectOffset_Set_Custom_PropRightP12Il2CppObjecti: __Z31RectOffset_Set_Custom_PropRightP12Il2CppObjecti, __Z70Register_UnityEngine_ParticleSystem_ShapeModule_GetSkinnedMeshRendererv: __Z70Register_UnityEngine_ParticleSystem_ShapeModule_GetSkinnedMeshRendererv, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE12removeClientERNS_19PxProfileZoneClientE, __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject: __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject, __Z48WheelJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf: __Z48WheelJoint2D_CUSTOM_INTERNAL_CALL_GetMotorTorqueP12Il2CppObjectf, __ZN14SharedMeshDataD2Ev: __ZN14SharedMeshDataD2Ev, __ZN18ProceduralMaterial19SetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP9Texture2D: __ZN18ProceduralMaterial19SetSubstanceTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP9Texture2D, __Z39getPxParticleBase_ParticleReadDataFlagsPKN5physx14PxParticleBaseE: __Z39getPxParticleBase_ParticleReadDataFlagsPKN5physx14PxParticleBaseE, __ZN9GfxDevice18GetNativeGfxDeviceEv: __ZN9GfxDevice18GetNativeGfxDeviceEv, __Z17GetBuildTimestampv: __Z17GetBuildTimestampv, __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_S2_S2_b: __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_S2_S2_b, __ZN4crnd10dxt5_block17get_block_values6EPjjj: __ZN4crnd10dxt5_block17get_block_values6EPjjj, _UNITY_png_read_end: _UNITY_png_read_end, __ZN18ProceduralMaterial7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18ProceduralMaterial7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx2Cm10Collection10getObjectsEPPNS_6PxBaseEjj: __ZNK5physx2Cm10Collection10getObjectsEPPNS_6PxBaseEjj, __Z35setPxHeightFieldGeometryHeightFieldPN5physx21PxHeightFieldGeometryEPNS_13PxHeightFieldE: __Z35setPxHeightFieldGeometryHeightFieldPN5physx21PxHeightFieldGeometryEPNS_13PxHeightFieldE, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEbT0_S6_T_, __ZN5physx17ConvexMeshBuilder12loadFromDescERKNS_16PxConvexMeshDescENS_10PxPlatform4EnumE: __ZN5physx17ConvexMeshBuilder12loadFromDescERKNS_16PxConvexMeshDescENS_10PxPlatform4EnumE, __ZNSt3__211__stdoutbufIcE8overflowEi: __ZNSt3__211__stdoutbufIcE8overflowEi, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __Z20RegisterModule_IMGUIv: __Z20RegisterModule_IMGUIv, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7getMassEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE7getMassEv, __Z37LocationService_Get_Custom_PropStatusP12Il2CppObject: __Z37LocationService_Get_Custom_PropStatusP12Il2CppObject, __ZN4FMOD5Sound18set3DCustomRolloffEP11FMOD_VECTORi: __ZN4FMOD5Sound18set3DCustomRolloffEP11FMOD_VECTORi, __ZN16ReflectionProbes6UpdateEv: __ZN16ReflectionProbes6UpdateEv, __Z26TransformVerticesInnerLoopILb0ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb0ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __ZN13UnityProfiler23SetActiveSeparateThreadEb: __ZN13UnityProfiler23SetActiveSeparateThreadEb, __Z9RecordJobPFvPvES_R21SingleThreadedJobInfo: __Z9RecordJobPFvPvES_R21SingleThreadedJobInfo, _write_file_header: _write_file_header, __ZNK11b2GearJoint17GetReactionTorqueEf: __ZNK11b2GearJoint17GetReactionTorqueEf, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEbT0_S7_T_, __Z53Register_UnityEngine_ParticleSystemRenderer_SetMeshesv: __Z53Register_UnityEngine_ParticleSystemRenderer_SetMeshesv, __ZN13AvatarBuilder17GenerateAvatarMapERK10GameObjectRNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEES9_RK16HumanDescription10AvatarTypebRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE: __ZN13AvatarBuilder17GenerateAvatarMapERK10GameObjectRNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEES9_RK16HumanDescription10AvatarTypebRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE, __ZN5Umbra4Math4ceilENS_5FloatE: __ZN5Umbra4Math4ceilENS_5FloatE, __ZN18DeferredRenderLoop24AddReflectionsToEmissionEP13RenderTextureS1_: __ZN18DeferredRenderLoop24AddReflectionsToEmissionEP13RenderTextureS1_, __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z19UnsignedIntToStringj: __Z19UnsignedIntToStringj, _i64Subtract: _i64Subtract, __ZN12HandlerChain16DestroyFileEntryER13FileEntryData: __ZN12HandlerChain16DestroyFileEntryER13FileEntryData, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7setNameEPKc, __ZN13BoneInfluence8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13BoneInfluence8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z27Animator_CUSTOM_ResolveHashP12Il2CppObjecti: __Z27Animator_CUSTOM_ResolveHashP12Il2CppObjecti, __ZN13BaseAllocatorD2Ev: __ZN13BaseAllocatorD2Ev, __ZN4FMOD8ChannelI15getSystemObjectEPPNS_6SystemE: __ZN4FMOD8ChannelI15getSystemObjectEPPNS_6SystemE, __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff: __ZN19ShaderPropertySheet26SetTextureWithExplicitSizeERKN9ShaderLab16FastPropertyNameE9TextureIDiiff, __ZN39AssetBundleLoadFromMemoryAsyncOperationD0Ev: __ZN39AssetBundleLoadFromMemoryAsyncOperationD0Ev, __ZN5physx13ActorAABBTaskC2Ev: __ZN5physx13ActorAABBTaskC2Ev, __ZN17ProfilerFrameData19FreeAllTimerQueriesEv: __ZN17ProfilerFrameData19FreeAllTimerQueriesEv, __ZN5Umbra12PortalCuller4initEbbRKNS_4AABBEi: __ZN5Umbra12PortalCuller4initEbbRKNS_4AABBEi, __ZNK9Rigidbody17GetFreezeRotationEv: __ZNK9Rigidbody17GetFreezeRotationEv, __Z44Register_UnityEngine_AI_OffMeshLink_set_areav: __Z44Register_UnityEngine_AI_OffMeshLink_set_areav, _frexpl: _frexpl, __ZN19SkinnedMeshRenderer11PrepareSkinEiP18JobBatchDispatcher: __ZN19SkinnedMeshRenderer11PrepareSkinEiP18JobBatchDispatcher, _UNITY_png_free_jmpbuf: _UNITY_png_free_jmpbuf, _frexpf: _frexpf, __ZN15PolynomialCurve9IntegrateEv: __ZN15PolynomialCurve9IntegrateEv, __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalVectoriRK8Vector4f: __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalVectoriRK8Vector4f, __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fPS2_i: __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fPS2_i, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags, __ZN9WWWCached10IsDoneImplEv: __ZN9WWWCached10IsDoneImplEv, __ZN17Physics2DSettings20SetContactArrowScaleEf: __ZN17Physics2DSettings20SetContactArrowScaleEf, __ZN19ComputeShaderKernel8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19ComputeShaderKernel8TransferI24GenerateTypeTreeTransferEEvRT_, ___mkostemps: ___mkostemps, _cff_decoder_init: _cff_decoder_init, __Z44Physics2D_Set_Custom_PropMaxTranslationSpeedf: __Z44Physics2D_Set_Custom_PropMaxTranslationSpeedf, __ZN6Shader15ThreadedCleanupEv: __ZN6Shader15ThreadedCleanupEv, __Z23ConvertIntegerToTypePtrIiEbPvR14SafeBinaryRead: __Z23ConvertIntegerToTypePtrIiEbPvR14SafeBinaryRead, __ZN13AnimationClip9PPtrCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13AnimationClip9PPtrCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj532ENS_22PxRepXPropertyAccessorILj532ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj532ENS_22PxRepXPropertyAccessorILj532ES4_jjEEEEvjRKT0_, __Z46Register_UnityEngine_AnimationState_set_weightv: __Z46Register_UnityEngine_AnimationState_set_weightv, __Z23EndsWithCaseInsensitivePKcjS0_j: __Z23EndsWithCaseInsensitivePKcjS0_j, __ZN17SurfaceEffector2D14SetUseFrictionEb: __ZN17SurfaceEffector2D14SetUseFrictionEb, __ZN7dtCrowd19UpdateProximityGridEv: __ZN7dtCrowd19UpdateProximityGridEv, _raccess_guess_linux_double: _raccess_guess_linux_double, __ZN24DownloadHandlerAudioClip12GetAudioClipEv: __ZN24DownloadHandlerAudioClip12GetAudioClipEv, __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointAllv: __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointAllv, __ZN16MessageForwarder17WillHandleMessageEPvRK17MessageIdentifier: __ZN16MessageForwarder17WillHandleMessageEPvRK17MessageIdentifier, __Z20RegisterBuiltinTypesv: __Z20RegisterBuiltinTypesv, __ZN5physx3Ext13DistanceJoint12setToleranceEf: __ZN5physx3Ext13DistanceJoint12setToleranceEf, __ZN12CubemapArray19AllocateTextureDataEib: __ZN12CubemapArray19AllocateTextureDataEib, __ZN5physx7Cooking15cookHeightFieldERKNS_17PxHeightFieldDescERNS_14PxOutputStreamE: __ZN5physx7Cooking15cookHeightFieldERKNS_17PxHeightFieldDescERNS_14PxOutputStreamE, __Z43Register_UnityEngine_CullingGroup_IsVisiblev: __Z43Register_UnityEngine_CullingGroup_IsVisiblev, __ZN5physx27PxRigidStaticRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx27PxRigidStaticRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN8Animator12CreateObjectEv: __ZN8Animator12CreateObjectEv, __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI10GameObjectE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Unity17ConfigurableJoint10SetXMotionEi: __ZN5Unity17ConfigurableJoint10SetXMotionEi, __Z34Register_UnityEngine_GUIStyle_Initv: __Z34Register_UnityEngine_GUIStyle_Initv, __ZN5physx2Sc13ConstraintSim14postFlagChangeENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEES5_: __ZN5physx2Sc13ConstraintSim14postFlagChangeENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEES5_, __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj, __Z38Rigidbody2D_Get_Custom_PropConstraintsP12Il2CppObject: __Z38Rigidbody2D_Get_Custom_PropConstraintsP12Il2CppObject, __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5Umbra9IndexListC2ERKS0_: __ZN5Umbra9IndexListC2ERKS0_, __ZN15CollisionModule9FreeCacheER19ParticleSystemState: __ZN15CollisionModule9FreeCacheER19ParticleSystemState, __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb: __ZN5physx2Gu3EPA16PenetrationDepthERKNS0_7ConvexVES4_PNS0_17EPASupportMapPairEPKNS_6shdfnd3aos5Vec3VESB_SB_iRS9_SC_SC_RNS8_6FloatVEb, __Z18StripAllWhitespaceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18StripAllWhitespaceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx2Sc8ShapeSim20createTransformCacheERNS_17PxsTransformCacheE: __ZN5physx2Sc8ShapeSim20createTransformCacheERNS_17PxsTransformCacheE, __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalTransactionv: __Z72Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalTransactionv, __Z45Register_UnityEngine_Camera_get_targetTexturev: __Z45Register_UnityEngine_Camera_get_targetTexturev, __ZN11Rigidbody2D17UpdateConstraintsEb: __ZN11Rigidbody2D17UpdateConstraintsEb, __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_R4Mesh: __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb0EEEEvRT_R4Mesh, __Z54Register_UnityEngine_GameObject_FindGameObjectsWithTagv: __Z54Register_UnityEngine_GameObject_FindGameObjectsWithTagv, __Z38Register_UnityEngine_WindZone_set_modev: __Z38Register_UnityEngine_WindZone_set_modev, __ZN5physx6shdfnd12getAllocatorEv: __ZN5physx6shdfnd12getAllocatorEv, __ZN4FMOD8ChannelI8getIndexEPi: __ZN4FMOD8ChannelI8getIndexEPi, __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimDataNWEEEEEEEjT_j: __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimDataNWEEEEEEEjT_j, __ZN5physx9NpFactory14createInstanceEv: __ZN5physx9NpFactory14createInstanceEv, __Z15GetAllArgumentsv: __Z15GetAllArgumentsv, _UNITY_png_do_swap: _UNITY_png_do_swap, __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai: __Z21StoreShadowMapInCacheP14ShadowMapCacheRK17ShadowCachingDatai, __ZNK5Umbra15CameraTransform15getMatrixFormatEv: __ZNK5Umbra15CameraTransform15getMatrixFormatEv, __Z35Texture2DArray_Get_Custom_PropDepthP12Il2CppObject: __Z35Texture2DArray_Get_Custom_PropDepthP12Il2CppObject, __ZNK5physx13NpClothFabric16getTetherAnchorsEPjj: __ZNK5physx13NpClothFabric16getTetherAnchorsEPjj, __Z24getPxScene_ArticulationsPKN5physx7PxSceneEPPNS_14PxArticulationEj: __Z24getPxScene_ArticulationsPKN5physx7PxSceneEPPNS_14PxArticulationEj, __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE6resizeEjRKS3_, __ZN5physx15PxGeometryQuery7raycastERKNS_6PxVec3ES3_RKNS_10PxGeometryERKNS_11PxTransformEfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEb: __ZN5physx15PxGeometryQuery7raycastERKNS_6PxVec3ES3_RKNS_10PxGeometryERKNS_11PxTransformEfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEb, __ZNK17FileSystemHandler12GetAssetGUIDERK13FileEntryData: __ZNK17FileSystemHandler12GetAssetGUIDERK13FileEntryData, __ZN13GfxDeviceNull17DestroySubProgramEPN9ShaderLab10SubProgramE: __ZN13GfxDeviceNull17DestroySubProgramEPN9ShaderLab10SubProgramE, __ZN9Heightmap14CleanupPhysicsEv: __ZN9Heightmap14CleanupPhysicsEv, __ZN5physx2Cm12RenderBufferD2Ev: __ZN5physx2Cm12RenderBufferD2Ev, __ZN20TextRenderingPrivate17TextMeshGenerator17GetCursorPositionERK5RectTIfEi: __ZN20TextRenderingPrivate17TextMeshGenerator17GetCursorPositionERK5RectTIfEi, __ZN37AssetBundleLoadFromFileAsyncOperation20ExecuteSynchronouslyEv: __ZN37AssetBundleLoadFromFileAsyncOperation20ExecuteSynchronouslyEv, __Z38Application_Get_Custom_PropSandboxTypev: __Z38Application_Get_Custom_PropSandboxTypev, __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN9Rigidbody4MoveERK8Vector3fRK11Quaternionf: __ZN9Rigidbody4MoveERK8Vector3fRK11Quaternionf, __ZNSt3__26locale5__imp7installINS_12ctype_bynameIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_12ctype_bynameIcEEEEvPT_, __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z52Register_UnityEngine_AudioReverbZone_get_reflectionsv: __Z52Register_UnityEngine_AudioReverbZone_get_reflectionsv, __ZL20DidChangeActiveSceneP10UnitySceneS0_: __ZL20DidChangeActiveSceneP10UnitySceneS0_, __ZN5physx26PxConvexMeshRepXSerializerD0Ev: __ZN5physx26PxConvexMeshRepXSerializerD0Ev, __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc: __ZN7ApiGLES12CreateShaderEN2gl11ShaderStageEPKc, __ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv: __ZN20TextRenderingPrivate19NativeTextGenerator8WordWrapEv, __ZNK23LODTreeInstanceRenderer11GetMaterialEi: __ZNK23LODTreeInstanceRenderer11GetMaterialEi, __ZN14EmissionModuleD0Ev: __ZN14EmissionModuleD0Ev, __Z22SetMaterialMatrixArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z22SetMaterialMatrixArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __ZNK11b2EdgeShape11ComputeMassEP10b2MassDataf: __ZNK11b2EdgeShape11ComputeMassEP10b2MassDataf, __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev: __ZN5physx36PxJointAngularLimitPairGeneratedInfoC2Ev, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZNK10Effector2D14IgnoreContactsEv: __ZNK10Effector2D14IgnoreContactsEv, __ZN13GfxDeviceGLES21ProcessPendingMipGensEv: __ZN13GfxDeviceGLES21ProcessPendingMipGensEv, __ZNK5physx6shdfnd10Foundation12getAllocatorEv: __ZNK5physx6shdfnd10Foundation12getAllocatorEv, __ZN11UnityEngine15CloudWebService16SessionContainer17ResetArchivedFileERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer17ResetArchivedFileERK8UnityStr, __ZgtRK8Scalar4fS1_: __ZgtRK8Scalar4fS1_, __Z20HandleSteppedTangentRK11KeyframeTplI11QuaternionfES3_RS0_: __Z20HandleSteppedTangentRK11KeyframeTplI11QuaternionfES3_RS0_, __Z25getPxPhysics_HeightFieldsPKN5physx9PxPhysicsEPPNS_13PxHeightFieldEj: __Z25getPxPhysics_HeightFieldsPKN5physx9PxPhysicsEPPNS_13PxHeightFieldEj, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9copy_fromERKSL_j: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9copy_fromERKSL_j, __Z18Transfer_BlittableI8JSONReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL30CleanupModule_CloudWebServicesv: __ZL30CleanupModule_CloudWebServicesv, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi: __ZNSt3__215__inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeEi, __Z50WheelCollider_Get_Custom_PropForceAppPointDistanceP12Il2CppObject: __Z50WheelCollider_Get_Custom_PropForceAppPointDistanceP12Il2CppObject, __ZN17GeneralConnection25RegisterConnectionHandlerEPFvjE: __ZN17GeneralConnection25RegisterConnectionHandlerEPFvjE, __ZL25ProgramUniformMatrix3x4fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix3x4fvPK7ApiGLESjiihPKv, __Z37setPxArticulationJoint_TargetVelocityPN5physx19PxArticulationJointERKNS_6PxVec3E: __Z37setPxArticulationJoint_TargetVelocityPN5physx19PxArticulationJointERKNS_6PxVec3E, __ZN14PhysicsManager15InitializeClassEv: __ZN14PhysicsManager15InitializeClassEv, __Z43Register_UnityEngine_AnimationCurve_SetKeysv: __Z43Register_UnityEngine_AnimationCurve_SetKeysv, __ZN12FixedJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12FixedJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPNS_3Cct10ControllerENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Cct10ControllerENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN4FMOD6System9getOutputEP15FMOD_OUTPUTTYPE: __ZN4FMOD6System9getOutputEP15FMOD_OUTPUTTYPE, __ZNK22GenericPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK22GenericPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZNK9dtNavMesh24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyPKfPf: __ZNK9dtNavMesh24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyPKfPf, __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st: __ZNK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st, __ZN12_GLOBAL__N_120DefaultAssertHandlerD0Ev: __ZN12_GLOBAL__N_120DefaultAssertHandlerD0Ev, __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurveMultiplierv: __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetCurveMultiplierv, __ZN5physx3Ext20computeSphereDensityEff: __ZN5physx3Ext20computeSphereDensityEff, __ZN5Umbra8QueryExt10setWorkMemEPhj: __ZN5Umbra8QueryExt10setWorkMemEPhj, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16GetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE16GetRequestHeaderERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE, __ZN21DownloadHandlerBufferC2Ev: __ZN21DownloadHandlerBufferC2Ev, _tmpnam: _tmpnam, __ZN27TimeSliceAwakeFromLoadQueue19IntegrateTimeSlicedEi: __ZN27TimeSliceAwakeFromLoadQueue19IntegrateTimeSlicedEi, __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN23SharedMeshRenderingData6UnloadEv: __ZN23SharedMeshRenderingData6UnloadEv, __ZN14SplatPrototype8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14SplatPrototype8TransferI24GenerateTypeTreeTransferEEvRT_, __Z45Register_UnityEngine_ReflectionProbe_set_typev: __Z45Register_UnityEngine_ReflectionProbe_set_typev, __ZN14AnimationState8SetSpeedEf: __ZN14AnimationState8SetSpeedEf, __Z38Input_Get_Custom_PropCompensateSensorsv: __Z38Input_Get_Custom_PropCompensateSensorsv, __Z25Light_Get_Custom_PropTypeP12Il2CppObject: __Z25Light_Get_Custom_PropTypeP12Il2CppObject, __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx8debugger4comm21CreatePropertyMessage9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm21CreatePropertyMessage9serializeERNS1_15EventSerializerE, __ZNSt3__23mapIiP15MonoScriptCacheNS_4lessIiEE13stl_allocatorINS_4pairIKiS2_EEL18MemLabelIdentifier76ELi16EEEixERS7_: __ZNSt3__23mapIiP15MonoScriptCacheNS_4lessIiEE13stl_allocatorINS_4pairIKiS2_EEL18MemLabelIdentifier76ELi16EEEixERS7_, __Z42SkinnedMeshRenderer_RenderWithLastPositionRK15RenderNodeQueuejRK14ChannelAssignsi: __Z42SkinnedMeshRenderer_RenderWithLastPositionRK15RenderNodeQueuejRK14ChannelAssignsi, __ZN16UploadHandlerRawC2EPKvj: __ZN16UploadHandlerRawC2EPKvj, __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10JointDrive8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14PhysicsManager6onWakeEPPN5physx7PxActorEj: __ZN14PhysicsManager6onWakeEPPN5physx7PxActorEj, _UNITY_LZ4_createStream: _UNITY_LZ4_createStream, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE13isSubordinateEv, __ZN18ScriptingArguments12InMonoFormatEv: __ZN18ScriptingArguments12InMonoFormatEv, __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij: __ZN12VRGfxHelpers19RenderOcclusionMeshEPfPij, __Z58Register_UnityEngine_ParticleSystem_MainModule_GetDurationv: __Z58Register_UnityEngine_ParticleSystem_MainModule_GetDurationv, __ZNSt3__215__codecvt_utf16IwLb0EED0Ev: __ZNSt3__215__codecvt_utf16IwLb0EED0Ev, __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_12PxDebugPointENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5Umbra18ReceiverMaskBufferC2Ev: __ZN5Umbra18ReceiverMaskBufferC2Ev, __ZN9BoxPrunerD2Ev: __ZN9BoxPrunerD2Ev, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7setNameEPKc, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED0Ev, __Z49Register_UnityEngine_Physics_INTERNAL_get_gravityv: __Z49Register_UnityEngine_Physics_INTERNAL_get_gravityv, __Z37AndroidJNI_CUSTOM_SetStaticShortField13Il2Cpp_IntPtrS_s: __Z37AndroidJNI_CUSTOM_SetStaticShortField13Il2Cpp_IntPtrS_s, __ZNK8VRDevice9GetAspectEv: __ZNK8VRDevice9GetAspectEv, __Z34Register_UnityEngine_Animator_Playv: __Z34Register_UnityEngine_Animator_Playv, __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __Z43Register_UnityEngine_TerrainData_GetHeightsv: __Z43Register_UnityEngine_TerrainData_GetHeightsv, __ZN13GfxDeviceGLES17ApplyBackfaceModeEv: __ZN13GfxDeviceGLES17ApplyBackfaceModeEv, __ZNKSt3__215__codecvt_utf16IwLb0EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_: __ZNKSt3__215__codecvt_utf16IwLb0EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_, __ZN5physx16PxParticleSystemD0Ev: __ZN5physx16PxParticleSystemD0Ev, __Z42TrailRenderer_Get_Custom_PropColorGradientP12Il2CppObject: __Z42TrailRenderer_Get_Custom_PropColorGradientP12Il2CppObject, __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayPvPy: __ZN20LocalFileSystemPosix4ReadER13FileEntryDatayPvPy, __ZN13DrawImmediate6VertexEfff: __ZN13DrawImmediate6VertexEfff, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx3Ext7D6Joint13getSwingLimitEv: __ZNK5physx3Ext7D6Joint13getSwingLimitEv, __ZNK12TLSAllocatorI14StackAllocatorE19GetRequestedPtrSizeEPKv: __ZNK12TLSAllocatorI14StackAllocatorE19GetRequestedPtrSizeEPKv, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4initEPNS_15basic_streambufIcS2_EE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4initEPNS_15basic_streambufIcS2_EE, __ZN5physx15NpActorTemplateINS_7PxClothEED0Ev: __ZN5physx15NpActorTemplateINS_7PxClothEED0Ev, __Z19GetPhysicsManager2Dv: __Z19GetPhysicsManager2Dv, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN4Mesh17ReloadToGfxDeviceEv: __ZN4Mesh17ReloadToGfxDeviceEv, __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_: __ZN7mecanim8skeleton23SkeletonBuildIndexArrayEPiPKNS0_8SkeletonES4_, __Z22GetUnityConnectServicev: __Z22GetUnityConnectServicev, __Z52Register_UnityEngine_SkinnedMeshRenderer_set_qualityv: __Z52Register_UnityEngine_SkinnedMeshRenderer_set_qualityv, __ZN18ScriptingArguments9AddStructEPKv: __ZN18ScriptingArguments9AddStructEPKv, __Z20Terrain_CUSTOM_FlushP12Il2CppObject: __Z20Terrain_CUSTOM_FlushP12Il2CppObject, __ZNK13ScreenManager24GetAllowLayeredRenderingEv: __ZNK13ScreenManager24GetAllowLayeredRenderingEv, __ZN5Umbra15bitPackIntArrayEPKjiPji: __ZN5Umbra15bitPackIntArrayEPKjiPji, __ZN12_GLOBAL__N_110DataStream11isConnectedEv: __ZN12_GLOBAL__N_110DataStream11isConnectedEv, __ZN12MeshCollider12CleanupClassEv: __ZN12MeshCollider12CleanupClassEv, __Z32Camera_Set_Custom_PropClearFlagsP12Il2CppObjecti: __Z32Camera_Set_Custom_PropClearFlagsP12Il2CppObjecti, __ZN13ScreenManager22SetResolutionImmediateEiibi: __ZN13ScreenManager22SetResolutionImmediateEiibi, __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE8__appendEj, __ZN5physx17PxsContactManager4initERKNS_24PxvManagerDescRigidRigidEPKNS_18PxsMaterialManagerE: __ZN5physx17PxsContactManager4initERKNS_24PxvManagerDescRigidRigidEPKNS_18PxsMaterialManagerE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __ZN13WheelCollider25AddWheelToExistingVehicleEP9RigidbodyPN5physx16PxVehicleNoDriveEi: __ZN13WheelCollider25AddWheelToExistingVehicleEP9RigidbodyPN5physx16PxVehicleNoDriveEi, __Z55Register_UnityEngine_QualitySettings_get_softVegetationv: __Z55Register_UnityEngine_QualitySettings_get_softVegetationv, __Z49Register_UnityEngine_Cloth_set_collisionMassScalev: __Z49Register_UnityEngine_Cloth_set_collisionMassScalev, __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z25LoadAssetsFromAssetBundleR11AssetBundleRKNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP13dynamic_arrayIiLj4EEP12Il2CppObjectbRSI_IP6ObjectLj4EE: __Z25LoadAssetsFromAssetBundleR11AssetBundleRKNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP13dynamic_arrayIiLj4EEP12Il2CppObjectbRSI_IP6ObjectLj4EE, __ZN14BlendShapeData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14BlendShapeData8TransferI24GenerateTypeTreeTransferEEvRT_, _wscanf: _wscanf, __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalDestroyv: __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalDestroyv, _UNITY_FT_Stream_Seek: _UNITY_FT_Stream_Seek, __Z31CustomEventData_CUSTOM_AddInt16P12Il2CppObjectP12Il2CppStrings: __Z31CustomEventData_CUSTOM_AddInt16P12Il2CppObjectP12Il2CppStrings, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5frontEv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN9JSONWrite8TransferINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZNK13SparseTexture20TileUploadErrorCheckEiii: __ZNK13SparseTexture20TileUploadErrorCheckEiii, __Z43Register_UnityEngine_Collider2D_set_densityv: __Z43Register_UnityEngine_Collider2D_set_densityv, __ZNK8LODGroup22GetWorldReferencePointEv: __ZNK8LODGroup22GetWorldReferencePointEv, __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags: __ZN17RemapPPtrTransfer12PushMetaFlagE17TransferMetaFlags, __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI15AudioMixerGroupE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11Rigidbody2D12LayerChangedEv: __ZN11Rigidbody2D12LayerChangedEv, __ZN5physx10PxsContextC2ERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS6_13EventProfilerEj: __ZN5physx10PxsContextC2ERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS6_13EventProfilerEj, __ZNK9CGProgram18GetScriptClassNameEv: __ZNK9CGProgram18GetScriptClassNameEv, __ZN12LightsModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12LightsModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15ResourceManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15ResourceManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z44Register_UnityEngine_GUIUtility_GetControlIDv: __Z44Register_UnityEngine_GUIUtility_GetControlIDv, __Z51Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYRollv: __Z51Register_UnityEngine_Avatar_INTERNAL_CALL_GetZYRollv, __ZN11AudioSource17SetSamplePositionEj: __ZN11AudioSource17SetSamplePositionEj, __ZN5physx2Cm10FanoutTask12addReferenceEv: __ZN5physx2Cm10FanoutTask12addReferenceEv, _mkfifo: _mkfifo, __ZN5physx17ConvexHullBuilder17CreatePolygonDataEv: __ZN5physx17ConvexHullBuilder17CreatePolygonDataEv, __ZN2UI13RectTransform18OnTransformChangedEi: __ZN2UI13RectTransform18OnTransformChangedEi, __Z40TerrainData_CUSTOM_Internal_SetAlphamapsP12Il2CppObjectiiiiP11Il2CppArray: __Z40TerrainData_CUSTOM_Internal_SetAlphamapsP12Il2CppObjectiiiiP11Il2CppArray, __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_set_motorv: __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_set_motorv, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE7reserveEj, __ZN5physx2Cm26dumpFreeListAllocatorStateERNS0_17FreeListAllocatorE: __ZN5physx2Cm26dumpFreeListAllocatorStateERNS0_17FreeListAllocatorE, __Z51Register_UnityEngine_Effector2D_get_useColliderMaskv: __Z51Register_UnityEngine_Effector2D_get_useColliderMaskv, __ZN5physx2Sc9ClothCore18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj: __ZN5physx2Sc9ClothCore18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj, ___muldsi3: ___muldsi3, __ZN9AudioClip15CreateUserSoundERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjsjb: __ZN9AudioClip15CreateUserSoundERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjsjb, __ZN13MemoryManager24InitializeDebugAllocatorEv: __ZN13MemoryManager24InitializeDebugAllocatorEv, __ZN17InternalIndexPool7releaseEv: __ZN17InternalIndexPool7releaseEv, __ZN13RenderManager30RemoveAllIntermediateRenderersEv: __ZN13RenderManager30RemoveAllIntermediateRenderersEv, __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI9OffsetPtrIN7mecanim8skeleton8SkeletonEEEEvRT_PKc17TransferMetaFlags, __Z32GUI_CUSTOM_Internal_BeginWindowsv: __Z32GUI_CUSTOM_Internal_BeginWindowsv, __ZN12_GLOBAL__N_112andNotIsZeroI8Scalar4fEET_RKS2_S4_: __ZN12_GLOBAL__N_112andNotIsZeroI8Scalar4fEET_RKS2_S4_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj477ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj477ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z38Input_CUSTOM_INTERNAL_get_accelerationP8Vector3f: __Z38Input_CUSTOM_INTERNAL_get_accelerationP8Vector3f, __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN23ControllerContactFilter27setCharacterControllerShapeEPKN5physx7PxShapeE: __ZN23ControllerContactFilter27setCharacterControllerShapeEPKN5physx7PxShapeE, __ZN4FMOD8ChannelI12setFrequencyEf: __ZN4FMOD8ChannelI12setFrequencyEf, __ZNK20OcclusionCullingData26GetTypeInfoVirtualInternalEv: __ZNK20OcclusionCullingData26GetTypeInfoVirtualInternalEv, __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb: __ZN13GfxDeviceGLES16SetComputeBufferE15ComputeBufferIDi20ComputeBufferCounterbb, __Z19ApplyBlendShapeTmplILb1ELb1EEvPK16BlendShapeVertexjjfiiiPh: __Z19ApplyBlendShapeTmplILb1ELb1EEvPK16BlendShapeVertexjjfiiiPh, __Z30MeshFilter_Get_Custom_PropMeshP12Il2CppObject: __Z30MeshFilter_Get_Custom_PropMeshP12Il2CppObject, __ZN5physx13PxsCCDContextC2EPNS_10PxsContextE: __ZN5physx13PxsCCDContextC2EPNS_10PxsContextE, __ZN13GfxDeviceNull12ImmediateEndEv: __ZN13GfxDeviceNull12ImmediateEndEv, __Z30AudioSource_CUSTOM_PlayDelayedP12Il2CppObjectf: __Z30AudioSource_CUSTOM_PlayDelayedP12Il2CppObjectf, __ZN14PhysicsManager24ProcessTriggerEnterExitsEv: __ZN14PhysicsManager24ProcessTriggerEnterExitsEv, __Z66Register_UnityEngine_Object_GetOffsetOfInstanceIDInCPlusPlusObjectv: __Z66Register_UnityEngine_Object_GetOffsetOfInstanceIDInCPlusPlusObjectv, _UNITY_png_colorspace_set_gamma: _UNITY_png_colorspace_set_gamma, __ZN13SpeedTreeWind17ComputeWindAnchorEPf: __ZN13SpeedTreeWind17ComputeWindAnchorEPf, __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev: __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED1Ev, __Z22CullAllPerObjectLightsiRK15RenderNodeQueueRK12ActiveLightsR27PerObjectLightCullingOutput: __Z22CullAllPerObjectLightsiRK15RenderNodeQueueRK12ActiveLightsR27PerObjectLightCullingOutput, __Z24RegisterStrippedTypeInfoI10MeshFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI10MeshFilterEviPKcS2_, __GLOBAL__sub_I_runtime_baseclasses2_lump_cpp: __GLOBAL__sub_I_runtime_baseclasses2_lump_cpp, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE8FinalizeEv, __Z55Register_UnityEngine_CharacterController_set_slopeLimitv: __Z55Register_UnityEngine_CharacterController_set_slopeLimitv, __Z26Transfer_UnityEngineObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z40ParticleSystem_Get_Custom_PropRandomSeedP12Il2CppObject: __Z40ParticleSystem_Get_Custom_PropRandomSeedP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj209ENS_22PxRepXPropertyAccessorILj209ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj209ENS_22PxRepXPropertyAccessorILj209ES4_ffEEEEvRKT0_, __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEjRKS1_: __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE8__appendEjRKS1_, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7ReleaseEPS2_: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7ReleaseEPS2_, __ZN14PhysicMaterialD2Ev: __ZN14PhysicMaterialD2Ev, __Z35GUI_CUSTOM_INTERNAL_CALL_DragWindowRK5RectTIfE: __Z35GUI_CUSTOM_INTERNAL_CALL_DragWindowRK5RectTIfE, _UNITY_ft_mem_qrealloc: _UNITY_ft_mem_qrealloc, __Z41Register_UnityEngine_Object_DestroyObjectv: __Z41Register_UnityEngine_Object_DestroyObjectv, _UNITY_FT_Glyph_Transform: _UNITY_FT_Glyph_Transform, __ZN11NavMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11NavMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UnityReplayKitIsRecording: _UnityReplayKitIsRecording, __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE: __ZNK5physx2Gu15HeightFieldUtil20overlapAABBTrianglesERKNS_11PxTransformERKNS_9PxBounds3EjPNS0_12EntityReportIjEE, __Z48Register_UnityEngine_LineRenderer_get_widthCurvev: __Z48Register_UnityEngine_LineRenderer_get_widthCurvev, __Z52Register_UnityEngine_Material_SetVectorArrayImplListv: __Z52Register_UnityEngine_Material_SetVectorArrayImplListv, __ZNSt3__215numpunct_bynameIcE6__initEPKc: __ZNSt3__215numpunct_bynameIcE6__initEPKc, __Z45Register_UnityEngine_Rigidbody2D_get_rotationv: __Z45Register_UnityEngine_Rigidbody2D_get_rotationv, __ZN2UI14CanvasRenderer18EnableRectClippingE5RectTIfE: __ZN2UI14CanvasRenderer18EnableRectClippingE5RectTIfE, __ZN11Rigidbody2D12MoveRotationEf: __ZN11Rigidbody2D12MoveRotationEf, __Z45Register_UnityEngine_Texture2DArray_get_depthv: __Z45Register_UnityEngine_Texture2DArray_get_depthv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZNK6Camera17GetProjectionNearEv: __ZNK6Camera17GetProjectionNearEv, __Z28Mesh_CUSTOM_ClearBlendShapesP12Il2CppObject: __Z28Mesh_CUSTOM_ClearBlendShapesP12Il2CppObject, __ZN5physx2Gu25PersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j: __ZN5physx2Gu25PersistentContactManifold8drawLineERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_j, __Z29StdTemplateConversionFunctionIasEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIasEbPvR14SafeBinaryRead, __ZN11UnityEngine9Analytics15AnalyticsConfig10UnregisterERNS_7Connect13ConfigHandlerE: __ZN11UnityEngine9Analytics15AnalyticsConfig10UnregisterERNS_7Connect13ConfigHandlerE, __ZN14Physics2DState12DestroyWorldEv: __ZN14Physics2DState12DestroyWorldEv, __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeIN5Cache10CachedFileENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZN5physx6shdfnd12PxRingBuffer8sendDataENS1_11MessageTypeEPKvjb: __ZN5physx6shdfnd12PxRingBuffer8sendDataENS1_11MessageTypeEPKvjb, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIS7_EERSB_, __ZN14Texture2DArray16DeleteGfxTextureEv: __ZN14Texture2DArray16DeleteGfxTextureEv, __ZN14AreaEffector2D16CheckConsistencyEv: __ZN14AreaEffector2D16CheckConsistencyEv, __Z50WheelCollider_Set_Custom_PropForceAppPointDistanceP12Il2CppObjectf: __Z50WheelCollider_Set_Custom_PropForceAppPointDistanceP12Il2CppObjectf, __Z28dtMergeCorridorStartShortcutPyiiPKyi: __Z28dtMergeCorridorStartShortcutPyiiPKyi, __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient: __ZL19WriteMinMaxGradientRK18MonoMinMaxGradientR14MinMaxGradient, __Z48Register_UnityEngine_ParticleEmitter_get_minSizev: __Z48Register_UnityEngine_ParticleEmitter_get_minSizev, __ZN10builtintex14GetHaloTextureEv: __ZN10builtintex14GetHaloTextureEv, __Z50CanvasRenderer_CUSTOM_SplitIndiciesStreamsInternalP12Il2CppObjectS0_: __Z50CanvasRenderer_CUSTOM_SplitIndiciesStreamsInternalP12Il2CppObjectS0_, __ZN19VREyeTextureManagerC2Ev: __ZN19VREyeTextureManagerC2Ev, __Z75Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailMultiplierv: __Z75Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailMultiplierv, __ZN4Mesh18CheckIfBuffersLostEv: __ZN4Mesh18CheckIfBuffersLostEv, __ZN5physx18PxVehicleDriveTank17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx18PxVehicleDriveTank17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN4crnd10dxt5_block17get_block_values8EPjjj: __ZN4crnd10dxt5_block17get_block_values8EPjjj, __Z59Register_UnityEngine_Rendering_CommandBuffer_GetTemporaryRTv: __Z59Register_UnityEngine_Rendering_CommandBuffer_GetTemporaryRTv, _UnityReplayKitSetMicrophoneEnabled: _UnityReplayKitSetMicrophoneEnabled, __ZN5physx27PxcPCMContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx27PxcPCMContactBoxHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN17ArchiveFileSystem9MakeLocalER13FileEntryDatab: __ZN17ArchiveFileSystem9MakeLocalER13FileEntryDatab, __ZNSt3__26locale5__imp7installINS_15time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __Z49Register_UnityEngine_Renderer_INTERNAL_get_boundsv: __Z49Register_UnityEngine_Renderer_INTERNAL_get_boundsv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags, __Z31Cloth_Set_Custom_PropUseGravityP12Il2CppObjecth: __Z31Cloth_Set_Custom_PropUseGravityP12Il2CppObjecth, __Z31HumanTrait_CUSTOM_GetParentBonei: __Z31HumanTrait_CUSTOM_GetParentBonei, __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass: __ZN9Scripting41TrackedReferenceBaseToScriptingObjectImplEP20TrackedReferenceBaseP11Il2CppClass, __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE17handleBufferFlushEPKhj: __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE17handleBufferFlushEPKhj, __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_DeterminantRK10Matrix4x4f: __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_DeterminantRK10Matrix4x4f, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN12AdsIdHandler16FetchCachedAdsIdEv: __ZN12AdsIdHandler16FetchCachedAdsIdEv, __ZN5physx2Gu11HeightFieldD2Ev: __ZN5physx2Gu11HeightFieldD2Ev, __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv: __ZN17GeneralConnection10Connection22ReleaseReceivedMessageEv, __ZN13OcclusionArea12CleanupClassEv: __ZN13OcclusionArea12CleanupClassEv, __ZN5physx2Sn9XmlParser14processCommentEPKc: __ZN5physx2Sn9XmlParser14processCommentEPKc, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv, __ZNK5physx2Gu11ConvexHullV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_: __ZNK5physx2Gu11ConvexHullV19supportVertexMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_, __Z36JsonUtility_CUSTOM_FromJsonOverwriteP12Il2CppStringP12Il2CppObject: __Z36JsonUtility_CUSTOM_FromJsonOverwriteP12Il2CppStringP12Il2CppObject, __ZN5Umbra8QueryExt14clusterPortalsERNS_9IndexListEi: __ZN5Umbra8QueryExt14clusterPortalsERNS_9IndexListEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z29Event_Get_Custom_PropPressureP12Il2CppObject: __Z29Event_Get_Custom_PropPressureP12Il2CppObject, __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18PlatformEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z35GetTextRenderingScriptingClassesPtrv: __Z35GetTextRenderingScriptingClassesPtrv, __Z13RegisterClassI16LevelGameManagerEvv: __Z13RegisterClassI16LevelGameManagerEvv, __ZN14SpriteRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14SpriteRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant: __ZN17AnimationPlayable34AnimationPlayableAllocateRecursiveEP35AnimationPlayableEvaluationConstant, __Z48Register_UnityEngine_Time_get_timeSinceLevelLoadv: __Z48Register_UnityEngine_Time_get_timeSinceLevelLoadv, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z48Register_UnityEngine_AudioSource_set_minDistancev: __Z48Register_UnityEngine_AudioSource_set_minDistancev, __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_: __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_, __ZN14TerrainManager17Heightmap_GetSizeER9Heightmap: __ZN14TerrainManager17Heightmap_GetSizeER9Heightmap, __Z29StdTemplateConversionFunctionIjbEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjbEbPvR14SafeBinaryRead, __Z54Register_UnityEngine_AndroidJNI_GetBooleanArrayElementv: __Z54Register_UnityEngine_AndroidJNI_GetBooleanArrayElementv, __ZN18ProfilerConnection17RemoveConnectionsEv: __ZN18ProfilerConnection17RemoveConnectionsEv, __Z18ConvertUTF16toUTF8PKtiRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z18ConvertUTF16toUTF8PKtiRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_4BoxVENS0_10ShrunkBoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __ZN12MeshCollider13AwakeFromLoadE17AwakeFromLoadMode: __ZN12MeshCollider13AwakeFromLoadE17AwakeFromLoadMode, __ZN13DrawImmediate8TexCoordEifff: __ZN13DrawImmediate8TexCoordEifff, __ZN13GfxDeviceGLES9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb: __ZN13GfxDeviceGLES9SkinOnGPUERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb, __ZN17SurfaceEffector2D18SetUseContactForceEb: __ZN17SurfaceEffector2D18SetUseContactForceEb, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9push_backEw, __ZNSt3__28ios_baseD0Ev: __ZNSt3__28ios_baseD0Ev, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN21ArchiveStorageCreator16BeginStreamBlockE15CompressionType16CompressionLevel: __ZN21ArchiveStorageCreator16BeginStreamBlockE15CompressionType16CompressionLevel, __Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi: __Z37scripting_method_get_nth_argumenttype21ScriptingMethodIl2Cppi, __ZN20SphericalHarmonicsL217AddToCoefficientsEPKN4math7_float4EPKf: __ZN20SphericalHarmonicsL217AddToCoefficientsEPKN4math7_float4EPKf, __ZN13ComputeBuffer9CopyCountEPS_S0_j: __ZN13ComputeBuffer9CopyCountEPS_S0_j, __ZNK5Umbra10Visibility15getInputObjectsEv: __ZNK5Umbra10Visibility15getInputObjectsEv, __ZL32GeomOverlapCallback_ConvexConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL32GeomOverlapCallback_ConvexConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5Unity12PhysicsQuery11CapsuleTestE8Vector3fS1_fi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery11CapsuleTestE8Vector3fS1_fi23QueryTriggerInteraction, __ZN14RenderSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN14RenderSettings13AwakeFromLoadE17AwakeFromLoadMode, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN22NavMeshProjectSettingsD2Ev: __ZN22NavMeshProjectSettingsD2Ev, __Z63Register_UnityEngine_AI_NavMeshObstacle_set_carveOnlyStationaryv: __Z63Register_UnityEngine_AI_NavMeshObstacle_set_carveOnlyStationaryv, __Z55QualitySettings_CUSTOM_INTERNAL_set_shadowCascade4SplitRK8Vector3f: __Z55QualitySettings_CUSTOM_INTERNAL_set_shadowCascade4SplitRK8Vector3f, __ZNSt3__26locale5__impD0Ev: __ZNSt3__26locale5__impD0Ev, __Z24RegisterStrippedTypeInfoI12WheelJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI12WheelJoint2DEviPKcS2_, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE, __ZN16UnityAdsSettings10InitializeER6Object: __ZN16UnityAdsSettings10InitializeER6Object, __Z42Canvas_Get_Custom_PropOverridePixelPerfectP12Il2CppObject: __Z42Canvas_Get_Custom_PropOverridePixelPerfectP12Il2CppObject, __Z36Register_UnityEngine_GUI_get_changedv: __Z36Register_UnityEngine_GUI_get_changedv, __ZN21RotationBySpeedModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj: __ZN21RotationBySpeedModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4Ejj, __ZN11TypeManagerC2ERN4RTTI16RuntimeTypeArrayE: __ZN11TypeManagerC2ERN4RTTI16RuntimeTypeArrayE, __Z39AudioSource_Get_Custom_PropSpatialBlendP12Il2CppObject: __Z39AudioSource_Get_Custom_PropSpatialBlendP12Il2CppObject, __ZN5physx2Sn8MetaData11addNewClassEPKciPNS0_9MetaClassEMNS0_5ConvXEFvS3_RKNS0_15PxMetaDataEntryES9_E: __ZN5physx2Sn8MetaData11addNewClassEPKciPNS0_9MetaClassEMNS0_5ConvXEFvS3_RKNS0_15PxMetaDataEntryES9_E, __Z30AudioMixer_CUSTOM_FindSnapshotP12Il2CppObjectP12Il2CppString: __Z30AudioMixer_CUSTOM_FindSnapshotP12Il2CppObjectP12Il2CppString, __ZNK9dtNavMesh20getOffMeshConnectionEy: __ZNK9dtNavMesh20getOffMeshConnectionEy, __ZNSt3__26stoullERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji: __ZNSt3__26stoullERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji, __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_: __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_, __ZN11ICallString18SetScriptingStringEP12Il2CppString: __ZN11ICallString18SetScriptingStringEP12Il2CppString, __Z36ShaderVariantCollection_CUSTOM_ClearP12Il2CppObject: __Z36ShaderVariantCollection_CUSTOM_ClearP12Il2CppObject, __ZN2UI6Canvas18SetOverrideSortingEb: __ZN2UI6Canvas18SetOverrideSortingEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj526ENS_22PxRepXPropertyAccessorILj526ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj526ENS_22PxRepXPropertyAccessorILj526ES4_ffEEEEvRKT0_, __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIffEEPfEEjT0_S5_S5_T_, __GLOBAL__sub_I_runtime_mecanim_animation_lump_cpp: __GLOBAL__sub_I_runtime_mecanim_animation_lump_cpp, __ZN12TextureInput5CleanEv: __ZN12TextureInput5CleanEv, __ZN5physx2Sc5Scene29fireBrokenConstraintCallbacksEv: __ZN5physx2Sc5Scene29fireBrokenConstraintCallbacksEv, __ZN5Umbra7ImpTile17getPortalDataSizeEPKS0_: __ZN5Umbra7ImpTile17getPortalDataSizeEPKS0_, __Z28setPxParticleFluid_StiffnessPN5physx15PxParticleFluidEf: __Z28setPxParticleFluid_StiffnessPN5physx15PxParticleFluidEf, __Z38GUIUtility_CUSTOM_Internal_GetGUIDepthv: __Z38GUIUtility_CUSTOM_Internal_GetGUIDepthv, __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi: __ZN7mecanim9animation13GetClipStartXERKNS0_18ClipMuscleConstantEi, __Z54ParticleAnimator_CUSTOM_INTERNAL_set_localRotationAxisP12Il2CppObjectRK8Vector3f: __Z54ParticleAnimator_CUSTOM_INTERNAL_set_localRotationAxisP12Il2CppObjectRK8Vector3f, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE22getClientBehaviorFlagsEv, __Z61Register_UnityEngine_TerrainData_Internal_SetDetailResolutionv: __Z61Register_UnityEngine_TerrainData_Internal_SetDetailResolutionv, __ZN4gles14GetProcAddressEPKc: __ZN4gles14GetProcAddressEPKc, __Z33getNbPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveE: __Z33getNbPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveE, __ZN11TimeManager9ResetTimeEb: __ZN11TimeManager9ResetTimeEb, __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E9erase_oneIS7_EEjRKT_: __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E9erase_oneIS7_EEjRKT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15dtPathQueryInfo8copyFromERS_: __ZN15dtPathQueryInfo8copyFromERS_, __ZN11DynamicMesh15ConnectPolygonsEv: __ZN11DynamicMesh15ConnectPolygonsEv, __ZNK8Animator12GetClipStatsEv: __ZNK8Animator12GetClipStatsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj153ENS_22PxRepXPropertyAccessorILj153ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN8TypeTree16AssignByteOffsetERK16TypeTreeIteratorj: __ZN8TypeTree16AssignByteOffsetERK16TypeTreeIteratorj, __ZN18StreamedBinaryReadILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN18StreamedBinaryReadILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, __Z36ComputeBuffer_CUSTOM_InternalGetDataP12Il2CppObjectP11Il2CppArrayi: __Z36ComputeBuffer_CUSTOM_InternalGetDataP12Il2CppObjectP11Il2CppArrayi, __ZN13AnimationClip16SetRuntimeEventsERKNSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE: __ZN13AnimationClip16SetRuntimeEventsERKNSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE, __Z9GetIIMGUIv: __Z9GetIIMGUIv, __ZngRK8Scalar4f: __ZngRK8Scalar4f, __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE: __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE5eraseENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEE, __GLOBAL__sub_I_runtime_graphics4_lump_cpp: __GLOBAL__sub_I_runtime_graphics4_lump_cpp, __ZN9GfxDevice18CloneRenderSurfaceEP17RenderSurfaceBase: __ZN9GfxDevice18CloneRenderSurfaceEP17RenderSurfaceBase, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, _UNITY_png_access_version_number: _UNITY_png_access_version_number, __ZN9JSONWrite8TransferINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getRigidBodyFlagsEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getRigidBodyFlagsEv, __ZN19RenderBufferManager26CleanupRenderBufferManagerEv: __ZN19RenderBufferManager26CleanupRenderBufferManagerEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv, __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE: __ZN5physx2Sc10NPhaseCore41removeFromForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE, __ZN10HumanTrait17RequiredBoneCountEv: __ZN10HumanTrait17RequiredBoneCountEv, __ZNK15b2DistanceJoint16GetReactionForceEf: __ZNK15b2DistanceJoint16GetReactionForceEf, __ZN5physx18PxSetAssertHandlerERNS_15PxAssertHandlerE: __ZN5physx18PxSetAssertHandlerERNS_15PxAssertHandlerE, __ZN8Renderer16SetMaterialCountEi: __ZN8Renderer16SetMaterialCountEi, __Z49QualitySettings_Get_Custom_PropMasterTextureLimitv: __Z49QualitySettings_Get_Custom_PropMasterTextureLimitv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z66Register_UnityEngine_VR_VRSettings_set_renderViewportScaleInternalv: __Z66Register_UnityEngine_VR_VRSettings_set_renderViewportScaleInternalv, __ZN9ShaderLab28UpdateGlobalShaderPropertiesEf: __ZN9ShaderLab28UpdateGlobalShaderPropertiesEf, __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexERKNS1_5CacheEf: __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexERKNS1_5CacheEf, __ZN5physx10PxsContext16createFluidShapeEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE: __ZN5physx10PxsContext16createFluidShapeEPNS_20PxsParticleSystemSimEPKNS_15PxsParticleCellE, __Z30CalculateBoxAreaRadialFrustum2P8Vector3ffff: __Z30CalculateBoxAreaRadialFrustum2P8Vector3ffff, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEjRKS1_: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEjRKS1_, __Z29StdTemplateConversionFunctionIajEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIajEbPvR14SafeBinaryRead, __ZNSt3__211__libcpp_dbD2Ev: __ZNSt3__211__libcpp_dbD2Ev, __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __Z33Gradient_Set_Custom_PropAlphaKeysP12Il2CppObjectP11Il2CppArray: __Z33Gradient_Set_Custom_PropAlphaKeysP12Il2CppObjectP11Il2CppArray, __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15DownloadHandler7PrepareEv: __ZN15DownloadHandler7PrepareEv, __ZN15ConstantForce2DD0Ev: __ZN15ConstantForce2DD0Ev, __Z44ParticleSystem_NoiseModule_CUSTOM_SetQualityP12Il2CppObjecti: __Z44ParticleSystem_NoiseModule_CUSTOM_SetQualityP12Il2CppObjecti, __ZN5physx14NpArticulation9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx14NpArticulation9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z18SetLogEntryHandlerPFb7LogTypePKcPiE: __Z18SetLogEntryHandlerPFb7LogTypePKcPiE, __Z48Register_UnityEngine_Time_get_renderedFrameCountv: __Z48Register_UnityEngine_Time_get_renderedFrameCountv, __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI14SafeBinaryReadEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI14SafeBinaryReadEEvRS4_RT_, __ZThn24_N5physx2Sc16ActorInteractionD0Ev: __ZThn24_N5physx2Sc16ActorInteractionD0Ev, __Z31Mesh_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z31Mesh_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE, __Z43Register_UnityEngine_TextMesh_set_alignmentv: __Z43Register_UnityEngine_TextMesh_set_alignmentv, __ZN29DelayedPointerDeletionManager32CleanupPendingMainThreadPointersEv: __ZN29DelayedPointerDeletionManager32CleanupPendingMainThreadPointersEv, _endhostent: _endhostent, __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_9StopEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EE18handleProfileEventINS0_9StopEventEEEbRT_, __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetEnabledv: __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetEnabledv, __ZN12IFileAdapter4ReadER13FileEntryDatayyPvPy: __ZN12IFileAdapter4ReadER13FileEntryDatayyPvPy, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKiEEvRT_: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKiEEvRT_, __Z44AudioReverbFilter_Set_Custom_PropLfReferenceP12Il2CppObjectf: __Z44AudioReverbFilter_Set_Custom_PropLfReferenceP12Il2CppObjectf, __ZN30RuntimeInitializeOnLoadManager15ThreadedCleanupEv: __ZN30RuntimeInitializeOnLoadManager15ThreadedCleanupEv, __ZNK14dtNavMeshQuery26closestPointOnPolyBoundaryEyPKfPf: __ZNK14dtNavMeshQuery26closestPointOnPolyBoundaryEyPKfPf, __ZN5physx7NpScene8addClothERNS_7NpClothE: __ZN5physx7NpScene8addClothERNS_7NpClothE, __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI8StateKey10StateRangeEEEEvRT_PKc17TransferMetaFlags, __ZN9GfxDevice24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj: __ZN9GfxDevice24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj, __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKNS0_10ValueDeltaERNS_5human9HumanPoseE: __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKNS0_10ValueDeltaERNS_5human9HumanPoseE, __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE, __ZN23ForwardShaderRenderLoop15StartRenderJobsER8JobFencebR17ShaderPassContext: __ZN23ForwardShaderRenderLoop15StartRenderJobsER8JobFencebR17ShaderPassContext, __Z39setPxRigidDynamic_SolverIterationCountsPN5physx14PxRigidDynamicEjj: __Z39setPxRigidDynamic_SolverIterationCountsPN5physx14PxRigidDynamicEjj, __GLOBAL__sub_I_runtime_camera4_lump_cpp: __GLOBAL__sub_I_runtime_camera4_lump_cpp, __ZN26AnimatorControllerPlayableD2Ev: __ZN26AnimatorControllerPlayableD2Ev, __ZN5physx2Sc8BodyCore25invalidateKinematicTargetEv: __ZN5physx2Sc8BodyCore25invalidateKinematicTargetEv, __Z34Joint2D_Set_Custom_PropBreakTorqueP12Il2CppObjectf: __Z34Joint2D_Set_Custom_PropBreakTorqueP12Il2CppObjectf, __ZNK5physx2Sc9ClothCore24getSelfCollisionDistanceEv: __ZNK5physx2Sc9ClothCore24getSelfCollisionDistanceEv, __ZN4FMOD4DSPI7getInfoEPcPjPiS3_S3_: __ZN4FMOD4DSPI7getInfoEPcPjPiS3_S3_, __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE: __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams6InsertEPKcRNS1_11CustomValueE, __Z24GUIStatePushDisplayIndexi: __Z24GUIStatePushDisplayIndexi, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5Umbra9intersectERKNS_4AABBERKNS_4QuadE: __ZN5Umbra9intersectERKNS_4AABBERKNS_4QuadE, __Z24GUI_CUSTOM_UnfocusWindowv: __Z24GUI_CUSTOM_UnfocusWindowv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvRS2_S5_RKS2_S7_: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvRS2_S5_RKS2_S7_, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI14SafeBinaryReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI14SafeBinaryReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN14MemoryProfiler16StaticInitializeEv: __ZN14MemoryProfiler16StaticInitializeEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __Z47Register_UnityEngine_Texture_GetNativeTextureIDv: __Z47Register_UnityEngine_Texture_GetNativeTextureIDv, __ZN7ApiGLES15BindArrayBufferEj: __ZN7ApiGLES15BindArrayBufferEj, __ZN20TextRenderingPrivate15CleanupFreeTypeEv: __ZN20TextRenderingPrivate15CleanupFreeTypeEv, __ZNK5Umbra15CameraTransform10getFrustumERNS_7FrustumE: __ZNK5Umbra15CameraTransform10getFrustumERNS_7FrustumE, __Z13GetFileSystemv: __Z13GetFileSystemv, __ZNSt3__26localeC2EPKc: __ZNSt3__26localeC2EPKc, __ZN14TerrainManager23CreateTerrainGameObjectEP11TerrainData: __ZN14TerrainManager23CreateTerrainGameObjectEP11TerrainData, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZNKSt3__27codecvtIwc11__mbstate_tE16do_always_noconvEv: __ZNKSt3__27codecvtIwc11__mbstate_tE16do_always_noconvEv, __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN8Material23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8Material23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEEC2EPNS0_7SystemIEi: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEEC2EPNS0_7SystemIEi, __Z56Register_UnityEngine_RenderSettings_set_customReflectionv: __Z56Register_UnityEngine_RenderSettings_set_customReflectionv, __Z24GetTextureShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE: __Z24GetTextureShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN9JSONWrite8TransferI13dynamic_arrayIsLj2EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIsLj2EEEEvRT_PKc17TransferMetaFlags, __ZN5Umbra13MatrixFactory6rotateEffff: __ZN5Umbra13MatrixFactory6rotateEffff, _unity_z_deflate: _unity_z_deflate, __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionXv: __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionXv, __GLOBAL__sub_I_runtime_audio2_lump_cpp: __GLOBAL__sub_I_runtime_audio2_lump_cpp, __Z48Register_UnityEngine_Collider2D_IsTouchingLayersv: __Z48Register_UnityEngine_Collider2D_IsTouchingLayersv, __ZN15TerrainCollider14GetTerrainDataEv: __ZN15TerrainCollider14GetTerrainDataEv, __ZNK25SingleBlockMemoryFileData4ReadEyyPv: __ZNK25SingleBlockMemoryFileData4ReadEyyPv, __ZN13TextRendering4Font5ResetEv: __ZN13TextRendering4Font5ResetEv, __ZN5physx2Sc9ShapeCore8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx2Sc9ShapeCore8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZNK10FileSystem21GetUserAppCacheFolderEv: __ZNK10FileSystem21GetUserAppCacheFolderEv, __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_T_, __Z53AnimatorControllerPlayable_CUSTOM_ResolveHashInternalR9HPlayablei: __Z53AnimatorControllerPlayable_CUSTOM_ResolveHashInternalR9HPlayablei, __Z31getPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveEj: __Z31getPxVehicleNoDrive_BrakeTorquePKN5physx16PxVehicleNoDriveEj, __Z45Register_UnityEngine_Canvas_get_targetDisplayv: __Z45Register_UnityEngine_Canvas_get_targetDisplayv, __Z42SystemInfo_Get_Custom_PropGraphicsDeviceIDv: __Z42SystemInfo_Get_Custom_PropGraphicsDeviceIDv, __Z44Physics2D_Get_Custom_PropAlwaysShowCollidersv: __Z44Physics2D_Get_Custom_PropAlwaysShowCollidersv, __Z37HingeJoint_CUSTOM_INTERNAL_get_springP12Il2CppObjectP11JointSpring: __Z37HingeJoint_CUSTOM_INTERNAL_get_springP12Il2CppObjectP11JointSpring, __ZNSt3__27codecvtIwc11__mbstate_tED0Ev: __ZNSt3__27codecvtIwc11__mbstate_tED0Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10GameObject8ActivateEv: __ZN10GameObject8ActivateEv, __ZN7mecanim9animation17CreateAvatarInputEPKNS0_14AvatarConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation17CreateAvatarInputEPKNS0_14AvatarConstantERNS_6memory9AllocatorE, __Z33Texture2DArray_CUSTOM_GetPixels32P12Il2CppObjectii: __Z33Texture2DArray_CUSTOM_GetPixels32P12Il2CppObjectii, __ZNK15CapsuleCollider26GetTypeInfoVirtualInternalEv: __ZNK15CapsuleCollider26GetTypeInfoVirtualInternalEv, __ZN2UI6Canvas23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN2UI6Canvas23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN11UnityEngine9Analytics15AnalyticsConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead: __ZN11UnityEngine9Analytics15AnalyticsConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead, __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthXMultiplierP12Il2CppObjectf: __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthXMultiplierP12Il2CppObjectf, __ZN11ColorModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11ColorModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE19getConcreteTypeNameEv, __ZN11AssetBundle15ThreadedCleanupEv: __ZN11AssetBundle15ThreadedCleanupEv, __ZN6Object13ClassIDToRTTIEi: __ZN6Object13ClassIDToRTTIEi, __Z48ConstantForce_CUSTOM_INTERNAL_get_relativeTorqueP12Il2CppObjectP8Vector3f: __Z48ConstantForce_CUSTOM_INTERNAL_get_relativeTorqueP12Il2CppObjectP8Vector3f, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI16BlendShapeVertexLj4EEEEvRT_17TransferMetaFlags, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK5physx13NpClothFabric12getPhaseTypeEj: __ZNK5physx13NpClothFabric12getPhaseTypeEj, __ZN14DetailRenderer7CleanupEv: __ZN14DetailRenderer7CleanupEv, __ZN14BillboardAsset23VirtualRedirectTransferER14SafeBinaryRead: __ZN14BillboardAsset23VirtualRedirectTransferER14SafeBinaryRead, __Z39Animation_Get_Custom_PropAnimatePhysicsP12Il2CppObject: __Z39Animation_Get_Custom_PropAnimatePhysicsP12Il2CppObject, __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_, __ZN5physx2Sn9XmlParser10deallocateEPv: __ZN5physx2Sn9XmlParser10deallocateEPv, __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __ZN2UI13RectTransform23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN2UI13RectTransform23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __ZN14PhysicsManager13RecreateSceneEv: __ZN14PhysicsManager13RecreateSceneEv, __ZN7ApiGLES15DebugPushMarkerEPKc: __ZN7ApiGLES15DebugPushMarkerEPKc, __ZN5physx2Sc27ConstraintProjectionManager28removeFromPendingTreeUpdatesERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc27ConstraintProjectionManager28removeFromPendingTreeUpdatesERNS0_19ConstraintGroupNodeE, __ZN8Animator17GetTargetPositionEv: __ZN8Animator17GetTargetPositionEv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __Z42Register_UnityEngine_GUIStyleState_Cleanupv: __Z42Register_UnityEngine_GUIStyleState_Cleanupv, __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab16FastPropertyName8TransferI14SafeBinaryReadEEvRT_, __ZN9ShaderLab9IntShader27RemoveUnsupportedSubShadersEv: __ZN9ShaderLab9IntShader27RemoveUnsupportedSubShadersEv, __ZN13GfxDeviceGLES18CreateStencilStateERK15GfxStencilState: __ZN13GfxDeviceGLES18CreateStencilStateERK15GfxStencilState, __Z44Register_UnityEngine_Time_set_fixedDeltaTimev: __Z44Register_UnityEngine_Time_set_fixedDeltaTimev, __ZN13GfxDeviceGLES8EndFrameEv: __ZN13GfxDeviceGLES8EndFrameEv, __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK12HeaderHelper3GetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, _strerror_l: _strerror_l, __Z29Time_Get_Custom_PropDeltaTimev: __Z29Time_Get_Custom_PropDeltaTimev, __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE10InitializeEv: __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE10InitializeEv, __Z48Register_UnityEngine_LightProbes_get_bakedProbesv: __Z48Register_UnityEngine_LightProbes_get_bakedProbesv, __Z40Register_UnityEngine_Time_get_frameCountv: __Z40Register_UnityEngine_Time_get_frameCountv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12createObjectERPhRNS_24PxDeserializationContextE, __GLOBAL__sub_I_PlayerPaths_cpp: __GLOBAL__sub_I_PlayerPaths_cpp, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __ZN12b2MotorJoint12SetMaxTorqueEf: __ZN12b2MotorJoint12SetMaxTorqueEf, __Z51Transform_CUSTOM_INTERNAL_CALL_RotateAroundInternalP12Il2CppObjectRK8Vector3ff: __Z51Transform_CUSTOM_INTERNAL_CALL_RotateAroundInternalP12Il2CppObjectRK8Vector3ff, __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN10builtintex22GetDitherMaskTexture3DEv: __ZN10builtintex22GetDitherMaskTexture3DEv, __ZNK5physx2Gu11HeightField15getSampleStrideEv: __ZNK5physx2Gu11HeightField15getSampleStrideEv, __Z27GameObject_CUSTOM_SetActiveP12Il2CppObjecth: __Z27GameObject_CUSTOM_SetActiveP12Il2CppObjecth, __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj: __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2ERKNS_12basic_stringIcNS2_IcEENS_9allocatorIcEEEEj, __ZN18GfxFramebufferGLES11SetViewportERK5RectTIiE: __ZN18GfxFramebufferGLES11SetViewportERK5RectTIiE, __ZThn4_N12_GLOBAL__N_111StreamOwnerD0Ev: __ZThn4_N12_GLOBAL__N_111StreamOwnerD0Ev, __Z35getPxParticleReadDataPositionBufferPKN5physx18PxParticleReadDataE: __Z35getPxParticleReadDataPositionBufferPKN5physx18PxParticleReadDataE, __Z44AreaEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf: __Z44AreaEffector2D_Set_Custom_PropForceVariationP12Il2CppObjectf, __ZN13dynamic_arrayIP14TreeBinaryTreeLj4EEC2ERKS2_: __ZN13dynamic_arrayIP14TreeBinaryTreeLj4EEC2ERKS2_, __ZNK5physx2Sc15ArticulationSim27debugCheckSleepStateOfLinksEb: __ZNK5physx2Sc15ArticulationSim27debugCheckSleepStateOfLinksEb, __Z47Register_UnityEngine_SystemInfo_get_deviceModelv: __Z47Register_UnityEngine_SystemInfo_get_deviceModelv, __ZN11TimeManager10TimeHolderC2Ev: __ZN11TimeManager10TimeHolderC2Ev, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z27GetUnityAnalyticsManagerPtrv: __Z27GetUnityAnalyticsManagerPtrv, __ZNSt3__220__codecvt_utf8_utf16IwED0Ev: __ZNSt3__220__codecvt_utf8_utf16IwED0Ev, _ctanh: _ctanh, _ctanl: _ctanl, __ZN14EdgeCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14EdgeCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _ctanf: _ctanf, __ZN6Camera18SetBackgroundColorERK10ColorRGBAf: __ZN6Camera18SetBackgroundColorERK10ColorRGBAf, __Z55Register_UnityEngine_QualitySettings_get_shadowCascadesv: __Z55Register_UnityEngine_QualitySettings_get_shadowCascadesv, __Z32Animator_CUSTOM_GetIntegerStringP12Il2CppObjectP12Il2CppString: __Z32Animator_CUSTOM_GetIntegerStringP12Il2CppObjectP12Il2CppString, __ZN18GfxFramebufferGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES: __ZN18GfxFramebufferGLES43AddRenderSurfaceToDeferredFBOInvalidateListEPK17RenderSurfaceGLES, __Z33Collider2D_Set_Custom_PropDensityP12Il2CppObjectf: __Z33Collider2D_Set_Custom_PropDensityP12Il2CppObjectf, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7setNameEPKc, __ZN5Umbra9BitVector6resizeEjbb: __ZN5Umbra9BitVector6resizeEjbb, __Z18Transfer_BlittableI14SafeBinaryReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx2Sc17ParticleSystemSim17updateRigidBodiesEv: __ZN5physx2Sc17ParticleSystemSim17updateRigidBodiesEv, __Z49InitializeSpriteRendererAnimationBindingInterfacev: __Z49InitializeSpriteRendererAnimationBindingInterfacev, __Z32Register_UnityEngine_GUIClip_Popv: __Z32Register_UnityEngine_GUIClip_Popv, __ZN12_GLOBAL__N_110Connection22initializeProfileTypesERN5physx8debugger4comm31PvdCommStreamInternalDataStreamE: __ZN12_GLOBAL__N_110Connection22initializeProfileTypesERN5physx8debugger4comm31PvdCommStreamInternalDataStreamE, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5writeEPKci: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5writeEPKci, __ZN5physx2Sn5ConvX15getConcreteTypeEPKc: __ZN5physx2Sn5ConvX15getConcreteTypeEPKc, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9showmanycEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9showmanycEv, __ZNK18AudioLowPassFilter18GetCutoffFrequencyEv: __ZNK18AudioLowPassFilter18GetCutoffFrequencyEv, __ZN8Animator19ValidateTargetIndexEi: __ZN8Animator19ValidateTargetIndexEi, __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext: __Z29SetCascadedShadowShaderParamsPK10Matrix4x4fiPKfPK8Vector4fRK8Vector2fR17ShaderPassContext, __ZN17GeneralConnection13MulticastInfo5ClearEv: __ZN17GeneralConnection13MulticastInfo5ClearEv, __Z46Register_UnityEngine_Terrain_set_drawHeightmapv: __Z46Register_UnityEngine_Terrain_set_drawHeightmapv, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN13ConstantForce23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13ConstantForce23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5Umbra7ImpTile23getAccurateFindDataSizeEPKS0_: __ZN5Umbra7ImpTile23getAccurateFindDataSizeEPKS0_, __ZN6Avatar16CheckConsistencyEv: __ZN6Avatar16CheckConsistencyEv, __Z51Register_UnityEngine_RenderTexture_ReleaseTemporaryv: __Z51Register_UnityEngine_RenderTexture_ReleaseTemporaryv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_, __ZN13GfxDeviceGLES15ReloadResourcesEv: __ZN13GfxDeviceGLES15ReloadResourcesEv, __ZN15Cast2DQueryBaseD2Ev: __ZN15Cast2DQueryBaseD2Ev, __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_21PxsBodyTransformVault13PxsBody2WorldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN13RendererScene16UpdateVisibilityEPK9IndexList: __ZN13RendererScene16UpdateVisibilityEPK9IndexList, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE7getNameEv, __Z78Register_UnityEngine_RenderBufferHelper_INTERNAL_CALL_GetNativeRenderBufferPtrv: __Z78Register_UnityEngine_RenderBufferHelper_INTERNAL_CALL_GetNativeRenderBufferPtrv, __ZN5physx2Sn20SerializationContext17registerReferenceERNS_6PxBaseEjj: __ZN5physx2Sn20SerializationContext17registerReferenceERNS_6PxBaseEjj, __ZN17AudioChorusFilterD2Ev: __ZN17AudioChorusFilterD2Ev, __Z43Animator_CUSTOM_GetIKRotationWeightInternalP12Il2CppObjecti: __Z43Animator_CUSTOM_GetIKRotationWeightInternalP12Il2CppObjecti, __Z42CommandBuffer_CUSTOM_Internal_DrawRendererP12Il2CppObjectS0_S0_ii: __Z42CommandBuffer_CUSTOM_Internal_DrawRendererP12Il2CppObjectS0_S0_ii, __GLOBAL__sub_I_SwSelfCollision_cpp: __GLOBAL__sub_I_SwSelfCollision_cpp, __ZN12CullingGroup15NotifyInvisibleEv: __ZN12CullingGroup15NotifyInvisibleEv, __ZN5Light8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Light8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx7NpScene22setNbContactDataBlocksEj: __ZN5physx7NpScene22setNbContactDataBlocksEj, __Z63Register_UnityEngineInternal_GIDebugVisualisation_PlayCycleModev: __Z63Register_UnityEngineInternal_GIDebugVisualisation_PlayCycleModev, __ZN7mecanim5human10TwistSolveEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_: __ZN7mecanim5human10TwistSolveEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __ZN14PhysicMaterial15InitializeClassEv: __ZN14PhysicMaterial15InitializeClassEv, __ZN5physx7NpScene24updateScbStateAndSetupSqERKNS_12PxRigidActorERNS_3Scb5ActorERNS_14NpShapeManagerEbPNS_9PxBounds3E: __ZN5physx7NpScene24updateScbStateAndSetupSqERKNS_12PxRigidActorERNS_3Scb5ActorERNS_14NpShapeManagerEbPNS_9PxBounds3E, _UNITY_png_write_gAMA_fixed: _UNITY_png_write_gAMA_fixed, __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapXP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapXP12Il2CppObjectR15MonoMinMaxCurve, _malloc_footprint: _malloc_footprint, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z40AudioReverbFilter_Get_Custom_PropDensityP12Il2CppObject: __Z40AudioReverbFilter_Get_Custom_PropDensityP12Il2CppObject, __ZN7Terrain17RemoveFromManagerEv: __ZN7Terrain17RemoveFromManagerEv, _jpeg_copy_critical_parameters: _jpeg_copy_critical_parameters, __ZN8GUILayer12CleanupClassEv: __ZN8GUILayer12CleanupClassEv, __ZN23iPhoneLocalNotification12SetAlertBodyEPKc: __ZN23iPhoneLocalNotification12SetAlertBodyEPKc, __ZNK5Umbra4Tome9getStatusEv: __ZNK5Umbra4Tome9getStatusEv, __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f: __ZN15TerrainRendererC2Ei4PPtrI11TerrainDataERK8Vector3f, __Z42Register_UnityEngine_TextMesh_get_richTextv: __Z42Register_UnityEngine_TextMesh_get_richTextv, __ZL44CreateObjectToIndexMappingFromNonRootObjectsR21GarbageCollectorState: __ZL44CreateObjectToIndexMappingFromNonRootObjectsR21GarbageCollectorState, __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_243kDidDeleteMesh4CallEPviR11MessageData: __ZZN14ParticleSystem15InitializeClassEvEN29FunctorImpl_243kDidDeleteMesh4CallEPviR11MessageData, __Z13RegisterClassI14Texture2DArrayEvv: __Z13RegisterClassI14Texture2DArrayEvv, __Z21getPxConstraint_FlagsPKN5physx12PxConstraintE: __Z21getPxConstraint_FlagsPKN5physx12PxConstraintE, __ZN10GUIManagerD2Ev: __ZN10GUIManagerD2Ev, _unity_z_inflateCopy: _unity_z_inflateCopy, __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZMultiplierv, __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh: __ZN5physx2Sc8ActorSim26setActorsInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEPKNS0_5ActorEh, __Z55Register_UnityEngine_SkinnedMeshRenderer_set_sharedMeshv: __Z55Register_UnityEngine_SkinnedMeshRenderer_set_sharedMeshv, __Z52Register_UnityEngine_Animation_Internal_RewindByNamev: __Z52Register_UnityEngine_Animation_Internal_RewindByNamev, __Z24GL_CUSTOM_MultiTexCoord2iff: __Z24GL_CUSTOM_MultiTexCoord2iff, __ZN5physx8debugger4comm11CreateClassD0Ev: __ZN5physx8debugger4comm11CreateClassD0Ev, __ZN8GradientC2Ev: __ZN8GradientC2Ev, __Z33NavMeshObstacle_CUSTOM_FitExtentsP12Il2CppObject: __Z33NavMeshObstacle_CUSTOM_FitExtentsP12Il2CppObject, __Z30Event_Set_Custom_PropCharacterP12Il2CppObjectt: __Z30Event_Set_Custom_PropCharacterP12Il2CppObjectt, __ZN5physx6shdfnd5ArrayIPNS_3Cct15ObstacleContextENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_3Cct15ObstacleContextENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, _cexpl: _cexpl, _cexpf: _cexpf, __ZN5Umbra15CameraTransformaSERKS0_: __ZN5Umbra15CameraTransformaSERKS0_, __ZNSt3__218__time_get_storageIwEC2EPKc: __ZNSt3__218__time_get_storageIwEC2EPKc, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEED0Ev, __ZN13GfxDeviceNull15EndTimerQueriesEv: __ZN13GfxDeviceNull15EndTimerQueriesEv, __ZN8Material31SetTextureScaleAndOffsetIndexedEN9ShaderLab16FastPropertyNameEif: __ZN8Material31SetTextureScaleAndOffsetIndexedEN9ShaderLab16FastPropertyNameEif, __ZN5physx2Sc5Scene26setBounceThresholdVelocityEf: __ZN5physx2Sc5Scene26setBounceThresholdVelocityEf, _Write_CVT_Stretched: _Write_CVT_Stretched, __Z23GetGfxDeviceLevelString16GfxDeviceLevelGL: __Z23GetGfxDeviceLevelString16GfxDeviceLevelGL, __ZN5physx25PxVehicleConstraintShader17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx25PxVehicleConstraintShader17getBinaryMetaDataERNS_14PxOutputStreamE, __Z34GL_CUSTOM_INTERNAL_CALL_MultMatrixRK10Matrix4x4f: __Z34GL_CUSTOM_INTERNAL_CALL_MultMatrixRK10Matrix4x4f, __ZN9Transform23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Transform23VirtualRedirectTransferER14SafeBinaryRead, __ZN6Socket4RecvEPvjP12RecvUserData: __ZN6Socket4RecvEPvjP12RecvUserData, __ZL17SerializeSnapshotRK14MemorySnapshotR13dynamic_arrayIhLj1EE: __ZL17SerializeSnapshotRK14MemorySnapshotR13dynamic_arrayIhLj1EE, __ZN43MultiWriterSingleReaderAtomicCircularBuffer16CopyDataToBufferEP26AtomicCircularBufferHandlePhii: __ZN43MultiWriterSingleReaderAtomicCircularBuffer16CopyDataToBufferEP26AtomicCircularBufferHandlePhii, __ZNK14ParticleSystem13GetRandomSeedEv: __ZNK14ParticleSystem13GetRandomSeedEv, __ZN9rapidjson8internal8PrettifyEPcii: __ZN9rapidjson8internal8PrettifyEPcii, __ZN9Transform11SetLocalTRSERK8Vector3fRK11QuaternionfS2_: __ZN9Transform11SetLocalTRSERK8Vector3fRK11QuaternionfS2_, __Z38Graphics_CUSTOM_DrawProceduralIndirect16GfxPrimitiveTypeP12Il2CppObjecti: __Z38Graphics_CUSTOM_DrawProceduralIndirect16GfxPrimitiveTypeP12Il2CppObjecti, __ZN17PackedFloatVector10PackFloatsEPKfiiiib: __ZN17PackedFloatVector10PackFloatsEPKfiiiib, __ZN15b2ContactSolver24SolveVelocityConstraintsEv: __ZN15b2ContactSolver24SolveVelocityConstraintsEv, __ZN17GeneralConnection28RegisterDisconnectionHandlerEPFvjE: __ZN17GeneralConnection28RegisterDisconnectionHandlerEPFvjE, __Z62Register_UnityEngine_AI_NavMeshAgent_set_obstacleAvoidanceTypev: __Z62Register_UnityEngine_AI_NavMeshAgent_set_obstacleAvoidanceTypev, __Z23DestroyMutexLockedQueueP16MutexLockedQueue: __Z23DestroyMutexLockedQueueP16MutexLockedQueue, __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26localeC2ERKS0_PKci: __ZNSt3__26localeC2ERKS0_PKci, __Z70Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsLifetimev: __Z70Register_UnityEngine_ParticleSystem_TrailModule_SetSizeAffectsLifetimev, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE6resizeEjRKS4_, __ZNK10UnityScene12GetRootCountEv: __ZNK10UnityScene12GetRootCountEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN11PlayerPrefs4SyncEv: __ZN11PlayerPrefs4SyncEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE6getDirEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11TetrahedronLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11TetrahedronLj4EEEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_Gizmos_INTERNAL_set_colorv: __Z46Register_UnityEngine_Gizmos_INTERNAL_set_colorv, __ZN5physx12NpConstraint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx12NpConstraint12createObjectERPhRNS_24PxDeserializationContextE, __Z39setPxRigidBody_MaxDepenetrationVelocityPN5physx11PxRigidBodyEf: __Z39setPxRigidBody_MaxDepenetrationVelocityPN5physx11PxRigidBodyEf, __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIjjEEPjEEjT0_S5_S5_T_, __ZN14EdgeCollider2D16CheckConsistencyEv: __ZN14EdgeCollider2D16CheckConsistencyEv, __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE9push_backEv: __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE9push_backEv, __ZNK7VRInput22GetWorldToCameraMatrixERK8UnityStr4PPtrI9TransformE: __ZNK7VRInput22GetWorldToCameraMatrixERK8UnityStr4PPtrI9TransformE, __ZN8MaterialD0Ev: __ZN8MaterialD0Ev, __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z53Register_UnityEngine_SystemInfo_SupportsTextureFormatv: __Z53Register_UnityEngine_SystemInfo_SupportsTextureFormatv, __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN11HaloManager4HaloENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z65AnimatorControllerPlayable_CUSTOM_GetNextAnimatorClipInfoInternalR9HPlayablei: __Z65AnimatorControllerPlayable_CUSTOM_GetNextAnimatorClipInfoInternalR9HPlayablei, __Z31Light_Get_Custom_PropCookieSizeP12Il2CppObject: __Z31Light_Get_Custom_PropCookieSizeP12Il2CppObject, __ZN21LightProbeProxyVolume8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN21LightProbeProxyVolume8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11AudioModule21SetActiveOutputDriverEPv: __ZN11AudioModule21SetActiveOutputDriverEPv, __ZNK13TranslateGLES9FilterMinE17TextureFilterModeb: __ZNK13TranslateGLES9FilterMinE17TextureFilterModeb, __Z39RenderSettings_CUSTOM_GetRenderSettingsv: __Z39RenderSettings_CUSTOM_GetRenderSettingsv, __Z51Register_UnityEngine_Texture_set_masterTextureLimitv: __Z51Register_UnityEngine_Texture_set_masterTextureLimitv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjS8_, __ZN5physx2Sc13ConstraintSimC2ERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_RNS0_5SceneE: __ZN5physx2Sc13ConstraintSimC2ERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_RNS0_5SceneE, __ZN18GfxFramebufferGLES22EnsureDefaultFBOInitedEv: __ZN18GfxFramebufferGLES22EnsureDefaultFBOInitedEv, __ZN17PersistentManager14IsStreamLoadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager14IsStreamLoadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN12GraphicsCaps8InitNullEv: __ZN12GraphicsCaps8InitNullEv, __ZN23ParticleSystemParticles15WriteCustomDataEPKN4math14float4_storageEii: __ZN23ParticleSystemParticles15WriteCustomDataEPKN4math14float4_storageEii, __ZNK13GfxDeviceNull25GetDeviceProjectionMatrixEv: __ZNK13GfxDeviceNull25GetDeviceProjectionMatrixEv, __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo: __Z9FireEventR14AnimationEventRN5Unity9ComponentEP14AnimationStateP17AnimatorStateInfoP16AnimatorClipInfo, __ZNK9Texture2D30ExtractCompressedImageInternalEPhiii: __ZNK9Texture2D30ExtractCompressedImageInternalEPhiii, __ZNK7Terrain24GetTreeLODBiasMultiplierEv: __ZNK7Terrain24GetTreeLODBiasMultiplierEv, _UNITY_FT_Init_Class_sfnt_service_ps_name: _UNITY_FT_Init_Class_sfnt_service_ps_name, __ZL16OutOfMemoryErrorjiRK10MemLabelIdiPKc: __ZL16OutOfMemoryErrorjiRK10MemLabelIdiPKc, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMaxDepenetrationVelocityEf: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMaxDepenetrationVelocityEf, __ZN5physx18PxVehicleDriveTankD0Ev: __ZN5physx18PxVehicleDriveTankD0Ev, __ZN5physx17ConvexMeshBuilder15computeMassInfoEv: __ZN5physx17ConvexMeshBuilder15computeMassInfoEv, __ZNK21FullParameterPreparer16OnPrepareTextureERPKN9ShaderLab6TexEnvERKN20GpuProgramParameters16TextureParameterEj: __ZNK21FullParameterPreparer16OnPrepareTextureERPKN9ShaderLab6TexEnvERKN20GpuProgramParameters16TextureParameterEj, __ZN4FMOD7Channel9isVirtualEPb: __ZN4FMOD7Channel9isVirtualEPb, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu12TriangleMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZL21AddComponentUncheckedR10GameObjectiP11Il2CppClassP10MonoScriptPNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZNK13ScreenManager19GetSystemResolutionEv: __ZNK13ScreenManager19GetSystemResolutionEv, __ZNSt3__28ios_base17register_callbackEPFvNS0_5eventERS0_iEi: __ZNSt3__28ios_base17register_callbackEPFvNS0_5eventERS0_iEi, __ZN23PreloadManagerOperation19IntegrateMainThreadEv: __ZN23PreloadManagerOperation19IntegrateMainThreadEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Sc18ParticleSystemCore17getStaticFrictionEv: __ZNK5physx2Sc18ParticleSystemCore17getStaticFrictionEv, __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv: __ZNSt3__210__list_impINS_4pairIiNS1_IK4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEEEE11memory_poolIS9_EE5clearEv, __ZN7mecanim9animation15HasMotionCurvesERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation15HasMotionCurvesERKNS0_18ClipMuscleConstantE, __ZNKSt3__211__libcpp_db15__subscriptableEPKvi: __ZNKSt3__211__libcpp_db15__subscriptableEPKvi, __ZN17AnimationCurveTplI8Vector3fE16StripInvalidKeysEv: __ZN17AnimationCurveTplI8Vector3fE16StripInvalidKeysEv, _UNITY_FT_Angle_Diff: _UNITY_FT_Angle_Diff, __ZNK12MeshCollider13GetSharedMeshEv: __ZNK12MeshCollider13GetSharedMeshEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8pubimbueERKNS_6localeE: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8pubimbueERKNS_6localeE, __Z42Application_Get_Custom_PropRunInBackgroundv: __Z42Application_Get_Custom_PropRunInBackgroundv, __ZN16MBPOS_TmpBuffers15allocateUpdatedEjj: __ZN16MBPOS_TmpBuffers15allocateUpdatedEjj, __ZN8GUIStyle8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8GUIStyle8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetEnabledv: __Z68Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetEnabledv, __Z56Register_UnityEngine_ParticleAnimator_get_colorAnimationv: __Z56Register_UnityEngine_ParticleAnimator_get_colorAnimationv, __Z15NormalizeRobustRK8Vector3fRf: __Z15NormalizeRobustRK8Vector3fRf, __ZN9Transform25CompleteTransformTransferI17RemapPPtrTransferEEvRT_: __ZN9Transform25CompleteTransformTransferI17RemapPPtrTransferEEvRT_, __ZN5Unity5Joint5ResetEv: __ZN5Unity5Joint5ResetEv, __ZN5physx28PxDefaultCpuDispatcherCreateEjPj: __ZN5physx28PxDefaultCpuDispatcherCreateEjPj, __Z32SetVirtualJoystickConnectedStatePKcb: __Z32SetVirtualJoystickConnectedStatePKcb, __ZN5physx2Gu18intersectBoxConvexERKNS_13PxBoxGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E: __ZN5physx2Gu18intersectBoxConvexERKNS_13PxBoxGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj, __Z16getPxScene_FlagsPKN5physx7PxSceneE: __Z16getPxScene_FlagsPKN5physx7PxSceneE, __ZN12TreeInstance8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12TreeInstance8TransferI18StreamedBinaryReadILb1EEEEvRT_, _mbstowcs: _mbstowcs, __ZN14CachingManager10MarkAsUsedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128: __ZN14CachingManager10MarkAsUsedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128, __ZN20TextRenderingPrivate7GUITextD0Ev: __ZN20TextRenderingPrivate7GUITextD0Ev, __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE11flushEventsEv: __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE11flushEventsEv, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13SpeedTreeWind10SWindGroup8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SpeedTreeWind10SWindGroup8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN14NavMeshManager26SetAvoidancePredictionTimeEf: __ZN14NavMeshManager26SetAvoidancePredictionTimeEf, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl9lockClassEN5physx8debugger18NonNegativeIntegerE: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl9lockClassEN5physx8debugger18NonNegativeIntegerE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __Z56Register_UnityEngine_Input_INTERNAL_get_mouseScrollDeltav: __Z56Register_UnityEngine_Input_INTERNAL_get_mouseScrollDeltav, __ZN23ControllerContactFilterC2EPKN5physx7PxShapeE: __ZN23ControllerContactFilterC2EPKN5physx7PxShapeE, __ZN19CharacterController12GetSkinWidthEv: __ZN19CharacterController12GetSkinWidthEv, __ZN6Camera16TransformChangedEv: __ZN6Camera16TransformChangedEv, __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE8__appendEj: __ZNSt3__26vectorI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEE8__appendEj, __ZN19CullingGroupManager15InitializeClassEPv: __ZN19CullingGroupManager15InitializeClassEPv, __ZNK2UI6Canvas12GetPixelRectEv: __ZNK2UI6Canvas12GetPixelRectEv, __Z36Register_UnityEngine_Camera_get_mainv: __Z36Register_UnityEngine_Camera_get_mainv, __ZN5physx6shdfnd9SListImplC2Ev: __ZN5physx6shdfnd9SListImplC2Ev, __ZN10MemoryFile5FlushEv: __ZN10MemoryFile5FlushEv, __Z22TransferField_NonArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI14SafeBinaryRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN14ParticleSystem8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14ParticleSystem8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmittersCountP12Il2CppObject: __Z59ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmittersCountP12Il2CppObject, __ZNK5physx3Ext7D6Joint8getTwistEv: __ZNK5physx3Ext7D6Joint8getTwistEv, __ZN5physx19clothParticleWriterERNS_14PxOutputStreamERKNS_15PxClothParticleE: __ZN5physx19clothParticleWriterERNS_14PxOutputStreamERKNS_15PxClothParticleE, __ZNK5physx7NpScene12getTimestampEv: __ZNK5physx7NpScene12getTimestampEv, __ZNK13SparseTexture17GetUploadTileSizeEiRiS0_: __ZNK13SparseTexture17GetUploadTileSizeEiRiS0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __Z48Texture_CUSTOM_INTERNAL_CALL_GetNativeTexturePtrP12Il2CppObjectRPv: __Z48Texture_CUSTOM_INTERNAL_CALL_GetNativeTexturePtrP12Il2CppObjectRPv, __ZN16Physics2DManager15ColliderCastAllEPK10Collider2DRK8Vector2ffibP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager15ColliderCastAllEPK10Collider2DRK8Vector2ffibP13dynamic_arrayI12RaycastHit2DLj4EE, _UNITY_png_get_palette_max: _UNITY_png_get_palette_max, __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx12solveContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z14FMOD_FILE_OpenPKciPjPPvS3_: __Z14FMOD_FILE_OpenPKciPjPPvS3_, __ZN14Physics2DState11CreateWorldERK8Vector2f: __ZN14Physics2DState11CreateWorldERK8Vector2f, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE15growAndPushBackERKS2_, __ZN11UnityEngine15CloudWebService19SessionEventManager25GetUnusedSessionContainerERj: __ZN11UnityEngine15CloudWebService19SessionEventManager25GetUnusedSessionContainerERj, __ZN5physx7PxClothD0Ev: __ZN5physx7PxClothD0Ev, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEN17ArchiveFileSystem11ArchiveItemEEENS_19__map_value_compareIS8_SB_NS_4lessIS8_EELb1EEES5_ISB_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_, __Z13IsGyroEnabledi: __Z13IsGyroEnabledi, __ZN5physx3Scb4Body17switchBodyToNoSimEv: __ZN5physx3Scb4Body17switchBodyToNoSimEv, __Z40Register_UnityEngine_Animator_set_avatarv: __Z40Register_UnityEngine_Animator_set_avatarv, __ZN5physx23NpParticleFluidReadData6unlockEv: __ZN5physx23NpParticleFluidReadData6unlockEv, __ZN13SpeedTreeWind8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SpeedTreeWind8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj: __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6resizeEj, __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNK9GfxDevice26ShouldJobsSyncAtEndOfFrameEv: __ZNK9GfxDevice26ShouldJobsSyncAtEndOfFrameEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv, __Z47Register_UnityEngine_AudioChorusFilter_get_ratev: __Z47Register_UnityEngine_AudioChorusFilter_get_ratev, __Z26RegisterAllClassesGranularv: __Z26RegisterAllClassesGranularv, _toupper_l: _toupper_l, __ZN12TreeRendererC2ER12TreeDatabaseRK8Vector3f: __ZN12TreeRendererC2ER12TreeDatabaseRK8Vector3f, __Z19GetUnityAdsSettingsv: __Z19GetUnityAdsSettingsv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE15growAndPushBackERKS2_, _UNITY_png_set_keep_unknown_chunks: _UNITY_png_set_keep_unknown_chunks, __ZN26ProbeSetTetrahedralization11SetHullRaysEPK8Vector3fS2_: __ZN26ProbeSetTetrahedralization11SetHullRaysEPK8Vector3fS2_, __ZN5physx2Sn17RepXVisitorWriterINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE: __ZN5physx2Sn17RepXVisitorWriterINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE, __ZN10GUIManager18GetCursorFlashTimeEi: __ZN10GUIManager18GetCursorFlashTimeEi, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEaSEOS3_: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEaSEOS3_, __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, _jpeg_write_raw_data: _jpeg_write_raw_data, __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_: __ZN19RingbufferTemplates22WriteValueToRingBufferIi17GrowingRingbufferEEbRT0_RKT_, __ZN12FileAccessor5CloseEv: __ZN12FileAccessor5CloseEv, __ZN7Striper10TrackStripEjjjPjS0_Pbb: __ZN7Striper10TrackStripEjjjPjS0_Pbb, __ZNK12CubemapArray20GetTextureLayerCountEv: __ZNK12CubemapArray20GetTextureLayerCountEv, ___ipparse: ___ipparse, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_19updateCCDSinglePassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_, ___remdi3: ___remdi3, __ZNK15b2FrictionJoint10GetAnchorBEv: __ZNK15b2FrictionJoint10GetAnchorBEv, __ZN23ShaderVariantCollection8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN23ShaderVariantCollection8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN8Playable7DestroyEv: __ZN8Playable7DestroyEv, __ZNK19TextRenderingModule22TMGenGetCursorPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfEi: __ZNK19TextRenderingModule22TMGenGetCursorPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfEi, __Z20ReadObjectFromVectorR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags: __Z20ReadObjectFromVectorR6ObjectRK13dynamic_arrayIhLj1EE24TransferInstructionFlags, __ZSt14get_unexpectedv: __ZSt14get_unexpectedv, __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI24GenerateTypeTreeTransferEEvRT_, __Z33EmitSerializationCommandsForFieldI14SafeBinaryReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI14SafeBinaryReadEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN14SpriteRenderer15UpdateLocalAABBEv: __ZN14SpriteRenderer15UpdateLocalAABBEv, __ZN23b2ChainAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN23b2ChainAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator, __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetTypev: __Z59Register_UnityEngine_ParticleSystem_CollisionModule_SetTypev, __ZN9JSONWrite8TransferIsEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIsEEvRT_PKc17TransferMetaFlags, __ZN10MemoryPool13StaticDestroyEPv: __ZN10MemoryPool13StaticDestroyEPv, __ZN10SampleClip23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10SampleClip23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN17GameObjectManager13StaticDestroyEv: __ZN17GameObjectManager13StaticDestroyEv, __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_: __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEjT0_SD_SD_T_, __Z52Register_UnityEngine_AudioReverbZone_set_HFReferencev: __Z52Register_UnityEngine_AudioReverbZone_set_HFReferencev, __Z32Screen_Get_Custom_PropFullScreenv: __Z32Screen_Get_Custom_PropFullScreenv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE, __ZN9GfxDevice13AddBatchStatsE17GfxBatchStatsTypeiiiy: __ZN9GfxDevice13AddBatchStatsE17GfxBatchStatsTypeiiiy, __ZNKSt3__28numpunctIcE12do_falsenameEv: __ZNKSt3__28numpunctIcE12do_falsenameEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags, __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEbT0_SD_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEbT0_SD_T_, _ft_var_readpackedpoints: _ft_var_readpackedpoints, __ZNSt3__227__insertion_sort_incompleteIR12GreaterLayerPP14AnimationStateEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR12GreaterLayerPP14AnimationStateEEbT0_S6_T_, __ZN5physx14NpArticulation15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx14NpArticulation15importExtraDataERNS_24PxDeserializationContextE, __Z32setPxHeightFieldGeometryRowScalePN5physx21PxHeightFieldGeometryEf: __Z32setPxHeightFieldGeometryRowScalePN5physx21PxHeightFieldGeometryEf, __ZN11AudioSource13UpdateDopplerE12SoundChannelfR8Vector3fS2_: __ZN11AudioSource13UpdateDopplerE12SoundChannelfR8Vector3fS2_, __ZN9Animation17SetAnimatePhysicsEb: __ZN9Animation17SetAnimatePhysicsEb, __Z34Profiler_CUSTOM_SetSamplersEnabledh: __Z34Profiler_CUSTOM_SetSamplersEnabledh, __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN16MemoryFileSystem11CreateAsDirER13FileEntryData: __ZN16MemoryFileSystem11CreateAsDirER13FileEntryData, __ZN5physx10PxsContext27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE: __ZN5physx10PxsContext27setCCDContactModifyCallbackEPNS_26PxCCDContactModifyCallbackE, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE8recreateEj, __Z39ScriptingInstantiateObjectFromClassNamePKc: __Z39ScriptingInstantiateObjectFromClassNamePKc, __ZN5physx7NpClothD2Ev: __ZN5physx7NpClothD2Ev, __ZNK5physx2Sc8BodyCore14getInverseMassEv: __ZNK5physx2Sc8BodyCore14getInverseMassEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE12readPropertyIfEEbRT_, __ZN24GenerateTypeTreeTransfer5AlignEv: __ZN24GenerateTypeTreeTransfer5AlignEv, __ZN12MeshCollider13SetSharedMeshE4PPtrI4MeshE: __ZN12MeshCollider13SetSharedMeshE4PPtrI4MeshE, __ZN5physx2Sc18TriggerInteractionD0Ev: __ZN5physx2Sc18TriggerInteractionD0Ev, __ZNK5physx2Gu11HeightField12getNbColumnsEv: __ZNK5physx2Gu11HeightField12getNbColumnsEv, __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetEnabledv: __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetEnabledv, __Z43Register_UnityEngine_Camera_set_cullingMaskv: __Z43Register_UnityEngine_Camera_set_cullingMaskv, __Z50Register_UnityEngine_LineRenderer_set_numPositionsv: __Z50Register_UnityEngine_LineRenderer_set_numPositionsv, __ZN5physx2Sc10NPhaseCore13findActorPairEPNS0_8ShapeSimES3_: __ZN5physx2Sc10NPhaseCore13findActorPairEPNS0_8ShapeSimES3_, __ZN2UI14CanvasRenderer16SetMaterialCountEi: __ZN2UI14CanvasRenderer16SetMaterialCountEi, __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE: __ZN5physx14NpShapeManager9detachAllEPNS_7NpSceneE, ___errno_location: ___errno_location, __ZN9Animation7AddClipER13AnimationClip: __ZN9Animation7AddClipER13AnimationClip, __ZN13AnimationClip10FloatCurve8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13AnimationClip10FloatCurve8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13RuntimeStaticI14dynamic_bitsetE13StaticDestroyEPv: __ZN13RuntimeStaticI14dynamic_bitsetE13StaticDestroyEPv, __ZNK14dtNavMeshQuery18findDistanceToWallEyPKfPK13dtQueryFilterPfS5_S5_Pj: __ZNK14dtNavMeshQuery18findDistanceToWallEyPKfPK13dtQueryFilterPfS5_S5_Pj, __ZN7mecanim12statemachine17CreateStateOutputEPKNS0_13StateConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine17CreateStateOutputEPKNS0_13StateConstantERNS_6memory9AllocatorE, __ZN5physx6shdfnd4sortINS_2Sc8BodyRankENS0_7GreaterIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortINS_2Sc8BodyRankENS0_7GreaterIS3_EENS0_19ReflectionAllocatorIS3_EEEEvPT_jRKT0_RKT1_j, __ZNKSt16nested_exception14rethrow_nestedEv: __ZNKSt16nested_exception14rethrow_nestedEv, __ZNK5physx10NpMaterial14getRestitutionEv: __ZNK5physx10NpMaterial14getRestitutionEv, __ZN10AudioMixer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10AudioMixer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z25getPxHeightFieldDescFlagsPKN5physx17PxHeightFieldDescE: __Z25getPxHeightFieldDescFlagsPKN5physx17PxHeightFieldDescE, __ZN19ClampVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19ClampVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__28__c_nodeD2Ev: __ZNSt3__28__c_nodeD2Ev, __ZN17PersistentManager24ResetHighestFileIDAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager24ResetHighestFileIDAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getProjectionPlaneERNS_6PxVec3ERf: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getProjectionPlaneERNS_6PxVec3ERf, __Z35getPxHeightFieldGeometryHeightScalePKN5physx21PxHeightFieldGeometryE: __Z35getPxHeightFieldGeometryHeightScalePKN5physx21PxHeightFieldGeometryE, __ZN13GfxDeviceGLES16CreateDynamicVBOEv: __ZN13GfxDeviceGLES16CreateDynamicVBOEv, __Z15OffsetCurveTimeR17AnimationCurveTplIfEf: __Z15OffsetCurveTimeR17AnimationCurveTplIfEf, __ZN7ApiGLES16DispatchIndirectEjj: __ZN7ApiGLES16DispatchIndirectEjj, __ZN11OffMeshLink13AwakeFromLoadE17AwakeFromLoadMode: __ZN11OffMeshLink13AwakeFromLoadE17AwakeFromLoadMode, __ZN17GeneralConnection30UnregisterDisconnectionHandlerEPFvjE: __ZN17GeneralConnection30UnregisterDisconnectionHandlerEPFvjE, __ZN5physx7NpScene12checkResultsEb: __ZN5physx7NpScene12checkResultsEb, __ZN9Rigidbody8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Rigidbody8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z24RegisterStrippedTypeInfoI16ParticleAnimatorEviPKcS2_: __Z24RegisterStrippedTypeInfoI16ParticleAnimatorEviPKcS2_, __ZNKSt3__26locale5__imp9use_facetEl: __ZNKSt3__26locale5__imp9use_facetEl, _UNITY_png_get_pHYs_dpi: _UNITY_png_get_pHYs_dpi, __Z13SetIAnimationP10IAnimation: __Z13SetIAnimationP10IAnimation, __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z38Camera_Set_Custom_PropStereoSeparationP12Il2CppObjectf: __Z38Camera_Set_Custom_PropStereoSeparationP12Il2CppObjectf, __ZN9Scripting35GetComponentObjectToScriptingObjectEPN5Unity9ComponentER10GameObjectPKNS0_4TypeE: __ZN9Scripting35GetComponentObjectToScriptingObjectEPN5Unity9ComponentER10GameObjectPKNS0_4TypeE, __ZN5physx2Sc20ArticulationJointSim7destroyEv: __ZN5physx2Sc20ArticulationJointSim7destroyEv, __ZNK9Rigidbody11GetPositionEv: __ZNK9Rigidbody11GetPositionEv, __ZN5physx6shdfnd12PxRingBuffer11receiveDataERPKvRj: __ZN5physx6shdfnd12PxRingBuffer11receiveDataERPKvRj, __ZN6SpriteD2Ev: __ZN6SpriteD2Ev, __ZN4FMOD8ChannelI18setInputChannelMixEPfi: __ZN4FMOD8ChannelI18setInputChannelMixEPfi, __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR17CompareInstanceIDPP6ObjectEEjT0_S6_S6_S6_S6_T_, __ZN6Sphere3SetEPK8Vector3fj: __ZN6Sphere3SetEPK8Vector3fj, __Z23GetRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureType: __Z23GetRenderLoopTempBufferP10RenderLoop24BuiltinRenderTextureType, __Z26Light_Set_Custom_PropRangeP12Il2CppObjectf: __Z26Light_Set_Custom_PropRangeP12Il2CppObjectf, __ZN13b2DynamicTree12DestroyProxyEi: __ZN13b2DynamicTree12DestroyProxyEi, __ZNSt3__227__insertion_sort_incompleteIRPFbRK6b2PairS3_EPS1_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRK6b2PairS3_EPS1_EEbT0_S8_T_, _strnlen: _strnlen, __ZNK5physx5cloth8SwSolver17EndSimulationTask7getNameEv: __ZNK5physx5cloth8SwSolver17EndSimulationTask7getNameEv, __ZN9GfxDevice17DestroyGpuProgramEPK10GpuProgram: __ZN9GfxDevice17DestroyGpuProgramEPK10GpuProgram, __ZN9TextAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9TextAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZMultiplierv, __Z31AudioSource_Get_Custom_PropClipP12Il2CppObject: __Z31AudioSource_Get_Custom_PropClipP12Il2CppObject, __ZN10systeminfo23GetSystemLanguageStringEi: __ZN10systeminfo23GetSystemLanguageStringEi, __ZN11UnityEngine15CloudWebService14DataDispatcher29ResetDispatchSessionContainerERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher29ResetDispatchSessionContainerERNS0_16SessionContainerE, __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc11InteractionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z24Mathf_CUSTOM_HalfToFloatt: __Z24Mathf_CUSTOM_HalfToFloatt, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ES2_RKNS_18PxVehicleGearsDataES6_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ES2_RKNS_18PxVehicleGearsDataES6_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_, __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi: __ZN14SafeBinaryRead23IsVersionSmallerOrEqualEi, __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_: __ZNK17AnimationCurveTplI8Vector3fE20FindIndexForSamplingERKNS1_5CacheEfRiS5_, __Z30Sprite_Get_Custom_PropVerticesP12Il2CppObject: __Z30Sprite_Get_Custom_PropVerticesP12Il2CppObject, __ZN19AutoOffMeshLinkData8TransferI14SafeBinaryReadEEvRT_: __ZN19AutoOffMeshLinkData8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7NpScene17releaseBatchQueryEPNS_12PxBatchQueryE: __ZN5physx7NpScene17releaseBatchQueryEPNS_12PxBatchQueryE, __ZN5physx5cloth16SwInterCollisionI8Scalar4fEC2EPKNS0_20SwInterCollisionDataEjffjPFbPvS7_ER14StackAllocatorILj16EEPNS_13PxProfileZoneE: __ZN5physx5cloth16SwInterCollisionI8Scalar4fEC2EPKNS0_20SwInterCollisionDataEjffjPFbPvS7_ER14StackAllocatorILj16EEPNS_13PxProfileZoneE, __ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv: __ZN33AssetBundleLoadFromAsyncOperation33TryToLoadAndInitializeAssetBundleEv, __ZNK5physx15PxsArticulation16computeResidualsEPKNS_2Cm13SpatialVectorEPKNS_30PxcArticulationJointTransformsEb: __ZNK5physx15PxsArticulation16computeResidualsEPKNS_2Cm13SpatialVectorEPKNS_30PxcArticulationJointTransformsEb, __Z27RegisterAllowNameConversionPKcS0_S0_: __Z27RegisterAllowNameConversionPKcS0_S0_, __ZN5physx2Sc5Scene20clearSleepWakeBodiesEv: __ZN5physx2Sc5Scene20clearSleepWakeBodiesEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_jj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_jj, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags, __Z33Texture_Set_Custom_PropFilterModeP12Il2CppObjecti: __Z33Texture_Set_Custom_PropFilterModeP12Il2CppObjecti, __Z42Register_UnityEngine_Time_get_unscaledTimev: __Z42Register_UnityEngine_Time_get_unscaledTimev, __ZN5physx2Sq12BucketPrunerD0Ev: __ZN5physx2Sq12BucketPrunerD0Ev, __Z36Register_UnityEngine_Texture3D_Applyv: __Z36Register_UnityEngine_Texture3D_Applyv, __ZN12HandlerChainD0Ev: __ZN12HandlerChainD0Ev, __ZN5physx9NpFactory22releaseAggregateToPoolERNS_11NpAggregateE: __ZN5physx9NpFactory22releaseAggregateToPoolERNS_11NpAggregateE, __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17AnimationCurveTplI11QuaternionfE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5audio5mixer11IsSuspendedERKNS0_16AudioMixerMemoryE: __ZN5audio5mixer11IsSuspendedERKNS0_16AudioMixerMemoryE, __ZZN8VRModuleC1EvEN30beforeInitializeEngineGraphics7ForwardEv: __ZZN8VRModuleC1EvEN30beforeInitializeEngineGraphics7ForwardEv, __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityv: __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityv, __Z37VRSettings_Set_Custom_PropRenderScalef: __Z37VRSettings_Set_Custom_PropRenderScalef, __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff: __ZN12TreeRenderer13RenderRecurseEP14TreeBinaryTreePK5PlaneR13dynamic_arrayIjLj4EERK8Vector3fff, __Z35getPxRevoluteJoint_ConcreteTypeNamePKN5physx15PxRevoluteJointE: __Z35getPxRevoluteJoint_ConcreteTypeNamePKN5physx15PxRevoluteJointE, __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyRotationInternalv: __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyRotationInternalv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getLinearDragEv, __ZN5physx7Cooking20validateTriangleMeshERKNS_18PxTriangleMeshDescE: __ZN5physx7Cooking20validateTriangleMeshERKNS_18PxTriangleMeshDescE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj285ENS_22PxRepXPropertyAccessorILj285ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj285ENS_22PxRepXPropertyAccessorILj285ES4_ffEEEEvRKT0_, __ZN13RenderTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13RenderTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRT_RT0_, __ZN18AnimatorController23GetAnimationSetBindingsEv: __ZN18AnimatorController23GetAnimationSetBindingsEv, __ZNK13BuildSettings26GetTypeInfoVirtualInternalEv: __ZNK13BuildSettings26GetTypeInfoVirtualInternalEv, __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Vector4f8TransferI24GenerateTypeTreeTransferEEvRT_, __Z70Register_UnityEngine_Profiling_Profiler_get_maxNumberOfSamplesPerFramev: __Z70Register_UnityEngine_Profiling_Profiler_get_maxNumberOfSamplesPerFramev, __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN17ProceduralTexture32FixNormalUsageAndFormatAtRuntimeEv: __ZN17ProceduralTexture32FixNormalUsageAndFormatAtRuntimeEv, _UNITY_png_free_default: _UNITY_png_free_default, __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIeeEEPeEEjT0_S5_S5_T_, __Z56Register_UnityEngine_RenderSettings_set_ambientIntensityv: __Z56Register_UnityEngine_RenderSettings_set_ambientIntensityv, __ZN19SharedRendererSceneD2Ev: __ZN19SharedRendererSceneD2Ev, __ZN4FileD2Ev: __ZN4FileD2Ev, __ZNK5physx23PxsSolverSetupSolveTask7getNameEv: __ZNK5physx23PxsSolverSetupSolveTask7getNameEv, __Z42ReflectionProbe_Set_Custom_PropRefreshModeP12Il2CppObjecti: __Z42ReflectionProbe_Set_Custom_PropRefreshModeP12Il2CppObjecti, __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj: __ZN4crnd13prefix_coding14decoder_tables4initEjPKhj, __Z53Register_UnityEngine_Animator_CheckIfInIKPassInternalv: __Z53Register_UnityEngine_Animator_CheckIfInIKPassInternalv, __ZeoRK8Scalar4fS1_: __ZeoRK8Scalar4fS1_, __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j: __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E9copy_fromERKSI_j, __Z50Register_UnityEngine_GUITexture_INTERNAL_set_colorv: __Z50Register_UnityEngine_GUITexture_INTERNAL_set_colorv, __ZNSt3__212ctype_bynameIcEC2EPKcj: __ZNSt3__212ctype_bynameIcEC2EPKcj, __ZN12TextureIdMap7CleanupEv: __ZN12TextureIdMap7CleanupEv, __ZN10MemoryPoolD2Ev: __ZN10MemoryPoolD2Ev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev, __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z33scripting_capture_memory_snapshotv: __Z33scripting_capture_memory_snapshotv, __Z34Camera_Get_Custom_PropOrthographicP12Il2CppObject: __Z34Camera_Get_Custom_PropOrthographicP12Il2CppObject, __Z25scripting_class_get_imageP11Il2CppClass: __Z25scripting_class_get_imageP11Il2CppClass, __Z36getPxVehicleDriveDynDataMEnginespeedPKN5physx21PxVehicleDriveDynDataE: __Z36getPxVehicleDriveDynDataMEnginespeedPKN5physx21PxVehicleDriveDynDataE, __Z48Register_UnityEngine_Display_RelativeMouseAtImplv: __Z48Register_UnityEngine_Display_RelativeMouseAtImplv, __Z43getPxVehicleSuspensionDataMCamberAtMaxDroopPKN5physx23PxVehicleSuspensionDataE: __Z43getPxVehicleSuspensionDataMCamberAtMaxDroopPKN5physx23PxVehicleSuspensionDataE, __ZNK14TerrainManager31GetSplatBaseMaterialTextureNameEv: __ZNK14TerrainManager31GetSplatBaseMaterialTextureNameEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj141ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15switchFromNoSimEv: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15switchFromNoSimEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _jinit_downsampler: _jinit_downsampler, __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15AnchoredJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__217moneypunct_bynameIcLb1EE4initEPKc: __ZNSt3__217moneypunct_bynameIcLb1EE4initEPKc, __ZN11AudioSource26SetCustomSpatialBlendCurveERK17AnimationCurveTplIfE: __ZN11AudioSource26SetCustomSpatialBlendCurveERK17AnimationCurveTplIfE, __ZNK9GfxDevice21GetDefaultHDRRTFormatEv: __ZNK9GfxDevice21GetDefaultHDRRTFormatEv, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE12setActorFlagENS_11PxActorFlag4EnumEb, __Z63Register_UnityEngine_AI_NavMeshObstacle_get_carveOnlyStationaryv: __Z63Register_UnityEngine_AI_NavMeshObstacle_get_carveOnlyStationaryv, __Z47NavMesh_CUSTOM_SetPathfindingIterationsPerFramei: __Z47NavMesh_CUSTOM_SetPathfindingIterationsPerFramei, __Z45ParticleSystem_LightsModule_CUSTOM_GetEnabledP12Il2CppObject: __Z45ParticleSystem_LightsModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN12LightsModule17MainThreadCleanupEv: __ZN12LightsModule17MainThreadCleanupEv, __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Warpv: __Z55Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Warpv, __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __Z27Component_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString: __Z27Component_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString, __ZN16HumanPoseHandler12SetHumanPoseER8Vector3fR11QuaternionfPf: __ZN16HumanPoseHandler12SetHumanPoseER8Vector3fR11QuaternionfPf, __ZN22ParticleCollisionEventC2ERK8Vector3fS2_S2_ii: __ZN22ParticleCollisionEventC2ERK8Vector3fS2_S2_ii, __ZNSt3__212__get_sp_mutEPKv: __ZNSt3__212__get_sp_mutEPKv, __Z38BillboardAsset_Get_Custom_PropMaterialP12Il2CppObject: __Z38BillboardAsset_Get_Custom_PropMaterialP12Il2CppObject, __Z50Register_UnityEngine_AssetBundle_LoadFromFileAsyncv: __Z50Register_UnityEngine_AssetBundle_LoadFromFileAsyncv, __ZN17Physics2DSettings8TransferI14SafeBinaryReadEEvRT_: __ZN17Physics2DSettings8TransferI14SafeBinaryReadEEvRT_, __ZN5physx23PxsBroadPhaseContextSap13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE: __ZN5physx23PxsBroadPhaseContextSap13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE, __ZN5Umbra12PortalCuller7executeERNS_16VisibilityResultEbbRKNS_4AABBEi: __ZN5Umbra12PortalCuller7executeERNS_16VisibilityResultEbbRKNS_4AABBEi, _perror: _perror, __Z41AreaEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf: __Z41AreaEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf, __ZSt17current_exceptionv: __ZSt17current_exceptionv, __ZN9Rigidbody23SetSleepAngularVelocityEf: __ZN9Rigidbody23SetSleepAngularVelocityEf, __Z18IsLinearCollectionP11Il2CppClass: __Z18IsLinearCollectionP11Il2CppClass, __ZN5physx24PxD6JointGeneratedValuesC2EPKNS_9PxD6JointE: __ZN5physx24PxD6JointGeneratedValuesC2EPKNS_9PxD6JointE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorForceMode2DEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorForceMode2DEvRT_RT0_PKc17TransferMetaFlags, __ZN10HumanTrait11RightFinger12GetBoneCountEv: __ZN10HumanTrait11RightFinger12GetBoneCountEv, __ZN8GUIStateC2Ei: __ZN8GUIStateC2Ei, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj469ENS_22PxRepXPropertyAccessorILj469ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj469ENS_22PxRepXPropertyAccessorILj469ES4_ffEEEEvRKT0_, __Z42Register_UnityEngine_Canvas_get_renderModev: __Z42Register_UnityEngine_Canvas_get_renderModev, __Z32HumanTrait_CUSTOM_BoneFromMusclei: __Z32HumanTrait_CUSTOM_BoneFromMusclei, __ZN11UTF16String12BorrowStringEP12Il2CppString: __ZN11UTF16String12BorrowStringEP12Il2CppString, __ZN12SocketStream7RecvAllEPvjl: __ZN12SocketStream7RecvAllEPvjl, __ZN8Renderer26SupportedMessagesDidChangeEi: __ZN8Renderer26SupportedMessagesDidChangeEi, __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN13DrawImmediate11TexCoordAllEfff: __ZN13DrawImmediate11TexCoordAllEfff, __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationXTilev: __Z58Register_UnityEngine_ParticleRenderer_get_uvAnimationXTilev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj560ES3_NS_27PxVehicleClutchAccuracyMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEclILj560ES3_NS_27PxVehicleClutchAccuracyMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11UnityEngine15CloudWebService13WWWRestClient10ReleaseWWWEv: __ZN11UnityEngine15CloudWebService13WWWRestClient10ReleaseWWWEv, __ZN5Umbra20RuntimeTomeGenerator21makeNeighborBitvectorEiRKNS_5ArrayIiEEbRNS1_IjEEPKNS0_6ResultE: __ZN5Umbra20RuntimeTomeGenerator21makeNeighborBitvectorEiRKNS_5ArrayIiEEbRNS1_IjEEPKNS0_6ResultE, __Z41Register_UnityEngine_Event_set_clickCountv: __Z41Register_UnityEngine_Event_set_clickCountv, __Z32GL_CUSTOM_INTERNAL_CALL_TexCoordRK8Vector3f: __Z32GL_CUSTOM_INTERNAL_CALL_TexCoordRK8Vector3f, __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetEnabledv: __Z64Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetEnabledv, _close: _close, __Z45Canvas_Get_Custom_PropCachedSortingLayerValueP12Il2CppObject: __Z45Canvas_Get_Custom_PropCachedSortingLayerValueP12Il2CppObject, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_14postCCDAdvanceEPNS_10PxBaseTaskEEEE11runInternalEv, __ZNK5physx3Cct13BoxController14getUpDirectionEv: __ZNK5physx3Cct13BoxController14getUpDirectionEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj172ENS_22PxRepXPropertyAccessorILj172ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN11UnityEngine9Animation38InitializeGenericAnimationBindingCacheEPv: __ZN11UnityEngine9Animation38InitializeGenericAnimationBindingCacheEPv, __ZN13b2PulleyJointD0Ev: __ZN13b2PulleyJointD0Ev, __ZN22ParticleSystemRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN22ParticleSystemRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __GLOBAL__sub_I_platformdependent_webgl_source_lump_cpp: __GLOBAL__sub_I_platformdependent_webgl_source_lump_cpp, __Z23CullObjectsWithoutUmbraRK17CullingParametersPK4AABBR9IndexList: __Z23CullObjectsWithoutUmbraRK17CullingParametersPK4AABBR9IndexList, _ycck_cmyk_convert: _ycck_cmyk_convert, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE26getRelativeAngularVelocityEv, __Z39OffMeshLink_Set_Custom_PropEndTransformP12Il2CppObjectS0_: __Z39OffMeshLink_Set_Custom_PropEndTransformP12Il2CppObjectS0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj182ENS_22PxRepXPropertyAccessorILj182ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN10InputEventaSERKS_: __ZN10InputEventaSERKS_, ___dns_query: ___dns_query, __ZN17GlobalGameManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN17GlobalGameManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_: __Z14tessMeshSpliceP8TESSmeshP12TESShalfEdgeS2_, __Z5WhiteP9Texture2DPhiiii: __Z5WhiteP9Texture2DPhiiii, _UNITY_png_xy_from_XYZ: _UNITY_png_xy_from_XYZ, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__grow_byEjjjjjj, __Z53Register_UnityEngine_Terrain_get_detailObjectDistancev: __Z53Register_UnityEngine_Terrain_get_detailObjectDistancev, __ZN5physx2Cm17FreeListAllocator8allocateEjPKcS3_i: __ZN5physx2Cm17FreeListAllocator8allocateEjPKcS3_i, __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_115parse_simple_idINS0_2DbEEEPKcS4_S4_RT_, __ZN14GfxDeviceStats19EndClientFrameStatsEv: __ZN14GfxDeviceStats19EndClientFrameStatsEv, __ZN11UmbraModule23CullDynamicObjectsUmbraEPK4AABBPKN5Umbra15OcclusionBufferER9IndexList: __ZN11UmbraModule23CullDynamicObjectsUmbraEPK4AABBPKN5Umbra15OcclusionBufferER9IndexList, __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fPS2_i: __Z18TransformPoints3x4RK10Matrix4x4fPK8Vector3fPS2_i, __ZN5physx2Gu5RTree17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu5RTree17getBinaryMetaDataERNS_14PxOutputStreamE, __Z31Collider_Get_Custom_PropEnabledP12Il2CppObject: __Z31Collider_Get_Custom_PropEnabledP12Il2CppObject, __Z12storeAlignedPfRK8Scalar4f: __Z12storeAlignedPfRK8Scalar4f, __ZN5physx23PxcContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx23PxcContactSphereCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z43Register_UnityEngine_AI_NavMesh_SetAreaCostv: __Z43Register_UnityEngine_AI_NavMesh_SetAreaCostv, __Z28CheckPlatformSupportsShadowsv: __Z28CheckPlatformSupportsShadowsv, __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb: __ZN7mecanim12SetValueMaskEPNS_14ValueArrayMaskEb, __ZN5physx17NpMaterialManager16releaseMaterialsEv: __ZN5physx17NpMaterialManager16releaseMaterialsEv, __Z38RenderTexture_Get_Custom_PropIsCubemapP12Il2CppObject: __Z38RenderTexture_Get_Custom_PropIsCubemapP12Il2CppObject, __ZN12_GLOBAL__N_110Connection8setColorEPKvRKN5physx8debugger8PvdColorE: __ZN12_GLOBAL__N_110Connection8setColorEPKvRKN5physx8debugger8PvdColorE, __ZN11UnityEngine15PlatformWrapper27GetApplicationInstallerNameEv: __ZN11UnityEngine15PlatformWrapper27GetApplicationInstallerNameEv, __ZN4PPtrI18AnimatorControllerE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI18AnimatorControllerE8TransferI14SafeBinaryReadEEvRT_, __ZN18ProceduralMaterialD2Ev: __ZN18ProceduralMaterialD2Ev, _UNITY_png_get_interlace_type: _UNITY_png_get_interlace_type, __Z47Register_UnityEngine_BillboardAsset_SetVerticesv: __Z47Register_UnityEngine_BillboardAsset_SetVerticesv, __ZN20BufferedSocketStream4SendEPKvj: __ZN20BufferedSocketStream4SendEPKvj, __Z35RenderTexture_Get_Custom_PropActivev: __Z35RenderTexture_Get_Custom_PropActivev, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E14squash_deletedEv, __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject: __Z39WebCamTexture_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject, __ZN5physx2Gu28computeMTD_SphereHeightFieldERNS_6PxVec3ERfRKNS0_6SphereERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE: __ZN5physx2Gu28computeMTD_SphereHeightFieldERNS_6PxVec3ERfRKNS0_6SphereERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE, __ZNK5physx3Cct17CapsuleController8getStatsERNS_17PxControllerStatsE: __ZNK5physx3Cct17CapsuleController8getStatsERNS_17PxControllerStatsE, __ZNSt3__26vectorINS0_IfNS_9allocatorIfEEEENS1_IS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorINS0_IfNS_9allocatorIfEEEENS1_IS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_, __Z34Rigidbody2D_Set_Custom_PropInertiaP12Il2CppObjectf: __Z34Rigidbody2D_Set_Custom_PropInertiaP12Il2CppObjectf, __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmPKwSC_: __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmPKwSC_, ___mmap: ___mmap, __Z34GeomOverlapCallback_BoxHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z34GeomOverlapCallback_BoxHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN13GfxDeviceGLES15ActivateDisplayEj: __ZN13GfxDeviceGLES15ActivateDisplayEj, __Z21IsAssetBundleFilenameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z21IsAssetBundleFilenameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN12WheelJoint2DD2Ev: __ZN12WheelJoint2DD2Ev, __ZN15AnchoredJoint2DD0Ev: __ZN15AnchoredJoint2DD0Ev, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE15testVertexIndexEj, __Z34RegisterPrepareRenderNodesCallbackiPFvR35RenderNodeQueuePrepareThreadContextES2_PFPvvEPFvS3_E: __Z34RegisterPrepareRenderNodesCallbackiPFvR35RenderNodeQueuePrepareThreadContextES2_PFPvvEPFvS3_E, __ZN5physx2Gu17computeMTD_BoxBoxERNS_6PxVec3ERfRKNS0_3BoxES6_: __ZN5physx2Gu17computeMTD_BoxBoxERNS_6PxVec3ERfRKNS0_3BoxES6_, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10eventValueEtyx, __ZZN12NavMeshAgent15InitializeClassEvEN32FunctorImpl_103kTransformChanged4CallEPviR11MessageData: __ZZN12NavMeshAgent15InitializeClassEvEN32FunctorImpl_103kTransformChanged4CallEPviR11MessageData, __Z37getPxSceneDescFrictionOffsetThresholdPKN5physx11PxSceneDescE: __Z37getPxSceneDescFrictionOffsetThresholdPKN5physx11PxSceneDescE, __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E: __ZN9Transform35SetLocalRotationWithoutNotificationERKN4math7_float4E, __Z67Register_UnityEngine_Connect_UnityConnectSettings_get_testConfigUrlv: __Z67Register_UnityEngine_Connect_UnityConnectSettings_get_testConfigUrlv, __ZN13WheelCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN13WheelCollider23VirtualRedirectTransferER14SafeBinaryRead, __Z42Register_UnityEngine_Renderer_set_materialv: __Z42Register_UnityEngine_Renderer_set_materialv, __Z26Transform_CUSTOM_SetParentP12Il2CppObjectS0_h: __Z26Transform_CUSTOM_SetParentP12Il2CppObjectS0_h, __ZN13TranslateGLES10InitFormatERK12GraphicsCaps: __ZN13TranslateGLES10InitFormatERK12GraphicsCaps, __ZNK12TreeRenderer15GetTreePositionERK12TreeInstance: __ZNK12TreeRenderer15GetTreePositionERK12TreeInstance, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj478ES3_NS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj478ES3_NS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier52ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP5Light13stl_allocatorIS2_L18MemLabelIdentifier52ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN14AnimationState18ShouldMixTransformER9Transform: __ZN14AnimationState18ShouldMixTransformER9Transform, __ZN15ParticleEmitter8TransferI17RemapPPtrTransferEEvRT_: __ZN15ParticleEmitter8TransferI17RemapPPtrTransferEEvRT_, __ZN13GfxDeviceNull19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_: __ZN13GfxDeviceNull19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_, __ZN27AnimationLayerMixerPlayable19DeallocateResourcesEv: __ZN27AnimationLayerMixerPlayable19DeallocateResourcesEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj556ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj556ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18AudioMixerSnapshot8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18AudioMixerSnapshot8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK10FileSystem10ToAbsoluteEPKc: __ZNK10FileSystem10ToAbsoluteEPKc, __Z28setPxMaterial_StaticFrictionPN5physx10PxMaterialEf: __Z28setPxMaterial_StaticFrictionPN5physx10PxMaterialEf, __ZZN2UI6Canvas15InitializeClassEvEN39FunctorImpl_1284kCanvasHierarchyChanged4CallEPviR11MessageData: __ZZN2UI6Canvas15InitializeClassEvEN39FunctorImpl_1284kCanvasHierarchyChanged4CallEPviR11MessageData, __Z53Register_UnityEngine_TextGenerator_get_characterCountv: __Z53Register_UnityEngine_TextGenerator_get_characterCountv, __Z41ParticleSystem_Get_Custom_PropScalingModeP12Il2CppObject: __Z41ParticleSystem_Get_Custom_PropScalingModeP12Il2CppObject, __ZNSt3__26locale5__imp12install_fromINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, __ZN11TimeManager13StepFixedTimeEv: __ZN11TimeManager13StepFixedTimeEv, __Z49ParticleSystem_MainModule_CUSTOM_GetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_MainModule_CUSTOM_GetStartLifetimeP12Il2CppObjectR15MonoMinMaxCurve, __Z50AnimatorControllerPlayable_CUSTOM_SetTriggerStringR9HPlayableP12Il2CppString: __Z50AnimatorControllerPlayable_CUSTOM_SetTriggerStringR9HPlayableP12Il2CppString, __ZN11MonoManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN11MonoManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN7Terrain15AddTreeInstanceERK12TreeInstance: __ZN7Terrain15AddTreeInstanceERK12TreeInstance, __ZNK19SkinnedMeshRenderer29GetValidBlendShapeWeightCountEv: __ZNK19SkinnedMeshRenderer29GetValidBlendShapeWeightCountEv, __ZN13RuntimeStaticI18AssetBundleManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI18AssetBundleManagerE16StaticInitializeEPv, __ZN5Unity17ConfigurableJoint17SetAngularXMotionEi: __ZN5Unity17ConfigurableJoint17SetAngularXMotionEi, __ZNK5physx7NpShape12getMaterialsEPPNS_10PxMaterialEj: __ZNK5physx7NpShape12getMaterialsEPPNS_10PxMaterialEj, _cf2_getOtherBlues: _cf2_getOtherBlues, __Z36AndroidJNI_CUSTOM_GetIntArrayElement13Il2Cpp_IntPtri: __Z36AndroidJNI_CUSTOM_GetIntArrayElement13Il2Cpp_IntPtri, __Z31Rigidbody2D_Get_Custom_PropDragP12Il2CppObject: __Z31Rigidbody2D_Get_Custom_PropDragP12Il2CppObject, __ZN20PxsAtomIntegrateTaskD0Ev: __ZN20PxsAtomIntegrateTaskD0Ev, __ZN4crnd25crnd_crn_format_to_fourccE10crn_format: __ZN4crnd25crnd_crn_format_to_fourccE10crn_format, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZNK9Rigidbody11GetVelocityEv: __ZNK9Rigidbody11GetVelocityEv, __ZN5physx2Gu17GetGeomSweepFuncsEv: __ZN5physx2Gu17GetGeomSweepFuncsEv, __Z54Camera_CUSTOM_INTERNAL_get_nonJitteredProjectionMatrixP12Il2CppObjectP10Matrix4x4f: __Z54Camera_CUSTOM_INTERNAL_get_nonJitteredProjectionMatrixP12Il2CppObjectP10Matrix4x4f, __ZN14RenderSettings13CalcFogFactorEff: __ZN14RenderSettings13CalcFogFactorEff, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewByteArrayv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewByteArrayv, __ZN9AudioClip13AwakeFromLoadE17AwakeFromLoadMode: __ZN9AudioClip13AwakeFromLoadE17AwakeFromLoadMode, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_17PxCapsuleGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_17PxCapsuleGeometryE, __ZN18JobBatchDispatcher8KickJobsEv: __ZN18JobBatchDispatcher8KickJobsEv, __Z70RectTransformUtility_CUSTOM_INTERNAL_CALL_RectangleContainsScreenPointP12Il2CppObjectRK13Vector2fIcallS0_: __Z70RectTransformUtility_CUSTOM_INTERNAL_CALL_RectangleContainsScreenPointP12Il2CppObjectRK13Vector2fIcallS0_, __ZN5physx2Sn5ConvX6read16ERPKv: __ZN5physx2Sn5ConvX6read16ERPKv, __ZNK5physx16PxsSolverExtBody9getAngVelEv: __ZNK5physx16PxsSolverExtBody9getAngVelEv, __ZN9Transform19GetLocalEulerAnglesEN4math13RotationOrderE: __ZN9Transform19GetLocalEulerAnglesEN4math13RotationOrderE, __ZN4FMOD6System10getChannelEiPPNS_7ChannelE: __ZN4FMOD6System10getChannelEiPPNS_7ChannelE, __Z50Register_UnityEngine_GUIUtility_get_textFieldInputv: __Z50Register_UnityEngine_GUIUtility_get_textFieldInputv, __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsLevelv: __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsLevelv, __Z21getPxCloth_IsSleepingPKN5physx7PxClothE: __Z21getPxCloth_IsSleepingPKN5physx7PxClothE, __ZN21AnimationClipOverride8TransferI14SafeBinaryReadEEvRT_: __ZN21AnimationClipOverride8TransferI14SafeBinaryReadEEvRT_, __Z63Register_UnityEngine_AudioHighPassFilter_set_highpassResonanceQv: __Z63Register_UnityEngine_AudioHighPassFilter_set_highpassResonanceQv, __ZN17b2ContactListenerD2Ev: __ZN17b2ContactListenerD2Ev, __Z48Register_UnityEngine_Object_Internal_CloneSinglev: __Z48Register_UnityEngine_Object_Internal_CloneSinglev, __Z52Register_UnityEngine_AudioSource_GetSpatializerFloatv: __Z52Register_UnityEngine_AudioSource_GetSpatializerFloatv, __ZN2UI6Canvas25UpdateCanvasRectTransformEb: __ZN2UI6Canvas25UpdateCanvasRectTransformEb, __ZN26AnimatorControllerPlayable12GetLayerNameEi: __ZN26AnimatorControllerPlayable12GetLayerNameEi, __ZN9Texture2D34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction: __ZN9Texture2D34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction, __ZN15CapsuleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15CapsuleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z34GUIUtility_CUSTOM_GrabMouseControli: __Z34GUIUtility_CUSTOM_GrabMouseControli, __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE, __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS3_EEvRT_, __ZNK19LowerResBlitTexture13GetDataHeightEv: __ZNK19LowerResBlitTexture13GetDataHeightEv, __ZN15RenderNodeQueueD2Ev: __ZN15RenderNodeQueueD2Ev, __Z47Register_UnityEngine_AudioEchoFilter_get_dryMixv: __Z47Register_UnityEngine_AudioEchoFilter_get_dryMixv, __Z29Animator_CUSTOM_StartPlaybackP12Il2CppObject: __Z29Animator_CUSTOM_StartPlaybackP12Il2CppObject, __ZN20TextRenderingPrivate8FontImpl34GetNumCharactersThatFitWithinWidthERK11UTF16Stringfij: __ZN20TextRenderingPrivate8FontImpl34GetNumCharactersThatFitWithinWidthERK11UTF16Stringfij, __ZN12b2BroadPhase9MoveProxyEiRK6b2AABBRK6b2Vec2: __ZN12b2BroadPhase9MoveProxyEiRK6b2AABBRK6b2Vec2, __Z47Register_UnityEngine_Animator_get_isOptimizablev: __Z47Register_UnityEngine_Animator_get_isOptimizablev, __ZN18BuoyancyEffector2D13SetLinearDragEf: __ZN18BuoyancyEffector2D13SetLinearDragEf, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z37HingeJoint_CUSTOM_INTERNAL_set_springP12Il2CppObjectRK11JointSpring: __Z37HingeJoint_CUSTOM_INTERNAL_set_springP12Il2CppObjectRK11JointSpring, _UNITY_FT_New_Library: _UNITY_FT_New_Library, __ZN4FMOD7ReverbI9setActiveEb: __ZN4FMOD7ReverbI9setActiveEb, __ZN20UnloadSceneOperation7PerformEv: __ZN20UnloadSceneOperation7PerformEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_: __Z13TransformAABBRK4AABBRK10Matrix4x4fRS_, __ZN10PngDecoderD0Ev: __ZN10PngDecoderD0Ev, __Z50Register_UnityEngine_GUI_INTERNAL_set_contentColorv: __Z50Register_UnityEngine_GUI_INTERNAL_set_contentColorv, __Z16ByteSwapDateTimeR8DateTime: __Z16ByteSwapDateTimeR8DateTime, __Z63Register_UnityEngine_AssetBundle_get_isStreamedSceneAssetBundlev: __Z63Register_UnityEngine_AssetBundle_get_isStreamedSceneAssetBundlev, __Z54PolygonCollider2D_CUSTOM_INTERNAL_CALL_CreatePrimitiveP12Il2CppObjectiRK13Vector2fIcallS3_: __Z54PolygonCollider2D_CUSTOM_INTERNAL_CALL_CreatePrimitiveP12Il2CppObjectiRK13Vector2fIcallS3_, __Z35ParticleSystem_CUSTOM_Internal_PlayP12Il2CppObject: __Z35ParticleSystem_CUSTOM_Internal_PlayP12Il2CppObject, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7releaseEv, __Z57ParticleSystem_ShapeModule_CUSTOM_SetUseMeshMaterialIndexP12Il2CppObjecth: __Z57ParticleSystem_ShapeModule_CUSTOM_SetUseMeshMaterialIndexP12Il2CppObjecth, _tre_ast_new_node: _tre_ast_new_node, __Z48Register_UnityEngine_MonoBehaviour_StopCoroutinev: __Z48Register_UnityEngine_MonoBehaviour_StopCoroutinev, _h2v2_fancy_upsample: _h2v2_fancy_upsample, __ZN5physx6shdfnd8SyncImpl5resetEv: __ZN5physx6shdfnd8SyncImpl5resetEv, __Z56getPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE: __Z56getPxVehicleTireLoadFilterDataMMinFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE, __Z45Register_UnityEngine_Renderer_set_castShadowsv: __Z45Register_UnityEngine_Renderer_set_castShadowsv, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN16ScriptingManager33RebuildNativeTypeToScriptingClassEv: __ZN16ScriptingManager33RebuildNativeTypeToScriptingClassEv, __Z40Terrain_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi: __Z40Terrain_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi, __ZN10GUITexture23VirtualRedirectTransferER14SafeBinaryRead: __ZN10GUITexture23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z55Register_UnityEngine_Connect_UnityAdsSettings_SetGameIdv: __Z55Register_UnityEngine_Connect_UnityAdsSettings_SetGameIdv, __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK8Vector3f: __Z48ParticleSystemRenderer_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK8Vector3f, __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5Unity17ConfigurableJoint8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity17ConfigurableJoint8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11JpegDecoderD0Ev: __ZN11JpegDecoderD0Ev, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN22BaseUnityConnectClientD0Ev: __ZN22BaseUnityConnectClientD0Ev, __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_: __Z17b2CollidePolygonsP10b2ManifoldPK14b2PolygonShapeRK11b2TransformS3_S6_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale0Ef, __Z28Sprite_Get_Custom_PropPackedP12Il2CppObject: __Z28Sprite_Get_Custom_PropPackedP12Il2CppObject, __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiii11ColorRGBA32P8Materiali: __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiii11ColorRGBA32P8Materiali, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4swapERS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4swapERS5_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE8pushNameEPKc, __ZN15DistanceJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15DistanceJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__28messagesIwED0Ev: __ZNSt3__28messagesIwED0Ev, __ZN10TagManager29GetSortingLayerIndexFromValueEi: __ZN10TagManager29GetSortingLayerIndexFromValueEi, __ZN5physx18RepXSerializerImplINS_7PxClothEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_7PxClothEE11getTypeNameEv, __ZN16MecanimAnimationD2Ev: __ZN16MecanimAnimationD2Ev, __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudev: __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetMagnitudev, __Z32NavMeshAgent_CUSTOM_StopInternalP12Il2CppObject: __Z32NavMeshAgent_CUSTOM_StopInternalP12Il2CppObject, __Z41AudioReverbFilter_Get_Custom_PropDryLevelP12Il2CppObject: __Z41AudioReverbFilter_Get_Custom_PropDryLevelP12Il2CppObject, __Z68Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawPrefixLabelv: __Z68Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawPrefixLabelv, _UNITY_png_read_finish_IDAT: _UNITY_png_read_finish_IDAT, __Z34Vector3_CUSTOM_INTERNAL_CALL_SlerpRK8Vector3fS1_fRS_: __Z34Vector3_CUSTOM_INTERNAL_CALL_SlerpRK8Vector3fS1_fRS_, __ZN5physx2Gu5Debug9visualizeERKNS_22PxTriangleMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_22PxTriangleMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, _strspn: _strspn, __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z45AnimationState_Get_Custom_PropNormalizedSpeedP12Il2CppObject: __Z45AnimationState_Get_Custom_PropNormalizedSpeedP12Il2CppObject, __Z20setPxSceneDescLimitsPN5physx11PxSceneDescENS_13PxSceneLimitsE: __Z20setPxSceneDescLimitsPN5physx11PxSceneDescENS_13PxSceneLimitsE, __ZN5physx17PxcNpMemBlockPool15releaseContactsEv: __ZN5physx17PxcNpMemBlockPool15releaseContactsEv, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_ED2Ev, __Z13RegisterClassI14DirectorPlayerEvv: __Z13RegisterClassI14DirectorPlayerEvv, __ZN20DynamicPropertySheet10FlushQueueEv: __ZN20DynamicPropertySheet10FlushQueueEv, __ZN14SafeBinaryRead8TransferIN7mecanim18ValueArrayConstantEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim18ValueArrayConstantEEEvRT_PKc17TransferMetaFlags, _gray_render_line: _gray_render_line, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE7reserveEj, __ZNKSt3__217moneypunct_bynameIcLb1EE16do_positive_signEv: __ZNKSt3__217moneypunct_bynameIcLb1EE16do_positive_signEv, __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN11TimeManager17SetFixedDeltaTimeEf: __ZN11TimeManager17SetFixedDeltaTimeEf, __ZN7mecanim5human5Human8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim5human5Human8TransferI24GenerateTypeTreeTransferEEvRT_, __Z53DownloadHandlerAssetBundle_Get_Custom_PropAssetBundleP12Il2CppObject: __Z53DownloadHandlerAssetBundle_Get_Custom_PropAssetBundleP12Il2CppObject, __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEbT0_SE_T_: __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEbT0_SE_T_, _t1_hints_funcs_init: _t1_hints_funcs_init, __ZN18CrashReportManager22InitCrashReportHandlerERK8UnityStrS2_: __ZN18CrashReportManager22InitCrashReportHandlerERK8UnityStrS2_, __ZN5physx2Sn25readStridedBufferPropertyINS_21PxClothCollisionPlaneEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_21PxClothCollisionPlaneEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __ZN10UnityScene19RemoveRootFromSceneER9Transformb: __ZN10UnityScene19RemoveRootFromSceneER9Transformb, __ZN5physx14PxsAABBManager9prepareBPEv: __ZN5physx14PxsAABBManager9prepareBPEv, __Z16RecordForEachJobPFvPvjES_jPFvS_ER21SingleThreadedJobInfo: __Z16RecordForEachJobPFvPvjES_jPFvS_ER21SingleThreadedJobInfo, __ZN5physx7NpCloth20removeCollisionPlaneEj: __ZN5physx7NpCloth20removeCollisionPlaneEj, __Z53Register_UnityEngine_RenderTexture_Internal_SetHeightv: __Z53Register_UnityEngine_RenderTexture_Internal_SetHeightv, __ZN5physx2Gu33MultiplePersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj: __ZN5physx2Gu33MultiplePersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj, __Z52Register_UnityEngine_Physics_set_queriesHitBackfacesv: __Z52Register_UnityEngine_Physics_set_queriesHitBackfacesv, __ZN5physx5cloth8SwSolverD2Ev: __ZN5physx5cloth8SwSolverD2Ev, __ZNSt3__28__rs_getEv: __ZNSt3__28__rs_getEv, __ZN9Transform23SetIsDispatchInterestedERK27TransformChangeSystemHandleb: __ZN9Transform23SetIsDispatchInterestedERK27TransformChangeSystemHandleb, __Z52Register_UnityEngine_Material_INTERNAL_CALL_GetColorv: __Z52Register_UnityEngine_Material_INTERNAL_CALL_GetColorv, __ZN7mecanim9animation24DestroyBlendTreeConstantEPNS0_17BlendTreeConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation24DestroyBlendTreeConstantEPNS0_17BlendTreeConstantERNS_6memory9AllocatorE, __Z54Register_UnityEngine_Terrain_get_realtimeLightmapIndexv: __Z54Register_UnityEngine_Terrain_get_realtimeLightmapIndexv, __ZN10GameObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10GameObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE8pushBackEv: __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE8pushBackEv, __ZNSt3__211unique_lockINS_5mutexEE6unlockEv: __ZNSt3__211unique_lockINS_5mutexEE6unlockEv, __ZN5physx9NpFactory13createNpClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx9NpFactory13createNpClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN9GfxDevice22AcquireThreadOwnershipEv: __ZN9GfxDevice22AcquireThreadOwnershipEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6setbufEPci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6setbufEPci, __ZN8Renderer23RendererBecameInvisibleEv: __ZN8Renderer23RendererBecameInvisibleEv, __ZN22CrashReportingSettingsD2Ev: __ZN22CrashReportingSettingsD2Ev, __Z51Register_UnityEngine_Rigidbody2D_set_sharedMaterialv: __Z51Register_UnityEngine_Rigidbody2D_set_sharedMaterialv, __ZN11ForceModuleD0Ev: __ZN11ForceModuleD0Ev, __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_set_rndVelocityv: __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_set_rndVelocityv, __Z28Event_Get_Custom_PropKeyCodeP12Il2CppObject: __Z28Event_Get_Custom_PropKeyCodeP12Il2CppObject, __ZN13ComputeBufferD2Ev: __ZN13ComputeBufferD2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK24RingBufferMemoryFileData5CloneEv: __ZNK24RingBufferMemoryFileData5CloneEv, __Z51Register_UnityEngine_Motion_get_averageAngularSpeedv: __Z51Register_UnityEngine_Motion_get_averageAngularSpeedv, __Z25EnsureLoopFrameContinuityI11QuaternionfEvR17AnimationCurveTplIT_E: __Z25EnsureLoopFrameContinuityI11QuaternionfEvR17AnimationCurveTplIT_E, __Z14IsStringNumberRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z14IsStringNumberRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNK9Rigidbody7GetDragEv: __ZNK9Rigidbody7GetDragEv, __ZN14AnimationState13SetupStopTimeEv: __ZN14AnimationState13SetupStopTimeEv, __ZNSt3__218__time_get_storageIcE4initERKNS_5ctypeIcEE: __ZNSt3__218__time_get_storageIcE4initERKNS_5ctypeIcEE, __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI7CubemapE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z45ParticleSystem_Set_Custom_PropGravityModifierP12Il2CppObjectf: __Z45ParticleSystem_Set_Custom_PropGravityModifierP12Il2CppObjectf, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z46Register_UnityEngine_BillboardAsset_GetIndicesv: __Z46Register_UnityEngine_BillboardAsset_GetIndicesv, __ZN19LightProbeOcclusion8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19LightProbeOcclusion8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15AnimationBinder20SetValueAwakeGenericERK20BoundCurveDeprecated: __ZN15AnimationBinder20SetValueAwakeGenericERK20BoundCurveDeprecated, __ZThn8_N5physx2Gu10ConvexMesh14onRefCountZeroEv: __ZThn8_N5physx2Gu10ConvexMesh14onRefCountZeroEv, _UNITY_png_get_IHDR: _UNITY_png_get_IHDR, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7releaseEv: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE7releaseEv, __ZN4FMOD7ReverbI9getActiveEPb: __ZN4FMOD7ReverbI9getActiveEPb, __ZN5physx28PxDistanceJointGeneratedInfoC2Ev: __ZN5physx28PxDistanceJointGeneratedInfoC2Ev, __Z17ShowErrorWithModei: __Z17ShowErrorWithModei, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jRKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jRKS4_, __Z13RegisterClassI9AudioClipEvv: __Z13RegisterClassI9AudioClipEvv, __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab26SerializedShaderFloatValue8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__211__libcpp_db17__find_c_and_lockEPv: __ZNKSt3__211__libcpp_db17__find_c_and_lockEPv, __Z53ParticleSystem_NoiseModule_CUSTOM_SetOctaveMultiplierP12Il2CppObjectf: __Z53ParticleSystem_NoiseModule_CUSTOM_SetOctaveMultiplierP12Il2CppObjectf, __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE: __Z33ConvertNativeRaycastHitsToManagedRKNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEEE, __ZNK5Umbra15CameraTransform3getERNS_9Matrix4x4ENS0_10DepthRangeENS_12MatrixFormatE: __ZNK5Umbra15CameraTransform3getERNS_9Matrix4x4ENS0_10DepthRangeENS_12MatrixFormatE, __Z49Register_UnityEngine_Debug_INTERNAL_CALL_DrawLinev: __Z49Register_UnityEngine_Debug_INTERNAL_CALL_DrawLinev, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekoffExNS_8ios_base7seekdirEj, __ZL16RegisterVRDevice23UnityVRDeviceDefinition: __ZL16RegisterVRDevice23UnityVRDeviceDefinition, __ZN5physx2Sc11InteractionD0Ev: __ZN5physx2Sc11InteractionD0Ev, _UNITY_FT_Destroy_Class_cff_driver_class: _UNITY_FT_Destroy_Class_cff_driver_class, __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE13finalizeQueryEv: __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE13finalizeQueryEv, __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN8Renderer13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Sq8AABBTree6refit2EPNS0_15AABBTreeBuilderEPj: __ZN5physx2Sq8AABBTree6refit2EPNS0_15AABBTreeBuilderEPj, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEED0Ev, __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK16GraphicsSettings26GetTypeInfoVirtualInternalEv: __ZNK16GraphicsSettings26GetTypeInfoVirtualInternalEv, __ZNK14SoundHandleAPI7GetDataEPfjj: __ZNK14SoundHandleAPI7GetDataEPfjj, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEv, __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, _UNITY_png_handle_sCAL: _UNITY_png_handle_sCAL, __Z25scripting_class_from_namePK11Il2CppImagePKcS3_: __Z25scripting_class_from_namePK11Il2CppImagePKcS3_, __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZNK8Animator29GetAnimatorOverrideControllerEv: __ZNK8Animator29GetAnimatorOverrideControllerEv, __ZNSt3__28ios_base5clearEj: __ZNSt3__28ios_base5clearEj, __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_, _sincos: _sincos, __ZN4FMOD5Sound12getLoopCountEPi: __ZN4FMOD5Sound12getLoopCountEPi, __ZN4FMOD7SystemI28GetSystemFromNonSystemHandleEPv: __ZN4FMOD7SystemI28GetSystemFromNonSystemHandleEPv, __ZL26ExtractScriptTypeReferenceRK16TypeTreeIteratorjR15CacheReaderBasebR31LocalSerializedObjectIdentifier: __ZL26ExtractScriptTypeReferenceRK16TypeTreeIteratorjR15CacheReaderBasebR31LocalSerializedObjectIdentifier, __Z32GUITexture_Set_Custom_PropBorderP12Il2CppObjectS0_: __Z32GUITexture_Set_Custom_PropBorderP12Il2CppObjectS0_, __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController: __ZN26AnimatorControllerPlayable21SetAnimatorControllerEP25RuntimeAnimatorController, __Z32getPxVehicleWheelsMWheelsSimDataPKN5physx15PxVehicleWheelsE: __Z32getPxVehicleWheelsMWheelsSimDataPKN5physx15PxVehicleWheelsE, __Z31TerrainData_CUSTOM_GetSteepnessP12Il2CppObjectff: __Z31TerrainData_CUSTOM_GetSteepnessP12Il2CppObjectff, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __ZN5physx15PxsCCDSweepTask11runInternalEv: __ZN5physx15PxsCCDSweepTask11runInternalEv, __ZN10GameObject21SetIsStaticDeprecatedEb: __ZN10GameObject21SetIsStaticDeprecatedEb, __ZN23ShaderVariantCollection11VariantInfo8TransferI14SafeBinaryReadEEvRT_: __ZN23ShaderVariantCollection11VariantInfo8TransferI14SafeBinaryReadEEvRT_, __Z45ShaderVariantCollection_CUSTOM_RemoveInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray: __Z45ShaderVariantCollection_CUSTOM_RemoveInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray, __ZN2UI13CanvasManager17EmitWorldGeometryENS0_10CameraTypeE: __ZN2UI13CanvasManager17EmitWorldGeometryENS0_10CameraTypeE, __ZNK5physx2Sc5Scene30getClothInterCollisionDistanceEv: __ZNK5physx2Sc5Scene30getClothInterCollisionDistanceEv, __Z43ParticleSystem_TriggerModule_CUSTOM_GetExitP12Il2CppObject: __Z43ParticleSystem_TriggerModule_CUSTOM_GetExitP12Il2CppObject, __ZNK24RendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK24RendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __Z48Register_UnityEngine_ParticleEmitter_set_enabledv: __Z48Register_UnityEngine_ParticleEmitter_set_enabledv, __ZN5Unity17ConfigurableJoint16FinalizeCreateD6Ev: __ZN5Unity17ConfigurableJoint16FinalizeCreateD6Ev, __Z54Register_UnityEngine_SystemInfo_get_supports3DTexturesv: __Z54Register_UnityEngine_SystemInfo_get_supports3DTexturesv, __Z24Tree_Set_Custom_PropDataP12Il2CppObjectS0_: __Z24Tree_Set_Custom_PropDataP12Il2CppObjectS0_, __Z24RegisterStrippedTypeInfoI9CGProgramEviPKcS2_: __Z24RegisterStrippedTypeInfoI9CGProgramEviPKcS2_, __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_: __ZNSt3__27__sort4IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_T_, __Z23ClipPolygonAgainstPlaneiPK8Vector3fRK5PlanePaPS_: __Z23ClipPolygonAgainstPlaneiPK8Vector3fRK5PlanePaPS_, __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK13Vector2fIcall: __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK13Vector2fIcall, __Z48Register_UnityEngine_AnimationState_set_wrapModev: __Z48Register_UnityEngine_AnimationState_set_wrapModev, __Z41Register_UnityEngine_GUIText_get_fontSizev: __Z41Register_UnityEngine_GUIText_get_fontSizev, __ZN14ParticleSystem16SetStartLifeTimeEf: __ZN14ParticleSystem16SetStartLifeTimeEf, __Z38Register_UnityEngine_LODGroup_set_sizev: __Z38Register_UnityEngine_LODGroup_set_sizev, __Z16GetScriptingRandv: __Z16GetScriptingRandv, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv, __ZNSt3__212__do_nothingEPv: __ZNSt3__212__do_nothingEPv, __ZN5Unity5Cloth17RemoveFromManagerEv: __ZN5Unity5Cloth17RemoveFromManagerEv, __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE13StaticDestroyEPv, __Z59Register_UnityEngine_AudioSettings_get_profilerCaptureFlagsv: __Z59Register_UnityEngine_AudioSettings_get_profilerCaptureFlagsv, __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj: __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEixEj, __Z49Register_UnityEngine_DistanceJoint2D_get_distancev: __Z49Register_UnityEngine_DistanceJoint2D_get_distancev, __Z40Register_UnityEngine_TerrainData_AddUserv: __Z40Register_UnityEngine_TerrainData_AddUserv, __ZNK17SurfaceEffector2D26GetTypeInfoVirtualInternalEv: __ZNK17SurfaceEffector2D26GetTypeInfoVirtualInternalEv, __ZN23PreloadManagerOperation9SetStatusENS_6StatusE: __ZN23PreloadManagerOperation9SetStatusENS_6StatusE, __ZN5physx3Ext10FixedJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext10FixedJoint12createObjectERPhRNS_24PxDeserializationContextE, __ZN10VertexData14AllocateMemoryEj: __ZN10VertexData14AllocateMemoryEj, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEPKcjj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefIhEE: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefIhEE, __Z34ParticleSystem_Set_Custom_PropTimeP12Il2CppObjectf: __Z34ParticleSystem_Set_Custom_PropTimeP12Il2CppObjectf, __ZN5physx13PxsCCDContext14verifyCCDBeginEv: __ZN5physx13PxsCCDContext14verifyCCDBeginEv, __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags, __ZL41InitializeParticlesLegacyScriptingClassesv: __ZL41InitializeParticlesLegacyScriptingClassesv, __Z13GetCopyBufferv: __Z13GetCopyBufferv, __ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb: __ZN5physx2Gu27generateFullContactManifoldERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_PNS0_17PersistentContactERjRKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VEb, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7ReleaseEPS2_: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7ReleaseEPS2_, __ZN14RotationModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14RotationModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _jpeg_std_error: _jpeg_std_error, __ZN18AnimatorController10ClearAssetEv: __ZN18AnimatorController10ClearAssetEv, _UNITY_tt_face_load_cmap: _UNITY_tt_face_load_cmap, __ZNK5Umbra4Tome14testCapabilityEj: __ZNK5Umbra4Tome14testCapabilityEj, __ZNK12AudioManager21GetPlayingSourceCountEv: __ZNK12AudioManager21GetPlayingSourceCountEv, __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData: __ZN5Unity9Component14SendMessageAnyERK17MessageIdentifierR11MessageData, __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN4FMOD7Channel13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD7Channel13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZNKSt3__215__codecvt_utf16IwLb1EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IwLb1EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_, __ZZN8Collider15InitializeClassEvEN28FunctorImpl_777kLayerChanged4CallEPviR11MessageData: __ZZN8Collider15InitializeClassEvEN28FunctorImpl_777kLayerChanged4CallEPviR11MessageData, __ZN5Unity11SpringJoint14SetMaxDistanceEf: __ZN5Unity11SpringJoint14SetMaxDistanceEf, __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi: __ZNK10__cxxabiv117__class_type_info29process_static_type_below_dstEPNS_19__dynamic_cast_infoEPKvi, __ZN8Renderer15RemoveFromSceneER13RendererScene: __ZN8Renderer15RemoveFromSceneER13RendererScene, __ZN5IMGUI11FocusWindowER8GUIStatei: __ZN5IMGUI11FocusWindowER8GUIStatei, __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE: __ZN5physx2Gu5Facet10silhouetteEjRKNS_6shdfnd3aos5Vec3VEPS5_S7_RNS0_10EdgeBufferERNS_2Cm20InlineDeferredIDPoolILj64EEE, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __ZN9JSONWrite8TransferI13dynamic_arrayIfLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIfLj4EEEEvRT_PKc17TransferMetaFlags, __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb: __ZN8VRModule14CreateVRModuleERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb, __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeZSorterP16DetailMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeZSorterP16DetailMeshBVNodeEEbT0_S5_T_, __ZN9GfxDevice12EndRecordingEPP14GfxDisplayListRK19ShaderPropertySheet: __ZN9GfxDevice12EndRecordingEPP14GfxDisplayListRK19ShaderPropertySheet, __ZN5physx31PxClothFabricPhaseGeneratedInfoC2Ev: __ZN5physx31PxClothFabricPhaseGeneratedInfoC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj68ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj68ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _IsMacBinary: _IsMacBinary, __ZN4FMOD8ChannelI20get3DConeOrientationEP11FMOD_VECTOR: __ZN4FMOD8ChannelI20get3DConeOrientationEP11FMOD_VECTOR, __Z52Register_UnityEngine_PointEffector2D_get_forceSourcev: __Z52Register_UnityEngine_PointEffector2D_get_forceSourcev, __ZNK22ParticleSystemRenderer16PrepareForRenderER14ParticleSystemRK6CameraRK10Matrix4x4ffP23ParticleSystemParticlesR22ParticleSystemTempData: __ZNK22ParticleSystemRenderer16PrepareForRenderER14ParticleSystemRK6CameraRK10Matrix4x4ffP23ParticleSystemParticlesR22ParticleSystemTempData, __ZN5physx2Gu25GetGeomOverlapMethodTableEv: __ZN5physx2Gu25GetGeomOverlapMethodTableEv, __Z42ShaderVariantCollection_CUSTOM_AddInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray: __Z42ShaderVariantCollection_CUSTOM_AddInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray, _cff_parse_private_dict: _cff_parse_private_dict, __Z43setPxVehicleSuspensionDataMSpringDamperRatePN5physx23PxVehicleSuspensionDataEf: __Z43setPxVehicleSuspensionDataMSpringDamperRatePN5physx23PxVehicleSuspensionDataEf, __ZN12_GLOBAL__N_124PropertyDefinitionHelper18addPropertyMessageERKN5physx8debugger14NamespacedNameES5_j: __ZN12_GLOBAL__N_124PropertyDefinitionHelper18addPropertyMessageERKN5physx8debugger14NamespacedNameES5_j, __ZNK23iPhoneLocalNotification17GetRepeatCalendarEv: __ZNK23iPhoneLocalNotification17GetRepeatCalendarEv, __Z49Register_UnityEngine_Camera_INTERNAL_get_velocityv: __Z49Register_UnityEngine_Camera_INTERNAL_get_velocityv, __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj: __ZN8Gradient12SetAlphaKeysEPNS_8AlphaKeyEj, __Z48Register_UnityEngine_Vector3_INTERNAL_CALL_Slerpv: __Z48Register_UnityEngine_Vector3_INTERNAL_CALL_Slerpv, __ZN5physx2Sn17readAllPropertiesINS_12PxFixedJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_12PxFixedJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __Z20ConvertAlphaKeyArrayP11Il2CppArrayPN8Gradient8AlphaKeyE: __Z20ConvertAlphaKeyArrayP11Il2CppArrayPN8Gradient8AlphaKeyE, __ZN4FMOD7Channel15getCurrentSoundEPPNS_5SoundE: __ZN4FMOD7Channel15getCurrentSoundEPPNS_5SoundE, __ZN26ProbeSetTetrahedralization8TransferI14SafeBinaryReadEEvRT_: __ZN26ProbeSetTetrahedralization8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__get_long_sizeEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE15__get_long_sizeEv, __ZNK12HingeJoint2D17GetReferenceAngleEv: __ZNK12HingeJoint2D17GetReferenceAngleEv, _t1_hints_stem: _t1_hints_stem, __Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_: __Z28ProceduralPreset_parseValuesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEES6_S6_, _pop_arg: _pop_arg, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRPv: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRPv, __ZN5physx8debugger4comm19AddProfileZoneEventD0Ev: __ZN5physx8debugger4comm19AddProfileZoneEventD0Ev, __ZN7mecanim9animation21SkeletonPoseFromValueIN4math4trsXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTIS3_EERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib: __ZN7mecanim9animation21SkeletonPoseFromValueIN4math4trsXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTIS3_EERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888818TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZN5Unity12PhysicsQuery7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery7RaycastERK3RayfR10RaycastHiti23QueryTriggerInteraction, __Z59Register_UnityEngine_Material_INTERNAL_CALL_SetTextureScalev: __Z59Register_UnityEngine_Material_INTERNAL_CALL_SetTextureScalev, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED0Ev: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE10__set_sizeEj, __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __Z53Register_UnityEngine_Graphics_ClearRandomWriteTargetsv: __Z53Register_UnityEngine_Graphics_ClearRandomWriteTargetsv, __Z49Register_UnityEngine_SliderJoint2D_get_jointSpeedv: __Z49Register_UnityEngine_SliderJoint2D_get_jointSpeedv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags, __ZN14CachingManager23GetCachingDiskSpaceFreeEv: __ZN14CachingManager23GetCachingDiskSpaceFreeEv, __ZN9ShaderLab7ProgramC2Ei10ShaderType: __ZN9ShaderLab7ProgramC2Ei10ShaderType, __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16CircleCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx33PxParticleReadDataGeneratedValuesC2EPKNS_18PxParticleReadDataE: __ZN5physx33PxParticleReadDataGeneratedValuesC2EPKNS_18PxParticleReadDataE, __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __Z14RunNativeTestsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE: __Z14RunNativeTestsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE, __ZN17ParticleLightNodeD2Ev: __ZN17ParticleLightNodeD2Ev, __ZN5physx2Sc10NPhaseCore18removeClothOverlapEPNS0_8ClothSimEPKNS0_8ShapeSimE: __ZN5physx2Sc10NPhaseCore18removeClothOverlapEPNS0_8ClothSimEPKNS0_8ShapeSimE, __ZN13GfxDeviceGLES17BeginTimerQueriesEv: __ZN13GfxDeviceGLES17BeginTimerQueriesEv, __Z46Register_UnityEngine_PolygonCollider2D_SetPathv: __Z46Register_UnityEngine_PolygonCollider2D_SetPathv, __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j: __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEEEEjT_j, __ZN4FMOD6System16setDSPBufferSizeEji: __ZN4FMOD6System16setDSPBufferSizeEji, __Z53Register_UnityEngine_Application_HasUserAuthorizationv: __Z53Register_UnityEngine_Application_HasUserAuthorizationv, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim10ValueArrayEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim10ValueArrayEEEEvRT_PKc17TransferMetaFlags, __Z38UnityWebRequest_CUSTOM_InternalDestroyP12Il2CppObject: __Z38UnityWebRequest_CUSTOM_InternalDestroyP12Il2CppObject, __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z43Register_UnityEngine_Cloth_set_coefficientsv: __Z43Register_UnityEngine_Cloth_set_coefficientsv, __ZNK5physx2Sc17ParticleSystemSim23getSimulationFilterDataEv: __ZNK5physx2Sc17ParticleSystemSim23getSimulationFilterDataEv, __ZN14BillboardAsset11UnshareDataEv: __ZN14BillboardAsset11UnshareDataEv, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType0EEEbPKv, __ZN15DistanceJoint2D18SetMaxDistanceOnlyEb: __ZN15DistanceJoint2D18SetMaxDistanceOnlyEb, __ZN5physx13NpRigidStatic12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx13NpRigidStatic12createObjectERPhRNS_24PxDeserializationContextE, __Z48Register_UnityEngine_Collider_set_sharedMaterialv: __Z48Register_UnityEngine_Collider_set_sharedMaterialv, __ZL17ProgramUniform1ivPK7ApiGLESjiihPKv: __ZL17ProgramUniform1ivPK7ApiGLESjiihPKv, __ZN14TerrainManagerD2Ev: __ZN14TerrainManagerD2Ev, __ZN5physx2Sc5Scene16getArticulationsEv: __ZN5physx2Sc5Scene16getArticulationsEv, _pthread_self: _pthread_self, __ZN18PlayableController7SetTimeEd: __ZN18PlayableController7SetTimeEd, __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE: __ZN4crnd12symbol_codec6decodeERKNS_25static_huffman_data_modelE, __ZN13UnityProfiler8EndFrameEv: __ZN13UnityProfiler8EndFrameEv, __ZL20PngWriteToMemoryFuncP14png_struct_defPhj: __ZL20PngWriteToMemoryFuncP14png_struct_defPhj, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv, __Z45ParticleSystem_TriggerModule_CUSTOM_SetInsideP12Il2CppObjecti: __Z45ParticleSystem_TriggerModule_CUSTOM_SetInsideP12Il2CppObjecti, __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4ERKS1_: __ZN5Umbra11ShadowUtils7getAABBERNS_4AABBERKNS_9Matrix4x4ERKS1_, _lrint: _lrint, __ZN13TrailRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13TrailRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN8ColliderD0Ev: __ZN8ColliderD0Ev, __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleNonAllocv: __Z66Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleNonAllocv, __ZN13RenderManager29InvokeOnRenderObjectCallbacksEv: __ZN13RenderManager29InvokeOnRenderObjectCallbacksEv, __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout: __ZN10VertexData6ResizeEjjjRK19VertexStreamsLayoutRK20VertexChannelsLayout, _UNITY_png_set_compression_mem_level: _UNITY_png_set_compression_mem_level, __ZN13TriggerModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13TriggerModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK8Vector3fS1_RK11QuaternionfS1_P10RaycastHitfi23QueryTriggerInteraction: __Z45Physics_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK8Vector3fS1_RK11QuaternionfS1_P10RaycastHitfi23QueryTriggerInteraction, __ZNK5physx14NpRigidDynamic17getAngularDampingEv: __ZNK5physx14NpRigidDynamic17getAngularDampingEv, __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence: __Z17CalculateSkinPoseR10Matrix4x4fiPKS_PKiPK14BoneInfluence2PK13BoneInfluence, __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_: __ZN14qsort_internal6_QSortIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_, __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14ParticleSystem29ComputePrewarmStartParametersERff: __ZN14ParticleSystem29ComputePrewarmStartParametersERff, __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx17PxsContactManagerD2Ev: __ZN5physx17PxsContactManagerD2Ev, __ZN38AssetBundleLoadFromCacheAsyncOperation20LoadCachedArchiveJobEPv: __ZN38AssetBundleLoadFromCacheAsyncOperation20LoadCachedArchiveJobEPv, __ZNK14ParticleSystem14GetLengthInSecEv: __ZNK14ParticleSystem14GetLengthInSecEv, __ZNK5physx3Ext13RevoluteJoint11getVelocityEv: __ZNK5physx3Ext13RevoluteJoint11getVelocityEv, __Z46ParticleSystemRenderer_Get_Custom_PropSortModeP12Il2CppObject: __Z46ParticleSystemRenderer_Get_Custom_PropSortModeP12Il2CppObject, __Z15Transfer_StringI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMinCCDAdvanceCoefficientEf: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27setMinCCDAdvanceCoefficientEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj626ENS_22PxRepXPropertyAccessorILj626ES4_KjjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj626ENS_22PxRepXPropertyAccessorILj626ES4_KjjEEEEvjRKT0_, __ZN10Collider2D9GetBoundsEv: __ZN10Collider2D9GetBoundsEv, _open_memstream: _open_memstream, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags, __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdatePlayerEmitCanvasGeometrystruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN44PostLateUpdatePlayerEmitCanvasGeometrystruct7ForwardEv, __ZN37AssetBundleLoadFromFileAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN37AssetBundleLoadFromFileAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx22PxcHeightFieldAabbTest8IteratorppEv: __ZN5physx22PxcHeightFieldAabbTest8IteratorppEv, __ZN8GUILayer17RemoveFromManagerEv: __ZN8GUILayer17RemoveFromManagerEv, __ZL16SendTriggerEventP8ColliderS0_17MessageIdentifier: __ZL16SendTriggerEventP8ColliderS0_17MessageIdentifier, __ZNKSt3__213random_device7entropyEv: __ZNKSt3__213random_device7entropyEv, __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStream5writeEPKvj: __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStream5writeEPKvj, __ZNSt3__210moneypunctIcLb1EED0Ev: __ZNSt3__210moneypunctIcLb1EED0Ev, __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z22PlatformAppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z22PlatformAppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, _UNITY_png_fixed: _UNITY_png_fixed, __ZN22BlockMemoryCacheWriterD2Ev: __ZN22BlockMemoryCacheWriterD2Ev, __ZN11ShapeModuleD2Ev: __ZN11ShapeModuleD2Ev, __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace: __Z22GetTextureDecodeValues16TextureUsageMode17TextureColorSpace, __ZN14LineParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14LineParameters8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14AsyncOperation23SetAllowSceneActivationEb: __ZN14AsyncOperation23SetAllowSceneActivationEb, __ZN20UnityConnectSettings15ThreadedCleanupEv: __ZN20UnityConnectSettings15ThreadedCleanupEv, __ZN13HeightmapData8TransferI14SafeBinaryReadEEvRT_: __ZN13HeightmapData8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j: __ZNK5physx32PxVehicleClutchDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEEEEEjT_j, __ZN23ParticleSystemParticlesC2Ev: __ZN23ParticleSystemParticlesC2Ev, __Z23scripting_class_is_enumP11Il2CppClass: __Z23scripting_class_is_enumP11Il2CppClass, __ZN7Joint2D16SetConnectedBodyE4PPtrI11Rigidbody2DE: __ZN7Joint2D16SetConnectedBodyE4PPtrI11Rigidbody2DE, __Z36Physics2D_Set_Custom_PropTimeToSleepf: __Z36Physics2D_Set_Custom_PropTimeToSleepf, __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEiPKN5Unity4TypeE: __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEiPKN5Unity4TypeE, __ZNK17MonoScriptManager20GetAllRuntimeScriptsER13dynamic_arrayIP10MonoScriptLj4EE: __ZNK17MonoScriptManager20GetAllRuntimeScriptsER13dynamic_arrayIP10MonoScriptLj4EE, __Z13RegisterClassI11AssetBundleEvv: __Z13RegisterClassI11AssetBundleEvv, __ZNK13UnityProfiler19GetEnabledThisFrameEv: __ZNK13UnityProfiler19GetEnabledThisFrameEv, __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE8recreateEj, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNSt3__218condition_variableD2Ev: __ZNSt3__218condition_variableD2Ev, __ZN11UTF16String18GetScriptingStringEv: __ZN11UTF16String18GetScriptingStringEv, __ZN7mecanim9animation21GetMuscleCurveTQIndexEi: __ZN7mecanim9animation21GetMuscleCurveTQIndexEi, __Z42Register_UnityEngine_Texture3D_SetPixels32v: __Z42Register_UnityEngine_Texture3D_SetPixels32v, _scalbn: _scalbn, __ZN18DeferredRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDPS3_iRK8Vector4fRK14LightingLayersR10MinMaxAABBb: __ZN18DeferredRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDPS3_iRK8Vector4fRK14LightingLayersR10MinMaxAABBb, __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z23getPxCloth_TetherConfigPKN5physx7PxClothE: __Z23getPxCloth_TetherConfigPKN5physx7PxClothE, __Z9CullSceneR22SceneCullingParametersPK6CameraR11CullResults: __Z9CullSceneR22SceneCullingParametersPK6CameraR11CullResults, __ZN5Unity17ConfigurableJoint20ApplySetupAxesToDescEi: __ZN5Unity17ConfigurableJoint20ApplySetupAxesToDescEi, __Z41Register_UnityEngine_Light_get_bakedIndexv: __Z41Register_UnityEngine_Light_get_bakedIndexv, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5egptrEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5egptrEv, __ZN9AudioClip21ScriptPCMReadCallbackEP10FMOD_SOUNDPvj: __ZN9AudioClip21ScriptPCMReadCallbackEP10FMOD_SOUNDPvj, __ZNK7Texture13IsNPOTAllowedEv: __ZNK7Texture13IsNPOTAllowedEv, __ZN8Renderer13BoundsChangedEv: __ZN8Renderer13BoundsChangedEv, __ZN5Unity5ClothC2E10MemLabelId18ObjectCreationMode: __ZN5Unity5ClothC2E10MemLabelId18ObjectCreationMode, __ZN12_GLOBAL__N_1L20GetIndexFromBoneNameENSt3__211__wrap_iterIPKN13AvatarBuilder14NamedTransformEEES6_RK8UnityStr: __ZN12_GLOBAL__N_1L20GetIndexFromBoneNameENSt3__211__wrap_iterIPKN13AvatarBuilder14NamedTransformEEES6_RK8UnityStr, __ZNK5physx7NpCloth16getRestPositionsEPNS_6PxVec4E: __ZNK5physx7NpCloth16getRestPositionsEPNS_6PxVec4E, __ZN4FMOD6System12loadGeometryEPKviPPNS_8GeometryE: __ZN4FMOD6System12loadGeometryEPKviPPNS_8GeometryE, __ZN22VirtualJoystickManager26UpdatePhysicalJoystickListEv: __ZN22VirtualJoystickManager26UpdatePhysicalJoystickListEv, __ZN11UnityEngine15CloudWebService19SessionEventManager21ProcessFlushEventsJobEv: __ZN11UnityEngine15CloudWebService19SessionEventManager21ProcessFlushEventsJobEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9Texture3D11InitTextureEiii13TextureFormatb: __ZN9Texture3D11InitTextureEiii13TextureFormatb, __ZL15SortColorByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES6_: __ZL15SortColorByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES6_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_10PxMaterialEE8pushNameEPKc, __ZN11OffMeshLinkD0Ev: __ZN11OffMeshLinkD0Ev, __Z25GetGpuProgramTypeFromDataPKhS0_: __Z25GetGpuProgramTypeFromDataPKhS0_, __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE: __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE, __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEED0Ev, __ZN14CompressedMeshD2Ev: __ZN14CompressedMeshD2Ev, __ZN14PhysicsManager14OverlapCapsuleERK8Vector3fS2_fi23QueryTriggerInteraction: __ZN14PhysicsManager14OverlapCapsuleERK8Vector3fS2_fi23QueryTriggerInteraction, __ZN5physx28solveParallelDefaultFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj: __ZN5physx28solveParallelDefaultFrictionERNS_18PxsDynamicsContextEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPiSA_SA_SA_SA_SA_PNS_25PxcThresholdStreamElementEjSA_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSD_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSL_5ArrayINS_24PxsConstraintBatchHeaderENSL_19ReflectionAllocatorISW_EEEES10_RNSV_IjNSX_IjEEEES13_PPNS_12PxsRigidBodyEj, __Z55Register_UnityEngine_Physics2D_set_maxAngularCorrectionv: __Z55Register_UnityEngine_Physics2D_set_maxAngularCorrectionv, __Z44Mesh_CUSTOM_PrintErrorBadSubmeshIndexIndicesP12Il2CppObject: __Z44Mesh_CUSTOM_PrintErrorBadSubmeshIndexIndicesP12Il2CppObject, __ZN13SliderJoint2D14ConfigureAngleERK6b2Vec2S2_: __ZN13SliderJoint2D14ConfigureAngleERK6b2Vec2S2_, __ZN16UnityAdsSettings11SetTestModeEb: __ZN16UnityAdsSettings11SetTestModeEb, __ZN18DelayedCallManager15RemoveNoCleanupERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE: __ZN18DelayedCallManager15RemoveNoCleanupERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE, __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EdeEv: __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EdeEv, __ZN15DirectorManager12CleanupClassEv: __ZN15DirectorManager12CleanupClassEv, __Z19IsGearVRApplicationv: __Z19IsGearVRApplicationv, __Z59Register_UnityEngine_Rigidbody2D_set_collisionDetectionModev: __Z59Register_UnityEngine_Rigidbody2D_set_collisionDetectionModev, __ZN14EdgeCollider2D15ThreadedCleanupEv: __ZN14EdgeCollider2D15ThreadedCleanupEv, __ZN5physx8debugger4comm23EndPropertyMessageGroupD0Ev: __ZN5physx8debugger4comm23EndPropertyMessageGroupD0Ev, __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKPositionInternalP12Il2CppObjectiRK8Vector3f: __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKPositionInternalP12Il2CppObjectiRK8Vector3f, __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif: __ZNK17AnimationCurveTplI11QuaternionfE18CalculateCacheDataERNS1_5CacheEiif, __ZN5physx3Ext14PrismaticJointD0Ev: __ZN5physx3Ext14PrismaticJointD0Ev, __ZN5Unity11Adjacencies10UpdateLinkEjjjj: __ZN5Unity11Adjacencies10UpdateLinkEjjjj, __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13RuntimeStaticI22VirtualJoystickManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI22VirtualJoystickManagerE13StaticDestroyEPv, __ZN33AssetBundleLoadFromAsyncOperationD0Ev: __ZN33AssetBundleLoadFromAsyncOperationD0Ev, __Z44AreaEffector2D_Get_Custom_PropForceVariationP12Il2CppObject: __Z44AreaEffector2D_Get_Custom_PropForceVariationP12Il2CppObject, __Z46Playables_CUSTOM_INTERNAL_CALL_ConnectInternalR9HPlayableS0_ii: __Z46Playables_CUSTOM_INTERNAL_CALL_ConnectInternalR9HPlayableS0_ii, __ZN13AnimationClip10FloatCurveaSERKS0_: __ZN13AnimationClip10FloatCurveaSERKS0_, __ZNK12b2MouseJoint16GetReactionForceEf: __ZNK12b2MouseJoint16GetReactionForceEf, __ZN4FMOD7ReverbI13setPropertiesEPK22FMOD_REVERB_PROPERTIES: __ZN4FMOD7ReverbI13setPropertiesEPK22FMOD_REVERB_PROPERTIES, __ZN5physx33PxVehicleGearsDataGeneratedValuesC2EPKNS_18PxVehicleGearsDataE: __ZN5physx33PxVehicleGearsDataGeneratedValuesC2EPKNS_18PxVehicleGearsDataE, _remainder: _remainder, __Z15Transfer_StringI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z44Register_UnityEngine_Mesh_GetBlendShapeIndexv: __Z44Register_UnityEngine_Mesh_GetBlendShapeIndexv, __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdateFinishFrameRenderingstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdateFinishFrameRenderingstruct7ForwardEv, __ZN13ScreenManager13SetLockCursorE14CursorLockMode: __ZN13ScreenManager13SetLockCursorE14CursorLockMode, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZNK5physx19NpArticulationJoint28getTwistLimitContactDistanceEv: __ZNK5physx19NpArticulationJoint28getTwistLimitContactDistanceEv, __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE: __ZN19UnityConnectService20OnPlayerStateChangedENS_12SessionStateE, __Z24RegisterStrippedTypeInfoI13MonoBehaviourEviPKcS2_: __Z24RegisterStrippedTypeInfoI13MonoBehaviourEviPKcS2_, __ZN5physx13PxTaskManager17createTaskManagerEPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE: __ZN5physx13PxTaskManager17createTaskManagerEPNS_15PxCpuDispatcherEPNS_15PxGpuDispatcherEPNS_15PxSpuDispatcherE, __ZN13GfxDeviceGLES17DestroySubProgramEPN9ShaderLab10SubProgramE: __ZN13GfxDeviceGLES17DestroySubProgramEPN9ShaderLab10SubProgramE, __ZNK13WheelCollider14GetMotorTorqueEv: __ZNK13WheelCollider14GetMotorTorqueEv, __ZN15AudioReverbZone16CheckConsistencyEv: __ZN15AudioReverbZone16CheckConsistencyEv, __ZN15NavMeshObstacle8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15NavMeshObstacle8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Unity11AdjacenciesD2Ev: __ZN5Unity11AdjacenciesD2Ev, __ZN5physx22propagateDrivenImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKS8_: __ZN5physx22propagateDrivenImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKS8_, __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallbackD0Ev: __ZZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEEN13AccumCallbackD0Ev, __ZN20TextRenderingPrivate8TextMesh11SetRichTextEb: __ZN20TextRenderingPrivate8TextMesh11SetRichTextEb, __Z56TextGenerator_CUSTOM_INTERNAL_CALL_Populate_Internal_cppP12Il2CppObjectP12Il2CppStringS0_RK10ColorRGBAfiffihhiiiihiffffhhPj: __Z56TextGenerator_CUSTOM_INTERNAL_CALL_Populate_Internal_cppP12Il2CppObjectP12Il2CppStringS0_RK10ColorRGBAfiffihhiiiihiffffhhPj, __Z18StopPreloadManagerv: __Z18StopPreloadManagerv, __Z43QualitySettings_Get_Custom_PropCurrentLevelv: __Z43QualitySettings_Get_Custom_PropCurrentLevelv, __ZL29RegisterModuleICalls_UnityAdsv: __ZL29RegisterModuleICalls_UnityAdsv, __ZN5physx2Sc9ClothCore15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc9ClothCore15importExtraDataERNS_24PxDeserializationContextE, __Z38LineRenderer_Get_Custom_PropStartWidthP12Il2CppObject: __Z38LineRenderer_Get_Custom_PropStartWidthP12Il2CppObject, __ZN5Umbra11ArrayMapper5fetchEi: __ZN5Umbra11ArrayMapper5fetchEi, __Z48Register_UnityEngine_GL_IssuePluginEventInternalv: __Z48Register_UnityEngine_GL_IssuePluginEventInternalv, __Z42Camera_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf: __Z42Camera_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf, __ZN10Collider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10Collider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__225__num_get_signed_integralIlEET_PKcS3_Rji: __ZNSt3__225__num_get_signed_integralIlEET_PKcS3_Rji, __ZN11UnityEngine15CloudWebService14DataDispatcher4StopEv: __ZN11UnityEngine15CloudWebService14DataDispatcher4StopEv, __ZN5physx3Ext10FixedJoint28setProjectionLinearToleranceEf: __ZN5physx3Ext10FixedJoint28setProjectionLinearToleranceEf, __Z17ComputeIdentifierPK8sockaddr: __Z17ComputeIdentifierPK8sockaddr, __Z55Register_UnityEngine_Animator_get_rightFeetBottomHeightv: __Z55Register_UnityEngine_Animator_get_rightFeetBottomHeightv, _zipWriteInFileInZip: _zipWriteInFileInZip, __ZN8Animator17OnPlayableDestroyEv: __ZN8Animator17OnPlayableDestroyEv, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx22PxcHeightFieldAabbTest5beginEv: __ZNK5physx22PxcHeightFieldAabbTest5beginEv, __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv, __ZNK5physx7NpCloth21getLinearInertiaScaleEv: __ZNK5physx7NpCloth21getLinearInertiaScaleEv, _fputws: _fputws, __ZN17GlobalGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17GlobalGameManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN8Animator20ProcessAnimationsJobEPPS_j: __ZN8Animator20ProcessAnimationsJobEPPS_j, __ZNK16b2PrismaticJoint10GetAnchorBEv: __ZNK16b2PrismaticJoint10GetAnchorBEv, __ZNK11b2GearJoint16GetReactionForceEf: __ZNK11b2GearJoint16GetReactionForceEf, __ZNK11b2WeldJoint10GetAnchorAEv: __ZNK11b2WeldJoint10GetAnchorAEv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEEEE15growAndPushBackERKS2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags, __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIN9SubModule14SubEmitterDataELj4EE18resize_initializedEjRKS1_12ResizePolicy, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z35Camera_Get_Custom_PropNearClipPlaneP12Il2CppObject: __Z35Camera_Get_Custom_PropNearClipPlaneP12Il2CppObject, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES6_PNS7_IT0_EE, __ZNK17AnimationCurveTplIfE9FindIndexERKNS0_5CacheEf: __ZNK17AnimationCurveTplIfE9FindIndexERKNS0_5CacheEf, __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowMagnitudev: __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowMagnitudev, _cff_get_is_cid: _cff_get_is_cid, __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE: __ZL33FileEntryInfoListToFolderContentsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK13dynamic_arrayI13FileEntryInfoLj8EERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE, __ZNK5physx3Ext7D6Joint14getLinearLimitEv: __ZNK5physx3Ext7D6Joint14getLinearLimitEv, __Z41getPxClothMotionConstraintConfigStiffnessPKN5physx29PxClothMotionConstraintConfigE: __Z41getPxClothMotionConstraintConfigStiffnessPKN5physx29PxClothMotionConstraintConfigE, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __ZNK10UnityScene7ReleaseEv: __ZNK10UnityScene7ReleaseEv, __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy: __ZN13dynamic_arrayI10Matrix4x4fLj16EE18resize_initializedEjRKS0_12ResizePolicy, __ZN5physx23NpParticleFluidReadData18getDataAccessFlagsEv: __ZN5physx23NpParticleFluidReadData18getDataAccessFlagsEv, __ZN18AssetBundleManager55CollectPreloadObjectsFromAssetBundleLoadAssetOperationsER13dynamic_arrayIiLj4EE: __ZN18AssetBundleManager55CollectPreloadObjectsFromAssetBundleLoadAssetOperationsER13dynamic_arrayIiLj4EE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE8pushNameEPKc, __ZN5physx18ReducedVertexCloudD2Ev: __ZN5physx18ReducedVertexCloudD2Ev, _jinit_c_coef_controller: _jinit_c_coef_controller, __ZN26AnimatorOverrideControllerD2Ev: __ZN26AnimatorOverrideControllerD2Ev, __ZN5physx12_GLOBAL__N_116LocationCallback6invokeERfPKNS_2Sq13PrunerPayloadEj: __ZN5physx12_GLOBAL__N_116LocationCallback6invokeERfPKNS_2Sq13PrunerPayloadEj, __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, _cff_ps_has_glyph_names: _cff_ps_has_glyph_names, __ZNK6Camera22GetCameraToWorldMatrixEv: __ZNK6Camera22GetCameraToWorldMatrixEv, __ZN15FileSystemEntry13MoveByCopyingERS_23FileSystemCopyMoveFlags: __ZN15FileSystemEntry13MoveByCopyingERS_23FileSystemCopyMoveFlags, __Z49Register_UnityEngine_WheelCollider_get_steerAnglev: __Z49Register_UnityEngine_WheelCollider_get_steerAnglev, __ZN7Terrain7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN7Terrain7PRODUCEE10MemLabelId18ObjectCreationMode, __Z49Register_UnityEngine_AI_NavMeshObstacle_set_shapev: __Z49Register_UnityEngine_AI_NavMeshObstacle_set_shapev, __Z14StringToUInt32PKc: __Z14StringToUInt32PKc, __ZN5physx9NpPhysics24registerDeletionListenerERNS_18PxDeletionListenerERKNS_7PxFlagsINS_19PxDeletionEventFlag4EnumEhEEb: __ZN5physx9NpPhysics24registerDeletionListenerERNS_18PxDeletionListenerERKNS_7PxFlagsINS_19PxDeletionEventFlag4EnumEhEEb, _regerror: _regerror, __ZN21ParticleSystemManagerD2Ev: __ZN21ParticleSystemManagerD2Ev, __ZN5physx15writeWordBufferEPKtjbRNS_14PxOutputStreamE: __ZN5physx15writeWordBufferEPKtjbRNS_14PxOutputStreamE, __Z37CapsuleCollider_Set_Custom_PropRadiusP12Il2CppObjectf: __Z37CapsuleCollider_Set_Custom_PropRadiusP12Il2CppObjectf, __Z13RegisterClassI17GlobalGameManagerEvv: __Z13RegisterClassI17GlobalGameManagerEvv, __ZN5physx14SapPairManager4initEj: __ZN5physx14SapPairManager4initEj, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags, __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __ZN9Animation4StopEv: __ZN9Animation4StopEv, __ZNSt3__26__sortIRNS_6__lessIllEEPlEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIllEEPlEEvT0_S5_T_, __ZN5physx2Gu23computeMTD_PlaneCapsuleERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_7CapsuleE: __ZN5physx2Gu23computeMTD_PlaneCapsuleERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_7CapsuleE, __ZN5physx2Cm12RenderOutputlsEj: __ZN5physx2Cm12RenderOutputlsEj, __Z33RenderSettings_Get_Custom_PropFogv: __Z33RenderSettings_Get_Custom_PropFogv, __Z23ConvertImageToPNGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EE: __Z23ConvertImageToPNGBufferRK14ImageReferenceR13dynamic_arrayIhLj1EE, __ZL29StaticCleanupIUnityInterfacesPv: __ZL29StaticCleanupIUnityInterfacesPv, __Z39ParticleRenderer_Get_Custom_PropUvTilesP12Il2CppObject: __Z39ParticleRenderer_Get_Custom_PropUvTilesP12Il2CppObject, __ZN24CompressedAnimationCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN24CompressedAnimationCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE19resizeUninitializedEj, __ZN8Material26CopyPropertiesFromMaterialERS_: __ZN8Material26CopyPropertiesFromMaterialERS_, __ZN13GfxDeviceGLES17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace: __ZN13GfxDeviceGLES17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z24RegisterStrippedTypeInfoI10SampleClipEviPKcS2_: __Z24RegisterStrippedTypeInfoI10SampleClipEviPKcS2_, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefIhEE: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefIhEE, __ZN12FixedJoint2D15ThreadedCleanupEv: __ZN12FixedJoint2D15ThreadedCleanupEv, __ZNK26PlayerSettingsSplashScreen34GetSplashScreenBackgroundLandscapeEv: __ZNK26PlayerSettingsSplashScreen34GetSplashScreenBackgroundLandscapeEv, __Z19DebugTextLineByLinePKci: __Z19DebugTextLineByLinePKci, __ZN5Umbra20RuntimeTomeGeneratorC2EPNS_9AllocatorES2_jPPKNS_7ImpTomeEiRKNS_4AABBE: __ZN5Umbra20RuntimeTomeGeneratorC2EPNS_9AllocatorES2_jPPKNS_7ImpTomeEiRKNS_4AABBE, __ZN7mecanim12statemachine18StateMachineMemory8TransferI8BlobSizeEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI8BlobSizeEEvRT_, __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimeMultiplierv: __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimeMultiplierv, __Z57Register_UnityEngine_Camera_INTERNAL_set_projectionMatrixv: __Z57Register_UnityEngine_Camera_INTERNAL_set_projectionMatrixv, __Z33Canvas_Get_Custom_PropWorldCameraP12Il2CppObject: __Z33Canvas_Get_Custom_PropWorldCameraP12Il2CppObject, __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEEEEjT_j: __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEEEEjT_j, __ZNK5Umbra14TomeCollection14getObjectCountEv: __ZNK5Umbra14TomeCollection14getObjectCountEv, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapZMultiplierv, __Z44NavMeshObstacle_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z44NavMeshObstacle_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, _tt_cmap0_validate: _tt_cmap0_validate, __ZN20TextRenderingPrivate7GUIText16RenderGUIElementERK5RectTIfER17ShaderPassContext: __ZN20TextRenderingPrivate7GUIText16RenderGUIElementERK5RectTIfER17ShaderPassContext, __ZNK18DownloadHandlerVFS13GetMemorySizeEv: __ZNK18DownloadHandlerVFS13GetMemorySizeEv, __ZN19UnityConnectService13ReportSessionEv: __ZN19UnityConnectService13ReportSessionEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab18SerializedProperty22SerializedPropertyTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab18SerializedProperty22SerializedPropertyTypeEEvRT_RT0_PKc17TransferMetaFlags, __ZN5physx6shdfnd5ArrayINS_14PxTaskTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_14PxTaskTableRowENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_: __ZNSt3__211__sift_downIRN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEP21ForwardRenderPassDataEEvT0_S7_T_NS_15iterator_traitsIS7_E15difference_typeES7_, __ZN21UnityWebStream_Static14WriteBigEndianERNSt3__26vectorIhNS0_9allocatorIhEEEEi: __ZN21UnityWebStream_Static14WriteBigEndianERNSt3__26vectorIhNS0_9allocatorIhEEEEi, __ZNK5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE7getNameEv, __ZN15CollisionModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN15CollisionModule5CacheERK27ParticleSystemReadOnlyStateR19ParticleSystemState, __Z46UnityWebRequest_CUSTOM_InternalGetCustomMethodP12Il2CppObject: __Z46UnityWebRequest_CUSTOM_InternalGetCustomMethodP12Il2CppObject, __Z54Register_UnityEngine_PointEffector2D_get_distanceScalev: __Z54Register_UnityEngine_PointEffector2D_get_distanceScalev, __Z56Register_UnityEngine_Avatar_INTERNAL_CALL_GetPreRotationv: __Z56Register_UnityEngine_Avatar_INTERNAL_CALL_GetPreRotationv, __Z33UnregisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE: __Z33UnregisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE, __ZN19LightProbeOcclusion8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19LightProbeOcclusion8TransferI24GenerateTypeTreeTransferEEvRT_, __Z44Application_CUSTOM_GetStreamProgressForLeveli: __Z44Application_CUSTOM_GetStreamProgressForLeveli, __ZN2UI14CanvasRenderer13SyncTransformENS0_8SyncFlagEb: __ZN2UI14CanvasRenderer13SyncTransformENS0_8SyncFlagEb, __Z54Register_UnityEngine_RenderSettings_set_flareFadeSpeedv: __Z54Register_UnityEngine_RenderSettings_set_flareFadeSpeedv, __Z20RegisterModule_Clothv: __Z20RegisterModule_Clothv, __Z47ParticleSystem_LightsModule_CUSTOM_SetIntensityP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_LightsModule_CUSTOM_SetIntensityP12Il2CppObjectR15MonoMinMaxCurve, __ZN10GUITexture23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10GUITexture23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN26AnimatorControllerPlayable29CleanupStateMachineBehavioursEv: __ZN26AnimatorControllerPlayable29CleanupStateMachineBehavioursEv, __ZNSt3__220__get_up_to_n_digitsIcPcEEiRT0_S2_RjRKNS_5ctypeIT_EEi: __ZNSt3__220__get_up_to_n_digitsIcPcEEiRT0_S2_RjRKNS_5ctypeIT_EEi, __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math7affineXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE: __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math7affineXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE, __ZN5physx3Ext14PrismaticJoint8setLimitERKNS_22PxJointLinearLimitPairE: __ZN5physx3Ext14PrismaticJoint8setLimitERKNS_22PxJointLinearLimitPairE, __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_9StopEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_9StopEventEEEbRT_, __ZN18AnimatorController15InitializeClassEv: __ZN18AnimatorController15InitializeClassEv, __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab19SerializedStencilOp8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj646ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj646ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation16ControllerMemory8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj458ES2_RKNS_22PxJointLinearLimitPairES6_EEKNS_35PxJointLinearLimitPairGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj458ES2_RKNS_22PxJointLinearLimitPairES6_EEKNS_35PxJointLinearLimitPairGeneratedInfoEEEvPjRKT_RT0_, __ZNK14RenderSettings28GetGeneratedSkyboxReflectionEv: __ZNK14RenderSettings28GetGeneratedSkyboxReflectionEv, __ZN12CachedReader8InitReadER15CacheReaderBasejj: __ZN12CachedReader8InitReadER15CacheReaderBasejj, __Z28LogToPlayerConnectionMessage7LogTypeN17GeneralConnection9MessageIDEPKcPi: __Z28LogToPlayerConnectionMessage7LogTypeN17GeneralConnection9MessageIDEPKcPi, __ZN5physx16PxVehicleNoDrive8allocateEj: __ZN5physx16PxVehicleNoDrive8allocateEj, __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE: __ZN5physx2Sc5Scene19addBroadPhaseVolumeERKNS_9PxBounds3ERNS0_8ShapeSimE, __GLOBAL__sub_I_runtime_profiler_lump_cpp: __GLOBAL__sub_I_runtime_profiler_lump_cpp, __ZNK10FileSystem20GetUserAppDataFolderEv: __ZNK10FileSystem20GetUserAppDataFolderEv, ___freading: ___freading, __Z42Rigidbody_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP8Vector3f: __Z42Rigidbody_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP8Vector3f, __ZN5physx2Sn12RepXUpgrader35upgrade3_1CollectionTo3_2CollectionERNS0_14RepXCollectionE: __ZN5physx2Sn12RepXUpgrader35upgrade3_1CollectionTo3_2CollectionERNS0_14RepXCollectionE, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE15exportExtraDataERNS_22PxSerializationContextE, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5imbueERKNS_6localeE, __Z51Register_UnityEngine_Application_HasAdvancedLicensev: __Z51Register_UnityEngine_Application_HasAdvancedLicensev, __ZThn8_N5physx2Sc18TriggerInteraction10onActivateEj: __ZThn8_N5physx2Sc18TriggerInteraction10onActivateEj, __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEEC2ERNS_19PxAllocatorCallbackE, _UNITY_png_write_info: _UNITY_png_write_info, __Z68Register_UnityEngine_TerrainData_INTERNAL_CALL_GetInterpolatedNormalv: __Z68Register_UnityEngine_TerrainData_INTERNAL_CALL_GetInterpolatedNormalv, __ZN33AssetBundleLoadFromAsyncOperation6CancelEv: __ZN33AssetBundleLoadFromAsyncOperation6CancelEv, __Z44Register_UnityEngine_AudioClip_get_frequencyv: __Z44Register_UnityEngine_AudioClip_get_frequencyv, __Z35Mesh_Get_Custom_PropBlendShapeCountP12Il2CppObject: __Z35Mesh_Get_Custom_PropBlendShapeCountP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj187ENS_22PxRepXPropertyAccessorILj187ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj187ENS_22PxRepXPropertyAccessorILj187ES4_ffEEEEvRKT0_, __ZN17InternalIndexPool15allocateIndicesEjRKN5physx16PxStrideIteratorIjEE: __ZN17InternalIndexPool15allocateIndicesEjRKN5physx16PxStrideIteratorIjEE, __Z33RenderSettings_Set_Custom_PropFogh: __Z33RenderSettings_Set_Custom_PropFogh, __Z13InitDebugGLESv: __Z13InitDebugGLESv, __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNKSt3__210moneypunctIwLb1EE13do_pos_formatEv: __ZNKSt3__210moneypunctIwLb1EE13do_pos_formatEv, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab14SerializedPassENS0_9allocatorIS3_EEEEEvRT_j, __Z56Register_UnityEngine_Shader_GetGlobalVectorArrayImplListv: __Z56Register_UnityEngine_Shader_GetGlobalVectorArrayImplListv, __Z59setPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPN5physx19PxVehicleEngineDataEf: __Z59setPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPN5physx19PxVehicleEngineDataEf, __ZN5physx2Sc7PhysicsD2Ev: __ZN5physx2Sc7PhysicsD2Ev, __ZL15ProcessVerticesRNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEEEPFbNS_11__wrap_iterIPS2_EES9_S9_E: __ZL15ProcessVerticesRNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEEEPFbNS_11__wrap_iterIPS2_EES9_S9_E, __Z30setPxVehicleGearsDataMNbRatiosPN5physx18PxVehicleGearsDataEj: __Z30setPxVehicleGearsDataMNbRatiosPN5physx18PxVehicleGearsDataEj, __ZN5physx6shdfnd8internal7median3INS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEvPT_iiRT0_: __ZN5physx6shdfnd8internal7median3INS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEvPT_iiRT0_, __ZN5Unity17ConfigurableJoint17SetAngularYZDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint17SetAngularYZDriveERK10JointDrive, _strpbrk: _strpbrk, __ZN5Umbra11ShadowUtils18getFrustumVerticesEPNS_7Vector3EPKNS_7Vector4E: __ZN5Umbra11ShadowUtils18getFrustumVerticesEPNS_7Vector3EPKNS_7Vector4E, __ZN21RotationBySpeedModule5ResetEv: __ZN21RotationBySpeedModule5ResetEv, __Z29Transfer_Blittable_ArrayFieldI8JSONRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN14SerializedFile4Type10SetOldTypeEPK8TypeTree: __ZN14SerializedFile4Type10SetOldTypeEPK8TypeTree, __ZN29LineParametersPropertyBindingC2E11ClassIDTypeN11UnityEngine9Animation8BindTypeE: __ZN29LineParametersPropertyBindingC2E11ClassIDTypeN11UnityEngine9Animation8BindTypeE, __ZN30ParticleSystemTrailGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj: __ZN30ParticleSystemTrailGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj, __ZN12CachedWriter15CompleteWritingEv: __ZN12CachedWriter15CompleteWritingEv, __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii: __ZNK23ParticleSystemParticles14CopyToArrayAOSEP22ParticleSystemParticleii, __Z42Register_UnityEngine_Animator_StopPlaybackv: __Z42Register_UnityEngine_Animator_StopPlaybackv, __ZN9ShaderLab18SerializedProperty8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab18SerializedProperty8TransferI14SafeBinaryReadEEvRT_, __Z36Register_UnityEngine_RectOffset_Initv: __Z36Register_UnityEngine_RectOffset_Initv, __Z43GameObject_CUSTOM_Internal_CreateGameObjectP12Il2CppObjectP12Il2CppString: __Z43GameObject_CUSTOM_Internal_CreateGameObjectP12Il2CppObjectP12Il2CppString, __Z34GetNonJitteredViewProjectionMatrixR6Camera: __Z34GetNonJitteredViewProjectionMatrixR6Camera, __ZN13dynamic_arrayI13BoneInfluenceLj16EEC2ERKS1_: __ZN13dynamic_arrayI13BoneInfluenceLj16EEC2ERKS1_, __ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_: __ZN6Camera25StandaloneRenderToCubemapEP7TextureiPFvPK9SceneNodePK4AABBR9IndexListPvESA_, __ZN11AudioModule6UpdateEv: __ZN11AudioModule6UpdateEv, __ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_: __ZN12_GLOBAL__N_110ReadStringINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEEEbR12FileAccessorPT_, __Z62Register_UnityEngine_GUIClip_Internal_GetAbsoluteMousePositionv: __Z62Register_UnityEngine_GUIClip_Internal_GetAbsoluteMousePositionv, __ZN7ApiGLES13DeleteProgramERj: __ZN7ApiGLES13DeleteProgramERj, __ZN11KeyframeTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11KeyframeTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN20BufferedSocketStreamD0Ev: __ZN20BufferedSocketStreamD0Ev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags, __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE: __ZNK5physx2Sn5ConvX12getMetaClassEPKcNS0_12MetaDataTypeE, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7releaseEv: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE7releaseEv, __ZN13GfxDeviceGLES23UploadSparseTextureTileE9TextureIDiiiPKhii: __ZN13GfxDeviceGLES23UploadSparseTextureTileE9TextureIDiiiPKhii, __Z21CalculateHullWireMeshR13dynamic_arrayI8Vector3fLj4EERK16NavMeshCarveDataff: __Z21CalculateHullWireMeshR13dynamic_arrayI8Vector3fLj4EERK16NavMeshCarveDataff, __Z45Register_UnityEngine_Mesh_INTERNAL_get_boundsv: __Z45Register_UnityEngine_Mesh_INTERNAL_get_boundsv, __ZN5physx25PxLockedDataGeneratedInfoC2Ev: __ZN5physx25PxLockedDataGeneratedInfoC2Ev, __Z32getPxVehicleGearsDataMFinalRatioPKN5physx18PxVehicleGearsDataE: __Z32getPxVehicleGearsDataMFinalRatioPKN5physx18PxVehicleGearsDataE, __Z34Register_UnityEngine_Graphics_Blitv: __Z34Register_UnityEngine_Graphics_Blitv, __ZNK5physx2Sc15ClothFabricCore13getRestvaluesEPfj: __ZNK5physx2Sc15ClothFabricCore13getRestvaluesEPfj, __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipVv: __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipVv, __Z13RegisterClassIN2UI14CanvasRendererEEvv: __Z13RegisterClassIN2UI14CanvasRendererEEvv, __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI8MaterialE8TransferI14SafeBinaryReadEEvRT_, __Z64Register_UnityEngine_GUIStyle_GetFontInternalDuringLoadingThreadv: __Z64Register_UnityEngine_GUIStyle_GetFontInternalDuringLoadingThreadv, __ZN5physx2Sn18writeAllPropertiesINS_23PxVehicleDriveSimDataNWEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_23PxVehicleDriveSimDataNWEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject: __ZN13MonoBehaviour8SetClassEP11Il2CppClassP12Il2CppObject, __Z67AnimatorControllerPlayable_CUSTOM_GetAnimatorTransitionInfoInternalR9HPlayablei: __Z67AnimatorControllerPlayable_CUSTOM_GetAnimatorTransitionInfoInternalR9HPlayablei, __ZN17PolygonCollider2D15TransformPointsERK13dynamic_arrayI8Vector2fLj4EERK10Matrix4x4fRKS1_P6b2Vec2: __ZN17PolygonCollider2D15TransformPointsERK13dynamic_arrayI8Vector2fLj4EERK10Matrix4x4fRKS1_P6b2Vec2, __ZN12_GLOBAL__N_112UserRenderer17flushRenderEventsEv: __ZN12_GLOBAL__N_112UserRenderer17flushRenderEventsEv, __ZN2UI6Canvas25UpdateCanvasPlaneDistanceEv: __ZN2UI6Canvas25UpdateCanvasPlaneDistanceEv, __Z34PrepareParametersCullShadowCastersRK11ActiveLightRK14ShadowCullDataR22SceneCullingParametersR13ShadowedLight: __Z34PrepareParametersCullShadowCastersRK11ActiveLightRK14ShadowCullDataR22SceneCullingParametersR13ShadowedLight, __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_: __ZNSt3__27__sort3IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_T_, __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN17AnimationPlayable7GetTypeEv: __ZN17AnimationPlayable7GetTypeEv, __Z38Register_UnityEngine_Cloth_get_enabledv: __Z38Register_UnityEngine_Cloth_get_enabledv, __ZN11UnityEngine9Analytics16TransactionEventD0Ev: __ZN11UnityEngine9Analytics16TransactionEventD0Ev, __Z40AudioSource_CUSTOM_INTERNAL_CALL_UnPauseP12Il2CppObject: __Z40AudioSource_CUSTOM_INTERNAL_CALL_UnPauseP12Il2CppObject, __ZN17FileSystemHandler12CreateAsFileER13FileEntryData: __ZN17FileSystemHandler12CreateAsFileER13FileEntryData, __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE: __ZN5physx2SnL22releaseNodeAndChildrenEPNS_18CMemoryPoolManagerEPNS0_7XmlNodeE, __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP14AnimationState13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __Z59ParticleSystem_LightsModule_CUSTOM_SetUseRandomDistributionP12Il2CppObjecth: __Z59ParticleSystem_LightsModule_CUSTOM_SetUseRandomDistributionP12Il2CppObjecth, __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E, __ZNSt3__212ctype_bynameIwED0Ev: __ZNSt3__212ctype_bynameIwED0Ev, __ZN5Flare12FlareElement8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Flare12FlareElement8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine15PlatformWrapper24GetSystemLanguageCultureEv: __ZN11UnityEngine15PlatformWrapper24GetSystemLanguageCultureEv, __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRyNS0_27EventStreamCompressionFlags4EnumE, __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags, __ZNK17FileSystemHandler9IsSymLinkERK13FileEntryData: __ZNK17FileSystemHandler9IsSymLinkERK13FileEntryData, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN19CloudServiceHandler19StopEventDispatcherEv: __ZN19CloudServiceHandler19StopEventDispatcherEv, __ZNSt3__25ctypeIwED0Ev: __ZNSt3__25ctypeIwED0Ev, __Z58Register_UnityEngine_ConfigurableJoint_set_projectionAnglev: __Z58Register_UnityEngine_ConfigurableJoint_set_projectionAnglev, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __Z8memset32Pvjy: __Z8memset32Pvjy, __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE: __ZN17AnimationCurveTplIfE6AssignERK11KeyframeTplIfE, __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE: __ZNK6Camera15SaveMatrixStateERNS_11MatrixStateE, __Z52Register_UnityEngine_OcclusionArea_INTERNAL_get_sizev: __Z52Register_UnityEngine_OcclusionArea_INTERNAL_get_sizev, _UNITY_FT_Create_Class_cff_field_handlers: _UNITY_FT_Create_Class_cff_field_handlers, __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE7copyfmtERKS3_: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE7copyfmtERKS3_, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5uflowEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5uflowEv, __Z61Register_UnityEngineInternal_GIDebugVisualisation_get_texTypev: __Z61Register_UnityEngineInternal_GIDebugVisualisation_get_texTypev, __ZN6Camera13AwakeFromLoadE17AwakeFromLoadMode: __ZN6Camera13AwakeFromLoadE17AwakeFromLoadMode, __Z50Register_UnityEngine_Mesh_PrintErrorCantAccessMeshv: __Z50Register_UnityEngine_Mesh_PrintErrorCantAccessMeshv, __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK6Camera21ScreenToViewportPointERK8Vector3f: __ZNK6Camera21ScreenToViewportPointERK8Vector3f, __Z18CheckValidFileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18CheckValidFileNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z51Register_UnityEngine_BuoyancyEffector2D_get_densityv: __Z51Register_UnityEngine_BuoyancyEffector2D_get_densityv, _mallopt: _mallopt, __ZN15SerializeTraitsI31ArrayOfManagedObjectsTransfererE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_: __ZN15SerializeTraitsI31ArrayOfManagedObjectsTransfererE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_, __ZN13MemoryManager22GetTotalProfilerMemoryEv: __ZN13MemoryManager22GetTotalProfilerMemoryEv, __Z24RegisterStrippedTypeInfoI12FixedJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI12FixedJoint2DEviPKcS2_, _initstate: _initstate, __ZN5physx8debugger14PvdMarshallingItjE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItjE12marshalBlockEPKhPhj, __ZN17JointSuspension2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17JointSuspension2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK10Matrix4x4f10IsIdentityEf: __ZNK10Matrix4x4f10IsIdentityEf, _UNITY_png_set_read_fn: _UNITY_png_set_read_fn, __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb: __ZN5physx2Gu14computeHullOBBERNS0_3BoxERKNS_9PxBounds3EfRKNS_11PxTransformERKNS_2Cm8Matrix34ESC_RKNS9_23FastVertex2ShapeScalingEb, __Z50setPxVehicleTireDataMCamberStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf: __Z50setPxVehicleTireDataMCamberStiffnessPerUnitGravityPN5physx17PxVehicleTireDataEf, __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb: __ZN5physx33PxcContactSphereHeightFieldSharedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferEb, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __Z38DynamicGI_Get_Custom_PropIndirectScalev: __Z38DynamicGI_Get_Custom_PropIndirectScalev, __Z37Camera_CUSTOM_SetTargetBuffersMRTImplP12Il2CppObjectP11Il2CppArrayP21ScriptingRenderBuffer: __Z37Camera_CUSTOM_SetTargetBuffersMRTImplP12Il2CppObjectP11Il2CppArrayP21ScriptingRenderBuffer, __Z51Register_UnityEngine_MonoBehaviour_set_useGUILayoutv: __Z51Register_UnityEngine_MonoBehaviour_set_useGUILayoutv, __ZN15AABBTreeOverlapIN5physx2Gu12OBBAABBTestsILb1EEEEclEPNS0_2Sq13PrunerPayloadERKNS5_8AABBTreeERKS3_RNS5_14PrunerCallbackE: __ZN15AABBTreeOverlapIN5physx2Gu12OBBAABBTestsILb1EEEEclEPNS0_2Sq13PrunerPayloadERKNS5_8AABBTreeERKS3_RNS5_14PrunerCallbackE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv, __Z22IsChildOrSameTransformP9TransformS0_: __Z22IsChildOrSameTransformP9TransformS0_, __Z54Register_UnityEngine_MaterialPropertyBlock_get_isEmptyv: __Z54Register_UnityEngine_MaterialPropertyBlock_get_isEmptyv, __Z52Register_UnityEngine_WindZone_set_windPulseFrequencyv: __Z52Register_UnityEngine_WindZone_set_windPulseFrequencyv, __ZN14AnimationEventC2ERKS_: __ZN14AnimationEventC2ERKS_, __Z33Animation_Set_Custom_PropWrapModeP12Il2CppObjecti: __Z33Animation_Set_Custom_PropWrapModeP12Il2CppObjecti, __ZN14SafeBinaryRead8TransferIjEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIjEEvRT_PKc17TransferMetaFlags, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13MemoryManager19GetAllocatorAtIndexEi: __ZN13MemoryManager19GetAllocatorAtIndexEi, __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv: __ZNK13Simd4iFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv, __ZN39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader: __ZN39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader, __ZZN2UI23InitializeCanvasManagerEvEN41UIEventsCanvasManagerRenderOverlaysstruct7ForwardEi: __ZZN2UI23InitializeCanvasManagerEvEN41UIEventsCanvasManagerRenderOverlaysstruct7ForwardEi, __Z50Register_UnityEngine_AnimationCurve_SmoothTangentsv: __Z50Register_UnityEngine_AnimationCurve_SmoothTangentsv, __ZN14StackAllocator10ReallocateEPvji: __ZN14StackAllocator10ReallocateEPvji, __Z30AnimationCurve_CUSTOM_EvaluateP12Il2CppObjectf: __Z30AnimationCurve_CUSTOM_EvaluateP12Il2CppObjectf, __ZN12CubemapArray8TransferI14SafeBinaryReadEEvRT_: __ZN12CubemapArray8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx12PxsRigidBody20getAdvancedTransformEf: __ZNK5physx12PxsRigidBody20getAdvancedTransformEf, __ZN14CachingManager23GetCachingDiskSpaceUsedEv: __ZN14CachingManager23GetCachingDiskSpaceUsedEv, __ZNK2UI13RectTransform17GetDrivenByObjectEv: __ZNK2UI13RectTransform17GetDrivenByObjectEv, _UNITY_png_do_check_palette_indexes: _UNITY_png_do_check_palette_indexes, __Z57Register_UnityEngine_Transform_INTERNAL_set_localRotationv: __Z57Register_UnityEngine_Transform_INTERNAL_set_localRotationv, _jsimd_can_h2v1_upsample: _jsimd_can_h2v1_upsample, __ZN5physx2Sn17readAllPropertiesINS_18PxVehicleDriveTankEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_18PxVehicleDriveTankEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZNSt3__217__assoc_sub_state9set_valueEv: __ZNSt3__217__assoc_sub_state9set_valueEv, __ZN15AudioEchoFilterC2E10MemLabelId18ObjectCreationMode: __ZN15AudioEchoFilterC2E10MemLabelId18ObjectCreationMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__28ios_base7failureC2EPKcRKNS_10error_codeE: __ZNSt3__28ios_base7failureC2EPKcRKNS_10error_codeE, __Z52Register_UnityEngine_TerrainData_set_splatPrototypesv: __Z52Register_UnityEngine_TerrainData_set_splatPrototypesv, __ZN21LightProbeProxyVolumeC2E10MemLabelId18ObjectCreationMode: __ZN21LightProbeProxyVolumeC2E10MemLabelId18ObjectCreationMode, __ZN6SocketD0Ev: __ZN6SocketD0Ev, __ZN5physx16PxcContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx16PxcContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN12GUIClipState4ClipERK5RectTIfE: __ZN12GUIClipState4ClipERK5RectTIfE, __Z42getPxVehicleDriveDynDataMAutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE: __Z42getPxVehicleDriveDynDataMAutoBoxSwitchTimePKN5physx21PxVehicleDriveDynDataE, _i64Add: _i64Add, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN15ResourceManager10Dependency8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15ResourceManager10Dependency8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10TagManager21FindDefaultLayerIndexEv: __ZN10TagManager21FindDefaultLayerIndexEv, __ZN5physx13PxsCCDContextD2Ev: __ZN5physx13PxsCCDContextD2Ev, __ZN5physx20PxsParticleSystemSim13setSimulatedVEb: __ZN5physx20PxsParticleSystemSim13setSimulatedVEb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags, __ZN8Animator15SetBodyRotationERK11Quaternionf: __ZN8Animator15SetBodyRotationERK11Quaternionf, __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN7mecanim9animation16ControllerMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18Transfer_BlittableI9JSONWriteLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_FT_Stream_ReleaseFrame: _UNITY_FT_Stream_ReleaseFrame, __ZN5physx2Sc5Scene20addArticulationJointERNS0_21ArticulationJointCoreERNS0_8BodyCoreES5_: __ZN5physx2Sc5Scene20addArticulationJointERNS0_21ArticulationJointCoreERNS0_8BodyCoreES5_, __ZN8Renderer16TransformChangedEi: __ZN8Renderer16TransformChangedEi, __Z37Register_UnityEngine_AudioSource_Playv: __Z37Register_UnityEngine_AudioSource_Playv, __ZN6Camera21CleanupAfterRenderingEPK11CullResults: __ZN6Camera21CleanupAfterRenderingEPK11CullResults, __Z46Register_UnityEngine_LineRenderer_get_endWidthv: __Z46Register_UnityEngine_LineRenderer_get_endWidthv, __ZN14CellVisualizer21containsCellRecursiveEii: __ZN14CellVisualizer21containsCellRecursiveEii, __ZN5Unity11SpringJoint23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity11SpringJoint23VirtualRedirectTransferER14SafeBinaryRead, __Z41AudioMixerGroup_Get_Custom_PropAudioMixerP12Il2CppObject: __Z41AudioMixerGroup_Get_Custom_PropAudioMixerP12Il2CppObject, __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsUInt64ERK8UnityStry: __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsUInt64ERK8UnityStry, __Z14FMOD_FILE_ReadPvS_jPjS_: __Z14FMOD_FILE_ReadPvS_jPjS_, __ZN5physx6shdfnd8internal7median3IjKNS_19SortBoundsPredicateEEEvPT_iiRT0_: __ZN5physx6shdfnd8internal7median3IjKNS_19SortBoundsPredicateEEEvPT_iiRT0_, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj601ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj601ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __Z41SortingLayer_CUSTOM_GetLayerValueFromNameP12Il2CppString: __Z41SortingLayer_CUSTOM_GetLayerValueFromNameP12Il2CppString, __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE: __ZN5physx7NpShape8setActorEPNS_12PxRigidActorE, __ZNK9AudioClip10GetBitRateEv: __ZNK9AudioClip10GetBitRateEv, __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK8Renderer26GetTypeInfoVirtualInternalEv: __ZNK8Renderer26GetTypeInfoVirtualInternalEv, __ZN10MonoScript23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10MonoScript23VirtualRedirectTransferER17RemapPPtrTransfer, __Z58Register_UnityEngine_AI_NavMeshAgent_get_avoidancePriorityv: __Z58Register_UnityEngine_AI_NavMeshAgent_get_avoidancePriorityv, __ZN5Unity17ConfigurableJoint18SetProjectionAngleEf: __ZN5Unity17ConfigurableJoint18SetProjectionAngleEf, __Z20CreateObjectFromCodeI12CubemapArrayEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI12CubemapArrayEPT_17AwakeFromLoadMode10MemLabelId, __ZN13TargetJoint2D19AutoConfigureTargetEv: __ZN13TargetJoint2D19AutoConfigureTargetEv, __ZN27ColorModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN27ColorModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN13ComputeShader18DestroyRuntimeDataEv: __ZN13ComputeShader18DestroyRuntimeDataEv, __Z45Register_UnityEngine_Transform_DetachChildrenv: __Z45Register_UnityEngine_Transform_DetachChildrenv, __ZN4FMOD7Channel20get3DConeOrientationEP11FMOD_VECTOR: __ZN4FMOD7Channel20get3DConeOrientationEP11FMOD_VECTOR, __Z38Register_UnityEngine_Light_get_shadowsv: __Z38Register_UnityEngine_Light_get_shadowsv, __ZN13SpeedTreeWind7SParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SpeedTreeWind7SParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15FileSystemEntryC2Ev: __ZN15FileSystemEntryC2Ev, __ZN5physx2Sc15ArticulationSim22updateCachedTransformsERNS_17PxsTransformCacheEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx2Sc15ArticulationSim22updateCachedTransformsERNS_17PxsTransformCacheEPNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __ZNK16MemoryFileSystem15GetFileRefCountEPKc: __ZNK16MemoryFileSystem15GetFileRefCountEPKc, __ZN4File5CloseEv: __ZN4File5CloseEv, __Z46Register_UnityEngine_Time_get_captureFrameratev: __Z46Register_UnityEngine_Time_get_captureFrameratev, __ZN9Rigidbody23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Rigidbody23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN14BlendShapeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14BlendShapeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Scb5Scene9syncStateEv: __ZN5physx3Scb5Scene9syncStateEv, __ZNK5physx36PxVehicleDriveSimData4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j: __ZNK5physx36PxVehicleDriveSimData4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv, __ZN6Avatar12SetParameterEif: __ZN6Avatar12SetParameterEif, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISC_EE5valueERS7_E4typeESC_SC_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISC_EE5valueERS7_E4typeESC_SC_, __GLOBAL__sub_I_runtime_serialize_transferfunctions_lump_cpp: __GLOBAL__sub_I_runtime_serialize_transferfunctions_lump_cpp, __Z47Register_UnityEngine_AudioReverbZone_set_roomLFv: __Z47Register_UnityEngine_AudioReverbZone_set_roomLFv, __ZN15DirectorManager25CanScheduleForDestructionEP8Playable: __ZN15DirectorManager25CanScheduleForDestructionEP8Playable, __ZN5physx10PxMaterialD0Ev: __ZN5physx10PxMaterialD0Ev, __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcNS_14PxProfileNamesEj: __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcNS_14PxProfileNamesEj, __Z21RandomPointInsideCubeR5RandNPKf: __Z21RandomPointInsideCubeR5RandNPKf, __Z27Animation_CUSTOM_RemoveClipP12Il2CppObjectS0_: __Z27Animation_CUSTOM_RemoveClipP12Il2CppObjectS0_, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEcvbEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEEcvbEv, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefIKhEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefIKhEE, __ZN10UnityScene14SetPathAndGUIDERK8UnityStrRK9UnityGUID: __ZN10UnityScene14SetPathAndGUIDERK8UnityStrRK9UnityGUID, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19getInvInertiaScale1Ev, __ZN4FMOD6System20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb: __ZN4FMOD6System20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb, __ZN4FMOD6SoundI18get3DCustomRolloffEPP11FMOD_VECTORPi: __ZN4FMOD6SoundI18get3DCustomRolloffEPP11FMOD_VECTORPi, __ZN5physx14NpArticulation7releaseEv: __ZN5physx14NpArticulation7releaseEv, __ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE: __ZNK5physx14NpSceneQueries10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z45Register_UnityEngine_GameObject_get_transformv: __Z45Register_UnityEngine_GameObject_get_transformv, __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN22UnityWebRequestManager31UnregisterDownloadScriptHandlerEP21DownloadHandlerScript: __ZN22UnityWebRequestManager31UnregisterDownloadScriptHandlerEP21DownloadHandlerScript, __ZL11TextHandleriPK23EmscriptenKeyboardEventPv: __ZL11TextHandleriPK23EmscriptenKeyboardEventPv, __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity5Joint16JointTransferPreI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __ZN15AudioEchoFilter6UpdateEv: __ZN15AudioEchoFilter6UpdateEv, __Z29Rigidbody_Get_Custom_PropMassP12Il2CppObject: __Z29Rigidbody_Get_Custom_PropMassP12Il2CppObject, __ZN5Unity5Joint16CheckConsistencyEv: __ZN5Unity5Joint16CheckConsistencyEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignESt16initializer_listIwE, __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_: __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaERKNS_6shdfnd3aos6Mat33VEPKNS_14PxcSIMDSpatialEPS9_, __Z57Register_UnityEngine_QualitySettings_get_activeColorSpacev: __Z57Register_UnityEngine_QualitySettings_get_activeColorSpacev, __ZN5physx2Sq10AABBPruner18updateBucketPrunerEv: __ZN5physx2Sq10AABBPruner18updateBucketPrunerEv, __Z40FixedJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject: __Z40FixedJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject, __ZN15SerializeTraitsIN16ParticleRenderer11UVAnimationEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN16ParticleRenderer11UVAnimationEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN4FMOD7SystemI11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E: __ZN4FMOD7SystemI11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E, __ZN16LightmapSettings14ClearLightmapsEv: __ZN16LightmapSettings14ClearLightmapsEv, __Z23Input_CUSTOM_GetAxisRawP12Il2CppString: __Z23Input_CUSTOM_GetAxisRawP12Il2CppString, _cff_lookup_glyph_by_stdcharcode: _cff_lookup_glyph_by_stdcharcode, __Z38Register_UnityEngine_Event_set_keyCodev: __Z38Register_UnityEngine_Event_set_keyCodev, __Z21CleanupVehiclesModulev: __Z21CleanupVehiclesModulev, __ZN5physx3Cct11SweptVolumeD2Ev: __ZN5physx3Cct11SweptVolumeD2Ev, __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalMatrixv: __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalMatrixv, __Z11CloneObjectR6ObjectR9Transformb: __Z11CloneObjectR6ObjectR9Transformb, __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j: __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleDriveSimData4WEEEEEEEjT_j, __ZN11UnityEngine15CloudWebService13WWWRestClient7CleanupEv: __ZN11UnityEngine15CloudWebService13WWWRestClient7CleanupEv, __Z40Input_Set_Custom_PropBackButtonLeavesApph: __Z40Input_Set_Custom_PropBackButtonLeavesApph, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj161ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj161ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _ft_outline_glyph_copy: _ft_outline_glyph_copy, __ZN16ControllerFilterD0Ev: __ZN16ControllerFilterD0Ev, __ZN5physx2Sc5Scene21buildActiveTransformsEv: __ZN5physx2Sc5Scene21buildActiveTransformsEv, __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE: __Z24InitializeMainSceneRangeiiR13dynamic_arrayI10SceneRangeLj4EE, __Z19FileSystemIsMountedv: __Z19FileSystemIsMountedv, __ZN14b2PolygonShape8ValidateEPK6b2Vec2i: __ZN14b2PolygonShape8ValidateEPK6b2Vec2i, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj579ENS_22PxRepXPropertyAccessorILj579ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj579ENS_22PxRepXPropertyAccessorILj579ES4_ffEEEEvRKT0_, __ZN17GeneralConnection14OnDisconnectedEj: __ZN17GeneralConnection14OnDisconnectedEj, __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE: __ZL15CloneObjectImplP6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE, __ZN5Unity17ConfigurableJoint20SetLinearLimitSpringERK20SoftJointLimitSpring: __ZN5Unity17ConfigurableJoint20SetLinearLimitSpringERK20SoftJointLimitSpring, __ZL18DestroyCachedStripPv: __ZL18DestroyCachedStripPv, __Z40Register_UnityEngine_Shader_PropertyToIDv: __Z40Register_UnityEngine_Shader_PropertyToIDv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEbT0_SD_T_: __ZNSt3__227__insertion_sort_incompleteIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEbT0_SD_T_, __Z32AndroidJNI_CUSTOM_PushLocalFramei: __Z32AndroidJNI_CUSTOM_PushLocalFramei, __ZN13PhysicsModule10GetGravityEv: __ZN13PhysicsModule10GetGravityEv, __ZNK5physx2Sq12BucketPruner9visualizeERNS_2Cm12RenderOutputEj: __ZNK5physx2Sq12BucketPruner9visualizeERNS_2Cm12RenderOutputEj, __ZN15AudioReverbZone15ThreadedCleanupEv: __ZN15AudioReverbZone15ThreadedCleanupEv, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE8getSceneEv, __ZN8Animator16InitializeAvatarEv: __ZN8Animator16InitializeAvatarEv, __ZN10SampleClip14ReleaseIfEqualE11SoundHandle: __ZN10SampleClip14ReleaseIfEqualE11SoundHandle, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z54Register_UnityEngine_ReflectionProbe_set_blendDistancev: __Z54Register_UnityEngine_ReflectionProbe_set_blendDistancev, __ZN19SpriteMeshGenerator7invmaskERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEE: __ZN19SpriteMeshGenerator7invmaskERNSt3__26vectorINS_6vertexENS0_9allocatorIS2_EEEE, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewIntArrayv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewIntArrayv, __ZN11TimeManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11TimeManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEfEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_: __ZNSt3__26vectorINS_4pairIN9ShaderLab16FastPropertyNameEfEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_, __Z41ReflectionProbe_Get_Custom_PropResolutionP12Il2CppObject: __Z41ReflectionProbe_Get_Custom_PropResolutionP12Il2CppObject, __ZN15DetailPrototype8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15DetailPrototype8TransferI24GenerateTypeTreeTransferEEvRT_, __Z50AnimatorOverrideController_CUSTOM_GetOverrideClipsP12Il2CppObject: __Z50AnimatorOverrideController_CUSTOM_GetOverrideClipsP12Il2CppObject, __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE: __ZNSt3__218condition_variable4waitERNS_11unique_lockINS_5mutexEEE, __ZN5physx6shdfnd5ArrayIPNS_2Sc9ClothCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc9ClothCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN11UnityEngine15CloudWebService14DataDispatcherD0Ev: __ZN11UnityEngine15CloudWebService14DataDispatcherD0Ev, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev, __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_ColDepthv: __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_ColDepthv, __ZN4crnd12crn_unpacker12unpack_levelEPKvjPPvjjj: __ZN4crnd12crn_unpacker12unpack_levelEPKvjPPvjjj, __ZN13AudioListener7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13AudioListener7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx30solveExtFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx30solveExtFrictionBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __Z40Collider2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_: __Z40Collider2D_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_, __ZN22UnityWebRequestManager8RegisterEP15UnityWebRequest: __ZN22UnityWebRequestManager8RegisterEP15UnityWebRequest, _tlsf_realloc_align: _tlsf_realloc_align, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZN5physx25PxAggregateRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx25PxAggregateRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNK8Animator21GetControllerPlayableEv: __ZNK8Animator21GetControllerPlayableEv, __ZN14AssetReferenceC2ERKS_: __ZN14AssetReferenceC2ERKS_, __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z47Register_UnityEngine_Cloth_set_bendingStiffnessv: __Z47Register_UnityEngine_Cloth_set_bendingStiffnessv, __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN22BuiltinResourceManager22InitializeAllResourcesEv: __ZN22BuiltinResourceManager22InitializeAllResourcesEv, __ZNK5physx19NpArticulationJoint10getDampingEv: __ZNK5physx19NpArticulationJoint10getDampingEv, __ZN23CloudWebServicesManager17PlayerLoopHandlerEv: __ZN23CloudWebServicesManager17PlayerLoopHandlerEv, __ZN5physx2Sc5Scene20particlePostShapeGenEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene20particlePostShapeGenEPNS_10PxBaseTaskE, __Z46Register_UnityEngine_Transform_SetSiblingIndexv: __Z46Register_UnityEngine_Transform_SetSiblingIndexv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEPKcjj, __ZN27GenericSlowGarbageCollector18GenerateInstanceIDEi17TransferMetaFlags: __ZN27GenericSlowGarbageCollector18GenerateInstanceIDEi17TransferMetaFlags, __Z46ParticleSystem_ShapeModule_CUSTOM_GetMeshScaleP12Il2CppObject: __Z46ParticleSystem_ShapeModule_CUSTOM_GetMeshScaleP12Il2CppObject, __ZNKSt3__224__generic_error_category7messageEi: __ZNKSt3__224__generic_error_category7messageEi, __ZNK13Lz4Compressor18CompressStreamInitEPPv16CompressionLevel: __ZNK13Lz4Compressor18CompressStreamInitEPPv16CompressionLevel, __ZN15OcclusionPortalD2Ev: __ZN15OcclusionPortalD2Ev, __ZN16StreamedResource8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16StreamedResource8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z27OptimizeReorderVertexBufferR4Mesh: __Z27OptimizeReorderVertexBufferR4Mesh, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4goodEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE4goodEv, _deflate_fast: _deflate_fast, __Z23CleanupDeveloperConsolev: __Z23CleanupDeveloperConsolev, __ZNSt3__25mutexD2Ev: __ZNSt3__25mutexD2Ev, __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_: __ZN12VRGfxHelpers44CalculateAspectRatioCorrectedBlitCoordinatesERK8Vector2fRK5RectTIfES2_S6_NS_7FitModeEfRS0_S8_S8_S8_, __Z27scripting_array_element_ptrP11Il2CppArrayij: __Z27scripting_array_element_ptrP11Il2CppArrayij, __ZN14AvatarPlayback9PlayFrameEfRPN7mecanim9animation12AvatarMemoryERPNS1_16ControllerMemoryE: __ZN14AvatarPlayback9PlayFrameEfRPN7mecanim9animation12AvatarMemoryERPNS1_16ControllerMemoryE, __Z56Register_UnityEngine_QualitySettings_set_maxQueuedFramesv: __Z56Register_UnityEngine_QualitySettings_set_maxQueuedFramesv, _UNITY_png_error: _UNITY_png_error, __Z40VRSettings_Get_Custom_PropShowDeviceViewv: __Z40VRSettings_Get_Custom_PropShowDeviceViewv, __ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf: __ZN5Umbra22DepthFirstRegionFinder7executeEPNS_8UserListIiEEPKjiRKNS_7Vector3EfPf, __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE: __ZN5physx15readFloatBufferEPfjbRNS_13PxInputStreamE, __ZN11UnityEngine15CloudWebService17CloudServiceEventD0Ev: __ZN11UnityEngine15CloudWebService17CloudServiceEventD0Ev, __Z42TextGenerator_CUSTOM_GetCharactersInternalP12Il2CppObjectS0_: __Z42TextGenerator_CUSTOM_GetCharactersInternalP12Il2CppObjectS0_, __ZN7mecanim9animation15GetMotionStartXERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation15GetMotionStartXERKNS0_18ClipMuscleConstantE, __ZN14SharedMeshDataC2ERKS_: __ZN14SharedMeshDataC2ERKS_, __ZN17Physics2DSettings23SetMaxAngularCorrectionEf: __ZN17Physics2DSettings23SetMaxAngularCorrectionEf, __Z43Register_UnityEngine_TextMesh_set_fontStylev: __Z43Register_UnityEngine_TextMesh_set_fontStylev, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZL28GeomMTDCallback_SphereConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL28GeomMTDCallback_SphereConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeMultiplierP12Il2CppObjectf: __Z76ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeMultiplierP12Il2CppObjectf, __ZN19ConstantBuffersGLES5ClearEv: __ZN19ConstantBuffersGLES5ClearEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEcj, __ZN9ShaderLab4PassC2ENS0_8PassTypeE: __ZN9ShaderLab4PassC2ENS0_8PassTypeE, __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb: __ZN5physx2GuL27calculateContactInformationEPKNS_6shdfnd3aos5Vec3VES5_PKNS0_5FacetERKNS0_7ConvexVESB_RS3_SC_SC_RNS2_6FloatVEb, __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeIN20TextRenderingPrivate8FontImpl15TexturePositionENS_4lessIS3_EE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZN9Texture3D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Texture3D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z63Register_UnityEngineInternal_GIDebugVisualisation_get_cycleModev: __Z63Register_UnityEngineInternal_GIDebugVisualisation_get_cycleModev, __ZN14ParticleSystem4EmitERS_RK21SubEmitterEmitCommand: __ZN14ParticleSystem4EmitERS_RK21SubEmitterEmitCommand, __ZNK5physx2Gu11HeightField22isCollisionVertexPrecaEjjjt: __ZNK5physx2Gu11HeightField22isCollisionVertexPrecaEjjjt, __Z28Animator_CUSTOM_GetLayerNameP12Il2CppObjecti: __Z28Animator_CUSTOM_GetLayerNameP12Il2CppObjecti, __ZNK5physx18NpArticulationLink7getTypeEv: __ZNK5physx18NpArticulationLink7getTypeEv, __ZN27ForceModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN27ForceModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb: __ZNK11AudioSource19GetFilterComponentsERNSt3__26vectorIPN4FMOD3DSPENS0_9allocatorIS4_EEEEb, __ZN14ParticleSystem4PlayEb: __ZN14ParticleSystem4PlayEb, __Z56Register_UnityEngine_BuoyancyEffector2D_set_surfaceLevelv: __Z56Register_UnityEngine_BuoyancyEffector2D_set_surfaceLevelv, _UNITY_png_reset_crc: _UNITY_png_reset_crc, __ZN16GraphicsSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16GraphicsSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13RuntimeStaticI15GUIEventManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI15GUIEventManagerE13StaticDestroyEPv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj179ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z38AndroidJNI_CUSTOM_CallStaticVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z38AndroidJNI_CUSTOM_CallStaticVoidMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff: __ZN14EmissionModule16EmitOverDistanceER27ParticleSystemEmissionStateRK26ParticleSystemEmissionDataRK8Vector3fffff, __ZN9dtNavMesh26unconnectOffMeshConnectionEj: __ZN9dtNavMesh26unconnectOffMeshConnectionEj, _mwrite: _mwrite, __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12resize_deltaEjj, ___tre_mem_new_impl: ___tre_mem_new_impl, __ZN12AudioManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12AudioManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z56Transform_CUSTOM_INTERNAL_CALL_InverseTransformDirectionP12Il2CppObjectRK8Vector3fRS1_: __Z56Transform_CUSTOM_INTERNAL_CALL_InverseTransformDirectionP12Il2CppObjectRK8Vector3fRS1_, __Z43getPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataEj: __Z43getPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataEj, __Z13RegisterClassI14AreaEffector2DEvv: __Z13RegisterClassI14AreaEffector2DEvv, __ZN10TagManager27IsSortingLayerUniqueIDValidEi: __ZN10TagManager27IsSortingLayerUniqueIDValidEi, __Z44GIDebugVisualisation_CUSTOM_CycleSkipSystemsi: __Z44GIDebugVisualisation_CUSTOM_CycleSkipSystemsi, __ZN5physx29PxParticleBaseGeneratedValuesC2EPKNS_14PxParticleBaseE: __ZN5physx29PxParticleBaseGeneratedValuesC2EPKNS_14PxParticleBaseE, __Z41Register_UnityEngine_Input_GetMouseButtonv: __Z41Register_UnityEngine_Input_GetMouseButtonv, _tt_cmap6_char_index: _tt_cmap6_char_index, __ZN5physx9NpPhysics21getProfileZoneManagerEv: __ZN5physx9NpPhysics21getProfileZoneManagerEv, __ZN15SerializeTraitsI10BlendShapeE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI10BlendShapeE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN13GfxDeviceGLES16DeleteTimerQueryEP13GfxTimerQuery: __ZN13GfxDeviceGLES16DeleteTimerQueryEP13GfxTimerQuery, __ZN7mecanim9animation8GetClipXERKNS0_18ClipMuscleConstantEPKfi: __ZN7mecanim9animation8GetClipXERKNS0_18ClipMuscleConstantEPKfi, __Z48Bounds_CUSTOM_INTERNAL_CALL_Internal_SqrDistanceRK4AABBRK8Vector3f: __Z48Bounds_CUSTOM_INTERNAL_CALL_Internal_SqrDistanceRK4AABBRK8Vector3f, __ZNK5physx15NpActorTemplateINS_7PxClothEE7getNameEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE7getNameEv, __ZN5physx2Sc15ArticulationSimC2ERNS0_16ArticulationCoreERNS0_5SceneERNS0_8BodyCoreE: __ZN5physx2Sc15ArticulationSimC2ERNS0_16ArticulationCoreERNS0_5SceneERNS0_8BodyCoreE, __ZNKSt3__220__time_get_c_storageIwE8__monthsEv: __ZNKSt3__220__time_get_c_storageIwE8__monthsEv, __Z14ScaleCurveTimeR17AnimationCurveTplIfEf: __Z14ScaleCurveTimeR17AnimationCurveTplIfEf, __Z52Register_UnityEngine_AudioReverbZone_get_reverbDelayv: __Z52Register_UnityEngine_AudioReverbZone_get_reverbDelayv, __ZNK12NavMeshAgent23SetOffMeshLinkDataFlagsEP15OffMeshLinkDatay: __ZNK12NavMeshAgent23SetOffMeshLinkDataFlagsEP15OffMeshLinkDatay, __Z49AnimationClipPlayable_CUSTOM_SetRemoveStartOffsetR9HPlayableh: __Z49AnimationClipPlayable_CUSTOM_SetRemoveStartOffsetR9HPlayableh, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj603ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj603ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE: __ZN12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE, __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEiP11Il2CppArrayRKT_i, __ZN8Material14SetOverrideTagEii: __ZN8Material14SetOverrideTagEii, __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIttEEPtEEjT0_S5_S5_S5_T_, __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEERS2_: __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEERS2_, __ZNK23PreloadManagerOperation25GetAllowParallelExecutionEv: __ZNK23PreloadManagerOperation25GetAllowParallelExecutionEv, __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIdEEvRT_PKc17TransferMetaFlags, __ZN7ApiGLES17CreateVertexArrayEv: __ZN7ApiGLES17CreateVertexArrayEv, __ZN16ScriptingManagerD0Ev: __ZN16ScriptingManagerD0Ev, __ZN14NavMeshManager17UpdateCrowdSystemEv: __ZN14NavMeshManager17UpdateCrowdSystemEv, __ZN2UI6Canvas24UpdateCanvasPixelPerfectEv: __ZN2UI6Canvas24UpdateCanvasPixelPerfectEv, __Z45Register_UnityEngine_Rigidbody2D_set_bodyTypev: __Z45Register_UnityEngine_Rigidbody2D_set_bodyTypev, __ZN11UnityEngine9Analytics15AnalyticsConfig8RegisterERNS_7Connect13ConfigHandlerE: __ZN11UnityEngine9Analytics15AnalyticsConfig8RegisterERNS_7Connect13ConfigHandlerE, __ZN43MultiWriterSingleReaderAtomicCircularBufferC2Ei: __ZN43MultiWriterSingleReaderAtomicCircularBufferC2Ei, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __ZN16CircleCollider2DD2Ev: __ZN16CircleCollider2DD2Ev, __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf: __ZN5physx2Sc18ParticleSystemCore17setStaticFrictionEf, __ZN15PxsCMUpdateTask7releaseEv: __ZN15PxsCMUpdateTask7releaseEv, __Z26SetupLightShaderPropertiesRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_: __Z26SetupLightShaderPropertiesRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj75ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj75ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__24stoiERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji: __ZNSt3__24stoiERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji, __ZN14ParticleSystemD0Ev: __ZN14ParticleSystemD0Ev, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE7seekposENS_4fposI11__mbstate_tEEj, __ZN11UnityEngine15PlatformWrapper21GetApplicationVersionEv: __ZN11UnityEngine15PlatformWrapper21GetApplicationVersionEv, __Z35ReflectionProbeBlendInfoToScriptingRK24ReflectionProbeBlendInfoR33ScriptingReflectionProbeBlendInfo: __Z35ReflectionProbeBlendInfoToScriptingRK24ReflectionProbeBlendInfoR33ScriptingReflectionProbeBlendInfo, __ZN5physx2Gu24contactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu24contactSphereHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN14RenderSettings16CheckConsistencyEv: __ZN14RenderSettings16CheckConsistencyEv, __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_SetBoxv: __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_SetBoxv, __Z31Input_Get_Custom_PropTouchCountv: __Z31Input_Get_Custom_PropTouchCountv, __ZN5physx2Gu13MeshInterfaceC2Ev: __ZN5physx2Gu13MeshInterfaceC2Ev, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z11ResetStdoutv: __Z11ResetStdoutv, __ZN5physx15PxsParticleData6createERNS_24PxDeserializationContextE: __ZN5physx15PxsParticleData6createERNS_24PxDeserializationContextE, __Z57Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundv: __Z57Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundv, __ZN5physx25PxAggregateRepXSerializerD0Ev: __ZN5physx25PxAggregateRepXSerializerD0Ev, __ZNK5physx7NpScene19checkPositionSanityERKNS_12PxRigidActorERKNS_11PxTransformEPKc: __ZNK5physx7NpScene19checkPositionSanityERKNS_12PxRigidActorERKNS_11PxTransformEPKc, __Z70Register_UnityEngine_AnimatorOverrideController_Internal_SetClipByNamev: __Z70Register_UnityEngine_AnimatorOverrideController_Internal_SetClipByNamev, __ZN11BoxCollider6CreateEPK9Rigidbody: __ZN11BoxCollider6CreateEPK9Rigidbody, __Z48Register_UnityEngine_ComputeBuffer_DestroyBufferv: __Z48Register_UnityEngine_ComputeBuffer_DestroyBufferv, __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z26ValidateGlobalGameManagersv: __Z26ValidateGlobalGameManagersv, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __Z36Light_Get_Custom_PropShadowNearPlaneP12Il2CppObject: __Z36Light_Get_Custom_PropShadowNearPlaneP12Il2CppObject, __Z42CleanupBlendShapeAnimationBindingInterfacev: __Z42CleanupBlendShapeAnimationBindingInterfacev, __Z43Register_UnityEngine_Rigidbody2D_IsTouchingv: __Z43Register_UnityEngine_Rigidbody2D_IsTouchingv, __ZN5audio5mixer17AssignOutputGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPN4FMOD12ChannelGroupE: __ZN5audio5mixer17AssignOutputGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPN4FMOD12ChannelGroupE, __ZNKSt3__28numpunctIwE11do_groupingEv: __ZNKSt3__28numpunctIwE11do_groupingEv, __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb1EEEEvRT_, _finish_pass_huff: _finish_pass_huff, __Z43Application_CUSTOM_RequestUserAuthorizationi: __Z43Application_CUSTOM_RequestUserAuthorizationi, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setParticleReadDataFlagENS_22PxParticleReadDataFlag4EnumEb, __ZN26AnimatorControllerPlayable6Memory5ResetERN7mecanim6memory16MecanimAllocatorE: __ZN26AnimatorControllerPlayable6Memory5ResetERN7mecanim6memory16MecanimAllocatorE, __ZN13GfxDeviceNull15ReloadResourcesEv: __ZN13GfxDeviceNull15ReloadResourcesEv, __Z59ParticleSystem_CollisionModule_CUSTOM_SetMaxCollisionShapesP12Il2CppObjecti: __Z59ParticleSystem_CollisionModule_CUSTOM_SetMaxCollisionShapesP12Il2CppObjecti, __ZN5physx23PxSetGroupCollisionFlagEttb: __ZN5physx23PxSetGroupCollisionFlagEttb, __Z66Register_UnityEngine_CharacterController_set_enableOverlapRecoveryv: __Z66Register_UnityEngine_CharacterController_set_enableOverlapRecoveryv, __ZN5physx2Gu21intersectSphereConvexERKNS0_6SphereERKNS0_10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformEPNS_6PxVec3E: __ZN5physx2Gu21intersectSphereConvexERKNS0_6SphereERKNS0_10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformEPNS_6PxVec3E, __ZN37RotationBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN37RotationBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z46ParticleSystem_EmissionModule_CUSTOM_SetBurstsP12Il2CppObjectP11Il2CppArrayi: __Z46ParticleSystem_EmissionModule_CUSTOM_SetBurstsP12Il2CppObjectP11Il2CppArrayi, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7SetSizeEi: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE7SetSizeEi, __ZN5physx2Sn5ConvXD0Ev: __ZN5physx2Sn5ConvXD0Ev, __ZN5physx21MBPPostUpdateWorkTask11runInternalEv: __ZN5physx21MBPPostUpdateWorkTask11runInternalEv, __ZN5Unity5Cloth10DeactivateE19DeactivateOperation: __ZN5Unity5Cloth10DeactivateE19DeactivateOperation, _UNITY_tt_face_load_post: _UNITY_tt_face_load_post, __ZN2UI14CanvasRenderer18SyncInheritedAlphaENS0_8SyncFlagE: __ZN2UI14CanvasRenderer18SyncInheritedAlphaENS0_8SyncFlagE, __Z24RegisterStrippedTypeInfoIN5Unity17ConfigurableJointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity17ConfigurableJointEEviPKcS3_, __ZN14BillboardAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14BillboardAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _quantize: _quantize, __Z28ReleaseInstanceUpdateManagerv: __Z28ReleaseInstanceUpdateManagerv, __ZN8Collider17MainThreadCleanupEv: __ZN8Collider17MainThreadCleanupEv, __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationZMultiplierv, __Z47ParticleEmitter_CUSTOM_INTERNAL_set_rndVelocityP12Il2CppObjectRK8Vector3f: __Z47ParticleEmitter_CUSTOM_INTERNAL_set_rndVelocityP12Il2CppObjectRK8Vector3f, __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb: __ZN9TextureOpI17SharedTextureDataE15ExtractMipLevelEPS0_S2_iibb, __ZN5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_: __ZN5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_, __ZN16Physics2DManager7BoxCastERK8Vector2fS2_fS2_fiffPK10Collider2DbP12RaycastHit2Di: __ZN16Physics2DManager7BoxCastERK8Vector2fS2_fS2_fiffPK10Collider2DbP12RaycastHit2Di, __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11AudioFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_: __ZN11MinMaxCurve8TransferI14SafeBinaryReadEEvRT_, __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetRotationR9HPlayableRK11Quaternionf: __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetRotationR9HPlayableRK11Quaternionf, __ZN5physx6shdfnd13TempAllocator10deallocateEPv: __ZN5physx6shdfnd13TempAllocator10deallocateEPv, __ZN5physx7profile23EventContextInformation9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile23EventContextInformation9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE, __ZN15EditorExtensionD2Ev: __ZN15EditorExtensionD2Ev, __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4gles18GetFramebufferGLESEv: __ZN4gles18GetFramebufferGLESEv, __ZN21LinearCollectionField7IsValidEv: __ZN21LinearCollectionField7IsValidEv, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXMultiplierv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags, __Z23SetInputWeightFromIndexR9HPlayableif: __Z23SetInputWeightFromIndexR9HPlayableif, __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_12BitDataArrayEii: __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_12BitDataArrayEii, __Z54Register_UnityEngine_SystemInfo_get_processorFrequencyv: __Z54Register_UnityEngine_SystemInfo_get_processorFrequencyv, __ZNSt3__217__assoc_sub_state4copyEv: __ZNSt3__217__assoc_sub_state4copyEv, __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE: __ZN5physx11localSearchERjRKNS_6PxVec3EPS2_PKNS_2Gu16BigConvexRawDataE, __Z23profiler_get_group_name13ProfilerGroup: __Z23profiler_get_group_name13ProfilerGroup, __ZNKSt3__27codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_: __ZNKSt3__27codecvtIwc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_, __ZN12HandlerChain10AtomicMoveER13FileEntryDataS1_: __ZN12HandlerChain10AtomicMoveER13FileEntryDataS1_, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRS3_S4_E: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRS3_S4_E, __Z45Register_UnityEngine_Light_set_shadowSoftnessv: __Z45Register_UnityEngine_Light_set_shadowSoftnessv, __ZN17PersistentManager14GetLocalFileIDEi: __ZN17PersistentManager14GetLocalFileIDEi, __ZN8Material14CreateMaterialERKS_ib: __ZN8Material14CreateMaterialERKS_ib, __Z47Register_UnityEngine_Rigidbody2D_set_fixedAnglev: __Z47Register_UnityEngine_Rigidbody2D_set_fixedAnglev, __Z38NavMeshAgent_CUSTOM_SamplePathPositionP12Il2CppObjectifP10NavMeshHit: __Z38NavMeshAgent_CUSTOM_SamplePathPositionP12Il2CppObjectifP10NavMeshHit, __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__214__split_bufferIN13AnimationClip10FloatCurveER13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev, __Z50RenderSettings_CUSTOM_INTERNAL_set_ambientSkyColorRK10ColorRGBAf: __Z50RenderSettings_CUSTOM_INTERNAL_set_ambientSkyColorRK10ColorRGBAf, __ZN5physx2Sc7BodySim25notifyNotReadyForSleepingEv: __ZN5physx2Sc7BodySim25notifyNotReadyForSleepingEv, _UNITY_ft_mem_strcpyn: _UNITY_ft_mem_strcpyn, __ZNK8GUIStyle15CalcMinMaxWidthER10GUIContentPfS2_: __ZNK8GUIStyle15CalcMinMaxWidthER10GUIContentPfS2_, __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNK13AnimationClip15GetAverageSpeedEv: __ZNK13AnimationClip15GetAverageSpeedEv, __Z40Register_UnityEngine_Application_HasARGVv: __Z40Register_UnityEngine_Application_HasARGVv, __Z48getPxVehicleDriveSimData4W_AckermannGeometryDataPKN5physx23PxVehicleDriveSimData4WE: __Z48getPxVehicleDriveSimData4W_AckermannGeometryDataPKN5physx23PxVehicleDriveSimData4WE, __Z36Light_Set_Custom_PropShadowNearPlaneP12Il2CppObjectf: __Z36Light_Set_Custom_PropShadowNearPlaneP12Il2CppObjectf, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z22scripting_string_charsP12Il2CppString: __Z22scripting_string_charsP12Il2CppString, __Z16getPxJoint_ScenePKN5physx7PxJointE: __Z16getPxJoint_ScenePKN5physx7PxJointE, __ZNKSt3__214__codecvt_utf8IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_: __ZNKSt3__214__codecvt_utf8IwE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_, __ZNSt3__210__stdinbufIcE5imbueERKNS_6localeE: __ZNSt3__210__stdinbufIcE5imbueERKNS_6localeE, __Z35HingeJoint_Get_Custom_PropUseSpringP12Il2CppObject: __Z35HingeJoint_Get_Custom_PropUseSpringP12Il2CppObject, __ZN14AnimationState20UpdateBlendingWeightEfb: __ZN14AnimationState20UpdateBlendingWeightEfb, __ZN17AnimationCurveTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17AnimationCurveTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_png_set_longjmp_fn: _UNITY_png_set_longjmp_fn, __ZN18AudioLowPassFilterC2E10MemLabelId18ObjectCreationMode: __ZN18AudioLowPassFilterC2E10MemLabelId18ObjectCreationMode, __Z37ComputeShader_CUSTOM_Internal_SetIntsP12Il2CppObjectiP11Il2CppArray: __Z37ComputeShader_CUSTOM_Internal_SetIntsP12Il2CppObjectiP11Il2CppArray, __ZNKSt3__27collateIwE7compareEPKwS3_S3_S3_: __ZNKSt3__27collateIwE7compareEPKwS3_S3_S3_, __ZN5Unity17ConfigurableJoint7SetupD6Ev: __ZN5Unity17ConfigurableJoint7SetupD6Ev, __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNK5physx15PxsParticleData17getParticleCountVEv: __ZNK5physx15PxsParticleData17getParticleCountVEv, __ZNK12PhysXRaycast9GetShapesERK4AABBiPN5physx12PxOverlapHitEjb23QueryTriggerInteraction: __ZNK12PhysXRaycast9GetShapesERK4AABBiPN5physx12PxOverlapHitEjb23QueryTriggerInteraction, __Z39AndroidJNI_CUSTOM_GetDoubleArrayElement13Il2Cpp_IntPtri: __Z39AndroidJNI_CUSTOM_GetDoubleArrayElement13Il2Cpp_IntPtri, __ZN5physx5cloth16TripletSchedulerC2ENS0_5RangeIA4_KjEE: __ZN5physx5cloth16TripletSchedulerC2ENS0_5RangeIA4_KjEE, __ZN14AsyncOperation20SetCoroutineCallbackEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E: __ZN14AsyncOperation20SetCoroutineCallbackEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E, __Z64Register_UnityEngine_Networking_UnityWebRequest_GetRequestHeaderv: __Z64Register_UnityEngine_Networking_UnityWebRequest_GetRequestHeaderv, __Z66Register_UnityEngine_SystemInfo_get_supportsRawShadowDepthSamplingv: __Z66Register_UnityEngine_SystemInfo_get_supportsRawShadowDepthSamplingv, __ZN14AnimationState19SetupUnstoppedStateEv: __ZN14AnimationState19SetupUnstoppedStateEv, __ZNSt3__26locale5__imp7installINS_12ctype_bynameIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_12ctype_bynameIwEEEEvPT_, __Z30LensFlare_Get_Custom_PropFlareP12Il2CppObject: __Z30LensFlare_Get_Custom_PropFlareP12Il2CppObject, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN20TextRenderingPrivate8TextMeshD0Ev: __ZN20TextRenderingPrivate8TextMeshD0Ev, __ZN14ParticleSystem12AddToManagerEv: __ZN14ParticleSystem12AddToManagerEv, __ZN3MBP11preallocateEjj: __ZN3MBP11preallocateEjj, __ZThn32_N22ParticleSystemRenderer21RendererBecameVisibleEv: __ZThn32_N22ParticleSystemRenderer21RendererBecameVisibleEv, __ZN10GCProfiler13RegisterEventENS_7GCEventEi: __ZN10GCProfiler13RegisterEventENS_7GCEventEi, __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeIi10vector_setIiNS_4lessIiEENS_9allocatorIiEEEEENS_19__map_value_compareIiS8_S4_Lb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __ZN5physx2Cm4Task3runEv: __ZN5physx2Cm4Task3runEv, __ZNKSt3__214__codecvt_utf8IDiE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__214__codecvt_utf8IDiE10do_unshiftER11__mbstate_tPcS4_RS4_, __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve, __ZN9Behaviour8TransferI30ReportScriptingObjectsTransferEEvRT_: __ZN9Behaviour8TransferI30ReportScriptingObjectsTransferEEvRT_, __Z46Register_UnityEngine_SpringJoint_get_tolerancev: __Z46Register_UnityEngine_SpringJoint_get_tolerancev, __Z56Register_UnityEngine_Camera_INTERNAL_set_backgroundColorv: __Z56Register_UnityEngine_Camera_INTERNAL_set_backgroundColorv, __Z13CopyAnimationR13AnimationClipS0_: __Z13CopyAnimationR13AnimationClipS0_, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15createParticlesERKNS_22PxParticleCreationDataE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15createParticlesERKNS_22PxParticleCreationDataE, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fED2Ev: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fED2Ev, __Z43Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction: __Z43Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleRK8Vector3fS1_fi23QueryTriggerInteraction, __Z39Application_CUSTOM_GetStackTraceLogType7LogType: __Z39Application_CUSTOM_GetStackTraceLogType7LogType, __Z34Texture2D_CUSTOM_Internal_ResizeWHP12Il2CppObjectii: __Z34Texture2D_CUSTOM_Internal_ResizeWHP12Il2CppObjectii, __ZNSt3__210istrstreamD1Ev: __ZNSt3__210istrstreamD1Ev, __ZN26LegacyTreeInstanceRendererC2ER12TreeRendereriP4MeshRK13dynamic_arrayIP8MaterialLj4EERK10Matrix4x4fRK4AABB: __ZN26LegacyTreeInstanceRendererC2ER12TreeRendereriP4MeshRK13dynamic_arrayIP8MaterialLj4EERK10Matrix4x4fRK4AABB, __Z46getPxPrismaticJoint_ProjectionAngularTolerancePKN5physx16PxPrismaticJointE: __Z46getPxPrismaticJoint_ProjectionAngularTolerancePKN5physx16PxPrismaticJointE, __ZN5Umbra8sha1HashEPKhj: __ZN5Umbra8sha1HashEPKhj, __Z40Camera_CUSTOM_INTERNAL_CALL_RaycastTry2DP12Il2CppObjectRK3Rayfi: __Z40Camera_CUSTOM_INTERNAL_CALL_RaycastTry2DP12Il2CppObjectRK3Rayfi, __ZN4FMOD7Channel19get3DMinMaxDistanceEPfS1_: __ZN4FMOD7Channel19get3DMinMaxDistanceEPfS1_, __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j: __ZNK5physx27PxD6JointDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j, __Z45CharacterController_Set_Custom_PropSlopeLimitP12Il2CppObjectf: __Z45CharacterController_Set_Custom_PropSlopeLimitP12Il2CppObjectf, __ZNSt3__28messagesIcED0Ev: __ZNSt3__28messagesIcED0Ev, __ZN11UmbraModule38RemoveDuplicatesFromMultipleIndexListsER13CullingOutputPKN5Umbra4TomeEPPNS2_10VisibilityEi: __ZN11UmbraModule38RemoveDuplicatesFromMultipleIndexListsER13CullingOutputPKN5Umbra4TomeEPPNS2_10VisibilityEi, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj, __Z50Register_UnityEngine_Input_get_backButtonLeavesAppv: __Z50Register_UnityEngine_Input_get_backButtonLeavesAppv, __ZSt9terminatev: __ZSt9terminatev, __Z38CanvasRenderer_Get_Custom_PropHasMovedP12Il2CppObject: __Z38CanvasRenderer_Get_Custom_PropHasMovedP12Il2CppObject, __Z32Light_Set_Custom_PropCullingMaskP12Il2CppObjecti: __Z32Light_Set_Custom_PropCullingMaskP12Il2CppObjecti, __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEENS0_9allocatorIS6_EEEEEvRT_j, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapXMultiplierv, __Z35setPxSceneDescWakeCounterResetValuePN5physx11PxSceneDescEf: __Z35setPxSceneDescWakeCounterResetValuePN5physx11PxSceneDescEf, __ZThn12_N12_GLOBAL__N_110ConnectionD0Ev: __ZThn12_N12_GLOBAL__N_110ConnectionD0Ev, __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z50Application_CUSTOM_GetStreamProgressForLevelByNameP12Il2CppString: __Z50Application_CUSTOM_GetStreamProgressForLevelByNameP12Il2CppString, __ZNK17GeneralConnection12GetLocalGuidEv: __ZNK17GeneralConnection12GetLocalGuidEv, __ZN5physx15PxSerialization27serializeCollectionToBinaryERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS3_b: __ZN5physx15PxSerialization27serializeCollectionToBinaryERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS3_b, __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider: __Z33SetIAnimationStateNetworkProviderP30IAnimationStateNetworkProvider, __ZNKSt3__210moneypunctIwLb0EE11curr_symbolEv: __ZNKSt3__210moneypunctIwLb0EE11curr_symbolEv, __Z34UpdateTextureImageDataOnMainThreadP9Texture2D: __Z34UpdateTextureImageDataOnMainThreadP9Texture2D, __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev: __ZNSt3__212__deque_baseI4NodeNS_9allocatorIS1_EEED2Ev, __Z56Register_UnityEngine_SystemInfo_get_maxRenderTextureSizev: __Z56Register_UnityEngine_SystemInfo_get_maxRenderTextureSizev, __ZNK14SoundHandleAPI12GetLoadStateEv: __ZNK14SoundHandleAPI12GetLoadStateEv, __ZL30RegisterModuleICalls_Physics2Dv: __ZL30RegisterModuleICalls_Physics2Dv, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEbT0_S7_T_, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE, _fstat: _fstat, __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZNK5physx16PxBroadPhaseBase10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj: __ZNK5physx16PxBroadPhaseBase10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj, __Z47Register_UnityEngine_Projector_get_farClipPlanev: __Z47Register_UnityEngine_Projector_get_farClipPlanev, __ZNK8VRDevice21GetShowVRSplashScreenEv: __ZNK8VRDevice21GetShowVRSplashScreenEv, __ZNK5physx13NpClothFabric17getReferenceCountEv: __ZNK5physx13NpClothFabric17getReferenceCountEv, __ZNK12NavMeshAgent26GetTypeInfoVirtualInternalEv: __ZNK12NavMeshAgent26GetTypeInfoVirtualInternalEv, __ZN13RenderManager12CleanupClassEv: __ZN13RenderManager12CleanupClassEv, __Z55Register_UnityEngine_Animator_INTERNAL_get_rootPositionv: __Z55Register_UnityEngine_Animator_INTERNAL_get_rootPositionv, __Z28GetSpriteMeshRectPixelBoundsiiRK5RectTIfERiS3_S3_S3_: __Z28GetSpriteMeshRectPixelBoundsiiRK5RectTIfERiS3_S3_S3_, __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDic11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIDic11__mbstate_tEEEEvPT_, __Z44Register_UnityEngine_Cloth_set_selfCollisionv: __Z44Register_UnityEngine_Cloth_set_selfCollisionv, __ZN18ScriptingArguments12AddOutObjectEPP12Il2CppObject: __ZN18ScriptingArguments12AddOutObjectEPP12Il2CppObject, __ZN4FMOD7SystemI16getDSPBufferSizeEPjPi: __ZN4FMOD7SystemI16getDSPBufferSizeEPjPi, _endmntent: _endmntent, __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10Matrix4x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN19BaseConnectSettings10InitializeER6Object: __ZN19BaseConnectSettings10InitializeER6Object, __ZN5physx27PxRigidDynamicGeneratedInfoC2Ev: __ZN5physx27PxRigidDynamicGeneratedInfoC2Ev, __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen13AnimationModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen13AnimationModeEEvRT_RT0_PKc17TransferMetaFlags, __ZNK16MeshVertexFormat18GetUsedStreamCountEv: __ZNK16MeshVertexFormat18GetUsedStreamCountEv, __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __Z39Hash128_CUSTOM_Internal_Hash128ToStringjjjj: __Z39Hash128_CUSTOM_Internal_Hash128ToStringjjjj, __ZN5physx8debugger4comm20StreamPropMessageArgD0Ev: __ZN5physx8debugger4comm20StreamPropMessageArgD0Ev, __ZN12_GLOBAL__N_110DataStream11originShiftEPKvN5physx6PxVec3E: __ZN12_GLOBAL__N_110DataStream11originShiftEPKvN5physx6PxVec3E, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXv, __ZNK29ParticleSystemPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK29ParticleSystemPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, _write: _write, __ZN14SpriteRenderer12CleanupClassEv: __ZN14SpriteRenderer12CleanupClassEv, __Z37Animator_Get_Custom_PropStabilizeFeetP12Il2CppObject: __Z37Animator_Get_Custom_PropStabilizeFeetP12Il2CppObject, __GLOBAL__sub_I_TextMeshGenerator_cpp: __GLOBAL__sub_I_TextMeshGenerator_cpp, __Z21TransferBlobSerializeIN7mecanim9animation14AvatarConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation14AvatarConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_, __ZN5physx26PxConvexMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx26PxConvexMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZL32CleanupAnimationScriptingClassesv: __ZL32CleanupAnimationScriptingClassesv, __ZNK13TargetJoint2D10SwapBodiesEv: __ZNK13TargetJoint2D10SwapBodiesEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags, __ZN5physx23PxVehicleDriveSimDataNW17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx23PxVehicleDriveSimDataNW17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN10Collider2D15InitializeClassEv: __ZN10Collider2D15InitializeClassEv, __ZN11NoiseModuleD0Ev: __ZN11NoiseModuleD0Ev, __ZN25RuntimeAnimatorController15ThreadedCleanupEv: __ZN25RuntimeAnimatorController15ThreadedCleanupEv, __Z44Register_UnityEngine_ParticleSystem_get_loopv: __Z44Register_UnityEngine_ParticleSystem_get_loopv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4cendEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4cendEv, __ZN5physx2Sc9ClothCore12setParticlesEPKNS_15PxClothParticleES4_: __ZN5physx2Sc9ClothCore12setParticlesEPKNS_15PxClothParticleES4_, __ZN19ShaderPropertySheet22CopyVectorPropertyFromERKS_i: __ZN19ShaderPropertySheet22CopyVectorPropertyFromERKS_i, __Z36Register_UnityEngine_GL_LoadIdentityv: __Z36Register_UnityEngine_GL_LoadIdentityv, __Z45Register_UnityEngine_Camera_get_renderingPathv: __Z45Register_UnityEngine_Camera_get_renderingPathv, __ZNK5physx18PxsSolverStartTask7getNameEv: __ZNK5physx18PxsSolverStartTask7getNameEv, __ZN9ShaderLab11ShaderStateD2Ev: __ZN9ShaderLab11ShaderStateD2Ev, __ZN18UnityConnectClientD2Ev: __ZN18UnityConnectClientD2Ev, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z40ConfigurableJoint_Set_Custom_PropZMotionP12Il2CppObjecti: __Z40ConfigurableJoint_Set_Custom_PropZMotionP12Il2CppObjecti, _flockfile: _flockfile, __Z20GetTypeChildrenCountRK16TypeTreeIterator: __Z20GetTypeChildrenCountRK16TypeTreeIterator, __Z12FormatStringPKcz: __Z12FormatStringPKcz, __ZNK4Mesh27GetPreferredTexCoordChannelE13ShaderChannel: __ZNK4Mesh27GetPreferredTexCoordChannelE13ShaderChannel, __ZN13RenderManager22RenderOffscreenCamerasEv: __ZN13RenderManager22RenderOffscreenCamerasEv, __ZL25GetSubmeshTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __ZL25GetSubmeshTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __Z48getPxSimulationStatisticsNbAxisSolverConstraintsPKN5physx22PxSimulationStatisticsE: __Z48getPxSimulationStatisticsNbAxisSolverConstraintsPKN5physx22PxSimulationStatisticsE, __ZN2UI14CanvasRenderer15ThreadedCleanupEv: __ZN2UI14CanvasRenderer15ThreadedCleanupEv, __Z52Register_UnityEngine_AI_NavMeshAgent_set_autoBrakingv: __Z52Register_UnityEngine_AI_NavMeshAgent_set_autoBrakingv, __Z23getPxShape_GeometryTypePKN5physx7PxShapeE: __Z23getPxShape_GeometryTypePKN5physx7PxShapeE, __ZN17Physics2DSettings21GetLayerCollisionMaskEi: __ZN17Physics2DSettings21GetLayerCollisionMaskEi, __Z23RecalculateSplineSlopeTI11QuaternionfEvR17AnimationCurveTplIT_Eif: __Z23RecalculateSplineSlopeTI11QuaternionfEvR17AnimationCurveTplIT_Eif, __Z9GetIClothv: __Z9GetIClothv, __Z15IsFloatRTFormat19RenderTextureFormat: __Z15IsFloatRTFormat19RenderTextureFormat, __ZN26AnimatorControllerPlayable15GetRecorderDataEv: __ZN26AnimatorControllerPlayable15GetRecorderDataEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9GfxDevice28ScheduleGeometryJobsInternalEPFvP15GeometryJobDataEPK22GeometryJobInstructionj: __ZN9GfxDevice28ScheduleGeometryJobsInternalEPFvP15GeometryJobDataEPK22GeometryJobInstructionj, __Z46EmitSerializationCommandsForManagedObjectFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN9Transform11SetRotationERK11Quaternionf: __ZN9Transform11SetRotationERK11Quaternionf, __ZN10MonoScript39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN10MonoScript39ShouldIgnoreInGarbageDependencyTrackingEv, __Z34getPxVehicleAutoBoxData_DownRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE: __Z34getPxVehicleAutoBoxData_DownRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE, __ZN5physx3Ext7D6Joint13setSwingLimitERKNS_16PxJointLimitConeE: __ZN5physx3Ext7D6Joint13setSwingLimitERKNS_16PxJointLimitConeE, __Z19UpdateProceduralTplILb0EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E: __Z19UpdateProceduralTplILb0EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E, __ZN15DirectorManager9OnDisableEv: __ZN15DirectorManager9OnDisableEv, __ZN11ICompressorD2Ev: __ZN11ICompressorD2Ev, __ZN5physx2Gu22computeMTD_PlaneConvexERNS_6PxVec3ERfRKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu22computeMTD_PlaneConvexERNS_6PxVec3ERfRKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE, __ZN10MeshFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10MeshFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z73Register_UnityEngine_AssetBundleManifest_INTERNAL_CALL_GetAssetBundleHashv: __Z73Register_UnityEngine_AssetBundleManifest_INTERNAL_CALL_GetAssetBundleHashv, __ZNKSt3__220__codecvt_utf8_utf16IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_, __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E: __ZN14ParticleSystem37UpdateModulesPreSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E, __ZN30RuntimeInitializeOnLoadManagerD0Ev: __ZN30RuntimeInitializeOnLoadManagerD0Ev, __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj: __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj, __ZN11Rigidbody2D16TransformChangedEi: __ZN11Rigidbody2D16TransformChangedEi, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE13isSubordinateEv, __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E: __ZN5physx14PxsComputeAABBERKNS_17PxcAABBDataStaticERNS_9PxBounds3E, __Z31Texture3D_Get_Custom_PropFormatP12Il2CppObject: __Z31Texture3D_Get_Custom_PropFormatP12Il2CppObject, __ZN5Unity10HingeJoint8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity10HingeJoint8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK6Object12GetClassNameEv: __ZNK6Object12GetClassNameEv, __ZN25b2PolygonAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN25b2PolygonAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN2UI13CanvasManager14GetDisplaySizeEi: __ZN2UI13CanvasManager14GetDisplaySizeEi, _ft_stroker_outside: _ft_stroker_outside, _cf2_getFamilyOtherBlues: _cf2_getFamilyOtherBlues, __ZN12CullingGroup4InitEv: __ZN12CullingGroup4InitEv, __Z15GetEventManagerv: __Z15GetEventManagerv, __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE: __ZN5physx2Gu23computeBoxAroundCapsuleERKNS0_7CapsuleERNS0_3BoxE, __Z20ReleaseScreenManagerv: __Z20ReleaseScreenManagerv, __Z18setPxSceneUserDataPN5physx7PxSceneEPv: __Z18setPxSceneUserDataPN5physx7PxSceneEPv, __ZNKSt3__212__do_message7messageEi: __ZNKSt3__212__do_message7messageEi, __Z47Physics_Get_Custom_PropMinPenetrationForPenaltyv: __Z47Physics_Get_Custom_PropMinPenetrationForPenaltyv, _UNITY_png_write_iTXt: _UNITY_png_write_iTXt, __ZN5Umbra10PortalInfoC2ERKS0_: __ZN5Umbra10PortalInfoC2ERKS0_, __ZNK13RenderTexture10GetVRUsageEv: __ZNK13RenderTexture10GetVRUsageEv, __ZN11UnityEngine9Animation27BoundCurveValueAwakeGenericER6Object: __ZN11UnityEngine9Animation27BoundCurveValueAwakeGenericER6Object, __Z49Register_UnityEngine_WebCamTexture_set_deviceNamev: __Z49Register_UnityEngine_WebCamTexture_set_deviceNamev, __Z30setPxJointLinearLimitPairLowerPN5physx22PxJointLinearLimitPairEf: __Z30setPxJointLinearLimitPairLowerPN5physx22PxJointLinearLimitPairEf, __Z40Register_UnityEngine_Material_get_shaderv: __Z40Register_UnityEngine_Material_get_shaderv, __ZThn8_N12_GLOBAL__N_117ConnectionManager14onDeallocationEPv: __ZThn8_N12_GLOBAL__N_117ConnectionManager14onDeallocationEPv, __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE: __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE, __Z28WindZone_Set_Custom_PropModeP12Il2CppObjectN8WindZone12WindZoneModeE: __Z28WindZone_Set_Custom_PropModeP12Il2CppObjectN8WindZone12WindZoneModeE, __Z51Register_UnityEngine_Physics2D_INTERNAL_set_gravityv: __Z51Register_UnityEngine_Physics2D_INTERNAL_set_gravityv, __ZN22BaseUnityConnectClient13ResumeSessionEv: __ZN22BaseUnityConnectClient13ResumeSessionEv, __Z42ReflectionProbe_Get_Custom_PropCullingMaskP12Il2CppObject: __Z42ReflectionProbe_Get_Custom_PropCullingMaskP12Il2CppObject, __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z57Register_UnityEngine_QualitySettings_set_shadowProjectionv: __Z57Register_UnityEngine_QualitySettings_set_shadowProjectionv, __ZN4FMOD6SoundI6unlockEPvS1_jj: __ZN4FMOD6SoundI6unlockEPvS1_jj, __Z15GetVideoCardIDsRiS_: __Z15GetVideoCardIDsRiS_, __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E: __Z35InverseTransformPositionAndRotationRK23TransformAccessReadOnlyRKN4math7_float3ERKNS2_7_float4E, __ZNK16b2PrismaticJoint13GetUpperLimitEv: __ZNK16b2PrismaticJoint13GetUpperLimitEv, __ZN5physx6shdfnd15atomicIncrementEPVi: __ZN5physx6shdfnd15atomicIncrementEPVi, __ZNKSt3__215__codecvt_utf16IDsLb0EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IDsLb0EE13do_max_lengthEv, __ZN9Transform28ApplySerializedToRuntimeDataEv: __ZN9Transform28ApplySerializedToRuntimeDataEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjjc, __Z33Screen_Get_Custom_PropResolutionsv: __Z33Screen_Get_Custom_PropResolutionsv, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthXMultiplierv, __ZNK16b2PrismaticJoint13GetLowerLimitEv: __ZNK16b2PrismaticJoint13GetLowerLimitEv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20setRigidDynamicFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __ZN19CharacterController22ApplyRootMotionBuiltinEP14RootMotionData: __ZN19CharacterController22ApplyRootMotionBuiltinEP14RootMotionData, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv, __ZN12_GLOBAL__N_124PropertyDefinitionHelper7popNameEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper7popNameEv, _UNITY_LZ4_freeStream: _UNITY_LZ4_freeStream, __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE: __ZNK5physx3Cct13BoxController6getOBBERNS_13PxExtendedBoxE, __Z21ReleasePreloadManagerv: __Z21ReleasePreloadManagerv, __ZN22CrashReportingSettings18InitializeDefaultsEv: __ZN22CrashReportingSettings18InitializeDefaultsEv, _fnmatch: _fnmatch, __ZN11ShapeModule17DidModifyMeshDataEv: __ZN11ShapeModule17DidModifyMeshDataEv, __ZN15QualitySettings15InitializeClassEv: __ZN15QualitySettings15InitializeClassEv, __ZN18AsyncUploadManager22WaitForActiveAsyncReadEv: __ZN18AsyncUploadManager22WaitForActiveAsyncReadEv, __Z39ComputeShader_CUSTOM_Internal_SetFloatsP12Il2CppObjectiP11Il2CppArray: __Z39ComputeShader_CUSTOM_Internal_SetFloatsP12Il2CppObjectiP11Il2CppArray, __Z25scripting_raise_exceptionP15Il2CppException: __Z25scripting_raise_exceptionP15Il2CppException, __ZN6prcoreL11inner_clearILj1EEEvPhjjj: __ZN6prcoreL11inner_clearILj1EEEvPhjjj, __Z13RegisterClassI18DelayedCallManagerEvv: __Z13RegisterClassI18DelayedCallManagerEvv, _mseek: _mseek, __Z61Register_UnityEngine_Animator_GetCurrentAnimatorClipInfoCountv: __Z61Register_UnityEngine_Animator_GetCurrentAnimatorClipInfoCountv, _dn_skipname: _dn_skipname, __Z63Register_UnityEngineInternal_GIDebugVisualisation_StopCycleModev: __Z63Register_UnityEngineInternal_GIDebugVisualisation_StopCycleModev, __ZN5physx2Sn5ConvX11alignTargetEi: __ZN5physx2Sn5ConvX11alignTargetEi, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpENS_4fposI11__mbstate_tEE: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5seekpENS_4fposI11__mbstate_tEE, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv, __ZN5physx3Ext18ProfileZoneHandlerD2Ev: __ZN5physx3Ext18ProfileZoneHandlerD2Ev, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj, __ZNK26AnimatorOverrideController28HasMultiThreadedStateMachineEv: __ZNK26AnimatorOverrideController28HasMultiThreadedStateMachineEv, __ZNK5physx7NpCloth20getNbCollisionPlanesEv: __ZNK5physx7NpCloth20getNbCollisionPlanesEv, _getchar: _getchar, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE13isSubordinateEv, __Z15FindOrAddByNameI15ComputeShaderCBERT_RNSt3__26vectorIS1_NS3_9allocatorIS1_EEEERKS1_: __Z15FindOrAddByNameI15ComputeShaderCBERT_RNSt3__26vectorIS1_NS3_9allocatorIS1_EEEERKS1_, __ZNSt3__214codecvt_bynameIcc11__mbstate_tED2Ev: __ZNSt3__214codecvt_bynameIcc11__mbstate_tED2Ev, __Z46Physics2D_Set_Custom_PropAngularSleepTolerancef: __Z46Physics2D_Set_Custom_PropAngularSleepTolerancef, __Z34scripting_class_get_declaring_typeP11Il2CppClass: __Z34scripting_class_get_declaring_typeP11Il2CppClass, __Z45Register_UnityEngine_AndroidJNI_GetShortFieldv: __Z45Register_UnityEngine_AndroidJNI_GetShortFieldv, __ZNSt9bad_allocD0Ev: __ZNSt9bad_allocD0Ev, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToShortArrayP11Il2CppArrayRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_ToShortArrayP11Il2CppArrayRPv, __ZN5physx2Sc24ConstraintProjectionTree18projectPoseForTreeERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc24ConstraintProjectionTree18projectPoseForTreeERNS0_19ConstraintGroupNodeE, __ZN14MemoryProfiler13StaticDestroyEv: __ZN14MemoryProfiler13StaticDestroyEv, __ZN15PointEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15PointEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine15PlatformWrapper13IsDebugDeviceEv: __ZN11UnityEngine15PlatformWrapper13IsDebugDeviceEv, __ZNK5physx2Sc15ArticulationSim10isSleepingEv: __ZNK5physx2Sc15ArticulationSim10isSleepingEv, __Z51Register_UnityEngine_AudioReverbFilter_get_dryLevelv: __Z51Register_UnityEngine_AudioReverbFilter_get_dryLevelv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEE15growAndPushBackERKS2_, _UNITY_png_get_x_pixels_per_meter: _UNITY_png_get_x_pixels_per_meter, __Z34RemapMonoBehaviourToBuiltinClassIDRK14FileIdentifierx: __Z34RemapMonoBehaviourToBuiltinClassIDRK14FileIdentifierx, __ZN14UnityAnalytics9SetUserIdERK8UnityStr: __ZN14UnityAnalytics9SetUserIdERK8UnityStr, __Z55Register_UnityEngine_Physics_INTERNAL_CALL_CheckCapsulev: __Z55Register_UnityEngine_Physics_INTERNAL_CALL_CheckCapsulev, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLongArrayv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLongArrayv, __ZN11UnityEngine15CloudWebService19SessionEventManager37OnTimerExpiredPerformArchiveJobStaticEPv: __ZN11UnityEngine15CloudWebService19SessionEventManager37OnTimerExpiredPerformArchiveJobStaticEPv, _strlcat: _strlcat, __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN9BlobWrite8TransferIN7mecanim9animation16ControllerMemoryEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim9animation16ControllerMemoryEEEvRT_PKc17TransferMetaFlags, __ZN13BuildSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13BuildSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN20IntermediateRendererD2Ev: __ZN20IntermediateRendererD2Ev, __ZN13AnimationClip8GetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfE: __ZN13AnimationClip8GetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfE, __Z20GetGfxDeviceTypeName17GfxDeviceRenderer: __Z20GetGfxDeviceTypeName17GfxDeviceRenderer, __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j: __ZNK5physx22PxD6JointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j, __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext: __Z27ComputeScreenSpaceShadowMapRK6CameraRK15SharedLightDataP13RenderTexture10ShadowType16ShadowProjectionR17ShaderPassContext, __Z27GL_Get_Custom_PropWireframev: __Z27GL_Get_Custom_PropWireframev, __ZN13AnimationClip19FireAnimationEventsEffRN5Unity9ComponentEP17AnimatorStateInfoP16AnimatorClipInfob: __ZN13AnimationClip19FireAnimationEventsEffRN5Unity9ComponentEP17AnimatorStateInfoP16AnimatorClipInfob, __ZNK5physx11NpAggregate16getSelfCollisionEv: __ZNK5physx11NpAggregate16getSelfCollisionEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_, __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE7destroyEv: __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE7destroyEv, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveScalev: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveScalev, __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN12MeshCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12MeshCollider23VirtualRedirectTransferER17RemapPPtrTransfer, _jpeg_save_markers: _jpeg_save_markers, __ZN5physx19NpClothParticleDataD0Ev: __ZN5physx19NpClothParticleDataD0Ev, _tre_purge_regset: _tre_purge_regset, __ZNSt3__218__insertion_sort_3IR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_, __ZN6Socket11SetBlockingEb: __ZN6Socket11SetBlockingEb, __ZN14SpriteRendererD0Ev: __ZN14SpriteRendererD0Ev, __ZN27AnimatorControllerParameter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN27AnimatorControllerParameter8TransferI24GenerateTypeTreeTransferEEvRT_, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetCollidesWithv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetCollidesWithv, __ZN11PreloadData39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN11PreloadData39ShouldIgnoreInGarbageDependencyTrackingEv, _UNITY_FT_Stream_ReadUShortLE: _UNITY_FT_Stream_ReadUShortLE, __ZZN8Renderer15InitializeClassEvEN32FunctorImpl_130kTransformChanged4CallEPviR11MessageData: __ZZN8Renderer15InitializeClassEvEN32FunctorImpl_130kTransformChanged4CallEPviR11MessageData, __ZN4FMOD12ChannelGroup14getNumChannelsEPi: __ZN4FMOD12ChannelGroup14getNumChannelsEPi, __Z39OffMeshLink_Get_Custom_PropCostOverrideP12Il2CppObject: __Z39OffMeshLink_Get_Custom_PropCostOverrideP12Il2CppObject, __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_: __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEvT0_SC_T_, __ZN14TerrainManager18GetTerrainPositionEP7Terrain: __ZN14TerrainManager18GetTerrainPositionEP7Terrain, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, _rindex: _rindex, __ZN3WWW12SetAudioClipEP9AudioClip: __ZN3WWW12SetAudioClipEP9AudioClip, __ZN9Behaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Behaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK14UnityWebStream19GetProgressForSceneEi: __ZNK14UnityWebStream19GetProgressForSceneEi, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfersEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfersEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN15DirectorManager8OnEnableEv: __ZN15DirectorManager8OnEnableEv, __Z49Register_UnityEngine_Rigidbody2D_SetDragBehaviourv: __Z49Register_UnityEngine_Rigidbody2D_SetDragBehaviourv, __ZN5physx2Sc7BodySim10onActivateEv: __ZN5physx2Sc7BodySim10onActivateEv, __Z49Register_UnityEngine_Animator_get_applyRootMotionv: __Z49Register_UnityEngine_Animator_get_applyRootMotionv, __Z22Check3MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_P6ObjectR11MonoManager: __Z22Check3MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_P6ObjectR11MonoManager, __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888: __Z19GetColorBlockColorsPK11DXTColBlockP9Color8888, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE8pushNameEPKc, __Z48Register_UnityEngine_Rigidbody2D_set_constraintsv: __Z48Register_UnityEngine_Rigidbody2D_set_constraintsv, __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxAllRK13Vector2fIcallS1_fiff: __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxAllRK13Vector2fIcallS1_fiff, __ZL18SweepCapsuleSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL18SweepCapsuleSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN5physx2Sc19ShapeInstancePairLLD0Ev: __ZN5physx2Sc19ShapeInstancePairLLD0Ev, __ZNK12WheelJoint2D14GetMotorTorqueEf: __ZNK12WheelJoint2D14GetMotorTorqueEf, _tt_cmap4_get_info: _tt_cmap4_get_info, __ZNK12NavMeshAgent14GetDestinationEv: __ZNK12NavMeshAgent14GetDestinationEv, __Z26getPxSceneDescSanityBoundsPKN5physx11PxSceneDescE: __Z26getPxSceneDescSanityBoundsPKN5physx11PxSceneDescE, __Z30getPxVehicleTireDataMLatStiffXPKN5physx17PxVehicleTireDataE: __Z30getPxVehicleTireDataMLatStiffXPKN5physx17PxVehicleTireDataE, __ZN5physx16PxsParticleShape12setUserDataVEPv: __ZN5physx16PxsParticleShape12setUserDataVEPv, __Z42Register_UnityEngine_Mesh_set_subMeshCountv: __Z42Register_UnityEngine_Mesh_set_subMeshCountv, __ZNK9WWWCached6GetUrlEv: __ZNK9WWWCached6GetUrlEv, __ZN14SphereCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14SphereCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED0Ev, _cf2_glyphpath_curveTo: _cf2_glyphpath_curveTo, __ZN15Cast2DQueryBase8RunQueryEb: __ZN15Cast2DQueryBase8RunQueryEb, __Z30Animator_CUSTOM_GetFloatStringP12Il2CppObjectP12Il2CppString: __Z30Animator_CUSTOM_GetFloatStringP12Il2CppObjectP12Il2CppString, __Z48AudioReverbZone_Get_Custom_PropRoomRolloffFactorP12Il2CppObject: __Z48AudioReverbZone_Get_Custom_PropRoomRolloffFactorP12Il2CppObject, __ZN5physx19PxsSimObjectFactory19destroyArticulationERNS_15PxsArticulationE: __ZN5physx19PxsSimObjectFactory19destroyArticulationERNS_15PxsArticulationE, __Z27getPxSceneDescCpuDispatcherPKN5physx11PxSceneDescE: __Z27getPxSceneDescCpuDispatcherPKN5physx11PxSceneDescE, __Z46Register_UnityEngine_GUIStyle_set_stretchWidthv: __Z46Register_UnityEngine_GUIStyle_set_stretchWidthv, __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5Umbra18ImpOcclusionBuffer18isAABBFullyVisibleERKNS_7Vector3ES3_: __ZNK5Umbra18ImpOcclusionBuffer18isAABBFullyVisibleERKNS_7Vector3ES3_, __ZNK9GfxBuffer6IsLostEv: __ZNK9GfxBuffer6IsLostEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj396ENS_22PxRepXPropertyAccessorILj396ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj396ENS_22PxRepXPropertyAccessorILj396ES4_ffEEEEvRKT0_, _fread_file_func: _fread_file_func, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZL17Transfer_GUIStyleI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z42Register_UnityEngine_GUITexture_get_borderv: __Z42Register_UnityEngine_GUITexture_get_borderv, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXMultiplierv, __ZN13TranslateGLES14InitObjectTypeERK12GraphicsCaps: __ZN13TranslateGLES14InitObjectTypeERK12GraphicsCaps, __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_: __ZNSt3__26vectorINS_4pairIP11Il2CppClassPKN5Unity4TypeEEENS_9allocatorIS8_EEE21__push_back_slow_pathIKS8_EEvRT_, __ZN26LegacyTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN26LegacyTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z33NavMeshAgent_Get_Custom_PropSpeedP12Il2CppObject: __Z33NavMeshAgent_Get_Custom_PropSpeedP12Il2CppObject, __ZN4PPtrI11TerrainDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI11TerrainDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Ext23DefaultBufferedProfilerC2ERNS_12PxFoundationEPKc: __ZN5physx3Ext23DefaultBufferedProfilerC2ERNS_12PxFoundationEPKc, __ZN5physx27PxHeightFieldRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx27PxHeightFieldRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNK12AudioManager15GetSpeakerCountEv: __ZNK12AudioManager15GetSpeakerCountEv, __Z50Register_UnityEngine_TrailRenderer_get_textureModev: __Z50Register_UnityEngine_TrailRenderer_get_textureModev, __Z43Cloth_Get_Custom_PropUseContinuousCollisionP12Il2CppObject: __Z43Cloth_Get_Custom_PropUseContinuousCollisionP12Il2CppObject, __ZN15b2FrictionJoint4DumpEv: __ZN15b2FrictionJoint4DumpEv, __ZN5physx2Sc16ArticulationCore6wakeUpEf: __ZN5physx2Sc16ArticulationCore6wakeUpEf, __Z45Register_UnityEngine_Texture2D_SetAllPixels32v: __Z45Register_UnityEngine_Texture2D_SetAllPixels32v, __ZN5physx18PxcSkipNarrowPhaseERNS_13PxcNpWorkUnitE: __ZN5physx18PxcSkipNarrowPhaseERNS_13PxcNpWorkUnitE, __ZN5physx19NpArticulationJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx19NpArticulationJoint17resolveReferencesERNS_24PxDeserializationContextE, __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st: __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st, __ZNK5physx2Sn21SerializationRegistry17getRepXSerializerEPKc: __ZNK5physx2Sn21SerializationRegistry17getRepXSerializerEPKc, __ZN9GfxDevice19FreeComputeBufferIDE15ComputeBufferID: __ZN9GfxDevice19FreeComputeBufferIDE15ComputeBufferID, __ZN8Animator40SetAllowConstantClipSamplingOptimizationEb: __ZN8Animator40SetAllowConstantClipSamplingOptimizationEb, __Z38AndroidJNI_CUSTOM_CallStaticByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z38AndroidJNI_CUSTOM_CallStaticByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKc19ProfilerInformationEENS_19__map_value_compareIS3_S5_N22UnityProfilerPerThread25CompareDynamicMethodNamesELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __Z36ComputeBuffer_CUSTOM_InternalSetDataP12Il2CppObjectP11Il2CppArrayi: __Z36ComputeBuffer_CUSTOM_InternalSetDataP12Il2CppObjectP11Il2CppArrayi, __ZNK5physx7NpCloth24getLinearDragCoefficientEv: __ZNK5physx7NpCloth24getLinearDragCoefficientEv, __ZNK10FileSystem11MoveToTrashEPKc: __ZNK10FileSystem11MoveToTrashEPKc, __ZN15NavMeshSettings5ResetEv: __ZN15NavMeshSettings5ResetEv, __ZN14CachingManager15ClearTempFolderEv: __ZN14CachingManager15ClearTempFolderEv, __ZN13SubstanceData25OnMaterialFinishedLoadingEv: __ZN13SubstanceData25OnMaterialFinishedLoadingEv, __ZN15AudioReverbZone23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15AudioReverbZone23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx2Sc32DefaultClothInterCollisionFilterEPvS1_: __ZN5physx2Sc32DefaultClothInterCollisionFilterEPvS1_, __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE: __ZN15Cast2DQueryBaseC2ERK8Vector2fS2_fiffPK10Collider2DbR13dynamic_arrayI12RaycastHit2DLj4EE, __Z43Physics_Set_Custom_PropDefaultContactOffsetf: __Z43Physics_Set_Custom_PropDefaultContactOffsetf, __ZN3WWW6RetainEv: __ZN3WWW6RetainEv, __ZN13GfxDeviceGLES19RenderTargetBarrierEv: __ZN13GfxDeviceGLES19RenderTargetBarrierEv, __Z25InvertMatrix4x4_General3DPKfPf: __Z25InvertMatrix4x4_General3DPKfPf, _UNITY_TT_Init_Glyph_Loading: _UNITY_TT_Init_Glyph_Loading, __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z69ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __ZN9dtNavMeshD2Ev: __ZN9dtNavMeshD2Ev, __ZN12ImageFilters8DoRenderER17ShaderPassContextP13RenderTexturebbbb: __ZN12ImageFilters8DoRenderER17ShaderPassContextP13RenderTexturebbbb, __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK8Vector3fS1_fS1_P10RaycastHitfi23QueryTriggerInteraction: __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK8Vector3fS1_fS1_P10RaycastHitfi23QueryTriggerInteraction, __Z51Register_UnityEngine_Physics_set_queriesHitTriggersv: __Z51Register_UnityEngine_Physics_set_queriesHitTriggersv, __ZN11WindManager16ComputeWindForceERK4AABB: __ZN11WindManager16ComputeWindForceERK4AABB, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17setRigidBodyFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __ZN11UnityEngine9Animation28SetBoundCurveInstanceIDValueERKNS0_10BoundCurveEi: __ZN11UnityEngine9Animation28SetBoundCurveInstanceIDValueERKNS0_10BoundCurveEi, __Z11OpenConsolev: __Z11OpenConsolev, __ZN15NavMeshObstacle10SmartResetEv: __ZN15NavMeshObstacle10SmartResetEv, __Z44Register_UnityEngine_AI_OffMeshLink_get_areav: __Z44Register_UnityEngine_AI_OffMeshLink_get_areav, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZv, __ZN12_GLOBAL__N_117EventBufferClient4lockEjjy: __ZN12_GLOBAL__N_117EventBufferClient4lockEjjy, __ZN14SafeBinaryRead21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN14SafeBinaryRead21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, __ZN13SparseTexture16DeleteGfxTextureEv: __ZN13SparseTexture16DeleteGfxTextureEv, __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEEEEjT_j: __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEEEEjT_j, __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev: __ZNSt3__214__split_bufferIPNS_6locale5facetERNS_15__sso_allocatorIS3_Lj28EEEED2Ev, __ZNK5Umbra10Visibility14getInputBufferEv: __ZNK5Umbra10Visibility14getInputBufferEv, __Z41CharacterController_Get_Custom_PropRadiusP12Il2CppObject: __Z41CharacterController_Get_Custom_PropRadiusP12Il2CppObject, __ZN8Animator10DeactivateE19DeactivateOperation: __ZN8Animator10DeactivateE19DeactivateOperation, __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf: __ZN5physx22PxVehicleWheelsDynData21setWheelRotationSpeedEjf, __ZN14RenderSettings16ApplyHaloTextureEv: __ZN14RenderSettings16ApplyHaloTextureEv, _sha256_update: _sha256_update, __ZN5physx2Sc5Scene16finishBroadPhaseEj: __ZN5physx2Sc5Scene16finishBroadPhaseEj, __Z45Physics2D_Set_Custom_PropLinearSleepTolerancef: __Z45Physics2D_Set_Custom_PropLinearSleepTolerancef, __ZL25processBrokenEdgeIslands2PKjjRN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerEPjS8_S8_RNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEE: __ZL25processBrokenEdgeIslands2PKjjRN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerEPjS8_S8_RNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEE, __ZN15SerializeTraitsI11KeyframeTplIfEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsI11KeyframeTplIfEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZNSt3__26vectorI9HumanBoneNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI9HumanBoneNS_9allocatorIS1_EEE8__appendEj, __ZN10RenderLoop12PrepareFrameEbb: __ZN10RenderLoop12PrepareFrameEbb, __ZN10BlendShape8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10BlendShape8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13BuildSettingsC2E10MemLabelId18ObjectCreationMode: __ZN13BuildSettingsC2E10MemLabelId18ObjectCreationMode, __ZN14DirectorPlayer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14DirectorPlayer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z65Register_UnityEngine_ParticleSystem_GetCustomParticleDataInternalv: __Z65Register_UnityEngine_ParticleSystem_GetCustomParticleDataInternalv, __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, _TT_Hint_Glyph: _TT_Hint_Glyph, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateUpdateInputManagerstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN35EarlyUpdateUpdateInputManagerstruct7ForwardEv, __ZN11KeyframeTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11KeyframeTplI11QuaternionfE8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4math8Collider8TransferI8BlobSizeEEvRT_: __ZN4math8Collider8TransferI8BlobSizeEEvRT_, __ZN13GfxDeviceGLES20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh: __ZN13GfxDeviceGLES20SetShadersThreadableEPP10GpuProgramPPK20GpuProgramParametersPKPKh, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale1Ef, __ZNSt3__213__vector_baseI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEED2Ev: __ZNSt3__213__vector_baseI16MessageForwarder13stl_allocatorIS1_L18MemLabelIdentifier6ELi8EEED2Ev, __ZN22VertexDeclarationCacheD2Ev: __ZN22VertexDeclarationCacheD2Ev, __Z21getPxClothFabric_SetsPKN5physx13PxClothFabricEPjj: __Z21getPxClothFabric_SetsPKN5physx13PxClothFabricEPjj, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev, __Z48setPxVehicleDifferentialNWData_DrivenWheelStatusPN5physx27PxVehicleDifferentialNWDataEj: __Z48setPxVehicleDifferentialNWData_DrivenWheelStatusPN5physx27PxVehicleDifferentialNWDataEj, __ZN17AudioReverbFilterC2E10MemLabelId18ObjectCreationMode: __ZN17AudioReverbFilterC2E10MemLabelId18ObjectCreationMode, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED2Ev: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED2Ev, __ZNK9DebugGLES18ShaderDeleteStatusEj: __ZNK9DebugGLES18ShaderDeleteStatusEj, __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f: __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f, __ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_: __ZN5physx19PxsMaterialCombiner18combineRestitutionERKNS_15PxsMaterialDataES3_, __Z19CreateGLESGfxDevice17GfxDeviceRenderer: __Z19CreateGLESGfxDevice17GfxDeviceRenderer, __Z49Register_UnityEngine_Font_GetOSInstalledFontNamesv: __Z49Register_UnityEngine_Font_GetOSInstalledFontNamesv, __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEwj, __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE13getBufferSizeEj: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE13getBufferSizeEj, __ZN18ProceduralMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18ProceduralMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5Umbra9IndexList11getCapacityEv: __ZNK5Umbra9IndexList11getCapacityEv, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN27ConvexVsMeshOverlapCallbackD0Ev: __ZN27ConvexVsMeshOverlapCallbackD0Ev, __ZNK5physx2Sc18ParticleSystemCore19getParticleReadDataERNS_23PxParticleFluidReadDataE: __ZNK5physx2Sc18ParticleSystemCore19getParticleReadDataERNS_23PxParticleFluidReadDataE, __Z42SurfaceEffector2D_Set_Custom_PropUseBounceP12Il2CppObjecth: __Z42SurfaceEffector2D_Set_Custom_PropUseBounceP12Il2CppObjecth, __ZNK8VRDevice16GetLocalRotationERK8UnityStr: __ZNK8VRDevice16GetLocalRotationERK8UnityStr, __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerStringv: __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerStringv, __Z44AudioMixerSnapshot_Get_Custom_PropAudioMixerP12Il2CppObject: __Z44AudioMixerSnapshot_Get_Custom_PropAudioMixerP12Il2CppObject, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __ZN5physx2Cm12RenderBuffer6appendERKNS_14PxRenderBufferE: __ZN5physx2Cm12RenderBuffer6appendERKNS_14PxRenderBufferE, __ZN12CullingGroup18SetScriptingObjectEP12Il2CppObject: __ZN12CullingGroup18SetScriptingObjectEP12Il2CppObject, __ZN7mecanim9animation18CreateAnimationSetEjjjRNS_6memory9AllocatorE: __ZN7mecanim9animation18CreateAnimationSetEjjjRNS_6memory9AllocatorE, __Z35GUI_CUSTOM_Internal_GetMouseTooltipv: __Z35GUI_CUSTOM_Internal_GetMouseTooltipv, __ZN13BoxCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13BoxCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN6Object30StringToClassIDCaseInsensitiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN6Object30StringToClassIDCaseInsensitiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, ___nl_langinfo: ___nl_langinfo, __ZZN8VRDevice10InitializeEbEN33PostLateUpdateVRPostPresentstruct7ForwardEv: __ZZN8VRDevice10InitializeEbEN33PostLateUpdateVRPostPresentstruct7ForwardEv, __Z26TransformVerticesInnerLoopILb1ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb1ELb0ELb1EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __ZNK8Playable12IndexOfInputEPKS_: __ZNK8Playable12IndexOfInputEPKS_, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvPKjtPKtj: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb1EEEvPKjtPKtj, __Z41Register_UnityEngine_AssetBundle_Containsv: __Z41Register_UnityEngine_AssetBundle_Containsv, __ZN5physx2Gu5RTree8validateEv: __ZN5physx2Gu5RTree8validateEv, _UNITY_png_get_image_height: _UNITY_png_get_image_height, __ZN8WindZone8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8WindZone8TransferI24GenerateTypeTreeTransferEEvRT_, __Z43Animator_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf: __Z43Animator_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf, __ZN9LensFlare16TransformChangedEv: __ZN9LensFlare16TransformChangedEv, __ZN4FMOD3DSP12getNumInputsEPi: __ZN4FMOD3DSP12getNumInputsEPi, __ZN17PhysicsMaterial2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17PhysicsMaterial2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK21DownloadHandlerBuffer13GetMemorySizeEv: __ZNK21DownloadHandlerBuffer13GetMemorySizeEv, __Z38Shader_CUSTOM_SetGlobalVectorArrayImpliP11Il2CppArray: __Z38Shader_CUSTOM_SetGlobalVectorArrayImpliP11Il2CppArray, __Z42AudioReverbFilter_Get_Custom_PropDecayTimeP12Il2CppObject: __Z42AudioReverbFilter_Get_Custom_PropDecayTimeP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS6_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS6_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags, __Z51Register_UnityEngine_AI_NavMeshAgent_get_autoRepathv: __Z51Register_UnityEngine_AI_NavMeshAgent_get_autoRepathv, __Z43TextGenerator_Get_Custom_PropCharacterCountP12Il2CppObject: __Z43TextGenerator_Get_Custom_PropCharacterCountP12Il2CppObject, __Z57Register_UnityEngine_Audio_AudioMixerGroup_get_audioMixerv: __Z57Register_UnityEngine_Audio_AudioMixerGroup_get_audioMixerv, __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15TextureSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Umbra17ImpTomeCollection11deserializeERNS_11InputStreamEPPKNS_7ImpTomeEiPNS_9AllocatorE: __ZN5Umbra17ImpTomeCollection11deserializeERNS_11InputStreamEPPKNS_7ImpTomeEiPNS_9AllocatorE, __ZN23LODTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN23LODTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z42AnchoredJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall: __Z42AnchoredJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall, __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastNonAllocv: __Z60Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastNonAllocv, __ZN27AnimationLayerMixerPlayableD2Ev: __ZN27AnimationLayerMixerPlayableD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj509ENS_22PxRepXPropertyAccessorILj509ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj509ENS_22PxRepXPropertyAccessorILj509ES4_ffEEEEvRKT0_, __Z56getPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE: __Z56getPxVehicleTireLoadFilterDataMMaxFilteredNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE, __ZN5physx19PxsContactReductionILj6EE14reduceContactsEv: __ZN5physx19PxsContactReductionILj6EE14reduceContactsEv, __Z32Scene_CUSTOM_GetIsLoadedInternali: __Z32Scene_CUSTOM_GetIsLoadedInternali, __Z53Register_UnityEngine_GUIClip_INTERNAL_get_topmostRectv: __Z53Register_UnityEngine_GUIClip_INTERNAL_get_topmostRectv, __Z45Rigidbody_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f: __Z45Rigidbody_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f, __ZNK6Camera28CalculateNeedsToRenderIntoRTEv: __ZNK6Camera28CalculateNeedsToRenderIntoRTEv, __ZN9LensFlare8SetColorERK10ColorRGBAf: __ZN9LensFlare8SetColorERK10ColorRGBAf, __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_RNS3_18ImpulseAccumulatorE: __ZNK5physx5cloth11SwCollisionI8Scalar4fE12collideConesEPKS2_RNS3_18ImpulseAccumulatorE, __Z70Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsLifetimev: __Z70Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsLifetimev, __ZN15AudioEchoFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15AudioEchoFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN11NavMeshData8TransferI14SafeBinaryReadEEvRT_: __ZN11NavMeshData8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN13MonoBehaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13MonoBehaviour23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z45ReflectionProbe_Set_Custom_PropShadowDistanceP12Il2CppObjectf: __Z45ReflectionProbe_Set_Custom_PropShadowDistanceP12Il2CppObjectf, __ZN13GfxDeviceGLES20CreateComputeProgramEPKhj: __ZN13GfxDeviceGLES20CreateComputeProgramEPKhj, __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj: __ZN5physx14PxVehicleDrive15patchupPointersEPS0_Phjj, __Z31HumanPoseHandler_CUSTOM_DisposeP12Il2CppObject: __Z31HumanPoseHandler_CUSTOM_DisposeP12Il2CppObject, __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, _readdir_r: _readdir_r, __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEEEvRT_j, __ZN5physx42PxVehicleTireLoadFilterDataGeneratedValuesC2EPKNS_27PxVehicleTireLoadFilterDataE: __ZN5physx42PxVehicleTireLoadFilterDataGeneratedValuesC2EPKNS_27PxVehicleTireLoadFilterDataE, __ZNK5Umbra9FloatList7getSizeEv: __ZNK5Umbra9FloatList7getSizeEv, __ZN17CircleCast2DQuery19InitializeCastShapeEv: __ZN17CircleCast2DQuery19InitializeCastShapeEv, __ZN5Umbra8QueryExt13getPortalInfoERNS_10PortalInfoEi: __ZN5Umbra8QueryExt13getPortalInfoERNS_10PortalInfoEi, __ZN13GUIStyleState8TransferI8JSONReadEEvRT_: __ZN13GUIStyleState8TransferI8JSONReadEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_, __ZNK10FileSystem15LocalFileSystemEv: __ZNK10FileSystem15LocalFileSystemEv, __ZN5physx6shdfnd10Foundation11decRefCountEv: __ZN5physx6shdfnd10Foundation11decRefCountEv, __ZN17ArchiveFileSystem4SeekER13FileEntryDatax10FileOrigin: __ZN17ArchiveFileSystem4SeekER13FileEntryDatax10FileOrigin, __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN15QualitySettings16CheckConsistencyEv: __ZN15QualitySettings16CheckConsistencyEv, __Z47Register_UnityEngine_SliderJoint2D_set_useMotorv: __Z47Register_UnityEngine_SliderJoint2D_set_useMotorv, __ZN5physx6shdfnd10checkValidERKf: __ZN5physx6shdfnd10checkValidERKf, __ZN8VRDeviceC2EPK23UnityVRDeviceDefinition: __ZN8VRDeviceC2EPK23UnityVRDeviceDefinition, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN5Umbra4Math4atanERKNS_6DoubleE: __ZN5Umbra4Math4atanERKNS_6DoubleE, __Z43Register_UnityEngine_Texture_set_filterModev: __Z43Register_UnityEngine_Texture_set_filterModev, __ZN13dynamic_arrayIN14SerializedFile4TypeELj8EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIN14SerializedFile4TypeELj8EE18resize_initializedEjRKS1_12ResizePolicy, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pubsetbufEPci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pubsetbufEPci, __ZN14ParticleSystem29AllocateAllStructuresOfArraysEv: __ZN14ParticleSystem29AllocateAllStructuresOfArraysEv, __ZN5Umbra6DoubledVERKd: __ZN5Umbra6DoubledVERKd, __Z20RequiredComponentsOfP11Il2CppClass: __Z20RequiredComponentsOfP11Il2CppClass, __Z52Register_UnityEngine_CapsuleCollider2D_get_directionv: __Z52Register_UnityEngine_CapsuleCollider2D_get_directionv, __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z44getPxSimulationStatisticsNbActiveConstraintsPKN5physx22PxSimulationStatisticsE: __Z44getPxSimulationStatisticsNbActiveConstraintsPKN5physx22PxSimulationStatisticsE, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE, ___fgetwc_unlocked: ___fgetwc_unlocked, __ZNK7dtCrowd8getAgentERK13dtCrowdHandle: __ZNK7dtCrowd8getAgentERK13dtCrowdHandle, __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi: __ZNSt3__215__inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeEi, __ZN5physx19NpArticulationJoint12setChildPoseERKNS_11PxTransformE: __ZN5physx19NpArticulationJoint12setChildPoseERKNS_11PxTransformE, __ZN6Shader20CreateFromParsedFormEv: __ZN6Shader20CreateFromParsedFormEv, __ZN12AdsIdHandler25ExecuteAsyncFetchAdsIdJobEv: __ZN12AdsIdHandler25ExecuteAsyncFetchAdsIdJobEv, __ZN16LightmapSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN16LightmapSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskEEEE7getNameEv, __ZN21AssetBundleFileSystemD0Ev: __ZN21AssetBundleFileSystemD0Ev, __ZN10GameObject25RegisterDestroyedCallbackEPFvPS_E: __ZN10GameObject25RegisterDestroyedCallbackEPFvPS_E, __Z43RenderSettings_Get_Custom_PropFlareStrengthv: __Z43RenderSettings_Get_Custom_PropFlareStrengthv, __ZNK5physx2Sq12BucketPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE: __ZNK5physx2Sq12BucketPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE, __ZN5physx8debugger14PvdMarshallingIfjE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIfjE12marshalBlockEPKhPhj, __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__215__num_get_floatIfEET_PKcS3_Rj: __ZNSt3__215__num_get_floatIfEET_PKcS3_Rj, __Z18GetNbBroadPhaseAddPKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE: __Z18GetNbBroadPhaseAddPKN5physx22PxSimulationStatisticsENS0_10VolumeTypeE, __Z54Register_UnityEngine_SpriteRenderer_SetSprite_INTERNALv: __Z54Register_UnityEngine_SpriteRenderer_SetSprite_INTERNALv, __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_, __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE: __ZN5physx7NpActor15getShapeManagerERNS_12PxRigidActorE, __ZN14PlayerSettings18InitDefaultCursorsEv: __ZN14PlayerSettings18InitDefaultCursorsEv, __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f: __ZN9Heightmap20CalculateNormalSobelEiiiiRK13dynamic_arrayIsLj2EERK8Vector3f, __Z46Register_UnityEngine_CanvasRenderer_SetTexturev: __Z46Register_UnityEngine_CanvasRenderer_SetTexturev, __ZN35ClampVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN35ClampVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendESt16initializer_listIwE, __ZN5physx27PxClothFabricRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx27PxClothFabricRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj47ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj47ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z55Register_UnityEngine_ParticleRenderer_set_velocityScalev: __Z55Register_UnityEngine_ParticleRenderer_set_velocityScalev, __ZN16LightmapSettings16CheckConsistencyEv: __ZN16LightmapSettings16CheckConsistencyEv, __Z41setPxFixedJoint_ProjectionLinearTolerancePN5physx12PxFixedJointEf: __Z41setPxFixedJoint_ProjectionLinearTolerancePN5physx12PxFixedJointEf, _jpeg_idct_ifast: _jpeg_idct_ifast, __ZNK20TextRenderingPrivate8FontImpl11GetTabWidthEv: __ZNK20TextRenderingPrivate8FontImpl11GetTabWidthEv, __ZN5physx7profile32PxProfileMemoryEventRecorderImpl14onDeallocationEPv: __ZN5physx7profile32PxProfileMemoryEventRecorderImpl14onDeallocationEPv, __ZN14CachingManager10GetIsReadyEv: __ZN14CachingManager10GetIsReadyEv, __Z46Register_UnityEngine_AI_NavMeshAgent_ResetPathv: __Z46Register_UnityEngine_AI_NavMeshAgent_ResetPathv, __ZN7mecanim12statemachine10IsDisabledEPKNS0_17StateMachineInputE: __ZN7mecanim12statemachine10IsDisabledEPKNS0_17StateMachineInputE, __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE6getlocEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE6getlocEv, __ZNK9dtNavMesh24getNextOffMeshConnectionEPK19dtOffMeshConnection: __ZNK9dtNavMesh24getNextOffMeshConnectionEPK19dtOffMeshConnection, __Z61ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailMultiplierP12Il2CppObjectf: __Z61ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailMultiplierP12Il2CppObjectf, __ZNK26AnimatorControllerPlayable25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo: __ZNK26AnimatorControllerPlayable25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo, __ZN10PngDecoderC2Ev: __ZN10PngDecoderC2Ev, __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_CapsuleCastv: __Z63Register_UnityEngine_Physics_INTERNAL_CALL_Internal_CapsuleCastv, __ZN12AudioManager17ShouldSourcePauseEb: __ZN12AudioManager17ShouldSourcePauseEb, __ZNK18AudioLowPassFilter26GetTypeInfoVirtualInternalEv: __ZNK18AudioLowPassFilter26GetTypeInfoVirtualInternalEv, __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI10BlendShapeLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN5physx7profile30PxProfileMemoryEventBufferImpl14onDeallocationEPv: __ZN5physx7profile30PxProfileMemoryEventBufferImpl14onDeallocationEPv, __ZN5physx6shdfnd7PAUtils9statEventEtjj: __ZN5physx6shdfnd7PAUtils9statEventEtjj, __ZN17PersistentManager20ClearActiveNameSpaceENS_19ActiveNameSpaceTypeE: __ZN17PersistentManager20ClearActiveNameSpaceENS_19ActiveNameSpaceTypeE, __ZN15AudioReverbZone6UpdateEv: __ZN15AudioReverbZone6UpdateEv, __ZN15ContactFilter2DD0Ev: __ZN15ContactFilter2DD0Ev, __ZN9ShaderLab13InitShaderLabEv: __ZN9ShaderLab13InitShaderLabEv, __Z43Register_UnityEngine_Camera_set_fieldOfViewv: __Z43Register_UnityEngine_Camera_set_fieldOfViewv, __ZN5physx2Sn20SerializationContextC2ERKNS_2Cm10CollectionEPS4_: __ZN5physx2Sn20SerializationContextC2ERKNS_2Cm10CollectionEPS4_, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetYMultiplierv, __ZN11UnityEngine7Connect20BasePersistentValues18TransferBaseValuesI8JSONReadEEvRT_: __ZN11UnityEngine7Connect20BasePersistentValues18TransferBaseValuesI8JSONReadEEvRT_, __ZNK14AreaEffector2D26GetTypeInfoVirtualInternalEv: __ZNK14AreaEffector2D26GetTypeInfoVirtualInternalEv, __Z13tessMeshUnionP9TESSallocP8TESSmeshS2_: __Z13tessMeshUnionP9TESSallocP8TESSmeshS2_, __ZNK9ShaderLab9IntShader13GetDependencyERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZNK9ShaderLab9IntShader13GetDependencyERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN5physx2Gu29checkOverlapCapsule_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu29checkOverlapCapsule_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, __ZNK17AnimationCurveTplI11QuaternionfE8WrapTimeEf: __ZNK17AnimationCurveTplI11QuaternionfE8WrapTimeEf, __Z43Register_UnityEngine_TrailRenderer_set_timev: __Z43Register_UnityEngine_TrailRenderer_set_timev, __ZN11Rigidbody2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11Rigidbody2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNKSt3__210moneypunctIcLb1EE8groupingEv: __ZNKSt3__210moneypunctIcLb1EE8groupingEv, __ZN15UnityAdsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15UnityAdsManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5UmbramlERKNS_9Matrix4x4ES2_: __ZN5UmbramlERKNS_9Matrix4x4ES2_, __ZN19AssetBundleManifest15ThreadedCleanupEv: __ZN19AssetBundleManifest15ThreadedCleanupEv, __ZN18BuoyancyEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18BuoyancyEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15ArchiveReadFile4SeekEx10FileOrigin: __ZN15ArchiveReadFile4SeekEx10FileOrigin, __ZN5physx23PxsBroadPhaseContextSap6createERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE: __ZN5physx23PxsBroadPhaseContextSap6createERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE, __ZN5physx7NpScene26removeArticulationInternalERNS_14PxArticulationEbb: __ZN5physx7NpScene26removeArticulationInternalERNS_14PxArticulationEbb, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcjj, __ZN11DynamicMesh24CollapsePolygonUnorderedEj: __ZN11DynamicMesh24CollapsePolygonUnorderedEj, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetQualityv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetQualityv, __ZN5physx8debugger14PvdMarshallingIhfE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhfE12marshalBlockEPKhPhj, __Z56Register_UnityEngine_Animator_get_layersAffectMassCenterv: __Z56Register_UnityEngine_Animator_get_layersAffectMassCenterv, __ZN13SparseTexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13SparseTexture7PRODUCEE10MemLabelId18ObjectCreationMode, __Z42NavMeshAgent_Set_Custom_PropUpdateRotationP12Il2CppObjecth: __Z42NavMeshAgent_Set_Custom_PropUpdateRotationP12Il2CppObjecth, __ZN19MeshParticleEmitter19OnMeshFilterChangedEv: __ZN19MeshParticleEmitter19OnMeshFilterChangedEv, __ZN5physx7NpActor15removeConnectorERNS_7PxActorEj: __ZN5physx7NpActor15removeConnectorERNS_7PxActorEj, __Z23LogOutputToSpecificFilePKc: __Z23LogOutputToSpecificFilePKc, __Z39getPxParticleReadDataValidParticleRangePKN5physx18PxParticleReadDataE: __Z39getPxParticleReadDataValidParticleRangePKN5physx18PxParticleReadDataE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D9SleepModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D9SleepModeEEvRT_RT0_PKc17TransferMetaFlags, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE15exportExtraDataERNS_22PxSerializationContextE, __ZN8Renderer10AddToSceneER13RendererScene: __ZN8Renderer10AddToSceneER13RendererScene, __Z18Transfer_BlittableI8JSONReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7reserveEj, __ZNSt3__214__codecvt_utf8IDiED0Ev: __ZNSt3__214__codecvt_utf8IDiED0Ev, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZN9ShaderLab20SerializedSubProgram8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab20SerializedSubProgram8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx20PxsParticleSystemSim16getShapesUpdateVERNS_29PxvParticleShapeUpdateResultsE: __ZNK5physx20PxsParticleSystemSim16getShapesUpdateVERNS_29PxvParticleShapeUpdateResultsE, __ZN15DirectorManager15AdvanceTimeFuncEP14AdvanceTimeJobj: __ZN15DirectorManager15AdvanceTimeFuncEP14AdvanceTimeJobj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ev: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ev, __ZNSt16bad_array_lengthD0Ev: __ZNSt16bad_array_lengthD0Ev, __ZN15ReflectionProbe15ThreadedCleanupEv: __ZN15ReflectionProbe15ThreadedCleanupEv, __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv, __Z50WheelCollider_CUSTOM_INTERNAL_set_sidewaysFrictionP12Il2CppObjectRK18WheelFrictionCurve: __Z50WheelCollider_CUSTOM_INTERNAL_set_sidewaysFrictionP12Il2CppObjectRK18WheelFrictionCurve, __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEED0Ev, __Z37AudioChorusFilter_Set_Custom_PropRateP12Il2CppObjectf: __Z37AudioChorusFilter_Set_Custom_PropRateP12Il2CppObjectf, _cf2_doFlex: _cf2_doFlex, __ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_: __ZN14PhysicsManager18GetIgnoreCollisionEPKN5physx12PxFilterDataES3_, __ZN7mecanim9animation28GetWeightFreeformDirectionalERKNS0_19Blend2dDataConstantEP8Vector2fiiS4_: __ZN7mecanim9animation28GetWeightFreeformDirectionalERKNS0_19Blend2dDataConstantEP8Vector2fiiS4_, __ZN5physx6shdfnd10FoundationD0Ev: __ZN5physx6shdfnd10FoundationD0Ev, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19setVirtualParticlesENS0_5RangeIA4_KjEENS4_IKNS_6PxVec3EEE, __ZNK12b2WheelJoint14GetMotorTorqueEf: __ZNK12b2WheelJoint14GetMotorTorqueEf, __Z53Register_UnityEngine_CanvasRenderer_get_materialCountv: __Z53Register_UnityEngine_CanvasRenderer_get_materialCountv, __Z17GetUnityWebStreamv: __Z17GetUnityWebStreamv, __ZN10Collider2DD0Ev: __ZN10Collider2DD0Ev, __Z47Register_UnityEngine_AndroidJNI_GetBooleanFieldv: __Z47Register_UnityEngine_AndroidJNI_GetBooleanFieldv, __ZN5Umbra15BufferAllocatorC2Ev: __ZN5Umbra15BufferAllocatorC2Ev, __ZN4FMOD5Sound21getMusicChannelVolumeEiPf: __ZN4FMOD5Sound21getMusicChannelVolumeEiPf, __ZN13GfxDeviceGLES22ReleaseThreadOwnershipEv: __ZN13GfxDeviceGLES22ReleaseThreadOwnershipEv, __ZN5physx16PxsFluidDynamics10mergeForceEPNS_10PxBaseTaskE: __ZN5physx16PxsFluidDynamics10mergeForceEPNS_10PxBaseTaskE, __ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE: __ZN7mecanim12statemachine17EvaluateConditionEPKNS0_17ConditionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE, __Z46Register_UnityEngine_RuntimeUndo_RecordObjectsv: __Z46Register_UnityEngine_RuntimeUndo_RecordObjectsv, __ZN5physx2Sc5Scene11postCCDPassEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene11postCCDPassEPNS_10PxBaseTaskE, __ZNK5physx7NpScene24getContactModifyCallbackEv: __ZNK5physx7NpScene24getContactModifyCallbackEv, __ZN5physx2Sc18ParticleSystemCore13setRestOffsetEf: __ZN5physx2Sc18ParticleSystemCore13setRestOffsetEf, __Z47ParticleSystem_TriggerModule_CUSTOM_GetColliderP12Il2CppObjecti: __Z47ParticleSystem_TriggerModule_CUSTOM_GetColliderP12Il2CppObjecti, __Z45Register_UnityEngine_Transform_get_childCountv: __Z45Register_UnityEngine_Transform_get_childCountv, __Z32getPxScene_ContactModifyCallbackPKN5physx7PxSceneE: __Z32getPxScene_ContactModifyCallbackPKN5physx7PxSceneE, __ZN13BuildSettings34ConvertDisplayScenePathToScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13BuildSettings34ConvertDisplayScenePathToScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z55Register_UnityEngine_RenderTexture_INTERNAL_CALL_Createv: __Z55Register_UnityEngine_RenderTexture_INTERNAL_CALL_Createv, __ZNK8VRDevice25GetStereoscopicBackbufferEv: __ZNK8VRDevice25GetStereoscopicBackbufferEv, _stbir_resize_uint16_generic: _stbir_resize_uint16_generic, _LzmaDecode: _LzmaDecode, __ZN5Umbra9Matrix2x211flushToZeroEv: __ZN5Umbra9Matrix2x211flushToZeroEv, __ZN10DynamicVBO12ReleaseChunkER21DynamicVBOChunkHandlejj: __ZN10DynamicVBO12ReleaseChunkER21DynamicVBOChunkHandlejj, __Z71Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityMultiplierv: __Z71Register_UnityEngine_ParticleSystem_LightsModule_GetIntensityMultiplierv, _UNITY_FT_Remove_Module: _UNITY_FT_Remove_Module, __Z52Register_UnityEngine_AudioReverbFilter_get_decayTimev: __Z52Register_UnityEngine_AudioReverbFilter_get_decayTimev, _UNITY_png_get_x_offset_microns: _UNITY_png_get_x_offset_microns, __ZN5physx27PxClothFabricRepXSerializerD0Ev: __ZN5physx27PxClothFabricRepXSerializerD0Ev, __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN24EllipsoidParticleEmitterC2E10MemLabelId18ObjectCreationMode: __ZN24EllipsoidParticleEmitterC2E10MemLabelId18ObjectCreationMode, __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNK13WheelCollider13GetSteerAngleEv: __ZNK13WheelCollider13GetSteerAngleEv, __Z42Register_UnityEngine_GameObject_set_activev: __Z42Register_UnityEngine_GameObject_set_activev, __Z23setPxD6Joint_SwingLimitPN5physx9PxD6JointERKNS_16PxJointLimitConeE: __Z23setPxD6Joint_SwingLimitPN5physx9PxD6JointERKNS_16PxJointLimitConeE, __Z12BuildTextureIA4_tPFvP9Texture2DPS0_iiiiEES2_PKcii13TextureFormatRKT0_17TextureColorSpaceb: __Z12BuildTextureIA4_tPFvP9Texture2DPS0_iiiiEES2_PKcii13TextureFormatRKT0_17TextureColorSpaceb, __Z6simd4iRK8Scalar4f: __Z6simd4iRK8Scalar4f, __Z43ReflectionProbe_Set_Custom_PropBakedTextureP12Il2CppObjectS0_: __Z43ReflectionProbe_Set_Custom_PropBakedTextureP12Il2CppObjectS0_, _rgb_gray_convert: _rgb_gray_convert, __Z46Graphics_CUSTOM_Internal_DrawMeshInstancedListP12Il2CppObjectiS0_S0_S0_17ShadowCastingModehiS0_: __Z46Graphics_CUSTOM_Internal_DrawMeshInstancedListP12Il2CppObjectiS0_S0_S0_17ShadowCastingModehiS0_, __ZN22NavMeshProjectSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN22NavMeshProjectSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx3Cct10ControllerD2Ev: __ZN5physx3Cct10ControllerD2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags, _cf2_glyphpath_computeOffset: _cf2_glyphpath_computeOffset, __Z38AudioChorusFilter_Set_Custom_PropDelayP12Il2CppObjectf: __Z38AudioChorusFilter_Set_Custom_PropDelayP12Il2CppObjectf, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_, __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf: __ZNK14dtNavMeshQuery18closestPointOnPolyEyPKfPf, __ZN4FMOD8ChannelI8getDelayE14FMOD_DELAYTYPEPjS2_: __ZN4FMOD8ChannelI8getDelayE14FMOD_DELAYTYPEPjS2_, __Z53Register_UnityEngine_Cloth_get_worldAccelerationScalev: __Z53Register_UnityEngine_Cloth_get_worldAccelerationScalev, __ZN5physx16PxVehicleDriveNW4freeEv: __ZN5physx16PxVehicleDriveNW4freeEv, _start_pass_downsample: _start_pass_downsample, __ZN5physx17PxcNpMemBlockPool11flushUnusedEv: __ZN5physx17PxcNpMemBlockPool11flushUnusedEv, __Z59QualitySettings_Get_Custom_PropBillboardsFaceCameraPositionv: __Z59QualitySettings_Get_Custom_PropBillboardsFaceCameraPositionv, __ZL27BindVertexProgramAttributesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER14ChannelAssignsj: __ZL27BindVertexProgramAttributesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER14ChannelAssignsj, __Z51Register_UnityEngine_Physics2D_get_showColliderAABBv: __Z51Register_UnityEngine_Physics2D_get_showColliderAABBv, __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20TextRenderingPrivate7GUIText8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4Mesh23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN4Mesh23VirtualRedirectTransferER17RemapPPtrTransfer, __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj: __Z18SetVertexStateGLESRK14ChannelAssignsP21VertexDeclarationGLESPK18VertexStreamSourcejjj, __ZN21LoadResourceOperationD0Ev: __ZN21LoadResourceOperationD0Ev, __ZN12CubemapArray8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12CubemapArray8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclERKNS_27PxRigidActorShapeCollectionEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclERKNS_27PxRigidActorShapeCollectionEj, __ZN15AudioMixerGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15AudioMixerGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z28AndroidJNI_CUSTOM_GetVersionv: __Z28AndroidJNI_CUSTOM_GetVersionv, __ZN7mecanim9animation16ControllerMemory8TransferI17RemapPPtrTransferEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI17RemapPPtrTransferEEvRT_, __Z55Register_UnityEngine_Animator_get_hasTransformHierarchyv: __Z55Register_UnityEngine_Animator_get_hasTransformHierarchyv, __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32: __Z17TryParseHtmlColorRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER11ColorRGBA32, __Z49Register_UnityEngine_DebugLogHandler_Internal_Logv: __Z49Register_UnityEngine_DebugLogHandler_Internal_Logv, __ZN13TriggerModule16CheckConsistencyEv: __ZN13TriggerModule16CheckConsistencyEv, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERe: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERe, __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv: __ZN7ApiGLES12TextureImageEj16TextureDimensioniN2gl9TexFormatEiiiiiPKv, __Z53Register_UnityEngine_RenderSettings_get_flareStrengthv: __Z53Register_UnityEngine_RenderSettings_get_flareStrengthv, __Z33AssetBundle_CUSTOM_LoadFromMemoryP11Il2CppArrayj: __Z33AssetBundle_CUSTOM_LoadFromMemoryP11Il2CppArrayj, __Z35computeBlockStreamByteSizesCoulomb4PN5physx21PxcSolverContact4DescERNS_18PxcNpThreadContextERKNS_27PxcCorrelationBufferCoulombERjPjS7_: __Z35computeBlockStreamByteSizesCoulomb4PN5physx21PxcSolverContact4DescERNS_18PxcNpThreadContextERKNS_27PxcCorrelationBufferCoulombERjPjS7_, __ZN12b2MouseJointD0Ev: __ZN12b2MouseJointD0Ev, __ZN2UI6Canvas21UpdateCanvasInvMatrixEv: __ZN2UI6Canvas21UpdateCanvasInvMatrixEv, __ZNK5physx3Cct17CapsuleController11getPositionEv: __ZNK5physx3Cct17CapsuleController11getPositionEv, __Z32getNbPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkE: __Z32getNbPxArticulationLink_ChildrenPKN5physx18PxArticulationLinkE, __ZN29AnimationStateNetworkProvider29GetNetworkAnimationStateCountER9Animation: __ZN29AnimationStateNetworkProvider29GetNetworkAnimationStateCountER9Animation, __Z55Register_UnityEngine_GUIUtility_Internal_GetBuiltinSkinv: __Z55Register_UnityEngine_GUIUtility_Internal_GetBuiltinSkinv, __ZN11UmbraModule34CullShadowCastersWithUmbraThreadedER20ShadowCullingJobDataR10BlockRangei: __ZN11UmbraModule34CullShadowCastersWithUmbraThreadedER20ShadowCullingJobDataR10BlockRangei, __ZN14SpriteRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14SpriteRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN2UI14CanvasRenderer40SetNextTransformChangedTriggeredByCanvasEv: __ZN2UI14CanvasRenderer40SetNextTransformChangedTriggeredByCanvasEv, __ZN12InputManager14ResetInputAxesEv: __ZN12InputManager14ResetInputAxesEv, __ZN22b2EdgeAndCircleContactC2EP9b2FixtureS1_: __ZN22b2EdgeAndCircleContactC2EP9b2FixtureS1_, __ZN5physx15NpParticleFluid12setViscosityEf: __ZN5physx15NpParticleFluid12setViscosityEf, _UNITY_FT_Load_Glyph: _UNITY_FT_Load_Glyph, __ZN25ShadowMapJobHeaderScratchD2Ev: __ZN25ShadowMapJobHeaderScratchD2Ev, __ZN19SkinnedMeshRenderer13BecameVisibleEv: __ZN19SkinnedMeshRenderer13BecameVisibleEv, __Z48Register_UnityEngine_AudioReverbZone_set_densityv: __Z48Register_UnityEngine_AudioReverbZone_set_densityv, __Z41Input_Get_Custom_PropStylusTouchSupportedv: __Z41Input_Get_Custom_PropStylusTouchSupportedv, __ZN10VertexData4SwapERS_: __ZN10VertexData4SwapERS_, __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_: __ZNSt3__27__sort4IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_T_, __ZN18AsyncUploadManager13GetAsyncFenceEP6Object: __ZN18AsyncUploadManager13GetAsyncFenceEP6Object, __ZNK8Animator21GetAnimatorControllerEv: __ZNK8Animator21GetAnimatorControllerEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEaSERKS3_: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEaSERKS3_, __Z45Register_UnityEngine_Camera_set_targetDisplayv: __Z45Register_UnityEngine_Camera_set_targetDisplayv, __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E: __ZN5physx22PxVehicleWheelsSimData26setSuspForceAppPointOffsetEjRKNS_6PxVec3E, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE12readPropertyIfEEbRT_, __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager13RegisterLayerEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __ZZN16AnimationManager15InitializeClassEvEN43FixedUpdateLegacyFixedAnimationUpdatestruct7ForwardEv: __ZZN16AnimationManager15InitializeClassEvEN43FixedUpdateLegacyFixedAnimationUpdatestruct7ForwardEv, __ZL20ForwardInvokeDelayedP6ObjectPv: __ZL20ForwardInvokeDelayedP6ObjectPv, __ZN5physx9NpPhysics31registerDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj: __ZN5physx9NpPhysics31registerDeletionListenerObjectsERNS_18PxDeletionListenerEPKPKNS_6PxBaseEj, __ZN5physx3Scb5Scene15syncEntireSceneEPj: __ZN5physx3Scb5Scene15syncEntireSceneEPj, __ZN14HeightMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14HeightMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z42Physics2D_Get_Custom_PropContactArrowScalev: __Z42Physics2D_Get_Custom_PropContactArrowScalev, __ZN18ProceduralMaterial26FreezeAndReleaseSourceDataEv: __ZN18ProceduralMaterial26FreezeAndReleaseSourceDataEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E: __ZNK5Umbra7ImpTile12getCellIndexEiRKNS_7Vector3E, __Z34Animator_CUSTOM_ResetTriggerStringP12Il2CppObjectP12Il2CppString: __Z34Animator_CUSTOM_ResetTriggerStringP12Il2CppObjectP12Il2CppString, __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE: __Z10AddGUIAxesRNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEEE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags, __ZN8VRDevice19GetSinglePassStereoEv: __ZN8VRDevice19GetSinglePassStereoEv, __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK12LineRenderer11GetPositionEi: __ZNK12LineRenderer11GetPositionEi, __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_set_rndForcev: __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_set_rndForcev, __Z43Register_UnityEngine_CrashReport_GetReportsv: __Z43Register_UnityEngine_CrashReport_GetReportsv, __ZN5physx13PxsCCDContext14updateCCDBeginEv: __ZN5physx13PxsCCDContext14updateCCDBeginEv, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS0_9allocatorIS3_EEEEEvRT_j, __ZNK5physx32PxClothTetherConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEEEEEjT_j: __ZNK5physx32PxClothTetherConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEEEEEjT_j, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZNK7b2World7RayCastEP17b2RayCastCallbackRK6b2Vec2S4_: __ZNK7b2World7RayCastEP17b2RayCastCallbackRK6b2Vec2S4_, __Z13RegisterClassI19CharacterControllerEvv: __Z13RegisterClassI19CharacterControllerEvv, __ZN4FMOD8ChannelI11getUserDataEPPv: __ZN4FMOD8ChannelI11getUserDataEPPv, __Z31Profiler_Get_Custom_PropLogFilev: __Z31Profiler_Get_Custom_PropLogFilev, __Z49Register_UnityEngine_AudioReverbFilter_set_roomLFv: __Z49Register_UnityEngine_AudioReverbFilter_set_roomLFv, __ZN5physx5cloth15intersectBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_: __ZN5physx5cloth15intersectBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_, __Z31ResolveDepthIntoTextureIfNeededR9GfxDeviceR10RenderLoop17DepthBufferFormatRP13RenderTextureP9TextureIDPb: __Z31ResolveDepthIntoTextureIfNeededR9GfxDeviceR10RenderLoop17DepthBufferFormatRP13RenderTextureP9TextureIDPb, __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeMultiplierP12Il2CppObject: __Z76ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFrameOverTimeMultiplierP12Il2CppObject, __Z38Application_Get_Custom_PropCompanyNamev: __Z38Application_Get_Custom_PropCompanyNamev, __ZN22LocalFileSystemHandler16DestroyFileEntryER13FileEntryData: __ZN22LocalFileSystemHandler16DestroyFileEntryER13FileEntryData, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, _write_scan_header: _write_scan_header, __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK8Vector3f: __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MovePositionP12Il2CppObjectRK8Vector3f, _hypot: _hypot, __ZN13GfxDeviceGLES28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi: __ZN13GfxDeviceGLES28UpdateComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvEjjPKhPKjS8_PKi, __Z74Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentColorv: __Z74Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentColorv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getConstraintEv, __ZNSt3__214collate_bynameIcED0Ev: __ZNSt3__214collate_bynameIcED0Ev, __ZN2UI13RectTransform15InitializeClassEv: __ZN2UI13RectTransform15InitializeClassEv, __Z23AddCleanLogEntryHandlerPFb7LogTypePKcPiE: __Z23AddCleanLogEntryHandlerPFb7LogTypePKcPiE, __ZN18AsyncUploadManager35ManageTextureUploadRingBufferMemoryEi: __ZN18AsyncUploadManager35ManageTextureUploadRingBufferMemoryEi, __ZN5LightC2E10MemLabelId18ObjectCreationMode: __ZN5LightC2E10MemLabelId18ObjectCreationMode, __ZN5physx29solveExtContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx29solveExtContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN13RuntimeStaticI13RendererSceneE13StaticDestroyEPv: __ZN13RuntimeStaticI13RendererSceneE13StaticDestroyEPv, __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv: __ZNK5physx2Sc18ParticleSystemCore8getFlagsEv, __ZN12NavMeshAgent15SetAngularSpeedEf: __ZN12NavMeshAgent15SetAngularSpeedEf, __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates: __Z38CalculateLightProbeSamplingCoordinatesRK17LightProbeContextRK8Vector3fiR29LightProbeSamplingCoordinates, __ZN5physx6shdfnd21computeQuatFromNormalERKNS_6PxVec3E: __ZN5physx6shdfnd21computeQuatFromNormalERKNS_6PxVec3E, __Z36Register_UnityEngine_Camera_CopyFromv: __Z36Register_UnityEngine_Camera_CopyFromv, __ZNK6Avatar24GetRightFeetBottomHeightEv: __ZNK6Avatar24GetRightFeetBottomHeightEv, __ZN24OcclusionCullingSettings17MainThreadCleanupEv: __ZN24OcclusionCullingSettings17MainThreadCleanupEv, __ZN13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EE6insertEPS0_PKS0_S4_, _newlocale: _newlocale, __ZNK15b2RevoluteJoint14GetMotorTorqueEf: __ZNK15b2RevoluteJoint14GetMotorTorqueEf, _jsimd_h2v2_upsample: _jsimd_h2v2_upsample, __ZNK9DebugGLES6VerifyEv: __ZNK9DebugGLES6VerifyEv, __ZN12_GLOBAL__N_112UserRenderer9addClientERN5physx26PxProfileEventBufferClientE: __ZN12_GLOBAL__N_112UserRenderer9addClientERN5physx26PxProfileEventBufferClientE, __ZN22DownloadHandlerTextureC2Ev: __ZN22DownloadHandlerTextureC2Ev, __ZN12GUIClipState6UnclipERK8Vector2f: __ZN12GUIClipState6UnclipERK8Vector2f, __ZNK14Texture2DArray11GetPixels32EiP11ColorRGBA32ii: __ZNK14Texture2DArray11GetPixels32EiP11ColorRGBA32ii, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxJointLinearLimitPairEE8pushNameEPKc, __ZN8JSONReadD2Ev: __ZN8JSONReadD2Ev, __ZNK24MeshIntermediateRenderer14AllowsBatchingEv: __ZNK24MeshIntermediateRenderer14AllowsBatchingEv, __Z58Register_UnityEngine_ComputeShader_INTERNAL_CALL_SetVectorv: __Z58Register_UnityEngine_ComputeShader_INTERNAL_CALL_SetVectorv, __Z69Register_UnityEngine_Rendering_CommandBuffer_IssuePluginEventInternalv: __Z69Register_UnityEngine_Rendering_CommandBuffer_IssuePluginEventInternalv, __ZNSt10bad_typeidC2Ev: __ZNSt10bad_typeidC2Ev, __ZN18ScreenManagerWebGL21SetCursorInsideWindowEb: __ZN18ScreenManagerWebGL21SetCursorInsideWindowEb, __ZN22DownloadHandlerTextureC2Eb: __ZN22DownloadHandlerTextureC2Eb, __ZN9Animation8GetStateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation8GetStateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9UnityGUID8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx3Ext14SphericalJoint28setProjectionLinearToleranceEf: __ZN5physx3Ext14SphericalJoint28setProjectionLinearToleranceEf, __ZN12LineRenderer14UpdateRendererEv: __ZN12LineRenderer14UpdateRendererEv, __ZN9Rigidbody27InvalidateAssociatedVehicleEv: __ZN9Rigidbody27InvalidateAssociatedVehicleEv, __Z14SkipPathPrefixPKcS0_jb: __Z14SkipPathPrefixPKcS0_jb, __ZN17Physics2DSettings22SetMaxLinearCorrectionEf: __ZN17Physics2DSettings22SetMaxLinearCorrectionEf, __ZNSt8bad_castC2Ev: __ZNSt8bad_castC2Ev, __ZN14dtNavMeshQueryC2Ev: __ZN14dtNavMeshQueryC2Ev, __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache: __ZN16ScriptingManager19RegisterScriptCacheEP15MonoScriptCache, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_S6_T_, __ZNK14SoundHandleAPI11GetLengthMSEv: __ZNK14SoundHandleAPI11GetLengthMSEv, __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData: __ZN24MaterialDisplayListCache22InvalidateDisplayListsER18SharedMaterialData, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE8__appendEj, __ZN5physx18NpArticulationLinkD2Ev: __ZN5physx18NpArticulationLinkD2Ev, __Z53Register_UnityEngine_Terrain_get_reflectionProbeUsagev: __Z53Register_UnityEngine_Terrain_get_reflectionProbeUsagev, __Z53Register_UnityEngine_AI_OffMeshLink_set_biDirectionalv: __Z53Register_UnityEngine_AI_OffMeshLink_set_biDirectionalv, __ZN14DirectorPlayer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14DirectorPlayer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15TerrainCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15TerrainCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN31TransformFeedbackSkinPoseBufferD0Ev: __ZN31TransformFeedbackSkinPoseBufferD0Ev, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE12NeedsPollingEv: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE12NeedsPollingEv, __ZN5physx14PxRigidBodyExt17linearSweepSingleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEERNS_10PxSweepHitERjRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf: __ZN5physx14PxRigidBodyExt17linearSweepSingleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEERNS_10PxSweepHitERjRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf, __Z18Transfer_BlittableI8JSONReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z29CubemapArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayiii: __Z29CubemapArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayiii, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS4_EENS5_9allocatorIS4_EEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS4_EENS5_9allocatorIS4_EEEEEvRT_17TransferMetaFlags, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags, __Z16CreateCompressor15CompressionType10MemLabelId: __Z16CreateCompressor15CompressionType10MemLabelId, __ZN19SpriteMeshGenerator4path8min_costEv: __ZN19SpriteMeshGenerator4path8min_costEv, __ZN6Avatar17MainThreadCleanupEv: __ZN6Avatar17MainThreadCleanupEv, __ZN17ProfilerFrameData9SerializeER13dynamic_arrayIiLj4EE: __ZN17ProfilerFrameData9SerializeER13dynamic_arrayIiLj4EE, __ZNSt3__25stackIPN9ShaderLab21SerializedShaderStateENS_5dequeIS3_NS_9allocatorIS3_EEEEED2Ev: __ZNSt3__25stackIPN9ShaderLab21SerializedShaderStateENS_5dequeIS3_NS_9allocatorIS3_EEEEED2Ev, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE7hasDataEv: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE7hasDataEv, __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_15PxDebugTriangleENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetXv, __ZN5Umbra5QueryaSERKS0_: __ZN5Umbra5QueryaSERKS0_, __ZN10Collider2D15ThreadedCleanupEv: __ZN10Collider2D15ThreadedCleanupEv, __ZN5physx2Gu23computeSphere_SphereMTDERKNS0_6SphereES3_RNS_10PxSweepHitE: __ZN5physx2Gu23computeSphere_SphereMTDERKNS0_6SphereES3_RNS_10PxSweepHitE, __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21AssetReferenceStorageD2Ev: __ZN21AssetReferenceStorageD2Ev, __ZN12_GLOBAL__N_19MyFastXml8readDataEPc: __ZN12_GLOBAL__N_19MyFastXml8readDataEPc, __Z49Register_UnityEngine_TrailRenderer_set_startWidthv: __Z49Register_UnityEngine_TrailRenderer_set_startWidthv, __ZN5physx7NpCloth19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj: __ZN5physx7NpCloth19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj, __ZN13UnityProfiler10SetLogPathENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13UnityProfiler10SetLogPathENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z21GetDelayedCallManagerv: __Z21GetDelayedCallManagerv, __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_: __ZN9JSONWrite12AppendToNodeEPN9rapidjson12GenericValueINS0_4UTF8IcEE13JSONAllocatorEEPKcRS5_, __Z38SliderJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject: __Z38SliderJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject, __Z38RenderTexture_Get_Custom_PropUseMipMapP12Il2CppObject: __Z38RenderTexture_Get_Custom_PropUseMipMapP12Il2CppObject, __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE17GetUploadProgressEv: __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE17GetUploadProgressEv, __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI14PhysicMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z43Register_UnityEngine_Texture_set_mipMapBiasv: __Z43Register_UnityEngine_Texture_set_mipMapBiasv, __Z41Animator_CUSTOM_INTERNAL_get_rootPositionP12Il2CppObjectP8Vector3f: __Z41Animator_CUSTOM_INTERNAL_get_rootPositionP12Il2CppObjectP8Vector3f, __ZN5Unity5JointD2Ev: __ZN5Unity5JointD2Ev, __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj: __Z24CalculateSkinPoseMathLibILi4EEvRN4math8float4x4EPK10Matrix4x4fPKvj, __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E: __ZNK8Gradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareERKS5_: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareERKS5_, __Z44DebugLogHandler_CUSTOM_Internal_LogExceptionP15Il2CppExceptionP12Il2CppObject: __Z44DebugLogHandler_CUSTOM_Internal_LogExceptionP15Il2CppExceptionP12Il2CppObject, __ZN18ProfilerConnectionC2Ev: __ZN18ProfilerConnectionC2Ev, __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE7destroyEv: __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE7destroyEv, __Z44Register_UnityEngine_AndroidJNI_IsSameObjectv: __Z44Register_UnityEngine_AndroidJNI_IsSameObjectv, __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth12LerpIteratorIS1_NS3_17UnalignedIteratorIS1_Lj3EEEEEEEvPNS3_12TriangleDataERKT0_j: __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth12LerpIteratorIS1_NS3_17UnalignedIteratorIS1_Lj3EEEEEEEvPNS3_12TriangleDataERKT0_j, _cff_cmap_encoding_char_index: _cff_cmap_encoding_char_index, __ZN11LightProbes8TransferI14SafeBinaryReadEEvRT_: __ZN11LightProbes8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_, __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionZP12Il2CppObject: __Z52LightProbeProxyVolume_Get_Custom_PropGridResolutionZP12Il2CppObject, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags, __ZN11UnityEngine9Analytics13UserInfoEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine9Analytics13UserInfoEvent12ToJsonStringER9JSONWrite, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEclERS4_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEclERS4_17TransferMetaFlagsR9BlobWrite, __ZN10Matrix3x3f8SetScaleERK8Vector3f: __ZN10Matrix3x3f8SetScaleERK8Vector3f, __Z61Register_UnityEngine_QualitySettings_set_asyncUploadTimeSlicev: __Z61Register_UnityEngine_QualitySettings_set_asyncUploadTimeSlicev, __ZN14UnityWebStreamD2Ev: __ZN14UnityWebStreamD2Ev, __ZNK12b2WheelJoint14IsMotorEnabledEv: __ZNK12b2WheelJoint14IsMotorEnabledEv, __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z60Register_UnityEngine_Rendering_CommandBuffer_Blit_Identifierv: __Z60Register_UnityEngine_Rendering_CommandBuffer_Blit_Identifierv, __ZN5physx2Gu18contactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu18contactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN26IntersectAnyVsMeshCallbackILi0ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi0ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv: __ZN9rapidjson12PrettyWriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv, __ZN5physx7NpShape12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx7NpShape12createObjectERPhRNS_24PxDeserializationContextE, __ZN10OnGUIStateC2Ev: __ZN10OnGUIStateC2Ev, __Z12GetTimestampv: __Z12GetTimestampv, __ZN15ReflectionProbe29CheckAndReleaseCachedRendererEv: __ZN15ReflectionProbe29CheckAndReleaseCachedRendererEv, __ZNK9ShaderLab7Program21GetMatchingSubProgramEPK6ShaderPKNS_4PassERK16ShaderKeywordSetjPS7_R19ShaderSnippetResult: __ZNK9ShaderLab7Program21GetMatchingSubProgramEPK6ShaderPKNS_4PassERK16ShaderKeywordSetjPS7_R19ShaderSnippetResult, __ZNKSt3__25ctypeIwE10do_scan_isEtPKwS3_: __ZNKSt3__25ctypeIwE10do_scan_isEtPKwS3_, _UNITY_FT_Init_Class_tt_cmap12_class_rec: _UNITY_FT_Init_Class_tt_cmap12_class_rec, __ZN14PhysicMaterial23VirtualRedirectTransferER14SafeBinaryRead: __ZN14PhysicMaterial23VirtualRedirectTransferER14SafeBinaryRead, __Z49EmitSerializationCommandsForLinearCollectionFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI9JSONWriteEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZL25ProgramUniformMatrix2x3fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix2x3fvPK7ApiGLESjiihPKv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE19getConcreteTypeNameEv, __ZN14FileCacherRead13AllocateBlockERNS_10CacheBlockE: __ZN14FileCacherRead13AllocateBlockERNS_10CacheBlockE, __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN13GfxDeviceGLES27SetRandomWriteTargetTextureEi9TextureID: __ZN13GfxDeviceGLES27SetRandomWriteTargetTextureEi9TextureID, __Z14RectfToRectIntRK5RectTIfE: __Z14RectfToRectIntRK5RectTIfE, __ZN16ScriptingManager43AddOutOfHierarchyNativeTypeToScriptingClassEPKN5Unity4TypeEP11Il2CppClass: __ZN16ScriptingManager43AddOutOfHierarchyNativeTypeToScriptingClassEPKN5Unity4TypeEP11Il2CppClass, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx32PxsSolverConstraintPartitionTaskD0Ev: __ZN5physx32PxsSolverConstraintPartitionTaskD0Ev, __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_: __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_, __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverTrailv: __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverTrailv, __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj, __Z34getPxJointLimitParametersStiffnessPKN5physx22PxJointLimitParametersE: __Z34getPxJointLimitParametersStiffnessPKN5physx22PxJointLimitParametersE, __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi: __ZN20BaseBehaviourManager12AddBehaviourER8ListNodeI9BehaviourEi, __Z22DeOptimizeIndexBuffersR4Mesh: __Z22DeOptimizeIndexBuffersR4Mesh, __Z60Register_UnityEngine_ScriptableObject_CreateInstanceFromTypev: __Z60Register_UnityEngine_ScriptableObject_CreateInstanceFromTypev, __ZN8Animator17GetAvatarRotationEv: __ZN8Animator17GetAvatarRotationEv, __ZN18DelayedCallManager15ThreadedCleanupEv: __ZN18DelayedCallManager15ThreadedCleanupEv, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudeMultiplierv: __Z90Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudeMultiplierv, __ZN10MeshFilter19SetInstantiatedMeshEP4Mesh: __ZN10MeshFilter19SetInstantiatedMeshEP4Mesh, __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb1EEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIwLb1EEEEEvRKS1_, __ZN11UnityEngine15CloudWebService19SessionEventManager27ProcessFlushEventsJobStaticEPv: __ZN11UnityEngine15CloudWebService19SessionEventManager27ProcessFlushEventsJobStaticEPv, __ZN5physx24PxsParticleSystemBatcherC2ERNS_10PxsContextE: __ZN5physx24PxsParticleSystemBatcherC2ERNS_10PxsContextE, __ZN23ArchiveStorageConverter11GetProgressEv: __ZN23ArchiveStorageConverter11GetProgressEv, __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns: __ZNK21BillboardBatchManager19DrawSingleBillboardERK22BillboardRenderingDataRK14ChannelAssigns, __ZN4FMOD7Channel19get3DDistanceFilterEPbPfS2_: __ZN4FMOD7Channel19get3DDistanceFilterEPbPfS2_, __ZN11NavMeshData23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11NavMeshData23VirtualRedirectTransferER17RemapPPtrTransfer, __Z25Animator_CUSTOM_GetBoolIDP12Il2CppObjecti: __Z25Animator_CUSTOM_GetBoolIDP12Il2CppObjecti, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpRigidStaticEEEEEvPT_jRKT0_RKT1_j, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_, __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_set_sizev: __Z56Register_UnityEngine_CapsuleCollider2D_INTERNAL_set_sizev, __ZN20ObjectMemoryProfiler18TakeMemorySnapshotER13dynamic_arrayIiLj4EEb: __ZN20ObjectMemoryProfiler18TakeMemorySnapshotER13dynamic_arrayIiLj4EEb, __Z53Register_UnityEngine_ComputeShader_Internal_SetFloatsv: __Z53Register_UnityEngine_ComputeShader_Internal_SetFloatsv, __ZN4crnd10dxt1_block10pack_colorEjjjbj: __ZN4crnd10dxt1_block10pack_colorEjjjbj, __ZN23iPhoneLocalNotificationC2EP11objc_object: __ZN23iPhoneLocalNotificationC2EP11objc_object, __ZN5physx7NpShape17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx7NpShape17getBinaryMetaDataERNS_14PxOutputStreamE, __Z43Register_UnityEngine_Mesh_GetBlendShapeNamev: __Z43Register_UnityEngine_Mesh_GetBlendShapeNamev, __ZN14DetailDatabaseC2EP11TerrainDataP12TreeDatabase: __ZN14DetailDatabaseC2EP11TerrainDataP12TreeDatabase, __ZN11AudioSource16CreateFMODGroupsEv: __ZN11AudioSource16CreateFMODGroupsEv, __Z13RegisterClassI5FlareEvv: __Z13RegisterClassI5FlareEvv, __ZN11AudioSource28SetSpatializePostEffectsGainEf: __ZN11AudioSource28SetSpatializePostEffectsGainEf, __Z44setPxVehicleWheelsDynData_WheelRotationAnglePN5physx22PxVehicleWheelsDynDataEjf: __Z44setPxVehicleWheelsDynData_WheelRotationAnglePN5physx22PxVehicleWheelsDynDataEjf, __ZN5physx7NpCloth18addCollisionSphereERKNS_22PxClothCollisionSphereE: __ZN5physx7NpCloth18addCollisionSphereERKNS_22PxClothCollisionSphereE, __Z14PlaneCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersif: __Z14PlaneCollisionR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersif, __ZN11UnityEngine9Analytics16TransactionEventC2ERK8UnityStrdS4_S4_S4_yb: __ZN11UnityEngine9Analytics16TransactionEventC2ERK8UnityStrdS4_S4_S4_yb, __ZN5Umbra18ImpOcclusionBuffer7combineERKS0_: __ZN5Umbra18ImpOcclusionBuffer7combineERKS0_, __ZN17GenericDynamicVBOD0Ev: __ZN17GenericDynamicVBOD0Ev, __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE19resizeUninitializedEj, __ZN8Animator15GetPlaybackTimeEv: __ZN8Animator15GetPlaybackTimeEv, __ZNK5physx3Cct13BoxController18getNonWalkableModeEv: __ZNK5physx3Cct13BoxController18getNonWalkableModeEv, __ZN5physx18NpArticulationLink17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx18NpArticulationLink17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE7getNameEv, __Z31ComputeShader_CUSTOM_SetTextureP12Il2CppObjectiiS0_: __Z31ComputeShader_CUSTOM_SetTextureP12Il2CppObjectiiS0_, __ZN5physx2Gu8gjkLocalINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE: __ZN5physx2Gu8gjkLocalINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE, __Z73Register_UnityEngine_Networking_DownloadHandler_InternalCreateAssetBundlev: __Z73Register_UnityEngine_Networking_DownloadHandler_InternalCreateAssetBundlev, __ZN7b2World16SetAllowSleepingEb: __ZN7b2World16SetAllowSleepingEb, __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj: __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj, __ZN16Physics2DManager31DestroyColliderIgnoreCollisionsEP10Collider2D: __ZN16Physics2DManager31DestroyColliderIgnoreCollisionsEP10Collider2D, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE21__grow_by_and_replaceEjjjjjjPKc, __ZN2UI20CleanupCanvasManagerEv: __ZN2UI20CleanupCanvasManagerEv, __ZN5audio5mixer14GetGroupVUInfoERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDbPNS0_6VUInfoE: __ZN5audio5mixer14GetGroupVUInfoERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDbPNS0_6VUInfoE, __Z48Register_UnityEngine_Rendering_SplashScreen_Drawv: __Z48Register_UnityEngine_Rendering_SplashScreen_Drawv, __ZNK13b2DynamicTree8ValidateEv: __ZNK13b2DynamicTree8ValidateEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN10GameObject8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10GameObject8TransferI24GenerateTypeTreeTransferEEvRT_, __Z49Register_UnityEngine_GUI_Internal_GetMouseTooltipv: __Z49Register_UnityEngine_GUI_Internal_GetMouseTooltipv, __ZN13LoadOperation12GetDebugNameEv: __ZN13LoadOperation12GetDebugNameEv, __ZN13WheelCollider19CreateWheelIfNeededEv: __ZN13WheelCollider19CreateWheelIfNeededEv, __Z34Animation_Get_Custom_PropIsPlayingP12Il2CppObject: __Z34Animation_Get_Custom_PropIsPlayingP12Il2CppObject, __ZN10GUITextureD2Ev: __ZN10GUITextureD2Ev, __ZN18CrashReportManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18CrashReportManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx6shdfnd5ArrayIPNS_18NpArticulationLinkENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_18NpArticulationLinkENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_, __ZN5physx6shdfnd5ArrayINS_2Sq10AABBPruner12NewTreeFixupENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_2Sq10AABBPruner12NewTreeFixupENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z14FindAvatarRootPKN7mecanim8skeleton8SkeletonEPKjR9Transformb: __Z14FindAvatarRootPKN7mecanim8skeleton8SkeletonEPKjR9Transformb, __ZN10Matrix4x4f5ScaleERK8Vector3f: __ZN10Matrix4x4f5ScaleERK8Vector3f, __ZN5physx2Sc5Scene16scheduleClothGpuERNS_10PxBaseTaskE: __ZN5physx2Sc5Scene16scheduleClothGpuERNS_10PxBaseTaskE, __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_: __ZNK15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS3_, __ZNK19LowerResBlitTexture12GetDataWidthEv: __ZNK19LowerResBlitTexture12GetDataWidthEv, __ZN19AssetBundleManifest15AssetBundleInfo8TransferI14SafeBinaryReadEEvRT_: __ZN19AssetBundleManifest15AssetBundleInfo8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx2Sc9ClothCore16getContactOffsetEv: __ZNK5physx2Sc9ClothCore16getContactOffsetEv, __ZN5physx2Sc7BodySim28notifyAddSpatialAccelerationEv: __ZN5physx2Sc7BodySim28notifyAddSpatialAccelerationEv, __ZN21UnityAnalyticsManagerD0Ev: __ZN21UnityAnalyticsManagerD0Ev, __Z16Projector_RenderRK15RenderNodeQueuejR17ShaderPassContext: __Z16Projector_RenderRK15RenderNodeQueuejR17ShaderPassContext, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE: __ZN7mecanim9animation19DestroyAvatarMemoryEPNS0_12AvatarMemoryERNS_6memory9AllocatorE, __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv, __Z24GUI_Get_Custom_PropDepthv: __Z24GUI_Get_Custom_PropDepthv, __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_: __ZNSt3__27__sort3IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_T_, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, _UNITY_png_compress_IDAT: _UNITY_png_compress_IDAT, _TT_Access_Glyph_Frame: _TT_Access_Glyph_Frame, __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc: __ZN4core12basic_stringIcNS_20StringStorageDefaultIcEEE6assignEPKc, __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter: __ZN14NavMeshManager7RaycastEP10NavMeshHitRK8Vector3fS4_RK13dtQueryFilter, __ZN4FMOD6System19setHardwareChannelsEi: __ZN4FMOD6System19setHardwareChannelsEi, __ZN5physx2Sc10NPhaseCore39addToPersistentContactEventPairsDelayedEPNS0_19ShapeInstancePairLLE: __ZN5physx2Sc10NPhaseCore39addToPersistentContactEventPairsDelayedEPNS0_19ShapeInstancePairLLE, __Z52Register_UnityEngine_Material_SetMatrixArrayImplListv: __Z52Register_UnityEngine_Material_SetMatrixArrayImplListv, __ZN14CachingManager20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN14CachingManager20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z62Register_UnityEngine_Application_get_backgroundLoadingPriorityv: __Z62Register_UnityEngine_Application_get_backgroundLoadingPriorityv, __ZNK22LocalFileSystemHandler9CanHandleEPKc: __ZNK22LocalFileSystemHandler9CanHandleEPKc, __ZN5physx7NpShape18checkMaterialSetupERKNS_10PxGeometryEPKcPKPNS_10PxMaterialEt: __ZN5physx7NpShape18checkMaterialSetupERKNS_10PxGeometryEPKcPKPNS_10PxMaterialEt, __Z40getPxSceneDescDynamicTreeRebuildRateHintPKN5physx11PxSceneDescE: __Z40getPxSceneDescDynamicTreeRebuildRateHintPKN5physx11PxSceneDescE, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED0Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK9Texture2D20GetStorageMemorySizeEv: __ZNK9Texture2D20GetStorageMemorySizeEv, __ZN7b2World12SetDebugDrawEP6b2Draw: __ZN7b2World12SetDebugDrawEP6b2Draw, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5ebackEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5ebackEv, __ZN4FMOD13ChannelGroupI11overridePanEf: __ZN4FMOD13ChannelGroupI11overridePanEf, __ZN11TerrainData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11TerrainData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_9basic_iosIwS2_EES6_E: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_9basic_iosIwS2_EES6_E, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEvPT_jRKT0_RKT1_j, __ZN20LocalFileSystemWebGL5CloseER13FileEntryData: __ZN20LocalFileSystemWebGL5CloseER13FileEntryData, __ZN10UnityScene15SetLoadingStateENS_12LoadingStateE: __ZN10UnityScene15SetLoadingStateENS_12LoadingStateE, __ZN5physx2Sc20ArticulationJointSim10onActivateEj: __ZN5physx2Sc20ArticulationJointSim10onActivateEj, __ZN10DynamicVBOD0Ev: __ZN10DynamicVBOD0Ev, __ZNK15ReflectionProbe10GetTextureEv: __ZNK15ReflectionProbe10GetTextureEv, __Z22getPxScene_ConstraintsPKN5physx7PxSceneEPPNS_12PxConstraintEj: __Z22getPxScene_ConstraintsPKN5physx7PxSceneEPPNS_12PxConstraintEj, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE15GetOverheadSizeEPv: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE15GetOverheadSizeEPv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx22PxSceneGeneratedValuesC2EPKNS_7PxSceneE: __ZN5physx22PxSceneGeneratedValuesC2EPKNS_7PxSceneE, __ZThn8_N5physx2Sc19ShapeInstancePairLL10onActivateEj: __ZThn8_N5physx2Sc19ShapeInstancePairLL10onActivateEj, __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi: __ZN23ParticleSystemParticles22SetUsesEmitAccumulatorEi, _unzGoToNextFile: _unzGoToNextFile, __ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj: __ZN5Umbra11KDTraversalI18MultiPointTraverseE4nextERNS_6KDTree4NodeERj, __Z52Register_UnityEngine_GUI_INTERNAL_CALL_DoModalWindowv: __Z52Register_UnityEngine_GUI_INTERNAL_CALL_DoModalWindowv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj3ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj3ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z49EmitSerializationCommandsForLinearCollectionFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN20OcclusionCullingData23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN20OcclusionCullingData23VirtualRedirectTransferER17RemapPPtrTransfer, __Z31RegisterModule_CloudWebServicesv: __Z31RegisterModule_CloudWebServicesv, __ZN15LocationService15GetLastLocationEv: __ZN15LocationService15GetLastLocationEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb1EEE, __ZN30RuntimeInitializeOnLoadManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN30RuntimeInitializeOnLoadManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12_GLOBAL__N_111createClothERKN5physx11PxTransformERNS0_13PxClothFabricEPKNS0_15PxClothParticleENS0_7PxFlagsINS0_11PxClothFlag4EnumEtEE: __ZN12_GLOBAL__N_111createClothERKN5physx11PxTransformERNS0_13PxClothFabricEPKNS0_15PxClothParticleENS0_7PxFlagsINS0_11PxClothFlag4EnumEtEE, _remove: _remove, __Z39AudioChorusFilter_Set_Custom_PropDryMixP12Il2CppObjectf: __Z39AudioChorusFilter_Set_Custom_PropDryMixP12Il2CppObjectf, __Z22ApplyPerspectiveMatrixRK6Camerab: __Z22ApplyPerspectiveMatrixRK6Camerab, __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj: __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj, __ZN8Animator21SetupPlayableConstantEv: __ZN8Animator21SetupPlayableConstantEv, __ZN8VRDevice27UpdateDeviceConnectedCachedEv: __ZN8VRDevice27UpdateDeviceConnectedCachedEv, __Z61Register_UnityEngine_PlatformEffector2D_set_useOneWayGroupingv: __Z61Register_UnityEngine_PlatformEffector2D_set_useOneWayGroupingv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags, __ZN16CrashReportEventC2ERK8UnityStrS2_S2_: __ZN16CrashReportEventC2ERK8UnityStrS2_S2_, __ZN4FMOD5Sound11setDefaultsEfffi: __ZN4FMOD5Sound11setDefaultsEfffi, _cff_glyph_load: _cff_glyph_load, __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_: __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E13find_positionERS9_, __Z34Joint2D_Get_Custom_PropBreakTorqueP12Il2CppObject: __Z34Joint2D_Get_Custom_PropBreakTorqueP12Il2CppObject, __Z21GetPreallocatedMemoryi: __Z21GetPreallocatedMemoryi, __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E: __ZN5physx6shdfnd19optimizeBoundingBoxERNS_7PxMat33E, __ZN5physx2Cm8PtrTable15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Cm8PtrTable15importExtraDataERNS_24PxDeserializationContextE, __Z48CharacterJoint_CUSTOM_INTERNAL_set_lowTwistLimitP12Il2CppObjectRK14SoftJointLimit: __Z48CharacterJoint_CUSTOM_INTERNAL_set_lowTwistLimitP12Il2CppObjectRK14SoftJointLimit, __Z18setPxActorUserDataPN5physx7PxActorEPv: __Z18setPxActorUserDataPN5physx7PxActorEPv, __Z31setPxVehicleNoDrive_BrakeTorquePN5physx16PxVehicleNoDriveEjf: __Z31setPxVehicleNoDrive_BrakeTorquePN5physx16PxVehicleNoDriveEjf, __ZN8Collider25CreateWithoutIgnoreAttachEv: __ZN8Collider25CreateWithoutIgnoreAttachEv, _UNITY_png_create_read_struct_2: _UNITY_png_create_read_struct_2, __ZN5physx2Sc5Scene19startBatchInsertionERNS0_19BatchInsertionStateE: __ZN5physx2Sc5Scene19startBatchInsertionERNS0_19BatchInsertionStateE, __ZN11AssetBundle6GetAllEv: __ZN11AssetBundle6GetAllEv, __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN18BuoyancyEffector2D21ContactUpdateCallbackEf: __ZN18BuoyancyEffector2D21ContactUpdateCallbackEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity5Joint16SetConnectedBodyE4PPtrI9RigidbodyE: __ZN5Unity5Joint16SetConnectedBodyE4PPtrI9RigidbodyE, __ZNK9GfxDevice28GetActiveRenderSurfaceHeightEv: __ZNK9GfxDevice28GetActiveRenderSurfaceHeightEv, __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt: __ZN5physx3Cct19findTouchedGeometryEPKNS0_30InternalCBData_FindTouchedGeomERKNS_17PxExtendedBounds3ERNS_6shdfnd5ArrayINS_10PxTriangleENS7_19ReflectionAllocatorIS9_EEEERNS8_IjNSA_IjEEEESG_RKNS0_9CCTFilterERKNS0_9CCTParamsERt, __ZN12LineRenderer15ThreadedCleanupEv: __ZN12LineRenderer15ThreadedCleanupEv, __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKfRNS_5human9HumanPoseE: __ZN7mecanim9animation12GetHumanPoseERKNS0_18ClipMuscleConstantEPKfRNS_5human9HumanPoseE, __Z52StaticBatchingUtility_CUSTOM_InternalCombineVerticesP11Il2CppArrayP12Il2CppString: __Z52StaticBatchingUtility_CUSTOM_InternalCombineVerticesP11Il2CppArrayP12Il2CppString, __Z15CreateDenseClipRN7mecanim9animation9DenseClipEjfffRNS_6memory9AllocatorE: __Z15CreateDenseClipRN7mecanim9animation9DenseClipEjfffRNS_6memory9AllocatorE, __ZN4FMOD5Sound13setSoundGroupEPNS_10SoundGroupE: __ZN4FMOD5Sound13setSoundGroupEPNS_10SoundGroupE, __ZNSt3__26gslice6__initEj: __ZNSt3__26gslice6__initEj, __ZN39AssetBundleLoadFromStreamAsyncOperationD2Ev: __ZN39AssetBundleLoadFromStreamAsyncOperationD2Ev, __ZN9GfxDevice40IgnoreNextUnresolveOnCurrentRenderTargetEv: __ZN9GfxDevice40IgnoreNextUnresolveOnCurrentRenderTargetEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj545ENS_22PxRepXPropertyAccessorILj545ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj545ENS_22PxRepXPropertyAccessorILj545ES4_ffEEEEvRKT0_, __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN22NavMeshProjectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK4Halo26GetTypeInfoVirtualInternalEv: __ZNK4Halo26GetTypeInfoVirtualInternalEv, __Z53Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfP11Il2CppArrayiff: __Z53Physics2D_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfP11Il2CppArrayiff, __Z13GetFileLengthRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z13GetFileLengthRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z37Register_UnityEngine_Event_get_buttonv: __Z37Register_UnityEngine_Event_get_buttonv, __ZN5physx16NpConnectorArray17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx16NpConnectorArray17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN12_GLOBAL__N_122DistanceJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_122DistanceJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorEC2EjjbP15BucketAllocatorPKc: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorEC2EjjbP15BucketAllocatorPKc, __ZN13SliderJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13SliderJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx17updateIslandsMainEjPKjjS1_jS1_jS1_jS1_jS1_jRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEES8_jS8_S8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS2_13EventProfilerE: __ZN5physx17updateIslandsMainEjPKjjS1_jS1_jS1_jS1_jS1_jRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEES8_jS8_S8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERNS_23ArticulationRootManagerERNS_33ProcessSleepingIslandsComputeDataERNS_30IslandManagerUpdateWorkBuffersEPNS2_13EventProfilerE, __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z40Register_UnityEngine_Skybox_get_materialv: __Z40Register_UnityEngine_Skybox_get_materialv, __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_: __ZNSt3__27__sort3IRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEjT0_SC_SC_T_, __ZN19ControllerHitReport10onShapeHitERKN5physx20PxControllerShapeHitE: __ZN19ControllerHitReport10onShapeHitERKN5physx20PxControllerShapeHitE, __ZN26AnimatorControllerPlayable11ResolveHashEi: __ZN26AnimatorControllerPlayable11ResolveHashEi, __ZN13SpringJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN13SpringJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __Z10WriteArrayIjEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE: __Z10WriteArrayIjEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE, __ZNK5physx2Sn18RepXCollectionImpl3endEv: __ZNK5physx2Sn18RepXCollectionImpl3endEv, __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE, __ZN5Umbra4Tome14swapEndiannessEPS0_j: __ZN5Umbra4Tome14swapEndiannessEPS0_j, __Z48Caching_Set_Custom_PropMaximumAvailableDiskSpacex: __Z48Caching_Set_Custom_PropMaximumAvailableDiskSpacex, __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_: __ZNSt3__26__sortIR11IndexSorterPiEEvT0_S4_T_, __ZN5physx6shdfnd5ArrayINS_15PxMetaDataEntryENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_15PxMetaDataEntryENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN12_GLOBAL__N_122SocketNetworkOutStreamD2Ev: __ZN12_GLOBAL__N_122SocketNetworkOutStreamD2Ev, __ZN11AudioModule14SetBypassOnDSPEPN4FMOD3DSPEb: __ZN11AudioModule14SetBypassOnDSPEPN4FMOD3DSPEb, __ZN2UI14CanvasRenderer15SetParentCanvasEPNS_6CanvasE: __ZN2UI14CanvasRenderer15SetParentCanvasEPNS_6CanvasE, _UNITY_png_do_gray_to_rgb: _UNITY_png_do_gray_to_rgb, __ZN19VREyeTextureManager22CreateEyeTextureStagesEjbi: __ZN19VREyeTextureManager22CreateEyeTextureStagesEjbi, _UNITY_png_set_pCAL: _UNITY_png_set_pCAL, __ZN7Texture12SetUsageModeE16TextureUsageMode: __ZN7Texture12SetUsageModeE16TextureUsageMode, __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_11EventHeaderE, __Z10IsInvokingR13MonoBehaviourR11ICallString: __Z10IsInvokingR13MonoBehaviourR11ICallString, __ZN12b2MotorJoint16SetAngularOffsetEf: __ZN12b2MotorJoint16SetAngularOffsetEf, __Z31FindAttributeInTypeTreeNoArraysRK16TypeTreeIteratorPKc: __Z31FindAttributeInTypeTreeNoArraysRK16TypeTreeIteratorPKc, __Z16RemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z16RemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__212strstreambufC2EPKai: __ZNSt3__212strstreambufC2EPKai, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED0Ev: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED0Ev, __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE: __ZN7mecanim17DestroyValueArrayEPNS_10ValueArrayERNS_6memory9AllocatorE, __ZNK5physx7NpShape7getNameEv: __ZNK5physx7NpShape7getNameEv, __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21InheritVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN21InheritVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx7profile10EventValue9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile10EventValue9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE, __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIwEE, __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZNK3WWW24GetEstimatedDownloadSizeEv: __ZNK3WWW24GetEstimatedDownloadSizeEv, __ZN12_GLOBAL__N_116StaticInitializeEPv: __ZN12_GLOBAL__N_116StaticInitializeEPv, ___fflush_unlocked: ___fflush_unlocked, __ZL8Perlin1DRKN4math8floatNx3ERKf: __ZL8Perlin1DRKN4math8floatNx3ERKf, __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedFieldv: __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedFieldv, __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j: __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEEEEjT_j, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv, __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_: __ZNSt3__26vectorIiNS_9allocatorIiEEE6insertENS_11__wrap_iterIPKiEERS5_, __Z57Register_UnityEngine_AnimationState_RemoveMixingTransformv: __Z57Register_UnityEngine_AnimationState_RemoveMixingTransformv, __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb: __ZN8Animator13UpdateAvatarsERK13dynamic_arrayI11DirectorJobLj8EEbbb, __ZNK19SkinnedMeshRenderer25DoesQualifyForGPUSkinningEv: __ZNK19SkinnedMeshRenderer25DoesQualifyForGPUSkinningEv, __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorINS_4pairIi22ParticleModulePropertyEENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN6b2Body13ResetMassDataEv: __ZN6b2Body13ResetMassDataEv, __Z53Register_UnityEngine_Physics2D_set_positionIterationsv: __Z53Register_UnityEngine_Physics2D_set_positionIterationsv, __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE8recreateEj: __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE8recreateEj, __ZN9SubModule5ResetEv: __ZN9SubModule5ResetEv, __ZN5physx3Ext20ProfileZoneInterface19handleClientRemovedEv: __ZN5physx3Ext20ProfileZoneInterface19handleClientRemovedEv, __ZN20SoundChannelInstance15ParameterBufferC2Ev: __ZN20SoundChannelInstance15ParameterBufferC2Ev, __ZN18ScreenManagerWebGLD0Ev: __ZN18ScreenManagerWebGLD0Ev, __ZNK12FileAccessor4SizeEv: __ZNK12FileAccessor4SizeEv, __ZN5physx13PxsCCDContext23runCCDModifiableContactEPNS_19PxModifiableContactEjPKNS_12PxsShapeCoreES5_PKNS_12PxsRigidCoreES8_PKNS_12PxsRigidBodyESB_: __ZN5physx13PxsCCDContext23runCCDModifiableContactEPNS_19PxModifiableContactEjPKNS_12PxsShapeCoreES5_PKNS_12PxsRigidCoreES8_PKNS_12PxsRigidBodyESB_, __ZN5physx9NpFactoryD2Ev: __ZN5physx9NpFactoryD2Ev, __ZN5physx15PxsParticleData6createERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E: __ZN5physx15PxsParticleData6createERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E, __ZN5physx7NpCloth18unlockParticleDataEv: __ZN5physx7NpCloth18unlockParticleDataEv, __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_T_, __ZN8JSONRead18GetValueNodeForKeyEPKc: __ZN8JSONRead18GetValueNodeForKeyEPKc, __ZN5physx3Cct15ObstacleContextC2ERNS0_26CharacterControllerManagerE: __ZN5physx3Cct15ObstacleContextC2ERNS0_26CharacterControllerManagerE, __ZN5physx29PxRigidDynamicGeneratedValuesC2EPKNS_14PxRigidDynamicE: __ZN5physx29PxRigidDynamicGeneratedValuesC2EPKNS_14PxRigidDynamicE, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__215recursive_mutex4lockEv: __ZNSt3__215recursive_mutex4lockEv, __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateMemoryFrameMaintenancestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateMemoryFrameMaintenancestruct7ForwardEv, __ZN5physx6shdfnd9SListImpl7getSizeEv: __ZN5physx6shdfnd9SListImpl7getSizeEv, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEPNS_13basic_ostreamIwS2_EE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEPNS_13basic_ostreamIwS2_EE, __ZN22BaseUnityConnectClient19OnEnterStateStartedEv: __ZN22BaseUnityConnectClient19OnEnterStateStartedEv, __ZL40UpdateTransformsGetMessagesMultiThreadedP30UpdateTransformGetMessagesInfoj: __ZL40UpdateTransformsGetMessagesMultiThreadedP30UpdateTransformGetMessagesInfoj, __ZN19AssetBundleManifest25CollectDirectDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE: __ZN19AssetBundleManifest25CollectDirectDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZNSt3__212strstreambuf7seekoffExNS_8ios_base7seekdirEj: __ZNSt3__212strstreambuf7seekoffExNS_8ios_base7seekdirEj, __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj: __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE8__appendEj, __ZN13ProbeRendererC2EP13RenderTextureS1_b: __ZN13ProbeRendererC2EP13RenderTextureS1_b, __ZN9Rigidbody10DeactivateE19DeactivateOperation: __ZN9Rigidbody10DeactivateE19DeactivateOperation, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEcj, __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_: __Z23b2CollideEdgeAndPolygonP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS6_, __ZN20SphericalHarmonicsL2pLERKS_: __ZN20SphericalHarmonicsL2pLERKS_, __ZZN12MeshRenderer15InitializeClassEvEN29FunctorImpl_100kDidModifyMesh4CallEPviR11MessageData: __ZZN12MeshRenderer15InitializeClassEvEN29FunctorImpl_100kDidModifyMesh4CallEPviR11MessageData, _PxInitExtensions: _PxInitExtensions, __Z47Register_UnityEngine_Shader_get_disableBatchingv: __Z47Register_UnityEngine_Shader_get_disableBatchingv, __ZNK5physx27PxVehicleDifferentialNWData16getIsDrivenWheelEj: __ZNK5physx27PxVehicleDifferentialNWData16getIsDrivenWheelEj, __ZN14CompressedMeshC2Ev: __ZN14CompressedMeshC2Ev, __ZN14CompletionTaskC2Ev: __ZN14CompletionTaskC2Ev, __ZN26AnimatorControllerPlayable12ResetTriggerEi: __ZN26AnimatorControllerPlayable12ResetTriggerEi, __ZN22RenderingCommandBuffer18AddSetGlobalVectorERKN9ShaderLab16FastPropertyNameERK8Vector4f: __ZN22RenderingCommandBuffer18AddSetGlobalVectorERKN9ShaderLab16FastPropertyNameERK8Vector4f, __ZNK13WheelCollider16SupportsMaterialEv: __ZNK13WheelCollider16SupportsMaterialEv, __ZN8LODGroup21SetAnimateCrossFadingEb: __ZN8LODGroup21SetAnimateCrossFadingEb, __Z36Register_UnityEngine_Mesh_ResizeListv: __Z36Register_UnityEngine_Mesh_ResizeListv, __ZNKSt3__28ios_base6getlocEv: __ZNKSt3__28ios_base6getlocEv, __ZN9TextAsset18SetScriptDontDirtyERK8UnityStr: __ZN9TextAsset18SetScriptDontDirtyERK8UnityStr, __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo: __ZN18VertexChannelsInfoC2ERA8_K11ChannelInfo, __ZN5physx6shdfnd4sortIPKNS_24PxsIndexedContactManagerENS_25ArticulationSortPredicateENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPKNS_24PxsIndexedContactManagerENS_25ArticulationSortPredicateENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j, __ZN10UnityScene14AddRootToSceneERS_R9Transform: __ZN10UnityScene14AddRootToSceneERS_R9Transform, __ZN14RenderSettingsD2Ev: __ZN14RenderSettingsD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii: __ZN19SpriteMeshGenerator4path3fitERNSt3__26vectorIiNS1_9allocatorIiEEEEii, __ZN6Object8TransferI17RemapPPtrTransferEEvRT_: __ZN6Object8TransferI17RemapPPtrTransferEEvRT_, __Z18Transfer_BlittableI9JSONWriteLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z31ComputeBuffer_CUSTOM_InitBufferP12Il2CppObjectiij: __Z31ComputeBuffer_CUSTOM_InitBufferP12Il2CppObjectiij, _acct: _acct, __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE9getShapesEPPNS_7PxShapeEjj: __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE9getShapesEPPNS_7PxShapeEjj, __Z44getPxVehicleAckermannGeometryDataMFrontWidthPKN5physx30PxVehicleAckermannGeometryDataE: __Z44getPxVehicleAckermannGeometryDataMFrontWidthPKN5physx30PxVehicleAckermannGeometryDataE, _cargf: _cargf, _getservbyport_r: _getservbyport_r, __ZN19ScriptingInvocationC2EP11Il2CppClassPKc: __ZN19ScriptingInvocationC2EP11Il2CppClassPKc, __ZN4crnd9crnd_freeEPv: __ZN4crnd9crnd_freeEPv, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetYv, __ZN9Texture3D19AllocateTextureDataEi13TextureFormatb: __ZN9Texture3D19AllocateTextureDataEi13TextureFormatb, __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf: __ZL35stbir__resample_horizontal_upsampleP11stbir__infoiPf, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED0Ev: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED0Ev, __ZNSt3__26__sortIRNS_6__lessIhhEEPhEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIhhEEPhEEvT0_S5_T_, __ZN18DelayedCallManager20CancelAllCallDelayedE4PPtrI6ObjectE: __ZN18DelayedCallManager20CancelAllCallDelayedE4PPtrI6ObjectE, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEED0Ev, __ZN9Texture2D10ReadPixelsEiiiiiiibb: __ZN9Texture2D10ReadPixelsEiiiiiiibb, __ZNK10Effector2D18GetActiveCollidersER13dynamic_arrayIP10Collider2DLj4EE: __ZNK10Effector2D18GetActiveCollidersER13dynamic_arrayIP10Collider2DLj4EE, __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED2Ev, __ZN5physx3Cct17CapsuleController6resizeEf: __ZN5physx3Cct17CapsuleController6resizeEf, __Z47BuoyancyEffector2D_Get_Custom_PropFlowVariationP12Il2CppObject: __Z47BuoyancyEffector2D_Get_Custom_PropFlowVariationP12Il2CppObject, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx24PxSceneDescGeneratedInfoC2Ev: __ZN5physx24PxSceneDescGeneratedInfoC2Ev, __ZN11UnityEngine15PlatformWrapper24GetProcessorFrequencyMHzEv: __ZN11UnityEngine15PlatformWrapper24GetProcessorFrequencyMHzEv, __ZNK5physx27PxClothGeodesicTetherCooker13getTetherDataEPjPf: __ZNK5physx27PxClothGeodesicTetherCooker13getTetherDataEPjPf, __Z44SystemInfo_Get_Custom_PropGraphicsMemorySizev: __Z44SystemInfo_Get_Custom_PropGraphicsMemorySizev, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI19StreamedBinaryWriteILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI19StreamedBinaryWriteILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z22AddCurveToStreamedClipIfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E: __Z22AddCurveToStreamedClipIfEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E, _tolower_l: _tolower_l, __ZN6Skybox8SetupSunERK6CameraR9GfxDevice: __ZN6Skybox8SetupSunERK6CameraR9GfxDevice, __ZN12_GLOBAL__N_123FStreamNetworkOutStream18getWrittenDataSizeEv: __ZN12_GLOBAL__N_123FStreamNetworkOutStream18getWrittenDataSizeEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj686ES3_RKNS_27PxVehicleDifferentialNWDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj686ES3_RKNS_27PxVehicleDifferentialNWDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z31Light_Get_Custom_PropRenderModeP12Il2CppObject: __Z31Light_Get_Custom_PropRenderModeP12Il2CppObject, __ZN13GfxDeviceGLES11SetTexturesE10ShaderTypeiPK15GfxTextureParam: __ZN13GfxDeviceGLES11SetTexturesE10ShaderTypeiPK15GfxTextureParam, __ZN13GfxDeviceGLES12DeleteBufferEP9GfxBuffer: __ZN13GfxDeviceGLES12DeleteBufferEP9GfxBuffer, __ZN5physx7NpCloth18setDragCoefficientEf: __ZN5physx7NpCloth18setDragCoefficientEf, __Z31Sprite_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE: __Z31Sprite_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE, __ZN5physx12InlineBufferIjLj4096EE4freeEv: __ZN5physx12InlineBufferIjLj4096EE4freeEv, __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb0EEEEvRT_, _fill_fopen_filefunc: _fill_fopen_filefunc, __Z14dictDeleteDictP9TESSallocP4Dict: __Z14dictDeleteDictP9TESSallocP4Dict, __Z25Shader_CUSTOM_FindBuiltinP12Il2CppString: __Z25Shader_CUSTOM_FindBuiltinP12Il2CppString, __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeP11Il2CppArray: __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeP11Il2CppArray, __ZN11b2GearJoint23InitVelocityConstraintsERK12b2SolverData: __ZN11b2GearJoint23InitVelocityConstraintsERK12b2SolverData, __Z60Register_UnityEngine_Transform_INTERNAL_CALL_TransformVectorv: __Z60Register_UnityEngine_Transform_INTERNAL_CALL_TransformVectorv, __ZNK10EnumTraits14ReflectionInfo15GetNameForValueEi: __ZNK10EnumTraits14ReflectionInfo15GetNameForValueEi, __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE: __ZN5physx6shdfnd9SListImpl4pushEPNS0_10SListEntryE, __ZN22RenderingCommandBuffer18AddSetRenderTargetEiPK18RenderTextureParamRS1_i11CubemapFacei: __ZN22RenderingCommandBuffer18AddSetRenderTargetEiPK18RenderTextureParamRS1_i11CubemapFacei, __ZNSt3__26chrono12system_clock9to_time_tERKNS0_10time_pointIS1_NS0_8durationIxNS_5ratioILx1ELx1000000EEEEEEE: __ZNSt3__26chrono12system_clock9to_time_tERKNS0_10time_pointIS1_NS0_8durationIxNS_5ratioILx1ELx1000000EEEEEEE, _UNITY_png_check_fp_number: _UNITY_png_check_fp_number, __ZN10TagManager13LayerToStringEj: __ZN10TagManager13LayerToStringEj, __ZN12BaseRendererC2E12RendererType: __ZN12BaseRendererC2E12RendererType, __Z54Register_UnityEngine_RenderBufferHelper_GetStoreActionv: __Z54Register_UnityEngine_RenderBufferHelper_GetStoreActionv, __ZN12TreeDatabase17RefreshPrototypesEv: __ZN12TreeDatabase17RefreshPrototypesEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES7_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7crbeginEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7crbeginEv, __ZN5physx24PxsParticleSystemBatcher19scheduleDynamicsCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE: __ZN5physx24PxsParticleSystemBatcher19scheduleDynamicsCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE, __ZN18ProceduralMaterial7SetSizeEii: __ZN18ProceduralMaterial7SetSizeEii, __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader: __ZThn128_N39AssetBundleLoadFromStreamAsyncOperation35OnArchiveStorageBlocksInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader, __Z24setPxJoint_InvMassScale0PN5physx7PxJointEf: __Z24setPxJoint_InvMassScale0PN5physx7PxJointEf, __ZN20ArchiveStorageHeader17GetBlocksInfoSizeERKNS_10BlocksInfoE: __ZN20ArchiveStorageHeader17GetBlocksInfoSizeERKNS_10BlocksInfoE, __ZN13ComputeShader21DispatchComputeShaderEjiii: __ZN13ComputeShader21DispatchComputeShaderEjiii, __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMConvexVsHeightfieldContactGenerationCallbackEE7onEventEjPj: __ZN5physx2Gu39PCMHeightfieldContactGenerationCallbackINS_47PCMConvexVsHeightfieldContactGenerationCallbackEE7onEventEjPj, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sc15ContactIterator4PairC2ERPKvjRPKfjRNS0_8ShapeSimESA_: __ZN5physx2Sc15ContactIterator4PairC2ERPKvjRPKfjRNS0_8ShapeSimESA_, __ZN5physx14NpArticulation12applyImpulseEPNS_18PxArticulationLinkERKNS_24PxArticulationDriveCacheERKNS_6PxVec3ES8_: __ZN5physx14NpArticulation12applyImpulseEPNS_18PxArticulationLinkERKNS_24PxArticulationDriveCacheERKNS_6PxVec3ES8_, __ZN5physx9NpFactory24releaseRigidStaticToPoolERNS_13NpRigidStaticE: __ZN5physx9NpFactory24releaseRigidStaticToPoolERNS_13NpRigidStaticE, __ZN5physx2Sc10NPhaseCore30createElementInteractionMarkerERNS0_10ElementSimES3_: __ZN5physx2Sc10NPhaseCore30createElementInteractionMarkerERNS0_10ElementSimES3_, _UNITY_tt_size_reset: _UNITY_tt_size_reset, __ZN4Mesh15UnshareMeshDataEv: __ZN4Mesh15UnshareMeshDataEv, __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj32ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE: __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj32ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE, __Z54ParticleAnimator_CUSTOM_INTERNAL_get_worldRotationAxisP12Il2CppObjectP8Vector3f: __Z54ParticleAnimator_CUSTOM_INTERNAL_get_worldRotationAxisP12Il2CppObjectP8Vector3f, __ZN13RenderTexture12GenerateMipsEv: __ZN13RenderTexture12GenerateMipsEv, __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody: __ZN8Collider14FinalizeCreateERN5physx10PxGeometryEPK9Rigidbody, __ZN8Collider14WordsToPointerEjj: __ZN8Collider14WordsToPointerEjj, __Z37Cursor_CUSTOM_INTERNAL_CALL_SetCursorP12Il2CppObjectRK13Vector2fIcall10CursorMode: __Z37Cursor_CUSTOM_INTERNAL_CALL_SetCursorP12Il2CppObjectRK13Vector2fIcall10CursorMode, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl20getOrCreateClassImplERKN5physx8debugger14NamespacedNameEi, __ZN21ParticleSystemManagerC2Ev: __ZN21ParticleSystemManagerC2Ev, __Z61Register_UnityEngine_Texture2D_LoadRawTextureData_ImplPointerv: __Z61Register_UnityEngine_Texture2D_LoadRawTextureData_ImplPointerv, __Z33Material_Get_Custom_PropPassCountP12Il2CppObject: __Z33Material_Get_Custom_PropPassCountP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj469ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj469ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11OffMeshLink10SmartResetEv: __ZN11OffMeshLink10SmartResetEv, __ZNK5physx3Ext20DefaultCpuDispatcher14getRunProfiledEv: __ZNK5physx3Ext20DefaultCpuDispatcher14getRunProfiledEv, __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE16StaticInitializeEPv, __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI9Texture2DEPT_17AwakeFromLoadMode10MemLabelId, __Z65Register_UnityEngine_CharacterController_INTERNAL_CALL_SimpleMovev: __Z65Register_UnityEngine_CharacterController_INTERNAL_CALL_SimpleMovev, __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE7destroyEPNS_11__tree_nodeISC_PvEE, __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture: __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexture, __ZN14Texture2DArray8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14Texture2DArray8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN29AudioEffectInternalDefinitionD2Ev: __ZN29AudioEffectInternalDefinitionD2Ev, __Z18sweepBox_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z18sweepBox_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetEnabledv: __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetEnabledv, __Z28setPxParticleFluid_ViscosityPN5physx15PxParticleFluidEf: __Z28setPxParticleFluid_ViscosityPN5physx15PxParticleFluidEf, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEE, _PxRegisterParticles: _PxRegisterParticles, __ZThn8_N5physx2Sc21ElementSimInteractionD1Ev: __ZThn8_N5physx2Sc21ElementSimInteractionD1Ev, __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI27AnimatorControllerParameterNS_9allocatorIS1_EEE7reserveEj, __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E: __ZN5physx2Sc8BodyCore13onOriginShiftERKNS_6PxVec3E, __ZNSt3__28__sp_mut4lockEv: __ZNSt3__28__sp_mut4lockEv, __Z37Light_Set_Custom_PropShadowResolutionP12Il2CppObjecti: __Z37Light_Set_Custom_PropShadowResolutionP12Il2CppObjecti, __ZN19SkinnedMeshRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN19SkinnedMeshRenderer8TransferI14SafeBinaryReadEEvRT_, __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsStringERK8UnityStrS3_: __ZN11UnityEngine15PlatformWrapper20SetPlayerPrefsStringERK8UnityStrS3_, __ZNK5physx19PxVehicleEngineData7isValidEv: __ZNK5physx19PxVehicleEngineData7isValidEv, __ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj: __ZNK5physx22PxVehicleWheelsSimData18getIsWheelDisabledEj, __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEj: __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEj, __Z20CreateObjectFromCodeI18ProceduralMaterialEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI18ProceduralMaterialEPT_17AwakeFromLoadMode10MemLabelId, __Z51Register_UnityEngine_Graphics_Internal_BlitMultiTapv: __Z51Register_UnityEngine_Graphics_Internal_BlitMultiTapv, _UNITY_ft_module_get_service: _UNITY_ft_module_get_service, __ZN4FMOD7Channel15set3DAttributesEPK11FMOD_VECTORS3_: __ZN4FMOD7Channel15set3DAttributesEPK11FMOD_VECTORS3_, __ZN16Physics2DManager8LinecastERK8Vector2fS2_iffPK10Collider2DbP12RaycastHit2Di: __ZN16Physics2DManager8LinecastERK8Vector2fS2_iffPK10Collider2DbP12RaycastHit2Di, __Z37SystemInfo_Get_Custom_PropNpotSupportv: __Z37SystemInfo_Get_Custom_PropNpotSupportv, __Z18CleanupBatchDeletev: __Z18CleanupBatchDeletev, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEce, __ZN5physx16NpParticleSystem15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx16NpParticleSystem15exportExtraDataERNS_22PxSerializationContextE, __ZN11AudioSource12ApplyFiltersEv: __ZN11AudioSource12ApplyFiltersEv, __Z48getPxVehicleWheelsSimData_MinLongSlipDenominatorPKN5physx22PxVehicleWheelsSimDataE: __Z48getPxVehicleWheelsSimData_MinLongSlipDenominatorPKN5physx22PxVehicleWheelsSimDataE, __ZN5IMGUI9GUIWindow5OnGUIER8GUIState: __ZN5IMGUI9GUIWindow5OnGUIER8GUIState, __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_112PropDescImplEED0Ev: __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_112PropDescImplEED0Ev, __Z38NavMesh_CUSTOM_GetNavMeshLayerFromNameP12Il2CppString: __Z38NavMesh_CUSTOM_GetNavMeshLayerFromNameP12Il2CppString, __ZN17MeshRenderingData7ReleaseEv: __ZN17MeshRenderingData7ReleaseEv, __Z13RegisterClassI11BoxColliderEvv: __Z13RegisterClassI11BoxColliderEvv, __ZN5Umbra9BitVector3_orERKS0_: __ZN5Umbra9BitVector3_orERKS0_, __Z37HumanTrait_CUSTOM_GetMuscleDefaultMaxi: __Z37HumanTrait_CUSTOM_GetMuscleDefaultMaxi, __ZN10systeminfo18GetRuntimePlatformEv: __ZN10systeminfo18GetRuntimePlatformEv, __Z38AudioClip_Get_Custom_PropIsReadyToPlayP12Il2CppObject: __Z38AudioClip_Get_Custom_PropIsReadyToPlayP12Il2CppObject, __Z50Register_UnityEngine_AudioSource_set_reverbZoneMixv: __Z50Register_UnityEngine_AudioSource_set_reverbZoneMixv, __ZNKSt3__220__time_get_c_storageIwE3__XEv: __ZNKSt3__220__time_get_c_storageIwE3__XEv, __Z51ParticleEmitter_Get_Custom_PropEmitterVelocityScaleP12Il2CppObject: __Z51ParticleEmitter_Get_Custom_PropEmitterVelocityScaleP12Il2CppObject, __ZN5physx2Sc8ShapeSim16onGeometryChangeEv: __ZN5physx2Sc8ShapeSim16onGeometryChangeEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN8GUILayer14RenderGUILayerE5RectTIfEjR17ShaderPassContext: __ZN8GUILayer14RenderGUILayerE5RectTIfEjR17ShaderPassContext, __ZN5physx20PxsParticleSystemSimD2Ev: __ZN5physx20PxsParticleSystemSimD2Ev, __ZN16Physics2DManager28RemoveJointBreakLimitUpdatesEP7Joint2D: __ZN16Physics2DManager28RemoveJointBreakLimitUpdatesEP7Joint2D, ___shlim: ___shlim, __ZN10Effector2D19RecalculateContactsEv: __ZN10Effector2D19RecalculateContactsEv, __ZN18ProfilerConnection21EnableProfilerMessageEPKvjj: __ZN18ProfilerConnection21EnableProfilerMessageEPKvjj, __ZN5physx5cloth5arrayERKNS_6PxVec3E: __ZN5physx5cloth5arrayERKNS_6PxVec3E, __ZN21SystemInfoStringCache13StaticDestroyEPv: __ZN21SystemInfoStringCache13StaticDestroyEPv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN10AudioMixer16CheckConsistencyEv: __ZN10AudioMixer16CheckConsistencyEv, __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcNS_14PxProfileNamesEj: __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcNS_14PxProfileNamesEj, __ZN5physx14SapPairManagerC2Ev: __ZN5physx14SapPairManagerC2Ev, __Z36Mesh_CUSTOM_PrintErrorCantAccessMeshP12Il2CppObject30InternalScriptingShaderChannel: __Z36Mesh_CUSTOM_PrintErrorCantAccessMeshP12Il2CppObject30InternalScriptingShaderChannel, __ZN23ForwardShaderRenderLoop17PrepareShadowMapsEPK11ActiveLightRK11CullResults: __ZN23ForwardShaderRenderLoop17PrepareShadowMapsEPK11ActiveLightRK11CullResults, __Z7FNVHashPKc: __Z7FNVHashPKc, __ZN9UdpSocketD0Ev: __ZN9UdpSocketD0Ev, __ZN19CloudServiceHandler22ResetNetworkRetryIndexEv: __ZN19CloudServiceHandler22ResetNetworkRetryIndexEv, __ZNK12NavMeshAgent16GetInternalAgentEv: __ZNK12NavMeshAgent16GetInternalAgentEv, __ZN5physx21computeIsAccelAppliedEPKfPb: __ZN5physx21computeIsAccelAppliedEPKfPb, __ZN14AvatarPlayback11RecordFrameEfPKN7mecanim9animation12AvatarMemoryEPNS1_16ControllerMemoryE: __ZN14AvatarPlayback11RecordFrameEfPKN7mecanim9animation12AvatarMemoryEPNS1_16ControllerMemoryE, __ZNSt3__26localeC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__26localeC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN9CGProgramD0Ev: __ZN9CGProgramD0Ev, __ZNK9ShaderLab7Program40EnsureCompiledAndMarkUnsupportedIfFailedEPKNS_10SubProgramERK16ShaderKeywordSetPS4_R19ShaderSnippetResult: __ZNK9ShaderLab7Program40EnsureCompiledAndMarkUnsupportedIfFailedEPKNS_10SubProgramERK16ShaderKeywordSetPS4_R19ShaderSnippetResult, __ZNSt3__28ios_base33__set_badbit_and_consider_rethrowEv: __ZNSt3__28ios_base33__set_badbit_and_consider_rethrowEv, __Z53Register_UnityEngine_RenderSettings_GetRenderSettingsv: __Z53Register_UnityEngine_RenderSettings_GetRenderSettingsv, __ZN4FMOD6System19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS: __ZN4FMOD6System19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS, __ZN4FMOD5Sound12addSyncPointEjjPKcPP14FMOD_SYNCPOINT: __ZN4FMOD5Sound12addSyncPointEjjPKcPP14FMOD_SYNCPOINT, _isblank: _isblank, __Z48Screen_Set_Custom_PropAutorotateToLandscapeRighth: __Z48Screen_Set_Custom_PropAutorotateToLandscapeRighth, __ZN9BlobWrite8TransferIN7mecanim9animation14AvatarConstantEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim9animation14AvatarConstantEEEvRT_PKc17TransferMetaFlags, __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE5writeEPKvj: __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE5writeEPKvj, __ZN17SizeBySpeedModuleD2Ev: __ZN17SizeBySpeedModuleD2Ev, __ZN14VRSplashScreen22StopTrackingLossSplashEv: __ZN14VRSplashScreen22StopTrackingLossSplashEv, __ZN10HumanTrait10LeftFinger13GetMuscleNameEi: __ZN10HumanTrait10LeftFinger13GetMuscleNameEi, _memcpy: _memcpy, __ZN17BillboardRendererD2Ev: __ZN17BillboardRendererD2Ev, __ZN12_GLOBAL__N_119RendererEventClientD2Ev: __ZN12_GLOBAL__N_119RendererEventClientD2Ev, __ZN10SampleClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10SampleClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _malloc_footprint_limit: _malloc_footprint_limit, _UNITY_png_set_tRNS: _UNITY_png_set_tRNS, __ZN7GUIClipC2ERK5RectTIfES3_RK8Vector2fS6_S6_: __ZN7GUIClipC2ERK5RectTIfES3_RK8Vector2fS6_S6_, __Z52Register_UnityEngine_AnimationClip_GetEventsInternalv: __Z52Register_UnityEngine_AnimationClip_GetEventsInternalv, __Z43Rigidbody_Get_Custom_PropMaxAngularVelocityP12Il2CppObject: __Z43Rigidbody_Get_Custom_PropMaxAngularVelocityP12Il2CppObject, __ZN18GlslGpuProgramGLES25LoadFromBinaryShaderCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER14ChannelAssignsPKc: __ZN18GlslGpuProgramGLES25LoadFromBinaryShaderCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER14ChannelAssignsPKc, __ZN19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN25TransformFeedbackSkinning8SkinMeshERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb: __ZN25TransformFeedbackSkinning8SkinMeshERK18VertexStreamSourceP9GfxBufferP17GPUSkinPoseBufferS4_iijb, __ZN18LoadSceneOperation19IntegrateMainThreadEv: __ZN18LoadSceneOperation19IntegrateMainThreadEv, __ZN9Rigidbody5ResetEv: __ZN9Rigidbody5ResetEv, __ZN24OcclusionCullingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN24OcclusionCullingSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN16b2CapsuleContactC2EP9b2FixtureS1_: __ZN16b2CapsuleContactC2EP9b2FixtureS1_, __ZN11TrailModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11TrailModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN17CapsuleCollider2D10SmartResetEv: __ZN17CapsuleCollider2D10SmartResetEv, __ZNK2UI13RectTransform13GetWorldSpaceER8Vector3fR8Vector2f: __ZNK2UI13RectTransform13GetWorldSpaceER8Vector3fR8Vector2f, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE12readPropertyIfEEbRT_, __ZNK5physx7NpCloth25getAngularDragCoefficientEv: __ZNK5physx7NpCloth25getAngularDragCoefficientEv, __ZN9Heightmap16GetPxHeightFieldEv: __ZN9Heightmap16GetPxHeightFieldEv, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj, __ZN12_GLOBAL__N_117ConnectionManager13connectAddRefEPN5physx8debugger18PvdNetworkInStreamERNS2_19PvdNetworkOutStreamENS1_7PxFlagsINS2_17PvdConnectionType4EnumEjEEb: __ZN12_GLOBAL__N_117ConnectionManager13connectAddRefEPN5physx8debugger18PvdNetworkInStreamERNS2_19PvdNetworkOutStreamENS1_7PxFlagsINS2_17PvdConnectionType4EnumEjEEb, __Z65ParticleSystem_CollisionModule_CUSTOM_SetEnableInteriorCollisionsP12Il2CppObjecth: __Z65ParticleSystem_CollisionModule_CUSTOM_SetEnableInteriorCollisionsP12Il2CppObjecth, __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN22ParticleSystemRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN20GlobalCachingManager16ReadCacheIndicesERNSt3__26vectorIP5CacheNS0_9allocatorIS3_EEEEb: __ZN20GlobalCachingManager16ReadCacheIndicesERNSt3__26vectorIP5CacheNS0_9allocatorIS3_EEEEb, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z31Camera_Get_Custom_PropEventMaskP12Il2CppObject: __Z31Camera_Get_Custom_PropEventMaskP12Il2CppObject, __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi: __ZN19ConstantBuffersGLES13SetCBConstantEiiPKvi, __ZN9Texture3D15ThreadedCleanupEv: __ZN9Texture3D15ThreadedCleanupEv, __ZN13BoxCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13BoxCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN17MemoryCacheReaderD2Ev: __ZN17MemoryCacheReaderD2Ev, __Z12OptionalTypePKcS0_S0_: __Z12OptionalTypePKcS0_S0_, __ZNSt3__212system_errorD2Ev: __ZNSt3__212system_errorD2Ev, __Z20RequiredComponentsOfP13MonoBehaviour: __Z20RequiredComponentsOfP13MonoBehaviour, __ZN7mecanim9animation22MotionOutputBlendBeginEPNS0_12MotionOutputEbb: __ZN7mecanim9animation22MotionOutputBlendBeginEPNS0_12MotionOutputEbb, __ZN19TouchPhaseEmulation18PostprocessTouchesEv: __ZN19TouchPhaseEmulation18PostprocessTouchesEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj663ES3_RKNS_19PxVehicleEngineDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj663ES3_RKNS_19PxVehicleEngineDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9JSONWrite8TransferIaEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIaEEvRT_PKc17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z36UploadHandler_CUSTOM_InternalDestroyP12Il2CppObject: __Z36UploadHandler_CUSTOM_InternalDestroyP12Il2CppObject, __ZN17BillboardRenderer15ThreadedCleanupEv: __ZN17BillboardRenderer15ThreadedCleanupEv, __ZN9Rigidbody15ThreadedCleanupEv: __ZN9Rigidbody15ThreadedCleanupEv, __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix1v: __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix1v, __Z19SendMessageInternalPKcS0_P12Il2CppObject: __Z19SendMessageInternalPKcS0_P12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx5cloth11SwCollisionI8Scalar4fE13computeBoundsEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE13computeBoundsEv, __ZNK5physx22PxDefaultFileInputData4tellEv: __ZNK5physx22PxDefaultFileInputData4tellEv, __ZN16BaseVideoTexture17UploadToGfxDeviceEv: __ZN16BaseVideoTexture17UploadToGfxDeviceEv, _read_markers: _read_markers, __ZNK14DetailDatabase12IsPatchEmptyEii: __ZNK14DetailDatabase12IsPatchEmptyEii, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7getTypeEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE7getTypeEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj620ES2_KjiEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z44AudioSource_Get_Custom_PropBypassReverbZonesP12Il2CppObject: __Z44AudioSource_Get_Custom_PropBypassReverbZonesP12Il2CppObject, __Z57Register_UnityEngine_AudioListener_get_velocityUpdateModev: __Z57Register_UnityEngine_AudioListener_get_velocityUpdateModev, __Z36GiveDebuggerChanceToAttachIfRequiredv: __Z36GiveDebuggerChanceToAttachIfRequiredv, __ZN13IDecompressorD2Ev: __ZN13IDecompressorD2Ev, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_BillboardAsset_set_heightv: __Z46Register_UnityEngine_BillboardAsset_set_heightv, __ZNK13ScreenManager13GetLockCursorEv: __ZNK13ScreenManager13GetLockCursorEv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj10EEERAT__Kc, __ZN11Rigidbody2D24InformCollidersOfNewBodyEv: __ZN11Rigidbody2D24InformCollidersOfNewBodyEv, __ZN5physx3Scb4Body14setWakeCounterEf: __ZN5physx3Scb4Body14setWakeCounterEf, __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN11UnityEngine7Connect15DeviceInfoEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine7Connect15DeviceInfoEvent12ToJsonStringER9JSONWrite, __Z46Physics2D_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK13Vector2fIcallS1_fS1_P11Il2CppArrayfiff: __Z46Physics2D_CUSTOM_INTERNAL_CALL_BoxCastNonAllocRK13Vector2fIcallS1_fS1_P11Il2CppArrayfiff, __Z29setPxHeightFieldDescNbColumnsPN5physx17PxHeightFieldDescEj: __Z29setPxHeightFieldDescNbColumnsPN5physx17PxHeightFieldDescEj, _jinit_compress_master: _jinit_compress_master, __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetAngularVelocityv: __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetAngularVelocityv, __ZN21BillboardBatchManagerD2Ev: __ZN21BillboardBatchManagerD2Ev, __ZN5physx27InternalTriangleMeshBuilder20createSharedEdgeDataEbb: __ZN5physx27InternalTriangleMeshBuilder20createSharedEdgeDataEbb, __Z34getPxSceneLimitsMaxNbDynamicShapesPKN5physx13PxSceneLimitsE: __Z34getPxSceneLimitsMaxNbDynamicShapesPKN5physx13PxSceneLimitsE, __ZN9LensFlare12AddToManagerEv: __ZN9LensFlare12AddToManagerEv, __Z95Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParameterCountInternalv: __Z95Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParameterCountInternalv, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetXMultiplierv, __Z56Register_UnityEngine_RelativeJoint2D_get_correctionScalev: __Z56Register_UnityEngine_RelativeJoint2D_get_correctionScalev, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEEEEjT_j, __Z12CancelInvokeR13MonoBehaviour: __Z12CancelInvokeR13MonoBehaviour, __Z20SkeletonBoneFromMonoRK16MonoSkeletonBoneR12SkeletonBone: __Z20SkeletonBoneFromMonoRK16MonoSkeletonBoneR12SkeletonBone, __ZN16LightmapSettings7RebuildEv: __ZN16LightmapSettings7RebuildEv, _lrand48: _lrand48, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN2UI11CanvasGroup13AwakeFromLoadE17AwakeFromLoadMode: __ZN2UI11CanvasGroup13AwakeFromLoadE17AwakeFromLoadMode, __ZN8WindZone8TransferI14SafeBinaryReadEEvRT_: __ZN8WindZone8TransferI14SafeBinaryReadEEvRT_, __ZN5Cache15UpdateTimestampERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEl: __ZN5Cache15UpdateTimestampERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEl, __ZN12_GLOBAL__N_110DataStream23endPropertyMessageGroupEv: __ZN12_GLOBAL__N_110DataStream23endPropertyMessageGroupEv, __ZNK13GfxDeviceNull27GetActiveRenderDepthSurfaceEv: __ZNK13GfxDeviceNull27GetActiveRenderDepthSurfaceEv, __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Renderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx14PxsAABBManager28setAggregateElemVolumeBoundsEjRKNS_11IntegerAABBE: __ZN5physx14PxsAABBManager28setAggregateElemVolumeBoundsEjRKNS_11IntegerAABBE, __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetCycleCountP12Il2CppObject: __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetCycleCountP12Il2CppObject, __Z70Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesWithVariantv: __Z70Register_UnityEngine_AssetBundleManifest_GetAllAssetBundlesWithVariantv, __Z42Register_UnityEngine_Display_SetParamsImplv: __Z42Register_UnityEngine_Display_SetParamsImplv, __ZNKSt3__215__codecvt_utf16IwLb1EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IwLb1EE9do_lengthER11__mbstate_tPKcS5_j, __ZN18AwakeFromLoadQueue19DetermineQueueIndexEPKN5Unity4TypeER6Object: __ZN18AwakeFromLoadQueue19DetermineQueueIndexEPKN5Unity4TypeER6Object, __ZN5physx6shdfnd8internal11HashMapBaseINS0_4PairIjjEEN12_GLOBAL__N_14EdgeENS0_4HashIS4_EENS0_9AllocatorEEixERKS4_: __ZN5physx6shdfnd8internal11HashMapBaseINS0_4PairIjjEEN12_GLOBAL__N_14EdgeENS0_4HashIS4_EENS0_9AllocatorEEixERKS4_, __ZN11BoxCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f: __ZN11BoxCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f, __ZN4FMOD7SystemI17setNetworkTimeoutEi: __ZN4FMOD7SystemI17setNetworkTimeoutEi, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags, __ZNK17SurfaceEffector2D16UseContactUpdateEv: __ZNK17SurfaceEffector2D16UseContactUpdateEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN12TreeDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12TreeDatabase8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN4FMOD7SystemI9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE: __ZN4FMOD7SystemI9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE, __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj: __ZN25MultiBlocksMemoryFileDataC2E10MemLabelIdj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS4_, __ZN9Texture3D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Texture3D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN18ProceduralMaterial27SetProceduralProcessorUsageE24ProceduralProcessorUsage: __ZN18ProceduralMaterial27SetProceduralProcessorUsageE24ProceduralProcessorUsage, __ZN5physx18NpArticulationLink9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx18NpArticulationLink9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __ZNK12HingeJoint2D14GetMotorTorqueEf: __ZNK12HingeJoint2D14GetMotorTorqueEf, __ZN5physx3Cct8SweptBoxD0Ev: __ZN5physx3Cct8SweptBoxD0Ev, __Z46Register_UnityEngine_GL_INTERNAL_CALL_TexCoordv: __Z46Register_UnityEngine_GL_INTERNAL_CALL_TexCoordv, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23setIjNS1_4lessIjEENS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23setIjNS1_4lessIjEENS1_9allocatorIjEEEEEEvRT_17TransferMetaFlags, __Z43Register_UnityEngine_Debug_get_isDebugBuildv: __Z43Register_UnityEngine_Debug_get_isDebugBuildv, __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE: __ZL43ReadHeaderAndBlocksInfo_UnityWebAndUnityRawR12FileAccessorRN20ArchiveStorageHeader6HeaderERNS1_10BlocksInfoE, __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl7IntRectE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl7IntRectE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN5Umbra15SystemAllocator8allocateEjPKc: __ZN5Umbra15SystemAllocator8allocateEjPKc, __Z40NavMeshObstacle_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f: __Z40NavMeshObstacle_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f, __ZN14BillboardAsset17MainThreadCleanupEv: __ZN14BillboardAsset17MainThreadCleanupEv, __Z47Register_UnityEngine_AnimationClip_set_wrapModev: __Z47Register_UnityEngine_AnimationClip_set_wrapModev, __ZN13AnimationClip7SetNameEPKc: __ZN13AnimationClip7SetNameEPKc, __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_worldVelocityv: __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_worldVelocityv, __ZN16MemoryFileSystem4ReadER13FileEntryDatayPvPy: __ZN16MemoryFileSystem4ReadER13FileEntryDatayPvPy, __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace: __ZNK13TranslateGLES9GetFormatE19RenderTextureFormat17TextureColorSpace, __Z17UpdateSteeringJobP9CrowdInfoj: __Z17UpdateSteeringJobP9CrowdInfoj, __Z38Canvas_Get_Custom_PropSortingLayerNameP12Il2CppObject: __Z38Canvas_Get_Custom_PropSortingLayerNameP12Il2CppObject, __ZN12InputManager11SetKeyStateEib: __ZN12InputManager11SetKeyStateEib, __Z47AnimatorControllerPlayable_CUSTOM_GetBoolStringR9HPlayableP12Il2CppString: __Z47AnimatorControllerPlayable_CUSTOM_GetBoolStringR9HPlayableP12Il2CppString, __Z22b2DistanceBetweenLinesP6b2Vec2S0_RKS_S2_S2_S2_: __Z22b2DistanceBetweenLinesP6b2Vec2S0_RKS_S2_S2_S2_, __Z50setPxSimulationStatisticsParticlesGpuMeshCacheSizePN5physx22PxSimulationStatisticsEj: __Z50setPxSimulationStatisticsParticlesGpuMeshCacheSizePN5physx22PxSimulationStatisticsEj, __ZN5physx7NpScene7setFlagENS_11PxSceneFlag4EnumEb: __ZN5physx7NpScene7setFlagENS_11PxSceneFlag4EnumEb, __ZNSt3__2L10__init_patIcEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_: __ZNSt3__2L10__init_patIcEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_, __Z26Transfer_UnityEngineObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18ExpandVector3CurveR17AnimationCurveTplI8Vector3fEPPS_IfE: __Z18ExpandVector3CurveR17AnimationCurveTplI8Vector3fEPPS_IfE, __ZN5physx31PxClothGeodesicTetherCookerImpl23computeGeodesicDistanceEjjRi: __ZN5physx31PxClothGeodesicTetherCookerImpl23computeGeodesicDistanceEjjRi, __Z43Register_UnityEngine_AI_NavMesh_Triangulatev: __Z43Register_UnityEngine_AI_NavMesh_Triangulatev, __ZN15ArchiveReadFile4ReadEyyPvPy: __ZN15ArchiveReadFile4ReadEyyPvPy, __ZNK5physx2Gu11HeightField17getTriangleNormalEj: __ZNK5physx2Gu11HeightField17getTriangleNormalEj, __ZN5physx27PxClothGeodesicTetherCookerD2Ev: __ZN5physx27PxClothGeodesicTetherCookerD2Ev, __ZNKSt3__212ctype_bynameIwE8do_widenEPKcS3_Pw: __ZNKSt3__212ctype_bynameIwE8do_widenEPKcS3_Pw, __ZN5physx2Sc10NPhaseCore30processPersistentContactEventsEv: __ZN5physx2Sc10NPhaseCore30processPersistentContactEventsEv, __ZNSt3__227__insertion_sort_incompleteIRPFbRK16BlendShapeVertexS3_EPS1_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRK16BlendShapeVertexS3_EPS1_EEbT0_S8_T_, __Z37AndroidJNI_CUSTOM_CallStaticIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z37AndroidJNI_CUSTOM_CallStaticIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNK5physx13NpVolumeCache10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf: __ZNK5physx13NpVolumeCache10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf, __GLOBAL__sub_I_SwCollision_cpp: __GLOBAL__sub_I_SwCollision_cpp, __Z59Register_UnityEngine_ParticleSystem_INTERNAL_set_startColorv: __Z59Register_UnityEngine_ParticleSystem_INTERNAL_set_startColorv, __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXMultiplierv, __ZNK5physx2Sc16ArticulationCore16updateDriveCacheERNS_9PxcFsDataEfj: __ZNK5physx2Sc16ArticulationCore16updateDriveCacheERNS_9PxcFsDataEfj, __Z41QualitySettings_Get_Custom_PropVSyncCountv: __Z41QualitySettings_Get_Custom_PropVSyncCountv, __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_: __ZN15SerializeTraitsIN9ShaderLab19SerializedStencilOpEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_, _unity_z_zError: _unity_z_zError, __ZN5physx3Ext18ProfileZoneHandler13onZoneRemovedERNS_13PxProfileZoneE: __ZN5physx3Ext18ProfileZoneHandler13onZoneRemovedERNS_13PxProfileZoneE, __Z43Sprite_CUSTOM_Internal_GetTextureRectOffsetP12Il2CppObjectP13Vector2fIcall: __Z43Sprite_CUSTOM_Internal_GetTextureRectOffsetP12Il2CppObjectP13Vector2fIcall, __Z28AnimationCurve_CUSTOM_AddKeyP12Il2CppObjectff: __Z28AnimationCurve_CUSTOM_AddKeyP12Il2CppObjectff, ___cxa_guard_release: ___cxa_guard_release, __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MovePositionv: __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MovePositionv, _UNITY_TT_Done_Context: _UNITY_TT_Done_Context, __Z50Register_UnityEngine_Event_Internal_SetNativeEventv: __Z50Register_UnityEngine_Event_Internal_SetNativeEventv, __ZNK9Transform18FindLastChildIndexEv: __ZNK9Transform18FindLastChildIndexEv, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, _Round_Super_45: _Round_Super_45, __Z31AndroidJNI_CUSTOM_SetFloatField13Il2Cpp_IntPtrS_f: __Z31AndroidJNI_CUSTOM_SetFloatField13Il2Cpp_IntPtrS_f, __ZN5physx55PxVehicleDrive4WSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE: __ZN5physx55PxVehicleDrive4WSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE, __ZnajRKSt9nothrow_t: __ZnajRKSt9nothrow_t, __ZN5physx2Sc5Scene24initActiveBodiesIteratorERNS0_12BodyIteratorE: __ZN5physx2Sc5Scene24initActiveBodiesIteratorERNS0_12BodyIteratorE, __ZN5physx13PxsCCDContext18postCCDDepenetrateEPNS_10PxBaseTaskE: __ZN5physx13PxsCCDContext18postCCDDepenetrateEPNS_10PxBaseTaskE, __ZN5physx16PxsIslandManager13updateIslandsEv: __ZN5physx16PxsIslandManager13updateIslandsEv, __ZN5Umbra12QueryContext11getGateCostERKNS_10MappedTileERKNS_6PortalE: __ZN5Umbra12QueryContext11getGateCostERKNS_10MappedTileERKNS_6PortalE, __ZN16ParticleRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN16ParticleRenderer8TransferI14SafeBinaryReadEEvRT_, _UNITY_png_set_strip_16: _UNITY_png_set_strip_16, __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE: __ZN19ShaderPropertySheet16SetComputeBufferERKN9ShaderLab16FastPropertyNameE15ComputeBufferIDNS_8SetFlagsE, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER14SafeBinaryRead, __Z23profiler_cleanup_threadv: __Z23profiler_cleanup_threadv, __ZN5physx2Gu25PersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj: __ZN5physx2Gu25PersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj, __ZN23ManagedAttributeManager15InitializeClassEv: __ZN23ManagedAttributeManager15InitializeClassEv, __Z18ExtractMeshIndicesRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEERK15CombineInstancebRjPt: __Z18ExtractMeshIndicesRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEERK15CombineInstancebRjPt, __ZN14SafeBinaryRead8TransferIN7mecanim9animation19Blend1dDataConstantEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim9animation19Blend1dDataConstantEEEvRT_PKc17TransferMetaFlags, __ZNK5physx16PxVehicleDrive4W7isValidEv: __ZNK5physx16PxVehicleDrive4W7isValidEv, __ZN16GraphicsSettings10SmartResetEv: __ZN16GraphicsSettings10SmartResetEv, __ZN13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEC2ERKS2_: __ZN13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEC2ERKS2_, __ZN17InternalIndexPoolC2EjjPKj: __ZN17InternalIndexPoolC2EjjPKj, __ZN5physx3Cct13HandleManagerC2Ev: __ZN5physx3Cct13HandleManagerC2Ev, __ZN19StreamedBinaryWriteILb0EE4InitE24TransferInstructionFlags20BuildTargetSelection: __ZN19StreamedBinaryWriteILb0EE4InitE24TransferInstructionFlags20BuildTargetSelection, __ZN13GfxDeviceGLES15SetBackfaceModeEb: __ZN13GfxDeviceGLES15SetBackfaceModeEb, __ZN11BoxCollider13AwakeFromLoadE17AwakeFromLoadMode: __ZN11BoxCollider13AwakeFromLoadE17AwakeFromLoadMode, __ZN12AudioManager10InitNormalEv: __ZN12AudioManager10InitNormalEv, _strtoull: _strtoull, __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __Z28AssetBundle_CUSTOM_LoadAsyncP12Il2CppObjectP12Il2CppStringS0_: __Z28AssetBundle_CUSTOM_LoadAsyncP12Il2CppObjectP12Il2CppStringS0_, __ZN5physx2Gu25PersistentContactManifold26reduceBatchContactsClusterEPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold26reduceBatchContactsClusterEPKNS0_17PersistentContactEj, __ZThn80_NK26AnimatorControllerPlayable24HasStateMachineBehaviourEv: __ZThn80_NK26AnimatorControllerPlayable24HasStateMachineBehaviourEv, __ZN19SkinnedMeshRenderer13DidDeleteMeshEv: __ZN19SkinnedMeshRenderer13DidDeleteMeshEv, __ZNSt3__25mutex4lockEv: __ZNSt3__25mutex4lockEv, __Z58RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustPointRK13Vector2fIcallP12Il2CppObjectS3_RS_: __Z58RectTransformUtility_CUSTOM_INTERNAL_CALL_PixelAdjustPointRK13Vector2fIcallP12Il2CppObjectS3_RS_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat: __ZN13RenderTexture14SetColorFormatE19RenderTextureFormat, __ZN12NavMeshAgent11SetVelocityERK8Vector3f: __ZN12NavMeshAgent11SetVelocityERK8Vector3f, __Z53Register_UnityEngine_TerrainData_get_detailPrototypesv: __Z53Register_UnityEngine_TerrainData_get_detailPrototypesv, __ZN5physx3Ext13RevoluteJoint8setLimitERKNS_23PxJointAngularLimitPairE: __ZN5physx3Ext13RevoluteJoint8setLimitERKNS_23PxJointAngularLimitPairE, __Z38Register_UnityEngine_Light_get_isBakedv: __Z38Register_UnityEngine_Light_get_isBakedv, _UNITY_FT_Get_Module: _UNITY_FT_Get_Module, __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi: __ZN7mecanim5human14HumanFixMidDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi, __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z40AudioReverbZone_Get_Custom_PropDiffusionP12Il2CppObject: __Z40AudioReverbZone_Get_Custom_PropDiffusionP12Il2CppObject, __Z21getPxClothParticlePosPKN5physx15PxClothParticleE: __Z21getPxClothParticlePosPKN5physx15PxClothParticleE, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE8__appendEj: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE8__appendEj, __ZN13OcclusionArea23VirtualRedirectTransferER14SafeBinaryRead: __ZN13OcclusionArea23VirtualRedirectTransferER14SafeBinaryRead, __Z33GetParticleSystemScriptingClassesv: __Z33GetParticleSystemScriptingClassesv, __ZN5Umbra4Math3sinENS_5FloatE: __ZN5Umbra4Math3sinENS_5FloatE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjP2tmcc, __ZNSt3__27promiseIvED2Ev: __ZNSt3__27promiseIvED2Ev, __ZN8LODGroup18OnTransformChangedEi: __ZN8LODGroup18OnTransformChangedEi, __ZN12AspectRatios8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12AspectRatios8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Unity17ConfigurableJoint5ResetEv: __ZN5Unity17ConfigurableJoint5ResetEv, __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv: __ZN18ConcurrentFreeListI10AtomicNodeE7CleanUpEv, __Z54RenderTexture_CUSTOM_INTERNAL_CALL_MarkRestoreExpectedP12Il2CppObject: __Z54RenderTexture_CUSTOM_INTERNAL_CALL_MarkRestoreExpectedP12Il2CppObject, __ZN13GfxDeviceNull10BeginFrameEv: __ZN13GfxDeviceNull10BeginFrameEv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED2Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED2Ev, __ZN12MeshCollider15InitializeClassEv: __ZN12MeshCollider15InitializeClassEv, __ZN5physx2Sn5ConvX17registerUnionTypeEPKcS3_i: __ZN5physx2Sn5ConvX17registerUnionTypeEPKcS3_i, __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZNK5physx2Sc9ClothCore22getNbCollisionCapsulesEv: __ZNK5physx2Sc9ClothCore22getNbCollisionCapsulesEv, __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetEnabledv: __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetEnabledv, __ZN5physx24PxcArticulationFnsScalar16multiplySubtractERKNS_9SpInertiaEPKNS_2Cm13SpatialVectorES7_: __ZN5physx24PxcArticulationFnsScalar16multiplySubtractERKNS_9SpInertiaEPKNS_2Cm13SpatialVectorES7_, __ZN15b2DistanceJointC2EPK18b2DistanceJointDef: __ZN15b2DistanceJointC2EPK18b2DistanceJointDef, _UNITY_FT_Bitmap_Init: _UNITY_FT_Bitmap_Init, __ZN5physx3Scb5Scene16removeRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene16removeRigidNoSimINS0_4BodyELb1ELb1EEEvRT_RNS0_13ObjectTrackerE, __ZN10Effector2DD2Ev: __ZN10Effector2DD2Ev, __Z35Rigidbody2D_CUSTOM_SetDragBehaviourP12Il2CppObjecth: __Z35Rigidbody2D_CUSTOM_SetDragBehaviourP12Il2CppObjecth, __ZN9Rigidbody14SetConstraintsEi: __ZN9Rigidbody14SetConstraintsEi, __Z50Register_UnityEngine_QualitySettings_DecreaseLevelv: __Z50Register_UnityEngine_QualitySettings_DecreaseLevelv, __ZN9LensFlare8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9LensFlare8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sc14ConstraintCore15updateConstantsEPv: __ZN5physx2Sc14ConstraintCore15updateConstantsEPv, __ZN22BlockMemoryCacheWriter13GetFileLengthEv: __ZN22BlockMemoryCacheWriter13GetFileLengthEv, __ZN5Umbra8QueryExt22buildPlaneShadowCullerERNS_15ShadowCullerExtERKNS_15CameraTransformERKNS_7Vector3EPfjPPS4_i: __ZN5Umbra8QueryExt22buildPlaneShadowCullerERNS_15ShadowCullerExtERKNS_15CameraTransformERKNS_7Vector3EPfjPPS4_i, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx5cloth9ClothImplINS0_7SwClothEED2Ev: __ZN5physx5cloth9ClothImplINS0_7SwClothEED2Ev, __ZN7Texture15FindTextureByIDE9TextureID: __ZN7Texture15FindTextureByIDE9TextureID, __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD0Ev: __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD0Ev, __Z36Animator_CUSTOM_CrossFadeInFixedTimeP12Il2CppObjectifif: __Z36Animator_CUSTOM_CrossFadeInFixedTimeP12Il2CppObjectifif, __Z27GeomOverlapCallback_BoxMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z27GeomOverlapCallback_BoxMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5Umbra15CameraTransform10setFrustumERKNS_7FrustumE: __ZN5Umbra15CameraTransform10setFrustumERKNS_7FrustumE, __ZNK17ArchiveFileSystem8PositionERK13FileEntryData: __ZNK17ArchiveFileSystem8PositionERK13FileEntryData, __Z27CalculateAABBCornerVerticesR10GameObjectP8Vector3f: __Z27CalculateAABBCornerVerticesR10GameObjectP8Vector3f, __Z12ReadIntArrayPPiS_i: __Z12ReadIntArrayPPiS_i, __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE: __ZN5physxlsERNS_14PxOutputStreamERKNS_12PxFilterDataE, __Z42Transform_Get_Custom_PropHierarchyCapacityP12Il2CppObject: __Z42Transform_Get_Custom_PropHierarchyCapacityP12Il2CppObject, __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j: __ZN15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j, __ZN5Umbra5Query11setSpuUsageENS0_8SpuUsageE: __ZN5Umbra5Query11setSpuUsageENS0_8SpuUsageE, __ZN5physx24NpPtrTableStorageManagerD0Ev: __ZN5physx24NpPtrTableStorageManagerD0Ev, __Z19GetUserAccelerationi: __Z19GetUserAccelerationi, __Z23ClearVertexDataChannelsjjjR14VertexDataInfo: __Z23ClearVertexDataChannelsjjjR14VertexDataInfo, __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES: __ZN18GfxFramebufferGLES30ReadbackDepthIntoRenderTextureEP17RenderSurfaceGLES, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E, __ZN19ClampVelocityModule8TransferI17RemapPPtrTransferEEvRT_: __ZN19ClampVelocityModule8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx15NpParticleFluid17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx15NpParticleFluid17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK17AudioChorusFilter26GetTypeInfoVirtualInternalEv: __ZNK17AudioChorusFilter26GetTypeInfoVirtualInternalEv, __Z48ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_NoiseModule_CUSTOM_SetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI8MonoPPtr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __ZN5physx36PxVehicleDriveDynDataGeneratedValuesC2EPKNS_21PxVehicleDriveDynDataE: __ZN5physx36PxVehicleDriveDynDataGeneratedValuesC2EPKNS_21PxVehicleDriveDynDataE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9__grow_byEjjjjjj, __Z9GetIAudiov: __Z9GetIAudiov, __Z42Camera_Set_Custom_PropTransparencySortModeP12Il2CppObjectN6Camera20TransparencySortModeE: __Z42Camera_Set_Custom_PropTransparencySortModeP12Il2CppObjectN6Camera20TransparencySortModeE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7Terrain16SetLightmapIndexEi12LightmapType: __ZN7Terrain16SetLightmapIndexEi12LightmapType, __ZN9Texture2D18LoadRawTextureDataEPKvj: __ZN9Texture2D18LoadRawTextureDataEPKvj, __Z59AssetBundleManifest_CUSTOM_INTERNAL_CALL_GetAssetBundleHashP12Il2CppObjectP12Il2CppStringR7Hash128: __Z59AssetBundleManifest_CUSTOM_INTERNAL_CALL_GetAssetBundleHashP12Il2CppObjectP12Il2CppStringR7Hash128, __ZN5physx13NpVolumeCache7forEachERNS_13PxVolumeCache8IteratorE: __ZN5physx13NpVolumeCache7forEachERNS_13PxVolumeCache8IteratorE, __ZNKSt3__210moneypunctIwLb0EE16do_positive_signEv: __ZNKSt3__210moneypunctIwLb0EE16do_positive_signEv, __Z53Register_UnityEngine_Application_get_bundleIdentifierv: __Z53Register_UnityEngine_Application_get_bundleIdentifierv, __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20SphericalHarmonicsL28TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery: __ZNK14dtPathCorridor11findCornersEPfPhPyPiiPK14dtNavMeshQuery, __ZN20SoundChannelInstance9isPlayingEPb: __ZN20SoundChannelInstance9isPlayingEPb, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl9findClassERKN5physx8debugger14NamespacedNameE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl9findClassERKN5physx8debugger14NamespacedNameE, __ZN5physx13PxRigidStaticD0Ev: __ZN5physx13PxRigidStaticD0Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN19ClampVelocityModule8TransferI14SafeBinaryReadEEvRT_: __ZN19ClampVelocityModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx23ArticulationRootManager6resizeEj: __ZN5physx23ArticulationRootManager6resizeEj, __ZNKSt3__215__codecvt_utf16IDiLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IDiLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZNK11AudioSource31GetCustomReverbZoneMixCurveCopyEv: __ZNK11AudioSource31GetCustomReverbZoneMixCurveCopyEv, __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E: __ZN9Transform32SetLocalScaleWithoutNotificationERKN4math7_float3E, __Z49Register_UnityEngine_Camera_GetStereoViewMatricesv: __Z49Register_UnityEngine_Camera_GetStereoViewMatricesv, __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthYP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthYP12Il2CppObjectR15MonoMinMaxCurve, __Z50Renderer_Set_Custom_PropMotionVectorGenerationModeP12Il2CppObject26MotionVectorGenerationMode: __Z50Renderer_Set_Custom_PropMotionVectorGenerationModeP12Il2CppObject26MotionVectorGenerationMode, __ZN12HandlerChain11PushHandlerEP17FileSystemHandler: __ZN12HandlerChain11PushHandlerEP17FileSystemHandler, __ZNK5physx7NpShape23getSimulationFilterDataEv: __ZNK5physx7NpShape23getSimulationFilterDataEv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentryC2ERS3_b, __ZNKSt3__28messagesIwE8do_closeEi: __ZNKSt3__28messagesIwE8do_closeEi, __ZNK5physx2Sn5ConvX11getNbErrorsEv: __ZNK5physx2Sn5ConvX11getNbErrorsEv, __ZN20SoundChannelInstance6setPanEf: __ZN20SoundChannelInstance6setPanEf, __Z33CreateMonoScriptFromScriptingTypeP11Il2CppClass: __Z33CreateMonoScriptFromScriptingTypeP11Il2CppClass, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z37AsyncOperation_CUSTOM_InternalDestroyP12Il2CppObject: __Z37AsyncOperation_CUSTOM_InternalDestroyP12Il2CppObject, __Z49Register_UnityEngine_ReflectionProbe_BlendCubemapv: __Z49Register_UnityEngine_ReflectionProbe_BlendCubemapv, __ZNKSt3__214__codecvt_utf8IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_: __ZNKSt3__214__codecvt_utf8IDsE5do_inER11__mbstate_tPKcS5_RS5_PDsS7_RS7_, __ZN10GameObject18TransferComponentsI14SafeBinaryReadEEvRT_: __ZN10GameObject18TransferComponentsI14SafeBinaryReadEEvRT_, __ZN5physx10PxsContext28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskE: __ZN5physx10PxsContext28mergeCMDiscreteUpdateResultsEPNS_10PxBaseTaskE, _term_mem_destination: _term_mem_destination, __ZN2UI14CanvasRenderer15InitializeClassEv: __ZN2UI14CanvasRenderer15InitializeClassEv, __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx3Ext20DefaultCpuDispatcher7releaseEv: __ZN5physx3Ext20DefaultCpuDispatcher7releaseEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags, _remainderf: _remainderf, __Z48Register_UnityEngine_Renderer_set_receiveShadowsv: __Z48Register_UnityEngine_Renderer_set_receiveShadowsv, __ZNK6Avatar7IsValidEv: __ZNK6Avatar7IsValidEv, __ZZ23InitPlayerLoopCallbacksvEN46FixedUpdateScriptRunBehaviourFixedUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN46FixedUpdateScriptRunBehaviourFixedUpdatestruct7ForwardEv, __ZN5physx24PxMaterialRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx24PxMaterialRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedItEES4_S4_S4_RNS_8ios_baseERjRT_, __Z24RegisterStrippedTypeInfoI5LightEviPKcS2_: __Z24RegisterStrippedTypeInfoI5LightEviPKcS2_, __Z38WheelJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D: __Z38WheelJoint2D_CUSTOM_INTERNAL_get_motorP12Il2CppObjectP12JointMotor2D, __ZN21PxsParallelSolverTask11runInternalEv: __ZN21PxsParallelSolverTask11runInternalEv, __Z29StdTemplateConversionFunctionIitEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIitEbPvR14SafeBinaryRead, __Z51ParticleSystem_CUSTOM_SetCustomParticleDataInternalP12Il2CppObjectS0_i: __Z51ParticleSystem_CUSTOM_SetCustomParticleDataInternalP12Il2CppObjectS0_i, __ZN5physx2Cm8PtrTable15replaceWithLastEjRNS0_22PtrTableStorageManagerE: __ZN5physx2Cm8PtrTable15replaceWithLastEjRNS0_22PtrTableStorageManagerE, __ZN18LoadSceneOperation21CompleteAwakeSequenceEv: __ZN18LoadSceneOperation21CompleteAwakeSequenceEv, __Z30Light_Get_Custom_PropSpotAngleP12Il2CppObject: __Z30Light_Get_Custom_PropSpotAngleP12Il2CppObject, __ZN13SpeedTreeWind10SWindGroupC2Ev: __ZN13SpeedTreeWind10SWindGroupC2Ev, __ZN15AnchoredJoint2D17ConfigureDistanceERK6b2Vec2S2_: __ZN15AnchoredJoint2D17ConfigureDistanceERK6b2Vec2S2_, __ZNK12MeshRenderer26GetAdditionalVertexStreamsEv: __ZNK12MeshRenderer26GetAdditionalVertexStreamsEv, __ZN20ArchiveStorageHeader19ReadHeaderSignatureER12FileAccessorRNS_6HeaderE: __ZN20ArchiveStorageHeader19ReadHeaderSignatureER12FileAccessorRNS_6HeaderE, __ZN2gl12IsFormatHalfENS_9TexFormatE: __ZN2gl12IsFormatHalfENS_9TexFormatE, __Z28ScriptingStructArrayToVectorI9HumanBone13MonoHumanBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_: __Z28ScriptingStructArrayToVectorI9HumanBone13MonoHumanBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_, __ZN19RuntimeSceneManager11MergeScenesER10UnitySceneS1_: __ZN19RuntimeSceneManager11MergeScenesER10UnitySceneS1_, __ZN5physx2Sc17ParticleSystemSim24visualizeParticlesBoundsERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim24visualizeParticlesBoundsERNS_2Cm12RenderOutputE, __ZN15ResourceManager16FindDependenciesEiR13dynamic_arrayIiLj4EE: __ZN15ResourceManager16FindDependenciesEiR13dynamic_arrayIiLj4EE, __Z52Register_UnityEngine_Shader_SetGlobalVectorArrayImplv: __Z52Register_UnityEngine_Shader_SetGlobalVectorArrayImplv, __ZN5Umbra12RegionFinder7executeEPNS_8UserListIiEEPNS1_IfEES5_S3_: __ZN5Umbra12RegionFinder7executeEPNS_8UserListIiEEPNS1_IfEES5_S3_, __Z25getPxJointLimitConeZAnglePKN5physx16PxJointLimitConeE: __Z25getPxJointLimitConeZAnglePKN5physx16PxJointLimitConeE, __Z48Register_UnityEngine_HingeJoint2D_get_jointSpeedv: __Z48Register_UnityEngine_HingeJoint2D_get_jointSpeedv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN9b2Contact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN9b2Contact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalGetCustomMethodv: __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalGetCustomMethodv, _malloc_stats: _malloc_stats, __ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE: __ZN4FMOD6System15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE, __ZN26AnimatorControllerPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE: __ZN26AnimatorControllerPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE, __ZNK5Umbra4Tome7getSizeEv: __ZNK5Umbra4Tome7getSizeEv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEEEvT_S6_T0_T1_, __ZNK7dtCrowd27UpdateProximityGridCellSizeEP15dtProximityGridii: __ZNK7dtCrowd27UpdateProximityGridCellSizeEP15dtProximityGridii, _wcsnlen: _wcsnlen, __ZNK5physx19NpArticulationJoint21getExternalComplianceEv: __ZNK5physx19NpArticulationJoint21getExternalComplianceEv, __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8WindZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN19SkinnedMeshRenderer10SetQualityEi: __ZN19SkinnedMeshRenderer10SetQualityEi, __Z57Register_UnityEngine_ParticleSystem_MainModule_SetEnabledv: __Z57Register_UnityEngine_ParticleSystem_MainModule_SetEnabledv, __ZNK5physx22PxVehicleWheelsDynData22getTireForceShaderDataEj: __ZNK5physx22PxVehicleWheelsDynData22getTireForceShaderDataEj, __ZN9WWWCachedC2EPKc7Hash128j: __ZN9WWWCachedC2EPKc7Hash128j, __Z64Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplListv: __Z64Register_UnityEngine_MaterialPropertyBlock_SetFloatArrayImplListv, __ZNSt3__210moneypunctIwLb1EED2Ev: __ZNSt3__210moneypunctIwLb1EED2Ev, __ZNSt3__214__codecvt_utf8IwED0Ev: __ZNSt3__214__codecvt_utf8IwED0Ev, _Direct_Move: _Direct_Move, __Z24scripting_field_get_typeP9FieldInfo: __Z24scripting_field_get_typeP9FieldInfo, _fgetc: _fgetc, __ZN15CapsuleCollider15ThreadedCleanupEv: __ZN15CapsuleCollider15ThreadedCleanupEv, __ZN24MeshIntermediateRendererC2Ev: __ZN24MeshIntermediateRendererC2Ev, __ZN15AudioReverbZoneD2Ev: __ZN15AudioReverbZoneD2Ev, __ZN4FMOD8ChannelI20set3DConeOrientationEP11FMOD_VECTOR: __ZN4FMOD8ChannelI20set3DConeOrientationEP11FMOD_VECTOR, _fgets: _fgets, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN11UnityEngine9Animation30CreateAvatarBindingConstantOptER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE: __ZN11UnityEngine9Animation30CreateAvatarBindingConstantOptER9TransformPKN7mecanim9animation14AvatarConstantERNS3_6memory9AllocatorE, __Z53Register_UnityEngine_RenderBufferHelper_SetLoadActionv: __Z53Register_UnityEngine_RenderBufferHelper_SetLoadActionv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj473ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj473ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z27QuadTreeNodeRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi: __Z27QuadTreeNodeRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi, __ZN4FMOD3DSP15getSystemObjectEPPNS_6SystemE: __ZN4FMOD3DSP15getSystemObjectEPPNS_6SystemE, __ZN5physx7NpScene12addAggregateERNS_11PxAggregateE: __ZN5physx7NpScene12addAggregateERNS_11PxAggregateE, __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetModev: __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_GetModev, __ZNSt3__218shared_timed_mutexC2Ev: __ZNSt3__218shared_timed_mutexC2Ev, __ZN10AudioMixer21UpdateCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE: __ZN10AudioMixer21UpdateCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE, __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE6resizeEjRKt: __ZN5physx6shdfnd5ArrayItNS0_15InlineAllocatorILj8ENS0_19ReflectionAllocatorItEEEEE6resizeEjRKt, __ZN14b2PolygonShape8SetAsBoxEff: __ZN14b2PolygonShape8SetAsBoxEff, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZThn80_NK26AnimatorControllerPlayable25GetStateMachineBehavioursEv: __ZThn80_NK26AnimatorControllerPlayable25GetStateMachineBehavioursEv, __Z40GUIUtility_Get_Custom_PropHasModalWindowv: __Z40GUIUtility_Get_Custom_PropHasModalWindowv, __ZN5IMGUI9GUIWindow23ReleaseScriptingObjectsEv: __ZN5IMGUI9GUIWindow23ReleaseScriptingObjectsEv, __ZN13WheelCollider9SetRadiusEf: __ZN13WheelCollider9SetRadiusEf, __ZN9Rigidbody8AddForceERK8Vector3fi: __ZN9Rigidbody8AddForceERK8Vector3fi, __ZN5physx2Sc5Scene22removeBroadPhaseRegionEj: __ZN5physx2Sc5Scene22removeBroadPhaseRegionEj, __Z62Register_UnityEngine_Analytics_CustomEventData_InternalDestroyv: __Z62Register_UnityEngine_Analytics_CustomEventData_InternalDestroyv, __ZN10UnityScene19HasLevelGameManagerEP11GameManager: __ZN10UnityScene19HasLevelGameManagerEP11GameManager, __ZN14PhysicMaterial8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14PhysicMaterial8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__227__num_get_unsigned_integralItEET_PKcS3_Rji: __ZNSt3__227__num_get_unsigned_integralItEET_PKcS3_Rji, __Z31OffMeshLink_Set_Custom_PropAreaP12Il2CppObjecti: __Z31OffMeshLink_Set_Custom_PropAreaP12Il2CppObjecti, __ZNK21AssetBundleFileSystem9CanHandleEPKc: __ZNK21AssetBundleFileSystem9CanHandleEPKc, __ZN5physx6shdfnd9MutexImplD2Ev: __ZN5physx6shdfnd9MutexImplD2Ev, __ZNK7dtCrowd26getObstacleAvoidanceParamsEi: __ZNK7dtCrowd26getObstacleAvoidanceParamsEi, __ZN14RenderSettings12CleanupClassEv: __ZN14RenderSettings12CleanupClassEv, __ZN5Umbra9BitVectorC2ERKS0_: __ZN5Umbra9BitVectorC2ERKS0_, __ZN9Texture2D15UpdatePOTStatusEv: __ZN9Texture2D15UpdatePOTStatusEv, __Z30AndroidJNI_CUSTOM_IsInstanceOf13Il2Cpp_IntPtrS_: __Z30AndroidJNI_CUSTOM_IsInstanceOf13Il2Cpp_IntPtrS_, __ZN38AssetBundleLoadFromCacheAsyncOperationD0Ev: __ZN38AssetBundleLoadFromCacheAsyncOperationD0Ev, __Z50Register_UnityEngine_FixedJoint2D_get_dampingRatiov: __Z50Register_UnityEngine_FixedJoint2D_get_dampingRatiov, __ZL30CleanupPhysicsScriptingClassesv: __ZL30CleanupPhysicsScriptingClassesv, __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev: __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD0Ev, __ZN5physx2Sc10NPhaseCore35createParticlePacketBodyInteractionERNS0_19ParticlePacketShapeERNS0_8ShapeSimEj: __ZN5physx2Sc10NPhaseCore35createParticlePacketBodyInteractionERNS0_19ParticlePacketShapeERNS0_8ShapeSimEj, __ZN9GfxDevice16GetMultiGPUCountEv: __ZN9GfxDevice16GetMultiGPUCountEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags, __ZNK11AudioSource14GetMinDistanceEv: __ZNK11AudioSource14GetMinDistanceEv, __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev: __ZN11UnityEngine15CloudWebService16SessionContainerC2Ev, __ZN8Collider15InitializeClassEv: __ZN8Collider15InitializeClassEv, __Z36CanvasRenderer_Get_Custom_PropIsMaskP12Il2CppObject: __Z36CanvasRenderer_Get_Custom_PropIsMaskP12Il2CppObject, __GLOBAL__sub_I_runtime_webrequest_lump_cpp: __GLOBAL__sub_I_runtime_webrequest_lump_cpp, __ZN8VRModule11VRLoadSceneEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZN8VRModule11VRLoadSceneEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __Z61Register_UnityEngine_Rigidbody_INTERNAL_get_worldCenterOfMassv: __Z61Register_UnityEngine_Rigidbody_INTERNAL_get_worldCenterOfMassv, __Z24RegisterStrippedTypeInfoI11BoxColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI11BoxColliderEviPKcS2_, __ZN11UnityEngine15PlatformWrapper14GetLicenseTypeEv: __ZN11UnityEngine15PlatformWrapper14GetLicenseTypeEv, __Z58Register_UnityEngine_Terrain_INTERNAL_CALL_AddTreeInstancev: __Z58Register_UnityEngine_Terrain_INTERNAL_CALL_AddTreeInstancev, __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z54Register_UnityEngine_Canvas_set_referencePixelsPerUnitv: __Z54Register_UnityEngine_Canvas_set_referencePixelsPerUnitv, __ZN14FileCacherRead12RequestBlockEi: __ZN14FileCacherRead12RequestBlockEi, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN13SpeedTreeWind16SetGustFrequencyEf: __ZN13SpeedTreeWind16SetGustFrequencyEf, __ZN9GfxDevice17SetGpuProgramNameEP10GpuProgramPKc: __ZN9GfxDevice17SetGpuProgramNameEP10GpuProgramPKc, __Z26scripting_class_get_parentP11Il2CppClass: __Z26scripting_class_get_parentP11Il2CppClass, __ZN11UnityEngine15CloudWebService14DataDispatcher30FindSessionContainerToDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher30FindSessionContainerToDispatchEv, __ZN12NavMeshAgent27SetInternalAnimationPolyRefEy: __ZN12NavMeshAgent27SetInternalAnimationPolyRefEy, __ZN13MonoBehaviour19SetupScriptingCacheEP11Il2CppClassP10MonoScript: __ZN13MonoBehaviour19SetupScriptingCacheEP11Il2CppClassP10MonoScript, __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperationD0Ev: __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperationD0Ev, __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE11getTypeNameEv, __ZN12LineRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN12LineRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZN13ComputeShader9HasKernelERKN9ShaderLab16FastPropertyNameE: __ZN13ComputeShader9HasKernelERKN9ShaderLab16FastPropertyNameE, __ZN11LightProbesC2E10MemLabelId18ObjectCreationMode: __ZN11LightProbesC2E10MemLabelId18ObjectCreationMode, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z33Texture_CUSTOM_GetNativeTextureIDP12Il2CppObject: __Z33Texture_CUSTOM_GetNativeTextureIDP12Il2CppObject, __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE: __ZN5physx3Scb5Scene16removeConstraintERNS0_10ConstraintE, _ngettext: _ngettext, __Z36SystemInfo_Get_Custom_PropDeviceNamev: __Z36SystemInfo_Get_Custom_PropDeviceNamev, __ZN5physx20PxcPCMContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx20PxcPCMContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z39SortingLayer_CUSTOM_GetLayerValueFromIDi: __Z39SortingLayer_CUSTOM_GetLayerValueFromIDi, __Z21GetCrashReportManagerv: __Z21GetCrashReportManagerv, __Z28Camera_CUSTOM_GetHDRWarningsP12Il2CppObject: __Z28Camera_CUSTOM_GetHDRWarningsP12Il2CppObject, __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7Hash1288TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv: __ZN10__cxxabiv112_GLOBAL__N_111string_pair9move_fullEv, __ZN4FMOD6System19getGeometrySettingsEPf: __ZN4FMOD6System19getGeometrySettingsEPf, __ZN13SliderJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13SliderJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_S6_T_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_jjRKS4_, __ZNK5physx7NpScene29getDynamicTreeRebuildRateHintEv: __ZNK5physx7NpScene29getDynamicTreeRebuildRateHintEv, __Z30getNbPxScene_BroadPhaseRegionsPKN5physx7PxSceneE: __Z30getNbPxScene_BroadPhaseRegionsPKN5physx7PxSceneE, __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14PlayerSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_, _start_pass_fdctmgr: _start_pass_fdctmgr, __ZN13DrawImmediate5ColorEffff: __ZN13DrawImmediate5ColorEffff, __Z45QualitySettings_Set_Custom_PropShadowCascadesi: __Z45QualitySettings_Set_Custom_PropShadowCascadesi, __ZN5IMGUI9GUIWindowC2Ev: __ZN5IMGUI9GUIWindowC2Ev, __Z50Register_UnityEngine_GUIUtility_set_textFieldInputv: __Z50Register_UnityEngine_GUIUtility_set_textFieldInputv, __ZN13dynamic_arrayI10Matrix4x4fLj16EEC2ERKS1_: __ZN13dynamic_arrayI10Matrix4x4fLj16EEC2ERKS1_, __Z42Register_UnityEngine_Mesh_get_subMeshCountv: __Z42Register_UnityEngine_Mesh_get_subMeshCountv, __ZN13RuntimeStaticI15GUIEventManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI15GUIEventManagerE16StaticInitializeEPv, __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16UnityAdsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Scb14ParticleSystem9syncStateEv: __ZN5physx3Scb14ParticleSystem9syncStateEv, __Z54Register_UnityEngine_AreaEffector2D_set_forceVariationv: __Z54Register_UnityEngine_AreaEffector2D_set_forceVariationv, __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIcc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIcc11__mbstate_tEEEEvPT_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEE, __Z11SkinGenericILi4ELb1ELb1EEvR12SkinMeshInfo: __Z11SkinGenericILi4ELb1ELb1EEvR12SkinMeshInfo, __ZN5physx2Sn13XmlNodeReader15gotoNextSiblingEv: __ZN5physx2Sn13XmlNodeReader15gotoNextSiblingEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E9copy_fromERKSF_j, __Z51Register_UnityEngine_AreaEffector2D_get_angularDragv: __Z51Register_UnityEngine_AreaEffector2D_get_angularDragv, __Z21CompareGUIDStringLessRK9UnityGUIDS1_: __Z21CompareGUIDStringLessRK9UnityGUIDS1_, __ZN13MonoBehaviour25TransferEngineAndInstanceI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13MonoBehaviour25TransferEngineAndInstanceI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj62ES2_RKNS_11PxTransformES6_EEEEvjRT_, __Z37Light_Set_Custom_PropShadowNormalBiasP12Il2CppObjectf: __Z37Light_Set_Custom_PropShadowNormalBiasP12Il2CppObjectf, __ZN7TextureD2Ev: __ZN7TextureD2Ev, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_ED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVES2_ED0Ev, ___fseeko: ___fseeko, __ZNK4PPtrI6ObjectEcvPS0_Ev: __ZNK4PPtrI6ObjectEcvPS0_Ev, __Z46Animator_Get_Custom_PropLayersAffectMassCenterP12Il2CppObject: __Z46Animator_Get_Custom_PropLayersAffectMassCenterP12Il2CppObject, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv, __ZN14LineParametersC2E10MemLabelId: __ZN14LineParametersC2E10MemLabelId, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale1Ef, __ZN5physx43solveFrictionCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx43solveFrictionCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN15ConstantForce2D11FixedUpdateEv: __ZN15ConstantForce2D11FixedUpdateEv, _strcasecmp_l: _strcasecmp_l, __ZN15PointEffector2DD0Ev: __ZN15PointEffector2DD0Ev, __Z17IntersectRayPlaneRK3RayRK5PlanePf: __Z17IntersectRayPlaneRK3RayRK5PlanePf, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getFrictionEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN20BufferedSocketStream13OnSocketErrorEv: __ZN20BufferedSocketStream13OnSocketErrorEv, __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt: __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE6resizeEjRKt, __ZN5physx2Sc5Scene15createAggregateEPvb: __ZN5physx2Sc5Scene15createAggregateEPvb, __ZL27CleanupGlobalNameConversionPv: __ZL27CleanupGlobalNameConversionPv, __ZN18CapsuleCast2DQuery19InitializeCastShapeEv: __ZN18CapsuleCast2DQuery19InitializeCastShapeEv, __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow2P12Il2CppObjectRK10Matrix4x4fi: __Z51Graphics_CUSTOM_INTERNAL_CALL_Internal_DrawMeshNow2P12Il2CppObjectRK10Matrix4x4fi, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERf: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERf, __ZN18PlayableController4BindEP8PlayableP14DirectorPlayeriP12Il2CppObject: __ZN18PlayableController4BindEP8PlayableP14DirectorPlayeriP12Il2CppObject, __ZN7mecanim5human18HumanGetFootHeightEPKNS0_5HumanEb: __ZN7mecanim5human18HumanGetFootHeightEPKNS0_5HumanEb, __ZNK5physx20PxsSolverCoreGeneral13solveVCoulombEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE: __ZNK5physx20PxsSolverCoreGeneral13solveVCoulombEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE, __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__212strstreambufC2Ei: __ZNSt3__212strstreambufC2Ei, __Z43UploadHandlerRaw_CUSTOM_InternalGetProgressP12Il2CppObject: __Z43UploadHandlerRaw_CUSTOM_InternalGetProgressP12Il2CppObject, _UNITY_png_set_user_transform_info: _UNITY_png_set_user_transform_info, _cf2_arrstack_clear: _cf2_arrstack_clear, __ZN5Umbra10StackAllocD2Ev: __ZN5Umbra10StackAllocD2Ev, __Z50Register_UnityEngine_Application_get_installerNamev: __Z50Register_UnityEngine_Application_get_installerNamev, __Z38Material_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectiR10ColorRGBAf: __Z38Material_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectiR10ColorRGBAf, __Z53AssetBundle_Get_Custom_PropIsStreamedSceneAssetBundleP12Il2CppObject: __Z53AssetBundle_Get_Custom_PropIsStreamedSceneAssetBundleP12Il2CppObject, __ZN5physx2Cm17FreeListAllocator9freeChunkEPNS0_5ChunkE: __ZN5physx2Cm17FreeListAllocator9freeChunkEPNS0_5ChunkE, __ZNK5Umbra15OcclusionBuffer20testAARectVisibilityERKNS_7Vector2ES3_fj: __ZNK5Umbra15OcclusionBuffer20testAARectVisibilityERKNS_7Vector2ES3_fj, __ZL40RuntimeInitializeOnSceneLoadedAfterAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZL40RuntimeInitializeOnSceneLoadedAfterAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_, __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEED0Ev: __ZN18MultiQueryCallbackIN5physx12PxRaycastHitEED0Ev, __ZN7mecanim8skeleton15Skeleton3BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_: __ZN7mecanim8skeleton15Skeleton3BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z38Rigidbody2D_Set_Custom_PropConstraintsP12Il2CppObjectN11Rigidbody2D11ConstraintsE: __Z38Rigidbody2D_Set_Custom_PropConstraintsP12Il2CppObjectN11Rigidbody2D11ConstraintsE, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, _UNITY_FT_Matrix_Multiply: _UNITY_FT_Matrix_Multiply, __ZN16ReflectionProbes8AddProbeE4PPtrI15ReflectionProbeE: __ZN16ReflectionProbes8AddProbeE4PPtrI15ReflectionProbeE, __Z43ConfigurableJoint_Get_Custom_PropSwapBodiesP12Il2CppObject: __Z43ConfigurableJoint_Get_Custom_PropSwapBodiesP12Il2CppObject, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE8setstateEj: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE8setstateEj, __ZN11ForceModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11ForceModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEE8TransferI14SafeBinaryReadEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEE8TransferI14SafeBinaryReadEEvRS6_RT_, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj12EEERAT__Kc, __ZNK5physx15NpParticleFluid2isENS_11PxActorType4EnumE: __ZNK5physx15NpParticleFluid2isENS_11PxActorType4EnumE, __Z53Register_UnityEngine_Terrain_set_detailObjectDistancev: __Z53Register_UnityEngine_Terrain_set_detailObjectDistancev, __Z46Mesh_CUSTOM_PrintErrorBadSubmeshIndexTrianglesP12Il2CppObject: __Z46Mesh_CUSTOM_PrintErrorBadSubmeshIndexTrianglesP12Il2CppObject, _UNITY_ft_glyphslot_free_bitmap: _UNITY_ft_glyphslot_free_bitmap, __ZN5physx16PxsBroadPhaseMBP13postUpdatePPUEPNS_10PxBaseTaskE: __ZN5physx16PxsBroadPhaseMBP13postUpdatePPUEPNS_10PxBaseTaskE, __ZN13GfxDeviceGLES23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_: __ZN13GfxDeviceGLES23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_, __Z38setPxVehicleDriveDynDataMGearUpPressedPN5physx21PxVehicleDriveDynDataEb: __Z38setPxVehicleDriveDynDataMGearUpPressedPN5physx21PxVehicleDriveDynDataEb, __ZNSt3__218__insertion_sort_3IRNS_6__lessIttEEPtEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIttEEPtEEvT0_S5_T_, __ZNK5physx2Cm12RenderBuffer10getNbLinesEv: __ZNK5physx2Cm12RenderBuffer10getNbLinesEv, __ZL26RegisterModuleICalls_Audiov: __ZL26RegisterModuleICalls_Audiov, __ZN19SkinnedMeshRenderer5ResetEv: __ZN19SkinnedMeshRenderer5ResetEv, __ZNK5physx7NpScene18getSolverBatchSizeEv: __ZNK5physx7NpScene18getSolverBatchSizeEv, __ZN12HandlerChain9MakeLocalER13FileEntryDatab: __ZN12HandlerChain9MakeLocalER13FileEntryDatab, __Z39Register_UnityEngine_Event_get_pressurev: __Z39Register_UnityEngine_Event_get_pressurev, __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11UnityEngine15CloudWebService19SessionEventManager31OnTimerExpiredPerformArchiveJobERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService19SessionEventManager31OnTimerExpiredPerformArchiveJobERNS0_16SessionContainerE, __ZN13GfxDeviceGLES16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode: __ZN13GfxDeviceGLES16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode, __Z48Register_UnityEngine_AI_NavMeshAgent_SetAreaCostv: __Z48Register_UnityEngine_AI_NavMeshAgent_SetAreaCostv, __ZN5audio5mixer27ClearExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryE: __ZN5audio5mixer27ClearExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryE, __ZN11MonoManagerD2Ev: __ZN11MonoManagerD2Ev, __ZN4FMOD8ChannelI14getLowPassGainEPf: __ZN4FMOD8ChannelI14getLowPassGainEPf, __Z48Register_UnityEngine_SpringJoint_set_maxDistancev: __Z48Register_UnityEngine_SpringJoint_set_maxDistancev, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN7ApiGLES9MapBufferEjN2gl12BufferTargetEllj: __ZN7ApiGLES9MapBufferEjN2gl12BufferTargetEllj, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __ZN17GenericDynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb: __ZN17GenericDynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb, __ZN14UnityAnalytics23OnSceneLoadedAfterAwakeEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZN14UnityAnalytics23OnSceneLoadedAfterAwakeEiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __ZN10Effector2D13RemoveContactEP9b2Contact: __ZN10Effector2D13RemoveContactEP9b2Contact, __Z45Register_UnityEngine_Light_get_shadowSoftnessv: __Z45Register_UnityEngine_Light_get_shadowSoftnessv, __Z49CharacterJoint_CUSTOM_INTERNAL_get_highTwistLimitP12Il2CppObjectP14SoftJointLimit: __Z49CharacterJoint_CUSTOM_INTERNAL_get_highTwistLimitP12Il2CppObjectP14SoftJointLimit, __Z52ParticleSystem_CollisionModule_CUSTOM_GetRadiusScaleP12Il2CppObject: __Z52ParticleSystem_CollisionModule_CUSTOM_GetRadiusScaleP12Il2CppObject, __ZN8Material21SetShaderKeywordNamesERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZN8Material21SetShaderKeywordNamesERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRN15ResourceManager10Dependency6SorterEPS2_EEvT0_S6_T_, __ZN13FileEntryDataD2Ev: __ZN13FileEntryDataD2Ev, __ZN5physx8debugger4comm17StringHandleEventD0Ev: __ZN5physx8debugger4comm17StringHandleEventD0Ev, __ZN18GfxFramebufferGLES10SetScissorERK5RectTIiE: __ZN18GfxFramebufferGLES10SetScissorERK5RectTIiE, __ZN8Animator15GetBodyRotationEv: __ZN8Animator15GetBodyRotationEv, __ZN5physx6shdfnd10checkValidEPKc: __ZN5physx6shdfnd10checkValidEPKc, __ZN16b2CapsuleContactD0Ev: __ZN16b2CapsuleContactD0Ev, __ZN15b2ContactFilterD2Ev: __ZN15b2ContactFilterD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj501ENS_22PxRepXPropertyAccessorILj501ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj501ENS_22PxRepXPropertyAccessorILj501ES4_ffEEEEvRKT0_, __ZN4PPtrI23ShaderVariantCollectionE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI23ShaderVariantCollectionE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK7Terrain26GetTypeInfoVirtualInternalEv: __ZNK7Terrain26GetTypeInfoVirtualInternalEv, __Z21getNbPxPhysics_ShapesPKN5physx9PxPhysicsE: __Z21getNbPxPhysics_ShapesPKN5physx9PxPhysicsE, __ZN18UnityPropertySheet25AssignDefinedPropertiesToER19ShaderPropertySheet: __ZN18UnityPropertySheet25AssignDefinedPropertiesToER19ShaderPropertySheet, __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMaxv: __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMaxv, __ZN11dtPathQueue4initEiiPK9dtNavMesh: __ZN11dtPathQueue4initEiiPK9dtNavMesh, __ZN19VREyeTextureManager17CreateEyeTexturesEf: __ZN19VREyeTextureManager17CreateEyeTexturesEf, __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_rotationv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_rotationv, __Z19b2ClipSegmentToLineP12b2ClipVertexPKS_RK6b2Vec2fi: __Z19b2ClipSegmentToLineP12b2ClipVertexPKS_RK6b2Vec2fi, __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j: __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j, __ZN9InputAxis8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9InputAxis8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx14NpRigidDynamicD2Ev: __ZN5physx14NpRigidDynamicD2Ev, __ZN5physx7NpCloth13setGlobalPoseERKNS_11PxTransformE: __ZN5physx7NpCloth13setGlobalPoseERKNS_11PxTransformE, __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE14GetUploadBytesEv: __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE14GetUploadBytesEv, __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_: __Z19GetReflectionSampleRK23ReflectionProbesContextRK10RenderNodeRK16ReflectionSamplePS5_, __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayMultiplierv, __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_, __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED0Ev: __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESED0Ev, __Z52Register_UnityEngine_AnimationClip_SetEventsInternalv: __Z52Register_UnityEngine_AnimationClip_SetEventsInternalv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEEEvPT_jRKT0_RKT1_j, __Z50Register_UnityEngine_TerrainData_get_treeInstancesv: __Z50Register_UnityEngine_TerrainData_get_treeInstancesv, __Z39TrailRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_: __Z39TrailRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_, __Z61Register_UnityEngine_Connect_UnityConnectSettings_get_enabledv: __Z61Register_UnityEngine_Connect_UnityConnectSettings_get_enabledv, __ZN5physx2Sc8ShapeSim16onResetFilteringEv: __ZN5physx2Sc8ShapeSim16onResetFilteringEv, __Z30ComputeBuffer_CUSTOM_CopyCountP12Il2CppObjectS0_i: __Z30ComputeBuffer_CUSTOM_CopyCountP12Il2CppObjectS0_i, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEED0Ev, __Z47Register_UnityEngine_AudioReverbZone_get_roomHFv: __Z47Register_UnityEngine_AudioReverbZone_get_roomHFv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEw, __Z32WebCamTexture_CUSTOM_GetPixels32P12Il2CppObjectP11Il2CppArray: __Z32WebCamTexture_CUSTOM_GetPixels32P12Il2CppObjectP11Il2CppArray, __Z21setPxMaterialUserDataPN5physx10PxMaterialEPv: __Z21setPxMaterialUserDataPN5physx10PxMaterialEPv, __ZN5physx10PxsContext11preAllocateEjjjj: __ZN5physx10PxsContext11preAllocateEjjjj, __Z61Register_UnityEngine_Camera_get_clearStencilAfterLightingPassv: __Z61Register_UnityEngine_Camera_get_clearStencilAfterLightingPassv, __Z35Physics_CUSTOM_IgnoreLayerCollisioniih: __Z35Physics_CUSTOM_IgnoreLayerCollisioniih, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j, __ZN5physx18NpArticulationLink12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx18NpArticulationLink12createObjectERPhRNS_24PxDeserializationContextE, __ZN21LightProbeProxyVolume15ThreadedCleanupEv: __ZN21LightProbeProxyVolume15ThreadedCleanupEv, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale0Ev, __Z18Transfer_BlittableI9JSONWriteLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13AnimationClip36ClipWasModifiedAndUpdateClipSettingsEv: __ZN13AnimationClip36ClipWasModifiedAndUpdateClipSettingsEv, __Z19setPxMeshScaleScalePN5physx11PxMeshScaleENS_6PxVec3E: __Z19setPxMeshScaleScalePN5physx11PxMeshScaleENS_6PxVec3E, __ZN15PolynomialCurve15DoubleIntegrateEv: __ZN15PolynomialCurve15DoubleIntegrateEv, __ZNK6Avatar7IsHumanEv: __ZNK6Avatar7IsHumanEv, __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN11Rigidbody2DD0Ev: __ZN11Rigidbody2DD0Ev, __ZN11AudioFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN11AudioFilter23VirtualRedirectTransferER14SafeBinaryRead, __Z18getPxD6Joint_TwistPKN5physx9PxD6JointE: __Z18getPxD6Joint_TwistPKN5physx9PxD6JointE, __ZNK26AnimatorControllerPlayable8GetAssetEv: __ZNK26AnimatorControllerPlayable8GetAssetEv, __Z32GL_CUSTOM_INTERNAL_get_modelviewP10Matrix4x4f: __Z32GL_CUSTOM_INTERNAL_get_modelviewP10Matrix4x4f, __Z24RegisterStrippedTypeInfoI17BillboardRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI17BillboardRendererEviPKcS2_, __Z26scripting_class_get_objectP11Il2CppClass: __Z26scripting_class_get_objectP11Il2CppClass, __ZNK9dtNavMesh9getTileAtEiii: __ZNK9dtNavMesh9getTileAtEiii, __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN14AnimationState22DidModifyAnimationClipEP13AnimationClipR4ListI8ListNodeIS_EE: __ZN14AnimationState22DidModifyAnimationClipEP13AnimationClipR4ListI8ListNodeIS_EE, __ZL22InitializeModule_Clothv: __ZL22InitializeModule_Clothv, __ZNK8Material16IsKeywordEnabledEPKc: __ZNK8Material16IsKeywordEnabledEPKc, __Z22Texture2D_CUSTOM_ApplyP12Il2CppObjecthh: __Z22Texture2D_CUSTOM_ApplyP12Il2CppObjecthh, __ZN5physx5cloth8intFloorERK8Scalar4f: __ZN5physx5cloth8intFloorERK8Scalar4f, __Z49ThreadAndSerializationSafeCheckInitFromMainThreadv: __Z49ThreadAndSerializationSafeCheckInitFromMainThreadv, __ZN9GfxDevice15InvalidateStateEv: __ZN9GfxDevice15InvalidateStateEv, __Z18SkinGenericMathLibILi1ELb1ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi1ELb1ELb0EEvR12SkinMeshInfo, __ZN4File4ReadEyPvj: __ZN4File4ReadEyPvj, __ZN5physx2Sc9ClothCore25setAngularDragCoefficientENS_6PxVec3E: __ZN5physx2Sc9ClothCore25setAngularDragCoefficientENS_6PxVec3E, __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE16getNbConstraintsEv: __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE16getNbConstraintsEv, __ZN9Scripting30SetCachedPtrOnScriptingWrapperEP12Il2CppObjectP6Object: __ZN9Scripting30SetCachedPtrOnScriptingWrapperEP12Il2CppObjectP6Object, __ZNK12b2MotorJoint10GetAnchorAEv: __ZNK12b2MotorJoint10GetAnchorAEv, __ZN5physx2Sc7BodySim22notifyReadyForSleepingEv: __ZN5physx2Sc7BodySim22notifyReadyForSleepingEv, __ZN5physx2Sc16ActorInteractionD2Ev: __ZN5physx2Sc16ActorInteractionD2Ev, __Z43Register_UnityEngine_AnimationCurve_Cleanupv: __Z43Register_UnityEngine_AnimationCurve_Cleanupv, __ZN17ArchiveFileSystem12MountArchiveEPKcS1_: __ZN17ArchiveFileSystem12MountArchiveEPKcS1_, __ZN16MinMaxPolyCurves20FindMinMaxIntegratedEv: __ZN16MinMaxPolyCurves20FindMinMaxIntegratedEv, __Z46Register_UnityEngine_Animation_GetStateAtIndexv: __Z46Register_UnityEngine_Animation_GetStateAtIndexv, __ZN23AllocationRootReference12AddReferenceEP24ProfilerAllocationHeaderj: __ZN23AllocationRootReference12AddReferenceEP24ProfilerAllocationHeaderj, __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpacev: __Z65Register_UnityEngine_ParticleSystem_MainModule_GetSimulationSpacev, __ZN15RelativeJoint2D18SetCorrectionScaleEf: __ZN15RelativeJoint2D18SetCorrectionScaleEf, __ZNK5physx2Cm19CmEventNameProvider15getProfileNamesEv: __ZNK5physx2Cm19CmEventNameProvider15getProfileNamesEv, __ZL12InbetweenJobP16InbetweenJobData: __ZL12InbetweenJobP16InbetweenJobData, __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z21DeleteFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __Z32getPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricEPjj: __Z32getPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricEPjj, __Z39CanvasGroup_Set_Custom_PropInteractableP12Il2CppObjecth: __Z39CanvasGroup_Set_Custom_PropInteractableP12Il2CppObjecth, __ZNK12CachedWriter11GetPositionEv: __ZNK12CachedWriter11GetPositionEv, __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy: __ZN13dynamic_arrayI4PPtrI8MaterialELj4EE18resize_initializedEjRKS2_12ResizePolicy, __Z50Playable_CUSTOM_INTERNAL_CALL_SetPlayStateInternalR9HPlayable9PlayState: __Z50Playable_CUSTOM_INTERNAL_CALL_SetPlayStateInternalR9HPlayable9PlayState, __ZL20UnityDetourAllocTempi: __ZL20UnityDetourAllocTempi, __ZNK16TypeTreeIterator10DebugPrintERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZNK16TypeTreeIterator10DebugPrintERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __Z15GetLODGroupAABBR10MinMaxAABBRK8LODGroup: __Z15GetLODGroupAABBR10MinMaxAABBRK8LODGroup, __ZNK13MonoBehaviour24IsSharedBetweenAnimatorsEv: __ZNK13MonoBehaviour24IsSharedBetweenAnimatorsEv, __ZN13MonoBehaviour16DelayedStartCallEP6ObjectPv: __ZN13MonoBehaviour16DelayedStartCallEP6ObjectPv, __ZN9GfxDevice25SetInvertProjectionMatrixEb: __ZN9GfxDevice25SetInvertProjectionMatrixEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _unzSetOffset: _unzSetOffset, __ZN5physx3Ext7D6Joint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext7D6Joint12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj165ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj165ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK11PreloadData18GetInstanceIDArrayER13dynamic_arrayIiLj4EE: __ZNK11PreloadData18GetInstanceIDArrayER13dynamic_arrayIiLj4EE, __ZN14NavMeshManager26UpdateAllNavMeshAgentCostsEif: __ZN14NavMeshManager26UpdateAllNavMeshAgentCostsEif, __Z30GUI_CUSTOM_Internal_EndWindowsv: __Z30GUI_CUSTOM_Internal_EndWindowsv, __ZNSt3__25ctypeIcED0Ev: __ZNSt3__25ctypeIcED0Ev, __Z34getPxVehicleDrive_ConcreteTypeNamePKN5physx14PxVehicleDriveE: __Z34getPxVehicleDrive_ConcreteTypeNamePKN5physx14PxVehicleDriveE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferentialNWDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_27PxVehicleDifferentialNWDataEE8pushNameEPKc, __ZNK5physx14NpSpatialIndex7raycastERKNS_6PxVec3ES3_fRNS_25PxSpatialLocationCallbackE: __ZNK5physx14NpSpatialIndex7raycastERKNS_6PxVec3ES3_fRNS_25PxSpatialLocationCallbackE, establishStackSpace: establishStackSpace, __ZN11UnityEngine15CloudWebService19SessionEventManager31ArchiveAndResetSessionContainerERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService19SessionEventManager31ArchiveAndResetSessionContainerERNS0_16SessionContainerE, __ZN13BoneInfluence8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13BoneInfluence8TransferI24GenerateTypeTreeTransferEEvRT_, __Z50AnimatorOverrideController_CUSTOM_GetOriginalClipsP12Il2CppObject: __Z50AnimatorOverrideController_CUSTOM_GetOriginalClipsP12Il2CppObject, __Z24RegisterStrippedTypeInfoI18ProceduralMaterialEviPKcS2_: __Z24RegisterStrippedTypeInfoI18ProceduralMaterialEviPKcS2_, __ZNK5Light16UnshareLightDataEv: __ZNK5Light16UnshareLightDataEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, __Z40Register_UnityEngine_Shader_GetGlobalIntv: __Z40Register_UnityEngine_Shader_GetGlobalIntv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev, __Z38Rigidbody2D_Set_Custom_PropAngularDragP12Il2CppObjectf: __Z38Rigidbody2D_Set_Custom_PropAngularDragP12Il2CppObjectf, __ZN15ArchiveReadFile9SetLengthEy: __ZN15ArchiveReadFile9SetLengthEy, __Z61Register_UnityEngine_ParticleEmitter_set_emitterVelocityScalev: __Z61Register_UnityEngine_ParticleEmitter_set_emitterVelocityScalev, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEEEE15growAndPushBackERKS2_, __ZN5Umbra13MatrixFactory5scaleERKNS_7Vector3E: __ZN5Umbra13MatrixFactory5scaleERKNS_7Vector3E, __ZN7Joint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN7Joint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN10Effector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10Effector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_connectedAnchorv: __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_connectedAnchorv, __ZN12_GLOBAL__N_121SphericalJointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_121SphericalJointProjectEPKvRN5physx11PxTransformES4_b, ___fpclassify: ___fpclassify, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_, __Z35PlatformDeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z35PlatformDeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXMultiplierv, __Z76Register_UnityEngine_UnityEventQueueSystem_INTERNAL_CALL_GetGlobalEventQueuev: __Z76Register_UnityEngine_UnityEventQueueSystem_INTERNAL_CALL_GetGlobalEventQueuev, __ZN14Texture2DArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14Texture2DArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z26profiler_initialize_threadPKcS0_: __Z26profiler_initialize_threadPKcS0_, __ZNK29BillboardTreeInstanceRenderer14RenderInstanceERK14ChannelAssigns: __ZNK29BillboardTreeInstanceRenderer14RenderInstanceERK14ChannelAssigns, __Z46Register_UnityEngine_GUIStyle_AssignStyleStatev: __Z46Register_UnityEngine_GUIStyle_AssignStyleStatev, _tt_cmap14_ensure: _tt_cmap14_ensure, __ZN27AnimatorControllerParameterC2Ev: __ZN27AnimatorControllerParameterC2Ev, __Z43LineRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf: __Z43LineRenderer_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf, __Z18Shader_CUSTOM_FindP12Il2CppString: __Z18Shader_CUSTOM_FindP12Il2CppString, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_17PxCapsuleGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_17PxCapsuleGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __Z14StringToUInt64PKc: __Z14StringToUInt64PKc, __ZN5physx8debugger15ForwardingArrayINS0_20PropertyMessageEntryEED0Ev: __ZN5physx8debugger15ForwardingArrayINS0_20PropertyMessageEntryEED0Ev, __Z22CalculateShadowMapSizeRK13ShadowJobData9LightTypeRK8Vector2fii: __Z22CalculateShadowMapSizeRK13ShadowJobData9LightTypeRK8Vector2fii, __Z47ParticleSystem_LightsModule_CUSTOM_SetMaxLightsP12Il2CppObjecti: __Z47ParticleSystem_LightsModule_CUSTOM_SetMaxLightsP12Il2CppObjecti, _UNITY_png_ascii_from_fp: _UNITY_png_ascii_from_fp, __Z35Renderer_Get_Custom_PropProbeAnchorP12Il2CppObject: __Z35Renderer_Get_Custom_PropProbeAnchorP12Il2CppObject, __ZN5physx2Sq11PruningPool12removeObjectEj: __ZN5physx2Sq11PruningPool12removeObjectEj, __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z18ConvertUTF8toUTF32RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayImLj4EE: __Z18ConvertUTF8toUTF32RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEER13dynamic_arrayImLj4EE, __ZN7mecanim9animation20GetMuscleCurveInMaskERKNS_6bitsetILj66EEEi: __ZN7mecanim9animation20GetMuscleCurveInMaskERKNS_6bitsetILj66EEEi, __Z42Register_UnityEngine_Screen_get_fullScreenv: __Z42Register_UnityEngine_Screen_get_fullScreenv, __ZN8Collider15ThreadedCleanupEv: __ZN8Collider15ThreadedCleanupEv, __ZN5physx2Gu28computeConvex_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbjRNS_10PxSweepHitE: __ZN5physx2Gu28computeConvex_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbjRNS_10PxSweepHitE, __ZNK12b2MouseJoint11GetMaxForceEv: __ZNK12b2MouseJoint11GetMaxForceEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcjj, __ZNK25ThreadsafeLinearAllocator8ContainsEPKv: __ZNK25ThreadsafeLinearAllocator8ContainsEPKv, __ZN5physx16NpParticleSystemD0Ev: __ZN5physx16NpParticleSystemD0Ev, __Z22Animation_CUSTOM_BlendP12Il2CppObjectP12Il2CppStringff: __Z22Animation_CUSTOM_BlendP12Il2CppObjectP12Il2CppStringff, __ZN14EmissionModule8TransferI14SafeBinaryReadEEvRT_: __ZN14EmissionModule8TransferI14SafeBinaryReadEEvRT_, _pthread_mutex_lock: _pthread_mutex_lock, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z35getPxSceneDescWakeCounterResetValuePKN5physx11PxSceneDescE: __Z35getPxSceneDescWakeCounterResetValuePKN5physx11PxSceneDescE, __Z29StdTemplateConversionFunctionIstEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIstEbPvR14SafeBinaryRead, __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_anchorv: __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_anchorv, __ZN12SoundManager14OnExitPlayModeEv: __ZN12SoundManager14OnExitPlayModeEv, __Z48Register_UnityEngine_AudioSource_get_timeSamplesv: __Z48Register_UnityEngine_AudioSource_get_timeSamplesv, __ZN5physx19PxcContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx19PxcContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z33WheelCollider_Get_Custom_PropMassP12Il2CppObject: __Z33WheelCollider_Get_Custom_PropMassP12Il2CppObject, __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetRadiusv: __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetRadiusv, __ZN5Unity17ConfigurableJoint17SetAngularYMotionEi: __ZN5Unity17ConfigurableJoint17SetAngularYMotionEi, __ZN22RenderingCommandBuffer20AddClearRenderTargetEjRK10ColorRGBAffj: __ZN22RenderingCommandBuffer20AddClearRenderTargetEjRK10ColorRGBAffj, __Z28TestAssetBundleCompatibilityRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_: __Z28TestAssetBundleCompatibilityRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_, ___dn_expand: ___dn_expand, __ZL27ForwardInvokeDelayedCleanupPv: __ZL27ForwardInvokeDelayedCleanupPv, __ZN20SphericalHarmonicsL211AddWeightedERK20SphericalHarmonicsL1f: __ZN20SphericalHarmonicsL211AddWeightedERK20SphericalHarmonicsL1f, __Z50ScriptingGetComponentsOfTypeFromGameObjectFastPathP10GameObjectP12Il2CppObject: __Z50ScriptingGetComponentsOfTypeFromGameObjectFastPathP10GameObjectP12Il2CppObject, __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEESK_EERKT_, __ZNSt3__215recursive_mutexC2Ev: __ZNSt3__215recursive_mutexC2Ev, __ZNK13WheelCollider17GetVehicleNoDriveEv: __ZNK13WheelCollider17GetVehicleNoDriveEv, __ZN10FileSystem13StaticDestroyEPv: __ZN10FileSystem13StaticDestroyEPv, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __Z33Register_UnityEngine_GL_LoadOrthov: __Z33Register_UnityEngine_GL_LoadOrthov, __Z21FilterCubeMapMipChainP13CImageSurfaceS0_iRK17CubemapgenOptionsf: __Z21FilterCubeMapMipChainP13CImageSurfaceS0_iRK17CubemapgenOptionsf, __ZN13GfxDeviceGLES23ClearRandomWriteTargetsEv: __ZN13GfxDeviceGLES23ClearRandomWriteTargetsEv, __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14VelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14VelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZThn12_N5physx3Ext13RevoluteJointD1Ev: __ZThn12_N5physx3Ext13RevoluteJointD1Ev, __Z30getPxVehicleDriveMDriveDynDataPKN5physx14PxVehicleDriveE: __Z30getPxVehicleDriveMDriveDynDataPKN5physx14PxVehicleDriveE, __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_: __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_, __GLOBAL__sub_I_modules_particleslegacy_private_lump_cpp: __GLOBAL__sub_I_modules_particleslegacy_private_lump_cpp, __Z66Register_UnityEngine_GUIText_INTERNAL_CALL_Internal_SetPixelOffsetv: __Z66Register_UnityEngine_GUIText_INTERNAL_CALL_Internal_SetPixelOffsetv, __ZNK13TranslateGLES15FramebufferMaskEN2gl15FramebufferMaskE: __ZNK13TranslateGLES15FramebufferMaskEN2gl15FramebufferMaskE, __Z52Register_UnityEngine_ParticleSystemRenderer_get_meshv: __Z52Register_UnityEngine_ParticleSystemRenderer_get_meshv, __Z16sweepBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z16sweepBox_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z34ReflectionProbe_CUSTOM_RenderProbeP12Il2CppObjectS0_: __Z34ReflectionProbe_CUSTOM_RenderProbeP12Il2CppObjectS0_, __Z49Rigidbody_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK8Vector3fS3_i: __Z49Rigidbody_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK8Vector3fS3_i, __Z30Joint_CUSTOM_INTERNAL_set_axisP12Il2CppObjectRK8Vector3f: __Z30Joint_CUSTOM_INTERNAL_set_axisP12Il2CppObjectRK8Vector3f, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z36WheelJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth: __Z36WheelJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth, __Z44Animator_Get_Custom_PropLeftFeetBottomHeightP12Il2CppObject: __Z44Animator_Get_Custom_PropLeftFeetBottomHeightP12Il2CppObject, __Z54Register_UnityEngine_AudioSource_get_bypassReverbZonesv: __Z54Register_UnityEngine_AudioSource_get_bypassReverbZonesv, __Z56SystemInfo_Get_Custom_PropSupportsRawShadowDepthSamplingv: __Z56SystemInfo_Get_Custom_PropSupportsRawShadowDepthSamplingv, __ZN5physx22PxVehicleWheelsSimData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx22PxVehicleWheelsSimData17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN14TerrainManager13RemoveTerrainEP7Terrain: __ZN14TerrainManager13RemoveTerrainEP7Terrain, _jpeg_input_complete: _jpeg_input_complete, __ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj: __ZN5Umbra20RuntimeTomeGenerator17constructSubtreesEPiiRNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEifbj, __ZN20TerrainPhysicsModule21AttachTerrainColliderER10GameObjectP11TerrainData: __ZN20TerrainPhysicsModule21AttachTerrainColliderER10GameObjectP11TerrainData, __ZN10AudioMixer20GetGroupPathFromGUIDERK9UnityGUID: __ZN10AudioMixer20GetGroupPathFromGUIDERK9UnityGUID, __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9shadertag14GetShaderTagIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z39Application_CUSTOM_HasUserAuthorizationi: __Z39Application_CUSTOM_HasUserAuthorizationi, __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEED0Ev: __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEED0Ev, __ZN5physx2Gu16getPCMConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE: __ZN5physx2Gu16getPCMConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE, __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj: __ZN19ShaderPropertySheet16SetArrayPropertyERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEPKvjj, __Z18HandleSteppedCurveRK11KeyframeTplI11QuaternionfES3_RS0_: __Z18HandleSteppedCurveRK11KeyframeTplI11QuaternionfES3_RS0_, __ZN5physx14NpRigidDynamic17setSleepThresholdEf: __ZN5physx14NpRigidDynamic17setSleepThresholdEf, __ZN9Animation8GetStateEP14AnimationState: __ZN9Animation8GetStateEP14AnimationState, __ZN14TimerQueryGLES10PollResultERyb: __ZN14TimerQueryGLES10PollResultERyb, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4rendEv, __ZNSt3__221__thread_specific_ptrINS_15__thread_structEEC2Ev: __ZNSt3__221__thread_specific_ptrINS_15__thread_structEEC2Ev, __ZN14GfxDeviceStats10StateStats5ResetEv: __ZN14GfxDeviceStats10StateStats5ResetEv, __ZNK16LightmapSettings26GetTypeInfoVirtualInternalEv: __ZNK16LightmapSettings26GetTypeInfoVirtualInternalEv, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z30getPxSceneDescDynamicStructurePKN5physx11PxSceneDescE: __Z30getPxSceneDescDynamicStructurePKN5physx11PxSceneDescE, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj14EEERAT__Kc, __Z51ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve: __Z51ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve, __ZL37StaticInitializeAudioSourceFilterRootPv: __ZL37StaticInitializeAudioSourceFilterRootPv, __ZN5physx2Gu23computeBoxTriImpactDataERNS_6PxVec3ES2_RKS1_S4_S4_S4_RKNS_10PxTriangleE: __ZN5physx2Gu23computeBoxTriImpactDataERNS_6PxVec3ES2_RKS1_S4_S4_S4_RKNS_10PxTriangleE, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx18PxVehicleGraphDescC2Ev: __ZN5physx18PxVehicleGraphDescC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK6Camera22CalculateFrustumPlanesEP5PlaneRK10Matrix4x4ffRfb: __ZNK6Camera22CalculateFrustumPlanesEP5PlaneRK10Matrix4x4ffRfb, __ZN7ApiGLES11BindSamplerEij: __ZN7ApiGLES11BindSamplerEij, __ZN5physx15PxVehicleUpdate18suspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb: __ZN5physx15PxVehicleUpdate18suspensionRaycastsEPNS_12PxBatchQueryEjPPNS_15PxVehicleWheelsEjPNS_18PxBatchQueryResultINS_12PxRaycastHitEEEPKb, __ZN5physx3Scb5Scene13addShapeToPvdERNS0_5ShapeERNS_7PxActorE: __ZN5physx3Scb5Scene13addShapeToPvdERNS0_5ShapeERNS_7PxActorE, __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx3Scb14ParticleSystem20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, _mprotect: _mprotect, __ZN8Collider10SetupLayerEv: __ZN8Collider10SetupLayerEv, __Z51TextGenerator_Get_Custom_PropFontSizeUsedForBestFitP12Il2CppObject: __Z51TextGenerator_Get_Custom_PropFontSizeUsedForBestFitP12Il2CppObject, __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j, __Z37setPxClothMotionConstraintConfigScalePN5physx29PxClothMotionConstraintConfigEf: __Z37setPxClothMotionConstraintConfigScalePN5physx29PxClothMotionConstraintConfigEf, __Z10DestripifyPKtiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __Z10DestripifyPKtiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __Z39Register_UnityEngine_Rigidbody2D_WakeUpv: __Z39Register_UnityEngine_Rigidbody2D_WakeUpv, __ZL30MonoBehaviourGetObjectGUIStatePv: __ZL30MonoBehaviourGetObjectGUIStatePv, __ZNK5physx3Cct15ObstacleContext19getObstacleByHandleEj: __ZNK5physx3Cct15ObstacleContext19getObstacleByHandleEj, __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaSERKS4_: __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaSERKS4_, __ZN13AnimationClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13AnimationClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetnEPwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetnEPwi, __Z13InvokeDelayedR13MonoBehaviourR11ICallStringff: __Z13InvokeDelayedR13MonoBehaviourR11ICallStringff, __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE: __ZN20ArchiveStorageHeader17ReadDirectoryInfoER12FileAccessorRKNS_6HeaderERNS_13DirectoryInfoE, __ZN5physx3Scb5Scene21addBodyAndShapesToPvdERNS0_4BodyE: __ZN5physx3Scb5Scene21addBodyAndShapesToPvdERNS0_4BodyE, __ZL31GeomOverlapCallback_SpherePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL31GeomOverlapCallback_SpherePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __Z10anyGreaterRK8Scalar4fS1_RS_: __Z10anyGreaterRK8Scalar4fS1_RS_, __ZN9Coroutine17ContinueCoroutineEP6ObjectPv: __ZN9Coroutine17ContinueCoroutineEP6ObjectPv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN22ParticleSystemRendererD0Ev: __ZN22ParticleSystemRendererD0Ev, __ZN9Texture2D17MainThreadCleanupEv: __ZN9Texture2D17MainThreadCleanupEv, __ZN5Umbra10QueryState7mapTomeERNS_10MappedTomeEi: __ZN5Umbra10QueryState7mapTomeERNS_10MappedTomeEi, __Z70Register_UnityEngine_DynamicGI_INTERNAL_CALL_UpdateMaterialsForTerrainv: __Z70Register_UnityEngine_DynamicGI_INTERNAL_CALL_UpdateMaterialsForTerrainv, __ZN13dynamic_arrayIiLj4EEC2ERKS0_: __ZN13dynamic_arrayIiLj4EEC2ERKS0_, __ZNK12UnityVersionltERKS_: __ZNK12UnityVersionltERKS_, __ZN15ReflectionProbe12CleanupClassEv: __ZN15ReflectionProbe12CleanupClassEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL16term_destinationP20jpeg_compress_struct: __ZL16term_destinationP20jpeg_compress_struct, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCentrifugalInertiaERKNS_6PxVec3E, __Z57Register_UnityEngine_ParticleRenderer_get_maxParticleSizev: __Z57Register_UnityEngine_ParticleRenderer_get_maxParticleSizev, __Z13UpdateMoveJobP9CrowdInfoj: __Z13UpdateMoveJobP9CrowdInfoj, __ZN20TextRenderingPrivate8FontImpl19HasCharacterDynamicEj: __ZN20TextRenderingPrivate8FontImpl19HasCharacterDynamicEj, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED0Ev, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_yearES4_S4_RNS_8ios_baseERjP2tm, _ft_black_reset: _ft_black_reset, __Z43Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointRK13Vector2fIcalliff: __Z43Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointRK13Vector2fIcalliff, _prepare_for_output_pass: _prepare_for_output_pass, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags, __Z39GUIUtility_CUSTOM_GetPermanentControlIDv: __Z39GUIUtility_CUSTOM_GetPermanentControlIDv, __Z27CreatePxStreamFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypeR12MemoryStream: __Z27CreatePxStreamFromUnityMeshP4MeshbbRK10Matrix4x4f13TransformTypeR12MemoryStream, __Z48Terrain_CUSTOM_ApplyDelayedHeightmapModificationP12Il2CppObject: __Z48Terrain_CUSTOM_ApplyDelayedHeightmapModificationP12Il2CppObject, __Z32GetShaderInstanceMatrixParamNamei: __Z32GetShaderInstanceMatrixParamNamei, __ZN15QualitySettingsD0Ev: __ZN15QualitySettingsD0Ev, __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEED0Ev, __ZN15b2ContactSolverD2Ev: __ZN15b2ContactSolverD2Ev, __ZN18AssetBundleManager29CollectPreloadDataRecursivelyEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEERK13dynamic_arrayIiLj4EER19InstanceIDHashTableIPKNS0_9AssetInfoENS3_4pairIKiSI_EEE: __ZN18AssetBundleManager29CollectPreloadDataRecursivelyEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEERK13dynamic_arrayIiLj4EER19InstanceIDHashTableIPKNS0_9AssetInfoENS3_4pairIKiSI_EEE, __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E: __Z15CalculateMinMaxRKN4math7_float2ERKNS_7_float4E, __Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture: __Z15CubemapGPUBlendP7TextureS0_fP13RenderTexture, __ZN5physx7NpShape8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx7NpShape8requiresERNS_23PxProcessPxBaseCallbackE, __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_117parse_source_nameINS0_2DbEEEPKcS4_S4_RT_, __Z48LODGroup_CUSTOM_INTERNAL_get_localReferencePointP12Il2CppObjectP8Vector3f: __Z48LODGroup_CUSTOM_INTERNAL_get_localReferencePointP12Il2CppObjectP8Vector3f, __ZN11UnityEngine9Animation28GenericAnimationBindingCache15BindPPtrGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE: __ZN11UnityEngine9Animation28GenericAnimationBindingCache15BindPPtrGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE, __ZN19CharacterController12SetSkinWidthEf: __ZN19CharacterController12SetSkinWidthEf, __ZN12CubemapArray13RebuildMipMapEv: __ZN12CubemapArray13RebuildMipMapEv, __ZN14PhysicsManager11RaycastTestERK3Rayfi23QueryTriggerInteraction: __ZN14PhysicsManager11RaycastTestERK3Rayfi23QueryTriggerInteraction, __ZN14RenderSettings23UpdateFinalAmbientProbeEv: __ZN14RenderSettings23UpdateFinalAmbientProbeEv, __ZNK39AssetBundleLoadFromStreamAsyncOperation18GetDownloadedBytesEv: __ZNK39AssetBundleLoadFromStreamAsyncOperation18GetDownloadedBytesEv, __Z50Register_UnityEngine_AudioSource_get_bypassEffectsv: __Z50Register_UnityEngine_AudioSource_get_bypassEffectsv, __ZN17ArchiveFileSystem16DestroyFileEntryER13FileEntryData: __ZN17ArchiveFileSystem16DestroyFileEntryER13FileEntryData, __Z29IsApplicationGenuineAvailablev: __Z29IsApplicationGenuineAvailablev, __ZN8Material16SetComputeBufferEN9ShaderLab16FastPropertyNameE15ComputeBufferID: __ZN8Material16SetComputeBufferEN9ShaderLab16FastPropertyNameE15ComputeBufferID, __ZN11TimeManager8SetPauseEb: __ZN11TimeManager8SetPauseEb, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __Z45Register_UnityEngine_LensFlare_set_brightnessv: __Z45Register_UnityEngine_LensFlare_set_brightnessv, __Z51RenderSettings_Set_Custom_PropDefaultReflectionModeN14RenderSettings21DefaultReflectionModeE: __Z51RenderSettings_Set_Custom_PropDefaultReflectionModeN14RenderSettings21DefaultReflectionModeE, __ZNK9Rigidbody15GetCenterOfMassEv: __ZNK9Rigidbody15GetCenterOfMassEv, __ZNSt3__212__rs_defaultC2ERKS0_: __ZNSt3__212__rs_defaultC2ERKS0_, __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI9TransformE8TransferI14SafeBinaryReadEEvRT_, __Z43TerrainData_Set_Custom_PropWavingGrassSpeedP12Il2CppObjectf: __Z43TerrainData_Set_Custom_PropWavingGrassSpeedP12Il2CppObjectf, __Z44Register_UnityEngine_Application_get_genuinev: __Z44Register_UnityEngine_Application_get_genuinev, _unity_z_deflateTune: _unity_z_deflateTune, __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN7ApiGLES17BindUniformBufferEjj: __ZN7ApiGLES17BindUniformBufferEjj, __Z30Animator_CUSTOM_GetLayerWeightP12Il2CppObjecti: __Z30Animator_CUSTOM_GetLayerWeightP12Il2CppObjecti, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN5Mutex18BlockUntilUnlockedEv: __ZN5Mutex18BlockUntilUnlockedEv, __ZNK10FileSystem18SetApplicationPathEPKc: __ZNK10FileSystem18SetApplicationPathEPKc, __ZN5physx6shdfnd10ThreadImpl5getIdEv: __ZN5physx6shdfnd10ThreadImpl5getIdEv, __ZNK20DynamicPropertySheet17HasQueuedPropertyEN9ShaderLab16FastPropertyNameEN19ShaderPropertySheet12PropertyTypeE: __ZNK20DynamicPropertySheet17HasQueuedPropertyEN9ShaderLab16FastPropertyNameEN19ShaderPropertySheet12PropertyTypeE, __ZN12ImageFilters21GetTargetBeforeOpaqueEv: __ZN12ImageFilters21GetTargetBeforeOpaqueEv, _UnityReplayKitLastError: _UnityReplayKitLastError, __ZN8Animator11TargetMatchEv: __ZN8Animator11TargetMatchEv, __Z57Register_UnityEngine_WheelCollider_set_suspensionDistancev: __Z57Register_UnityEngine_WheelCollider_set_suspensionDistancev, __ZNK22DownloadHandlerTexture9GetLengthEv: __ZNK22DownloadHandlerTexture9GetLengthEv, __ZN12AudioManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN12AudioManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN17AnimationCurveTplI8Vector3fE6AddKeyERK11KeyframeTplIS0_E: __ZN17AnimationCurveTplI8Vector3fE6AddKeyERK11KeyframeTplIS0_E, __Z38ParticleEmitter_Get_Custom_PropMaxSizeP12Il2CppObject: __Z38ParticleEmitter_Get_Custom_PropMaxSizeP12Il2CppObject, __ZN8VRDevice21SetStereoRenderTargetEP6Camera15StereoscopicEye16SinglePassStereo: __ZN8VRDevice21SetStereoRenderTargetEP6Camera15StereoscopicEye16SinglePassStereo, __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb: __ZN5physx14PxRigidBodyExt20updateMassAndInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb, __Z49Rigidbody2D_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP13Vector2fIcall: __Z49Rigidbody2D_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP13Vector2fIcall, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE25getRelativeLinearVelocityEv, __ZNK17UniqueIDGenerator6ExistsE13UniqueSmallID: __ZNK17UniqueIDGenerator6ExistsE13UniqueSmallID, _catanh: _catanh, __Z40Camera_Get_Custom_PropLayerCullSphericalP12Il2CppObject: __Z40Camera_Get_Custom_PropLayerCullSphericalP12Il2CppObject, __ZN8GUIState24GetNextKeyboardControlIDERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb: __ZN8GUIState24GetNextKeyboardControlIDERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb, __Z29StdTemplateConversionFunctionIhyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhyEbPvR14SafeBinaryRead, _catanl: _catanl, __ZNK11AudioSource15GetDopplerLevelEv: __ZNK11AudioSource15GetDopplerLevelEv, __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_17MemoryEventHeaderE: __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_17MemoryEventHeaderE, __ZZN16AnimationManager15InitializeClassEvEN40PreLateUpdateLegacyAnimationUpdatestruct7ForwardEv: __ZZN16AnimationManager15InitializeClassEvEN40PreLateUpdateLegacyAnimationUpdatestruct7ForwardEv, _catanf: _catanf, _UNITY_FT_Destroy_Class_pscmaps_services: _UNITY_FT_Destroy_Class_pscmaps_services, __Z52Register_UnityEngine_AndroidJNI_GetFloatArrayElementv: __Z52Register_UnityEngine_AndroidJNI_GetFloatArrayElementv, __ZN4FMOD8ChannelI19set3DMinMaxDistanceEff: __ZN4FMOD8ChannelI19set3DMinMaxDistanceEff, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED0Ev, __ZNSt3__212bad_weak_ptrD2Ev: __ZNSt3__212bad_weak_ptrD2Ev, __Z32setPxVehicleAutoBoxData_UpRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf: __Z32setPxVehicleAutoBoxData_UpRatiosPN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumEf, __Z34Camera_Set_Custom_PropFarClipPlaneP12Il2CppObjectf: __Z34Camera_Set_Custom_PropFarClipPlaneP12Il2CppObjectf, __ZN5physx16PxsIslandManager12resizeArraysEv: __ZN5physx16PxsIslandManager12resizeArraysEv, __ZN12_GLOBAL__N_122createArticulationLinkERN5physx14NpArticulationEPNS0_18NpArticulationLinkERKNS0_11PxTransformE: __ZN12_GLOBAL__N_122createArticulationLinkERN5physx14NpArticulationEPNS0_18NpArticulationLinkERKNS0_11PxTransformE, __ZNK19CharacterController22GetWorldCenterPositionEv: __ZNK19CharacterController22GetWorldCenterPositionEv, __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE: __Z24collideWithMeshTrianglesRN5physx19PxsParticleCollDataERKNS_2Gu24InternalTriangleMeshDataERKNS_2Cm23FastVertex2ShapeScalingEPKNS_6PxVec3EjfRKNS_11PxTransformE, __ZN5physx21PxClothRepXSerializer16objectToFileImplEPKNS_7PxClothEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxClothRepXSerializer16objectToFileImplEPKNS_7PxClothEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z22getPxRigidBody_InvMassPKN5physx11PxRigidBodyE: __Z22getPxRigidBody_InvMassPKN5physx11PxRigidBodyE, __ZNSt3__227__insertion_sort_incompleteIR11IndexSorterPiEEbT0_S4_T_: __ZNSt3__227__insertion_sort_incompleteIR11IndexSorterPiEEbT0_S4_T_, __Z30Sampler_Set_Custom_PropEnabledP12Il2CppObjecth: __Z30Sampler_Set_Custom_PropEnabledP12Il2CppObjecth, __Z11GetIPhysicsv: __Z11GetIPhysicsv, __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN26DownloadHandlerAssetBundle14GetAssetBundleEv: __ZN26DownloadHandlerAssetBundle14GetAssetBundleEv, __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf: __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeEf, __ZN18MultiFrameGUIState18ClearNamedControlsEv: __ZN18MultiFrameGUIState18ClearNamedControlsEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv, __ZN16LightmapSettings17SetGIWorkflowModeEN9Lightmaps14GIWorkflowModeE: __ZN16LightmapSettings17SetGIWorkflowModeEN9Lightmaps14GIWorkflowModeE, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject, _mkstemp: _mkstemp, __ZN12_GLOBAL__N_111StreamOwnerD2Ev: __ZN12_GLOBAL__N_111StreamOwnerD2Ev, __Z35PointEffector2D_Set_Custom_PropDragP12Il2CppObjectf: __Z35PointEffector2D_Set_Custom_PropDragP12Il2CppObjectf, __ZN5physx7NpSceneD2Ev: __ZN5physx7NpSceneD2Ev, __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN13sorted_vectorINSt3__24pairIP11Il2CppClassPKN5Unity4TypeEEEN10vector_mapIS3_S7_NS0_4lessIS3_EENS0_9allocatorIS8_EEE13value_compareESD_E21sort_clear_duplicatesEv: __ZN13sorted_vectorINSt3__24pairIP11Il2CppClassPKN5Unity4TypeEEEN10vector_mapIS3_S7_NS0_4lessIS3_EENS0_9allocatorIS8_EEE13value_compareESD_E21sort_clear_duplicatesEv, __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_: __ZNSt3__26__sortIR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j, __Z12StringToGUIDRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z12StringToGUIDRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z25AddPPtrCurveToClipBuilderR13dynamic_arrayI12PPtrKeyframeLj4EERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilder: __Z25AddPPtrCurveToClipBuilderR13dynamic_arrayI12PPtrKeyframeLj4EERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilder, __ZN5physx19PxsConstraintHelper21setupSolverConstraintERKNS_11PxTransformES3_PKNS_13PxcSolverBodyES6_PNS_17PxcSolverBodyDataES8_PFjPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvS3_S3_ESG_jffRNS_23PxcSolverConstraintDescERKNS_13PxsConstraintERNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE: __ZN5physx19PxsConstraintHelper21setupSolverConstraintERKNS_11PxTransformES3_PKNS_13PxcSolverBodyES6_PNS_17PxcSolverBodyDataES8_PFjPNS_14Px1DConstraintERNS_6PxVec3EjRNS_24PxConstraintInvMassScaleEPKvS3_S3_ESG_jffRNS_23PxcSolverConstraintDescERKNS_13PxsConstraintERNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE, __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sc8BodyCore14setWakeCounterEfb: __ZN5physx2Sc8BodyCore14setWakeCounterEfb, __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc18ParticleSystemCoreENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZZ23InitPlayerLoopCallbacksvEN36EarlyUpdatePresentBeforeUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36EarlyUpdatePresentBeforeUpdatestruct7ForwardEv, __ZN9WWWCached23HasDownloadedOrMayBlockEv: __ZN9WWWCached23HasDownloadedOrMayBlockEv, __ZL25CullLocalShadowCastersJobP25LocalShadowCullingJobDataj: __ZL25CullLocalShadowCastersJobP25LocalShadowCullingJobDataj, __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc18TriggerInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5physx7NpCloth25setAngularDragCoefficientENS_6PxVec3E: __ZN5physx7NpCloth25setAngularDragCoefficientENS_6PxVec3E, __ZN4Halo5ResetEv: __ZN4Halo5ResetEv, __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN13AvatarBuilder21IsValidHumanHierarchyERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE: __ZN13AvatarBuilder21IsValidHumanHierarchyERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE, __ZN6prcoreL12RemapGenericI15TexFormatBGR88817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatBGR88817TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE8pushNameEPKc, __ZN5physx6shdfnd9SListImpl3popEv: __ZN5physx6shdfnd9SListImpl3popEv, __Z55Register_UnityEngine_AudioSettings_get_outputSampleRatev: __Z55Register_UnityEngine_AudioSettings_get_outputSampleRatev, __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInternalv: __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInternalv, __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_: __ZNK15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E13find_positionERS4_, __Z27RegisterModuleClasses_WebGLv: __Z27RegisterModuleClasses_WebGLv, __ZN13RendererScene11AddRendererEP8Renderer: __ZN13RendererScene11AddRendererEP8Renderer, _UNITY_png_write_tEXt: _UNITY_png_write_tEXt, __ZN9InputAxisaSERKS_: __ZN9InputAxisaSERKS_, __ZN18SpeedTreeWindAssetD2Ev: __ZN18SpeedTreeWindAssetD2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags, __Z50ParticleSystemRenderer_Get_Custom_PropSortingFudgeP12Il2CppObject: __Z50ParticleSystemRenderer_Get_Custom_PropSortingFudgeP12Il2CppObject, __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_: __ZN17GlobalGameManager8TransferI14SafeBinaryReadEEvRT_, __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN13ConstantForce8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13ConstantForce8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj670ES2_RKNS_30PxVehicleAckermannGeometryDataES6_EEKNS_43PxVehicleAckermannGeometryDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj670ES2_RKNS_30PxVehicleAckermannGeometryDataES6_EEKNS_43PxVehicleAckermannGeometryDataGeneratedInfoEEEvPjRKT_RT0_, __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17AnimationCurveTplI8Vector3fE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetVelocityv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetVelocityv, __ZN9GfxDevice14ImmediateShapeEffffNS_18ImmediateShapeTypeE: __ZN9GfxDevice14ImmediateShapeEffffNS_18ImmediateShapeTypeE, __ZN20TextRenderingPrivate8FontImpl12LoadAllFontsEv: __ZN20TextRenderingPrivate8FontImpl12LoadAllFontsEv, __ZN8Animator13IsPlayingBackEv: __ZN8Animator13IsPlayingBackEv, __Z21Event_CUSTOM_InitCopyP12Il2CppObjectS0_: __Z21Event_CUSTOM_InitCopyP12Il2CppObjectS0_, __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags, __ZN15TerrainRenderer11RenderStep1EPK6Cameraiff: __ZN15TerrainRenderer11RenderStep1EPK6Cameraiff, __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j: __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j, __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetMatrixv: __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetMatrixv, __ZNK5physx2Sc5Scene9getLimitsEv: __ZNK5physx2Sc5Scene9getLimitsEv, __ZN13ComputeBuffer22UnloadAllFromGfxDeviceEv: __ZN13ComputeBuffer22UnloadAllFromGfxDeviceEv, __ZNK5physx16PxVehicleNoDrive13getSteerAngleEj: __ZNK5physx16PxVehicleNoDrive13getSteerAngleEj, __Z41Register_UnityEngine_Animator_ResolveHashv: __Z41Register_UnityEngine_Animator_ResolveHashv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags, __Z13RegisterClassI7CubemapEvv: __Z13RegisterClassI7CubemapEvv, __Z39Physics2D_Set_Custom_PropBaumgarteScalef: __Z39Physics2D_Set_Custom_PropBaumgarteScalef, __ZN8Animator27FreeGlobalSpaceSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEE: __ZN8Animator27FreeGlobalSpaceSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEE, __ZN15ApplicationInfo16GetInstallerNameEv: __ZN15ApplicationInfo16GetInstallerNameEv, __ZN4FMOD6System19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD6System19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES, __ZN12FixedJoint2D12SetFrequencyEf: __ZN12FixedJoint2D12SetFrequencyEf, __ZN5Unity10FixedJoint15ThreadedCleanupEv: __ZN5Unity10FixedJoint15ThreadedCleanupEv, __Z52Register_UnityEngine_Rigidbody2D_get_angularVelocityv: __Z52Register_UnityEngine_Rigidbody2D_get_angularVelocityv, __ZN5physx3Cct17CapsuleController8getSceneEv: __ZN5physx3Cct17CapsuleController8getSceneEv, __Z23SetGlobalBoolPreferencePKcb: __Z23SetGlobalBoolPreferencePKcb, _vsprintf: _vsprintf, __ZThn8_N12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv: __ZThn8_N12_GLOBAL__N_111StreamOwner18getWrittenDataSizeEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __Z26GUI_Set_Custom_PropChangedh: __Z26GUI_Set_Custom_PropChangedh, __ZThn24_N5physx2Sc21ConstraintInteractionD1Ev: __ZThn24_N5physx2Sc21ConstraintInteractionD1Ev, __Z46DownloadHandler_CUSTOM_InternalCreateAudioClipP12Il2CppObjectP12Il2CppStringi: __Z46DownloadHandler_CUSTOM_InternalCreateAudioClipP12Il2CppObjectP12Il2CppStringi, __ZN22MemoryCacherReadBlocksD0Ev: __ZN22MemoryCacherReadBlocksD0Ev, __ZN5physx2Sn17readAllPropertiesINS_17PxTolerancesScaleEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_17PxTolerancesScaleEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN34ColorBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN34ColorBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z40WheelCollider_Set_Custom_PropMotorTorqueP12Il2CppObjectf: __Z40WheelCollider_Set_Custom_PropMotorTorqueP12Il2CppObjectf, __Z46Register_UnityEngine_Texture2DArray_get_formatv: __Z46Register_UnityEngine_Texture2DArray_get_formatv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16setContactOffsetEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16setContactOffsetEf, __ZN9GfxDevice20GetVertexDeclarationERK18VertexChannelsInfo: __ZN9GfxDevice20GetVertexDeclarationERK18VertexChannelsInfo, __ZN5physx3Cct10Controller16createProxyActorERNS_9PxPhysicsERKNS_10PxGeometryERKNS_10PxMaterialE: __ZN5physx3Cct10Controller16createProxyActorERNS_9PxPhysicsERKNS_10PxGeometryERKNS_10PxMaterialE, __ZN5physx2Sc7Element21destroyLowLevelVolumeEv: __ZN5physx2Sc7Element21destroyLowLevelVolumeEv, __Z24RegisterStrippedTypeInfoI16BaseVideoTextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI16BaseVideoTextureEviPKcS2_, __ZN29ParticleSystemPropertyBindingC2Ev: __ZN29ParticleSystemPropertyBindingC2Ev, __ZN5physx14PxsAABBManager8destroyVEv: __ZN5physx14PxsAABBManager8destroyVEv, __ZN14ParticleSystem18SetGravityModifierEf: __ZN14ParticleSystem18SetGravityModifierEf, __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL27GetComponentsImplementationILb0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13switchToNoSimEv: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13switchToNoSimEv, __Z13dtFreeNavMeshP9dtNavMesh: __Z13dtFreeNavMeshP9dtNavMesh, __ZNK8VRDevice15GetDisableVSyncEv: __ZNK8VRDevice15GetDisableVSyncEv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEEEE15growAndPushBackERKS2_, __Z39Animator_Get_Custom_PropFeetPivotActiveP12Il2CppObject: __Z39Animator_Get_Custom_PropFeetPivotActiveP12Il2CppObject, __ZNK5Umbra4Tome9getBoundsERNS_7Vector3ES2_: __ZNK5Umbra4Tome9getBoundsERNS_7Vector3ES2_, __ZN4FMOD7SystemID2Ev: __ZN4FMOD7SystemID2Ev, __Z41getPxFixedJoint_ProjectionLinearTolerancePKN5physx12PxFixedJointE: __Z41getPxFixedJoint_ProjectionLinearTolerancePKN5physx12PxFixedJointE, __ZN8Animator14SetAvatarScaleERK8Vector3f: __ZN8Animator14SetAvatarScaleERK8Vector3f, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __Z46RenderSettings_Set_Custom_PropCustomReflectionP12Il2CppObject: __Z46RenderSettings_Set_Custom_PropCustomReflectionP12Il2CppObject, __ZN11ShapeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11ShapeModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE: __ZN5Unity4Type14FindTypeByNameEPKcNS0_22CaseSensitivityOptionsE, __Z22getPxSceneDescUserDataPKN5physx11PxSceneDescE: __Z22getPxSceneDescUserDataPKN5physx11PxSceneDescE, __ZNK6Camera19GetSinglePassStereoEv: __ZNK6Camera19GetSinglePassStereoEv, __ZN27AnimatorControllerParameter7SetNameEPKc: __ZN27AnimatorControllerParameter7SetNameEPKc, __Z47getNbPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataE: __Z47getNbPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataE, __ZL30InitializeGlobalNameConversionPv: __ZL30InitializeGlobalNameConversionPv, __ZN15FileSystemEntry8SetFlagsEjj: __ZN15FileSystemEntry8SetFlagsEjj, __Z24CleanupPersistentManagerv: __Z24CleanupPersistentManagerv, __Z42Animation_Get_Custom_PropPlayAutomaticallyP12Il2CppObject: __Z42Animation_Get_Custom_PropPlayAutomaticallyP12Il2CppObject, __ZN5Umbra9BitVector5resetEj: __ZN5Umbra9BitVector5resetEj, __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointv: __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointv, __ZN4Mesh11MarkDynamicEv: __ZN4Mesh11MarkDynamicEv, __ZN18GlslGpuProgramGLESC2E20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput: __ZN18GlslGpuProgramGLESC2E20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput, __ZN11PreloadData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11PreloadData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph: __ZL12CopyChannelsjjRA4_K10StreamInfoRA8_K11ChannelInfoPKhS2_S6_Ph, __ZN10FileSystem8ShutdownEv: __ZN10FileSystem8ShutdownEv, __Z25GetBuiltinTexEnvParamNamei: __Z25GetBuiltinTexEnvParamNamei, __ZN11ColorModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11ColorModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead12GradientModeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead12GradientModeEvRT_RT0_PKc17TransferMetaFlags, __Z48AnimatorControllerPlayable_CUSTOM_SetFloatStringR9HPlayableP12Il2CppStringf: __Z48AnimatorControllerPlayable_CUSTOM_SetFloatStringR9HPlayableP12Il2CppStringf, __Z22UnregisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z22UnregisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN10Collider2D17OnRemoveComponentEPN5Unity9ComponentE: __ZN10Collider2D17OnRemoveComponentEPN5Unity9ComponentE, __ZN16MemoryFileSystem18CreateFileFromDataEPKcPvjb: __ZN16MemoryFileSystem18CreateFileFromDataEPKcPvjb, __Z53Register_UnityEngine_MaterialPropertyBlock_GetTexturev: __Z53Register_UnityEngine_MaterialPropertyBlock_GetTexturev, _stbir_resize_subpixel: _stbir_resize_subpixel, __ZThn8_NK12_GLOBAL__N_111StreamOwner11isConnectedEv: __ZThn8_NK12_GLOBAL__N_111StreamOwner11isConnectedEv, __ZThn12_N5physx3Ext14SphericalJointD1Ev: __ZThn12_N5physx3Ext14SphericalJointD1Ev, __Z46Register_UnityEngine_LineRenderer_GetPositionsv: __Z46Register_UnityEngine_LineRenderer_GetPositionsv, __ZN15MBP_PairManagerD2Ev: __ZN15MBP_PairManagerD2Ev, __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_17PxsFluidCollisionEXadL_ZNS2_12mergeResultsEPNS_10PxBaseTaskEEEE11runInternalEv, __Z42Shader_CUSTOM_GetGlobalMatrixArrayImplListiP12Il2CppObject: __Z42Shader_CUSTOM_GetGlobalMatrixArrayImplListiP12Il2CppObject, __Z39Rigidbody_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK8Vector3fi: __Z39Rigidbody_CUSTOM_INTERNAL_CALL_AddForceP12Il2CppObjectRK8Vector3fi, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, ___intscan: ___intscan, __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetInnerUVP12Il2CppObjectR8Vector4f: __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetInnerUVP12Il2CppObjectR8Vector4f, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags, __Z67Register_UnityEngine_LightProbes_INTERNAL_CALL_GetInterpolatedProbev: __Z67Register_UnityEngine_LightProbes_INTERNAL_CALL_GetInterpolatedProbev, _setbuf: _setbuf, __ZN12PhysXRaycast26GetGameObjectForRaycastHitERK10RaycastHit: __ZN12PhysXRaycast26GetGameObjectForRaycastHitERK10RaycastHit, __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z60Gyroscope_CUSTOM_INTERNAL_CALL_rotationRateUnbiased_InternaliR8Vector3f: __Z60Gyroscope_CUSTOM_INTERNAL_CALL_rotationRateUnbiased_InternaliR8Vector3f, __ZN5physx5cloth14IterationStateI8Scalar4fE6updateEv: __ZN5physx5cloth14IterationStateI8Scalar4fE6updateEv, __ZN14SafeBinaryRead8TransferI18WheelFrictionCurveEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI18WheelFrictionCurveEEvRT_PKc17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj390ENS_22PxRepXPropertyAccessorILj390ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj390ENS_22PxRepXPropertyAccessorILj390ES4_ffEEEEvRKT0_, __ZN19RenderBufferManager24IsReusableWithParametersERKNSt3__24pairIK4PPtrI13RenderTextureENS_23RenderTextureParametersEEERKS6_: __ZN19RenderBufferManager24IsReusableWithParametersERKNSt3__24pairIK4PPtrI13RenderTextureENS_23RenderTextureParametersEEERKS6_, __ZN5physx13NpVolumeCache14getCacheVolumeERNS_16PxGeometryHolderERNS_11PxTransformE: __ZN5physx13NpVolumeCache14getCacheVolumeERNS_16PxGeometryHolderERNS_11PxTransformE, __ZN13TargetJoint2D11SetMaxForceEf: __ZN13TargetJoint2D11SetMaxForceEf, __ZNSt3__26locale5__imp7installINS_7collateIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7collateIcEEEEvPT_, __ZN15ArchiveReadFile5CloseEv: __ZN15ArchiveReadFile5CloseEv, __ZN13RendererScene27UpdatePreviousFrameMatricesEv: __ZN13RendererScene27UpdatePreviousFrameMatricesEv, __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_19PxHeightFieldSampleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getRelativeTransformEv, __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList: __Z34ProcessIndexListIsNodeVisibleInOutRK22SceneCullingParametersPK9SceneNodePK4AABBR9IndexList, __ZN13AnimationClip13AddScaleCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN13AnimationClip13AddScaleCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __Z51Register_UnityEngine_Rigidbody_INTERNAL_CALL_WakeUpv: __Z51Register_UnityEngine_Rigidbody_INTERNAL_CALL_WakeUpv, __ZN5Unity11SpringJoint9SetSpringEf: __ZN5Unity11SpringJoint9SetSpringEf, _UNITY_FT_Stroker_Rewind: _UNITY_FT_Stroker_Rewind, _strtoul_l: _strtoul_l, __Z37CapsuleCollider_Set_Custom_PropHeightP12Il2CppObjectf: __Z37CapsuleCollider_Set_Custom_PropHeightP12Il2CppObjectf, __ZNK5physx15PxVehicleWheels7isValidEv: __ZNK5physx15PxVehicleWheels7isValidEv, __Z24RegisterStrippedTypeInfoI11TimeManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI11TimeManagerEviPKcS2_, __ZN7mecanim5human18HumanGetFootBottomEPKNS0_5HumanEb: __ZN7mecanim5human18HumanGetFootBottomEPKNS0_5HumanEb, _tt_cmap12_char_index: _tt_cmap12_char_index, __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Ext18ProfileZoneHandler11onZoneAddedERNS_13PxProfileZoneE: __ZN5physx3Ext18ProfileZoneHandler11onZoneAddedERNS_13PxProfileZoneE, __Z38Transform_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f: __Z38Transform_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f, __ZN16MemoryFileSystem8SetFlagsER13FileEntryDatajj: __ZN16MemoryFileSystem8SetFlagsER13FileEntryDatajj, _unity_z_deflateParams: _unity_z_deflateParams, _compute_reciprocal: _compute_reciprocal, __ZN7mecanim12statemachine24DestroyConditionConstantEPNS0_17ConditionConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine24DestroyConditionConstantEPNS0_17ConditionConstantERNS_6memory9AllocatorE, __ZN17PersistentManager23PostLoadStreamNameSpaceER15StreamNameSpacei: __ZN17PersistentManager23PostLoadStreamNameSpaceER15StreamNameSpacei, __Z20Animator_CUSTOM_PlayP12Il2CppObjectiif: __Z20Animator_CUSTOM_PlayP12Il2CppObjectiif, __ZN12_GLOBAL__N_117MemoryEventClient17handleBufferFlushEPKhj: __ZN12_GLOBAL__N_117MemoryEventClient17handleBufferFlushEPKhj, __ZN11MonoManagerC2E10MemLabelId18ObjectCreationMode: __ZN11MonoManagerC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Gu10computeMTDERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos6FloatVERNS9_5Vec3VE: __ZN5physx2Gu10computeMTDERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERNS_6shdfnd3aos6FloatVERNS9_5Vec3VE, __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI20OcclusionCullingDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14RenderSettings18SetAmbientSkyColorERK10ColorRGBAf: __ZN14RenderSettings18SetAmbientSkyColorERK10ColorRGBAf, __ZN5Light7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Light7PRODUCEE10MemLabelId18ObjectCreationMode, __Z54Register_UnityEngine_OcclusionArea_INTERNAL_set_centerv: __Z54Register_UnityEngine_OcclusionArea_INTERNAL_set_centerv, __Z21IsValidRenderingLightRK5Light9LightTypej: __Z21IsValidRenderingLightRK5Light9LightTypej, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjRKS5_, __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f: __Z38NavMeshAgent_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f, __Z34Camera_CUSTOM_SetReplacementShaderP12Il2CppObjectS0_P12Il2CppString: __Z34Camera_CUSTOM_SetReplacementShaderP12Il2CppObjectS0_P12Il2CppString, __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __Z36GUI_Get_Custom_PropUsePageScrollbarsv: __Z36GUI_Get_Custom_PropUsePageScrollbarsv, __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_RKNS6_6FloatVE: __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_RKNS6_6FloatVE, __ZN17PersistentManager26GetStreamNameSpaceInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager26GetStreamNameSpaceInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN19StreamedBinaryWriteILb0EE8TransferIN8LODGroup3LODEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIN8LODGroup3LODEEEvRT_PKc17TransferMetaFlags, __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN13GfxDeviceGLES16SetDisplayTargetEj: __ZN13GfxDeviceGLES16SetDisplayTargetEj, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findERKS5_j, __Z6simd4fffff: __Z6simd4fffff, _UNITY_png_read_row: _UNITY_png_read_row, __ZN6prcoreL10inner_flipILj4EEEvPhS1_j: __ZN6prcoreL10inner_flipILj4EEEvPhS1_j, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED2Ev: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED2Ev, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10date_orderEv: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10date_orderEv, __ZNK17AnimationPlayable15GetApplyMotionXEv: __ZNK17AnimationPlayable15GetApplyMotionXEv, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN10AudioMixer19EnsureValidConstantEv: __ZN10AudioMixer19EnsureValidConstantEv, __Z46OffMeshLink_Get_Custom_PropAutoUpdatePositionsP12Il2CppObject: __Z46OffMeshLink_Get_Custom_PropAutoUpdatePositionsP12Il2CppObject, __ZNSt3__217__assoc_sub_state24set_value_at_thread_exitEv: __ZNSt3__217__assoc_sub_state24set_value_at_thread_exitEv, __Z10DestripifyIjjEvPKT_iPT0_i: __Z10DestripifyIjjEvPKT_iPT0_i, _UNITY_FT_Done_Memory: _UNITY_FT_Done_Memory, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEE15growAndPushBackERKS2_, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z49Register_UnityEngine_Physics2D_set_baumgarteScalev: __Z49Register_UnityEngine_Physics2D_set_baumgarteScalev, __ZN4FMOD4DSPI9getActiveEPb: __ZN4FMOD4DSPI9getActiveEPb, __ZN18ProceduralMaterial17SetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf: __ZN18ProceduralMaterial17SetSubstanceFloatERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEf, __ZN19CollisionListener2D26DestroyRigidbodyCollisionsEP11Rigidbody2D: __ZN19CollisionListener2D26DestroyRigidbodyCollisionsEP11Rigidbody2D, __ZN4FMOD7Channel20set3DConeOrientationEP11FMOD_VECTOR: __ZN4FMOD7Channel20set3DConeOrientationEP11FMOD_VECTOR, __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetDeathv: __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetDeathv, __Z47Canvas_Get_Custom_PropSortingGridNormalizedSizeP12Il2CppObject: __Z47Canvas_Get_Custom_PropSortingGridNormalizedSizeP12Il2CppObject, __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_: __ZNSt3__27__sort3IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_T_, __ZN6Camera27SetSurfaceUseResolvedBufferEP13RenderTexture: __ZN6Camera27SetSurfaceUseResolvedBufferEP13RenderTexture, __Z33Sprite_Get_Custom_PropPackingModeP12Il2CppObject: __Z33Sprite_Get_Custom_PropPackingModeP12Il2CppObject, __ZN8Animator15BindingsDataSet5ResetEv: __ZN8Animator15BindingsDataSet5ResetEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_, __Z39Register_UnityEngine_Cursor_get_visiblev: __Z39Register_UnityEngine_Cursor_get_visiblev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj278ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj278ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZL23SelectClosestEdgeCB_BoxRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E: __ZL23SelectClosestEdgeCB_BoxRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E, __ZN8Animator14GetPivotWeightEv: __ZN8Animator14GetPivotWeightEv, __ZN2UI14CanvasRendererC2E10MemLabelId18ObjectCreationMode: __ZN2UI14CanvasRendererC2E10MemLabelId18ObjectCreationMode, __Z58GUIUtility_CUSTOM_INTERNAL_CALL_Internal_GetNextControlID2i9FocusTypeRK5RectTIfE: __Z58GUIUtility_CUSTOM_INTERNAL_CALL_Internal_GetNextControlID2i9FocusTypeRK5RectTIfE, __ZThn32_N13TrailRenderer19UpdateTransformInfoEv: __ZThn32_N13TrailRenderer19UpdateTransformInfoEv, __ZN5physx2Sc7BodySimC2ERNS0_5SceneERNS0_8BodyCoreE: __ZN5physx2Sc7BodySimC2ERNS0_5SceneERNS0_8BodyCoreE, __ZN19ScriptingInvocation6InvokeIP12Il2CppStringEET_PP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeIP12Il2CppStringEET_PP15Il2CppExceptionb, __Z69Register_UnityEngine_ParticleSystemRenderer_Internal_SetVertexStreamsv: __Z69Register_UnityEngine_ParticleSystemRenderer_Internal_SetVertexStreamsv, _tt_cmap14_def_char_count: _tt_cmap14_def_char_count, __ZN15OcclusionPortal23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15OcclusionPortal23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z18RenderImageFiltersR10RenderLoopP13RenderTextureb: __Z18RenderImageFiltersR10RenderLoopP13RenderTextureb, __ZN7mecanim4hand13FingerLengthsEPKNS0_4HandEPKNS_8skeleton8SkeletonEPf: __ZN7mecanim4hand13FingerLengthsEPKNS0_4HandEPKNS_8skeleton8SkeletonEPf, __ZN5physx2Sc11Interaction7destroyEv: __ZN5physx2Sc11Interaction7destroyEv, __ZL22PrepareValueParametersI27OverridingParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_: __ZL22PrepareValueParametersI27OverridingParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_, __ZN5physx6shdfnd10checkValidERKNS_7PxMat33E: __ZN5physx6shdfnd10checkValidERKNS_7PxMat33E, __Z40Register_UnityEngine_Material_set_shaderv: __Z40Register_UnityEngine_Material_set_shaderv, __ZN5physx21solve1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx21solve1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN20TextRenderingPrivate8TextMesh7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN20TextRenderingPrivate8TextMesh7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11AudioSource16AnyChannelPausedEv: __ZN11AudioSource16AnyChannelPausedEv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN17ArchiveFileSystem19InitializeFileEntryER13FileEntryData: __ZN17ArchiveFileSystem19InitializeFileEntryER13FileEntryData, __ZN19CharacterController8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19CharacterController8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cleanup_382: _cleanup_382, __ZNK5physx16PxPrismaticJoint19getConcreteTypeNameEv: __ZNK5physx16PxPrismaticJoint19getConcreteTypeNameEv, _cleanup_387: _cleanup_387, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E4swapERSL_, __ZN11UnityEngine7Connect18ConnectSessionInfoC2Ev: __ZN11UnityEngine7Connect18ConnectSessionInfoC2Ev, __Z20Cubemap_CUSTOM_ApplyP12Il2CppObjecthh: __Z20Cubemap_CUSTOM_ApplyP12Il2CppObjecthh, __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE: __ZN5physx2Gu23getPolygonalData_ConvexEPNS0_13PolygonalDataEPKNS0_14ConvexHullDataERKNS_2Cm23FastVertex2ShapeScalingE, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getConstraintEv, __Z58Register_UnityEngine_Renderer_get_staticBatchRootTransformv: __Z58Register_UnityEngine_Renderer_get_staticBatchRootTransformv, __ZN13AnimationClip15AddRuntimeEventER14AnimationEvent: __ZN13AnimationClip15AddRuntimeEventER14AnimationEvent, __ZN5physx12NpConstraint8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx12NpConstraint8setFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __Z42getPxArticulationJoint_TangentialStiffnessPKN5physx19PxArticulationJointE: __Z42getPxArticulationJoint_TangentialStiffnessPKN5physx19PxArticulationJointE, __ZN19UnityConnectService20OnPlayerPausedStaticEPS_b: __ZN19UnityConnectService20OnPlayerPausedStaticEPS_b, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8Animator5ResetEv: __ZN8Animator5ResetEv, _jdiv_round_up: _jdiv_round_up, __Z35LensFlare_Get_Custom_PropBrightnessP12Il2CppObject: __Z35LensFlare_Get_Custom_PropBrightnessP12Il2CppObject, __Z46GUIUtility_CUSTOM_SetDidGUIWindowsEatLastEventh: __Z46GUIUtility_CUSTOM_SetDidGUIWindowsEatLastEventh, __ZN11TypeManager24InitializeGlobalInstanceEv: __ZN11TypeManager24InitializeGlobalInstanceEv, __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy: __ZN13dynamic_arrayIiLj4EE18resize_initializedEjRKi12ResizePolicy, _sw_write: _sw_write, __Z18CleanupAudioModulev: __Z18CleanupAudioModulev, __Z30getPxMaterial_ConcreteTypeNamePKN5physx10PxMaterialE: __Z30getPxMaterial_ConcreteTypeNamePKN5physx10PxMaterialE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D22CollisionDetectionModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D22CollisionDetectionModeEEvRT_RT0_PKc17TransferMetaFlags, __ZN7Terrain8TransferI17RemapPPtrTransferEEvRT_: __ZN7Terrain8TransferI17RemapPPtrTransferEEvRT_, __Z29RegisterModule_TerrainPhysicsv: __Z29RegisterModule_TerrainPhysicsv, __Z48ConfigurableJoint_Get_Custom_PropProjectionAngleP12Il2CppObject: __Z48ConfigurableJoint_Get_Custom_PropProjectionAngleP12Il2CppObject, __Z52Register_UnityEngine_AndroidJNI_CallStaticCharMethodv: __Z52Register_UnityEngine_AndroidJNI_CallStaticCharMethodv, _UNITY_png_handle_cHRM: _UNITY_png_handle_cHRM, __ZN22LocalFileSystemHandler18IsAbsoluteFilePathEPKc: __ZN22LocalFileSystemHandler18IsAbsoluteFilePathEPKc, __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE15growAndPushBackERKS4_, __GLOBAL__sub_I_runtime_terrain_lump_cpp: __GLOBAL__sub_I_runtime_terrain_lump_cpp, __ZN10MeshFilterC2E10MemLabelId18ObjectCreationMode: __ZN10MeshFilterC2E10MemLabelId18ObjectCreationMode, __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESN_RKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESN_RKT_, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf: __ZN7mecanim8skeleton9SetupAxesEPNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEERKNS4_13SetupAxesInfoEiibf, __ZN5Umbra9intersectERKNS_11LineSegmentERKNS_4QuadE: __ZN5Umbra9intersectERKNS_11LineSegmentERKNS_4QuadE, _cf2_getFamilyBlues: _cf2_getFamilyBlues, __ZN5physx6shdfnd12ErrorHandler11reportErrorENS_11PxErrorCode4EnumEPKcS5_i: __ZN5physx6shdfnd12ErrorHandler11reportErrorENS_11PxErrorCode4EnumEPKcS5_i, __Z45ParticleSystem_CollisionModule_CUSTOM_SetTypeP12Il2CppObjecti: __Z45ParticleSystem_CollisionModule_CUSTOM_SetTypeP12Il2CppObjecti, __Z41OffMeshLink_Set_Custom_PropStartTransformP12Il2CppObjectS0_: __Z41OffMeshLink_Set_Custom_PropStartTransformP12Il2CppObjectS0_, __Z50Register_UnityEngine_AudioSettings_set_speakerModev: __Z50Register_UnityEngine_AudioSettings_set_speakerModev, __Z47Register_UnityEngine_Physics2D_IsTouchingLayersv: __Z47Register_UnityEngine_Physics2D_IsTouchingLayersv, __ZN13BoxCollider2D5ResetEv: __ZN13BoxCollider2D5ResetEv, __Z3RedP9Texture2DPhiiii: __Z3RedP9Texture2DPhiiii, __ZN4FMOD7SystemI13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE: __ZN4FMOD7SystemI13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE, __ZN17CapsuleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17CapsuleCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z39Register_UnityEngine_RectOffset_set_topv: __Z39Register_UnityEngine_RectOffset_set_topv, __Z28computeBlockStreamByteSizes4PN5physx21PxcSolverContact4DescERjPjRNS_18PxcNpThreadContextE: __Z28computeBlockStreamByteSizes4PN5physx21PxcSolverContact4DescERjPjRNS_18PxcNpThreadContextE, __Z52Register_UnityEngine_Terrain_get_detailObjectDensityv: __Z52Register_UnityEngine_Terrain_get_detailObjectDensityv, __ZN26AnimatorOverrideController8TransferI17RemapPPtrTransferEEvRT_: __ZN26AnimatorOverrideController8TransferI17RemapPPtrTransferEEvRT_, __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_: __ZNSt3__26__sortIRPFbPKN5IMGUI9GUIWindowES4_EPPS2_EEvT0_SA_T_, __Z30setPxVehicleWheelDataMToeAnglePN5physx18PxVehicleWheelDataEf: __Z30setPxVehicleWheelDataMToeAnglePN5physx18PxVehicleWheelDataEf, __ZN11OffMeshLink13AddConnectionEv: __ZN11OffMeshLink13AddConnectionEv, __Z41Register_UnityEngine_TextMesh_set_offsetZv: __Z41Register_UnityEngine_TextMesh_set_offsetZv, __ZNK9AudioClip12GetSoundSizeEv: __ZNK9AudioClip12GetSoundSizeEv, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __ZN21DownloadHandlerBuffer13OnReceiveDataEPKvj: __ZN21DownloadHandlerBuffer13OnReceiveDataEPKvj, __ZN6Camera5ClearEv: __ZN6Camera5ClearEv, __ZN5physx16PxsIslandManager27setWokenPairContactManagersEv: __ZN5physx16PxsIslandManager27setWokenPairContactManagersEv, __ZNK15b2FrictionJoint12GetMaxTorqueEv: __ZNK15b2FrictionJoint12GetMaxTorqueEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj577ENS_22PxRepXPropertyAccessorILj577ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj577ENS_22PxRepXPropertyAccessorILj577ES4_ffEEEEvRKT0_, __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_N9ShaderLab14CStringCompareELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN20SoundChannelInstanceD0Ev: __ZN20SoundChannelInstanceD0Ev, __ZN5physx16writeFabricPhaseERNS_14PxOutputStreamERKNS_18PxClothFabricPhaseE: __ZN5physx16writeFabricPhaseERNS_14PxOutputStreamERKNS_18PxClothFabricPhaseE, __Z52Register_UnityEngine_Transform_set_hierarchyCapacityv: __Z52Register_UnityEngine_Transform_set_hierarchyCapacityv, __ZN15CollisionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15CollisionModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19getInvInertiaScale0Ev, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale0Ev, __ZN13UnityProfiler20InitializeMainThreadEv: __ZN13UnityProfiler20InitializeMainThreadEv, __Z76Register_UnityEngine_Animator_get_isRootPositionOrRotationControlledByCurvesv: __Z76Register_UnityEngine_Animator_get_isRootPositionOrRotationControlledByCurvesv, __Z22sweepCapsule_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z22sweepCapsule_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNK14AudioBehaviour26GetTypeInfoVirtualInternalEv: __ZNK14AudioBehaviour26GetTypeInfoVirtualInternalEv, __ZN9Texture3D13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Texture3D13AwakeFromLoadE17AwakeFromLoadMode, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwj, __ZN29AnimationStateNetworkProvider24GetNetworkAnimationStateER9AnimationP24AnimationStateForNetworki: __ZN29AnimationStateNetworkProvider24GetNetworkAnimationStateER9AnimationP24AnimationStateForNetworki, __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10ColorRGBAf8TransferI24GenerateTypeTreeTransferEEvRT_, __Z40setPxArticulationJoint_TangentialDampingPN5physx19PxArticulationJointEf: __Z40setPxArticulationJoint_TangentialDampingPN5physx19PxArticulationJointEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8IRaycast12IntersectAnyERKN4math8floatNx3ES3_P4AABBj: __ZN8IRaycast12IntersectAnyERKN4math8floatNx3ES3_P4AABBj, __ZL19makeDetailEdgeSlabsPfPKfii: __ZL19makeDetailEdgeSlabsPfPKfii, __ZNK14BillboardAsset26GetTypeInfoVirtualInternalEv: __ZNK14BillboardAsset26GetTypeInfoVirtualInternalEv, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4failEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4failEv, __ZNK4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj: __ZNK4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj, __ZN5physx21PxcArticulationHelper14getLtbDataSizeEj: __ZN5physx21PxcArticulationHelper14getLtbDataSizeEj, __Z20Gradient_CUSTOM_InitP12Il2CppObject: __Z20Gradient_CUSTOM_InitP12Il2CppObject, __ZN22UnityWebRequestManager22ScriptsChangedCallbackEv: __ZN22UnityWebRequestManager22ScriptsChangedCallbackEv, __Z54Register_UnityEngine_ConstantForce_INTERNAL_set_torquev: __Z54Register_UnityEngine_ConstantForce_INTERNAL_set_torquev, __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx5cloth8SwSolver26getInterCollisionStiffnessEv: __ZNK5physx5cloth8SwSolver26getInterCollisionStiffnessEv, __Z24RegisterStrippedTypeInfoI19AudioHighPassFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI19AudioHighPassFilterEviPKcS2_, __ZN4FMOD7Channel6setPanEf: __ZN4FMOD7Channel6setPanEf, __Z46Input_CUSTOM_INTERNAL_set_compositionCursorPosRK13Vector2fIcall: __Z46Input_CUSTOM_INTERNAL_set_compositionCursorPosRK13Vector2fIcall, __ZN25StaticProfilerInformation8RegisterEv: __ZN25StaticProfilerInformation8RegisterEv, __ZN7mecanim5human10MuscleNameEj: __ZN7mecanim5human10MuscleNameEj, __ZNK5physx7NpScene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj: __ZNK5physx7NpScene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj, __ZN10HumanTrait4Body11GetBoneNameEi: __ZN10HumanTrait4Body11GetBoneNameEi, __ZN14qsort_internal14_Partition3WayIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEENSt3__24pairIT_S7_EES7_S7_T0_T1_: __ZN14qsort_internal14_Partition3WayIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEENSt3__24pairIT_S7_EES7_S7_T0_T1_, __ZN5physx9NpFactory16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj: __ZN5physx9NpFactory16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj, __ZN5Umbra20RuntimeStructBuilder5cleanEv: __ZN5Umbra20RuntimeStructBuilder5cleanEv, __ZN17AnimationPlayable29CleanupStateMachineBehavioursEv: __ZN17AnimationPlayable29CleanupStateMachineBehavioursEv, __ZN12LightsModuleD0Ev: __ZN12LightsModuleD0Ev, _UNITY_ft_create_default_module_classes: _UNITY_ft_create_default_module_classes, __Z66ShaderVariantCollection_ShaderVariant_CUSTOM_Internal_CheckVariantP12Il2CppObject14ShaderPassTypeP11Il2CppArray: __Z66ShaderVariantCollection_ShaderVariant_CUSTOM_Internal_CheckVariantP12Il2CppObject14ShaderPassTypeP11Il2CppArray, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7releaseEv, _UNITY_LZ4_compress_forceExtDict: _UNITY_LZ4_compress_forceExtDict, __Z52Register_UnityEngine_Transform_INTERNAL_get_positionv: __Z52Register_UnityEngine_Transform_INTERNAL_get_positionv, __Z55Register_UnityEngine_PhysicMaterial_set_staticFriction2v: __Z55Register_UnityEngine_PhysicMaterial_set_staticFriction2v, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj401ENS_22PxRepXPropertyAccessorILj401ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj401ENS_22PxRepXPropertyAccessorILj401ES4_ffEEEEvRKT0_, __ZL24SendTransformChangedMaskRK18TransformHierarchyii: __ZL24SendTransformChangedMaskRK18TransformHierarchyii, __Z70Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorP12Il2CppObjectRK13Vector2fIcallPS1_: __Z70Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetVectorP12Il2CppObjectRK13Vector2fIcallPS1_, __Z30CleanupDynamicBatchGeometryJobP25DynamicVBOGeometryJobData: __Z30CleanupDynamicBatchGeometryJobP25DynamicVBOGeometryJobData, __Z44Register_UnityEngine_HumanTrait_RequiredBonev: __Z44Register_UnityEngine_HumanTrait_RequiredBonev, _iswspace_l: _iswspace_l, __ZN12TLSAllocatorI14StackAllocatorE13TryDeallocateEPv: __ZN12TLSAllocatorI14StackAllocatorE13TryDeallocateEPv, __ZN4gles24CreateColorRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE: __ZN4gles24CreateColorRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE, __ZN5physx25PxGeometryGeneratedValuesC2EPKNS_10PxGeometryE: __ZN5physx25PxGeometryGeneratedValuesC2EPKNS_10PxGeometryE, __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadE25RuntimeInitializeLoadType: __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadE25RuntimeInitializeLoadType, __Z50Register_UnityEngine_CapsuleCollider_set_directionv: __Z50Register_UnityEngine_CapsuleCollider_set_directionv, __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13TextRendering4Font8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9LensFlareC2E10MemLabelId18ObjectCreationMode: __ZN9LensFlareC2E10MemLabelId18ObjectCreationMode, __Z37Register_UnityEngine_GUIText_get_textv: __Z37Register_UnityEngine_GUIText_get_textv, __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f: __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f, __Z26Object_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString: __Z26Object_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString, __Z40ConstantForce_CUSTOM_INTERNAL_get_torqueP12Il2CppObjectP8Vector3f: __Z40ConstantForce_CUSTOM_INTERNAL_get_torqueP12Il2CppObjectP8Vector3f, __ZN20ArchiveStorageReader15MakeStorageUsedEv: __ZN20ArchiveStorageReader15MakeStorageUsedEv, __ZN15AnchoredJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15AnchoredJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z13GetTouchCountv: __Z13GetTouchCountv, __Z43NavMesh_CUSTOM_INTERNAL_CALL_SamplePositionRK8Vector3fP10NavMeshHitfi: __Z43NavMesh_CUSTOM_INTERNAL_CALL_SamplePositionRK8Vector3fP10NavMeshHitfi, _gray_cubic_to: _gray_cubic_to, __ZNK20LightPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK20LightPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __Z19GetScreenManagerPtrv: __Z19GetScreenManagerPtrv, __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE: __ZN17AnimationCurveTplIfE6AddKeyERK11KeyframeTplIfE, __ZN4FMOD4DSPI13getNumOutputsEPi: __ZN4FMOD4DSPI13getNumOutputsEPi, __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig32RestoreNetworkRetryTimeoutConfigER13dynamic_arrayIiLj4EE: __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig32RestoreNetworkRetryTimeoutConfigER13dynamic_arrayIiLj4EE, __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD1Ev: __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD1Ev, __ZN15ResourceManager12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN15ResourceManager12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f: __ZL16generateContactsRN5physx2Gu13ContactBufferERKNS_6PxVec3EffS5_RKNS_2Cm8Matrix34ES9_f, __Z48Register_UnityEngine_Camera_RemoveCommandBuffersv: __Z48Register_UnityEngine_Camera_RemoveCommandBuffersv, __Z32AnimatorControllerParameterToCppRK31MonoAnimatorControllerParameterR27AnimatorControllerParameter: __Z32AnimatorControllerParameterToCppRK31MonoAnimatorControllerParameterR27AnimatorControllerParameter, __ZN15ConstantForce2D16CheckConsistencyEv: __ZN15ConstantForce2D16CheckConsistencyEv, __Z51Graphics_CUSTOM_Internal_SetRandomWriteTargetBufferiP12Il2CppObjecth: __Z51Graphics_CUSTOM_Internal_SetRandomWriteTargetBufferiP12Il2CppObjecth, __ZN11UnityEngine9Animation37SetGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayER9Transformb: __ZN11UnityEngine9Animation37SetGenericRootTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayER9Transformb, __ZL30RegisterModuleICalls_Animationv: __ZL30RegisterModuleICalls_Animationv, __ZN7ApiGLES13IsVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE: __ZN7ApiGLES13IsVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE, __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI7GUIClipNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIssEEPsEEjT0_S5_S5_T_, __ZN5physx7NpScene15setFrictionTypeENS_14PxFrictionType4EnumE: __ZN5physx7NpScene15setFrictionTypeENS_14PxFrictionType4EnumE, __ZN15NavMeshObstacle10FitExtentsEv: __ZN15NavMeshObstacle10FitExtentsEv, __ZNK5physx29PxClothSimpleTetherCookerImpl15getCookerStatusEv: __ZNK5physx29PxClothSimpleTetherCookerImpl15getCookerStatusEv, __ZN5physx2Gu28checkOverlapSphere_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu28checkOverlapSphere_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __ZN19SkinnedMeshRenderer19UpdateTransformInfoEv: __ZN19SkinnedMeshRenderer19UpdateTransformInfoEv, __ZN20SpeedTreeWindManagerC2Ev: __ZN20SpeedTreeWindManagerC2Ev, __ZN22RenderingCommandBuffer24AddSetShadowSamplingModeERK18RenderTextureParam18ShadowSamplingMode: __ZN22RenderingCommandBuffer24AddSetShadowSamplingModeERK18RenderTextureParam18ShadowSamplingMode, __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj: __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE7reserveEj, _jsimd_h2v1_fancy_upsample: _jsimd_h2v1_fancy_upsample, __ZN26AnimatorControllerPlayable13AddObjectUserER8UserList: __ZN26AnimatorControllerPlayable13AddObjectUserER8UserList, __Z54Register_UnityEngine_AudioReverbFilter_set_hfReferencev: __Z54Register_UnityEngine_AudioReverbFilter_set_hfReferencev, __ZN9Animation23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Animation23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK4Mesh18GetSubMeshBuffer16Ei: __ZNK4Mesh18GetSubMeshBuffer16Ei, __ZN5physx13GuMeshFactory18addFactoryListenerERNS_21GuMeshFactoryListenerE: __ZN5physx13GuMeshFactory18addFactoryListenerERNS_21GuMeshFactoryListenerE, __Z32AudioSource_Set_Custom_PropPitchP12Il2CppObjectf: __Z32AudioSource_Set_Custom_PropPitchP12Il2CppObjectf, __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN13OpenFileCache10ForceCloseERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13OpenFileCache10ForceCloseERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z33setPxConvexMeshGeometryConvexMeshPN5physx20PxConvexMeshGeometryEPNS_12PxConvexMeshE: __Z33setPxConvexMeshGeometryConvexMeshPN5physx20PxConvexMeshGeometryEPNS_12PxConvexMeshE, __Z37getPxClothMotionConstraintConfigScalePKN5physx29PxClothMotionConstraintConfigE: __Z37getPxClothMotionConstraintConfigScalePKN5physx29PxClothMotionConstraintConfigE, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXv, __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17BillboardRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv, __Z40AudioSource_Get_Custom_PropRolloffFactorP12Il2CppObject: __Z40AudioSource_Get_Custom_PropRolloffFactorP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN5physx2Gu14contactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu14contactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEvT0_S7_T_, __ZN5Umbra17LineSegmentFinder13queryInternalILb1EEEbRKNS_7Vector3ES4_RNS_4CellES6_PNS_8UserListIiEE: __ZN5Umbra17LineSegmentFinder13queryInternalILb1EEEbRKNS_7Vector3ES4_RNS_4CellES6_PNS_8UserListIiEE, __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantE: __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantE, __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE: __Z17EulerToQuaternionRK8Vector3fN4math13RotationOrderE, __ZN14BatchedOverlapC2ERK13dynamic_arrayI15BatchedOverlapsLj4EEj: __ZN14BatchedOverlapC2ERK13dynamic_arrayI15BatchedOverlapsLj4EEj, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_, __ZN19UnityConnectService27OnPlayerSessionStateChangedEv: __ZN19UnityConnectService27OnPlayerSessionStateChangedEv, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale1Ef, __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_31PxClothParticleMotionConstraintENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN13SpringJoint2D12SetFrequencyEf: __ZN13SpringJoint2D12SetFrequencyEf, __ZNSt3__227__insertion_sort_incompleteIR23TreeInstanceIndexSorterPjEEbT0_S4_T_: __ZNSt3__227__insertion_sort_incompleteIR23TreeInstanceIndexSorterPjEEbT0_S4_T_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE8pushNameEPKc, __ZN10__cxxabiv120__si_class_type_infoD0Ev: __ZN10__cxxabiv120__si_class_type_infoD0Ev, __ZN11AudioFilter12AddToManagerEv: __ZN11AudioFilter12AddToManagerEv, __ZNK5Umbra10Visibility24getOutputObjectDistancesEv: __ZNK5Umbra10Visibility24getOutputObjectDistancesEv, __Z27SetupModuleScriptingClassesPFvvES0_: __Z27SetupModuleScriptingClassesPFvvES0_, __Z56AnimatorControllerPlayable_CUSTOM_GetLayerWeightInternalR9HPlayablei: __Z56AnimatorControllerPlayable_CUSTOM_GetLayerWeightInternalR9HPlayablei, __ZN10MeshFilter12CleanupClassEv: __ZN10MeshFilter12CleanupClassEv, __ZN18ScreenManagerWebGL22SetResolutionImmediateEiibi: __ZN18ScreenManagerWebGL22SetResolutionImmediateEiibi, __ZNK15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E13find_positionERS5_: __ZNK15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E13find_positionERS5_, __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f: __ZN8Material9SetMatrixEN9ShaderLab16FastPropertyNameERK10Matrix4x4f, __ZN5physx2Gu16SupportLocalImplINS0_11ConvexHullVEED0Ev: __ZN5physx2Gu16SupportLocalImplINS0_11ConvexHullVEED0Ev, __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToIntArrayv: __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToIntArrayv, _UNITY_FT_Stream_EnterFrame: _UNITY_FT_Stream_EnterFrame, __ZN19UnityConnectService23RegisterGlobalCallbacksEv: __ZN19UnityConnectService23RegisterGlobalCallbacksEv, __Z17DecodeRGBMChanneljjjh: __Z17DecodeRGBMChanneljjjh, __ZN5Umbra16LineSegmentQueryC2ERKS0_: __ZN5Umbra16LineSegmentQueryC2ERKS0_, __ZN5physx10PxsContext14updateDynamicsEfPNS_10PxBaseTaskERNS_18PxsMaterialManagerE: __ZN5physx10PxsContext14updateDynamicsEfPNS_10PxBaseTaskERNS_18PxsMaterialManagerE, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j, __ZN11OffMeshLink8TransferI14SafeBinaryReadEEvRT_: __ZN11OffMeshLink8TransferI14SafeBinaryReadEEvRT_, __ZN5physx20PxsParticleSystemSim22setSimulationTimeStepVEf: __ZN5physx20PxsParticleSystemSim22setSimulationTimeStepVEf, __ZN5Unity17ConfigurableJoint16CheckConsistencyEv: __ZN5Unity17ConfigurableJoint16CheckConsistencyEv, __ZNK6Object7GetNameEv: __ZNK6Object7GetNameEv, __ZN5physx7NpScene17removeRigidStaticERNS_13NpRigidStaticEbb: __ZN5physx7NpScene17removeRigidStaticERNS_13NpRigidStaticEbb, __Z43Register_UnityEngine_AI_NavMesh_GetAreaCostv: __Z43Register_UnityEngine_AI_NavMesh_GetAreaCostv, __ZN8VRDevice17SetShowDeviceViewEb: __ZN8VRDevice17SetShowDeviceViewEb, __ZN23PxsCMDiscreteUpdateTask11runInternalEv: __ZN23PxsCMDiscreteUpdateTask11runInternalEv, __ZNKSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE14__count_uniqueIS6_EEjRKT_: __ZNKSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE14__count_uniqueIS6_EEjRKT_, __Z37InitializeUnityCloudWebServicesModulev: __Z37InitializeUnityCloudWebServicesModulev, __ZN20TextRenderingPrivate22ScriptingTextGenerator19InitCharAndLineInfoEii: __ZN20TextRenderingPrivate22ScriptingTextGenerator19InitCharAndLineInfoEii, __ZN6Camera30SetNonJitteredProjectionMatrixERK10Matrix4x4f: __ZN6Camera30SetNonJitteredProjectionMatrixERK10Matrix4x4f, __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __ZN12FixedJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12FixedJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _memccpy: _memccpy, __Z14OutputPolymeshP14TESStesselatorP8TESSmeshiii: __Z14OutputPolymeshP14TESStesselatorP8TESSmeshiii, __ZN9BoxPruner10staticSortEv: __ZN9BoxPruner10staticSortEv, __Z29Transfer_Blittable_ArrayFieldI8JSONReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZL25ProgramUniformMatrix3x2fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix3x2fvPK7ApiGLESjiihPKv, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEEEEjT_j, __Z53Register_UnityEngine_AndroidJNI_CallStaticFloatMethodv: __Z53Register_UnityEngine_AndroidJNI_CallStaticFloatMethodv, __Z49WebGLInput_Set_Custom_PropCaptureAllKeyboardInputh: __Z49WebGLInput_Set_Custom_PropCaptureAllKeyboardInputh, __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState: __Z20MarkInstanceIDAsRootiR27GarbageCollectorThreadState, __Z29TextAsset_Get_Custom_PropTextP12Il2CppObject: __Z29TextAsset_Get_Custom_PropTextP12Il2CppObject, __GLOBAL__sub_I_runtime_graphics_mesh3_lump_cpp: __GLOBAL__sub_I_runtime_graphics_mesh3_lump_cpp, __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeIP23AllocationRootReferenceNS_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZN5physx21PxcArticulationHelper12saveVelocityERKNS_25PxcArticulationSolverDescE: __ZN5physx21PxcArticulationHelper12saveVelocityERKNS_25PxcArticulationSolverDescE, __ZN12ScriptMapper9AddShaderER6Shader: __ZN12ScriptMapper9AddShaderER6Shader, __ZN16PlayerConnection7CleanupEv: __ZN16PlayerConnection7CleanupEv, __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_get_centerOfMassv: __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_get_centerOfMassv, __ZN5physx2Sc5ActorD0Ev: __ZN5physx2Sc5ActorD0Ev, __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE8__appendEj, __Z25GetCrashReportingSettingsv: __Z25GetCrashReportingSettingsv, __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi: __ZN24GenerateTypeTreeTransfer20TransferTypelessDataEjPvi, __ZN18StreamedBinaryReadILb1EE8TransferI15NavMeshTileDataEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferI15NavMeshTileDataEEvRT_PKc17TransferMetaFlags, __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EEjNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_jEEL18MemLabelIdentifier65ELi16EEEixERSA_: __ZN14dense_hash_mapINSt3__24pairIPK10Collider2DS4_EEjNS2_23ColliderPairHashFunctorENS0_8equal_toIS5_EE13stl_allocatorINS1_IKS5_jEEL18MemLabelIdentifier65ELi16EEEixERSA_, __ZN5physx2Sq17SceneQueryManager11preallocateEjj: __ZN5physx2Sq17SceneQueryManager11preallocateEjj, __ZN17ArchiveFileSystem8SetFlagsER13FileEntryDatajj: __ZN17ArchiveFileSystem8SetFlagsER13FileEntryDatajj, __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __ZN23TransformChangeDispatch24RemoveTransformHierarchyER18TransformHierarchy: __ZN23TransformChangeDispatch24RemoveTransformHierarchyER18TransformHierarchy, __ZN11NavMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11NavMeshData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN12_GLOBAL__N_115offsetTrianglesEPN5physx6PxVec3ES2_f: __ZN12_GLOBAL__N_115offsetTrianglesEPN5physx6PxVec3ES2_f, __ZN5physx6shdfnd4sortINS_23PxcSolverConstraintDescENS_14ConstraintLessENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortINS_23PxcSolverConstraintDescENS_14ConstraintLessENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j, __ZN5physx2Cm29ConstraintImmediateVisualizer21visualizeAngularLimitERKNS_11PxTransformEffb: __ZN5physx2Cm29ConstraintImmediateVisualizer21visualizeAngularLimitERKNS_11PxTransformEffb, __ZNK8Gradient16GetConstantColorEv: __ZNK8Gradient16GetConstantColorEv, __Z62Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToWorldPointv: __Z62Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToWorldPointv, __ZNK5physx2Sc8ShapeSim10getAbsPoseEv: __ZNK5physx2Sc8ShapeSim10getAbsPoseEv, __Z13RegisterClassI15EditorExtensionEvv: __Z13RegisterClassI15EditorExtensionEvv, __ZN11UnityEngine9Animation28GenericAnimationBindingCache11BindGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE: __ZN11UnityEngine9Animation28GenericAnimationBindingCache11BindGenericERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE, __ZN16DeveloperConsole14HasLogMessagesEv: __ZN16DeveloperConsole14HasLogMessagesEv, __ZNK8GUIStyle14DrawBackgroundER8GUIStateRK5RectTIfEPK13GUIStyleState: __ZNK8GUIStyle14DrawBackgroundER8GUIStateRK5RectTIfEPK13GUIStyleState, __ZN5physx14SapPairManager12reallocPairsEb: __ZN5physx14SapPairManager12reallocPairsEb, __ZN8Animator18EvaluateControllerEf: __ZN8Animator18EvaluateControllerEf, __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf: __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf, __Z31Register_UnityEngine_GL_Vertex3v: __Z31Register_UnityEngine_GL_Vertex3v, __ZNK27StateMachineBehaviourPlayer18FireStateBehaviourER17AnimatorStateInfoiN7mecanim12statemachine19StateMachineMessageE: __ZNK27StateMachineBehaviourPlayer18FireStateBehaviourER17AnimatorStateInfoiN7mecanim12statemachine19StateMachineMessageE, __ZNK5physx2Sc19ParticlePacketShape8isActiveEv: __ZNK5physx2Sc19ParticlePacketShape8isActiveEv, __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN9dtNavMesh33unconnectOffMeshConnectionsToTileEPK10dtMeshTile: __ZN9dtNavMesh33unconnectOffMeshConnectionsToTileEPK10dtMeshTile, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __Z37Application_CUSTOM_HasAdvancedLicensev: __Z37Application_CUSTOM_HasAdvancedLicensev, _UNITY_FT_Create_Class_sfnt_services: _UNITY_FT_Create_Class_sfnt_services, __Z26Application_CUSTOM_OpenURLP12Il2CppString: __Z26Application_CUSTOM_OpenURLP12Il2CppString, __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthXP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthXP12Il2CppObjectR15MonoMinMaxCurve, __Z13RegisterClassI19AudioHighPassFilterEvv: __Z13RegisterClassI19AudioHighPassFilterEvv, __ZN11GPUProfiler8EndFrameEv: __ZN11GPUProfiler8EndFrameEv, _towlower: _towlower, __ZNSt3__223__system_error_categoryD0Ev: __ZNSt3__223__system_error_categoryD0Ev, __ZN4FMOD8ChannelI17set3DDopplerLevelEf: __ZN4FMOD8ChannelI17set3DDopplerLevelEf, __Z39FrictionJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf: __Z39FrictionJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf, __Z40AudioSource_Set_Custom_PropReverbZoneMixP12Il2CppObjectf: __Z40AudioSource_Set_Custom_PropReverbZoneMixP12Il2CppObjectf, __ZN4FMOD3DSP12getParameterEiPfPci: __ZN4FMOD3DSP12getParameterEiPfPci, __Z38AudioSource_Set_Custom_PropMaxDistanceP12Il2CppObjectf: __Z38AudioSource_Set_Custom_PropMaxDistanceP12Il2CppObjectf, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jRKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jRKS4_, __ZN10dtNodePoolC2Eii: __ZN10dtNodePoolC2Eii, __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __Z32GUIStyle_Get_Custom_PropClippingP12Il2CppObject: __Z32GUIStyle_Get_Custom_PropClippingP12Il2CppObject, __ZNK6IDList14GetSearchIndexEv: __ZNK6IDList14GetSearchIndexEv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setRestOffsetEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13setRestOffsetEf, __ZN11UnityEngine15PlatformWrapper19GetDeviceSystemNameEv: __ZN11UnityEngine15PlatformWrapper19GetDeviceSystemNameEv, __Z51SpriteRenderer_CUSTOM_INTERNAL_CALL_GetSpriteBoundsP12Il2CppObjectR4AABB: __Z51SpriteRenderer_CUSTOM_INTERNAL_CALL_GetSpriteBoundsP12Il2CppObjectR4AABB, __Z71Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityMultiplierv: __Z71Register_UnityEngine_ParticleSystem_LightsModule_SetIntensityMultiplierv, __ZN11TimeManager12SetTimeScaleEf: __ZN11TimeManager12SetTimeScaleEf, __Z53Register_UnityEngine_Camera_INTERNAL_CALL_ResetAspectv: __Z53Register_UnityEngine_Camera_INTERNAL_CALL_ResetAspectv, __Z19GetDeveloperConsolev: __Z19GetDeveloperConsolev, __ZThn8_N5physx2Gu12TriangleMeshD1Ev: __ZThn8_N5physx2Gu12TriangleMeshD1Ev, __Z36Rigidbody2D_Get_Custom_PropSleepModeP12Il2CppObject: __Z36Rigidbody2D_Get_Custom_PropSleepModeP12Il2CppObject, __ZNK21FullParameterPreparer15OnPrepareVectorER12PartialArrayI8Vector4fERKN20GpuProgramParameters14ValueParameterEj: __ZNK21FullParameterPreparer15OnPrepareVectorER12PartialArrayI8Vector4fERKN20GpuProgramParameters14ValueParameterEj, __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD0Ev: __ZN7WeakPtrI20SoundChannelInstanceE10SharedDataD0Ev, __ZN12_GLOBAL__N_1L5gNXORERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L5gNXORERN5physx12PxGroupsMaskERKS1_S4_, __ZNK19VREyeTextureManager18GetEyeTextureWidthEv: __ZNK19VREyeTextureManager18GetEyeTextureWidthEv, _csqrt: _csqrt, _jpeg_quality_scaling: _jpeg_quality_scaling, __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetVelocityP12Il2CppObjectRK8Vector3f: __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetVelocityP12Il2CppObjectRK8Vector3f, __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z19StandardizePathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN17PersistentManager27GetLoadErrorMessageFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager27GetLoadErrorMessageFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z46Register_UnityEngine_CanvasRenderer_get_isMaskv: __Z46Register_UnityEngine_CanvasRenderer_get_isMaskv, _fcvt: _fcvt, __Z15Hash128ToStringjjjj: __Z15Hash128ToStringjjjj, __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8tabCountEv: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8tabCountEv, __ZNK14SplatMaterials13HasSmoothnessEv: __ZNK14SplatMaterials13HasSmoothnessEv, _UNITY_LZ4_setStreamDecode: _UNITY_LZ4_setStreamDecode, __ZN4FMOD3DSP11getDefaultsEPfS1_S1_Pi: __ZN4FMOD3DSP11getDefaultsEPfS1_S1_Pi, __ZN11Rigidbody2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11Rigidbody2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, _select_scan_parameters: _select_scan_parameters, __ZN5physx11PxcLtbSolveERKNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPNS_14PxcSIMDSpatialE: __ZN5physx11PxcLtbSolveERKNS_9PxcFsDataEPNS_6shdfnd3aos5Vec3VEPNS_14PxcSIMDSpatialE, _int_upsample: _int_upsample, _dirfd: _dirfd, __ZN5physx25contactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx25contactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __Z32getPxCloth_SelfCollisionDistancePKN5physx7PxClothE: __Z32getPxCloth_SelfCollisionDistancePKN5physx7PxClothE, __ZN5physx2Sc5Scene15setContactCacheEb: __ZN5physx2Sc5Scene15setContactCacheEb, __Z43GUIStyleState_CUSTOM_INTERNAL_set_textColorP12Il2CppObjectRK10ColorRGBAf: __Z43GUIStyleState_CUSTOM_INTERNAL_set_textColorP12Il2CppObjectRK10ColorRGBAf, __ZN11AudioSource8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11AudioSource8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYv, __Z47Register_UnityEngine_Random_GetRandomUnitCirclev: __Z47Register_UnityEngine_Random_GetRandomUnitCirclev, __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZL22StaticInitializePlayerPv: __ZL22StaticInitializePlayerPv, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj, __ZN18AudioMixerSnapshot13AwakeFromLoadE17AwakeFromLoadMode: __ZN18AudioMixerSnapshot13AwakeFromLoadE17AwakeFromLoadMode, __ZN19ShaderPropertySheet21GetWritableFloatArrayEi: __ZN19ShaderPropertySheet21GetWritableFloatArrayEi, __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN9ShaderLab10GrabPasses23ApplyGrabPassMainThreadERKNS_16FastPropertyNameER17ShaderPassContext: __ZN9ShaderLab10GrabPasses23ApplyGrabPassMainThreadERKNS_16FastPropertyNameER17ShaderPassContext, __ZN9GfxDevice18CreateVertexBufferEv: __ZN9GfxDevice18CreateVertexBufferEv, __Z26Mesh_CUSTOM_UploadMeshDataP12Il2CppObjecth: __Z26Mesh_CUSTOM_UploadMeshDataP12Il2CppObjecth, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_16PxSphereGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_16PxSphereGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetAlphaAffectsIntensityv: __Z73Register_UnityEngine_ParticleSystem_LightsModule_SetAlphaAffectsIntensityv, __ZN3WWW18GetResponseHeadersEv: __ZN3WWW18GetResponseHeadersEv, __ZN11Rigidbody2D4CastERK8Vector2ffP12RaycastHit2Di: __ZN11Rigidbody2D4CastERK8Vector2ffP12RaycastHit2Di, __ZN5physx25PxVehicleCopyDynamicsDataERKNS_24PxVehicleCopyDynamicsMapERKNS_15PxVehicleWheelsEPS3_: __ZN5physx25PxVehicleCopyDynamicsDataERKNS_24PxVehicleCopyDynamicsMapERKNS_15PxVehicleWheelsEPS3_, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMinCCDAdvanceCoefficientEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE27getMinCCDAdvanceCoefficientEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyINS_12PxFilterDataEEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyINS_12PxFilterDataEEEbRT_, _png_get_int_32: _png_get_int_32, __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix3v: __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix3v, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags, __ZN5physx17PxScaleRigidActorERNS_12PxRigidActorEfb: __ZN5physx17PxScaleRigidActorERNS_12PxRigidActorEfb, __ZN8GUIStyle16CalcContentRectsERK5RectTIfE8Vector2fS4_RS1_S5_RfS6_iiS4_: __ZN8GUIStyle16CalcContentRectsERK5RectTIfE8Vector2fS4_RS1_S5_RfS6_iiS4_, __ZN8VRDevice8ShutdownEv: __ZN8VRDevice8ShutdownEv, __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv: __ZN5physx23NpRigidDynamicGetShapesERNS_3Scb4BodyERPKPv, __ZN5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE: __ZN5physx5cloth9SwFactory11createClothENS0_5RangeIKNS_6PxVec4EEERNS0_6FabricE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj505ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj505ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i: __ZN21TreeBinaryTreeBuilder5SplitER14TreeBinaryTreeRK8Vector3fS4_i, __ZN5physx2Gu29computeConvex_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbRNS_10PxSweepHitE: __ZN5physx2Gu29computeConvex_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES6_ffbRNS_10PxSweepHitE, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYMultiplierv, __ZN21AnimationPosePlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE: __ZN21AnimationPosePlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE, __ZN12_GLOBAL__N_110DataStream5flushEv: __ZN12_GLOBAL__N_110DataStream5flushEv, __Z44Register_UnityEngine_Joint_INTERNAL_set_axisv: __Z44Register_UnityEngine_Joint_INTERNAL_set_axisv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj493ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj493ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN14ParticleSystem13DidDeleteMeshEv: __ZN14ParticleSystem13DidDeleteMeshEv, __ZN11LightProbes8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11LightProbes8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z29scripting_class_enum_basetypeP11Il2CppClass: __Z29scripting_class_enum_basetypeP11Il2CppClass, __ZL25ResetEllipsoidEmitterRandv: __ZL25ResetEllipsoidEmitterRandv, __ZN10builtintex15GetBlackTextureEv: __ZN10builtintex15GetBlackTextureEv, __ZN5physx13NpVolumeCacheD0Ev: __ZN5physx13NpVolumeCacheD0Ev, __ZN4crnd10dxt5_block15unpack_endpointEjj: __ZN4crnd10dxt5_block15unpack_endpointEjj, __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb: __ZN5physx2Gu14epaPenetrationERKNS0_7ConvexVES3_PNS0_17EPASupportMapPairEPhS6_hRNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEb, __ZNK13TranslateGLES4WrapE15TextureWrapMode: __ZNK13TranslateGLES4WrapE15TextureWrapMode, __Z77Register_UnityEngine_Networking_UnityWebRequest_InternalGetResponseHeaderKeysv: __Z77Register_UnityEngine_Networking_UnityWebRequest_InternalGetResponseHeaderKeysv, __Z47Register_UnityEngine_Gizmos_INTERNAL_set_matrixv: __Z47Register_UnityEngine_Gizmos_INTERNAL_set_matrixv, __ZN14CachingManager9AuthorizeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_xiS8_: __ZN14CachingManager9AuthorizeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_xiS8_, __Z11GetINetworkv: __Z11GetINetworkv, __Z32getPxCloth_LinearDragCoefficientPKN5physx7PxClothE: __Z32getPxCloth_LinearDragCoefficientPKN5physx7PxClothE, __ZN14CachingManager8IsCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128: __ZN14CachingManager8IsCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_ED2Ev, __ZN12_GLOBAL__N_110Connection7releaseEv: __ZN12_GLOBAL__N_110Connection7releaseEv, __ZN5physx3Cct26CharacterControllerManager15getRenderBufferEv: __ZN5physx3Cct26CharacterControllerManager15getRenderBufferEv, __Z42Register_UnityEngine_WindZone_get_windMainv: __Z42Register_UnityEngine_WindZone_get_windMainv, __ZNK7b2Mat337Solve22ERK6b2Vec2: __ZNK7b2Mat337Solve22ERK6b2Vec2, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __ZN18BackgroundJobQueue10InitializeEv: __ZN18BackgroundJobQueue10InitializeEv, __ZN17PolygonCollider2DD2Ev: __ZN17PolygonCollider2DD2Ev, __ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii: __ZL33CheckTextureArraySetGetPixelsArgsRK14Texture2DArrayiPKvii, __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN5Cache18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN19RuntimeSceneManager28RemoveWaitingForLoadingSceneEP10UnityScene: __ZN19RuntimeSceneManager28RemoveWaitingForLoadingSceneEP10UnityScene, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbumpEi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbumpEi, __Z47Register_UnityEngine_AnimationClip_get_stopTimev: __Z47Register_UnityEngine_AnimationClip_get_stopTimev, __ZN17ProfilerFrameData10ThreadDataD2Ev: __ZN17ProfilerFrameData10ThreadDataD2Ev, __ZN4crnd12crn_unpacker11init_tablesEv: __ZN4crnd12crn_unpacker11init_tablesEv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN7ApiGLES11SetCullModeE8CullMode: __ZN7ApiGLES11SetCullModeE8CullMode, __ZN9ShaderLab14SerializedPass8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab14SerializedPass8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sn17readAllPropertiesINS_17PxHeightFieldDescEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_17PxHeightFieldDescEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __Z52Register_UnityEngine_Physics2D_get_baumgarteTOIScalev: __Z52Register_UnityEngine_Physics2D_get_baumgarteTOIScalev, _erfl: _erfl, __Z41Physics2D_CUSTOM_INTERNAL_CALL_BoxCastAllRK13Vector2fIcallS1_fS1_fiff: __Z41Physics2D_CUSTOM_INTERNAL_CALL_BoxCastAllRK13Vector2fIcallS1_fS1_fiff, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2EPK15dense_hashtableISA_S6_SC_SK_SF_SI_EPKSA_SR_b, __ZN12b2MouseJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN12b2MouseJoint24SolveVelocityConstraintsERK12b2SolverData, __ZNKSt3__215__codecvt_utf16IDiLb0EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IDiLb0EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_8ios_baseES5_E: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRNS_8ios_baseES5_E, __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D: __Z38ConvertRayCastHit2DColliderToScriptingP12RaycastHit2D, __ZN5physx2Gu21intersectSphereSphereERKNS0_6SphereES3_: __ZN5physx2Gu21intersectSphereSphereERKNS0_6SphereES3_, __Z38RenderTexture_CUSTOM_Internal_SetWidthP12Il2CppObjecti: __Z38RenderTexture_CUSTOM_Internal_SetWidthP12Il2CppObjecti, _UNITY_FT_Init_Class_cff_cmap_unicode_class_rec: _UNITY_FT_Init_Class_cff_cmap_unicode_class_rec, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj436ENS_22PxRepXPropertyAccessorILj436ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj436ENS_22PxRepXPropertyAccessorILj436ES4_ffEEEEvRKT0_, __ZN2UI11CanvasGroup15InitializeClassEv: __ZN2UI11CanvasGroup15InitializeClassEv, __Z42Register_UnityEngine_AndroidJNI_GetVersionv: __Z42Register_UnityEngine_AndroidJNI_GetVersionv, __ZNK4Mesh18ExtractVertexArrayEP8Vector3f: __ZNK4Mesh18ExtractVertexArrayEP8Vector3f, __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE: __ZN5physx2Sc7BodySim22updateCachedTransformsERNS_17PxsTransformCacheE, __ZNK25BlendshapePropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK25BlendshapePropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_: __ZN7Joint2D8TransferI17RemapPPtrTransferEEvRT_, __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI24GenerateTypeTreeTransferEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __Z32GameObject_Set_Custom_PropActiveP12Il2CppObjecth: __Z32GameObject_Set_Custom_PropActiveP12Il2CppObjecth, __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE: __ZN5physxL20applyAllPreFiltersVCEPNS_12PxActorShapeERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_7NpSceneERNS5_INS_9PxHitFlag4EnumEtEE, _UNITY_png_set_swap: _UNITY_png_set_swap, __ZN12GUIClipStateC2Ev: __ZN12GUIClipStateC2Ev, __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI7TextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z17InstantiateObjectR6ObjectRK8Vector3fRK11Quaternionf: __Z17InstantiateObjectR6ObjectRK8Vector3fRK11Quaternionf, __ZN17AnimationPlayable27SetupStateMachineBehavioursEP6Object: __ZN17AnimationPlayable27SetupStateMachineBehavioursEP6Object, _mknod: _mknod, __ZNK12b2WheelJoint19GetJointTranslationEv: __ZNK12b2WheelJoint19GetJointTranslationEv, __Z35CalculateTriangleAreaRadialFrustum2P8Vector3ffff: __Z35CalculateTriangleAreaRadialFrustum2P8Vector3ffff, __Z22GetRegisteredVRDevicesv: __Z22GetRegisteredVRDevicesv, __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17Physics2DSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, _UNITY_png_get_cHRM: _UNITY_png_get_cHRM, __ZN12WheelJoint2D16CheckConsistencyEv: __ZN12WheelJoint2D16CheckConsistencyEv, __ZN11UnityEngine9Animation40SetFlattenedSkeletonTransformsMainThreadER9TransformRKNS0_21AvatarBindingConstantE: __ZN11UnityEngine9Animation40SetFlattenedSkeletonTransformsMainThreadER9TransformRKNS0_21AvatarBindingConstantE, __ZN5physx7NpCloth19addCollisionCapsuleEjj: __ZN5physx7NpCloth19addCollisionCapsuleEjj, __Z40getPxVehicleDifferential4WDataMFrontBiasPKN5physx27PxVehicleDifferential4WDataE: __Z40getPxVehicleDifferential4WDataMFrontBiasPKN5physx27PxVehicleDifferential4WDataE, __Z41Rigidbody_CUSTOM_INTERNAL_CALL_IsSleepingP12Il2CppObject: __Z41Rigidbody_CUSTOM_INTERNAL_CALL_IsSleepingP12Il2CppObject, __ZN9ShaderLab18SerializedProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab18SerializedProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14ParticleSystem17MainThreadCleanupEv: __ZN14ParticleSystem17MainThreadCleanupEv, __ZN4FMOD5Sound7releaseEv: __ZN4FMOD5Sound7releaseEv, __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE24GenerateTypeTreeTransferEvRPT_PKcRjS8_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE24GenerateTypeTreeTransferEvRPT_PKcRjS8_RT0_, _strtof: _strtof, __GLOBAL__sub_I_PluginInterfaceVR_cpp: __GLOBAL__sub_I_PluginInterfaceVR_cpp, _strtod: _strtod, __ZNK12CubemapArray13GetDataHeightEv: __ZNK12CubemapArray13GetDataHeightEv, _strtol: _strtol, __ZN14GfxContextGLES8Instance10InvalidateEv: __ZN14GfxContextGLES8Instance10InvalidateEv, __ZL23setMassAndUpdateInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb: __ZL23setMassAndUpdateInertiabRN5physx11PxRigidBodyEPKfjPKNS_6PxVec3Eb, __ZN19RuntimeSceneManager16UnloadSceneAsyncEP10UnityScene: __ZN19RuntimeSceneManager16UnloadSceneAsyncEP10UnityScene, _UNITY_png_read_filter_row_paeth_1byte_pixel: _UNITY_png_read_filter_row_paeth_1byte_pixel, __ZNSt3__219__thread_local_dataEv: __ZNSt3__219__thread_local_dataEv, __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags, __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11AudioFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__218__insertion_sort_3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEvT0_S5_T_, __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ResetCullingMatrixv: __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ResetCullingMatrixv, _strtox: _strtox, _rgb_gray_convert_22: _rgb_gray_convert_22, __ZN23ForwardShaderRenderLoop23CleanupShadowJobHeadersEv: __ZN23ForwardShaderRenderLoop23CleanupShadowJobHeadersEv, __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB: __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB, __ZNK5physx13NpVolumeCache7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE: __ZNK5physx13NpVolumeCache7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE, __Z35AnimationState_Get_Custom_PropLayerP12Il2CppObject: __Z35AnimationState_Get_Custom_PropLayerP12Il2CppObject, __Z49setPxVehicleDifferential4WDataMRearLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf: __Z49setPxVehicleDifferential4WDataMRearLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf, __ZNK22GenericPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK22GenericPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __Z32Screen_Set_Custom_PropFullScreenh: __Z32Screen_Set_Custom_PropFullScreenh, __Z76Register_UnityEngine_ParticleSystem_CollisionModule_SetUsesCollisionMessagesv: __Z76Register_UnityEngine_ParticleSystem_CollisionModule_SetUsesCollisionMessagesv, __ZNK13InitialModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4Eb: __ZNK13InitialModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4Eb, __Z48Register_UnityEngine_AnimationClip_get_frameRatev: __Z48Register_UnityEngine_AnimationClip_get_frameRatev, __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_get_worldCenterOfMassv: __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_get_worldCenterOfMassv, __ZN5physx12NpConstraint23setMinResponseThresholdEf: __ZN5physx12NpConstraint23setMinResponseThresholdEf, __Z34Collider2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti: __Z34Collider2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti, __ZN9GfxDevice21SwapDynamicVBOBuffersEj: __ZN9GfxDevice21SwapDynamicVBOBuffersEj, __ZN20TextRenderingPrivate15DynamicFontData19GetFaceForCharacterERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEERKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEjj: __ZN20TextRenderingPrivate15DynamicFontData19GetFaceForCharacterERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEERKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEjj, __ZN11Rigidbody2D27SetUseFullKinematicContactsEb: __ZN11Rigidbody2D27SetUseFullKinematicContactsEb, __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE: __ZNK5physx2Sc8BodyCore18getKinematicTargetERNS_11PxTransformE, __Z69Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimeMultiplierv: __Z69Register_UnityEngine_ParticleSystem_TrailModule_GetLifetimeMultiplierv, __Z51Rigidbody2D_Set_Custom_PropUseFullKinematicContactsP12Il2CppObjecth: __Z51Rigidbody2D_Set_Custom_PropUseFullKinematicContactsP12Il2CppObjecth, __ZN13GfxDeviceGLES20UpdateConstantBufferEijPKv: __ZN13GfxDeviceGLES20UpdateConstantBufferEijPKv, __ZN5physx2Gu10ConvexMesh7releaseEv: __ZN5physx2Gu10ConvexMesh7releaseEv, __ZNK13TranslateGLES14GetShaderStageEN2gl11ShaderStageE: __ZNK13TranslateGLES14GetShaderStageEN2gl11ShaderStageE, __Z13RegisterClassI24EllipsoidParticleEmitterEvv: __Z13RegisterClassI24EllipsoidParticleEmitterEvv, __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv: __ZNK5physx17ConvexHullBuilder17CheckHullPolygonsEv, __ZN11UnityEngine15PlatformWrapper19GetBundleIdentifierEv: __ZN11UnityEngine15PlatformWrapper19GetBundleIdentifierEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj, __ZNK5Umbra4Tome12getStatisticENS0_9StatisticE: __ZNK5Umbra4Tome12getStatisticENS0_9StatisticE, __Z46UnityWebRequest_Set_Custom_PropDownloadHandlerP12Il2CppObjectS0_: __Z46UnityWebRequest_Set_Custom_PropDownloadHandlerP12Il2CppObjectS0_, __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj: __ZN5physx2Gu17GJKCPairDoSimplexEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_RKS3_Rj, __Z38Projector_Get_Custom_PropNearClipPlaneP12Il2CppObject: __Z38Projector_Get_Custom_PropNearClipPlaneP12Il2CppObject, __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z30ComputeShader_CUSTOM_SetBufferP12Il2CppObjectiiS0_: __Z30ComputeShader_CUSTOM_SetBufferP12Il2CppObjectiiS0_, __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetSeparateAxesv: __Z73Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetSeparateAxesv, __Z18setPxScene_GravityPN5physx7PxSceneERKNS_6PxVec3E: __Z18setPxScene_GravityPN5physx7PxSceneERKNS_6PxVec3E, __Z37Shader_Get_Custom_PropDisableBatchingP12Il2CppObject: __Z37Shader_Get_Custom_PropDisableBatchingP12Il2CppObject, __ZN4Mesh19GetVertexBufferDataER16VertexBufferData: __ZN4Mesh19GetVertexBufferDataER16VertexBufferData, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj4ENS_22PxRepXPropertyAccessorILj4ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj4ENS_22PxRepXPropertyAccessorILj4ES4_ffEEEEvRKT0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj447ENS_22PxRepXPropertyAccessorILj447ES4_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj447ENS_22PxRepXPropertyAccessorILj447ES4_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESC_EEEEvRKT0_, __ZNK21IntermediateRenderers13GetSceneNodesEv: __ZNK21IntermediateRenderers13GetSceneNodesEv, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefIKhEE: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefIKhEE, __ZN13MonoBehaviour18TransferEngineDataI24GenerateTypeTreeTransferEE4PPtrI10MonoScriptERT_: __ZN13MonoBehaviour18TransferEngineDataI24GenerateTypeTreeTransferEE4PPtrI10MonoScriptERT_, __ZN11TimeManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11TimeManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Gu9Container5EmptyEv: __ZN5physx2Gu9Container5EmptyEv, __ZN11UnityEngine15CloudWebService19SessionEventManager5CloseEv: __ZN11UnityEngine15CloudWebService19SessionEventManager5CloseEv, __ZN11UnityEngine15CloudWebService18RestFileDownloader7OpenVFSEv: __ZN11UnityEngine15CloudWebService18RestFileDownloader7OpenVFSEv, __ZN17CommonStringTable16StaticInitializeEPv: __ZN17CommonStringTable16StaticInitializeEPv, __ZN10GameObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10GameObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19getTypePairFrictionEjj: __ZNK5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19getTypePairFrictionEjj, __ZN5physx2Sc8ClothSim21removeCollisionSphereEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim21removeCollisionSphereEPKNS0_8ShapeSimE, __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKPositionInternalv: __Z65Register_UnityEngine_Animator_INTERNAL_CALL_SetIKPositionInternalv, __ZNK32RendererMaterialAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK32RendererMaterialAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZNSt3__26locale5__impC2ERKS1_PNS0_5facetEl: __ZNSt3__26locale5__impC2ERKS1_PNS0_5facetEl, __Z38Register_UnityEngine_Material_GetFloatv: __Z38Register_UnityEngine_Material_GetFloatv, __ZNK9Texture3D20GetRuntimeMemorySizeEv: __ZNK9Texture3D20GetRuntimeMemorySizeEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKc, __ZNK12CullingGroup34GetEffectiveDistanceReferencePointEv: __ZNK12CullingGroup34GetEffectiveDistanceReferencePointEv, __ZN12MeshRenderer13DidDeleteMeshEv: __ZN12MeshRenderer13DidDeleteMeshEv, __Z30AudioSource_CUSTOM_PlayOneShotP12Il2CppObjectS0_f: __Z30AudioSource_CUSTOM_PlayOneShotP12Il2CppObjectS0_f, __ZN12NavMeshAgent6ResumeEv: __ZN12NavMeshAgent6ResumeEv, __Z48TargetJoint2D_Get_Custom_PropAutoConfigureTargetP12Il2CppObject: __Z48TargetJoint2D_Get_Custom_PropAutoConfigureTargetP12Il2CppObject, __Z37Register_UnityEngine_Camera_set_depthv: __Z37Register_UnityEngine_Camera_set_depthv, __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_: __ZN6Camera23SetTargetTextureBuffersEP13RenderTextureiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_PS1_, __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawWireSphereRK8Vector3ff: __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawWireSphereRK8Vector3ff, __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z64ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZL17ProgramUniform4ivPK7ApiGLESjiihPKv: __ZL17ProgramUniform4ivPK7ApiGLESjiihPKv, __Z52Register_UnityEngine_Font_RequestCharactersInTexturev: __Z52Register_UnityEngine_Font_RequestCharactersInTexturev, __Z34Cubemap_Get_Custom_PropMipmapCountP12Il2CppObject: __Z34Cubemap_Get_Custom_PropMipmapCountP12Il2CppObject, __Z50Register_UnityEngine_PointEffector2D_set_forceModev: __Z50Register_UnityEngine_PointEffector2D_set_forceModev, __ZNK5physx2Sc18ParticleSystemCore14getWorldBoundsEv: __ZNK5physx2Sc18ParticleSystemCore14getWorldBoundsEv, __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE13StaticDestroyES5_: __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE13StaticDestroyES5_, __Z38Input_Set_Custom_PropMultiTouchEnabledh: __Z38Input_Set_Custom_PropMultiTouchEnabledh, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj, __Z50Register_UnityEngine_RenderTexture_SupportsStencilv: __Z50Register_UnityEngine_RenderTexture_SupportsStencilv, __ZN2UI13RectTransform12CleanupClassEv: __ZN2UI13RectTransform12CleanupClassEv, __Z18CleanupHaloManagerv: __Z18CleanupHaloManagerv, __ZN24MaterialDisplayListCache24GetCachedPassForMaterialERK18SharedMaterialDataPN9ShaderLab4PassE: __ZN24MaterialDisplayListCache24GetCachedPassForMaterialERK18SharedMaterialDataPN9ShaderLab4PassE, __Z13TransferFieldI24GenerateTypeTreeTransferLb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI24GenerateTypeTreeTransferLb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __ZN12_GLOBAL__N_117ConnectionManager25recordDeallocationHandlerEPv: __ZN12_GLOBAL__N_117ConnectionManager25recordDeallocationHandlerEPv, __ZNK5physx2Sc9RigidCore10getPxActorEv: __ZNK5physx2Sc9RigidCore10getPxActorEv, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE7reserveEj, __ZN5Light8TransferI14SafeBinaryReadEEvRT_: __ZN5Light8TransferI14SafeBinaryReadEEvRT_, __ZN9GfxDevice23UnregisterNativeTextureE9TextureID: __ZN9GfxDevice23UnregisterNativeTextureE9TextureID, __ZN11KeyframeTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11KeyframeTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z48Register_UnityEngine_QualitySettings_set_shadowsv: __Z48Register_UnityEngine_QualitySettings_set_shadowsv, __Z44Register_UnityEngine_Terrain_set_terrainDatav: __Z44Register_UnityEngine_Terrain_set_terrainDatav, __ZN19TouchPhaseEmulationC2Efb: __ZN19TouchPhaseEmulationC2Efb, __Z35Register_UnityEngine_Light_set_typev: __Z35Register_UnityEngine_Light_set_typev, __ZN12TreeInstance8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12TreeInstance8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE: __ZN5physx16writeFloatBufferEPKfjbRNS_14PxOutputStreamE, __Z24Font_CUSTOM_HasCharacterP12Il2CppObjectt: __Z24Font_CUSTOM_HasCharacterP12Il2CppObjectt, __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN9Animation25CheckRendererVisibleStateEv: __ZN9Animation25CheckRendererVisibleStateEv, __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __ZNK13GfxDeviceGLES21GetDefaultHDRRTFormatEv: __ZNK13GfxDeviceGLES21GetDefaultHDRRTFormatEv, __ZN14RotationModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14RotationModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx27PxLockedDataGeneratedValuesC2EPKNS_12PxLockedDataE: __ZN5physx27PxLockedDataGeneratedValuesC2EPKNS_12PxLockedDataE, __Z11GetImageTagR11UTF16StringRi: __Z11GetImageTagR11UTF16StringRi, __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI14SafeBinaryReadEEvRS5_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStrN11AssetBundle9AssetInfoEEEE8TransferI14SafeBinaryReadEEvRS5_RT_, __Z43Register_UnityEngine_GUITexture_set_texturev: __Z43Register_UnityEngine_GUITexture_set_texturev, __ZN12_GLOBAL__N_117ConnectionManager22setIsTopLevelUIElementEPKvb: __ZN12_GLOBAL__N_117ConnectionManager22setIsTopLevelUIElementEPKvb, __ZN8Renderer23NotifySceneHandleChangeEi: __ZN8Renderer23NotifySceneHandleChangeEi, __Z18Transfer_BlittableI14SafeBinaryReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26vectorItNS_9allocatorItEEE6assignIPtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_: __ZNSt3__26vectorItNS_9allocatorItEEE6assignIPtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_, __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_12PxFixedJointEE11getTypeNameEv, __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv: __ZN7ApiGLES23EnableVertexArrayAttribEjjN2gl21VertexArrayAttribKindEi19VertexChannelFormatiPKv, __ZNK5Umbra14DepthmapReader9visualizeEPKNS_7ImpTomeEPNS_12QueryContextEi: __ZNK5Umbra14DepthmapReader9visualizeEPKNS_7ImpTomeEPNS_12QueryContextEi, __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass: __ZNK17MonoScriptManager17FindRuntimeScriptEP11Il2CppClass, __Z53Register_UnityEngine_Graphics_Internal_DrawMeshMatrixv: __Z53Register_UnityEngine_Graphics_Internal_DrawMeshMatrixv, __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxPrismaticJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZN8VRDevice20CreateVRSplashScreenEv: __ZN8VRDevice20CreateVRSplashScreenEv, __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L12utf8_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE, __Z34Register_UnityEngine_GL_PushMatrixv: __Z34Register_UnityEngine_GL_PushMatrixv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE, __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, _unity_z_tr_align: _unity_z_tr_align, __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve, __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESb16TextureDimension9TextureIDjjjRK17RenderSurfaceDesc: __ZN4gles25CreateUpdateRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESb16TextureDimension9TextureIDjjjRK17RenderSurfaceDesc, __ZN5physx2Sc10NPhaseCore24releaseShapeInstancePairEPNS0_19ShapeInstancePairLLEjj: __ZN5physx2Sc10NPhaseCore24releaseShapeInstancePairEPNS0_19ShapeInstancePairLLEjj, __ZNSt3__26vectorI17TransferMetaFlags13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI17TransferMetaFlags13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN12_GLOBAL__N_16ParserILb1EE7releaseEv: __ZN12_GLOBAL__N_16ParserILb1EE7releaseEv, __Z29StdTemplateConversionFunctionIhbEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhbEbPvR14SafeBinaryRead, __ZN11TerrainData7AddUserEP10GameObject: __ZN11TerrainData7AddUserEP10GameObject, __ZNK5physx7NpScene16getCpuDispatcherEv: __ZNK5physx7NpScene16getCpuDispatcherEv, __ZN8b2IslandD2Ev: __ZN8b2IslandD2Ev, __ZN5physx2Gu17RadixSortBufferedD0Ev: __ZN5physx2Gu17RadixSortBufferedD0Ev, __ZNK20LocalFileSystemPosix5IsDirERK13FileEntryData: __ZNK20LocalFileSystemPosix5IsDirERK13FileEntryData, _memchr: _memchr, __Z29CreateShaderVariantCollectionv: __Z29CreateShaderVariantCollectionv, __Z40OffMeshLink_Get_Custom_PropBiDirectionalP12Il2CppObject: __Z40OffMeshLink_Get_Custom_PropBiDirectionalP12Il2CppObject, __ZNK12SocketStream10IsBlockingEv: __ZNK12SocketStream10IsBlockingEv, __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11setGridSizeEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11setGridSizeEf, __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateScriptv: __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateScriptv, __ZNK13BuildSettings13GetHashOfTypeEPKN5Unity4TypeE: __ZNK13BuildSettings13GetHashOfTypeEPKN5Unity4TypeE, __ZN9DebugGLESC2ERK7ApiGLES: __ZN9DebugGLESC2ERK7ApiGLES, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE8__appendEj, __Z21CheckShouldRenderPassiR8Material: __Z21CheckShouldRenderPassiR8Material, __Z17GetManagerContextv: __Z17GetManagerContextv, __ZN10SampleClipD0Ev: __ZN10SampleClipD0Ev, __Z32Caching_Get_Custom_PropSpaceFreev: __Z32Caching_Get_Custom_PropSpaceFreev, __ZN5physx7NpScene20checkResultsInternalEb: __ZN5physx7NpScene20checkResultsInternalEb, __ZN16ParticleRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16ParticleRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv: __ZNK5physx2Sc9ActorPair24releaseContactReportDataEv, _cf2_stack_count: _cf2_stack_count, __Z18Transfer_BlittableI14SafeBinaryReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18TestAABBVisibilityPKN5Umbra15OcclusionBufferE8Vector3fS3_: __Z18TestAABBVisibilityPKN5Umbra15OcclusionBufferE8Vector3fS3_, __ZN5physx2Sc13ConstraintSim15setBreakForceLLEff: __ZN5physx2Sc13ConstraintSim15setBreakForceLLEff, __ZN8Collider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8Collider23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN13WheelCollider12ScaleChangedEv: __ZN13WheelCollider12ScaleChangedEv, __ZNK13OcclusionArea15GetGlobalCenterEv: __ZNK13OcclusionArea15GetGlobalCenterEv, __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher19HandleDeleteFailureERNS0_16SessionContainerE, __Z9GetIUmbrav: __Z9GetIUmbrav, __ZN5UmbramlERKNS_7Vector2ERKNS_9Matrix2x2E: __ZN5UmbramlERKNS_7Vector2ERKNS_9Matrix2x2E, __ZN5physx23ArticulationRootManagerD0Ev: __ZN5physx23ArticulationRootManagerD0Ev, __ZNSt3__26chrono12system_clock3nowEv: __ZNSt3__26chrono12system_clock3nowEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb: __ZN5physx2GuL34fullContactsGenerationConvexConvexERKNS0_11ConvexHullVERS1_RKNS_6shdfnd3aos12PsTransformVES9_bbPNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS6_5Vec3VERKNS6_6FloatVEb, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZNK16ChannelGroupData18GetMeasuredVULevelEi: __ZNK16ChannelGroupData18GetMeasuredVULevelEi, __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_10StartEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EE18handleProfileEventINS0_10StartEventEEEbRT_, __ZN9shadertag7CleanupEv: __ZN9shadertag7CleanupEv, __Z48setPxArticulationJoint_SwingLimitContactDistancePN5physx19PxArticulationJointEf: __Z48setPxArticulationJoint_SwingLimitContactDistancePN5physx19PxArticulationJointEf, __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace: __Z51ParticleSystem_MainModule_CUSTOM_SetSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace, __ZN18CrashReportHandler9HandleLogERK8UnityStrS2_7LogType: __ZN18CrashReportHandler9HandleLogERK8UnityStrS2_7LogType, __ZNK5physx7NpScene15getFrictionTypeEv: __ZNK5physx7NpScene15getFrictionTypeEv, __Z43Register_UnityEngine_Material_get_passCountv: __Z43Register_UnityEngine_Material_get_passCountv, __ZN26AnimatorControllerPlayable11UpdateGraphEf: __ZN26AnimatorControllerPlayable11UpdateGraphEf, __Z34AndroidJNI_CUSTOM_CallStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z34AndroidJNI_CUSTOM_CallStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN5physx12NpBatchQuery7releaseEv: __ZN5physx12NpBatchQuery7releaseEv, __Z51NavMeshAgent_Get_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObject: __Z51NavMeshAgent_Get_Custom_PropAutoTraverseOffMeshLinkP12Il2CppObject, __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21EnlightenSceneMapping8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12_GLOBAL__N_114D6JointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_114D6JointProjectEPKvRN5physx11PxTransformES4_b, __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE19FileEnumerationFlagRNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_: __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE19FileEnumerationFlagRNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_, __ZN6Camera21AddPostRenderCallbackEPFvRS_PvES1_: __ZN6Camera21AddPostRenderCallbackEPFvRS_PvES1_, __Z13TransferArrayILi3Ej19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_: __Z13TransferArrayILi3Ej19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_, __ZNSt3__227__insertion_sort_incompleteIR17CompareInstanceIDPP6ObjectEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR17CompareInstanceIDPP6ObjectEEbT0_S6_T_, _UNITY_tt_glyphzone_done: _UNITY_tt_glyphzone_done, __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj: __ZN4core20StringStorageDefaultIcE7replaceEjjPKcj, _openlog: _openlog, __Z48Register_UnityEngine_Renderer_get_sharedMaterialv: __Z48Register_UnityEngine_Renderer_get_sharedMaterialv, __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_: __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_, __ZN14MessageHandler17WillHandleMessageEPvji: __ZN14MessageHandler17WillHandleMessageEPvji, __Z3absRK8Scalar4f: __Z3absRK8Scalar4f, _psh_globals_destroy: _psh_globals_destroy, __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi: __ZNK9Texture2D9GetPixelsEiiiiiP10ColorRGBAfi, __ZN5physx34solveFriction_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx34solveFriction_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx38PxVehicleSuspensionDataGeneratedValuesC2EPKNS_23PxVehicleSuspensionDataE: __ZN5physx38PxVehicleSuspensionDataGeneratedValuesC2EPKNS_23PxVehicleSuspensionDataE, __Z30Joint_CUSTOM_INTERNAL_get_axisP12Il2CppObjectP8Vector3f: __Z30Joint_CUSTOM_INTERNAL_get_axisP12Il2CppObjectP8Vector3f, __ZZ23InitPlayerLoopCallbacksvEN47FixedUpdateScriptRunDelayedFixedFrameRatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN47FixedUpdateScriptRunDelayedFixedFrameRatestruct7ForwardEv, __ZL27DestroySpeedTreeWindManagerPv: __ZL27DestroySpeedTreeWindManagerPv, __ZN5physx42solveContactCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx42solveContactCoulombPreBlock_ConcludeStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx33solveContact_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx33solveContact_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN17PersistentManager22GetFromActivationQueueEi: __ZN17PersistentManager22GetFromActivationQueueEi, __ZN13SliderJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SliderJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z51CharacterJoint_CUSTOM_INTERNAL_set_twistLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring: __Z51CharacterJoint_CUSTOM_INTERNAL_set_twistLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring, __Z29Transfer_Blittable_ArrayFieldI9JSONWritedEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritedEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18SpeedTreeWindAsset17MainThreadCleanupEv: __ZN18SpeedTreeWindAsset17MainThreadCleanupEv, __ZN5Unity5Cloth23SetExternalAccelerationERK8Vector3f: __ZN5Unity5Cloth23SetExternalAccelerationERK8Vector3f, __Z39ParticleRenderer_Set_Custom_PropUvTilesP12Il2CppObjectP11Il2CppArray: __Z39ParticleRenderer_Set_Custom_PropUvTilesP12Il2CppObjectP11Il2CppArray, __Z49Register_UnityEngine_Animation_set_animatePhysicsv: __Z49Register_UnityEngine_Animation_set_animatePhysicsv, __Z26ExtractAllRenderersInSceneR13dynamic_arrayIP8RendererLj4EE: __Z26ExtractAllRenderersInSceneR13dynamic_arrayIP8RendererLj4EE, __Z18Transfer_BlittableI8JSONReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18BaseUnityAnalyticsD2Ev: __ZN18BaseUnityAnalyticsD2Ev, __ZN5Umbra20ObjectDistanceParamsC2EPKNS_7Vector3Ef: __ZN5Umbra20ObjectDistanceParamsC2EPKNS_7Vector3Ef, __Z64Register_UnityEngine_TerrainData_get_Internal_alphamapResolutionv: __Z64Register_UnityEngine_TerrainData_get_Internal_alphamapResolutionv, __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE: __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsConvexEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE, __ZN28LightsModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN28LightsModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __Z31Object_Get_Custom_PropHideFlagsP12Il2CppObject: __Z31Object_Get_Custom_PropHideFlagsP12Il2CppObject, __Z58Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_Draw2v: __Z58Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_Draw2v, __ZN9BlobWrite8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim4hand4HandEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sc13ClothBulkData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc13ClothBulkData17getBinaryMetaDataERNS_14PxOutputStreamE, __Z15GL_CUSTOM_Flushv: __Z15GL_CUSTOM_Flushv, __Z49Register_UnityEngine_Camera_get_stereoConvergencev: __Z49Register_UnityEngine_Camera_get_stereoConvergencev, __ZN11AssetBundle7GetImplEiRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN11AssetBundle7GetImplEiRKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z40SpriteRenderer_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z40SpriteRenderer_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __ZN11GameManager24NetworkOnApplicationQuitEv: __ZN11GameManager24NetworkOnApplicationQuitEv, _null_convert: _null_convert, __ZN14NavMeshCarvingC2Ev: __ZN14NavMeshCarvingC2Ev, __ZN12CachedReaderC2Ev: __ZN12CachedReaderC2Ev, _UNITY_LZ4_uncompress_unknownOutputSize: _UNITY_LZ4_uncompress_unknownOutputSize, __ZN11LightProbesD2Ev: __ZN11LightProbesD2Ev, __Z93Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInFixedTimeInternalv: __Z93Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_PlayInFixedTimeInternalv, __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_: __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_, __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE12__move_rangeEPS4_S8_S8_: __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE12__move_rangeEPS4_S8_S8_, __Z52Register_UnityEngine_RectTransform_INTERNAL_get_rectv: __Z52Register_UnityEngine_RectTransform_INTERNAL_get_rectv, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_20PxConvexMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_20PxConvexMeshGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE18__construct_at_endEj: __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE18__construct_at_endEj, __ZNK23AnimationOffsetPlayable15GetApplyMotionXEv: __ZNK23AnimationOffsetPlayable15GetApplyMotionXEv, __ZNK5Unity10HingeJoint14CanWriteSpringEv: __ZNK5Unity10HingeJoint14CanWriteSpringEv, __ZN11GameManagerD0Ev: __ZN11GameManagerD0Ev, __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrENS_21AssetBundleLoadResultE: __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrENS_21AssetBundleLoadResultE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z68Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_EnableRectClippingv: __Z68Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_EnableRectClippingv, __Z33TrailRenderer_Get_Custom_PropTimeP12Il2CppObject: __Z33TrailRenderer_Get_Custom_PropTimeP12Il2CppObject, __Z23setPxScene_CCDMaxPassesPN5physx7PxSceneEj: __Z23setPxScene_CCDMaxPassesPN5physx7PxSceneEj, __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN16PackedQuatVector8TransferI14SafeBinaryReadEEvRT_: __ZN16PackedQuatVector8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc5Scene15deleteAggregateEj: __ZN5physx2Sc5Scene15deleteAggregateEj, __ZNK5physx2Sc8BodyCore14getWakeCounterEv: __ZNK5physx2Sc8BodyCore14getWakeCounterEv, __ZNK11b2EdgeShape9TestPointERK11b2TransformRK6b2Vec2: __ZNK11b2EdgeShape9TestPointERK11b2TransformRK6b2Vec2, __ZN15LightProbeUtils34RemoveDuplicateLightProbePositionsEPK8Vector3fiR13dynamic_arrayIS0_Lj4EE: __ZN15LightProbeUtils34RemoveDuplicateLightProbePositionsEPK8Vector3fiR13dynamic_arrayIS0_Lj4EE, _jpeg_set_colorspace: _jpeg_set_colorspace, __ZN15NavMeshObstacle23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15NavMeshObstacle23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx6shdfnd10Foundation24getReportAllocationNamesEv: __ZNK5physx6shdfnd10Foundation24getReportAllocationNamesEv, __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode: __ZN17PersistentManager22MakeObjectUnpersistentEi13UnpersistMode, __ZN20ArchiveStorageHeader10ReadHeaderER12FileAccessorRNS_6HeaderE: __ZN20ArchiveStorageHeader10ReadHeaderER12FileAccessorRNS_6HeaderE, __Z40TerrainData_Set_Custom_PropTreeInstancesP12Il2CppObjectP11Il2CppArray: __Z40TerrainData_Set_Custom_PropTreeInstancesP12Il2CppObjectP11Il2CppArray, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_19GenericStringStreamIS2_EEEEjRT_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_19GenericStringStreamIS2_EEEEjRT_, __Z60Register_UnityEngine_ParticleRenderer_get_particleRenderModev: __Z60Register_UnityEngine_ParticleRenderer_get_particleRenderModev, __Z46SystemInfo_Get_Custom_PropGraphicsDeviceVendorv: __Z46SystemInfo_Get_Custom_PropGraphicsDeviceVendorv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEvPT_jRKT0_RKT1_j, __ZN5Unity9ComponentD2Ev: __ZN5Unity9ComponentD2Ev, __Z38Physics2D_CUSTOM_SetLayerCollisionMaskii: __Z38Physics2D_CUSTOM_SetLayerCollisionMaskii, __ZgeRK8Scalar4fS1_: __ZgeRK8Scalar4fS1_, _swscanf: _swscanf, _mrand48: _mrand48, __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMinP12Il2CppObjectP13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_get_anchorMinP12Il2CppObjectP13Vector2fIcall, __ZN5physx2Gu18gjkRelativeRayCastINS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVES3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb, __Z24RegisterStrippedTypeInfoI15ParticleEmitterEviPKcS2_: __Z24RegisterStrippedTypeInfoI15ParticleEmitterEviPKcS2_, __Z34Renderer_CUSTOM_SetStaticBatchInfoP12Il2CppObjectii: __Z34Renderer_CUSTOM_SetStaticBatchInfoP12Il2CppObjectii, __ZNK5Umbra15OcclusionBuffer8getWidthEv: __ZNK5Umbra15OcclusionBuffer8getWidthEv, __ZN7mecanim9animation27GetWeightsFreeformCartesianERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb: __ZN7mecanim9animation27GetWeightsFreeformCartesianERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb, __Z20GetThreadedGfxDevicev: __Z20GetThreadedGfxDevicev, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16getContactOffsetEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16getContactOffsetEv, __ZNSt3__215numpunct_bynameIcED0Ev: __ZNSt3__215numpunct_bynameIcED0Ev, __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector2fLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector2fLj4EEEEvRT_PKc17TransferMetaFlags, __ZNK5physx16PxParticleSystem8isKindOfEPKc: __ZNK5physx16PxParticleSystem8isKindOfEPKc, __Z48Register_UnityEngine_Mesh_SetArrayForChannelImplv: __Z48Register_UnityEngine_Mesh_SetArrayForChannelImplv, __ZN19VREyeTextureManager16UpdateFrameCountEj: __ZN19VREyeTextureManager16UpdateFrameCountEj, __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx2Sc17ParticleSystemSim23scheduleShapeGenerationERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim23scheduleShapeGenerationERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE, __ZN5physx20BigConvexDataBuilder10InitializeEv: __ZN5physx20BigConvexDataBuilder10InitializeEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9CGProgramC2E10MemLabelId18ObjectCreationMode: __ZN9CGProgramC2E10MemLabelId18ObjectCreationMode, __Z64Register_UnityEngine_Transform_INTERNAL_CALL_GetLocalEulerAnglesv: __Z64Register_UnityEngine_Transform_INTERNAL_CALL_GetLocalEulerAnglesv, __ZN5physx2Sc8ShapeSim21destroyTransformCacheERNS_17PxsTransformCacheE: __ZN5physx2Sc8ShapeSim21destroyTransformCacheERNS_17PxsTransformCacheE, __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE: __ZN5physx2Sc18ParticleSystemCore16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE, __Z61Register_UnityEngine_LightProbeProxyVolume_set_resolutionModev: __Z61Register_UnityEngine_LightProbeProxyVolume_set_resolutionModev, __Z45Rigidbody_Set_Custom_PropSleepAngularVelocityP12Il2CppObjectf: __Z45Rigidbody_Set_Custom_PropSleepAngularVelocityP12Il2CppObjectf, __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI21ScriptingMethodIl2CppP19ProfilerInformationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, _setlogmask: _setlogmask, __Z57Register_UnityEngine_SliderJoint2D_get_autoConfigureAnglev: __Z57Register_UnityEngine_SliderJoint2D_get_autoConfigureAnglev, __ZN20FloatToHalfConverter26InitializePrecomputeTablesEPv: __ZN20FloatToHalfConverter26InitializePrecomputeTablesEPv, __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetRowIndexv: __Z75Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetRowIndexv, __Z19TransferField_ArrayI9JSONWrite16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI9JSONWrite16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZL34GetComponentsImplementationRecurseILb0ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN9GfxDeviceD0Ev: __ZN9GfxDeviceD0Ev, __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_: __ZN10__cxxabiv112_GLOBAL__N_117parse_call_offsetEPKcS2_, __ZN13GfxDeviceGLES30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb: __ZN13GfxDeviceGLES30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb, __ZN10MemoryPoolC2EbPKcii10MemLabelIdi: __ZN10MemoryPoolC2EbPKcii10MemLabelIdi, __ZN15dtPathQueryInfoD2Ev: __ZN15dtPathQueryInfoD2Ev, __Z61Register_UnityEngine_AudioLowPassFilter_set_lowpassResonanceQv: __Z61Register_UnityEngine_AudioLowPassFilter_set_lowpassResonanceQv, __Z57Register_UnityEngine_Sprite_Internal_GetTextureRectOffsetv: __Z57Register_UnityEngine_Sprite_Internal_GetTextureRectOffsetv, __Z45Quaternion_CUSTOM_INTERNAL_CALL_LerpUnclampedRK11QuaternionfS1_fRS_: __Z45Quaternion_CUSTOM_INTERNAL_CALL_LerpUnclampedRK11QuaternionfS1_fRS_, __Z35getPxScene_CCDContactModifyCallbackPKN5physx7PxSceneE: __Z35getPxScene_CCDContactModifyCallbackPKN5physx7PxSceneE, __ZN5audio5mixer18AudioMixerConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5audio5mixer18AudioMixerConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11AudioSource11SetPriorityEi: __ZN11AudioSource11SetPriorityEi, __ZN23ArchiveStorageConverter18DecompressAndStoreEv: __ZN23ArchiveStorageConverter18DecompressAndStoreEv, ___clang_call_terminate: ___clang_call_terminate, __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN22BaseUnityConnectClient17StartEventHandlerEv: __ZN22BaseUnityConnectClient17StartEventHandlerEv, __ZN18ScriptingArguments12GetBooleanAtEi: __ZN18ScriptingArguments12GetBooleanAtEi, __ZN11UnityEngine9Analytics15UserCustomEventD0Ev: __ZN11UnityEngine9Analytics15UserCustomEventD0Ev, __Z26BuildSerializationCacheForP11Il2CppClassRb: __Z26BuildSerializationCacheForP11Il2CppClassRb, __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN23CloudWebServicesManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK5physx29PxSphereGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEEEEEjT_j: __ZNK5physx29PxSphereGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEEEEEjT_j, __ZN22BaseUnityConnectClient20StartEventDispatcherEv: __ZN22BaseUnityConnectClient20StartEventDispatcherEv, __ZN4Mesh19GetInstantiatedMeshEPS_R6Object: __ZN4Mesh19GetInstantiatedMeshEPS_R6Object, __ZN4PPtrI6SpriteE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI6SpriteE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK10Collider2D10IsTouchingEPS_: __ZNK10Collider2D10IsTouchingEPS_, __ZN4FMOD6System9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE: __ZN4FMOD6System9createDSPEP20FMOD_DSP_DESCRIPTIONPPNS_3DSPE, __Z32Application_CUSTOM_HasProLicensev: __Z32Application_CUSTOM_HasProLicensev, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __Z37NavMeshObstacle_Set_Custom_PropRadiusP12Il2CppObjectf: __Z37NavMeshObstacle_Set_Custom_PropRadiusP12Il2CppObjectf, __Z50NavMesh_CUSTOM_INTERNAL_CALL_CalculatePathInternalRK8Vector3fS1_iP12Il2CppObject: __Z50NavMesh_CUSTOM_INTERNAL_CALL_CalculatePathInternalRK8Vector3fS1_iP12Il2CppObject, __ZN18AssetBundleManager35RemoveAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation: __ZN18AssetBundleManager35RemoveAssetBundleLoadAssetOperationEP29AssetBundleLoadAssetOperation, __ZN5physx2Gu9Container18DeleteKeepingOrderEj: __ZN5physx2Gu9Container18DeleteKeepingOrderEj, _UNITY_tt_face_load_strike_metrics: _UNITY_tt_face_load_strike_metrics, __ZN5Cache17ReadCacheInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlS9_: __ZN5Cache17ReadCacheInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlS9_, __Z28Cloth_Get_Custom_PropNormalsP12Il2CppObject: __Z28Cloth_Get_Custom_PropNormalsP12Il2CppObject, __ZThn4_N16RayRTreeCallbackILi0ELb1EED0Ev: __ZThn4_N16RayRTreeCallbackILi0ELb1EED0Ev, __ZN5physx2Sq17SceneQueryManager30blockingSPURaycastOverlapSweepEPNS_12NpBatchQueryEPb: __ZN5physx2Sq17SceneQueryManager30blockingSPURaycastOverlapSweepEPNS_12NpBatchQueryEPb, __Z46Playables_CUSTOM_INTERNAL_CALL_InternalDestroyR9HPlayable: __Z46Playables_CUSTOM_INTERNAL_CALL_InternalDestroyR9HPlayable, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEEC2EPNS0_7SystemIEi: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEEC2EPNS0_7SystemIEi, __ZN16PxOverflowBufferIN5physx10PxSweepHitEED0Ev: __ZN16PxOverflowBufferIN5physx10PxSweepHitEED0Ev, __ZN5physx5cloth8SwFabricC2ERNS0_9SwFactoryEjNS0_5RangeIKjEES6_NS4_IKfEES6_S6_S8_j: __ZN5physx5cloth8SwFabricC2ERNS0_9SwFactoryEjNS0_5RangeIKjEES6_NS4_IKfEES6_S6_S8_j, __Z42Register_UnityEngine_AnimationCurve_AddKeyv: __Z42Register_UnityEngine_AnimationCurve_AddKeyv, __ZN12NavMeshAgent4WarpERK8Vector3f: __ZN12NavMeshAgent4WarpERK8Vector3f, __ZN5physx31PxDefaultSimulationFilterShaderEjNS_12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj: __ZN5physx31PxDefaultSimulationFilterShaderEjNS_12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj, __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf: __ZN13WheelCollider37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf, __ZNK5physx13PxContactPair15extractContactsEPNS_18PxContactPairPointEj: __ZNK5physx13PxContactPair15extractContactsEPNS_18PxContactPairPointEj, __Z40SystemInfo_Get_Custom_PropMaxTextureSizev: __Z40SystemInfo_Get_Custom_PropMaxTextureSizev, __Z34GL_CUSTOM_IssuePluginEventInternal13Il2Cpp_IntPtri: __Z34GL_CUSTOM_IssuePluginEventInternal13Il2Cpp_IntPtri, __ZN7mecanim9animation29MotionOutputSetDeltaTransformEPNS0_12MotionOutputERKN4math4trsXE: __ZN7mecanim9animation29MotionOutputSetDeltaTransformEPNS0_12MotionOutputERKN4math4trsXE, __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Stopv: __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Stopv, __Z53Register_UnityEngine_ParticleSystem_get_startRotationv: __Z53Register_UnityEngine_ParticleSystem_get_startRotationv, __ZN7mecanim12statemachine18DestroyStateOutputEPNS0_11StateOutputERNS_6memory9AllocatorE: __ZN7mecanim12statemachine18DestroyStateOutputEPNS0_11StateOutputERNS_6memory9AllocatorE, __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_: __ZN18DelayedCallManager17CancelCallDelayedE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN18AudioLowPassFilter8TransferI14SafeBinaryReadEEvRT_: __ZN18AudioLowPassFilter8TransferI14SafeBinaryReadEEvRT_, __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_, __ZNK9Texture2D20ExtractImageInternalEP14ImageReferenceNS0_8BlitModeEbi: __ZNK9Texture2D20ExtractImageInternalEP14ImageReferenceNS0_8BlitModeEbi, __ZN5physx28PxArticulationRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx28PxArticulationRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN15b2RevoluteJointC2EPK18b2RevoluteJointDef: __ZN15b2RevoluteJointC2EPK18b2RevoluteJointDef, __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback: __ZL17QueryDetailBVTreeRK10DetailMeshRK14DetailMeshPolyRK8Vector3fS7_P25QueryDetailBVTreeCallback, __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object: __Z33scripting_unity_engine_object_newP11Il2CppClassP6Object, __ZN17GeneralConnection13GetConnectionEj: __ZN17GeneralConnection13GetConnectionEj, __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_get_colorv: __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_get_colorv, __Z42Register_UnityEngine_Renderer_get_materialv: __Z42Register_UnityEngine_Renderer_get_materialv, __ZN7mecanim12statemachine28DestroySelectorStateConstantEPNS0_21SelectorStateConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine28DestroySelectorStateConstantEPNS0_21SelectorStateConstantERNS_6memory9AllocatorE, __ZN17b2ContactListenerD0Ev: __ZN17b2ContactListenerD0Ev, __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce: __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEce, __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_: __ZNSt3__26__sortIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEvT0_S8_T_, __ZN5physx8debugger4comm15DestroyInstanceD0Ev: __ZN5physx8debugger4comm15DestroyInstanceD0Ev, __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi: __ZN5Unity4Type41GetDeserializationStubForPersistentTypeIDEi, __Z25IsManagerContextAvailablei: __Z25IsManagerContextAvailablei, __Z28getPxScene_MeshContactMarginPKN5physx7PxSceneE: __Z28getPxScene_MeshContactMarginPKN5physx7PxSceneE, __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing2LimitP12Il2CppObjectRK14SoftJointLimit: __Z46CharacterJoint_CUSTOM_INTERNAL_set_swing2LimitP12Il2CppObjectRK14SoftJointLimit, __ZNK13SpeedTreeWind23ComputeOscillationTimesEPf: __ZNK13SpeedTreeWind23ComputeOscillationTimesEPf, __ZNK12AudioManager10GetDSPTimeEv: __ZNK12AudioManager10GetDSPTimeEv, __Z47Register_UnityEngine_Physics_set_sleepThresholdv: __Z47Register_UnityEngine_Physics_set_sleepThresholdv, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEv, __ZNK5Umbra18ImpOcclusionBuffer15dumpDebugBufferEPvRKNS_15OcclusionBuffer10BufferDescE: __ZNK5Umbra18ImpOcclusionBuffer15dumpDebugBufferEPvRKNS_15OcclusionBuffer10BufferDescE, __ZNKSt3__215__codecvt_utf16IwLb0EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IwLb0EE11do_encodingEv, __ZN12b2ChainShape5ClearEv: __ZN12b2ChainShape5ClearEv, __Z42Terrain_Get_Custom_PropDrawTreesAndFoliageP12Il2CppObject: __Z42Terrain_Get_Custom_PropDrawTreesAndFoliageP12Il2CppObject, __ZN9Coroutine17SetMoveNextMethodE21ScriptingMethodIl2Cpp: __ZN9Coroutine17SetMoveNextMethodE21ScriptingMethodIl2Cpp, __ZN20TextRenderingPrivate8TextMesh7GetMeshEv: __ZN20TextRenderingPrivate8TextMesh7GetMeshEv, __Z34Register_UnityEngine_Event_Cleanupv: __Z34Register_UnityEngine_Event_Cleanupv, __Z13FindConverterPKcS0_: __Z13FindConverterPKcS0_, __ZNK9Texture2D12GetDimensionEv: __ZNK9Texture2D12GetDimensionEv, _unity_z_crc32: _unity_z_crc32, __ZNK16TypeTreeIterator8ChildrenEv: __ZNK16TypeTreeIterator8ChildrenEv, __Z42ParticleSystem_Set_Custom_PropMaxParticlesP12Il2CppObjecti: __Z42ParticleSystem_Set_Custom_PropMaxParticlesP12Il2CppObjecti, __Z26Random_Get_Custom_PropSeedv: __Z26Random_Get_Custom_PropSeedv, __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt64v: __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt64v, __ZN5physx2Sc9ClothCore23removeCollisionTriangleEj: __ZN5physx2Sc9ClothCore23removeCollisionTriangleEj, __ZN14StackAllocatorD0Ev: __ZN14StackAllocatorD0Ev, __ZN13WebCamTexture5PauseEv: __ZN13WebCamTexture5PauseEv, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE19resizeUninitializedEj, __ZNK5physx7NpCloth23getNbCollisionTrianglesEv: __ZNK5physx7NpCloth23getNbCollisionTrianglesEv, __ZN26AnimatorOverrideController23GetAnimationSetBindingsEv: __ZN26AnimatorOverrideController23GetAnimationSetBindingsEv, __ZN5physx35PxcSweepEstimateAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f: __ZN5physx35PxcSweepEstimateAnyShapeHeightfieldERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f, __ZNK5physx3Cct26CharacterControllerManager17onObstacleRemovedEj: __ZNK5physx3Cct26CharacterControllerManager17onObstacleRemovedEj, __Z52Register_UnityEngine_ReflectionProbe_get_refreshModev: __Z52Register_UnityEngine_ReflectionProbe_get_refreshModev, __ZNK5physx14PxTriangleMesh8isKindOfEPKc: __ZNK5physx14PxTriangleMesh8isKindOfEPKc, __ZN18ProceduralMaterial8TransferI17RemapPPtrTransferEEvRT_: __ZN18ProceduralMaterial8TransferI17RemapPPtrTransferEEvRT_, __ZN13AudioProfiler15CaptureDSPNodesEPN4FMOD3DSPERNS_27AudioProfilerCaptureContextEjjf: __ZN13AudioProfiler15CaptureDSPNodesEPN4FMOD3DSPERNS_27AudioProfilerCaptureContextEjjf, __Z52Register_UnityEngine_AndroidJNI_SetStaticStringFieldv: __Z52Register_UnityEngine_AndroidJNI_SetStaticStringFieldv, __ZNK5physx2Sc9ClothCore14getNbParticlesEv: __ZNK5physx2Sc9ClothCore14getNbParticlesEv, __Z21getPxJoint_BreakForcePKN5physx7PxJointERfS3_: __Z21getPxJoint_BreakForcePKN5physx7PxJointERfS3_, __ZNK8Renderer16GetMaterialCountEv: __ZNK8Renderer16GetMaterialCountEv, __ZThn32_N8RendererD0Ev: __ZThn32_N8RendererD0Ev, __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMinCCDAdvanceCoefficientEf: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE27setMinCCDAdvanceCoefficientEf, __ZN22AnimationMixerPlayableC2E18DirectorPlayerType: __ZN22AnimationMixerPlayableC2E18DirectorPlayerType, __ZNK14SerializedFile13GetAllFileIDsER13dynamic_arrayIxLj8EE: __ZNK14SerializedFile13GetAllFileIDsER13dynamic_arrayIxLj8EE, __Z50Register_UnityEngine_QualitySettings_IncreaseLevelv: __Z50Register_UnityEngine_QualitySettings_IncreaseLevelv, __ZNK5physx12NpConstraint7isValidEv: __ZNK5physx12NpConstraint7isValidEv, __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI8MaterialEPT_17AwakeFromLoadMode10MemLabelId, _UNITY_png_handle_bKGD: _UNITY_png_handle_bKGD, __ZNK9dtNavMesh11calcTileLocEPKfPiS2_: __ZNK9dtNavMesh11calcTileLocEPKfPiS2_, __ZNK5physx18PxVehicleDriveTank7isValidEv: __ZNK5physx18PxVehicleDriveTank7isValidEv, __ZNK5physx36PxVehicleSuspensionDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEEEEEjT_j: __ZNK5physx36PxVehicleSuspensionDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEEEEEjT_j, __Z55ParticleSystemExtensionsImpl_CUSTOM_GetTriggerParticlesP12Il2CppObjectiS0_: __Z55ParticleSystemExtensionsImpl_CUSTOM_GetTriggerParticlesP12Il2CppObjectiS0_, __ZN15ConstantForce2D8SetForceERK8Vector2f: __ZN15ConstantForce2D8SetForceERK8Vector2f, __Z23VehicleComputeTireForcePKvffffffffffffRfS1_S1_S1_: __Z23VehicleComputeTireForcePKvffffffffffffRfS1_S1_S1_, __Z62Register_UnityEngine_LightProbeProxyVolume_set_boundingBoxModev: __Z62Register_UnityEngine_LightProbeProxyVolume_set_boundingBoxModev, __ZN16BaseVideoTextureD0Ev: __ZN16BaseVideoTextureD0Ev, __ZN7mecanim12statemachine17EvaluateSelectorsEPKNS0_20StateMachineConstantEPKNS_18ValueArrayConstantEPNS_10ValueArrayEjPKNS0_17StateMachineInputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceE: __ZN7mecanim12statemachine17EvaluateSelectorsEPKNS0_20StateMachineConstantEPKNS_18ValueArrayConstantEPNS_10ValueArrayEjPKNS0_17StateMachineInputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceE, __ZNK14dtNavMeshQuery14isInClosedListEy: __ZNK14dtNavMeshQuery14isInClosedListEy, __ZN11UnityEngine15CloudWebService13WWWRestClient5AbortEv: __ZN11UnityEngine15CloudWebService13WWWRestClient5AbortEv, _rgb_ycc_convert: _rgb_ycc_convert, __ZNK25BlendshapePropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK25BlendshapePropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN8FindClipclERK4PPtrI13AnimationClipE: __ZN8FindClipclERK4PPtrI13AnimationClipE, __ZN11UnityEngine15CloudWebService16SessionContainer23UpdateFirstAddEventTimeEv: __ZN11UnityEngine15CloudWebService16SessionContainer23UpdateFirstAddEventTimeEv, __ZN13SliderJoint2D21SetAutoConfigureAngleEb: __ZN13SliderJoint2D21SetAutoConfigureAngleEb, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev, __Z31AudioSource_Set_Custom_PropTimeP12Il2CppObjectf: __Z31AudioSource_Set_Custom_PropTimeP12Il2CppObjectf, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_9basic_iosIcS2_EES6_E: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRNS_9basic_iosIcS2_EES6_E, __ZN10DebugStats11DeserializeEPPi: __ZN10DebugStats11DeserializeEPPi, __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetDurationInternalv: __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetDurationInternalv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj162ENS_22PxRepXPropertyAccessorILj162ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj162ENS_22PxRepXPropertyAccessorILj162ES4_ffEEEEvRKT0_, __Z20Event_CUSTOM_CleanupP12Il2CppObject: __Z20Event_CUSTOM_CleanupP12Il2CppObject, __Z11CopyBuffersRN5physx13PxcNpWorkUnitERNS_18PxcNpThreadContextEb: __Z11CopyBuffersRN5physx13PxcNpWorkUnitERNS_18PxcNpThreadContextEb, __Z49ParticleSystem_NoiseModule_CUSTOM_GetRemapEnabledP12Il2CppObject: __Z49ParticleSystem_NoiseModule_CUSTOM_GetRemapEnabledP12Il2CppObject, __ZN21WorldParticleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN21WorldParticleCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z41Register_UnityEngine_Screen_SetResolutionv: __Z41Register_UnityEngine_Screen_SetResolutionv, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYv, _tt_cmap13_next: _tt_cmap13_next, __Z18computeSweptBoundsRKN5physx18PxcAABBDataDynamicERNS_9PxBounds3E: __Z18computeSweptBoundsRKN5physx18PxcAABBDataDynamicERNS_9PxBounds3E, __Z27StateChangeValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object: __Z27StateChangeValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object, __ZNK18AnimatorController27GetAnimationClipsToRegisterEv: __ZNK18AnimatorController27GetAnimationClipsToRegisterEv, __Z40Transform_CUSTOM_INTERNAL_get_localScaleP12Il2CppObjectP8Vector3f: __Z40Transform_CUSTOM_INTERNAL_get_localScaleP12Il2CppObjectP8Vector3f, __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams: __ZN7dtCrowd26setObstacleAvoidanceParamsEiPK25dtObstacleAvoidanceParams, __ZN10EventEntry10PostInvokeEP12EventManager: __ZN10EventEntry10PostInvokeEP12EventManager, __Z40setPxArticulationJoint_TwistLimitEnabledPN5physx19PxArticulationJointEb: __Z40setPxArticulationJoint_TwistLimitEnabledPN5physx19PxArticulationJointEb, __ZN8Animator36GetRootBlendTreeConstantAndWorkspaceEiiRPKN7mecanim9animation21BlendTreeNodeConstantERPNS1_18BlendTreeWorkspaceE: __ZN8Animator36GetRootBlendTreeConstantAndWorkspaceEiiRPKN7mecanim9animation21BlendTreeNodeConstantERPNS1_18BlendTreeWorkspaceE, __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14MinMaxGradient8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN17PhysicsMaterial2D8TransferI14SafeBinaryReadEEvRT_: __ZN17PhysicsMaterial2D8TransferI14SafeBinaryReadEEvRT_, __Z19AddCurveToDenseClipI11QuaternionfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E: __Z19AddCurveToDenseClipI11QuaternionfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E, __Z66Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimev: __Z66Register_UnityEngine_ParticleSystem_EmissionModule_GetRateOverTimev, __Z46Animator_Set_Custom_PropLinearVelocityBlendingP12Il2CppObjecth: __Z46Animator_Set_Custom_PropLinearVelocityBlendingP12Il2CppObjecth, __ZL39InitializeTextRenderingScriptingClassesv: __ZL39InitializeTextRenderingScriptingClassesv, __ZN5physx14PxTriangleMeshD0Ev: __ZN5physx14PxTriangleMeshD0Ev, __ZN26RemapFunctorTempRemapTable18GenerateInstanceIDEi17TransferMetaFlags: __ZN26RemapFunctorTempRemapTable18GenerateInstanceIDEi17TransferMetaFlags, __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z38ScriptableObject_CUSTOM_CreateInstanceP12Il2CppString: __Z38ScriptableObject_CUSTOM_CreateInstanceP12Il2CppString, _isblank_l: _isblank_l, __ZN26ProbeSetTetrahedralization13SetTetrahedraEPK11TetrahedronS2_: __ZN26ProbeSetTetrahedralization13SetTetrahedraEPK11TetrahedronS2_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_S6_T_, __ZNK5physx16PxBroadPhaseBase7getCapsERNS_16PxBroadPhaseCapsE: __ZNK5physx16PxBroadPhaseBase7getCapsERNS_16PxBroadPhaseCapsE, __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_: __ZN5physx16PxsIslandManager7addEdgeENS0_9eEdgeTypeENS_20PxsIslandManagerHookIjLj4294967295EEES3_RS3_, __Z36WheelJoint2D_Get_Custom_PropUseMotorP12Il2CppObject: __Z36WheelJoint2D_Get_Custom_PropUseMotorP12Il2CppObject, __ZN13MonoBehaviour26HandleCoroutineReturnValueE21ScriptingMethodIl2CppP12Il2CppObject: __ZN13MonoBehaviour26HandleCoroutineReturnValueE21ScriptingMethodIl2CppP12Il2CppObject, __Z51Register_UnityEngine_Texture_get_masterTextureLimitv: __Z51Register_UnityEngine_Texture_get_masterTextureLimitv, __Z48Register_UnityEngine_Caching_set_expirationDelayv: __Z48Register_UnityEngine_Caching_set_expirationDelayv, __ZN10OnGUIState13SetKeyTooltipERK11UTF16String: __ZN10OnGUIState13SetKeyTooltipERK11UTF16String, __ZN4FMOD6System19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES: __ZN4FMOD6System19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES, __Z45Register_UnityEngine_Motion_get_apparentSpeedv: __Z45Register_UnityEngine_Motion_get_apparentSpeedv, __ZN13AudioListener23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13AudioListener23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN4FMOD5Sound13getVariationsEPfS1_S1_: __ZN4FMOD5Sound13getVariationsEPfS1_S1_, __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_GetPositionv: __Z59Register_UnityEngine_LineRenderer_INTERNAL_CALL_GetPositionv, __ZN5IMGUI9GUIWindowD2Ev: __ZN5IMGUI9GUIWindowD2Ev, __Z20sweepCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z20sweepCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN22ProceduralMaterialData17SetTextureRawDataEjP25SubstanceRawTextureShared: __ZN22ProceduralMaterialData17SetTextureRawDataEjP25SubstanceRawTextureShared, __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb: __ZN18AwakeFromLoadQueue13AwakeFromLoadE17AwakeFromLoadModeb, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE12getClassSizeEv, __ZN10TagManagerD2Ev: __ZN10TagManagerD2Ev, __ZN13AnimationClip9SetLegacyEb: __ZN13AnimationClip9SetLegacyEb, __ZNK5physx12NpConstraint23getMinResponseThresholdEv: __ZNK5physx12NpConstraint23getMinResponseThresholdEv, _UNITY_png_get_sBIT: _UNITY_png_get_sBIT, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11StartObjectEv, __ZN12GraphicsCaps11ClearMemoryEv: __ZN12GraphicsCaps11ClearMemoryEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj683ES3_NS_21PxVehicleDriveSimDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj683ES3_NS_21PxVehicleDriveSimDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation18ClipMuscleConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation18ClipMuscleConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Ext14PrismaticJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext14PrismaticJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatABGR8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatABGR8888EEvPKNS_9InnerInfoE, __ZNK5physx9PxTaskMgr16getGpuDispatcherEv: __ZNK5physx9PxTaskMgr16getGpuDispatcherEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED0Ev: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEED0Ev, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15setActorSimFlagEb: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE15setActorSimFlagEb, __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii: __ZN20TextRenderingPrivate17TextMeshGenerator3GetERK11UTF16StringPNS_8FontImplE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii, __Z14UpdateCurveKeyR17AnimationCurveTplIfEiRK11KeyframeTplIfE: __Z14UpdateCurveKeyR17AnimationCurveTplIfEiRK11KeyframeTplIfE, __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode: __ZN10Effector2DC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Gu22computeMTD_CapsuleMeshERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu22computeMTD_CapsuleMeshERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE, __ZN5physx8debugger15ForwardingArrayIPhED0Ev: __ZN5physx8debugger15ForwardingArrayIPhED0Ev, __ZN5Flare8TransferI14SafeBinaryReadEEvRT_: __ZN5Flare8TransferI14SafeBinaryReadEEvRT_, __Z20GetShaderGlobalFloatN9ShaderLab16FastPropertyNameE: __Z20GetShaderGlobalFloatN9ShaderLab16FastPropertyNameE, __ZNK5physx3Cct17CapsuleController7getTypeEv: __ZNK5physx3Cct17CapsuleController7getTypeEv, __ZN8Gradient8TransferI8JSONReadEEvRT_: __ZN8Gradient8TransferI8JSONReadEEvRT_, __Z50Register_UnityEngine_ParticleSystem_set_startDelayv: __Z50Register_UnityEngine_ParticleSystem_set_startDelayv, __Z53ThreadAndSerializationSafeCheckAllowRecursiveTransferb: __Z53ThreadAndSerializationSafeCheckAllowRecursiveTransferb, __ZNK14NavMeshManager23GetSourceTileDataBoundsER13dynamic_arrayI12TileLocationLj4EE: __ZNK14NavMeshManager23GetSourceTileDataBoundsER13dynamic_arrayI12TileLocationLj4EE, __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii: __ZL27RecalculateTypeTreeByteSizeR8TypeTreeRK16TypeTreeIteratorPii, _UNITY_FT_Get_Charmap_Index: _UNITY_FT_Get_Charmap_Index, __Z39Register_UnityEngine_Animator_get_speedv: __Z39Register_UnityEngine_Animator_get_speedv, __ZNK14PreloadManager15IsThreadRunningEv: __ZNK14PreloadManager15IsThreadRunningEv, __ZN18DelayedCallManagerC2E10MemLabelId18ObjectCreationMode: __ZN18DelayedCallManagerC2E10MemLabelId18ObjectCreationMode, __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_: __ZN14MemoryProfiler22RegisterRootAllocationEPvjP13BaseAllocatorPKcS4_, __ZN11UnityEngine7Connect13AppStartEventC2Ev: __ZN11UnityEngine7Connect13AppStartEventC2Ev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZL17ProgramUniform4fvPK7ApiGLESjiihPKv: __ZL17ProgramUniform4fvPK7ApiGLESjiihPKv, __ZNK5physx2Sc16ArticulationCore10isSleepingEv: __ZNK5physx2Sc16ArticulationCore10isSleepingEv, __Z44Terrain_CUSTOM_INTERNAL_CALL_AddTreeInstanceP12Il2CppObjectRK12TreeInstance: __Z44Terrain_CUSTOM_INTERNAL_CALL_AddTreeInstanceP12Il2CppObjectRK12TreeInstance, __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_GetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray: __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_GetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setSimulationFilterDataERKNS_12PxFilterDataE, __ZN20BufferedSocketStream18CanSendNonblockingEj: __ZN20BufferedSocketStream18CanSendNonblockingEj, __ZN7mecanim9animation26InitializeMuscleClipTablesEv: __ZN7mecanim9animation26InitializeMuscleClipTablesEv, __ZN17AudioReverbFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17AudioReverbFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE11PostRequestEv: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE11PostRequestEv, __Z45Component_CUSTOM_GetComponentsForListInternalP12Il2CppObjectS0_S0_: __Z45Component_CUSTOM_GetComponentsForListInternalP12Il2CppObjectS0_S0_, __ZN13ScreenManager13SetShowCursorEb: __ZN13ScreenManager13SetShowCursorEb, __ZN11UnityEngine7Connect13ConnectConfig11ResetValuesEv: __ZN11UnityEngine7Connect13ConnectConfig11ResetValuesEv, __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE: __ZN7mecanim9animation17EvaluateAvatarEndEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceE, __Z34AnimationState_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString: __Z34AnimationState_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString, __ZN5Umbra9Matrix4x4mLERKS0_: __ZN5Umbra9Matrix4x4mLERKS0_, __ZNK5physx2Sc16ArticulationCore14getWakeCounterEv: __ZNK5physx2Sc16ArticulationCore14getWakeCounterEv, __Z46RenderSettings_Get_Custom_PropFogStartDistancev: __Z46RenderSettings_Get_Custom_PropFogStartDistancev, __ZN20TextRenderingPrivate19NativeTextGenerator17PixelCorrectRoundEf: __ZN20TextRenderingPrivate19NativeTextGenerator17PixelCorrectRoundEf, __ZN14TerrainManager20CollectTreeRenderersEPK6CameraR13dynamic_arrayI9SceneNodeLj4EERS3_I4AABBLj4EE: __ZN14TerrainManager20CollectTreeRenderersEPK6CameraR13dynamic_arrayI9SceneNodeLj4EERS3_I4AABBLj4EE, _stbir_resize_uint8_generic: _stbir_resize_uint8_generic, __ZN5physx2Sc21ConstraintInteraction12onDeactivateEj: __ZN5physx2Sc21ConstraintInteraction12onDeactivateEj, __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __Z37AndroidJNI_CUSTOM_GetByteArrayElement13Il2Cpp_IntPtri: __Z37AndroidJNI_CUSTOM_GetByteArrayElement13Il2Cpp_IntPtri, __Z39AssetBundleRequest_Get_Custom_PropAssetP12Il2CppObject: __Z39AssetBundleRequest_Get_Custom_PropAssetP12Il2CppObject, __ZN5Umbra9Matrix4x46invertERKS0_: __ZN5Umbra9Matrix4x46invertERKS0_, __ZN5physx12NpConstraint9setActorsEPNS_12PxRigidActorES2_: __ZN5physx12NpConstraint9setActorsEPNS_12PxRigidActorES2_, __Z35CubemapArray_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh: __Z35CubemapArray_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh, __ZNK5physx2Sc9ClothCore24getParticleAccelerationsEPNS_6PxVec4E: __ZNK5physx2Sc9ClothCore24getParticleAccelerationsEPNS_6PxVec4E, _unlinkat: _unlinkat, __Z26setPxShape_QueryFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE: __Z26setPxShape_QueryFilterDataPN5physx7PxShapeERKNS_12PxFilterDataE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj158ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj158ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetWorldSpacev: __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetWorldSpacev, __Z35Animator_Get_Custom_PropPivotWeightP12Il2CppObject: __Z35Animator_Get_Custom_PropPivotWeightP12Il2CppObject, __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE: __Z43scripting_class_get_method_from_name_filterP11Il2CppClassPKciN24ScriptingMethodFiltering18MethodSearchFilterE, __Z56Register_UnityEngine_TerrainData_Internal_SetDetailLayerv: __Z56Register_UnityEngine_TerrainData_Internal_SetDetailLayerv, __Z47Register_UnityEngine_AndroidJNI_CallShortMethodv: __Z47Register_UnityEngine_AndroidJNI_CallShortMethodv, __Z34ParticleSystem_Get_Custom_PropTimeP12Il2CppObject: __Z34ParticleSystem_Get_Custom_PropTimeP12Il2CppObject, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEED0Ev, __ZN5Unity10FixedJoint5ResetEv: __ZN5Unity10FixedJoint5ResetEv, __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i: __ZNK10__cxxabiv117__class_type_info29process_static_type_above_dstEPNS_19__dynamic_cast_infoEPKvS4_i, __ZN6Avatar15SetMuscleMinMaxEiff: __ZN6Avatar15SetMuscleMinMaxEiff, __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_: __ZNSt3__27__sort3IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_T_, __ZN5Umbra9BitVector5orNotERKS0_: __ZN5Umbra9BitVector5orNotERKS0_, __ZN16RayRTreeCallbackILi1ELb0EED2Ev: __ZN16RayRTreeCallbackILi1ELb0EED2Ev, __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj: __ZNK5physx18PxcConvexTriangles16getPolygonNormalEj, __ZN18ProceduralMaterial14StopProcessingEb: __ZN18ProceduralMaterial14StopProcessingEb, __Z62Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundLocalv: __Z62Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundLocalv, __Z23AsyncReadForceCloseFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z23AsyncReadForceCloseFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14ParticleSystem17SetAutoRandomSeedEb: __ZN14ParticleSystem17SetAutoRandomSeedEb, __Z26Shader_CUSTOM_PropertyToIDP12Il2CppString: __Z26Shader_CUSTOM_PropertyToIDP12Il2CppString, __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv: __ZN24dense_hashtable_iteratorINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E30advance_past_empty_and_deletedEv, __ZN7mecanim5human29HumanComputeMomentumOfInertiaEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human29HumanComputeMomentumOfInertiaEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZN11NavMeshDataC2E10MemLabelId18ObjectCreationMode: __ZN11NavMeshDataC2E10MemLabelId18ObjectCreationMode, __Z18Transfer_BlittableI9JSONWriteLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Scb14ParticleSystem12ForceUpdates10initializeEj: __ZN5physx3Scb14ParticleSystem12ForceUpdates10initializeEj, __ZN5physx5cloth6FabricD0Ev: __ZN5physx5cloth6FabricD0Ev, _memalign: _memalign, __Z59Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatv: __Z59Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatv, __ZN9Animation5BlendERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEff: __ZN9Animation5BlendERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEff, __Z57Register_UnityEngine_Networking_UnityWebRequest_get_errorv: __Z57Register_UnityEngine_Networking_UnityWebRequest_get_errorv, __ZNKSt3__224__generic_error_category4nameEv: __ZNKSt3__224__generic_error_category4nameEv, __ZN13MemoryManager17GetAllocatorIndexEP13BaseAllocator: __ZN13MemoryManager17GetAllocatorIndexEP13BaseAllocator, __ZN10__cxxabiv116__shim_type_infoD0Ev: __ZN10__cxxabiv116__shim_type_infoD0Ev, __ZN5physx2Gu9RadixSort4SortEPKfj: __ZN5physx2Gu9RadixSort4SortEPKfj, __ZN23ShaderVariantCollectionC2E10MemLabelId18ObjectCreationMode: __ZN23ShaderVariantCollectionC2E10MemLabelId18ObjectCreationMode, __ZN6Camera15StandaloneSetupER17ShaderPassContext: __ZN6Camera15StandaloneSetupER17ShaderPassContext, __ZN14DLHAudioHelperD0Ev: __ZN14DLHAudioHelperD0Ev, __ZN5physx2Sq11PruningPool11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq11PruningPool11shiftOriginERKNS_6PxVec3E, __Z51Register_UnityEngine_Texture2DArray_Internal_Createv: __Z51Register_UnityEngine_Texture2DArray_Internal_Createv, __ZN9Transform8TransferI17RemapPPtrTransferEEvRT_: __ZN9Transform8TransferI17RemapPPtrTransferEEvRT_, __Z69Register_UnityEngine_QualitySettings_set_billboardsFaceCameraPositionv: __Z69Register_UnityEngine_QualitySettings_set_billboardsFaceCameraPositionv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z35getPxVehicleDriveDynDataMTargetGearPKN5physx21PxVehicleDriveDynDataE: __Z35getPxVehicleDriveDynDataMTargetGearPKN5physx21PxVehicleDriveDynDataE, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EE, __ZN15TerrainRenderer13CleanupMeshesEv: __ZN15TerrainRenderer13CleanupMeshesEv, __Z45Register_UnityEngine_ParticleEmitter_get_emitv: __Z45Register_UnityEngine_ParticleEmitter_get_emitv, __ZNK6Camera17CalculateUsingHDREv: __ZNK6Camera17CalculateUsingHDREv, __Z47Register_UnityEngine_MonoBehaviour_CancelInvokev: __Z47Register_UnityEngine_MonoBehaviour_CancelInvokev, __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13GetFloatValueEPv: __ZZL31RegisterOtherRendererPropertiesR22GenericPropertyBindingEN24Wrapper_m_ReceiveShadows13GetFloatValueEPv, __Z24RegisterStrippedTypeInfoI9Texture3DEviPKcS2_: __Z24RegisterStrippedTypeInfoI9Texture3DEviPKcS2_, _ether_ntoa_r: _ether_ntoa_r, __ZN5physx21PxRevoluteJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx21PxRevoluteJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __ZN6prcoreL27StretchGenericFloatBilinearI16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI16TexFormatRGFloatEEvPKNS_9InnerInfoE, _gzprintf: _gzprintf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj4ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEclILj4ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN16MessageForwarder27RegisterAllMessagesCallbackEPFvPviR11MessageDataEPFbS0_iS2_E: __ZN16MessageForwarder27RegisterAllMessagesCallbackEPFvPviR11MessageDataEPFbS0_iS2_E, __ZN4FMOD6System11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD6System11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __Z18profiler_end_framev: __Z18profiler_end_framev, __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11NamedObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN13MonoBehaviour17MainThreadCleanupEv: __ZN13MonoBehaviour17MainThreadCleanupEv, __ZN39AssetBundleLoadFromStreamAsyncOperation22FinalizeArchiveCreatorEv: __ZN39AssetBundleLoadFromStreamAsyncOperation22FinalizeArchiveCreatorEv, __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_get_sizeCustomP12Il2CppObjectP8Vector3f: __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_get_sizeCustomP12Il2CppObjectP8Vector3f, __Z17RegisterModule_AIv: __Z17RegisterModule_AIv, __ZN5physx15PxCollectionExt6removeERNS_12PxCollectionEtPS1_: __ZN5physx15PxCollectionExt6removeERNS_12PxCollectionEtPS1_, __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferItEEvRT_PKc17TransferMetaFlags, __ZN15AnchoredJoint2D9SetAnchorERK8Vector2f: __ZN15AnchoredJoint2D9SetAnchorERK8Vector2f, __Z45ParticleSystem_Set_Custom_PropSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace: __Z45ParticleSystem_Set_Custom_PropSimulationSpaceP12Il2CppObject29ParticleSystemSimulationSpace, __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayIPN5Unity9ComponentELj4EEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayIPN5Unity9ComponentELj4EEEiP11Il2CppArrayRKT_i, __ZN10TagManager19GetSortingLayerNameEi: __ZN10TagManager19GetSortingLayerNameEi, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE7releaseEv: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE7releaseEv, __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN6HelperI14SafeBinaryRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI14SafeBinaryRead18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN5physx2Gu16SupportLocalImplINS0_9TriangleVEED0Ev: __ZN5physx2Gu16SupportLocalImplINS0_9TriangleVEED0Ev, __Z44WebCamTexture_Get_Custom_PropRequestedHeightP12Il2CppObject: __Z44WebCamTexture_Get_Custom_PropRequestedHeightP12Il2CppObject, __ZNK23iPhoneLocalNotification12GetAlertBodyEv: __ZNK23iPhoneLocalNotification12GetAlertBodyEv, __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_: __ZN8Material24SetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameERK8Vector2fS4_, _UNITY_png_get_copyright: _UNITY_png_get_copyright, __ZN10FlareLayer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10FlareLayer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN18GlslGpuProgramGLES14CompileProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_S8_S8_S8_R14ChannelAssigns: __ZN18GlslGpuProgramGLES14CompileProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_S8_S8_S8_R14ChannelAssigns, __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN5physx9PxTaskMgr15submitNamedTaskEPNS_6PxTaskEPKcNS_10PxTaskType4EnumE: __ZN5physx9PxTaskMgr15submitNamedTaskEPNS_6PxTaskEPKcNS_10PxTaskType4EnumE, __ZN4FMOD4DSPI15getSystemObjectEPPNS_6SystemE: __ZN4FMOD4DSPI15getSystemObjectEPPNS_6SystemE, _zipOpenNewFileInZip3: _zipOpenNewFileInZip3, __ZN8Playable7ConnectEPS_S0_ii: __ZN8Playable7ConnectEPS_S0_ii, __ZN9Animation19SortAnimationStatesEv: __ZN9Animation19SortAnimationStatesEv, __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatABGR8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatABGR8888EEvPKNS_9InnerInfoE, __ZN15AABBTreeRaycastILb0EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE: __ZN15AABBTreeRaycastILb0EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE, __ZN7b2World13DrawDebugDataEv: __ZN7b2World13DrawDebugDataEv, __ZN11LightProbes23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11LightProbes23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN16NovodexAllocator10deallocateEPv: __ZN16NovodexAllocator10deallocateEPv, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE: __Z39EnsureQuaternionContinuityPreserveSlopeR17AnimationCurveTplI11QuaternionfE, __Z42Register_UnityEngine_Texture2D_GetPixels32v: __Z42Register_UnityEngine_Texture2D_GetPixels32v, __ZN9GfxDevice20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi: __ZN9GfxDevice20UpdateSkinPoseBufferEP17GPUSkinPoseBufferPK10Matrix4x4fi, __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE: __ZNK5physx2Gu5RTree12traverseAABBERKNS_6PxVec3ES4_jPjPNS1_8CallbackE, __ZN26PlayerSettingsSplashScreen8SetDirtyEv: __ZN26PlayerSettingsSplashScreen8SetDirtyEv, __ZN14AnimationState15InitializeClassEv: __ZN14AnimationState15InitializeClassEv, __ZN14BillboardAsset10SetIndicesEPKtj: __ZN14BillboardAsset10SetIndicesEPKtj, __ZN5physx2Sn13XmlNodeReader14addOrGotoChildEPKc: __ZN5physx2Sn13XmlNodeReader14addOrGotoChildEPKc, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE12readPropertyIfEEbRT_, __ZN20UnityConnectSettings14GetCloudUserIdEv: __ZN20UnityConnectSettings14GetCloudUserIdEv, __ZNSt3__212ctype_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__212ctype_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __Z32Canvas_Set_Custom_PropRenderModeP12Il2CppObjectN2UI6Canvas10RenderModeE: __Z32Canvas_Set_Custom_PropRenderModeP12Il2CppObjectN2UI6Canvas10RenderModeE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj593ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj593ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18ScreenManagerWebGL31EmscriptenFullScreenChangeEventEPKv: __ZN18ScreenManagerWebGL31EmscriptenFullScreenChangeEventEPKv, __Z46RenderTexture_Get_Custom_PropEnableRandomWriteP12Il2CppObject: __Z46RenderTexture_Get_Custom_PropEnableRandomWriteP12Il2CppObject, __ZN5physx38setupFinalizeSolverConstraintsCoulomb4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRNS_27PxcCorrelationBufferCoulombEjjjRKNS_6shdfnd3aos5Vec4VESB_SB_SB_: __ZN5physx38setupFinalizeSolverConstraintsCoulomb4EPNS_21PxcSolverContact4DescERNS_18PxcNpThreadContextEPhffRNS_27PxcCorrelationBufferCoulombEjjjRKNS_6shdfnd3aos5Vec4VESB_SB_SB_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15UnityWebRequestC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN15UnityWebRequestC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb: __Z19FindShaderLabShaderRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorI4PPtrI6ShaderENS3_ISB_EEEEb, __ZN7mecanim13ValueArrayAddEPKNS_10ValueArrayES2_PKNS_14ValueArrayMaskEfbPS0_PS3_: __ZN7mecanim13ValueArrayAddEPKNS_10ValueArrayES2_PKNS_14ValueArrayMaskEfbPS0_PS3_, __ZN8Renderer16CheckConsistencyEv: __ZN8Renderer16CheckConsistencyEv, __Z67Register_UnityEngine_RenderSettings_set_defaultReflectionResolutionv: __Z67Register_UnityEngine_RenderSettings_set_defaultReflectionResolutionv, __ZNK14ParticleSystem16GetStartLifeTimeEv: __ZNK14ParticleSystem16GetStartLifeTimeEv, __ZN5physx7NpScene17addParticleSystemERNS_16NpParticleSystemE: __ZN5physx7NpScene17addParticleSystemERNS_16NpParticleSystemE, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_17TransferMetaFlags, __Z51Register_UnityEngine_TargetJoint2D_get_dampingRatiov: __Z51Register_UnityEngine_TargetJoint2D_get_dampingRatiov, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEbT0_SB_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEbT0_SB_T_, __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx7NpCloth23setExternalAccelerationENS_6PxVec3E: __ZN5physx7NpCloth23setExternalAccelerationENS_6PxVec3E, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxConvexMeshGeometryEEEEclILj269ES3_PNS_12PxConvexMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Sc5Scene13endSimulationEv: __ZN5physx2Sc5Scene13endSimulationEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEPKcj, __Z20IsTexEnvBuiltinParamPKcPi: __Z20IsTexEnvBuiltinParamPKcPi, __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEjT0_S8_S8_S8_S8_T_, __Z49Bounds_CUSTOM_INTERNAL_CALL_Internal_IntersectRayR3RayR4AABBPf: __Z49Bounds_CUSTOM_INTERNAL_CALL_Internal_IntersectRayR3RayR4AABBPf, __ZN5physx10PxsContext24removeParticleSystemImplEPNS_20PxvParticleSystemSimEb: __ZN5physx10PxsContext24removeParticleSystemImplEPNS_20PxvParticleSystemSimEb, __ZN5Umbra4HashIiiE10getDefaultERKiS3_: __ZN5Umbra4HashIiiE10getDefaultERKiS3_, __ZN12FileAccessorD0Ev: __ZN12FileAccessorD0Ev, __Z42RelativeJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall: __Z42RelativeJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20getRigidDynamicFlagsEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE20getRigidDynamicFlagsEv, __Z55Register_UnityEngine_Animation_INTERNAL_set_localBoundsv: __Z55Register_UnityEngine_Animation_INTERNAL_set_localBoundsv, __ZN5physx2Gu3EPA14expandTriangleERiRKNS_6shdfnd3aos6FloatVES7_: __ZN5physx2Gu3EPA14expandTriangleERiRKNS_6shdfnd3aos6FloatVES7_, __ZN5physx9NpPhysics16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj: __ZN5physx9NpPhysics16createConstraintEPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj, __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z59ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE: __ZN5physx2Sc16InteractionScene21unregisterInteractionEPNS0_11InteractionE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z28RenderSceneShaderReplacementRK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEER17ShaderPassContext: __Z28RenderSceneShaderReplacementRK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEER17ShaderPassContext, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalRotationv: __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalRotationv, __ZN5physx25PxRigidActorGeneratedInfoC2Ev: __ZN5physx25PxRigidActorGeneratedInfoC2Ev, __ZNK14TerrainManager27CreateSharedMeshDataPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB: __ZNK14TerrainManager27CreateSharedMeshDataPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP14SharedMeshDataLj4EERK4AABB, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumTrianglesEv, __ZN16UnityAdsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16UnityAdsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx7profile15ZoneManagerImplC2EPNS_12PxFoundationE: __ZN5physx7profile15ZoneManagerImplC2EPNS_12PxFoundationE, __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_: __ZNSt3__26__sortIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_, __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationYTilev: __Z58Register_UnityEngine_ParticleRenderer_set_uvAnimationYTilev, __ZN16ParticleRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16ParticleRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z20FromToQuaternionSafeRK8Vector3fS1_: __Z20FromToQuaternionSafeRK8Vector3fS1_, __ZN13SpeedTreeWind10SWindGroup8TransferI14SafeBinaryReadEEvRT_: __ZN13SpeedTreeWind10SWindGroup8TransferI14SafeBinaryReadEEvRT_, __ZNK4Mesh26GetSubMeshDrawBuffersRangeEib: __ZNK4Mesh26GetSubMeshDrawBuffersRangeEib, __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN13BuildSettings8TransferI14SafeBinaryReadEEvRT_: __ZN13BuildSettings8TransferI14SafeBinaryReadEEvRT_, __ZN13RenderManager18AddCameraProjectorEP9Projectori: __ZN13RenderManager18AddCameraProjectorEP9Projectori, __ZN11UnityEngine15CloudWebService17SessionEventQueue16ExtractEventDataEPKcyR8UnityStr: __ZN11UnityEngine15CloudWebService17SessionEventQueue16ExtractEventDataEPKcyR8UnityStr, __Z48ParticleAnimator_Get_Custom_PropDoesAnimateColorP12Il2CppObject: __Z48ParticleAnimator_Get_Custom_PropDoesAnimateColorP12Il2CppObject, __Z27getPxRigidActor_ConstraintsPKN5physx12PxRigidActorEPPNS_12PxConstraintEj: __Z27getPxRigidActor_ConstraintsPKN5physx12PxRigidActorEPPNS_12PxConstraintEj, __ZN5physx20BigConvexDataBuilder10PrecomputeEj: __ZN5physx20BigConvexDataBuilder10PrecomputeEj, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z53Register_UnityEngine_Light_set_shadowCustomResolutionv: __Z53Register_UnityEngine_Light_set_shadowCustomResolutionv, __ZThn32_N8Renderer21RendererBecameVisibleEv: __ZThn32_N8Renderer21RendererBecameVisibleEv, __Z13RegisterClassI13BuildSettingsEvv: __Z13RegisterClassI13BuildSettingsEvv, __ZNK17AnimationCurveTplI11QuaternionfE14GetPreInfinityEv: __ZNK17AnimationCurveTplI11QuaternionfE14GetPreInfinityEv, __Z38RenderTexture_CUSTOM_Internal_GetWidthP12Il2CppObject: __Z38RenderTexture_CUSTOM_Internal_GetWidthP12Il2CppObject, __ZN4FMOD7SystemI13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i: __ZN4FMOD7SystemI13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i, __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z61Register_UnityEngine_ParticleSystemRenderer_get_velocityScalev: __Z61Register_UnityEngine_ParticleSystemRenderer_get_velocityScalev, __Z51AnimatorOverrideController_CUSTOM_Internal_SetDirtyP12Il2CppObject: __Z51AnimatorOverrideController_CUSTOM_Internal_SetDirtyP12Il2CppObject, __Z15Hash128ToStringRK7Hash128: __Z15Hash128ToStringRK7Hash128, __ZN12MemoryStreamD0Ev: __ZN12MemoryStreamD0Ev, __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13DrawImmediate10InvalidateEv: __ZN13DrawImmediate10InvalidateEv, __ZN14AssetReference24GetAssetReferenceStorageEv: __ZN14AssetReference24GetAssetReferenceStorageEv, __Z39Register_UnityEngine_Font_set_fontNamesv: __Z39Register_UnityEngine_Font_set_fontNamesv, __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMConvexVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj: __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMConvexVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj, __ZN22ProceduralMaterialData20RemoveTextureRawDataEj: __ZN22ProceduralMaterialData20RemoveTextureRawDataEj, __ZN5physx16PxsIslandManager23updateIslandsSecondPassEPNS_10PxBaseTaskEj: __ZN5physx16PxsIslandManager23updateIslandsSecondPassEPNS_10PxBaseTaskEj, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN11UnityEngine15CloudWebService16SessionContainer24GetSessionHeaderJsonDataERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN11UnityEngine15CloudWebService16SessionContainer24GetSessionHeaderJsonDataERK8UnityStrRNSt3__219basic_ostringstreamIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZN12ImageFilters23SetupRenderTargetCommonER9GfxDeviceP7TextureP13RenderTextureNS_9BlitFlagsE11CubemapFace: __ZN12ImageFilters23SetupRenderTargetCommonER9GfxDeviceP7TextureP13RenderTextureNS_9BlitFlagsE11CubemapFace, __Z12stbAllocImpljPv: __Z12stbAllocImpljPv, __ZN15DirectorManager25RemoveControllerFromArrayERNSt3__26vectorI20ProcessFrameJobGroupNS0_9allocatorIS2_EEEEP18PlayableController: __ZN15DirectorManager25RemoveControllerFromArrayERNSt3__26vectorI20ProcessFrameJobGroupNS0_9allocatorIS2_EEEEP18PlayableController, __ZN11LightProbes14LightProbeData5ClearEv: __ZN11LightProbes14LightProbeData5ClearEv, __ZN5Unity10HingeJoint12SetUseSpringEb: __ZN5Unity10HingeJoint12SetUseSpringEb, __ZNK8VRDevice27GetOverrideApplicationPauseEv: __ZNK8VRDevice27GetOverrideApplicationPauseEv, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_10MemLabelId17TransferMetaFlags, __Z31Animator_CUSTOM_IsBoneTransformP12Il2CppObjectS0_: __Z31Animator_CUSTOM_IsBoneTransformP12Il2CppObjectS0_, __ZN14SplatMaterials16LoadSplatShadersEv: __ZN14SplatMaterials16LoadSplatShadersEv, __ZN13MemoryManager31ThreadTempAllocFrameMaintenanceEv: __ZN13MemoryManager31ThreadTempAllocFrameMaintenanceEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE, __Z29Material_CUSTOM_SetBufferImplP12Il2CppObjectiS0_: __Z29Material_CUSTOM_SetBufferImplP12Il2CppObjectiS0_, __ZN17PersistentManagerD2Ev: __ZN17PersistentManagerD2Ev, __ZN5physx23PxsBroadPhaseContextSap11freeBuffersEv: __ZN5physx23PxsBroadPhaseContextSap11freeBuffersEv, __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21ComputeShaderResource8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cimagl: _cimagl, __ZN8JSONRead14GetDataVersionEv: __ZN8JSONRead14GetDataVersionEv, __ZNK15CollisionEvents9GetEventsEiP26MonoParticleCollisionEventi: __ZNK15CollisionEvents9GetEventsEiP26MonoParticleCollisionEventi, __ZN9Rigidbody23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Rigidbody23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z46Collider_CUSTOM_INTERNAL_CALL_Internal_RaycastP12Il2CppObjectRK3RayP10RaycastHitf: __Z46Collider_CUSTOM_INTERNAL_CALL_Internal_RaycastP12Il2CppObjectRK3RayP10RaycastHitf, __Z19GetScriptingManagerv: __Z19GetScriptingManagerv, __Z36RenderSettings_Get_Custom_PropSkyboxv: __Z36RenderSettings_Get_Custom_PropSkyboxv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN10Matrix4x4f9TranslateERK8Vector3f: __ZN10Matrix4x4f9TranslateERK8Vector3f, __ZN15DirectorManager14OnExitPlayModeEv: __ZN15DirectorManager14OnExitPlayModeEv, __Z39WheelCollider_Get_Custom_PropSteerAngleP12Il2CppObject: __Z39WheelCollider_Get_Custom_PropSteerAngleP12Il2CppObject, __ZNK5physx2Sn18RepXCollectionImpl18getTolerancesScaleEv: __ZNK5physx2Sn18RepXCollectionImpl18getTolerancesScaleEv, __ZN15AudioReverbZone4InitEv: __ZN15AudioReverbZone4InitEv, __ZN5Umbra5QueryC2Ev: __ZN5Umbra5QueryC2Ev, __Z42PointEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D: __Z42PointEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZMultiplierv, __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z45Register_UnityEngine_Cloth_get_sleepThresholdv: __Z45Register_UnityEngine_Cloth_get_sleepThresholdv, __ZN4Mesh17MainThreadCleanupEv: __ZN4Mesh17MainThreadCleanupEv, __ZN5physx6shdfnd5ArrayIPKNS_24PxsIndexedContactManagerENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPKNS_24PxsIndexedContactManagerENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNK12InputManager26GetTypeInfoVirtualInternalEv: __ZNK12InputManager26GetTypeInfoVirtualInternalEv, __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo: __Z22AnimatorClipInfoToMonoRK16AnimatorClipInfoR20MonoAnimatorClipInfo, __Z5storePfRK8Scalar4f: __Z5storePfRK8Scalar4f, __Z26GUI_Get_Custom_PropChangedv: __Z26GUI_Get_Custom_PropChangedv, __ZNSt3__218__insertion_sort_3IRNS_6__lessIyyEEPyEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIyyEEPyEEvT0_S5_T_, __Z47SliderJoint2D_Get_Custom_PropAutoConfigureAngleP12Il2CppObject: __Z47SliderJoint2D_Get_Custom_PropAutoConfigureAngleP12Il2CppObject, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE, __ZN20SoundChannelInstance14SetPositionPCMEj: __ZN20SoundChannelInstance14SetPositionPCMEj, __ZN4math4Axes8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4math4Axes8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK20LocalFileSystemPosix19GetUserConfigFolderEv: __ZNK20LocalFileSystemPosix19GetUserConfigFolderEv, __ZN14dtNavMeshQuery7getPathEPyPii: __ZN14dtNavMeshQuery7getPathEPyPii, __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED2Ev, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE18__construct_at_endEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE18__construct_at_endEj, __ZN24dtObstacleAvoidanceQuery6addBoxEPKfS1_S1_S1_S1_S1_: __ZN24dtObstacleAvoidanceQuery6addBoxEPKfS1_S1_S1_S1_S1_, _UNITY_FT_Init_Class_sfnt_interface: _UNITY_FT_Init_Class_sfnt_interface, __ZNSt3__26locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_9money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8capacityEv, __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z28SetVectorArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __ZN5physx2Sq12BucketPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj: __ZN5physx2Sq12BucketPruner10addObjectsEPjPKNS_9PxBounds3EPKNS0_13PrunerPayloadEj, __Z42Register_UnityEngine_Compass_get_timestampv: __Z42Register_UnityEngine_Compass_get_timestampv, __Z40Register_UnityEngine_TerrainData_AddTreev: __Z40Register_UnityEngine_TerrainData_AddTreev, __ZN16SubstanceArchiveD0Ev: __ZN16SubstanceArchiveD0Ev, __ZNK19RenderEventsContext25PostExecuteCommandBuffersEiR17ShaderPassContextP13RenderTextureP19ProfilerInformationi: __ZNK19RenderEventsContext25PostExecuteCommandBuffersEiR17ShaderPassContextP13RenderTextureP19ProfilerInformationi, __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_: __ZN5physx11PxMeshQuery11getTriangleERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_, __ZN5physx21MBPPostUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE: __ZN5physx21MBPPostUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx10PxsContext19resetThreadContextsEv: __ZN5physx10PxsContext19resetThreadContextsEv, __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E: __Z14TransformPoint23TransformAccessReadOnlyRKN4math7_float3E, __ZN5physx33postProcessConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj: __ZN5physx33postProcessConstraintPartitioningEPNS_13PxcSolverBodyEjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPNS_24PxcFsSelfConstraintBlockEj, __ZN5physx2Sc5Scene21getOutOfBoundsObjectsEv: __ZN5physx2Sc5Scene21getOutOfBoundsObjectsEv, __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EEPKN5Unity4TypeEz: __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EEPKN5Unity4TypeEz, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE8pushNameEPKc, __Z42Animator_CUSTOM_GetCurrentAnimatorClipInfoP12Il2CppObjecti: __Z42Animator_CUSTOM_GetCurrentAnimatorClipInfoP12Il2CppObjecti, _cabsl: _cabsl, __ZNK9Texture3D20GetTextureLayerCountEv: __ZNK9Texture3D20GetTextureLayerCountEv, __Z57Register_UnityEngine_UnityLogWriter_WriteStringToUnityLogv: __Z57Register_UnityEngine_UnityLogWriter_WriteStringToUnityLogv, __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr: __ZN19AssetBundleManifest19GetAssetBundleIndexERK8UnityStr, __Z49Register_UnityEngine_AndroidJNI_ExceptionDescribev: __Z49Register_UnityEngine_AndroidJNI_ExceptionDescribev, __Z25SetPolynomialCurveToValueR17AnimationCurveTplIfER24OptimizedPolynomialCurvef: __Z25SetPolynomialCurveToValueR17AnimationCurveTplIfER24OptimizedPolynomialCurvef, _cabsf: _cabsf, __Z49Register_UnityEngine_Light_get_shadowSoftnessFadev: __Z49Register_UnityEngine_Light_get_shadowSoftnessFadev, __ZN16SpriteRenderDataC2ERKS_: __ZN16SpriteRenderDataC2ERKS_, __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN13MemoryManager13GetAllocCountERK10MemLabelId: __ZN13MemoryManager13GetAllocCountERK10MemLabelId, __ZN39AssetBundleLoadFromStreamAsyncOperation22TryInitializeDiskCacheEv: __ZN39AssetBundleLoadFromStreamAsyncOperation22TryInitializeDiskCacheEv, _mbrtowc: _mbrtowc, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4swapERS3_: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4swapERS3_, __Z51AudioSettings_CUSTOM_INTERNAL_CALL_GetConfigurationR27AudioConfigurationScripting: __Z51AudioSettings_CUSTOM_INTERNAL_CALL_GetConfigurationR27AudioConfigurationScripting, __Z31Mathf_CUSTOM_LinearToGammaSpacef: __Z31Mathf_CUSTOM_LinearToGammaSpacef, __ZN19SpriteMeshGenerator4path3optEf: __ZN19SpriteMeshGenerator4path3optEf, _y1f: _y1f, __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib: __ZN17PersistentManager32CreateThreadActivationQueueEntryER14SerializedFile26SerializedObjectIdentifierib, __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD2Ev: __ZZN5physx15PxSerialization18dumpBinaryMetaDataERNS_14PxOutputStreamERNS_23PxSerializationRegistryEEN14MetaDataStreamD2Ev, __ZN5physx2Cm17FreeListAllocator10allocChunkEj: __ZN5physx2Cm17FreeListAllocator10allocChunkEj, __Z18UpdateProximityJobP9CrowdInfoj: __Z18UpdateProximityJobP9CrowdInfoj, __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb: __ZN5physx3Ext5joint17projectTransformsERNS_11PxTransformES3_RKS2_S5_S5_RKNS0_9JointDataEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj165ENS_22PxRepXPropertyAccessorILj165ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj165ENS_22PxRepXPropertyAccessorILj165ES4_ffEEEEvRKT0_, _psh_blues_set_zones: _psh_blues_set_zones, __ZThn8_N5physx2Sc24ElementInteractionMarker10initializeEv: __ZThn8_N5physx2Sc24ElementInteractionMarker10initializeEv, __ZNK14Texture2DArray12GetDataWidthEv: __ZNK14Texture2DArray12GetDataWidthEv, __ZN14NavMeshManager15LoadNavMeshDataEiPK11NavMeshData: __ZN14NavMeshManager15LoadNavMeshDataEiPK11NavMeshData, __ZN13GfxDeviceNull16CreateTimerQueryEv: __ZN13GfxDeviceNull16CreateTimerQueryEv, __ZN12LightManager8AddLightEP5Light: __ZN12LightManager8AddLightEP5Light, __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f: __ZN13SpeedTreeWind23SetDirectionAndStrengthERK8Vector4f, __Z46Register_UnityEngine_EdgeCollider2D_set_pointsv: __Z46Register_UnityEngine_EdgeCollider2D_set_pointsv, __Z36Joint_Get_Custom_PropEnableCollisionP12Il2CppObject: __Z36Joint_Get_Custom_PropEnableCollisionP12Il2CppObject, __Z53Register_UnityEngine_Cloth_set_worldAccelerationScalev: __Z53Register_UnityEngine_Cloth_set_worldAccelerationScalev, __Z56Register_UnityEngine_ParticleSystem_TrailModule_SetRatiov: __Z56Register_UnityEngine_ParticleSystem_TrailModule_SetRatiov, _UNITY_png_set_expand: _UNITY_png_set_expand, __Z23GetInternetReachabilityv: __Z23GetInternetReachabilityv, __ZN12AudioManager15InitializeClassEv: __ZN12AudioManager15InitializeClassEv, __ZNK14Texture2DArray26GetTypeInfoVirtualInternalEv: __ZNK14Texture2DArray26GetTypeInfoVirtualInternalEv, __ZNSt3__27collateIwEC2Ej: __ZNSt3__27collateIwEC2Ej, __Z44Register_UnityEngine_PlayerPrefs_TrySetFloatv: __Z44Register_UnityEngine_PlayerPrefs_TrySetFloatv, __ZN5Unity14CharacterJoint20ApplySetupAxesToDescEi: __ZN5Unity14CharacterJoint20ApplySetupAxesToDescEi, __ZN17Physics2DSettings23SetShowColliderContactsEb: __ZN17Physics2DSettings23SetShowColliderContactsEb, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15CacheReaderBaseD2Ev: __ZN15CacheReaderBaseD2Ev, __ZN5physx7NpShapeD0Ev: __ZN5physx7NpShapeD0Ev, __Z51Register_UnityEngine_QualitySettings_get_vSyncCountv: __Z51Register_UnityEngine_QualitySettings_get_vSyncCountv, __ZN6Camera16CheckConsistencyEv: __ZN6Camera16CheckConsistencyEv, __ZN13AnimationClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13AnimationClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE: __ZNK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE, __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx6shdfnd5ArrayINS_3Ext5Local18OverflowRecordPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Ext5Local18OverflowRecordPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN5physx2Sc7BodySim19postSwitchToDynamicEv: __ZN5physx2Sc7BodySim19postSwitchToDynamicEv, _iconv_close: _iconv_close, __Z61AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoInternal9HPlayableRS_ihP12Il2CppObject: __Z61AnimatorControllerPlayable_CUSTOM_GetAnimatorClipInfoInternal9HPlayableRS_ihP12Il2CppObject, __ZNK15LightProbeGroup26GetTypeInfoVirtualInternalEv: __ZNK15LightProbeGroup26GetTypeInfoVirtualInternalEv, __ZN5Umbra11PatchWriter4initERNS_12OutputStreamEPKh: __ZN5Umbra11PatchWriter4initERNS_12OutputStreamEPKh, __ZNSt3__26vectorI15CarveDataArraysNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI15CarveDataArraysNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN13MonoBehaviour20StopCoroutineManagedEP9Coroutine: __ZN13MonoBehaviour20StopCoroutineManagedEP9Coroutine, __ZN5physx2Sc9ClothCore15getParticleDataERNS_19PxClothParticleDataE: __ZN5physx2Sc9ClothCore15getParticleDataERNS_19PxClothParticleDataE, __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE19resizeUninitializedEj, __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZL17EscapeFieldStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14SpriteRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj: __ZN14SpriteRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj, __ZN8VRDevice37SetCustomSplashScreenCreationCallbackEPFP14VRSplashScreenvE: __ZN8VRDevice37SetCustomSplashScreenCreationCallbackEPFP14VRSplashScreenvE, __ZN12LightsModule8TransferI17RemapPPtrTransferEEvRT_: __ZN12LightsModule8TransferI17RemapPPtrTransferEEvRT_, __Z39Register_UnityEngine_GL_LoadPixelMatrixv: __Z39Register_UnityEngine_GL_LoadPixelMatrixv, __Z44Register_UnityEngine_Rigidbody2D_get_inertiav: __Z44Register_UnityEngine_Rigidbody2D_get_inertiav, __ZN24CompressedAnimationCurve8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN24CompressedAnimationCurve8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sc8ShapeSim18onFilterDataChangeEv: __ZN5physx2Sc8ShapeSim18onFilterDataChangeEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31ParticleSystemVertexStreamFlagsEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31ParticleSystemVertexStreamFlagsEvRT_RT0_PKc17TransferMetaFlags, _cff_cmap_encoding_done: _cff_cmap_encoding_done, __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesYv: __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetNumTilesYv, __ZN11b2WeldJointC2EPK14b2WeldJointDef: __ZN11b2WeldJointC2EPK14b2WeldJointDef, __ZN11LightProbes28GetPendingCoefficientsOffsetERK10vector_mapI7Hash12813ProbeSetIndexNSt3__24lessIS1_EENS3_9allocatorINS3_4pairIS1_S2_EEEEERKS1_: __ZN11LightProbes28GetPendingCoefficientsOffsetERK10vector_mapI7Hash12813ProbeSetIndexNSt3__24lessIS1_EENS3_9allocatorINS3_4pairIS1_S2_EEEEERKS1_, __ZN4gles19ActivateTextureUnitER15DeviceStateGLESj: __ZN4gles19ActivateTextureUnitER15DeviceStateGLESj, __ZN8Animator12GetBehaviourEP11Il2CppClass: __ZN8Animator12GetBehaviourEP11Il2CppClass, _tt_cmap14_char_index: _tt_cmap14_char_index, __ZN5physx37PxTriangleMeshGeometryGeneratedValuesC2EPKNS_22PxTriangleMeshGeometryE: __ZN5physx37PxTriangleMeshGeometryGeneratedValuesC2EPKNS_22PxTriangleMeshGeometryE, __ZL19SweepCapsuleCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL19SweepCapsuleCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetAnimationTypev: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetAnimationTypev, __ZNK5physx7NpScene15getNbAggregatesEv: __ZNK5physx7NpScene15getNbAggregatesEv, __ZN5physxL23PxcSweepConvexTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf: __ZN5physxL23PxcSweepConvexTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf, __ZN10MonoScript8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10MonoScript8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNKSt3__220__codecvt_utf8_utf16IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx8debugger15ForwardingArrayIN12_GLOBAL__N_124PropertyMessageEntryImplEED0Ev: __ZN5physx8debugger15ForwardingArrayIN12_GLOBAL__N_124PropertyMessageEntryImplEED0Ev, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7ReleaseEPS2_: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7ReleaseEPS2_, __ZN13ScreenManagerD2Ev: __ZN13ScreenManagerD2Ev, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EEPKS7_RKSA_, _UNITY_png_get_oFFs: _UNITY_png_get_oFFs, __ZN4FMOD4DSPI8addInputEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD4DSPI8addInputEPNS_3DSPEPPNS_13DSPConnectionE, __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE: __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE, __Z49Register_UnityEngine_RelativeJoint2D_get_maxForcev: __Z49Register_UnityEngine_RelativeJoint2D_get_maxForcev, __Z43Input_Get_Custom_PropTouchPressureSupportedv: __Z43Input_Get_Custom_PropTouchPressureSupportedv, __Z18Transfer_BlittableI14SafeBinaryReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN26ProbeSetTetrahedralization8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN26ProbeSetTetrahedralization8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx19computeSprungMassesEjPKNS_6PxVec3ERS1_fjPf: __ZN5physx19computeSprungMassesEjPKNS_6PxVec3ERS1_fjPf, __Z54Register_UnityEngine_Transform_INTERNAL_set_localScalev: __Z54Register_UnityEngine_Transform_INTERNAL_set_localScalev, __Z37Shader_CUSTOM_GetGlobalFloatArrayImpli: __Z37Shader_CUSTOM_GetGlobalFloatArrayImpli, __ZN11AudioSource4StopEb: __ZN11AudioSource4StopEb, __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE: __ZN5physx20resolveConstraintPtrERNS_24PxDeserializationContextEPNS_12PxConstraintEPNS_21PxConstraintConnectorERNS_23PxConstraintShaderTableE, __ZN5physx3Cct10Controller17findTouchedObjectERKNS_19PxControllerFiltersEPKNS_17PxObstacleContextERKNS_6PxVec3E: __ZN5physx3Cct10Controller17findTouchedObjectERKNS_19PxControllerFiltersEPKNS_17PxObstacleContextERKNS_6PxVec3E, __ZN12AudioManager16UpdatePauseStateEv: __ZN12AudioManager16UpdatePauseStateEv, __ZN11Rigidbody2D16SetDragBehaviourEb: __ZN11Rigidbody2D16SetDragBehaviourEb, __ZN8LODGroupD0Ev: __ZN8LODGroupD0Ev, __ZN22LocalFileSystemHandler4NameEv: __ZN22LocalFileSystemHandler4NameEv, __ZN9Texture2D11EncodeToJPGER13dynamic_arrayIhLj1EEi: __ZN9Texture2D11EncodeToJPGER13dynamic_arrayIhLj1EEi, __Z38WheelJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D: __Z38WheelJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D, __ZNK5Umbra10PortalInfo12getGateIndexEi: __ZNK5Umbra10PortalInfo12getGateIndexEi, __Z34Register_UnityEngine_Mesh_Optimizev: __Z34Register_UnityEngine_Mesh_Optimizev, __Z29Transfer_Blittable_ArrayFieldI8JSONRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, ___strcoll_l: ___strcoll_l, __ZN5physx2Sc13ConstraintSim18createLLConstraintEv: __ZN5physx2Sc13ConstraintSim18createLLConstraintEv, __ZN15CacheWriterBaseD0Ev: __ZN15CacheWriterBaseD0Ev, __ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE: __ZN5physx15PxVehicleUpdate16isOnDynamicActorERKNS_22PxVehicleWheelsSimDataERKNS_22PxVehicleWheelsDynDataE, __ZN6Object13StaticDestroyEv: __ZN6Object13StaticDestroyEv, __ZN15SkyboxGenerator28GetSixFaceSkyboxVertexFormatEv: __ZN15SkyboxGenerator28GetSixFaceSkyboxVertexFormatEv, __ZN5physx22PxVehicleWheelsSimData8allocateEj: __ZN5physx22PxVehicleWheelsSimData8allocateEj, __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb: __ZN5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb, __ZN17ProceduralTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17ProceduralTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13RendererScene15NotifyInvisibleEv: __ZN13RendererScene15NotifyInvisibleEv, __ZN11UnityEngine15PlatformWrapper14GetDeviceModelEv: __ZN11UnityEngine15PlatformWrapper14GetDeviceModelEv, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZN5physx22PxDefaultErrorCallbackD2Ev: __ZN5physx22PxDefaultErrorCallbackD2Ev, __Z38AndroidJNI_CUSTOM_SetStaticObjectField13Il2Cpp_IntPtrS_S_: __Z38AndroidJNI_CUSTOM_SetStaticObjectField13Il2Cpp_IntPtrS_S_, __ZN5physx33PxJointLinearLimitGeneratedValuesC2EPKNS_18PxJointLinearLimitE: __ZN5physx33PxJointLinearLimitGeneratedValuesC2EPKNS_18PxJointLinearLimitE, __ZN5physx6shdfnd8internal9partitionINS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEiPT_iiRT0_: __ZN5physx6shdfnd8internal9partitionINS_5cloth8SwSolver22CpuClothSimulationTaskEKPFbRKS5_S7_EEEiPT_iiRT0_, __Z27Input_CUSTOM_ResetInputAxesv: __Z27Input_CUSTOM_ResetInputAxesv, _a64l: _a64l, __Z25CreateUniqueTempDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __Z25CreateUniqueTempDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx2Sc5Scene26getSimulationEventCallbackEh: __ZNK5physx2Sc5Scene26getSimulationEventCallbackEh, __Z46Object_CUSTOM_FindObjectsOfTypeIncludingAssetsP12Il2CppObject: __Z46Object_CUSTOM_FindObjectsOfTypeIncludingAssetsP12Il2CppObject, __Z46ParticleEmitter_Get_Custom_PropAngularVelocityP12Il2CppObject: __Z46ParticleEmitter_Get_Custom_PropAngularVelocityP12Il2CppObject, __ZN21AudioDistortionFilterC2E10MemLabelId18ObjectCreationMode: __ZN21AudioDistortionFilterC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE: __ZN5physx2Gu16getPCMConvexDataERKNS0_11ConvexHullVEbRNS0_13PolygonalDataE, __Z24RegisterStrippedTypeInfoI22ParticleSystemRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI22ParticleSystemRendererEviPKcS2_, __Z17dynamic_pptr_castIP16LevelGameManager6ObjectET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP16LevelGameManager6ObjectET_RK4PPtrIT0_E, _UNITY_TT_RunIns: _UNITY_TT_RunIns, __ZN17PolygonCollider2D15ThreadedCleanupEv: __ZN17PolygonCollider2D15ThreadedCleanupEv, __ZN5Umbra9Matrix2x2mLERKS0_: __ZN5Umbra9Matrix2x2mLERKS0_, __Z49Register_UnityEngine_PolygonCollider2D_set_pointsv: __Z49Register_UnityEngine_PolygonCollider2D_set_pointsv, _UNITY_FT_Stream_Skip: _UNITY_FT_Stream_Skip, __Z41Register_UnityEngine_Mesh_set_boneWeightsv: __Z41Register_UnityEngine_Mesh_set_boneWeightsv, __ZTv0_n12_NSt3__210ostrstreamD0Ev: __ZTv0_n12_NSt3__210ostrstreamD0Ev, __ZN8Playable6HandleEv: __ZN8Playable6HandleEv, __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z27getPxSceneLimitsMaxNbActorsPKN5physx13PxSceneLimitsE: __Z27getPxSceneLimitsMaxNbActorsPKN5physx13PxSceneLimitsE, __ZN14ParticleSystem25AddParticleSystemRendererEv: __ZN14ParticleSystem25AddParticleSystemRendererEv, __ZN8Animator16CheckConsistencyEv: __ZN8Animator16CheckConsistencyEv, __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet: __ZN20IntermediateRenderer30AssignExternalCustomPropertiesEP19ShaderPropertySheet, __ZN9Projector17PrepareRenderNodeEjjPS_R15RenderNodeQueueR22PerThreadPageAllocator: __ZN9Projector17PrepareRenderNodeEjjPS_R15RenderNodeQueueR22PerThreadPageAllocator, __ZN5physx3Scb11RigidObject13onShapeDetachERNS0_5ShapeEbb: __ZN5physx3Scb11RigidObject13onShapeDetachERNS0_5ShapeEbb, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE7reserveEj, __ZN21ImposterRenderTexture15UpdateImpostersERK6Camera: __ZN21ImposterRenderTexture15UpdateImpostersERK6Camera, __ZNK5Umbra4Tome13findGateIndexEj: __ZNK5Umbra4Tome13findGateIndexEj, __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE: __ZNK7ApiGLES21GetFramebufferBindingEN2gl17FramebufferTargetE, __ZN5physx29EntityReportContainerCallbackD0Ev: __ZN5physx29EntityReportContainerCallbackD0Ev, __Z44QualitySettings_Get_Custom_PropSoftParticlesv: __Z44QualitySettings_Get_Custom_PropSoftParticlesv, __Z45PhysicMaterial_Get_Custom_PropStaticFriction2P12Il2CppObject: __Z45PhysicMaterial_Get_Custom_PropStaticFriction2P12Il2CppObject, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNK5physx19NpArticulationJoint20getTwistLimitEnabledEv: __ZNK5physx19NpArticulationJoint20getTwistLimitEnabledEv, __ZN5physx35solveFriction_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx35solveFriction_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN9GfxDevice16DynamicBatchMeshERK10Matrix4x4fRK16VertexBufferDatajjPKtj25GfxTransformVerticesFlags: __ZN9GfxDevice16DynamicBatchMeshERK10Matrix4x4fRK16VertexBufferDatajjPKtj25GfxTransformVerticesFlags, __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK26AnimatorControllerPlayable13IsInitializedEv: __ZNK26AnimatorControllerPlayable13IsInitializedEv, __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI18StreamedBinaryReadILb1EEEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __Z48Register_UnityEngine_SliderJoint2D_set_useLimitsv: __Z48Register_UnityEngine_SliderJoint2D_set_useLimitsv, __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE: __ZN17GeneralConnection24UnregisterMessageHandlerENS_9MessageIDEPFvPKvjjE, __Z47Screen_Set_Custom_PropAutorotateToLandscapeLefth: __Z47Screen_Set_Custom_PropAutorotateToLandscapeLefth, __ZN5Unity5Cloth18ApplyConfigurationEv: __ZN5Unity5Cloth18ApplyConfigurationEv, __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __ZN13GfxDeviceGLES20GetVertexDeclarationERK18VertexChannelsInfo: __ZN13GfxDeviceGLES20GetVertexDeclarationERK18VertexChannelsInfo, __ZNSt3__212system_errorD0Ev: __ZNSt3__212system_errorD0Ev, __Z51Register_UnityEngine_Transform_INTERNAL_CALL_LookAtv: __Z51Register_UnityEngine_Transform_INTERNAL_CALL_LookAtv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEE15growAndPushBackERKS2_, __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev: __ZN5physx35PxVehicleWheelsSimDataGeneratedInfoC2Ev, __ZN5physx2Sn9XmlParser8allocateEj: __ZN5physx2Sn9XmlParser8allocateEj, __ZN5Unity9Component13AwakeFromLoadE17AwakeFromLoadMode: __ZN5Unity9Component13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESK_RKT_, __ZN5physx20updateLowSpeedTimersEPKfPf: __ZN5physx20updateLowSpeedTimersEPKfPf, __Z43RectTransform_CUSTOM_INTERNAL_get_sizeDeltaP12Il2CppObjectP13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_get_sizeDeltaP12Il2CppObjectP13Vector2fIcall, __ZN12_GLOBAL__N_16ParserILb0EE7releaseEv: __ZN12_GLOBAL__N_16ParserILb0EE7releaseEv, __ZN12TreeDatabase11RemoveTreesERK8Vector2ffi: __ZN12TreeDatabase11RemoveTreesERK8Vector2ffi, __ZNK5physx2Gu13MeshInterface13CheckTopologyEv: __ZNK5physx2Gu13MeshInterface13CheckTopologyEv, __ZNK8Animator25GetLayersAffectMassCenterEv: __ZNK8Animator25GetLayersAffectMassCenterEv, __ZN13SliderJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13SliderJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNSt3__212future_errorD0Ev: __ZNSt3__212future_errorD0Ev, __ZN12HeaderHelper21ParseAndSetAllHeadersEPKcj: __ZN12HeaderHelper21ParseAndSetAllHeadersEPKcj, __ZN5physx2Sn5ConvX22convertExtraData_ArrayEPKcS3_S3_RKNS0_14ExtraDataEntryE: __ZN5physx2Sn5ConvX22convertExtraData_ArrayEPKcS3_S3_RKNS0_14ExtraDataEntryE, _unztell: _unztell, __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc: __ZNK7ApiGLES13GetDebugLabelEN2gl10ObjectTypeEjiPiPc, __ZN16GraphicsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16GraphicsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z17RuntimeInitializev: __Z17RuntimeInitializev, __Z45CharacterController_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f: __Z45CharacterController_CUSTOM_INTERNAL_CALL_MoveP12Il2CppObjectRK8Vector3f, __Z38Collider_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_: __Z38Collider_Set_Custom_PropSharedMaterialP12Il2CppObjectS0_, __ZN14dtNavMeshQuery19updateNeighbourLinkEPK6dtLinkyyPK6dtNode: __ZN14dtNavMeshQuery19updateNeighbourLinkEPK6dtLinkyyPK6dtNode, __ZN11ErrorStreamD0Ev: __ZN11ErrorStreamD0Ev, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE6getDirEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE15growAndPushBackERKS2_, __Z87Register_UnityEngine_Networking_DownloadHandler_INTERNAL_CALL_InternalCreateAssetBundlev: __Z87Register_UnityEngine_Networking_DownloadHandler_INTERNAL_CALL_InternalCreateAssetBundlev, __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj: __ZN17GeneralConnection11SendMessageEjNS_9MessageIDEPKvj, __ZN5physx17PxcNpMemBlockPool4initEjj: __ZN5physx17PxcNpMemBlockPool4initEjj, __Z52Register_UnityEngine_Camera_get_transparencySortModev: __Z52Register_UnityEngine_Camera_get_transparencySortModev, __Z28Font_CUSTOM_GetCharacterInfoP12Il2CppObjecttPN20TextRenderingPrivate22ScriptingCharacterInfoEii: __Z28Font_CUSTOM_GetCharacterInfoP12Il2CppObjecttPN20TextRenderingPrivate22ScriptingCharacterInfoEii, __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags, __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EE6extendEv: __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EE6extendEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcj, __ZNK12ScriptMapper26GetTypeInfoVirtualInternalEv: __ZNK12ScriptMapper26GetTypeInfoVirtualInternalEv, __ZN7mecanim12AndValueMaskEPNS_14ValueArrayMaskEPKS0_: __ZN7mecanim12AndValueMaskEPNS_14ValueArrayMaskEPKS0_, __ZN5physx2Cm12RenderBuffer6appendINS_11PxDebugLineEEEvRNS_6shdfnd5ArrayIT_NS4_15AllocatorTraitsIS6_E4TypeEEEPKS6_j: __ZN5physx2Cm12RenderBuffer6appendINS_11PxDebugLineEEEvRNS_6shdfnd5ArrayIT_NS4_15AllocatorTraitsIS6_E4TypeEEEPKS6_j, __ZN8JobQueue13ScheduleGroupEP8JobGroupNS_16JobQueuePriorityE: __ZN8JobQueue13ScheduleGroupEP8JobGroupNS_16JobQueuePriorityE, __ZN10GUIManager16GUIObjectWrapperC2EP16DeveloperConsole: __ZN10GUIManager16GUIObjectWrapperC2EP16DeveloperConsole, __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPKv: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPKv, __Z55Register_UnityEngine_ParticleSystem_get_gravityModifierv: __Z55Register_UnityEngine_ParticleSystem_get_gravityModifierv, __Z33Animation_Get_Custom_PropWrapModeP12Il2CppObject: __Z33Animation_Get_Custom_PropWrapModeP12Il2CppObject, __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb, __ZN12NavMeshAgent14GetCrowdSystemEv: __ZN12NavMeshAgent14GetCrowdSystemEv, __ZN5physx15PxVehicleWheelsD2Ev: __ZN5physx15PxVehicleWheelsD2Ev, _UNITY_FT_Outline_Copy: _UNITY_FT_Outline_Copy, _malloc: _malloc, __ZN4crnd10crnd_traceEPKcPi: __ZN4crnd10crnd_traceEPKcPi, __Z49ParticleSystemRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf: __Z49ParticleSystemRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf, __ZNK26LegacyTreeInstanceRenderer16GetMaterialCountEv: __ZNK26LegacyTreeInstanceRenderer16GetMaterialCountEv, __ZNK5physx2Sc8BodyCore10isSleepingEv: __ZNK5physx2Sc8BodyCore10isSleepingEv, __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE14doSupportSweepERKNS_6shdfnd3aos5Vec3VE, __ZN5Cache18WriteCacheInfoFileEb: __ZN5Cache18WriteCacheInfoFileEb, _UNITY_FT_Face_GetCharVariantIndex: _UNITY_FT_Face_GetCharVariantIndex, __Z13RegisterClassI24OcclusionCullingSettingsEvv: __Z13RegisterClassI24OcclusionCullingSettingsEvv, __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_792kDidModifyMesh4CallEPviR11MessageData: __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_792kDidModifyMesh4CallEPviR11MessageData, __Z41Register_UnityEngine_GameObject_get_layerv: __Z41Register_UnityEngine_GameObject_get_layerv, __Z21CleanupNavMeshManagerv: __Z21CleanupNavMeshManagerv, __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj: __ZN18AwakeFromLoadQueue22InvokeCheckConsistencyEPNS_4ItemEj, __Z13RegisterClassI17AudioReverbFilterEvv: __Z13RegisterClassI17AudioReverbFilterEvv, _jsimd_can_idct_4x4: _jsimd_can_idct_4x4, __Z52Register_UnityEngine_Terrain_set_heightmapPixelErrorv: __Z52Register_UnityEngine_Terrain_set_heightmapPixelErrorv, __ZN5physx2Sc8ClothSim14insertShapeSimEjPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim14insertShapeSimEjPKNS0_8ShapeSimE, __Z29StdTemplateConversionFunctionItaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItaEbPvR14SafeBinaryRead, __ZN6Camera16SetTargetBuffersEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PP13RenderTexture: __ZN6Camera16SetTargetBuffersEiP12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_PP13RenderTexture, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE8getSceneEv, __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb0EEEEvRT_, ___cos: ___cos, __Z38Register_UnityEngine_Light_set_shadowsv: __Z38Register_UnityEngine_Light_set_shadowsv, __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __Z52Register_UnityEngine_Terrain_get_treeCrossFadeLengthv: __Z52Register_UnityEngine_Terrain_get_treeCrossFadeLengthv, __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMSphereVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj: __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_40PCMSphereVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj, __ZN10Collider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN10Collider2D23VirtualRedirectTransferER14SafeBinaryRead, __Z22ReplaceDirectoryInPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_: __Z22ReplaceDirectoryInPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_S7_, __ZL38FrustumAndOcculusionCullLocalLightsJobP21LocalLightCullJobDataj: __ZL38FrustumAndOcculusionCullLocalLightsJobP21LocalLightCullJobDataj, __ZN3WWW12CallWhenDoneEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E: __ZN3WWW12CallWhenDoneEPF15CallObjectStateP6ObjectPvES2_S3_PFS0_S3_E, __ZNK32PlaneColliderCache_dense_hashmap4FindERK8Vector3fS2_RS0_S3_RiS4_f: __ZNK32PlaneColliderCache_dense_hashmap4FindERK8Vector3fS2_RS0_S3_RiS4_f, __ZN7mecanim9animation19Blend2dDataConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation19Blend2dDataConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4FMOD6Reverb11getUserDataEPPv: __ZN4FMOD6Reverb11getUserDataEPPv, __ZN4FMOD7SystemI17getRecordPositionEiPj: __ZN4FMOD7SystemI17getRecordPositionEiPj, __ZN21AssetBundleFileSystem4SeekER13FileEntryDatax10FileOrigin: __ZN21AssetBundleFileSystem4SeekER13FileEntryDatax10FileOrigin, __ZNK14SoundHandleAPI20GetMusicChannelCountEv: __ZNK14SoundHandleAPI20GetMusicChannelCountEv, __ZN12_GLOBAL__N_124PropertyDefinitionHelper14clearNameStackEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper14clearNameStackEv, __ZN17FileSystemHandler11MoveToTrashER13FileEntryData: __ZN17FileSystemHandler11MoveToTrashER13FileEntryData, __ZN13RenderManagerD2Ev: __ZN13RenderManagerD2Ev, __ZN16PlayerConnection15PollConnectModeEv: __ZN16PlayerConnection15PollConnectModeEv, __Z54Register_UnityEngine_Debug_get_developerConsoleVisiblev: __Z54Register_UnityEngine_Debug_get_developerConsoleVisiblev, __ZNK20LightPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK20LightPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj: __ZN12AdsIdHandler23InvokeAdsIdDoneDelegateEj, __ZN23AnimationOffsetPlayable11DerivesFromEP11Il2CppClass: __ZN23AnimationOffsetPlayable11DerivesFromEP11Il2CppClass, __Z25PxLocationHitToRaycastHitRKN5physx13PxLocationHitER10RaycastHit: __Z25PxLocationHitToRaycastHitRKN5physx13PxLocationHitER10RaycastHit, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgramENS0_9allocatorIS3_EEEEEvRT_j, __ZN14PhysicsManager23SetDefaultContactOffsetEf: __ZN14PhysicsManager23SetDefaultContactOffsetEf, __Z46RenderTexture_Set_Custom_PropEnableRandomWriteP12Il2CppObjecth: __Z46RenderTexture_Set_Custom_PropEnableRandomWriteP12Il2CppObjecth, __ZN5physx2Sq17SceneQueryManager12createPrunerENS_18PxPruningStructure4EnumE: __ZN5physx2Sq17SceneQueryManager12createPrunerENS_18PxPruningStructure4EnumE, __ZNK5physx19NpArticulationJoint13getTwistLimitERfS1_: __ZNK5physx19NpArticulationJoint13getTwistLimitERfS1_, __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId: __Z16DecompressCrunchPKhRjR13TextureFormatiiii10MemLabelId, _inet_makeaddr: _inet_makeaddr, __ZN17TransformInternal24CreateTransformHierarchyEj: __ZN17TransformInternal24CreateTransformHierarchyEj, __Z51Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK8Vector3fS1_fP11Il2CppArrayi23QueryTriggerInteraction: __Z51Physics_CUSTOM_INTERNAL_CALL_OverlapCapsuleNonAllocRK8Vector3fS1_fP11Il2CppArrayi23QueryTriggerInteraction, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE13getActorFlagsEv, __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_: __ZN5physx17PxMeshOverlapUtil11findOverlapERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_, __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9Scripting25BroadcastScriptingMessageER10GameObjectPKcP12Il2CppObject: __ZN9Scripting25BroadcastScriptingMessageER10GameObjectPKcP12Il2CppObject, __Z14RectIntToRectfRK5RectTIiE: __Z14RectIntToRectfRK5RectTIiE, __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11MinMaxCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK13TriggerEvents9GetEventsENS_9EventTypeERK23ParticleSystemParticlesP22ParticleSystemParticlei: __ZNK13TriggerEvents9GetEventsENS_9EventTypeERK23ParticleSystemParticlesP22ParticleSystemParticlei, __Z69Register_UnityEngine_TerrainData_Internal_GetMinimumBaseMapResolutionv: __Z69Register_UnityEngine_TerrainData_Internal_GetMinimumBaseMapResolutionv, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler25CUDAProfileEventOccurenceENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __ZN8Animator13AwakeFromLoadE17AwakeFromLoadMode: __ZN8Animator13AwakeFromLoadE17AwakeFromLoadMode, __ZN10AudioMixer13CleanupMemoryEv: __ZN10AudioMixer13CleanupMemoryEv, __ZNSt3__212system_errorC2ENS_10error_codeE: __ZNSt3__212system_errorC2ENS_10error_codeE, __Z20ComputeTransformTypeRK10Matrix4x4ff: __Z20ComputeTransformTypeRK10Matrix4x4ff, __ZN5physx2Sc24ElementInteractionMarker10initializeEv: __ZN5physx2Sc24ElementInteractionMarker10initializeEv, __ZN5physx28PxTriangleMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx28PxTriangleMeshRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __Z28AddGenericCurveToClipBuilderR17AnimationCurveTplIfERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilderb: __Z28AddGenericCurveToClipBuilderR17AnimationCurveTplIfERKN11UnityEngine9Animation14GenericBindingER18MecanimClipBuilderb, __Z40CubemapArray_Get_Custom_PropCubemapCountP12Il2CppObject: __Z40CubemapArray_Get_Custom_PropCubemapCountP12Il2CppObject, __Z51PlatformEffector2D_Set_Custom_PropUseOneWayGroupingP12Il2CppObjecth: __Z51PlatformEffector2D_Set_Custom_PropUseOneWayGroupingP12Il2CppObjecth, __ZN10HttpHelper17IsHeaderNameValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN10HttpHelper17IsHeaderNameValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN23ForwardShaderRenderLoop16PerformRenderingER8JobFencePK11ActiveLightRK13ShadowJobDatabbbN6Camera10RenderFlagE: __ZN23ForwardShaderRenderLoop16PerformRenderingER8JobFencePK11ActiveLightRK13ShadowJobDatabbbN6Camera10RenderFlagE, __ZNK5physx2Gu4BoxV8isInsideERKS1_: __ZNK5physx2Gu4BoxV8isInsideERKS1_, __Z32GUIStyle_CUSTOM_AssignStyleStateP12Il2CppObjecti13Il2Cpp_IntPtr: __Z32GUIStyle_CUSTOM_AssignStyleStateP12Il2CppObjecti13Il2Cpp_IntPtr, __ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_: __ZNK25RenderPrePassObjectSorterclERK16RenderObjectDataS2_, __ZN5physx22PxVehicleWheelsDynData26setTireForceShaderFunctionEPFvPKvffffffffffffRfS3_S3_S3_E: __ZN5physx22PxVehicleWheelsDynData26setTireForceShaderFunctionEPFvPKvffffffffffffRfS3_S3_S3_E, __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf: __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE6resizeEjRKf, __ZN10VertexDataD2Ev: __ZN10VertexDataD2Ev, __Z30GeomOverlapCallback_ConvexMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z30GeomOverlapCallback_ConvexMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN13GfxDeviceGLES19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace: __ZN13GfxDeviceGLES19CreateSparseTextureE9TextureIDii13TextureFormati17TextureColorSpace, __ZN5physx2Sn5ConvX20convertManifestTableEPKvRi: __ZN5physx2Sn5ConvX20convertManifestTableEPKvRi, __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXMultiplierv, __Z41Register_UnityEngine_Material_HasPropertyv: __Z41Register_UnityEngine_Material_HasPropertyv, __ZN5audio5mixer21SetResultingMuteStateERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEib: __ZN5audio5mixer21SetResultingMuteStateERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEib, __ZN9AudioClip7SetDataEPKfjj: __ZN9AudioClip7SetDataEPKfjj, __ZN5physx13PxHitCallbackINS_12PxOverlapHitEE13finalizeQueryEv: __ZN5physx13PxHitCallbackINS_12PxOverlapHitEE13finalizeQueryEv, __ZN2UI11CanvasGroup7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN2UI11CanvasGroup7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN24b2ChainAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN24b2ChainAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZNSt3__25ctypeIcE21__classic_lower_tableEv: __ZNSt3__25ctypeIcE21__classic_lower_tableEv, __ZL43GeomOverlapCallback_HeightfieldUnregisteredRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL43GeomOverlapCallback_HeightfieldUnregisteredRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN19SkinnedMeshRenderer22UpdateAllSkinnedMeshesENS_10UpdateTypeEP13dynamic_arrayIPS_Lj4EE: __ZN19SkinnedMeshRenderer22UpdateAllSkinnedMeshesENS_10UpdateTypeEP13dynamic_arrayIPS_Lj4EE, __Z17MakeFileNameValidRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z17MakeFileNameValidRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z21setPxShape_RestOffsetPN5physx7PxShapeEf: __Z21setPxShape_RestOffsetPN5physx7PxShapeEf, __ZN7Joint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN7Joint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientProbeRK20SphericalHarmonicsL2: __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientProbeRK20SphericalHarmonicsL2, __Z19VehiclesNeedsUpdatev: __Z19VehiclesNeedsUpdatev, __ZN4FMOD7SystemI17createDSPByPluginEjPPNS_3DSPE: __ZN4FMOD7SystemI17createDSPByPluginEjPPNS_3DSPE, __Z10WritePixelPhRK11ColorRGBA3213TextureFormat: __Z10WritePixelPhRK11ColorRGBA3213TextureFormat, __ZN2UI11CanvasGroup8SetAlphaEf: __ZN2UI11CanvasGroup8SetAlphaEf, __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeZMultiplierP12Il2CppObject: __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeZMultiplierP12Il2CppObject, __ZN7b2World22SetDestructionListenerEP21b2DestructionListener: __ZN7b2World22SetDestructionListenerEP21b2DestructionListener, __ZN8Renderer14UpdateLODGroupEv: __ZN8Renderer14UpdateLODGroupEv, __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb: __ZN14SafeBinaryRead13BeginTransferEPKcS1_PPFbPvRS_Eb, __ZN17PersistentManager18LoadFileCompletelyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager18LoadFileCompletelyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx2Sc19ParticlePacketShape20setInteractionsDirtyENS0_15CoreInteraction9DirtyFlagE: __ZN5physx2Sc19ParticlePacketShape20setInteractionsDirtyENS0_15CoreInteraction9DirtyFlagE, __Z42AudioReverbZone_Set_Custom_PropMaxDistanceP12Il2CppObjectf: __Z42AudioReverbZone_Set_Custom_PropMaxDistanceP12Il2CppObjectf, __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev: __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulatorC2Ev, __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier: __ZN6Motion17NotifyObjectUsersERK17MessageIdentifier, __Z41Register_UnityEngine_Input_get_anyKeyDownv: __Z41Register_UnityEngine_Input_get_anyKeyDownv, __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_: __ZN19CloudServiceHandler15RestoreDataFileERK8UnityStrRS0_, __ZN11UnityEngine15CloudWebService14DataDispatcher26OnSessionContainerArchivedERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher26OnSessionContainerArchivedERNS0_16SessionContainerE, _cf2_hintmask_init: _cf2_hintmask_init, __ZN5physx2Gu25PersistentContactManifold19reduceBatchContactsEPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold19reduceBatchContactsEPKNS0_17PersistentContactEj, __ZNSt3__219__shared_mutex_base13unlock_sharedEv: __ZNSt3__219__shared_mutex_base13unlock_sharedEv, __Z24getPxD6Joint_LinearLimitPKN5physx9PxD6JointE: __Z24getPxD6Joint_LinearLimitPKN5physx9PxD6JointE, __Z29ConvertDXT5nmNormalMapToPlainR14ImageReference: __Z29ConvertDXT5nmNormalMapToPlainR14ImageReference, __ZN14Raycast2DQueryD0Ev: __ZN14Raycast2DQueryD0Ev, __ZN11UnityEngine9Animation31GetGenericAnimationBindingCacheEv: __ZN11UnityEngine9Animation31GetGenericAnimationBindingCacheEv, __ZN17Physics2DSettings5ResetEv: __ZN17Physics2DSettings5ResetEv, __ZN13SliderJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN13SliderJoint2DC2E10MemLabelId18ObjectCreationMode, __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_: __ZNSt3__26__sortIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEvT0_S6_T_, __Z29Light_CUSTOM_AddCommandBufferP12Il2CppObject20RenderLightEventTypeS0_: __Z29Light_CUSTOM_AddCommandBufferP12Il2CppObject20RenderLightEventTypeS0_, __ZN5physx9NpFactory23releaseConstraintToPoolERNS_12NpConstraintE: __ZN5physx9NpFactory23releaseConstraintToPoolERNS_12NpConstraintE, __ZN5physx2Gu10ConvexMesh12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx2Gu10ConvexMesh12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx14PxRigidBodyExt19getVelocityAtOffsetERKNS_11PxRigidBodyERKNS_6PxVec3E: __ZN5physx14PxRigidBodyExt19getVelocityAtOffsetERKNS_11PxRigidBodyERKNS_6PxVec3E, __Z47Register_UnityEngine_Graphics_CopyTexture_Slicev: __Z47Register_UnityEngine_Graphics_CopyTexture_Slicev, __ZNK5Umbra14TomeCollection7getTomeEi: __ZNK5Umbra14TomeCollection7getTomeEi, __Z39Register_UnityEngine_CubemapArray_Applyv: __Z39Register_UnityEngine_CubemapArray_Applyv, __Z22getPxD6JointDriveFlagsPKN5physx14PxD6JointDriveE: __Z22getPxD6JointDriveFlagsPKN5physx14PxD6JointDriveE, __Z21SetupMonoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK8Vector3f: __Z21SetupMonoFlareElementP11FlareVertexRK8Vector2fS3_S3_RK11ColorRGBA32RK8Vector3f, __ZN5physx22PxVehicleTelemetryData8allocateEj: __ZN5physx22PxVehicleTelemetryData8allocateEj, _UNITY_FT_Done_Glyph: _UNITY_FT_Done_Glyph, __ZNK5physx16PxsSolverExtBody9getLinVelEv: __ZNK5physx16PxsSolverExtBody9getLinVelEv, __ZN2gl15IsFormatIntegerENS_9TexFormatE: __ZN2gl15IsFormatIntegerENS_9TexFormatE, __ZN14LineParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14LineParameters8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx40PCMConvexVsMeshContactGenerationCallbackD0Ev: __ZN5physx40PCMConvexVsMeshContactGenerationCallbackD0Ev, __Z23ChooseSuitableFSAALeveliiiiii: __Z23ChooseSuitableFSAALeveliiiiii, __Z42Register_UnityEngine_GUIUtility_SetChangedv: __Z42Register_UnityEngine_GUIUtility_SetChangedv, ___tre_mem_destroy: ___tre_mem_destroy, __ZN5physx2Sc5Scene9solveStepEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene9solveStepEPNS_10PxBaseTaskE, __Z36Rigidbody_Get_Custom_PropIsKinematicP12Il2CppObject: __Z36Rigidbody_Get_Custom_PropIsKinematicP12Il2CppObject, __Z42Shader_CUSTOM_INTERNAL_CALL_GetGlobalColoriR10ColorRGBAf: __Z42Shader_CUSTOM_INTERNAL_CALL_GetGlobalColoriR10ColorRGBAf, __ZN5physx5cloth9ClothImplINS0_7SwClothEED0Ev: __ZN5physx5cloth9ClothImplINS0_7SwClothEED0Ev, __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_, __ZN5physx2Sn17readAllPropertiesINS_15PxRevoluteJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_15PxRevoluteJointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7getNameEv, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __ZN5physx15PxVehicleUpdate13updateDrive4WEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDrive4WEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx15PxVehicleUpdate13updateDrive4WEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDrive4WEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __ZNSt3__218__insertion_sort_3IRNS_6__lessIffEEPfEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIffEEPfEEvT0_S5_T_, __ZN7ApiGLES20CreateComputeProgramEj: __ZN7ApiGLES20CreateComputeProgramEj, __Z72Register_UnityEngine_Networking_UnityWebRequest_InternalSetRequestHeaderv: __Z72Register_UnityEngine_Networking_UnityWebRequest_InternalSetRequestHeaderv, __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __ZN5physx21PxcArticulationHelper12getDataSizesEjRjS1_S1_: __ZN5physx21PxcArticulationHelper12getDataSizesEjRjS1_S1_, __Z46UploadHandlerRaw_CUSTOM_InternalGetContentTypeP12Il2CppObject: __Z46UploadHandlerRaw_CUSTOM_InternalGetContentTypeP12Il2CppObject, __ZN5physx9PxTaskMgr13getTaskFromIDEj: __ZN5physx9PxTaskMgr13getTaskFromIDEj, __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwx, __ZN6SkyboxC2E10MemLabelId18ObjectCreationMode: __ZN6SkyboxC2E10MemLabelId18ObjectCreationMode, __ZN14SerializedFile27PatchRemapDeprecatedClassesEv: __ZN14SerializedFile27PatchRemapDeprecatedClassesEv, __ZNK5physx2Gu13MeshInterface7IsValidEv: __ZNK5physx2Gu13MeshInterface7IsValidEv, __Z23ClearLocalNotificationsv: __Z23ClearLocalNotificationsv, __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E: __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E, __ZN15QualitySettings14QualitySettingC2Ev: __ZN15QualitySettings14QualitySettingC2Ev, __ZNSt3__215numpunct_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__215numpunct_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwm, __ZN20UnityConnectSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN20UnityConnectSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E: __ZN5physx2Gu13MeshInterface11SetPointersEPKvbPKNS_6PxVec3E, __ZN11UnityEngine15CloudWebService16SessionContainer20DeleteArchivedFolderERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer20DeleteArchivedFolderERK8UnityStr, __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwe, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwb, __ZN5physx12writeBack1D4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_: __ZN5physx12writeBack1D4EPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_, __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv: __ZN12_GLOBAL__N_117ConnectionManager15getInstanceDataEPKv, __ZN11AssetBundle23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11AssetBundle23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN18GlslGpuProgramGLES24StoreInBinaryShaderCacheEPKc: __ZN18GlslGpuProgramGLES24StoreInBinaryShaderCacheEPKc, __ZThn4_NK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_: __ZThn4_NK5physx5cloth9SwFactory17extractFabricDataERKNS0_6FabricENS0_5RangeIjEES6_NS5_IfEES6_S6_S7_, __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE: __ZN25StaticProfilerInformationC2EPKc13ProfilerGroupN19ProfilerInformation5FlagsE, __ZNK15PointEffector2D21DesignedForNonTriggerEv: __ZNK15PointEffector2D21DesignedForNonTriggerEv, _ft_bitmap_glyph_init: _ft_bitmap_glyph_init, __ZN13BuildSettings34ConvertScenePathToDisplayScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13BuildSettings34ConvertScenePathToDisplayScenePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, __ZN5Unity10FixedJoint6CreateEv: __ZN5Unity10FixedJoint6CreateEv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5epptrEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5epptrEv, __ZN8Gradient17ValidateColorKeysEv: __ZN8Gradient17ValidateColorKeysEv, __ZN5physx2Sc5Scene23setCreateContactReportsEb: __ZN5physx2Sc5Scene23setCreateContactReportsEb, __ZN12_GLOBAL__N_119PvdConnectionReader7executeEv: __ZN12_GLOBAL__N_119PvdConnectionReader7executeEv, _load_truetype_glyph: _load_truetype_glyph, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale0Ev, __ZNK5physx3Ext14SphericalJoint28getProjectionLinearToleranceEv: __ZNK5physx3Ext14SphericalJoint28getProjectionLinearToleranceEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateUpdateAllSkinnedMeshesstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdateUpdateAllSkinnedMeshesstruct7ForwardEv, __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_: __ZNSt3__27__sort5IRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEjT0_SB_SB_SB_SB_T_, __Z27RemoveUnnecessaryTransformsR10GameObjectPK16HumanDescriptionPK8UnityStrjb: __Z27RemoveUnnecessaryTransformsR10GameObjectPK16HumanDescriptionPK8UnityStrjb, __Z12GetIVRDevicev: __Z12GetIVRDevicev, __Z29Rigidbody2D_CUSTOM_IsTouchingP12Il2CppObjectS0_: __Z29Rigidbody2D_CUSTOM_IsTouchingP12Il2CppObjectS0_, __Z34Material_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray: __Z34Material_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN7dtCrowd14resetAgentPathERK13dtCrowdHandle: __ZN7dtCrowd14resetAgentPathERK13dtCrowdHandle, __ZNK17Physics2DSettings23GetIgnoreLayerCollisionEii: __ZNK17Physics2DSettings23GetIgnoreLayerCollisionEii, __Z100Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveIDv: __Z100Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveIDv, __ZN10GISettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10GISettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN9ShaderLab18SerializedPropertyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z29StdTemplateConversionFunctionIhxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhxEbPvR14SafeBinaryRead, __ZL12InvokeMethodI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_, __ZNK5Umbra10Sha1Digest3strEPc: __ZNK5Umbra10Sha1Digest3strEPc, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_17TransferMetaFlags, __ZN12MeshCollider8TransferI14SafeBinaryReadEEvRT_: __ZN12MeshCollider8TransferI14SafeBinaryReadEEvRT_, __Z30GetSplashScreenBackgroundColorv: __Z30GetSplashScreenBackgroundColorv, __Z38Register_UnityEngine_Screen_get_heightv: __Z38Register_UnityEngine_Screen_get_heightv, __ZN5Unity14CharacterJoint19SetSwingLimitSpringERK20SoftJointLimitSpring: __ZN5Unity14CharacterJoint19SetSwingLimitSpringERK20SoftJointLimitSpring, __ZNK18ScreenManagerWebGL13GetLockCursorEv: __ZNK18ScreenManagerWebGL13GetLockCursorEv, __ZN12UserListNode5ClearEv: __ZN12UserListNode5ClearEv, __ZN7Joint2D18SetEnableCollisionEb: __ZN7Joint2D18SetEnableCollisionEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj525ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv: __ZN17GeneralConnection10Connection11SendMessageERNS_14NetworkMessageEPKv, __ZN16ControllerFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE: __ZN16ControllerFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE, __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Rewindv: __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Rewindv, __ZN4FMOD6System17setNetworkTimeoutEi: __ZN4FMOD6System17setNetworkTimeoutEi, __ZN27ConvexVsMeshOverlapCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN27ConvexVsMeshOverlapCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __Z47Application_Get_Custom_PropIsHumanControllingUsv: __Z47Application_Get_Custom_PropIsHumanControllingUsv, __ZNK5Umbra18ReceiverMaskBuffer8getWidthEv: __ZNK5Umbra18ReceiverMaskBuffer8getWidthEv, _realpath: _realpath, __ZN12LightsModule16DeleteLightsListER4ListI17ParticleLightNodeE: __ZN12LightsModule16DeleteLightsListER4ListI17ParticleLightNodeE, __Z16DestroyGfxDevicev: __Z16DestroyGfxDevicev, __Z54Register_UnityEngine_WheelCollider_INTERNAL_set_centerv: __Z54Register_UnityEngine_WheelCollider_INTERNAL_set_centerv, __ZN5Umbra6KDTree8buildLutEPjPKji: __ZN5Umbra6KDTree8buildLutEPjPKji, __ZNK13SparseTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK13SparseTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE: __ZNK5physx2Sc5Scene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE, __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_: __ZN4glsl18ExtractDefineBlockERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_PS6_, _cf2_interpT2CharString: _cf2_interpT2CharString, __ZNK5physx7NpScene14getTaskManagerEv: __ZNK5physx7NpScene14getTaskManagerEv, __ZN9Texture2D11EncodeToPNGER13dynamic_arrayIhLj1EE: __ZN9Texture2D11EncodeToPNGER13dynamic_arrayIhLj1EE, __Z33VRSettings_Set_Custom_PropEnabledh: __Z33VRSettings_Set_Custom_PropEnabledh, __ZThn4_N5physx12MemoryBufferD1Ev: __ZThn4_N5physx12MemoryBufferD1Ev, __ZN11UnityEngine9Animation18FindAnimatedObjectER10GameObjectRK18EditorCurveBinding: __ZN11UnityEngine9Animation18FindAnimatedObjectER10GameObjectRK18EditorCurveBinding, __ZN26PlayerSettingsSplashScreenC2EP14PlayerSettings: __ZN26PlayerSettingsSplashScreenC2EP14PlayerSettings, __ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody: __ZN8Collider24FindNewAttachedRigidbodyEPK9Rigidbody, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, _unity_z_zlibCompileFlags: _unity_z_zlibCompileFlags, __ZNK25ThreadsafeLinearAllocator21GetReservedMemorySizeEv: __ZNK25ThreadsafeLinearAllocator21GetReservedMemorySizeEv, __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc: __ZN9Scripting12LogExceptionEP15Il2CppExceptioniPKc, __Z37Collider_Set_Custom_PropContactOffsetP12Il2CppObjectf: __Z37Collider_Set_Custom_PropContactOffsetP12Il2CppObjectf, __Z48getPxVehicleTireLoadFilterDataMMaxNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE: __Z48getPxVehicleTireLoadFilterDataMMaxNormalisedLoadPKN5physx27PxVehicleTireLoadFilterDataE, __ZN14EmissionModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14EmissionModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN16RayRTreeCallbackILi0ELb0EED2Ev: __ZN16RayRTreeCallbackILi0ELb0EED2Ev, __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimeMultiplierv: __Z90Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimeMultiplierv, __ZN4FMOD6System13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i: __ZN4FMOD6System13setFileSystemEPF11FMOD_RESULTPKciPjPPvS6_EPFS1_S5_S5_EPFS1_S5_S5_jS4_S5_EPFS1_S5_jS5_EPFS1_P18FMOD_ASYNCREADINFOS5_ESA_i, __ZNK11AudioSource14GetSecPositionEv: __ZNK11AudioSource14GetSecPositionEv, __ZL21CleanupModule_Terrainv: __ZL21CleanupModule_Terrainv, __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize2R8Vector3fS0_: __Z53Vector3_CUSTOM_INTERNAL_CALL_Internal_OrthoNormalize2R8Vector3fS0_, __ZN13ComputeShader13AfterDispatchEj: __ZN13ComputeShader13AfterDispatchEj, __Z52Register_UnityEngine_Transform_INTERNAL_set_rotationv: __Z52Register_UnityEngine_Transform_INTERNAL_set_rotationv, __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE: __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z46Register_UnityEngine_Physics_set_sleepVelocityv: __Z46Register_UnityEngine_Physics_set_sleepVelocityv, __ZN14DetailDatabase21RemoveDetailPrototypeEi: __ZN14DetailDatabase21RemoveDetailPrototypeEi, __ZN9ShaderLab26SerializedShaderDependency8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab26SerializedShaderDependency8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getWorldBoundsEf: __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getWorldBoundsEf, _UNITY_png_flush: _UNITY_png_flush, __ZN10GUITexture10BuildSheetEv: __ZN10GUITexture10BuildSheetEv, __ZN12_GLOBAL__N_110DataStream15flushPvdCommandEv: __ZN12_GLOBAL__N_110DataStream15flushPvdCommandEv, __ZN13AudioListener11FixedUpdateEv: __ZN13AudioListener11FixedUpdateEv, __ZN5physx18ReducedVertexCloud5CleanEv: __ZN5physx18ReducedVertexCloud5CleanEv, __Z28getPxSceneDescBroadPhaseTypePKN5physx11PxSceneDescE: __Z28getPxSceneDescBroadPhaseTypePKN5physx11PxSceneDescE, __ZN5physx9NpPhysics16initOffsetTablesERNS_14PxvOffsetTableE: __ZN5physx9NpPhysics16initOffsetTablesERNS_14PxvOffsetTableE, __Z8StrNICmpPKcS0_j: __Z8StrNICmpPKcS0_j, __ZN10AudioMixer5ResetEv: __ZN10AudioMixer5ResetEv, __ZN37RotationBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN37RotationBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN7ApiGLES20DrawElementsIndirectE16GfxPrimitiveTypejj: __ZN7ApiGLES20DrawElementsIndirectE16GfxPrimitiveTypejj, __ZN11AudioModule18PauseVideoTexturesEv: __ZN11AudioModule18PauseVideoTexturesEv, __ZNK21PxsParallelSolverTask7getNameEv: __ZNK21PxsParallelSolverTask7getNameEv, __Z38Register_UnityEngine_Rigidbody2D_Sleepv: __Z38Register_UnityEngine_Rigidbody2D_Sleepv, ___stdio_write: ___stdio_write, __Z56Register_UnityEngine_PhysicMaterial_set_dynamicFriction2v: __Z56Register_UnityEngine_PhysicMaterial_set_dynamicFriction2v, __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh: __ZN5physx2Sc10ElementSim27setElementInteractionsDirtyENS0_15CoreInteraction9DirtyFlagEh, __ZN4FMOD6System11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E: __ZN4FMOD6System11setCallbackEPF11FMOD_RESULTP11FMOD_SYSTEM24FMOD_SYSTEM_CALLBACKTYPEPvS5_E, __Z46GL_CUSTOM_INTERNAL_CALL_GetGPUProjectionMatrixRK10Matrix4x4fhRS_: __Z46GL_CUSTOM_INTERNAL_CALL_GetGPUProjectionMatrixRK10Matrix4x4fhRS_, __ZNKSt3__217moneypunct_bynameIwLb1EE13do_pos_formatEv: __ZNKSt3__217moneypunct_bynameIwLb1EE13do_pos_formatEv, __ZNK14TerrainManager23CollectLODGroupManagersEPK6CameraPP15LODGroupManagerj: __ZNK14TerrainManager23CollectLODGroupManagersEPK6CameraPP15LODGroupManagerj, __ZN25BuiltinShaderParamIndices16CheckMatrixParamEPKciiiib: __ZN25BuiltinShaderParamIndices16CheckMatrixParamEPKciiiib, __ZNK5physx14NpArticulation11getAPISceneEv: __ZNK5physx14NpArticulation11getAPISceneEv, __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE: __ZN5physx2Cm12RenderOutputlsERKNS_11PxTransformE, __ZN4FMOD5Sound13getSoundGroupEPPNS_10SoundGroupE: __ZN4FMOD5Sound13getSoundGroupEPPNS_10SoundGroupE, __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_: __ZNSt3__27__sort4IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_T_, __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEclILj532ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN25ThreadsafeLinearAllocatorD0Ev: __ZN25ThreadsafeLinearAllocatorD0Ev, __ZN14GfxContextGLES8Instance14GetFramebufferEv: __ZN14GfxContextGLES8Instance14GetFramebufferEv, __ZN8Collider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8Collider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL28CleanupAudioScriptingClassesv: __ZL28CleanupAudioScriptingClassesv, __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx2Sc9ClothCore19getPreviousTimeStepEv: __ZNK5physx2Sc9ClothCore19getPreviousTimeStepEv, __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE: __ZN8Material11HasPropertyEN9ShaderLab16FastPropertyNameE, __ZN15dtProximityGrid5clearEv: __ZN15dtProximityGrid5clearEv, __Z67Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_CalculatePathInternalv: __Z67Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_CalculatePathInternalv, __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL14solve1D4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5ImageC2Eii13TextureFormat: __ZN5ImageC2Eii13TextureFormat, __ZN19RuntimeSceneManagerD0Ev: __ZN19RuntimeSceneManagerD0Ev, __Z53Register_UnityEngine_ColorUtility_DoTryParseHtmlColorv: __Z53Register_UnityEngine_ColorUtility_DoTryParseHtmlColorv, __Z43Texture_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE: __Z43Texture_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE, __ZN5physx7NpScene12executeSceneEPNS_10PxBaseTaskE: __ZN5physx7NpScene12executeSceneEPNS_10PxBaseTaskE, _UNITY_LZ4_decompress_safe_continue: _UNITY_LZ4_decompress_safe_continue, __ZN20TextRenderingPrivate19NativeTextGenerator16OffsetCharactersE8Vector2fPN2UI8UIVertexEPS1_i: __ZN20TextRenderingPrivate19NativeTextGenerator16OffsetCharactersE8Vector2fPN2UI8UIVertexEPS1_i, __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetRectOffsetPtrv: __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetRectOffsetPtrv, __Z35AudioSource_Get_Custom_PropPriorityP12Il2CppObject: __Z35AudioSource_Get_Custom_PropPriorityP12Il2CppObject, __ZN5physx17MBPUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE: __ZN5physx17MBPUpdateWorkTaskC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerE, __ZN14SpriteRendererC2E10MemLabelId18ObjectCreationMode: __ZN14SpriteRendererC2E10MemLabelId18ObjectCreationMode, __ZN6Camera14UpdateVelocityEv: __ZN6Camera14UpdateVelocityEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN13MonoBehaviour18TransferEngineDataI19StreamedBinaryWriteILb0EEEE4PPtrI10MonoScriptERT_: __ZN13MonoBehaviour18TransferEngineDataI19StreamedBinaryWriteILb0EEEE4PPtrI10MonoScriptERT_, __ZN8Animator19ApplyOnAnimatorMoveEv: __ZN8Animator19ApplyOnAnimatorMoveEv, __Z13RegisterClassI26AnimatorOverrideControllerEvv: __Z13RegisterClassI26AnimatorOverrideControllerEvv, __Z35RectOffset_CUSTOM_INTERNAL_CALL_AddP12Il2CppObjectRK5RectTIfERS2_: __Z35RectOffset_CUSTOM_INTERNAL_CALL_AddP12Il2CppObjectRK5RectTIfERS2_, __Z22GetComponentWithScriptR10GameObjectiP10MonoScript: __Z22GetComponentWithScriptR10GameObjectiP10MonoScript, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE13isSubordinateEv, __ZN15SkyboxGenerator27GetCubemapSkyboxVertexCountEv: __ZN15SkyboxGenerator27GetCubemapSkyboxVertexCountEv, __ZN13GfxDeviceGLES19CreateComputeBufferE15ComputeBufferIDjjj: __ZN13GfxDeviceGLES19CreateComputeBufferE15ComputeBufferIDjjj, __Z19getPxRigidBody_MassPKN5physx11PxRigidBodyE: __Z19getPxRigidBody_MassPKN5physx11PxRigidBodyE, __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticFieldIDv: __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetStaticFieldIDv, __ZN5physx8debugger15ForwardingArrayINS0_9PtrOffsetEED0Ev: __ZN5physx8debugger15ForwardingArrayINS0_9PtrOffsetEED0Ev, __ZN6Sprite23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Sprite23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN17BillboardRenderer17MainThreadCleanupEv: __ZN17BillboardRenderer17MainThreadCleanupEv, __Z39setPxRigidBody_MinCCDAdvanceCoefficientPN5physx11PxRigidBodyEf: __Z39setPxRigidBody_MinCCDAdvanceCoefficientPN5physx11PxRigidBodyEf, __Z36TerrainData_CUSTOM_RefreshPrototypesP12Il2CppObject: __Z36TerrainData_CUSTOM_RefreshPrototypesP12Il2CppObject, __ZN5physx2Gu33MultiplePersistentContactManifold24addManifoldContactPointsEPNS0_21MeshPersistentContactEjPPNS0_15PCMContactPatchEjRKNS_6shdfnd3aos6FloatVESB_h: __ZN5physx2Gu33MultiplePersistentContactManifold24addManifoldContactPointsEPNS0_21MeshPersistentContactEjPPNS0_15PCMContactPatchEjRKNS_6shdfnd3aos6FloatVESB_h, __Z46Register_UnityEngine_SystemInfo_get_deviceTypev: __Z46Register_UnityEngine_SystemInfo_get_deviceTypev, __Z66Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawRendererv: __Z66Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawRendererv, __ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE: __ZN5physx24PxsSetupSolverConstraintEPKNS_13PxsConstraintEPNS_17PxcSolverBodyDataERNS_24PxcConstraintBlockStreamEffRNS_23PxcSolverConstraintDescERNS_25PxsConstraintBlockManagerE, __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z36AnimationClip_CUSTOM_SampleAnimationP12Il2CppObjectS0_f: __Z36AnimationClip_CUSTOM_SampleAnimationP12Il2CppObjectS0_f, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Umbra11PatchWriter5patchEPKvS2_: __ZN5Umbra11PatchWriter5patchEPKvS2_, __ZN5physx9NpPhysics13getFoundationEv: __ZN5physx9NpPhysics13getFoundationEv, _vsnprintf: _vsnprintf, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZMultiplierv, __ZN5Unity10HingeJoint12SetUseLimitsEb: __ZN5Unity10HingeJoint12SetUseLimitsEb, __ZThn4_N16RayRTreeCallbackILi1ELb1EED0Ev: __ZThn4_N16RayRTreeCallbackILi1ELb1EED0Ev, __ZThn32_N22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj: __ZN5physxL23updateParticleGroupPairEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjS5_jbbRKNS_26PxsFluidDynamicsParametersEPhPj, _casinf: _casinf, __ZN7Joint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN7Joint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _iswdigit_l: _iswdigit_l, __ZN12AudioManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12AudioManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z12UnloadObjectP6Object: __Z12UnloadObjectP6Object, __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_: __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj184ENS_22PxRepXPropertyAccessorILj184ENS_14PxParticleBaseENS_15PxMetaDataPlaneESA_EEEEvRKT0_, __ZN4FMOD6SoundI15deleteSyncPointEP14FMOD_SYNCPOINT: __ZN4FMOD6SoundI15deleteSyncPointEP14FMOD_SYNCPOINT, __ZN5physx17PxsContactManager6setCCDEb: __ZN5physx17PxsContactManager6setCCDEb, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_secondERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN8Animator20CreatePlayableMemoryEv: __ZN8Animator20CreatePlayableMemoryEv, __ZN8Collider12CleanupClassEv: __ZN8Collider12CleanupClassEv, __ZN18PlatformEffector2D5ResetEv: __ZN18PlatformEffector2D5ResetEv, __ZN9GfxDevice18BeforePluginRenderEv: __ZN9GfxDevice18BeforePluginRenderEv, __ZN4gles21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS3_: __ZN4gles21FillRenderTargetSetupEP20GfxRenderTargetSetupP17RenderSurfaceBaseS3_, __ZNK5physx7NpCloth20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE: __ZNK5physx7NpCloth20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE, __ZN14VelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj: __ZN14VelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj, __ZN14PhysicMaterial15ThreadedCleanupEv: __ZN14PhysicMaterial15ThreadedCleanupEv, __ZN5physx2Sc5Scene7releaseEv: __ZN5physx2Sc5Scene7releaseEv, __Z29Material_CUSTOM_EnableKeywordP12Il2CppObjectP12Il2CppString: __Z29Material_CUSTOM_EnableKeywordP12Il2CppObjectP12Il2CppString, __Z42Register_UnityEngine_LODGroup_get_fadeModev: __Z42Register_UnityEngine_LODGroup_get_fadeModev, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl8getClassEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl8getClassEN5physx8debugger18NonNegativeIntegerE, __ZNK2UI6Canvas20CalculateCanvasAlphaEv: __ZNK2UI6Canvas20CalculateCanvasAlphaEv, _jzero_far: _jzero_far, __Z29Transfer_Blittable_ArrayFieldI8JSONReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN16LightmapSettings8TransferI17RemapPPtrTransferEEvRT_: __ZN16LightmapSettings8TransferI17RemapPPtrTransferEEvRT_, __ZN6b2BodyC2EPK9b2BodyDefP7b2World: __ZN6b2BodyC2EPK9b2BodyDefP7b2World, __Z32Event_Set_Custom_PropCommandNameP12Il2CppObjectP12Il2CppString: __Z32Event_Set_Custom_PropCommandNameP12Il2CppObjectP12Il2CppString, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, _UNITY_png_set_gAMA: _UNITY_png_set_gAMA, __Z40getPxHeightFieldGeometryHeightFieldFlagsPKN5physx21PxHeightFieldGeometryE: __Z40getPxHeightFieldGeometryHeightFieldFlagsPKN5physx21PxHeightFieldGeometryE, __Z18GetNavMeshSettingsv: __Z18GetNavMeshSettingsv, __Z32AudioMixerReceiveProcessCallbackP21UnityAudioEffectStatePfS1_jii: __Z32AudioMixerReceiveProcessCallbackP21UnityAudioEffectStatePfS1_jii, _gethostid: _gethostid, __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_pathEndPositionv: __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_pathEndPositionv, __ZN16MessageForwarder15AddBaseMessagesERKS_: __ZN16MessageForwarder15AddBaseMessagesERKS_, __ZNK13GfxDeviceNull13GetViewMatrixEv: __ZNK13GfxDeviceNull13GetViewMatrixEv, __Z46Register_UnityEngine_PolygonCollider2D_GetPathv: __Z46Register_UnityEngine_PolygonCollider2D_GetPathv, __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoWindowv: __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoWindowv, __ZNK5Umbra15CameraTransform16getWorldToCameraERNS_9Matrix4x4E: __ZNK5Umbra15CameraTransform16getWorldToCameraERNS_9Matrix4x4E, __ZN20UnityConnectSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN20UnityConnectSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __Z48Register_UnityEngine_Material_SetVectorArrayImplv: __Z48Register_UnityEngine_Material_SetVectorArrayImplv, __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10Effector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z36Rigidbody_Set_Custom_PropAngularDragP12Il2CppObjectf: __Z36Rigidbody_Set_Custom_PropAngularDragP12Il2CppObjectf, __ZN9allocutil14BuddyAllocator16InternalAllocateEhRj: __ZN9allocutil14BuddyAllocator16InternalAllocateEhRj, __Z45Register_UnityEngine_AnimationCurve_RemoveKeyv: __Z45Register_UnityEngine_AnimationCurve_RemoveKeyv, __ZN4File4ReadEPvj: __ZN4File4ReadEPvj, __ZThn8_N12_GLOBAL__N_110ConnectionD0Ev: __ZThn8_N12_GLOBAL__N_110ConnectionD0Ev, __ZNK14Texture2DArray13GetDataHeightEv: __ZNK14Texture2DArray13GetDataHeightEv, __ZN5physx2Sn5ConvX22convertReferenceTablesEPKvRiS4_: __ZN5physx2Sn5ConvX22convertReferenceTablesEPKvRiS4_, _towupper_l: _towupper_l, _vfwprintf: _vfwprintf, __ZN7dtCrowd23UpdateActiveObstacleIDsEv: __ZN7dtCrowd23UpdateActiveObstacleIDsEv, __ZNSt3__211__stdoutbufIcE4syncEv: __ZNSt3__211__stdoutbufIcE4syncEv, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNK5physx2Gu5RTree11traverseOBBERKNS0_3BoxEjPjPNS1_8CallbackE: __ZNK5physx2Gu5RTree11traverseOBBERKNS0_3BoxEjPjPNS1_8CallbackE, __ZN14SerializedFile4Type8ReadTypeILb0EEEbibRPKhS3_Pi: __ZN14SerializedFile4Type8ReadTypeILb0EEEbibRPKhS3_Pi, __Z19SetRaycastInterfaceP8IRaycast: __Z19SetRaycastInterfaceP8IRaycast, __ZN15RelativeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15RelativeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z83Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointv: __Z83Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointv, __GLOBAL__sub_I_runtime_terrain2_lump_cpp: __GLOBAL__sub_I_runtime_terrain2_lump_cpp, __ZN16ReflectionProbes16RenderProbeFacesEP15ReflectionProbei: __ZN16ReflectionProbes16RenderProbeFacesEP15ReflectionProbei, __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI11QuaternionfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN5physx2Sc17ParticleSystemSim27releaseParticlePacketShapesEv: __ZN5physx2Sc17ParticleSystemSim27releaseParticlePacketShapesEv, __Z29ComputeShader_CUSTOM_SetFloatP12Il2CppObjectif: __Z29ComputeShader_CUSTOM_SetFloatP12Il2CppObjectif, __Z53Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForcev: __Z53Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForcev, __ZN10GameObject37RemoveComponentFromGameObjectInternalERN5Unity9ComponentE: __ZN10GameObject37RemoveComponentFromGameObjectInternalERN5Unity9ComponentE, __Z27sweepConvex_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z27sweepConvex_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEv: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16releaseParticlesEv, __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_: __ZN7Texture8TransferI17RemapPPtrTransferEEvRT_, __ZN14NavMeshManager18UnregisterObstacleERi: __ZN14NavMeshManager18UnregisterObstacleERi, __ZNK14DataBufferGLES14GetRecreateAgeEv: __ZNK14DataBufferGLES14GetRecreateAgeEv, __ZN9Scripting9GetMethodEPKcS1_S1_S1_: __ZN9Scripting9GetMethodEPKcS1_S1_S1_, __ZNK5physx15PxParticleFluid8isKindOfEPKc: __ZNK5physx15PxParticleFluid8isKindOfEPKc, __ZN15DirectorManager32StopScheduledPlayableControllersEv: __ZN15DirectorManager32StopScheduledPlayableControllersEv, __ZN6Object21AwakeFromLoadThreadedEv: __ZN6Object21AwakeFromLoadThreadedEv, __ZN18MultiFrameGUIStateC2Ev: __ZN18MultiFrameGUIStateC2Ev, __ZN13AnimationClip12Vector3CurveaSERKS0_: __ZN13AnimationClip12Vector3CurveaSERKS0_, __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19ClampVelocityModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN22b2EdgeAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN22b2EdgeAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN15ResourceManagerD0Ev: __ZN15ResourceManagerD0Ev, __Z24RegisterStrippedTypeInfoI15QualitySettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI15QualitySettingsEviPKcS2_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_13PxRigidStaticEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __Z56Register_UnityEngine_LocationService_get_isEnabledByUserv: __Z56Register_UnityEngine_LocationService_get_isEnabledByUserv, __ZN21UniformBufferTFMethod16BindForRenderingEj: __ZN21UniformBufferTFMethod16BindForRenderingEj, __ZN18BuoyancyEffector2D16CheckConsistencyEv: __ZN18BuoyancyEffector2D16CheckConsistencyEv, __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_: __ZN4FMOD6System17getSoftwareFormatEPiP17FMOD_SOUND_FORMATS1_S1_P18FMOD_DSP_RESAMPLERS1_, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN4FMOD6System13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj: __ZN4FMOD6System13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj, __ZNK5physx3Ext14PrismaticJoint8getLimitEv: __ZNK5physx3Ext14PrismaticJoint8getLimitEv, __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj: __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj, __Z33RenderTexture_CUSTOM_GetTemporaryiii19RenderTextureFormat22RenderTextureReadWritei: __Z33RenderTexture_CUSTOM_GetTemporaryiii19RenderTextureFormat22RenderTextureReadWritei, __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_, __GLOBAL__sub_I_FontImpl_cpp: __GLOBAL__sub_I_FontImpl_cpp, __ZNK9GfxDevice18GetDefaultRTFormatEv: __ZNK9GfxDevice18GetDefaultRTFormatEv, __ZN5physx3Scb4Base7destroyEv: __ZN5physx3Scb4Base7destroyEv, __ZNK12NavMeshAgent7HasPathEv: __ZNK12NavMeshAgent7HasPathEv, __Z49Register_UnityEngine_AudioClip_Construct_Internalv: __Z49Register_UnityEngine_AudioClip_Construct_Internalv, _dummy0: _dummy0, __ZN13GfxDeviceGLES22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_: __ZN13GfxDeviceGLES22UpdateComputeResourcesEjPK9TextureIDPK16TextureDimensionPKijPKjjPK15ComputeBufferIDS7_PK20ComputeBufferCounterjSC_S2_S5_S9_SF_, _sfnt_init_face: _sfnt_init_face, __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6appendEPKc, __ZNK5physx16PxsBroadPhaseMBP7getCapsERNS_16PxBroadPhaseCapsE: __ZNK5physx16PxsBroadPhaseMBP7getCapsERNS_16PxBroadPhaseCapsE, __ZN22UnityProfilerPerThread7CleanupEv: __ZN22UnityProfilerPerThread7CleanupEv, ___cxx_global_var_init: ___cxx_global_var_init, __Z26getPxD6Joint_DrivePositionPKN5physx9PxD6JointE: __Z26getPxD6Joint_DrivePositionPKN5physx9PxD6JointE, __ZN11dtPathQueue18setStaleInProgressEj: __ZN11dtPathQueue18setStaleInProgressEj, __ZN7VRInputC2EPK34UnityVRDeviceSpecificConfiguration: __ZN7VRInputC2EPK34UnityVRDeviceSpecificConfiguration, __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __Z36setPxVehicleDriveDynDataMEnginespeedPN5physx21PxVehicleDriveDynDataEf: __Z36setPxVehicleDriveDynDataMEnginespeedPN5physx21PxVehicleDriveDynDataEf, __ZNK5physx24MatrixNGaussSeidelSolver5solveEjfRKNS_8MatrixNNERKNS_7VectorNERS4_: __ZNK5physx24MatrixNGaussSeidelSolver5solveEjfRKNS_8MatrixNNERKNS_7VectorNERS4_, __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_Transactionv: __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_Transactionv, __ZN5physx16PxsFluidDynamics12mergeDensityEPNS_10PxBaseTaskE: __ZN5physx16PxsFluidDynamics12mergeDensityEPNS_10PxBaseTaskE, __ZN5physx6shdfnd7FastIPCD0Ev: __ZN5physx6shdfnd7FastIPCD0Ev, __ZN4PPtrI19SkinnedMeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI19SkinnedMeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Gu22computeMTD_SpherePlaneERNS_6PxVec3ERfRKNS0_6SphereERKNS_7PxPlaneE: __ZN5physx2Gu22computeMTD_SpherePlaneERNS_6PxVec3ERfRKNS0_6SphereERKNS_7PxPlaneE, __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sn17InternalReferenceIjEENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN13ScreenManager14GetResolutionsEib: __ZN13ScreenManager14GetResolutionsEib, __exit: __exit, __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __Z62DownloadHandler_CUSTOM_INTERNAL_CALL_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringRK7Hash128j: __Z62DownloadHandler_CUSTOM_INTERNAL_CALL_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringRK7Hash128j, __ZN13MemoryManager23StartLoggingAllocationsEj: __ZN13MemoryManager23StartLoggingAllocationsEj, __ZN7Terrain11RemoveTreesERK8Vector2ffi: __ZN7Terrain11RemoveTreesERK8Vector2ffi, __Z15GetChannelIndexRK14BlendShapeDataPKc: __Z15GetChannelIndexRK14BlendShapeDataPKc, __Z35Input_CUSTOM_mainGyroIndex_Internalv: __Z35Input_CUSTOM_mainGyroIndex_Internalv, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getRelativeTransformEv, _cf2_getSeacComponent: _cf2_getSeacComponent, __ZNK17AnimationCurveTplI8Vector3fE15GetPostInfinityEv: __ZNK17AnimationCurveTplI8Vector3fE15GetPostInfinityEv, __ZN5physx9NpFactory15createAggregateEjb: __ZN5physx9NpFactory15createAggregateEjb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7reserveEj, __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_: __Z22b2CollideEdgeAndCircleP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK13b2CircleShapeS6_, __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayListImplv: __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayListImplv, __ZN4gles25InitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadENS_24BlitFramebufferAlphaModeENS_35BlitFramebufferColorSpaceConversionE: __ZN4gles25InitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadENS_24BlitFramebufferAlphaModeENS_35BlitFramebufferColorSpaceConversionE, __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_: __ZN5physx23writeBackContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEPPKNS_17PxcSolverBodyDataES8_, __ZN5physx11NpAggregate18removeArticulationERNS_14PxArticulationE: __ZN5physx11NpAggregate18removeArticulationERNS_14PxArticulationE, __ZN9Texture2D8TransferI17RemapPPtrTransferEEvRT_: __ZN9Texture2D8TransferI17RemapPPtrTransferEEvRT_, __ZN10MonoScript23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10MonoScript23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStrS2_EENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN13GfxDeviceNull13SetBlendStateEPK16DeviceBlendState: __ZN13GfxDeviceNull13SetBlendStateEPK16DeviceBlendState, __Z43Register_UnityEngine_TextMesh_get_fontStylev: __Z43Register_UnityEngine_TextMesh_get_fontStylev, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN12HandlerChain6DeleteER13FileEntryDatab: __ZN12HandlerChain6DeleteER13FileEntryDatab, __ZN9Coroutine35HandleIEnumerableCurrentReturnValueEP12Il2CppObject: __ZN9Coroutine35HandleIEnumerableCurrentReturnValueEP12Il2CppObject, __Z55Register_UnityEngine_ParticleSystem_get_simulationSpacev: __Z55Register_UnityEngine_ParticleSystem_get_simulationSpacev, __ZN14UnityAnalytics29OnSceneLoadedAfterAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZN14UnityAnalytics29OnSceneLoadedAfterAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __Z27setPxVehicleChassisDataMMOIPN5physx20PxVehicleChassisDataENS_6PxVec3E: __Z27setPxVehicleChassisDataMMOIPN5physx20PxVehicleChassisDataENS_6PxVec3E, _wcslen: _wcslen, __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12ImmediatePtrI10GameObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx7NpScene14getTaskManagerEv: __ZN5physx7NpScene14getTaskManagerEv, __ZN5physx2Gu17pcmContactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu17pcmContactBoxMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN9Transform8TransferI14SafeBinaryReadEEvRT_: __ZN9Transform8TransferI14SafeBinaryReadEEvRT_, __Z38Register_UnityEngine_AudioClip_GetDatav: __Z38Register_UnityEngine_AudioClip_GetDatav, __Z53ParticleSystem_CollisionModule_CUSTOM_GetCollidesWithP12Il2CppObject: __Z53ParticleSystem_CollisionModule_CUSTOM_GetCollidesWithP12Il2CppObject, __ZN19SkinnedMeshRenderer19GetOptBonesWritableEv: __ZN19SkinnedMeshRenderer19GetOptBonesWritableEv, __Z47Register_UnityEngine_SpringJoint2D_set_distancev: __Z47Register_UnityEngine_SpringJoint2D_set_distancev, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z12pqHeapDeleteP13PriorityQHeapi: __Z12pqHeapDeleteP13PriorityQHeapi, __ZNSt3__215__time_get_tempIwEC2EPKc: __ZNSt3__215__time_get_tempIwEC2EPKc, _UNITY_png_handle_tRNS: _UNITY_png_handle_tRNS, __ZN17AudioChorusFilterC2E10MemLabelId18ObjectCreationMode: __ZN17AudioChorusFilterC2E10MemLabelId18ObjectCreationMode, __Z36RenderTexture_Get_Custom_PropEnabledv: __Z36RenderTexture_Get_Custom_PropEnabledv, __ZNK5physx2Sc5Scene26getNbContactDataBlocksUsedEv: __ZNK5physx2Sc5Scene26getNbContactDataBlocksUsedEv, __Z48Register_UnityEngine_ParticleEmitter_get_maxSizev: __Z48Register_UnityEngine_ParticleEmitter_get_maxSizev, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6xsgetnEPwi, __ZN4FMOD7Channel12setFrequencyEf: __ZN4FMOD7Channel12setFrequencyEf, __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferI5RectTIfEEEvRT_PKc17TransferMetaFlags, __ZN8Material20SetCustomRenderQueueEi: __ZN8Material20SetCustomRenderQueueEi, __Z46UnityWebRequest_Get_Custom_PropDownloadedBytesP12Il2CppObject: __Z46UnityWebRequest_Get_Custom_PropDownloadedBytesP12Il2CppObject, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN11b2EdgeShape3SetERK6b2Vec2S2_: __ZN11b2EdgeShape3SetERK6b2Vec2S2_, __ZN4gles17UpdateStencilMaskER15DeviceStateGLESPK22DeviceStencilStateGLESh: __ZN4gles17UpdateStencilMaskER15DeviceStateGLESPK22DeviceStencilStateGLESh, __ZN5physx6shdfnd5ArrayIPNS_20PxProfileZoneHandlerENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_20PxProfileZoneHandlerENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZThn340_N17BillboardRenderer15OnBoundsChangedEv: __ZThn340_N17BillboardRenderer15OnBoundsChangedEv, __ZNSt3__214collate_bynameIcEC2EPKcj: __ZNSt3__214collate_bynameIcEC2EPKcj, __Z42InvalidateStateHashesOnMaterialsWithShaderP6Shader: __Z42InvalidateStateHashesOnMaterialsWithShaderP6Shader, __ZN5physx2Cm17FreeListAllocator9getQWSizeEj: __ZN5physx2Cm17FreeListAllocator9getQWSizeEj, __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN9Behaviour12CleanupClassEv: __ZN9Behaviour12CleanupClassEv, __ZN5physx2Sc5SceneC2ERKNS_11PxSceneDescERNS_2Cm13EventProfilerE: __ZN5physx2Sc5SceneC2ERKNS_11PxSceneDescERNS_2Cm13EventProfilerE, __Z38Register_UnityEngine_Camera_get_aspectv: __Z38Register_UnityEngine_Camera_get_aspectv, __ZN14PhysicMaterial13SetBouncinessEf: __ZN14PhysicMaterial13SetBouncinessEf, __Z12WeldVerticesRK17WeldVerticesInputR18WeldVerticesOutput: __Z12WeldVerticesRK17WeldVerticesInputR18WeldVerticesOutput, __Z44TerrainData_Set_Custom_PropWavingGrassAmountP12Il2CppObjectf: __Z44TerrainData_Set_Custom_PropWavingGrassAmountP12Il2CppObjectf, __ZN9GfxDevice29GetNativeRenderSurfacePointerEP17RenderSurfaceBase: __ZN9GfxDevice29GetNativeRenderSurfacePointerEP17RenderSurfaceBase, __ZN8Animator13BatchedFKPassERK13dynamic_arrayI11DirectorJobLj8EE: __ZN8Animator13BatchedFKPassERK13dynamic_arrayI11DirectorJobLj8EE, __Z31Input_Get_Custom_PropAnyKeyDownv: __Z31Input_Get_Custom_PropAnyKeyDownv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z45Register_UnityEngine_Mathf_LinearToGammaSpacev: __Z45Register_UnityEngine_Mathf_LinearToGammaSpacev, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXMultiplierv, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayIN10GameObject13ComponentPairELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId, __ZN5physx11HullLibrary11ComputeHullEjPKfRNS_11PHullResultEjff: __ZN5physx11HullLibrary11ComputeHullEjPKfRNS_11PHullResultEjff, __ZN15TerrainCollider12SetIsTriggerEb: __ZN15TerrainCollider12SetIsTriggerEb, __Z37Camera_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject: __Z37Camera_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject, __ZN4FMOD13ChannelGroupID2Ev: __ZN4FMOD13ChannelGroupID2Ev, __ZN14HeightMeshData8TransferI14SafeBinaryReadEEvRT_: __ZN14HeightMeshData8TransferI14SafeBinaryReadEEvRT_, __ZN13TranslateGLES24InitTextureFormat2FormatERK12GraphicsCaps: __ZN13TranslateGLES24InitTextureFormat2FormatERK12GraphicsCaps, __ZN5physx2Sc5Scene11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sc5Scene11shiftOriginERKNS_6PxVec3E, __Znwj: __Znwj, __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorI13dynamic_arrayI5PlaneLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE: __ZN11DynamicMesh9ClipPolysERKNSt3__26vectorI13dynamic_arrayI5PlaneLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE, __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object: __ZN9Scripting31ConnectScriptingWrapperToObjectEP12Il2CppObjectP6Object, __ZN4FMOD7SystemI16createSoundGroupEPKcPPNS_10SoundGroupE: __ZN4FMOD7SystemI16createSoundGroupEPKcPPNS_10SoundGroupE, __ZNK21UnityAnalyticsManager26GetTypeInfoVirtualInternalEv: __ZNK21UnityAnalyticsManager26GetTypeInfoVirtualInternalEv, __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE: __ZN5physx2Gu18intersectSphereBoxERKNS0_6SphereERKNS0_3BoxE, __ZNK9GfxDevice14GetBufferCountE14GfxBufferLabel15GfxBufferTarget: __ZNK9GfxDevice14GetBufferCountE14GfxBufferLabel15GfxBufferTarget, __Z55Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshv: __Z55Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshv, __Z32Animator_CUSTOM_SetIntegerStringP12Il2CppObjectP12Il2CppStringi: __Z32Animator_CUSTOM_SetIntegerStringP12Il2CppObjectP12Il2CppStringi, __ZN15SerializeTraitsIN17ProceduralTexture17TextureParametersEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN17ProceduralTexture17TextureParametersEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZN19SkinnedMeshRenderer8SkinMeshEP12SkinMeshInfobR9GfxDeviceP22GeometryJobInstructionRi: __ZN19SkinnedMeshRenderer8SkinMeshEP12SkinMeshInfobR9GfxDeviceP22GeometryJobInstructionRi, __ZN5physx21PxcCacheLocalContactsENS_14PxGeometryType4EnumES1_RNS_18PxcNpThreadContextERNS_10PxcNpCacheERKNS_11PxTransformES8_fPFbRKNS_2Gu13GeometryUnionESC_S8_S8_RKfS5_RNS9_13ContactBufferEESC_SC_: __ZN5physx21PxcCacheLocalContactsENS_14PxGeometryType4EnumES1_RNS_18PxcNpThreadContextERNS_10PxcNpCacheERKNS_11PxTransformES8_fPFbRKNS_2Gu13GeometryUnionESC_S8_S8_RKfS5_RNS9_13ContactBufferEESC_SC_, __ZNK10SampleClip17CalculateFMODModeEv: __ZNK10SampleClip17CalculateFMODModeEv, _psh_blues_snap_stem: _psh_blues_snap_stem, __ZNSt3__227__insertion_sort_incompleteIR12RaycastHit2DPS1_EEbT0_S4_T_: __ZNSt3__227__insertion_sort_incompleteIR12RaycastHit2DPS1_EEbT0_S4_T_, __Z41GUIUtility_CUSTOM_Internal_GetDefaultSkini: __Z41GUIUtility_CUSTOM_Internal_GetDefaultSkini, __ZNK5physx2Gu15HeightFieldUtil27getSmoothNormalAtShapePointEff: __ZNK5physx2Gu15HeightFieldUtil27getSmoothNormalAtShapePointEff, __Z44setPxVehicleWheelsSimData_ThresholdLongSpeedPN5physx22PxVehicleWheelsSimDataEf: __Z44setPxVehicleWheelsSimData_ThresholdLongSpeedPN5physx22PxVehicleWheelsSimDataEf, __Z59Register_UnityEngine_LightProbeProxyVolume_set_probeDensityv: __Z59Register_UnityEngine_LightProbeProxyVolume_set_probeDensityv, __ZN14PhysicsManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14PhysicsManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx3Scb5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj: __ZNK5physx3Scb5Scene20getBroadPhaseRegionsEPNS_22PxBroadPhaseRegionInfoEjj, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags, __ZN11b2RopeJoint4DumpEv: __ZN11b2RopeJoint4DumpEv, __ZN17AnimationPlayable8OwnAssetEP11NamedObject: __ZN17AnimationPlayable8OwnAssetEP11NamedObject, __ZN14RenderSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14RenderSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z49AnimationLayerMixerPlayable_CUSTOM_InternalCreateR9HPlayable: __Z49AnimationLayerMixerPlayable_CUSTOM_InternalCreateR9HPlayable, __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12AudioManager22GetScriptBufferManagerEv: __ZN12AudioManager22GetScriptBufferManagerEv, __ZN7SubMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7SubMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _cf2_hintmask_isValid: _cf2_hintmask_isValid, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z56Register_UnityEngine_RenderSettings_get_fogStartDistancev: __Z56Register_UnityEngine_RenderSettings_get_fogStartDistancev, __ZNK5physx2Sc9ClothCore25getNbSelfCollisionIndicesEv: __ZNK5physx2Sc9ClothCore25getNbSelfCollisionIndicesEv, __Z38AndroidJNI_CUSTOM_GetFloatArrayElement13Il2Cpp_IntPtri: __Z38AndroidJNI_CUSTOM_GetFloatArrayElement13Il2Cpp_IntPtri, __ZN23UnityPurchasingSettings5ResetEv: __ZN23UnityPurchasingSettings5ResetEv, __Z21TransferBlobSerializeIN7mecanim9animation18ControllerConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ControllerConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_, __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_SetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray: __Z59HumanPoseHandler_CUSTOM_INTERNAL_CALL_Internal_SetHumanPoseP12Il2CppObjectR8Vector3fR11QuaternionfP11Il2CppArray, __Z75Register_UnityEngine_ParticleSystem_ShapeModule_GetSphericalDirectionAmountv: __Z75Register_UnityEngine_ParticleSystem_ShapeModule_GetSphericalDirectionAmountv, __ZNSt3__218__time_get_storageIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__218__time_get_storageIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z47AudioSettings_Get_Custom_PropDriverCapabilitiesv: __Z47AudioSettings_Get_Custom_PropDriverCapabilitiesv, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZNK15FrictionJoint2D26GetTypeInfoVirtualInternalEv: __ZNK15FrictionJoint2D26GetTypeInfoVirtualInternalEv, __ZN5Unity10HingeJoint15ThreadedCleanupEv: __ZN5Unity10HingeJoint15ThreadedCleanupEv, __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getRigidBodyFlagsEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getRigidBodyFlagsEv, __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15QualitySettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN12PhysXRaycast10RaycastAllERK3Rayfi23QueryTriggerInteractionR13dynamic_arrayI10RaycastHitLj4EE: __ZN12PhysXRaycast10RaycastAllERK3Rayfi23QueryTriggerInteractionR13dynamic_arrayI10RaycastHitLj4EE, __Z36AudioMixer_CUSTOM_FindMatchingGroupsP12Il2CppObjectP12Il2CppString: __Z36AudioMixer_CUSTOM_FindMatchingGroupsP12Il2CppObjectP12Il2CppString, __ZN4crnd5crc16EPKvjt: __ZN4crnd5crc16EPKvjt, __ZN2UI6Canvas22GetOrderOverrideCanvasEv: __ZN2UI6Canvas22GetOrderOverrideCanvasEv, __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode: __ZN17PersistentManager10ReadObjectEi17AwakeFromLoadMode, __ZNK17PhysicsMaterial2D26GetTypeInfoVirtualInternalEv: __ZNK17PhysicsMaterial2D26GetTypeInfoVirtualInternalEv, __Z13ReadFileCacheR15CacheReaderBasePvjj: __Z13ReadFileCacheR15CacheReaderBasePvjj, __ZN5physx17PxcNpMemBlockPoolD2Ev: __ZN5physx17PxcNpMemBlockPoolD2Ev, __ZNSt3__26locale5__imp12install_fromINS_7collateIcEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7collateIcEEEEvRKS1_, __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_: __ZNSt3__26__sortIR15ReflProbeSorterPP15ReflectionProbeEEvT0_S6_T_, __ZNSt3__28messagesIcEC2Ej: __ZNSt3__28messagesIcEC2Ej, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj44ENS_22PxRepXPropertyAccessorILj44ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj44ENS_22PxRepXPropertyAccessorILj44ES4_ffEEEEvRKT0_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj, _start_pass_prep: _start_pass_prep, _UNITY_png_get_io_chunk_type: _UNITY_png_get_io_chunk_type, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN7Terrain24SetTreeLODBiasMultiplierEf: __ZN7Terrain24SetTreeLODBiasMultiplierEf, __Z28getPxParticleBase_RestOffsetPKN5physx14PxParticleBaseE: __Z28getPxParticleBase_RestOffsetPKN5physx14PxParticleBaseE, __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN2UI14CanvasRenderer11GetMaterialEi: __ZN2UI14CanvasRenderer11GetMaterialEi, __Z63Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawCursorv: __Z63Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_DrawCursorv, __ZN14ParticleSystem23VirtualRedirectTransferER14SafeBinaryRead: __ZN14ParticleSystem23VirtualRedirectTransferER14SafeBinaryRead, __ZN8Collider20ClosestPointOnBoundsERK8Vector3fRS0_Rf: __ZN8Collider20ClosestPointOnBoundsERK8Vector3fRS0_Rf, __ZNK20PxsAtomIntegrateTask7getNameEv: __ZNK20PxsAtomIntegrateTask7getNameEv, __Z62TerrainData_CUSTOM_Internal_GetMinimumDetailResolutionPerPatchv: __Z62TerrainData_CUSTOM_Internal_GetMinimumDetailResolutionPerPatchv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E, __ZNK13GfxDeviceGLES14IsShaderActiveE10ShaderType: __ZNK13GfxDeviceGLES14IsShaderActiveE10ShaderType, __ZN10TagManager15ThreadedCleanupEv: __ZN10TagManager15ThreadedCleanupEv, __ZN11RadixSorter4SortEPjjb: __ZN11RadixSorter4SortEPjjb, __Z47Register_UnityEngine_CapsuleCollider_get_heightv: __Z47Register_UnityEngine_CapsuleCollider_get_heightv, __ZN19CullingGroupManager18RemoveCullingGroupEP12CullingGroup: __ZN19CullingGroupManager18RemoveCullingGroupEP12CullingGroup, _ioctl: _ioctl, __ZN4FMOD7SystemI19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS: __ZN4FMOD7SystemI19getAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS, __ZN7Texture16CheckConsistencyEv: __ZN7Texture16CheckConsistencyEv, __ZNKSt3__217moneypunct_bynameIwLb0EE16do_decimal_pointEv: __ZNKSt3__217moneypunct_bynameIwLb0EE16do_decimal_pointEv, __ZN13UnityProfiler13UpdateEnabledEv: __ZN13UnityProfiler13UpdateEnabledEv, __ZN15TextureTFMethodD2Ev: __ZN15TextureTFMethodD2Ev, __Z51Register_UnityEngine_CanvasRenderer_SetAlphaTexturev: __Z51Register_UnityEngine_CanvasRenderer_SetAlphaTexturev, __ZN11Rigidbody2D17SetFreezeRotationEb: __ZN11Rigidbody2D17SetFreezeRotationEb, __ZNK14MemoryProfiler22GetMemLabelAllocationsER13dynamic_arrayINSt3__24pairIijEELj4EEPKS0_IiLj4EE: __ZNK14MemoryProfiler22GetMemLabelAllocationsER13dynamic_arrayINSt3__24pairIijEELj4EEPKS0_IiLj4EE, __Z36BillboardAsset_Get_Custom_PropBottomP12Il2CppObject: __Z36BillboardAsset_Get_Custom_PropBottomP12Il2CppObject, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEPKc, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveDynDataEE8pushNameEPKc, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpClothEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_7NpClothEEEEEE15growAndPushBackERKS2_, __ZN11UnityEngine7Connect14RemoteSettings7SetJSONER8JSONRead: __ZN11UnityEngine7Connect14RemoteSettings7SetJSONER8JSONRead, __ZN2UI6Canvas15SetPixelPerfectEb: __ZN2UI6Canvas15SetPixelPerfectEb, __ZN7mecanim12statemachine21GetTransitionConstantEPKNS0_20StateMachineConstantEPKNS0_18StateMachineMemoryE: __ZN7mecanim12statemachine21GetTransitionConstantEPKNS0_20StateMachineConstantEPKNS0_18StateMachineMemoryE, __Z26SkinVerticesGenericMathLibILi2ELb1ELb1EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi2ELb1ELb1EEvPKhiiiiPhiPKvS4_, __Z27getPxCloth_ConcreteTypeNamePKN5physx7PxClothE: __Z27getPxCloth_ConcreteTypeNamePKN5physx7PxClothE, __ZN5physx3Cct15ObstacleContext14updateObstacleEjRKNS_10PxObstacleE: __ZN5physx3Cct15ObstacleContext14updateObstacleEjRKNS_10PxObstacleE, __ZN12_GLOBAL__N_117ConnectionManager11isConnectedEv: __ZN12_GLOBAL__N_117ConnectionManager11isConnectedEv, __ZN21InheritVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21InheritVelocityModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx26resetVehicleToleranceScaleEv: __ZN5physx26resetVehicleToleranceScaleEv, __ZN12HandlerChain11CreateAsDirER13FileEntryData: __ZN12HandlerChain11CreateAsDirER13FileEntryData, __ZN5Umbra5Query6deinitEv: __ZN5Umbra5Query6deinitEv, __ZN12TreeDatabaseC2ER11TerrainData: __ZN12TreeDatabaseC2ER11TerrainData, __ZN5physx8debugger15ForwardingArrayIPNS0_4comm20PvdConnectionHandlerEED0Ev: __ZN5physx8debugger15ForwardingArrayIPNS0_4comm20PvdConnectionHandlerEED0Ev, __Z54Register_UnityEngine_Physics2D_set_maxLinearCorrectionv: __Z54Register_UnityEngine_Physics2D_set_maxLinearCorrectionv, __Z18Transfer_BlittableI14SafeBinaryReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getFactoryEv, __ZNKSt3__210moneypunctIcLb0EE11curr_symbolEv: __ZNKSt3__210moneypunctIcLb0EE11curr_symbolEv, _UNITY_FT_Bitmap_Copy: _UNITY_FT_Bitmap_Copy, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE17getDominanceGroupEv, __ZNK10Effector2D26GetTypeInfoVirtualInternalEv: __ZNK10Effector2D26GetTypeInfoVirtualInternalEv, __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f: __ZN21BillboardBatchManager24AutoBillboardShaderProps5ApplyEbRK10Matrix4x4fRK8Vector3f, __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode: __ZN10GameObjectC2E10MemLabelId18ObjectCreationMode, __Z22GetTextureFormatString13TextureFormat: __Z22GetTextureFormatString13TextureFormat, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15PointEffector2D8TransferI14SafeBinaryReadEEvRT_: __ZN15PointEffector2D8TransferI14SafeBinaryReadEEvRT_, __Z61Register_UnityEngine_ParticleSystem_TrailModule_SetWorldSpacev: __Z61Register_UnityEngine_ParticleSystem_TrailModule_SetWorldSpacev, __Z18Transfer_BlittableI14SafeBinaryReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx14NpRigidDynamic17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx14NpRigidDynamic17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN14SpriteRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZNK5Umbra4Tome12getTileCountEv: __ZNK5Umbra4Tome12getTileCountEv, __ZN5physx9NpPhysicsD2Ev: __ZN5physx9NpPhysicsD2Ev, __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z38Collider_Get_Custom_PropSharedMaterialP12Il2CppObject: __Z38Collider_Get_Custom_PropSharedMaterialP12Il2CppObject, __ZNK6Object26GetTypeInfoVirtualInternalEv: __ZNK6Object26GetTypeInfoVirtualInternalEv, __ZNK8Animator28WarningStringIfLoggingActiveEPKc: __ZNK8Animator28WarningStringIfLoggingActiveEPKc, __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_: __ZN11UnityEngine15CloudWebService16WWWRestHeaderMap3setERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEESA_, __Z32AndroidJNI_CUSTOM_CallByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z32AndroidJNI_CUSTOM_CallByteMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN4FMOD7Channel12setLoopCountEi: __ZN4FMOD7Channel12setLoopCountEi, __Z32setPxParticleBase_StaticFrictionPN5physx14PxParticleBaseEf: __Z32setPxParticleBase_StaticFrictionPN5physx14PxParticleBaseEf, __ZN5physx3Scb13ObjectTracker17scheduleForUpdateERNS0_4BaseE: __ZN5physx3Scb13ObjectTracker17scheduleForUpdateERNS0_4BaseE, __ZN10BlendShape8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10BlendShape8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags, __ZN12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i: __ZN12_GLOBAL__N_110Connection11reportErrorEN5physx11PxErrorCode4EnumEPKcS5_i, __Z63ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossMultiplierP12Il2CppObject: __Z63ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossMultiplierP12Il2CppObject, __Z16GetMemoryManagerv: __Z16GetMemoryManagerv, __Z40TextGenerator_Get_Custom_PropVertexCountP12Il2CppObject: __Z40TextGenerator_Get_Custom_PropVertexCountP12Il2CppObject, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15set_deleted_keyERKS9_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15set_deleted_keyERKS9_, __Z36QualitySettings_CUSTOM_IncreaseLevelh: __Z36QualitySettings_CUSTOM_IncreaseLevelh, _fma: _fma, __ZN11UnityEngine9Animation28GenericAnimationBindingCache5ClearER13dynamic_arrayIPNS0_23CachedComponentBindingsELj4EE: __ZN11UnityEngine9Animation28GenericAnimationBindingCache5ClearER13dynamic_arrayIPNS0_23CachedComponentBindingsELj4EE, __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipUP12Il2CppObject: __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipUP12Il2CppObject, __Z52Register_UnityEngine_LODGroup_get_animateCrossFadingv: __Z52Register_UnityEngine_LODGroup_get_animateCrossFadingv, __ZN13PhysicsModule16GetProfilerStatsER12PhysicsStats: __ZN13PhysicsModule16GetProfilerStatsER12PhysicsStats, __Z51Register_UnityEngine_BuoyancyEffector2D_set_densityv: __Z51Register_UnityEngine_BuoyancyEffector2D_set_densityv, __Z20CalculateRangeBoundsfPfPKfS1_S1_: __Z20CalculateRangeBoundsfPfPKfS1_S1_, __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE6resizeEjRKc: __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE6resizeEjRKc, __ZN6Camera26CalculateMatrixShaderPropsERK10Matrix4x4fRS0_S3_: __ZN6Camera26CalculateMatrixShaderPropsERK10Matrix4x4fRS0_S3_, __Z25ExecuteOneJobInMainThreadv: __Z25ExecuteOneJobInMainThreadv, __ZN5Light8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Light8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14BatchAllocatorC2Ev: __ZN14BatchAllocatorC2Ev, __Z52Register_UnityEngine_AndroidJNI_SetStaticDoubleFieldv: __Z52Register_UnityEngine_AndroidJNI_SetStaticDoubleFieldv, __Z25setPxVehicleWheelDataMMOIPN5physx18PxVehicleWheelDataEf: __Z25setPxVehicleWheelDataMMOIPN5physx18PxVehicleWheelDataEf, __ZN10systeminfo25GetDeviceUniqueIdentifierEv: __ZN10systeminfo25GetDeviceUniqueIdentifierEv, __ZN14TimerQueryGLES7MeasureEv: __ZN14TimerQueryGLES7MeasureEv, __Z85Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MoveGameObjectToScenev: __Z85Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_MoveGameObjectToScenev, __ZThn4_N11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE: __ZThn4_N11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE, __Z44Terrain_Set_Custom_PropTreeLODBiasMultiplierP12Il2CppObjectf: __Z44Terrain_Set_Custom_PropTreeLODBiasMultiplierP12Il2CppObjectf, __Z46ReflectionProbe_Get_Custom_PropTimeSlicingModeP12Il2CppObject: __Z46ReflectionProbe_Get_Custom_PropTimeSlicingModeP12Il2CppObject, __Z18Transfer_BlittableI14SafeBinaryReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD7Channel15get3DAttributesEP11FMOD_VECTORS2_: __ZN4FMOD7Channel15get3DAttributesEP11FMOD_VECTORS2_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN15AudioEchoFilter5ResetEv: __ZN15AudioEchoFilter5ResetEv, __Z33Cloth_Get_Custom_PropCoefficientsP12Il2CppObject: __Z33Cloth_Get_Custom_PropCoefficientsP12Il2CppObject, __ZN17PersistentManager14LoadFileStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_24TransferInstructionFlagsii: __ZN17PersistentManager14LoadFileStreamERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_24TransferInstructionFlagsii, __ZN9Heightmap8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Heightmap8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx5PxMaxIjEET_S1_S1_: __ZN5physx5PxMaxIjEET_S1_S1_, __Z46Register_UnityEngine_Application_HasProLicensev: __Z46Register_UnityEngine_Application_HasProLicensev, __ZN19TouchPhaseEmulation11InitTouchesEv: __ZN19TouchPhaseEmulation11InitTouchesEv, __Z53Register_UnityEngine_GUIClip_INTERNAL_get_visibleRectv: __Z53Register_UnityEngine_GUIClip_INTERNAL_get_visibleRectv, __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b: __ZN12VRGfxHelpers17BlitTextureRegionEP13RenderTexture8Vector2fS2_S1_S2_S2_b, __ZN5physx13GuMeshFactory13addConvexMeshEPNS_2Gu10ConvexMeshEb: __ZN5physx13GuMeshFactory13addConvexMeshEPNS_2Gu10ConvexMeshEb, __ZN5physx2Sc10NPhaseCore21filterRbCollisionPairERKNS0_8ShapeSimES4_PNS0_10FilterPairE: __ZN5physx2Sc10NPhaseCore21filterRbCollisionPairERKNS0_8ShapeSimES4_PNS0_10FilterPairE, __ZN13TrailRenderer5ClearEv: __ZN13TrailRenderer5ClearEv, __Z49Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK13Vector2fIcallS1_fP11Il2CppArrayiff: __Z49Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK13Vector2fIcallS1_fP11Il2CppArrayiff, __ZL54CombineLocalShadowCasterCullignIndexListsAndDestroyJobP25LocalShadowCullingJobData: __ZL54CombineLocalShadowCasterCullignIndexListsAndDestroyJobP25LocalShadowCullingJobData, _if_nametoindex: _if_nametoindex, __ZN9Rigidbody7SetMassEf: __ZN9Rigidbody7SetMassEf, __ZN13ComputeShaderC2E10MemLabelId18ObjectCreationMode: __ZN13ComputeShaderC2E10MemLabelId18ObjectCreationMode, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z28AllocateNextLowestInstanceIDv: __Z28AllocateNextLowestInstanceIDv, __Z45Register_UnityEngine_AndroidJNI_GetFloatFieldv: __Z45Register_UnityEngine_AndroidJNI_GetFloatFieldv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj601ENS_22PxRepXPropertyAccessorILj601ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj601ENS_22PxRepXPropertyAccessorILj601ES4_ffEEEEvRKT0_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignERKS5_, __ZN5Umbra12QueryContext12allocWorkMemEjb: __ZN5Umbra12QueryContext12allocWorkMemEjb, __ZN4FMOD13ChannelGroupI4stopEv: __ZN4FMOD13ChannelGroupI4stopEv, __ZL22PrepareMeshRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext: __ZL22PrepareMeshRenderNodesILb0EEvR35RenderNodeQueuePrepareThreadContext, __ZN9Scripting40CreateScriptingArrayFromScriptingObjectsEPP12Il2CppObjectiP11Il2CppClass: __ZN9Scripting40CreateScriptingArrayFromScriptingObjectsEPP12Il2CppObjectiP11Il2CppClass, __Z50AssetBundle_CUSTOM_LoadAssetWithSubAssets_InternalP12Il2CppObjectP12Il2CppStringS0_: __Z50AssetBundle_CUSTOM_LoadAssetWithSubAssets_InternalP12Il2CppObjectP12Il2CppStringS0_, __Z24RegisterStrippedTypeInfoI16GraphicsSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI16GraphicsSettingsEviPKcS2_, __ZThn8_N5physx19TriangleMeshBuilderD0Ev: __ZThn8_N5physx19TriangleMeshBuilderD0Ev, __ZN4Halo15ThreadedCleanupEv: __ZN4Halo15ThreadedCleanupEv, __ZNKSt3__217moneypunct_bynameIwLb1EE14do_curr_symbolEv: __ZNKSt3__217moneypunct_bynameIwLb1EE14do_curr_symbolEv, __Z16DecodeColorBlockPjRK11DXTColBlockiPKj: __Z16DecodeColorBlockPjRK11DXTColBlockiPKj, __ZN4gles15UpdateColorMaskER15DeviceStateGLESPK20DeviceBlendStateGLESj: __ZN4gles15UpdateColorMaskER15DeviceStateGLESPK20DeviceBlendStateGLESj, __ZNK12MeshCollider16GetNonSharedMeshEv: __ZNK12MeshCollider16GetNonSharedMeshEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags, __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_get_sizev: __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_get_sizev, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN16DeveloperConsole16AppendNewEntriesEv: __ZN16DeveloperConsole16AppendNewEntriesEv, __ZNKSt3__210moneypunctIwLb0EE16do_thousands_sepEv: __ZNKSt3__210moneypunctIwLb0EE16do_thousands_sepEv, _ft_raster1_init: _ft_raster1_init, _UNITY_FT_MulDiv_No_Round: _UNITY_FT_MulDiv_No_Round, __ZN4Tree15InitializeClassEv: __ZN4Tree15InitializeClassEv, __ZN5Unity17ConfigurableJoint23SetAngularYZLimitSpringERK20SoftJointLimitSpring: __ZN5Unity17ConfigurableJoint23SetAngularYZLimitSpringERK20SoftJointLimitSpring, __ZN26AnimatorControllerPlayable11DerivesFromEP11Il2CppClass: __ZN26AnimatorControllerPlayable11DerivesFromEP11Il2CppClass, __ZN18AudioMixerSnapshot15ThreadedCleanupEv: __ZN18AudioMixerSnapshot15ThreadedCleanupEv, __ZN12HingeJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN12HingeJoint2DC2E10MemLabelId18ObjectCreationMode, __ZN13SpeedTreeWind16SBranchWindLevelC2Ev: __ZN13SpeedTreeWind16SBranchWindLevelC2Ev, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIwEE, __Z72Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_GetRayIntersectionv: __Z72Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_GetRayIntersectionv, __Z31setPxCloth_SimulationFilterDataPN5physx7PxClothERKNS_12PxFilterDataE: __Z31setPxCloth_SimulationFilterDataPN5physx7PxClothERKNS_12PxFilterDataE, __Z26Input_CUSTOM_GetKeyDownInti: __Z26Input_CUSTOM_GetKeyDownInti, __ZN12LODFadeCacheC2ER13BatchRenderer: __ZN12LODFadeCacheC2ER13BatchRenderer, __ZN4FMOD6System10getVersionEPj: __ZN4FMOD6System10getVersionEPj, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE10deallocateEv, __Z36GameObject_Get_Custom_PropActiveSelfP12Il2CppObject: __Z36GameObject_Get_Custom_PropActiveSelfP12Il2CppObject, __ZN4FMOD8ChannelI9setPausedEb: __ZN4FMOD8ChannelI9setPausedEb, __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot: __ZN10AudioMixer16GetSnapshotIndexERK18AudioMixerSnapshot, __ZN5physx7NpScene5solveEfPNS_10PxBaseTaskEPvjb: __ZN5physx7NpScene5solveEfPNS_10PxBaseTaskEPvjb, __ZN14SafeBinaryRead16IsCurrentVersionEv: __ZN14SafeBinaryRead16IsCurrentVersionEv, __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetEnabledv: __Z70Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetEnabledv, __Z22WWW_Get_Custom_PropUrlP12Il2CppObject: __Z22WWW_Get_Custom_PropUrlP12Il2CppObject, __ZN8Gradient19InitializeOptimizedER17OptimizedGradient: __ZN8Gradient19InitializeOptimizedER17OptimizedGradient, _valloc: _valloc, __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv: __ZN5physx17PxcNpMemBlockPool18swapNpCacheStreamsEv, __ZN9ShaderLab16SerializedShader8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab16SerializedShader8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18ReflectionProbeJob3RunEv: __ZN18ReflectionProbeJob3RunEv, __Z40Register_UnityEngine_Animator_GetFloatIDv: __Z40Register_UnityEngine_Animator_GetFloatIDv, __ZN5physx10NpMaterial18setDynamicFrictionEf: __ZN5physx10NpMaterial18setDynamicFrictionEf, __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEEclILj536ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE12readPropertyIfEEbRT_, __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif: __ZL10RenderFaceR9GfxDeviceR18MaterialStateCacheP13RenderTextureiif, __Z36Light_Get_Custom_PropPixelLightCountv: __Z36Light_Get_Custom_PropPixelLightCountv, __Z12SetIVehiclesP9IVehicles: __Z12SetIVehiclesP9IVehicles, __ZN2UI11CanvasGroup22SendCanvasGroupChangedEv: __ZN2UI11CanvasGroup22SendCanvasGroupChangedEv, __ZN12b2BroadPhase10BufferMoveEi: __ZN12b2BroadPhase10BufferMoveEi, __Z24getPxScene_CpuDispatcherPKN5physx7PxSceneE: __Z24getPxScene_CpuDispatcherPKN5physx7PxSceneE, __ZN6Object24CalculateCachedTypeIndexEPS_: __ZN6Object24CalculateCachedTypeIndexEPS_, __ZN5physx2Sn20handleShapeMaterialsINS0_21RepXVisitorWriterBaseINS_7PxShapeEEEEEvRT_RKNS_24PxShapeMaterialsPropertyE: __ZN5physx2Sn20handleShapeMaterialsINS0_21RepXVisitorWriterBaseINS_7PxShapeEEEEEvRT_RKNS_24PxShapeMaterialsPropertyE, __ZN12_GLOBAL__N_111StreamOwner9readBytesEPhj: __ZN12_GLOBAL__N_111StreamOwner9readBytesEPhj, __Z28Gradient_Set_Custom_PropModeP12Il2CppObject12GradientMode: __Z28Gradient_Set_Custom_PropModeP12Il2CppObject12GradientMode, __Z51Register_UnityEngine_AI_NavMeshAgent_get_baseOffsetv: __Z51Register_UnityEngine_AI_NavMeshAgent_get_baseOffsetv, __ZN4FMOD6System19getRecordDriverInfoEiPciP9FMOD_GUID: __ZN4FMOD6System19getRecordDriverInfoEiPciP9FMOD_GUID, __ZN5physx2Sc21ArticulationJointCore20setSwingLimitEnabledEb: __ZN5physx2Sc21ArticulationJointCore20setSwingLimitEnabledEb, __Z18SkinGenericMathLibILi1ELb0ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi1ELb0ELb0EEvR12SkinMeshInfo, __ZNK8VRDevice17GetViewportForEyeE15StereoscopicEyeR5RectTIfE: __ZNK8VRDevice17GetViewportForEyeE15StereoscopicEyeR5RectTIfE, __ZN14DetailDatabase16CleanupPrototypeER15DetailPrototypeRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __ZN14DetailDatabase16CleanupPrototypeER15DetailPrototypeRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN8Renderer32GetAndAssignInstantiatedMaterialEib: __ZN8Renderer32GetAndAssignInstantiatedMaterialEib, __Z43Register_UnityEngine_GL_INTERNAL_CALL_Colorv: __Z43Register_UnityEngine_GL_INTERNAL_CALL_Colorv, __ZN23AllocationRootReference13SetObjectNameEPKc: __ZN23AllocationRootReference13SetObjectNameEPKc, __ZN16CompareSceneNameC2ERK8UnityStr: __ZN16CompareSceneNameC2ERK8UnityStr, __ZN11TrailModule8TransferI14SafeBinaryReadEEvRT_: __ZN11TrailModule8TransferI14SafeBinaryReadEEvRT_, __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_: __ZN13dynamic_arrayI8Vector3fLj4EEC2ERKS1_, __ZN10MonoScript10FindMethodEPKc: __ZN10MonoScript10FindMethodEPKc, __ZN20ArchiveStorageHeader7ReadAllER12FileAccessorRNS_6HeaderERNS_10BlocksInfoERNS_13DirectoryInfoE: __ZN20ArchiveStorageHeader7ReadAllER12FileAccessorRNS_6HeaderERNS_10BlocksInfoERNS_13DirectoryInfoE, __Z28Scene_CUSTOM_GetPathInternali: __Z28Scene_CUSTOM_GetPathInternali, __ZNK13TrailRenderer26GetTypeInfoVirtualInternalEv: __ZNK13TrailRenderer26GetTypeInfoVirtualInternalEv, __ZN15TerrainRenderer9ReloadAllEv: __ZN15TerrainRenderer9ReloadAllEv, __Z74Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneAtv: __Z74Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneAtv, _XXH64_hashFromCanonical: _XXH64_hashFromCanonical, __Z29scripting_class_instance_sizeP11Il2CppClass: __Z29scripting_class_instance_sizeP11Il2CppClass, __ZN5physx24PxDefaultMemoryInputDataD0Ev: __ZN5physx24PxDefaultMemoryInputDataD0Ev, __Z39VRStats_Get_Custom_PropGpuTimeLastFramev: __Z39VRStats_Get_Custom_PropGpuTimeLastFramev, __ZNK18PlayableController14GetBindingInfoER13dynamic_arrayIP14DirectorPlayerLj4EERS0_IP8PlayableLj4EERS0_IiLj4EE: __ZNK18PlayableController14GetBindingInfoER13dynamic_arrayIP14DirectorPlayerLj4EERS0_IP8PlayableLj4EERS0_IiLj4EE, __ZN5Umbra10Visibility16setOutputObjectsEPNS_9IndexListE: __ZN5Umbra10Visibility16setOutputObjectsEPNS_9IndexListE, __ZN11MatrixStack10MultMatrixERK10Matrix4x4f: __ZN11MatrixStack10MultMatrixERK10Matrix4x4f, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj91ENS_22PxRepXPropertyAccessorILj91ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj91ENS_22PxRepXPropertyAccessorILj91ES4_ffEEEEvRKT0_, __Z53AudioHighPassFilter_Get_Custom_PropHighpassResonanceQP12Il2CppObject: __Z53AudioHighPassFilter_Get_Custom_PropHighpassResonanceQP12Il2CppObject, __ZN9b2ContactC2EP9b2FixtureiS1_i: __ZN9b2ContactC2EP9b2FixtureiS1_i, __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii: __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeii, __ZNKSt3__25ctypeIwE5do_isEtw: __ZNKSt3__25ctypeIwE5do_isEtw, __Z32Compass_Get_Custom_PropTimestampP12Il2CppObject: __Z32Compass_Get_Custom_PropTimestampP12Il2CppObject, __ZN14ParticleSystem14BeginUpdateAllEv: __ZN14ParticleSystem14BeginUpdateAllEv, __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __Z31Profiler_Set_Custom_PropEnabledh: __Z31Profiler_Set_Custom_PropEnabledh, __ZNK5physx3Cct26CharacterControllerManager17onObstacleUpdatedEjPKNS_17PxObstacleContextE: __ZNK5physx3Cct26CharacterControllerManager17onObstacleUpdatedEjPKNS_17PxObstacleContextE, __ZN13ResourceImageD2Ev: __ZN13ResourceImageD2Ev, __ZN13TextRendering4Font13AwakeFromLoadE17AwakeFromLoadMode: __ZN13TextRendering4Font13AwakeFromLoadE17AwakeFromLoadMode, __Z53AndroidJNIHelper_CUSTOM_INTERNAL_CALL_CreateJavaProxyP12Il2CppObjectRPv: __Z53AndroidJNIHelper_CUSTOM_INTERNAL_CALL_CreateJavaProxyP12Il2CppObjectRPv, __ZN5physx26PxSerializerDefaultAdapterINS_12NpConstraintEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_12NpConstraintEED0Ev, __Z49Register_UnityEngine_PolygonCollider2D_get_pointsv: __Z49Register_UnityEngine_PolygonCollider2D_get_pointsv, __ZN5physx13PxsCCDContext9updateCCDEfPNS_10PxBaseTaskEb: __ZN5physx13PxsCCDContext9updateCCDEfPNS_10PxBaseTaskEb, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZNK5Umbra18ReceiverMaskBuffer18getCameraTransformEv: __ZNK5Umbra18ReceiverMaskBuffer18getCameraTransformEv, __Z19setPxD6Joint_MotionPN5physx9PxD6JointENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE: __Z19setPxD6Joint_MotionPN5physx9PxD6JointENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE, __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE16StaticInitializeES8_: __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE16StaticInitializeES8_, __ZN12TreeRenderer11RemoveTreesERK8Vector3ffi: __ZN12TreeRenderer11RemoveTreesERK8Vector3ffi, __Z55Register_UnityEngine_SystemInfo_get_graphicsShaderLevelv: __Z55Register_UnityEngine_SystemInfo_get_graphicsShaderLevelv, __ZNK9Transform21GetWorldToLocalMatrixEv: __ZNK9Transform21GetWorldToLocalMatrixEv, _unity_z_deflateBound: _unity_z_deflateBound, __ZN15ResourceManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15ResourceManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sc12MaterialCoreD2Ev: __ZN5physx2Sc12MaterialCoreD2Ev, __ZN13GfxDeviceNull25SetInvertProjectionMatrixEb: __ZN13GfxDeviceNull25SetInvertProjectionMatrixEb, __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z38AudioChorusFilter_Get_Custom_PropDelayP12Il2CppObject: __Z38AudioChorusFilter_Get_Custom_PropDelayP12Il2CppObject, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwERKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwERKS4_, __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZLimitSpringv: __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZLimitSpringv, __ZNK15DirectorManager16GetScriptMethodsEs: __ZNK15DirectorManager16GetScriptMethodsEs, __ZN21AudioDistortionFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN21AudioDistortionFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9Texture2D17UploadToGfxDeviceEv: __ZN9Texture2D17UploadToGfxDeviceEv, __Z48Register_UnityEngine_QualitySettings_set_lodBiasv: __Z48Register_UnityEngine_QualitySettings_set_lodBiasv, __Z30Shader_CUSTOM_IsKeywordEnabledP12Il2CppString: __Z30Shader_CUSTOM_IsKeywordEnabledP12Il2CppString, ___cxa_demangle: ___cxa_demangle, __ZN15ParticleEmitter14WriteParticlesEPK14SimpleParticlei: __ZN15ParticleEmitter14WriteParticlesEPK14SimpleParticlei, __ZNK18DownloadHandlerVFS9GetLengthEv: __ZNK18DownloadHandlerVFS9GetLengthEv, __ZNKSt3__210moneypunctIcLb0EE13do_neg_formatEv: __ZNKSt3__210moneypunctIcLb0EE13do_neg_formatEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN17PersistentManager24GetPartiallyLoadedObjectEi: __ZN17PersistentManager24GetPartiallyLoadedObjectEi, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4PPtrI11LightProbesE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI11LightProbesE8TransferI14SafeBinaryReadEEvRT_, __ZNK10__cxxabiv116__shim_type_info5noop1Ev: __ZNK10__cxxabiv116__shim_type_info5noop1Ev, __ZN5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEED0Ev, __Z19setPxRigidBody_MassPN5physx11PxRigidBodyEf: __Z19setPxRigidBody_MassPN5physx11PxRigidBodyEf, __Z54Register_UnityEngine_TerrainData_RemoveDetailPrototypev: __Z54Register_UnityEngine_TerrainData_RemoveDetailPrototypev, __Z66Register_UnityEngine_GeometryUtility_INTERNAL_CALL_CalculateBoundsv: __Z66Register_UnityEngine_GeometryUtility_INTERNAL_CALL_CalculateBoundsv, __Z37AndroidJNI_CUSTOM_SetCharArrayElement13Il2Cpp_IntPtrit: __Z37AndroidJNI_CUSTOM_SetCharArrayElement13Il2Cpp_IntPtrit, __Z45Playable_CUSTOM_INTERNAL_CALL_SetTimeInternalR9HPlayabled: __Z45Playable_CUSTOM_INTERNAL_CALL_SetTimeInternalR9HPlayabled, __ZNKSt3__210__time_put8__do_putEPwRS1_PK2tmcc: __ZNKSt3__210__time_put8__do_putEPwRS1_PK2tmcc, __ZN23ArchiveStorageConverter23InitializeTargetArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15CompressionTypej: __ZN23ArchiveStorageConverter23InitializeTargetArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15CompressionTypej, __Z53Register_UnityEngine_GameObject_GetComponentsInternalv: __Z53Register_UnityEngine_GameObject_GetComponentsInternalv, __ZN19AssetBundleManifest23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN19AssetBundleManifest23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14dtPathCorridor22optimizePathVisibilityEPKffPK14dtNavMeshQueryPK13dtQueryFilter: __ZN14dtPathCorridor22optimizePathVisibilityEPKffPK14dtNavMeshQueryPK13dtQueryFilter, __ZNK6Camera26CalculateAntiAliasingForRTEv: __ZNK6Camera26CalculateAntiAliasingForRTEv, __Z55Register_UnityEngine_Application_get_persistentDataPathv: __Z55Register_UnityEngine_Application_get_persistentDataPathv, __Z34Debug_CUSTOM_GetDiagnosticSwitchesP12Il2CppObject: __Z34Debug_CUSTOM_GetDiagnosticSwitchesP12Il2CppObject, _exp10l: _exp10l, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11attachShapeERNS_7PxShapeE, __ZN13TrailRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13TrailRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_: __ZL15GetIndexForNameRNSt3__23mapI8UnityStriNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_iEEEEEERS6_, __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_791kDidDeleteMesh4CallEPviR11MessageData: __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_791kDidDeleteMesh4CallEPviR11MessageData, __ZL23RegisterModuleICalls_VRv: __ZL23RegisterModuleICalls_VRv, __ZN23AnimationOffsetPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN23AnimationOffsetPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetYMultiplierv, __ZN7Joint2D14SetBreakTorqueEf: __ZN7Joint2D14SetBreakTorqueEf, __Z66ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceMultiplierP12Il2CppObject: __Z66ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceMultiplierP12Il2CppObject, __ZN5Umbra15CameraTransform15setMatrixFormatENS_12MatrixFormatE: __ZN5Umbra15CameraTransform15setMatrixFormatENS_12MatrixFormatE, __ZN9UdpSocket5CloseEv: __ZN9UdpSocket5CloseEv, __Z34Register_UnityEngine_GUI_get_depthv: __Z34Register_UnityEngine_GUI_get_depthv, __ZN5physx27PxsFluidParticleOpcodeCache5writeERtRKNS_9PxBounds3ERKNS0_18QuantizationParamsERKNS_2Gu13GeometryUnionEb: __ZN5physx27PxsFluidParticleOpcodeCache5writeERtRKNS_9PxBounds3ERKNS0_18QuantizationParamsERKNS_2Gu13GeometryUnionEb, __ZN17ProceduralTexture16ResetAlphaSourceEv: __ZN17ProceduralTexture16ResetAlphaSourceEv, __ZN10DynamicVBO14AllocateHandleEv: __ZN10DynamicVBO14AllocateHandleEv, _Round_To_Double_Grid: _Round_To_Double_Grid, __Z32getPxConstraint_ConcreteTypeNamePKN5physx12PxConstraintE: __Z32getPxConstraint_ConcreteTypeNamePKN5physx12PxConstraintE, __ZN9ShaderLab11ShaderState10SetProgramE10ShaderTypePNS_7ProgramEPK6Shader: __ZN9ShaderLab11ShaderState10SetProgramE10ShaderTypePNS_7ProgramEPK6Shader, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK8GUIStyle16GetGUIStyleStateER8GUIStatebbbb: __ZNK8GUIStyle16GetGUIStyleStateER8GUIStatebbbb, __ZN14DirectorPlayer7SetTimeEd: __ZN14DirectorPlayer7SetTimeEd, __ZNK3Ray14SqrDistToPointERK8Vector3f: __ZNK3Ray14SqrDistToPointERK8Vector3f, __ZN2UI14CanvasRenderer25UpdatePotentialMeshCountsEv: __ZN2UI14CanvasRenderer25UpdatePotentialMeshCountsEv, __ZNSt3__211__stdoutbufIcE5imbueERKNS_6localeE: __ZNSt3__211__stdoutbufIcE5imbueERKNS_6localeE, __ZN4FMOD12ChannelGroup8setPitchEf: __ZN4FMOD12ChannelGroup8setPitchEf, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13RenderingPathEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13RenderingPathEvRT_RT0_PKc17TransferMetaFlags, __ZN9b2Simplex9ReadCacheEPK14b2SimplexCachePK15b2DistanceProxyRK11b2TransformS5_S8_: __ZN9b2Simplex9ReadCacheEPK14b2SimplexCachePK15b2DistanceProxyRK11b2TransformS5_S8_, __ZNK13WheelCollider17HasActorRigidBodyEv: __ZNK13WheelCollider17HasActorRigidBodyEv, __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE16StaticInitializeEPv, __Z50Register_UnityEngine_Rigidbody_set_useConeFrictionv: __Z50Register_UnityEngine_Rigidbody_set_useConeFrictionv, __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE: __ZN5physx2Sc27ConstraintProjectionManager24addToPendingGroupUpdatesERNS0_13ConstraintSimE, __ZN5audio5mixer20GetGroupNameFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID: __ZN5audio5mixer20GetGroupNameFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID, __Z43UnityWebRequest_Get_Custom_PropResponseCodeP12Il2CppObject: __Z43UnityWebRequest_Get_Custom_PropResponseCodeP12Il2CppObject, __Z50Register_UnityEngine_LineRenderer_get_numPositionsv: __Z50Register_UnityEngine_LineRenderer_get_numPositionsv, __Z56Register_UnityEngine_GUIStyle_INTERNAL_get_contentOffsetv: __Z56Register_UnityEngine_GUIStyle_INTERNAL_get_contentOffsetv, __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_sizeCustomv: __Z66Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_sizeCustomv, __ZNSt13runtime_errorC2ERKS_: __ZNSt13runtime_errorC2ERKS_, __Z18Transfer_BlittableI9JSONWriteLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj650ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_: __ZN20ParticleSystemModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7NpScene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE: __ZN5physx7NpScene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE, __Z41Camera_Get_Custom_PropPreviewCullingLayerv: __Z41Camera_Get_Custom_PropPreviewCullingLayerv, __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalGetMethodv: __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalGetMethodv, __ZN6b2Body13CreateFixtureEPK7b2Shapef: __ZN6b2Body13CreateFixtureEPK7b2Shapef, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_ED2Ev, __ZN24ControllerFilterCallback6filterERKN5physx12PxControllerES3_: __ZN24ControllerFilterCallback6filterERKN5physx12PxControllerES3_, __Z64Register_UnityEngine_LightProbeProxyVolume_set_probePositionModev: __Z64Register_UnityEngine_LightProbeProxyVolume_set_probePositionModev, __ZN11Rigidbody2D12CleanupClassEv: __ZN11Rigidbody2D12CleanupClassEv, __Z13RegisterClassI13WheelColliderEvv: __Z13RegisterClassI13WheelColliderEvv, __Z44Register_UnityEngine_Animation_GetStateCountv: __Z44Register_UnityEngine_Animation_GetStateCountv, __ZN5Umbra9IndexListC2Ev: __ZN5Umbra9IndexListC2Ev, __ZN5physx14NpRigidDynamic18getKinematicTargetERNS_11PxTransformE: __ZN5physx14NpRigidDynamic18getKinematicTargetERNS_11PxTransformE, __ZN13GfxDeviceNull29RenderSurfaceStructMemorySizeEb: __ZN13GfxDeviceNull29RenderSurfaceStructMemorySizeEb, __Z36AudioSource_Set_Custom_PropMinVolumeP12Il2CppObjectf: __Z36AudioSource_Set_Custom_PropMinVolumeP12Il2CppObjectf, _tlsf_malloc: _tlsf_malloc, _tre_set_union: _tre_set_union, __ZN12LightManager11RemoveLightEP5Light: __ZN12LightManager11RemoveLightEP5Light, _truncf: _truncf, __ZNK5physx2Sc8ClothSim7getCoreEv: __ZNK5physx2Sc8ClothSim7getCoreEv, __Z18pqHeapNewPriorityQP9TESSallociPFiPvS1_E: __Z18pqHeapNewPriorityQP9TESSallociPFiPvS1_E, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation21BlendTreeNodeConstantEEEEEvRT_17TransferMetaFlags, __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb: __ZNSt3__214__scan_keywordINS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEPKNS_12basic_stringIcS3_NS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SE_SD_SD_RKT1_Rjb, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE25getRelativeLinearVelocityEv, __Z36Rigidbody_CUSTOM_INTERNAL_CALL_SleepP12Il2CppObject: __Z36Rigidbody_CUSTOM_INTERNAL_CALL_SleepP12Il2CppObject, __Z43setPxVehicleWheelsSimData_WheelCentreOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E: __Z43setPxVehicleWheelsSimData_WheelCentreOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E, _UNITY_FT_CeilFix: _UNITY_FT_CeilFix, __ZN21InheritVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj: __ZN21InheritVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjj, __ZN13AvatarBuilder23IsValidHumanDescriptionERK16HumanDescriptionRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEEb: __ZN13AvatarBuilder23IsValidHumanDescriptionERK16HumanDescriptionRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEEb, __ZN15FrictionJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15FrictionJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN9TextureOpI11TextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi: __ZN9TextureOpI11TextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi, __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE: __ZN5physx2Sc9RigidCoreC2ENS_11PxActorType4EnumE, __ZN5Umbra4PathC2EPNS0_4NodeEi: __ZN5Umbra4PathC2EPNS0_4NodeEi, __ZNK5physx7NpCloth22getNbMotionConstraintsEv: __ZNK5physx7NpCloth22getNbMotionConstraintsEv, __ZN13TextRendering4FontC2E10MemLabelId18ObjectCreationMode: __ZN13TextRendering4FontC2E10MemLabelId18ObjectCreationMode, __ZNK22NavMeshProjectSettings26GetTypeInfoVirtualInternalEv: __ZNK22NavMeshProjectSettings26GetTypeInfoVirtualInternalEv, __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsDelayv: __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsDelayv, __ZN5physx28SimulationStatisticsPropertyC2Ev: __ZN5physx28SimulationStatisticsPropertyC2Ev, __ZN14AreaEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE: __ZN14AreaEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE, __ZN8Animator9GotoStateEiifff: __ZN8Animator9GotoStateEiifff, __ZN9Scripting37GetScriptingArrayTypeElementNoRefImplEP11Il2CppArrayi: __ZN9Scripting37GetScriptingArrayTypeElementNoRefImplEP11Il2CppArrayi, __ZZ23InitPlayerLoopCallbacksvEN27EarlyUpdateClearLinesstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN27EarlyUpdateClearLinesstruct7ForwardEv, __Z41NavMeshAgent_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f: __Z41NavMeshAgent_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f, __ZN5physx3Scb4Body17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb4Body17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN22ParticleSystemRenderer19UpdateTransformInfoEv: __ZN22ParticleSystemRenderer19UpdateTransformInfoEv, __Z39Object_CUSTOM_EnsureRunningOnMainThreadP12Il2CppObject: __Z39Object_CUSTOM_EnsureRunningOnMainThreadP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z62Register_UnityEngine_Screen_set_autorotateToPortraitUpsideDownv: __Z62Register_UnityEngine_Screen_set_autorotateToPortraitUpsideDownv, __Z32AndroidJNI_CUSTOM_ExceptionClearv: __Z32AndroidJNI_CUSTOM_ExceptionClearv, __ZN5physx18NpArticulationLink11clearTorqueENS_11PxForceMode4EnumE: __ZN5physx18NpArticulationLink11clearTorqueENS_11PxForceMode4EnumE, __Z13RegisterClassI15AudioMixerGroupEvv: __Z13RegisterClassI15AudioMixerGroupEvv, __ZN5physx13NpRigidStatic13switchToNoSimEv: __ZN5physx13NpRigidStatic13switchToNoSimEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_BoxCastv: __Z59Register_UnityEngine_Physics_INTERNAL_CALL_Internal_BoxCastv, __Z42ParticleSystem_ShapeModule_CUSTOM_SetAngleP12Il2CppObjectf: __Z42ParticleSystem_ShapeModule_CUSTOM_SetAngleP12Il2CppObjectf, __ZL28DrawBillboardsWith3DRotationILb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL28DrawBillboardsWith3DRotationILb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZNK8Animator38PrepareAnimatorControllerPlayableCacheEv: __ZNK8Animator38PrepareAnimatorControllerPlayableCacheEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __Z48CharacterJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject: __Z48CharacterJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject, __Z10EncodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z10EncodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNK5physx14PxArticulation8isKindOfEPKc: __ZNK5physx14PxArticulation8isKindOfEPKc, __Z59Register_UnityEngine_Physics2D_set_minPenetrationForPenaltyv: __Z59Register_UnityEngine_Physics2D_set_minPenetrationForPenaltyv, __ZThn4_NK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZThn4_NK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD2Ev: __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD2Ev, _ptsname: _ptsname, __Z40CullingGroup_Set_Custom_PropTargetCameraP12Il2CppObjectS0_: __Z40CullingGroup_Set_Custom_PropTargetCameraP12Il2CppObjectS0_, __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_: __ZNSt3__26__sortIR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEvT0_S5_T_, __ZN14SphereCollider12ScaleChangedEv: __ZN14SphereCollider12ScaleChangedEv, __Z51Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorRotationP12Il2CppObjectRK11Quaternionf: __Z51Rigidbody_CUSTOM_INTERNAL_set_inertiaTensorRotationP12Il2CppObjectRK11Quaternionf, __Z29InitPathNamePersistentManagerv: __Z29InitPathNamePersistentManagerv, __ZNKSt3__27codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j: __ZNKSt3__27codecvtIcc11__mbstate_tE9do_lengthERS1_PKcS5_j, __ZN18SharedMaterialDataD0Ev: __ZN18SharedMaterialDataD0Ev, __ZThn8_N5physx2Sc18TriggerInteraction10initializeEv: __ZThn8_N5physx2Sc18TriggerInteraction10initializeEv, __ZNK16UploadHandlerRaw11GetProgressEv: __ZNK16UploadHandlerRaw11GetProgressEv, __ZNK20LocalFileSystemPosix8FilenameERK13FileEntryData: __ZNK20LocalFileSystemPosix8FilenameERK13FileEntryData, __ZNK17BillboardRenderer26GetTypeInfoVirtualInternalEv: __ZNK17BillboardRenderer26GetTypeInfoVirtualInternalEv, _UNITY_TT_Vary_Apply_Glyph_Deltas: _UNITY_TT_Vary_Apply_Glyph_Deltas, __Z37Projector_Set_Custom_PropOrthographicP12Il2CppObjecth: __Z37Projector_Set_Custom_PropOrthographicP12Il2CppObjecth, __ZN14GfxDeviceStats16ResetClientStatsEv: __ZN14GfxDeviceStats16ResetClientStatsEv, __ZNK15b2RevoluteJoint13GetUpperLimitEv: __ZNK15b2RevoluteJoint13GetUpperLimitEv, __ZN14ParticleSystem17DisableUses3DSizeEv: __ZN14ParticleSystem17DisableUses3DSizeEv, __Z16FindActiveLightsR13dynamic_arrayIPK5LightLj4EES4_RS_I8Vector4fLj4EERS_IiLj4EERK14ShadowCullData: __Z16FindActiveLightsR13dynamic_arrayIPK5LightLj4EES4_RS_I8Vector4fLj4EERS_IiLj4EERK14ShadowCullData, __ZN26PxcContactCellMeshCallbackD0Ev: __ZN26PxcContactCellMeshCallbackD0Ev, __ZN28LightProbeProxyVolumeManager17RemoveProxyVolumeEP21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager17RemoveProxyVolumeEP21LightProbeProxyVolume, __ZN5physx3Ext14PrismaticJoint28setProjectionLinearToleranceEf: __ZN5physx3Ext14PrismaticJoint28setProjectionLinearToleranceEf, __Z47Register_UnityEngine_AI_NavMeshAgent_set_radiusv: __Z47Register_UnityEngine_AI_NavMeshAgent_set_radiusv, __Z64Register_UnityEngine_Physics2D_INTERNAL_set_colliderContactColorv: __Z64Register_UnityEngine_Physics2D_INTERNAL_set_colliderContactColorv, __ZN4crnd13crnd_get_dataEPvPPKvPj: __ZN4crnd13crnd_get_dataEPvPPKvPj, __Z48ConfigurableJoint_CUSTOM_INTERNAL_set_slerpDriveP12Il2CppObjectRK10JointDrive: __Z48ConfigurableJoint_CUSTOM_INTERNAL_set_slerpDriveP12Il2CppObjectRK10JointDrive, __Z39RenderTexture_CUSTOM_Internal_GetHeightP12Il2CppObject: __Z39RenderTexture_CUSTOM_Internal_GetHeightP12Il2CppObject, __ZN9LensFlare15InitializeClassEv: __ZN9LensFlare15InitializeClassEv, __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZLimitSpringv: __Z72Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularYZLimitSpringv, __ZN5physx14PxsAABBManager14sortAggregatesEPjjS1_jPNS_19AggregateSortedDataE: __ZN5physx14PxsAABBManager14sortAggregatesEPjjS1_jPNS_19AggregateSortedDataE, _jpeg_write_coefficients: _jpeg_write_coefficients, __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __ZNKSt3__25ctypeIwE10do_toupperEPwPKw: __ZNKSt3__25ctypeIwE10do_toupperEPwPKw, __Z35Camera_Set_Custom_PropTargetDisplayP12Il2CppObjecti: __Z35Camera_Set_Custom_PropTargetDisplayP12Il2CppObjecti, __Z41Register_UnityEngine_GUIText_set_materialv: __Z41Register_UnityEngine_GUIText_set_materialv, __Z47DownloadHandlerAudioClip_CUSTOM_InternalGetDataP12Il2CppObject: __Z47DownloadHandlerAudioClip_CUSTOM_InternalGetDataP12Il2CppObject, __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10AudioMixer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z45WheelCollider_Get_Custom_PropWheelDampingRateP12Il2CppObject: __Z45WheelCollider_Get_Custom_PropWheelDampingRateP12Il2CppObject, __ZN6Camera22ResetReplacementShaderEv: __ZN6Camera22ResetReplacementShaderEv, _wcsncasecmp_l: _wcsncasecmp_l, __Z21CountTrianglesInStripItEiPKT_i: __Z21CountTrianglesInStripItEiPKT_i, __Z46Register_UnityEngine_Light_set_pixelLightCountv: __Z46Register_UnityEngine_Light_set_pixelLightCountv, __ZN5Unity11Adjacencies4InitEPKtPKji: __ZN5Unity11Adjacencies4InitEPKtPKji, __ZN10__cxxabiv112_GLOBAL__N_118parse_builtin_typeINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_118parse_builtin_typeINS0_2DbEEEPKcS4_S4_RT_, __ZN16LightmapSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN16LightmapSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeINS_12__value_typeIjbEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier77ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __Z37SliderJoint2D_Get_Custom_PropUseMotorP12Il2CppObject: __Z37SliderJoint2D_Get_Custom_PropUseMotorP12Il2CppObject, __ZN6Sprite17NotifyObjectUsersEv: __ZN6Sprite17NotifyObjectUsersEv, __ZN5physx9NpFactory26releaseParticleFluidToPoolERNS_15NpParticleFluidE: __ZN5physx9NpFactory26releaseParticleFluidToPoolERNS_15NpParticleFluidE, __ZNK5physx2Sc9ClothCore26getNbSeparationConstraintsEv: __ZNK5physx2Sc9ClothCore26getNbSeparationConstraintsEv, _UNITY_png_write_sBIT: _UNITY_png_write_sBIT, __Z45Register_UnityEngine_AnimationState_set_speedv: __Z45Register_UnityEngine_AnimationState_set_speedv, __ZN9Rigidbody17ResetCenterOfMassEv: __ZN9Rigidbody17ResetCenterOfMassEv, __ZN7b2World5SolveERK10b2TimeStep: __ZN7b2World5SolveERK10b2TimeStep, __ZN15QualitySettings13SetVSyncCountEi: __ZN15QualitySettings13SetVSyncCountEi, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN12b2BroadPhase12DestroyProxyEi: __ZN12b2BroadPhase12DestroyProxyEi, __ZN13BatchRendererD2Ev: __ZN13BatchRendererD2Ev, __ZN7mecanim5human5Human8TransferI8BlobSizeEEvRT_: __ZN7mecanim5human5Human8TransferI8BlobSizeEEvRT_, __ZN9SubModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9SubModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE: __ZN5Umbra13BorderMatcher11matchBorderEiRKNS_8RectBaseINS_8Vector2iEiEE, __ZN12TLSAllocatorI14StackAllocatorED0Ev: __ZN12TLSAllocatorI14StackAllocatorED0Ev, __Z45Register_UnityEngine_RuntimeUndo_RecordObjectv: __Z45Register_UnityEngine_RuntimeUndo_RecordObjectv, __ZN13b2DynamicTree10RemoveLeafEi: __ZN13b2DynamicTree10RemoveLeafEi, __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN13GfxDeviceGLES22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace: __ZN13GfxDeviceGLES22UploadTextureSubData2DE9TextureIDPKhiiiiii13TextureFormat17TextureColorSpace, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE15testVertexIndexEj, __ZN11ShapeModule8TransferI14SafeBinaryReadEEvRT_: __ZN11ShapeModule8TransferI14SafeBinaryReadEEvRT_, __Z39Register_UnityEngine_Camera_get_currentv: __Z39Register_UnityEngine_Camera_get_currentv, __ZN5physx19NpClothParticleData6unlockEv: __ZN5physx19NpClothParticleData6unlockEv, __ZN5physx2Gu9RadixSortC2Ev: __ZN5physx2Gu9RadixSortC2Ev, __ZNK9Heightmap14GetPatchRegionEiRiS0_S0_: __ZNK9Heightmap14GetPatchRegionEiRiS0_S0_, __Z35Camera_CUSTOM_GetStereoViewMatricesP12Il2CppObject: __Z35Camera_CUSTOM_GetStereoViewMatricesP12Il2CppObject, __Z67Register_UnityEngine_ParticleSystemRenderer_get_cameraVelocityScalev: __Z67Register_UnityEngine_ParticleSystemRenderer_get_cameraVelocityScalev, __ZN15TerrainRenderer12ReloadBoundsEv: __ZN15TerrainRenderer12ReloadBoundsEv, __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN5Unity5Cloth15SetCoefficientsEPNS0_26ClothConstrainCoefficientsE: __ZN5Unity5Cloth15SetCoefficientsEPNS0_26ClothConstrainCoefficientsE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags, __ZL28GeomMTDCallback_NotSupportedRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL28GeomMTDCallback_NotSupportedRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZNK26AnimatorOverrideController41GetStateMachineBehaviourVectorDescriptionEv: __ZNK26AnimatorOverrideController41GetStateMachineBehaviourVectorDescriptionEv, __ZN5physx8debugger4comm15EventSerializerD2Ev: __ZN5physx8debugger4comm15EventSerializerD2Ev, __Z34setPxRevoluteJoint_DriveForceLimitPN5physx15PxRevoluteJointEf: __Z34setPxRevoluteJoint_DriveForceLimitPN5physx15PxRevoluteJointEf, __ZN4Tree23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN4Tree23VirtualRedirectTransferER17RemapPPtrTransfer, __Z46Register_UnityEngine_Random_INTERNAL_set_statev: __Z46Register_UnityEngine_Random_INTERNAL_set_statev, __ZN17PxcPoolMallocDataD2Ev: __ZN17PxcPoolMallocDataD2Ev, __ZN9Transform17ValidateHierarchyER18TransformHierarchy: __ZN9Transform17ValidateHierarchyER18TransformHierarchy, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_: __ZL25visualizeTouchedTrianglesjjPKN5physx10PxTriangleEPNS_2Cm12RenderBufferERKNS_6PxVec3ES8_, __ZN9LensFlare7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9LensFlare7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11AudioModule27GetDSPFromAudioCustomFilterEP17AudioCustomFilter: __ZN11AudioModule27GetDSPFromAudioCustomFilterEP17AudioCustomFilter, __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z39Register_UnityEngine_Mesh_set_bindposesv: __Z39Register_UnityEngine_Mesh_set_bindposesv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE11runInternalEv, __Z34NavMesh_CUSTOM_TriangulateInternalv: __Z34NavMesh_CUSTOM_TriangulateInternalv, __ZN15UnityAdsManagerD2Ev: __ZN15UnityAdsManagerD2Ev, __Z61Register_UnityEngine_TerrainData_get_detailResolutionPerPatchv: __Z61Register_UnityEngine_TerrainData_get_detailResolutionPerPatchv, __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf: __ZN9Transform22SetPositionAndRotationERK8Vector3fRK11Quaternionf, __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_: __ZN5physx3Ext5joint14computeDerivedERKNS0_9JointDataERKNS_11PxTransformES7_RS5_S8_S8_, __Z25getPxSphereGeometryRadiusPKN5physx16PxSphereGeometryE: __Z25getPxSphereGeometryRadiusPKN5physx16PxSphereGeometryE, __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE: __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EEiPKN7mecanim18ValueArrayConstantERNS7_6memory9AllocatorE, __ZN23TextDOMTransferReadBaseI8JSONReadE10InitArraysEv: __ZN23TextDOMTransferReadBaseI8JSONReadE10InitArraysEv, __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14RenderSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14RenderSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j: __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j, __Z47Screen_Get_Custom_PropAutorotateToLandscapeLeftv: __Z47Screen_Get_Custom_PropAutorotateToLandscapeLeftv, __Z24RegisterStrippedTypeInfoI11LightProbesEviPKcS2_: __Z24RegisterStrippedTypeInfoI11LightProbesEviPKcS2_, __ZNK5physx17AggregateAABBTask7getNameEv: __ZNK5physx17AggregateAABBTask7getNameEv, __ZN13GfxDeviceGLES20SetRenderSurfaceNameEP17RenderSurfaceBasePKc: __ZN13GfxDeviceGLES20SetRenderSurfaceNameEP17RenderSurfaceBasePKc, __ZN11Rigidbody2D11SetRotationEf: __ZN11Rigidbody2D11SetRotationEf, _unzGetOffset: _unzGetOffset, __ZN12_GLOBAL__N_1L9gSWAP_ANDERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L9gSWAP_ANDERN5physx12PxGroupsMaskERKS1_S4_, __Z41AreaEffector2D_Get_Custom_PropForceTargetP12Il2CppObject: __Z41AreaEffector2D_Get_Custom_PropForceTargetP12Il2CppObject, __ZN18WheelFrictionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18WheelFrictionCurve8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z53Register_UnityEngine_SystemInfo_get_supportsVibrationv: __Z53Register_UnityEngine_SystemInfo_get_supportsVibrationv, __ZL32MarkLevelGameManagerDependenciesR27GarbageCollectorThreadState: __ZL32MarkLevelGameManagerDependenciesR27GarbageCollectorThreadState, __ZN11AssetBundle8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11AssetBundle8TransferI24GenerateTypeTreeTransferEEvRT_, __Z26scripting_gc_get_heap_sizev: __Z26scripting_gc_get_heap_sizev, __Z56Register_UnityEngine_TerrainData_set_wavingGrassStrengthv: __Z56Register_UnityEngine_TerrainData_set_wavingGrassStrengthv, __ZN12CachedWriter16UpdateWriteCacheEPKvj: __ZN12CachedWriter16UpdateWriteCacheEPKvj, __Z31Texture2DArray_CUSTOM_GetPixelsP12Il2CppObjectii: __Z31Texture2DArray_CUSTOM_GetPixelsP12Il2CppObjectii, _fgetpos: _fgetpos, _UNITY_tt_size_init: _UNITY_tt_size_init, __Z29Rigidbody_Set_Custom_PropMassP12Il2CppObjectf: __Z29Rigidbody_Set_Custom_PropMassP12Il2CppObjectf, _jcopy_block_row: _jcopy_block_row, __Z38setPxScene_ClothInterCollisionDistancePN5physx7PxSceneEf: __Z38setPxScene_ClothInterCollisionDistancePN5physx7PxSceneEf, __Z51Register_UnityEngine_SpringJoint2D_get_dampingRatiov: __Z51Register_UnityEngine_SpringJoint2D_get_dampingRatiov, _PxCreateControllerManager: _PxCreateControllerManager, __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile23EventContextInformation9streamifyINS0_17EventDeserializerILb1EEEEEvRT_NS0_27EventStreamCompressionFlags4EnumE, __Z26scripting_class_has_parentP11Il2CppClassS0_: __Z26scripting_class_has_parentP11Il2CppClassS0_, __ZN14VelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14VelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19setTypePairFrictionEjjf: __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs19setTypePairFrictionEjjf, __Z49ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitP12Il2CppObjectP14SoftJointLimit: __Z49ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitP12Il2CppObjectP14SoftJointLimit, __ZN13SplatDatabase12SetAlphamapsEiiiiPf: __ZN13SplatDatabase12SetAlphamapsEiiiiPf, __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameMultiplierP12Il2CppObject: __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameMultiplierP12Il2CppObject, __Z26setPxD6Joint_DriveVelocityPN5physx9PxD6JointENS_6PxVec3ES2_: __Z26setPxD6Joint_DriveVelocityPN5physx9PxD6JointENS_6PxVec3ES2_, __ZN16ParticleAnimator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16ParticleAnimator23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z46Register_UnityEngine_Collider2D_get_shapeCountv: __Z46Register_UnityEngine_Collider2D_get_shapeCountv, __ZN18GlslGpuProgramGLES10FillParamsEjR20GpuProgramParametersP16PropertyNamesSet: __ZN18GlslGpuProgramGLES10FillParamsEjR20GpuProgramParametersP16PropertyNamesSet, __ZN5IMGUI12BeginWindowsER8GUIStatebb: __ZN5IMGUI12BeginWindowsER8GUIStatebb, _gray_rgb_convert: _gray_rgb_convert, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZNK5physx2Gu11ConvexHullV22BruteForceSearchMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_: __ZNK5physx2Gu11ConvexHullV22BruteForceSearchMinMaxERKNS_6shdfnd3aos5Vec3VERNS3_6FloatVES8_, __ZNK27AnimationLayerMixerPlayable13GetParametersEj: __ZNK27AnimationLayerMixerPlayable13GetParametersEj, __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerCountInternalv: __Z91Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerCountInternalv, __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17GlobalGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z50QualitySettings_Get_Custom_PropShadowCascade2Splitv: __Z50QualitySettings_Get_Custom_PropShadowCascade2Splitv, __ZN5physx2Sc8BodyCore22disableInternalCachingEb: __ZN5physx2Sc8BodyCore22disableInternalCachingEb, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __Z6getBitj: __Z6getBitj, __ZN14PlayerSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14PlayerSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL28CleanupClothScriptingClassesv: __ZL28CleanupClothScriptingClassesv, __ZNK20LightPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK20LightPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __ZN23TransformChangeDispatch16UnregisterSystemER27TransformChangeSystemHandle: __ZN23TransformChangeDispatch16UnregisterSystemER27TransformChangeSystemHandle, __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii: __ZN20GpuProgramParameters14AddBufferParamEPKciP16PropertyNamesSetii, _tolower: _tolower, __ZN19CollisionListener2D16ReportCollisionsEv: __ZN19CollisionListener2D16ReportCollisionsEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z40setPxVehicleWheelDataMMaxHandBrakeTorquePN5physx18PxVehicleWheelDataEf: __Z40setPxVehicleWheelDataMMaxHandBrakeTorquePN5physx18PxVehicleWheelDataEf, __ZNSt3__217moneypunct_bynameIcLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__217moneypunct_bynameIcLb0EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN11AudioSource17RemoveFromManagerEv: __ZN11AudioSource17RemoveFromManagerEv, __ZN8Renderer16SetMaterialArrayERK13dynamic_arrayI4PPtrI8MaterialELj4EE: __ZN8Renderer16SetMaterialArrayERK13dynamic_arrayI4PPtrI8MaterialELj4EE, __ZN5Umbra15ShadowCullerExtC2ERKS0_: __ZN5Umbra15ShadowCullerExtC2ERKS0_, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv, __Z53Register_UnityEngine_PlatformEffector2D_set_useOneWayv: __Z53Register_UnityEngine_PlatformEffector2D_set_useOneWayv, __Z16RandomQuaternionR4Rand: __Z16RandomQuaternionR4Rand, __ZN11UnityEngine7Connect16PersistentValues5ResetEv: __ZN11UnityEngine7Connect16PersistentValues5ResetEv, __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z47Rigidbody_Get_Custom_PropCollisionDetectionModeP12Il2CppObject: __Z47Rigidbody_Get_Custom_PropCollisionDetectionModeP12Il2CppObject, __ZN16MessageForwarder24GetExpectedParameterTypeEi: __ZN16MessageForwarder24GetExpectedParameterTypeEi, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13LineAlignmentEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead13LineAlignmentEvRT_RT0_PKc17TransferMetaFlags, __Z20ClearShaderCacheGLESv: __Z20ClearShaderCacheGLESv, __Z38AsyncOperation_Get_Custom_PropProgressP12Il2CppObject: __Z38AsyncOperation_Get_Custom_PropProgressP12Il2CppObject, __Z46Register_UnityEngine_Light_RemoveCommandBufferv: __Z46Register_UnityEngine_Light_RemoveCommandBufferv, __ZNK14ParticleSystem24GetCustomSimulationSpaceEv: __ZNK14ParticleSystem24GetCustomSimulationSpaceEv, __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z55Register_UnityEngine_Profiling_Profiler_GetSamplerNamesv: __Z55Register_UnityEngine_Profiling_Profiler_GetSamplerNamesv, __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj1ES2_NS_25GenericInsituStringStreamIS2_EEEERS4_RT1_: __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj1ES2_NS_25GenericInsituStringStreamIS2_EEEERS4_RT1_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE12find_last_ofEPKwj, __ZN14SerializedFile10ReadHeaderEv: __ZN14SerializedFile10ReadHeaderEv, __ZL32CleanupPhysics2DScriptingClassesv: __ZL32CleanupPhysics2DScriptingClassesv, __ZN11DynamicMesh20RemoveUnusedVerticesEv: __ZN11DynamicMesh20RemoveUnusedVerticesEv, __ZNKSt3__28messagesIcE3getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNKSt3__28messagesIcE3getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN13SparseTextureD2Ev: __ZN13SparseTextureD2Ev, __Z34Time_Set_Custom_PropFixedDeltaTimef: __Z34Time_Set_Custom_PropFixedDeltaTimef, __ZN9GfxDevice11CopyTextureE9TextureIDiiiiiiiS0_iiiii: __ZN9GfxDevice11CopyTextureE9TextureIDiiiiiiiS0_iiiii, __Z42Register_UnityEngine_CanvasGroup_get_alphav: __Z42Register_UnityEngine_CanvasGroup_get_alphav, __Z44AnimationState_Get_Custom_PropNormalizedTimeP12Il2CppObject: __Z44AnimationState_Get_Custom_PropNormalizedTimeP12Il2CppObject, __ZN39AssetBundleLoadFromMemoryAsyncOperation20ExecuteSynchronouslyEPKhj: __ZN39AssetBundleLoadFromMemoryAsyncOperation20ExecuteSynchronouslyEPKhj, __ZN12_GLOBAL__N_116MetaDataProvider6addRefEv: __ZN12_GLOBAL__N_116MetaDataProvider6addRefEv, __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f: __ZN11ShapeModule15AcquireMeshDataERK10Matrix4x4f, __Z51Register_UnityEngine_RenderSettings_set_ambientModev: __Z51Register_UnityEngine_RenderSettings_set_ambientModev, __ZNK5physx3Ext7D6Joint28getProjectionLinearToleranceEv: __ZNK5physx3Ext7D6Joint28getProjectionLinearToleranceEv, __ZN5Unity12PhysicsQuery15BoxCastNonAllocERK8Vector3fS3_S3_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery15BoxCastNonAllocERK8Vector3fS3_S3_P10RaycastHitiRK11Quaternionffi23QueryTriggerInteraction, __Z20AnimationEventToMonoRK14AnimationEventR18MonoAnimationEvent: __Z20AnimationEventToMonoRK14AnimationEventR18MonoAnimationEvent, __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetActiveScenev: __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetActiveScenev, __ZL15SweepBoxUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL15SweepBoxUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb: __Z12BuildTextureIhPFvP9Texture2DPhiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb, __Z60GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_GetWindowRectiR5RectTIfE: __Z60GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_GetWindowRectiR5RectTIfE, __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14MinMaxGradient8TransferI24GenerateTypeTreeTransferEEvRT_, __Z42Register_UnityEngine_PlayerPrefs_DeleteKeyv: __Z42Register_UnityEngine_PlayerPrefs_DeleteKeyv, __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE: __ZN5physx2Gu20PCMContactConvexMeshERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESP_bbRNS0_33MultiplePersistentContactManifoldE, __ZN11AudioSource16UpdateParametersEv: __ZN11AudioSource16UpdateParametersEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS2_9allocatorIiEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS2_9allocatorIiEEEEEvRT_17TransferMetaFlags, __ZN16Physics2DManager16BatchOverlapInitEPK4PPtrIN5Unity9ComponentEEPP10Collider2Dj: __ZN16Physics2DManager16BatchOverlapInitEPK4PPtrIN5Unity9ComponentEEPP10Collider2Dj, __Z26GetCoreScriptingClassesPtrv: __Z26GetCoreScriptingClassesPtrv, __Z28scripting_array_element_sizeP11Il2CppClass: __Z28scripting_array_element_sizeP11Il2CppClass, __ZN5Unity5Joint17MainThreadCleanupEv: __ZN5Unity5Joint17MainThreadCleanupEv, __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z39NavMeshAgent_Set_Custom_PropAutoBrakingP12Il2CppObjecth: __Z39NavMeshAgent_Set_Custom_PropAutoBrakingP12Il2CppObjecth, __ZN22ProceduralMaterialData16CopyFromMaterialEP18ProceduralMaterial: __ZN22ProceduralMaterialData16CopyFromMaterialEP18ProceduralMaterial, __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii: __ZN7mecanim5human22HumanAlignSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_ii, __Z27Input_CUSTOM_GetMouseButtoni: __Z27Input_CUSTOM_GetMouseButtoni, __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __Z16HumanLimitToMonoRK17SkeletonBoneLimitR14MonoHumanLimit: __Z16HumanLimitToMonoRK17SkeletonBoneLimitR14MonoHumanLimit, __ZNK8VRDevice18GetEyeTextureWidthEv: __ZNK8VRDevice18GetEyeTextureWidthEv, __Z44DownloadHandler_CUSTOM_InternalCreateTextureP12Il2CppObjecth: __Z44DownloadHandler_CUSTOM_InternalCreateTextureP12Il2CppObjecth, __Z32GL_CUSTOM_INTERNAL_CALL_ViewportRK5RectTIfE: __Z32GL_CUSTOM_INTERNAL_CALL_ViewportRK5RectTIfE, __ZN5Umbra20RuntimeStructBuilder8finalizeEPNS_9AllocatorE: __ZN5Umbra20RuntimeStructBuilder8finalizeEPNS_9AllocatorE, _grayscale_convert: _grayscale_convert, __ZL16CleanupModule_VRv: __ZL16CleanupModule_VRv, __Z47Renderer_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f: __Z47Renderer_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj460ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj460ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _tt_cmap14_init: _tt_cmap14_init, __ZN6prcoreL13inner_stretchILj1ELj1EEEvPKNS_9InnerInfoE: __ZN6prcoreL13inner_stretchILj1ELj1EEEvPKNS_9InnerInfoE, _fmod: _fmod, __Z49AnimationClip_CUSTOM_Internal_CreateAnimationClipP12Il2CppObject: __Z49AnimationClip_CUSTOM_Internal_CreateAnimationClipP12Il2CppObject, __Z59ConfigurableJoint_CUSTOM_INTERNAL_set_targetAngularVelocityP12Il2CppObjectRK8Vector3f: __Z59ConfigurableJoint_CUSTOM_INTERNAL_set_targetAngularVelocityP12Il2CppObjectRK8Vector3f, __Z64Register_UnityEngine_ParticleSystem_CollisionModule_SetVoxelSizev: __Z64Register_UnityEngine_ParticleSystem_CollisionModule_SetVoxelSizev, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEPNS_15basic_streambufIwS2_EE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5rdbufEPNS_15basic_streambufIwS2_EE, __ZN5physx2Gu15MeshRayCollider7collideILi0ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_: __ZN5physx2Gu15MeshRayCollider7collideILi0ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_, __ZN19AudioHighPassFilter12AddToManagerEv: __ZN19AudioHighPassFilter12AddToManagerEv, __ZN8GUIState37InvokeScriptingMakeMasterEventCurrentEi: __ZN8GUIState37InvokeScriptingMakeMasterEventCurrentEi, __Z58setPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePN5physx22PxSimulationStatisticsEj: __Z58setPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePN5physx22PxSimulationStatisticsEj, __Z37GUIUtility_CUSTOM_ReleaseMouseControlv: __Z37GUIUtility_CUSTOM_ReleaseMouseControlv, __Z38Motion_Get_Custom_PropIsAnimatorMotionP12Il2CppObject: __Z38Motion_Get_Custom_PropIsAnimatorMotionP12Il2CppObject, __Z42CapsuleCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z42CapsuleCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __Z31CommandBuffer_CUSTOM_InitBufferP12Il2CppObject: __Z31CommandBuffer_CUSTOM_InitBufferP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj497ENS_22PxRepXPropertyAccessorILj497ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj497ENS_22PxRepXPropertyAccessorILj497ES4_ffEEEEvRKT0_, __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj: __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE8__appendEj, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx16PxVehicleDriveNW6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj: __ZN5physx16PxVehicleDriveNW6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimDataNWEj, __ZN15TextureTFMethod13MapBoneBufferEj: __ZN15TextureTFMethod13MapBoneBufferEj, __Z38Profiler_CUSTOM_GetTotalReservedMemoryv: __Z38Profiler_CUSTOM_GetTotalReservedMemoryv, __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z11StringToKeyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8MaterialELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8MaterialELj4EEEEvRT_17TransferMetaFlags, __ZN7mecanim5human9HumanGoal8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim5human9HumanGoal8TransferI24GenerateTypeTreeTransferEEvRT_, __Z48Register_UnityEngine_AnimationState_get_wrapModev: __Z48Register_UnityEngine_AnimationState_get_wrapModev, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStrS4_NS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S4_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __GLOBAL__sub_I_runtime_animation_lump_cpp: __GLOBAL__sub_I_runtime_animation_lump_cpp, __ZN26AnimatorControllerPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE: __ZN26AnimatorControllerPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN11SoundHandle8Instance13CreateChannelERS_b: __ZN11SoundHandle8Instance13CreateChannelERS_b, __Z14UnquantizeBC6Hih: __Z14UnquantizeBC6Hih, __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject: __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject, __ZN9GfxDevice26UpdateViewProjectionMatrixEv: __ZN9GfxDevice26UpdateViewProjectionMatrixEv, __ZN14GfxContextGLES10InvalidateER7ApiGLES: __ZN14GfxContextGLES10InvalidateER7ApiGLES, __Z37AndroidJNI_CUSTOM_GetStaticShortField13Il2Cpp_IntPtrS_: __Z37AndroidJNI_CUSTOM_GetStaticShortField13Il2Cpp_IntPtrS_, __Z42Physics2D_Get_Custom_PropBaumgarteTOIScalev: __Z42Physics2D_Get_Custom_PropBaumgarteTOIScalev, _ps_hinter_init: _ps_hinter_init, __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8Vector3fNS0_9allocatorIS2_EEEEEvRT_j, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN19CollisionListener2D21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE: __ZN19CollisionListener2D21SetColliderCollisionsEP10Collider2DN11Collision2D11ContactModeE, __ZN18AsyncUploadManager16TimeSlicedUpdateEv: __ZN18AsyncUploadManager16TimeSlicedUpdateEv, __Z43QualitySettings_Set_Custom_PropBlendWeightsi: __Z43QualitySettings_Set_Custom_PropBlendWeightsi, __ZN19SkinnedMeshRenderer15InitializeClassEv: __ZN19SkinnedMeshRenderer15InitializeClassEv, __ZN19RuntimeSceneManager32LoadSceneAsyncByNameOrBuildIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiNS_11LoadingModeEb: __ZN19RuntimeSceneManager32LoadSceneAsyncByNameOrBuildIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEiNS_11LoadingModeEb, __ZN5physx20PxClothGeneratedInfoC2Ev: __ZN5physx20PxClothGeneratedInfoC2Ev, __Z55Register_UnityEngine_AI_NavMeshAgent_set_updatePositionv: __Z55Register_UnityEngine_AI_NavMeshAgent_set_updatePositionv, __Z24tessMeshMergeConvexFacesP8TESSmeshi: __Z24tessMeshMergeConvexFacesP8TESSmeshi, __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE: __ZN5physx11HullLibrary13ReleaseResultERNS_10HullResultE, __ZN11NoiseModule15PreviewNoiseJobILi1EEEvP19PreviewNoiseJobData: __ZN11NoiseModule15PreviewNoiseJobILi1EEEvP19PreviewNoiseJobData, __GLOBAL__sub_I_SwSolverKernel_cpp: __GLOBAL__sub_I_SwSolverKernel_cpp, __ZN5physx18NpArticulationLinkC2ERKNS_11PxTransformERNS_14NpArticulationEPS0_: __ZN5physx18NpArticulationLinkC2ERKNS_11PxTransformERNS_14NpArticulationEPS0_, __ZNSt3__27collateIcEC2Ej: __ZNSt3__27collateIcEC2Ej, __ZNK21FullParameterPreparer22OnPrepareComputeBufferER15ComputeBufferIDRKN20GpuProgramParameters15BufferParameterEj: __ZNK21FullParameterPreparer22OnPrepareComputeBufferER15ComputeBufferIDRKN20GpuProgramParameters15BufferParameterEj, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __Z22GetProjectRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z22GetProjectRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationZMultiplierP12Il2CppObjectf: __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationZMultiplierP12Il2CppObjectf, __Z41BuoyancyEffector2D_Get_Custom_PropDensityP12Il2CppObject: __Z41BuoyancyEffector2D_Get_Custom_PropDensityP12Il2CppObject, __ZN7Joint2D12CleanupClassEv: __ZN7Joint2D12CleanupClassEv, __Z29getPxHeightFieldDescThicknessPKN5physx17PxHeightFieldDescE: __Z29getPxHeightFieldDescThicknessPKN5physx17PxHeightFieldDescE, __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE19resizeUninitializedEj, __ZN15FrictionJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15FrictionJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZL24QueryPortalVisibilityJobP28QueryPortalVisibilityJobDataj: __ZL24QueryPortalVisibilityJobP28QueryPortalVisibilityJobDataj, __Z47QualitySettings_Set_Custom_PropShadowProjection16ShadowProjection: __Z47QualitySettings_Set_Custom_PropShadowProjection16ShadowProjection, __ZN15QualitySettings15SetAntiAliasingEi: __ZN15QualitySettings15SetAntiAliasingEi, __Z42SkinnedMeshRenderer_Get_Custom_PropQualityP12Il2CppObject: __Z42SkinnedMeshRenderer_Get_Custom_PropQualityP12Il2CppObject, __ZN24DownloadHandlerAudioClip17OnCompleteContentEv: __ZN24DownloadHandlerAudioClip17OnCompleteContentEv, __ZN25ThreadsafeLinearAllocator10DeallocateEPv: __ZN25ThreadsafeLinearAllocator10DeallocateEPv, __ZN11BoxCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11BoxCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN22MemoryCacherReadBlocks12GetCacheSizeEv: __ZN22MemoryCacherReadBlocks12GetCacheSizeEv, __ZN19ShaderPropertySheet18SetTexturePropertyERKN9ShaderLab16FastPropertyNameERKNS_15TexturePropertyE: __ZN19ShaderPropertySheet18SetTexturePropertyERKN9ShaderLab16FastPropertyNameERKNS_15TexturePropertyE, __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_: __ZN15SerializeTraitsIKN4math7_float4EE8TransferI24GenerateTypeTreeTransferEEvRS2_RT_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSESt16initializer_listIwE, __Z64Register_UnityEngine_Physics2D_INTERNAL_get_colliderContactColorv: __Z64Register_UnityEngine_Physics2D_INTERNAL_get_colliderContactColorv, __ZN20dynamic_block_vectorI14FileIdentifierE22push_back_no_constructEv: __ZN20dynamic_block_vectorI14FileIdentifierE22push_back_no_constructEv, __ZN15DirectorManager14ConnectionPool10CreateItemEi: __ZN15DirectorManager14ConnectionPool10CreateItemEi, __ZN12InputManager16CheckConsistencyEv: __ZN12InputManager16CheckConsistencyEv, __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb: __ZN6Object21FindInstanceIDsOfTypeEPKN5Unity4TypeER13dynamic_arrayIiLj4EEb, __ZN5physx7NpShape17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx7NpShape17resolveReferencesERNS_24PxDeserializationContextE, __Z27scripting_class_is_abstractP11Il2CppClass: __Z27scripting_class_is_abstractP11Il2CppClass, __ZN16AllProfilerStats11DeserializeEPPib: __ZN16AllProfilerStats11DeserializeEPPib, __Z40ParticleSystem_Get_Custom_PropIsEmittingP12Il2CppObject: __Z40ParticleSystem_Get_Custom_PropIsEmittingP12Il2CppObject, __ZN5Umbra9FloatListC2ERKS0_: __ZN5Umbra9FloatListC2ERKS0_, __Z32GUIStyle_Get_Custom_PropRichTextP12Il2CppObject: __Z32GUIStyle_Get_Custom_PropRichTextP12Il2CppObject, __Z30Material_CUSTOM_DisableKeywordP12Il2CppObjectP12Il2CppString: __Z30Material_CUSTOM_DisableKeywordP12Il2CppObjectP12Il2CppString, __Z44Effector2D_Get_Custom_PropDesignedForTriggerP12Il2CppObject: __Z44Effector2D_Get_Custom_PropDesignedForTriggerP12Il2CppObject, __ZN5physx2Sc15ClothFabricCoreD2Ev: __ZN5physx2Sc15ClothFabricCoreD2Ev, __Z74Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_GetWindowRectv: __Z74Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_GetWindowRectv, __ZN9GfxDevice14InsertCPUFenceEv: __ZN9GfxDevice14InsertCPUFenceEv, __Z33GUIStyle_Get_Custom_PropAlignmentP12Il2CppObject: __Z33GUIStyle_Get_Custom_PropAlignmentP12Il2CppObject, __Z31getPxShape_SimulationFilterDataPKN5physx7PxShapeE: __Z31getPxShape_SimulationFilterDataPKN5physx7PxShapeE, __Z13RegisterClassI14SphereColliderEvv: __Z13RegisterClassI14SphereColliderEvv, __ZN14CachingManager10CleanCacheENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN14CachingManager10CleanCacheENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject: __ZN13MonoBehaviour9SetScriptERK4PPtrI10MonoScriptEP12Il2CppObject, __ZN2UI13CanvasManager17EmitDataForCameraEP6Camera: __ZN2UI13CanvasManager17EmitDataForCameraEP6Camera, __ZN10builtintex16GetDefaultTexEnvE16TextureDimension: __ZN10builtintex16GetDefaultTexEnvE16TextureDimension, __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE: __ZN5physx18NpShapeDecRefCountERNS_3Scb5ShapeE, __ZN19CharacterController23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN19CharacterController23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN11NavMeshData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11NavMeshData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZZN15DirectorManager15InitializeClassEvEN36FixedUpdateDirectorFixedUpdatestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN36FixedUpdateDirectorFixedUpdatestruct7ForwardEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __Z41Register_UnityEngine_Object_get_hideFlagsv: __Z41Register_UnityEngine_Object_get_hideFlagsv, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZNK21EnlightenSceneMapping36GetEnlightenSystemForInputSystemHashERK7Hash128: __ZNK21EnlightenSceneMapping36GetEnlightenSystemForInputSystemHashERK7Hash128, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE11getBodyPoseEPKNS_12PxRigidActorE, __Z54Register_UnityEngine_ParticleEmitter_get_useWorldSpacev: __Z54Register_UnityEngine_ParticleEmitter_get_useWorldSpacev, __ZN13GfxDeviceGLES28DestroyRenderSurfacePlatformEP17RenderSurfaceBase: __ZN13GfxDeviceGLES28DestroyRenderSurfacePlatformEP17RenderSurfaceBase, __ZN11AssetBundle39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN11AssetBundle39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN15AudioReverbZone14SetMinDistanceEf: __ZN15AudioReverbZone14SetMinDistanceEf, __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj: __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17handleBufferFlushEPKhj, __ZN5physx2Gu21computeMTD_ConvexMeshERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES9_: __ZN5physx2Gu21computeMTD_ConvexMeshERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES9_, __ZN13SliderJoint2D15ThreadedCleanupEv: __ZN13SliderJoint2D15ThreadedCleanupEv, __Z25InitComponentRequirementsv: __Z25InitComponentRequirementsv, __Z26TrailRenderer_CUSTOM_ClearP12Il2CppObject: __Z26TrailRenderer_CUSTOM_ClearP12Il2CppObject, __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_: __ZN13sorted_vectorINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEN10vector_mapIiS3_NS0_4lessIiEENS0_9allocatorIS4_EEE13value_compareES9_E14find_or_insertIiS3_EEvRPT0_RKT_, __Z43Register_UnityEngine_AnimationClip_SetCurvev: __Z43Register_UnityEngine_AnimationClip_SetCurvev, __Z34ReflectionProbe_Set_Custom_PropHdrP12Il2CppObjecth: __Z34ReflectionProbe_Set_Custom_PropHdrP12Il2CppObjecth, __ZNK5physx12NpBatchQuery19getPostFilterShaderEv: __ZNK5physx12NpBatchQuery19getPostFilterShaderEv, __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipUv: __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFlipUv, __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN7mecanim9animation19GetVectorCurveValueERKN4math7_float3Ei: __ZN7mecanim9animation19GetVectorCurveValueERKN4math7_float3Ei, __Z37AndroidJNI_CUSTOM_AttachCurrentThreadv: __Z37AndroidJNI_CUSTOM_AttachCurrentThreadv, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE, __Z28PlayerPrefs_CUSTOM_GetStringP12Il2CppStringS0_: __Z28PlayerPrefs_CUSTOM_GetStringP12Il2CppStringS0_, __ZN8LODGroupC2E10MemLabelId18ObjectCreationMode: __ZN8LODGroupC2E10MemLabelId18ObjectCreationMode, __ZN21BillboardBatchManager19TransformBillboardsEPvS0_RK19SharedBillboardDataPKNS_17BillboardInstanceEjjj: __ZN21BillboardBatchManager19TransformBillboardsEPvS0_RK19SharedBillboardDataPKNS_17BillboardInstanceEjjj, __ZN5physx25PxVehicleConstraintShader11prepareDataEv: __ZN5physx25PxVehicleConstraintShader11prepareDataEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __ZN5physx12solve1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx12solve1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf: __Z20RenderFullScreenQuadR9GfxDeviceRK6CameraPK14ChannelAssignsRK5RectTIfEf, __ZN21AudioDistortionFilter6UpdateEv: __ZN21AudioDistortionFilter6UpdateEv, __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject: __ZN9Scripting24RaiseNullExceptionObjectEP12Il2CppObject, __Z54Register_UnityEngine_Terrain_set_treeLODBiasMultiplierv: __Z54Register_UnityEngine_Terrain_set_treeLODBiasMultiplierv, __ZN9InputAxisC2ERKS_: __ZN9InputAxisC2ERKS_, __ZN8GUIStyle14GetClipTextureEv: __ZN8GUIStyle14GetClipTextureEv, _UNITY_tt_face_get_kerning: _UNITY_tt_face_get_kerning, __ZL17Transfer_GUIStyleI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z26setPxCloth_SolverFrequencyPN5physx7PxClothEf: __Z26setPxCloth_SolverFrequencyPN5physx7PxClothEf, __ZN5Umbra16LineSegmentQuery8setStartERKNS_7Vector3E: __ZN5Umbra16LineSegmentQuery8setStartERKNS_7Vector3E, __Z24BillboardRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi: __Z24BillboardRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi, __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z30GL_CUSTOM_INTERNAL_CALL_VertexRK8Vector3f: __Z30GL_CUSTOM_INTERNAL_CALL_VertexRK8Vector3f, __ZN24GenerateTypeTreeTransfer8TransferI12WheelJoint2DEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI12WheelJoint2DEEvRT_PKc17TransferMetaFlags, __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8Animator23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z42Register_UnityEngine_Input_get_inputStringv: __Z42Register_UnityEngine_Input_get_inputStringv, __ZN15PointEffector2D5ResetEv: __ZN15PointEffector2D5ResetEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Scb11RigidObject13onShapeAttachERNS0_5ShapeE: __ZN5physx3Scb11RigidObject13onShapeAttachERNS0_5ShapeE, __Z20ProcessFilterExtentsPffP10CBBoxInt32P13CImageSurfaceS3_S_jbfiR17PrecomputeContext: __Z20ProcessFilterExtentsPffP10CBBoxInt32P13CImageSurfaceS3_S_jbfiR17PrecomputeContext, __ZN7Cubemap13RebuildMipMapEv: __ZN7Cubemap13RebuildMipMapEv, __ZNK5physx3Ext13DistanceJoint10getDampingEv: __ZNK5physx3Ext13DistanceJoint10getDampingEv, __ZNKSt3__210moneypunctIcLb0EE13decimal_pointEv: __ZNKSt3__210moneypunctIcLb0EE13decimal_pointEv, __ZNK10GameObject38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState: __ZNK10GameObject38MarkGameObjectAndComponentDependenciesER27GarbageCollectorThreadState, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEEC2EPKcP15BucketAllocatorP13BaseAllocatorS9_: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEEC2EPKcP15BucketAllocatorP13BaseAllocatorS9_, __ZN11Rigidbody2D14RecreateJointsEv: __ZN11Rigidbody2D14RecreateJointsEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLERKS5_, __ZN20TextRenderingPrivate8TextMesh8TransferI14SafeBinaryReadEEvRT_: __ZN20TextRenderingPrivate8TextMesh8TransferI14SafeBinaryReadEEvRT_, __ZN19RuntimeSceneManager8GetSceneEi: __ZN19RuntimeSceneManager8GetSceneEi, _UNITY_LZ4_compress_withState: _UNITY_LZ4_compress_withState, __ZNK5physx2Sc5Scene15getFrictionTypeEv: __ZNK5physx2Sc5Scene15getFrictionTypeEv, __ZNK5Umbra9Matrix4x48getScaleEv: __ZNK5Umbra9Matrix4x48getScaleEv, __Z29RegisterModule_UnityAnalyticsv: __Z29RegisterModule_UnityAnalyticsv, __ZN5physx29solveExtFrictionConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx29solveExtFrictionConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN10AtomicList4InitEv: __ZN10AtomicList4InitEv, __Z31getPxRigidDynamic_LinearDampingPKN5physx14PxRigidDynamicE: __Z31getPxRigidDynamic_LinearDampingPKN5physx14PxRigidDynamicE, __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPj: __ZN16RayRTreeCallbackILi1ELb0EE14processResultsEjPj, __ZN5physx2Sn5ConvX11setNoOutputEb: __ZN5physx2Sn5ConvX11setNoOutputEb, __ZN5physx20solveConcludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx20solveConcludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN23ArchiveStorageConverter11SetPriorityE14ThreadPriority: __ZN23ArchiveStorageConverter11SetPriorityE14ThreadPriority, _PxAddCollectionToPhysics: _PxAddCollectionToPhysics, __ZN12b2WheelJoint11EnableMotorEb: __ZN12b2WheelJoint11EnableMotorEb, __Z18Transfer_BlittableI14SafeBinaryReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx9NpPhysics17getNbHeightFieldsEv: __ZNK5physx9NpPhysics17getNbHeightFieldsEv, __ZN5physx17AggregateAABBTaskD0Ev: __ZN5physx17AggregateAABBTaskD0Ev, __ZN13AudioListener23SetAlternativeTransformEP9Transform: __ZN13AudioListener23SetAlternativeTransformEP9Transform, __Z31InitializeUnityWebRequestModulev: __Z31InitializeUnityWebRequestModulev, __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE: __ZN5Umbra20RuntimeTomeGenerator13makeOldNewMapEPKNS_7ImpTomeERNS_6KDTreeEiPiiRKNS_4AABBE, __ZN14dtPathCorridor12SetPathValidEb: __ZN14dtPathCorridor12SetPathValidEb, __Z32Animation_CUSTOM_CrossFadeQueuedP12Il2CppObjectP12Il2CppStringfii: __Z32Animation_CUSTOM_CrossFadeQueuedP12Il2CppObjectP12Il2CppStringfii, _UNITY_ft_validator_error: _UNITY_ft_validator_error, ___xstat: ___xstat, __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21RotationBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z15GetAccelerationi: __Z15GetAccelerationi, __Z58Register_UnityEngine_Input_get_eatKeyPressOnTextFieldFocusv: __Z58Register_UnityEngine_Input_get_eatKeyPressOnTextFieldFocusv, __ZN22ParticleSystemRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN22ParticleSystemRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN20NavMeshBuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20NavMeshBuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK8GUIStyle17DrawTextUnderlineER8GUIStateRK5RectTIfER10GUIContentiiPK13GUIStyleState: __ZNK8GUIStyle17DrawTextUnderlineER8GUIStateRK5RectTIfER10GUIContentiiPK13GUIStyleState, __Z15GetAccelerationv: __Z15GetAccelerationv, __ZN7mecanim9animation19ClearAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation19ClearAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE, __Z43RenderSettings_CUSTOM_INTERNAL_get_fogColorP10ColorRGBAf: __Z43RenderSettings_CUSTOM_INTERNAL_get_fogColorP10ColorRGBAf, __Z65Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedMethodv: __Z65Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedMethodv, __ZN5physx2Sc8ClothSim8reinsertEv: __ZN5physx2Sc8ClothSim8reinsertEv, __ZN19CharacterController7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN19CharacterController7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN4crnd13prefix_coding14decoder_tables5clearEv: __ZN4crnd13prefix_coding14decoder_tables5clearEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv, __ZN9GfxDevice23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer: __ZN9GfxDevice23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer, __ZN13BoxCollider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN13BoxCollider2D23VirtualRedirectTransferER14SafeBinaryRead, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13getPropertiesEN5physx8debugger18NonNegativeIntegerEPNS2_19PropertyDescriptionEjj: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13getPropertiesEN5physx8debugger18NonNegativeIntegerEPNS2_19PropertyDescriptionEjj, __Z49CharacterJoint_CUSTOM_INTERNAL_set_highTwistLimitP12Il2CppObjectRK14SoftJointLimit: __Z49CharacterJoint_CUSTOM_INTERNAL_set_highTwistLimitP12Il2CppObjectRK14SoftJointLimit, __ZN23PreloadManagerOperationC2Ev: __ZN23PreloadManagerOperationC2Ev, __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_: __ZN14qsort_internal6_QSortIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEEEvT_S6_T0_T1_, __Z42Register_UnityEngine_Animator_GetBehaviourv: __Z42Register_UnityEngine_Animator_GetBehaviourv, __ZN5physx9NpPhysics11unlockSceneEv: __ZN5physx9NpPhysics11unlockSceneEv, __Z38AnimationClip_Set_Custom_PropFrameRateP12Il2CppObjectf: __Z38AnimationClip_Set_Custom_PropFrameRateP12Il2CppObjectf, __ZN4PPtrI11Rigidbody2DE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI11Rigidbody2DE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx5cloth15getNextFabricIdEv: __ZN5physx5cloth15getNextFabricIdEv, __ZN11TrailModuleD0Ev: __ZN11TrailModuleD0Ev, __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetBounceMultiplierv: __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetBounceMultiplierv, __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_14PxArticulationEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN15AudioEchoFilterD0Ev: __ZN15AudioEchoFilterD0Ev, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_, __ZN9TextAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9TextAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN17ProceduralTexture19UnloadFromGfxDeviceEb: __ZN17ProceduralTexture19UnloadFromGfxDeviceEb, __ZNK6Camera15IsValidToRenderEv: __ZNK6Camera15IsValidToRenderEv, __ZN17PersistentManager17IsObjectAvailableEi: __ZN17PersistentManager17IsObjectAvailableEi, __Z18InitializeVRModulev: __Z18InitializeVRModulev, __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace: __ZN7Texture19SetStoredColorSpaceE17TextureColorSpace, __Z42Register_UnityEngine_ParticleEmitter_Emit3v: __Z42Register_UnityEngine_ParticleEmitter_Emit3v, __Z13RegisterClassI16BaseVideoTextureEvv: __Z13RegisterClassI16BaseVideoTextureEvv, __Z52Register_UnityEngine_SystemInfo_get_graphicsDeviceIDv: __Z52Register_UnityEngine_SystemInfo_get_graphicsDeviceIDv, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI25CapsuleTraceSegmentReportE15testVertexIndexEj, __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE8recreateEj, __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEPK10TextureRef: __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEPK10TextureRef, __Z52Register_UnityEngine_Screen_set_autorotateToPortraitv: __Z52Register_UnityEngine_Screen_set_autorotateToPortraitv, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale1Ef, _UNITY_ft_pic_container_init: _UNITY_ft_pic_container_init, __Z16CalcInvDeltaTimef: __Z16CalcInvDeltaTimef, __ZNSt3__219__partial_sort_copyIRNS_6__lessI16dtCrowdNeighbourS2_EEPS2_S5_EET1_T0_S7_S6_S6_T_: __ZNSt3__219__partial_sort_copyIRNS_6__lessI16dtCrowdNeighbourS2_EEPS2_S5_EET1_T0_S7_S6_S6_T_, __Z49Register_UnityEngine_Animator_set_applyRootMotionv: __Z49Register_UnityEngine_Animator_set_applyRootMotionv, __ZN5physx2Sc9ClothCore6wakeUpEf: __ZN5physx2Sc9ClothCore6wakeUpEf, __ZN18ScreenManagerWebGLC2Ev: __ZN18ScreenManagerWebGLC2Ev, __ZN12HandlerChain8SetFlagsER13FileEntryDatajj: __ZN12HandlerChain8SetFlagsER13FileEntryDatajj, __Z58Register_UnityEngine_SystemInfo_get_deviceUniqueIdentifierv: __Z58Register_UnityEngine_SystemInfo_get_deviceUniqueIdentifierv, __ZN7ApiGLES12CheckProgramERj: __ZN7ApiGLES12CheckProgramERj, __Z20PlayerRenderUnityGUIi: __Z20PlayerRenderUnityGUIi, __ZL21PxcGenerateVFContactsRKN5physx2Cm8Matrix34ERNS_2Gu13ContactBufferERKNS4_7SegmentEfPKNS_6PxVec3ERSB_jf: __ZL21PxcGenerateVFContactsRKN5physx2Cm8Matrix34ERNS_2Gu13ContactBufferERKNS4_7SegmentEfPKNS_6PxVec3ERSB_jf, __Z59GeometryUtility_CUSTOM_INTERNAL_CALL_Internal_ExtractPlanesP11Il2CppArrayRK10Matrix4x4f: __Z59GeometryUtility_CUSTOM_INTERNAL_CALL_Internal_ExtractPlanesP11Il2CppArrayRK10Matrix4x4f, _UNITY_png_get_current_pass_number: _UNITY_png_get_current_pass_number, __ZN5physx6shdfnd10ThreadImpl5yieldEv: __ZN5physx6shdfnd10ThreadImpl5yieldEv, __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE11getTypeNameEv, __ZN7Joint2D7CleanupEb: __ZN7Joint2D7CleanupEb, __Z30GetBuiltinMatrixParamArraySize24BuiltinShaderMatrixParam: __Z30GetBuiltinMatrixParamArraySize24BuiltinShaderMatrixParam, __Z38AudioSource_Set_Custom_PropTimeSamplesP12Il2CppObjecti: __Z38AudioSource_Set_Custom_PropTimeSamplesP12Il2CppObjecti, __ZN8Material11SetPassSlowEiR17ShaderPassContextib: __ZN8Material11SetPassSlowEiR17ShaderPassContextib, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j, __ZNK30SpriteRendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK30SpriteRendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN5physx14NpRigidDynamic14setWakeCounterEf: __ZN5physx14NpRigidDynamic14setWakeCounterEf, __Z66Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserGenderv: __Z66Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserGenderv, __ZN16ParticleRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16ParticleRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx27PxClothGeodesicTetherCooker23getNbTethersPerParticleEv: __ZNK5physx27PxClothGeodesicTetherCooker23getNbTethersPerParticleEv, __ZN14RenderSettings8TransferI14SafeBinaryReadEEvRT_: __ZN14RenderSettings8TransferI14SafeBinaryReadEEvRT_, __ZN12MeshRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN12MeshRenderer13AwakeFromLoadE17AwakeFromLoadMode, __Z54Register_UnityEngine_PointEffector2D_set_distanceScalev: __Z54Register_UnityEngine_PointEffector2D_set_distanceScalev, __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11OffMeshLink8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Ext13RevoluteJoint28setProjectionLinearToleranceEf: __ZN5physx3Ext13RevoluteJoint28setProjectionLinearToleranceEf, __ZN5physx3Scb13ObjectTracker6removeERNS0_4BaseE: __ZN5physx3Scb13ObjectTracker6removeERNS0_4BaseE, __ZN11AudioModule23CreateAudioCustomFilterEP13MonoBehaviour: __ZN11AudioModule23CreateAudioCustomFilterEP13MonoBehaviour, _significand: _significand, __ZN5physx3Cct9SweepTest13moveCharacterEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERNS0_11SweptVolumeERKNS_6PxVec3ERKNS0_13UserObstaclesEfRKNS_19PxControllerFiltersEbb: __ZN5physx3Cct9SweepTest13moveCharacterEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERNS0_11SweptVolumeERKNS_6PxVec3ERKNS0_13UserObstaclesEfRKNS_19PxControllerFiltersEbb, __Z48Screen_Get_Custom_PropAutorotateToLandscapeRightv: __Z48Screen_Get_Custom_PropAutorotateToLandscapeRightv, __ZN5physx2Sn5ConvXC2Ev: __ZN5physx2Sn5ConvXC2Ev, __Z56Register_UnityEngine_SystemInfo_get_supportsImageEffectsv: __Z56Register_UnityEngine_SystemInfo_get_supportsImageEffectsv, __ZN4FMOD5Sound6unlockEPvS1_jj: __ZN4FMOD5Sound6unlockEPvS1_jj, __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformGetEv: __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformGetEv, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx2Sc5Scene20postCallbacksPreSyncEv: __ZN5physx2Sc5Scene20postCallbacksPreSyncEv, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE, __ZN14StackAllocatorILj16EE10deallocateEPv: __ZN14StackAllocatorILj16EE10deallocateEPv, __Z29Transfer_Blittable_ArrayFieldI8JSONRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_: __ZNSt3__227__tree_balance_after_insertIPNS_16__tree_node_baseIPvEEEEvT_S5_, __ZNK5physx19TriangleMeshBuilder4saveERNS_14PxOutputStreamEbRKNS_15PxCookingParamsE: __ZNK5physx19TriangleMeshBuilder4saveERNS_14PxOutputStreamEbRKNS_15PxCookingParamsE, _get_sfnt_table: _get_sfnt_table, _tt_sbit_decoder_load_byte_aligned: _tt_sbit_decoder_load_byte_aligned, __ZN14SphereCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14SphereCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN19AudioHighPassFilter16CheckConsistencyEv: __ZN19AudioHighPassFilter16CheckConsistencyEv, __Z55Register_UnityEngine_RenderTexture_set_autoGenerateMipsv: __Z55Register_UnityEngine_RenderTexture_set_autoGenerateMipsv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator10UpdateModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator10UpdateModeEEvRT_RT0_PKc17TransferMetaFlags, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE7getNameEv, __ZNSt3__26__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIxxEEPxEEvT0_S5_T_, __Z26getPxD6Joint_DriveVelocityPKN5physx9PxD6JointERNS_6PxVec3ES4_: __Z26getPxD6Joint_DriveVelocityPKN5physx9PxD6JointERNS_6PxVec3ES4_, __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14VehiclesModule19InitVehiclesManagerEv: __ZN14VehiclesModule19InitVehiclesManagerEv, __Z45Register_UnityEngine_HumanTrait_get_BoneCountv: __Z45Register_UnityEngine_HumanTrait_get_BoneCountv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN15CapsuleCollider22FetchPoseFromTransformEv: __ZN15CapsuleCollider22FetchPoseFromTransformEv, __ZN8UserList11RemoveIndexEi: __ZN8UserList11RemoveIndexEi, __ZNK6Avatar13GetHumanScaleEv: __ZNK6Avatar13GetHumanScaleEv, __ZN16ReflectionProbes12CleanupClassEv: __ZN16ReflectionProbes12CleanupClassEv, _unity_z_tr_stored_block: _unity_z_tr_stored_block, __Z46Register_UnityEngine_TerrainData_get_thicknessv: __Z46Register_UnityEngine_TerrainData_get_thicknessv, __Z60Register_UnityEngine_Input_INTERNAL_get_compositionCursorPosv: __Z60Register_UnityEngine_Input_INTERNAL_get_compositionCursorPosv, __ZN12FileAccessor9SetLengthEy: __ZN12FileAccessor9SetLengthEy, __ZNK22UnityProfilerPerThread15GetActiveSampleEi: __ZNK22UnityProfilerPerThread15GetActiveSampleEi, __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN16ScriptingManager24GetAssemblyNameForCSharpEv: __ZN16ScriptingManager24GetAssemblyNameForCSharpEv, __ZN7mecanim5human14HumanSetupAxesEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human14HumanSetupAxesEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZN13SparseTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13SparseTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5IMGUI25RestoreGUIStatePropertiesER8GUIStateR10InputEventRNS_23GUIStatePropertiesCacheE: __ZN5IMGUI25RestoreGUIStatePropertiesER8GUIStateR10InputEventRNS_23GUIStatePropertiesCacheE, __Z49Register_UnityEngine_WheelCollider_set_steerAnglev: __Z49Register_UnityEngine_WheelCollider_set_steerAnglev, __Z41Joint_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK8Vector3f: __Z41Joint_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK8Vector3f, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __GLOBAL__sub_I_artifacts_generated_webgl_modules_imgui_lump_cpp: __GLOBAL__sub_I_artifacts_generated_webgl_modules_imgui_lump_cpp, __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f: __Z21CalculateInbetweenKeyI8Vector3fE11KeyframeTplIT_ERKS3_S5_f, __ZN20OcclusionCullingData13AwakeFromLoadE17AwakeFromLoadMode: __ZN20OcclusionCullingData13AwakeFromLoadE17AwakeFromLoadMode, __Z13RegisterClassI5LightEvv: __Z13RegisterClassI5LightEvv, __ZN9JSONWrite8TransferI13dynamic_arrayIxLj8EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIxLj8EEEEvRT_PKc17TransferMetaFlags, __ZN5Light23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Light23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj578ENS_22PxRepXPropertyAccessorILj578ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj578ENS_22PxRepXPropertyAccessorILj578ES4_ffEEEEvRKT0_, __ZN5physx26PxSerializerDefaultAdapterINS_10NpMaterialEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_10NpMaterialEED0Ev, _UNITY_FT_Destroy_Class_sfnt_module_class: _UNITY_FT_Destroy_Class_sfnt_module_class, __ZNKSt3__217moneypunct_bynameIcLb1EE16do_decimal_pointEv: __ZNKSt3__217moneypunct_bynameIcLb1EE16do_decimal_pointEv, __Z38Register_UnityEngine_Camera_IsFilteredv: __Z38Register_UnityEngine_Camera_IsFilteredv, __ZN9ShaderLab19ParseQueueAndOffsetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERi: __ZN9ShaderLab19ParseQueueAndOffsetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERi, __ZN5physx14NpSpatialIndexC2Ev: __ZN5physx14NpSpatialIndexC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj400ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj400ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZL22ScheduleSceneNodesJobsP25ScheduleSceneNodesJobDataj: __ZL22ScheduleSceneNodesJobsP25ScheduleSceneNodesJobDataj, __ZN12BaseRenderer11ClearProbesER10RenderNode: __ZN12BaseRenderer11ClearProbesER10RenderNode, __Z47Register_UnityEngine_AudioEchoFilter_get_wetMixv: __Z47Register_UnityEngine_AudioEchoFilter_get_wetMixv, __ZN6Sprite23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Sprite23VirtualRedirectTransferER14SafeBinaryRead, __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE: __ZN2UI13CanvasManager16AddDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE, __ZN8Animator23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8Animator23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__218__libcpp_refstringC2EPKc: __ZNSt3__218__libcpp_refstringC2EPKc, __ZNK9Texture2D8GetPixelEiii: __ZNK9Texture2D8GetPixelEiii, __ZN16MemoryFileSystem8FindNodeEPKc: __ZN16MemoryFileSystem8FindNodeEPKc, __ZN11RadixSorter4SortEPfj: __ZN11RadixSorter4SortEPfj, __ZN5physx2Sc10ClothShapeD0Ev: __ZN5physx2Sc10ClothShapeD0Ev, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE19getConcreteTypeNameEv, __ZNKSt3__214error_category10equivalentEiRKNS_15error_conditionE: __ZNKSt3__214error_category10equivalentEiRKNS_15error_conditionE, _UNITY_png_handle_iTXt: _UNITY_png_handle_iTXt, __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN5Unity14CharacterJointD2Ev: __ZN5Unity14CharacterJointD2Ev, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5c_strEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5c_strEv, __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8Renderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcjj, __Z53Register_UnityEngine_AI_NavMeshAgent_set_angularSpeedv: __Z53Register_UnityEngine_AI_NavMeshAgent_set_angularSpeedv, __Z17setConstraintDataRN5physx19PxsParticleCollDataERKfRKNS_6PxVec3ES6_RKNS_11PxTransformE: __Z17setConstraintDataRN5physx19PxsParticleCollDataERKfRKNS_6PxVec3ES6_RKNS_11PxTransformE, __ZNK8GUIStyle14GetCurrentFontEv: __ZNK8GUIStyle14GetCurrentFontEv, __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbRK8Vector2fS3_EPS1_EEvT0_S8_T_, __ZN11Rigidbody2D11SetPositionERK8Vector2f: __ZN11Rigidbody2D11SetPositionERK8Vector2f, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_19NpArticulationJointEEEE15growAndPushBackERKS2_, __ZN9Transform22EnsureCapacityIncreaseEj: __ZN9Transform22EnsureCapacityIncreaseEj, __Z43ParticleSystem_Get_Custom_PropStartLifetimeP12Il2CppObject: __Z43ParticleSystem_Get_Custom_PropStartLifetimeP12Il2CppObject, __ZN5physx3Ext5joint16ConstraintHelper13halfAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE: __ZN5physx3Ext5joint16ConstraintHelper13halfAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE, __ZNK13GfxDeviceNull26GetActiveRenderTargetCountEv: __ZNK13GfxDeviceNull26GetActiveRenderTargetCountEv, __ZN5Unity11SpringJoint23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity11SpringJoint23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN19AudioHighPassFilter6UpdateEv: __ZN19AudioHighPassFilter6UpdateEv, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx2Gu27intersectRayTriangleCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f: __ZN5physx2Gu27intersectRayTriangleCullingERKNS_6PxVec3ES3_S3_S3_S3_RfS4_S4_f, __ZNK15AudioReverbZone15GetReverbPresetEv: __ZNK15AudioReverbZone15GetReverbPresetEv, __ZN5Unity5Joint22SetEnablePreprocessingEb: __ZN5Unity5Joint22SetEnablePreprocessingEb, __ZN12WWWDelayCall8CallbackEP6ObjectPv: __ZN12WWWDelayCall8CallbackEP6ObjectPv, __ZN5physx2Sc18ParticleSystemCore16setContactOffsetEf: __ZN5physx2Sc18ParticleSystemCore16setContactOffsetEf, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgramENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z38AudioSource_Get_Custom_PropTimeSamplesP12Il2CppObject: __Z38AudioSource_Get_Custom_PropTimeSamplesP12Il2CppObject, __Z32getPxParticleReadDataFlagsBufferPKN5physx18PxParticleReadDataE: __Z32getPxParticleReadDataFlagsBufferPKN5physx18PxParticleReadDataE, __Z48Register_UnityEngine_RenderTexture_set_useMipMapv: __Z48Register_UnityEngine_RenderTexture_set_useMipMapv, __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZN23ArchiveStorageConverter11ProcessDataEPKvj: __ZN23ArchiveStorageConverter11ProcessDataEPKvj, __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_: __ZN13dynamic_arrayIjLj4EE6insertEPjPKjS3_, __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE: __ZN5audio5mixer23DestroyAudioMixerMemoryEPNS0_16AudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorE, __ZN23UnityPurchasingSettingsD0Ev: __ZN23UnityPurchasingSettingsD0Ev, __ZN4FMOD6SoundI21getMusicChannelVolumeEiPf: __ZN4FMOD6SoundI21getMusicChannelVolumeEiPf, __Z29RemoteSettings_CUSTOM_GetBoolP12Il2CppStringh: __Z29RemoteSettings_CUSTOM_GetBoolP12Il2CppStringh, __ZN9Texture3D5ResetEv: __ZN9Texture3D5ResetEv, __Z52Register_UnityEngine_ParticleEmitter_set_rndRotationv: __Z52Register_UnityEngine_ParticleEmitter_set_rndRotationv, __ZN5physx7NpClothC2ENS_7PxFlagsINS_10PxBaseFlag4EnumEtEE: __ZN5physx7NpClothC2ENS_7PxFlagsINS_10PxBaseFlag4EnumEtEE, __Z53Register_UnityEngine_AI_OffMeshLink_get_biDirectionalv: __Z53Register_UnityEngine_AI_OffMeshLink_get_biDirectionalv, _truncate: _truncate, __Z41Animator_CUSTOM_INTERNAL_set_rootPositionP12Il2CppObjectRK8Vector3f: __Z41Animator_CUSTOM_INTERNAL_set_rootPositionP12Il2CppObjectRK8Vector3f, __ZNK7Terrain37GetLightmapSTConsideringDynamicUVRectE12LightmapType: __ZNK7Terrain37GetLightmapSTConsideringDynamicUVRectE12LightmapType, __ZN15QualitySettings14QualitySetting8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15QualitySettings14QualitySetting8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Umbra5Float8isFiniteEf: __ZN5Umbra5Float8isFiniteEf, __Z57ConfigurableJoint_CUSTOM_INTERNAL_get_angularXLimitSpringP12Il2CppObjectP20SoftJointLimitSpring: __Z57ConfigurableJoint_CUSTOM_INTERNAL_get_angularXLimitSpringP12Il2CppObjectP20SoftJointLimitSpring, __ZN12AudioManagerC2E10MemLabelId18ObjectCreationMode: __ZN12AudioManagerC2E10MemLabelId18ObjectCreationMode, __ZN13GfxDeviceGLES10BeginFrameEv: __ZN13GfxDeviceGLES10BeginFrameEv, __ZNK15Lz4Decompressor22DecompressStreamDeinitEPv: __ZNK15Lz4Decompressor22DecompressStreamDeinitEPv, __ZN17MessageIdentifier17GetSortedMessagesEb: __ZN17MessageIdentifier17GetSortedMessagesEb, __Z23ConvertIntegerToTypePtrIjEbPvR14SafeBinaryRead: __Z23ConvertIntegerToTypePtrIjEbPvR14SafeBinaryRead, __ZN12SpriteVertex8TransferI14SafeBinaryReadEEvRT_: __ZN12SpriteVertex8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx3Scb5Scene22getNbBroadPhaseRegionsEv: __ZNK5physx3Scb5Scene22getNbBroadPhaseRegionsEv, __ZN5Umbra12QueryContext10isGateOpenERKNS_6PortalE: __ZN5Umbra12QueryContext10isGateOpenERKNS_6PortalE, __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_: __ZN16LevelGameManager8TransferI17RemapPPtrTransferEEvRT_, __ZN7Joint2D20AddBreakLimitsUpdateEv: __ZN7Joint2D20AddBreakLimitsUpdateEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv, __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI10ColorRGBAfLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKiS2_EE: __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKiS2_EE, _strtoull_l: _strtoull_l, __ZN13SweepCallbackD0Ev: __ZN13SweepCallbackD0Ev, __ZN12MeshColliderC2E10MemLabelId18ObjectCreationMode: __ZN12MeshColliderC2E10MemLabelId18ObjectCreationMode, __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsStringERK8UnityStrS1_: __ZN11UnityEngine15PlatformWrapper20GetPlayerPrefsStringERK8UnityStrS1_, __Z44getPxParticleReadDataCollisionVelocityBufferPKN5physx18PxParticleReadDataE: __Z44getPxParticleReadDataCollisionVelocityBufferPKN5physx18PxParticleReadDataE, _UNITY_tt_face_load_any: _UNITY_tt_face_load_any, __ZN11Rigidbody2D5ResetEv: __ZN11Rigidbody2D5ResetEv, __Z54Register_UnityEngine_GUIUtility_Internal_GetHotControlv: __Z54Register_UnityEngine_GUIUtility_Internal_GetHotControlv, __ZN5physx22PxSphericalJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx22PxSphericalJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu30LargePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE13isSubordinateEv, __ZThn8_N5physx2Sc24ElementInteractionMarkerD1Ev: __ZThn8_N5physx2Sc24ElementInteractionMarkerD1Ev, __Z50ParticleSystem_CollisionModule_CUSTOM_GetVoxelSizeP12Il2CppObject: __Z50ParticleSystem_CollisionModule_CUSTOM_GetVoxelSizeP12Il2CppObject, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZN5Unity12PhysicsQuery10BoxCastAllERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery10BoxCastAllERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteraction, __ZN5physx20MTorqueCurvePropertyC2Ev: __ZN5physx20MTorqueCurvePropertyC2Ev, __ZN22BuiltinResourceManager24RegisterResourceInternalExPKcPKN5Unity4TypeES1_b: __ZN22BuiltinResourceManager24RegisterResourceInternalExPKcPKN5Unity4TypeES1_b, __ZN4FMOD13ChannelGroupI9getPausedEPb: __ZN4FMOD13ChannelGroupI9getPausedEPb, __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE8__appendEj, _UNITY_FT_Init_Class_cff_service_ps_name: _UNITY_FT_Init_Class_cff_service_ps_name, __ZL30GeomOverlapCallback_PlanePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL30GeomOverlapCallback_PlanePlaneRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf: __ZN5physx2Sc16ArticulationCore17setSleepThresholdEf, __ZNK6Avatar9GetZYRollEiRK8Vector3f: __ZNK6Avatar9GetZYRollEiRK8Vector3f, __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEj, __ZN5physx7NpActor29addConstraintsToSceneInternalEv: __ZN5physx7NpActor29addConstraintsToSceneInternalEv, __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j: __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEEEEEjT_j, __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK9Rigidbody: __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK9Rigidbody, __ZN10SizeModuleD0Ev: __ZN10SizeModuleD0Ev, __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatABGR8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatABGR8888EEvPKNS_9InnerInfoE, __ZN7mecanim9animation31UpdateAvatarMemoryFirstEvalFlagEPNS0_12AvatarMemoryEf: __ZN7mecanim9animation31UpdateAvatarMemoryFirstEvalFlagEPNS0_12AvatarMemoryEf, __ZN5physx10PxsContext15setCCDMaxPassesEj: __ZN5physx10PxsContext15setCCDMaxPassesEj, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZN16b2PolygonContactD0Ev: __ZN16b2PolygonContactD0Ev, __ZN19TouchPhaseEmulationD0Ev: __ZN19TouchPhaseEmulationD0Ev, __Z42AudioReverbFilter_Set_Custom_PropDiffusionP12Il2CppObjectf: __Z42AudioReverbFilter_Set_Custom_PropDiffusionP12Il2CppObjectf, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx9NpPhysics20releaseSceneInternalERNS_7PxSceneE: __ZN5physx9NpPhysics20releaseSceneInternalERNS_7PxSceneE, __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sn15PxMetaDataEntryENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNSt3__214__split_bufferIP4NodeNS_9allocatorIS2_EEE10push_frontERKS2_: __ZNSt3__214__split_bufferIP4NodeNS_9allocatorIS2_EEE10push_frontERKS2_, __ZN4FMOD6SoundI13getVariationsEPfS1_S1_: __ZN4FMOD6SoundI13getVariationsEPfS1_S1_, __Z24RegisterStrippedTypeInfoI23ShaderVariantCollectionEviPKcS2_: __Z24RegisterStrippedTypeInfoI23ShaderVariantCollectionEviPKcS2_, __ZN5physx2Gu9ContainerC2Ejf: __ZN5physx2Gu9ContainerC2Ejf, __Z45Register_UnityEngine_Object_DontDestroyOnLoadv: __Z45Register_UnityEngine_Object_DontDestroyOnLoadv, __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN22NavMeshProjectSettings8TransferI14SafeBinaryReadEEvRT_: __ZN22NavMeshProjectSettings8TransferI14SafeBinaryReadEEvRT_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z27CalculateOrientedBoxCornersPfPKfS1_S1_S1_S1_: __Z27CalculateOrientedBoxCornersPfPKfS1_S1_S1_S1_, __ZN5physx12PxLockedDataD2Ev: __ZN5physx12PxLockedDataD2Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z25Application_CUSTOM_Unloadv: __Z25Application_CUSTOM_Unloadv, __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb: __ZN5physx2Sc8BodyCore20tearDownSimStateDataEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEb, __Z6pqInitP9TESSallocP9PriorityQ: __Z6pqInitP9TESSallocP9PriorityQ, __ZNSt3__215numpunct_bynameIwEC2EPKcj: __ZNSt3__215numpunct_bynameIwEC2EPKcj, __ZNSt3__218__insertion_sort_3IRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_: __ZNSt3__218__insertion_sort_3IRPFbP10GUIElementS2_EPS2_EEvT0_S7_T_, __ZThn8_N5physx3Cct13BoxController15getPxControllerEv: __ZThn8_N5physx3Cct13BoxController15getPxControllerEv, _decompress_data: _decompress_data, _malloc_max_footprint: _malloc_max_footprint, __ZN20TextRenderingPrivate8TextMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20TextRenderingPrivate8TextMesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z23RemapVertexDataChannelsPKjjR10VertexData: __Z23RemapVertexDataChannelsPKjjR10VertexData, __Z46Register_UnityEngine_GUI_INTERNAL_CALL_DoLabelv: __Z46Register_UnityEngine_GUI_INTERNAL_CALL_DoLabelv, __ZL33RegisterModuleICalls_UnityConnectv: __ZL33RegisterModuleICalls_UnityConnectv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12getClassSizeEv, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetXv, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN15ArchiveReadFile4ReadEyPvPy: __ZN15ArchiveReadFile4ReadEyPvPy, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12_GLOBAL__N_112UserRenderer8drawTextEN5physx6PxVec3ENS1_8debugger8PvdColorEPKcz: __ZN12_GLOBAL__N_112UserRenderer8drawTextEN5physx6PxVec3ENS1_8debugger8PvdColorEPKcz, __Z30scripting_cast_object_to_arrayP12Il2CppObject: __Z30scripting_cast_object_to_arrayP12Il2CppObject, __ZN13DrawImmediate11FlushBufferEv: __ZN13DrawImmediate11FlushBufferEv, __ZN9b2Fixture6CreateEP16b2BlockAllocatorP6b2BodyPK12b2FixtureDef: __ZN9b2Fixture6CreateEP16b2BlockAllocatorP6b2BodyPK12b2FixtureDef, __ZN17GenericDynamicVBO10AllocateIBEjR21DynamicVBOChunkHandle: __ZN17GenericDynamicVBO10AllocateIBEjR21DynamicVBOChunkHandle, __ZN5physx2Sn9XmlParserD0Ev: __ZN5physx2Sn9XmlParserD0Ev, __Z58Register_UnityEngine_Physics2D_set_queriesStartInCollidersv: __Z58Register_UnityEngine_Physics2D_set_queriesStartInCollidersv, __Z31AndroidJNI_CUSTOM_FromLongArray13Il2Cpp_IntPtr: __Z31AndroidJNI_CUSTOM_FromLongArray13Il2Cpp_IntPtr, __ZN6Camera8TransferI14SafeBinaryReadEEvRT_: __ZN6Camera8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__27codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_: __ZNKSt3__27codecvtIDsc11__mbstate_tE5do_inERS1_PKcS5_RS5_PDsS7_RS7_, __ZN19CharacterController9SetCenterERK8Vector3f: __ZN19CharacterController9SetCenterERK8Vector3f, __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNKSt3__220__codecvt_utf8_utf16IDsE16do_always_noconvEv: __ZNKSt3__220__codecvt_utf8_utf16IDsE16do_always_noconvEv, __Z30Material_Get_Custom_PropShaderP12Il2CppObject: __Z30Material_Get_Custom_PropShaderP12Il2CppObject, __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128: __ZN5Cache9URLToPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE7Hash128, __Z38AudioSource_CUSTOM_SetScheduledEndTimeP12Il2CppObjectd: __Z38AudioSource_CUSTOM_SetScheduledEndTimeP12Il2CppObjectd, __Z43Camera_CUSTOM_ResetStereoProjectionMatricesP12Il2CppObject: __Z43Camera_CUSTOM_ResetStereoProjectionMatricesP12Il2CppObject, __ZN14MessageHandlerD2Ev: __ZN14MessageHandlerD2Ev, __ZN9Animation15UpdateAnimationEd: __ZN9Animation15UpdateAnimationEd, __ZN4FMOD6System17getRecordPositionEiPj: __ZN4FMOD6System17getRecordPositionEiPj, _openpty: _openpty, __Z53Register_UnityEngine_ConstantForce_INTERNAL_get_forcev: __Z53Register_UnityEngine_ConstantForce_INTERNAL_get_forcev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Umbra9FloatListC2EPfii: __ZN5Umbra9FloatListC2EPfii, __ZNK14AreaEffector2D18DesignedForTriggerEv: __ZNK14AreaEffector2D18DesignedForTriggerEv, __Z33CullingGroup_CUSTOM_EraseSwapBackP12Il2CppObjecti: __Z33CullingGroup_CUSTOM_EraseSwapBackP12Il2CppObjecti, __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif: __ZNK17AnimationCurveTplIfE18CalculateCacheDataERNS0_5CacheEiif, __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E: __ZNK24OptimizedPolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E, __ZN7mecanim9animation22DestroyControllerInputEPNS0_15ControllerInputERNS_6memory9AllocatorE: __ZN7mecanim9animation22DestroyControllerInputEPNS0_15ControllerInputERNS_6memory9AllocatorE, __ZN5physx3Cct17CapsuleController15invalidateCacheEv: __ZN5physx3Cct17CapsuleController15invalidateCacheEv, _isascii: _isascii, __Z13RegisterClassI9LensFlareEvv: __Z13RegisterClassI9LensFlareEvv, __ZN5physx2Sq11PruningPoolD2Ev: __ZN5physx2Sq11PruningPoolD2Ev, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7releaseEv, __ZN4FMOD6SoundI11setSubSoundEiPNS_5SoundE: __ZN4FMOD6SoundI11setSubSoundEiPNS_5SoundE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __ZN19MemoryProfilerStats18ResetGCAllocationsEv: __ZN19MemoryProfilerStats18ResetGCAllocationsEv, __Z25scripting_class_from_typePK10Il2CppType: __Z25scripting_class_from_typePK10Il2CppType, __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10ColorRGBAf8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatI8EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatI8EEvPKNS_9InnerInfoE, __Z42Register_UnityEngine_Animator_IsControlledv: __Z42Register_UnityEngine_Animator_IsControlledv, __ZN4crnd10dxt1_block17get_block_colors3EPNS_10color_quadIhiEEtt: __ZN4crnd10dxt1_block17get_block_colors3EPNS_10color_quadIhiEEtt, __ZN9dtNavMesh15connectIntLinksEP10dtMeshTile: __ZN9dtNavMesh15connectIntLinksEP10dtMeshTile, __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatARGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI18TexFormatARGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z37Register_UnityEngine_Input_get_anyKeyv: __Z37Register_UnityEngine_Input_get_anyKeyv, __ZN14NavMeshManager32SetOffMeshConnectionCostOverrideEyf: __ZN14NavMeshManager32SetOffMeshConnectionCostOverrideEyf, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE7reserveEj, __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskD0Ev: __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskD0Ev, __Z18ConvertUTF8toUTF32PKhiPmRi: __Z18ConvertUTF8toUTF32PKhiPmRi, _sleep: _sleep, __ZN5physx9PxTaskMgr12getNamedTaskEPKc: __ZN5physx9PxTaskMgr12getNamedTaskEPKc, __ZNSt3__28ios_base4moveERS0_: __ZNSt3__28ios_base4moveERS0_, __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_15PxParticleFluidEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, _UNITY_png_safecat: _UNITY_png_safecat, __ZN8UVModuleD2Ev: __ZN8UVModuleD2Ev, __ZNKSt3__215__codecvt_utf16IDiLb1EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IDiLb1EE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_, __Z44Register_UnityEngine_ParticleSystem_set_timev: __Z44Register_UnityEngine_ParticleSystem_set_timev, __ZN19TransportJavaScript9DoRequestERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEm21UnityWebRequestMethodS8_bbP12HeaderHelperP13UploadHandlerP15DownloadHandlerP14ResponseHelperP15UnityWebRequest: __ZN19TransportJavaScript9DoRequestERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEm21UnityWebRequestMethodS8_bbP12HeaderHelperP13UploadHandlerP15DownloadHandlerP14ResponseHelperP15UnityWebRequest, __Z18Transfer_BlittableI14SafeBinaryReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN8Collider8TransferI17RemapPPtrTransferEEvRT_: __ZN8Collider8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z39CanvasBatchIntermediateRenderer_CleanupR15RenderNodeQueuej: __Z39CanvasBatchIntermediateRenderer_CleanupR15RenderNodeQueuej, _remquo: _remquo, _write_marker_byte: _write_marker_byte, __Z21ExpandQuaternionCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE: __Z21ExpandQuaternionCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE, __ZN5Umbra17BasePoolAllocator9removeAllEv: __ZN5Umbra17BasePoolAllocator9removeAllEv, __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN14BillboardAssetD0Ev: __ZN14BillboardAssetD0Ev, __Z29getPxHeightFieldDescNbColumnsPKN5physx17PxHeightFieldDescE: __Z29getPxHeightFieldDescNbColumnsPKN5physx17PxHeightFieldDescE, __ZNK13Lz4Compressor14CompressStreamEPvPKvPjS0_S3_b: __ZNK13Lz4Compressor14CompressStreamEPvPKvPjS0_S3_b, __ZN12LineRenderer17SetPositionsCountEi: __ZN12LineRenderer17SetPositionsCountEi, __ZN19RingbufferTemplates22WriteValueToRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RKT_: __ZN19RingbufferTemplates22WriteValueToRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RKT_, __ZN9Texture2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Texture2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx7NpScene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb: __ZN5physx7NpScene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb, __ZN5physx7ConvexHC2Eiii: __ZN5physx7ConvexHC2Eiii, __ZNKSt3__214__codecvt_utf8IwE11do_encodingEv: __ZNKSt3__214__codecvt_utf8IwE11do_encodingEv, __ZN8VRDevice14AfterRenderingEv: __ZN8VRDevice14AfterRenderingEv, __Z42BillboardRenderer_Set_Custom_PropBillboardP12Il2CppObjectS0_: __Z42BillboardRenderer_Set_Custom_PropBillboardP12Il2CppObjectS0_, __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN22PerThreadPageAllocator10InitializeER19AtomicPageAllocator: __ZN22PerThreadPageAllocator10InitializeER19AtomicPageAllocator, __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI14BillboardAssetE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN16MemoryFileSystemC2EPKc: __ZN16MemoryFileSystemC2EPKc, __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_ClearRenderTargetP12Il2CppObjecthhRK10ColorRGBAff: __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_ClearRenderTargetP12Il2CppObjecthhRK10ColorRGBAff, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags, __ZN22UnityProfilerPerThread24AddMiscSamplesAfterFrameEyb: __ZN22UnityProfilerPerThread24AddMiscSamplesAfterFrameEyb, __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEi: __ZN7mecanim5human18Skeleton2HumanPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEi, __ZN9ShaderLab16CleanupShaderLabEv: __ZN9ShaderLab16CleanupShaderLabEv, __Z70Register_UnityEngine_AI_NavMeshAgent_GetCurrentOffMeshLinkDataInternalv: __Z70Register_UnityEngine_AI_NavMeshAgent_GetCurrentOffMeshLinkDataInternalv, __ZN4FMOD3DSP16getSpeakerActiveE12FMOD_SPEAKERPb: __ZN4FMOD3DSP16getSpeakerActiveE12FMOD_SPEAKERPb, __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimev: __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimev, __ZNSt3__218__insertion_sort_3IRNS_6__lessIwwEEPwEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIwwEEPwEEvT0_S5_T_, __ZN5Umbra10QueryState10getWorkMemERPhRj: __ZN5Umbra10QueryState10getWorkMemERPhRj, __Z15RetainLightmapsR12LightmapData: __Z15RetainLightmapsR12LightmapData, __ZN12HingeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12HingeJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _ttyname: _ttyname, __ZN7Texture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN7Texture7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx14NpRigidDynamic24getSolverIterationCountsERjS1_: __ZNK5physx14NpRigidDynamic24getSolverIterationCountsERjS1_, __Z30setPxCloth_AngularInertiaScalePN5physx7PxClothENS_6PxVec3E: __Z30setPxCloth_AngularInertiaScalePN5physx7PxClothENS_6PxVec3E, __ZN9GfxDevice21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE: __ZN9GfxDevice21DestroyComputeProgramER12ObjectHandleI18ComputeProgram_TagPvE, __ZN20TextRenderingPrivate13ApplyToMeshesEv: __ZN20TextRenderingPrivate13ApplyToMeshesEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE13isSubordinateEv, __ZN12_GLOBAL__N_112RenderReaderILb1EED0Ev: __ZN12_GLOBAL__N_112RenderReaderILb1EED0Ev, __ZN11UnityEngine15CloudWebService16SessionContainer17ArchiveEventQueueERK8UnityStrS4_: __ZN11UnityEngine15CloudWebService16SessionContainer17ArchiveEventQueueERK8UnityStrS4_, __ZN4FMOD8ChannelI10getDSPHeadEPPNS_3DSPE: __ZN4FMOD8ChannelI10getDSPHeadEPPNS_3DSPE, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED2Ev: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEED2Ev, __Z19raycast_heightFieldRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z19raycast_heightFieldRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv, __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj: __ZN5physx6shdfnd5ArrayItNS0_19ReflectionAllocatorItEEE8recreateEj, __ZNK16Physics2DManager23GetIgnoreLayerCollisionEii: __ZNK16Physics2DManager23GetIgnoreLayerCollisionEii, __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyRotationInternalv: __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyRotationInternalv, __Z31RemoteSettings_CUSTOM_GetStringP12Il2CppStringS0_: __Z31RemoteSettings_CUSTOM_GetStringP12Il2CppStringS0_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj189ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj189ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZNK5physx7NpScene11getNbActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE: __ZNK5physx7NpScene11getNbActorsENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_16NpParticleSystemEEEE15growAndPushBackERKS2_, __Z47BillboardAsset_CUSTOM_GetImageTexCoordsInternalP12Il2CppObjectS0_: __Z47BillboardAsset_CUSTOM_GetImageTexCoordsInternalP12Il2CppObjectS0_, __Z19getPxMaterial_FlagsPKN5physx10PxMaterialE: __Z19getPxMaterial_FlagsPKN5physx10PxMaterialE, __ZN15SharedLightData16CheckConsistencyEv: __ZN15SharedLightData16CheckConsistencyEv, __Z45Register_UnityEngine_AssetBundle_LoadFromFilev: __Z45Register_UnityEngine_AssetBundle_LoadFromFilev, __ZN17RenderLoopContextC2E10MemLabelId: __ZN17RenderLoopContextC2E10MemLabelId, __ZThn8_N5physx13NpClothFabricD0Ev: __ZThn8_N5physx13NpClothFabricD0Ev, __ZN14TerrainManager12GetWorldAABBEPN5Unity9ComponentE: __ZN14TerrainManager12GetWorldAABBEPN5Unity9ComponentE, __Z21GetBlendShapeVerticesP8Vector3fS0_S0_RK13dynamic_arrayI16BlendShapeVertexLj4EERK10BlendShapei: __Z21GetBlendShapeVerticesP8Vector3fS0_S0_RK13dynamic_arrayI16BlendShapeVertexLj4EERK10BlendShapei, __Z39Register_UnityEngine_Cubemap_get_formatv: __Z39Register_UnityEngine_Cubemap_get_formatv, __Z62AnimatorControllerPlayable_CUSTOM_CrossFadeInFixedTimeInternalR9HPlayableifif: __Z62AnimatorControllerPlayable_CUSTOM_CrossFadeInFixedTimeInternalR9HPlayableifif, __ZN5physx16PxsBroadPhaseMBP9updatePPUEPNS_10PxBaseTaskE: __ZN5physx16PxsBroadPhaseMBP9updatePPUEPNS_10PxBaseTaskE, __ZN5physx16PxVehicleIsInAirERKNS_25PxVehicleWheelQueryResultE: __ZN5physx16PxVehicleIsInAirERKNS_25PxVehicleWheelQueryResultE, __Z53ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsWidthP12Il2CppObject: __Z53ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsWidthP12Il2CppObject, __ZN15LocationService22IsServiceEnabledByUserEv: __ZN15LocationService22IsServiceEnabledByUserEv, __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb: __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb, __ZNK13SliderJoint2D13GetJointSpeedEv: __ZNK13SliderJoint2D13GetJointSpeedEv, __ZN5physx2Sc12BodyIterator7getNextEv: __ZN5physx2Sc12BodyIterator7getNextEv, __ZN5Umbra10StackAlloc8allocateEjPKc: __ZN5Umbra10StackAlloc8allocateEjPKc, __Z32setPxVehicleDriveNWMDriveSimDataPN5physx16PxVehicleDriveNWENS_23PxVehicleDriveSimDataNWE: __Z32setPxVehicleDriveNWMDriveSimDataPN5physx16PxVehicleDriveNWENS_23PxVehicleDriveSimDataNWE, __ZN5physx6shdfnd10Foundation19AlignCheckAllocatorD0Ev: __ZN5physx6shdfnd10Foundation19AlignCheckAllocatorD0Ev, __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp: __Z35scripting_object_get_virtual_methodP12Il2CppObject21ScriptingMethodIl2Cpp, _ft_black_done: _ft_black_done, __ZN12HingeJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN12HingeJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN10GUITexture8SetColorERK10ColorRGBAf: __ZN10GUITexture8SetColorERK10ColorRGBAf, __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalSetCustomMethodv: __Z71Register_UnityEngine_Networking_UnityWebRequest_InternalSetCustomMethodv, __ZN4math8Collider8TransferI14SafeBinaryReadEEvRT_: __ZN4math8Collider8TransferI14SafeBinaryReadEEvRT_, __Z36GetParticleSystemScriptingClassesPtrv: __Z36GetParticleSystemScriptingClassesPtrv, __Z44Register_UnityEngine_AI_NavMesh_SetLayerCostv: __Z44Register_UnityEngine_AI_NavMesh_SetLayerCostv, __ZN9GfxDevice15EndProfileEventEv: __ZN9GfxDevice15EndProfileEventEv, __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation13LayerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx2Sc15ArticulationSim16updateDriveCacheERNS_9PxcFsDataEfj: __ZNK5physx2Sc15ArticulationSim16updateDriveCacheERNS_9PxcFsDataEfj, __ZNSt3__214collate_bynameIwED0Ev: __ZNSt3__214collate_bynameIwED0Ev, __Z55Rigidbody_CUSTOM_INTERNAL_CALL_GetRelativePointVelocityP12Il2CppObjectRK8Vector3fRS1_: __Z55Rigidbody_CUSTOM_INTERNAL_CALL_GetRelativePointVelocityP12Il2CppObjectRK8Vector3fRS1_, _cf2_arrstack_size: _cf2_arrstack_size, _unzOpen2: _unzOpen2, __Z41RenderTexture_Set_Custom_PropAntiAliasingP12Il2CppObjecti: __Z41RenderTexture_Set_Custom_PropAntiAliasingP12Il2CppObjecti, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE6PrefixENS_4TypeE, __ZNK9dtNavMesh10getTilesAtEiiPPK10dtMeshTilei: __ZNK9dtNavMesh10getTilesAtEiiPPK10dtMeshTilei, __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_: __ZN5physx6shdfnd8internal11HashMapBaseINS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplENS5_20NamespacedNameHasherENS3_19ForwardingAllocatorEE6insertES4_S7_, __ZN11ContextGLES18HandleInvalidStateEPb: __ZN11ContextGLES18HandleInvalidStateEPb, __ZN14PhysicsManager20GetDefaultPxMaterialEv: __ZN14PhysicsManager20GetDefaultPxMaterialEv, __Z56Register_UnityEngine_Physics_get_defaultSolverIterationsv: __Z56Register_UnityEngine_Physics_get_defaultSolverIterationsv, __Z69Register_UnityEngine_Connect_UnityAdsSettings_set_initializeOnStartupv: __Z69Register_UnityEngine_Connect_UnityAdsSettings_set_initializeOnStartupv, __Z32GetTextRenderingScriptingClassesv: __Z32GetTextRenderingScriptingClassesv, __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags, __Z40GUIUtility_CUSTOM_Internal_SetHotControli: __Z40GUIUtility_CUSTOM_Internal_SetHotControli, __ZNSt13bad_exceptionD0Ev: __ZNSt13bad_exceptionD0Ev, __ZNK16MemoryFileSystem12GetAssetGUIDERK13FileEntryData: __ZNK16MemoryFileSystem12GetAssetGUIDERK13FileEntryData, __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv: __ZN5physx6shdfnd10ThreadImpl11waitForQuitEv, __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z61Register_UnityEngine_ParticleSystemRenderer_set_velocityScalev: __Z61Register_UnityEngine_ParticleSystemRenderer_set_velocityScalev, __Z29CanvasRenderer_CUSTOM_SetMeshP12Il2CppObjectS0_: __Z29CanvasRenderer_CUSTOM_SetMeshP12Il2CppObjectS0_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z58Register_UnityEngine_ParticleSystem_TrailModule_GetEnabledv: __Z58Register_UnityEngine_ParticleSystem_TrailModule_GetEnabledv, __Z24RegisterStrippedTypeInfoI6MotionEviPKcS2_: __Z24RegisterStrippedTypeInfoI6MotionEviPKcS2_, __Z48Register_UnityEngine_Terrain_get_legacyShininessv: __Z48Register_UnityEngine_Terrain_get_legacyShininessv, __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit: __Z36ConvertRayCastHitColliderToScriptingP10RaycastHit, __ZL35CleanupUnityConnectScriptingClassesv: __ZL35CleanupUnityConnectScriptingClassesv, __ZL16CalculateBoxHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff: __ZL16CalculateBoxHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, _gethostent: _gethostent, __ZN18ScriptingArguments8AddArrayEP11Il2CppArray: __ZN18ScriptingArguments8AddArrayEP11Il2CppArray, __Z20getPxShape_LocalPosePKN5physx7PxShapeE: __Z20getPxShape_LocalPosePKN5physx7PxShapeE, __Z46Animator_Set_Custom_PropLayersAffectMassCenterP12Il2CppObjecth: __Z46Animator_Set_Custom_PropLayersAffectMassCenterP12Il2CppObjecth, __Z14OutputContoursP14TESStesselatorP8TESSmeshi: __Z14OutputContoursP14TESStesselatorP8TESSmeshi, __ZNK9Texture3D9GetPixelsEP10ColorRGBAfi: __ZNK9Texture3D9GetPixelsEP10ColorRGBAfi, __ZNK29ParticleSystemPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK29ParticleSystemPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN5physx2Sn5ConvX20getCurrentOutputSizeEv: __ZN5physx2Sn5ConvX20getCurrentOutputSizeEv, __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags, __Z12testransSignP10TESSvertexS0_S0_: __Z12testransSignP10TESSvertexS0_S0_, __Z50Register_UnityEngine_Audio_AudioMixer_FindSnapshotv: __Z50Register_UnityEngine_Audio_AudioMixer_FindSnapshotv, _UNITY_tt_face_load_bhed: _UNITY_tt_face_load_bhed, __Z27GUIText_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString: __Z27GUIText_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString, __ZN15AudioReverbZone5ResetEv: __ZN15AudioReverbZone5ResetEv, __ZN24b2ChainAndPolygonContactD0Ev: __ZN24b2ChainAndPolygonContactD0Ev, __ZN14Texture2DArray9SetPixelsEiPK10ColorRGBAfii: __ZN14Texture2DArray9SetPixelsEiPK10ColorRGBAfii, __Z25dtMergeCorridorStartMovedPyiiPKyi: __Z25dtMergeCorridorStartMovedPyiiPKyi, _UNITY_FT_Select_Metrics: _UNITY_FT_Select_Metrics, __ZN16BaseVideoTextureD2Ev: __ZN16BaseVideoTextureD2Ev, __ZNK14CompletionTask7getNameEv: __ZNK14CompletionTask7getNameEv, __Z37NavMeshObstacle_Get_Custom_PropHeightP12Il2CppObject: __Z37NavMeshObstacle_Get_Custom_PropHeightP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI12SpriteVertexLj4EEEEvRT_17TransferMetaFlags, _tt_sbit_decoder_load_bit_aligned: _tt_sbit_decoder_load_bit_aligned, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj150ENS_22PxRepXPropertyAccessorILj150ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_: __ZN9Polygon2D21GenerateNSidedPolygonEiRK8Vector2fS2_, __Z29StdTemplateConversionFunctionIbhEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbhEbPvR14SafeBinaryRead, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16setContactOffsetEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16setContactOffsetEf, __Z26getPxScene_SolverBatchSizePKN5physx7PxSceneE: __Z26getPxScene_SolverBatchSizePKN5physx7PxSceneE, __Z50Register_UnityEngine_Graphics_ExecuteCommandBufferv: __Z50Register_UnityEngine_Graphics_ExecuteCommandBufferv, _jsimd_can_idct_ifast: _jsimd_can_idct_ifast, __Z49Register_UnityEngine_ParticleSystem_get_isPlayingv: __Z49Register_UnityEngine_ParticleSystem_get_isPlayingv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN28BucketPrunerOverlapTraversalI19SphereAABBTest_SIMDLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E: __ZN28BucketPrunerOverlapTraversalI19SphereAABBTest_SIMDLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E, __ZN20TextRenderingPrivate8TextMesh10SetOffsetZEf: __ZN20TextRenderingPrivate8TextMesh10SetOffsetZEf, __ZN13RuntimeStaticI12AdsIdHandlerE16StaticInitializeEPv: __ZN13RuntimeStaticI12AdsIdHandlerE16StaticInitializeEPv, __Z41Joint_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP8Vector3f: __Z41Joint_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP8Vector3f, __ZN13MonoBehaviour40AddExternalDependencyCallbacksToManagersEv: __ZN13MonoBehaviour40AddExternalDependencyCallbacksToManagersEv, __Z70Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistancev: __Z70Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistancev, __Z26RandomBarycentricCoordEdgeR5RandN: __Z26RandomBarycentricCoordEdgeR5RandN, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z20ConvertColorKeyArrayP11Il2CppArrayPN8Gradient8ColorKeyE: __Z20ConvertColorKeyArrayP11Il2CppArrayPN8Gradient8ColorKeyE, __ZN13MemoryManager13StaticDestroyEv: __ZN13MemoryManager13StaticDestroyEv, __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefEP11FT_FaceRec_EENS_19__map_value_compareIS3_S6_NS_4lessIS3_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __Z52Register_UnityEngine_BoxCollider_INTERNAL_set_centerv: __Z52Register_UnityEngine_BoxCollider_INTERNAL_set_centerv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_RenderTexture_set_enabledv: __Z46Register_UnityEngine_RenderTexture_set_enabledv, __Z47Register_UnityEngine_GameObject_CreatePrimitivev: __Z47Register_UnityEngine_GameObject_CreatePrimitivev, __ZN5physx2Gu25computeMTD_BoxHeightFieldERNS_6PxVec3ERfRKNS0_3BoxERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE: __ZN5physx2Gu25computeMTD_BoxHeightFieldERNS_6PxVec3ERfRKNS0_3BoxERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE, __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev: __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED1Ev, __Z51Register_UnityEngine_AudioChorusFilter_get_feedbackv: __Z51Register_UnityEngine_AudioChorusFilter_get_feedbackv, __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcRNS_21PxProfileNameProviderEj: __ZN5physx13PxProfileZone17createProfileZoneEPNS_19PxAllocatorCallbackEPKcRNS_21PxProfileNameProviderEj, __ZNK13SplatDatabase22GetSpecularMetallicMapEv: __ZNK13SplatDatabase22GetSpecularMetallicMapEv, __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEED0Ev: __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEED0Ev, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryD2Ev, __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI19AutoOffMeshLinkData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j, __ZN5physx3Cct26CharacterControllerManagerD0Ev: __ZN5physx3Cct26CharacterControllerManagerD0Ev, __ZL17Transfer_GUIStyleI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE16getNbConstraintsEv: __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE16getNbConstraintsEv, __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEjRKf: __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEjRKf, __ZN5physx25PxAggregateRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx25PxAggregateRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNK5physx38PxsSolverCreateFinalizeConstraintsTask7getNameEv: __ZNK5physx38PxsSolverCreateFinalizeConstraintsTask7getNameEv, __Z63Register_UnityEngine_Networking_UnityWebRequest_InternalDestroyv: __Z63Register_UnityEngine_Networking_UnityWebRequest_InternalDestroyv, __ZL27PrepareSceneNodesJobCombineP25ScheduleSceneNodesJobData: __ZL27PrepareSceneNodesJobCombineP25ScheduleSceneNodesJobData, __ZN9Heightmap13AwakeFromLoadEv: __ZN9Heightmap13AwakeFromLoadEv, __ZN14SafeBinaryRead4WalkERK16TypeTreeIteratorPi: __ZN14SafeBinaryRead4WalkERK16TypeTreeIteratorPi, __ZN2UI6Canvas24NestedCanvasListContainsEPS0_: __ZN2UI6Canvas24NestedCanvasListContainsEPS0_, __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE: __ZNK5physx11PxsCCDShape10getAbsPoseEPKNS_12PxsRigidBodyE, __ZN19CharacterControllerC2E10MemLabelId18ObjectCreationMode: __ZN19CharacterControllerC2E10MemLabelId18ObjectCreationMode, _UNITY_tt_face_load_sbit_image: _UNITY_tt_face_load_sbit_image, __Z55Register_UnityEngine_AudioReverbFilter_get_decayHFRatiov: __Z55Register_UnityEngine_AudioReverbFilter_get_decayHFRatiov, __ZNSt11logic_errorC2ERKS_: __ZNSt11logic_errorC2ERKS_, __ZN19MemoryProfilerStats14RegisterObjectEP6Object: __ZN19MemoryProfilerStats14RegisterObjectEP6Object, __ZN5physx13NpRigidStatic8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx13NpRigidStatic8requiresERNS_23PxProcessPxBaseCallbackE, __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE: __ZN11UnityEngine9Animation26CreateAnimationSetBindingsEPKN7mecanim9animation18ControllerConstantERK13dynamic_arrayI4PPtrI13AnimationClipELj4EERNS1_6memory9AllocatorE, __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14ParticleSystem24SetCustomSimulationSpaceERK4PPtrI9TransformE: __ZN14ParticleSystem24SetCustomSimulationSpaceERK4PPtrI9TransformE, _unity_z_zlibVersion: _unity_z_zlibVersion, __Z42Camera_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf: __Z42Camera_CUSTOM_INTERNAL_get_backgroundColorP12Il2CppObjectP10ColorRGBAf, __Z28Scene_CUSTOM_GetNameInternali: __Z28Scene_CUSTOM_GetNameInternali, __ZN7Terrain31UpdateTerrainRendererLightmapSTE12LightmapType: __ZN7Terrain31UpdateTerrainRendererLightmapSTE12LightmapType, __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI14SafeBinaryReadEEvRT_, __ZN11MonoManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11MonoManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z40Register_UnityEngine_GL_IssuePluginEventv: __Z40Register_UnityEngine_GL_IssuePluginEventv, __ZN11AudioSource19UpdateReverbZoneMixE12SoundChannelf: __ZN11AudioSource19UpdateReverbZoneMixE12SoundChannelf, __Z55Register_UnityEngine_BuoyancyEffector2D_get_angularDragv: __Z55Register_UnityEngine_BuoyancyEffector2D_get_angularDragv, __ZN15QualitySettings19SetShadowResolutionENS_16ShadowResolutionE: __ZN15QualitySettings19SetShadowResolutionENS_16ShadowResolutionE, __ZN9Animation9IsPlayingERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation9IsPlayingERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN18GfxFramebufferGLES25GetCurrentFramebufferNameEv: __ZN18GfxFramebufferGLES25GetCurrentFramebufferNameEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __ZN11UnityEngine7Connect17DeviceInfoUpdater17LookForAppChangesERNS0_15DeviceInfoEventEj: __ZN11UnityEngine7Connect17DeviceInfoUpdater17LookForAppChangesERNS0_15DeviceInfoEventEj, __Z40GetPersistentDataPathApplicationSpecificv: __Z40GetPersistentDataPathApplicationSpecificv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev, __ZN5physx9NpFactory20createParticleSystemEjb: __ZN5physx9NpFactory20createParticleSystemEjb, __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv: __ZN5physx2Sc19ShapeInstancePairLL14destroyManagerEv, __Z9SetIUmbraP6IUmbra: __Z9SetIUmbraP6IUmbra, __Z19GetBehaviourManagerv: __Z19GetBehaviourManagerv, __ZNK15Lz4Decompressor20DecompressStreamInitEPPv: __ZNK15Lz4Decompressor20DecompressStreamInitEPPv, __Z34HumanTrait_Get_Custom_PropBoneNamev: __Z34HumanTrait_Get_Custom_PropBoneNamev, __ZNK5physx7NpCloth23getSimulationFilterDataEv: __ZNK5physx7NpCloth23getSimulationFilterDataEv, __ZNK13BuildSettings15GetHashOfScriptERK7Hash128: __ZNK13BuildSettings15GetHashOfScriptERK7Hash128, __ZN18ScriptingArguments7AddEnumEi: __ZN18ScriptingArguments7AddEnumEi, __ZN5Umbra16TileTraverseTreeC2EPNS_12QueryContextEi: __ZN5Umbra16TileTraverseTreeC2EPNS_12QueryContextEi, __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb: __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb, __ZN5physx2Sc16InteractionScene8addActorERNS0_5ActorEb: __ZN5physx2Sc16InteractionScene8addActorERNS0_5ActorEb, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj32EEEEEE15growAndPushBackERKS2_, __ZNK7ApiGLES18GetFramebufferInfoEv: __ZNK7ApiGLES18GetFramebufferInfoEv, __Z38Canvas_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString: __Z38Canvas_Set_Custom_PropSortingLayerNameP12Il2CppObjectP12Il2CppString, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb, __ZN5physx3Cct10Controller15releaseInternalEv: __ZN5physx3Cct10Controller15releaseInternalEv, __Z26DestroyGameObjectHierarchyR10GameObject: __Z26DestroyGameObjectHierarchyR10GameObject, _tt_cmap4_char_map_binary: _tt_cmap4_char_map_binary, __Z29getPxD6Joint_ConcreteTypeNamePKN5physx9PxD6JointE: __Z29getPxD6Joint_ConcreteTypeNamePKN5physx9PxD6JointE, __ZNSt3__221recursive_timed_mutex4lockEv: __ZNSt3__221recursive_timed_mutex4lockEv, __ZN5physx36PxHeightFieldGeometryGeneratedValuesC2EPKNS_21PxHeightFieldGeometryE: __ZN5physx36PxHeightFieldGeometryGeneratedValuesC2EPKNS_21PxHeightFieldGeometryE, __ZN15AudioEchoFilter16CheckConsistencyEv: __ZN15AudioEchoFilter16CheckConsistencyEv, __ZN10MeshFilter20WillDestroyComponentEv: __ZN10MeshFilter20WillDestroyComponentEv, __Z30Animation_CUSTOM_GetStateCountP12Il2CppObject: __Z30Animation_CUSTOM_GetStateCountP12Il2CppObject, __ZN10GUITexture12CleanupClassEv: __ZN10GUITexture12CleanupClassEv, __ZN4FMOD4DSPI16getSpeakerActiveE12FMOD_SPEAKERPb: __ZN4FMOD4DSPI16getSpeakerActiveE12FMOD_SPEAKERPb, __ZN5physx9NpPhysics23getPvdConnectionManagerEv: __ZN5physx9NpPhysics23getPvdConnectionManagerEv, __ZN16LightmapSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16LightmapSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __Z24RegisterStrippedTypeInfoI17AudioReverbFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI17AudioReverbFilterEviPKcS2_, _wctype_l: _wctype_l, __ZN20BufferedSocketStreamC2Eijj: __ZN20BufferedSocketStreamC2Eijj, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE: __ZN12_GLOBAL__N_117ConnectionManager12onDisconnectERN5physx8debugger4comm31PvdCommStreamInternalConnectionE, __ZN7mecanim12statemachine27IsCurrentTransitionAnyStateEPKNS0_18StateMachineMemoryE: __ZN7mecanim12statemachine27IsCurrentTransitionAnyStateEPKNS0_18StateMachineMemoryE, __ZN5physx7NpScene29addArticulationLinkConstraintERNS_18NpArticulationLinkE: __ZN5physx7NpScene29addArticulationLinkConstraintERNS_18NpArticulationLinkE, __ZN6Camera18RenderDepthTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera18RenderDepthTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE, __ZN9GfxDevice25GetBackBufferDepthSurfaceEv: __ZN9GfxDevice25GetBackBufferDepthSurfaceEv, __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Umbra7FrustumC2Effff: __ZN5Umbra7FrustumC2Effff, __ZN5physx18PxShortestRotationERKNS_6PxVec3ES2_: __ZN5physx18PxShortestRotationERKNS_6PxVec3ES2_, __Z43Camera_CUSTOM_INTERNAL_get_projectionMatrixP12Il2CppObjectP10Matrix4x4f: __Z43Camera_CUSTOM_INTERNAL_get_projectionMatrixP12Il2CppObjectP10Matrix4x4f, __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E: __ZN5physx2Sc8BodyCore17setInverseInertiaERKNS_6PxVec3E, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff: __Z10RecordEmitR27ParticleSystemEmissionStateRK28ParticleSystemSubEmitterDataRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles21ParticleSystemSubTypeijfff, __Z62Register_UnityEngine_QualitySettings_set_particleRaycastBudgetv: __Z62Register_UnityEngine_QualitySettings_set_particleRaycastBudgetv, __Z34Register_UnityEngine_Input_GetAxisv: __Z34Register_UnityEngine_Input_GetAxisv, __Z45AudioSettings_Set_Custom_PropOutputSampleRatei: __Z45AudioSettings_Set_Custom_PropOutputSampleRatei, __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZDriveP12Il2CppObjectRK10JointDrive: __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZDriveP12Il2CppObjectRK10JointDrive, __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z39Register_UnityEngine_Cloth_get_frictionv: __Z39Register_UnityEngine_Cloth_get_frictionv, __ZN13b2DynamicTree9MoveProxyEiRK6b2AABBRK6b2Vec2: __ZN13b2DynamicTree9MoveProxyEiRK6b2AABBRK6b2Vec2, _cfsetospeed: _cfsetospeed, __ZN12LineRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12LineRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN19StreamedBinaryWriteILb0EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData: __ZN19StreamedBinaryWriteILb0EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData, __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE: __ZN5Unity12PhysicsQuery15BoxCastInternalERK8Vector3fS3_S3_RK11Quaternionffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_10PxSweepHitEEE, __ZN4math4Axes8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4math4Axes8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z36Cloth_Get_Custom_PropSphereCollidersP12Il2CppObject: __Z36Cloth_Get_Custom_PropSphereCollidersP12Il2CppObject, __Z16DrawSplashScreenb: __Z16DrawSplashScreenb, __Z36Texture2DArray_Get_Custom_PropFormatP12Il2CppObject: __Z36Texture2DArray_Get_Custom_PropFormatP12Il2CppObject, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjPKcj, __Z47Register_UnityEngine_Camera_get_stereoActiveEyev: __Z47Register_UnityEngine_Camera_get_stereoActiveEyev, __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeIPN2UI14CanvasRendererENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z43PhysicMaterial_Set_Custom_PropBounceCombineP12Il2CppObjecti: __Z43PhysicMaterial_Set_Custom_PropBounceCombineP12Il2CppObjecti, __Z16LightAttenuationIhEvP9Texture2DPT_iiii: __Z16LightAttenuationIhEvP9Texture2DPT_iiii, __Z60Register_UnityEngine_Renderer_get_motionVectorGenerationModev: __Z60Register_UnityEngine_Renderer_get_motionVectorGenerationModev, __Z49Register_UnityEngine_Physics_INTERNAL_set_gravityv: __Z49Register_UnityEngine_Physics_INTERNAL_set_gravityv, __ZN4PPtrI13MonoBehaviourE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI13MonoBehaviourE8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS8_PNS_11__tree_nodeIS8_SH_EEiEESK_RKT_, __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_: __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEES8_EPS6_EEvT0_SD_T_, __ZN12LightsModule15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType: __ZN12LightsModule15AddCustomLightsERK27LocalLightCullingParametersRK11CullResultsR12ActiveLightsRi9LightType, __ZN8Animator17ApplyOnAnimatorIKEi: __ZN8Animator17ApplyOnAnimatorIKEi, __ZN24OcclusionCullingSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN24OcclusionCullingSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK11AudioSource20GetBypassReverbZonesEv: __ZNK11AudioSource20GetBypassReverbZonesEv, __ZN5physx20PxsParticleSystemSim16onRbShapeChangeVERKNS_16PxvParticleShapeEjj: __ZN5physx20PxsParticleSystemSim16onRbShapeChangeVERKNS_16PxvParticleShapeEjj, __ZN20SoundChannelInstance4StopEv: __ZN20SoundChannelInstance4StopEv, __ZN11NavMeshData15ThreadedCleanupEv: __ZN11NavMeshData15ThreadedCleanupEv, __ZN9Transform25RebuildTransformHierarchyEv: __ZN9Transform25RebuildTransformHierarchyEv, __ZN21WorldParticleCollider8TransferI14SafeBinaryReadEEvRT_: __ZN21WorldParticleCollider8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj86ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z52Register_UnityEngine_Audio_AudioMixer_set_updateModev: __Z52Register_UnityEngine_Audio_AudioMixer_set_updateModev, __Z29StdTemplateConversionFunctionIhtEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhtEbPvR14SafeBinaryRead, __ZN7ApiGLES18DrawArraysIndirectE16GfxPrimitiveTypejj: __ZN7ApiGLES18DrawArraysIndirectE16GfxPrimitiveTypejj, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_: __ZN20TierGraphicsSettings8TransferI14SafeBinaryReadEEvRT_, __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14SpriteRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z38BoxCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z38BoxCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN14Texture2DArray15UpdateImageDataEb: __ZN14Texture2DArray15UpdateImageDataEb, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE17ValidateIntegrityEPKv, __ZN5physx31PxProfileBulkMemoryEventHandler16parseEventBufferEPKhjRS0_bPNS_19PxAllocatorCallbackE: __ZN5physx31PxProfileBulkMemoryEventHandler16parseEventBufferEPKhjRS0_bPNS_19PxAllocatorCallbackE, __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE8recreateEj, __Z57Register_UnityEngine_Animator_INTERNAL_get_targetRotationv: __Z57Register_UnityEngine_Animator_INTERNAL_get_targetRotationv, __ZN5physx20PxsParticleSystemSim24packetShapesFinalizationEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim24packetShapesFinalizationEPNS_10PxBaseTaskE, __ZN18AnimatorController8GetAssetEb: __ZN18AnimatorController8GetAssetEb, __Z40SkinnedMeshRenderer_Set_Custom_PropBonesP12Il2CppObjectP11Il2CppArray: __Z40SkinnedMeshRenderer_Set_Custom_PropBonesP12Il2CppObjectP11Il2CppArray, __ZNK5physx29PxVehicleDrive4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j: __ZNK5physx29PxVehicleDrive4WGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE7reserveEj: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE7reserveEj, __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7Texture8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10Collider2D10SetDensityEf: __ZN10Collider2D10SetDensityEf, __Z50Register_UnityEngine_PhysicMaterial_set_bouncinessv: __Z50Register_UnityEngine_PhysicMaterial_set_bouncinessv, __Z40UnityWebRequest_CUSTOM_GetResponseHeaderP12Il2CppObjectP12Il2CppString: __Z40UnityWebRequest_CUSTOM_GetResponseHeaderP12Il2CppObjectP12Il2CppString, __ZN13GfxDeviceNull15ImmediateVertexEfff: __ZN13GfxDeviceNull15ImmediateVertexEfff, __Z38AudioChorusFilter_Get_Custom_PropDepthP12Il2CppObject: __Z38AudioChorusFilter_Get_Custom_PropDepthP12Il2CppObject, __ZN2UI13RectTransformD2Ev: __ZN2UI13RectTransformD2Ev, __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateUpdateResolutionstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateUpdateResolutionstruct7ForwardEv, __ZN9GfxDevice14BeginRecordingEv: __ZN9GfxDevice14BeginRecordingEv, __ZN10MonoScript27InitializeAndRegisterScriptEP11Il2CppClass: __ZN10MonoScript27InitializeAndRegisterScriptEP11Il2CppClass, __ZN11Rigidbody2D12MovePositionERK8Vector2f: __ZN11Rigidbody2D12MovePositionERK8Vector2f, __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f, __ZN8keywords10InitializeEv: __ZN8keywords10InitializeEv, __ZN5physx2Sc9ShapeCoreC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKtt: __ZN5physx2Sc9ShapeCoreC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKtt, __Z47CanvasRenderer_Get_Custom_PropHasPopInstructionP12Il2CppObject: __Z47CanvasRenderer_Get_Custom_PropHasPopInstructionP12Il2CppObject, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERd: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERd, __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDic11__mbstate_tEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDic11__mbstate_tEEEEvRKS1_, __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN13SpringJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SpringJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN12MeshCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12MeshCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10Matrix4x4f8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEtyj, __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_: __Z20EvaluateSlowThreadedRK11MinMaxCurveRN21MinMaxAnimationCurves5CacheERKN4math7_float4ES8_, __Z46Quaternion_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK11QuaternionfS1_fRS_: __Z46Quaternion_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK11QuaternionfS1_fRS_, __Z40setPxArticulation_StabilizationThresholdPN5physx14PxArticulationEf: __Z40setPxArticulation_StabilizationThresholdPN5physx14PxArticulationEf, __Z37PrintWarningAboutDecompressingTexture13TextureFormat: __Z37PrintWarningAboutDecompressingTexture13TextureFormat, __Z31AndroidJNI_CUSTOM_SetShortField13Il2Cpp_IntPtrS_s: __Z31AndroidJNI_CUSTOM_SetShortField13Il2Cpp_IntPtrS_s, __Z23UpdateCaptureScreenshotv: __Z23UpdateCaptureScreenshotv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4sizeEv, __Z30Mesh_CUSTOM_AddBlendShapeFrameP12Il2CppObjectP12Il2CppStringfP11Il2CppArrayS4_S4_: __Z30Mesh_CUSTOM_AddBlendShapeFrameP12Il2CppObjectP12Il2CppStringfP11Il2CppArrayS4_S4_, __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareEntriesEPKvS7_: __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local14compareEntriesEPKvS7_, __Z50Register_UnityEngine_Camera_get_commandBufferCountv: __Z50Register_UnityEngine_Camera_get_commandBufferCountv, __Z32Renderer_CUSTOM_SetPropertyBlockP12Il2CppObjectS0_: __Z32Renderer_CUSTOM_SetPropertyBlockP12Il2CppObjectS0_, __Z35AudioReverbZone_Set_Custom_PropRoomP12Il2CppObjecti: __Z35AudioReverbZone_Set_Custom_PropRoomP12Il2CppObjecti, __ZThn32_NK8Renderer16GetMaterialCountEv: __ZThn32_NK8Renderer16GetMaterialCountEv, _bsearch: _bsearch, __Z44RenderSettings_Set_Custom_PropFlareFadeSpeedf: __Z44RenderSettings_Set_Custom_PropFlareFadeSpeedf, __ZN8Animator9SetAvatarEP6Avatar: __ZN8Animator9SetAvatarEP6Avatar, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN4crnd10dxt5_block16get_block_valuesEPNS_10color_quadIhiEEjj: __ZN4crnd10dxt5_block16get_block_valuesEPNS_10color_quadIhiEEjj, __Z28Camera_Get_Custom_PropAspectP12Il2CppObject: __Z28Camera_Get_Custom_PropAspectP12Il2CppObject, __ZN5physx26PxClothFabricGeneratedInfoC2Ev: __ZN5physx26PxClothFabricGeneratedInfoC2Ev, __ZThn8_N5physx13NpClothFabricD1Ev: __ZThn8_N5physx13NpClothFabricD1Ev, __ZN5physx8debugger14PvdMarshallingIayE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIayE12marshalBlockEPKhPhj, __Z37Register_UnityEngine_Event_set_buttonv: __Z37Register_UnityEngine_Event_set_buttonv, __ZNSt3__217__assoc_sub_state16__on_zero_sharedEv: __ZNSt3__217__assoc_sub_state16__on_zero_sharedEv, __ZN8AnimatorD2Ev: __ZN8AnimatorD2Ev, __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx14NpShapeManager15exportExtraDataERNS_22PxSerializationContextE, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12createObjectERPhRNS_24PxDeserializationContextE, __Z43Register_UnityEngine_Camera_get_pixelHeightv: __Z43Register_UnityEngine_Camera_get_pixelHeightv, __ZN26AnimatorControllerPlayable20GetAnimatorStateNameEib: __ZN26AnimatorControllerPlayable20GetAnimatorStateNameEib, _ps_hints_apply: _ps_hints_apply, __Z35Collider2D_Set_Custom_PropIsTriggerP12Il2CppObjecth: __Z35Collider2D_Set_Custom_PropIsTriggerP12Il2CppObjecth, _wcstoul: _wcstoul, __ZN5physx2Sn5ConvX8convert8EPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX8convert8EPKcRKNS0_15PxMetaDataEntryES6_, __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_13NpVolumeCacheENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z51Register_UnityEngine_TextGenerator_GetLinesInternalv: __Z51Register_UnityEngine_TextGenerator_GetLinesInternalv, __ZNK5Umbra4AABB17getPlaneEquationsEPNS_7Vector4E: __ZNK5Umbra4AABB17getPlaneEquationsEPNS_7Vector4E, __ZNK5physx7NpCloth25getSelfCollisionStiffnessEv: __ZNK5physx7NpCloth25getSelfCollisionStiffnessEv, __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_: __Z12EvaluateSlowRK11MinMaxCurveRKN4math7_float4ES5_, __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5audio5mixer13GroupConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11UnityEngine9Animation27GetCurveCountForBindingTypeEj: __ZN11UnityEngine9Animation27GetCurveCountForBindingTypeEj, __ZN15b2FrictionJoint24SolvePositionConstraintsERK12b2SolverData: __ZN15b2FrictionJoint24SolvePositionConstraintsERK12b2SolverData, _jsimd_fdct_islow: _jsimd_fdct_islow, __ZN15SharedLightDataD2Ev: __ZN15SharedLightDataD2Ev, __Z54GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawPrefixLabel13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih: __Z54GUIStyle_CUSTOM_INTERNAL_CALL_Internal_DrawPrefixLabel13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setgEPcS4_S4_: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE4setgEPcS4_S4_, __ZN11UnityEngine15CloudWebService14DataDispatcher39StartJobSetupSessionContainerToDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher39StartJobSetupSessionContainerToDispatchEv, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17ValidateIntegrityEPKv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17ValidateIntegrityEPKv, __ZN5Umbra8QueryExtC2EPKNS_14TomeCollectionE: __ZN5Umbra8QueryExtC2EPKNS_14TomeCollectionE, __Z15setsockopt_stubiiiPKvj: __Z15setsockopt_stubiiiPKvj, __ZN2UI11CanvasGroupD2Ev: __ZN2UI11CanvasGroupD2Ev, __ZN14SplatPrototype8TransferI14SafeBinaryReadEEvRT_: __ZN14SplatPrototype8TransferI14SafeBinaryReadEEvRT_, __Z34AudioListener_Get_Custom_PropPausev: __Z34AudioListener_Get_Custom_PropPausev, __Z18Transfer_BlittableI8JSONReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _finish_pass_master: _finish_pass_master, __ZZN9Rigidbody15InitializeClassEvEN32FunctorImpl_464kTransformChanged4CallEPviR11MessageData: __ZZN9Rigidbody15InitializeClassEvEN32FunctorImpl_464kTransformChanged4CallEPviR11MessageData, __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace: __ZN12ImageFilters22SetCurrentRenderTargetEP13RenderTexturej11CubemapFace, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEED0Ev, __Z20scripting_domain_getv: __Z20scripting_domain_getv, __ZNSt3__212strstreambuf8overflowEi: __ZNSt3__212strstreambuf8overflowEi, __Z31Light_Set_Custom_PropRenderModeP12Il2CppObjecti: __Z31Light_Set_Custom_PropRenderModeP12Il2CppObjecti, __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_12PxFilterDataENS0_15InlineAllocatorILj80ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZN12_GLOBAL__N_110DataStream12beginSectionEPKvPKc: __ZN12_GLOBAL__N_110DataStream12beginSectionEPKvPKc, __ZN18WheelFrictionCurve12SetToDefaultENS_9CurveTypeE: __ZN18WheelFrictionCurve12SetToDefaultENS_9CurveTypeE, __Z40setPxJointLimitParametersContactDistancePN5physx22PxJointLimitParametersEf: __Z40setPxJointLimitParametersContactDistancePN5physx22PxJointLimitParametersEf, __Z36Animator_CUSTOM_InterruptMatchTargetP12Il2CppObjecth: __Z36Animator_CUSTOM_InterruptMatchTargetP12Il2CppObjecth, __Z14IsWorldPlayingv: __Z14IsWorldPlayingv, __Z35Motion_Get_Custom_PropApparentSpeedP12Il2CppObject: __Z35Motion_Get_Custom_PropApparentSpeedP12Il2CppObject, __Z21RegisterVRDeviceDebugv: __Z21RegisterVRDeviceDebugv, __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference: __Z18transfer_ownershipPvRK10MemLabelIdP23AllocationRootReference, __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv: __ZN11UnityEngine15CloudWebService16SessionContainer7ArchiveEv, __ZN20TextRenderingPrivate7GUIText7SetFontE4PPtrIN13TextRendering4FontEE: __ZN20TextRenderingPrivate7GUIText7SetFontE4PPtrIN13TextRendering4FontEE, __Z10dtFreeTempPv: __Z10dtFreeTempPv, __ZN5physx2Sc19ShapeInstancePairLL19sendLostTouchReportEbj: __ZN5physx2Sc19ShapeInstancePairLL19sendLostTouchReportEbj, __ZNK5physx12PxConstraint19getConcreteTypeNameEv: __ZNK5physx12PxConstraint19getConcreteTypeNameEv, __ZNK17SurfaceEffector2D18DesignedForTriggerEv: __ZNK17SurfaceEffector2D18DesignedForTriggerEv, __ZN5physx17ConvexMeshBuilder14loadConvexHullERKNS_16PxConvexMeshDescE: __ZN5physx17ConvexMeshBuilder14loadConvexHullERKNS_16PxConvexMeshDescE, __ZN12_GLOBAL__N_112UserRenderer9drawLinesEPKN5physx8debugger8renderer7PvdLineEj: __ZN12_GLOBAL__N_112UserRenderer9drawLinesEPKN5physx8debugger8renderer7PvdLineEj, __ZNK5physx9NpPhysics15getConvexMeshesEPPNS_12PxConvexMeshEjj: __ZNK5physx9NpPhysics15getConvexMeshesEPPNS_12PxConvexMeshEjj, __Z33Projector_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z33Projector_Set_Custom_PropMaterialP12Il2CppObjectS0_, __Z37getPxSceneDescBounceThresholdVelocityPKN5physx11PxSceneDescE: __Z37getPxSceneDescBounceThresholdVelocityPKN5physx11PxSceneDescE, __ZN8Material15InitializeClassEv: __ZN8Material15InitializeClassEv, __ZN15DeviceStateGLESD2Ev: __ZN15DeviceStateGLESD2Ev, __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18ComputeShaderParam8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17Physics2DSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z39getPxVehicleSuspensionDataMCamberAtRestPKN5physx23PxVehicleSuspensionDataE: __Z39getPxVehicleSuspensionDataMCamberAtRestPKN5physx23PxVehicleSuspensionDataE, _pshinter_get_t1_funcs: _pshinter_get_t1_funcs, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN14AvatarPlaybackD2Ev: __ZN14AvatarPlaybackD2Ev, __ZN5Unity10FixedJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity10FixedJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx17MBPUpdateWorkTaskD0Ev: __ZN5physx17MBPUpdateWorkTaskD0Ev, _send: _send, __Z32Time_Get_Custom_PropUnscaledTimev: __Z32Time_Get_Custom_PropUnscaledTimev, _alloc_small: _alloc_small, __ZNK13ScreenManager20GetCurrentResolutionEv: __ZNK13ScreenManager20GetCurrentResolutionEv, __ZNSt16bad_array_lengthC2Ev: __ZNSt16bad_array_lengthC2Ev, __ZN5physx21PxClothRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxClothRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN15AnchoredJoint2DD2Ev: __ZN15AnchoredJoint2DD2Ev, __Z48Register_UnityEngine_Display_GetRenderingExtImplv: __Z48Register_UnityEngine_Display_GetRenderingExtImplv, __ZL33DeveloperConsoleGetObjectGUIStatePv: __ZL33DeveloperConsoleGetObjectGUIStatePv, __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE15getSerializableEv, __ZN13dynamic_arrayIP9b2FixtureLj4EEC2ERKS2_: __ZN13dynamic_arrayIP9b2FixtureLj4EEC2ERKS2_, __ZN5physx20InternalTriangleMesh19allocateAdjacenciesEv: __ZN5physx20InternalTriangleMesh19allocateAdjacenciesEv, __ZN5physx2Gu24pcmContactBoxHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu24pcmContactBoxHeightFieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN5physx20PxcNpCacheStreamPair7reserveEj: __ZN5physx20PxcNpCacheStreamPair7reserveEj, __ZNK6Camera25GetRenderImmediateObjectsEv: __ZNK6Camera25GetRenderImmediateObjectsEv, __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEED0Ev: __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEED0Ev, __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __Z35Resources_CUSTOM_UnloadUnusedAssetsv: __Z35Resources_CUSTOM_UnloadUnusedAssetsv, __Z34PlayerPrefs_CUSTOM_TrySetSetStringP12Il2CppStringS0_: __Z34PlayerPrefs_CUSTOM_TrySetSetStringP12Il2CppStringS0_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN15QualitySettings31SetBillboardsFaceCameraPositionEb: __ZN15QualitySettings31SetBillboardsFaceCameraPositionEb, __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity5Joint17JointTransferPostI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6PxQuatC2ERKNS_7PxMat33E: __ZN5physx6PxQuatC2ERKNS_7PxMat33E, __Z41NavMesh_CUSTOM_SetAvoidancePredictionTimef: __Z41NavMesh_CUSTOM_SetAvoidancePredictionTimef, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE27__invalidate_iterators_pastEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE27__invalidate_iterators_pastEj, __Z19DestroyWorldObjectsRK13dynamic_arrayIiLj4EE: __Z19DestroyWorldObjectsRK13dynamic_arrayIiLj4EE, __Z47AndroidJNI_CUSTOM_INTERNAL_CALL_NewBooleanArrayiRPv: __Z47AndroidJNI_CUSTOM_INTERNAL_CALL_NewBooleanArrayiRPv, __ZNK9Texture2D16GetPixelBilinearEiff: __ZNK9Texture2D16GetPixelBilinearEiff, __Z54Register_UnityEngine_Camera_INTERNAL_set_cullingMatrixv: __Z54Register_UnityEngine_Camera_INTERNAL_set_cullingMatrixv, __ZN15SerializeTraitsINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEEE8TransferI14SafeBinaryReadEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEEE8TransferI14SafeBinaryReadEEvRS6_RT_, __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP14DataBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __Z35AndroidJNI_CUSTOM_GetStringUTFChars13Il2Cpp_IntPtr: __Z35AndroidJNI_CUSTOM_GetStringUTFChars13Il2Cpp_IntPtr, __ZN5physx24PxcArticulationFnsScalar8multiplyERKNS_12PxcFsInertiaERKNS_2Cm13SpatialVectorE: __ZN5physx24PxcArticulationFnsScalar8multiplyERKNS_12PxcFsInertiaERKNS_2Cm13SpatialVectorE, __Z30AndroidJNI_CUSTOM_GetByteField13Il2Cpp_IntPtrS_: __Z30AndroidJNI_CUSTOM_GetByteField13Il2Cpp_IntPtrS_, __ZNK5Umbra6KDTree4rankEi: __ZNK5Umbra6KDTree4rankEi, __ZN16Physics2DManager7RaycastERK3RayfiR12RaycastHit2D: __ZN16Physics2DManager7RaycastERK3RayfiR12RaycastHit2D, __Z47Gyroscope_CUSTOM_INTERNAL_CALL_gravity_InternaliR8Vector3f: __Z47Gyroscope_CUSTOM_INTERNAL_CALL_gravity_InternaliR8Vector3f, __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z18SRGB_LinearToGammaR14ImageReference: __Z18SRGB_LinearToGammaR14ImageReference, __ZN8GUIStyle14SetGUIClipRectERK5RectTIfE: __ZN8GUIStyle14SetGUIClipRectERK5RectTIfE, __Z45Register_UnityEngine_LensFlare_get_brightnessv: __Z45Register_UnityEngine_LensFlare_get_brightnessv, __ZN5physx9PxTaskMgr13emitStopEventERNS_10PxBaseTaskEj: __ZN5physx9PxTaskMgr13emitStopEventERNS_10PxBaseTaskEj, __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager31HasMemoryOrCachedSerializedFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z22GetRenderBufferManagerv: __Z22GetRenderBufferManagerv, _UNITY_FT_MulFix: _UNITY_FT_MulFix, __ZN17GeneralConnection10DisconnectEj: __ZN17GeneralConnection10DisconnectEj, _UNITY_png_set_text_compression_strategy: _UNITY_png_set_text_compression_strategy, __Z48AudioSource_Set_Custom_PropBypassListenerEffectsP12Il2CppObjecth: __Z48AudioSource_Set_Custom_PropBypassListenerEffectsP12Il2CppObjecth, __Z31getPxVehicleClutchDataMStrengthPKN5physx19PxVehicleClutchDataE: __Z31getPxVehicleClutchDataMStrengthPKN5physx19PxVehicleClutchDataE, __Z45Register_UnityEngine_HingeJoint_get_useSpringv: __Z45Register_UnityEngine_HingeJoint_get_useSpringv, __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer: __ZN12AudioManager22CleanupDependentMixersEP10AudioMixer, _getgroups: _getgroups, __ZN23ShaderVariantCollection17WarmupShadersImplEPFvP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContextES9_SA_: __ZN23ShaderVariantCollection17WarmupShadersImplEPFvP6ShaderiPN9ShaderLab4PassERK16ShaderKeywordSetP10DynamicVBOPvR17ShaderPassContextES9_SA_, __ZN5physx23PxsBroadPhaseContextSap11batchCreateEv: __ZN5physx23PxsBroadPhaseContextSap11batchCreateEv, __ZN5physx2Sn9StrToImplINS_6PxQuatEE5strtoERS2_RPKc: __ZN5physx2Sn9StrToImplINS_6PxQuatEE5strtoERS2_RPKc, __ZNSt3__26locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7codecvtIDsc11__mbstate_tEEEEvPT_, _UNITY_png_write_IEND: _UNITY_png_write_IEND, __Z57AnimatorControllerPlayable_CUSTOM_PlayInFixedTimeInternalR9HPlayableiif: __Z57AnimatorControllerPlayable_CUSTOM_PlayInFixedTimeInternalR9HPlayableiif, __ZN11UnityEngine9Animation28GetBoundCurveInstanceIDValueERKNS0_10BoundCurveE: __ZN11UnityEngine9Animation28GetBoundCurveInstanceIDValueERKNS0_10BoundCurveE, __ZNK20GpuProgramParameters16FindTextureParamERKN9ShaderLab16FastPropertyNameE16TextureDimension: __ZNK20GpuProgramParameters16FindTextureParamERKN9ShaderLab16FastPropertyNameE16TextureDimension, _tcgetsid: _tcgetsid, __ZN14NavMeshManager14SamplePositionEP10NavMeshHitRK8Vector3fRK13dtQueryFilterf: __ZN14NavMeshManager14SamplePositionEP10NavMeshHitRK8Vector3fRK13dtQueryFilterf, __Z63Register_UnityEngine_Renderer_get_lightProbeProxyVolumeOverridev: __Z63Register_UnityEngine_Renderer_get_lightProbeProxyVolumeOverridev, _ft_free: _ft_free, __ZN16HumanPoseHandlerD0Ev: __ZN16HumanPoseHandlerD0Ev, __ZN17PersistentManager29HasThreadedObjectsToIntegrateEv: __ZN17PersistentManager29HasThreadedObjectsToIntegrateEv, __ZNK5physx21PxSpringGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j: __ZNK5physx21PxSpringGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEEEEEjT_j, __ZN11BoxCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11BoxCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5Unity12PhysicsQuery10OverlapBoxERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery10OverlapBoxERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteraction, __ZN11Rigidbody2D9AddTorqueEfNS_9ForceModeE: __ZN11Rigidbody2D9AddTorqueEfNS_9ForceModeE, __Z52Register_UnityEngine_Physics2D_get_velocityThresholdv: __Z52Register_UnityEngine_Physics2D_get_velocityThresholdv, __ZNK20LocalFileSystemPosix20GetUserAppDataFolderEv: __ZNK20LocalFileSystemPosix20GetUserAppDataFolderEv, __Z28getPxParticleFluid_ViscosityPKN5physx15PxParticleFluidE: __Z28getPxParticleFluid_ViscosityPKN5physx15PxParticleFluidE, __Z37Register_UnityEngine_AudioSource_Stopv: __Z37Register_UnityEngine_AudioSource_Stopv, __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIj25DeferredSkinningOperationEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZN9Transform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Transform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi: __ZN7mecanim9animation12GetClipStopXERKNS0_18ClipMuscleConstantEi, __Z26GetRemoteNotificationCountv: __Z26GetRemoteNotificationCountv, _tt_cmap14_char_var_isdefault: _tt_cmap14_char_var_isdefault, __ZN12LightsModule5CacheER19ParticleSystemState: __ZN12LightsModule5CacheER19ParticleSystemState, __Z29Transform_Get_Custom_PropRootP12Il2CppObject: __Z29Transform_Get_Custom_PropRootP12Il2CppObject, __Z32CanvasRenderer_CUSTOM_SetTextureP12Il2CppObjectS0_: __Z32CanvasRenderer_CUSTOM_SetTextureP12Il2CppObjectS0_, __ZN5physx8areEqualERKNS_6PxQuatES2_: __ZN5physx8areEqualERKNS_6PxQuatES2_, __ZNK12RemoveByName16ShouldRemoveClipEP13AnimationClip: __ZNK12RemoveByName16ShouldRemoveClipEP13AnimationClip, __ZN7Terrain23GarbageCollectRenderersEv: __ZN7Terrain23GarbageCollectRenderersEv, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __Z37setPxRigidBody_MassSpaceInertiaTensorPN5physx11PxRigidBodyERKNS_6PxVec3E: __Z37setPxRigidBody_MassSpaceInertiaTensorPN5physx11PxRigidBodyERKNS_6PxVec3E, __Z33Camera_Set_Custom_PropCullingMaskP12Il2CppObjecti: __Z33Camera_Set_Custom_PropCullingMaskP12Il2CppObjecti, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj: __ZN7ApiGLES12DrawElementsE16GfxPrimitiveTypePKvjjj, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN16UnityAdsSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16UnityAdsSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13GfxDeviceNull13ReadbackImageER14ImageReferenceiiiiii: __ZN13GfxDeviceNull13ReadbackImageER14ImageReferenceiiiiii, __Z36Graphics_CUSTOM_Internal_SetRTSimpleP21ScriptingRenderBufferS0_iii: __Z36Graphics_CUSTOM_Internal_SetRTSimpleP21ScriptingRenderBufferS0_iii, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setDynamicFrictionEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18setDynamicFrictionEf, __ZN5physx18NpArticulationLink17setCMassLocalPoseERKNS_11PxTransformE: __ZN5physx18NpArticulationLink17setCMassLocalPoseERKNS_11PxTransformE, __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK7Hash128j: __ZN26DownloadHandlerAssetBundleC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK7Hash128j, __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej: __ZN16ReflectionProbes11UpdateProbeER15ReflectionProbej, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, _UNITY_png_get_sCAL_fixed: _UNITY_png_get_sCAL_fixed, _md5crypt: _md5crypt, __ZL23ResetRandSeedForEmitterv: __ZL23ResetRandSeedForEmitterv, __Z22PlayerSendFrameStartedb: __Z22PlayerSendFrameStartedb, __Z15HumanBoneToMonoRK9HumanBoneR13MonoHumanBone: __Z15HumanBoneToMonoRK9HumanBoneR13MonoHumanBone, __ZN10builtintex21GetAttenuationTextureEv: __ZN10builtintex21GetAttenuationTextureEv, __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __Z24getPxJoint_InvMassScale0PKN5physx7PxJointE: __Z24getPxJoint_InvMassScale0PKN5physx7PxJointE, __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE: __ZN5physx18PxsDynamicsContext18setDescFromIndicesERNS_23PxcSolverConstraintDescERKNS_21PxsIndexedInteractionE, __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev: __ZN10__cxxabiv112_GLOBAL__N_111string_pairD2Ev, __Z46setPxSimulationStatisticsCompressedContactSizePN5physx22PxSimulationStatisticsEj: __Z46setPxSimulationStatisticsCompressedContactSizePN5physx22PxSimulationStatisticsEj, __ZnajRK10MemLabelIdiPKci: __ZnajRK10MemLabelIdiPKci, __ZNK5physx14PxRigidDynamic19getConcreteTypeNameEv: __ZNK5physx14PxRigidDynamic19getConcreteTypeNameEv, __ZN13GfxDeviceGLES20SetRenderTargetsImplERK20GfxRenderTargetSetup: __ZN13GfxDeviceGLES20SetRenderTargetsImplERK20GfxRenderTargetSetup, __ZN15HeightMeshQueryD2Ev: __ZN15HeightMeshQueryD2Ev, __ZNK14StackAllocator20IsOverflowAllocationEPKv: __ZNK14StackAllocator20IsOverflowAllocationEPKv, __ZN5physx9PxTaskMgr12finishBeforeERNS_6PxTaskEj: __ZN5physx9PxTaskMgr12finishBeforeERNS_6PxTaskEj, __ZN5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj, __Z62Register_UnityEngine_Profiling_Profiler_GetTotalReservedMemoryv: __Z62Register_UnityEngine_Profiling_Profiler_GetTotalReservedMemoryv, __ZN7dtCrowd19completeOffMeshLinkEib: __ZN7dtCrowd19completeOffMeshLinkEib, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE18getAngularVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE18getAngularVelocityEv, _wcscasecmp: _wcscasecmp, __ZN14ParticleSystem13StartVelocityERS_RK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjRKN4math7_float3ERKfbb: __ZN14ParticleSystem13StartVelocityERS_RK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjRKN4math7_float3ERKfbb, __ZN5physx13BigConvexDataC2Ev: __ZN5physx13BigConvexDataC2Ev, __ZN23b2EdgeAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN23b2EdgeAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNKSt3__210moneypunctIcLb0EE11do_groupingEv: __ZNKSt3__210moneypunctIcLb0EE11do_groupingEv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetZv, __Z49AnimatorUtility_CUSTOM_OptimizeTransformHierarchyP12Il2CppObjectP11Il2CppArray: __Z49AnimatorUtility_CUSTOM_OptimizeTransformHierarchyP12Il2CppObjectP11Il2CppArray, __ZN14BoxCast2DQueryD0Ev: __ZN14BoxCast2DQueryD0Ev, __Z69Register_UnityEngine_Joint2D_Joint2D_CUSTOM_INTERNAL_GetReactionForcev: __Z69Register_UnityEngine_Joint2D_Joint2D_CUSTOM_INTERNAL_GetReactionForcev, __ZN4FMOD12ChannelGroup11setUserDataEPv: __ZN4FMOD12ChannelGroup11setUserDataEPv, __ZN10Matrix4x4f9TransposeEv: __ZN10Matrix4x4f9TransposeEv, __ZN9ShaderLab9SubShaderC2ERKS0_: __ZN9ShaderLab9SubShaderC2ERKS0_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7__allocEv, __ZN15TerrainRenderer9FindChildER12QuadTreeNodei: __ZN15TerrainRenderer9FindChildER12QuadTreeNodei, __ZN12CubemapArray15UpdateImageDataEb: __ZN12CubemapArray15UpdateImageDataEb, __Z24Rigidbody2D_CUSTOM_SleepP12Il2CppObject: __Z24Rigidbody2D_CUSTOM_SleepP12Il2CppObject, __Z61Register_UnityEngine_GUIClip_INTERNAL_CALL_Internal_Clip_Rectv: __Z61Register_UnityEngine_GUIClip_INTERNAL_CALL_Internal_Clip_Rectv, __Z9pqIsEmptyP9PriorityQ: __Z9pqIsEmptyP9PriorityQ, __ZN9GfxDevice19CreateComputeBufferE15ComputeBufferIDjjj: __ZN9GfxDevice19CreateComputeBufferE15ComputeBufferIDjjj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, _do_read: _do_read, __Z33AudioSource_Set_Custom_PropSpreadP12Il2CppObjectf: __Z33AudioSource_Set_Custom_PropSpreadP12Il2CppObjectf, __Z27getPxVehicleWheelDataMWidthPKN5physx18PxVehicleWheelDataE: __Z27getPxVehicleWheelDataMWidthPKN5physx18PxVehicleWheelDataE, __ZN9AudioClip7WWWReadEPvS0_jPjS0_: __ZN9AudioClip7WWWReadEPvS0_jPjS0_, __Z75Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorPixelPositionv: __Z75Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_GetCursorPixelPositionv, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _UNITY_png_write_image: _UNITY_png_write_image, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE15growAndPushBackERKS2_, __Z33Input_Get_Custom_PropMousePresentv: __Z33Input_Get_Custom_PropMousePresentv, __ZN12FlareManagerC2Ev: __ZN12FlareManagerC2Ev, __ZN7ApiGLES15BindVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE: __ZN7ApiGLES15BindVertexArrayEN2gl6HandleILNS0_10ObjectTypeE3EEE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN22RenderingCommandBufferD2Ev: __ZN22RenderingCommandBufferD2Ev, __Z38TargetJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf: __Z38TargetJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf, __ZNK5Umbra4Tome15getObjectBoundsEiRNS_7Vector3ES2_: __ZNK5Umbra4Tome15getObjectBoundsEiRNS_7Vector3ES2_, __Z24RegisterStrippedTypeInfoIN5Unity11SpringJointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity11SpringJointEEviPKcS3_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_, __ZNK5physx2Sc5Scene22getClientBehaviorFlagsEh: __ZNK5physx2Sc5Scene22getClientBehaviorFlagsEh, __Z55Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToAxisAngleRadRK11QuaternionfP8Vector3fPf: __Z55Quaternion_CUSTOM_INTERNAL_CALL_Internal_ToAxisAngleRadRK11QuaternionfP8Vector3fPf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE12readPropertyIfEEbRT_, __ZN4FMOD12ChannelGroup7releaseEv: __ZN4FMOD12ChannelGroup7releaseEv, __Z16IsDirectoryEmptyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z16IsDirectoryEmptyRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TIjEENS0_9AllocatorEE8recreateEj, __ZNK5Umbra9Matrix4x310isIdentityEv: __ZNK5Umbra9Matrix4x310isIdentityEv, __ZN2UI13RectTransform5ResetEv: __ZN2UI13RectTransform5ResetEv, __Z44getPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataEj: __Z44getPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataEj, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _scalbnf: _scalbnf, __ZN11UnityEngine15PlatformWrapper17IsInternetAllowedEv: __ZN11UnityEngine15PlatformWrapper17IsInternetAllowedEv, __Z15getPxShape_NamePKN5physx7PxShapeE: __Z15getPxShape_NamePKN5physx7PxShapeE, __ZN5Unity11SpringJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity11SpringJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx26PxSerializerDefaultAdapterINS_11NpAggregateEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_11NpAggregateEED0Ev, __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z42UnityAnalyticsHandler_CUSTOM_SetUserGenderP12Il2CppObjectN14UnityAnalytics6GenderE: __Z42UnityAnalyticsHandler_CUSTOM_SetUserGenderP12Il2CppObjectN14UnityAnalytics6GenderE, __ZN17PolygonCollider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN17PolygonCollider2D23VirtualRedirectTransferER14SafeBinaryRead, __Z37getPxRevoluteJoint_RevoluteJointFlagsPKN5physx15PxRevoluteJointE: __Z37getPxRevoluteJoint_RevoluteJointFlagsPKN5physx15PxRevoluteJointE, __ZN14PreloadManager18PushIntegrateQueueEP23PreloadManagerOperation: __ZN14PreloadManager18PushIntegrateQueueEP23PreloadManagerOperation, __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationYMultiplierP12Il2CppObjectf: __Z60ParticleSystem_MainModule_CUSTOM_SetStartRotationYMultiplierP12Il2CppObjectf, __Z31TerrainData_CUSTOM_GetAlphamapsP12Il2CppObjectiiii: __Z31TerrainData_CUSTOM_GetAlphamapsP12Il2CppObjectiiii, __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj: __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj, __ZNKSt3__27collateIcE7compareEPKcS3_S3_S3_: __ZNKSt3__27collateIcE7compareEPKcS3_S3_S3_, __Z6md5_32PKvijPv: __Z6md5_32PKvijPv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj160ENS_22PxRepXPropertyAccessorILj160ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj160ENS_22PxRepXPropertyAccessorILj160ES4_ffEEEEvRKT0_, __ZN14TerrainManager21GetEnlightenProxyMeshEP7Terrain: __ZN14TerrainManager21GetEnlightenProxyMeshEP7Terrain, __ZL11AddSentinelP14TESStesselatorfff: __ZL11AddSentinelP14TESStesselatorfff, __ZN13InitialModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13InitialModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9GfxDevice28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE: __ZN9GfxDevice28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE, __ZN12_GLOBAL__N_112RenderReaderILb0EED0Ev: __ZN12_GLOBAL__N_112RenderReaderILb0EED0Ev, __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleRK13Vector2fIcallfiff: __Z44Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleRK13Vector2fIcallfiff, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_jj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjRKS5_jj, __ZN17Physics2DSettings24SetAngularSleepToleranceEf: __ZN17Physics2DSettings24SetAngularSleepToleranceEf, __ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX10convertPtrEPKcRKNS0_15PxMetaDataEntryES6_, __ZN18ProfilerConnection36HandleBeginInstrumentFunctionMessageEPKvjj: __ZN18ProfilerConnection36HandleBeginInstrumentFunctionMessageEPKvjj, __Z47Register_UnityEngine_MeshCollider_set_skinWidthv: __Z47Register_UnityEngine_MeshCollider_set_skinWidthv, __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11ClothModule33SetUpSkinnedBuffersOnSkinnedClothEPN5Unity5ClothEPvS3_S3_jb: __ZN11ClothModule33SetUpSkinnedBuffersOnSkinnedClothEPN5Unity5ClothEPvS3_S3_jb, __Z25setPxVehicleTireDataMTypePN5physx17PxVehicleTireDataEj: __Z25setPxVehicleTireDataMTypePN5physx17PxVehicleTireDataEj, __ZN13RuntimeStaticI17UniqueIDGeneratorE16StaticInitializeEPv: __ZN13RuntimeStaticI17UniqueIDGeneratorE16StaticInitializeEPv, __ZN11AudioFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11AudioFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15FileSystemEntry5TouchEv: __ZN15FileSystemEntry5TouchEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS2_EENS4_9allocatorINS4_4pairIS2_S3_EEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS2_EENS4_9allocatorINS4_4pairIS2_S3_EEEEEEEvRT_17TransferMetaFlags, __Z46AnimatorControllerPlayable_CUSTOM_SetTriggerIDR9HPlayablei: __Z46AnimatorControllerPlayable_CUSTOM_SetTriggerIDR9HPlayablei, __Z53Register_UnityEngine_Material_INTERNAL_CALL_SetMatrixv: __Z53Register_UnityEngine_Material_INTERNAL_CALL_SetMatrixv, _UNITY_tt_face_done_kern: _UNITY_tt_face_done_kern, __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEED0Ev, __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIhEEvRT_PKc17TransferMetaFlags, __ZN9Rigidbody17AddRelativeTorqueERK8Vector3fi: __ZN9Rigidbody17AddRelativeTorqueERK8Vector3fi, __Z49getPxVehicleDifferential4WDataMRearLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE: __Z49getPxVehicleDifferential4WDataMRearLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE, __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity9Component8TransferI24GenerateTypeTreeTransferEEvRT_, __Z34setPxSceneLimitsMaxNbDynamicShapesPN5physx13PxSceneLimitsEj: __Z34setPxSceneLimitsMaxNbDynamicShapesPN5physx13PxSceneLimitsEj, _h2v2_downsample: _h2v2_downsample, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKc, __ZN14DetailDatabase24RelocateProtoUVFromRectsEP5RectTIfE: __ZN14DetailDatabase24RelocateProtoUVFromRectsEP5RectTIfE, __Z67Register_UnityEngine_ParticleSystem_ShapeModule_GetAlignToDirectionv: __Z67Register_UnityEngine_ParticleSystem_ShapeModule_GetAlignToDirectionv, __ZN5physx2Sc5Scene16afterIntegrationEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene16afterIntegrationEPNS_10PxBaseTaskE, __Z25GetRenderBufferManagerPtrv: __Z25GetRenderBufferManagerPtrv, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_, __ZN13dynamic_arrayI14ProfilerSampleLj8EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI14ProfilerSampleLj8EE6insertEPS0_PKS0_S4_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj664ES3_RKNS_18PxVehicleGearsDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj664ES3_RKNS_18PxVehicleGearsDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI14SafeBinaryReadEEvRT_, __ZN13RuntimeStaticI20HardwareInfoReporterE16StaticInitializeEPv: __ZN13RuntimeStaticI20HardwareInfoReporterE16StaticInitializeEPv, __Z56Register_UnityEngine_CharacterJoint_set_enableProjectionv: __Z56Register_UnityEngine_CharacterJoint_set_enableProjectionv, __ZN14SafeBinaryRead16EndArrayTransferEv: __ZN14SafeBinaryRead16EndArrayTransferEv, __Z59GUIStyle_CUSTOM_Internal_GetNumCharactersThatFitWithinWidth13Il2Cpp_IntPtrP12Il2CppStringf: __Z59GUIStyle_CUSTOM_Internal_GetNumCharactersThatFitWithinWidth13Il2Cpp_IntPtrP12Il2CppStringf, __ZN15PointEffector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15PointEffector2D23VirtualRedirectTransferER14SafeBinaryRead, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt13runtime_erroraSERKS_: __ZNSt13runtime_erroraSERKS_, __ZN13AnimationClip15QuaternionCurve8TransferI14SafeBinaryReadEEvRT_: __ZN13AnimationClip15QuaternionCurve8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx13NpClothFabric15getNbRestvaluesEv: __ZNK5physx13NpClothFabric15getNbRestvaluesEv, __ZN20GpuProgramParametersD2Ev: __ZN20GpuProgramParametersD2Ev, __Z18GetLogEntryHandlerv: __Z18GetLogEntryHandlerv, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv, __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi0ELb0EED0Ev, __ZN9GfxDevice20ImmediateTexCoordAllEfff: __ZN9GfxDevice20ImmediateTexCoordAllEfff, __ZN4FMOD6SoundI13setLoopPointsEjjjj: __ZN4FMOD6SoundI13setLoopPointsEjjjj, __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEif: __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEif, __ZN11AudioSource17UpdateSpatializerE12SoundChannelf: __ZN11AudioSource17UpdateSpatializerE12SoundChannelf, __ZN7ApiGLES11VertexArrayC2ERKS_ji19VertexChannelFormatiPKvN2gl21VertexArrayAttribKindE: __ZN7ApiGLES11VertexArrayC2ERKS_ji19VertexChannelFormatiPKvN2gl21VertexArrayAttribKindE, __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_highAngularXLimitP12Il2CppObjectP14SoftJointLimit: __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_highAngularXLimitP12Il2CppObjectP14SoftJointLimit, __Z57Register_UnityEngine_SystemInfo_get_supportsAccelerometerv: __Z57Register_UnityEngine_SystemInfo_get_supportsAccelerometerv, __Z40TargetJoint2D_CUSTOM_INTERNAL_set_targetP12Il2CppObjectRK13Vector2fIcall: __Z40TargetJoint2D_CUSTOM_INTERNAL_set_targetP12Il2CppObjectRK13Vector2fIcall, __Z61AnimatorOverrideController_CUSTOM_Internal_CreateAnimationSetP12Il2CppObject: __Z61AnimatorOverrideController_CUSTOM_Internal_CreateAnimationSetP12Il2CppObject, __ZNK21DownloadHandlerBuffer8GetBytesEv: __ZNK21DownloadHandlerBuffer8GetBytesEv, __ZN24RingBufferMemoryFileDataD2Ev: __ZN24RingBufferMemoryFileDataD2Ev, __ZN2UI6Canvas16CheckConsistencyEv: __ZN2UI6Canvas16CheckConsistencyEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags, __ZN13MonoBehaviour18ReleaseScriptCacheEv: __ZN13MonoBehaviour18ReleaseScriptCacheEv, __ZNK13TranslateGLES16StencilOperationE9StencilOp: __ZNK13TranslateGLES16StencilOperationE9StencilOp, __ZN10AudioMixer19GetFMODChannelGroupERK9UnityGUID: __ZN10AudioMixer19GetFMODChannelGroupERK9UnityGUID, __ZNK5Umbra9FloatList6getPtrEv: __ZNK5Umbra9FloatList6getPtrEv, __ZNK14CompressedMesh8ValidateEv: __ZNK14CompressedMesh8ValidateEv, __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalVectorv: __Z57Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalVectorv, __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv: __ZN13dynamic_arrayI9SceneNodeLj4EE19push_back_constructEv, __Z29Transfer_Blittable_ArrayFieldI9JSONWriteiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWriteiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI11DetailPatchNS0_9allocatorIS2_EEEEEvRT_j, __Z22RectOffset_CUSTOM_InitP12Il2CppObject: __Z22RectOffset_CUSTOM_InitP12Il2CppObject, __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E10insert_oneERKS8_: __ZN13sorted_vectorINSt3__24pairINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EEN10vector_mapIS7_S7_27compare_tstring_insensitiveIS7_E13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE13value_compareESE_E10insert_oneERKS8_, __ZN18AnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18AnimatorController23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN7b2World11DestroyBodyEP6b2Body: __ZN7b2World11DestroyBodyEP6b2Body, __Z7anyTrueRK8Scalar4f: __Z7anyTrueRK8Scalar4f, __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z61ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentSize3DP12Il2CppObjectR22ParticleSystemParticleR8Vector3f: __Z61ParticleSystem_Particle_CUSTOM_INTERNAL_CALL_GetCurrentSize3DP12Il2CppObjectR22ParticleSystemParticleR8Vector3f, __ZNK7ApiGLES9IsEnabledEN2gl10EnabledCapE: __ZNK7ApiGLES9IsEnabledEN2gl10EnabledCapE, __Z57Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorv: __Z57Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorv, __ZN26AnimatorOverrideController8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN26AnimatorOverrideController8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11OffMeshLinkC2ER10MemLabelId18ObjectCreationMode: __ZN11OffMeshLinkC2ER10MemLabelId18ObjectCreationMode, __ZN2UI6Canvas8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN2UI6Canvas8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15NavMeshObstacle7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15NavMeshObstacle7PRODUCEE10MemLabelId18ObjectCreationMode, __Z20SetupVehiclesManagerv: __Z20SetupVehiclesManagerv, __ZN19SkinnedMeshRenderer29CalculateRootLocalSpaceBoundsER10MinMaxAABB: __ZN19SkinnedMeshRenderer29CalculateRootLocalSpaceBoundsER10MinMaxAABB, __ZNK14ParticleSystem26CulledSystemIsStillPlayingEd: __ZNK14ParticleSystem26CulledSystemIsStillPlayingEd, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __Z27ConvertSeparatorsToPlatformPc: __Z27ConvertSeparatorsToPlatformPc, __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z40EdgeCollider2D_Get_Custom_PropPointCountP12Il2CppObject: __Z40EdgeCollider2D_Get_Custom_PropPointCountP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEclILj681ES3_KNS_30PxVehicleDriveTankControlModel4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEclILj681ES3_KNS_30PxVehicleDriveTankControlModel4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx6shdfnd4Time11getLastTimeEv: __ZNK5physx6shdfnd4Time11getLastTimeEv, __Z38Camera_CUSTOM_INTERNAL_CALL_RaycastTryP12Il2CppObjectRK3Rayfi23QueryTriggerInteraction: __Z38Camera_CUSTOM_INTERNAL_CALL_RaycastTryP12Il2CppObjectRK3Rayfi23QueryTriggerInteraction, __ZNK9Rigidbody19GetSolverIterationsEv: __ZNK9Rigidbody19GetSolverIterationsEv, __Z49AudioReverbFilter_Get_Custom_PropReflectionsDelayP12Il2CppObject: __Z49AudioReverbFilter_Get_Custom_PropReflectionsDelayP12Il2CppObject, __ZN19CharacterController13GetSlopeLimitEv: __ZN19CharacterController13GetSlopeLimitEv, __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5Umbra9Matrix2x23detEv: __ZN5Umbra9Matrix2x23detEv, __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E: __ZN5physx22PxVehicleWheelsSimData20setWheelCentreOffsetEjRKNS_6PxVec3E, __ZN12FlareManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj: __ZN12FlareManager17RenderGeometryJobEP25DynamicVBOGeometryJobDataj, __Z38SurfaceEffector2D_Get_Custom_PropSpeedP12Il2CppObject: __Z38SurfaceEffector2D_Get_Custom_PropSpeedP12Il2CppObject, __ZN5physx2Sc9ClothCore11switchClothEPNS_5cloth5ClothE: __ZN5physx2Sc9ClothCore11switchClothEPNS_5cloth5ClothE, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl14createPropertyEN5physx8debugger18NonNegativeIntegerEPKcS5_S3_NS2_12PropertyType4EnumE: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl14createPropertyEN5physx8debugger18NonNegativeIntegerEPKcS5_S3_NS2_12PropertyType4EnumE, __ZNK16MemoryFileSystem9IsSymLinkERK13FileEntryData: __ZNK16MemoryFileSystem9IsSymLinkERK13FileEntryData, __Z16dtPointInPolygonPKfS0_i: __Z16dtPointInPolygonPKfS0_i, __ZN13UnityProfilerC2Ev: __ZN13UnityProfilerC2Ev, __Z29NativeToScriptingVertexLayoutPK11ChannelInfoP25ScriptingVertexDataLayoutRi: __Z29NativeToScriptingVertexLayoutPK11ChannelInfoP25ScriptingVertexDataLayoutRi, __ZN5physx8debugger8renderer15PvdUserRenderer6createERNS_19PxAllocatorCallbackEj: __ZN5physx8debugger8renderer15PvdUserRenderer6createERNS_19PxAllocatorCallbackEj, __ZN17UniqueIDGenerator7CleanupEv: __ZN17UniqueIDGenerator7CleanupEv, __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv: __ZN23ParticleSystemParticles22SetUsesInitialVelocityEv, _UNITY_TT_Load_Context: _UNITY_TT_Load_Context, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN24dtObstacleAvoidanceQuery7prepareEPKfS1_ffffPK25dtObstacleAvoidanceParams: __ZN24dtObstacleAvoidanceQuery7prepareEPKfS1_ffffPK25dtObstacleAvoidanceParams, __Z55ParticleSystem_TrailModule_CUSTOM_SetLifetimeMultiplierP12Il2CppObjectf: __Z55ParticleSystem_TrailModule_CUSTOM_SetLifetimeMultiplierP12Il2CppObjectf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z52Register_UnityEngine_BillboardRenderer_set_billboardv: __Z52Register_UnityEngine_BillboardRenderer_set_billboardv, __ZN12b2MotorJoint24SolvePositionConstraintsERK12b2SolverData: __ZN12b2MotorJoint24SolvePositionConstraintsERK12b2SolverData, __Z23GetCurrentRenderOptionsv: __Z23GetCurrentRenderOptionsv, __Z38Camera_Set_Custom_PropStereoMirrorModeP12Il2CppObjecth: __Z38Camera_Set_Custom_PropStereoMirrorModeP12Il2CppObjecth, __Z50Register_UnityEngine_JsonUtility_FromJsonOverwritev: __Z50Register_UnityEngine_JsonUtility_FromJsonOverwritev, __ZN4FMOD12ChannelGroup13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD12ChannelGroup13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj587ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj587ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Umbra9Matrix4x49transposeERKS0_: __ZN5Umbra9Matrix4x49transposeERKS0_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv, __Z46CanvasRenderer_Get_Custom_PropPopMaterialCountP12Il2CppObject: __Z46CanvasRenderer_Get_Custom_PropPopMaterialCountP12Il2CppObject, __Z31AudioSource_Set_Custom_PropLoopP12Il2CppObjecth: __Z31AudioSource_Set_Custom_PropLoopP12Il2CppObjecth, __ZN5Unity5Cloth23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity5Cloth23VirtualRedirectTransferER14SafeBinaryRead, __ZN9GfxDevice28GetNativeVertexBufferPointerEP9GfxBuffer: __ZN9GfxDevice28GetNativeVertexBufferPointerEP9GfxBuffer, __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_, __ZN18ProceduralMaterial29ThrowOrWarnIfMaterialIsFrozenEPKc: __ZN18ProceduralMaterial29ThrowOrWarnIfMaterialIsFrozenEPKc, __ZN5physx2Gu26intersectHeightFieldSphereERKNS0_15HeightFieldUtilERKNS0_6SphereE: __ZN5physx2Gu26intersectHeightFieldSphereERKNS0_15HeightFieldUtilERKNS0_6SphereE, __ZN11ShapeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11ShapeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale0Ef, __ZNK12CubemapArray15GetCubemapCountEv: __ZNK12CubemapArray15GetCubemapCountEv, _UNITY_FT_Vector_Rotate: _UNITY_FT_Vector_Rotate, __ZN6Camera16ResetFieldOfViewEv: __ZN6Camera16ResetFieldOfViewEv, __Z41ParticleSystem_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth: __Z41ParticleSystem_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth, __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12CachedReader18InitResourceImagesER18ResourceImageGroup: __ZN12CachedReader18InitResourceImagesER18ResourceImageGroup, __ZN5physx5cloth11SwCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE: __ZN5physx5cloth11SwCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE, __Z42PointEffector2D_Get_Custom_PropForceSourceP12Il2CppObject: __Z42PointEffector2D_Get_Custom_PropForceSourceP12Il2CppObject, __ZNK5physx7NpScene16getGpuDispatcherEv: __ZNK5physx7NpScene16getGpuDispatcherEv, __ZN5physx7NpShapeD2Ev: __ZN5physx7NpShapeD2Ev, __Z52Register_UnityEngine_Graphics_DrawProceduralIndirectv: __Z52Register_UnityEngine_Graphics_DrawProceduralIndirectv, __ZNK7WeakPtrIN11SoundHandle8InstanceEE10SharedData9GetRawPtrEv: __ZNK7WeakPtrIN11SoundHandle8InstanceEE10SharedData9GetRawPtrEv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setExternalAccelerationERKNS_6PxVec3E: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23setExternalAccelerationERKNS_6PxVec3E, __ZNK26AnimatorControllerPlayable18ValidateLayerIndexEi: __ZNK26AnimatorControllerPlayable18ValidateLayerIndexEi, __ZN17PersistentManager25ExtractAwakeFromLoadQueueEPKijR18AwakeFromLoadQueue: __ZN17PersistentManager25ExtractAwakeFromLoadQueueEPKijR18AwakeFromLoadQueue, __Z59Register_UnityEngine_QualitySettings_set_masterTextureLimitv: __Z59Register_UnityEngine_QualitySettings_set_masterTextureLimitv, __ZNK5physx29PxSphericalJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j: __ZNK5physx29PxSphericalJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEEEEjT_j, __ZN5physx2Sq17SceneQueryManagerD2Ev: __ZN5physx2Sq17SceneQueryManagerD2Ev, _tre_match_empty: _tre_match_empty, __ZN8Animator18AutoMecanimDataSet5ResetEv: __ZN8Animator18AutoMecanimDataSet5ResetEv, __Z61Register_UnityEngine_ConstantForce_INTERNAL_get_relativeForcev: __Z61Register_UnityEngine_ConstantForce_INTERNAL_get_relativeForcev, __ZN19AudioHighPassFilterD0Ev: __ZN19AudioHighPassFilterD0Ev, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E11set_deletedER30dense_hashtable_const_iteratorIS9_S7_SB_SJ_SE_SH_E: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E11set_deletedER30dense_hashtable_const_iteratorIS9_S7_SB_SJ_SE_SH_E, __ZN5Umbra4Tome4initEPPKS0_PKhj: __ZN5Umbra4Tome4initEPPKS0_PKhj, __ZN20SoundChannelInstance11setPriorityEi: __ZN20SoundChannelInstance11setPriorityEi, __ZNSt3__213random_deviceD2Ev: __ZNSt3__213random_deviceD2Ev, __ZN5physx3Ext7D6Joint16setDrivePositionERKNS_11PxTransformE: __ZN5physx3Ext7D6Joint16setDrivePositionERKNS_11PxTransformE, __ZNK5physx14NpSceneQueries7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheE: __ZNK5physx14NpSceneQueries7raycastERKNS_6PxVec3ES3_fRNS_13PxHitCallbackINS_12PxRaycastHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheE, __ZNK5physx2Sc18ParticleSystemCore14getRestitutionEv: __ZNK5physx2Sc18ParticleSystemCore14getRestitutionEv, __ZN17PolygonCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17PolygonCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z56Register_UnityEngine_Physics2D_get_angularSleepTolerancev: __Z56Register_UnityEngine_Physics2D_get_angularSleepTolerancev, __ZN13GfxDeviceNull16CreateDepthStateERK13GfxDepthState: __ZN13GfxDeviceNull16CreateDepthStateERK13GfxDepthState, __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E14squash_deletedEv, __ZN5Unity17ConfigurableJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity17ConfigurableJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd7FastIPC16pumpPendingSendsEv: __ZN5physx6shdfnd7FastIPC16pumpPendingSendsEv, _UNITY_png_colorspace_set_ICC: _UNITY_png_colorspace_set_ICC, __ZN22UnityWebRequestManager7CleanupEv: __ZN22UnityWebRequestManager7CleanupEv, __ZN26DownloadHandlerAssetBundleD2Ev: __ZN26DownloadHandlerAssetBundleD2Ev, __Z15StartFMODRecordPN4FMOD6SystemEiPN11SoundHandle8InstanceEb: __Z15StartFMODRecordPN4FMOD6SystemEiPN11SoundHandle8InstanceEb, __ZN15DirectorManager14ConnectionPoolD2Ev: __ZN15DirectorManager14ConnectionPoolD2Ev, __ZNK7b2Mat3312GetInverse22EPS_: __ZNK7b2Mat3312GetInverse22EPS_, __ZNK24RingBufferMemoryFileData4ReadEyyPv: __ZNK24RingBufferMemoryFileData4ReadEyyPv, __Z63Register_UnityEngine_ParticleSystemRenderer_set_maxParticleSizev: __Z63Register_UnityEngine_ParticleSystemRenderer_set_maxParticleSizev, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE12getClassSizeEv, __ZN5physx15NpActorTemplateINS_7PxClothEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_7PxClothEE7setNameEPKc, __ZN22UnityWebRequestManager22InitializationCallbackEv: __ZN22UnityWebRequestManager22InitializationCallbackEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj72ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj72ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z53Register_UnityEngine_SurfaceEffector2D_set_forceScalev: __Z53Register_UnityEngine_SurfaceEffector2D_set_forceScalev, __ZN9Transform7GetRootEv: __ZN9Transform7GetRootEv, __Z25RectOffset_CUSTOM_CleanupP12Il2CppObject: __Z25RectOffset_CUSTOM_CleanupP12Il2CppObject, __ZN10Matrix4x4faSERK10Matrix3x3f: __ZN10Matrix4x4faSERK10Matrix3x3f, __ZN18ScriptingArguments28AdjustArgumentsToMatchMethodE21ScriptingMethodIl2Cpp: __ZN18ScriptingArguments28AdjustArgumentsToMatchMethodE21ScriptingMethodIl2Cpp, __ZNSt3__217moneypunct_bynameIcLb0EE4initEPKc: __ZNSt3__217moneypunct_bynameIcLb0EE4initEPKc, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b, __ZNK27AnimatorControllerParameter7GetNameEv: __ZNK27AnimatorControllerParameter7GetNameEv, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj, __Z65Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorRotationv: __Z65Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorRotationv, __ZN11AudioModule11FixedUpdateEv: __ZN11AudioModule11FixedUpdateEv, __Z49Register_UnityEngine_Profiling_Profiler_EndSamplev: __Z49Register_UnityEngine_Profiling_Profiler_EndSamplev, __Z16CalculateWeightsILb1EEvPP14AnimationStateiiPfi: __Z16CalculateWeightsILb1EEvPP14AnimationStateiiPfi, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj, __ZN5physx18PxsSolverStartTaskD0Ev: __ZN5physx18PxsSolverStartTaskD0Ev, __ZN13BitSetUtility10InitBitSetEPjj: __ZN13BitSetUtility10InitBitSetEPjj, __ZN14FileCacherReadC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjj: __ZN14FileCacherReadC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEjj, __ZN13MonoBehaviour17RenderImageFilterEPN5Unity9ComponentEP13RenderTextureS4_: __ZN13MonoBehaviour17RenderImageFilterEPN5Unity9ComponentEP13RenderTextureS4_, __ZN4FMOD6Reverb13getPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD6Reverb13getPropertiesEP22FMOD_REVERB_PROPERTIES, __ZN5Unity5Cloth10SetDampingEf: __ZN5Unity5Cloth10SetDampingEf, __ZN17Physics2DSettingsD2Ev: __ZN17Physics2DSettingsD2Ev, __ZN17AudioCustomFilter6GetDSPEv: __ZN17AudioCustomFilter6GetDSPEv, __ZN16LevelGameManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16LevelGameManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14RenderSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z29Application_CUSTOM_CancelQuitv: __Z29Application_CUSTOM_CancelQuitv, __ZN16ReflectionProbes24RefreshAllRealtimeProbesEv: __ZN16ReflectionProbes24RefreshAllRealtimeProbesEv, __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx2Minusx1PKN5physx17PxVehicleTireDataE: __Z54getPxVehicleTireData_FrictionVsSlipGraphRecipx2Minusx1PKN5physx17PxVehicleTireDataE, __Z25GetAudioEffectDefinitionsjPPP26UnityAudioEffectDefinition: __Z25GetAudioEffectDefinitionsjPPP26UnityAudioEffectDefinition, __Z40Register_UnityEngine_WindZone_get_radiusv: __Z40Register_UnityEngine_WindZone_get_radiusv, __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_: __ZNSt3__26__sortIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEvT0_S6_T_, __ZN5physx22XmlMemoryAllocatorImplD2Ev: __ZN5physx22XmlMemoryAllocatorImplD2Ev, __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev: __ZN5physx29PxVehicleDriveNWGeneratedInfoC2Ev, __ZN8Collider26SupportedMessagesDidChangeEi: __ZN8Collider26SupportedMessagesDidChangeEi, __Z29GL_CUSTOM_LoadPixelMatrixArgsffff: __Z29GL_CUSTOM_LoadPixelMatrixArgsffff, __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_: __Z23GetTransformationMatrixPN4math8float3x3EbbRK10Matrix4x4fS4_, __Z52GUIText_CUSTOM_INTERNAL_CALL_Internal_SetPixelOffsetP12Il2CppObjectRK13Vector2fIcall: __Z52GUIText_CUSTOM_INTERNAL_CALL_Internal_SetPixelOffsetP12Il2CppObjectRK13Vector2fIcall, __ZN19SkinnedMeshRenderer11GetOptBonesEv: __ZN19SkinnedMeshRenderer11GetOptBonesEv, __Z57Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorv: __Z57Register_UnityEngine_Rigidbody_INTERNAL_set_inertiaTensorv, __ZN15LODGroupManager14RemoveLODGroupEi: __ZN15LODGroupManager14RemoveLODGroupEi, __ZNK26AnimatorOverrideController21GetAnimatorControllerEv: __ZNK26AnimatorOverrideController21GetAnimatorControllerEv, __Z54Register_UnityEngine_Renderer_set_reflectionProbeUsagev: __Z54Register_UnityEngine_Renderer_set_reflectionProbeUsagev, __ZN12BaseRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN12BaseRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN9ShaderLab23ClearGrabPassFrameStateEv: __ZN9ShaderLab23ClearGrabPassFrameStateEv, __ZN15AABBTreeOverlapIN5physx2Gu12AABBAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE: __ZN15AABBTreeOverlapIN5physx2Gu12AABBAABBTestEEclEPNS0_2Sq13PrunerPayloadERKNS4_8AABBTreeERKS2_RNS4_14PrunerCallbackE, __ZNSt3__26locale5__imp7installINS_15messages_bynameIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15messages_bynameIcEEEEvPT_, __Z26Texture3D_CUSTOM_GetPixelsP12Il2CppObjecti: __Z26Texture3D_CUSTOM_GetPixelsP12Il2CppObjecti, __ZN5physx2Sn20SerializationContext18getTotalStoredSizeEv: __ZN5physx2Sn20SerializationContext18getTotalStoredSizeEv, __ZN8Animator9GetAvatarEv: __ZN8Animator9GetAvatarEv, __ZN5physx28PxTriangleMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx28PxTriangleMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN24MidPhaseQueryLocalReport7onEventEjPj: __ZN24MidPhaseQueryLocalReport7onEventEjPj, __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6insertIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPjEEE4typeENSD_IPKjEES9_S9_: __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6insertIPKtEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPjEEE4typeENSD_IPKjEES9_S9_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj659ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj659ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN13GfxDeviceGLES23CreateGPUSkinPoseBufferEv: __ZN13GfxDeviceGLES23CreateGPUSkinPoseBufferEv, _ft_alloc: _ft_alloc, __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv: __ZN5physx22PxVehicleWheelsDynData11setUserDataEjPv, __Z34Camera_Set_Custom_PropOrthographicP12Il2CppObjecth: __Z34Camera_Set_Custom_PropOrthographicP12Il2CppObjecth, __ZN19AtomicPageAllocator5ClearEv: __ZN19AtomicPageAllocator5ClearEv, __ZN9LensFlare23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9LensFlare23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13GfxDeviceNull16BeginBufferWriteEP9GfxBufferjj: __ZN13GfxDeviceNull16BeginBufferWriteEP9GfxBufferjj, __ZN13b2DynamicTree12AllocateNodeEv: __ZN13b2DynamicTree12AllocateNodeEv, __Z42TerrainCollider_Set_Custom_PropTerrainDataP12Il2CppObjectS0_: __Z42TerrainCollider_Set_Custom_PropTerrainDataP12Il2CppObjectS0_, __ZN18AwakeFromLoadQueue19InvokeAwakeFromLoadEPNS_4ItemEj17AwakeFromLoadMode: __ZN18AwakeFromLoadQueue19InvokeAwakeFromLoadEPNS_4ItemEj17AwakeFromLoadMode, __ZN11UnityEngine7ConnectL19ConfigChangedStaticEPNS0_14RemoteSettingsERK8UnityStrR8JSONRead: __ZN11UnityEngine7ConnectL19ConfigChangedStaticEPNS0_14RemoteSettingsERK8UnityStrR8JSONRead, __Z36GetBlendShapeFrameVerticesFromScriptRK4MeshiiP11Il2CppArrayS3_S3_: __Z36GetBlendShapeFrameVerticesFromScriptRK4MeshiiP11Il2CppArrayS3_S3_, __ZN5physx2Sc15ContactIterator11getNextPairEv: __ZN5physx2Sc15ContactIterator11getNextPairEv, __Z36Register_UnityEngine_Animator_Rebindv: __Z36Register_UnityEngine_Animator_Rebindv, __Z24RegisterStrippedTypeInfoI18SpeedTreeWindAssetEviPKcS2_: __Z24RegisterStrippedTypeInfoI18SpeedTreeWindAssetEviPKcS2_, __Z31ReadObjectFromPersistentManageri: __Z31ReadObjectFromPersistentManageri, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN9JSONWrite17TransferBasicDataIxEEvRT_: __ZN9JSONWrite17TransferBasicDataIxEEvRT_, __ZN10Matrix4x4f8SetBasisERK8Vector3fS2_S2_: __ZN10Matrix4x4f8SetBasisERK8Vector3fS2_S2_, __Z13RegisterClassI11MonoManagerEvv: __Z13RegisterClassI11MonoManagerEvv, __ZN8VRDevice20HandleGfxThreadEventE25UnityVREventGfxThreadTypej: __ZN8VRDevice20HandleGfxThreadEventE25UnityVREventGfxThreadTypej, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEP15FileSystemEntryEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_, __Z42Register_UnityEngine_Shader_SetGlobalFloatv: __Z42Register_UnityEngine_Shader_SetGlobalFloatv, __ZN10AudioMixer8TransferI17RemapPPtrTransferEEvRT_: __ZN10AudioMixer8TransferI17RemapPPtrTransferEEvRT_, __ZNK14SoundHandleAPI12GetLengthPCMEv: __ZNK14SoundHandleAPI12GetLengthPCMEv, __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue: __ZN10GameObject32ActivateAwakeRecursivelyInternalE19DeactivateOperationR18AwakeFromLoadQueue, __ZN4PPtrI19SkinnedMeshRendererE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI19SkinnedMeshRendererE8TransferI14SafeBinaryReadEEvRT_, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewGlobalRef13Il2Cpp_IntPtrRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewGlobalRef13Il2Cpp_IntPtrRPv, __ZN7mecanim12statemachine33DestroySelectorTransitionConstantEPNS0_26SelectorTransitionConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine33DestroySelectorTransitionConstantEPNS0_26SelectorTransitionConstantERNS_6memory9AllocatorE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev, __Z54Register_UnityEngine_Physics2D_get_maxTranslationSpeedv: __Z54Register_UnityEngine_Physics2D_get_maxTranslationSpeedv, __Z48Register_UnityEngine_Renderer_set_useLightProbesv: __Z48Register_UnityEngine_Renderer_set_useLightProbesv, __ZN12InputManager12CleanupClassEv: __ZN12InputManager12CleanupClassEv, __ZN5Umbra9IndexListaSERKS0_: __ZN5Umbra9IndexListaSERKS0_, __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN22VertexCacheDeOptimizerIjLi16EE19DeOptimizeTrianglesEPjjPKjj: __ZN22VertexCacheDeOptimizerIjLi16EE19DeOptimizeTrianglesEPjjPKjj, __ZN19SkinnedMeshRenderer15BecameInvisibleEv: __ZN19SkinnedMeshRenderer15BecameInvisibleEv, __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessImmEEPmEEjT0_S5_S5_S5_T_, __ZN13TextRendering17TextMeshGenerator15GetVertexFormatEv: __ZN13TextRendering17TextMeshGenerator15GetVertexFormatEv, __Z39Physics_CUSTOM_INTERNAL_CALL_OverlapBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction: __Z39Physics_CUSTOM_INTERNAL_CALL_OverlapBoxRK8Vector3fS1_RK11Quaternionfi23QueryTriggerInteraction, __Z28GUIUtility_CUSTOM_GetChangedv: __Z28GUIUtility_CUSTOM_GetChangedv, __ZN25MultiBlocksMemoryFileData6UnlockEPv: __ZN25MultiBlocksMemoryFileData6UnlockEPv, __ZN8Material13EnableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8Material13EnableKeywordERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z55Register_UnityEngine_PointEffector2D_set_forceMagnitudev: __Z55Register_UnityEngine_PointEffector2D_set_forceMagnitudev, __ZN21UnityAnalyticsManager23RegisterGlobalCallbacksEv: __ZN21UnityAnalyticsManager23RegisterGlobalCallbacksEv, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_fEEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_fEEEEEEEEvRT_17TransferMetaFlags, __ZN6Shader23HandleShadersWithErrorsEv: __ZN6Shader23HandleShadersWithErrorsEv, __ZNK9SubModule19GetSubEmittersCountEv: __ZNK9SubModule19GetSubEmittersCountEv, __ZNK26AnimatorOverrideController26GetTypeInfoVirtualInternalEv: __ZNK26AnimatorOverrideController26GetTypeInfoVirtualInternalEv, __Z35ParticleSystem_CUSTOM_Internal_EmitP12Il2CppObjectR24ParticleSystemEmitParamsi: __Z35ParticleSystem_CUSTOM_Internal_EmitP12Il2CppObjectR24ParticleSystemEmitParamsi, __Z37Register_UnityEngine_GL_BeginInternalv: __Z37Register_UnityEngine_GL_BeginInternalv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK12AudioManager25RequiresCustomSpatializerEv: __ZNK12AudioManager25RequiresCustomSpatializerEv, __ZNSt3__218shared_timed_mutex6unlockEv: __ZNSt3__218shared_timed_mutex6unlockEv, __ZN16b2PrismaticJoint24SolvePositionConstraintsERK12b2SolverData: __ZN16b2PrismaticJoint24SolvePositionConstraintsERK12b2SolverData, __ZN13GfxDeviceGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE: __ZN13GfxDeviceGLES15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE, __ZN19CharacterController24CleanupControllerManagerEv: __ZN19CharacterController24CleanupControllerManagerEv, __ZNKSt3__210moneypunctIcLb0EE10neg_formatEv: __ZNKSt3__210moneypunctIcLb0EE10neg_formatEv, __Z34DeveloperConsole_HandleLogFunctionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib: __Z34DeveloperConsole_HandleLogFunctionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z30CanvasRenderer_CUSTOM_SetAlphaP12Il2CppObjectf: __Z30CanvasRenderer_CUSTOM_SetAlphaP12Il2CppObjectf, __ZN14PhysicsManager19GetPerformanceStatsER12PhysicsStats: __ZN14PhysicsManager19GetPerformanceStatsER12PhysicsStats, __Z24RegisterStrippedTypeInfoI8MaterialEviPKcS2_: __Z24RegisterStrippedTypeInfoI8MaterialEviPKcS2_, __Z55Register_UnityEngine_AI_NavMesh_GetNavMeshLayerFromNamev: __Z55Register_UnityEngine_AI_NavMesh_GetNavMeshLayerFromNamev, __ZN4FMOD7Channel17set3DDopplerLevelEf: __ZN4FMOD7Channel17set3DDopplerLevelEf, _tt_cmap4_init: _tt_cmap4_init, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendESt16initializer_listIcE, __ZN12TextureInput9SetBufferEPv: __ZN12TextureInput9SetBufferEPv, __ZNK11AudioSource30GetCustomSpatialBlendCurveCopyEv: __ZNK11AudioSource30GetCustomSpatialBlendCurveCopyEv, __Z30GetGUIStateCurrentDisplayIndexv: __Z30GetGUIStateCurrentDisplayIndexv, __ZN5Light23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Light23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN14PhysicsManager7onSleepEPPN5physx7PxActorEj: __ZN14PhysicsManager7onSleepEPPN5physx7PxActorEj, __Z52Register_UnityEngine_ReflectionProbe_set_refreshModev: __Z52Register_UnityEngine_ReflectionProbe_set_refreshModev, __ZN4PPtrI11NavMeshDataE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI11NavMeshDataE8TransferI14SafeBinaryReadEEvRT_, __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoD2Ev: __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoD2Ev, __ZN20TextRenderingPrivate11FormatStack10PushFormatERKNS_16TextFormatChangeE: __ZN20TextRenderingPrivate11FormatStack10PushFormatERKNS_16TextFormatChangeE, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueNS_4lessIS6_EENS4_INS_4pairIKS6_S7_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSB_, __ZN13SparseTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13SparseTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN11Rigidbody2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11Rigidbody2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9ShaderLab9IntShader15ResolveFallbackERKNS_16SerializedShaderEP6ShaderRNSt3__26vectorI4PPtrIS4_ENS6_9allocatorIS9_EEEEb: __ZN9ShaderLab9IntShader15ResolveFallbackERKNS_16SerializedShaderEP6ShaderRNSt3__26vectorI4PPtrIS4_ENS6_9allocatorIS9_EEEEb, __ZN5physx21PxcContactConvexMesh2ERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx21PxcContactConvexMesh2ERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN12HandlerChain8IsLockedERK13FileEntryData: __ZN12HandlerChain8IsLockedERK13FileEntryData, __ZN5physx2Sc9ClothCore24setLinearDragCoefficientENS_6PxVec3E: __ZN5physx2Sc9ClothCore24setLinearDragCoefficientENS_6PxVec3E, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv, __ZN16ScriptingManager29GetUserDefinedAssemblyPostfixEv: __ZN16ScriptingManager29GetUserDefinedAssemblyPostfixEv, __ZNK5physx2Sc21ElementSimInteraction23isLastFilterInteractionEv: __ZNK5physx2Sc21ElementSimInteraction23isLastFilterInteractionEv, __ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN11PlayerPrefs6HasKeyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZZN8Animator15InitializeClassEvEN43FunctorImpl_387kDidModifyAnimatorController4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN43FunctorImpl_387kDidModifyAnimatorController4CallEPviR11MessageData, __ZN5audio5mixer14FindGroupIndexERKNS0_18AudioMixerConstantERK9UnityGUID: __ZN5audio5mixer14FindGroupIndexERKNS0_18AudioMixerConstantERK9UnityGUID, __Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z13IsFileCreatedRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN10Matrix4x4f8SetScaleERK8Vector3f: __ZN10Matrix4x4f8SetScaleERK8Vector3f, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE17getDominanceGroupEv, __ZN5physx2Sc9StaticSimD0Ev: __ZN5physx2Sc9StaticSimD0Ev, __ZN37RotationBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN37RotationBySpeedModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN10__cxxabiv120__function_type_infoD0Ev: __ZN10__cxxabiv120__function_type_infoD0Ev, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToByteArrayP11Il2CppArrayRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToByteArrayP11Il2CppArrayRPv, __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEvT0_S7_T_, __Z24RegisterStrippedTypeInfoI14ParticleSystemEviPKcS2_: __Z24RegisterStrippedTypeInfoI14ParticleSystemEviPKcS2_, __ZN5physx16PxVehicleDrive4W8allocateEj: __ZN5physx16PxVehicleDrive4W8allocateEj, __ZN25ConvexVsMeshSweepCallbackD0Ev: __ZN25ConvexVsMeshSweepCallbackD0Ev, _ilogbf: _ilogbf, __Z50Register_UnityEngine_AndroidJNI_GetStaticByteFieldv: __Z50Register_UnityEngine_AndroidJNI_GetStaticByteFieldv, __ZN4FMOD4DSPI9setActiveEb: __ZN4FMOD4DSPI9setActiveEb, __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf: __ZN5Umbra9RasterOps26updateDepthBufferReferenceERKNS_17BlockRasterBufferERNS_11DepthBufferEf, __ZN10__cxxabiv112_GLOBAL__N_118parse_expr_primaryINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_118parse_expr_primaryINS0_2DbEEEPKcS4_S4_RT_, __Z42Register_UnityEngine_Animator_SetTriggerIDv: __Z42Register_UnityEngine_Animator_SetTriggerIDv, __ZN15MulticastSocketC2Ev: __ZN15MulticastSocketC2Ev, __Z61Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetRTv: __Z61Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetRTv, __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_: __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE9push_backERKS2_, __ZN5physx45updateAtomFrictionProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj: __ZN5physx45updateAtomFrictionProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj, __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi: __ZN22UnityProfilerPerThread11BeginSampleEP19ProfilerInformationi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj522ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44Register_UnityEngine_Animator_get_humanScalev: __Z44Register_UnityEngine_Animator_get_humanScalev, __ZN12BaseRenderer23RendererCullingCallbackEv: __ZN12BaseRenderer23RendererCullingCallbackEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj468ENS_22PxRepXPropertyAccessorILj468ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj468ENS_22PxRepXPropertyAccessorILj468ES4_ffEEEEvRKT0_, _vsscanf: _vsscanf, __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIhhEEPhEEjT0_S5_S5_T_, __ZNK5physx5cloth14IterationStateI8Scalar4fE16getPreviousAlphaEv: __ZNK5physx5cloth14IterationStateI8Scalar4fE16getPreviousAlphaEv, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12resize_deltaEjj, __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif: __ZNK17AnimationCurveTplI8Vector3fE18CalculateCacheDataERNS1_5CacheEiif, __Z23sweepCCTCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z23sweepCCTCapsule_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNSt3__227__insertion_sort_incompleteIR15ReflProbeSorterPP15ReflectionProbeEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR15ReflProbeSorterPP15ReflectionProbeEEbT0_S6_T_, __ZN11NoiseModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11NoiseModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__217__assoc_sub_state13set_exceptionESt13exception_ptr: __ZNSt3__217__assoc_sub_state13set_exceptionESt13exception_ptr, __ZN5Unity5Cloth22SetUseVirtualParticlesEb: __ZN5Unity5Cloth22SetUseVirtualParticlesEb, __Z15allGreaterEqualRK8Scalar4fS1_: __Z15allGreaterEqualRK8Scalar4fS1_, __Z24DoMotionVectorRenderLoopR17RenderLoopContext: __Z24DoMotionVectorRenderLoopR17RenderLoopContext, __Z13VFormatLengthPKcPi: __Z13VFormatLengthPKcPi, __Z35Random_CUSTOM_INTERNAL_get_rotationP11Quaternionf: __Z35Random_CUSTOM_INTERNAL_get_rotationP11Quaternionf, __Z40AudioChorusFilter_Get_Custom_PropWetMix1P12Il2CppObject: __Z40AudioChorusFilter_Get_Custom_PropWetMix1P12Il2CppObject, __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__26vectorIN5physx25PxVehicleWheelQueryResultENS0_9allocatorIS3_EEEEE16StaticInitializeEPv, __ZN9AudioClip20CreateScriptCallbackEv: __ZN9AudioClip20CreateScriptCallbackEv, __ZN13RuntimeStaticI14dynamic_bitsetE16StaticInitializeEPv: __ZN13RuntimeStaticI14dynamic_bitsetE16StaticInitializeEPv, __ZN16BaseVideoTexture10YUYVToRGBAEPt: __ZN16BaseVideoTexture10YUYVToRGBAEPt, __ZN15LocationService24SetHeadingUpdatesEnabledEb: __ZN15LocationService24SetHeadingUpdatesEnabledEb, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5rdbufEv, _mbtowc: _mbtowc, _setegid: _setegid, __Z42Screen_Get_Custom_PropAutorotateToPortraitv: __Z42Screen_Get_Custom_PropAutorotateToPortraitv, __ZN21OverlapCapsuleQuery2DD2Ev: __ZN21OverlapCapsuleQuery2DD2Ev, __ZN5physx2Sn5ConvX10initOutputERNS_14PxOutputStreamE: __ZN5physx2Sn5ConvX10initOutputERNS_14PxOutputStreamE, __ZN23ShaderVariantCollectionD2Ev: __ZN23ShaderVariantCollectionD2Ev, __ZN5physx11NpAggregate8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx11NpAggregate8requiresERNS_23PxProcessPxBaseCallbackE, __ZN26VertexDeclarationCacheGLES23CreateVertexDeclarationERK18VertexChannelsInfo: __ZN26VertexDeclarationCacheGLES23CreateVertexDeclarationERK18VertexChannelsInfo, __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b: __ZN12HeaderHelper14SetUnvalidatedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b, __ZN7mecanim9animation4Clip8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation4Clip8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz: __ZN5physx2Sn5ConvX14displayMessageENS_11PxErrorCode4EnumEPKcz, __ZL20InternalGetByteArrayPK15DownloadHandler: __ZL20InternalGetByteArrayPK15DownloadHandler, __ZN4FMOD8ChannelI11setPriorityEi: __ZN4FMOD8ChannelI11setPriorityEi, __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypej: __ZNK8VRDevice17SendEventCallbackE16UnityVREventTypej, __Z23GUIDToStringWithHyphensRK9UnityGUID: __Z23GUIDToStringWithHyphensRK9UnityGUID, __ZN5physx2Sn18RepXCollectionImplC2ERNS_23PxSerializationRegistryERNS_19PxAllocatorCallbackERNS_12PxCollectionE: __ZN5physx2Sn18RepXCollectionImplC2ERNS_23PxSerializationRegistryERNS_19PxAllocatorCallbackERNS_12PxCollectionE, __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx8debugger4comm15RemoveObjectRef9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm15RemoveObjectRef9serializeERNS1_15EventSerializerE, __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE12allocateSlabEv, _UNITY_png_colorspace_endpoints_match: _UNITY_png_colorspace_endpoints_match, __ZN11NavMeshData23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11NavMeshData23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN14ParticleSystem13SetUsesTrailsEv: __ZN14ParticleSystem13SetUsesTrailsEv, __Z51Register_UnityEngine_CanvasGroup_get_blocksRaycastsv: __Z51Register_UnityEngine_CanvasGroup_get_blocksRaycastsv, _UNITY_tt_face_get_ps_name: _UNITY_tt_face_get_ps_name, __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate7GUITextEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate7GUITextEEviPKcS3_, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19setInvInertiaScale1Ef, __ZNSt3__218__time_get_storageIcEC2EPKc: __ZNSt3__218__time_get_storageIcEC2EPKc, _jsimd_h2v1_merged_upsample: _jsimd_h2v1_merged_upsample, _UNITY_png_create_png_struct: _UNITY_png_create_png_struct, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8__appendEj, __Z46Register_UnityEngine_AndroidJNI_PushLocalFramev: __Z46Register_UnityEngine_AndroidJNI_PushLocalFramev, __Z42Register_UnityEngine_PlayerPrefs_DeleteAllv: __Z42Register_UnityEngine_PlayerPrefs_DeleteAllv, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE6assignIPjEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZNK9dtNavMesh7getTileEi: __ZNK9dtNavMesh7getTileEi, __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_: __ZNSt3__26vectorI4PPtrI10GameObjectE13stl_allocatorIS3_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_, __ZN4FMOD5Sound17get3DConeSettingsEPfS1_S1_: __ZN4FMOD5Sound17get3DConeSettingsEPfS1_S1_, __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIfNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIfEEEEE8recreateEj, __ZN7SubMesh8TransferI14SafeBinaryReadEEvRT_: __ZN7SubMesh8TransferI14SafeBinaryReadEEvRT_, __ZN19CollisionListener2DD2Ev: __ZN19CollisionListener2DD2Ev, __ZN5Umbra9Matrix3x35identEv: __ZN5Umbra9Matrix3x35identEv, __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_anchorv: __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_set_anchorv, __ZNK5physx15PxDistanceJoint8isKindOfEPKc: __ZNK5physx15PxDistanceJoint8isKindOfEPKc, __ZN5physx5cloth5arrayERNS_6PxVec3E: __ZN5physx5cloth5arrayERNS_6PxVec3E, __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_fb, __ZN12MeshRenderer26SetAdditionalVertexStreamsEP4Mesh: __ZN12MeshRenderer26SetAdditionalVertexStreamsEP4Mesh, _unzReadCurrentFile: _unzReadCurrentFile, __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf: __ZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPf, __ZNK9Heightmap15GetAdjustedSizeEi: __ZNK9Heightmap15GetAdjustedSizeEi, __ZNK5physx2Sc18ParticleSystemCore18getProjectionPlaneEv: __ZNK5physx2Sc18ParticleSystemCore18getProjectionPlaneEv, __ZN9AnimationC2E10MemLabelId18ObjectCreationMode: __ZN9AnimationC2E10MemLabelId18ObjectCreationMode, __Z58Register_UnityEngine_Physics2D_get_queriesStartInCollidersv: __Z58Register_UnityEngine_Physics2D_get_queriesStartInCollidersv, __Z22delete_object_internalP6Object: __Z22delete_object_internalP6Object, __ZN26LightProbeProxyVolumeUtilsL20FindTetrahedronIndexER9TransformRi: __ZN26LightProbeProxyVolumeUtilsL20FindTetrahedronIndexER9TransformRi, __Z20CalculateSurfaceAreaRK10Matrix4x4fRKNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEER13dynamic_arrayI8Vector3fLj4EE: __Z20CalculateSurfaceAreaRK10Matrix4x4fRKNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEER13dynamic_arrayI8Vector3fLj4EE, __Z88Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerStringv: __Z88Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerStringv, __Z43Register_UnityEngine_GUIStyle_set_alignmentv: __Z43Register_UnityEngine_GUIStyle_set_alignmentv, __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNK14b2PolygonShape11ComputeMassEP10b2MassDataf: __ZNK14b2PolygonShape11ComputeMassEP10b2MassDataf, __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_targetv: __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_get_targetv, __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjPKj: __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEjjPKj, __ZNK16MemoryFileSystem6ExistsERK13FileEntryData: __ZNK16MemoryFileSystem6ExistsERK13FileEntryData, __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve: __Z66ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetMagnitudeP12Il2CppObjectR15MonoMinMaxCurve, __ZN15LightProbeGroup17RemoveFromManagerEv: __ZN15LightProbeGroup17RemoveFromManagerEv, __ZN5physx15NpParticleFluidD2Ev: __ZN5physx15NpParticleFluidD2Ev, __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD6Reverb15get3DAttributesEP11FMOD_VECTORPfS3_: __ZN4FMOD6Reverb15get3DAttributesEP11FMOD_VECTORPfS3_, __Z50Register_UnityEngine_RenderTexture_get_volumeDepthv: __Z50Register_UnityEngine_RenderTexture_get_volumeDepthv, __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE, __ZN26AnimatorOverrideController8GetAssetEb: __ZN26AnimatorOverrideController8GetAssetEb, __ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE: __ZL15processContactsRN5physx6PxVec3ERfjPKNS_2Gu12ContactPointE, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN7mecanim12statemachine19CreateStateConstantEPPNS0_18TransitionConstantEjfjbbbjfjPPNS_9animation17BlendTreeConstantEjjjjjbRNS_6memory9AllocatorE: __ZN7mecanim12statemachine19CreateStateConstantEPPNS0_18TransitionConstantEjfjbbbjfjPPNS_9animation17BlendTreeConstantEjjjjjbRNS_6memory9AllocatorE, __ZNK10FileSystem18GetApplicationPathEv: __ZNK10FileSystem18GetApplicationPathEv, _XXH64_update: _XXH64_update, __ZN11OffMeshLink16RemoveConnectionEv: __ZN11OffMeshLink16RemoveConnectionEv, __ZN5physx3Cct12SweptCapsuleD0Ev: __ZN5physx3Cct12SweptCapsuleD0Ev, __ZN9Animation8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Animation8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10GUIElement7HitTestERK8Vector2fRK5RectTIfE: __ZN10GUIElement7HitTestERK8Vector2fRK5RectTIfE, __Z18ReadBufferFromFileP13dynamic_arrayIhLj1EERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z18ReadBufferFromFileP13dynamic_arrayIhLj1EERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __Z18HandleSteppedCurveRK11KeyframeTplI8Vector3fES3_RS0_: __Z18HandleSteppedCurveRK11KeyframeTplI8Vector3fES3_RS0_, __ZNK5physx3Cct17CapsuleController9getRadiusEv: __ZNK5physx3Cct17CapsuleController9getRadiusEv, __ZL18ActiveSceneChangedP10UnitySceneS0_: __ZL18ActiveSceneChangedP10UnitySceneS0_, __ZNK19SkinnedMeshRenderer26GetTypeInfoVirtualInternalEv: __ZNK19SkinnedMeshRenderer26GetTypeInfoVirtualInternalEv, __ZN5physx24getBinaryMetaData_PxBaseERNS_14PxOutputStreamE: __ZN5physx24getBinaryMetaData_PxBaseERNS_14PxOutputStreamE, __ZN5Umbra5QueryC2EPKNS_14TomeCollectionE: __ZN5Umbra5QueryC2EPKNS_14TomeCollectionE, __Z24RegisterStrippedTypeInfoI24OcclusionCullingSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI24OcclusionCullingSettingsEviPKcS2_, __ZNSt3__219__thread_struct_imp27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE: __ZNSt3__219__thread_struct_imp27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE, __GLOBAL__sub_I_runtime_utilities_lump_cpp: __GLOBAL__sub_I_runtime_utilities_lump_cpp, _cf2_hintmap_map: _cf2_hintmap_map, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf, __Z51PlatformEffector2D_Get_Custom_PropUseOneWayGroupingP12Il2CppObject: __Z51PlatformEffector2D_Get_Custom_PropUseOneWayGroupingP12Il2CppObject, __ZNK5Umbra14TomeCollection15getClusterCountEv: __ZNK5Umbra14TomeCollection15getClusterCountEv, __Z24DecodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24DecodeStringWithNewlinesRNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb: __ZN5physx3Scb5Scene20removeParticleSystemERNS0_14ParticleSystemEb, __ZN17RemapPPtrTransfer8TransferI13SplatDatabaseEEvRT_PKc17TransferMetaFlags: __ZN17RemapPPtrTransfer8TransferI13SplatDatabaseEEvRT_PKc17TransferMetaFlags, __ZL24PutAdditionalShadowLightRK4AABBRK11ActiveLightRK10Matrix4x4ffR13dynamic_arrayI16ForwardShadowMapLj4EE: __ZL24PutAdditionalShadowLightRK4AABBRK11ActiveLightRK10Matrix4x4ffR13dynamic_arrayI16ForwardShadowMapLj4EE, __ZNK15NavMeshSettings19ShouldWriteForBuildEv: __ZNK15NavMeshSettings19ShouldWriteForBuildEv, __ZN6Shader8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN6Shader8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN17PersistentManager19RemapToAbsolutePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager19RemapToAbsolutePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5Umbra12OutputStreamD2Ev: __ZN5Umbra12OutputStreamD2Ev, __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE: __ZN5physx2Sc27ConstraintProjectionManager15invalidateGroupERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimE, __ZN13SliderJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13SliderJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx10NpMaterial25setRestitutionCombineModeENS_13PxCombineMode4EnumE: __ZN5physx10NpMaterial25setRestitutionCombineModeENS_13PxCombineMode4EnumE, __ZN14RedirectHelper10RedirectToERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN14RedirectHelper10RedirectToERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __ZNKSt3__220__codecvt_utf8_utf16IDiE16do_always_noconvEv: __ZNKSt3__220__codecvt_utf8_utf16IDiE16do_always_noconvEv, __ZN11GameManager13NetworkUpdateEv: __ZN11GameManager13NetworkUpdateEv, __Z43LineRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf: __Z43LineRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf, _UNITY_tt_face_done_loca: _UNITY_tt_face_done_loca, __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED0Ev, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale1Ef, __ZNK5physx7NpCloth26getCentrifugalInertiaScaleEv: __ZNK5physx7NpCloth26getCentrifugalInertiaScaleEv, __Z52Gyroscope_CUSTOM_INTERNAL_CALL_rotationRate_InternaliR8Vector3f: __Z52Gyroscope_CUSTOM_INTERNAL_CALL_rotationRate_InternaliR8Vector3f, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags, __ZN14DetailDatabase18CreateTextureAtlasEPP9Texture2DP5RectTIfEjb: __ZN14DetailDatabase18CreateTextureAtlasEPP9Texture2DP5RectTIfEjb, __ZZN13BuildSettingsC1E10MemLabelId18ObjectCreationModeEN27initializedPreloadedPlugins7ForwardEv: __ZZN13BuildSettingsC1E10MemLabelId18ObjectCreationModeEN27initializedPreloadedPlugins7ForwardEv, __ZN9AudioClip22GetFormatFromExtensionERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9AudioClip22GetFormatFromExtensionERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN16MemoryFileSystem12CreateAsFileER13FileEntryData: __ZN16MemoryFileSystem12CreateAsFileER13FileEntryData, __Z49Playable_CUSTOM_INTERNAL_CALL_SetDurationInternalR9HPlayabled: __Z49Playable_CUSTOM_INTERNAL_CALL_SetDurationInternalR9HPlayabled, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_zDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_zDrivev, __ZN11SoundHandle8Instance7DisposeEv: __ZN11SoundHandle8Instance7DisposeEv, __ZN5physx20PxShapeGeneratedInfoC2Ev: __ZN5physx20PxShapeGeneratedInfoC2Ev, __ZN6Camera6RenderER11CullResultsR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera6RenderER11CullResultsR17ShaderPassContextNS_10RenderFlagE, __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE: __ZN5physx2Sc19ConstraintGroupNode28markForProjectionTreeRebuildERNS0_27ConstraintProjectionManagerE, __ZN12CachedWriter5WriteEPKvj: __ZN12CachedWriter5WriteEPKvj, ___cxx_global_var_init5: ___cxx_global_var_init5, __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_: __Z19CalculateConvexHullR13dynamic_arrayI8Vector2fLj4EES2_, __Z27SetClippingPlaneShaderPropsR9GfxDevice: __Z27SetClippingPlaneShaderPropsR9GfxDevice, __Z56Register_UnityEngine_Terrain_INTERNAL_set_legacySpecularv: __Z56Register_UnityEngine_Terrain_INTERNAL_set_legacySpecularv, __Z48Register_UnityEngine_Motion_get_isAnimatorMotionv: __Z48Register_UnityEngine_Motion_get_isAnimatorMotionv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5uflowEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5uflowEv, __ZN5physx18RepXSerializerImplINS_7PxShapeEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_7PxShapeEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN13BitSetUtility8MoveBitsEPjjjj: __ZN13BitSetUtility8MoveBitsEPjjjj, __Z26setPxHeightFieldDescFormatPN5physx17PxHeightFieldDescENS_19PxHeightFieldFormat4EnumE: __Z26setPxHeightFieldDescFormatPN5physx17PxHeightFieldDescENS_19PxHeightFieldFormat4EnumE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags, __ZN5physx11NodeManager6resizeEj: __ZN5physx11NodeManager6resizeEj, __ZNK19TextRenderingModule38FontGetNumCharactersThatFitWithinWidthEPN13TextRendering4FontERK11UTF16Stringfij: __ZNK19TextRenderingModule38FontGetNumCharactersThatFitWithinWidthEPN13TextRendering4FontERK11UTF16Stringfij, __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN14ParticleSystem13SetRandomSeedEj: __ZN14ParticleSystem13SetRandomSeedEj, __ZN10Effector2D25CheckEffectorColliderMaskEP10Collider2DS1_: __ZN10Effector2D25CheckEffectorColliderMaskEP10Collider2DS1_, __ZN14DLHAudioHelper15LockPartialDataEv: __ZN14DLHAudioHelper15LockPartialDataEv, __ZN5physx19ActorAABBUpdateTaskD0Ev: __ZN5physx19ActorAABBUpdateTaskD0Ev, __ZNK9DebugGLES3LogEPKc: __ZNK9DebugGLES3LogEPKc, __ZN8Renderer20SetupSortingOverrideEv: __ZN8Renderer20SetupSortingOverrideEv, __ZN5physx23PxsSolverSetupSolveTask11runInternalEv: __ZN5physx23PxsSolverSetupSolveTask11runInternalEv, __Z31Cloth_Get_Custom_PropUseGravityP12Il2CppObject: __Z31Cloth_Get_Custom_PropUseGravityP12Il2CppObject, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEEEvPT_jRKT0_RKT1_j, __Z20SetStackTraceLogType7LogType17StackTraceLogType: __Z20SetStackTraceLogType7LogType17StackTraceLogType, _gzclose: _gzclose, ___tan: ___tan, __ZN24MaterialDisplayListCache16CachedShaderPass9FindEntryERK16ShaderKeywordSet: __ZN24MaterialDisplayListCache16CachedShaderPass9FindEntryERK16ShaderKeywordSet, __Z67Register_UnityEngine_PhysicMaterial_Internal_CreateDynamicsMaterialv: __Z67Register_UnityEngine_PhysicMaterial_Internal_CreateDynamicsMaterialv, __ZNSt3__212bad_weak_ptrD0Ev: __ZNSt3__212bad_weak_ptrD0Ev, __ZNK5physx7NpCloth23getSelfCollisionIndicesEPj: __ZNK5physx7NpCloth23getSelfCollisionIndicesEPj, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZN15TerrainCollider15ThreadedCleanupEv: __ZN15TerrainCollider15ThreadedCleanupEv, __ZN4FMOD5Sound10getNumTagsEPiS1_: __ZN4FMOD5Sound10getNumTagsEPiS1_, __ZNK18AssetBundleManager37GetAssetBundleAndScenePathBySceneNameERK8UnityStrRP11AssetBundleRS0_: __ZNK18AssetBundleManager37GetAssetBundleAndScenePathBySceneNameERK8UnityStrRP11AssetBundleRS0_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getUserDataEv, __ZN21AnimationClipPlayable11SetDurationEd: __ZN21AnimationClipPlayable11SetDurationEd, __Z57Register_UnityEngine_SystemInfo_get_operatingSystemFamilyv: __Z57Register_UnityEngine_SystemInfo_get_operatingSystemFamilyv, __ZNK22LocalFileSystemHandler21GetUserAppCacheFolderEv: __ZNK22LocalFileSystemHandler21GetUserAppCacheFolderEv, __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj: __Z29DecompressNativeTextureFormat13TextureFormatS_iiPKjiiPj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj164ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj164ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_: __ZNSt3__27__sort5IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_, __ZN24DownloadHandlerAudioClip22OnReceiveContentLengthEj: __ZN24DownloadHandlerAudioClip22OnReceiveContentLengthEj, __ZN13BuildSettings12GetSceneNameEi: __ZN13BuildSettings12GetSceneNameEi, __Z24RegisterStrippedTypeInfoI15UnityAdsManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI15UnityAdsManagerEviPKcS2_, __ZN13AvatarBuilder22RemoveAllNoneHumanLeafERNSt3__26vectorINS_14NamedTransformENS0_9allocatorIS2_EEEERK16HumanDescription: __ZN13AvatarBuilder22RemoveAllNoneHumanLeafERNSt3__26vectorINS_14NamedTransformENS0_9allocatorIS2_EEEERK16HumanDescription, __ZN10GameObject25SetSupportedMessagesDirtyEv: __ZN10GameObject25SetSupportedMessagesDirtyEv, __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE: __ZN19ProfilerInformationC2EPKc13ProfilerGroupNS_5FlagsE, __ZN14VelocityModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles: __ZN14VelocityModule16UpdateProceduralERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticles, __Z55Register_UnityEngine_Physics2D_get_changeStopsCallbacksv: __Z55Register_UnityEngine_Physics2D_get_changeStopsCallbacksv, __Z38DownloadHandler_CUSTOM_InternalDestroyP12Il2CppObject: __Z38DownloadHandler_CUSTOM_InternalDestroyP12Il2CppObject, __ZN8WWWAudio17UnlockPartialDataEv: __ZN8WWWAudio17UnlockPartialDataEv, __ZNK5physx7NpScene28getSceneQueryStaticTimestampEv: __ZNK5physx7NpScene28getSceneQueryStaticTimestampEv, __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_S5_T_, __Z40getPxJointLimitParametersBounceThresholdPKN5physx22PxJointLimitParametersE: __Z40getPxJointLimitParametersBounceThresholdPKN5physx22PxJointLimitParametersE, __ZN13GfxDeviceNull15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE: __ZN13GfxDeviceNull15DiscardContentsER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseE, __ZN12_GLOBAL__N_115StringTableImplD0Ev: __ZN12_GLOBAL__N_115StringTableImplD0Ev, __ZNK22LocalFileSystemHandler19GetUserConfigFolderEv: __ZNK22LocalFileSystemHandler19GetUserConfigFolderEv, __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale0Ev: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale0Ev, __ZN21PxsParallelSolverTaskD0Ev: __ZN21PxsParallelSolverTaskD0Ev, __ZN2UI15PixelAdjustRectEPNS_13RectTransformEPNS_6CanvasE: __ZN2UI15PixelAdjustRectEPNS_13RectTransformEPNS_6CanvasE, __Z30setPxParticleBase_ParticleMassPN5physx14PxParticleBaseEf: __Z30setPxParticleBase_ParticleMassPN5physx14PxParticleBaseEf, __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_23PxcSolverConstraintDescENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z20getPxJoint_LocalPosePKN5physx7PxJointENS_17PxJointActorIndex4EnumE: __Z20getPxJoint_LocalPosePKN5physx7PxJointENS_17PxJointActorIndex4EnumE, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKN12_GLOBAL__N_117ClassPropertyNameEPNS4_12PropDescImplEEES5_NS4_23ClassPropertyNameHasherENS1_11HashMapBaseIS5_S8_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofERKS5_j, __Z48ParticleSystemRenderer_Set_Custom_PropRenderModeP12Il2CppObject24ParticleSystemRenderMode: __Z48ParticleSystemRenderer_Set_Custom_PropRenderModeP12Il2CppObject24ParticleSystemRenderMode, __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_: __ZN8Renderer8TransferI14SafeBinaryReadEEvRT_, __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_set_enableCaptureExceptionsv: __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_set_enableCaptureExceptionsv, __ZNK15b2RevoluteJoint14IsLimitEnabledEv: __ZNK15b2RevoluteJoint14IsLimitEnabledEv, __ZN11UmbraModule21QueryPortalVisibilityEPN5Umbra10VisibilityEPK22SceneCullingParametersjii: __ZN11UmbraModule21QueryPortalVisibilityEPN5Umbra10VisibilityEPK22SceneCullingParametersjii, __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN15MBP_PairManager13reserveMemoryEj: __ZN15MBP_PairManager13reserveMemoryEj, __ZN14UnityAnalytics11GetTestModeEv: __ZN14UnityAnalytics11GetTestModeEv, __Z32IsCaptureAllKeyboardInputEnabledv: __Z32IsCaptureAllKeyboardInputEnabledv, __ZN44ConvexVsHeightfieldContactGenerationCallbackD0Ev: __ZN44ConvexVsHeightfieldContactGenerationCallbackD0Ev, __ZNK14Texture2DArray20GetRuntimeMemorySizeEv: __ZNK14Texture2DArray20GetRuntimeMemorySizeEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags, __Z35SkinnedMeshRenderer_CUSTOM_BakeMeshP12Il2CppObjectS0_: __Z35SkinnedMeshRenderer_CUSTOM_BakeMeshP12Il2CppObjectS0_, __ZN12CubemapArrayD2Ev: __ZN12CubemapArrayD2Ev, __Z24RegisterStrippedTypeInfoIN5Unity5JointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity5JointEEviPKcS3_, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25getMassSpaceInertiaTensorEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25getMassSpaceInertiaTensorEv, __Z26tessMeshTessellateInteriorP8TESSmesh: __Z26tessMeshTessellateInteriorP8TESSmesh, __Z13RegisterClassI21UnityAnalyticsManagerEvv: __Z13RegisterClassI21UnityAnalyticsManagerEvv, __Z64Register_UnityEngine_Animator_IsParameterControlledByCurveStringv: __Z64Register_UnityEngine_Animator_IsParameterControlledByCurveStringv, __Z43Register_UnityEngine_ComputeShader_Dispatchv: __Z43Register_UnityEngine_ComputeShader_Dispatchv, __Z25getPxPhysics_ClothFabricsPKN5physx9PxPhysicsEPPNS_13PxClothFabricEj: __Z25getPxPhysics_ClothFabricsPKN5physx9PxPhysicsEPPNS_13PxClothFabricEj, __ZNK12_GLOBAL__N_123DoubleBufferedOutStream11isConnectedEv: __ZNK12_GLOBAL__N_123DoubleBufferedOutStream11isConnectedEv, __ZN12WheelJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN12WheelJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN20SphericalHarmonicsL111AddWeightedERKS_f: __ZN20SphericalHarmonicsL111AddWeightedERKS_f, __Z53Register_UnityEngine_Physics_set_sleepAngularVelocityv: __Z53Register_UnityEngine_Physics_set_sleepAngularVelocityv, __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj: __ZN5physx2Sc5Scene7addBodyERNS0_8BodyCoreEPKPvjj, __Z56Register_UnityEngine_Application_get_streamingAssetsPathv: __Z56Register_UnityEngine_Application_get_streamingAssetsPathv, __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZL19DrawSimpleWatermark13WatermarkEnumff: __ZL19DrawSimpleWatermark13WatermarkEnumff, __ZN19ClampVelocityModule16CheckConsistencyEv: __ZN19ClampVelocityModule16CheckConsistencyEv, __ZN10SizeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10SizeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16updateSleepStateEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE16updateSleepStateEv, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEE15growAndPushBackERKS5_, __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj: __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE8allocateEj, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayv, __Z49Register_UnityEngine_FrictionJoint2D_get_maxForcev: __Z49Register_UnityEngine_FrictionJoint2D_get_maxForcev, _UNITY_png_calculate_crc: _UNITY_png_calculate_crc, __ZN15FrictionJoint2D5ResetEv: __ZN15FrictionJoint2D5ResetEv, __ZN18StreamedBinaryReadILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sn5ConvX6outputEPKci: __ZN5physx2Sn5ConvX6outputEPKci, __ZN5physx38PxVehicleDriveSimData4WGeneratedValuesC2EPKNS_23PxVehicleDriveSimData4WE: __ZN5physx38PxVehicleDriveSimData4WGeneratedValuesC2EPKNS_23PxVehicleDriveSimData4WE, __ZN14ParticleSystem14SetSecPositionEf: __ZN14ParticleSystem14SetSecPositionEf, _pop_arg_481: _pop_arg_481, _strcspn: _strcspn, __Z40Register_UnityEngine_TrailRenderer_Clearv: __Z40Register_UnityEngine_TrailRenderer_Clearv, __Z48Physics_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK8Vector3fS1_fS1_P11Il2CppArrayfi23QueryTriggerInteraction: __Z48Physics_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK8Vector3fS1_fS1_P11Il2CppArrayfi23QueryTriggerInteraction, __ZN8Animator22ScriptingStringToCRC32ER11ICallString: __ZN8Animator22ScriptingStringToCRC32ER11ICallString, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN22UnityAnalyticsSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN16ParticleAnimatorD0Ev: __ZN16ParticleAnimatorD0Ev, __Z42Register_UnityEngine_Screen_set_fullScreenv: __Z42Register_UnityEngine_Screen_set_fullScreenv, __ZN12AdsIdHandler28ScheduleJobToFetchAsyncAdsIdEv: __ZN12AdsIdHandler28ScheduleJobToFetchAsyncAdsIdEv, __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj: __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj, __ZN13WheelCollider7CleanupEv: __ZN13WheelCollider7CleanupEv, __ZN21WorldParticleCollider15ThreadedCleanupEv: __ZN21WorldParticleCollider15ThreadedCleanupEv, __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsulev: __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsulev, __ZNK8Renderer11GetMaterialEi: __ZNK8Renderer11GetMaterialEi, __ZN6b2BodyD2Ev: __ZN6b2BodyD2Ev, __ZNK22LocalFileSystemHandler26GetApplicationContentsPathEv: __ZNK22LocalFileSystemHandler26GetApplicationContentsPathEv, __ZN12_GLOBAL__N_138ArchiveRedirectFileSystemStaticDestroyEPv: __ZN12_GLOBAL__N_138ArchiveRedirectFileSystemStaticDestroyEPv, __ZNK5physx5cloth8SwFabric13getNumTethersEv: __ZNK5physx5cloth8SwFabric13getNumTethersEv, __ZN10TagManager8TransferI14SafeBinaryReadEEvRT_: __ZN10TagManager8TransferI14SafeBinaryReadEEvRT_, __Z42setPxParticleReadDataCollisionNormalBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE: __Z42setPxParticleReadDataCollisionNormalBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE13isSubordinateEv, __ZNK8Animator21GetControllerConstantEv: __ZNK8Animator21GetControllerConstantEv, __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MoveRotationv: __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_MoveRotationv, __ZN12GUIClipState3PopER10InputEvent: __ZN12GUIClipState3PopER10InputEvent, _strtoumax: _strtoumax, __ZN18GfxFramebufferGLES37GetFramebufferNameFromDepthAttachmentEP17RenderSurfaceBase: __ZN18GfxFramebufferGLES37GetFramebufferNameFromDepthAttachmentEP17RenderSurfaceBase, __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_: __ZN10Matrix4x4f6SetTRSERK8Vector3fRK11QuaternionfS2_, __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeYMultiplierP12Il2CppObject: __Z56ParticleSystem_MainModule_CUSTOM_GetStartSizeYMultiplierP12Il2CppObject, _ft_raster1_set_mode: _ft_raster1_set_mode, _UNITY_png_malloc_array: _UNITY_png_malloc_array, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj, __ZN14SafeBinaryRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlags, __ZN5physx2Gu8getPlaneERKNS_11PxTransformE: __ZN5physx2Gu8getPlaneERKNS_11PxTransformE, __ZL25MotionVectorRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL25MotionVectorRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZNK8Animator8HasStateEii: __ZNK8Animator8HasStateEii, __ZN5physx2Sc5Scene16stepSetupCollideEv: __ZN5physx2Sc5Scene16stepSetupCollideEv, __Z30getPxJointLinearLimitPairLowerPKN5physx22PxJointLinearLimitPairE: __Z30getPxJointLinearLimitPairLowerPKN5physx22PxJointLinearLimitPairE, __ZN5physx20PxCreateSpatialIndexEv: __ZN5physx20PxCreateSpatialIndexEv, __ZN10Effector2D32ProcessCheckEffectorColliderMaskEP10Collider2DS1_: __ZN10Effector2D32ProcessCheckEffectorColliderMaskEP10Collider2DS1_, _UNITY_FT_Get_Sfnt_Table: _UNITY_FT_Get_Sfnt_Table, __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcRNS_21PxProfileNameProviderEj: __ZN5physx13PxProfileZone17createProfileZoneEPNS_12PxFoundationEPKcRNS_21PxProfileNameProviderEj, __Z39getPxArticulationJoint_ConcreteTypeNamePKN5physx19PxArticulationJointE: __Z39getPxArticulationJoint_ConcreteTypeNamePKN5physx19PxArticulationJointE, __Z5splatILj0EE8Scalar4fRKS0_: __Z5splatILj0EE8Scalar4fRKS0_, __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER9TransformR13dynamic_arrayI20BoundCurveDeprecatedLj4EERNS3_6vectorIPSF_S6_ISM_LSA_25ELi16EEEERi: __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER9TransformR13dynamic_arrayI20BoundCurveDeprecatedLj4EERNS3_6vectorIPSF_S6_ISM_LSA_25ELi16EEEERi, __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __Z39Transform_Get_Custom_PropParentInternalP12Il2CppObject: __Z39Transform_Get_Custom_PropParentInternalP12Il2CppObject, __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15AudioEchoFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z35getPxDistanceJoint_ConcreteTypeNamePKN5physx15PxDistanceJointE: __Z35getPxDistanceJoint_ConcreteTypeNamePKN5physx15PxDistanceJointE, __Z51Register_UnityEngine_AudioChorusFilter_set_feedbackv: __Z51Register_UnityEngine_AudioChorusFilter_set_feedbackv, __ZNK5Umbra18ReceiverMaskBuffer8getDepthEii: __ZNK5Umbra18ReceiverMaskBuffer8getDepthEii, __ZN12_GLOBAL__N_112UserRenderer10drawPointsEPKN5physx8debugger8renderer8PvdPointEj: __ZN12_GLOBAL__N_112UserRenderer10drawPointsEPKN5physx8debugger8renderer8PvdPointEj, __Z29StdTemplateConversionFunctionIjsEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjsEbPvR14SafeBinaryRead, __ZN5physx3Ext10FixedJoint29setProjectionAngularToleranceEf: __ZN5physx3Ext10FixedJoint29setProjectionAngularToleranceEf, __Z20DestroyCullingOutputR13CullingOutput: __Z20DestroyCullingOutputR13CullingOutput, __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE: __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVE, __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E: __ZN5physx2Sc8ShapeSimC2ERNS0_8RigidSimERKNS0_9ShapeCoreEPNS_12PxsRigidBodyEPNS_9PxBounds3E, __ZNK5physx7NpScene26getFrictionOffsetThresholdEv: __ZNK5physx7NpScene26getFrictionOffsetThresholdEv, __Z21pqHeapDeletePriorityQP9TESSallocP13PriorityQHeap: __Z21pqHeapDeletePriorityQP9TESSallocP13PriorityQHeap, __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14AreaEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z20IntersectionAABBAABBRK10MinMaxAABBS1_PS_: __Z20IntersectionAABBAABBRK10MinMaxAABBS1_PS_, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEEC2ERNS_19PxAllocatorCallbackE, __ZN9RigidbodyC2E10MemLabelId18ObjectCreationMode: __ZN9RigidbodyC2E10MemLabelId18ObjectCreationMode, __ZNK5physx16PxVehicleDrive4W19getConcreteTypeNameEv: __ZNK5physx16PxVehicleDrive4W19getConcreteTypeNameEv, __Z49Mesh_CUSTOM_INTERNAL_CALL_GetNativeIndexBufferPtrP12Il2CppObjectRPv: __Z49Mesh_CUSTOM_INTERNAL_CALL_GetNativeIndexBufferPtrP12Il2CppObjectRPv, __ZN5physx8debugger4comm25BeginPropertyMessageGroup9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm25BeginPropertyMessageGroup9serializeERNS1_15EventSerializerE, __ZN9JSONWrite14BeginMetaGroupEPKc: __ZN9JSONWrite14BeginMetaGroupEPKc, __ZN12NavMeshAgent15InitializeClassEv: __ZN12NavMeshAgent15InitializeClassEv, __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE: __ZN8Material24GetTextureScaleAndOffsetEN9ShaderLab16FastPropertyNameE, __ZN7mecanim28CreateValueArrayConstantCopyEPKNS_18ValueArrayConstantEjRNS_6memory9AllocatorE: __ZN7mecanim28CreateValueArrayConstantCopyEPKNS_18ValueArrayConstantEjRNS_6memory9AllocatorE, __Z51Register_UnityEngine_AndroidJNI_EnsureLocalCapacityv: __Z51Register_UnityEngine_AndroidJNI_EnsureLocalCapacityv, __Z54Register_UnityEngine_AudioReverbFilter_get_lfReferencev: __Z54Register_UnityEngine_AudioReverbFilter_get_lfReferencev, __ZN9Rigidbody22UpdateMassDistributionEv: __ZN9Rigidbody22UpdateMassDistributionEv, __ZN12AudioManager21SetActiveOutputDriverEP9FMOD_GUID: __ZN12AudioManager21SetActiveOutputDriverEP9FMOD_GUID, __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaNERKS4_: __ZN5physx5cloth11SwCollisionI8Scalar4fE9ShapeMaskaNERKS4_, __ZN5physx2Sc15ClothFabricCoreC2Ev: __ZN5physx2Sc15ClothFabricCoreC2Ev, __Z51QualitySettings_Get_Custom_PropAnisotropicFilteringv: __Z51QualitySettings_Get_Custom_PropAnisotropicFilteringv, __ZN17PersistentManager42GetSerializedFileInternalIfObjectAvailableEix: __ZN17PersistentManager42GetSerializedFileInternalIfObjectAvailableEix, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, _UNITY_tt_face_load_loca: _UNITY_tt_face_load_loca, _pthread_cond_broadcast: _pthread_cond_broadcast, __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE: __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE4copyIS9_EEvRKNS1_IS5_T_EE, __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14SplatPrototype8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj67ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj67ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK11UnityEngine9Animation28GenericAnimationBindingCache20CreateGenericBindingERK8UnityStri4PPtrI10MonoScriptES4_bRNS0_14GenericBindingE: __ZNK11UnityEngine9Animation28GenericAnimationBindingCache20CreateGenericBindingERK8UnityStri4PPtrI10MonoScriptES4_bRNS0_14GenericBindingE, __ZN5physx3Ext13DistanceJoint12setStiffnessEf: __ZN5physx3Ext13DistanceJoint12setStiffnessEf, __ZNK12CubemapArray12GetDataWidthEv: __ZNK12CubemapArray12GetDataWidthEv, __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYMultiplierv: __Z82Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYMultiplierv, __ZN18SpeedTreeWindAsset15ThreadedCleanupEv: __ZN18SpeedTreeWindAsset15ThreadedCleanupEv, __ZN17AnimationPlayableD2Ev: __ZN17AnimationPlayableD2Ev, __ZN12_GLOBAL__N_112UserRendererD0Ev: __ZN12_GLOBAL__N_112UserRendererD0Ev, __Z35setPxScene_CCDContactModifyCallbackPN5physx7PxSceneEPNS_26PxCCDContactModifyCallbackE: __Z35setPxScene_CCDContactModifyCallbackPN5physx7PxSceneEPNS_26PxCCDContactModifyCallbackE, __Z17IsValidScriptType14MonoScriptType: __Z17IsValidScriptType14MonoScriptType, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE13isSubordinateEv, __ZN7mecanim9animation19Blend2dDataConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation19Blend2dDataConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx11HullLibraryD2Ev: __ZN5physx11HullLibraryD2Ev, __Z24GetCompressionTypeString13TextureFormat: __Z24GetCompressionTypeString13TextureFormat, __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_: __ZNSt3__27__sort5IR12RaycastHit2DPS1_EEjT0_S4_S4_S4_S4_T_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv, __ZN7mecanim12statemachine29GetTransitionSourceStateIndexENS0_16TransitionSourceEPNS0_18StateMachineMemoryE: __ZN7mecanim12statemachine29GetTransitionSourceStateIndexENS0_16TransitionSourceEPNS0_18StateMachineMemoryE, __ZN4FMOD8ChannelI7getMuteEPb: __ZN4FMOD8ChannelI7getMuteEPb, __ZN5Umbra4AABB13flattenToSideEi: __ZN5Umbra4AABB13flattenToSideEi, __ZN22CreateGpuProgramOutput20CreateChannelAssignsEv: __ZN22CreateGpuProgramOutput20CreateChannelAssignsEv, __ZNSt3__23mapINS_4pairIPcS2_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS_9allocatorINS1_IKS3_S8_EEEEEixERSE_: __ZNSt3__23mapINS_4pairIPcS2_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS_9allocatorINS1_IKS3_S8_EEEEEixERSE_, __ZN22BaseUnityConnectClient8SetStateENS_5StateE: __ZN22BaseUnityConnectClient8SetStateENS_5StateE, __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener: __ZN12AdsIdHandler17RequestAdsIdAsyncER14IAdsIdListener, __Z59Register_UnityEngine_WheelCollider_ConfigureVehicleSubstepsv: __Z59Register_UnityEngine_WheelCollider_ConfigureVehicleSubstepsv, __Z50Register_UnityEngine_ParticleSystem_get_isEmittingv: __Z50Register_UnityEngine_ParticleSystem_get_isEmittingv, __Z57Register_UnityEngine_SurfaceEffector2D_get_speedVariationv: __Z57Register_UnityEngine_SurfaceEffector2D_get_speedVariationv, __Z19LoadAndLookupSymbolRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z19LoadAndLookupSymbolRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_: __ZNSt3__26__sortIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEvT0_SB_T_, __Z9SetIClothP6ICloth: __Z9SetIClothP6ICloth, __ZN13AvatarBuilder12IsValidHumanERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE: __ZN13AvatarBuilder12IsValidHumanERK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEER9TransformRNS3_12basic_stringIcNS3_11char_traitsIcEENS6_IcEEEE, __Z43Register_UnityEngine_Animation_get_wrapModev: __Z43Register_UnityEngine_Animation_get_wrapModev, __ZN5physx2Gu24computeMTD_CapsuleConvexERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES9_: __ZN5physx2Gu24computeMTD_CapsuleConvexERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES9_, __ZN23ControllerContactFilterC2Ev: __ZN23ControllerContactFilterC2Ev, __ZN22BaseUnityConnectClient25PrepareCloudServiceConfigEv: __ZN22BaseUnityConnectClient25PrepareCloudServiceConfigEv, __ZN5physx7NpCloth21setDampingCoefficientENS_6PxVec3E: __ZN5physx7NpCloth21setDampingCoefficientENS_6PxVec3E, __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity5Joint16JointTransferPreI18StreamedBinaryReadILb1EEEEvRT_, __ZNK15FileSystemEntry4PathEv: __ZNK15FileSystemEntry4PathEv, __ZN5physx3Cct10Controller19rideOnTouchedObjectERNS0_11SweptVolumeERKNS_6PxVec3ERS4_PKNS_17PxObstacleContextE: __ZN5physx3Cct10Controller19rideOnTouchedObjectERNS0_11SweptVolumeERKNS_6PxVec3ERS4_PKNS_17PxObstacleContextE, __ZN12TLSAllocatorI14StackAllocatorE16FrameMaintenanceEb: __ZN12TLSAllocatorI14StackAllocatorE16FrameMaintenanceEb, __Z29scripting_profiler_set_eventsi: __Z29scripting_profiler_set_eventsi, __ZN7Terrain13SetLightmapSTERK8Vector4f12LightmapType: __ZN7Terrain13SetLightmapSTERK8Vector4f12LightmapType, __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE: __ZL32InitializeDefaultQualitySettingsPN15QualitySettings14QualitySettingE, __ZN20TextRenderingPrivate7GUIText5ResetEv: __ZN20TextRenderingPrivate7GUIText5ResetEv, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE19getConcreteTypeNameEv, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE, _UNITY_png_get_signature: _UNITY_png_get_signature, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh: __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEE6resizeEjRKh, __ZN18DelayedCallManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18DelayedCallManager7PRODUCEE10MemLabelId18ObjectCreationMode, _skip_variable: _skip_variable, __ZN13TrailRendererD0Ev: __ZN13TrailRendererD0Ev, __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_RNS3_18ImpulseAccumulatorE: __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_RNS3_18ImpulseAccumulatorE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj268ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxConvexMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj268ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_, __ZN14EdgeCollider2DC2E10MemLabelId18ObjectCreationMode: __ZN14EdgeCollider2DC2E10MemLabelId18ObjectCreationMode, __Z66AnimatorControllerPlayable_CUSTOM_GetNextAnimatorStateInfoInternalR9HPlayablei: __Z66AnimatorControllerPlayable_CUSTOM_GetNextAnimatorStateInfoInternalR9HPlayablei, __ZN5physx6shdfnd10SocketImpl10disconnectEv: __ZN5physx6shdfnd10SocketImpl10disconnectEv, __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalVectorv: __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalVectorv, __ZN5physx2Gu11gjkRelativeINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE, __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture: __ZN19ShaderPropertySheet10SetTextureERKN9ShaderLab16FastPropertyNameEP7Texture, __Z59GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorStringIndex13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectRK13Vector2fIcall: __Z59GUIStyle_CUSTOM_INTERNAL_CALL_Internal_GetCursorStringIndex13Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectRK13Vector2fIcall, __ZN8GUILayer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8GUILayer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z26setPxSceneDescCcdMaxPassesPN5physx11PxSceneDescEj: __Z26setPxSceneDescCcdMaxPassesPN5physx11PxSceneDescEj, __Z29getPxSphericalJoint_LimitConePKN5physx16PxSphericalJointE: __Z29getPxSphericalJoint_LimitConePKN5physx16PxSphericalJointE, __ZN23CloudWebServicesManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN23CloudWebServicesManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z53Register_UnityEngine_ParticleSystemRenderer_GetMeshesv: __Z53Register_UnityEngine_ParticleSystemRenderer_GetMeshesv, __ZN17AnimationPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN17AnimationPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_ToIntArrayP11Il2CppArrayRPv: __Z42AndroidJNI_CUSTOM_INTERNAL_CALL_ToIntArrayP11Il2CppArrayRPv, __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy: __ZN5physx8debugger4comm31PvdCommStreamInternalDataStream6createERNS_19PxAllocatorCallbackERNS1_21PvdOMMetaDataProviderEjRNS1_30PvdCommStreamEventBufferClientEy, __ZN19OverlapPointQuery2DD0Ev: __ZN19OverlapPointQuery2DD0Ev, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z42Register_UnityEngine_Canvas_set_renderModev: __Z42Register_UnityEngine_Canvas_set_renderModev, __ZN15FileSystemEntryaSERKS_: __ZN15FileSystemEntryaSERKS_, __ZN5Unity5Cloth13UpdateNormalsEv: __ZN5Unity5Cloth13UpdateNormalsEv, __ZL25default_terminate_handlerv: __ZL25default_terminate_handlerv, __ZL19CleanupModule_WebGLv: __ZL19CleanupModule_WebGLv, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv, __ZN5Unity17ToNovodexInfinityEf: __ZN5Unity17ToNovodexInfinityEf, __Z26scripting_field_get_parentP9FieldInfo: __Z26scripting_field_get_parentP9FieldInfo, __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_: __ZN5physx2Gu22closestPtPointTriangleERKNS_6PxVec3ES3_S3_S3_RfS4_, __ZN15DetailPrototypeD2Ev: __ZN15DetailPrototypeD2Ev, __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI14SafeBinaryReadEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI14SafeBinaryReadEEvRS6_RT_, __ZN14PhysicMaterial16GetBounceCombineEv: __ZN14PhysicMaterial16GetBounceCombineEv, __ZN5physx27solveExtContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx27solveExtContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZNK26DownloadHandlerAssetBundle8GetErrorEv: __ZNK26DownloadHandlerAssetBundle8GetErrorEv, __ZN5physx15PxsParticleData13onOriginShiftERKNS_6PxVec3E: __ZN5physx15PxsParticleData13onOriginShiftERKNS_6PxVec3E, __ZNK5physx20PxsParticleSystemSim22getSimulationTimeStepVEv: __ZNK5physx20PxsParticleSystemSim22getSimulationTimeStepVEv, __ZN16ShapeCast2DQueryD0Ev: __ZN16ShapeCast2DQueryD0Ev, __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z59ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN8Animator10SetIntegerEii: __ZN8Animator10SetIntegerEii, __ZN5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE18clearInterpolationEv, __ZN5physx21PxsBodyTransformVaultD2Ev: __ZN5physx21PxsBodyTransformVaultD2Ev, __Z48Register_UnityEngine_Sprite_INTERNAL_CALL_Createv: __Z48Register_UnityEngine_Sprite_INTERNAL_CALL_Createv, __Z23GetPersistentManagerPtrv: __Z23GetPersistentManagerPtrv, __Z21SupportsMotionVectorsv: __Z21SupportsMotionVectorsv, __ZNK10InputEvent5DebugEv: __ZNK10InputEvent5DebugEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z38Register_UnityEngine_Cloth_get_dampingv: __Z38Register_UnityEngine_Cloth_get_dampingv, __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_: __ZNSt3__27__sort3IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_T_, __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE: __ZN5physx3Ext19ProfileEventHandler16reportCollectionERNS_26PxBufferedProfilerCallbackERKNS1_15EventCollectionE, __ZN4math8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4math8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi1EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi1EEEEvRT_17TransferMetaFlags, __ZN19CloudServiceHandler17InitServiceFolderENS_13InitModeFlagsE: __ZN19CloudServiceHandler17InitServiceFolderENS_13InitModeFlagsE, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNKSt3__28messagesIwE5closeEi: __ZNKSt3__28messagesIwE5closeEi, __Z55Register_UnityEngine_Animator_GetAnimatorTransitionInfov: __Z55Register_UnityEngine_Animator_GetAnimatorTransitionInfov, _main: _main, __Z23sweepConvex_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z23sweepConvex_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN7mecanim9animation25DestroyStreamedClipMemoryERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE: __ZN7mecanim9animation25DestroyStreamedClipMemoryERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE, __ZN27NoiseModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN27NoiseModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN5physx3Ext14PrismaticJoint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext14PrismaticJoint15importExtraDataERNS_24PxDeserializationContextE, _cff_property_set: _cff_property_set, __ZN9ShaderLab26GetFastPropertyIndexByNameEPKc: __ZN9ShaderLab26GetFastPropertyIndexByNameEPKc, __Z33GetIAnimationStateNetworkProviderv: __Z33GetIAnimationStateNetworkProviderv, __Z52Register_UnityEngine_Mesh_GetBlendShapeFrameVerticesv: __Z52Register_UnityEngine_Mesh_GetBlendShapeFrameVerticesv, _UNITY_ft_smooth_lcdv_renderer_class_pic_init: _UNITY_ft_smooth_lcdv_renderer_class_pic_init, __ZN13OcclusionArea23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13OcclusionArea23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx3Ext7D6Joint29getProjectionAngularToleranceEv: __ZNK5physx3Ext7D6Joint29getProjectionAngularToleranceEv, __Z13GetImagePixelI11ColorRGBA32ET_PKhii13TextureFormat15TextureWrapModeii: __Z13GetImagePixelI11ColorRGBA32ET_PKhii13TextureFormat15TextureWrapModeii, __Z31AudioFilterReadValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object: __Z31AudioFilterReadValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object, __ZN7ApiGLES9InitDebugEv: __ZN7ApiGLES9InitDebugEv, __ZN8GUIState10BeginOnGUIER14ObjectGUIState: __ZN8GUIState10BeginOnGUIER14ObjectGUIState, __ZN7mecanim9animation24CreateStreamedClipMemoryERKNS0_12StreamedClipERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE: __ZN7mecanim9animation24CreateStreamedClipMemoryERKNS0_12StreamedClipERNS0_18StreamedClipMemoryERNS_6memory9AllocatorE, __Z52Register_UnityEngine_LODGroup_set_animateCrossFadingv: __Z52Register_UnityEngine_LODGroup_set_animateCrossFadingv, __Z34getPxVehicleDriveTankMDriveSimDataPKN5physx18PxVehicleDriveTankE: __Z34getPxVehicleDriveTankMDriveSimDataPKN5physx18PxVehicleDriveTankE, __ZN8Animator16SetStabilizeFeetEb: __ZN8Animator16SetStabilizeFeetEb, __ZN19AssetBundleManifestD2Ev: __ZN19AssetBundleManifestD2Ev, __Z31Register_UnityEngine_Mesh_Clearv: __Z31Register_UnityEngine_Mesh_Clearv, __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeIiEET_PP15Il2CppExceptionb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z43Register_UnityEngine_Avatar_SetMuscleMinMaxv: __Z43Register_UnityEngine_Avatar_SetMuscleMinMaxv, __ZNK5physx13NpVolumeCache7isValidEj: __ZNK5physx13NpVolumeCache7isValidEj, __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceTypev: __Z54Register_UnityEngine_SystemInfo_get_graphicsDeviceTypev, __ZN4glsl22IsShaderParameterArrayEPKciiPb: __ZN4glsl22IsShaderParameterArrayEPKciiPb, __Z36QualitySettings_CUSTOM_DecreaseLevelh: __Z36QualitySettings_CUSTOM_DecreaseLevelh, __ZN5physx17PxcNpMemBlockPool19acquireContactBlockEv: __ZN5physx17PxcNpMemBlockPool19acquireContactBlockEv, __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE: __ZN7ApiGLES15BindFramebufferEN2gl17FramebufferTargetENS0_6HandleILNS0_10ObjectTypeE9EEE, __ZNK5physx13NpVolumeCache7isValidEv: __ZNK5physx13NpVolumeCache7isValidEv, __ZN21LightProbeProxyVolume8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21LightProbeProxyVolume8TransferI24GenerateTypeTreeTransferEEvRT_, __Z25setPxArticulationUserDataPN5physx14PxArticulationEPv: __Z25setPxArticulationUserDataPN5physx14PxArticulationEPv, __ZN28LightProbeProxyVolumeManager16BlendLightProbesER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager16BlendLightProbesER21LightProbeProxyVolume, __ZN5physx3Cct17CapsuleControllerD0Ev: __ZN5physx3Cct17CapsuleControllerD0Ev, __ZN23LODTreeInstanceRenderer10UpdateWindEv: __ZN23LODTreeInstanceRenderer10UpdateWindEv, __ZN5physx36PxVehicleWheels4SimDataGeneratedInfoC2Ev: __ZN5physx36PxVehicleWheels4SimDataGeneratedInfoC2Ev, __Z32LightProbes_Get_Custom_PropCountP12Il2CppObject: __Z32LightProbes_Get_Custom_PropCountP12Il2CppObject, __ZN10AudioMixer20FindSnapshotFromNameEPKc: __ZN10AudioMixer20FindSnapshotFromNameEPKc, __Z36AudioEchoFilter_Set_Custom_PropDelayP12Il2CppObjectf: __Z36AudioEchoFilter_Set_Custom_PropDelayP12Il2CppObjectf, __Z24RegisterModuleClasses_VRv: __Z24RegisterModuleClasses_VRv, __ZN18DownloadHandlerVFS4InitEPKc: __ZN18DownloadHandlerVFS4InitEPKc, __ZN9AudioClipC2E10MemLabelId18ObjectCreationMode: __ZN9AudioClipC2E10MemLabelId18ObjectCreationMode, __ZN11AudioSource7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11AudioSource7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE: __ZN6prcoreL19BlitCopyWithBlitterER14ImageReferenceRKS0_NS_15BlitterRemapAnyE, __ZN5physx18PxcConvexTrianglesC2ERKNS_24PxTriangleMeshGeometryLLERKNS_2Cm23FastVertex2ShapeScalingEPKjjPj: __ZN5physx18PxcConvexTrianglesC2ERKNS_24PxTriangleMeshGeometryLLERKNS_2Cm23FastVertex2ShapeScalingEPKjjPj, __Z43Register_UnityEngine_AudioSource_get_volumev: __Z43Register_UnityEngine_AudioSource_get_volumev, __Z55AnimatorControllerPlayable_CUSTOM_GetLayerCountInternalR9HPlayable: __Z55AnimatorControllerPlayable_CUSTOM_GetLayerCountInternalR9HPlayable, __Z49Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatricesP12Il2CppObjectRK10Matrix4x4fS3_: __Z49Camera_CUSTOM_INTERNAL_CALL_SetStereoViewMatricesP12Il2CppObjectRK10Matrix4x4fS3_, __ZN5physx14PxsAABBManager15deleteAggregateEj: __ZN5physx14PxsAABBManager15deleteAggregateEj, __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_highAngularXLimitv: __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_get_highAngularXLimitv, __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj: __ZN20ArchiveStorageReader17ReinitCachedBlockEPNS_11CachedBlockEj, __Z43ParticleSystem_Get_Custom_PropParticleCountP12Il2CppObject: __Z43ParticleSystem_Get_Custom_PropParticleCountP12Il2CppObject, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv, __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE: __ZN5physx2Sc10NPhaseCore9runFilterERKNS0_10ElementSimES4_PNS0_10FilterPairE, __ZN24OcclusionCullingSettingsC2E10MemLabelId18ObjectCreationMode: __ZN24OcclusionCullingSettingsC2E10MemLabelId18ObjectCreationMode, __Z26scripting_gc_maxgenerationv: __Z26scripting_gc_maxgenerationv, __ZN5physx2Sc17ParticleSystemSim21visualizeInteractionsERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim21visualizeInteractionsERNS_2Cm12RenderOutputE, __ZNK5physx20PxsSolverCoreGeneral13solveV_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj: __ZNK5physx20PxsSolverCoreGeneral13solveV_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj, __Z30CustomEventData_CUSTOM_AddBoolP12Il2CppObjectP12Il2CppStringh: __Z30CustomEventData_CUSTOM_AddBoolP12Il2CppObjectP12Il2CppStringh, __Z21GetContainerArraySizeRK16TypeTreeIteratorPv: __Z21GetContainerArraySizeRK16TypeTreeIteratorPv, __Z39GUI_CUSTOM_INTERNAL_get_backgroundColorP10ColorRGBAf: __Z39GUI_CUSTOM_INTERNAL_get_backgroundColorP10ColorRGBAf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE8pushNameEPKc, __Z20GetPlayerSettingsPtrv: __Z20GetPlayerSettingsPtrv, __ZN10GUIManager28SetDidGUIWindowsEatLastEventEbi: __ZN10GUIManager28SetDidGUIWindowsEatLastEventEbi, __ZNSt3__211__money_getIwEC2Ev: __ZNSt3__211__money_getIwEC2Ev, __ZN5physx3Ext21computeCapsuleDensityEfff: __ZN5physx3Ext21computeCapsuleDensityEfff, _UNITY_FT_Stream_OpenMemory: _UNITY_FT_Stream_OpenMemory, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI8JSONReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI8JSONReadEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN10AtomicList4PeekEv: __ZN10AtomicList4PeekEv, __Z54Register_UnityEngine_WebCamTexture_set_requestedHeightv: __Z54Register_UnityEngine_WebCamTexture_set_requestedHeightv, __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE16__construct_nodeERKNS_4pairIKS2_bEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE16__construct_nodeERKNS_4pairIKS2_bEE, __ZN12CubemapArray7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12CubemapArray7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN16ReflectionProbesC2Ev: __ZN16ReflectionProbesC2Ev, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBFloatEEvPKNS_9InnerInfoE, __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_SetActiveScenev: __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_SetActiveScenev, __Z48Register_UnityEngine_Renderer_set_sortingLayerIDv: __Z48Register_UnityEngine_Renderer_set_sortingLayerIDv, __ZN13GfxDeviceGLES16SetForceCullModeE8CullMode: __ZN13GfxDeviceGLES16SetForceCullModeE8CullMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj430ES3_RKNS_18PxJointLinearLimitES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj430ES3_RKNS_18PxJointLinearLimitES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerIDv: __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetIntegerIDv, __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR11NodeZSorterP16HeightMeshBVNodeEEvT0_S5_T_, _erf: _erf, __ZN6Shader25SetGlobalMaximumShaderLODEi: __ZN6Shader25SetGlobalMaximumShaderLODEi, __ZN5physx2Sn17readAllPropertiesINS_16PxParticleSystemEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_16PxParticleSystemEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __Z47ParticleSystem_MainModule_CUSTOM_SetScalingModeP12Il2CppObject25ParticleSystemScalingMode: __Z47ParticleSystem_MainModule_CUSTOM_SetScalingModeP12Il2CppObject25ParticleSystemScalingMode, __Z31Light_Set_Custom_PropCookieSizeP12Il2CppObjectf: __Z31Light_Set_Custom_PropCookieSizeP12Il2CppObjectf, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv, __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb: __Z21addForceAtPosInternalRN5physx11PxRigidBodyERKNS_6PxVec3ES4_NS_11PxForceMode4EnumEb, __ZN11LightProbes22SetBakedLightOcclusionEPK19LightProbeOcclusioni: __ZN11LightProbes22SetBakedLightOcclusionEPK19LightProbeOcclusioni, __Z29GL_CUSTOM_INTERNAL_CALL_ColorRK10ColorRGBAf: __Z29GL_CUSTOM_INTERNAL_CALL_ColorRK10ColorRGBAf, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z42Register_UnityEngine_GUITexture_set_borderv: __Z42Register_UnityEngine_GUITexture_set_borderv, __ZN19CharacterController24GetEnableOverlapRecoveryEv: __ZN19CharacterController24GetEnableOverlapRecoveryEv, __ZN18AnimatorControllerC2E10MemLabelId18ObjectCreationMode: __ZN18AnimatorControllerC2E10MemLabelId18ObjectCreationMode, __ZN14PhysicsManager17MainThreadCleanupEv: __ZN14PhysicsManager17MainThreadCleanupEv, __ZN5physx6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, ___synccall: ___synccall, __ZNK5physx6shdfnd10Foundation16getErrorCallbackEv: __ZNK5physx6shdfnd10Foundation16getErrorCallbackEv, __ZN12_GLOBAL__N_117MemoryEventClientD2Ev: __ZN12_GLOBAL__N_117MemoryEventClientD2Ev, __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv: __ZN13RuntimeStaticI19UnityConnectServiceE10InitializeEv, __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_: __ZN15SerializeTraitsIKN4math7_float4EE8TransferI18StreamedBinaryReadILb1EEEEvRS2_RT_, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf, _iswdigit: _iswdigit, __ZNK15b2RevoluteJoint17GetReactionTorqueEf: __ZNK15b2RevoluteJoint17GetReactionTorqueEf, __Z18GetIParticleSystemv: __Z18GetIParticleSystemv, __ZNK17GlobalGameManager7GetNameEv: __ZNK17GlobalGameManager7GetNameEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags, __Z33GUIText_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z33GUIText_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __Z44SystemInfo_Get_Custom_PropProcessorFrequencyv: __Z44SystemInfo_Get_Custom_PropProcessorFrequencyv, __Z82Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputInternalv: __Z82Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputInternalv, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E9set_valueEPSC_RKSC_, __ZNKSt3__210moneypunctIcLb1EE10neg_formatEv: __ZNKSt3__210moneypunctIcLb1EE10neg_formatEv, __ZN5physx6shdfnd14atomicExchangeEPVii: __ZN5physx6shdfnd14atomicExchangeEPVii, __ZN26AnimatorControllerPlayable13GetBehavioursEP11Il2CppClass: __ZN26AnimatorControllerPlayable13GetBehavioursEP11Il2CppClass, __ZN11TrailModule16CheckConsistencyEv: __ZN11TrailModule16CheckConsistencyEv, __ZN11UnityEngine9Animation14GenericBinding8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11UnityEngine9Animation14GenericBinding8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sc9ActorCore17setDominanceGroupEh: __ZN5physx2Sc9ActorCore17setDominanceGroupEh, __Z41ReflectionProbe_Get_Custom_PropClearFlagsP12Il2CppObject: __Z41ReflectionProbe_Get_Custom_PropClearFlagsP12Il2CppObject, __ZN9Animation14SampleInternalEv: __ZN9Animation14SampleInternalEv, __ZL18stbir__support_twof: __ZL18stbir__support_twof, __ZN5physx16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE8pushBackEv: __ZN5physx16PxsCCDBlockArrayINS_11PxsCCDShapeELi128EE8pushBackEv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14resetFilteringERNS_3Scb11RigidObjectEPKPNS_7PxShapeEj, __ZN5Unity5JointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity5JointC2E10MemLabelId18ObjectCreationMode, __ZN19CullingGroupManager17CullAndSendEventsERK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK8JobFence: __ZN19CullingGroupManager17CullAndSendEventsERK22SceneCullingParameters4PPtrI6CameraERK13CullingOutputRK8JobFence, __GLOBAL__sub_I_runtime_unityconnect_lump_cpp: __GLOBAL__sub_I_runtime_unityconnect_lump_cpp, __Z39Register_UnityEngine_Animator_SetTargetv: __Z39Register_UnityEngine_Animator_SetTargetv, __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN14SphereColliderD2Ev: __ZN14SphereColliderD2Ev, __ZN14ParticleSystem21SendCollisionMessagesERK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN14ParticleSystem21SendCollisionMessagesERK27ParticleSystemReadOnlyStateR19ParticleSystemState, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_, __Z34Rigidbody2D_Get_Custom_PropInertiaP12Il2CppObject: __Z34Rigidbody2D_Get_Custom_PropInertiaP12Il2CppObject, _getgrouplist: _getgrouplist, __Z14dtAllocNavMeshv: __Z14dtAllocNavMeshv, __ZNK6b2Draw8GetFlagsEv: __ZNK6b2Draw8GetFlagsEv, __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI8BitFieldE8TransferI14SafeBinaryReadEEvRS0_RT_, _sscanf: _sscanf, __ZN17CommonStringTable13StaticCleanupEPv: __ZN17CommonStringTable13StaticCleanupEPv, __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIaaEEPaEEjT0_S5_S5_S5_S5_T_, __ZN16GraphicsSettingsD2Ev: __ZN16GraphicsSettingsD2Ev, __Z46getPxVehicleSuspensionData_RecipMaxCompressionPKN5physx23PxVehicleSuspensionDataE: __Z46getPxVehicleSuspensionData_RecipMaxCompressionPKN5physx23PxVehicleSuspensionDataE, __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi: __Z5SplitRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEcRNS_6vectorIS5_NS3_IS5_EEEEi, __ZN12PhysXRaycastD0Ev: __ZN12PhysXRaycastD0Ev, __ZN9GfxDevice16SynchronizeStatsEv: __ZN9GfxDevice16SynchronizeStatsEv, __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fEiii: __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fEiii, __ZL22DrawParticlesWithPivotILb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL22DrawParticlesWithPivotILb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZNK23LODTreeInstanceRenderer16GetMaterialCountEv: __ZNK23LODTreeInstanceRenderer16GetMaterialCountEv, __Z35Rigidbody2D_Set_Custom_PropBodyTypeP12Il2CppObjectN11Rigidbody2D8BodyTypeE: __Z35Rigidbody2D_Set_Custom_PropBodyTypeP12Il2CppObjectN11Rigidbody2D8BodyTypeE, __ZN14EmissionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14EmissionModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sc27ConstraintProjectionManager23addToPendingTreeUpdatesERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc27ConstraintProjectionManager23addToPendingTreeUpdatesERNS0_19ConstraintGroupNodeE, __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ResetProjectionMatrixv: __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ResetProjectionMatrixv, __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff: __ZN10Matrix3x3f12SetAxisAngleERK8Vector3ff, __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iE: __ZN5Umbra9RasterOps11testRectAnyERKNS_17BlockRasterBufferERKNS_8Vector4iE, __ZN14EdgeCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14EdgeCollider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14ConstantString6assignEPKc10MemLabelId: __ZN14ConstantString6assignEPKc10MemLabelId, __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev: __ZN5physx34PxVehicleDriveSimDataGeneratedInfoC2Ev, __ZL39UnityAudioEffect_InternalCreateCallbackP14FMOD_DSP_STATE: __ZL39UnityAudioEffect_InternalCreateCallbackP14FMOD_DSP_STATE, __ZNK20GpuProgramParameters23PrepareOverridingValuesERK19ShaderPropertySheetR13dynamic_arrayIhLj4EE: __ZNK20GpuProgramParameters23PrepareOverridingValuesERK19ShaderPropertySheetR13dynamic_arrayIhLj4EE, __Z22GetDeveloperConsolePtrv: __Z22GetDeveloperConsolePtrv, __ZN4crnd12crn_unpacker22decode_color_selectorsEv: __ZN4crnd12crn_unpacker22decode_color_selectorsEv, __ZN5physx2Sc18ParticleSystemCore20setMaxMotionDistanceEf: __ZN5physx2Sc18ParticleSystemCore20setMaxMotionDistanceEf, __ZN18LoadSceneOperationD2Ev: __ZN18LoadSceneOperationD2Ev, __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj: __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE8recreateEj, __ZN19CharacterController23VirtualRedirectTransferER14SafeBinaryRead: __ZN19CharacterController23VirtualRedirectTransferER14SafeBinaryRead, __ZN17OverlapBoxQuery2DD2Ev: __ZN17OverlapBoxQuery2DD2Ev, __ZN5physx9NpPhysicsD0Ev: __ZN5physx9NpPhysicsD0Ev, __ZN24iPhoneRemoteNotification8SetErrorEP11objc_object: __ZN24iPhoneRemoteNotification8SetErrorEP11objc_object, __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdatePlayerSendFrameStartedstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN42PostLateUpdatePlayerSendFrameStartedstruct7ForwardEv, __ZN9CGProgram15ThreadedCleanupEv: __ZN9CGProgram15ThreadedCleanupEv, __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CB10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ESF_SF_RfPKj: __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CB10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ESF_SF_RfPKj, __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE8recreateEj, __ZNKSt3__25ctypeIwE8do_widenEc: __ZNKSt3__25ctypeIwE8do_widenEc, __ZN26AnimatorOverrideController10BuildAssetEv: __ZN26AnimatorOverrideController10BuildAssetEv, __ZNK5physx3Scb5Scene17getBroadPhaseTypeEv: __ZNK5physx3Scb5Scene17getBroadPhaseTypeEv, __Z49CommandBuffer_CUSTOM_SetGlobalVectorArrayListImplP12Il2CppObjectiS0_: __Z49CommandBuffer_CUSTOM_SetGlobalVectorArrayListImplP12Il2CppObjectiS0_, __ZN18ShadowMapJobHeaderC2ERK13ShadowJobDataPK15SharedLightDataPK10MinMaxAABB: __ZN18ShadowMapJobHeaderC2ERK13ShadowJobDataPK15SharedLightDataPK10MinMaxAABB, __ZN20UnityConnectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN20UnityConnectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZdaPvj: __ZdaPvj, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_13PxBoxGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_13PxBoxGeometryE, __ZN5physx11PxHitBufferINS_12PxOverlapHitEED0Ev: __ZN5physx11PxHitBufferINS_12PxOverlapHitEED0Ev, __ZN5physx29PxSphericalJointGeneratedInfoC2Ev: __ZN5physx29PxSphericalJointGeneratedInfoC2Ev, __ZNSt3__26stoullERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji: __ZNSt3__26stoullERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji, __Z47ParticleSystem_TrailModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth: __Z47ParticleSystem_TrailModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth, __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERKS1_: __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERKS1_, __ZNK12b2MouseJoint9GetTargetEv: __ZNK12b2MouseJoint9GetTargetEv, __Z38RegisterModuleClasses_CloudWebServicesv: __Z38RegisterModuleClasses_CloudWebServicesv, __Z13RegisterClassI22ParticleSystemRendererEvv: __Z13RegisterClassI22ParticleSystemRendererEvv, __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetRadiusv: __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetRadiusv, __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByPathP12Il2CppStringRi: __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByPathP12Il2CppStringRi, __ZNKSt3__214error_category23default_error_conditionEi: __ZNKSt3__214error_category23default_error_conditionEi, __Z60Register_UnityEngine_ParticleSystem_CollisionModule_SetPlanev: __Z60Register_UnityEngine_ParticleSystem_CollisionModule_SetPlanev, __ZN19TransportJavaScriptC2Ev: __ZN19TransportJavaScriptC2Ev, __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI8Vector4fEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE12readPropertyIfEEbRT_, __ZN24CollectBroadphaseTerrainD0Ev: __ZN24CollectBroadphaseTerrainD0Ev, __ZNK26PlayerSettingsSplashScreen22CanDisableSplashScreenEv: __ZNK26PlayerSettingsSplashScreen22CanDisableSplashScreenEv, __ZNK11LightProbes14LightProbeData12GetNumProbesEv: __ZNK11LightProbes14LightProbeData12GetNumProbesEv, __ZN16GraphicsSettingsC2E10MemLabelId18ObjectCreationMode: __ZN16GraphicsSettingsC2E10MemLabelId18ObjectCreationMode, __ZNK17ArchiveFileSystem9IsSymLinkERK13FileEntryData: __ZNK17ArchiveFileSystem9IsSymLinkERK13FileEntryData, __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx7solve1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK13RendererScene20GetDynamicSceneNodesEv: __ZNK13RendererScene20GetDynamicSceneNodesEv, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_S6_EEEEEEEEvRT_17TransferMetaFlags, __Z47Register_UnityEngine_AI_NavMeshAgent_CopyPathTov: __Z47Register_UnityEngine_AI_NavMeshAgent_CopyPathTov, __Z21SetupOddNegativeScaleR9GfxDeviceb: __Z21SetupOddNegativeScaleR9GfxDeviceb, __ZN12LightManagerD2Ev: __ZN12LightManagerD2Ev, __ZN29AssetBundleLoadAssetOperationC2ER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb: __ZN29AssetBundleLoadAssetOperationC2ER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb, __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameP12Il2CppObjectR15MonoMinMaxCurve: __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetStartFrameP12Il2CppObjectR15MonoMinMaxCurve, __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE: __ZN11UnityEngine9Animation28GenericAnimationBindingCache10BindScriptERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc16ActorElementPairEEEE15growAndPushBackERKS2_, __ZN11AudioSource14SetMaxDistanceEf: __ZN11AudioSource14SetMaxDistanceEf, __ZN17CapsuleCollider2D5ResetEv: __ZN17CapsuleCollider2D5ResetEv, _jinit_upsampler: _jinit_upsampler, __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j: __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j, __ZN5physx2Gu17RadixSortBuffered6ResizeEj: __ZN5physx2Gu17RadixSortBuffered6ResizeEj, __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb: __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb, __ZN5Unity14CharacterJoint8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity14CharacterJoint8TransferI14SafeBinaryReadEEvRT_, __ZN11AssetBundle23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11AssetBundle23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13SplatDatabase20SetBaseMapResolutionEi: __ZN13SplatDatabase20SetBaseMapResolutionEi, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EE: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EE, __Z30GetOcclusionCullingSettingsPtrv: __Z30GetOcclusionCullingSettingsPtrv, __ZN5physx6shdfnd6Socket4readEPhj: __ZN5physx6shdfnd6Socket4readEPhj, __ZN5physx8debugger21PvdNetworkStreamOwner6createERNS_19PxAllocatorCallbackERNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamE: __ZN5physx8debugger21PvdNetworkStreamOwner6createERNS_19PxAllocatorCallbackERNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamE, __Z48GUIClip_CUSTOM_Internal_GetAbsoluteMousePositionP13Vector2fIcall: __Z48GUIClip_CUSTOM_Internal_GetAbsoluteMousePositionP13Vector2fIcall, __Z30MeshFilter_Set_Custom_PropMeshP12Il2CppObjectS0_: __Z30MeshFilter_Set_Custom_PropMeshP12Il2CppObjectS0_, __Z38Compass_Get_Custom_PropMagneticHeadingP12Il2CppObject: __Z38Compass_Get_Custom_PropMagneticHeadingP12Il2CppObject, __ZN11AudioFilter17RemoveFromManagerEv: __ZN11AudioFilter17RemoveFromManagerEv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED2Ev: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED2Ev, __ZN5physx8debugger4comm14AddProfileZone9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm14AddProfileZone9serializeERNS1_15EventSerializerE, __ZN21UnityAnalyticsManagerC2E10MemLabelId18ObjectCreationMode: __ZN21UnityAnalyticsManagerC2E10MemLabelId18ObjectCreationMode, __ZN7mecanim4hand13HandSetupAxesEPKNS0_4HandEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS4_8SkeletonEb: __ZN7mecanim4hand13HandSetupAxesEPKNS0_4HandEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS4_8SkeletonEb, __ZNK11RemoveByPtr16ShouldRemoveClipEP13AnimationClip: __ZNK11RemoveByPtr16ShouldRemoveClipEP13AnimationClip, __ZN6Camera20SetCameraShaderPropsER17ShaderPassContextRK21CameraRenderingParams: __ZN6Camera20SetCameraShaderPropsER17ShaderPassContextRK21CameraRenderingParams, _gray_raster_set_mode: _gray_raster_set_mode, __ZN10BlendShape8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10BlendShape8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx2Sc19ParticlePacketShape18computeWorldBoundsERNS_9PxBounds3E: __ZNK5physx2Sc19ParticlePacketShape18computeWorldBoundsERNS_9PxBounds3E, __ZN5physx2Sc9ClothCore21setCollisionMassScaleEf: __ZN5physx2Sc9ClothCore21setCollisionMassScaleEf, __ZN7mecanim9animation24CreateClipMuscleConstantEPNS0_4ClipERNS_6memory9AllocatorE: __ZN7mecanim9animation24CreateClipMuscleConstantEPNS0_4ClipERNS_6memory9AllocatorE, __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev: __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEED2Ev, __Z40GUIClip_CUSTOM_INTERNAL_CALL_Unclip_RectR5RectTIfE: __Z40GUIClip_CUSTOM_INTERNAL_CALL_Unclip_RectR5RectTIfE, _UNITY_png_gamma_8bit_correct: _UNITY_png_gamma_8bit_correct, __ZN14MemoryProfiler23GetCurrentRootReferenceEv: __ZN14MemoryProfiler23GetCurrentRootReferenceEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_9basic_iosIwS2_EES6_E: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_9basic_iosIwS2_EES6_E, __Z13RegisterClassI6SkyboxEvv: __Z13RegisterClassI6SkyboxEvv, __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_: __ZNSt3__214__split_bufferIN10__cxxabiv112_GLOBAL__N_111string_pairERNS2_11short_allocIS3_Lj4096EEEEC2EjjS6_, __ZN13AnimationClip23VirtualRedirectTransferER14SafeBinaryRead: __ZN13AnimationClip23VirtualRedirectTransferER14SafeBinaryRead, __ZN14b2PolygonShape3SetEPK6b2Vec2i: __ZN14b2PolygonShape3SetEPK6b2Vec2i, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEvPT_jRKT0_RKT1_j, __ZN14SphereCollider8TransferI14SafeBinaryReadEEvRT_: __ZN14SphereCollider8TransferI14SafeBinaryReadEEvRT_, __Z43Physics_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK8Vector3fS1_fS1_fi23QueryTriggerInteraction: __Z43Physics_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK8Vector3fS1_fS1_fi23QueryTriggerInteraction, __Z26getPxCloth_SolverFrequencyPKN5physx7PxClothE: __Z26getPxCloth_SolverFrequencyPKN5physx7PxClothE, __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE16__construct_nodeERKS3_: __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE16__construct_nodeERKS3_, __Z31Light_Get_Custom_PropShadowBiasP12Il2CppObject: __Z31Light_Get_Custom_PropShadowBiasP12Il2CppObject, __ZN5physx3Ext23DefaultBufferedProfilerD0Ev: __ZN5physx3Ext23DefaultBufferedProfilerD0Ev, __ZN13WebCamTexture19GetCameraProjectionEv: __ZN13WebCamTexture19GetCameraProjectionEv, __ZN10TagManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10TagManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeINS_12__value_typeIiiEENS_19__map_value_compareIiS2_NS_4lessIiEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZN5physx28PxClothFabricGeneratedValuesC2EPKNS_13PxClothFabricE: __ZN5physx28PxClothFabricGeneratedValuesC2EPKNS_13PxClothFabricE, __ZL18MonoBehaviourDoGUIPvN13MonoBehaviour13GUILayoutTypeEii: __ZL18MonoBehaviourDoGUIPvN13MonoBehaviour13GUILayoutTypeEii, _UNITY_png_get_y_pixels_per_inch: _UNITY_png_get_y_pixels_per_inch, __ZN12GraphicsCapsD2Ev: __ZN12GraphicsCapsD2Ev, __ZN12WheelJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12WheelJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z24Caching_CUSTOM_AuthorizeP12Il2CppStringS0_xiS0_: __Z24Caching_CUSTOM_AuthorizeP12Il2CppStringS0_xiS0_, __ZN20ExternalForcesModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E: __ZN20ExternalForcesModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E, __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge: __Z21tessMeshAddEdgeVertexP8TESSmeshP12TESShalfEdge, __Z14RuntimeCleanupv: __Z14RuntimeCleanupv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EjwRKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EjwRKS4_, __Z24RegisterStrippedTypeInfoI24EllipsoidParticleEmitterEviPKcS2_: __Z24RegisterStrippedTypeInfoI24EllipsoidParticleEmitterEviPKcS2_, __Z46getNbPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataE: __Z46getNbPxVehicleWheelsDynData_WheelRotationAnglePKN5physx22PxVehicleWheelsDynDataE, __ZNSt3__26vectorINS_4pairI14ConstantStringP11AssetBundleEENS_9allocatorIS5_EEE6insertENS_11__wrap_iterIPKS5_EERSA_: __ZNSt3__26vectorINS_4pairI14ConstantStringP11AssetBundleEENS_9allocatorIS5_EEE6insertENS_11__wrap_iterIPKS5_EERSA_, __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE21__push_back_slow_pathIS6_EEvOT_: __ZNSt3__26vectorINS_4pairIPNS_18condition_variableEPNS_5mutexEEENS_18__hidden_allocatorIS6_EEE21__push_back_slow_pathIS6_EEvOT_, __ZN19CloudServiceHandlerD2Ev: __ZN19CloudServiceHandlerD2Ev, __ZN5Umbra9Matrix4x45identEv: __ZN5Umbra9Matrix4x45identEv, __ZNK11ICallString16GetRawCharBufferEv: __ZNK11ICallString16GetRawCharBufferEv, __ZN8Animator19SetLookAtHeadWeightEf: __ZN8Animator19SetLookAtHeadWeightEf, __Z50Register_UnityEngine_Renderer_set_sortingLayerNamev: __Z50Register_UnityEngine_Renderer_set_sortingLayerNamev, __ZThn4_N12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE: __ZThn4_N12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEE15growAndPushBackERKS6_: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEE15growAndPushBackERKS6_, __ZNK9Texture3D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK9Texture3D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __Z35Canvas_Get_Custom_PropTargetDisplayP12Il2CppObject: __Z35Canvas_Get_Custom_PropTargetDisplayP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj471ES3_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj471ES3_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z37RuntimeUndo_CUSTOM_SetTransformParentP12Il2CppObjectS0_P12Il2CppString: __Z37RuntimeUndo_CUSTOM_SetTransformParentP12Il2CppObjectS0_P12Il2CppString, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator11CullingModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8Animator11CullingModeEEvRT_RT0_PKc17TransferMetaFlags, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE12getClassSizeEv, __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB: __ZNK7b2World9QueryAABBEP15b2QueryCallbackRK6b2AABB, __ZN11HaloManager10DeleteHaloEiP6Object: __ZN11HaloManager10DeleteHaloEiP6Object, __Z18ConvertUTF32toUTF8PKmiPhRi: __Z18ConvertUTF32toUTF8PKmiPhRi, __Z55Register_UnityEngine_ReflectionProbe_set_shadowDistancev: __Z55Register_UnityEngine_ReflectionProbe_set_shadowDistancev, __ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf: __ZN20TextRenderingPrivate19NativeTextGenerator15RegisterNewLineEiiRf, __Z40Register_UnityEngine_TerrainData_HasUserv: __Z40Register_UnityEngine_TerrainData_HasUserv, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXMultiplierv, __ZN5physx7NpScene9lockWriteEPKcj: __ZN5physx7NpScene9lockWriteEPKcj, __Z39AudioReverbFilter_Set_Custom_PropRoomLFP12Il2CppObjectf: __Z39AudioReverbFilter_Set_Custom_PropRoomLFP12Il2CppObjectf, __Z23PlayerSendFrameCompleteb: __Z23PlayerSendFrameCompleteb, __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E: __ZNK5physx2Sc8ShapeSim18computeWorldBoundsERKNS0_9ShapeCoreERKNS0_8RigidSimEPNS_9PxBounds3E, __Z45Register_UnityEngine_GUIStyle_get_fixedHeightv: __Z45Register_UnityEngine_GUIStyle_get_fixedHeightv, __Z48Register_UnityEngine_Material_get_shaderKeywordsv: __Z48Register_UnityEngine_Material_get_shaderKeywordsv, __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, _raccess_guess_linux_netatalk: _raccess_guess_linux_netatalk, __ZN18UnityPropertySheet8TransferI14SafeBinaryReadEEvRT_: __ZN18UnityPropertySheet8TransferI14SafeBinaryReadEEvRT_, __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z39Rigidbody_Set_Custom_PropFreezeRotationP12Il2CppObjecth: __Z39Rigidbody_Set_Custom_PropFreezeRotationP12Il2CppObjecth, __Z59Register_UnityEngine_Profiling_Profiler_get_enableBinaryLogv: __Z59Register_UnityEngine_Profiling_Profiler_get_enableBinaryLogv, __ZN23ManagedAttributeManager12CleanupClassEv: __ZN23ManagedAttributeManager12CleanupClassEv, __ZN11AudioModule23SetProfilerCaptureFlagsEi: __ZN11AudioModule23SetProfilerCaptureFlagsEi, __Z51Register_UnityEngine_Input_get_stylusTouchSupportedv: __Z51Register_UnityEngine_Input_get_stylusTouchSupportedv, __ZN9Behaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Behaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE15getSerializableEv, __ZN22NavMeshProjectSettingsC2ER10MemLabelId18ObjectCreationMode: __ZN22NavMeshProjectSettingsC2ER10MemLabelId18ObjectCreationMode, __Z39Rigidbody_Get_Custom_PropSleepThresholdP12Il2CppObject: __Z39Rigidbody_Get_Custom_PropSleepThresholdP12Il2CppObject, __ZN8Animator18SetFeetPivotActiveEf: __ZN8Animator18SetFeetPivotActiveEf, __ZN18DelayedCallManagerD0Ev: __ZN18DelayedCallManagerD0Ev, __ZN11UmbraModule21BuildMaskShadowCullerERN5Umbra15ShadowCullerExtEPKNS0_10VisibilityEPK22SceneCullingParametersPK8Vector3fSB_i: __ZN11UmbraModule21BuildMaskShadowCullerERN5Umbra15ShadowCullerExtEPKNS0_10VisibilityEPK22SceneCullingParametersPK8Vector3fSB_i, __ZN5physx2Gu3EPA11expandPointEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_: __ZN5physx2Gu3EPA11expandPointEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44UnityWebRequest_Set_Custom_PropUploadHandlerP12Il2CppObjectS0_: __Z44UnityWebRequest_Set_Custom_PropUploadHandlerP12Il2CppObjectS0_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags, __ZNK5physx2Sq16BucketPrunerCore5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE: __ZNK5physx2Sq16BucketPrunerCore5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE, __Z38Renderer_Set_Custom_PropReceiveShadowsP12Il2CppObjecth: __Z38Renderer_Set_Custom_PropReceiveShadowsP12Il2CppObjecth, __Z43Register_UnityEngine_Component_GetComponentv: __Z43Register_UnityEngine_Component_GetComponentv, __ZN6prcoreL12RemapGenericI15TexFormatRGB88815TexFormatRGB565EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB88815TexFormatRGB565EEvPKNS_9InnerInfoE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __ZN5physx3Ext13DistanceJointD2Ev: __ZN5physx3Ext13DistanceJointD2Ev, __ZN9AnimationD0Ev: __ZN9AnimationD0Ev, __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fES4_RKS0_I8Vector2fEiiiPK15TerrainRenderer: __ZNK9Heightmap17FillPatchVerticesERK14StrideIteratorI8Vector3fES4_RKS0_I8Vector2fEiiiPK15TerrainRenderer, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE, __ZN14ManagerContextC2Ev: __ZN14ManagerContextC2Ev, __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz: __ZN9Scripting30RaiseInvalidOperationExceptionEPKcz, __ZN5physx31PxSphereGeometryGeneratedValuesC2EPKNS_16PxSphereGeometryE: __ZN5physx31PxSphereGeometryGeneratedValuesC2EPKNS_16PxSphereGeometryE, __Z37AudioChorusFilter_Get_Custom_PropRateP12Il2CppObject: __Z37AudioChorusFilter_Get_Custom_PropRateP12Il2CppObject, __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRPFbPN2UI6CanvasES3_EPS3_EEjT0_S8_S8_S8_T_, __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNK13b2DynamicTree5QueryI19b2WorldQueryWrapperEEvPT_RK6b2AABB: __ZNK13b2DynamicTree5QueryI19b2WorldQueryWrapperEEvPT_RK6b2AABB, __Z52Transform_CUSTOM_INTERNAL_CALL_InverseTransformPointP12Il2CppObjectRK8Vector3fRS1_: __Z52Transform_CUSTOM_INTERNAL_CALL_InverseTransformPointP12Il2CppObjectRK8Vector3fRS1_, __ZN5Unity5Cloth12AddToManagerEv: __ZN5Unity5Cloth12AddToManagerEv, __ZN15FileSystemEntry6DeleteEb: __ZN15FileSystemEntry6DeleteEb, __Z45InitializeBlendShapeAnimationBindingInterfacev: __Z45InitializeBlendShapeAnimationBindingInterfacev, __ZN11UnityEngine15CloudWebService16SessionContainer21GetJsonArrayDataBlockEjRK8UnityStrS4_RS2_Pj: __ZN11UnityEngine15CloudWebService16SessionContainer21GetJsonArrayDataBlockEjRK8UnityStrS4_RS2_Pj, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3badEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3badEv, ___rem_pio2_large: ___rem_pio2_large, __ZN5physx2Sc5Actor12onDeactivateEv: __ZN5physx2Sc5Actor12onDeactivateEv, __Z51Register_UnityEngine_ShaderVariantCollection_WarmUpv: __Z51Register_UnityEngine_ShaderVariantCollection_WarmUpv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z25Profiler_CUSTOM_EndSamplev: __Z25Profiler_CUSTOM_EndSamplev, __ZNKSt3__25ctypeIwE10do_tolowerEw: __ZNKSt3__25ctypeIwE10do_tolowerEw, __ZNSt3__26locale5__imp7installEPNS0_5facetEl: __ZNSt3__26locale5__imp7installEPNS0_5facetEl, __Z28StateMachineValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object: __Z28StateMachineValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object, __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_: __ZN5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskERKS2_PS4_S6_, __ZN14DetailDatabase8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14DetailDatabase8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK17AnimationCurveTplI11QuaternionfE20EvaluateWithoutCacheEfRS0_: __ZNK17AnimationCurveTplI11QuaternionfE20EvaluateWithoutCacheEfRS0_, __ZN5physx2Gu4BoxV6createERKNS0_8CapsuleVE: __ZN5physx2Gu4BoxV6createERKNS0_8CapsuleVE, __ZN5physx3Cct26CharacterControllerManager11shiftOriginERKNS_6PxVec3E: __ZN5physx3Cct26CharacterControllerManager11shiftOriginERKNS_6PxVec3E, __Z52Register_UnityEngine_AudioReverbFilter_set_diffusionv: __Z52Register_UnityEngine_AudioReverbFilter_set_diffusionv, __Z24SetExecutionRestrictions21ExecutionRestrictions: __Z24SetExecutionRestrictions21ExecutionRestrictions, __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j: __ZNSt3__224__put_character_sequenceIcNS_11char_traitsIcEEEERNS_13basic_ostreamIT_T0_EES7_PKS4_j, _vswscanf: _vswscanf, __ZN13WheelCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13WheelCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNKSt3__210moneypunctIcLb0EE13do_pos_formatEv: __ZNKSt3__210moneypunctIcLb0EE13do_pos_formatEv, __ZN33AssetBundleLoadFromAsyncOperation7PerformEv: __ZN33AssetBundleLoadFromAsyncOperation7PerformEv, __ZN5Flare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Flare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z52Register_UnityEngine_ParticleSystemRenderer_set_meshv: __Z52Register_UnityEngine_ParticleSystemRenderer_set_meshv, __ZN2UI8SubBatch7DestroyEv: __ZN2UI8SubBatch7DestroyEv, __ZN21VRGlobalSettingsState18RestoreGlobalStateEv: __ZN21VRGlobalSettingsState18RestoreGlobalStateEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z42Terrain_Set_Custom_PropDrawTreesAndFoliageP12Il2CppObjecth: __Z42Terrain_Set_Custom_PropDrawTreesAndFoliageP12Il2CppObjecth, __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_: __ZN19ShaderPropertySheet23SetTextureWithPlacementERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_, __ZN5physx2Sc5Scene19initDominanceMatrixEv: __ZN5physx2Sc5Scene19initDominanceMatrixEv, __ZN16ScriptingManager14IsTrustedTokenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN16ScriptingManager14IsTrustedTokenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx13NpClothFabric17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx13NpClothFabric17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx19NpArticulationJoint20setTangentialDampingEf: __ZN5physx19NpArticulationJoint20setTangentialDampingEf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE12readPropertyIfEEbRT_, __Z52Register_UnityEngine_BoxCollider_INTERNAL_get_centerv: __Z52Register_UnityEngine_BoxCollider_INTERNAL_get_centerv, __ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_: __ZNK14dtNavMeshQuery15getPortalPointsEyyPfS0_, __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN4math4trsXEE8TransferI14SafeBinaryReadEEvRS1_RT_, __Z43Register_UnityEngine_CubemapArray_SetPixelsv: __Z43Register_UnityEngine_CubemapArray_SetPixelsv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj: __ZN5physx2Gu33closestPtPointTriangleBaryCentricERKNS_6shdfnd3aos5Vec3VES5_S5_PjRj, __ZNK18ScriptingArguments8GetCountEv: __ZNK18ScriptingArguments8GetCountEv, __Z45Register_UnityEngine_SparseTexture_UpdateTilev: __Z45Register_UnityEngine_SparseTexture_UpdateTilev, __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_, __ZN25SubstanceRawTextureSharedD2Ev: __ZN25SubstanceRawTextureSharedD2Ev, __ZN26PlayerSettingsSplashScreen8TransferI14SafeBinaryReadEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _UNITY_tt_face_load_kern: _UNITY_tt_face_load_kern, __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKciEENS_19__map_value_compareIS3_S4_27compare_tstring_insensitiveIS3_ELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN13TargetJoint2D5ResetEv: __ZN13TargetJoint2D5ResetEv, __ZN5Unity17ConfigurableJoint17SetAngularZMotionEi: __ZN5Unity17ConfigurableJoint17SetAngularZMotionEi, __Z61Register_UnityEngine_ParticleSystem_MainModule_GetPlayOnAwakev: __Z61Register_UnityEngine_ParticleSystem_MainModule_GetPlayOnAwakev, __Z13RegisterClassIN5Unity14CharacterJointEEvv: __Z13RegisterClassIN5Unity14CharacterJointEEvv, __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv: __ZN5physx2Sc15CoreInteraction19removeFromDirtyListEv, __ZN17Physics2DSettings19SetShowColliderAABBEb: __ZN17Physics2DSettings19SetShowColliderAABBEb, __ZN5physx28PxProfileMemoryEventRecorder14createRecorderEPNS_12PxFoundationE: __ZN5physx28PxProfileMemoryEventRecorder14createRecorderEPNS_12PxFoundationE, _Read_CVT_Stretched: _Read_CVT_Stretched, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE8getSceneEv, __ZN5physx16PxsBroadPhaseMBP9addRegionERKNS_18PxBroadPhaseRegionEb: __ZN5physx16PxsBroadPhaseMBP9addRegionERKNS_18PxBroadPhaseRegionEb, __ZN8Animator7GetBoolEiRb: __ZN8Animator7GetBoolEiRb, __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE: __ZN5Unity12PhysicsQuery15RaycastInternalERK3Rayfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxRaycastHitEEE, __ZN13AnimationClip18CleanupMecanimDataEv: __ZN13AnimationClip18CleanupMecanimDataEv, __Z30LoadNamedObjectFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObject: __Z30LoadNamedObjectFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObject, __ZN17ProceduralTexture20UploadWaitingTextureEv: __ZN17ProceduralTexture20UploadWaitingTextureEv, __ZN14ConstantStringaSERKS_: __ZN14ConstantStringaSERKS_, __Z17getPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEj: __Z17getPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEEPPNS_7PxActorEj, __ZN8LODGroup18GetWorldSpaceScaleEv: __ZN8LODGroup18GetWorldSpaceScaleEv, __Z40Register_UnityEngine_Light_set_spotAnglev: __Z40Register_UnityEngine_Light_set_spotAnglev, __ZNKSt3__215__codecvt_utf16IDiLb1EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IDiLb1EE16do_always_noconvEv, __ZN4FMOD7Channel14get3DOcclusionEPfS1_: __ZN4FMOD7Channel14get3DOcclusionEPfS1_, __ZN12_GLOBAL__N_110Connection10disconnectEv: __ZN12_GLOBAL__N_110Connection10disconnectEv, __ZNK19CollisionListener2D16IsTouchingLayersEPK10Collider2Di: __ZNK19CollisionListener2D16IsTouchingLayersEPK10Collider2Di, __ZN19SkinnedMeshRenderer24AnimatorModifiedCallbackEPvS0_i: __ZN19SkinnedMeshRenderer24AnimatorModifiedCallbackEPvS0_i, __ZN15TerrainCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15TerrainCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN10OnGUIStateD2Ev: __ZN10OnGUIStateD2Ev, _UNITY_png_write_rows: _UNITY_png_write_rows, __Z28GetGLSLPropertyNameRemapGLESPKc: __Z28GetGLSLPropertyNameRemapGLESPKc, __ZN15SerializeTraitsI10JointMotorE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI10JointMotorE8TransferI14SafeBinaryReadEEvRS0_RT_, _fprintf: _fprintf, __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh: __ZN5physx2Sc9ActorCoreC2ENS_11PxActorType4EnumEthhh, __Z33VRDevice_Get_Custom_PropIsPresentv: __Z33VRDevice_Get_Custom_PropIsPresentv, __Z31getPxScene_FilterShaderDataSizePKN5physx7PxSceneE: __Z31getPxScene_FilterShaderDataSizePKN5physx7PxSceneE, __Z52Register_UnityEngine_Physics2D_SetLayerCollisionMaskv: __Z52Register_UnityEngine_Physics2D_SetLayerCollisionMaskv, __ZN19VREyeTextureManager30ClearRenderTextureAndSetActiveEP13RenderTexture13GfxClearFlags: __ZN19VREyeTextureManager30ClearRenderTextureAndSetActiveEP13RenderTexture13GfxClearFlags, __ZN23ControllerContactFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE: __ZN23ControllerContactFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE, __ZN5physx49solveDrive4WInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE: __ZN5physx49solveDrive4WInternaDynamicsEnginePlusDrivenWheelsERKNS_19ImplicitSolverInputEPNS_20ImplicitSolverOutputE, __ZN14PlayerSettings22SetAutoRotationAllowedEib: __ZN14PlayerSettings22SetAutoRotationAllowedEib, __Z30getPxRigidBody_AngularVelocityPKN5physx11PxRigidBodyE: __Z30getPxRigidBody_AngularVelocityPKN5physx11PxRigidBodyE, __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21ComputeShaderResource8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK8Material13GetShaderPPtrEv: __ZNK8Material13GetShaderPPtrEv, __Z48SystemInfo_Get_Custom_PropSupportsSparseTexturesv: __Z48SystemInfo_Get_Custom_PropSupportsSparseTexturesv, __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIaaEEPaEEjT0_S5_S5_T_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_, _cff_index_get_name: _cff_index_get_name, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_16ConstantIteratorIS2_EEEEvRT_RKS2_: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_16ConstantIteratorIS2_EEEEvRT_RKS2_, __Z34setPxClothTetherConfigStretchLimitPN5physx19PxClothTetherConfigEf: __Z34setPxClothTetherConfigStretchLimitPN5physx19PxClothTetherConfigEf, __Z51Register_UnityEngine_AI_NavMeshObstacle_set_carvingv: __Z51Register_UnityEngine_AI_NavMeshObstacle_set_carvingv, __Z44NavMeshAgent_CUSTOM_INTERNAL_get_destinationP12Il2CppObjectP8Vector3f: __Z44NavMeshAgent_CUSTOM_INTERNAL_get_destinationP12Il2CppObjectP8Vector3f, _UNITY_FT_Init_Class_tt_cmap13_class_rec: _UNITY_FT_Init_Class_tt_cmap13_class_rec, _UNITY_FT_Stream_GetULong: _UNITY_FT_Stream_GetULong, __Z39Register_UnityEngine_RectOffset_Cleanupv: __Z39Register_UnityEngine_RectOffset_Cleanupv, __ZN13RendererScene14RemoveRendererEi: __ZN13RendererScene14RemoveRendererEi, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZNK13Lz4Compressor7GetTypeEv: __ZNK13Lz4Compressor7GetTypeEv, __ZN5physx2Gu33MultiplePersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj: __ZN5physx2Gu33MultiplePersistentContactManifold9drawPointERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VEfj, __ZN11AudioSource13GetOutputDataEPfii: __ZN11AudioSource13GetOutputDataEPfii, __ZN23ShaderVariantCollection8TransferI17RemapPPtrTransferEEvRT_: __ZN23ShaderVariantCollection8TransferI17RemapPPtrTransferEEvRT_, __ZN8TypeTree8AddChildERK16TypeTreeIterator: __ZN8TypeTree8AddChildERK16TypeTreeIterator, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev, _UNITY_FT_Init_Class_cff_service_get_cmap_info: _UNITY_FT_Init_Class_cff_service_get_cmap_info, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16getInvMassScale0Ev, __ZNK5Umbra15CameraTransform16getCameraToWorldERNS_9Matrix4x4E: __ZNK5Umbra15CameraTransform16getCameraToWorldERNS_9Matrix4x4E, __ZN11b2RopeJoint24SolvePositionConstraintsERK12b2SolverData: __ZN11b2RopeJoint24SolvePositionConstraintsERK12b2SolverData, __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawGUITexturev: __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawGUITexturev, __Z29Cursor_Set_Custom_PropVisibleh: __Z29Cursor_Set_Custom_PropVisibleh, __ZN5Umbra13MatrixFactory10frustumInfEfff: __ZN5Umbra13MatrixFactory10frustumInfEfff, __Z71Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawMeshInstancedv: __Z71Register_UnityEngine_Rendering_CommandBuffer_Internal_DrawMeshInstancedv, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveERS3_: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveERS3_, __Z39SparseTexture_Get_Custom_PropTileHeightP12Il2CppObject: __Z39SparseTexture_Get_Custom_PropTileHeightP12Il2CppObject, _XXH32_createState: _XXH32_createState, __Z44AudioReverbFilter_Get_Custom_PropReverbLevelP12Il2CppObject: __Z44AudioReverbFilter_Get_Custom_PropReverbLevelP12Il2CppObject, __ZN9Scripting34ScriptingWrapperClassForNativeTypeEPKN5Unity4TypeE: __ZN9Scripting34ScriptingWrapperClassForNativeTypeEPKN5Unity4TypeE, __ZN21UnityAnalyticsManager25UnregisterGlobalCallbacksEv: __ZN21UnityAnalyticsManager25UnregisterGlobalCallbacksEv, __ZN23ForwardShaderRenderLoop21RenderLightShadowMapsER16ForwardShadowMapbbR17ShaderPassContext: __ZN23ForwardShaderRenderLoop21RenderLightShadowMapsER16ForwardShadowMapbbR17ShaderPassContext, __ZN23b2ChainAndCircleContactC2EP9b2FixtureiS1_i: __ZN23b2ChainAndCircleContactC2EP9b2FixtureiS1_i, __Z28ScriptingStructArrayToVectorI12SkeletonBone16MonoSkeletonBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_: __Z28ScriptingStructArrayToVectorI12SkeletonBone16MonoSkeletonBoneNSt3__26vectorIS0_NS2_9allocatorIS0_EEEEPFvRKS1_RS0_EEvP11Il2CppArrayRT1_T2_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPKcEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE6createERS4_Rb, __ZN15FrictionJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN15FrictionJoint2DC2E10MemLabelId18ObjectCreationMode, __ZN12_GLOBAL__N_110DataStream15isInstanceValidEPKv: __ZN12_GLOBAL__N_110DataStream15isInstanceValidEPKv, __Z55Register_UnityEngine_SphereCollider_INTERNAL_get_centerv: __Z55Register_UnityEngine_SphereCollider_INTERNAL_get_centerv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj656ENS_22PxRepXPropertyAccessorILj656ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj656ENS_22PxRepXPropertyAccessorILj656ES4_jjEEEEvjRKT0_, __ZN13ScreenManager28RegisterDidSwitchResolutionsEPFvvE: __ZN13ScreenManager28RegisterDidSwitchResolutionsEPFvvE, __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZMultiplierv: __Z77Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetZMultiplierv, __ZN18SharedMaterialDataD2Ev: __ZN18SharedMaterialDataD2Ev, __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc: __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcPK2tmcc, __ZN14TerrainManager23TryGetSplatBaseMaterialEP7Terrain: __ZN14TerrainManager23TryGetSplatBaseMaterialEP7Terrain, _llvm_ctpop_i32: _llvm_ctpop_i32, __ZN9GfxDevice13GetCurrentGPUEv: __ZN9GfxDevice13GetCurrentGPUEv, __ZNK9WWWCached14GetPartialSizeEv: __ZNK9WWWCached14GetPartialSizeEv, __ZNK5Umbra10PortalInfo16getTargetClusterEv: __ZNK5Umbra10PortalInfo16getTargetClusterEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN4FMOD7ReverbIC2EPNS_7SystemIE: __ZN4FMOD7ReverbIC2EPNS_7SystemIE, __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN4Halo23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN4Halo23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx7profile17EventDeserializerILb0EE9streamifyIyEEvPKcRT_: __ZN5physx7profile17EventDeserializerILb0EE9streamifyIyEEvPKcRT_, __ZN11ColorModule5ResetEv: __ZN11ColorModule5ResetEv, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_: __ZL8DrawQuadRK5RectTIfEfP7TextureRK10ColorRGBAfS2_, __ZN29BillboardTreeInstanceRendererC2ER12TreeRendereriib: __ZN29BillboardTreeInstanceRendererC2ER12TreeRendereriib, __ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff: __ZN14EmissionModule12EmitOverTimeER27ParticleSystemEmissionStateRjRK26ParticleSystemEmissionDatafff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj29ENS_22PxRepXPropertyAccessorILj29ENS_11PxRigidBodyEffEEEEvRKT0_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9islandGenEPNS_10PxBaseTaskEEEED0Ev, __Z17TimeToNanosecondsy: __Z17TimeToNanosecondsy, __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9InputAxisC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z41LineRenderer_Get_Custom_PropUseWorldSpaceP12Il2CppObject: __Z41LineRenderer_Get_Custom_PropUseWorldSpaceP12Il2CppObject, __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb1EEEEEvPT_, _zipOpen: _zipOpen, __ZNK5physx2Gu24ShrunkConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVERS4_Ri: __ZNK5physx2Gu24ShrunkConvexHullNoScaleV15supportRelativeERKNS_6shdfnd3aos5Vec3VERKNS3_15PsMatTransformVERS4_Ri, __Z48AnimatorControllerPlayable_CUSTOM_GetFloatStringR9HPlayableP12Il2CppString: __Z48AnimatorControllerPlayable_CUSTOM_GetFloatStringR9HPlayableP12Il2CppString, __ZN19CharacterController10SimpleMoveERK8Vector3f: __ZN19CharacterController10SimpleMoveERK8Vector3f, __Z40TargetJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall: __Z40TargetJoint2D_CUSTOM_INTERNAL_get_targetP12Il2CppObjectP13Vector2fIcall, __ZN5physx15saveHeightFieldERKNS_2Gu11HeightFieldERNS_14PxOutputStreamEb: __ZN5physx15saveHeightFieldERKNS_2Gu11HeightFieldERNS_14PxOutputStreamEb, __ZN14ParticleSystem23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14ParticleSystem23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5Unity17ConfigurableJoint20SetRotationDriveModeEi: __ZN5Unity17ConfigurableJoint20SetRotationDriveModeEi, __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDsc11__mbstate_tEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7codecvtIDsc11__mbstate_tEEEEvRKS1_, __ZN9ShaderLab20SerializedSubProgram14AddBufferParamEPKci: __ZN9ShaderLab20SerializedSubProgram14AddBufferParamEPKci, __Z66Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMousePositionv: __Z66Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMousePositionv, __Z29RegisterVRDeviceStereoDisplayv: __Z29RegisterVRDeviceStereoDisplayv, __Z37Cloth_Get_Custom_PropCapsuleCollidersP12Il2CppObject: __Z37Cloth_Get_Custom_PropCapsuleCollidersP12Il2CppObject, __Z14ComputeMD5HashPKhjPh: __Z14ComputeMD5HashPKhjPh, __ZN5Unity11SpringJointD2Ev: __ZN5Unity11SpringJointD2Ev, __ZN5Umbra15MemOutputStreamD2Ev: __ZN5Umbra15MemOutputStreamD2Ev, __ZN10__cxxabiv112_GLOBAL__N_123parse_binary_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_: __ZN10__cxxabiv112_GLOBAL__N_123parse_binary_expressionINS0_2DbEEEPKcS4_S4_RKNT_6StringERS5_, __Z45PhysicMaterial_Set_Custom_PropFrictionCombineP12Il2CppObjecti: __Z45PhysicMaterial_Set_Custom_PropFrictionCombineP12Il2CppObjecti, __Z31NavMeshAgent_CUSTOM_SetAreaCostP12Il2CppObjectif: __Z31NavMeshAgent_CUSTOM_SetAreaCostP12Il2CppObjectif, __ZN5physx19NpArticulationJoint8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx19NpArticulationJoint8requiresERNS_23PxProcessPxBaseCallbackE, __ZN5physx7NpCloth24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE: __ZN5physx7NpCloth24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE3endEv, __ZN5physx31PxSphericalJointGeneratedValuesC2EPKNS_16PxSphericalJointE: __ZN5physx31PxSphericalJointGeneratedValuesC2EPKNS_16PxSphericalJointE, _jinit_color_deconverter: _jinit_color_deconverter, __Z16TexelCoordToVectiffiPfi: __Z16TexelCoordToVectiffiPfi, __ZN6b2Body19SynchronizeFixturesEv: __ZN6b2Body19SynchronizeFixturesEv, __Z41RegisterAllowNameConversionInDerivedTypesPKcS0_S0_: __Z41RegisterAllowNameConversionInDerivedTypesPKcS0_S0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZL16PresizeOutputJobP25ScheduleSceneNodesJobData: __ZL16PresizeOutputJobP25ScheduleSceneNodesJobData, __ZN23PreloadManagerOperation11SetPriorityEi: __ZN23PreloadManagerOperation11SetPriorityEi, __ZThn8_N12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv: __ZThn8_N12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv, __Z47Register_UnityEngine_RenderTexture_get_isVolumev: __Z47Register_UnityEngine_RenderTexture_get_isVolumev, __ZN11AudioFilter13AwakeFromLoadE17AwakeFromLoadMode: __ZN11AudioFilter13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__25dequeIPN9ShaderLab21SerializedShaderStateENS_9allocatorIS3_EEE19__add_back_capacityEv: __ZNSt3__25dequeIPN9ShaderLab21SerializedShaderStateENS_9allocatorIS3_EEE19__add_back_capacityEv, __ZN5physx19NpArticulationJoint12setDriveTypeENS_28PxArticulationJointDriveType4EnumE: __ZN5physx19NpArticulationJoint12setDriveTypeENS_28PxArticulationJointDriveType4EnumE, __Z35RenderTexture_CUSTOM_GetDepthBufferP12Il2CppObjectP21ScriptingRenderBuffer: __Z35RenderTexture_CUSTOM_GetDepthBufferP12Il2CppObjectP21ScriptingRenderBuffer, __ZN12TreeRenderer11TreeUpdatedEi: __ZN12TreeRenderer11TreeUpdatedEi, __ZN5physx2Sc23ElementActorInteractionD0Ev: __ZN5physx2Sc23ElementActorInteractionD0Ev, __ZN5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEED0Ev, __ZN5physx16NpParticleSystem12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx16NpParticleSystem12createObjectERPhRNS_24PxDeserializationContextE, __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18AudioLowPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNKSt3__212ctype_bynameIwE8do_widenEc: __ZNKSt3__212ctype_bynameIwE8do_widenEc, __ZN4FMOD12ChannelGroup11getUserDataEPPv: __ZN4FMOD12ChannelGroup11getUserDataEPPv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZN18AudioLowPassFilterD2Ev: __ZN18AudioLowPassFilterD2Ev, __ZN17MemoryCacheReader13GetFileLengthEv: __ZN17MemoryCacheReader13GetFileLengthEv, __Z35Light_Get_Custom_PropShadowSoftnessP12Il2CppObject: __Z35Light_Get_Custom_PropShadowSoftnessP12Il2CppObject, __ZNSt3__26__treeIN12ShaderErrors11ShaderErrorENS_4lessIS2_EENS_9allocatorIS2_EEE5eraseENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_PvEEiEE: __ZNSt3__26__treeIN12ShaderErrors11ShaderErrorENS_4lessIS2_EENS_9allocatorIS2_EEE5eraseENS_21__tree_const_iteratorIS2_PNS_11__tree_nodeIS2_PvEEiEE, __Z46get_current_allocation_root_reference_internalv: __Z46get_current_allocation_root_reference_internalv, __ZN14PreloadManager16EndProfilerFrameEi: __ZN14PreloadManager16EndProfilerFrameEi, __ZNK16CircleCollider2D26GetTypeInfoVirtualInternalEv: __ZNK16CircleCollider2D26GetTypeInfoVirtualInternalEv, __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5audio5mixer18AudioMixerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z37getPxScene_MaxNbContactDataBlocksUsedPKN5physx7PxSceneE: __Z37getPxScene_MaxNbContactDataBlocksUsedPKN5physx7PxSceneE, __Z61Register_UnityEngine_QualitySettings_get_anisotropicFilteringv: __Z61Register_UnityEngine_QualitySettings_get_anisotropicFilteringv, _jsimd_can_idct_islow: _jsimd_can_idct_islow, __Z38Register_UnityEngine_Event_get_keyCodev: __Z38Register_UnityEngine_Event_get_keyCodev, __ZNK17ProceduralTexture20GetStorageMemorySizeEv: __ZNK17ProceduralTexture20GetStorageMemorySizeEv, __ZN11UnityEngine9Analytics9PerfEventC2Ev: __ZN11UnityEngine9Analytics9PerfEventC2Ev, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration18addContactsToPatchERKNS_6shdfnd3aos5Vec3VEjj: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration18addContactsToPatchERKNS_6shdfnd3aos5Vec3VEjj, __ZN16LightmapSettings28SetStaticLightmapSceneHandleEi: __ZN16LightmapSettings28SetStaticLightmapSceneHandleEi, __ZN5physx2Sc5Scene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh: __ZN5physx2Sc5Scene26setSimulationEventCallbackEPNS_25PxSimulationEventCallbackEh, __ZN13BaseAllocator17LogAllocationInfoEPKvjPKPvj: __ZN13BaseAllocator17LogAllocationInfoEPKvjPKPvj, __Z29StdTemplateConversionFunctionIsyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsyEbPvR14SafeBinaryRead, __Z44Register_UnityEngine_GUIText_set_lineSpacingv: __Z44Register_UnityEngine_GUIText_set_lineSpacingv, __ZNK19MeshParticleEmitter26GetTypeInfoVirtualInternalEv: __ZNK19MeshParticleEmitter26GetTypeInfoVirtualInternalEv, __Z15CalcPixelMatrixRK5RectTIfER10Matrix4x4f: __Z15CalcPixelMatrixRK5RectTIfER10Matrix4x4f, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE19getConcreteTypeNameEv, __ZN19MeshParticleEmitter15ThreadedCleanupEv: __ZN19MeshParticleEmitter15ThreadedCleanupEv, __Z54Register_UnityEngine_AudioReverbFilter_get_reverbLevelv: __Z54Register_UnityEngine_AudioReverbFilter_get_reverbLevelv, __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_PKc17TransferMetaFlags, __Z44SystemInfo_Get_Custom_PropSupportsInstancingv: __Z44SystemInfo_Get_Custom_PropSupportsInstancingv, __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYMultiplierv: __Z74Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYMultiplierv, __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetUseRandomDistributionv: __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetUseRandomDistributionv, __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN5IMGUI19NamedKeyControlList15GetControlNamedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthXP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_SetStrengthXP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE10deallocateEv: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE10deallocateEv, __ZN18AnimatorController16CheckConsistencyEv: __ZN18AnimatorController16CheckConsistencyEv, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetXMultiplierv, __Z29StdTemplateConversionFunctionIiyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIiyEbPvR14SafeBinaryRead, __ZN5physx2Gu15EdgeListBuilder18CreateFacesToEdgesEjPKjPKt: __ZN5physx2Gu15EdgeListBuilder18CreateFacesToEdgesEjPKjPKt, __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_10moneypunctIcLb1EEEEEvPT_, __Z23GetCoreScriptingClassesv: __Z23GetCoreScriptingClassesv, __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z33Gizmos_CUSTOM_INTERNAL_get_matrixP10Matrix4x4f: __Z33Gizmos_CUSTOM_INTERNAL_get_matrixP10Matrix4x4f, __Z50setPxSimulationStatisticsParticlesGpuMeshCacheUsedPN5physx22PxSimulationStatisticsEj: __Z50setPxSimulationStatisticsParticlesGpuMeshCacheUsedPN5physx22PxSimulationStatisticsEj, __Z35Register_UnityEngine_Event_InitCopyv: __Z35Register_UnityEngine_Event_InitCopyv, __Z11dtAllocTempi: __Z11dtAllocTempi, __ZN5physx13NpClothFabricD0Ev: __ZN5physx13NpClothFabricD0Ev, __ZNK13TranslateGLES10ObjectTypeEN2gl10ObjectTypeE: __ZNK13TranslateGLES10ObjectTypeEN2gl10ObjectTypeE, __ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri: __ZN14SafeBinaryRead18BeginArrayTransferEPKcS1_Ri, __ZN5physx9NpPhysics17createClothFabricERKNS_17PxClothFabricDescE: __ZN5physx9NpPhysics17createClothFabricERKNS_17PxClothFabricDescE, __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z20SetNoShadowsKeywordsR17ShaderPassContext: __Z20SetNoShadowsKeywordsR17ShaderPassContext, __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb: __ZN16ReflectionProbes21AllocateRenderTextureERK15ReflectionProbeb, __ZN16Physics2DManager19AddRigidbodyUpdatesEP11Rigidbody2D: __ZN16Physics2DManager19AddRigidbodyUpdatesEP11Rigidbody2D, __ZN19ClampVelocityModuleD2Ev: __ZN19ClampVelocityModuleD2Ev, __ZN8Collider19SetDisableCollisionEb: __ZN8Collider19SetDisableCollisionEb, __ZN9allocutil14BuddyAllocatorC2E10MemLabelIdjjj: __ZN9allocutil14BuddyAllocatorC2E10MemLabelIdjjj, __ZN5physx2Sn13XmlWriterImpl5writeEPKcS3_: __ZN5physx2Sn13XmlWriterImpl5writeEPKcS3_, __Z24AudioClip_CUSTOM_SetDataP12Il2CppObjectP11Il2CppArrayi: __Z24AudioClip_CUSTOM_SetDataP12Il2CppObjectP11Il2CppArrayi, __ZNK15HeightMeshQuery17GetGeometryHeightERK8Vector3fPf: __ZNK15HeightMeshQuery17GetGeometryHeightERK8Vector3fPf, __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj: __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj, __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E14squash_deletedEv, __ZN5physx6shdfnd10Foundation15destroyInstanceEv: __ZN5physx6shdfnd10Foundation15destroyInstanceEv, __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE: __ZN5physx9NpPhysics23removeMaterialFromTableERNS_10NpMaterialE, __Z39Register_UnityEngine_Cloth_set_frictionv: __Z39Register_UnityEngine_Cloth_set_frictionv, __ZN24OcclusionCullingSettings12CleanupClassEv: __ZN24OcclusionCullingSettings12CleanupClassEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj208ENS_22PxRepXPropertyAccessorILj208ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj208ENS_22PxRepXPropertyAccessorILj208ES4_ffEEEEvRKT0_, __ZN15ConstantForce2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15ConstantForce2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN20LightPropertyBinding14GenerateHashesEv: __ZN20LightPropertyBinding14GenerateHashesEv, __Z55Joint2D_CUSTOM_Joint2D_CUSTOM_INTERNAL_GetReactionForceP12Il2CppObjectfP13Vector2fIcall: __Z55Joint2D_CUSTOM_Joint2D_CUSTOM_INTERNAL_GetReactionForceP12Il2CppObjectfP13Vector2fIcall, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb, __ZN5physx13PxHeightFieldD0Ev: __ZN5physx13PxHeightFieldD0Ev, __ZThn32_N22ParticleSystemRenderer23RendererBecameInvisibleEv: __ZThn32_N22ParticleSystemRenderer23RendererBecameInvisibleEv, __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetColorv: __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_SetColorv, __ZN30ForwardShaderRenderLoopScratchD0Ev: __ZN30ForwardShaderRenderLoopScratchD0Ev, __ZNSt3__26locale2id5__getEv: __ZNSt3__26locale2id5__getEv, __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState: __ZN14ParticleSystem12UpdateBoundsERKS_R23ParticleSystemParticlesR19ParticleSystemState, __ZN15b2RevoluteJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN15b2RevoluteJoint24SolveVelocityConstraintsERK12b2SolverData, __Z43TrailRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti: __Z43TrailRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti, __ZN5physx3Scb5Scene18removeShapeFromPvdERNS0_5ShapeERNS_7PxActorE: __ZN5physx3Scb5Scene18removeShapeFromPvdERNS0_5ShapeERNS_7PxActorE, __Z24RegisterStrippedTypeInfoI10Collider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI10Collider2DEviPKcS2_, __Z34FindRequiredComponentsForComponenti: __Z34FindRequiredComponentsForComponenti, __ZN5Umbra13MatrixFactory7frustumEffffff: __ZN5Umbra13MatrixFactory7frustumEffffff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj566ENS_22PxRepXPropertyAccessorILj566ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj566ENS_22PxRepXPropertyAccessorILj566ES4_ffEEEEvRKT0_, __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf: __ZN16RayRTreeCallbackILi0ELb0EE14processResultsEjPjRf, __ZN11UnityEngine7Connect14RemoteSettings7GetBoolERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb: __ZN11UnityEngine7Connect14RemoteSettings7GetBoolERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb, __ZN31CanvasBatchIntermediateRendererD2Ev: __ZN31CanvasBatchIntermediateRendererD2Ev, __Z63ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossMultiplierP12Il2CppObjectf: __Z63ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossMultiplierP12Il2CppObjectf, __Z48AudioReverbZone_Set_Custom_PropRoomRolloffFactorP12Il2CppObjectf: __Z48AudioReverbZone_Set_Custom_PropRoomRolloffFactorP12Il2CppObjectf, __ZN11UnityEngine15CloudWebService14DataDispatcherC2ERNS0_11IRestClientE: __ZN11UnityEngine15CloudWebService14DataDispatcherC2ERNS0_11IRestClientE, __ZN12_GLOBAL__N_122RevoluteJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_122RevoluteJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEEEEjT_j, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEED0Ev, __ZN8LODGroup23GetLODGroupIndexAndMaskEP8RendererPjS2_: __ZN8LODGroup23GetLODGroupIndexAndMaskEP8RendererPjS2_, __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEbT0_S7_T_, __ZN5physx2Sc17ParticleSystemSimD2Ev: __ZN5physx2Sc17ParticleSystemSimD2Ev, _UNITY_png_deflate_claim: _UNITY_png_deflate_claim, __Z55Register_UnityEngine_QualitySettings_set_shadowDistancev: __Z55Register_UnityEngine_QualitySettings_set_shadowDistancev, __ZNSt3__26__sortIRNS_6__lessImmEEPmEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessImmEEPmEEvT0_S5_T_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer13GroupConstantEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd6SocketD0Ev: __ZN5physx6shdfnd6SocketD0Ev, __ZN4FMOD7SystemI19setStreamBufferSizeEjj: __ZN4FMOD7SystemI19setStreamBufferSizeEjj, __ZN7ApiGLES22BindElementArrayBufferEj: __ZN7ApiGLES22BindElementArrayBufferEj, __ZN5physx7NpScene26setVisualizationCullingBoxERKNS_9PxBounds3E: __ZN5physx7NpScene26setVisualizationCullingBoxERKNS_9PxBounds3E, __ZNK6Skybox11GetMaterialEv: __ZNK6Skybox11GetMaterialEv, __ZN15MBP_PairManagerC2Ev: __ZN15MBP_PairManagerC2Ev, __Z43ParticleSystem_MainModule_CUSTOM_SetPrewarmP12Il2CppObjecth: __Z43ParticleSystem_MainModule_CUSTOM_SetPrewarmP12Il2CppObjecth, __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j: __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j, __Z46UnityWebRequest_Get_Custom_PropDownloadHandlerP12Il2CppObject: __Z46UnityWebRequest_Get_Custom_PropDownloadHandlerP12Il2CppObject, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS3_EE13stl_allocatorINS4_4pairIS3_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags, __ZN5physx11NpAggregate17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx11NpAggregate17resolveReferencesERNS_24PxDeserializationContextE, __ZN9Rigidbody12CleanupClassEv: __ZN9Rigidbody12CleanupClassEv, __Z37GUIStyle_Get_Custom_PropImagePositionP12Il2CppObject: __Z37GUIStyle_Get_Custom_PropImagePositionP12Il2CppObject, __Z32getPxJointLimitParametersDampingPKN5physx22PxJointLimitParametersE: __Z32getPxJointLimitParametersDampingPKN5physx22PxJointLimitParametersE, __ZN14ParticleSystem23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14ParticleSystem23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI17PhysicsMaterial2DE8TransferI14SafeBinaryReadEEvRT_, __ZN12b2WheelJoint4DumpEv: __ZN12b2WheelJoint4DumpEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE15growAndPushBackERKS2_, __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKS2_iEE, __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipERNS_6memory9AllocatorE: __ZN7mecanim9animation16CreateClipMemoryEPKNS0_4ClipERNS_6memory9AllocatorE, __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, _finish_pass_gather: _finish_pass_gather, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj: __ZN5physx2Sq10AABBPruner18setRebuildRateHintEj, __ZN5Umbra17LineSegmentFinder7executeEPNS_19ImpLineSegmentQueryEi: __ZN5Umbra17LineSegmentFinder7executeEPNS_19ImpLineSegmentQueryEi, __ZN12b2MotorJoint19SetCorrectionFactorEf: __ZN12b2MotorJoint19SetCorrectionFactorEf, __Z40Time_Get_Custom_PropRealtimeSinceStartupv: __Z40Time_Get_Custom_PropRealtimeSinceStartupv, __ZN9GfxDevice13AfterDrawCallEv: __ZN9GfxDevice13AfterDrawCallEv, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __ZNSt3__210ostrstreamD1Ev: __ZNSt3__210ostrstreamD1Ev, __ZN7mecanim12statemachine17ConditionConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine17ConditionConstant8TransferI14SafeBinaryReadEEvRT_, __ZN10DynamicVBOD2Ev: __ZN10DynamicVBOD2Ev, __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi: __ZN7mecanim8skeleton25SkeletonGetGlobalRotationEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi, __ZNK5physx2Sq10AABBPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE: __ZNK5physx2Sq10AABBPruner7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE, __Z36SphereCollider_Set_Custom_PropRadiusP12Il2CppObjectf: __Z36SphereCollider_Set_Custom_PropRadiusP12Il2CppObjectf, __ZN5physx18solveConcludeExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx18solveConcludeExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5physx2Sn5ConvX9convert16EPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX9convert16EPKcRKNS0_15PxMetaDataEntryES6_, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN22UnityAnalyticsSettings15SetTestEventUrlE8UnityStr: __ZN22UnityAnalyticsSettings15SetTestEventUrlE8UnityStr, __ZNK5Umbra17ImpTomeCollection9serializeERNS_12OutputStreamE: __ZNK5Umbra17ImpTomeCollection9serializeERNS_12OutputStreamE, __ZN4FMOD6System23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_: __ZN4FMOD6System23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_, __ZThn4_NK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv: __ZThn4_NK5physx5cloth8SwSolver29getInterCollisionNbIterationsEv, __ZNK12NavMeshAgent22GetNextOffMeshLinkDataEP15OffMeshLinkData: __ZNK12NavMeshAgent22GetNextOffMeshLinkDataEP15OffMeshLinkData, __Z19getPxMeshScaleScalePKN5physx11PxMeshScaleE: __Z19getPxMeshScaleScalePKN5physx11PxMeshScaleE, _cff_get_cmap_info: _cff_get_cmap_info, __Z23ConvertCacheToBuildKeysI8Vector3fEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder: __Z23ConvertCacheToBuildKeysI8Vector3fEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor13constructLeftERS3_: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor13constructLeftERS3_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEED0Ev, __ZN5physx2Gu24computeMTD_SphereCapsuleERNS_6PxVec3ERfRKNS0_6SphereERKNS0_7CapsuleE: __ZN5physx2Gu24computeMTD_SphereCapsuleERNS_6PxVec3ERfRKNS0_6SphereERKNS0_7CapsuleE, __ZN5physx2Cm23createFreeListAllocatorERNS_19PxAllocatorCallbackE: __ZN5physx2Cm23createFreeListAllocatorERNS_19PxAllocatorCallbackE, __ZNK14VertexDataInfo14GetStreamIndexE13ShaderChannel: __ZNK14VertexDataInfo14GetStreamIndexE13ShaderChannel, __ZN23b2ChainAndCircleContactD0Ev: __ZN23b2ChainAndCircleContactD0Ev, __ZN9AudioClip21AwakeFromLoadThreadedEv: __ZN9AudioClip21AwakeFromLoadThreadedEv, __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI6ObjectE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK12TLSAllocatorI14StackAllocatorE10GetPtrSizeEPKv: __ZNK12TLSAllocatorI14StackAllocatorE10GetPtrSizeEPKv, __ZNK5physx2Sc8ShapeSim13getFilterInfoERjRNS_12PxFilterDataE: __ZNK5physx2Sc8ShapeSim13getFilterInfoERjRNS_12PxFilterDataE, __Z47Register_UnityEngine_SpringJoint2D_get_distancev: __Z47Register_UnityEngine_SpringJoint2D_get_distancev, __ZN5physx2Gu24computeSphere_CapsuleMTDERKNS0_6SphereERKNS0_7CapsuleERNS_10PxSweepHitE: __ZN5physx2Gu24computeSphere_CapsuleMTDERKNS0_6SphereERKNS0_7CapsuleERNS_10PxSweepHitE, __Z53Register_UnityEngine_AssetBundleRequest_get_allAssetsv: __Z53Register_UnityEngine_AssetBundleRequest_get_allAssetsv, __ZN5physx2Gu22findOverlapCapsuleMeshERKNS0_7CapsuleERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb: __ZN5physx2Gu22findOverlapCapsuleMeshERKNS0_7CapsuleERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb, __Z38TerrainData_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z38TerrainData_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __ZN21BillboardBatchManager13StaticCleanupEPv: __ZN21BillboardBatchManager13StaticCleanupEPv, __ZN11ColorModule8TransferI17RemapPPtrTransferEEvRT_: __ZN11ColorModule8TransferI17RemapPPtrTransferEEvRT_, __ZNK15ReflectionProbe26GetTypeInfoVirtualInternalEv: __ZNK15ReflectionProbe26GetTypeInfoVirtualInternalEv, __ZL27CleanupModule_TextRenderingv: __ZL27CleanupModule_TextRenderingv, __ZN5Umbra15SystemAllocatorD0Ev: __ZN5Umbra15SystemAllocatorD0Ev, __ZN19MeshParticleEmitter18SetupParticleStripER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti: __ZN19MeshParticleEmitter18SetupParticleStripER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti, __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_400kDidModifyMesh4CallEPviR11MessageData: __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_400kDidModifyMesh4CallEPviR11MessageData, __Z53Register_UnityEngine_AudioReverbZone_set_reverbPresetv: __Z53Register_UnityEngine_AudioReverbZone_set_reverbPresetv, __ZNK22BuiltinResourceManager21GetResourceInstanceIDEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE: __ZNK22BuiltinResourceManager21GetResourceInstanceIDEPKN5Unity4TypeERKNSt3__212basic_stringIcNS4_11char_traitsIcEENS4_9allocatorIcEEEE, __ZN21ComputeShaderResource8TransferI14SafeBinaryReadEEvRT_: __ZN21ComputeShaderResource8TransferI14SafeBinaryReadEEvRT_, __ZN6prcore10ClearImageER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE: __ZN6prcore10ClearImageER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE, __ZN23SweepBoxMeshHitCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN23SweepBoxMeshHitCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Playv: __Z53Register_UnityEngine_WebCamTexture_INTERNAL_CALL_Playv, __ZN5physx2Sc5Scene24resizeReleasedBodyIDMapsEjj: __ZN5physx2Sc5Scene24resizeReleasedBodyIDMapsEjj, __Z35AndroidJNI_CUSTOM_SetStaticIntField13Il2Cpp_IntPtrS_i: __Z35AndroidJNI_CUSTOM_SetStaticIntField13Il2Cpp_IntPtrS_i, __ZN21AssetReferenceStorage12AddReferenceEi: __ZN21AssetReferenceStorage12AddReferenceEi, __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedMethod13Il2Cpp_IntPtrS_hRPv: __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedMethod13Il2Cpp_IntPtrS_hRPv, __ZN19ParticleSystemStateC2Ev: __ZN19ParticleSystemStateC2Ev, __ZN3WWW17SetThreadPriorityE14ThreadPriority: __ZN3WWW17SetThreadPriorityE14ThreadPriority, __ZN5physx24PxsParticleSystemBatcher20scheduleCollisionCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE: __ZN5physx24PxsParticleSystemBatcher20scheduleCollisionCpuEPPNS_20PxvParticleSystemSimEjRNS_10PxBaseTaskE, __Z15SHFilterCubeMapP13CImageSurfaceS0_biR17PrecomputeContext: __Z15SHFilterCubeMapP13CImageSurfaceS0_biR17PrecomputeContext, __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_S5_T_, __ZN11ShapeModule16UpdateCachedMeshEv: __ZN11ShapeModule16UpdateCachedMeshEv, __Z39WheelCollider_Get_Custom_PropIsGroundedP12Il2CppObject: __Z39WheelCollider_Get_Custom_PropIsGroundedP12Il2CppObject, __ZNK5physx2Sn8MetaData12getMetaClassEPKc: __ZNK5physx2Sn8MetaData12getMetaClassEPKc, __Z45AudioReverbFilter_Set_Custom_PropDecayHFRatioP12Il2CppObjectf: __Z45AudioReverbFilter_Set_Custom_PropDecayHFRatioP12Il2CppObjectf, __Z36AudioMixer_Set_Custom_PropUpdateModeP12Il2CppObject20AudioMixerUpdateMode: __Z36AudioMixer_Set_Custom_PropUpdateModeP12Il2CppObject20AudioMixerUpdateMode, _UNITY_LZ4_loadDict: _UNITY_LZ4_loadDict, _compress_output_20: _compress_output_20, __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j: __ZNK5physx33PxVehicleAutoBoxDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEEEEEjT_j, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN5physx3Scb5Scene26preSimulateUpdateAppThreadEf: __ZN5physx3Scb5Scene26preSimulateUpdateAppThreadEf, __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEE7executeEv: __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEE7executeEv, __ZN14SphereCollider9SetCenterERK8Vector3f: __ZN14SphereCollider9SetCenterERK8Vector3f, __Z25SetupTerrainPhysicsModulev: __Z25SetupTerrainPhysicsModulev, __ZNK2UI13RectTransform26GetTypeInfoVirtualInternalEv: __ZNK2UI13RectTransform26GetTypeInfoVirtualInternalEv, __Z43Register_UnityEngine_Joint2D_set_breakForcev: __Z43Register_UnityEngine_Joint2D_set_breakForcev, __ZNK17AnimationCurveTplIfE8WrapTimeEf: __ZNK17AnimationCurveTplIfE8WrapTimeEf, __ZN5physx15PxsCCDSweepTaskD0Ev: __ZN5physx15PxsCCDSweepTaskD0Ev, __Z52AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticObjectField13Il2Cpp_IntPtrS_RPv: __Z52AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticObjectField13Il2Cpp_IntPtrS_RPv, __Z53ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_CollisionModule_CUSTOM_GetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve, __Z72Register_UnityEngine_Networking_DownloadHandlerAudioClip_InternalGetDatav: __Z72Register_UnityEngine_Networking_DownloadHandlerAudioClip_InternalGetDatav, __GLOBAL__sub_I_runtime_video_lump_cpp: __GLOBAL__sub_I_runtime_video_lump_cpp, _UNITY_FT_Stream_ReadULongLE: _UNITY_FT_Stream_ReadULongLE, __Z18Transfer_BlittableI9JSONWriteLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21UnityAnalyticsManager17GetUnityAnalyticsEv: __ZN21UnityAnalyticsManager17GetUnityAnalyticsEv, __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_: __ZZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEjEN5Local5_DrawEPKNS0_12AABBTreeNodeES8_S4_, __ZZN19SkinnedMeshRenderer15InitializeClassEvEN31FunctorImpl_789kBecameInvisible4CallEPviR11MessageData: __ZZN19SkinnedMeshRenderer15InitializeClassEvEN31FunctorImpl_789kBecameInvisible4CallEPviR11MessageData, _UNITY_ft_raster1_renderer_class_pic_free: _UNITY_ft_raster1_renderer_class_pic_free, __ZN14RenderSettings30SetDefaultReflectionResolutionEi: __ZN14RenderSettings30SetDefaultReflectionResolutionEi, __ZN15PointEffector2D14SetForceTargetE19EffectorSelection2D: __ZN15PointEffector2D14SetForceTargetE19EffectorSelection2D, __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE: __ZNK17AnimationCurveTplI8Vector3fE13EvaluateClampEfPNS1_5CacheE, __ZNKSt3__217moneypunct_bynameIwLb1EE16do_positive_signEv: __ZNKSt3__217moneypunct_bynameIwLb1EE16do_positive_signEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z20OptimizeIndexBuffersR4Mesh: __Z20OptimizeIndexBuffersR4Mesh, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPKv: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPKv, __ZN7Terrain16SetDefaultValuesEv: __ZN7Terrain16SetDefaultValuesEv, __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14OcclusionScene8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZL22SRGB_GammaToLinear_JobP17ImageSliceJobDataj: __ZL22SRGB_GammaToLinear_JobP17ImageSliceJobDataj, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __ZN27ParticleSystemReadOnlyState8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb: __ZN5physx2Gu19EPALocalPenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb, __ZN14PhysicsManagerD0Ev: __ZN14PhysicsManagerD0Ev, _cf2_hint_isBottom: _cf2_hint_isBottom, __ZN5physx11Adjacencies17AssignNewEdgeCodeEjh: __ZN5physx11Adjacencies17AssignNewEdgeCodeEjh, __ZN9GfxDevice18HandleInvalidStateEv: __ZN9GfxDevice18HandleInvalidStateEv, __ZN20UnityConnectSettings8TransferI14SafeBinaryReadEEvRT_: __ZN20UnityConnectSettings8TransferI14SafeBinaryReadEEvRT_, __ZN5physx6shdfnd5ArrayIbNS0_19ReflectionAllocatorIbEEE15growAndPushBackERKb: __ZN5physx6shdfnd5ArrayIbNS0_19ReflectionAllocatorIbEEE15growAndPushBackERKb, __ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_: __ZNK5physx2Gu15HeightFieldUtil22findClosestPointOnEdgeEjjjjRKNS_6PxVec3ERS2_, __ZN11Tetrahedron8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11Tetrahedron8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE18__construct_at_endIPS2_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES9_S9_j, __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb1EEEEvRT_, _ft_raster1_get_cbox: _ft_raster1_get_cbox, __Z27Sampler_Get_Custom_PropNameP12Il2CppObject: __Z27Sampler_Get_Custom_PropNameP12Il2CppObject, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EEjPKi: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXES3_EEvPKNS0_13SkeletonPoseTIT_EEPNS4_IT0_EEjPKi, __ZN12TreeRenderer24InitializePrototypeInfosEv: __ZN12TreeRenderer24InitializePrototypeInfosEv, __Z13RegisterClassI12AudioManagerEvv: __Z13RegisterClassI12AudioManagerEvv, __ZN10GUITexture10GetTextureEv: __ZN10GUITexture10GetTextureEv, __ZN8Animator17SetLookAtPositionE8Vector3f: __ZN8Animator17SetLookAtPositionE8Vector3f, __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairI4PPtrI6ShaderE8UnityStrEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_, _ft_realloc: _ft_realloc, __ZNK12StatusHelper10IsCompleteEv: __ZNK12StatusHelper10IsCompleteEv, __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim9animation18MotionNeighborListEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_: __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim9animation18MotionNeighborListEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_, __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb: __ZN5physx7NpScene19removeActorInternalERNS_7PxActorEbb, __ZN13TrailRenderer11TrailPointsD2Ev: __ZN13TrailRenderer11TrailPointsD2Ev, __ZN15RelativeJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15RelativeJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN4FMOD7SystemI16setDSPBufferSizeEji: __ZN4FMOD7SystemI16setDSPBufferSizeEji, __Z45Register_UnityEngine_Time_get_smoothDeltaTimev: __Z45Register_UnityEngine_Time_get_smoothDeltaTimev, __Z35Register_UnityEngine_Object_Destroyv: __Z35Register_UnityEngine_Object_Destroyv, __ZN5physx29PxArticulationGeneratedValuesC2EPKNS_14PxArticulationE: __ZN5physx29PxArticulationGeneratedValuesC2EPKNS_14PxArticulationE, __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight: __Z21SetupActiveLocalLightRK27LocalLightCullingParametersRK13ShadowJobDataRK8Vector4fPK5RectTIfEbbfR11ActiveLight, __ZN5physx2Sc5Scene21saveLastCCDTransformsEv: __ZN5physx2Sc5Scene21saveLastCCDTransformsEv, __ZNK10Collider2D16IsTouchingLayersEi: __ZNK10Collider2D16IsTouchingLayersEi, __ZN6Object19IsClassIDDeprecatedEi: __ZN6Object19IsClassIDDeprecatedEi, __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_: __Z18GetImagePixelBlockI10ColorRGBAfEbPKhii13TextureFormatiiiiPT_, __Z52Register_UnityEngine_PolygonCollider2D_set_pathCountv: __Z52Register_UnityEngine_PolygonCollider2D_set_pathCountv, __ZNK11AudioSource24GetCustomSpreadCurveCopyEv: __ZNK11AudioSource24GetCustomSpreadCurveCopyEv, __ZN4Tree18OnWillRenderObjectEv: __ZN4Tree18OnWillRenderObjectEv, __ZNKSt3__210moneypunctIcLb0EE14do_frac_digitsEv: __ZNKSt3__210moneypunctIcLb0EE14do_frac_digitsEv, __Z38ParticleEmitter_Set_Custom_PropMaxSizeP12Il2CppObjectf: __Z38ParticleEmitter_Set_Custom_PropMaxSizeP12Il2CppObjectf, __Z35OcclusionPortal_Get_Custom_PropOpenP12Il2CppObject: __Z35OcclusionPortal_Get_Custom_PropOpenP12Il2CppObject, __Z57Register_UnityEngine_Profiling_Profiler_AddFramesFromFilev: __Z57Register_UnityEngine_Profiling_Profiler_AddFramesFromFilev, __Z31RegisterModuleClasses_Animationv: __Z31RegisterModuleClasses_Animationv, __Z33AudioClip_Get_Custom_PropLoadTypeP12Il2CppObject: __Z33AudioClip_Get_Custom_PropLoadTypeP12Il2CppObject, __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode: __ZN17GlobalGameManagerC2E10MemLabelId18ObjectCreationMode, __Z33GUIStyle_Set_Custom_PropFontStyleP12Il2CppObjecti: __Z33GUIStyle_Set_Custom_PropFontStyleP12Il2CppObjecti, _UNITY_FT_Property_Set: _UNITY_FT_Property_Set, __Z53ParticleSystem_ShapeModule_CUSTOM_GetAlignToDirectionP12Il2CppObject: __Z53ParticleSystem_ShapeModule_CUSTOM_GetAlignToDirectionP12Il2CppObject, __ZN15UniformTFMethodD0Ev: __ZN15UniformTFMethodD0Ev, __Z34AndroidJNI_CUSTOM_CallDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z34AndroidJNI_CUSTOM_CallDoubleMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __Z34getPxSceneDescFilterShaderDataSizePKN5physx11PxSceneDescE: __Z34getPxSceneDescFilterShaderDataSizePKN5physx11PxSceneDescE, __Z50Register_UnityEngine_Rigidbody_get_useConeFrictionv: __Z50Register_UnityEngine_Rigidbody_get_useConeFrictionv, __ZN15AudioReverbZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15AudioReverbZone8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi: __ZN18StreamedBinaryReadILb0EE20TransferTypelessDataEjPvi, _bzero: _bzero, __ZNK16Physics2DManager18GetIgnoreCollisionEP10Collider2DS1_: __ZNK16Physics2DManager18GetIgnoreCollisionEP10Collider2DS1_, _UNITY_png_set_sBIT: _UNITY_png_set_sBIT, __Z57Register_UnityEngine_WebCamTexture_get_videoRotationAnglev: __Z57Register_UnityEngine_WebCamTexture_get_videoRotationAnglev, __ZN5physx8debugger4comm31PvdCommStreamInternalConnection6createERNS_19PxAllocatorCallbackES4_RNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamENS_7PxFlagsINS0_17PvdConnectionType4EnumEjEERNS1_21PvdConnectionListenerERNS_6shdfnd6MutexTINS0_19ForwardingAllocatorEEEb: __ZN5physx8debugger4comm31PvdCommStreamInternalConnection6createERNS_19PxAllocatorCallbackES4_RNS0_19PvdNetworkOutStreamEPNS0_18PvdNetworkInStreamENS_7PxFlagsINS0_17PvdConnectionType4EnumEjEERNS1_21PvdConnectionListenerERNS_6shdfnd6MutexTINS0_19ForwardingAllocatorEEEb, __Z52Register_UnityEngine_MonoBehaviour_StopAllCoroutinesv: __Z52Register_UnityEngine_MonoBehaviour_StopAllCoroutinesv, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj128EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZNSt3__26locale5__imp12install_fromINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __Z46Register_UnityEngine_CrashReport_GetReportDatav: __Z46Register_UnityEngine_CrashReport_GetReportDatav, __Z63Register_UnityEngine_WheelCollider_INTERNAL_set_forwardFrictionv: __Z63Register_UnityEngine_WheelCollider_INTERNAL_set_forwardFrictionv, __ZN15NavMeshObstacle23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15NavMeshObstacle23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZNK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZNK11AudioSource11GetPriorityEv: __ZNK11AudioSource11GetPriorityEv, __ZN11UnityEngine9Animation28GenericAnimationBindingCacheC2Ev: __ZN11UnityEngine9Animation28GenericAnimationBindingCacheC2Ev, __ZN4FMOD7Channel9setVolumeEf: __ZN4FMOD7Channel9setVolumeEf, __ZN20TextRenderingPrivate17TextMeshGeneratorD2Ev: __ZN20TextRenderingPrivate17TextMeshGeneratorD2Ev, __ZN11AudioSource16SetReverbZoneMixEf: __ZN11AudioSource16SetReverbZoneMixEf, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat14TexFormatRHalfEEvPKNS_9InnerInfoE, __Z50Register_UnityEngine_WheelCollider_get_brakeTorquev: __Z50Register_UnityEngine_WheelCollider_get_brakeTorquev, __ZN13UnityProfiler10SetEnabledEb: __ZN13UnityProfiler10SetEnabledEb, __ZN8VRDevice16SetDeviceEnabledEb: __ZN8VRDevice16SetDeviceEnabledEb, __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN8VRDevice22DisableStereoRenderingEb: __ZN8VRDevice22DisableStereoRenderingEb, __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv: __ZN5physx2Sq16BucketPrunerCore13classifyBoxesEv, __Z39Scene_CUSTOM_GetRootGameObjectsInternaliP12Il2CppObject: __Z39Scene_CUSTOM_GetRootGameObjectsInternaliP12Il2CppObject, __Z14SetGyroEnabledib: __Z14SetGyroEnabledib, __ZN13MonoBehaviour31AddBehaviourCallbacksToManagersEv: __ZN13MonoBehaviour31AddBehaviourCallbacksToManagersEv, __ZNK14ParticleSystem13GetStartDelayEv: __ZNK14ParticleSystem13GetStartDelayEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS2_EE13stl_allocatorINS3_4pairIS2_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128iNSt3__24lessIS2_EE13stl_allocatorINS3_4pairIS2_iEEL18MemLabelIdentifier79ELi16EEEEEvRT_17TransferMetaFlags, __ZN10GISettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10GISettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z48ParticleRenderer_Set_Custom_PropUvAnimationXTileP12Il2CppObjecti: __Z48ParticleRenderer_Set_Custom_PropUvAnimationXTileP12Il2CppObjecti, __Z18ConvertUTF8toUTF16PKhiPtRi: __Z18ConvertUTF8toUTF16PKhiPtRi, __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRPFbRK6b2PairS3_EPS1_EEjT0_S8_S8_S8_T_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, __ZNK7b2World14QueryProxyAABBEP20b2QueryProxyCallbackRK6b2AABB: __ZNK7b2World14QueryProxyAABBEP20b2QueryProxyCallbackRK6b2AABB, __Z25GetRenderLoopImageFiltersR10RenderLoop: __Z25GetRenderLoopImageFiltersR10RenderLoop, __Z25Animator_CUSTOM_SetTargetP12Il2CppObjectif: __Z25Animator_CUSTOM_SetTargetP12Il2CppObjectif, __Z25setPxJointLimitConeYAnglePN5physx16PxJointLimitConeEf: __Z25setPxJointLimitConeYAnglePN5physx16PxJointLimitConeEf, __Z20getPxScene_TimestampPKN5physx7PxSceneE: __Z20getPxScene_TimestampPKN5physx7PxSceneE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZN24RingBufferMemoryFileData5WriteEyyPKv: __ZN24RingBufferMemoryFileData5WriteEyyPKv, __ZNSt3__214codecvt_bynameIDic11__mbstate_tED0Ev: __ZNSt3__214codecvt_bynameIDic11__mbstate_tED0Ev, __Z46MaterialPropertyBlock_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray: __Z46MaterialPropertyBlock_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN11CustomArrayC2Em: __ZN11CustomArrayC2Em, __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVES2_S3_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_fb, __Z29HumanTrait_CUSTOM_HasColliderP12Il2CppObjecti: __Z29HumanTrait_CUSTOM_HasColliderP12Il2CppObjecti, __ZN7mecanim9animation11SetIKOnFeetEbRKNS0_14AvatarConstantERKNS0_11AvatarInputERNS0_12AvatarMemoryERNS0_15AvatarWorkspaceERNS0_12AvatarOutputE: __ZN7mecanim9animation11SetIKOnFeetEbRKNS0_14AvatarConstantERKNS0_11AvatarInputERNS0_12AvatarMemoryERNS0_15AvatarWorkspaceERNS0_12AvatarOutputE, __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcijNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE: __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcijNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE, __ZN13AnimationClip15ClipWasModifiedEb: __ZN13AnimationClip15ClipWasModifiedEb, __Z39Register_UnityEngine_GUIStyleState_Initv: __Z39Register_UnityEngine_GUIStyleState_Initv, __ZL19BlendLightProbesJobP19BlendProbesJobInputj: __ZL19BlendLightProbesJobP19BlendProbesJobInputj, __ZL25CullAllPerObjectLightsJobP29CullAllPerObjectLightsJobDataj: __ZL25CullAllPerObjectLightsJobP29CullAllPerObjectLightsJobDataj, __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector3fLj4EEEEvRT_PKc17TransferMetaFlags, __Z40UnityAdsSettings_Set_Custom_PropTestModeh: __Z40UnityAdsSettings_Set_Custom_PropTestModeh, __ZN15dtLocalBoundary10addSegmentEfPKf: __ZN15dtLocalBoundary10addSegmentEfPKf, __ZN11ShapeModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState: __ZN11ShapeModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState, __Z41Rigidbody_CUSTOM_INTERNAL_CALL_SetDensityP12Il2CppObjectf: __Z41Rigidbody_CUSTOM_INTERNAL_CALL_SetDensityP12Il2CppObjectf, __ZNSt3__28messagesIcED2Ev: __ZNSt3__28messagesIcED2Ev, __Z49Register_UnityEngine_CanvasGroup_get_interactablev: __Z49Register_UnityEngine_CanvasGroup_get_interactablev, __ZNK5physx16PxBroadPhaseBase24getNumOutOfBoundsObjectsEv: __ZNK5physx16PxBroadPhaseBase24getNumOutOfBoundsObjectsEv, __ZN13MemoryManager20RegisterDeallocationEPvRK10MemLabelIdPKc: __ZN13MemoryManager20RegisterDeallocationEPvRK10MemLabelIdPKc, __ZN5physx9NpFactory18releaseClothToPoolERNS_7NpClothE: __ZN5physx9NpFactory18releaseClothToPoolERNS_7NpClothE, __ZN15QualitySettings24SetAsyncUploadBufferSizeEi: __ZN15QualitySettings24SetAsyncUploadBufferSizeEi, __ZL21ExecuteRenderQueueJobP29RenderNodeQueuePrepareContextj: __ZL21ExecuteRenderQueueJobP29RenderNodeQueuePrepareContextj, __ZNK8VRDevice25GetCameraStereoSeparationEPK6Camera: __ZNK8VRDevice25GetCameraStereoSeparationEPK6Camera, __ZN5physx11NpAggregate8addActorERNS_7PxActorE: __ZN5physx11NpAggregate8addActorERNS_7PxActorE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj437ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj437ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z37setPxSceneLimitsMaxNbObjectsPerRegionPN5physx13PxSceneLimitsEj: __Z37setPxSceneLimitsMaxNbObjectsPerRegionPN5physx13PxSceneLimitsEj, __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb: __ZN14AnimationState10FireEventsEffbRN5Unity9ComponentEffb, __ZNK8Animator28GetRuntimeAnimatorControllerEv: __ZNK8Animator28GetRuntimeAnimatorControllerEv, __ZN14qsort_internal18QSortSingleJobDataIP15RODataDepthPassi17ROSorterDepthPassE7SortJobEPS4_: __ZN14qsort_internal18QSortSingleJobDataIP15RODataDepthPassi17ROSorterDepthPassE7SortJobEPS4_, __ZN16BaseVideoTexture7SuspendEv: __ZN16BaseVideoTexture7SuspendEv, _UNITY_png_get_io_ptr: _UNITY_png_get_io_ptr, __ZN9GfxDevice20DestroyComputeBufferE15ComputeBufferID: __ZN9GfxDevice20DestroyComputeBufferE15ComputeBufferID, __ZN21AnimationClipPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant: __ZN21AnimationClipPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant, __ZN7Terrain12CleanupClassEv: __ZN7Terrain12CleanupClassEv, __ZN23TransformChangeDispatch20CheckAndClearChangedE27TransformChangeSystemHandle: __ZN23TransformChangeDispatch20CheckAndClearChangedE27TransformChangeSystemHandle, __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix3x3E: __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix3x3E, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject, __Z24RegisterStrippedTypeInfoI17Physics2DSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI17Physics2DSettingsEviPKcS2_, __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_PS3_: __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_PS3_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEE15growAndPushBackERKS2_, __Z37Light_Get_Custom_PropShadowResolutionP12Il2CppObject: __Z37Light_Get_Custom_PropShadowResolutionP12Il2CppObject, __ZN15LODGroupManager20ClearAllForceLODMaskEv: __ZN15LODGroupManager20ClearAllForceLODMaskEv, __ZN22RenderingCommandBuffer19AddIssuePluginEventEPFviEi: __ZN22RenderingCommandBuffer19AddIssuePluginEventEPFviEi, __ZN5physx12NpConstraint22setConstraintFunctionsERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableE: __ZN5physx12NpConstraint22setConstraintFunctionsERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj525ENS_22PxRepXPropertyAccessorILj525ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj525ENS_22PxRepXPropertyAccessorILj525ES4_ffEEEEvRKT0_, __ZN5Umbra8QueryExt16queryLineSegmentEPNS_16LineSegmentQueryEi: __ZN5Umbra8QueryExt16queryLineSegmentEPNS_16LineSegmentQueryEi, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE12getClassSizeEv, __ZN7Striper16ConnectAllStripsER13STRIPERRESULT: __ZN7Striper16ConnectAllStripsER13STRIPERRESULT, __Z47Register_UnityEngine_AndroidJNI_FromDoubleArrayv: __Z47Register_UnityEngine_AndroidJNI_FromDoubleArrayv, __Z36OffMeshLink_Set_Custom_PropActivatedP12Il2CppObjecth: __Z36OffMeshLink_Set_Custom_PropActivatedP12Il2CppObjecth, __Z53ParticleSystem_CollisionModule_CUSTOM_SetMinKillSpeedP12Il2CppObjectf: __Z53ParticleSystem_CollisionModule_CUSTOM_SetMinKillSpeedP12Il2CppObjectf, __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f: __Z21CalculateInbetweenKeyIfE11KeyframeTplIT_ERKS2_S4_f, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags, _unity_z_compress2: _unity_z_compress2, __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB888EEvPKNS_9InnerInfoE, _cproj: _cproj, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE8pushNameEPKc, __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb: __ZN5physx2GuL31fullContactsGenerationBoxConvexERKNS_6PxVec3ERKNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos12PsTransformVESD_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNSA_5Vec3VERKNSA_6FloatVEbb, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE20selfCollideParticlesEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE20selfCollideParticlesEv, __Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP26AnimatorOverrideController25RuntimeAnimatorControllerET_RK4PPtrIT0_E, __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIK12TriangleEdgeiEES2_16TriangleEdgeHashN14dense_hash_mapIS2_iS5_NS0_8equal_toIS2_EENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv, __Z43Register_UnityEngine_Joint2D_get_breakForcev: __Z43Register_UnityEngine_Joint2D_get_breakForcev, __ZN11UnityEngine15PlatformWrapper23GetGraphicsFixedVersionEv: __ZN11UnityEngine15PlatformWrapper23GetGraphicsFixedVersionEv, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZN8LODGroup11SetLODArrayERKNSt3__26vectorINS_3LODENS0_9allocatorIS2_EEEE: __ZN8LODGroup11SetLODArrayERKNSt3__26vectorINS_3LODENS0_9allocatorIS2_EEEE, __ZN13b2PulleyJoint24SolvePositionConstraintsERK12b2SolverData: __ZN13b2PulleyJoint24SolvePositionConstraintsERK12b2SolverData, __Z49Register_UnityEngine_WebCamTexture_get_deviceNamev: __Z49Register_UnityEngine_WebCamTexture_get_deviceNamev, __ZN13AudioListener14OnAddComponentEv: __ZN13AudioListener14OnAddComponentEv, __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2EPKcj: __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2EPKcj, __ZN22RenderingCommandBuffer13ClearCommandsEv: __ZN22RenderingCommandBuffer13ClearCommandsEv, __Z35getPxVehicleDriveSimDataNW_DiffDataPKN5physx23PxVehicleDriveSimDataNWE: __Z35getPxVehicleDriveSimDataNW_DiffDataPKN5physx23PxVehicleDriveSimDataNWE, __ZN14CompressedMesh8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14CompressedMesh8TransferI24GenerateTypeTreeTransferEEvRT_, __Z26GUI_Set_Custom_PropEnabledh: __Z26GUI_Set_Custom_PropEnabledh, __ZN17PolygonCollider2D19ExtractConvexShapesER13dynamic_arrayIP7b2ShapeLj4EERK10Matrix4x4f: __ZN17PolygonCollider2D19ExtractConvexShapesER13dynamic_arrayIP7b2ShapeLj4EERK10Matrix4x4f, __Z44NavMeshObstacle_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f: __Z44NavMeshObstacle_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f, __Z50Register_UnityEngine_RelativeJoint2D_set_maxTorquev: __Z50Register_UnityEngine_RelativeJoint2D_set_maxTorquev, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z32GUIStyle_Set_Custom_PropWordWrapP12Il2CppObjecth: __Z32GUIStyle_Set_Custom_PropWordWrapP12Il2CppObjecth, __Z31WWW_CUSTOM_LoadImageIntoTextureP12Il2CppObjectS0_: __Z31WWW_CUSTOM_LoadImageIntoTextureP12Il2CppObjectS0_, __ZN5physx3Cct13HandleManagerD2Ev: __ZN5physx3Cct13HandleManagerD2Ev, __Z30setPxSceneDescDynamicStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE: __Z30setPxSceneDescDynamicStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE, __ZN18ScriptingArguments9AddUInt64Ey: __ZN18ScriptingArguments9AddUInt64Ey, __Z19setPxShape_GeometryPN5physx7PxShapeERKNS_10PxGeometryE: __Z19setPxShape_GeometryPN5physx7PxShapeERKNS_10PxGeometryE, _setpriority: _setpriority, __Z37getPxScene_DynamicTreeRebuildRateHintPKN5physx7PxSceneE: __Z37getPxScene_DynamicTreeRebuildRateHintPKN5physx7PxSceneE, __Z64Register_UnityEngine_Networking_UnityWebRequest_get_isModifiablev: __Z64Register_UnityEngine_Networking_UnityWebRequest_get_isModifiablev, __ZN13BuildSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13BuildSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z43Register_UnityEngine_SpringJoint_get_damperv: __Z43Register_UnityEngine_SpringJoint_get_damperv, __ZN5physx3Cct10ControllerC2ERKNS_16PxControllerDescEPNS_7PxSceneE: __ZN5physx3Cct10ControllerC2ERKNS_16PxControllerDescEPNS_7PxSceneE, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20TextRenderingPrivate7GUIText8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20TextRenderingPrivate7GUIText8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK16MemoryFileSystem12LockFileDataEPKcPPvPy: __ZNK16MemoryFileSystem12LockFileDataEPKcPPvPy, __ZN16SpriteRenderDataD2Ev: __ZN16SpriteRenderDataD2Ev, __ZN5physx11HullLibraryC2Ev: __ZN5physx11HullLibraryC2Ev, __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_T_, __ZN7Texture7ReleaseEv: __ZN7Texture7ReleaseEv, __ZN14RedirectHelper16SetRedirectLimitEj: __ZN14RedirectHelper16SetRedirectLimitEj, __Z61Register_UnityEngine_TerrainData_INTERNAL_set_wavingGrassTintv: __Z61Register_UnityEngine_TerrainData_INTERNAL_set_wavingGrassTintv, __ZL19HandleDecompressionPKhii13TextureFormatiiii: __ZL19HandleDecompressionPKhii13TextureFormatiiii, __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_: __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_, __ZNSt3__26locale5__imp12install_fromINS_7collateIwEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7collateIwEEEEvRKS1_, ___fmodeflags: ___fmodeflags, __ZN5physx14NpArticulation10createLinkEPNS_18PxArticulationLinkERKNS_11PxTransformE: __ZN5physx14NpArticulation10createLinkEPNS_18PxArticulationLinkERKNS_11PxTransformE, __Z18Transfer_BlittableI14SafeBinaryReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN24AudioScriptBufferManager17GetDSPFilterArrayEjRP11Il2CppArray: __ZN24AudioScriptBufferManager17GetDSPFilterArrayEjRP11Il2CppArray, __ZN5physx3Scb10Constraint9setBodiesEPNS0_11RigidObjectES3_: __ZN5physx3Scb10Constraint9setBodiesEPNS0_11RigidObjectES3_, __Z13RegisterClassI11LightProbesEvv: __Z13RegisterClassI11LightProbesEvv, __ZZN14PhysicsManager15InitializeClassEvEN58EarlyUpdatePhysicsResetInterpolatedTransformPositionstruct7ForwardEv: __ZZN14PhysicsManager15InitializeClassEvEN58EarlyUpdatePhysicsResetInterpolatedTransformPositionstruct7ForwardEv, __ZN24PhysicsUpdateBehaviour2D17RemoveFromManagerEv: __ZN24PhysicsUpdateBehaviour2D17RemoveFromManagerEv, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI10RectOffset13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j, __ZN5Unity12PhysicsQuery21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction, __ZN5physx29PxParticleSystemGeneratedInfoC2Ev: __ZN5physx29PxParticleSystemGeneratedInfoC2Ev, __Z51Camera_Set_Custom_PropClearStencilAfterLightingPassP12Il2CppObjecth: __Z51Camera_Set_Custom_PropClearStencilAfterLightingPassP12Il2CppObjecth, __Z16GetCustomLogFilev: __Z16GetCustomLogFilev, __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j: __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E9copy_fromERKSD_j, __Z54Register_UnityEngine_TrailRenderer_get_widthMultiplierv: __Z54Register_UnityEngine_TrailRenderer_get_widthMultiplierv, _strcoll: _strcoll, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZN12LineRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12LineRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN12SoundManager19CreateSoundInternalEPKcjP22FMOD_CREATESOUNDEXINFOR11SoundHandlejP10SampleClip: __ZN12SoundManager19CreateSoundInternalEPKcjP22FMOD_CREATESOUNDEXINFOR11SoundHandlejP10SampleClip, __ZN15b2CircleContactC2EP9b2FixtureS1_: __ZN15b2CircleContactC2EP9b2FixtureS1_, __Z60Register_UnityEngine_Camera_INTERNAL_get_cameraToWorldMatrixv: __Z60Register_UnityEngine_Camera_INTERNAL_get_cameraToWorldMatrixv, __ZN5physx2Sc18ParticleSystemCore15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc18ParticleSystemCore15exportExtraDataERNS_22PxSerializationContextE, __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15PackedIntVector8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN24RigidbodyMovementState2D19SetAngularMoveStateEf: __ZN24RigidbodyMovementState2D19SetAngularMoveStateEf, __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetVectorv: __Z66Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_GetVectorv, __Z21GetLoadedObjectReasonP6Object: __Z21GetLoadedObjectReasonP6Object, __ZN15NavMeshObstacleD0Ev: __ZN15NavMeshObstacleD0Ev, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_11NpAggregateEEEEEvPT_jRKT0_RKT1_j, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE16__construct_nodeERKNS_4pairIKS8_SB_EE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE16__construct_nodeERKNS_4pairIKS8_SB_EE, __Z11tesedgeSignP10TESSvertexS0_S0_: __Z11tesedgeSignP10TESSvertexS0_S0_, __ZN5Unity5Cloth18ResetConfigurationEv: __ZN5Unity5Cloth18ResetConfigurationEv, __ZN26AnimatorControllerPlayable24ClearFirstEvaluationFlagEv: __ZN26AnimatorControllerPlayable24ClearFirstEvaluationFlagEv, __ZL15SweepCapsuleBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL15SweepCapsuleBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN19RenderBufferManager7CleanupEv: __ZN19RenderBufferManager7CleanupEv, __Z46Register_UnityEngine_TextGenerator_Dispose_cppv: __Z46Register_UnityEngine_TextGenerator_Dispose_cppv, __ZN5physx23PxsBroadPhaseContextSap17performBoxPruningENS_2Gu4AxesE: __ZN5physx23PxsBroadPhaseContextSap17performBoxPruningENS_2Gu4AxesE, __ZNK5physx21PxVehicleDriveDynData7isValidEv: __ZNK5physx21PxVehicleDriveDynData7isValidEv, __ZZN14PhysicsManager15InitializeClassEvEN35FixedUpdatePhysicsFixedUpdatestruct7ForwardEv: __ZZN14PhysicsManager15InitializeClassEvEN35FixedUpdatePhysicsFixedUpdatestruct7ForwardEv, __ZNK5physx5cloth8SwSolver22CpuClothSimulationTask7getNameEv: __ZNK5physx5cloth8SwSolver22CpuClothSimulationTask7getNameEv, __ZN5physx9NpPhysics11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx9NpPhysics11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN5physx32PxTolerancesScaleGeneratedValuesC2EPKNS_17PxTolerancesScaleE: __ZN5physx32PxTolerancesScaleGeneratedValuesC2EPKNS_17PxTolerancesScaleE, __Z56Register_UnityEngine_GUIStyleState_SetBackgroundInternalv: __Z56Register_UnityEngine_GUIStyleState_SetBackgroundInternalv, __ZNK14ParticleSystem18LimitParticleCountEj: __ZNK14ParticleSystem18LimitParticleCountEj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIPKN5Unity4TypeE7Hash128NSt3__24lessIS6_EENS8_9allocatorINS8_4pairIS6_S7_EEEEEEEvRT_17TransferMetaFlags, __Z20CreateShadowMapCachev: __Z20CreateShadowMapCachev, __Z50Register_UnityEngine_Collider2D_get_usedByEffectorv: __Z50Register_UnityEngine_Collider2D_get_usedByEffectorv, __ZNK5physx3Cct13BoxController7getTypeEv: __ZNK5physx3Cct13BoxController7getTypeEv, _UNITY_png_icc_check_tag_table: _UNITY_png_icc_check_tag_table, __ZNK16TypeTreeIterator6FatherEv: __ZNK16TypeTreeIterator6FatherEv, _rand_r: _rand_r, __ZN8Remapper19ClearPreallocateIDsEv: __ZN8Remapper19ClearPreallocateIDsEv, __ZN17PersistentManager29GetAllFileIDsAndTypesFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EERS9_IPKN5Unity4TypeELj4EE: __ZN17PersistentManager29GetAllFileIDsAndTypesFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EERS9_IPKN5Unity4TypeELj4EE, __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI6AvatarE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN13GfxDeviceNull17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace: __ZN13GfxDeviceNull17UploadTextureCubeE9TextureIDPKhiii13TextureFormatij17TextureColorSpace, __ZN5physx7profile15ZoneManagerImpl18flushProfileEventsEv: __ZN5physx7profile15ZoneManagerImpl18flushProfileEventsEv, __ZN14DataBufferGLES6UploadEiiPKv: __ZN14DataBufferGLES6UploadEiiPKv, _lockf: _lockf, __Z21GetQualitySettingsPtrv: __Z21GetQualitySettingsPtrv, __Z40Register_UnityEngine_RectOffset_get_leftv: __Z40Register_UnityEngine_RectOffset_get_leftv, __Z59ParticleSystem_LightsModule_CUSTOM_GetUseRandomDistributionP12Il2CppObject: __Z59ParticleSystem_LightsModule_CUSTOM_GetUseRandomDistributionP12Il2CppObject, __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib: __ZNK10__cxxabiv117__class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEE15indexedPropertyILj530ES4_NS4_4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE, __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE: __Z28GetMatrixArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE, __ZN12SocketStream16InterruptedErrorEv: __ZN12SocketStream16InterruptedErrorEv, __ZNK5Umbra4Tome16getClusterBoundsEiRNS_7Vector3ES2_: __ZNK5Umbra4Tome16getClusterBoundsEiRNS_7Vector3ES2_, __ZN5physx21PxcContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx21PxcContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z49Register_UnityEngine_RelativeJoint2D_set_maxForcev: __Z49Register_UnityEngine_RelativeJoint2D_set_maxForcev, __ZN13MemoryManager22GetTotalReservedMemoryEv: __ZN13MemoryManager22GetTotalReservedMemoryEv, __ZNSt3__211regex_errorC2ENS_15regex_constants10error_typeE: __ZNSt3__211regex_errorC2ENS_15regex_constants10error_typeE, __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab14SerializedPass8TransferI18StreamedBinaryReadILb1EEEEvRT_, _csqrtl: _csqrtl, __ZN7ApiGLES14TextureSamplerEj16TextureDimension17TextureFilterMode15TextureWrapModeifb18ShadowSamplingModeN2gl17TextureSrgbDecodeE: __ZN7ApiGLES14TextureSamplerEj16TextureDimension17TextureFilterMode15TextureWrapModeifb18ShadowSamplingModeN2gl17TextureSrgbDecodeE, __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer16MarkAsDispatchedERK8UnityStr, __ZN22RenderingCommandBufferD0Ev: __ZN22RenderingCommandBufferD0Ev, __ZN37InheritVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN37InheritVelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZThn340_N17BillboardRenderer14OnAssetDeletedEv: __ZThn340_N17BillboardRenderer14OnAssetDeletedEv, __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_10PxBounds3VENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbaseEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5pbaseEv, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZNK17AnimationCurveTplIfE8GetRangeEv: __ZNK17AnimationCurveTplIfE8GetRangeEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_17TransferMetaFlags, __ZN5UmbramlERKNS_9Matrix2x2ES2_: __ZN5UmbramlERKNS_9Matrix2x2ES2_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN5physx23PxsBroadPhaseContextSapD0Ev: __ZN5physx23PxsBroadPhaseContextSapD0Ev, __ZN8VRModule22StartRenderingToDeviceEv: __ZN8VRModule22StartRenderingToDeviceEv, __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7mecanim8skeleton19DestroySkeletonMaskEPNS0_12SkeletonMaskERNS_6memory9AllocatorE: __ZN7mecanim8skeleton19DestroySkeletonMaskEPNS0_12SkeletonMaskERNS_6memory9AllocatorE, __ZNK14UnityWebStream16CanSceneBeLoadedEi: __ZNK14UnityWebStream16CanSceneBeLoadedEi, __ZN15NavMeshSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN15NavMeshSettings23VirtualRedirectTransferER14SafeBinaryRead, __Z41Physics_Get_Custom_PropQueriesHitTriggersv: __Z41Physics_Get_Custom_PropQueriesHitTriggersv, __ZN17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZL31InitializeAudioScriptingClassesv: __ZL31InitializeAudioScriptingClassesv, __ZN9JSONWrite8TransferI4PPtrIN13TextRendering4FontEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI4PPtrIN13TextRendering4FontEEEEvRT_PKc17TransferMetaFlags, __ZThn32_N13TrailRendererD0Ev: __ZThn32_N13TrailRendererD0Ev, __ZN11CustomArray9GetOffsetEv: __ZN11CustomArray9GetOffsetEv, __ZNSt3__215__thread_structC2Ev: __ZNSt3__215__thread_structC2Ev, __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __Z37Material_CUSTOM_GetColorArrayImplListP12Il2CppObjectiS0_: __Z37Material_CUSTOM_GetColorArrayImplListP12Il2CppObjectiS0_, __ZN14MessageHandler27RegisterAllMessagesCallbackEPKN5Unity4TypeEPFvPviR11MessageDataEPFbS4_iS6_E: __ZN14MessageHandler27RegisterAllMessagesCallbackEPKN5Unity4TypeEPFvPviR11MessageDataEPFbS4_iS6_E, __ZNK15LODGroupManager17CalculateLODMasksERK13LODParametersfPhPf: __ZNK15LODGroupManager17CalculateLODMasksERK13LODParametersfPhPf, __Z16MainThreadRunnerPFvPvES_10JobGroupID: __Z16MainThreadRunnerPFvPvES_10JobGroupID, __ZN20ArchiveStorageReader10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy: __ZN20ArchiveStorageReader10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12TreeDatabase7AddTreeERK12TreeInstance: __ZN12TreeDatabase7AddTreeERK12TreeInstance, __ZN30RuntimeInitializeOnLoadManagerD2Ev: __ZN30RuntimeInitializeOnLoadManagerD2Ev, __ZNK13AnimationClip16GetApparentSpeedEv: __ZNK13AnimationClip16GetApparentSpeedEv, __Z51Register_UnityEngine_SpringJoint2D_set_dampingRatiov: __Z51Register_UnityEngine_SpringJoint2D_set_dampingRatiov, __ZN22LocalFileSystemHandlerD0Ev: __ZN22LocalFileSystemHandlerD0Ev, __ZN13WheelCollider15ThreadedCleanupEv: __ZN13WheelCollider15ThreadedCleanupEv, _renameat: _renameat, __ZN12NavMeshAgent8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12NavMeshAgent8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17AnimationCurveTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17AnimationCurveTplI8Vector3fE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx12_GLOBAL__N_120copyStaticPropertiesERNS_12PxRigidActorERKS1_: __ZN5physx12_GLOBAL__N_120copyStaticPropertiesERNS_12PxRigidActorERKS1_, __ZN22RenderingCommandBuffer20AddDrawMeshInstancedEP4MeshiP8MaterialiPK10Matrix4x4fjP19ShaderPropertySheet: __ZN22RenderingCommandBuffer20AddDrawMeshInstancedEP4MeshiP8MaterialiPK10Matrix4x4fjP19ShaderPropertySheet, __ZN25RuntimeAnimatorControllerD0Ev: __ZN25RuntimeAnimatorControllerD0Ev, __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetOutsidev: __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetOutsidev, __ZNK18ProceduralMaterial26GetTypeInfoVirtualInternalEv: __ZNK18ProceduralMaterial26GetTypeInfoVirtualInternalEv, __ZN4FMOD7SystemI15getNetworkProxyEPci: __ZN4FMOD7SystemI15getNetworkProxyEPci, __ZN5Unity11SpringJoint6CreateEv: __ZN5Unity11SpringJoint6CreateEv, __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212system_errorC2EiRKNS_14error_categoryERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__212system_errorC2EiRKNS_14error_categoryERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN11LightProbes23SetRealtimeCoefficientsEPK13dynamic_arrayI20SphericalHarmonicsL2Lj4EE: __ZN11LightProbes23SetRealtimeCoefficientsEPK13dynamic_arrayI20SphericalHarmonicsL2Lj4EE, __Z87Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInternalv: __Z87Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInternalv, __ZN5physx42PxVehicleDifferentialNWDataGeneratedValuesC2EPKNS_27PxVehicleDifferentialNWDataE: __ZN5physx42PxVehicleDifferentialNWDataGeneratedValuesC2EPKNS_27PxVehicleDifferentialNWDataE, __ZN12_GLOBAL__N_16ParserILb0EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE: __ZN12_GLOBAL__N_16ParserILb0EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE, __Z43Register_UnityEngine_Projector_set_materialv: __Z43Register_UnityEngine_Projector_set_materialv, __ZN14PlayerSettings12CleanupClassEv: __ZN14PlayerSettings12CleanupClassEv, __ZN12HandlerChain4LockER13FileEntryData12FileLockMode: __ZN12HandlerChain4LockER13FileEntryData12FileLockMode, __Z30TransferField_LinearCollectionI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI8JSONReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z41RenderTexture_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObject: __Z41RenderTexture_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObject, _raccess_make_file_name: _raccess_make_file_name, __ZN20IntermediateRendererD0Ev: __ZN20IntermediateRendererD0Ev, __ZN5physx7Cooking14cookConvexMeshERKNS_16PxConvexMeshDescERNS_14PxOutputStreamEPNS_25PxConvexMeshCookingResult4EnumE: __ZN5physx7Cooking14cookConvexMeshERKNS_16PxConvexMeshDescERNS_14PxOutputStreamEPNS_25PxConvexMeshCookingResult4EnumE, __Z57Register_UnityEngine_RectTransform_INTERNAL_get_sizeDeltav: __Z57Register_UnityEngine_RectTransform_INTERNAL_get_sizeDeltav, __ZN5physx5cloth8SwSolver22CpuClothSimulationTask11runInternalEv: __ZN5physx5cloth8SwSolver22CpuClothSimulationTask11runInternalEv, __ZN19ScriptingInvocation11SetDefaultsEv: __ZN19ScriptingInvocation11SetDefaultsEv, __ZN5physx2Sn13XmlNodeReader13countChildrenEv: __ZN5physx2Sn13XmlNodeReader13countChildrenEv, _toupper: _toupper, _isFinf: _isFinf, __ZN5physx2Sc9ClothCore24setParticleAccelerationsEPKNS_6PxVec4E: __ZN5physx2Sc9ClothCore24setParticleAccelerationsEPKNS_6PxVec4E, _UNITY_png_read_image: _UNITY_png_read_image, __ZNK8Renderer10GetEnabledEv: __ZNK8Renderer10GetEnabledEv, __Z47ParticleSystem_Set_Custom_PropUseAutoRandomSeedP12Il2CppObjecth: __Z47ParticleSystem_Set_Custom_PropUseAutoRandomSeedP12Il2CppObjecth, _ft_raccess_sort_ref_by_id: _ft_raccess_sort_ref_by_id, __ZNK18AudioLowPassFilter30GetCustomLowpassLevelCurveCopyEv: __ZNK18AudioLowPassFilter30GetCustomLowpassLevelCurveCopyEv, __Z80Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistanceMultiplierv: __Z80Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverDistanceMultiplierv, __ZNK9GfxDevice14GetBufferBytesE14GfxBufferLabel15GfxBufferTarget: __ZNK9GfxDevice14GetBufferBytesE14GfxBufferLabel15GfxBufferTarget, __ZN12NavMeshAgent15SetAccelerationEf: __ZN12NavMeshAgent15SetAccelerationEf, __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE: __ZN5physx2Gu17generatedContactsERNS0_13PolygonalDataES2_RKNS0_15HullPolygonDataES5_PNS0_12SupportLocalES7_RKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVE, __Z24Cubemap_CUSTOM_GetPixelsP12Il2CppObjectii: __Z24Cubemap_CUSTOM_GetPixelsP12Il2CppObjectii, __ZN5physx30solveContactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx30solveContactPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN11SoundHandle8InstanceC2Ev: __ZN11SoundHandle8InstanceC2Ev, __Z45Register_UnityEngine_TerrainData_GetSteepnessv: __Z45Register_UnityEngine_TerrainData_GetSteepnessv, __ZNK14SoundHandleAPI14GetNumChannelsEv: __ZNK14SoundHandleAPI14GetNumChannelsEv, __ZNK12WheelJoint2D13GetJointSpeedEv: __ZNK12WheelJoint2D13GetJointSpeedEv, __ZN21UnityWebStream_Static10ReadStringERPKhS1_PNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN21UnityWebStream_Static10ReadStringERPKhS1_PNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZNK5physx13PxRigidStatic8isKindOfEPKc: __ZNK5physx13PxRigidStatic8isKindOfEPKc, __ZN8Animator24SetupAnimationClipsCacheEv: __ZN8Animator24SetupAnimationClipsCacheEv, __Z44Register_UnityEngine_AnimationState_get_clipv: __Z44Register_UnityEngine_AnimationState_get_clipv, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_20PxConvexMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __Z48GUIStyle_CUSTOM_INTERNAL_set_Internal_clipOffsetP12Il2CppObjectRK13Vector2fIcall: __Z48GUIStyle_CUSTOM_INTERNAL_set_Internal_clipOffsetP12Il2CppObjectRK13Vector2fIcall, __ZL19UnityDetourFreeTempPv: __ZL19UnityDetourFreeTempPv, __Z48Register_UnityEngine_AndroidJNI_CallStringMethodv: __Z48Register_UnityEngine_AndroidJNI_CallStringMethodv, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler12ProfileEventENS0_19ReflectionAllocatorIS4_EEE4copyIS6_EEvRKNS1_IS4_T_EE, __ZNK20LightPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK20LightPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZNK13WheelCollider12GetRigidbodyEv: __ZNK13WheelCollider12GetRigidbodyEv, __Z11KeyToStringi: __Z11KeyToStringi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj208ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxTolerancesScaleEEEEclILj208ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx35solveConcludeContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx35solveConcludeContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK5physx7NpCloth25getVirtualParticleWeightsEPNS_6PxVec3E: __ZNK5physx7NpCloth25getVirtualParticleWeightsEPNS_6PxVec3E, __ZNK14RenderSettings20GetDefaultSpotCookieEv: __ZNK14RenderSettings20GetDefaultSpotCookieEv, __ZN8Material15ClearPropertiesEv: __ZN8Material15ClearPropertiesEv, __ZN5physx3Cct13BoxController20updateKinematicProxyEv: __ZN5physx3Cct13BoxController20updateKinematicProxyEv, _UNITY_png_set_gAMA_fixed: _UNITY_png_set_gAMA_fixed, __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI8MaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Unity14CharacterJoint18SetProjectionAngleEf: __ZN5Unity14CharacterJoint18SetProjectionAngleEf, __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb: __Z28GetVectorArrayShaderPropertyPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb, _PxInitVehicleSDK: _PxInitVehicleSDK, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEjw, __ZL21LibpngReadWarningFuncP14png_struct_defPKc: __ZL21LibpngReadWarningFuncP14png_struct_defPKc, __Z35Rigidbody2D_Get_Custom_PropRotationP12Il2CppObject: __Z35Rigidbody2D_Get_Custom_PropRotationP12Il2CppObject, __ZN8Animator22SupportsOnAnimatorMoveEv: __ZN8Animator22SupportsOnAnimatorMoveEv, __Z25Caching_CUSTOM_CleanCachev: __Z25Caching_CUSTOM_CleanCachev, __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb: __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEfPKNS_6PxVec3Eb, __Z24RegisterStrippedTypeInfoI9AnimationEviPKcS2_: __Z24RegisterStrippedTypeInfoI9AnimationEviPKcS2_, __ZN17PersistentManager29RegisterInOrderDeleteCallbackEPFvRKNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEbE: __ZN17PersistentManager29RegisterInOrderDeleteCallbackEPFvRKNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEbE, __ZN4FMOD7SystemI19getSoftwareChannelsEPi: __ZN4FMOD7SystemI19getSoftwareChannelsEPi, __ZNK14PhysicMaterial26GetTypeInfoVirtualInternalEv: __ZNK14PhysicMaterial26GetTypeInfoVirtualInternalEv, __ZN5Umbra20RuntimeStructBuilderD2Ev: __ZN5Umbra20RuntimeStructBuilderD2Ev, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlEEENS_19__map_value_compareIS7_SA_NS_4lessIS7_EELb1EEENS5_ISA_EEE4findIS7_EENS_15__tree_iteratorISA_PNS_11__tree_nodeISA_PvEEiEERKT_, __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE: __ZN5physxL25generatedTriangleContactsERKNS_2Gu9TriangleVEjhRKNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE, __Z57ThreadAndSerializationSafeCheckIsRecursiveTransferAllowedv: __Z57ThreadAndSerializationSafeCheckIsRecursiveTransferAllowedv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj156ES3_RKNS_19PxClothTetherConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj156ES3_RKNS_19PxClothTetherConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__212ctype_bynameIwED2Ev: __ZNSt3__212ctype_bynameIwED2Ev, __ZN21AssetBundleFileSystem23MountToGlobalFileSystemEv: __ZN21AssetBundleFileSystem23MountToGlobalFileSystemEv, __ZN17BillboardRenderer15OnBoundsChangedEv: __ZN17BillboardRenderer15OnBoundsChangedEv, __Z18GetApplicationPathv: __Z18GetApplicationPathv, __Z15SetIApplicationP12IApplication: __Z15SetIApplicationP12IApplication, __Z41Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxRK13Vector2fIcallS1_fiff: __Z41Physics2D_CUSTOM_INTERNAL_CALL_OverlapBoxRK13Vector2fIcallS1_fiff, __Z39Physics2D_Get_Custom_PropBaumgarteScalev: __Z39Physics2D_Get_Custom_PropBaumgarteScalev, __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv: __ZN5physx14PxsAABBManager21freeDestroyedOverlapsEv, __ZNK14ParticleSystem14GetScalingModeEv: __ZNK14ParticleSystem14GetScalingModeEv, __Z16jpeg_memory_destP20jpeg_compress_structPhiPiPvPFvS3_S3_iE: __Z16jpeg_memory_destP20jpeg_compress_structPhiPiPvPFvS3_S3_iE, __Z23scripting_gchandle_freej: __Z23scripting_gchandle_freej, __Z55Register_UnityEngine_AI_NavMeshAgent_get_updateRotationv: __Z55Register_UnityEngine_AI_NavMeshAgent_get_updateRotationv, __ZN13SubstanceData19AreMaterialsLoadingEv: __ZN13SubstanceData19AreMaterialsLoadingEv, __ZN7mecanim5human12RetargetFromEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_SD_PKNS6_7_float3E: __ZN7mecanim5human12RetargetFromEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_SD_PKNS6_7_float3E, __Z37AudioReverbZone_Get_Custom_PropReverbP12Il2CppObject: __Z37AudioReverbZone_Get_Custom_PropReverbP12Il2CppObject, __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb: __ZN16MemoryFileSystem16FindNodeOrCreateEPKcb, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEED0Ev, __ZNK23iPhoneLocalNotification19GetAlertLaunchImageEv: __ZNK23iPhoneLocalNotification19GetAlertLaunchImageEv, _isalpha_l: _isalpha_l, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags, __ZN5physx2Sc9ClothCore21setLinearInertiaScaleENS_6PxVec3E: __ZN5physx2Sc9ClothCore21setLinearInertiaScaleENS_6PxVec3E, __ZN10MeshFilter13GetSharedMeshEv: __ZN10MeshFilter13GetSharedMeshEv, __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesERKNS0_14IterationStateIS2_EE: __ZN5physx5cloth11SwCollisionI8Scalar4fE15collideConvexesERKNS0_14IterationStateIS2_EE, __ZN9Heightmap13CreatePhysicsEv: __ZN9Heightmap13CreatePhysicsEv, __ZN9ShaderLab14TopParserStateEv: __ZN9ShaderLab14TopParserStateEv, __Z29TextureColorSpaceToColorSpace17TextureColorSpace: __Z29TextureColorSpaceToColorSpace17TextureColorSpace, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __ZN5physx2Sc5Scene20fireCallBacksPreSyncEv: __ZN5physx2Sc5Scene20fireCallBacksPreSyncEv, __Z11StringToIntPKc: __Z11StringToIntPKc, __ZN10builtintex23GenerateBuiltinTexturesEv: __ZN10builtintex23GenerateBuiltinTexturesEv, _wms_close: _wms_close, __ZN15FrictionJoint2D12SetMaxTorqueEf: __ZN15FrictionJoint2D12SetMaxTorqueEf, __ZN9Scripting28CreateEngineScriptableObjectEP12Il2CppObject: __ZN9Scripting28CreateEngineScriptableObjectEP12Il2CppObject, __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD0Ev: __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD0Ev, __ZNSt3__227__insertion_sort_incompleteIR12GCHandleLessPNS_4pairIyiEEEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR12GCHandleLessPNS_4pairIyiEEEEbT0_S6_T_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIjjEES3_EEPS3_EEbT0_S7_T_, __Z29CleanupParticlesFromNodeQueueR15RenderNodeQueuej: __Z29CleanupParticlesFromNodeQueueR15RenderNodeQueuej, __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE: __ZN5physx2Gu15getScaledConvexERPNS_6PxVec3ERPhS2_S4_bPKS1_PKhjRKNS_2Cm23FastVertex2ShapeScalingE, __ZNKSt3__27collateIcE9transformEPKcS3_: __ZNKSt3__27collateIcE9transformEPKcS3_, __ZN5physx7NpActor17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx7NpActor17getBinaryMetaDataERNS_14PxOutputStreamE, __Z18ClearByDrawingQuadjRK10ColorRGBAffjR17ShaderPassContext: __Z18ClearByDrawingQuadjRK10ColorRGBAffjR17ShaderPassContext, __ZNK8VRDevice16GetDroppedFramesEv: __ZNK8VRDevice16GetDroppedFramesEv, __ZNKSt3__28messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE: __ZNKSt3__28messagesIwE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE, _UNITY_png_init_read_transformations: _UNITY_png_init_read_transformations, _emit_sof: _emit_sof, __ZN9SubModuleD0Ev: __ZN9SubModuleD0Ev, __ZNK5physx2Sc5Scene15getCCDMaxPassesEv: __ZNK5physx2Sc5Scene15getCCDMaxPassesEv, __Z33Renderer_Get_Custom_PropMaterialsP12Il2CppObject: __Z33Renderer_Get_Custom_PropMaterialsP12Il2CppObject, __ZN11LightProbes15InitializeClassEv: __ZN11LightProbes15InitializeClassEv, __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj: __ZN5physx2SnL29setMissingPropertiesToDefaultERNS0_14RepXCollectionERNS_15XmlReaderWriterEPKNS0_16RepXDefaultEntryEj, __ZNSt3__26thread6detachEv: __ZNSt3__26thread6detachEv, __ZN5physx17PxcNpMemBlockPool13setBlockCountEj: __ZN5physx17PxcNpMemBlockPool13setBlockCountEj, __Z54Register_UnityEngine_ReflectionProbe_get_boxProjectionv: __Z54Register_UnityEngine_ReflectionProbe_get_boxProjectionv, __ZN5physx9NpPhysics9lockSceneEv: __ZN5physx9NpPhysics9lockSceneEv, __ZNK5physx5cloth8SwSolver8hasErrorEv: __ZNK5physx5cloth8SwSolver8hasErrorEv, __ZN12HandlerChain18IsAbsoluteFilePathEPKc: __ZN12HandlerChain18IsAbsoluteFilePathEPKc, __Z50Mesh_CUSTOM_INTERNAL_CALL_GetNativeVertexBufferPtrP12Il2CppObjectiRPv: __Z50Mesh_CUSTOM_INTERNAL_CALL_GetNativeVertexBufferPtrP12Il2CppObjectiRPv, __ZN4PPtrI18AudioMixerSnapshotE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI18AudioMixerSnapshotE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK17ArchiveFileSystem6TargetERK13FileEntryDataR15FileSystemEntry: __ZNK17ArchiveFileSystem6TargetERK13FileEntryDataR15FileSystemEntry, __ZN9Heightmap12SetThicknessEf: __ZN9Heightmap12SetThicknessEf, __Z60Register_UnityEngine_ParticleRenderer_set_particleRenderModev: __Z60Register_UnityEngine_ParticleRenderer_set_particleRenderModev, __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali: __ZNK21BuiltinShaderSettings22CreateMaterialIfNeededEPP8Materiali, __Z54ConfigurableJoint_CUSTOM_INTERNAL_get_lowAngularXLimitP12Il2CppObjectP14SoftJointLimit: __Z54ConfigurableJoint_CUSTOM_INTERNAL_get_lowAngularXLimitP12Il2CppObjectP14SoftJointLimit, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpExNS_8ios_base7seekdirE: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpExNS_8ios_base7seekdirE, __ZN2UI6Canvas30SendIgnoreNextTransformChangedEv: __ZN2UI6Canvas30SendIgnoreNextTransformChangedEv, __ZN19SharedRendererSceneC2ERK10MemLabelId: __ZN19SharedRendererSceneC2ERK10MemLabelId, __ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij: __ZN5Umbra20RuntimeTomeGenerator17constructTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEE11ConstructorERKNS_4AABBEPiij, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxCapsuleGeometryEE12readPropertyIfEEbRT_, __ZNK23ShaderVariantCollection15GetVariantCountEv: __ZNK23ShaderVariantCollection15GetVariantCountEv, __ZN7mecanim6memory16InPlaceAllocator10DeallocateEPv: __ZN7mecanim6memory16InPlaceAllocator10DeallocateEPv, _UNITY_FT_Create_Class_sfnt_module_class: _UNITY_FT_Create_Class_sfnt_module_class, __ZN17AnimationCurveTplI11QuaternionfE6AssignEPK11KeyframeTplIS0_ES5_: __ZN17AnimationCurveTplI11QuaternionfE6AssignEPK11KeyframeTplIS0_ES5_, __ZNK14SphereCollider15GetScaledRadiusERK8Vector3f: __ZNK14SphereCollider15GetScaledRadiusERK8Vector3f, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE20getExternalReferenceERj, __Z27Avatar_CUSTOM_GetAxisLengthP12Il2CppObjecti: __Z27Avatar_CUSTOM_GetAxisLengthP12Il2CppObjecti, __Z31getPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveEj: __Z31getPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveEj, __Z40GameObject_CUSTOM_FindGameObjectsWithTagP12Il2CppString: __Z40GameObject_CUSTOM_FindGameObjectsWithTagP12Il2CppString, __ZN5physx6shdfnd4swapINS_5cloth11SwCollisionI8Scalar4fE13CollisionDataEEEvRT_S8_: __ZN5physx6shdfnd4swapINS_5cloth11SwCollisionI8Scalar4fE13CollisionDataEEEvRT_S8_, __ZN11TerrainData23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11TerrainData23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN6Camera21ResetProjectionMatrixEv: __ZN6Camera21ResetProjectionMatrixEv, __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material: __ZN22RenderingCommandBuffer36AcquireAndRegisterSharedMaterialDataEP8Material, __ZN17AudioChorusFilter16CheckConsistencyEv: __ZN17AudioChorusFilter16CheckConsistencyEv, __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmPKcSC_: __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmPKcSC_, __Z30CreateBoxedObjectFromPrimitiveb: __Z30CreateBoxedObjectFromPrimitiveb, __ZN11UnityEngine15CloudWebService18RestFileDownloader7OnAbortEv: __ZN11UnityEngine15CloudWebService18RestFileDownloader7OnAbortEv, _UNITY_png_set_cHRM_fixed: _UNITY_png_set_cHRM_fixed, __Z48Register_UnityEngine_RenderTexture_get_isCubemapv: __Z48Register_UnityEngine_RenderTexture_get_isCubemapv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z45ParticleSystem_Get_Custom_PropGravityModifierP12Il2CppObject: __Z45ParticleSystem_Get_Custom_PropGravityModifierP12Il2CppObject, __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE8__appendEj, __Z51Register_UnityEngine_ReflectionProbe_get_resolutionv: __Z51Register_UnityEngine_ReflectionProbe_get_resolutionv, __ZNK5physx14NpRigidDynamic25getStabilizationThresholdEv: __ZNK5physx14NpRigidDynamic25getStabilizationThresholdEv, __ZNK18AudioLowPassFilter26GetCustomLowpassLevelCurveEv: __ZNK18AudioLowPassFilter26GetCustomLowpassLevelCurveEv, __ZN22ScAfterIntegrationTaskD0Ev: __ZN22ScAfterIntegrationTaskD0Ev, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __Z34CanvasRenderer_Set_Custom_PropCullP12Il2CppObjecth: __Z34CanvasRenderer_Set_Custom_PropCullP12Il2CppObjecth, __ZN18CrashReportManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18CrashReportManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z41PlatformEffector2D_Set_Custom_PropSideArcP12Il2CppObjectf: __Z41PlatformEffector2D_Set_Custom_PropSideArcP12Il2CppObjectf, __ZNSt3__216__narrow_to_utf8ILj16EED0Ev: __ZNSt3__216__narrow_to_utf8ILj16EED0Ev, __ZN9Animation18SetVisibleInternalEb: __ZN9Animation18SetVisibleInternalEb, __ZNK9GfxDevice19GetTotalBufferBytesEv: __ZNK9GfxDevice19GetTotalBufferBytesEv, __ZNK5physx2Gu10ConvexMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_9PxBounds3Eyfj: __ZNK5physx2Gu10ConvexMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_9PxBounds3Eyfj, __Z28getPxPhysics_TolerancesScalePKN5physx9PxPhysicsE: __Z28getPxPhysics_TolerancesScalePKN5physx9PxPhysicsE, __ZNK9ShaderLab7Program26FindBestMatchingSubProgramERK16ShaderKeywordSet: __ZNK9ShaderLab7Program26FindBestMatchingSubProgramERK16ShaderKeywordSet, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN4FMOD6System13set3DSettingsEfff: __ZN4FMOD6System13set3DSettingsEfff, __Z44Register_UnityEngine_Component_get_transformv: __Z44Register_UnityEngine_Component_get_transformv, __ZN19RuntimeSceneManager14SetActiveSceneER10UnityScene: __ZN19RuntimeSceneManager14SetActiveSceneER10UnityScene, __ZN15CapsuleColliderD2Ev: __ZN15CapsuleColliderD2Ev, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEE25__construct_node_with_keyERSE_: __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEE25__construct_node_with_keyERSE_, __Z31AudioSource_Set_Custom_PropClipP12Il2CppObjectS0_: __Z31AudioSource_Set_Custom_PropClipP12Il2CppObjectS0_, __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyE: __ZN5physx2Sc5Scene9addShapesEPKPvjjRNS0_8RigidSimEPNS_12PxsRigidBodyE, __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj: __ZN13GfxDeviceGLES22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvEjjj, __ZN2UI6Canvas16TransformChangedEi: __ZN2UI6Canvas16TransformChangedEi, __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z50Playable_CUSTOM_INTERNAL_CALL_GetPlayStateInternalR9HPlayable: __Z50Playable_CUSTOM_INTERNAL_CALL_GetPlayStateInternalR9HPlayable, __ZN2UI6CanvasD2Ev: __ZN2UI6CanvasD2Ev, __Z16AppendPathToHashRKN7mecanim5crc32EPKc: __Z16AppendPathToHashRKN7mecanim5crc32EPKc, __ZN5physx2Sn18RepXCollectionImpl4loadERNS_11PxInputDataERNS0_21SerializationRegistryE: __ZN5physx2Sn18RepXCollectionImpl4loadERNS_11PxInputDataERNS0_21SerializationRegistryE, __Z29getPxRigidBody_RigidBodyFlagsPKN5physx11PxRigidBodyE: __Z29getPxRigidBody_RigidBodyFlagsPKN5physx11PxRigidBodyE, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE3tieEv, __ZN13ComputeShader28DestroyRuntimeDataMainThreadEv: __ZN13ComputeShader28DestroyRuntimeDataMainThreadEv, __ZNK22NavMeshProjectSettings12GetAreaNamesEv: __ZNK22NavMeshProjectSettings12GetAreaNamesEv, __Z45ParticleRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf: __Z45ParticleRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf, __ZN13GfxDeviceGLES25GenerateRenderSurfaceMipsEP17RenderSurfaceBase: __ZN13GfxDeviceGLES25GenerateRenderSurfaceMipsEP17RenderSurfaceBase, __Z32AddPathRemapsForBuiltinResourcesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z32AddPathRemapsForBuiltinResourcesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, _convsamp: _convsamp, __Z35SpriteRenderer_Set_Custom_PropFlipYP12Il2CppObjecth: __Z35SpriteRenderer_Set_Custom_PropFlipYP12Il2CppObjecth, __Z22CalculateMipMapCount3Diii: __Z22CalculateMipMapCount3Diii, __ZN5physx2Gu17EPASupportMapPairD2Ev: __ZN5physx2Gu17EPASupportMapPairD2Ev, __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetBuildIndexByScenePathv: __Z74Register_UnityEngine_SceneManagement_SceneUtility_GetBuildIndexByScenePathv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_png_set_tRNS_to_alpha: _UNITY_png_set_tRNS_to_alpha, __Z49Register_UnityEngine_SystemInfo_get_supportsAudiov: __Z49Register_UnityEngine_SystemInfo_get_supportsAudiov, __ZN12HingeJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN12HingeJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZN21EnlightenSceneMapping8TransferI14SafeBinaryReadEEvRT_: __ZN21EnlightenSceneMapping8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7profile14parseEventDataILb0ENS0_17MemoryEventParserILb0EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_: __ZN5physx7profile14parseEventDataILb0ENS0_17MemoryEventParserILb0EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_, __ZNK5Flare26GetTypeInfoVirtualInternalEv: __ZNK5Flare26GetTypeInfoVirtualInternalEv, __ZNKSt3__217moneypunct_bynameIcLb0EE14do_curr_symbolEv: __ZNKSt3__217moneypunct_bynameIcLb0EE14do_curr_symbolEv, __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN19MeshParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sq11getHitActorEPKNS_3Scb5ActorE: __ZN5physx2Sq11getHitActorEPKNS_3Scb5ActorE, __ZN15ParticleEmitter18UpdateManagerStateEb: __ZN15ParticleEmitter18UpdateManagerStateEb, __Z36Input_Get_Custom_PropIsGyroAvailablev: __Z36Input_Get_Custom_PropIsGyroAvailablev, __ZN25ThreadsafeLinearAllocator16PrintAllocationsEi: __ZN25ThreadsafeLinearAllocator16PrintAllocationsEi, __ZN9ShaderLabL22StaticDestroyShaderLabEPv: __ZN9ShaderLabL22StaticDestroyShaderLabEPv, __ZN12b2WheelJoint24SolvePositionConstraintsERK12b2SolverData: __ZN12b2WheelJoint24SolvePositionConstraintsERK12b2SolverData, __Z29StdTemplateConversionFunctionIjyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjyEbPvR14SafeBinaryRead, _UNITY_FT_Init_Class_tt_cmap10_class_rec: _UNITY_FT_Init_Class_tt_cmap10_class_rec, __ZN9ShaderLab27SerializedShaderVectorValue8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab27SerializedShaderVectorValue8TransferI14SafeBinaryReadEEvRT_, __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalSetUrlv: __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalSetUrlv, __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_: __ZNSt3__27__sort3IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_T_, __ZN5physx16PxVehicleNoDrive4freeEv: __ZN5physx16PxVehicleNoDrive4freeEv, __ZNK12TLSAllocatorI14StackAllocatorE17GetProfilerHeaderEPKv: __ZNK12TLSAllocatorI14StackAllocatorE17GetProfilerHeaderEPKv, __ZNK14RenderSettings15GetAmbientProbeEv: __ZNK14RenderSettings15GetAmbientProbeEv, __ZN5physx2Gu29checkOverlapSphere_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu29checkOverlapSphere_convexGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __Z21TransposeMatrix4x4REFPK10Matrix4x4fPS_: __Z21TransposeMatrix4x4REFPK10Matrix4x4fPS_, __ZN4FMOD7Channel13get3DPanLevelEPf: __ZN4FMOD7Channel13get3DPanLevelEPf, __ZN16GraphicsSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN16GraphicsSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZN13MemoryManager16FrameMaintenanceEb: __ZN13MemoryManager16FrameMaintenanceEb, __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17AudioChorusFilter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_: __ZNSt3__26__sortIRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEvT0_SD_T_, __ZN8Animator27InitializeVisibilityCullingEv: __ZN8Animator27InitializeVisibilityCullingEv, __ZNK6Camera6GetFarEv: __ZNK6Camera6GetFarEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZNK6Object14GetMemoryLabelEv: __ZNK6Object14GetMemoryLabelEv, __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE: __ZN5physx18NpShapeIncRefCountERNS_3Scb5ShapeE, __ZN4FMOD6SoundI8seekDataEj: __ZN4FMOD6SoundI8seekDataEj, __Z22getPxConstraint_ActorsPKN5physx12PxConstraintERPNS_12PxRigidActorES5_: __Z22getPxConstraint_ActorsPKN5physx12PxConstraintERPNS_12PxRigidActorES5_, __Z51ParticleSystem_TrailModule_CUSTOM_SetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient: __Z51ParticleSystem_TrailModule_CUSTOM_SetColorOverTrailP12Il2CppObjectR18MonoMinMaxGradient, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getBreakForceERfS5_, __ZN14DirectorPlayer23VirtualRedirectTransferER14SafeBinaryRead: __ZN14DirectorPlayer23VirtualRedirectTransferER14SafeBinaryRead, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER14SafeBinaryRead: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER14SafeBinaryRead, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderE8UnityStrNS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S7_EEEEEEEEvRT_17TransferMetaFlags, __ZN12_GLOBAL__N_115StringTableImpl11strToHandleEPKc: __ZN12_GLOBAL__N_115StringTableImpl11strToHandleEPKc, __Z58ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring: __Z58ConfigurableJoint_CUSTOM_INTERNAL_set_angularYZLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring, __ZN4FMOD5Sound13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD5Sound13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2ERKS3_: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEEC2ERKS3_, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale0Ef, __ZN10AudioMixerD2Ev: __ZN10AudioMixerD2Ev, __ZNK17AnimationCurveTplI8Vector3fE8WrapTimeEf: __ZNK17AnimationCurveTplI8Vector3fE8WrapTimeEf, __ZN13GfxDeviceNull12DeleteBufferEP9GfxBuffer: __ZN13GfxDeviceNull12DeleteBufferEP9GfxBuffer, __ZNKSt3__210moneypunctIcLb1EE16do_thousands_sepEv: __ZNKSt3__210moneypunctIcLb1EE16do_thousands_sepEv, __Z27GetUserAuthorizationManagerv: __Z27GetUserAuthorizationManagerv, __ZNK9Texture2D26GetTypeInfoVirtualInternalEv: __ZNK9Texture2D26GetTypeInfoVirtualInternalEv, __ZN4FMOD7SystemI19getRecordDriverInfoEiPciP9FMOD_GUID: __ZN4FMOD7SystemI19getRecordDriverInfoEiPciP9FMOD_GUID, __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_: __ZNK15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E13find_positionERS2_, __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff: __ZN26AnimatorControllerPlayable20GotoStateInFixedTimeEiifff, __ZN5physx23PxSpringGeneratedValuesC2EPKNS_8PxSpringE: __ZN5physx23PxSpringGeneratedValuesC2EPKNS_8PxSpringE, _start_pass_phuff_decoder: _start_pass_phuff_decoder, __ZN5physx28PxBoxGeometryGeneratedValuesC2EPKNS_13PxBoxGeometryE: __ZN5physx28PxBoxGeometryGeneratedValuesC2EPKNS_13PxBoxGeometryE, __Z17GetTransformDepthR9Transform: __Z17GetTransformDepthR9Transform, __ZNSt3__26futureIvE3getEv: __ZNSt3__26futureIvE3getEv, __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib: __ZNK10__cxxabiv120__si_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib, __ZN13RuntimeStaticI18AssetBundleManagerE7DestroyEv: __ZN13RuntimeStaticI18AssetBundleManagerE7DestroyEv, __ZN7Terrain8TransferI14SafeBinaryReadEEvRT_: __ZN7Terrain8TransferI14SafeBinaryReadEEvRT_, __Z24Material_CUSTOM_SetFloatP12Il2CppObjectif: __Z24Material_CUSTOM_SetFloatP12Il2CppObjectif, __ZNK15HeightMeshQuery17SetPositionHeightEPf: __ZNK15HeightMeshQuery17SetPositionHeightEPf, __ZN5physx2Sc9ClothCore25setSelfCollisionStiffnessEf: __ZN5physx2Sc9ClothCore25setSelfCollisionStiffnessEf, __ZNSt3__221__undeclare_reachableEPv: __ZNSt3__221__undeclare_reachableEPv, __ZN21VRGlobalSettingsState15SaveGlobalStateEv: __ZN21VRGlobalSettingsState15SaveGlobalStateEv, __ZN12NavMeshAgent17SetUpdateRotationEb: __ZN12NavMeshAgent17SetUpdateRotationEb, __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveScaleP12Il2CppObjectf: __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveScaleP12Il2CppObjectf, __ZN5Light10SetupFlareEv: __ZN5Light10SetupFlareEv, __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb: __ZN5physx14PxRigidBodyExt23setMassAndUpdateInertiaERNS_11PxRigidBodyEPKfjPKNS_6PxVec3Eb, __Z51Register_UnityEngine_ReflectionProbe_set_clearFlagsv: __Z51Register_UnityEngine_ReflectionProbe_set_clearFlagsv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31AnimatorControllerParameterTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead31AnimatorControllerParameterTypeEvRT_RT0_PKc17TransferMetaFlags, __Z44AreaEffector2D_Set_Custom_PropUseGlobalAngleP12Il2CppObjecth: __Z44AreaEffector2D_Set_Custom_PropUseGlobalAngleP12Il2CppObjecth, __Z49Register_UnityEngine_Transform_set_parentInternalv: __Z49Register_UnityEngine_Transform_set_parentInternalv, __ZN19VREyeTextureManager20FlushToDeviceTextureEf: __ZN19VREyeTextureManager20FlushToDeviceTextureEf, __ZN9Rigidbody17SetFreezeRotationEb: __ZN9Rigidbody17SetFreezeRotationEb, __ZN10AudioMixer12UpdateBypassEv: __ZN10AudioMixer12UpdateBypassEv, __Z57Register_UnityEngine_ConfigurableJoint_get_projectionModev: __Z57Register_UnityEngine_ConfigurableJoint_get_projectionModev, __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_set_sizeCustomP12Il2CppObjectRK8Vector3f: __Z52LightProbeProxyVolume_CUSTOM_INTERNAL_set_sizeCustomP12Il2CppObjectRK8Vector3f, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_RKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_RKS4_, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z58Register_UnityEngine_RenderTexture_INTERNAL_CALL_IsCreatedv: __Z58Register_UnityEngine_RenderTexture_INTERNAL_CALL_IsCreatedv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj, __Z16GetDefaultMetricRK10Matrix4x4f: __Z16GetDefaultMetricRK10Matrix4x4f, __ZN8Animator13AvatarDataSet5ResetEv: __ZN8Animator13AvatarDataSet5ResetEv, __ZNK5physx2Sn22DeserializationContext16resolveReferenceEjj: __ZNK5physx2Sn22DeserializationContext16resolveReferenceEjj, __ZN14RenderSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14RenderSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN8Renderer19SetLightmapIndexIntEi12LightmapType: __ZN8Renderer19SetLightmapIndexIntEi12LightmapType, __ZN18AudioMixerSnapshot8TransferI17RemapPPtrTransferEEvRT_: __ZN18AudioMixerSnapshot8TransferI17RemapPPtrTransferEEvRT_, __ZN11TrailModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11TrailModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__217__assoc_sub_stateD2Ev: __ZNSt3__217__assoc_sub_stateD2Ev, __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv: __ZN11UnityEngine15PlatformWrapper27GetCurrentMillisecondsInUTCEv, __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEE8__appendEj, __Z50Register_UnityEngine_ParticleEmitter_get_particlesv: __Z50Register_UnityEngine_ParticleEmitter_get_particlesv, __ZNSt3__213move_backwardIP10InputEventS1_S2_RS1_PS2_iLi0EEENS_16__deque_iteratorIT0_T1_T2_T3_T4_XT5_EEET_SC_SB_PNS_9enable_ifIXsr27__is_random_access_iteratorISC_EE5valueEvE4typeE: __ZNSt3__213move_backwardIP10InputEventS1_S2_RS1_PS2_iLi0EEENS_16__deque_iteratorIT0_T1_T2_T3_T4_XT5_EEET_SC_SB_PNS_9enable_ifIXsr27__is_random_access_iteratorISC_EE5valueEvE4typeE, __ZNK7dtCrowd26getAgentFromProximityIndexEi: __ZNK7dtCrowd26getAgentFromProximityIndexEi, __Z48Register_UnityEngine_TargetJoint2D_get_frequencyv: __Z48Register_UnityEngine_TargetJoint2D_get_frequencyv, __Z55Register_UnityEngine_AI_NavMeshAgent_get_updatePositionv: __Z55Register_UnityEngine_AI_NavMeshAgent_get_updatePositionv, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetZv, _UNITY_png_get_y_offset_inches_fixed: _UNITY_png_get_y_offset_inches_fixed, __ZNK5physx2Gu12OBBAABBTestsILb1EEclENS_6shdfnd3aos5Vec3VES5_: __ZNK5physx2Gu12OBBAABBTestsILb1EEclENS_6shdfnd3aos5Vec3VES5_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_, __ZN9ShaderLab20ShaderBlendStateDescC2Ev: __ZN9ShaderLab20ShaderBlendStateDescC2Ev, __Z30AndroidJNI_CUSTOM_GetLongField13Il2Cpp_IntPtrS_: __Z30AndroidJNI_CUSTOM_GetLongField13Il2Cpp_IntPtrS_, _jpeg_alloc_quant_table: _jpeg_alloc_quant_table, __Z20getPxSceneDescLimitsPKN5physx11PxSceneDescE: __Z20getPxSceneDescLimitsPKN5physx11PxSceneDescE, __ZN14EmissionModule8TransferI17RemapPPtrTransferEEvRT_: __ZN14EmissionModule8TransferI17RemapPPtrTransferEEvRT_, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetFrequencyv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetFrequencyv, __ZN15QualitySettings23SetAsyncUploadTimeSliceEi: __ZN15QualitySettings23SetAsyncUploadTimeSliceEi, __Z51CharacterController_Set_Custom_PropDetectCollisionsP12Il2CppObjecth: __Z51CharacterController_Set_Custom_PropDetectCollisionsP12Il2CppObjecth, __ZN12TreeRendererD2Ev: __ZN12TreeRendererD2Ev, __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_: __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_S7_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8pop_backEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE8pop_backEv, __ZN12FlareManager6UpdateEv: __ZN12FlareManager6UpdateEv, __ZN2UI11CanvasGroup23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN2UI11CanvasGroup23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR17DetailNodeZSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_, _UNITY_FT_Activate_Size: _UNITY_FT_Activate_Size, __Z44Register_UnityEngine_CanvasRenderer_set_cullv: __Z44Register_UnityEngine_CanvasRenderer_set_cullv, __ZN5physx25PxcGetMaterialHeightFieldEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx25PxcGetMaterialHeightFieldEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, _UNITY_png_do_read_transformations: _UNITY_png_do_read_transformations, __ZNK5physx14NpSpatialIndex9getBoundsEj: __ZNK5physx14NpSpatialIndex9getBoundsEj, __ZN5Umbra20RuntimeTomeGenerator17serializeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEERNS_7ImpTomeE: __ZN5Umbra20RuntimeTomeGenerator17serializeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEERNS_7ImpTomeE, __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __Z59Register_UnityEngine_Rigidbody_INTERNAL_set_angularVelocityv: __Z59Register_UnityEngine_Rigidbody_INTERNAL_set_angularVelocityv, _UNITY_FT_Attach_Stream: _UNITY_FT_Attach_Stream, __ZNK5physx12PxFixedJoint8isKindOfEPKc: __ZNK5physx12PxFixedJoint8isKindOfEPKc, __ZThn28_N14PhysicsManagerD1Ev: __ZThn28_N14PhysicsManagerD1Ev, __ZN4FMOD6SoundI12addSyncPointEjjPKcPP14FMOD_SYNCPOINT: __ZN4FMOD6SoundI12addSyncPointEjjPKcPP14FMOD_SYNCPOINT, __ZN9Scripting19ScriptingWrapperForEP6Object: __ZN9Scripting19ScriptingWrapperForEP6Object, __ZN5physx6shdfnd5ArrayINS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN16ParticleRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16ParticleRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK19CharacterController26GetTypeInfoVirtualInternalEv: __ZNK19CharacterController26GetTypeInfoVirtualInternalEv, __Z48Register_UnityEngine_Projector_set_nearClipPlanev: __Z48Register_UnityEngine_Projector_set_nearClipPlanev, __ZN11UnityEngine15PlatformWrapper17GetProcessorCountEv: __ZN11UnityEngine15PlatformWrapper17GetProcessorCountEv, __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi: __ZN7mecanim5human14HumanFixEndDoFEPKNS0_5HumanEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEES9_iifi, __ZN16b2PrismaticJoint9SetLimitsEff: __ZN16b2PrismaticJoint9SetLimitsEff, __Z43getPxVehicleAckermannGeometryDataMRearWidthPKN5physx30PxVehicleAckermannGeometryDataE: __Z43getPxVehicleAckermannGeometryDataMRearWidthPKN5physx30PxVehicleAckermannGeometryDataE, __ZN5physx2Sq16BucketPrunerCore11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq16BucketPrunerCore11shiftOriginERKNS_6PxVec3E, __Z13RegisterClassI20UnityConnectSettingsEvv: __Z13RegisterClassI20UnityConnectSettingsEvv, _UNITY_png_chunk_benign_error: _UNITY_png_chunk_benign_error, __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b: __ZN29CalculateAmbientFaceProcessorclER5ImageiRK8Vector3fS4_S4_b, __Z20RegisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbPFP17BaseWebCamTexturevE: __Z20RegisterWebCamDeviceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbPFP17BaseWebCamTexturevE, __ZN5physx2Sc17ParticleSystemSim9startStepEv: __ZN5physx2Sc17ParticleSystemSim9startStepEv, __ZN15b2RevoluteJoint13SetMotorSpeedEf: __ZN15b2RevoluteJoint13SetMotorSpeedEf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj87ES2_jEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE14simplePropertyIKNS_3Pvd26PxPvdRangePropertyAccessorILj87ES2_jEEEEvjRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjjc, __ZN10AudioMixer23VirtualRedirectTransferER14SafeBinaryRead: __ZN10AudioMixer23VirtualRedirectTransferER14SafeBinaryRead, __ZNK20LocalFileSystemPosix26GetApplicationContentsPathEv: __ZNK20LocalFileSystemPosix26GetApplicationContentsPathEv, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEv, _psh_hint_table_find_strong_points: _psh_hint_table_find_strong_points, __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS6_, __Z59Register_UnityEngine_Camera_Internal_RenderToCubemapTexturev: __Z59Register_UnityEngine_Camera_Internal_RenderToCubemapTexturev, __Z31setPxVehicleGearsData_GearRatioPN5physx18PxVehicleGearsDataENS0_4EnumEf: __Z31setPxVehicleGearsData_GearRatioPN5physx18PxVehicleGearsDataENS0_4EnumEf, __Z22GetStreamingAssetsPathv: __Z22GetStreamingAssetsPathv, __ZNK5Umbra18ImpOcclusionBuffer13visualizeHullEPNS_12QueryContextE: __ZNK5Umbra18ImpOcclusionBuffer13visualizeHullEPNS_12QueryContextE, __Z34getPxRevoluteJoint_DriveForceLimitPKN5physx15PxRevoluteJointE: __Z34getPxRevoluteJoint_DriveForceLimitPKN5physx15PxRevoluteJointE, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE10onComShiftEj, __Z31scripting_method_get_returntype21ScriptingMethodIl2Cpp: __Z31scripting_method_get_returntype21ScriptingMethodIl2Cpp, __ZN5physx2Sc5Scene19islandGenSecondPassEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene19islandGenSecondPassEPNS_10PxBaseTaskE, __ZN25SubstanceRawTextureSharedC2EPv: __ZN25SubstanceRawTextureSharedC2EPv, __ZNK17ArchiveFileSystem4SizeERK13FileEntryData: __ZNK17ArchiveFileSystem4SizeERK13FileEntryData, __Z58Register_UnityEngine_ParticleSystem_ShapeModule_GetEnabledv: __Z58Register_UnityEngine_ParticleSystem_ShapeModule_GetEnabledv, __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j: __ZNK5physx28PxDistanceJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE, __ZN4FMOD7Channel9setPausedEb: __ZN4FMOD7Channel9setPausedEb, __ZN16CrashReportEventD2Ev: __ZN16CrashReportEventD2Ev, __ZN5physx20PxsParticleSystemSim20remapShapesToPacketsEPKPNS_16PxvParticleShapeEj: __ZN5physx20PxsParticleSystemSim20remapShapesToPacketsEPKPNS_16PxvParticleShapeEj, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindERKS5_j, __ZN15OcclusionPortal7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15OcclusionPortal7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx3Cct9SweepTestD2Ev: __ZN5physx3Cct9SweepTestD2Ev, __ZN15AudioMixerGroupD2Ev: __ZN15AudioMixerGroupD2Ev, __ZNK8Material14GetOverrideTagEi: __ZNK8Material14GetOverrideTagEi, __ZNK8VRDevice16GetFramePresentsEv: __ZNK8VRDevice16GetFramePresentsEv, __ZL23StereoDisplayInitializeR34UnityVRDeviceSpecificConfiguration: __ZL23StereoDisplayInitializeR34UnityVRDeviceSpecificConfiguration, __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf: __ZL13ClearAlphaMapP9Texture2DRK10ColorRGBAf, __Z52Register_UnityEngine_SurfaceEffector2D_get_useBouncev: __Z52Register_UnityEngine_SurfaceEffector2D_get_useBouncev, __Z53Register_UnityEngine_ConfigurableJoint_get_swapBodiesv: __Z53Register_UnityEngine_ConfigurableJoint_get_swapBodiesv, __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE15growAndPushBackERKS3_, __ZN5Umbra16VisibilityResultD2Ev: __ZN5Umbra16VisibilityResultD2Ev, __ZN25PathNamePersistentManager30PathIDToFileIdentifierInternalEi: __ZN25PathNamePersistentManager30PathIDToFileIdentifierInternalEi, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER17RemapPPtrTransfer, __Z41Shader_CUSTOM_SetGlobalFloatArrayImplListiP12Il2CppObject: __Z41Shader_CUSTOM_SetGlobalFloatArrayImplListiP12Il2CppObject, __ZN5physx2Sc21ConstraintInteractionC2EPNS0_13ConstraintSimERNS0_8RigidSimES5_: __ZN5physx2Sc21ConstraintInteractionC2EPNS0_13ConstraintSimERNS0_8RigidSimES5_, __Z32CrashReport_CUSTOM_GetReportDataP12Il2CppStringPd: __Z32CrashReport_CUSTOM_GetReportDataP12Il2CppStringPd, __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD0Ev: __ZN7WeakPtrIN11SoundHandle8InstanceEE10SharedDataD0Ev, __ZNK11b2WeldJoint16GetReactionForceEf: __ZNK11b2WeldJoint16GetReactionForceEf, __ZN5physx9NpFactory25releaseRigidDynamicToPoolERNS_14NpRigidDynamicE: __ZN5physx9NpFactory25releaseRigidDynamicToPoolERNS_14NpRigidDynamicE, _accept4: _accept4, __ZL32CullAllPerObjectLightsCombineJobP29CullAllPerObjectLightsJobData: __ZL32CullAllPerObjectLightsCombineJobP29CullAllPerObjectLightsJobData, __ZNK20LocalFileSystemPosix21GetUserAppCacheFolderEv: __ZNK20LocalFileSystemPosix21GetUserAppCacheFolderEv, __ZN7mecanim5human6Handle8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim5human6Handle8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z36AudioMixer_Get_Custom_PropUpdateModeP12Il2CppObject: __Z36AudioMixer_Get_Custom_PropUpdateModeP12Il2CppObject, __ZN10GpuProgram20ApplyValueParametersI21GLESGpuProgramApplierEEPKhRT_RK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EES3_: __ZN10GpuProgram20ApplyValueParametersI21GLESGpuProgramApplierEEPKhRT_RK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EES3_, __Z27getPxPhysics_TriangleMeshesPKN5physx9PxPhysicsEPPNS_14PxTriangleMeshEj: __Z27getPxPhysics_TriangleMeshesPKN5physx9PxPhysicsEPPNS_14PxTriangleMeshEj, __ZN15ReplacementPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceData: __ZN15ReplacementPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceData, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4initEPNS_15basic_streambufIwS2_EE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4initEPNS_15basic_streambufIwS2_EE, __Z15Transfer_StringI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD6SoundI13setVariationsEfff: __ZN4FMOD6SoundI13setVariationsEfff, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES7_EEKNS_35PxVehicleWheelsDynDataGeneratedInfoEEEvPjRKT_RT0_, __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEEEEjT_j: __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEEEEEjT_j, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxArticulationJointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj63ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN4Mesh8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4Mesh8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z22TransferField_NonArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx2Sn9PtrAccessINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEERKT_PS7_j: __ZN5physx2Sn9PtrAccessINS_7PxFlagsINS_14PxParticleFlag4EnumEtEEEERKT_PS7_j, __Z55Register_UnityEngine_LineRenderer_INTERNAL_set_endColorv: __Z55Register_UnityEngine_LineRenderer_INTERNAL_set_endColorv, __ZN5physx3Scb5SceneC2ERKNS_11PxSceneDescENS_2Cm13EventProfilerE: __ZN5physx3Scb5SceneC2ERKNS_11PxSceneDescENS_2Cm13EventProfilerE, __ZN5physx7NpScene18setSolverBatchSizeEj: __ZN5physx7NpScene18setSolverBatchSizeEj, __ZN6Camera14SetCullingMaskEj: __ZN6Camera14SetCullingMaskEj, __Z52Register_UnityEngine_AI_NavMeshAgent_FindClosestEdgev: __Z52Register_UnityEngine_AI_NavMeshAgent_FindClosestEdgev, __Z56Register_UnityEngine_PhysicMaterial_get_dynamicFriction2v: __Z56Register_UnityEngine_PhysicMaterial_get_dynamicFriction2v, __ZL16SceneWasUnloadedi: __ZL16SceneWasUnloadedi, __ZN5physx21PxcArticulationHelper16prepareDataBlockERNS_9PxcFsDataEPKNS_19PxsArticulationLinkEtPNS_11PxTransformEPNS_12PxcFsInertiaEPNS_30PxcArticulationJointTransformsEj: __ZN5physx21PxcArticulationHelper16prepareDataBlockERNS_9PxcFsDataEPKNS_19PxsArticulationLinkEtPNS_11PxTransformEPNS_12PxcFsInertiaEPNS_30PxcArticulationJointTransformsEj, __Z44Register_UnityEngine_Camera_set_orthographicv: __Z44Register_UnityEngine_Camera_set_orthographicv, __Z45Register_UnityEngine_Animator_set_cullingModev: __Z45Register_UnityEngine_Animator_set_cullingModev, __ZN9InputAxis9MakeMouseEi: __ZN9InputAxis9MakeMouseEi, __ZNK9ShaderLab11ShaderState20FindSubProgramsToUseEPK6ShaderPKNS_4PassER11SubProgramsRK17ShaderPassContext: __ZNK9ShaderLab11ShaderState20FindSubProgramsToUseEPK6ShaderPKNS_4PassER11SubProgramsRK17ShaderPassContext, _UNITY_png_crc_error: _UNITY_png_crc_error, __Z44UnityConnectSettings_Get_Custom_PropTestModev: __Z44UnityConnectSettings_Get_Custom_PropTestModev, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN7dtCrowd6updateEfP21dtCrowdAgentDebugInfoi: __ZN7dtCrowd6updateEfP21dtCrowdAgentDebugInfoi, __ZN5Unity5Cloth8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity5Cloth8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physxL22concludeContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEjj: __ZN5physxL22concludeContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextEjj, ___stdio_exit: ___stdio_exit, __Z38Register_UnityEngine_Material_FindPassv: __Z38Register_UnityEngine_Material_FindPassv, __Z13RegisterClassI8RendererEvv: __Z13RegisterClassI8RendererEvv, __ZN4FMOD6System10getDSPHeadEPPNS_3DSPE: __ZN4FMOD6System10getDSPHeadEPPNS_3DSPE, __ZN10FileSystemC2Ev: __ZN10FileSystemC2Ev, __ZN5Umbra15ImpShadowCullerC2Ev: __ZN5Umbra15ImpShadowCullerC2Ev, __Z38LightProbes_Get_Custom_PropBakedProbesP12Il2CppObject: __Z38LightProbes_Get_Custom_PropBakedProbesP12Il2CppObject, __ZN5physx20PxsParticleSystemSim15addInteractionVERKNS_16PxvParticleShapeEjjbb: __ZN5physx20PxsParticleSystemSim15addInteractionVERKNS_16PxvParticleShapeEjjbb, __ZN5physx8debugger4comm11DeriveClassD0Ev: __ZN5physx8debugger4comm11DeriveClassD0Ev, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK21EnlightenSceneMapping19GetTerrainNumChunksERiS0_RK7Hash128: __ZNK21EnlightenSceneMapping19GetTerrainNumChunksERiS0_RK7Hash128, __ZN12CullingGroupD2Ev: __ZN12CullingGroupD2Ev, __Z18GetGUIBlitMaterialv: __Z18GetGUIBlitMaterialv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5tellpEv: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5tellpEv, __ZN5physx5cloth8SwSolver29setInterCollisionNbIterationsEj: __ZN5physx5cloth8SwSolver29setInterCollisionNbIterationsEj, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx10PxsContext11swapStreamsEv: __ZN5physx10PxsContext11swapStreamsEv, _UNITY_png_write_chunk_end: _UNITY_png_write_chunk_end, __Z35Register_UnityEngine_Transform_Findv: __Z35Register_UnityEngine_Transform_Findv, __Z37Register_UnityEngine_Texture2D_Resizev: __Z37Register_UnityEngine_Texture2D_Resizev, __Z45Register_UnityEngine_Animator_get_logWarningsv: __Z45Register_UnityEngine_Animator_get_logWarningsv, __ZN24GenerateTypeTreeTransfer8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI15ComputeShaderCBEEvRT_PKc17TransferMetaFlags, _UNITY_tt_face_load_head: _UNITY_tt_face_load_head, __Z12SetToDefaultR11JointSpring: __Z12SetToDefaultR11JointSpring, __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E14squash_deletedEv, __ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE: __ZN5physx2Sc5Scene8addClothERNS0_9ClothCoreE, __Z35AllocExtractMeshTrianglesFromScriptRK4Meshi: __Z35AllocExtractMeshTrianglesFromScriptRK4Meshi, __ZN20TextRenderingPrivate8TextMesh15DidAddComponentEv: __ZN20TextRenderingPrivate8TextMesh15DidAddComponentEv, __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_: __Z14ClipAnimationsI8Vector3fN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_, __ZN5physx3Cct17CapsuleController7releaseEv: __ZN5physx3Cct17CapsuleController7releaseEv, __ZN5physx14SapPairManagerD2Ev: __ZN5physx14SapPairManagerD2Ev, __Z32setPxCloth_SelfCollisionDistancePN5physx7PxClothEf: __Z32setPxCloth_SelfCollisionDistancePN5physx7PxClothEf, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN16b2PrismaticJoint23InitVelocityConstraintsERK12b2SolverData: __ZN16b2PrismaticJoint23InitVelocityConstraintsERK12b2SolverData, __ZN6Camera16SetTargetTextureEP13RenderTexture: __ZN6Camera16SetTargetTextureEP13RenderTexture, __ZN5physx2Sc8BodyCore8setFlagsEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx2Sc8BodyCore8setFlagsEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_timeES4_S4_RNS_8ios_baseERjP2tm, __Z8pqInsertP9TESSallocP9PriorityQPv: __Z8pqInsertP9TESSallocP9PriorityQPv, __ZNK5physx19NpArticulationJoint21getInternalComplianceEv: __ZNK5physx19NpArticulationJoint21getInternalComplianceEv, __ZN5physx7PxvTermEv: __ZN5physx7PxvTermEv, __ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController: __ZN26AnimatorOverrideController22GetEffectiveControllerEP25RuntimeAnimatorController, __Z12StringToGUIDPKcj: __Z12StringToGUIDPKcj, __Z40AudioReverbZone_Set_Custom_PropDiffusionP12Il2CppObjectf: __Z40AudioReverbZone_Set_Custom_PropDiffusionP12Il2CppObjectf, __ZL22InitializeModule_WebGLv: __ZL22InitializeModule_WebGLv, __ZN5Unity10HingeJoint16CheckConsistencyEv: __ZN5Unity10HingeJoint16CheckConsistencyEv, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER14SafeBinaryRead: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER14SafeBinaryRead, __ZN19StreamedBinaryWriteILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN19StreamedBinaryWriteILb1EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, __ZN14TimerQueryGLESD2Ev: __ZN14TimerQueryGLESD2Ev, __ZN5physx16PxVehicleNoDrive14setToRestStateEv: __ZN5physx16PxVehicleNoDrive14setToRestStateEv, __Z64Register_UnityEngine_AnimatorOverrideController_GetOriginalClipsv: __Z64Register_UnityEngine_AnimatorOverrideController_GetOriginalClipsv, __ZN26AnimatorOverrideController7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN26AnimatorOverrideController7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_: __ZN5physx21PxcArticulationHelper18getImpulseResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS4_, __ZN5physx11MeshCleanerD2Ev: __ZN5physx11MeshCleanerD2Ev, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN23PxsCMDiscreteUpdateTaskD0Ev: __ZN23PxsCMDiscreteUpdateTaskD0Ev, __ZN5physx2Sc19ClothFabricBulkDataD2Ev: __ZN5physx2Sc19ClothFabricBulkDataD2Ev, __ZN17RemapPPtrTransfer11PopMetaFlagEv: __ZN17RemapPPtrTransfer11PopMetaFlagEv, __Z20AddDirectionalLightsPPK5LightjR12ActiveLights: __Z20AddDirectionalLightsPPK5LightjR12ActiveLights, __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z42Register_UnityEngine_Component_SendMessagev: __Z42Register_UnityEngine_Component_SendMessagev, __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev: __ZN5physx35PxJointLinearLimitPairGeneratedInfoC2Ev, __ZN8Animator17GetAvatarConstantEv: __ZN8Animator17GetAvatarConstantEv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIhLj1EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN14PlayerSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14PlayerSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN8VRModule27CleanupGfxResourcesCallbackEv: __ZN8VRModule27CleanupGfxResourcesCallbackEv, __ZNK13SpeedTreeWind18GetMaxBranchLengthEv: __ZNK13SpeedTreeWind18GetMaxBranchLengthEv, __ZN13GfxDeviceGLES15FinishRenderingEv: __ZN13GfxDeviceGLES15FinishRenderingEv, __ZN5physx3Scb4Body8setFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __ZN5physx3Scb4Body8setFlagsENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __Z53Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastAllv: __Z53Register_UnityEngine_Physics_INTERNAL_CALL_BoxCastAllv, __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13AnimationClip10FloatCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Unity12PhysicsQuery18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14WSAInputSourceEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14WSAInputSourceEvRT_RT0_PKc17TransferMetaFlags, __Z42Register_UnityEngine_Mesh_ClearBlendShapesv: __Z42Register_UnityEngine_Mesh_ClearBlendShapesv, __Z45RenderTexture_Get_Custom_PropAutoGenerateMipsP12Il2CppObject: __Z45RenderTexture_Get_Custom_PropAutoGenerateMipsP12Il2CppObject, __Z55Register_UnityEngine_RectTransform_set_drivenPropertiesv: __Z55Register_UnityEngine_RectTransform_set_drivenPropertiesv, __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity5Joint17JointTransferPostI24GenerateTypeTreeTransferEEvRT_, __ZN5physx23ArticulationRootManagerD2Ev: __ZN5physx23ArticulationRootManagerD2Ev, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlENS_4lessIS6_EENS4_INS_4pairIKS6_S8_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSC_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEN5IMGUI12NamedControlENS_4lessIS6_EENS4_INS_4pairIKS6_S8_EEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSC_, _do_read_529: _do_read_529, __Z63Register_UnityEngine_Networking_UploadHandler_InternalCreateRawv: __Z63Register_UnityEngine_Networking_UploadHandler_InternalCreateRawv, __ZNK5physx2Sq17AABBTreeUpdateMap8checkMapEjRKNS0_8AABBTreeE: __ZNK5physx2Sq17AABBTreeUpdateMap8checkMapEjRKNS0_8AABBTreeE, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEE8__appendEj, __ZN9b2FixtureC2Ev: __ZN9b2FixtureC2Ev, __Z42Register_UnityEngine_Camera_GetHDRWarningsv: __Z42Register_UnityEngine_Camera_GetHDRWarningsv, __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EERKS9_PKS6_: __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EERKS9_PKS6_, __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EppEv: __ZN5physx5cloth12LerpIteratorI8Scalar4fPKS2_EppEv, __ZN12b2WheelJointC2EPK15b2WheelJointDef: __ZN12b2WheelJointC2EPK15b2WheelJointDef, __ZN23ShaderVariantCollection15ThreadedCleanupEv: __ZN23ShaderVariantCollection15ThreadedCleanupEv, __ZN5physx19NpArticulationJoint12setStiffnessEf: __ZN5physx19NpArticulationJoint12setStiffnessEf, __Z44RenderSettings_Get_Custom_PropFlareFadeSpeedv: __Z44RenderSettings_Get_Custom_PropFlareFadeSpeedv, __ZN19SkinnedMeshRenderer12CleanupClassEv: __ZN19SkinnedMeshRenderer12CleanupClassEv, __ZN13MemoryManager22StopLoggingAllocationsEv: __ZN13MemoryManager22StopLoggingAllocationsEv, __Z36Animation_Get_Custom_PropCullingTypeP12Il2CppObject: __Z36Animation_Get_Custom_PropCullingTypeP12Il2CppObject, __Z24RegisterStrippedTypeInfoIN13TextRendering4FontEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN13TextRendering4FontEEviPKcS3_, __Z69Register_UnityEngine_QualitySettings_get_billboardsFaceCameraPositionv: __Z69Register_UnityEngine_QualitySettings_get_billboardsFaceCameraPositionv, __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE8__appendEj, __ZNK5Umbra9Matrix3x39isUniformEv: __ZNK5Umbra9Matrix3x39isUniformEv, __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr: __ZL26KeywordSetToStringDontSortRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEER8UnityStr, __ZN9WWWCached8GetErrorEv: __ZN9WWWCached8GetErrorEv, __ZNK5physx19NpArticulationJoint13getParentPoseEv: __ZNK5physx19NpArticulationJoint13getParentPoseEv, __ZNK5physx14SapPairManager8FindPairEjj: __ZNK5physx14SapPairManager8FindPairEjj, _UNITY_png_set_text_compression_mem_level: _UNITY_png_set_text_compression_mem_level, __ZN17Physics2DSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17Physics2DSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN13SpringJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN13SpringJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __Z51Register_UnityEngine_WebCamTexture_set_requestedFPSv: __Z51Register_UnityEngine_WebCamTexture_set_requestedFPSv, __ZN9Projector5ResetEv: __ZN9Projector5ResetEv, _strtoul: _strtoul, __ZN7dtCrowd4initEi: __ZN7dtCrowd4initEi, __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E: __Z24InverseTransformPosition23TransformAccessReadOnlyRKN4math7_float3E, __ZN25MinMaxOptimizedPolyCurves26FindMinMaxDoubleIntegratedEv: __ZN25MinMaxOptimizedPolyCurves26FindMinMaxDoubleIntegratedEv, __ZNK10MemoryFile6IsOpenEv: __ZNK10MemoryFile6IsOpenEv, __ZN9GfxDevice20BeginDynamicBatchingERK14ChannelAssignsjjP17VertexDeclarationjj16GfxPrimitiveType: __ZN9GfxDevice20BeginDynamicBatchingERK14ChannelAssignsjjP17VertexDeclarationjj16GfxPrimitiveType, __ZN7mecanim18ValueArrayBlendEndERNS_10ValueArrayERKNS_14ValueArrayMaskERKNS_16ValueArrayWeightEPKS0_: __ZN7mecanim18ValueArrayBlendEndERNS_10ValueArrayERKNS_14ValueArrayMaskERKNS_16ValueArrayWeightEPKS0_, __ZN18CrashReportManager12CloseServiceEv: __ZN18CrashReportManager12CloseServiceEv, __ZNK27AnimatorControllerParameter13GetControllerEv: __ZNK27AnimatorControllerParameter13GetControllerEv, __ZNK4Mesh15GetSubMeshCountEv: __ZNK4Mesh15GetSubMeshCountEv, __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb, _UNITY_FT_Set_Debug_Hook: _UNITY_FT_Set_Debug_Hook, __Z12WeldVerticesRK14VertexDataInfoRK13dynamic_arrayIjLj4EEfR18WeldVerticesOutput: __Z12WeldVerticesRK14VertexDataInfoRK13dynamic_arrayIjLj4EEfR18WeldVerticesOutput, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __Z40SliderJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP24JointTranslationLimits2D: __Z40SliderJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP24JointTranslationLimits2D, __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI24GenerateTypeTreeTransferEEvRS6_RT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __Z22GetMemoryProfilerStatsv: __Z22GetMemoryProfilerStatsv, __ZN16ReflectionProbes17SetDefaultTextureE4PPtrI7TextureEf: __ZN16ReflectionProbes17SetDefaultTextureE4PPtrI7TextureEf, __ZN5physx3Cct13BoxControllerD0Ev: __ZN5physx3Cct13BoxControllerD0Ev, __Z26IntersectAABBAABBInclusiveRK4AABBS1_: __Z26IntersectAABBAABBInclusiveRK4AABBS1_, ___fesetround: ___fesetround, __Z65Register_UnityEngine_Networking_UnityWebRequest_get_redirectLimitv: __Z65Register_UnityEngine_Networking_UnityWebRequest_get_redirectLimitv, __ZNKSt3__210moneypunctIwLb0EE14do_curr_symbolEv: __ZNKSt3__210moneypunctIwLb0EE14do_curr_symbolEv, _write_tables_only: _write_tables_only, __Z48Register_UnityEngine_Projector_get_nearClipPlanev: __Z48Register_UnityEngine_Projector_get_nearClipPlanev, __ZN14ImageReferenceC2Eiii13TextureFormatPv: __ZN14ImageReferenceC2Eiii13TextureFormatPv, __Z17MergeLightmapDataiR18AwakeFromLoadQueue: __Z17MergeLightmapDataiR18AwakeFromLoadQueue, __ZNK5physx2Gu12TriangleMesh17getTrianglesRemapEv: __ZNK5physx2Gu12TriangleMesh17getTrianglesRemapEv, __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE: __ZN18DelayedCallManager6RemoveERKNS_8CallbackENSt3__221__tree_const_iteratorIS0_PNS3_11__tree_nodeIS0_PvEEiEE, __Z52QualitySettings_Set_Custom_PropAsyncUploadBufferSizei: __Z52QualitySettings_Set_Custom_PropAsyncUploadBufferSizei, __Z14TriangleArea3DRK8Vector3fS1_S1_: __Z14TriangleArea3DRK8Vector3fS1_S1_, __ZN24MeshIntermediateRendererD0Ev: __ZN24MeshIntermediateRendererD0Ev, __ZN5physx34solveContactCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx34solveContactCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN8Animator12ResetTriggerEi: __ZN8Animator12ResetTriggerEi, __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK8Vector3fRK11Quaternionfi: __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK8Vector3fRK11Quaternionfi, __Z51Register_UnityEngine_Rigidbody_set_detectCollisionsv: __Z51Register_UnityEngine_Rigidbody_set_detectCollisionsv, __ZN22ParticleSystemRenderer12GetWorldAABBER4AABB: __ZN22ParticleSystemRenderer12GetWorldAABBER4AABB, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setExternalAccelerationERKNS_6PxVec3E: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setExternalAccelerationERKNS_6PxVec3E, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN8GUIStyle8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8GUIStyle8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11UnityEngine9Animation30UnregisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE: __ZN11UnityEngine9Animation30UnregisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE, __ZN15PointEffector2DC2E10MemLabelId18ObjectCreationMode: __ZN15PointEffector2DC2E10MemLabelId18ObjectCreationMode, __GLOBAL__sub_I_runtime_gamecode_lump_cpp: __GLOBAL__sub_I_runtime_gamecode_lump_cpp, __ZZN15DirectorManager15InitializeClassEvEN41FixedUpdateDirectorFixedAdvanceTimestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN41FixedUpdateDirectorFixedAdvanceTimestruct7ForwardEv, __ZN5physx2Sc18TriggerInteraction10initializeEv: __ZN5physx2Sc18TriggerInteraction10initializeEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEEEvPT_jRKT0_RKT1_j, __Z50Register_UnityEngine_Camera_set_layerCullDistancesv: __Z50Register_UnityEngine_Camera_set_layerCullDistancesv, __ZN5physx2Sc24ConstraintProjectionTree11projectPoseERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc24ConstraintProjectionTree11projectPoseERNS0_19ConstraintGroupNodeE, __ZN24CollectBroadphaseTerrain9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE: __ZN24CollectBroadphaseTerrain9preFilterERKN5physx12PxFilterDataEPKNS0_7PxShapeEPKNS0_12PxRigidActorERNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEE, __ZN11dtPathQueue5clearEv: __ZN11dtPathQueue5clearEv, __ZN11UnityEngine15PlatformWrapper16GetVRDeviceModelEv: __ZN11UnityEngine15PlatformWrapper16GetVRDeviceModelEv, __ZN4UNET16ScriptingUpdater16SetUpdatePointerEv: __ZN4UNET16ScriptingUpdater16SetUpdatePointerEv, __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext: __Z28QueuePrepareNodeToMainThreadR35RenderNodeQueuePrepareThreadContext, __Z38Rigidbody_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f: __Z38Rigidbody_CUSTOM_INTERNAL_get_positionP12Il2CppObjectP8Vector3f, __ZN10Effector2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN10Effector2D13AwakeFromLoadE17AwakeFromLoadMode, __ZN21WorldParticleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN21WorldParticleCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z48Register_UnityEngine_Application_GetValueForARGVv: __Z48Register_UnityEngine_Application_GetValueForARGVv, __Z29setPxSphericalJoint_LimitConePN5physx16PxSphericalJointERKNS_16PxJointLimitConeE: __Z29setPxSphericalJoint_LimitConePN5physx16PxSphericalJointERKNS_16PxJointLimitConeE, __ZNK5Umbra9Matrix4x43detEv: __ZNK5Umbra9Matrix4x43detEv, __ZL21BuildEmptyCubeTexturePKci11ColorRGBA3217TextureColorSpace: __ZL21BuildEmptyCubeTexturePKci11ColorRGBA3217TextureColorSpace, __ZN14VelocityModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff: __ZN14VelocityModule25CalculateProceduralBoundsER10MinMaxAABBRK10Matrix4x4ff, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReaddEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReaddEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __Z38Font_CUSTOM_RequestCharactersInTextureP12Il2CppObjectP12Il2CppStringii: __Z38Font_CUSTOM_RequestCharactersInTextureP12Il2CppObjectP12Il2CppStringii, __ZN5physx6shdfnd10Foundation13setErrorLevelENS_11PxErrorCode4EnumE: __ZN5physx6shdfnd10Foundation13setErrorLevelENS_11PxErrorCode4EnumE, __ZN5Unity5Cloth10SetEnabledEb: __ZN5Unity5Cloth10SetEnabledEb, __Z34Display_CUSTOM_ActivateDisplayImpl13Il2Cpp_IntPtriii: __Z34Display_CUSTOM_ActivateDisplayImpl13Il2Cpp_IntPtriii, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_8CapsuleVEED0Ev, __ZNK5physx13NpVolumeCache10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf: __ZNK5physx13NpVolumeCache10multiQueryINS_10PxSweepHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf, __ZN9Heightmap23RecalculateMinMaxHeightEiii: __ZN9Heightmap23RecalculateMinMaxHeightEiii, __ZN5physx12NpConstraint15updateConstantsEv: __ZN5physx12NpConstraint15updateConstantsEv, __Z51Register_UnityEngine_Compass_INTERNAL_get_rawVectorv: __Z51Register_UnityEngine_Compass_INTERNAL_get_rawVectorv, __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateUpdateCaptureScreenshotstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN43PostLateUpdateUpdateCaptureScreenshotstruct7ForwardEv, __ZN14BillboardAsset11SetVerticesEPK8Vector2fj: __ZN14BillboardAsset11SetVerticesEPK8Vector2fj, __ZN5Umbra20RuntimeTomeGenerator6Result5clearEb: __ZN5Umbra20RuntimeTomeGenerator6Result5clearEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj46ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj46ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN4FMOD4DSPI11setDefaultsEfffi: __ZN4FMOD4DSPI11setDefaultsEfffi, __Z38getPxParticleBase_SimulationFilterDataPKN5physx14PxParticleBaseE: __Z38getPxParticleBase_SimulationFilterDataPKN5physx14PxParticleBaseE, __ZN5physx28solveConcludeContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx28solveConcludeContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff: __ZNK5physx2Gu15HeightFieldUtil24getFaceIndexAtShapePointEff, __ZN5physx2Sc16InteractionSceneC2ERNS0_5SceneE: __ZN5physx2Sc16InteractionSceneC2ERNS0_5SceneE, __Z48Register_UnityEngine_SpringJoint_get_maxDistancev: __Z48Register_UnityEngine_SpringJoint_get_maxDistancev, __ZN9TextAssetD0Ev: __ZN9TextAssetD0Ev, __ZN13WebCamTextureD2Ev: __ZN13WebCamTextureD2Ev, __Z40WheelCollider_Get_Custom_PropMotorTorqueP12Il2CppObject: __Z40WheelCollider_Get_Custom_PropMotorTorqueP12Il2CppObject, __ZN21ExecutionOrderManagerC2Ev: __ZN21ExecutionOrderManagerC2Ev, __ZN5physx18PxsDynamicsContext10solveGroupERNS_16PxsThreadContextERKNS_16PxsIslandObjectsERKNS_16PxsIslandIndicesERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjj: __ZN5physx18PxsDynamicsContext10solveGroupERNS_16PxsThreadContextERKNS_16PxsIslandObjectsERKNS_16PxsIslandIndicesERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEjj, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeZv, __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15LightProbeGroup23VirtualRedirectTransferER14SafeBinaryRead: __ZN15LightProbeGroup23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx9NpFactory21onArticulationReleaseEPNS_14PxArticulationE: __ZN5physx9NpFactory21onArticulationReleaseEPNS_14PxArticulationE, __ZN13NavMeshParams8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13NavMeshParams8TransferI24GenerateTypeTreeTransferEEvRT_, _unity_z_tr_flush_block: _unity_z_tr_flush_block, __ZN7Terrain15ThreadedCleanupEv: __ZN7Terrain15ThreadedCleanupEv, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5ebackEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5ebackEv, __ZN10Matrix3x3f7SetZeroEv: __ZN10Matrix3x3f7SetZeroEv, __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_FT_Stroker_EndSubPath: _UNITY_FT_Stroker_EndSubPath, __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_, __ZN5physx3Scb5Scene23addStaticAndShapesToPvdERNS0_11RigidStaticE: __ZN5physx3Scb5Scene23addStaticAndShapesToPvdERNS0_11RigidStaticE, _saveSetjmp: _saveSetjmp, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED2Ev: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED2Ev, __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE: __ZN5physx12maxdirsteridINS_6float3EEEiPKT_iRS3_RNS_12hullLibArray5ArrayIiEE, __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12WheelJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13ScreenManager20SetScreenOrientationE17ScreenOrientation: __ZN13ScreenManager20SetScreenOrientationE17ScreenOrientation, _Vertical_Sweep_Drop: _Vertical_Sweep_Drop, __ZNK15FileSystemEntry8FilenameEv: __ZNK15FileSystemEntry8FilenameEv, __ZNK5physx22PxVehicleWheelsSimData20getWheelShapeMappingEj: __ZNK5physx22PxVehicleWheelsSimData20getWheelShapeMappingEj, __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_S5_T_, __ZN20GpuProgramParameters14AddMatrixParamEPKcii15ShaderParamTypeiiiP16PropertyNamesSet: __ZN20GpuProgramParameters14AddMatrixParamEPKcii15ShaderParamTypeiiiP16PropertyNamesSet, __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterSystemv: __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterSystemv, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZMultiplierv, __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj, __Z38Register_UnityEngine_Event_get_rawTypev: __Z38Register_UnityEngine_Event_get_rawTypev, __ZN8Animator19SetVisibleRenderersEb: __ZN8Animator19SetVisibleRenderersEb, __ZN2gl22WebGLGetCurrentContextEv: __ZN2gl22WebGLGetCurrentContextEv, __Z29LightmapSettings_CUSTOM_Resetv: __Z29LightmapSettings_CUSTOM_Resetv, __ZN9AudioClip9LoadSoundEv: __ZN9AudioClip9LoadSoundEv, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_27TriggerTraceSegmentCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_27TriggerTraceSegmentCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_, __Z42Physics2D_Set_Custom_PropContactArrowScalef: __Z42Physics2D_Set_Custom_PropContactArrowScalef, __ZNSt3__26locale8__globalEv: __ZNSt3__26locale8__globalEv, __Z36Gyroscope_CUSTOM_getEnabled_Internali: __Z36Gyroscope_CUSTOM_getEnabled_Internali, __Z40UnityAnalyticsHandler_CUSTOM_FlushEventsP12Il2CppObject: __Z40UnityAnalyticsHandler_CUSTOM_FlushEventsP12Il2CppObject, __ZN9dtNavMesh4initEPK15dtNavMeshParams: __ZN9dtNavMesh4initEPK15dtNavMeshParams, __Z46AnimationClip_CUSTOM_INTERNAL_CALL_ClearCurvesP12Il2CppObject: __Z46AnimationClip_CUSTOM_INTERNAL_CALL_ClearCurvesP12Il2CppObject, __ZN5physx11Adjacencies4LoadERNS_13PxInputStreamE: __ZN5physx11Adjacencies4LoadERNS_13PxInputStreamE, __Z46RenderSettings_Get_Custom_PropAmbientIntensityv: __Z46RenderSettings_Get_Custom_PropAmbientIntensityv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj160ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj160ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Sc10ClothShapeC2ERNS0_8ClothSimE: __ZN5physx2Sc10ClothShapeC2ERNS0_8ClothSimE, __ZNK5physx3Scb5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE: __ZNK5physx3Scb5Scene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE, __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx14SapPairManager10RemovePairEjj: __ZN5physx14SapPairManager10RemovePairEjj, __ZN5Umbra9RasterOps15rasterizePortalERNS_17BlockRasterBufferERKNS_8Vector4iERKNS_5VQuadERKNS_11AxisNormalsERKS1_: __ZN5Umbra9RasterOps15rasterizePortalERNS_17BlockRasterBufferERKNS_8Vector4iERKNS_5VQuadERKNS_11AxisNormalsERKS1_, __ZN19CharacterController13AwakeFromLoadE17AwakeFromLoadMode: __ZN19CharacterController13AwakeFromLoadE17AwakeFromLoadMode, __ZN19ParticleSystemState8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19ParticleSystemState8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13AnimationClipD0Ev: __ZN13AnimationClipD0Ev, __ZN8Animator13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8Animator13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE13getActorFlagsEv, __ZN7mecanim12statemachine36GetTransitionInterruptionSourceCountE28TransitionInterruptionSource: __ZN7mecanim12statemachine36GetTransitionInterruptionSourceCountE28TransitionInterruptionSource, __Z45QualitySettings_Get_Custom_PropSoftVegetationv: __Z45QualitySettings_Get_Custom_PropSoftVegetationv, __ZN22ProceduralMaterialData18SetAllOutputsDirtyEb: __ZN22ProceduralMaterialData18SetAllOutputsDirtyEb, __ZN17GeneralConnection14NetworkMessage11SetDataSizeEj: __ZN17GeneralConnection14NetworkMessage11SetDataSizeEj, __ZNK10Collider2D12OverlapPointERK8Vector2f: __ZNK10Collider2D12OverlapPointERK8Vector2f, __Z35setPxVehicleDriveSimData4W_DiffDataPN5physx23PxVehicleDriveSimData4WERKNS_27PxVehicleDifferential4WDataE: __Z35setPxVehicleDriveSimData4W_DiffDataPN5physx23PxVehicleDriveSimData4WERKNS_27PxVehicleDifferential4WDataE, __ZN21VertexDeclarationGLESD0Ev: __ZN21VertexDeclarationGLESD0Ev, __Z41ComputeShader_CUSTOM_SetTextureFromGlobalP12Il2CppObjectiii: __Z41ComputeShader_CUSTOM_SetTextureFromGlobalP12Il2CppObjectiii, __ZN5audio5mixer18AudioMixerConstant8TransferI14SafeBinaryReadEEvRT_: __ZN5audio5mixer18AudioMixerConstant8TransferI14SafeBinaryReadEEvRT_, __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, ___lgammaf_r: ___lgammaf_r, __ZNK5physx3Cct13BoxController11getUserDataEv: __ZNK5physx3Cct13BoxController11getUserDataEv, __ZN12LightsModule9ResetSeedERK27ParticleSystemReadOnlyState: __ZN12LightsModule9ResetSeedERK27ParticleSystemReadOnlyState, __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN6Camera16StandaloneRenderENS_10RenderFlagEP6ShaderRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN4FMOD5Sound17set3DConeSettingsEfff: __ZN4FMOD5Sound17set3DConeSettingsEfff, __Z36Collider2D_Get_Custom_PropBouncinessP12Il2CppObject: __Z36Collider2D_Get_Custom_PropBouncinessP12Il2CppObject, __ZL23RegisterModuleICalls_AIv: __ZL23RegisterModuleICalls_AIv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags, __ZN14SpriteRenderer5ResetEv: __ZN14SpriteRenderer5ResetEv, __ZN5physx5cloth7Factory13createFactoryENS1_8PlatformEPv: __ZN5physx5cloth7Factory13createFactoryENS1_8PlatformEPv, __ZN7VRInput27ClearAllReferenceTransformsEv: __ZN7VRInput27ClearAllReferenceTransformsEv, __ZN7mecanim9animation14ValuesFromClipERKNS_10ValueArrayERKNS0_18ClipMuscleConstantERKNS0_10ClipOutputERKNS0_12ClipBindingsEiRS1_RNS_14ValueArrayMaskEb: __ZN7mecanim9animation14ValuesFromClipERKNS_10ValueArrayERKNS0_18ClipMuscleConstantERKNS0_10ClipOutputERKNS0_12ClipBindingsEiRS1_RNS_14ValueArrayMaskEb, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetAnimationTypev: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetAnimationTypev, __Z49NavMeshAgent_Set_Custom_PropObstacleAvoidanceTypeP12Il2CppObject21ObstacleAvoidanceType: __Z49NavMeshAgent_Set_Custom_PropObstacleAvoidanceTypeP12Il2CppObject21ObstacleAvoidanceType, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7ReleaseEPS2_: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEE7ReleaseEPS2_, __ZN5physx10PxBaseTaskD0Ev: __ZN5physx10PxBaseTaskD0Ev, __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_: __ZN4FMOD5Sound9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_, __ZN14ParticleSystem13AwakeFromLoadE17AwakeFromLoadMode: __ZN14ParticleSystem13AwakeFromLoadE17AwakeFromLoadMode, __ZN7mecanim4hand12PhalangeNameEj: __ZN7mecanim4hand12PhalangeNameEj, __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_GetMatrixv: __Z52Register_UnityEngine_GUIClip_INTERNAL_CALL_GetMatrixv, __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_6PxVec3EEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __ZNK5physx14NpArticulation22getSeparationToleranceEv: __ZNK5physx14NpArticulation22getSeparationToleranceEv, __Z42Physics_Set_Custom_PropQueriesHitBackfacesh: __Z42Physics_Set_Custom_PropQueriesHitBackfacesh, __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx3Ext20ProfileZoneInterface17handleBufferFlushEPKhj: __ZN5physx3Ext20ProfileZoneInterface17handleBufferFlushEPKhj, __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN29TriggerModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN29TriggerModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN12NavMeshAgent13AwakeFromLoadE17AwakeFromLoadMode: __ZN12NavMeshAgent13AwakeFromLoadE17AwakeFromLoadMode, __ZN13RuntimeStaticI12EventManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI12EventManagerE13StaticDestroyEPv, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN14DetailDatabase28GenerateTextureAtlasThreadedEv: __ZN14DetailDatabase28GenerateTextureAtlasThreadedEv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__get_white_spaceERS4_S4_RjRKNS_5ctypeIcEE, __ZNK8VRDevice22GetOverrideFieldOfViewEv: __ZNK8VRDevice22GetOverrideFieldOfViewEv, _UNITY_png_chunk_error: _UNITY_png_chunk_error, __ZN14PhysicMaterial7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14PhysicMaterial7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sn18RepXCollectionImpl21instantiateCollectionERNS_23PxRepXInstantiationArgsERNS_12PxCollectionE: __ZN5physx2Sn18RepXCollectionImpl21instantiateCollectionERNS_23PxRepXInstantiationArgsERNS_12PxCollectionE, __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_: __ZN13RenderTexture6CreateERK12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES6_, _jpeg_CreateCompress: _jpeg_CreateCompress, __ZNK5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4sizeEv: __ZNK5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE4sizeEv, __ZN23iPhoneLocalNotificationC2ERKS_: __ZN23iPhoneLocalNotificationC2ERKS_, __ZNK2UI13RectTransform25CalculateRectInLocalSpaceEv: __ZNK2UI13RectTransform25CalculateRectInLocalSpaceEv, _cf2_decoder_parse_charstrings: _cf2_decoder_parse_charstrings, __ZN11AudioFilter7CleanupEv: __ZN11AudioFilter7CleanupEv, __Z18SRGB_GammaToLinearR14ImageReference: __Z18SRGB_GammaToLinearR14ImageReference, __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_set_motorv: __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_set_motorv, __ZN5Umbra9FloatList6setPtrEPf: __ZN5Umbra9FloatList6setPtrEPf, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE15growAndPushBackERKS2_, __Z44DownloadHandlerBuffer_CUSTOM_InternalGetTextP12Il2CppObject: __Z44DownloadHandlerBuffer_CUSTOM_InternalGetTextP12Il2CppObject, __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA4444EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA4444EEvPKNS_9InnerInfoE, __ZN7mecanim9animation18PrecomputeFreeformEiRNS0_19Blend2dDataConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation18PrecomputeFreeformEiRNS0_19Blend2dDataConstantERNS_6memory9AllocatorE, __ZN10AtomicList3TagEv: __ZN10AtomicList3TagEv, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6assignIPiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20NavMeshObstacleShapeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead20NavMeshObstacleShapeEvRT_RT0_PKc17TransferMetaFlags, __Z24RegisterStrippedTypeInfoI17PolygonCollider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI17PolygonCollider2DEviPKcS2_, __ZNSt11logic_errorD2Ev: __ZNSt11logic_errorD2Ev, __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb: __ZN5physx10PxsContext16updateBroadPhaseEPNS_10PxBaseTaskEb, __Z53Register_UnityEngine_ParticleRenderer_get_lengthScalev: __Z53Register_UnityEngine_ParticleRenderer_get_lengthScalev, _Round_To_Half_Grid: _Round_To_Half_Grid, __ZN10AudioMixer18PatchLiveLinkValueEjjf: __ZN10AudioMixer18PatchLiveLinkValueEjjf, __ZNK22GenericPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK22GenericPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN17SurfaceEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17SurfaceEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN25ParticleSystemGeometryJob12ScheduleJobsEPP12BaseRendererjPK6CameraRK10Matrix4x4f: __ZN25ParticleSystemGeometryJob12ScheduleJobsEPP12BaseRendererjPK6CameraRK10Matrix4x4f, __ZN12TLSAllocatorI14StackAllocatorE10ReallocateEPvji: __ZN12TLSAllocatorI14StackAllocatorE10ReallocateEPvji, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumConvexesEv, __Z28Rigidbody2D_CUSTOM_AddTorqueP12Il2CppObjectfN11Rigidbody2D9ForceModeE: __Z28Rigidbody2D_CUSTOM_AddTorqueP12Il2CppObjectfN11Rigidbody2D9ForceModeE, __ZNK13RendererScene20GetStaticObjectCountEv: __ZNK13RendererScene20GetStaticObjectCountEv, __Z50Register_UnityEngine_WheelCollider_set_brakeTorquev: __Z50Register_UnityEngine_WheelCollider_set_brakeTorquev, __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b: __Z25b2CollidePolygonAndCircleP10b2ManifoldPK14b2PolygonShapeRK11b2TransformPK13b2CircleShapeS6_b, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv, __ZNK5physx2Sc10NPhaseCore39getDefaultContactReportStreamBufferSizeEv: __ZNK5physx2Sc10NPhaseCore39getDefaultContactReportStreamBufferSizeEv, __ZN13GfxDeviceGLES23UnregisterNativeTextureE9TextureID: __ZN13GfxDeviceGLES23UnregisterNativeTextureE9TextureID, __ZN9Texture3D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Texture3D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15TextureSettings16CheckConsistencyEv: __ZN15TextureSettings16CheckConsistencyEv, __Z24RegisterStrippedTypeInfoI9TransformEviPKcS2_: __Z24RegisterStrippedTypeInfoI9TransformEviPKcS2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi15EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi15EEEEvRT_17TransferMetaFlags, __Z53Register_UnityEngine_LightmapSettings_get_lightProbesv: __Z53Register_UnityEngine_LightmapSettings_get_lightProbesv, __ZN11CustomArray10CheckArrayEm: __ZN11CustomArray10CheckArrayEm, __ZN7ApiGLES10GenTextureE16TextureDimension: __ZN7ApiGLES10GenTextureE16TextureDimension, __Z24RegisterStrippedTypeInfoI21AudioDistortionFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI21AudioDistortionFilterEviPKcS2_, __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf: __ZN15PolynomialCurve10BuildCurveERK17AnimationCurveTplIfEf, __ZN5physx3Scb14ParticleSystem12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE: __ZN5physx3Scb14ParticleSystem12setPositionsEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE, __ZN26b2PolygonAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN26b2PolygonAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN5physx20PxsParticleSystemSim32flushBufferedInteractionUpdatesVEv: __ZN5physx20PxsParticleSystemSim32flushBufferedInteractionUpdatesVEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI6ShaderENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN5physx29resetSerializationRegistryPtrEv: __ZN5physx29resetSerializationRegistryPtrEv, __ZNSt3__25mutex6unlockEv: __ZNSt3__25mutex6unlockEv, _unity_z_inflateSync: _unity_z_inflateSync, __Z14DecompressDXT3iiiPKjPj: __Z14DecompressDXT3iiiPKjPj, __ZN19SharedBillboardData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19SharedBillboardData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Unity10FixedJointD0Ev: __ZN5Unity10FixedJointD0Ev, __Z45ParticleSystem_TriggerModule_CUSTOM_GetInsideP12Il2CppObject: __Z45ParticleSystem_TriggerModule_CUSTOM_GetInsideP12Il2CppObject, __Z29Input_CUSTOM_GetJoystickNamesv: __Z29Input_CUSTOM_GetJoystickNamesv, __Z30getPxArticulationJoint_DampingPKN5physx19PxArticulationJointE: __Z30getPxArticulationJoint_DampingPKN5physx19PxArticulationJointE, __Z19ClearConsoleLogPathv: __Z19ClearConsoleLogPathv, __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYv: __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationYv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __Z49Register_UnityEngine_Renderer_get_lightProbeUsagev: __Z49Register_UnityEngine_Renderer_get_lightProbeUsagev, __Z54RenderSettings_CUSTOM_INTERNAL_get_ambientEquatorColorP10ColorRGBAf: __Z54RenderSettings_CUSTOM_INTERNAL_get_ambientEquatorColorP10ColorRGBAf, __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE16TransferTypelessEPjPKc17TransferMetaFlags, __ZN9Transform19FindPreviousSiblingEv: __ZN9Transform19FindPreviousSiblingEv, ___ftello_unlocked: ___ftello_unlocked, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj461ENS_22PxRepXPropertyAccessorILj461ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj461ENS_22PxRepXPropertyAccessorILj461ES4_ffEEEEvRKT0_, __Z42Register_UnityEngine_RectOffset_set_bottomv: __Z42Register_UnityEngine_RectOffset_set_bottomv, __ZN16ParticleAnimator8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16ParticleAnimator8TransferI24GenerateTypeTreeTransferEEvRT_, __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8Gradient8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z39Physics_CUSTOM_INTERNAL_CALL_BoxCastAllRK8Vector3fS1_S1_RK11Quaternionffi23QueryTriggerInteraction: __Z39Physics_CUSTOM_INTERNAL_CALL_BoxCastAllRK8Vector3fS1_S1_RK11Quaternionffi23QueryTriggerInteraction, __ZN5physx23PxsSolverSetupSolveTaskD0Ev: __ZN5physx23PxsSolverSetupSolveTaskD0Ev, __Z39LocationService_Get_Custom_PropLastDataP12Il2CppObject: __Z39LocationService_Get_Custom_PropLastDataP12Il2CppObject, _tt_cmap4_char_map_linear: _tt_cmap4_char_map_linear, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4syncEv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4syncEv, __ZN17GeneralConnection7CleanupEv: __ZN17GeneralConnection7CleanupEv, __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags, __ZN13MemoryManager30ReallowAllocationsOnThisThreadEv: __ZN13MemoryManager30ReallowAllocationsOnThisThreadEv, __ZNK11AudioSource18GetSpatialBlendMixEv: __ZNK11AudioSource18GetSpatialBlendMixEv, __ZNK6Sprite13GetRenderDataEb: __ZNK6Sprite13GetRenderDataEb, __ZNK7Cubemap16GetSourceTextureE11CubemapFace: __ZNK7Cubemap16GetSourceTextureE11CubemapFace, _sep_downsample: _sep_downsample, __ZN12_GLOBAL__N_112RenderReaderILb0EE7hasDataEv: __ZN12_GLOBAL__N_112RenderReaderILb0EE7hasDataEv, __ZN5physx18PxFixedJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx18PxFixedJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __Z31GUIText_Set_Custom_PropRichTextP12Il2CppObjecth: __Z31GUIText_Set_Custom_PropRichTextP12Il2CppObjecth, __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeXMultiplierP12Il2CppObjectf: __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeXMultiplierP12Il2CppObjectf, _UNITY_FT_Init_Class_cff_service_cid_info: _UNITY_FT_Init_Class_cff_service_cid_info, __ZNK13TranslateGLES20GetTextureSRGBDecodeEN2gl17TextureSrgbDecodeE: __ZNK13TranslateGLES20GetTextureSRGBDecodeEN2gl17TextureSrgbDecodeE, __ZN5physx2Sq12BucketPruner13removeObjectsEPKjj: __ZN5physx2Sq12BucketPruner13removeObjectsEPKjj, __ZN5Unity5Joint31SetAutoConfigureConnectedAnchorEb: __ZN5Unity5Joint31SetAutoConfigureConnectedAnchorEb, __Z65Register_UnityEngine_GeometryUtility_INTERNAL_CALL_TestPlanesAABBv: __Z65Register_UnityEngine_GeometryUtility_INTERNAL_CALL_TestPlanesAABBv, __ZN15SerializeTraitsINSt3__24pairI8UnityStriEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStriEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS3_RT_, __ZN8Animator9SetTargetEif: __ZN8Animator9SetTargetEif, __ZNKSt3__220__codecvt_utf8_utf16IDiE13do_max_lengthEv: __ZNKSt3__220__codecvt_utf8_utf16IDiE13do_max_lengthEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxJointLinearLimitEE12readPropertyIfEEbRT_, _getresgid: _getresgid, __Z24IsAlphaOnlyTextureFormat13TextureFormat: __Z24IsAlphaOnlyTextureFormat13TextureFormat, __ZN13AnimationClip13AddEulerCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN13AnimationClip13AddEulerCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZN4Mesh25RecalculateBoundsInternalEv: __ZN4Mesh25RecalculateBoundsInternalEv, __ZN12HeaderHelper13SetAllHeadersEPKcj: __ZN12HeaderHelper13SetAllHeadersEPKcj, _UNITY_FT_Stream_ExitFrame: _UNITY_FT_Stream_ExitFrame, __Z41AnimationCurve_Set_Custom_PropPreWrapModeP12Il2CppObjecti: __Z41AnimationCurve_Set_Custom_PropPreWrapModeP12Il2CppObjecti, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEvPT_jRKT0_RKT1_j, __ZN9dtNavMesh25clearAllOffMeshConnectionEv: __ZN9dtNavMesh25clearAllOffMeshConnectionEv, __ZN14MemoryProfiler18PushAllocationRootEPvP13BaseAllocatorb: __ZN14MemoryProfiler18PushAllocationRootEPvP13BaseAllocatorb, __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _bitshift64Shl: _bitshift64Shl, __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetAlphaAffectsIntensityv: __Z73Register_UnityEngine_ParticleSystem_LightsModule_GetAlphaAffectsIntensityv, __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SpeedTreeWind16SBranchWindLevel8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZZ16InitClothManagervEN45PostLateUpdatePhysicsSkinnedClothUpdatestruct7ForwardEv: __ZZ16InitClothManagervEN45PostLateUpdatePhysicsSkinnedClothUpdatestruct7ForwardEv, _deflate_stored: _deflate_stored, __ZN7Cursors9SetCursorEP9Texture2D8Vector2f10CursorMode: __ZN7Cursors9SetCursorEP9Texture2D8Vector2f10CursorMode, _start_pass_main_29: _start_pass_main_29, __ZNSt3__26locale7classicEv: __ZNSt3__26locale7classicEv, __Z39PolygonCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray: __Z39PolygonCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray, __Z24Sprite_Get_Custom_PropUvP12Il2CppObject: __Z24Sprite_Get_Custom_PropUvP12Il2CppObject, __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode: __ZN12BaseRenderer17FlattenCommonDataERS_RK13TransformInfofR10RenderNode, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setProfileZoneManagerEPNS_20PxProfileZoneManagerE, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERPKc: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERPKc, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7GetFreeEi: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7GetFreeEi, __Z19GetAnimationManagerv: __Z19GetAnimationManagerv, __ZN5physx14NpSpatialIndex6updateEjRKNS_9PxBounds3E: __ZN5physx14NpSpatialIndex6updateEjRKNS_9PxBounds3E, __Z13TransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_: __Z13TransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_, __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11AudioSource23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z39Renderer_Get_Custom_PropLightProbeUsageP12Il2CppObject: __Z39Renderer_Get_Custom_PropLightProbeUsageP12Il2CppObject, __ZN18ScriptingArguments11GetStringAtEi: __ZN18ScriptingArguments11GetStringAtEi, __ZNK5physx14NpArticulation10getNbLinksEv: __ZNK5physx14NpArticulation10getNbLinksEv, __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z25FindAncestorComponentImplR10GameObjecti: __Z25FindAncestorComponentImplR10GameObjecti, _tt_cmap2_validate: _tt_cmap2_validate, __ZN5physx2Sq12BucketPruner6commitEv: __ZN5physx2Sq12BucketPruner6commitEv, __ZL15CompareVerticesRK8Vector2fS1_: __ZL15CompareVerticesRK8Vector2fS1_, __ZN12FlareManager17LoadFlareMaterialEv: __ZN12FlareManager17LoadFlareMaterialEv, __Z29ComputeShader_CUSTOM_DispatchP12Il2CppObjectiiii: __Z29ComputeShader_CUSTOM_DispatchP12Il2CppObjectiiii, __ZL23ProgramUniformMatrix4fvPK7ApiGLESjiihPKv: __ZL23ProgramUniformMatrix4fvPK7ApiGLESjiihPKv, __ZNK11AudioSource24EvaluateAttenuationCurveEf: __ZNK11AudioSource24EvaluateAttenuationCurveEf, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv, __Z39Register_UnityEngine_Animation_set_clipv: __Z39Register_UnityEngine_Animation_set_clipv, __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z29StdTemplateConversionFunctionIyyEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyyEbPvR14SafeBinaryRead, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl18getPropertyMessageEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl18getPropertyMessageEN5physx8debugger18NonNegativeIntegerE, _modf: _modf, __ZN20UnityConnectSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN20UnityConnectSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__28ios_base7copyfmtERKS0_: __ZNSt3__28ios_base7copyfmtERKS0_, __Z41GUIUtility_CUSTOM_Internal_GetBuiltinSkini: __Z41GUIUtility_CUSTOM_Internal_GetBuiltinSkini, __ZNKSt3__217moneypunct_bynameIcLb0EE16do_positive_signEv: __ZNKSt3__217moneypunct_bynameIcLb0EE16do_positive_signEv, _getpgrp: _getpgrp, __ZN5physx2Sq11PruningPoolC2Ev: __ZN5physx2Sq11PruningPoolC2Ev, __ZNK5Umbra9Matrix4x4eqERKS0_: __ZNK5Umbra9Matrix4x4eqERKS0_, __Z31setPxVehicleEngineDataMMaxOmegaPN5physx19PxVehicleEngineDataEf: __Z31setPxVehicleEngineDataMMaxOmegaPN5physx19PxVehicleEngineDataEf, __ZN26AnimatorControllerPlayable13GenerateGraphEv: __ZN26AnimatorControllerPlayable13GenerateGraphEv, __ZN11UmbraModule18CreateShadowCullerEv: __ZN11UmbraModule18CreateShadowCullerEv, __Z38Application_Get_Custom_PropAbsoluteURLv: __Z38Application_Get_Custom_PropAbsoluteURLv, __ZN9Behaviour18UpdateEnabledStateEb: __ZN9Behaviour18UpdateEnabledStateEb, __Z31DoCalculateAnimatorSkinMatricesP25CalculateSkinMatricesTask: __Z31DoCalculateAnimatorSkinMatricesP25CalculateSkinMatricesTask, __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI9Texture2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu10ConvexMeshD0Ev: __ZN5physx2Gu10ConvexMeshD0Ev, _unity_z_uncompress: _unity_z_uncompress, __ZL20ForwardRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL20ForwardRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZL17CreateLogoPresetsj: __ZL17CreateLogoPresetsj, __ZN9ShaderLab20SerializedSubProgramD2Ev: __ZN9ShaderLab20SerializedSubProgramD2Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags, __Z13RegisterClassIN13TextRendering4FontEEvv: __Z13RegisterClassIN13TextRendering4FontEEvv, __ZN12GUIClipState6UnclipERK5RectTIfE: __ZN12GUIClipState6UnclipERK5RectTIfE, __ZNKSt3__220__time_get_c_storageIwE3__xEv: __ZNKSt3__220__time_get_c_storageIwE3__xEv, __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns: __Z15RenderLightGeomR9GfxDeviceRK6CameraRK11ActiveLightRK8Vector3fRK10Matrix4x4fbPK14ChannelAssigns, __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerIDv: __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerIDv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP16RenderObjectDatai25RenderPrePassObjectSorterEEvT_S4_T0_T1_, __Z36Cloth_Set_Custom_PropSphereCollidersP12Il2CppObjectP11Il2CppArray: __Z36Cloth_Set_Custom_PropSphereCollidersP12Il2CppObjectP11Il2CppArray, __Z63Register_UnityEngine_AnimationClip_Internal_CreateAnimationClipv: __Z63Register_UnityEngine_AnimationClip_Internal_CreateAnimationClipv, __Z51Register_UnityEngine_TrailRenderer_get_autodestructv: __Z51Register_UnityEngine_TrailRenderer_get_autodestructv, __Z6AppendPKcS0_: __Z6AppendPKcS0_, __ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv: __ZNK12TLSAllocatorI14StackAllocatorE19GetCurrentAllocatorEv, __ZN7dtCrowd14RemoveObstacleER13dtCrowdHandle: __ZN7dtCrowd14RemoveObstacleER13dtCrowdHandle, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES7_PNS8_IT0_EE: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EES7_PNS8_IT0_EE, __ZN13GfxDeviceGLES15InvalidateStateEv: __ZN13GfxDeviceGLES15InvalidateStateEv, __ZN12_GLOBAL__N_122SocketNetworkOutStream10disconnectEv: __ZN12_GLOBAL__N_122SocketNetworkOutStream10disconnectEv, __ZL35InitializeAnimationScriptingClassesv: __ZL35InitializeAnimationScriptingClassesv, __ZN5physx7NpScene11addMaterialERNS_10NpMaterialE: __ZN5physx7NpScene11addMaterialERNS_10NpMaterialE, __Z45Register_UnityEngine_OcclusionPortal_get_openv: __Z45Register_UnityEngine_OcclusionPortal_get_openv, __Z67Register_UnityEngine_AI_NavMeshObstacle_get_carvingTimeToStationaryv: __Z67Register_UnityEngine_AI_NavMeshObstacle_get_carvingTimeToStationaryv, __Z36getPxSceneDescMaxNbContactDataBlocksPKN5physx11PxSceneDescE: __Z36getPxSceneDescMaxNbContactDataBlocksPKN5physx11PxSceneDescE, __ZN7mecanim9animation9GetCycleXERKN4math4trsXES4_S4_if: __ZN7mecanim9animation9GetCycleXERKN4math4trsXES4_S4_if, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags, __ZNK2UI6Canvas30GetSortingBucketNormalizedSizeEv: __ZNK2UI6Canvas30GetSortingBucketNormalizedSizeEv, __ZNSt3__212strstreambufC2EPciS1_: __ZNSt3__212strstreambufC2EPciS1_, __ZN15Cast2DQueryBase19ConvertToRaycastHitERNS_14FixtureContactEP12RaycastHit2D: __ZN15Cast2DQueryBase19ConvertToRaycastHitERNS_14FixtureContactEP12RaycastHit2D, __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_: __ZZNK5physx2Sq8AABBTree4walkEPFbPKNS0_12AABBTreeNodeEjPvES5_EN5Local5_walkES4_S4_RjS9_S7_S5_, __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL27GetComponentsImplementationILb0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z39Camera_CUSTOM_INTERNAL_CALL_ResetAspectP12Il2CppObject: __Z39Camera_CUSTOM_INTERNAL_CALL_ResetAspectP12Il2CppObject, __ZNKSt3__210moneypunctIwLb1EE13positive_signEv: __ZNKSt3__210moneypunctIwLb1EE13positive_signEv, _decode_mcu: _decode_mcu, __Z30Shader_CUSTOM_WarmupAllShadersv: __Z30Shader_CUSTOM_WarmupAllShadersv, __ZN5physx2Sn20getBinaryPlatformTagEv: __ZN5physx2Sn20getBinaryPlatformTagEv, __ZN18b2FrictionJointDef10InitializeEP6b2BodyS1_RK6b2Vec2: __ZN18b2FrictionJointDef10InitializeEP6b2BodyS1_RK6b2Vec2, __Z55TerrainData_CUSTOM_Internal_GetMinimumBaseMapResolutionv: __Z55TerrainData_CUSTOM_Internal_GetMinimumBaseMapResolutionv, __Z36Time_Set_Custom_PropCaptureFrameratei: __Z36Time_Set_Custom_PropCaptureFrameratei, __ZN7dtCrowd17requestMoveTargetERK13dtCrowdHandlePKf: __ZN7dtCrowd17requestMoveTargetERK13dtCrowdHandlePKf, __Z28Light_Set_Custom_PropShadowsP12Il2CppObjecti: __Z28Light_Set_Custom_PropShadowsP12Il2CppObjecti, __ZN11WindManager7GetListEv: __ZN11WindManager7GetListEv, __Z49Register_UnityEngine_Component_SendMessageUpwardsv: __Z49Register_UnityEngine_Component_SendMessageUpwardsv, __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp: __Z35scripting_method_get_argument_count21ScriptingMethodIl2Cpp, __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED1Ev: __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED1Ev, __ZN5physx20PxsParticleSystemSimD0Ev: __ZN5physx20PxsParticleSystemSimD0Ev, _Round_Down_To_Grid: _Round_Down_To_Grid, __ZN5physx2Sc19ConstraintGroupNode7getRootEv: __ZN5physx2Sc19ConstraintGroupNode7getRootEv, __ZNK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E: __ZNK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E, __ZN15AudioEchoFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15AudioEchoFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z19getPxD6Joint_MotionPKN5physx9PxD6JointENS_8PxD6Axis4EnumE: __Z19getPxD6Joint_MotionPKN5physx9PxD6JointENS_8PxD6Axis4EnumE, __ZNK5physx2Sn12PointerRemap12getObjectRefEyRj: __ZNK5physx2Sn12PointerRemap12getObjectRefEyRj, __Z14FindSceneRangeRK13dynamic_arrayI10SceneRangeLj4EERK9UnityGUID: __Z14FindSceneRangeRK13dynamic_arrayI10SceneRangeLj4EERK9UnityGUID, __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE9getShapesEPPNS_7PxShapeEjj: __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE9getShapesEPPNS_7PxShapeEjj, __Z43Register_UnityEngine_Texture_set_anisoLevelv: __Z43Register_UnityEngine_Texture_set_anisoLevelv, __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE19computeDriveInertiaERKNS_12PxcFsInertiaES5_PKNS_14PxcSIMDSpatialE: __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE19computeDriveInertiaERKNS_12PxcFsInertiaES5_PKNS_14PxcSIMDSpatialE, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE26getRelativeAngularVelocityEv, __ZN16RenderTextureMap6RemoveEPK17RenderSurfaceBase: __ZN16RenderTextureMap6RemoveEPK17RenderSurfaceBase, __ZN10GameObject8TransferI17RemapPPtrTransferEEvRT_: __ZN10GameObject8TransferI17RemapPPtrTransferEEvRT_, __Z56Register_UnityEngine_QualitySettings_get_maximumLODLevelv: __Z56Register_UnityEngine_QualitySettings_get_maximumLODLevelv, __ZNK5physx2Cm10Collection5getIdERKNS_6PxBaseE: __ZNK5physx2Cm10Collection5getIdERKNS_6PxBaseE, _UNITY_FT_Get_Char_Index: _UNITY_FT_Get_Char_Index, __ZN12ShaderErrors11ShaderErrorC2ERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_S9_iibb: __ZN12ShaderErrors11ShaderErrorC2ERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_S9_iibb, __Z25PxcClearContactCacheStatsv: __Z25PxcClearContactCacheStatsv, __ZN14StackAllocator13TryDeallocateEPv: __ZN14StackAllocator13TryDeallocateEPv, __Z60Register_UnityEngine_WheelCollider_set_forceAppPointDistancev: __Z60Register_UnityEngine_WheelCollider_set_forceAppPointDistancev, __Z36GeomOverlapCallback_PlaneHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z36GeomOverlapCallback_PlaneHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5physx2Gu12TriangleMesh12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx2Gu12TriangleMesh12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_10PxTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z21GetRenderModeSortBias15LightRenderMode: __Z21GetRenderModeSortBias15LightRenderMode, _wcscoll: _wcscoll, _UNITY_png_do_bgr: _UNITY_png_do_bgr, __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei: __ZNK12b2ChainShape12GetChildEdgeEP11b2EdgeShapei, __ZN20SoundChannelInstance19set3DMinMaxDistanceEff: __ZN20SoundChannelInstance19set3DMinMaxDistanceEff, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE11prepareDataEv, __ZN8GUIStyle8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8GUIStyle8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK8Animator13IsInitializedEv: __ZNK8Animator13IsInitializedEv, __ZN13TrailRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData: __ZN13TrailRenderer21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData, __Z34Joint_Get_Custom_PropConnectedBodyP12Il2CppObject: __Z34Joint_Get_Custom_PropConnectedBodyP12Il2CppObject, __Z21getPxCloth_ClothFlagsPKN5physx7PxClothE: __Z21getPxCloth_ClothFlagsPKN5physx7PxClothE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj91ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj91ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9Texture3D13RebuildMipMapEv: __ZN9Texture3D13RebuildMipMapEv, __Z18ConvertUTF8toUTF32PPKhS0_PPmS2_15ConversionFlags: __Z18ConvertUTF8toUTF32PPKhS0_PPmS2_15ConversionFlags, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEOS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEOS5_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv, __ZN12MeshRenderer17MainThreadCleanupEv: __ZN12MeshRenderer17MainThreadCleanupEv, __ZNSt3__215__get_classnameEPKcb: __ZNSt3__215__get_classnameEPKcb, __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_get_motorv: __Z53Register_UnityEngine_SliderJoint2D_INTERNAL_get_motorv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE8pushNameEPKc, __ZN5physx14PxsAABBManager15setVolumeBoundsEjRKNS_9PxBounds3E: __ZN5physx14PxsAABBManager15setVolumeBoundsEjRKNS_9PxBounds3E, __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb: __Z25SetLightProbeProxyVolumesR13BatchRendererRK27LightProbeProxyVolumeSampleb, __ZN14MemoryProfiler22GetRelatedIDMemorySizeEj: __ZN14MemoryProfiler22GetRelatedIDMemorySizeEj, __ZN15DistanceJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15DistanceJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_png_get_PLTE: _UNITY_png_get_PLTE, __ZNSt3__26locale5__imp12install_fromINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN18ScriptingArguments6AddIntEi: __ZN18ScriptingArguments6AddIntEi, __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs: __Z11BuildCurvesR16MinMaxPolyCurvesRK21MinMaxAnimationCurvesfs, __Z41Register_UnityEngine_Rigidbody2D_get_dragv: __Z41Register_UnityEngine_Rigidbody2D_get_dragv, __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED0Ev, __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc: __ZNK7ApiGLES10DebugLabelEN2gl10ObjectTypeEjiPKc, __Z10DecodeRGBMRK11ColorRGBA3210RGBMRanges: __Z10DecodeRGBMRK11ColorRGBA3210RGBMRanges, __Z31Joint_Set_Custom_PropBreakForceP12Il2CppObjectf: __Z31Joint_Set_Custom_PropBreakForceP12Il2CppObjectf, __Z36AudioSource_Get_Custom_PropMaxVolumeP12Il2CppObject: __Z36AudioSource_Get_Custom_PropMaxVolumeP12Il2CppObject, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j, __ZNK21EnlightenSceneMapping17GetProbesetHashesER13dynamic_arrayI7Hash128Lj8EE: __ZNK21EnlightenSceneMapping17GetProbesetHashesER13dynamic_arrayI7Hash128Lj8EE, __Z34Register_UnityEngine_Terrain_Flushv: __Z34Register_UnityEngine_Terrain_Flushv, __ZN5physx10NpMaterialD2Ev: __ZN5physx10NpMaterialD2Ev, __Z31AndroidJNI_CUSTOM_CallIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z31AndroidJNI_CUSTOM_CallIntMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNK5physx2Sq10AABBPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE: __ZNK5physx2Sq10AABBPruner5sweepERKNS0_9ShapeDataERKNS_6PxVec3ERfRNS0_14PrunerCallbackE, __ZN5physx23PxsFluidDynamicsSphTask11runInternalEv: __ZN5physx23PxsFluidDynamicsSphTask11runInternalEv, __ZN9Rigidbody16AddRelativeForceERK8Vector3fi: __ZN9Rigidbody16AddRelativeForceERK8Vector3fi, __Z44Register_UnityEngine_GameObject_set_isStaticv: __Z44Register_UnityEngine_GameObject_set_isStaticv, __ZN3MBP8finalizeEPN5physx16PxsBroadPhaseMBPE: __ZN3MBP8finalizeEPN5physx16PxsBroadPhaseMBPE, __Z58Register_UnityEngine_Application_get_genuineCheckAvailablev: __Z58Register_UnityEngine_Application_get_genuineCheckAvailablev, __Z46Register_UnityEngine_CullingGroup_QueryIndicesv: __Z46Register_UnityEngine_CullingGroup_QueryIndicesv, __ZN5physx8readWordEbRNS_13PxInputStreamE: __ZN5physx8readWordEbRNS_13PxInputStreamE, __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIiiEEPiEEvT0_S5_T_, __ZN7mecanim9animation24CreateBlendTreeWorkspaceEjRNS_6memory9AllocatorE: __ZN7mecanim9animation24CreateBlendTreeWorkspaceEjRNS_6memory9AllocatorE, __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EERN7mecanim6memory9AllocatorE: __ZN11UnityEngine9Animation26CreateAnimationSetBindingsERK13dynamic_arrayIP13AnimationClipLj4EERN7mecanim6memory9AllocatorE, __Z50Register_UnityEngine_ParticleSystem_Internal_Pausev: __Z50Register_UnityEngine_ParticleSystem_Internal_Pausev, _common: _common, __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIttEEPtEEjT0_S5_S5_T_, __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__26vectorIPN5physx15PxVehicleWheelsENS0_9allocatorIS4_EEEEE13StaticDestroyEPv, __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb: __ZL25ProcessAssetBundleEntriesR11AssetBundleNSt3__24pairINS1_14__map_iteratorINS1_15__tree_iteratorINS1_12__value_typeI8UnityStrNS_9AssetInfoEEEPNS1_11__tree_nodeIS8_PvEEiEEEESE_EEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EEb, __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z53Transform_CUSTOM_INTERNAL_CALL_InverseTransformVectorP12Il2CppObjectRK8Vector3fRS1_: __Z53Transform_CUSTOM_INTERNAL_CALL_InverseTransformVectorP12Il2CppObjectRK8Vector3fRS1_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZN13RuntimeStaticI21AssetReferenceStorageE16StaticInitializeEPv: __ZN13RuntimeStaticI21AssetReferenceStorageE16StaticInitializeEPv, __Z51ParticleSystemRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf: __Z51ParticleSystemRenderer_Set_Custom_PropVelocityScaleP12Il2CppObjectf, __ZNK5physx2Gu5RTree4saveERNS_14PxOutputStreamE: __ZNK5physx2Gu5RTree4saveERNS_14PxOutputStreamE, __ZNK13TargetJoint2D26GetTypeInfoVirtualInternalEv: __ZNK13TargetJoint2D26GetTypeInfoVirtualInternalEv, __ZN4FMOD3DSP13disconnectAllEbb: __ZN4FMOD3DSP13disconnectAllEbb, __ZN18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_: __ZN18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_, __Z36AudioSource_Set_Custom_PropMaxVolumeP12Il2CppObjectf: __Z36AudioSource_Set_Custom_PropMaxVolumeP12Il2CppObjectf, __ZN5Unity9Component26CalculateSupportedMessagesEv: __ZN5Unity9Component26CalculateSupportedMessagesEv, __ZN15DownloadHandlerD2Ev: __ZN15DownloadHandlerD2Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4PPtrI6AvatarE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI6AvatarE8TransferI14SafeBinaryReadEEvRT_, __Z5SlerpRK11QuaternionfS1_f: __Z5SlerpRK11QuaternionfS1_f, __Z20GetCommonStringTablev: __Z20GetCommonStringTablev, __Z46Register_UnityEngine_Debug_SetDiagnosticSwitchv: __Z46Register_UnityEngine_Debug_SetDiagnosticSwitchv, __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeP11Il2CppArray: __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeP11Il2CppArray, __ZN7mecanim12statemachine18GetTransitionCountENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE: __ZN7mecanim12statemachine18GetTransitionCountENS0_16TransitionSourceEPKNS0_20StateMachineConstantEPNS0_18StateMachineMemoryE, __Z39Material_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f: __Z39Material_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f, __Z41Register_UnityEngine_Collider_set_enabledv: __Z41Register_UnityEngine_Collider_set_enabledv, __ZN19RuntimeSceneManager31CollectDontDestroyOnLoadObjectsERNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE: __ZN19RuntimeSceneManager31CollectDontDestroyOnLoadObjectsERNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE, __Z41Rigidbody2D_Set_Custom_PropFreezeRotationP12Il2CppObjecth: __Z41Rigidbody2D_Set_Custom_PropFreezeRotationP12Il2CppObjecth, __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN11TypeManager17ClassIDToTypeInfoEi: __ZN11TypeManager17ClassIDToTypeInfoEi, __ZN5physx19PxcScratchAllocator5allocEjb: __ZN5physx19PxcScratchAllocator5allocEjb, __ZN16SpriteRenderData11SetVerticesEPK12SpriteVertexj: __ZN16SpriteRenderData11SetVerticesEPK12SpriteVertexj, __ZNK5physx15PxVehicleWheels8isKindOfEPKc: __ZNK5physx15PxVehicleWheels8isKindOfEPKc, __Z24RegisterStrippedTypeInfoI15AudioEchoFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI15AudioEchoFilterEviPKcS2_, __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12TreeDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx14PxsAABBManager17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE: __ZN5physx14PxsAABBManager17setStaticAABBDataEjRKNS_17PxcAABBDataStaticE, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18setConstraintFlagsENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __Z37GetBarycentricCoordinatesForOuterCellPPK8Vector3fRK13dynamic_arrayIS_Lj4EERS0_RK11TetrahedronR8Vector4fRf: __Z37GetBarycentricCoordinatesForOuterCellPPK8Vector3fRK13dynamic_arrayIS_Lj4EERS0_RK11TetrahedronR8Vector4fRf, __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __Z37TextMesh_Set_Custom_PropCharacterSizeP12Il2CppObjectf: __Z37TextMesh_Set_Custom_PropCharacterSizeP12Il2CppObjectf, __Z13GrayscaleRampP9Texture2DPhiiii: __Z13GrayscaleRampP9Texture2DPhiiii, __ZN15SerializeTraitsI17SortingLayerEntryE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI17SortingLayerEntryE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN12ScriptMapper8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12ScriptMapper8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z45ParticleSystem_TrailModule_CUSTOM_SetLifetimeP12Il2CppObjectR15MonoMinMaxCurve: __Z45ParticleSystem_TrailModule_CUSTOM_SetLifetimeP12Il2CppObjectR15MonoMinMaxCurve, _UNITY_png_set_filter: _UNITY_png_set_filter, __ZN21OverlapCapsuleQuery2D13ReportFixtureEP9b2Fixture: __ZN21OverlapCapsuleQuery2D13ReportFixtureEP9b2Fixture, __Z18setPxShapeUserDataPN5physx7PxShapeEPv: __Z18setPxShapeUserDataPN5physx7PxShapeEPv, __ZThn4_NK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE: __ZThn4_NK5physx5cloth9SwFactory23extractVirtualParticlesERKNS0_5ClothENS0_5RangeIA4_jEENS5_INS_6PxVec3EEE, __ZNSt3__27promiseIvE28set_exception_at_thread_exitESt13exception_ptr: __ZNSt3__27promiseIvE28set_exception_at_thread_exitESt13exception_ptr, __ZN13GfxDeviceGLES14SetWorldMatrixERK10Matrix4x4f: __ZN13GfxDeviceGLES14SetWorldMatrixERK10Matrix4x4f, __ZN5Umbra15ShadowCullerExtC2Ev: __ZN5Umbra15ShadowCullerExtC2Ev, __ZN4FMOD6System19getHardwareChannelsEPi: __ZN4FMOD6System19getHardwareChannelsEPi, __ZNK9Heightmap15CalculateBoundsEiii: __ZNK9Heightmap15CalculateBoundsEiii, __ZL22stbir__filter_mitchellff: __ZL22stbir__filter_mitchellff, __ZN14CellVisualizer7executeEv: __ZN14CellVisualizer7executeEv, __Z56Register_UnityEngine_CanvasRenderer_get_popMaterialCountv: __Z56Register_UnityEngine_CanvasRenderer_get_popMaterialCountv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRd: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRd, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD12ChannelGroup18overrideSpeakerMixEffffffff: __ZN4FMOD12ChannelGroup18overrideSpeakerMixEffffffff, __ZN8Renderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8Renderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z53Register_UnityEngine_WebCamTexture_get_requestedWidthv: __Z53Register_UnityEngine_WebCamTexture_get_requestedWidthv, __ZN20UnityConnectSettings16CheckConsistencyEv: __ZN20UnityConnectSettings16CheckConsistencyEv, __ZN5audio5mixer26CopyExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPfi: __ZN5audio5mixer26CopyExposedParameterValuesERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryEPfi, __ZN15ParticleEmitter11CalcOffsetsEP8Vector3fP10Matrix3x3ff: __ZN15ParticleEmitter11CalcOffsetsEP8Vector3fP10Matrix3x3ff, __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_SetPixelv: __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_SetPixelv, __Z13RegisterClassI13SliderJoint2DEvv: __Z13RegisterClassI13SliderJoint2DEvv, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_13PxBoxGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_13PxBoxGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, __ZN5physx11AdjTriangle4FlipEv: __ZN5physx11AdjTriangle4FlipEv, __Z44Register_UnityEngine_Graphics_DrawProceduralv: __Z44Register_UnityEngine_Graphics_DrawProceduralv, __Z22getPxCloth_WakeCounterPKN5physx7PxClothE: __Z22getPxCloth_WakeCounterPKN5physx7PxClothE, __ZN21IntermediateRenderers5ClearEj: __ZN21IntermediateRenderers5ClearEj, __ZN17CapsuleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17CapsuleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE13SetDownloaderERNS0_14RestDownloaderE: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE13SetDownloaderERNS0_14RestDownloaderE, __ZN5physx34PxsSolverConstraintPostProcessTaskD0Ev: __ZN5physx34PxsSolverConstraintPostProcessTaskD0Ev, __ZN15DirectorManager31AddScheduledPlayableControllersEv: __ZN15DirectorManager31AddScheduledPlayableControllersEv, __ZN12_GLOBAL__N_120DefaultAssertHandlerclEPKcS2_iRb: __ZN12_GLOBAL__N_120DefaultAssertHandlerclEPKcS2_iRb, _UNITY_FT_Vector_Unit: _UNITY_FT_Vector_Unit, __Z15GetIApplicationv: __Z15GetIApplicationv, __ZN5physx3Ext26computeSphereInertiaTensorERNS_6PxVec3Effb: __ZN5physx3Ext26computeSphereInertiaTensorERNS_6PxVec3Effb, __ZN5physx14SapPairManager10RemovePairEjjjj: __ZN5physx14SapPairManager10RemovePairEjjjj, __ZN33SizeBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN33SizeBySpeedModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXDrivev: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_angularXDrivev, __ZN7ApiGLES11DrawCaptureE16GfxPrimitiveTypej: __ZN7ApiGLES11DrawCaptureE16GfxPrimitiveTypej, __ZN14AreaEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14AreaEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z18GetApplicationInfov: __Z18GetApplicationInfov, __ZN5physx8debugger14PvdMarshallingIadE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIadE12marshalBlockEPKhPhj, __Z19InterpolateKeyframeI8Vector3fET_RK11KeyframeTplIS1_ES5_f: __Z19InterpolateKeyframeI8Vector3fET_RK11KeyframeTplIS1_ES5_f, __ZN5physx13PxInputStreamD2Ev: __ZN5physx13PxInputStreamD2Ev, _UNITY_LZ4_compress_limitedOutput_withState: _UNITY_LZ4_compress_limitedOutput_withState, __ZNK17BaseWebCamTexture9GetDeviceEv: __ZNK17BaseWebCamTexture9GetDeviceEv, __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE: __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE, __ZN6Camera20SetTemporarySettingsERK23CameraTemporarySettings: __ZN6Camera20SetTemporarySettingsERK23CameraTemporarySettings, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESL_EERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE19__equal_range_multiIS2_EENS_4pairINS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEESL_EERKT_, __Z40Register_UnityEngine_Mesh_SetIndicesImplv: __Z40Register_UnityEngine_Mesh_SetIndicesImplv, __ZNK12NavMeshAgent27GetInternalAnimationPolyRefEv: __ZNK12NavMeshAgent27GetInternalAnimationPolyRefEv, __ZN17RemapPPtrTransfer8TransferI24OcclusionCullingSettingsEEvRT_PKc17TransferMetaFlags: __ZN17RemapPPtrTransfer8TransferI24OcclusionCullingSettingsEEvRT_PKc17TransferMetaFlags, __Z62Register_UnityEngine_Connect_UnityConnectSettings_set_testModev: __Z62Register_UnityEngine_Connect_UnityConnectSettings_set_testModev, __Z17WriteConditionalyR13dynamic_arrayIiLj4EEP19ProfilerInformation: __Z17WriteConditionalyR13dynamic_arrayIiLj4EEP19ProfilerInformation, __ZNK17AnimationCurveTplI8Vector3fE9FindIndexEf: __ZNK17AnimationCurveTplI8Vector3fE9FindIndexEf, __ZN6Shader18LoadDefaultShadersEv: __ZN6Shader18LoadDefaultShadersEv, __ZN5physx2Gu13MeshInterface17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu13MeshInterface17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj451ENS_22PxRepXPropertyAccessorILj451ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj451ENS_22PxRepXPropertyAccessorILj451ES4_ffEEEEvRKT0_, __ZN13RenderManager13RenderCamerasEiPFvvE: __ZN13RenderManager13RenderCamerasEiPFvvE, __ZN8WindZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8WindZone23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx9PxTaskMgr7releaseEv: __ZN5physx9PxTaskMgr7releaseEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj632ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z24ReleaseBufferManagerGLESv: __Z24ReleaseBufferManagerGLESv, __ZN13RuntimeStaticI19UnityConnectServiceE13StaticDestroyEPv: __ZN13RuntimeStaticI19UnityConnectServiceE13StaticDestroyEPv, __Z18Transfer_BlittableI9JSONWriteLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN33AssetBundleLoadFromAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN33AssetBundleLoadFromAsyncOperationC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZZN8Animator15InitializeClassEvEN31FunctorImpl_390kDidModifyAvatar4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN31FunctorImpl_390kDidModifyAvatar4CallEPviR11MessageData, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN5Umbra11ShadowUtils19getShadowClipPlanesERKNS_7Vector3EPNS_7Vector4ES5_Ri: __ZN5Umbra11ShadowUtils19getShadowClipPlanesERKNS_7Vector3EPNS_7Vector4ES5_Ri, __ZN12_GLOBAL__N_117ConnectionManager11setPickableEPKvb: __ZN12_GLOBAL__N_117ConnectionManager11setPickableEPKvb, _UNITY_png_do_write_transformations: _UNITY_png_do_write_transformations, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16getInvMassScale0Ev, __Z32HumanTrait_CUSTOM_MuscleFromBoneii: __Z32HumanTrait_CUSTOM_MuscleFromBoneii, __ZNK5physx2Sc5Scene8getStatsERNS_22PxSimulationStatisticsE: __ZNK5physx2Sc5Scene8getStatsERNS_22PxSimulationStatisticsE, __Z33getPxCloth_SelfCollisionStiffnessPKN5physx7PxClothE: __Z33getPxCloth_SelfCollisionStiffnessPKN5physx7PxClothE, __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo: __ZNK26AnimatorControllerPlayable20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo, __ZThn4_N12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv: __ZThn4_N12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv, __ZN9ShaderLab20SerializedProperties16AddRangePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEfff: __ZN9ShaderLab20SerializedProperties16AddRangePropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEEfff, __Z47Register_UnityEngine_AI_NavMeshAgent_set_heightv: __Z47Register_UnityEngine_AI_NavMeshAgent_set_heightv, __ZN18UnityPropertySheet11UnityTexEnv8TransferI14SafeBinaryReadEEvRT_: __ZN18UnityPropertySheet11UnityTexEnv8TransferI14SafeBinaryReadEEvRT_, __ZN13DrawImmediate3EndEv: __ZN13DrawImmediate3EndEv, __ZN5physx7NpCloth27sendPvdSelfCollisionIndicesEv: __ZN5physx7NpCloth27sendPvdSelfCollisionIndicesEv, __ZNK9GfxDevice14IsPureThreadedEv: __ZNK9GfxDevice14IsPureThreadedEv, _wcsrtombs: _wcsrtombs, __ZN5Unity10HingeJointD0Ev: __ZN5Unity10HingeJointD0Ev, __ZN11OffMeshLink12AddToManagerEv: __ZN11OffMeshLink12AddToManagerEv, __ZNK14ParticleSystem7IsAliveEv: __ZNK14ParticleSystem7IsAliveEv, __ZNSt3__217moneypunct_bynameIwLb0EED2Ev: __ZNSt3__217moneypunct_bynameIwLb0EED2Ev, __ZNSt3__26vectorIP9Transform13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP9Transform13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN20VertexCacheOptimizerIjLi16EE17OptimizeTrianglesEPjjPKjj: __ZN20VertexCacheOptimizerIjLi16EE17OptimizeTrianglesEPjjPKjj, __ZNK5physx2Sc9ClothCore22getFrictionCoefficientEv: __ZNK5physx2Sc9ClothCore22getFrictionCoefficientEv, __ZN2UI6Canvas23SetOverridePixelPerfectEb: __ZN2UI6Canvas23SetOverridePixelPerfectEb, __Z13TransferArrayILi7EKN4math7_float3E19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_: __Z13TransferArrayILi7EKN4math7_float3E19StreamedBinaryWriteILb0EEEvRAT__T0_PKcRT1_, __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_anchorv: __Z56Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_anchorv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb, __ZN5physx8debugger4comm14CreatePropertyD0Ev: __ZN5physx8debugger4comm14CreatePropertyD0Ev, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED2Ev, __ZN5physx3Scb13ObjectTracker17scheduleForInsertERNS0_4BaseE: __ZN5physx3Scb13ObjectTracker17scheduleForInsertERNS0_4BaseE, __Z51ParticleRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject: __Z51ParticleRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject, __ZNK24iPhoneRemoteNotification12GetSoundNameEv: __ZNK24iPhoneRemoteNotification12GetSoundNameEv, _atanh: _atanh, __ZN5physx14NpArticulation24setSolverIterationCountsEjj: __ZN5physx14NpArticulation24setSolverIterationCountsEjj, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS5_9allocatorINS5_4pairIiS4_EEEEEEEvRT_17TransferMetaFlags, __Z48Register_UnityEngine_AsyncOperation_get_progressv: __Z48Register_UnityEngine_AsyncOperation_get_progressv, __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN20UnityConnectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudev: __Z80Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetMagnitudev, __ZN12LightsModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12LightsModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z60Register_UnityEngine_AnimationClip_INTERNAL_CALL_ClearCurvesv: __Z60Register_UnityEngine_AnimationClip_INTERNAL_CALL_ClearCurvesv, _lldiv: _lldiv, __ZN16StreamedResource8TransferI17RemapPPtrTransferEEvRT_: __ZN16StreamedResource8TransferI17RemapPPtrTransferEEvRT_, __Z52Register_UnityEngine_Material_INTERNAL_CALL_SetColorv: __Z52Register_UnityEngine_Material_INTERNAL_CALL_SetColorv, __ZN8Animator15InitializeClassEv: __ZN8Animator15InitializeClassEv, __Z65Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetBufferv: __Z65Register_UnityEngine_Graphics_Internal_SetRandomWriteTargetBufferv, __ZL12InvokeMethodI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI9JSONWriteEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectClass13Il2Cpp_IntPtrRPv: __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_GetObjectClass13Il2Cpp_IntPtrRPv, __ZN5physx22PxcPCMContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcPCMContactBoxConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_: __Z13b2TestOverlapPK7b2ShapeiS1_iRK11b2TransformS4_, __ZN15FrictionJoint2D15ThreadedCleanupEv: __ZN15FrictionJoint2D15ThreadedCleanupEv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19onConstraintReleaseEv, __Z54Register_UnityEngine_TerrainData_GetInterpolatedHeightv: __Z54Register_UnityEngine_TerrainData_GetInterpolatedHeightv, __Z36Application_CUSTOM_DontDestroyOnLoadP12Il2CppObject: __Z36Application_CUSTOM_DontDestroyOnLoadP12Il2CppObject, __ZN24EllipsoidParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN24EllipsoidParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx3Ext19ProfileEventHandler12reportEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE: __ZN5physx3Ext19ProfileEventHandler12reportEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE, __ZN5physx2Sq17SceneQueryManager12freeSPUTasksEPNS_12NpBatchQueryE: __ZN5physx2Sq17SceneQueryManager12freeSPUTasksEPNS_12NpBatchQueryE, _wcsncasecmp: _wcsncasecmp, __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj: __ZZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEEEN5Local9_WalkFaceERZNS0_5Walk2ES5_S6_S9_SE_E17PrivateWalkParamsjjjj, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI14SafeBinaryReadEEvRT_, __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb1EEEEvRT_: __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx21PxcArticulationHelper18setJointTransformsERNS_30PxcArticulationJointTransformsERKNS_11PxTransformES5_RKNS_24PxsArticulationJointCoreE: __ZN5physx21PxcArticulationHelper18setJointTransformsERNS_30PxcArticulationJointTransformsERKNS_11PxTransformES5_RKNS_24PxsArticulationJointCoreE, __Z45Register_UnityEngine_Input_GetMouseButtonDownv: __Z45Register_UnityEngine_Input_GetMouseButtonDownv, _UNITY_png_write_end: _UNITY_png_write_end, __Z51Register_UnityEngine_Collider2D_INTERNAL_get_offsetv: __Z51Register_UnityEngine_Collider2D_INTERNAL_get_offsetv, __ZN5Umbra8QueryExt24queryStaticShadowCastersERKNS_15ShadowCullerExtERNS_9IndexListEPKNS_20ObjectDistanceParamsEiiPS4_: __ZN5Umbra8QueryExt24queryStaticShadowCastersERKNS_15ShadowCullerExtERNS_9IndexListEPKNS_20ObjectDistanceParamsEiiPS4_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv, __ZN9GfxDevice17SetComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE: __ZN9GfxDevice17SetComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE, __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb: __ZN12_GLOBAL__N_113truncateSwingERKN5physx6PxQuatERKNS0_6PxVec3EffRb, __Z54Register_UnityEngine_Terrain_get_treeBillboardDistancev: __Z54Register_UnityEngine_Terrain_get_treeBillboardDistancev, __ZNK11NavMeshData26GetTypeInfoVirtualInternalEv: __ZNK11NavMeshData26GetTypeInfoVirtualInternalEv, __ZN17WeakPtrSharedDataD2Ev: __ZN17WeakPtrSharedDataD2Ev, __ZN13dynamic_arrayIP26AnimatorControllerPlayableLj4EEC2ERKS2_RK10MemLabelId: __ZN13dynamic_arrayIP26AnimatorControllerPlayableLj4EEC2ERKS2_RK10MemLabelId, __Z23InitializePhysicsModulev: __Z23InitializePhysicsModulev, __ZN17AudioChorusFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17AudioChorusFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __Z54Register_UnityEngine_RenderSettings_set_fogEndDistancev: __Z54Register_UnityEngine_RenderSettings_set_fogEndDistancev, __ZN13OcclusionArea15ThreadedCleanupEv: __ZN13OcclusionArea15ThreadedCleanupEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector2fLj4EEEEvRT_17TransferMetaFlags, __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Renderer8TransferI24GenerateTypeTreeTransferEEvRT_, __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane: __Z23ExtractProjectionPlanesRK10Matrix4x4fP5Plane, __ZN8VRDevice11EarlyUpdateEv: __ZN8VRDevice11EarlyUpdateEv, _wcscmp: _wcscmp, __ZN6Camera8DoRenderER11CullResultsRK19SharedRendererSceneNS_10RenderFlagEPFvRS_R10RenderLoopRK15RenderNodeQueueEPSA_: __ZN6Camera8DoRenderER11CullResultsRK19SharedRendererSceneNS_10RenderFlagEPFvRS_R10RenderLoopRK15RenderNodeQueueEPSA_, __ZNK5physx2Sc10ClothShape13getFilterInfoERjRNS_12PxFilterDataE: __ZNK5physx2Sc10ClothShape13getFilterInfoERjRNS_12PxFilterDataE, __ZN5physx2Gu28checkOverlapOBB_triangleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu28checkOverlapOBB_triangleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __Z50Physics2D_CUSTOM_INTERNAL_set_colliderContactColorRK10ColorRGBAf: __Z50Physics2D_CUSTOM_INTERNAL_set_colliderContactColorRK10ColorRGBAf, __ZN16GraphicsSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16GraphicsSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN20SphericalHarmonicsL215AddAmbientLightERK10ColorRGBAf: __ZN20SphericalHarmonicsL215AddAmbientLightERK10ColorRGBAf, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6ignoreEii: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE6ignoreEii, __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_19ParticlePacketShapeE: __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_19ParticlePacketShapeE, _inet_network: _inet_network, __ZN5physx2Sc5Scene10broadPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene10broadPhaseEPNS_10PxBaseTaskE, __ZN22ParticleSystemRenderer17MainThreadCleanupEv: __ZN22ParticleSystemRenderer17MainThreadCleanupEv, __ZNSt3__215__thread_struct27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE: __ZNSt3__215__thread_struct27__make_ready_at_thread_exitEPNS_17__assoc_sub_stateE, __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing2LimitP12Il2CppObjectP14SoftJointLimit: __Z46CharacterJoint_CUSTOM_INTERNAL_get_swing2LimitP12Il2CppObjectP14SoftJointLimit, __Z51ConfigurableJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf: __Z51ConfigurableJoint_Set_Custom_PropProjectionDistanceP12Il2CppObjectf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZN17GlobalGameManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17GlobalGameManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z51CharacterJoint_CUSTOM_INTERNAL_get_twistLimitSpringP12Il2CppObjectP20SoftJointLimitSpring: __Z51CharacterJoint_CUSTOM_INTERNAL_get_twistLimitSpringP12Il2CppObjectP20SoftJointLimitSpring, __ZN23ShaderVariantCollection11VariantInfo8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN23ShaderVariantCollection11VariantInfo8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx3Cct13BoxController13setSlopeLimitEf: __ZN5physx3Cct13BoxController13setSlopeLimitEf, _ether_line: _ether_line, __ZN16b2StackAllocatorC2Ev: __ZN16b2StackAllocatorC2Ev, __ZNK17AnimationCurveTplI11QuaternionfE8EvaluateEfPNS1_5CacheE: __ZNK17AnimationCurveTplI11QuaternionfE8EvaluateEfPNS1_5CacheE, __ZNSt3__218__insertion_sort_3IRNS_6__lessIddEEPdEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIddEEPdEEvT0_S5_T_, __Z66Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRate_Internalv: __Z66Register_UnityEngine_Gyroscope_INTERNAL_CALL_rotationRate_Internalv, _init_destination: _init_destination, __Z10SetGlobalT15TransformAccessRKN4math7_float3E: __Z10SetGlobalT15TransformAccessRKN4math7_float3E, __Z9TrimCharsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z9TrimCharsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __Z35setPxVehicleDifferential4WDataMTypePN5physx27PxVehicleDifferential4WDataENS0_4EnumE: __Z35setPxVehicleDifferential4WDataMTypePN5physx27PxVehicleDifferential4WDataENS0_4EnumE, __ZN5Flare23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Flare23VirtualRedirectTransferER14SafeBinaryRead, __Z32CustomEventData_CUSTOM_AddUInt16P12Il2CppObjectP12Il2CppStringt: __Z32CustomEventData_CUSTOM_AddUInt16P12Il2CppObjectP12Il2CppStringt, __Z40Register_UnityEngine_LensFlare_set_flarev: __Z40Register_UnityEngine_LensFlare_set_flarev, __Z15setPxShape_NamePN5physx7PxShapeEPKc: __Z15setPxShape_NamePN5physx7PxShapeEPKc, __ZNK27AnimatorControllerParameter14GetDefaultBoolEv: __ZNK27AnimatorControllerParameter14GetDefaultBoolEv, __ZN17WeakPtrSharedDataC2E10MemLabelId: __ZN17WeakPtrSharedDataC2E10MemLabelId, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj163ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj163ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN19TouchPhaseEmulation18DispatchTouchEventEj8Vector2fNS_10TouchPhaseExj: __ZN19TouchPhaseEmulation18DispatchTouchEventEj8Vector2fNS_10TouchPhaseExj, __ZNK15FileSystemEntry12GetAssetGUIDEv: __ZNK15FileSystemEntry12GetAssetGUIDEv, __Z29GetTerrainScriptingClassesPtrv: __Z29GetTerrainScriptingClassesPtrv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEE15growAndPushBackERKS2_, __ZN9JSONWrite8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags, __ZNK15ResourceManager26GetTypeInfoVirtualInternalEv: __ZNK15ResourceManager26GetTypeInfoVirtualInternalEv, __ZN19SkinnedMeshRenderer22SetUpdateWhenOffscreenEb: __ZN19SkinnedMeshRenderer22SetUpdateWhenOffscreenEb, __Z52Register_UnityEngine_Physics_get_queriesHitBackfacesv: __Z52Register_UnityEngine_Physics_get_queriesHitBackfacesv, __ZN8Material17UpdateToNewShaderEb: __ZN8Material17UpdateToNewShaderEb, __Z51ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve: __Z51ParticleSystem_TrailModule_CUSTOM_SetWidthOverTrailP12Il2CppObjectR15MonoMinMaxCurve, __Z41ReflectionProbe_Get_Custom_PropImportanceP12Il2CppObject: __Z41ReflectionProbe_Get_Custom_PropImportanceP12Il2CppObject, __Z36Register_UnityEngine_Animation_Blendv: __Z36Register_UnityEngine_Animation_Blendv, __GLOBAL__sub_I_runtime_cloth_lump_cpp: __GLOBAL__sub_I_runtime_cloth_lump_cpp, __ZN5physx8debugger8renderer19PvdUserRenderParser6createERNS_19PxAllocatorCallbackEb: __ZN5physx8debugger8renderer19PvdUserRenderParser6createERNS_19PxAllocatorCallbackEb, __ZN8Material25AcquireSharedMaterialDataEv: __ZN8Material25AcquireSharedMaterialDataEv, __ZN5physx2Sc27ConstraintProjectionManagerC2Ev: __ZN5physx2Sc27ConstraintProjectionManagerC2Ev, __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei: __ZN15TerrainRenderer26MarkChildVisibilityRecurseER12QuadTreeNodei, __ZN12MeshRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN12MeshRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN13WebCamTexture6CreateEv: __ZN13WebCamTexture6CreateEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofERKS5_j, _Line_To: _Line_To, __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_velocityv: __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_velocityv, __Z34ComputeBuffer_Get_Custom_PropCountP12Il2CppObject: __Z34ComputeBuffer_Get_Custom_PropCountP12Il2CppObject, __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z38Register_UnityEngine_GUIStyle_set_namev: __Z38Register_UnityEngine_GUIStyle_set_namev, __Z38RectTransform_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE: __Z38RectTransform_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE, __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_desiredVelocityv: __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_desiredVelocityv, __Z46Register_UnityEngine_AudioClip_UnloadAudioDatav: __Z46Register_UnityEngine_AudioClip_UnloadAudioDatav, __ZN12HandlerChain5LinksEv: __ZN12HandlerChain5LinksEv, __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext: __ZN13RenderTexture17SetGlobalPropertyERKN9ShaderLab16FastPropertyNameER17ShaderPassContext, __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj: __ZN5physx2Sc16InteractionScene20allocatePointerBlockEj, __Z45OffMeshLinkData_CUSTOM_GetOffMeshLinkInternalP12Il2CppObjecti: __Z45OffMeshLinkData_CUSTOM_GetOffMeshLinkInternalP12Il2CppObjecti, __ZN9b2Simplex6Solve3Ev: __ZN9b2Simplex6Solve3Ev, __ZN22RenderingCommandBuffer20FlattenCommandBufferER17ShaderPassContextR15RenderNodeQueue: __ZN22RenderingCommandBuffer20FlattenCommandBufferER17ShaderPassContextR15RenderNodeQueue, __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate8TextMeshEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN20TextRenderingPrivate8TextMeshEEviPKcS3_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_, __ZL8BatchJobP18BatchJobDataSingle: __ZL8BatchJobP18BatchJobDataSingle, __Z53Register_UnityEngine_ParticleSystem_set_startRotationv: __Z53Register_UnityEngine_ParticleSystem_set_startRotationv, __Z59Register_UnityEngine_QualitySettings_get_masterTextureLimitv: __Z59Register_UnityEngine_QualitySettings_get_masterTextureLimitv, __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveSimDataEEEEEEEjT_j: __ZNK5physx34PxVehicleDriveSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveSimDataEEEEEEEjT_j, _setlinebuf: _setlinebuf, __ZN7mecanim12statemachine27CreateStateMachineWorkspaceEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine27CreateStateMachineWorkspaceEPKNS0_20StateMachineConstantEjRNS_6memory9AllocatorE, __ZNK4Tree26GetTypeInfoVirtualInternalEv: __ZNK4Tree26GetTypeInfoVirtualInternalEv, __Z40LineRenderer_Get_Custom_PropNumPositionsP12Il2CppObject: __Z40LineRenderer_Get_Custom_PropNumPositionsP12Il2CppObject, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthYMultiplierv, __ZN17BillboardRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17BillboardRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN12ActiveLightsD2Ev: __ZN12ActiveLightsD2Ev, __ZL26RegisterModuleICalls_Clothv: __ZL26RegisterModuleICalls_Clothv, __Z29getNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE: __Z29getNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj524ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15QualitySettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15QualitySettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx7PxvInitERKNS_14PxvOffsetTableE: __ZN5physx7PxvInitERKNS_14PxvOffsetTableE, __ZN7ApiGLES17DeleteVertexArrayERN2gl6HandleILNS0_10ObjectTypeE3EEE: __ZN7ApiGLES17DeleteVertexArrayERN2gl6HandleILNS0_10ObjectTypeE3EEE, __Z22RecalculateSplineSlopeR17AnimationCurveTplIfEif: __Z22RecalculateSplineSlopeR17AnimationCurveTplIfEif, __Z45AnimationState_Set_Custom_PropNormalizedSpeedP12Il2CppObjectf: __Z45AnimationState_Set_Custom_PropNormalizedSpeedP12Il2CppObjectf, __ZN5physx14collideWithBoxEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf: __ZN5physx14collideWithBoxEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf, __ZN5physx12NpConstraintC2EPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj: __ZN5physx12NpConstraintC2EPNS_12PxRigidActorES2_RNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj, __ZN7Striper4InitER13STRIPERCREATE: __ZN7Striper4InitER13STRIPERCREATE, __ZN20LocalFileSystemPosix6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN20LocalFileSystemPosix6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z33Renderer_Set_Custom_PropMaterialsP12Il2CppObjectP11Il2CppArray: __Z33Renderer_Set_Custom_PropMaterialsP12Il2CppObjectP11Il2CppArray, __ZNK13b2PulleyJoint16GetGroundAnchorBEv: __ZNK13b2PulleyJoint16GetGroundAnchorBEv, __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_: __ZN14qsort_internal6_QSortIP16ParticleSortDataiPFbRKS1_S4_EEEvT_S7_T0_T1_, __Z15Transfer_StringI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI14SafeBinaryReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15ParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead: __ZN15ParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead, __Z59ParticleCollisionEvent_CUSTOM_InstanceIDToColliderComponenti: __Z59ParticleCollisionEvent_CUSTOM_InstanceIDToColliderComponenti, __ZN5physx44solveFrictionCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx44solveFrictionCoulombPreBlock_WriteBackStaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj: __ZN19SkinnedMeshRenderer22CalculateAnimatedPosesEP10Matrix4x4fj, __ZNK5Umbra9Matrix4x49isUniformEv: __ZNK5Umbra9Matrix4x49isUniformEv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_117ProfileZoneClientENS_8debugger19ForwardingAllocatorEED0Ev, __ZN5physx2Sn13XmlNodeReaderD2Ev: __ZN5physx2Sn13XmlNodeReaderD2Ev, _unity_z_get_crc_table: _unity_z_get_crc_table, __ZN7b2JointD0Ev: __ZN7b2JointD0Ev, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEPKcj, __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE10BeginWriteEjj: __ZN14DrawBufferGLESI12VertexBuffer27VertexBufferUsageMapperGLESE10BeginWriteEjj, __ZL12edgeEdgeDistRN5physx6PxVec3ES1_RKS0_S3_S3_S3_: __ZL12edgeEdgeDistRN5physx6PxVec3ES1_RKS0_S3_S3_S3_, __Z49RenderSettings_Get_Custom_PropReflectionIntensityv: __Z49RenderSettings_Get_Custom_PropReflectionIntensityv, __Z49WheelCollider_CUSTOM_INTERNAL_set_forwardFrictionP12Il2CppObjectRK18WheelFrictionCurve: __Z49WheelCollider_CUSTOM_INTERNAL_set_forwardFrictionP12Il2CppObjectRK18WheelFrictionCurve, __ZN16Physics2DManager21GetLayerCollisionMaskEi: __ZN16Physics2DManager21GetLayerCollisionMaskEi, __Z49Register_UnityEngine_Rendering_SplashScreen_Beginv: __Z49Register_UnityEngine_Rendering_SplashScreen_Beginv, __ZL35InitializePhysics2DScriptingClassesv: __ZL35InitializePhysics2DScriptingClassesv, __Z48Register_UnityEngine_Input_get_compensateSensorsv: __Z48Register_UnityEngine_Input_get_compensateSensorsv, __Z48RelativeJoint2D_CUSTOM_INTERNAL_get_linearOffsetP12Il2CppObjectP13Vector2fIcall: __Z48RelativeJoint2D_CUSTOM_INTERNAL_get_linearOffsetP12Il2CppObjectP13Vector2fIcall, __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerStringv: __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetIntegerStringv, __ZN12LightsModule20ResetUsedLightsCacheEv: __ZN12LightsModule20ResetUsedLightsCacheEv, __ZN5physx40solveContactCoulomb_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx40solveContactCoulomb_BStaticConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN8VRDevice26ReleaseEyeTextureResourcesEPvP17RenderSurfaceBase: __ZN8VRDevice26ReleaseEyeTextureResourcesEPvP17RenderSurfaceBase, __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE7rdstateEv: __ZNKSt3__29basic_iosIwNS_11char_traitsIwEEE7rdstateEv, __ZN14NavMeshManager20AddOffMeshConnectionERK8Vector3fS2_ibh: __ZN14NavMeshManager20AddOffMeshConnectionERK8Vector3fS2_ibh, __Z43SkinnedMeshRenderer_Get_Custom_PropRootBoneP12Il2CppObject: __Z43SkinnedMeshRenderer_Get_Custom_PropRootBoneP12Il2CppObject, __Z10BeginsWithPKcS0_: __Z10BeginsWithPKcS0_, __ZN13GfxDeviceNull15SetBackfaceModeEb: __ZN13GfxDeviceNull15SetBackfaceModeEb, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen8DrawModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen8DrawModeEEvRT_RT0_PKc17TransferMetaFlags, __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_: __ZN12_GLOBAL__N_110copyVectorERN5physx6shdfnd5ArrayINS0_6PxVec4ENS1_16AlignedAllocatorILj16ENS1_9AllocatorEEEEERKS7_, __Z40Camera_Get_Custom_PropCommandBufferCountP12Il2CppObject: __Z40Camera_Get_Custom_PropCommandBufferCountP12Il2CppObject, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale1Ef, __ZN5physx21SapPostUpdateWorkTask11runInternalEv: __ZN5physx21SapPostUpdateWorkTask11runInternalEv, __ZNK9Texture3D13GetDataHeightEv: __ZNK9Texture3D13GetDataHeightEv, __Z52Register_UnityEngine_PointEffector2D_get_forceTargetv: __Z52Register_UnityEngine_PointEffector2D_get_forceTargetv, __ZN16PlayerConnection3GetEv: __ZN16PlayerConnection3GetEv, __ZN5physx21PxcFsApplyJointDrivesERNS_9PxcFsDataEPKNS_6shdfnd3aos5Vec3VE: __ZN5physx21PxcFsApplyJointDrivesERNS_9PxcFsDataEPKNS_6shdfnd3aos5Vec3VE, __Z33VRSettings_Get_Custom_PropEnabledv: __Z33VRSettings_Get_Custom_PropEnabledv, __Z26TerrainData_CUSTOM_AddUserP12Il2CppObjectS0_: __Z26TerrainData_CUSTOM_AddUserP12Il2CppObjectS0_, __ZN5physx2Sc9ClothCore18clearInterpolationEv: __ZN5physx2Sc9ClothCore18clearInterpolationEv, __ZN8JSONRead8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlagsb, __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialES4_: __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialES4_, __Z41getPxArticulationJoint_ExternalCompliancePKN5physx19PxArticulationJointE: __Z41getPxArticulationJoint_ExternalCompliancePKN5physx19PxArticulationJointE, __ZN2UI14CanvasRenderer22CanvasHierarchyChangedEv: __ZN2UI14CanvasRenderer22CanvasHierarchyChangedEv, __Z7dtAlloci: __Z7dtAlloci, __ZN8Renderer10SmartResetEv: __ZN8Renderer10SmartResetEv, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE18AddHeaderAndFooterEPvji: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE18AddHeaderAndFooterEPvji, __Z18Transfer_BlittableI14SafeBinaryReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z15return_originalRK21AnimationClipOverride: __Z15return_originalRK21AnimationClipOverride, __ZN5physx2Gu12TriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu12TriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __ZNK14PlayerSettings13GetColorSpaceEv: __ZNK14PlayerSettings13GetColorSpaceEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj652ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj652ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z42setPxArticulationJoint_TangentialStiffnessPN5physx19PxArticulationJointEf: __Z42setPxArticulationJoint_TangentialStiffnessPN5physx19PxArticulationJointEf, __ZN6Socket16InterruptedErrorEv: __ZN6Socket16InterruptedErrorEv, __ZNSt3__217moneypunct_bynameIcLb0EEC2EPKcj: __ZNSt3__217moneypunct_bynameIcLb0EEC2EPKcj, __ZN29PxsCreateFinalizeContactsTask11runInternalEv: __ZN29PxsCreateFinalizeContactsTask11runInternalEv, __ZN10AudioMixer23OnEnterPlayModePreStartEv: __ZN10AudioMixer23OnEnterPlayModePreStartEv, __ZN12AudioManager23ProcessScheduledSourcesEv: __ZN12AudioManager23ProcessScheduledSourcesEv, __Z57Register_UnityEngine_GUIStyleState_INTERNAL_get_textColorv: __Z57Register_UnityEngine_GUIStyleState_INTERNAL_get_textColorv, __Z99Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityv: __Z99Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityv, __Z28RegisterModule_TextRenderingv: __Z28RegisterModule_TextRenderingv, __Z50Register_UnityEngine_DynamicGI_get_updateThresholdv: __Z50Register_UnityEngine_DynamicGI_get_updateThresholdv, __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CapsuleCastv: __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CapsuleCastv, __ZN12LightmapData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12LightmapData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15AudioMixerGroupC2E10MemLabelId18ObjectCreationMode: __ZN15AudioMixerGroupC2E10MemLabelId18ObjectCreationMode, __ZN7b2Joint7DestroyEPS_P16b2BlockAllocator: __ZN7b2Joint7DestroyEPS_P16b2BlockAllocator, __ZN5physx3Ext13RevoluteJoint29setProjectionAngularToleranceEf: __ZN5physx3Ext13RevoluteJoint29setProjectionAngularToleranceEf, __ZN11AudioSource12SetStereoPanEf: __ZN11AudioSource12SetStereoPanEf, __Z57Register_UnityEngine_AudioReverbZone_get_reflectionsDelayv: __Z57Register_UnityEngine_AudioReverbZone_get_reflectionsDelayv, _UNITY_png_fixed_error: _UNITY_png_fixed_error, _srand: _srand, __ZN6Object16RevertWeakHandleEv: __ZN6Object16RevertWeakHandleEv, __Z17dynamic_pptr_castIP17BillboardRenderer8RendererET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP17BillboardRenderer8RendererET_RK4PPtrIT0_E, __ZN17Physics2DSettings14SetTimeToSleepEf: __ZN17Physics2DSettings14SetTimeToSleepEf, __Z41Rigidbody_Get_Custom_PropDetectCollisionsP12Il2CppObject: __Z41Rigidbody_Get_Custom_PropDetectCollisionsP12Il2CppObject, __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetBirthv: __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_SetBirthv, __ZN4FMOD7SystemI19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES: __ZN4FMOD7SystemI19setReverbPropertiesEPK22FMOD_REVERB_PROPERTIES, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_GetSuperclass13Il2Cpp_IntPtrRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_GetSuperclass13Il2Cpp_IntPtrRPv, __Z42Shader_CUSTOM_SetGlobalMatrixArrayImplListiP12Il2CppObject: __Z42Shader_CUSTOM_SetGlobalMatrixArrayImplListiP12Il2CppObject, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_, __Z34OffMeshLink_CUSTOM_UpdatePositionsP12Il2CppObject: __Z34OffMeshLink_CUSTOM_UpdatePositionsP12Il2CppObject, __ZNK18ProceduralMaterial9GetPresetEv: __ZNK18ProceduralMaterial9GetPresetEv, __ZN12_GLOBAL__N_118LegacySerialStreamD0Ev: __ZN12_GLOBAL__N_118LegacySerialStreamD0Ev, __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIKN4math7_float4EEEvRT_PKc17TransferMetaFlags, __ZN16NullVertexBufferD0Ev: __ZN16NullVertexBufferD0Ev, __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi: __ZN14dtNavMeshQuery22finalizeSlicedFindPathEPi, __ZNK9Texture3D12GetDimensionEv: __ZNK9Texture3D12GetDimensionEv, __Z41Register_UnityEngine_RectOffset_set_rightv: __Z41Register_UnityEngine_RectOffset_set_rightv, __ZN5Umbra8memEqualEPKvS1_j: __ZN5Umbra8memEqualEPKvS1_j, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_10MemLabelId17TransferMetaFlags, __Z14PxToRaycastHitRKN5physx12PxRaycastHitER10RaycastHit: __Z14PxToRaycastHitRKN5physx12PxRaycastHitER10RaycastHit, __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii: __ZN9Animation14QueueCrossFadeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEfii, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE6createERS4_Rb, __ZN5physx22PxVehicleSetUpdateModeENS_19PxVehicleUpdateMode4EnumE: __ZN5physx22PxVehicleSetUpdateModeENS_19PxVehicleUpdateMode4EnumE, __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_: __ZNSt3__27__sort5IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_S7_T_, __Z46EmitSerializationCommandsForManagedObjectFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z50Register_UnityEngine_AndroidJNI_GetStaticLongFieldv: __Z50Register_UnityEngine_AndroidJNI_GetStaticLongFieldv, __Z25Animation_CUSTOM_GetStateP12Il2CppObjectP12Il2CppString: __Z25Animation_CUSTOM_GetStateP12Il2CppObjectP12Il2CppString, __ZN14FileCacherRead7RequestEiR16AsyncReadCommandRNS_10CacheBlockE: __ZN14FileCacherRead7RequestEiR16AsyncReadCommandRNS_10CacheBlockE, __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE: __ZN19ShaderPropertySheet9SetVectorERKN9ShaderLab16FastPropertyNameERK8Vector4fNS_8SetFlagsE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_13PxRigidStaticEE8pushNameEPKc, __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz: __ZNSt3__219__libcpp_snprintf_lEPcjP15__locale_structPKcz, __ZN14SafeBinaryRead10SetVersionEi: __ZN14SafeBinaryRead10SetVersionEi, __ZNK14NavMeshManager27IsOffMeshConnectionOccupiedEy: __ZNK14NavMeshManager27IsOffMeshConnectionOccupiedEy, __Z31Mathf_CUSTOM_GammaToLinearSpacef: __Z31Mathf_CUSTOM_GammaToLinearSpacef, __ZN7dtCrowd24setAgentAnimationPolyRefERK13dtCrowdHandley: __ZN7dtCrowd24setAgentAnimationPolyRefERK13dtCrowdHandley, __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc21ConstraintInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __Z11SetIPhysicsP8IPhysics: __Z11SetIPhysicsP8IPhysics, __Z50ParticleSystem_SubEmittersModule_CUSTOM_GetEnabledP12Il2CppObject: __Z50ParticleSystem_SubEmittersModule_CUSTOM_GetEnabledP12Il2CppObject, __ZNK11Rigidbody2D15GetCenterOfMassEv: __ZNK11Rigidbody2D15GetCenterOfMassEv, __ZN6ObjectD0Ev: __ZN6ObjectD0Ev, _UNITY_png_convert_to_rfc1123_buffer: _UNITY_png_convert_to_rfc1123_buffer, ___getdents: ___getdents, __Z19GetLightmapSettingsv: __Z19GetLightmapSettingsv, __Z49ParticleEmitter_Get_Custom_PropRndAngularVelocityP12Il2CppObject: __Z49ParticleEmitter_Get_Custom_PropRndAngularVelocityP12Il2CppObject, __ZNK19RenderEventsContext21GetCommandBufferCountEv: __ZNK19RenderEventsContext21GetCommandBufferCountEv, __Z29GameObject_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i: __Z29GameObject_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i, __ZN29AssetBundleLoadAssetOperation9LoadAssetER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb: __ZN29AssetBundleLoadAssetOperation9LoadAssetER11AssetBundleRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjectb, __ZN5Umbra15PortalRayTracer4initERNS_10PortalNodeE: __ZN5Umbra15PortalRayTracer4initERNS_10PortalNodeE, __Z49ParticleEmitter_CUSTOM_INTERNAL_get_worldVelocityP12Il2CppObjectP8Vector3f: __Z49ParticleEmitter_CUSTOM_INTERNAL_get_worldVelocityP12Il2CppObjectP8Vector3f, _inet_ntop: _inet_ntop, __Z21FindTransformWithNameP9TransformPKc: __Z21FindTransformWithNameP9TransformPKc, __ZN14DataBufferGLES13EnsureStorageEi: __ZN14DataBufferGLES13EnsureStorageEi, _inet_ntoa: _inet_ntoa, __ZNSt3__26vectorIP4NodeNS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIP4NodeNS_9allocatorIS2_EEE8__appendEj, __ZN14PlayerSettings15InitializeClassEv: __ZN14PlayerSettings15InitializeClassEv, __ZN5physx21PxcArticulationHelper15createHardLimitERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Eff: __ZN5physx21PxcArticulationHelper15createHardLimitERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Eff, __Z22Animator_CUSTOM_UpdateP12Il2CppObjectf: __Z22Animator_CUSTOM_UpdateP12Il2CppObjectf, __ZN14RenderSettings31CalculateAmbientProbeFromSkyboxEv: __ZN14RenderSettings31CalculateAmbientProbeFromSkyboxEv, __ZNK27AnimatorControllerParameter13GetDefaultIntEv: __ZNK27AnimatorControllerParameter13GetDefaultIntEv, __ZN14ParticleSystem18Update1IncrementalERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesfNS_11UpdateFlagsE: __ZN14ParticleSystem18Update1IncrementalERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesfNS_11UpdateFlagsE, __ZN9Texture2D18UnshareTextureDataEv: __ZN9Texture2D18UnshareTextureDataEv, __Z61Register_UnityEngine_Cloth_INTERNAL_CALL_ClearTransformMotionv: __Z61Register_UnityEngine_Cloth_INTERNAL_CALL_ClearTransformMotionv, __ZN5physx2Sn13XmlNodeReader19getCurrentItemValueEv: __ZN5physx2Sn13XmlNodeReader19getCurrentItemValueEv, __ZN13GfxDeviceGLES22CopyComputeBufferCountE15ComputeBufferIDS0_j: __ZN13GfxDeviceGLES22CopyComputeBufferCountE15ComputeBufferIDS0_j, __Z43PlatformEffector2D_Get_Custom_PropUseOneWayP12Il2CppObject: __Z43PlatformEffector2D_Get_Custom_PropUseOneWayP12Il2CppObject, __Z31RegisterModuleClasses_Physics2Dv: __Z31RegisterModuleClasses_Physics2Dv, __ZN5physx6shdfnd9Allocator8allocateEjPKci: __ZN5physx6shdfnd9Allocator8allocateEjPKci, __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN26EnlightenSystemInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11DetailPatch8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11DetailPatch8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED2Ev: __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED2Ev, __ZN11LightProbes23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11LightProbes23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z29ScriptingToNativeVertexLayoutPK25ScriptingVertexDataLayoutiR19VertexStreamsLayoutR20VertexChannelsLayout: __Z29ScriptingToNativeVertexLayoutPK25ScriptingVertexDataLayoutiR19VertexStreamsLayoutR20VertexChannelsLayout, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv, __Z43SurfaceEffector2D_Get_Custom_PropForceScaleP12Il2CppObject: __Z43SurfaceEffector2D_Get_Custom_PropForceScaleP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIbEEEvRT_17TransferMetaFlags, __ZN4FMOD4DSPI7getTypeEP13FMOD_DSP_TYPE: __ZN4FMOD4DSPI7getTypeEP13FMOD_DSP_TYPE, __ZN7Texture9ReloadAllEbbb: __ZN7Texture9ReloadAllEbbb, __ZN16ParticleAnimator8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16ParticleAnimator8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z25getPxMaterial_RestitutionPKN5physx10PxMaterialE: __Z25getPxMaterial_RestitutionPKN5physx10PxMaterialE, __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE7reserveEj: __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS5_IS8_EEE7reserveEj, __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16ParticleRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_4pairIKiS3_EEN2UI14DepthSortLayerEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZNK10Collider2D11GetFrictionEv: __ZNK10Collider2D11GetFrictionEv, __ZN7Joint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN7Joint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__24moveI10InputEventPS1_RS1_PS2_iLi0ES1_S2_S3_S4_iLi0EEENS_16__deque_iteratorIT5_T6_T7_T8_T9_XT10_EEENS5_IT_T0_T1_T2_T3_XT4_EEESH_SB_: __ZNSt3__24moveI10InputEventPS1_RS1_PS2_iLi0ES1_S2_S3_S4_iLi0EEENS_16__deque_iteratorIT5_T6_T7_T8_T9_XT10_EEENS5_IT_T0_T1_T2_T3_XT4_EEESH_SB_, __ZNK8Animator45IsRootTranslationOrRotationControllerByCurvesEv: __ZNK8Animator45IsRootTranslationOrRotationControllerByCurvesEv, __Z64Register_UnityEngine_ParticleSystem_INTERNAL_set_startRotation3Dv: __Z64Register_UnityEngine_ParticleSystem_INTERNAL_set_startRotation3Dv, __Z33Sprite_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z33Sprite_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __ZNSt16nested_exceptionD2Ev: __ZNSt16nested_exceptionD2Ev, __Z15GetUsedHeapSizev: __Z15GetUsedHeapSizev, ___fxstat: ___fxstat, __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21ImposterRenderTextureD2Ev: __ZN21ImposterRenderTextureD2Ev, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __Z52Register_UnityEngine_Terrain_set_detailObjectDensityv: __Z52Register_UnityEngine_Terrain_set_detailObjectDensityv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKc, _UNITY_FT_Tan: _UNITY_FT_Tan, _cf2_hintmap_init: _cf2_hintmap_init, __ZN12ImageDecoder11SetReadFuncEPvPFjS0_PhjE: __ZN12ImageDecoder11SetReadFuncEPvPFjS0_PhjE, __ZN20TextRenderingPrivate8FontImpl14AddRectToCacheERNS0_13CharacterInfoE: __ZN20TextRenderingPrivate8FontImpl14AddRectToCacheERNS0_13CharacterInfoE, __Z27Font_Get_Custom_PropDynamicP12Il2CppObject: __Z27Font_Get_Custom_PropDynamicP12Il2CppObject, __Z24GetIMGUIScriptingClassesv: __Z24GetIMGUIScriptingClassesv, __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb: __ZN15ReflectionProbe14ScheduleRenderENS_15TimeSlicingModeE4PPtrI13RenderTextureEb, __Z13RegisterClassI11NamedObjectEvv: __Z13RegisterClassI11NamedObjectEvv, __Z67Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Singlev: __Z67Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Singlev, __Z26Mesh_CUSTOM_SetIndicesImplP12Il2CppObjecti16GfxPrimitiveTypeP11Il2CppArrayih: __Z26Mesh_CUSTOM_SetIndicesImplP12Il2CppObjecti16GfxPrimitiveTypeP11Il2CppArrayih, __ZN9GfxDevice11CopyTextureE9TextureIDS0_: __ZN9GfxDevice11CopyTextureE9TextureIDS0_, __Z38Register_UnityEngine_Caching_get_indexv: __Z38Register_UnityEngine_Caching_get_indexv, __ZNK8Animator17GetTimeUpdateModeEv: __ZNK8Animator17GetTimeUpdateModeEv, __ZN5physx35PxVehicleChassisDataGeneratedValuesC2EPKNS_20PxVehicleChassisDataE: __ZN5physx35PxVehicleChassisDataGeneratedValuesC2EPKNS_20PxVehicleChassisDataE, __ZN5physx20PxSceneGeneratedInfoC2Ev: __ZN5physx20PxSceneGeneratedInfoC2Ev, __ZNSt3__210moneypunctIwLb1EEC2Ej: __ZNSt3__210moneypunctIwLb1EEC2Ej, __ZN5physx2Gu11HeightField34parseTrianglesForCollisionVerticesEt: __ZN5physx2Gu11HeightField34parseTrianglesForCollisionVerticesEt, __Z33RenderTexture_Get_Custom_PropSRGBP12Il2CppObject: __Z33RenderTexture_Get_Custom_PropSRGBP12Il2CppObject, __ZN12InputManagerD2Ev: __ZN12InputManagerD2Ev, __Z43CanvasRenderer_Get_Custom_PropRelativeDepthP12Il2CppObject: __Z43CanvasRenderer_Get_Custom_PropRelativeDepthP12Il2CppObject, __ZN18ColorBySpeedModuleD2Ev: __ZN18ColorBySpeedModuleD2Ev, __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_originCustomP12Il2CppObjectP8Vector3f: __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_originCustomP12Il2CppObjectP8Vector3f, _fread: _fread, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxVehicleTireDataEE8pushNameEPKc, __ZN4gles12AddDepthBiasER15DeviceStateGLESPK17DeviceRasterStateff: __ZN4gles12AddDepthBiasER15DeviceStateGLESPK17DeviceRasterStateff, __ZN5Unity10HingeJoint24WriteTwistLimitAsLimitedEv: __ZN5Unity10HingeJoint24WriteTwistLimitAsLimitedEv, __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx15NpActorTemplateINS_7PxClothEED2Ev: __ZN5physx15NpActorTemplateINS_7PxClothEED2Ev, _UNITY_tt_face_free_ps_names: _UNITY_tt_face_free_ps_names, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpENS_4fposI11__mbstate_tEE: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE5seekpENS_4fposI11__mbstate_tEE, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __ZNK5physx3Cct17CapsuleController15getFootPositionEv: __ZNK5physx3Cct17CapsuleController15getFootPositionEv, _vswprintf: _vswprintf, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev, __ZN15ReflectionProbe21ReleaseCachedRendererEv: __ZN15ReflectionProbe21ReleaseCachedRendererEv, __ZL28InitializeAIScriptingClassesv: __ZL28InitializeAIScriptingClassesv, __ZN5Flare7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Flare7PRODUCEE10MemLabelId18ObjectCreationMode, __Z34Camera_Get_Custom_PropFarClipPlaneP12Il2CppObject: __Z34Camera_Get_Custom_PropFarClipPlaneP12Il2CppObject, __ZNK14DLHAudioHelper14GetPartialSizeEv: __ZNK14DLHAudioHelper14GetPartialSizeEv, __Z31OffMeshLink_Get_Custom_PropAreaP12Il2CppObject: __Z31OffMeshLink_Get_Custom_PropAreaP12Il2CppObject, __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b: __Z15CameraUnProjectRK8Vector3fRK10Matrix4x4fS4_RK5RectTIiERS_b, __ZN13SpeedTreeWind4GustEdd: __ZN13SpeedTreeWind4GustEdd, __ZN5physx3Ext19ProfileEventHandlerD2Ev: __ZN5physx3Ext19ProfileEventHandlerD2Ev, _gcvt: _gcvt, __Z48getNbPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataE: __Z48getNbPxVehicleWheelsSimData_SceneQueryFilterDataPKN5physx22PxVehicleWheelsSimDataE, __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEED0Ev, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13set_empty_keyERKSA_: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13set_empty_keyERKSA_, __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E: __Z19CalculateVertexDataRK14StrideIteratorI8Vector3fES3_RKS_I11ColorRGBA32EPK16MeshTriangleDataRKN4math5_int4ESE_P12SkinMeshInfoRNSB_8floatNx3ESI_RNSB_4pix4E, __ZN33AssetBundleLoadFromAsyncOperation13DeleteStorageEv: __ZN33AssetBundleLoadFromAsyncOperation13DeleteStorageEv, __ZN19SkinnedMeshRenderer5SetupEP4MeshRK13dynamic_arrayI4PPtrI9TransformELj4EE: __ZN19SkinnedMeshRenderer5SetupEP4MeshRK13dynamic_arrayI4PPtrI9TransformELj4EE, __Z38LineRenderer_Get_Custom_PropWidthCurveP12Il2CppObject: __Z38LineRenderer_Get_Custom_PropWidthCurveP12Il2CppObject, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEEEEjT_j, _cacoshf: _cacoshf, __Z61Register_UnityEngine_RenderTexture_INTERNAL_CALL_GenerateMipsv: __Z61Register_UnityEngine_RenderTexture_INTERNAL_CALL_GenerateMipsv, __ZN5Umbra18ReceiverMaskBufferC2ERKS0_: __ZN5Umbra18ReceiverMaskBufferC2ERKS0_, __ZNK15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E13find_positionERS5_: __ZNK15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E13find_positionERS5_, __ZN5physx11HullLibrary9removeb2bEPNS_3TriES2_: __ZN5physx11HullLibrary9removeb2bEPNS_3TriES2_, __ZN23TransformChangeDispatch14RegisterSystemENS_12InterestTypeE: __ZN23TransformChangeDispatch14RegisterSystemENS_12InterestTypeE, __ZNK5Umbra9Matrix2x29isUniformEv: __ZNK5Umbra9Matrix2x29isUniformEv, __Z25CollectNeighbourObstaclesR12dtCrowdAgentRK17ReadonlyCrowdInfo: __Z25CollectNeighbourObstaclesR12dtCrowdAgentRK17ReadonlyCrowdInfo, __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14ShadowSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN22UnityProfilerPerThread21InjectGCCollectSampleEv: __ZN22UnityProfilerPerThread21InjectGCCollectSampleEv, _mkostemp: _mkostemp, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE, __ZN9JSONWrite8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags, __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_: __ZN10Matrix3x3f17SetFromToRotationERK8Vector3fS2_, __ZN5physx3Scb12Articulation17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb12Articulation17getBinaryMetaDataERNS_14PxOutputStreamE, __Z31Texture2D_Get_Custom_PropFormatP12Il2CppObject: __Z31Texture2D_Get_Custom_PropFormatP12Il2CppObject, __ZNK5physx2Sc9ClothCore21getDampingCoefficientEv: __ZNK5physx2Sc9ClothCore21getDampingCoefficientEv, __Z42AssetBundle_CUSTOM_LoadAssetAsync_InternalP12Il2CppObjectP12Il2CppStringS0_: __Z42AssetBundle_CUSTOM_LoadAssetAsync_InternalP12Il2CppObjectP12Il2CppStringS0_, __ZN7mecanim12statemachine24GetTransitionSourceIndexE28TransitionInterruptionSourceNS0_16TransitionSourceE: __ZN7mecanim12statemachine24GetTransitionSourceIndexE28TransitionInterruptionSourceNS0_16TransitionSourceE, __ZN15NavMeshObstacle19OnNavMeshInitializeEv: __ZN15NavMeshObstacle19OnNavMeshInitializeEv, __ZN5physx7NpCloth15setTetherConfigERKNS_19PxClothTetherConfigE: __ZN5physx7NpCloth15setTetherConfigERKNS_19PxClothTetherConfigE, __ZN14AreaEffector2D17SetUseGlobalAngleEb: __ZN14AreaEffector2D17SetUseGlobalAngleEb, __ZN5physx31PxClothGeodesicTetherCookerImpl25computeVertexIntersectionEjjRN12_GLOBAL__N_116PathIntersectionE: __ZN5physx31PxClothGeodesicTetherCookerImpl25computeVertexIntersectionEjjRN12_GLOBAL__N_116PathIntersectionE, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE11runInternalEv, __ZNK7dtCrowd13IsRefOccupiedEy: __ZNK7dtCrowd13IsRefOccupiedEy, __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx14NpRigidDynamic17setCMassLocalPoseERKNS_11PxTransformE: __ZN5physx14NpRigidDynamic17setCMassLocalPoseERKNS_11PxTransformE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj553ENS_22PxRepXPropertyAccessorILj553ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj553ENS_22PxRepXPropertyAccessorILj553ES4_ffEEEEvRKT0_, __ZZN17Physics2DSettings15InitializeClassEvEN15didDestroyWorld7ForwardEv: __ZZN17Physics2DSettings15InitializeClassEvEN15didDestroyWorld7ForwardEv, __ZN5physx20AggregateOverlapTaskD0Ev: __ZN5physx20AggregateOverlapTaskD0Ev, __ZN11UnityEngine9AnimationL19GetTypeTreeBindTypeERK16TypeTreeIterator: __ZN11UnityEngine9AnimationL19GetTypeTreeBindTypeERK16TypeTreeIterator, __ZN4FMOD7SystemI14setSpeakerModeE16FMOD_SPEAKERMODE: __ZN4FMOD7SystemI14setSpeakerModeE16FMOD_SPEAKERMODE, __ZN22ParticleSystemRenderer14UpdateRendererEv: __ZN22ParticleSystemRenderer14UpdateRendererEv, __Z29Time_Set_Custom_PropTimeScalef: __Z29Time_Set_Custom_PropTimeScalef, __ZN13AvatarBuilder14NamedTransformC2ERKS0_: __ZN13AvatarBuilder14NamedTransformC2ERKS0_, __Z39Light_Get_Custom_PropShadowSoftnessFadeP12Il2CppObject: __Z39Light_Get_Custom_PropShadowSoftnessFadeP12Il2CppObject, __Z40ParticleSystem_CUSTOM_INTERNAL_CALL_EmitP12Il2CppObjecti: __Z40ParticleSystem_CUSTOM_INTERNAL_CALL_EmitP12Il2CppObjecti, __Z53Register_UnityEngine_Application_SetStackTraceLogTypev: __Z53Register_UnityEngine_Application_SetStackTraceLogTypev, __ZN5physx2Sc16InteractionScene14retrieveMemoryEv: __ZN5physx2Sc16InteractionScene14retrieveMemoryEv, _csinhf: _csinhf, __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_14PxParticleBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, _csinhl: _csinhl, __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z18SkeletonBoneToMonoRK12SkeletonBoneR16MonoSkeletonBone: __Z18SkeletonBoneToMonoRK12SkeletonBoneR16MonoSkeletonBone, __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags: __Z33TransferPPtrToMonoObjectUnCheckedi24TransferInstructionFlags, __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo: __Z28BuildSingleStreamChannelInfojRK20VertexChannelsLayoutP11ChannelInfo, __ZN5physx34PxcContactConvexHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx34PxcContactConvexHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z18AddGroupToWorkloadR26BlockRangeBalancedWorkloadjR13dynamic_arrayI10BlockRangeLj4EERS1_IjLj4EE: __Z18AddGroupToWorkloadR26BlockRangeBalancedWorkloadjR13dynamic_arrayI10BlockRangeLj4EERS1_IjLj4EE, __ZN5physx7NpShape8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx7NpShape8setFlagsENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN12HingeJoint2D6CreateEv: __ZN12HingeJoint2D6CreateEv, __ZN12_GLOBAL__N_122SocketNetworkOutStream18getWrittenDataSizeEv: __ZN12_GLOBAL__N_122SocketNetworkOutStream18getWrittenDataSizeEv, __ZN9GfxDevice24CreateRenderColorSurfaceE9TextureIDiiii16TextureDimension19RenderTextureFormatj: __ZN9GfxDevice24CreateRenderColorSurfaceE9TextureIDiiii16TextureDimension19RenderTextureFormatj, __ZNK26AnimatorControllerPlayable25GetStateMachineBehavioursEv: __ZNK26AnimatorControllerPlayable25GetStateMachineBehavioursEv, __Z52Register_UnityEngine_AI_NavMeshAgent_get_pathPendingv: __Z52Register_UnityEngine_AI_NavMeshAgent_get_pathPendingv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj176ENS_14PxParticleBaseERKNS_12PxFilterDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_T_, __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE: __Z17DebugStringToFileINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEvRKT_iPKci15LogMessageFlagsiiPFvRK11CppLogEntryE, __Z26AndroidJNI_CUSTOM_ThrowNew13Il2Cpp_IntPtrP12Il2CppString: __Z26AndroidJNI_CUSTOM_ThrowNew13Il2Cpp_IntPtrP12Il2CppString, __ZNK15AudioReverbZone14GetMaxDistanceEv: __ZNK15AudioReverbZone14GetMaxDistanceEv, __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11TimeManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z38HingeJoint2D_Get_Custom_PropLimitStateP12Il2CppObject: __Z38HingeJoint2D_Get_Custom_PropLimitStateP12Il2CppObject, __ZN10VertexData27ConvertLegacyShaderChannelsERK13dynamic_arrayI11ChannelInfoLj4EEi: __ZN10VertexData27ConvertLegacyShaderChannelsERK13dynamic_arrayI11ChannelInfoLj4EEi, __ZN21MinMaxAnimationCurvesaSERKS_: __ZN21MinMaxAnimationCurvesaSERKS_, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfig11ResetValuesEv: __ZN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfig11ResetValuesEv, __ZN9Animation11SetWrapModeEi: __ZN9Animation11SetWrapModeEi, __ZNK13GfxDeviceNull14GetWorldMatrixEv: __ZNK13GfxDeviceNull14GetWorldMatrixEv, __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15AudioReverbZone23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatRGBA888817TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z24getPxScene_SpuDispatcherPKN5physx7PxSceneE: __Z24getPxScene_SpuDispatcherPKN5physx7PxSceneE, __ZNSt3__28messagesIwED2Ev: __ZNSt3__28messagesIwED2Ev, __ZN5Unity9Component23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity9Component23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z22GameObject_CUSTOM_FindP12Il2CppString: __Z22GameObject_CUSTOM_FindP12Il2CppString, __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_17PxExtendedCapsuleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx2Gu29ConvexVsMeshContactGenerationC2ERNS0_9ContainerERKNS_11PxTransformES6_RKNS0_13PolygonalDataERKNS_2Cm8Matrix34ESD_RKNSA_23FastVertex2ShapeScalingEfbfS6_S6_RNS0_13ContactBufferE: __ZN5physx2Gu29ConvexVsMeshContactGenerationC2ERNS0_9ContainerERKNS_11PxTransformES6_RKNS0_13PolygonalDataERKNS_2Cm8Matrix34ESD_RKNSA_23FastVertex2ShapeScalingEfbfS6_S6_RNS0_13ContactBufferE, __ZN4FMOD7Channel12getFrequencyEPf: __ZN4FMOD7Channel12getFrequencyEPf, __ZN10UnityScene23UnloadLevelGameManagersEv: __ZN10UnityScene23UnloadLevelGameManagersEv, __ZNK15DownloadHandler14HasPendingDataEv: __ZNK15DownloadHandler14HasPendingDataEv, __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_15PsMatTransformVE: __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_15PsMatTransformVE, __ZNK4Mesh15GetTopologyMaskEv: __ZNK4Mesh15GetTopologyMaskEv, __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiiiiiS0_iiiii: __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiiiiiS0_iiiii, __Z40WheelCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z40WheelCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN10dtNodePool8findNodeEy: __ZN10dtNodePool8findNodeEy, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14ShadowSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14ShadowSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE, __Z38AlignedCylinderOverlapsOrientedCapsulePfPKfS1_S1_S1_fff: __Z38AlignedCylinderOverlapsOrientedCapsulePfPKfS1_S1_S1_fff, __ZN9CGProgramD2Ev: __ZN9CGProgramD2Ev, __ZN5Unity17ConfigurableJoint9SetZDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint9SetZDriveERK10JointDrive, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv: __ZNK5physx2Sc18ParticleSystemCore20getMaxMotionDistanceEv, __ZN4PPtrI11Rigidbody2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI11Rigidbody2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_png_get_cHRM_XYZ_fixed: _UNITY_png_get_cHRM_XYZ_fixed, __ZN14BillboardAsset5ResetEv: __ZN14BillboardAsset5ResetEv, __ZNK5physx7NpShape12getLocalPoseEv: __ZNK5physx7NpShape12getLocalPoseEv, __ZNK14dtPathCorridor11isPathStaleEv: __ZNK14dtPathCorridor11isPathStaleEv, __ZN14AssetReferenceD2Ev: __ZN14AssetReferenceD2Ev, __ZNK5physx7NpCloth9getFabricEv: __ZNK5physx7NpCloth9getFabricEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE15reserveInternalEj, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5Umbra4Tome15checkCorruptionEv: __ZNK5Umbra4Tome15checkCorruptionEv, __ZN5physx7Cooking9getParamsEv: __ZN5physx7Cooking9getParamsEv, __ZN17AnimationCurveTplI11QuaternionfE16StripInvalidKeysEv: __ZN17AnimationCurveTplI11QuaternionfE16StripInvalidKeysEv, __ZN13GfxDeviceNull20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_: __ZN13GfxDeviceNull20SetShadersMainThreadERK11SubProgramsPK19ShaderPropertySheetS5_, __Z40Terrain_Get_Custom_PropEditorRenderFlagsP12Il2CppObject: __Z40Terrain_Get_Custom_PropEditorRenderFlagsP12Il2CppObject, __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j: __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEEEEEjT_j, _UNITY_FT_Glyph_Copy: _UNITY_FT_Glyph_Copy, __ZThn4_N12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE: __ZThn4_N12_GLOBAL__N_110DataStream14createPropertyERKN5physx8debugger14NamespacedNameEPKcS7_S5_NS2_12PropertyType4EnumENS2_7DataRefINS2_10NamedValueEEE, __ZN8Animator15GetHintPositionEi: __ZN8Animator15GetHintPositionEi, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_RKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_RKS4_, _raccess_guess_darwin_hfsplus: _raccess_guess_darwin_hfsplus, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf: __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPjRf, __Z31Profiler_Set_Custom_PropLogFileP12Il2CppString: __Z31Profiler_Set_Custom_PropLogFileP12Il2CppString, __ZN5physx15PxsParticleData7releaseEv: __ZN5physx15PxsParticleData7releaseEv, __ZN5physx2Sn13XmlNodeReader11removeChildEPKc: __ZN5physx2Sn13XmlNodeReader11removeChildEPKc, __Z63Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatricesv: __Z63Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoViewMatricesv, __ZNSt3__23mapINS_4pairIPcS2_EENS_3setIS2_15compare_tstringIPKcENS_9allocatorIS2_EEEE20smaller_tstring_pairIS7_ENS9_INS1_IKS3_SB_EEEEEixERSE_: __ZNSt3__23mapINS_4pairIPcS2_EENS_3setIS2_15compare_tstringIPKcENS_9allocatorIS2_EEEE20smaller_tstring_pairIS7_ENS9_INS1_IKS3_SB_EEEEEixERSE_, __ZNK8VRDevice20GetScaledEyePullbackEPK6CamerafR8Vector3f: __ZNK8VRDevice20GetScaledEyePullbackEPK6CamerafR8Vector3f, __ZN15OverlapCallback14processTouchesEPKN5physx12PxOverlapHitEj: __ZN15OverlapCallback14processTouchesEPKN5physx12PxOverlapHitEj, __Z13RegisterClassI9Texture2DEvv: __Z13RegisterClassI9Texture2DEvv, __ZN13AudioListener6UpdateEv: __ZN13AudioListener6UpdateEv, __Z55Register_UnityEngine_Physics2D_get_maxAngularCorrectionv: __Z55Register_UnityEngine_Physics2D_get_maxAngularCorrectionv, __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8Vector3fEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sq10AABBPrunerD0Ev: __ZN5physx2Sq10AABBPrunerD0Ev, __Z50SpringJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject: __Z50SpringJoint2D_Get_Custom_PropAutoConfigureDistanceP12Il2CppObject, __Z43Register_UnityEngine_ComputeShader_SetFloatv: __Z43Register_UnityEngine_ComputeShader_SetFloatv, __ZNKSt3__215__codecvt_utf16IDsLb0EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IDsLb0EE6do_outER11__mbstate_tPKDsS5_RS5_PcS7_RS7_, __Z19GetGlobalPreferencePKc: __Z19GetGlobalPreferencePKc, __Z44QualitySettings_Set_Custom_PropSoftParticlesh: __Z44QualitySettings_Set_Custom_PropSoftParticlesh, __ZN17Physics2DSettings20SetColliderAABBColorERK10ColorRGBAf: __ZN17Physics2DSettings20SetColliderAABBColorERK10ColorRGBAf, _ldexpl: _ldexpl, __ZNSt3__26locale5__imp12install_fromINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, _ldexpf: _ldexpf, __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_: __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS4_EEvRT_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED2Ev, _jpeg_fill_bit_buffer: _jpeg_fill_bit_buffer, __Z24profiler_register_objectP6Object: __Z24profiler_register_objectP6Object, __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj: __ZNSt3__26vectorIN19VREyeTextureManager12TextureStageE13stl_allocatorIS2_L18MemLabelIdentifier87ELi16EEE8__appendEj, __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E: __ZN17AnimationCurveTplI11QuaternionfE6AddKeyERK11KeyframeTplIS0_E, __ZN7mecanim8skeleton15DestroySkeletonEPNS0_8SkeletonERNS_6memory9AllocatorE: __ZN7mecanim8skeleton15DestroySkeletonEPNS0_8SkeletonERNS_6memory9AllocatorE, __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh: __ZN5physx2Sc11InteractionC2ERNS0_5ActorES3_NS0_15InteractionTypeEh, __ZL32StaticDestroyRuntimeSceneManagerPv: __ZL32StaticDestroyRuntimeSceneManagerPv, __ZN14Texture2DArrayD2Ev: __ZN14Texture2DArrayD2Ev, __ZN5physx11NpAggregateC2Ejb: __ZN5physx11NpAggregateC2Ejb, __ZN11UnityEngine9Animation14GenericBinding8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11UnityEngine9Animation14GenericBinding8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj: __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6resizeEj, __Z53Register_UnityEngine_Animator_GetNextAnimatorClipInfov: __Z53Register_UnityEngine_Animator_GetNextAnimatorClipInfov, __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getProjectionPlaneERNS_6PxVec3ERf: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getProjectionPlaneERNS_6PxVec3ERf, __Z58Register_UnityEngine_AudioReverbZone_get_roomRolloffFactorv: __Z58Register_UnityEngine_AudioReverbZone_get_roomRolloffFactorv, __ZN6b2Body14DestroyFixtureEP9b2Fixtureb: __ZN6b2Body14DestroyFixtureEP9b2Fixtureb, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN11UnityEngine9AnimationL22GenerateBindingRecurseERK16TypeTreeIteratorP12Il2CppObjectN7mecanim5crc32ER13dynamic_arrayINS0_13CachedBindingELj4EE: __ZN11UnityEngine9AnimationL22GenerateBindingRecurseERK16TypeTreeIteratorP12Il2CppObjectN7mecanim5crc32ER13dynamic_arrayINS0_13CachedBindingELj4EE, __ZN13SparseTexture8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SparseTexture8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11AudioSource17MainThreadCleanupEv: __ZN11AudioSource17MainThreadCleanupEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEEEvPT_jRKT0_RKT1_j, __ZN8Animator20SetLookAtClampWeightEf: __ZN8Animator20SetLookAtClampWeightEf, __ZN5Light23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Light23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z37Register_UnityEngine_Light_get_cookiev: __Z37Register_UnityEngine_Light_get_cookiev, __Z27RegisterAllowNameConversionR20AllowNameConversionsPKcS2_S2_: __Z27RegisterAllowNameConversionR20AllowNameConversionsPKcS2_S2_, __ZN16SubstanceArchive23VirtualRedirectTransferER14SafeBinaryRead: __ZN16SubstanceArchive23VirtualRedirectTransferER14SafeBinaryRead, __Z64Register_UnityEngine_Transform_INTERNAL_CALL_SetLocalEulerAnglesv: __Z64Register_UnityEngine_Transform_INTERNAL_CALL_SetLocalEulerAnglesv, __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE16StaticInitializeEPv: __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE16StaticInitializeEPv, __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN22NavMeshProjectSettings15NavMeshAreaData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10systeminfo22GetDeviceSystemVersionEv: __ZN10systeminfo22GetDeviceSystemVersionEv, __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9LensFlare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z34setPxVehicleWheelsSimData_TireDataPN5physx22PxVehicleWheelsSimDataEjNS_17PxVehicleTireDataE: __Z34setPxVehicleWheelsSimData_TireDataPN5physx22PxVehicleWheelsSimDataEjNS_17PxVehicleTireDataE, __ZN5physx3Ext14SphericalJoint21setSphericalJointFlagENS_20PxSphericalJointFlag4EnumEb: __ZN5physx3Ext14SphericalJoint21setSphericalJointFlagENS_20PxSphericalJointFlag4EnumEb, __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj8ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE: __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj8ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED0Ev: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED0Ev, __ZNK24OcclusionCullingSettings20InvalidatePVSOnSceneEv: __ZNK24OcclusionCullingSettings20InvalidatePVSOnSceneEv, __Z39Input_Set_Custom_PropImeCompositionModei: __Z39Input_Set_Custom_PropImeCompositionModei, __ZN5physx2Sq10AABBPruner13updateObjectsEPKjPKNS_9PxBounds3Ej: __ZN5physx2Sq10AABBPruner13updateObjectsEPKjPKNS_9PxBounds3Ej, __Z27ComputeShader_CUSTOM_SetIntP12Il2CppObjectii: __Z27ComputeShader_CUSTOM_SetIntP12Il2CppObjectii, __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolStringv: __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolStringv, __ZN12MeshCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12MeshCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN22ProceduralMaterialData20ReleaseTextureInputsEv: __ZN22ProceduralMaterialData20ReleaseTextureInputsEv, __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj: __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE6resizeEjRKj, __ZN5physx8debugger14PvdMarshallingIifE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIifE12marshalBlockEPKhPhj, __ZThn4_N12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj: __ZThn4_N12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj, __ZNK12_GLOBAL__N_112UserRenderer10hasClientsEv: __ZNK12_GLOBAL__N_112UserRenderer10hasClientsEv, __ZNK13b2DynamicTree9GetHeightEv: __ZNK13b2DynamicTree9GetHeightEv, __Z52Register_UnityEngine_GUIUtility_Internal_GetGUIDepthv: __Z52Register_UnityEngine_GUIUtility_Internal_GetGUIDepthv, __ZN5audio5mixer12UpdateBypassERNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryE: __ZN5audio5mixer12UpdateBypassERNS0_18AudioMixerConstantERNS0_16AudioMixerMemoryE, __ZNK12HingeJoint2D13GetJointSpeedEv: __ZNK12HingeJoint2D13GetJointSpeedEv, __ZN5physx3Scb5Scene11addMaterialERNS_2Sc12MaterialCoreE: __ZN5physx3Scb5Scene11addMaterialERNS_2Sc12MaterialCoreE, __ZN5UmbramlERKNS_9Matrix3x3ES2_: __ZN5UmbramlERKNS_9Matrix3x3ES2_, __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEE7getNameEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9push_backEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEE9push_backEc, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNSt3__2L22utf16be_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE: __ZNSt3__2L22utf16be_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE, __Z58Register_UnityEngine_Terrain_SetSplatMaterialPropertyBlockv: __Z58Register_UnityEngine_Terrain_SetSplatMaterialPropertyBlockv, __ZN6Camera24OnRenderTextureDestroyedEP13RenderTexture: __ZN6Camera24OnRenderTextureDestroyedEP13RenderTexture, __Z56Register_UnityEngine_ParticleSystem_ShapeModule_SetAnglev: __Z56Register_UnityEngine_ParticleSystem_ShapeModule_SetAnglev, __Z71Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionNonAllocv: __Z71Register_UnityEngine_Physics2D_INTERNAL_CALL_GetRayIntersectionNonAllocv, __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetFieldIDv: __Z56Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetFieldIDv, __ZN5physx2Sq8populateEPKNS0_10ActorShapeE: __ZN5physx2Sq8populateEPKNS0_10ActorShapeE, __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10TagManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZThn4_NK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZThn4_NK5physx5cloth9SwFactory28extractSeparationConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_, __Z13RegisterClassI21AudioDistortionFilterEvv: __Z13RegisterClassI21AudioDistortionFilterEvv, __Z19GetRaycastInterfacev: __Z19GetRaycastInterfacev, __ZZN15DirectorManager15InitializeClassEvEN47FixedUpdateDirectorFixedUpdatePostPhysicsstruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN47FixedUpdateDirectorFixedUpdatePostPhysicsstruct7ForwardEv, __ZN33EnlightenTerrainChunksInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN33EnlightenTerrainChunksInformation8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_OverlapPointv: __Z59Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_OverlapPointv, __Z22scripting_object_unboxP12Il2CppObject: __Z22scripting_object_unboxP12Il2CppObject, _UNITY_FT_Raccess_Get_HeaderInfo: _UNITY_FT_Raccess_Get_HeaderInfo, __ZN16BaseVideoTexture15InitVideoMemoryEii: __ZN16BaseVideoTexture15InitVideoMemoryEii, __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE: __ZN5physx2Gu11ConvexHullVC2EPKNS0_14ConvexHullDataERKNS_6shdfnd3aos5Vec3VES9_RKNS6_5Vec4VE, __ZN11MemoryStats9SerializeER13dynamic_arrayIiLj4EE: __ZN11MemoryStats9SerializeER13dynamic_arrayIiLj4EE, __Z52Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionAllRK3Rayfi: __Z52Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionAllRK3Rayfi, __ZN5Umbra5FloatC2Ej: __ZN5Umbra5FloatC2Ej, __ZN5Umbra5FloatC2Ei: __ZN5Umbra5FloatC2Ei, __Z13TransferFieldI17RemapPPtrTransferLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI17RemapPPtrTransferLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __Z42Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaRK13Vector2fIcallS1_iff: __Z42Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaRK13Vector2fIcallS1_iff, __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_: __ZN5physx6shdfnd5slerpEfRKNS_6PxQuatES3_, __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshRendererv: __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshRendererv, __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21InheritVelocityModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE8__appendEj, __Z39ParticleSystem_Get_Custom_PropIsPlayingP12Il2CppObject: __Z39ParticleSystem_Get_Custom_PropIsPlayingP12Il2CppObject, __Z40CullingGroup_Get_Custom_PropTargetCameraP12Il2CppObject: __Z40CullingGroup_Get_Custom_PropTargetCameraP12Il2CppObject, __ZNK24iPhoneRemoteNotification12GetAlertBodyEv: __ZNK24iPhoneRemoteNotification12GetAlertBodyEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj, __ZL30InitializeModule_TextRenderingv: __ZL30InitializeModule_TextRenderingv, __ZN5physx3Scb5Scene6getPvdEv: __ZN5physx3Scb5Scene6getPvdEv, __Z89Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddAmbientLightInternalv: __Z89Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddAmbientLightInternalv, __Z35Terrain_Get_Custom_PropTreeDistanceP12Il2CppObject: __Z35Terrain_Get_Custom_PropTreeDistanceP12Il2CppObject, __ZN5physx12NpBatchQueryD0Ev: __ZN5physx12NpBatchQueryD0Ev, __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE15clearCachedDataEv: __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE15clearCachedDataEv, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc: __ZN5physx6shdfnd5ArrayIcNS0_19ReflectionAllocatorIcEEE15growAndPushBackERKc, __ZN10MeshFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10MeshFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7SetSizeEi, __ZN5physx2Sc13ConstraintSim14hasDynamicBodyEv: __ZN5physx2Sc13ConstraintSim14hasDynamicBodyEv, __ZN5physx10NpMaterial14setRestitutionEf: __ZN5physx10NpMaterial14setRestitutionEf, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertIPKwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPwEEE4typeENSB_IS8_EESA_SA_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertIPKwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPwEEE4typeENSB_IS8_EESA_SA_, __ZN11UnityEngine15CloudWebService14RestDownloader22OnReceiveContentLengthEj: __ZN11UnityEngine15CloudWebService14RestDownloader22OnReceiveContentLengthEj, __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb: __ZN17TransformInternal24AddTransformSubhierarchyER18TransformHierarchyjS1_RjS2_jb, __ZL22SRGB_LinearToGamma_JobP17ImageSliceJobDataj: __ZL22SRGB_LinearToGamma_JobP17ImageSliceJobDataj, __Z42UnityAdsSettings_CUSTOM_SetPlatformEnabledih: __Z42UnityAdsSettings_CUSTOM_SetPlatformEnabledih, __Z15SetAlphaChanneliiPhi13TextureFormath: __Z15SetAlphaChanneliiPhi13TextureFormath, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimev: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFrameOverTimev, __ZN5physx24PxDeserializationContextD2Ev: __ZN5physx24PxDeserializationContextD2Ev, __ZN16UploadHandlerRaw5ResetEv: __ZN16UploadHandlerRaw5ResetEv, _UNITY_png_get_mem_ptr: _UNITY_png_get_mem_ptr, __Z44Register_UnityEngine_Animator_get_parametersv: __Z44Register_UnityEngine_Animator_get_parametersv, __Z49Physics2D_CUSTOM_INTERNAL_set_colliderAsleepColorRK10ColorRGBAf: __Z49Physics2D_CUSTOM_INTERNAL_set_colliderAsleepColorRK10ColorRGBAf, __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_: __ZN5physx11PxMeshQuery11getTriangleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformEjRNS_10PxTriangleEPjS9_, __ZN5physx2Gu25PersistentContactManifold25addBatchManifoldContacts2EPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold25addBatchManifoldContacts2EPKNS0_17PersistentContactEj, __ZN12SoundManager15GetProfilerDataER10AudioStats: __ZN12SoundManager15GetProfilerDataER10AudioStats, __ZN4PPtrI23ShaderVariantCollectionE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI23ShaderVariantCollectionE8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEEEEjT_j: __ZNK5physx34PxHeightFieldGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEEEEjT_j, __Z20CheckMessageDataTypeiR11MessageData: __Z20CheckMessageDataTypeiR11MessageData, __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI10RectOffset13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi: __ZL30FindOrCreateTypeInfoForClassIDR13dynamic_arrayIN14SerializedFile4TypeELj8EEibsi, __ZN20TextRenderingPrivate8FontImpl8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE: __ZN16Converter_String17ScriptingToNativeEP12Il2CppStringPNSt3__212basic_stringIcNS2_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEE, __ZN4FMOD4DSPI9setBypassEb: __ZN4FMOD4DSPI9setBypassEb, __ZN15TerrainCollider14SetTerrainDataE4PPtrI11TerrainDataE: __ZN15TerrainCollider14SetTerrainDataE4PPtrI11TerrainDataE, __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitv: __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_get_linearLimitv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb, __ZN5physx26PxControllerFilterCallbackD2Ev: __ZN5physx26PxControllerFilterCallbackD2Ev, __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj615ES4_NS_17PxVehicleTireDataEKjNS_30PxVehicleTireDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZNK18DelayedCallManager26GetTypeInfoVirtualInternalEv: __ZNK18DelayedCallManager26GetTypeInfoVirtualInternalEv, _UNITY_png_check_chunk_name: _UNITY_png_check_chunk_name, _if_freenameindex: _if_freenameindex, __Z28Animator_CUSTOM_StringToHashP12Il2CppString: __Z28Animator_CUSTOM_StringToHashP12Il2CppString, __ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE: __ZN5physx2Gu15EdgeListBuilder4InitERKNS0_14EDGELISTCREATEE, __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDPairELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __Z7Empty2DP9Texture2DPhiiii: __Z7Empty2DP9Texture2DPhiiii, __ZN14VRSplashScreenD0Ev: __ZN14VRSplashScreenD0Ev, __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_: __ZNSt3__27__sort5IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_SB_SB_T_, __Z66Register_UnityEngine_StaticBatchingUtility_InternalCombineVerticesv: __Z66Register_UnityEngine_StaticBatchingUtility_InternalCombineVerticesv, __ZN12GUIClipStateD2Ev: __ZN12GUIClipStateD2Ev, __ZL33GeomMTDCallback_SphereHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL33GeomMTDCallback_SphereHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN11UnityEngine7Connect18ConnectSessionInfoD2Ev: __ZN11UnityEngine7Connect18ConnectSessionInfoD2Ev, __ZN12FixedJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12FixedJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx16PxsIslandManager28clearDeletedNodeStateChangesEv: __ZN5physx16PxsIslandManager28clearDeletedNodeStateChangesEv, __ZN12GUIClipState22GetTopMostPhysicalRectEv: __ZN12GUIClipState22GetTopMostPhysicalRectEv, __ZNK5physx13NpClothFabric11getNbPhasesEv: __ZNK5physx13NpClothFabric11getNbPhasesEv, __ZZN22ParticleSystemRenderer15InitializeClassEvEN29FunctorImpl_104kDidDeleteMesh4CallEPviR11MessageData: __ZZN22ParticleSystemRenderer15InitializeClassEvEN29FunctorImpl_104kDidDeleteMesh4CallEPviR11MessageData, __ZN5physx2Sn18writeAllPropertiesINS_18PxJointLinearLimitEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_18PxJointLinearLimitEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __ZN15NavMeshObstacle10SetCarvingEb: __ZN15NavMeshObstacle10SetCarvingEb, __Z41AreaEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D: __Z41AreaEffector2D_Set_Custom_PropForceTargetP12Il2CppObject19EffectorSelection2D, __ZN12EventManager8AddEventEPFvPvS0_iES0_P10EventEntry: __ZN12EventManager8AddEventEPFvPvS0_iES0_P10EventEntry, __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterPropertiesv: __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterPropertiesv, __Z48Register_UnityEngine_LineRenderer_set_startWidthv: __Z48Register_UnityEngine_LineRenderer_set_startWidthv, __ZL11RenderLightRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionRP13RenderTextureS9_iiPK18DeviceStencilStateRK10MinMaxAABBRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext: __ZL11RenderLightRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionRP13RenderTextureS9_iiPK18DeviceStencilStateRK10MinMaxAABBRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext, __ZNK5physx7NpCloth19getPreviousTimeStepEv: __ZNK5physx7NpCloth19getPreviousTimeStepEv, __ZN7mecanim9animation13GetRootStartXERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation13GetRootStartXERKNS0_18ClipMuscleConstantE, __Z34ReflectionProbe_Get_Custom_PropHdrP12Il2CppObject: __Z34ReflectionProbe_Get_Custom_PropHdrP12Il2CppObject, __ZN5physx6shdfnd6TlsSetEjPv: __ZN5physx6shdfnd6TlsSetEjPv, __ZN5physx2Sc5Scene7endStepEv: __ZN5physx2Sc5Scene7endStepEv, __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject: __ZN27Converter_SimpleNativeClassI17AnimationCurveTplIfEE17NativeToScriptingERKS1_RP12Il2CppObject, __Z43SurfaceEffector2D_Set_Custom_PropForceScaleP12Il2CppObjectf: __Z43SurfaceEffector2D_Set_Custom_PropForceScaleP12Il2CppObjectf, __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi: __Z15CreatePrimitiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi, __Z43Register_UnityEngine_Renderer_get_isVisiblev: __Z43Register_UnityEngine_Renderer_get_isVisiblev, __ZN22UnityAnalyticsSettings8TransferI14SafeBinaryReadEEvRT_: __ZN22UnityAnalyticsSettings8TransferI14SafeBinaryReadEEvRT_, __ZN8Collider7CleanupEv: __ZN8Collider7CleanupEv, __Z39Register_UnityEngine_AssetBundle_Unloadv: __Z39Register_UnityEngine_AssetBundle_Unloadv, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE19getConcreteTypeNameEv, __Z57Register_UnityEngine_ConfigurableJoint_set_angularZMotionv: __Z57Register_UnityEngine_ConfigurableJoint_set_angularZMotionv, __ZN10SampleClip8TransferI14SafeBinaryReadEEvRT_: __ZN10SampleClip8TransferI14SafeBinaryReadEEvRT_, __ZL16SweepCapsuleMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL16SweepCapsuleMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeP11Il2CppArray: __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeP11Il2CppArray, _fminl: _fminl, __ZN9Texture2D8CompressEb: __ZN9Texture2D8CompressEb, __Z44PlatformEffector2D_Get_Custom_PropSurfaceArcP12Il2CppObject: __Z44PlatformEffector2D_Get_Custom_PropSurfaceArcP12Il2CppObject, __ZN25RuntimeAnimatorController8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN25RuntimeAnimatorController8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx20PxClothMeshQuadifierD2Ev: __ZN5physx20PxClothMeshQuadifierD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __Z35Application_Get_Custom_PropPlatformv: __Z35Application_Get_Custom_PropPlatformv, __Z30GetLightProbeProxyVolumeSampleRK28LightProbeProxyVolumeContextsR27LightProbeProxyVolumeSample: __Z30GetLightProbeProxyVolumeSampleRK28LightProbeProxyVolumeContextsR27LightProbeProxyVolumeSample, _fminf: _fminf, __ZN7Terrain23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN7Terrain23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN17AnimationCurveTplI8Vector3fE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17AnimationCurveTplI8Vector3fE8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12MeshCollider6CreateEPK9Rigidbody: __ZN12MeshCollider6CreateEPK9Rigidbody, __ZNK10FileSystem9LastErrorEv: __ZNK10FileSystem9LastErrorEv, __ZNSt3__218__insertion_sort_3IRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_: __ZNSt3__218__insertion_sort_3IRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_, __ZNSt3__227__insertion_sort_incompleteIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEbT0_SB_T_: __ZNSt3__227__insertion_sort_incompleteIRN11UnityEngine9Animation11BindingSortEPNS_4pairINS2_14GenericBindingEPNS2_10BoundIndexEEEEEbT0_SB_T_, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS2_S5_EE, __Z44TrailRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject: __Z44TrailRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject, __Z51Register_UnityEngine_Animator_get_recorderStartTimev: __Z51Register_UnityEngine_Animator_get_recorderStartTimev, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEvPT_jRKT0_RKT1_j, _sincosl: _sincosl, __ZNK5physx3Cct17CapsuleController13getStepOffsetEv: __ZNK5physx3Cct17CapsuleController13getStepOffsetEv, __Z48SystemInfo_Get_Custom_PropSupportsRenderTexturesv: __Z48SystemInfo_Get_Custom_PropSupportsRenderTexturesv, __ZNSt3__26vectorI20ShadowCasterPartData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI20ShadowCasterPartData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb: __ZN5physx2Gu15MeshRayCollider10collideOBBERKNS0_3BoxEbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEb, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat14TexFormatRHalfEEvPKNS_9InnerInfoE, __ZN18DeferredRenderLoop17RenderReflectionsEP13RenderTexturePS1_: __ZN18DeferredRenderLoop17RenderReflectionsEP13RenderTexturePS1_, __ZN11MonoManager17GetScriptingClassEPKcS1_S1_: __ZN11MonoManager17GetScriptingClassEPKcS1_S1_, __Z27RenderSettings_CUSTOM_Resetv: __Z27RenderSettings_CUSTOM_Resetv, __Z35Transfer_Blittable_SingleValueFieldI8JSONRead10Matrix4x4fEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI8JSONRead10Matrix4x4fEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __ZN14AvatarPlayback9StartTimeEv: __ZN14AvatarPlayback9StartTimeEv, __ZNSt3__217__assoc_sub_state12__make_readyEv: __ZNSt3__217__assoc_sub_state12__make_readyEv, __ZThn32_N19SkinnedMeshRendererD0Ev: __ZThn32_N19SkinnedMeshRendererD0Ev, _unity_z_tr_init: _unity_z_tr_init, __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_: __ZN5physx2Gu33closestPtPointTriangleTesselationEPNS_6shdfnd3aos5Vec3VES4_S4_PjRjRS3_S7_, _compress_output: _compress_output, __ZN14AreaEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14AreaEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN26AnimatorOverrideController7SetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI13AnimationClipEb: __ZN26AnimatorOverrideController7SetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE4PPtrI13AnimationClipEb, __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEE13StaticDestroyEPv, __ZNK5physx10PxMaterial8isKindOfEPKc: __ZNK5physx10PxMaterial8isKindOfEPKc, __ZN14NavMeshManager10UnloadDataEi: __ZN14NavMeshManager10UnloadDataEi, __ZN15ReflectionProbe16CheckConsistencyEv: __ZN15ReflectionProbe16CheckConsistencyEv, __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamES3_: __ZN5physx2Sn5ConvX11setMetaDataERNS_13PxInputStreamES3_, __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11PreloadData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5Umbra9RasterOps4fillERNS_17BlockRasterBufferEi: __ZN5Umbra9RasterOps4fillERNS_17BlockRasterBufferEi, __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE: __ZNK16SpriteRenderData20CalculateUVsIfNeededEbRK8Vector2fRK5RectTIfE, __ZNKSt3__211__libcpp_db9__addableEPKvi: __ZNKSt3__211__libcpp_db9__addableEPKvi, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE7getNameEv, __ZN13UnityProfiler27RecordPreviousFrameInternalE12ProfilerMode: __ZN13UnityProfiler27RecordPreviousFrameInternalE12ProfilerMode, __ZN13MemoryManager20GetTempAllocatorSizeEv: __ZN13MemoryManager20GetTempAllocatorSizeEv, __GLOBAL__sub_I_runtime_virtualfilesystem_memoryfilesystem_lump_cpp: __GLOBAL__sub_I_runtime_virtualfilesystem_memoryfilesystem_lump_cpp, __Z22Check4MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_S1_P6ObjectR11MonoManager: __Z22Check4MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_S1_S1_P6ObjectR11MonoManager, __ZN15NavMeshObstacle16SetMoveThresholdEf: __ZN15NavMeshObstacle16SetMoveThresholdEf, __ZN13RenderManager19GetCurrentCameraPtrEv: __ZN13RenderManager19GetCurrentCameraPtrEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj573ENS_22PxRepXPropertyAccessorILj573ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj573ENS_22PxRepXPropertyAccessorILj573ES4_ffEEEEvRKT0_, __ZN8Animator8GetFloatEiRfb: __ZN8Animator8GetFloatEiRfb, __ZN5physx2Sn10parseShapeINS0_17RepXVisitorReaderINS_7PxShapeEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE: __ZN5physx2Sn10parseShapeINS0_17RepXVisitorReaderINS_7PxShapeEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE, _cff_cmap_unicode_char_index: _cff_cmap_unicode_char_index, __ZN20TextRenderingPrivate22ScriptingTextGenerator19GetStringRenderInfoERS0_RKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEPNS_8FontImplE11ColorRGBA32iffibbiiNS0_16VerticalWrapModeENS0_18HorizontalWrapModeEbiRK8Vector2fSI_bbbPj: __ZN20TextRenderingPrivate22ScriptingTextGenerator19GetStringRenderInfoERS0_RKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEPNS_8FontImplE11ColorRGBA32iffibbiiNS0_16VerticalWrapModeENS0_18HorizontalWrapModeEbiRK8Vector2fSI_bbbPj, __ZL34GetComponentsImplementationRecurseILb0ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN8Remapper33RemoveCompleteSerializedFileIndexEiRNSt3__26vectorIiNS0_9allocatorIiEEEE: __ZN8Remapper33RemoveCompleteSerializedFileIndexEiRNSt3__26vectorIiNS0_9allocatorIiEEEE, __ZNK20IntermediateRenderer11GetMaterialEi: __ZNK20IntermediateRenderer11GetMaterialEi, __ZN9GfxDevice20CleanupSharedBuffersEv: __ZN9GfxDevice20CleanupSharedBuffersEv, __ZN12_GLOBAL__N_110DataStream10endSectionEPKvPKc: __ZN12_GLOBAL__N_110DataStream10endSectionEPKvPKc, __Z42Register_UnityEngine_Mesh_GetTrianglesImplv: __Z42Register_UnityEngine_Mesh_GetTrianglesImplv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEED0Ev, __ZN5IMGUI16GetFocusedWindowER8GUIState: __ZN5IMGUI16GetFocusedWindowER8GUIState, __ZN9ShaderLab11ShaderState29FindPropsAffectingStateBlocksERK19ShaderPropertySheetR13dynamic_arrayIiLj4EE: __ZN9ShaderLab11ShaderState29FindPropsAffectingStateBlocksERK19ShaderPropertySheetR13dynamic_arrayIiLj4EE, __Z53Register_UnityEngine_ConstantForce_INTERNAL_set_forcev: __Z53Register_UnityEngine_ConstantForce_INTERNAL_set_forcev, __ZN19SkinnedMeshRenderer8BakeMeshER4Mesh: __ZN19SkinnedMeshRenderer8BakeMeshER4Mesh, __Z43Register_UnityEngine_Animator_StartPlaybackv: __Z43Register_UnityEngine_Animator_StartPlaybackv, __ZN7mecanim5human14MuscleFromBoneEii: __ZN7mecanim5human14MuscleFromBoneEii, __ZN5physx2Gu19gjkRelativeFallbackERKNS0_7ConvexVES3_PNS0_10SupportMapES5_RKNS_6shdfnd3aos5Vec3VERS8_SB_SB_RNS7_6FloatVE: __ZN5physx2Gu19gjkRelativeFallbackERKNS0_7ConvexVES3_PNS0_10SupportMapES5_RKNS_6shdfnd3aos5Vec3VERS8_SB_SB_RNS7_6FloatVE, _sfnt_module_class_pic_init: _sfnt_module_class_pic_init, __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_EC2ERKSL_j, __ZN2UI13CanvasManager39EmitScreenSpaceCamerasGeometryForCameraEP6CameraS2_: __ZN2UI13CanvasManager39EmitScreenSpaceCamerasGeometryForCameraEP6CameraS2_, __Z25Light_Set_Custom_PropTypeP12Il2CppObject9LightType: __Z25Light_Set_Custom_PropTypeP12Il2CppObject9LightType, __ZN11UnityEngine15CloudWebService14DataDispatcher31ReleaseDispatchSessionContainerERNS0_16SessionContainerEb: __ZN11UnityEngine15CloudWebService14DataDispatcher31ReleaseDispatchSessionContainerERNS0_16SessionContainerEb, _UNITY_png_read_filter_row: _UNITY_png_read_filter_row, __ZN10AudioMixer20GetGroupNameFromGUIDERK9UnityGUID: __ZN10AudioMixer20GetGroupNameFromGUIDERK9UnityGUID, __Z30Skybox_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z30Skybox_Set_Custom_PropMaterialP12Il2CppObjectS0_, __ZNK5physx7NpCloth21getCollisionMassScaleEv: __ZNK5physx7NpCloth21getCollisionMassScaleEv, __ZNK20GpuProgramParameters13PrepareValuesEPK19ShaderPropertySheetS2_R13dynamic_arrayIhLj4EEjP12GfxPatchInfoPb: __ZNK20GpuProgramParameters13PrepareValuesEPK19ShaderPropertySheetS2_R13dynamic_arrayIhLj4EEjP12GfxPatchInfoPb, __ZN21AudioDistortionFilterD2Ev: __ZN21AudioDistortionFilterD2Ev, __ZN5physx7NpShape9visualizeERNS_2Cm12RenderOutputERKNS_12PxRigidActorE: __ZN5physx7NpShape9visualizeERNS_2Cm12RenderOutputERKNS_12PxRigidActorE, __ZN4FMOD7SystemI13get3DSettingsEPfS1_S1_: __ZN4FMOD7SystemI13get3DSettingsEPfS1_S1_, __Z52Register_UnityEngine_Physics2D_get_showColliderSleepv: __Z52Register_UnityEngine_Physics2D_get_showColliderSleepv, __ZNK10GUITexture26GetTypeInfoVirtualInternalEv: __ZNK10GUITexture26GetTypeInfoVirtualInternalEv, __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE8__appendEj, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZN5physx8debugger26PropertyMessageDescriptionD2Ev: __ZN5physx8debugger26PropertyMessageDescriptionD2Ev, _cff_get_kerning: _cff_get_kerning, __Z56Register_UnityEngine_TrailRenderer_get_minVertexDistancev: __Z56Register_UnityEngine_TrailRenderer_get_minVertexDistancev, __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXv: __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationXv, __Z39getPxVehicleDifferential4WDataMRearBiasPKN5physx27PxVehicleDifferential4WDataE: __Z39getPxVehicleDifferential4WDataMRearBiasPKN5physx27PxVehicleDifferential4WDataE, __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __Z31CrashReport_CUSTOM_RemoveReportP12Il2CppString: __Z31CrashReport_CUSTOM_RemoveReportP12Il2CppString, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getMaxParticlesEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15getMaxParticlesEv, __ZN5Umbra4Math4sqrtERKNS_6DoubleE: __ZN5Umbra4Math4sqrtERKNS_6DoubleE, __Z48Register_UnityEngine_DynamicGI_set_indirectScalev: __Z48Register_UnityEngine_DynamicGI_set_indirectScalev, __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionYP12Il2CppObjecti: __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionYP12Il2CppObjecti, __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearSeparationConstraintsEv, __ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv: __ZN11UnityEngine15CloudWebService19SessionEventManager31SetupNextActiveSessionContainerEv, __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8Gradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_, ___toread_needs_stdio_exit: ___toread_needs_stdio_exit, __ZN10GameObject20AddComponentInternalERS_RN5Unity9ComponentE: __ZN10GameObject20AddComponentInternalERS_RN5Unity9ComponentE, __ZN14SphereCollider15ThreadedCleanupEv: __ZN14SphereCollider15ThreadedCleanupEv, _sn_write: _sn_write, __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_: __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTextureP8MaterialiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSC_, __ZN7mecanim12statemachine18TransitionConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine18TransitionConstant8TransferI14SafeBinaryReadEEvRT_, __ZN13InitialModule5StartERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fjf: __ZN13InitialModule5StartERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesRK10Matrix4x4fjf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEEEvRT_17TransferMetaFlags, __ZN17GenericDynamicVBO18ReserveIndexBufferEjj: __ZN17GenericDynamicVBO18ReserveIndexBufferEjj, __ZNSt3__212system_errorC2ENS_10error_codeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__212system_errorC2ENS_10error_codeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN25MeshMTDGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN25MeshMTDGenerationCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZN14PreloadManager33PrepareProcessingPreloadOperationEv: __ZN14PreloadManager33PrepareProcessingPreloadOperationEv, __ZN24PhysicsUpdateBehaviour2D15ThreadedCleanupEv: __ZN24PhysicsUpdateBehaviour2D15ThreadedCleanupEv, __ZN9ShaderLab10GrabPasses13ApplyGrabPassERKNS_16FastPropertyNameER17ShaderPassContextRKS0_: __ZN9ShaderLab10GrabPasses13ApplyGrabPassERKNS_16FastPropertyNameER17ShaderPassContextRKS0_, __ZN22LocalFileSystemHandler16CurrentDirectoryEv: __ZN22LocalFileSystemHandler16CurrentDirectoryEv, __Z38Register_UnityEngine_Material_SetFloatv: __Z38Register_UnityEngine_Material_SetFloatv, __ZN13GfxDeviceNull12GetSRGBWriteEv: __ZN13GfxDeviceNull12GetSRGBWriteEv, __ZN4FMOD7SystemI23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_: __ZN4FMOD7SystemI23set3DListenerAttributesEiPK11FMOD_VECTORS3_S3_S3_, __Z36AudioSource_Get_Custom_PropPanStereoP12Il2CppObject: __Z36AudioSource_Get_Custom_PropPanStereoP12Il2CppObject, __Z18Transfer_BlittableI8JSONReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7TerrainD0Ev: __ZN7TerrainD0Ev, __ZNK5physx2Sc9ClothCore25getAngularDragCoefficientEv: __ZNK5physx2Sc9ClothCore25getAngularDragCoefficientEv, _UNITY_tt_face_done: _UNITY_tt_face_done, __Z50Register_UnityEngine_Cloth_set_useVirtualParticlesv: __Z50Register_UnityEngine_Cloth_set_useVirtualParticlesv, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED0Ev: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED0Ev, __ZNK13GfxDeviceGLES18GetCurrentTargetAAEv: __ZNK13GfxDeviceGLES18GetCurrentTargetAAEv, __ZN16StreamedResource8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16StreamedResource8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN21LightProbeProxyVolume12GetProbeAABBEv: __ZN21LightProbeProxyVolume12GetProbeAABBEv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN20SoundChannelInstance11set3DSpreadEf: __ZN20SoundChannelInstance11set3DSpreadEf, __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE: __ZN11TerrainData11NotifyUsersENS_12ChangedFlagsE, __ZN12LineRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12LineRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN17PolygonCollider2D15CreatePrimitiveEi8Vector2fS0_b: __ZN17PolygonCollider2D15CreatePrimitiveEi8Vector2fS0_b, __ZL23DebugGetDeviceConnectedv: __ZL23DebugGetDeviceConnectedv, __Z13RegisterClassI12MeshRendererEvv: __Z13RegisterClassI12MeshRendererEvv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_17PxTolerancesScaleEE12readPropertyIfEEbRT_, __ZN10Matrix3x3faSERK10Matrix4x4f: __ZN10Matrix3x3faSERK10Matrix4x4f, __ZN13PhysicsModule19ReleaseNxConvexMeshEP17PhysicsModuleMesh: __ZN13PhysicsModule19ReleaseNxConvexMeshEP17PhysicsModuleMesh, __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_get_linearOffsetv: __Z62Register_UnityEngine_RelativeJoint2D_INTERNAL_get_linearOffsetv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_, __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastAllv: __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastAllv, __ZN12ImageDecoder14MemoryReadFuncEPvPhj: __ZN12ImageDecoder14MemoryReadFuncEPvPhj, __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb: __ZN20SpeedTreeWindManager21PrepareWindPropertiesER19ShaderPropertySheetb, __ZN14NavMeshManager19RegisterOffMeshLinkER11OffMeshLinkRi: __ZN14NavMeshManager19RegisterOffMeshLinkER11OffMeshLinkRi, __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatRGBA444417TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZNK9DebugGLES10LogApiCallEPKcS1_l: __ZNK9DebugGLES10LogApiCallEPKcS1_l, __ZN16ParticleSortData12CompareValueERKS_S1_: __ZN16ParticleSortData12CompareValueERKS_S1_, __ZNK20b2SeparationFunction17FindMinSeparationEPiS0_f: __ZNK20b2SeparationFunction17FindMinSeparationEPiS0_f, __Z72Camera_Set_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObjecth: __Z72Camera_Set_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObjecth, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwjj, __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEED0Ev, __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext23InternalCapsuleObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext23InternalCapsuleObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z23DrawSplashAndWatermarksv: __Z23DrawSplashAndWatermarksv, __ZN4Mesh9SetColorsEPK11ColorRGBA32j: __ZN4Mesh9SetColorsEPK11ColorRGBA32j, _cprojf: _cprojf, __ZN10GameObject14SwapComponentsEii: __ZN10GameObject14SwapComponentsEii, __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolStringv: __Z83Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolStringv, __ZN16BaseVideoTexture15ThreadedCleanupEv: __ZN16BaseVideoTexture15ThreadedCleanupEv, __ZN5physx2Gu9RadixSortD0Ev: __ZN5physx2Gu9RadixSortD0Ev, __ZN5physx2Sc20ArticulationJointSimD2Ev: __ZN5physx2Sc20ArticulationJointSimD2Ev, __Z55Register_UnityEngine_CharacterController_get_isGroundedv: __Z55Register_UnityEngine_CharacterController_get_isGroundedv, __ZN5physx7NpScene10setGravityERKNS_6PxVec3E: __ZN5physx7NpScene10setGravityERKNS_6PxVec3E, __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIiEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Gu12TriangleMesh11getVerticesEv: __ZNK5physx2Gu12TriangleMesh11getVerticesEv, __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossMultiplierv: __Z77Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossMultiplierv, __Z24RegisterStrippedTypeInfoI9RigidbodyEviPKcS2_: __Z24RegisterStrippedTypeInfoI9RigidbodyEviPKcS2_, __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi: __ZNSt3__220__get_up_to_n_digitsIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEiRT0_S5_RjRKNS_5ctypeIT_EEi, _UNITY_TT_Save_Context: _UNITY_TT_Save_Context, __ZN12b2BroadPhaseD2Ev: __ZN12b2BroadPhaseD2Ev, __ZN5physx2Sc13ConstraintSim16postBodiesChangeEPNS0_9RigidCoreES3_: __ZN5physx2Sc13ConstraintSim16postBodiesChangeEPNS0_9RigidCoreES3_, __ZNK5physx7NpScene34getClothInterCollisionNbIterationsEv: __ZNK5physx7NpScene34getClothInterCollisionNbIterationsEv, __Z51ReflectionProbe_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf: __Z51ReflectionProbe_CUSTOM_INTERNAL_set_backgroundColorP12Il2CppObjectRK10ColorRGBAf, __ZN18LoadSceneOperation13CleanupMemoryEv: __ZN18LoadSceneOperation13CleanupMemoryEv, __ZN9GfxDevice28SetComputeBufferCounterValueE15ComputeBufferIDj: __ZN9GfxDevice28SetComputeBufferCounterValueE15ComputeBufferIDj, __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEbT0_SC_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEbT0_SC_T_, __Z25setPxJointLimitConeZAnglePN5physx16PxJointLimitConeEf: __Z25setPxJointLimitConeZAnglePN5physx16PxJointLimitConeEf, _UnityReplayKitIsCameraEnabled: _UnityReplayKitIsCameraEnabled, _rmdir: _rmdir, __Z47Register_UnityEngine_TextMesh_get_characterSizev: __Z47Register_UnityEngine_TextMesh_get_characterSizev, __ZNSt3__217declare_reachableEPv: __ZNSt3__217declare_reachableEPv, __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE: __ZN7mecanim9animation16GetMaxBlendCountERKNS0_17BlendTreeConstantERKNS0_21BlendTreeNodeConstantE, __ZThn32_N19SkinnedMeshRenderer23UpdatePreviousFrameDataEv: __ZThn32_N19SkinnedMeshRenderer23UpdatePreviousFrameDataEv, __ZL21computeMassAndInertiabRN5physx11PxRigidBodyEPKfS3_jbRNS_3Ext21InertiaTensorComputerE: __ZL21computeMassAndInertiabRN5physx11PxRigidBodyEPKfS3_jbRNS_3Ext21InertiaTensorComputerE, __ZZN4UNET16ScriptingUpdater4InitEvEN29PreLateUpdateUNetUpdatestruct7ForwardEv: __ZZN4UNET16ScriptingUpdater4InitEvEN29PreLateUpdateUNetUpdatestruct7ForwardEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setProjectionPlaneERKNS_6PxVec3Ef: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18setProjectionPlaneERKNS_6PxVec3Ef, __Z40Register_UnityEngine_TextAsset_get_bytesv: __Z40Register_UnityEngine_TextAsset_get_bytesv, __Z42AudioReverbZone_Get_Custom_PropReverbDelayP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropReverbDelayP12Il2CppObject, __ZN13SplatDatabase13AwakeFromLoadE17AwakeFromLoadMode: __ZN13SplatDatabase13AwakeFromLoadE17AwakeFromLoadMode, __ZN4gles27UninitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadE: __ZN4gles27UninitializeBlitFramebufferERNS_23BlitFramebufferDrawQuadE, __ZN24OcclusionCullingSettingsD2Ev: __ZN24OcclusionCullingSettingsD2Ev, __ZL25InitializeDefaultMaterialv: __ZL25InitializeDefaultMaterialv, __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailv: __Z65Register_UnityEngine_ParticleSystem_TrailModule_SetWidthOverTrailv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEj: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEj, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEi, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEm: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEm, __ZN18DelayedCallManager14HasDelayedCallE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_: __ZN18DelayedCallManager14HasDelayedCallE4PPtrI6ObjectEPF15CallObjectStatePS1_PvEPFbS5_S5_ES5_, __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow2v: __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow2v, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEb, __ZNK22GenericPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK22GenericPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEe: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEe, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEd: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEd, __ZN19RuntimeSceneManager18LoadSceneAsyncIntoER10UnitySceneRK8UnityStrNS_11LoadingModeEb: __ZN19RuntimeSceneManager18LoadSceneAsyncIntoER10UnitySceneRK8UnityStrNS_11LoadingModeEb, __ZN13MonoBehaviour17StopAllCoroutinesEv: __ZN13MonoBehaviour17StopAllCoroutinesEv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEy: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEy, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEx: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEx, __Z21SetNbBroadPhaseRemovePN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj: __Z21SetNbBroadPhaseRemovePN5physx22PxSimulationStatisticsENS0_10VolumeTypeEj, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEs: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEs, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_, __Z33GameObject_CUSTOM_CreatePrimitivei: __Z33GameObject_CUSTOM_CreatePrimitivei, __ZN10AudioMixer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10AudioMixer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z43GameObject_Get_Custom_PropActiveInHierarchyP12Il2CppObject: __Z43GameObject_Get_Custom_PropActiveInHierarchyP12Il2CppObject, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEt: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEt, __ZNK13RendererScene26GetIntermediateObjectCountEv: __ZNK13RendererScene26GetIntermediateObjectCountEv, __ZN14StackAllocatorILj16EE8allocateEj: __ZN14StackAllocatorILj16EE8allocateEj, __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEEEEEjT_j: __ZNK5physx24PxMeshScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEEEEEjT_j, __ZN5physx15PxSerialization8completeERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_b: __ZN5physx15PxSerialization8completeERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_b, __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc: __ZN19ShaderPropertySheet37CreateTextureAuxPropertyUninitializedERKN9ShaderLab16FastPropertyNameEPKc, __ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj: __ZN39AssetBundleLoadFromStreamAsyncOperation10FeedStreamEPKvj, _log10l: _log10l, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEED0Ev, __ZNSt9exceptionD0Ev: __ZNSt9exceptionD0Ev, __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii: __Z40ConfigureBlockRangesWithMinIndicesPerJobP10BlockRangeii, __Z59Register_UnityEngine_ShaderVariantCollection_get_isWarmedUpv: __Z59Register_UnityEngine_ShaderVariantCollection_get_isWarmedUpv, __Z54Register_UnityEngine_Physics2D_GetIgnoreLayerCollisionv: __Z54Register_UnityEngine_Physics2D_GetIgnoreLayerCollisionv, __Z35Rigidbody_Set_Custom_PropUseGravityP12Il2CppObjecth: __Z35Rigidbody_Set_Custom_PropUseGravityP12Il2CppObjecth, __Z46Physics2D_Get_Custom_PropAngularSleepTolerancev: __Z46Physics2D_Get_Custom_PropAngularSleepTolerancev, __ZN18AsyncUploadManager17CreateInstructionEv: __ZN18AsyncUploadManager17CreateInstructionEv, __ZN14dtPathCorridorD2Ev: __ZN14dtPathCorridorD2Ev, __Z36setPxVehicleWheelDataMMaxBrakeTorquePN5physx18PxVehicleWheelDataEf: __Z36setPxVehicleWheelDataMMaxBrakeTorquePN5physx18PxVehicleWheelDataEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj656ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j: __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIcEEvPKT_j, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXMultiplierv, __Z52Register_UnityEngine_Physics2D_set_contactArrowScalev: __Z52Register_UnityEngine_Physics2D_set_contactArrowScalev, __Z56Register_UnityEngine_Shader_SetGlobalVectorArrayImplListv: __Z56Register_UnityEngine_Shader_SetGlobalVectorArrayImplListv, __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE: __ZN5physx2Gu17RadixSortBuffered4SortEPKjjNS0_9RadixHintE, __ZN16PlayerConnection14ReadConfigFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN16PlayerConnection14ReadConfigFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z50Register_UnityEngine_Time_get_realtimeSinceStartupv: __Z50Register_UnityEngine_Time_get_realtimeSinceStartupv, __Z50AudioHighPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf: __Z50AudioHighPassFilter_Set_Custom_PropCutoffFrequencyP12Il2CppObjectf, __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc: __ZL12CreateStringPjR13dynamic_arrayIcLj1EEPKc, __ZN5physx21constructBatchHeadersEPNS_23PxcSolverConstraintDescEjPKjRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS4_19ReflectionAllocatorIS6_EEEE: __ZN5physx21constructBatchHeadersEPNS_23PxcSolverConstraintDescEjPKjRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS4_19ReflectionAllocatorIS6_EEEE, __ZN16MemoryFileSystem19InitializeFileEntryER13FileEntryData: __ZN16MemoryFileSystem19InitializeFileEntryER13FileEntryData, __Z57Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastAllv: __Z57Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastAllv, __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZN5physx19NpArticulationJoint7releaseEv: __ZN5physx19NpArticulationJoint7releaseEv, __ZN12SoundManager19FlushDisposedSoundsEv: __ZN12SoundManager19FlushDisposedSoundsEv, __Z36TerrainData_CUSTOM_ResetDirtyDetailsP12Il2CppObject: __Z36TerrainData_CUSTOM_ResetDirtyDetailsP12Il2CppObject, __ZNK5physx14NpArticulation8getSceneEv: __ZNK5physx14NpArticulation8getSceneEv, __Z60Register_UnityEngine_AudioHighPassFilter_get_cutoffFrequencyv: __Z60Register_UnityEngine_AudioHighPassFilter_get_cutoffFrequencyv, __Z60Playables_CUSTOM_INTERNAL_CALL_SetPlayableDeleteOnDisconnectR9HPlayableh: __Z60Playables_CUSTOM_INTERNAL_CALL_SetPlayableDeleteOnDisconnectR9HPlayableh, __Z22GL_CUSTOM_LoadIdentityv: __Z22GL_CUSTOM_LoadIdentityv, __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi: __ZN9Scripting24RaiseDotNetExceptionImplEPKcS1_S1_Pi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleGearsDataEEEEclILj533ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN17GeneralConnection14NetworkMessage20CheckMessageValidityEv: __ZN17GeneralConnection14NetworkMessage20CheckMessageValidityEv, __ZN5physx6shdfnd9Allocator10deallocateEPv: __ZN5physx6shdfnd9Allocator10deallocateEPv, __ZN18ProceduralMaterial15ThreadedCleanupEv: __ZN18ProceduralMaterial15ThreadedCleanupEv, __ZN12FixedJoint2D6CreateEv: __ZN12FixedJoint2D6CreateEv, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE6getDirEv, __ZN5physx32PxVehicleTireDataGeneratedValuesC2EPKNS_17PxVehicleTireDataE: __ZN5physx32PxVehicleTireDataGeneratedValuesC2EPKNS_17PxVehicleTireDataE, __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15ParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN20SphericalHarmonicsL16ShrinkERK20SphericalHarmonicsL2: __ZN20SphericalHarmonicsL16ShrinkERK20SphericalHarmonicsL2, __Z68Register_UnityEngine_TerrainData_Internal_GetMaximumDetailPatchCountv: __Z68Register_UnityEngine_TerrainData_Internal_GetMaximumDetailPatchCountv, __Z42setPxVehicleDriveDynDataMAutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf: __Z42setPxVehicleDriveDynDataMAutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf, _UNITY_png_combine_row: _UNITY_png_combine_row, __ZN17GeneralConnection14NetworkMessage5GetIDEv: __ZN17GeneralConnection14NetworkMessage5GetIDEv, __Z45Register_UnityEngine_AnimationState_get_layerv: __Z45Register_UnityEngine_AnimationState_get_layerv, __ZN9Scripting35GetComponentObjectToScriptingObjectEP6ObjectR10GameObjectPKN5Unity4TypeE: __ZN9Scripting35GetComponentObjectToScriptingObjectEP6ObjectR10GameObjectPKN5Unity4TypeE, __ZNK5physx14NpRigidDynamic7getTypeEv: __ZNK5physx14NpRigidDynamic7getTypeEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setFrictionEf, __ZN5physx28PxArticulationRepXSerializer16objectToFileImplEPKNS_14PxArticulationEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx28PxArticulationRepXSerializer16objectToFileImplEPKNS_14PxArticulationEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__26vectorIPK11Il2CppImageNS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIPK11Il2CppImageNS_9allocatorIS3_EEE8__appendEj, __ZN11NamedObject7SetNameEPKc: __ZN11NamedObject7SetNameEPKc, __ZN5physx2Gu17contactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu17contactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ParticleSystemSubTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ParticleSystemSubTypeEvRT_RT0_PKc17TransferMetaFlags, __ZN9Texture3D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Texture3D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx28PxTransformFromPlaneEquationERKNS_7PxPlaneE: __ZN5physx28PxTransformFromPlaneEquationERKNS_7PxPlaneE, __ZN4FMOD6SoundI7getModeEPj: __ZN4FMOD6SoundI7getModeEPj, __ZN24CollectBroadphaseTerrainD2Ev: __ZN24CollectBroadphaseTerrainD2Ev, __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE16__construct_nodeERKNS_4pairIKS4_S5_EE, __ZN5physx23PxcGetMaterialShapeMeshEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx23PxcGetMaterialShapeMeshEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, __ZN22RenderingCommandBuffer18AddSetRenderTargetERK18RenderTextureParami11CubemapFacei: __ZN22RenderingCommandBuffer18AddSetRenderTargetERK18RenderTextureParami11CubemapFacei, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __Z39ParticleAnimator_Set_Custom_PropDampingP12Il2CppObjectf: __Z39ParticleAnimator_Set_Custom_PropDampingP12Il2CppObjectf, __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_22PxClothCollisionSphereENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZN9Animation19ValidateBoundCurvesEv: __ZN9Animation19ValidateBoundCurvesEv, __ZN16SpriteRenderData8TransferI14SafeBinaryReadEEvRT_: __ZN16SpriteRenderData8TransferI14SafeBinaryReadEEvRT_, __Z33getPxParticleBase_DynamicFrictionPKN5physx14PxParticleBaseE: __Z33getPxParticleBase_DynamicFrictionPKN5physx14PxParticleBaseE, _UNITY_png_write_finish_row: _UNITY_png_write_finish_row, __Z24RegisterStrippedTypeInfoI19SkinnedMeshRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI19SkinnedMeshRendererEviPKcS2_, __ZN15SharedLightData21UpdateSpotAngleValuesEv: __ZN15SharedLightData21UpdateSpotAngleValuesEv, __ZN25MultiBlocksMemoryFileDataD2Ev: __ZN25MultiBlocksMemoryFileDataD2Ev, __Z46Register_UnityEngine_QualitySettings_get_namesv: __Z46Register_UnityEngine_QualitySettings_get_namesv, __ZN19CharacterController11GetVelocityEv: __ZN19CharacterController11GetVelocityEv, __Z34ParticleSystem_CUSTOM_GetParticlesP12Il2CppObjectP11Il2CppArray: __Z34ParticleSystem_CUSTOM_GetParticlesP12Il2CppObjectP11Il2CppArray, __Z52Register_UnityEngine_ParticleSystem_set_maxParticlesv: __Z52Register_UnityEngine_ParticleSystem_set_maxParticlesv, _psnames_module_class_pic_init: _psnames_module_class_pic_init, __Z13RegisterClassI15NavMeshSettingsEvv: __Z13RegisterClassI15NavMeshSettingsEvv, __Z17HasFrameToPresentv: __Z17HasFrameToPresentv, __ZN17FileSystemHandler11HasFastHashERK13FileEntryDataR7Hash128: __ZN17FileSystemHandler11HasFastHashERK13FileEntryDataR7Hash128, __ZNK9Texture3D12GetDataWidthEv: __ZNK9Texture3D12GetDataWidthEv, __ZNK5physx16PxVehicleDriveNW7isValidEv: __ZNK5physx16PxVehicleDriveNW7isValidEv, __Z46Camera_CUSTOM_INTERNAL_CALL_ScreenToWorldPointP12Il2CppObjectRK8Vector3fRS1_: __Z46Camera_CUSTOM_INTERNAL_CALL_ScreenToWorldPointP12Il2CppObjectRK8Vector3fRS1_, __ZN14DetailDatabase19SetDetailResolutionEii: __ZN14DetailDatabase19SetDetailResolutionEii, __ZN19MemoryProfilerStatsD2Ev: __ZN19MemoryProfilerStatsD2Ev, __ZnwjRK10MemLabelIdiPKcS3_S3_i: __ZnwjRK10MemLabelIdiPKcS3_S3_i, __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl: __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEEl, __Z29setPxSceneDescStaticStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE: __Z29setPxSceneDescStaticStructurePN5physx11PxSceneDescENS_18PxPruningStructure4EnumE, __ZN9ShaderLab10SubProgram17DestroyGpuProgramEv: __ZN9ShaderLab10SubProgram17DestroyGpuProgramEv, __ZN13RuntimeStaticI12GraphicsCapsE16StaticInitializeEPv: __ZN13RuntimeStaticI12GraphicsCapsE16StaticInitializeEPv, __ZN15FrictionJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15FrictionJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN30RuntimeInitializeOnLoadManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRNS_6__lessI8UnityStrS2_EEPS2_EEjT0_S6_S6_S6_T_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIttEEPtEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIttEEPtEEbT0_S5_T_, __Z35UnityPropertySheet_MakeSortedFloatsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_fEEEEEER10vector_mapIS2_fS4_NS5_INS6_IS2_fEEEEE: __Z35UnityPropertySheet_MakeSortedFloatsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEfNS_4lessIS2_EENS_9allocatorINS_4pairIKS2_fEEEEEER10vector_mapIS2_fS4_NS5_INS6_IS2_fEEEEE, __ZNK13BaseAllocator22GetAllocatedMemorySizeEv: __ZNK13BaseAllocator22GetAllocatedMemorySizeEv, __ZN14VelocityModuleD0Ev: __ZN14VelocityModuleD0Ev, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __ZN5Umbra10TomeLoader8freeTomeEPKNS_4TomeEPNS_9AllocatorE: __ZN5Umbra10TomeLoader8freeTomeEPKNS_4TomeEPNS_9AllocatorE, __ZN20BaseBehaviourManagerD2Ev: __ZN20BaseBehaviourManagerD2Ev, __ZN5physx17PxsFluidCollisionD2Ev: __ZN5physx17PxsFluidCollisionD2Ev, __ZN14Texture2DArray8TransferI14SafeBinaryReadEEvRT_: __ZN14Texture2DArray8TransferI14SafeBinaryReadEEvRT_, __ZN9Rigidbody15SetCenterOfMassERK8Vector3f: __ZN9Rigidbody15SetCenterOfMassERK8Vector3f, __ZN19ScriptingInvocationC2EPv21ScriptingMethodIl2Cpp: __ZN19ScriptingInvocationC2EPv21ScriptingMethodIl2Cpp, __Z36Terrain_Set_Custom_PropLightmapIndexP12Il2CppObjecti: __Z36Terrain_Set_Custom_PropLightmapIndexP12Il2CppObjecti, __ZN5physx18PxsDynamicsContext13solveParallelEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEEPPNS_12PxsRigidBodyEj: __ZN5physx18PxsDynamicsContext13solveParallelEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEEPPNS_12PxsRigidBodyEj, __ZN23AnimationOffsetPlayable11SetPositionE8Vector3f: __ZN23AnimationOffsetPlayable11SetPositionE8Vector3f, __ZN5physx3Cct9SweepTest9onReleaseERKNS_6PxBaseE: __ZN5physx3Cct9SweepTest9onReleaseERKNS_6PxBaseE, __ZN6Shader25GetGlobalMaximumShaderLODEv: __ZN6Shader25GetGlobalMaximumShaderLODEv, __ZL15NormalizeRobustRK8Vector3fRfS2_: __ZL15NormalizeRobustRK8Vector3fRfS2_, __ZN5physx2Sn5ConvX6outputEs: __ZN5physx2Sn5ConvX6outputEs, __ZNSt3__218__insertion_sort_3IRNS_6__lessIccEEPcEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIccEEPcEEvT0_S5_T_, __ZN15CapsuleCollider12ScaleChangedEv: __ZN15CapsuleCollider12ScaleChangedEv, _UNITY_ft_smooth_lcd_renderer_class_pic_init: _UNITY_ft_smooth_lcd_renderer_class_pic_init, __ZN5physx2Sn5ConvX6outputEi: __ZN5physx2Sn5ConvX6outputEi, __ZN13RuntimeStaticI22VirtualJoystickManagerE7DestroyEv: __ZN13RuntimeStaticI22VirtualJoystickManagerE7DestroyEv, __ZN19SkinnedMeshRenderer17MainThreadCleanupEv: __ZN19SkinnedMeshRenderer17MainThreadCleanupEv, __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z50ParticleSystem_SizeBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN11ShapeModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11ShapeModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z44Register_UnityEngine_WWW_get_bytesDownloadedv: __Z44Register_UnityEngine_WWW_get_bytesDownloadedv, __ZN5physx3Cct13BoxController15setFootPositionERKNS_14PxExtendedVec3E: __ZN5physx3Cct13BoxController15setFootPositionERKNS_14PxExtendedVec3E, __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev: __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED0Ev, __ZN5physx2Sc9ClothCore23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx2Sc9ClothCore23setSimulationFilterDataERKNS_12PxFilterDataE, __ZN4FMOD7Channel13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_: __ZN4FMOD7Channel13getSpeakerMixEPfS1_S1_S1_S1_S1_S1_S1_, __Z38Register_UnityEngine_Font_get_materialv: __Z38Register_UnityEngine_Font_get_materialv, __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN9Heightmap13UpdatePhysicsEv: __ZN9Heightmap13UpdatePhysicsEv, __Z24GUI_Set_Custom_PropDepthi: __Z24GUI_Set_Custom_PropDepthi, __ZN2gl13IsFormatFloatENS_9TexFormatE: __ZN2gl13IsFormatFloatENS_9TexFormatE, __ZN11RadixSorter12ResetIndicesEv: __ZN11RadixSorter12ResetIndicesEv, __ZN10MonoScriptD0Ev: __ZN10MonoScriptD0Ev, __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE: __ZN20BaseBehaviourManager15RemoveBehaviourER8ListNodeI9BehaviourE, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE: __ZNK5physx2Gu12PolygonalBox16getPolygonalDataEPNS0_13PolygonalDataE, __Z33Component_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i: __Z33Component_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv, __ZN7mecanim12statemachine20GetBlendTreeConstantERKNS0_13StateConstantEi: __ZN7mecanim12statemachine20GetBlendTreeConstantERKNS0_13StateConstantEi, __ZNKSt3__217moneypunct_bynameIcLb1EE16do_negative_signEv: __ZNKSt3__217moneypunct_bynameIcLb1EE16do_negative_signEv, __ZN5physx6shdfnd28atomicCompareExchangePointerEPPVvPvS4_: __ZN5physx6shdfnd28atomicCompareExchangePointerEPPVvPvS4_, __ZN9Texture3DD0Ev: __ZN9Texture3DD0Ev, __Z37AndroidJNI_CUSTOM_SetByteArrayElement13Il2Cpp_IntPtria: __Z37AndroidJNI_CUSTOM_SetByteArrayElement13Il2Cpp_IntPtria, __ZN13ScreenManager44RequestConcreteOrientationFromPlayerSettingsEi: __ZN13ScreenManager44RequestConcreteOrientationFromPlayerSettingsEi, __Z38Material_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_: __Z38Material_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_, __Z42Canvas_CUSTOM_GetDefaultCanvasTextMaterialv: __Z42Canvas_CUSTOM_GetDefaultCanvasTextMaterialv, __Z46Register_UnityEngine_AudioSource_PlayScheduledv: __Z46Register_UnityEngine_AudioSource_PlayScheduledv, __ZN11PreloadData23VirtualRedirectTransferER14SafeBinaryRead: __ZN11PreloadData23VirtualRedirectTransferER14SafeBinaryRead, __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E: __Z6simd4fIN6detail9FourTupleEE13Simd4fFactoryIT_ERK13Simd4iFactoryIS3_E, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE12addAttributeEPKcS5_: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE12addAttributeEPKcS5_, __ZN5physx3Cct9SweepTestC2Ev: __ZN5physx3Cct9SweepTestC2Ev, _jinit_master_decompress: _jinit_master_decompress, __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR17DetailNodeZSorterP16DetailMeshBVNodeEEvT0_S5_T_, __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv: __ZN18LoadSceneOperation25PlayerLoadSceneFromThreadEv, __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEvT0_S6_T_, __Z40AnimationClip_Get_Custom_PropHumanMotionP12Il2CppObject: __Z40AnimationClip_Get_Custom_PropHumanMotionP12Il2CppObject, __ZN5Unity17ConfigurableJoint16SetAngularXDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint16SetAngularXDriveERK10JointDrive, _ualarm: _ualarm, __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIN4math14float4_storageELj4EE18resize_initializedEjRKS1_12ResizePolicy, __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj: __ZN8Gradient12SetColorKeysEPNS_8ColorKeyEj, __Z16GetRealGfxDevicev: __Z16GetRealGfxDevicev, __Z12calculateMTDRKN5physx2Gu8CapsuleVERKNS_6shdfnd3aos6FloatVEbPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS5_5Vec3VESG_SG_SE_RS6_: __Z12calculateMTDRKN5physx2Gu8CapsuleVERKNS_6shdfnd3aos6FloatVEbPK11MTDTrianglejjPNS0_21MeshPersistentContactERjRNS5_5Vec3VESG_SG_SE_RS6_, __Z26GetManagedAttributeManagerv: __Z26GetManagedAttributeManagerv, __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace: __ZNK13TranslateGLES13GetFormatDescE13TextureFormat17TextureColorSpace, __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEiP11Il2CppArrayRKT_i, __ZN22BaseUnityConnectClient19OnEnterStateStoppedEv: __ZN22BaseUnityConnectClient19OnEnterStateStoppedEv, __ZNK14VehiclesModule19VehiclesNeedsUpdateEv: __ZNK14VehiclesModule19VehiclesNeedsUpdateEv, __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv: __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE10deallocateEv, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE24getParticleReadDataFlagsEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE24getParticleReadDataFlagsEv, __Z13RegisterClassI17AudioChorusFilterEvv: __Z13RegisterClassI17AudioChorusFilterEvv, __Z41TargetJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf: __Z41TargetJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf, __ZThn32_NK12MeshRenderer19GetStaticBatchIndexEv: __ZThn32_NK12MeshRenderer19GetStaticBatchIndexEv, __ZN15dtLocalBoundaryD2Ev: __ZN15dtLocalBoundaryD2Ev, __Z35Terrain_Set_Custom_PropTreeDistanceP12Il2CppObjectf: __Z35Terrain_Set_Custom_PropTreeDistanceP12Il2CppObjectf, __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlags, __Z73Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxCollisionShapesv: __Z73Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxCollisionShapesv, __ZNK14ParticleSystem9IsPlayingEv: __ZNK14ParticleSystem9IsPlayingEv, __Z46Register_UnityEngine_Joint_INTERNAL_set_anchorv: __Z46Register_UnityEngine_Joint_INTERNAL_set_anchorv, __Z68Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallStaticObjectMethodv: __Z68Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallStaticObjectMethodv, __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z55ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __Z39setPxParticleFluid_RestParticleDistancePN5physx15PxParticleFluidEf: __Z39setPxParticleFluid_RestParticleDistancePN5physx15PxParticleFluidEf, __ZN5physx7NpCloth21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj: __ZN5physx7NpCloth21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj, __ZN13b2PulleyJoint4DumpEv: __ZN13b2PulleyJoint4DumpEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5frontEv, __ZNK14PhysicMaterial17GetStaticFrictionEv: __ZNK14PhysicMaterial17GetStaticFrictionEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13shrink_to_fitEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13shrink_to_fitEv, __ZN13ProbeRenderer6RenderEP15ReflectionProbeib: __ZN13ProbeRenderer6RenderEP15ReflectionProbeib, __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo: __ZN12NativeBufferI27Converter_SimpleNativeClassI17AnimationCurveTplIfEEE15SetupForWritingER9ArrayInfo, __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeXP12Il2CppObjectR15MonoMinMaxCurve, __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj: __ZNK5physx2Gu15HeightFieldUtil16getEdgeFaceIndexEj, __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN13UnityProfiler13GetDebugStatsER10DebugStats: __ZN13UnityProfiler13GetDebugStatsER10DebugStats, __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_14PxRigidDynamicEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE: __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_14PxRigidDynamicEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE, __Z24RegisterStrippedTypeInfoI6CameraEviPKcS2_: __Z24RegisterStrippedTypeInfoI6CameraEviPKcS2_, __Z29Transfer_Blittable_ArrayFieldI8JSONReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _compress_data: _compress_data, __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionXv: __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionXv, __Z38Physics2D_CUSTOM_GetLayerCollisionMaski: __Z38Physics2D_CUSTOM_GetLayerCollisionMaski, __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE13TextureFormat: __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE13TextureFormat, __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdatePlayerUpdateCanvasesstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN40PostLateUpdatePlayerUpdateCanvasesstruct7ForwardEv, __ZNK25SingleBlockMemoryFileData5CloneEv: __ZNK25SingleBlockMemoryFileData5CloneEv, __Z32Light_Get_Custom_PropCullingMaskP12Il2CppObject: __Z32Light_Get_Custom_PropCullingMaskP12Il2CppObject, __Z42Register_UnityEngine_AudioSource_get_pitchv: __Z42Register_UnityEngine_AudioSource_get_pitchv, __ZN11JSONUtility15SerializeObjectEP12Il2CppObjectRN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb24TransferInstructionFlags: __ZN11JSONUtility15SerializeObjectEP12Il2CppObjectRN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEb24TransferInstructionFlags, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEjw, __ZN12CullingGroup13NotifyVisibleEv: __ZN12CullingGroup13NotifyVisibleEv, __ZN8Animator26ClearRelatedPropertyBlocksEv: __ZN8Animator26ClearRelatedPropertyBlocksEv, __Z30getPxJointLinearLimitPairUpperPKN5physx22PxJointLinearLimitPairE: __Z30getPxJointLinearLimitPairUpperPKN5physx22PxJointLinearLimitPairE, __ZN15TerrainCollider15InitializeClassEv: __ZN15TerrainCollider15InitializeClassEv, __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter: __ZN14dtPathCorridor12movePositionEPKfPK14dtNavMeshQueryPK13dtQueryFilter, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetVelocityv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_set_targetVelocityv, __Z43Register_UnityEngine_GUIStyle_Internal_Drawv: __Z43Register_UnityEngine_GUIStyle_Internal_Drawv, __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetIKHintPositionInternalv: __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetIKHintPositionInternalv, __Z50Register_UnityEngine_AndroidJNI_SetStaticByteFieldv: __Z50Register_UnityEngine_AndroidJNI_SetStaticByteFieldv, __Z24RegisterStrippedTypeInfoI10MonoScriptEviPKcS2_: __Z24RegisterStrippedTypeInfoI10MonoScriptEviPKcS2_, __ZNK16ChannelGroupData20GetMeasuredPeakLevelEi: __ZNK16ChannelGroupData20GetMeasuredPeakLevelEi, __Z48ParticleRenderer_Set_Custom_PropUvAnimationYTileP12Il2CppObjecti: __Z48ParticleRenderer_Set_Custom_PropUvAnimationYTileP12Il2CppObjecti, __ZN12NavMeshAgent21RemoveFromCrowdSystemEv: __ZN12NavMeshAgent21RemoveFromCrowdSystemEv, __ZN13SplatDatabase18SetSplatPrototypesERKNSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEE: __ZN13SplatDatabase18SetSplatPrototypesERKNSt3__26vectorI14SplatPrototypeNS0_9allocatorIS2_EEEE, __Z24RegisterStrippedTypeInfoI18PlatformEffector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI18PlatformEffector2DEviPKcS2_, __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z34Graphics_CUSTOM_CopyTexture_RegionP12Il2CppObjectiiiiiiS0_iiii: __Z34Graphics_CUSTOM_CopyTexture_RegionP12Il2CppObjectiiiiiiS0_iiii, __ZN9JSONWrite8TransferI13dynamic_arrayIaLj1EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIaLj1EEEEvRT_PKc17TransferMetaFlags, __Z48Register_UnityEngine_Terrain_set_basemapDistancev: __Z48Register_UnityEngine_Terrain_set_basemapDistancev, __ZNKSt3__28messagesIwE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE: __ZNKSt3__28messagesIwE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE, __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI28EnlightenRendererInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE12getClassSizeEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRPv, __ZN8Animator30HasOnlySingleLayeredControllerEv: __ZN8Animator30HasOnlySingleLayeredControllerEv, __ZN16ParticleAnimatorC2E10MemLabelId18ObjectCreationMode: __ZN16ParticleAnimatorC2E10MemLabelId18ObjectCreationMode, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv: __ZN11UnityEngine15CloudWebService19SessionEventManager17PlayerLoopHandlerEv, __ZN18LoadSceneOperation25RetainSceneSerializedFileEv: __ZN18LoadSceneOperation25RetainSceneSerializedFileEv, _UnityAudioSupportsPositiveGains: _UnityAudioSupportsPositiveGains, __ZN4Mesh21AcquireSharedMeshDataEv: __ZN4Mesh21AcquireSharedMeshDataEv, __ZN13AudioProfiler17CaptureAudioClipsERNS_27AudioProfilerCaptureContextE: __ZN13AudioProfiler17CaptureAudioClipsERNS_27AudioProfilerCaptureContextE, __ZN11LightProbes15ThreadedCleanupEv: __ZN11LightProbes15ThreadedCleanupEv, __ZN5physx6shdfnd10SocketImplD0Ev: __ZN5physx6shdfnd10SocketImplD0Ev, __ZNK5physx3Ext10FixedJoint28getProjectionLinearToleranceEv: __ZNK5physx3Ext10FixedJoint28getProjectionLinearToleranceEv, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_PKc17TransferMetaFlags, _wctrans: _wctrans, __ZN18AnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18AnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN17PhysicsMaterial2DD0Ev: __ZN17PhysicsMaterial2DD0Ev, __Z54Register_UnityEngine_CharacterController_get_skinWidthv: __Z54Register_UnityEngine_CharacterController_get_skinWidthv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE8__appendEj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_, __ZN10Collider2D5ResetEv: __ZN10Collider2D5ResetEv, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwd: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwd, __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowVariationv: __Z57Register_UnityEngine_BuoyancyEffector2D_set_flowVariationv, __ZN10EventEntry9PreInvokeEv: __ZN10EventEntry9PreInvokeEv, __ZN5physx3Cct26CharacterControllerManager7releaseEv: __ZN5physx3Cct26CharacterControllerManager7releaseEv, __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_: __ZZL19ExtractHullPolygonsRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderEPS2_S3_EN5Local15GetNeighborFaceEjjPKNS0_11AdjTriangleEPKjS_S_, __ZN14TimerQueryGLESC2Ev: __ZN14TimerQueryGLESC2Ev, __ZNK39AssetBundleLoadFromStreamAsyncOperation21GetExpectedStreamSizeEv: __ZNK39AssetBundleLoadFromStreamAsyncOperation21GetExpectedStreamSizeEv, __ZNKSt3__215__codecvt_utf16IwLb0EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IwLb0EE13do_max_lengthEv, __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE: __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE, _wcrtomb: _wcrtomb, __ZN8PlayableC2E18DirectorPlayerType: __ZN8PlayableC2E18DirectorPlayerType, __ZN5physx2Sc8ActorSim19postActorFlagChangeEjj: __ZN5physx2Sc8ActorSim19postActorFlagChangeEjj, __ZN4FMOD7SystemI19setGeometrySettingsEf: __ZN4FMOD7SystemI19setGeometrySettingsEf, __ZN5Unity10HingeJoint23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity10HingeJoint23VirtualRedirectTransferER17RemapPPtrTransfer, __Z37AndroidJNI_CUSTOM_GetLongArrayElement13Il2Cpp_IntPtri: __Z37AndroidJNI_CUSTOM_GetLongArrayElement13Il2Cpp_IntPtri, __ZN11TimeManager5ResetEv: __ZN11TimeManager5ResetEv, __ZN5physx2Gu21pcmContactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu21pcmContactCapsuleMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN19SkinnedMeshRendererD0Ev: __ZN19SkinnedMeshRendererD0Ev, __ZN13OcclusionArea8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13OcclusionArea8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z32setPxVehicleGearsDataMSwitchTimePN5physx18PxVehicleGearsDataEf: __Z32setPxVehicleGearsDataMSwitchTimePN5physx18PxVehicleGearsDataEf, _tt_cmap4_validate: _tt_cmap4_validate, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwm: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwm, __Z54LightProbeProxyVolume_Get_Custom_PropProbePositionModeP12Il2CppObject: __Z54LightProbeProxyVolume_Get_Custom_PropProbePositionModeP12Il2CppObject, __ZN4FMOD13ChannelGroupI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD13ChannelGroupI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __Z52Register_UnityEngine_ParticleEmitter_get_rndRotationv: __Z52Register_UnityEngine_ParticleEmitter_get_rndRotationv, __ZN22UnityProfilerPerThread23InjectUnaccountedSampleEP19ProfilerInformationS1_: __ZN22UnityProfilerPerThread23InjectUnaccountedSampleEP19ProfilerInformationS1_, __ZN21WorldParticleCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN21WorldParticleCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN12InputManager10UpdateAxesEv: __ZN12InputManager10UpdateAxesEv, __ZNK2UI13RectTransform23CalculateLocalPosition3Ev: __ZNK2UI13RectTransform23CalculateLocalPosition3Ev, __ZN8DateTimeC2Eiiiiii: __ZN8DateTimeC2Eiiiiii, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE15growAndPushBackERKS2_, __Z42GUIStyle_CUSTOM_INTERNAL_set_contentOffsetP12Il2CppObjectRK13Vector2fIcall: __Z42GUIStyle_CUSTOM_INTERNAL_set_contentOffsetP12Il2CppObjectRK13Vector2fIcall, __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv: __ZNK5physx2Sc18ParticleSystemCore24getParticleReadDataFlagsEv, __ZN5physx7NpCloth28sendPvdSeparationConstraintsEv: __ZN5physx7NpCloth28sendPvdSeparationConstraintsEv, __ZNK16MemoryFileSystem6TargetERK13FileEntryDataR15FileSystemEntry: __ZNK16MemoryFileSystem6TargetERK13FileEntryDataR15FileSystemEntry, __ZNKSt3__25ctypeIcE8do_widenEPKcS3_Pc: __ZNKSt3__25ctypeIcE8do_widenEPKcS3_Pc, __ZN17ProceduralTexture23VirtualRedirectTransferER14SafeBinaryRead: __ZN17ProceduralTexture23VirtualRedirectTransferER14SafeBinaryRead, __ZN20SoundChannelInstance6UpdateEv: __ZN20SoundChannelInstance6UpdateEv, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math8ColliderEEEclERS3_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math8ColliderEEEclERS3_17TransferMetaFlagsR9BlobWrite, __Z67Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatrixv: __Z67Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatrixv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwj, __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_: __ZN5Unity9Component8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEEEvPT_jRKT0_RKT1_j, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapI8UnityStrS3_NS1_4lessIS3_EE13stl_allocatorINS1_4pairIKS3_S3_EEL18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN19TransportJavaScript5AbortEv: __ZN19TransportJavaScript5AbortEv, __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE: __ZN8keywords24KeywordSetToKeywordNamesERK16ShaderKeywordSetRNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEE, __ZN5physx19PxClothFabricCreateERNS_9PxPhysicsERKNS_15PxClothMeshDescERKNS_6PxVec3Eb: __ZN5physx19PxClothFabricCreateERNS_9PxPhysicsERKNS_15PxClothMeshDescERKNS_6PxVec3Eb, __ZN5physx15PxVehicleWheels7releaseEv: __ZN5physx15PxVehicleWheels7releaseEv, __ZN9Transform13SetLocalScaleERK8Vector3f: __ZN9Transform13SetLocalScaleERK8Vector3f, __Z49Register_UnityEngine_Rigidbody_set_sleepThresholdv: __Z49Register_UnityEngine_Rigidbody_set_sleepThresholdv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6ignoreEij: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE6ignoreEij, __ZN14PhysicMaterial17MainThreadCleanupEv: __ZN14PhysicMaterial17MainThreadCleanupEv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_, _PxCreateFoundation: _PxCreateFoundation, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE8__appendEj, __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE: __ZL15writeQueryInputRN5physx16BatchQueryStreamERKNS_15MultiQueryInputE, __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN5Unity10HingeJoint15WriteJointMotorEv: __ZN5Unity10HingeJoint15WriteJointMotorEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __ZN11LightProbes14LightProbeData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11LightProbes14LightProbeData8TransferI24GenerateTypeTreeTransferEEvRT_, __Z51Register_UnityEngine_WebCamTexture_get_requestedFPSv: __Z51Register_UnityEngine_WebCamTexture_get_requestedFPSv, __ZN5physx2Gu10ConvexMesh8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx2Gu10ConvexMesh8requiresERNS_23PxProcessPxBaseCallbackE, __ZN17SurfaceEffector2D16CheckConsistencyEv: __ZN17SurfaceEffector2D16CheckConsistencyEv, _cf2_builder_lineTo: _cf2_builder_lineTo, __Z32GUIStyle_Get_Custom_PropWordWrapP12Il2CppObject: __Z32GUIStyle_Get_Custom_PropWordWrapP12Il2CppObject, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18ConvertUTF32toUTF8PPKmS0_PPhS2_15ConversionFlags: __Z18ConvertUTF32toUTF8PPKmS0_PPhS2_15ConversionFlags, __ZNSt13exception_ptraSERKS_: __ZNSt13exception_ptraSERKS_, __Z33Canvas_Set_Custom_PropWorldCameraP12Il2CppObjectS0_: __Z33Canvas_Set_Custom_PropWorldCameraP12Il2CppObjectS0_, __ZN8VRDevice22StartRenderingToDeviceEv: __ZN8VRDevice22StartRenderingToDeviceEv, __ZN22NavMeshProjectSettings5ResetEv: __ZN22NavMeshProjectSettings5ResetEv, __ZN13GfxDeviceGLES12IsValidStateEv: __ZN13GfxDeviceGLES12IsValidStateEv, __Z35setPxVehicleDriveDynData_TargetGearPN5physx21PxVehicleDriveDynDataEj: __Z35setPxVehicleDriveDynData_TargetGearPN5physx21PxVehicleDriveDynDataEj, __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11TerrainData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z59Register_UnityEngine_SystemInfo_get_supports2DArrayTexturesv: __Z59Register_UnityEngine_SystemInfo_get_supports2DArrayTexturesv, __ZN18AudioMixerSnapshotD0Ev: __ZN18AudioMixerSnapshotD0Ev, __ZN12SoundManager14UpdateChannelsEv: __ZN12SoundManager14UpdateChannelsEv, __ZN5physx2Sc5Scene14stepSetupSolveEv: __ZN5physx2Sc5Scene14stepSetupSolveEv, __ZN19BaseConnectSettings15ThreadedCleanupEv: __ZN19BaseConnectSettings15ThreadedCleanupEv, __ZN15SharedGfxBufferD2Ev: __ZN15SharedGfxBufferD2Ev, _UNITY_FT_Destroy_Class_pshinter_module_class: _UNITY_FT_Destroy_Class_pshinter_module_class, __ZN22BaseUnityConnectClient11StopSessionEv: __ZN22BaseUnityConnectClient11StopSessionEv, __ZN15ArchiveReadFile5WriteEyyPKvPy: __ZN15ArchiveReadFile5WriteEyyPKvPy, __ZN19MeshParticleEmitterD0Ev: __ZN19MeshParticleEmitterD0Ev, __ZN5physx2Sc5Scene15kinematicsSetupEv: __ZN5physx2Sc5Scene15kinematicsSetupEv, __ZN14ParticleSystem13DidModifyMeshEv: __ZN14ParticleSystem13DidModifyMeshEv, __ZN12InputManager21GetJoystickButtonNameEii: __ZN12InputManager21GetJoystickButtonNameEii, __ZN5physx2Sc10NPhaseCore10updatePairEPNS0_15CoreInteractionE: __ZN5physx2Sc10NPhaseCore10updatePairEPNS0_15CoreInteractionE, __ZN5Light13SetBakedIndexEi: __ZN5Light13SetBakedIndexEi, __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE11getTypeNameEv, __ZN12b2MotorJoint15SetLinearOffsetERK6b2Vec2: __ZN12b2MotorJoint15SetLinearOffsetERK6b2Vec2, __Z27getPxArticulation_AggregatePKN5physx14PxArticulationE: __Z27getPxArticulation_AggregatePKN5physx14PxArticulationE, __ZNK19UnityConnectService11IsAvailableEv: __ZNK19UnityConnectService11IsAvailableEv, __Z50Register_UnityEngine_DynamicGI_set_synchronousModev: __Z50Register_UnityEngine_DynamicGI_set_synchronousModev, __ZNK13WheelCollider29GetGlobalSpringTargetPositionEv: __ZNK13WheelCollider29GetGlobalSpringTargetPositionEv, __ZN4FMOD8ChannelI11set3DSpreadEf: __ZN4FMOD8ChannelI11set3DSpreadEf, __ZN4math8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4math8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11OffMeshLink8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11OffMeshLink8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13MonoBehaviour15ThreadedCleanupEv: __ZN13MonoBehaviour15ThreadedCleanupEv, __ZNK9ShaderLab7Program27EndWriteUnsupportedVariantsEv: __ZNK9ShaderLab7Program27EndWriteUnsupportedVariantsEv, __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z65Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayImplListv: __Z65Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayImplListv, _psh_globals_set_scale: _psh_globals_set_scale, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclERKNS_32PxArticulationLinkCollectionPropEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclERKNS_32PxArticulationLinkCollectionPropEj, __ZN12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE: __ZN12_GLOBAL__N_110DataStream11createClassERKN5physx8debugger14NamespacedNameE, __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE: __ZN5physx26PxcArticulationFnsSimdBase13invertInertiaERKNS_12PxcFsInertiaE, __ZN26AnimatorControllerPlayable11ClearMemoryEv: __ZN26AnimatorControllerPlayable11ClearMemoryEv, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN17CollisionMeshData21AwakeFromLoadThreadedER4Mesh: __ZN17CollisionMeshData21AwakeFromLoadThreadedER4Mesh, __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z42Register_UnityEngine_GameObject_get_activev: __Z42Register_UnityEngine_GameObject_get_activev, __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenMultiplierv: __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenMultiplierv, __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb0EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb0EEEvP12NoiseJobData, __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_: __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_, __ZN11UnityEngine15CloudWebService17SessionEventQueue20GetEventsAsJsonArrayEjR8UnityStrPj: __ZN11UnityEngine15CloudWebService17SessionEventQueue20GetEventsAsJsonArrayEjR8UnityStrPj, __Z51Register_UnityEngine_Projector_set_orthographicSizev: __Z51Register_UnityEngine_Projector_set_orthographicSizev, __ZN5physx8debugger26PropertyMessageDescriptionD0Ev: __ZN5physx8debugger26PropertyMessageDescriptionD0Ev, _cff_cmap_encoding_char_next: _cff_cmap_encoding_char_next, __ZN23TransformChangeDispatch40GetAndClearChangedAsBatchedJobs_InternalE27TransformChangeSystemHandlePFvPvPK23TransformAccessReadOnlyjES1_PFvS1_E: __ZN23TransformChangeDispatch40GetAndClearChangedAsBatchedJobs_InternalE27TransformChangeSystemHandlePFvPvPK23TransformAccessReadOnlyjES1_PFvS1_E, __ZN13GfxDeviceGLES13SetDepthStateEPK16DeviceDepthState: __ZN13GfxDeviceGLES13SetDepthStateEPK16DeviceDepthState, _dummy_consume_data: _dummy_consume_data, __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE: __ZN2UI25AddCanvasRendererToCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE, __Z16HasPathComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z16HasPathComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIffEEPfEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIffEEPfEEbT0_S5_T_, __ZN5Flare8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Flare8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10MemoryPool8AllocateEj: __ZN10MemoryPool8AllocateEj, __ZL23contactHullHeightfield2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEb: __ZL23contactHullHeightfield2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEb, _tt_cmap12_validate: _tt_cmap12_validate, __Z42Register_UnityEngine_Shader_GetGlobalFloatv: __Z42Register_UnityEngine_Shader_GetGlobalFloatv, _hashmd: _hashmd, __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrIN13TextRendering4FontEE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZThn8_NK5physx3Cct13BoxController21getHalfHeightInternalEv: __ZThn8_NK5physx3Cct13BoxController21getHalfHeightInternalEv, __ZN5physxL21PxcInvalidContactPairERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physxL21PxcInvalidContactPairERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN10MemoryPool8AllocateEv: __ZN10MemoryPool8AllocateEv, __Z58Register_UnityEngine_RenderTexture_SetGlobalShaderPropertyv: __Z58Register_UnityEngine_RenderTexture_SetGlobalShaderPropertyv, __ZN5physx3Ext21InertiaTensorComputer10setCapsuleEiff: __ZN5physx3Ext21InertiaTensorComputer10setCapsuleEiff, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getERNS_15basic_streambufIwS2_EE, __ZN19SkinnedMeshRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19SkinnedMeshRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z56Register_UnityEngine_ParticleAnimator_set_colorAnimationv: __Z56Register_UnityEngine_ParticleAnimator_set_colorAnimationv, __ZN14VehiclesModule33ResetWheelQueriesTouchingColliderEP8Collider: __ZN14VehiclesModule33ResetWheelQueriesTouchingColliderEP8Collider, _UNITY_png_get_compression_type: _UNITY_png_get_compression_type, __Z42Register_UnityEngine_AndroidJNI_FatalErrorv: __Z42Register_UnityEngine_AndroidJNI_FatalErrorv, __ZN14b2PolygonShapeD0Ev: __ZN14b2PolygonShapeD0Ev, __ZNKSt3__210moneypunctIwLb1EE13decimal_pointEv: __ZNKSt3__210moneypunctIwLb1EE13decimal_pointEv, __ZN14ParticleSystem5PauseEv: __ZN14ParticleSystem5PauseEv, __ZNK5physx2Sc18ParticleSystemCore10getDampingEv: __ZNK5physx2Sc18ParticleSystemCore10getDampingEv, __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j: __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j, __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx2Sc9ActorCore13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr: __ZN11UnityEngine7Connect13ConfigHandler12GetListenersERK8UnityStr, __ZN7mecanim9animation13LayerConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation13LayerConstant8TransferI14SafeBinaryReadEEvRT_, __Z58Register_UnityEngine_Canvas_GetETC1SupportedCanvasMaterialv: __Z58Register_UnityEngine_Canvas_GetETC1SupportedCanvasMaterialv, __Z41CharacterController_Set_Custom_PropHeightP12Il2CppObjectf: __Z41CharacterController_Set_Custom_PropHeightP12Il2CppObjectf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj576ENS_22PxRepXPropertyAccessorILj576ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj576ENS_22PxRepXPropertyAccessorILj576ES4_ffEEEEvRKT0_, _jsimd_can_quantize_float: _jsimd_can_quantize_float, __Z41Register_UnityEngine_RectOffset_get_rightv: __Z41Register_UnityEngine_RectOffset_get_rightv, __Z41Animator_CUSTOM_GetAnimatorTransitionInfoP12Il2CppObjecti: __Z41Animator_CUSTOM_GetAnimatorTransitionInfoP12Il2CppObjecti, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE11solveFabricEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE11solveFabricEv, __Z47Register_UnityEngine_HingeJoint2D_set_useLimitsv: __Z47Register_UnityEngine_HingeJoint2D_set_useLimitsv, __Z42CapsuleCollider2D_Set_Custom_PropDirectionP12Il2CppObjectN17CapsuleCollider2D16CapsuleDirectionE: __Z42CapsuleCollider2D_Set_Custom_PropDirectionP12Il2CppObjectN17CapsuleCollider2D16CapsuleDirectionE, __Z39FrictionJoint2D_Get_Custom_PropMaxForceP12Il2CppObject: __Z39FrictionJoint2D_Get_Custom_PropMaxForceP12Il2CppObject, __ZN11NoiseModule15PreviewNoiseJobILi2EEEvP19PreviewNoiseJobData: __ZN11NoiseModule15PreviewNoiseJobILi2EEEvP19PreviewNoiseJobData, __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc: __Z30RegisterValidateMethodCallbackiPF21ScriptingMethodIl2CppS_P11Il2CppClassP6ObjectEPKc, __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRe: __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRe, __ZN24OcclusionCullingSettings15ThreadedCleanupEv: __ZN24OcclusionCullingSettings15ThreadedCleanupEv, __ZN8Animator15UpdateWithDeltaEf: __ZN8Animator15UpdateWithDeltaEf, __Z29StdTemplateConversionFunctionIyhEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyhEbPvR14SafeBinaryRead, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE8ValidateEPS1_: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE8ValidateEPS1_, __Z58Register_UnityEngine_Quaternion_INTERNAL_CALL_LookRotationv: __Z58Register_UnityEngine_Quaternion_INTERNAL_CALL_LookRotationv, __Z48Register_UnityEngine_AudioChorusFilter_set_delayv: __Z48Register_UnityEngine_AudioChorusFilter_set_delayv, __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv: __ZN5physx6shdfnd4Time23getBootCounterFrequencyEv, __Z24setPxTolerancesScaleMassPN5physx17PxTolerancesScaleEf: __Z24setPxTolerancesScaleMassPN5physx17PxTolerancesScaleEf, __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN17GlobalGameManagerD0Ev: __ZN17GlobalGameManagerD0Ev, __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN12SocketStream13OnSocketErrorEv: __ZN12SocketStream13OnSocketErrorEv, __ZN9BlobWrite8TransferI19StaticArrayTransferIfLi24EEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI19StaticArrayTransferIfLi24EEEEvRT_PKc17TransferMetaFlags, __Z50Register_UnityEngine_Joint_get_enablePreprocessingv: __Z50Register_UnityEngine_Joint_get_enablePreprocessingv, __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_GetHumanPosev: __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_GetHumanPosev, __ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_: __ZNSt3__29__num_getIcE19__stage2_float_loopEcRbRcPcRS4_ccRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjS4_, __Z47Register_UnityEngine_AndroidJNIHelper_get_debugv: __Z47Register_UnityEngine_AndroidJNIHelper_get_debugv, __ZN5physx6shdfnd10SocketImpl4readEPhj: __ZN5physx6shdfnd10SocketImpl4readEPhj, __Z46Physics_Get_Custom_PropPenetrationPenaltyForcev: __Z46Physics_Get_Custom_PropPenetrationPenaltyForcev, __ZNK11b2WeldJoint17GetReactionTorqueEf: __ZNK11b2WeldJoint17GetReactionTorqueEf, __ZN13LoadOperationD0Ev: __ZN13LoadOperationD0Ev, __Z22SetCompensatingSensorsb: __Z22SetCompensatingSensorsb, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteUint64Ey: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteUint64Ey, __ZN12ImageFilters17SwitchTargetToLDREP13RenderTexture: __ZN12ImageFilters17SwitchTargetToLDREP13RenderTexture, __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx23PxGetGroupCollisionFlagEtt: __ZN5physx23PxGetGroupCollisionFlagEtt, __Z48Register_UnityEngine_Terrain_get_basemapDistancev: __Z48Register_UnityEngine_Terrain_get_basemapDistancev, __Z44Physics2D_Set_Custom_PropAlwaysShowCollidersh: __Z44Physics2D_Set_Custom_PropAlwaysShowCollidersh, __Z56Register_UnityEngine_Terrain_INTERNAL_get_legacySpecularv: __Z56Register_UnityEngine_Terrain_INTERNAL_get_legacySpecularv, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE17setDominanceGroupEh, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5rfindEcj, __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb1EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi1ELb1ELb1EEEvP12NoiseJobData, ___memrchr: ___memrchr, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setSimulationFilterDataERKNS_12PxFilterDataE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23setSimulationFilterDataERKNS_12PxFilterDataE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj506ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEEclILj506ENS_8PxSpringEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9JSONWrite6UnwrapEPKc: __ZN9JSONWrite6UnwrapEPKc, __Z53Register_UnityEngine_QualitySettings_set_blendWeightsv: __Z53Register_UnityEngine_QualitySettings_set_blendWeightsv, __ZN14PhysicsManager18GetBounceThresholdEv: __ZN14PhysicsManager18GetBounceThresholdEv, __ZN9dtNavMesh10removeTileEyPPKhPi: __ZN9dtNavMesh10removeTileEyPPKhPi, _cf2_arrstack_push: _cf2_arrstack_push, __Z20Input_CUSTOM_GetAxisP12Il2CppString: __Z20Input_CUSTOM_GetAxisP12Il2CppString, __ZN4FMOD12ChannelGroup7getNameEPci: __ZN4FMOD12ChannelGroup7getNameEPci, __Z52Register_UnityEngine_Animation_get_playAutomaticallyv: __Z52Register_UnityEngine_Animation_get_playAutomaticallyv, _trinkle: _trinkle, __ZN5Unity5Cloth7CleanupEv: __ZN5Unity5Cloth7CleanupEv, __Z24GetLastPathNameComponentPKcj: __Z24GetLastPathNameComponentPKcj, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPci: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPci, __ZN12CubemapArray17MainThreadCleanupEv: __ZN12CubemapArray17MainThreadCleanupEv, __ZZN11Rigidbody2D15InitializeClassEvEN28FunctorImpl_199kLayerChanged4CallEPviR11MessageData: __ZZN11Rigidbody2D15InitializeClassEvEN28FunctorImpl_199kLayerChanged4CallEPviR11MessageData, __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE: __ZN5physx2Gu25PersistentContactManifold16addManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE, __ZN5physx7NpCloth13setRestOffsetEf: __ZN5physx7NpCloth13setRestOffsetEf, __Z54Register_UnityEngine_WheelJoint2D_get_jointTranslationv: __Z54Register_UnityEngine_WheelJoint2D_get_jointTranslationv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEED0Ev, __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI5LightE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z20UnloadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z20UnloadDynamicLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z53Register_UnityEngine_RectTransform_INTERNAL_get_pivotv: __Z53Register_UnityEngine_RectTransform_INTERNAL_get_pivotv, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN9ShaderLab21SerializedShaderStateC2Ev: __ZN9ShaderLab21SerializedShaderStateC2Ev, __ZN9GfxDevice12ImmediateEndEv: __ZN9GfxDevice12ImmediateEndEv, __ZNKSt3__27codecvtIDsc11__mbstate_tE11do_encodingEv: __ZNKSt3__27codecvtIDsc11__mbstate_tE11do_encodingEv, __ZNK26AnimatorOverrideController7GetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZNK26AnimatorOverrideController7GetClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, _strncat: _strncat, __ZN12NavMeshAgent16CheckConsistencyEv: __ZN12NavMeshAgent16CheckConsistencyEv, __ZN18AsyncUploadManager18ScheduleJobPrivateER8JobFencePFvP28FileTextureUploadInstructionES3_: __ZN18AsyncUploadManager18ScheduleJobPrivateER8JobFencePFvP28FileTextureUploadInstructionES3_, __Z54Register_UnityEngine_GameObject_GetComponentInChildrenv: __Z54Register_UnityEngine_GameObject_GetComponentInChildrenv, __ZN6Camera21SetScreenViewportRectERK5RectTIfE: __ZN6Camera21SetScreenViewportRectERK5RectTIfE, __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE6resizeEjRKS5_: __ZN5physx6shdfnd5ArrayIPKNS_2Sc8ShapeSimENS0_19ReflectionAllocatorIS5_EEE6resizeEjRKS5_, __Z32GUIStyle_CUSTOM_AssignRectOffsetP12Il2CppObjecti13Il2Cpp_IntPtr: __Z32GUIStyle_CUSTOM_AssignRectOffsetP12Il2CppObjecti13Il2Cpp_IntPtr, __Z43Register_UnityEngine_Canvas_get_renderOrderv: __Z43Register_UnityEngine_Canvas_get_renderOrderv, __ZN17PersistentManager13GetAllFileIDsERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EE: __ZN17PersistentManager13GetAllFileIDsERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEER13dynamic_arrayIxLj8EE, _UNITY_FT_Get_Name_Index: _UNITY_FT_Get_Name_Index, __Z55SkinnedMeshRenderer_Set_Custom_PropSkinnedMotionVectorsP12Il2CppObjecth: __Z55SkinnedMeshRenderer_Set_Custom_PropSkinnedMotionVectorsP12Il2CppObjecth, __ZN8VRDevice10InitializeEb: __ZN8VRDevice10InitializeEb, __Z9dtReallocPvi: __Z9dtReallocPvi, __ZN6b2Body16SetFixedRotationEb: __ZN6b2Body16SetFixedRotationEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN7mecanim9animation21CreateAvatarWorkspaceEPKNS0_14AvatarConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation21CreateAvatarWorkspaceEPKNS0_14AvatarConstantERNS_6memory9AllocatorE, __Z51Register_UnityEngine_TerrainData_set_treePrototypesv: __Z51Register_UnityEngine_TerrainData_set_treePrototypesv, __Z62Register_UnityEngine_Texture_INTERNAL_CALL_GetNativeTexturePtrv: __Z62Register_UnityEngine_Texture_INTERNAL_CALL_GetNativeTexturePtrv, __Z62Register_UnityEngine_SceneManagement_Scene_GetIsLoadedInternalv: __Z62Register_UnityEngine_SceneManagement_Scene_GetIsLoadedInternalv, __Z40ReflectionProbe_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f: __Z40ReflectionProbe_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f, __Z37Renderer_Get_Custom_PropLightmapIndexP12Il2CppObject: __Z37Renderer_Get_Custom_PropLightmapIndexP12Il2CppObject, __Z49RenderTexture_CUSTOM_Internal_CreateRenderTextureP12Il2CppObject: __Z49RenderTexture_CUSTOM_Internal_CreateRenderTextureP12Il2CppObject, __ZN9ShaderLab22SerializedBindChannels4BindE13ShaderChannel15VertexComponentbP12ShaderErrors: __ZN9ShaderLab22SerializedBindChannels4BindE13ShaderChannel15VertexComponentbP12ShaderErrors, __Z50Register_UnityEngine_ParticleSystem_get_startSpeedv: __Z50Register_UnityEngine_ParticleSystem_get_startSpeedv, __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_: __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_, __Z25BillboardRenderer_CleanupR15RenderNodeQueuej: __Z25BillboardRenderer_CleanupR15RenderNodeQueuej, __Z60Register_UnityEngine_AI_NavMeshPath_CalculateCornersInternalv: __Z60Register_UnityEngine_AI_NavMeshPath_CalculateCornersInternalv, __ZN9GfxDevice14AddSetPassStatEv: __ZN9GfxDevice14AddSetPassStatEv, __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_17PxcSolverBodyDataENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, ___divdi3: ___divdi3, __ZN18LoadSceneOperationC2Ev: __ZN18LoadSceneOperationC2Ev, __Z49Register_UnityEngine_AudioReverbFilter_set_roomHFv: __Z49Register_UnityEngine_AudioReverbFilter_set_roomHFv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE16releaseParticlesEjRKNS_16PxStrideIteratorIKjEE, __Z55Register_UnityEngine_AI_NavMeshAgent_SamplePathPositionv: __Z55Register_UnityEngine_AI_NavMeshAgent_SamplePathPositionv, _post_process_1pass: _post_process_1pass, __ZN10GUITexture8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10GUITexture8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj120ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj120ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_15NpParticleFluidEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __Z55Register_UnityEngine_Physics2D_get_linearSleepTolerancev: __Z55Register_UnityEngine_Physics2D_get_linearSleepTolerancev, __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetRemoveStartOffsetv: __Z85Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetRemoveStartOffsetv, __ZL27ClearTransformTemporaryFlagR9Transform: __ZL27ClearTransformTemporaryFlagR9Transform, __Z22LoadGpuProgramFromDataPKhS0_: __Z22LoadGpuProgramFromDataPKhS0_, _UNITY_LZ4_decompress_safe: _UNITY_LZ4_decompress_safe, __ZN8Animator10GetIntegerEiRi: __ZN8Animator10GetIntegerEiRi, __ZN5physx32solveContactCoulomb_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx32solveContactCoulomb_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z24RegisterStrippedTypeInfoI14SphereColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI14SphereColliderEviPKcS2_, __ZN15ReplacementPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceData: __ZN15ReplacementPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceData, __Z45Register_UnityEngine_HumanPoseHandler_Disposev: __Z45Register_UnityEngine_HumanPoseHandler_Disposev, _wcstoull: _wcstoull, __ZN17PhysicsMaterial2DC2E10MemLabelId18ObjectCreationMode: __ZN17PhysicsMaterial2DC2E10MemLabelId18ObjectCreationMode, __Z43Register_UnityEngine_AudioClip_get_loadTypev: __Z43Register_UnityEngine_AudioClip_get_loadTypev, __ZN15QualitySettings22SetAnisotropicTexturesEi: __ZN15QualitySettings22SetAnisotropicTexturesEi, _UnityReplayKitStartBroadcasting: _UnityReplayKitStartBroadcasting, __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE, __Z49Register_UnityEngine_Terrain_set_materialTemplatev: __Z49Register_UnityEngine_Terrain_set_materialTemplatev, __Z62Register_UnityEngine_GUIStyle_INTERNAL_set_Internal_clipOffsetv: __Z62Register_UnityEngine_GUIStyle_INTERNAL_set_Internal_clipOffsetv, __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN19SpriteMeshGenerator4path18SetSizeUnOptimizedEii: __ZN19SpriteMeshGenerator4path18SetSizeUnOptimizedEii, __Z32setPxVehicleDriveTank_DriveModelPN5physx18PxVehicleDriveTankENS_30PxVehicleDriveTankControlModel4EnumE: __Z32setPxVehicleDriveTank_DriveModelPN5physx18PxVehicleDriveTankENS_30PxVehicleDriveTankControlModel4EnumE, __Z42SystemInfo_Get_Custom_PropSystemMemorySizev: __Z42SystemInfo_Get_Custom_PropSystemMemorySizev, __ZN14GfxContextGLESC2Ev: __ZN14GfxContextGLESC2Ev, __Z53ParticleSystemRenderer_Get_Custom_PropMinParticleSizeP12Il2CppObject: __Z53ParticleSystemRenderer_Get_Custom_PropMinParticleSizeP12Il2CppObject, __ZN14UnityAnalytics13SetUserGenderENS_6GenderE: __ZN14UnityAnalytics13SetUserGenderENS_6GenderE, __Z44Register_UnityEngine_HingeJoint_set_useMotorv: __Z44Register_UnityEngine_HingeJoint_set_useMotorv, __Z22GUIClip_CUSTOM_Reapplyv: __Z22GUIClip_CUSTOM_Reapplyv, __Z53Register_UnityEngine_SliderJoint2D_get_referenceAnglev: __Z53Register_UnityEngine_SliderJoint2D_get_referenceAnglev, __ZN5physx6shdfnd7FastXml8CallbackD2Ev: __ZN5physx6shdfnd7FastXml8CallbackD2Ev, __ZN20SpeedTreeWindManager15DeleteLocalWindEP18SpeedTreeLocalWind: __ZN20SpeedTreeWindManager15DeleteLocalWindEP18SpeedTreeLocalWind, _jpeg_mem_init: _jpeg_mem_init, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim4hand4HandEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim4hand4HandEEE8TransferI18StreamedBinaryReadILb1EEEEvRS4_RT_, __ZNK5Unity17ConfigurableJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_: __ZNK5Unity17ConfigurableJoint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_, __Z66Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipSystemsv: __Z66Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipSystemsv, __ZL7EdgeLeqP14TESStesselatorP12ActiveRegionS2_: __ZL7EdgeLeqP14TESStesselatorP12ActiveRegionS2_, __Z55QualitySettings_Get_Custom_PropRealtimeReflectionProbesv: __Z55QualitySettings_Get_Custom_PropRealtimeReflectionProbesv, __Z18SetApplicationPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18SetApplicationPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj690ES3_NS_23PxVehicleDriveSimDataNWES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj690ES3_NS_23PxVehicleDriveSimDataNWES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK13RenderTexture20GetRuntimeMemorySizeEv: __ZNK13RenderTexture20GetRuntimeMemorySizeEv, __ZN11UnityEngine15PlatformWrapper30GetGraphicsDriverLibraryStringEv: __ZN11UnityEngine15PlatformWrapper30GetGraphicsDriverLibraryStringEv, __Z18IsInsidePlayerLoopv: __Z18IsInsidePlayerLoopv, __Z33CanvasRenderer_CUSTOM_SetMaterialP12Il2CppObjectS0_i: __Z33CanvasRenderer_CUSTOM_SetMaterialP12Il2CppObjectS0_i, __ZN13ScreenManager26ReapplyRequestedResolutionEv: __ZN13ScreenManager26ReapplyRequestedResolutionEv, __Z58Register_UnityEngine_ParticleAnimator_set_doesAnimateColorv: __Z58Register_UnityEngine_ParticleAnimator_set_doesAnimateColorv, __ZNK5physx17MBPUpdateWorkTask7getNameEv: __ZNK5physx17MBPUpdateWorkTask7getNameEv, __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev: __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED1Ev, __ZN4crnd10dxt1_block15unpack_endpointEjjbj: __ZN4crnd10dxt1_block15unpack_endpointEjjbj, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefINS0_12StringHandleEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE8writeRefENS0_7DataRefINS0_12StringHandleEEE, __ZNK12MeshRenderer13GetSharedMeshEv: __ZNK12MeshRenderer13GetSharedMeshEv, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN5physx6shdfnd5ArrayIPNS_21GuMeshFactoryListenerENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_21GuMeshFactoryListenerENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE14setOwnerClientEh, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z13RemoveVehiclePN5physx16PxVehicleNoDriveEj: __Z13RemoveVehiclePN5physx16PxVehicleNoDriveEj, __ZN19MemoryProfilerStats16UnregisterObjectEP6Object: __ZN19MemoryProfilerStats16UnregisterObjectEP6Object, __ZNK13b2PulleyJoint10GetAnchorAEv: __ZNK13b2PulleyJoint10GetAnchorAEv, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv, __ZN13GfxDeviceGLES15InitCommonStateER15DeviceStateGLES: __ZN13GfxDeviceGLES15InitCommonStateER15DeviceStateGLES, __ZN13TargetJoint2DD2Ev: __ZN13TargetJoint2DD2Ev, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEED2Ev: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEED2Ev, __ZN10Matrix3x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10Matrix3x4f8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z52Register_UnityEngine_GL_INTERNAL_CALL_Internal_Clearv: __Z52Register_UnityEngine_GL_INTERNAL_CALL_Internal_Clearv, __ZN23CloudWebServicesManager23PlayerLoopHandlerStaticEv: __ZN23CloudWebServicesManager23PlayerLoopHandlerStaticEv, __ZN13PhysicsModule18ReleaseHeightFieldEPv: __ZN13PhysicsModule18ReleaseHeightFieldEPv, __ZN11TerrainDataD0Ev: __ZN11TerrainDataD0Ev, __ZN7dtCrowd19updateAgentVelocityERK13dtCrowdHandlePKf: __ZN7dtCrowd19updateAgentVelocityERK13dtCrowdHandlePKf, __ZN13GfxDeviceGLES16DoMemoryBarriersEv: __ZN13GfxDeviceGLES16DoMemoryBarriersEv, __ZN5physx23PxVehicleDriveSimDataNW11setDiffDataERKNS_27PxVehicleDifferentialNWDataE: __ZN5physx23PxVehicleDriveSimDataNW11setDiffDataERKNS_27PxVehicleDifferentialNWDataE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxArticulationEE8pushNameEPKc, __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j: __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j, __ZN2UI13RectTransform10DeactivateE19DeactivateOperation: __ZN2UI13RectTransform10DeactivateE19DeactivateOperation, __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci: __Z15calloc_internaljjiRK10MemLabelId15AllocateOptionsPKci, ___cxa_bad_typeid: ___cxa_bad_typeid, __ZN12AudioManager14AddAudioSourceEP11AudioSource: __ZN12AudioManager14AddAudioSourceEP11AudioSource, __ZN5physx20PxJointGeneratedInfoC2Ev: __ZN5physx20PxJointGeneratedInfoC2Ev, __ZTv0_n12_NSt3__210istrstreamD1Ev: __ZTv0_n12_NSt3__210istrstreamD1Ev, __ZN5physx2Sc10NPhaseCore27resizeContactReportPairDataEjjRNS0_20ContactStreamManagerE: __ZN5physx2Sc10NPhaseCore27resizeContactReportPairDataEjjRNS0_20ContactStreamManagerE, __Z26setPxVehicleWheelDataMMassPN5physx18PxVehicleWheelDataEf: __Z26setPxVehicleWheelDataMMassPN5physx18PxVehicleWheelDataEf, __ZN19ShaderPropertySheet18SetTextureUnscaledERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_: __ZN19ShaderPropertySheet18SetTextureUnscaledERKN9ShaderLab16FastPropertyNameEP7Texture8Vector2fS6_, __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE: __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE, __ZNSt3__211timed_mutexD2Ev: __ZNSt3__211timed_mutexD2Ev, __Z11BuildBVTreeRK13dynamic_arrayI8Vector3fLj4EERS_IiLj4EERS_I16HeightMeshBVNodeLj4EEi: __Z11BuildBVTreeRK13dynamic_arrayI8Vector3fLj4EERS_IiLj4EERS_I16HeightMeshBVNodeLj4EEi, __ZN5physx2Sc5Scene11afterSolverEj: __ZN5physx2Sc5Scene11afterSolverEj, __ZN4crnd5utils16compute_max_mipsEjj: __ZN4crnd5utils16compute_max_mipsEjj, __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z45Rigidbody_CUSTOM_INTERNAL_set_angularVelocityP12Il2CppObjectRK8Vector3f: __Z45Rigidbody_CUSTOM_INTERNAL_set_angularVelocityP12Il2CppObjectRK8Vector3f, __ZN5physx23NpVolumeCacheSqCallbackD0Ev: __ZN5physx23NpVolumeCacheSqCallbackD0Ev, __ZN17CircleCast2DQueryD2Ev: __ZN17CircleCast2DQueryD2Ev, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS1_15NameHandleValueEEE, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE26getRelativeAngularVelocityEv, __ZN5physx3Cct26CharacterControllerManager22setDebugRenderingFlagsENS_7PxFlagsINS_27PxControllerDebugRenderFlag4EnumEjEE: __ZN5physx3Cct26CharacterControllerManager22setDebugRenderingFlagsENS_7PxFlagsINS_27PxControllerDebugRenderFlag4EnumEjEE, __ZN5physx2Cm21visualizeAngularLimitERNS0_12RenderOutputEfRKNS_11PxTransformEffb: __ZN5physx2Cm21visualizeAngularLimitERNS0_12RenderOutputEfRKNS_11PxTransformEffb, __ZNK13BaseAllocator26GetPeakAllocatedMemorySizeEv: __ZNK13BaseAllocator26GetPeakAllocatedMemorySizeEv, __Z51Physics2D_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiffP12RaycastHit2D: __Z51Physics2D_CUSTOM_INTERNAL_CALL_Internal_CapsuleCastRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiffP12RaycastHit2D, __Z29GL_CUSTOM_RenderTargetBarrierv: __Z29GL_CUSTOM_RenderTargetBarrierv, __ZN5physx31PxParticleReadDataGeneratedInfoC2Ev: __ZN5physx31PxParticleReadDataGeneratedInfoC2Ev, __Z49Register_UnityEngine_Light_get_alreadyLightmappedv: __Z49Register_UnityEngine_Light_get_alreadyLightmappedv, __Z31AudioSource_Get_Custom_PropTimeP12Il2CppObject: __Z31AudioSource_Get_Custom_PropTimeP12Il2CppObject, __ZN14MessageHandler15MessageNameToIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN14MessageHandler15MessageNameToIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, _UNITY_FT_Done_Size: _UNITY_FT_Done_Size, __Z64Register_UnityEngine_AI_NavMeshObstacle_set_carvingMoveThresholdv: __Z64Register_UnityEngine_AI_NavMeshObstacle_set_carvingMoveThresholdv, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_17DeallocationEventEEEvT_: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_17DeallocationEventEEEvT_, __Z28getPxHeightFieldDesc_IsValidPKN5physx17PxHeightFieldDescE: __Z28getPxHeightFieldDesc_IsValidPKN5physx17PxHeightFieldDescE, __ZN10builtintex21GetBlackCubeTextureIDEv: __ZN10builtintex21GetBlackCubeTextureIDEv, __ZN5physx22PxVehicleWheelsDynData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx22PxVehicleWheelsDynData17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxActorES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE15reserveInternalEj, __Z51Register_UnityEngine_Effector2D_set_useColliderMaskv: __Z51Register_UnityEngine_Effector2D_set_useColliderMaskv, __ZN5Umbra4Math3expERKNS_6DoubleE: __ZN5Umbra4Math3expERKNS_6DoubleE, __Z45SceneManager_CUSTOM_INTERNAL_CALL_MergeScenesRKiS0_: __Z45SceneManager_CUSTOM_INTERNAL_CALL_MergeScenesRKiS0_, __ZN23PreloadManagerOperation12GetDebugNameEv: __ZN23PreloadManagerOperation12GetDebugNameEv, __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolIDv: __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetBoolIDv, __ZN16UnityAdsSettings8TransferI14SafeBinaryReadEEvRT_: __ZN16UnityAdsSettings8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getTetherConstraintScaleEv, __ZN11Rigidbody2D11GetMaterialEv: __ZN11Rigidbody2D11GetMaterialEv, __Z61Register_UnityEngine_ShaderVariantCollection_get_variantCountv: __Z61Register_UnityEngine_ShaderVariantCollection_get_variantCountv, __ZNSt3__212ctype_bynameIcED0Ev: __ZNSt3__212ctype_bynameIcED0Ev, _UNITY_png_set_gamma_fixed: _UNITY_png_set_gamma_fixed, __Z25GetBuiltinMatrixParamNamei: __Z25GetBuiltinMatrixParamNamei, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED2Ev: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEED2Ev, __ZN5Unity12PhysicsQuery11RaycastTestERK3Rayfi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery11RaycastTestERK3Rayfi23QueryTriggerInteraction, __ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb: __ZN5physx2Sc10NPhaseCore19refilterInteractionEPNS0_21ElementSimInteractionEPKNS0_10FilterInfoEb, _vprintf: _vprintf, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZL12CullGroupJobP20CullingGroupsJobDataj: __ZL12CullGroupJobP20CullingGroupsJobDataj, __ZN5physx21PxcArticulationHelper13prepareFsDataERNS_9PxcFsDataEPKNS_19PxsArticulationLinkE: __ZN5physx21PxcArticulationHelper13prepareFsDataERNS_9PxcFsDataEPKNS_19PxsArticulationLinkE, __ZNK13BaseAllocator21GetReservedMemorySizeEv: __ZNK13BaseAllocator21GetReservedMemorySizeEv, __Z17dynamic_pptr_castIP13MonoBehaviour6ObjectET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP13MonoBehaviour6ObjectET_RK4PPtrIT0_E, __ZN5physx7Cooking19computeHullPolygonsERKNS_20PxSimpleTriangleMeshERNS_19PxAllocatorCallbackERjRPNS_6PxVec3ES6_RPjS6_RPNS_13PxHullPolygonE: __ZN5physx7Cooking19computeHullPolygonsERKNS_20PxSimpleTriangleMeshERNS_19PxAllocatorCallbackERjRPNS_6PxVec3ES6_RPjS6_RPNS_13PxHullPolygonE, __ZN19SpriteMeshGenerator4path8cve_costEi: __ZN19SpriteMeshGenerator4path8cve_costEi, __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __Z36getPxSphericalJoint_ConcreteTypeNamePKN5physx16PxSphericalJointE: __Z36getPxSphericalJoint_ConcreteTypeNamePKN5physx16PxSphericalJointE, __ZNK5physx2Sq17SceneQueryManager11canRunOnSPUERKNS_12NpBatchQueryE: __ZNK5physx2Sq17SceneQueryManager11canRunOnSPUERKNS_12NpBatchQueryE, __Z36CommandBuffer_CUSTOM_SetGlobalBufferP12Il2CppObjectiS0_: __Z36CommandBuffer_CUSTOM_SetGlobalBufferP12Il2CppObjectiS0_, __ZNSt3__26thread4joinEv: __ZNSt3__26thread4joinEv, __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE7reserveEj, __ZN18PhysxJobDispatcher10submitTaskERN5physx10PxBaseTaskE: __ZN18PhysxJobDispatcher10submitTaskERN5physx10PxBaseTaskE, __Z25GetUnityAnalyticsSettingsv: __Z25GetUnityAnalyticsSettingsv, __ZN4FMOD6System11setUserDataEPv: __ZN4FMOD6System11setUserDataEPv, __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_16PxPrismaticJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNK16LevelGameManager26GetTypeInfoVirtualInternalEv: __ZNK16LevelGameManager26GetTypeInfoVirtualInternalEv, __ZN18AssetBundleManager18CollectPreloadDataEiPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEER13dynamic_arrayIiLj4EE: __ZN18AssetBundleManager18CollectPreloadDataEiPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEER13dynamic_arrayIiLj4EE, __ZN19ComputeShaderKernelaSERKS_: __ZN19ComputeShaderKernelaSERKS_, __ZN4FMOD7Channel17get3DConeSettingsEPfS1_S1_: __ZN4FMOD7Channel17get3DConeSettingsEPfS1_S1_, __ZL22addOrRemoveRigidObjectILb0ELb0ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b: __ZL22addOrRemoveRigidObjectILb0ELb0ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__rEv, __ZNK13TranslateGLES13GetFormatDescE19RenderTextureFormat17TextureColorSpace: __ZNK13TranslateGLES13GetFormatDescE19RenderTextureFormat17TextureColorSpace, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __ZNK5physx2Sc15ClothFabricCore14getNbParticlesEv: __ZNK5physx2Sc15ClothFabricCore14getNbParticlesEv, __ZN9Heightmap8TransferI14SafeBinaryReadEEvRT_: __ZN9Heightmap8TransferI14SafeBinaryReadEEvRT_, __Z38AudioSource_Set_Custom_PropMinDistanceP12Il2CppObjectf: __Z38AudioSource_Set_Custom_PropMinDistanceP12Il2CppObjectf, __ZNSt3__217__assoc_sub_state28set_exception_at_thread_exitESt13exception_ptr: __ZNSt3__217__assoc_sub_state28set_exception_at_thread_exitESt13exception_ptr, __ZNSt3__215messages_bynameIcED2Ev: __ZNSt3__215messages_bynameIcED2Ev, __ZN15b2FrictionJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN15b2FrictionJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode: __ZN15TerrainRenderer21RecursiveCalculateLodER12QuadTreeNode, __Z33LODGroup_CUSTOM_RecalculateBoundsP12Il2CppObject: __Z33LODGroup_CUSTOM_RecalculateBoundsP12Il2CppObject, __ZN7mecanim9animation10SampleClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEfPf: __ZN7mecanim9animation10SampleClipERKNS0_12StreamedClipERNS0_18StreamedClipMemoryEfPf, __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi: __ZNK21ExecutionOrderManager23GetScriptExecutionOrderEi, __ZNK10MonoScript18GetScriptClassNameEv: __ZNK10MonoScript18GetScriptClassNameEv, __ZN5physx14PxRigidBodyExt26getLocalVelocityAtLocalPosERKNS_11PxRigidBodyERKNS_6PxVec3E: __ZN5physx14PxRigidBodyExt26getLocalVelocityAtLocalPosERKNS_11PxRigidBodyERKNS_6PxVec3E, __ZN10AtomicList3AddEP10AtomicNodeS1_i: __ZN10AtomicList3AddEP10AtomicNodeS1_i, __Z10md5_startsP11md5_context: __Z10md5_startsP11md5_context, __ZN5physx9NpPhysics11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtbNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx9NpPhysics11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtbNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN12HingeJoint2D16CheckConsistencyEv: __ZN12HingeJoint2D16CheckConsistencyEv, __ZN11AssetBundle8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11AssetBundle8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z14OrthoNormalizeP8Vector3fS0_: __Z14OrthoNormalizeP8Vector3fS0_, __Z48AssetBundleManifest_CUSTOM_GetDirectDependenciesP12Il2CppObjectP12Il2CppString: __Z48AssetBundleManifest_CUSTOM_GetDirectDependenciesP12Il2CppObjectP12Il2CppString, __Z49Register_UnityEngine_AndroidJNI_CallBooleanMethodv: __Z49Register_UnityEngine_AndroidJNI_CallBooleanMethodv, __ZNK11b2EdgeShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi: __ZNK11b2EdgeShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi, __Z10WriteArrayI22AudioProfilerGroupInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE: __Z10WriteArrayI22AudioProfilerGroupInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE, __Z54ParticleSystem_LightsModule_CUSTOM_GetSizeAffectsRangeP12Il2CppObject: __Z54ParticleSystem_LightsModule_CUSTOM_GetSizeAffectsRangeP12Il2CppObject, __ZN4FMOD7SystemI20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE: __ZN4FMOD7SystemI20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE, __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_: __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireMeshP12Il2CppObjectiRK8Vector3fRK11QuaternionfS3_, __Z68AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveStringR9HPlayableP12Il2CppString: __Z68AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveStringR9HPlayableP12Il2CppString, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags, __ZN5physx2Sc15CoreInteraction11updateStateEb: __ZN5physx2Sc15CoreInteraction11updateStateEb, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE8__appendEj: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE8__appendEj, __Z48AddToTimeSliceAwakeFromLoadQueueProgressCallbackR6ObjectPv: __Z48AddToTimeSliceAwakeFromLoadQueueProgressCallbackR6ObjectPv, __ZN5physx2Gu30checkOverlapSphere_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu30checkOverlapSphere_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __ZN8TypeTreeC2ERK10MemLabelId: __ZN8TypeTreeC2ERK10MemLabelId, __ZNK13b2PulleyJoint17GetCurrentLengthBEv: __ZNK13b2PulleyJoint17GetCurrentLengthBEv, __Z21InitializeVideoModulev: __Z21InitializeVideoModulev, __ZN14qsort_internal18QSortSingleJobDataIP17RODataReplacementi19ROSorterReplacementE7SortJobEPS4_: __ZN14qsort_internal18QSortSingleJobDataIP17RODataReplacementi19ROSorterReplacementE7SortJobEPS4_, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S7_EEEEEEEEvRT_17TransferMetaFlags, __Z24GL_CUSTOM_MultiTexCoord3ifff: __Z24GL_CUSTOM_MultiTexCoord3ifff, _UNITY_png_write_start_row: _UNITY_png_write_start_row, __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile17EventDeserializerILb0EE9streamifyEPKcRjNS0_27EventStreamCompressionFlags4EnumE, __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj: __Z8CopyBlobIN7mecanim9animation12AvatarMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj, __ZN14PlayerSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN14PlayerSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN12NavMeshAgent14SetDestinationERK8Vector3f: __ZN12NavMeshAgent14SetDestinationERK8Vector3f, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags, __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalVectorv: __Z74Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalVectorv, __ZN4FMOD6Reverb9setActiveEb: __ZN4FMOD6Reverb9setActiveEb, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E9copy_fromERKSK_j, __ZL44RenderRemainingObjectsThatCantHandleDeferred13RenderingPathR17RenderLoopContextRK11CullResultsbP13RenderTextureS6_R13dynamic_arrayI16RenderObjectDataLj4EE: __ZL44RenderRemainingObjectsThatCantHandleDeferred13RenderingPathR17RenderLoopContextRK11CullResultsbP13RenderTextureS6_R13dynamic_arrayI16RenderObjectDataLj4EE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZNKSt11logic_error4whatEv: __ZNKSt11logic_error4whatEv, __ZN5physx18RepXSerializerImplINS_9PxD6JointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_9PxD6JointEE11getTypeNameEv, __ZN13AnimationClip7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13AnimationClip7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN20TextRenderingPrivate15DynamicFontData21GetFontMetricsForFaceERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEiRKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEPfSI_: __ZN20TextRenderingPrivate15DynamicFontData21GetFontMetricsForFaceERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEiRKNS2_I4PPtrIN13TextRendering4FontEES4_ISD_LS5_34ELi16EEEEPfSI_, __ZN14PhysicMaterial8DumpDescERNS_18PhysicMaterialDescE: __ZN14PhysicMaterial8DumpDescERNS_18PhysicMaterialDescE, __Z65Register_UnityEngine_ParticleEmitter_INTERNAL_CALL_ClearParticlesv: __Z65Register_UnityEngine_ParticleEmitter_INTERNAL_CALL_ClearParticlesv, __ZN21AnimationClipPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN21AnimationClipPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, _process_data_simple_main_30: _process_data_simple_main_30, _UNITY_png_get_bKGD: _UNITY_png_get_bKGD, __Z45Register_UnityEngine_ComputeShader_SetTexturev: __Z45Register_UnityEngine_ComputeShader_SetTexturev, __GLOBAL__sub_I_runtime_ai_internal_crowd_lump_cpp: __GLOBAL__sub_I_runtime_ai_internal_crowd_lump_cpp, __Z46Register_UnityEngine_Terrain_set_lightmapIndexv: __Z46Register_UnityEngine_Terrain_set_lightmapIndexv, __ZN5physx6shdfnd5ArrayIPNS_7PxClothENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxClothENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN4FMOD6System9setOutputE15FMOD_OUTPUTTYPE: __ZN4FMOD6System9setOutputE15FMOD_OUTPUTTYPE, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags, __ZN12_GLOBAL__N_120createParticleSystemEjb: __ZN12_GLOBAL__N_120createParticleSystemEjb, __ZN5physx2Gu8EdgeListD2Ev: __ZN5physx2Gu8EdgeListD2Ev, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4goodEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4goodEv, __ZN24EllipsoidParticleEmitter13SetupParticleER8ParticleRK8Vector3fRK10Matrix3x3ff: __ZN24EllipsoidParticleEmitter13SetupParticleER8ParticleRK8Vector3fRK10Matrix3x3ff, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZv, __ZNK9Heightmap21InitPxHeightFieldDescERN5physx17PxHeightFieldDescEiiPNS0_19PxHeightFieldSampleE: __ZNK9Heightmap21InitPxHeightFieldDescERN5physx17PxHeightFieldDescEiiPNS0_19PxHeightFieldSampleE, __Z41Register_UnityEngine_GameObject_SetActivev: __Z41Register_UnityEngine_GameObject_SetActivev, __Z13RegisterClassIN5Unity10HingeJointEEvv: __Z13RegisterClassIN5Unity10HingeJointEEvv, __Z18raycast_convexMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z18raycast_convexMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __ZNK8Animator14IsInTransitionEi: __ZNK8Animator14IsInTransitionEi, __Z47Register_UnityEngine_FixedJoint2D_get_frequencyv: __Z47Register_UnityEngine_FixedJoint2D_get_frequencyv, __Z27AssetBundle_CUSTOM_ContainsP12Il2CppObjectP12Il2CppString: __Z27AssetBundle_CUSTOM_ContainsP12Il2CppObjectP12Il2CppString, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13HeightmapDataLj4EEEEvRT_17TransferMetaFlags, __ZNK13SliderJoint2D19GetJointTranslationEv: __ZNK13SliderJoint2D19GetJointTranslationEv, __ZN11AudioSource23VirtualRedirectTransferER14SafeBinaryRead: __ZN11AudioSource23VirtualRedirectTransferER14SafeBinaryRead, __GLOBAL__sub_I_runtime_ai_internal_lump_cpp: __GLOBAL__sub_I_runtime_ai_internal_lump_cpp, __ZL22CleanupModule_Vehiclesv: __ZL22CleanupModule_Vehiclesv, __ZN7mecanim9animation14AvatarConstant8TransferI17RemapPPtrTransferEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI17RemapPPtrTransferEEvRT_, __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByNamev: __Z78Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByNamev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN8Collider8TransferI14SafeBinaryReadEEvRT_: __ZN8Collider8TransferI14SafeBinaryReadEEvRT_, __ZN15MonoScriptCacheC2Ev: __ZN15MonoScriptCacheC2Ev, __ZN14SafeBinaryRead8TransferItEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferItEEvRT_PKc17TransferMetaFlags, __ZN9Transform8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Transform8TransferI24GenerateTypeTreeTransferEEvRT_, __ZL36PxcTestFacesSepAxesBackfaceRoughPassRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ESD_RfRSB_RjfSD_: __ZL36PxcTestFacesSepAxesBackfaceRoughPassRKN5physx2Gu13PolygonalDataES3_RKNS_2Cm8Matrix34ES7_RKNS4_23FastVertex2ShapeScalingESA_S7_RKNS_6PxVec3ESD_RfRSB_RjfSD_, __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN24UserAuthorizationManager5ResetEv: __ZN24UserAuthorizationManager5ResetEv, __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetRotationP12Il2CppObjectRK11Quaternionf: __Z52ConfigurableJoint_CUSTOM_INTERNAL_set_targetRotationP12Il2CppObjectRK11Quaternionf, __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy: __ZN13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EE18resize_initializedEjRKS2_12ResizePolicy, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI17RemapPPtrTransferEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI17RemapPPtrTransferEEvRT_, __ZN5Cache22ReadCacheIndexThreadedEPv: __ZN5Cache22ReadCacheIndexThreadedEPv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIwEE, __ZNSt3__28numpunctIcED0Ev: __ZNSt3__28numpunctIcED0Ev, __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN5physx25PxcPCMContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx25PxcPCMContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN14NavMeshCarving13SetDirtyLayerEi: __ZN14NavMeshCarving13SetDirtyLayerEi, _UNITY_LZ4_compressBound: _UNITY_LZ4_compressBound, __ZN5physx17PxsFluidCollision19addTempW2STransformERNS0_8TaskDataERKNS_31PxsParticleStreamContactManagerE: __ZN5physx17PxsFluidCollision19addTempW2STransformERNS0_8TaskDataERKNS_31PxsParticleStreamContactManagerE, __ZNK13TranslateGLES9FilterMagE17TextureFilterMode: __ZNK13TranslateGLES9FilterMagE17TextureFilterMode, __ZN28BucketPrunerOverlapTraversalI24BucketPrunerAABBAABBTestLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E: __ZN28BucketPrunerOverlapTraversalI24BucketPrunerAABBAABBTestLb1EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E, __Z42Register_UnityEngine_GameObject_CompareTagv: __Z42Register_UnityEngine_GameObject_CompareTagv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj644ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj644ES3_KbbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN17GeneralConnection10ConnectionD2Ev: __ZN17GeneralConnection10ConnectionD2Ev, __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E14squash_deletedEv, __ZN19AudioHighPassFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN19AudioHighPassFilter23VirtualRedirectTransferER14SafeBinaryRead, __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE: __Z32scripting_class_get_nested_typesP11Il2CppClassRNSt3__26vectorIS0_13stl_allocatorIS0_L18MemLabelIdentifier1ELi16EEEE, _bindtextdomain: _bindtextdomain, __ZN15ReflProbeSorterclEPK15ReflectionProbeS2_: __ZN15ReflProbeSorterclEPK15ReflectionProbeS2_, __Z13GetNbCCDPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_: __Z13GetNbCCDPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_, __ZN5physx8debugger17PvdNetworkStreams7connectERNS_19PxAllocatorCallbackEPKcijRPNS0_18PvdNetworkInStreamERPNS0_19PvdNetworkOutStreamE: __ZN5physx8debugger17PvdNetworkStreams7connectERNS_19PxAllocatorCallbackEPKcijRPNS0_18PvdNetworkInStreamERPNS0_19PvdNetworkOutStreamE, __ZN14AsyncOperationD2Ev: __ZN14AsyncOperationD2Ev, __ZN8JSONReadC2EPKc24TransferInstructionFlagsRK10MemLabelIdbPNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEi: __ZN8JSONReadC2EPKc24TransferInstructionFlagsRK10MemLabelIdbPNSt3__212basic_stringIcNS6_11char_traitsIcEENS6_9allocatorIcEEEEi, _tt_cmap14_get_info: _tt_cmap14_get_info, __Z51Register_UnityEngine_Profiling_Profiler_set_enabledv: __Z51Register_UnityEngine_Profiling_Profiler_set_enabledv, __Z50Register_UnityEngine_AndroidJNI_SetStaticLongFieldv: __Z50Register_UnityEngine_AndroidJNI_SetStaticLongFieldv, __Z40RenderSettings_Set_Custom_PropFogDensityf: __Z40RenderSettings_Set_Custom_PropFogDensityf, __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportMapRelativeImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __ZN5physx6shdfnd10checkValidERKNS_6PxQuatE: __ZN5physx6shdfnd10checkValidERKNS_6PxQuatE, __Z39ParticleSystemRenderer_CUSTOM_SetMeshesP12Il2CppObjectP11Il2CppArrayi: __Z39ParticleSystemRenderer_CUSTOM_SetMeshesP12Il2CppObjectP11Il2CppArrayi, __ZN13RendererScene27CleanupPVSAndRequestRebuildEv: __ZN13RendererScene27CleanupPVSAndRequestRebuildEv, __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadedBytesv: __Z67Register_UnityEngine_Networking_UnityWebRequest_get_downloadedBytesv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEE15growAndPushBackERKS2_, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEEEvPT_jRKT0_RKT1_j, __ZN19CloudServiceHandler29ProcessAsyncFileRestoreStaticEPv: __ZN19CloudServiceHandler29ProcessAsyncFileRestoreStaticEPv, __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj: __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEj, _putwc: _putwc, __ZN4FMOD7ReverbI11setUserDataEPv: __ZN4FMOD7ReverbI11setUserDataEPv, __ZN5FlareD2Ev: __ZN5FlareD2Ev, __Z72Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedMultiplierv: __Z72Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedMultiplierv, __ZN10Matrix4x4f11SetIdentityEv: __ZN10Matrix4x4f11SetIdentityEv, _Vertical_Sweep_Span: _Vertical_Sweep_Span, __Z65Register_UnityEngine_TerrainData_set_Internal_heightmapResolutionv: __Z65Register_UnityEngine_TerrainData_set_Internal_heightmapResolutionv, __Z57Register_UnityEngine_Animator_INTERNAL_get_targetPositionv: __Z57Register_UnityEngine_Animator_INTERNAL_get_targetPositionv, __Z31profiler_set_memory_record_mode24ProfilerMemoryRecordMode: __Z31profiler_set_memory_record_mode24ProfilerMemoryRecordMode, __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE8recreateEj, __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority: __Z33ScheduleJobForEachDependsInternalR8JobFencePFvPvjES1_iRKS_PFvS1_E11JobPriority, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_: __ZN14qsort_internal6_QSortIP17RODataReplacementi19ROSorterReplacementEEvT_S4_T0_T1_, __ZN9GfxDevice20UpdateConstantBufferEijPKv: __ZN9GfxDevice20UpdateConstantBufferEijPKv, __Z41GIDebugVisualisation_CUSTOM_PlayCycleModev: __Z41GIDebugVisualisation_CUSTOM_PlayCycleModev, __ZN37AssetBundleLoadFromFileAsyncOperation14ConvertArchiveEv: __ZN37AssetBundleLoadFromFileAsyncOperation14ConvertArchiveEv, __ZN5simdimiERK8Scalar4fS2_: __ZN5simdimiERK8Scalar4fS2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI21ComputeShaderResourceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z24getPxJoint_InvMassScale1PKN5physx7PxJointE: __Z24getPxJoint_InvMassScale1PKN5physx7PxJointE, __ZN15LightProbeGroup12AddToManagerEv: __ZN15LightProbeGroup12AddToManagerEv, __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe: __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRe, _tt_cmap12_char_next: _tt_cmap12_char_next, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI33EnlightenTerrainChunksInformationLj4EEEEvRT_17TransferMetaFlags, __ZNSt3__26locale5__imp12install_fromINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, _gzerror: _gzerror, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj64ENS_22PxRepXPropertyAccessorILj64ES4_RKNS_6PxQuatES9_EEEEvRKT0_, _ps_hints_t1stem3: _ps_hints_t1stem3, __Z54Register_UnityEngine_Physics_INTERNAL_CALL_CheckSpherev: __Z54Register_UnityEngine_Physics_INTERNAL_CALL_CheckSpherev, __Z17Event_CUSTOM_InitP12Il2CppObjecti: __Z17Event_CUSTOM_InitP12Il2CppObjecti, __Z43Register_UnityEngine_Cloth_SetEnabledFadingv: __Z43Register_UnityEngine_Cloth_SetEnabledFadingv, __ZNK6Avatar23GetLeftFeetBottomHeightEv: __ZNK6Avatar23GetLeftFeetBottomHeightEv, __Z13RegisterClassI11GameManagerEvv: __Z13RegisterClassI11GameManagerEvv, __ZN5physx15PxCollectionExt16createCollectionERNS_9PxPhysicsE: __ZN5physx15PxCollectionExt16createCollectionERNS_9PxPhysicsE, __Z38Renderer_Set_Custom_PropUseLightProbesP12Il2CppObjecth: __Z38Renderer_Set_Custom_PropUseLightProbesP12Il2CppObjecth, __ZN5physx2Sc9ClothCore24setSelfCollisionDistanceEf: __ZN5physx2Sc9ClothCore24setSelfCollisionDistanceEf, __ZNK15FileSystemEntry7IsLocalEv: __ZNK15FileSystemEntry7IsLocalEv, __Z19GetActiveColorSpacev: __Z19GetActiveColorSpacev, __Z19CreateNullGfxDevicev: __Z19CreateNullGfxDevicev, __ZN8Playable26EndIgnoreAllocationTrackerEv: __ZN8Playable26EndIgnoreAllocationTrackerEv, __Z62Register_UnityEngine_DistanceJoint2D_get_autoConfigureDistancev: __Z62Register_UnityEngine_DistanceJoint2D_get_autoConfigureDistancev, __Z45Register_UnityEngine_SparseTexture_UnloadTilev: __Z45Register_UnityEngine_SparseTexture_UnloadTilev, __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_15PxRevoluteJointEE11getTypeNameEv, __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalPositioniR8Vector3f: __Z51InputTracking_CUSTOM_INTERNAL_CALL_GetLocalPositioniR8Vector3f, _strtoll_l: _strtoll_l, __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_117ProfileZoneClientEED0Ev: __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_117ProfileZoneClientEED0Ev, __ZN4FMOD6SoundI8readDataEPvjPj: __ZN4FMOD6SoundI8readDataEPvjPj, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z49getPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj: __Z49getPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj, __ZN11UnityEngine9Animation38FindTransformBindingIndexByBindingHashERK13dynamic_arrayINS0_14BoundTransformELj4EEj: __ZN11UnityEngine9Animation38FindTransformBindingIndexByBindingHashERK13dynamic_arrayINS0_14BoundTransformELj4EEj, __Z23GUIStyle_CUSTOM_CleanupP12Il2CppObject: __Z23GUIStyle_CUSTOM_CleanupP12Il2CppObject, __ZN14DetailDatabase33DidThreadedLoadCreateTextureAtlasEv: __ZN14DetailDatabase33DidThreadedLoadCreateTextureAtlasEv, __ZN12SoundManagerD2Ev: __ZN12SoundManagerD2Ev, __ZN5Unity10HingeJoint9SetSpringERK11JointSpring: __ZN5Unity10HingeJoint9SetSpringERK11JointSpring, __Z13RegisterClassI11AudioSourceEvv: __Z13RegisterClassI11AudioSourceEvv, __ZNK25UnityWebRequestJavaScript17GetUploadProgressEv: __ZNK25UnityWebRequestJavaScript17GetUploadProgressEv, __Z19GetVertexBufferDataP14SharedMeshDataR16VertexBufferDatai: __Z19GetVertexBufferDataP14SharedMeshDataR16VertexBufferDatai, __ZN15TerrainCollider14TerrainChangedEi: __ZN15TerrainCollider14TerrainChangedEi, __Z69Register_UnityEngine_Networking_DownloadHandler_InternalCreateTexturev: __Z69Register_UnityEngine_Networking_DownloadHandler_InternalCreateTexturev, _UNITY_FT_Stroker_Export: _UNITY_FT_Stroker_Export, __ZN15TerrainCollider20CleanupTreeCollidersEv: __ZN15TerrainCollider20CleanupTreeCollidersEv, __ZN9GfxDevice13FreeTextureIDE9TextureID: __ZN9GfxDevice13FreeTextureIDE9TextureID, __Z37setPxSceneDescFrictionOffsetThresholdPN5physx11PxSceneDescEf: __Z37setPxSceneDescFrictionOffsetThresholdPN5physx11PxSceneDescEf, __ZN13RuntimeStaticI18AssetBundleManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI18AssetBundleManagerE13StaticDestroyEPv, __Z61Register_UnityEngine_AudioLowPassFilter_get_lowpassResonanceQv: __Z61Register_UnityEngine_AudioLowPassFilter_get_lowpassResonanceQv, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10DeallocateEPv: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10DeallocateEPv, __ZN9Scripting25RaiseInvalidCastExceptionEPKcz: __ZN9Scripting25RaiseInvalidCastExceptionEPKcz, _UNITY_ft_raccess_rule_by_darwin_vfs: _UNITY_ft_raccess_rule_by_darwin_vfs, __Z14RunNativeTestsv: __Z14RunNativeTestsv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15OcclusionPortalELj4EEEEvRT_17TransferMetaFlags, _cf2_doStems: _cf2_doStems, __ZN4FMOD7SystemI6updateEv: __ZN4FMOD7SystemI6updateEv, __ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE: __ZN4FMOD6System21getMasterChannelGroupEPPNS_12ChannelGroupE, __ZN13ScreenManager14GetBlitTextureEv: __ZN13ScreenManager14GetBlitTextureEv, __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_: __ZNSt3__26__sortIRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_, __ZN16Physics2DManager20GetRigidBodyVelocityERK11Rigidbody2D: __ZN16Physics2DManager20GetRigidBodyVelocityERK11Rigidbody2D, __Z41Register_UnityEngine_AudioSource_set_clipv: __Z41Register_UnityEngine_AudioSource_set_clipv, __ZZN8VRModuleC1EvEN28playerLoadFirstScenePreAwake7ForwardEv: __ZZN8VRModuleC1EvEN28playerLoadFirstScenePreAwake7ForwardEv, __ZNK22RenderingCommandBuffer15FindTempRTIndexERKN9ShaderLab16FastPropertyNameE: __ZNK22RenderingCommandBuffer15FindTempRTIndexERKN9ShaderLab16FastPropertyNameE, __Z21ApplyDirectionalForceR23ParticleSystemParticlesjjRK8Vector3fS3_RKN4math7_float4E: __Z21ApplyDirectionalForceR23ParticleSystemParticlesjjRK8Vector3fS3_RKN4math7_float4E, __ZNSt3__27collateIcED0Ev: __ZNSt3__27collateIcED0Ev, __ZN8VRDevice10SetEnabledEb: __ZN8VRDevice10SetEnabledEb, _UNITY_FT_Stroker_CubicTo: _UNITY_FT_Stroker_CubicTo, __ZN5physx3Ext20DefaultCpuDispatcher14setRunProfiledEb: __ZN5physx3Ext20DefaultCpuDispatcher14setRunProfiledEb, __Z33Event_Set_Custom_PropDisplayIndexP12Il2CppObjecti: __Z33Event_Set_Custom_PropDisplayIndexP12Il2CppObjecti, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj477ENS_22PxRepXPropertyAccessorILj477ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj477ENS_22PxRepXPropertyAccessorILj477ES4_RKNS_16PxJointLimitConeES9_EEEEvRKT0_, __Z29Cursor_Get_Custom_PropVisiblev: __Z29Cursor_Get_Custom_PropVisiblev, __Z29StdTemplateConversionFunctionIjaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjaEbPvR14SafeBinaryRead, __Z29Transfer_Blittable_ArrayFieldI9JSONWriteaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWriteaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN9Texture3D15UpdateImageDataEb: __ZN9Texture3D15UpdateImageDataEb, __Z40setPxVehicleWheelsSimData_SuspensionDataPN5physx22PxVehicleWheelsSimDataEjNS_23PxVehicleSuspensionDataE: __Z40setPxVehicleWheelsSimData_SuspensionDataPN5physx22PxVehicleWheelsSimDataEjNS_23PxVehicleSuspensionDataE, __ZThn12_NK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZNK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZNK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZNK5physx18PxcConvexTriangles9getBoundsERNS_9PxBounds3ERKNS_11PxTransformE: __ZNK5physx18PxcConvexTriangles9getBoundsERNS_9PxBounds3ERKNS_11PxTransformE, __ZN21AnimationPosePlayable19DeallocateResourcesEv: __ZN21AnimationPosePlayable19DeallocateResourcesEv, __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN19AudioHighPassFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf: __ZN5physx2Gu27distancePointSegmentSquaredERKNS_6PxVec3ES3_S3_Pf, __ZN5physx2Sc9ActorCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc9ActorCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN19RenderEventsContext23RemoveAllCommandBuffersEv: __ZN19RenderEventsContext23RemoveAllCommandBuffersEv, __ZNK26LegacyTreeInstanceRenderer14GetSubsetIndexEi: __ZNK26LegacyTreeInstanceRenderer14GetSubsetIndexEi, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEEEE15growAndPushBackERKS2_, __Z39Renderer_Set_Custom_PropSharedMaterialsP12Il2CppObjectP11Il2CppArray: __Z39Renderer_Set_Custom_PropSharedMaterialsP12Il2CppObjectP11Il2CppArray, __Z30Material_Set_Custom_PropShaderP12Il2CppObjectS0_: __Z30Material_Set_Custom_PropShaderP12Il2CppObjectS0_, __ZN5physx2Sc9ClothCore26setCentrifugalInertiaScaleENS_6PxVec3E: __ZN5physx2Sc9ClothCore26setCentrifugalInertiaScaleENS_6PxVec3E, _UNITY_png_crc_finish: _UNITY_png_crc_finish, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getTranslationEv, __Z10SetGlobalR15TransformAccessRKN4math7_float4E: __Z10SetGlobalR15TransformAccessRKN4math7_float4E, __ZNK5physx2Sc9ClothCore13getGlobalPoseEv: __ZNK5physx2Sc9ClothCore13getGlobalPoseEv, __ZN5Umbra15OcclusionBuffer5clearEv: __ZN5Umbra15OcclusionBuffer5clearEv, __ZN5physx9NpPhysics16destroySceneLockEv: __ZN5physx9NpPhysics16destroySceneLockEv, __ZN4FMOD12ChannelGroup11overridePanEf: __ZN4FMOD12ChannelGroup11overridePanEf, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEvPT_jRKT0_RKT1_j, __Z44Register_UnityEngine_Camera_AddCommandBufferv: __Z44Register_UnityEngine_Camera_AddCommandBufferv, __ZNK2UI11CanvasGroup26GetTypeInfoVirtualInternalEv: __ZNK2UI11CanvasGroup26GetTypeInfoVirtualInternalEv, __Z64Register_UnityEngine_Networking_UnityWebRequest_InternalGetErrorv: __Z64Register_UnityEngine_Networking_UnityWebRequest_InternalGetErrorv, __ZN8Animator14GetLayerWeightEi: __ZN8Animator14GetLayerWeightEi, _nexttowardl: _nexttowardl, __ZN11KeyframeTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_: __ZN11KeyframeTplI11QuaternionfE8TransferI14SafeBinaryReadEEvRT_, __ZN26DownloadHandlerAssetBundle22OnReceiveContentLengthEj: __ZN26DownloadHandlerAssetBundle22OnReceiveContentLengthEj, __ZN11DetailPatch8TransferI14SafeBinaryReadEEvRT_: __ZN11DetailPatch8TransferI14SafeBinaryReadEEvRT_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE21setCollisionMassScaleEf, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx26PxcPCMContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx26PxcPCMContactCapsuleConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZNSt3__221recursive_timed_mutex8try_lockEv: __ZNSt3__221recursive_timed_mutex8try_lockEv, __ZN6Object23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Object23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN24MidPhaseQueryLocalReportD0Ev: __ZN24MidPhaseQueryLocalReportD0Ev, __ZNK11Rigidbody2D10IsTouchingEP10Collider2D: __ZNK11Rigidbody2D10IsTouchingEP10Collider2D, __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatIDv: __Z80Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetFloatIDv, __ZNSt3__2L22utf16le_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE: __ZNSt3__2L22utf16le_to_ucs4_lengthEPKhS1_jmNS_12codecvt_modeE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, __Z42DestroyTransformComponentAndChildHierarchyR9Transform: __Z42DestroyTransformComponentAndChildHierarchyR9Transform, __Z45Application_Get_Custom_PropWebSecurityEnabledv: __Z45Application_Get_Custom_PropWebSecurityEnabledv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11get_weekdayES4_S4_RNS_8ios_baseERjP2tm, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj657ENS_22PxRepXPropertyAccessorILj657ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj657ENS_22PxRepXPropertyAccessorILj657ES4_jjEEEEvjRKT0_, __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags, __ZNK5physx3Ext7D6Joint14getSwingZAngleEv: __ZNK5physx3Ext7D6Joint14getSwingZAngleEv, __ZN29MotionVectorRenderLoopScratchD0Ev: __ZN29MotionVectorRenderLoopScratchD0Ev, _toascii: _toascii, __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_: __ZN5physx6shdfnd8internal11HashMapBaseIN12_GLOBAL__N_117ClassPropertyNameEPNS3_12PropDescImplENS3_23ClassPropertyNameHasherENS_8debugger19ForwardingAllocatorEE6insertES4_S6_, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE18__get_day_year_numERiRS4_S4_RjRKNS_5ctypeIwEE, __Z24GetShaderChannelFromNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24GetShaderChannelFromNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z28PlayerPrefs_CUSTOM_TrySetIntP12Il2CppStringi: __Z28PlayerPrefs_CUSTOM_TrySetIntP12Il2CppStringi, __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE6resizeEj: __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE6resizeEj, __ZN5physx31initCollDataAndApplyConstraintsERNS_19PxsParticleCollDataERKNS_16PxsFluidParticleERKNS_6PxVec3EfS7_S7_PKNS_11PxsBodyCoreESA_jRKNS_27PxsFluidCollisionParametersE: __ZN5physx31initCollDataAndApplyConstraintsERNS_19PxsParticleCollDataERKNS_16PxsFluidParticleERKNS_6PxVec3EfS7_S7_PKNS_11PxsBodyCoreESA_jRKNS_27PxsFluidCollisionParametersE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E, __Z65Register_UnityEngine_ParticleSystemRenderer_Internal_GetMeshCountv: __Z65Register_UnityEngine_ParticleSystemRenderer_Internal_GetMeshCountv, __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5audio5mixer22CreateAudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorEib: __ZN5audio5mixer22CreateAudioMixerMemoryERKNS0_18AudioMixerConstantEPN4FMOD6SystemERN7mecanim6memory9AllocatorEib, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10date_orderEv: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10date_orderEv, __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj: __ZN5physx2Gu32PCMSphereVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj, __Z29CrashReport_CUSTOM_GetReportsv: __Z29CrashReport_CUSTOM_GetReportsv, __Z27Profiler_CUSTOM_BeginSampleP12Il2CppStringP12Il2CppObject: __Z27Profiler_CUSTOM_BeginSampleP12Il2CppStringP12Il2CppObject, __Z70Register_UnityEngine_Networking_DownloadHandlerAudioClip_get_audioClipv: __Z70Register_UnityEngine_Networking_DownloadHandlerAudioClip_get_audioClipv, __ZN12FlareManager12RenderFlaresERK10Matrix4x4f: __ZN12FlareManager12RenderFlaresERK10Matrix4x4f, __ZN14ParticleSystem35CalculateMaximumSubEmitterEmitCountERS_R19ParticleSystemStatefbi: __ZN14ParticleSystem35CalculateMaximumSubEmitterEmitCountERS_R19ParticleSystemStatefbi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN8JSONRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_10MemLabelId17TransferMetaFlags, __ZN9HeightmapD2Ev: __ZN9HeightmapD2Ev, __ZN12FlareManager11UpdateFlareEiP5FlareRK8Vector3fbfRK10ColorRGBAffjj: __ZN12FlareManager11UpdateFlareEiP5FlareRK8Vector3fbfRK10ColorRGBAffjj, __ZNK5physx2Sc8SimStats7readOutERNS_22PxSimulationStatisticsERKNS_11PxvSimStatsE: __ZNK5physx2Sc8SimStats7readOutERNS_22PxSimulationStatisticsERKNS_11PxvSimStatsE, __ZN5Flare8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Flare8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5Umbra13TomeUserIdMap9getUserIdEi: __ZNK5Umbra13TomeUserIdMap9getUserIdEi, __ZNK16b2PrismaticJoint10GetAnchorAEv: __ZNK16b2PrismaticJoint10GetAnchorAEv, __ZN10HumanTrait20InitializeMuscleNameEv: __ZN10HumanTrait20InitializeMuscleNameEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __ZN4Halo12CleanupClassEv: __ZN4Halo12CleanupClassEv, __ZNKSt3__215__codecvt_utf16IDiLb0EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IDiLb0EE9do_lengthER11__mbstate_tPKcS5_j, __Z53Register_UnityEngine_Physics2D_get_positionIterationsv: __Z53Register_UnityEngine_Physics2D_get_positionIterationsv, __ZNK22GenericPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK22GenericPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN6Avatar15ThreadedCleanupEv: __ZN6Avatar15ThreadedCleanupEv, __Z42Register_UnityEngine_Light_get_cullingMaskv: __Z42Register_UnityEngine_Light_get_cullingMaskv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __ZNK11Rigidbody2D16GetRelativePointERK8Vector2f: __ZNK11Rigidbody2D16GetRelativePointERK8Vector2f, __Z42Screen_Set_Custom_PropAutorotateToPortraith: __Z42Screen_Set_Custom_PropAutorotateToPortraith, __Z13RegisterClassI15FrictionJoint2DEvv: __Z13RegisterClassI15FrictionJoint2DEvv, __Z43Register_UnityEngine_Shader_SetGlobalBufferv: __Z43Register_UnityEngine_Shader_SetGlobalBufferv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN14SerializedFile11GetTypeTreeEx: __ZN14SerializedFile11GetTypeTreeEx, __Z76Register_UnityEngine_ParticleSystemRenderer_Internal_GetEnabledVertexStreamsv: __Z76Register_UnityEngine_ParticleSystemRenderer_Internal_GetEnabledVertexStreamsv, _jpeg_set_defaults: _jpeg_set_defaults, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4peekEv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4peekEv, __ZN2UI6Canvas15ThreadedCleanupEv: __ZN2UI6Canvas15ThreadedCleanupEv, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED0Ev: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED0Ev, __Z38MaterialPropertyBlock_CUSTOM_SetBufferP12Il2CppObjectiS0_: __Z38MaterialPropertyBlock_CUSTOM_SetBufferP12Il2CppObjectiS0_, __Z37AudioReverbFilter_Set_Custom_PropRoomP12Il2CppObjectf: __Z37AudioReverbFilter_Set_Custom_PropRoomP12Il2CppObjectf, __Z28CleanupUnityWebRequestModulev: __Z28CleanupUnityWebRequestModulev, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN10SpookyHash6UpdateEPKvj: __ZN10SpookyHash6UpdateEPKvj, __ZN5physx2Gu31SinglePersistentContactManifold31addBatchManifoldContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE: __ZN5physx2Gu31SinglePersistentContactManifold31addBatchManifoldContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __ZN5physx21PxVehicleDriveDynData14setToRestStateEv: __ZN5physx21PxVehicleDriveDynData14setToRestStateEv, __ZN7mecanim12statemachine32CreateSelectorTransitionConstantEPPNS0_17ConditionConstantEjjRNS_6memory9AllocatorE: __ZN7mecanim12statemachine32CreateSelectorTransitionConstantEPPNS0_17ConditionConstantEjjRNS_6memory9AllocatorE, __ZN16LevelGameManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16LevelGameManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z49Register_UnityEngine_Input_mainGyroIndex_Internalv: __Z49Register_UnityEngine_Input_mainGyroIndex_Internalv, __ZN24UVModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN24UVModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_: __Z36scripting_liveness_calculation_beginP11Il2CppClassiPFvPP12Il2CppObjectiPvES4_PFvvES8_, __Z40Rigidbody2D_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK13Vector2fIcall: __Z40Rigidbody2D_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK13Vector2fIcall, __ZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEE: __ZN5physx11Adjacencies5Walk2EPFvRKNS_16CommonWalkParamsEjjjjEPvPKNS_6PxVec3EPKNS_2Gu9TriangleTIjEE, __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_, __ZN10RectOffset8TransferI8JSONReadEEvRT_: __ZN10RectOffset8TransferI8JSONReadEEvRT_, __ZN5physx8debugger4comm19AddProfileZoneEvent9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm19AddProfileZoneEvent9serializeERNS1_15EventSerializerE, __ZN5physx2Sn18RepXCollectionImpl7destroyEv: __ZN5physx2Sn18RepXCollectionImpl7destroyEv, __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10RectOffset8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx2Sc5Scene27getCCDContactModifyCallbackEv: __ZNK5physx2Sc5Scene27getCCDContactModifyCallbackEv, __ZN11BoxCollider7SetSizeERK8Vector3f: __ZN11BoxCollider7SetSizeERK8Vector3f, __Z30RegisterModule_ParticlesLegacyv: __Z30RegisterModule_ParticlesLegacyv, __Z24scripting_class_get_typeP11Il2CppClass: __Z24scripting_class_get_typeP11Il2CppClass, _gray_conic_to: _gray_conic_to, __ZN26AnimatorControllerPlayable7SetBoolEiRKb: __ZN26AnimatorControllerPlayable7SetBoolEiRKb, __ZN5physx2Sc18TriggerInteraction10onActivateEj: __ZN5physx2Sc18TriggerInteraction10onActivateEj, __Z24RegisterStrippedTypeInfoI20OcclusionCullingDataEviPKcS2_: __Z24RegisterStrippedTypeInfoI20OcclusionCullingDataEviPKcS2_, __Z57Register_UnityEngine_RenderSettings_get_reflectionBouncesv: __Z57Register_UnityEngine_RenderSettings_get_reflectionBouncesv, _UNITY_FT_Outline_New_Internal: _UNITY_FT_Outline_New_Internal, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj623ENS_22PxRepXPropertyAccessorILj623ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj623ENS_22PxRepXPropertyAccessorILj623ES4_KffEEEEvRKT0_, __Z53Register_UnityEngine_TerrainData_set_detailPrototypesv: __Z53Register_UnityEngine_TerrainData_set_detailPrototypesv, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEbT0_S8_T_, __ZNK15Lz4Decompressor16DecompressStreamEPvPKvPjS0_S3_b: __ZNK15Lz4Decompressor16DecompressStreamEPvPKvPjS0_S3_b, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13set_empty_keyERKS9_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13set_empty_keyERKS9_, __ZN19CullingGroupManager12CleanupClassEPv: __ZN19CullingGroupManager12CleanupClassEPv, __Z31Texture2D_CUSTOM_SetAllPixels32P12Il2CppObjectP11Il2CppArrayi: __Z31Texture2D_CUSTOM_SetAllPixels32P12Il2CppObjectP11Il2CppArrayi, __Z47AudioReverbZone_Get_Custom_PropReflectionsDelayP12Il2CppObject: __Z47AudioReverbZone_Get_Custom_PropReflectionsDelayP12Il2CppObject, __ZN15QualitySettings21SetMasterTextureLimitEi: __ZN15QualitySettings21SetMasterTextureLimitEi, __ZN14dtPathCorridor8setToEndEv: __ZN14dtPathCorridor8setToEndEv, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE: __ZN5physx2Sc8ActorSimC2ERNS0_5SceneERNS0_9ActorCoreENS0_14IslandNodeInfo4TypeE, __ZN11UnityEngine15CloudWebService19SessionEventManager20ProcessEventQueueJobEPNS0_14CloudEventInfoE: __ZN11UnityEngine15CloudWebService19SessionEventManager20ProcessEventQueueJobEPNS0_14CloudEventInfoE, _UNITY_FT_List_Remove: _UNITY_FT_List_Remove, __ZNK5Umbra10Visibility22getOutputContributionsEv: __ZNK5Umbra10Visibility22getOutputContributionsEv, __Z18ActivateGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z18ActivateGameObjectR10GameObjectRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN14ParticleSystem16TransformChangedEi: __ZN14ParticleSystem16TransformChangedEi, __ZN5physx2Gu31checkOverlapCapsule_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu31checkOverlapCapsule_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, _empty_output_buffer: _empty_output_buffer, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE6getlocEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE6getlocEv, __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__213__vector_baseIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEED2Ev, __ZN5Umbra9Matrix3x3mLEf: __ZN5Umbra9Matrix3x3mLEf, __ZN17GeneralConnection14NetworkMessage5SetIDENS_9MessageIDE: __ZN17GeneralConnection14NetworkMessage5SetIDENS_9MessageIDE, __Z20raycast_triangleMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_: __Z20raycast_triangleMeshRKN5physx10PxGeometryERKNS_11PxTransformERKNS_6PxVec3ES8_fNS_7PxFlagsINS_9PxHitFlag4EnumEtEEjPNS_12PxRaycastHitEbPFbRSD_PvESG_, __Z29FindBrightestDirectionalLightb: __Z29FindBrightestDirectionalLightb, __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE: __ZN9Scripting26GetMethodWithSearchOptionsEP11Il2CppClassPKcN24ScriptingMethodFiltering18MethodSearchFilterE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE13isSubordinateEv, __ZN7CubemapD2Ev: __ZN7CubemapD2Ev, __Z33Material_CUSTOM_GetFloatArrayImplP12Il2CppObjecti: __Z33Material_CUSTOM_GetFloatArrayImplP12Il2CppObjecti, __ZN16Physics2DManager11CapsuleCastERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP12RaycastHit2Di: __ZN16Physics2DManager11CapsuleCastERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP12RaycastHit2Di, _UNITY_FT_GlyphLoader_Prepare: _UNITY_FT_GlyphLoader_Prepare, __Z52Register_UnityEngine_ParticleSystem_Internal_IsAlivev: __Z52Register_UnityEngine_ParticleSystem_Internal_IsAlivev, __Z51CharacterController_CUSTOM_INTERNAL_CALL_SimpleMoveP12Il2CppObjectRK8Vector3f: __Z51CharacterController_CUSTOM_INTERNAL_CALL_SimpleMoveP12Il2CppObjectRK8Vector3f, __Z35AnimationClip_Set_Custom_PropLegacyP12Il2CppObjecth: __Z35AnimationClip_Set_Custom_PropLegacyP12Il2CppObjecth, __ZN18AsyncUploadManager23HandleAsyncReadCommandsEv: __ZN18AsyncUploadManager23HandleAsyncReadCommandsEv, __ZN5physxL22testTriangleFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_: __ZN5physxL22testTriangleFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_, __ZN9Rigidbody18AddForceAtPositionERK8Vector3fS2_i: __ZN9Rigidbody18AddForceAtPositionERK8Vector3fS2_i, __ZNK2UI13RectTransform7GetRectEv: __ZNK2UI13RectTransform7GetRectEv, __ZL38UnityAudioEffect_InternalResetCallbackP14FMOD_DSP_STATE: __ZL38UnityAudioEffect_InternalResetCallbackP14FMOD_DSP_STATE, __Z36CanvasRenderer_CUSTOM_GetPopMaterialP12Il2CppObjecti: __Z36CanvasRenderer_CUSTOM_GetPopMaterialP12Il2CppObjecti, __ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__212_GLOBAL__N_130throw_from_string_out_of_rangeERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN13AnimationClip8SetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfEbb: __ZN13AnimationClip8SetCurveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi4PPtrI10MonoScriptES8_P17AnimationCurveTplIfEbb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj666ES3_RKNS_20PxVehicleAutoBoxDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj666ES3_RKNS_20PxVehicleAutoBoxDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z40Register_UnityEngine_Resources_LoadAsyncv: __Z40Register_UnityEngine_Resources_LoadAsyncv, __ZN17ArchiveFileSystem5WriteER13FileEntryDatayPvPy: __ZN17ArchiveFileSystem5WriteER13FileEntryDatayPvPy, _build_tree: _build_tree, __ZNK5physx2Sn8MetaData12getMetaClassENS_14PxConcreteType4EnumE: __ZNK5physx2Sn8MetaData12getMetaClassENS_14PxConcreteType4EnumE, __Z28Mesh_CUSTOM_SetTrianglesImplP12Il2CppObjectiP11Il2CppArrayih: __Z28Mesh_CUSTOM_SetTrianglesImplP12Il2CppObjectiP11Il2CppArrayih, __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation4Clip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z60Register_UnityEngine_Material_INTERNAL_CALL_SetTextureOffsetv: __Z60Register_UnityEngine_Material_INTERNAL_CALL_SetTextureOffsetv, __Z62Register_UnityEngine_GUIStyle_INTERNAL_get_Internal_clipOffsetv: __Z62Register_UnityEngine_GUIStyle_INTERNAL_get_Internal_clipOffsetv, __Z49MonoBehaviour_CUSTOM_StartCoroutine_Auto_InternalP12Il2CppObjectS0_: __Z49MonoBehaviour_CUSTOM_StartCoroutine_Auto_InternalP12Il2CppObjectS0_, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE, __ZN11JointLimits8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11JointLimits8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Unity12PhysicsQuery11CapsuleCastERK8Vector3fS3_fS3_fR10RaycastHiti23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery11CapsuleCastERK8Vector3fS3_fS3_fR10RaycastHiti23QueryTriggerInteraction, __Z45Register_UnityEngine_Renderer_get_probeAnchorv: __Z45Register_UnityEngine_Renderer_get_probeAnchorv, __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_19ParticlePacketShapeE: __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_19ParticlePacketShapeE, __Z50Register_UnityEngine_Profiling_Sampler_set_enabledv: __Z50Register_UnityEngine_Profiling_Sampler_set_enabledv, __Z17UnloadAssetBundleR11AssetBundleb: __Z17UnloadAssetBundleR11AssetBundleb, __ZN5physx12_GLOBAL__N_122getImpulseResponseSimdERKNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES6_: __ZN5physx12_GLOBAL__N_122getImpulseResponseSimdERKNS_9PxcFsDataEjNS_6shdfnd3aos5Vec3VES6_, _stbir_resize_uint8_srgb: _stbir_resize_uint8_srgb, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwy, __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci: __Z36scripting_class_get_method_from_nameP11Il2CppClassPKci, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN13TextRendering4Font23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13TextRendering4Font23VirtualRedirectTransferER17RemapPPtrTransfer, _UNITY_png_read_data: _UNITY_png_read_data, __Z39GUIClip_CUSTOM_INTERNAL_get_visibleRectP5RectTIfE: __Z39GUIClip_CUSTOM_INTERNAL_get_visibleRectP5RectTIfE, __Z42CapsuleCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall: __Z42CapsuleCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall, __ZL23SweepCapsuleUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL23SweepCapsuleUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN5physx2Sc21ElementSimInteractionD0Ev: __ZN5physx2Sc21ElementSimInteractionD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7Joint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESL_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESL_RKT_, __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE: __ZN19ShaderPropertySheet9SetMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4fNS_8SetFlagsE, __ZN14RenderSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14RenderSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEty, __Z53Register_UnityEngine_Input_get_touchPressureSupportedv: __Z53Register_UnityEngine_Input_get_touchPressureSupportedv, __Z39Gizmos_CUSTOM_INTERNAL_CALL_DrawFrustumRK8Vector3fffff: __Z39Gizmos_CUSTOM_INTERNAL_CALL_DrawFrustumRK8Vector3fffff, _cf2_glyphpath_init: _cf2_glyphpath_init, _regcomp: _regcomp, __Z61Animator_Set_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObjecth: __Z61Animator_Set_Custom_PropAllowConstantClipSamplingOptimizationP12Il2CppObjecth, __ZN10GUITexture15ThreadedCleanupEv: __ZN10GUITexture15ThreadedCleanupEv, __Z32Register_UnityEngine_WWW_InitWWWv: __Z32Register_UnityEngine_WWW_InitWWWv, __ZN5physx49PxVehicleUpdateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE: __ZN5physx49PxVehicleUpdateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE, __ZN5LightD0Ev: __ZN5LightD0Ev, __Z40DynamicGI_Set_Custom_PropUpdateThresholdf: __Z40DynamicGI_Set_Custom_PropUpdateThresholdf, __ZN9Transform28ApplyRuntimeToSerializedDataEv: __ZN9Transform28ApplyRuntimeToSerializedDataEv, __ZN14ParticleSystem23CheckSupportsProceduralERKS_: __ZN14ParticleSystem23CheckSupportsProceduralERKS_, __Z21WWW_CUSTOM_GetTextureP12Il2CppObjecth: __Z21WWW_CUSTOM_GetTextureP12Il2CppObjecth, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj74ENS_22PxRepXPropertyAccessorILj74ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj74ENS_22PxRepXPropertyAccessorILj74ES4_ffEEEEvRKT0_, __ZN12NavMeshAgent19SetStoppingDistanceEf: __ZN12NavMeshAgent19SetStoppingDistanceEf, __ZN16PlayerConnection14PollListenModeEv: __ZN16PlayerConnection14PollListenModeEv, _LzmaDec_Init: _LzmaDec_Init, __Z43GIDebugVisualisation_Get_Custom_PropTexTypev: __Z43GIDebugVisualisation_Get_Custom_PropTexTypev, __Z77Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeTriggerParticlesSizev: __Z77Register_UnityEngine_ParticleSystemExtensionsImpl_GetSafeTriggerParticlesSizev, __ZN5physx14NpRigidDynamic24setSolverIterationCountsEjj: __ZN5physx14NpRigidDynamic24setSolverIterationCountsEjj, __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE: __ZL23CalculateTransformRootsR9TransformRNSt3__26vectorIPS_13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEE, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEaSEOS3_: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEaSEOS3_, __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEE8recreateEj, __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayListImplv: __Z73Register_UnityEngine_Rendering_CommandBuffer_SetGlobalVectorArrayListImplv, __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN13AvatarBuilder14NamedTransformENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, _jpeg_default_colorspace: _jpeg_default_colorspace, __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet: __ZN20GpuProgramParameters14AddVectorParamEPKcii15ShaderParamTypeiiP16PropertyNamesSet, __ZN8Renderer24CopyCustomPropertiesFromERK19ShaderPropertySheet: __ZN8Renderer24CopyCustomPropertiesFromERK19ShaderPropertySheet, __ZN5physx12NpConstraint7releaseEv: __ZN5physx12NpConstraint7releaseEv, __ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj: __ZNK5physx16PxVehicleNoDrive14getDriveTorqueEj, __ZN12FixedJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN12FixedJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwd, __Z63Register_UnityEngine_ParticleSystem_LightsModule_GetLightPrefabv: __Z63Register_UnityEngine_ParticleSystem_LightsModule_GetLightPrefabv, __Z46Register_UnityEngine_Texture2D_Internal_Createv: __Z46Register_UnityEngine_Texture2D_Internal_Createv, __ZN12AudioManager15DidReloadDomainEv: __ZN12AudioManager15DidReloadDomainEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj264ENS_22PxRepXPropertyAccessorILj264ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN2UI6Canvas16SetTargetDisplayEi: __ZN2UI6Canvas16SetTargetDisplayEi, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_16StringTableEventEEEvT_: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEE9sendEventINS0_16StringTableEventEEEvT_, __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf: __ZN7mecanim5human15GetLookAtDeltaQERKN4math7_float3ES4_RKNS1_7_float4ES4_S4_RKf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8Material14SetMatrixArrayEN9ShaderLab16FastPropertyNameEPK10Matrix4x4fj: __ZN8Material14SetMatrixArrayEN9ShaderLab16FastPropertyNameEPK10Matrix4x4fj, __ZN4FMOD6System14getDriverInfoWEiPsiP9FMOD_GUID: __ZN4FMOD6System14getDriverInfoWEiPsiP9FMOD_GUID, __ZNK5physx2Sc18ParticleSystemCore23getRestParticleDistanceEv: __ZNK5physx2Sc18ParticleSystemCore23getRestParticleDistanceEv, __Z45Animator_Get_Custom_PropHasTransformHierarchyP12Il2CppObject: __Z45Animator_Get_Custom_PropHasTransformHierarchyP12Il2CppObject, __ZN11UnityEngine9AnimationL23InitializeDefaultValuesERKNS0_30AnimatorGenericBindingConstantEPKN7mecanim9animation14AvatarConstantEb: __ZN11UnityEngine9AnimationL23InitializeDefaultValuesERKNS0_30AnimatorGenericBindingConstantEPKN7mecanim9animation14AvatarConstantEb, __ZN8Gradient17ValidateAlphaKeysEv: __ZN8Gradient17ValidateAlphaKeysEv, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, _tre_copy_ast: _tre_copy_ast, __Z14EmptyNormalMapP9Texture2DPhiiii: __Z14EmptyNormalMapP9Texture2DPhiiii, __ZN9dtNavMesh10getTilesAtEiiPP10dtMeshTilei: __ZN9dtNavMesh10getTilesAtEiiPP10dtMeshTilei, _UNITY_TT_Run_Context: _UNITY_TT_Run_Context, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE13getActorFlagsEv, __ZN9DepthPassD0Ev: __ZN9DepthPassD0Ev, __ZN5physx15PxsParticleData15setRestOffsetsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKfEE: __ZN5physx15PxsParticleData15setRestOffsetsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKfEE, __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj: __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE7reserveEj, __Z48Register_UnityEngine_SparseTexture_get_isCreatedv: __Z48Register_UnityEngine_SparseTexture_get_isCreatedv, __Z46Cloth_CUSTOM_INTERNAL_get_externalAccelerationP12Il2CppObjectP8Vector3f: __Z46Cloth_CUSTOM_INTERNAL_get_externalAccelerationP12Il2CppObjectP8Vector3f, __ZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f: __ZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_f, __ZN13InitialModule8TransferI14SafeBinaryReadEEvRT_: __ZN13InitialModule8TransferI14SafeBinaryReadEEvRT_, __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii: __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii, __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN27AnimatorControllerParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cff_ps_get_font_info: _cff_ps_get_font_info, __Z28Gradient_Get_Custom_PropModeP12Il2CppObject: __Z28Gradient_Get_Custom_PropModeP12Il2CppObject, __ZNK5physx13NpClothFabric20getNbParticleIndicesEv: __ZNK5physx13NpClothFabric20getNbParticleIndicesEv, __ZN8Playable29SetPlayableDeleteOnDisconnectEPS_b: __ZN8Playable29SetPlayableDeleteOnDisconnectEPS_b, __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI10GameObjectE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15NavMeshObstacle17OnVelocityChangedEP8Vector3f: __ZN15NavMeshObstacle17OnVelocityChangedEP8Vector3f, __ZN13b2DynamicTree10InsertLeafEi: __ZN13b2DynamicTree10InsertLeafEi, __Z57Register_UnityEngine_RenderSettings_INTERNAL_set_fogColorv: __Z57Register_UnityEngine_RenderSettings_INTERNAL_set_fogColorv, __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11NamedObject8TransferI24GenerateTypeTreeTransferEEvRT_, __Z24RegisterStrippedTypeInfoIN2UI6CanvasEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN2UI6CanvasEEviPKcS3_, __Z31Profiler_CUSTOM_GetMonoHeapSizev: __Z31Profiler_CUSTOM_GetMonoHeapSizev, __ZN12HandlerChain5WriteER13FileEntryDatayyPvPy: __ZN12HandlerChain5WriteER13FileEntryDatayyPvPy, __Z46CharacterController_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z46CharacterController_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __ZN9Transform8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Transform8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14PlayerSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14PlayerSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __Z32Mesh_Set_Custom_PropSubMeshCountP12Il2CppObjecti: __Z32Mesh_Set_Custom_PropSubMeshCountP12Il2CppObjecti, __ZN11UnityEngine15CloudWebService17SessionEventQueue14ParseEventDataERK8UnityStr: __ZN11UnityEngine15CloudWebService17SessionEventQueue14ParseEventDataERK8UnityStr, __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet: __ZNK9ShaderLab7Program24MarkVariantAsUnsupportedERK16ShaderKeywordSet, __Z62Register_UnityEngine_ParticleSystem_MainModule_SetMaxParticlesv: __Z62Register_UnityEngine_ParticleSystem_MainModule_SetMaxParticlesv, __ZNK9dtNavMesh12getPolyFlagsEy: __ZNK9dtNavMesh12getPolyFlagsEy, __Z63ParticleSystem_CollisionModule_CUSTOM_SetEnableDynamicCollidersP12Il2CppObjecth: __Z63ParticleSystem_CollisionModule_CUSTOM_SetEnableDynamicCollidersP12Il2CppObjecth, __ZN4FMOD6SoundI15getSystemObjectEPPNS_6SystemE: __ZN4FMOD6SoundI15getSystemObjectEPPNS_6SystemE, __Z58Register_UnityEngine_CharacterJoint_set_projectionDistancev: __Z58Register_UnityEngine_CharacterJoint_set_projectionDistancev, __Z47Register_UnityEngine_AudioEchoFilter_set_wetMixv: __Z47Register_UnityEngine_AudioEchoFilter_set_wetMixv, __ZN5physx20clearTorqueCurvePairEPNS_19PxVehicleEngineDataE: __ZN5physx20clearTorqueCurvePairEPNS_19PxVehicleEngineDataE, __ZL17setupOverlapFlagsjP13BoxPrunerData: __ZL17setupOverlapFlagsjP13BoxPrunerData, __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiRKNS_7Vector3ES7_PNS_9AllocatorEPKS0_: __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiRKNS_7Vector3ES7_PNS_9AllocatorEPKS0_, __ZN11GPUProfiler10BeginFrameEv: __ZN11GPUProfiler10BeginFrameEv, __Z28UnloadAssetBundleFileStreamsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE: __Z28UnloadAssetBundleFileStreamsRKNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE, __Z22setPxArticulation_NamePN5physx14PxArticulationEPKc: __Z22setPxArticulation_NamePN5physx14PxArticulationEPKc, __ZN11dtNodeQueue11trickleDownEiP6dtNode: __ZN11dtNodeQueue11trickleDownEiP6dtNode, __ZN4FMOD13ChannelGroupI15getSystemObjectEPPNS_6SystemE: __ZN4FMOD13ChannelGroupI15getSystemObjectEPPNS_6SystemE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj523ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _UNITY_ft_validator_init: _UNITY_ft_validator_init, __Z36AudioEchoFilter_Get_Custom_PropDelayP12Il2CppObject: __Z36AudioEchoFilter_Get_Custom_PropDelayP12Il2CppObject, __ZN13b2PulleyJoint11ShiftOriginERK6b2Vec2: __ZN13b2PulleyJoint11ShiftOriginERK6b2Vec2, __Z17GetCachingManagerv: __Z17GetCachingManagerv, __Z46Register_UnityEngine_Animator_get_recorderModev: __Z46Register_UnityEngine_Animator_get_recorderModev, __ZNK19TouchPhaseEmulation8GetTouchEjR5Touch: __ZNK19TouchPhaseEmulation8GetTouchEjR5Touch, __Z36AnimationState_Set_Custom_PropWeightP12Il2CppObjectf: __Z36AnimationState_Set_Custom_PropWeightP12Il2CppObjectf, __Z22Input_CUSTOM_GetButtonP12Il2CppString: __Z22Input_CUSTOM_GetButtonP12Il2CppString, __ZN5physx21NpShapeGetScPtrOffsetEv: __ZN5physx21NpShapeGetScPtrOffsetEv, __ZNKSt3__28numpunctIwE11do_truenameEv: __ZNKSt3__28numpunctIwE11do_truenameEv, __Z14GetChannelNameRK14BlendShapeDatai: __Z14GetChannelNameRK14BlendShapeDatai, __Z48Register_UnityEngine_GUIUtility_GrabMouseControlv: __Z48Register_UnityEngine_GUIUtility_GrabMouseControlv, __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12HingeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z65ParticleSystem_CollisionModule_CUSTOM_GetEnableInteriorCollisionsP12Il2CppObject: __Z65ParticleSystem_CollisionModule_CUSTOM_GetEnableInteriorCollisionsP12Il2CppObject, __ZN13RenderTexture23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13RenderTexture23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx3Scb14ParticleSystem16releaseParticlesEv: __ZN5physx3Scb14ParticleSystem16releaseParticlesEv, __ZN13RenderTextureD0Ev: __ZN13RenderTextureD0Ev, __ZN20UnloadSceneOperationD0Ev: __ZN20UnloadSceneOperationD0Ev, __ZThn32_N16ParticleRendererD0Ev: __ZThn32_N16ParticleRendererD0Ev, __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb: __ZN6Object21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb, __ZNSt16nested_exceptionC2Ev: __ZNSt16nested_exceptionC2Ev, __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb: __ZN5physx2Sc10NPhaseCore18releaseElementPairEPNS0_21ElementSimInteractionEjjb, __ZN8VRModuleC2Ev: __ZN8VRModuleC2Ev, __ZN19CloudServiceHandler23ProcessAsyncFileRestoreERN11UnityEngine15CloudWebService11FileRestoreE: __ZN19CloudServiceHandler23ProcessAsyncFileRestoreERN11UnityEngine15CloudWebService11FileRestoreE, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9Rigidbody24SetInertiaTensorRotationERK11Quaternionf: __ZN9Rigidbody24SetInertiaTensorRotationERK11Quaternionf, __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMinP12Il2CppObjectRK13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMinP12Il2CppObjectRK13Vector2fIcall, __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode: __ZN15TerrainRenderer21RecursiveRemoveMeshesER12QuadTreeNode, __ZN5Umbra15ShadowCullerExtaSERKS0_: __ZN5Umbra15ShadowCullerExtaSERKS0_, __ZNSt3__214error_categoryC2Ev: __ZNSt3__214error_categoryC2Ev, __Z27getPxScene_DynamicStructurePKN5physx7PxSceneE: __Z27getPxScene_DynamicStructurePKN5physx7PxSceneE, __ZN15UniformTFMethod16BindForRenderingEj: __ZN15UniformTFMethod16BindForRenderingEj, _tcsendbreak: _tcsendbreak, __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags, __Z56Register_UnityEngine_Random_INTERNAL_get_rotationUniformv: __Z56Register_UnityEngine_Random_INTERNAL_get_rotationUniformv, __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_NewObject13Il2Cpp_IntPtrS_P11Il2CppArrayRPv: __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_NewObject13Il2Cpp_IntPtrS_P11Il2CppArrayRPv, __ZN5Unity14CharacterJoint14SetSwing1LimitERK14SoftJointLimit: __ZN5Unity14CharacterJoint14SetSwing1LimitERK14SoftJointLimit, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7Terrain12MaterialTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN7Terrain12MaterialTypeEEvRT_RT0_PKc17TransferMetaFlags, __ZN26IntersectAnyVsMeshCallbackILi2ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi2ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __Z20RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __Z20RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __ZN5physx20InternalTriangleMesh17allocateMaterialsEv: __ZN5physx20InternalTriangleMesh17allocateMaterialsEv, __Z30GUI_CUSTOM_Internal_SetTooltipP12Il2CppString: __Z30GUI_CUSTOM_Internal_SetTooltipP12Il2CppString, __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12getClassSizeEv, __Z29DeleteFileOrDirectoryIfExistsPKcb: __Z29DeleteFileOrDirectoryIfExistsPKcb, __ZN4Mesh24QueryGpuSkinSourceBufferEi: __ZN4Mesh24QueryGpuSkinSourceBufferEi, _cimagf: _cimagf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj619ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN13ScreenManager12SetIsFocusedEb: __ZN13ScreenManager12SetIsFocusedEb, __Z46Register_UnityEngine_Animator_set_playbackTimev: __Z46Register_UnityEngine_Animator_set_playbackTimev, __ZN14PhysicsManager13CreateReportsEv: __ZN14PhysicsManager13CreateReportsEv, __ZN18AudioLowPassFilter26SetCustomLowpassLevelCurveERK17AnimationCurveTplIfE: __ZN18AudioLowPassFilter26SetCustomLowpassLevelCurveERK17AnimationCurveTplIfE, __Z26InitializeAsyncReadManagerv: __Z26InitializeAsyncReadManagerv, __ZNKSt3__28messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE: __ZNKSt3__28messagesIwE6do_getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE, __Z75Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierMultiplierv: __Z75Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierMultiplierv, _skip_input_data: _skip_input_data, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13TargetJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z54Register_UnityEngine_AudioReverbFilter_get_roomRolloffv: __Z54Register_UnityEngine_AudioReverbFilter_get_roomRolloffv, __Z34Register_UnityEngine_Camera_Renderv: __Z34Register_UnityEngine_Camera_Renderv, __ZNSt3__26__sortIRNS_6__lessIddEEPdEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIddEEPdEEvT0_S5_T_, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE8__appendEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu31SpherePersistentContactManifoldEEEE15growAndPushBackERKS2_, __ZNK14UnityWebStream10IsFinishedEv: __ZNK14UnityWebStream10IsFinishedEv, __Z31Collider_Set_Custom_PropEnabledP12Il2CppObjecth: __Z31Collider_Set_Custom_PropEnabledP12Il2CppObjecth, __ZN5physx7NpShape12setLocalPoseERKNS_11PxTransformE: __ZN5physx7NpShape12setLocalPoseERKNS_11PxTransformE, __ZNK5physx9NpFactory9getShapesEPPNS_7PxShapeEjj: __ZNK5physx9NpFactory9getShapesEPPNS_7PxShapeEjj, __Z26GetScriptClassIdComponentsP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES9_S9_: __Z26GetScriptClassIdComponentsP11Il2CppClassRNSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES9_S9_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE15growAndPushBackERKS2_, __Z17GetConsoleLogPathv: __Z17GetConsoleLogPathv, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED2Ev: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED2Ev, __ZN6Camera5ResetEv: __ZN6Camera5ResetEv, __ZN8VRDevice12ProcessFocusEv: __ZN8VRDevice12ProcessFocusEv, __ZN13GfxDeviceGLES13DeleteTextureE9TextureID: __ZN13GfxDeviceGLES13DeleteTextureE9TextureID, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj594ENS_22PxRepXPropertyAccessorILj594ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj594ENS_22PxRepXPropertyAccessorILj594ES4_ffEEEEvRKT0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj446ENS_22PxRepXPropertyAccessorILj446ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj446ENS_22PxRepXPropertyAccessorILj446ES4_ffEEEEvRKT0_, __ZN8VRModule11EarlyUpdateEv: __ZN8VRModule11EarlyUpdateEv, __ZN5physx12NpGetPxSceneERNS_3Scb5SceneE: __ZN5physx12NpGetPxSceneERNS_3Scb5SceneE, __ZN14ParticleSystem17DisableUsesTrailsEv: __ZN14ParticleSystem17DisableUsesTrailsEv, _strlen: _strlen, __ZN5physx23performBoxPruningNewNewERKNS_2Gu4AxesEPKjjbPjPPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_: __ZN5physx23performBoxPruningNewNewERKNS_2Gu4AxesEPKjjbPjPPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_, __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5Umbra11Transformer16frustumShrinkBoxEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_RS4_S5_: __ZNK5Umbra11Transformer16frustumShrinkBoxEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_RS4_S5_, __Z43Random_CUSTOM_INTERNAL_get_insideUnitSphereP8Vector3f: __Z43Random_CUSTOM_INTERNAL_get_insideUnitSphereP8Vector3f, __Z28getPxPrismaticJoint_PositionPKN5physx16PxPrismaticJointE: __Z28getPxPrismaticJoint_PositionPKN5physx16PxPrismaticJointE, __Z55Register_UnityEngine_Joint_INTERNAL_get_connectedAnchorv: __Z55Register_UnityEngine_Joint_INTERNAL_get_connectedAnchorv, __ZN5physx22PxDefaultFileInputDataD2Ev: __ZN5physx22PxDefaultFileInputDataD2Ev, _UNITY_ft_mem_free: _UNITY_ft_mem_free, _strverscmp: _strverscmp, __Z33getPxArticulationJoint_SwingLimitPKN5physx19PxArticulationJointERfS3_: __Z33getPxArticulationJoint_SwingLimitPKN5physx19PxArticulationJointERfS3_, __Z36MeshFilter_Set_Custom_PropSharedMeshP12Il2CppObjectS0_: __Z36MeshFilter_Set_Custom_PropSharedMeshP12Il2CppObjectS0_, __ZNSt3__2L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L13utf16_to_utf8EPKtS1_RS1_PhS3_RS3_mNS_12codecvt_modeE, __ZN18DelayedCallManager6UpdateEi: __ZN18DelayedCallManager6UpdateEi, __Z52Register_UnityEngine_Display_GetRenderingBuffersImplv: __Z52Register_UnityEngine_Display_GetRenderingBuffersImplv, __ZN9GfxDevice14ImmediateColorEffff: __ZN9GfxDevice14ImmediateColorEffff, _nrand48: _nrand48, __ZN13GfxDeviceGLES16BeginBufferWriteEP9GfxBufferjj: __ZN13GfxDeviceGLES16BeginBufferWriteEP9GfxBufferjj, __Z48Register_UnityEngine_Matrix4x4_INTERNAL_CALL_TRSv: __Z48Register_UnityEngine_Matrix4x4_INTERNAL_CALL_TRSv, __ZN8Renderer15RemoveFromSceneEv: __ZN8Renderer15RemoveFromSceneEv, _uname: _uname, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject, __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI17SortingLayerEntryNS0_9allocatorIS2_EEEEEvRT_j, _unzOpenCurrentFile3: _unzOpenCurrentFile3, _unzOpenCurrentFile2: _unzOpenCurrentFile2, __ZNK5physx7NpScene16getSpuDispatcherEv: __ZNK5physx7NpScene16getSpuDispatcherEv, __ZNK15RelativeJoint2D15GetLinearOffsetEv: __ZNK15RelativeJoint2D15GetLinearOffsetEv, __Z45getPxRevoluteJoint_ProjectionAngularTolerancePKN5physx15PxRevoluteJointE: __Z45getPxRevoluteJoint_ProjectionAngularTolerancePKN5physx15PxRevoluteJointE, __ZN19MeshParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN19MeshParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer, __Z67Register_UnityEngine_AI_NavMeshAgent_GetNextOffMeshLinkDataInternalv: __Z67Register_UnityEngine_AI_NavMeshAgent_GetNextOffMeshLinkDataInternalv, _ferror: _ferror, __ZN5physx28integrateWheelRotationAnglesEffffPKfS1_S1_PKbRKNS_21PxVehicleDriveSimDataERKNS_23PxVehicleWheels4SimDataERNS_21PxVehicleDriveDynDataERNS_23PxVehicleWheels4DynDataE: __ZN5physx28integrateWheelRotationAnglesEffffPKfS1_S1_PKbRKNS_21PxVehicleDriveSimDataERKNS_23PxVehicleWheels4SimDataERNS_21PxVehicleDriveDynDataERNS_23PxVehicleWheels4DynDataE, __ZN20BaseBehaviourManager12CommonUpdateI16BehaviourManagerEEvv: __ZN20BaseBehaviourManager12CommonUpdateI16BehaviourManagerEEvv, __ZN6b2Draw8SetFlagsEj: __ZN6b2Draw8SetFlagsEj, __ZNK13SliderJoint2D13GetMotorForceEf: __ZNK13SliderJoint2D13GetMotorForceEf, __ZN17LowLevelAllocator7ReallocEPvjj: __ZN17LowLevelAllocator7ReallocEPvjj, __Z55Register_UnityEngine_CharacterJoint_set_projectionAnglev: __Z55Register_UnityEngine_CharacterJoint_set_projectionAnglev, __ZN5physx9NpFactory22createNpParticleSystemEjb: __ZN5physx9NpFactory22createNpParticleSystemEjb, __ZNK5physx13NpRigidStatic13getGlobalPoseEv: __ZNK5physx13NpRigidStatic13getGlobalPoseEv, __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z9LightMaskjRK14LightingLayers: __Z9LightMaskjRK14LightingLayers, __ZN11UnityEngine15PlatformWrapper13GetDeviceNameEv: __ZN11UnityEngine15PlatformWrapper13GetDeviceNameEv, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN14SphereCollider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14SphereCollider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNKSt3__26locale4nameEv: __ZNKSt3__26locale4nameEv, __ZN5physx7profile19MemoryEventRecorderD0Ev: __ZN5physx7profile19MemoryEventRecorderD0Ev, __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher18PreformWebDispatchEv, __ZN15DirectorManager23DestroyPendingPlayablesEv: __ZN15DirectorManager23DestroyPendingPlayablesEv, __Z24HumanDescriptionFromMonoRK20MonoHumanDescriptionR16HumanDescription: __Z24HumanDescriptionFromMonoRK20MonoHumanDescriptionR16HumanDescription, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumParticleAccelerationsEv, __Z46PhysicMaterial_Get_Custom_PropDynamicFriction2P12Il2CppObject: __Z46PhysicMaterial_Get_Custom_PropDynamicFriction2P12Il2CppObject, __ZThn8_N12_GLOBAL__N_111StreamOwnerD1Ev: __ZThn8_N12_GLOBAL__N_111StreamOwnerD1Ev, __ZN14SpriteRenderer19UpdateTransformInfoEv: __ZN14SpriteRenderer19UpdateTransformInfoEv, __Z35Animator_Get_Custom_PropCullingModeP12Il2CppObject: __Z35Animator_Get_Custom_PropCullingModeP12Il2CppObject, __ZN16ReflectionProbes20BlurMipmapLevelsFromEP15ReflectionProbei: __ZN16ReflectionProbes20BlurMipmapLevelsFromEP15ReflectionProbei, __ZNK14ParticleSystem18GetStartRotation3DEv: __ZNK14ParticleSystem18GetStartRotation3DEv, __ZN14AreaEffector2D14SetForceTargetE19EffectorSelection2D: __ZN14AreaEffector2D14SetForceTargetE19EffectorSelection2D, __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_, __ZN9ShaderLab11ShaderStateC2Ev: __ZN9ShaderLab11ShaderStateC2Ev, __Z17RenderStaticBatchR9GfxDevice10Matrix4x4fRNSt3__26vectorI7SubMesh13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEEERK11MeshBuffersPK17BatchInstanceDatajRK14ChannelAssigns: __Z17RenderStaticBatchR9GfxDevice10Matrix4x4fRNSt3__26vectorI7SubMesh13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEEERK11MeshBuffersPK17BatchInstanceDatajRK14ChannelAssigns, __ZN5physx2Sc8ClothSimD2Ev: __ZN5physx2Sc8ClothSimD2Ev, __ZN5physx2Sc5Scene18postReportsCleanupEv: __ZN5physx2Sc5Scene18postReportsCleanupEv, __Z33AudioSource_Get_Custom_PropSpreadP12Il2CppObject: __Z33AudioSource_Get_Custom_PropSpreadP12Il2CppObject, __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI14ConstantStringNS_9allocatorIS1_EEE8__appendEj, __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_: __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_T_, __Z42Shader_CUSTOM_SetGlobalVectorArrayImplListiP12Il2CppObject: __Z42Shader_CUSTOM_SetGlobalVectorArrayImplListiP12Il2CppObject, __ZNKSt3__26locale5__imp9has_facetEl: __ZNKSt3__26locale5__imp9has_facetEl, __Z23getNbPxAggregate_ActorsPKN5physx11PxAggregateE: __Z23getNbPxAggregate_ActorsPKN5physx11PxAggregateE, __ZN12AudioManager14OnMixerChangedEv: __ZN12AudioManager14OnMixerChangedEv, __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_: __Z22MultiplyMatrices4x4REFPK10Matrix4x4fS1_PS_, __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE: __ZN5physx9NpPhysics23notifyDeletionListenersEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE, __ZN12_GLOBAL__N_119constrainSeparationI8Scalar4fPKS1_EEvPT_PKS4_RKT0_: __ZN12_GLOBAL__N_119constrainSeparationI8Scalar4fPKS1_EEvPT_PKS4_RKT0_, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEED0Ev: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEED0Ev, __Z52Register_UnityEngine_AudioReverbZone_set_reflectionsv: __Z52Register_UnityEngine_AudioReverbZone_set_reflectionsv, _gzdirect: _gzdirect, __ZNK5physx31PxClothGeodesicTetherCookerImpl13getTetherDataEPjPf: __ZNK5physx31PxClothGeodesicTetherCookerImpl13getTetherDataEPjPf, __ZN20TextRenderingPrivate19NativeTextGenerator11InsertSpaceEv: __ZN20TextRenderingPrivate19NativeTextGenerator11InsertSpaceEv, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE, __Z36Projector_Set_Custom_PropFieldOfViewP12Il2CppObjectf: __Z36Projector_Set_Custom_PropFieldOfViewP12Il2CppObjectf, __ZN14ParticleSystem16UpdateProceduralERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles: __ZN14ParticleSystem16UpdateProceduralERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticles, __ZN4FMOD7Channel11setUserDataEPv: __ZN4FMOD7Channel11setUserDataEPv, __ZN9JSONWrite8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags, __ZN8Renderer15InitializeClassEv: __ZN8Renderer15InitializeClassEv, __ZNSt3__211timed_mutex8try_lockEv: __ZNSt3__211timed_mutex8try_lockEv, __Z61Register_UnityEngine_ParticleSystem_MainModule_GetScalingModev: __Z61Register_UnityEngine_ParticleSystem_MainModule_GetScalingModev, __ZN9Scripting24UnloadAssetFromScriptingEP6Object: __ZN9Scripting24UnloadAssetFromScriptingEP6Object, __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z29StdTemplateConversionFunctionIjtEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjtEbPvR14SafeBinaryRead, __ZN12TextureInput8CopyFromERKS_: __ZN12TextureInput8CopyFromERKS_, __ZNK14AsyncOperation7ReleaseEv: __ZNK14AsyncOperation7ReleaseEv, __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionZv: __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionZv, __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_: __ZN35RegisterRuntimeInitializeAndCleanupC2EPFvPvES2_iS0_, _UNITY_png_get_uint_31: _UNITY_png_get_uint_31, __ZNK5physx2Sc8ActorSim8getSceneEv: __ZNK5physx2Sc8ActorSim8getSceneEv, __ZN20BufferedSocketStream15FlushSendbufferEv: __ZN20BufferedSocketStream15FlushSendbufferEv, __ZN11UnityEngine15CloudWebService16SessionContainer11PurgeEventsEj: __ZN11UnityEngine15CloudWebService16SessionContainer11PurgeEventsEj, __ZN5physx7NpShape19getMeshRefCountableEv: __ZN5physx7NpShape19getMeshRefCountableEv, __ZNK10Matrix3x3f14GetDeterminantEv: __ZNK10Matrix3x3f14GetDeterminantEv, __Z52AudioDistortionFilter_Set_Custom_PropDistortionLevelP12Il2CppObjectf: __Z52AudioDistortionFilter_Set_Custom_PropDistortionLevelP12Il2CppObjectf, __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_: __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__do_getERS4_S4_bRKNS_6localeEjRjRbRKNS_5ctypeIcEERNS_10unique_ptrIcPFvPvEEERPcSM_, __ZN5physx2Sc9ClothCore13setRestOffsetEf: __ZN5physx2Sc9ClothCore13setRestOffsetEf, _fesetround: _fesetround, __ZN15RelativeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15RelativeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags, __ZN5physx14NpArticulation15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx14NpArticulation15exportExtraDataERNS_22PxSerializationContextE, __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_: __ZN5physx26PxcArticulationFnsSimdBase10computeSISERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialEPS4_, __Z19CanReplaceComponentRN5Unity9ComponentEiPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z19CanReplaceComponentRN5Unity9ComponentEiPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs7releaseEv: __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs7releaseEv, __Z20FindPluginExecutablePKc: __Z20FindPluginExecutablePKc, __ZN5physx15PxsParticleDataC2EPh: __ZN5physx15PxsParticleDataC2EPh, __ZN18LoadSceneOperation14SetFinalTimingEffff: __ZN18LoadSceneOperation14SetFinalTimingEffff, __Z46Register_UnityEngine_AndroidJNI_SetObjectFieldv: __Z46Register_UnityEngine_AndroidJNI_SetObjectFieldv, __Z53Quaternion_CUSTOM_INTERNAL_CALL_Internal_FromEulerRadRK8Vector3fR11Quaternionf: __Z53Quaternion_CUSTOM_INTERNAL_CALL_Internal_FromEulerRadRK8Vector3fR11Quaternionf, __ZN11UnityEngine15CloudWebService14DataDispatcher25IsSessionContainerExpiredERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher25IsSessionContainerExpiredERNS0_16SessionContainerE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __Z45Register_UnityEngine_HingeJoint_set_useLimitsv: __Z45Register_UnityEngine_HingeJoint_set_useLimitsv, __ZN17ProceduralTextureD0Ev: __ZN17ProceduralTextureD0Ev, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl10getClassesEPN5physx8debugger16ClassDescriptionEjj: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl10getClassesEPN5physx8debugger16ClassDescriptionEjj, __ZN5physx2Gu18computeFeatureCodeEff: __ZN5physx2Gu18computeFeatureCodeEff, __ZNK22LocalFileSystemHandler21GetAvailableDiskSpaceEPKcRy: __ZNK22LocalFileSystemHandler21GetAvailableDiskSpaceEPKcRy, __Z52Register_UnityEngine_TerrainData_Internal_SetHeightsv: __Z52Register_UnityEngine_TerrainData_Internal_SetHeightsv, __Z41Physics2D_Set_Custom_PropShowColliderAABBh: __Z41Physics2D_Set_Custom_PropShowColliderAABBh, __ZN15CapsuleCollider8TransferI14SafeBinaryReadEEvRT_: __ZN15CapsuleCollider8TransferI14SafeBinaryReadEEvRT_, _UNITY_FT_GlyphLoader_CopyPoints: _UNITY_FT_GlyphLoader_CopyPoints, __ZL18Texture2D_EncodeToP9Texture2DR13dynamic_arrayIhLj1EEii: __ZL18Texture2D_EncodeToP9Texture2DR13dynamic_arrayIhLj1EEii, __ZN14ParticleSystem10SmartResetEv: __ZN14ParticleSystem10SmartResetEv, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetZMultiplierv, __ZN19SkinnedMeshRenderer11GetRootBoneEv: __ZN19SkinnedMeshRenderer11GetRootBoneEv, __ZN5Unity14CharacterJoint12SetSwingAxisERK8Vector3f: __ZN5Unity14CharacterJoint12SetSwingAxisERK8Vector3f, __ZN19ShaderPropertySheet18ReserveValueBufferEj: __ZN19ShaderPropertySheet18ReserveValueBufferEj, __ZNK15CollisionEvents10SendEventsERN5Unity9ComponentE: __ZNK15CollisionEvents10SendEventsERN5Unity9ComponentE, __ZN5physx2Cm17FreeListAllocatorD2Ev: __ZN5physx2Cm17FreeListAllocatorD2Ev, __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __Z36Rigidbody_Get_Custom_PropAngularDragP12Il2CppObject: __Z36Rigidbody_Get_Custom_PropAngularDragP12Il2CppObject, __Z36Canvas_Set_Custom_PropSortingLayerIDP12Il2CppObjecti: __Z36Canvas_Set_Custom_PropSortingLayerIDP12Il2CppObjecti, __Z13RegisterClassIN2UI11CanvasGroupEEvv: __Z13RegisterClassIN2UI11CanvasGroupEEvv, __ZN5physx2Sc8ShapeSim20removeFromBroadPhaseEb: __ZN5physx2Sc8ShapeSim20removeFromBroadPhaseEb, __Z35UnregisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE: __Z35UnregisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE, __ZN5physx2Sc13ConstraintSimD2Ev: __ZN5physx2Sc13ConstraintSimD2Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags, __Z18RecalculateAutoKeyR17AnimationCurveTplIfEif: __Z18RecalculateAutoKeyR17AnimationCurveTplIfEif, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEbT0_SC_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEbT0_SC_T_, __ZN15PointEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15PointEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNKSt3__210moneypunctIwLb1EE14do_frac_digitsEv: __ZNKSt3__210moneypunctIwLb1EE14do_frac_digitsEv, __ZN4FMOD6SoundI9getLengthEPjj: __ZN4FMOD6SoundI9getLengthEPjj, __Z28Event_Set_Custom_PropKeyCodeP12Il2CppObjecti: __Z28Event_Set_Custom_PropKeyCodeP12Il2CppObjecti, __Z26GetMeshVertexFormatManagerv: __Z26GetMeshVertexFormatManagerv, __Z47Physics_Set_Custom_PropMinPenetrationForPenaltyf: __Z47Physics_Set_Custom_PropMinPenetrationForPenaltyf, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZN11AudioSource14SetMinDistanceEf: __ZN11AudioSource14SetMinDistanceEf, __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcPNS_21PxProfileNameProviderEj: __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcPNS_21PxProfileNameProviderEj, __Z22sweepCCTBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z22sweepCCTBox_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5Cache9FreeSpaceEj: __ZN5Cache9FreeSpaceEj, __Z49Playable_CUSTOM_INTERNAL_CALL_GetDurationInternalR9HPlayable: __Z49Playable_CUSTOM_INTERNAL_CALL_GetDurationInternalR9HPlayable, __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14DirectorPlayer8TransferI18StreamedBinaryReadILb0EEEEvRT_, _cf2_initLocalRegionBuffer: _cf2_initLocalRegionBuffer, __ZN15TerrainRenderer19GetPatchIndexBufferEi: __ZN15TerrainRenderer19GetPatchIndexBufferEi, _UNITY_png_muldiv: _UNITY_png_muldiv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEED2Ev, __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjfbfRNS_6memory9AllocatorE: __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjfbfRNS_6memory9AllocatorE, __ZN5physx16PxsSolverEndTaskD2Ev: __ZN5physx16PxsSolverEndTaskD2Ev, __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDriveNWEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDriveNWEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZNK13b2CircleShape9TestPointERK11b2TransformRK6b2Vec2: __ZNK13b2CircleShape9TestPointERK11b2TransformRK6b2Vec2, __Z15SampleAnimationR10GameObjectR13AnimationClipfi: __Z15SampleAnimationR10GameObjectR13AnimationClipfi, __Z38Animator_CUSTOM_ApplyBuiltinRootMotionP12Il2CppObject: __Z38Animator_CUSTOM_ApplyBuiltinRootMotionP12Il2CppObject, __ZNK12FileAccessor8PositionEv: __ZNK12FileAccessor8PositionEv, __ZN14SafeBinaryRead8TransferIN7mecanim9animation17BlendTreeConstantEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim9animation17BlendTreeConstantEEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Gu15HeightFieldUtil27getFaceIndexAtTriangleIndexEj: __ZNK5physx2Gu15HeightFieldUtil27getFaceIndexAtTriangleIndexEj, __ZN21AnimationClipPlayableD0Ev: __ZN21AnimationClipPlayableD0Ev, __Z49Register_UnityEngine_ParticleSystem_get_startSizev: __Z49Register_UnityEngine_ParticleSystem_get_startSizev, __Z38Register_UnityEngine_Resources_LoadAllv: __Z38Register_UnityEngine_Resources_LoadAllv, __ZN19VREyeTextureManager12BlitToBufferE15UnityVRBlitModeRK5RectTIfEfP13RenderTexture: __ZN19VREyeTextureManager12BlitToBufferE15UnityVRBlitModeRK5RectTIfEfP13RenderTexture, __Z38GetScriptingBuiltinResourceFromManagerR22BuiltinResourceManagerP12Il2CppObjectRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z38GetScriptingBuiltinResourceFromManagerR22BuiltinResourceManagerP12Il2CppObjectRKNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZSt15set_new_handlerPFvvE: __ZSt15set_new_handlerPFvvE, __Z47Register_UnityEngine_Cloth_set_capsuleCollidersv: __Z47Register_UnityEngine_Cloth_set_capsuleCollidersv, __ZN5physx2Sc19ClothFabricBulkData15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc19ClothFabricBulkData15importExtraDataERNS_24PxDeserializationContextE, __Z50PlatformEffector2D_Get_Custom_PropRotationalOffsetP12Il2CppObject: __Z50PlatformEffector2D_Get_Custom_PropRotationalOffsetP12Il2CppObject, __ZN7mecanim5human25HumanPoseAddOverrideLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE: __ZN7mecanim5human25HumanPoseAddOverrideLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE, __ZN22VirtualJoystickManager23GetVirtualJoystickIndexEPKc: __ZN22VirtualJoystickManager23GetVirtualJoystickIndexEPKc, __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI7CubemapE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN28LightProbeProxyVolumeManager16UpdateResolutionER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager16UpdateResolutionER21LightProbeProxyVolume, __ZN22BaseUnityConnectClient18DetermineNextStateENS_5StateEPS0_: __ZN22BaseUnityConnectClient18DetermineNextStateENS_5StateEPS0_, __ZNK6Shader23GetActiveSubShaderIndexEv: __ZNK6Shader23GetActiveSubShaderIndexEv, __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi0ELb1EED0Ev, __ZN4FMOD8ChannelI16setSpeakerLevelsE12FMOD_SPEAKERPfi: __ZN4FMOD8ChannelI16setSpeakerLevelsE12FMOD_SPEAKERPfi, __ZN5Light13SetShadowTypeE10ShadowType: __ZN5Light13SetShadowTypeE10ShadowType, __ZNK18PlatformEffector2D18GroupOneWayContactERN10Effector2D15EffectorContactE: __ZNK18PlatformEffector2D18GroupOneWayContactERN10Effector2D15EffectorContactE, __Z40Animator_Set_Custom_PropRecorderStopTimeP12Il2CppObjectf: __Z40Animator_Set_Custom_PropRecorderStopTimeP12Il2CppObjectf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN4FMOD3DSP11setDefaultsEfffi: __ZN4FMOD3DSP11setDefaultsEfffi, __Z38scripting_class_get_system_type_objectP11Il2CppClass: __Z38scripting_class_get_system_type_objectP11Il2CppClass, __ZN18ProceduralMaterialC2E10MemLabelId18ObjectCreationMode: __ZN18ProceduralMaterialC2E10MemLabelId18ObjectCreationMode, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z37CalculateJobCountWithMinIndicesPerJobii: __Z37CalculateJobCountWithMinIndicesPerJobii, __ZNSt3__218__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIxxEEPxEEvT0_S5_T_, __ZN14DetailDatabase24SetDetailPrototypesDirtyEv: __ZN14DetailDatabase24SetDetailPrototypesDirtyEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z43Transform_CUSTOM_INTERNAL_set_localPositionP12Il2CppObjectRK8Vector3f: __Z43Transform_CUSTOM_INTERNAL_set_localPositionP12Il2CppObjectRK8Vector3f, __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI17BlendShapeChannelNS0_9allocatorIS2_EEEEEvRT_j, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj497ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj497ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr: __ZN19RuntimeSceneManager15FindSceneByNameERK8UnityStr, __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev: __ZN12_GLOBAL__N_123DoubleBufferedOutStreamD2Ev, __Z99Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorControllerInternalv: __Z99Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorControllerInternalv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI8RendererELj4EEEEvRT_17TransferMetaFlags, __ZN8Animator15GetGoalPositionEi: __ZN8Animator15GetGoalPositionEi, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetYv, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb, ___cxa_guard_abort: ___cxa_guard_abort, __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __Z45Register_UnityEngine_Camera_get_nearClipPlanev: __Z45Register_UnityEngine_Camera_get_nearClipPlanev, __Z38getPxArticulationLink_ConcreteTypeNamePKN5physx18PxArticulationLinkE: __Z38getPxArticulationLink_ConcreteTypeNamePKN5physx18PxArticulationLinkE, __ZN17ArchiveFileSystem11MoveToTrashER13FileEntryData: __ZN17ArchiveFileSystem11MoveToTrashER13FileEntryData, __Z36NavMeshAgent_Get_Custom_PropAreaMaskP12Il2CppObject: __Z36NavMeshAgent_Get_Custom_PropAreaMaskP12Il2CppObject, __Z36Register_UnityEngine_Texture2D_Applyv: __Z36Register_UnityEngine_Texture2D_Applyv, __ZNK8GUIStyle20GetCursorStringIndexERK5RectTIfER10GUIContentRK8Vector2f: __ZNK8GUIStyle20GetCursorStringIndexERK5RectTIfER10GUIContentRK8Vector2f, __Z56CharacterController_Get_Custom_PropEnableOverlapRecoveryP12Il2CppObject: __Z56CharacterController_Get_Custom_PropEnableOverlapRecoveryP12Il2CppObject, __Z53Register_UnityEngine_Terrain_set_reflectionProbeUsagev: __Z53Register_UnityEngine_Terrain_set_reflectionProbeUsagev, __ZN5physx33mergeKinematicProxiesBackToSourceERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjS8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERS4_PjSG_: __ZN5physx33mergeKinematicProxiesBackToSourceERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKjS8_RNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerERS4_PjSG_, __ZN7mecanim4hand8HandPose8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim4hand8HandPose8TransferI14SafeBinaryReadEEvRT_, __Z13RegisterClassI12HingeJoint2DEvv: __Z13RegisterClassI12HingeJoint2DEvv, _Horizontal_Sweep_Step: _Horizontal_Sweep_Step, __ZNSt9type_infoD0Ev: __ZNSt9type_infoD0Ev, __ZN8JSONRead12EndMetaGroupEv: __ZN8JSONRead12EndMetaGroupEv, _fill_input_buffer: _fill_input_buffer, __ZN5physx2Gu12OBBAABBTestsILb1EEC2ERKNS_11PxTransformERKNS_13PxBoxGeometryEf: __ZN5physx2Gu12OBBAABBTestsILb1EEC2ERKNS_11PxTransformERKNS_13PxBoxGeometryEf, __Z20scripting_get_corlibv: __Z20scripting_get_corlibv, __Z30GUIUtility_CUSTOM_GetControlIDi9FocusType: __Z30GUIUtility_CUSTOM_GetControlIDi9FocusType, __ZN2UI6Canvas19UnloadFromGfxDeviceEv: __ZN2UI6Canvas19UnloadFromGfxDeviceEv, __ZNK20DynamicPropertySheet7IsDirtyEv: __ZNK20DynamicPropertySheet7IsDirtyEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxCapsuleGeometryEEEEclILj260ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z24RegisterStrippedTypeInfoI11NavMeshDataEviPKcS2_: __Z24RegisterStrippedTypeInfoI11NavMeshDataEviPKcS2_, __Z56Register_UnityEngine_Vector3_INTERNAL_CALL_RotateTowardsv: __Z56Register_UnityEngine_Vector3_INTERNAL_CALL_RotateTowardsv, __ZNK12CubemapArray11GetPixels32EiP11ColorRGBA3211CubemapFaceii: __ZNK12CubemapArray11GetPixels32EiP11ColorRGBA3211CubemapFaceii, __ZN12InputManagerC2E10MemLabelId18ObjectCreationMode: __ZN12InputManagerC2E10MemLabelId18ObjectCreationMode, __Z13SetIPhysics2DP10IPhysics2D: __Z13SetIPhysics2DP10IPhysics2D, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __ZNK19TransportJavaScript9GetStatusEv: __ZNK19TransportJavaScript9GetStatusEv, __Z32PolygonCollider2D_CUSTOM_SetPathP12Il2CppObjectiP11Il2CppArray: __Z32PolygonCollider2D_CUSTOM_SetPathP12Il2CppObjectiP11Il2CppArray, __ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf: __ZL11PxcTestAxisRKN5physx6PxVec3ERKNS_2Gu7SegmentEfRKNS3_3BoxERf, __Z51Register_UnityEngine_RenderTexture_get_isPowerOfTwov: __Z51Register_UnityEngine_RenderTexture_get_isPowerOfTwov, __ZN14BillboardAsset7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14BillboardAsset7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN7mecanim9animation16GetAllBlendValueEjP9OffsetPtrINS0_21BlendTreeNodeConstantEER13dynamic_arrayIiLj4EE: __ZN7mecanim9animation16GetAllBlendValueEjP9OffsetPtrINS0_21BlendTreeNodeConstantEER13dynamic_arrayIiLj4EE, __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx27solveContactCoulomb_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z69AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorStateInfoInternalR9HPlayablei: __Z69AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorStateInfoInternalR9HPlayablei, __ZNK12TreeDatabase9Prototype17GetRepresentationER13dynamic_arrayINSt3__24pairIPK4Mesh10Matrix4x4fEELj4EE: __ZNK12TreeDatabase9Prototype17GetRepresentationER13dynamic_arrayINSt3__24pairIPK4Mesh10Matrix4x4fEELj4EE, __ZN9Transform23SetHasChangedDeprecatedEb: __ZN9Transform23SetHasChangedDeprecatedEb, __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERKNSA_5Vec3VESJ_RSE_RSH_SL_fb, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE14getOwnerClientEv, __Z28Texture2D_CUSTOM_EncodeToJPGP12Il2CppObjecti: __Z28Texture2D_CUSTOM_EncodeToJPGP12Il2CppObjecti, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE6resizeEj: __ZNSt3__26vectorIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEE6resizeEj, __ZNKSt3__28numpunctIcE16do_decimal_pointEv: __ZNKSt3__28numpunctIcE16do_decimal_pointEv, __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetEnabledv: __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetEnabledv, __ZNK5physx9PxTaskMgr12getReferenceEj: __ZNK5physx9PxTaskMgr12getReferenceEj, __Z25scripting_object_get_sizeP12Il2CppObject: __Z25scripting_object_get_sizeP12Il2CppObject, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEwj, __ZN14PhysicsManager19CapsuleCastNonAllocERK8Vector3fS2_fS2_P10RaycastHitifi23QueryTriggerInteraction: __ZN14PhysicsManager19CapsuleCastNonAllocERK8Vector3fS2_fS2_P10RaycastHitifi23QueryTriggerInteraction, __Z61Register_UnityEngine_ConfigurableJoint_get_projectionDistancev: __Z61Register_UnityEngine_ConfigurableJoint_get_projectionDistancev, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN17SharedTextureDataD2Ev: __ZN17SharedTextureDataD2Ev, __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj: __Z24CalculateSkinPoseMathLibILi2EEvRN4math8float4x4EPK10Matrix4x4fPKvj, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E4swapERSK_, __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z18ConvertUTF32toUTF8RK13dynamic_arrayImLj4EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z18ConvertUTF32toUTF8RK13dynamic_arrayImLj4EERNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z8SkinMeshR12SkinMeshInfo: __Z8SkinMeshR12SkinMeshInfo, __ZN19LowerResBlitTextureD0Ev: __ZN19LowerResBlitTextureD0Ev, __Z48Register_UnityEngine_Application_get_installModev: __Z48Register_UnityEngine_Application_get_installModev, __ZN12_GLOBAL__N_117ConnectionManager16sendErrorMessageEN5physx11PxErrorCode4EnumEPKcS5_j: __ZN12_GLOBAL__N_117ConnectionManager16sendErrorMessageEN5physx11PxErrorCode4EnumEPKcS5_j, _UNITY_FT_Stream_ReadChar: _UNITY_FT_Stream_ReadChar, __ZNK14GfxContextGLES8Instance14GetFramebufferEv: __ZNK14GfxContextGLES8Instance14GetFramebufferEv, __Z41LineRenderer_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth: __Z41LineRenderer_Set_Custom_PropUseWorldSpaceP12Il2CppObjecth, __Z14resize_trimmedINSt3__26vectorIN8LODGroup11LODStruct50ENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN8LODGroup11LODStruct50ENS0_9allocatorIS3_EEEEEvRT_j, __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZNKSt3__27codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j: __ZNKSt3__27codecvtIwc11__mbstate_tE9do_lengthERS1_PKcS5_j, __ZN5physx16PxVehicleDriveNW8allocateEj: __ZN5physx16PxVehicleDriveNW8allocateEj, _per_scan_setup: _per_scan_setup, __ZNK5physx2Sc9ClothCore14getWakeCounterEv: __ZNK5physx2Sc9ClothCore14getWakeCounterEv, __ZN14PlayerSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN14PlayerSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13postIslandGenEPNS_10PxBaseTaskEEEED0Ev, _getpriority: _getpriority, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj527ENS_22PxRepXPropertyAccessorILj527ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj527ENS_22PxRepXPropertyAccessorILj527ES4_ffEEEEvRKT0_, __ZN20LocalFileSystemPosix6DeleteER13FileEntryDatab: __ZN20LocalFileSystemPosix6DeleteER13FileEntryDatab, __ZN20TextRenderingPrivate15GetFontMetadataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERS6_S9_RjSA_iPi: __ZN20TextRenderingPrivate15GetFontMetadataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERS6_S9_RjSA_iPi, __ZN23ControllerContactFilterD0Ev: __ZN23ControllerContactFilterD0Ev, __ZN10GUITexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10GUITexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN6Camera23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Camera23VirtualRedirectTransferER17RemapPPtrTransfer, __Z38Font_CUSTOM_Internal_CreateDynamicFontP12Il2CppObjectP11Il2CppArrayi: __Z38Font_CUSTOM_Internal_CreateDynamicFontP12Il2CppObjectP11Il2CppArrayi, __ZNK14DataBufferGLES12GetUpdateAgeEv: __ZNK14DataBufferGLES12GetUpdateAgeEv, __Z52Register_UnityEngine_GUIUtility_set_systemCopyBufferv: __Z52Register_UnityEngine_GUIUtility_set_systemCopyBufferv, __ZN16CircleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16CircleCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z20RenderSceneDepthPassRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext: __Z20RenderSceneDepthPassRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext, __Z12NHxRoughnessItEvP9Texture2DPT_iiii: __Z12NHxRoughnessItEvP9Texture2DPT_iiii, __ZN21ImposterRenderTextureC2ERK12TreeDatabase: __ZN21ImposterRenderTextureC2ERK12TreeDatabase, __ZN15SerializeTraitsI23ManagedObjectTransfererE8TransferI30ReportScriptingObjectsTransferEEvRS0_RT_: __ZN15SerializeTraitsI23ManagedObjectTransfererE8TransferI30ReportScriptingObjectsTransferEEvRS0_RT_, __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectf: __Z45Rigidbody2D_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectf, __ZN13SplatDatabase27SetMaterialRequiresMetallicEb: __ZN13SplatDatabase27SetMaterialRequiresMetallicEb, __ZN19RenderBufferManager23InitRenderBufferManagerEv: __ZN19RenderBufferManager23InitRenderBufferManagerEv, __ZTv0_n12_NSt3__29strstreamD0Ev: __ZTv0_n12_NSt3__29strstreamD0Ev, __ZN14BlendShapeDataaSERKS_: __ZN14BlendShapeDataaSERKS_, __Z29setPxRigidBody_CMassLocalPosePN5physx11PxRigidBodyERKNS_11PxTransformE: __Z29setPxRigidBody_CMassLocalPosePN5physx11PxRigidBodyERKNS_11PxTransformE, __ZN5physx5cloth11SwCollisionI8Scalar4fE21buildConeAccelerationEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE21buildConeAccelerationEv, __Z15setPxJoint_NamePN5physx7PxJointEPKc: __Z15setPxJoint_NamePN5physx7PxJointEPKc, __ZN5physx6shdfnd18BufferedSocketImplC2Ev: __ZN5physx6shdfnd18BufferedSocketImplC2Ev, __ZNK5physx19PxArticulationJoint8isKindOfEPKc: __ZNK5physx19PxArticulationJoint8isKindOfEPKc, __Z46UnityWebRequest_Get_Custom_PropUseHttpContinueP12Il2CppObject: __Z46UnityWebRequest_Get_Custom_PropUseHttpContinueP12Il2CppObject, __ZNSt3__210to_wstringEl: __ZNSt3__210to_wstringEl, __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEvT0_S6_T_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj560ENS_22PxRepXPropertyAccessorILj560ES4_NS_27PxVehicleClutchAccuracyMode4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleClutchDataEEEE14handleAccessorILj560ENS_22PxRepXPropertyAccessorILj560ES4_NS_27PxVehicleClutchAccuracyMode4EnumESA_EEEEvRKT0_, __Z36Profiler_CUSTOM_GetTempAllocatorSizev: __Z36Profiler_CUSTOM_GetTempAllocatorSizev, __Z55Register_UnityEngine_AudioReverbFilter_set_decayHFRatiov: __Z55Register_UnityEngine_AudioReverbFilter_set_decayHFRatiov, __ZZN8VRModuleC1EvEN11whilePaused7ForwardEv: __ZZN8VRModuleC1EvEN11whilePaused7ForwardEv, __ZN13GfxDeviceGLES16SetActiveContextEPv: __ZN13GfxDeviceGLES16SetActiveContextEPv, __ZL27GeomMTDCallback_SpherePlaneRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL27GeomMTDCallback_SpherePlaneRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN4FMOD6Reverb7releaseEv: __ZN4FMOD6Reverb7releaseEv, __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb0EEEEvRT_: __ZN13MonoBehaviour25TransferEngineAndInstanceI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx11NpConnector17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx11NpConnector17getBinaryMetaDataERNS_14PxOutputStreamE, __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_SetEnabledv: __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_SetEnabledv, __Z55LightProbeProxyVolume_Get_Custom_PropIsFeatureSupportedv: __Z55LightProbeProxyVolume_Get_Custom_PropIsFeatureSupportedv, __ZThn32_N19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N19SkinnedMeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZNK9Transform25InverseTransformDirectionERK8Vector3f: __ZNK9Transform25InverseTransformDirectionERK8Vector3f, __ZN14DetailDatabase8TransferI14SafeBinaryReadEEvRT_: __ZN14DetailDatabase8TransferI14SafeBinaryReadEEvRT_, __ZN20TextRenderingPrivate7GUIText8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20TextRenderingPrivate7GUIText8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__210to_wstringEd: __ZNSt3__210to_wstringEd, __ZN11UnityEngine15PlatformWrapper22GetDeviceSystemVersionEv: __ZN11UnityEngine15PlatformWrapper22GetDeviceSystemVersionEv, ___ptsname_r: ___ptsname_r, __ZN12_GLOBAL__N_110DataStream16setPropertyValueEPKvPKcN5physx8debugger7DataRefIKhEERKNS6_14NamespacedNameE: __ZN12_GLOBAL__N_110DataStream16setPropertyValueEPKvPKcN5physx8debugger7DataRefIKhEERKNS6_14NamespacedNameE, __ZN29AssetBundleLoadAssetOperation15GetLoadedAssetsER13dynamic_arrayIP6ObjectLj4EEb: __ZN29AssetBundleLoadAssetOperation15GetLoadedAssetsER13dynamic_arrayIP6ObjectLj4EEb, __ZN26DownloadHandlerAssetBundle17OnCompleteContentEv: __ZN26DownloadHandlerAssetBundle17OnCompleteContentEv, __ZN6prcoreL12RemapGenericI11TexFormatA817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI11TexFormatA817TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z28getPxDistanceJoint_TolerancePKN5physx15PxDistanceJointE: __Z28getPxDistanceJoint_TolerancePKN5physx15PxDistanceJointE, __ZN14FileCacherRead11GetPathNameEv: __ZN14FileCacherRead11GetPathNameEv, __ZN9ShaderLab27SerializedShaderVectorValue8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab27SerializedShaderVectorValue8TransferI24GenerateTypeTreeTransferEEvRT_, __Z71Register_UnityEngine_ParticleSystem_MainModule_GetCustomSimulationSpacev: __Z71Register_UnityEngine_ParticleSystem_MainModule_GetCustomSimulationSpacev, __ZNK16TypeTreeIterator4LastEv: __ZNK16TypeTreeIterator4LastEv, __ZN8Renderer26UpdateAllRenderersInternalEb: __ZN8Renderer26UpdateAllRenderersInternalEb, _socket: _socket, __Z48Register_UnityEngine_Physics_set_bounceThresholdv: __Z48Register_UnityEngine_Physics_set_bounceThresholdv, __ZN13PhysicsModule24CreateNxMeshFromNxStreamEbPKvj: __ZN13PhysicsModule24CreateNxMeshFromNxStreamEbPKvj, _unzlocal_GetCurrentFileInfoInternal: _unzlocal_GetCurrentFileInfoInternal, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15switchFromNoSimEv: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15switchFromNoSimEv, __ZN5physx14NpRigidDynamic6wakeUpEv: __ZN5physx14NpRigidDynamic6wakeUpEv, __ZN5physx2Sc12MaterialCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc12MaterialCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx5cloth16SwInterCollisionI8Scalar4fE13getBufferSizeEj: __ZN5physx5cloth16SwInterCollisionI8Scalar4fE13getBufferSizeEj, __ZN5physx2Sc5Scene25deallocateConstraintBlockEPvj: __ZN5physx2Sc5Scene25deallocateConstraintBlockEPvj, __ZN5physx12NpBatchQuery7raycastERKNS_6PxVec3ES3_ftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE: __ZN5physx12NpBatchQuery7raycastERKNS_6PxVec3ES3_ftNS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE, __ZN10GameObject18TransferComponentsI24GenerateTypeTreeTransferEEvRT_: __ZN10GameObject18TransferComponentsI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx18PxFabricCookerImpl4saveERNS_14PxOutputStreamEb: __ZNK5physx18PxFabricCookerImpl4saveERNS_14PxOutputStreamEb, __ZN19GfxThreadableDevice15OnDeviceCreatedEb: __ZN19GfxThreadableDevice15OnDeviceCreatedEb, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv, __ZNKSt3__210moneypunctIcLb0EE11frac_digitsEv: __ZNKSt3__210moneypunctIcLb0EE11frac_digitsEv, __Z32setPxVehicleWheelsMWheelsDynDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsDynDataE: __Z32setPxVehicleWheelsMWheelsDynDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsDynDataE, __ZN5IMGUI12GetEventTypeERK8GUIStateRK10InputEvent: __ZN5IMGUI12GetEventTypeERK8GUIStateRK10InputEvent, __Z36Graphics_CUSTOM_GetActiveDepthBufferP21ScriptingRenderBuffer: __Z36Graphics_CUSTOM_GetActiveDepthBufferP21ScriptingRenderBuffer, __ZN12_GLOBAL__N_112UserRenderer20visualizeJointFramesERKN5physx11PxTransformES4_: __ZN12_GLOBAL__N_112UserRenderer20visualizeJointFramesERKN5physx11PxTransformES4_, __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13dynamic_arrayIP15ReflectionProbeLj4EEC2ERKS2_RK10MemLabelId: __ZN13dynamic_arrayIP15ReflectionProbeLj4EEC2ERKS2_RK10MemLabelId, __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16LightmapSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI15PackedIntVectorEEvRT_PKc17TransferMetaFlags, __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStyle: __ZN5IMGUI9GUIToggleER8GUIStateRK5RectTIfEbR10GUIContentR8GUIStyle, __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim6bitsetILj66EEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim6bitsetILj66EEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j: __ZNK5physx31PxVehicleGearsDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEEEEEjT_j, __ZNKSt3__215__codecvt_utf16IDiLb0EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IDiLb0EE13do_max_lengthEv, __ZN12ScriptMapper8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12ScriptMapper8TransferI24GenerateTypeTreeTransferEEvRT_, __Z36UnityPropertySheet_MakeSortedTexEnvsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEER10vector_mapIS2_S4_S6_NS7_INS8_IS2_S4_EEEEE: __Z36UnityPropertySheet_MakeSortedTexEnvsRKNSt3__23mapIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvENS_4lessIS2_EENS_9allocatorINS_4pairIKS2_S4_EEEEEER10vector_mapIS2_S4_S6_NS7_INS8_IS2_S4_EEEEE, __ZN18BaseUnityAnalyticsC2ER22BaseUnityConnectClient: __ZN18BaseUnityAnalyticsC2ER22BaseUnityConnectClient, __Z31setPxClothTetherConfigStiffnessPN5physx19PxClothTetherConfigEf: __Z31setPxClothTetherConfigStiffnessPN5physx19PxClothTetherConfigEf, __ZNK5physx23PxVehicleDriveSimData4W7isValidEv: __ZNK5physx23PxVehicleDriveSimData4W7isValidEv, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor7kdSplitEif: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor7kdSplitEif, __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EixEj: __ZNK5physx5cloth12LerpIteratorI8Scalar4fPKS2_EixEj, __ZN9Texture2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Texture2D23VirtualRedirectTransferER14SafeBinaryRead, __Z36GUIStyle_Get_Custom_PropStretchWidthP12Il2CppObject: __Z36GUIStyle_Get_Custom_PropStretchWidthP12Il2CppObject, __Z36Camera_Get_Custom_PropOpaqueSortModeP12Il2CppObject: __Z36Camera_Get_Custom_PropOpaqueSortModeP12Il2CppObject, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE21PageAllocationElementC2Ev: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE21PageAllocationElementC2Ev, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv: __ZNK9Transform28GetWorldToLocalMatrixNoScaleEv, __ZThn12_N5physx3Ext10FixedJointD0Ev: __ZThn12_N5physx3Ext10FixedJointD0Ev, __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE: __ZN5physx3Cct9SweepTest11doSweepTestEPKNS0_30InternalCBData_FindTouchedGeomEPKNS0_20InternalCBData_OnHitERKNS0_13UserObstaclesERNS0_11SweptVolumeERKNS_6PxVec3ESF_jPjfRKNS_19PxControllerFiltersENS0_9SweepPassE, __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatBGR888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB56515TexFormatBGR888EEvPKNS_9InnerInfoE, __ZL15DebugInitializeR34UnityVRDeviceSpecificConfiguration: __ZL15DebugInitializeR34UnityVRDeviceSpecificConfiguration, __Z52Register_UnityEngine_ReflectionProbe_set_cullingMaskv: __Z52Register_UnityEngine_ReflectionProbe_set_cullingMaskv, __Z37Resources_CUSTOM_FindObjectsOfTypeAllP12Il2CppObject: __Z37Resources_CUSTOM_FindObjectsOfTypeAllP12Il2CppObject, __Z23LODGroup_CUSTOM_SetLODsP12Il2CppObjectP11Il2CppArray: __Z23LODGroup_CUSTOM_SetLODsP12Il2CppObjectP11Il2CppArray, __Z44ParticleSystem_MainModule_CUSTOM_GetDurationP12Il2CppObject: __Z44ParticleSystem_MainModule_CUSTOM_GetDurationP12Il2CppObject, __ZN13Simd4fFactoryIN6detail9FourTupleEEC2Effff: __ZN13Simd4fFactoryIN6detail9FourTupleEEC2Effff, __ZNK5physx2Cm12RenderBuffer11getNbPointsEv: __ZNK5physx2Cm12RenderBuffer11getNbPointsEv, __ZNK9Rigidbody27GetSolverVelocityIterationsEv: __ZNK9Rigidbody27GetSolverVelocityIterationsEv, __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN5physx2Sn9MetaClass5checkERKNS0_8MetaDataE: __ZN5physx2Sn9MetaClass5checkERKNS0_8MetaDataE, __ZN5physx2Sn20SerializationContextD0Ev: __ZN5physx2Sn20SerializationContextD0Ev, __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE: __ZN5physx2Gu31SinglePersistentContactManifold30addBatchManifoldContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchERKNS_6shdfnd3aos6FloatVE, __ZN10HumanTrait13GetMuscleNameEv: __ZN10HumanTrait13GetMuscleNameEv, __ZN13GfxDeviceGLESD0Ev: __ZN13GfxDeviceGLESD0Ev, __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointP12Il2CppObjectRK13Vector2fIcallPS1_: __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointP12Il2CppObjectRK13Vector2fIcallPS1_, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx13GuMeshFactoryD2Ev: __ZN5physx13GuMeshFactoryD2Ev, __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity17ConfigurableJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14AsyncOperation15InvokeCoroutineEv: __ZN14AsyncOperation15InvokeCoroutineEv, __ZN5physx13BigConvexData4LoadERNS_13PxInputStreamE: __ZN5physx13BigConvexData4LoadERNS_13PxInputStreamE, __ZNSt3__212strstreambufC2EPhiS1_: __ZNSt3__212strstreambufC2EPhiS1_, __ZN13RenderManager15BatchModeUpdateEv: __ZN13RenderManager15BatchModeUpdateEv, __ZN5Light12AddToManagerEv: __ZN5Light12AddToManagerEv, __Z29RectOffset_Get_Custom_PropTopP12Il2CppObject: __Z29RectOffset_Get_Custom_PropTopP12Il2CppObject, __ZN8GUILayer7HitTestERK8Vector2f: __ZN8GUILayer7HitTestERK8Vector2f, __ZN8TypeTree8AddChildEj: __ZN8TypeTree8AddChildEj, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5egptrEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE5egptrEv, __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE: __ZN5Umbra10QueryState12setQueryDataEPKNS_7ImpTomeEPKNS_17ImpTomeCollectionE, __ZNK8GUIStyle10CalcHeightER10GUIContentf: __ZNK8GUIStyle10CalcHeightER10GUIContentf, __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z35CombineMeshIndicesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb: __Z35CombineMeshIndicesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb, __ZNKSt3__210moneypunctIwLb0EE10pos_formatEv: __ZNKSt3__210moneypunctIwLb0EE10pos_formatEv, __ZN18ProceduralMaterial16GetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18ProceduralMaterial16GetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK18ScreenManagerWebGL12IsFullScreenEv: __ZNK18ScreenManagerWebGL12IsFullScreenEv, __ZN9Coroutine26CompareCoroutineEnumeratorEPvS0_: __ZN9Coroutine26CompareCoroutineEnumeratorEPvS0_, __ZN14SphereCollider9SetRadiusEf: __ZN14SphereCollider9SetRadiusEf, __ZN10GISettings14SetAlbedoBoostEf: __ZN10GISettings14SetAlbedoBoostEf, __ZN5physx14NpArticulation7getRootEv: __ZN5physx14NpArticulation7getRootEv, __ZN15RelativeJoint2DD2Ev: __ZN15RelativeJoint2DD2Ev, ___fwritable: ___fwritable, __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj, __Z35RenderTexture_Set_Custom_PropActiveP12Il2CppObject: __Z35RenderTexture_Set_Custom_PropActiveP12Il2CppObject, __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN14SpriteRenderer14OnDeleteSpriteEv: __ZN14SpriteRenderer14OnDeleteSpriteEv, __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE: __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE, __Z60Register_UnityEngine_Renderer_set_motionVectorGenerationModev: __Z60Register_UnityEngine_Renderer_set_motionVectorGenerationModev, __ZL19CleanupModule_Clothv: __ZL19CleanupModule_Clothv, __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_10PxsContextEXadL_ZNS2_23prepareCMDiscreteUpdateEPNS_10PxBaseTaskEEEED0Ev, __ZN20SubstanceArchiveDataC2Ev: __ZN20SubstanceArchiveDataC2Ev, __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxQuatE: __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxQuatE, __Z22NeedToPerformRenderingv: __Z22NeedToPerformRenderingv, __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10Collider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14DirectorPlayer4StopEv: __ZN14DirectorPlayer4StopEv, _UNITY_png_set_sCAL_fixed: _UNITY_png_set_sCAL_fixed, __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_centerv: __Z59Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_centerv, __ZN2UI13RectTransform16UpdatePosAndRectEb: __ZN2UI13RectTransform16UpdatePosAndRectEb, __ZN13MonoBehaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13MonoBehaviour23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN11AssetBundle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11AssetBundle23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z40getPxJointLimitParametersContactDistancePKN5physx22PxJointLimitParametersE: __Z40getPxJointLimitParametersContactDistancePKN5physx22PxJointLimitParametersE, __ZN5Flare12FlareElement8TransferI14SafeBinaryReadEEvRT_: __ZN5Flare12FlareElement8TransferI14SafeBinaryReadEEvRT_, __ZN8Material15SetColorIndexedEN9ShaderLab16FastPropertyNameEif: __ZN8Material15SetColorIndexedEN9ShaderLab16FastPropertyNameEif, __ZN15FrictionJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN15FrictionJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__weeksEv, __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_: __ZN6prcoreL17BlitBilinearFloatERK14ImageReferenceRS0_, __Z48Register_UnityEngine_Debug_ClearDeveloperConsolev: __Z48Register_UnityEngine_Debug_ClearDeveloperConsolev, __Z27getPxVehicleChassisDataMMOIPKN5physx20PxVehicleChassisDataE: __Z27getPxVehicleChassisDataMMOIPKN5physx20PxVehicleChassisDataE, __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKRotationInternalv: __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKRotationInternalv, __Z48Register_UnityEngine_ParticleSystem_get_durationv: __Z48Register_UnityEngine_ParticleSystem_get_durationv, __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E15insert_noresizeERKS5_: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E15insert_noresizeERKS5_, __ZN5physx3Cct13BoxController11setPositionERKNS_14PxExtendedVec3E: __ZN5physx3Cct13BoxController11setPositionERKNS_14PxExtendedVec3E, __ZN9TextAsset23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9TextAsset23VirtualRedirectTransferER17RemapPPtrTransfer, __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_swingLimitSpringv: __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_swingLimitSpringv, __Z50ParticleSystem_CollisionModule_CUSTOM_SetVoxelSizeP12Il2CppObjectf: __Z50ParticleSystem_CollisionModule_CUSTOM_SetVoxelSizeP12Il2CppObjectf, __ZN5physx6shdfnd7PAUtils13registerEventEPKc: __ZN5physx6shdfnd7PAUtils13registerEventEPKc, __Z37scripting_produce_method_from_backendPK10MethodInfo: __Z37scripting_produce_method_from_backendPK10MethodInfo, __ZN20ArchiveStorageHeader23ReadHeaderAndBlocksInfoER12FileAccessorRNS_6HeaderERNS_10BlocksInfoE: __ZN20ArchiveStorageHeader23ReadHeaderAndBlocksInfoER12FileAccessorRNS_6HeaderERNS_10BlocksInfoE, __ZNK5physx3Ext7D6Joint8getDriveENS_9PxD6Drive4EnumE: __ZNK5physx3Ext7D6Joint8getDriveENS_9PxD6Drive4EnumE, __ZNK14StackAllocator10GetPtrSizeEPKv: __ZNK14StackAllocator10GetPtrSizeEPKv, __ZN7mecanim9animation12GetWeights1dERKNS0_19Blend1dDataConstantEPff: __ZN7mecanim9animation12GetWeights1dERKNS0_19Blend1dDataConstantEPff, __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE, __Z34TextGenerator_CUSTOM_GetLinesArrayP12Il2CppObject: __Z34TextGenerator_CUSTOM_GetLinesArrayP12Il2CppObject, __ZNK5physx7NpScene27getCCDContactModifyCallbackEv: __ZNK5physx7NpScene27getCCDContactModifyCallbackEv, __ZN5Unity11SpringJoint15ThreadedCleanupEv: __ZN5Unity11SpringJoint15ThreadedCleanupEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv, __Z55Register_UnityEngine_Physics2D_set_changeStopsCallbacksv: __Z55Register_UnityEngine_Physics2D_set_changeStopsCallbacksv, __ZN33AssetBundleLoadFromAsyncOperation27IntegrateWithPreloadManagerEv: __ZN33AssetBundleLoadFromAsyncOperation27IntegrateWithPreloadManagerEv, _UNITY_FT_Create_Class_cff_services: _UNITY_FT_Create_Class_cff_services, __ZNK10FileSystem10CreatePathEPKc: __ZNK10FileSystem10CreatePathEPKc, __Z24tessMeshSetWindingNumberP8TESSmeshii: __Z24tessMeshSetWindingNumberP8TESSmeshii, __ZN12HandlerChain12CreateAsFileER13FileEntryData: __ZN12HandlerChain12CreateAsFileER13FileEntryData, __ZN5physx14PxcSweepBoxBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx14PxcSweepBoxBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN12ScriptMapperD0Ev: __ZN12ScriptMapperD0Ev, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIhhEEPhEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIhhEEPhEEbT0_S5_T_, __Z42getPxVehicleAckermannGeometryDataMAccuracyPKN5physx30PxVehicleAckermannGeometryDataE: __Z42getPxVehicleAckermannGeometryDataMAccuracyPKN5physx30PxVehicleAckermannGeometryDataE, __ZNK5physx2Sc8ShapeSim8getSceneEv: __ZNK5physx2Sc8ShapeSim8getSceneEv, __ZN8Material15ResetWithShaderEP6Shader: __ZN8Material15ResetWithShaderEP6Shader, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj37ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f: __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f, __ZNK12NavMeshAgent18SamplePathPositionEifP10NavMeshHit: __ZNK12NavMeshAgent18SamplePathPositionEifP10NavMeshHit, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetZMultiplierv, __ZN11ContextGLES7PresentEv: __ZN11ContextGLES7PresentEv, __Z43SystemInfo_Get_Custom_PropSupportsVibrationv: __Z43SystemInfo_Get_Custom_PropSupportsVibrationv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN19SkinnedMeshRenderer12SetLocalAABBERK4AABB: __ZN19SkinnedMeshRenderer12SetLocalAABBERK4AABB, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z26setPxSceneDescSanityBoundsPN5physx11PxSceneDescENS_9PxBounds3E: __Z26setPxSceneDescSanityBoundsPN5physx11PxSceneDescENS_9PxBounds3E, __Z30AndroidJNI_CUSTOM_SetCharField13Il2Cpp_IntPtrS_t: __Z30AndroidJNI_CUSTOM_SetCharField13Il2Cpp_IntPtrS_t, __Z31GUI_Get_Custom_PropBlitMaterialv: __Z31GUI_Get_Custom_PropBlitMaterialv, __ZN7mecanim9animation16CreateClipOutputEiRNS_6memory9AllocatorE: __ZN7mecanim9animation16CreateClipOutputEiRNS_6memory9AllocatorE, __ZN20SoundChannelInstance7SetLoopEb: __ZN20SoundChannelInstance7SetLoopEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj693ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZNK9dtNavMesh12getTileRefAtEiii: __ZNK9dtNavMesh12getTileRefAtEiii, __ZNK5Umbra9Matrix4x311getMaxScaleEv: __ZNK5Umbra9Matrix4x311getMaxScaleEv, __ZN17BufferManagerGLESC2Ev: __ZN17BufferManagerGLESC2Ev, _cf2_arrstack_getPointer: _cf2_arrstack_getPointer, __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN10GameObject23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN9rapidjson8internal6u32toaEjPc: __ZN9rapidjson8internal6u32toaEjPc, __Z42CapsuleCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall: __Z42CapsuleCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev, __Z65Register_UnityEngine_SkinnedMeshRenderer_set_skinnedMotionVectorsv: __Z65Register_UnityEngine_SkinnedMeshRenderer_set_skinnedMotionVectorsv, __Z22GenerateDitherTexturesv: __Z22GenerateDitherTexturesv, __ZN15DirectorManager17RemoveFromManagerEP18PlayableController: __ZN15DirectorManager17RemoveFromManagerEP18PlayableController, __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z24ClearRegisteredVRDevicesv: __Z24ClearRegisteredVRDevicesv, __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetEnabledv: __Z67Register_UnityEngine_ParticleSystem_ExternalForcesModule_SetEnabledv, __ZN9GfxDevice23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii: __ZN9GfxDevice23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii, __ZN19RenderEventsContext16AddCommandBufferEiP22RenderingCommandBuffer: __ZN19RenderEventsContext16AddCommandBufferEiP22RenderingCommandBuffer, __ZN5physx6shdfnd7TlsFreeEj: __ZN5physx6shdfnd7TlsFreeEj, __Z26GUI_Get_Custom_PropEnabledv: __Z26GUI_Get_Custom_PropEnabledv, __ZN5physx2Sc5Scene20initContactsIteratorERNS0_15ContactIteratorE: __ZN5physx2Sc5Scene20initContactsIteratorERNS0_15ContactIteratorE, _freeaddrinfo: _freeaddrinfo, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev, __ZN19MeshParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19MeshParticleEmitter8TransferI24GenerateTypeTreeTransferEEvRT_, __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetAngularVelocityv: __Z73Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetAngularVelocityv, __ZNK5physx2Sc17ParticleSystemSim18getSimParticleDataERNS_28PxvParticleSystemSimDataDescEb: __ZNK5physx2Sc17ParticleSystemSim18getSimParticleDataERNS_28PxvParticleSystemSimDataDescEb, __ZN5physx2Gu26intersectHeightFieldConvexERKNS0_15HeightFieldUtilERKNS_11PxTransformERKNS0_10ConvexMeshES6_RKNS_11PxMeshScaleE: __ZN5physx2Gu26intersectHeightFieldConvexERKNS0_15HeightFieldUtilERKNS_11PxTransformERKNS0_10ConvexMeshES6_RKNS_11PxMeshScaleE, __ZL27CleanupModule_JSONSerializev: __ZL27CleanupModule_JSONSerializev, __ZNSt3__214__get_const_dbEv: __ZNSt3__214__get_const_dbEv, __ZN14PhysicsManager18OverlapBoxNonAllocERK8Vector3fS2_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction: __ZN14PhysicsManager18OverlapBoxNonAllocERK8Vector3fS2_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction, __ZN2UI6Canvas39UpdateCanvasSortingBucketNormalizedSizeEv: __ZN2UI6Canvas39UpdateCanvasSortingBucketNormalizedSizeEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z32TransferFileOverPlayerConnectionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvjS8_j: __Z32TransferFileOverPlayerConnectionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvjS8_j, __ZN10Effector2D17MainThreadCleanupEv: __ZN10Effector2D17MainThreadCleanupEv, __ZN4FMOD7SystemI19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS: __ZN4FMOD7SystemI19setAdvancedSettingsEP21FMOD_ADVANCEDSETTINGS, __Z46setPxVehicleEngineDataMDampingRateFullThrottlePN5physx19PxVehicleEngineDataEf: __Z46setPxVehicleEngineDataMDampingRateFullThrottlePN5physx19PxVehicleEngineDataEf, __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z59ParticleSystem_RotationBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __Z24RegisterStrippedTypeInfoI14PlayerSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI14PlayerSettingsEviPKcS2_, _UNITY_png_get_x_pixels_per_inch: _UNITY_png_get_x_pixels_per_inch, __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_SetColorv: __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_SetColorv, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetEnabledv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetEnabledv, _ntohl: _ntohl, __Z39Register_UnityEngine_Font_get_fontNamesv: __Z39Register_UnityEngine_Font_get_fontNamesv, __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI14ParticleSystemE8TransferI14SafeBinaryReadEEvRT_, _Unity_FT_Done_FreeType: _Unity_FT_Done_FreeType, __Z46Register_UnityEngine_WebCamTexture_get_devicesv: __Z46Register_UnityEngine_WebCamTexture_get_devicesv, __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN10OnGUIState30ClearNameOfNextKeyboardControlEv: __ZN10OnGUIState30ClearNameOfNextKeyboardControlEv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_, __Z13MurmurHash64APKviy: __Z13MurmurHash64APKviy, __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK14BillboardAsset9GetHeightEv: __ZNK14BillboardAsset9GetHeightEv, __ZN5physx23PxVehicleWheels4SimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E: __ZN5physx23PxVehicleWheels4SimData26setTireForceAppPointOffsetEjRKNS_6PxVec3E, __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPKvNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN14DirectorPlayerD0Ev: __ZN14DirectorPlayerD0Ev, __Z49Register_UnityEngine_Texture2D_SetBlockOfPixels32v: __Z49Register_UnityEngine_Texture2D_SetBlockOfPixels32v, __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, _internal_memalign: _internal_memalign, __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f: __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f, __ZN13dynamic_arrayIhLj1EEC2ERKS0_: __ZN13dynamic_arrayIhLj1EEC2ERKS0_, __Z96Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParametersArrayInternalv: __Z96Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetParametersArrayInternalv, __Z43setPxVehicleAckermannGeometryDataMRearWidthPN5physx30PxVehicleAckermannGeometryDataEf: __Z43setPxVehicleAckermannGeometryDataMRearWidthPN5physx30PxVehicleAckermannGeometryDataEf, __ZN12TreeRenderer14ClearRenderersEv: __ZN12TreeRenderer14ClearRenderersEv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_10MemLabelId17TransferMetaFlags, __Z46Register_UnityEngine_Rigidbody2D_get_simulatedv: __Z46Register_UnityEngine_Rigidbody2D_get_simulatedv, __Z60Register_UnityEngine_CharacterController_INTERNAL_set_centerv: __Z60Register_UnityEngine_CharacterController_INTERNAL_set_centerv, __ZN5physx14NpSpatialIndex6insertERNS_18PxSpatialIndexItemERKNS_9PxBounds3E: __ZN5physx14NpSpatialIndex6insertERNS_18PxSpatialIndexItemERKNS_9PxBounds3E, __ZN5physx9NpFactory20createNpArticulationEv: __ZN5physx9NpFactory20createNpArticulationEv, __ZN14MemoryProfilerD2Ev: __ZN14MemoryProfilerD2Ev, __Z34GUIStyle_Set_Custom_PropFixedWidthP12Il2CppObjectf: __Z34GUIStyle_Set_Custom_PropFixedWidthP12Il2CppObjectf, __ZNSt3__26locale5__imp12make_classicEv: __ZNSt3__26locale5__imp12make_classicEv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags, __Z73Register_UnityEngine_GUIStyle_Internal_GetNumCharactersThatFitWithinWidthv: __Z73Register_UnityEngine_GUIStyle_Internal_GetNumCharactersThatFitWithinWidthv, __ZN11AudioSource5PauseEv: __ZN11AudioSource5PauseEv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE19setParticleBaseFlagENS_18PxParticleBaseFlag4EnumEb, __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraEv: __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraEv, __Z53Register_UnityEngine_Collider2D_get_attachedRigidbodyv: __Z53Register_UnityEngine_Collider2D_get_attachedRigidbodyv, _PxRegisterHeightFields: _PxRegisterHeightFields, __ZN12_GLOBAL__N_112PropDescImplD0Ev: __ZN12_GLOBAL__N_112PropDescImplD0Ev, __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefIKhEE: __ZN5physx8debugger4comm16EventStreamifierINS0_22ForwardingMemoryBufferEE9streamifyERNS0_7DataRefIKhEE, __ZN8VRDevice22SetRenderViewportScaleEf: __ZN8VRDevice22SetRenderViewportScaleEf, __ZN11UnityEngine9Animation31CreateControllerBindingConstantEPKN7mecanim9animation18ControllerConstantEPKNS2_12AnimationSetEPNS1_18ValueArrayConstantEjPKNS2_14AvatarConstantERNS1_6memory9AllocatorE: __ZN11UnityEngine9Animation31CreateControllerBindingConstantEPKN7mecanim9animation18ControllerConstantEPKNS2_12AnimationSetEPNS1_18ValueArrayConstantEjPKNS2_14AvatarConstantERNS1_6memory9AllocatorE, __Z30setPxVehicleTireDataMLatStiffXPN5physx17PxVehicleTireDataEf: __Z30setPxVehicleTireDataMLatStiffXPN5physx17PxVehicleTireDataEf, __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt64v: __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt64v, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN24GenerateTypeTreeTransfer8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN5audio5mixer16SnapshotConstantEEEvRT_PKc17TransferMetaFlags, __ZN23ForwardShaderRenderLoopD0Ev: __ZN23ForwardShaderRenderLoopD0Ev, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj384EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __ZN7mecanim9animation13HasRootCurvesERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation13HasRootCurvesERKNS0_18ClipMuscleConstantE, __ZNK23iPhoneLocalNotification11GetTimeZoneEv: __ZNK23iPhoneLocalNotification11GetTimeZoneEv, __Z40Rigidbody_Set_Custom_PropUseConeFrictionP12Il2CppObjecth: __Z40Rigidbody_Set_Custom_PropUseConeFrictionP12Il2CppObjecth, __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_T_, __ZN37AssetBundleLoadFromFileAsyncOperation11LoadArchiveEv: __ZN37AssetBundleLoadFromFileAsyncOperation11LoadArchiveEv, __Z36WebCamTexture_Get_Custom_PropDevicesv: __Z36WebCamTexture_Get_Custom_PropDevicesv, __Z47GUIClip_CUSTOM_INTERNAL_CALL_Internal_Clip_RectR5RectTIfE: __Z47GUIClip_CUSTOM_INTERNAL_CALL_Internal_Clip_RectR5RectTIfE, __Z24RegisterStrippedTypeInfoI13SparseTextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI13SparseTextureEviPKcS2_, __Z46Register_UnityEngine_GL_INTERNAL_get_modelviewv: __Z46Register_UnityEngine_GL_INTERNAL_get_modelviewv, __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EOS3_: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EOS3_, __ZN5physx25PxVehicleConstraintShader19visualiseConstraintERNS_22PxConstraintVisualizerEPKvRKNS_11PxTransformES7_j: __ZN5physx25PxVehicleConstraintShader19visualiseConstraintERNS_22PxConstraintVisualizerEPKvRKNS_11PxTransformES7_j, __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_PKNS0_10SphereDataESA_: __ZN5physx5cloth12expandBoundsI8Scalar4fEENS0_11BoundingBoxIT_EERKS5_PKNS0_10SphereDataESA_, __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj: __ZNK5physx22PxVehicleWheelsSimData20getWheelCentreOffsetEj, __Z21XOREncryptToHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_: __Z21XOREncryptToHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_, __ZN5physx9NpFactory21acquireConnectorArrayEv: __ZN5physx9NpFactory21acquireConnectorArrayEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, _UNITY_png_calloc: _UNITY_png_calloc, __Z61Register_UnityEngine_Gyroscope_INTERNAL_CALL_gravity_Internalv: __Z61Register_UnityEngine_Gyroscope_INTERNAL_CALL_gravity_Internalv, __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj: __ZN5physx2Cm9FlushPool21allocateNotThreadSafeEjj, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf, __ZN14RenderSettingsC2E10MemLabelId18ObjectCreationMode: __ZN14RenderSettingsC2E10MemLabelId18ObjectCreationMode, __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj: __ZNK5physx22PxVehicleWheelsDynData11getUserDataEj, __ZN2UI6Canvas24DrawIntermediateRendererERNS_5BatchE10Matrix4x4fiP6Camerat: __ZN2UI6Canvas24DrawIntermediateRendererERNS_5BatchE10Matrix4x4fiP6Camerat, __ZN23LODTreeInstanceRendererD0Ev: __ZN23LODTreeInstanceRendererD0Ev, __ZN24iPhoneRemoteNotificationC2EP11objc_object: __ZN24iPhoneRemoteNotificationC2EP11objc_object, __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE: __ZN16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE, __Z26CleanupActiveLightsContextR21ActiveLightingContext: __Z26CleanupActiveLightsContextR21ActiveLightingContext, __ZThn12_N5physx3Ext7D6JointD0Ev: __ZThn12_N5physx3Ext7D6JointD0Ev, __ZN5physx7NpScene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE: __ZN5physx7NpScene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE, __ZN15QualitySettings10SetLODBiasEf: __ZN15QualitySettings10SetLODBiasEf, __ZN13OcclusionAreaC2E10MemLabelId18ObjectCreationMode: __ZN13OcclusionAreaC2E10MemLabelId18ObjectCreationMode, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE, __ZN5physx2Sc10NPhaseCore36addToForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE: __ZN5physx2Sc10NPhaseCore36addToForceThresholdContactEventPairsEPNS0_19ShapeInstancePairLLE, __ZN18PlayableController4PlayEv: __ZN18PlayableController4PlayEv, __ZN20SoundChannelInstance16UpdatePauseStateEv: __ZN20SoundChannelInstance16UpdatePauseStateEv, __Z55Register_UnityEngine_RenderTexture_get_autoGenerateMipsv: __Z55Register_UnityEngine_RenderTexture_get_autoGenerateMipsv, __ZN4FMOD7Channel19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD7Channel19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES, __Z17AppendMeshIndicesPtRjPKtjb: __Z17AppendMeshIndicesPtRjPKtjb, __Z49EmitSerializationCommandsForLinearCollectionFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI24GenerateTypeTreeTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN5physx2Sn5ConvX20convertExtraData_PtrEPKcS3_RKNS0_15PxMetaDataEntryEiii: __ZN5physx2Sn5ConvX20convertExtraData_PtrEPKcS3_RKNS0_15PxMetaDataEntryEiii, __ZN8Animator6RecordEf: __ZN8Animator6RecordEf, __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_NS0_4lessIS7_EE13stl_allocatorINS0_4pairIKS7_S7_EEL18MemLabelIdentifier12ELi16EEEEE13StaticDestroyEPv, __Z29StdTemplateConversionFunctionIbjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbjEbPvR14SafeBinaryRead, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN12_GLOBAL__N_119RendererEventClient19handleClientRemovedEv: __ZN12_GLOBAL__N_119RendererEventClient19handleClientRemovedEv, __ZNK27StateMachineBehaviourPlayer13FireBehaviourER8StateKeyR18ScriptingArgumentsN7mecanim12statemachine19StateMachineMessageEb: __ZNK27StateMachineBehaviourPlayer13FireBehaviourER8StateKeyR18ScriptingArgumentsN7mecanim12statemachine19StateMachineMessageEb, __ZN12_GLOBAL__N_116CollectionSorterD2Ev: __ZN12_GLOBAL__N_116CollectionSorterD2Ev, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __ZN7Texture17MainThreadCleanupEv: __ZN7Texture17MainThreadCleanupEv, __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIS4_S8_EE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIS4_S8_EE, __ZNK16SpriteRenderData17AcquireSharedDataEv: __ZNK16SpriteRenderData17AcquireSharedDataEv, __ZN9GfxDevice16DeleteDynamicVBOEv: __ZN9GfxDevice16DeleteDynamicVBOEv, __ZN5physx13NpRigidStaticD2Ev: __ZN5physx13NpRigidStaticD2Ev, __ZNK5physx13PxHeightField19getConcreteTypeNameEv: __ZNK5physx13PxHeightField19getConcreteTypeNameEv, __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_, __ZN4FMOD6SoundI19setSubSoundSentenceEPii: __ZN4FMOD6SoundI19setSubSoundSentenceEPii, __Z31Mesh_Set_Custom_PropBoneWeightsP12Il2CppObjectP11Il2CppArray: __Z31Mesh_Set_Custom_PropBoneWeightsP12Il2CppObjectP11Il2CppArray, __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __Z36getPxVehicleDriveDynDataMCurrentGearPKN5physx21PxVehicleDriveDynDataE: __Z36getPxVehicleDriveDynDataMCurrentGearPKN5physx21PxVehicleDriveDynDataE, __ZN4FMOD7ReverbI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD7ReverbI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN20ArchiveStorageReader10ReadHeaderEy: __ZN20ArchiveStorageReader10ReadHeaderEy, __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass: __ZN9Scripting25GetTypeFromScriptingClassEP11Il2CppClass, __ZN5Umbra9Matrix4x46invertERKNS_9Matrix4x3E: __ZN5Umbra9Matrix4x46invertERKNS_9Matrix4x3E, __ZN13SpringJoint2DD2Ev: __ZN13SpringJoint2DD2Ev, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __ZN5physx29BroadPhaseBatchUpdateWorkTask11runInternalEv: __ZN5physx29BroadPhaseBatchUpdateWorkTask11runInternalEv, __Z51Rigidbody2D_Get_Custom_PropUseFullKinematicContactsP12Il2CppObject: __Z51Rigidbody2D_Get_Custom_PropUseFullKinematicContactsP12Il2CppObject, __Z55Register_UnityEngine_VR_VRSettings_get_loadedDeviceNamev: __Z55Register_UnityEngine_VR_VRSettings_get_loadedDeviceNamev, __ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_: __ZN5physx2Sc24ConstraintProjectionTree23projectionTreeBuildStepERNS0_19ConstraintGroupNodeEPNS0_13ConstraintSimEPPS2_, __Z47CommandBuffer_CUSTOM_SetShadowSamplingMode_ImplP12Il2CppObjectR26MonoRenderTargetIdentifier18ShadowSamplingMode: __Z47CommandBuffer_CUSTOM_SetShadowSamplingMode_ImplP12Il2CppObjectR26MonoRenderTargetIdentifier18ShadowSamplingMode, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEc, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj297ES3_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj297ES3_NS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z48Register_UnityEngine_DynamicGI_get_indirectScalev: __Z48Register_UnityEngine_DynamicGI_get_indirectScalev, __ZNK5physx2Gu15HeightFieldUtil24findProjectionOnTriangleEjjjRKNS_6PxVec3ERS2_: __ZNK5physx2Gu15HeightFieldUtil24findProjectionOnTriangleEjjjRKNS_6PxVec3ERS2_, __ZN11SoundHandle7ReleaseEv: __ZN11SoundHandle7ReleaseEv, __ZN16MinMaxPolyCurves9IntegrateEv: __ZN16MinMaxPolyCurves9IntegrateEv, __ZNK12HandlerChain9IsSymLinkERK13FileEntryData: __ZNK12HandlerChain9IsSymLinkERK13FileEntryData, __ZN24CompressedAnimationCurve8TransferI14SafeBinaryReadEEvRT_: __ZN24CompressedAnimationCurve8TransferI14SafeBinaryReadEEvRT_, __Z57Register_UnityEngine_LineRenderer_INTERNAL_set_startColorv: __Z57Register_UnityEngine_LineRenderer_INTERNAL_set_startColorv, __ZNSt3__214codecvt_bynameIwc11__mbstate_tED0Ev: __ZNSt3__214codecvt_bynameIwc11__mbstate_tED0Ev, __Z41AnimationCurve_Get_Custom_PropPreWrapModeP12Il2CppObject: __Z41AnimationCurve_Get_Custom_PropPreWrapModeP12Il2CppObject, __ZNK10Collider2D26GetTypeInfoVirtualInternalEv: __ZNK10Collider2D26GetTypeInfoVirtualInternalEv, __ZN22ParticleSystemRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN22ParticleSystemRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4FMOD12ChannelGroup8getPitchEPf: __ZN4FMOD12ChannelGroup8getPitchEPf, __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode: __ZN8RendererC2E12RendererType10MemLabelId18ObjectCreationMode, _ft_raster1_render: _ft_raster1_render, __ZN13AudioListener13AwakeFromLoadE17AwakeFromLoadMode: __ZN13AudioListener13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt9exceptionD2Ev: __ZNSt9exceptionD2Ev, __ZN19MeshParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead: __ZN19MeshParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead, __Z44Register_UnityEngine_AndroidJNI_GetByteFieldv: __Z44Register_UnityEngine_AndroidJNI_GetByteFieldv, __ZN5physx6shdfnd10ThreadImpl15setAffinityMaskEj: __ZN5physx6shdfnd10ThreadImpl15setAffinityMaskEj, __ZN15QualitySettings5ResetEv: __ZN15QualitySettings5ResetEv, __ZN4math4Axes8TransferI14SafeBinaryReadEEvRT_: __ZN4math4Axes8TransferI14SafeBinaryReadEEvRT_, __ZN17CollisionMeshData8TransferI14SafeBinaryReadEEvRT_R4Mesh: __ZN17CollisionMeshData8TransferI14SafeBinaryReadEEvRT_R4Mesh, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags, __Z26NavMesh_CUSTOM_TriangulatePP11Il2CppArrayS1_: __Z26NavMesh_CUSTOM_TriangulatePP11Il2CppArrayS1_, __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE: __ZN5physx9NpPhysics11addMaterialEPNS_10NpMaterialE, __ZN5physx21PxDistanceJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx21PxDistanceJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __ZNKSt3__28numpunctIwE16do_thousands_sepEv: __ZNKSt3__28numpunctIwE16do_thousands_sepEv, __Z29StdTemplateConversionFunctionIbtEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbtEbPvR14SafeBinaryRead, __Z41Register_UnityEngine_Avatar_GetAxisLengthv: __Z41Register_UnityEngine_Avatar_GetAxisLengthv, __Z44ParticleSystem_NoiseModule_CUSTOM_GetQualityP12Il2CppObject: __Z44ParticleSystem_NoiseModule_CUSTOM_GetQualityP12Il2CppObject, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToLongArrayv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToLongArrayv, __ZN5physx26PxRigidBodyGeneratedValuesC2EPKNS_11PxRigidBodyE: __ZN5physx26PxRigidBodyGeneratedValuesC2EPKNS_11PxRigidBodyE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _UNITY_png_permit_mng_features: _UNITY_png_permit_mng_features, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE8pushNameEPKc, __ZN12_GLOBAL__N_16ParserILb1EED2Ev: __ZN12_GLOBAL__N_16ParserILb1EED2Ev, __Z26CreateTangentSpaceTangentsPK8Vector3fPK8Vector2fS1_P10Matrix3x3fiPKii: __Z26CreateTangentSpaceTangentsPK8Vector3fPK8Vector2fS1_P10Matrix3x3fiPKii, __ZN17ProceduralTexture24AcquireSharedTextureDataEv: __ZN17ProceduralTexture24AcquireSharedTextureDataEv, __ZN5physx15PxVehicleUpdate6updateEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx15PxVehicleUpdate6updateEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __ZN7mecanim5human15HumanPoseMirrorERNS0_9HumanPoseERKS1_: __ZN7mecanim5human15HumanPoseMirrorERNS0_9HumanPoseERKS1_, __ZN14UnityWebStream6RetainEv: __ZN14UnityWebStream6RetainEv, __Z29StdTemplateConversionFunctionIhhEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhhEbPvR14SafeBinaryRead, __ZN8Collider19CreateShapeInternalERN5physx10PxGeometryEPNS0_12PxRigidActorEib: __ZN8Collider19CreateShapeInternalERN5physx10PxGeometryEPNS0_12PxRigidActorEib, __Z36Quaternion_CUSTOM_INTERNAL_CALL_LerpRK11QuaternionfS1_fRS_: __Z36Quaternion_CUSTOM_INTERNAL_CALL_LerpRK11QuaternionfS1_fRS_, __Z41Quaternion_CUSTOM_INTERNAL_CALL_AngleAxisfRK8Vector3fR11Quaternionf: __Z41Quaternion_CUSTOM_INTERNAL_CALL_AngleAxisfRK8Vector3fR11Quaternionf, __Z43Register_UnityEngine_GUI_INTERNAL_get_colorv: __Z43Register_UnityEngine_GUI_INTERNAL_get_colorv, __Z13RegisterClassI15AudioReverbZoneEvv: __Z13RegisterClassI15AudioReverbZoneEvv, __ZN4FMOD6SoundI13getMusicSpeedEPf: __ZN4FMOD6SoundI13getMusicSpeedEPf, __Z44SceneManager_CUSTOM_INTERNAL_CALL_GetSceneAtiRi: __Z44SceneManager_CUSTOM_INTERNAL_CALL_GetSceneAtiRi, __GLOBAL__sub_I_runtime_vehicles_lump_cpp: __GLOBAL__sub_I_runtime_vehicles_lump_cpp, __Z35AssetBundle_CUSTOM_GetAllAssetNamesP12Il2CppObject: __Z35AssetBundle_CUSTOM_GetAllAssetNamesP12Il2CppObject, __ZN5physx12NpBatchQuery11setRunOnSpuEb: __ZN5physx12NpBatchQuery11setRunOnSpuEb, __ZN9ShaderLab9SubShader29CreateFromSerializedSubShaderERKNS_19SerializedSubShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_: __ZN9ShaderLab9SubShader29CreateFromSerializedSubShaderERKNS_19SerializedSubShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEbPS7_, __ZN18ColorBySpeedModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32: __ZN18ColorBySpeedModule6UpdateERK23ParticleSystemParticlesP11ColorRGBA32, __ZN14ParticleSystem14SetPlayOnAwakeEb: __ZN14ParticleSystem14SetPlayOnAwakeEb, __ZN12_GLOBAL__N_112UserRenderer13setInstanceIdEPKv: __ZN12_GLOBAL__N_112UserRenderer13setInstanceIdEPKv, __ZN11UnityEngine15CloudWebService13SessionHeader10SaveToFileER12FileAccessor: __ZN11UnityEngine15CloudWebService13SessionHeader10SaveToFileER12FileAccessor, __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalMatrixv: __Z57Register_UnityEngine_Shader_INTERNAL_CALL_SetGlobalMatrixv, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN6Shader13AwakeFromLoadE17AwakeFromLoadMode: __ZN6Shader13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE7reserveEj, __ZN6Camera15InitializeClassEv: __ZN6Camera15InitializeClassEv, __ZN5physx30solveConcludeExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx30solveConcludeExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN14PlayerSettingsC2E10MemLabelId18ObjectCreationMode: __ZN14PlayerSettingsC2E10MemLabelId18ObjectCreationMode, __ZN14DirectorPlayer9GetStagesER13dynamic_arrayI9StageDescLj4EE: __ZN14DirectorPlayer9GetStagesER13dynamic_arrayI9StageDescLj4EE, __Z41Register_UnityEngine_RenderSettings_Resetv: __Z41Register_UnityEngine_RenderSettings_Resetv, __ZN5physx7NpCloth24setLinearDragCoefficientENS_6PxVec3E: __ZN5physx7NpCloth24setLinearDragCoefficientENS_6PxVec3E, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj16ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK12HandlerChain8FilenameERK13FileEntryData: __ZNK12HandlerChain8FilenameERK13FileEntryData, __ZN4FMOD12ChannelGroup12getNumGroupsEPi: __ZN4FMOD12ChannelGroup12getNumGroupsEPi, __ZN9ShaderLab20SerializedSubProgram11AddUAVParamEPKcii: __ZN9ShaderLab20SerializedSubProgram11AddUAVParamEPKcii, __ZNK14StackAllocator15WalkAllocationsEPFvPKvjPKPvjE: __ZNK14StackAllocator15WalkAllocationsEPFvPKvjPKPvjE, __ZN13UploadHandler6RetainEv: __ZN13UploadHandler6RetainEv, __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_AddKey_Internalv: __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_AddKey_Internalv, __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __Z28tessMeshTessellateMonoRegionP8TESSmeshP8TESSface: __Z28tessMeshTessellateMonoRegionP8TESSmeshP8TESSface, __ZN5physx3Cct13BoxController20setHalfForwardExtentEf: __ZN5physx3Cct13BoxController20setHalfForwardExtentEf, __Z26PlayerInitEngineNoGraphicsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z26PlayerInitEngineNoGraphicsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZN11TrailModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjRKf: __ZN11TrailModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjRKf, __ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE: __ZN5physx10readHeaderEaaaaRjRbRNS_13PxInputStreamE, __Z31Camera_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE: __Z31Camera_CUSTOM_INTERNAL_get_rectP12Il2CppObjectP5RectTIfE, __ZNK22DownloadHandlerTexture13GetMemorySizeEv: __ZNK22DownloadHandlerTexture13GetMemorySizeEv, __Z57Register_UnityEngine_AudioSource_set_ignoreListenerVolumev: __Z57Register_UnityEngine_AudioSource_set_ignoreListenerVolumev, __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z60Register_UnityEngine_AudioHighPassFilter_set_cutoffFrequencyv: __Z60Register_UnityEngine_AudioHighPassFilter_set_cutoffFrequencyv, __ZN19CharacterController10IsGroundedEv: __ZN19CharacterController10IsGroundedEv, __ZN5physx2Sn17RepXVisitorReaderINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE: __ZN5physx2Sn17RepXVisitorReaderINS_18PxArticulationLinkEE19handleIncomingJointERKNS_22PxReadOnlyPropertyInfoILj57ES2_PNS_19PxArticulationJointEEE, __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK12NavMeshAgent8CopyPathEP11NavMeshPath: __ZNK12NavMeshAgent8CopyPathEP11NavMeshPath, __ZNKSt3__214__codecvt_utf8IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_: __ZNKSt3__214__codecvt_utf8IwE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_, __Z44Register_UnityEngine_Collider2D_get_frictionv: __Z44Register_UnityEngine_Collider2D_get_frictionv, __ZNSt3__26vectorIP6IDListNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP6IDListNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN19AudioHighPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN19AudioHighPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN17CapsuleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17CapsuleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb0EEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb0EEEEEvRKS1_, __ZN12NavMeshAgentD2Ev: __ZN12NavMeshAgentD2Ev, __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_anchorv: __Z54Register_UnityEngine_TargetJoint2D_INTERNAL_set_anchorv, __ZN10GpuProgramD2Ev: __ZN10GpuProgramD2Ev, __ZN22LocalFileSystemHandler9LastErrorEv: __ZN22LocalFileSystemHandler9LastErrorEv, __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_: __ZNSt3__27__sort4IR23TreeInstanceIndexSorterPjEEjT0_S4_S4_S4_T_, __ZN12b2BroadPhaseC2Ev: __ZN12b2BroadPhaseC2Ev, __ZNK13EmscriptenWWW14GetPartialSizeEv: __ZNK13EmscriptenWWW14GetPartialSizeEv, __ZN9BlobWrite8TransferIN7mecanim8skeleton4NodeEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim8skeleton4NodeEEEvRT_PKc17TransferMetaFlags, __ZN14ParticleSystem4EmitEi: __ZN14ParticleSystem4EmitEi, __Z46Register_UnityEngine_AudioSettings_get_dspTimev: __Z46Register_UnityEngine_AudioSettings_get_dspTimev, __ZN5IMGUI23CacheGUIStatePropertiesER8GUIStateRNS_23GUIStatePropertiesCacheE: __ZN5IMGUI23CacheGUIStatePropertiesER8GUIStateRNS_23GUIStatePropertiesCacheE, __Z69ThreadAndSerializationSafeCheckSetMonoBehaviourConstructorBeingCalledP13MonoBehaviour: __Z69ThreadAndSerializationSafeCheckSetMonoBehaviourConstructorBeingCalledP13MonoBehaviour, __ZThn12_N5physx3Ext13DistanceJointD1Ev: __ZThn12_N5physx3Ext13DistanceJointD1Ev, __ZN10AtomicNode4LinkEPS_: __ZN10AtomicNode4LinkEPS_, __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_, __Z32TextGenerator_CUSTOM_Dispose_cppP12Il2CppObject: __Z32TextGenerator_CUSTOM_Dispose_cppP12Il2CppObject, __ZN23b2EdgeAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN23b2EdgeAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN11UnityEngine15CloudWebService13WWWRestClient12NeedsPollingEv: __ZN11UnityEngine15CloudWebService13WWWRestClient12NeedsPollingEv, __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_9PxD6JointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __Z41TrailRenderer_Set_Custom_PropAutodestructP12Il2CppObjecth: __Z41TrailRenderer_Set_Custom_PropAutodestructP12Il2CppObjecth, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToByteArrayv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToByteArrayv, __Z11tessNewTessP9TESSalloc: __Z11tessNewTessP9TESSalloc, __ZNSt3__26locale5__imp7installINS_15time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __Z34Register_UnityEngine_WWW_get_bytesv: __Z34Register_UnityEngine_WWW_get_bytesv, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE10visitCellsERKNS4_11OverlapLineE: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI24ConvexVsHeightfieldSweepE10visitCellsERKNS4_11OverlapLineE, __ZN9BoxPruner14optimizeMemoryEv: __ZN9BoxPruner14optimizeMemoryEv, __Z35AudioClip_CUSTOM_Construct_Internalv: __Z35AudioClip_CUSTOM_Construct_Internalv, __ZN5Unity12PhysicsQuery10SphereTestERK8Vector3ffi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery10SphereTestERK8Vector3ffi23QueryTriggerInteraction, __Z51AnimatorUtility_CUSTOM_DeoptimizeTransformHierarchyP12Il2CppObject: __Z51AnimatorUtility_CUSTOM_DeoptimizeTransformHierarchyP12Il2CppObject, _UNITY_FT_Face_GetCharsOfVariant: _UNITY_FT_Face_GetCharsOfVariant, __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj: __Z8CopyBlobIN7mecanim9animation16ControllerMemoryEEPT_RKS3_RNS0_6memory9AllocatorERj, __Z44Register_UnityEngine_Sprite_OverrideGeometryv: __Z44Register_UnityEngine_Sprite_OverrideGeometryv, __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE: __ZN13AvatarBuilder14GetAllChildrenER9TransformRNSt3__26vectorINS_14NamedTransformENS2_9allocatorIS4_EEEERKNS3_I8UnityStrNS5_IS9_EEEE, __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti: __Z27FindOrCreateMonoScriptCacheP11Il2CppClass22InitScriptingCacheTypeP6Objecti, __ZN9AudioClip23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9AudioClip23VirtualRedirectTransferER17RemapPPtrTransfer, __Z45WheelCollider_Set_Custom_PropWheelDampingRateP12Il2CppObjectf: __Z45WheelCollider_Set_Custom_PropWheelDampingRateP12Il2CppObjectf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj16EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj16EEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS3_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_, __ZN28LightProbeProxyVolumeManager21SwapVolumeTextureSetsER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager21SwapVolumeTextureSetsER21LightProbeProxyVolume, __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE: __ZN6Camera18RestoreMatrixStateERKNS_11MatrixStateE, __Z34AudioClip_Get_Custom_PropFrequencyP12Il2CppObject: __Z34AudioClip_Get_Custom_PropFrequencyP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __Z49LightProbeProxyVolume_Get_Custom_PropProbeDensityP12Il2CppObject: __Z49LightProbeProxyVolume_Get_Custom_PropProbeDensityP12Il2CppObject, __ZNK14RedirectHelper11RevertToGetEl: __ZNK14RedirectHelper11RevertToGetEl, __Z20b2NearestPointOnLineRK6b2Vec2S1_S1_: __Z20b2NearestPointOnLineRK6b2Vec2S1_S1_, __ZN12FixedJoint2DD0Ev: __ZN12FixedJoint2DD0Ev, __ZN9ShaderLab10GrabPasses3AddEPNS_4PassEPK6Camera: __ZN9ShaderLab10GrabPasses3AddEPNS_4PassEPK6Camera, __ZN14dtPathCorridorC2Ev: __ZN14dtPathCorridorC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _socketpair: _socketpair, __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Gradient8TransferI24GenerateTypeTreeTransferEEvRT_, __ZZN15DirectorManager15InitializeClassEvEN47PreLateUpdateDirectorUpdateAnimationBeginstruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN47PreLateUpdateDirectorUpdateAnimationBeginstruct7ForwardEv, __Z45Register_UnityEngine_Camera_INTERNAL_get_rectv: __Z45Register_UnityEngine_Camera_INTERNAL_get_rectv, __Z14SetIsBatchmodeb: __Z14SetIsBatchmodeb, __Z40Renderer_Get_Custom_PropSortingLayerNameP12Il2CppObject: __Z40Renderer_Get_Custom_PropSortingLayerNameP12Il2CppObject, __ZN12_GLOBAL__N_111StreamOwner6addRefEv: __ZN12_GLOBAL__N_111StreamOwner6addRefEv, __ZNK9Transform23GetHasChangedDeprecatedEv: __ZNK9Transform23GetHasChangedDeprecatedEv, __Z54Register_UnityEngine_WebCamTexture_get_requestedHeightv: __Z54Register_UnityEngine_WebCamTexture_get_requestedHeightv, __ZNSt3__26vectorIN5physx12PxOverlapHitENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN5physx12PxOverlapHitENS_9allocatorIS2_EEE8__appendEj, __ZN4crnd12symbol_codec14start_decodingEPKhj: __ZN4crnd12symbol_codec14start_decodingEPKhj, __ZN13RenderManager24OnRenderTextureDestroyedEP13RenderTexture: __ZN13RenderManager24OnRenderTextureDestroyedEP13RenderTexture, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN11UnityEngine15CloudWebService19SessionEventManager11FlushEventsEv: __ZN11UnityEngine15CloudWebService19SessionEventManager11FlushEventsEv, __ZNKSt3__27codecvtIcc11__mbstate_tE13do_max_lengthEv: __ZNKSt3__27codecvtIcc11__mbstate_tE13do_max_lengthEv, _utimensat: _utimensat, __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb0EEEEvRT_, _tt_cmap8_validate: _tt_cmap8_validate, __ZN5physx27PxFixedJointGeneratedValuesC2EPKNS_12PxFixedJointE: __ZN5physx27PxFixedJointGeneratedValuesC2EPKNS_12PxFixedJointE, __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv: __ZNK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv, __ZN12AudioManager25GetScriptBufferManagerPtrEv: __ZN12AudioManager25GetScriptBufferManagerPtrEv, __ZN14Texture2DArray17MainThreadCleanupEv: __ZN14Texture2DArray17MainThreadCleanupEv, _wcsstr: _wcsstr, __Z19FlattenRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb: __Z19FlattenRelativePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj68ENS_22PxRepXPropertyAccessorILj68ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj68ENS_22PxRepXPropertyAccessorILj68ES4_ffEEEEvRKT0_, __ZN11OffMeshLink23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11OffMeshLink23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z51Register_UnityEngine_RenderTexture_set_isPowerOfTwov: __Z51Register_UnityEngine_RenderTexture_set_isPowerOfTwov, __ZN14DetailDatabase29ComputeVertexAndTriangleCountER11DetailPatch16DetailRenderModefPiS3_: __ZN14DetailDatabase29ComputeVertexAndTriangleCountER11DetailPatch16DetailRenderModefPiS3_, __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE: __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS5_EE, __ZN5physx7NpScene22removeArticulationLinkERNS_18NpArticulationLinkEb: __ZN5physx7NpScene22removeArticulationLinkERNS_18NpArticulationLinkEb, _fputc: _fputc, __ZN12MeshRenderer10DeactivateE19DeactivateOperation: __ZN12MeshRenderer10DeactivateE19DeactivateOperation, __ZNSt3__26vectorItNS_9allocatorItEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorItNS_9allocatorItEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleItNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN12InputManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN12InputManager23VirtualRedirectTransferER14SafeBinaryRead, __Z24RegisterStrippedTypeInfoI16LightmapSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI16LightmapSettingsEviPKcS2_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __Z24CalculateRaycastTexcoordP8ColliderRK8Vector2fRK8Vector3fji: __Z24CalculateRaycastTexcoordP8ColliderRK8Vector2fRK8Vector3fji, _fputs: _fputs, __ZN15ResourceManager8TransferI14SafeBinaryReadEEvRT_: __ZN15ResourceManager8TransferI14SafeBinaryReadEEvRT_, _feraiseexcept: _feraiseexcept, __ZN12NavMeshAgent26ActivateCurrentOffMeshLinkEb: __ZN12NavMeshAgent26ActivateCurrentOffMeshLinkEb, __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE: __ZN10GameObject20AddComponentInternalEPN5Unity9ComponentE, __Z41Animator_CUSTOM_INTERNAL_set_rootRotationP12Il2CppObjectRK11Quaternionf: __Z41Animator_CUSTOM_INTERNAL_set_rootRotationP12Il2CppObjectRK11Quaternionf, __Z52LightProbeProxyVolume_Get_Custom_PropBoundingBoxModeP12Il2CppObject: __Z52LightProbeProxyVolume_Get_Custom_PropBoundingBoxModeP12Il2CppObject, __Z49Register_UnityEngine_ParticleSystem_Internal_Emitv: __Z49Register_UnityEngine_ParticleSystem_Internal_Emitv, __Z41Shader_CUSTOM_GetGlobalFloatArrayImplListiP12Il2CppObject: __Z41Shader_CUSTOM_GetGlobalFloatArrayImplListiP12Il2CppObject, __Z80Register_UnityEngine_Experimental_Director_AnimationMixerPlayable_InternalCreatev: __Z80Register_UnityEngine_Experimental_Director_AnimationMixerPlayable_InternalCreatev, __ZN4Mesh9SetBoundsERK4AABB: __ZN4Mesh9SetBoundsERK4AABB, __Z57ParticleSystem_LightsModule_CUSTOM_GetIntensityMultiplierP12Il2CppObject: __Z57ParticleSystem_LightsModule_CUSTOM_GetIntensityMultiplierP12Il2CppObject, __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity14CharacterJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_png_set_invalid: _UNITY_png_set_invalid, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv, __ZN15AudioEchoFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15AudioEchoFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN13RenderTexture25GetLiveRenderTextureCountEv: __ZN13RenderTexture25GetLiveRenderTextureCountEv, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi2ELb1EED2Ev, __ZN20SphericalHarmonicsL26ExpandERK20SphericalHarmonicsL1: __ZN20SphericalHarmonicsL26ExpandERK20SphericalHarmonicsL1, __ZN7mecanim9animation18CreateConstantClipERNS0_12ConstantClipEjRNS_6memory9AllocatorE: __ZN7mecanim9animation18CreateConstantClipERNS0_12ConstantClipEjRNS_6memory9AllocatorE, __Z24CalculateImageMipMapSizeii13TextureFormat: __Z24CalculateImageMipMapSizeii13TextureFormat, __ZZN20SpeedTreeWindManagerC1EvEN25PreUpdateWindUpdatestruct7ForwardEv: __ZZN20SpeedTreeWindManagerC1EvEN25PreUpdateWindUpdatestruct7ForwardEv, __Z66Register_UnityEngine_ReflectionProbe_get_maxBakedCubemapResolutionv: __Z66Register_UnityEngine_ReflectionProbe_get_maxBakedCubemapResolutionv, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, __ZNK5physx7NpShape18getQueryFilterDataEv: __ZNK5physx7NpShape18getQueryFilterDataEv, __ZN10__cxxabiv112_GLOBAL__N_119parse_discriminatorEPKcS2_: __ZN10__cxxabiv112_GLOBAL__N_119parse_discriminatorEPKcS2_, __ZN4FMOD7SystemI15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE: __ZN4FMOD7SystemI15createDSPByTypeE13FMOD_DSP_TYPEPPNS_3DSPE, __Z29UnloadGameObjectAndComponentsR10GameObject: __Z29UnloadGameObjectAndComponentsR10GameObject, _lcong48: _lcong48, __ZN20TextRenderingPrivate15DynamicFontDataC2Ev: __ZN20TextRenderingPrivate15DynamicFontDataC2Ev, __ZL22StaticInitializeShaderPv: __ZL22StaticInitializeShaderPv, __ZN18BuoyancyEffector2D16SetFlowMagnitudeEf: __ZN18BuoyancyEffector2D16SetFlowMagnitudeEf, __ZN4PPtrI14PhysicMaterialE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI14PhysicMaterialE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED2Ev, __ZN20IntermediateRenderer19UpdateTransformInfoEv: __ZN20IntermediateRenderer19UpdateTransformInfoEv, __ZN7ApiGLES14RecreateBufferEjN2gl12BufferTargetElPKvj: __ZN7ApiGLES14RecreateBufferEjN2gl12BufferTargetElPKvj, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE11runInternalEv, __ZanRK8Scalar4fS1_: __ZanRK8Scalar4fS1_, __Z41Register_UnityEngine_MonoBehaviour_Invokev: __Z41Register_UnityEngine_MonoBehaviour_Invokev, __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZN9Texture2D30UpdateImageDataDontTouchMipmapEv: __ZN9Texture2D30UpdateImageDataDontTouchMipmapEv, __ZN6Camera12CleanupClassEv: __ZN6Camera12CleanupClassEv, __ZNK16ParticleAnimator15UpdateParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof: __ZNK16ParticleAnimator15UpdateParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEER19PrivateParticleInfof, __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN8Animator23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z38Material_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_: __Z38Material_CUSTOM_SetVectorArrayImplListP12Il2CppObjectiS0_, __Z35DoesComponentAllowMultipleInclusioni: __Z35DoesComponentAllowMultipleInclusioni, __Z20MonoCreateGameObjectPKc: __Z20MonoCreateGameObjectPKc, __ZN15UnityAdsManager12CleanupClassEv: __ZN15UnityAdsManager12CleanupClassEv, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN22SharedSpriteRenderDataD2Ev: __ZN22SharedSpriteRenderDataD2Ev, __ZN15FrictionJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15FrictionJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNSt3__26locale5__imp7installINS_7collateIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7collateIwEEEEvPT_, __ZN22b2EdgeAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN22b2EdgeAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform: __ZN11UnityEngine9Animation33SetGenericTransformPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayEP9Transform, __ZN5physx2Cm9FlushPoolD2Ev: __ZN5physx2Cm9FlushPoolD2Ev, __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15CapsuleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE: __ZN5physx15reflectVelocityERNS_6PxVec3ERKS0_S3_S3_S3_jRKNS_27PxsFluidCollisionParametersE, __ZN13MemoryManager27InitializeDefaultAllocatorsEv: __ZN13MemoryManager27InitializeDefaultAllocatorsEv, __Z30AudioMixerFaderProcessCallbackP21UnityAudioEffectStatePfS1_jii: __Z30AudioMixerFaderProcessCallbackP21UnityAudioEffectStatePfS1_jii, __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_: __ZN17AnimationCurveTplIfE10RemoveKeysEP11KeyframeTplIfES3_, __ZN15b2FrictionJoint11SetMaxForceEf: __ZN15b2FrictionJoint11SetMaxForceEf, _cf2_initGlobalRegionBuffer: _cf2_initGlobalRegionBuffer, __Z36Register_UnityEngine_Input_GetButtonv: __Z36Register_UnityEngine_Input_GetButtonv, __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_S5_T_, __Z39Transform_Get_Custom_PropHierarchyCountP12Il2CppObject: __Z39Transform_Get_Custom_PropHierarchyCountP12Il2CppObject, __ZN11UmbraModule24OcclusionCullLocalLightsER21LocalLightCullJobDataR10BlockRange: __ZN11UmbraModule24OcclusionCullLocalLightsER21LocalLightCullJobDataR10BlockRange, __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRNS_6__lessI15OrderedCallbackS2_EEPS2_EEjT0_S6_S6_S6_T_, __ZN5physxL18testPolyFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_: __ZN5physxL18testPolyFaceNormalERKNS_2Gu9TriangleVERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSE_RjRNSD_5Vec3VENS0_13FeatureStatusERSL_, __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_399kDidDeleteMesh4CallEPviR11MessageData: __ZZN12MeshCollider15InitializeClassEvEN29FunctorImpl_399kDidDeleteMesh4CallEPviR11MessageData, __ZL40UnityAudioEffect_InternalReleaseCallbackP14FMOD_DSP_STATE: __ZL40UnityAudioEffect_InternalReleaseCallbackP14FMOD_DSP_STATE, __ZNK7dtCrowd11GetObstacleERK13dtCrowdHandle: __ZNK7dtCrowd11GetObstacleERK13dtCrowdHandle, __ZNK14CompletionTask10IsFinishedEv: __ZNK14CompletionTask10IsFinishedEv, __ZN6Sprite16OverrideGeometryEPK8Vector2fjPKtj: __ZN6Sprite16OverrideGeometryEPK8Vector2fjPKtj, __Z49HumanPoseHandler_CUSTOM_Internal_HumanPoseHandlerP12Il2CppObjectS0_S0_: __Z49HumanPoseHandler_CUSTOM_Internal_HumanPoseHandlerP12Il2CppObjectS0_S0_, __ZN5physx2Sq16BucketPrunerCore7releaseEv: __ZN5physx2Sq16BucketPrunerCore7releaseEv, __ZN5physx17PxsFluidCollision12mergeResultsEPNS_10PxBaseTaskE: __ZN5physx17PxsFluidCollision12mergeResultsEPNS_10PxBaseTaskE, __Z19Random_CUSTOM_Rangeff: __Z19Random_CUSTOM_Rangeff, __ZN5physx2Sc16ArticulationCore26setInternalDriveIterationsEj: __ZN5physx2Sc16ArticulationCore26setInternalDriveIterationsEj, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv, __Z51Playable_CUSTOM_INTERNAL_CALL_CanSetWeightsInternalR9HPlayable: __Z51Playable_CUSTOM_INTERNAL_CALL_CanSetWeightsInternalR9HPlayable, __ZN10AudioMixer8TransferI14SafeBinaryReadEEvRT_: __ZN10AudioMixer8TransferI14SafeBinaryReadEEvRT_, __ZN2UI14DepthSortLayer11GetDepthForERKNS_23RenderableUIInstructionEPS2_: __ZN2UI14DepthSortLayer11GetDepthForERKNS_23RenderableUIInstructionEPS2_, __ZN5Unity17ConfigurableJoint12CleanupClassEv: __ZN5Unity17ConfigurableJoint12CleanupClassEv, __Z47AudioListener_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti: __Z47AudioListener_Set_Custom_PropVelocityUpdateModeP12Il2CppObjecti, __Z57Register_UnityEngine_ConfigurableJoint_get_angularXMotionv: __Z57Register_UnityEngine_ConfigurableJoint_get_angularXMotionv, __Z29StdTemplateConversionFunctionIjxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjxEbPvR14SafeBinaryRead, __ZN8Collider8ReCreateEv: __ZN8Collider8ReCreateEv, __ZN14DirectorPlayer15ThreadedCleanupEv: __ZN14DirectorPlayer15ThreadedCleanupEv, __ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE: __ZN5physx11writeHeaderEaaaajbRNS_14PxOutputStreamE, __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK13b2DynamicTree12GetAreaRatioEv: __ZNK13b2DynamicTree12GetAreaRatioEv, __ZN7ApiGLES16CheckFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEEb: __ZN7ApiGLES16CheckFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEEb, __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFrameMultiplierv: __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetStartFrameMultiplierv, __ZN8Material9GetShaderEv: __ZN8Material9GetShaderEv, __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj, __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_localVelocityv: __Z63Register_UnityEngine_ParticleEmitter_INTERNAL_set_localVelocityv, __Z26setPxRigidActor_GlobalPosePN5physx12PxRigidActorERKNS_11PxTransformE: __Z26setPxRigidActor_GlobalPosePN5physx12PxRigidActorERKNS_11PxTransformE, _XXH32_freeState: _XXH32_freeState, __Z10PlayerLoopv: __Z10PlayerLoopv, __ZN5physx29PxD6JointDriveGeneratedValuesC2EPKNS_14PxD6JointDriveE: __ZN5physx29PxD6JointDriveGeneratedValuesC2EPKNS_14PxD6JointDriveE, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedv: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedv, __ZN5physx3Ext13RevoluteJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext13RevoluteJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK5physx2Sc5Scene22getNbBroadPhaseRegionsEv: __ZNK5physx2Sc5Scene22getNbBroadPhaseRegionsEv, __Z38Rigidbody_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf: __Z38Rigidbody_CUSTOM_INTERNAL_get_rotationP12Il2CppObjectP11Quaternionf, __ZN12LineRendererD0Ev: __ZN12LineRendererD0Ev, __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEED0Ev, __Z28CreateAsDirectoryIfNotExistsPKc: __Z28CreateAsDirectoryIfNotExistsPKc, _unzOpen: _unzOpen, __ZNK11TerrainData26GetTypeInfoVirtualInternalEv: __ZNK11TerrainData26GetTypeInfoVirtualInternalEv, __Z35Animator_Get_Custom_PropLogWarningsP12Il2CppObject: __Z35Animator_Get_Custom_PropLogWarningsP12Il2CppObject, __ZN5physx23PxVehicleDriveSimData4W11setDiffDataERKNS_27PxVehicleDifferential4WDataE: __ZN5physx23PxVehicleDriveSimData4W11setDiffDataERKNS_27PxVehicleDifferential4WDataE, __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab16FastPropertyName8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z32Register_UnityEngine_WWW_get_urlv: __Z32Register_UnityEngine_WWW_get_urlv, __ZN15SerializeTraitsI11JointSpringE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI11JointSpringE8TransferI14SafeBinaryReadEEvRS0_RT_, __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_GetTreeInstancev: __Z62Register_UnityEngine_TerrainData_INTERNAL_CALL_GetTreeInstancev, __Z44Register_UnityEngine_GUIText_get_lineSpacingv: __Z44Register_UnityEngine_GUIText_get_lineSpacingv, __ZN17InternalIndexPoolC2Ej: __ZN17InternalIndexPoolC2Ej, __ZN5physx3Ext20DefaultCpuDispatcher13fetchNextTaskEv: __ZN5physx3Ext20DefaultCpuDispatcher13fetchNextTaskEv, __ZNKSt3__215__codecvt_utf16IDsLb1EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IDsLb1EE13do_max_lengthEv, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEE13stl_allocatorIS6_L18MemLabelIdentifier51ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN10builtintex17GetDefaultTextureE16TextureDimension: __ZN10builtintex17GetDefaultTextureE16TextureDimension, __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f: __ZN7Cursors17InitializeCursorsEP9Texture2D8Vector2f, __Z42Terrain_Set_Custom_PropHeightmapPixelErrorP12Il2CppObjectf: __Z42Terrain_Set_Custom_PropHeightmapPixelErrorP12Il2CppObjectf, __ZN5physx3Ext7D6Joint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext7D6Joint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __Z36TerrainData_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f: __Z36TerrainData_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f, __ZN14RotationModule16UpdateProceduralERK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4E: __ZN14RotationModule16UpdateProceduralERK19ParticleSystemStateR23ParticleSystemParticlesRKN4math7_float4E, __ZNSt3__212__deque_baseI10InputEventNS_9allocatorIS1_EEE5clearEv: __ZNSt3__212__deque_baseI10InputEventNS_9allocatorIS1_EEE5clearEv, __Z29RegisterModule_CrashReportingv: __Z29RegisterModule_CrashReportingv, _ftell_file_func: _ftell_file_func, __Z24GetAudioEffectDefinitionPKcPP29AudioEffectInternalDefinitioni: __Z24GetAudioEffectDefinitionPKcPP29AudioEffectInternalDefinitioni, __ZN7mecanim9animation16EvaluateAvatarDXEPKNS0_25ControllerBindingConstantEPKNS0_11AvatarInputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEPNS0_12AvatarOutputE: __ZN7mecanim9animation16EvaluateAvatarDXEPKNS0_25ControllerBindingConstantEPKNS0_11AvatarInputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEPNS0_12AvatarOutputE, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_, __ZN9profiling14SamplerManager17UnregisterSamplerEP19ProfilerInformation: __ZN9profiling14SamplerManager17UnregisterSamplerEP19ProfilerInformation, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj155ES2_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigEEEKNS_33PxClothStretchConfigGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj155ES2_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigEEEKNS_33PxClothStretchConfigGeneratedInfoEEEvPjRKT_RT0_, __ZN9JSONWrite8TransferI10Matrix4x4fEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI10Matrix4x4fEEvRT_PKc17TransferMetaFlags, __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE: __ZN5physx15PxVehicleUpdate10updatePostEPKNS_29PxVehicleConcurrentUpdateDataEjPPNS_15PxVehicleWheelsE, __ZNK6Camera26GetTypeInfoVirtualInternalEv: __ZNK6Camera26GetTypeInfoVirtualInternalEv, __ZN9Coroutine23ProcessCoroutineCurrentEv: __ZN9Coroutine23ProcessCoroutineCurrentEv, __ZN19CloudServiceHandler16StopEventHandlerEv: __ZN19CloudServiceHandler16StopEventHandlerEv, __ZN14AnimationState24SetWeightTargetImmediateEfb: __ZN14AnimationState24SetWeightTargetImmediateEfb, __ZN11TrailModule17UpdateStripLengthER23ParticleSystemParticles: __ZN11TrailModule17UpdateStripLengthER23ParticleSystemParticles, __Z45AnimationClip_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB: __Z45AnimationClip_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB, __ZN5physx14PxVehicleDrive4freeEv: __ZN5physx14PxVehicleDrive4freeEv, __Z30AndroidJNI_CUSTOM_SetLongField13Il2Cpp_IntPtrS_x: __Z30AndroidJNI_CUSTOM_SetLongField13Il2Cpp_IntPtrS_x, __Z30setPxSceneDescFilterShaderDataPN5physx11PxSceneDescEPKv: __Z30setPxSceneDescFilterShaderDataPN5physx11PxSceneDescEPKv, __Z53Register_UnityEngine_Hash128_Internal_Hash128ToStringv: __Z53Register_UnityEngine_Hash128_Internal_Hash128ToStringv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE2atEj, __Z49ParticleSystem_NoiseModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z49ParticleSystem_NoiseModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __ZN18BuoyancyEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE: __ZN18BuoyancyEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE, __Z28CalculateSubShaderIndexToUsePK6ShaderS1_ii: __Z28CalculateSubShaderIndexToUsePK6ShaderS1_ii, __ZN14RotationModuleD0Ev: __ZN14RotationModuleD0Ev, __Z51Register_UnityEngine_SystemInfo_get_supportsStencilv: __Z51Register_UnityEngine_SystemInfo_get_supportsStencilv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx3Cct13BoxController13getHalfHeightEv: __ZNK5physx3Cct13BoxController13getHalfHeightEv, __ZN15ConstantForce2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15ConstantForce2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN11HaloManager11RenderHalosEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f: __ZN11HaloManager11RenderHalosEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f, __Z10IsInvokingR13MonoBehaviour: __Z10IsInvokingR13MonoBehaviour, __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev: __ZN5physx36PxVehicleSuspensionDataGeneratedInfoC2Ev, _jsimd_idct_4x4: _jsimd_idct_4x4, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_, __Z59Register_UnityEngine_AudioLowPassFilter_set_cutoffFrequencyv: __Z59Register_UnityEngine_AudioLowPassFilter_set_cutoffFrequencyv, __ZN5Umbra9UnionFindIjE9unionSetsERKjS3_: __ZN5Umbra9UnionFindIjE9unionSetsERKjS3_, __ZN12CachedWriter11SetPositionEj: __ZN12CachedWriter11SetPositionEj, __ZNK12MeshRenderer26GetTypeInfoVirtualInternalEv: __ZNK12MeshRenderer26GetTypeInfoVirtualInternalEv, __ZNK23iPhoneLocalNotification14GetAlertActionEv: __ZNK23iPhoneLocalNotification14GetAlertActionEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj49ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z30Material_CUSTOM_SetOverrideTagP12Il2CppObjectP12Il2CppStringS2_: __Z30Material_CUSTOM_SetOverrideTagP12Il2CppObjectP12Il2CppStringS2_, __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI8Vector3fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN17CapsuleCollider2D16CapsuleDirectionEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN17CapsuleCollider2D16CapsuleDirectionEEvRT_RT0_PKc17TransferMetaFlags, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7__allocEv, __Z10CreateFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEii: __Z10CreateFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEii, __ZN11NavMeshData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11NavMeshData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN13ComputeShader13AwakeFromLoadE17AwakeFromLoadMode: __ZN13ComputeShader13AwakeFromLoadE17AwakeFromLoadMode, __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z34Object_CUSTOM_Internal_CloneSingleP12Il2CppObject: __Z34Object_CUSTOM_Internal_CloneSingleP12Il2CppObject, __Z24Animation_CUSTOM_AddClipP12Il2CppObjectS0_P12Il2CppStringiih: __Z24Animation_CUSTOM_AddClipP12Il2CppObjectS0_P12Il2CppStringiih, __ZThn28_N14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj: __ZThn28_N14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj, __ZN8PlayableD2Ev: __ZN8PlayableD2Ev, __ZN5physx8debugger4comm25BeginPropertyMessageGroupD0Ev: __ZN5physx8debugger4comm25BeginPropertyMessageGroupD0Ev, __Z48ParticleSystem_CollisionModule_CUSTOM_GetQualityP12Il2CppObject: __Z48ParticleSystem_CollisionModule_CUSTOM_GetQualityP12Il2CppObject, __ZN5Unity5Cloth8TransferI17RemapPPtrTransferEEvRT_: __ZN5Unity5Cloth8TransferI17RemapPPtrTransferEEvRT_, __ZN4HaloD2Ev: __ZN4HaloD2Ev, __Z27Event_Get_Custom_PropButtonP12Il2CppObject: __Z27Event_Get_Custom_PropButtonP12Il2CppObject, __ZN11ICallString5ClearEv: __ZN11ICallString5ClearEv, __ZN15b2FrictionJoint12SetMaxTorqueEf: __ZN15b2FrictionJoint12SetMaxTorqueEf, __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType: __ZN6Camera23GetBuiltinRenderTextureE24BuiltinRenderTextureType, __ZN13SpeedTreeWind13SetTreeValuesERK8Vector3ff: __ZN13SpeedTreeWind13SetTreeValuesERK8Vector3ff, __ZN4Halo12AddToManagerEv: __ZN4Halo12AddToManagerEv, __ZNKSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_: __ZNKSt3__23mapI8UnityStrS1_NS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S1_EEL18MemLabelIdentifier1ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_, __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetMultiplierv: __Z70Register_UnityEngine_ParticleSystem_ExternalForcesModule_GetMultiplierv, _wrap_write: _wrap_write, __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb: __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj567ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj567ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareEjjPKcj, __Z54Register_UnityEngine_Debug_set_developerConsoleVisiblev: __Z54Register_UnityEngine_Debug_set_developerConsoleVisiblev, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __ZN5physx2Sq12BucketPruner11preallocateEj: __ZN5physx2Sq12BucketPruner11preallocateEj, __Z52Register_UnityEngine_Animation_set_playAutomaticallyv: __Z52Register_UnityEngine_Animation_set_playAutomaticallyv, __ZN20TextRenderingPrivate8TextMesh5ResetEv: __ZN20TextRenderingPrivate8TextMesh5ResetEv, __ZN13RendererScene26ClearIntermediateRenderersEv: __ZN13RendererScene26ClearIntermediateRenderersEv, __Z47ConfigurableJoint_Set_Custom_PropAngularYMotionP12Il2CppObjecti: __Z47ConfigurableJoint_Set_Custom_PropAngularYMotionP12Il2CppObjecti, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyjEEyNS0_4HashIyEENS1_11HashMapBaseIyjS7_NS0_9AllocatorEE6GetKeyES9_Lb1EE15reserveInternalEj, __ZN25b2PolygonAndCircleContactD0Ev: __ZN25b2PolygonAndCircleContactD0Ev, __ZN19ClampVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E: __ZN19ClampVelocityModule6UpdateERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E, __Z58Register_UnityEngine_Collider2D_INTERNAL_CALL_OverlapPointv: __Z58Register_UnityEngine_Collider2D_INTERNAL_CALL_OverlapPointv, __Z13RegisterClassI10GUITextureEvv: __Z13RegisterClassI10GUITextureEvv, __Z13RegisterClassI14PlayerSettingsEvv: __Z13RegisterClassI14PlayerSettingsEvv, __ZN5physx2Sc27ConstraintProjectionManager29removeFromPendingGroupUpdatesERNS0_13ConstraintSimE: __ZN5physx2Sc27ConstraintProjectionManager29removeFromPendingGroupUpdatesERNS0_13ConstraintSimE, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZN16b2CapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN16b2CapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, _UNITY_FT_Init_Class_cff_cmap_encoding_class_rec: _UNITY_FT_Init_Class_cff_cmap_encoding_class_rec, __Z48Register_UnityEngine_AudioSource_set_rolloffModev: __Z48Register_UnityEngine_AudioSource_set_rolloffModev, _unity_z_inflatePrime: _unity_z_inflatePrime, __Z46Register_UnityEngine_BillboardAsset_set_bottomv: __Z46Register_UnityEngine_BillboardAsset_set_bottomv, __Z47ParticleSystem_CollisionModule_CUSTOM_SetDampenP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_CollisionModule_CUSTOM_SetDampenP12Il2CppObjectR15MonoMinMaxCurve, __ZN21DownloadHandlerScript17InvokeReceiveDataEP12Il2CppObjectP11Il2CppArrayi: __ZN21DownloadHandlerScript17InvokeReceiveDataEP12Il2CppObjectP11Il2CppArrayi, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __Z38AudioReverbZone_Set_Custom_PropDensityP12Il2CppObjectf: __Z38AudioReverbZone_Set_Custom_PropDensityP12Il2CppObjectf, __ZN13dynamic_arrayI28EnlightenRendererInformationLj8EE6insertEPS0_PKS0_S4_: __ZN13dynamic_arrayI28EnlightenRendererInformationLj8EE6insertEPS0_PKS0_S4_, __ZN7mecanim12statemachine27CreateSelectorStateConstantEPPNS0_26SelectorTransitionConstantEjjbRNS_6memory9AllocatorE: __ZN7mecanim12statemachine27CreateSelectorStateConstantEPPNS0_26SelectorTransitionConstantEjjbRNS_6memory9AllocatorE, __Z39setPxArticulation_SolverIterationCountsPN5physx14PxArticulationEjj: __Z39setPxArticulation_SolverIterationCountsPN5physx14PxArticulationEjj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj581ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj581ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI14SafeBinaryRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii: __ZN19SpriteMeshGenerator12path_segmentC2ENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii, __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st: __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_PvP11CUstream_st, __ZN12_GLOBAL__N_117ProfileZoneClientD0Ev: __ZN12_GLOBAL__N_117ProfileZoneClientD0Ev, __Z14NetworkCleanupv: __Z14NetworkCleanupv, __Z60Register_UnityEngine_ShaderVariantCollection_Internal_Createv: __Z60Register_UnityEngine_ShaderVariantCollection_Internal_Createv, __Z21SetGyroUpdateIntervalif: __Z21SetGyroUpdateIntervalif, __ZNK5Umbra18ImpOcclusionBuffer9dumpFloatEPfRKNS_15OcclusionBuffer10BufferDescE: __ZNK5Umbra18ImpOcclusionBuffer9dumpFloatEPfRKNS_15OcclusionBuffer10BufferDescE, __ZN21AssetBundleFileSystem19InitializeFileEntryER13FileEntryData: __ZN21AssetBundleFileSystem19InitializeFileEntryER13FileEntryData, __ZN11TrailModule8TransferI17RemapPPtrTransferEEvRT_: __ZN11TrailModule8TransferI17RemapPPtrTransferEEvRT_, __Z23InitPlayerLoopCallbacksv: __Z23InitPlayerLoopCallbacksv, __ZN16SubstanceArchive23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16SubstanceArchive23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwi: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwi, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwRKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EPKwRKS4_, __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f: __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_8CapsuleVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f, __Z29GUIText_Get_Custom_PropAnchorP12Il2CppObject: __Z29GUIText_Get_Custom_PropAnchorP12Il2CppObject, __ZN8Animator7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8Animator7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sc18ParticleSystemCore12setViscosityEf: __ZN5physx2Sc18ParticleSystemCore12setViscosityEf, __ZN5physx3Ext14SphericalJointD0Ev: __ZN5physx3Ext14SphericalJointD0Ev, __Z29setPxRigidDynamic_WakeCounterPN5physx14PxRigidDynamicEf: __Z29setPxRigidDynamic_WakeCounterPN5physx14PxRigidDynamicEf, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10ColorRGBAfLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN10Matrix3x3f9TransposeEv: __ZN10Matrix3x3f9TransposeEv, __ZN5physx2Sn9XmlParser12processCloseEPKcjRb: __ZN5physx2Sn9XmlParser12processCloseEPKcjRb, __ZN6b2Rope7SolveC3Ev: __ZN6b2Rope7SolveC3Ev, __Z54Register_UnityEngine_AI_NavMeshPath_DestroyNavMeshPathv: __Z54Register_UnityEngine_AI_NavMeshPath_DestroyNavMeshPathv, __Z48ExtractUmbraCameraTransformFromCullingParametersRK17CullingParametersRN5Umbra15CameraTransformE: __Z48ExtractUmbraCameraTransformFromCullingParametersRK17CullingParametersRN5Umbra15CameraTransformE, __ZN5physx2Sc21ArticulationJointCore20setTargetOrientationERKNS_6PxQuatE: __ZN5physx2Sc21ArticulationJointCore20setTargetOrientationERKNS_6PxQuatE, __ZN5physx3Cct26CharacterControllerManager16purgeControllersEv: __ZN5physx3Cct26CharacterControllerManager16purgeControllersEv, __ZN11UmbraModule18AllocateVisibilityEPKN5Umbra4TomeEPiRK10MemLabelId: __ZN11UmbraModule18AllocateVisibilityEPKN5Umbra4TomeEPiRK10MemLabelId, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __ZNK13CameraLODData17HasNotBeenUsedForEf: __ZNK13CameraLODData17HasNotBeenUsedForEf, __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20ParticleSystemModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26vectorINS_4pairIxN14SerializedFile10ObjectInfoEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_: __ZNSt3__26vectorINS_4pairIxN14SerializedFile10ObjectInfoEEENS_9allocatorIS4_EEE21__push_back_slow_pathIKS4_EEvRT_, __Z34GameObject_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i: __Z34GameObject_CUSTOM_BroadcastMessageP12Il2CppObjectP12Il2CppStringS0_i, __ZNKSt3__210moneypunctIcLb1EE11curr_symbolEv: __ZNKSt3__210moneypunctIcLb1EE11curr_symbolEv, __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE: __ZNK13TranslateGLES17MemoryBarrierBitsEN2gl17MemoryBarrierTypeE, __Z59Register_UnityEngine_Sprite_get_associatedAlphaSplitTexturev: __Z59Register_UnityEngine_Sprite_get_associatedAlphaSplitTexturev, _log10f: _log10f, __ZN14PlayerSettingsD0Ev: __ZN14PlayerSettingsD0Ev, __GLOBAL__sub_I_runtime_graphics6_lump_cpp: __GLOBAL__sub_I_runtime_graphics6_lump_cpp, __Z46Register_UnityEngine_AndroidJNI_CallCharMethodv: __Z46Register_UnityEngine_AndroidJNI_CallCharMethodv, __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj: __ZN5physx2Sq12AABBTreeNode15_buildHierarchyEPNS0_15AABBTreeBuilderEPj, __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf, __ZNK5physx11NpAggregate9getActorsEPPNS_7PxActorEjj: __ZNK5physx11NpAggregate9getActorsEPPNS_7PxActorEjj, __ZN5Umbra10PortalInfoaSERKS0_: __ZN5Umbra10PortalInfoaSERKS0_, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_24ShrunkConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh, __Z20IsValidTextureFormat13TextureFormat: __Z20IsValidTextureFormat13TextureFormat, __ZN5physx17NodeChangeManager4initEj: __ZN5physx17NodeChangeManager4initEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj396ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxClothTetherConfigEEEEclILj396ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx17PxcNpMemBlockPool20getMaxUsedBlockCountEv: __ZNK5physx17PxcNpMemBlockPool20getMaxUsedBlockCountEv, __Z39getPxPrismaticJoint_PrismaticJointFlagsPKN5physx16PxPrismaticJointE: __Z39getPxPrismaticJoint_PrismaticJointFlagsPKN5physx16PxPrismaticJointE, __Z13UpdatePathJobP9CrowdInfoj: __Z13UpdatePathJobP9CrowdInfoj, __ZN12_GLOBAL__N_120DistanceJointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_120DistanceJointProjectEPKvRN5physx11PxTransformES4_b, __ZN11AudioSource11PlayOneShotER9AudioClipf: __ZN11AudioSource11PlayOneShotER9AudioClipf, __Z24RegisterStrippedTypeInfoI13SliderJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI13SliderJoint2DEviPKcS2_, __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawIconv: __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawIconv, __Z9SetIAudioP6IAudio: __Z9SetIAudioP6IAudio, __ZN2UI13RectTransform15GetLocalCornersERA4_8Vector3f: __ZN2UI13RectTransform15GetLocalCornersERA4_8Vector3f, __Z33MonoBehaviour_CUSTOM_CancelInvokeP12Il2CppObjectP12Il2CppString: __Z33MonoBehaviour_CUSTOM_CancelInvokeP12Il2CppObjectP12Il2CppString, __ZN5IMGUI19NamedKeyControlList16GetNameOfControlEi: __ZN5IMGUI19NamedKeyControlList16GetNameOfControlEi, __ZNK15FileSystemEntry6TargetERS_: __ZNK15FileSystemEntry6TargetERS_, __ZN4Mesh11SetVerticesEPK8Vector3fj: __ZN4Mesh11SetVerticesEPK8Vector3fj, __ZN5physx14NpArticulationD2Ev: __ZN5physx14NpArticulationD2Ev, __ZN12GraphicsCaps25CleanupGraphicsCapsMemoryEv: __ZN12GraphicsCaps25CleanupGraphicsCapsMemoryEv, __ZN18UnityPropertySheet20AddNewShaderlabPropsERK19ShaderPropertySheet: __ZN18UnityPropertySheet20AddNewShaderlabPropsERK19ShaderPropertySheet, __ZNK15MonoScriptCache8RefCountEv: __ZNK15MonoScriptCache8RefCountEv, __Z24RegisterStrippedTypeInfoI23CloudWebServicesManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI23CloudWebServicesManagerEviPKcS2_, __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15AudioMixerGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_17ShrunkConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh, __Z18Transfer_BlittableI8JSONReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_png_read_IDAT_data: _UNITY_png_read_IDAT_data, __ZN5Unity10HingeJointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity10HingeJointC2E10MemLabelId18ObjectCreationMode, __Z48Renderer_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f: __Z48Renderer_CUSTOM_INTERNAL_set_lightmapScaleOffsetP12Il2CppObjectRK8Vector4f, __ZN5physx19PxsSimObjectFactoryC2Ev: __ZN5physx19PxsSimObjectFactoryC2Ev, __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN11AssetBundle12GetPathRangeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN6Camera17MainThreadCleanupEv: __ZN6Camera17MainThreadCleanupEv, __ZN20OcclusionCullingData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20OcclusionCullingData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13WheelCollider26AddWheelToRecreatedVehicleEP9Rigidbody: __ZN13WheelCollider26AddWheelToRecreatedVehicleEP9Rigidbody, _iswlower: _iswlower, __Z48Register_UnityEngine_AudioSource_set_playOnAwakev: __Z48Register_UnityEngine_AudioSource_set_playOnAwakev, __ZN8Animator28CreateStateMachineBehavioursEv: __ZN8Animator28CreateStateMachineBehavioursEv, __ZNK12AudioManager11GetCPUUsageEv: __ZNK12AudioManager11GetCPUUsageEv, __ZN9Rigidbody21SetMaxAngularVelocityEf: __ZN9Rigidbody21SetMaxAngularVelocityEf, __Z16setPxShape_FlagsPN5physx7PxShapeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __Z16setPxShape_FlagsPN5physx7PxShapeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __ZN20HardwareInfoReporterD2Ev: __ZN20HardwareInfoReporterD2Ev, __ZNK13b2CircleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi: __ZNK13b2CircleShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi, __ZN5Unity5Joint13SetBreakForceEf: __ZN5Unity5Joint13SetBreakForceEf, __ZN5physx19PxsFluidSpatialHashC2Ejfjb: __ZN5physx19PxsFluidSpatialHashC2Ejfjb, __ZL22Transfer_ManagedObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE12getAggregateEv, __ZN19AudioHighPassFilter5ResetEv: __ZN19AudioHighPassFilter5ResetEv, _inflate_table: _inflate_table, __ZN5physx36createFinalizeSolverContacts4CoulombEPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE: __ZN5physx36createFinalizeSolverContacts4CoulombEPPNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPPNS_23PxcSolverConstraintDescEPPKNS_13PxcSolverBodyESB_PPKNS_17PxcSolverBodyDataESF_PPKNS_12PxsRigidCoreESJ_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE, __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Light23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx3Cct17CapsuleController16getContactOffsetEv: __ZNK5physx3Cct17CapsuleController16getContactOffsetEv, __Z38AnimationClip_Get_Custom_PropStartTimeP12Il2CppObject: __Z38AnimationClip_Get_Custom_PropStartTimeP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv, __ZN21AnimationClipPlayable7SetClipEP13AnimationClip: __ZN21AnimationClipPlayable7SetClipEP13AnimationClip, __ZN16ParticleAnimator8TransferI14SafeBinaryReadEEvRT_: __ZN16ParticleAnimator8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIeeEEPeEEjT0_S5_S5_S5_T_, __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaRotationv: __Z56Register_UnityEngine_Animator_INTERNAL_get_deltaRotationv, __ZN13BuildSettingsD2Ev: __ZN13BuildSettingsD2Ev, __Z52Register_UnityEngine_AndroidJNI_GetStaticStringFieldv: __Z52Register_UnityEngine_AndroidJNI_GetStaticStringFieldv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIxLj8EEEEvRT_17TransferMetaFlags, __ZN9GfxDevice21CommonReloadResourcesEj: __ZN9GfxDevice21CommonReloadResourcesEj, __ZNKSt3__27codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_: __ZNKSt3__27codecvtIDsc11__mbstate_tE6do_outERS1_PKDsS5_RS5_PcS7_RS7_, __ZNK14PhysicMaterial14InitPxMaterialEPN5physx10PxMaterialE: __ZNK14PhysicMaterial14InitPxMaterialEPN5physx10PxMaterialE, __Z50Register_UnityEngine_ParticleEmitter_get_maxEnergyv: __Z50Register_UnityEngine_ParticleEmitter_get_maxEnergyv, __ZN5physx17PxStringTableImpl7releaseEv: __ZN5physx17PxStringTableImpl7releaseEv, __Z46Register_UnityEngine_LineRenderer_set_endWidthv: __Z46Register_UnityEngine_LineRenderer_set_endWidthv, __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN24iPhoneRemoteNotification15GetEnabledTypesEv: __ZN24iPhoneRemoteNotification15GetEnabledTypesEv, __ZN20TextRenderingPrivate8FontImpl16SetupDynamicFontEv: __ZN20TextRenderingPrivate8FontImpl16SetupDynamicFontEv, __ZNK9Texture2D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK9Texture2D16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __ZNSt3__211char_traitsIwE7compareEPKwS3_j: __ZNSt3__211char_traitsIwE7compareEPKwS3_j, __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE: __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_11PxTransformE, __Z23InternalStringGeneratorRN20TextRenderingPrivate19NativeTextGeneratorEbPj: __Z23InternalStringGeneratorRN20TextRenderingPrivate19NativeTextGeneratorEbPj, __Z33setPxParticleBase_DynamicFrictionPN5physx14PxParticleBaseEf: __Z33setPxParticleBase_DynamicFrictionPN5physx14PxParticleBaseEf, __ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__212_GLOBAL__N_129throw_from_string_invalid_argERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj292ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z25JsonUtility_CUSTOM_ToJsonP12Il2CppObjecth: __Z25JsonUtility_CUSTOM_ToJsonP12Il2CppObjecth, __ZNK5Umbra9Matrix3x311getMaxScaleEv: __ZNK5Umbra9Matrix3x311getMaxScaleEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5gbumpEi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5gbumpEi, __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17AnimationCurveTplIfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z31Object_Set_Custom_PropHideFlagsP12Il2CppObjecti: __Z31Object_Set_Custom_PropHideFlagsP12Il2CppObjecti, __ZN17CapsuleCollider2D14CreateInternalEP11Rigidbody2D: __ZN17CapsuleCollider2D14CreateInternalEP11Rigidbody2D, __ZN13EmscriptenWWW7GetDataEv: __ZN13EmscriptenWWW7GetDataEv, __ZN5physx2Gu20pcmContactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu20pcmContactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z46Terrain_Set_Custom_PropTreeMaximumFullLODCountP12Il2CppObjecti: __Z46Terrain_Set_Custom_PropTreeMaximumFullLODCountP12Il2CppObjecti, _dgettext: _dgettext, __ZN7Texture12CleanupClassEv: __ZN7Texture12CleanupClassEv, __Z43AudioReverbZone_Set_Custom_PropDecayHFRatioP12Il2CppObjectf: __Z43AudioReverbZone_Set_Custom_PropDecayHFRatioP12Il2CppObjectf, __Z48Register_UnityEngine_ParticleEmitter_set_maxSizev: __Z48Register_UnityEngine_ParticleEmitter_set_maxSizev, __Z46ParticleAnimator_Get_Custom_PropColorAnimationP12Il2CppObject: __Z46ParticleAnimator_Get_Custom_PropColorAnimationP12Il2CppObject, __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEvT0_SB_T_, __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EEPKS6_RKS9_: __ZNSt3__2plIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_12basic_stringIT_T0_T1_EEPKS6_RKS9_, __Z25GetNbDiscreteContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_: __Z25GetNbDiscreteContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_, __ZN5physx15PxSerialization14isSerializableERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_: __ZN5physx15PxSerialization14isSerializableERNS_12PxCollectionERNS_23PxSerializationRegistryEPKS1_, _UNITY_ft_raster1_renderer_class_pic_init: _UNITY_ft_raster1_renderer_class_pic_init, __Z61Register_UnityEngine_MeshRenderer_set_additionalVertexStreamsv: __Z61Register_UnityEngine_MeshRenderer_set_additionalVertexStreamsv, __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE7reserveEj: __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE7reserveEj, __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __ZN5physx2Gu20pcmContactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu20pcmContactSphereMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN20OcclusionCullingData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20OcclusionCullingData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf: __ZN5physx13integrateCoreERNS_11PxsBodyCoreERNS_12PxsRigidBodyERNS_2Cm13SpatialVectorEf, __Z36BoxCollider_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f: __Z36BoxCollider_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f, __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8Collider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN12HeaderHelperC2ERKS_: __ZN12HeaderHelperC2ERKS_, __Z25setPxMaterial_RestitutionPN5physx10PxMaterialEf: __Z25setPxMaterial_RestitutionPN5physx10PxMaterialEf, ___fwritex: ___fwritex, __Z43Register_UnityEngine_GUIStyle_set_fontStylev: __Z43Register_UnityEngine_GUIStyle_set_fontStylev, __ZN5physx17collideWithSphereEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf: __ZN5physx17collideWithSphereEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf, __Z61getPxVehicleTireData_RecipLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE: __Z61getPxVehicleTireData_RecipLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE, __Z37Texture2D_Get_Custom_PropWhiteTexturev: __Z37Texture2D_Get_Custom_PropWhiteTexturev, __ZN4Mesh8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4Mesh8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf, __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN16RayRTreeCallbackILi1ELb1EED2Ev: __ZN16RayRTreeCallbackILi1ELb1EED2Ev, __Z39AudioSource_Set_Custom_PropSpatialBlendP12Il2CppObjectf: __Z39AudioSource_Set_Custom_PropSpatialBlendP12Il2CppObjectf, __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E14find_or_insertIS2_S4_EEvRPT0_RKT_: __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E14find_or_insertIS2_S4_EEvRPT0_RKT_, __ZNK12CubemapArray26GetTypeInfoVirtualInternalEv: __ZNK12CubemapArray26GetTypeInfoVirtualInternalEv, _zipOpenNewFileInZip: _zipOpenNewFileInZip, __ZN11UnityEngine15CloudWebService17CloudJobScheduler10InitializeEv: __ZN11UnityEngine15CloudWebService17CloudJobScheduler10InitializeEv, __Z45Register_UnityEngine_AudioReverbZone_get_roomv: __Z45Register_UnityEngine_AudioReverbZone_get_roomv, __Z48Register_UnityEngine_ParticleSystem_SetParticlesv: __Z48Register_UnityEngine_ParticleSystem_SetParticlesv, __Z24InitializeGUIClipTexturev: __Z24InitializeGUIClipTexturev, __ZN23CloudWebServicesManager25RemoveCloudServiceHandlerEP19CloudServiceHandler: __ZN23CloudWebServicesManager25RemoveCloudServiceHandlerEP19CloudServiceHandler, __ZN11UnityEngine9Animation15IsTransformTypeEi: __ZN11UnityEngine9Animation15IsTransformTypeEi, _strncasecmp: _strncasecmp, __ZN12MeshColliderD0Ev: __ZN12MeshColliderD0Ev, __ZN11UnityEngine15CloudWebService16SessionContainer18DeleteArchivedFileERK8UnityStrS4_Rb: __ZN11UnityEngine15CloudWebService16SessionContainer18DeleteArchivedFileERK8UnityStrS4_Rb, __ZNK20TextRenderingPrivate7GUIText7GetFontEv: __ZNK20TextRenderingPrivate7GUIText7GetFontEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z23scripting_thread_detachP12Il2CppThread: __Z23scripting_thread_detachP12Il2CppThread, __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK8Material32AcquireSharedMaterialDataFromJobEv: __ZNK8Material32AcquireSharedMaterialDataFromJobEv, _UNITY_FT_Hypot: _UNITY_FT_Hypot, __Z19AppendTransformPathR8UnityStrPKc: __Z19AppendTransformPathR8UnityStrPKc, _UnityReplayKitIsMicrophoneEnabled: _UnityReplayKitIsMicrophoneEnabled, __ZN8Animator5IKJobEPPS_j: __ZN8Animator5IKJobEPPS_j, _UNITY_FT_Init_Class_tt_cmap4_class_rec: _UNITY_FT_Init_Class_tt_cmap4_class_rec, __Z23scripting_type_get_typePK10Il2CppType: __Z23scripting_type_get_typePK10Il2CppType, _ilogb: _ilogb, __ZL14SweepBoxSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL14SweepBoxSpherePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __Z48Register_UnityEngine_Graphics_CopyTexture_Regionv: __Z48Register_UnityEngine_Graphics_CopyTexture_Regionv, _basename: _basename, __ZN15TerrainRenderer17CalculateEdgeMaskER12QuadTreeNode: __ZN15TerrainRenderer17CalculateEdgeMaskER12QuadTreeNode, __Z58ParticleSystem_ShapeModule_CUSTOM_SetRandomDirectionAmountP12Il2CppObjectf: __Z58ParticleSystem_ShapeModule_CUSTOM_SetRandomDirectionAmountP12Il2CppObjectf, __ZN9GfxDevice18AliasRenderSurfaceE9TextureIDP17RenderSurfaceBase: __ZN9GfxDevice18AliasRenderSurfaceE9TextureIDP17RenderSurfaceBase, __ZN13TriggerModule5ResetEv: __ZN13TriggerModule5ResetEv, __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_18PxVehicleWheelDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZNSt3__218__insertion_sort_3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEvT0_S6_T_, __ZN26PlayerSettingsSplashScreen37GetSplashScreenBackgroundLandscapeUvsEv: __ZN26PlayerSettingsSplashScreen37GetSplashScreenBackgroundLandscapeUvsEv, __ZNK13b2PulleyJoint10GetAnchorBEv: __ZNK13b2PulleyJoint10GetAnchorBEv, __ZNK19SkinnedMeshRenderer16GetBindposeCountEv: __ZNK19SkinnedMeshRenderer16GetBindposeCountEv, _unzGoToFilePos: _unzGoToFilePos, __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE: __ZN11UnityEngine15CloudWebService14DataDispatcher20OnRestDownloaderDoneERNS0_14RestDownloaderE, __Z34CalculateTriangleAreaRadialFrustumP8Vector3fffff: __Z34CalculateTriangleAreaRadialFrustumP8Vector3fffff, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_, __ZN17PrePassRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDS3_RS3_RK8Vector4fRK14LightingLayersR10MinMaxAABBb: __ZN17PrePassRenderLoop14RenderLightingER21ActiveLightingContextP13RenderTexture9TextureIDS3_RS3_RK8Vector4fRK14LightingLayersR10MinMaxAABBb, __ZN13BaseAllocator14CheckIntegrityEv: __ZN13BaseAllocator14CheckIntegrityEv, _ftell: _ftell, __ZN4Tree23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN4Tree23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z57ParticleSystemRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf: __Z57ParticleSystemRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf, __ZN14VehiclesModule14UpdateVehiclesEf: __ZN14VehiclesModule14UpdateVehiclesEf, __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj, __ZN14MessageHandler16ResolveCallbacksEv: __ZN14MessageHandler16ResolveCallbacksEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags, _UNITY_png_set_mem_fn: _UNITY_png_set_mem_fn, __Z49Register_UnityEngine_AndroidJNI_SetStaticIntFieldv: __Z49Register_UnityEngine_AndroidJNI_SetStaticIntFieldv, __ZN9Texture2D19UnloadFromGfxDeviceEb: __ZN9Texture2D19UnloadFromGfxDeviceEb, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E9copy_fromERKSH_j, __ZN4PPtrI11NavMeshDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI11NavMeshDataE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ESt16initializer_listIwE, __ZN15QualitySettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN15QualitySettings23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv: __ZN24OptimizedPolynomialCurve15DoubleIntegrateEv, __ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf: __ZNK5physx13NpVolumeCache10multiQueryINS_12PxOverlapHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf, __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetShapeTypev: __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetShapeTypev, __Z41setPxVehicleSuspensionDataMMaxCompressionPN5physx23PxVehicleSuspensionDataEf: __Z41setPxVehicleSuspensionDataMMaxCompressionPN5physx23PxVehicleSuspensionDataEf, __ZNSt3__215messages_bynameIwED2Ev: __ZNSt3__215messages_bynameIwED2Ev, __ZN8Material15BuildPropertiesEv: __ZN8Material15BuildPropertiesEv, _strtold_l: _strtold_l, __ZN14ParticleSystem13KillParticlesILb1EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj: __ZN14ParticleSystem13KillParticlesILb1EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj, __ZNK5physx2Cm10Collection12getNbObjectsEv: __ZNK5physx2Cm10Collection12getNbObjectsEv, __ZN13EmscriptenWWW17UnlockPartialDataEv: __ZN13EmscriptenWWW17UnlockPartialDataEv, __Z55Register_UnityEngine_AudioReverbFilter_get_reverbPresetv: __Z55Register_UnityEngine_AudioReverbFilter_get_reverbPresetv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRS3_S4_E: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPFRS3_S4_E, __GLOBAL__sub_I_runtime_camera3_lump_cpp: __GLOBAL__sub_I_runtime_camera3_lump_cpp, __ZN12_GLOBAL__N_113SetBlendStateER7ApiGLESR15DeviceStateGLESPK20DeviceBlendStateGLESi: __ZN12_GLOBAL__N_113SetBlendStateER7ApiGLESR15DeviceStateGLESPK20DeviceBlendStateGLESi, __ZN5Umbra15PortalRayTracer7executeERNS_16VisibilityResultE: __ZN5Umbra15PortalRayTracer7executeERNS_16VisibilityResultE, _iswxdigit: _iswxdigit, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI10vector_mapINSt3__24pairIttEEfN20TextRenderingPrivate8FontImpl14KerningCompareENS3_9allocatorINS4_IS5_fEEEEEEEvRT_17TransferMetaFlags, __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VE, __GLOBAL__sub_I_VRGfxHelpers_cpp: __GLOBAL__sub_I_VRGfxHelpers_cpp, __Z35setPxParticleReadDataVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE: __Z35setPxParticleReadDataVelocityBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE, __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6StringEPKcjb: __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6StringEPKcjb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEE14handleAccessorILj279ENS_22PxRepXPropertyAccessorILj279ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxTriangleMeshGeometryEEEE14handleAccessorILj279ENS_22PxRepXPropertyAccessorILj279ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_, __ZN12TreeDatabase8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12TreeDatabase8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18ProceduralMaterial9SetPresetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18ProceduralMaterial9SetPresetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5Unity10HingeJoint6CreateEv: __ZN5Unity10HingeJoint6CreateEv, __ZN5physx7NpScene16createBatchQueryERKNS_16PxBatchQueryDescE: __ZN5physx7NpScene16createBatchQueryERKNS_16PxBatchQueryDescE, __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE8recreateEj, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getParentClassEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getParentClassEN5physx8debugger18NonNegativeIntegerE, __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI14SafeBinaryReadEEvRT_: __ZN11UnityEngine9Animation28AnimationClipBindingConstant8TransferI14SafeBinaryReadEEvRT_, __Z44Register_UnityEngine_Animator_SetFloatIDDampv: __Z44Register_UnityEngine_Animator_SetFloatIDDampv, __ZN8IRaycastD2Ev: __ZN8IRaycastD2Ev, __ZN20UnityConnectSettings16SetTestConfigUrlE8UnityStr: __ZN20UnityConnectSettings16SetTestConfigUrlE8UnityStr, __Z24RegisterStrippedTypeInfoI7CubemapEviPKcS2_: __Z24RegisterStrippedTypeInfoI7CubemapEviPKcS2_, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl6addRefEv: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl6addRefEv, __ZN26AnimatorOverrideController11ManualDirtyEv: __ZN26AnimatorOverrideController11ManualDirtyEv, __ZN9Rigidbody10SetDensityEf: __ZN9Rigidbody10SetDensityEf, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_AllocObjectv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_AllocObjectv, _UNITY_FT_Init_Class_ft_bitmap_glyph_class: _UNITY_FT_Init_Class_ft_bitmap_glyph_class, _mktemp: _mktemp, __ZN12TreeDatabase9Prototype11SetMaterialEiP8Material: __ZN12TreeDatabase9Prototype11SetMaterialEiP8Material, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE12getClassSizeEv, __ZNK20TextRenderingPrivate7GUIText26GetTypeInfoVirtualInternalEv: __ZNK20TextRenderingPrivate7GUIText26GetTypeInfoVirtualInternalEv, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEEEvT_S5_T0_T1_, __ZN10Matrix4x4f12SetTranslateERK8Vector3f: __ZN10Matrix4x4f12SetTranslateERK8Vector3f, __ZNSt3__26__sortIRNS_6__lessIeeEEPeEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIeeEEPeEEvT0_S5_T_, __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN4Tree23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK13b2PulleyJoint17GetCurrentLengthAEv: __ZNK13b2PulleyJoint17GetCurrentLengthAEv, __Z62Register_UnityEngine_QualitySettings_set_shadowNearPlaneOffsetv: __Z62Register_UnityEngine_QualitySettings_set_shadowNearPlaneOffsetv, __Z56Register_UnityEngine_Analytics_CustomEventData_AddStringv: __Z56Register_UnityEngine_Analytics_CustomEventData_AddStringv, __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI12MeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z36getPxJointLimitParametersRestitutionPKN5physx22PxJointLimitParametersE: __Z36getPxJointLimitParametersRestitutionPKN5physx22PxJointLimitParametersE, __Z28BlitCopyCompressedDXT1ToDXT5PKhiiPhii: __Z28BlitCopyCompressedDXT1ToDXT5PKhiiPhii, __Z41Register_UnityEngine_Input_GetKeyUpStringv: __Z41Register_UnityEngine_Input_GetKeyUpStringv, __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE: __ZNSt3__218__time_get_storageIcE9__analyzeEcRKNS_5ctypeIcEE, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_, __ZNK11b2RopeJoint10GetAnchorBEv: __ZNK11b2RopeJoint10GetAnchorBEv, __ZN12FlareManager8AddFlareEv: __ZN12FlareManager8AddFlareEv, __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier: __ZN25RuntimeAnimatorController17NotifyObjectUsersERK17MessageIdentifier, __Z56Register_UnityEngine_ShaderVariantCollection_AddInternalv: __Z56Register_UnityEngine_ShaderVariantCollection_AddInternalv, __ZN12MeshCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12MeshCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _t2_hints_funcs_init: _t2_hints_funcs_init, __Z40VRSettings_Get_Custom_PropIsDeviceActivev: __Z40VRSettings_Get_Custom_PropIsDeviceActivev, __Z43ReflectionProbe_Get_Custom_PropBakedTextureP12Il2CppObject: __Z43ReflectionProbe_Get_Custom_PropBakedTextureP12Il2CppObject, __ZN6Object7SetNameEPKc: __ZN6Object7SetNameEPKc, __ZN13InitialModule13StartExternalERK27ParticleSystemReadOnlyStateRK23ParticleSystemParticlesRK10Matrix4x4fRK24ParticleSystemEmitParamsP22ParticleSystemParticlej: __ZN13InitialModule13StartExternalERK27ParticleSystemReadOnlyStateRK23ParticleSystemParticlesRK10Matrix4x4fRK24ParticleSystemEmitParamsP22ParticleSystemParticlej, __ZNK13WebCamTexture22GetBufferTextureFormatEv: __ZNK13WebCamTexture22GetBufferTextureFormatEv, __ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib: __ZNK14b2PolygonShape11ComputeAABBEP6b2AABBRK11b2Transformib, __ZL42GeomOverlapCallback_HeightfieldHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL42GeomOverlapCallback_HeightfieldHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN5physx7NpShape15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx7NpShape15exportExtraDataERNS_22PxSerializationContextE, __ZN5physx3Ext14computeBoxMassERKNS_6PxVec3Ef: __ZN5physx3Ext14computeBoxMassERKNS_6PxVec3Ef, __ZN8Remapper14SetupRemappingEiRK26SerializedObjectIdentifier: __ZN8Remapper14SetupRemappingEiRK26SerializedObjectIdentifier, __ZNSt3__210to_wstringEi: __ZNSt3__210to_wstringEi, __ZNSt3__210to_wstringEj: __ZNSt3__210to_wstringEj, __Z43Register_UnityEngine_Input_get_mousePresentv: __Z43Register_UnityEngine_Input_get_mousePresentv, __ZNSt3__210to_wstringEm: __ZNSt3__210to_wstringEm, __Z46ComputeShader_CUSTOM_GetKernelThreadGroupSizesP12Il2CppObjectiPjS1_S1_: __Z46ComputeShader_CUSTOM_GetKernelThreadGroupSizesP12Il2CppObjectiPjS1_S1_, _unity_z_inflateBack: _unity_z_inflateBack, __ZNSt3__210to_wstringEe: __ZNSt3__210to_wstringEe, __ZN25CapsuleTraceSegmentReport7onEventEjPj: __ZN25CapsuleTraceSegmentReport7onEventEjPj, __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalAbortv: __Z61Register_UnityEngine_Networking_UnityWebRequest_InternalAbortv, __ZNSt3__210to_wstringEx: __ZNSt3__210to_wstringEx, __ZNSt3__210to_wstringEy: __ZNSt3__210to_wstringEy, __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc16ActorElementPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE: __ZN2UI13RectTransform25UpdatePosAndRectRecursiveEbPK5RectTIfE, __ZN4FMOD5Sound8readDataEPvjPj: __ZN4FMOD5Sound8readDataEPvjPj, __ZN4FMOD13ChannelGroupI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD13ChannelGroupI6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, __ZN17MessageIdentifier16StaticInitializeEPv: __ZN17MessageIdentifier16StaticInitializeEPv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN17AnimationCurveTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_: __ZN17AnimationCurveTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_, __Z58Register_UnityEngine_Cloth_INTERNAL_set_randomAccelerationv: __Z58Register_UnityEngine_Cloth_INTERNAL_set_randomAccelerationv, __ZN5physx14SingleAABBTaskD0Ev: __ZN5physx14SingleAABBTaskD0Ev, __Z14OptionalMethodPKcS0_S0_S0_: __Z14OptionalMethodPKcS0_S0_S0_, __ZL28removeBrokenEdgesFromIslandsPKjjS0_jS0_RKN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerERNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEEPSD_: __ZL28removeBrokenEdgesFromIslandsPKjjS0_jS0_RKN5physx11NodeManagerERNS1_11EdgeManagerERNS1_13IslandManagerERNS1_2Cm10BitMapBaseINS1_6shdfnd9AllocatorEEEPSD_, __ZN12LightmapData8TransferI14SafeBinaryReadEEvRT_: __ZN12LightmapData8TransferI14SafeBinaryReadEEvRT_, __ZN5physx21PxShapeRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxShapeRepXSerializer14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN15AudioEchoFilter12AddToManagerEv: __ZN15AudioEchoFilter12AddToManagerEv, __ZN5Unity17ConfigurableJoint9SetYDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint9SetYDriveERK10JointDrive, __ZN5physx8debugger14PvdMarshallingIaxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIaxE12marshalBlockEPKhPhj, __ZN15UnityAdsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15UnityAdsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z25CheckBatchModeErrorStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z25CheckBatchModeErrorStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN11PreloadData15ThreadedCleanupEv: __ZN11PreloadData15ThreadedCleanupEv, __Z52Register_UnityEngine_HingeJoint2D_get_referenceAnglev: __Z52Register_UnityEngine_HingeJoint2D_get_referenceAnglev, __ZN9Transform23UpdateAllChildrenOrdersEv: __ZN9Transform23UpdateAllChildrenOrdersEv, __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEED0Ev, _UNITY_FT_Matrix_Invert: _UNITY_FT_Matrix_Invert, __Z69Register_UnityEngine_Connect_UnityAdsSettings_get_initializeOnStartupv: __Z69Register_UnityEngine_Connect_UnityAdsSettings_get_initializeOnStartupv, __ZNK12NavMeshAgent27GetEndPositionOfCurrentPathEv: __ZNK12NavMeshAgent27GetEndPositionOfCurrentPathEv, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEPNS_15basic_streambufIwS2_EE, __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetRandomizedv: __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetRandomizedv, __ZN16LightmapSettings24SetEnlightenSceneMappingERK21EnlightenSceneMapping: __ZN16LightmapSettings24SetEnlightenSceneMappingERK21EnlightenSceneMapping, __Z45WheelCollider_CUSTOM_ConfigureVehicleSubstepsP12Il2CppObjectfii: __Z45WheelCollider_CUSTOM_ConfigureVehicleSubstepsP12Il2CppObjectfii, __ZN8WindZone23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8WindZone23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN19AudioHighPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN19AudioHighPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN10InputEventC2ERKS_: __ZN10InputEventC2ERKS_, __ZNSt3__215__time_get_tempIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__215__time_get_tempIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEbT0_S5_T_, __Z10WriteArrayIcEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE: __Z10WriteArrayIcEvR13dynamic_arrayIiLj4EERKS0_IT_Xsr11AlignOfTypeIS3_EE5alignEE, __Z13RegisterClassI13SpringJoint2DEvv: __Z13RegisterClassI13SpringJoint2DEvv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, _erfc2_142: _erfc2_142, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_130PropertyMessageDescriptionImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev, _UNITY_png_get_chunk_cache_max: _UNITY_png_get_chunk_cache_max, __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi: __ZN19StreamedBinaryWriteILb0EE20TransferTypelessDataEjPvi, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17doAddProfileEventINS0_9StopEventEEEvtRKT_, _labs: _labs, __ZN4FMOD7Channel18setInputChannelMixEPfi: __ZN4FMOD7Channel18setInputChannelMixEPfi, __ZN5Umbra21UserCallbackAllocator10deallocateEPv: __ZN5Umbra21UserCallbackAllocator10deallocateEPv, __Z33SwitchToStandaloneDefaultSettingsv: __Z33SwitchToStandaloneDefaultSettingsv, __ZN3MBP11freeBuffersEv: __ZN3MBP11freeBuffersEv, __ZZN4Tree15InitializeClassEvEN33FunctorImpl_52kOnWillRenderObject4CallEPviR11MessageData: __ZZN4Tree15InitializeClassEvEN33FunctorImpl_52kOnWillRenderObject4CallEPviR11MessageData, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE15clearCachedDataEv: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE15clearCachedDataEv, __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE18doWarmStartSupportEiRNS_6shdfnd3aos5Vec3VE, __ZN9DepthPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceDatab: __ZN9DepthPass7PrepareER6CameraRK15RenderNodeQueueRK17ShaderReplaceDatab, __Z45Register_UnityEngine_SpriteRenderer_get_flipYv: __Z45Register_UnityEngine_SpriteRenderer_get_flipYv, __GLOBAL__sub_I_runtime_scenemanager_lump_cpp: __GLOBAL__sub_I_runtime_scenemanager_lump_cpp, __Z51Register_UnityEngine_AssetBundle_LoadAsset_Internalv: __Z51Register_UnityEngine_AssetBundle_LoadAsset_Internalv, __ZN4crnd10dxt3_block9set_alphaEjjjb: __ZN4crnd10dxt3_block9set_alphaEjjjb, __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyPositionInternalv: __Z67Register_UnityEngine_Animator_INTERNAL_CALL_GetBodyPositionInternalv, __ZNK16MemoryFileSystem8FindNodeEPKc: __ZNK16MemoryFileSystem8FindNodeEPKc, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKc, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj470ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj470ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation13LayerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation13LayerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _UNITY_png_handle_oFFs: _UNITY_png_handle_oFFs, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj431ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj431ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx21PxsBodyTransformVault10removeBodyERKNS_11PxsBodyCoreE: __ZN5physx21PxsBodyTransformVault10removeBodyERKNS_11PxsBodyCoreE, __Z38AnimationClip_CUSTOM_GetEventsInternalP12Il2CppObject: __Z38AnimationClip_CUSTOM_GetEventsInternalP12Il2CppObject, __Z23GetPhysics2DSettingsPtrv: __Z23GetPhysics2DSettingsPtrv, __ZN5physx7NpScene11removeClothERNS_7NpClothE: __ZN5physx7NpScene11removeClothERNS_7NpClothE, __ZN11AudioSource8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11AudioSource8TransferI24GenerateTypeTreeTransferEEvRT_, __Z23SetupLightShaderKeywordRK15SharedLightDataR17ShaderPassContext: __Z23SetupLightShaderKeywordRK15SharedLightDataR17ShaderPassContext, __ZN7mecanim9animation8GetRootXERKNS0_18ClipMuscleConstantEPKf: __ZN7mecanim9animation8GetRootXERKNS0_18ClipMuscleConstantEPKf, __ZN5physx13GuMeshFactory16removeConvexMeshERNS_12PxConvexMeshE: __ZN5physx13GuMeshFactory16removeConvexMeshERNS_12PxConvexMeshE, __ZN11PreloadData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11PreloadData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14VelocityModule8TransferI17RemapPPtrTransferEEvRT_: __ZN14VelocityModule8TransferI17RemapPPtrTransferEEvRT_, __ZN15b2RevoluteJoint17SetMaxMotorTorqueEf: __ZN15b2RevoluteJoint17SetMaxMotorTorqueEf, __ZN12SoundManager20OnExitPlayModeStaticEv: __ZN12SoundManager20OnExitPlayModeStaticEv, __Z18getPxScene_GravityPKN5physx7PxSceneE: __Z18getPxScene_GravityPKN5physx7PxSceneE, __ZN11ContextGLES7ReleaseEv: __ZN11ContextGLES7ReleaseEv, __ZN18CrashReportHandler27DidReloadMonoDomainCallbackEPS_: __ZN18CrashReportHandler27DidReloadMonoDomainCallbackEPS_, __Z43Register_UnityEngine_Font_set_characterInfov: __Z43Register_UnityEngine_Font_set_characterInfov, __Z37Projector_Set_Custom_PropIgnoreLayersP12Il2CppObjecti: __Z37Projector_Set_Custom_PropIgnoreLayersP12Il2CppObjecti, __Z51Register_UnityEngine_AndroidJNI_DetachCurrentThreadv: __Z51Register_UnityEngine_AndroidJNI_DetachCurrentThreadv, __Z39AndroidJNI_CUSTOM_SetDoubleArrayElement13Il2Cpp_IntPtrid: __Z39AndroidJNI_CUSTOM_SetDoubleArrayElement13Il2Cpp_IntPtrid, __ZNSt3__218__insertion_sort_3IRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_: __ZNSt3__218__insertion_sort_3IRPFbRK16NavMeshCarveDataS3_EPS1_EEvT0_S8_T_, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj, __Z33Camera_Get_Custom_PropCullingMaskP12Il2CppObject: __Z33Camera_Get_Custom_PropCullingMaskP12Il2CppObject, __ZN15NavMeshSettings15InitializeClassEv: __ZN15NavMeshSettings15InitializeClassEv, __ZN7Cursors16GetCursorHotspotEv: __ZN7Cursors16GetCursorHotspotEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pubsetbufEPwi: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pubsetbufEPwi, __ZN23DefaultMeshVertexFormatC2Ej: __ZN23DefaultMeshVertexFormatC2Ej, __ZN5physx7profile32PxProfileMemoryEventRecorderImpl11setListenerEPNS_20PxAllocationListenerE: __ZN5physx7profile32PxProfileMemoryEventRecorderImpl11setListenerEPNS_20PxAllocationListenerE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5beginEv, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getConstraintEv, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx2Sc8ClothSim22removeCollisionCapsuleEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim22removeCollisionCapsuleEPKNS0_8ShapeSimE, __ZN5physx2Cm10Collection7releaseEv: __ZN5physx2Cm10Collection7releaseEv, __ZN7Striper16ComputeBestStripEjR14BestStripCache: __ZN7Striper16ComputeBestStripEjR14BestStripCache, __ZL23CleanupModule_Physics2Dv: __ZL23CleanupModule_Physics2Dv, __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetEnabledv: __Z60Register_UnityEngine_ParticleSystem_TriggerModule_GetEnabledv, __Z40AudioChorusFilter_Set_Custom_PropWetMix3P12Il2CppObjectf: __Z40AudioChorusFilter_Set_Custom_PropWetMix3P12Il2CppObjectf, __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_FromToRotationv: __Z60Register_UnityEngine_Quaternion_INTERNAL_CALL_FromToRotationv, __ZNSt3__26__sortIRNS_6__lessIttEEPtEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIttEEPtEEvT0_S5_T_, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS4_, __ZNK5physx30PxVehicleAckermannGeometryData7isValidEv: __ZNK5physx30PxVehicleAckermannGeometryData7isValidEv, __Z44Register_UnityEngine_MeshCollider_set_convexv: __Z44Register_UnityEngine_MeshCollider_set_convexv, __ZN12AudioManager15ThreadedCleanupEv: __ZN12AudioManager15ThreadedCleanupEv, __Z35Physics2D_CUSTOM_GetIgnoreCollisionP12Il2CppObjectS0_: __Z35Physics2D_CUSTOM_GetIgnoreCollisionP12Il2CppObjectS0_, __Z41Caching_Get_Custom_PropCompressionEnabledv: __Z41Caching_Get_Custom_PropCompressionEnabledv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7getMassEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7getMassEv, __ZNK18BuoyancyEffector2D18DesignedForTriggerEv: __ZNK18BuoyancyEffector2D18DesignedForTriggerEv, __ZN15ConstantForce2D15ThreadedCleanupEv: __ZN15ConstantForce2D15ThreadedCleanupEv, __ZNK13RenderTexture12FitGivenRectERiS0_S0_S0_: __ZNK13RenderTexture12FitGivenRectERiS0_S0_S0_, _mkdtemp: _mkdtemp, __ZN8Animator26ParameterControlledByCurveEi: __ZN8Animator26ParameterControlledByCurveEi, __ZN23b2EdgeAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN23b2EdgeAndCapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN11AssetBundle8TransferI17RemapPPtrTransferEEvRT_: __ZN11AssetBundle8TransferI17RemapPPtrTransferEEvRT_, __ZN19TouchPhaseEmulation18FreeExpiredTouchesEjx: __ZN19TouchPhaseEmulation18FreeExpiredTouchesEjx, __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIiP15MonoScriptCacheEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier76ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_10PxMaterialEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z39Animator_CUSTOM_SetLookAtWeightInternalP12Il2CppObjectfffff: __Z39Animator_CUSTOM_SetLookAtWeightInternalP12Il2CppObjectfffff, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8pop_backEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8pop_backEv, __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress: __ZN17PersistentManager26LoadFileCompletelyThreadedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPxPiibR12LoadProgress, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj291ENS_22PxRepXPropertyAccessorILj291ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj291ENS_22PxRepXPropertyAccessorILj291ES4_jjEEEEvjRKT0_, __Z13RegisterClassI8GUILayerEvv: __Z13RegisterClassI8GUILayerEvv, __ZN20OcclusionCullingData7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN20OcclusionCullingData7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN8combiner31DecodeTextureCombinerDescriptorEjRNS_9OperationEPNS_6SourceEPNS_7OperandERi: __ZN8combiner31DecodeTextureCombinerDescriptorEjRNS_9OperationEPNS_6SourceEPNS_7OperandERi, __ZN11UnityEngine7Connect15DeviceInfoEventD0Ev: __ZN11UnityEngine7Connect15DeviceInfoEventD0Ev, __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz: __Z29CreateGameObjectWithHideFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEbiPKcz, __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI13TreePrototypeNS_9allocatorIS1_EEE8__appendEj, __ZN13MonoBehaviour22CanHandleNotificationsEPviR11MessageData: __ZN13MonoBehaviour22CanHandleNotificationsEPviR11MessageData, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj139ES3_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj139ES3_NS_7PxFlagsINS_11PxClothFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN16GraphicsCapsGLESC2Ev: __ZN16GraphicsCapsGLESC2Ev, __ZN16ReflectionProbes14BlurProbeFacesEP15ReflectionProbei: __ZN16ReflectionProbes14BlurProbeFacesEP15ReflectionProbei, __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall: __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_SetRangeP12Il2CppObjectRK13Vector2fIcall, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5clearEj: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5clearEj, __Z29AnimationCurve_CUSTOM_CleanupP12Il2CppObject: __Z29AnimationCurve_CUSTOM_CleanupP12Il2CppObject, __Z44BillboardAsset_CUSTOM_SetIndicesInternalListP12Il2CppObjectS0_: __Z44BillboardAsset_CUSTOM_SetIndicesInternalListP12Il2CppObjectS0_, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10GetPtrSizeEPKv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10GetPtrSizeEPKv, __ZN8UVModule8TransferI14SafeBinaryReadEEvRT_: __ZN8UVModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx13BigConvexData13CreateOffsetsEv: __ZN5physx13BigConvexData13CreateOffsetsEv, __Z40Register_UnityEngine_Mesh_UploadMeshDatav: __Z40Register_UnityEngine_Mesh_UploadMeshDatav, __ZN5physx19PxsFluidSpatialHash31reorderParticleIndicesToPacketsEPjjRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPt: __ZN5physx19PxsFluidSpatialHash31reorderParticleIndicesToPacketsEPjjRKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPt, __ZN12AudioManager21FixMasterGroupRoutingEv: __ZN12AudioManager21FixMasterGroupRoutingEv, __ZN9ShaderLab9IntShader10LinkShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEb: __ZN9ShaderLab9IntShader10LinkShaderERKNS_16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS4_9allocatorIS8_EEEEb, __ZN29AssetBundleLoadAssetOperation15ForceLoadAssetsEv: __ZN29AssetBundleLoadAssetOperation15ForceLoadAssetsEv, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadjEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadjEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf: __Z13ReadPixelImplPKh13TextureFormatR10ColorRGBAf, __Z47Physics2D_CUSTOM_INTERNAL_CALL_LinecastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff: __Z47Physics2D_CUSTOM_INTERNAL_CALL_LinecastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff, __ZN4FMOD6System11getSoundRAMEPiS1_S1_: __ZN4FMOD6System11getSoundRAMEPiS1_S1_, __ZNK5physx6PxVec3mlEf: __ZNK5physx6PxVec3mlEf, __ZN18PlatformEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18PlatformEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_: __ZN15TerrainRenderer18GetNodeAndRendererEiiiRPS_, __ZN13GfxDeviceGLES22AcquireThreadOwnershipEv: __ZN13GfxDeviceGLES22AcquireThreadOwnershipEv, __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD2Ev: __ZN12_GLOBAL__N_130PropertyMessageDescriptionImplD2Ev, __ZN13TrailRenderer15InitializeClassEv: __ZN13TrailRenderer15InitializeClassEv, _UNITY_TT_Load_Glyph: _UNITY_TT_Load_Glyph, __ZN9Animation16SetVisibleBoundsEb: __ZN9Animation16SetVisibleBoundsEb, __Z34AndroidJNI_CUSTOM_IsAssignableFrom13Il2Cpp_IntPtrS_: __Z34AndroidJNI_CUSTOM_IsAssignableFrom13Il2Cpp_IntPtrS_, __ZN10Matrix3x3fmLEf: __ZN10Matrix3x3fmLEf, __ZN5Light15ThreadedCleanupEv: __ZN5Light15ThreadedCleanupEv, __Z5splatILj1EE8Scalar4fRKS0_: __Z5splatILj1EE8Scalar4fRKS0_, __ZN10MemoryPool17PreallocateMemoryEi: __ZN10MemoryPool17PreallocateMemoryEi, __ZN11ChannelInfo8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11ChannelInfo8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17ProceduralTexture15ThreadedCleanupEv: __ZN17ProceduralTexture15ThreadedCleanupEv, __ZNK7Joint2D16UseConnectedBodyEv: __ZNK7Joint2D16UseConnectedBodyEv, __ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE: __ZN5physx6shdfnd12ErrorHandler21registerErrorCallbackERNS_15PxErrorCallbackE, _cff_index_get_string: _cff_index_get_string, __Z29setPxHeightFieldDescThicknessPN5physx17PxHeightFieldDescEf: __Z29setPxHeightFieldDescThicknessPN5physx17PxHeightFieldDescEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, __Z20LightAttenuateApproxRKfS0_: __Z20LightAttenuateApproxRKfS0_, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv, __ZN5physx2Sc18ParticleSystemCore16getParticleStateEv: __ZN5physx2Sc18ParticleSystemCore16getParticleStateEv, __ZN13WebCamTexture21HandleCaptureRequestsEv: __ZN13WebCamTexture21HandleCaptureRequestsEv, __ZN6SpriteC2E10MemLabelId18ObjectCreationMode: __ZN6SpriteC2E10MemLabelId18ObjectCreationMode, __Z41Register_UnityEngine_Mesh_get_vertexCountv: __Z41Register_UnityEngine_Mesh_get_vertexCountv, __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj: __ZN5physx2Sc10NPhaseCore15onVolumeRemovedEPNS0_7ElementEj, _UNITY_FT_Init_Class_pshinter_interface: _UNITY_FT_Init_Class_pshinter_interface, __Z29getPxMaterial_DynamicFrictionPKN5physx10PxMaterialE: __Z29getPxMaterial_DynamicFrictionPKN5physx10PxMaterialE, __ZN23b2EdgeAndPolygonContactC2EP9b2FixtureS1_: __ZN23b2EdgeAndPolygonContactC2EP9b2FixtureS1_, __ZN5physx19PxClothFabricCookerC2ERKNS_15PxClothMeshDescERKNS_6PxVec3Eb: __ZN5physx19PxClothFabricCookerC2ERKNS_15PxClothMeshDescERKNS_6PxVec3Eb, __Z64Register_UnityEngine_Physics_get_defaultSolverVelocityIterationsv: __Z64Register_UnityEngine_Physics_get_defaultSolverVelocityIterationsv, __ZNK5Umbra15GateStateVector8getStateEi: __ZNK5Umbra15GateStateVector8getStateEi, __ZN22MemoryCacherReadBlocks10DirectReadEPvjj: __ZN22MemoryCacherReadBlocks10DirectReadEPvjj, __ZN5physx2Sc7BodySim19postActorFlagChangeEjj: __ZN5physx2Sc7BodySim19postActorFlagChangeEjj, __Z62Register_UnityEngine_LightProbeProxyVolume_get_boundingBoxModev: __Z62Register_UnityEngine_LightProbeProxyVolume_get_boundingBoxModev, __Z51Register_UnityEngine_ParticleSystem_set_scalingModev: __Z51Register_UnityEngine_ParticleSystem_set_scalingModev, __Z43AudioReverbZone_Get_Custom_PropDecayHFRatioP12Il2CppObject: __Z43AudioReverbZone_Get_Custom_PropDecayHFRatioP12Il2CppObject, __ZN4math5Limit8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4math5Limit8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E, __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12InputManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN19OverlapPointQuery2D13ReportFixtureEP9b2Fixture: __ZN19OverlapPointQuery2D13ReportFixtureEP9b2Fixture, __Z35CreateInstanceFixedBehaviourManagerv: __Z35CreateInstanceFixedBehaviourManagerv, __Z18Transfer_BlittableI8JSONReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21LightProbeProxyVolume12GetTransformEv: __ZN21LightProbeProxyVolume12GetTransformEv, _UNITY_FT_Stroker_Done: _UNITY_FT_Stroker_Done, __Z48Register_UnityEngine_AndroidJNI_IsAssignableFromv: __Z48Register_UnityEngine_AndroidJNI_IsAssignableFromv, __Z24GetClothScriptingClassesv: __Z24GetClothScriptingClassesv, __Z65Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetColorv: __Z65Register_UnityEngine_MaterialPropertyBlock_INTERNAL_CALL_SetColorv, __ZN19SpriteMeshGenerator9DecomposeEP13dynamic_arrayI8Vector2fLj4EEPS0_ItLj2EEb: __ZN19SpriteMeshGenerator9DecomposeEP13dynamic_arrayI8Vector2fLj4EEPS0_ItLj2EEb, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE13isSubordinateEv, __ZNKSt3__210moneypunctIwLb0EE16do_decimal_pointEv: __ZNKSt3__210moneypunctIwLb0EE16do_decimal_pointEv, __Z24RegisterStrippedTypeInfoI25RuntimeAnimatorControllerEviPKcS2_: __Z24RegisterStrippedTypeInfoI25RuntimeAnimatorControllerEviPKcS2_, __ZNKSt3__210moneypunctIcLb0EE16do_negative_signEv: __ZNKSt3__210moneypunctIcLb0EE16do_negative_signEv, __Z38Register_UnityEngine_TextMesh_set_fontv: __Z38Register_UnityEngine_TextMesh_set_fontv, __Z59Register_UnityEngine_Rigidbody_set_solverVelocityIterationsv: __Z59Register_UnityEngine_Rigidbody_set_solverVelocityIterationsv, __ZL28GeomOverlapCallback_PlaneBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL28GeomOverlapCallback_PlaneBoxRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN15DirectorManager17RemoveFromManagerEP14DirectorPlayer: __ZN15DirectorManager17RemoveFromManagerEP14DirectorPlayer, __ZN9JSONWrite8TransferINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED2Ev: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED2Ev, __Z31getPxParticleBase_ContactOffsetPKN5physx14PxParticleBaseE: __Z31getPxParticleBase_ContactOffsetPKN5physx14PxParticleBaseE, _UNITY_png_save_int_32: _UNITY_png_save_int_32, __Z47Effector2D_Get_Custom_PropDesignedForNonTriggerP12Il2CppObject: __Z47Effector2D_Get_Custom_PropDesignedForNonTriggerP12Il2CppObject, __Z54Register_UnityEngine_ParticleSystem_ShapeModule_GetArcv: __Z54Register_UnityEngine_ParticleSystem_ShapeModule_GetArcv, __ZNK15ConstantForce2D26GetTypeInfoVirtualInternalEv: __ZNK15ConstantForce2D26GetTypeInfoVirtualInternalEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj8ENS_22PxRepXPropertyAccessorILj8ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_10PxMaterialEEEE14handleAccessorILj8ENS_22PxRepXPropertyAccessorILj8ES4_NS_13PxCombineMode4EnumESA_EEEEvRKT0_, __ZN28LightProbeProxyVolumeManager15InitializeClassEv: __ZN28LightProbeProxyVolumeManager15InitializeClassEv, __ZN5physx6shdfnd10Foundation9errorImplENS_11PxErrorCode4EnumEPKciS5_Pi: __ZN5physx6shdfnd10Foundation9errorImplENS_11PxErrorCode4EnumEPKciS5_Pi, __ZN5physx27InternalTriangleMeshBuilder11createRTreeEv: __ZN5physx27InternalTriangleMeshBuilder11createRTreeEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj433ES2_NS_9PxD6Drive4EnumENS_14PxD6JointDriveEEEKNS_27PxD6JointDriveGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_3Pvd28PxPvdIndexedPropertyAccessorILj433ES2_NS_9PxD6Drive4EnumENS_14PxD6JointDriveEEEKNS_27PxD6JointDriveGeneratedInfoEEEvPjRKT_RT0_, __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17GlobalGameManager8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13RendererSceneD2Ev: __ZN13RendererSceneD2Ev, __ZNK6Avatar26GetTypeInfoVirtualInternalEv: __ZNK6Avatar26GetTypeInfoVirtualInternalEv, __ZN18AudioMixerSnapshot8TransferI14SafeBinaryReadEEvRT_: __ZN18AudioMixerSnapshot8TransferI14SafeBinaryReadEEvRT_, __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf: __Z13SetImagePixelR14ImageReferenceii15TextureWrapModeRK10ColorRGBAf, __Z18IntersectRaySphereRK3RayRK6Sphere: __Z18IntersectRaySphereRK3RayRK6Sphere, __ZN20QuadTreeNodeRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN20QuadTreeNodeRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayI4CellNS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE6resizeEj, __ZN13RendererScene27SetPreventAddRemoveRendererEb: __ZN13RendererScene27SetPreventAddRemoveRendererEb, __ZN13WheelCollider10SetupLayerEv: __ZN13WheelCollider10SetupLayerEv, __ZN23b2EdgeAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN23b2EdgeAndPolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN19VREyeTextureManager28BlitLeftToRightForMonoscopicEv: __ZN19VREyeTextureManager28BlitLeftToRightForMonoscopicEv, __Z14CleanupShadersv: __Z14CleanupShadersv, __Z32TextMesh_Set_Custom_PropFontSizeP12Il2CppObjecti: __Z32TextMesh_Set_Custom_PropFontSizeP12Il2CppObjecti, __Z36setPxRigidDynamic_MaxAngularVelocityPN5physx14PxRigidDynamicEf: __Z36setPxRigidDynamic_MaxAngularVelocityPN5physx14PxRigidDynamicEf, __ZN9GfxDevice24CreateRenderDepthSurfaceE9TextureIDiii16TextureDimension17DepthBufferFormatj: __ZN9GfxDevice24CreateRenderDepthSurfaceE9TextureIDiii16TextureDimension17DepthBufferFormatj, __ZL12InvokeMethodI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13RenderTexture10SetVRUsageE14VRTextureUsage: __ZN13RenderTexture10SetVRUsageE14VRTextureUsage, __Z37Projector_Get_Custom_PropOrthographicP12Il2CppObject: __Z37Projector_Get_Custom_PropOrthographicP12Il2CppObject, __Z46Register_UnityEngine_HumanTrait_BoneFromMusclev: __Z46Register_UnityEngine_HumanTrait_BoneFromMusclev, __ZNK8Material20GetActualRenderQueueEv: __ZNK8Material20GetActualRenderQueueEv, __ZN19CloudServiceHandler8SaveFileERK8UnityStrPKvj: __ZN19CloudServiceHandler8SaveFileERK8UnityStrPKvj, _nextafterf: _nextafterf, __Z24dtDistancePtPolyEdgesSqrPKfS0_iPfS1_: __Z24dtDistancePtPolyEdgesSqrPKfS0_iPfS1_, __ZN5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEED0Ev: __ZN5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEED0Ev, __Z62Register_UnityEngine_Physics2D_INTERNAL_get_colliderAwakeColorv: __Z62Register_UnityEngine_Physics2D_INTERNAL_get_colliderAwakeColorv, __ZNK10MonoScript22GetScriptFullClassNameEv: __ZNK10MonoScript22GetScriptFullClassNameEv, __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z20IsLightValidToRenderRK5Light: __Z20IsLightValidToRenderRK5Light, __Z13RegisterClassI6CameraEvv: __Z13RegisterClassI6CameraEvv, __ZN7mecanim4hand11DestroyHandEPNS0_4HandERNS_6memory9AllocatorE: __ZN7mecanim4hand11DestroyHandEPNS0_4HandERNS_6memory9AllocatorE, __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E: __ZN4FMOD7Channel11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Gu23checkOverlapOBB_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu23checkOverlapOBB_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __Z33Register_UnityEngine_GL_TexCoord3v: __Z33Register_UnityEngine_GL_TexCoord3v, __Z29Transfer_Blittable_ArrayFieldI8JSONReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __Z42Rigidbody2D_Set_Custom_PropAngularVelocityP12Il2CppObjectf: __Z42Rigidbody2D_Set_Custom_PropAngularVelocityP12Il2CppObjectf, __Z15ScaleCurveValueR17AnimationCurveTplIfEf: __Z15ScaleCurveValueR17AnimationCurveTplIfEf, __ZNK5physx2Sc9ClothCore22getNbMotionConstraintsEv: __ZNK5physx2Sc9ClothCore22getNbMotionConstraintsEv, __Z47Terrain_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f: __Z47Terrain_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f, __ZN26SharedLightmapSettingsDataD0Ev: __ZN26SharedLightmapSettingsDataD0Ev, __Z16dtDistancePtAABBPKfS0_S0_: __Z16dtDistancePtAABBPKfS0_S0_, __Z46Camera_CUSTOM_INTERNAL_set_worldToCameraMatrixP12Il2CppObjectRK10Matrix4x4f: __Z46Camera_CUSTOM_INTERNAL_set_worldToCameraMatrixP12Il2CppObjectRK10Matrix4x4f, __ZN8DrawUtil24DrawMeshRawFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi: __ZN8DrawUtil24DrawMeshRawFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi, __ZN5physx12NpConstraintD2Ev: __ZN5physx12NpConstraintD2Ev, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetXv, __Z26PlainLogToPlayerConnection7LogTypePKcPi: __Z26PlainLogToPlayerConnection7LogTypePKcPi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZNK12TreeRenderer19LODTreeInstanceData21PrepareWindPropertiesEv: __ZNK12TreeRenderer19LODTreeInstanceData21PrepareWindPropertiesEv, __ZL24processBrokenEdgeIslandsRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerEPjSD_SD_RS4_: __ZL24processBrokenEdgeIslandsRKN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERNS_11NodeManagerERNS_11EdgeManagerERNS_13IslandManagerEPjSD_SD_RS4_, __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __Z16TransferTextPPtrI8JSONReadEvR4PPtrI6ObjectERT_: __Z16TransferTextPPtrI8JSONReadEvR4PPtrI6ObjectERT_, __Z32CullingGroup_CUSTOM_QueryIndicesP12Il2CppObjecthiN12CullingGroup12QueryOptionsEP11Il2CppArrayi: __Z32CullingGroup_CUSTOM_QueryIndicesP12Il2CppObjecthiN12CullingGroup12QueryOptionsEP11Il2CppArrayi, __ZNK20HardwareInfoReporter16IsHwStatsEnabledEv: __ZNK20HardwareInfoReporter16IsHwStatsEnabledEv, _getopt_long: _getopt_long, __ZNK5physx20PxsParticleSystemSim12isSimulatedVEv: __ZNK5physx20PxsParticleSystemSim12isSimulatedVEv, __ZN8Animator14SetLayerWeightEif: __ZN8Animator14SetLayerWeightEif, __ZN18CrashReportManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18CrashReportManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z42ParticleSystem_TrailModule_CUSTOM_GetRatioP12Il2CppObject: __Z42ParticleSystem_TrailModule_CUSTOM_GetRatioP12Il2CppObject, __ZN16MBPOS_TmpBuffersD2Ev: __ZN16MBPOS_TmpBuffersD2Ev, __ZN7dtCrowd11GetObstacleERK13dtCrowdHandle: __ZN7dtCrowd11GetObstacleERK13dtCrowdHandle, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteUintEj: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteUintEj, __Z39GUIElement_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3fS0_: __Z39GUIElement_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3fS0_, __ZN4FMOD7SystemI12unloadPluginEj: __ZN4FMOD7SystemI12unloadPluginEj, __ZNK17ArchiveFileSystem5IsDirERK13FileEntryData: __ZNK17ArchiveFileSystem5IsDirERK13FileEntryData, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __Z30setPxCloth_SleepLinearVelocityPN5physx7PxClothEf: __Z30setPxCloth_SleepLinearVelocityPN5physx7PxClothEf, __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE: __ZN7mecanim21DestroyValueArrayMaskEPNS_14ValueArrayMaskERNS_6memory9AllocatorE, __ZN5audio5mixer16SnapshotConstant8TransferI14SafeBinaryReadEEvRT_: __ZN5audio5mixer16SnapshotConstant8TransferI14SafeBinaryReadEEvRT_, __Z30NavMeshPath_CUSTOM_NavMeshPathP12Il2CppObject: __Z30NavMeshPath_CUSTOM_NavMeshPathP12Il2CppObject, __ZN7mecanim8skeleton8Skeleton8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim8skeleton8Skeleton8TransferI14SafeBinaryReadEEvRT_, __Z32Camera_Get_Custom_PropAllCamerasv: __Z32Camera_Get_Custom_PropAllCamerasv, __ZL13ResetRandSeedv: __ZL13ResetRandSeedv, _UNITY_FT_Add_Module: _UNITY_FT_Add_Module, __ZN7ApiGLES14GenerateMipmapEj16TextureDimension: __ZN7ApiGLES14GenerateMipmapEj16TextureDimension, __ZNK5physx16PxBroadPhaseBase12getNbRegionsEv: __ZNK5physx16PxBroadPhaseBase12getNbRegionsEv, __ZN30RotationModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN30RotationModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZNSt3__214__scan_keywordIPwPNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SC_SB_SB_RKT1_Rjb: __ZNSt3__214__scan_keywordIPwPNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEENS_5ctypeIwEEEET0_RT_SC_SB_SB_RKT1_Rjb, __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularYLimitP12Il2CppObjectP14SoftJointLimit: __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularYLimitP12Il2CppObjectP14SoftJointLimit, __ZN21ArchiveStorageCreator10AppendDataEPKvj: __ZN21ArchiveStorageCreator10AppendDataEPKvj, __Z13RegisterClassIN5Unity9ComponentEEvv: __Z13RegisterClassIN5Unity9ComponentEEvv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd7FastIPC8sendDataEPKvjb: __ZN5physx6shdfnd7FastIPC8sendDataEPKvjb, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEj: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEOS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignEOS5_, __ZN6Camera16SetCullingMatrixERK10Matrix4x4f: __ZN6Camera16SetCullingMatrixERK10Matrix4x4f, __Z31GetLightProbeProxyVolumeManagerv: __Z31GetLightProbeProxyVolumeManagerv, __ZL35RegisterModuleICalls_CrashReportingv: __ZL35RegisterModuleICalls_CrashReportingv, __ZN14CompressedMesh8CompressERK4MeshRK21CompressedMeshQuality: __ZN14CompressedMesh8CompressERK4MeshRK21CompressedMeshQuality, __Z48Transform_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f: __Z48Transform_CUSTOM_INTERNAL_get_worldToLocalMatrixP12Il2CppObjectP10Matrix4x4f, __ZN5Unity5Cloth15UpdateCollidersEv: __ZN5Unity5Cloth15UpdateCollidersEv, __ZN6Camera8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN6Camera8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z45Texture2D_CUSTOM_LoadRawTextureData_ImplArrayP12Il2CppObjectP11Il2CppArray: __Z45Texture2D_CUSTOM_LoadRawTextureData_ImplArrayP12Il2CppObjectP11Il2CppArray, _nextafterl: _nextafterl, __ZN23iPhoneLocalNotificationC2Ev: __ZN23iPhoneLocalNotificationC2Ev, __Z62Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastNonAllocv: __Z62Register_UnityEngine_Physics_INTERNAL_CALL_CapsuleCastNonAllocv, __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawGUITextureRK5RectTIfEP12Il2CppObjectiiiiS4_: __Z42Gizmos_CUSTOM_INTERNAL_CALL_DrawGUITextureRK5RectTIfEP12Il2CppObjectiiiiS4_, __ZN28LightProbeProxyVolumeManager14AddProxyVolumeEP21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager14AddProxyVolumeEP21LightProbeProxyVolume, __ZN7mecanim5human9HumanPose8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim5human9HumanPose8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26chrono12steady_clock3nowEv: __ZNSt3__26chrono12steady_clock3nowEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags, __Z48Renderer_Get_Custom_PropStaticBatchRootTransformP12Il2CppObject: __Z48Renderer_Get_Custom_PropStaticBatchRootTransformP12Il2CppObject, __ZL25CleanupAIScriptingClassesv: __ZL25CleanupAIScriptingClassesv, __ZL20PrepareShadowMapsJobP18ShadowMapJobHeader: __ZL20PrepareShadowMapsJobP18ShadowMapJobHeader, __Z37Camera_Get_Custom_PropStereoTargetEyeP12Il2CppObject: __Z37Camera_Get_Custom_PropStereoTargetEyeP12Il2CppObject, __ZN14ParticleSystem21DisableUses3DRotationEv: __ZN14ParticleSystem21DisableUses3DRotationEv, __ZNK14PhysicMaterial21CopyMaterialToDefaultEv: __ZNK14PhysicMaterial21CopyMaterialToDefaultEv, __ZN5physx22PxVehicleWheelsSimData15setSubStepCountEfjj: __ZN5physx22PxVehicleWheelsSimData15setSubStepCountEfjj, __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j: __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEEEEjT_j, __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E5clearEv: __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E5clearEv, __ZN10GameObject13AwakeFromLoadE17AwakeFromLoadMode: __ZN10GameObject13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Sc21ArticulationJointCore20setTangentialDampingEf: __ZN5physx2Sc21ArticulationJointCore20setTangentialDampingEf, __ZNK11AudioSource9GetVolumeEv: __ZNK11AudioSource9GetVolumeEv, __ZN12WWWDelayCall14MatchForCancelEPvS0_: __ZN12WWWDelayCall14MatchForCancelEPvS0_, __ZNK5physx29PxShapeGeometryPropertyHelper15getGeometryTypeEPKNS_7PxShapeE: __ZNK5physx29PxShapeGeometryPropertyHelper15getGeometryTypeEPKNS_7PxShapeE, __Z35Renderer_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z35Renderer_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __Z21GetShaderGlobalMatrixN9ShaderLab16FastPropertyNameE: __Z21GetShaderGlobalMatrixN9ShaderLab16FastPropertyNameE, __ZN5Umbra12PortalCuller8traverseEv: __ZN5Umbra12PortalCuller8traverseEv, __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation11GetProgressEv: __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation11GetProgressEv, __ZN5physx22PxDefaultErrorCallbackD0Ev: __ZN5physx22PxDefaultErrorCallbackD0Ev, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE7reserveEj: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier12ELi16EEE7reserveEj, __Z24RegisterStrippedTypeInfoI14PhysicsManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI14PhysicsManagerEviPKcS2_, __ZNK8Animator8GetSpeedEv: __ZNK8Animator8GetSpeedEv, __ZN5physx16PxsIslandManager7addBodyEPvRNS_20PxsIslandManagerHookIjLj4294967295EEEb: __ZN5physx16PxsIslandManager7addBodyEPvRNS_20PxsIslandManagerHookIjLj4294967295EEEb, __Z31AudioSource_Get_Custom_PropLoopP12Il2CppObject: __Z31AudioSource_Get_Custom_PropLoopP12Il2CppObject, __ZNK13b2PulleyJoint10GetLengthAEv: __ZNK13b2PulleyJoint10GetLengthAEv, __ZN5physx9NpFactory16addParticleFluidEPNS_15PxParticleFluidEb: __ZN5physx9NpFactory16addParticleFluidEPNS_15PxParticleFluidEb, __ZNK2UI6Canvas15GetPixelPerfectEv: __ZNK2UI6Canvas15GetPixelPerfectEv, __Z41Register_UnityEngine_GL_get_invertCullingv: __Z41Register_UnityEngine_GL_get_invertCullingv, __ZN17AnimationCurveTplI11QuaternionfE15SetPostInfinityEi: __ZN17AnimationCurveTplI11QuaternionfE15SetPostInfinityEi, __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE: __ZN5physx13integrateBodyEfRKNS_6PxVec3ES2_S2_fRS0_S3_RNS_11PxTransformE, __Z30InstallPlayerConnectionLoggingb: __Z30InstallPlayerConnectionLoggingb, __Z51Register_UnityEngine_TerrainData_GetSupportedLayersv: __Z51Register_UnityEngine_TerrainData_GetSupportedLayersv, __Z48Register_UnityEngine_AndroidJNI_FromBooleanArrayv: __Z48Register_UnityEngine_AndroidJNI_FromBooleanArrayv, __Z18Transfer_BlittableI8JSONReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN14MessageHandlerC2Ev: __ZN14MessageHandlerC2Ev, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYv, __ZN13InitialModuleD0Ev: __ZN13InitialModuleD0Ev, __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_: __ZNSt3__26vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEC2EjRKS3_RKS5_, __Z50Register_UnityEngine_RelativeJoint2D_get_maxTorquev: __Z50Register_UnityEngine_RelativeJoint2D_get_maxTorquev, __ZN5physx15computeMaxIndexEPKtj: __ZN5physx15computeMaxIndexEPKtj, __ZN5physx2Sc7BodySimD0Ev: __ZN5physx2Sc7BodySimD0Ev, __ZL20AddRequiredClassIMPL11ClassIDTypeS_: __ZL20AddRequiredClassIMPL11ClassIDTypeS_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES7_EELj4EEEEvRT_17TransferMetaFlags, __ZNK26AnimatorOverrideController16GetOverrideClipsEv: __ZNK26AnimatorOverrideController16GetOverrideClipsEv, __ZN18ProceduralMaterial21AddSubstanceGraphDataEP13SubstanceDataPhjRNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS6_L18MemLabelIdentifier1ELi16EEEE: __ZN18ProceduralMaterial21AddSubstanceGraphDataEP13SubstanceDataPhjRNSt3__26vectorIP22ProceduralMaterialData13stl_allocatorIS6_L18MemLabelIdentifier1ELi16EEEE, __Z22RecalculateSplineSlopeIfEvR17AnimationCurveTplIT_E: __Z22RecalculateSplineSlopeIfEvR17AnimationCurveTplIT_E, __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf: __ZN5physx21PxVehicleDriveDynData14setAnalogInputEjf, _inflateBackInit_: _inflateBackInit_, __ZN5physx5cloth11SwCollisionI8Scalar4fE10deallocateERKNS3_13CollisionDataE: __ZN5physx5cloth11SwCollisionI8Scalar4fE10deallocateERKNS3_13CollisionDataE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj144ENS_22PxRepXPropertyAccessorILj144ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj144ENS_22PxRepXPropertyAccessorILj144ES4_ffEEEEvRKT0_, __ZN5physx10NpMaterial17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx10NpMaterial17getBinaryMetaDataERNS_14PxOutputStreamE, __Z42AudioReverbZone_Get_Custom_PropReflectionsP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropReflectionsP12Il2CppObject, __ZN5physx7NpCloth17addCollisionPlaneERKNS_21PxClothCollisionPlaneE: __ZN5physx7NpCloth17addCollisionPlaneERKNS_21PxClothCollisionPlaneE, __Z62Register_UnityEngine_Transform_INTERNAL_get_worldToLocalMatrixv: __Z62Register_UnityEngine_Transform_INTERNAL_get_worldToLocalMatrixv, __ZN8BitArrayC2Ev: __ZN8BitArrayC2Ev, __Z49Physics2D_Get_Custom_PropMinPenetrationForPenaltyv: __Z49Physics2D_Get_Custom_PropMinPenetrationForPenaltyv, __ZNK9Texture3D26GetTypeInfoVirtualInternalEv: __ZNK9Texture3D26GetTypeInfoVirtualInternalEv, __Z35CommandBuffer_CUSTOM_GetTemporaryRTP12Il2CppObjectiiiii19RenderTextureFormat22RenderTextureReadWritei: __Z35CommandBuffer_CUSTOM_GetTemporaryRTP12Il2CppObjectiiiii19RenderTextureFormat22RenderTextureReadWritei, __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDataR17ShaderPassContext: __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneRK17ShaderReplaceDataR17ShaderPassContext, __ZNSt3__214__shared_count12__add_sharedEv: __ZNSt3__214__shared_count12__add_sharedEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN20GpuProgramParameters11AddUAVParamEPKciiP16PropertyNamesSet: __ZN20GpuProgramParameters11AddUAVParamEPKciiP16PropertyNamesSet, __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z53NavMeshAgent_CUSTOM_GetCurrentOffMeshLinkDataInternalP12Il2CppObject: __Z53NavMeshAgent_CUSTOM_GetCurrentOffMeshLinkDataInternalP12Il2CppObject, __Z35GameObject_Get_Custom_PropTransformP12Il2CppObject: __Z35GameObject_Get_Custom_PropTransformP12Il2CppObject, __ZN5physx18PxsDynamicsContext20solveParallelCoulombEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEES12_PPNS_12PxsRigidBodyEj: __ZN5physx18PxsDynamicsContext20solveParallelCoulombEjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_PNS_2Cm13SpatialVectorEPKPNS_11PxsBodyCoreERNSC_10BitMapBaseINS_6shdfnd9AllocatorEEEPKPNS_15PxsArticulationEjPViRNSK_5ArrayINS_24PxsConstraintBatchHeaderENSK_19ReflectionAllocatorISV_EEEESZ_RNSU_IjNSW_IjEEEES12_PPNS_12PxsRigidBodyEj, __Z40Camera_Set_Custom_PropLayerCullSphericalP12Il2CppObjecth: __Z40Camera_Set_Custom_PropLayerCullSphericalP12Il2CppObjecth, __Z48AudioSource_Set_Custom_PropSpatializePostEffectsP12Il2CppObjecth: __Z48AudioSource_Set_Custom_PropSpatializePostEffectsP12Il2CppObjecth, __ZNSt3__214error_categoryD2Ev: __ZNSt3__214error_categoryD2Ev, __ZN13ScreenManager36EnableOrientationsFromPlayerSettingsEv: __ZN13ScreenManager36EnableOrientationsFromPlayerSettingsEv, __ZN14RenderSettings15ThreadedCleanupEv: __ZN14RenderSettings15ThreadedCleanupEv, _UNITY_png_get_sPLT: _UNITY_png_get_sPLT, __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsDelayv: __Z59Register_UnityEngine_AudioReverbFilter_set_reflectionsDelayv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN12NavMeshAgentD0Ev: __ZN12NavMeshAgentD0Ev, __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb: __ZN29AudioEffectInternalDefinitionC2EP26UnityAudioEffectDefinitionb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, __ZNK5physx10PxMaterial19getConcreteTypeNameEv: __ZNK5physx10PxMaterial19getConcreteTypeNameEv, __Z56Register_UnityEngine_AI_NavMeshAgent_CompleteOffMeshLinkv: __Z56Register_UnityEngine_AI_NavMeshAgent_CompleteOffMeshLinkv, __ZN6Camera25RenderDepthNormalsTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera25RenderDepthNormalsTextureERK11CullResultsRK19SharedRendererSceneR17ShaderPassContextNS_10RenderFlagE, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE8getSceneEv, __Z14GetPlayerPausev: __Z14GetPlayerPausev, __ZN15AnchoredJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN15AnchoredJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z20SetShaderGlobalFloatN9ShaderLab16FastPropertyNameEf: __Z20SetShaderGlobalFloatN9ShaderLab16FastPropertyNameEf, __ZN5audio5mixer21ValidateSnapshotIndexERNS0_18AudioMixerConstantEi: __ZN5audio5mixer21ValidateSnapshotIndexERNS0_18AudioMixerConstantEi, __Z36AndroidJNI_CUSTOM_GetStaticCharField13Il2Cpp_IntPtrS_: __Z36AndroidJNI_CUSTOM_GetStaticCharField13Il2Cpp_IntPtrS_, __ZN17PersistentManager25PreallocateObjectThreadedEi: __ZN17PersistentManager25PreallocateObjectThreadedEi, __ZN7mecanim9animation12AvatarMemory8TransferI8BlobSizeEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI8BlobSizeEEvRT_, __ZN5physx29PxClothSimpleTetherCookerImplC2ERKNS_15PxClothMeshDescE: __ZN5physx29PxClothSimpleTetherCookerImplC2ERKNS_15PxClothMeshDescE, __ZN5physx3Scb14ParticleSystem15createParticlesERKNS_22PxParticleCreationDataE: __ZN5physx3Scb14ParticleSystem15createParticlesERKNS_22PxParticleCreationDataE, __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveStringv: __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsParameterControlledByCurveStringv, __Z48Register_UnityEngine_AnimationClip_get_startTimev: __Z48Register_UnityEngine_AnimationClip_get_startTimev, __ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb: __ZN5physx2Gu20sweepSphereTrianglesEjPKNS_10PxTriangleERKNS_6PxVec3EfS6_fPKjRS4_S9_RfRjRNS_7PxFlagsINS_9PxHitFlag4EnumEtEES9_bb, __Z57Register_UnityEngine_Material_Internal_CreateWithMaterialv: __Z57Register_UnityEngine_Material_Internal_CreateWithMaterialv, __ZN20TextRenderingPrivate7GUIText8TransferI14SafeBinaryReadEEvRT_: __ZN20TextRenderingPrivate7GUIText8TransferI14SafeBinaryReadEEvRT_, __ZN11UnityEngine15CloudWebService17CloudJobScheduler11ScheduleJobEPFvPvES2_: __ZN11UnityEngine15CloudWebService17CloudJobScheduler11ScheduleJobEPFvPvES2_, __Z51Register_UnityEngine_AndroidJNI_SetCharArrayElementv: __Z51Register_UnityEngine_AndroidJNI_SetCharArrayElementv, __ZNK21DownloadHandlerBuffer9GetLengthEv: __ZNK21DownloadHandlerBuffer9GetLengthEv, __ZN19ParticleSystemState28ClearSubEmitterCommandBufferEv: __ZN19ParticleSystemState28ClearSubEmitterCommandBufferEv, __ZNK5physx9NpPhysics17getTriangleMeshesEPPNS_14PxTriangleMeshEjj: __ZNK5physx9NpPhysics17getTriangleMeshesEPPNS_14PxTriangleMeshEjj, __ZN4FMOD4DSPI11setUserDataEPv: __ZN4FMOD4DSPI11setUserDataEPv, __ZN12AudioManager22GetAutomaticUpdateModeEP10GameObject: __ZN12AudioManager22GetAutomaticUpdateModeEP10GameObject, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE: __ZN4coreplEPKcRKNS_12basic_stringIcNS_20StringStorageDefaultIcEEEE, __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE: __ZN5physx2Cm12RenderOutputlsENS1_9PrimitiveE, __Z41Register_UnityEngine_AudioSource_set_loopv: __Z41Register_UnityEngine_AudioSource_set_loopv, __Z49ParticleEmitter_CUSTOM_INTERNAL_set_localVelocityP12Il2CppObjectRK8Vector3f: __Z49ParticleEmitter_CUSTOM_INTERNAL_set_localVelocityP12Il2CppObjectRK8Vector3f, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D13InterpolationEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D13InterpolationEEvRT_RT0_PKc17TransferMetaFlags, __Z53ParticleSystem_TrailModule_CUSTOM_GetDieWithParticlesP12Il2CppObject: __Z53ParticleSystem_TrailModule_CUSTOM_GetDieWithParticlesP12Il2CppObject, __Z23sweepCCTBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z23sweepCCTBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN5physx9NpFactory17createClothFabricERNS_13PxInputStreamE: __ZN5physx9NpFactory17createClothFabricERNS_13PxInputStreamE, __Z22RecreatePhysicsWorld2Dv: __Z22RecreatePhysicsWorld2Dv, __Z64Register_UnityEngine_RenderTexture_INTERNAL_CALL_DiscardContentsv: __Z64Register_UnityEngine_RenderTexture_INTERNAL_CALL_DiscardContentsv, __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14EdgeCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK9Transform14CountNodesDeepEv: __ZNK9Transform14CountNodesDeepEv, __ZNK7dtCrowd7hasPathEi: __ZNK7dtCrowd7hasPathEi, __ZN5physx20PxProfileZoneManager24createProfileZoneManagerEPNS_12PxFoundationE: __ZN5physx20PxProfileZoneManager24createProfileZoneManagerEPNS_12PxFoundationE, __Z18getPxShapeUserDataPKN5physx7PxShapeE: __Z18getPxShapeUserDataPKN5physx7PxShapeE, __Z21CreateMonoScriptCacheRK8UnityStrP11Il2CppClass22InitScriptingCacheTypeP6Objecti: __Z21CreateMonoScriptCacheRK8UnityStrP11Il2CppClass22InitScriptingCacheTypeP6Objecti, __Z29CollectAndProduceClonedIslandR6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE: __Z29CollectAndProduceClonedIslandR6ObjectP9TransformR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS4_4pairIiiEEL18MemLabelIdentifier1ELi16EEE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E6getDirEv, __Z27getPxSceneDescGpuDispatcherPKN5physx11PxSceneDescE: __Z27getPxSceneDescGpuDispatcherPKN5physx11PxSceneDescE, __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateGUIClearEventsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateGUIClearEventsstruct7ForwardEv, __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE11getTypeNameEv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_jj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjRKS5_jj, __ZN13TrailRendererC2E10MemLabelId18ObjectCreationMode: __ZN13TrailRendererC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE: __ZN5physx2Sn5ConvX17getBinaryMetaDataENS0_12MetaDataTypeE, _tgammal: _tgammal, __ZN13RuntimeStaticI15ApplicationInfoE16StaticInitializeEPv: __ZN13RuntimeStaticI15ApplicationInfoE16StaticInitializeEPv, __ZNSt8bad_castD2Ev: __ZNSt8bad_castD2Ev, _cf2_builder_cubeTo: _cf2_builder_cubeTo, _tgammaf: _tgammaf, __ZN16MemoryFileSystem9MakeLocalER13FileEntryDatab: __ZN16MemoryFileSystem9MakeLocalER13FileEntryDatab, __ZNKSt3__214__codecvt_utf8IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_: __ZNKSt3__214__codecvt_utf8IDiE6do_outER11__mbstate_tPKDiS5_RS5_PcS7_RS7_, __ZN9BlobWrite8TransferIN4math4AxesEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN4math4AxesEEEvRT_PKc17TransferMetaFlags, _preadv: _preadv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_: __ZNSt3__23mapI9ShapePair16TriggerStayStateNS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S2_EEEEEixERS7_, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED0Ev: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED0Ev, __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setTetherConstraintScaleEf, __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN11KeyframeTplI11QuaternionfEC2EfRKS0_: __ZN11KeyframeTplI11QuaternionfEC2EfRKS0_, __ZN5Umbra16LineSegmentQuery6setEndERKNS_7Vector3E: __ZN5Umbra16LineSegmentQuery6setEndERKNS_7Vector3E, __ZNK6Camera34CalculateNearPlaneWorldSpaceLengthEv: __ZNK6Camera34CalculateNearPlaneWorldSpaceLengthEv, __ZN4FMOD13ChannelGroupI8setPitchEf: __ZN4FMOD13ChannelGroupI8setPitchEf, __ZN11KeyframeTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_: __ZN11KeyframeTplI8Vector3fE8TransferI14SafeBinaryReadEEvRT_, __ZN14ParticleSystem27SetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticleii: __ZN14ParticleSystem27SetTriggerParticlesExternalEN13TriggerEvents9EventTypeEP22ParticleSystemParticleii, __ZN29UnityWebRequestAsyncOperationD2Ev: __ZN29UnityWebRequestAsyncOperationD2Ev, __Z13RegisterClassI18SpeedTreeWindAssetEvv: __Z13RegisterClassI18SpeedTreeWindAssetEvv, __ZN5physx2Cm8BaseTask3runEv: __ZN5physx2Cm8BaseTask3runEv, __ZNK4Mesh20GetRuntimeMemorySizeEv: __ZNK4Mesh20GetRuntimeMemorySizeEv, __ZN10TagManager13StringToLayerERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager13StringToLayerERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __Z49Register_UnityEngine_RenderTexture_GetColorBufferv: __Z49Register_UnityEngine_RenderTexture_GetColorBufferv, __ZN5physx2Sc5Scene36collectPostSolverVelocitiesBeforeCCDEv: __ZN5physx2Sc5Scene36collectPostSolverVelocitiesBeforeCCDEv, __Z42PolygonCollider2D_Get_Custom_PropPathCountP12Il2CppObject: __Z42PolygonCollider2D_Get_Custom_PropPathCountP12Il2CppObject, __ZN13RenderTexture17MainThreadCleanupEv: __ZN13RenderTexture17MainThreadCleanupEv, __Z18TreePrototypeToCppRK17MonoTreePrototypeR13TreePrototype: __Z18TreePrototypeToCppRK17MonoTreePrototypeR13TreePrototype, __ZNK14BillboardAsset9GetBoundsEv: __ZNK14BillboardAsset9GetBoundsEv, __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E: __ZN5physx2Sc18ParticleSystemCore23setExternalAccelerationERKNS_6PxVec3E, __ZN5physx2Sc5Scene30setClothInterCollisionDistanceEf: __ZN5physx2Sc5Scene30setClothInterCollisionDistanceEf, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEyEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_yS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __ZN5physx6shdfnd5ArrayINS_19PxsW2STransformTempENS0_16AlignedAllocatorILj16ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_19PxsW2STransformTempENS0_16AlignedAllocatorILj16ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZN5physx14PxVehicleGraph24clearRecordedChannelDataEv: __ZN5physx14PxVehicleGraph24clearRecordedChannelDataEv, __Z27GetOcclusionCullingSettingsv: __Z27GetOcclusionCullingSettingsv, __ZN9ShaderLab27ComputeStateBlockValuesHashERK13dynamic_arrayIiLj4EEPK19ShaderPropertySheetS6_: __ZN9ShaderLab27ComputeStateBlockValuesHashERK13dynamic_arrayIiLj4EEPK19ShaderPropertySheetS6_, __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZN17BillboardRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN17BillboardRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZN9Coroutine26CompareCoroutineMethodNameEPvS0_: __ZN9Coroutine26CompareCoroutineMethodNameEPvS0_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __Z33setPxRigidDynamic_KinematicTargetPN5physx14PxRigidDynamicERKNS_11PxTransformE: __Z33setPxRigidDynamic_KinematicTargetPN5physx14PxRigidDynamicERKNS_11PxTransformE, __ZN5physx27PxDefaultMemoryOutputStreamD0Ev: __ZN5physx27PxDefaultMemoryOutputStreamD0Ev, __ZNK6Shader24GetShadowCasterPassToUseEiRi: __ZNK6Shader24GetShadowCasterPassToUseEiRi, __ZN12AdsIdHandler22HandleAdsIdAsyncStatusEb: __ZN12AdsIdHandler22HandleAdsIdAsyncStatusEb, __Z19MurmurHash3_x64_128PKvijPv: __Z19MurmurHash3_x64_128PKvijPv, __ZN18ProceduralMaterial24IsProceduralInputVisibleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18ProceduralMaterial24IsProceduralInputVisibleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx2Sc9ClothCore23getSimulationFilterDataEv: __ZNK5physx2Sc9ClothCore23getSimulationFilterDataEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcj, __ZN4crnd11crnd_assertEPKcS1_j: __ZN4crnd11crnd_assertEPKcS1_j, __ZN4FMOD3DSP13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD3DSP13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZThn32_N8Renderer23RendererBecameInvisibleEv: __ZThn32_N8Renderer23RendererBecameInvisibleEv, __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverLifetimev: __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverLifetimev, __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E: __ZN5physx2Cm12RenderOutputlsERKNS_7PxMat44E, __ZNK11SoundHandle8Instance21GetMemoryInfoInternalEb: __ZNK11SoundHandle8Instance21GetMemoryInfoInternalEb, __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE: __ZN5physx2Sq13getGlobalPoseERKNS_3Scb5ShapeERKNS1_5ActorE, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE8overflowEi, __ZN5physx2Sc21ArticulationJointCoreC2ERKNS_11PxTransformES4_: __ZN5physx2Sc21ArticulationJointCoreC2ERKNS_11PxTransformES4_, __Z13RegisterClassIN5Unity5JointEEvv: __Z13RegisterClassIN5Unity5JointEEvv, __Z18PxCreateCollectionv: __Z18PxCreateCollectionv, __ZNK5physx16PxsBroadPhaseMBP12getNbRegionsEv: __ZNK5physx16PxsBroadPhaseMBP12getNbRegionsEv, __Z47UnityWebRequest_CUSTOM_InternalSetRequestHeaderP12Il2CppObjectP12Il2CppStringS2_: __Z47UnityWebRequest_CUSTOM_InternalSetRequestHeaderP12Il2CppObjectP12Il2CppStringS2_, __Z46CharacterController_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z46CharacterController_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN5physx16collideWithPlaneERNS_19PxsParticleCollDataEf: __ZN5physx16collideWithPlaneERNS_19PxsParticleCollDataEf, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE18__get_long_pointerEv, __ZN13RenderManager21RemoveCameraProjectorEP9Projector: __ZN13RenderManager21RemoveCameraProjectorEP9Projector, __ZN32ParticleSystemGeometryJobModules7ReleaseE10MemLabelId: __ZN32ParticleSystemGeometryJobModules7ReleaseE10MemLabelId, __ZN14SafeBinaryRead12IsOldVersionEi: __ZN14SafeBinaryRead12IsOldVersionEi, __Z34Register_UnityEngine_Tree_get_datav: __Z34Register_UnityEngine_Tree_get_datav, __ZN17AudioCustomFilter7CleanupEv: __ZN17AudioCustomFilter7CleanupEv, __ZN5physx13PxHitCallbackINS_10PxSweepHitEE13finalizeQueryEv: __ZN5physx13PxHitCallbackINS_10PxSweepHitEE13finalizeQueryEv, __ZN15TextureSettings5ResetEv: __ZN15TextureSettings5ResetEv, __Z60Register_UnityEngine_CharacterController_INTERNAL_get_centerv: __Z60Register_UnityEngine_CharacterController_INTERNAL_get_centerv, __ZN5physx2Sc5Scene13scheduleClothERNS_10PxBaseTaskEb: __ZN5physx2Sc5Scene13scheduleClothERNS_10PxBaseTaskEb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE8pushNameEPKc, __Z28getPxParticleFluid_StiffnessPKN5physx15PxParticleFluidE: __Z28getPxParticleFluid_StiffnessPKN5physx15PxParticleFluidE, __ZN5physx17collideWithConvexEPNS_7PxPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf: __ZN5physx17collideWithConvexEPNS_7PxPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf, __ZN5physx2Gu21SweepCapsuleTrianglesEjPKNS_10PxTriangleEbRKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS_6PxVec3EfPKjRSA_SF_RfRjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu21SweepCapsuleTrianglesEjPKNS_10PxTriangleEbRKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS_6PxVec3EfPKjRSA_SF_RfRjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZN8JSONRead8TransferIaEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIaEEvRT_PKc17TransferMetaFlagsb, __Z39RectTransform_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK13Vector2fIcall: __Z39RectTransform_CUSTOM_INTERNAL_set_pivotP12Il2CppObjectRK13Vector2fIcall, __Z46ParticleSystem_TriggerModule_CUSTOM_GetEnabledP12Il2CppObject: __Z46ParticleSystem_TriggerModule_CUSTOM_GetEnabledP12Il2CppObject, __Z42AudioReverbZone_Set_Custom_PropLFReferenceP12Il2CppObjectf: __Z42AudioReverbZone_Set_Custom_PropLFReferenceP12Il2CppObjectf, __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetPositionv: __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_SetPositionv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z29StdTemplateConversionFunctionIibEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIibEbPvR14SafeBinaryRead, __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE: __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE, __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10GUITexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetNormalOffsetv: __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetNormalOffsetv, _jsimd_can_quantize: _jsimd_can_quantize, __ZNK5physx11PxAggregate19getConcreteTypeNameEv: __ZNK5physx11PxAggregate19getConcreteTypeNameEv, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZN2UI16PixelAdjustPointERK8Vector2fP9TransformPNS_6CanvasE: __ZN2UI16PixelAdjustPointERK8Vector2fP9TransformPNS_6CanvasE, __Z27GetTypeWithoutLoadingObjecti: __Z27GetTypeWithoutLoadingObjecti, __ZN23CloudWebServicesManager15GetCloudServiceEN19CloudServiceHandler11ServiceTypeE: __ZN23CloudWebServicesManager15GetCloudServiceEN19CloudServiceHandler11ServiceTypeE, __ZN5physx3Cct16shapeHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef: __ZN5physx3Cct16shapeHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef, __ZN9Animation9IsPlayingEv: __ZN9Animation9IsPlayingEv, _UNITY_tt_face_load_name: _UNITY_tt_face_load_name, __Z29setPxCloth_DampingCoefficientPN5physx7PxClothENS_6PxVec3E: __Z29setPxCloth_DampingCoefficientPN5physx7PxClothENS_6PxVec3E, __Z45getPxPrismaticJoint_ProjectionLinearTolerancePKN5physx16PxPrismaticJointE: __Z45getPxPrismaticJoint_ProjectionLinearTolerancePKN5physx16PxPrismaticJointE, __ZN5physx7profile14parseEventDataILb1ENS0_17MemoryEventParserILb1EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_: __ZN5physx7profile14parseEventDataILb1ENS0_17MemoryEventParserILb1EEENS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEbRT0_PKhjPT1_, __Z42TerrainData_Get_Custom_PropSplatPrototypesP12Il2CppObject: __Z42TerrainData_Get_Custom_PropSplatPrototypesP12Il2CppObject, _llvm_ctpop_i64: _llvm_ctpop_i64, __ZN7mecanim9animation12AvatarMemory8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI14SafeBinaryReadEEvRT_, __Z48Register_UnityEngine_Renderer_SetStaticBatchInfov: __Z48Register_UnityEngine_Renderer_SetStaticBatchInfov, __ZThn12_N5physx7NpShapeD0Ev: __ZThn12_N5physx7NpShapeD0Ev, __ZNK5physx6PxVec4mlEf: __ZNK5physx6PxVec4mlEf, __Z51ParticleSystemRenderer_Set_Custom_PropTrailMaterialP12Il2CppObjectS0_: __Z51ParticleSystemRenderer_Set_Custom_PropTrailMaterialP12Il2CppObjectS0_, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE6createERKS5_Rb, __Z29SpriteRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __Z29SpriteRenderer_RenderMultipleRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv: __ZN39AssetBundleLoadFromStreamAsyncOperation17LoadCachedArchiveEv, __ZN5physx10PxsContext17releaseFluidShapeEPNS_16PxsParticleShapeE: __ZN5physx10PxsContext17releaseFluidShapeEPNS_16PxsParticleShapeE, __ZN8Collider12SetIsTriggerEb: __ZN8Collider12SetIsTriggerEb, __ZN17Physics2DSettings26SetQueriesStartInCollidersEb: __ZN17Physics2DSettings26SetQueriesStartInCollidersEb, _FMOD_System_Create: _FMOD_System_Create, __ZN17SharedTextureData32GetCrunchDecompressedTextureDataI11TextureDataEEbRKT_: __ZN17SharedTextureData32GetCrunchDecompressedTextureDataI11TextureDataEEbRKT_, __ZN14PhysicsManager21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction: __ZN14PhysicsManager21SweepRigidbodyTestAllEPN5physx12PxRigidActorERK8Vector3ffi23QueryTriggerInteraction, __Z33Register_UnityEngine_WWW_get_sizev: __Z33Register_UnityEngine_WWW_get_sizev, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_, __ZN9BlobWrite4PushEjPKvj: __ZN9BlobWrite4PushEjPKvj, __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj: __ZNK5physx2Gu15HeightFieldUtil15getVertexNormalEjjj, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthZv, __ZN26IntersectAnyVsMeshCallbackILi0ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi0ELb1EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __Z48Register_UnityEngine_QualitySettings_get_lodBiasv: __Z48Register_UnityEngine_QualitySettings_get_lodBiasv, __Z17GetPreloadManagerv: __Z17GetPreloadManagerv, __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEjT0_S6_S6_S6_S6_T_, __ZN5physx2Gu17RadixSortBuffered4SortEPKfj: __ZN5physx2Gu17RadixSortBuffered4SortEPKfj, _FT_Init_Table_ft_raccess_guess_table: _FT_Init_Table_ft_raccess_guess_table, __ZN7Joint2DD0Ev: __ZN7Joint2DD0Ev, __ZN2UI14CanvasRenderer17SetMaterialNoSyncEP8MaterialiR13dynamic_arrayI4PPtrIS1_ELj4EE: __ZN2UI14CanvasRenderer17SetMaterialNoSyncEP8MaterialiR13dynamic_arrayI4PPtrIS1_ELj4EE, __ZN5audio5mixer13GroupConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5audio5mixer13GroupConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx16PxsParticleShapeD0Ev: __ZN5physx16PxsParticleShapeD0Ev, __ZN5physx16PxVehicleUpdatesEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx16PxVehicleUpdatesEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEjPPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv: __ZNK11MinMaxCurve26FindMinMaxDoubleIntegratedEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZNK16DeveloperConsole9IsVisibleEv: __ZNK16DeveloperConsole9IsVisibleEv, __ZNK12TextureInput8HasImageEv: __ZNK12TextureInput8HasImageEv, __ZN10systeminfo17GetProcessorCountEv: __ZN10systeminfo17GetProcessorCountEv, __Z54Register_UnityEngine_AnimationState_set_normalizedTimev: __Z54Register_UnityEngine_AnimationState_set_normalizedTimev, __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectFieldv: __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectFieldv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EE6createERS6_Rb, __Z50Register_UnityEngine_AI_NavMeshObstacle_set_heightv: __Z50Register_UnityEngine_AI_NavMeshObstacle_set_heightv, __ZN5physx13IslandManagerD0Ev: __ZN5physx13IslandManagerD0Ev, __ZN16SpriteRenderData8SetDirtyEv: __ZN16SpriteRenderData8SetDirtyEv, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE5CheckEv: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE5CheckEv, __Z16SanitizeKeyEventR10InputEvent: __Z16SanitizeKeyEventR10InputEvent, __ZNK5physx2Gu11HeightField12getThicknessEv: __ZNK5physx2Gu11HeightField12getThicknessEv, __Z20HandleSteppedTangentRK11KeyframeTplIfES2_Rf: __Z20HandleSteppedTangentRK11KeyframeTplIfES2_Rf, __ZN5physx11HullLibrary8calchullEPNS_6float3EiRPiRiRS2_S5_if: __ZN5physx11HullLibrary8calchullEPNS_6float3EiRPiRiRS2_S5_if, __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetBounceMultiplierv: __Z71Register_UnityEngine_ParticleSystem_CollisionModule_SetBounceMultiplierv, ___floatscan: ___floatscan, __ZN4FMOD7Channel8getIndexEPi: __ZN4FMOD7Channel8getIndexEPi, __ZN10FlareLayer17RemoveFromManagerEv: __ZN10FlareLayer17RemoveFromManagerEv, __ZNK9Transform26GetTypeInfoVirtualInternalEv: __ZNK9Transform26GetTypeInfoVirtualInternalEv, __Z45ParticleSystem_Particle_CUSTOM_GetCurrentSizeP12Il2CppObjectR22ParticleSystemParticle: __Z45ParticleSystem_Particle_CUSTOM_GetCurrentSizeP12Il2CppObjectR22ParticleSystemParticle, __Z13RegisterClassI13RenderTextureEvv: __Z13RegisterClassI13RenderTextureEvv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5Unity17ConfigurableJoint17SetTargetPositionERK8Vector3f: __ZN5Unity17ConfigurableJoint17SetTargetPositionERK8Vector3f, _cf2_getSubfont: _cf2_getSubfont, __ZN5physx2Sc5Scene26fireQueuedContactCallbacksEb: __ZN5physx2Sc5Scene26fireQueuedContactCallbacksEb, __Z38SparseTexture_Get_Custom_PropTileWidthP12Il2CppObject: __Z38SparseTexture_Get_Custom_PropTileWidthP12Il2CppObject, __Z24GUIStyle_CUSTOM_InitCopyP12Il2CppObjectS0_: __Z24GUIStyle_CUSTOM_InitCopyP12Il2CppObjectS0_, __ZN7Terrain17MainThreadCleanupEv: __ZN7Terrain17MainThreadCleanupEv, __ZNK15ReflectionProbe13GetGlobalAABBEv: __ZNK15ReflectionProbe13GetGlobalAABBEv, __ZN24MaterialDisplayListCache17CachedShaderEntry7ReleaseEv: __ZN24MaterialDisplayListCache17CachedShaderEntry7ReleaseEv, __Z46Register_UnityEngine_BillboardAsset_SetIndicesv: __Z46Register_UnityEngine_BillboardAsset_SetIndicesv, __ZN5physx2Gu23computeMTD_SphereSphereERNS_6PxVec3ERfRKNS0_6SphereES6_: __ZN5physx2Gu23computeMTD_SphereSphereERNS_6PxVec3ERfRKNS0_6SphereES6_, __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_: __ZN12ImageFilters4BlitER17ShaderPassContextP7TextureP13RenderTexturePK18SharedMaterialDataPKcP6ShaderiNS_9BlitFlagsE11CubemapFaceRK8Vector2fSH_, __Z13RegisterClassI18AudioLowPassFilterEvv: __Z13RegisterClassI18AudioLowPassFilterEvv, __Z31Light_Set_Custom_PropShadowBiasP12Il2CppObjectf: __Z31Light_Set_Custom_PropShadowBiasP12Il2CppObjectf, __ZN9ShaderLab10GrabPassesC2E10MemLabelId: __ZN9ShaderLab10GrabPassesC2E10MemLabelId, __ZN20TextRenderingPrivate8TextMesh12CleanupClassEv: __ZN20TextRenderingPrivate8TextMesh12CleanupClassEv, __GLOBAL__sub_I_runtime_particlesystem_modules_lump_cpp: __GLOBAL__sub_I_runtime_particlesystem_modules_lump_cpp, __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager15ClassMethodInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK7Texture20GetUnscaledTextureIDEv: __ZNK7Texture20GetUnscaledTextureIDEv, __ZN14AsyncOperation11SetPriorityEi: __ZN14AsyncOperation11SetPriorityEi, __ZN14ParticleSystem20SetParticlesExternalEP22ParticleSystemParticlei: __ZN14ParticleSystem20SetParticlesExternalEP22ParticleSystemParticlei, __ZN5physx7NpScene14executeCollideEPNS_10PxBaseTaskE: __ZN5physx7NpScene14executeCollideEPNS_10PxBaseTaskE, __ZN15CacheWriterBase23WriteHeaderAndCloseFileEPvjj: __ZN15CacheWriterBase23WriteHeaderAndCloseFileEPvjj, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEEEEjT_j, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj568ENS_22PxRepXPropertyAccessorILj568ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEE14handleAccessorILj568ENS_22PxRepXPropertyAccessorILj568ES4_ffEEEEvRKT0_, __ZNSt3__24listIP19CloudServiceHandler13stl_allocatorIS2_L18MemLabelIdentifier85ELi16EEE6removeERKS2_: __ZNSt3__24listIP19CloudServiceHandler13stl_allocatorIS2_L18MemLabelIdentifier85ELi16EEE6removeERKS2_, __ZNK5physx2Sc8BodyCore17getAngularDampingEv: __ZNK5physx2Sc8BodyCore17getAngularDampingEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__get_long_capEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE14__get_long_capEv, __ZN10TagManager8TransferI17RemapPPtrTransferEEvRT_: __ZN10TagManager8TransferI17RemapPPtrTransferEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclERKNS_24PxShapeMaterialsPropertyEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclERKNS_24PxShapeMaterialsPropertyEj, __ZN10FileSystem23UnmountMemoryFileSystemEv: __ZN10FileSystem23UnmountMemoryFileSystemEv, __Z39WebCamTexture_Set_Custom_PropDeviceNameP12Il2CppObjectP12Il2CppString: __Z39WebCamTexture_Set_Custom_PropDeviceNameP12Il2CppObjectP12Il2CppString, _ps_unicode_value: _ps_unicode_value, __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev: __ZN5physx29PxJointLimitConeGeneratedInfoC2Ev, __ZN5Umbra4Math3tanERKNS_6DoubleE: __ZN5Umbra4Math3tanERKNS_6DoubleE, __ZL26CullDynamicSceneCombineJobP14CullingJobData: __ZL26CullDynamicSceneCombineJobP14CullingJobData, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRf: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRf, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor14constructRightERS3_: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE11Constructor14constructRightERS3_, __ZN5physx3Ext10FixedJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext10FixedJoint17resolveReferencesERNS_24PxDeserializationContextE, __Z27GetTextureIDOrBlackFallbackP9Texture2D: __Z27GetTextureIDOrBlackFallbackP9Texture2D, __Z51Register_UnityEngine_Physics_INTERNAL_CALL_CheckBoxv: __Z51Register_UnityEngine_Physics_INTERNAL_CALL_CheckBoxv, __ZN2UI13CanvasManager34AlignCanvasRectTransformWithCameraEv: __ZN2UI13CanvasManager34AlignCanvasRectTransformWithCameraEv, __Z58getPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePKN5physx22PxSimulationStatisticsE: __Z58getPxSimulationStatisticsTotalDiscreteContactPairsAnyShapePKN5physx22PxSimulationStatisticsE, __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRPFbRK8Vector2fS3_EPS1_EEjT0_S8_S8_S8_S8_T_, __Z56Register_UnityEngine_Physics_get_penetrationPenaltyForcev: __Z56Register_UnityEngine_Physics_get_penetrationPenaltyForcev, __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN18BuoyancyEffector2D8TransferI14SafeBinaryReadEEvRT_: __ZN18BuoyancyEffector2D8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE7reserveEj, __ZNK9Rigidbody24GetRelativePointVelocityERK8Vector3f: __ZNK9Rigidbody24GetRelativePointVelocityERK8Vector3f, __Z21InitializeUmbraModulev: __Z21InitializeUmbraModulev, __Z53Register_UnityEngine_SkinnedMeshRenderer_get_rootBonev: __Z53Register_UnityEngine_SkinnedMeshRenderer_get_rootBonev, __ZN5Umbra20RuntimeTomeGenerator9buildTomeERNS0_6ResultEPKS1_j: __ZN5Umbra20RuntimeTomeGenerator9buildTomeERNS0_6ResultEPKS1_j, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setgEPwS4_S4_: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4setgEPwS4_S4_, __ZN11OffMeshLink15ThreadedCleanupEv: __ZN11OffMeshLink15ThreadedCleanupEv, __Z37GUIStyle_Set_Custom_PropImagePositionP12Il2CppObjecti: __Z37GUIStyle_Set_Custom_PropImagePositionP12Il2CppObjecti, __ZNSt3__217moneypunct_bynameIcLb1EED2Ev: __ZNSt3__217moneypunct_bynameIcLb1EED2Ev, __Z23CreateAsFileIfNotExistsPKc: __Z23CreateAsFileIfNotExistsPKc, __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE16TransferTypelessEPjPKc17TransferMetaFlags, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcE, __ZL19OnLightProbesUpdatev: __ZL19OnLightProbesUpdatev, __Z23getNbPxClothFabric_SetsPKN5physx13PxClothFabricE: __Z23getNbPxClothFabric_SetsPKN5physx13PxClothFabricE, __ZN15MulticastSocket4RecvEPvjP12RecvUserData: __ZN15MulticastSocket4RecvEPvjP12RecvUserData, __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing2Limitv: __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing2Limitv, __ZNK7ApiGLES3GetEj: __ZNK7ApiGLES3GetEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__29strstreamD1Ev: __ZNSt3__29strstreamD1Ev, __ZN5physx7NpScene12fetchResultsEbPj: __ZN5physx7NpScene12fetchResultsEbPj, __ZN2UI6Canvas22CalculateMinBucketSizeEv: __ZN2UI6Canvas22CalculateMinBucketSizeEv, __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx22solveExtContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE4findIS6_EENS_15__tree_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEjEENS_19__map_value_compareIS6_S7_NS_4lessIS6_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE4findIS6_EENS_15__tree_iteratorIS7_PNS_11__tree_nodeIS7_PvEEiEERKT_, __Z41Register_UnityEngine_Collider_get_enabledv: __Z41Register_UnityEngine_Collider_get_enabledv, __ZN11LightProbes7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11LightProbes7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx32PxsSolverConstraintPartitionTask7getNameEv: __ZNK5physx32PxsSolverConstraintPartitionTask7getNameEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE15reserveInternalEj, __Z84Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByBuildIndexv: __Z84Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_GetSceneByBuildIndexv, __ZN7mecanim9animation28MotionOutputSetDeltaPositionEPNS0_12MotionOutputERKN4math7_float3E: __ZN7mecanim9animation28MotionOutputSetDeltaPositionEPNS0_12MotionOutputERKN4math7_float3E, __Z45InitializeSerializationByCodeGenerationThreadv: __Z45InitializeSerializationByCodeGenerationThreadv, __Z23PatchMuscleClipWithInfoP13AnimationClipRK21AnimationClipSettingsbPN7mecanim9animation18ClipMuscleConstantERNS4_6memory9AllocatorE: __Z23PatchMuscleClipWithInfoP13AnimationClipRK21AnimationClipSettingsbPN7mecanim9animation18ClipMuscleConstantERNS4_6memory9AllocatorE, __ZNK11ICallString6IsNullEv: __ZNK11ICallString6IsNullEv, __ZN24PrepareSceneNodesJobDataD2Ev: __ZN24PrepareSceneNodesJobDataD2Ev, __Z62Register_UnityEngine_QualitySettings_get_shadowNearPlaneOffsetv: __Z62Register_UnityEngine_QualitySettings_get_shadowNearPlaneOffsetv, __ZN5physx2Sn21getBinaryPlatformNameEj: __ZN5physx2Sn21getBinaryPlatformNameEj, _UNITY_tt_driver_init: _UNITY_tt_driver_init, __ZN9GfxDevice24ReleaseSharedTextureDataEP17SharedTextureData: __ZN9GfxDevice24ReleaseSharedTextureDataEP17SharedTextureData, __ZN23TextDOMTransferReadBaseI8JSONReadE14BeginMetaGroupEPKc: __ZN23TextDOMTransferReadBaseI8JSONReadE14BeginMetaGroupEPKc, __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE: __ZN7mecanim9animation17DestroyClipMemoryEPNS0_10ClipMemoryERNS_6memory9AllocatorE, __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_: __ZN9b2Fixture11SynchronizeEP12b2BroadPhaseRK11b2TransformS4_, __ZN8b2Island5SolveEP9b2ProfileRK10b2TimeStepRK6b2Vec2b: __ZN8b2Island5SolveEP9b2ProfileRK10b2TimeStepRK6b2Vec2b, __ZN8JSONRead4InitE24TransferInstructionFlagsRK10MemLabelId: __ZN8JSONRead4InitE24TransferInstructionFlagsRK10MemLabelId, __Z43SliderJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject: __Z43SliderJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject, __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr: __ZN11UnityEngine9Analytics15UserCustomEventC2ERK8UnityStr, __Z48Register_UnityEngine_Rigidbody2D_set_angularDragv: __Z48Register_UnityEngine_Rigidbody2D_set_angularDragv, __ZNK14BillboardAsset20AcquireBillboardDataEv: __ZNK14BillboardAsset20AcquireBillboardDataEv, __ZNK7b2Timer15GetMillisecondsEv: __ZNK7b2Timer15GetMillisecondsEv, __ZNK26DownloadHandlerAssetBundle6IsDoneEv: __ZNK26DownloadHandlerAssetBundle6IsDoneEv, __ZN15DownloadHandler21OnBindScriptingObjectEP12Il2CppObject: __ZN15DownloadHandler21OnBindScriptingObjectEP12Il2CppObject, __Z75Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierMultiplierv: __Z75Register_UnityEngine_ParticleSystem_MainModule_GetGravityModifierMultiplierv, __ZN5physx2Sq8AABBTree11refitMarkedEjPKNS_9PxBounds3EPj: __ZN5physx2Sq8AABBTree11refitMarkedEjPKNS_9PxBounds3EPj, __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z62Register_UnityEngine_LODGroup_INTERNAL_get_localReferencePointv: __Z62Register_UnityEngine_LODGroup_INTERNAL_get_localReferencePointv, __Z61Register_UnityEngine_SceneManagement_Scene_GetIsDirtyInternalv: __Z61Register_UnityEngine_SceneManagement_Scene_GetIsDirtyInternalv, __ZL11EncodeValueRK9PrefValue: __ZL11EncodeValueRK9PrefValue, __ZNK10FileSystem26GetApplicationContentsPathEv: __ZNK10FileSystem26GetApplicationContentsPathEv, __ZN13b2DynamicTree8FreeNodeEi: __ZN13b2DynamicTree8FreeNodeEi, __ZN11b2EdgeShapeD0Ev: __ZN11b2EdgeShapeD0Ev, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZNSt3__210moneypunctIcLb0EEC2Ej: __ZNSt3__210moneypunctIcLb0EEC2Ej, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector4fLj4EEEEvRT_17TransferMetaFlags, __Z58Register_UnityEngine_BillboardAsset_SetIndicesInternalListv: __Z58Register_UnityEngine_BillboardAsset_SetIndicesInternalListv, __Z33InitializeMeshVertexFormatManagerv: __Z33InitializeMeshVertexFormatManagerv, __Z36Physics_Set_Custom_PropSleepVelocityf: __Z36Physics_Set_Custom_PropSleepVelocityf, __Z33AudioSource_CUSTOM_GetCustomCurveP12Il2CppObject24MonoAudioSourceCurveType: __Z33AudioSource_CUSTOM_GetCustomCurveP12Il2CppObject24MonoAudioSourceCurveType, __ZN5physx16computeDirectionERjS0_: __ZN5physx16computeDirectionERjS0_, __Z40ParticleEmitter_Set_Custom_PropMinEnergyP12Il2CppObjectf: __Z40ParticleEmitter_Set_Custom_PropMinEnergyP12Il2CppObjectf, __ZNK5physx14NpArticulation14getWorldBoundsEf: __ZNK5physx14NpArticulation14getWorldBoundsEf, __ZN5Unity12PhysicsQuery14CapsuleCastAllERK8Vector3fS3_fS3_fi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery14CapsuleCastAllERK8Vector3fS3_fS3_fi23QueryTriggerInteraction, __ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE: __ZNK5physx2Sc16InteractionScene19isActiveInteractionEPKNS0_11InteractionE, __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy: __ZN13dynamic_arrayIfLj4EE18resize_initializedEjRKf12ResizePolicy, __ZL22InternalWarningConsolePKcz: __ZL22InternalWarningConsolePKcz, __Z24RegisterStrippedTypeInfoI10GameObjectEviPKcS2_: __Z24RegisterStrippedTypeInfoI10GameObjectEviPKcS2_, __ZN5Light8SetColorERK10ColorRGBAf: __ZN5Light8SetColorERK10ColorRGBAf, __ZL34GetComponentsImplementationRecurseILb1ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi1ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z28CullDirectionalShadowCastersiRK22SceneCullingParametersR11CullResults: __Z28CullDirectionalShadowCastersiRK22SceneCullingParametersR11CullResults, __ZN12TextureInputC2Ev: __ZN12TextureInputC2Ev, __ZN20TextRenderingPrivate15GetFontsManager13StaticDestroyEv: __ZN20TextRenderingPrivate15GetFontsManager13StaticDestroyEv, __Z46ParticleEmitter_Set_Custom_PropAngularVelocityP12Il2CppObjectf: __Z46ParticleEmitter_Set_Custom_PropAngularVelocityP12Il2CppObjectf, __Z44GUIUtility_CUSTOM_Internal_GetPixelsPerPointv: __Z44GUIUtility_CUSTOM_Internal_GetPixelsPerPointv, __ZL16NavMeshLoadSceneiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZL16NavMeshLoadSceneiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __ZN21UniformBufferTFMethodD0Ev: __ZN21UniformBufferTFMethodD0Ev, __ZNK8VRDevice25GetStereoRenderingEnabledEv: __ZNK8VRDevice25GetStereoRenderingEnabledEv, __Z41LineRenderer_Get_Custom_PropColorGradientP12Il2CppObject: __Z41LineRenderer_Get_Custom_PropColorGradientP12Il2CppObject, _UNITY_png_sig_cmp: _UNITY_png_sig_cmp, __ZN15MulticastSocket6SetTTLEh: __ZN15MulticastSocket6SetTTLEh, __ZN20LocalFileSystemPosix8IsLockedERK13FileEntryData: __ZN20LocalFileSystemPosix8IsLockedERK13FileEntryData, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_: __ZNSt3__27__sort4IRN10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier1ELi16EEE13value_compareEPS6_EEjT0_SD_SD_SD_T_, __ZN14ParticleSystem18SystemWannaRayCastERKS_: __ZN14ParticleSystem18SystemWannaRayCastERKS_, __ZNK21EnlightenSceneMapping14GetSystemAtlasEPK26EnlightenSystemInformation: __ZNK21EnlightenSceneMapping14GetSystemAtlasEPK26EnlightenSystemInformation, __ZNSt3__217moneypunct_bynameIcLb0EED0Ev: __ZNSt3__217moneypunct_bynameIcLb0EED0Ev, __ZN10Collider2D12SetIsTriggerEb: __ZN10Collider2D12SetIsTriggerEb, __ZN11UnityEngine15CloudWebService13WWWRestClient11PerformPostEv: __ZN11UnityEngine15CloudWebService13WWWRestClient11PerformPostEv, __ZN21GLESGpuProgramApplier11ApplyMatrixERKN20GpuProgramParameters14ValueParameterEPK10Matrix4x4ft: __ZN21GLESGpuProgramApplier11ApplyMatrixERKN20GpuProgramParameters14ValueParameterEPK10Matrix4x4ft, __ZN10GameObjectD0Ev: __ZN10GameObjectD0Ev, _UNITY_FT_Stream_Close: _UNITY_FT_Stream_Close, __Z49Register_UnityEngine_Resources_UnloadUnusedAssetsv: __Z49Register_UnityEngine_Resources_UnloadUnusedAssetsv, __ZN10GameObject18TransferComponentsI17RemapPPtrTransferEEvRT_: __ZN10GameObject18TransferComponentsI17RemapPPtrTransferEEvRT_, __ZNK6Avatar10GetZYPostQEiRK11QuaternionfS2_: __ZNK6Avatar10GetZYPostQEiRK11QuaternionfS2_, __ZN5physx3Ext21InertiaTensorComputer6setBoxERKNS_6PxVec3E: __ZN5physx3Ext21InertiaTensorComputer6setBoxERKNS_6PxVec3E, __Z35getPxVehicleDriveSimData_ClutchDataPKN5physx21PxVehicleDriveSimDataE: __Z35getPxVehicleDriveSimData_ClutchDataPKN5physx21PxVehicleDriveSimDataE, __Z40AndroidJNI_CUSTOM_GetBooleanArrayElement13Il2Cpp_IntPtri: __Z40AndroidJNI_CUSTOM_GetBooleanArrayElement13Il2Cpp_IntPtri, __Z41Register_UnityEngine_Shader_EnableKeywordv: __Z41Register_UnityEngine_Shader_EnableKeywordv, __Z61Register_UnityEngine_BillboardAsset_GetImageTexCoordsInternalv: __Z61Register_UnityEngine_BillboardAsset_GetImageTexCoordsInternalv, __ZN5physx47PCMSphereVsHeightfieldContactGenerationCallbackD0Ev: __ZN5physx47PCMSphereVsHeightfieldContactGenerationCallbackD0Ev, __ZNK24TreeIntermediateRenderer12GetLayerMaskEv: __ZNK24TreeIntermediateRenderer12GetLayerMaskEv, __ZN17ProceduralTexture10InvalidateEv: __ZN17ProceduralTexture10InvalidateEv, __ZN5Umbra20SingleBlockAllocator10deallocateEPv: __ZN5Umbra20SingleBlockAllocator10deallocateEPv, __ZNSt20bad_array_new_lengthC2Ev: __ZNSt20bad_array_new_lengthC2Ev, __ZN13UploadHandler7ReleaseEv: __ZN13UploadHandler7ReleaseEv, __Z41SpringJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf: __Z41SpringJoint2D_Set_Custom_PropDampingRatioP12Il2CppObjectf, __ZN13MemoryManager18RegisterAllocationEPvjRK10MemLabelIdPKcS5_i: __ZN13MemoryManager18RegisterAllocationEPvjRK10MemLabelIdPKcS5_i, __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZN4FMOD7SystemI5closeEv: __ZN4FMOD7SystemI5closeEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEEclILj527ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK12NavMeshAgent21CalculateScaledRadiusEv: __ZNK12NavMeshAgent21CalculateScaledRadiusEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgExNS_8ios_base7seekdirE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgExNS_8ios_base7seekdirE, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEEEEjT_j, __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx10solveExt1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN15CapsuleCollider13AwakeFromLoadE17AwakeFromLoadMode: __ZN15CapsuleCollider13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx7NpCloth21removeCollisionConvexEj: __ZN5physx7NpCloth21removeCollisionConvexEj, __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getAccelerationFilterWidthEv, __ZN5physx3Ext13RevoluteJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext13RevoluteJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE: __ZN5physx2Gu22computeOBBAroundConvexERNS0_3BoxERKNS_20PxConvexMeshGeometryEPKNS_12PxConvexMeshERKNS_11PxTransformE, __ZN5physx2Sc5Scene18visualizeStartStepEv: __ZN5physx2Sc5Scene18visualizeStartStepEv, __Z36Cloth_Set_Custom_PropSolverFrequencyP12Il2CppObjecth: __Z36Cloth_Set_Custom_PropSolverFrequencyP12Il2CppObjecth, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_T_, _malloc_set_footprint_limit: _malloc_set_footprint_limit, __ZN13UnityProfiler10BeginFrameEv: __ZN13UnityProfiler10BeginFrameEv, __Z42Physics2D_Set_Custom_PropBaumgarteTOIScalef: __Z42Physics2D_Set_Custom_PropBaumgarteTOIScalef, __ZN7VRInput21UpdateControllerInputEv: __ZN7VRInput21UpdateControllerInputEv, __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE: __ZNK5physx2Gu24ShrunkConvexHullNoScaleV10planeShiftEjRKNS_6shdfnd3aos6FloatVE, __Z42Register_UnityEngine_ParticleEmitter_Emit2v: __Z42Register_UnityEngine_ParticleEmitter_Emit2v, __ZN13BatchRenderer3AddERK17BatchInstanceData: __ZN13BatchRenderer3AddERK17BatchInstanceData, __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEjT0_S5_S5_T_, __ZN13AnimationClip11ClearCurvesEv: __ZN13AnimationClip11ClearCurvesEv, __ZN12_GLOBAL__N_124HfTrianglesEntityReport27onEventEjPj: __ZN12_GLOBAL__N_124HfTrianglesEntityReport27onEventEjPj, _UNITY_png_get_y_pixels_per_meter: _UNITY_png_get_y_pixels_per_meter, __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_: __ZN5physx16writeBackContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_14executeCollideEPNS_10PxBaseTaskEEEE11runInternalEv, __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags, __Z48Register_UnityEngine_Effector2D_get_colliderMaskv: __Z48Register_UnityEngine_Effector2D_get_colliderMaskv, __ZN5physx2Cm10FanoutTask11runInternalEv: __ZN5physx2Cm10FanoutTask11runInternalEv, __Z26Animation_CUSTOM_CrossFadeP12Il2CppObjectP12Il2CppStringfi: __Z26Animation_CUSTOM_CrossFadeP12Il2CppObjectP12Il2CppStringfi, __ZN4FMOD8ChannelI15setChannelGroupEPNS_12ChannelGroupE: __ZN4FMOD8ChannelI15setChannelGroupEPNS_12ChannelGroupE, __ZN12_GLOBAL__N_116clothSizeGreaterIN5physx5cloth8SwSolver22CpuClothSimulationTaskEEEbRKT_S7_: __ZN12_GLOBAL__N_116clothSizeGreaterIN5physx5cloth8SwSolver22CpuClothSimulationTaskEEEbRKT_S7_, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleERKNS0_9TriangleVEjRKNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVEhPNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration15processTriangleERKNS0_9TriangleVEjRKNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVEhPNS0_21MeshPersistentContactERj, __ZN9GfxDevice19EndGraphicsJobsLateEv: __ZN9GfxDevice19EndGraphicsJobsLateEv, __Z36GUITexture_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z36GUITexture_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, _UNITY_FT_Lookup_Renderer: _UNITY_FT_Lookup_Renderer, __ZN5physx24PxPhysicsGeneratedValuesC2EPKNS_9PxPhysicsE: __ZN5physx24PxPhysicsGeneratedValuesC2EPKNS_9PxPhysicsE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEaSEOS3_: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEaSEOS3_, __ZN18AnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18AnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx34PxClothParticleDataGeneratedValuesC2EPKNS_19PxClothParticleDataE: __ZN5physx34PxClothParticleDataGeneratedValuesC2EPKNS_19PxClothParticleDataE, __ZN12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN9ShaderLabL17FindLightModePassEPNS_9SubShaderE14ShaderPassType: __ZN9ShaderLabL17FindLightModePassEPNS_9SubShaderE14ShaderPassType, __ZN8Remapper41GetAllLoadedObjectsForSerializedFileIndexEiPNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE: __ZN8Remapper41GetAllLoadedObjectsForSerializedFileIndexEiPNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE, __ZN13WheelCollider15InitializeClassEv: __ZN13WheelCollider15InitializeClassEv, __Z36Register_UnityEngine_Animator_Updatev: __Z36Register_UnityEngine_Animator_Updatev, __Z32WindZone_Set_Custom_PropWindMainP12Il2CppObjectf: __Z32WindZone_Set_Custom_PropWindMainP12Il2CppObjectf, __ZN13TextRendering4FontD0Ev: __ZN13TextRendering4FontD0Ev, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb0EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN5Unity11AdjacenciesC2Ev: __ZN5Unity11AdjacenciesC2Ev, __ZNK18AnimatorController13GetBehavioursEv: __ZNK18AnimatorController13GetBehavioursEv, __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRNS_6__lessI18ParticleSorterPredS2_EEPS2_EEjT0_S6_S6_S6_T_, __Z25ApproximateUVDistributionR4Meshi: __Z25ApproximateUVDistributionR4Meshi, __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayINS_8debugger20PropertyMessageEntryENS2_19ForwardingAllocatorEED0Ev, __ZN15ApplicationInfo14GetInstallModeEv: __ZN15ApplicationInfo14GetInstallModeEv, __ZN13MemoryManager24LogDeallocationToConsoleEPvjPKc: __ZN13MemoryManager24LogDeallocationToConsoleEPvjPKc, __ZN9Texture2D13ApplySettingsEv: __ZN9Texture2D13ApplySettingsEv, __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall: __Z63ParticleSystem_ColorBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE11PoolElement8ContainsEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE11PoolElement8ContainsEPKv, __ZN12InputManager19SetJoystickPositionEiif: __ZN12InputManager19SetJoystickPositionEiif, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __ZN9Scripting32GetScriptingWrapperForInstanceIDEi: __ZN9Scripting32GetScriptingWrapperForInstanceIDEi, __ZN5physx10NpMaterial7setFlagENS_14PxMaterialFlag4EnumEb: __ZN5physx10NpMaterial7setFlagENS_14PxMaterialFlag4EnumEb, __ZN13RenderTexture25ResolveAntiAliasedSurfaceEv: __ZN13RenderTexture25ResolveAntiAliasedSurfaceEv, __Z27TransformVerticesStridedREFPhRK10Matrix4x4fjPKhiiiS4_ii25GfxTransformVerticesFlags: __Z27TransformVerticesStridedREFPhRK10Matrix4x4fjPKhiiiS4_ii25GfxTransformVerticesFlags, __ZN5physx3Ext15CpuWorkerThread7executeEv: __ZN5physx3Ext15CpuWorkerThread7executeEv, __ZN5Umbra4Math3logENS_5FloatE: __ZN5Umbra4Math3logENS_5FloatE, __Z51getNbPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE: __Z51getNbPxVehicleWheelsSimData_TireForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataE, __ZN19RenderEventsContextC2ERKS_: __ZN19RenderEventsContextC2ERKS_, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_PopLocalFramev: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_PopLocalFramev, __Z26Object_Get_Custom_PropNameP12Il2CppObject: __Z26Object_Get_Custom_PropNameP12Il2CppObject, __ZN14RotationModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14RotationModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, _UNITY_png_chunk_unknown_handling: _UNITY_png_chunk_unknown_handling, __ZN5physx17PxcNpMemBlockPool20acquireFrictionBlockEv: __ZN5physx17PxcNpMemBlockPool20acquireFrictionBlockEv, __ZN14Texture2DArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14Texture2DArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z46Register_UnityEngine_AndroidJNI_SetStringFieldv: __Z46Register_UnityEngine_AndroidJNI_SetStringFieldv, __ZN10GUIManager16SendQueuedEventsEv: __ZN10GUIManager16SendQueuedEventsEv, __ZNKSt3__212ctype_bynameIcE10do_toupperEc: __ZNKSt3__212ctype_bynameIcE10do_toupperEc, __Z33Texture_Get_Custom_PropMipMapBiasP12Il2CppObject: __Z33Texture_Get_Custom_PropMipMapBiasP12Il2CppObject, __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE7getNameEv, __ZZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPiiEN12PolygonQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi: __ZZNK14dtNavMeshQuery13queryPolygonsEPKfS1_PK13dtQueryFilterPyPiiEN12PolygonQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi, __ZN23b2ChainAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN23b2ChainAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN11WindManager11GetInstanceEv: __ZN11WindManager11GetInstanceEv, __ZN18ComputeShaderParam8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18ComputeShaderParam8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN16ParticleAnimator17SetColorAnimationEP10ColorRGBAf: __ZN16ParticleAnimator17SetColorAnimationEP10ColorRGBAf, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYMultiplierv, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEED0Ev, __Z24RegisterStrippedTypeInfoI11AudioFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI11AudioFilterEviPKcS2_, __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIhNS0_9allocatorIhEEEEEvRT_j, __ZN14AsyncOperation23GetAllowSceneActivationEv: __ZN14AsyncOperation23GetAllowSceneActivationEv, __ZN16PhysicsUtility2D21XRotUpdateFromRBAngleERK11Quaternionff: __ZN16PhysicsUtility2D21XRotUpdateFromRBAngleERK11Quaternionff, __Z14FromJsonSharedR11ICallStringP12Il2CppObjectP11Il2CppClass: __Z14FromJsonSharedR11ICallStringP12Il2CppObjectP11Il2CppClass, __Z53Register_UnityEngine_BillboardAsset_SetImageTexCoordsv: __Z53Register_UnityEngine_BillboardAsset_SetImageTexCoordsv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj146ENS_22PxRepXPropertyAccessorILj146ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z44ReflectionProbe_Set_Custom_PropNearClipPlaneP12Il2CppObjectf: __Z44ReflectionProbe_Set_Custom_PropNearClipPlaneP12Il2CppObjectf, __ZN13UnityProfiler25SaveCurrentFrameRecordingEv: __ZN13UnityProfiler25SaveCurrentFrameRecordingEv, __Z45Register_UnityEngine_Cloth_set_sleepThresholdv: __Z45Register_UnityEngine_Cloth_set_sleepThresholdv, __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE: __ZN5physx7NpActor11getAPISceneERKNS_7PxActorE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__move_assignERS5_NS_17integral_constantIbLb0EEE, __ZZN2UI23InitializeCanvasManagerEvEN32UIEventsWillRenderCanvasesstruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN32UIEventsWillRenderCanvasesstruct7ForwardEv, __Z38Register_UnityEngine_Cloth_set_enabledv: __Z38Register_UnityEngine_Cloth_set_enabledv, __ZN11UnityEngine15CloudWebService14DataDispatcher23PreformRetryWebDispatchEv: __ZN11UnityEngine15CloudWebService14DataDispatcher23PreformRetryWebDispatchEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEPKc, __ZN8Playable17GetScriptInstanceEPS_: __ZN8Playable17GetScriptInstanceEPS_, __Z24ExtractMonoPPtrClassNameRK16TypeTreeIterator: __Z24ExtractMonoPPtrClassNameRK16TypeTreeIterator, __Z39getPxRigidBody_MaxDepenetrationVelocityPKN5physx11PxRigidBodyE: __Z39getPxRigidBody_MaxDepenetrationVelocityPKN5physx11PxRigidBodyE, _UNITY_FT_Face_GetVariantSelectors: _UNITY_FT_Face_GetVariantSelectors, __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE: __ZN11UnityEngine15CloudWebService17CloudServiceEventC2EPKcNS0_15CloudEventFlagsE, __ZNK8WWWAudio11GetCapacityEv: __ZNK8WWWAudio11GetCapacityEv, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE6resizeEjRKS4_, __ZN16AnimationManager12CleanupClassEv: __ZN16AnimationManager12CleanupClassEv, __Z44ComputeShader_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f: __Z44ComputeShader_CUSTOM_INTERNAL_CALL_SetVectorP12Il2CppObjectiRK8Vector4f, __ZN7dtCrowd17UpdateMoveRequestEv: __ZN7dtCrowd17UpdateMoveRequestEv, __ZN5physx27PxClothFabricRepXSerializer16objectToFileImplEPKNS_13PxClothFabricEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx27PxClothFabricRepXSerializer16objectToFileImplEPKNS_13PxClothFabricEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN17RemapPPtrTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN17RemapPPtrTransfer21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN25SingleBlockMemoryFileData9SetLengthEy: __ZN25SingleBlockMemoryFileData9SetLengthEy, __ZL26SelectClosestEdgeCB_ConvexRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E: __ZL26SelectClosestEdgeCB_ConvexRKN5physx2Gu13PolygonalDataERKNS_2Cm23FastVertex2ShapeScalingERKNS_6PxVec3E, _emit_dqt: _emit_dqt, __Z48Register_UnityEngine_WebCamTexture_get_isPlayingv: __Z48Register_UnityEngine_WebCamTexture_get_isPlayingv, __Z30AndroidJNI_CUSTOM_SetByteField13Il2Cpp_IntPtrS_h: __Z30AndroidJNI_CUSTOM_SetByteField13Il2Cpp_IntPtrS_h, __Z28Caching_Get_Custom_PropIndexv: __Z28Caching_Get_Custom_PropIndexv, __ZNK5physx7NpShape11isExclusiveEv: __ZNK5physx7NpShape11isExclusiveEv, __ZNSt3__210__stdinbufIwE5uflowEv: __ZNSt3__210__stdinbufIwE5uflowEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab14SerializedPassENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZThn8_N5physx17ConvexMeshBuilderD0Ev: __ZThn8_N5physx17ConvexMeshBuilderD0Ev, __Z30TryGetManagedStackFrameDetailsPvR17ManagedStackFrame: __Z30TryGetManagedStackFrameDetailsPvR17ManagedStackFrame, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE23estimateTemporaryMemoryERKNS0_7SwClothE, __ZN5physx14PxRigidBodyExt13addForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb: __ZN5physx14PxRigidBodyExt13addForceAtPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb, __ZNKSt3__25ctypeIwE9do_narrowEwc: __ZNKSt3__25ctypeIwE9do_narrowEwc, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9stopEventEty, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZN4FMOD6SoundI13getLoopPointsEPjjS1_j: __ZN4FMOD6SoundI13getLoopPointsEPjjS1_j, __ZN16ParticleAnimator7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16ParticleAnimator7PRODUCEE10MemLabelId18ObjectCreationMode, __Z32Camera_Get_Custom_PropCameraTypeP12Il2CppObject: __Z32Camera_Get_Custom_PropCameraTypeP12Il2CppObject, __ZN12_GLOBAL__N_123DoubleBufferedOutStream18getWrittenDataSizeEv: __ZN12_GLOBAL__N_123DoubleBufferedOutStream18getWrittenDataSizeEv, __ZN5physx3Ext23computeEllipsoidDensityERKNS_6PxVec3Ef: __ZN5physx3Ext23computeEllipsoidDensityERKNS_6PxVec3Ef, __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j: __ZNK5physx32PxVehicleEngineDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEEEEEjT_j, __Z26CreateGameObjectWithVAListRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcPi: __Z26CreateGameObjectWithVAListRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKcPi, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9underflowEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9underflowEv, __ZN9DepthPass16PerformRenderingER17ShaderPassContext: __ZN9DepthPass16PerformRenderingER17ShaderPassContext, __ZN4FMOD8ChannelI15set3DAttributesEPK11FMOD_VECTORS3_: __ZN4FMOD8ChannelI15set3DAttributesEPK11FMOD_VECTORS3_, _casinh: _casinh, __ZN11UnityEngine9Animation23GetBoundCurveFloatValueERKNS0_10BoundCurveE: __ZN11UnityEngine9Animation23GetBoundCurveFloatValueERKNS0_10BoundCurveE, __ZN11Rigidbody2DD2Ev: __ZN11Rigidbody2DD2Ev, __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_11RTreeNodeNQENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_13PxcSolverBodyENS0_16AlignedAllocatorILj128ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZN5physx16PxsBroadPhaseMBPD0Ev: __ZN5physx16PxsBroadPhaseMBPD0Ev, __ZN4FMOD6SoundI13setSoundGroupEPNS_10SoundGroupE: __ZN4FMOD6SoundI13setSoundGroupEPNS_10SoundGroupE, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2INS_11__wrap_iterIPS1_EEEET_S9_RKS3_PNS_9enable_ifIXaasr21__is_forward_iteratorIS9_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeE: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2INS_11__wrap_iterIPS1_EEEET_S9_RKS3_PNS_9enable_ifIXaasr21__is_forward_iteratorIS9_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeE, __ZN9Heightmap15PrecomputeErrorEiiiib: __ZN9Heightmap15PrecomputeErrorEiiiib, __ZN10DynamicVBO11SwapBuffersEj: __ZN10DynamicVBO11SwapBuffersEj, _UNITY_FT_Stream_Pos: _UNITY_FT_Stream_Pos, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES7_EEKNS_34PxVehicleDriveDynDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeINS_12__value_typeItiEENS_19__map_value_compareItS2_NS_4lessItEELb1EEENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZN5physx14NpSceneQueriesD2Ev: __ZN5physx14NpSceneQueriesD2Ev, __ZN13RuntimeStaticI19UnityPluginRegistryE13StaticDestroyEPv: __ZN13RuntimeStaticI19UnityPluginRegistryE13StaticDestroyEPv, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E9copy_fromERKSL_j: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E9copy_fromERKSL_j, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getDynamicFrictionEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE18getDynamicFrictionEv, __ZN7Cubemap23VirtualRedirectTransferER14SafeBinaryRead: __ZN7Cubemap23VirtualRedirectTransferER14SafeBinaryRead, __ZN20TextRenderingPrivate19NativeTextGenerator24ProcessFormatForPositionEv: __ZN20TextRenderingPrivate19NativeTextGenerator24ProcessFormatForPositionEv, __ZN5Umbra9RasterOps10expandBlitERNS_17BlockRasterBufferERKS1_: __ZN5Umbra9RasterOps10expandBlitERNS_17BlockRasterBufferERKS1_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN13GfxDeviceNull17ImmediateTexCoordEifff: __ZN13GfxDeviceNull17ImmediateTexCoordEifff, _ether_ntoa: _ether_ntoa, __ZN11AudioFilter15ThreadedCleanupEv: __ZN11AudioFilter15ThreadedCleanupEv, __Z43Register_UnityEngine_Gradient_get_colorKeysv: __Z43Register_UnityEngine_Gradient_get_colorKeysv, __ZN5physx3Ext20ProfileZoneInterfaceD2Ev: __ZN5physx3Ext20ProfileZoneInterfaceD2Ev, __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE6extendEv: __ZN5physx11PxcPoolListINS_20PxsParticleSystemSimENS_10PxsContextEE6extendEv, __Z60Register_UnityEngine_QualitySettings_get_shadowCascade2Splitv: __Z60Register_UnityEngine_QualitySettings_get_shadowCascade2Splitv, __ZN5physx18PxcNpThreadContextD2Ev: __ZN5physx18PxcNpThreadContextD2Ev, __Z41Physics_Get_Custom_PropMaxAngularVelocityv: __Z41Physics_Get_Custom_PropMaxAngularVelocityv, __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE10onComShiftEj, __Z46ComputeShader_CUSTOM_Internal_DispatchIndirectP12Il2CppObjectiS0_j: __Z46ComputeShader_CUSTOM_Internal_DispatchIndirectP12Il2CppObjectiS0_j, __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E: __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI11DetailPatchNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z48Register_UnityEngine_GUI_GetNameOfFocusedControlv: __Z48Register_UnityEngine_GUI_GetNameOfFocusedControlv, __ZN8MaterialC2E10MemLabelId18ObjectCreationMode: __ZN8MaterialC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEED0Ev, __Z14SetReflectionsR13BatchRendererRK16ReflectionSample: __Z14SetReflectionsR13BatchRendererRK16ReflectionSample, __Z41setPxVehicleClutchDataMEstimateIterationsPN5physx19PxVehicleClutchDataEj: __Z41setPxVehicleClutchDataMEstimateIterationsPN5physx19PxVehicleClutchDataEj, __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeIN18DelayedCallManager8CallbackENS_4lessIS2_EENS_9allocatorIS2_EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_Pf: __Z20IntersectRayTriangleRK3RayRK8Vector3fS4_S4_Pf, __Z49Event_CUSTOM_INTERNAL_CALL_Internal_SetMouseDeltaP12Il2CppObjectRK13Vector2fIcall: __Z49Event_CUSTOM_INTERNAL_CALL_Internal_SetMouseDeltaP12Il2CppObjectRK13Vector2fIcall, __Z44setPxVehicleWheelsDynData_WheelRotationSpeedPN5physx22PxVehicleWheelsDynDataEjf: __Z44setPxVehicleWheelsDynData_WheelRotationSpeedPN5physx22PxVehicleWheelsDynDataEjf, __ZN7mecanim12statemachine15GetMirrorOffsetEb: __ZN7mecanim12statemachine15GetMirrorOffsetEb, __Z42Register_UnityEngine_WindZone_set_windMainv: __Z42Register_UnityEngine_WindZone_set_windMainv, __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_T_, __ZN5physx15NpActorTemplateINS_7PxClothEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_7PxClothEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __Z36Register_UnityEngine_GUI_get_enabledv: __Z36Register_UnityEngine_GUI_get_enabledv, __ZN4Mesh24UnshareMeshRenderingDataEv: __ZN4Mesh24UnshareMeshRenderingDataEv, __ZN5physx18PxsDynamicsContextD2Ev: __ZN5physx18PxsDynamicsContextD2Ev, __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideParticlesEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideParticlesEv, __ZN12NavMeshAgent8TransferI14SafeBinaryReadEEvRT_: __ZN12NavMeshAgent8TransferI14SafeBinaryReadEEvRT_, __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN26AnimatorControllerPlayable23ValidateParameterStringE17GetSetValueResultRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN13BatchRenderer15ApplyShaderPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEi13BatchingFlagsbPKNS7_10GrabPassesE: __ZN13BatchRenderer15ApplyShaderPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEi13BatchingFlagsbPKNS7_10GrabPassesE, __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent11ColorRGBA32: __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent11ColorRGBA32, __ZN5physx14PxsAABBManager19removeAggregatePairEjj: __ZN5physx14PxsAABBManager19removeAggregatePairEjj, __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE: __Z16GetJoystickNamesRNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEEE, __ZN26AnimatorOverrideController15ThreadedCleanupEv: __ZN26AnimatorOverrideController15ThreadedCleanupEv, __ZN6SkyboxD0Ev: __ZN6SkyboxD0Ev, __ZN30EmissionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN30EmissionModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z11IsFenceDoneRK8JobFence: __Z11IsFenceDoneRK8JobFence, __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_: __ZN5physx10PxsContext22fillManagerTouchEventsEPNS_27PxvContactManagerTouchEventERiS2_S3_S2_S3_, __ZN11Rigidbody2D22ApplyRootMotionBuiltinEP14RootMotionData: __ZN11Rigidbody2D22ApplyRootMotionBuiltinEP14RootMotionData, __ZN12FixedJoint2D16CheckConsistencyEv: __ZN12FixedJoint2D16CheckConsistencyEv, __ZNSt3__26locale5facetD2Ev: __ZNSt3__26locale5facetD2Ev, __Z24WWW_Get_Custom_PropBytesP12Il2CppObject: __Z24WWW_Get_Custom_PropBytesP12Il2CppObject, __ZN4FMOD13ChannelGroupI11setUserDataEPv: __ZN4FMOD13ChannelGroupI11setUserDataEPv, __Z34TerrainData_CUSTOM_Internal_CreateP12Il2CppObjectS0_: __Z34TerrainData_CUSTOM_Internal_CreateP12Il2CppObjectS0_, __ZN29DepthOrReplacementPassScratchD2Ev: __ZN29DepthOrReplacementPassScratchD2Ev, __ZN7mecanim9reflectorILj8EE7reflectEh: __ZN7mecanim9reflectorILj8EE7reflectEh, __ZN19AssetBundleManifest23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN19AssetBundleManifest23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_j: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_S8_j, _UNITY_tt_face_get_name: _UNITY_tt_face_get_name, __Z36profiler_begin_frame_separate_thread12ProfilerMode: __Z36profiler_begin_frame_separate_thread12ProfilerMode, __ZN5physx20PxsParticleSystemSim23updateDynamicsParameterEv: __ZN5physx20PxsParticleSystemSim23updateDynamicsParameterEv, __ZNK8Renderer21GetWorldToLocalMatrixEv: __ZNK8Renderer21GetWorldToLocalMatrixEv, __ZN14PreloadManager4StopEv: __ZN14PreloadManager4StopEv, __ZN11Rigidbody2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11Rigidbody2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z54Register_UnityEngine_PhysicMaterial_get_staticFrictionv: __Z54Register_UnityEngine_PhysicMaterial_get_staticFrictionv, __ZN4FMOD7SystemI20getRecordDriverInfoWEiPsiP9FMOD_GUID: __ZN4FMOD7SystemI20getRecordDriverInfoWEiPsiP9FMOD_GUID, __Z48SystemInfo_Get_Custom_PropSupportsComputeShadersv: __Z48SystemInfo_Get_Custom_PropSupportsComputeShadersv, __ZN16b2StackAllocator8AllocateEi: __ZN16b2StackAllocator8AllocateEi, __ZN16UploadHandlerRawD2Ev: __ZN16UploadHandlerRawD2Ev, _UNITY_png_handle_sPLT: _UNITY_png_handle_sPLT, __Z51Register_UnityEngine_GUIUtility_set_keyboardControlv: __Z51Register_UnityEngine_GUIUtility_set_keyboardControlv, __ZN13BaseAllocator17GetFreeBlockCountEPii: __ZN13BaseAllocator17GetFreeBlockCountEPii, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE8__appendEj, __ZN22AnimationMixerPlayableD0Ev: __ZN22AnimationMixerPlayableD0Ev, __ZN11LightProbes14LightProbeDataaSERKS0_: __ZN11LightProbes14LightProbeDataaSERKS0_, __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES: __ZN4gles24InvalidatePipelineStatesERK14GfxContextGLESR15DeviceStateGLES, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb0ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __Z22FindGameObjectsWithTagI13dynamic_arrayIP10GameObjectLj4EEEvjRT_: __Z22FindGameObjectsWithTagI13dynamic_arrayIP10GameObjectLj4EEEvjRT_, __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE: __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVERKNS5_6FloatVE, __ZN19RingbufferTemplates23PeekValueFromRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RPKT_: __ZN19RingbufferTemplates23PeekValueFromRingBufferIN27TimeSliceAwakeFromLoadQueue13AsyncInstanceE17GrowingRingbufferEEbRT0_RPKT_, __ZNK30SpriteRendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK30SpriteRendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN14PhysicsManager13AwakeFromLoadE17AwakeFromLoadMode: __ZN14PhysicsManager13AwakeFromLoadE17AwakeFromLoadMode, __Z18getPxSceneUserDataPKN5physx7PxSceneE: __Z18getPxSceneUserDataPKN5physx7PxSceneE, __ZN11AudioModule15IsAudioDisabledEv: __ZN11AudioModule15IsAudioDisabledEv, __Z31CullingGroup_CUSTOM_GetDistanceP12Il2CppObjecti: __Z31CullingGroup_CUSTOM_GetDistanceP12Il2CppObjecti, _cff_face_done: _cff_face_done, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRd, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRe, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRf, _PxSetJointGlobalFrame: _PxSetJointGlobalFrame, __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb1EEEEvRT_: __ZN18AnimatorController19TransferRuntimeDataI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRl, __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14MinMaxGradient8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpClothEEEE15growAndPushBackERKS2_, __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20ParticleSystemModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z39Camera_Get_Custom_PropStereoConvergenceP12Il2CppObject: __Z39Camera_Get_Custom_PropStereoConvergenceP12Il2CppObject, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRt, __ZN5physx10PxSetGroupERNS_7PxActorEt: __ZN5physx10PxSetGroupERNS_7PxActorEt, __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb: __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb, __ZN13OcclusionAreaD0Ev: __ZN13OcclusionAreaD0Ev, __ZN5physx20PxsParticleSystemSim5clearEv: __ZN5physx20PxsParticleSystemSim5clearEv, __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Collider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRx, __ZN5physx8CCDSweepINS_2Gu4BoxVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu4BoxVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __ZN5physx16PxBroadPhaseBase9addRegionERKNS_18PxBroadPhaseRegionEb: __ZN5physx16PxBroadPhaseBase9addRegionERKNS_18PxBroadPhaseRegionEb, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float4EEEclERS4_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float4EEEclERS4_17TransferMetaFlagsR9BlobWrite, __Z50Register_UnityEngine_AreaEffector2D_get_forceAnglev: __Z50Register_UnityEngine_AreaEffector2D_get_forceAnglev, __ZL18ProgramUniform3uivPK7ApiGLESjiihPKv: __ZL18ProgramUniform3uivPK7ApiGLESjiihPKv, __ZN13ComputeShader7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13ComputeShader7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sn21SerializationRegistry20unregisterSerializerEt: __ZN5physx2Sn21SerializationRegistry20unregisterSerializerEt, __ZN14SafeBinaryRead8TransferIN8LODGroup11LODRendererEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN8LODGroup11LODRendererEEEvRT_PKc17TransferMetaFlags, __Z26getPxJoint_ConstraintFlagsPKN5physx7PxJointE: __Z26getPxJoint_ConstraintFlagsPKN5physx7PxJointE, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_PhSF_Rh, __ZN4Mesh5ClearEb: __ZN4Mesh5ClearEb, __ZN17PersistentManager25ExtractAwakeFromLoadQueueER18AwakeFromLoadQueue: __ZN17PersistentManager25ExtractAwakeFromLoadQueueER18AwakeFromLoadQueue, __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNK10FileSystem21GetAvailableDiskSpaceEPKcRy: __ZNK10FileSystem21GetAvailableDiskSpaceEPKcRy, __ZN11AudioSource19GetSpatializerFloatEiPf: __ZN11AudioSource19GetSpatializerFloatEiPf, __ZN12LightsModule16CheckConsistencyEv: __ZN12LightsModule16CheckConsistencyEv, __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED2Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z32TextMesh_Get_Custom_PropRichTextP12Il2CppObject: __Z32TextMesh_Get_Custom_PropRichTextP12Il2CppObject, __ZN5physx2Gu20doSupportMappingPairERKNS0_7ConvexVES3_PNS0_10SupportMapES5_NS_6shdfnd3aos5Vec3VEPS8_S9_S9_jRNS0_12SimplexStackE: __ZN5physx2Gu20doSupportMappingPairERKNS0_7ConvexVES3_PNS0_10SupportMapES5_NS_6shdfnd3aos5Vec3VEPS8_S9_S9_jRNS0_12SimplexStackE, __ZN6HelperI19StreamedBinaryWriteILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI19StreamedBinaryWriteILb0EE23TransferArrayField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __Z40RenderBufferHelper_CUSTOM_GetStoreActionP21ScriptingRenderBuffer: __Z40RenderBufferHelper_CUSTOM_GetStoreActionP21ScriptingRenderBuffer, __ZNSt3__212ctype_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__212ctype_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN10GameObject21MarkActiveRecursivelyEb: __ZN10GameObject21MarkActiveRecursivelyEb, __ZN12NavMeshAgent4MoveERK8Vector3f: __ZN12NavMeshAgent4MoveERK8Vector3f, __ZN12_GLOBAL__N_118LegacySerialStream9writeDataEPKvj: __ZN12_GLOBAL__N_118LegacySerialStream9writeDataEPKvj, __Z52Register_UnityEngine_GUIText_Internal_GetPixelOffsetv: __Z52Register_UnityEngine_GUIText_Internal_GetPixelOffsetv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setDampingERKNS_6PxVec3E, __ZN18JobBatchDispatcher26ScheduleJobForEachInternalER8JobFencePFvPvjES2_iPFvS2_ERKS0_: __ZN18JobBatchDispatcher26ScheduleJobForEachInternalER8JobFencePFvPvjES2_iPFvS2_ERKS0_, __ZN13GfxDeviceGLES15OnDeviceCreatedEb: __ZN13GfxDeviceGLES15OnDeviceCreatedEb, __ZN13WheelCollider19SetSidewaysFrictionERK18WheelFrictionCurve: __ZN13WheelCollider19SetSidewaysFrictionERK18WheelFrictionCurve, __ZN11AudioFilter17MainThreadCleanupEv: __ZN11AudioFilter17MainThreadCleanupEv, __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN7mecanim12statemachine18StateMachineMemory8TransferI9BlobWriteEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI9BlobWriteEEvRT_, __ZN5physx6shdfnd4Time19getCounterFrequencyEv: __ZN5physx6shdfnd4Time19getCounterFrequencyEv, _testSetjmp: _testSetjmp, __ZNK14RenderSettings13CalcFogFactorEf: __ZNK14RenderSettings13CalcFogFactorEf, __ZN12FixedJoint2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN12FixedJoint2D23VirtualRedirectTransferER14SafeBinaryRead, __ZNK7Texture41QueryPersistentManagerForDataAvailabilityEv: __ZNK7Texture41QueryPersistentManagerForDataAvailabilityEv, __ZN5physx2Sc17ParticleSystemSim21prepareCollisionInputEPNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim21prepareCollisionInputEPNS_10PxBaseTaskE, __ZN11prophecysdk4half8selftestEv: __ZN11prophecysdk4half8selftestEv, __ZN10dtNodePoolD2Ev: __ZN10dtNodePoolD2Ev, __ZN4File4LockENS_8LockModeEb: __ZN4File4LockENS_8LockModeEb, __ZN14PhysicsManager8TransferI14SafeBinaryReadEEvRT_: __ZN14PhysicsManager8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN12b2MouseJoint12SetFrequencyEf: __ZN12b2MouseJoint12SetFrequencyEf, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject, __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN4Halo23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN7b2WorldD2Ev: __ZN7b2WorldD2Ev, __Z22scripting_array_lengthP11Il2CppArray: __Z22scripting_array_lengthP11Il2CppArray, __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15ReflectionProbe8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z61Register_UnityEngine_Rendering_GraphicsSettings_GetShaderModev: __Z61Register_UnityEngine_Rendering_GraphicsSettings_GetShaderModev, __ZN22UnityProfilerPerThread22DomainReloadedCallbackEv: __ZN22UnityProfilerPerThread22DomainReloadedCallbackEv, __Z16GetFrustumPointsRK10Matrix4x4fP8Vector3f: __Z16GetFrustumPointsRK10Matrix4x4fP8Vector3f, _strerror: _strerror, __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorI4PPtrI6ShaderENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN16UnityAdsSettingsD2Ev: __ZN16UnityAdsSettingsD2Ev, __Z61Register_UnityEngine_LightmapSettings_get_lightmapsModeLegacyv: __Z61Register_UnityEngine_LightmapSettings_get_lightmapsModeLegacyv, __ZN6prcoreL18BlitFloatToIntegerERK14ImageReferenceRS0_: __ZN6prcoreL18BlitFloatToIntegerERK14ImageReferenceRS0_, __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16ParticleAnimator23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE28getMassSpaceInvInertiaTensorEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE28getMassSpaceInvInertiaTensorEv, __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_set_forcev: __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_set_forcev, __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject: __ZN13MonoBehaviour30InvokeMethodOrCoroutineCheckedE21ScriptingMethodIl2CppP12Il2CppObject, __ZNK22VirtualJoystickManager24GetPhysicalJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZNK22VirtualJoystickManager24GetPhysicalJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __ZN5physx29PxPrismaticJointGeneratedInfoC2Ev: __ZN5physx29PxPrismaticJointGeneratedInfoC2Ev, __Z49Sprite_Get_Custom_PropAssociatedAlphaSplitTextureP12Il2CppObject: __Z49Sprite_Get_Custom_PropAssociatedAlphaSplitTextureP12Il2CppObject, __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb: __ZN8Material23GetInstantiatedMaterialEPS_R6Objectb, __Z50Physics2D_CUSTOM_INTERNAL_get_colliderContactColorP10ColorRGBAf: __Z50Physics2D_CUSTOM_INTERNAL_get_colliderContactColorP10ColorRGBAf, __Z69Register_UnityEngine_QualitySettings_INTERNAL_get_shadowCascade4Splitv: __Z69Register_UnityEngine_QualitySettings_INTERNAL_get_shadowCascade4Splitv, __ZN21WorldParticleCollider5ResetEv: __ZN21WorldParticleCollider5ResetEv, __ZNK5Umbra7ImpTile11getNodeDataEi: __ZNK5Umbra7ImpTile11getNodeDataEi, __ZN12VRGfxHelpers13BlitLeftRightEP13RenderTextureS1_S1_: __ZN12VRGfxHelpers13BlitLeftRightEP13RenderTextureS1_S1_, __ZN5physx17ConvexHullBuilder27CreateTrianglesFromPolygonsEv: __ZN5physx17ConvexHullBuilder27CreateTrianglesFromPolygonsEv, __Z44Register_UnityEngine_AudioSource_PlayOneShotv: __Z44Register_UnityEngine_AudioSource_PlayOneShotv, _herror: _herror, __ZN12_GLOBAL__N_124PropertyDefinitionHelperD2Ev: __ZN12_GLOBAL__N_124PropertyDefinitionHelperD2Ev, __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialE: __ZN5physx26PxcArticulationFnsSimdBase16multiplySubtractERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialE, __ZN13TextRendering4Font8TransferI17RemapPPtrTransferEEvRT_: __ZN13TextRendering4Font8TransferI17RemapPPtrTransferEEvRT_, __ZN10MemoryFileD2Ev: __ZN10MemoryFileD2Ev, __Z45Renderer_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject: __Z45Renderer_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject, __ZNKSt3__27collateIwE4hashEPKwS3_: __ZNKSt3__27collateIwE4hashEPKwS3_, __ZN7ApiGLES24DisableVertexArrayAttribEj: __ZN7ApiGLES24DisableVertexArrayAttribEj, __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayPvPy: __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayPvPy, __Z58Register_UnityEngine_AudioReverbZone_set_roomRolloffFactorv: __Z58Register_UnityEngine_AudioReverbZone_set_roomRolloffFactorv, __ZNK5physx14NpArticulation7getNameEv: __ZNK5physx14NpArticulation7getNameEv, __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN13GfxDeviceGLES12PresentFrameEv: __ZN13GfxDeviceGLES12PresentFrameEv, __ZN17AnimationCurveTplI8Vector3fE14SetPreInfinityEi: __ZN17AnimationCurveTplI8Vector3fE14SetPreInfinityEi, __ZNK14dtNavMeshQuery19getPolyWallSegmentsEyPK13dtQueryFilterPfPyPii: __ZNK14dtNavMeshQuery19getPolyWallSegmentsEyPK13dtQueryFilterPfPyPii, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z48Register_UnityEngine_Camera_SetReplacementShaderv: __Z48Register_UnityEngine_Camera_SetReplacementShaderv, __ZNSt3__219__thread_struct_imp25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE: __ZNSt3__219__thread_struct_imp25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE, __ZN13GfxDeviceGLES15SetStereoTargetE15StereoscopicEye: __ZN13GfxDeviceGLES15SetStereoTargetE15StereoscopicEye, __ZN13GfxDeviceGLES12GetSRGBWriteEv: __ZN13GfxDeviceGLES12GetSRGBWriteEv, __ZN5physx6shdfnd10checkValidERKNS_11PxTransformE: __ZN5physx6shdfnd10checkValidERKNS_11PxTransformE, __ZN14StackAllocator16SetRequestedSizeEj: __ZN14StackAllocator16SetRequestedSizeEj, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetZv, __Z20setPxShape_LocalPosePN5physx7PxShapeERKNS_11PxTransformE: __Z20setPxShape_LocalPosePN5physx7PxShapeERKNS_11PxTransformE, __Z41Texture_Get_Custom_PropMasterTextureLimitv: __Z41Texture_Get_Custom_PropMasterTextureLimitv, __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZN8Animator21GetGoalWeightRotationEi: __ZN8Animator21GetGoalWeightRotationEi, _tt_cmap4_set_range: _tt_cmap4_set_range, __ZN5physx21PxClothRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxClothRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN9TransformD0Ev: __ZN9TransformD0Ev, __ZN8Animator24StopGraphsAndClearObjectEv: __ZN8Animator24StopGraphsAndClearObjectEv, __ZN13SpeedTreeWind13EnableGustingEb: __ZN13SpeedTreeWind13EnableGustingEb, __Z46Register_UnityEngine_Projector_get_fieldOfViewv: __Z46Register_UnityEngine_Projector_get_fieldOfViewv, __Z17SetConsoleLogPathPKc: __Z17SetConsoleLogPathPKc, __ZN14ParticleSystem17SystemWillRayCastERKS_: __ZN14ParticleSystem17SystemWillRayCastERKS_, __ZNK5Umbra14TomeCollection15getObjectBoundsEiRNS_7Vector3ES2_: __ZNK5Umbra14TomeCollection15getObjectBoundsEiRNS_7Vector3ES2_, __ZN5physx5cloth13UserAllocatedD2Ev: __ZN5physx5cloth13UserAllocatedD2Ev, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj6EEERAT__Kc, __ZN13CameraLODDataC2EPK6CamerajhfRK10MemLabelId: __ZN13CameraLODDataC2EPK6CamerajhfRK10MemLabelId, __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEED0Ev, _memory_stream_close: _memory_stream_close, __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi: __ZN2UI6Canvas34AlignCanvasRectTransformWithCameraERi, __ZN4FMOD6System13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD6System13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj553ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj553ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx15NpActorTemplateINS_7PxClothEE8getSceneEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE8getSceneEv, __ZN5physx17PxsFluidCollision26processShapeListWithFilterEjj: __ZN5physx17PxsFluidCollision26processShapeListWithFilterEjj, __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsCanvasManagerEmitOffScreenGeometrystruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsCanvasManagerEmitOffScreenGeometrystruct7ForwardEv, __ZNK12StatusHelper7IsErrorEv: __ZNK12StatusHelper7IsErrorEv, __ZNK12AudioManager9GetVolumeEv: __ZNK12AudioManager9GetVolumeEv, __Z64Register_UnityEngine_Physics_set_defaultSolverVelocityIterationsv: __Z64Register_UnityEngine_Physics_set_defaultSolverVelocityIterationsv, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv, __ZN5physx6shdfnd9MutexImpl7getSizeEv: __ZN5physx6shdfnd9MutexImpl7getSizeEv, __ZN11Rigidbody2D7SetDragEf: __ZN11Rigidbody2D7SetDragEf, __ZN5physx6shdfnd5ArrayIPNS_13PxProfileZoneENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_13PxProfileZoneENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z51QualitySettings_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE: __Z51QualitySettings_Set_Custom_PropAnisotropicFilteringN7Texture20AnisotropicFilteringE, __ZN5physx9PxTaskMgr14stopSimulationEv: __ZN5physx9PxTaskMgr14stopSimulationEv, __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16GraphicsSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__210__time_getC2EPKc: __ZNSt3__210__time_getC2EPKc, __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayyPvPy: __ZN21AssetBundleFileSystem4ReadER13FileEntryDatayyPvPy, __Z28PrecomputeFilterLookupTablesP17PrecomputeContextjifif: __Z28PrecomputeFilterLookupTablesP17PrecomputeContextjifif, __Z24CalculateGlobalRSInverse23TransformAccessReadOnly: __Z24CalculateGlobalRSInverse23TransformAccessReadOnly, __ZN19MemoryProfilerStats24RemoveDynamicObjectCountEP6Objecti: __ZN19MemoryProfilerStats24RemoveDynamicObjectCountEP6Objecti, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE3putEw: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE3putEw, __Z56Gyroscope_CUSTOM_INTERNAL_CALL_userAcceleration_InternaliR8Vector3f: __Z56Gyroscope_CUSTOM_INTERNAL_CALL_userAcceleration_InternaliR8Vector3f, __ZN9GfxDevice14OnDeleteBufferEP9GfxBuffer: __ZN9GfxDevice14OnDeleteBufferEP9GfxBuffer, __ZN24PhysicsUpdateBehaviour2DD0Ev: __ZN24PhysicsUpdateBehaviour2DD0Ev, __Z55Register_UnityEngine_AudioReverbFilter_set_reverbPresetv: __Z55Register_UnityEngine_AudioReverbFilter_set_reverbPresetv, __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshScalev: __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshScalev, __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_: __ZNK9SubModule17GetSubEmitterPtrsEPP14ParticleSystemPiS3_S3_S3_, __ZNK29ParticleSystemPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK29ParticleSystemPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZNK11Rigidbody2D10IsSleepingEv: __ZNK11Rigidbody2D10IsSleepingEv, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZNK7dtCrowd14getAgentFilterEi: __ZNK7dtCrowd14getAgentFilterEi, __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_: __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6insertENS_11__wrap_iterIPKS3_EERS9_, __ZN5physx7NpShape7setNameEPKc: __ZN5physx7NpShape7setNameEPKc, __ZNK11SoundHandle19IsStreamingFromDiskEv: __ZNK11SoundHandle19IsStreamingFromDiskEv, __Z62Register_UnityEngine_HingeJoint2D_INTERNAL_CALL_GetMotorTorquev: __Z62Register_UnityEngine_HingeJoint2D_INTERNAL_CALL_GetMotorTorquev, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEE15growAndPushBackERKS2_, __Z28RemoteSettings_CUSTOM_HasKeyP12Il2CppString: __Z28RemoteSettings_CUSTOM_HasKeyP12Il2CppString, __ZN9AudioClip8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9AudioClip8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP12MeshRenderer8RendererET_RK4PPtrIT0_E, __Z43DownloadHandler_CUSTOM_InternalCreateBufferP12Il2CppObject: __Z43DownloadHandler_CUSTOM_InternalCreateBufferP12Il2CppObject, __ZNK13Lz4Compressor29CalculateCompressedBufferSizeEj: __ZNK13Lz4Compressor29CalculateCompressedBufferSizeEj, __ZNK5physx7NpCloth22getNbCollisionConvexesEv: __ZNK5physx7NpCloth22getNbCollisionConvexesEv, __Z36Register_UnityEngine_Object_get_namev: __Z36Register_UnityEngine_Object_get_namev, __Z39Register_UnityEngine_TextAsset_get_textv: __Z39Register_UnityEngine_TextAsset_get_textv, __ZN14ParticleSystem8TransferI14SafeBinaryReadEEvRT_: __ZN14ParticleSystem8TransferI14SafeBinaryReadEEvRT_, __ZN15DistanceJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN15DistanceJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __Z46Register_UnityEngine_Canvas_get_sortingLayerIDv: __Z46Register_UnityEngine_Canvas_get_sortingLayerIDv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv, __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv: __Z12pqHeapInsertP9TESSallocP13PriorityQHeapPv, __ZN5physx15NpActorTemplateINS_7PxClothEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_7PxClothEE17resolveReferencesERNS_24PxDeserializationContextE, __Z29AudioMasterDSPProcessCallbackP21UnityAudioEffectStatePfS1_jii: __Z29AudioMasterDSPProcessCallbackP21UnityAudioEffectStatePfS1_jii, __ZNK14ParticleSystem16GetStartRotationEv: __ZNK14ParticleSystem16GetStartRotationEv, __ZNSt3__211regex_errorD2Ev: __ZNSt3__211regex_errorD2Ev, __ZNSt3__219__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_: __ZNSt3__219__double_or_nothingIwEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_, __ZN5physx2Sc18ParticleSystemCore13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE: __ZN5physx2Sc18ParticleSystemCore13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE, __Z52Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleNonAllocRK13Vector2fIcallfP11Il2CppArrayiff: __Z52Physics2D_CUSTOM_INTERNAL_CALL_OverlapCircleNonAllocRK13Vector2fIcallfP11Il2CppArrayiff, _unzGetCurrentFileInfo: _unzGetCurrentFileInfo, __Z55Register_UnityEngine_Rigidbody_set_sleepAngularVelocityv: __Z55Register_UnityEngine_Rigidbody_set_sleepAngularVelocityv, __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags: __ZN14SafeBinaryRead16TransferTypelessEPjPKc17TransferMetaFlags, __ZN13AnimationClip14CompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE: __ZN13AnimationClip14CompressCurvesERNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRy: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRy, __ZN5physx2Sn5ConvX11convertPad8EPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX11convertPad8EPKcRKNS0_15PxMetaDataEntryES6_, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE, __ZN18MultiQueryCallbackIN5physx10PxSweepHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj: __ZN18MultiQueryCallbackIN5physx10PxSweepHitEE6invokeERfPKNS0_2Sq13PrunerPayloadEj, __ZN22ParticleSystemRenderer15ThreadedCleanupEv: __ZN22ParticleSystemRenderer15ThreadedCleanupEv, __Z69Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatricesv: __Z69Register_UnityEngine_Camera_INTERNAL_CALL_SetStereoProjectionMatricesv, __Z56Register_UnityEngine_ReflectionProbe_IsFinishedRenderingv: __Z56Register_UnityEngine_ReflectionProbe_IsFinishedRenderingv, __ZN5UmbraL12processBlockEPKjPj: __ZN5UmbraL12processBlockEPKjPj, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx2Sc19ShapeInstancePairLL9visualizeERNS_2Cm12RenderOutputE: __ZN5physx2Sc19ShapeInstancePairLL9visualizeERNS_2Cm12RenderOutputE, __ZN5Unity5Cloth10LateUpdateEv: __ZN5Unity5Cloth10LateUpdateEv, __ZN6Shader20GetScreenClearShaderEv: __ZN6Shader20GetScreenClearShaderEv, __Z33getPxVehicleEngineDataMPeakTorquePKN5physx19PxVehicleEngineDataE: __Z33getPxVehicleEngineDataMPeakTorquePKN5physx19PxVehicleEngineDataE, __Z42GenericMixerPlayable_CUSTOM_InternalCreateR9HPlayable: __Z42GenericMixerPlayable_CUSTOM_InternalCreateR9HPlayable, __Z24PlayerEmitCanvasGeometryv: __Z24PlayerEmitCanvasGeometryv, __Z53Register_UnityEngine_AndroidJNI_SetObjectArrayElementv: __Z53Register_UnityEngine_AndroidJNI_SetObjectArrayElementv, __Z56Register_UnityEngine_ParticleEmitter_set_angularVelocityv: __Z56Register_UnityEngine_ParticleEmitter_set_angularVelocityv, __ZNSt3__218condition_variable15__do_timed_waitERNS_11unique_lockINS_5mutexEEENS_6chrono10time_pointINS5_12system_clockENS5_8durationIxNS_5ratioILx1ELx1000000000EEEEEEE: __ZNSt3__218condition_variable15__do_timed_waitERNS_11unique_lockINS_5mutexEEENS_6chrono10time_pointINS5_12system_clockENS5_8durationIxNS_5ratioILx1ELx1000000000EEEEEEE, __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_114parse_encodingINS0_2DbEEEPKcS4_S4_RT_, __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15NavMeshObstacle8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRb: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRb, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z32AudioMixerDuckingDestroyCallbackP21UnityAudioEffectState: __Z32AudioMixerDuckingDestroyCallbackP21UnityAudioEffectState, __ZN13ComputeShader15ThreadedCleanupEv: __ZN13ComputeShader15ThreadedCleanupEv, __ZNK12HandlerChain8PositionERK13FileEntryData: __ZNK12HandlerChain8PositionERK13FileEntryData, __ZN16MeshVertexFormatD2Ev: __ZN16MeshVertexFormatD2Ev, __ZN16b2PolygonContactC2EP9b2FixtureS1_: __ZN16b2PolygonContactC2EP9b2FixtureS1_, __ZN8UVModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8UVModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN2UI6Canvas23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN2UI6Canvas23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN8BitArrayC2Ej: __ZN8BitArrayC2Ej, __ZN8Animator6RebindEb: __ZN8Animator6RebindEb, __ZN9ShaderLab18SerializedPropertyaSERKS0_: __ZN9ShaderLab18SerializedPropertyaSERKS0_, __ZNK20IntermediateRenderer12GetLayerMaskEv: __ZNK20IntermediateRenderer12GetLayerMaskEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier54ELi16EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __Z58Register_UnityEngine_AI_NavMeshAgent_get_remainingDistancev: __Z58Register_UnityEngine_AI_NavMeshAgent_get_remainingDistancev, __ZN7mecanim9animation12GetRootStopXERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation12GetRootStopXERKNS0_18ClipMuscleConstantE, __ZN15PointEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15PointEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI25RuntimeAnimatorControllerE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z42BillboardRenderer_Get_Custom_PropBillboardP12Il2CppObject: __Z42BillboardRenderer_Get_Custom_PropBillboardP12Il2CppObject, __Z15Transfer_StringI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI17RemapPPtrTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__212ctype_bynameIwE10do_tolowerEPwPKw: __ZNKSt3__212ctype_bynameIwE10do_tolowerEPwPKw, __ZN8Animator10IsInIKPassEv: __ZN8Animator10IsInIKPassEv, __ZNK28RectTransformPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK28RectTransformPropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, _cff_parse_cid_ros: _cff_parse_cid_ros, __Z50SpringJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth: __Z50SpringJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth, __ZN5physx2Sc27ConstraintProjectionManager10addToGroupERNS0_7BodySimEPS2_RNS0_13ConstraintSimE: __ZN5physx2Sc27ConstraintProjectionManager10addToGroupERNS0_7BodySimEPS2_RNS0_13ConstraintSimE, __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawMeshP12Il2CppObjectS0_RK10Matrix4x4fS0_iiS0_: __Z52CommandBuffer_CUSTOM_INTERNAL_CALL_Internal_DrawMeshP12Il2CppObjectS0_RK10Matrix4x4fS0_iiS0_, __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode0EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf: __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode0EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf, __ZN12NavMeshAgent7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12NavMeshAgent7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b: __ZN5physx22writeCompressedContactEPKNS_2Gu12ContactPointEjRNS_18PxcNpThreadContextERtRPhRjRPfjS6_PKNS_18PxsMaterialManagerEbbPNS_15PxsMaterialInfoEjbPS4_b, __ZNKSt3__211__libcpp_db15__decrementableEPKv: __ZNKSt3__211__libcpp_db15__decrementableEPKv, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z35getPxVehicleDriveDynData_TargetGearPKN5physx21PxVehicleDriveDynDataE: __Z35getPxVehicleDriveDynData_TargetGearPKN5physx21PxVehicleDriveDynDataE, __ZN8BitArray6resizeEj: __ZN8BitArray6resizeEj, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEEEvPT_jRKT0_RKT1_j, __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIKjS6_EE: __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier5ELi16EEE16__construct_nodeERKNS_4pairIKjS6_EE, __ZNK15DownloadHandler8GetErrorEv: __ZNK15DownloadHandler8GetErrorEv, __ZN13UnityProfiler18StartProfilingModeE12ProfilerMode: __ZN13UnityProfiler18StartProfilingModeE12ProfilerMode, __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring: __Z55ConfigurableJoint_CUSTOM_INTERNAL_set_linearLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring, __ZN5physx6shdfnd6Socket11setBlockingEb: __ZN5physx6shdfnd6Socket11setBlockingEb, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN7ApiGLES23BindAtomicCounterBufferEjj: __ZN7ApiGLES23BindAtomicCounterBufferEjj, __ZNSt3__214__shared_countD0Ev: __ZNSt3__214__shared_countD0Ev, __GLOBAL__sub_I_runtime_graphics_lump_cpp: __GLOBAL__sub_I_runtime_graphics_lump_cpp, __ZN16RTreeCookerRemap5remapEPjjj: __ZN16RTreeCookerRemap5remapEPjjj, __Z47Register_UnityEngine_AI_NavMesh_AddOffMeshLinksv: __Z47Register_UnityEngine_AI_NavMesh_AddOffMeshLinksv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__get_weekdaynameERiRS4_S4_RjRKNS_5ctypeIwEE, __Z47Register_UnityEngine_Terrain_get_activeTerrainsv: __Z47Register_UnityEngine_Terrain_get_activeTerrainsv, __Z20HandleSteppedTangentRK11KeyframeTplI8Vector3fES3_RS0_: __Z20HandleSteppedTangentRK11KeyframeTplI8Vector3fES3_RS0_, __ZN14SerializedFileC2Ev: __ZN14SerializedFileC2Ev, __Z47ParticleSystemRenderer_Get_Custom_PropAlignmentP12Il2CppObject: __Z47ParticleSystemRenderer_Get_Custom_PropAlignmentP12Il2CppObject, __Z46Register_UnityEngine_Camera_set_opaqueSortModev: __Z46Register_UnityEngine_Camera_set_opaqueSortModev, __ZN14ParticleSystemC2E10MemLabelId18ObjectCreationMode: __ZN14ParticleSystemC2E10MemLabelId18ObjectCreationMode, __ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE: __ZN5physx22setupSolverConstraint4EPNS_24PxcSolverConstraint4DescEffRNS_24PxcConstraintBlockStreamERNS_25PxsConstraintBlockManagerE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE12readPropertyIfEEbRT_, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEE13stl_allocatorIS8_L18MemLabelIdentifier12ELi16EEE12__find_equalIS7_EERPNS_16__tree_node_baseIPvEESM_RKT_, __Z43Register_UnityEngine_Screen_get_resolutionsv: __Z43Register_UnityEngine_Screen_get_resolutionsv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZThn4_N16RayRTreeCallbackILi0ELb1EED1Ev: __ZThn4_N16RayRTreeCallbackILi0ELb1EED1Ev, __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_: __ZNSt3__26vectorIhNS_9allocatorIhEEE6assignIPhEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_, __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE8EndWriteEj: __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESE8EndWriteEj, __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_positionv: __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_positionv, __ZNK7b2World14GetTreeBalanceEv: __ZNK7b2World14GetTreeBalanceEv, __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI5FlareE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx21solveFriction_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5Unity5ClothD0Ev: __ZN5Unity5ClothD0Ev, __Z27Register_UnityEngine_GL_Endv: __Z27Register_UnityEngine_GL_Endv, __ZN19MeshParticleEmitter8TransferI14SafeBinaryReadEEvRT_: __ZN19MeshParticleEmitter8TransferI14SafeBinaryReadEEvRT_, __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15RelativeJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, _UNITY_LZ4_decompress_fast: _UNITY_LZ4_decompress_fast, __ZN11AudioSource14OnAddComponentEv: __ZN11AudioSource14OnAddComponentEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE19getConcreteTypeNameEv, __Z21setPxSceneDescGravityPN5physx11PxSceneDescENS_6PxVec3E: __Z21setPxSceneDescGravityPN5physx11PxSceneDescENS_6PxVec3E, __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __Z44WebCamTexture_Set_Custom_PropRequestedHeightP12Il2CppObjecti: __Z44WebCamTexture_Set_Custom_PropRequestedHeightP12Il2CppObjecti, __ZN9BoxPruner14findOverlapsMTER15MBP_PairManagerPKjPK10MBP_Object: __ZN9BoxPruner14findOverlapsMTER15MBP_PairManagerPKjPK10MBP_Object, __Z33UnityAdsSettings_CUSTOM_SetGameIdiP12Il2CppString: __Z33UnityAdsSettings_CUSTOM_SetGameIdiP12Il2CppString, __Z22getNbPxShape_MaterialsPKN5physx7PxShapeE: __Z22getNbPxShape_MaterialsPKN5physx7PxShapeE, __ZNK22MotionVectorRenderLoop18RenderObjectSorterclERK18RPDataMotionVectorS3_: __ZNK22MotionVectorRenderLoop18RenderObjectSorterclERK18RPDataMotionVectorS3_, __Z35getPxVehicleWheels_ConcreteTypeNamePKN5physx15PxVehicleWheelsE: __Z35getPxVehicleWheels_ConcreteTypeNamePKN5physx15PxVehicleWheelsE, __ZN20DynamicPropertySheetD2Ev: __ZN20DynamicPropertySheetD2Ev, __ZN12_GLOBAL__N_122SocketNetworkOutStream5writeEPKhj: __ZN12_GLOBAL__N_122SocketNetworkOutStream5writeEPKhj, __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __Z20PreApiCallChecksGLESPK7ApiGLESPKcS3_l: __Z20PreApiCallChecksGLESPK7ApiGLESPKcS3_l, __ZN5physx37PxJointLinearLimitPairGeneratedValuesC2EPKNS_22PxJointLinearLimitPairE: __ZN5physx37PxJointLinearLimitPairGeneratedValuesC2EPKNS_22PxJointLinearLimitPairE, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEE15growAndPushBackERKS2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128S2_NSt3__24lessIS2_EENS3_9allocatorINS3_4pairIS2_S2_EEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapI7Hash128S2_NSt3__24lessIS2_EENS3_9allocatorINS3_4pairIS2_S2_EEEEEEEvRT_17TransferMetaFlags, __Z29NavMeshAgent_CUSTOM_ResetPathP12Il2CppObject: __Z29NavMeshAgent_CUSTOM_ResetPathP12Il2CppObject, __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_boundsGlobalP12Il2CppObjectP4AABB: __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_get_boundsGlobalP12Il2CppObjectP4AABB, _UNITY_png_set_swap_alpha: _UNITY_png_set_swap_alpha, __ZN11UnityEngine15CloudWebService16SessionContainer20RestoreSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE: __ZN11UnityEngine15CloudWebService16SessionContainer20RestoreSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE, _UNITY_FT_GlyphLoader_Rewind: _UNITY_FT_GlyphLoader_Rewind, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx2Gu12TriangleMesh13getNbVerticesEv: __ZNK5physx2Gu12TriangleMesh13getNbVerticesEv, __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet: __ZN23ShaderVariantCollection10AddVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet, ___freadable: ___freadable, __Z44Register_UnityEngine_Canvas_get_isRootCanvasv: __Z44Register_UnityEngine_Canvas_get_isRootCanvasv, __ZN5Umbra20RuntimeTomeGenerator6ResultC2Ev: __ZN5Umbra20RuntimeTomeGenerator6ResultC2Ev, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj16EEENS0_19ReflectionAllocatorIS5_EEE15disposeElementsEv, __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEE19ResizeSTLStyleArrayERS4_iRK10MemLabelId, __ZN16Physics2DManager11FixedUpdateEv: __ZN16Physics2DManager11FixedUpdateEv, __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZMultiplierv: __Z74Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetZMultiplierv, __ZN4File5WriteEyPKvj: __ZN4File5WriteEyPKvj, __ZNK6Shader11IsSupportedEv: __ZNK6Shader11IsSupportedEv, __ZNSt3__221__throw_runtime_errorEPKc: __ZNSt3__221__throw_runtime_errorEPKc, _atanhl: _atanhl, __Z36Motion_CUSTOM_ValidateIfRetargetableP12Il2CppObjecth: __Z36Motion_CUSTOM_ValidateIfRetargetableP12Il2CppObjecth, _UNITY_tt_face_load_hdmx: _UNITY_tt_face_load_hdmx, __Z18CalculateImageSizeii13TextureFormat: __Z18CalculateImageSizeii13TextureFormat, _atanhf: _atanhf, __ZN12_GLOBAL__N_110Connection18getConnectionStateEv: __ZN12_GLOBAL__N_110Connection18getConnectionStateEv, __ZN14TerrainManager15CullAllTerrainsEP6CameraRK17CullingParameters: __ZN14TerrainManager15CullAllTerrainsEP6CameraRK17CullingParameters, __ZN5physx6shdfnd5ArrayIPNS_7NpSceneENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_7NpSceneENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx3Ext7D6Joint11prepareDataEv: __ZN5physx3Ext7D6Joint11prepareDataEv, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18UnityPropertySheet11UnityTexEnv8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN16SubstanceArchiveD2Ev: __ZN16SubstanceArchiveD2Ev, __ZNK26AnimatorOverrideController12StringFromIDEj: __ZNK26AnimatorOverrideController12StringFromIDEj, __ZNK12b2MotorJoint11GetMaxForceEv: __ZNK12b2MotorJoint11GetMaxForceEv, __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_GetCollisionv: __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_GetCollisionv, __ZN4FMOD8ChannelI7setModeEj: __ZN4FMOD8ChannelI7setModeEj, __ZN7mecanim20ValueArrayBlendBeginERNS_14ValueArrayMaskE: __ZN7mecanim20ValueArrayBlendBeginERNS_14ValueArrayMaskE, __ZN4Halo23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN4Halo23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN16b2BlockAllocatorD2Ev: __ZN16b2BlockAllocatorD2Ev, __ZL30FindScriptingClassForClassNamePKc: __ZL30FindScriptingClassForClassNamePKc, __ZNK5Umbra16LineSegmentQuery12getObjectSetEv: __ZNK5Umbra16LineSegmentQuery12getObjectSetEv, __Z38Display_CUSTOM_GetRenderingBuffersImpl13Il2Cpp_IntPtrP21ScriptingRenderBufferS1_: __Z38Display_CUSTOM_GetRenderingBuffersImpl13Il2Cpp_IntPtrP21ScriptingRenderBufferS1_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z11SkinGenericILi2ELb1ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi2ELb1ELb0EEvR12SkinMeshInfo, __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType: __ZN8PlayableC2EP11Il2CppClass18DirectorPlayerType, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXMultiplierv, __ZN21EnlightenSceneMapping14SetSceneHandleEi: __ZN21EnlightenSceneMapping14SetSceneHandleEi, __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject: __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetWorldSpaceP12Il2CppObject, __ZNK5physx10NpMaterial22getFrictionCombineModeEv: __ZNK5physx10NpMaterial22getFrictionCombineModeEv, __Z33Texture_Get_Custom_PropFilterModeP12Il2CppObject: __Z33Texture_Get_Custom_PropFilterModeP12Il2CppObject, __ZNK17CommonStringTable16FindCommonStringEPKc: __ZNK17CommonStringTable16FindCommonStringEPKc, __ZN15AudioReverbZone12AddToManagerEv: __ZN15AudioReverbZone12AddToManagerEv, __ZN20NavMeshBuildSettings8TransferI17RemapPPtrTransferEEvRT_: __ZN20NavMeshBuildSettings8TransferI17RemapPPtrTransferEEvRT_, __ZN27AnimatorControllerParameter8TransferI17RemapPPtrTransferEEvRT_: __ZN27AnimatorControllerParameter8TransferI17RemapPPtrTransferEEvRT_, __ZN13GfxDeviceNull25SetShaderPropertiesCopiedERK19ShaderPropertySheet: __ZN13GfxDeviceNull25SetShaderPropertiesCopiedERK19ShaderPropertySheet, __ZN5Light7PrecalcEv: __ZN5Light7PrecalcEv, __Z40OffMeshLink_Set_Custom_PropBiDirectionalP12Il2CppObjecth: __Z40OffMeshLink_Set_Custom_PropBiDirectionalP12Il2CppObjecth, __ZN27AnimationLayerMixerPlayable6Memory20CreateNodeStateArrayEiRKN7mecanim18ValueArrayConstantEbbbRNS1_6memory9AllocatorE: __ZN27AnimationLayerMixerPlayable6Memory20CreateNodeStateArrayEiRKN7mecanim18ValueArrayConstantEbbbRNS1_6memory9AllocatorE, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9underflowEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9underflowEv, __Z40Register_UnityEngine_AnimationCurve_Initv: __Z40Register_UnityEngine_AnimationCurve_Initv, __ZN9UnityGUID4InitEv: __ZN9UnityGUID4InitEv, __ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii: __ZL30CheckCubeArraySetGetPixelsArgsRK12CubemapArrayiPKv11CubemapFaceii, __Z35getPxVehicleDriveSimData4W_DiffDataPKN5physx23PxVehicleDriveSimData4WE: __Z35getPxVehicleDriveSimData4W_DiffDataPKN5physx23PxVehicleDriveSimData4WE, __Z51GeometryUtility_CUSTOM_INTERNAL_CALL_TestPlanesAABBP11Il2CppArrayRK4AABB: __Z51GeometryUtility_CUSTOM_INTERNAL_CALL_TestPlanesAABBP11Il2CppArrayRK4AABB, __ZN5physx16PxsFluidDynamics17OrderedIndexTableC2Ev: __ZN5physx16PxsFluidDynamics17OrderedIndexTableC2Ev, __ZN5physx2Gu5Debug9visualizeERKNS_17PxCapsuleGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_17PxCapsuleGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __Z34Joint_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_: __Z34Joint_Set_Custom_PropConnectedBodyP12Il2CppObjectS0_, __ZN8VRDevice20SetDeviceViewTextureEP13RenderTexture: __ZN8VRDevice20SetDeviceViewTextureEP13RenderTexture, __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetStyleStatePtrP12Il2CppObjectiRPv: __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetStyleStatePtrP12Il2CppObjectiRPv, __ZN19ConstantBuffersGLES13FindAndBindCBEiii: __ZN19ConstantBuffersGLES13FindAndBindCBEiii, __ZN19CharacterController4MoveERK8Vector3f: __ZN19CharacterController4MoveERK8Vector3f, __ZN16TimerQueriesGLESD2Ev: __ZN16TimerQueriesGLESD2Ev, __ZNSt3__224__generic_error_categoryD0Ev: __ZNSt3__224__generic_error_categoryD0Ev, __ZN7mecanim5human14GetMuscleRangeEPKNS0_5HumanEiRfS4_: __ZN7mecanim5human14GetMuscleRangeEPKNS0_5HumanEiRfS4_, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_25spatialHashUpdateSectionsEPNS_10PxBaseTaskEEEE11runInternalEv, __ZL32GeomOverlapCallback_SphereSphereRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL32GeomOverlapCallback_SphereSphereRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z36CleanupAnimationStateNetworkProviderv: __Z36CleanupAnimationStateNetworkProviderv, __ZN14ParticleSystem16SetupSubEmittersERS_R19ParticleSystemState: __ZN14ParticleSystem16SetupSubEmittersERS_R19ParticleSystemState, __Z46Register_UnityEngine_AudioSource_set_panStereov: __Z46Register_UnityEngine_AudioSource_set_panStereov, __Z43Texture_Get_Custom_PropAnisotropicFilteringv: __Z43Texture_Get_Custom_PropAnisotropicFilteringv, _lrintf: _lrintf, __Z19TestAndInsertObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE: __Z19TestAndInsertObjectP6ObjectiiR13dynamic_arrayIS0_Lj4EE, __ZN14AreaEffector2D14SetAngularDragEf: __ZN14AreaEffector2D14SetAngularDragEf, __ZN17ArchiveFileSystem18IsAbsoluteFilePathEPKc: __ZN17ArchiveFileSystem18IsAbsoluteFilePathEPKc, __ZN5physx17ConvexMeshBuilderD0Ev: __ZN5physx17ConvexMeshBuilderD0Ev, __Z13RegisterClassI18BuoyancyEffector2DEvv: __Z13RegisterClassI18BuoyancyEffector2DEvv, __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_f: __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_f, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpClothFabricEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN4FMOD8ChannelI13getAudibilityEPf: __ZN4FMOD8ChannelI13getAudibilityEPf, __Z41TerrainData_Set_Custom_PropTreePrototypesP12Il2CppObjectP11Il2CppArray: __Z41TerrainData_Set_Custom_PropTreePrototypesP12Il2CppObjectP11Il2CppArray, __ZN12TreeDatabase24RecalculateTreePositionsEv: __ZN12TreeDatabase24RecalculateTreePositionsEv, __ZN8GUILayer15InitializeClassEv: __ZN8GUILayer15InitializeClassEv, __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN12EventManager17InvokeEventCommonEPS_P10EventEntryPvi: __ZN12EventManager17InvokeEventCommonEPS_P10EventEntryPvi, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf: __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPjRf, __ZN5physx19NpClothParticleData18getDataAccessFlagsEv: __ZN5physx19NpClothParticleData18getDataAccessFlagsEv, __Z29StdTemplateConversionFunctionItbEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItbEbPvR14SafeBinaryRead, __ZNK5physx2Gu12TriangleMesh20computeWorldTriangleERNS_10PxTriangleEjRKNS_2Cm8Matrix34EPjS8_: __ZNK5physx2Gu12TriangleMesh20computeWorldTriangleERNS_10PxTriangleEjRKNS_2Cm8Matrix34EPjS8_, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEE4swapERS3_: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEE4swapERS3_, __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev: __ZN5physx42PxClothMotionConstraintConfigGeneratedInfoC2Ev, __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15ReflectionProbe17ShouldAutoRefreshEv: __ZN15ReflectionProbe17ShouldAutoRefreshEv, __Z63Register_UnityEngine_Connect_UnityAdsSettings_IsPlatformEnabledv: __Z63Register_UnityEngine_Connect_UnityAdsSettings_IsPlatformEnabledv, __ZNK14dtPathCorridor17containsPolyByRefEy: __ZNK14dtPathCorridor17containsPolyByRefEy, _atof: _atof, __ZN11UnityEngine15PlatformWrapper34GetRenderTextureFormatSupportFlagsEv: __ZN11UnityEngine15PlatformWrapper34GetRenderTextureFormatSupportFlagsEv, __Z47ParticleSystem_MainModule_CUSTOM_GetScalingModeP12Il2CppObject: __Z47ParticleSystem_MainModule_CUSTOM_GetScalingModeP12Il2CppObject, __ZN4FMOD6System13getNumDriversEPi: __ZN4FMOD6System13getNumDriversEPi, __ZN14UnityAnalyticsC2Ev: __ZN14UnityAnalyticsC2Ev, __Z63Register_UnityEngine_Transform_INTERNAL_CALL_TransformDirectionv: __Z63Register_UnityEngine_Transform_INTERNAL_CALL_TransformDirectionv, _getuid: _getuid, __ZN14AnimationState12CleanupClassEv: __ZN14AnimationState12CleanupClassEv, __Z49Register_UnityEngine_Rigidbody_set_freezeRotationv: __Z49Register_UnityEngine_Rigidbody_set_freezeRotationv, __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab19SerializedSubShader8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__get_long_sizeEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE15__get_long_sizeEv, __Z41Rigidbody_Get_Custom_PropSolverIterationsP12Il2CppObject: __Z41Rigidbody_Get_Custom_PropSolverIterationsP12Il2CppObject, __Z13RegisterClassI25RuntimeAnimatorControllerEvv: __Z13RegisterClassI25RuntimeAnimatorControllerEvv, __Z56ParticleSystem_SubEmittersModule_CUSTOM_RemoveSubEmitterP12Il2CppObjecti: __Z56ParticleSystem_SubEmittersModule_CUSTOM_RemoveSubEmitterP12Il2CppObjecti, __ZNK9Texture2D13GetDataFormatEv: __ZNK9Texture2D13GetDataFormatEv, __Z15FMOD_FILE_ClosePvS_: __Z15FMOD_FILE_ClosePvS_, __Z43Transform_CUSTOM_INTERNAL_get_localPositionP12Il2CppObjectP8Vector3f: __Z43Transform_CUSTOM_INTERNAL_get_localPositionP12Il2CppObjectP8Vector3f, __ZNSt3__26locale14__install_ctorERKS0_PNS0_5facetEl: __ZNSt3__26locale14__install_ctorERKS0_PNS0_5facetEl, __ZThn32_N17BillboardRendererD0Ev: __ZThn32_N17BillboardRendererD0Ev, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEE7getNameEv, __ZNK5physx2Sc15ClothFabricCore16getTetherAnchorsEPjj: __ZNK5physx2Sc15ClothFabricCore16getTetherAnchorsEPjj, __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_: __ZN5physx9PxBounds313transformFastERKNS_11PxTransformERKS0_, __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN9WWWCached14GetAssetBundleEv: __ZN9WWWCached14GetAssetBundleEv, __ZNSt3__212_GLOBAL__N_13mutEv: __ZNSt3__212_GLOBAL__N_13mutEv, __ZNK17AnimationCurveTplIfE14GetPreInfinityEv: __ZNK17AnimationCurveTplIfE14GetPreInfinityEv, __ZNK8Collider16GetContactOffsetEv: __ZNK8Collider16GetContactOffsetEv, __ZN5physx2Sn9XmlParser14processElementEPKcS3_RKNS_6shdfnd7FastXml14AttributePairsEi: __ZN5physx2Sn9XmlParser14processElementEPKcS3_RKNS_6shdfnd7FastXml14AttributePairsEi, __ZN14NavMeshCarving11AddObstacleER15NavMeshObstacleRi: __ZN14NavMeshCarving11AddObstacleER15NavMeshObstacleRi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj38ENS_22PxRepXPropertyAccessorILj38ENS_11PxRigidBodyEKffEEEEvRKT0_, __ZN13SplatDatabase14CheckAlphamapsEb: __ZN13SplatDatabase14CheckAlphamapsEb, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z50Register_UnityEngine_VR_VRSettings_get_renderScalev: __Z50Register_UnityEngine_VR_VRSettings_get_renderScalev, __Z41Display_CUSTOM_SetRenderingResolutionImpl13Il2Cpp_IntPtrii: __Z41Display_CUSTOM_SetRenderingResolutionImpl13Il2Cpp_IntPtrii, __ZN4PPtrI10AudioMixerE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI10AudioMixerE8TransferI14SafeBinaryReadEEvRT_, __Z19GetCpuDispatcherPtrv: __Z19GetCpuDispatcherPtrv, __ZN17ProceduralTexture39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN17ProceduralTexture39ShouldIgnoreInGarbageDependencyTrackingEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_, __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf: __Z21GetSoftShadowsEnabledbbN15QualitySettings13ShadowQualityEf, __Z32getPxVehicleDriveNWMDriveSimDataPKN5physx16PxVehicleDriveNWE: __Z32getPxVehicleDriveNWMDriveSimDataPKN5physx16PxVehicleDriveNWE, __ZNK5physx20AggregateOverlapTask7getNameEv: __ZNK5physx20AggregateOverlapTask7getNameEv, __ZN13OcclusionArea8TransferI14SafeBinaryReadEEvRT_: __ZN13OcclusionArea8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_j: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_S8_j, __ZN5physx2Sc10NPhaseCore7convertEPNS0_21ElementSimInteractionENS0_15InteractionTypeERNS0_10FilterInfoEb: __ZN5physx2Sc10NPhaseCore7convertEPNS0_21ElementSimInteractionENS0_15InteractionTypeERNS0_10FilterInfoEb, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcNS_8debugger4comm9SetCameraEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS7_19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj, _UNITY_png_start_read_image: _UNITY_png_start_read_image, __Z42getPxFixedJoint_ProjectionAngularTolerancePKN5physx12PxFixedJointE: __Z42getPxFixedJoint_ProjectionAngularTolerancePKN5physx12PxFixedJointE, __Z52Register_UnityEngine_TerrainData_RemoveTreePrototypev: __Z52Register_UnityEngine_TerrainData_RemoveTreePrototypev, _gray_raster_done: _gray_raster_done, __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15AudioEchoFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx16PxVehicleNoDrive12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx16PxVehicleNoDrive12createObjectERPhRNS_24PxDeserializationContextE, __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __ZNK21EnlightenSceneMapping15GetInstanceHashEi: __ZNK21EnlightenSceneMapping15GetInstanceHashEi, __Z69Register_UnityEngine_Profiling_Profiler_SetTempAllocatorRequestedSizev: __Z69Register_UnityEngine_Profiling_Profiler_SetTempAllocatorRequestedSizev, __ZN12NavMeshAgent13SetAutoRepathEb: __ZN12NavMeshAgent13SetAutoRepathEb, __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_14PxLightCpuTaskENS0_13TempAllocatorEE8recreateEj, __ZN21AssetBundleFileSystem10AddArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN21AssetBundleFileSystem10AddArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetTimeInternalv: __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_SetTimeInternalv, __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS0_9allocatorIS3_EEEEEvRT_j, __ZN19StreamedBinaryWriteILb1EE16TransferTypelessEPjPKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb1EE16TransferTypelessEPjPKc17TransferMetaFlags, __Z56Register_UnityEngine_Physics_set_penetrationPenaltyForcev: __Z56Register_UnityEngine_Physics_set_penetrationPenaltyForcev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgExNS_8ios_base7seekdirE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgExNS_8ios_base7seekdirE, __Z83Register_UnityEngine_Networking_DownloadHandlerScript_InternalSetPreallocatedBufferv: __Z83Register_UnityEngine_Networking_DownloadHandlerScript_InternalSetPreallocatedBufferv, __Z50Register_UnityEngine_ConfigurableJoint_get_yMotionv: __Z50Register_UnityEngine_ConfigurableJoint_get_yMotionv, __Z37getPxArticulationJoint_TargetVelocityPKN5physx19PxArticulationJointE: __Z37getPxArticulationJoint_TargetVelocityPKN5physx19PxArticulationJointE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx23solveExt1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx23solveExt1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZL19SweepBoxUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL19SweepBoxUserCapsulePKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_: __ZNSt3__26__sortIR23TreeInstanceIndexSorterPjEEvT0_S4_T_, __ZN15AnchoredJoint2D31SetAutoConfigureConnectedAnchorEb: __ZN15AnchoredJoint2D31SetAutoConfigureConnectedAnchorEb, __Z46Register_UnityEngine_AudioSource_set_maxVolumev: __Z46Register_UnityEngine_AudioSource_set_maxVolumev, __ZN10MonoScript5RenewEP11Il2CppClass: __ZN10MonoScript5RenewEP11Il2CppClass, __ZL21CheckMaterialsNotNullRK13dynamic_arrayI4PPtrI8MaterialELj4EERKS0_I10GameObjectE: __ZL21CheckMaterialsNotNullRK13dynamic_arrayI4PPtrI8MaterialELj4EERKS0_I10GameObjectE, __ZNK11AudioSource13GetSpatializeEv: __ZNK11AudioSource13GetSpatializeEv, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE10exceptionsEv, _UNITY_png_read_start_row: _UNITY_png_read_start_row, __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE: __ZN11UnityEngine9Animation29SetGenericFloatPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE, __Z25GetProceduralMemoryBudget19ProceduralCacheSize: __Z25GetProceduralMemoryBudget19ProceduralCacheSize, __ZNKSt3__214__codecvt_utf8IDsE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__214__codecvt_utf8IDsE10do_unshiftER11__mbstate_tPcS4_RS4_, __Z55Register_UnityEngine_VR_VRSettings_get_supportedDevicesv: __Z55Register_UnityEngine_VR_VRSettings_get_supportedDevicesv, __ZN10AtomicList5ClearEP10AtomicNodei: __ZN10AtomicList5ClearEP10AtomicNodei, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_17TransferMetaFlags, __ZN17ArchiveFileSystem12CreateAsFileER13FileEntryData: __ZN17ArchiveFileSystem12CreateAsFileER13FileEntryData, __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_: __ZNSt3__26vectorIN23ShaderVariantCollection11VariantInfoENS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12resize_deltaEjj, __ZNK7b2World13GetTreeHeightEv: __ZNK7b2World13GetTreeHeightEv, __ZN5physx21collideWithStaticMeshEjPNS_19PxsParticleCollDataEPNS_27PxsFluidParticleOpcodeCacheERKNS_2Gu13GeometryUnionERKNS_11PxTransformESA_fff: __ZN5physx21collideWithStaticMeshEjPNS_19PxsParticleCollDataEPNS_27PxsFluidParticleOpcodeCacheERKNS_2Gu13GeometryUnionERKNS_11PxTransformESA_fff, __ZNK21EnlightenSceneMapping27GetTerrainMainChunkSystemIdERiiPiS1_: __ZNK21EnlightenSceneMapping27GetTerrainMainChunkSystemIdERiiPiS1_, __Z72Camera_Get_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObject: __Z72Camera_Get_Custom_PropUseJitteredProjectionMatrixForTransparentRenderingP12Il2CppObject, __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE: __ZN5physx5cloth7SwCloth5clearERNS0_13SwConstraintsE, __ZN9GfxDevice18EndDynamicBatchingE13TransformType: __ZN9GfxDevice18EndDynamicBatchingE13TransformType, _UNITY_FT_Get_CMap_Language_ID: _UNITY_FT_Get_CMap_Language_ID, __Z44Register_UnityEngine_AndroidJNI_GetLongFieldv: __Z44Register_UnityEngine_AndroidJNI_GetLongFieldv, __Z42Physics_Get_Custom_PropQueriesHitBackfacesv: __Z42Physics_Get_Custom_PropQueriesHitBackfacesv, __ZN21DownloadHandlerBufferD2Ev: __ZN21DownloadHandlerBufferD2Ev, __Z33Shader_Get_Custom_PropRenderQueueP12Il2CppObject: __Z33Shader_Get_Custom_PropRenderQueueP12Il2CppObject, __ZNK15TerrainCollider15SupportsTriggerEv: __ZNK15TerrainCollider15SupportsTriggerEv, __Z24RegisterStrippedTypeInfoI13BoxCollider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI13BoxCollider2DEviPKcS2_, _remainderl: _remainderl, __ZN14PhysicsManager18GetIgnoreCollisionEii: __ZN14PhysicsManager18GetIgnoreCollisionEii, __Z54Register_UnityEngine_AudioSettings_INTERNAL_CALL_Resetv: __Z54Register_UnityEngine_AudioSettings_INTERNAL_CALL_Resetv, __ZN5physx21AggregateActorManager6resizeEj: __ZN5physx21AggregateActorManager6resizeEj, __ZNK8Collider10HasEnabledEv: __ZNK8Collider10HasEnabledEv, __Z51NavMeshObstacle_Get_Custom_PropCarvingMoveThresholdP12Il2CppObject: __Z51NavMeshObstacle_Get_Custom_PropCarvingMoveThresholdP12Il2CppObject, __Z36setPxVehicleDriveSimData_AutoBoxDataPN5physx21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataE: __Z36setPxVehicleDriveSimData_AutoBoxDataPN5physx21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataE, __Z29StdTemplateConversionFunctionIhiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhiEbPvR14SafeBinaryRead, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_7NpShapeEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK15ParticleEmitter10GetEnabledEv: __ZNK15ParticleEmitter10GetEnabledEv, __Z29GUIStyle_CUSTOM_Internal_DrawP12Il2CppObjectR26MonoInternal_DrawArguments: __Z29GUIStyle_CUSTOM_Internal_DrawP12Il2CppObjectR26MonoInternal_DrawArguments, __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE: __ZN19ShaderPropertySheet8SetFloatERKN9ShaderLab16FastPropertyNameEfNS_8SetFlagsE, __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy: __ZN13dynamic_arrayIsLj2EE18resize_initializedEjRKs12ResizePolicy, __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN19AssetBundleManifest23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK13Vector2fIcallS1_fS1_fiffP12RaycastHit2D: __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_BoxCastRK13Vector2fIcallS1_fS1_fiffP12RaycastHit2D, __ZN9Rigidbody26SupportedMessagesDidChangeEi: __ZN9Rigidbody26SupportedMessagesDidChangeEi, __Z36Camera_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE: __Z36Camera_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE, __ZN5physx19PxsSimObjectFactoryD2Ev: __ZN5physx19PxsSimObjectFactoryD2Ev, __Z37CanvasRenderer_CUSTOM_SetAlphaTextureP12Il2CppObjectS0_: __Z37CanvasRenderer_CUSTOM_SetAlphaTextureP12Il2CppObjectS0_, __Z36CanvasRenderer_Set_Custom_PropIsMaskP12Il2CppObjecth: __Z36CanvasRenderer_Set_Custom_PropIsMaskP12Il2CppObjecth, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE18__get_long_pointerEv, __Z26Camera_Get_Custom_PropMainv: __Z26Camera_Get_Custom_PropMainv, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ParticlePacketShapeENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5physx2Sc17ParticleSystemSim16visualizeEndStepERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim16visualizeEndStepERNS_2Cm12RenderOutputE, _clog: _clog, __Z31Joint_Get_Custom_PropBreakForceP12Il2CppObject: __Z31Joint_Get_Custom_PropBreakForceP12Il2CppObject, __ZN6Object15SetIsPersistentEb: __ZN6Object15SetIsPersistentEb, __Z22setPxMeshScaleRotationPN5physx11PxMeshScaleENS_6PxQuatE: __Z22setPxMeshScaleRotationPN5physx11PxMeshScaleENS_6PxQuatE, __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE: __ZN9Rigidbody23WakeupPxActorIfPossibleEPN5physx7PxActorE, __ZN27ParticleSystemReadOnlyState8TransferI14SafeBinaryReadEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI14SafeBinaryReadEEvRT_, __Z62Register_UnityEngine_TerrainData_Internal_GetMaximumResolutionv: __Z62Register_UnityEngine_TerrainData_Internal_GetMaximumResolutionv, __ZN27TrailModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN27TrailModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN7mecanim4hand4HandC2Ev: __ZN7mecanim4hand4HandC2Ev, __ZN13UnityProfiler21FinalizeAndStoreFrameEP17ProfilerFrameData: __ZN13UnityProfiler21FinalizeAndStoreFrameEP17ProfilerFrameData, __Z32CalculateCustomCullingParametersR17CullingParametersRK13LODParametersjPK5Planei: __Z32CalculateCustomCullingParametersR17CullingParametersRK13LODParametersjPK5Planei, __Z54Register_UnityEngine_Physics2D_get_maxLinearCorrectionv: __Z54Register_UnityEngine_Physics2D_get_maxLinearCorrectionv, __ZNK5physx3Ext13DistanceJoint21getDistanceJointFlagsEv: __ZNK5physx3Ext13DistanceJoint21getDistanceJointFlagsEv, __ZN9GfxDevice14ProfileControlENS_17GfxProfileControlEj: __ZN9GfxDevice14ProfileControlENS_17GfxProfileControlEj, __ZN14RenderSettings19PostInitializeClassEv: __ZN14RenderSettings19PostInitializeClassEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferentialNWDataEEEEclILj550ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z54Register_UnityEngine_Camera_Internal_RenderToCubemapRTv: __Z54Register_UnityEngine_Camera_Internal_RenderToCubemapRTv, __Z30IntersectSphereSphereInclusiveRK6SphereS1_: __Z30IntersectSphereSphereInclusiveRK6SphereS1_, __Z28TextMesh_Set_Custom_PropFontP12Il2CppObjectS0_: __Z28TextMesh_Set_Custom_PropFontP12Il2CppObjectS0_, __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_ConnectInternalv: __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_ConnectInternalv, __ZNK6IDList20CanHaveKeyboardFocusEi: __ZNK6IDList20CanHaveKeyboardFocusEi, __ZNK9Transform13GetWorldScaleEv: __ZNK9Transform13GetWorldScaleEv, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb0ELb1ELb1ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZN9GfxDevice19SetProjectionMatrixERK10Matrix4x4f: __ZN9GfxDevice19SetProjectionMatrixERK10Matrix4x4f, __Z58Register_UnityEngine_Physics_INTERNAL_CALL_RaycastNonAllocv: __Z58Register_UnityEngine_Physics_INTERNAL_CALL_RaycastNonAllocv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18TransitionConstantEEEEEvRT_17TransferMetaFlags, __Z29AnimationCurve_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArray: __Z29AnimationCurve_CUSTOM_SetKeysP12Il2CppObjectP11Il2CppArray, __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19onConstraintReleaseEv, __ZN7mecanim9animation12AvatarMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14FileCacherReadD0Ev: __ZN14FileCacherReadD0Ev, __Z47Camera_CUSTOM_INTERNAL_CALL_GetStereoViewMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f: __Z47Camera_CUSTOM_INTERNAL_CALL_GetStereoViewMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE8pushNameEPKc, __Z21getPxSceneDescGravityPKN5physx11PxSceneDescE: __Z21getPxSceneDescGravityPKN5physx11PxSceneDescE, __ZN15DirectorManager16GenerateUniqueIdEv: __ZN15DirectorManager16GenerateUniqueIdEv, __ZN5physx7profile15ZoneManagerImplD0Ev: __ZN5physx7profile15ZoneManagerImplD0Ev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZNK25MultiBlocksMemoryFileData4ReadEyyPv: __ZNK25MultiBlocksMemoryFileData4ReadEyyPv, __ZNK12TLSAllocatorI14StackAllocatorE21GetReservedMemorySizeEv: __ZNK12TLSAllocatorI14StackAllocatorE21GetReservedMemorySizeEv, __ZNSt16invalid_argumentD0Ev: __ZNSt16invalid_argumentD0Ev, __Z31Motion_Get_Custom_PropIsLoopingP12Il2CppObject: __Z31Motion_Get_Custom_PropIsLoopingP12Il2CppObject, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20getRigidDynamicFlagsEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE20getRigidDynamicFlagsEv, __ZNK5physx3Cct17CapsuleController9getHeightEv: __ZNK5physx3Cct17CapsuleController9getHeightEv, __ZN33AssetBundleLoadFromAsyncOperation20IntegrateImmediatelyEv: __ZN33AssetBundleLoadFromAsyncOperation20IntegrateImmediatelyEv, __Z39AudioReverbFilter_Set_Custom_PropRoomHFP12Il2CppObjectf: __Z39AudioReverbFilter_Set_Custom_PropRoomHFP12Il2CppObjectf, __ZN39AssetBundleLoadFromStreamAsyncOperation11SetPriorityEi: __ZN39AssetBundleLoadFromStreamAsyncOperation11SetPriorityEi, __Z51Register_UnityEngine_TerrainData_get_heightmapWidthv: __Z51Register_UnityEngine_TerrainData_get_heightmapWidthv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEEEvPT_jRKT0_RKT1_j, __ZN7dtCrowd21updateAgentFilterCostEiif: __ZN7dtCrowd21updateAgentFilterCostEiif, __ZN5physx2Sc11Interaction10onActivateEj: __ZN5physx2Sc11Interaction10onActivateEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData16EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13ComputeShader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z43GUIClip_CUSTOM_INTERNAL_CALL_Unclip_Vector2R13Vector2fIcall: __Z43GUIClip_CUSTOM_INTERNAL_CALL_Unclip_Vector2R13Vector2fIcall, __ZNK5physx20ProcessBPResultsTask7getNameEv: __ZNK5physx20ProcessBPResultsTask7getNameEv, __ZN5physx16PxsIslandManager21clearEdgeCreatedFlagsEv: __ZN5physx16PxsIslandManager21clearEdgeCreatedFlagsEv, __ZN5physx15PxsParticleData13setPositionsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE: __ZN5physx15PxsParticleData13setPositionsVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE, __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE: __ZN8Animator14FireBehavioursEN7mecanim12statemachine19StateMachineMessageE, __ZNK5physx14PxTriangleMesh19getConcreteTypeNameEv: __ZNK5physx14PxTriangleMesh19getConcreteTypeNameEv, __Z45Register_UnityEngine_Object_FindObjectsOfTypev: __Z45Register_UnityEngine_Object_FindObjectsOfTypev, __ZNK5physx7NpShape11getAPISceneEv: __ZNK5physx7NpShape11getAPISceneEv, __ZNK8VRDevice17GetOverrideAspectEv: __ZNK8VRDevice17GetOverrideAspectEv, __Z49AudioReverbFilter_Set_Custom_PropReflectionsLevelP12Il2CppObjectf: __Z49AudioReverbFilter_Set_Custom_PropReflectionsLevelP12Il2CppObjectf, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN16SpriteRenderData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Unity17ConfigurableJoint6CreateEv: __ZN5Unity17ConfigurableJoint6CreateEv, __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_: __ZNSt3__216__pad_and_outputIcNS_11char_traitsIcEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_, __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_fS2_S6_S7_fb: __ZN5physx18getImpulseResponseERKNS_16PxsSolverExtBodyERKNS_2Cm13SpatialVectorERS4_fS2_S6_S7_fb, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z44AudioSource_Set_Custom_PropBypassReverbZonesP12Il2CppObjecth: __Z44AudioSource_Set_Custom_PropBypassReverbZonesP12Il2CppObjecth, _UNITY_FT_FloorFix: _UNITY_FT_FloorFix, __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_set_originCustomP12Il2CppObjectRK8Vector3f: __Z54LightProbeProxyVolume_CUSTOM_INTERNAL_set_originCustomP12Il2CppObjectRK8Vector3f, __ZN12AudioManager8TransferI14SafeBinaryReadEEvRT_: __ZN12AudioManager8TransferI14SafeBinaryReadEEvRT_, __ZNK26LegacyTreeInstanceRenderer11GetMaterialEi: __ZNK26LegacyTreeInstanceRenderer11GetMaterialEi, __ZNK9Rigidbody14GetAngularDragEv: __ZNK9Rigidbody14GetAngularDragEv, __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity9Component23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNSt3__219declare_no_pointersEPcj: __ZNSt3__219declare_no_pointersEPcj, __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN28LightProbeProxyVolumeManager19OnLightProbesUpdateEv: __ZN28LightProbeProxyVolumeManager19OnLightProbesUpdateEv, __Z45Register_UnityEngine_Sprite_get_pixelsPerUnitv: __Z45Register_UnityEngine_Sprite_get_pixelsPerUnitv, __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN10FileSystem5StartEv: __ZN10FileSystem5StartEv, __Z21InitializeHaloManagerv: __Z21InitializeHaloManagerv, __ZN37AssetBundleLoadFromFileAsyncOperation14LoadArchiveJobEPv: __ZN37AssetBundleLoadFromFileAsyncOperation14LoadArchiveJobEPv, __ZN13BoxCollider2D12SetPolygon2DEP9Polygon2D: __ZN13BoxCollider2D12SetPolygon2DEP9Polygon2D, __ZN19SkinnedMeshRenderer12UploadClothsERK13dynamic_arrayIPS_Lj4EE: __ZN19SkinnedMeshRenderer12UploadClothsERK13dynamic_arrayIPS_Lj4EE, __ZN11NamedObjectD2Ev: __ZN11NamedObjectD2Ev, __ZN11BoxCollider12ScaleChangedEv: __ZN11BoxCollider12ScaleChangedEv, __ZNK5physx40PxVehicleTireLoadFilterDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEEEEEjT_j: __ZNK5physx40PxVehicleTireLoadFilterDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleTireLoadFilterDataEEEEEEEjT_j, __Z44Terrain_CUSTOM_SetSplatMaterialPropertyBlockP12Il2CppObjectS0_: __Z44Terrain_CUSTOM_SetSplatMaterialPropertyBlockP12Il2CppObjectS0_, __ZN8Remapper38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier: __ZN8Remapper38InstanceIDToSerializedObjectIdentifierEiR26SerializedObjectIdentifier, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIwEE, __Z53Register_UnityEngine_ParticleSystem_get_particleCountv: __Z53Register_UnityEngine_ParticleSystem_get_particleCountv, __ZNK14Texture2DArray9GetPixelsEiP10ColorRGBAfii: __ZNK14Texture2DArray9GetPixelsEiP10ColorRGBAfii, __ZNK15FileSystemEntry6ParentEPS_: __ZNK15FileSystemEntry6ParentEPS_, __Z8CopyBlobIN7mecanim9animation14AvatarConstantEEPT_RKS3_RNS0_6memory9AllocatorERj: __Z8CopyBlobIN7mecanim9animation14AvatarConstantEEPT_RKS3_RNS0_6memory9AllocatorERj, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18clothPreprocessingEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Object23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_SetCollisionv: __Z66Register_UnityEngine_ParticleSystem_SubEmittersModule_SetCollisionv, __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_: __ZN5physx2Gu16computeOBBPointsEPNS_6PxVec3ERKS1_S4_S4_S4_S4_, __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_12PxConstraintENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN5physx16PxRepXSerializerD2Ev: __ZN5physx16PxRepXSerializerD2Ev, __ZN18ScriptingArguments9GetTypeAtEi: __ZN18ScriptingArguments9GetTypeAtEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z42LineRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti: __Z42LineRenderer_Set_Custom_PropNumCapVerticesP12Il2CppObjecti, __ZN22PerThreadPageAllocatorC2ER19AtomicPageAllocator: __ZN22PerThreadPageAllocatorC2ER19AtomicPageAllocator, __Z13RegisterClassI13ConstantForceEvv: __Z13RegisterClassI13ConstantForceEvv, __ZNKSt3__28messagesIcE8do_closeEi: __ZNKSt3__28messagesIcE8do_closeEi, _encode_mcu_gather: _encode_mcu_gather, __Z30CustomEventData_CUSTOM_AddCharP12Il2CppObjectP12Il2CppStringt: __Z30CustomEventData_CUSTOM_AddCharP12Il2CppObjectP12Il2CppStringt, __Z41Register_UnityEngine_Animator_get_isHumanv: __Z41Register_UnityEngine_Animator_get_isHumanv, __Z55Terrain_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f: __Z55Terrain_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f, __Z30scripting_stack_trace_info_forP15Il2CppExceptionR14StackTraceInfo: __Z30scripting_stack_trace_info_forP15Il2CppExceptionR14StackTraceInfo, __ZNK14DataBufferGLES12GetRenderAgeEv: __ZNK14DataBufferGLES12GetRenderAgeEv, __Z57Register_UnityEngine_SystemInfo_get_supportsMotionVectorsv: __Z57Register_UnityEngine_SystemInfo_get_supportsMotionVectorsv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjjw, __Z67Register_UnityEngine_ParticleSystem_ShapeModule_SetAlignToDirectionv: __Z67Register_UnityEngine_ParticleSystem_ShapeModule_SetAlignToDirectionv, __ZN19ShaderPropertySheet5ClearEb: __ZN19ShaderPropertySheet5ClearEb, __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN2UI11CanvasGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4crnd17crnd_unpack_levelEPvPS0_jjj: __ZN4crnd17crnd_unpack_levelEPvPS0_jjj, __Z23getPxD6Joint_TwistLimitPKN5physx9PxD6JointE: __Z23getPxD6Joint_TwistLimitPKN5physx9PxD6JointE, __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI9UnityGUIDE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZZ23InitPlayerLoopCallbacksvEN44EarlyUpdateResetFrameStatsAfterPresentstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN44EarlyUpdateResetFrameStatsAfterPresentstruct7ForwardEv, __ZN5physx16PxVehicleNoDrive6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE: __ZN5physx16PxVehicleNoDrive6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE, _cpowf: _cpowf, __Z44Register_UnityEngine_Light_GetCommandBuffersv: __Z44Register_UnityEngine_Light_GetCommandBuffersv, __ZN16LevelGameManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN16LevelGameManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx7NpShape11setGeometryERKNS_10PxGeometryE: __ZN5physx7NpShape11setGeometryERKNS_10PxGeometryE, __Z25GetApplicationManagedPathv: __Z25GetApplicationManagedPathv, __ZN11OffMeshLink12SetActivatedEb: __ZN11OffMeshLink12SetActivatedEb, __Z53ParticleSystem_NoiseModule_CUSTOM_GetOctaveMultiplierP12Il2CppObject: __Z53ParticleSystem_NoiseModule_CUSTOM_GetOctaveMultiplierP12Il2CppObject, __Z26DirectorPlayer_CUSTOM_StopP12Il2CppObject: __Z26DirectorPlayer_CUSTOM_StopP12Il2CppObject, __ZNSt3__215messages_bynameIcEC2EPKcj: __ZNSt3__215messages_bynameIcEC2EPKcj, __ZN12CubemapArray8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12CubemapArray8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibPv: __ZN17SharedTextureDataC2E10MemLabelIdii13TextureFormatiiibPv, __ZN11AudioModule23DeleteAudioCustomFilterEP17AudioCustomFilter: __ZN11AudioModule23DeleteAudioCustomFilterEP17AudioCustomFilter, __ZN12_GLOBAL__N_1L4gANDERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L4gANDERN5physx12PxGroupsMaskERKS1_S4_, __ZN14PhysicMaterial5ResetEv: __ZN14PhysicMaterial5ResetEv, __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesERKNS0_14IterationStateIS2_EE: __ZN5physx5cloth11SwCollisionI8Scalar4fE16collideTrianglesERKNS0_14IterationStateIS2_EE, __ZN5physx14PxRigidBodyExt23addLocalForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb: __ZN5physx14PxRigidBodyExt23addLocalForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN11BoxCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11BoxCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN11AudioFilter4InitEv: __ZN11AudioFilter4InitEv, __ZN9ShaderLab7Program13AddSubProgramEPNS_10SubProgramE: __ZN9ShaderLab7Program13AddSubProgramEPNS_10SubProgramE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Sn13XmlNodeReader7releaseEv: __ZN5physx2Sn13XmlNodeReader7releaseEv, __ZN5physx2Gu17SweepBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu17SweepBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE, _wcsncmp: _wcsncmp, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z39ColorUtility_CUSTOM_DoTryParseHtmlColorP12Il2CppStringP16ColorRGBA32Icall: __Z39ColorUtility_CUSTOM_DoTryParseHtmlColorP12Il2CppStringP16ColorRGBA32Icall, __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_: __ZNSt3__26__sortIR11EventSorterP14AnimationEventEEvT0_S5_T_, __Z48DownloadHandler_CUSTOM_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringj: __Z48DownloadHandler_CUSTOM_InternalCreateAssetBundleP12Il2CppObjectP12Il2CppStringj, __ZN5physx14PxsComputeAABBEbPKNS_12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_: __ZN5physx14PxsComputeAABBEbPKNS_12PxcRigidBodyEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS6_, __ZN13MonoBehaviour23VirtualRedirectTransferER14SafeBinaryRead: __ZN13MonoBehaviour23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE6resizeEjRKS3_, __ZN12_GLOBAL__N_110Connection16sendErrorMessageEjPKcS2_j: __ZN12_GLOBAL__N_110Connection16sendErrorMessageEjPKcS2_j, __Z35Camera_Get_Custom_PropTargetTextureP12Il2CppObject: __Z35Camera_Get_Custom_PropTargetTextureP12Il2CppObject, __ZNSt3__26__sortIRNS_6__lessIjjEEPjEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIjjEEPjEEvT0_S5_T_, __ZN5physx13NpRigidStatic15switchFromNoSimEv: __ZN5physx13NpRigidStatic15switchFromNoSimEv, __ZN15AudioMixerGroup13AwakeFromLoadE17AwakeFromLoadMode: __ZN15AudioMixerGroup13AwakeFromLoadE17AwakeFromLoadMode, __ZN14NavMeshManagerD2Ev: __ZN14NavMeshManagerD2Ev, __ZN13GfxDeviceGLES13ReadbackImageER14ImageReferenceiiiiii: __ZN13GfxDeviceGLES13ReadbackImageER14ImageReferenceiiiiii, __ZN12IFileAdapter5WriteER13FileEntryDatayPvPy: __ZN12IFileAdapter5WriteER13FileEntryDatayPvPy, __ZThn12_N5physx10NpMaterialD1Ev: __ZThn12_N5physx10NpMaterialD1Ev, __ZN12_GLOBAL__N_123FStreamNetworkOutStream5writeEPKhj: __ZN12_GLOBAL__N_123FStreamNetworkOutStream5writeEPKhj, __ZN5physx7NpScene18removeRigidDynamicERNS_14NpRigidDynamicEbb: __ZN5physx7NpScene18removeRigidDynamicERNS_14NpRigidDynamicEbb, _UNITY_png_default_write_data: _UNITY_png_default_write_data, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj433ES4_NS_9PxD6Drive4EnumENS_14PxD6JointDriveENS_27PxD6JointDriveGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_, __Z32getNbPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveE: __Z32getNbPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveE, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE19getConcreteTypeNameEv, __ZN11KeyframeTplI8Vector3fEC2EfRKS0_: __ZN11KeyframeTplI8Vector3fEC2EfRKS0_, __ZN12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE: __ZN12_GLOBAL__N_110Connection13onZoneRemovedERN5physx13PxProfileZoneE, _jn: _jn, __Z47Register_UnityEngine_Texture2DArray_SetPixels32v: __Z47Register_UnityEngine_Texture2DArray_SetPixels32v, __ZN6Camera20WindowSizeHasChangedEv: __ZN6Camera20WindowSizeHasChangedEv, __ZNK11NoiseModule12PreviewNoiseILi3EEEvP9Texture2DP10ColorRGBAf: __ZNK11NoiseModule12PreviewNoiseILi3EEEvP9Texture2DP10ColorRGBAf, __ZN5physx2Sc7BodySim24sleepStateIntegrityCheckEv: __ZN5physx2Sc7BodySim24sleepStateIntegrityCheckEv, __ZN5physx3Cct15ObstacleContext13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Cct15ObstacleContext13onOriginShiftERKNS_6PxVec3E, __Z62Register_UnityEngine_ConstantForce_INTERNAL_set_relativeTorquev: __Z62Register_UnityEngine_ConstantForce_INTERNAL_set_relativeTorquev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj603ENS_22PxRepXPropertyAccessorILj603ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj603ENS_22PxRepXPropertyAccessorILj603ES4_ffEEEEvRKT0_, __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI14SafeBinaryReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __ZN5physx27PxHeightFieldRepXSerializerD0Ev: __ZN5physx27PxHeightFieldRepXSerializerD0Ev, __ZNK5physx7NpScene8stopReadEv: __ZNK5physx7NpScene8stopReadEv, __ZN8UserList15GetEntryInOtherEi: __ZN8UserList15GetEntryInOtherEi, __ZN10MeshFilterD2Ev: __ZN10MeshFilterD2Ev, __ZNK5physx2Sn9MetaClass14getFieldByNameEPKcRNS0_15PxMetaDataEntryE: __ZNK5physx2Sn9MetaClass14getFieldByNameEPKcRNS0_15PxMetaDataEntryE, __Z20FindShadowMapInCacheP14ShadowMapCachei: __Z20FindShadowMapInCacheP14ShadowMapCachei, __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_: __ZNSt3__27__sort3IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_T_, __ZNK24DownloadHandlerAudioClip8GetBytesEv: __ZNK24DownloadHandlerAudioClip8GetBytesEv, __Z51Register_UnityEngine_Animation_PlayDefaultAnimationv: __Z51Register_UnityEngine_Animation_PlayDefaultAnimationv, __Z64Register_UnityEngine_TerrainData_set_Internal_alphamapResolutionv: __Z64Register_UnityEngine_TerrainData_set_Internal_alphamapResolutionv, __ZN4FMOD12ChannelGroup8addGroupEPS0_: __ZN4FMOD12ChannelGroup8addGroupEPS0_, __ZN17AnimationPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE: __ZN17AnimationPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE, __ZL17WriteToBufferFuncPvPhj: __ZL17WriteToBufferFuncPvPhj, __Z52Register_UnityEngine_Effector2D_get_requiresColliderv: __Z52Register_UnityEngine_Effector2D_get_requiresColliderv, __ZNK12CullingGroup13GetUpdateTypeEv: __ZNK12CullingGroup13GetUpdateTypeEv, __ZNK6Shader11GetBlobDataEjRPKhRj: __ZNK6Shader11GetBlobDataEjRPKhRj, __ZN2UI6Canvas15AddNestedCanvasEPS0_: __ZN2UI6Canvas15AddNestedCanvasEPS0_, __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7Texture8TransferI18StreamedBinaryReadILb1EEEEvRT_, _j0: _j0, __ZNK9AudioClip20GetMusicChannelCountEv: __ZNK9AudioClip20GetMusicChannelCountEv, __Z57Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Vector2v: __Z57Register_UnityEngine_GUIClip_INTERNAL_CALL_Unclip_Vector2v, _getdelim: _getdelim, __ZNK3WWW17GetUnityWebStreamEv: __ZNK3WWW17GetUnityWebStreamEv, __ZN5physx21PxcArticulationHelper22createTangentialSpringERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Efff: __ZN5physx21PxcArticulationHelper22createTangentialSpringERKNS_9PxcFsDataEPKNS_19PxsArticulationLinkEjRNS_24PxcSolverConstraint1DExtERKNS_6PxVec3Efff, __ZL22stbir__filter_triangleff: __ZL22stbir__filter_triangleff, _ft_var_apply_tuple: _ft_var_apply_tuple, __Z31createFinalizeContacts_ParallelN5physx14PxFrictionType4EnumEPNS_17PxcSolverBodyDataERNS_16PxsThreadContextEffffPNS_10PxsContextEPijj: __Z31createFinalizeContacts_ParallelN5physx14PxFrictionType4EnumEPNS_17PxcSolverBodyDataERNS_16PxsThreadContextEffffPNS_10PxsContextEPijj, __Z48Register_UnityEngine_Shader_get_globalMaximumLODv: __Z48Register_UnityEngine_Shader_get_globalMaximumLODv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z50ParticleSystem_ShapeModule_CUSTOM_SetUseMeshColorsP12Il2CppObjecth: __Z50ParticleSystem_ShapeModule_CUSTOM_SetUseMeshColorsP12Il2CppObjecth, __ZN5physx3Cct17CapsuleController9setHeightEf: __ZN5physx3Cct17CapsuleController9setHeightEf, __Z20tessGetVertexIndicesP14TESStesselator: __Z20tessGetVertexIndicesP14TESStesselator, __ZNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEE8__appendEj, __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_: __Z12CombineCurveI11QuaternionfEvRK17AnimationCurveTplIfEiRS1_IT_ERKS5_, __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji: __Z21DecodeAlpha3BitLinearPjRK23DXTAlphaBlock3BitLineariji, __ZN5physx2Sn21SerializationRegistryD2Ev: __ZN5physx2Sn21SerializationRegistryD2Ev, __ZN19SpriteMeshGenerator4path3infEi: __ZN19SpriteMeshGenerator4path3infEi, __ZN19CharacterController9GetCenterEv: __ZN19CharacterController9GetCenterEv, __Z72Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_CalculatePathInternalv: __Z72Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_CalculatePathInternalv, __Z48Register_UnityEngine_ParticleEmitter_set_minSizev: __Z48Register_UnityEngine_ParticleEmitter_set_minSizev, __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE: __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE4copyIS5_EEvRKNS1_IS3_T_EE, __Z53Register_UnityEngine_Rigidbody_get_maxAngularVelocityv: __Z53Register_UnityEngine_Rigidbody_get_maxAngularVelocityv, __ZN15dtLocalBoundaryC2Ev: __ZN15dtLocalBoundaryC2Ev, __ZNK8GUILayer26GetTypeInfoVirtualInternalEv: __ZNK8GUILayer26GetTypeInfoVirtualInternalEv, _catclose: _catclose, __ZN5Unity11SpringJoint20ApplySetupAxesToDescEi: __ZN5Unity11SpringJoint20ApplySetupAxesToDescEi, __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetBirthP12Il2CppObjecti: __Z48ParticleSystem_SubEmittersModule_CUSTOM_GetBirthP12Il2CppObjecti, __ZN9GfxDevice15SetStereoTargetE15StereoscopicEye: __ZN9GfxDevice15SetStereoTargetE15StereoscopicEye, __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef: __ZN14DetailRenderer15GrabCachedPatchEii16DetailRenderModef, __ZN8LODGroup23RegisterCachedRenderersEv: __ZN8LODGroup23RegisterCachedRenderersEv, __ZN11UnityEngine7Connect12AppStopEventC2Ev: __ZN11UnityEngine7Connect12AppStopEventC2Ev, _jsimd_can_fdct_ifast: _jsimd_can_fdct_ifast, __ZN16ParticleRenderer20SetUVAnimationCyclesEf: __ZN16ParticleRenderer20SetUVAnimationCyclesEf, __ZN16ShapeCast2DQuery19InitializeCastShapeEv: __ZN16ShapeCast2DQuery19InitializeCastShapeEv, __Z39Renderer_Get_Custom_PropSharedMaterialsP12Il2CppObject: __Z39Renderer_Get_Custom_PropSharedMaterialsP12Il2CppObject, __Z35setPxParticleReadDataPositionBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE: __Z35setPxParticleReadDataPositionBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKNS_6PxVec3EEE, __ZNK5physx17PxsCCDAdvanceTask7getNameEv: __ZNK5physx17PxsCCDAdvanceTask7getNameEv, __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv: __ZNKSt3__220__vector_base_commonILb1EE20__throw_length_errorEv, __ZN9Texture3DC2E10MemLabelId18ObjectCreationMode: __ZN9Texture3DC2E10MemLabelId18ObjectCreationMode, __Z54Register_UnityEngine_AudioSource_INTERNAL_CALL_UnPausev: __Z54Register_UnityEngine_AudioSource_INTERNAL_CALL_UnPausev, __ZNK14StackAllocator8ContainsEPKv: __ZNK14StackAllocator8ContainsEPKv, __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE8pushNameEPKc, __ZN5physx18PxsSolverStartTaskD2Ev: __ZN5physx18PxsSolverStartTaskD2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN8WindZone12AddToManagerEv: __ZN8WindZone12AddToManagerEv, __ZNSt13exception_ptrD2Ev: __ZNSt13exception_ptrD2Ev, __ZN5ImageC2Eiii13TextureFormatPv: __ZN5ImageC2Eiii13TextureFormatPv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN17TransformInternal25CopyTransformSubhierarchyER18TransformHierarchyjS1_jb: __ZN17TransformInternal25CopyTransformSubhierarchyER18TransformHierarchyjS1_jb, __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN4FMOD6SoundI9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_: __ZN4FMOD6SoundI9getFormatEP15FMOD_SOUND_TYPEP17FMOD_SOUND_FORMATPiS5_, __ZNK16ReflectionProbes41CalculateHDRDecodeValuesForDefaultTextureEP7Texture: __ZNK16ReflectionProbes41CalculateHDRDecodeValuesForDefaultTextureEP7Texture, __Z39getPxVehicleDriveDynData_GearSwitchTimePKN5physx21PxVehicleDriveDynDataE: __Z39getPxVehicleDriveDynData_GearSwitchTimePKN5physx21PxVehicleDriveDynDataE, __ZN9ShaderLab9SubShaderC2Ev: __ZN9ShaderLab9SubShaderC2Ev, __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI23ShaderVariantCollectionE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__25ctypeIwE10do_toupperEw: __ZNKSt3__25ctypeIwE10do_toupperEw, __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb: __Z35CopyVectorArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameEb, __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE: __ZN5physx2Sc5Scene11removeClothERNS0_9ClothCoreE, __ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB: __ZL17CullCastersCommonRK17ShadowCullContextRK9SceneNodeRK4AABB, __ZN19UnityConnectService27OnDidReloadMonoDomainStaticEPS_: __ZN19UnityConnectService27OnDidReloadMonoDomainStaticEPS_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj90ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj90ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z56Renderer_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f: __Z56Renderer_CUSTOM_INTERNAL_get_realtimeLightmapScaleOffsetP12Il2CppObjectP8Vector4f, __Z16ClearBlendShapesR14BlendShapeData: __Z16ClearBlendShapesR14BlendShapeData, __Z32CustomEventData_CUSTOM_AddStringP12Il2CppObjectP12Il2CppStringS2_: __Z32CustomEventData_CUSTOM_AddStringP12Il2CppObjectP12Il2CppStringS2_, __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __Z47AnimatorControllerPlayable_CUSTOM_SetBoolStringR9HPlayableP12Il2CppStringh: __Z47AnimatorControllerPlayable_CUSTOM_SetBoolStringR9HPlayableP12Il2CppStringh, __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix3v: __Z50Register_UnityEngine_AudioChorusFilter_set_wetMix3v, __Z38Texture2D_CUSTOM_UpdateExternalTextureP12Il2CppObject13Il2Cpp_IntPtr: __Z38Texture2D_CUSTOM_UpdateExternalTextureP12Il2CppObject13Il2Cpp_IntPtr, __ZN5physx16PxVehicleDrive4WC2Ev: __ZN5physx16PxVehicleDrive4WC2Ev, _cf2_arrstack_setCount: _cf2_arrstack_setCount, __ZN11MonoManager8TransferI14SafeBinaryReadEEvRT_: __ZN11MonoManager8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_: __ZNSt3__26__sortIR12RaycastHit2DPS1_EEvT0_S4_T_, __ZN8Animator19FireAnimationEventsEv: __ZN8Animator19FireAnimationEventsEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_7profile26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE15reserveInternalEj, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZNK12MeshRenderer23GetMeshStaticBatchIndexEv: __ZNK12MeshRenderer23GetMeshStaticBatchIndexEv, __Z22PlayableValidityChecksRK9HPlayable: __Z22PlayableValidityChecksRK9HPlayable, __Z31CubemapArray_CUSTOM_GetPixels32P12Il2CppObjectiii: __Z31CubemapArray_CUSTOM_GetPixels32P12Il2CppObjectiii, __Z25PlayerPrefs_CUSTOM_HasKeyP12Il2CppString: __Z25PlayerPrefs_CUSTOM_HasKeyP12Il2CppString, __Z57Register_UnityEngine_Rendering_CommandBuffer_Blit_Texturev: __Z57Register_UnityEngine_Rendering_CommandBuffer_Blit_Texturev, __Z45Register_UnityEngine_Terrain_get_treeDistancev: __Z45Register_UnityEngine_Terrain_get_treeDistancev, __Z21getPxConstraint_ScenePKN5physx12PxConstraintE: __Z21getPxConstraint_ScenePKN5physx12PxConstraintE, __ZNK18PlatformEffector2D21DesignedForNonTriggerEv: __ZNK18PlatformEffector2D21DesignedForNonTriggerEv, __ZN13GfxDeviceGLES18HandleInvalidStateEv: __ZN13GfxDeviceGLES18HandleInvalidStateEv, __ZN5physx2Sn5ConvX7convertERNS_13PxInputStreamEjRNS_14PxOutputStreamE: __ZN5physx2Sn5ConvX7convertERNS_13PxInputStreamEjRNS_14PxOutputStreamE, __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID: __Z30TextureIdMapGLES_QueryOrCreateP7ApiGLES16TextureDimension9TextureID, __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth: __Z62ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth, __ZN16UploadHandlerRaw8GetBytesEv: __ZN16UploadHandlerRaw8GetBytesEv, __ZNSt3__227__insertion_sort_incompleteIRN15ResourceManager10Dependency6SorterEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRN15ResourceManager10Dependency6SorterEPS2_EEbT0_S6_T_, __ZNSt10bad_typeidD0Ev: __ZNSt10bad_typeidD0Ev, __Z10GetCookingv: __Z10GetCookingv, __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv: __ZN12_GLOBAL__N_127SphereMeshContactGeneration20generateLastContactsEv, __ZN26AnimatorControllerPlayableC2E18DirectorPlayerType: __ZN26AnimatorControllerPlayableC2E18DirectorPlayerType, __Z62getPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPKN5physx19PxVehicleEngineDataE: __Z62getPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPKN5physx19PxVehicleEngineDataE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN15dtLocalBoundary5resetEv: __ZN15dtLocalBoundary5resetEv, __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZThn32_N12LineRenderer19UpdateTransformInfoEv: __ZThn32_N12LineRenderer19UpdateTransformInfoEv, __ZNK12b2ChainShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi: __ZNK12b2ChainShape7RayCastEP15b2RayCastOutputRK14b2RayCastInputRK11b2Transformi, __ZN8Animator15SetPlaybackTimeEf: __ZN8Animator15SetPlaybackTimeEf, __ZN5physx2Gu20computeMTD_BoxConvexERNS_6PxVec3ERfRKNS0_3BoxERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu20computeMTD_BoxConvexERNS_6PxVec3ERfRKNS0_3BoxERKNS_20PxConvexMeshGeometryERKNS_11PxTransformE, __ZNK9AudioClip9GetLengthEv: __ZNK9AudioClip9GetLengthEv, __ZN13ComputeBuffer7SetDataEPKvj: __ZN13ComputeBuffer7SetDataEPKvj, __ZNK16LightmapSettings17AcquireSharedDataEv: __ZNK16LightmapSettings17AcquireSharedDataEv, __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z59Register_UnityEngine_GUIStyle_INTERNAL_CALL_SetMouseTooltipv: __Z59Register_UnityEngine_GUIStyle_INTERNAL_CALL_SetMouseTooltipv, __Z16HexStringToBytesPKcjPv: __Z16HexStringToBytesPKcjPv, __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_: __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_, __Z41TrailRenderer_Get_Custom_PropAutodestructP12Il2CppObject: __Z41TrailRenderer_Get_Custom_PropAutodestructP12Il2CppObject, __ZN5physx2Cm9FlushPoolC2Ej: __ZN5physx2Cm9FlushPoolC2Ej, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj575ENS_22PxRepXPropertyAccessorILj575ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj575ENS_22PxRepXPropertyAccessorILj575ES4_ffEEEEvRKT0_, __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation9DenseClip8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14MemoryProfiler20UnregisterMemoryToIDEjj: __ZN14MemoryProfiler20UnregisterMemoryToIDEjj, __ZN5physx40PCMSphereVsMeshContactGenerationCallbackD0Ev: __ZN5physx40PCMSphereVsMeshContactGenerationCallbackD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_, _wcpncpy: _wcpncpy, __ZN5physx6shdfnd6Socket5flushEv: __ZN5physx6shdfnd6Socket5flushEv, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12getClassSizeEv, __ZN5physx2Sc5Scene15setFrictionTypeENS_14PxFrictionType4EnumE: __ZN5physx2Sc5Scene15setFrictionTypeENS_14PxFrictionType4EnumE, __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetTimeInternalv: __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetTimeInternalv, __ZN4FMOD6SoundI13getSoundGroupEPPNS_10SoundGroupE: __ZN4FMOD6SoundI13getSoundGroupEPPNS_10SoundGroupE, __ZN5physx3Scb4Body18setKinematicTargetERKNS_11PxTransformE: __ZN5physx3Scb4Body18setKinematicTargetERKNS_11PxTransformE, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_20PxConvexMeshGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_20PxConvexMeshGeometryE, __ZN5physx7profile17EventDeserializerILb1EE9streamifyIyEEvPKcRT_: __ZN5physx7profile17EventDeserializerILb1EE9streamifyIyEEvPKcRT_, __ZN7Terrain5FlushEv: __ZN7Terrain5FlushEv, __ZN14NavMeshCarving5CarveEv: __ZN14NavMeshCarving5CarveEv, __ZN18CrashReportHandler12FlushReportsEv: __ZN18CrashReportHandler12FlushReportsEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj502ENS_22PxRepXPropertyAccessorILj502ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj502ENS_22PxRepXPropertyAccessorILj502ES4_ffEEEEvRKT0_, __Z17IsContainedInAABBRK4AABBS1_: __Z17IsContainedInAABBRK4AABBS1_, __ZN5physx19PxcScratchAllocatorC2Ev: __ZN5physx19PxcScratchAllocatorC2Ev, __Z35Renderer_Get_Custom_PropCastShadowsP12Il2CppObject: __Z35Renderer_Get_Custom_PropCastShadowsP12Il2CppObject, __ZN5physx3Scb5Scene18removeArticulationERNS0_12ArticulationE: __ZN5physx3Scb5Scene18removeArticulationERNS0_12ArticulationE, __ZN12_GLOBAL__N_116MetaDataProviderD2Ev: __ZN12_GLOBAL__N_116MetaDataProviderD2Ev, __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv: __ZN5physx14PxsAABBManager19freeCreatedOverlapsEv, __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEEC2ERNS_19PxAllocatorCallbackE, __ZN12HingeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12HingeJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN27AnimatorControllerParameter8TransferI14SafeBinaryReadEEvRT_: __ZN27AnimatorControllerParameter8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn25readStridedBufferPropertyIhEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyIhEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __ZN5physx14NpRigidDynamic16setLinearDampingEf: __ZN5physx14NpRigidDynamic16setLinearDampingEf, __ZN9Texture2D15ExtractMipLevelEP17SharedTextureDataiibb: __ZN9Texture2D15ExtractMipLevelEP17SharedTextureDataiibb, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK9Transform21InverseTransformPointERK8Vector3f: __ZNK9Transform21InverseTransformPointERK8Vector3f, _wcstoumax: _wcstoumax, __Z37AudioReverbZone_Get_Custom_PropRoomHFP12Il2CppObject: __Z37AudioReverbZone_Get_Custom_PropRoomHFP12Il2CppObject, __ZNK8Animator26GetGlobalSpaceSkeletonPoseEPPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEEiRKNS3_7_float4E: __ZNK8Animator26GetGlobalSpaceSkeletonPoseEPPN7mecanim8skeleton13SkeletonPoseTIN4math7affineXEEEiRKNS3_7_float4E, __Z46RenderSettings_Set_Custom_PropFogStartDistancef: __Z46RenderSettings_Set_Custom_PropFogStartDistancef, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj620ES4_iKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN5physx2Sc5Scene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf: __ZN5physx2Sc5Scene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf, __ZNK8Animator21HasAnimatorControllerEv: __ZNK8Animator21HasAnimatorControllerEv, __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj: __ZN5physx2Sc16InteractionScene22deallocatePointerBlockEPPvj, __Z47ParticleSystem_MainModule_CUSTOM_GetPlayOnAwakeP12Il2CppObject: __Z47ParticleSystem_MainModule_CUSTOM_GetPlayOnAwakeP12Il2CppObject, __ZNK5Umbra14TomeCollection9serializeERNS_12OutputStreamE: __ZNK5Umbra14TomeCollection9serializeERNS_12OutputStreamE, __Z26SkinVerticesGenericMathLibILi4ELb1ELb1EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi4ELb1ELb1EEvPKhiiiiPhiPKvS4_, _jinit_phuff_decoder: _jinit_phuff_decoder, __ZN17ProceduralTexture17TextureParametersC2Eiii13TextureFormat: __ZN17ProceduralTexture17TextureParametersC2Eiii13TextureFormat, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED2Ev: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED2Ev, __ZN22NavMeshProjectSettings11SetAreaCostEjf: __ZN22NavMeshProjectSettings11SetAreaCostEjf, __ZN4FMOD8ChannelI4stopEv: __ZN4FMOD8ChannelI4stopEv, __ZN28LightProbeProxyVolumeManager17UpdateProxyVolumeER21LightProbeProxyVolumej: __ZN28LightProbeProxyVolumeManager17UpdateProxyVolumeER21LightProbeProxyVolumej, __Z30CleanupBuiltinShaderParamNamesv: __Z30CleanupBuiltinShaderParamNamesv, _strndup: _strndup, __Z40ParticleSystem_Set_Custom_PropRandomSeedP12Il2CppObjectj: __Z40ParticleSystem_Set_Custom_PropRandomSeedP12Il2CppObjectj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_iiNS0_15FramebufferMaskE: __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_iiNS0_15FramebufferMaskE, __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19MeshParticleEmitter8TransferI18StreamedBinaryReadILb0EEEEvRT_, _UNITY_png_set_oFFs: _UNITY_png_set_oFFs, __ZNK5physx3Cct17CapsuleController8getActorEv: __ZNK5physx3Cct17CapsuleController8getActorEv, __ZN5physx15NpParticleFluidC2Ejb: __ZN5physx15NpParticleFluidC2Ejb, __Z52ParticleSystem_SubEmittersModule_CUSTOM_SetCollisionP12Il2CppObjectiS0_: __Z52ParticleSystem_SubEmittersModule_CUSTOM_SetCollisionP12Il2CppObjectiS0_, __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN23ShaderVariantCollection23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN11TerrainData14BeforeShutdownEv: __ZN11TerrainData14BeforeShutdownEv, __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIssEEPsEEjT0_S5_S5_S5_S5_T_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf, __ZN16AnimationManager6UpdateEv: __ZN16AnimationManager6UpdateEv, __ZN17GeneralConnection13DisconnectAllEv: __ZN17GeneralConnection13DisconnectAllEv, __ZNK5physx14NpArticulation10isSleepingEv: __ZNK5physx14NpArticulation10isSleepingEv, __Z49UnityConnectSettings_Set_Custom_PropTestConfigUrlP12Il2CppString: __Z49UnityConnectSettings_Set_Custom_PropTestConfigUrlP12Il2CppString, __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_SetRangev: __Z77Register_UnityEngine_ParticleSystem_ColorBySpeedModule_INTERNAL_CALL_SetRangev, __Z42Register_UnityEngine_Camera_get_allCamerasv: __Z42Register_UnityEngine_Camera_get_allCamerasv, __ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb: __ZN5Umbra20RuntimeTomeGenerator11selectSplitEPiiRKNS_4AABBEiRfRb, __Z59ParticleSystem_MainModule_CUSTOM_SetStartLifetimeMultiplierP12Il2CppObjectf: __Z59ParticleSystem_MainModule_CUSTOM_SetStartLifetimeMultiplierP12Il2CppObjectf, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE6sbumpcEv, __ZN15TerrainCollider12CleanupClassEv: __ZN15TerrainCollider12CleanupClassEv, __Z47SystemInfo_Get_Custom_PropGraphicsMultiThreadedv: __Z47SystemInfo_Get_Custom_PropGraphicsMultiThreadedv, __Z39ParticleSystemRenderer_CUSTOM_GetMeshesP12Il2CppObjectP11Il2CppArray: __Z39ParticleSystemRenderer_CUSTOM_GetMeshesP12Il2CppObjectP11Il2CppArray, __ZNKSt3__28messagesIcE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE: __ZNKSt3__28messagesIcE4openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE, __ZN5Umbra6KDTree10getLUTSizeEi: __ZN5Umbra6KDTree10getLUTSizeEi, __Z18LoadPluginFunctionPvPKc: __Z18LoadPluginFunctionPvPKc, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __Z54Register_UnityEngine_ReflectionProbe_get_blendDistancev: __Z54Register_UnityEngine_ReflectionProbe_get_blendDistancev, __ZL31InitializeModule_ParticleSystemv: __ZL31InitializeModule_ParticleSystemv, __Z24RegisterStrippedTypeInfoI11AudioSourceEviPKcS2_: __Z24RegisterStrippedTypeInfoI11AudioSourceEviPKcS2_, __ZN23MeshVertexFormatManagerC2Ev: __ZN23MeshVertexFormatManagerC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _gray_hline: _gray_hline, __ZNK15ParticleEmitter13ReadParticlesEP14SimpleParticleii: __ZNK15ParticleEmitter13ReadParticlesEP14SimpleParticleii, __Z53Register_UnityEngine_ReflectionProbe_get_farClipPlanev: __Z53Register_UnityEngine_ReflectionProbe_get_farClipPlanev, _ms_write: _ms_write, __ZN10HttpHelper18IsHeaderValueValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN10HttpHelper18IsHeaderValueValidERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, ___crypt_md5: ___crypt_md5, __ZN12_GLOBAL__N_112RenderReaderILb1EE7hasDataEv: __ZN12_GLOBAL__N_112RenderReaderILb1EE7hasDataEv, __ZN5physx2Sc15ArticulationSim12updateForcesEffbRKNS_6PxVec3Ebb: __ZN5physx2Sc15ArticulationSim12updateForcesEffbRKNS_6PxVec3Ebb, __Z4InitR13CImageSurfaceiii: __Z4InitR13CImageSurfaceiii, __Z48Register_UnityEngine_TerrainData_GetAdjustedSizev: __Z48Register_UnityEngine_TerrainData_GetAdjustedSizev, __ZN11ContextGLES7IsValidEv: __ZN11ContextGLES7IsValidEv, _tt_cmap0_char_index: _tt_cmap0_char_index, __ZN5physx13NpClothFabricC2Ev: __ZN5physx13NpClothFabricC2Ev, __ZN16HumanDescriptionD2Ev: __ZN16HumanDescriptionD2Ev, __ZNSt3__227__insertion_sort_incompleteIR11NodeZSorterP16HeightMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR11NodeZSorterP16HeightMeshBVNodeEEbT0_S5_T_, __ZN5physx15NpActorTemplateINS_7PxClothEE7releaseEv: __ZN5physx15NpActorTemplateINS_7PxClothEE7releaseEv, __Z37NavMeshObstacle_Set_Custom_PropHeightP12Il2CppObjectf: __Z37NavMeshObstacle_Set_Custom_PropHeightP12Il2CppObjectf, __ZN21EnlightenSceneMapping5EraseEi: __ZN21EnlightenSceneMapping5EraseEi, _gettext: _gettext, __ZN18PhysxJobDispatcherD0Ev: __ZN18PhysxJobDispatcherD0Ev, __ZN18ProceduralMaterial12RebuildCloneEb: __ZN18ProceduralMaterial12RebuildCloneEb, __ZL25ProgramUniformMatrix4x3fvPK7ApiGLESjiihPKv: __ZL25ProgramUniformMatrix4x3fvPK7ApiGLESjiihPKv, __ZN28LightsModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN28LightsModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z64Register_UnityEngine_AI_NavMesh_GetPathfindingIterationsPerFramev: __Z64Register_UnityEngine_AI_NavMesh_GetPathfindingIterationsPerFramev, __ZN9Texture2D19InitTextureInternalEii13TextureFormatiNS_10EInitFlagsEii: __ZN9Texture2D19InitTextureInternalEii13TextureFormatiNS_10EInitFlagsEii, __ZN29AssetBundleLoadAssetOperationD0Ev: __ZN29AssetBundleLoadAssetOperationD0Ev, __ZN5Umbra20RuntimeTomeGenerator23combineHierarchyPortalsEi: __ZN5Umbra20RuntimeTomeGenerator23combineHierarchyPortalsEi, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_130PropertyMessageDescriptionImplENS_8debugger19ForwardingAllocatorEE8recreateEj, __ZN11Rigidbody2D10DeactivateE19DeactivateOperation: __ZN11Rigidbody2D10DeactivateE19DeactivateOperation, __ZN12TreeDatabase9Prototype3SetERK4PPtrI10GameObjectEfb: __ZN12TreeDatabase9Prototype3SetERK4PPtrI10GameObjectEfb, __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __ZN11AudioModule16GetProfilerStatsER10AudioStats: __ZN11AudioModule16GetProfilerStatsER10AudioStats, __ZNK16ReflectionProbes21GenerateDefaultSampleEv: __ZNK16ReflectionProbes21GenerateDefaultSampleEv, __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPFlPKwPPwiEEET_RKNS2_IcNS3_IcEENS5_IcEEEERKT0_PjiT1_: __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPFlPKwPPwiEEET_RKNS2_IcNS3_IcEENS5_IcEEEERKT0_PjiT1_, __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci: __ZN13MemoryManager8AllocateEjiRK10MemLabelId15AllocateOptionsPKci, __ZN12NavMeshAgent8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12NavMeshAgent8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z59Register_UnityEngine_Physics2D_get_minPenetrationForPenaltyv: __Z59Register_UnityEngine_Physics2D_get_minPenetrationForPenaltyv, __Z37Animator_Get_Custom_PropIsOptimizableP12Il2CppObject: __Z37Animator_Get_Custom_PropIsOptimizableP12Il2CppObject, _UNITY_FT_Init_Class_tt_cmap2_class_rec: _UNITY_FT_Init_Class_tt_cmap2_class_rec, __ZNK13TranslateGLES23VertexArrayKindBitfieldEN2gl21VertexArrayAttribKindE: __ZNK13TranslateGLES23VertexArrayKindBitfieldEN2gl21VertexArrayAttribKindE, __Z45Register_UnityEngine_CullingGroup_set_enabledv: __Z45Register_UnityEngine_CullingGroup_set_enabledv, _out: _out, __ZN10Collider2D19RecalculateContactsEv: __ZN10Collider2D19RecalculateContactsEv, __ZN5physx7profile30PxProfileMemoryEventBufferImplD0Ev: __ZN5physx7profile30PxProfileMemoryEventBufferImplD0Ev, __ZN5physx2Sc10NPhaseCore26createRbElementInteractionERNS0_8ShapeSimES3_: __ZN5physx2Sc10NPhaseCore26createRbElementInteractionERNS0_8ShapeSimES3_, __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_velocityv: __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_velocityv, __ZNSt3__24stodERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj: __ZNSt3__24stodERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj, __ZN6Shader23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Shader23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9Texture2D16DeleteGfxTextureEv: __ZN9Texture2D16DeleteGfxTextureEv, __ZN9AudioClip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9AudioClip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E, __Z47Register_UnityEngine_AudioReverbZone_set_roomHFv: __Z47Register_UnityEngine_AudioReverbZone_set_roomHFv, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc, _jinit_c_prep_controller: _jinit_c_prep_controller, __ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f: __ZN5physx2Gu24contactPolygonPolygonExtEjPKNS_6PxVec3EPKhRKNS_2Cm8Matrix34ERKNS_7PxPlaneERKNS_7PxMat33EjS3_S5_S9_SC_SF_RS2_S9_S9_jjRNS0_13ContactBufferEbSG_f, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE14initCommonDataERNS0_9JointDataEPNS_12PxRigidActorERKNS_11PxTransformES8_SB_, __ZN10systeminfo19ISOToSystemLanguageERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN10systeminfo19ISOToSystemLanguageERNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxsCCDPairENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z54Register_UnityEngine_PhysicMaterial_set_staticFrictionv: __Z54Register_UnityEngine_PhysicMaterial_set_staticFrictionv, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE25getRelativeLinearVelocityEv, __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_positionv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_positionv, __ZN11UnityEngine9Animation32DestroyControllerBindingConstantEPN7mecanim9animation25ControllerBindingConstantERNS1_6memory9AllocatorE: __ZN11UnityEngine9Animation32DestroyControllerBindingConstantEPN7mecanim9animation25ControllerBindingConstantERNS1_6memory9AllocatorE, __ZN14ParticleSystem8SyncJobsEb: __ZN14ParticleSystem8SyncJobsEb, __Z12GetIVehiclesv: __Z12GetIVehiclesv, __Z51BillboardAsset_CUSTOM_SetImageTexCoordsInternalListP12Il2CppObjectS0_: __Z51BillboardAsset_CUSTOM_SetImageTexCoordsInternalListP12Il2CppObjectS0_, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEclERS6_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEclERS6_17TransferMetaFlagsR9BlobWrite, __ZN14ParticleTrails10ReallocateEjj: __ZN14ParticleTrails10ReallocateEjj, __Z40getPxVehicleDriveDynDataMGearDownPressedPKN5physx21PxVehicleDriveDynDataE: __Z40getPxVehicleDriveDynDataMGearDownPressedPKN5physx21PxVehicleDriveDynDataE, __ZN5physx24solveExt1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx24solveExt1DBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EEc: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EEc, __Z43Animator_CUSTOM_GetCurrentAnimatorStateInfoP12Il2CppObjecti: __Z43Animator_CUSTOM_GetCurrentAnimatorStateInfoP12Il2CppObjecti, __Z57Register_UnityEngine_Vector3_INTERNAL_CALL_SlerpUnclampedv: __Z57Register_UnityEngine_Vector3_INTERNAL_CALL_SlerpUnclampedv, __ZN12InputManager8TransferI14SafeBinaryReadEEvRT_: __ZN12InputManager8TransferI14SafeBinaryReadEEvRT_, __Z50Register_UnityEngine_Gyroscope_setEnabled_Internalv: __Z50Register_UnityEngine_Gyroscope_setEnabled_Internalv, __Z22sweepConvex_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z22sweepConvex_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf, __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN4Mesh13SetVertexDataEPKvjjji: __ZN4Mesh13SetVertexDataEPKvjjji, __ZN11NamedObject23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11NamedObject23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN13RendererSceneC2Ev: __ZN13RendererSceneC2Ev, __ZN5physx18ReducedVertexCloud6ReduceEPNS_12REDUCEDCLOUDE: __ZN5physx18ReducedVertexCloud6ReduceEPNS_12REDUCEDCLOUDE, __ZN5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E: __ZN5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__zeroEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__zeroEv, __ZN5physx2Sn5ConvX23convertExportReferencesEPKvRi: __ZN5physx2Sn5ConvX23convertExportReferencesEPKvRi, __ZN21DownloadHandlerScript17OnCompleteContentEv: __ZN21DownloadHandlerScript17OnCompleteContentEv, __Z54Register_UnityEngine_AreaEffector2D_set_useGlobalAnglev: __Z54Register_UnityEngine_AreaEffector2D_set_useGlobalAnglev, __ZN9JSONWrite17TransferBasicDataIyEEvRT_: __ZN9JSONWrite17TransferBasicDataIyEEvRT_, __Z24RegisterStrippedTypeInfoI11MonoManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI11MonoManagerEviPKcS2_, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetCurrentAllocatorEv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetCurrentAllocatorEv, __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSpeedMultiplierv, __ZN5physx2Sc9ActorCore14reinsertShapesEv: __ZN5physx2Sc9ActorCore14reinsertShapesEv, __ZN9Texture3D13UploadTextureEv: __ZN9Texture3D13UploadTextureEv, __ZN13TrailRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13TrailRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14PhysicsManager16SetSleepVelocityEf: __ZN14PhysicsManager16SetSleepVelocityEf, __Z28RecreateSkinnedMeshResourcesv: __Z28RecreateSkinnedMeshResourcesv, __Z18Transfer_BlittableI9JSONWriteLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZNSt3__215recursive_mutex8try_lockEv: __ZNSt3__215recursive_mutex8try_lockEv, __Z52Register_UnityEngine_Shader_GetGlobalMatrixArrayImplv: __Z52Register_UnityEngine_Shader_GetGlobalMatrixArrayImplv, __Z24RegisterStrippedTypeInfoI17GlobalGameManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI17GlobalGameManagerEviPKcS2_, __ZN5physx2Sc13ConstraintSim8getRigidEj: __ZN5physx2Sc13ConstraintSim8getRigidEj, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN5Unity17ConfigurableJoint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity17ConfigurableJoint7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sc9ClothCore24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE: __ZN5physx2Sc9ClothCore24setSeparationConstraintsEPKNS_35PxClothParticleSeparationConstraintE, __ZN5physx2Sc15ObjectIDTracker9releaseIDEj: __ZN5physx2Sc15ObjectIDTracker9releaseIDEj, __ZN5physx2Gu12TriangleMeshD2Ev: __ZN5physx2Gu12TriangleMeshD2Ev, _getline: _getline, __Z20GetIdentityTransformv: __Z20GetIdentityTransformv, __ZN4FMOD7SystemI7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE: __ZN4FMOD7SystemI7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE, __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI11TetrahedronLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN4FMOD7Channel13setSpeakerMixEffffffff: __ZN4FMOD7Channel13setSpeakerMixEffffffff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj581ENS_22PxRepXPropertyAccessorILj581ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj581ENS_22PxRepXPropertyAccessorILj581ES4_ffEEEEvRKT0_, __Z28Event_Get_Custom_PropRawTypeP12Il2CppObject: __Z28Event_Get_Custom_PropRawTypeP12Il2CppObject, __Z32getPxVehicleDriveTank_DriveModelPKN5physx18PxVehicleDriveTankE: __Z32getPxVehicleDriveTank_DriveModelPKN5physx18PxVehicleDriveTankE, __ZN15DirectorManager13OnAdvanceTimeEv: __ZN15DirectorManager13OnAdvanceTimeEv, __ZN5physx16PxVehicleDrive4W14setToRestStateEv: __ZN5physx16PxVehicleDrive4W14setToRestStateEv, __ZN5physx16PxVehicleNoDrive13setSteerAngleEjf: __ZN5physx16PxVehicleNoDrive13setSteerAngleEjf, __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z27GetIMGUIScriptingClassesPtrv: __Z27GetIMGUIScriptingClassesPtrv, _UNITY_png_unity_get_crc: _UNITY_png_unity_get_crc, __ZN14MemoryProfiler27SetRootAllocationObjectNameEPvRK10MemLabelIdPKc: __ZN14MemoryProfiler27SetRootAllocationObjectNameEPvRK10MemLabelIdPKc, __ZN12LightManager9GetLightsE9LightTypei: __ZN12LightManager9GetLightsE9LightTypei, __ZN22BaseUnityConnectClient20OnEnterStatePreparedEv: __ZN22BaseUnityConnectClient20OnEnterStatePreparedEv, __Z60Register_UnityEngine_Camera_INTERNAL_get_worldToCameraMatrixv: __Z60Register_UnityEngine_Camera_INTERNAL_get_worldToCameraMatrixv, __Z34AreaEffector2D_Get_Custom_PropDragP12Il2CppObject: __Z34AreaEffector2D_Get_Custom_PropDragP12Il2CppObject, __Z39Rigidbody_Set_Custom_PropSleepThresholdP12Il2CppObjectf: __Z39Rigidbody_Set_Custom_PropSleepThresholdP12Il2CppObjectf, _UNITY_FT_Vector_Transform: _UNITY_FT_Vector_Transform, __Z28Debug_CUSTOM_OpenConsoleFilev: __Z28Debug_CUSTOM_OpenConsoleFilev, __ZN19ClampVelocityModule5ResetEv: __ZN19ClampVelocityModule5ResetEv, __Z34Graphics_Get_Custom_PropActiveTierv: __Z34Graphics_Get_Custom_PropActiveTierv, __Z58Register_UnityEngine_Caching_set_maximumAvailableDiskSpacev: __Z58Register_UnityEngine_Caching_set_maximumAvailableDiskSpacev, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS5_L18MemLabelIdentifier77ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS5_L18MemLabelIdentifier77ELi16EEEEEEvRT_17TransferMetaFlags, __Z39getPxVehicleWheelsDynData_Wheel4DynDataPKN5physx22PxVehicleWheelsDynDataE: __Z39getPxVehicleWheelsDynData_Wheel4DynDataPKN5physx22PxVehicleWheelsDynDataE, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ObstacleAvoidanceTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead21ObstacleAvoidanceTypeEvRT_RT0_PKc17TransferMetaFlags, __ZN4PPtrI6ObjectE8TransferI8JSONReadEEvRT_: __ZN4PPtrI6ObjectE8TransferI8JSONReadEEvRT_, __Z57ParticleSystem_CollisionModule_CUSTOM_GetBounceMultiplierP12Il2CppObject: __Z57ParticleSystem_CollisionModule_CUSTOM_GetBounceMultiplierP12Il2CppObject, __Z36ParticleSystem_CUSTOM_Internal_PauseP12Il2CppObject: __Z36ParticleSystem_CUSTOM_Internal_PauseP12Il2CppObject, __Z40Terrain_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectR8Vector3f: __Z40Terrain_CUSTOM_INTERNAL_CALL_GetPositionP12Il2CppObjectR8Vector3f, __ZN5physx9NpPhysics7releaseEv: __ZN5physx9NpPhysics7releaseEv, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetZv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareERKS5_: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7compareERKS5_, __Z48Physics2D_Get_Custom_PropQueriesStartInCollidersv: __Z48Physics2D_Get_Custom_PropQueriesStartInCollidersv, __Z45EnsureQuaternionContinuityAndRecalculateSlopeR17AnimationCurveTplI11QuaternionfE: __Z45EnsureQuaternionContinuityAndRecalculateSlopeR17AnimationCurveTplI11QuaternionfE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15TerrainColliderC2E10MemLabelId18ObjectCreationMode: __ZN15TerrainColliderC2E10MemLabelId18ObjectCreationMode, __ZN15UnityAdsManager5ResetEv: __ZN15UnityAdsManager5ResetEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5Unity5Cloth23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity5Cloth23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5Umbra9RasterOps4blitERNS_17BlockRasterBufferERKS1_: __ZN5Umbra9RasterOps4blitERNS_17BlockRasterBufferERKS1_, __ZN17AudioChorusFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17AudioChorusFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx3Cct26CharacterControllerManager8getSceneEv: __ZNK5physx3Cct26CharacterControllerManager8getSceneEv, _UNITY_tt_face_load_sbit: _UNITY_tt_face_load_sbit, __ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE: __ZNK5physx14NpSceneQueries10multiQueryINS_12PxRaycastHitEEEbRKNS_15MultiQueryInputERNS_13PxHitCallbackIT_EENS_7PxFlagsINS_9PxHitFlag4EnumEtEEPKNS_12PxQueryCacheERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPNS_20BatchQueryFilterDataE, __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIy8TFShaderEENS_19__map_value_compareIyS3_NS_4lessIyEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZN5physx9NpFactory11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx9NpFactory11createClothERKNS_11PxTransformERNS_13PxClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __Z22IsChildOrSameTransformR9TransformS0_: __Z22IsChildOrSameTransformR9TransformS0_, __ZNK16b2PrismaticJoint14IsMotorEnabledEv: __ZNK16b2PrismaticJoint14IsMotorEnabledEv, __ZN15DirectorManager30ScheduleForDestructionInternalEP8Playable: __ZN15DirectorManager30ScheduleForDestructionInternalEP8Playable, __ZN26AnimatorControllerPlayable7GetBoolEiRb: __ZN26AnimatorControllerPlayable7GetBoolEiRb, __ZNK5physx7NpShape32getMaterialFromInternalFaceIndexEj: __ZNK5physx7NpShape32getMaterialFromInternalFaceIndexEj, __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI17SubstanceEnumItemNS0_9allocatorIS2_EEEEEvRT_j, __ZNK13b2PulleyJoint17GetReactionTorqueEf: __ZNK13b2PulleyJoint17GetReactionTorqueEf, __ZN5physx2Gu5RTreeC2Ev: __ZN5physx2Gu5RTreeC2Ev, __ZN20SpeedTreeWindManager18RegisterGlobalWindER13SpeedTreeWind: __ZN20SpeedTreeWindManager18RegisterGlobalWindER13SpeedTreeWind, __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19SharedBillboardData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN7mecanim12statemachine18StateMachineMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN12MemoryStream4readEPvj: __ZN12MemoryStream4readEPvj, __ZN8Animator15SetHintPositionEiRK8Vector3f: __ZN8Animator15SetHintPositionEiRK8Vector3f, __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE: __ZN5physx2Sc16InteractionScene28notifyInteractionDeactivatedEPNS0_11InteractionE, __ZN5physx9NpPhysics15releaseInstanceEv: __ZN5physx9NpPhysics15releaseInstanceEv, __Z43Register_UnityEngine_Screen_set_orientationv: __Z43Register_UnityEngine_Screen_set_orientationv, __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN13RuntimeStaticI12GraphicsCapsE13StaticDestroyEPv: __ZN13RuntimeStaticI12GraphicsCapsE13StaticDestroyEPv, __Z32getPxVehicleWheelsMWheelsDynDataPKN5physx15PxVehicleWheelsE: __Z32getPxVehicleWheelsMWheelsDynDataPKN5physx15PxVehicleWheelsE, _Conic_To: _Conic_To, __ZN19RenderEventsContext20RemoveCommandBuffersEi: __ZN19RenderEventsContext20RemoveCommandBuffersEi, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags, __Z38Compass_Get_Custom_PropHeadingAccuracyP12Il2CppObject: __Z38Compass_Get_Custom_PropHeadingAccuracyP12Il2CppObject, __Z14FixupCubeEdgesP13CImageSurfaceii: __Z14FixupCubeEdgesP13CImageSurfaceii, __Z18Transfer_BlittableI9JSONWriteLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN2UI26GetAvaliableShaderPropertyERNS_7BatchesE: __ZN2UI26GetAvaliableShaderPropertyERNS_7BatchesE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN6Camera8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN6Camera8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z26setPxJoint_ConstraintFlagsPN5physx7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE: __Z26setPxJoint_ConstraintFlagsPN5physx7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEE, __ZN5physx14PxVehicleDrive14setToRestStateEv: __ZN5physx14PxVehicleDrive14setToRestStateEv, __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, __Z43ParticleSystem_TriggerModule_CUSTOM_SetExitP12Il2CppObjecti: __Z43ParticleSystem_TriggerModule_CUSTOM_SetExitP12Il2CppObjecti, __Z24RegisterStrippedTypeInfoI15CapsuleColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI15CapsuleColliderEviPKcS2_, __ZL15UnityDetourFreePv: __ZL15UnityDetourFreePv, __ZN12_GLOBAL__N_117ConnectionManager23nullDeallocationHandlerEPv: __ZN12_GLOBAL__N_117ConnectionManager23nullDeallocationHandlerEPv, __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE: __ZNK5physx14NpShapeManager14getWorldBoundsERKNS_12PxRigidActorE, __ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE: __ZNK17AnimationCurveTplIfE13EvaluateClampEfPNS0_5CacheE, __ZL22PrepareValueParametersI21FullParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_: __ZL22PrepareValueParametersI21FullParameterPreparerEvRK13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEjjjRS1_IhLj4EERKT_, __Z50AnimatorControllerPlayable_CUSTOM_SetIntegerStringR9HPlayableP12Il2CppStringi: __Z50AnimatorControllerPlayable_CUSTOM_SetIntegerStringR9HPlayableP12Il2CppStringi, __ZN7mecanim9animation30AllocateAvatarOuputForBindingsEPNS0_12AvatarOutputEbPKNS_18ValueArrayConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation30AllocateAvatarOuputForBindingsEPNS0_12AvatarOutputEbPKNS_18ValueArrayConstantERNS_6memory9AllocatorE, __Z54Register_UnityEngine_ParticleSystem_INTERNAL_CALL_Emitv: __Z54Register_UnityEngine_ParticleSystem_INTERNAL_CALL_Emitv, __ZNK23SharedMeshRenderingData20GetRuntimeMemorySizeEv: __ZNK23SharedMeshRenderingData20GetRuntimeMemorySizeEv, __ZN10MemoryFile5WriteEyPKvPy: __ZN10MemoryFile5WriteEyPKvPy, __ZN5physx2Sc7BodySim16resetSleepFilterEv: __ZN5physx2Sc7BodySim16resetSleepFilterEv, __ZN21AnimationClipPlayable11DerivesFromEP11Il2CppClass: __ZN21AnimationClipPlayable11DerivesFromEP11Il2CppClass, __Z18tessProjectPolygonP14TESStesselator: __Z18tessProjectPolygonP14TESStesselator, __ZN5physx2Sc27ConstraintProjectionManager10groupUnionERNS0_19ConstraintGroupNodeES3_: __ZN5physx2Sc27ConstraintProjectionManager10groupUnionERNS0_19ConstraintGroupNodeES3_, __Z46Register_UnityEngine_Renderer_set_sortingOrderv: __Z46Register_UnityEngine_Renderer_set_sortingOrderv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE10onComShiftEj, __ZN10builtintex17GetBlackTextureIDEv: __ZN10builtintex17GetBlackTextureIDEv, __Z31AndroidJNI_CUSTOM_GetShortField13Il2Cpp_IntPtrS_: __Z31AndroidJNI_CUSTOM_GetShortField13Il2Cpp_IntPtrS_, __ZN26AnimatorControllerPlayable15SetRecorderDataEPN7mecanim9animation16ControllerMemoryERNS0_6memory9AllocatorE: __ZN26AnimatorControllerPlayable15SetRecorderDataEPN7mecanim9animation16ControllerMemoryERNS0_6memory9AllocatorE, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZL8Perlin2DRKN4math8floatNx3ERKf: __ZL8Perlin2DRKN4math8floatNx3ERKf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE8pushNameEPKc, __ZN22DownloadHandlerTextureD2Ev: __ZN22DownloadHandlerTextureD2Ev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags, __Z41Register_UnityEngine_Mesh_get_boneWeightsv: __Z41Register_UnityEngine_Mesh_get_boneWeightsv, __Z44Terrain_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject: __Z44Terrain_Get_Custom_PropRealtimeLightmapIndexP12Il2CppObject, __ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj: __ZN5Umbra20RuntimeStructBuilder11reserveHeapEjj, __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_velocityv: __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_velocityv, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES5_, __Z34setPxScene_VisualizationCullingBoxPN5physx7PxSceneERKNS_9PxBounds3E: __Z34setPxScene_VisualizationCullingBoxPN5physx7PxSceneERKNS_9PxBounds3E, __ZN12InputManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12InputManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z48setPxArticulationJoint_TwistLimitContactDistancePN5physx19PxArticulationJointEf: __Z48setPxArticulationJoint_TwistLimitContactDistancePN5physx19PxArticulationJointEf, __ZN5physx2Gu35checkOverlapCapsule_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu35checkOverlapCapsule_heightFieldGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, __ZmlRK8Scalar4fS1_: __ZmlRK8Scalar4fS1_, __ZN4FMOD7SystemIC2Ei: __ZN4FMOD7SystemIC2Ei, __ZN9dtNavMesh19getTileAndPolyByRefEyPP10dtMeshTilePPK6dtPoly: __ZN9dtNavMesh19getTileAndPolyByRefEyPP10dtMeshTilePPK6dtPoly, __ZN5physx2Sq17SceneQueryManager23forceDynamicTreeRebuildEbb: __ZN5physx2Sq17SceneQueryManager23forceDynamicTreeRebuildEbb, __Z23InitializeStdConvertersv: __Z23InitializeStdConvertersv, __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __ZN5physx7NpScene15flushSimulationEb: __ZN5physx7NpScene15flushSimulationEb, __ZN10SampleClip15InitializeClassEv: __ZN10SampleClip15InitializeClassEv, __Z49Register_UnityEngine_Cloth_get_collisionMassScalev: __Z49Register_UnityEngine_Cloth_get_collisionMassScalev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIiEEEvRT_17TransferMetaFlags, __ZN17ProfilerFrameData17ReleaseTimerQueryEP13GfxTimerQuery: __ZN17ProfilerFrameData17ReleaseTimerQueryEP13GfxTimerQuery, __ZN9ShaderLab25SerializedTexturePropertyC2Ev: __ZN9ShaderLab25SerializedTexturePropertyC2Ev, __Z76Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimeMultiplierv: __Z76Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimeMultiplierv, _SetFullscreen: _SetFullscreen, __ZN20SoundChannelInstanceC2E11SoundHandleb: __ZN20SoundChannelInstanceC2E11SoundHandleb, _gzgets: _gzgets, __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12maybe_shrinkEv, __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7Joint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z20CleanupPhysicsModulev: __Z20CleanupPhysicsModulev, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE6getDirEv, __ZN5Umbra9Matrix4x4mLERKNS_9Matrix4x3E: __ZN5Umbra9Matrix4x4mLERKNS_9Matrix4x3E, __ZN6Camera12AddToManagerEv: __ZN6Camera12AddToManagerEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED1Ev: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED1Ev, _cff_sid_to_glyph_name: _cff_sid_to_glyph_name, __ZNK10Collider2D20GetAttachedRigidbodyEb: __ZNK10Collider2D20GetAttachedRigidbodyEb, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEED1Ev, __ZN5physx22PxDefaultErrorCallback11reportErrorENS_11PxErrorCode4EnumEPKcS4_i: __ZN5physx22PxDefaultErrorCallback11reportErrorENS_11PxErrorCode4EnumEPKcS4_i, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEE6appendERKS6_jj, __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_: __ZN9Behaviour8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEED0Ev, __ZN23SharedMeshRenderingData17UnloadIndexBufferEv: __ZN23SharedMeshRenderingData17UnloadIndexBufferEv, __Z54Register_UnityEngine_PlatformEffector2D_get_surfaceArcv: __Z54Register_UnityEngine_PlatformEffector2D_get_surfaceArcv, __ZThn4_N5physx5cloth9SwFactoryD0Ev: __ZThn4_N5physx5cloth9SwFactoryD0Ev, __ZNK11AudioSource16GetReverbZoneMixEv: __ZNK11AudioSource16GetReverbZoneMixEv, __Z37SliderJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth: __Z37SliderJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth, __Z49AudioSettings_Get_Custom_PropProfilerCaptureFlagsv: __Z49AudioSettings_Get_Custom_PropProfilerCaptureFlagsv, __ZN15DirectorManager11AcquireNodeEv: __ZN15DirectorManager11AcquireNodeEv, __ZN5physx9NpPhysics19createParticleFluidEjb: __ZN5physx9NpPhysics19createParticleFluidEjb, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekoffExNS_8ios_base7seekdirEj, __ZL33AllowIdentityTransformDestructionv: __ZL33AllowIdentityTransformDestructionv, __ZN5physx2Gu17sweepSphereSphereERKNS_6PxVec3EfS3_fS3_RfRS1_: __ZN5physx2Gu17sweepSphereSphereERKNS_6PxVec3EfS3_fS3_RfRS1_, __ZN5physx2Sc5Scene16visualizeEndStepEv: __ZN5physx2Sc5Scene16visualizeEndStepEv, __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv: __ZN27ParticleSystemReadOnlyState16CheckConsistencyEv, __Z39Animation_Set_Custom_PropAnimatePhysicsP12Il2CppObjecth: __Z39Animation_Set_Custom_PropAnimatePhysicsP12Il2CppObjecth, __ZN15ReflectionProbe13SetProbeDirtyEv: __ZN15ReflectionProbe13SetProbeDirtyEv, __Z46ParticleSystem_NoiseModule_CUSTOM_GetFrequencyP12Il2CppObject: __Z46ParticleSystem_NoiseModule_CUSTOM_GetFrequencyP12Il2CppObject, __Z27GetGyroRotationRateUnbiasedi: __Z27GetGyroRotationRateUnbiasedi, _UNITY_png_save_uint_16: _UNITY_png_save_uint_16, __Z33Cloth_Set_Custom_PropCoefficientsP12Il2CppObjectP11Il2CppArray: __Z33Cloth_Set_Custom_PropCoefficientsP12Il2CppObjectP11Il2CppArray, __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_: __ZN11NamedObject8TransferI17RemapPPtrTransferEEvRT_, __ZN21LightProbeProxyVolume8TransferI14SafeBinaryReadEEvRT_: __ZN21LightProbeProxyVolume8TransferI14SafeBinaryReadEEvRT_, __ZN5physx23AggregateAABBUpdateTaskD0Ev: __ZN5physx23AggregateAABBUpdateTaskD0Ev, __Z52Register_UnityEngine_Application_get_submitAnalyticsv: __Z52Register_UnityEngine_Application_get_submitAnalyticsv, __ZN21LightProbeProxyVolumeD0Ev: __ZN21LightProbeProxyVolumeD0Ev, _UNITY_png_set_text_compression_method: _UNITY_png_set_text_compression_method, __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18ColorBySpeedModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_9TriangleVERKNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv: __ZNK5physx3Scb4Body29getGlobalInertiaTensorInverseEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __Z25scripting_method_get_name21ScriptingMethodIl2Cpp: __Z25scripting_method_get_name21ScriptingMethodIl2Cpp, __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb1EEEEvRS1_RT_: __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb1EEEEvRS1_RT_, _UNITY_FT_Cos: _UNITY_FT_Cos, __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_: __ZN5physx2SnL23copyRepXNodeAndSiblingsEPNS_18CMemoryPoolManagerEPKNS0_7XmlNodeEPS3_, __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec3ENS0_15InlineAllocatorILj60ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_: __ZN15SerializeTraitsIN4math4trsXEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_, __ZN14PhysicsManager34SetDefaultSolverVelocityIterationsEi: __ZN14PhysicsManager34SetDefaultSolverVelocityIterationsEi, __ZN14GrowableBuffer13EnlargeBufferEjj: __ZN14GrowableBuffer13EnlargeBufferEjj, __ZN8DateTime26FromMicrosecondsSinceEpochEy: __ZN8DateTime26FromMicrosecondsSinceEpochEy, __ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf: __ZN5physx2Cm15ConeLimitHelper8getLimitERKNS_6PxQuatERNS_6PxVec3ERf, __ZN14Texture2DArray23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14Texture2DArray23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN14PhysicMaterial23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14PhysicMaterial23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE8allocateEj, __Z20CreateObjectFromCodeI6SpriteEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI6SpriteEPT_17AwakeFromLoadMode10MemLabelId, __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN19CharacterController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z33NavMeshPath_Get_Custom_PropStatusP12Il2CppObject: __Z33NavMeshPath_Get_Custom_PropStatusP12Il2CppObject, __ZN9b2Fixture8RefilterEv: __ZN9b2Fixture8RefilterEv, __ZN7b2Joint11ShiftOriginERK6b2Vec2: __ZN7b2Joint11ShiftOriginERK6b2Vec2, __ZNK5physx14NpArticulation26getExternalDriveIterationsEv: __ZNK5physx14NpArticulation26getExternalDriveIterationsEv, __ZNK5physx7NpShape13getOwnerSceneEv: __ZNK5physx7NpShape13getOwnerSceneEv, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE26getRelativeAngularVelocityEv, __ZN29InitialModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN29InitialModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z26Avatar_CUSTOM_SetParameterP12Il2CppObjectif: __Z26Avatar_CUSTOM_SetParameterP12Il2CppObjectif, __ZN16ParticleRendererD0Ev: __ZN16ParticleRendererD0Ev, __ZN5physx2Sc9ClothCore18unlockParticleDataEv: __ZN5physx2Sc9ClothCore18unlockParticleDataEv, __Z53TerrainData_Set_Custom_PropInternal_baseMapResolutionP12Il2CppObjecti: __Z53TerrainData_Set_Custom_PropInternal_baseMapResolutionP12Il2CppObjecti, __Z42Register_UnityEngine_Camera_set_clearFlagsv: __Z42Register_UnityEngine_Camera_set_clearFlagsv, __ZN12_GLOBAL__N_117EventBufferClientD0Ev: __ZN12_GLOBAL__N_117EventBufferClientD0Ev, __ZNK14SoundHandleAPI16GetBitsPerSampleEv: __ZNK14SoundHandleAPI16GetBitsPerSampleEv, __ZN13SliderJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SliderJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentrycvbEv: __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6sentrycvbEv, __Z57Register_UnityEngine_SystemInfo_get_graphicsDeviceVersionv: __Z57Register_UnityEngine_SystemInfo_get_graphicsDeviceVersionv, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS_7profile26WrapperReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZN14Physics2DState13RecreateWorldEv: __ZN14Physics2DState13RecreateWorldEv, __ZN5physx17ConvexMeshBuilderD2Ev: __ZN5physx17ConvexMeshBuilderD2Ev, __ZNK19CharacterController16GetGlobalExtentsEv: __ZNK19CharacterController16GetGlobalExtentsEv, __Z11GetGUIStatev: __Z11GetGUIStatev, _t2_hints_stems: _t2_hints_stems, __ZNKSt3__212ctype_bynameIcE10do_tolowerEc: __ZNKSt3__212ctype_bynameIcE10do_tolowerEc, __ZN5physx5cloth16SwInterCollisionI8Scalar4fE15collideParticleEj: __ZN5physx5cloth16SwInterCollisionI8Scalar4fE15collideParticleEj, __ZN7mecanim9animation4Clip8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation4Clip8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15DirectorManager16PrepareFrameFuncEP11DirectorJobj: __ZN15DirectorManager16PrepareFrameFuncEP11DirectorJobj, __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEEC2ERNS_19PxAllocatorCallbackE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj621ES4_NS_12PxFilterDataEKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN5physx2Gu33pcmDistanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_S7_: __ZN5physx2Gu33pcmDistanceSegmentTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_RNS2_6FloatVES7_S7_, __ZNK5physx23PxVehicleWheels4SimData7isValidEj: __ZNK5physx23PxVehicleWheels4SimData7isValidEj, __ZN24MaterialDisplayListCache20MaterialDisplayLists22InvalidateDisplayListsEv: __ZN24MaterialDisplayListCache20MaterialDisplayLists22InvalidateDisplayListsEv, __ZN13MonoBehaviour15InitializeClassEv: __ZN13MonoBehaviour15InitializeClassEv, __Z48Register_UnityEngine_Texture2D_Internal_ResizeWHv: __Z48Register_UnityEngine_Texture2D_Internal_ResizeWHv, __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN11PlayerPrefs9GetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __Z54Register_UnityEngine_Transform_INTERNAL_get_lossyScalev: __Z54Register_UnityEngine_Transform_INTERNAL_get_lossyScalev, __ZN5physx2Sc5Scene18releaseConstraintsEv: __ZN5physx2Sc5Scene18releaseConstraintsEv, __ZN15b2ContactSolverC2EP18b2ContactSolverDef: __ZN15b2ContactSolverC2EP18b2ContactSolverDef, __ZN10TagManager11TagToStringEj: __ZN10TagManager11TagToStringEj, _jsimd_h2v1_downsample: _jsimd_h2v1_downsample, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __Z50getPxSimulationStatisticsParticlesGpuMeshCacheUsedPKN5physx22PxSimulationStatisticsE: __Z50getPxSimulationStatisticsParticlesGpuMeshCacheUsedPKN5physx22PxSimulationStatisticsE, __ZN5physx3Ext7D6Joint29setProjectionAngularToleranceEf: __ZN5physx3Ext7D6Joint29setProjectionAngularToleranceEf, __ZN23iPhoneLocalNotification19GetDefaultSoundNameEv: __ZN23iPhoneLocalNotification19GetDefaultSoundNameEv, __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_: __ZNSt3__27__sort5IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameE10ColorRGBAfEES7_EPS5_EEjT0_SC_SC_SC_SC_T_, __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIyyEEPyEEjT0_S5_S5_S5_S5_T_, __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN7Texture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK30SpriteRendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK30SpriteRendererAnimationBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrIN13TextRendering4FontEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z57Register_UnityEngine_Canvas_set_sortingGridNormalizedSizev: __Z57Register_UnityEngine_Canvas_set_sortingGridNormalizedSizev, __Z43Register_UnityEngine_RenderSettings_set_fogv: __Z43Register_UnityEngine_RenderSettings_set_fogv, __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf: __ZN8Material8SetFloatEN9ShaderLab16FastPropertyNameEf, __ZNK16BaseVideoTexture9IsPlayingEv: __ZNK16BaseVideoTexture9IsPlayingEv, __ZN4FMOD4DSPI12getNumInputsEPi: __ZN4FMOD4DSPI12getNumInputsEPi, __ZN37AssetBundleLoadFromFileAsyncOperationD2Ev: __ZN37AssetBundleLoadFromFileAsyncOperationD2Ev, __Z26Texture2D_CUSTOM_SetPixelsP12Il2CppObjectiiiiP11Il2CppArrayi: __Z26Texture2D_CUSTOM_SetPixelsP12Il2CppObjectiiiiP11Il2CppArrayi, ___cxa_get_globals: ___cxa_get_globals, __Z16dictInsertBeforeP4DictP8DictNodePv: __Z16dictInsertBeforeP4DictP8DictNodePv, __ZN16MemoryFileSystem10ToAbsoluteEPKc: __ZN16MemoryFileSystem10ToAbsoluteEPKc, _Current_Ppem_Stretched: _Current_Ppem_Stretched, _cff_index_forget_element: _cff_index_forget_element, __ZN5physx12NpBatchQuery7executeEv: __ZN5physx12NpBatchQuery7executeEv, __ZNK15b2DistanceJoint10GetAnchorAEv: __ZNK15b2DistanceJoint10GetAnchorAEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEEC2ERKS6_jjRKS5_, __Z50getPxVehicleWheels4SimData_RecipTireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE: __Z50getPxVehicleWheels4SimData_RecipTireRestLoadsArrayPKN5physx23PxVehicleWheels4SimDataE, __Z37NavMeshPath_CUSTOM_DestroyNavMeshPathP12Il2CppObject: __Z37NavMeshPath_CUSTOM_DestroyNavMeshPathP12Il2CppObject, __ZZN26AnimatorOverrideController15InitializeClassEvEN42FunctorImpl_63kDidModifyAnimatorController4CallEPviR11MessageData: __ZZN26AnimatorOverrideController15InitializeClassEvEN42FunctorImpl_63kDidModifyAnimatorController4CallEPviR11MessageData, __ZN5physx6shdfnd10Foundation11getInstanceEv: __ZN5physx6shdfnd10Foundation11getInstanceEv, __ZL18ShouldCancelInvokePvS_: __ZL18ShouldCancelInvokePvS_, __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN24CollectBroadphaseTerrainC2EPN5physx12PxOverlapHitEij23QueryTriggerInteraction: __ZN24CollectBroadphaseTerrainC2EPN5physx12PxOverlapHitEij23QueryTriggerInteraction, __ZN5physx2Gu11ReadIndicesEtjPtRNS_13PxInputStreamEb: __ZN5physx2Gu11ReadIndicesEtjPtRNS_13PxInputStreamEb, __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE: __ZNK5physx18PxcConvexTriangles19calcCenterAndBoundsERKNS_11PxTransformE, __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZL16FMOD_ErrorString11FMOD_RESULT_325: __ZL16FMOD_ErrorString11FMOD_RESULT_325, __ZN5physx2Sc17ParticleSystemSim18visualizeParticlesERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim18visualizeParticlesERNS_2Cm12RenderOutputE, __ZNK14PhysicMaterial18GetDynamicFrictionEv: __ZNK14PhysicMaterial18GetDynamicFrictionEv, __ZN15CacheReaderBaseD0Ev: __ZN15CacheReaderBaseD0Ev, __ZN5physx16PxsParticleShapeC2EPNS_10PxsContextEj: __ZN5physx16PxsParticleShapeC2EPNS_10PxsContextEj, __ZN9dtNavMesh24connectOffMeshConnectionEj: __ZN9dtNavMesh24connectOffMeshConnectionEj, __ZN9JSONWrite12EndMetaGroupEv: __ZN9JSONWrite12EndMetaGroupEv, __Z36Canvas_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE: __Z36Canvas_CUSTOM_INTERNAL_get_pixelRectP12Il2CppObjectP5RectTIfE, __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SplatDatabase8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setTetherConstraintStiffnessEf, _ps_hints_t2counter: _ps_hints_t2counter, __Z39Register_UnityEngine_Transform_GetChildv: __Z39Register_UnityEngine_Transform_GetChildv, __ZNK14SoundHandleAPI13GetMemoryInfoEb: __ZNK14SoundHandleAPI13GetMemoryInfoEb, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE: __ZN5Umbra11KDTraversalINS_13PointTraverseILb1EEEE4nextERNS_6KDTree4NodeERNS_10NoUserDataE, __Z43Register_UnityEngine_WheelCollider_get_massv: __Z43Register_UnityEngine_WheelCollider_get_massv, __Z19setPxMaterial_FlagsPN5physx10PxMaterialENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE: __Z19setPxMaterial_FlagsPN5physx10PxMaterialENS_7PxFlagsINS_14PxMaterialFlag4EnumEtEE, __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve: __ZL16WriteMinMaxCurveRK15MonoMinMaxCurveR11MinMaxCurve, __Z44Register_UnityEngine_Canvas_set_sortingOrderv: __Z44Register_UnityEngine_Canvas_set_sortingOrderv, __ZN22NavMeshProjectSettings15ThreadedCleanupEv: __ZN22NavMeshProjectSettings15ThreadedCleanupEv, __ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb: __ZN5physx2Sc19ShapeInstancePairLL16managerLostTouchEjb, __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetBouncev: __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetBouncev, __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI7TextureE8TransferI18StreamedBinaryReadILb1EEEEvRT_, _ft_stroker_inside: _ft_stroker_inside, __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z15CreateDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN10__cxxabiv112_GLOBAL__N_110construct_Ev: __ZN10__cxxabiv112_GLOBAL__N_110construct_Ev, __Z46Register_UnityEngine_Light_get_bounceIntensityv: __Z46Register_UnityEngine_Light_get_bounceIntensityv, __ZL23CleanupModule_Animationv: __ZL23CleanupModule_Animationv, __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx18PxFabricCookerImpl13getDescriptorEv: __ZNK5physx18PxFabricCookerImpl13getDescriptorEv, __ZN14PhysicsManager12CleanupClassEv: __ZN14PhysicsManager12CleanupClassEv, __ZN5physx14PxVehicleDrive15computeByteSizeEj: __ZN5physx14PxVehicleDrive15computeByteSizeEj, __ZN6Shader10GetDefaultEv: __ZN6Shader10GetDefaultEv, __Z40Register_UnityEngine_Texture3D_SetPixelsv: __Z40Register_UnityEngine_Texture3D_SetPixelsv, __Z35AnimationState_Set_Custom_PropLayerP12Il2CppObjecti: __Z35AnimationState_Set_Custom_PropLayerP12Il2CppObjecti, __ZN5physx34PxsSolverConstraintPostProcessTask11runInternalEv: __ZN5physx34PxsSolverConstraintPostProcessTask11runInternalEv, __ZN4FMOD5Sound19getMusicNumChannelsEPi: __ZN4FMOD5Sound19getMusicNumChannelsEPi, __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j: __ZNK5physx35PxJointLimitParametersGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEEEEEjT_j, __ZN5physx6shdfnd6Socket7connectEPKctj: __ZN5physx6shdfnd6Socket7connectEPKctj, _UNITY_FT_Init_Class_ft_standard_raster: _UNITY_FT_Init_Class_ft_standard_raster, __ZN4Tree7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN4Tree7PRODUCEE10MemLabelId18ObjectCreationMode, _process_data_context_main: _process_data_context_main, __ZThn4_N16RayRTreeCallbackILi1ELb0EE14processResultsEjPj: __ZThn4_N16RayRTreeCallbackILi1ELb0EE14processResultsEjPj, __Z42Register_UnityEngine_AudioClip_get_samplesv: __Z42Register_UnityEngine_AudioClip_get_samplesv, __ZN14SphereCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14SphereCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN10Effector2D15ThreadedCleanupEv: __ZN10Effector2D15ThreadedCleanupEv, __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE8recreateEj, __Z47Register_UnityEngine_AI_NavMeshAgent_get_radiusv: __Z47Register_UnityEngine_AI_NavMeshAgent_get_radiusv, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z44Register_UnityEngine_AndroidJNI_SetCharFieldv: __Z44Register_UnityEngine_AndroidJNI_SetCharFieldv, __Z54Register_UnityEngine_OcclusionArea_INTERNAL_get_centerv: __Z54Register_UnityEngine_OcclusionArea_INTERNAL_get_centerv, __ZN7mecanim5human13HumanCopyAxesEPKNS0_5HumanEPS1_: __ZN7mecanim5human13HumanCopyAxesEPKNS0_5HumanEPS1_, __Z40NavMeshAgent_Get_Custom_PropAngularSpeedP12Il2CppObject: __Z40NavMeshAgent_Get_Custom_PropAngularSpeedP12Il2CppObject, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z35Collider2D_Get_Custom_PropIsTriggerP12Il2CppObject: __Z35Collider2D_Get_Custom_PropIsTriggerP12Il2CppObject, __ZN17SurfaceEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17SurfaceEffector2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN2gl17GetCurrentContextEv: __ZN2gl17GetCurrentContextEv, __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_get_backgroundColorv: __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_get_backgroundColorv, __ZN5physx11HullLibrary16CreateConvexHullERKNS_8HullDescERNS_10HullResultE: __ZN5physx11HullLibrary16CreateConvexHullERKNS_8HullDescERNS_10HullResultE, ___do_des: ___do_des, _jinit_d_coef_controller: _jinit_d_coef_controller, __ZN5physx23performBoxPruningNewOldERKNS_2Gu4AxesEPKjjS5_jPjS6_PPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_: __ZN5physx23performBoxPruningNewOldERKNS_2Gu4AxesEPKjjS5_jPjS6_PPNS_8SapBox1DES5_RNS_14SapPairManagerERS6_RjSD_, __Z24RegisterStrippedTypeInfoI9LensFlareEviPKcS2_: __Z24RegisterStrippedTypeInfoI9LensFlareEviPKcS2_, __Z42Canvas_Set_Custom_PropOverridePixelPerfectP12Il2CppObjecth: __Z42Canvas_Set_Custom_PropOverridePixelPerfectP12Il2CppObjecth, __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z37CapsuleCollider_Get_Custom_PropHeightP12Il2CppObject: __Z37CapsuleCollider_Get_Custom_PropHeightP12Il2CppObject, __ZNK7Cubemap12GetDimensionEv: __ZNK7Cubemap12GetDimensionEv, __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN18AwakeFromLoadQueue34PersistentManagerAwakeSingleObjectER6Object17AwakeFromLoadMode: __ZN18AwakeFromLoadQueue34PersistentManagerAwakeSingleObjectER6Object17AwakeFromLoadMode, __ZN22DeviceStencilStateGLESC2ERK15GfxStencilState: __ZN22DeviceStencilStateGLESC2ERK15GfxStencilState, __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_: __ZN8GUIStyle8TransferI17RemapPPtrTransferEEvRT_, __ZN19ConstantBuffersGLES8UpdateCBEiiPKv: __ZN19ConstantBuffersGLES8UpdateCBEiiPKv, __ZN4FMOD13ChannelGroupI10getChannelEiPPNS_7ChannelE: __ZN4FMOD13ChannelGroupI10getChannelEiPPNS_7ChannelE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20OcclusionCullingData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14AudioBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14AudioBehaviour7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN14ParticleSystem27DetermineSupportsProceduralERKS_: __ZN14ParticleSystem27DetermineSupportsProceduralERKS_, __Z51Register_UnityEngine_SystemInfo_get_supportsShadowsv: __Z51Register_UnityEngine_SystemInfo_get_supportsShadowsv, __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN11DynamicMesh10DetailHullaSERKS0_: __ZN11DynamicMesh10DetailHullaSERKS0_, __ZNKSt3__27codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_: __ZNKSt3__27codecvtIcc11__mbstate_tE6do_outERS1_PKcS5_RS5_PcS7_RS7_, __ZNK12b2MouseJoint12GetFrequencyEv: __ZNK12b2MouseJoint12GetFrequencyEv, _UNITY_ft_mem_realloc: _UNITY_ft_mem_realloc, __ZN8ColliderD2Ev: __ZN8ColliderD2Ev, __ZN8VRDeviceD0Ev: __ZN8VRDeviceD0Ev, __ZN17PhysicsMaterial2D11SetFrictionEf: __ZN17PhysicsMaterial2D11SetFrictionEf, __ZNK9AudioClip26GetTypeInfoVirtualInternalEv: __ZNK9AudioClip26GetTypeInfoVirtualInternalEv, __Z42Physics_CUSTOM_INTERNAL_CALL_OverlapSphereRK8Vector3ffi23QueryTriggerInteraction: __Z42Physics_CUSTOM_INTERNAL_CALL_OverlapSphereRK8Vector3ffi23QueryTriggerInteraction, __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_12PxConstraintES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i: __ZNK9Texture2D11GetPixels32EiP11ColorRGBA32i, __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEjT0_S6_S6_S6_T_, __ZN17FileSystemHandler9MakeLocalER13FileEntryDatab: __ZN17FileSystemHandler9MakeLocalER13FileEntryDatab, __ZN10Effector2D15WakeAllContactsEv: __ZN10Effector2D15WakeAllContactsEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setCapsulesENS0_5RangeIKjEEjj, __ZNSt3__26localeC2ERKS0_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi: __ZNSt3__26localeC2ERKS0_RKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEi, __ZN17OverlapBoxQuery2D13ReportFixtureEP9b2Fixture: __ZN17OverlapBoxQuery2D13ReportFixtureEP9b2Fixture, __ZN5physx2Sn13XmlNodeReader17popCurrentContextEv: __ZN5physx2Sn13XmlNodeReader17popCurrentContextEv, __ZN14MemoryProfiler20UnregisterAllocationEPvjRK10MemLabelId: __ZN14MemoryProfiler20UnregisterAllocationEPvjRK10MemLabelId, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEPKwj, __ZN25ThreadsafeLinearAllocator8AllocateEji: __ZN25ThreadsafeLinearAllocator8AllocateEji, __ZN7ApiGLES6SubmitEN2gl10SubmitModeE: __ZN7ApiGLES6SubmitEN2gl10SubmitModeE, _ft_smooth_render: _ft_smooth_render, __ZN12_GLOBAL__N_110Connection5flushEv: __ZN12_GLOBAL__N_110Connection5flushEv, __Z18Transfer_BlittableI8JSONReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_limitsv: __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_limitsv, __ZN11TypeManager21FindAllDerivedClassesEPK4RTTIR13dynamic_arrayIS2_Lj4EEb: __ZN11TypeManager21FindAllDerivedClassesEPK4RTTIR13dynamic_arrayIS2_Lj4EEb, __Z51AnchoredJoint2D_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP13Vector2fIcall: __Z51AnchoredJoint2D_CUSTOM_INTERNAL_get_connectedAnchorP12Il2CppObjectP13Vector2fIcall, __ZN10VertexDataC2ERKS_j: __ZN10VertexDataC2ERKS_j, _wcstoimax: _wcstoimax, __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetDampenP12Il2CppObjectf: __Z63ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetDampenP12Il2CppObjectf, __ZN5physx28PxVehicleWheelsGeneratedInfoC2Ev: __ZN5physx28PxVehicleWheelsGeneratedInfoC2Ev, __Z28setPxConvexMeshGeometryScalePN5physx20PxConvexMeshGeometryENS_11PxMeshScaleE: __Z28setPxConvexMeshGeometryScalePN5physx20PxConvexMeshGeometryENS_11PxMeshScaleE, __ZNK5physx2Sc16ArticulationCore24getSolverIterationCountsEv: __ZNK5physx2Sc16ArticulationCore24getSolverIterationCountsEv, __ZN14Texture2DArray11SetPixels32EiPK11ColorRGBA32ii: __ZN14Texture2DArray11SetPixels32EiPK11ColorRGBA32ii, __Z56ParticleSystem_ShapeModule_CUSTOM_SetSkinnedMeshRendererP12Il2CppObjectS0_: __Z56ParticleSystem_ShapeModule_CUSTOM_SetSkinnedMeshRendererP12Il2CppObjectS0_, __Z51Register_UnityEngine_GL_INTERNAL_CALL_MultiTexCoordv: __Z51Register_UnityEngine_GL_INTERNAL_CALL_MultiTexCoordv, __ZN16RTreeCookerRemapD0Ev: __ZN16RTreeCookerRemapD0Ev, __ZN11Rigidbody2DC2E10MemLabelId18ObjectCreationMode: __ZN11Rigidbody2DC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sc18ParticleSystemCore16setInternalFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE: __ZN5physx2Sc18ParticleSystemCore16setInternalFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj, _strfmon_l: _strfmon_l, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEE7getNameEv, __Z98Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInFixedTimeInternalv: __Z98Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_CrossFadeInFixedTimeInternalv, __ZNK5physx13BigConvexData20ComputeNearestOffsetERKNS_6PxVec3E: __ZNK5physx13BigConvexData20ComputeNearestOffsetERKNS_6PxVec3E, __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_: __ZNSt3__23mapI21GLESRenderTargetSetupN2gl6HandleILNS2_10ObjectTypeE9EEENS_4lessIS1_EENS_9allocatorINS_4pairIKS1_S5_EEEEEixERSA_, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE19getConcreteTypeNameEv, __ZNK17AnimationCurveTplI8Vector3fE14GetPreInfinityEv: __ZNK17AnimationCurveTplI8Vector3fE14GetPreInfinityEv, __Z46Register_UnityEngine_EdgeCollider2D_get_pointsv: __Z46Register_UnityEngine_EdgeCollider2D_get_pointsv, __ZN5physx14PxsAABBManager18setDynamicAABBDataEjRKNS_18PxcAABBDataDynamicE: __ZN5physx14PxsAABBManager18setDynamicAABBDataEjRKNS_18PxcAABBDataDynamicE, __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB: __Z51SkinnedMeshRenderer_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB, __ZN10InputEvent4InitEi: __ZN10InputEvent4InitEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE14handleAccessorILj640ENS_22PxRepXPropertyAccessorILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataESA_EEEEvRKT0_, __Z12CreateMipMapPhiii13TextureFormat: __Z12CreateMipMapPhiii13TextureFormat, __Z33Collider_Set_Custom_PropIsTriggerP12Il2CppObjecth: __Z33Collider_Set_Custom_PropIsTriggerP12Il2CppObjecth, __Z14GetLightProbesv: __Z14GetLightProbesv, __ZN5physx2Sc17ParticleSystemSim7endStepEv: __ZN5physx2Sc17ParticleSystemSim7endStepEv, __Z39Register_UnityEngine_Animation_get_clipv: __Z39Register_UnityEngine_Animation_get_clipv, __ZN13SliderJoint2DD0Ev: __ZN13SliderJoint2DD0Ev, __ZNK24DownloadHandlerAudioClip9GetLengthEv: __ZNK24DownloadHandlerAudioClip9GetLengthEv, __ZN5physx17PxcNpMemBlockPool19acquireNpCacheBlockEv: __ZN5physx17PxcNpMemBlockPool19acquireNpCacheBlockEv, __ZNSt3__28messagesIwEC2Ej: __ZNSt3__28messagesIwEC2Ej, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN14AreaEffector2D13SetForceAngleEf: __ZN14AreaEffector2D13SetForceAngleEf, __Z23HTML5MouseButtonToUnityi: __Z23HTML5MouseButtonToUnityi, _jsimd_idct_islow: _jsimd_idct_islow, __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj: __ZNK5physx22PxVehicleWheelsSimData26getSuspForceAppPointOffsetEj, _jsimd_can_idct_float: _jsimd_can_idct_float, __ZN5physx27integrateNoDriveWheelSpeedsEfPKfPKbS1_S1_S1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE: __ZN5physx27integrateNoDriveWheelSpeedsEfPKfPKbS1_S1_S1_RKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE, __ZN7mecanim5human13FullBodySolveEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESC_SC_: __ZN7mecanim5human13FullBodySolveEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESC_SC_, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration16generateContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration16generateContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj, __ZN12AudioManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12AudioManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sc13ConstraintSim15needsProjectionEv: __ZN5physx2Sc13ConstraintSim15needsProjectionEv, __Z38CanvasBatchIntermediateRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi: __Z38CanvasBatchIntermediateRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi, __ZN33SizeBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN33SizeBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN10GameObject30SetActiveRecursivelyDeprecatedEb: __ZN10GameObject30SetActiveRecursivelyDeprecatedEb, __ZN5physx17PxStringTableImplD0Ev: __ZN5physx17PxStringTableImplD0Ev, __ZN15SharedLightData18CalculateAreaRangeEv: __ZN15SharedLightData18CalculateAreaRangeEv, __ZN10Collider2D17RemoveFromManagerEv: __ZN10Collider2D17RemoveFromManagerEv, __ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_: __ZN2UI26DistancePointToLineSegmentE8Vector3fS0_S0_, __ZN17ProceduralTexture8TransferI14SafeBinaryReadEEvRT_: __ZN17ProceduralTexture8TransferI14SafeBinaryReadEEvRT_, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, __ZN14AreaEffector2D12CleanupClassEv: __ZN14AreaEffector2D12CleanupClassEv, __ZN5physx3Ext7D6Joint9setMotionENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE: __ZN5physx3Ext7D6Joint9setMotionENS_8PxD6Axis4EnumENS_10PxD6Motion4EnumE, __ZN14RenderSettings24SetDefaultReflectionModeENS_21DefaultReflectionModeE: __ZN14RenderSettings24SetDefaultReflectionModeENS_21DefaultReflectionModeE, __Z52UnityWebRequest_CUSTOM_InternalGetResponseHeaderKeysP12Il2CppObject: __Z52UnityWebRequest_CUSTOM_InternalGetResponseHeaderKeysP12Il2CppObject, __Z3md5PhiS_: __Z3md5PhiS_, __ZN5physx17ConvexHullBuilder23CalculateVertexMapTableEjb: __ZN5physx17ConvexHullBuilder23CalculateVertexMapTableEjb, __ZN12GUIClipState4PushER10InputEventRK5RectTIfE8Vector2fRKS6_b: __ZN12GUIClipState4PushER10InputEventRK5RectTIfE8Vector2fRKS6_b, __ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE: __ZNK5physx10PxsContext25getVisualizationParameterENS_24PxVisualizationParameter4EnumE, __ZNK5physx19NpArticulationJoint13getOwnerSceneEv: __ZNK5physx19NpArticulationJoint13getOwnerSceneEv, __ZN5physx2Sn17readAllPropertiesINS_7PxClothEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_7PxClothEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN5physx5Elems4growEj: __ZN5physx5Elems4growEj, __Z17SetupVertexLightsiPKPK11ActiveLightR17ShaderPassContext: __Z17SetupVertexLightsiPKPK11ActiveLightR17ShaderPassContext, __Z62Register_UnityEngine_Terrain_ApplyDelayedHeightmapModificationv: __Z62Register_UnityEngine_Terrain_ApplyDelayedHeightmapModificationv, __ZN16GUIKeyboardState8EndFrameEv: __ZN16GUIKeyboardState8EndFrameEv, __ZN5physx19NpArticulationJoint10setDampingEf: __ZN5physx19NpArticulationJoint10setDampingEf, __ZN9LensFlare8TransferI14SafeBinaryReadEEvRT_: __ZN9LensFlare8TransferI14SafeBinaryReadEEvRT_, __ZN5Unity9Component7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity9Component7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN12TLSAllocatorI14StackAllocatorED2Ev: __ZN12TLSAllocatorI14StackAllocatorED2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __ZNK5physx7profile21NullEventNameProvider15getProfileNamesEv: __ZNK5physx7profile21NullEventNameProvider15getProfileNamesEv, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadaEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadaEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __ZN4PPtrI17ProceduralTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI17ProceduralTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SphereColliderC2E10MemLabelId18ObjectCreationMode: __ZN14SphereColliderC2E10MemLabelId18ObjectCreationMode, __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType: __ZN8Playable9ConstructEP11Il2CppClassP12Il2CppObject18DirectorPlayerType, __ZNK5physx3Ext13RevoluteJoint8getLimitEv: __ZNK5physx3Ext13RevoluteJoint8getLimitEv, __ZN5physx21PxProfileNameProviderD2Ev: __ZN5physx21PxProfileNameProviderD2Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15AudioMixerGroupELj4EEEEvRT_17TransferMetaFlags, __Z17ExtractStacktraceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_Piii: __Z17ExtractStacktraceRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_Piii, __Z37RenderSettings_Get_Custom_PropFogModev: __Z37RenderSettings_Get_Custom_PropFogModev, __ZN8UserList7AddUserER12UserListNode: __ZN8UserList7AddUserER12UserListNode, __Z12ReadTypeTreeR8TypeTreeRPKhS2_ib: __Z12ReadTypeTreeR8TypeTreeRPKhS2_ib, __ZN8UserList5ClearEv: __ZN8UserList5ClearEv, __ZN8Animator20SetBoneLocalRotationEi11Quaternionf: __ZN8Animator20SetBoneLocalRotationEi11Quaternionf, _significandf: _significandf, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfertEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfertEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z58Register_UnityEngine_SceneManagement_Scene_IsValidInternalv: __Z58Register_UnityEngine_SceneManagement_Scene_IsValidInternalv, __ZN9AudioClip12CleanupClassEv: __ZN9AudioClip12CleanupClassEv, __Z29AddRenderersToRenderNodeQueuePP12BaseRendererjR15RenderNodeQueue: __Z29AddRenderersToRenderNodeQueuePP12BaseRendererjR15RenderNodeQueue, __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE: __ZN5physx22PxVehicleWheelsSimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE, __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofERKS5_j, __ZNSt3__211char_traitsIwE6assignEPwjw: __ZNSt3__211char_traitsIwE6assignEPwjw, __Z32GUIStyle_Set_Custom_PropClippingP12Il2CppObjecti: __Z32GUIStyle_Set_Custom_PropClippingP12Il2CppObjecti, _UNITY_png_set_interlace_handling: _UNITY_png_set_interlace_handling, __Z39Register_UnityEngine_GL_InvalidateStatev: __Z39Register_UnityEngine_GL_InvalidateStatev, __ZNKSt3__210moneypunctIcLb1EE14do_curr_symbolEv: __ZNKSt3__210moneypunctIcLb1EE14do_curr_symbolEv, __Z38Register_UnityEngine_LODGroup_get_sizev: __Z38Register_UnityEngine_LODGroup_get_sizev, __ZN5physx2Sc9ClothCore22setAngularInertiaScaleENS_6PxVec3E: __ZN5physx2Sc9ClothCore22setAngularInertiaScaleENS_6PxVec3E, __Z32scripting_class_get_assemblynameP11Il2CppClass: __Z32scripting_class_get_assemblynameP11Il2CppClass, __ZN30ReportScriptingObjectsTransfer8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags: __ZN30ReportScriptingObjectsTransfer8TransferI23ManagedObjectTransfererEEvRT_PKc17TransferMetaFlags, _gray_render_scanline: _gray_render_scanline, _tcgetpgrp: _tcgetpgrp, __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN14DetailDatabase13AwakeFromLoadE17AwakeFromLoadMode: __ZN14DetailDatabase13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ERKS5_, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_14updateDynamicsEPNS_10PxBaseTaskEEEE7getNameEv, __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj: __ZN20SoundChannelInstance8setDelayE14FMOD_DELAYTYPEjj, __Z64Register_UnityEngine_RectTransform_INTERNAL_set_anchoredPositionv: __Z64Register_UnityEngine_RectTransform_INTERNAL_set_anchoredPositionv, __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv: __ZN31CanvasBatchIntermediateRenderer25CleanupSubBatchPropertiesEv, _mempcpy: _mempcpy, __ZL37CleanupParticleSystemScriptingClassesv: __ZL37CleanupParticleSystemScriptingClassesv, __ZNK11b2RopeJoint17GetReactionTorqueEf: __ZNK11b2RopeJoint17GetReactionTorqueEf, __ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __ZN5physx15PxGeometryQuery5sweepERKNS_6PxVec3EfRKNS_10PxGeometryERKNS_11PxTransformES6_S9_RNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __Z28getPxSceneLimitsMaxNbRegionsPKN5physx13PxSceneLimitsE: __Z28getPxSceneLimitsMaxNbRegionsPKN5physx13PxSceneLimitsE, __ZNK13RenderTexture26GetTypeInfoVirtualInternalEv: __ZNK13RenderTexture26GetTypeInfoVirtualInternalEv, _cf2_getPpemY: _cf2_getPpemY, __ZN5Umbra12QueryContext12clusterColorEi: __ZN5Umbra12QueryContext12clusterColorEi, __ZN8Playable11DerivesFromEP11Il2CppClass: __ZN8Playable11DerivesFromEP11Il2CppClass, __Z46Register_UnityEngine_Rigidbody_set_constraintsv: __Z46Register_UnityEngine_Rigidbody_set_constraintsv, __Z39getPxVehicleDriveDynDataMGearSwitchTimePKN5physx21PxVehicleDriveDynDataE: __Z39getPxVehicleDriveDynDataMGearSwitchTimePKN5physx21PxVehicleDriveDynDataE, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcb: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcb, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcd: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcd, __Z31setPxCloth_ExternalAccelerationPN5physx7PxClothENS_6PxVec3E: __Z31setPxCloth_ExternalAccelerationPN5physx7PxClothENS_6PxVec3E, __Z33getPxVehicleWheelData_RecipRadiusPKN5physx18PxVehicleWheelDataE: __Z33getPxVehicleWheelData_RecipRadiusPKN5physx18PxVehicleWheelDataE, __ZN9GfxDevice14WaitOnCPUFenceEj: __ZN9GfxDevice14WaitOnCPUFenceEj, __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEEEEjT_j: __ZNK5physx40PxVehicleDifferential4WDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEEEEEjT_j, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcl: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcl, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcm: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcm, __ZN5physx2Sn18RecursiveTraversal8traverseEv: __ZN5physx2Sn18RecursiveTraversal8traverseEv, __Z45Animation_Set_Custom_PropAnimateOnlyIfVisibleP12Il2CppObjecth: __Z45Animation_Set_Custom_PropAnimateOnlyIfVisibleP12Il2CppObjecth, __Z41ReflectionProbe_Set_Custom_PropResolutionP12Il2CppObjecti: __Z41ReflectionProbe_Set_Custom_PropResolutionP12Il2CppObjecti, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcy: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcy, __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j: __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j, __ZL29GeomMTDCallback_SphereCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL29GeomMTDCallback_SphereCapsuleRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z33Canvas_Get_Custom_PropScaleFactorP12Il2CppObject: __Z33Canvas_Get_Custom_PropScaleFactorP12Il2CppObject, __ZN11AssetBundleD0Ev: __ZN11AssetBundleD0Ev, __Z45Register_UnityEngine_Renderer_get_castShadowsv: __Z45Register_UnityEngine_Renderer_get_castShadowsv, __GLOBAL__sub_I_runtime_baseclasses_lump_cpp: __GLOBAL__sub_I_runtime_baseclasses_lump_cpp, __ZN6Avatar17NotifyObjectUsersERK17MessageIdentifier: __ZN6Avatar17NotifyObjectUsersERK17MessageIdentifier, __ZN12TextureInputD2Ev: __ZN12TextureInputD2Ev, __ZNSt3__26vectorIN19ControllerHitReport29RecordedControllerColliderHitENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19ControllerHitReport29RecordedControllerColliderHitENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatStringv: __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetFloatStringv, __ZNK5physx13NpClothFabric16getTetherLengthsEPfj: __ZNK5physx13NpClothFabric16getTetherLengthsEPfj, __ZN14SplatMaterialsD2Ev: __ZN14SplatMaterialsD2Ev, __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetSeparateAxesv: __Z74Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetSeparateAxesv, __ZN5physx2Sc18TriggerInteraction7destroyEv: __ZN5physx2Sc18TriggerInteraction7destroyEv, __ZN21UnityAnalyticsManager27OnPlayerSessionStateChangedEjyy: __ZN21UnityAnalyticsManager27OnPlayerSessionStateChangedEjyy, __ZN5physx3Ext10FixedJointD2Ev: __ZN5physx3Ext10FixedJointD2Ev, __Z23IsInitializedRenderLoopR10RenderLoop: __Z23IsInitializedRenderLoopR10RenderLoop, __Z20IsFloatTextureFormat13TextureFormat: __Z20IsFloatTextureFormat13TextureFormat, __ZNK23iPhoneLocalNotification17GetRepeatIntervalEv: __ZNK23iPhoneLocalNotification17GetRepeatIntervalEv, __Z90Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerNameInternalv: __Z90Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetLayerNameInternalv, __ZNK5Umbra14TomeCollection11getNumTomesEv: __ZNK5Umbra14TomeCollection11getNumTomesEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendEPKc, __Z15FindChildWithIDP9TransformRKN7mecanim5crc32EjRS2_i: __Z15FindChildWithIDP9TransformRKN7mecanim5crc32EjRS2_i, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setMassSpaceInertiaTensorERKNS_6PxVec3E: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setMassSpaceInertiaTensorERKNS_6PxVec3E, __ZNK5physx2Sc9ClothCore13getClothFlagsEv: __ZNK5physx2Sc9ClothCore13getClothFlagsEv, __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_80kLayerChanged4CallEPviR11MessageData: __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_80kLayerChanged4CallEPviR11MessageData, __Z36getPxVehicleWheelDataMMaxBrakeTorquePKN5physx18PxVehicleWheelDataE: __Z36getPxVehicleWheelDataMMaxBrakeTorquePKN5physx18PxVehicleWheelDataE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_am_pmERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN5physx10PxsContextD2Ev: __ZN5physx10PxsContextD2Ev, __Z61Register_UnityEngine_Rendering_GraphicsSettings_SetShaderModev: __Z61Register_UnityEngine_Rendering_GraphicsSettings_SetShaderModev, __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI15OcclusionPortalE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext: __Z20SetupObjectLightmapsRK26SharedLightmapSettingsDataRK15LightmapIndicesR17ShaderPassContext, __ZNK19TouchPhaseEmulation22IsStylusTouchSupportedEv: __ZNK19TouchPhaseEmulation22IsStylusTouchSupportedEv, __Z59Register_UnityEngine_AudioLowPassFilter_get_cutoffFrequencyv: __Z59Register_UnityEngine_AudioLowPassFilter_get_cutoffFrequencyv, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z33GUIStyle_CUSTOM_Internal_CalcSize13Il2Cpp_IntPtrP12Il2CppObjectP13Vector2fIcall: __Z33GUIStyle_CUSTOM_Internal_CalcSize13Il2Cpp_IntPtrP12Il2CppObjectP13Vector2fIcall, __Z26getPxCapsuleGeometryRadiusPKN5physx17PxCapsuleGeometryE: __Z26getPxCapsuleGeometryRadiusPKN5physx17PxCapsuleGeometryE, __Z33getPxSceneLimitsMaxNbStaticShapesPKN5physx13PxSceneLimitsE: __Z33getPxSceneLimitsMaxNbStaticShapesPKN5physx13PxSceneLimitsE, __GLOBAL__sub_I_runtime_virtualfilesystem_archivefilesystem_lump_cpp: __GLOBAL__sub_I_runtime_virtualfilesystem_archivefilesystem_lump_cpp, __ZN5physx16PxVehicleNoDrive15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx16PxVehicleNoDrive15exportExtraDataERNS_22PxSerializationContextE, __ZN12WheelJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12WheelJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z32GUI_Get_Custom_PropBlendMaterialv: __Z32GUI_Get_Custom_PropBlendMaterialv, __ZN24EllipsoidParticleEmitterD0Ev: __ZN24EllipsoidParticleEmitterD0Ev, __ZN5Umbra10PathFinder20getMemoryRequirementEPKNS_7ImpTomeE: __ZN5Umbra10PathFinder20getMemoryRequirementEPKNS_7ImpTomeE, __Z49Register_UnityEngine_AnimationState_set_blendModev: __Z49Register_UnityEngine_AnimationState_set_blendModev, _cbrt: _cbrt, __ZN12SocketStream4RecvEPvj: __ZN12SocketStream4RecvEPvj, ___stdio_close: ___stdio_close, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN2UI6Canvas10RenderModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN2UI6Canvas10RenderModeEEvRT_RT0_PKc17TransferMetaFlags, __Z39MeshCollider_Get_Custom_PropInflateMeshP12Il2CppObject: __Z39MeshCollider_Get_Custom_PropInflateMeshP12Il2CppObject, __ZL17ProgramUniform2ivPK7ApiGLESjiihPKv: __ZL17ProgramUniform2ivPK7ApiGLESjiihPKv, _cff_get_ps_name: _cff_get_ps_name, __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatABGR8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatBGRA888817TexFormatABGR8888EEvPKNS_9InnerInfoE, __ZNK5physx12NpConstraint13isSubordinateEv: __ZNK5physx12NpConstraint13isSubordinateEv, __Z52Register_UnityEngine_AI_NavMeshAgent_get_isOnNavMeshv: __Z52Register_UnityEngine_AI_NavMeshAgent_get_isOnNavMeshv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj600ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj600ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZN9Transform8GetSceneEv: __ZN9Transform8GetSceneEv, __ZN5Umbra16LineSegmentQueryaSERKS0_: __ZN5Umbra16LineSegmentQueryaSERKS0_, __ZN5Umbra20RuntimeTomeGenerator12makeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEE: __ZN5Umbra20RuntimeTomeGenerator12makeTopLevelERNS_25RuntimeSpatialSubdivisionINS_9AllocatorEEE, __ZN5physx25PxDefaultFileOutputStreamD0Ev: __ZN5physx25PxDefaultFileOutputStreamD0Ev, __ZN9JSONWrite8TransferI4PPtrI9Texture2DEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI4PPtrI9Texture2DEEEvRT_PKc17TransferMetaFlags, __ZN5physx8debugger14PvdMarshallingIdyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIdyE12marshalBlockEPKhPhj, __ZN5physx2Sc9ShapeCore11setGeometryERKNS_10PxGeometryE: __ZN5physx2Sc9ShapeCore11setGeometryERKNS_10PxGeometryE, __ZN18AnimatorController28InvalidateAnimatorControllerEb: __ZN18AnimatorController28InvalidateAnimatorControllerEb, __ZN5physx6shdfnd7PAUtils9statEventEtj: __ZN5physx6shdfnd7PAUtils9statEventEtj, __ZN15TerrainRenderer22ReloadPrecomputedErrorEv: __ZN15TerrainRenderer22ReloadPrecomputedErrorEv, __Z37Cloth_Set_Custom_PropCapsuleCollidersP12Il2CppObjectP11Il2CppArray: __Z37Cloth_Set_Custom_PropCapsuleCollidersP12Il2CppObjectP11Il2CppArray, __ZN14SpriteRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN14SpriteRenderer23VirtualRedirectTransferER14SafeBinaryRead, __Z54Register_UnityEngine_QualitySettings_set_softParticlesv: __Z54Register_UnityEngine_QualitySettings_set_softParticlesv, __Z41Physics2D_CUSTOM_INTERNAL_CALL_RaycastAllRK13Vector2fIcallS1_fiff: __Z41Physics2D_CUSTOM_INTERNAL_CALL_RaycastAllRK13Vector2fIcallS1_fiff, __Z38SpringJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf: __Z38SpringJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf, __ZN19SkinnedMeshRenderer8TransferI17RemapPPtrTransferEEvRT_: __ZN19SkinnedMeshRenderer8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx24NpPtrTableStorageManager8allocateEj: __ZN5physx24NpPtrTableStorageManager8allocateEj, __Z39getPxD6Joint_ProjectionAngularTolerancePKN5physx9PxD6JointE: __Z39getPxD6Joint_ProjectionAngularTolerancePKN5physx9PxD6JointE, __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi: __ZNK19ShaderPropertySheet25GetVectorValueInsRGBSpaceEi, __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f: __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_GetMatrixP12Il2CppObjectiR10Matrix4x4f, __Z28EnsureRenderTextureIsCreatedP13RenderTexture: __Z28EnsureRenderTextureIsCreatedP13RenderTexture, __Z37getPxRigidBody_MassSpaceInertiaTensorPKN5physx11PxRigidBodyE: __Z37getPxRigidBody_MassSpaceInertiaTensorPKN5physx11PxRigidBodyE, __Z48Physics2D_Set_Custom_PropQueriesStartInCollidersh: __Z48Physics2D_Set_Custom_PropQueriesStartInCollidersh, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewStringUTFP12Il2CppStringRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewStringUTFP12Il2CppStringRPv, __Z34SliderJoint2D_Get_Custom_PropAngleP12Il2CppObject: __Z34SliderJoint2D_Get_Custom_PropAngleP12Il2CppObject, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEwj, _tt_cmap6_get_info: _tt_cmap6_get_info, __ZN4Mesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4Mesh8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z22setPxD6JointDriveFlagsPN5physx14PxD6JointDriveENS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEE: __Z22setPxD6JointDriveFlagsPN5physx14PxD6JointDriveENS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEE, __Z38FlattenRelativePathAndRemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb: __Z38FlattenRelativePathAndRemoveMountpointRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEb, __Z19BuildTransitionNameNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_: __Z19BuildTransitionNameNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES5_, __ZN5physx13NpVolumeCache7releaseEv: __ZN5physx13NpVolumeCache7releaseEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getSeparationConstraintsEv, __ZN10TagManager11StringToTagERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager11StringToTagERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __ZN15UnityWebRequestD0Ev: __ZN15UnityWebRequestD0Ev, _forward_DCT: _forward_DCT, __ZNSt3__218__insertion_sort_3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_: __ZNSt3__218__insertion_sort_3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEvT0_SE_T_, __Z40UnityWebRequest_CUSTOM_InternalGetMethodP12Il2CppObject: __Z40UnityWebRequest_CUSTOM_InternalGetMethodP12Il2CppObject, __ZNSt3__218__insertion_sort_3IRNS_6__lessIeeEEPeEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIeeEEPeEEvT0_S5_T_, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getNumCapsulesEv, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE11GetPoolListEj: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE11GetPoolListEj, __ZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE: __ZN5physxL20PxcSweepAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextE, __ZN9Texture2D8SetPixelEiiiRK10ColorRGBAf: __ZN9Texture2D8SetPixelEiiiRK10ColorRGBAf, __ZN5physx2Sc19ParticlePacketShapeD2Ev: __ZN5physx2Sc19ParticlePacketShapeD2Ev, __Z38Camera_Get_Custom_PropStereoMirrorModeP12Il2CppObject: __Z38Camera_Get_Custom_PropStereoMirrorModeP12Il2CppObject, __ZN8Collider7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8Collider7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK17AnimationCurveTplIfE9FindIndexEf: __ZNK17AnimationCurveTplIfE9FindIndexEf, __ZL23RegisterModuleICalls_UIv: __ZL23RegisterModuleICalls_UIv, __ZN14PhysicsManager14CleanupReportsEv: __ZN14PhysicsManager14CleanupReportsEv, __ZL11DecodeValuePPKcS0_: __ZL11DecodeValuePPKcS0_, __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Raycastv: __Z58Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_Raycastv, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z38Projector_Set_Custom_PropNearClipPlaneP12Il2CppObjectf: __Z38Projector_Set_Custom_PropNearClipPlaneP12Il2CppObjectf, __Z53Register_UnityEngine_Physics_get_sleepAngularVelocityv: __Z53Register_UnityEngine_Physics_get_sleepAngularVelocityv, __ZN9GfxDevice23UploadSparseTextureTileE9TextureIDiiiPKhii: __ZN9GfxDevice23UploadSparseTextureTileE9TextureIDiiiPKhii, __ZN5physx3Ext17computeBoxDensityERKNS_6PxVec3Ef: __ZN5physx3Ext17computeBoxDensityERKNS_6PxVec3Ef, __ZN11MatrixStack5ResetEv: __ZN11MatrixStack5ResetEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpConnectorArrayEEEEEvPT_jRKT0_RKT1_j, __ZNK4AABB17CalculateVerticesEP8Vector3f: __ZNK4AABB17CalculateVerticesEP8Vector3f, __ZN22DownloadHandlerTexture13OnReceiveDataEPKvj: __ZN22DownloadHandlerTexture13OnReceiveDataEPKvj, __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z27SetFloatArrayShaderPropertyP19ShaderPropertySheetN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __Z32Renderer_Get_Custom_PropMaterialP12Il2CppObject: __Z32Renderer_Get_Custom_PropMaterialP12Il2CppObject, __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE7getNameEv: __ZNK5physx15NpActorTemplateINS_15PxParticleFluidEE7getNameEv, __ZNK16MemoryFileSystem8IsHiddenERK13FileEntryData: __ZNK16MemoryFileSystem8IsHiddenERK13FileEntryData, __ZN13TargetJoint2D15ThreadedCleanupEv: __ZN13TargetJoint2D15ThreadedCleanupEv, __Z43Register_UnityEngine_Font_get_characterInfov: __Z43Register_UnityEngine_Font_get_characterInfov, __ZN22BuiltinResourceManager19InitializeResourcesEv: __ZN22BuiltinResourceManager19InitializeResourcesEv, __ZN9Rigidbody8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Rigidbody8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13GfxDeviceGLES20SetComputeBufferDataE15ComputeBufferIDPKvj: __ZN13GfxDeviceGLES20SetComputeBufferDataE15ComputeBufferIDPKvj, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19onConstraintReleaseEv, __ZN5Umbra4Math4ceilERKNS_6DoubleE: __ZN5Umbra4Math4ceilERKNS_6DoubleE, __ZN23ControllerContactFilterD2Ev: __ZN23ControllerContactFilterD2Ev, __ZN27StateMachineBehaviourPlayerC2EP28IStateMachineBehaviourSender: __ZN27StateMachineBehaviourPlayerC2EP28IStateMachineBehaviourSender, __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Behaviour8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11AudioSource8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11AudioSource8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Umbra13MatrixFactory7frustumEfff: __ZN5Umbra13MatrixFactory7frustumEfff, __Z54ConfigurableJoint_CUSTOM_INTERNAL_set_lowAngularXLimitP12Il2CppObjectRK14SoftJointLimit: __Z54ConfigurableJoint_CUSTOM_INTERNAL_set_lowAngularXLimitP12Il2CppObjectRK14SoftJointLimit, __Z43Register_UnityEngine_GUI_BringWindowToFrontv: __Z43Register_UnityEngine_GUI_BringWindowToFrontv, __ZN16BaseVideoTexture18PauseVideoTexturesEv: __ZN16BaseVideoTexture18PauseVideoTexturesEv, __ZN6Sprite15GenerateOutlineEfhbRNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEi: __ZN6Sprite15GenerateOutlineEfhbRNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEi, __ZN17b2RayCastCallbackD2Ev: __ZN17b2RayCastCallbackD2Ev, __ZNK13AnimationClip9IsLoopingEv: __ZNK13AnimationClip9IsLoopingEv, __Z9transposeR8Scalar4fS0_S0_S0_: __Z9transposeR8Scalar4fS0_S0_S0_, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_21__tree_const_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_, __Z47QualitySettings_Get_Custom_PropActiveColorSpacev: __Z47QualitySettings_Get_Custom_PropActiveColorSpacev, __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxVehicleDriveNWEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetRowIndexP12Il2CppObject: __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetRowIndexP12Il2CppObject, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_, __Z31setPxVehicleNoDrive_DriveTorquePN5physx16PxVehicleNoDriveEjf: __Z31setPxVehicleNoDrive_DriveTorquePN5physx16PxVehicleNoDriveEjf, __ZN9ProjectorD0Ev: __ZN9ProjectorD0Ev, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS0_9allocatorIS3_EEEEEvRT_j, _isdigit: _isdigit, __ZNK17ArchiveFileSystem9CanHandleEPKc: __ZNK17ArchiveFileSystem9CanHandleEPKc, __Z45LightmapSettings_Set_Custom_PropLightmapsModei: __Z45LightmapSettings_Set_Custom_PropLightmapsModei, __ZN9Transform8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Transform8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f: __ZN5Umbra16ConnectTraversalINS_15ClusterPathNodeEE10updateNodeES1_f, __Z31LODGroup_Get_Custom_PropEnabledP12Il2CppObject: __Z31LODGroup_Get_Custom_PropEnabledP12Il2CppObject, __ZN5physx27PxDefaultMemoryOutputStreamC2ERNS_19PxAllocatorCallbackE: __ZN5physx27PxDefaultMemoryOutputStreamC2ERNS_19PxAllocatorCallbackE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv, __ZN5physx7NpScene10getPhysicsEv: __ZN5physx7NpScene10getPhysicsEv, __Z20GetPlatformCachePathv: __Z20GetPlatformCachePathv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN12MeshRenderer13SetSharedMeshE4PPtrI4MeshE: __ZN12MeshRenderer13SetSharedMeshE4PPtrI4MeshE, __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn13ManifestEntryENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN9BoxPruner17prepareOverlapsMTEv: __ZN9BoxPruner17prepareOverlapsMTEv, __ZN13WheelCollider24SetForceAppPointDistanceEf: __ZN13WheelCollider24SetForceAppPointDistanceEf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags, __ZN5physx12NpConstraint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx12NpConstraint17resolveReferencesERNS_24PxDeserializationContextE, __Z19FindCommandsInCachePK15MonoScriptCacheRK24TransferRequestSignatureRb: __Z19FindCommandsInCachePK15MonoScriptCacheRK24TransferRequestSignatureRb, __ZNKSt3__220__codecvt_utf8_utf16IDsE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__220__codecvt_utf8_utf16IDsE9do_lengthER11__mbstate_tPKcS5_j, __ZN5physx19NpArticulationJoint20setTwistLimitEnabledEb: __ZN5physx19NpArticulationJoint20setTwistLimitEnabledEb, __Z53Register_UnityEngine_MonoBehaviour_StopCoroutine_Autov: __Z53Register_UnityEngine_MonoBehaviour_StopCoroutine_Autov, __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN25PathNamePersistentManager22InsertPathNameInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN25PathNamePersistentManager22InsertPathNameInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveCountP12Il2CppObject: __Z48ParticleSystem_NoiseModule_CUSTOM_GetOctaveCountP12Il2CppObject, __ZN14RenderSettings18SetAmbientLightOldERK10ColorRGBAf: __ZN14RenderSettings18SetAmbientLightOldERK10ColorRGBAf, __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_nextPositionv: __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_set_nextPositionv, __Z53Register_UnityEngine_LineRenderer_get_widthMultiplierv: __Z53Register_UnityEngine_LineRenderer_get_widthMultiplierv, __ZNSt3__227__insertion_sort_incompleteIRPFbRK16MeshTriangleDataS3_EPS1_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRK16MeshTriangleDataS3_EPS1_EEbT0_S8_T_, __ZN5physx2Sc9ClothCore21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj: __ZN5physx2Sc9ClothCore21setCollisionTrianglesEPKNS_24PxClothCollisionTriangleEj, _sort: _sort, __Z6AppendRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc: __Z6AppendRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc, __ZL26RegisterModuleICalls_Umbrav: __ZL26RegisterModuleICalls_Umbrav, __ZN5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEED0Ev, __ZdlPvj: __ZdlPvj, __Z16MarkObjectAsRootRK6ObjectR27GarbageCollectorThreadState: __Z16MarkObjectAsRootRK6ObjectR27GarbageCollectorThreadState, __Z35profiler_set_active_separate_threadb: __Z35profiler_set_active_separate_threadb, __ZN19SkinnedMeshRenderer23GetSkinnedMeshLocalAABBER4AABB: __ZN19SkinnedMeshRenderer23GetSkinnedMeshLocalAABBER4AABB, __ZN20TextRenderingPrivate8TextMesh8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20TextRenderingPrivate8TextMesh8TransferI24GenerateTypeTreeTransferEEvRT_, _UnityReplayKitBroadcastingAPIAvailable: _UnityReplayKitBroadcastingAPIAvailable, _UNITY_png_write_chunk: _UNITY_png_write_chunk, __ZL32TransformParticleMeshAnimatedUVsILb1EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh: __ZL32TransformParticleMeshAnimatedUVsILb1EEvRK16ParticleMeshDataiRK22ParticleSystemTempDataRK31ParticleSystemParticlesTempData11ColorRGBA32RK26ParticleSystemRendererDataRK10Matrix4x4fRK10Matrix3x3fRK8Vector3fRK23ParticleSystemParticlesPPh, __Z53Register_UnityEngine_CanvasRenderer_get_absoluteDepthv: __Z53Register_UnityEngine_CanvasRenderer_get_absoluteDepthv, __ZN6Socket7ConnectEPKctlbb: __ZN6Socket7ConnectEPKctlbb, __Z6simd4iiiii: __Z6simd4iiiii, __ZNK8VRDevice13GetViewMatrixEPK6Camera21MonoOrStereoscopicEye: __ZNK8VRDevice13GetViewMatrixEPK6Camera21MonoOrStereoscopicEye, __ZN7mecanim5human25HumanPoseAddAdditiveLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE: __ZN7mecanim5human25HumanPoseAddAdditiveLayerERNS0_9HumanPoseERKS1_fRKNS_6bitsetILj66EEE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags, __ZN22LocalFileSystemHandler10ToAbsoluteEPKc: __ZN22LocalFileSystemHandler10ToAbsoluteEPKc, __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE7getNameEv, __Z47Register_UnityEngine_AudioReverbZone_get_roomLFv: __Z47Register_UnityEngine_AudioReverbZone_get_roomLFv, __Z18ClipAnimationCurveIfEbRK17AnimationCurveTplIT_ERS2_ff: __Z18ClipAnimationCurveIfEbRK17AnimationCurveTplIT_ERS2_ff, __ZN8Gradient13SwapAlphaKeysEii: __ZN8Gradient13SwapAlphaKeysEii, __ZN15DistanceJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15DistanceJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE: __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE, __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshShapeTypev: __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshShapeTypev, __ZN10GameObject8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10GameObject8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn5ConvX11exportInt64Ey: __ZN5physx2Sn5ConvX11exportInt64Ey, __ZN29DelayedPointerDeletionManager17GrowPendingBufferEv: __ZN29DelayedPointerDeletionManager17GrowPendingBufferEv, __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationZP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, __ZL37StaticInitializeAudioCustomFilterRootPv: __ZL37StaticInitializeAudioCustomFilterRootPv, __Z54Register_UnityEngine_TerrainData_set_wavingGrassAmountv: __Z54Register_UnityEngine_TerrainData_set_wavingGrassAmountv, _UNITY_FT_CMap_New: _UNITY_FT_CMap_New, __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb, __ZN17BillboardRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17BillboardRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12WWWDelayCall7CleanupEPv: __ZN12WWWDelayCall7CleanupEPv, __ZN12_GLOBAL__N_127SphereMeshContactGeneration10addContactERKN5physx6PxVec3Efj: __ZN12_GLOBAL__N_127SphereMeshContactGeneration10addContactERKN5physx6PxVec3Efj, __Z54Register_UnityEngine_AudioReverbFilter_set_lfReferencev: __Z54Register_UnityEngine_AudioReverbFilter_set_lfReferencev, __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt32v: __Z55Register_UnityEngine_Analytics_CustomEventData_AddInt32v, __ZN17AudioReverbFilterD0Ev: __ZN17AudioReverbFilterD0Ev, __ZN9Rigidbody18SetAngularVelocityERK8Vector3f: __ZN9Rigidbody18SetAngularVelocityERK8Vector3f, __ZN14ParticleSystem13SetUsesLightsEv: __ZN14ParticleSystem13SetUsesLightsEv, __Z41Register_UnityEngine_GUIText_set_richTextv: __Z41Register_UnityEngine_GUIText_set_richTextv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS3_EENS4_9allocatorIS3_EEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_setIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS3_EENS4_9allocatorIS3_EEEEEvRT_17TransferMetaFlags, _bulk_free: _bulk_free, __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEEEEjT_j: __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEEEEjT_j, __Z48Register_UnityEngine_Display_ActivateDisplayImplv: __Z48Register_UnityEngine_Display_ActivateDisplayImplv, _psh_hint_table_activate_mask: _psh_hint_table_activate_mask, __Z13RegisterClassI9CGProgramEvv: __Z13RegisterClassI9CGProgramEvv, __ZN14PlayerSettings8TransferI14SafeBinaryReadEEvRT_: __ZN14PlayerSettings8TransferI14SafeBinaryReadEEvRT_, __ZN22BlockMemoryCacheWriter16UnlockCacheBlockEj: __ZN22BlockMemoryCacheWriter16UnlockCacheBlockEj, __ZN8Playable7ProcessEiRK9FrameDataP14DirectorPlayerPv: __ZN8Playable7ProcessEiRK9FrameDataP14DirectorPlayerPv, __ZN7mecanim9animation14GetMotionStopXERKNS0_18ClipMuscleConstantE: __ZN7mecanim9animation14GetMotionStopXERKNS0_18ClipMuscleConstantE, _UNITY_FT_Get_SubGlyph_Info: _UNITY_FT_Get_SubGlyph_Info, __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE: __ZN11UnityEngine9Animation22CreateTransformBindingERK8UnityStriRNS0_14GenericBindingE, __ZN8Animator13GetBehavioursEP11Il2CppClass: __ZN8Animator13GetBehavioursEP11Il2CppClass, __ZN22NavMeshProjectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN22NavMeshProjectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN28ApplyBuiltinInstanceProperty22PerformFlushPropertiesEv: __ZN28ApplyBuiltinInstanceProperty22PerformFlushPropertiesEv, __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev: __ZN5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEED0Ev, __Z46TrailRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti: __Z46TrailRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti, __Z35getPxParticleBase_ParticleBaseFlagsPKN5physx14PxParticleBaseE: __Z35getPxParticleBase_ParticleBaseFlagsPKN5physx14PxParticleBaseE, __ZN4crnd24crnd_output_debug_stringEPKc: __ZN4crnd24crnd_output_debug_stringEPKc, __Z42Terrain_Get_Custom_PropHeightmapPixelErrorP12Il2CppObject: __Z42Terrain_Get_Custom_PropHeightmapPixelErrorP12Il2CppObject, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_jc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceENS_11__wrap_iterIPKcEES9_jc, __ZN10SampleClip12CleanupClassEv: __ZN10SampleClip12CleanupClassEv, __ZN12AudioManager13AwakeFromLoadE17AwakeFromLoadMode: __ZN12AudioManager13AwakeFromLoadE17AwakeFromLoadMode, __ZN5Umbra15KDTraverseStackIjE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbjj: __ZN5Umbra15KDTraverseStackIjE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbjj, __ZN7ApiGLES13DeleteSamplerERj: __ZN7ApiGLES13DeleteSamplerERj, __ZN11TerrainDataD2Ev: __ZN11TerrainDataD2Ev, _UNITY_png_handle_iCCP: _UNITY_png_handle_iCCP, __Z51Register_UnityEngine_Application_get_systemLanguagev: __Z51Register_UnityEngine_Application_get_systemLanguagev, __Z50Renderer_Get_Custom_PropMotionVectorGenerationModeP12Il2CppObject: __Z50Renderer_Get_Custom_PropMotionVectorGenerationModeP12Il2CppObject, __Z46Register_UnityEngine_GUIUtility_UpdateUndoNamev: __Z46Register_UnityEngine_GUIUtility_UpdateUndoNamev, __Z18Transfer_BlittableI14SafeBinaryReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_24PxClothCollisionTriangleENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z15ResolveSymlinksRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z15ResolveSymlinksRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z25Input_CUSTOM_GetKeyStringP12Il2CppString: __Z25Input_CUSTOM_GetKeyStringP12Il2CppString, __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK17MonoScriptManager17FindRuntimeScriptERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE15growAndPushBackERKS4_, __ZN16SubstanceArchive8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16SubstanceArchive8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEE15growAndPushBackERKS2_, __ZN13MemoryManager12GetAllocatorERK10MemLabelId: __ZN13MemoryManager12GetAllocatorERK10MemLabelId, __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetStyleStatePtrv: __Z60Register_UnityEngine_GUIStyle_INTERNAL_CALL_GetStyleStatePtrv, _jinit_huff_decoder: _jinit_huff_decoder, __ZSt17__throw_bad_allocv: __ZSt17__throw_bad_allocv, __ZN5physx23NpVolumeCacheSqCallback14processTouchesEPKNS_12PxOverlapHitEj: __ZN5physx23NpVolumeCacheSqCallback14processTouchesEPKNS_12PxOverlapHitEj, __ZNSt3__28valarrayIjEC2Ej: __ZNSt3__28valarrayIjEC2Ej, __ZN21AudioDistortionFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN21AudioDistortionFilter23VirtualRedirectTransferER14SafeBinaryRead, __Z43WebCamTexture_Set_Custom_PropRequestedWidthP12Il2CppObjecti: __Z43WebCamTexture_Set_Custom_PropRequestedWidthP12Il2CppObjecti, __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb: __ZNK5physx2Sc8BodyCore28checkSimStateKinematicStatusEb, __ZN4FMOD7SystemI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD7SystemI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, _tt_cmap8_char_index: _tt_cmap8_char_index, __ZN5UmbramlERKNS_9Matrix4x4ERKNS_9Matrix4x3E: __ZN5UmbramlERKNS_9Matrix4x4ERKNS_9Matrix4x3E, __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j: __ZN3WWW6CreateEPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j, __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture: __ZN8Material10SetTextureEN9ShaderLab16FastPropertyNameEP7Texture, __ZNK9profiling14SamplerManager10GetSamplerERKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE: __ZNK9profiling14SamplerManager10GetSamplerERKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEE, _UNITY_png_benign_error: _UNITY_png_benign_error, __ZN13UploadHandler21OnBindScriptingObjectEP12Il2CppObject: __ZN13UploadHandler21OnBindScriptingObjectEP12Il2CppObject, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN19ShaderPropertySheet22GetWritableMatrixArrayEi: __ZN19ShaderPropertySheet22GetWritableMatrixArrayEi, __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12LineRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj: __ZN12LineRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj, __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize2v: __Z67Register_UnityEngine_Vector3_INTERNAL_CALL_Internal_OrthoNormalize2v, __Z18Transfer_BlittableI17RemapPPtrTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK9dtNavMesh11getPolyAreaEy: __ZNK9dtNavMesh11getPolyAreaEy, __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebiP6Camera: __Z27AddMeshIntermediateRendererRK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebiP6Camera, __ZNSt3__26vectorIjNS_9allocatorIjEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIjNS_9allocatorIjEEE6assignINS_11__wrap_iterIPjEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIjNS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj: __ZN5physx2Sc17ParticleSystemSim14addInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEj, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _UNITY_png_read_filter_row_sub: _UNITY_png_read_filter_row_sub, _rgb_ycc_start: _rgb_ycc_start, __Z38NavMeshObstacle_Set_Custom_PropCarvingP12Il2CppObjecth: __Z38NavMeshObstacle_Set_Custom_PropCarvingP12Il2CppObjecth, __ZN5Umbra9BitVector8setRangeEjj: __ZN5Umbra9BitVector8setRangeEjj, __ZN5physx6shdfnd3Cpu8getCpuIdEv: __ZN5physx6shdfnd3Cpu8getCpuIdEv, __ZN18DownloadHandlerVFS17OnCompleteContentEv: __ZN18DownloadHandlerVFS17OnCompleteContentEv, __Z38GameObject_CUSTOM_SetActiveRecursivelyP12Il2CppObjecth: __Z38GameObject_CUSTOM_SetActiveRecursivelyP12Il2CppObjecth, __ZN4Mesh9SetBoundsEjRK4AABB: __ZN4Mesh9SetBoundsEjRK4AABB, __Z32DeveloperConsole_OpenConsoleFilev: __Z32DeveloperConsole_OpenConsoleFilev, __Z18Transfer_BlittableI14SafeBinaryReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _jsimd_h2v2_downsample: _jsimd_h2v2_downsample, __Z60Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_SamplePositionv: __Z60Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_SamplePositionv, __ZN9GfxDevice25IsRenderTargetConfigValidEjj19RenderTextureFormat17DepthBufferFormat: __ZN9GfxDevice25IsRenderTargetConfigValidEjj19RenderTextureFormat17DepthBufferFormat, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8AllocateEji: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE8AllocateEji, __ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_: __ZL25CheckCopyTextureArgumentsRK7ApiGLESP11GLESTextureS3_, __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E: __ZN17OptimizedGradient4lerpERK11ColorRGBA32S2_RKN4math5_int4E, __Z40CommandBuffer_Get_Custom_PropSizeInBytesP12Il2CppObject: __Z40CommandBuffer_Get_Custom_PropSizeInBytesP12Il2CppObject, __ZN9HumanBoneC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9HumanBoneC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK9Rigidbody17GetSleepThresholdEv: __ZNK9Rigidbody17GetSleepThresholdEv, __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpeedP12Il2CppObject: __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpeedP12Il2CppObject, __ZN18AudioLowPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18AudioLowPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN11UnityEngine15CloudWebService19SessionEventManager29SessionContainerDoneArchiveItERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService19SessionEventManager29SessionContainerDoneArchiveItERNS0_16SessionContainerE, __ZN18AnimatorControllerD2Ev: __ZN18AnimatorControllerD2Ev, __ZN14PlayerSettings21SetMTRenderingRuntimeEb: __ZN14PlayerSettings21SetMTRenderingRuntimeEb, __Z18Transfer_BlittableI8JSONReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z51Register_UnityEngine_Material_SetFloatArrayImplListv: __Z51Register_UnityEngine_Material_SetFloatArrayImplListv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj295ENS_22PxRepXPropertyAccessorILj295ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj295ENS_22PxRepXPropertyAccessorILj295ES4_ffEEEEvRKT0_, __Z54ParticleSystem_TrailModule_CUSTOM_GetMinVertexDistanceP12Il2CppObject: __Z54ParticleSystem_TrailModule_CUSTOM_GetMinVertexDistanceP12Il2CppObject, __ZN5physx3Scb11RigidObject9syncStateEv: __ZN5physx3Scb11RigidObject9syncStateEv, __Z68Register_UnityEngineInternal_GIDebugVisualisation_get_pauseCycleModev: __Z68Register_UnityEngineInternal_GIDebugVisualisation_get_pauseCycleModev, __ZN14SerializedFile4TypeD2Ev: __ZN14SerializedFile4TypeD2Ev, __ZNSt3__27promiseIvEC2Ev: __ZNSt3__27promiseIvEC2Ev, _jpeg_make_d_derived_tbl: _jpeg_make_d_derived_tbl, __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev: __ZTv0_n12_NSt3__213basic_ostreamIcNS_11char_traitsIcEEED0Ev, __ZN5physx14NpRigidDynamic25setContactReportThresholdEf: __ZN5physx14NpRigidDynamic25setContactReportThresholdEf, __ZN20ArchiveStorageHeader18WriteDirectoryInfoER12FileAccessorRKNS_13DirectoryInfoE: __ZN20ArchiveStorageHeader18WriteDirectoryInfoER12FileAccessorRKNS_13DirectoryInfoE, __ZNK5physx6PxVec4plERKS0_: __ZNK5physx6PxVec4plERKS0_, __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti: __ZN9Scripting27SendScriptingMessageUpwardsER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti, __Z24RegisterStrippedTypeInfoI11OffMeshLinkEviPKcS2_: __Z24RegisterStrippedTypeInfoI11OffMeshLinkEviPKcS2_, _tt_name_entry_ascii_from_utf16: _tt_name_entry_ascii_from_utf16, __Z28AnimationPlayableEvaluateEndP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __Z28AnimationPlayableEvaluateEndP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN5physx2Sc8ClothSim17addCollisionPlaneEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim17addCollisionPlaneEPKNS0_8ShapeSimE, __ZN22UnityAnalyticsSettings18InitializeDefaultsEv: __ZN22UnityAnalyticsSettings18InitializeDefaultsEv, _UNITY_FT_Stroker_Set: _UNITY_FT_Stroker_Set, __ZN5physx16PxsThreadContext12resizeArraysEjjjjj: __ZN5physx16PxsThreadContext12resizeArraysEjjjjj, __Z24RegisterStrippedTypeInfoI15ReflectionProbeEviPKcS2_: __Z24RegisterStrippedTypeInfoI15ReflectionProbeEviPKcS2_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags, __ZN11BoxColliderC2E10MemLabelId18ObjectCreationMode: __ZN11BoxColliderC2E10MemLabelId18ObjectCreationMode, __Z34Matrix4x4_CUSTOM_INTERNAL_CALL_TRSRK8Vector3fRK11QuaternionfS1_R10Matrix4x4f: __Z34Matrix4x4_CUSTOM_INTERNAL_CALL_TRSRK8Vector3fRK11QuaternionfS1_R10Matrix4x4f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj293ES3_NS_19PxHeightFieldFormat4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj293ES3_NS_19PxHeightFieldFormat4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _wcsnrtombs: _wcsnrtombs, __ZN5physx8debugger4comm11OriginShift9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm11OriginShift9serializeERNS1_15EventSerializerE, __ZN4math4Axes8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4math4Axes8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN18BaseUnityAnalytics6RetainEv: __ZN18BaseUnityAnalytics6RetainEv, __Z36Rigidbody_Set_Custom_PropIsKinematicP12Il2CppObjecth: __Z36Rigidbody_Set_Custom_PropIsKinematicP12Il2CppObjecth, __Z53Register_UnityEngine_HumanTrait_get_RequiredBoneCountv: __Z53Register_UnityEngine_HumanTrait_get_RequiredBoneCountv, __Z36GUIStyle_Set_Custom_PropStretchWidthP12Il2CppObjecth: __Z36GUIStyle_Set_Custom_PropStretchWidthP12Il2CppObjecth, __ZN5physx8debugger22ForwardingMemoryBufferD0Ev: __ZN5physx8debugger22ForwardingMemoryBufferD0Ev, __ZN9Behaviour23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Behaviour23VirtualRedirectTransferER14SafeBinaryRead, __ZNK28RectTransformPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK28RectTransformPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __Z27NavMeshAgent_CUSTOM_SetPathP12Il2CppObjectS0_: __Z27NavMeshAgent_CUSTOM_SetPathP12Il2CppObjectS0_, __ZN8LODGroup11SetFadeModeENS_11LODFadeModeE: __ZN8LODGroup11SetFadeModeENS_11LODFadeModeE, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__24pairIN9ShaderLab16FastPropertyNameEN18UnityPropertySheet11UnityTexEnvEEEEEvRT_PKc17TransferMetaFlags, __ZNK6Camera16ScreenPointToRayERK8Vector2f: __ZNK6Camera16ScreenPointToRayERK8Vector2f, __Z44Terrain_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti: __Z44Terrain_Set_Custom_PropRealtimeLightmapIndexP12Il2CppObjecti, __ZL17sample_allocationPvP12Il2CppObjectP11Il2CppClass: __ZL17sample_allocationPvP12Il2CppObjectP11Il2CppClass, __ZN5physx3Ext20ProfileZoneInterface19getProfileEventNameEy: __ZN5physx3Ext20ProfileZoneInterface19getProfileEventNameEy, __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii: __ZN9Texture2D9SetPixelsEiiiiiPK10ColorRGBAfii, __ZN19SpriteMeshGenerator4mask5mdistEPjR14dynamic_bitset: __ZN19SpriteMeshGenerator4mask5mdistEPjR14dynamic_bitset, __ZN9dtNavMesh23removeOffMeshConnectionEy: __ZN9dtNavMesh23removeOffMeshConnectionEy, __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN10GUIManager16GUIObjectWrapperENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNK5physx2Sc5Scene21getBroadPhaseCallbackEh: __ZNK5physx2Sc5Scene21getBroadPhaseCallbackEh, __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeEyPjPt: __ZN11UnityEngine15CloudWebService16SessionContainer21ConvertFromFolderTimeEyPjPt, __Z36Collider2D_Get_Custom_PropShapeCountP12Il2CppObject: __Z36Collider2D_Get_Custom_PropShapeCountP12Il2CppObject, __ZNSt3__212strstreambufD0Ev: __ZNSt3__212strstreambufD0Ev, __ZN13AudioListenerC2E10MemLabelId18ObjectCreationMode: __ZN13AudioListenerC2E10MemLabelId18ObjectCreationMode, __ZN7dtCrowd19ResizeProximityGridEv: __ZN7dtCrowd19ResizeProximityGridEv, __Z44WheelJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject: __Z44WheelJoint2D_Get_Custom_PropJointTranslationP12Il2CppObject, __ZN11UnityEngine15CloudWebService17SessionEventQueueD2Ev: __ZN11UnityEngine15CloudWebService17SessionEventQueueD2Ev, __Z29CubemapArray_CUSTOM_GetPixelsP12Il2CppObjectiii: __Z29CubemapArray_CUSTOM_GetPixelsP12Il2CppObjectiii, __ZN13TargetJoint2DD0Ev: __ZN13TargetJoint2DD0Ev, __Z75Register_UnityEngine_GUIStyleState_GetBackgroundInternalFromDeserializationv: __Z75Register_UnityEngine_GUIStyleState_GetBackgroundInternalFromDeserializationv, __ZNK5physx14PxVehicleGraph14getLatestValueEj: __ZNK5physx14PxVehicleGraph14getLatestValueEj, __ZN29BillboardTreeInstanceRendererD0Ev: __ZN29BillboardTreeInstanceRendererD0Ev, __Z7FTAllocP13FT_MemoryRec_l: __Z7FTAllocP13FT_MemoryRec_l, __ZN5physx19CVariableMemoryPoolD2Ev: __ZN5physx19CVariableMemoryPoolD2Ev, _ccos: _ccos, __ZN5physx12NpBatchQuery15finalizeExecuteEv: __ZN5physx12NpBatchQuery15finalizeExecuteEv, __ZN11UnityEngine7Connect13ConnectConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead: __ZN11UnityEngine7Connect13ConnectConfig19ConfigChangedStaticEPS1_RK8UnityStrR8JSONRead, __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE: __ZN5physx3Scb5Scene13addConstraintERNS0_10ConstraintE, __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ERKS5_: __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ERKS5_, __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIccEEPcEEjT0_S5_S5_T_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __ZNK12CubemapArray12GetDimensionEv: __ZNK12CubemapArray12GetDimensionEv, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _unity_z_adler32_combine: _unity_z_adler32_combine, __Z49Register_UnityEngine_AI_NavMeshObstacle_get_shapev: __Z49Register_UnityEngine_AI_NavMeshObstacle_get_shapev, __ZN15DirectorManager25RemoveControllerFromArrayER13dynamic_arrayI11DirectorJobLj8EEP18PlayableController: __ZN15DirectorManager25RemoveControllerFromArrayER13dynamic_arrayI11DirectorJobLj8EEP18PlayableController, __Z48Register_UnityEngine_Terrain_set_legacyShininessv: __Z48Register_UnityEngine_Terrain_set_legacyShininessv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj29ENS_11PxRigidBodyEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx7NpCloth16getStretchConfigENS_22PxClothFabricPhaseType4EnumE: __ZNK5physx7NpCloth16getStretchConfigENS_22PxClothFabricPhaseType4EnumE, __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_: __ZNSt3__27__sort3IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_T_, __ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b: __ZN7mecanim9animation15ComputeClipTimeEffffbfRfS1_b, __Z48getPxSimulationStatisticsNbActiveKinematicBodiesPKN5physx22PxSimulationStatisticsE: __Z48getPxSimulationStatisticsNbActiveKinematicBodiesPKN5physx22PxSimulationStatisticsE, __Z38Register_UnityEngine_Font_set_materialv: __Z38Register_UnityEngine_Font_set_materialv, __ZN5IMGUI10EndWindowsER8GUIStateb: __ZN5IMGUI10EndWindowsER8GUIStateb, __ZN5Unity9Component23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity9Component23VirtualRedirectTransferER17RemapPPtrTransfer, __Z46Register_UnityEngine_BillboardAsset_get_heightv: __Z46Register_UnityEngine_BillboardAsset_get_heightv, __Z34getPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataEj: __Z34getPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataEj, __Z33setPxRevoluteJoint_DriveGearRatioPN5physx15PxRevoluteJointEf: __Z33setPxRevoluteJoint_DriveGearRatioPN5physx15PxRevoluteJointEf, __Z42Physics2D_Get_Custom_PropVelocityThresholdv: __Z42Physics2D_Get_Custom_PropVelocityThresholdv, __Z42Register_UnityEngine_GUIStyle_get_richTextv: __Z42Register_UnityEngine_GUIStyle_get_richTextv, __ZN18GfxFramebufferGLES21InvalidateAttachmentsEv: __ZN18GfxFramebufferGLES21InvalidateAttachmentsEv, __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS0_18TempAllocatorChunkENS0_9AllocatorEE8recreateEj, _gzdopen: _gzdopen, __ZThn8_N5physx2Sc19ShapeInstancePairLLD1Ev: __ZThn8_N5physx2Sc19ShapeInstancePairLLD1Ev, __ZN10__cxxabiv112_GLOBAL__N_18demangleINS0_2DbEEEvPKcS4_RT_Ri: __ZN10__cxxabiv112_GLOBAL__N_18demangleINS0_2DbEEEvPKcS4_RT_Ri, __ZN13BaseAllocatorD0Ev: __ZN13BaseAllocatorD0Ev, __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientLightv: __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientLightv, __Z55Register_UnityEngine_Profiling_Profiler_GetMonoHeapSizev: __Z55Register_UnityEngine_Profiling_Profiler_GetMonoHeapSizev, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EED0Ev, __ZN27NoiseModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN27NoiseModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN4PPtrI12MeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI12MeshRendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z50Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Orthov: __Z50Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Orthov, __ZThn8_N5physx2Sc23ElementActorInteractionD1Ev: __ZThn8_N5physx2Sc23ElementActorInteractionD1Ev, __ZNK5physx2Sc5Scene31getClothInterCollisionStiffnessEv: __ZNK5physx2Sc5Scene31getClothInterCollisionStiffnessEv, __ZN5physx14NpSpatialIndex11rebuildStepEv: __ZN5physx14NpSpatialIndex11rebuildStepEv, __ZN5physx3Ext19ProfileEventHandler12onEventValueERKNS_16PxProfileEventIdEjyx: __ZN5physx3Ext19ProfileEventHandler12onEventValueERKNS_16PxProfileEventIdEjyx, __ZNSt3__26locale5__imp12install_fromINS_8messagesIwEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8messagesIwEEEEvRKS1_, __ZN7mecanim9animation16DestroyDenseClipERNS0_9DenseClipERNS_6memory9AllocatorE: __ZN7mecanim9animation16DestroyDenseClipERNS0_9DenseClipERNS_6memory9AllocatorE, __Z49Material_CUSTOM_Internal_GetTextureScaleAndOffsetP12Il2CppObjectP12Il2CppStringP8Vector4f: __Z49Material_CUSTOM_Internal_GetTextureScaleAndOffsetP12Il2CppObjectP12Il2CppStringP8Vector4f, __ZNK21AnimationClipPlayable8GetAssetEv: __ZNK21AnimationClipPlayable8GetAssetEv, __ZN12CubemapArray15ThreadedCleanupEv: __ZN12CubemapArray15ThreadedCleanupEv, __Z46Register_UnityEngine_AnimationCurve_get_lengthv: __Z46Register_UnityEngine_AnimationCurve_get_lengthv, __ZNK7Joint2D17GetReactionTorqueEf: __ZNK7Joint2D17GetReactionTorqueEf, __ZN5physx3Scb14ParticleSystemC2ERKNS_11PxActorType4EnumEjb: __ZN5physx3Scb14ParticleSystemC2ERKNS_11PxActorType4EnumEjb, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __Z41getPxVehicleSuspensionDataMSpringStrengthPKN5physx23PxVehicleSuspensionDataE: __Z41getPxVehicleSuspensionDataMSpringStrengthPKN5physx23PxVehicleSuspensionDataE, __Z38Register_UnityEngine_Gradient_set_modev: __Z38Register_UnityEngine_Gradient_set_modev, __ZN12CullingGroup13EraseSwapBackEj: __ZN12CullingGroup13EraseSwapBackEj, __ZN5Light23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Light23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z36Register_UnityEngine_Mesh_HasChannelv: __Z36Register_UnityEngine_Mesh_HasChannelv, __ZN5physx2Sn5ConvX12convertFloatEPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX12convertFloatEPKcRKNS0_15PxMetaDataEntryES6_, __ZN14AreaEffector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN14AreaEffector2D23VirtualRedirectTransferER14SafeBinaryRead, _initgroups: _initgroups, __ZN12SkinMeshInfoC2Ev: __ZN12SkinMeshInfoC2Ev, __ZN5physx2Cm20isNVTXSupportEnabledEv: __ZN5physx2Cm20isNVTXSupportEnabledEv, __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx16solveExtFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15MatrixParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __Z32GUIStyle_Set_Custom_PropRichTextP12Il2CppObjecth: __Z32GUIStyle_Set_Custom_PropRichTextP12Il2CppObjecth, __ZN15PointEffector2D15ThreadedCleanupEv: __ZN15PointEffector2D15ThreadedCleanupEv, _Ins_DELTAP: _Ins_DELTAP, __Z27Input_CUSTOM_GetKeyUpStringP12Il2CppString: __Z27Input_CUSTOM_GetKeyUpStringP12Il2CppString, __ZNK14Texture2DArray12GetDimensionEv: __ZNK14Texture2DArray12GetDimensionEv, __ZN4FMOD7SystemI26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD7SystemI26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES, __ZNK20TextRenderingPrivate8FontImpl10GetGlyphNoEj: __ZNK20TextRenderingPrivate8FontImpl10GetGlyphNoEj, __ZN5physx7NpScene13addCollectionERKNS_12PxCollectionE: __ZN5physx7NpScene13addCollectionERKNS_12PxCollectionE, __ZN12TLSAllocatorI14StackAllocatorE14CheckIntegrityEv: __ZN12TLSAllocatorI14StackAllocatorE14CheckIntegrityEv, __ZN17AnimationCurveTplIfE8TransferI8JSONReadEEvRT_: __ZN17AnimationCurveTplIfE8TransferI8JSONReadEEvRT_, __ZN17PolygonCollider2D15InitializeClassEv: __ZN17PolygonCollider2D15InitializeClassEv, __ZN10Matrix4x4f8SetOrthoEffffff: __ZN10Matrix4x4f8SetOrthoEffffff, _mread: _mread, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10ReallocateEPvji: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE10ReallocateEPvji, __ZThn680_N18UnityConnectClientD1Ev: __ZThn680_N18UnityConnectClientD1Ev, __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15ReflectionProbe8TransferI14SafeBinaryReadEEvRT_: __ZN15ReflectionProbe8TransferI14SafeBinaryReadEEvRT_, __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Texture2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_set_colorv: __Z54Register_UnityEngine_SpriteRenderer_INTERNAL_set_colorv, __Z13RotateTowardsRK8Vector3fS1_ff: __Z13RotateTowardsRK8Vector3fS1_ff, __Z61Register_UnityEngine_Input_INTERNAL_CALL_GetAccelerationEventv: __Z61Register_UnityEngine_Input_INTERNAL_CALL_GetAccelerationEventv, __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14Texture2DArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4FMOD6System15setNetworkProxyEPKc: __ZN4FMOD6System15setNetworkProxyEPKc, __Z39GfxDeviceWaitForAllRenderJobsToCompletev: __Z39GfxDeviceWaitForAllRenderJobsToCompletev, __ZThn8_NSt3__29strstreamD0Ev: __ZThn8_NSt3__29strstreamD0Ev, __ZN11UmbraModule25SetOcclusionPortalEnabledEPKN5Umbra4TomeEPvjb: __ZN11UmbraModule25SetOcclusionPortalEnabledEPKN5Umbra4TomeEPvjb, __ZN16b2BlockAllocatorC2Ev: __ZN16b2BlockAllocatorC2Ev, __ZZN11AudioSource15InitializeClassEvEN32FunctorImpl_2215kDidAddComponent4CallEPviR11MessageData: __ZZN11AudioSource15InitializeClassEvEN32FunctorImpl_2215kDidAddComponent4CallEPviR11MessageData, __ZN15ReflectionProbe14SetRefreshModeENS_11RefreshModeE: __ZN15ReflectionProbe14SetRefreshModeENS_11RefreshModeE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5Umbra4Tome15getObjectUserIDEi: __ZNK5Umbra4Tome15getObjectUserIDEi, __Z69Register_UnityEngine_AnchoredJoint2D_get_autoConfigureConnectedAnchorv: __Z69Register_UnityEngine_AnchoredJoint2D_get_autoConfigureConnectedAnchorv, __ZNK5physx3Ext13DistanceJoint12getToleranceEv: __ZNK5physx3Ext13DistanceJoint12getToleranceEv, __ZN5physx2Sn13XmlWriterImpl15addAndGotoChildEPKc: __ZN5physx2Sn13XmlWriterImpl15addAndGotoChildEPKc, __Z21WWW_CUSTOM_DestroyWWWP12Il2CppObjecth: __Z21WWW_CUSTOM_DestroyWWWP12Il2CppObjecth, __ZN13TextRendering4Font23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13TextRendering4Font23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL12AddLightToSHRK4AABBRK15SharedLightDataP18ForwardLightsBlockf: __ZL12AddLightToSHRK4AABBRK15SharedLightDataP18ForwardLightsBlockf, __ZN5Umbra16getAPIInfoStringENS_10InfoStringE: __ZN5Umbra16getAPIInfoStringENS_10InfoStringE, __Z59CullingGroup_CUSTOM_INTERNAL_CALL_SetDistanceReferencePointP12Il2CppObjectRK8Vector3f: __Z59CullingGroup_CUSTOM_INTERNAL_CALL_SetDistanceReferencePointP12Il2CppObjectRK8Vector3f, ___overflow: ___overflow, __ZN2UI6Canvas19GetCanvasMeshBoundsEv: __ZN2UI6Canvas19GetCanvasMeshBoundsEv, _memset: _memset, __Z22IsBuildTarget64BitBlob19BuildTargetPlatform: __Z22IsBuildTarget64BitBlob19BuildTargetPlatform, __ZN28LightProbeProxyVolumeContextC2E10MemLabelId: __ZN28LightProbeProxyVolumeContextC2E10MemLabelId, __ZN7mecanim12statemachine17ConditionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim12statemachine17ConditionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human23HumanComputeOrientationEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __ZN17GeneralConnectionD0Ev: __ZN17GeneralConnectionD0Ev, __Z62Register_UnityEngine_WebGL_UNetWebGlHelpers_InitUpdateFunctionv: __Z62Register_UnityEngine_WebGL_UNetWebGlHelpers_InitUpdateFunctionv, __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z44Register_UnityEngine_Camera_set_farClipPlanev: __Z44Register_UnityEngine_Camera_set_farClipPlanev, __Z42GUIStyleState_CUSTOM_GetBackgroundInternalP12Il2CppObject: __Z42GUIStyleState_CUSTOM_GetBackgroundInternalP12Il2CppObject, __Z51StaticBatchingUtility_CUSTOM_InternalCombineIndicesP11Il2CppArrayP12Il2CppObject: __Z51StaticBatchingUtility_CUSTOM_InternalCombineIndicesP11Il2CppArrayP12Il2CppObject, __ZN5physx28PxRevoluteJointGeneratedInfoC2Ev: __ZN5physx28PxRevoluteJointGeneratedInfoC2Ev, __Z35ParticleSystemRenderer_RenderMeshesRK15RenderNodeQueuejRK14ChannelAssignsi: __Z35ParticleSystemRenderer_RenderMeshesRK15RenderNodeQueuejRK14ChannelAssignsi, __Z43PlatformEffector2D_Set_Custom_PropUseOneWayP12Il2CppObjecth: __Z43PlatformEffector2D_Set_Custom_PropUseOneWayP12Il2CppObjecth, __ZN2UI6Canvas25SetReferencePixelsPerUnitEf: __ZN2UI6Canvas25SetReferencePixelsPerUnitEf, __ZN5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEED0Ev: __ZN5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEED0Ev, __ZThn8_N5physx2Gu10ConvexMeshD1Ev: __ZThn8_N5physx2Gu10ConvexMeshD1Ev, __ZN18PlatformEffector2DD2Ev: __ZN18PlatformEffector2DD2Ev, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5Umbra11PatchWriterC2Ev: __ZN5Umbra11PatchWriterC2Ev, __ZN6b2Rope4StepEfi: __ZN6b2Rope4StepEfi, __Z48Register_UnityEngine_AudioSource_set_maxDistancev: __Z48Register_UnityEngine_AudioSource_set_maxDistancev, __ZN11UnityEngine15PlatformWrapper17RequestAdsIdAsyncER14IAdsIdListener: __ZN11UnityEngine15PlatformWrapper17RequestAdsIdAsyncER14IAdsIdListener, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIcLj1EEEEvRT_17TransferMetaFlags, __Z37Compass_CUSTOM_INTERNAL_get_rawVectorP12Il2CppObjectP8Vector3f: __Z37Compass_CUSTOM_INTERNAL_get_rawVectorP12Il2CppObjectP8Vector3f, __Z53Register_UnityEngine_Physics2D_get_queriesHitTriggersv: __Z53Register_UnityEngine_Physics2D_get_queriesHitTriggersv, __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE: __ZN13AvatarBuilder12GetTransformEiRK16HumanDescriptionRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEERKNS4_I8UnityStrNS6_ISB_EEEE, __ZN5physx13PxParticleExt15createIndexPoolEj: __ZN5physx13PxParticleExt15createIndexPoolEj, __Z16GetGUIManagerPtrv: __Z16GetGUIManagerPtrv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEclILj648ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44Register_UnityEngine_Caching_DeleteFromCachev: __Z44Register_UnityEngine_Caching_DeleteFromCachev, __Z53getPxSimulationStatisticsParticlesGpuMeshCacheHitratePKN5physx22PxSimulationStatisticsE: __Z53getPxSimulationStatisticsParticlesGpuMeshCacheHitratePKN5physx22PxSimulationStatisticsE, __ZN9Scripting11RaiseIfNullEPv: __ZN9Scripting11RaiseIfNullEPv, __ZN5Umbra20RuntimeTomeGenerator12estimateTomeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEERNS0_8EstimateE: __ZN5Umbra20RuntimeTomeGenerator12estimateTomeEPPKNS_7ImpTomeEiRKNS_5ArrayINS0_13GeneratorTileEEERNS0_8EstimateE, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEf: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEf, __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK10MinMaxAABB8IsInsideERK8Vector3f: __ZNK10MinMaxAABB8IsInsideERK8Vector3f, __ZN13TextRendering4Font15InitializeClassEv: __ZN13TextRendering4Font15InitializeClassEv, __ZNSt3__211char_traitsIwE4copyEPwPKwj: __ZNSt3__211char_traitsIwE4copyEPwPKwj, __ZN10HumanTrait11RightFinger13GetMuscleNameEi: __ZN10HumanTrait11RightFinger13GetMuscleNameEi, __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN6b2Draw11AppendFlagsEj: __ZN6b2Draw11AppendFlagsEj, __ZN5physx13ActorAABBTaskD0Ev: __ZN5physx13ActorAABBTaskD0Ev, __Z46Register_UnityEngine_GUIStyle_get_stretchWidthv: __Z46Register_UnityEngine_GUIStyle_get_stretchWidthv, __ZN6Camera27SetSurfaceUseResolvedBufferER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES5_: __ZN6Camera27SetSurfaceUseResolvedBufferER12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES5_, __Z29Mesh_CUSTOM_GetBlendShapeNameP12Il2CppObjecti: __Z29Mesh_CUSTOM_GetBlendShapeNameP12Il2CppObjecti, __Z43getPxSceneDescContactReportStreamBufferSizePKN5physx11PxSceneDescE: __Z43getPxSceneDescContactReportStreamBufferSizePKN5physx11PxSceneDescE, __ZN11UnityEngine15CloudWebService14DataDispatcher5StartERKNS0_18CloudServiceConfigE: __ZN11UnityEngine15CloudWebService14DataDispatcher5StartERKNS0_18CloudServiceConfigE, __ZN11b2WeldJoint24SolvePositionConstraintsERK12b2SolverData: __ZN11b2WeldJoint24SolvePositionConstraintsERK12b2SolverData, __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20ArchiveStorageHeader12StorageBlockE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx6shdfnd8FPUGuardD2Ev: __ZN5physx6shdfnd8FPUGuardD2Ev, __ZNK14DirectorPlayer26GetTypeInfoVirtualInternalEv: __ZNK14DirectorPlayer26GetTypeInfoVirtualInternalEv, _jsimd_can_h2v2_fancy_upsample: _jsimd_can_h2v2_fancy_upsample, __Z43Register_UnityEngine_RenderSettings_get_fogv: __Z43Register_UnityEngine_RenderSettings_get_fogv, __ZN7Terrain16OnTerrainChangedEN11TerrainData12ChangedFlagsE: __ZN7Terrain16OnTerrainChangedEN11TerrainData12ChangedFlagsE, __ZN5physx2Sc5Actor19reallocInteractionsERPPNS0_11InteractionERjjj: __ZN5physx2Sc5Actor19reallocInteractionsERPPNS0_11InteractionERjjj, __ZN13AnimationClip9PPtrCurve8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13AnimationClip9PPtrCurve8TransferI24GenerateTypeTreeTransferEEvRT_, __Z52Register_UnityEngine_Animator_ApplyBuiltinRootMotionv: __Z52Register_UnityEngine_Animator_ApplyBuiltinRootMotionv, __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j: __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEE5writeIhEEvPKT_j, __ZNSt3__29__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE: __ZNSt3__29__num_putIcE21__widen_and_group_intEPcS2_S2_S2_RS2_S3_RKNS_6localeE, __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888815TexFormatRGB888EEvPKNS_9InnerInfoE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine17ConditionConstantEEEEEvRT_17TransferMetaFlags, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI5RectTIfELj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN13PhysicsModule29GetColliderMaterialInstanceIDER8Collider: __ZN13PhysicsModule29GetColliderMaterialInstanceIDER8Collider, __ZN12NavMeshAgent7SetPathEPK11NavMeshPath: __ZN12NavMeshAgent7SetPathEPK11NavMeshPath, __ZN5physx21PxShapeRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxShapeRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZThn32_N13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofERKS5_j, _UNITY_png_read_filter_row_avg: _UNITY_png_read_filter_row_avg, __ZN5physx3Scb11RigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb11RigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE, __Z34getPxScene_BounceThresholdVelocityPKN5physx7PxSceneE: __Z34getPxScene_BounceThresholdVelocityPKN5physx7PxSceneE, __Z44CharacterController_Set_Custom_PropSkinWidthP12Il2CppObjectf: __Z44CharacterController_Set_Custom_PropSkinWidthP12Il2CppObjectf, __ZNSt3__210__time_putD2Ev: __ZNSt3__210__time_putD2Ev, __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSA_5Vec3VESF_SF_RSB_PhSH_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_9TriangleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSA_5Vec3VESF_SF_RSB_PhSH_Rhb, __Z29Cloth_Set_Custom_PropFrictionP12Il2CppObjectf: __Z29Cloth_Set_Custom_PropFrictionP12Il2CppObjectf, _posix_fallocate: _posix_fallocate, _h2v2_smooth_downsample: _h2v2_smooth_downsample, _UNITY_png_build_16bit_table: _UNITY_png_build_16bit_table, __ZN8StateKey8TransferI14SafeBinaryReadEEvRT_: __ZN8StateKey8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Cm8PtrTable15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Cm8PtrTable15exportExtraDataERNS_22PxSerializationContextE, __ZN20UnityConnectSettings5ResetEv: __ZN20UnityConnectSettings5ResetEv, __ZThn120_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv: __ZThn120_NK5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE15getProfileNamesEv, __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev: __ZTv0_n12_NSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev, __ZN19CharacterController16TransformChangedEi: __ZN19CharacterController16TransformChangedEi, _psh_hint_align: _psh_hint_align, __ZN8Animator20GetRecorderStartTimeEv: __ZN8Animator20GetRecorderStartTimeEv, __ZN13UploadHandlerD2Ev: __ZN13UploadHandlerD2Ev, __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri: __ZNK5physx2Gu11ConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri, __Z40getPxArticulationJoint_TargetOrientationPKN5physx19PxArticulationJointE: __Z40getPxArticulationJoint_TargetOrientationPKN5physx19PxArticulationJointE, __ZNK14ParticleSystem10IsEmittingEv: __ZNK14ParticleSystem10IsEmittingEv, __ZNSt3__28ios_base6xallocEv: __ZNSt3__28ios_base6xallocEv, _tt_cmap12_next: _tt_cmap12_next, __ZN15TerrainCollider16TransformChangedEi: __ZN15TerrainCollider16TransformChangedEi, __ZN10HumanTrait4Body12GetBoneCountEv: __ZN10HumanTrait4Body12GetBoneCountEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13RuntimeStaticI15ApplicationInfoE7DestroyEv: __ZN13RuntimeStaticI15ApplicationInfoE7DestroyEv, __ZNK5physx3Cct17CapsuleController15getClimbingModeEv: __ZNK5physx3Cct17CapsuleController15getClimbingModeEv, __ZN13TrailRenderer16CheckConsistencyEv: __ZN13TrailRenderer16CheckConsistencyEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __GLOBAL__sub_I_SaveAndLoadHelper_cpp: __GLOBAL__sub_I_SaveAndLoadHelper_cpp, __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7mecanim9animation17SampleClipAtIndexERKNS0_9DenseClipEif: __ZN7mecanim9animation17SampleClipAtIndexERKNS0_9DenseClipEif, __Z35Application_Get_Custom_PropDataPathv: __Z35Application_Get_Custom_PropDataPathv, __Z49ReflectionProbe_Get_Custom_PropCustomBakedTextureP12Il2CppObject: __Z49ReflectionProbe_Get_Custom_PropCustomBakedTextureP12Il2CppObject, __ZN5Umbra4Math3sinERKNS_6DoubleE: __ZN5Umbra4Math3sinERKNS_6DoubleE, __ZN2UI6Canvas19SetSortingLayerNameERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN2UI6Canvas19SetSortingLayerNameERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __Z43QualitySettings_Get_Custom_PropBlendWeightsv: __Z43QualitySettings_Get_Custom_PropBlendWeightsv, _Round_Up_To_Grid: _Round_Up_To_Grid, __ZN11UnityEngine15CloudWebService18RestFileDownloader8CloseVFSEv: __ZN11UnityEngine15CloudWebService18RestFileDownloader8CloseVFSEv, __ZN5physx2Sc5Actor10onActivateEv: __ZN5physx2Sc5Actor10onActivateEv, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthZv, __ZNSt3__218__insertion_sort_3IRNS_6__lessIiiEEPiEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIiiEEPiEEvT0_S5_T_, __ZN13GfxDeviceGLES16AddPendingMipGenEP17RenderSurfaceBase: __ZN13GfxDeviceGLES16AddPendingMipGenEP17RenderSurfaceBase, __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI19StreamedBinaryWriteILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN8JSONRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI8BitFieldEEvRT_PKc17TransferMetaFlagsb, __ZNK5physx2Sc18ParticleSystemCore12getStiffnessEv: __ZNK5physx2Sc18ParticleSystemCore12getStiffnessEv, __ZN5physx27PxDefaultMemoryOutputStreamD2Ev: __ZN5physx27PxDefaultMemoryOutputStreamD2Ev, __ZN18ShadowMapJobHeaderD2Ev: __ZN18ShadowMapJobHeaderD2Ev, __ZNK16MemoryFileSystem12LastModifiedERK13FileEntryData: __ZNK16MemoryFileSystem12LastModifiedERK13FileEntryData, __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_16NpConnectorArrayENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __Z29StdTemplateConversionFunctionIiaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIiaEbPvR14SafeBinaryRead, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx2Gu29checkOverlapSphere_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu29checkOverlapSphere_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __ZN4FMOD8ChannelI6setPanEf: __ZN4FMOD8ChannelI6setPanEf, __ZN16DeveloperConsoleC2Ev: __ZN16DeveloperConsoleC2Ev, __ZN8WWWAudioD0Ev: __ZN8WWWAudioD0Ev, __ZN5physx7NpScene14addRigidStaticERNS_13NpRigidStaticE: __ZN5physx7NpScene14addRigidStaticERNS_13NpRigidStaticE, __Z29Font_Set_Custom_PropFontNamesP12Il2CppObjectP11Il2CppArray: __Z29Font_Set_Custom_PropFontNamesP12Il2CppObjectP11Il2CppArray, __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEEEEEvRT_RKNS0_11EventHeaderE, __ZN22BlockMemoryCacheWriter15CompleteWritingEj: __ZN22BlockMemoryCacheWriter15CompleteWritingEj, __ZN11AudioFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11AudioFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK16b2PrismaticJoint17GetReactionTorqueEf: __ZNK16b2PrismaticJoint17GetReactionTorqueEf, __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_: __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE6insertENS_11__wrap_iterIPKS2_EERS7_, __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow1v: __Z65Register_UnityEngine_Graphics_INTERNAL_CALL_Internal_DrawMeshNow1v, __ZN8DateTimeC2Ev: __ZN8DateTimeC2Ev, __ZNSt3__28numpunctIwED0Ev: __ZNSt3__28numpunctIwED0Ev, __ZN9Transform20SetHierarchyCapacityEj: __ZN9Transform20SetHierarchyCapacityEj, __ZNSt3__215numpunct_bynameIcEC2EPKcj: __ZNSt3__215numpunct_bynameIcEC2EPKcj, __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__23setIPFvP11Il2CppClassR23CachedSerializationDataRbENS0_4lessIS8_EENS0_9allocatorIS8_EEEEE13StaticDestroyEPv, __ZN8Material8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Material8TransferI24GenerateTypeTreeTransferEEvRT_, __Z49Register_UnityEngine_Physics2D_GetIgnoreCollisionv: __Z49Register_UnityEngine_Physics2D_GetIgnoreCollisionv, __ZN5physx2Sc5Scene5solveEfPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene5solveEfPNS_10PxBaseTaskE, __ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf: __ZNK5Umbra15OcclusionBuffer18testAABBVisibilityERKNS_7Vector3ES3_jPf, __ZN5physx10PxsContext21addParticleSystemImplEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb: __ZN5physx10PxsContext21addParticleSystemImplEPNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj616ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN14TerrainManager12GetWorldAABBEP7Terrain: __ZN14TerrainManager12GetWorldAABBEP7Terrain, __ZN5Umbra9BitVector6andNotERKS0_: __ZN5Umbra9BitVector6andNotERKS0_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv, __Z24RegisterStrippedTypeInfoI19CharacterControllerEviPKcS2_: __Z24RegisterStrippedTypeInfoI19CharacterControllerEviPKcS2_, __ZL23CalculateProbeInfluenceRK4AABBS1_: __ZL23CalculateProbeInfluenceRK4AABBS1_, __Z47Register_UnityEngine_Rigidbody2D_get_fixedAnglev: __Z47Register_UnityEngine_Rigidbody2D_get_fixedAnglev, _UNITY_png_colorspace_set_sRGB: _UNITY_png_colorspace_set_sRGB, __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4AABB8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13ComputeShaderD2Ev: __ZN13ComputeShaderD2Ev, __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation6IsDoneEv: __ZN24UserAuthorizationManager33UserAuthorizationManagerOperation6IsDoneEv, __ZN4FMOD7SystemI10getVersionEPj: __ZN4FMOD7SystemI10getVersionEPj, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameEfEENS_19__map_value_compareIS3_S4_NS_4lessIS3_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __Z20scripting_string_newPKcj: __Z20scripting_string_newPKcj, __ZN14UnityAnalyticsD2Ev: __ZN14UnityAnalyticsD2Ev, __Z11GetHostNamev: __Z11GetHostNamev, __ZNK17GenericDynamicVBO15GetAllocateSizeEPK9GfxBufferj: __ZNK17GenericDynamicVBO15GetAllocateSizeEPK9GfxBufferj, __ZN16GraphicsSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16GraphicsSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11MemoryStats11DeserializeEPPib: __ZN11MemoryStats11DeserializeEPPib, __ZNSt3__26locale5__imp7installINS_14collate_bynameIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14collate_bynameIcEEEEvPT_, __Z72Register_UnityEngine_ParticleSystem_ShapeModule_GetRandomDirectionAmountv: __Z72Register_UnityEngine_ParticleSystem_ShapeModule_GetRandomDirectionAmountv, __ZN9GfxDevice30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_: __ZN9GfxDevice30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj8ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEclILj8ES3_NS_13PxCombineMode4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21AudioDistortionFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN21AudioDistortionFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z30setPxVehicleDriveMDriveDynDataPN5physx14PxVehicleDriveENS_21PxVehicleDriveDynDataE: __Z30setPxVehicleDriveMDriveDynDataPN5physx14PxVehicleDriveENS_21PxVehicleDriveDynDataE, __ZNK5physx3Cct17CapsuleController18getNonWalkableModeEv: __ZNK5physx3Cct17CapsuleController18getNonWalkableModeEv, __ZN19SpriteMeshGenerator4path9clip_testE8Vector2fi: __ZN19SpriteMeshGenerator4path9clip_testE8Vector2fi, __ZN24GenerateTypeTreeTransfer11EndTransferEv: __ZN24GenerateTypeTreeTransfer11EndTransferEv, __Z33TextMesh_Get_Custom_PropFontStyleP12Il2CppObject: __Z33TextMesh_Get_Custom_PropFontStyleP12Il2CppObject, __ZNK9Transform18GetTransformAccessEv: __ZNK9Transform18GetTransformAccessEv, __ZNK16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE: __ZNK16GraphicsSettings24GetBuiltinShaderSettingsENS_17BuiltinShaderTypeE, __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13BuildSettings13GetSceneIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j, __ZN14PlayerSettings21GetMTRenderingRuntimeEv: __ZN14PlayerSettings21GetMTRenderingRuntimeEv, __ZN5physx2Sn17readAllPropertiesINS_10PxMaterialEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_10PxMaterialEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN15RenderNodeQueueC2ERK10MemLabelId: __ZN15RenderNodeQueueC2ERK10MemLabelId, __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetQualityv: __Z62Register_UnityEngine_ParticleSystem_CollisionModule_GetQualityv, __Z20sweepConvex_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z20sweepConvex_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI6ObjectE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEE8__appendEj, __ZN5physx5cloth6GatherI8Scalar4fEC2ERKS2_: __ZN5physx5cloth6GatherI8Scalar4fEC2ERKS2_, __ZN6SocketC2Ei: __ZN6SocketC2Ei, __ZNSt3__211__libcpp_dbC2Ev: __ZNSt3__211__libcpp_dbC2Ev, __Z24RegisterStrippedTypeInfoIN2UI14CanvasRendererEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN2UI14CanvasRendererEEviPKcS3_, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE18getConstraintFlagsEv, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb1EE10RectOffsetLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z32Register_UnityEngine_Shader_Findv: __Z32Register_UnityEngine_Shader_Findv, __ZN18CrashReportManager15ThreadedCleanupEv: __ZN18CrashReportManager15ThreadedCleanupEv, __Z48Register_UnityEngine_WindZone_set_windTurbulencev: __Z48Register_UnityEngine_WindZone_set_windTurbulencev, __ZN5physx2Sc5Scene11getSceneGpuEb: __ZN5physx2Sc5Scene11getSceneGpuEb, __ZNK11GameManager19ShouldWriteForBuildEv: __ZNK11GameManager19ShouldWriteForBuildEv, __ZN7Terrain11GetRendererEPK6Camerab: __ZN7Terrain11GetRendererEPK6Camerab, __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE: __ZN6Camera11SetupRenderER17ShaderPassContextNS_10RenderFlagE, __Z28Component_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i: __Z28Component_CUSTOM_SendMessageP12Il2CppObjectP12Il2CppStringS0_i, __Z45ParticleSystem_LightsModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z45ParticleSystem_LightsModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN6Socket16SetIgnoreSIGPIPEEb: __ZN6Socket16SetIgnoreSIGPIPEEb, __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math7affineXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE: __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math7affineXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE, __ZNKSt3__223__match_any_but_newlineIcE6__execERNS_7__stateIcEE: __ZNKSt3__223__match_any_but_newlineIcE6__execERNS_7__stateIcEE, __Z47TerrainData_CUSTOM_Internal_SetDetailResolutionP12Il2CppObjectii: __Z47TerrainData_CUSTOM_Internal_SetDetailResolutionP12Il2CppObjectii, __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j: __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEEEEEjT_j, __ZN14ImageReference9BlitImageERKS_NS_10ColorSpaceENS_8BlitModeE: __ZN14ImageReference9BlitImageERKS_NS_10ColorSpaceENS_8BlitModeE, __ZN12_GLOBAL__N_116MetaDataProvider15destroyInstanceEPKv: __ZN12_GLOBAL__N_116MetaDataProvider15destroyInstanceEPKv, __Z37CustomEventData_CUSTOM_InternalCreateP12Il2CppObjectP12Il2CppString: __Z37CustomEventData_CUSTOM_InternalCreateP12Il2CppObjectP12Il2CppString, __ZN14DataBufferGLES15RecreateStorageEi: __ZN14DataBufferGLES15RecreateStorageEi, __Z55Register_UnityEngine_Physics2D_get_showColliderContactsv: __Z55Register_UnityEngine_Physics2D_get_showColliderContactsv, __Z48Register_UnityEngine_TextMesh_INTERNAL_get_colorv: __Z48Register_UnityEngine_TextMesh_INTERNAL_get_colorv, _closelog: _closelog, __ZNK28MonoBehaviourPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK28MonoBehaviourPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __Z50Register_UnityEngine_AI_NavMeshObstacle_get_heightv: __Z50Register_UnityEngine_AI_NavMeshObstacle_get_heightv, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __ZN15NavMeshObstacle22SetCarveOnlyStationaryEb: __ZN15NavMeshObstacle22SetCarveOnlyStationaryEb, ___stdio_seek: ___stdio_seek, __Z54Register_UnityEngine_ParticleAnimator_get_autodestructv: __Z54Register_UnityEngine_ParticleAnimator_get_autodestructv, __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, _symlink: _symlink, __Z37HumanTrait_Get_Custom_PropMuscleCountv: __Z37HumanTrait_Get_Custom_PropMuscleCountv, __ZN14SerializedFile14GetProduceDataExRiR31LocalSerializedObjectIdentifierR18MemLabelIdentifier: __ZN14SerializedFile14GetProduceDataExRiR31LocalSerializedObjectIdentifierR18MemLabelIdentifier, __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE: __ZN5physx2Cm23FastVertex2ShapeScaling4initERKNS_6PxVec3ERKNS_6PxQuatE, __ZNK26PlayerSettingsSplashScreen24GetShowUnitySplashScreenEv: __ZNK26PlayerSettingsSplashScreen24GetShowUnitySplashScreenEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv, __ZN5physx3Ext15CpuWorkerThread10initializeEPNS0_20DefaultCpuDispatcherE: __ZN5physx3Ext15CpuWorkerThread10initializeEPNS0_20DefaultCpuDispatcherE, __Z71Register_UnityEngine_Animator_get_allowConstantClipSamplingOptimizationv: __Z71Register_UnityEngine_Animator_get_allowConstantClipSamplingOptimizationv, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __Z41RenderTexture_Get_Custom_PropIsPowerOfTwoP12Il2CppObject: __Z41RenderTexture_Get_Custom_PropIsPowerOfTwoP12Il2CppObject, __ZN17ProceduralTexture23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17ProceduralTexture23VirtualRedirectTransferER17RemapPPtrTransfer, __Z32Collider_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z32Collider_Set_Custom_PropMaterialP12Il2CppObjectS0_, __ZN5physx18PxsSolverStartTask10startTasksEv: __ZN5physx18PxsSolverStartTask10startTasksEv, __ZN7mecanim9animation19CreateLayerConstantEjjRNS_6memory9AllocatorE: __ZN7mecanim9animation19CreateLayerConstantEjjRNS_6memory9AllocatorE, __ZNK20LightPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK20LightPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20UnityConnectSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Scripting28RaiseNotImplementedExceptionEPKcz: __ZN9Scripting28RaiseNotImplementedExceptionEPKcz, __ZNK5physx19PxArticulationJoint19getConcreteTypeNameEv: __ZNK5physx19PxArticulationJoint19getConcreteTypeNameEv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN15ReplacementPassD2Ev: __ZN15ReplacementPassD2Ev, __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_16PxVehicleNoDriveEE11getTypeNameEv, __ZN5physx17ConvexMeshBuilder19computeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_RNS_19PxAllocatorCallbackERjRPS3_S9_RPjS9_RPNS_13PxHullPolygonE: __ZN5physx17ConvexMeshBuilder19computeHullPolygonsERKjPKNS_6PxVec3ES2_PS1_RNS_19PxAllocatorCallbackERjRPS3_S9_RPjS9_RPNS_13PxHullPolygonE, __Z45Playable_CUSTOM_INTERNAL_CALL_GetTimeInternalR9HPlayable: __Z45Playable_CUSTOM_INTERNAL_CALL_GetTimeInternalR9HPlayable, __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetOutsidev: __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetOutsidev, __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j: __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j, __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj: __ZN5physx2Cm10BitMapBaseINS_6shdfnd9AllocatorEE8combine1INS4_2OREEEvPKjj, __ZN17AudioCustomFilterD2Ev: __ZN17AudioCustomFilterD2Ev, ___lockfile: ___lockfile, __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx24PxParticleRepXSerializerINS_15PxParticleFluidEEC2ERNS_19PxAllocatorCallbackE, _UNITY_FT_Raccess_Get_DataOffsets: _UNITY_FT_Raccess_Get_DataOffsets, __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE6resizeEjRKS3_, __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L13utf8_to_utf16EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE, __ZNSt3__26locale5__imp7installINS_8numpunctIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8numpunctIwEEEEvPT_, __ZNK12NavMeshAgent20GetRemainingDistanceEv: __ZNK12NavMeshAgent20GetRemainingDistanceEv, __ZNK9ShaderLab7Program26EndReadUnsupportedVariantsEv: __ZNK9ShaderLab7Program26EndReadUnsupportedVariantsEv, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_15collisionUpdateEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN11Rigidbody2D11SetVelocityERK8Vector2f: __ZN11Rigidbody2D11SetVelocityERK8Vector2f, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7setNameEPKc, __ZNK9WWWCached11GetProgressEv: __ZNK9WWWCached11GetProgressEv, __Z57Register_UnityEngine_Application_get_isHumanControllingUsv: __Z57Register_UnityEngine_Application_get_isHumanControllingUsv, _gray_render_span: _gray_render_span, __ZNK13ScreenManager6GetDPIEv: __ZNK13ScreenManager6GetDPIEv, __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ScreenPointToRayv: __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ScreenPointToRayv, __Z35Mesh_CUSTOM_GetArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray: __Z35Mesh_CUSTOM_GetArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray, __ZN11Rigidbody2D25SetCollisionDetectionModeENS_22CollisionDetectionModeE: __ZN11Rigidbody2D25SetCollisionDetectionModeENS_22CollisionDetectionModeE, __Z19DestroySingleObjectP6Object: __Z19DestroySingleObjectP6Object, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEE14handleAccessorILj510ENS_22PxRepXPropertyAccessorILj510ES4_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxD6JointDriveEEEE14handleAccessorILj510ENS_22PxRepXPropertyAccessorILj510ES4_NS_7PxFlagsINS_18PxD6JointDriveFlag4EnumEjEESC_EEEEvRKT0_, __ZN21WorldParticleCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN21WorldParticleCollider23VirtualRedirectTransferER14SafeBinaryRead, __ZN13GfxDeviceGLES15EndTimerQueriesEv: __ZN13GfxDeviceGLES15EndTimerQueriesEv, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __Z33Graphics_CUSTOM_SetupVertexLightsP11Il2CppArray: __Z33Graphics_CUSTOM_SetupVertexLightsP11Il2CppArray, __ZNK14SerializedFile7GetTypeEx: __ZNK14SerializedFile7GetTypeEx, __Z14RegisterPluginPvR20UnityPluginFunctions: __Z14RegisterPluginPvR20UnityPluginFunctions, __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEEixERSE_: __ZNSt3__23mapIN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueENS_4lessIS5_EE13stl_allocatorINS_4pairIKS5_S9_EEL18MemLabelIdentifier5ELi16EEEixERSE_, __ZNK11AudioSource7GetMuteEv: __ZNK11AudioSource7GetMuteEv, __Z54Register_UnityEngine_ParticleSystem_MainModule_SetLoopv: __Z54Register_UnityEngine_ParticleSystem_MainModule_SetLoopv, __Z47Register_UnityEngine_TrailRenderer_get_endWidthv: __Z47Register_UnityEngine_TrailRenderer_get_endWidthv, __ZNK11b2RopeJoint12GetMaxLengthEv: __ZNK11b2RopeJoint12GetMaxLengthEv, __ZN10systeminfo20IsPlatformStandaloneE15RuntimePlatform: __ZN10systeminfo20IsPlatformStandaloneE15RuntimePlatform, __Z46Register_UnityEngine_Projector_get_aspectRatiov: __Z46Register_UnityEngine_Projector_get_aspectRatiov, __ZN21LinearCollectionField24SetSizeFieldInListObjectEi: __ZN21LinearCollectionField24SetSizeFieldInListObjectEi, __ZNSt3__26vectorI11ImageFilterNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_: __ZNSt3__26vectorI11ImageFilterNS_9allocatorIS1_EEE6insertENS_11__wrap_iterIPKS1_EERS6_, __ZN11UnityEngine7Connect13AppStartEventD0Ev: __ZN11UnityEngine7Connect13AppStartEventD0Ev, __ZNK5physx2Cm12RenderBuffer14getNbTrianglesEv: __ZNK5physx2Cm12RenderBuffer14getNbTrianglesEv, __Z36SystemInfo_Get_Custom_PropDeviceTypev: __Z36SystemInfo_Get_Custom_PropDeviceTypev, __ZN26AnimatorControllerPlayable8SetFloatEiRKf: __ZN26AnimatorControllerPlayable8SetFloatEiRKf, __ZNK5Umbra6Portal7getQuadERKNS_7Vector3ES3_fRS1_S4_S4_S4_: __ZNK5Umbra6Portal7getQuadERKNS_7Vector3ES3_fRS1_S4_S4_S4_, __ZN12CubemapArray13UploadTextureEv: __ZN12CubemapArray13UploadTextureEv, __Z61Register_UnityEngine_Renderer_INTERNAL_get_worldToLocalMatrixv: __Z61Register_UnityEngine_Renderer_INTERNAL_get_worldToLocalMatrixv, __ZN5Umbra11PatchWriter11computeSizeEi: __ZN5Umbra11PatchWriter11computeSizeEi, __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_set_sizev: __Z54Register_UnityEngine_ReflectionProbe_INTERNAL_set_sizev, __GLOBAL__sub_I_UnityAdsSettings_cpp: __GLOBAL__sub_I_UnityAdsSettings_cpp, __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi: __ZN9Scripting39GetScriptingArrayObjectElementNoRefImplEP11Il2CppArrayi, __ZN5Umbra12QueryContext7mapTileEi: __ZN5Umbra12QueryContext7mapTileEi, __Z37AudioReverbZone_Set_Custom_PropRoomLFP12Il2CppObjecti: __Z37AudioReverbZone_Set_Custom_PropRoomLFP12Il2CppObjecti, __ZN16LightmapSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN16LightmapSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZL31InitializeModule_UnityAnalyticsv: __ZL31InitializeModule_UnityAnalyticsv, __ZN5physx21PxsFluidCollisionTask11runInternalEv: __ZN5physx21PxsFluidCollisionTask11runInternalEv, __ZN25DeferredRenderLoopScratchD2Ev: __ZN25DeferredRenderLoopScratchD2Ev, __Z70Register_UnityEngine_ParticleSystem_SubEmittersModule_RemoveSubEmitterv: __Z70Register_UnityEngine_ParticleSystem_SubEmittersModule_RemoveSubEmitterv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags, __Z18Transfer_BlittableI8JSONReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z29Rigidbody_Set_Custom_PropDragP12Il2CppObjectf: __Z29Rigidbody_Set_Custom_PropDragP12Il2CppObjectf, __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE: __ZNK8VRModule19GetEnabledVRDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE, __ZN5physx24extContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx24extContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZL17MouseWheelHandleriPK20EmscriptenWheelEventPv: __ZL17MouseWheelHandleriPK20EmscriptenWheelEventPv, __Z23Material_CUSTOM_SetPassP12Il2CppObjecti: __Z23Material_CUSTOM_SetPassP12Il2CppObjecti, __ZNK7dtCrowd29getObstacleFromProximityIndexEi: __ZNK7dtCrowd29getObstacleFromProximityIndexEi, __ZN17CapsuleCollider2D16CheckConsistencyEv: __ZN17CapsuleCollider2D16CheckConsistencyEv, __ZN5physx17PxcSweepSphereBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx17PxcSweepSphereBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb: __Z15LoadPixelMatrixRK5RectTIfER9GfxDeviceb, __Z39RectTransform_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP13Vector2fIcall: __Z39RectTransform_CUSTOM_INTERNAL_get_pivotP12Il2CppObjectP13Vector2fIcall, __ZNK5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4sizeEv: __ZNK5physx6shdfnd5ArrayINS_6PxVec3ENS0_9AllocatorEE4sizeEv, __ZN11UnityEngine15CloudWebService17CloudServiceEventC2Ev: __ZN11UnityEngine15CloudWebService17CloudServiceEventC2Ev, __ZN21RotationBySpeedModuleD2Ev: __ZN21RotationBySpeedModuleD2Ev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjjw, __Z28GetAnimationScriptingClassesv: __Z28GetAnimationScriptingClassesv, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags, __ZN6Camera21PrepareLODCullingDataER11CullResultsPKS_: __ZN6Camera21PrepareLODCullingDataER11CullResultsPKS_, __Z24RegisterStrippedTypeInfoI9TextAssetEviPKcS2_: __Z24RegisterStrippedTypeInfoI9TextAssetEviPKcS2_, __ZN6Avatar8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN6Avatar8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z48Register_UnityEngine_Renderer_get_useLightProbesv: __Z48Register_UnityEngine_Renderer_get_useLightProbesv, _UNITY_LZ4_freeStreamDecode: _UNITY_LZ4_freeStreamDecode, __Z48Register_UnityEngine_ParticleSystem_get_isPausedv: __Z48Register_UnityEngine_ParticleSystem_get_isPausedv, __ZNK14NavMeshManager19GetSourceTileDataAtEiii: __ZNK14NavMeshManager19GetSourceTileDataAtEiii, __Z34NavMeshAgent_Set_Custom_PropRadiusP12Il2CppObjectf: __Z34NavMeshAgent_Set_Custom_PropRadiusP12Il2CppObjectf, __Z45NavMeshAgent_Set_Custom_PropAvoidancePriorityP12Il2CppObjecti: __Z45NavMeshAgent_Set_Custom_PropAvoidancePriorityP12Il2CppObjecti, _UNITY_FT_Stream_ReadULong: _UNITY_FT_Stream_ReadULong, __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerStringv: __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetTriggerStringv, __Z27getNbPxPhysics_ConvexMeshesPKN5physx9PxPhysicsE: __Z27getNbPxPhysics_ConvexMeshesPKN5physx9PxPhysicsE, __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeYMultiplierv, __Z51Register_UnityEngine_AndroidJNI_SetLongArrayElementv: __Z51Register_UnityEngine_AndroidJNI_SetLongArrayElementv, __ZN5physxL29PxcUnimplementedTriangleSweepERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf: __ZN5physxL29PxcUnimplementedTriangleSweepERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf, __ZN13AudioListenerD0Ev: __ZN13AudioListenerD0Ev, __ZN4FMOD6SoundI19set3DMinMaxDistanceEff: __ZN4FMOD6SoundI19set3DMinMaxDistanceEff, __ZN4Tree11SetTreeDataE4PPtrI13MonoBehaviourE: __ZN4Tree11SetTreeDataE4PPtrI13MonoBehaviourE, __Z13shutdown_stubii: __Z13shutdown_stubii, __ZN5MutexD2Ev: __ZN5MutexD2Ev, _UNITY_png_write_IHDR: _UNITY_png_write_IHDR, __ZN5physx8debugger4comm11DeriveClass9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm11DeriveClass9serializeERNS1_15EventSerializerE, __ZN5Umbra12QueryContext17findMultipleCellsEPKNS_7Vector3EPNS_4CellEi: __ZN5Umbra12QueryContext17findMultipleCellsEPKNS_7Vector3EPNS_4CellEi, __ZN26AnimatorControllerPlayable6MemoryD0Ev: __ZN26AnimatorControllerPlayable6MemoryD0Ev, __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEED0Ev, __ZN6Sprite13AwakeFromLoadE17AwakeFromLoadMode: __ZN6Sprite13AwakeFromLoadE17AwakeFromLoadMode, __Z25GetBuiltinVectorParamNamei: __Z25GetBuiltinVectorParamNamei, __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS5_L18MemLabelIdentifier34ELi16EEEEEvRT_j, __ZN14AnimationStateC2Ev: __ZN14AnimationStateC2Ev, __ZN10MonoScript8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10MonoScript8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_: __ZN15SerializeTraitsIN9ShaderLab27SerializedShaderVectorValueEE8TransferI18StreamedBinaryReadILb0EEEEvRS1_RT_, __ZN5physx2Gu22GJKRelativeTesselationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativeTesselationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __ZN5physx6shdfnd16MemoryMappedFileC2EPKcj: __ZN5physx6shdfnd16MemoryMappedFileC2EPKcj, __Z37HumanTrait_CUSTOM_GetMuscleDefaultMini: __Z37HumanTrait_CUSTOM_GetMuscleDefaultMini, __Z33RenderImageFilterValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object: __Z33RenderImageFilterValidateCallback21ScriptingMethodIl2CppP11Il2CppClassP6Object, __Z51Register_UnityEngine_Collider_get_attachedRigidbodyv: __Z51Register_UnityEngine_Collider_get_attachedRigidbodyv, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12getClassSizeEv, __GLOBAL__sub_I_runtime_particlesystem_modules2_lump_cpp: __GLOBAL__sub_I_runtime_particlesystem_modules2_lump_cpp, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN15SerializeTraitsIN2UI11CanvasGroupEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN2UI11CanvasGroupEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv: __ZN17AnimationCurveTplI11QuaternionfE15InvalidateCacheEv, __Z27setPxSceneDescGpuDispatcherPN5physx11PxSceneDescEPNS_15PxGpuDispatcherE: __Z27setPxSceneDescGpuDispatcherPN5physx11PxSceneDescEPNS_15PxGpuDispatcherE, __Z17UTF8ToUTF16StringPKcR11UTF16String: __Z17UTF8ToUTF16StringPKcR11UTF16String, __Z42TrailRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf: __Z42TrailRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf, __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData: __Z28CalculateSubShaderIndexToUsePK6ShaderRK17ShaderReplaceDataRK18SharedMaterialData, __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_T_, __ZNSt3__227__insertion_sort_incompleteIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRN18AssetBundleManager27SortPreloadDataByIdentifierEPNS1_11PreloadDataEEEbT0_S6_T_, __ZN12CullingGroupC2Ev: __ZN12CullingGroupC2Ev, __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _str_next: _str_next, _isalnum_l: _isalnum_l, __ZN24EllipsoidParticleEmitter15ThreadedCleanupEv: __ZN24EllipsoidParticleEmitter15ThreadedCleanupEv, __ZN6Camera16SetTargetDisplayEi: __ZN6Camera16SetTargetDisplayEi, __ZN12SocketStreamC2Eib: __ZN12SocketStreamC2Eib, __Z39AudioSource_Set_Custom_PropDopplerLevelP12Il2CppObjectf: __Z39AudioSource_Set_Custom_PropDopplerLevelP12Il2CppObjectf, _UNITY_FT_Done_GlyphSlot: _UNITY_FT_Done_GlyphSlot, __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13RenderTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf: __ZL5case0jjjRN5physx6PxVec3ERKS0_S3_PfRf, __ZNK5Umbra4Path9getLengthEv: __ZNK5Umbra4Path9getLengthEv, __ZNKSt3__215__codecvt_utf16IwLb1EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IwLb1EE16do_always_noconvEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj170ENS_22PxRepXPropertyAccessorILj170ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN5physx27collideWithConvexPlanesSIMDERNS_21PxsParticleCollDataV4EPKNS_7PxPlaneEjf: __ZN5physx27collideWithConvexPlanesSIMDERNS_21PxsParticleCollDataV4EPKNS_7PxPlaneEjf, __ZN5physx16PxsIslandManager10removeNodeERNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager10removeNodeERNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED2Ev: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED2Ev, __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetLengthv: __Z57Register_UnityEngine_ParticleSystem_ShapeModule_SetLengthv, __Z45PointEffector2D_Get_Custom_PropForceVariationP12Il2CppObject: __Z45PointEffector2D_Get_Custom_PropForceVariationP12Il2CppObject, __ZNK5Umbra13TomeUserIdMap7getSizeEv: __ZNK5Umbra13TomeUserIdMap7getSizeEv, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12resize_deltaEjj, __ZN16SubstanceArchive15ThreadedCleanupEv: __ZN16SubstanceArchive15ThreadedCleanupEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN9Projector23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Projector23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEED0Ev, __ZN10FileSystemD2Ev: __ZN10FileSystemD2Ev, __ZN15b2ContactSolver29InitializeVelocityConstraintsEv: __ZN15b2ContactSolver29InitializeVelocityConstraintsEv, __ZN4FMOD5Sound13setMusicSpeedEf: __ZN4FMOD5Sound13setMusicSpeedEf, __ZN5Unity5Joint7CleanupEv: __ZN5Unity5Joint7CleanupEv, __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fPKS1_EEvPT_RKT0_j: __ZN12_GLOBAL__N_114generatePlanesI8Scalar4fPKS1_EEvPT_RKT0_j, __ZZN15DirectorManager15InitializeClassEvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv, __ZN5physx3Ext20DefaultCpuDispatcherD2Ev: __ZN5physx3Ext20DefaultCpuDispatcherD2Ev, __ZN8TypeTree16AssignTypeStringERK16TypeTreeIteratorPKc: __ZN8TypeTree16AssignTypeStringERK16TypeTreeIteratorPKc, __ZN12ScriptMapper15ThreadedCleanupEv: __ZN12ScriptMapper15ThreadedCleanupEv, __Z66Register_UnityEngine_ParticleSystem_CollisionModule_SetRadiusScalev: __Z66Register_UnityEngine_ParticleSystem_CollisionModule_SetRadiusScalev, __ZN4FMOD4DSPID2Ev: __ZN4FMOD4DSPID2Ev, __ZN15NavMeshSettingsD2Ev: __ZN15NavMeshSettingsD2Ev, __Z33GetRuntimeInitializeOnLoadManagerv: __Z33GetRuntimeInitializeOnLoadManagerv, __Z55Register_UnityEngine_Camera_GetStereoProjectionMatricesv: __Z55Register_UnityEngine_Camera_GetStereoProjectionMatricesv, __ZNK9Rigidbody18GetAngularVelocityEv: __ZNK9Rigidbody18GetAngularVelocityEv, __ZThn4_N5physx5cloth8SwSolver26setInterCollisionStiffnessEf: __ZThn4_N5physx5cloth8SwSolver26setInterCollisionStiffnessEf, __ZN14UnityWebStream16FeedDownloadDataEPKhib: __ZN14UnityWebStream16FeedDownloadDataEPKhib, __Z47WheelCollider_Get_Custom_PropSuspensionDistanceP12Il2CppObject: __Z47WheelCollider_Get_Custom_PropSuspensionDistanceP12Il2CppObject, _cff_decoder_prepare: _cff_decoder_prepare, __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv: __ZNK5physx2Sc18ParticleSystemCore23getExternalAccelerationEv, _unity_z_inflateInit2_: _unity_z_inflateInit2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx2Cm10CollectionD0Ev: __ZN5physx2Cm10CollectionD0Ev, __Z40Register_UnityEngine_Animator_SetFloatIDv: __Z40Register_UnityEngine_Animator_SetFloatIDv, __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI4PPtrI10MonoScriptE13stl_allocatorIS3_L18MemLabelIdentifier76ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN7dtCrowd16ReserveObstaclesEi: __ZN7dtCrowd16ReserveObstaclesEi, __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNKSt3__220__time_get_c_storageIwE7__am_pmEv: __ZNKSt3__220__time_get_c_storageIwE7__am_pmEv, __ZN13MemoryManager17GetAllocatorCountEv: __ZN13MemoryManager17GetAllocatorCountEv, __ZN14AreaEffector2D15InitializeClassEv: __ZN14AreaEffector2D15InitializeClassEv, __ZN17PolygonCollider2D10SmartResetEv: __ZN17PolygonCollider2D10SmartResetEv, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10StartArrayEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb1EEE, __Z54Register_UnityEngine_RelativeJoint2D_set_angularOffsetv: __Z54Register_UnityEngine_RelativeJoint2D_set_angularOffsetv, __ZThn4_N12_GLOBAL__N_110ConnectionD0Ev: __ZThn4_N12_GLOBAL__N_110ConnectionD0Ev, _UNITY_tt_face_load_font_dir: _UNITY_tt_face_load_font_dir, __Z46Register_UnityEngine_AI_NavMeshPath_get_statusv: __Z46Register_UnityEngine_AI_NavMeshPath_get_statusv, __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb: __ZN20IntermediateRenderer10InitializeERK10Matrix4x4fRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb, __Z15TransformSpriteRPhRPtjPK10Matrix4x4fPK12SpriteVertexjPKtj11ColorRGBA32j: __Z15TransformSpriteRPhRPtjPK10Matrix4x4fPK12SpriteVertexjPKtj11ColorRGBA32j, __Z37Physics2D_CUSTOM_INTERNAL_set_gravityRK13Vector2fIcall: __Z37Physics2D_CUSTOM_INTERNAL_set_gravityRK13Vector2fIcall, __ZNK12TreeDatabase9Prototype21GetTreeInstanceMatrixER10Matrix4x4fRK8Vector3fRK12TreeInstance: __ZNK12TreeDatabase9Prototype21GetTreeInstanceMatrixER10Matrix4x4fRK8Vector3fRK12TreeInstance, __ZNK5physx27PxVehicleTireLoadFilterData7isValidEv: __ZNK5physx27PxVehicleTireLoadFilterData7isValidEv, _carg: _carg, __Z49Rigidbody_Get_Custom_PropMaxDepenetrationVelocityP12Il2CppObject: __Z49Rigidbody_Get_Custom_PropMaxDepenetrationVelocityP12Il2CppObject, __ZN14NavMeshManager32SetPathfindingIterationsPerFrameEi: __ZN14NavMeshManager32SetPathfindingIterationsPerFrameEi, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN13MonoBehaviour20WillDestroyComponentEv: __ZN13MonoBehaviour20WillDestroyComponentEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20TextRenderingPrivate7GUIText13GetScreenRectERK5RectTIfE: __ZN20TextRenderingPrivate7GUIText13GetScreenRectERK5RectTIfE, __ZN20LateBehaviourManager6UpdateEv: __ZN20LateBehaviourManager6UpdateEv, __ZN5physx21PxProfileEventHandler16parseEventBufferEPKhjRS0_b: __ZN5physx21PxProfileEventHandler16parseEventBufferEPKhjRS0_b, __ZN14DataBufferGLES5UnmapEv: __ZN14DataBufferGLES5UnmapEv, __ZN16ParticleRenderer16CheckConsistencyEv: __ZN16ParticleRenderer16CheckConsistencyEv, __ZThn4_N5physx5cloth8SwSolverD0Ev: __ZThn4_N5physx5cloth8SwSolverD0Ev, __Z46SkinnedMeshRenderer_CUSTOM_SetBlendShapeWeightP12Il2CppObjectif: __Z46SkinnedMeshRenderer_CUSTOM_SetBlendShapeWeightP12Il2CppObjectif, __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB4444EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB88817TexFormatARGB4444EEvPKNS_9InnerInfoE, __ZNK5physx2Sc5Scene9hasClothsEv: __ZNK5physx2Sc5Scene9hasClothsEv, __Z51Register_UnityEngine_Component_GetComponentFastPathv: __Z51Register_UnityEngine_Component_GetComponentFastPathv, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5c_strEv, __ZN5Unity14CharacterJoint14SetSwing2LimitERK14SoftJointLimit: __ZN5Unity14CharacterJoint14SetSwing2LimitERK14SoftJointLimit, __ZNK13MonoBehaviour18ShouldRunBehaviourEv: __ZNK13MonoBehaviour18ShouldRunBehaviourEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj618ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, _cf2_buf_isEnd: _cf2_buf_isEnd, __Z33ShouldWarnOnSlowSerializationPathI9JSONWriteEbv: __Z33ShouldWarnOnSlowSerializationPathI9JSONWriteEbv, __ZNK15b2FrictionJoint16GetReactionForceEf: __ZNK15b2FrictionJoint16GetReactionForceEf, __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15LightProbeGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z48ParticleRenderer_Get_Custom_PropUvAnimationXTileP12Il2CppObject: __Z48ParticleRenderer_Get_Custom_PropUvAnimationXTileP12Il2CppObject, __ZN14PreloadManager17PopIntegrateQueueEP23PreloadManagerOperation: __ZN14PreloadManager17PopIntegrateQueueEP23PreloadManagerOperation, __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_: __ZNK15dense_hashtableINSt3__24pairIKiP6ObjectEEi21InstanceIDHashFunctorN14dense_hash_mapIiS4_S6_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS2_, __Z12CanAddScriptR10GameObjectP11Il2CppClassPS2_S3_: __Z12CanAddScriptR10GameObjectP11Il2CppClassPS2_S3_, __ZN11AudioSource11FixedUpdateEv: __ZN11AudioSource11FixedUpdateEv, __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_: __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_, __ZN11LightProbes14LightProbeData8TransferI14SafeBinaryReadEEvRT_: __ZN11LightProbes14LightProbeData8TransferI14SafeBinaryReadEEvRT_, _copysign: _copysign, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE10deallocateEv: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE10deallocateEv, __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi: __ZN28ParticleSystemSubEmitterData4InitEP14ParticleSystemi, __ZN20ExternalForcesModule5ResetEv: __ZN20ExternalForcesModule5ResetEv, __Z38Rigidbody_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f: __Z38Rigidbody_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK8Vector3f, __ZN4Tree30ComputeSpeedTreeWindPropertiesERK18SpeedTreeWindAsset: __ZN4Tree30ComputeSpeedTreeWindPropertiesERK18SpeedTreeWindAsset, _sfnt_load_face: _sfnt_load_face, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewShortArrayv: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewShortArrayv, __ZN12_GLOBAL__N_117ConnectionManager29connectionDeallocationHandlerEPv: __ZN12_GLOBAL__N_117ConnectionManager29connectionDeallocationHandlerEPv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj164ENS_22PxRepXPropertyAccessorILj164ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj164ENS_22PxRepXPropertyAccessorILj164ES4_ffEEEEvRKT0_, __Z30setPxJointLinearLimitPairUpperPN5physx22PxJointLinearLimitPairEf: __Z30setPxJointLinearLimitPairUpperPN5physx22PxJointLinearLimitPairEf, __ZN7mecanim9animation14AvatarConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI14SafeBinaryReadEEvRT_, __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim8skeleton8Skeleton8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __ZN2UI14CanvasRendererD0Ev: __ZN2UI14CanvasRendererD0Ev, __ZN5physx2Sc5Scene13postIslandGenEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene13postIslandGenEPNS_10PxBaseTaskE, __Z20IsNPOTTextureAllowedb: __Z20IsNPOTTextureAllowedb, _raccess_guess_apple_generic: _raccess_guess_apple_generic, __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile17CUDAProfileBuffer9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE, __ZNK21EnlightenSceneMapping24GetRadiositySystemHashesER13dynamic_arrayI7Hash128Lj8EE: __ZNK21EnlightenSceneMapping24GetRadiositySystemHashesER13dynamic_arrayI7Hash128Lj8EE, __ZZN2UI23InitializeCanvasManagerEvEN47UIEventsCanvasmanagerEmitOnScreenGeometrystruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN47UIEventsCanvasmanagerEmitOnScreenGeometrystruct7ForwardEv, __Z16DestroyIndexListR9IndexList: __Z16DestroyIndexListR9IndexList, __Z62ParticleSystemRenderer_CUSTOM_Internal_GetEnabledVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlags: __Z62ParticleSystemRenderer_CUSTOM_Internal_GetEnabledVertexStreamsP12Il2CppObject31ParticleSystemVertexStreamFlags, __ZN7mecanim13ValueConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim13ValueConstant8TransferI14SafeBinaryReadEEvRT_, __ZN15ResourceManager39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN15ResourceManager39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti: __ZN11UTF16String30TakeOverPreAllocatedUTF16BytesEPti, __Z55ConfigurableJoint_Set_Custom_PropConfiguredInWorldSpaceP12Il2CppObjecth: __Z55ConfigurableJoint_Set_Custom_PropConfiguredInWorldSpaceP12Il2CppObjecth, __Z10ResetInputv: __Z10ResetInputv, __ZNK9dtNavMesh19queryPolygonsInTileEPK10dtMeshTilePKfS4_P15dtQueryCallback: __ZNK9dtNavMesh19queryPolygonsInTileEPK10dtMeshTilePKfS4_P15dtQueryCallback, __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL20solveFriction4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z5splatILj3EE8Scalar4fRKS0_: __Z5splatILj3EE8Scalar4fRKS0_, __ZNK5physx12NpConstraint13getBreakForceERfS1_: __ZNK5physx12NpConstraint13getBreakForceERfS1_, __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11AudioModule30GetOrCreateDSPFromCustomFilterEP17AudioCustomFilter: __ZN11AudioModule30GetOrCreateDSPFromCustomFilterEP17AudioCustomFilter, __Z38AudioSource_CUSTOM_GetOutputDataHelperP12Il2CppObjectP11Il2CppArrayi: __Z38AudioSource_CUSTOM_GetOutputDataHelperP12Il2CppObjectP11Il2CppArrayi, __ZN11ColorModuleD2Ev: __ZN11ColorModuleD2Ev, __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5IMGUI10DragWindowER8GUIStateRK5RectTIfE: __ZN5IMGUI10DragWindowER8GUIStateRK5RectTIfE, __Z25getPxArticulationUserDataPKN5physx14PxArticulationE: __Z25getPxArticulationUserDataPKN5physx14PxArticulationE, __Z36Light_Set_Custom_PropBounceIntensityP12Il2CppObjectf: __Z36Light_Set_Custom_PropBounceIntensityP12Il2CppObjectf, __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE10onComShiftEj, __ZN22ProceduralMaterialData5CleanEv: __ZN22ProceduralMaterialData5CleanEv, __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15PxVehicleWheels17resolveReferencesERNS_24PxDeserializationContextE, __ZN22UnityProfilerPerThread11SetIsActiveEb: __ZN22UnityProfilerPerThread11SetIsActiveEb, __ZN21AnimationPosePlayableC2Ev: __ZN21AnimationPosePlayableC2Ev, __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_13NpVolumeCacheES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __Z32getPxSceneLimitsMaxNbConstraintsPKN5physx13PxSceneLimitsE: __Z32getPxSceneLimitsMaxNbConstraintsPKN5physx13PxSceneLimitsE, __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_: __ZNSt3__26__sortIR17CompareInstanceIDPP6ObjectEEvT0_S6_T_, __Z44RenderTexture_CUSTOM_INTERNAL_CALL_IsCreatedP12Il2CppObject: __Z44RenderTexture_CUSTOM_INTERNAL_CALL_IsCreatedP12Il2CppObject, __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj: __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE15growAndPushBackERKj, __ZNK5physx3Cct13BoxController21getHalfHeightInternalEv: __ZNK5physx3Cct13BoxController21getHalfHeightInternalEv, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13switchToNoSimEv: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE13switchToNoSimEv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj5EEERAT__Kc, __ZN24PhysicsUpdateBehaviour2DC2E10MemLabelId18ObjectCreationMode: __ZN24PhysicsUpdateBehaviour2DC2E10MemLabelId18ObjectCreationMode, __Z13RegisterClassI9AnimationEvv: __Z13RegisterClassI9AnimationEvv, __ZN5Unity14CharacterJoint17SetHighTwistLimitERK14SoftJointLimit: __ZN5Unity14CharacterJoint17SetHighTwistLimitERK14SoftJointLimit, __ZN12_GLOBAL__N_112RenderReaderILb0EED2Ev: __ZN12_GLOBAL__N_112RenderReaderILb0EED2Ev, __Z44Physics2D_Get_Custom_PropMaxTranslationSpeedv: __Z44Physics2D_Get_Custom_PropMaxTranslationSpeedv, __Z38AudioSource_Get_Custom_PropRolloffModeP12Il2CppObject: __Z38AudioSource_Get_Custom_PropRolloffModeP12Il2CppObject, __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetOuterUVv: __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetOuterUVv, __ZN5physx2Sc7BodySim14internalWakeUpEf: __ZN5physx2Sc7BodySim14internalWakeUpEf, __Z49LightProbeProxyVolume_Set_Custom_PropProbeDensityP12Il2CppObjectf: __Z49LightProbeProxyVolume_Set_Custom_PropProbeDensityP12Il2CppObjectf, __Z51Register_UnityEngine_MonoBehaviour_get_useGUILayoutv: __Z51Register_UnityEngine_MonoBehaviour_get_useGUILayoutv, ___strchrnul: ___strchrnul, __ZN12NavMeshAgent14OnNavMeshAddedEv: __ZN12NavMeshAgent14OnNavMeshAddedEv, _unity_z_inflateSyncPoint: _unity_z_inflateSyncPoint, __Z32tri_tri_intersect_with_isectlinePfS_S_S_S_S_PiS_S_: __Z32tri_tri_intersect_with_isectlinePfS_S_S_S_S_PiS_S_, __Z48Physics2D_CUSTOM_INTERNAL_CALL_Internal_LinecastRK13Vector2fIcallS1_iffP12RaycastHit2D: __Z48Physics2D_CUSTOM_INTERNAL_CALL_Internal_LinecastRK13Vector2fIcallS1_iffP12RaycastHit2D, __ZL28CleanupModule_TerrainPhysicsv: __ZL28CleanupModule_TerrainPhysicsv, __ZN21AssetBundleFileSystem7AddPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN21AssetBundleFileSystem7AddPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, ___dynamic_cast: ___dynamic_cast, __Z70Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetDatav: __Z70Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetDatav, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj141ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi0ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z29GetCloudWebServicesManagerPtrv: __Z29GetCloudWebServicesManagerPtrv, __ZN14ShadowSettings5ResetEv: __ZN14ShadowSettings5ResetEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN5physx7NpScene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf: __ZN5physx7NpScene25setVisualizationParameterENS_24PxVisualizationParameter4EnumEf, __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali: __Z14DrawGUITextureRK5RectTIfEP7TextureS2_iiiif11ColorRGBA32P8Materiali, __ZN19TransportJavaScript10OnProgressEPvjj: __ZN19TransportJavaScript10OnProgressEPvjj, __ZN11UnityEngine15CloudWebService19SessionEventManager10QueueEventEPNS0_14CloudEventInfoE: __ZN11UnityEngine15CloudWebService19SessionEventManager10QueueEventEPNS0_14CloudEventInfoE, __ZN6prcoreL13inner_stretchILj4ELj4EEEvPKNS_9InnerInfoE: __ZN6prcoreL13inner_stretchILj4ELj4EEEvPKNS_9InnerInfoE, __Z29Transfer_Blittable_ArrayFieldI9JSONWriteyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWriteyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx2Sc24ElementInteractionMarkerD0Ev: __ZN5physx2Sc24ElementInteractionMarkerD0Ev, _wmemchr: _wmemchr, __ZN16ScriptingManager33GetAssemblyNameForCSharpFirstPassEv: __ZN16ScriptingManager33GetAssemblyNameForCSharpFirstPassEv, __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE: __ZN5physx2Sc5Scene22removeBroadPhaseVolumeERNS0_10ClothShapeE, __Z42Register_UnityEngine_RemoteSettings_HasKeyv: __Z42Register_UnityEngine_RemoteSettings_HasKeyv, __ZN11NamedObjectD0Ev: __ZN11NamedObjectD0Ev, __Z49Register_UnityEngine_Input_set_imeCompositionModev: __Z49Register_UnityEngine_Input_set_imeCompositionModev, __ZN5physx9NpFactory19createParticleFluidEjb: __ZN5physx9NpFactory19createParticleFluidEjb, __ZN5physx2Sc9ClothCoreD2Ev: __ZN5physx2Sc9ClothCoreD2Ev, __Z30WebCamTexture_CUSTOM_GetPixelsP12Il2CppObjectiiii: __Z30WebCamTexture_CUSTOM_GetPixelsP12Il2CppObjectiiii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, __ZN17b2ContactListener10EndContactEP9b2Contact: __ZN17b2ContactListener10EndContactEP9b2Contact, __Z35Transform_Get_Custom_PropHasChangedP12Il2CppObject: __Z35Transform_Get_Custom_PropHasChangedP12Il2CppObject, __Z51Register_UnityEngine_AI_NavMesh_TriangulateInternalv: __Z51Register_UnityEngine_AI_NavMesh_TriangulateInternalv, __ZN5physx6shdfnd9MutexImpl6unlockEv: __ZN5physx6shdfnd9MutexImpl6unlockEv, __ZN7mecanim9animation14AvatarConstant8TransferI8BlobSizeEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI8BlobSizeEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj555ENS_22PxRepXPropertyAccessorILj555ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj555ENS_22PxRepXPropertyAccessorILj555ES4_ffEEEEvRKT0_, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv, __ZN12_GLOBAL__N_1L37PostProcessCullResultsForSkyboxProbesEPK9SceneNodePK4AABBR9IndexListPv: __ZN12_GLOBAL__N_1L37PostProcessCullResultsForSkyboxProbesEPK9SceneNodePK4AABBR9IndexListPv, __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext19InternalBoxObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Cct15ObstacleContext19InternalBoxObstacleENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj: __ZN5physx2Gu25PersistentContactManifold11drawPolygonERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVEPNS6_5Vec3VEjj, __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv: __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEppEv, __ZN5physx2Gu9Container17InitSharedBuffersEjPjb: __ZN5physx2Gu9Container17InitSharedBuffersEjPjb, __ZN8Animator11MatchTargetERK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff: __ZN8Animator11MatchTargetERK8Vector3fRK11QuaternionfiRK21MatchTargetWeightMaskff, __Z32PolygonCollider2D_CUSTOM_GetPathP12Il2CppObjecti: __Z32PolygonCollider2D_CUSTOM_GetPathP12Il2CppObjecti, __Z43LineRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf: __Z43LineRenderer_Set_Custom_PropWidthMultiplierP12Il2CppObjectf, __Z13RegisterClassI11OffMeshLinkEvv: __Z13RegisterClassI11OffMeshLinkEvv, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED0Ev: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorED0Ev, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN4gles10InvalidateER20TextureUnitStateGLES: __ZN4gles10InvalidateER20TextureUnitStateGLES, __Z48InitializeMonoBehaviourAnimationBindingInterfacev: __Z48InitializeMonoBehaviourAnimationBindingInterfacev, __ZN4FMOD13ChannelGroupI19setAudibilityFactorEf: __ZN4FMOD13ChannelGroupI19setAudibilityFactorEf, __ZN10GUIElementC2E10MemLabelId18ObjectCreationMode: __ZN10GUIElementC2E10MemLabelId18ObjectCreationMode, _BF_set_key: _BF_set_key, __Z57Register_UnityEngine_AudioSettings_get_unityAudioDisabledv: __Z57Register_UnityEngine_AudioSettings_get_unityAudioDisabledv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcERKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2ESt16initializer_listIcERKS4_, __ZNK11Rigidbody2D24GetRelativePointVelocityERK8Vector2f: __ZNK11Rigidbody2D24GetRelativePointVelocityERK8Vector2f, __ZN5physx2Sc9ShapeCoreC2ERKNS_7PxEMPTYE: __ZN5physx2Sc9ShapeCoreC2ERKNS_7PxEMPTYE, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZNK5Umbra4Tome16getGateStateSizeEv: __ZNK5Umbra4Tome16getGateStateSizeEv, __Z46Register_UnityEngine_Animator_GetIntegerStringv: __Z46Register_UnityEngine_Animator_GetIntegerStringv, __ZN26AnimatorControllerPlayable17GotoStateInternalEiifffb: __ZN26AnimatorControllerPlayable17GotoStateInternalEiifffb, _cfsetispeed: _cfsetispeed, __ZN5physx25PxVehicleConstraintShader10onComShiftEj: __ZN5physx25PxVehicleConstraintShader10onComShiftEj, __ZNKSt3__214error_category10equivalentERKNS_10error_codeEi: __ZNKSt3__214error_category10equivalentERKNS_10error_codeEi, __ZNK8VRDevice13GetDeviceNameEv: __ZNK8VRDevice13GetDeviceNameEv, _jsimd_idct_ifast: _jsimd_idct_ifast, __Z53Register_UnityEngine_GUIUtility_GetPermanentControlIDv: __Z53Register_UnityEngine_GUIUtility_GetPermanentControlIDv, __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity5Cloth23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx22PxPrismaticJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_: __ZN5physx22PxPrismaticJointCreateERNS_9PxPhysicsEPNS_12PxRigidActorERKNS_11PxTransformES3_S6_, __ZN5physx3Ext7D6Joint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext7D6Joint15importExtraDataERNS_24PxDeserializationContextE, _md5_update: _md5_update, __ZN10GUIElementD2Ev: __ZN10GUIElementD2Ev, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE, __Z28setPxVehicleChassisDataMMassPN5physx20PxVehicleChassisDataEf: __Z28setPxVehicleChassisDataMMassPN5physx20PxVehicleChassisDataEf, __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj: __ZNSt3__26vectorIN20ArchiveStorageHeader4NodeE13stl_allocatorIS2_L18MemLabelIdentifier54ELi16EEE8__appendEj, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __ZN12AudioManager16CheckConsistencyEv: __ZN12AudioManager16CheckConsistencyEv, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv: __ZNK5physx2Sc18ParticleSystemCore15getMaxParticlesEv, __Z41AudioChorusFilter_Set_Custom_PropFeedbackP12Il2CppObjectf: __Z41AudioChorusFilter_Set_Custom_PropFeedbackP12Il2CppObjectf, __ZNK17BillboardRenderer11GetMaterialEi: __ZNK17BillboardRenderer11GetMaterialEi, __ZN5physx14PxsAABBManager25processAggregateAggregateERKNS_19AggregateSortedDataERKNS_9AggregateES3_S6_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx14PxsAABBManager25processAggregateAggregateERKNS_19AggregateSortedDataERKNS_9AggregateES3_S6_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __Z22HumanDescriptionToMonoRK16HumanDescriptionR20MonoHumanDescription: __Z22HumanDescriptionToMonoRK16HumanDescriptionR20MonoHumanDescription, __GLOBAL__sub_I_runtime_camera_renderloops_lump_cpp: __GLOBAL__sub_I_runtime_camera_renderloops_lump_cpp, __ZNK8WindZone16ComputeWindForceERK4AABBf: __ZNK8WindZone16ComputeWindForceERK4AABBf, __ZN8LODGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8LODGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z53Register_UnityEngine_TrailRenderer_set_numCapVerticesv: __Z53Register_UnityEngine_TrailRenderer_set_numCapVerticesv, __ZN5Flare8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Flare8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN6AvatarD2Ev: __ZN6AvatarD2Ev, __ZNK5physx19PxVehicleClutchData7isValidEv: __ZNK5physx19PxVehicleClutchData7isValidEv, __Z65Register_UnityEngine_ConfigurableJoint_set_configuredInWorldSpacev: __Z65Register_UnityEngine_ConfigurableJoint_set_configuredInWorldSpacev, __ZN10GUITextureC2E10MemLabelId18ObjectCreationMode: __ZN10GUITextureC2E10MemLabelId18ObjectCreationMode, __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode: __ZN25RuntimeAnimatorControllerC2E10MemLabelId18ObjectCreationMode, __ZNK5physx3Ext13DistanceJoint14getMinDistanceEv: __ZNK5physx3Ext13DistanceJoint14getMinDistanceEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_yearES4_S4_RNS_8ios_baseERjP2tm, __Z32Texture2D_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh13Il2Cpp_IntPtr: __Z32Texture2D_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormathh13Il2Cpp_IntPtr, __ZN13AnimationClip9GetLengthEv: __ZN13AnimationClip9GetLengthEv, __ZN13AudioListener8DoUpdateEv: __ZN13AudioListener8DoUpdateEv, __Z22Light_CUSTOM_GetLights9LightTypei: __Z22Light_CUSTOM_GetLights9LightTypei, __Z29Transfer_Blittable_ArrayFieldI9JSONWritejEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritejEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZL33GeomOverlapCallback_SphereCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL33GeomOverlapCallback_SphereCapsuleRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZNK12HandlerChain5IsDirERK13FileEntryData: __ZNK12HandlerChain5IsDirERK13FileEntryData, __ZN5physx2Sn12PointerRemapC2Ev: __ZN5physx2Sn12PointerRemapC2Ev, __ZN5physx2Gu15EdgeListBuilderC2Ev: __ZN5physx2Gu15EdgeListBuilderC2Ev, __ZN12InputManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12InputManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj: __ZNK5physx14NpShapeManager9getShapesEPPNS_7PxShapeEjj, __ZN14InputInterfaceD2Ev: __ZN14InputInterfaceD2Ev, __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformEb: __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformEb, __Z48Register_UnityEngine_QualitySettings_get_shadowsv: __Z48Register_UnityEngine_QualitySettings_get_shadowsv, __Z26GetPhysicsScriptingClassesv: __Z26GetPhysicsScriptingClassesv, __ZN11BoxCollider17MainThreadCleanupEv: __ZN11BoxCollider17MainThreadCleanupEv, __ZN12_GLOBAL__N_16ParserILb1EED0Ev: __ZN12_GLOBAL__N_16ParserILb1EED0Ev, __ZN11ShapeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11ShapeModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z40RelativeJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject: __Z40RelativeJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject, __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_get_pivotv: __Z62Register_UnityEngine_ParticleSystemRenderer_INTERNAL_get_pivotv, __ZN9ShaderLab7ProgramD2Ev: __ZN9ShaderLab7ProgramD2Ev, __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb: __ZN5physx3Scb5Scene14addRigidStaticERNS0_11RigidStaticEb, __ZN23MeshVertexFormatManagerD2Ev: __ZN23MeshVertexFormatManagerD2Ev, __ZL23ProgramUniformMatrix2fvPK7ApiGLESjiihPKv: __ZL23ProgramUniformMatrix2fvPK7ApiGLESjiihPKv, __ZN2UI14CanvasRenderer14GetPopMaterialEi: __ZN2UI14CanvasRenderer14GetPopMaterialEi, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SplatPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14SplatPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN6ShaderC2E10MemLabelId18ObjectCreationMode: __ZN6ShaderC2E10MemLabelId18ObjectCreationMode, __ZN5physx3Ext14PrismaticJointD2Ev: __ZN5physx3Ext14PrismaticJointD2Ev, __ZN4crnd11crnd_mallocEjPj: __ZN4crnd11crnd_mallocEjPj, __ZN8JSONRead8TransferI8Vector4fEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI8Vector4fEEvRT_PKc17TransferMetaFlagsb, __ZL31InitializeModule_TerrainPhysicsv: __ZL31InitializeModule_TerrainPhysicsv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ENSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEE, __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_CreateScenev: __Z75Register_UnityEngine_SceneManagement_SceneManager_INTERNAL_CALL_CreateScenev, __Z38TerrainData_CUSTOM_RemoveTreePrototypeP12Il2CppObjecti: __Z38TerrainData_CUSTOM_RemoveTreePrototypeP12Il2CppObjecti, __ZZN8VRModuleC1EvEN21enterPlayModePreAwake7ForwardEv: __ZZN8VRModuleC1EvEN21enterPlayModePreAwake7ForwardEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj163ENS_22PxRepXPropertyAccessorILj163ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj163ENS_22PxRepXPropertyAccessorILj163ES4_ffEEEEvRKT0_, __Z44Register_UnityEngine_GL_INTERNAL_CALL_Vertexv: __Z44Register_UnityEngine_GL_INTERNAL_CALL_Vertexv, __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object: __ZN15MBP_PairManager7addPairEjjPKjPK10MBP_Object, _UNITY_FT_Raccess_Guess: _UNITY_FT_Raccess_Guess, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_: __ZNSt3__27__sort3IR11IndexSorterPiEEjT0_S4_S4_T_, __ZN2UI6Canvas11DrawRawMeshERNS_5BatchEP9GfxBufferS4_: __ZN2UI6Canvas11DrawRawMeshERNS_5BatchEP9GfxBufferS4_, __ZN11UnityEngine15CloudWebService13WWWRestClientC2Ev: __ZN11UnityEngine15CloudWebService13WWWRestClientC2Ev, __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIi8UnityStrEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZN7Texture15InitializeClassEv: __ZN7Texture15InitializeClassEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE25getSelfCollisionStiffnessEv, __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15ResourceManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sn13XmlNodeWriter8beginTagEPKc: __ZN5physx2Sn13XmlNodeWriter8beginTagEPKc, __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxParticleFluidEE8pushNameEPKc, __Z61Register_UnityEngine_TextGenerator_get_fontSizeUsedForBestFitv: __Z61Register_UnityEngine_TextGenerator_get_fontSizeUsedForBestFitv, __Z55RuntimeAnimatorController_Get_Custom_PropAnimationClipsP12Il2CppObject: __Z55RuntimeAnimatorController_Get_Custom_PropAnimationClipsP12Il2CppObject, __Z36BillboardAsset_Get_Custom_PropHeightP12Il2CppObject: __Z36BillboardAsset_Get_Custom_PropHeightP12Il2CppObject, __Z52Register_UnityEngine_Transform_get_hierarchyCapacityv: __Z52Register_UnityEngine_Transform_get_hierarchyCapacityv, __Z76Register_UnityEngine_ParticleSystem_MainModule_SetRandomizeRotationDirectionv: __Z76Register_UnityEngine_ParticleSystem_MainModule_SetRandomizeRotationDirectionv, __ZN5physx8debugger15ForwardingArrayIhED0Ev: __ZN5physx8debugger15ForwardingArrayIhED0Ev, ___stpcpy: ___stpcpy, __Z30Animator_Get_Custom_PropAvatarP12Il2CppObject: __Z30Animator_Get_Custom_PropAvatarP12Il2CppObject, __ZNK13TranslateGLES17GetTextureSwizzleEN2gl18TextureSwizzleFuncE: __ZNK13TranslateGLES17GetTextureSwizzleEN2gl18TextureSwizzleFuncE, __ZN16MecanimAnimation40GetReadWriteGlobalSpaceSkeletonPoseFenceEPN5Unity9ComponentE: __ZN16MecanimAnimation40GetReadWriteGlobalSpaceSkeletonPoseFenceEPN5Unity9ComponentE, __ZThn8_N5physx3Cct13BoxControllerD0Ev: __ZThn8_N5physx3Cct13BoxControllerD0Ev, __ZN4PPtrI5FlareE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI5FlareE8TransferI14SafeBinaryReadEEvRT_, __ZN7mecanim4hand17Skeleton2HandPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS4_13SkeletonPoseTIN4math4trsXEEEPNS0_8HandPoseEf: __ZN7mecanim4hand17Skeleton2HandPoseEPKNS0_4HandEPKNS_8skeleton8SkeletonEPKNS4_13SkeletonPoseTIN4math4trsXEEEPNS0_8HandPoseEf, __ZNK10SampleClip14CalculateFlagsEv: __ZNK10SampleClip14CalculateFlagsEv, __Z7GetBitsPKhRjj: __Z7GetBitsPKhRjj, __Z38Physics_Get_Custom_PropBounceThresholdv: __Z38Physics_Get_Custom_PropBounceThresholdv, _XXH32: _XXH32, __ZNK13TriggerEvents10SendEventsER14ParticleSystemR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZNK13TriggerEvents10SendEventsER14ParticleSystemR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStateR19ParticleSystemState, __ZN19UnityConnectService18HandleSessionStateEb: __ZN19UnityConnectService18HandleSessionStateEb, __ZThn4_N16RayRTreeCallbackILi0ELb0EED1Ev: __ZThn4_N16RayRTreeCallbackILi0ELb0EED1Ev, _pvalloc: _pvalloc, __ZN5physx2Sn18RepXCollectionImpl10getVersionEv: __ZN5physx2Sn18RepXCollectionImpl10getVersionEv, __ZN4PPtrI13RenderTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI13RenderTextureE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_: __ZNSt3__214__split_bufferINS_6vectorIN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEERNS5_IS7_Lj4096EEEEC2EjjS9_, __Z35getPxHeightFieldGeometryColumnScalePKN5physx21PxHeightFieldGeometryE: __Z35getPxHeightFieldGeometryColumnScalePKN5physx21PxHeightFieldGeometryE, __ZN12AudioManager9CloseFMODEv: __ZN12AudioManager9CloseFMODEv, __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_15PxPlaneGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc: __ZN5physx2Sn17RepXVisitorWriterINS_7PxShapeEE21writeGeometryPropertyINS_15PxPlaneGeometryEEEvRKNS_23PxShapeGeometryPropertyEPKc, _Dual_Project: _Dual_Project, __ZN13TrailRenderer12CleanupClassEv: __ZN13TrailRenderer12CleanupClassEv, __Z20RegisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE: __Z20RegisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE, __Z41Register_UnityEngine_AudioSource_get_clipv: __Z41Register_UnityEngine_AudioSource_get_clipv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv, __ZNK9HPlayable7IsValidEv: __ZNK9HPlayable7IsValidEv, __ZN17AudioReverbFilter8TransferI14SafeBinaryReadEEvRT_: __ZN17AudioReverbFilter8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9pbackfailEi, _towupper: _towupper, __ZN11TypeManagerD2Ev: __ZN11TypeManagerD2Ev, __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_: __Z23GetFolderContentsAtPathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_3setIS5_NS_4lessIS5_EENS3_IS5_EEEE22FolderContentsPathModeS7_, __ZN5physx2Sn9MetaClass21checkAndCompleteClassERKNS0_8MetaDataERiS5_: __ZN5physx2Sn9MetaClass21checkAndCompleteClassERKNS0_8MetaDataERiS5_, __ZN13TargetJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN13TargetJoint2D8TransferI14SafeBinaryReadEEvRT_, ___wcscoll_l: ___wcscoll_l, __ZN20TextRenderingPrivate8TextMesh12SetFontStyleEi: __ZN20TextRenderingPrivate8TextMesh12SetFontStyleEi, __ZN5physx6PxVec4C2ERKS0_: __ZN5physx6PxVec4C2ERKS0_, __Z14FindSceneIndexRK13dynamic_arrayI10SceneRangeLj4EEi: __Z14FindSceneIndexRK13dynamic_arrayI10SceneRangeLj4EEi, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI14ConstantStringNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN14NavMeshManager13UpdateCarvingEv: __ZN14NavMeshManager13UpdateCarvingEv, __Z43Register_UnityEngine_AudioSource_get_spreadv: __Z43Register_UnityEngine_AudioSource_get_spreadv, __ZL35GeomOverlapCallback_MeshHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL35GeomOverlapCallback_MeshHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z43Terrain_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti: __Z43Terrain_Set_Custom_PropReflectionProbeUsageP12Il2CppObjecti, __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv: __ZNKSt3__221__basic_string_commonILb1EE20__throw_out_of_rangeEv, __ZN13SplatDatabaseC2EP11TerrainData: __ZN13SplatDatabaseC2EP11TerrainData, __ZN11JointLimits8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11JointLimits8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2GuL25getClosestPtPointTriangleEPNS_6shdfnd3aos5Vec3VERKNS2_5BoolVEPjRj: __ZN5physx2GuL25getClosestPtPointTriangleEPNS_6shdfnd3aos5Vec3VERKNS2_5BoolVEPjRj, __ZN12_GLOBAL__N_124PropertyDefinitionHelper10getTopNameEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper10getTopNameEv, __ZN11TerrainData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11TerrainData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9GfxDevice18InsertCustomMarkerEi: __ZN9GfxDevice18InsertCustomMarkerEi, __ZN12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv: __ZN12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv, __Z20DetailPrototypeToCppRK19MonoDetailPrototypeR15DetailPrototype: __Z20DetailPrototypeToCppRK19MonoDetailPrototypeR15DetailPrototype, __ZN13ModuleManager4LoadEv: __ZN13ModuleManager4LoadEv, __ZN14SphereCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14SphereCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev: __ZN5physx31PxJointLinearLimitGeneratedInfoC2Ev, __Z36getPxVehicleNoDrive_ConcreteTypeNamePKN5physx16PxVehicleNoDriveE: __Z36getPxVehicleNoDrive_ConcreteTypeNamePKN5physx16PxVehicleNoDriveE, __ZN12ImageFilters14GetTargetFinalEv: __ZN12ImageFilters14GetTargetFinalEv, __ZN5physx7NpCloth8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx7NpCloth8requiresERNS_23PxProcessPxBaseCallbackE, __ZN5IMGUI12GetGeneratorERK5RectTIfERK10GUIContentPN13TextRendering4FontE10TextAnchorbb11ColorRGBA32fii13ImagePosition: __ZN5IMGUI12GetGeneratorERK5RectTIfERK10GUIContentPN13TextRendering4FontE10TextAnchorbb11ColorRGBA32fii13ImagePosition, __Z48Register_UnityEngine_TargetJoint2D_set_frequencyv: __Z48Register_UnityEngine_TargetJoint2D_set_frequencyv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj399ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj399ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_: __ZN15SerializeTraitsIN4math4trsXEE8TransferI19StreamedBinaryWriteILb0EEEEvRS1_RT_, __Z37AudioSource_Get_Custom_PropSpatializeP12Il2CppObject: __Z37AudioSource_Get_Custom_PropSpatializeP12Il2CppObject, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10setDampingEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10setDampingEf, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN15QualitySettings15ThreadedCleanupEv: __ZN15QualitySettings15ThreadedCleanupEv, __ZN8Material5ResetEv: __ZN8Material5ResetEv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10EventValueEEEvRNS0_11EventHeaderERT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10EventValueEEEvRNS0_11EventHeaderERT_, __ZN14DirectorPlayer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14DirectorPlayer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9InputAxis18GetDescriptiveNameEb: __ZN9InputAxis18GetDescriptiveNameEb, __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z8EvaluateIL12GradientMode0ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __ZN5physx2Sc17ParticleSystemSim19scheduleDynamicsCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE: __ZN5physx2Sc17ParticleSystemSim19scheduleDynamicsCpuERNS0_16InteractionSceneERKNS_6shdfnd5ArrayIPS1_NS4_19ReflectionAllocatorIS6_EEEERNS_10PxBaseTaskE, __ZNSt3__28ios_base7failureD0Ev: __ZNSt3__28ios_base7failureD0Ev, __Z13RegisterClassI14PhysicsManagerEvv: __Z13RegisterClassI14PhysicsManagerEvv, __ZNK9Texture2D20GetUnscaledTextureIDEv: __ZNK9Texture2D20GetUnscaledTextureIDEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDriveNWEEEEclILj674ENS_14PxVehicleDriveENS_21PxVehicleDriveDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity5Cloth20ClearTransformMotionEv: __ZN5Unity5Cloth20ClearTransformMotionEv, __Z20SendCullingCallbacksRK13CullingOutputRK14ShadowCullDataRK15SharedLightData: __Z20SendCullingCallbacksRK13CullingOutputRK14ShadowCullDataRK15SharedLightData, __Z52Register_UnityEngine_Terrain_CreateTerrainGameObjectv: __Z52Register_UnityEngine_Terrain_CreateTerrainGameObjectv, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19setInvInertiaScale0Ef, __ZN6Camera18DoRenderPostLayersEPK11CullResultsR17ShaderPassContextNS_10RenderFlagE: __ZN6Camera18DoRenderPostLayersEPK11CullResultsR17ShaderPassContextNS_10RenderFlagE, __ZN4FMOD7SystemI13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj: __ZN4FMOD7SystemI13getPluginInfoEjP15FMOD_PLUGINTYPEPciPj, __Z32BillboardAsset_CUSTOM_GetIndicesP12Il2CppObject: __Z32BillboardAsset_CUSTOM_GetIndicesP12Il2CppObject, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN20GpuProgramParameters14ConstantBufferENS_9allocatorIS2_EEE7reserveEj, __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb: __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb, __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf: __ZN5physx2Sc18ParticleSystemCore18setDynamicFrictionEf, __Z46Register_UnityEngine_Mesh_ExtractArrayFromListv: __Z46Register_UnityEngine_Mesh_ExtractArrayFromListv, _qsort: _qsort, __ZNK5physx15PxParticleFluid19getConcreteTypeNameEv: __ZNK5physx15PxParticleFluid19getConcreteTypeNameEv, __ZN15DirectorManager18FinishConstructionEP12Il2CppObjectR9HPlayable: __ZN15DirectorManager18FinishConstructionEP12Il2CppObjectR9HPlayable, __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j: __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E9copy_fromERKSE_j, __ZNK25BlendshapePropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK25BlendshapePropertyBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf: __ZL28CalculateBillboardPropertiesRK10Matrix4x4fR8Vector3fS3_Rf, __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE: __ZN7mecanim8skeleton19DestroySkeletonPoseIN4math4trsXEEEvPNS0_13SkeletonPoseTIT_EERNS_6memory9AllocatorE, __ZN12_GLOBAL__N_122SocketNetworkOutStream7releaseEv: __ZN12_GLOBAL__N_122SocketNetworkOutStream7releaseEv, __Z50AnimatorOverrideController_CUSTOM_Internal_GetClipP12Il2CppObjectS0_h: __Z50AnimatorOverrideController_CUSTOM_Internal_GetClipP12Il2CppObjectS0_h, __Z19SetupKeyNameMappingv: __Z19SetupKeyNameMappingv, __ZNK22ProceduralMaterialData17GetTextureRawDataEj: __ZNK22ProceduralMaterialData17GetTextureRawDataEj, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17setDominanceGroupEh, __ZN13GfxDeviceNull16SetForceCullModeE8CullMode: __ZN13GfxDeviceNull16SetForceCullModeE8CullMode, _UNITY_png_set_sPLT: _UNITY_png_set_sPLT, __ZN14RenderSettings15SetHaloStrengthEf: __ZN14RenderSettings15SetHaloStrengthEf, __ZN11AssetBundle8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11AssetBundle8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetLifetimeLossv, __Z36UnityWebRequest_Get_Custom_PropErrorP12Il2CppObject: __Z36UnityWebRequest_Get_Custom_PropErrorP12Il2CppObject, __Z65Register_UnityEngine_BillboardAsset_SetImageTexCoordsInternalListv: __Z65Register_UnityEngine_BillboardAsset_SetImageTexCoordsInternalListv, __ZN8Collider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN8Collider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN4FMOD4DSPI11getUserDataEPPv: __ZN4FMOD4DSPI11getUserDataEPPv, _yn: _yn, __ZL17Transfer_GUIStyleI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13MemoryManager29SetTempAllocatorRequestedSizeEj: __ZN13MemoryManager29SetTempAllocatorRequestedSizeEj, __Z16ClipPolysByPlanehPK8Vector3fRK5PlanePhPS_S5_S6_: __Z16ClipPolysByPlanehPK8Vector3fRK5PlanePhPS_S5_S6_, __ZNK5physx2Sc18ParticleSystemCore6getSimEv: __ZNK5physx2Sc18ParticleSystemCore6getSimEv, __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE8__appendEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEE27extendedDualIndexedPropertyILj605ES4_jjfEEvjRKNS_33PxExtendedDualIndexedPropertyInfoIXT_ET0_T1_T2_T3_EEjj, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE8__appendEj, __ZN5physx7NpCloth15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx7NpCloth15exportExtraDataERNS_22PxSerializationContextE, __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13GUIStyleStateEEvRT_PKc17TransferMetaFlags, __ZL34GeomMTDCallback_CapsuleHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL34GeomMTDCallback_CapsuleHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN5physx7NpCloth22setFrictionCoefficientEf: __ZN5physx7NpCloth22setFrictionCoefficientEf, __Z50Register_UnityEngine_CapsuleCollider_get_directionv: __Z50Register_UnityEngine_CapsuleCollider_get_directionv, __Z46Register_UnityEngine_AsyncOperation_get_isDonev: __Z46Register_UnityEngine_AsyncOperation_get_isDonev, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcd: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcd, __Z26setPxConstraint_BreakForcePN5physx12PxConstraintEff: __Z26setPxConstraint_BreakForcePN5physx12PxConstraintEff, __Z39Random_CUSTOM_INTERNAL_get_onUnitSphereP8Vector3f: __Z39Random_CUSTOM_INTERNAL_get_onUnitSphereP8Vector3f, __Z33Collider_Get_Custom_PropIsTriggerP12Il2CppObject: __Z33Collider_Get_Custom_PropIsTriggerP12Il2CppObject, __ZN10MonoScript7RebuildEP11Il2CppClass: __ZN10MonoScript7RebuildEP11Il2CppClass, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcy: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcy, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __ZN19SkinnedMeshRenderer17GetActualRootBoneEv: __ZN19SkinnedMeshRenderer17GetActualRootBoneEv, __Z41QualitySettings_Set_Custom_PropVSyncCounti: __Z41QualitySettings_Set_Custom_PropVSyncCounti, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx17EdgeChangeManager4initEj: __ZN5physx17EdgeChangeManager4initEj, __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_10StaticCoreE: __ZNK5physx2Sc5Scene17prefetchForRemoveERKNS0_10StaticCoreE, _scalbln: _scalbln, __ZN5physx2Cm10FanoutTask15removeReferenceEv: __ZN5physx2Cm10FanoutTask15removeReferenceEv, __ZN5physx14NpRigidDynamic17setLinearVelocityERKNS_6PxVec3Eb: __ZN5physx14NpRigidDynamic17setLinearVelocityERKNS_6PxVec3Eb, __Z37Cloth_Set_Custom_PropBendingStiffnessP12Il2CppObjectf: __Z37Cloth_Set_Custom_PropBendingStiffnessP12Il2CppObjectf, __ZN5physx6shdfnd18BufferedSocketImpl5flushEv: __ZN5physx6shdfnd18BufferedSocketImpl5flushEv, __Z26Input_CUSTOM_GetButtonDownP12Il2CppString: __Z26Input_CUSTOM_GetButtonDownP12Il2CppString, __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateProfilerEndFramestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdateProfilerEndFramestruct7ForwardEv, __ZN5Unity5Joint22JointTransferPreNoAxisI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity5Joint22JointTransferPreNoAxisI24GenerateTypeTreeTransferEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18StreamedBinaryReadILb1EE8TransferIN4math14float3_storageEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN4math14float3_storageEEEvRT_PKc17TransferMetaFlags, _y1: _y1, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__26vectorIP11Il2CppClass13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP11Il2CppClass13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7Texture8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z55Register_UnityEngine_Renderer_get_realtimeLightmapIndexv: __Z55Register_UnityEngine_Renderer_get_realtimeLightmapIndexv, __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12AudioManager26CreateAllocationBoundSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPN11SoundHandle8InstanceEP10SampleClip: __ZN12AudioManager26CreateAllocationBoundSoundEPKcjP22FMOD_CREATESOUNDEXINFOPPN11SoundHandle8InstanceEP10SampleClip, __Z38GUIText_CUSTOM_Internal_GetPixelOffsetP12Il2CppObjectP13Vector2fIcall: __Z38GUIText_CUSTOM_Internal_GetPixelOffsetP12Il2CppObjectP13Vector2fIcall, _dispose_chunk: _dispose_chunk, __ZN14RotationModule8TransferI14SafeBinaryReadEEvRT_: __ZN14RotationModule8TransferI14SafeBinaryReadEEvRT_, __ZN22PerThreadPageAllocatorC2Ev: __ZN22PerThreadPageAllocatorC2Ev, __ZN15DirectorManager14ConnectionPoolC2Ev: __ZN15DirectorManager14ConnectionPoolC2Ev, __Z50ParticleSystem_ShapeModule_CUSTOM_SetMeshShapeTypeP12Il2CppObjecti: __Z50ParticleSystem_ShapeModule_CUSTOM_SetMeshShapeTypeP12Il2CppObjecti, __ZNK12b2ChainShape9TestPointERK11b2TransformRK6b2Vec2: __ZNK12b2ChainShape9TestPointERK11b2TransformRK6b2Vec2, __ZNK10FileSystem6DeleteEPKcb: __ZNK10FileSystem6DeleteEPKcb, __Z25setPxSphereGeometryRadiusPN5physx16PxSphereGeometryEf: __Z25setPxSphereGeometryRadiusPN5physx16PxSphereGeometryEf, __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferEPNS_12PxFoundationEj: __ZN5physx26PxProfileMemoryEventBuffer23createMemoryEventBufferEPNS_12PxFoundationEj, __ZN11CullResultsC2Ev: __ZN11CullResultsC2Ev, __ZN16LightmapSettings14GetLightProbesEv: __ZN16LightmapSettings14GetLightProbesEv, __ZN5physx5cloth8SwSolver11removeClothEPNS0_5ClothE: __ZN5physx5cloth8SwSolver11removeClothEPNS0_5ClothE, __ZThn4_NK5physx5cloth8SwFabric13getNumTethersEv: __ZThn4_NK5physx5cloth8SwFabric13getNumTethersEv, __ZN20SoundChannelInstance15set3DAttributesEPK11FMOD_VECTORS2_: __ZN20SoundChannelInstance15set3DAttributesEPK11FMOD_VECTORS2_, __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_: __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_jRKS2_, __ZN12LightsModule5ResetEv: __ZN12LightsModule5ResetEv, __Z29Transfer_Blittable_ArrayFieldI8JSONReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadxEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _iswgraph: _iswgraph, _tt_cmap6_validate: _tt_cmap6_validate, __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN26VertexDeclarationCacheGLES24DestroyVertexDeclarationEP17VertexDeclaration: __ZN26VertexDeclarationCacheGLES24DestroyVertexDeclarationEP17VertexDeclaration, _towctrans: _towctrans, __ZN9Animation6SampleEv: __ZN9Animation6SampleEv, __ZN15AudioMixerGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15AudioMixerGroup23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleWheelDataEE8pushNameEPKc, __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7SetSizeEi: __ZN10ObjectPoolIN4FMOD5SoundENS0_6SoundIEE7SetSizeEi, __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv: __ZN17AnimationCurveTplI8Vector3fE15InvalidateCacheEv, __Z41Register_UnityEngine_Texture2D_get_formatv: __Z41Register_UnityEngine_Texture2D_get_formatv, __ZN5physx3Ext14PrismaticJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext14PrismaticJoint12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE25recurseAddLinkAndChildrenEPKNS_18PxArticulationLinkERNS_6shdfnd11InlineArrayIS6_Lj64ENS7_19ReflectionAllocatorIS6_EEEE: __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE25recurseAddLinkAndChildrenEPKNS_18PxArticulationLinkERNS_6shdfnd11InlineArrayIS6_Lj64ENS7_19ReflectionAllocatorIS6_EEEE, __Z59Register_UnityEngine_ParticleSystem_Particle_GetCurrentSizev: __Z59Register_UnityEngine_ParticleSystem_Particle_GetCurrentSizev, __Z59Application_CUSTOM_GetUserAuthorizationRequestMode_Internalv: __Z59Application_CUSTOM_GetUserAuthorizationRequestMode_Internalv, _fmal: _fmal, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6cbeginEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6cbeginEv, __ZNK17ProfilerFrameData10ThreadData22ExtractAllChildSamplesEjR13dynamic_arrayIjLj4EE: __ZNK17ProfilerFrameData10ThreadData22ExtractAllChildSamplesEjR13dynamic_arrayIjLj4EE, _fmaf: _fmaf, __ZN10Collider2D11SetMaterialE4PPtrI17PhysicsMaterial2DE: __ZN10Collider2D11SetMaterialE4PPtrI17PhysicsMaterial2DE, _posix_madvise: _posix_madvise, __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastTestRK8Vector3fS1_fi23QueryTriggerInteraction: __Z49Physics_CUSTOM_INTERNAL_CALL_Internal_RaycastTestRK8Vector3fS1_fi23QueryTriggerInteraction, __ZN12_GLOBAL__N_123SphericalJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_123SphericalJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __ZN5physx5cloth8SwSolver19StartSimulationTask11runInternalEv: __ZN5physx5cloth8SwSolver19StartSimulationTask11runInternalEv, __Z26IsProfilerEnabledThisFramev: __Z26IsProfilerEnabledThisFramev, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE11runInternalEv, __ZZN8Renderer15InitializeClassEvEN28FunctorImpl_131kLayerChanged4CallEPviR11MessageData: __ZZN8Renderer15InitializeClassEvEN28FunctorImpl_131kLayerChanged4CallEPviR11MessageData, __Z55Register_UnityEngine_GUITexture_INTERNAL_get_pixelInsetv: __Z55Register_UnityEngine_GUITexture_INTERNAL_get_pixelInsetv, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK19RuntimeSceneManager19GetLoadedSceneCountEv: __ZNK19RuntimeSceneManager19GetLoadedSceneCountEv, __ZNK14ParticleSystem26GetCollisionEventsExternalEiP26MonoParticleCollisionEventi: __ZNK14ParticleSystem26GetCollisionEventsExternalEiP26MonoParticleCollisionEventi, _SendMessageString: _SendMessageString, __Z53Register_UnityEngine_GUI_INTERNAL_set_backgroundColorv: __Z53Register_UnityEngine_GUI_INTERNAL_set_backgroundColorv, __ZN14FileCacherRead21DebugLinearFileAccessEjj: __ZN14FileCacherRead21DebugLinearFileAccessEjj, __Z82Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralv: __Z82Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_Internal_DrawProceduralv, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_PopLocalFrame13Il2Cpp_IntPtrRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_PopLocalFrame13Il2Cpp_IntPtrRPv, __Z43Register_UnityEngine_GUI_INTERNAL_set_colorv: __Z43Register_UnityEngine_GUI_INTERNAL_set_colorv, _UNITY_png_handle_unknown: _UNITY_png_handle_unknown, __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript: __ZN13MonoBehaviour19RebuildMonoInstanceEP11Il2CppClassP12Il2CppObjectP10MonoScript, __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_18PxcAABBDataDynamicEbPNS_11IntegerAABBEj: __ZN5physx20updateBodyShapeAABBsEPKjjS1_PKNS_18PxcAABBDataDynamicEbPNS_11IntegerAABBEj, __ZN5physx2Gu8EdgeList4LoadERNS_13PxInputStreamE: __ZN5physx2Gu8EdgeList4LoadERNS_13PxInputStreamE, __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI18SpeedTreeWindAssetE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z45MonoBehaviour_CUSTOM_Internal_CancelInvokeAllP12Il2CppObject: __Z45MonoBehaviour_CUSTOM_Internal_CancelInvokeAllP12Il2CppObject, _LzmaDec_Free: _LzmaDec_Free, __ZN17ProceduralTexture8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17ProceduralTexture8TransferI24GenerateTypeTreeTransferEEvRT_, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapYv, __ZN13PhysicsModule20ConvertContactToMonoEP9Collision: __ZN13PhysicsModule20ConvertContactToMonoEP9Collision, __ZN9SubModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9SubModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z53Register_UnityEngine_AI_NavMeshAgent_get_walkableMaskv: __Z53Register_UnityEngine_AI_NavMeshAgent_get_walkableMaskv, __Z65Register_UnityEngine_QualitySettings_set_realtimeReflectionProbesv: __Z65Register_UnityEngine_QualitySettings_set_realtimeReflectionProbesv, __ZL35LoadMemoryBufferIntoTextureInternalR9Texture2DPKhj20LoadImageCompressionb: __ZL35LoadMemoryBufferIntoTextureInternalR9Texture2DPKhj20LoadImageCompressionb, _cf2_stack_init: _cf2_stack_init, __ZNSt3__217__assoc_sub_stateD0Ev: __ZNSt3__217__assoc_sub_stateD0Ev, __Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB: __Z25IsObjectWithinShadowRangeRK13ShadowJobDataRK4AABB, __Z38GameObject_CUSTOM_GetComponentInParentP12Il2CppObjectS0_: __Z38GameObject_CUSTOM_GetComponentInParentP12Il2CppObjectS0_, __Z61Register_UnityEngine_MeshRenderer_get_additionalVertexStreamsv: __Z61Register_UnityEngine_MeshRenderer_get_additionalVertexStreamsv, __Z21InitializeBatchDeletev: __Z21InitializeBatchDeletev, __Z36Light_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject: __Z36Light_CUSTOM_RemoveAllCommandBuffersP12Il2CppObject, __ZN12MeshCollider7CleanupEv: __ZN12MeshCollider7CleanupEv, __ZN18ProceduralMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18ProceduralMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z29AndroidJNI_CUSTOM_GetIntField13Il2Cpp_IntPtrS_: __Z29AndroidJNI_CUSTOM_GetIntField13Il2Cpp_IntPtrS_, __ZN20TextRenderingPrivate8FontImpl17CreateDynamicFontERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEi: __ZN20TextRenderingPrivate8FontImpl17CreateDynamicFontERKNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEi, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z22EulerToQuaternionCurveRK17AnimationCurveTplIfES2_S2_RS_I11QuaternionfE: __Z22EulerToQuaternionCurveRK17AnimationCurveTplIfES2_S2_RS_I11QuaternionfE, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __ZNK5physx14NpArticulation26getMaxProjectionIterationsEv: __ZNK5physx14NpArticulation26getMaxProjectionIterationsEv, __Z17NpGetPxConstraintRN5physx2Sc14ConstraintCoreE: __Z17NpGetPxConstraintRN5physx2Sc14ConstraintCoreE, _getpgid: _getpgid, __ZN5physx21PxClothRepXSerializerD0Ev: __ZN5physx21PxClothRepXSerializerD0Ev, __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE18getAngularVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE18getAngularVelocityEv, __ZN11UnityEngine15CloudWebService16SessionContainer19ConvertToFolderTimeEjt: __ZN11UnityEngine15CloudWebService16SessionContainer19ConvertToFolderTimeEjt, __Z19GetUserConfigFolderv: __Z19GetUserConfigFolderv, __ZThn8_N5physx2Sc18TriggerInteraction12onDeactivateEj: __ZThn8_N5physx2Sc18TriggerInteraction12onDeactivateEj, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5Unity11SpringJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity11SpringJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z27ClearCommonScriptingClassesR22CommonScriptingClasses: __Z27ClearCommonScriptingClassesR22CommonScriptingClasses, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19ComputeShaderKernelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI19ComputeShaderKernelNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE: __ZN7mecanim5human20MaskHasRightFootGoalERKNS_6bitsetILj66EEE, __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, _UNITY_tt_face_set_sbit_strike: _UNITY_tt_face_set_sbit_strike, __ZN5physx14NpRigidDynamic8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb: __ZN5physx14NpRigidDynamic8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb, __Z39Joint_CUSTOM_INTERNAL_get_currentTorqueP12Il2CppObjectP8Vector3f: __Z39Joint_CUSTOM_INTERNAL_get_currentTorqueP12Il2CppObjectP8Vector3f, __Z34getPxArticulationLink_InboundJointPKN5physx18PxArticulationLinkE: __Z34getPxArticulationLink_InboundJointPKN5physx18PxArticulationLinkE, __Z63Register_UnityEngine_CharacterJoint_INTERNAL_get_highTwistLimitv: __Z63Register_UnityEngine_CharacterJoint_INTERNAL_get_highTwistLimitv, __ZN7CurveID13CalculateHashEv: __ZN7CurveID13CalculateHashEv, __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11NamedObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z17profiler_end_mode12ProfilerMode: __Z17profiler_end_mode12ProfilerMode, __Z44Register_UnityEngine_Shader_IsKeywordEnabledv: __Z44Register_UnityEngine_Shader_IsKeywordEnabledv, __Z27CancelAndStopPreloadManagerv: __Z27CancelAndStopPreloadManagerv, __ZN19UnityConnectService30OnSceneLoadedBeforeAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZN19UnityConnectService30OnSceneLoadedBeforeAwakeStaticEPS_iR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_8ios_baseES5_E: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_8ios_baseES5_E, __ZL35RegisterModuleICalls_UnityAnalyticsv: __ZL35RegisterModuleICalls_UnityAnalyticsv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE8__appendEj, __Z48Register_UnityEngine_Joint2D_set_enableCollisionv: __Z48Register_UnityEngine_Joint2D_set_enableCollisionv, __Z41scripting_type_get_class_or_element_classPK10Il2CppType: __Z41scripting_type_get_class_or_element_classPK10Il2CppType, __ZN13GfxDeviceGLES29RenderSurfaceStructMemorySizeEb: __ZN13GfxDeviceGLES29RenderSurfaceStructMemorySizeEb, _UNITY_FT_Init_Class_ft_outline_glyph_class: _UNITY_FT_Init_Class_ft_outline_glyph_class, __Z36TerrainData_Get_Custom_PropThicknessP12Il2CppObject: __Z36TerrainData_Get_Custom_PropThicknessP12Il2CppObject, __ZNK5physx11Adjacencies22ComputeNbBoundaryEdgesEv: __ZNK5physx11Adjacencies22ComputeNbBoundaryEdgesEv, __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalMatrixiR10Matrix4x4f: __Z43Shader_CUSTOM_INTERNAL_CALL_GetGlobalMatrixiR10Matrix4x4f, __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE: __ZN11UnityEngine9Animation28SetGenericPPtrPropertyValuesERKNS0_30AnimatorGenericBindingConstantERKN7mecanim10ValueArrayE, __Z57Register_UnityEngine_Gyroscope_setUpdateInterval_Internalv: __Z57Register_UnityEngine_Gyroscope_setUpdateInterval_Internalv, __ZN14BillboardAsset9SetHeightEf: __ZN14BillboardAsset9SetHeightEf, __ZN14qsort_internal18QSortSingleJobDataIP16RenderObjectDatai26RenderDeferredObjectSorterE7SortJobEPS4_: __ZN14qsort_internal18QSortSingleJobDataIP16RenderObjectDatai26RenderDeferredObjectSorterE7SortJobEPS4_, __ZN10CBBoxInt328ClampMinEiii: __ZN10CBBoxInt328ClampMinEiii, __ZN21AnimationClipPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE: __ZN21AnimationClipPlayable17GetAnimationClipsER13dynamic_arrayIP13AnimationClipLj4EE, __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER8UnityStrjPKc: __ZN11UnityEngine15CloudWebService17CloudServiceEvent12ToJsonStringER8UnityStrjPKc, __ZN14SphereCollider13AwakeFromLoadE17AwakeFromLoadMode: __ZN14SphereCollider13AwakeFromLoadE17AwakeFromLoadMode, __ZN12_GLOBAL__N_112UserRenderer13drawTrianglesEPKN5physx8debugger8renderer11PvdTriangleEj: __ZN12_GLOBAL__N_112UserRenderer13drawTrianglesEPKN5physx8debugger8renderer11PvdTriangleEj, __ZN9ShaderLab9IntShaderD2Ev: __ZN9ShaderLab9IntShaderD2Ev, __Z31GetAllAssetNamesFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE: __Z31GetAllAssetNamesFromAssetBundleR11AssetBundleRNSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEE, __ZN20TextRenderingPrivate17TextMeshGenerator24GetCursorIndexAtPositionERK5RectTIfERK8Vector2f: __ZN20TextRenderingPrivate17TextMeshGenerator24GetCursorIndexAtPositionERK5RectTIfERK8Vector2f, __ZN6Camera16DoRenderGUILayerER17ShaderPassContextNS_10RenderFlagE: __ZN6Camera16DoRenderGUILayerER17ShaderPassContextNS_10RenderFlagE, __ZN5physx21solveVDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE: __ZN5physx21solveVDefaultFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jPNS_2Cm13SpatialVectorE, __Z47Register_UnityEngine_Light_RemoveCommandBuffersv: __Z47Register_UnityEngine_Light_RemoveCommandBuffersv, __Z32setPxJointLimitParametersDampingPN5physx22PxJointLimitParametersEf: __Z32setPxJointLimitParametersDampingPN5physx22PxJointLimitParametersEf, __ZN12TreeDatabase17MainThreadCleanupEv: __ZN12TreeDatabase17MainThreadCleanupEv, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN9JSONWrite8TransferI13dynamic_arrayI8BitFieldLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI8BitFieldLj4EEEEvRT_PKc17TransferMetaFlags, __Z40Camera_CUSTOM_INTERNAL_set_cullingMatrixP12Il2CppObjectRK10Matrix4x4f: __Z40Camera_CUSTOM_INTERNAL_set_cullingMatrixP12Il2CppObjectRK10Matrix4x4f, __ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb: __ZNK17MeshRenderingData30ExtractMeshBuffersAndDrawRangeEjiR11MeshBuffersR16DrawBuffersRangeb, __ZN5physx5cloth10initializeINS0_7SwClothEEEvRT_PKNS_6PxVec4ES7_: __ZN5physx5cloth10initializeINS0_7SwClothEEEvRT_PKNS_6PxVec4ES7_, _cf2_stack_popInt: _cf2_stack_popInt, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9push_backEc, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5Unity17ConfigurableJoint25SetConfiguredInWorldSpaceEb: __ZN5Unity17ConfigurableJoint25SetConfiguredInWorldSpaceEb, __Z65Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToEulerRadv: __Z65Register_UnityEngine_Quaternion_INTERNAL_CALL_Internal_ToEulerRadv, _raccess_guess_darwin_newvfs: _raccess_guess_darwin_newvfs, __ZN15LODGroupManager19ClearInternalArraysEv: __ZN15LODGroupManager19ClearInternalArraysEv, __ZN5physx2Sq17SceneQueryManager11flushShapesEv: __ZN5physx2Sq17SceneQueryManager11flushShapesEv, __Z52Register_UnityEngine_AI_NavMeshAgent_get_autoBrakingv: __Z52Register_UnityEngine_AI_NavMeshAgent_get_autoBrakingv, __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, _UNITY_FT_Stream_GetULongLE: _UNITY_FT_Stream_GetULongLE, __Z31CustomEventData_CUSTOM_AddInt32P12Il2CppObjectP12Il2CppStringi: __Z31CustomEventData_CUSTOM_AddInt32P12Il2CppObjectP12Il2CppStringi, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _getsid: _getsid, __ZN25RuntimeAnimatorController8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN25RuntimeAnimatorController8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEED0Ev, __ZNK11MonoManager26GetTypeInfoVirtualInternalEv: __ZNK11MonoManager26GetTypeInfoVirtualInternalEv, __ZN13WheelColliderD0Ev: __ZN13WheelColliderD0Ev, __Z45getNbPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataE: __Z45getNbPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataE, __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_get_enableCaptureExceptionsv: __Z86Register_UnityEngine_CrashReportHandler_CrashReportHandler_get_enableCaptureExceptionsv, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z37Register_UnityEngine_Font_get_dynamicv: __Z37Register_UnityEngine_Font_get_dynamicv, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_116CollectionSorter7ElementENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_116CollectionSorter7ElementENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z48Register_UnityEngine_BillboardAsset_set_materialv: __Z48Register_UnityEngine_BillboardAsset_set_materialv, __Z14OrthoNormalizeP8Vector3fS0_S0_: __Z14OrthoNormalizeP8Vector3fS0_S0_, __Z35getPxVehicleDriveDynData_GearChangePKN5physx21PxVehicleDriveDynDataE: __Z35getPxVehicleDriveDynData_GearChangePKN5physx21PxVehicleDriveDynDataE, __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev: __ZTv0_n12_NSt3__214basic_iostreamIcNS_11char_traitsIcEEED0Ev, __ZN7Texture15ThreadedCleanupEv: __ZN7Texture15ThreadedCleanupEv, __ZThn32_N17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N17BillboardRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj655ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj655ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z34ParticleSystem_Set_Custom_PropLoopP12Il2CppObjecth: __Z34ParticleSystem_Set_Custom_PropLoopP12Il2CppObjecth, __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __ZN11UnityEngine7Connect16PersistentValues10SaveValuesER9JSONWrite: __ZN11UnityEngine7Connect16PersistentValues10SaveValuesER9JSONWrite, __ZNKSt3__217moneypunct_bynameIcLb1EE13do_pos_formatEv: __ZNKSt3__217moneypunct_bynameIcLb1EE13do_pos_formatEv, __ZN2UI11CanvasGroup16CheckConsistencyEv: __ZN2UI11CanvasGroup16CheckConsistencyEv, _psh_hint_table_init: _psh_hint_table_init, __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI14ParticleSystemE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZL11md5_processP11md5_contextPh: __ZL11md5_processP11md5_contextPh, __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__213__vector_baseI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev, __ZN12_GLOBAL__N_110Connection14onDeallocationEPv: __ZN12_GLOBAL__N_110Connection14onDeallocationEPv, __ZN8Gradient7SetKeysEPNS_8ColorKeyEjPNS_8AlphaKeyEj: __ZN8Gradient7SetKeysEPNS_8ColorKeyEjPNS_8AlphaKeyEj, __Z13RegisterClassI11PreloadDataEvv: __Z13RegisterClassI11PreloadDataEvv, __ZN23OverlapCallbackNonAllocD0Ev: __ZN23OverlapCallbackNonAllocD0Ev, __ZN5physx2Sc5Scene29scheduleParticleCollisionPrepERNS_10PxBaseTaskES3_: __ZN5physx2Sc5Scene29scheduleParticleCollisionPrepERNS_10PxBaseTaskES3_, __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv: __ZN12_GLOBAL__N_110Connection22checkMemoryEventClientEv, __Z42Register_UnityEngine_GUIText_get_fontStylev: __Z42Register_UnityEngine_GUIText_get_fontStylev, __Z33getNbPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveE: __Z33getNbPxVehicleNoDrive_DriveTorquePKN5physx16PxVehicleNoDriveE, __ZNK9AudioClip15GetChannelCountEv: __ZNK9AudioClip15GetChannelCountEv, __Z31setPxVehicleDriveDynData_GearUpPN5physx21PxVehicleDriveDynDataEb: __Z31setPxVehicleDriveDynData_GearUpPN5physx21PxVehicleDriveDynDataEb, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFrameOverTimeP12Il2CppObjectR15MonoMinMaxCurve, __ZN12MemoryStreamC2EPhj: __ZN12MemoryStreamC2EPhj, __ZN15DirectorManager8FreeNodeEP5HNode: __ZN15DirectorManager8FreeNodeEP5HNode, __Z56ParticleSystem_ExternalForcesModule_CUSTOM_GetMultiplierP12Il2CppObject: __Z56ParticleSystem_ExternalForcesModule_CUSTOM_GetMultiplierP12Il2CppObject, __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv: __ZNK5physx2Sc18ParticleSystemCore23getSimulationFilterDataEv, __Z31Cursor_Set_Custom_PropLockState14CursorLockMode: __Z31Cursor_Set_Custom_PropLockState14CursorLockMode, __ZN9JSONWrite8TransferI8GUIStyleEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8GUIStyleEEvRT_PKc17TransferMetaFlags, __ZN4PPtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_, __ZN18ProceduralMaterial10ClearCacheEv: __ZN18ProceduralMaterial10ClearCacheEv, __Z39NavMeshAgent_Get_Custom_PropIsOnNavMeshP12Il2CppObject: __Z39NavMeshAgent_Get_Custom_PropIsOnNavMeshP12Il2CppObject, __ZN4Mesh21GetSharedPxConvexMeshEv: __ZN4Mesh21GetSharedPxConvexMeshEv, __ZN21SweepCallbackNonAllocD0Ev: __ZN21SweepCallbackNonAllocD0Ev, __ZN9GfxDevice15ResetFrameStatsEv: __ZN9GfxDevice15ResetFrameStatsEv, __Z14PrepareJobDataRK15UpdateCrowdInfoPS_i: __Z14PrepareJobDataRK15UpdateCrowdInfoPS_i, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__get_short_sizeEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16__get_short_sizeEv, __ZN5physx2Sc5Scene20rigidBodyNarrowPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene20rigidBodyNarrowPhaseEPNS_10PxBaseTaskE, __ZNK14SplatMaterials11HasMetallicEv: __ZNK14SplatMaterials11HasMetallicEv, _ft_ansi_stream_close: _ft_ansi_stream_close, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj538ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN23ShaderVariantCollection13AwakeFromLoadE17AwakeFromLoadMode: __ZN23ShaderVariantCollection13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx8debugger16ClassDescriptionD0Ev: __ZN5physx8debugger16ClassDescriptionD0Ev, __Z47Register_UnityEngine_Texture_Internal_GetHeightv: __Z47Register_UnityEngine_Texture_Internal_GetHeightv, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesEv, __ZN5physx9NpPhysics17createHeightFieldERNS_13PxInputStreamE: __ZN5physx9NpPhysics17createHeightFieldERNS_13PxInputStreamE, __Z43LineRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject: __Z43LineRenderer_Get_Custom_PropWidthMultiplierP12Il2CppObject, __ZN5Umbra5FloatpLEf: __ZN5Umbra5FloatpLEf, _UNITY_tt_face_init: _UNITY_tt_face_init, __ZN5Unity5Cloth11SetFrictionEf: __ZN5Unity5Cloth11SetFrictionEf, __ZN14SpriteRenderer9SetSpriteE4PPtrI6SpriteE: __ZN14SpriteRenderer9SetSpriteE4PPtrI6SpriteE, __ZN10PngDecoder11InitDecoderEv: __ZN10PngDecoder11InitDecoderEv, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN5physx7profile15ZoneManagerImpl21setUserCustomProfilerEPNS_20PxUserCustomProfilerE: __ZN5physx7profile15ZoneManagerImpl21setUserCustomProfilerEPNS_20PxUserCustomProfilerE, __ZN5physx2Cm8PtrTable3addEPvRNS0_22PtrTableStorageManagerE: __ZN5physx2Cm8PtrTable3addEPvRNS0_22PtrTableStorageManagerE, __ZN14StackAllocator10DeallocateEPv: __ZN14StackAllocator10DeallocateEPv, __ZN16GeometryJobTasksC2Ev: __ZN16GeometryJobTasksC2Ev, __ZN10CBBoxInt328ClampMaxEiii: __ZN10CBBoxInt328ClampMaxEiii, __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setAngularInertiaERKNS_6PxVec3E, __Z28TestAssetBundleCompatibilityR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERS7_: __Z28TestAssetBundleCompatibilityR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEERS7_, __Z44PhysicMaterial_Set_Custom_PropStaticFrictionP12Il2CppObjectf: __Z44PhysicMaterial_Set_Custom_PropStaticFrictionP12Il2CppObjectf, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags, __Z56ParticleSystem_MainModule_CUSTOM_GetStartSpeedMultiplierP12Il2CppObject: __Z56ParticleSystem_MainModule_CUSTOM_GetStartSpeedMultiplierP12Il2CppObject, __ZN5physx16PxsBroadPhaseMBP13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE: __ZN5physx16PxsBroadPhaseMBP13setUpdateDataERKNS_23PxcBroadPhaseUpdateDataE, __ZL39PatchShaderSourceForAdrenoES3WorkaroundNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPS5_: __ZL39PatchShaderSourceForAdrenoES3WorkaroundNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPS5_, __Z24MonoAddComponentWithTypeR10GameObjectP12Il2CppObject: __Z24MonoAddComponentWithTypeR10GameObjectP12Il2CppObject, __ZNK5physx7NpScene26getSimulationEventCallbackEh: __ZNK5physx7NpScene26getSimulationEventCallbackEh, __ZN20SubstanceArchiveDataD2Ev: __ZN20SubstanceArchiveDataD2Ev, __ZN21AnimationClipPlayable7SetTimeEd: __ZN21AnimationClipPlayable7SetTimeEd, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx2Sc7BodySim19updateKinematicPoseEv: __ZN5physx2Sc7BodySim19updateKinematicPoseEv, __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet: __ZN8Material17SetShaderKeywordsERK16ShaderKeywordSet, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __ZN5physx14NpSpatialIndexD0Ev: __ZN5physx14NpSpatialIndexD0Ev, __Z44TerrainData_Get_Custom_PropTreeInstanceCountP12Il2CppObject: __Z44TerrainData_Get_Custom_PropTreeInstanceCountP12Il2CppObject, __ZN17b2ContactListener8PreSolveEP9b2ContactPK10b2Manifold: __ZN17b2ContactListener8PreSolveEP9b2ContactPK10b2Manifold, __Z20RenderSceneDepthPassRK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext: __Z20RenderSceneDepthPassRK19SharedRendererSceneRK17ShaderReplaceDatabR17ShaderPassContext, __ZN5Unity11AdjTriangle8FindEdgeEjj: __ZN5Unity11AdjTriangle8FindEdgeEjj, __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj: __ZN5physx2Sc17ParticleSystemSim17removeInteractionERKNS0_19ParticlePacketShapeERKNS0_8ShapeSimEbj, __Z43ParticleRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf: __Z43ParticleRenderer_Set_Custom_PropLengthScaleP12Il2CppObjectf, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK11DynamicMesh8SubtractERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEERKS4_RS4_SC_PKhRKS2_I5PlaneLj4EE: __ZNK11DynamicMesh8SubtractERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEERKS4_RS4_SC_PKhRKS2_I5PlaneLj4EE, __ZN17MemoryCacheWriter11GetPathNameEv: __ZN17MemoryCacheWriter11GetPathNameEv, __ZN9HumanBoneC2ERKS_: __ZN9HumanBoneC2ERKS_, __ZN9ShaderLab21SerializedShaderState8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab21SerializedShaderState8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK13MonoBehaviour17GetExecutionOrderEv: __ZNK13MonoBehaviour17GetExecutionOrderEv, __ZN5physx18NpArticulationLink8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx18NpArticulationLink8requiresERNS_23PxProcessPxBaseCallbackE, __ZN8Animator15IsBoneTransformEP9Transform: __ZN8Animator15IsBoneTransformEP9Transform, __Z40AudioSource_CUSTOM_SetScheduledStartTimeP12Il2CppObjectd: __Z40AudioSource_CUSTOM_SetScheduledStartTimeP12Il2CppObjectd, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE, __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE: __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE, __ZNSt3__210__stdinbufIcE9pbackfailEi: __ZNSt3__210__stdinbufIcE9pbackfailEi, __Z21GetManagerFromContexti: __Z21GetManagerFromContexti, __ZNK8GUIStyle10DrawCursorER8GUIStateRK5RectTIfER10GUIContentiRK10ColorRGBAf: __ZNK8GUIStyle10DrawCursorER8GUIStateRK5RectTIfER10GUIContentiRK10ColorRGBAf, __ZN2UI13CanvasManager20UpdateDirtyRenderersER8JobFencePNS_6CanvasE: __ZN2UI13CanvasManager20UpdateDirtyRenderersER8JobFencePNS_6CanvasE, __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ES4_S4_f: __ZN5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEC2ES4_S4_f, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5widenEc: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE5widenEc, _UNITY_FT_Create_Class_pscmaps_services: _UNITY_FT_Create_Class_pscmaps_services, __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb: __ZN2UI6Canvas17EmitWorldGeometryEP6CameraRtb, __ZNK19TouchPhaseEmulation15GetMousePresentEv: __ZNK19TouchPhaseEmulation15GetMousePresentEv, __Z38Material_Get_Custom_PropShaderKeywordsP12Il2CppObject: __Z38Material_Get_Custom_PropShaderKeywordsP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj74ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj74ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity11SpringJoint5ResetEv: __ZN5Unity11SpringJoint5ResetEv, __ZNSt3__26vectorIPFvjENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIPFvjENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN9Animation8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9Animation8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z44AudioReverbFilter_Set_Custom_PropReverbLevelP12Il2CppObjectf: __Z44AudioReverbFilter_Set_Custom_PropReverbLevelP12Il2CppObjectf, __ZN6ShaderD2Ev: __ZN6ShaderD2Ev, __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_: __ZNSt3__27__sort5IR11IndexSorterPiEEjT0_S4_S4_S4_S4_T_, _Round_None: _Round_None, __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_17MemoryEventHeaderE: __ZN5physx7profile16StringTableEvent9streamifyINS0_17EventDeserializerILb0EEEEEvRT_RKNS0_17MemoryEventHeaderE, __ZN24MaterialDisplayListCache16CachedShaderPass11InsertEntryERKNS_17CachedShaderEntryE: __ZN24MaterialDisplayListCache16CachedShaderPass11InsertEntryERKNS_17CachedShaderEntryE, __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf: __ZN5physx2Sc18ParticleSystemCore14setRestitutionEf, __ZN8GUIState10BeginFrameEf: __ZN8GUIState10BeginFrameEf, _UNITY_FT_Outline_Reverse: _UNITY_FT_Outline_Reverse, __Z47BuoyancyEffector2D_Get_Custom_PropFlowMagnitudeP12Il2CppObject: __Z47BuoyancyEffector2D_Get_Custom_PropFlowMagnitudeP12Il2CppObject, __Z21ExecuteOneJobQueueJobv: __Z21ExecuteOneJobQueueJobv, __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Texture2D15UpdateImageDataEv: __ZN9Texture2D15UpdateImageDataEv, __Z39RenderTexture_CUSTOM_Internal_SetHeightP12Il2CppObjecti: __Z39RenderTexture_CUSTOM_Internal_SetHeightP12Il2CppObjecti, __ZNK17FileSystemHandler8FilenameERK13FileEntryData: __ZNK17FileSystemHandler8FilenameERK13FileEntryData, __ZN13ComputeShader10GetKernelsE17GfxDeviceRendereri: __ZN13ComputeShader10GetKernelsE17GfxDeviceRendereri, __Z49Register_UnityEngine_Animation_INTERNAL_CALL_Stopv: __Z49Register_UnityEngine_Animation_INTERNAL_CALL_Stopv, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getParticleBaseFlagsEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE20getParticleBaseFlagsEv, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z13RequireMethodPKcS0_S0_S0_: __Z13RequireMethodPKcS0_S0_S0_, __ZN5physx13GuMeshFactory21removeFactoryListenerERNS_21GuMeshFactoryListenerE: __ZN5physx13GuMeshFactory21removeFactoryListenerERNS_21GuMeshFactoryListenerE, __ZN19ControllerHitReportD0Ev: __ZN19ControllerHitReportD0Ev, __Z23CalculateClippedCapsulePfS_PKfS1_S1_ff: __Z23CalculateClippedCapsulePfS_PKfS1_S1_ff, __ZL29CleanupModule_ParticlesLegacyv: __ZL29CleanupModule_ParticlesLegacyv, __ZNK19LowerResBlitTexture12GetDimensionEv: __ZNK19LowerResBlitTexture12GetDimensionEv, __ZN14GraphicsHelper8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE: __ZN14GraphicsHelper8DrawQuadER9GfxDevicePK14ChannelAssignsbRK5RectTIfE, __ZN9JSONWriteD2Ev: __ZN9JSONWriteD2Ev, __Z24RegisterStrippedTypeInfoI11GameManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI11GameManagerEviPKcS2_, __ZN8JSONRead8TransferIyEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIyEEvRT_PKc17TransferMetaFlagsb, __ZN22RenderingCommandBuffer17AddDrawProceduralERK10Matrix4x4fP8Materiali16GfxPrimitiveTypeiiP19ShaderPropertySheet: __ZN22RenderingCommandBuffer17AddDrawProceduralERK10Matrix4x4fP8Materiali16GfxPrimitiveTypeiiP19ShaderPropertySheet, __ZN6Skybox14RenderAllFacesEP8Material: __ZN6Skybox14RenderAllFacesEP8Material, __Z46ParticleSystem_TriggerModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z46ParticleSystem_TriggerModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN12MeshCollider12SetIsTriggerEb: __ZN12MeshCollider12SetIsTriggerEb, __ZL33InitializeTerrainScriptingClassesv: __ZL33InitializeTerrainScriptingClassesv, __Z24BuildHumanAvatarInternalP10GameObjectRK16HumanDescription: __Z24BuildHumanAvatarInternalP10GameObjectRK16HumanDescription, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD7ReverbID2Ev: __ZN4FMOD7ReverbID2Ev, __ZN11TypeManager19ClassNameToTypeInfoEPKcb: __ZN11TypeManager19ClassNameToTypeInfoEPKcb, __Z39NavMeshAgent_Get_Custom_PropAutoBrakingP12Il2CppObject: __Z39NavMeshAgent_Get_Custom_PropAutoBrakingP12Il2CppObject, __Z19dtFreePathQueryInfoP15dtPathQueryInfo: __Z19dtFreePathQueryInfoP15dtPathQueryInfo, __Z26AddScaleCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb: __Z26AddScaleCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb, __ZN4FMOD6System16createSoundGroupEPKcPPNS_10SoundGroupE: __ZN4FMOD6System16createSoundGroupEPKcPPNS_10SoundGroupE, __Z42TerrainData_Get_Custom_PropHeightmapHeightP12Il2CppObject: __Z42TerrainData_Get_Custom_PropHeightmapHeightP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj627ES2_KjbEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN6Shader19SetMaximumShaderLODEi: __ZN6Shader19SetMaximumShaderLODEi, __Z30RectOffset_Set_Custom_PropLeftP12Il2CppObjecti: __Z30RectOffset_Set_Custom_PropLeftP12Il2CppObjecti, _UNITY_FT_Vector_NormLen: _UNITY_FT_Vector_NormLen, __ZN22CrashReportingSettingsD0Ev: __ZN22CrashReportingSettingsD0Ev, __Z28Resources_CUSTOM_UnloadAssetP12Il2CppObject: __Z28Resources_CUSTOM_UnloadAssetP12Il2CppObject, __ZN6Socket15WouldBlockErrorEv: __ZN6Socket15WouldBlockErrorEv, __ZN9GfxDevice19SetNextDrawCallTypeE15GfxDrawCallType: __ZN9GfxDevice19SetNextDrawCallTypeE15GfxDrawCallType, __Z35GUIStyle_Get_Custom_PropFixedHeightP12Il2CppObject: __Z35GUIStyle_Get_Custom_PropFixedHeightP12Il2CppObject, __ZN4TreeC2E10MemLabelId18ObjectCreationMode: __ZN4TreeC2E10MemLabelId18ObjectCreationMode, __ZN18PlatformEffector2D18SetUseSideFrictionEb: __ZN18PlatformEffector2D18SetUseSideFrictionEb, __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE: __ZN7mecanim9animation24CreateAnimationNodeStateERKNS_18ValueArrayConstantEbbbRNS_6memory9AllocatorE, __Z23TransferScriptingObjectI24GenerateTypeTreeTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI24GenerateTypeTreeTransferEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE18getConstraintFlagsEv, __ZN9ShaderLab18SerializedPropertyD2Ev: __ZN9ShaderLab18SerializedPropertyD2Ev, __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE13StaticDestroyEPv: __ZN13RuntimeStaticINSt3__23mapIy8TFShaderNS0_4lessIyEENS0_9allocatorINS0_4pairIKyS2_EEEEEEE13StaticDestroyEPv, __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7Joint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15LocationService18SetDesiredAccuracyEf: __ZN15LocationService18SetDesiredAccuracyEf, __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEE7SortJobEPS6_: __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb0EEEE7SortJobEPS6_, __ZN24MeshIntermediateRenderer16StaticInitializeEPv: __ZN24MeshIntermediateRenderer16StaticInitializeEPv, __ZN17ArchiveFileSystem12MountArchiveEP20ArchiveStorageReader: __ZN17ArchiveFileSystem12MountArchiveEP20ArchiveStorageReader, __Z51Register_UnityEngine_Rigidbody_get_detectCollisionsv: __Z51Register_UnityEngine_Rigidbody_get_detectCollisionsv, __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc17ParticleSystemSimEXadL_ZNS3_21prepareCollisionInputEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN9Scripting29GetFirstNonGenericParentClassEP11Il2CppClassS1_: __ZN9Scripting29GetFirstNonGenericParentClassEP11Il2CppClassS1_, __Z63Register_UnityEngine_WebCamTexture_Internal_CreateWebCamTexturev: __Z63Register_UnityEngine_WebCamTexture_Internal_CreateWebCamTexturev, __ZN5physx14NpArticulation8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx14NpArticulation8requiresERNS_23PxProcessPxBaseCallbackE, __Z40scripting_liveness_calculation_from_rootP12Il2CppObjectPv: __Z40scripting_liveness_calculation_from_rootP12Il2CppObjectPv, __ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE: __ZN5Umbra11KDTraversalINS_14TraverseFilterINS_10NoUserDataEEEE4nextERNS_6KDTree4NodeE, __ZN24RigidbodyMovementState2D20ResetLinearMoveStateEv: __ZN24RigidbodyMovementState2D20ResetLinearMoveStateEv, __Z65Register_UnityEngine_ParticleSystem_SetCustomParticleDataInternalv: __Z65Register_UnityEngine_ParticleSystem_SetCustomParticleDataInternalv, _wcschr: _wcschr, __ZN7Terrain22SetDetailObjectDensityEf: __ZN7Terrain22SetDetailObjectDensityEf, _cf2_getBlueValues: _cf2_getBlueValues, __ZN9Rigidbody8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Rigidbody8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z28getPxAggregate_SelfCollisionPKN5physx11PxAggregateE: __Z28getPxAggregate_SelfCollisionPKN5physx11PxAggregateE, __Z15CleanupGUIStatei: __Z15CleanupGUIStatei, __ZN14DataBufferGLES16RecreateWithDataEiPKv: __ZN14DataBufferGLES16RecreateWithDataEiPKv, __Z57ParticleSystem_MainModule_CUSTOM_GetCustomSimulationSpaceP12Il2CppObject: __Z57ParticleSystem_MainModule_CUSTOM_GetCustomSimulationSpaceP12Il2CppObject, __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17SurfaceEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI6ObjectELj4EEEEvRT_17TransferMetaFlags, __Z26CombineDepthNormalsTextureRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EE: __Z26CombineDepthNormalsTextureRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EE, __Z44TrailRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf: __Z44TrailRenderer_CUSTOM_INTERNAL_get_startColorP12Il2CppObjectP10ColorRGBAf, __ZN14b2CapsuleShape12SetByEndCapsEfRK6b2Vec2S2_S2_: __ZN14b2CapsuleShape12SetByEndCapsEfRK6b2Vec2S2_S2_, __ZNK5physx3Cct13BoxController13getSlopeLimitEv: __ZNK5physx3Cct13BoxController13getSlopeLimitEv, __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_velocityv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_get_velocityv, __ZN5physx30PxRevoluteJointGeneratedValuesC2EPKNS_15PxRevoluteJointE: __ZN5physx30PxRevoluteJointGeneratedValuesC2EPKNS_15PxRevoluteJointE, __Z24PlayerInitEngineGraphicsb: __Z24PlayerInitEngineGraphicsb, __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT__4326: __ZL29CanTransferTypeAsNestedObjectI18TransferField_InfoEbRKT__4326, __ZN12_GLOBAL__N_112UserRenderer18visualizeLimitConeERKN5physx11PxTransformEffb: __ZN12_GLOBAL__N_112UserRenderer18visualizeLimitConeERKN5physx11PxTransformEffb, __ZN7mecanim4hand10FingerNameEj: __ZN7mecanim4hand10FingerNameEj, __ZN2UI13CanvasManager25UpdateCanvasRectTransformEv: __ZN2UI13CanvasManager25UpdateCanvasRectTransformEv, __ZNK14GfxContextGLES10GetCurrentEv: __ZNK14GfxContextGLES10GetCurrentEv, __ZN12EventManager8HasEventEP10EventEntryPFvPvS2_iEPKv: __ZN12EventManager8HasEventEP10EventEntryPFvPvS2_iEPKv, _unzGoToFirstFile: _unzGoToFirstFile, __ZNSt3__214__scan_keywordIPcPNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SC_SB_SB_RKT1_Rjb: __ZNSt3__214__scan_keywordIPcPNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_5ctypeIcEEEET0_RT_SC_SB_SB_RKT1_Rjb, __ZN5physx13PxHitCallbackINS_10PxSweepHitEED2Ev: __ZN5physx13PxHitCallbackINS_10PxSweepHitEED2Ev, __Z10DestripifyPKtiRNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEEE: __Z10DestripifyPKtiRNSt3__26vectorIt13stl_allocatorItL18MemLabelIdentifier1ELi16EEEE, __Z33Canvas_Set_Custom_PropScaleFactorP12Il2CppObjectf: __Z33Canvas_Set_Custom_PropScaleFactorP12Il2CppObjectf, __ZNK10AudioMixer31AllowSnapshotTransitionsFromAPIEv: __ZNK10AudioMixer31AllowSnapshotTransitionsFromAPIEv, __ZN16Physics2DManager16GetProfilerStatsER14Physics2DStats: __ZN16Physics2DManager16GetProfilerStatsER14Physics2DStats, __Z43ParticleSystem_MainModule_CUSTOM_GetEnabledP12Il2CppObject: __Z43ParticleSystem_MainModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE6createERKjRb: __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE6createERKjRb, __ZN5Unity17ConfigurableJoint17SetTargetVelocityERK8Vector3f: __ZN5Unity17ConfigurableJoint17SetTargetVelocityERK8Vector3f, __ZN12_GLOBAL__N_124HfTrianglesEntityReport2D0Ev: __ZN12_GLOBAL__N_124HfTrianglesEntityReport2D0Ev, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN6Camera13CopiableState5ResetEv: __ZN6Camera13CopiableState5ResetEv, __Z6recipTILi1EE8Scalar4fRKS0_: __Z6recipTILi1EE8Scalar4fRKS0_, __ZN5physx5cloth16SwInterCollisionI8Scalar4fE16collideParticlesEPKjjS5_jj: __ZN5physx5cloth16SwInterCollisionI8Scalar4fE16collideParticlesEPKjjS5_jj, __Z55Register_UnityEngine_Application_get_webSecurityHostUrlv: __Z55Register_UnityEngine_Application_get_webSecurityHostUrlv, __ZN7mecanim6memory16InPlaceAllocator8AllocateEjj: __ZN7mecanim6memory16InPlaceAllocator8AllocateEjj, __Z38ParticleEmitter_Get_Custom_PropMinSizeP12Il2CppObject: __Z38ParticleEmitter_Get_Custom_PropMinSizeP12Il2CppObject, __ZN15DownloadHandlerD0Ev: __ZN15DownloadHandlerD0Ev, __Z34Input_Get_Custom_PropImeIsSelectedv: __Z34Input_Get_Custom_PropImeIsSelectedv, __ZNK5physx22PxDefaultFileInputData9getLengthEv: __ZNK5physx22PxDefaultFileInputData9getLengthEv, __ZN16DeveloperConsole9HandleLogERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType: __ZN16DeveloperConsole9HandleLogERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_7LogType, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK10Effector2D16RequiresColliderEv: __ZNK10Effector2D16RequiresColliderEv, __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN24TextDOMTransferWriteBaseI9JSONWriteEC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN24TextDOMTransferWriteBaseI9JSONWriteEC2E24TransferInstructionFlagsPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z37Register_UnityEngine_LODGroup_SetLODsv: __Z37Register_UnityEngine_LODGroup_SetLODsv, __ZN24MeshIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN24MeshIntermediateRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physxL23updateStreamForceTwoWayEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE: __ZN5physxL23updateStreamForceTwoWayEPNS_6PxVec3ES1_PNS_16PxsFluidParticleES3_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE, __Z52Register_UnityEngine_QualitySettings_GetQualityLevelv: __Z52Register_UnityEngine_QualitySettings_GetQualityLevelv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj71ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __ZNSt3__215messages_bynameIwED0Ev: __ZNSt3__215messages_bynameIwED0Ev, __ZN23b2ChainAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN23b2ChainAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZNK22VirtualJoystickManager23GetVirtualJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZNK22VirtualJoystickManager23GetVirtualJoystickNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, _XXH64: _XXH64, __Z26PlayerRenderCanvasOverlaysi: __Z26PlayerRenderCanvasOverlaysi, __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_: __ZN5physx15PxCreateDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_, __ZNK14StackAllocator17GetProfilerHeaderEPKv: __ZNK14StackAllocator17GetProfilerHeaderEPKv, __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE8__appendEj: __ZNSt3__26vectorI21ProceduralTextureData13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE8__appendEj, __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE: __ZN14ParticleSystem7Update0ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStatefNS_11UpdateFlagsE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z53ParticleSystem_CollisionModule_CUSTOM_GetMinKillSpeedP12Il2CppObject: __Z53ParticleSystem_CollisionModule_CUSTOM_GetMinKillSpeedP12Il2CppObject, __Z18Transfer_BlittableI9JSONWriteLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN11UnityEngine7Connect20BasePersistentValuesD2Ev: __ZN11UnityEngine7Connect20BasePersistentValuesD2Ev, __Z21GetUserAppCacheFolderv: __Z21GetUserAppCacheFolderv, __ZN4FMOD7SystemI17getCDROMDriveNameEiPciS1_iS1_i: __ZN4FMOD7SystemI17getCDROMDriveNameEiPciS1_iS1_i, __Z45setPxVehicleDifferential4WDataMFrontRearSplitPN5physx27PxVehicleDifferential4WDataEf: __Z45setPxVehicleDifferential4WDataMFrontRearSplitPN5physx27PxVehicleDifferential4WDataEf, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEED2Ev, __Z16SyncFenceNoClearRK8JobFence: __Z16SyncFenceNoClearRK8JobFence, __ZN33AssetBundleLoadFromAsyncOperation6IsDoneEv: __ZN33AssetBundleLoadFromAsyncOperation6IsDoneEv, __ZN14OcclusionScene8TransferI14SafeBinaryReadEEvRT_: __ZN14OcclusionScene8TransferI14SafeBinaryReadEEvRT_, __Z36getPxRigidDynamic_MaxAngularVelocityPKN5physx14PxRigidDynamicE: __Z36getPxRigidDynamic_MaxAngularVelocityPKN5physx14PxRigidDynamicE, __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED0Ev: __ZNSt3__214codecvt_bynameIDsc11__mbstate_tED0Ev, __ZN14CachingManager21GetAuthorizationLevelEv: __ZN14CachingManager21GetAuthorizationLevelEv, __Z34Compass_Get_Custom_PropTrueHeadingP12Il2CppObject: __Z34Compass_Get_Custom_PropTrueHeadingP12Il2CppObject, __Z45Register_UnityEngine_RenderTexture_get_activev: __Z45Register_UnityEngine_RenderTexture_get_activev, __Z38Register_UnityEngine_Animation_AddClipv: __Z38Register_UnityEngine_Animation_AddClipv, __Z41GUIUtility_Get_Custom_PropKeyboardControlv: __Z41GUIUtility_Get_Custom_PropKeyboardControlv, __Z50Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff: __Z50Physics2D_CUSTOM_INTERNAL_CALL_OverlapAreaNonAllocRK13Vector2fIcallS1_P11Il2CppArrayiff, __ZN18ProceduralMaterial12CleanupClassEv: __ZN18ProceduralMaterial12CleanupClassEv, __ZN22BaseUnityConnectClient7ReleaseEv: __ZN22BaseUnityConnectClient7ReleaseEv, __ZNK13ScreenManager21IsMultiDisplayEnabledEv: __ZNK13ScreenManager21IsMultiDisplayEnabledEv, __Z52Register_UnityEngine_AudioSource_SetSpatializerFloatv: __Z52Register_UnityEngine_AudioSource_SetSpatializerFloatv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN12AudioManager11StopSourcesEv: __ZN12AudioManager11StopSourcesEv, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameEfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_fEEEEEEEEvRT_17TransferMetaFlags, __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb: __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService14CloudEventInfoEb, _zipCloseFileInZip: _zipCloseFileInZip, __ZNK13MonoBehaviour10HasEnabledEv: __ZNK13MonoBehaviour10HasEnabledEv, __Z39Register_UnityEngine_Time_get_deltaTimev: __Z39Register_UnityEngine_Time_get_deltaTimev, __ZN20LocalFileSystemPosix12CreateAsFileER13FileEntryData: __ZN20LocalFileSystemPosix12CreateAsFileER13FileEntryData, __ZN15MulticastSocket4JoinEv: __ZN15MulticastSocket4JoinEv, __ZN14PhysicsManager10RaycastAllERK3Rayfi23QueryTriggerInteraction: __ZN14PhysicsManager10RaycastAllERK3Rayfi23QueryTriggerInteraction, _UNITY_png_malloc_default: _UNITY_png_malloc_default, __ZNK26AnimatorOverrideController16GetOriginalClipsEv: __ZNK26AnimatorOverrideController16GetOriginalClipsEv, __Z18dtFreeNavMeshQueryP14dtNavMeshQuery: __Z18dtFreeNavMeshQueryP14dtNavMeshQuery, __Z44Register_UnityEngine_Animator_SetLayerWeightv: __Z44Register_UnityEngine_Animator_SetLayerWeightv, __ZN5physx9PxTaskMgr12dispatchTaskEjb: __ZN5physx9PxTaskMgr12dispatchTaskEjb, __ZNK5physx13NpClothFabric18getParticleIndicesEPjj: __ZNK5physx13NpClothFabric18getParticleIndicesEPjj, __ZN5physx2Sc16ActorInteractionD0Ev: __ZN5physx2Sc16ActorInteractionD0Ev, __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIjjNS0_4HashIjEENS1_11HashSetBaseIjS4_NS0_9AllocatorELb0EE6GetKeyES6_Lb0EE15reserveInternalEj, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIhLj256EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __Z61Register_UnityEngine_LightmapSettings_set_lightmapsModeLegacyv: __Z61Register_UnityEngine_LightmapSettings_set_lightmapsModeLegacyv, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__cEv, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE, ___wcsxfrm_l: ___wcsxfrm_l, __ZN5physx2Sc8ClothSim19addCollisionCapsuleEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim19addCollisionCapsuleEPKNS0_8ShapeSimE, __ZN9Rigidbody16SetInterpolationE22RigidbodyInterpolation: __ZN9Rigidbody16SetInterpolationE22RigidbodyInterpolation, _compare_offsets: _compare_offsets, __Z50setPxVehicleDifferential4WDataMFrontLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf: __Z50setPxVehicleDifferential4WDataMFrontLeftRightSplitPN5physx27PxVehicleDifferential4WDataEf, __ZNK5physx13NpRigidStatic7getTypeEv: __ZNK5physx13NpRigidStatic7getTypeEv, __Z30Animator_CUSTOM_IsInTransitionP12Il2CppObjecti: __Z30Animator_CUSTOM_IsInTransitionP12Il2CppObjecti, __Z31GetRelaunchApplicationArgumentsv: __Z31GetRelaunchApplicationArgumentsv, __ZN4core20StringStorageDefaultIcE10reallocateEj: __ZN4core20StringStorageDefaultIcE10reallocateEj, __ZN5physx2Sn5ConvX10setNullPtrEb: __ZN5physx2Sn5ConvX10setNullPtrEb, __ZN14MemoryProfiler20GetRelatedMemorySizeEPKv: __ZN14MemoryProfiler20GetRelatedMemorySizeEPKv, ___fpclassifyf: ___fpclassifyf, __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI24GenerateTypeTreeTransfer8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setRotationERKNS_6PxQuatE, __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEEclILj291ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z39Cloth_Get_Custom_PropCollisionMassScaleP12Il2CppObject: __Z39Cloth_Get_Custom_PropCollisionMassScaleP12Il2CppObject, __ZN5physx2Cm20visualizeLinearLimitERNS0_12RenderOutputEfRKNS_11PxTransformES5_fb: __ZN5physx2Cm20visualizeLinearLimitERNS0_12RenderOutputEfRKNS_11PxTransformES5_fb, __ZN9Transform40SendTransformChangedToModifiedTransformsEv: __ZN9Transform40SendTransformChangedToModifiedTransformsEv, __Z53Register_UnityEngine_Caching_INTERNAL_CALL_MarkAsUsedv: __Z53Register_UnityEngine_Caching_INTERNAL_CALL_MarkAsUsedv, __Z41Animation_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB: __Z41Animation_CUSTOM_INTERNAL_get_localBoundsP12Il2CppObjectP4AABB, __Z33Physics2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti: __Z33Physics2D_CUSTOM_IsTouchingLayersP12Il2CppObjecti, __ZNK13BaseAllocator24GetBookKeepingMemorySizeEv: __ZNK13BaseAllocator24GetBookKeepingMemorySizeEv, __ZN5physx7NpScene9stopWriteEb: __ZN5physx7NpScene9stopWriteEb, __ZN5Umbra5FloatmIEf: __ZN5Umbra5FloatmIEf, __ZN2UI14CanvasRenderer9SyncDepthENS0_8SyncFlagE: __ZN2UI14CanvasRenderer9SyncDepthENS0_8SyncFlagE, _wstring_read: _wstring_read, __ZN17PxcPoolMallocDataC2Ev: __ZN17PxcPoolMallocDataC2Ev, __ZN9BehaviourD0Ev: __ZN9BehaviourD0Ev, __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE: __ZNSt3__26__treeIjNS_4lessIjEENS_9allocatorIjEEE7destroyEPNS_11__tree_nodeIjPvEE, __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientLightRK10ColorRGBAf: __Z47RenderSettings_CUSTOM_INTERNAL_set_ambientLightRK10ColorRGBAf, __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE: __ZN5physx19PxVisualDebuggerExt16createConnectionEPNS_8debugger4comm20PvdConnectionManagerEPKcNS_7PxFlagsINS_30PxVisualDebuggerConnectionFlag4EnumEjEE, __ZN16MemoryFileSystemD0Ev: __ZN16MemoryFileSystemD0Ev, __ZL25CleanupImageFilterGlobalsPv: __ZL25CleanupImageFilterGlobalsPv, __ZZN10MeshFilter15InitializeClassEvEN30FunctorImpl_84kDidAddComponent4CallEPviR11MessageData: __ZZN10MeshFilter15InitializeClassEvEN30FunctorImpl_84kDidAddComponent4CallEPviR11MessageData, __ZNK10Collider2D7RaycastERK8Vector2ffiffP12RaycastHit2Di: __ZNK10Collider2D7RaycastERK8Vector2ffiffP12RaycastHit2Di, __ZN5physx28PxClothParticleGeneratedInfoC2Ev: __ZN5physx28PxClothParticleGeneratedInfoC2Ev, __Z17FreeStaticQueriesv: __Z17FreeStaticQueriesv, __ZNK5Umbra10PortalInfo7getAABBERNS_7Vector3ES2_: __ZNK5Umbra10PortalInfo7getAABBERNS_7Vector3ES2_, __ZN12_GLOBAL__N_116CompleteCallbackD0Ev: __ZN12_GLOBAL__N_116CompleteCallbackD0Ev, __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN7mecanim9animation19EvaluateClipAtIndexEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEj: __ZN7mecanim9animation19EvaluateClipAtIndexEPKNS0_4ClipEPKNS0_9ClipInputEPNS0_10ClipMemoryEj, __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN15NavMeshObstacle18OnTransformChangedEi: __ZN15NavMeshObstacle18OnTransformChangedEi, __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Rigidbody23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN13BoneInfluence8TransferI14SafeBinaryReadEEvRT_: __ZN13BoneInfluence8TransferI14SafeBinaryReadEEvRT_, __ZN8LODGroup17GetWorldSpaceSizeEv: __ZN8LODGroup17GetWorldSpaceSizeEv, __ZN5Umbra15MemOutputStream5writeEPKvj: __ZN5Umbra15MemOutputStream5writeEPKvj, __Z53Register_UnityEngine_Motion_INTERNAL_get_averageSpeedv: __Z53Register_UnityEngine_Motion_INTERNAL_get_averageSpeedv, __ZN9Animation19SetVisibleRenderersEb: __ZN9Animation19SetVisibleRenderersEb, __ZN17BillboardRenderer19UpdateTransformInfoEv: __ZN17BillboardRenderer19UpdateTransformInfoEv, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN11UnityEngine15CloudWebService14DataDispatcher5CloseEv: __ZN11UnityEngine15CloudWebService14DataDispatcher5CloseEv, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_0EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERNS0_7DataRefINS0_12StringHandleEEE, __Z43Register_UnityEngine_AudioSource_set_volumev: __Z43Register_UnityEngine_AudioSource_set_volumev, __ZN5physx23computeDiffTorqueRatiosERKNS_27PxVehicleDifferential4WDataEfPKfPf: __ZN5physx23computeDiffTorqueRatiosERKNS_27PxVehicleDifferential4WDataEfPKfPf, __Z48TerrainData_CUSTOM_INTERNAL_CALL_GetTreeInstanceP12Il2CppObjectiR12TreeInstance: __Z48TerrainData_CUSTOM_INTERNAL_CALL_GetTreeInstanceP12Il2CppObjectiR12TreeInstance, __Z38Shader_Set_Custom_PropGlobalMaximumLODi: __Z38Shader_Set_Custom_PropGlobalMaximumLODi, __ZN20SpeedTreeWindManager7GetWindERK4AABBRP18SpeedTreeLocalWindRK18SpeedTreeWindAsset: __ZN20SpeedTreeWindManager7GetWindERK4AABBRP18SpeedTreeLocalWindRK18SpeedTreeWindAsset, __ZN11UnityEngine15PlatformWrapper25GetApplicationInstallModeEv: __ZN11UnityEngine15PlatformWrapper25GetApplicationInstallModeEv, __ZN8VRDevice33SetCustomSplashUpdateLoopCallbackEPFvRK11QuaternionfRK8Vector3fS5_E: __ZN8VRDevice33SetCustomSplashUpdateLoopCallbackEPFvRK11QuaternionfRK8Vector3fS5_E, __ZN5physx3Scb5ClothC2ERKNS_11PxTransformERNS_2Sc15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx3Scb5ClothC2ERKNS_11PxTransformERNS_2Sc15ClothFabricCoreEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN15ResourceManagerC2E10MemLabelId18ObjectCreationMode: __ZN15ResourceManagerC2E10MemLabelId18ObjectCreationMode, __ZN12_GLOBAL__N_119FixedJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_119FixedJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __ZL26ClosestHeightPointTriangleRK8Vector3ffS1_S1_S1_Rf: __ZL26ClosestHeightPointTriangleRK8Vector3ffS1_S1_S1_Rf, __ZN11b2GearJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN11b2GearJoint24SolveVelocityConstraintsERK12b2SolverData, __ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff: __ZNK5physx2Gu15HeightFieldUtil22getHeightAtShapePoint2Ejff, __ZN8JSONRead8TransferI8Vector2fEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI8Vector2fEEvRT_PKc17TransferMetaFlagsb, __ZN5physx20PxGetFilterConstantsERNS_12PxGroupsMaskES1_: __ZN5physx20PxGetFilterConstantsERNS_12PxGroupsMaskES1_, __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI13AnimationClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity5Joint17JointTransferPostI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIfNS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKf: __ZN5physx6shdfnd5ArrayIfNS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE15growAndPushBackERKf, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj: __ZNSt3__221__murmur2_or_cityhashIjLj32EEclEPKvj, __Z34GUIText_Get_Custom_PropLineSpacingP12Il2CppObject: __Z34GUIText_Get_Custom_PropLineSpacingP12Il2CppObject, __Z15CreateJobSystemv: __Z15CreateJobSystemv, __ZN21RotationBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN21RotationBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN12_GLOBAL__N_117ConnectionManager10addHandlerERN5physx8debugger4comm20PvdConnectionHandlerE: __ZN12_GLOBAL__N_117ConnectionManager10addHandlerERN5physx8debugger4comm20PvdConnectionHandlerE, __Z30setPxVehicleTireDataMLatStiffYPN5physx17PxVehicleTireDataEf: __Z30setPxVehicleTireDataMLatStiffYPN5physx17PxVehicleTireDataEf, __Z54TerrainData_CUSTOM_Internal_GetMaximumDetailPatchCountv: __Z54TerrainData_CUSTOM_Internal_GetMaximumDetailPatchCountv, __ZNSt3__28valarrayIjE6resizeEjj: __ZNSt3__28valarrayIjE6resizeEjj, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z41Register_UnityEngine_Light_set_shadowBiasv: __Z41Register_UnityEngine_Light_set_shadowBiasv, __ZL17ProgramUniform1fvPK7ApiGLESjiihPKv: __ZL17ProgramUniform1fvPK7ApiGLESjiihPKv, __ZN12TreeRenderer17PopulateRenderersEv: __ZN12TreeRenderer17PopulateRenderersEv, _jsimd_can_h2v1_merged_upsample: _jsimd_can_h2v1_merged_upsample, __ZN15PointEffector2D16CheckConsistencyEv: __ZN15PointEffector2D16CheckConsistencyEv, __ZN9JSONWrite8TransferI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI11ColorRGBA32Lj4EEEEvRT_PKc17TransferMetaFlags, __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE: __ZN22UnityProfilerPerThread22GetProfilerInformationEPKc13ProfilerGroupN19ProfilerInformation5FlagsE, __Z53Register_UnityEngine_Physics_get_defaultContactOffsetv: __Z53Register_UnityEngine_Physics_get_defaultContactOffsetv, __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN20GpuProgramParameters16TextureParameterENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, _UNITY_ft_smooth_lcdv_renderer_class_pic_free: _UNITY_ft_smooth_lcdv_renderer_class_pic_free, __Z29AddCanvasIntermediateRendererPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS3_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModebP6Camera: __Z29AddCanvasIntermediateRendererPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS3_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModebP6Camera, __Z11GetAttitudei: __Z11GetAttitudei, __ZN5physx18PxArticulationLinkD0Ev: __ZN5physx18PxArticulationLinkD0Ev, __ZN5physx21PxcContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx21PxcContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN10GUITexture10SetTextureEP7Texture: __ZN10GUITexture10SetTextureEP7Texture, __ZNK14GfxContextGLES21GetDefaultVertexArrayEv: __ZNK14GfxContextGLES21GetDefaultVertexArrayEv, __ZNK20OcclusionCullingData8GetSceneERK9UnityGUID: __ZNK20OcclusionCullingData8GetSceneERK9UnityGUID, __Z20CleanupStdConvertersv: __Z20CleanupStdConvertersv, __ZNSt3__28ios_base5iwordEi: __ZNSt3__28ios_base5iwordEi, __Z53Register_UnityEngine_PhysicMaterial_set_bounceCombinev: __Z53Register_UnityEngine_PhysicMaterial_set_bounceCombinev, __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientProbeP20SphericalHarmonicsL2: __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientProbeP20SphericalHarmonicsL2, __Z26Transform_CUSTOM_IsChildOfP12Il2CppObjectS0_: __Z26Transform_CUSTOM_IsChildOfP12Il2CppObjectS0_, __ZNK10UnityScene32MarkLevelGameManagerDependenciesER27GarbageCollectorThreadState: __ZNK10UnityScene32MarkLevelGameManagerDependenciesER27GarbageCollectorThreadState, __Z38MeshCollider_Set_Custom_PropSharedMeshP12Il2CppObjectS0_: __Z38MeshCollider_Set_Custom_PropSharedMeshP12Il2CppObjectS0_, __Z32getPxVehicleChassisDataMCMOffsetPKN5physx20PxVehicleChassisDataE: __Z32getPxVehicleChassisDataMCMOffsetPKN5physx20PxVehicleChassisDataE, __ZNK5physx2Sc15ArticulationSim17releaseDriveCacheERNS_9PxcFsDataE: __ZNK5physx2Sc15ArticulationSim17releaseDriveCacheERNS_9PxcFsDataE, __ZNSt3__210moneypunctIcLb1EED2Ev: __ZNSt3__210moneypunctIcLb1EED2Ev, __ZN11UnityEngine7Connect15AppInstallEventC2EPKcNS_15CloudWebService15CloudEventFlagsE: __ZN11UnityEngine7Connect15AppInstallEventC2EPKcNS_15CloudWebService15CloudEventFlagsE, __ZN16UnityAdsSettings22SetInitializeOnStartupEb: __ZN16UnityAdsSettings22SetInitializeOnStartupEb, __ZN4crnd34crnd_get_crn_format_bits_per_texelE10crn_format: __ZN4crnd34crnd_get_crn_format_bits_per_texelE10crn_format, __Z32Random_CUSTOM_INTERNAL_set_stateRK9RandState: __Z32Random_CUSTOM_INTERNAL_set_stateRK9RandState, __Z47Register_UnityEngine_Collider_get_contactOffsetv: __Z47Register_UnityEngine_Collider_get_contactOffsetv, __Z19CheckChannelBinding13ShaderChannel15VertexComponentP12ShaderErrors: __Z19CheckChannelBinding13ShaderChannel15VertexComponentP12ShaderErrors, __ZN5physx3Ext19ProfileEventHandlerC2Ev: __ZN5physx3Ext19ProfileEventHandlerC2Ev, __ZNK5physx5cloth11SwClothData6verifyEv: __ZNK5physx5cloth11SwClothData6verifyEv, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE13isSubordinateEv, __Z11SetINetworkP8INetwork: __Z11SetINetworkP8INetwork, __ZN7Terrain8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7Terrain8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z37getPxParticleReadDataRestOffsetBufferPKN5physx18PxParticleReadDataE: __Z37getPxParticleReadDataRestOffsetBufferPKN5physx18PxParticleReadDataE, __ZL10CullLightsRK22SceneCullingParametersR11CullResults: __ZL10CullLightsRK22SceneCullingParametersR11CullResults, __Z26GetUnityConnectSettingsPtrv: __Z26GetUnityConnectSettingsPtrv, __ZNK14dtNavMeshQuery24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyyPKfPf: __ZNK14dtNavMeshQuery24closestPointOnPolyInTileEPK10dtMeshTilePK6dtPolyyPKfPf, __ZZN13WheelCollider15InitializeClassEvEN29FunctorImpl_1262kLayerChanged4CallEPviR11MessageData: __ZZN13WheelCollider15InitializeClassEvEN29FunctorImpl_1262kLayerChanged4CallEPviR11MessageData, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10broadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags, __Z13RegisterClassI11NavMeshDataEvv: __Z13RegisterClassI11NavMeshDataEvv, __ZN7mecanim5human5Human8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim5human5Human8TransferI14SafeBinaryReadEEvRT_, __ZN15UniformTFMethodD2Ev: __ZN15UniformTFMethodD2Ev, __ZN20HardwareInfoReporter12CleanupClassEv: __ZN20HardwareInfoReporter12CleanupClassEv, __Z41Register_UnityEngine_Rigidbody2D_set_dragv: __Z41Register_UnityEngine_Rigidbody2D_set_dragv, _ps_hints_done: _ps_hints_done, __ZN9LensFlare23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9LensFlare23VirtualRedirectTransferER17RemapPPtrTransfer, _UNITY_png_colorspace_check_xy: _UNITY_png_colorspace_check_xy, __Z22GetFolderSizeRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z22GetFolderSizeRecursiveRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZL7StbFreePvS_: __ZL7StbFreePvS_, __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_: __ZN5physx2GuL17calculateContactsERKNS_6shdfnd3aos6FloatVES5_PNS2_5Vec3VERKS6_S9_PNS0_17PersistentContactERjS5_, __ZNK9AudioClip8GetMovieEv: __ZNK9AudioClip8GetMovieEv, __ZNK5physx21PxsBodyTransformVault17isInVaultInternalERKNS_11PxsBodyCoreE: __ZNK5physx21PxsBodyTransformVault17isInVaultInternalERKNS_11PxsBodyCoreE, __Z53ParticleSystem_ExternalForcesModule_CUSTOM_GetEnabledP12Il2CppObject: __Z53ParticleSystem_ExternalForcesModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN10Effector2D15SetColliderMaskEi: __ZN10Effector2D15SetColliderMaskEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN23iPhoneLocalNotification11SetTimeZoneEPKc: __ZN23iPhoneLocalNotification11SetTimeZoneEPKc, __Z63Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeIndexBufferPtrv: __Z63Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeIndexBufferPtrv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPcEEE4typeENSB_IS8_EESA_SA_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertIPKcEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorISA_EE5valueENS_11__wrap_iterIPcEEE4typeENSB_IS8_EESA_SA_, __ZThn8_N12_GLOBAL__N_117ConnectionManagerD0Ev: __ZThn8_N12_GLOBAL__N_117ConnectionManagerD0Ev, __ZN13UpdateManager6UpdateEv: __ZN13UpdateManager6UpdateEv, _geteuid: _geteuid, __ZN27AnimationLayerMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN27AnimationLayerMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __Z44Register_UnityEngine_AudioListener_get_pausev: __Z44Register_UnityEngine_AudioListener_get_pausev, __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams8TransferI9JSONWriteEEvRT_: __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams8TransferI9JSONWriteEEvRT_, __ZN5physx6shdfnd12ellipseClampERKNS_6PxVec3ES3_: __ZN5physx6shdfnd12ellipseClampERKNS_6PxVec3ES3_, __ZNK9Texture2D16CountDataMipmapsEv: __ZNK9Texture2D16CountDataMipmapsEv, __ZNK9DebugGLES13ActiveTextureEv: __ZNK9DebugGLES13ActiveTextureEv, __ZNSt3__218__insertion_sort_3IRNS_6__lessIllEEPlEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIllEEPlEEvT0_S5_T_, __ZN11UnityEngine15CloudWebService16SessionContainer17RestoreEventQueueERK8UnityStrS4_Pvy: __ZN11UnityEngine15CloudWebService16SessionContainer17RestoreEventQueueERK8UnityStrS4_Pvy, __ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_: __ZNK26RenderDeferredObjectSorterclERK16RenderObjectDataS2_, __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats: __ZN15SHConstantCacheC2ER13BatchRendererR15RenderLoopStats, __ZNSt3__26vectorIP16BaseVideoTexture13stl_allocatorIS2_L18MemLabelIdentifier19ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP16BaseVideoTexture13stl_allocatorIS2_L18MemLabelIdentifier19ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE18getSleepAfterCountEv, __ZNSt3__28valarrayIjED2Ev: __ZNSt3__28valarrayIjED2Ev, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __Z6FormatPKcz: __Z6FormatPKcz, __ZN12GUIClipState9SetMatrixER10InputEventRK10Matrix4x4f: __ZN12GUIClipState9SetMatrixER10InputEventRK10Matrix4x4f, __Z53Register_UnityEngine_RectTransform_set_drivenByObjectv: __Z53Register_UnityEngine_RectTransform_set_drivenByObjectv, __ZN16b2PolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN16b2PolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN5physx5cloth9transformERKNS0_11PhaseConfigE: __ZN5physx5cloth9transformERKNS0_11PhaseConfigE, __ZThn8_NK5physx3Cct17CapsuleController21getHalfHeightInternalEv: __ZThn8_NK5physx3Cct17CapsuleController21getHalfHeightInternalEv, __Z31AudioSource_Set_Custom_PropMuteP12Il2CppObjecth: __Z31AudioSource_Set_Custom_PropMuteP12Il2CppObjecth, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj4EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj4EEERAT__Kc, __Z44ParticleAnimator_Get_Custom_PropAutodestructP12Il2CppObject: __Z44ParticleAnimator_Get_Custom_PropAutodestructP12Il2CppObject, __Z49EmitSerializationCommandsForLinearCollectionFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z40TerrainData_CUSTOM_RemoveDetailPrototypeP12Il2CppObjecti: __Z40TerrainData_CUSTOM_RemoveDetailPrototypeP12Il2CppObjecti, __ZN8LODGroup8TransferI14SafeBinaryReadEEvRT_: __ZN8LODGroup8TransferI14SafeBinaryReadEEvRT_, __ZN13GfxDeviceGLES17CaptureScreenshotEiiiiPh: __ZN13GfxDeviceGLES17CaptureScreenshotEiiiiPh, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14SafeBinaryRead21CleanupConverterTableEv: __ZN14SafeBinaryRead21CleanupConverterTableEv, __Z38Register_UnityEngine_Sprite_get_packedv: __Z38Register_UnityEngine_Sprite_get_packedv, __ZN5physx6shdfnd12ErrorHandlerC2Ev: __ZN5physx6shdfnd12ErrorHandlerC2Ev, __ZN5Umbra15OcclusionBufferC2Ev: __ZN5Umbra15OcclusionBufferC2Ev, __ZN14RenderSettings13SetFogDensityEf: __ZN14RenderSettings13SetFogDensityEf, __Z19GetDownloadProgressbjj: __Z19GetDownloadProgressbjj, __ZNK5physx9NpPhysics14getNbMaterialsEv: __ZNK5physx9NpPhysics14getNbMaterialsEv, __ZdlPvRK10MemLabelIdiPKci: __ZdlPvRK10MemLabelIdiPKci, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags, __ZNK14SerializedFile12GetHighestIDEv: __ZNK14SerializedFile12GetHighestIDEv, __ZN5Unity14CharacterJoint16SetLowTwistLimitERK14SoftJointLimit: __ZN5Unity14CharacterJoint16SetLowTwistLimitERK14SoftJointLimit, __ZNK5physx2Gu11HeightField22getConvexEdgeThresholdEv: __ZNK5physx2Gu11HeightField22getConvexEdgeThresholdEv, __ZN11TerrainData17MainThreadCleanupEv: __ZN11TerrainData17MainThreadCleanupEv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj15EEERAT__Kc, __Z40setPxSceneDescContactCorrelationDistancePN5physx11PxSceneDescEf: __Z40setPxSceneDescContactCorrelationDistancePN5physx11PxSceneDescEf, __ZN4Mesh30InvalidateGpuSkinSourceBuffersEv: __ZN4Mesh30InvalidateGpuSkinSourceBuffersEv, __ZN11UnityEngine9Animation31GetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN11UnityEngine9Animation31GetHumanTransformPropertyValuesERKNS0_21AvatarBindingConstantERN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEE, __Z15CullLocalLightsR8JobFenceS0_RK22SceneCullingParametersRK13dynamic_arrayI8Vector4fLj4EERKS4_IiLj4EER9IndexListSD_RS4_IfLj4EERS4_I5RectTIfELj4EERS4_I13TargetEyeMaskLj4EEPPK5LightRK14ShadowCullData: __Z15CullLocalLightsR8JobFenceS0_RK22SceneCullingParametersRK13dynamic_arrayI8Vector4fLj4EERKS4_IiLj4EER9IndexListSD_RS4_IfLj4EERS4_I5RectTIfELj4EERS4_I13TargetEyeMaskLj4EEPPK5LightRK14ShadowCullData, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj73ENS_22PxRepXPropertyAccessorILj73ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj73ENS_22PxRepXPropertyAccessorILj73ES4_ffEEEEvRKT0_, __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_: __ZNSt3__27__sort4IRPFbRK16BlendShapeVertexS3_EPS1_EEjT0_S8_S8_S8_T_, __ZN15dtPathQueryInfo3setEyyPKfS1_PK14dtNavMeshQuery: __ZN15dtPathQueryInfo3setEyyPKfS1_PK14dtNavMeshQuery, __Z46Register_UnityEngine_Light_set_shadowNearPlanev: __Z46Register_UnityEngine_Light_set_shadowNearPlanev, _unzGetGlobalInfo: _unzGetGlobalInfo, __ZNK16ParticleRenderer22AdjustBoundsForStretchERK15ParticleEmitterR10MinMaxAABB: __ZNK16ParticleRenderer22AdjustBoundsForStretchERK15ParticleEmitterR10MinMaxAABB, __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMaxP12Il2CppObjectRK13Vector2fIcall: __Z43RectTransform_CUSTOM_INTERNAL_set_anchorMaxP12Il2CppObjectRK13Vector2fIcall, __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI11KeyframeTplIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId, __ZN10VertexData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10VertexData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN18UnityConnectClient27OnPlayerSessionStateChangedEjyy: __ZN18UnityConnectClient27OnPlayerSessionStateChangedEjyy, __ZN11UnityEngine9Analytics16TransactionEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine9Analytics16TransactionEvent12ToJsonStringER9JSONWrite, __Z21Transform_CUSTOM_FindP12Il2CppObjectP12Il2CppString: __Z21Transform_CUSTOM_FindP12Il2CppObjectP12Il2CppString, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteNullEv: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE9WriteNullEv, __ZN15GUIEventManager18RemoveEventAtIndexEi: __ZN15GUIEventManager18RemoveEventAtIndexEi, __ZN8VRDevice22SetDidPauseApplicationEb: __ZN8VRDevice22SetDidPauseApplicationEb, __ZNK23TransformChangeDispatch37AssertUnnecessaryTransformHierarchiesEv: __ZNK23TransformChangeDispatch37AssertUnnecessaryTransformHierarchiesEv, __ZNK13TextRendering4Font10GetTextureEv: __ZNK13TextRendering4Font10GetTextureEv, __Z64AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveIDR9HPlayablei: __Z64AnimatorControllerPlayable_CUSTOM_IsParameterControlledByCurveIDR9HPlayablei, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15createParticlesERKNS_22PxParticleCreationDataE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15createParticlesERKNS_22PxParticleCreationDataE, __ZN28LightProbeProxyVolumeManagerC2Ev: __ZN28LightProbeProxyVolumeManagerC2Ev, __ZNK27UnloadUnusedAssetsOperation25GetAllowParallelExecutionEv: __ZNK27UnloadUnusedAssetsOperation25GetAllowParallelExecutionEv, __Z52Register_UnityEngine_RenderTexture_Internal_SetWidthv: __Z52Register_UnityEngine_RenderTexture_Internal_SetWidthv, __Z32Transform_CUSTOM_SetSiblingIndexP12Il2CppObjecti: __Z32Transform_CUSTOM_SetSiblingIndexP12Il2CppObjecti, __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11Quaternionf8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z54Register_UnityEngine_Renderer_get_reflectionProbeUsagev: __Z54Register_UnityEngine_Renderer_get_reflectionProbeUsagev, __ZN20SphericalHarmonicsL28TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20SphericalHarmonicsL28TransferI24GenerateTypeTreeTransferEEvRT_, __Z43TerrainData_Set_Custom_PropDetailPrototypesP12Il2CppObjectP11Il2CppArray: __Z43TerrainData_Set_Custom_PropDetailPrototypesP12Il2CppObjectP11Il2CppArray, __ZN11delayed_setI4PPtrI10GUIElementENSt3__23setIS2_NS3_4lessIS2_EE11memory_poolIS2_EEEE13apply_delayedEv: __ZN11delayed_setI4PPtrI10GUIElementENSt3__23setIS2_NS3_4lessIS2_EE11memory_poolIS2_EEEE13apply_delayedEv, __Z42getPxClothStretchConfigStiffnessMultiplierPKN5physx20PxClothStretchConfigE: __Z42getPxClothStretchConfigStiffnessMultiplierPKN5physx20PxClothStretchConfigE, __Z44Register_UnityEngine_CanvasRenderer_GetAlphav: __Z44Register_UnityEngine_CanvasRenderer_GetAlphav, __ZN14CachingManager5ResetEv: __ZN14CachingManager5ResetEv, __ZN8TToArray5IndexIfEERfRT_i: __ZN8TToArray5IndexIfEERfRT_i, __Z43Collider2D_Get_Custom_PropAttachedRigidbodyP12Il2CppObject: __Z43Collider2D_Get_Custom_PropAttachedRigidbodyP12Il2CppObject, __ZN26LightProbeProxyVolumeUtilsL28ComputeGlobalAABBOnHierarchyER9TransformR10MinMaxAABB: __ZN26LightProbeProxyVolumeUtilsL28ComputeGlobalAABBOnHierarchyER9TransformR10MinMaxAABB, __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE5eraseENS_16__deque_iteratorIS1_PKS1_RS6_PKS7_iLi0EEE: __ZNSt3__25dequeI10InputEventNS_9allocatorIS1_EEE5eraseENS_16__deque_iteratorIS1_PKS1_RS6_PKS7_iLi0EEE, __Z43Register_UnityEngine_SpringJoint_set_springv: __Z43Register_UnityEngine_SpringJoint_set_springv, __Z48Register_UnityEngine_CircleCollider2D_set_radiusv: __Z48Register_UnityEngine_CircleCollider2D_set_radiusv, __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32: __Z13ReadPixelImplPKh13TextureFormatR11ColorRGBA32, __ZNK5physx16PxsBroadPhaseMBP21getOutOfBoundsObjectsEv: __ZNK5physx16PxsBroadPhaseMBP21getOutOfBoundsObjectsEv, __Z18GetGUIEventManagerv: __Z18GetGUIEventManagerv, __Z37AudioReverbZone_Set_Custom_PropReverbP12Il2CppObjecti: __Z37AudioReverbZone_Set_Custom_PropReverbP12Il2CppObjecti, __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_SetStartDelayMultiplierv, __ZN18ProceduralMaterial15UpdateAnimationEf: __ZN18ProceduralMaterial15UpdateAnimationEf, __ZN5physx7Cooking7releaseEv: __ZN5physx7Cooking7releaseEv, __ZN22ParticleSystemRenderer16CheckConsistencyEv: __ZN22ParticleSystemRenderer16CheckConsistencyEv, __ZN17BufferManagerGLESD2Ev: __ZN17BufferManagerGLESD2Ev, __ZN8Material10GetDefaultEv: __ZN8Material10GetDefaultEv, __ZN12HingeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12HingeJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z20GetAccelerationCountv: __Z20GetAccelerationCountv, __ZN12HandlerChain19InitializeFileEntryER13FileEntryData: __ZN12HandlerChain19InitializeFileEntryER13FileEntryData, __Z46Camera_CUSTOM_INTERNAL_CALL_ResetCullingMatrixP12Il2CppObject: __Z46Camera_CUSTOM_INTERNAL_CALL_ResetCullingMatrixP12Il2CppObject, __Z46Register_UnityEngine_Transform_GetSiblingIndexv: __Z46Register_UnityEngine_Transform_GetSiblingIndexv, __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId: __ZN19AtomicPageAllocatorC2EPKcRK10MemLabelId, __ZN17SurfaceEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE: __ZN17SurfaceEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE, __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19SpriteMeshGenerator12path_segmentENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN20ArchiveStorageReader9ReadBlockEjyyPvPy: __ZN20ArchiveStorageReader9ReadBlockEjyyPvPy, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20TextRenderingPrivate13GetLoadTargetEii: __ZN20TextRenderingPrivate13GetLoadTargetEii, __ZNSt3__219__shared_weak_count14__release_weakEv: __ZNSt3__219__shared_weak_count14__release_weakEv, __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI8MaterialE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z13RegisterClassI8AnimatorEvv: __Z13RegisterClassI8AnimatorEvv, __ZNKSt3__220__time_get_c_storageIcE7__weeksEv: __ZNKSt3__220__time_get_c_storageIcE7__weeksEv, __GLOBAL__sub_I_SwInterCollision_cpp: __GLOBAL__sub_I_SwInterCollision_cpp, __ZNK9Heightmap20CalculateNormalSobelEii: __ZNK9Heightmap20CalculateNormalSobelEii, __ZL22GeomMTDCallback_BoxBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL22GeomMTDCallback_BoxBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN4FMOD5Sound16getNumSyncPointsEPi: __ZN4FMOD5Sound16getNumSyncPointsEPi, __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim8skeleton8Skeleton8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20TextRenderingPrivate19NativeTextGenerator11SetMeshDataERNS_17TextMeshGeneratorE: __ZN20TextRenderingPrivate19NativeTextGenerator11SetMeshDataERNS_17TextMeshGeneratorE, __ZN5physx18ReducedVertexCloudC2EPKNS_6PxVec3Ej: __ZN5physx18ReducedVertexCloudC2EPKNS_6PxVec3Ej, __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_: __ZN15SerializeTraitsI14ConstantStringE8TransferI19StreamedBinaryWriteILb0EEEEvRS0_RT_, __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj: __ZN21TerrainIndexGenerator22GetOptimizedIndexStripEiRj, __ZN12GUIClipState15LoadPixelMatrixEffffRK10Matrix4x4f: __ZN12GUIClipState15LoadPixelMatrixEffffRK10Matrix4x4f, __ZN5physx13NpClothFabric16scaleRestlengthsEf: __ZN5physx13NpClothFabric16scaleRestlengthsEf, __ZN15ApplicationInfo19GetBundleIdentifierEv: __ZN15ApplicationInfo19GetBundleIdentifierEv, __ZN4FMOD5Sound9getLengthEPjj: __ZN4FMOD5Sound9getLengthEPjj, __ZN14Texture2DArray19UnloadFromGfxDeviceEb: __ZN14Texture2DArray19UnloadFromGfxDeviceEb, __ZNK5physx3Ext13DistanceJoint11getDistanceEv: __ZNK5physx3Ext13DistanceJoint11getDistanceEv, __Z44UnityWebRequest_Get_Custom_PropUploadedBytesP12Il2CppObject: __Z44UnityWebRequest_Get_Custom_PropUploadedBytesP12Il2CppObject, __Z41Register_UnityEngine_Rigidbody2D_set_massv: __Z41Register_UnityEngine_Rigidbody2D_set_massv, __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Multiplev: __Z69Register_UnityEngine_Rendering_CommandBuffer_SetRenderTarget_Multiplev, __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetColorv: __Z68Register_UnityEngine_ParticleSystem_ColorOverLifetimeModule_GetColorv, __ZN7mecanim9animation19DestroyAvatarOutputEPNS0_12AvatarOutputERNS_6memory9AllocatorE: __ZN7mecanim9animation19DestroyAvatarOutputEPNS0_12AvatarOutputERNS_6memory9AllocatorE, __Z42LODGroup_Set_Custom_PropAnimateCrossFadingP12Il2CppObjecth: __Z42LODGroup_Set_Custom_PropAnimateCrossFadingP12Il2CppObjecth, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERPKc: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERPKc, __ZN12_GLOBAL__N_112UserRenderer21visualizeAngularLimitERKN5physx11PxTransformEffb: __ZN12_GLOBAL__N_112UserRenderer21visualizeAngularLimitERKN5physx11PxTransformEffb, __ZN5Cache20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN5Cache20DidUnloadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_: __ZNSt3__26__treeINS_12__value_typeIjP25SubstanceRawTextureSharedEENS_19__map_value_compareIjS4_NS_4lessIjEELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier77ELi16EEE12__find_equalIjEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_SF_EEiEESI_RKT_, __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi: __ZN9Scripting34GetScriptingArrayObjectElementImplEP11Il2CppArrayi, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxShapeEE12readPropertyIfEEbRT_, __ZN12MeshCollider14SetInflateMeshEb: __ZN12MeshCollider14SetInflateMeshEb, __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_: __ZN14MinMaxGradient8TransferI14SafeBinaryReadEEvRT_, __Z34RectOffset_Get_Custom_PropVerticalP12Il2CppObject: __Z34RectOffset_Get_Custom_PropVerticalP12Il2CppObject, __ZN14BillboardAsset8TransferI14SafeBinaryReadEEvRT_: __ZN14BillboardAsset8TransferI14SafeBinaryReadEEvRT_, __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx24PxParticleRepXSerializerINS_16PxParticleSystemEEC2ERNS_19PxAllocatorCallbackE, __Z43Register_UnityEngine_Input_GetMouseButtonUpv: __Z43Register_UnityEngine_Input_GetMouseButtonUpv, __ZN5physx12MemoryBufferD0Ev: __ZN5physx12MemoryBufferD0Ev, __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleAllv: __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCircleAllv, __Z35Animation_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject: __Z35Animation_CUSTOM_INTERNAL_CALL_StopP12Il2CppObject, __ZNK6Object20GetRuntimeMemorySizeEv: __ZNK6Object20GetRuntimeMemorySizeEv, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47Register_UnityEngine_CapsuleCollider_set_heightv: __Z47Register_UnityEngine_CapsuleCollider_set_heightv, __Z47Register_UnityEngine_GUIText_INTERNAL_set_colorv: __Z47Register_UnityEngine_GUIText_INTERNAL_set_colorv, __Z69SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddDirectionalLightInternalRK8Vector3fRK10ColorRGBAfR20SphericalHarmonicsL2: __Z69SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_AddDirectionalLightInternalRK8Vector3fRK10ColorRGBAfR20SphericalHarmonicsL2, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_set_backgroundColorv: __Z65Register_UnityEngine_ReflectionProbe_INTERNAL_set_backgroundColorv, __ZN4PPtrI5LightE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI5LightE8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx2Sc9ClothCore23getSelfCollisionIndicesEPj: __ZNK5physx2Sc9ClothCore23getSelfCollisionIndicesEPj, __ZN8DrawUtil28DrawLineOrTrailFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi: __ZN8DrawUtil28DrawLineOrTrailFromNodeQueueERK15RenderNodeQueuejRK14ChannelAssignsi, __ZN5physx2Sc8BodyCore18addSpatialVelocityEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_: __ZN5physx2Sc8BodyCore18addSpatialVelocityEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEEPKNS_6PxVec3ESB_, __ZN5Umbra15GateStateVector8setStateEib: __ZN5Umbra15GateStateVector8setStateEib, __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE: __ZNK5Umbra7ImpTome22getClusterPortalCenterERKNS_6PortalE, __ZN26AnimatorOverrideController21SetAnimatorControllerE4PPtrI25RuntimeAnimatorControllerE: __ZN26AnimatorOverrideController21SetAnimatorControllerE4PPtrI25RuntimeAnimatorControllerE, __Z36Application_CUSTOM_CaptureScreenshotP12Il2CppStringi: __Z36Application_CUSTOM_CaptureScreenshotP12Il2CppStringi, _UNITY_LZ4_decompress_fast_continue: _UNITY_LZ4_decompress_fast_continue, __ZN2UI14CanvasRenderer19SetPopMaterialCountEi: __ZN2UI14CanvasRenderer19SetPopMaterialCountEi, __ZNK6Shader24GetSubShaderWithTagValueEii: __ZNK6Shader24GetSubShaderWithTagValueEii, __Z47Register_UnityEngine_CanvasRenderer_GetMaterialv: __Z47Register_UnityEngine_CanvasRenderer_GetMaterialv, __ZL20outputConvexToStreamPN5physx7PxShapeEPKNS_12PxRigidActorERKNS_11PxTransformERNS_6shdfnd5ArrayIjNS8_19ReflectionAllocatorIjEEEERNS9_INS_10PxTriangleENSA_ISE_EEEESD_RKNS_14PxExtendedVec3ERKNS_9PxBounds3ERKNS_3Cct9CCTParamsEPNS_2Cm12RenderBufferERt: __ZL20outputConvexToStreamPN5physx7PxShapeEPKNS_12PxRigidActorERKNS_11PxTransformERNS_6shdfnd5ArrayIjNS8_19ReflectionAllocatorIjEEEERNS9_INS_10PxTriangleENSA_ISE_EEEESD_RKNS_14PxExtendedVec3ERKNS_9PxBounds3ERKNS_3Cct9CCTParamsEPNS_2Cm12RenderBufferERt, __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb: __Z48ResetAndApplyDefaultReferencesOnNewMonoBehaviourR13MonoBehaviourb, __ZN2UI13CanvasManager34EmitWorldScreenspaceCameraGeometryENS0_10CameraTypeE: __ZN2UI13CanvasManager34EmitWorldScreenspaceCameraGeometryENS0_10CameraTypeE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj458ES3_RKNS_22PxJointLinearLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj458ES3_RKNS_22PxJointLinearLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_xDriveP12Il2CppObjectRK10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_xDriveP12Il2CppObjectRK10JointDrive, __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE15set_deleted_keyERSG_: __ZN14dense_hash_mapINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundle11djb2_hash_tIS7_ENS0_8equal_toIS7_EENS0_9allocatorINS0_4pairIKS7_S9_EEEEE15set_deleted_keyERSG_, __ZN21LightProbeProxyVolume21GetWorldToLocalMatrixEv: __ZN21LightProbeProxyVolume21GetWorldToLocalMatrixEv, __Z38SpringJoint_Set_Custom_PropMaxDistanceP12Il2CppObjectf: __Z38SpringJoint_Set_Custom_PropMaxDistanceP12Il2CppObjectf, __Z27GetEnabledNotificationTypesv: __Z27GetEnabledNotificationTypesv, __ZN5physx2Sn5ConvX13setReportModeENS_21PxConverterReportMode4EnumE: __ZN5physx2Sn5ConvX13setReportModeENS_21PxConverterReportMode4EnumE, __ZN4FMOD6SoundI7setModeEj: __ZN4FMOD6SoundI7setModeEj, __Z40TrailRenderer_Get_Custom_PropTextureModeP12Il2CppObject: __Z40TrailRenderer_Get_Custom_PropTextureModeP12Il2CppObject, __ZN10SampleClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10SampleClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __Z46Register_UnityEngine_LightProbes_get_positionsv: __Z46Register_UnityEngine_LightProbes_get_positionsv, __ZN23SharedMeshRenderingData17CreateIndexBufferEv: __ZN23SharedMeshRenderingData17CreateIndexBufferEv, __Z37FixedJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf: __Z37FixedJoint2D_Set_Custom_PropFrequencyP12Il2CppObjectf, __ZN5physx18NpArticulationLink14visualizeJointERNS_22PxConstraintVisualizerE: __ZN5physx18NpArticulationLink14visualizeJointERNS_22PxConstraintVisualizerE, __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE6resizeEjRKi: __ZN5physx6shdfnd5ArrayIiNS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIiEEEEE6resizeEjRKi, __ZN23iPhoneLocalNotification6CancelEv: __ZN23iPhoneLocalNotification6CancelEv, __ZN13SplatDatabase8TransferI14SafeBinaryReadEEvRT_: __ZN13SplatDatabase8TransferI14SafeBinaryReadEEvRT_, __Z53Register_UnityEngine_Cloth_get_useContinuousCollisionv: __Z53Register_UnityEngine_Cloth_get_useContinuousCollisionv, __ZN13RendererScene12CleanupUmbraEv: __ZN13RendererScene12CleanupUmbraEv, __ZNK9WWWCached17IsDownloadingDoneEv: __ZNK9WWWCached17IsDownloadingDoneEv, __ZN10GameObject5ResetEv: __ZN10GameObject5ResetEv, __ZN11TerrainData23VirtualRedirectTransferER14SafeBinaryRead: __ZN11TerrainData23VirtualRedirectTransferER14SafeBinaryRead, __ZN17AnimationCurveTplI11QuaternionfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17AnimationCurveTplI11QuaternionfE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK16LightmapSettings14GetLightProbesEv: __ZNK16LightmapSettings14GetLightProbesEv, __ZNSt3__25stollERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji: __ZNSt3__25stollERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji, __ZN12_GLOBAL__N_19MyFastXml7releaseEv: __ZN12_GLOBAL__N_19MyFastXml7releaseEv, __ZN5physx7profile32PxProfileMemoryEventRecorderImpl12onAllocationEjPKcS3_iPv: __ZN5physx7profile32PxProfileMemoryEventRecorderImpl12onAllocationEjPKcS3_iPv, __Z45SceneManager_CUSTOM_INTERNAL_CALL_CreateSceneP12Il2CppStringRi: __Z45SceneManager_CUSTOM_INTERNAL_CALL_CreateSceneP12Il2CppStringRi, __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4ERKNS_7Vector3ES5_: __ZN5Umbra11ShadowUtils18getOrthoProjectionERNS_9Matrix4x4ERKNS_7Vector3ES5_, __ZN5physx6shdfnd10ThreadImpl18getNbPhysicalCoresEv: __ZN5physx6shdfnd10ThreadImpl18getNbPhysicalCoresEv, __ZNSt3__210__stdinbufIwE9pbackfailEj: __ZNSt3__210__stdinbufIwE9pbackfailEj, __ZNK5physx14NpRigidDynamic17getSleepThresholdEv: __ZNK5physx14NpRigidDynamic17getSleepThresholdEv, __ZN4FMOD6SoundI18set3DCustomRolloffEP11FMOD_VECTORi: __ZN4FMOD6SoundI18set3DCustomRolloffEP11FMOD_VECTORi, __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12ConstantClipEi: __ZN7mecanim9animation17SampleClipAtIndexERKNS0_12ConstantClipEi, __Z50Register_UnityEngine_ReflectionProbe_set_intensityv: __Z50Register_UnityEngine_ReflectionProbe_set_intensityv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI9TransformELj4EEEEvRT_17TransferMetaFlags, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getMotionConstraintScaleEv, __ZN6Camera22RenderHaloAndLensFlareEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f: __ZN6Camera22RenderHaloAndLensFlareEPK11CullResultsR17ShaderPassContextRK10Matrix4x4f, _tlsf_memalign: _tlsf_memalign, __ZNK5Unity9Component26GetTypeInfoVirtualInternalEv: __ZNK5Unity9Component26GetTypeInfoVirtualInternalEv, __ZNK20TextRenderingPrivate8FontImpl10IsRectFreeERKNS0_7IntRectE: __ZNK20TextRenderingPrivate8FontImpl10IsRectFreeERKNS0_7IntRectE, __Z41Register_UnityEngine_Rigidbody2D_get_massv: __Z41Register_UnityEngine_Rigidbody2D_get_massv, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvPKjtPKtj: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fE16collideParticlesILb0EEEvPKjtPKtj, __ZNK13RendererScene22GetStaticBoundingBoxesEv: __ZNK13RendererScene22GetStaticBoundingBoxesEv, __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue11ResetValuesEv: __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue11ResetValuesEv, __Z21GetUnityConnectClientv: __Z21GetUnityConnectClientv, __ZN8LODGroup23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8LODGroup23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN12SocketStream8ShutdownEv: __ZN12SocketStream8ShutdownEv, __Z27setPxD6JointDriveForceLimitPN5physx14PxD6JointDriveEf: __Z27setPxD6JointDriveForceLimitPN5physx14PxD6JointDriveEf, __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN26b2PolygonAndCapsuleContactD0Ev: __ZN26b2PolygonAndCapsuleContactD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __ZN8GUIState13MoveAllDataToERS_b: __ZN8GUIState13MoveAllDataToERS_b, __ZN9ShaderLab9IntShader23CreateStateBlocksForKeyEjPK19ShaderPropertySheetS3_: __ZN9ShaderLab9IntShader23CreateStateBlocksForKeyEjPK19ShaderPropertySheetS3_, __ZN4crnd28crnd_get_segmented_file_sizeEPKvj: __ZN4crnd28crnd_get_segmented_file_sizeEPKvj, __Z34GetMinimumTextureMipWidthForFormat13TextureFormat: __Z34GetMinimumTextureMipWidthForFormat13TextureFormat, __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt32v: __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt32v, __Z51Register_UnityEngine_RuntimeUndo_SetTransformParentv: __Z51Register_UnityEngine_RuntimeUndo_SetTransformParentv, __Z58Register_UnityEngine_ParticleSystemRenderer_set_renderModev: __Z58Register_UnityEngine_ParticleSystemRenderer_set_renderModev, __ZNK5Unity10HingeJoint16GetClampedLimitsERfS1_: __ZNK5Unity10HingeJoint16GetClampedLimitsERfS1_, __ZN5Unity9Component23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity9Component23VirtualRedirectTransferER14SafeBinaryRead, __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab16SerializedTagMap8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7releaseEv: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE7releaseEv, __Z61Register_UnityEngine_ParticleSystem_TrailModule_GetWorldSpacev: __Z61Register_UnityEngine_ParticleSystem_TrailModule_GetWorldSpacev, ___fbufsize: ___fbufsize, __ZNK14PlayerSettings18GetSubmitAnalyticsEv: __ZNK14PlayerSettings18GetSubmitAnalyticsEv, __ZN5physx2Sc7BodySim30notifyClearSpatialAccelerationEv: __ZN5physx2Sc7BodySim30notifyClearSpatialAccelerationEv, __Z37Register_UnityEngine_Debug_DebugBreakv: __Z37Register_UnityEngine_Debug_DebugBreakv, __ZN14ParticleSystem13SetUses3DSizeEv: __ZN14ParticleSystem13SetUses3DSizeEv, __ZNK11NoiseModule12PreviewNoiseILi2EEEvP9Texture2DP10ColorRGBAf: __ZNK11NoiseModule12PreviewNoiseILi2EEEvP9Texture2DP10ColorRGBAf, __Z62Register_UnityEngine_QualitySettings_set_asyncUploadBufferSizev: __Z62Register_UnityEngine_QualitySettings_set_asyncUploadBufferSizev, __Z31Light_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z31Light_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, __Z57Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionNonAllocRK3RayP11Il2CppArrayfi: __Z57Physics2D_CUSTOM_INTERNAL_CALL_GetRayIntersectionNonAllocRK3RayP11Il2CppArrayfi, __Z50Register_UnityEngine_Terrain_set_editorRenderFlagsv: __Z50Register_UnityEngine_Terrain_set_editorRenderFlagsv, _UNITY_png_longjmp: _UNITY_png_longjmp, __ZN5physx6shdfnd7FastIPC18receiveAcknowledgeEv: __ZN5physx6shdfnd7FastIPC18receiveAcknowledgeEv, __ZN5Cache10CleanCacheEv: __ZN5Cache10CleanCacheEv, __ZN9allocutil14BuddyAllocatorD2Ev: __ZN9allocutil14BuddyAllocatorD2Ev, __ZN15ParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15ParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN9LensFlare8SetFlareEP5Flare: __ZN9LensFlare8SetFlareEP5Flare, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7setMassEf: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE7setMassEf, _bcmp: _bcmp, __ZN5Umbra14TomeCollection15findPortalIndexEiRiS1_: __ZN5Umbra14TomeCollection15findPortalIndexEiRiS1_, __ZN23iPhoneLocalNotification19SetAlertLaunchImageEPKc: __ZN23iPhoneLocalNotification19SetAlertLaunchImageEPKc, __Z26NavMesh_CUSTOM_GetAreaCosti: __Z26NavMesh_CUSTOM_GetAreaCosti, __ZN5physx11NpAggregateD2Ev: __ZN5physx11NpAggregateD2Ev, __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE: __ZN5physx6shdfnd10ThreadImpl5startEjPNS0_8RunnableE, __ZN12_GLOBAL__N_110DataStream19endSetPropertyValueEv: __ZN12_GLOBAL__N_110DataStream19endSetPropertyValueEv, __Z18GetSurfaceTexelPtrR13CImageSurfaceii: __Z18GetSurfaceTexelPtrR13CImageSurfaceii, __Z51Register_UnityEngine_Caching_set_compressionEnabledv: __Z51Register_UnityEngine_Caching_set_compressionEnabledv, __ZN5Umbra9BitVector4_xorERKS0_: __ZN5Umbra9BitVector4_xorERKS0_, __Z41Register_UnityEngine_CanvasRenderer_Clearv: __Z41Register_UnityEngine_CanvasRenderer_Clearv, __ZN5physx22PxVehicleWheelsSimData12disableWheelEj: __ZN5physx22PxVehicleWheelsSimData12disableWheelEj, __ZN5physx2Sn12RepXUpgrader34upgrade10CollectionTo3_1CollectionERNS0_14RepXCollectionE: __ZN5physx2Sn12RepXUpgrader34upgrade10CollectionTo3_1CollectionERNS0_14RepXCollectionE, __Z44SystemInfo_Get_Custom_PropSupports3DTexturesv: __Z44SystemInfo_Get_Custom_PropSupports3DTexturesv, __Z43ParticleSystem_ShapeModule_CUSTOM_SetRadiusP12Il2CppObjectf: __Z43ParticleSystem_ShapeModule_CUSTOM_SetRadiusP12Il2CppObjectf, __ZN12_GLOBAL__N_113ClassDescImplD0Ev: __ZN12_GLOBAL__N_113ClassDescImplD0Ev, __ZN15b2ContactSolver27SolveTOIPositionConstraintsEii: __ZN15b2ContactSolver27SolveTOIPositionConstraintsEii, __ZN5physx6shdfnd5ArrayIPNS_5cloth8SwFabricENS0_9AllocatorEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_5cloth8SwFabricENS0_9AllocatorEE15growAndPushBackERKS4_, __ZN14DetailDatabase17RefreshPrototypesEv: __ZN14DetailDatabase17RefreshPrototypesEv, __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu8CapsuleVENS1_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __Z29scripting_class_has_attributeP11Il2CppClassS0_: __Z29scripting_class_has_attributeP11Il2CppClassS0_, __ZN18BuoyancyEffector2DC2E10MemLabelId18ObjectCreationMode: __ZN18BuoyancyEffector2DC2E10MemLabelId18ObjectCreationMode, _fgetln: _fgetln, __ZNK5physx27PxDefaultMemoryOutputStream7getDataEv: __ZNK5physx27PxDefaultMemoryOutputStream7getDataEv, __ZN10SampleClip15AllocateChannelEby: __ZN10SampleClip15AllocateChannelEby, __Z64Register_UnityEngine_AnimatorOverrideController_Internal_SetClipv: __Z64Register_UnityEngine_AnimatorOverrideController_Internal_SetClipv, __ZN20BufferedSocketStreamD2Ev: __ZN20BufferedSocketStreamD2Ev, __ZN5physx6shdfnd7PAUtilsD2Ev: __ZN5physx6shdfnd7PAUtilsD2Ev, __ZN14SharedMeshDataD0Ev: __ZN14SharedMeshDataD0Ev, __Z32getPxSceneDescBroadPhaseCallbackPKN5physx11PxSceneDescE: __Z32getPxSceneDescBroadPhaseCallbackPKN5physx11PxSceneDescE, __Z50Camera_CUSTOM_INTERNAL_CALL_CalculateObliqueMatrixP12Il2CppObjectRK8Vector4fR10Matrix4x4f: __Z50Camera_CUSTOM_INTERNAL_CALL_CalculateObliqueMatrixP12Il2CppObjectRK8Vector4fR10Matrix4x4f, __Z27Animation_CUSTOM_PlayQueuedP12Il2CppObjectP12Il2CppStringii: __Z27Animation_CUSTOM_PlayQueuedP12Il2CppObjectP12Il2CppStringii, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE15reserveInternalEj, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__XEv, __ZN14dtPathCorridor12setStateFlagEbh: __ZN14dtPathCorridor12setStateFlagEbh, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj175ENS_22PxRepXPropertyAccessorILj175ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN12CubemapArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12CubemapArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE: __ZL20createInvisibleWallsRKN5physx3Cct9CCTParamsERKNS_10PxTriangleERNS_6shdfnd5ArrayIS4_NS7_19ReflectionAllocatorIS4_EEEERNS8_IjNS9_IjEEEE, __ZNK5physx2Sc9ClothCore24getLinearDragCoefficientEv: __ZNK5physx2Sc9ClothCore24getLinearDragCoefficientEv, __ZN23SharedMeshRenderingDataD2Ev: __ZN23SharedMeshRenderingDataD2Ev, __Z18Transfer_BlittableI14SafeBinaryReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL20AccumulateContinuousRK11MinMaxCurveffff: __ZL20AccumulateContinuousRK11MinMaxCurveffff, __Z48Register_UnityEngine_Application_get_isBatchmodev: __Z48Register_UnityEngine_Application_get_isBatchmodev, __ZN13RenderTexture13AwakeFromLoadE17AwakeFromLoadMode: __ZN13RenderTexture13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx8debugger14PvdMarshallingIidE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIidE12marshalBlockEPKhPhj, __ZN9Texture2D24AcquireSharedTextureDataEv: __ZN9Texture2D24AcquireSharedTextureDataEv, __ZN5physx2Sc19ParticlePacketShapeD0Ev: __ZN5physx2Sc19ParticlePacketShapeD0Ev, __ZN16PlayerConnectionD0Ev: __ZN16PlayerConnectionD0Ev, __ZNSt3__227__insertion_sort_incompleteIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEbT0_S6_T_, __ZNK5physx2Gu12TriangleMesh20getTriangleMeshFlagsEv: __ZNK5physx2Gu12TriangleMesh20getTriangleMeshFlagsEv, __ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv: __ZNK5physx2Sc18ParticleSystemCore11getGridSizeEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapI8StateKey10StateRangeNSt3__24lessIS3_EENS5_9allocatorINS5_4pairIS3_S4_EEEEEEEvRT_17TransferMetaFlags, _nextafter: _nextafter, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx22PxSimulationStatisticsC2Ev: __ZN5physx22PxSimulationStatisticsC2Ev, __Z37getPxVehicleSuspensionDataMSprungMassPKN5physx23PxVehicleSuspensionDataE: __Z37getPxVehicleSuspensionDataMSprungMassPKN5physx23PxVehicleSuspensionDataE, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __GLOBAL__sub_I_runtime_webrequest_downloadhandler_lump_cpp: __GLOBAL__sub_I_runtime_webrequest_downloadhandler_lump_cpp, __Z52Register_UnityEngine_AI_OffMeshLink_set_navMeshLayerv: __Z52Register_UnityEngine_AI_OffMeshLink_set_navMeshLayerv, ___udivmoddi4: ___udivmoddi4, __ZN13AnimationClip8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13AnimationClip8TransferI24GenerateTypeTreeTransferEEvRT_, __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev: __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev, __ZN4FMOD8ChannelI13setLoopPointsEjjjj: __ZN4FMOD8ChannelI13setLoopPointsEjjjj, __ZNSt3__23mapINS_4pairIKiS2_EEN2UI14DepthSortLayerENS_4lessIS3_EE13stl_allocatorINS1_IKS3_S5_EEL18MemLabelIdentifier1ELi16EEEixERS9_: __ZNSt3__23mapINS_4pairIKiS2_EEN2UI14DepthSortLayerENS_4lessIS3_EE13stl_allocatorINS1_IKS3_S5_EEL18MemLabelIdentifier1ELi16EEEixERS9_, __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugArcE: __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugArcE, __Z47Register_UnityEngine_FixedJoint2D_set_frequencyv: __Z47Register_UnityEngine_FixedJoint2D_set_frequencyv, __ZN9Animation17MainThreadCleanupEv: __ZN9Animation17MainThreadCleanupEv, __ZN8LODGroup22SetLocalReferencePointERK8Vector3f: __ZN8LODGroup22SetLocalReferencePointERK8Vector3f, __ZN5physx23PxsBroadPhaseContextSap11shiftOriginERKNS_6PxVec3E: __ZN5physx23PxsBroadPhaseContextSap11shiftOriginERKNS_6PxVec3E, __ZNK5physx14NpShapeManager15shapeIsAttachedERNS_7NpShapeE: __ZNK5physx14NpShapeManager15shapeIsAttachedERNS_7NpShapeE, __ZN13AudioListener23VirtualRedirectTransferER14SafeBinaryRead: __ZN13AudioListener23VirtualRedirectTransferER14SafeBinaryRead, __ZN26AnimatorOverrideController30PerformOverrideClipListCleanupEv: __ZN26AnimatorOverrideController30PerformOverrideClipListCleanupEv, __ZN19SkinnedMeshRenderer17PrepareSkinCustomERK10Matrix4x4f: __ZN19SkinnedMeshRenderer17PrepareSkinCustomERK10Matrix4x4f, _UNITY_png_gamma_significant: _UNITY_png_gamma_significant, __ZN4FMOD5Sound15getNumSubSoundsEPi: __ZN4FMOD5Sound15getNumSubSoundsEPi, __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetDieWithParticlesv: __Z67Register_UnityEngine_ParticleSystem_TrailModule_SetDieWithParticlesv, __Z49Register_UnityEngine_Renderer_get_sharedMaterialsv: __Z49Register_UnityEngine_Renderer_get_sharedMaterialsv, __ZThn4_N12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_: __ZThn4_N12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_, __ZN5physx22NbTriggerPairsPropertyC2Ev: __ZN5physx22NbTriggerPairsPropertyC2Ev, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __ZN33AssetBundleLoadFromAsyncOperation21InitializeAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN33AssetBundleLoadFromAsyncOperation21InitializeAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN9ShaderLab21SerializedBindChannel8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab21SerializedBindChannel8TransferI14SafeBinaryReadEEvRT_, __ZN15QualitySettingsD2Ev: __ZN15QualitySettingsD2Ev, __Z54Register_UnityEngine_GUIStyle_Internal_CalcMinMaxWidthv: __Z54Register_UnityEngine_GUIStyle_Internal_CalcMinMaxWidthv, __ZThn32_N12LineRendererD0Ev: __ZThn32_N12LineRendererD0Ev, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getRelativeTransformEv, __ZN13SliderJoint2D11SetUseMotorEb: __ZN13SliderJoint2D11SetUseMotorEb, __ZN9BlobWrite8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags, __ZN7mecanim9animation29GetWeightsFreeformDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb: __ZN7mecanim9animation29GetWeightsFreeformDirectionalERKNS0_19Blend2dDataConstantEPfPiP8Vector2fffb, __Z58Register_UnityEngine_LightProbeProxyVolume_set_refreshModev: __Z58Register_UnityEngine_LightProbeProxyVolume_set_refreshModev, __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z54ParticleSystem_RotationBySpeedModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN13ConstantForceD0Ev: __ZN13ConstantForceD0Ev, __ZN9Rigidbody16UpdateSortedBodyEv: __ZN9Rigidbody16UpdateSortedBodyEv, __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE7reserveEj, __ZN5physx8debugger4comm16SetPropertyValueD0Ev: __ZN5physx8debugger4comm16SetPropertyValueD0Ev, __ZNK8VRDevice14GetFieldOfViewEv: __ZNK8VRDevice14GetFieldOfViewEv, __ZNK23TransformChangeDispatch40AssertConsistentCombinedSubsystemChangedEv: __ZNK23TransformChangeDispatch40AssertConsistentCombinedSubsystemChangedEv, __Z34SkinnedMeshRenderer_InternalRenderRK15RenderNodeQueuejRK14ChannelAssignsib: __Z34SkinnedMeshRenderer_InternalRenderRK15RenderNodeQueuejRK14ChannelAssignsib, __Z34Register_UnityEngine_Material_Lerpv: __Z34Register_UnityEngine_Material_Lerpv, __ZN10GUIElement12AddToManagerEv: __ZN10GUIElement12AddToManagerEv, _UNITY_png_create_write_struct_2: _UNITY_png_create_write_struct_2, ___towrite: ___towrite, _UNITY_png_malloc_warn: _UNITY_png_malloc_warn, __ZNK18AudioMixerSnapshot26GetTypeInfoVirtualInternalEv: __ZNK18AudioMixerSnapshot26GetTypeInfoVirtualInternalEv, __Z45Register_UnityEngine_WheelCollider_get_radiusv: __Z45Register_UnityEngine_WheelCollider_get_radiusv, __ZN20ArchiveStorageReader31TryToReadDirectoryFromBlockDataEyPKvj: __ZN20ArchiveStorageReader31TryToReadDirectoryFromBlockDataEyPKvj, __Z6GetIPsPA16_c: __Z6GetIPsPA16_c, __ZN10Collider2D14OnAddComponentEPN5Unity9ComponentE: __ZN10Collider2D14OnAddComponentEPN5Unity9ComponentE, __ZN11UnityEngine9Animation28RegisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE: __ZN11UnityEngine9Animation28RegisterAvatarBindingObjectsEPNS0_21AvatarBindingConstantE, __Z35Input_Get_Custom_PropTouchSupportedv: __Z35Input_Get_Custom_PropTouchSupportedv, __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18SpeedTreeWindAsset23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z47Register_UnityEngine_CapsuleCollider_set_radiusv: __Z47Register_UnityEngine_CapsuleCollider_set_radiusv, __ZNK5Umbra14TomeCollection15getObjectUserIDEi: __ZNK5Umbra14TomeCollection15getObjectUserIDEi, __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc: __ZN5audio5mixer23GetExposedPropertyIndexERKNS0_18AudioMixerConstantEPKc, __ZN13SpeedTreeWind16SBranchWindLevel8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SpeedTreeWind16SBranchWindLevel8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx16NpParticleSystemC2Ejb: __ZN5physx16NpParticleSystemC2Ejb, __ZN5physx2Gu10ConvexMeshC2Ev: __ZN5physx2Gu10ConvexMeshC2Ev, __ZNKSt3__28numpunctIcE11do_truenameEv: __ZNKSt3__28numpunctIcE11do_truenameEv, __ZL15gHullPrefetchCBjPKN5physx6PxVec3E: __ZL15gHullPrefetchCBjPKN5physx6PxVec3E, __ZN5Unity17ConfigurableJoint15InitializeClassEv: __ZN5Unity17ConfigurableJoint15InitializeClassEv, __Z58Register_UnityEngine_DebugLogHandler_Internal_LogExceptionv: __Z58Register_UnityEngine_DebugLogHandler_Internal_LogExceptionv, __Z42TerrainCollider_Get_Custom_PropTerrainDataP12Il2CppObject: __Z42TerrainCollider_Get_Custom_PropTerrainDataP12Il2CppObject, __Z46Register_UnityEngine_Caching_get_spaceOccupiedv: __Z46Register_UnityEngine_Caching_get_spaceOccupiedv, __ZN14ParticleSystem24StartParticlesProceduralERS_R23ParticleSystemParticlesfffjjf: __ZN14ParticleSystem24StartParticlesProceduralERS_R23ParticleSystemParticlesfffjjf, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z38Register_UnityEngine_Camera_set_aspectv: __Z38Register_UnityEngine_Camera_set_aspectv, _cf2_hintmap_build: _cf2_hintmap_build, __ZN13UnityProfiler13StartNewFrameE12ProfilerMode: __ZN13UnityProfiler13StartNewFrameE12ProfilerMode, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS0_9allocatorIS4_EEEEEvRT_j, __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15ParticleEmitter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK20LocalFileSystemPosix9IsSymLinkERK13FileEntryData: __ZNK20LocalFileSystemPosix9IsSymLinkERK13FileEntryData, __ZN12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16getInvMassScale0Ev, __ZN5physx7NpCloth21setStiffnessFrequencyEf: __ZN5physx7NpCloth21setStiffnessFrequencyEf, _UNITY_png_write_row: _UNITY_png_write_row, __ZN5physx12NpConstraintD0Ev: __ZN5physx12NpConstraintD0Ev, __Z51Register_UnityEngine_Application_get_cloudProjectIdv: __Z51Register_UnityEngine_Application_get_cloudProjectIdv, __ZN15UniformTFMethod15UnmapBoneBufferEv: __ZN15UniformTFMethod15UnmapBoneBufferEv, __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE: __ZN5physx10PxsContext14addThreadStatsERKNS_16PxsThreadContext14ThreadSimStatsE, __Z56ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsLifetimeP12Il2CppObject: __Z56ParticleSystem_TrailModule_CUSTOM_GetSizeAffectsLifetimeP12Il2CppObject, __Z55Register_UnityEngine_Application_get_temporaryCachePathv: __Z55Register_UnityEngine_Application_get_temporaryCachePathv, __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetQualityv: __Z62Register_UnityEngine_ParticleSystem_CollisionModule_SetQualityv, __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeYSorterP16DetailMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeYSorterP16DetailMeshBVNodeEEbT0_S5_T_, __ZNSt3__219__shared_mutex_base6unlockEv: __ZNSt3__219__shared_mutex_base6unlockEv, __ZN5Umbra11ShadowUtils12getCameraDofERKNS_9Matrix4x4E: __ZN5Umbra11ShadowUtils12getCameraDofERKNS_9Matrix4x4E, __Z16GetLoadedLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z16GetLoadedLibraryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx22PxDefaultFileInputDataC2EPKc: __ZN5physx22PxDefaultFileInputDataC2EPKc, __ZN5physx14PxsAABBManager12createVolumeEjjjPvRKNS_9PxBounds3E: __ZN5physx14PxsAABBManager12createVolumeEjjjPvRKNS_9PxBounds3E, __ZN21AssetBundleFileSystem10RemovePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN21AssetBundleFileSystem10RemovePathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj284ENS_22PxRepXPropertyAccessorILj284ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEE14handleAccessorILj284ENS_22PxRepXPropertyAccessorILj284ES4_ffEEEEvRKT0_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEEEE15growAndPushBackERKS2_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx3Ext7D6Joint8setDriveENS_9PxD6Drive4EnumERKNS_14PxD6JointDriveE: __ZN5physx3Ext7D6Joint8setDriveENS_9PxD6Drive4EnumERKNS_14PxD6JointDriveE, __ZN6Camera24ResetWorldToCameraMatrixEv: __ZN6Camera24ResetWorldToCameraMatrixEv, __ZN16ReflectionProbesD2Ev: __ZN16ReflectionProbesD2Ev, __Z24RegisterStrippedTypeInfoI13AnimationClipEviPKcS2_: __Z24RegisterStrippedTypeInfoI13AnimationClipEviPKcS2_, __ZN12_GLOBAL__N_115ParamNameLookup9AddArraysEPKNS_22BuiltinArrayParamIndexEj: __ZN12_GLOBAL__N_115ParamNameLookup9AddArraysEPKNS_22BuiltinArrayParamIndexEj, __ZNSt3__26vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_: __ZNSt3__26vectorIfNS_9allocatorIfEEE6assignIPfEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIfNS_15iterator_traitsIS7_E9referenceEEE5valueEvE4typeES7_S7_, __ZN12AudioManager16AddAudioListenerEP13AudioListener: __ZN12AudioManager16AddAudioListenerEP13AudioListener, __ZN11ContextGLES7AcquireEv: __ZN11ContextGLES7AcquireEv, _UNITY_png_free_buffer_list: _UNITY_png_free_buffer_list, __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye: __ZNK6Camera25GetStereoProjectionMatrixE15StereoscopicEye, __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK13BoxCollider2D26GetTypeInfoVirtualInternalEv: __ZNK13BoxCollider2D26GetTypeInfoVirtualInternalEv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE12getClassSizeEv, __Z49Register_UnityEngine_ParticleSystem_Internal_Stopv: __Z49Register_UnityEngine_ParticleSystem_Internal_Stopv, __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_: __ZN8Vector4f8TransferI14SafeBinaryReadEEvRT_, __Z32setPxRigidDynamic_SleepThresholdPN5physx14PxRigidDynamicEf: __Z32setPxRigidDynamic_SleepThresholdPN5physx14PxRigidDynamicEf, __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14PhysicMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E, __ZN9Transform26SupportedMessagesDidChangeEi: __ZN9Transform26SupportedMessagesDidChangeEi, __ZN5physx8debugger14PvdMarshallingIiyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIiyE12marshalBlockEPKhPhj, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z56Register_UnityEngine_Animator_GetCurrentAnimatorClipInfov: __Z56Register_UnityEngine_Animator_GetCurrentAnimatorClipInfov, __Z55Register_UnityEngine_SliderJoint2D_get_jointTranslationv: __Z55Register_UnityEngine_SliderJoint2D_get_jointTranslationv, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEENS_19__map_value_compareIS6_SB_NS_4lessIS6_EELb1EEE13stl_allocatorISB_L18MemLabelIdentifier5ELi16EEE4findIS6_EENS_15__tree_iteratorISB_PNS_11__tree_nodeISB_PvEEiEERKT_, __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurveMultiplierv: __Z76Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetCurveMultiplierv, __Z69Register_UnityEngine_Animator_INTERNAL_CALL_GetIKHintPositionInternalv: __Z69Register_UnityEngine_Animator_INTERNAL_CALL_GetIKHintPositionInternalv, __ZN12_GLOBAL__N_19MyFastXml8getErrorERi: __ZN12_GLOBAL__N_19MyFastXml8getErrorERi, __ZN19CharacterController7CleanupEv: __ZN19CharacterController7CleanupEv, __Z46TrailRenderer_Get_Custom_PropMinVertexDistanceP12Il2CppObject: __Z46TrailRenderer_Get_Custom_PropMinVertexDistanceP12Il2CppObject, __ZN8Animator8TransferI14SafeBinaryReadEEvRT_: __ZN8Animator8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f: __ZN5physx2Gu16_gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f, __ZN13GfxDeviceNull12IsValidStateEv: __ZN13GfxDeviceNull12IsValidStateEv, __Z38SpringJoint_Set_Custom_PropMinDistanceP12Il2CppObjectf: __Z38SpringJoint_Set_Custom_PropMinDistanceP12Il2CppObjectf, __ZN5physx28createFinalizeSolverContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE: __ZN5physx28createFinalizeSolverContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE, __ZN5Umbra4Math3powERKNS_6DoubleES3_: __ZN5Umbra4Math3powERKNS_6DoubleES3_, __ZN9LensFlare5ResetEv: __ZN9LensFlare5ResetEv, __ZN20UnityConnectSettings18InitializeDefaultsEv: __ZN20UnityConnectSettings18InitializeDefaultsEv, __ZN18ColorBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18ColorBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx18NpArticulationLink13getGlobalPoseEv: __ZNK5physx18NpArticulationLink13getGlobalPoseEv, __ZN13ProbeRenderer10RenderCubeEP15ReflectionProbeP13RenderTextureib: __ZN13ProbeRenderer10RenderCubeEP15ReflectionProbeP13RenderTextureib, __ZN12_GLOBAL__N_110Connection14createRendererEv: __ZN12_GLOBAL__N_110Connection14createRendererEv, __Z27Screen_Get_Custom_PropWidthv: __Z27Screen_Get_Custom_PropWidthv, __ZN14SafeBinaryRead4InitERK16TypeTreeIteratorii24TransferInstructionFlagsRK10MemLabelId: __ZN14SafeBinaryRead4InitERK16TypeTreeIteratorii24TransferInstructionFlagsRK10MemLabelId, __ZN7Texture21SetMasterTextureLimitEib: __ZN7Texture21SetMasterTextureLimitEib, __Z12MoveCurveKeyR17AnimationCurveTplIfEi11KeyframeTplIfE: __Z12MoveCurveKeyR17AnimationCurveTplIfEi11KeyframeTplIfE, __ZN20b2SeparationFunction10InitializeEPK14b2SimplexCachePK15b2DistanceProxyRK7b2SweepS5_S8_f: __ZN20b2SeparationFunction10InitializeEPK14b2SimplexCachePK15b2DistanceProxyRK7b2SweepS5_S8_f, __Z10EncodeRGBMRK10ColorRGBAf10RGBMRanges: __Z10EncodeRGBMRK10ColorRGBAf10RGBMRanges, __Z55Register_UnityEngine_GUIUtility_Internal_GetDefaultSkinv: __Z55Register_UnityEngine_GUIUtility_Internal_GetDefaultSkinv, __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailv: __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetWidthOverTrailv, __Z51Register_UnityEngine_Graphics_Internal_SetMRTSimplev: __Z51Register_UnityEngine_Graphics_Internal_SetMRTSimplev, __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUseRandomRowv: __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetUseRandomRowv, __ZN13RenderTexture17UploadToGfxDeviceEv: __ZN13RenderTexture17UploadToGfxDeviceEv, __ZN4FMOD7Channel6getPanEPf: __ZN4FMOD7Channel6getPanEPf, __ZNK15NavMeshObstacle8HasMovedEf: __ZNK15NavMeshObstacle8HasMovedEf, __ZNK14b2CapsuleShape9TestPointERK11b2TransformRK6b2Vec2: __ZNK14b2CapsuleShape9TestPointERK11b2TransformRK6b2Vec2, __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERNS0_8SwFabricENS0_5RangeIKNS_6PxVec4EEE: __ZN5physx5cloth7SwClothC2ERNS0_9SwFactoryERNS0_8SwFabricENS0_5RangeIKNS_6PxVec4EEE, __ZNSt3__27promiseIvE13set_exceptionESt13exception_ptr: __ZNSt3__27promiseIvE13set_exceptionESt13exception_ptr, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE8recreateEj, __ZN15ResourceManager15ThreadedCleanupEv: __ZN15ResourceManager15ThreadedCleanupEv, _emscripten_GetProcAddress: _emscripten_GetProcAddress, __ZN13MonoBehaviour10FindMethodEPKc: __ZN13MonoBehaviour10FindMethodEPKc, __ZN6Shader8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN6Shader8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_monthERiRS4_S4_RjRKNS_5ctypeIcEE, __ZNK8Animator26ShouldInterruptMatchTargetEv: __ZNK8Animator26ShouldInterruptMatchTargetEv, __ZN12TreeDatabase7SetTreeEiRK12TreeInstance: __ZN12TreeDatabase7SetTreeEiRK12TreeInstance, __ZN9HaloLayerD0Ev: __ZN9HaloLayerD0Ev, __ZN14NavMeshManager24InitializeNavMeshSystemsEPK11NavMeshData: __ZN14NavMeshManager24InitializeNavMeshSystemsEPK11NavMeshData, __ZN7mecanim9animation18GetMuscleCurveNameEi: __ZN7mecanim9animation18GetMuscleCurveNameEi, __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj: __ZZN5physx11Adjacencies4WalkEPFvRKNS_16CommonWalkParamsEjjjjEPvEN5Local9_WalkFaceERZNS0_4WalkES5_S6_E17PrivateWalkParamsjjjj, __ZN5physx2Sc16InteractionScene11preAllocateEjjjj: __ZN5physx2Sc16InteractionScene11preAllocateEjjjj, __ZN12_GLOBAL__N_117ProfileZoneClient16handleEventAddedERKN5physx18PxProfileEventNameE: __ZN12_GLOBAL__N_117ProfileZoneClient16handleEventAddedERKN5physx18PxProfileEventNameE, __Z92Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorv: __Z92Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativeVectorv, __ZN9Behaviour11FixedUpdateEv: __ZN9Behaviour11FixedUpdateEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE21__grow_by_and_replaceEjjjjjjPKc, __Z48Register_UnityEngine_Caching_get_expirationDelayv: __Z48Register_UnityEngine_Caching_get_expirationDelayv, __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13ComputeBuffer15SetCounterValueEj: __ZN13ComputeBuffer15SetCounterValueEj, __ZN15b2CircleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN15b2CircleContact7DestroyEP9b2ContactP16b2BlockAllocator, __Z24GetExecutionRestrictionsv: __Z24GetExecutionRestrictionsv, __ZN5physx31PxComputeHeightFieldPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES5_Rj: __ZN5physx31PxComputeHeightFieldPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES5_Rj, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE25getRelativeLinearVelocityEv, __Z44Terrain_Set_Custom_PropTreeBillboardDistanceP12Il2CppObjectf: __Z44Terrain_Set_Custom_PropTreeBillboardDistanceP12Il2CppObjectf, __ZNK10MeshFilter26GetTypeInfoVirtualInternalEv: __ZNK10MeshFilter26GetTypeInfoVirtualInternalEv, __ZL19RenderLightDeferredRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionP13RenderTextureS9_iiPK18DeviceStencilStateRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext: __ZL19RenderLightDeferredRK17RenderLoopContextRK15LightingContextN15QualitySettings13ShadowQualityE16ShadowProjectionP13RenderTextureS9_iiPK18DeviceStencilStateRK22DeviceMVPMatricesStateRK8Vector4fRK14LightingLayersbR17ShaderPassContext, __ZN5physx3Ext18ProfileZoneHandlerD0Ev: __ZN5physx3Ext18ProfileZoneHandlerD0Ev, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_RNS_8ios_baseEwl, __Z46ParticleSystem_TriggerModule_CUSTOM_GetOutsideP12Il2CppObject: __Z46ParticleSystem_TriggerModule_CUSTOM_GetOutsideP12Il2CppObject, __Z48NavMeshAgent_CUSTOM_INTERNAL_get_pathEndPositionP12Il2CppObjectP8Vector3f: __Z48NavMeshAgent_CUSTOM_INTERNAL_get_pathEndPositionP12Il2CppObjectP8Vector3f, __ZN11JpegDecoder9ErrorExitEP18jpeg_common_struct: __ZN11JpegDecoder9ErrorExitEP18jpeg_common_struct, __ZN8GUIStyle8TransferI8JSONReadEEvRT_: __ZN8GUIStyle8TransferI8JSONReadEEvRT_, __ZN14PhysicsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14PhysicsManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZN8Renderer18UpdateManagerStateEb: __ZN8Renderer18UpdateManagerStateEb, __ZN17PersistentManager12SetPathRemapERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN17PersistentManager12SetPathRemapERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __ZN15LocationService17GetLocationStatusEv: __ZN15LocationService17GetLocationStatusEv, ___dup3: ___dup3, __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED2Ev: __ZN5physx8debugger12MemoryBufferINS0_19ForwardingAllocatorEED2Ev, __Z57Register_UnityEngine_RectTransform_INTERNAL_set_sizeDeltav: __Z57Register_UnityEngine_RectTransform_INTERNAL_set_sizeDeltav, __Z13TransferFieldI9JSONWriteLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI9JSONWriteLb1E27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5tellgEv: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5tellgEv, __Z54Register_UnityEngine_AI_OffMeshLink_get_startTransformv: __Z54Register_UnityEngine_AI_OffMeshLink_get_startTransformv, __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI21BuiltinShaderSettingsEEvRT_PKc17TransferMetaFlags, __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet: __ZN20IntermediateRenderer24CopyCustomPropertiesFromERK19ShaderPropertySheet, __Z37Camera_CUSTOM_ResetStereoViewMatricesP12Il2CppObject: __Z37Camera_CUSTOM_ResetStereoViewMatricesP12Il2CppObject, __ZN24b2ChainAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN24b2ChainAndPolygonContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE: __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartColorv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartColorv, __Z14SetPlayerFocusb: __Z14SetPlayerFocusb, __ZN10AudioMixer23GetInitialSnapshotIndexEv: __ZN10AudioMixer23GetInitialSnapshotIndexEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjS8_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjS8_, __ZN5physx17PxcContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx17PxcContactBoxMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN7mecanim8skeleton12SkeletonCopyEPKNS0_8SkeletonEPS1_: __ZN7mecanim8skeleton12SkeletonCopyEPKNS0_8SkeletonEPS1_, __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv: __ZNK13Simd4fFactoryIRKfEcv8Scalar4fEv, __ZN5physx5cloth8SwSolver17EndSimulationTask11runInternalEv: __ZN5physx5cloth8SwSolver17EndSimulationTask11runInternalEv, __Z29StdTemplateConversionFunctionIaxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIaxEbPvR14SafeBinaryRead, _posix_memalign: _posix_memalign, __ZN5physx34solveContact_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx34solveContact_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZNK5physx7NpCloth26getNbParticleAccelerationsEv: __ZNK5physx7NpCloth26getNbParticleAccelerationsEv, __ZN5physx6shdfnd8SyncImplD2Ev: __ZN5physx6shdfnd8SyncImplD2Ev, __ZNSt3__212strstreambuf6freezeEb: __ZNSt3__212strstreambuf6freezeEb, __ZN10GUIElement17RemoveFromManagerEv: __ZN10GUIElement17RemoveFromManagerEv, __ZN5physx30PxTolerancesScaleGeneratedInfoC2Ev: __ZN5physx30PxTolerancesScaleGeneratedInfoC2Ev, __Z13CombineMeshesRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb: __Z13CombineMeshesRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEER4Meshbb, __ZN16NovodexAllocatorD0Ev: __ZN16NovodexAllocatorD0Ev, _independent_calloc: _independent_calloc, __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE6resizeEjRKb: __ZN5physx6shdfnd5ArrayIbNS0_15InlineAllocatorILj5ENS0_19ReflectionAllocatorIbEEEEE6resizeEjRKb, __ZNK15FileSystemEntry8IsHiddenEv: __ZNK15FileSystemEntry8IsHiddenEv, __Z43UnityWebRequest_Get_Custom_PropIsModifiableP12Il2CppObject: __Z43UnityWebRequest_Get_Custom_PropIsModifiableP12Il2CppObject, __ZN5physx22PxVehicleWheelsDynData21setWheelRotationAngleEjf: __ZN5physx22PxVehicleWheelsDynData21setWheelRotationAngleEjf, __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE: __ZN5physx14NpShapeManager18findSceneQueryDataERKNS_7NpShapeE, __ZN5physx11RTreeCooker18buildFromTrianglesERNS_2Gu5RTreeEPKNS_6PxVec3EjPKtPKjjRNS_6shdfnd5ArrayIjNSB_19ReflectionAllocatorIjEEEEPNS0_13RemapCallbackEfNS_17PxMeshCookingHint4EnumE: __ZN5physx11RTreeCooker18buildFromTrianglesERNS_2Gu5RTreeEPKNS_6PxVec3EjPKtPKjjRNS_6shdfnd5ArrayIjNSB_19ReflectionAllocatorIjEEEEPNS0_13RemapCallbackEfNS_17PxMeshCookingHint4EnumE, __ZN9ShaderLab27ComputeShaderKeywordSetHashERK16ShaderKeywordSet: __ZN9ShaderLab27ComputeShaderKeywordSetHashERK16ShaderKeywordSet, __Z53Register_UnityEngine_ParticleSystem_get_startLifetimev: __Z53Register_UnityEngine_ParticleSystem_get_startLifetimev, __ZN5physx24NpPtrTableStorageManager10deallocateEPPvj: __ZN5physx24NpPtrTableStorageManager10deallocateEPPvj, __Z43Register_UnityEngine_Collider_get_isTriggerv: __Z43Register_UnityEngine_Collider_get_isTriggerv, __Z42Terrain_Get_Custom_PropDetailObjectDensityP12Il2CppObject: __Z42Terrain_Get_Custom_PropDetailObjectDensityP12Il2CppObject, __ZN23b2EdgeAndPolygonContactD0Ev: __ZN23b2EdgeAndPolygonContactD0Ev, __Z38Register_UnityEngine_Mathf_HalfToFloatv: __Z38Register_UnityEngine_Mathf_HalfToFloatv, __ZN5Umbra10PathFinder4findERNS_7ImpPathERKNS_7Vector3ES5_: __ZN5Umbra10PathFinder4findERNS_7ImpPathERKNS_7Vector3ES5_, __Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere: __Z30IntersectTransformedAABBSphereRK4AABBRK10Matrix4x4f13TransformTypeRK6Sphere, __ZN5physx27createContactPatchesCoulombERNS_27PxcCorrelationBufferCoulombERNS_2Gu13ContactBufferEfj: __ZN5physx27createContactPatchesCoulombERNS_27PxcCorrelationBufferCoulombERNS_2Gu13ContactBufferEfj, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj, __ZN6prcoreL29inner_stretch_rgb888_bilinearEPKNS_9InnerInfoE: __ZN6prcoreL29inner_stretch_rgb888_bilinearEPKNS_9InnerInfoE, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZNK5physx7NpScene15getFilterShaderEv: __ZNK5physx7NpScene15getFilterShaderEv, __ZN14AnimationEvent8TransferI17RemapPPtrTransferEEvRT_: __ZN14AnimationEvent8TransferI17RemapPPtrTransferEEvRT_, __Z18TransformDirection23TransformAccessReadOnlyRKN4math7_float3E: __Z18TransformDirection23TransformAccessReadOnlyRKN4math7_float3E, __Z48Register_UnityEngine_AsyncOperation_get_priorityv: __Z48Register_UnityEngine_AsyncOperation_get_priorityv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN10UnitySceneD2Ev: __ZN10UnitySceneD2Ev, __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_13PxRigidStaticEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE: __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_13PxRigidStaticEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE, __ZN7mecanim9animation22CreateControllerMemoryEPKNS0_18ControllerConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation22CreateControllerMemoryEPKNS0_18ControllerConstantERNS_6memory9AllocatorE, __ZN5physx14NpSpatialIndex25setIncrementalRebuildRateEj: __ZN5physx14NpSpatialIndex25setIncrementalRebuildRateEj, __ZN14PhysicMaterial12CleanupClassEv: __ZN14PhysicMaterial12CleanupClassEv, __Z36Time_Set_Custom_PropMaximumDeltaTimef: __Z36Time_Set_Custom_PropMaximumDeltaTimef, __Z48UnityAnalyticsHandler_CUSTOM_InternalTransactionP12Il2CppObjectP12Il2CppStringdS2_S2_S2_h: __Z48UnityAnalyticsHandler_CUSTOM_InternalTransactionP12Il2CppObjectP12Il2CppStringdS2_S2_S2_h, __Z51Register_UnityEngine_Camera_RemoveAllCommandBuffersv: __Z51Register_UnityEngine_Camera_RemoveAllCommandBuffersv, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZL25computeMassAndDiagInertiaRN5physx3Ext21InertiaTensorComputerERNS_6PxVec3ERNS_6PxQuatERfS4_bRKNS_11PxRigidBodyEPKc: __ZL25computeMassAndDiagInertiaRN5physx3Ext21InertiaTensorComputerERNS_6PxVec3ERNS_6PxQuatERfS4_bRKNS_11PxRigidBodyEPKc, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE17getDominanceGroupEv, __Z21CopyLocalNotificationj: __Z21CopyLocalNotificationj, __ZN15LightProbeGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15LightProbeGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_: __ZN14b2PolygonShape9SetAsEdgeERK6b2Vec2S2_, __Z13RegisterClassI9BehaviourEvv: __Z13RegisterClassI9BehaviourEvv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofERKS5_j: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofERKS5_j, __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EE4seedEj: __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EE4seedEj, __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEED0Ev, __ZNSt3__26vectorINS0_INS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEEENS4_IS8_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS8_RS9_EE: __ZNSt3__26vectorINS0_INS0_IN10__cxxabiv112_GLOBAL__N_111string_pairENS2_11short_allocIS3_Lj4096EEEEENS4_IS6_Lj4096EEEEENS4_IS8_Lj4096EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS8_RS9_EE, __ZN13GfxDeviceGLES5FlushEv: __ZN13GfxDeviceGLES5FlushEv, __ZN5Umbra15getAPIInfoValueENS_9InfoValueE: __ZN5Umbra15getAPIInfoValueENS_9InfoValueE, __ZN4math8Collider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN4math8Collider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__210moneypunctIwLb0EED0Ev: __ZNSt3__210moneypunctIwLb0EED0Ev, __Z39TextGenerator_CUSTOM_GetCharactersArrayP12Il2CppObject: __Z39TextGenerator_CUSTOM_GetCharactersArrayP12Il2CppObject, __GLOBAL__sub_I_runtime_assetbundles_lump_cpp: __GLOBAL__sub_I_runtime_assetbundles_lump_cpp, __ZN22BaseUnityConnectClient17RestoreValuesFileEv: __ZN22BaseUnityConnectClient17RestoreValuesFileEv, __ZNK12NavMeshAgent11GetVelocityEv: __ZNK12NavMeshAgent11GetVelocityEv, __Z19GetGraphicsSettingsv: __Z19GetGraphicsSettingsv, __ZNKSt3__220__time_get_c_storageIcE3__rEv: __ZNKSt3__220__time_get_c_storageIcE3__rEv, __Z22Camera_CUSTOM_CopyFromP12Il2CppObjectS0_: __Z22Camera_CUSTOM_CopyFromP12Il2CppObjectS0_, __Z30CreateInstanceBehaviourManagerv: __Z30CreateInstanceBehaviourManagerv, __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE: __ZN5physx2Gu24PCMMeshContactGenerationC2ERKNS_6shdfnd3aos6FloatVES6_RKNS3_12PsTransformVES9_RNS0_33MultiplePersistentContactManifoldERNS0_13ContactBufferE, __Z48ParticleRenderer_Get_Custom_PropUvAnimationYTileP12Il2CppObject: __Z48ParticleRenderer_Get_Custom_PropUvAnimationYTileP12Il2CppObject, __ZN18BuoyancyEffector2D5ResetEv: __ZN18BuoyancyEffector2D5ResetEv, __Z48Register_UnityEngine_TextGenerator_GetLinesArrayv: __Z48Register_UnityEngine_TextGenerator_GetLinesArrayv, __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev: __ZNSt3__219basic_ostringstreamIcNS_11char_traitsIcEENS_9allocatorIcEEED0Ev, __ZN14ParticleSystem21RendererBecameVisibleEv: __ZN14ParticleSystem21RendererBecameVisibleEv, __ZN6Object22CheckInstanceIDsLoadedEPii: __ZN6Object22CheckInstanceIDsLoadedEPii, __ZL17LightmapDataToCppR16LightmapDataMonoR12LightmapData: __ZL17LightmapDataToCppR16LightmapDataMonoR12LightmapData, __ZN5physx2Sc5Scene8simulateEfPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene8simulateEfPNS_10PxBaseTaskE, __Z43Physics_Get_Custom_PropSleepAngularVelocityv: __Z43Physics_Get_Custom_PropSleepAngularVelocityv, __ZNK6Shader18GetScriptClassNameEv: __ZNK6Shader18GetScriptClassNameEv, __ZN18ProceduralMaterial19GetGeneratedTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18ProceduralMaterial19GetGeneratedTextureERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z48getPxVehicleAckermannGeometryDataMAxleSeparationPKN5physx30PxVehicleAckermannGeometryDataE: __Z48getPxVehicleAckermannGeometryDataMAxleSeparationPKN5physx30PxVehicleAckermannGeometryDataE, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRS3_S4_E: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEElsEPFRS3_S4_E, __Z20LastParsedShaderNamev: __Z20LastParsedShaderNamev, __ZL31ParticleRenderer_FillVertexDataPvRK27LegacyParticleRenderingDataPK8ParticlePK5RectTIfE: __ZL31ParticleRenderer_FillVertexDataPvRK27LegacyParticleRenderingDataPK8ParticlePK5RectTIfE, __ZN5CacheD2Ev: __ZN5CacheD2Ev, __ZN4FMOD4DSPI16setSpeakerActiveE12FMOD_SPEAKERb: __ZN4FMOD4DSPI16setSpeakerActiveE12FMOD_SPEAKERb, __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_: __ZN11PlayerPrefs9SetStringERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_, __ZN14DataBufferGLES6DisownEv: __ZN14DataBufferGLES6DisownEv, __Z65Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForceAtPositionv: __Z65Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddForceAtPositionv, __ZNK5physx2Sc14ConstraintCore15getPxConstraintEv: __ZNK5physx2Sc14ConstraintCore15getPxConstraintEv, __ZN14GraphicsHelper28PrepareShaderParameterBufferER13dynamic_arrayIhLj4EERA6_P10GpuProgramRA6_PK20GpuProgramParametersRA6_PKhRK11SubProgramsPK19ShaderPropertySheetSL_: __ZN14GraphicsHelper28PrepareShaderParameterBufferER13dynamic_arrayIhLj4EERA6_P10GpuProgramRA6_PK20GpuProgramParametersRA6_PKhRK11SubProgramsPK19ShaderPropertySheetSL_, __Z50Register_UnityEngine_Application_DontDestroyOnLoadv: __Z50Register_UnityEngine_Application_DontDestroyOnLoadv, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _cff_index_get_sid_string: _cff_index_get_sid_string, __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetLayerWeightInternalv: __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_SetLayerWeightInternalv, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer8PvdPointEEE: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer8PvdPointEEE, _exp2f: _exp2f, _isspace: _isspace, __Z16pqHeapExtractMinP13PriorityQHeap: __Z16pqHeapExtractMinP13PriorityQHeap, _exp2l: _exp2l, __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatRGBA8888EEvPKNS_9InnerInfoE, __Z85Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_DisconnectInternalv: __Z85Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_DisconnectInternalv, __ZN9Scripting26GetMethodWithSearchOptionsEPKcS1_S1_S1_N24ScriptingMethodFiltering18MethodSearchFilterE: __ZN9Scripting26GetMethodWithSearchOptionsEPKcS1_S1_S1_N24ScriptingMethodFiltering18MethodSearchFilterE, __ZN13TargetJoint2D12SetFrequencyEf: __ZN13TargetJoint2D12SetFrequencyEf, __Z46UnityWebRequest_Get_Custom_PropChunkedTransferP12Il2CppObject: __Z46UnityWebRequest_Get_Custom_PropChunkedTransferP12Il2CppObject, __ZN7Joint2D17RemoveFromManagerEv: __ZN7Joint2D17RemoveFromManagerEv, __ZN14dtPathCorridor20optimizePathTopologyEP14dtNavMeshQueryPK13dtQueryFilter: __ZN14dtPathCorridor20optimizePathTopologyEP14dtNavMeshQueryPK13dtQueryFilter, __ZN12StatusHelper13SetStatusCodeEl: __ZN12StatusHelper13SetStatusCodeEl, __ZN18CrashReportManagerD0Ev: __ZN18CrashReportManagerD0Ev, __Z52Register_UnityEngine_Application_set_runInBackgroundv: __Z52Register_UnityEngine_Application_set_runInBackgroundv, __ZN5physx26PxSceneLimitsGeneratedInfoC2Ev: __ZN5physx26PxSceneLimitsGeneratedInfoC2Ev, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEE6sentryC2ERS3_, __ZN5physx2Gu31SinglePersistentContactManifold14reduceContactsEPNS0_21MeshPersistentContactEj: __ZN5physx2Gu31SinglePersistentContactManifold14reduceContactsEPNS0_21MeshPersistentContactEj, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb, __ZN13GfxDeviceNull12PresentFrameEv: __ZN13GfxDeviceNull12PresentFrameEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15LineTextureModeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15LineTextureModeEvRT_RT0_PKc17TransferMetaFlags, __ZN7mecanim9animation23CreateBlendTreeConstantEjRNS_6memory9AllocatorE: __ZN7mecanim9animation23CreateBlendTreeConstantEjRNS_6memory9AllocatorE, __ZN5physx2Gu12TriangleMesh8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx2Gu12TriangleMesh8requiresERNS_23PxProcessPxBaseCallbackE, __ZN11UnityEngine15CloudWebService14DataDispatcher29PreformRetryWebDispatchStaticEPv: __ZN11UnityEngine15CloudWebService14DataDispatcher29PreformRetryWebDispatchStaticEPv, __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11LightProbes23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z21GetBackgroundJobQueuev: __Z21GetBackgroundJobQueuev, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRb, __ZNSt3__215messages_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__215messages_bynameIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __Z43Register_UnityEngine_Collider2D_get_densityv: __Z43Register_UnityEngine_Collider2D_get_densityv, __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointNonAllocv: __Z65Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointNonAllocv, __Z43BuoyancyEffector2D_Get_Custom_PropFlowAngleP12Il2CppObject: __Z43BuoyancyEffector2D_Get_Custom_PropFlowAngleP12Il2CppObject, __ZNSt3__28ios_baseD2Ev: __ZNSt3__28ios_baseD2Ev, __ZNK9DebugGLES13ProgramStatusEv: __ZNK9DebugGLES13ProgramStatusEv, __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI26EnlightenSystemInformationLj8EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN24UserAuthorizationManager31ReplyToUserAuthorizationRequestEbb: __ZN24UserAuthorizationManager31ReplyToUserAuthorizationRequestEbb, __ZN19SpriteMeshGenerator4pathC2ERKNSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEiiiff: __ZN19SpriteMeshGenerator4pathC2ERKNSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEiiiff, __ZN12TreeRenderer11ReloadTreesEv: __ZN12TreeRenderer11ReloadTreesEv, __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE15growAndPushBackERKS3_, __ZN9Rigidbody22FetchPoseFromTransformEv: __ZN9Rigidbody22FetchPoseFromTransformEv, __ZL28CalculateCarveHullFromPointsR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fffPS7_i: __ZL28CalculateCarveHullFromPointsR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fffPS7_i, __ZN10systeminfo17GetSystemLanguageEv: __ZN10systeminfo17GetSystemLanguageEv, __ZN7mecanim8dynamics8ScalDamp8EvaluateEff: __ZN7mecanim8dynamics8ScalDamp8EvaluateEff, __Z40VRSettings_Set_Custom_PropShowDeviceViewh: __Z40VRSettings_Set_Custom_PropShowDeviceViewh, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5Umbra20RuntimeTomeGenerator13outputObjectsERNS_7ImpTomeERNS_4HashIjiEE: __ZN5Umbra20RuntimeTomeGenerator13outputObjectsERNS_7ImpTomeERNS_4HashIjiEE, __ZN9ShaderLab11shaderprops9GetMatrixEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE: __ZN9ShaderLab11shaderprops9GetMatrixEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS4_, __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10Collider2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine15CloudWebService17SessionEventQueue16InternalAddEventEPNS0_14CloudEventInfoE: __ZN11UnityEngine15CloudWebService17SessionEventQueue16InternalAddEventEPNS0_14CloudEventInfoE, __Z43GameObject_Get_Custom_PropIsStaticBatchableP12Il2CppObject: __Z43GameObject_Get_Custom_PropIsStaticBatchableP12Il2CppObject, __ZNSt3__26vectorIPN11UnityEngine15CloudWebService17WebFileDownloaderINS2_13WWWRestClientENS2_16WWWRestHeaderMapEEE13stl_allocatorIS7_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS7_EEvRT_: __ZNSt3__26vectorIPN11UnityEngine15CloudWebService17WebFileDownloaderINS2_13WWWRestClientENS2_16WWWRestHeaderMapEEE13stl_allocatorIS7_L18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKS7_EEvRT_, __ZN14PhysicsManager5ResetEv: __ZN14PhysicsManager5ResetEv, __Z38QualitySettings_CUSTOM_GetQualityLevelv: __Z38QualitySettings_CUSTOM_GetQualityLevelv, __ZN8GUIState18CycleKeyboardFocusERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb: __ZN8GUIState18CycleKeyboardFocusERNSt3__26vectorIP6IDListNS0_9allocatorIS3_EEEEb, __Z50Register_UnityEngine_AnimationClip_get_humanMotionv: __Z50Register_UnityEngine_AnimationClip_get_humanMotionv, __Z43WheelJoint2D_CUSTOM_INTERNAL_get_suspensionP12Il2CppObjectP17JointSuspension2D: __Z43WheelJoint2D_CUSTOM_INTERNAL_get_suspensionP12Il2CppObjectP17JointSuspension2D, __ZN22VertexDeclarationCache6CommitEv: __ZN22VertexDeclarationCache6CommitEv, __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2EOS1_, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EE11Collision2DEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_S7_S9_NS0_8equal_toIS5_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv, __ZN11AudioFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11AudioFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD1Ev: __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStreamD1Ev, __ZN5physx10PxsContext11beginUpdateEv: __ZN5physx10PxsContext11beginUpdateEv, __ZN14RenderSettings19SetAmbientIntensityEf: __ZN14RenderSettings19SetAmbientIntensityEf, __ZNK15CapsuleCollider18CalculateTransformEv: __ZNK15CapsuleCollider18CalculateTransformEv, __Z18ConvertImageToRGBMR14ImageReference: __Z18ConvertImageToRGBMR14ImageReference, _getpeername: _getpeername, __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode: __ZN13AnimationClipC2E10MemLabelId18ObjectCreationMode, __ZN12ImmediatePtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_: __ZN12ImmediatePtrI10GameObjectE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_, __ZNK18BuoyancyEffector2D26GetTypeInfoVirtualInternalEv: __ZNK18BuoyancyEffector2D26GetTypeInfoVirtualInternalEv, __ZN10SizeModule5ResetEv: __ZN10SizeModule5ResetEv, __ZN8Animator16GetDeltaPositionEv: __ZN8Animator16GetDeltaPositionEv, __ZN5physx7profile19MemoryEventRecorder14onDeallocationEPv: __ZN5physx7profile19MemoryEventRecorder14onDeallocationEPv, __Z24RegisterStrippedTypeInfoI17CapsuleCollider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI17CapsuleCollider2DEviPKcS2_, __ZN14PhysicMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14PhysicMaterial23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj: __ZNK5physx22PxVehicleWheelsSimData17getSuspensionDataEj, __ZN4FMOD8ChannelI14set3DOcclusionEff: __ZN4FMOD8ChannelI14set3DOcclusionEff, __Z65Register_UnityEngine_Networking_UnityWebRequest_set_uploadHandlerv: __Z65Register_UnityEngine_Networking_UnityWebRequest_set_uploadHandlerv, __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE9erase_oneIS1_EEjRKT_: __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE9erase_oneIS1_EEjRKT_, __ZNK5physx13GuMeshFactory17getTriangleMeshesEPPNS_14PxTriangleMeshEjj: __ZNK5physx13GuMeshFactory17getTriangleMeshesEPPNS_14PxTriangleMeshEjj, __ZN6prcore11GetValue1p0ERf: __ZN6prcore11GetValue1p0ERf, __ZN5physx2Sc15ArticulationSim9setActiveEbj: __ZN5physx2Sc15ArticulationSim9setActiveEbj, __ZNK26AnimatorControllerPlayable24HasStateMachineBehaviourEv: __ZNK26AnimatorControllerPlayable24HasStateMachineBehaviourEv, __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader: __ZN21AssetBundleFileSystem13RemoveArchiveEP20ArchiveStorageReader, __ZN7mecanim4hand13FingerDoFNameEj: __ZN7mecanim4hand13FingerDoFNameEj, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRy, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj174ENS_22PxRepXPropertyAccessorILj174ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN22AnimationMixerPlayable18SetInputConnectionEP8Playablei: __ZN22AnimationMixerPlayable18SetInputConnectionEP8Playablei, __ZN5physx2Gu15MeshHitCallbackINS_12PxRaycastHitEED2Ev: __ZN5physx2Gu15MeshHitCallbackINS_12PxRaycastHitEED2Ev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPci: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7getlineEPci, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_GetXv, __ZN5Umbra9KDRankLUT9constructEPKj: __ZN5Umbra9KDRankLUT9constructEPKj, __ZN13AvatarBuilder14GetAllChildrenER9TransformR8UnityStrRNSt3__26vectorINS_14NamedTransformENS4_9allocatorIS6_EEEERKNS5_IS2_NS7_IS2_EEEE: __ZN13AvatarBuilder14GetAllChildrenER9TransformR8UnityStrRNSt3__26vectorINS_14NamedTransformENS4_9allocatorIS6_EEEERKNS5_IS2_NS7_IS2_EEEE, __Z32setPxVehicleGearsDataMFinalRatioPN5physx18PxVehicleGearsDataEf: __Z32setPxVehicleGearsDataMFinalRatioPN5physx18PxVehicleGearsDataEf, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj187ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj187ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z37Rigidbody2D_Set_Custom_PropFixedAngleP12Il2CppObjecth: __Z37Rigidbody2D_Set_Custom_PropFixedAngleP12Il2CppObjecth, __ZN9GfxDevice21CreateComputeBufferIDEv: __ZN9GfxDevice21CreateComputeBufferIDEv, _recv: _recv, __Z52Register_UnityEngine_Canvas_set_overridePixelPerfectv: __Z52Register_UnityEngine_Canvas_set_overridePixelPerfectv, __ZNK12AudioManager18GetMemoryAllocatedEv: __ZNK12AudioManager18GetMemoryAllocatedEv, __Z36Joint2D_Get_Custom_PropConnectedBodyP12Il2CppObject: __Z36Joint2D_Get_Custom_PropConnectedBodyP12Il2CppObject, __ZN5Unity10FixedJoint23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN5Unity10FixedJoint23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE19getConcreteTypeNameEv, __ZN6Object8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN6Object8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEE6getDirEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZNK11AudioSource9GetSpreadEv: __ZNK11AudioSource9GetSpreadEv, __ZN8Playable17IsMultithreadableEv: __ZN8Playable17IsMultithreadableEv, _init_block: _init_block, __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z24RegisterStrippedTypeInfoI11AssetBundleEviPKcS2_: __Z24RegisterStrippedTypeInfoI11AssetBundleEviPKcS2_, __ZN5physx18RepXSerializerImplINS_14PxArticulationEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_14PxArticulationEE11getTypeNameEv, __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_S3_RfS4_: __ZN5physx2Gu16intersectRayAABBERKNS_6PxVec3ES3_S3_S3_S3_RfS4_, __Z31Camera_Set_Custom_PropEventMaskP12Il2CppObjecti: __Z31Camera_Set_Custom_PropEventMaskP12Il2CppObjecti, __Z58Register_UnityEngine_ParticleSystemRenderer_get_renderModev: __Z58Register_UnityEngine_ParticleSystemRenderer_get_renderModev, __ZN14NavMeshManager14DistanceToEdgeEP10NavMeshHitRK8Vector3fRK13dtQueryFilter: __ZN14NavMeshManager14DistanceToEdgeEP10NavMeshHitRK8Vector3fRK13dtQueryFilter, __ZN11UnityEngine15CloudWebService14DataDispatcher5PauseEv: __ZN11UnityEngine15CloudWebService14DataDispatcher5PauseEv, __ZN13GfxTimerQueryD0Ev: __ZN13GfxTimerQueryD0Ev, __ZN15ParticleEmitterD2Ev: __ZN15ParticleEmitterD2Ev, __ZN7Hash128C2EPKcj: __ZN7Hash128C2EPKcj, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI7SubMesh13stl_allocatorIS3_L18MemLabelIdentifier16ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI7SubMesh13stl_allocatorIS3_L18MemLabelIdentifier16ELi16EEEEEEvRT_17TransferMetaFlags, __Z53Register_UnityEngine_AndroidJNI_GetDoubleArrayElementv: __Z53Register_UnityEngine_AndroidJNI_GetDoubleArrayElementv, __Z37CalculateExpandedClippedBoxConvexHullPfS_PKffff: __Z37CalculateExpandedClippedBoxConvexHullPfS_PKffff, __Z57Register_UnityEngine_Effector2D_get_designedForNonTriggerv: __Z57Register_UnityEngine_Effector2D_get_designedForNonTriggerv, __ZN5physx12NpBatchQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformEtRKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE: __ZN5physx12NpBatchQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformEtRKNS_17PxQueryFilterDataEPvPKNS_12PxQueryCacheE, __ZN23ManagedAttributeManager52CallManagedGetParentTypeDisallowingMultipleInclusionEP11Il2CppClass: __ZN23ManagedAttributeManager52CallManagedGetParentTypeDisallowingMultipleInclusionEP11Il2CppClass, _cf2_arrstack_getBuffer: _cf2_arrstack_getBuffer, __ZN4FMOD6System18getChannelsPlayingEPi: __ZN4FMOD6System18getChannelsPlayingEPi, __ZN11AudioSource23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11AudioSource23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK9Polygon2D15GetNearestPointERK8Vector2fRiS3_Rf: __ZNK9Polygon2D15GetNearestPointERK8Vector2fRiS3_Rf, __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z21FillShaderRenderStateR22BasicShaderRenderStateRK10RenderNodeRK15RenderNodeQueueRK15RODataDepthPass: __Z21FillShaderRenderStateR22BasicShaderRenderStateRK10RenderNodeRK15RenderNodeQueueRK15RODataDepthPass, _llvm_ctlz_i64: _llvm_ctlz_i64, __Z18setPxJointUserDataPN5physx7PxJointEPv: __Z18setPxJointUserDataPN5physx7PxJointEPv, __ZN5Unity9Component10DeactivateE19DeactivateOperation: __ZN5Unity9Component10DeactivateE19DeactivateOperation, __ZN5physx2Gu18computeMTD_BoxMeshERNS_6PxVec3ERfRKNS0_3BoxERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE: __ZN5physx2Gu18computeMTD_BoxMeshERNS_6PxVec3ERfRKNS0_3BoxERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformE, __Z20SetStackTraceLogType17StackTraceLogType: __Z20SetStackTraceLogType17StackTraceLogType, __ZN15ConstantForce2DD2Ev: __ZN15ConstantForce2DD2Ev, __Z24scripting_class_get_nameP11Il2CppClass: __Z24scripting_class_get_nameP11Il2CppClass, __Z63Register_UnityEngine_AnimatorUtility_OptimizeTransformHierarchyv: __Z63Register_UnityEngine_AnimatorUtility_OptimizeTransformHierarchyv, __ZN6Shader8TransferI17RemapPPtrTransferEEvRT_: __ZN6Shader8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE: __ZN5physx2Gu15HeightFieldUtil19OverlapTraceSegmentI21BoxTraceSegmentReportE10visitCellsERKNS4_11OverlapLineE, __ZN5physx2Sn13XmlWriterImpl10leaveChildEv: __ZN5physx2Sn13XmlWriterImpl10leaveChildEv, __Z56ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsLifetimeP12Il2CppObjecth: __Z56ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsLifetimeP12Il2CppObjecth, __Z66Register_UnityEngine_MonoBehaviour_StopCoroutineViaEnumerator_Autov: __Z66Register_UnityEngine_MonoBehaviour_StopCoroutineViaEnumerator_Autov, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN11UnityEngine15CloudWebService13WWWRestClient18UpdateResponseInfoEv: __ZN11UnityEngine15CloudWebService13WWWRestClient18UpdateResponseInfoEv, __ZN9ShaderLab9SubShaderD2Ev: __ZN9ShaderLab9SubShaderD2Ev, __Z53Renderer_Get_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObject: __Z53Renderer_Get_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObject, __Z26RecalculateSplineSlopeLoopIfEvR17AnimationCurveTplIT_Eif: __Z26RecalculateSplineSlopeLoopIfEvR17AnimationCurveTplIT_Eif, __Z45Register_UnityEngine_SpriteRenderer_set_flipYv: __Z45Register_UnityEngine_SpriteRenderer_set_flipYv, __Z25CalculateFocusedLightHullPK8Vector3fRS0_RK10MinMaxAABBR13dynamic_arrayIS_Lj4EE: __Z25CalculateFocusedLightHullPK8Vector3fRS0_RK10MinMaxAABBR13dynamic_arrayIS_Lj4EE, __ZNK5physx3Cct13BoxController13getStepOffsetEv: __ZNK5physx3Cct13BoxController13getStepOffsetEv, __ZN24OcclusionCullingSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_: __ZN24OcclusionCullingSettings18TransferDeprecatedI14SafeBinaryReadEEvRT_, _fwide: _fwide, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxKillSpeedv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_SetMaxKillSpeedv, __Z15setPxActor_NamePN5physx7PxActorEPKc: __Z15setPxActor_NamePN5physx7PxActorEPKc, __ZN14AreaEffector2D7SetDragEf: __ZN14AreaEffector2D7SetDragEf, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE19getConcreteTypeNameEv, __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf: __ZN5physx6shdfnd5ArrayIfNS0_19ReflectionAllocatorIfEEE15growAndPushBackERKf, __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_: __ZN13dynamic_arrayI8Vector2fLj4EEC2ERKS1_, __Z13FocusCallbackiPK20EmscriptenFocusEventPv: __Z13FocusCallbackiPK20EmscriptenFocusEventPv, __ZN5physx7Cooking9setParamsERKNS_15PxCookingParamsE: __ZN5physx7Cooking9setParamsERKNS_15PxCookingParamsE, __ZL15SortFloatByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEfEES5_: __ZL15SortFloatByNameRKNSt3__24pairIN9ShaderLab16FastPropertyNameEfEES5_, __ZN5Unity5Cloth7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity5Cloth7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN15DetailPrototype8TransferI14SafeBinaryReadEEvRT_: __ZN15DetailPrototype8TransferI14SafeBinaryReadEEvRT_, __ZNK15PolynomialCurve20FindMinMaxIntegratedEv: __ZNK15PolynomialCurve20FindMinMaxIntegratedEv, __ZN13MonoBehaviour18CallMethodInactiveE21ScriptingMethodIl2Cpp: __ZN13MonoBehaviour18CallMethodInactiveE21ScriptingMethodIl2Cpp, __Z31Scene_CUSTOM_GetIsDirtyInternali: __Z31Scene_CUSTOM_GetIsDirtyInternali, __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16LevelGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11UnityEngine9Animation29SkeletonFindNodeIndexByNameIDEPKN7mecanim9animation14AvatarConstantEj: __ZN11UnityEngine9Animation29SkeletonFindNodeIndexByNameIDEPKN7mecanim9animation14AvatarConstantEj, __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator13GeneratorTileEE6updateEibbb: __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator13GeneratorTileEE6updateEibbb, __Z50Register_UnityEngine_AudioReverbZone_set_diffusionv: __Z50Register_UnityEngine_AudioReverbZone_set_diffusionv, __ZN8VRDevice19CleanupGfxResourcesEv: __ZN8VRDevice19CleanupGfxResourcesEv, __Z57RenderSettings_Set_Custom_PropDefaultReflectionResolutioni: __Z57RenderSettings_Set_Custom_PropDefaultReflectionResolutioni, __ZN11UTF16StringC2EP12Il2CppString10MemLabelId: __ZN11UTF16StringC2EP12Il2CppString10MemLabelId, __ZNK5physx31PxClothGeodesicTetherCookerImpl23getNbTethersPerParticleEv: __ZNK5physx31PxClothGeodesicTetherCookerImpl23getNbTethersPerParticleEv, __ZN13AnimationClip12Vector3CurveC2ERKS0_: __ZN13AnimationClip12Vector3CurveC2ERKS0_, __ZNK25BlendshapePropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK25BlendshapePropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __ZN7dtCrowd11removeAgentER13dtCrowdHandle: __ZN7dtCrowd11removeAgentER13dtCrowdHandle, __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN24b2ChainAndCapsuleContactC2EP9b2FixtureiS1_i: __ZN24b2ChainAndCapsuleContactC2EP9b2FixtureiS1_i, __ZL25DestroySparseTexturesGLESPv: __ZL25DestroySparseTexturesGLESPv, __Z45Register_UnityEngine_ParticleEmitter_set_emitv: __Z45Register_UnityEngine_ParticleEmitter_set_emitv, __ZN11PlayerPrefs9DeleteAllEv: __ZN11PlayerPrefs9DeleteAllEv, __ZN13SplatDatabase12GetAlphamapsER13dynamic_arrayIhLj1EEb: __ZN13SplatDatabase12GetAlphamapsER13dynamic_arrayIhLj1EEb, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer11PvdTriangleEEE, __ZN19CloudServiceHandler8SaveFileERK8UnityStrS2_: __ZN19CloudServiceHandler8SaveFileERK8UnityStrS2_, __ZN13BaseAllocator16ThreadInitializeEPS_: __ZN13BaseAllocator16ThreadInitializeEPS_, __ZNK16CrashReportEvent12ToJsonStringEv: __ZNK16CrashReportEvent12ToJsonStringEv, __ZNK6Avatar15GetPostRotationEi: __ZNK6Avatar15GetPostRotationEi, __ZN14RenderSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14RenderSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z34ParticleSystem_Get_Custom_PropLoopP12Il2CppObject: __Z34ParticleSystem_Get_Custom_PropLoopP12Il2CppObject, __ZN5physx37PxVehicleWheelsDynDataGeneratedValuesC2EPKNS_22PxVehicleWheelsDynDataE: __ZN5physx37PxVehicleWheelsDynDataGeneratedValuesC2EPKNS_22PxVehicleWheelsDynDataE, __ZNK10UnityScene19GetLevelGameManagerEi: __ZNK10UnityScene19GetLevelGameManagerEi, __ZN5physx2Gu20computeMTD_SphereBoxERNS_6PxVec3ERfRKNS0_6SphereERKNS0_3BoxE: __ZN5physx2Gu20computeMTD_SphereBoxERNS_6PxVec3ERfRKNS0_6SphereERKNS0_3BoxE, __ZN5Umbra4PathC2Ev: __ZN5Umbra4PathC2Ev, __ZN15QualitySettings16SetShadowQualityENS_13ShadowQualityE: __ZN15QualitySettings16SetShadowQualityENS_13ShadowQualityE, __ZNSt3__214__split_bufferI24CompressedAnimationCurveR13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev: __ZNSt3__214__split_bufferI24CompressedAnimationCurveR13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEED2Ev, __ZNK16LightmapSettings19AreLightProbesBakedEv: __ZNK16LightmapSettings19AreLightProbesBakedEv, __ZNK9Transform21GetLocalToWorldMatrixEv: __ZNK9Transform21GetLocalToWorldMatrixEv, __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI18StreamedBinaryReadILb1EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN2UI14CanvasRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN2UI14CanvasRenderer13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx14NpShapeManager15importExtraDataERNS_24PxDeserializationContextE, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __ZN20QuadTreeNodeRendererD0Ev: __ZN20QuadTreeNodeRendererD0Ev, __Z52LightProbeProxyVolume_Set_Custom_PropBoundingBoxModeP12Il2CppObjecti: __Z52LightProbeProxyVolume_Set_Custom_PropBoundingBoxModeP12Il2CppObjecti, __Z39MonoBehaviour_CUSTOM_StopCoroutine_AutoP12Il2CppObjectS0_: __Z39MonoBehaviour_CUSTOM_StopCoroutine_AutoP12Il2CppObjectS0_, __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPj: __ZN16RayRTreeCallbackILi1ELb1EE14processResultsEjPj, __ZN5physx2Sc17ParticleSystemSim25visualizeBroadPhaseBoundsERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim25visualizeBroadPhaseBoundsERNS_2Cm12RenderOutputE, __Z19setPxSceneDescFlagsPN5physx11PxSceneDescENS_7PxFlagsINS_11PxSceneFlag4EnumEtEE: __Z19setPxSceneDescFlagsPN5physx11PxSceneDescENS_7PxFlagsINS_11PxSceneFlag4EnumEtEE, __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_: __ZN5physx2Gu25PersistentContactManifold20refreshContactPointsERKNS_6shdfnd3aos15PsMatTransformVERKNS3_6FloatVES9_, __ZThn680_N18UnityConnectClientD0Ev: __ZThn680_N18UnityConnectClientD0Ev, __ZN8JSONRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI10ColorRGBAfEEvRT_PKc17TransferMetaFlagsb, __ZN11DynamicMesh13FindNeighborsEv: __ZN11DynamicMesh13FindNeighborsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj395ENS_22PxRepXPropertyAccessorILj395ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxClothTetherConfigEEEE14handleAccessorILj395ENS_22PxRepXPropertyAccessorILj395ES4_ffEEEEvRKT0_, __ZNK17IAnimationBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc: __ZNK17IAnimationBinding38SerializedPropertyPathToCurveAttributeER6ObjectPKc, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE17releaseEmptySlabsEv, __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE12getClassSizeEv, __ZN6IDList7GetNextER8GUIStatei9FocusType: __ZN6IDList7GetNextER8GUIStatei9FocusType, _AllocateUTF16Memory: _AllocateUTF16Memory, _tre_new_item: _tre_new_item, __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN15QualitySettings14QualitySettingENS0_9allocatorIS3_EEEEEvRT_j, __Z21GetUIScriptingClassesv: __Z21GetUIScriptingClassesv, __ZL21PxcFindSeparatingAxesRN5physx2Gu14SeparatingAxesEPKjjRKNS0_13PolygonalDataERKNS_2Cm8Matrix34ERKNS_7PxPlaneESB_RKNS_9PxBounds3EfRKNS8_23FastVertex2ShapeScalingE: __ZL21PxcFindSeparatingAxesRN5physx2Gu14SeparatingAxesEPKjjRKNS0_13PolygonalDataERKNS_2Cm8Matrix34ERKNS_7PxPlaneESB_RKNS_9PxBounds3EfRKNS8_23FastVertex2ShapeScalingE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_18NpArticulationLinkEEEE15growAndPushBackERKS2_, __ZN18GfxFramebufferGLES20CleanupFBOMapForRBIDERKj: __ZN18GfxFramebufferGLES20CleanupFBOMapForRBIDERKj, __Z39SystemInfo_Get_Custom_PropSupportsAudiov: __Z39SystemInfo_Get_Custom_PropSupportsAudiov, __ZN2UI6Canvas27UpdateCanvasOverrideSortingEv: __ZN2UI6Canvas27UpdateCanvasOverrideSortingEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj34ENS_22PxRepXPropertyAccessorILj34ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN12SocketStream7SendAllEPKvjl: __ZN12SocketStream7SendAllEPKvjl, __ZN8Animator12GetLayerNameEi: __ZN8Animator12GetLayerNameEi, __ZN13WheelCollider5ResetEv: __ZN13WheelCollider5ResetEv, __ZN11UnityEngine15CloudWebService13WWWRestClient17PlayerLoopHandlerEv: __ZN11UnityEngine15CloudWebService13WWWRestClient17PlayerLoopHandlerEv, __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE: __ZNKSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_bRNS_8ios_baseEcRKNS_12basic_stringIcS3_NS_9allocatorIcEEEE, __ZN12HandlerChain4SeekER13FileEntryDatax10FileOrigin: __ZN12HandlerChain4SeekER13FileEntryDatax10FileOrigin, __ZN13MonoBehaviour19RebuildMonoInstanceEv: __ZN13MonoBehaviour19RebuildMonoInstanceEv, __ZN14TerrainManager10AddTerrainEP7Terrain: __ZN14TerrainManager10AddTerrainEP7Terrain, __Z17IntersectAABBAABBRK4AABBS1_: __Z17IntersectAABBAABBRK4AABBS1_, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getParticleMassEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15getParticleMassEv, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_AllocObject13Il2Cpp_IntPtrRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_AllocObject13Il2Cpp_IntPtrRPv, __Z44Rigidbody2D_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP13Vector2fIcall: __Z44Rigidbody2D_CUSTOM_INTERNAL_get_centerOfMassP12Il2CppObjectP13Vector2fIcall, __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyPositionInternalv: __Z67Register_UnityEngine_Animator_INTERNAL_CALL_SetBodyPositionInternalv, __ZN14GfxDeviceStats19EndRenderFrameStatsEv: __ZN14GfxDeviceStats19EndRenderFrameStatsEv, __Z51CharacterController_Get_Custom_PropDetectCollisionsP12Il2CppObject: __Z51CharacterController_Get_Custom_PropDetectCollisionsP12Il2CppObject, __ZN5physx13NpVolumeCache4fillERKNS_10PxGeometryERKNS_11PxTransformE: __ZN5physx13NpVolumeCache4fillERKNS_10PxGeometryERKNS_11PxTransformE, __ZN20ArchiveStorageHeader15WriteBlocksInfoER12FileAccessorRKNS_10BlocksInfoE: __ZN20ArchiveStorageHeader15WriteBlocksInfoER12FileAccessorRKNS_10BlocksInfoE, __ZThn4_NK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE: __ZThn4_NK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE, __Z51Register_UnityEngine_Profiling_Profiler_BeginSamplev: __Z51Register_UnityEngine_Profiling_Profiler_BeginSamplev, __Z24getPxRevoluteJoint_LimitPKN5physx15PxRevoluteJointE: __Z24getPxRevoluteJoint_LimitPKN5physx15PxRevoluteJointE, __ZN5physx2GuL14testEdgeNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RNS7_5Vec3VENS0_13FeatureStatusERSH_: __ZN5physx2GuL14testEdgeNormalERKNS0_13PolygonalDataES3_PNS0_12SupportLocalES5_RKNS_6shdfnd3aos15PsMatTransformVESA_RKNS7_6FloatVERSB_RNS7_5Vec3VENS0_13FeatureStatusERSH_, __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE: __ZN5physx2Gu31SinglePersistentContactManifold25reduceBatchContactsSphereEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE, __ZNK9InputAxis11GetValueRawEv: __ZNK9InputAxis11GetValueRawEv, __Z21SimulateClothingScenePN5physx7PxSceneE: __Z21SimulateClothingScenePN5physx7PxSceneE, __ZN16BaseVideoTexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16BaseVideoTexture7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE15getGpuParticlesEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE6createERS4_Rb, _tcsetattr: _tcsetattr, __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi: __ZNK10__cxxabiv122__base_class_type_info27has_unambiguous_public_baseEPNS_19__dynamic_cast_infoEPvi, __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_20PxvParticleSystemSimENS0_13TempAllocatorEE6resizeEjRKS3_, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZN5physx9NpFactory17removeClothFabricERNS_13PxClothFabricE: __ZN5physx9NpFactory17removeClothFabricERNS_13PxClothFabricE, __ZN15AnimationBinderD2Ev: __ZN15AnimationBinderD2Ev, __ZN14VRSplashScreenD2Ev: __ZN14VRSplashScreenD2Ev, __ZN7mecanim8skeleton15Skeleton2BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_: __ZN7mecanim8skeleton15Skeleton2BoneIKEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_, __ZNK29UnityWebRequestAsyncOperation7ReleaseEv: __ZNK29UnityWebRequestAsyncOperation7ReleaseEv, __ZN9dtNavMesh25setOffMeshConnectionFlagsEyj: __ZN9dtNavMesh25setOffMeshConnectionFlagsEyj, __ZN13WheelCollider21SetSuspensionDistanceEf: __ZN13WheelCollider21SetSuspensionDistanceEf, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Gradient13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj: __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersRK16DrawBuffersRangejj, __ZN14GfxDeviceStats10ResetFrameEv: __ZN14GfxDeviceStats10ResetFrameEv, __ZNSt3__211timed_mutex4lockEv: __ZNSt3__211timed_mutex4lockEv, __ZN5physx7NpActor26removeConstraintsFromSceneEv: __ZN5physx7NpActor26removeConstraintsFromSceneEv, __Z21GetAnimatableBindTypeRK16TypeTreeIterator: __Z21GetAnimatableBindTypeRK16TypeTreeIterator, __Z17GetPhysicsManagerv: __Z17GetPhysicsManagerv, __ZN12ImageFilters19GetBlitCopyMaterialEv: __ZN12ImageFilters19GetBlitCopyMaterialEv, __Z42Terrain_Set_Custom_PropDetailObjectDensityP12Il2CppObjectf: __Z42Terrain_Set_Custom_PropDetailObjectDensityP12Il2CppObjectf, __Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo: __Z43IsVertexFormatCompatibleWithDynamicBatchingRK14VertexDataInfo, __ZN5physx25PxDefaultFileOutputStream5writeEPKvj: __ZN5physx25PxDefaultFileOutputStream5writeEPKvj, __ZN5Umbra15OcclusionBufferC2ERKS0_: __ZN5Umbra15OcclusionBufferC2ERKS0_, __ZN15FrictionJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15FrictionJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx15PxsArticulation15computeMomentumEPKNS_12PxcFsInertiaE: __ZNK5physx15PxsArticulation15computeMomentumEPKNS_12PxcFsInertiaE, __ZN16StreamedResource8TransferI14SafeBinaryReadEEvRT_: __ZN16StreamedResource8TransferI14SafeBinaryReadEEvRT_, __Z54ParticleSystem_ShapeModule_CUSTOM_GetMeshMaterialIndexP12Il2CppObject: __Z54ParticleSystem_ShapeModule_CUSTOM_GetMeshMaterialIndexP12Il2CppObject, __Z50Register_UnityEngine_GameObject_SendMessageUpwardsv: __Z50Register_UnityEngine_GameObject_SendMessageUpwardsv, __ZN18AwakeFromLoadQueue10ClearQueueEi: __ZN18AwakeFromLoadQueue10ClearQueueEi, __ZNK20LightPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK20LightPropertyBinding12GetPPtrValueERKN11UnityEngine9Animation10BoundCurveE, __ZN5physx2Sc14ConstraintCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc14ConstraintCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN23ShaderVariantCollection13ClearVariantsEv: __ZN23ShaderVariantCollection13ClearVariantsEv, __ZN5physx3Cct17CapsuleController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE: __ZN5physx3Cct17CapsuleController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZN5physx2Sc8BodyCore18setKinematicTargetEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEERKNS_11PxTransformEf: __ZN5physx2Sc8BodyCore18setKinematicTargetEPNS_6shdfnd4PoolINS0_12SimStateDataENS2_19ReflectionAllocatorIS4_EEEERKNS_11PxTransformEf, __Z18GetAnimationBinderv: __Z18GetAnimationBinderv, __Z35ReleaseInstanceLateBehaviourManagerv: __Z35ReleaseInstanceLateBehaviourManagerv, __ZN10SpookyHash5ShortEPKvjPyS2_: __ZN10SpookyHash5ShortEPKvjPyS2_, __Z42LODGroup_Get_Custom_PropAnimateCrossFadingP12Il2CppObject: __Z42LODGroup_Get_Custom_PropAnimateCrossFadingP12Il2CppObject, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN11AudioSource18SetSpatialBlendMixEf: __ZN11AudioSource18SetSpatialBlendMixEf, __ZN5physx18PxcContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx18PxcContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN5physx2Sc13ConstraintSim21checkMaxForceExceededEv: __ZN5physx2Sc13ConstraintSim21checkMaxForceExceededEv, __ZN10SampleClip8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10SampleClip8TransferI24GenerateTypeTreeTransferEEvRT_, __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_: __Z18GetImagePixelBlockI11ColorRGBA32EbPKhii13TextureFormatiiiiPT_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_14NpArticulationEEEEEE15growAndPushBackERKS2_, __ZN5Umbra10Visibility15setOutputBufferEPNS_15OcclusionBufferE: __ZN5Umbra10Visibility15setOutputBufferEPNS_15OcclusionBufferE, __Z40RenderTexture_Set_Custom_PropVolumeDepthP12Il2CppObjecti: __Z40RenderTexture_Set_Custom_PropVolumeDepthP12Il2CppObjecti, __Z15StringToHash128RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z15StringToHash128RKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_: __ZN5physx2Gu3EPA13expandSegmentEPNS0_17EPASupportMapPairERiRKNS_6shdfnd3aos6FloatVES9_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLEc, __ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_: __ZN5physx2Sn17readAllPropertiesINS_16PxSphereGeometryENS_29PxSphereGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_, _UNITY_FT_Matrix_Multiply_Scaled: _UNITY_FT_Matrix_Multiply_Scaled, __ZL26InitializeTextureImageLoadR9Texture2D13TextureFormatjjbR14ImageReferenceR13dynamic_arrayIhLj1EE: __ZL26InitializeTextureImageLoadR9Texture2D13TextureFormatjjbR14ImageReferenceR13dynamic_arrayIhLj1EE, __Z35Light_Set_Custom_PropShadowSoftnessP12Il2CppObjectf: __Z35Light_Set_Custom_PropShadowSoftnessP12Il2CppObjectf, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_13ccdBroadPhaseEPNS_10PxBaseTaskEEEE7getNameEv, __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetApplyFootIKv: __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_SetApplyFootIKv, __ZN7mecanim13CopyValueMaskEPNS_14ValueArrayMaskEPKS0_: __ZN7mecanim13CopyValueMaskEPNS_14ValueArrayMaskEPKS0_, __Z34Application_CUSTOM_GetValueForARGVP12Il2CppString: __Z34Application_CUSTOM_GetValueForARGVP12Il2CppString, __ZN14SplatMaterials20UpdateSplatMaterialsEP8Materialb: __ZN14SplatMaterials20UpdateSplatMaterialsEP8Materialb, __ZN6Shader7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Shader7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK9Heightmap25ComputeMaximumHeightErrorEiii: __ZNK9Heightmap25ComputeMaximumHeightErrorEiii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __Z47Register_UnityEngine_Motion_get_averageDurationv: __Z47Register_UnityEngine_Motion_get_averageDurationv, __ZN5physx2Gu19computeMTD_PlaneBoxERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_3BoxE: __ZN5physx2Gu19computeMTD_PlaneBoxERNS_6PxVec3ERfRKNS_7PxPlaneERKNS0_3BoxE, __ZN13b2DynamicTreeD2Ev: __ZN13b2DynamicTreeD2Ev, __Z40setPxJointLimitParametersBounceThresholdPN5physx22PxJointLimitParametersEf: __Z40setPxJointLimitParametersBounceThresholdPN5physx22PxJointLimitParametersEf, __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j: __ZNK5physx25PxRigidActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j, __ZN11HaloManager4HaloC2ERK8Vector3fRK11ColorRGBA32fij: __ZN11HaloManager4HaloC2ERK8Vector3fRK11ColorRGBA32fij, __ZN11DynamicMesh10AddPolygonEPKtRKij: __ZN11DynamicMesh10AddPolygonEPKtRKij, __ZN2UIL8PopulateERNS_23RenderableUIInstructionERKNS_13UIInstructionEib: __ZN2UIL8PopulateERNS_23RenderableUIInstructionERKNS_13UIInstructionEib, __ZNK9Animation26GetTypeInfoVirtualInternalEv: __ZNK9Animation26GetTypeInfoVirtualInternalEv, __ZN13dynamic_arrayI8Vector4fLj4EEC2ERKS1_: __ZN13dynamic_arrayI8Vector4fLj4EEC2ERKS1_, __Z38ParticleSystem_Get_Custom_PropDurationP12Il2CppObject: __Z38ParticleSystem_Get_Custom_PropDurationP12Il2CppObject, __ZN5physx2Sc7ElementD0Ev: __ZN5physx2Sc7ElementD0Ev, __Z46GIDebugVisualisation_CUSTOM_CycleSkipInstancesi: __Z46GIDebugVisualisation_CUSTOM_CycleSkipInstancesi, __ZNSt3__26vectorI17MessageIdentifierNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI17MessageIdentifierNS_9allocatorIS1_EEE8__appendEj, __Z64Register_UnityEngine_Application_ReplyToUserAuthorizationRequestv: __Z64Register_UnityEngine_Application_ReplyToUserAuthorizationRequestv, _fseek_file_func: _fseek_file_func, __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_: __ZNK9Transform29TransformPointWithLocalOffsetERK8Vector3fS2_, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen14UnityLogoStyleEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN26PlayerSettingsSplashScreen14UnityLogoStyleEEvRT_RT0_PKc17TransferMetaFlags, __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE: __ZN5physx2Sc19ConstraintGroupNodeC2ERNS0_7BodySimE, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularZLimitv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularZLimitv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj542ENS_22PxRepXPropertyAccessorILj542ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj542ENS_22PxRepXPropertyAccessorILj542ES4_ffEEEEvRKT0_, __Z39getPxRigidBody_MinCCDAdvanceCoefficientPKN5physx11PxRigidBodyE: __Z39getPxRigidBody_MinCCDAdvanceCoefficientPKN5physx11PxRigidBodyE, __Z29BakePxMeshStreamFromUnityMeshP4MeshbbbR13dynamic_arrayIhLj1EE: __Z29BakePxMeshStreamFromUnityMeshP4MeshbbbR13dynamic_arrayIhLj1EE, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, __ZN10__cxxabiv116__enum_type_infoD0Ev: __ZN10__cxxabiv116__enum_type_infoD0Ev, __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z34GetParticlesLegacyScriptingClassesv: __Z34GetParticlesLegacyScriptingClassesv, __ZNK5physx7NpCloth7getTypeEv: __ZNK5physx7NpCloth7getTypeEv, __ZN23AllocationRootReferenceD2Ev: __ZN23AllocationRootReferenceD2Ev, __ZN4PPtrI11TerrainDataE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI11TerrainDataE8TransferI14SafeBinaryReadEEvRT_, __Z44TerrainData_Get_Custom_PropWavingGrassAmountP12Il2CppObject: __Z44TerrainData_Get_Custom_PropWavingGrassAmountP12Il2CppObject, __ZN9GfxDevice23ClearRandomWriteTargetsEv: __ZN9GfxDevice23ClearRandomWriteTargetsEv, __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_Scale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN12_GLOBAL__N_141SphereMeshContactGenerationCallback_Scale10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __ZN23ForwardShaderRenderLoop14CollectShadowsER17ShadowCachingDataRK15SharedLightDatabbR17ShaderPassContext: __ZN23ForwardShaderRenderLoop14CollectShadowsER17ShadowCachingDataRK15SharedLightDatabbR17ShaderPassContext, __ZN22VirtualJoystickManager32SetVirtualJoystickConnectedStateEPKcb: __ZN22VirtualJoystickManager32SetVirtualJoystickConnectedStateEPKcb, __Z29dtAllocObstacleAvoidanceQueryv: __Z29dtAllocObstacleAvoidanceQueryv, __Z30Animator_CUSTOM_StartRecordingP12Il2CppObjecti: __Z30Animator_CUSTOM_StartRecordingP12Il2CppObjecti, __Z14TestPlanesAABBPK5PlaneiRK4AABB: __Z14TestPlanesAABBPK5PlaneiRK4AABB, __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS3_PNS_11__tree_nodeIS3_SD_EEiEESG_RKT_, __ZN23RayMeshColliderCallbackD0Ev: __ZN23RayMeshColliderCallbackD0Ev, __ZN5physx10PxsContext19destroyArticulationERNS_15PxsArticulationE: __ZN5physx10PxsContext19destroyArticulationERNS_15PxsArticulationE, __ZN20OcclusionCullingData23VirtualRedirectTransferER14SafeBinaryRead: __ZN20OcclusionCullingData23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE8__appendEj: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE8__appendEj, __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE: __ZN5physx2Sc18ParticleSystemCore24setParticleReadDataFlagsENS_7PxFlagsINS_22PxParticleReadDataFlag4EnumEtEE, __ZN16LevelGameManagerD2Ev: __ZN16LevelGameManagerD2Ev, __ZN5physx32PxVehicleComputeTireForceDefaultEPKvffffffffffffRfS2_S2_S2_: __ZN5physx32PxVehicleComputeTireForceDefaultEPKvffffffffffffRfS2_S2_S2_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj145ENS_22PxRepXPropertyAccessorILj145ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj120ENS_22PxRepXPropertyAccessorILj120ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj120ENS_22PxRepXPropertyAccessorILj120ES4_ffEEEEvRKT0_, __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE: __Z11CallDelayedPF15CallObjectStateP6ObjectPvE4PPtrIS0_EfS2_fPFS_S2_EN18DelayedCallManager15DelayedCallModeE, __ZN17AnimationPlayable19DeallocateResourcesEv: __ZN17AnimationPlayable19DeallocateResourcesEv, __ZN13SpeedTreeWind7SParamsC2Ev: __ZN13SpeedTreeWind7SParamsC2Ev, __ZNK5physx7NpShape13getRestOffsetEv: __ZNK5physx7NpShape13getRestOffsetEv, __ZN9JSONWrite8TransferINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI10RectOffset13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZN18PlatformEffector2D12CleanupClassEv: __ZN18PlatformEffector2D12CleanupClassEv, __GLOBAL__sub_I_runtime_math_random_lump_cpp: __GLOBAL__sub_I_runtime_math_random_lump_cpp, __ZN5physx6shdfnd9MutexImplC2Ev: __ZN5physx6shdfnd9MutexImplC2Ev, __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIiEEvRT_PKc17TransferMetaFlagsb, __ZNKSt3__210moneypunctIcLb1EE16do_negative_signEv: __ZNKSt3__210moneypunctIcLb1EE16do_negative_signEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_30PxVehicleAckermannGeometryDataEE8pushNameEPKc, __Z64Register_UnityEngine_Connect_UnityAdsSettings_SetPlatformEnabledv: __Z64Register_UnityEngine_Connect_UnityAdsSettings_SetPlatformEnabledv, __Z41AndroidJNI_CUSTOM_CallStaticBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z41AndroidJNI_CUSTOM_CallStaticBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray, _UNITY_FT_Set_Char_Size: _UNITY_FT_Set_Char_Size, __ZN14NavMeshManager18UpdateOffMeshLinksEv: __ZN14NavMeshManager18UpdateOffMeshLinksEv, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIjEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIjEEEvRT_PKc17TransferMetaFlags, __ZN5physx6shdfnd10ThreadImpl4quitEv: __ZN5physx6shdfnd10ThreadImpl4quitEv, __ZNK16BaseVideoTexture12GetDimensionEv: __ZNK16BaseVideoTexture12GetDimensionEv, __Z38Rigidbody2D_Get_Custom_PropAngularDragP12Il2CppObject: __Z38Rigidbody2D_Get_Custom_PropAngularDragP12Il2CppObject, __Z11IntToStringi: __Z11IntToStringi, _jpeg_abort: _jpeg_abort, __ZNSt3__26vectorIP18SpeedTreeLocalWind13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_: __ZNSt3__26vectorIP18SpeedTreeLocalWind13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE6insertENS_11__wrap_iterIPKS2_EERS8_, __Z24RegisterStrippedTypeInfoI15PointEffector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15PointEffector2DEviPKcS2_, __Z49Register_UnityEngine_Transform_get_hierarchyCountv: __Z49Register_UnityEngine_Transform_get_hierarchyCountv, __ZNKSt3__220__codecvt_utf8_utf16IDiE11do_encodingEv: __ZNKSt3__220__codecvt_utf8_utf16IDiE11do_encodingEv, __GLOBAL__sub_I_runtime_scripting_lump_cpp: __GLOBAL__sub_I_runtime_scripting_lump_cpp, __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv: __ZN5physx2Sq17SceneQueryManager12flushUpdatesEv, __ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv123__fundamental_type_info9can_catchEPKNS_16__shim_type_infoERPv, __Z36Camera_CUSTOM_INTERNAL_set_pixelRectP12Il2CppObjectRK5RectTIfE: __Z36Camera_CUSTOM_INTERNAL_set_pixelRectP12Il2CppObjectRK5RectTIfE, __ZNK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZNK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZNK11UnityEngine9Animation28GenericAnimationBindingCache30CurveAttributeToSerializedPathER10GameObjectRK18EditorCurveBinding: __ZNK11UnityEngine9Animation28GenericAnimationBindingCache30CurveAttributeToSerializedPathER10GameObjectRK18EditorCurveBinding, __ZNK14RenderSettings6GetSunEv: __ZNK14RenderSettings6GetSunEv, __ZN4gles20TextureIDFromSurfaceEP17RenderSurfaceGLESj: __ZN4gles20TextureIDFromSurfaceEP17RenderSurfaceGLESj, __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIN7mecanim12statemachine17ConditionConstantEEEvRT_PKc17TransferMetaFlags, __Z54Register_UnityEngine_Terrain_set_treeBillboardDistancev: __Z54Register_UnityEngine_Terrain_set_treeBillboardDistancev, __ZN15QualitySettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15QualitySettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim5human6HandleEEEEvRT_17TransferMetaFlags, __ZN13PhysicsModule20GetRigidBodyVelocityERK9Rigidbody: __ZN13PhysicsModule20GetRigidBodyVelocityERK9Rigidbody, __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEvRT_PKc17TransferMetaFlags, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags, __ZN5physx13NpClothFabric8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx13NpClothFabric8requiresERNS_23PxProcessPxBaseCallbackE, __Z20setPxSpringStiffnessPN5physx8PxSpringEf: __Z20setPxSpringStiffnessPN5physx8PxSpringEf, __Z30RegisterModuleClasses_Vehiclesv: __Z30RegisterModuleClasses_Vehiclesv, __ZN5physx15PxSetGroupsMaskERNS_7PxActorERKNS_12PxGroupsMaskE: __ZN5physx15PxSetGroupsMaskERNS_7PxActorERKNS_12PxGroupsMaskE, __Z37HingeJoint_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP11JointLimits: __Z37HingeJoint_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP11JointLimits, __ZN12BaseRenderer25FlattenSharedMaterialDataILb1EEEbRS_R22PerThreadPageAllocatorR10RenderNode: __ZN12BaseRenderer25FlattenSharedMaterialDataILb1EEEbRS_R22PerThreadPageAllocatorR10RenderNode, _UNITY_LZ4_versionNumber: _UNITY_LZ4_versionNumber, __ZN9AudioClip28ScriptPCMSetPositionCallbackEP10FMOD_SOUNDijj: __ZN9AudioClip28ScriptPCMSetPositionCallbackEP10FMOD_SOUNDijj, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEw: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4fillEw, __Z38WindZone_Set_Custom_PropWindTurbulenceP12Il2CppObjectf: __Z38WindZone_Set_Custom_PropWindTurbulenceP12Il2CppObjectf, __Z39setPxSphericalJoint_SphericalJointFlagsPN5physx16PxSphericalJointENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE: __Z39setPxSphericalJoint_SphericalJointFlagsPN5physx16PxSphericalJointENS_7PxFlagsINS_20PxSphericalJointFlag4EnumEtEE, __ZN5physx20InternalTriangleMesh15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx20InternalTriangleMesh15exportExtraDataERNS_22PxSerializationContextE, __Z43scripting_liveness_calculation_from_staticsPv: __Z43scripting_liveness_calculation_from_staticsPv, __ZNK5physx2Sc8BodyCore26getHasValidKinematicTargetEv: __ZNK5physx2Sc8BodyCore26getHasValidKinematicTargetEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI27ComputeShaderBuiltinSamplerNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZThn4_N5physx5cloth8SwSolver11removeClothEPNS0_5ClothE: __ZThn4_N5physx5cloth8SwSolver11removeClothEPNS0_5ClothE, __Z17FastCompressImageiiPKhPhbb: __Z17FastCompressImageiiPKhPhbb, _jinit_marker_reader: _jinit_marker_reader, __ZThn32_NK17BillboardRenderer16GetMaterialCountEv: __ZThn32_NK17BillboardRenderer16GetMaterialCountEv, __Z31GUIText_Get_Custom_PropRichTextP12Il2CppObject: __Z31GUIText_Get_Custom_PropRichTextP12Il2CppObject, __ZN8DateTime10IsLeapYearEi: __ZN8DateTime10IsLeapYearEi, __ZNK21FullParameterPreparer15OnPrepareMatrixER12PartialArrayI10Matrix4x4fERKN20GpuProgramParameters14ValueParameterEj: __ZNK21FullParameterPreparer15OnPrepareMatrixER12PartialArrayI10Matrix4x4fERKN20GpuProgramParameters14ValueParameterEj, __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9UnityGUID8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx5cloth13UserAllocatedD0Ev: __ZN5physx5cloth13UserAllocatedD0Ev, __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_: __ZN10Matrix4x4f18SetBasisTransposedERK8Vector3fS2_S2_, __ZN9TextAsset8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9TextAsset8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN17PersistentManager38LoadAndIntegrateAllPreallocatedObjectsEv: __ZN17PersistentManager38LoadAndIntegrateAllPreallocatedObjectsEv, __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv: __ZNK33AssetBundleLoadFromAsyncOperation12GetResultStrEv, __Z44NavMeshAgent_Set_Custom_PropStoppingDistanceP12Il2CppObjectf: __Z44NavMeshAgent_Set_Custom_PropStoppingDistanceP12Il2CppObjectf, __Z28Font_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z28Font_Set_Custom_PropMaterialP12Il2CppObjectS0_, __ZNSt3__26locale5__imp7installINS_15messages_bynameIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15messages_bynameIwEEEEvPT_, __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskC2ERNS0_7SwClothERNS1_17EndSimulationTaskE: __ZN5physx5cloth8SwSolver22CpuClothSimulationTaskC2ERNS0_7SwClothERNS1_17EndSimulationTaskE, __Z31GameObject_Get_Custom_PropLayerP12Il2CppObject: __Z31GameObject_Get_Custom_PropLayerP12Il2CppObject, __ZN9ShaderLab11shaderprops9GetTexEnvEPK19ShaderPropertySheetS3_NS_16FastPropertyNameE16TextureDimensionRNS0_16PropertyLocationE: __ZN9ShaderLab11shaderprops9GetTexEnvEPK19ShaderPropertySheetS3_NS_16FastPropertyNameE16TextureDimensionRNS0_16PropertyLocationE, __ZNK5Umbra4Tome12getCellCountEv: __ZNK5Umbra4Tome12getCellCountEv, __ZN8Renderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8Renderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN17GeneralConnectionC2Ev: __ZN17GeneralConnectionC2Ev, __ZN9GfxDevice26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID: __ZN9GfxDevice26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID, __Z64Register_UnityEngine_SceneManagement_Scene_GetBuildIndexInternalv: __Z64Register_UnityEngine_SceneManagement_Scene_GetBuildIndexInternalv, __Z24RegisterModule_Physics2Dv: __Z24RegisterModule_Physics2Dv, __Z30Shader_CUSTOM_SetGlobalTextureiP12Il2CppObject: __Z30Shader_CUSTOM_SetGlobalTextureiP12Il2CppObject, __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E: __Z19AddCurveToDenseClipI8Vector3fEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseNumberILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __Z23Texture2D_CUSTOM_ResizeP12Il2CppObjectii13TextureFormath: __Z23Texture2D_CUSTOM_ResizeP12Il2CppObjectii13TextureFormath, __ZN12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj: __ZN12_GLOBAL__N_110DataStream21createPropertyMessageERKN5physx8debugger14NamespacedNameES5_NS2_7DataRefINS2_18PropertyMessageArgEEEj, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEE14handleAccessorILj65ENS_22PxRepXPropertyAccessorILj65ES4_RKNS_6PxVec3ES9_EEEEvRKT0_, __ZN10MonoScript8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10MonoScript8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN23ArchiveStorageConverterC2EP32IArchiveStorageConverterListenerb: __ZN23ArchiveStorageConverterC2EP32IArchiveStorageConverterListenerb, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15setParticleMassEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE15setParticleMassEf, __ZN4FMOD6SoundI17get3DConeSettingsEPfS1_S1_: __ZN4FMOD6SoundI17get3DConeSettingsEPfS1_S1_, __Z38Register_UnityEngine_TextMesh_set_textv: __Z38Register_UnityEngine_TextMesh_set_textv, __ZN17Physics2DSettings16CheckConsistencyEv: __ZN17Physics2DSettings16CheckConsistencyEv, __ZN12_GLOBAL__N_116MetaDataProvider14createInstanceERKN5physx8debugger14NamespacedNameEPKv: __ZN12_GLOBAL__N_116MetaDataProvider14createInstanceERKN5physx8debugger14NamespacedNameEPKv, __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeIN17GeneralConnection9MessageIDEPFvPKvjjEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z16IntersectRayAABBRK3RayRK4AABBPfS5_: __Z16IntersectRayAABBRK3RayRK4AABBPfS5_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS3_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E: __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E, __ZN21DownloadHandlerScript21OnBindScriptingObjectEP12Il2CppObject: __ZN21DownloadHandlerScript21OnBindScriptingObjectEP12Il2CppObject, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj, __ZN5Umbra5Query11setThreadIdEj: __ZN5Umbra5Query11setThreadIdEj, __ZN22MemoryCacherReadBlocks18GetAddressOfMemoryEv: __ZN22MemoryCacherReadBlocks18GetAddressOfMemoryEv, __Z30Sampler_Get_Custom_PropEnabledP12Il2CppObject: __Z30Sampler_Get_Custom_PropEnabledP12Il2CppObject, __ZN17ProfilerFrameData30DeserializeProfilerInformationEPPib: __ZN17ProfilerFrameData30DeserializeProfilerInformationEPPib, __ZN11AudioFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11AudioFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __Z16GetUpdateManagerv: __Z16GetUpdateManagerv, __ZN17ArchiveFileSystem6DeleteER13FileEntryDatab: __ZN17ArchiveFileSystem6DeleteER13FileEntryDatab, __ZN5physx2Gu9Container6ResizeEj: __ZN5physx2Gu9Container6ResizeEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _rint: _rint, __Z46Register_UnityEngine_Time_get_maximumDeltaTimev: __Z46Register_UnityEngine_Time_get_maximumDeltaTimev, __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI6ShaderE8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIhhEEPhEEjT0_S5_S5_S5_S5_T_, __Z53Register_UnityEngine_BuoyancyEffector2D_set_flowAnglev: __Z53Register_UnityEngine_BuoyancyEffector2D_set_flowAnglev, __Z50ParticleSystem_SubEmittersModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z50ParticleSystem_SubEmittersModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z51Register_UnityEngine_RenderSettings_get_ambientModev: __Z51Register_UnityEngine_RenderSettings_get_ambientModev, __Z51Playable_CUSTOM_INTERNAL_CALL_GetInputCountInternalR9HPlayable: __Z51Playable_CUSTOM_INTERNAL_CALL_GetInputCountInternalR9HPlayable, __ZL29CalculateSphericalShadowRangeRK6CameraR8Vector3fRf: __ZL29CalculateSphericalShadowRangeRK6CameraR8Vector3fRf, __ZN11TypeManager41GetDeserializationStubForPersistentTypeIDEi: __ZN11TypeManager41GetDeserializationStubForPersistentTypeIDEi, _UNITY_FT_Bitmap_Convert: _UNITY_FT_Bitmap_Convert, _listen: _listen, __Z46LocationService_Get_Custom_PropIsEnabledByUserP12Il2CppObject: __Z46LocationService_Get_Custom_PropIsEnabledByUserP12Il2CppObject, __Z19pointConvexDistanceRN5physx6PxVec3ES1_RfRKS0_PKNS_2Gu10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformE: __Z19pointConvexDistanceRN5physx6PxVec3ES1_RfRKS0_PKNS_2Gu10ConvexMeshERKNS_11PxMeshScaleERKNS_11PxTransformE, __Z38Physics_Set_Custom_PropBounceThresholdf: __Z38Physics_Set_Custom_PropBounceThresholdf, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE6isGoodEv: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE6isGoodEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __Z33getPxRevoluteJoint_DriveGearRatioPKN5physx15PxRevoluteJointE: __Z33getPxRevoluteJoint_DriveGearRatioPKN5physx15PxRevoluteJointE, __ZN5physx10poseWheelsERKNS_23PxVehicleWheels4SimDataEPKNS_11PxTransformEjPNS_14PxRigidDynamicE: __ZN5physx10poseWheelsERKNS_23PxVehicleWheels4SimDataEPKNS_11PxTransformEjPNS_14PxRigidDynamicE, __ZN15NavMeshObstacle11SetVelocityERK8Vector3f: __ZN15NavMeshObstacle11SetVelocityERK8Vector3f, __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_: __ZN10Collider2D8TransferI14SafeBinaryReadEEvRT_, __Z26GarbageCollectSharedAssetsb: __Z26GarbageCollectSharedAssetsb, __ZNK5physx2Gu11HeightField8getFlagsEv: __ZNK5physx2Gu11HeightField8getFlagsEv, __ZN10DynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb: __ZN10DynamicVBO13HandleToChunkERK21DynamicVBOChunkHandleb, __Z45Register_UnityEngine_Light_set_shadowStrengthv: __Z45Register_UnityEngine_Light_set_shadowStrengthv, _iswalnum: _iswalnum, __ZNSt3__218__stable_sort_moveIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeE: __ZNSt3__218__stable_sort_moveIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_T_NS_15iterator_traitsISK_E15difference_typeEPNSN_10value_typeE, __ZNK5physx19PxClothFabricCooker4saveERNS_14PxOutputStreamEb: __ZNK5physx19PxClothFabricCooker4saveERNS_14PxOutputStreamEb, __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE20getExternalReferenceERj, __ZN5physx27PxConstraintGeneratedValuesC2EPKNS_12PxConstraintE: __ZN5physx27PxConstraintGeneratedValuesC2EPKNS_12PxConstraintE, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28getMotionConstraintStiffnessEv, __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorI8GUIStyle13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj, __ZN19SpriteMeshGenerator4path4clipEv: __ZN19SpriteMeshGenerator4path4clipEv, __ZNK11Rigidbody2D11GetRotationEv: __ZNK11Rigidbody2D11GetRotationEv, __ZN4FMOD5Sound7setModeEj: __ZN4FMOD5Sound7setModeEj, __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv, __ZN14PhysicsManager19CreateDynamicsSceneEbb: __ZN14PhysicsManager19CreateDynamicsSceneEbb, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN20TextRenderingPrivate8FontImpl13CharacterInfoELj4EEEEvRT_17TransferMetaFlags, __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_: __ZN14qsort_internal31_FindAndMovePivotToLastPositionIP21CompactCasterSortDatai28CompactShadowCasterKeySorterEEvT_S4_T0_T1_, __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv: __ZN20TextRenderingPrivate8TextMesh17SetupMeshRendererEv, __ZN13SparseTexture11InitTextureEii13TextureFormatib: __ZN13SparseTexture11InitTextureEii13TextureFormatib, __ZN17PersistentManager21RemoveObjectsFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager21RemoveObjectsFromPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN13BoxCollider2D10SmartResetEv: __ZN13BoxCollider2D10SmartResetEv, __Z34Terrain_Get_Custom_PropCastShadowsP12Il2CppObject: __Z34Terrain_Get_Custom_PropCastShadowsP12Il2CppObject, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEcj, __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairIN9ShaderLab16FastPropertyNameEfEEE8TransferI18StreamedBinaryReadILb0EEEEvRS4_RT_, __ZNK17BillboardRenderer16GetMaterialCountEv: __ZNK17BillboardRenderer16GetMaterialCountEv, __ZN4FMOD7Channel12getLoopCountEPi: __ZN4FMOD7Channel12getLoopCountEPi, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim4hand4HandEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim4hand4HandEEEEvRT_PKc17TransferMetaFlags, __ZNSt3__216__narrow_to_utf8ILj32EED0Ev: __ZNSt3__216__narrow_to_utf8ILj32EED0Ev, __ZN12_GLOBAL__N_112RenderReaderILb0EE6isGoodEv: __ZN12_GLOBAL__N_112RenderReaderILb0EE6isGoodEv, __ZN4gles25CreateRenderSurfaceCommonEP7ApiGLESP17RenderSurfaceGLES: __ZN4gles25CreateRenderSurfaceCommonEP7ApiGLESP17RenderSurfaceGLES, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z46Register_UnityEngine_GUIStyle_AssignRectOffsetv: __Z46Register_UnityEngine_GUIStyle_AssignRectOffsetv, __ZN8UserList7ReserveEj: __ZN8UserList7ReserveEj, __ZN13ScreenManager21SetCursorInsideWindowEb: __ZN13ScreenManager21SetCursorInsideWindowEb, __ZN20ComputeBufferCounter8TransferI14SafeBinaryReadEEvRT_: __ZN20ComputeBufferCounter8TransferI14SafeBinaryReadEEvRT_, __ZN15SerializeTraitsINSt3__24pairINS1_IttEEfEEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairINS1_IttEEfEEE8TransferI14SafeBinaryReadEEvRS3_RT_, _UNITY_png_get_iCCP: _UNITY_png_get_iCCP, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3E, __ZN14DetailRenderer16ReloadAllDetailsEv: __ZN14DetailRenderer16ReloadAllDetailsEv, __ZN5Unity11Adjacencies7AddEdgeEjjj: __ZN5Unity11Adjacencies7AddEdgeEjjj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_, __ZNK24TreeIntermediateRenderer8GetLayerEv: __ZNK24TreeIntermediateRenderer8GetLayerEv, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE22GetAllocatedMemorySizeEv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE22GetAllocatedMemorySizeEv, __Z55Register_UnityEngine_Material_Internal_CreateWithShaderv: __Z55Register_UnityEngine_Material_Internal_CreateWithShaderv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE6createERSB_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IPKNS_12PxsRigidCoreEPKNS_12PxsShapeCoreEEEPNS_11PxsCCDShapeEEESA_NS0_4HashISA_EENS1_11HashMapBaseISA_SD_SG_NS0_9AllocatorEE6GetKeyESI_Lb1EE6createERSB_Rb, __ZNK12HandlerChain6TargetERK13FileEntryDataR15FileSystemEntry: __ZNK12HandlerChain6TargetERK13FileEntryDataR15FileSystemEntry, __ZN4FMOD6SoundI15getNumSubSoundsEPi: __ZN4FMOD6SoundI15getNumSubSoundsEPi, __Z33CalculateTriangleAreaRotationlessP8Vector3ffffRS_: __Z33CalculateTriangleAreaRotationlessP8Vector3ffffRS_, __ZN5physx2Sc5Scene15setScratchBlockEPvj: __ZN5physx2Sc5Scene15setScratchBlockEPvj, __ZN18PlatformEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18PlatformEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN7mecanim9animation24CreateControllerConstantEjPPNS0_13LayerConstantEjPPNS_12statemachine20StateMachineConstantEPNS_18ValueArrayConstantEPNS_10ValueArrayEjRNS_6memory9AllocatorE: __ZN7mecanim9animation24CreateControllerConstantEjPPNS0_13LayerConstantEjPPNS_12statemachine20StateMachineConstantEPNS_18ValueArrayConstantEPNS_10ValueArrayEjRNS_6memory9AllocatorE, __ZN4FMOD7Channel4stopEv: __ZN4FMOD7Channel4stopEv, __ZN25b2PolygonAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN25b2PolygonAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __Z49Register_UnityEngine_ParticleSystem_Internal_Playv: __Z49Register_UnityEngine_ParticleSystem_Internal_Playv, __Z47SurfaceEffector2D_Set_Custom_PropSpeedVariationP12Il2CppObjectf: __Z47SurfaceEffector2D_Set_Custom_PropSpeedVariationP12Il2CppObjectf, __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z18Transfer_BlittableI8JSONReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10SampleClip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10SampleClip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z52Register_UnityEngine_Rigidbody2D_set_angularVelocityv: __Z52Register_UnityEngine_Rigidbody2D_set_angularVelocityv, __ZN5physx8debugger14PvdMarshallingIsfE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsfE12marshalBlockEPKhPhj, __ZNSt3__213random_deviceclEv: __ZNSt3__213random_deviceclEv, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16setInvMassScale0Ef, __Z49ParticleSystem_ShapeModule_CUSTOM_SetMeshRendererP12Il2CppObjectS0_: __Z49ParticleSystem_ShapeModule_CUSTOM_SetMeshRendererP12Il2CppObjectS0_, __ZN21AssetBundleFileSystemD2Ev: __ZN21AssetBundleFileSystemD2Ev, __ZN22VertexDeclarationCache13GetVertexDeclERK18VertexChannelsInfo: __ZN22VertexDeclarationCache13GetVertexDeclERK18VertexChannelsInfo, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_8ios_baseES5_E: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRNS_8ios_baseES5_E, __ZN15PointEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15PointEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_: __ZN9Scripting21GetOverrideMethodOnlyEPKcP11Il2CppClassS3_, __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_Rj: __ZNK5Umbra15ShadowCullerExt12isAABBActiveERKNS_7Vector3ES3_Rj, __ZN11AudioSource20SetBypassReverbZonesEb: __ZN11AudioSource20SetBypassReverbZonesEb, __Z46ParticleSystem_ShapeModule_CUSTOM_GetShapeTypeP12Il2CppObject: __Z46ParticleSystem_ShapeModule_CUSTOM_GetShapeTypeP12Il2CppObject, __Z29CalculateClippedBoxConvexHullPfPKfff: __Z29CalculateClippedBoxConvexHullPfPKfff, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIwEE, __Z44Physics2D_Get_Custom_PropMaxLinearCorrectionv: __Z44Physics2D_Get_Custom_PropMaxLinearCorrectionv, __Z56Register_UnityEngine_RenderTexture_Internal_GetDimensionv: __Z56Register_UnityEngine_RenderTexture_Internal_GetDimensionv, __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE: __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_3setIiNS0_4lessIiEENS4_IiEEEE, __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient: __Z49ParticleSystem_ColorBySpeedModule_CUSTOM_GetColorP12Il2CppObjectR18MonoMinMaxGradient, __ZNK9WWWCached7GetTypeEv: __ZNK9WWWCached7GetTypeEv, __Z13GetStacktracei: __Z13GetStacktracei, __Z24RegisterStrippedTypeInfoI9HaloLayerEviPKcS2_: __Z24RegisterStrippedTypeInfoI9HaloLayerEviPKcS2_, __Z42UNetWebGlHelpers_CUSTOM_InitUpdateFunctionv: __Z42UNetWebGlHelpers_CUSTOM_InitUpdateFunctionv, __ZN9Transform24MakeEditorValuesLookNiceEv: __ZN9Transform24MakeEditorValuesLookNiceEv, __ZN5physx2Sc5Scene18getParticleSystemsEv: __ZN5physx2Sc5Scene18getParticleSystemsEv, __Z13classifyPointPKfS0_S0_: __Z13classifyPointPKfS0_S0_, __ZN14ShadowSettings8TransferI14SafeBinaryReadEEvRT_: __ZN14ShadowSettings8TransferI14SafeBinaryReadEEvRT_, __ZN13MonoBehaviour12CleanupClassEv: __ZN13MonoBehaviour12CleanupClassEv, __ZN20TextRenderingPrivate8TextMesh7SetTextERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN20TextRenderingPrivate8TextMesh7SetTextERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN14AudioBehaviourD0Ev: __ZN14AudioBehaviourD0Ev, __ZN5physx26collideCellsWithStaticMeshEPNS_19PxsParticleCollDataERKNS_21PxsFluidLocalCellHashERKNS_2Gu13GeometryUnionERKNS_11PxTransformESB_fffRKNS_6PxVec3E: __ZN5physx26collideCellsWithStaticMeshEPNS_19PxsParticleCollDataERKNS_21PxsFluidLocalCellHashERKNS_2Gu13GeometryUnionERKNS_11PxTransformESB_fffRKNS_6PxVec3E, __Z14GetDeviceColorRK10ColorRGBAf: __Z14GetDeviceColorRK10ColorRGBAf, __ZN20HardwareInfoReporter15InitializeClassEv: __ZN20HardwareInfoReporter15InitializeClassEv, __ZN13GfxDeviceGLES28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE: __ZN13GfxDeviceGLES28CreateComputeConstantBuffersEjPKjP12ObjectHandleI18ConstantBuffer_TagPvE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8get_dateES4_S4_RNS_8ios_baseERjP2tm, __ZN15ReflectionProbe28SetProbeDirtyAndCheckRefreshEv: __ZN15ReflectionProbe28SetProbeDirtyAndCheckRefreshEv, __ZN5physx20solve1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx20solve1DConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z45Register_UnityEngine_Collider2D_set_isTriggerv: __Z45Register_UnityEngine_Collider2D_set_isTriggerv, __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI14SafeBinaryReadEEvRT_, __ZNK9CGProgram26GetTypeInfoVirtualInternalEv: __ZNK9CGProgram26GetTypeInfoVirtualInternalEv, __ZN9SubModule13AddSubEmitterEP14ParticleSystem21ParticleSystemSubTypei: __ZN9SubModule13AddSubEmitterEP14ParticleSystem21ParticleSystemSubTypei, _tt_size_done_bytecode: _tt_size_done_bytecode, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv, _SendMessageFloat: _SendMessageFloat, __ZN18ScriptingArguments10GetInt64AtEi: __ZN18ScriptingArguments10GetInt64AtEi, __Z29Rigidbody_Get_Custom_PropDragP12Il2CppObject: __Z29Rigidbody_Get_Custom_PropDragP12Il2CppObject, __ZN5Umbra12StreamReader14readLineAppendERNS_5ArrayIcEE: __ZN5Umbra12StreamReader14readLineAppendERNS_5ArrayIcEE, __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Cm19visualizeDoubleConeERNS0_12RenderOutputEfRKNS_11PxTransformEfb: __ZN5physx2Cm19visualizeDoubleConeERNS0_12RenderOutputEfRKNS_11PxTransformEfb, __ZN5physx16PxVehicleDrive4W5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj: __ZN5physx16PxVehicleDrive4W5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_23PxVehicleDriveSimData4WEj, __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12ScriptMapper23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z30getPxVehicleTireDataMLatStiffYPKN5physx17PxVehicleTireDataE: __Z30getPxVehicleTireDataMLatStiffYPKN5physx17PxVehicleTireDataE, __ZN10MeshFilter12OnDidAddMeshEv: __ZN10MeshFilter12OnDidAddMeshEv, __ZN5Umbra5Query4initEPKNS_14TomeCollectionE: __ZN5Umbra5Query4initEPKNS_14TomeCollectionE, __ZN9Transform16CheckConsistencyEv: __ZN9Transform16CheckConsistencyEv, __ZN4crnd25static_huffman_data_modelC2ERKS0_: __ZN4crnd25static_huffman_data_modelC2ERKS0_, __ZNK15DownloadHandler6IsDoneEv: __ZNK15DownloadHandler6IsDoneEv, __Z54Register_UnityEngine_Analytics_CustomEventData_AddBytev: __Z54Register_UnityEngine_Analytics_CustomEventData_AddBytev, __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z38Rigidbody_Get_Custom_PropInterpolationP12Il2CppObject: __Z38Rigidbody_Get_Custom_PropInterpolationP12Il2CppObject, __Z21GetScriptingArraySizeP11Il2CppArray: __Z21GetScriptingArraySizeP11Il2CppArray, __ZN5physx11NodeManagerD2Ev: __ZN5physx11NodeManagerD2Ev, __ZNK5physx2Sc15ArticulationSim13getLinkHandleERNS0_7BodySimE: __ZNK5physx2Sc15ArticulationSim13getLinkHandleERNS0_7BodySimE, __ZNK5physx5cloth8SwSolver8endFrameEv: __ZNK5physx5cloth8SwSolver8endFrameEv, __ZN24RigidbodyMovementState2D21SetInterpolationStateEv: __ZN24RigidbodyMovementState2D21SetInterpolationStateEv, __Z57Register_UnityEngine_Canvas_get_normalizedSortingGridSizev: __Z57Register_UnityEngine_Canvas_get_normalizedSortingGridSizev, __Z58Register_UnityEngine_AudioSource_get_outputAudioMixerGroupv: __Z58Register_UnityEngine_AudioSource_get_outputAudioMixerGroupv, __Z29getNbPxRigidActor_ConstraintsPKN5physx12PxRigidActorE: __Z29getNbPxRigidActor_ConstraintsPKN5physx12PxRigidActorE, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13getBreakForceERfS5_, __Z19CreateRealGfxDevice17GfxDeviceRendererb: __Z19CreateRealGfxDevice17GfxDeviceRendererb, __Z48LODGroup_CUSTOM_INTERNAL_set_localReferencePointP12Il2CppObjectRK8Vector3f: __Z48LODGroup_CUSTOM_INTERNAL_set_localReferencePointP12Il2CppObjectRK8Vector3f, __Z41Rigidbody_Set_Custom_PropSolverIterationsP12Il2CppObjecti: __Z41Rigidbody_Set_Custom_PropSolverIterationsP12Il2CppObjecti, __ZN5physx10conclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx10conclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z51Register_UnityEngine_AnimationCurve_set_preWrapModev: __Z51Register_UnityEngine_AnimationCurve_set_preWrapModev, __ZN11UnityEngine15CloudWebService14RestDownloader7OnAbortEv: __ZN11UnityEngine15CloudWebService14RestDownloader7OnAbortEv, __ZN2UI11CanvasGroupC2E10MemLabelId18ObjectCreationMode: __ZN2UI11CanvasGroupC2E10MemLabelId18ObjectCreationMode, _cf2_glyphpath_closeOpenPath: _cf2_glyphpath_closeOpenPath, __ZN21RotationBySpeedModule16CheckConsistencyEv: __ZN21RotationBySpeedModule16CheckConsistencyEv, __Z51Register_UnityEngine_AndroidJNI_GetByteArrayElementv: __Z51Register_UnityEngine_AndroidJNI_GetByteArrayElementv, __Z56AnimatorControllerPlayable_CUSTOM_IsInTransitionInternalR9HPlayablei: __Z56AnimatorControllerPlayable_CUSTOM_IsInTransitionInternalR9HPlayablei, __ZZ24InitializeNavMeshManagervEN37PreLateUpdateAIUpdatePostScriptstruct7ForwardEv: __ZZ24InitializeNavMeshManagervEN37PreLateUpdateAIUpdatePostScriptstruct7ForwardEv, __Z31GUIText_Get_Custom_PropMaterialP12Il2CppObject: __Z31GUIText_Get_Custom_PropMaterialP12Il2CppObject, __ZThn24_N5physx2Sc21ConstraintInteraction11updateStateEb: __ZThn24_N5physx2Sc21ConstraintInteraction11updateStateEb, __ZNK13GfxDeviceNull27GetActiveRenderColorSurfaceEi: __ZNK13GfxDeviceNull27GetActiveRenderColorSurfaceEi, __ZN2UI14CanvasRenderer19DisableRectClippingEv: __ZN2UI14CanvasRenderer19DisableRectClippingEv, __Z29TerrainData_CUSTOM_RemoveUserP12Il2CppObjectS0_: __Z29TerrainData_CUSTOM_RemoveUserP12Il2CppObjectS0_, __ZN26LegacyTreeInstanceRenderer6UpdateEb: __ZN26LegacyTreeInstanceRenderer6UpdateEb, __ZN13dynamic_arrayI14BoneInfluence2Lj16EEC2ERKS1_: __ZN13dynamic_arrayI14BoneInfluence2Lj16EEC2ERKS1_, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN17Physics2DSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17Physics2DSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIllEEPlEEjT0_S5_S5_S5_S5_T_, __Z20Event_CUSTOM_InitPtrP12Il2CppObject13Il2Cpp_IntPtr: __Z20Event_CUSTOM_InitPtrP12Il2CppObject13Il2Cpp_IntPtr, __ZN5physx2Sn5ConvX23convertImportReferencesEPKvRi: __ZN5physx2Sn5ConvX23convertImportReferencesEPKvRi, __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsWidthv: __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetSizeAffectsWidthv, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedv: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetScrollSpeedv, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getConstraintEv, __Z58Register_UnityEngine_AudioSource_set_bypassListenerEffectsv: __Z58Register_UnityEngine_AudioSource_set_bypassListenerEffectsv, __Z25UpdateLODGroupBoundingBoxR8LODGroup: __Z25UpdateLODGroupBoundingBoxR8LODGroup, __ZN4FMOD7SystemI10getChannelEiPPNS_7ChannelE: __ZN4FMOD7SystemI10getChannelEiPPNS_7ChannelE, __Z38WheelJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject: __Z38WheelJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject, _fmin: _fmin, __Z36Register_UnityEngine_Object_ToStringv: __Z36Register_UnityEngine_Object_ToStringv, __Z41Register_UnityEngine_Texture3D_get_formatv: __Z41Register_UnityEngine_Texture3D_get_formatv, __Z58Register_UnityEngine_TerrainData_RecalculateBasemapIfDirtyv: __Z58Register_UnityEngine_TerrainData_RecalculateBasemapIfDirtyv, __ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat: __ZN12_GLOBAL__N_123CheckRTFormatRenderableEP7ApiGLESRK12GraphicsCaps19RenderTextureFormat, __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger9PtrOffsetENS2_19ForwardingAllocatorEE15growAndPushBackERKS3_, __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeI4PPtrI10GUIElementENS_4lessIS3_EE11memory_poolIS3_EE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z38Register_UnityEngine_Motion_get_legacyv: __Z38Register_UnityEngine_Motion_get_legacyv, __Z45AudioSettings_Get_Custom_PropOutputSampleRatev: __Z45AudioSettings_Get_Custom_PropOutputSampleRatev, __Z51LightProbeProxyVolume_Set_Custom_PropResolutionModeP12Il2CppObjecti: __Z51LightProbeProxyVolume_Set_Custom_PropResolutionModeP12Il2CppObjecti, __Z26EnsureQuaternionContinuityPP17AnimationCurveTplIfE: __Z26EnsureQuaternionContinuityPP17AnimationCurveTplIfE, __ZNK13WheelCollider27GetGlobalSuspensionDistanceEv: __ZNK13WheelCollider27GetGlobalSuspensionDistanceEv, __ZN20SphericalHarmonicsL17SetZeroEv: __ZN20SphericalHarmonicsL17SetZeroEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc10NPhaseCore16ClothListElementEEEEEvPT_jRKT0_RKT1_j, __ZL23ProgramUniformMatrix3fvPK7ApiGLESjiihPKv: __ZL23ProgramUniformMatrix3fvPK7ApiGLESjiihPKv, _atoll: _atoll, __ZN5physx9NpPhysics14createMaterialEfff: __ZN5physx9NpPhysics14createMaterialEfff, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5imbueERKNS_6localeE, __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z55Register_UnityEngine_PhysicMaterial_set_dynamicFrictionv: __Z55Register_UnityEngine_PhysicMaterial_set_dynamicFrictionv, __Z49ReflectionProbe_Set_Custom_PropCustomBakedTextureP12Il2CppObjectS0_: __Z49ReflectionProbe_Set_Custom_PropCustomBakedTextureP12Il2CppObjectS0_, __ZNK13GfxDeviceGLES18GetDefaultRTFormatEv: __ZNK13GfxDeviceGLES18GetDefaultRTFormatEv, __ZN11UnityEngine15CloudWebService19SessionEventManager10InitializeERK8UnityStrPNS0_18ICloudJobSchedulerE: __ZN11UnityEngine15CloudWebService19SessionEventManager10InitializeERK8UnityStrPNS0_18ICloudJobSchedulerE, __Z47SystemInfo_Get_Custom_PropOperatingSystemFamilyv: __Z47SystemInfo_Get_Custom_PropOperatingSystemFamilyv, _UNITY_png_set_write_user_transform_fn: _UNITY_png_set_write_user_transform_fn, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_17ShrunkConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_, __Z52Register_UnityEngine_CombineInstance_InternalGetMeshv: __Z52Register_UnityEngine_CombineInstance_InternalGetMeshv, __Z35Terrain_Get_Custom_PropMaterialTypeP12Il2CppObject: __Z35Terrain_Get_Custom_PropMaterialTypeP12Il2CppObject, __Z13RegisterClassI12LineRendererEvv: __Z13RegisterClassI12LineRendererEvv, __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FindClassv: __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FindClassv, _UNITY_FT_Get_Glyph_Name: _UNITY_FT_Get_Glyph_Name, __ZNK9AudioClip12GetLengthSecEv: __ZNK9AudioClip12GetLengthSecEv, __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb: __ZN9ShaderLabL15GetSizedTextureEPK6CameraRKNS_16FastPropertyNameEbbRb, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_jj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendERKS5_jj, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv, _acoshl: _acoshl, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEv, __ZN4Mesh15ByteSwapIndicesEv: __ZN4Mesh15ByteSwapIndicesEv, __Z52Register_UnityEngine_PolygonCollider2D_get_pathCountv: __Z52Register_UnityEngine_PolygonCollider2D_get_pathCountv, _acoshf: _acoshf, __Z43AnimationClipPlayable_CUSTOM_SetApplyFootIKR9HPlayableh: __Z43AnimationClipPlayable_CUSTOM_SetApplyFootIKR9HPlayableh, __ZNK5physx2Sc5Scene29getContactCorrelationDistanceEv: __ZNK5physx2Sc5Scene29getContactCorrelationDistanceEv, __Z44Register_UnityEngine_AnimationState_set_timev: __Z44Register_UnityEngine_AnimationState_set_timev, __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Cm19PreallocatingRegionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx9NpFactory13addCollectionERKNS_2Cm10CollectionE: __ZN5physx9NpFactory13addCollectionERKNS_2Cm10CollectionE, _cf2_outline_close: _cf2_outline_close, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxJointAngularLimitPairEE8pushNameEPKc, __ZNK5Unity11SpringJoint26GetTypeInfoVirtualInternalEv: __ZNK5Unity11SpringJoint26GetTypeInfoVirtualInternalEv, __Z51Register_UnityEngine_Animator_set_recorderStartTimev: __Z51Register_UnityEngine_Animator_set_recorderStartTimev, __Z49Register_UnityEngine_FrictionJoint2D_set_maxForcev: __Z49Register_UnityEngine_FrictionJoint2D_set_maxForcev, _UNITY_png_read_update_info: _UNITY_png_read_update_info, __ZN9GfxDevice13GetDynamicVBOEv: __ZN9GfxDevice13GetDynamicVBOEv, __Z44SystemInfo_Get_Custom_PropCopyTextureSupportv: __Z44SystemInfo_Get_Custom_PropCopyTextureSupportv, __ZN5physx2Sc9ClothCore19addCollisionCapsuleEjj: __ZN5physx2Sc9ClothCore19addCollisionCapsuleEjj, __ZN9ShaderLab18SerializedProperty8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab18SerializedProperty8TransferI24GenerateTypeTreeTransferEEvRT_, __Z29StdTemplateConversionFunctionIiiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIiiEbPvR14SafeBinaryRead, __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj: __ZN9BlobWrite15TransferPtrImplEbP14ReduceCopyDataj, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj8EEEEEEEE15growAndPushBackERKS2_, __ZN7mecanim11OrValueMaskEPNS_14ValueArrayMaskEPKS0_: __ZN7mecanim11OrValueMaskEPNS_14ValueArrayMaskEPKS0_, __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EE6insertEPS2_PKS2_S6_: __ZN13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EE6insertEPS2_PKS2_S6_, __ZN15TerrainRenderer11RenderStep2Ev: __ZN15TerrainRenderer11RenderStep2Ev, __ZNK20LocalFileSystemPosix12LastModifiedERK13FileEntryData: __ZNK20LocalFileSystemPosix12LastModifiedERK13FileEntryData, __ZN18CrashReportHandler12CloseServiceEv: __ZN18CrashReportHandler12CloseServiceEv, __ZN20UnityConnectSettings10SetEnabledEb: __ZN20UnityConnectSettings10SetEnabledEb, __Z59Register_UnityEngine_CharacterController_get_collisionFlagsv: __Z59Register_UnityEngine_CharacterController_get_collisionFlagsv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__29strstreamD0Ev: __ZNSt3__29strstreamD0Ev, __Z37AndroidJNI_CUSTOM_DetachCurrentThreadv: __Z37AndroidJNI_CUSTOM_DetachCurrentThreadv, __ZN5physx6shdfnd5ArrayINS_2Cm13SpatialVectorENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Cm13SpatialVectorENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx2Sc5Scene15setCCDMaxPassesEj: __ZN5physx2Sc5Scene15setCCDMaxPassesEj, __Z27scripting_class_get_methodsP11Il2CppClassRNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE: __Z27scripting_class_get_methodsP11Il2CppClassRNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEE, __Z51Register_UnityEngine_TargetJoint2D_set_dampingRatiov: __Z51Register_UnityEngine_TargetJoint2D_set_dampingRatiov, __ZN22RenderingCommandBuffer19AddSetGlobalTextureERKN9ShaderLab16FastPropertyNameERK18RenderTextureParam: __ZN22RenderingCommandBuffer19AddSetGlobalTextureERKN9ShaderLab16FastPropertyNameERK18RenderTextureParam, __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireSpherev: __Z56Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireSpherev, __ZNK17ProceduralTexture12GetDimensionEv: __ZNK17ProceduralTexture12GetDimensionEv, __ZN5physx3Tri4neibEii: __ZN5physx3Tri4neibEii, __ZN5physx2Sc9ClothCore23setExternalAccelerationENS_6PxVec3E: __ZN5physx2Sc9ClothCore23setExternalAccelerationENS_6PxVec3E, _fsync: _fsync, __ZN16RenderTextureMap10InitializeEv: __ZN16RenderTextureMap10InitializeEv, __Z36Tree_Get_Custom_PropHasSpeedTreeWindP12Il2CppObject: __Z36Tree_Get_Custom_PropHasSpeedTreeWindP12Il2CppObject, __ZNSt3__26locale5__imp12install_fromINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN9Texture2D11SetPixels32EiiiiiPK11ColorRGBA32: __ZN9Texture2D11SetPixels32EiiiiiPK11ColorRGBA32, __ZN22BlockMemoryCacheWriter12ResizeBlocksEj: __ZN22BlockMemoryCacheWriter12ResizeBlocksEj, __Z43QualitySettings_Get_Custom_PropAntiAliasingv: __Z43QualitySettings_Get_Custom_PropAntiAliasingv, __ZN9AudioClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9AudioClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z28Camera_Set_Custom_PropAspectP12Il2CppObjectf: __Z28Camera_Set_Custom_PropAspectP12Il2CppObjectf, __ZN22BaseUnityConnectClient12CloseServiceEv: __ZN22BaseUnityConnectClient12CloseServiceEv, __ZThn8_N5physx2Gu12TriangleMesh14onRefCountZeroEv: __ZThn8_N5physx2Gu12TriangleMesh14onRefCountZeroEv, __Z54Register_UnityEngine_ParticleEmitter_get_particleCountv: __Z54Register_UnityEngine_ParticleEmitter_get_particleCountv, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZN12b2ChainShape13SetPrevVertexERK6b2Vec2: __ZN12b2ChainShape13SetPrevVertexERK6b2Vec2, __Z46Register_UnityEngine_LightProbes_get_cellCountv: __Z46Register_UnityEngine_LightProbes_get_cellCountv, __ZN15SharedLightData5ResetEv: __ZN15SharedLightData5ResetEv, __ZN5physx2Sc9ShapeCore17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx2Sc9ShapeCore17resolveReferencesERNS_24PxDeserializationContextE, __ZN7ApiGLES11LinkProgramEj: __ZN7ApiGLES11LinkProgramEj, __ZNK5physx3Ext20ProfileZoneInterface7getNameEv: __ZNK5physx3Ext20ProfileZoneInterface7getNameEv, __Z18MurmurHashAligned2PKvij: __Z18MurmurHashAligned2PKvij, __Z64Register_UnityEngine_TerrainData_NeedUpgradeScaledTreePrototypesv: __Z64Register_UnityEngine_TerrainData_NeedUpgradeScaledTreePrototypesv, __ZN7mecanim8skeleton20SkeletonNodeEndPointEPKNS0_8SkeletonEiPKNS0_13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim8skeleton20SkeletonNodeEndPointEPKNS0_8SkeletonEiPKNS0_13SkeletonPoseTIN4math4trsXEEE, __ZN7mecanim10ValueArray8TransferI9BlobWriteEEvRT_: __ZN7mecanim10ValueArray8TransferI9BlobWriteEEvRT_, __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_15NpParticleFluidEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN5physx2Sn21SerializationRegistry7releaseEv: __ZN5physx2Sn21SerializationRegistry7releaseEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZL22PxcGenerateVFContacts2RN5physx2Gu13ContactBufferERKNS_11PxTransformERKNS0_13PolygonalDataERKNS_11PxMeshScaleEjPKNS_6PxVec3EfRSD_f: __ZL22PxcGenerateVFContacts2RN5physx2Gu13ContactBufferERKNS_11PxTransformERKNS0_13PolygonalDataERKNS_11PxMeshScaleEjPKNS_6PxVec3EfRSD_f, __ZN5Umbra6Double8isFiniteERKd: __ZN5Umbra6Double8isFiniteERKd, __Z45CullingGroup_CUSTOM_SetDistanceReferencePointP12Il2CppObjectS0_: __Z45CullingGroup_CUSTOM_SetDistanceReferencePointP12Il2CppObjectS0_, _empty_mem_output_buffer: _empty_mem_output_buffer, _cf2_hintmask_isNew: _cf2_hintmask_isNew, __ZN5physx13PxHitCallbackINS_12PxRaycastHitEE13finalizeQueryEv: __ZN5physx13PxHitCallbackINS_12PxRaycastHitEE13finalizeQueryEv, _common_180: _common_180, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13MonoBehaviourELj4EEEEvRT_17TransferMetaFlags, __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZNKSt3__210moneypunctIwLb1EE11curr_symbolEv: __ZNKSt3__210moneypunctIwLb1EE11curr_symbolEv, __Z39SliderJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D: __Z39SliderJoint2D_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK12JointMotor2D, __Z32Animation_CUSTOM_GetStateAtIndexP12Il2CppObjecti: __Z32Animation_CUSTOM_GetStateAtIndexP12Il2CppObjecti, __ZNK11NoiseModule12PreviewNoiseILi1EEEvP9Texture2DP10ColorRGBAf: __ZNK11NoiseModule12PreviewNoiseILi1EEEvP9Texture2DP10ColorRGBAf, __ZN18GfxFramebufferGLES36TryInvalidateDefaultFramebufferDepthEv: __ZN18GfxFramebufferGLES36TryInvalidateDefaultFramebufferDepthEv, __Z44Register_UnityEngine_Screen_get_sleepTimeoutv: __Z44Register_UnityEngine_Screen_get_sleepTimeoutv, __Z32Joint_Get_Custom_PropBreakTorqueP12Il2CppObject: __Z32Joint_Get_Custom_PropBreakTorqueP12Il2CppObject, __Z59AnchoredJoint2D_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth: __Z59AnchoredJoint2D_Set_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObjecth, __ZN5physx2Sc18ParticleSystemCore20obtainStandaloneDataEv: __ZN5physx2Sc18ParticleSystemCore20obtainStandaloneDataEv, __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi: __ZN10TagManager32GetSortingLayerValueFromUniqueIDEi, __ZN4crnd10crnd_msizeEPv: __ZN4crnd10crnd_msizeEPv, __Z28GetSplashScreenBackgroundUvsRK5RectTIfE: __Z28GetSplashScreenBackgroundUvsRK5RectTIfE, __ZN5IMGUI17BringWindowToBackER8GUIStatei: __ZN5IMGUI17BringWindowToBackER8GUIStatei, __ZN3MBPD2Ev: __ZN3MBPD2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj443ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj443ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_: __ZN11MinMaxCurve8TransferI17RemapPPtrTransferEEvRT_, __Z18PrepareClipBuilderR18MecanimClipBuilder: __Z18PrepareClipBuilderR18MecanimClipBuilder, __ZN5physx8debugger19PvdNetworkOutStreamD0Ev: __ZN5physx8debugger19PvdNetworkOutStreamD0Ev, __ZN11UnityEngine7Connect13ConfigHandler7ReleaseEv: __ZN11UnityEngine7Connect13ConfigHandler7ReleaseEv, __Z51Register_UnityEngine_GUILayer_INTERNAL_CALL_HitTestv: __Z51Register_UnityEngine_GUILayer_INTERNAL_CALL_HitTestv, __Z29StdTemplateConversionFunctionIysEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIysEbPvR14SafeBinaryRead, __ZN15NavMeshSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15NavMeshSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __Z24GenerateIntegrationCacheR15PolynomialCurve: __Z24GenerateIntegrationCacheR15PolynomialCurve, __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_12PxConvexMeshENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx5cloth8SwSolver22CpuClothSimulationTask7releaseEv: __ZN5physx5cloth8SwSolver22CpuClothSimulationTask7releaseEv, __ZN5physxL21generatedPolyContactsERKNS_2Gu13PolygonalDataERKNS0_15HullPolygonDataERKNS0_9TriangleVEjhPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE: __ZN5physxL21generatedPolyContactsERKNS_2Gu13PolygonalDataERKNS0_15HullPolygonDataERKNS0_9TriangleVEjhPNS0_12SupportLocalEPNS0_21MeshPersistentContactERjRKNS_6shdfnd3aos6FloatVERKNSG_5Vec3VE, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEc: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE4fillEc, __ZN12LightManagerC2Ev: __ZN12LightManagerC2Ev, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getStringTableEv: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl14getStringTableEv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14SubstanceInputNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sc17ParticleSystemSim19scheduleRefilteringEv: __ZN5physx2Sc17ParticleSystemSim19scheduleRefilteringEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE2atEj, __ZN5physx6shdfnd12_GLOBAL__N_113PxThreadStartEPv: __ZN5physx6shdfnd12_GLOBAL__N_113PxThreadStartEPv, __Z75Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentSize3Dv: __Z75Register_UnityEngine_ParticleSystem_Particle_INTERNAL_CALL_GetCurrentSize3Dv, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16getContactOffsetEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE16getContactOffsetEv, __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E: __ZN5physx19PxsFluidSpatialHash14buildLocalHashEPKNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjPtjfRKNS_6PxVec3E, __ZN17SharedTextureDataC2E10MemLabelId: __ZN17SharedTextureDataC2E10MemLabelId, __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEv: __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEv, _UNITY_FT_Vector_Polarize: _UNITY_FT_Vector_Polarize, __ZN17AudioReverbFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17AudioReverbFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z34Canvas_Get_Custom_PropSortingOrderP12Il2CppObject: __Z34Canvas_Get_Custom_PropSortingOrderP12Il2CppObject, _tt_get_metrics: _tt_get_metrics, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float4EEEEvRT_17TransferMetaFlags, __ZN5IMGUI14GUIWindowState11SortWindowsEv: __ZN5IMGUI14GUIWindowState11SortWindowsEv, __ZN4FMOD7SystemI19getGeometrySettingsEPf: __ZN4FMOD7SystemI19getGeometrySettingsEPf, __ZN5physx2Gu26checkOverlapSphere_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE: __ZN5physx2Gu26checkOverlapSphere_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_6SphereE, __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayIPKNS_2Sc9ShapeCoreENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS5_EEEEE15growAndPushBackERKS5_, __ZN5physx15PxVehicleUpdate13updateDriveNWEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDriveNWEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx15PxVehicleUpdate13updateDriveNWEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_16PxVehicleDriveNWEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __Z51Register_UnityEngine_Physics2D_get_maxRotationSpeedv: __Z51Register_UnityEngine_Physics2D_get_maxRotationSpeedv, __Z13RegisterClassI16ParticleRendererEvv: __Z13RegisterClassI16ParticleRendererEvv, __ZN16GraphicsSettings15InitializeClassEv: __ZN16GraphicsSettings15InitializeClassEv, __ZN16AnimationManager15InitializeClassEv: __ZN16AnimationManager15InitializeClassEv, __ZN13GfxDeviceGLES23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii: __ZN13GfxDeviceGLES23DrawIndexedNullGeometryE16GfxPrimitiveTypeP9GfxBufferiii, __ZN14AssetReferenceaSERKS_: __ZN14AssetReferenceaSERKS_, __ZN15b2RevoluteJointD0Ev: __ZN15b2RevoluteJointD0Ev, __Z27Camera_Get_Custom_PropDepthP12Il2CppObject: __Z27Camera_Get_Custom_PropDepthP12Il2CppObject, __Z24RegisterModuleClasses_AIv: __Z24RegisterModuleClasses_AIv, __ZN7mecanim9animation22MotionAddOverrideLayerEPNS0_12MotionOutputEPKS1_fbbRKNS_6bitsetILj66EEE: __ZN7mecanim9animation22MotionAddOverrideLayerEPNS0_12MotionOutputEPKS1_fbbRKNS_6bitsetILj66EEE, __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthYMultiplierP12Il2CppObjectf: __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthYMultiplierP12Il2CppObjectf, __Z24GetCurrentTimeAsDateTimev: __Z24GetCurrentTimeAsDateTimev, __Z31ParticleEmitter_CUSTOM_SimulateP12Il2CppObjectf: __Z31ParticleEmitter_CUSTOM_SimulateP12Il2CppObjectf, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton19SkeletonMaskElementEEEEvRT_17TransferMetaFlags, __ZN15QualitySettings24SetParticleRaycastBudgetEi: __ZN15QualitySettings24SetParticleRaycastBudgetEi, __ZN16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z19sweepBox_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z19sweepBox_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN5physx2Sc5Scene18updateCCDMultiPassEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene18updateCCDMultiPassEPNS_10PxBaseTaskE, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwe: __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_bRNS_8ios_baseEwe, __Z49Playables_CUSTOM_INTERNAL_CALL_DisconnectInternalR9HPlayablei: __Z49Playables_CUSTOM_INTERNAL_CALL_DisconnectInternalR9HPlayablei, ___towcase: ___towcase, __ZN4FMOD7SystemI7lockDSPEv: __ZN4FMOD7SystemI7lockDSPEv, __Z31CullDirectionalShadowCastersJobP20ShadowCullingJobDataj: __Z31CullDirectionalShadowCastersJobP20ShadowCullingJobDataj, __ZN12b2WheelJoint17SetMaxMotorTorqueEf: __ZN12b2WheelJoint17SetMaxMotorTorqueEf, __ZN17MemoryCacheWriterD0Ev: __ZN17MemoryCacheWriterD0Ev, __Z27setPxJoint_InvInertiaScale1PN5physx7PxJointEf: __Z27setPxJoint_InvInertiaScale1PN5physx7PxJointEf, __ZN20TextRenderingPrivate18InitializeFreeTypeEv: __ZN20TextRenderingPrivate18InitializeFreeTypeEv, __ZNK21LightProbeProxyVolume13GetResolutionERjS0_S0_: __ZNK21LightProbeProxyVolume13GetResolutionERjS0_S0_, __ZNK5physx3Ext13RevoluteJoint18getDriveForceLimitEv: __ZNK5physx3Ext13RevoluteJoint18getDriveForceLimitEv, __Z55Register_UnityEngine_ParticleSystem_set_gravityModifierv: __Z55Register_UnityEngine_ParticleSystem_set_gravityModifierv, __Z24RegisterStrippedTypeInfoI6SkyboxEviPKcS2_: __Z24RegisterStrippedTypeInfoI6SkyboxEviPKcS2_, __Z46Register_UnityEngine_Renderer_GetPropertyBlockv: __Z46Register_UnityEngine_Renderer_GetPropertyBlockv, __ZN14CachingManagerD2Ev: __ZN14CachingManagerD2Ev, __ZN13GfxDeviceGLES13SetViewMatrixERK10Matrix4x4f: __ZN13GfxDeviceGLES13SetViewMatrixERK10Matrix4x4f, __ZN11AudioSourceC2E10MemLabelId18ObjectCreationMode: __ZN11AudioSourceC2E10MemLabelId18ObjectCreationMode, __ZN13TrailRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj: __ZN13TrailRenderer17RenderGeometryJobEP25DynamicVBOGeometryJobDataj, __ZN5physx28PxRigidDynamicRepXSerializerD0Ev: __ZN5physx28PxRigidDynamicRepXSerializerD0Ev, __ZN5physx22PxDefaultErrorCallbackC2Ev: __ZN5physx22PxDefaultErrorCallbackC2Ev, __ZN19UnityConnectServiceC2Ev: __ZN19UnityConnectServiceC2Ev, __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_3Ext19ProfileEventHandler15EventCollectionENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZN5physx3Cct17CapsuleController13setSlopeLimitEf: __ZN5physx3Cct17CapsuleController13setSlopeLimitEf, __Z48Register_UnityEngine_Texture2D_GetRawTextureDatav: __Z48Register_UnityEngine_Texture2D_GetRawTextureDatav, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE6createERS6_Rb, __ZN14RenderSettings16SetFlareStrengthEf: __ZN14RenderSettings16SetFlareStrengthEf, __Z21setPxActor_ActorFlagsPN5physx7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __Z21setPxActor_ActorFlagsPN5physx7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __Z35Debug_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_RK10ColorRGBAffh: __Z35Debug_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_RK10ColorRGBAffh, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE15growAndPushBackERKS8_, __ZN7mecanim9animation11xformPrePowERKN4math4trsXEi: __ZN7mecanim9animation11xformPrePowERKN4math4trsXEi, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_11postCCDPassEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj, __ZN9AudioClip8TransferI14SafeBinaryReadEEvRT_: __ZN9AudioClip8TransferI14SafeBinaryReadEEvRT_, __ZN14EmissionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14EmissionModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13AnimationClip8GetRangeEv: __ZN13AnimationClip8GetRangeEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK13GfxDeviceGLES11GetViewportEv: __ZNK13GfxDeviceGLES11GetViewportEv, __Z38CullingGroup_CUSTOM_SetBoundingSpheresP12Il2CppObjectP11Il2CppArray: __Z38CullingGroup_CUSTOM_SetBoundingSpheresP12Il2CppObjectP11Il2CppArray, __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7Hash1288TransferI24GenerateTypeTreeTransferEEvRT_, __Z64Register_UnityEngine_CanvasRenderer_CreateUIVertexStreamInternalv: __Z64Register_UnityEngine_CanvasRenderer_CreateUIVertexStreamInternalv, _tre_fill_pmatch: _tre_fill_pmatch, __ZN13EmscriptenWWWC2EPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j: __ZN13EmscriptenWWWC2EPKcS1_iRKNSt3__23mapINS2_12basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEES9_NS2_4lessIS9_EENS7_INS2_4pairIKS9_S9_EEEEEEb7Hash128j, __ZN15ReplacementPassD0Ev: __ZN15ReplacementPassD0Ev, __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fjPS2_ji: __Z18TransformPoints3x3RK10Matrix4x4fPK8Vector3fjPS2_ji, __Z34WWW_Get_Custom_PropBytesDownloadedP12Il2CppObject: __Z34WWW_Get_Custom_PropBytesDownloadedP12Il2CppObject, __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv: __ZN9ShaderLab14SerializedPass25ReconstructNamesFromTableEv, __ZN5physx13NpVolumeCache20setMaxNbStaticShapesEj: __ZN5physx13NpVolumeCache20setMaxNbStaticShapesEj, _fegetexceptflag: _fegetexceptflag, __Z39LineRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode: __Z39LineRenderer_Set_Custom_PropTextureModeP12Il2CppObject15LineTextureMode, __ZN18GfxFramebufferGLES5ClearEjRK10ColorRGBAffib: __ZN18GfxFramebufferGLES5ClearEjRK10ColorRGBAffib, __Z36GUI_CUSTOM_INTERNAL_set_contentColorRK10ColorRGBAf: __Z36GUI_CUSTOM_INTERNAL_set_contentColorRK10ColorRGBAf, __ZN24GenerateTypeTreeTransfer10SetVersionEi: __ZN24GenerateTypeTreeTransfer10SetVersionEi, __ZNK5physx14PxVehicleDrive7isValidEv: __ZNK5physx14PxVehicleDrive7isValidEv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE10__get_hourERiRS4_S4_RjRKNS_5ctypeIcEE, __Z21ScheduleMainThreadJobPFvPvES_10JobGroupID: __Z21ScheduleMainThreadJobPFvPvES_10JobGroupID, __ZN17ArchiveFileSystem9SetLengthER13FileEntryDatay: __ZN17ArchiveFileSystem9SetLengthER13FileEntryDatay, __ZN12_GLOBAL__N_123PrismaticJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j: __ZN12_GLOBAL__N_123PrismaticJointVisualizeERN5physx22PxConstraintVisualizerEPKvRKNS0_11PxTransformES7_j, __ZN5physx2Sn5ConvX16getNbMetaClassesENS0_12MetaDataTypeE: __ZN5physx2Sn5ConvX16getNbMetaClassesENS0_12MetaDataTypeE, __ZN9BoxPruner12removeObjectEt: __ZN9BoxPruner12removeObjectEt, __Z49EmitSerializationCommandsForLinearCollectionFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZNSt3__211char_traitsIcE4findEPKcjRS2_: __ZNSt3__211char_traitsIcE4findEPKcjRS2_, __Z14FreeBlockCountPvjiS_: __Z14FreeBlockCountPvjiS_, __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZN14VehiclesModule22CleanupVehiclesManagerEv: __ZN14VehiclesModule22CleanupVehiclesManagerEv, _UnityReplayKitStopBroadcasting: _UnityReplayKitStopBroadcasting, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj142ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj142ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN4FMOD6System26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD6System26setReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES, __ZN18SpeedTreeWindAsset15InitializeClassEv: __ZN18SpeedTreeWindAsset15InitializeClassEv, __ZN13AudioListener15ThreadedCleanupEv: __ZN13AudioListener15ThreadedCleanupEv, __ZNSt3__26__sortIRNS_6__lessIccEEPcEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIccEEPcEEvT0_S5_T_, __ZN12_GLOBAL__N_110DataStream25beginPropertyMessageGroupERKN5physx8debugger14NamespacedNameE: __ZN12_GLOBAL__N_110DataStream25beginPropertyMessageGroupERKN5physx8debugger14NamespacedNameE, __Z17InitializeChannelRK8UnityStriiR17BlendShapeChannel: __Z17InitializeChannelRK8UnityStriiR17BlendShapeChannel, __Z38SplashScreen_Get_Custom_PropIsFinishedv: __Z38SplashScreen_Get_Custom_PropIsFinishedv, _processblock_51: _processblock_51, __Z43Register_UnityEngine_GL_SetRevertBackfacingv: __Z43Register_UnityEngine_GL_SetRevertBackfacingv, __ZN5physx21PxcArticulationHelper13getFsDataSizeEj: __ZN5physx21PxcArticulationHelper13getFsDataSizeEj, __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeR9GfxBufferiii: __ZN8DrawUtil14DrawProceduralE16GfxPrimitiveTypeR9GfxBufferiii, __ZN7mecanim5human12RequiredBoneEj: __ZN7mecanim5human12RequiredBoneEj, __ZNK5physx14NpRigidDynamic16getLinearDampingEv: __ZNK5physx14NpRigidDynamic16getLinearDampingEv, _jpeg_write_marker: _jpeg_write_marker, __ZNK13RenderTexture14IsDepthTextureEv: __ZNK13RenderTexture14IsDepthTextureEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc12SimStateDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXv, _jinit_d_post_controller: _jinit_d_post_controller, __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15FrictionJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNSt3__218__stable_sort_moveIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeE: __ZNSt3__218__stable_sort_moveIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_T_NS_15iterator_traitsISE_E15difference_typeEPNSH_10value_typeE, __Z41RenderSettings_Get_Custom_PropAmbientModev: __Z41RenderSettings_Get_Custom_PropAmbientModev, __Z33getPxSceneDescNbContactDataBlocksPKN5physx11PxSceneDescE: __Z33getPxSceneDescNbContactDataBlocksPKN5physx11PxSceneDescE, __Z37Projector_Set_Custom_PropFarClipPlaneP12Il2CppObjectf: __Z37Projector_Set_Custom_PropFarClipPlaneP12Il2CppObjectf, __ZNSt3__220__get_collation_nameEPKc: __ZNSt3__220__get_collation_nameEPKc, __ZN14RenderSettings23UpdateDefaultReflectionEv: __ZN14RenderSettings23UpdateDefaultReflectionEv, __ZNK5physx2Sn9MetaClass14getFieldByTypeEPKcRNS0_15PxMetaDataEntryE: __ZNK5physx2Sn9MetaClass14getFieldByTypeEPKcRNS0_15PxMetaDataEntryE, __Z31CustomEventData_CUSTOM_AddInt64P12Il2CppObjectP12Il2CppStringx: __Z31CustomEventData_CUSTOM_AddInt64P12Il2CppObjectP12Il2CppStringx, __ZN22BaseUnityConnectClientD2Ev: __ZN22BaseUnityConnectClientD2Ev, __ZN10AudioMixer24CheckForCyclicReferencesEPS_P15AudioMixerGroup: __ZN10AudioMixer24CheckForCyclicReferencesEPS_P15AudioMixerGroup, __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE: __ZNSt3__2L20utf8_to_utf16_lengthEPKhS1_jmNS_12codecvt_modeE, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26locale5__imp7installINS_14collate_bynameIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14collate_bynameIwEEEEvPT_, __Z49Register_UnityEngine_ParticleSystem_get_isStoppedv: __Z49Register_UnityEngine_ParticleSystem_get_isStoppedv, __ZN5physx32solveContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx32solveContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN8Animator25SetLayersAffectMassCenterEb: __ZN8Animator25SetLayersAffectMassCenterEb, __ZN25RuntimeAnimatorController17MainThreadCleanupEv: __ZN25RuntimeAnimatorController17MainThreadCleanupEv, __ZNK5Umbra16LineSegmentQuery6getEndEv: __ZNK5Umbra16LineSegmentQuery6getEndEv, __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev: __ZN5physx33PxVehicleAutoBoxDataGeneratedInfoC2Ev, __ZN8Renderer21ClearCustomPropertiesEv: __ZN8Renderer21ClearCustomPropertiesEv, __Z24SetTargetFrameRateDirecti: __Z24SetTargetFrameRateDirecti, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_getES4_S4_RNS_8ios_baseERjRm, __ZN23SweepBoxMeshHitCallbackD2Ev: __ZN23SweepBoxMeshHitCallbackD2Ev, __ZNK5physx24PxDefaultMemoryInputData4tellEv: __ZNK5physx24PxDefaultMemoryInputData4tellEv, __Z69Register_UnityEngine_AnchoredJoint2D_set_autoConfigureConnectedAnchorv: __Z69Register_UnityEngine_AnchoredJoint2D_set_autoConfigureConnectedAnchorv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7getNameEv, __ZN25MinMaxOptimizedPolyCurves9IntegrateEv: __ZN25MinMaxOptimizedPolyCurves9IntegrateEv, __Z26setPxParticleBase_GridSizePN5physx14PxParticleBaseEf: __Z26setPxParticleBase_GridSizePN5physx14PxParticleBaseEf, __ZN16MemoryFileSystem5WriteER13FileEntryDatayyPvPy: __ZN16MemoryFileSystem5WriteER13FileEntryDatayyPvPy, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEE15growAndPushBackERKS2_, __ZN28LightProbeProxyVolumeManager22AllocateVolumeTexturesER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager22AllocateVolumeTexturesER21LightProbeProxyVolume, __Z35AudioListener_Get_Custom_PropVolumev: __Z35AudioListener_Get_Custom_PropVolumev, __ZN18ProceduralMaterial5CleanEv: __ZN18ProceduralMaterial5CleanEv, __Z31Object_CUSTOM_DontDestroyOnLoadP12Il2CppObject: __Z31Object_CUSTOM_DontDestroyOnLoadP12Il2CppObject, __ZN5physx21GuMeshFactoryListenerD2Ev: __ZN5physx21GuMeshFactoryListenerD2Ev, __Z16b2RaycastSegmentP15b2RayCastOutputRK14b2RayCastInputRK6b2Vec2S6_: __Z16b2RaycastSegmentP15b2RayCastOutputRK14b2RayCastInputRK6b2Vec2S6_, __Z24RegisterStrippedTypeInfoI11NamedObjectEviPKcS2_: __Z24RegisterStrippedTypeInfoI11NamedObjectEviPKcS2_, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE20getExternalReferenceERj, __Z19IsHalfTextureFormat13TextureFormat: __Z19IsHalfTextureFormat13TextureFormat, __ZNK5physx7PxCloth19getConcreteTypeNameEv: __ZNK5physx7PxCloth19getConcreteTypeNameEv, _null_method: _null_method, __ZN4FMOD13ChannelGroupI7releaseEv: __ZN4FMOD13ChannelGroupI7releaseEv, __Z53Register_UnityEngine_GUIElement_INTERNAL_CALL_HitTestv: __Z53Register_UnityEngine_GUIElement_INTERNAL_CALL_HitTestv, __ZN12_GLOBAL__N_117MemoryEventClient19handleClientRemovedEv: __ZN12_GLOBAL__N_117MemoryEventClient19handleClientRemovedEv, __ZN15DirectorManager14ConnectionPool14InitializePoolEjf: __ZN15DirectorManager14ConnectionPool14InitializePoolEjf, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN8Animator23SetPlaybackTimeInternalEf: __ZN8Animator23SetPlaybackTimeInternalEf, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpShapeEEEEEvPT_jRKT0_RKT1_j, __ZN5physx14NpArticulation10putToSleepEv: __ZN5physx14NpArticulation10putToSleepEv, __ZNK15ArchiveReadFile6IsOpenEv: __ZNK15ArchiveReadFile6IsOpenEv, __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_i: __ZN7mecanim8skeleton13SkeletonAlignEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_i, __ZN15UnityAdsManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15UnityAdsManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNKSt3__217moneypunct_bynameIwLb0EE16do_positive_signEv: __ZNKSt3__217moneypunct_bynameIwLb0EE16do_positive_signEv, __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetActiveSceneRi: __Z48SceneManager_CUSTOM_INTERNAL_CALL_GetActiveSceneRi, __ZN11AudioFilterD0Ev: __ZN11AudioFilterD0Ev, __ZL28CleanupModule_CrashReportingv: __ZL28CleanupModule_CrashReportingv, __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_GetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve, __ZN11LightProbes23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11LightProbes23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z58Register_UnityEngine_Animator_GetNextAnimatorClipInfoCountv: __Z58Register_UnityEngine_Animator_GetNextAnimatorClipInfoCountv, __Z54Register_UnityEngine_SurfaceEffector2D_get_useFrictionv: __Z54Register_UnityEngine_SurfaceEffector2D_get_useFrictionv, __ZN6Shader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Shader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice: __ZN27DeviceViewProjMatricesStateC2ER9GfxDevice, __ZNK5physx2Sc5Scene26getFrictionOffsetThresholdEv: __ZNK5physx2Sc5Scene26getFrictionOffsetThresholdEv, __Z50NavMeshObstacle_Get_Custom_PropCarveOnlyStationaryP12Il2CppObject: __Z50NavMeshObstacle_Get_Custom_PropCarveOnlyStationaryP12Il2CppObject, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8in_availEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8in_availEv, __Z43GUIStyleState_CUSTOM_INTERNAL_get_textColorP12Il2CppObjectP10ColorRGBAf: __Z43GUIStyleState_CUSTOM_INTERNAL_get_textColorP12Il2CppObjectP10ColorRGBAf, __ZN9ShaderLab20ParserStateStackSizeEv: __ZN9ShaderLab20ParserStateStackSizeEv, __Z42NavMeshObstacle_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z42NavMeshObstacle_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __ZN19AtomicPageAllocator12AllocatePageEj: __ZN19AtomicPageAllocator12AllocatePageEj, __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_PS2_RNS3_18ImpulseAccumulatorE: __ZNK5physx5cloth11SwCollisionI8Scalar4fE14collideSpheresERKS2_PS4_PS2_RNS3_18ImpulseAccumulatorE, _llrint: _llrint, __ZNK14DetailDatabase8GetLayerEiiiiiPi: __ZNK14DetailDatabase8GetLayerEiiiiiPi, __ZN15SerializeTraitsINSt3__24pairI7Hash128iEEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI7Hash128iEEE8TransferI14SafeBinaryReadEEvRS3_RT_, __ZN5physx3Scb5Scene16removeRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene16removeRigidNoSimINS0_11RigidStaticELb0ELb1EEEvRT_RNS0_13ObjectTrackerE, __Z46Register_UnityEngine_HingeJoint2D_get_useMotorv: __Z46Register_UnityEngine_HingeJoint2D_get_useMotorv, __Z19TransferField_ArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI24GenerateTypeTreeTransfer16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z42Register_UnityEngine_GUIText_get_alignmentv: __Z42Register_UnityEngine_GUIText_get_alignmentv, __Z38Physics_CUSTOM_GetIgnoreLayerCollisionii: __Z38Physics_CUSTOM_GetIgnoreLayerCollisionii, __ZNKSt3__210moneypunctIcLb1EE16do_decimal_pointEv: __ZNKSt3__210moneypunctIcLb1EE16do_decimal_pointEv, __ZN5physx8debugger14PvdMarshallingIsjE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsjE12marshalBlockEPKhPhj, __ZN5physx2Sc5Scene11collideStepEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene11collideStepEPNS_10PxBaseTaskE, __ZN4FMOD7SystemI10loadPluginEPKcPjj: __ZN4FMOD7SystemI10loadPluginEPKcPjj, __Z49QualitySettings_Set_Custom_PropMasterTextureLimiti: __Z49QualitySettings_Set_Custom_PropMasterTextureLimiti, __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim5human5Human8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN18AwakeFromLoadQueueC2E10MemLabelId: __ZN18AwakeFromLoadQueueC2E10MemLabelId, __ZN23CloudWebServicesManagerD2Ev: __ZN23CloudWebServicesManagerD2Ev, __ZN4gles22UploadTexture2DSubDataEP7ApiGLESj13TextureFormatPKviiiii17TextureColorSpace: __ZN4gles22UploadTexture2DSubDataEP7ApiGLESj13TextureFormatPKviiiii17TextureColorSpace, __Z28Light_Get_Custom_PropIsBakedP12Il2CppObject: __Z28Light_Get_Custom_PropIsBakedP12Il2CppObject, __ZN9Projector12CleanupClassEv: __ZN9Projector12CleanupClassEv, __ZN5physx45PxVehicleAckermannGeometryDataGeneratedValuesC2EPKNS_30PxVehicleAckermannGeometryDataE: __ZN5physx45PxVehicleAckermannGeometryDataGeneratedValuesC2EPKNS_30PxVehicleAckermannGeometryDataE, __ZN5physx2Gu26computeBox_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbRNS_10PxSweepHitE: __ZN5physx2Gu26computeBox_TriangleMeshMTDERKNS_22PxTriangleMeshGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbRNS_10PxSweepHitE, __ZN5Unity17ConfigurableJoint15ThreadedCleanupEv: __ZN5Unity17ConfigurableJoint15ThreadedCleanupEv, __ZN7ApiGLES17CreateFramebufferEv: __ZN7ApiGLES17CreateFramebufferEv, __ZN12SoundManager9GetHandleERK16StreamedResourceijjP10SampleClipb: __ZN12SoundManager9GetHandleERK16StreamedResourceijjP10SampleClipb, __ZNK17ArchiveFileSystem12LastModifiedERK13FileEntryData: __ZNK17ArchiveFileSystem12LastModifiedERK13FileEntryData, __ZNK15FileSystemEntry12LastModifiedEv: __ZNK15FileSystemEntry12LastModifiedEv, __Z23getPxClothFabric_PhasesPKN5physx13PxClothFabricEPNS_18PxClothFabricPhaseEj: __Z23getPxClothFabric_PhasesPKN5physx13PxClothFabricEPNS_18PxClothFabricPhaseEj, __Z18Transfer_BlittableI17RemapPPtrTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _FMOD_Debug_GetLevel: _FMOD_Debug_GetLevel, __ZN10GameObject10DeactivateE19DeactivateOperation: __ZN10GameObject10DeactivateE19DeactivateOperation, __Z24RegisterStrippedTypeInfoI15OcclusionPortalEviPKcS2_: __Z24RegisterStrippedTypeInfoI15OcclusionPortalEviPKcS2_, __Z49Camera_CUSTOM_INTERNAL_CALL_ViewportToScreenPointP12Il2CppObjectRK8Vector3fRS1_: __Z49Camera_CUSTOM_INTERNAL_CALL_ViewportToScreenPointP12Il2CppObjectRK8Vector3fRS1_, __ZN12_GLOBAL__N_117ConnectionManager14onDeallocationEPv: __ZN12_GLOBAL__N_117ConnectionManager14onDeallocationEPv, __ZN5physx2Sc7BodySim18postSetWakeCounterEfb: __ZN5physx2Sc7BodySim18postSetWakeCounterEfb, __Z50Animator_CUSTOM_IsParameterControlledByCurveStringP12Il2CppObjectP12Il2CppString: __Z50Animator_CUSTOM_IsParameterControlledByCurveStringP12Il2CppObjectP12Il2CppString, __ZN7mecanim9animation32DeallocateAvatarOuputForBindingsEPNS0_12AvatarOutputERNS_6memory9AllocatorE: __ZN7mecanim9animation32DeallocateAvatarOuputForBindingsEPNS0_12AvatarOutputERNS_6memory9AllocatorE, __ZN8Animator8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Animator8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z7LogGLESPKcS0_S0_l: __Z7LogGLESPKcS0_S0_l, __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI9TextureIDjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __Z36BoxCollider_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f: __Z36BoxCollider_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f, __Z44BuoyancyEffector2D_Get_Custom_PropLinearDragP12Il2CppObject: __Z44BuoyancyEffector2D_Get_Custom_PropLinearDragP12Il2CppObject, __Z31WWW_CUSTOM_GetAudioClipInternalP12Il2CppObjecthhhi: __Z31WWW_CUSTOM_GetAudioClipInternalP12Il2CppObjecthhhi, __Z24RegisterStrippedTypeInfoI22NavMeshProjectSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI22NavMeshProjectSettingsEviPKcS2_, __ZN15PackedIntVector8PackIntsIjEEvPT_i: __ZN15PackedIntVector8PackIntsIjEEvPT_i, __ZN10systeminfo16GetProcessorTypeEv: __ZN10systeminfo16GetProcessorTypeEv, __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZN4TreeD2Ev: __ZN4TreeD2Ev, __Z10WriteArrayI20AudioProfilerDSPInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE: __Z10WriteArrayI20AudioProfilerDSPInfoEvR13dynamic_arrayIiLj4EERKS1_IT_Xsr11AlignOfTypeIS4_EE5alignEE, __ZN13AnimationClip16CheckConsistencyEv: __ZN13AnimationClip16CheckConsistencyEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13getBreakForceERfS5_, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2Ev: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEC2Ev, __ZN4File19GetCurrentDirectoryEv: __ZN4File19GetCurrentDirectoryEv, __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE: __ZN7mecanim8skeleton18CreateSkeletonPoseIN4math4trsXEEEPNS0_13SkeletonPoseTIT_EEPKNS0_8SkeletonERNS_6memory9AllocatorE, __Z52Register_UnityEngine_ParticleSystem_get_maxParticlesv: __Z52Register_UnityEngine_ParticleSystem_get_maxParticlesv, __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_18PxClothFabricPhaseENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx9PxTaskMgr19initializeProfilingERNS_20PxProfileZoneManagerE: __ZN5physx9PxTaskMgr19initializeProfilingERNS_20PxProfileZoneManagerE, __ZNK13AnimationClip26GetTypeInfoVirtualInternalEv: __ZNK13AnimationClip26GetTypeInfoVirtualInternalEv, __ZNK5Umbra15GateStateVector6getPtrEv: __ZNK5Umbra15GateStateVector6getPtrEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE6wakeUpEv, _getmntent_r: _getmntent_r, __ZNK17ArchiveFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag: __ZNK17ArchiveFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag, __ZNK16BaseVideoTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK16BaseVideoTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __Z51QualitySettings_Get_Custom_PropAsyncUploadTimeSlicev: __Z51QualitySettings_Get_Custom_PropAsyncUploadTimeSlicev, __ZN5physx35createFinalizeSolverContactsCoulombERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE: __ZN5physx35createFinalizeSolverContactsCoulombERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEbbRNS_23PxcSolverConstraintDescEPKNS_13PxcSolverBodyES8_PKNS_17PxcSolverBodyDataESB_PKNS_12PxsRigidCoreESE_ffffRNS_25PxsConstraintBlockManagerENS_14PxFrictionType4EnumE, __Z53Register_UnityEngine_MaterialPropertyBlock_SetTexturev: __Z53Register_UnityEngine_MaterialPropertyBlock_SetTexturev, __ZNK21AssetBundleFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag: __ZNK21AssetBundleFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag, __Z42Register_UnityEngine_GUIStyle_get_fontSizev: __Z42Register_UnityEngine_GUIStyle_get_fontSizev, __ZN13SliderJoint2D16CheckConsistencyEv: __ZN13SliderJoint2D16CheckConsistencyEv, __Z62Register_UnityEngine_SliderJoint2D_INTERNAL_CALL_GetMotorForcev: __Z62Register_UnityEngine_SliderJoint2D_INTERNAL_CALL_GetMotorForcev, __Z48Register_UnityEngine_TextMesh_INTERNAL_set_colorv: __Z48Register_UnityEngine_TextMesh_INTERNAL_set_colorv, __Z41Register_UnityEngine_Graphics_DrawTexturev: __Z41Register_UnityEngine_Graphics_DrawTexturev, _getchar_unlocked: _getchar_unlocked, __ZN17ArchiveFileSystem4ReadER13FileEntryDatayyPvPy: __ZN17ArchiveFileSystem4ReadER13FileEntryDatayyPvPy, __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapEnabledv: __Z63Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapEnabledv, __ZL16FMOD_ErrorString11FMOD_RESULT_59: __ZL16FMOD_ErrorString11FMOD_RESULT_59, __ZN5Unity5Cloth21SetCollisionMassScaleEf: __ZN5Unity5Cloth21SetCollisionMassScaleEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj286ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj286ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoC2Ev: __ZN11UnityEngine7Connect15DeviceInfoEvent10DeviceInfoC2Ev, __Z24RegisterStrippedTypeInfoI17SurfaceEffector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI17SurfaceEffector2DEviPKcS2_, _getrusage: _getrusage, __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AngleAxisv: __Z55Register_UnityEngine_Quaternion_INTERNAL_CALL_AngleAxisv, __ZNK5physx2Sc9ClothCore15getTetherConfigEv: __ZNK5physx2Sc9ClothCore15getTetherConfigEv, __ZN12SoundManager27OnCreateSoundPushAllocationEPv: __ZN12SoundManager27OnCreateSoundPushAllocationEPv, __ZN5physx16PxsIslandManager11preAllocateEj: __ZN5physx16PxsIslandManager11preAllocateEj, __ZN5Unity10HingeJoint8SetMotorERK10JointMotor: __ZN5Unity10HingeJoint8SetMotorERK10JointMotor, __ZN15ReflectionProbe8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15ReflectionProbe8TransferI24GenerateTypeTreeTransferEEvRT_, __Z17InvalidateVehiclej: __Z17InvalidateVehiclej, __Z62Register_UnityEngine_Gyroscope_INTERNAL_CALL_attitude_Internalv: __Z62Register_UnityEngine_Gyroscope_INTERNAL_CALL_attitude_Internalv, __ZZN8VRModuleC1EvEN33InitializationVREarlyUpdatestruct7ForwardEv: __ZZN8VRModuleC1EvEN33InitializationVREarlyUpdatestruct7ForwardEv, __Z42AudioReverbZone_Set_Custom_PropReflectionsP12Il2CppObjecti: __Z42AudioReverbZone_Set_Custom_PropReflectionsP12Il2CppObjecti, __ZN13SliderJoint2D7CleanupEb: __ZN13SliderJoint2D7CleanupEb, __Z55Register_UnityEngine_ComputeShader_SetTextureFromGlobalv: __Z55Register_UnityEngine_ComputeShader_SetTextureFromGlobalv, __Z56ReflectionProbe_Get_Custom_PropMaxBakedCubemapResolutionv: __Z56ReflectionProbe_Get_Custom_PropMaxBakedCubemapResolutionv, __Z22GetJobQueueThreadCountv: __Z22GetJobQueueThreadCountv, __ZL16CleanupModule_UIv: __ZL16CleanupModule_UIv, __ZN17Physics2DSettingsC2E10MemLabelId18ObjectCreationMode: __ZN17Physics2DSettingsC2E10MemLabelId18ObjectCreationMode, __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13TargetJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, _iswblank: _iswblank, __Z53Register_UnityEngine_ParticleRenderer_set_lengthScalev: __Z53Register_UnityEngine_ParticleRenderer_set_lengthScalev, __ZNK8Animator15GetRecorderModeEv: __ZNK8Animator15GetRecorderModeEv, __ZN10GUIManager10DoGUIEventER10InputEventb: __ZN10GUIManager10DoGUIEventER10InputEventb, __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Shader23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14AnimationState12SetupFadeoutEf: __ZN14AnimationState12SetupFadeoutEf, __ZN9GfxBufferD2Ev: __ZN9GfxBufferD2Ev, __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode2EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN14ParticleSystem6UpdateERS_fNS_11UpdateFlagsEi: __ZN14ParticleSystem6UpdateERS_fNS_11UpdateFlagsEi, __ZN5physx36solveContactCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx36solveContactCoulombPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z38GeomOverlapCallback_CapsuleHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z38GeomOverlapCallback_CapsuleHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN23ShaderVariantCollection8TransferI14SafeBinaryReadEEvRT_: __ZN23ShaderVariantCollection8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx2Cm12RenderBuffer10getNbTextsEv: __ZNK5physx2Cm12RenderBuffer10getNbTextsEv, __Z36setPxConstraint_MinResponseThresholdPN5physx12PxConstraintEf: __Z36setPxConstraint_MinResponseThresholdPN5physx12PxConstraintEf, _reset_input_controller: _reset_input_controller, __ZN22UnityProfilerPerThread20CreateOverheadSampleEv: __ZN22UnityProfilerPerThread20CreateOverheadSampleEv, __ZNK14dtNavMeshQuery22findLocalNeighbourhoodEyPKffPK13dtQueryFilterPyS5_Pii: __ZNK14dtNavMeshQuery22findLocalNeighbourhoodEyPKffPK13dtQueryFilterPyS5_Pii, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE3endEv, __ZN4gles24CreateDepthRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE: __ZN4gles24CreateDepthRenderSurfaceEP7ApiGLESP17RenderSurfaceGLESN2gl9TexFormatE, __ZN16BehaviourManagerD0Ev: __ZN16BehaviourManagerD0Ev, __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Sc14ConstraintCore19prepareForSetBodiesEv: __ZN5physx2Sc14ConstraintCore19prepareForSetBodiesEv, _UNITY_ft_corner_is_flat: _UNITY_ft_corner_is_flat, __ZNK24DownloadHandlerAudioClip11GetProgressEv: __ZNK24DownloadHandlerAudioClip11GetProgressEv, __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentrycvbEv: __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6sentrycvbEv, __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj: __ZN5physx5cloth7SwCloth18clampTriangleCountENS0_5RangeIKNS_6PxVec3EEEj, __ZN22UnityAnalyticsSettings12GetOldUserIdEv: __ZN22UnityAnalyticsSettings12GetOldUserIdEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, _UNITY_png_convert_to_rfc1123: _UNITY_png_convert_to_rfc1123, __ZN24GenerateTypeTreeTransfer8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj296ENS_22PxRepXPropertyAccessorILj296ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxHeightFieldDescEEEE14handleAccessorILj296ENS_22PxRepXPropertyAccessorILj296ES4_ffEEEEvRKT0_, __Z48Register_UnityEngine_AudioChorusFilter_get_delayv: __Z48Register_UnityEngine_AudioChorusFilter_get_delayv, __ZNK28RectTransformPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK28RectTransformPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj: __ZNSt3__26vectorIP8Renderer13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE8__appendEj, __ZN18IDCollectorFunctorD2Ev: __ZN18IDCollectorFunctorD2Ev, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7releaseEv: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7releaseEv, __ZNK21DownloadHandlerScript9GetLengthEv: __ZNK21DownloadHandlerScript9GetLengthEv, __ZN5physx16PxsIslandManager19finishSolverIslandsEv: __ZN5physx16PxsIslandManager19finishSolverIslandsEv, __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv: __ZNK5physx17PxcNpMemBlockPool27getPeakConstraintBlockCountEv, _gzputs: _gzputs, __ZL32InitializeModule_UnityWebRequestv: __ZL32InitializeModule_UnityWebRequestv, __ZN5physx9NpPhysics13registerClothEv: __ZN5physx9NpPhysics13registerClothEv, __Z20FinishUpdatingClothsv: __Z20FinishUpdatingClothsv, __ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_: __ZL24AddShadowCasterCullPlanebPK5PlaneRK10Matrix4x4fRK8Vector3fffiii9LightTypeS7_RS_, __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_: __ZNKSt3__23mapINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiNS_4lessIS6_EENS4_INS_4pairIKS6_iEEEEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERSA_, __ZN5physx2Sc5Scene15addArticulationERNS0_16ArticulationCoreERNS0_8BodyCoreE: __ZN5physx2Sc5Scene15addArticulationERNS0_16ArticulationCoreERNS0_8BodyCoreE, __ZN5physx2Sc13ConstraintSim9visualizeERNS_14PxRenderBufferE: __ZN5physx2Sc13ConstraintSim9visualizeERNS_14PxRenderBufferE, _gzputc: _gzputc, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN14RenderSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14RenderSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx18PxsDynamicsContextC2EPNS_10PxsContextE: __ZN5physx18PxsDynamicsContextC2EPNS_10PxsContextE, __ZN4FMOD13ChannelGroupI8addGroupEPNS_12ChannelGroupE: __ZN4FMOD13ChannelGroupI8addGroupEPNS_12ChannelGroupE, __ZN2UI11CanvasGroup15SetInteractableEb: __ZN2UI11CanvasGroup15SetInteractableEb, __ZL17CheckForIntersectP14TESStesselatorP12ActiveRegion: __ZL17CheckForIntersectP14TESStesselatorP12ActiveRegion, __Z30Animator_CUSTOM_SetLayerWeightP12Il2CppObjectif: __Z30Animator_CUSTOM_SetLayerWeightP12Il2CppObjectif, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZN25PathNamePersistentManagerD0Ev: __ZN25PathNamePersistentManagerD0Ev, __Z21GetAIScriptingClassesv: __Z21GetAIScriptingClassesv, __ZN15ResourceManager6GetAllEv: __ZN15ResourceManager6GetAllEv, __ZL19GetCameraTargetRectRK6Camerab: __ZL19GetCameraTargetRectRK6Camerab, __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev: __ZThn8_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev, __Z18Transfer_BlittableI8JSONReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10systeminfo19GetDeviceSystemNameEv: __ZN10systeminfo19GetDeviceSystemNameEv, __ZN11UnityEngine15CloudWebService18RestFileDownloader22OnReceiveContentLengthEj: __ZN11UnityEngine15CloudWebService18RestFileDownloader22OnReceiveContentLengthEj, __Z59ConfigurableJoint_CUSTOM_INTERNAL_get_targetAngularVelocityP12Il2CppObjectP8Vector3f: __Z59ConfigurableJoint_CUSTOM_INTERNAL_get_targetAngularVelocityP12Il2CppObjectP8Vector3f, __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE: __ZN32SerializationCommandQueueBuilder3AddERK13dynamic_arrayI20SerializationCommandLj4EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi20EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIfLi20EEEEvRT_17TransferMetaFlags, __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN7Joint2D13AwakeFromLoadE17AwakeFromLoadMode, __Z47Register_UnityEngine_GUIText_INTERNAL_get_colorv: __Z47Register_UnityEngine_GUIText_INTERNAL_get_colorv, __ZN14PhysicsManager15ProcessContactsEv: __ZN14PhysicsManager15ProcessContactsEv, __Z50ParticleSystem_TriggerModule_CUSTOM_GetRadiusScaleP12Il2CppObject: __Z50ParticleSystem_TriggerModule_CUSTOM_GetRadiusScaleP12Il2CppObject, __Z11SkinGenericILi1ELb0ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi1ELb0ELb0EEvR12SkinMeshInfo, __Z23Mesh_CUSTOM_GetTopologyP12Il2CppObjecti: __Z23Mesh_CUSTOM_GetTopologyP12Il2CppObjecti, __Z11loadAlignedPKf: __Z11loadAlignedPKf, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN11UnityEngine7Connect17DeviceInfoUpdater5ResetEv: __ZN11UnityEngine7Connect17DeviceInfoUpdater5ResetEv, __Z52Register_UnityEngine_GameObject_SetActiveRecursivelyv: __Z52Register_UnityEngine_GameObject_SetActiveRecursivelyv, __ZN13DrawImmediate6NormalEfff: __ZN13DrawImmediate6NormalEfff, __ZN2UI14CanvasRenderer8GetColorEv: __ZN2UI14CanvasRenderer8GetColorEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj50ENS_22PxRepXPropertyAccessorILj50ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj50ENS_22PxRepXPropertyAccessorILj50ES4_ffEEEEvRKT0_, __ZN9ShaderLab11shaderprops16GetComputeBufferEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE: __ZN9ShaderLab11shaderprops16GetComputeBufferEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE, __ZN16SubstanceArchive7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN16SubstanceArchive7PRODUCEE10MemLabelId18ObjectCreationMode, __Z59Register_UnityEngine_ParticleRenderer_set_uvAnimationCyclesv: __Z59Register_UnityEngine_ParticleRenderer_set_uvAnimationCyclesv, __Z33setPxCloth_SelfCollisionStiffnessPN5physx7PxClothEf: __Z33setPxCloth_SelfCollisionStiffnessPN5physx7PxClothEf, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE12createObjectERPhRNS_24PxDeserializationContextE, __Z32AudioMixerDuckingProcessCallbackP21UnityAudioEffectStatePfS1_jii: __Z32AudioMixerDuckingProcessCallbackP21UnityAudioEffectStatePfS1_jii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj559ENS_22PxRepXPropertyAccessorILj559ES4_ffEEEEvRKT0_, __ZN8Renderer17MainThreadCleanupEv: __ZN8Renderer17MainThreadCleanupEv, __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN5physx7NpCloth10putToSleepEv: __ZN5physx7NpCloth10putToSleepEv, __ZN5physx17ConvexHullBuilderD2Ev: __ZN5physx17ConvexHullBuilderD2Ev, __ZN5physx19PxsFluidSpatialHash32reorderParticlesToPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEPKNS_16PxsFluidParticleEPKjPjPt: __ZN5physx19PxsFluidSpatialHash32reorderParticlesToPacketSectionsERKNS_15PxsParticleCellERNS_22PxsFluidPacketSectionsEPKNS_16PxsFluidParticleEPKjPjPt, __ZN12ImageDecoderD0Ev: __ZN12ImageDecoderD0Ev, _UNITY_FT_Create_Class_cff_driver_class: _UNITY_FT_Create_Class_cff_driver_class, __ZN15FileSystemEntryC2EPKc: __ZN15FileSystemEntryC2EPKc, __ZNSt3__212__next_primeEj: __ZNSt3__212__next_primeEj, __Z51Register_UnityEngine_LineRenderer_get_colorGradientv: __Z51Register_UnityEngine_LineRenderer_get_colorGradientv, __Z29AddRotationCurveToClipBuilderR17AnimationCurveTplI11QuaternionfERK8UnityStrR18MecanimClipBuilderb: __Z29AddRotationCurveToClipBuilderR17AnimationCurveTplI11QuaternionfERK8UnityStrR18MecanimClipBuilderb, __ZN14TerrainManagerD0Ev: __ZN14TerrainManagerD0Ev, _shm_unlink: _shm_unlink, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE15exportExtraDataERNS_22PxSerializationContextE, __ZN16SubstanceArchive13AwakeFromLoadE17AwakeFromLoadMode: __ZN16SubstanceArchive13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx32pcmDistanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES4_S4_S4_RNS1_6FloatVES6_: __ZN5physx32pcmDistanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES4_S4_S4_RNS1_6FloatVES6_, __ZN22UnityProfilerPerThread8EndFrameEv: __ZN22UnityProfilerPerThread8EndFrameEv, _ldiv: _ldiv, __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshRendererv: __Z63Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshRendererv, __ZN19RuntimeSceneManager21FindSceneByBuildIndexEi: __ZN19RuntimeSceneManager21FindSceneByBuildIndexEi, __ZN22DownloadHandlerTexture13CreateTextureEv: __ZN22DownloadHandlerTexture13CreateTextureEv, __ZNK18ProceduralMaterial20HasSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial20HasSubstancePropertyERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_: __ZL15AccumulateNoiseILb1ELi2EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_, __ZN18MultiFrameGUIStateD2Ev: __ZN18MultiFrameGUIStateD2Ev, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEE15growAndPushBackERKS2_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb1EEE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI16SplashScreenLogoLj4EEEEvRT_17TransferMetaFlags, __Z42Register_UnityEngine_Behaviour_set_enabledv: __Z42Register_UnityEngine_Behaviour_set_enabledv, __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_: __Z22CopyVertexDataChannelsjjRK14VertexDataInfoRS_, __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_worldRotationAxisv: __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_set_worldRotationAxisv, __ZN14PhysicMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14PhysicMaterial8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z33Graphics_CUSTOM_CopyTexture_SliceP12Il2CppObjectiiS0_ii: __Z33Graphics_CUSTOM_CopyTexture_SliceP12Il2CppObjectiiS0_ii, __Z37Collider2D_CUSTOM_INTERNAL_set_offsetP12Il2CppObjectRK13Vector2fIcall: __Z37Collider2D_CUSTOM_INTERNAL_set_offsetP12Il2CppObjectRK13Vector2fIcall, __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_: __ZNSt3__26__treeINS_12__value_typeIN19CloudServiceHandler11ServiceTypeEPS2_EENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier85ELi16EEE12__find_equalIS3_EERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_SG_EEiEESJ_RKT_, __ZN4FMOD6System7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE: __ZN4FMOD6System7playDSPE17FMOD_CHANNELINDEXPNS_3DSPEbPPNS_7ChannelE, __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __Z33AndroidJNI_CUSTOM_DeleteGlobalRef13Il2Cpp_IntPtr: __Z33AndroidJNI_CUSTOM_DeleteGlobalRef13Il2Cpp_IntPtr, __ZNK20LocalFileSystemPosix4SizeERK13FileEntryData: __ZNK20LocalFileSystemPosix4SizeERK13FileEntryData, __ZN5physx16PxsSolverEndTask11runInternalEv: __ZN5physx16PxsSolverEndTask11runInternalEv, __ZN12AudioManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12AudioManager8TransferI24GenerateTypeTreeTransferEEvRT_, __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetDeathv: __Z62Register_UnityEngine_ParticleSystem_SubEmittersModule_GetDeathv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj459ENS_22PxRepXPropertyAccessorILj459ES4_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj459ENS_22PxRepXPropertyAccessorILj459ES4_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESC_EEEEvRKT0_, __ZN12AudioManager17MainThreadCleanupEv: __ZN12AudioManager17MainThreadCleanupEv, __Z48Register_UnityEngine_ParticleEmitter_get_enabledv: __Z48Register_UnityEngine_ParticleEmitter_get_enabledv, __Z17GetPhysicsWorld2Dv: __Z17GetPhysicsWorld2Dv, __ZN5physx3Scb17ArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb17ArticulationJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeE: __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIP11Il2CppClassPKN5Unity4TypeENS_4lessIS3_EENS_9allocatorINS_4pairIS3_S7_EEEEE13value_compareENS_11__wrap_iterIPSC_EEEEvT0_SK_SK_T_NS_15iterator_traitsISK_E15difference_typeESO_PNSN_10value_typeE, __ZN4crnd28crnd_get_bytes_per_dxt_blockE10crn_format: __ZN4crnd28crnd_get_bytes_per_dxt_blockE10crn_format, __Z21GetImagePixelBilinearPKhii13TextureFormat15TextureWrapModeff: __Z21GetImagePixelBilinearPKhii13TextureFormat15TextureWrapModeff, __ZN9ShaderLab9SubShader15FindNamedPassesERK8UnityStrR13dynamic_arrayIPNS_4PassELj4EE: __ZN9ShaderLab9SubShader15FindNamedPassesERK8UnityStrR13dynamic_arrayIPNS_4PassELj4EE, __Z42getPxParticleReadDataCollisionNormalBufferPKN5physx18PxParticleReadDataE: __Z42getPxParticleReadDataCollisionNormalBufferPKN5physx18PxParticleReadDataE, __ZN14dtPathCorridor4initEPK9dtNavMeshi: __ZN14dtPathCorridor4initEPK9dtNavMeshi, __Z47Register_UnityEngine_Canvas_get_overrideSortingv: __Z47Register_UnityEngine_Canvas_get_overrideSortingv, __ZN5physx25PxcPCMContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx25PxcPCMContactConvexConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z54Register_UnityEngine_AreaEffector2D_get_forceVariationv: __Z54Register_UnityEngine_AreaEffector2D_get_forceVariationv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv, __ZN14b2CapsuleShapeD0Ev: __ZN14b2CapsuleShapeD0Ev, __Z42Transform_Set_Custom_PropHierarchyCapacityP12Il2CppObjecti: __Z42Transform_Set_Custom_PropHierarchyCapacityP12Il2CppObjecti, __ZN10Collider2D26UpdateColliderDensityStateEP11Rigidbody2D: __ZN10Collider2D26UpdateColliderDensityStateEP11Rigidbody2D, __ZL21DeveloperConsoleDoGUIPvN13MonoBehaviour13GUILayoutTypeEii: __ZL21DeveloperConsoleDoGUIPvN13MonoBehaviour13GUILayoutTypeEii, __ZN18ComputeShaderParam8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18ComputeShaderParam8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _SendMessage: _SendMessage, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXDrivev: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularXDrivev, __ZN5physx17ConvexHullBuilderC2EPNS_2Gu14ConvexHullDataE: __ZN5physx17ConvexHullBuilderC2EPNS_2Gu14ConvexHullDataE, __ZNK11MinMaxCurve10FindMinMaxEv: __ZNK11MinMaxCurve10FindMinMaxEv, __ZN29AssetBundleLoadAssetOperationD2Ev: __ZN29AssetBundleLoadAssetOperationD2Ev, __ZNK5physx23PxsFluidDynamicsSphTask7getNameEv: __ZNK5physx23PxsFluidDynamicsSphTask7getNameEv, __Z24IsProceduralInputVisiblePK18ProceduralMaterialRK8UnityStr: __Z24IsProceduralInputVisiblePK18ProceduralMaterialRK8UnityStr, __ZN4FMOD6System5closeEv: __ZN4FMOD6System5closeEv, __Z44Register_UnityEngine_Application_get_versionv: __Z44Register_UnityEngine_Application_get_versionv, __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList: __ZN15DirectorManager14ConnectionPool4FreeEP14ConnectionList, __ZN18AnimatorController30OnInvalidateAnimatorControllerEv: __ZN18AnimatorController30OnInvalidateAnimatorControllerEv, __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb: __ZN5physx3Scb5Scene18switchRigidToNoSimERNS0_11RigidObjectEb, __Z45LightProbeGroup_Get_Custom_PropProbePositionsP12Il2CppObject: __Z45LightProbeGroup_Get_Custom_PropProbePositionsP12Il2CppObject, __Z28TextMesh_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString: __Z28TextMesh_Set_Custom_PropTextP12Il2CppObjectP12Il2CppString, __Z50Register_UnityEngine_TerrainData_INTERNAL_get_sizev: __Z50Register_UnityEngine_TerrainData_INTERNAL_get_sizev, __Z22GetGfxDeviceLevelNamesv: __Z22GetGfxDeviceLevelNamesv, __Z45Register_UnityEngine_CubemapArray_GetPixels32v: __Z45Register_UnityEngine_CubemapArray_GetPixels32v, __ZN5Cache15FreeUsableSpaceEj: __ZN5Cache15FreeUsableSpaceEj, _gz_open: _gz_open, _find_charmap: _find_charmap, _fmax: _fmax, __ZNKSt3__215__codecvt_utf16IDsLb1EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IDsLb1EE11do_encodingEv, __ZN5physx6shdfnd5ArrayIPKcNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPKcNS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN12TextureIdMap10InitializeEv: __ZN12TextureIdMap10InitializeEv, __Z29RegisterModuleClasses_Physicsv: __Z29RegisterModuleClasses_Physicsv, _ft_smooth_set_mode: _ft_smooth_set_mode, __Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag: __Z16FlaggedAsSkippedINSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEEbRK13FileEntryInfoRKT_19FileEnumerationFlag, __ZN4FMOD7SystemI19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD7SystemI19getReverbPropertiesEP22FMOD_REVERB_PROPERTIES, __ZNKSt3__215__codecvt_utf16IDiLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_: __ZNKSt3__215__codecvt_utf16IDiLb0EE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_, __ZN33AssetBundleLoadFromAsyncOperationD2Ev: __ZN33AssetBundleLoadFromAsyncOperationD2Ev, __Z44Register_UnityEngine_ComputeShader_HasKernelv: __Z44Register_UnityEngine_ComputeShader_HasKernelv, __ZN14MemoryProfiler24UnregisterRootAllocationEP23AllocationRootReference: __ZN14MemoryProfiler24UnregisterRootAllocationEP23AllocationRootReference, __Z56ParticleSystem_MainModule_CUSTOM_GetStartDelayMultiplierP12Il2CppObject: __Z56ParticleSystem_MainModule_CUSTOM_GetStartDelayMultiplierP12Il2CppObject, __Z50Profiler_Get_Custom_PropMaxNumberOfSamplesPerFramev: __Z50Profiler_Get_Custom_PropMaxNumberOfSamplesPerFramev, __ZN5Umbra6Random4getIEv: __ZN5Umbra6Random4getIEv, __Z60Register_UnityEngine_Camera_INTERNAL_set_worldToCameraMatrixv: __Z60Register_UnityEngine_Camera_INTERNAL_set_worldToCameraMatrixv, __ZN11TypeManager14MarkDeprecatedEi: __ZN11TypeManager14MarkDeprecatedEi, __ZN23TransformChangeDispatch19SetSystemInterestedE15TransformAccess27TransformChangeSystemHandleb: __ZN23TransformChangeDispatch19SetSystemInterestedE15TransformAccess27TransformChangeSystemHandleb, __Z32Camera_Set_Custom_PropCameraTypeP12Il2CppObject10CameraType: __Z32Camera_Set_Custom_PropCameraTypeP12Il2CppObject10CameraType, __Z25getPxPhysics_ConvexMeshesPKN5physx9PxPhysicsEPPNS_12PxConvexMeshEj: __Z25getPxPhysics_ConvexMeshesPKN5physx9PxPhysicsEPPNS_12PxConvexMeshEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj285ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj285ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z41Application_Get_Custom_PropIsLoadingLevelv: __Z41Application_Get_Custom_PropIsLoadingLevelv, __Z44ParticleSystem_NoiseModule_CUSTOM_SetDampingP12Il2CppObjecth: __Z44ParticleSystem_NoiseModule_CUSTOM_SetDampingP12Il2CppObjecth, __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientProbev: __Z61Register_UnityEngine_RenderSettings_INTERNAL_set_ambientProbev, __ZN5physx16PxVehicleNoDrive17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx16PxVehicleNoDrive17getBinaryMetaDataERNS_14PxOutputStreamE, _tt_cmap10_char_next: _tt_cmap10_char_next, __Z56Register_UnityEngine_RenderTexture_INTERNAL_CALL_Releasev: __Z56Register_UnityEngine_RenderTexture_INTERNAL_CALL_Releasev, __Z48Register_UnityEngine_Hash128_INTERNAL_CALL_Parsev: __Z48Register_UnityEngine_Hash128_INTERNAL_CALL_Parsev, __ZN13GfxDeviceGLES19CancelPendingMipGenEP17RenderSurfaceBase: __ZN13GfxDeviceGLES19CancelPendingMipGenEP17RenderSurfaceBase, __ZN20SoundChannelInstance11UpdatePitchEv: __ZN20SoundChannelInstance11UpdatePitchEv, __ZN15NavMeshObstacle16CheckConsistencyEv: __ZN15NavMeshObstacle16CheckConsistencyEv, __ZN23RayMeshColliderCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN23RayMeshColliderCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZNK9ShaderLab11ShaderState29BuildDeviceStatesForWireframeER9GfxDevicePK19ShaderPropertySheetS5_RKS0_RNS0_12DeviceStatesE: __ZNK9ShaderLab11ShaderState29BuildDeviceStatesForWireframeER9GfxDevicePK19ShaderPropertySheetS5_RKS0_RNS0_12DeviceStatesE, _tre_set_empty: _tre_set_empty, _jpeg_read_header: _jpeg_read_header, __ZN18ProceduralMaterial8TransferI14SafeBinaryReadEEvRT_: __ZN18ProceduralMaterial8TransferI14SafeBinaryReadEEvRT_, __ZThn32_N22ParticleSystemRendererD0Ev: __ZThn32_N22ParticleSystemRendererD0Ev, __Z51scripting_object_new_and_invoke_default_constructorP11Il2CppClassPP15Il2CppException: __Z51scripting_object_new_and_invoke_default_constructorP11Il2CppClassPP15Il2CppException, _iswalnum_l: _iswalnum_l, __Z46Register_UnityEngine_Physics2D_IgnoreCollisionv: __Z46Register_UnityEngine_Physics2D_IgnoreCollisionv, __ZN5physx3Ext15CpuWorkerThread24tryAcceptJobToLocalQueueERNS_10PxBaseTaskEj: __ZN5physx3Ext15CpuWorkerThread24tryAcceptJobToLocalQueueERNS_10PxBaseTaskEj, __ZN9InputAxis8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9InputAxis8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Cct26CharacterControllerManager18getObstacleContextEj: __ZN5physx3Cct26CharacterControllerManager18getObstacleContextEj, __ZN11UnityEngine15CloudWebService17SessionEventQueueC2Ev: __ZN11UnityEngine15CloudWebService17SessionEventQueueC2Ev, __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass: __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass, _unity_z_deflatePrime: _unity_z_deflatePrime, __ZN5physx2Sc10NPhaseCore34insertParticleElementRbElementPairEPNS0_19ParticlePacketShapeEPNS0_8ShapeSimEPNS0_16ActorElementPairEj: __ZN5physx2Sc10NPhaseCore34insertParticleElementRbElementPairEPNS0_19ParticlePacketShapeEPNS0_8ShapeSimEPNS0_16ActorElementPairEj, __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE9propagateERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialERKNS_6shdfnd3aos6Mat33VENSA_6FloatVE: __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE9propagateERKNS_12PxcFsInertiaEPKNS_14PxcSIMDSpatialERKNS_6shdfnd3aos6Mat33VENSA_6FloatVE, __ZN26AnimatorControllerPlayable19DeallocateResourcesEv: __ZN26AnimatorControllerPlayable19DeallocateResourcesEv, __ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib: __ZNK13b2CircleShape11ComputeAABBEP6b2AABBRK11b2Transformib, __ZN10HumanTrait13GetFingerNameEib: __ZN10HumanTrait13GetFingerNameEib, __ZN14PhysicsManager17GetSleepThresholdEv: __ZN14PhysicsManager17GetSleepThresholdEv, __Z5rsqrtRK8Scalar4f: __Z5rsqrtRK8Scalar4f, __ZN14Texture2DArrayD0Ev: __ZN14Texture2DArrayD0Ev, __Z44Register_UnityEngine_Joint_INTERNAL_get_axisv: __Z44Register_UnityEngine_Joint_INTERNAL_get_axisv, __ZN5physx2Gu8GJKLocalERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE: __ZN5physx2Gu8GJKLocalERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE, __ZN6Object8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN6Object8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46TerrainData_CUSTOM_Internal_SetHeightsDelayLODP12Il2CppObjectiiiiP11Il2CppArray: __Z46TerrainData_CUSTOM_Internal_SetHeightsDelayLODP12Il2CppObjectiiiiP11Il2CppArray, __ZNK12TLSAllocatorI14StackAllocatorE15WalkAllocationsEPFvPKvjPKPvjE: __ZNK12TLSAllocatorI14StackAllocatorE15WalkAllocationsEPFvPKvjPKPvjE, __ZL18AddSliverTrianglesPjjii: __ZL18AddSliverTrianglesPjjii, __ZNK20TextRenderingPrivate8FontImpl37CheckFontWithCustomSizeStyleIsDynamicERiRjPj: __ZNK20TextRenderingPrivate8FontImpl37CheckFontWithCustomSizeStyleIsDynamicERiRjPj, __ZN4FMOD7SystemI11getSoundRAMEPiS1_S1_: __ZN4FMOD7SystemI11getSoundRAMEPiS1_S1_, __Z36LightProbes_Get_Custom_PropPositionsP12Il2CppObject: __Z36LightProbes_Get_Custom_PropPositionsP12Il2CppObject, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j, __ZN12ImageDecoder8SetErrorEv: __ZN12ImageDecoder8SetErrorEv, __ZN13MemoryManager13ThreadCleanupEv: __ZN13MemoryManager13ThreadCleanupEv, __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE: __ZN7mecanim25DestroyValueArrayConstantEPNS_18ValueArrayConstantERNS_6memory9AllocatorE, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_15NpParticleFluidEEEEEE15growAndPushBackERKS2_, __ZThn4_N12_GLOBAL__N_117ConnectionManagerD0Ev: __ZThn4_N12_GLOBAL__N_117ConnectionManagerD0Ev, __ZN13GfxDeviceGLES15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace: __ZN13GfxDeviceGLES15UploadTexture2DE9TextureID16TextureDimensionPKhiii13TextureFormatij16TextureUsageMode17TextureColorSpace, __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt16v: __Z56Register_UnityEngine_Analytics_CustomEventData_AddUInt16v, __ZN5physx27PxsFluidParticleOpcodeCache28writeTriangles_BaseU16_9xU10EPhPKjj: __ZN5physx27PxsFluidParticleOpcodeCache28writeTriangles_BaseU16_9xU10EPhPKjj, __GLOBAL__sub_I_runtime_preloadmanager_lump_cpp: __GLOBAL__sub_I_runtime_preloadmanager_lump_cpp, __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi: __ZL17FindLightModePassPN9ShaderLab9IntShaderE14ShaderPassTypeRi, __ZN13GfxDeviceNull14SetWorldMatrixERK10Matrix4x4f: __ZN13GfxDeviceNull14SetWorldMatrixERK10Matrix4x4f, __Z50Physics2D_CUSTOM_INTERNAL_CALL_Internal_CircleCastRK13Vector2fIcallfS1_fiffP12RaycastHit2D: __Z50Physics2D_CUSTOM_INTERNAL_CALL_Internal_CircleCastRK13Vector2fIcallfS1_fiffP12RaycastHit2D, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE12getClassSizeEv, __Z61Register_UnityEngine_ConstantForce_INTERNAL_set_relativeForcev: __Z61Register_UnityEngine_ConstantForce_INTERNAL_set_relativeForcev, __ZNK14NavMeshManager20GetOffMeshConnectionEyP8Vector3fS1_Pf: __ZNK14NavMeshManager20GetOffMeshConnectionEyP8Vector3fS1_Pf, __ZN21RotationBySpeedModule8TransferI17RemapPPtrTransferEEvRT_: __ZN21RotationBySpeedModule8TransferI17RemapPPtrTransferEEvRT_, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE17GetProfilerHeaderEPKv, __ZN5physx3Cct9SweepTest20findTouchedObstaclesERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3E: __ZN5physx3Cct9SweepTest20findTouchedObstaclesERKNS0_13UserObstaclesERKNS_17PxExtendedBounds3E, __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams: __ZN12NavMeshAgent15FillAgentParamsER18dtCrowdAgentParams, _if_indextoname: _if_indextoname, __ZNK5physx7NpScene15SceneCompletion7getNameEv: __ZNK5physx7NpScene15SceneCompletion7getNameEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj555ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj555ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9ShaderLab10SubProgramC2EPKc20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EEP16PropertyNamesSetRK16ShaderKeywordSet: __ZN9ShaderLab10SubProgramC2EPKc20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EEP16PropertyNamesSetRK16ShaderKeywordSet, _jsimd_fdct_ifast: _jsimd_fdct_ifast, __ZN11UnityEngine15CloudWebService17SessionEventQueue10SaveToFileER12FileAccessor: __ZN11UnityEngine15CloudWebService17SessionEventQueue10SaveToFileER12FileAccessor, __ZNK5Umbra11Transformer16getFrustumCornerEi: __ZNK5Umbra11Transformer16getFrustumCornerEi, __ZNKSt3__25ctypeIwE10do_tolowerEPwPKw: __ZNKSt3__25ctypeIwE10do_tolowerEPwPKw, __ZN5physx6shdfnd7PAUtilsC2Ev: __ZN5physx6shdfnd7PAUtilsC2Ev, __ZNK5physx2Sc9ClothCore21getCollisionMassScaleEv: __ZNK5physx2Sc9ClothCore21getCollisionMassScaleEv, __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv: __ZN24dense_hashtable_iteratorINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EppEv, __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12WheelJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN12WheelJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN12WheelJoint2DC2E10MemLabelId18ObjectCreationMode, __Z53Register_UnityEngine_RectTransform_INTERNAL_set_pivotv: __Z53Register_UnityEngine_RectTransform_INTERNAL_set_pivotv, __ZN5Unity14CharacterJoint21SetProjectionDistanceEf: __ZN5Unity14CharacterJoint21SetProjectionDistanceEf, __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_: __ZN5physx5cloth11SwCollisionI8Scalar4fE18ImpulseAccumulator8subtractERKS2_S6_S6_S6_S6_, __ZN8Playable7GetTypeEv: __ZN8Playable7GetTypeEv, __Z36NavMesh_CUSTOM_INTERNAL_CALL_RaycastRK8Vector3fS1_P10NavMeshHiti: __Z36NavMesh_CUSTOM_INTERNAL_CALL_RaycastRK8Vector3fS1_P10NavMeshHiti, __Z17DeformSkinnedMeshR12SkinMeshInfo: __Z17DeformSkinnedMeshR12SkinMeshInfo, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10ReallocateEPvji: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10ReallocateEPvji, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __Z10FindStringRKNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEEj: __Z10FindStringRKNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEEj, __ZThn4_N5physx12MemoryBufferD0Ev: __ZThn4_N5physx12MemoryBufferD0Ev, __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP17FileSystemHandlerNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN10TagManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10TagManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib: __ZNK10__cxxabiv121__vmi_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib, __ZN20LocalFileSystemPosixD2Ev: __ZN20LocalFileSystemPosixD2Ev, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED0Ev: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEED0Ev, __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI18StreamedBinaryReadILb1EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN10HumanTrait14BoneFromMuscleEi: __ZN10HumanTrait14BoneFromMuscleEi, __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetDurationInternalv: __Z85Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetDurationInternalv, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7releaseEv, __ZN5physx3Cct26CharacterControllerManager22releaseObstacleContextERNS0_15ObstacleContextE: __ZN5physx3Cct26CharacterControllerManager22releaseObstacleContextERNS0_15ObstacleContextE, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyERKN5physx8debugger14NamespacedNameEPKc: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyERKN5physx8debugger14NamespacedNameEPKc, __ZN19SkinnedMeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN19SkinnedMeshRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, __Z38AndroidJNI_CUSTOM_SetStaticStringField13Il2Cpp_IntPtrS_P12Il2CppString: __Z38AndroidJNI_CUSTOM_SetStaticStringField13Il2Cpp_IntPtrS_P12Il2CppString, __ZN5Umbra4Math3cosERKNS_6DoubleE: __ZN5Umbra4Math3cosERKNS_6DoubleE, __ZN26AnimatorOverrideControllerD0Ev: __ZN26AnimatorOverrideControllerD0Ev, __ZN24UserAuthorizationManager33UserAuthorizationManagerOperationD0Ev: __ZN24UserAuthorizationManager33UserAuthorizationManagerOperationD0Ev, __Z33EvaluateQuaternionFromEulerCurvesRK17AnimationCurveTplIfES2_S2_f: __Z33EvaluateQuaternionFromEulerCurvesRK17AnimationCurveTplIfES2_S2_f, __Z39ParticleSystem_Get_Custom_PropStartSizeP12Il2CppObject: __Z39ParticleSystem_Get_Custom_PropStartSizeP12Il2CppObject, __Z36EdgeCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray: __Z36EdgeCollider2D_Set_Custom_PropPointsP12Il2CppObjectP11Il2CppArray, __ZN14PhysicsManager26SetTransformMessageEnabledEb: __ZN14PhysicsManager26SetTransformMessageEnabledEb, __Z67Register_UnityEngine_Experimental_Director_Playables_CastToInternalv: __Z67Register_UnityEngine_Experimental_Director_Playables_CastToInternalv, __ZN17AudioChorusFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN17AudioChorusFilter23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd13TempAllocator8allocateEjPKci: __ZN5physx6shdfnd13TempAllocator8allocateEjPKci, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj659ENS_22PxRepXPropertyAccessorILj659ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj659ENS_22PxRepXPropertyAccessorILj659ES4_ffEEEEvRKT0_, __Z51ConfigurableJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject: __Z51ConfigurableJoint_Get_Custom_PropProjectionDistanceP12Il2CppObject, __ZN5Unity17ConfigurableJoint24SetTargetAngularVelocityERK8Vector3f: __ZN5Unity17ConfigurableJoint24SetTargetAngularVelocityERK8Vector3f, __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_21PxClothCollisionPlaneENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN4FMOD6System11registerDSPEP20FMOD_DSP_DESCRIPTIONPj: __ZN4FMOD6System11registerDSPEP20FMOD_DSP_DESCRIPTIONPj, __ZN18ProceduralMaterial16SetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi: __ZN18ProceduralMaterial16SetSubstanceEnumERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEi, __ZN5physx16PxsParticleShape8destroyVEv: __ZN5physx16PxsParticleShape8destroyVEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj157ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj157ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx20SingleAABBUpdateTask11runInternalEv: __ZN5physx20SingleAABBUpdateTask11runInternalEv, __ZN17CollisionMeshDataD2Ev: __ZN17CollisionMeshDataD2Ev, __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv: __ZNK5physx2Sn15PxMetaDataEntry11isVTablePtrEv, __ZNSt3__24stofERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj: __ZNSt3__24stofERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj, _UNITY_FT_Destroy_Class_ft_smooth_lcdv_renderer_class: _UNITY_FT_Destroy_Class_ft_smooth_lcdv_renderer_class, __ZN18GlslGpuProgramGLESD0Ev: __ZN18GlslGpuProgramGLESD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj618ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN15TerrainCollider7CleanupEv: __ZN15TerrainCollider7CleanupEv, __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4pptrEv: __ZNKSt3__215basic_streambufIwNS_11char_traitsIwEEE4pptrEv, __Z29Time_Get_Custom_PropFixedTimev: __Z29Time_Get_Custom_PropFixedTimev, __ZN13ScreenManager22SetRequestedResolutionEv: __ZN13ScreenManager22SetRequestedResolutionEv, __Z25getPxPrismaticJoint_LimitPKN5physx16PxPrismaticJointE: __Z25getPxPrismaticJoint_LimitPKN5physx16PxPrismaticJointE, __ZN5physx8debugger4comm23EndPropertyMessageGroup9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm23EndPropertyMessageGroup9serializeERNS1_15EventSerializerE, __Z24InitializeNavMeshManagerv: __Z24InitializeNavMeshManagerv, __Z28StartCreateTextureFromBufferPKhjb: __Z28StartCreateTextureFromBufferPKhjb, __Z34Canvas_Get_Custom_PropIsRootCanvasP12Il2CppObject: __Z34Canvas_Get_Custom_PropIsRootCanvasP12Il2CppObject, __Z33Camera_Get_Custom_PropPixelHeightP12Il2CppObject: __Z33Camera_Get_Custom_PropPixelHeightP12Il2CppObject, __ZN6Camera25InvokePostRenderCallbacksEv: __ZN6Camera25InvokePostRenderCallbacksEv, __ZN14dtPathCorridor11setCorridorEPKfPK14dtNavMeshQueryPKyib: __ZN14dtPathCorridor11setCorridorEPKfPK14dtNavMeshQueryPKyib, __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE: __ZN5physx2Sc15ArticulationSim10removeBodyERNS0_7BodySimE, __ZN5physx26PxSceneDescGeneratedValuesC2EPKNS_11PxSceneDescE: __ZN5physx26PxSceneDescGeneratedValuesC2EPKNS_11PxSceneDescE, __Z18GetQualitySettingsv: __Z18GetQualitySettingsv, __Z44Register_UnityEngine_Canvas_set_pixelPerfectv: __Z44Register_UnityEngine_Canvas_set_pixelPerfectv, __ZN13AudioListener7CleanupEv: __ZN13AudioListener7CleanupEv, __Z37Register_UnityEngine_Mesh_GetTopologyv: __Z37Register_UnityEngine_Mesh_GetTopologyv, __ZN5Umbra20RuntimeTomeGenerator21outputExternalPortalsERNS_7ExtTileEiiPKNS0_6ResultERKNS_5ArrayIjEEi: __ZN5Umbra20RuntimeTomeGenerator21outputExternalPortalsERNS_7ExtTileEiiPKNS0_6ResultERKNS_5ArrayIjEEi, __ZN22RenderingCommandBufferC2ERKS_: __ZN22RenderingCommandBufferC2ERKS_, __ZN12_GLOBAL__N_137BuggyBindElementArrayBufferWorkaround17BindBufferWrapperEjj: __ZN12_GLOBAL__N_137BuggyBindElementArrayBufferWorkaround17BindBufferWrapperEjj, __Z32Joint_Set_Custom_PropBreakTorqueP12Il2CppObjectf: __Z32Joint_Set_Custom_PropBreakTorqueP12Il2CppObjectf, __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE12__find_equalIS1_EERPNS_16__tree_node_baseIPvEESD_RKT_: __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE12__find_equalIS1_EERPNS_16__tree_node_baseIPvEESD_RKT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj658ENS_22PxRepXPropertyAccessorILj658ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj658ENS_22PxRepXPropertyAccessorILj658ES4_ffEEEEvRKT0_, __ZN15ReflectionProbe13SetResolutionEi: __ZN15ReflectionProbe13SetResolutionEi, __ZN9GfxDevice23GetNativeTexturePointerE9TextureID: __ZN9GfxDevice23GetNativeTexturePointerE9TextureID, __ZNK5physx22PxVehicleWheelsSimData7isValidEv: __ZNK5physx22PxVehicleWheelsSimData7isValidEv, __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaNonAllocv: __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreaNonAllocv, __ZeqRK8DateTimeS1_: __ZeqRK8DateTimeS1_, __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_: __ZN13dynamic_arrayI11DirectorJobLj8EEC2ERKS1_, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17clearSpatialForceENS_11PxForceMode4EnumEbb: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17clearSpatialForceENS_11PxForceMode4EnumEbb, __ZN14ConstantStringD2Ev: __ZN14ConstantStringD2Ev, __ZNK5physx2Gu11HeightField9getNbRowsEv: __ZNK5physx2Gu11HeightField9getNbRowsEv, __ZN6Socket26WaitForAvailableSendBufferEl: __ZN6Socket26WaitForAvailableSendBufferEl, __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_15PxClothParticleENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z46Register_UnityEngine_AndroidJNI_CallLongMethodv: __Z46Register_UnityEngine_AndroidJNI_CallLongMethodv, __Z46Register_UnityEngine_AI_NavMeshAgent_set_speedv: __Z46Register_UnityEngine_AI_NavMeshAgent_set_speedv, __ZNK11AudioFilter26GetTypeInfoVirtualInternalEv: __ZNK11AudioFilter26GetTypeInfoVirtualInternalEv, __ZNK12CullingGroup12QueryIndicesEbiNS_12QueryOptionsEPjjj: __ZNK12CullingGroup12QueryIndicesEbiNS_12QueryOptionsEPjjj, __ZN9AudioClip16SetMoviePlaybackEP13MoviePlayback: __ZN9AudioClip16SetMoviePlaybackEP13MoviePlayback, _UNITY_png_reciprocal2: _UNITY_png_reciprocal2, __ZN15DirectorManager18OnFixedAdvanceTimeEv: __ZN15DirectorManager18OnFixedAdvanceTimeEv, __Z47Register_UnityEngine_GUIStyle_get_imagePositionv: __Z47Register_UnityEngine_GUIStyle_get_imagePositionv, __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab16SerializedShader8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN10HumanTrait11RightFinger11GetBoneNameEi: __ZN10HumanTrait11RightFinger11GetBoneNameEi, _lgamma: _lgamma, __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE8recreateEj: __ZN5physx6shdfnd5ArrayIhNS0_19ReflectionAllocatorIhEEE8recreateEj, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv, __ZN17AnimationCurveTplI8Vector3fE10RemoveKeysEP11KeyframeTplIS0_ES4_: __ZN17AnimationCurveTplI8Vector3fE10RemoveKeysEP11KeyframeTplIS0_ES4_, _fwrite: _fwrite, __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f: __ZN5physx8CCDSweepINS_2Gu9TriangleVENS1_4BoxVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVERKNS9_5Vec3VERKNS9_6FloatVESI_SI_RSJ_RSG_SN_f, __ZN12TreeDatabase9Prototype17MainThreadCleanupEv: __ZN12TreeDatabase9Prototype17MainThreadCleanupEv, _UNITY_FT_Destroy_Class_tt_cmap_classes: _UNITY_FT_Destroy_Class_tt_cmap_classes, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv, _strtox_519: _strtox_519, __ZNK5physx20PxsSolverCoreGeneral20solveVCoulomb_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj: __ZNK5physx20PxsSolverCoreGeneral20solveVCoulomb_BlocksEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENS9_19ReflectionAllocatorISB_EEEESF_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj, __ZN18DeferredRenderLoopD0Ev: __ZN18DeferredRenderLoopD0Ev, __Z38GL_CUSTOM_INTERNAL_CALL_Internal_ClearhhRK10ColorRGBAff: __Z38GL_CUSTOM_INTERNAL_CALL_Internal_ClearhhRK10ColorRGBAff, __ZL9CleanHullRjPN5physx2Gu9TriangleTIjEES_PNS0_6PxVec3E: __ZL9CleanHullRjPN5physx2Gu9TriangleTIjEES_PNS0_6PxVec3E, __ZN18MecanimClipBuilderC2Ev: __ZN18MecanimClipBuilderC2Ev, __ZN26AnimatorControllerPlayable7GetTypeEv: __ZN26AnimatorControllerPlayable7GetTypeEv, __Z26getPxParticleBase_GridSizePKN5physx14PxParticleBaseE: __Z26getPxParticleBase_GridSizePKN5physx14PxParticleBaseE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_E18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES7_S7_, __Z59ParticleSystem_MainModule_CUSTOM_GetStartLifetimeMultiplierP12Il2CppObject: __Z59ParticleSystem_MainModule_CUSTOM_GetStartLifetimeMultiplierP12Il2CppObject, __ZN4FMOD7Channel17set3DConeSettingsEfff: __ZN4FMOD7Channel17set3DConeSettingsEfff, __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE: __ZN5physx2Sc5Actor17setIslandNodeTypeENS0_14IslandNodeInfo4TypeE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj147ENS_22PxRepXPropertyAccessorILj147ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z54Register_UnityEngine_BuoyancyEffector2D_set_linearDragv: __Z54Register_UnityEngine_BuoyancyEffector2D_set_linearDragv, __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17GlobalGameManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z57ParticleSystemRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject: __Z57ParticleSystemRenderer_Get_Custom_PropCameraVelocityScaleP12Il2CppObject, __Z18Transfer_BlittableI9JSONWriteLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_PvEE, __ZN5physx2Sq10AABBPruner19fullRebuildAABBTreeEv: __ZN5physx2Sq10AABBPruner19fullRebuildAABBTreeEv, __Z18SkinGenericMathLibILi4ELb0ELb0EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi4ELb0ELb0EEvR12SkinMeshInfo, __Z53Register_UnityEngine_ReflectionProbe_set_bakedTexturev: __Z53Register_UnityEngine_ReflectionProbe_set_bakedTexturev, __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei: __ZNK9SubModule23GetSubEmitterDeprecatedE21ParticleSystemSubTypei, __Z21AllocateStaticQueriesPK9dtNavMesh: __Z21AllocateStaticQueriesPK9dtNavMesh, _UNITY_FT_List_Up: _UNITY_FT_List_Up, __Z14DecompressDXT1iiiPKjPj: __Z14DecompressDXT1iiiPKjPj, __ZN23SharedMeshRenderingDataC2Ev: __ZN23SharedMeshRenderingDataC2Ev, __ZN5physx15PxsParticleData14setVelocitiesVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE: __ZN5physx15PxsParticleData14setVelocitiesVEjRKNS_16PxStrideIteratorIKjEERKNS1_IKNS_6PxVec3EEE, __ZNK5physx2Sc9ClothCore21getLinearInertiaScaleEv: __ZNK5physx2Sc9ClothCore21getLinearInertiaScaleEv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEED0Ev, __Z39PostprocessSceneGenerateGUITextureAtlasv: __Z39PostprocessSceneGenerateGUITextureAtlasv, __Z46Camera_CUSTOM_INTERNAL_CALL_ViewportPointToRayP12Il2CppObjectRK8Vector3fR3Ray: __Z46Camera_CUSTOM_INTERNAL_CALL_ViewportPointToRayP12Il2CppObjectRK8Vector3fR3Ray, __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_: __Z26ApplyBlendShapesToVerticesRK10BlendShapeRK13dynamic_arrayI16BlendShapeVertexLj4EEfRK12SkinMeshInfoRKN4math5_int4EPNSA_8floatNx3ESF_, __ZNK15UnityAdsManager26GetTypeInfoVirtualInternalEv: __ZNK15UnityAdsManager26GetTypeInfoVirtualInternalEv, __Z33getPxJoint_RelativeLinearVelocityPKN5physx7PxJointE: __Z33getPxJoint_RelativeLinearVelocityPKN5physx7PxJointE, __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForceAtPositionv: __Z63Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddForceAtPositionv, __Z45CharacterJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf: __Z45CharacterJoint_Set_Custom_PropProjectionAngleP12Il2CppObjectf, __ZNK19ShaderPropertySheet16GetSerializeSizeEv: __ZNK19ShaderPropertySheet16GetSerializeSizeEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPNS_6PxBaseEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb, __ZN5physx2Gu18GJKRelativeRayCastERNS0_11ConvexHullVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_11ConvexHullVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb, __ZNSt3__211__sift_downIRN22MotionVectorRenderLoop18RenderObjectSorterEP18RPDataMotionVectorEEvT0_S6_T_NS_15iterator_traitsIS6_E15difference_typeES6_: __ZNSt3__211__sift_downIRN22MotionVectorRenderLoop18RenderObjectSorterEP18RPDataMotionVectorEEvT0_S6_T_NS_15iterator_traitsIS6_E15difference_typeES6_, __ZN6Sprite23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Sprite23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN13RenderTexture8TransferI14SafeBinaryReadEEvRT_: __ZN13RenderTexture8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE11getTypeNameEv, __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyRotationInternalP12Il2CppObjectR11Quaternionf: __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyRotationInternalP12Il2CppObjectR11Quaternionf, __Z44Application_Get_Custom_PropStackTraceLogTypev: __Z44Application_Get_Custom_PropStackTraceLogTypev, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z31HingeJoint_Get_Custom_PropAngleP12Il2CppObject: __Z31HingeJoint_Get_Custom_PropAngleP12Il2CppObject, __ZN16UnityAdsSettingsC2Ev: __ZN16UnityAdsSettingsC2Ev, __Z40setPxSceneDescDynamicTreeRebuildRateHintPN5physx11PxSceneDescEj: __Z40setPxSceneDescDynamicTreeRebuildRateHintPN5physx11PxSceneDescEj, __ZN11Rigidbody2D19RecalculateContactsEv: __ZN11Rigidbody2D19RecalculateContactsEv, __ZN9GfxDeviceC2Ev: __ZN9GfxDeviceC2Ev, __ZN7b2World16SetContactFilterEP15b2ContactFilter: __ZN7b2World16SetContactFilterEP15b2ContactFilter, __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setUserDataEPv, __ZNK5physx15NpActorTemplateINS_7PxClothEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE22getClientBehaviorFlagsEv, __Z45Register_UnityEngine_Light_INTERNAL_get_colorv: __Z45Register_UnityEngine_Light_INTERNAL_get_colorv, __ZN17SurfaceEffector2DD2Ev: __ZN17SurfaceEffector2DD2Ev, __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _unity_z_deflateSetDictionary: _unity_z_deflateSetDictionary, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYMultiplierv, __Z18Transfer_BlittableI8JSONReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc21ArticulationJointCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc21ArticulationJointCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNSt3__221__thread_specific_ptrINS_15__thread_structEE16__at_thread_exitEPv: __ZNSt3__221__thread_specific_ptrINS_15__thread_structEE16__at_thread_exitEPv, __ZNK13WebCamTexture26GetTypeInfoVirtualInternalEv: __ZNK13WebCamTexture26GetTypeInfoVirtualInternalEv, __ZN12ScriptMapper23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12ScriptMapper23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _posix_close: _posix_close, __ZN12BaseRenderer21RendererBecameVisibleEv: __ZN12BaseRenderer21RendererBecameVisibleEv, _UNITY_FT_Destroy_Class_ft_smooth_lcd_renderer_class: _UNITY_FT_Destroy_Class_ft_smooth_lcd_renderer_class, __ZNSt3__25ctypeIcEC2EPKtbj: __ZNSt3__25ctypeIcEC2EPKtbj, __ZN4FMOD6System16getDSPBufferSizeEPjPi: __ZN4FMOD6System16getDSPBufferSizeEPjPi, __ZN17PersistentManager25GetSerializedFileInternalEi: __ZN17PersistentManager25GetSerializedFileInternalEi, __Z37Animator_Get_Custom_PropHasRootMotionP12Il2CppObject: __Z37Animator_Get_Custom_PropHasRootMotionP12Il2CppObject, __Z45Register_UnityEngine_Terrain_set_treeDistancev: __Z45Register_UnityEngine_Terrain_set_treeDistancev, __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIiEEPiEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_4lessIiEEPiEEbT0_S5_T_, __Z82Register_UnityEngine_Camera_set_useJitteredProjectionMatrixForTransparentRenderingv: __Z82Register_UnityEngine_Camera_set_useJitteredProjectionMatrixForTransparentRenderingv, __ZN12PPtrKeyframe8TransferI14SafeBinaryReadEEvRT_: __ZN12PPtrKeyframe8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Cm17FreeListAllocator15popFromFreeListEj: __ZN5physx2Cm17FreeListAllocator15popFromFreeListEj, __Z49Register_UnityEngine_ParticleAnimator_get_dampingv: __Z49Register_UnityEngine_ParticleAnimator_get_dampingv, __Z49Register_UnityEngine_AssetBundle_GetAllAssetNamesv: __Z49Register_UnityEngine_AssetBundle_GetAllAssetNamesv, __ZN12_GLOBAL__N_123DoubleBufferedOutStream5flushEv: __ZN12_GLOBAL__N_123DoubleBufferedOutStream5flushEv, __ZN9Animation8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Animation8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z28AudioMixer_CUSTOM_ClearFloatP12Il2CppObjectP12Il2CppString: __Z28AudioMixer_CUSTOM_ClearFloatP12Il2CppObjectP12Il2CppString, __ZN6Camera12RenderStereoENS_10RenderFlagE8CullFlagMS_FvR11CullResultsR17ShaderPassContextPK21CameraRenderingParamsS0_PvES9_: __ZN6Camera12RenderStereoENS_10RenderFlagE8CullFlagMS_FvR11CullResultsR17ShaderPassContextPK21CameraRenderingParamsS0_PvES9_, _tre_ast_new_catenation: _tre_ast_new_catenation, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4AxesEEEclERS3_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN4math4AxesEEEclERS3_17TransferMetaFlagsR9BlobWrite, __Z43getPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataEj: __Z43getPxVehicleWheelsSimData_WheelEnabledStatePKN5physx22PxVehicleWheelsSimDataEj, __ZN5physx16PxsThreadContextD2Ev: __ZN5physx16PxsThreadContextD2Ev, __ZN4Mesh18UpdateVertexFormatEv: __ZN4Mesh18UpdateVertexFormatEv, __ZN4FMOD4DSPI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD4DSPI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN5physx7NpScene26setBounceThresholdVelocityEf: __ZN5physx7NpScene26setBounceThresholdVelocityEf, __ZNK9Texture2D11GetGPUWidthEv: __ZNK9Texture2D11GetGPUWidthEv, __ZNK8Renderer21GetLocalToWorldMatrixEv: __ZNK8Renderer21GetLocalToWorldMatrixEv, __Z40Register_UnityEngine_GUIText_set_tabSizev: __Z40Register_UnityEngine_GUIText_set_tabSizev, __ZN5Umbra12PortalCuller12addStartCellERKNS0_4TileEi: __ZN5Umbra12PortalCuller12addStartCellERKNS0_4TileEi, __ZN8Animator23RemoveContainedRendererEPv: __ZN8Animator23RemoveContainedRendererEPv, __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallbackD0Ev: __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallbackD0Ev, __ZNK18PhysxJobDispatcher14getWorkerCountEv: __ZNK18PhysxJobDispatcher14getWorkerCountEv, __ZN18AwakeFromLoadQueue17ExtractAllObjectsER13dynamic_arrayI4PPtrI6ObjectELj4EE: __ZN18AwakeFromLoadQueue17ExtractAllObjectsER13dynamic_arrayI4PPtrI6ObjectELj4EE, __ZN4FMOD6System13getNumPluginsE15FMOD_PLUGINTYPEPi: __ZN4FMOD6System13getNumPluginsE15FMOD_PLUGINTYPEPi, __ZN14SphereCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f: __ZN14SphereCollider22GetPositionAndRotationERK9TransformR10Matrix4x4f, __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE: __ZN5physx22PxVehicleWheelsSimData17setSuspensionDataEjRKNS_23PxVehicleSuspensionDataE, __ZThn8_N5physx2Gu11HeightFieldD0Ev: __ZThn8_N5physx2Gu11HeightFieldD0Ev, __Z25GetHostBroadcastAddressesP7in_addri: __Z25GetHostBroadcastAddressesP7in_addri, __Z61Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplv: __Z61Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplv, __ZSt13set_terminatePFvvE: __ZSt13set_terminatePFvvE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRS3_S4_E: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsEPFRS3_S4_E, __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZN5physx20PxsParticleSystemSimC2EPNS_10PxsContextEj: __ZN5physx20PxsParticleSystemSimC2EPNS_10PxsContextEj, __ZN13UploadHandlerD0Ev: __ZN13UploadHandlerD0Ev, __ZL21DeferredRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL21DeferredRenderLoopJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZN5Umbra20ObjectDistanceParamsaSERKS0_: __ZN5Umbra20ObjectDistanceParamsaSERKS0_, __Z50Register_UnityEngine_WheelCollider_get_motorTorquev: __Z50Register_UnityEngine_WheelCollider_get_motorTorquev, __ZN6SocketD2Ev: __ZN6SocketD2Ev, __ZN9Coroutine18CleanupCoroutineGCEPv: __ZN9Coroutine18CleanupCoroutineGCEPv, __Z26profiler_get_info_for_namePKc13ProfilerGroup: __Z26profiler_get_info_for_namePKc13ProfilerGroup, __ZN8Animator7PrepareEv: __ZN8Animator7PrepareEv, __Z40Application_Get_Custom_PropInstallerNamev: __Z40Application_Get_Custom_PropInstallerNamev, __ZN4FMOD5Sound19get3DMinMaxDistanceEPfS1_: __ZN4FMOD5Sound19get3DMinMaxDistanceEPfS1_, __Z31CullBoundingSpheresWithoutUmbraRK17CullingParametersPK8Vector4fjjPhhb: __Z31CullBoundingSpheresWithoutUmbraRK17CullingParametersPK8Vector4fjjPhhb, __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc8BodyCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZNK5physx3Ext13RevoluteJoint16getDriveVelocityEv: __ZNK5physx3Ext13RevoluteJoint16getDriveVelocityEv, __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_: __ZNK15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E13find_positionERS7_, __ZN22ParticleSystemRenderer23RendererBecameInvisibleEv: __ZN22ParticleSystemRenderer23RendererBecameInvisibleEv, __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEjRKj: __ZNSt3__26vectorIjNS_9allocatorIjEEE8__appendEjRKj, __ZZ23InitPlayerLoopCallbacksvEN29EarlyUpdateGpuTimestampstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN29EarlyUpdateGpuTimestampstruct7ForwardEv, __Z45ParticleSystem_TrailModule_CUSTOM_GetLifetimeP12Il2CppObjectR15MonoMinMaxCurve: __Z45ParticleSystem_TrailModule_CUSTOM_GetLifetimeP12Il2CppObjectR15MonoMinMaxCurve, _freelocale: _freelocale, __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12NavMeshAgent23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12_GLOBAL__N_110DataStream14createInstanceERKN5physx8debugger14NamespacedNameEPKv: __ZN12_GLOBAL__N_110DataStream14createInstanceERKN5physx8debugger14NamespacedNameEPKv, __Z25TextGenerator_CUSTOM_InitP12Il2CppObject: __Z25TextGenerator_CUSTOM_InitP12Il2CppObject, __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15ComputeShaderCB8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx44PxClothMotionConstraintConfigGeneratedValuesC2EPKNS_29PxClothMotionConstraintConfigE: __ZN5physx44PxClothMotionConstraintConfigGeneratedValuesC2EPKNS_29PxClothMotionConstraintConfigE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj170ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SpeedTreeWind8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14NavMeshManager21UnregisterOffMeshLinkERi: __ZN14NavMeshManager21UnregisterOffMeshLinkERi, __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetDampenv: __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetDampenv, __ZN5physx2Gu9ContaineraSERKS1_: __ZN5physx2Gu9ContaineraSERKS1_, __Z38CircleCollider2D_Set_Custom_PropRadiusP12Il2CppObjectf: __Z38CircleCollider2D_Set_Custom_PropRadiusP12Il2CppObjectf, __ZN18ProfilerConnection42HandleSetAutoInstrumentedAssembliesMessageEPKvjj: __ZN18ProfilerConnection42HandleSetAutoInstrumentedAssembliesMessageEPKvjj, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14resetFilteringEv: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14resetFilteringEv, __ZThn4_N5physx5cloth8SwSolver29setInterCollisionNbIterationsEj: __ZThn4_N5physx5cloth8SwSolver29setInterCollisionNbIterationsEj, __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Texture3D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj172ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Umbra21testAllAndSetBitRangeEPjii: __ZN5Umbra21testAllAndSetBitRangeEPjii, __ZN13MonoBehaviour18TransferEngineDataI14SafeBinaryReadEE4PPtrI10MonoScriptERT_: __ZN13MonoBehaviour18TransferEngineDataI14SafeBinaryReadEE4PPtrI10MonoScriptERT_, _cff_get_advances: _cff_get_advances, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10WriteInt64Ex: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE10WriteInt64Ex, __ZN4FMOD7Channel16getSpeakerLevelsE12FMOD_SPEAKERPfi: __ZN4FMOD7Channel16getSpeakerLevelsE12FMOD_SPEAKERPfi, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE7releaseEv, __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim10ValueArray8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Transform48RemoveDeregisteredChangeSystemsFromAllTransformsEv: __ZN9Transform48RemoveDeregisteredChangeSystemsFromAllTransformsEv, __ZN17AudioCustomFilterD0Ev: __ZN17AudioCustomFilterD0Ev, __ZN5audio5mixer20TransitionToSnapshotERNS0_16AudioMixerMemoryEif: __ZN5audio5mixer20TransitionToSnapshotERNS0_16AudioMixerMemoryEif, __ZN12MeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12MeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN6detail13OffsetPointerIfEC2EPKfj: __ZN6detail13OffsetPointerIfEC2EPKfj, __ZNKSt3__210moneypunctIwLb1EE13do_neg_formatEv: __ZNKSt3__210moneypunctIwLb1EE13do_neg_formatEv, __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI27ComputeShaderBuiltinSamplerNS_9allocatorIS1_EEE8__appendEj, _tt_cmap13_get_info: _tt_cmap13_get_info, __Z19CreateCullingOutputPK16RendererCullDataR13CullingOutput: __Z19CreateCullingOutputPK16RendererCullDataR13CullingOutput, __Z49ConstantForce2D_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK13Vector2fIcall: __Z49ConstantForce2D_CUSTOM_INTERNAL_set_relativeForceP12Il2CppObjectRK13Vector2fIcall, _PxGetValue: _PxGetValue, __ZNK15PointEffector2D18DesignedForTriggerEv: __ZNK15PointEffector2D18DesignedForTriggerEv, __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayv: __Z65Register_UnityEngine_Rendering_CommandBuffer_SetGlobalMatrixArrayv, __ZN10AudioMixer13AwakeFromLoadE17AwakeFromLoadMode: __ZN10AudioMixer13AwakeFromLoadE17AwakeFromLoadMode, __ZN13RuntimeStaticI15AnimationBinderE13StaticDestroyEPv: __ZN13RuntimeStaticI15AnimationBinderE13StaticDestroyEPv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj502ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj502ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9JSONWrite8TransferI13dynamic_arrayIjLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIjLj4EEEEvRT_PKc17TransferMetaFlags, __Z58Register_UnityEngine_Input_set_eatKeyPressOnTextFieldFocusv: __Z58Register_UnityEngine_Input_set_eatKeyPressOnTextFieldFocusv, __Z40Rigidbody2D_Get_Custom_PropInterpolationP12Il2CppObject: __Z40Rigidbody2D_Get_Custom_PropInterpolationP12Il2CppObject, __ZN12LineRenderer10LinePointsD2Ev: __ZN12LineRenderer10LinePointsD2Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14ShaderPassTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead14ShaderPassTypeEvRT_RT0_PKc17TransferMetaFlags, __ZNK29PxsCreateFinalizeContactsTask7getNameEv: __ZNK29PxsCreateFinalizeContactsTask7getNameEv, __ZN29AudioEffectInternalDefinitionC2E13FMOD_DSP_TYPE: __ZN29AudioEffectInternalDefinitionC2E13FMOD_DSP_TYPE, __ZN10MonoScript8GetClassEv: __ZN10MonoScript8GetClassEv, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveCountv: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_SetOctaveCountv, __Z51Register_UnityEngine_AI_NavMeshAgent_set_baseOffsetv: __Z51Register_UnityEngine_AI_NavMeshAgent_set_baseOffsetv, __ZThn4_N5physx5cloth8SwFabric15scaleRestvaluesEf: __ZThn4_N5physx5cloth8SwFabric15scaleRestvaluesEf, __ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE: __ZN4crnd16elemental_vector17increase_capacityEjbjPFvPvS1_jE, __ZNSt3__210__time_putC2EPKc: __ZNSt3__210__time_putC2EPKc, __ZN2UI6Canvas14RenderOverlaysEv: __ZN2UI6Canvas14RenderOverlaysEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvN12_GLOBAL__N_112InstanceDataEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS_8debugger19ForwardingAllocatorEE6GetKeyESE_Lb1EED2Ev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__get_short_pointerEv, __ZN5physx3Cct11SweptVolumeD0Ev: __ZN5physx3Cct11SweptVolumeD0Ev, __ZNK5Umbra14TomeCollection7getSizeEv: __ZNK5Umbra14TomeCollection7getSizeEv, __ZN20SweepCapsuleCallbackD0Ev: __ZN20SweepCapsuleCallbackD0Ev, __ZN15QualitySettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15QualitySettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIP11Il2CppClassNS_9allocatorIS2_EEE8__appendEjRKS2_: __ZNSt3__26vectorIP11Il2CppClassNS_9allocatorIS2_EEE8__appendEjRKS2_, __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi: __ZN7mecanim5human26HumanComputeBoneMassCenterEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi, __ZN5physx3Ext20DefaultCpuDispatcherD0Ev: __ZN5physx3Ext20DefaultCpuDispatcherD0Ev, __Z50Register_UnityEngine_BillboardAsset_get_imageCountv: __Z50Register_UnityEngine_BillboardAsset_get_imageCountv, __Z50Register_UnityEngine_ComputeBuffer_SetCounterValuev: __Z50Register_UnityEngine_ComputeBuffer_SetCounterValuev, __Z32setPxClothStretchConfigStiffnessPN5physx20PxClothStretchConfigEf: __Z32setPxClothStretchConfigStiffnessPN5physx20PxClothStretchConfigEf, __ZN13RuntimeStaticI18UnityConnectClientE10InitializeEv: __ZN13RuntimeStaticI18UnityConnectClientE10InitializeEv, __Z37AndroidJNI_CUSTOM_GetCharArrayElement13Il2Cpp_IntPtri: __Z37AndroidJNI_CUSTOM_GetCharArrayElement13Il2Cpp_IntPtri, __ZN5physx15PxsParticleDataC2Ejb: __ZN5physx15PxsParticleDataC2Ejb, __ZN9GfxDevice23SyncAsyncResourceUploadE9TextureID10AsyncFencei: __ZN9GfxDevice23SyncAsyncResourceUploadE9TextureID10AsyncFencei, _UNITY_FT_New_Face: _UNITY_FT_New_Face, __Z33getPxMaterial_FrictionCombineModePKN5physx10PxMaterialE: __Z33getPxMaterial_FrictionCombineModePKN5physx10PxMaterialE, __ZN4PPtrI9AudioClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI9AudioClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIbEEclERS1_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIbEEclERS1_17TransferMetaFlagsR9BlobWrite, __ZN17BillboardRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17BillboardRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _h2v2_upsample: _h2v2_upsample, __ZN14ParticleSystem26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f: __ZN14ParticleSystem26RendererCullingOutputReadyEPP12BaseRendererjPK6CameraRK10Matrix4x4f, __ZN5physx2Gu12EntityReportIjED2Ev: __ZN5physx2Gu12EntityReportIjED2Ev, __Z46Register_UnityEngine_Cloth_get_solverFrequencyv: __Z46Register_UnityEngine_Cloth_get_solverFrequencyv, __ZN8UVModule16CheckConsistencyEv: __ZN8UVModule16CheckConsistencyEv, __ZN5physx6shdfnd10SocketImplC2Ev: __ZN5physx6shdfnd10SocketImplC2Ev, __ZN10AudioMixer17MainThreadCleanupEv: __ZN10AudioMixer17MainThreadCleanupEv, __ZN15AudioMixerGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15AudioMixerGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN26b2PolygonAndCapsuleContactC2EP9b2FixtureS1_: __ZN26b2PolygonAndCapsuleContactC2EP9b2FixtureS1_, __ZN14VelocityModule5ResetEv: __ZN14VelocityModule5ResetEv, __ZN6Skybox15ThreadedCleanupEv: __ZN6Skybox15ThreadedCleanupEv, __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy: __ZN13dynamic_arrayI13BoneInfluenceLj16EE18resize_initializedEjRKS0_12ResizePolicy, __ZN12GUIClipState19EndThroughExceptionEv: __ZN12GUIClipState19EndThroughExceptionEv, __ZN6Object16CheckConsistencyEv: __ZN6Object16CheckConsistencyEv, _start_output_pass: _start_output_pass, __Z24RegisterStrippedTypeInfoI8LODGroupEviPKcS2_: __Z24RegisterStrippedTypeInfoI8LODGroupEviPKcS2_, __ZNK5physx2Sn18RepXCollectionImpl5beginEv: __ZNK5physx2Sn18RepXCollectionImpl5beginEv, __Z47SliderJoint2D_Set_Custom_PropAutoConfigureAngleP12Il2CppObjecth: __Z47SliderJoint2D_Set_Custom_PropAutoConfigureAngleP12Il2CppObjecth, __ZNK14b2PolygonShape13GetChildCountEv: __ZNK14b2PolygonShape13GetChildCountEv, __Z54Register_UnityEngine_TrailRenderer_set_widthMultiplierv: __Z54Register_UnityEngine_TrailRenderer_set_widthMultiplierv, __ZN5physx6shdfnd10ThreadImplD2Ev: __ZN5physx6shdfnd10ThreadImplD2Ev, __ZN24ScriptingMethodFiltering36MethodDescriptionMatchesSearchFilterENS_18MethodSearchFilterEbi: __ZN24ScriptingMethodFiltering36MethodDescriptionMatchesSearchFilterENS_18MethodSearchFilterEbi, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj616ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, _UNITY_png_set_text: _UNITY_png_set_text, __ZN20FileSystemEnumerator9EnumerateEPFbR13FileEntryInfoPvES2_19FileEnumerationFlag: __ZN20FileSystemEnumerator9EnumerateEPFbR13FileEntryInfoPvES2_19FileEnumerationFlag, _gzread: _gzread, __ZN18GfxFramebufferGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_: __ZN18GfxFramebufferGLES30SetBackBufferColorDepthSurfaceEP17RenderSurfaceBaseS1_, __ZN9b2Fixture13SetFilterDataERK8b2Filter: __ZN9b2Fixture13SetFilterDataERK8b2Filter, __Z37VRSettings_Get_Custom_PropRenderScalev: __Z37VRSettings_Get_Custom_PropRenderScalev, __ZN9Rigidbody13SetUseGravityEb: __ZN9Rigidbody13SetUseGravityEb, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z47Register_UnityEngine_Animator_set_stabilizeFeetv: __Z47Register_UnityEngine_Animator_set_stabilizeFeetv, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EE, __ZN15AudioReverbZoneD0Ev: __ZN15AudioReverbZoneD0Ev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags, __ZN5physx5cloth16SwInterCollisionI8Scalar4fE23estimateTemporaryMemoryEPNS0_20SwInterCollisionDataEj: __ZN5physx5cloth16SwInterCollisionI8Scalar4fE23estimateTemporaryMemoryEPNS0_20SwInterCollisionDataEj, __Z45ParticleSystem_CollisionModule_CUSTOM_GetTypeP12Il2CppObject: __Z45ParticleSystem_CollisionModule_CUSTOM_GetTypeP12Il2CppObject, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags, __Z56Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayv: __Z56Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayv, __ZN12ServerSocketC2Eiii: __ZN12ServerSocketC2Eiii, __ZN5Light15ResetBakedIndexEv: __ZN5Light15ResetBakedIndexEv, __ZNK13b2DynamicTree7RayCastI21b2WorldRayCastWrapperEEvPT_RK14b2RayCastInput: __ZNK13b2DynamicTree7RayCastI21b2WorldRayCastWrapperEEvPT_RK14b2RayCastInput, __ZN12NavMeshAgent9SetRadiusEf: __ZN12NavMeshAgent9SetRadiusEf, __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14SpriteRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z51Register_UnityEngine_Physics2D_INTERNAL_get_gravityv: __Z51Register_UnityEngine_Physics2D_INTERNAL_get_gravityv, __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpacev: __Z65Register_UnityEngine_ParticleSystem_MainModule_SetSimulationSpacev, __Z40ParticleSystem_Get_Custom_PropStartDelayP12Il2CppObject: __Z40ParticleSystem_Get_Custom_PropStartDelayP12Il2CppObject, _free_pool: _free_pool, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIwEE, __ZN6Object24RegisterInstanceIDNoLockEPS_: __ZN6Object24RegisterInstanceIDNoLockEPS_, __Z31setPxRigidDynamic_LinearDampingPN5physx14PxRigidDynamicEf: __Z31setPxRigidDynamic_LinearDampingPN5physx14PxRigidDynamicEf, __ZN5physx7NpShape13setRestOffsetEf: __ZN5physx7NpShape13setRestOffsetEf, __ZNK8Renderer19GetSortingLayerNameEv: __ZNK8Renderer19GetSortingLayerNameEv, __Z13RegisterClassI12FixedJoint2DEvv: __Z13RegisterClassI12FixedJoint2DEvv, __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEEvRT_j, __ZN5physx7NpCloth7releaseEv: __ZN5physx7NpCloth7releaseEv, __Z41Renderer_Get_Custom_PropShadowCastingModeP12Il2CppObject: __Z41Renderer_Get_Custom_PropShadowCastingModeP12Il2CppObject, __Z26Application_CUSTOM_HasARGVP12Il2CppString: __Z26Application_CUSTOM_HasARGVP12Il2CppString, __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12CullingGroup22SetBoundingSphereCountEj: __ZN12CullingGroup22SetBoundingSphereCountEj, __ZN5physx18PxFabricCookerImplD2Ev: __ZN5physx18PxFabricCookerImplD2Ev, __Z49CharacterController_Get_Custom_PropCollisionFlagsP12Il2CppObject: __Z49CharacterController_Get_Custom_PropCollisionFlagsP12Il2CppObject, __ZN15SerializeTraitsIN7mecanim6bitsetILj66EEEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIN7mecanim6bitsetILj66EEEE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEED0Ev: __ZN5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_8CapsuleVEED0Ev, __ZN7mecanim5human9HumanPoseC2Ev: __ZN7mecanim5human9HumanPoseC2Ev, __Z39getPxSimulationStatisticsNbStaticBodiesPKN5physx22PxSimulationStatisticsE: __Z39getPxSimulationStatisticsNbStaticBodiesPKN5physx22PxSimulationStatisticsE, __Z33AllocExtractMeshIndicesFromScriptRK4Meshi: __Z33AllocExtractMeshIndicesFromScriptRK4Meshi, __ZN5physx20PxsParticleSystemSim15collisionUpdateEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim15collisionUpdateEPNS_10PxBaseTaskE, __Z37GetUnityWebRequestScriptingClassesPtrv: __Z37GetUnityWebRequestScriptingClassesPtrv, __ZN11UnityEngine15CloudWebService17CloudServiceEventD2Ev: __ZN11UnityEngine15CloudWebService17CloudServiceEventD2Ev, __ZNK9Rigidbody19GetDetectCollisionsEv: __ZNK9Rigidbody19GetDetectCollisionsEv, _islower: _islower, __ZN16SpriteRenderData16GenerateQuadMeshERK5RectTIfERK8Vector2ff: __ZN16SpriteRenderData16GenerateQuadMeshERK5RectTIfERK8Vector2ff, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSERKS5_, __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE8__appendEj, __Z31Animator_CUSTOM_PlayInFixedTimeP12Il2CppObjectiif: __Z31Animator_CUSTOM_PlayInFixedTimeP12Il2CppObjectiif, __ZNKSt3__26locale9has_facetERNS0_2idE: __ZNKSt3__26locale9has_facetERNS0_2idE, __ZN5physx11NpAggregate17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx11NpAggregate17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN15OcclusionPortalD0Ev: __ZN15OcclusionPortalD0Ev, __ZN7ApiGLES12DeleteBufferERj: __ZN7ApiGLES12DeleteBufferERj, __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE: __ZN8Animator19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE, __ZNSt3__219__shared_mutex_baseC2Ev: __ZNSt3__219__shared_mutex_baseC2Ev, __ZN9Rigidbody11SetRotationERK11Quaternionf: __ZN9Rigidbody11SetRotationERK11Quaternionf, __Z4swapR10VertexDataS0_: __Z4swapR10VertexDataS0_, __ZNK5physx7NpScene31getClothInterCollisionStiffnessEv: __ZNK5physx7NpScene31getClothInterCollisionStiffnessEv, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS2_4lessIS6_EENS2_9allocatorINS2_4pairIKS6_S8_EEEEEEEEvRT_17TransferMetaFlags, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv, _tre_ast_new_union: _tre_ast_new_union, __ZN2UI13RectTransform13SetWorldSpaceERK8Vector3fRK8Vector2fb: __ZN2UI13RectTransform13SetWorldSpaceERK8Vector3fRK8Vector2fb, __Z28setPxVehicleWheelDataMRadiusPN5physx18PxVehicleWheelDataEf: __Z28setPxVehicleWheelDataMRadiusPN5physx18PxVehicleWheelDataEf, __ZNKSt3__211__libcpp_db15__find_c_from_iEPv: __ZNKSt3__211__libcpp_db15__find_c_from_iEPv, __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb0EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi3ELb1ELb0EEEvP12NoiseJobData, __Z52ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveP12Il2CppObjectR15MonoMinMaxCurve: __Z52ParticleSystem_InheritVelocityModule_CUSTOM_GetCurveP12Il2CppObjectR15MonoMinMaxCurve, __ZNK9Texture2D12GetDataWidthEv: __ZNK9Texture2D12GetDataWidthEv, __ZN5physx2Cm19CmEventNameProviderD0Ev: __ZN5physx2Cm19CmEventNameProviderD0Ev, __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcNS_14PxProfileNamesEj: __ZN5physx7profile15ZoneManagerImpl17createProfileZoneEPKcNS_14PxProfileNamesEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclERKNS_27PxRigidActorShapeCollectionEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclERKNS_27PxRigidActorShapeCollectionEj, __Z18setPxD6Joint_DrivePN5physx9PxD6JointENS_9PxD6Drive4EnumENS_14PxD6JointDriveE: __Z18setPxD6Joint_DrivePN5physx9PxD6JointENS_9PxD6Drive4EnumENS_14PxD6JointDriveE, __ZN27AnimationLayerMixerPlayable7GetTypeEv: __ZN27AnimationLayerMixerPlayable7GetTypeEv, __ZN5physx18NpArticulationLink15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx18NpArticulationLink15importExtraDataERNS_24PxDeserializationContextE, __ZN4Mesh39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN4Mesh39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN17ProceduralTextureC2E10MemLabelId18ObjectCreationMode: __ZN17ProceduralTextureC2E10MemLabelId18ObjectCreationMode, __ZNSt3__210ostrstreamD2Ev: __ZNSt3__210ostrstreamD2Ev, __ZN18AsyncUploadManager17ScheduleAsyncReadEP10AtomicNodeP16AsyncReadCommand: __ZN18AsyncUploadManager17ScheduleAsyncReadEP10AtomicNodeP16AsyncReadCommand, __Z57Register_UnityEngine_Object_DoesObjectWithInstanceIDExistv: __Z57Register_UnityEngine_Object_DoesObjectWithInstanceIDExistv, __ZN12NavMeshAgent14UpdateRotationER9Transformf: __ZN12NavMeshAgent14UpdateRotationER9Transformf, __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsINSt3__24listI4PPtrI6CameraENS0_9allocatorIS4_EEEEEiP11Il2CppArrayRKT_i, _wctob: _wctob, __Z50AsyncOperation_Set_Custom_PropAllowSceneActivationP12Il2CppObjecth: __Z50AsyncOperation_Set_Custom_PropAllowSceneActivationP12Il2CppObjecth, __ZN16Physics2DManager12ColliderCastEPK10Collider2DRK8Vector2ffibP12RaycastHit2Di: __ZN16Physics2DManager12ColliderCastEPK10Collider2DRK8Vector2ffibP12RaycastHit2Di, __ZN12_GLOBAL__N_127ConvertUncompressedMipLevelE13TextureFormatS0_iiiPKvPv: __ZN12_GLOBAL__N_127ConvertUncompressedMipLevelE13TextureFormatS0_iiiPKvPv, __ZN7Terrain8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7Terrain8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6appendERKS5_jj, __Z33UnityAdsSettings_CUSTOM_GetGameIdi: __Z33UnityAdsSettings_CUSTOM_GetGameIdi, __Z50Register_UnityEngine_TerrainData_INTERNAL_set_sizev: __Z50Register_UnityEngine_TerrainData_INTERNAL_set_sizev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj660ENS_22PxRepXPropertyAccessorILj660ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj660ENS_22PxRepXPropertyAccessorILj660ES4_ffEEEEvRKT0_, __Z29Animator_CUSTOM_SetBoolStringP12Il2CppObjectP12Il2CppStringh: __Z29Animator_CUSTOM_SetBoolStringP12Il2CppObjectP12Il2CppStringh, __ZN8DrawUtil31CleanupDrawMeshRawFromNodeQueueER15RenderNodeQueuej: __ZN8DrawUtil31CleanupDrawMeshRawFromNodeQueueER15RenderNodeQueuej, __ZN8Animator8GetStatsEv: __ZN8Animator8GetStatsEv, __ZN7mecanim9animation21ValueFromSkeletonPoseERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapERNS_10ValueArrayE: __ZN7mecanim9animation21ValueFromSkeletonPoseERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapERNS_10ValueArrayE, __ZN5physx2Gu22gjkRelativePenetrationINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_11ConvexHullVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __ZNSt3__26locale5__impC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__26locale5__impC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __Z22GetLightmapSettingsPtrv: __Z22GetLightmapSettingsPtrv, __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E9erase_oneIS2_EEjRKT_: __ZN13sorted_vectorINSt3__24pairI14ConstantStringP11AssetBundleEEN10vector_mapIS2_S4_NS0_4lessIS2_EENS0_9allocatorIS5_EEE13value_compareESA_E9erase_oneIS2_EEjRKT_, __Z61Register_UnityEngine_PlatformEffector2D_get_useOneWayGroupingv: __Z61Register_UnityEngine_PlatformEffector2D_get_useOneWayGroupingv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z73Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetTexturev: __Z73Register_UnityEngine_Networking_DownloadHandlerTexture_InternalGetTexturev, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_14postBroadPhaseEPNS_10PxBaseTaskEEEE11runInternalEv, __Z45ParticleSystem_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf: __Z45ParticleSystem_CUSTOM_INTERNAL_set_startColorP12Il2CppObjectRK10ColorRGBAf, __ZNK16MemoryFileSystem4SizeERK13FileEntryData: __ZNK16MemoryFileSystem4SizeERK13FileEntryData, __ZNK24RendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK24RendererAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN14RenderSettings17ApplyLightChangesENS_16LightsUpdateTypeE: __ZN14RenderSettings17ApplyLightChangesENS_16LightsUpdateTypeE, __ZN4FMOD7Channel15getChannelGroupEPPNS_12ChannelGroupE: __ZN4FMOD7Channel15getChannelGroupEPPNS_12ChannelGroupE, __Z24CullStaticSceneWithUmbraR8JobFenceRK22SceneCullingParametersR13CullingOutput: __Z24CullStaticSceneWithUmbraR8JobFenceRK22SceneCullingParametersR13CullingOutput, __ZNK5physx3Cct13BoxController15getFootPositionEv: __ZNK5physx3Cct13BoxController15getFootPositionEv, __ZN5physx7NpScene14checkCollisionEb: __ZN5physx7NpScene14checkCollisionEb, __ZN5physx3Ext13DistanceJoint21setDistanceJointFlagsENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE: __ZN5physx3Ext13DistanceJoint21setDistanceJointFlagsENS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEE, __ZN16TimerQueriesGLESC2Ev: __ZN16TimerQueriesGLESC2Ev, __ZN5physx36solveExtContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx36solveExtContactCoulombBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE: __ZN12_GLOBAL__N_110DataStream8addEventERKN5physx8debugger4comm18EventSerializeableENS3_23PvdCommStreamEventTypes4EnumE, __ZN4FMOD7Channel11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD7Channel11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __ZN7ApiGLES13CreateSamplerE17TextureFilterMode15TextureWrapModei: __ZN7ApiGLES13CreateSamplerE17TextureFilterMode15TextureWrapModei, __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS_16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE9BlockInfoENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN5physx2Sc35ParticleElementRbElementInteraction19activateForLowLevelEj: __ZN5physx2Sc35ParticleElementRbElementInteraction19activateForLowLevelEj, __Z35OffMeshLink_Get_Custom_PropOccupiedP12Il2CppObject: __Z35OffMeshLink_Get_Custom_PropOccupiedP12Il2CppObject, __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E: __Z20SetGlobalMatrixLossy15TransformAccessRKN4math7_float3ERKNS0_7_float4ERKNS0_8float3x3E, __ZN16CircleCollider2DD0Ev: __ZN16CircleCollider2DD0Ev, _UNITY_tt_face_goto_table: _UNITY_tt_face_goto_table, __ZN5physx16PxsIslandManager33removeSleepingPairContactManagersEv: __ZN5physx16PxsIslandManager33removeSleepingPairContactManagersEv, __ZN8GUIState12GetControlIDEi9FocusTypeRK5RectTIfE: __ZN8GUIState12GetControlIDEi9FocusTypeRK5RectTIfE, __Z43Register_UnityEngine_WheelCollider_set_massv: __Z43Register_UnityEngine_WheelCollider_set_massv, __ZNK9dtNavMesh14isValidPolyRefEy: __ZNK9dtNavMesh14isValidPolyRefEy, __ZN16ScriptingManagerD2Ev: __ZN16ScriptingManagerD2Ev, __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev: __ZThn4_N5physx7profile30PxProfileMemoryEventBufferImplD1Ev, __Z46Register_UnityEngine_Texture2D_get_mipmapCountv: __Z46Register_UnityEngine_Texture2D_get_mipmapCountv, __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab19SerializedStencilOp8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN8Renderer12CleanupClassEv: __ZN8Renderer12CleanupClassEv, __Z13GetIEnlightenv: __Z13GetIEnlightenv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip9PPtrCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_PerspectiveffffR10Matrix4x4f: __Z42Matrix4x4_CUSTOM_INTERNAL_CALL_PerspectiveffffR10Matrix4x4f, __ZNK16Physics2DManager16IsTouchingLayersEPK10Collider2Di: __ZNK16Physics2DManager16IsTouchingLayersEPK10Collider2Di, __ZN5physx2Gu28distancePointTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_RS3_: __ZN5physx2Gu28distancePointTriangleSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_RS3_, __Z17GetCleanedLogFilev: __Z17GetCleanedLogFilev, __ZN6HelperI18StreamedBinaryReadILb1EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb: __ZN6HelperI18StreamedBinaryReadILb1EE18TransferField_InfoE24SerializationFunctionForERKS2_R23StaticTransferFieldInfoPb, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j, __Z36AnimationCurve_CUSTOM_SmoothTangentsP12Il2CppObjectif: __Z36AnimationCurve_CUSTOM_SmoothTangentsP12Il2CppObjectif, __ZN12HandlerChain9SetLengthER13FileEntryDatay: __ZN12HandlerChain9SetLengthER13FileEntryDatay, __ZN5physx6shdfnd10ThreadImpl11setPriorityENS0_14ThreadPriority4EnumE: __ZN5physx6shdfnd10ThreadImpl11setPriorityENS0_14ThreadPriority4EnumE, __Z46Register_UnityEngine_SphereCollider_set_radiusv: __Z46Register_UnityEngine_SphereCollider_set_radiusv, __Z45Register_UnityEngine_HumanTrait_GetParentBonev: __Z45Register_UnityEngine_HumanTrait_GetParentBonev, __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z16LightAttenuationItEvP9Texture2DPT_iiii: __Z16LightAttenuationItEvP9Texture2DPT_iiii, __ZN20SoundChannelInstance15getCurrentSoundEPPN4FMOD5SoundE: __ZN20SoundChannelInstance15getCurrentSoundEPPN4FMOD5SoundE, __Z42LineRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject: __Z42LineRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject, __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI4PPtrI9Texture2DENS0_9allocatorIS4_EEEEEvRT_j, __ZN5physx2Sc9RigidCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc9RigidCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN7Cubemap11InitTextureEii13TextureFormatN9Texture2D10EInitFlagsEiii: __ZN7Cubemap11InitTextureEii13TextureFormatN9Texture2D10EInitFlagsEiii, __GLOBAL__sub_I_runtime_misc2_lump_cpp: __GLOBAL__sub_I_runtime_misc2_lump_cpp, __ZNK5physx11AdjTriangle22ComputeNbBoundaryEdgesEv: __ZNK5physx11AdjTriangle22ComputeNbBoundaryEdgesEv, __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E: __Z28RecalculateSplineSlopeLinearIfEvR17AnimationCurveTplIT_E, __Z29AddPositionCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb: __Z29AddPositionCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb, __ZNKSt3__223__system_error_category4nameEv: __ZNKSt3__223__system_error_category4nameEv, __Z36RegisterRemoveImportErrorFromConsolePFviE: __Z36RegisterRemoveImportErrorFromConsolePFviE, __ZN12LightsModule9FreeCacheER19ParticleSystemState: __ZN12LightsModule9FreeCacheER19ParticleSystemState, __ZN13GfxDeviceNull14SetRasterStateEPK17DeviceRasterState: __ZN13GfxDeviceNull14SetRasterStateEPK17DeviceRasterState, __ZN15MulticastSocket12SetBroadcastEb: __ZN15MulticastSocket12SetBroadcastEb, __ZNK20LocalFileSystemPosix8PositionERK13FileEntryData: __ZNK20LocalFileSystemPosix8PositionERK13FileEntryData, __Z32GUIText_Get_Custom_PropAlignmentP12Il2CppObject: __Z32GUIText_Get_Custom_PropAlignmentP12Il2CppObject, __Z54Register_UnityEngine_Time_set_maximumParticleDeltaTimev: __Z54Register_UnityEngine_Time_set_maximumParticleDeltaTimev, __ZNK5physx16PxVehicleNoDrive7isValidEv: __ZNK5physx16PxVehicleNoDrive7isValidEv, __ZN5Umbra10StatsAlloc8allocateEjPKc: __ZN5Umbra10StatsAlloc8allocateEjPKc, __ZN14SpriteRenderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14SpriteRenderer7PRODUCEE10MemLabelId18ObjectCreationMode, _sha256_sum: _sha256_sum, __Z40Register_UnityEngine_Rigidbody2D_IsAwakev: __Z40Register_UnityEngine_Rigidbody2D_IsAwakev, __Z84Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanDestroyInternalv: __Z84Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanDestroyInternalv, __ZN5physx20PxsParticleSystemSim24removeTwoWayRbReferencesERKNS_16PxsParticleShapeEPKNS_11PxsBodyCoreE: __ZN5physx20PxsParticleSystemSim24removeTwoWayRbReferencesERKNS_16PxsParticleShapeEPKNS_11PxsBodyCoreE, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z76Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_CalcSizeWithConstraintsv: __Z76Register_UnityEngine_GUIStyle_INTERNAL_CALL_Internal_CalcSizeWithConstraintsv, __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_: __ZN4FMOD3DSP7getInfoEPcPjPiS3_S3_, __ZN20TextRenderingPrivate7GUIText15ThreadedCleanupEv: __ZN20TextRenderingPrivate7GUIText15ThreadedCleanupEv, __Z39AnimationState_Set_Custom_PropBlendModeP12Il2CppObjecti: __Z39AnimationState_Set_Custom_PropBlendModeP12Il2CppObjecti, __ZN12b2MotorJoint11SetMaxForceEf: __ZN12b2MotorJoint11SetMaxForceEf, __Z56Register_UnityEngine_GUIStyleState_GetBackgroundInternalv: __Z56Register_UnityEngine_GUIStyleState_GetBackgroundInternalv, __ZN5physx9NpFactory15addRigidDynamicEPNS_14PxRigidDynamicEb: __ZN5physx9NpFactory15addRigidDynamicEPNS_14PxRigidDynamicEb, __Z47PlatformEffector2D_Get_Custom_PropUseSideBounceP12Il2CppObject: __Z47PlatformEffector2D_Get_Custom_PropUseSideBounceP12Il2CppObject, __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb0EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIcLb0EEEEEvPT_, __ZN5physx2Gu11HeightField15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Gu11HeightField15importExtraDataERNS_24PxDeserializationContextE, __ZNSt3__26__sortIRNS_6__lessIssEEPsEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIssEEPsEEvT0_S5_T_, __ZN4FMOD13ChannelGroupI14get3DOcclusionEPfS1_: __ZN4FMOD13ChannelGroupI14get3DOcclusionEPfS1_, __ZN5physx18RepXSerializerImplINS_11PxAggregateEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_11PxAggregateEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z14DrawGUITextureRK5RectTIfEP7Textureiiiif11ColorRGBA32P8Materiali: __Z14DrawGUITextureRK5RectTIfEP7Textureiiiif11ColorRGBA32P8Materiali, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintStiffnessEf, __ZN5physx2Sc16ArticulationCore10putToSleepEv: __ZN5physx2Sc16ArticulationCore10putToSleepEv, __ZN28LightProbeProxyVolumeManager21AllocateVolumeTextureER21LightProbeProxyVolumePKc: __ZN28LightProbeProxyVolumeManager21AllocateVolumeTextureER21LightProbeProxyVolumePKc, __ZN5physx3Ext7D6JointD0Ev: __ZN5physx3Ext7D6JointD0Ev, __ZN15ParticleEmitter13AwakeFromLoadE17AwakeFromLoadMode: __ZN15ParticleEmitter13AwakeFromLoadE17AwakeFromLoadMode, __Z58Register_UnityEngine_Networking_UnityWebRequest_get_isDonev: __Z58Register_UnityEngine_Networking_UnityWebRequest_get_isDonev, __ZN5physx15PxGeometryQuery13pointDistanceERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEPS1_: __ZN5physx15PxGeometryQuery13pointDistanceERKNS_6PxVec3ERKNS_10PxGeometryERKNS_11PxTransformEPS1_, __ZN11TypeManager7Builder5BuildERK14dense_hash_mapIiP4RTTINS_27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS5_4pairIKiS3_EEL18MemLabelIdentifier6ELi16EEE: __ZN11TypeManager7Builder5BuildERK14dense_hash_mapIiP4RTTINS_27HashFunctorPersistentTypeIDENSt3__28equal_toIiEE13stl_allocatorINS5_4pairIKiS3_EEL18MemLabelIdentifier6ELi16EEE, __ZN30RuntimeInitializeOnLoadManager12CleanupClassEv: __ZN30RuntimeInitializeOnLoadManager12CleanupClassEv, _strsignal: _strsignal, __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14Texture2DArray8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__211__libcpp_db10__insert_iEPv: __ZNSt3__211__libcpp_db10__insert_iEPv, __ZN10TagManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10TagManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46Register_UnityEngine_Animator_GetBoneTransformv: __Z46Register_UnityEngine_Animator_GetBoneTransformv, __ZN12ScriptMapper23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN12ScriptMapper23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_: __ZN5physx2Gu25PersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_, __Z47Register_UnityEngine_Animator_get_isInitializedv: __Z47Register_UnityEngine_Animator_get_isInitializedv, __ZN5physx16PxsIslandManager23updateIslandsSecondPassERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx16PxsIslandManager23updateIslandsSecondPassERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __ZN10__cxxabiv121__vmi_class_type_infoD0Ev: __ZN10__cxxabiv121__vmi_class_type_infoD0Ev, __Z35RenderTexture_CUSTOM_GetColorBufferP12Il2CppObjectP21ScriptingRenderBuffer: __Z35RenderTexture_CUSTOM_GetColorBufferP12Il2CppObjectP21ScriptingRenderBuffer, __ZNSt3__218__insertion_sort_3IRNS_6__lessIhhEEPhEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIhhEEPhEEvT0_S5_T_, __ZN5Umbra14TomeCollection11deserializeERNS_11InputStreamEPPKNS_4TomeEiPNS_9AllocatorE: __ZN5Umbra14TomeCollection11deserializeERNS_11InputStreamEPPKNS_4TomeEiPNS_9AllocatorE, __ZN22ProceduralMaterialDataD2Ev: __ZN22ProceduralMaterialDataD2Ev, __ZN18MultiFrameGUIState15GetControlNamedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN18MultiFrameGUIState15GetControlNamedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc6ClientENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z56TerrainData_CUSTOM_Internal_GetMaximumAlphamapResolutionv: __Z56TerrainData_CUSTOM_Internal_GetMaximumAlphamapResolutionv, __ZN8Gradient13SwapColorKeysEii: __ZN8Gradient13SwapColorKeysEii, __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoButtonv: __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoButtonv, __ZN8LODGroup32NotifyLODGroupManagerIndexChangeEi: __ZN8LODGroup32NotifyLODGroupManagerIndexChangeEi, __ZN11UnityEngine15CloudWebService14RestDownloader6IsDoneEv: __ZN11UnityEngine15CloudWebService14RestDownloader6IsDoneEv, __Z46Register_UnityEngine_Graphics_CopyTexture_Fullv: __Z46Register_UnityEngine_Graphics_CopyTexture_Fullv, __Z44ParticleEmitter_Get_Custom_PropParticleCountP12Il2CppObject: __Z44ParticleEmitter_Get_Custom_PropParticleCountP12Il2CppObject, __Z20SignedTriangleArea2DPK8Vector3f: __Z20SignedTriangleArea2DPK8Vector3f, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl21getNbPropertyMessagesEv: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl21getNbPropertyMessagesEv, __ZN7ApiGLES14TextureSwizzleEj16TextureDimensionN2gl18TextureSwizzleFuncE: __ZN7ApiGLES14TextureSwizzleEj16TextureDimensionN2gl18TextureSwizzleFuncE, __ZN5physx6shdfnd10Foundation14createInstanceEjRNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE: __ZN5physx6shdfnd10Foundation14createInstanceEjRNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE, __Z48Register_UnityEngine_Compass_get_headingAccuracyv: __Z48Register_UnityEngine_Compass_get_headingAccuracyv, ___sindf: ___sindf, __Z51Register_UnityEngine_TerrainData_get_treePrototypesv: __Z51Register_UnityEngine_TerrainData_get_treePrototypesv, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13GetActivePoolEj: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13GetActivePoolEj, __Z42Register_UnityEngine_GUIStyle_get_clippingv: __Z42Register_UnityEngine_GUIStyle_get_clippingv, _cff_cmap_unicode_char_next: _cff_cmap_unicode_char_next, __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI10AudioMixerE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z36Collider2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfh: __Z36Collider2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayfh, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z45Animation_Get_Custom_PropAnimateOnlyIfVisibleP12Il2CppObject: __Z45Animation_Get_Custom_PropAnimateOnlyIfVisibleP12Il2CppObject, __ZL51RenameMotionCurvesToRootCurvesBackwardCompatibilityRNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE: __ZL51RenameMotionCurvesToRootCurvesBackwardCompatibilityRNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEE, __ZL34RegisterModuleICalls_TextRenderingv: __ZL34RegisterModuleICalls_TextRenderingv, __ZN14ConstantString12create_emptyEv: __ZN14ConstantString12create_emptyEv, __ZNK5physx10PxsContext18getSolverBatchSizeEv: __ZNK5physx10PxsContext18getSolverBatchSizeEv, __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN9Rigidbody7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Rigidbody7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN15SerializeTraitsINSt3__24pairIifEEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsINSt3__24pairIifEEE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZN18PlatformEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18PlatformEffector2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRGHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI15TexFormatRGHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZNK21EnlightenSceneMapping27GetRadiosityHashForRendererEPK6Object: __ZNK21EnlightenSceneMapping27GetRadiosityHashForRendererEPK6Object, __ZN12TreeRenderer29CreateMeshTreeRendererForTreeEi: __ZN12TreeRenderer29CreateMeshTreeRendererForTreeEi, __ZN30EmissionModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN30EmissionModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __Z40Register_UnityEngine_Texture3D_GetPixelsv: __Z40Register_UnityEngine_Texture3D_GetPixelsv, ___muldi3: ___muldi3, ___stdout_write: ___stdout_write, __ZN5physx26NpPhysicsInsertionCallbackD0Ev: __ZN5physx26NpPhysicsInsertionCallbackD0Ev, __ZN5physx2Gu10computeMTDERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_RNS_6shdfnd3aos6FloatVERNS6_5Vec3VE: __ZN5physx2Gu10computeMTDERNS0_13PolygonalDataES2_PNS0_12SupportLocalES4_RNS_6shdfnd3aos6FloatVERNS6_5Vec3VE, _tt_cmap13_validate: _tt_cmap13_validate, __ZN5physx2Sc7BodySim19deactivateKinematicEv: __ZN5physx2Sc7BodySim19deactivateKinematicEv, __Z40Collider2D_Get_Custom_PropUsedByEffectorP12Il2CppObject: __Z40Collider2D_Get_Custom_PropUsedByEffectorP12Il2CppObject, __Z43AnimationState_CUSTOM_RemoveMixingTransformP12Il2CppObjectS0_: __Z43AnimationState_CUSTOM_RemoveMixingTransformP12Il2CppObjectS0_, __Z44Physics_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK8Vector3fS1_P11Il2CppArrayfi23QueryTriggerInteraction: __Z44Physics_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK8Vector3fS1_P11Il2CppArrayfi23QueryTriggerInteraction, __Z55Register_UnityEngine_Animator_INTERNAL_CALL_MatchTargetv: __Z55Register_UnityEngine_Animator_INTERNAL_CALL_MatchTargetv, __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SliderJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN10GUITexture14DrawGUITextureERK5RectTIfER17ShaderPassContext: __ZN10GUITexture14DrawGUITextureERK5RectTIfER17ShaderPassContext, __Z57Register_UnityEngine_Animator_GetAnimatorClipInfoInternalv: __Z57Register_UnityEngine_Animator_GetAnimatorClipInfoInternalv, __ZN9Texture2D13GetAsyncFenceEv: __ZN9Texture2D13GetAsyncFenceEv, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED0Ev, __ZN5physx3Scb5Scene3addINS0_12ArticulationELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene3addINS0_12ArticulationELb1EEEvRT_RNS0_13ObjectTrackerE, _UNITY_png_set_sCAL_s: _UNITY_png_set_sCAL_s, __Z38QualitySettings_Get_Custom_PropShadowsv: __Z38QualitySettings_Get_Custom_PropShadowsv, __Z53Register_UnityEngine_Physics_INTERNAL_CALL_RaycastAllv: __Z53Register_UnityEngine_Physics_INTERNAL_CALL_RaycastAllv, __ZN14RenderSettings9SetUseFogEb: __ZN14RenderSettings9SetUseFogEb, __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_10ShrunkBoxVERKNS0_24ShrunkConvexHullNoScaleVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh, __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_connectedAnchorv: __Z65Register_UnityEngine_AnchoredJoint2D_INTERNAL_get_connectedAnchorv, __ZN4FMOD8ChannelIC2EPNS_7SystemIE: __ZN4FMOD8ChannelIC2EPNS_7SystemIE, __ZN4FMOD13ChannelGroupI14getParentGroupEPPNS_12ChannelGroupE: __ZN4FMOD13ChannelGroupI14getParentGroupEPPNS_12ChannelGroupE, _UNITY_png_info_init_3: _UNITY_png_info_init_3, __Z42Physics2D_Set_Custom_PropVelocityThresholdf: __Z42Physics2D_Set_Custom_PropVelocityThresholdf, __ZN5physx19NpArticulationJoint13setTwistLimitEff: __ZN5physx19NpArticulationJoint13setTwistLimitEff, __Z26Texture2D_CUSTOM_LoadImageP12Il2CppObjectP11Il2CppArrayh: __Z26Texture2D_CUSTOM_LoadImageP12Il2CppObjectP11Il2CppArrayh, __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_: __ZNK23ForwardShaderRenderLoop18RenderObjectSorterILb0EEclERK21ForwardRenderPassDataS4_, __Z19MoveFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z19MoveFileOrDirectoryRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __Z26AssetBundle_CUSTOM_LoadAllP12Il2CppObjectS0_: __Z26AssetBundle_CUSTOM_LoadAllP12Il2CppObjectS0_, __Z29StdTemplateConversionFunctionIfdEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIfdEbPvR14SafeBinaryRead, __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleNoDriveEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleNoDriveEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN14Texture2DArray7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14Texture2DArray7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN18AnimatorController19TransferRuntimeDataI14SafeBinaryReadEEvRT_: __ZN18AnimatorController19TransferRuntimeDataI14SafeBinaryReadEEvRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6assignERKS5_jj, __ZN15ReflectionProbe7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15ReflectionProbe7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN13TrailRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z36Canvas_Get_Custom_PropSortingLayerIDP12Il2CppObject: __Z36Canvas_Get_Custom_PropSortingLayerIDP12Il2CppObject, __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj: __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE8__appendEj, _UNITY_png_get_pixel_aspect_ratio: _UNITY_png_get_pixel_aspect_ratio, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI18ComputeShaderParamNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI18ComputeShaderParamNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZNK5Umbra4Tome10getVersionEv: __ZNK5Umbra4Tome10getVersionEv, __ZN18ProceduralMaterial5CloneEv: __ZN18ProceduralMaterial5CloneEv, __Z55Register_UnityEngine_Physics2D_set_linearSleepTolerancev: __Z55Register_UnityEngine_Physics2D_set_linearSleepTolerancev, __ZN5physx37PxSimulationStatisticsGeneratedValuesC2EPKNS_22PxSimulationStatisticsE: __ZN5physx37PxSimulationStatisticsGeneratedValuesC2EPKNS_22PxSimulationStatisticsE, __ZL22Transfer_ManagedObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12getLocalPoseENS_17PxJointActorIndex4EnumE, __ZN5physx2GuL32fullContactsGenerationCapsuleBoxERKNS0_8CapsuleVERKNS0_4BoxVENS_6PxVec3ERKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVESF_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS9_5Vec3VERKNS9_6FloatVEb: __ZN5physx2GuL32fullContactsGenerationCapsuleBoxERKNS0_8CapsuleVERKNS0_4BoxVENS_6PxVec3ERKNS_6shdfnd3aos15PsMatTransformVERKNS9_12PsTransformVESF_PNS0_17PersistentContactERjRNS0_13ContactBufferERNS0_25PersistentContactManifoldERNS9_5Vec3VERKNS9_6FloatVEb, __ZN5physx2Gu16testPolyDataAxisERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE: __ZN5physx2Gu16testPolyDataAxisERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE, __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif: __Z26RecalculateSplineSlopeLoopI11QuaternionfEvR17AnimationCurveTplIT_Eif, __Z45Application_Get_Custom_PropWebSecurityHostUrlv: __Z45Application_Get_Custom_PropWebSecurityHostUrlv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__set_long_capEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__set_long_capEj, __Z34CommandBuffer_CUSTOM_ReleaseBufferP12Il2CppObject: __Z34CommandBuffer_CUSTOM_ReleaseBufferP12Il2CppObject, __Z30setPxCapsuleGeometryHalfHeightPN5physx17PxCapsuleGeometryEf: __Z30setPxCapsuleGeometryHalfHeightPN5physx17PxCapsuleGeometryEf, __Z45getPxSphericalJoint_ProjectionLinearTolerancePKN5physx16PxSphericalJointE: __Z45getPxSphericalJoint_ProjectionLinearTolerancePKN5physx16PxSphericalJointE, __ZN10MemoryFile5CloseEv: __ZN10MemoryFile5CloseEv, __Z43CommandBuffer_CUSTOM_SetRenderTarget_SingleP12Il2CppObjectR26MonoRenderTargetIdentifieriii: __Z43CommandBuffer_CUSTOM_SetRenderTarget_SingleP12Il2CppObjectR26MonoRenderTargetIdentifieriii, __ZN17Physics2DSettings19SetMaxRotationSpeedEf: __ZN17Physics2DSettings19SetMaxRotationSpeedEf, __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_SetRangev: __Z80Register_UnityEngine_ParticleSystem_RotationBySpeedModule_INTERNAL_CALL_SetRangev, __Z62TerrainData_CUSTOM_Internal_GetMaximumDetailResolutionPerPatchv: __Z62TerrainData_CUSTOM_Internal_GetMaximumDetailResolutionPerPatchv, __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_: __ZN5physx2Gu30distanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_, __ZN4FMOD7Channel18set3DCustomRolloffEP11FMOD_VECTORi: __ZN4FMOD7Channel18set3DCustomRolloffEP11FMOD_VECTORi, __ZN5physx2Sq12BucketPrunerC2Ev: __ZN5physx2Sq12BucketPrunerC2Ev, _check_header: _check_header, __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z8EvaluateIL12GradientMode1ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __Z11IsGfxDevicev: __Z11IsGfxDevicev, __ZN5physx3Ext18computeConeDensityEfff: __ZN5physx3Ext18computeConeDensityEfff, __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev: __ZN5physx34PxHeightFieldGeometryGeneratedInfoC2Ev, __Z50Register_UnityEngine_Collider2D_set_usedByEffectorv: __Z50Register_UnityEngine_Collider2D_set_usedByEffectorv, __Z44UnityWebRequest_Get_Custom_PropUploadHandlerP12Il2CppObject: __Z44UnityWebRequest_Get_Custom_PropUploadHandlerP12Il2CppObject, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE12getNumPlanesEv, __Z64Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSphereNonAllocv: __Z64Register_UnityEngine_Physics_INTERNAL_CALL_OverlapSphereNonAllocv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv, __ZNK23iPhoneLocalNotification12GetSoundNameEv: __ZNK23iPhoneLocalNotification12GetSoundNameEv, __Z47Material_Get_Custom_PropGlobalIlluminationFlagsP12Il2CppObject: __Z47Material_Get_Custom_PropGlobalIlluminationFlagsP12Il2CppObject, __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetWorldSpacev: __Z81Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetWorldSpacev, __ZNSt3__28__c_node8__removeEPNS_8__i_nodeE: __ZNSt3__28__c_node8__removeEPNS_8__i_nodeE, __Z51Register_UnityEngine_Profiling_Profiler_set_logFilev: __Z51Register_UnityEngine_Profiling_Profiler_set_logFilev, __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_11PxTransformENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z22CleanupAfterRenderLoopR10RenderLoop: __Z22CleanupAfterRenderLoopR10RenderLoop, __ZN6Skybox23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Skybox23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED0Ev: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEED0Ev, __Z22GetMainThreadGfxDevicev: __Z22GetMainThreadGfxDevicev, __ZN12GUIClipState8EndOnGUIER10InputEvent: __ZN12GUIClipState8EndOnGUIER10InputEvent, __ZN9InputAxis10MakeButtonEii: __ZN9InputAxis10MakeButtonEii, __Z36ComputeBuffer_CUSTOM_SetCounterValueP12Il2CppObjectj: __Z36ComputeBuffer_CUSTOM_SetCounterValueP12Il2CppObjectj, __ZN15FileSystemEntry12CreateAsFileEv: __ZN15FileSystemEntry12CreateAsFileEv, __ZNKSt3__25ctypeIwE5do_isEPKwS3_Pt: __ZNKSt3__25ctypeIwE5do_isEPKwS3_Pt, __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN2UI11CanvasGroup23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN10__cxxabiv112_GLOBAL__N_19base_nameINSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEEEET_RS9_: __ZN10__cxxabiv112_GLOBAL__N_19base_nameINSt3__212basic_stringIcNS2_11char_traitsIcEENS0_12malloc_allocIcEEEEEET_RS9_, __ZN19MeshParticleEmitterD2Ev: __ZN19MeshParticleEmitterD2Ev, __ZNKSt3__223__system_error_category7messageEi: __ZNKSt3__223__system_error_category7messageEi, __Z32Debug_CUSTOM_SetDiagnosticSwitchP12Il2CppStringP12Il2CppObjecth: __Z32Debug_CUSTOM_SetDiagnosticSwitchP12Il2CppStringP12Il2CppObjecth, __ZNK12b2ChainShape5CloneEP16b2BlockAllocator: __ZNK12b2ChainShape5CloneEP16b2BlockAllocator, __ZZ23InitPlayerLoopCallbacksvEN30PreUpdateSendMouseEventsstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN30PreUpdateSendMouseEventsstruct7ForwardEv, __ZN5physx14PxVehicleDriveD0Ev: __ZN5physx14PxVehicleDriveD0Ev, __ZN8Renderer12GetTransformEv: __ZN8Renderer12GetTransformEv, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_, __Z13jpeg_user_srcP22jpeg_decompress_structPN12ImageDecoder11UserContextE: __Z13jpeg_user_srcP22jpeg_decompress_structPN12ImageDecoder11UserContextE, __Z44Register_UnityEngine_Caching_CleanNamedCachev: __Z44Register_UnityEngine_Caching_CleanNamedCachev, _unity_z_inflateGetHeader: _unity_z_inflateGetHeader, _tt_cmap13_init: _tt_cmap13_init, __Z15tessMeshZapFaceP8TESSmeshP8TESSface: __Z15tessMeshZapFaceP8TESSmeshP8TESSface, __ZNK14ParticleSystem17GetAutoRandomSeedEv: __ZNK14ParticleSystem17GetAutoRandomSeedEv, __Z23RandomPointInsideCircleR5RandNRKfS2_: __Z23RandomPointInsideCircleR5RandNRKfS2_, _sync: _sync, __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation21BlendTreeNodeConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN8Animator14CreateBindingsEv: __ZN8Animator14CreateBindingsEv, __Z53Register_UnityEngine_CanvasRenderer_set_materialCountv: __Z53Register_UnityEngine_CanvasRenderer_set_materialCountv, __ZNK15b2RevoluteJoint13GetJointAngleEv: __ZNK15b2RevoluteJoint13GetJointAngleEv, __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Behaviour13AwakeFromLoadE17AwakeFromLoadMode, __Z59Register_UnityEngine_RenderSettings_set_reflectionIntensityv: __Z59Register_UnityEngine_RenderSettings_set_reflectionIntensityv, _pselect: _pselect, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE27handleExtendedIndexPropertyILj643ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZNK16CompareSceneNameclEPK10UnityScene: __ZNK16CompareSceneNameclEPK10UnityScene, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj468ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj468ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, ___strdup: ___strdup, __ZN14ParticleSystem21SetCustomParticleDataEPKN4math14float4_storageEii: __ZN14ParticleSystem21SetCustomParticleDataEPKN4math14float4_storageEii, __ZN15TerrainCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15TerrainCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN12CubemapArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12CubemapArray8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11SoundHandleC2Ev: __ZN11SoundHandleC2Ev, __Z28dtClosestHeightPointTrianglePKfS0_S0_S0_Rf: __Z28dtClosestHeightPointTrianglePKfS0_S0_S0_Rf, __ZL27CleanupCoreScriptingClassesv: __ZL27CleanupCoreScriptingClassesv, __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED2Ev, __ZN14ParticleSystem7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14ParticleSystem7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture: __ZN19RenderBufferManager17ReleaseTempBufferEP13RenderTexture, __ZN5physx19NpArticulationJoint21setExternalComplianceEf: __ZN5physx19NpArticulationJoint21setExternalComplianceEf, __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13BoxCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z15HiearchyMatchesP9TransformPKN7mecanim8skeleton8SkeletonEiRKNS1_5crc32E: __Z15HiearchyMatchesP9TransformPKN7mecanim8skeleton8SkeletonEiRKNS1_5crc32E, __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sq10AABBPruner7releaseEv: __ZN5physx2Sq10AABBPruner7releaseEv, __ZN8GUIState8EndFrameEv: __ZN8GUIState8EndFrameEv, __Z37getPxArticulation_SeparationTolerancePKN5physx14PxArticulationE: __Z37getPxArticulation_SeparationTolerancePKN5physx14PxArticulationE, __Z45Register_UnityEngine_Matrix4x4_get_isIdentityv: __Z45Register_UnityEngine_Matrix4x4_get_isIdentityv, __ZN5physx8debugger19PvdNetworkOutStreamD2Ev: __ZN5physx8debugger19PvdNetworkOutStreamD2Ev, __Z44Register_UnityEngine_Time_get_fixedDeltaTimev: __Z44Register_UnityEngine_Time_get_fixedDeltaTimev, __ZNSt3__28__i_nodeD2Ev: __ZNSt3__28__i_nodeD2Ev, __Z48Register_UnityEngine_Joint2D_get_enableCollisionv: __Z48Register_UnityEngine_Joint2D_get_enableCollisionv, __Z26getPxDistanceJoint_DampingPKN5physx15PxDistanceJointE: __Z26getPxDistanceJoint_DampingPKN5physx15PxDistanceJointE, __Z28Caching_Get_Custom_PropReadyv: __Z28Caching_Get_Custom_PropReadyv, __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUseRandomRowP12Il2CppObjecth: __Z65ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetUseRandomRowP12Il2CppObjecth, __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_13PxHeightFieldENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __Z9ReadCacheR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjRKjRKf: __Z9ReadCacheR13dynamic_arrayI20BatchedRaycastResultLj4EERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesRK33ParticleSystemCollisionParametersjRKjRKf, __ZN18LoadSceneOperation23SetAllowSceneActivationEb: __ZN18LoadSceneOperation23SetAllowSceneActivationEb, __ZN5Umbra5QueryC2EPKNS_4TomeE: __ZN5Umbra5QueryC2EPKNS_4TomeE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_4pairIifEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorINS1_4pairIifEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEEEEEvRT_17TransferMetaFlags, __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE: __Z23RegisterLogPreprocessorPFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_S8_iS8_PiiiE, __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18ProceduralMaterial8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9Texture2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Texture2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12_GLOBAL__N_116MetaDataProvider20getInstanceClassTypeEPKv: __ZN12_GLOBAL__N_116MetaDataProvider20getInstanceClassTypeEPKv, __ZN13BoxCollider2D8TransferI14SafeBinaryReadEEvRT_: __ZN13BoxCollider2D8TransferI14SafeBinaryReadEEvRT_, __ZN5physx19PxsMaterialCombinerC2Eff: __ZN5physx19PxsMaterialCombinerC2Eff, __ZN12LightsModule17DeleteLightsCacheEv: __ZN12LightsModule17DeleteLightsCacheEv, __ZNK12CubemapArray9GetPixelsEiP10ColorRGBAf11CubemapFaceii: __ZNK12CubemapArray9GetPixelsEiP10ColorRGBAf11CubemapFaceii, _vasprintf: _vasprintf, __Z41getPxVehicleSuspensionDataMMaxCompressionPKN5physx23PxVehicleSuspensionDataE: __Z41getPxVehicleSuspensionDataMMaxCompressionPKN5physx23PxVehicleSuspensionDataE, _jinit_huff_encoder: _jinit_huff_encoder, __ZN13WheelCollider24ConfigureVehicleSubstepsEfii: __ZN13WheelCollider24ConfigureVehicleSubstepsEfii, __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx3Ext14PrismaticJoint22setPrismaticJointFlagsENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE: __ZN5physx3Ext14PrismaticJoint22setPrismaticJointFlagsENS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEE, __ZNK5physx18PxVehicleWheelData7isValidEv: __ZNK5physx18PxVehicleWheelData7isValidEv, __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE: __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE, __Z32CanvasGroup_Get_Custom_PropAlphaP12Il2CppObject: __Z32CanvasGroup_Get_Custom_PropAlphaP12Il2CppObject, __ZNK7dtCrowd22CalculateRemainingPathERK13dtCrowdHandle: __ZNK7dtCrowd22CalculateRemainingPathERK13dtCrowdHandle, __Z26CalculateSphereFrom4PointsPK8Vector3fRS_Rf: __Z26CalculateSphereFrom4PointsPK8Vector3fRS_Rf, __ZN12SoundManager26OnCreateSoundPopAllocationEv: __ZN12SoundManager26OnCreateSoundPopAllocationEv, __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb: __ZN5physx2Gu15GJKLocalRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb, __ZN11UnityEngine7Connect15DeviceInfoEventC2Ev: __ZN11UnityEngine7Connect15DeviceInfoEventC2Ev, __Z57Register_UnityEngine_WebCamTexture_get_didUpdateThisFramev: __Z57Register_UnityEngine_WebCamTexture_get_didUpdateThisFramev, __ZNK5physx18PxsDynamicsContext17integrateAtomPoseEPNS_12PxsRigidBodyERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERKNS_6PxVec3ESB_: __ZNK5physx18PxsDynamicsContext17integrateAtomPoseEPNS_12PxsRigidBodyERNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEERKNS_6PxVec3ESB_, __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_T_, __Z36Object_CUSTOM_FindSceneObjectsOfTypeP12Il2CppObject: __Z36Object_CUSTOM_FindSceneObjectsOfTypeP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15ComputeShaderCBNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z31RegisterStaticallyLinkedModulesv: __Z31RegisterStaticallyLinkedModulesv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj579ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj579ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK15ParticleEmitter26GetTypeInfoVirtualInternalEv: __ZNK15ParticleEmitter26GetTypeInfoVirtualInternalEv, __ZN13b2DynamicTreeC2Ev: __ZN13b2DynamicTreeC2Ev, _UNITY_FT_Init_Class_tt_cmap8_class_rec: _UNITY_FT_Init_Class_tt_cmap8_class_rec, __Z38LineRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_: __Z38LineRenderer_Set_Custom_PropWidthCurveP12Il2CppObjectS0_, __Z30getPxActor_ClientBehaviorFlagsPKN5physx7PxActorE: __Z30getPxActor_ClientBehaviorFlagsPKN5physx7PxActorE, __ZN26SizeModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN26SizeModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEcj, __ZL35FindAndLoadUnityPluginIl2CppWrapperPKc: __ZL35FindAndLoadUnityPluginIl2CppWrapperPKc, __Z60Register_UnityEngine_RelativeJoint2D_get_autoConfigureOffsetv: __Z60Register_UnityEngine_RelativeJoint2D_get_autoConfigureOffsetv, __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14SpriteRendererD2Ev: __ZN14SpriteRendererD2Ev, __ZN6Object8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN6Object8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EOS5_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKcEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj207ENS_22PxRepXPropertyAccessorILj207ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEE14handleAccessorILj207ENS_22PxRepXPropertyAccessorILj207ES4_ffEEEEvRKT0_, __Z22IsValidPolynomialCurveRK17AnimationCurveTplIfE: __Z22IsValidPolynomialCurveRK17AnimationCurveTplIfE, __ZN5physx19NpArticulationJoint28setSwingLimitContactDistanceEf: __ZN5physx19NpArticulationJoint28setSwingLimitContactDistanceEf, __ZN5physx2Sn25readStridedBufferPropertyItEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyItEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE, __ZN5physx2Gu25computeMTD_CapsuleCapsuleERNS_6PxVec3ERfRKNS0_7CapsuleES6_: __ZN5physx2Gu25computeMTD_CapsuleCapsuleERNS_6PxVec3ERfRKNS0_7CapsuleES6_, __Z61Register_UnityEngine_Connect_UnityConnectSettings_set_enabledv: __Z61Register_UnityEngine_Connect_UnityConnectSettings_set_enabledv, __ZN10AudioMixer11IsSuspendedEv: __ZN10AudioMixer11IsSuspendedEv, __ZN13MonoBehaviour25TransferEngineAndInstanceI14SafeBinaryReadEEvRT_: __ZN13MonoBehaviour25TransferEngineAndInstanceI14SafeBinaryReadEEvRT_, __ZN12InputManager17GetTextFieldInputEv: __ZN12InputManager17GetTextFieldInputEv, ___crypt_des: ___crypt_des, __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __Z41AudioClip_Get_Custom_PropLoadInBackgroundP12Il2CppObject: __Z41AudioClip_Get_Custom_PropLoadInBackgroundP12Il2CppObject, __Z46Register_UnityEngine_WebCamTexture_GetPixels32v: __Z46Register_UnityEngine_WebCamTexture_GetPixels32v, __ZNK8Material20GetRuntimeMemorySizeEv: __ZNK8Material20GetRuntimeMemorySizeEv, __Z30Time_Get_Custom_PropFrameCountv: __Z30Time_Get_Custom_PropFrameCountv, __ZZ23InitPlayerLoopCallbacksvEN35PostLateUpdateBatchModeUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN35PostLateUpdateBatchModeUpdatestruct7ForwardEv, __ZN14TreeBinaryTreeD2Ev: __ZN14TreeBinaryTreeD2Ev, __Z42CommandBuffer_CUSTOM_SetGlobalTexture_ImplP12Il2CppObjectiR26MonoRenderTargetIdentifier: __Z42CommandBuffer_CUSTOM_SetGlobalTexture_ImplP12Il2CppObjectiR26MonoRenderTargetIdentifier, __Z31getPxJointAngularLimitPairLowerPKN5physx23PxJointAngularLimitPairE: __Z31getPxJointAngularLimitPairLowerPKN5physx23PxJointAngularLimitPairE, __Z24InvokeOnWillRenderObjectRK13dynamic_arrayIP12BaseRendererLj4EE: __Z24InvokeOnWillRenderObjectRK13dynamic_arrayIP12BaseRendererLj4EE, __ZN5physx19NpArticulationJointC2ERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_: __ZN5physx19NpArticulationJointC2ERNS_18NpArticulationLinkERKNS_11PxTransformES2_S5_, __ZN20dynamic_block_vectorI14FileIdentifierE9push_backERKS0_: __ZN20dynamic_block_vectorI14FileIdentifierE9push_backERKS0_, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNK5physx7NpCloth15getTetherConfigEv: __ZNK5physx7NpCloth15getTetherConfigEv, __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev: __ZN5physx36PxVehicleDriveSimDataNWGeneratedInfoC2Ev, __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_: __ZNSt3__213__tree_removeIPNS_16__tree_node_baseIPvEEEEvT_S5_, __ZNK12LineRenderer26GetTypeInfoVirtualInternalEv: __ZNK12LineRenderer26GetTypeInfoVirtualInternalEv, __ZN5physx2Sc5Scene33updateFromVisualizationParametersEv: __ZN5physx2Sc5Scene33updateFromVisualizationParametersEv, __ZL16UnityDetourAlloci: __ZL16UnityDetourAlloci, __ZN17AudioChorusFilterD0Ev: __ZN17AudioChorusFilterD0Ev, __Z29setPxRigidBody_RigidBodyFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __Z29setPxRigidBody_RigidBodyFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __Z63Register_UnityEngine_AudioHighPassFilter_get_highpassResonanceQv: __Z63Register_UnityEngine_AudioHighPassFilter_get_highpassResonanceQv, _iswprint: _iswprint, __ZN4FMOD12ChannelGroup14get3DOcclusionEPfS1_: __ZN4FMOD12ChannelGroup14get3DOcclusionEPfS1_, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5tellpEv: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE5tellpEv, __ZNK15AnchoredJoint2D26GetTypeInfoVirtualInternalEv: __ZNK15AnchoredJoint2D26GetTypeInfoVirtualInternalEv, _vwscanf: _vwscanf, __ZN8Animator16GetBoneTransformEi: __ZN8Animator16GetBoneTransformEi, __ZN17PersistentManager25GetSerializedFileInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN17PersistentManager25GetSerializedFileInternalERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z67Register_UnityEngine_Networking_UnityWebRequest_set_downloadHandlerv: __Z67Register_UnityEngine_Networking_UnityWebRequest_set_downloadHandlerv, __ZN21EnlightenSceneMapping28GetDynamicLightmapSTInSystemEPK12BaseRendererRK28EnlightenRendererInformation: __ZN21EnlightenSceneMapping28GetDynamicLightmapSTInSystemEPK12BaseRendererRK28EnlightenRendererInformation, __ZN12IFileAdapter4SeekER13FileEntryDatax10FileOrigin: __ZN12IFileAdapter4SeekER13FileEntryDatax10FileOrigin, __ZN20OcclusionCullingData8TransferI14SafeBinaryReadEEvRT_: __ZN20OcclusionCullingData8TransferI14SafeBinaryReadEEvRT_, __ZN5physx17collideWithSphereERNS_19PxsParticleCollDataERKNS_16PxSphereGeometryEf: __ZN5physx17collideWithSphereERNS_19PxsParticleCollDataERKNS_16PxSphereGeometryEf, __ZN20TextRenderingPrivate8TextMesh9SetAnchorEs: __ZN20TextRenderingPrivate8TextMesh9SetAnchorEs, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z46DistanceJoint2D_Set_Custom_PropMaxDistanceOnlyP12Il2CppObjecth: __Z46DistanceJoint2D_Set_Custom_PropMaxDistanceOnlyP12Il2CppObjecth, __ZN5physx2Gu12TriangleMesh15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Gu12TriangleMesh15importExtraDataERNS_24PxDeserializationContextE, __ZNK14Texture2DArray20GetTextureLayerCountEv: __ZNK14Texture2DArray20GetTextureLayerCountEv, __Z45Register_UnityEngine_AndroidJNI_FromByteArrayv: __Z45Register_UnityEngine_AndroidJNI_FromByteArrayv, __ZNSt3__214codecvt_bynameIcc11__mbstate_tED0Ev: __ZNSt3__214codecvt_bynameIcc11__mbstate_tED0Ev, __Z10DestripifyItjEvPKT_iPT0_i: __Z10DestripifyItjEvPKT_iPT0_i, __ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE: __ZN11UnityEngine9Animation15IsMuscleBindingERKNS0_14GenericBindingE, _lrintl: _lrintl, __Z14CheckErrorGLESPK7ApiGLESPKcS3_l: __Z14CheckErrorGLESPK7ApiGLESPKcS3_l, __ZN5physx7NpShape14resetFilteringEv: __ZN5physx7NpShape14resetFilteringEv, __ZN7mecanim9animation23BlendDirectDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation23BlendDirectDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZThn80_NK26AnimatorControllerPlayable13IsInitializedEv: __ZThn80_NK26AnimatorControllerPlayable13IsInitializedEv, __ZN5physx18PxcArticulationRef17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE: __ZN5physx18PxcArticulationRef17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE, __Z51Register_UnityEngine_Application_get_isLoadingLevelv: __Z51Register_UnityEngine_Application_get_isLoadingLevelv, __ZN5physx12SubSortQuickC2EPjPKNS_10PxBounds3VEjf: __ZN5physx12SubSortQuickC2EPjPKNS_10PxBounds3VEjf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj293ENS_22PxRepXPropertyAccessorILj293ES4_NS_19PxHeightFieldFormat4EnumESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEE14handleAccessorILj293ENS_22PxRepXPropertyAccessorILj293ES4_NS_19PxHeightFieldFormat4EnumESA_EEEEvRKT0_, __ZNSt9bad_allocD2Ev: __ZNSt9bad_allocD2Ev, __ZN8LODGroup3LOD8TransferI14SafeBinaryReadEEvRT_: __ZN8LODGroup3LOD8TransferI14SafeBinaryReadEEvRT_, __Z35setPxClothStretchConfigStretchLimitPN5physx20PxClothStretchConfigEf: __Z35setPxClothStretchConfigStretchLimitPN5physx20PxClothStretchConfigEf, __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR11NodeXSorterP16HeightMeshBVNodeEEjT0_S5_S5_T_, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveMultiplierv, _casinhl: _casinhl, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf14TexFormatRHalfEEvPKNS_9InnerInfoE, _casinhf: _casinhf, __Z64Register_UnityEngine_ParticleSystem_TriggerModule_GetRadiusScalev: __Z64Register_UnityEngine_ParticleSystem_TriggerModule_GetRadiusScalev, __ZN19AudioHighPassFilter8TransferI14SafeBinaryReadEEvRT_: __ZN19AudioHighPassFilter8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj17ENS_7PxActorEhhEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Cm9DebugTextC2ERKNS_6PxVec3EfPKcz: __ZN5physx2Cm9DebugTextC2ERKNS_6PxVec3EfPKcz, __ZN9Animation10DeactivateE19DeactivateOperation: __ZN9Animation10DeactivateE19DeactivateOperation, __ZN18ColorBySpeedModule5ResetEv: __ZN18ColorBySpeedModule5ResetEv, _tt_cmap_init: _tt_cmap_init, __ZNSt3__215messages_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__215messages_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb: __ZL22TestDuplicateTrianglesRjPN5physx2Gu9TriangleTIjEEb, __Z39WheelCollider_Get_Custom_PropSprungMassP12Il2CppObject: __Z39WheelCollider_Get_Custom_PropSprungMassP12Il2CppObject, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZNK21EnlightenSceneMapping21RadiositySystemExistsERK7Hash128: __ZNK21EnlightenSceneMapping21RadiositySystemExistsERK7Hash128, __ZN5physx17PxMeshOverlapUtilC2Ev: __ZN5physx17PxMeshOverlapUtilC2Ev, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __ZN5physx8CCDSweepINS_2Gu11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f: __ZN5physx8CCDSweepINS_2Gu11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f, __ZN14CachingManager17VerifyValidDomainERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN14CachingManager17VerifyValidDomainERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN9Transform41SetPositionAndRotationWithoutNotificationERK8Vector3fRK11Quaternionf: __ZN9Transform41SetPositionAndRotationWithoutNotificationERK8Vector3fRK11Quaternionf, __ZN17ProceduralTexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17ProceduralTexture7PRODUCEE10MemLabelId18ObjectCreationMode, __Z48CharacterController_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z48CharacterController_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, __Z40Register_UnityEngine_RectOffset_set_leftv: __Z40Register_UnityEngine_RectOffset_set_leftv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI14AnimationEvent13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12TreeInstance8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12TreeInstance8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z22assign_allocation_rootPvjRK10MemLabelIdPKcS4_: __Z22assign_allocation_rootPvjRK10MemLabelIdPKcS4_, __ZN2UI13RectTransform15GetWorldCornersERA4_8Vector3f: __ZN2UI13RectTransform15GetWorldCornersERA4_8Vector3f, __ZN22UnityAnalyticsSettingsD0Ev: __ZN22UnityAnalyticsSettingsD0Ev, __ZL34GetComponentsImplementationRecurseILb1ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb1ELi1ELi0EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN17ArchiveFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN17ArchiveFileSystem6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS0_9allocatorIS4_EEEEEvRT_j, __ZN7mecanim4hand13HandPoseSolveEPKNS0_8HandPoseEPS1_: __ZN7mecanim4hand13HandPoseSolveEPKNS0_8HandPoseEPS1_, __Z42AudioReverbZone_Get_Custom_PropMinDistanceP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropMinDistanceP12Il2CppObject, __ZN18PlatformEffector2D15InitializeClassEv: __ZN18PlatformEffector2D15InitializeClassEv, __ZN17ParticleLightNodeD0Ev: __ZN17ParticleLightNodeD0Ev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_12NpConstraintEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, _cff_index_access_element: _cff_index_access_element, __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_: __ZNSt3__27__sort3IR15ReflProbeSorterPP15ReflectionProbeEEjT0_S6_S6_T_, __ZN18BuoyancyEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18BuoyancyEffector2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj694ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN5physx6shdfnd5ArrayINS_19PxContactModifyPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_19PxContactModifyPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN11JointLimits8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11JointLimits8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1EPNS_15basic_streambufIcS2_EE, __Z37Physics2D_CUSTOM_IgnoreLayerCollisioniih: __Z37Physics2D_CUSTOM_IgnoreLayerCollisioniih, __ZNK21DownloadHandlerBuffer11GetProgressEv: __ZNK21DownloadHandlerBuffer11GetProgressEv, __Z33BillboardAsset_CUSTOM_SetVerticesP12Il2CppObjectP11Il2CppArray: __Z33BillboardAsset_CUSTOM_SetVerticesP12Il2CppObjectP11Il2CppArray, __ZN5Unity12PhysicsQuery13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery13OverlapSphereERK8Vector3ffi23QueryTriggerInteraction, _UNITY_png_default_read_data: _UNITY_png_default_read_data, __Z31GeomOverlapCallback_CapsuleMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z31GeomOverlapCallback_CapsuleMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZNSt3__215__time_get_tempIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__215__time_get_tempIwEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getExternalAccelerationEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE23getExternalAccelerationEv, __ZN5Cache14ReadCacheIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN5Cache14ReadCacheIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z56Register_UnityEngine_AI_NavMeshAgent_get_isOnOffMeshLinkv: __Z56Register_UnityEngine_AI_NavMeshAgent_get_isOnOffMeshLinkv, __ZN9Transform30SetRotationWithoutNotificationERK11Quaternionf: __ZN9Transform30SetRotationWithoutNotificationERK11Quaternionf, __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEvT0_S7_T_, __ZN11ClothModule16GetClothingSceneEv: __ZN11ClothModule16GetClothingSceneEv, __ZN2UI20CalculateNestedAlphaEP9TransformPKS0_f: __ZN2UI20CalculateNestedAlphaEP9TransformPKS0_f, __Z43Playables_CUSTOM_EndIgnoreAllocationTrackerv: __Z43Playables_CUSTOM_EndIgnoreAllocationTrackerv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZN4FMOD13ChannelGroupI19getAudibilityFactorEPf: __ZN4FMOD13ChannelGroupI19getAudibilityFactorEPf, __Z40Application_CUSTOM_Internal_ExternalCallP12Il2CppString: __Z40Application_CUSTOM_Internal_ExternalCallP12Il2CppString, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15ShaderParamTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead15ShaderParamTypeEvRT_RT0_PKc17TransferMetaFlags, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx2Gu25PersistentContactManifold31addBatchManifoldContactsClusterEPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold31addBatchManifoldContactsClusterEPKNS0_17PersistentContactEj, __ZN9Animation12CleanupClassEv: __ZN9Animation12CleanupClassEv, _ft_raster1_transform: _ft_raster1_transform, __Z61Register_UnityEngine_ParticleSystem_EmissionModule_GetEnabledv: __Z61Register_UnityEngine_ParticleSystem_EmissionModule_GetEnabledv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13find_first_ofEPKcj, _ft_stroker_cap: _ft_stroker_cap, __ZN5physx2Sq10AABBPruner13removeObjectsEPKjj: __ZN5physx2Sq10AABBPruner13removeObjectsEPKjj, __ZN11UnityEngine15CloudWebService18RestFileDownloaderC2EPNS0_23IRestDownloaderListenerE: __ZN11UnityEngine15CloudWebService18RestFileDownloaderC2EPNS0_23IRestDownloaderListenerE, __ZN14CompressedMesh8TransferI14SafeBinaryReadEEvRT_: __ZN14CompressedMesh8TransferI14SafeBinaryReadEEvRT_, __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation11GetProgressEv: __ZN24UserAuthorizationManager38UserAuthorizationManagerErrorOperation11GetProgressEv, _error_exit: _error_exit, __ZN22BaseUnityConnectClient17InitializeSessionERK8UnityStrS2_N19CloudServiceHandler13InitModeFlagsE: __ZN22BaseUnityConnectClient17InitializeSessionERK8UnityStrS2_N19CloudServiceHandler13InitModeFlagsE, _UNITY_png_get_valid: _UNITY_png_get_valid, __Z42Register_UnityEngine_Mesh_SetTrianglesImplv: __Z42Register_UnityEngine_Mesh_SetTrianglesImplv, __ZN22ParticleSystemRendererD2Ev: __ZN22ParticleSystemRendererD2Ev, __ZNSt3__26localeaSERKS0_: __ZNSt3__26localeaSERKS0_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE19getConcreteTypeNameEv, _UNITY_FT_Sfnt_Table_Info: _UNITY_FT_Sfnt_Table_Info, __ZN7mecanim8skeleton23Skeleton2BoneAdjustHintEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_f: __ZN7mecanim8skeleton23Skeleton2BoneAdjustHintEPKNS0_8SkeletonEiiiRKN4math7_float3EfPNS0_13SkeletonPoseTINS4_4trsXEEESB_f, __ZN9ShaderLab26SerializedShaderDependency8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab26SerializedShaderDependency8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc9ClothCore21removeCollisionConvexEj: __ZN5physx2Sc9ClothCore21removeCollisionConvexEj, __Z12storeAlignedPfjRK8Scalar4f: __Z12storeAlignedPfjRK8Scalar4f, __ZNK5physx7NpCloth22getFrictionCoefficientEv: __ZNK5physx7NpCloth22getFrictionCoefficientEv, __Z39OffMeshLink_Get_Custom_PropNavMeshLayerP12Il2CppObject: __Z39OffMeshLink_Get_Custom_PropNavMeshLayerP12Il2CppObject, __ZN23b2EdgeAndCapsuleContactC2EP9b2FixtureS1_: __ZN23b2EdgeAndCapsuleContactC2EP9b2FixtureS1_, __ZN9ShaderLab9IntShader8PostLoadEP6Shader: __ZN9ShaderLab9IntShader8PostLoadEP6Shader, __ZN9Animation10RemoveClipERK19ShouldRemoveFunctorPKc: __ZN9Animation10RemoveClipERK19ShouldRemoveFunctorPKc, __ZN26LegacyTreeInstanceRendererD0Ev: __ZN26LegacyTreeInstanceRendererD0Ev, __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE: __ZN10MeshFilter13SetSharedMeshE4PPtrI4MeshE, __Z49SystemInfo_Get_Custom_PropUsesOpenGLTextureCoordsv: __Z49SystemInfo_Get_Custom_PropUsesOpenGLTextureCoordsv, __ZL20sample_mono_shutdownPv: __ZL20sample_mono_shutdownPv, __Z31SetShapeLocalPoseAndWakeUpActorPN5physx7PxShapeEPNS_12PxRigidActorERK10Matrix4x4f: __Z31SetShapeLocalPoseAndWakeUpActorPN5physx7PxShapeEPNS_12PxRigidActorERK10Matrix4x4f, _UNITY_png_set_iCCP: _UNITY_png_set_iCCP, __ZN5physx3Ext15CpuWorkerThread9giveUpJobEv: __ZN5physx3Ext15CpuWorkerThread9giveUpJobEv, __Z42setPxVehicleAckermannGeometryDataMAccuracyPN5physx30PxVehicleAckermannGeometryDataEf: __Z42setPxVehicleAckermannGeometryDataMAccuracyPN5physx30PxVehicleAckermannGeometryDataEf, __ZN9WWWCached7GetDataEv: __ZN9WWWCached7GetDataEv, __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j: __ZNK5physx20PxClothGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j, __ZN13SpeedTreeWind8TransferI14SafeBinaryReadEEvRT_: __ZN13SpeedTreeWind8TransferI14SafeBinaryReadEEvRT_, __ZN20UnityConnectSettings15SetTestEventUrlE8UnityStr: __ZN20UnityConnectSettings15SetTestEventUrlE8UnityStr, __ZL36CollectAndProduceGameObjectHierarchyR9TransformPS_R10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS3_4pairIiiEEL18MemLabelIdentifier1ELi16EEE: __ZL36CollectAndProduceGameObjectHierarchyR9TransformPS_R10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS3_4pairIiiEEL18MemLabelIdentifier1ELi16EEE, __Z43Register_UnityEngine_Canvas_get_scaleFactorv: __Z43Register_UnityEngine_Canvas_get_scaleFactorv, __ZN5physx2Sc17ParticleSystemSimC2ERNS0_5SceneERNS0_18ParticleSystemCoreE: __ZN5physx2Sc17ParticleSystemSimC2ERNS0_5SceneERNS0_18ParticleSystemCoreE, __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_10StartEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb1EE18handleProfileEventINS0_10StartEventEEEbRT_, __ZN5Umbra11ShadowUtils13getClipPlanesERKNS_9Matrix4x4EPNS_7Vector4ERb: __ZN5Umbra11ShadowUtils13getClipPlanesERKNS_9Matrix4x4EPNS_7Vector4ERb, __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE: __ZN8Material8GetColorEN9ShaderLab16FastPropertyNameE, __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN6IDList14SetSearchIndexEi: __ZN6IDList14SetSearchIndexEi, __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE: __ZN18ContactCapsuleMesh20processTriangleCacheILj16EEEbRN5physx2Gu13TriangleCacheIXT_EEE, __Z40AudioReverbFilter_Set_Custom_PropDensityP12Il2CppObjectf: __Z40AudioReverbFilter_Set_Custom_PropDensityP12Il2CppObjectf, __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setGravityERKNS_6PxVec3E, __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipVP12Il2CppObject: __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetFlipVP12Il2CppObject, _Direct_Move_Orig_X: _Direct_Move_Orig_X, _Direct_Move_Orig_Y: _Direct_Move_Orig_Y, __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E: __ZN28BucketPrunerOverlapTraversalI16OBBAABBTest_SIMDLb0EEclERKN5physx2Sq16BucketPrunerCoreERKS0_RNS3_14PrunerCallbackERKNS2_9PxBounds3E, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE19getConcreteTypeNameEv, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEj: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE10exceptionsEj, __ZN5physx8debugger14PvdMarshallingIjyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIjyE12marshalBlockEPKhPhj, __Z27getPxClothParticleInvWeightPKN5physx15PxClothParticleE: __Z27getPxClothParticleInvWeightPKN5physx15PxClothParticleE, __ZN12MeshRendererD2Ev: __ZN12MeshRendererD2Ev, __ZN5physx2Gu9RadixSort10SetBuffersEPjS2_S2_PS2_: __ZN5physx2Gu9RadixSort10SetBuffersEPjS2_S2_PS2_, __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode: __ZN11NamedObjectC2E10MemLabelId18ObjectCreationMode, __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj: __Z22SetMaterialVectorArrayP8MaterialN9ShaderLab16FastPropertyNameEP11Il2CppArrayj, __ZN11UnityEngine15PlatformWrapper26GetUnityAdsTrackingEnabledEv: __ZN11UnityEngine15PlatformWrapper26GetUnityAdsTrackingEnabledEv, __Z36RectOffset_Get_Custom_PropHorizontalP12Il2CppObject: __Z36RectOffset_Get_Custom_PropHorizontalP12Il2CppObject, __Z64Register_UnityEngine_RectTransform_INTERNAL_get_anchoredPositionv: __Z64Register_UnityEngine_RectTransform_INTERNAL_get_anchoredPositionv, __Z27EdgeCollider2D_CUSTOM_ResetP12Il2CppObject: __Z27EdgeCollider2D_CUSTOM_ResetP12Il2CppObject, __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_11PxDebugLineENS0_19ReflectionAllocatorIS2_EEE19resizeUninitializedEj, _wordfree: _wordfree, __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE: __ZN5physx2Sc21ArticulationJointCore12setDriveTypeENS_28PxArticulationJointDriveType4EnumE, __ZN14dtPathCorridor25moveOverOffmeshConnectionEyPfS0_PK14dtNavMeshQuery: __ZN14dtPathCorridor25moveOverOffmeshConnectionEyPfS0_PK14dtNavMeshQuery, __Z41Register_UnityEngine_Texture_set_wrapModev: __Z41Register_UnityEngine_Texture_set_wrapModev, __ZN5physx34PxVehicleEngineDataGeneratedValuesC2EPKNS_19PxVehicleEngineDataE: __ZN5physx34PxVehicleEngineDataGeneratedValuesC2EPKNS_19PxVehicleEngineDataE, __ZNK13GfxDeviceGLES27GetActiveRenderColorSurfaceEi: __ZNK13GfxDeviceGLES27GetActiveRenderColorSurfaceEi, __ZN5Unity14CharacterJoint15ThreadedCleanupEv: __ZN5Unity14CharacterJoint15ThreadedCleanupEv, __ZNKSt3__219__shared_weak_count13__get_deleterERKSt9type_info: __ZNKSt3__219__shared_weak_count13__get_deleterERKSt9type_info, __ZN2UI6Canvas25GetRootWorldToLocalMatrixEv: __ZN2UI6Canvas25GetRootWorldToLocalMatrixEv, __ZN5physx12PxConvexMeshD0Ev: __ZN5physx12PxConvexMeshD0Ev, __Z44Quaternion_CUSTOM_INTERNAL_CALL_LookRotationRK8Vector3fS1_R11Quaternionf: __Z44Quaternion_CUSTOM_INTERNAL_CALL_LookRotationRK8Vector3fS1_R11Quaternionf, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__rEv, __ZN13WheelCollider7SetMassEf: __ZN13WheelCollider7SetMassEf, __ZZL32InitializeModule_ParticlesLegacyvEN16cleanupAfterLoad7ForwardEv: __ZZL32InitializeModule_ParticlesLegacyvEN16cleanupAfterLoad7ForwardEv, _XXH64_canonicalFromHash: _XXH64_canonicalFromHash, __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimit10updateNodeEv: __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimit10updateNodeEv, _UNITY_png_destroy_write_struct: _UNITY_png_destroy_write_struct, _dummy1: _dummy1, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj159ENS_22PxRepXPropertyAccessorILj159ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj159ENS_22PxRepXPropertyAccessorILj159ES4_ffEEEEvRKT0_, __ZN8Animator17SetAvatarRotationERK11Quaternionf: __ZN8Animator17SetAvatarRotationERK11Quaternionf, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXv, __ZN5physx5cloth11BoundingBoxI8Scalar4fEC2ERKS3_: __ZN5physx5cloth11BoundingBoxI8Scalar4fEC2ERKS3_, __ZN5physx18PxcArticulationRef16propagateImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE: __ZN5physx18PxcArticulationRef16propagateImpulseERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERNS_6PxVec3ERKNS_2Cm13SpatialVectorERKNS_11PxcFsRowAuxE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE15indexedPropertyILj155ES4_NS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigENS_33PxClothStretchConfigGeneratedInfoEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKT3_, __ZN2UI6Canvas17RemoveFromManagerEv: __ZN2UI6Canvas17RemoveFromManagerEv, __ZN11UnityEngine15CloudWebService19SessionEventManager35CheckAndSetupActiveSessionContainerEv: __ZN11UnityEngine15CloudWebService19SessionEventManager35CheckAndSetupActiveSessionContainerEv, __ZNK5physx2Gu11HeightField9getHeightEff: __ZNK5physx2Gu11HeightField9getHeightEff, __ZN7mecanim9animation16EvaluateAvatarIKEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb: __ZN7mecanim9animation16EvaluateAvatarIKEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb, __ZN9profiling14SamplerManager15RegisterSamplerEP19ProfilerInformation: __ZN9profiling14SamplerManager15RegisterSamplerEP19ProfilerInformation, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN10AudioMixer24SetOutputAudioMixerGroupERK4PPtrI15AudioMixerGroupE: __ZN10AudioMixer24SetOutputAudioMixerGroupERK4PPtrI15AudioMixerGroupE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIjEEEvRT_17TransferMetaFlags, __Z39SystemInfo_Get_Custom_PropProcessorTypev: __Z39SystemInfo_Get_Custom_PropProcessorTypev, __Z41Register_UnityEngine_Light_set_cookieSizev: __Z41Register_UnityEngine_Light_set_cookieSizev, __Z14PxToRaycastHitRKN5physx10PxSweepHitER10RaycastHit: __Z14PxToRaycastHitRKN5physx10PxSweepHitER10RaycastHit, _UNITY_png_set_cHRM_XYZ_fixed: _UNITY_png_set_cHRM_XYZ_fixed, __ZN12_GLOBAL__N_111StreamOwnerD0Ev: __ZN12_GLOBAL__N_111StreamOwnerD0Ev, __ZNSt3__215__num_get_floatIdEET_PKcS3_Rj: __ZNSt3__215__num_get_floatIdEET_PKcS3_Rj, __ZN5Umbra4Math4atanENS_5FloatE: __ZN5Umbra4Math4atanENS_5FloatE, __ZN13TextRendering17SetITextRenderingEPNS_14ITextRenderingE: __ZN13TextRendering17SetITextRenderingEPNS_14ITextRenderingE, __ZN26PlayerSettingsSplashScreen36GetSplashScreenBackgroundPortraitUvsEv: __ZN26PlayerSettingsSplashScreen36GetSplashScreenBackgroundPortraitUvsEv, __Z44Register_UnityEngine_GameObject_GetComponentv: __Z44Register_UnityEngine_GameObject_GetComponentv, __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE21writeArticulationLinkEPKNS_18PxArticulationLinkE: __ZN5physx2Sn17RepXVisitorWriterINS_14PxArticulationEE21writeArticulationLinkEPKNS_18PxArticulationLinkE, __ZN9Rigidbody27SetMaxDepenetrationVelocityEf: __ZN9Rigidbody27SetMaxDepenetrationVelocityEf, _tt_cmap10_validate: _tt_cmap10_validate, __ZN5physx23NpParticleFluidReadData18setDataAccessFlagsENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx23NpParticleFluidReadData18setDataAccessFlagsENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv, __Z44UnityWebRequest_Get_Custom_PropRedirectLimitP12Il2CppObject: __Z44UnityWebRequest_Get_Custom_PropRedirectLimitP12Il2CppObject, _feclearexcept: _feclearexcept, __ZNSt3__220__codecvt_utf8_utf16IDiED0Ev: __ZNSt3__220__codecvt_utf8_utf16IDiED0Ev, __ZN16PxOverflowBufferIN5physx10PxSweepHitEE13finalizeQueryEv: __ZN16PxOverflowBufferIN5physx10PxSweepHitEE13finalizeQueryEv, __ZN11BoxCollider16TransformChangedEi: __ZN11BoxCollider16TransformChangedEi, __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE4findIS6_EENS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEERKT_: __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE4findIS6_EENS_15__tree_iteratorIS6_PNS_11__tree_nodeIS6_PvEEiEERKT_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindEPKwjj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEE15growAndPushBackERKS2_, __ZNK5physx6PxVec4miERKS0_: __ZNK5physx6PxVec4miERKS0_, __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVES2_S2_S2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_8CapsuleVES2_S2_S2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_fb, __ZN14SerializedFile12ReadMetadataILb1EEEbijPKhjj: __ZN14SerializedFile12ReadMetadataILb1EEEbijPKhjj, __ZN5physx8debugger4comm17StringHandleEvent9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm17StringHandleEvent9serializeERNS1_15EventSerializerE, __ZN23CloudWebServicesManager15ThreadedCleanupEv: __ZN23CloudWebServicesManager15ThreadedCleanupEv, __ZN5physx2Sn18writeAllPropertiesINS_15PxParticleFluidEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_15PxParticleFluidEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __Z29StdTemplateConversionFunctionIisEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIisEbPvR14SafeBinaryRead, __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerERKNS_7NpShapeE: __ZN5physx14NpShapeManager18teardownSceneQueryERNS_2Sq17SceneQueryManagerERKNS_7NpShapeE, __Z60Register_UnityEngine_PlatformEffector2D_get_rotationalOffsetv: __Z60Register_UnityEngine_PlatformEffector2D_get_rotationalOffsetv, __Z42Register_UnityEngine_Shader_DisableKeywordv: __Z42Register_UnityEngine_Shader_DisableKeywordv, __Z18Transfer_BlittableI9JSONWriteLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47Physics_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK8Vector3fS1_P11Il2CppArrayRK11Quaternionfi23QueryTriggerInteraction: __Z47Physics_CUSTOM_INTERNAL_CALL_OverlapBoxNonAllocRK8Vector3fS1_P11Il2CppArrayRK11Quaternionfi23QueryTriggerInteraction, __ZN9ShaderLab20SerializedSubProgram11SetKeywordsERKNSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEENS6_IS8_EEEE: __ZN9ShaderLab20SerializedSubProgram11SetKeywordsERKNSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEENS6_IS8_EEEE, __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj: __ZN5physx2Sc10NPhaseCore16onOverlapCreatedEPKNS_20PxvBroadPhaseOverlapEjj, __ZN9GfxDevice17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv: __ZN9GfxDevice17SetComputeUniformE12ObjectHandleI18ComputeProgram_TagPvER18ComputeShaderParamjPKv, __ZN19SkinnedMeshRenderer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19SkinnedMeshRenderer8TransferI24GenerateTypeTreeTransferEEvRT_, __Z29getPxClothFabricPhaseSetIndexPKN5physx18PxClothFabricPhaseE: __Z29getPxClothFabricPhaseSetIndexPKN5physx18PxClothFabricPhaseE, __Z18Transfer_BlittableI9JSONWriteLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK4PPtrIN5Unity9ComponentEEcvPS1_Ev: __ZNK4PPtrIN5Unity9ComponentEEcvPS1_Ev, __ZN15QualitySettings13ApplySettingsEib: __ZN15QualitySettings13ApplySettingsEib, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN17GeneralConnection13WaitForFinishEv: __ZN17GeneralConnection13WaitForFinishEv, __Z33getPxArticulationJoint_TwistLimitPKN5physx19PxArticulationJointERfS3_: __Z33getPxArticulationJoint_TwistLimitPKN5physx19PxArticulationJointERfS3_, __Z47RenderTexture_CUSTOM_INTERNAL_CALL_GenerateMipsP12Il2CppObject: __Z47RenderTexture_CUSTOM_INTERNAL_CALL_GenerateMipsP12Il2CppObject, __ZN5physx8debugger19PropertyDescriptionD0Ev: __ZN5physx8debugger19PropertyDescriptionD0Ev, __ZNK11b2GearJoint10GetAnchorAEv: __ZNK11b2GearJoint10GetAnchorAEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv, __ZN15QualitySettings17SetSoftVegetationEb: __ZN15QualitySettings17SetSoftVegetationEb, __ZN5physx3Scb4Body18putToSleepInternalEv: __ZN5physx3Scb4Body18putToSleepInternalEv, __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI17ProceduralTextureE13stl_allocatorIS3_L18MemLabelIdentifier77ELi16EEE8__appendEj, __ZN5physx3Cct26CharacterControllerManager14getControllersEv: __ZN5physx3Cct26CharacterControllerManager14getControllersEv, __ZN4math4Axes8TransferI8BlobSizeEEvRT_: __ZN4math4Axes8TransferI8BlobSizeEEvRT_, __ZN7VRInput20UpdateTrackedDevicesEv: __ZN7VRInput20UpdateTrackedDevicesEv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getMotionConstraintBiasEv, __ZN12NavMeshAgent15ThreadedCleanupEv: __ZN12NavMeshAgent15ThreadedCleanupEv, __ZN11AudioModule19UpdateVideoTexturesEv: __ZN11AudioModule19UpdateVideoTexturesEv, __ZN5physx15PxGetGroupsMaskERKNS_7PxActorE: __ZN5physx15PxGetGroupsMaskERKNS_7PxActorE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE15growAndPushBackERKS2_, _UNITY_FT_List_Add: _UNITY_FT_List_Add, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER17RemapPPtrTransfer, __Z27RegisterModuleClasses_Umbrav: __Z27RegisterModuleClasses_Umbrav, __ZN13FileEntryDataC2ERKS_: __ZN13FileEntryDataC2ERKS_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z35BillboardAsset_Get_Custom_PropWidthP12Il2CppObject: __Z35BillboardAsset_Get_Custom_PropWidthP12Il2CppObject, __Z39SetContentModificationDateToCurrentTimeRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z39SetContentModificationDateToCurrentTimeRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx3Ext23computeBoxInertiaTensorERNS_6PxVec3Effff: __ZN5physx3Ext23computeBoxInertiaTensorERNS_6PxVec3Effff, __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13TrailRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN18PlatformEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx14PxsAABBManager4initEPNS_13PxvBroadPhaseE: __ZN5physx14PxsAABBManager4initEPNS_13PxvBroadPhaseE, __ZNK12NavMeshAgent13IsPathPartialEv: __ZNK12NavMeshAgent13IsPathPartialEv, __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeIPc15compare_tstringIPKcENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZN8VRDevice19GetSupportedDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE: __ZN8VRDevice19GetSupportedDevicesERNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEE, __ZN12WheelJoint2D5ResetEv: __ZN12WheelJoint2D5ResetEv, __ZN5Unity11AdjTriangle14OppositeVertexEjj: __ZN5Unity11AdjTriangle14OppositeVertexEjj, __Z59Register_UnityEngine_WebGLInput_get_captureAllKeyboardInputv: __Z59Register_UnityEngine_WebGLInput_get_captureAllKeyboardInputv, __ZN27UnloadUnusedAssetsOperation7PerformEv: __ZN27UnloadUnusedAssetsOperation7PerformEv, __Z44UnityConnectSettings_Set_Custom_PropTestModeh: __Z44UnityConnectSettings_Set_Custom_PropTestModeh, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN13TriggerModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13TriggerModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z26getPxAggregate_MaxNbActorsPKN5physx11PxAggregateE: __Z26getPxAggregate_MaxNbActorsPKN5physx11PxAggregateE, __ZNKSt3__215__codecvt_utf16IwLb1EE13do_max_lengthEv: __ZNKSt3__215__codecvt_utf16IwLb1EE13do_max_lengthEv, __ZN12MeshCollider9SetConvexEb: __ZN12MeshCollider9SetConvexEb, __Z49Register_UnityEngine_Screen_get_currentResolutionv: __Z49Register_UnityEngine_Screen_get_currentResolutionv, __ZN5physx2Sn13XmlNodeReader4readEPKcRS3_: __ZN5physx2Sn13XmlNodeReader4readEPKcRS3_, __ZN5physx2Sc9ClothCore21removeCollisionSphereEj: __ZN5physx2Sc9ClothCore21removeCollisionSphereEj, __Z93Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddDirectionalLightInternalv: __Z93Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_AddDirectionalLightInternalv, __ZNK5physx23PxsBroadPhaseContextSap18getNumDeletedPairsEv: __ZNK5physx23PxsBroadPhaseContextSap18getNumDeletedPairsEv, __ZN5Umbra10QueryState10setWorkMemEPhj: __ZN5Umbra10QueryState10setWorkMemEPhj, __ZN16BaseVideoTexture6ResumeEv: __ZN16BaseVideoTexture6ResumeEv, __Z36Matrix4x4_CUSTOM_INTERNAL_CALL_OrthoffffffR10Matrix4x4f: __Z36Matrix4x4_CUSTOM_INTERNAL_CALL_OrthoffffffR10Matrix4x4f, __ZN5physx14SapPairManager7AddPairEjjh: __ZN5physx14SapPairManager7AddPairEjjh, __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EE11ClassIDTypez: __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EE11ClassIDTypez, __ZNK5physx16PxSphericalJoint8isKindOfEPKc: __ZNK5physx16PxSphericalJoint8isKindOfEPKc, __Z34Animator_Get_Custom_PropParametersP12Il2CppObject: __Z34Animator_Get_Custom_PropParametersP12Il2CppObject, __Z23getPxScene_FrictionTypePKN5physx7PxSceneE: __Z23getPxScene_FrictionTypePKN5physx7PxSceneE, _UNITY_FT_Bitmap_Embolden: _UNITY_FT_Bitmap_Embolden, __Z45Register_UnityEngine_Transform_set_hasChangedv: __Z45Register_UnityEngine_Transform_set_hasChangedv, __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing1Limitv: __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing1Limitv, __Z39TrailRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf: __Z39TrailRenderer_Set_Custom_PropStartWidthP12Il2CppObjectf, __ZN17BillboardRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17BillboardRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN20GpuProgramParameters21UpdateParamBufferSizeEv: __ZN20GpuProgramParameters21UpdateParamBufferSizeEv, __GLOBAL__sub_I_UnityWebStream_cpp: __GLOBAL__sub_I_UnityWebStream_cpp, __Z29VRDevice_Get_Custom_PropModelv: __Z29VRDevice_Get_Custom_PropModelv, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEED0Ev, __ZN7mecanim9animation28MotionOutputGetDeltaRotationEPKNS0_12MotionOutputE: __ZN7mecanim9animation28MotionOutputGetDeltaRotationEPKNS0_12MotionOutputE, __ZN13MonoBehaviour33AddImageEffectCallbacksToManagersEv: __ZN13MonoBehaviour33AddImageEffectCallbacksToManagersEv, __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI6SpriteE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z49Register_UnityEngine_Mesh_GetArrayFromChannelImplv: __Z49Register_UnityEngine_Mesh_GetArrayFromChannelImplv, _open_wmemstream: _open_wmemstream, __Z71Register_UnityEngine_Networking_DownloadHandler_InternalCreateAudioClipv: __Z71Register_UnityEngine_Networking_DownloadHandler_InternalCreateAudioClipv, __ZN5physx2Sn5ConvX6read32ERPKv: __ZN5physx2Sn5ConvX6read32ERPKv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj175ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z43CanvasRenderer_Set_Custom_PropMaterialCountP12Il2CppObjecti: __Z43CanvasRenderer_Set_Custom_PropMaterialCountP12Il2CppObjecti, __ZN17Physics2DSettings10SetGravityERK8Vector2f: __ZN17Physics2DSettings10SetGravityERK8Vector2f, __ZN6Shader28DeleteDefaultShaderLabShaderEv: __ZN6Shader28DeleteDefaultShaderLabShaderEv, __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI14SplatPrototypeNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZN9JSONWrite8TransferIN11UnityEngine9Analytics15UserCustomEvent12CustomParamsEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIN11UnityEngine9Analytics15UserCustomEvent12CustomParamsEEEvRT_PKc17TransferMetaFlags, __ZN5physx7NpScene19addArticulationLinkERNS_18NpArticulationLinkE: __ZN5physx7NpScene19addArticulationLinkERNS_18NpArticulationLinkE, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __ZN5physx7NpCloth25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE: __ZN5physx7NpCloth25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE, __ZNK5physx7NpCloth10isSleepingEv: __ZNK5physx7NpCloth10isSleepingEv, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __ZN5physx19PxsFluidSpatialHash20updatePacketSectionsEPjPNS_16PxsFluidParticleEPNS_10PxBaseTaskE: __ZN5physx19PxsFluidSpatialHash20updatePacketSectionsEPjPNS_16PxsFluidParticleEPNS_10PxBaseTaskE, __ZN16TimerQueriesGLES17BeginTimerQueriesEv: __ZN16TimerQueriesGLES17BeginTimerQueriesEv, __ZN5physx23PxsBroadPhaseContextSap13postUpdatePPUEPNS_10PxBaseTaskE: __ZN5physx23PxsBroadPhaseContextSap13postUpdatePPUEPNS_10PxBaseTaskE, __ZN2UI16PointInRectangleERK8Vector2fPNS_13RectTransformEP6Camera: __ZN2UI16PointInRectangleERK8Vector2fPNS_13RectTransformEP6Camera, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx5cloth11SwCollisionI8Scalar4fEclERKNS0_14IterationStateIS2_EE: __ZN5physx5cloth11SwCollisionI8Scalar4fEclERKNS0_14IterationStateIS2_EE, __Z28Display_CUSTOM_SetParamsImpl13Il2Cpp_IntPtriiii: __Z28Display_CUSTOM_SetParamsImpl13Il2Cpp_IntPtriiii, __Z5BlackP9Texture2DPhiiii: __Z5BlackP9Texture2DPhiiii, __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17PackedFloatVector8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE14getOwnerClientEv: __ZNK5physx15NpActorTemplateINS_18PxArticulationLinkEE14getOwnerClientEv, __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity5Joint16JointTransferPreI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_: __ZN5Unity10HingeJoint20WriteStateOnNewJointERKN5physx11PxTransformES4_, __ZNK5physx7NpActor12getAggregateEv: __ZNK5physx7NpActor12getAggregateEv, __Z52Register_UnityEngine_Transform_INTERNAL_set_positionv: __Z52Register_UnityEngine_Transform_INTERNAL_set_positionv, __ZN14AvatarPlayback9NextIndexEi: __ZN14AvatarPlayback9NextIndexEi, __ZN24ConvexVsHeightfieldSweepD2Ev: __ZN24ConvexVsHeightfieldSweepD2Ev, __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr: __ZN19CloudServiceHandler20RestoreDataFileAsyncERK8UnityStr, __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetModev: __Z65Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetModev, _cff_driver_done: _cff_driver_done, __ZNK19CharacterController31ArePropertiesValidExplainErrorsEv: __ZNK19CharacterController31ArePropertiesValidExplainErrorsEv, __Z42Animation_Set_Custom_PropPlayAutomaticallyP12Il2CppObjecth: __Z42Animation_Set_Custom_PropPlayAutomaticallyP12Il2CppObjecth, __ZN9Rigidbody9SweepTestERK8Vector3ff23QueryTriggerInteractionR10RaycastHit: __ZN9Rigidbody9SweepTestERK8Vector3ff23QueryTriggerInteractionR10RaycastHit, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERt: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERt, __Z33AndroidJNI_CUSTOM_GetBooleanField13Il2Cpp_IntPtrS_: __Z33AndroidJNI_CUSTOM_GetBooleanField13Il2Cpp_IntPtrS_, __Z36AudioSettings_Get_Custom_PropDspTimev: __Z36AudioSettings_Get_Custom_PropDspTimev, __ZN6Camera12RenderSkyboxEv: __ZN6Camera12RenderSkyboxEv, __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE: __ZN30RuntimeInitializeOnLoadManager23ExecuteInitializeOnLoadENSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier12ELi16EEEE, __ZNK5Umbra9Matrix4x3eqERKS0_: __ZNK5Umbra9Matrix4x3eqERKS0_, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12resize_deltaEjj, __ZN13AnimationClip8GetStatsER18AnimationClipStats: __ZN13AnimationClip8GetStatsER18AnimationClipStats, __ZN8keywords18KeywordSetToStringERK16ShaderKeywordSetR8UnityStr: __ZN8keywords18KeywordSetToStringERK16ShaderKeywordSetR8UnityStr, __Z13ClipAnimationR13AnimationClipS0_ffb: __Z13ClipAnimationR13AnimationClipS0_ffb, __Z26Camera_CUSTOM_SetupCurrentP12Il2CppObject: __Z26Camera_CUSTOM_SetupCurrentP12Il2CppObject, __ZL22CheckRedundantVerticesRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderES3_S3_: __ZL22CheckRedundantVerticesRjRN5physx2Gu9ContainerERKNS0_17ConvexHullBuilderES3_S3_, __Z29scripting_gc_collect_a_littlev: __Z29scripting_gc_collect_a_littlev, __ZN5Umbra9FloatListC2Ev: __ZN5Umbra9FloatListC2Ev, __Z47Register_UnityEngine_Sprite_INTERNAL_get_borderv: __Z47Register_UnityEngine_Sprite_INTERNAL_get_borderv, __ZN7mecanim9animation21DestroyAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation21DestroyAvatarConstantEPNS0_14AvatarConstantERNS_6memory9AllocatorE, __Z23GetUnityConnectSettingsv: __Z23GetUnityConnectSettingsv, __ZN12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv: __ZN12_GLOBAL__N_111StreamOwner17getLoadedDataSizeEv, __ZN16RayRTreeCallbackILi0ELb1EED0Ev: __ZN16RayRTreeCallbackILi0ELb1EED0Ev, __ZN17ProceduralTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17ProceduralTexture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z18Transfer_BlittableI8JSONReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERy: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERy, _UNITY_FT_Vector_Transform_Scaled: _UNITY_FT_Vector_Transform_Scaled, __ZN12InputManager15HasAxisOrButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager15HasAxisOrButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK17ProceduralTexture13GetDataHeightEv: __ZNK17ProceduralTexture13GetDataHeightEv, _UNITY_png_get_color_type: _UNITY_png_get_color_type, __ZN5physx34PxClothTetherConfigGeneratedValuesC2EPKNS_19PxClothTetherConfigE: __ZN5physx34PxClothTetherConfigGeneratedValuesC2EPKNS_19PxClothTetherConfigE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6insertEjPKcj, _printf_console_log: _printf_console_log, __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_T_, __ZN10builtintex21ReinitBuiltinTexturesEv: __ZN10builtintex21ReinitBuiltinTexturesEv, __Z48Register_UnityEngine_Rigidbody_set_sleepVelocityv: __Z48Register_UnityEngine_Rigidbody_set_sleepVelocityv, __Z21setPxCloth_RestOffsetPN5physx7PxClothEf: __Z21setPxCloth_RestOffsetPN5physx7PxClothEf, __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimeUpdateModev: __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimeUpdateModev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoCountInternalv: __Z102Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoCountInternalv, __Z48ParticleAnimator_Set_Custom_PropDoesAnimateColorP12Il2CppObjecth: __Z48ParticleAnimator_Set_Custom_PropDoesAnimateColorP12Il2CppObjecth, __ZN10FileSystem16StaticInitializeEPv: __ZN10FileSystem16StaticInitializeEPv, __Z55Register_UnityEngine_CharacterController_get_stepOffsetv: __Z55Register_UnityEngine_CharacterController_get_stepOffsetv, __ZN14dtNavMeshQuery29finalizeSlicedFindPathPartialEPiPKyi: __ZN14dtNavMeshQuery29finalizeSlicedFindPathPartialEPiPKyi, __ZN12_GLOBAL__N_120RevoluteJointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_120RevoluteJointProjectEPKvRN5physx11PxTransformES4_b, __ZN8Animator19ValidateParameterIDE17GetSetValueResulti: __ZN8Animator19ValidateParameterIDE17GetSetValueResulti, __Z51NavMeshObstacle_Set_Custom_PropCarvingMoveThresholdP12Il2CppObjectf: __Z51NavMeshObstacle_Set_Custom_PropCarvingMoveThresholdP12Il2CppObjectf, __Z13RegisterClassI18AudioMixerSnapshotEvv: __Z13RegisterClassI18AudioMixerSnapshotEvv, __ZN8LODGroup15InitializeClassEv: __ZN8LODGroup15InitializeClassEv, __ZN16b2StackAllocator4FreeEPv: __ZN16b2StackAllocator4FreeEPv, __ZN10Collider2DD2Ev: __ZN10Collider2DD2Ev, __Z59ParticleSystem_CollisionModule_CUSTOM_GetMaxCollisionShapesP12Il2CppObject: __Z59ParticleSystem_CollisionModule_CUSTOM_GetMaxCollisionShapesP12Il2CppObject, __ZN14DataBufferGLES11CopySubDataEPKS_iii: __ZN14DataBufferGLES11CopySubDataEPKS_iii, __Z26InitClipMuscleAdditivePoseRN7mecanim9animation18ClipMuscleConstantES2_PN11UnityEngine9Animation20AnimationSetBindingsEfRNS_6memory9AllocatorE: __Z26InitClipMuscleAdditivePoseRN7mecanim9animation18ClipMuscleConstantES2_PN11UnityEngine9Animation20AnimationSetBindingsEfRNS_6memory9AllocatorE, __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_13PxClothFabricENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __Z24getPxD6Joint_SwingZAnglePKN5physx9PxD6JointE: __Z24getPxD6Joint_SwingZAnglePKN5physx9PxD6JointE, __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev: __ZN5physx34PxVehicleDriveDynDataGeneratedInfoC2Ev, __ZN5Umbra10PathFinderC2ERNS_12QueryContextE: __ZN5Umbra10PathFinderC2ERNS_12QueryContextE, __ZN7mecanim9animation14AvatarConstant8TransferI9BlobWriteEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI9BlobWriteEEvRT_, __ZNK26AnimatorOverrideController7GetClipE4PPtrI13AnimationClipEb: __ZNK26AnimatorOverrideController7GetClipE4PPtrI13AnimationClipEb, __ZN4FMOD7SystemI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW: __ZN4FMOD7SystemI11getSpectrumEPfii19FMOD_DSP_FFT_WINDOW, __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_7NpClothENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN4FMOD5Sound19setSubSoundSentenceEPii: __ZN4FMOD5Sound19setSubSoundSentenceEPii, _getopt_long_only: _getopt_long_only, __Z46CanvasRenderer_Set_Custom_PropPopMaterialCountP12Il2CppObjecti: __Z46CanvasRenderer_Set_Custom_PropPopMaterialCountP12Il2CppObjecti, __Z26setPxD6Joint_DrivePositionPN5physx9PxD6JointERKNS_11PxTransformE: __Z26setPxD6Joint_DrivePositionPN5physx9PxD6JointERKNS_11PxTransformE, __Z43Register_UnityEngine_VR_VRDevice_get_familyv: __Z43Register_UnityEngine_VR_VRDevice_get_familyv, __ZN23TransformChangeDispatch22GetSubSystemInterestedE15TransformAccess27TransformChangeSystemHandle: __ZN23TransformChangeDispatch22GetSubSystemInterestedE15TransformAccess27TransformChangeSystemHandle, __Z43AnimatorControllerPlayable_CUSTOM_SetBoolIDR9HPlayableih: __Z43AnimatorControllerPlayable_CUSTOM_SetBoolIDR9HPlayableih, _sha256crypt: _sha256crypt, __Z16PresentAfterDrawN9GfxDevice11PresentModeE: __Z16PresentAfterDrawN9GfxDevice11PresentModeE, __ZN19SpriteMeshGenerator4path8simplifyEfi: __ZN19SpriteMeshGenerator4path8simplifyEfi, __ZN12HandlerChain11HasFastHashERK13FileEntryDataR7Hash128: __ZN12HandlerChain11HasFastHashERK13FileEntryDataR7Hash128, __Z24RegisterStrippedTypeInfoI11TerrainDataEviPKcS2_: __Z24RegisterStrippedTypeInfoI11TerrainDataEviPKcS2_, __Z17IsStringValidUTF8PKhj: __Z17IsStringValidUTF8PKhj, __Z49Register_UnityEngine_AudioSource_get_dopplerLevelv: __Z49Register_UnityEngine_AudioSource_get_dopplerLevelv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZZN10GUIManager14InitGUIManagerEvEN36PreUpdateIMGUISendQueuedEventsstruct7ForwardEv: __ZZN10GUIManager14InitGUIManagerEvEN36PreUpdateIMGUISendQueuedEventsstruct7ForwardEv, __ZN4FMOD8ChannelI13set3DPanLevelEf: __ZN4FMOD8ChannelI13set3DPanLevelEf, __ZN13TranslateGLES21InitFramebufferTargetERK12GraphicsCaps: __ZN13TranslateGLES21InitFramebufferTargetERK12GraphicsCaps, __Z38Mesh_CUSTOM_GetBlendShapeFrameVerticesP12Il2CppObjectiiP11Il2CppArrayS2_S2_: __Z38Mesh_CUSTOM_GetBlendShapeFrameVerticesP12Il2CppObjectiiP11Il2CppArrayS2_S2_, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE6insertIPKiEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsIS9_E9referenceEEE5valueENS_11__wrap_iterIPiEEE4typeENSD_IS7_EES9_S9_, __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZNK5physx2Gu11HeightField19getTriangleVerticesEjjjRNS_6PxVec3ES3_S3_: __ZNK5physx2Gu11HeightField19getTriangleVerticesEjjjRNS_6PxVec3ES3_S3_, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_PKc17TransferMetaFlags, _getlogin: _getlogin, __Z13RegisterClassIN5Unity10FixedJointEEvv: __Z13RegisterClassIN5Unity10FixedJointEEvv, __ZN11UnityEngine15CloudWebService14DataDispatcher37PrepareSessionContainerForDispatchingERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher37PrepareSessionContainerForDispatchingERNS0_16SessionContainerE, __ZN9Heightmap13SetResolutionEi: __ZN9Heightmap13SetResolutionEi, __ZN9GfxDevice16ScheduleAsyncJobEPFvP21GfxDeviceAsyncCommandES1_R8JobFenceR18JobBatchDispatcher: __ZN9GfxDevice16ScheduleAsyncJobEPFvP21GfxDeviceAsyncCommandES1_R8JobFenceR18JobBatchDispatcher, __Z52Register_UnityEngine_TrailRenderer_set_colorGradientv: __Z52Register_UnityEngine_TrailRenderer_set_colorGradientv, __ZN19RuntimeSceneManager43UnloadAllScenesWithoutDestroyingGameObjectsEv: __ZN19RuntimeSceneManager43UnloadAllScenesWithoutDestroyingGameObjectsEv, __Z32getPxRigidDynamic_SleepThresholdPKN5physx14PxRigidDynamicE: __Z32getPxRigidDynamic_SleepThresholdPKN5physx14PxRigidDynamicE, __ZN13AnimationClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13AnimationClip23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13RendererScene15EndCameraRenderEv: __ZN13RendererScene15EndCameraRenderEv, __ZN15DirectorManager14ConnectionPool11ClearUnsafeEv: __ZN15DirectorManager14ConnectionPool11ClearUnsafeEv, __ZN2UI14CanvasRenderer8SetColorERK10ColorRGBAf: __ZN2UI14CanvasRenderer8SetColorERK10ColorRGBAf, __ZN11NamedObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11NamedObject23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12maybe_shrinkEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc10FilterPairENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfoP17VertexDeclarationEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier14ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, __Z50Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_P11Il2CppArrayfiff: __Z50Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastNonAllocRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_P11Il2CppArrayfiff, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj118ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj118ES3_RKNS_12PxFilterDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZL8Perlin3DRKN4math8floatNx3ERKf: __ZL8Perlin3DRKN4math8floatNx3ERKf, __ZN9Heightmap7SetSizeERK8Vector3f: __ZN9Heightmap7SetSizeERK8Vector3f, __ZN5physx3Cct10ControllerD0Ev: __ZN5physx3Cct10ControllerD0Ev, __ZNK5physx15PxVehicleWheels20computeSidewaysSpeedEv: __ZNK5physx15PxVehicleWheels20computeSidewaysSpeedEv, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE7getNameEv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZN39AssetBundleLoadFromStreamAsyncOperation20MoveFilesToCachePathEv: __ZN39AssetBundleLoadFromStreamAsyncOperation20MoveFilesToCachePathEv, __Z47AudioMixer_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject: __Z47AudioMixer_Get_Custom_PropOutputAudioMixerGroupP12Il2CppObject, __ZN17AudioReverbFilter15SetReverbPresetEi: __ZN17AudioReverbFilter15SetReverbPresetEi, __ZN5physx24PxMaterialRepXSerializerD0Ev: __ZN5physx24PxMaterialRepXSerializerD0Ev, __ZN5physx2Sq10FIFOStack23popERPNS0_12AABBTreeNodeES4_: __ZN5physx2Sq10FIFOStack23popERPNS0_12AABBTreeNodeES4_, __ZN13GfxDeviceNull17CreateRasterStateERK14GfxRasterState: __ZN13GfxDeviceNull17CreateRasterStateERK14GfxRasterState, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN24DownloadHandlerAudioClipD2Ev: __ZN24DownloadHandlerAudioClipD2Ev, __ZN16ParticleRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16ParticleRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignIPwEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr38__libcpp_string_gets_noexcept_iteratorIS9_EE5valueERS5_E4typeES9_S9_, __Z60Register_UnityEngine_Profiling_Profiler_GetRuntimeMemorySizev: __Z60Register_UnityEngine_Profiling_Profiler_GetRuntimeMemorySizev, __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE: __ZN5physx2Sc5Scene22removeBroadPhaseVolumeEjRNS0_8ShapeSimE, __Z19il2cpp_array_new_2djjP11Il2CppClass: __Z19il2cpp_array_new_2djjP11Il2CppClass, __ZNK5physx13NpClothFabric9getPhasesEPNS_18PxClothFabricPhaseEj: __ZNK5physx13NpClothFabric9getPhasesEPNS_18PxClothFabricPhaseEj, __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_14PxRigidDynamicEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZL16FMOD_ErrorString11FMOD_RESULT: __ZL16FMOD_ErrorString11FMOD_RESULT, __ZN13PhysicsModule25CreateNxMeshFromUnityMeshEP4MeshbbRK10Matrix4x4f13TransformTypef: __ZN13PhysicsModule25CreateNxMeshFromUnityMeshEP4MeshbbRK10Matrix4x4f13TransformTypef, __ZThn12_N5physx7NpShapeD1Ev: __ZThn12_N5physx7NpShapeD1Ev, __ZN19SpriteMeshGenerator4path6selectEv: __ZN19SpriteMeshGenerator4path6selectEv, __Z41Register_UnityEngine_GUIText_get_richTextv: __Z41Register_UnityEngine_GUIText_get_richTextv, __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalEiRK31LocalSerializedObjectIdentifierRi: __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalEiRK31LocalSerializedObjectIdentifierRi, __Z31getPxSceneLimitsMaxNbAggregatesPKN5physx13PxSceneLimitsE: __Z31getPxSceneLimitsMaxNbAggregatesPKN5physx13PxSceneLimitsE, __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15PointEffector2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z53Register_UnityEngine_Random_INTERNAL_get_onUnitSpherev: __Z53Register_UnityEngine_Random_INTERNAL_get_onUnitSpherev, __ZN13GfxDeviceGLES28SetComputeBufferCounterValueE15ComputeBufferIDj: __ZN13GfxDeviceGLES28SetComputeBufferCounterValueE15ComputeBufferIDj, __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetSizeAffectsRangev: __Z68Register_UnityEngine_ParticleSystem_LightsModule_GetSizeAffectsRangev, __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14BillboardAsset23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f: __ZN6Camera22SetWorldToCameraMatrixERK10Matrix4x4f, __ZN4FMOD7SystemI11getDSPClockEPjS1_: __ZN4FMOD7SystemI11getDSPClockEPjS1_, __ZN15AnchoredJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15AnchoredJoint2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetShapeTypev: __Z60Register_UnityEngine_ParticleSystem_ShapeModule_GetShapeTypev, __ZN6b2DrawD0Ev: __ZN6b2DrawD0Ev, __ZN4PPtrI6CameraE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI6CameraE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z24RegisterStrippedTypeInfoI7TextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI7TextureEviPKcS2_, __Z35GUIUtility_Get_Custom_PropMouseUsedv: __Z35GUIUtility_Get_Custom_PropMouseUsedv, __Z60Register_UnityEngine_Mesh_PrintErrorCantAccessMeshForIndicesv: __Z60Register_UnityEngine_Mesh_PrintErrorCantAccessMeshForIndicesv, __ZN5physx7profile21NullEventNameProviderD0Ev: __ZN5physx7profile21NullEventNameProviderD0Ev, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4crnd10dxt1_block10pack_colorERKNS_10color_quadIhiEEbj: __ZN4crnd10dxt1_block10pack_colorERKNS_10color_quadIhiEEbj, __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb: __ZN15ResourceManager19PreloadDependenciesEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEEb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj419ENS_22PxRepXPropertyAccessorILj419ENS_7PxJointEffEEEEvRKT0_, __ZN14ParticleSystem12EndUpdateAllEv: __ZN14ParticleSystem12EndUpdateAllEv, __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20ParticleSystemModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN8VRDevice21RequestReloadVRDeviceERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb: __ZN8VRDevice21RequestReloadVRDeviceERKNSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEb, __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii: __ZN7ApiGLES16CopyTextureImageEj16TextureDimensionN2gl9TexFormatEiiiiijS0_S2_iiiiiiiiii, __ZN14CachingManagerC2Ev: __ZN14CachingManagerC2Ev, _cff_property_get: _cff_property_get, __ZN4FMOD6SoundI19get3DMinMaxDistanceEPfS1_: __ZN4FMOD6SoundI19get3DMinMaxDistanceEPfS1_, __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags, __ZN5Unity5Cloth16SetEnabledFadingEbf: __ZN5Unity5Cloth16SetEnabledFadingEbf, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZNK8Renderer14GetSubsetIndexEi: __ZNK8Renderer14GetSubsetIndexEi, __ZNK15NavMeshObstacle21GetWorldCenterAndAxesER8Vector3fS1_S1_S1_: __ZNK15NavMeshObstacle21GetWorldCenterAndAxesER8Vector3fS1_S1_S1_, __ZN4UNET16ScriptingUpdater18ClearUpdatePointerEv: __ZN4UNET16ScriptingUpdater18ClearUpdatePointerEv, __ZN25ShadowMapJobHeaderScratchD0Ev: __ZN25ShadowMapJobHeaderScratchD0Ev, __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv: __ZN19SkinnedMeshRenderer27CreateCachedAnimatorBindingEv, __ZN9GfxDevice30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb: __ZN9GfxDevice30ResolveComputeProgramResourcesE12ObjectHandleI18ComputeProgram_TagPvER19ComputeShaderKernelRNSt3__26vectorI15ComputeShaderCBNS6_9allocatorIS8_EEEERNS7_I18ComputeShaderParamNS9_ISD_EEEEb, __ZN5physx29PxvRegisterLegacyHeightFieldsEv: __ZN5physx29PxvRegisterLegacyHeightFieldsEv, __ZN17SurfaceEffector2D13SetForceScaleEf: __ZN17SurfaceEffector2D13SetForceScaleEf, __ZN11NoiseModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11NoiseModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14PhysicsManager23SetSleepAngularVelocityEf: __ZN14PhysicsManager23SetSleepAngularVelocityEf, __Z58Register_UnityEngine_Cloth_INTERNAL_get_randomAccelerationv: __Z58Register_UnityEngine_Cloth_INTERNAL_get_randomAccelerationv, _destroy: _destroy, __ZN5physx2Sc5Scene21finishParticleSystemsEv: __ZN5physx2Sc5Scene21finishParticleSystemsEv, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5clearEv: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E5clearEv, __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputCountInternalv: __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputCountInternalv, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_, __ZNSt3__214collate_bynameIcED2Ev: __ZNSt3__214collate_bynameIcED2Ev, __ZN4Mesh25RebuildCollisionTrianglesEv: __ZN4Mesh25RebuildCollisionTrianglesEv, __ZN12_GLOBAL__N_110DataStream14addProfileZoneEPvPKc: __ZN12_GLOBAL__N_110DataStream14addProfileZoneEPvPKc, __ZN8Animator14StartRecordingEi: __ZN8Animator14StartRecordingEi, __ZN4FMOD7ReverbI7releaseEv: __ZN4FMOD7ReverbI7releaseEv, __Z63Register_UnityEngine_SceneManagement_Scene_GetRootCountInternalv: __Z63Register_UnityEngine_SceneManagement_Scene_GetRootCountInternalv, __ZN15PackedIntVector8PackIntsItEEvPT_i: __ZN15PackedIntVector8PackIntsItEEvPT_i, __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI10MonoScriptE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN8Material14SetVectorArrayEN9ShaderLab16FastPropertyNameEPK8Vector4fj: __ZN8Material14SetVectorArrayEN9ShaderLab16FastPropertyNameEPK8Vector4fj, __ZN3MBP9addObjectERK5IAABBjb: __ZN3MBP9addObjectERK5IAABBjb, __Z38HingeJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject: __Z38HingeJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject, __GLOBAL__sub_I_runtime_virtualfilesystem_lump_cpp: __GLOBAL__sub_I_runtime_virtualfilesystem_lump_cpp, __ZN7mecanim5human14BoneFromMuscleEi: __ZN7mecanim5human14BoneFromMuscleEi, __Z42Register_UnityEngine_Random_RandomRangeIntv: __Z42Register_UnityEngine_Random_RandomRangeIntv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI19StaticArrayTransferIKN4math7_float3ELi7EEEEvRT_17TransferMetaFlags, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z29setPxClothFabricPhaseSetIndexPN5physx18PxClothFabricPhaseEj: __Z29setPxClothFabricPhaseSetIndexPN5physx18PxClothFabricPhaseEj, __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc: __ZN14SplatMaterials19SetTemplateMaterialERK4PPtrI8MaterialEPPKc, __Z15IsInstanceValidP12Il2CppObject: __Z15IsInstanceValidP12Il2CppObject, __Z19MurmurHash3_x86_128PKvijPv: __Z19MurmurHash3_x86_128PKvijPv, __Z36Register_UnityEngine_Light_GetLightsv: __Z36Register_UnityEngine_Light_GetLightsv, _cff_slot_load: _cff_slot_load, __Z32GameObject_Get_Custom_PropActiveP12Il2CppObject: __Z32GameObject_Get_Custom_PropActiveP12Il2CppObject, __Z41GUIClip_CUSTOM_INTERNAL_CALL_Clip_Vector2R13Vector2fIcall: __Z41GUIClip_CUSTOM_INTERNAL_CALL_Clip_Vector2R13Vector2fIcall, __ZN7mecanim9animation21CreateBlendTreeOutputEjRNS_6memory9AllocatorE: __ZN7mecanim9animation21CreateBlendTreeOutputEjRNS_6memory9AllocatorE, __ZNK5physx20BigConvexDataBuilder7ComputeERKNS_15VALENCIESCREATEE: __ZNK5physx20BigConvexDataBuilder7ComputeERKNS_15VALENCIESCREATEE, __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __ZN12b2MouseJoint15SetDampingRatioEf: __ZN12b2MouseJoint15SetDampingRatioEf, __ZNK5physx17PxcNpMemBlockPool17getUsedBlockCountEv: __ZNK5physx17PxcNpMemBlockPool17getUsedBlockCountEv, __Z53Register_UnityEngine_AudioReverbZone_get_reverbPresetv: __Z53Register_UnityEngine_AudioReverbZone_get_reverbPresetv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__210__stdinbufIcE5uflowEv: __ZNSt3__210__stdinbufIcE5uflowEv, __ZN18CrashReportManagerD2Ev: __ZN18CrashReportManagerD2Ev, __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_S5_S5_T_, __Z40Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestP12Il2CppObjectRK8Vector3fP10RaycastHitf23QueryTriggerInteraction: __Z40Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestP12Il2CppObjectRK8Vector3fP10RaycastHitf23QueryTriggerInteraction, __ZN7ApiGLES21CreateGraphicsProgramEjjjjj: __ZN7ApiGLES21CreateGraphicsProgramEjjjjj, __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE: __ZN12SoundManager18IntegrateFMODSoundEPN11SoundHandle8InstanceERK16StreamedResourcejiN17SoundHandleShared9LoadStateE, __ZN5physx6shdfnd5ArrayINS_2Sn15HeightFieldDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn15HeightFieldDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZNK14DirectorPlayer17GetTimeUpdateModeEv: __ZNK14DirectorPlayer17GetTimeUpdateModeEv, __ZN10systeminfo14GetDeviceModelEv: __ZN10systeminfo14GetDeviceModelEv, __ZNK12NavMeshAgent25GetCurrentOffMeshLinkDataEP15OffMeshLinkData: __ZNK12NavMeshAgent25GetCurrentOffMeshLinkDataEP15OffMeshLinkData, __Z19FitCapsuleToExtentsPfS_PKf: __Z19FitCapsuleToExtentsPfS_PKf, __ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv: __ZNK21ScriptingObjectOfTypeI14ParticleSystemEptEv, __ZN10__cxxabiv112_GLOBAL__N_118parse_template_argINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_118parse_template_argINS0_2DbEEEPKcS4_S4_RT_, _abort_message: _abort_message, __ZN9dtNavMesh19getPolyFlagsAndAreaEyPjPh: __ZN9dtNavMesh19getPolyFlagsAndAreaEyPjPh, __ZN14AnimationState15SetClonedCurvesERS_: __ZN14AnimationState15SetClonedCurvesERS_, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE7setNameEPKc, __ZN10PngDecoderD2Ev: __ZN10PngDecoderD2Ev, __Z49Register_UnityEngine_WheelCollider_get_sprungMassv: __Z49Register_UnityEngine_WheelCollider_get_sprungMassv, __ZN22ProceduralMaterialData12CopyFromDataERKS_: __ZN22ProceduralMaterialData12CopyFromDataERKS_, __Z15BuildMuscleClipRK18MecanimClipBuilderRK21AnimationClipSettingsbRN11UnityEngine9Animation28AnimationClipBindingConstantERN7mecanim6memory9AllocatorE: __Z15BuildMuscleClipRK18MecanimClipBuilderRK21AnimationClipSettingsbRN11UnityEngine9Animation28AnimationClipBindingConstantERN7mecanim6memory9AllocatorE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofERKS5_j, __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode: __ZN12BaseRenderer16FlattenProbeDataERS_RK13TransformInfoRK17LightProbeContextR10RenderNode, __ZNKSt9bad_alloc4whatEv: __ZNKSt9bad_alloc4whatEv, __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeTorquev: __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeTorquev, ___fdopen: ___fdopen, __ZN17FileSystemHandler8IsLockedERK13FileEntryData: __ZN17FileSystemHandler8IsLockedERK13FileEntryData, __Z26NavMesh_CUSTOM_SetAreaCostif: __Z26NavMesh_CUSTOM_SetAreaCostif, _getservbyname_r: _getservbyname_r, __ZN12TreeDatabase17SetTreePrototypesERKNSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEE: __ZN12TreeDatabase17SetTreePrototypesERKNSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEE, __Z8EndsWithPKcjS0_j: __Z8EndsWithPKcjS0_j, __ZN9ShaderLab32FindBestMatchingShaderKeywordSetERK16ShaderKeywordSetRK13dynamic_arrayIS0_Lj4EEPS5_: __ZN9ShaderLab32FindBestMatchingShaderKeywordSetERK16ShaderKeywordSetRK13dynamic_arrayIS0_Lj4EEPS5_, __Z25setPxHeightFieldDescFlagsPN5physx17PxHeightFieldDescENS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEE: __Z25setPxHeightFieldDescFlagsPN5physx17PxHeightFieldDescENS_7PxFlagsINS_17PxHeightFieldFlag4EnumEtEE, __ZNK5physx19NpArticulationJoint12getStiffnessEv: __ZNK5physx19NpArticulationJoint12getStiffnessEv, __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram16TextureParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN33AssetBundleLoadFromAsyncOperation12GetDebugNameEv: __ZN33AssetBundleLoadFromAsyncOperation12GetDebugNameEv, __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi1ELb0EED0Ev, __ZN4FMOD7Channel14set3DOcclusionEff: __ZN4FMOD7Channel14set3DOcclusionEff, __ZN5Unity5Cloth13SetUseGravityEb: __ZN5Unity5Cloth13SetUseGravityEb, __ZN8UserList11SendMessageERK17MessageIdentifierR11MessageData: __ZN8UserList11SendMessageERK17MessageIdentifierR11MessageData, __ZN5physx8debugger15ForwardingArrayINS0_10NamedValueEED0Ev: __ZN5physx8debugger15ForwardingArrayINS0_10NamedValueEED0Ev, __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEj: __ZN5physx2Sc35ParticleElementRbElementInteraction10initializeEj, __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_, __ZN20IntermediateRenderer10UpdateAABBEv: __ZN20IntermediateRenderer10UpdateAABBEv, __ZN12AudioManager32ScriptBufferManagerIsInitializedEv: __ZN12AudioManager32ScriptBufferManagerIsInitializedEv, __Z16TransformIndicesPtPKvjjjjb: __Z16TransformIndicesPtPKvjjjjb, __ZN5Unity5JointD0Ev: __ZN5Unity5JointD0Ev, __Z31GetPhysics2DScriptingClassesPtrv: __Z31GetPhysics2DScriptingClassesPtrv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIjEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN5physx17PxcNpMemBlockPool23acquireConstraintMemoryEv: __ZN5physx17PxcNpMemBlockPool23acquireConstraintMemoryEv, __ZZN14PhysicsManager15InitializeClassEvEN28PreUpdatePhysicsUpdatestruct7ForwardEv: __ZZN14PhysicsManager15InitializeClassEvEN28PreUpdatePhysicsUpdatestruct7ForwardEv, __ZN5physx30PxHeightFieldDescGeneratedInfoC2Ev: __ZN5physx30PxHeightFieldDescGeneratedInfoC2Ev, __ZN27AnimationLayerMixerPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant: __ZN27AnimationLayerMixerPlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant, __ZN7mecanim12statemachine18StateMachineMemory8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI14SafeBinaryReadEEvRT_, __Z46Register_UnityEngine_Projector_set_aspectRatiov: __Z46Register_UnityEngine_Projector_set_aspectRatiov, __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_: __ZN11NamedObject8TransferI14SafeBinaryReadEEvRT_, __ZNK10FileSystem16CurrentDirectoryEv: __ZNK10FileSystem16CurrentDirectoryEv, __ZN5physx8debugger4comm11CreateClass9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm11CreateClass9serializeERNS1_15EventSerializerE, __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9UnityGUID8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z61Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoViewMatrixv: __Z61Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoViewMatrixv, __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_twistLimitSpringv: __Z65Register_UnityEngine_CharacterJoint_INTERNAL_get_twistLimitSpringv, __Z15SampleEulerHintR9TransformR13AnimationClipf: __Z15SampleEulerHintR9TransformR13AnimationClipf, __ZN5physx3Cct13BoxController8getSceneEv: __ZN5physx3Cct13BoxController8getSceneEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21TreeBinaryTreeBuilder15CalculateBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERKNS1_IN12TreeDatabase9PrototypeENS3_ISD_EEEERK8Vector3fSK_: __ZN21TreeBinaryTreeBuilder15CalculateBoundsERKNSt3__26vectorI12TreeInstanceNS0_9allocatorIS2_EEEERK13dynamic_arrayIjLj4EERKNS1_IN12TreeDatabase9PrototypeENS3_ISD_EEEERK8Vector3fSK_, __ZN12BaseRenderer12GetWorldAABBER4AABB: __ZN12BaseRenderer12GetWorldAABBER4AABB, __Z26GetContentModificationDateRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z26GetContentModificationDateRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN17UniqueIDGeneratorC2E10MemLabelId: __ZN17UniqueIDGeneratorC2E10MemLabelId, __ZN7Terrain15InitializeClassEv: __ZN7Terrain15InitializeClassEv, __Z13RegisterClassI8ColliderEvv: __Z13RegisterClassI8ColliderEvv, __ZN5physx2Gu37generateCapsuleBoxFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb: __ZN5physx2Gu37generateCapsuleBoxFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb, __Z48Playable_CUSTOM_INTERNAL_CALL_CanDestroyInternalR9HPlayable: __Z48Playable_CUSTOM_INTERNAL_CALL_CanDestroyInternalR9HPlayable, __Z54ParticleSystem_InheritVelocityModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z54ParticleSystem_InheritVelocityModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI20SphericalHarmonicsL2Lj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5epptrEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE5epptrEv, __ZNK12ShaderErrors9HasErrorsEv: __ZNK12ShaderErrors9HasErrorsEv, __ZN16Physics2DManager10BoxCastAllERK8Vector2fS2_fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager10BoxCastAllERK8Vector2fS2_fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE, __ZN4Mesh10SetNormalsEPK8Vector3fj: __ZN4Mesh10SetNormalsEPK8Vector3fj, _strtok: _strtok, __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK8Collider: __ZN14PhysicsManager37RemoveFromTriggerEnterCacheIfRequiredEPK8Collider, __ZN4FMOD5Sound12getSyncPointEiPP14FMOD_SYNCPOINT: __ZN4FMOD5Sound12getSyncPointEiPP14FMOD_SYNCPOINT, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale1Ef: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16setInvMassScale1Ef, _Project_y: _Project_y, _Project_x: _Project_x, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj523ENS_22PxRepXPropertyAccessorILj523ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleEngineDataEEEE14handleAccessorILj523ENS_22PxRepXPropertyAccessorILj523ES4_ffEEEEvRKT0_, __ZNK28RectTransformPropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE: __ZNK28RectTransformPropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE, __ZN16MemoryFileSystem5CloseER13FileEntryData: __ZN16MemoryFileSystem5CloseER13FileEntryData, __ZN5physx3Scb5Shape12setMaterialsEPKPNS_10PxMaterialEt: __ZN5physx3Scb5Shape12setMaterialsEPKPNS_10PxMaterialEt, __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb0EEEEvRT_, __ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle: __ZNK7dtCrowd17getAgentAnimationERK13dtCrowdHandle, __ZN5physx21PxcSweepCapsuleConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx21PxcSweepCapsuleConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN12MeshRenderer15InitializeClassEv: __ZN12MeshRenderer15InitializeClassEv, __Z73Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimeMultiplierv: __Z73Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimeMultiplierv, __ZN14b2CapsuleShape13SetByExtentsYEffRK6b2Vec2f: __ZN14b2CapsuleShape13SetByExtentsYEffRK6b2Vec2f, __Z42ParticleSystem_TrailModule_CUSTOM_SetRatioP12Il2CppObjectf: __Z42ParticleSystem_TrailModule_CUSTOM_SetRatioP12Il2CppObjectf, __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue: __ZN17PersistentManager34ExtractTimeSliceAwakeFromLoadQueueER27TimeSliceAwakeFromLoadQueue, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags, __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_set_limitsv: __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_set_limitsv, __ZN5physx2Sc24ConstraintProjectionTree19getConstraintStatusERKNS0_13ConstraintSimEPKNS0_7BodySimERPS5_RjSA_: __ZN5physx2Sc24ConstraintProjectionTree19getConstraintStatusERKNS0_13ConstraintSimEPKNS0_7BodySimERPS5_RjSA_, __ZN5physx10PxsContext20updateContactManagerEfPNS_10PxBaseTaskE: __ZN5physx10PxsContext20updateContactManagerEfPNS_10PxBaseTaskE, __ZN5physx20InternalTriangleMesh15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx20InternalTriangleMesh15importExtraDataERNS_24PxDeserializationContextE, __ZN5physx2Gu25PersistentContactManifold20reduceContactSegmentERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE: __ZN5physx2Gu25PersistentContactManifold20reduceContactSegmentERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE, __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim4hand8HandPose8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN23ParticleSystemParticles12array_resizeEj: __ZN23ParticleSystemParticles12array_resizeEj, _readv: _readv, __Z38Camera_Get_Custom_PropDepthTextureModeP12Il2CppObject: __Z38Camera_Get_Custom_PropDepthTextureModeP12Il2CppObject, _catgets: _catgets, __Z34RenderTexture_Get_Custom_PropDepthP12Il2CppObject: __Z34RenderTexture_Get_Custom_PropDepthP12Il2CppObject, __ZN5physx19NpArticulationJoint20setSwingLimitEnabledEb: __ZN5physx19NpArticulationJoint20setSwingLimitEnabledEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj154ES3_RKNS_29PxClothMotionConstraintConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj154ES3_RKNS_29PxClothMotionConstraintConfigES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_: __ZN12_GLOBAL__N_110DataStream11deriveClassERKN5physx8debugger14NamespacedNameES5_, __ZN26EnlightenSystemInformation8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN26EnlightenSystemInformation8TransferI24GenerateTypeTreeTransferEEvRT_, __Z35getPxParticleFluid_ConcreteTypeNamePKN5physx15PxParticleFluidE: __Z35getPxParticleFluid_ConcreteTypeNamePKN5physx15PxParticleFluidE, __ZN9GfxDevice20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace: __ZN9GfxDevice20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace, _UnityRegisterRenderingPlugin: _UnityRegisterRenderingPlugin, __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKiEEvRT_: __ZNSt3__26vectorIi13stl_allocatorIiL18MemLabelIdentifier85ELi16EEE21__push_back_slow_pathIKiEEvRT_, _cf2_getNominalWidthX: _cf2_getNominalWidthX, __ZN9Projector22SetupProjectorSettingsEP8MaterialR23ProjectorRenderSettings: __ZN9Projector22SetupProjectorSettingsEP8MaterialR23ProjectorRenderSettings, __Z49ParticleSystem_ShapeModule_CUSTOM_GetNormalOffsetP12Il2CppObject: __Z49ParticleSystem_ShapeModule_CUSTOM_GetNormalOffsetP12Il2CppObject, __ZN12AdsIdHandler29InvokeAllDelegateAndListenersEv: __ZN12AdsIdHandler29InvokeAllDelegateAndListenersEv, __ZN13RenderTexture23VirtualRedirectTransferER14SafeBinaryRead: __ZN13RenderTexture23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__227__insertion_sort_incompleteIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEbT0_S5_T_, __Z28Texture3D_CUSTOM_GetPixels32P12Il2CppObjecti: __Z28Texture3D_CUSTOM_GetPixels32P12Il2CppObjecti, __ZThn32_N22ParticleSystemRenderer19UpdateTransformInfoEv: __ZThn32_N22ParticleSystemRenderer19UpdateTransformInfoEv, __Z30WWW_Get_Custom_PropAssetBundleP12Il2CppObject: __Z30WWW_Get_Custom_PropAssetBundleP12Il2CppObject, __Z50ParticleSystem_CUSTOM_INTERNAL_get_startRotation3DP12Il2CppObjectP8Vector3f: __Z50ParticleSystem_CUSTOM_INTERNAL_get_startRotation3DP12Il2CppObjectP8Vector3f, __Z41setPxClothMotionConstraintConfigStiffnessPN5physx29PxClothMotionConstraintConfigEf: __Z41setPxClothMotionConstraintConfigStiffnessPN5physx29PxClothMotionConstraintConfigEf, __ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy: __ZN9dtNavMesh7addTileEPKhi11dtTileFlagsiPy, __ZN9Animation8SetClipsERKNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEE: __ZN9Animation8SetClipsERKNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEE, __ZN18AsyncUploadManager18ScheduleAsyncReadsEv: __ZN18AsyncUploadManager18ScheduleAsyncReadsEv, __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE: __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_8DebugBoxE, __Z37Register_UnityEngine_GUIText_set_textv: __Z37Register_UnityEngine_GUIText_set_textv, __Z51Register_UnityEngine_Material_GetFloatArrayImplListv: __Z51Register_UnityEngine_Material_GetFloatArrayImplListv, __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall: __Z66ParticleSystem_RotationBySpeedModule_CUSTOM_INTERNAL_CALL_GetRangeP12Il2CppObjectR13Vector2fIcall, __Z57Register_UnityEngine_SurfaceEffector2D_set_speedVariationv: __Z57Register_UnityEngine_SurfaceEffector2D_set_speedVariationv, __ZNKSt3__28numpunctIcE16do_thousands_sepEv: __ZNKSt3__28numpunctIcE16do_thousands_sepEv, __Z63Register_UnityEngine_Physics2D_INTERNAL_set_colliderAsleepColorv: __Z63Register_UnityEngine_Physics2D_INTERNAL_set_colliderAsleepColorv, __ZN5Umbra11PatchWriter5patchEPKviS2_S2_: __ZN5Umbra11PatchWriter5patchEPKviS2_S2_, __ZN9Behaviour10LateUpdateEv: __ZN9Behaviour10LateUpdateEv, __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_: __ZN7Hash1288TransferI14SafeBinaryReadEEvRT_, __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv: __Z49AndroidJNI_CUSTOM_INTERNAL_CALL_GetStaticMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv, __ZN5physx15NpActorTemplateINS_7PxClothEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx15NpActorTemplateINS_7PxClothEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj: __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj, _Project: _Project, __ZN9Texture2D26AllocateScaledOrPaddedDataE13TextureFormat: __ZN9Texture2D26AllocateScaledOrPaddedDataE13TextureFormat, __ZN12VertexWelderILi2048EE4PushERK8Vector3f: __ZN12VertexWelderILi2048EE4PushERK8Vector3f, __ZNK5physx14NpSceneQueries7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE: __ZNK5physx14NpSceneQueries7overlapERKNS_10PxGeometryERKNS_11PxTransformERNS_13PxHitCallbackINS_12PxOverlapHitEEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackE, __ZN15LocationService18IsHeadingAvailableEv: __ZN15LocationService18IsHeadingAvailableEv, __ZNK21LightProbeProxyVolume24GetSHCoefficientsTextureEv: __ZNK21LightProbeProxyVolume24GetSHCoefficientsTextureEv, __ZN5physx6shdfnd5ArrayINS0_4PairIPNS_6PxBaseEyEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS0_4PairIPNS_6PxBaseEyEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN5physx2Sc5Scene27scheduleParticleDynamicsCpuERNS_10PxBaseTaskE: __ZN5physx2Sc5Scene27scheduleParticleDynamicsCpuERNS_10PxBaseTaskE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj171ENS_22PxRepXPropertyAccessorILj171ENS_14PxParticleBaseERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN15FrictionJoint2DD2Ev: __ZN15FrictionJoint2DD2Ev, __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_: __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE14__erase_uniqueIS4_EEjRKT_, __ZN22BuiltinResourceManager23AreResourcesInitializedEv: __ZN22BuiltinResourceManager23AreResourcesInitializedEv, __ZNSt3__218__insertion_sort_3IR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IR29ColliderHitsByDepthComparitorPP10Collider2DEEvT0_S6_T_, __Z28CompareBlendShapeVertexIndexRK16BlendShapeVertexS1_: __Z28CompareBlendShapeVertexIndexRK16BlendShapeVertexS1_, __ZN18PlatformEffector2D16CheckConsistencyEv: __ZN18PlatformEffector2D16CheckConsistencyEv, __ZN17GenericDynamicVBOD2Ev: __ZN17GenericDynamicVBOD2Ev, __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_8CapsuleVERKNS0_4BoxVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE, __ZN11b2GearJoint24SolvePositionConstraintsERK12b2SolverData: __ZN11b2GearJoint24SolvePositionConstraintsERK12b2SolverData, __Z41Register_UnityEngine_Object_set_hideFlagsv: __Z41Register_UnityEngine_Object_set_hideFlagsv, __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj: __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj, __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_: __ZN7mecanim8skeleton25SkeletonPoseComputeLocalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_, __Z50Register_UnityEngine_HingeJoint_INTERNAL_set_motorv: __Z50Register_UnityEngine_HingeJoint_INTERNAL_set_motorv, __ZN5Umbra9Matrix3x33detEv: __ZN5Umbra9Matrix3x33detEv, _UNITY_png_read_sig: _UNITY_png_read_sig, __ZN5physx2Gu9RadixSortD2Ev: __ZN5physx2Gu9RadixSortD2Ev, __ZN18AnimatorController19TransferRuntimeDataI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18AnimatorController19TransferRuntimeDataI19StreamedBinaryWriteILb0EEEEvRT_, __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectRK11Quaternionf: __Z43Rigidbody_CUSTOM_INTERNAL_CALL_MoveRotationP12Il2CppObjectRK11Quaternionf, __Z44PointEffector2D_Get_Custom_PropDistanceScaleP12Il2CppObject: __Z44PointEffector2D_Get_Custom_PropDistanceScaleP12Il2CppObject, __ZNK14RedirectHelper21GetRedirectsRemainingEv: __ZNK14RedirectHelper21GetRedirectsRemainingEv, __ZNK10__cxxabiv117__pbase_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv117__pbase_type_info9can_catchEPKNS_16__shim_type_infoERPv, __Z24PluginsSetGraphicsDevicePvi18GfxDeviceEventType: __Z24PluginsSetGraphicsDevicePvi18GfxDeviceEventType, __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx15PxSerialization27createSerializationRegistryERNS_9PxPhysicsE: __ZN5physx15PxSerialization27createSerializationRegistryERNS_9PxPhysicsE, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE26getRelativeAngularVelocityEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE26getRelativeAngularVelocityEv, __ZN13BoxCollider2D14CreateInternalEP11Rigidbody2D: __ZN13BoxCollider2D14CreateInternalEP11Rigidbody2D, __ZN2UI6Canvas19SyncTransformParentEv: __ZN2UI6Canvas19SyncTransformParentEv, __Z32RuntimeUndo_CUSTOM_RecordObjectsP11Il2CppArrayP12Il2CppString: __Z32RuntimeUndo_CUSTOM_RecordObjectsP11Il2CppArrayP12Il2CppString, __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc10NPhaseCore16ClothListElementENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __ZN11CullResults11InitDynamicEPK16RendererCullData: __ZN11CullResults11InitDynamicEPK16RendererCullData, _UNITY_LZ4_decompress_safe_withPrefix64k: _UNITY_LZ4_decompress_safe_withPrefix64k, __ZNK10GpuProgram11IsSupportedEv: __ZNK10GpuProgram11IsSupportedEv, __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToScreenPointv: __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ViewportToScreenPointv, __Z62ParticleSystem_MainModule_CUSTOM_SetRandomizeRotationDirectionP12Il2CppObjectf: __Z62ParticleSystem_MainModule_CUSTOM_SetRandomizeRotationDirectionP12Il2CppObjectf, __ZN20UnityConnectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20UnityConnectSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction7destroyEv: __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction7destroyEv, __ZN7ApiGLES23BindShaderStorageBufferEjj: __ZN7ApiGLES23BindShaderStorageBufferEjj, __ZN19ScriptingInvocation6InvokeIbEET_PP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeIbEET_PP15Il2CppExceptionb, __ZN7mecanim12statemachine13StateConstant15InitializeClassEv: __ZN7mecanim12statemachine13StateConstant15InitializeClassEv, __ZN5physx12_GLOBAL__N_115OverlapCallback6invokeERfPKNS_2Sq13PrunerPayloadEj: __ZN5physx12_GLOBAL__N_115OverlapCallback6invokeERfPKNS_2Sq13PrunerPayloadEj, __ZN14dtPathCorridor14SetPathPartialEb: __ZN14dtPathCorridor14SetPathPartialEb, __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN23iPhoneLocalNotification29SetApplicationIconBadgeNumberEi: __ZN23iPhoneLocalNotification29SetApplicationIconBadgeNumberEi, __ZN5physx2Sc15ArticulationSim10sleepCheckEffb: __ZN5physx2Sc15ArticulationSim10sleepCheckEffb, __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE: __ZN22BaseUnityConnectClientC2ERN11UnityEngine7Connect20BasePersistentValuesE, __ZNK9Rigidbody20GetWorldCenterOfMassEv: __ZNK9Rigidbody20GetWorldCenterOfMassEv, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z40Register_UnityEngine_Input_GetButtonDownv: __Z40Register_UnityEngine_Input_GetButtonDownv, __Z59Register_UnityEngine_Transform_INTERNAL_CALL_TransformPointv: __Z59Register_UnityEngine_Transform_INTERNAL_CALL_TransformPointv, __ZN9Scripting19ScriptingObjectNULLEP11Il2CppClass: __ZN9Scripting19ScriptingObjectNULLEP11Il2CppClass, __ZN6Avatar23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Avatar23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN19CullingGroupManagerC2Ev: __ZN19CullingGroupManagerC2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj31ENS_22PxRepXPropertyAccessorILj31ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8GUIStyle13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j, __ZN13PhysicsModule20IsRigidBodyKinematicERK9Rigidbody: __ZN13PhysicsModule20IsRigidBodyKinematicERK9Rigidbody, __ZN4crnd12symbol_codec8get_bitsEj: __ZN4crnd12symbol_codec8get_bitsEj, __ZN20TextRenderingPrivate8TextMesh7SetFontE4PPtrIN13TextRendering4FontEE: __ZN20TextRenderingPrivate8TextMesh7SetFontE4PPtrIN13TextRendering4FontEE, __ZN17GameObjectManager16StaticInitializeEv: __ZN17GameObjectManager16StaticInitializeEv, __ZNKSt3__27codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_: __ZNKSt3__27codecvtIcc11__mbstate_tE5do_inERS1_PKcS5_RS5_PcS7_RS7_, __Z26Transfer_UnityEngineObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__216generic_categoryEv: __ZNSt3__216generic_categoryEv, __ZN4FMOD8ChannelI11getWaveDataEPfii: __ZN4FMOD8ChannelI11getWaveDataEPfii, __Z41Register_UnityEngine_Component_CompareTagv: __Z41Register_UnityEngine_Component_CompareTagv, __ZN17PolygonCollider2D20ValidatePolygonShapeEPK6b2Vec2i: __ZN17PolygonCollider2D20ValidatePolygonShapeEPK6b2Vec2i, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED0Ev: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEED0Ev, __ZN5physx26PxSerializerDefaultAdapterINS_14NpArticulationEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_14NpArticulationEED0Ev, __ZN15ConstantForce2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15ConstantForce2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN23ShaderVariantCollection10ShaderInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN23ShaderVariantCollection10ShaderInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, _term_destination: _term_destination, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIfEES4_S4_S4_RNS_8ios_baseERjRT_, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetXMultiplierP12Il2CppObject, __Z15JobQueueCreatedv: __Z15JobQueueCreatedv, __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_zDriveP12Il2CppObjectRK10JointDrive: __Z44ConfigurableJoint_CUSTOM_INTERNAL_set_zDriveP12Il2CppObjectRK10JointDrive, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEEclILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11getNbShapesEv: __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11getNbShapesEv, __Z24GetAudioScriptingClassesv: __Z24GetAudioScriptingClassesv, __ZN13GfxDeviceGLES15SetImageTextureE9TextureIDi: __ZN13GfxDeviceGLES15SetImageTextureE9TextureIDi, _drand48: _drand48, __ZN5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEED0Ev, __ZN5physx2Sc7BodySim12updateForcesEffbRKNS_6PxVec3Ebb: __ZN5physx2Sc7BodySim12updateForcesEffbRKNS_6PxVec3Ebb, __Z38SliderJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth: __Z38SliderJoint2D_Set_Custom_PropUseLimitsP12Il2CppObjecth, __ZN12_GLOBAL__N_121SocketNetworkInStream7releaseEv: __ZN12_GLOBAL__N_121SocketNetworkInStream7releaseEv, __ZN15ReflectionProbe7SetModeENS_4ModeE: __ZN15ReflectionProbe7SetModeENS_4ModeE, __ZN4FMOD3DSP9getBypassEPb: __ZN4FMOD3DSP9getBypassEPb, __Z48Register_UnityEngine_TextGenerator_get_lineCountv: __Z48Register_UnityEngine_TextGenerator_get_lineCountv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __Z52QualitySettings_Get_Custom_PropParticleRaycastBudgetv: __Z52QualitySettings_Get_Custom_PropParticleRaycastBudgetv, __ZN26DownloadHandlerAssetBundle7OnAbortEv: __ZN26DownloadHandlerAssetBundle7OnAbortEv, __ZN20TextRenderingPrivate7GUITextC2E10MemLabelId18ObjectCreationMode: __ZN20TextRenderingPrivate7GUITextC2E10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN39AssetBundleLoadFromStreamAsyncOperationD0Ev: __ZN39AssetBundleLoadFromStreamAsyncOperationD0Ev, ___cxx_global_var_init6: ___cxx_global_var_init6, ___cxx_global_var_init7: ___cxx_global_var_init7, __ZN11UnityEngine15PlatformWrapper25GetDeviceUniqueIdentifierEv: __ZN11UnityEngine15PlatformWrapper25GetDeviceUniqueIdentifierEv, ___cxx_global_var_init1: ___cxx_global_var_init1, ___cxx_global_var_init2: ___cxx_global_var_init2, ___cxx_global_var_init3: ___cxx_global_var_init3, __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE18__construct_at_endINS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESH_SH_j: __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE18__construct_at_endINS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESH_SH_j, __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN7Cubemap23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, ___cxx_global_var_init8: ___cxx_global_var_init8, ___cxx_global_var_init9: ___cxx_global_var_init9, __ZN14SerializedFile6RetainEv: __ZN14SerializedFile6RetainEv, __ZN5physx2Gu5RTree17validateRecursiveEjNS0_10RTreeNodeQEPNS0_9RTreePageE: __ZN5physx2Gu5RTree17validateRecursiveEjNS0_10RTreeNodeQEPNS0_9RTreePageE, __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_6vectorIiNS4_IiEEEE: __ZN17PersistentManager20GetInstanceIDsAtPathERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPNS0_6vectorIiNS4_IiEEEE, __ZN21BoxTraceSegmentReportD0Ev: __ZN21BoxTraceSegmentReportD0Ev, __Z41Register_UnityEngine_Terrain_SetNeighborsv: __Z41Register_UnityEngine_Terrain_SetNeighborsv, __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIhEEvRT_PKc17TransferMetaFlagsb, __Z24RegisterStrippedTypeInfoI12NavMeshAgentEviPKcS2_: __Z24RegisterStrippedTypeInfoI12NavMeshAgentEviPKcS2_, __ZNSt14overflow_errorD0Ev: __ZNSt14overflow_errorD0Ev, __ZN13UnityProfiler18SerializeFrameDataER17ProfilerFrameDataR13dynamic_arrayIiLj4EE: __ZN13UnityProfiler18SerializeFrameDataER17ProfilerFrameDataR13dynamic_arrayIiLj4EE, __ZN13SpringJoint2D15SetDampingRatioEf: __ZN13SpringJoint2D15SetDampingRatioEf, __ZN5physx12_GLOBAL__N_111diagonalizeEPPNS_14Px1DConstraintERKNS0_9MassPropsE: __ZN5physx12_GLOBAL__N_111diagonalizeEPPNS_14Px1DConstraintERKNS0_9MassPropsE, __Z28GUI_CUSTOM_BringWindowToBacki: __Z28GUI_CUSTOM_BringWindowToBacki, __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj: __ZN5physx2Gu29ConvexVsMeshContactGeneration15processTriangleEPKNS_6PxVec3EjhPKj, __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_9TriangleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE, __ZN9Rigidbody10IsSleepingEv: __ZN9Rigidbody10IsSleepingEv, __ZN4FMOD7Channel13getLoopPointsEPjjS1_j: __ZN4FMOD7Channel13getLoopPointsEPjjS1_j, __Z46PhysicMaterial_Set_Custom_PropDynamicFriction2P12Il2CppObjectf: __Z46PhysicMaterial_Set_Custom_PropDynamicFriction2P12Il2CppObjectf, __ZN11BoxCollider10SmartResetEv: __ZN11BoxCollider10SmartResetEv, _cf2_hintmap_insertHint: _cf2_hintmap_insertHint, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI16HeightMeshBVNodeLj4EEEEvRT_17TransferMetaFlags, __ZNKSt3__217moneypunct_bynameIwLb0EE13do_neg_formatEv: __ZNKSt3__217moneypunct_bynameIwLb0EE13do_neg_formatEv, __Z46Animator_Get_Custom_PropLinearVelocityBlendingP12Il2CppObject: __Z46Animator_Get_Custom_PropLinearVelocityBlendingP12Il2CppObject, __ZN17AnimationPlayable13AddObjectUserER8UserList: __ZN17AnimationPlayable13AddObjectUserER8UserList, __ZN5physx12NpConstraint20getExternalReferenceERj: __ZN5physx12NpConstraint20getExternalReferenceERj, __ZN22BaseUnityConnectClient7IsStateENS_5StateE: __ZN22BaseUnityConnectClient7IsStateENS_5StateE, __ZN4gles30InitRenderTextureFormatSupportEP7ApiGLESP12GraphicsCaps: __ZN4gles30InitRenderTextureFormatSupportEP7ApiGLESP12GraphicsCaps, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv, __ZNK5physx7NpShape18getCapsuleGeometryERNS_17PxCapsuleGeometryE: __ZNK5physx7NpShape18getCapsuleGeometryERNS_17PxCapsuleGeometryE, __Z81Register_UnityEngine_Experimental_Director_Playables_BeginIgnoreAllocationTrackerv: __Z81Register_UnityEngine_Experimental_Director_Playables_BeginIgnoreAllocationTrackerv, __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI15DetailPrototypeNS_9allocatorIS1_EEE8__appendEj, __ZN5Umbra15PortalRayTracer12initTraverseERKNS_10PortalNodeE: __ZN5Umbra15PortalRayTracer12initTraverseERKNS_10PortalNodeE, __ZN12_GLOBAL__N_117createClothFabricERN5physx13PxInputStreamE: __ZN12_GLOBAL__N_117createClothFabricERN5physx13PxInputStreamE, __ZN14RenderSettings14ApplyFogParamsEv: __ZN14RenderSettings14ApplyFogParamsEv, __Z49Register_UnityEngine_Rigidbody_get_sleepThresholdv: __Z49Register_UnityEngine_Rigidbody_get_sleepThresholdv, __ZL31GetAndClearChangedTransformsJobP27GetChangedTransformsJobDataPK23TransformAccessReadOnlyj: __ZL31GetAndClearChangedTransformsJobP27GetChangedTransformsJobDataPK23TransformAccessReadOnlyj, __ZN12MeshCollider12ScaleChangedEv: __ZN12MeshCollider12ScaleChangedEv, __ZL9SetUvRectP6SpriteR5RectTIfE: __ZL9SetUvRectP6SpriteR5RectTIfE, __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED2Ev, __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_: __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawLineRK8Vector3fS1_, __Z13GetLocalEuler15TransformAccessN4math13RotationOrderE: __Z13GetLocalEuler15TransformAccessN4math13RotationOrderE, __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b: __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_b, __ZN13AnimationClip13AwakeFromLoadE17AwakeFromLoadMode: __ZN13AnimationClip13AwakeFromLoadE17AwakeFromLoadMode, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E15insert_noresizeERKSA_: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E15insert_noresizeERKSA_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv, __ZL19PreDestroyRecursiveR10GameObjectPj: __ZL19PreDestroyRecursiveR10GameObjectPj, __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj: __ZN7mecanim8skeleton16SkeletonFindNodeEPKNS0_8SkeletonEj, __ZN5physx7profile15ZoneManagerImpl14addProfileZoneERNS_13PxProfileZoneE: __ZN5physx7profile15ZoneManagerImpl14addProfileZoneERNS_13PxProfileZoneE, ___ftello: ___ftello, __ZN5physx3Cct10Controller18filterTouchedShapeERKNS_19PxControllerFiltersE: __ZN5physx3Cct10Controller18filterTouchedShapeERKNS_19PxControllerFiltersE, __Z50Register_UnityEngine_AndroidJNI_GetStringUTFLengthv: __Z50Register_UnityEngine_AndroidJNI_GetStringUTFLengthv, __ZN5physx6shdfnd13ReadWriteLock12unlockWriterEv: __ZN5physx6shdfnd13ReadWriteLock12unlockWriterEv, __ZN10Matrix3x3f6InvertEv: __ZN10Matrix3x3f6InvertEv, __ZThn8_N5physx2Sc18TriggerInteractionD1Ev: __ZThn8_N5physx2Sc18TriggerInteractionD1Ev, __ZNK5physx2Gu11HeightField24getTriangleMaterialIndexEj: __ZNK5physx2Gu11HeightField24getTriangleMaterialIndexEj, __ZN10Effector2D18SetUseColliderMaskEb: __ZN10Effector2D18SetUseColliderMaskEb, __ZNKSt13bad_exception4whatEv: __ZNKSt13bad_exception4whatEv, __ZN5physx2Gu13RTreeMidphaseD2Ev: __ZN5physx2Gu13RTreeMidphaseD2Ev, __Z54Register_UnityEngine_AudioReverbFilter_set_roomRolloffv: __Z54Register_UnityEngine_AudioReverbFilter_set_roomRolloffv, __ZN13GfxDeviceGLES21RegisterNativeTextureE9TextureIDi16TextureDimension: __ZN13GfxDeviceGLES21RegisterNativeTextureE9TextureIDi16TextureDimension, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ev: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ev, __ZNKSt3__215__codecvt_utf16IwLb0EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_: __ZNKSt3__215__codecvt_utf16IwLb0EE6do_outER11__mbstate_tPKwS5_RS5_PcS7_RS7_, __ZN19GfxThreadableDeviceD0Ev: __ZN19GfxThreadableDeviceD0Ev, __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb: __ZN5physx2Sc19ShapeInstancePairLL15managerNewTouchEjb, _wcswcs: _wcswcs, __ZN18LoadSceneOperation31CompletePreloadManagerLoadSceneEv: __ZN18LoadSceneOperation31CompletePreloadManagerLoadSceneEv, __ZN9SubModule14SubEmitterData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9SubModule14SubEmitterData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer32TransferSTLStyleArrayWithElementINSt3__24pairIiN19AssetBundleManifest15AssetBundleInfoEEEEEvRT_17TransferMetaFlags, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags, __ZNK5Umbra9UnionFindIjE8getIndexERKj: __ZNK5Umbra9UnionFindIjE8getIndexERKj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12InputManager12ProcessInputEv: __ZN12InputManager12ProcessInputEv, __ZNK7Texture16GetNpotTexelSizeEv: __ZNK7Texture16GetNpotTexelSizeEv, __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j: __ZNK5physx20PxShapeGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEEEEjT_j, __Z48SystemInfo_Get_Custom_PropDeviceUniqueIdentifierv: __Z48SystemInfo_Get_Custom_PropDeviceUniqueIdentifierv, __ZN5physx2Sc9ClothCore13onOriginShiftERKNS_6PxVec3E: __ZN5physx2Sc9ClothCore13onOriginShiftERKNS_6PxVec3E, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE14getAngularDragEv, __Z37Animator_Get_Custom_PropGravityWeightP12Il2CppObject: __Z37Animator_Get_Custom_PropGravityWeightP12Il2CppObject, __ZN17GeneralConnection27UnregisterConnectionHandlerEPFvjE: __ZN17GeneralConnection27UnregisterConnectionHandlerEPFvjE, __ZN5physx3Cct26CharacterControllerManager39setPreventVerticalSlidingAgainstCeilingEb: __ZN5physx3Cct26CharacterControllerManager39setPreventVerticalSlidingAgainstCeilingEb, __ZN9Coroutine3RunEPb: __ZN9Coroutine3RunEPb, __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetVelocityP12Il2CppObjectP8Vector3f: __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetVelocityP12Il2CppObjectP8Vector3f, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj399ENS_22PxRepXPropertyAccessorILj399ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEE14handleAccessorILj399ENS_22PxRepXPropertyAccessorILj399ES4_ffEEEEvRKT0_, __Z32Mesh_Get_Custom_PropSubMeshCountP12Il2CppObject: __Z32Mesh_Get_Custom_PropSubMeshCountP12Il2CppObject, __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z20GetFirstValueForARGVRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14LineParametersD0Ev: __ZN14LineParametersD0Ev, __ZN5physx20updateCellsSubpacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleEPKNS_15PxsParticleCellEPKjjRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersE: __ZN5physx20updateCellsSubpacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleEPKNS_15PxsParticleCellEPKjjRKNS_26PxsFluidDynamicsParametersERNS_27PxsFluidDynamicsTempBuffersE, __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN14DirectorPlayer12AddToManagerEv: __ZN14DirectorPlayer12AddToManagerEv, _UNITY_png_read_finish_row: _UNITY_png_read_finish_row, __ZN13BuildSettings16GetScenePathNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13BuildSettings16GetScenePathNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN15TerrainCollider12ScaleChangedEv: __ZN15TerrainCollider12ScaleChangedEv, __Z43UnityLogWriter_CUSTOM_WriteStringToUnityLogP12Il2CppString: __Z43UnityLogWriter_CUSTOM_WriteStringToUnityLogP12Il2CppString, __ZN5physx2Sc8ShapeSim16onMaterialChangeEv: __ZN5physx2Sc8ShapeSim16onMaterialChangeEv, __ZN11dtNodeQueue8bubbleUpEiP6dtNode: __ZN11dtNodeQueue8bubbleUpEiP6dtNode, __Z45getNbPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataE: __Z45getNbPxVehicleWheelsSimData_WheelShapeMappingPKN5physx22PxVehicleWheelsSimDataE, __ZN15QualitySettings19SetShadowProjectionE16ShadowProjection: __ZN15QualitySettings19SetShadowProjectionE16ShadowProjection, __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv: __ZNK15PolynomialCurve26FindMinMaxDoubleIntegratedEv, __ZN10AudioMixer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10AudioMixer8TransferI24GenerateTypeTreeTransferEEvRT_, __Z27RegisterModule_UnityConnectv: __Z27RegisterModule_UnityConnectv, __Z26InitializePhysicsManager2Dv: __Z26InitializePhysicsManager2Dv, __Z33setPxArticulationJoint_SwingLimitPN5physx19PxArticulationJointEff: __Z33setPxArticulationJoint_SwingLimitPN5physx19PxArticulationJointEff, __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_S6_T_, __ZNSt3__210moneypunctIwLb1EED0Ev: __ZNSt3__210moneypunctIwLb1EED0Ev, __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv: __ZN11UnityEngine15PlatformWrapper27GetGraphicsCapsSupportFlagsEv, __ZN11TypeManager21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb: __ZN11TypeManager21FindAllDerivedClassesE11ClassIDTypeR13dynamic_arrayIS0_Lj4EEb, __Z41getPxArticulationJoint_InternalCompliancePKN5physx19PxArticulationJointE: __Z41getPxArticulationJoint_InternalCompliancePKN5physx19PxArticulationJointE, __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_4lessIN22BuiltinResourceManager8ResourceEEEPS3_EEvT0_S7_T_, __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedField13Il2Cpp_IntPtrS_hRPv: __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_ToReflectedField13Il2Cpp_IntPtrS_hRPv, __ZN13GfxDeviceNull16DeleteTimerQueryEP13GfxTimerQuery: __ZN13GfxDeviceNull16DeleteTimerQueryEP13GfxTimerQuery, __ZN19StreamedBinaryWriteILb0EE8TransferI13TrailRendererEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI13TrailRendererEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEE6getDirEv, __Z40ParticleSystem_Get_Custom_PropStartSpeedP12Il2CppObject: __Z40ParticleSystem_Get_Custom_PropStartSpeedP12Il2CppObject, __ZN9Transform26CalculateSupportedMessagesEv: __ZN9Transform26CalculateSupportedMessagesEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj78ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj78ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj182ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9Projector15InitializeClassEv: __ZN9Projector15InitializeClassEv, __ZN5Unity5Cloth17SetSleepThresholdEf: __ZN5Unity5Cloth17SetSleepThresholdEf, __Z31Profiler_CUSTOM_BeginSampleOnlyP12Il2CppString: __Z31Profiler_CUSTOM_BeginSampleOnlyP12Il2CppString, __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEED2Ev: __ZN10ObjectPoolIN4FMOD6ReverbENS0_7ReverbIEED2Ev, __Z48ParticleSystem_MainModule_CUSTOM_SetMaxParticlesP12Il2CppObjecti: __Z48ParticleSystem_MainModule_CUSTOM_SetMaxParticlesP12Il2CppObjecti, __Z33__audio_mainthread_check_internalPKc: __Z33__audio_mainthread_check_internalPKc, __GLOBAL__sub_I_runtime_allocator2_lump_cpp: __GLOBAL__sub_I_runtime_allocator2_lump_cpp, __Z59Register_UnityEngine_Audio_AudioMixer_TransitionToSnapshotsv: __Z59Register_UnityEngine_Audio_AudioMixer_TransitionToSnapshotsv, __Z24PlayerLoadGlobalManagersPKcS0_j: __Z24PlayerLoadGlobalManagersPKcS0_j, __ZN13GfxDeviceGLES19SetProjectionMatrixERK10Matrix4x4f: __ZN13GfxDeviceGLES19SetProjectionMatrixERK10Matrix4x4f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj447ES3_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj447ES3_NS_7PxFlagsINS_19PxDistanceJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN14PhysicsManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14PhysicsManager8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx11HullLibrary7extrudeEPNS_3TriEi: __ZN5physx11HullLibrary7extrudeEPNS_3TriEi, __Z43LightmapSettings_Get_Custom_PropLightProbesv: __Z43LightmapSettings_Get_Custom_PropLightProbesv, __Z21GetVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z21GetVRDeviceDefinitionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14GfxDeviceStats15CopyClientStatsERKS_: __ZN14GfxDeviceStats15CopyClientStatsERKS_, __ZN15ParticleEmitter15ThreadedCleanupEv: __ZN15ParticleEmitter15ThreadedCleanupEv, __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetModev: __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetModev, __Z40BillboardAsset_Get_Custom_PropImageCountP12Il2CppObject: __Z40BillboardAsset_Get_Custom_PropImageCountP12Il2CppObject, __ZN5physx9NpFactoryC2Ev: __ZN5physx9NpFactoryC2Ev, __Z37Graphics_CUSTOM_Internal_BlitMaterialP12Il2CppObjectS0_S0_ih: __Z37Graphics_CUSTOM_Internal_BlitMaterialP12Il2CppObjectS0_S0_ih, __Z50Register_UnityEngine_CullingGroup_get_targetCamerav: __Z50Register_UnityEngine_CullingGroup_get_targetCamerav, __ZN20LocalFileSystemWebGL10AtomicMoveER13FileEntryDataS1_: __ZN20LocalFileSystemWebGL10AtomicMoveER13FileEntryDataS1_, __ZNK13b2CircleShape11ComputeMassEP10b2MassDataf: __ZNK13b2CircleShape11ComputeMassEP10b2MassDataf, __Z13InputShutdownv: __Z13InputShutdownv, __GLOBAL__sub_I_VRDevice_cpp: __GLOBAL__sub_I_VRDevice_cpp, __Z35AndroidJNI_CUSTOM_CallBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z35AndroidJNI_CUSTOM_CallBooleanMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN5Unity17ConfigurableJoint14SetLinearLimitERK14SoftJointLimit: __ZN5Unity17ConfigurableJoint14SetLinearLimitERK14SoftJointLimit, __Z39AndroidJNI_CUSTOM_CallStaticShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z39AndroidJNI_CUSTOM_CallStaticShortMethod13Il2Cpp_IntPtrS_P11Il2CppArray, _mkdirat: _mkdirat, __Z53Register_UnityEngine_Object_EnsureRunningOnMainThreadv: __Z53Register_UnityEngine_Object_EnsureRunningOnMainThreadv, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __Z67Register_UnityEngine_ParticleSystemRenderer_set_cameraVelocityScalev: __Z67Register_UnityEngine_ParticleSystemRenderer_set_cameraVelocityScalev, __Z31Object_CUSTOM_FindObjectsOfTypeP12Il2CppObject: __Z31Object_CUSTOM_FindObjectsOfTypeP12Il2CppObject, __Z29CullShadowCastersWithoutUmbraR9IndexListRK22SceneCullingParametersPK4AABBjj: __Z29CullShadowCastersWithoutUmbraR9IndexListRK22SceneCullingParametersPK4AABBjj, __ZN10Effector2D22ProcessPreSolveContactEbP10Collider2DS1_P9b2Contact: __ZN10Effector2D22ProcessPreSolveContactEbP10Collider2DS1_P9b2Contact, __Z39getPxParticleFluid_RestParticleDistancePKN5physx15PxParticleFluidE: __Z39getPxParticleFluid_RestParticleDistancePKN5physx15PxParticleFluidE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __ZNK15b2DistanceJoint10GetAnchorBEv: __ZNK15b2DistanceJoint10GetAnchorBEv, __Z37MaterialPropertyBlock_CUSTOM_SetFloatP12Il2CppObjectif: __Z37MaterialPropertyBlock_CUSTOM_SetFloatP12Il2CppObjectif, __Z19IsConsoleLogPathSetv: __Z19IsConsoleLogPathSetv, __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13ConstantForce23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv: __ZThn132_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19handleClientRemovedEv, __ZN26AnimatorControllerPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIPS_Lj4EE: __ZN26AnimatorControllerPlayable34CollectAnimatorControllerPlayablesER13dynamic_arrayIPS_Lj4EE, __ZN5physx3Cct13BoxController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE: __ZN5physx3Cct13BoxController4moveERKNS_6PxVec3EffRKNS_19PxControllerFiltersEPKNS_17PxObstacleContextE, __ZN18PlatformEffector2D10SetSideArcEf: __ZN18PlatformEffector2D10SetSideArcEf, __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetEnabledv: __Z65Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetEnabledv, __ZN11UnityEngine15PlatformWrapper12GetScreenDPIEv: __ZN11UnityEngine15PlatformWrapper12GetScreenDPIEv, __Z46Register_UnityEngine_AndroidJNI_SetDoubleFieldv: __Z46Register_UnityEngine_AndroidJNI_SetDoubleFieldv, __ZN4FMOD4DSPI9getOutputEiPPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD4DSPI9getOutputEiPPNS_3DSPEPPNS_13DSPConnectionE, __Z23translateToBufferTargetN14DataBufferGLES11BufferUsageE: __Z23translateToBufferTargetN14DataBufferGLES11BufferUsageE, __Z44MaterialPropertyBlock_Get_Custom_PropIsEmptyP12Il2CppObject: __Z44MaterialPropertyBlock_Get_Custom_PropIsEmptyP12Il2CppObject, __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiS0_iii: __ZN13GfxDeviceGLES11CopyTextureE9TextureIDiiiS0_iii, _tt_cmap4_next: _tt_cmap4_next, __ZN25PathNamePersistentManager24PathIDToPathNameInternalEi: __ZN25PathNamePersistentManager24PathIDToPathNameInternalEi, _jpeg_huff_decode: _jpeg_huff_decode, __ZNSt3__214__codecvt_utf8IDsED0Ev: __ZNSt3__214__codecvt_utf8IDsED0Ev, __Z38getPxVehicleDriveTank_ConcreteTypeNamePKN5physx18PxVehicleDriveTankE: __Z38getPxVehicleDriveTank_ConcreteTypeNamePKN5physx18PxVehicleDriveTankE, __ZN11Rigidbody2D18SetAngularVelocityEf: __ZN11Rigidbody2D18SetAngularVelocityEf, __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_: __ZNSt3__27__sort4IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEjT0_S9_S9_S9_T_, __ZN20ArchiveStorageHeader20GetDirectoryInfoSizeERKNS_13DirectoryInfoE: __ZN20ArchiveStorageHeader20GetDirectoryInfoSizeERKNS_13DirectoryInfoE, __Z49Register_UnityEngine_Camera_set_stereoConvergencev: __Z49Register_UnityEngine_Camera_set_stereoConvergencev, __ZN22BaseUnityConnectClient20QueueAppRunningEventEjjjj: __ZN22BaseUnityConnectClient20QueueAppRunningEventEjjjj, __ZN5physx2Sc16InteractionScene4initERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS7_13EventProfilerE: __ZN5physx2Sc16InteractionScene4initERKNS_11PxSceneDescEPNS_13PxTaskManagerEPNS_2Cm9FlushPoolERNS7_13EventProfilerE, __ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE: __ZN5physx2GuL18testSATCapsulePolyERKNS0_8CapsuleVERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSB_RNSA_5Vec3VE, __ZN18SpeedTreeWindAsset12CleanupClassEv: __ZN18SpeedTreeWindAsset12CleanupClassEv, __Z51Register_UnityEngine_AnimationClip_AddEventInternalv: __Z51Register_UnityEngine_AnimationClip_AddEventInternalv, __Z29SkipMipLevelsForTextureUploadi13TextureFormatiPPKhPiS3_S3_: __Z29SkipMipLevelsForTextureUploadi13TextureFormatiPPKhPiS3_S3_, __ZNK6Camera27GetImplicitProjectionMatrixEffffR10Matrix4x4f: __ZNK6Camera27GetImplicitProjectionMatrixEffffR10Matrix4x4f, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_4BoxVEED0Ev, __ZThn12_N5physx3Ext14PrismaticJointD1Ev: __ZThn12_N5physx3Ext14PrismaticJointD1Ev, __ZN14PlayerSettings17SetStackTraceTypeE7LogType17StackTraceLogType: __ZN14PlayerSettings17SetStackTraceTypeE7LogType17StackTraceLogType, __Z57Register_UnityEngine_Canvas_get_sortingGridNormalizedSizev: __Z57Register_UnityEngine_Canvas_get_sortingGridNormalizedSizev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim13ValueConstantEEEEvRT_17TransferMetaFlags, __Z45Register_UnityEngine_ReflectionProbe_get_typev: __Z45Register_UnityEngine_ReflectionProbe_get_typev, __Z28createPxPhysics_HeightFieldsPN5physx9PxPhysicsERNS_13PxInputStreamE: __Z28createPxPhysics_HeightFieldsPN5physx9PxPhysicsERNS_13PxInputStreamE, __ZN13MonoBehaviour17GetObjectGUIStateEv: __ZN13MonoBehaviour17GetObjectGUIStateEv, __ZN5physx20InternalTriangleMeshC2Ev: __ZN5physx20InternalTriangleMeshC2Ev, __ZN5physx2Gu21closestPtPointSegmentERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_: __ZN5physx2Gu21closestPtPointSegmentERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_RjRS3_S7_, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10getDampingEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE10getDampingEv, _seteuid: _seteuid, __ZN5physx2Gu12TriangleMeshD0Ev: __ZN5physx2Gu12TriangleMeshD0Ev, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE, __Z45Register_UnityEngine_Rigidbody_set_useGravityv: __Z45Register_UnityEngine_Rigidbody_set_useGravityv, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_8CapsuleVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_, __ZN12ScriptMapper23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12ScriptMapper23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN6Shader23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN6Shader23VirtualRedirectTransferER17RemapPPtrTransfer, __Z44AudioReverbFilter_Get_Custom_PropRoomRolloffP12Il2CppObject: __Z44AudioReverbFilter_Get_Custom_PropRoomRolloffP12Il2CppObject, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertEjRKS5_jj, __ZN20SpeedTreeWindManager11GetInstanceEv: __ZN20SpeedTreeWindManager11GetInstanceEv, __Z24RegisterStrippedTypeInfoI19AssetBundleManifestEviPKcS2_: __Z24RegisterStrippedTypeInfoI19AssetBundleManifestEviPKcS2_, _emit_dht: _emit_dht, __ZN18AwakeFromLoadQueue9IsInQueueER6Object: __ZN18AwakeFromLoadQueue9IsInQueueER6Object, __Z49setPxVehicleSuspensionDataMCamberAtMaxCompressionPN5physx23PxVehicleSuspensionDataEf: __Z49setPxVehicleSuspensionDataMCamberAtMaxCompressionPN5physx23PxVehicleSuspensionDataEf, __Z52Register_UnityEngine_AI_OffMeshLink_set_endTransformv: __Z52Register_UnityEngine_AI_OffMeshLink_set_endTransformv, __ZN11TimeManager15ThreadedCleanupEv: __ZN11TimeManager15ThreadedCleanupEv, __ZN13TrailRenderer16TransformChangedEi: __ZN13TrailRenderer16TransformChangedEi, __Z39Register_UnityEngine_Animation_GetStatev: __Z39Register_UnityEngine_Animation_GetStatev, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __Z24RegisterStrippedTypeInfoI18BuoyancyEffector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI18BuoyancyEffector2DEviPKcS2_, ___setrlimit: ___setrlimit, __ZNK5physx2Gu10ConvexMesh18getMassInformationERfRNS_7PxMat33ERNS_6PxVec3E: __ZNK5physx2Gu10ConvexMesh18getMassInformationERfRNS_7PxMat33ERNS_6PxVec3E, _UNITY_FT_Get_Postscript_Name: _UNITY_FT_Get_Postscript_Name, __ZL27GeomMTDCallback_CapsuleMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL27GeomMTDCallback_CapsuleMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z38Register_UnityEngine_GL_MultiTexCoord3v: __Z38Register_UnityEngine_GL_MultiTexCoord3v, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx2Sc5Scene22prepareParticleSystemsEv: __ZN5physx2Sc5Scene22prepareParticleSystemsEv, __Z44Register_UnityEngine_Animator_SetFloatStringv: __Z44Register_UnityEngine_Animator_SetFloatStringv, __ZN15ReflectionProbe13AwakeFromLoadE17AwakeFromLoadMode: __ZN15ReflectionProbe13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx30collideWithSphereNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_: __ZN5physx30collideWithSphereNonContinuousERNS_19PxsParticleCollDataERKNS_6PxVec3ERKfS6_, __ZThn12_NK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN21LinearCollectionField8SetArrayERK9ArrayInfo: __ZN21LinearCollectionField8SetArrayERK9ArrayInfo, __Z51Register_UnityEngine_TerrainData_GetAlphamapTexturev: __Z51Register_UnityEngine_TerrainData_GetAlphamapTexturev, __Z13RegisterClassI7TerrainEvv: __Z13RegisterClassI7TerrainEvv, __Z36UnityWebRequest_CUSTOM_InternalAbortP12Il2CppObject: __Z36UnityWebRequest_CUSTOM_InternalAbortP12Il2CppObject, __Z36Register_UnityEngine_Light_set_flarev: __Z36Register_UnityEngine_Light_set_flarev, __ZN9b2Contact6UpdateEP17b2ContactListener: __ZN9b2Contact6UpdateEP17b2ContactListener, __ZN5Umbra10Visibility24setOutputObjectDistancesEPf: __ZN5Umbra10Visibility24setOutputObjectDistancesEPf, __ZN18BuoyancyEffector2D15SetSurfaceLevelEf: __ZN18BuoyancyEffector2D15SetSurfaceLevelEf, __ZN11PerlinNoise5NoiseEff: __ZN11PerlinNoise5NoiseEff, __ZN22VirtualJoystickManager22ConnectVirtualJoystickEPKc: __ZN22VirtualJoystickManager22ConnectVirtualJoystickEPKc, __ZNK20TextRenderingPrivate8FontImpl22GetCharacterRenderInfoEjijfR5RectTIfES3_RbPj: __ZNK20TextRenderingPrivate8FontImpl22GetCharacterRenderInfoEjijfR5RectTIfES3_RbPj, __ZNSt13exception_ptrC2ERKS_: __ZNSt13exception_ptrC2ERKS_, __Z47Register_UnityEngine_Collider_set_contactOffsetv: __Z47Register_UnityEngine_Collider_set_contactOffsetv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead19EffectorSelection2DEvRT_RT0_PKc17TransferMetaFlags, __ZN14CompressedMesh10DecompressER4Mesh: __ZN14CompressedMesh10DecompressER4Mesh, __ZL26CleanupModule_UnityConnectv: __ZL26CleanupModule_UnityConnectv, _tlsf_block_size: _tlsf_block_size, __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddRelativeForcev: __Z63Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_AddRelativeForcev, __ZN18ProceduralMaterial18SetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK8Vector4f: __ZN18ProceduralMaterial18SetSubstanceVectorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK8Vector4f, __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFlPKcPPciEEET_RKS7_RKT0_PjiT1_: __ZNSt3__212_GLOBAL__N_117as_integer_helperIlNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPFlPKcPPciEEET_RKS7_RKT0_PjiT1_, __ZN5Umbra9intersectERKNS_4AABBES2_: __ZN5Umbra9intersectERKNS_4AABBES2_, __ZN10Matrix4x4f17SetFromToRotationERK8Vector3fS2_: __ZN10Matrix4x4f17SetFromToRotationERK8Vector3fS2_, __Z24RegisterStrippedTypeInfoI24PhysicsUpdateBehaviour2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI24PhysicsUpdateBehaviour2DEviPKcS2_, __ZNK7Joint2D10FetchBodyAEv: __ZNK7Joint2D10FetchBodyAEv, __ZNK9dtNavMesh26getOffMeshConnectionUserIdEyPj: __ZNK9dtNavMesh26getOffMeshConnectionUserIdEyPj, __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms: __ZN9ShaderLab4Pass9ApplyPassEjPK19ShaderPropertySheetR17ShaderPassContextP6ShaderiPKNS_10GrabPassesEP11SubPrograms, __ZN9Polygon2D12GenerateFromEP6SpriteRK8Vector2ffhb: __ZN9Polygon2D12GenerateFromEP6SpriteRK8Vector2ffhb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags, __Z65Register_UnityEngine_QualitySettings_get_realtimeReflectionProbesv: __Z65Register_UnityEngine_QualitySettings_get_realtimeReflectionProbesv, __Z53Register_UnityEngine_Animator_SetLookAtWeightInternalv: __Z53Register_UnityEngine_Animator_SetLookAtWeightInternalv, __ZN5physx18PxsDynamicsContext6updateEfPNS_10PxBaseTaskE: __ZN5physx18PxsDynamicsContext6updateEfPNS_10PxBaseTaskE, __ZN9JSONWrite8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI11QuaternionfEEvRT_PKc17TransferMetaFlags, __ZNK13GfxDeviceNull18GetWorldViewMatrixEv: __ZNK13GfxDeviceNull18GetWorldViewMatrixEv, __Z23getPxArticulation_LinksPKN5physx14PxArticulationEPPNS_18PxArticulationLinkEj: __Z23getPxArticulation_LinksPKN5physx14PxArticulationEPPNS_18PxArticulationLinkEj, __ZN19CharacterController15InitializeClassEv: __ZN19CharacterController15InitializeClassEv, _UNITY_FT_Stream_TryRead: _UNITY_FT_Stream_TryRead, __Z48setPxVehicleWheelsSimData_MinLongSlipDenominatorPN5physx22PxVehicleWheelsSimDataEf: __Z48setPxVehicleWheelsSimData_MinLongSlipDenominatorPN5physx22PxVehicleWheelsSimDataEf, __ZN24MeshIntermediateRenderer10InitializeERK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebi: __ZN24MeshIntermediateRenderer10InitializeERK10Matrix4x4fP4MeshRK4AABB4PPtrI8MaterialEi17ShadowCastingModebi, __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexEf: __ZNK17AnimationCurveTplI11QuaternionfE9FindIndexEf, __ZN5physx16PxsFluidDynamics23updateSubpacketPairHaloEPNS_6PxVec3EPNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjRbjS4_jS6_S7_RKS1_NS_16PxsSphUpdateTypeEPtRNS_27PxsFluidDynamicsTempBuffersE: __ZN5physx16PxsFluidDynamics23updateSubpacketPairHaloEPNS_6PxVec3EPNS_16PxsFluidParticleEjPNS_15PxsParticleCellEPjRbjS4_jS6_S7_RKS1_NS_16PxsSphUpdateTypeEPtRNS_27PxsFluidDynamicsTempBuffersE, __Z38Gizmos_CUSTOM_INTERNAL_CALL_DrawSphereRK8Vector3ff: __Z38Gizmos_CUSTOM_INTERNAL_CALL_DrawSphereRK8Vector3ff, __ZN5physx14NpRigidDynamic21setMaxAngularVelocityEf: __ZN5physx14NpRigidDynamic21setMaxAngularVelocityEf, __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_: __ZN15SerializeTraitsI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_, __Z37Cloth_Get_Custom_PropBendingStiffnessP12Il2CppObject: __Z37Cloth_Get_Custom_PropBendingStiffnessP12Il2CppObject, __ZN16HumanPoseHandler12GetHumanPoseER8Vector3fR11QuaternionfPf: __ZN16HumanPoseHandler12GetHumanPoseER8Vector3fR11QuaternionfPf, __ZN15QualitySettings18SetPixelLightCountEi: __ZN15QualitySettings18SetPixelLightCountEi, __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E: __ZN5physx3Ext21InertiaTensorComputer9translateERKNS_6PxVec3E, __ZN10AudioMixer14SetWeightedMixER13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEPff: __ZN10AudioMixer14SetWeightedMixER13dynamic_arrayI4PPtrI18AudioMixerSnapshotELj4EEPff, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEEEEjT_j, __Z37getPxParticleReadDataNbValidParticlesPKN5physx18PxParticleReadDataE: __Z37getPxParticleReadDataNbValidParticlesPKN5physx18PxParticleReadDataE, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE24getParticleReadDataFlagsEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE24getParticleReadDataFlagsEv, __Z47Register_UnityEngine_AndroidJNIHelper_set_debugv: __Z47Register_UnityEngine_AndroidJNIHelper_set_debugv, __ZN5physx12NpConstraint7setFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx12NpConstraint7setFlagENS_16PxConstraintFlag4EnumEb, __Z49Register_UnityEngine_Rigidbody2D_set_gravityScalev: __Z49Register_UnityEngine_Rigidbody2D_set_gravityScalev, __ZN12b2WheelJoint23InitVelocityConstraintsERK12b2SolverData: __ZN12b2WheelJoint23InitVelocityConstraintsERK12b2SolverData, __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvRS2_RNS_16PxcSolverContextERS7_SC_E: __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvRS2_RNS_16PxcSolverContextERS7_SC_E, __Z29StdTemplateConversionFunctionIabEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIabEbPvR14SafeBinaryRead, __Z17IsNodeVisibleFastRK9SceneNodeRK22SceneCullingParameters: __Z17IsNodeVisibleFastRK9SceneNodeRK22SceneCullingParameters, __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN5physx2Sc16ArticulationCore17getPxArticulationEv: __ZN5physx2Sc16ArticulationCore17getPxArticulationEv, __ZN8TypeTree16AssignNameStringERK16TypeTreeIteratorPKc: __ZN8TypeTree16AssignNameStringERK16TypeTreeIteratorPKc, __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_T_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEPKc, __Z41Register_UnityEngine_AudioSource_get_timev: __Z41Register_UnityEngine_AudioSource_get_timev, __Z37GUIStyle_Set_Custom_PropStretchHeightP12Il2CppObjecth: __Z37GUIStyle_Set_Custom_PropStretchHeightP12Il2CppObjecth, __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS7_: __ZN15dense_hashtableINSt3__24pairIKN11UnityEngine9Animation14GenericBindingENS3_10BoundIndexEEES4_NS3_25GenericBindingHashFunctorEN14dense_hash_mapIS4_S6_S8_NS3_30GenericBindingValueArrayUniqueE13stl_allocatorIS7_L18MemLabelIdentifier1ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS7_, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z24RegisterStrippedTypeInfoI18AudioLowPassFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI18AudioLowPassFilterEviPKcS2_, __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE14__erase_uniqueIS2_EEjRKT_: __ZNSt3__26__treeINS_12__value_typeI26SerializedObjectIdentifieriEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEENS_9allocatorIS3_EEE14__erase_uniqueIS2_EEjRKT_, __ZN16SpriteRenderData10SetIndicesEPKtj: __ZN16SpriteRenderData10SetIndicesEPKtj, __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKjRKNS_6PxVec3ES8_f: __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKjRKNS_6PxVec3ES8_f, __ZNK25UnityWebRequestJavaScript14GetUploadBytesEv: __ZNK25UnityWebRequestJavaScript14GetUploadBytesEv, __ZN9UdpSocketD2Ev: __ZN9UdpSocketD2Ev, __ZNSt3__26locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __ZN20TextRenderingPrivate14DynamicFontMap13StaticDestroyEv: __ZN20TextRenderingPrivate14DynamicFontMap13StaticDestroyEv, __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf: __ZN5physx5cloth10loadBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEPKf, __ZNK5physx3Ext13RevoluteJoint21getRevoluteJointFlagsEv: __ZNK5physx3Ext13RevoluteJoint21getRevoluteJointFlagsEv, __Z34setPxTriangleMeshGeometryMeshFlagsPN5physx22PxTriangleMeshGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE: __Z34setPxTriangleMeshGeometryMeshFlagsPN5physx22PxTriangleMeshGeometryENS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEE, __ZNK21EnlightenSceneMapping22GetTerrainInstanceHashEi: __ZNK21EnlightenSceneMapping22GetTerrainInstanceHashEi, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN6Camera15SetOrthographicEb: __ZN6Camera15SetOrthographicEb, __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_7PxPlaneENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE: __ZN9Texture2D16ResizeWithFormatEii13TextureFormatNS_10EInitFlagsE, __ZN20SoundChannelInstance20set3DConeOrientationEP11FMOD_VECTOR: __ZN20SoundChannelInstance20set3DConeOrientationEP11FMOD_VECTOR, __Z37GraphicsSettings_CUSTOM_GetShaderModeN16GraphicsSettings17BuiltinShaderTypeE: __Z37GraphicsSettings_CUSTOM_GetShaderModeN16GraphicsSettings17BuiltinShaderTypeE, __ZN4FMOD6System13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj: __ZN4FMOD6System13registerCodecEP22FMOD_CODEC_DESCRIPTIONPjj, __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_: __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E15insert_noresizeERKS4_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags, __Z24RegisterStrippedTypeInfoI15EditorExtensionEviPKcS2_: __Z24RegisterStrippedTypeInfoI15EditorExtensionEviPKcS2_, __ZN5physx2Sc9ShapeCore14setShape2ActorERKNS_11PxTransformE: __ZN5physx2Sc9ShapeCore14setShape2ActorERKNS_11PxTransformE, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEE15growAndPushBackERKS2_, __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12maybe_shrinkEv, __ZN8keywords14GetKeywordNameEi: __ZN8keywords14GetKeywordNameEi, __Z20Material_CUSTOM_LerpP12Il2CppObjectS0_S0_f: __Z20Material_CUSTOM_LerpP12Il2CppObjectS0_S0_f, __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth: __Z67ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth, __ZN24dtObstacleAvoidanceQuery9addCircleEPKfffS1_S1_: __ZN24dtObstacleAvoidanceQuery9addCircleEPKfffS1_S1_, __ZNSt3__26__sortIRNS_6__lessIwwEEPwEEvT0_S5_T_: __ZNSt3__26__sortIRNS_6__lessIwwEEPwEEvT0_S5_T_, __ZN15MBP_PairManager10removePairEjjjj: __ZN15MBP_PairManager10removePairEjjjj, __Z30Cubemap_CUSTOM_Internal_CreateP12Il2CppObjecti13TextureFormath: __Z30Cubemap_CUSTOM_Internal_CreateP12Il2CppObjecti13TextureFormath, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK4PPtrI18AudioMixerSnapshotEptEv: __ZNK4PPtrI18AudioMixerSnapshotEptEv, __Z44PointEffector2D_Set_Custom_PropDistanceScaleP12Il2CppObjectf: __Z44PointEffector2D_Set_Custom_PropDistanceScaleP12Il2CppObjectf, __Z27RegisterModuleClasses_Clothv: __Z27RegisterModuleClasses_Clothv, __ZN5physx13PxsCCDContext12updateCCDEndEv: __ZN5physx13PxsCCDContext12updateCCDEndEv, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_22PxTriangleMeshGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_22PxTriangleMeshGeometryE, __ZN4math8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4math8Collider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN20TextRenderingPrivate8FontImpl10CacheRectsEv: __ZN20TextRenderingPrivate8FontImpl10CacheRectsEv, __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIPN11UnityEngine15CloudWebService14CloudEventInfoE13stl_allocatorIS4_L18MemLabelIdentifier85ELi16EEE6assignIPS4_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z20CreateObjectFromCodeI7CubemapEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI7CubemapEPT_17AwakeFromLoadMode10MemLabelId, __ZN4Tree11GetTreeDataEv: __ZN4Tree11GetTreeDataEv, __ZL22addOrRemoveRigidObjectILb0ELb1ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b: __ZL22addOrRemoveRigidObjectILb0ELb1ELb1ELb1EN5physx3Scb4BodyEEvRNS0_2Sc5SceneERT3_b, __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample: __Z32ApplyReflectionProbeVectorParamsI28ApplyBuiltinInstancePropertyEvRT_RK16ReflectionSample, __ZN5physx17PxStringTableImplD2Ev: __ZN5physx17PxStringTableImplD2Ev, __Z46Application_Get_Custom_PropStreamingAssetsPathv: __Z46Application_Get_Custom_PropStreamingAssetsPathv, __Z55Register_UnityEngine_Rigidbody_get_sleepAngularVelocityv: __Z55Register_UnityEngine_Rigidbody_get_sleepAngularVelocityv, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetPositionv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetPositionv, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEC2INS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEET_NS_9enable_ifIXaasr21__is_forward_iteratorISG_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISG_E9referenceEEE5valueESG_E4typeE: __ZNSt3__26vectorIP10GUIElement13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEC2INS_21__tree_const_iteratorI4PPtrIS1_EPNS_11__tree_nodeISA_PvEEiEEEET_NS_9enable_ifIXaasr21__is_forward_iteratorISG_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISG_E9referenceEEE5valueESG_E4typeE, __ZN5Unity9ComponentD0Ev: __ZN5Unity9ComponentD0Ev, _UNITY_FT_Get_Renderer: _UNITY_FT_Get_Renderer, _UNITY_FT_Add_Default_Modules: _UNITY_FT_Add_Default_Modules, __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_: __ZN20SphericalHarmonicsL28TransferI14SafeBinaryReadEEvRT_, __ZN7Joint2D16CheckConsistencyEv: __ZN7Joint2D16CheckConsistencyEv, __ZN5physx20PxsParticleSystemSim26schedulePacketShapesUpdateERKNS_28PxvParticleShapesUpdateInputERNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim26schedulePacketShapesUpdateERKNS_28PxvParticleShapesUpdateInputERNS_10PxBaseTaskE, __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Samplev: __Z51Register_UnityEngine_Animation_INTERNAL_CALL_Samplev, __ZNK13MonoBehaviour8GetClassEv: __ZNK13MonoBehaviour8GetClassEv, __ZN11AudioSource12AddToManagerEv: __ZN11AudioSource12AddToManagerEv, __ZN9ShaderLab14SerializedPass16CreateNamesTableEv: __ZN9ShaderLab14SerializedPass16CreateNamesTableEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_17TransferMetaFlags, __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15PointEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNK12TLSAllocatorI14StackAllocatorE10IsAssignedEv: __ZNK12TLSAllocatorI14StackAllocatorE10IsAssignedEv, __Z41Effector2D_Get_Custom_PropUseColliderMaskP12Il2CppObject: __Z41Effector2D_Get_Custom_PropUseColliderMaskP12Il2CppObject, __Z19UploadTexture2DDataRK23UploadTextureDataParams: __Z19UploadTexture2DDataRK23UploadTextureDataParams, __Z24RegisterStrippedTypeInfoI14EdgeCollider2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI14EdgeCollider2DEviPKcS2_, __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshColorsv: __Z64Register_UnityEngine_ParticleSystem_ShapeModule_GetUseMeshColorsv, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5imbueERKNS_6localeE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE5imbueERKNS_6localeE, __ZNK12CubemapArray26CanReuploadDataToGfxDeviceEv: __ZNK12CubemapArray26CanReuploadDataToGfxDeviceEv, __ZN5physx14NpRigidDynamic18setAngularVelocityERKNS_6PxVec3Eb: __ZN5physx14NpRigidDynamic18setAngularVelocityERKNS_6PxVec3Eb, __ZNK4crnd10dxt3_block9get_alphaEjjb: __ZNK4crnd10dxt3_block9get_alphaEjjb, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj650ENS_22PxRepXPropertyAccessorILj650ES4_KjjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj650ENS_22PxRepXPropertyAccessorILj650ES4_KjjEEEEvjRKT0_, __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetDeathP12Il2CppObjectiS0_: __Z48ParticleSystem_SubEmittersModule_CUSTOM_SetDeathP12Il2CppObjectiS0_, __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_BoxCastv: __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_BoxCastv, __ZNK5physx14NpArticulation12getAggregateEv: __ZNK5physx14NpArticulation12getAggregateEv, __ZN9Animation14QueueCrossFadeER14AnimationStatefii: __ZN9Animation14QueueCrossFadeER14AnimationStatefii, __ZN5Unity10HingeJoint9SetLimitsERK11JointLimits: __ZN5Unity10HingeJoint9SetLimitsERK11JointLimits, __ZN5physx2Sc12MaterialCoreC2ERKNS_15PxsMaterialDataE: __ZN5physx2Sc12MaterialCoreC2ERKNS_15PxsMaterialDataE, __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_: __ZN12ImmediatePtrI9TransformE8TransferI14SafeBinaryReadEEvRT_, __ZN15QualitySettings29GetShadowDistanceForRenderingEv: __ZN15QualitySettings29GetShadowDistanceForRenderingEv, __ZN11SoundHandleC2ERKS_: __ZN11SoundHandleC2ERKS_, __ZN16CircleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16CircleCollider2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN8Playable14SetInputWeightEif: __ZN8Playable14SetInputWeightEif, __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireCubeRK8Vector3fS1_: __Z40Gizmos_CUSTOM_INTERNAL_CALL_DrawWireCubeRK8Vector3fS1_, __ZNK12TLSAllocatorI14StackAllocatorE24GetBookKeepingMemorySizeEv: __ZNK12TLSAllocatorI14StackAllocatorE24GetBookKeepingMemorySizeEv, _UNITY_png_app_warning: _UNITY_png_app_warning, __Z41Register_UnityEngine_AudioSource_get_mutev: __Z41Register_UnityEngine_AudioSource_get_mutev, __ZN7Cubemap7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN7Cubemap7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN5physx18PxVehicleDriveTank6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj: __ZN5physx18PxVehicleDriveTank6createEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj, __ZN7Texture26SetUsageModeNoDirtyNoApplyE16TextureUsageMode: __ZN7Texture26SetUsageModeNoDirtyNoApplyE16TextureUsageMode, __Z31AudioMixerDuckingCreateCallbackP21UnityAudioEffectState: __Z31AudioMixerDuckingCreateCallbackP21UnityAudioEffectState, __Z21GetLayerAndStateIndexPKN7mecanim9animation18ControllerConstantEjPiS4_: __Z21GetLayerAndStateIndexPKN7mecanim9animation18ControllerConstantEjPiS4_, __ZN5physx7NpCloth17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx7NpCloth17resolveReferencesERNS_24PxDeserializationContextE, __ZNKSt3__218__time_get_storageIwE15__do_date_orderEv: __ZNKSt3__218__time_get_storageIwE15__do_date_orderEv, _ps_dimension_add_t1stem: _ps_dimension_add_t1stem, __Z60Register_UnityEngine_ConfigurableJoint_set_rotationDriveModev: __Z60Register_UnityEngine_ConfigurableJoint_set_rotationDriveModev, __ZN12ShaderErrors11ShaderErrorC2ERKS0_: __ZN12ShaderErrors11ShaderErrorC2ERKS0_, __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __Z39SliderJoint2D_Get_Custom_PropLimitStateP12Il2CppObject: __Z39SliderJoint2D_Get_Custom_PropLimitStateP12Il2CppObject, __Z45Register_UnityEngine_Rigidbody2D_get_bodyTypev: __Z45Register_UnityEngine_Rigidbody2D_get_bodyTypev, __ZN5physx3Scb5Scene14updateMaterialERNS_2Sc12MaterialCoreE: __ZN5physx3Scb5Scene14updateMaterialERNS_2Sc12MaterialCoreE, __Z41Quaternion_CUSTOM_INTERNAL_CALL_AxisAngleRK8Vector3ffR11Quaternionf: __Z41Quaternion_CUSTOM_INTERNAL_CALL_AxisAngleRK8Vector3ffR11Quaternionf, __Z37Light_Get_Custom_PropShadowNormalBiasP12Il2CppObject: __Z37Light_Get_Custom_PropShadowNormalBiasP12Il2CppObject, __ZNK29LineParametersPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK29LineParametersPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, _mlock: _mlock, __ZN22CrashReportingSettingsC2Ev: __ZN22CrashReportingSettingsC2Ev, __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE8recreateEj, _cff_free_glyph_data: _cff_free_glyph_data, __Z28getPxScene_BroadPhaseRegionsPKN5physx7PxSceneEPNS_22PxBroadPhaseRegionInfoEj: __Z28getPxScene_BroadPhaseRegionsPKN5physx7PxSceneEPNS_22PxBroadPhaseRegionInfoEj, __ZN22VertexDeclarationCache5ClearEv: __ZN22VertexDeclarationCache5ClearEv, __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14PhysicsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z46Register_UnityEngine_Animator_get_playbackTimev: __Z46Register_UnityEngine_Animator_get_playbackTimev, __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE: __ZNSt3__26__treeINS_12__value_typeIPv17ExternalAllocInfoEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS4_S2_EE, __ZN18BuoyancyEffector2DD0Ev: __ZN18BuoyancyEffector2DD0Ev, __ZN23CloudWebServicesManagerD0Ev: __ZN23CloudWebServicesManagerD0Ev, __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdateProcessMouseInWindowstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdateProcessMouseInWindowstruct7ForwardEv, __Z13RegisterClassI6MotionEvv: __Z13RegisterClassI6MotionEvv, __ZN5physx3Ext13RevoluteJoint17setDriveGearRatioEf: __ZN5physx3Ext13RevoluteJoint17setDriveGearRatioEf, __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN19SkinnedMeshRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN11LightProbes8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11LightProbes8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN6Camera12SetEventMaskEj: __ZN6Camera12SetEventMaskEj, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z44NavMeshAgent_Get_Custom_PropStoppingDistanceP12Il2CppObject: __Z44NavMeshAgent_Get_Custom_PropStoppingDistanceP12Il2CppObject, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapYMultiplierv, __ZN5physx3Cct13BoxController15invalidateCacheEv: __ZN5physx3Cct13BoxController15invalidateCacheEv, __ZN5physx8debugger17MemPvdInputStreamD0Ev: __ZN5physx8debugger17MemPvdInputStreamD0Ev, _fullsize_upsample: _fullsize_upsample, __ZN11DetailPatch8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11DetailPatch8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI9Texture2DENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z26PlayerSendFramePostPresentb: __Z26PlayerSendFramePostPresentb, __ZN8Renderer20ResetStaticBatchInfoEv: __ZN8Renderer20ResetStaticBatchInfoEv, __ZNSt3__25ctypeIcE21__classic_upper_tableEv: __ZNSt3__25ctypeIcE21__classic_upper_tableEv, __ZN15ParticleEmitter4EmitEjf: __ZN15ParticleEmitter4EmitEjf, __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_: __ZN5physx17PxCreateKinematicERNS_9PxPhysicsERKNS_11PxTransformERKNS_10PxGeometryERNS_10PxMaterialEfS4_, __ZN18AsyncUploadManager12HasCompletedE10AsyncFence: __ZN18AsyncUploadManager12HasCompletedE10AsyncFence, __ZN13RenderTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13RenderTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN13MonoBehaviour16CallUpdateMethodEi: __ZN13MonoBehaviour16CallUpdateMethodEi, __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E: __ZNK17OptimizedGradient8EvaluateIL12GradientMode0EEEN4math4pix4ERKNS2_7_float4E, __ZN6Object11RemoveEventEPFvPvS0_iES0_: __ZN6Object11RemoveEventEPFvPvS0_iES0_, __Z13RegisterClassI14AudioBehaviourEvv: __Z13RegisterClassI14AudioBehaviourEvv, __ZN13GfxDeviceNull20GetVertexDeclarationERK18VertexChannelsInfo: __ZN13GfxDeviceNull20GetVertexDeclarationERK18VertexChannelsInfo, __Z40getPxSimulationStatisticsNbDynamicBodiesPKN5physx22PxSimulationStatisticsE: __Z40getPxSimulationStatisticsNbDynamicBodiesPKN5physx22PxSimulationStatisticsE, _ps_hinter_done: _ps_hinter_done, __Z69Register_UnityEngine_Terrain_INTERNAL_get_realtimeLightmapScaleOffsetv: __Z69Register_UnityEngine_Terrain_INTERNAL_get_realtimeLightmapScaleOffsetv, __ZN9Texture2D8TransferI14SafeBinaryReadEEvRT_: __ZN9Texture2D8TransferI14SafeBinaryReadEEvRT_, __ZN5physx25PxcPCMContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx25PxcPCMContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20ExternalForcesModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Ext18ProfileZoneHandler7releaseEv: __ZN5physx3Ext18ProfileZoneHandler7releaseEv, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z31setPxSceneLimitsMaxNbAggregatesPN5physx13PxSceneLimitsEj: __Z31setPxSceneLimitsMaxNbAggregatesPN5physx13PxSceneLimitsEj, __ZN17ArchiveFileSystemD2Ev: __ZN17ArchiveFileSystemD2Ev, __ZNK5physx20BigConvexDataBuilder16ComputeValenciesEjPKNS_16HullTriangleDataE: __ZNK5physx20BigConvexDataBuilder16ComputeValenciesEjPKNS_16HullTriangleDataE, __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi3ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZNK10Collider2D24GetColliderMaterialStateERfS0_: __ZNK10Collider2D24GetColliderMaterialStateERfS0_, __ZNK8VRDevice12GetNativePtrEv: __ZNK8VRDevice12GetNativePtrEv, __Z24RegisterStrippedTypeInfoI8ColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI8ColliderEviPKcS2_, _strlwr: _strlwr, __Z57ParticleSystem_MainModule_CUSTOM_SetCustomSimulationSpaceP12Il2CppObjectS0_: __Z57ParticleSystem_MainModule_CUSTOM_SetCustomSimulationSpaceP12Il2CppObjectS0_, __ZN17AudioChorusFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17AudioChorusFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, _UNITY_FT_New_GlyphSlot: _UNITY_FT_New_GlyphSlot, __Z39WebCamTexture_Get_Custom_PropDeviceNameP12Il2CppObject: __Z39WebCamTexture_Get_Custom_PropDeviceNameP12Il2CppObject, __ZN12ImageDecoder7SetDataEPKhj: __ZN12ImageDecoder7SetDataEPKhj, __ZN5physx2Sc15ClothFabricCore4loadERNS_13PxInputStreamE: __ZN5physx2Sc15ClothFabricCore4loadERNS_13PxInputStreamE, __ZN13RenderManager9AddCameraEP6Camera: __ZN13RenderManager9AddCameraEP6Camera, __ZN30RotationModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN30RotationModulePropertyBindings13GetFloatValueERK14ParticleSystemi, _iswlower_l: _iswlower_l, __ZN5Light16CheckConsistencyEv: __ZN5Light16CheckConsistencyEv, __ZNK19ShaderPropertySheet14GetMatrixArrayEi: __ZNK19ShaderPropertySheet14GetMatrixArrayEi, _wcswidth: _wcswidth, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj483ENS_22PxRepXPropertyAccessorILj483ENS_22PxJointLimitParametersEffEEEEvRKT0_, __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetColorv: __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_SetColorv, __ZN4FMOD6SoundI11setUserDataEPv: __ZN4FMOD6SoundI11setUserDataEPv, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17CUDAProfileBufferEyfPKhjj: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE17CUDAProfileBufferEyfPKhjj, __Z9SetLocalS15TransformAccessRKN4math7_float3E: __Z9SetLocalS15TransformAccessRKN4math7_float3E, __ZNK5physx3Cct26CharacterControllerManager21getNbObstacleContextsEv: __ZNK5physx3Cct26CharacterControllerManager21getNbObstacleContextsEv, __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveCountv: __Z62Register_UnityEngine_ParticleSystem_NoiseModule_GetOctaveCountv, __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetAnimationTypeP12Il2CppObject: __Z66ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetAnimationTypeP12Il2CppObject, __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE: __ZN26AnimatorControllerPlayable19GetAnimatorClipInfoEibR13dynamic_arrayI16AnimatorClipInfoLj4EE, __ZN22UnityAnalyticsSettings5ResetEv: __ZN22UnityAnalyticsSettings5ResetEv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getAngularInertiaEv, __Z32Behaviour_Set_Custom_PropEnabledP12Il2CppObjecth: __Z32Behaviour_Set_Custom_PropEnabledP12Il2CppObjecth, __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRe: __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_bRNS_8ios_baseERjRe, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4trsXEEEEvRT_17TransferMetaFlags, __ZN30VelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN30VelocityModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN22ProceduralMaterialData12SyncMaterialEP18ProceduralMaterial: __ZN22ProceduralMaterialData12SyncMaterialEP18ProceduralMaterial, __ZN5physx7NpSceneC2ERKNS_11PxSceneDescE: __ZN5physx7NpSceneC2ERKNS_11PxSceneDescE, __ZN18PlayableController15SetPrepareStageE13DirectorStage: __ZN18PlayableController15SetPrepareStageE13DirectorStage, __Z45PointEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf: __Z45PointEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf, __Z35Material_Get_Custom_PropRenderQueueP12Il2CppObject: __Z35Material_Get_Custom_PropRenderQueueP12Il2CppObject, __ZNSt11logic_errorC2EPKc: __ZNSt11logic_errorC2EPKc, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_9solveStepEPNS_10PxBaseTaskEEEE7getNameEv, __Z40setPxRigidDynamic_ContactReportThresholdPN5physx14PxRigidDynamicEf: __Z40setPxRigidDynamic_ContactReportThresholdPN5physx14PxRigidDynamicEf, __ZN5physx2Sc9ClothCore25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE: __ZN5physx2Sc9ClothCore25setMotionConstraintConfigERKNS_29PxClothMotionConstraintConfigE, __ZNK8GUIStyle34GetNumCharactersThatFitWithinWidthERK11UTF16Stringf: __ZNK8GUIStyle34GetNumCharactersThatFitWithinWidthERK11UTF16Stringf, __ZN15DetailPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15DetailPrototype8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_velocityv: __Z61Register_UnityEngine_AI_NavMeshObstacle_INTERNAL_set_velocityv, __Z31Renderer_Get_Custom_PropEnabledP12Il2CppObject: __Z31Renderer_Get_Custom_PropEnabledP12Il2CppObject, __Z27scripting_gchandle_weak_newP12Il2CppObject: __Z27scripting_gchandle_weak_newP12Il2CppObject, __ZL26RegisterModuleICalls_WebGLv: __ZL26RegisterModuleICalls_WebGLv, __ZN16GraphicsSettings15ThreadedCleanupEv: __ZN16GraphicsSettings15ThreadedCleanupEv, __ZN5physx24NpPtrTableStorageManagerD2Ev: __ZN5physx24NpPtrTableStorageManagerD2Ev, __ZN5physx3Scb10Constraint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb10Constraint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx12NpConstraint13setBreakForceEff: __ZN5physx12NpConstraint13setBreakForceEff, __Z37RegisterModuleClasses_ParticlesLegacyv: __Z37RegisterModuleClasses_ParticlesLegacyv, __ZNKSt3__27codecvtIwc11__mbstate_tE13do_max_lengthEv: __ZNKSt3__27codecvtIwc11__mbstate_tE13do_max_lengthEv, __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN8LODGroup3LODENS0_9allocatorIS3_EEEEEvRT_j, __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN28LightProbeProxyVolumeManager6UpdateEv: __ZN28LightProbeProxyVolumeManager6UpdateEv, __ZN24ConvexVsHeightfieldSweepD0Ev: __ZN24ConvexVsHeightfieldSweepD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z53ParticleSystemRenderer_Set_Custom_PropNormalDirectionP12Il2CppObjectf: __Z53ParticleSystemRenderer_Set_Custom_PropNormalDirectionP12Il2CppObjectf, __ZN5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEED0Ev, __ZN5physx3Ext15CpuWorkerThreadD2Ev: __ZN5physx3Ext15CpuWorkerThreadD2Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE8pushNameEPKc, __ZN5physx15PxsParticleData6createEjb: __ZN5physx15PxsParticleData6createEjb, _wcscasecmp_l: _wcscasecmp_l, __ZN13TreePrototype8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13TreePrototype8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17SurfaceEffector2DC2E10MemLabelId18ObjectCreationMode: __ZN17SurfaceEffector2DC2E10MemLabelId18ObjectCreationMode, __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE: __ZN7mecanim8skeleton14CreateSkeletonEiiRNS_6memory9AllocatorE, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEclERS4_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEclERS4_17TransferMetaFlagsR9BlobWrite, __ZN5physx2Sn22writeHeightFieldSampleERNS_14PxOutputStreamERKNS_19PxHeightFieldSampleE: __ZN5physx2Sn22writeHeightFieldSampleERNS_14PxOutputStreamERKNS_19PxHeightFieldSampleE, __ZN6Sprite15ThreadedCleanupEv: __ZN6Sprite15ThreadedCleanupEv, __Z19GetReflectionProbesv: __Z19GetReflectionProbesv, __ZNSt3__218shared_timed_mutex15try_lock_sharedEv: __ZNSt3__218shared_timed_mutex15try_lock_sharedEv, __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx20solveContact_BStaticERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_ED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_ED0Ev, __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetTextv: __Z69Register_UnityEngine_Networking_DownloadHandlerBuffer_InternalGetTextv, __ZN5physx6shdfnd10ThreadImplC2Ev: __ZN5physx6shdfnd10ThreadImplC2Ev, _unity_z_adler32: _unity_z_adler32, __ZN5physx2Gu5RTreeC2ERKNS_7PxEMPTYE: __ZN5physx2Gu5RTreeC2ERKNS_7PxEMPTYE, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx7NpScene14getConstraintsEPPNS_12PxConstraintEjj: __ZNK5physx7NpScene14getConstraintsEPPNS_12PxConstraintEjj, __Z26AudioMixer_CUSTOM_GetFloatP12Il2CppObjectP12Il2CppStringPf: __Z26AudioMixer_CUSTOM_GetFloatP12Il2CppObjectP12Il2CppStringPf, __ZN13UnityProfiler22EndFrameSeparateThreadEj: __ZN13UnityProfiler22EndFrameSeparateThreadEj, __ZN5physx7NpScene29setDynamicTreeRebuildRateHintEj: __ZN5physx7NpScene29setDynamicTreeRebuildRateHintEj, __Z42getPxVehicleTireLoadFilterData_DenominatorPKN5physx27PxVehicleTireLoadFilterDataE: __Z42getPxVehicleTireLoadFilterData_DenominatorPKN5physx27PxVehicleTireLoadFilterDataE, _nexttowardf: _nexttowardf, __Z11dictNewDictP9TESSallocPvPFiS1_S1_S1_E: __Z11dictNewDictP9TESSallocPvPFiS1_S1_S1_E, __ZN5physx2Gu11HeightField12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx2Gu11HeightField12createObjectERPhRNS_24PxDeserializationContextE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEEEEEvRT_17TransferMetaFlags, __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, ___crypt_sha256: ___crypt_sha256, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN21AudioDistortionFilterD0Ev: __ZN21AudioDistortionFilterD0Ev, __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb: __ZN5physx2Sc5Scene10removeBodyERNS0_8BodyCoreERNS_6shdfnd11InlineArrayIPKNS0_9ShapeCoreELj64ENS4_19ReflectionAllocatorIS8_EEEEb, __ZN20OcclusionCullingData17MainThreadCleanupEv: __ZN20OcclusionCullingData17MainThreadCleanupEv, __ZN5Umbra16LineSegmentQueryC2Ev: __ZN5Umbra16LineSegmentQueryC2Ev, __Z37Projector_Get_Custom_PropFarClipPlaneP12Il2CppObject: __Z37Projector_Get_Custom_PropFarClipPlaneP12Il2CppObject, __ZN43MultiWriterSingleReaderAtomicCircularBuffer31CopyDataAndMakeAvailableForReadEP26AtomicCircularBufferHandlePhii: __ZN43MultiWriterSingleReaderAtomicCircularBuffer31CopyDataAndMakeAvailableForReadEP26AtomicCircularBufferHandlePhii, __Z18MonoBehaviourDoGUIiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS1_E: __Z18MonoBehaviourDoGUIiR14ObjectGUIStateN13MonoBehaviour13GUILayoutTypeEi21ScriptingMethodIl2Cpp4PPtrIS1_E, __Z36Light_Set_Custom_PropPixelLightCounti: __Z36Light_Set_Custom_PropPixelLightCounti, __ZN6Object15IsClassIDSealedEi: __ZN6Object15IsClassIDSealedEi, __ZNK5physx9PxD6Joint8isKindOfEPKc: __ZNK5physx9PxD6Joint8isKindOfEPKc, __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE20getMotionConstraintsEv, __Z36Rigidbody2D_Get_Custom_PropSimulatedP12Il2CppObject: __Z36Rigidbody2D_Get_Custom_PropSimulatedP12Il2CppObject, __Z18Transfer_BlittableI8JSONReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Sc9ClothCore17resolveReferencesERNS0_15ClothFabricCoreE: __ZN5physx2Sc9ClothCore17resolveReferencesERNS0_15ClothFabricCoreE, _ttyname_r: _ttyname_r, __Z28sweepCapsule_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z28sweepCapsule_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, _UnityReplayKitRecordingAvailable: _UnityReplayKitRecordingAvailable, __ZNK19LowerResBlitTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK19LowerResBlitTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram12UAVParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIN9ShaderLab20SerializedSubProgram12UAVParameterEE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZNK5physx2Gu15HeightFieldUtil30clipShapeNormalToVertexVoronoiERNS_6PxVec3Ejjj: __ZNK5physx2Gu15HeightFieldUtil30clipShapeNormalToVertexVoronoiERNS_6PxVec3Ejjj, __ZThn4_N16RayRTreeCallbackILi1ELb0EED0Ev: __ZThn4_N16RayRTreeCallbackILi1ELb0EED0Ev, __Z52Register_UnityEngine_WindZone_get_windPulseFrequencyv: __Z52Register_UnityEngine_WindZone_get_windPulseFrequencyv, __Z39Animator_CUSTOM_CheckIfInIKPassInternalP12Il2CppObject: __Z39Animator_CUSTOM_CheckIfInIKPassInternalP12Il2CppObject, __Z25AssetBundle_CUSTOM_UnloadP12Il2CppObjecth: __Z25AssetBundle_CUSTOM_UnloadP12Il2CppObjecth, __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_: __ZN9Behaviour8TransferI14SafeBinaryReadEEvRT_, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19setInvInertiaScale0Ef, __ZNK13ScreenManager14IsStereoscopicEv: __ZNK13ScreenManager14IsStereoscopicEv, __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj: __ZN9GfxDevice22DispatchComputeProgramE12ObjectHandleI18ComputeProgram_TagPvE15ComputeBufferIDj, __ZN22RenderingCommandBuffer23AddSetGlobalMatrixArrayERKN9ShaderLab16FastPropertyNameEPK10Matrix4x4fi: __ZN22RenderingCommandBuffer23AddSetGlobalMatrixArrayERKN9ShaderLab16FastPropertyNameEPK10Matrix4x4fi, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_: __ZN17PackedFloatVector8TransferI14SafeBinaryReadEEvRT_, __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientProbev: __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientProbev, __Z59getPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPKN5physx19PxVehicleEngineDataE: __Z59getPxVehicleEngineDataMDampingRateZeroThrottleClutchEngagedPKN5physx19PxVehicleEngineDataE, __ZN10GameObject31GetSupportedMessagesRecalculateEv: __ZN10GameObject31GetSupportedMessagesRecalculateEv, __ZN9JSONWrite8TransferINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZN23AllocationRootReference7ReleaseEv: __ZN23AllocationRootReference7ReleaseEv, __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE: __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRKyNS0_27EventStreamCompressionFlags4EnumE, __Z42ParticleEmitter_Set_Custom_PropMaxEmissionP12Il2CppObjectf: __Z42ParticleEmitter_Set_Custom_PropMaxEmissionP12Il2CppObjectf, __ZNK5physx12NpConstraint8getForceERNS_6PxVec3ES2_: __ZNK5physx12NpConstraint8getForceERNS_6PxVec3ES2_, __ZN14dtNavMeshQueryD2Ev: __ZN14dtNavMeshQueryD2Ev, __Z56ParticleSystem_ExternalForcesModule_CUSTOM_SetMultiplierP12Il2CppObjectf: __Z56ParticleSystem_ExternalForcesModule_CUSTOM_SetMultiplierP12Il2CppObjectf, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK12CachedWriter12ActiveWriter11GetPositionEv: __ZNK12CachedWriter12ActiveWriter11GetPositionEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj128EEEEEEEvPT_jRKT0_RKT1_j, __ZNK9ShaderLab11ShaderState25InsertUnsupportedVariantsEPKNS_7ProgramE: __ZNK9ShaderLab11ShaderState25InsertUnsupportedVariantsEPKNS_7ProgramE, __ZNK5physx7NpShape21getConvexMeshGeometryERNS_20PxConvexMeshGeometryE: __ZNK5physx7NpShape21getConvexMeshGeometryERNS_20PxConvexMeshGeometryE, __Z31GetUnityConnectScriptingClassesv: __Z31GetUnityConnectScriptingClassesv, _UNITY_FT_New_Memory: _UNITY_FT_New_Memory, __Z36Rigidbody_Get_Custom_PropConstraintsP12Il2CppObject: __Z36Rigidbody_Get_Custom_PropConstraintsP12Il2CppObject, _ft_outline_glyph_init: _ft_outline_glyph_init, __Z23CalculateLightQuadFacSqRKf: __Z23CalculateLightQuadFacSqRKf, _FMOD_Debug_SetLevel: _FMOD_Debug_SetLevel, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE6resizeEjRKS3_, __Z46ParticleSystem_MainModule_CUSTOM_SetStartColorP12Il2CppObjectR18MonoMinMaxGradient: __Z46ParticleSystem_MainModule_CUSTOM_SetStartColorP12Il2CppObjectR18MonoMinMaxGradient, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEEEEjT_j, __ZN5physx23PxMaterialGeneratedInfoC2Ev: __ZN5physx23PxMaterialGeneratedInfoC2Ev, __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Perspectivev: __Z56Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Perspectivev, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8in_availEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8in_availEv, __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv: __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19onConstraintReleaseEv, __ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_: __ZN5physx2Gu17intersectRayAABB2ERKNS_6PxVec3ES3_S3_S3_fRfS4_, __ZN4FMOD8ChannelI12getLoopCountEPi: __ZN4FMOD8ChannelI12getLoopCountEPi, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead11QuaternionfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj: __ZN10__cxxabiv112_GLOBAL__N_119parse_cv_qualifiersEPKcS2_Rj, __Z57GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_MoveWindowiRK5RectTIfE: __Z57GUILayoutUtility_CUSTOM_INTERNAL_CALL_Internal_MoveWindowiRK5RectTIfE, __ZN4FMOD6System14createGeometryEiiPPNS_8GeometryE: __ZN4FMOD6System14createGeometryEiiPPNS_8GeometryE, __ZN12LineRenderer16SetUseWorldSpaceEb: __ZN12LineRenderer16SetUseWorldSpaceEb, __ZN13RenderTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13RenderTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15PackedIntVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15insert_noresizeERKS9_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E15insert_noresizeERKS9_, __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf: __ZN5physx22PxTransformFromSegmentERKNS_6PxVec3ES2_Pf, __ZN4FMOD3DSP7getTypeEP13FMOD_DSP_TYPE: __ZN4FMOD3DSP7getTypeEP13FMOD_DSP_TYPE, __Z10DestripifyIttEvPKT_iPT0_i: __Z10DestripifyIttEvPKT_iPT0_i, __Z40Rigidbody_CUSTOM_INTERNAL_CALL_AddTorqueP12Il2CppObjectRK8Vector3fi: __Z40Rigidbody_CUSTOM_INTERNAL_CALL_AddTorqueP12Il2CppObjectRK8Vector3fi, _vdprintf: _vdprintf, __Z46TerrainData_CUSTOM_INTERNAL_get_heightmapScaleP12Il2CppObjectP8Vector3f: __Z46TerrainData_CUSTOM_INTERNAL_get_heightmapScaleP12Il2CppObjectP8Vector3f, __Z18GetITerrainPhysicsv: __Z18GetITerrainPhysicsv, __ZN9Scripting22CreateScriptableObjectERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Scripting22CreateScriptableObjectERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z72Register_UnityEngine_ParticleSystem_ShapeModule_SetRandomDirectionAmountv: __Z72Register_UnityEngine_ParticleSystem_ShapeModule_SetRandomDirectionAmountv, __ZN4Mesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN4Mesh23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK16SpriteRenderData22IsUVCalculationPendingEv: __ZNK16SpriteRenderData22IsUVCalculationPendingEv, __ZNK7Terrain11GetPositionEv: __ZNK7Terrain11GetPositionEv, _UNITY_png_destroy_read_struct: _UNITY_png_destroy_read_struct, _UNITY_tt_done_blend: _UNITY_tt_done_blend, __Z63Register_UnityEngine_AI_NavMeshAgent_ActivateCurrentOffMeshLinkv: __Z63Register_UnityEngine_AI_NavMeshAgent_ActivateCurrentOffMeshLinkv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj78ENS_22PxRepXPropertyAccessorILj78ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj78ENS_22PxRepXPropertyAccessorILj78ES4_ffEEEEvRKT0_, __ZN5physx7NpScene12executeSolveEPNS_10PxBaseTaskE: __ZN5physx7NpScene12executeSolveEPNS_10PxBaseTaskE, __Z43Register_UnityEngine_GUIStyle_get_fontStylev: __Z43Register_UnityEngine_GUIStyle_get_fontStylev, __ZNK13WheelCollider30GetGlobalForceAppPointDistanceEv: __ZNK13WheelCollider30GetGlobalForceAppPointDistanceEv, __ZNSt3__26locale6globalERKS0_: __ZNSt3__26locale6globalERKS0_, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z13RegisterClassIN5Unity11SpringJointEEvv: __Z13RegisterClassIN5Unity11SpringJointEEvv, __ZNK5physx15NpParticleFluid12getViscosityEv: __ZNK5physx15NpParticleFluid12getViscosityEv, __ZN2UI14DoSyncClippingERNS_13UIInstructionEbRK5RectTIfE: __ZN2UI14DoSyncClippingERNS_13UIInstructionEbRK5RectTIfE, __ZNK5physx9NpFactory15getClothFabricsEPPNS_13PxClothFabricEj: __ZNK5physx9NpFactory15getClothFabricsEPPNS_13PxClothFabricEj, __ZN15DirectorManager22ScheduleForDestructionEP8Playable: __ZN15DirectorManager22ScheduleForDestructionEP8Playable, __Z40AudioSource_Set_Custom_PropBypassEffectsP12Il2CppObjecth: __Z40AudioSource_Set_Custom_PropBypassEffectsP12Il2CppObjecth, __Z18Transfer_BlittableI14SafeBinaryReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z52Register_UnityEngine_AI_NavMeshAgent_get_isPathStalev: __Z52Register_UnityEngine_AI_NavMeshAgent_get_isPathStalev, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8getSceneEv, __ZN9Scripting22RaiseArgumentExceptionEPKcz: __ZN9Scripting22RaiseArgumentExceptionEPKcz, __ZNK5physx2Sc16ActorInteraction13getNPhaseCoreEv: __ZNK5physx2Sc16ActorInteraction13getNPhaseCoreEv, __ZZN15NavMeshObstacle15InitializeClassEvEN33FunctorImpl_207kDidVelocityChange4CallEPviR11MessageData: __ZZN15NavMeshObstacle15InitializeClassEvEN33FunctorImpl_207kDidVelocityChange4CallEPviR11MessageData, __ZN9GfxDevice16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput: __ZN9GfxDevice16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput, _lroundf: _lroundf, __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE: __ZNSt3__26__treeINS_12__value_typeIjjEENS_19__map_value_compareIjS2_NS_4lessIjEELb1EEE13stl_allocatorIS2_L18MemLabelIdentifier58ELi16EEE7destroyEPNS_11__tree_nodeIS2_PvEE, __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj: __ZThn4_N5physx16MemoryBufferBaseINS_18CMemoryPoolManagerEE4readEPvj, __ZN17Physics2DSettings18UpdateBox2DGravityEv: __ZN17Physics2DSettings18UpdateBox2DGravityEv, __ZN5physx18PxcFsFlushVelocityERNS_9PxcFsDataE: __ZN5physx18PxcFsFlushVelocityERNS_9PxcFsDataE, __ZNK3WWW8IsCachedEv: __ZNK3WWW8IsCachedEv, __Z34getNbPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricE: __Z34getNbPxClothFabric_ParticleIndicesPKN5physx13PxClothFabricE, __Z53ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_CollisionModule_CUSTOM_SetLifetimeLossP12Il2CppObjectR15MonoMinMaxCurve, __Z17dynamic_pptr_castIP18AnimatorController25RuntimeAnimatorControllerET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP18AnimatorController25RuntimeAnimatorControllerET_RK4PPtrIT0_E, __ZNK16MemoryFileSystem5IsDirERK13FileEntryData: __ZNK16MemoryFileSystem5IsDirERK13FileEntryData, __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER10GameObjectR13dynamic_arrayI20BoundCurveDeprecatedLj4EE: __ZN15AnimationBinder10BindCurvesERK14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEER10GameObjectR13dynamic_arrayI20BoundCurveDeprecatedLj4EE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4copyEPwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4copyEPwjj, __ZNK5physx2Sn21SerializationRegistry17getSerializerTypeEj: __ZNK5physx2Sn21SerializationRegistry17getSerializerTypeEj, __Z38Joint_CUSTOM_INTERNAL_get_currentForceP12Il2CppObjectP8Vector3f: __Z38Joint_CUSTOM_INTERNAL_get_currentForceP12Il2CppObjectP8Vector3f, __ZNK5Umbra9IndexList7getSizeEv: __ZNK5Umbra9IndexList7getSizeEv, __crypt_extended_r_uut: __crypt_extended_r_uut, __ZN16ParticleRenderer22UpdateParticleRendererEv: __ZN16ParticleRenderer22UpdateParticleRendererEv, __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE15clearCachedDataEv: __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEE15clearCachedDataEv, __ZN17BufferManagerGLES13InvalidateAllEv: __ZN17BufferManagerGLES13InvalidateAllEv, __ZN2UI13DepthSortGrid17AddAndGetDepthForERKNS_23RenderableUIInstructionEPS2_i: __ZN2UI13DepthSortGrid17AddAndGetDepthForERKNS_23RenderableUIInstructionEPS2_i, _PxRegisterPhysicsSerializers: _PxRegisterPhysicsSerializers, __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E: __Z22AddCurveToStreamedClipI8Vector3fEvP19StreamedClipBuilderiRK17AnimationCurveTplIT_E, __ZNSt3__220__get_up_to_n_digitsIwPwEEiRT0_S2_RjRKNS_5ctypeIT_EEi: __ZNSt3__220__get_up_to_n_digitsIwPwEEiRT0_S2_RjRKNS_5ctypeIT_EEi, __Z45Physics2D_Set_Custom_PropShowColliderContactsh: __Z45Physics2D_Set_Custom_PropShowColliderContactsh, __ZN7mecanim9animation10GetWeightsERKNS0_21BlendTreeNodeConstantERNS0_18BlendTreeWorkspaceEPfff: __ZN7mecanim9animation10GetWeightsERKNS0_21BlendTreeNodeConstantERNS0_18BlendTreeWorkspaceEPfff, __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_: __ZN25RuntimeAnimatorController8TransferI17RemapPPtrTransferEEvRT_, __ZN13GfxDeviceGLES15EndProfileEventEv: __ZN13GfxDeviceGLES15EndProfileEventEv, __ZN5physx2Sc15CoreInteraction14addToDirtyListEv: __ZN5physx2Sc15CoreInteraction14addToDirtyListEv, __Z26InitializeEngineNoGraphicsv: __Z26InitializeEngineNoGraphicsv, __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv: __ZN5physx20InternalTriangleMesh18setupMeshInterfaceEv, __Z44Register_UnityEngine_Animator_GetLayerWeightv: __Z44Register_UnityEngine_Animator_GetLayerWeightv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf, __ZN11UnityEngine15CloudWebService17CloudJobSchedulerC2Ev: __ZN11UnityEngine15CloudWebService17CloudJobSchedulerC2Ev, __ZN5physx11NpAggregate15addArticulationERNS_14PxArticulationE: __ZN5physx11NpAggregate15addArticulationERNS_14PxArticulationE, __ZN5physx2Sn5ConvX14exportIntAsPtrEi: __ZN5physx2Sn5ConvX14exportIntAsPtrEi, __ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting: __ZN12AudioManager16SetConfigurationERK27AudioConfigurationScripting, __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb: __ZN22BaseUnityConnectClient10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEPKcjb, __ZN15QualitySettings23GetQualitySettingsNamesEv: __ZN15QualitySettings23GetQualitySettingsNamesEv, __Z38Terrain_Get_Custom_PropLegacyShininessP12Il2CppObject: __Z38Terrain_Get_Custom_PropLegacyShininessP12Il2CppObject, __ZN5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj, __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN22UnityProfilerPerThread20SampleGCMonoCallbackEPvii: __ZN22UnityProfilerPerThread20SampleGCMonoCallbackEPvii, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx24PxsParticleSystemBatcher23scheduleShapeGenerationEPPNS_20PxvParticleSystemSimEPNS_28PxvParticleShapesUpdateInputEjRNS_10PxBaseTaskE: __ZN5physx24PxsParticleSystemBatcher23scheduleShapeGenerationEPPNS_20PxvParticleSystemSimEPNS_28PxvParticleShapesUpdateInputEjRNS_10PxBaseTaskE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj580ENS_22PxRepXPropertyAccessorILj580ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleWheelDataEEEE14handleAccessorILj580ENS_22PxRepXPropertyAccessorILj580ES4_ffEEEEvRKT0_, __Z29StdTemplateConversionFunctionItjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItjEbPvR14SafeBinaryRead, __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK7Texture26GetTypeInfoVirtualInternalEv: __ZNK7Texture26GetTypeInfoVirtualInternalEv, __ZN5physx14PxCloneDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_14PxRigidDynamicE: __ZN5physx14PxCloneDynamicERNS_9PxPhysicsERKNS_11PxTransformERKNS_14PxRigidDynamicE, __Z45Physics2D_Get_Custom_PropLinearSleepTolerancev: __Z45Physics2D_Get_Custom_PropLinearSleepTolerancev, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN19ShaderPropertySheet22GetWritableVectorArrayEi: __ZN19ShaderPropertySheet22GetWritableVectorArrayEi, __Z52GeometryUtility_CUSTOM_INTERNAL_CALL_CalculateBoundsP11Il2CppArrayRK10Matrix4x4fR4AABB: __Z52GeometryUtility_CUSTOM_INTERNAL_CALL_CalculateBoundsP11Il2CppArrayRK10Matrix4x4fR4AABB, __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN24CompressedAnimationCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z45Register_UnityEngine_AndroidJNI_FromLongArrayv: __Z45Register_UnityEngine_AndroidJNI_FromLongArrayv, __ZNK8Animator23GetAnimationSetBindingsEv: __ZNK8Animator23GetAnimationSetBindingsEv, __Z56Register_UnityEngine_ContactPoint_ColliderFromInstanceIdv: __Z56Register_UnityEngine_ContactPoint_ColliderFromInstanceIdv, __Z26Resources_CUSTOM_LoadAsyncP12Il2CppStringP12Il2CppObject: __Z26Resources_CUSTOM_LoadAsyncP12Il2CppStringP12Il2CppObject, __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CBD0Ev: __ZZN5physx28PxcSweepEstimateAnyShapeMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_fEN2CBD0Ev, __Z38AndroidJNI_CUSTOM_SetFloatArrayElement13Il2Cpp_IntPtrif: __Z38AndroidJNI_CUSTOM_SetFloatArrayElement13Il2Cpp_IntPtrif, __ZN14EdgeCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14EdgeCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN27AnimatorControllerParameter14SetDefaultBoolEb: __ZN27AnimatorControllerParameter14SetDefaultBoolEb, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj32EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv, __Z45Register_UnityEngine_WheelCollider_set_radiusv: __Z45Register_UnityEngine_WheelCollider_set_radiusv, __ZltRK8Scalar4fS1_: __ZltRK8Scalar4fS1_, __ZN16CrashReportEventC2ERKS_: __ZN16CrashReportEventC2ERKS_, __ZN5physx2Sc18ParticleSystemCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc18ParticleSystemCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN7Terrain15SetMaterialTypeENS_12MaterialTypeE: __ZN7Terrain15SetMaterialTypeENS_12MaterialTypeE, __ZN8Material10ComputeCRCEv: __ZN8Material10ComputeCRCEv, _llvm_bitreverse_i32: _llvm_bitreverse_i32, __ZNK15ArchiveReadFile4SizeEv: __ZNK15ArchiveReadFile4SizeEv, __Z37Texture_CUSTOM_INTERNAL_get_texelSizeP12Il2CppObjectP13Vector2fIcall: __Z37Texture_CUSTOM_INTERNAL_get_texelSizeP12Il2CppObjectP13Vector2fIcall, __ZN13ConstantForce8TransferI14SafeBinaryReadEEvRT_: __ZN13ConstantForce8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIjjEEPjEEjT0_S5_S5_S5_T_, __Z43Physics2D_Get_Custom_PropVelocityIterationsv: __Z43Physics2D_Get_Custom_PropVelocityIterationsv, __Z42RenderTexture_CUSTOM_INTERNAL_CALL_ReleaseP12Il2CppObject: __Z42RenderTexture_CUSTOM_INTERNAL_CALL_ReleaseP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEEEE15growAndPushBackERKS2_, __ZN2UI14CanvasRenderer14SetPopMaterialEP8Materiali: __ZN2UI14CanvasRenderer14SetPopMaterialEP8Materiali, __Z47Register_UnityEngine_Material_SetFloatArrayImplv: __Z47Register_UnityEngine_Material_SetFloatArrayImplv, __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedMultiplierv, __Z41Rigidbody2D_Get_Custom_PropSharedMaterialP12Il2CppObject: __Z41Rigidbody2D_Get_Custom_PropSharedMaterialP12Il2CppObject, __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_: __ZN14qsort_internal6_QSortIP16RenderObjectDatai26RenderDeferredObjectSorterEEvT_S4_T0_T1_, __Z27getPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj: __Z27getPxClothFabric_RestvaluesPKN5physx13PxClothFabricEPfj, __Z27Screen_CUSTOM_SetResolutioniihi: __Z27Screen_CUSTOM_SetResolutioniihi, __ZNK17ProceduralTexture7IsBakedEv: __ZNK17ProceduralTexture7IsBakedEv, __ZNK13RendererScene19GetStaticSceneNodesEv: __ZNK13RendererScene19GetStaticSceneNodesEv, __ZN5Unity11Adjacencies14CreateDatabaseEv: __ZN5Unity11Adjacencies14CreateDatabaseEv, __ZNKSt3__214__codecvt_utf8IDiE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__214__codecvt_utf8IDiE9do_lengthER11__mbstate_tPKcS5_j, __Z36LineRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf: __Z36LineRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf, __ZNSt3__26locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4swapERS3_: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4swapERS3_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN10GameObject13ComponentPairELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN10GameObject13ComponentPairELj4EEEEvRT_17TransferMetaFlags, __ZN15CapsuleCollider12SetDirectionEi: __ZN15CapsuleCollider12SetDirectionEi, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EOS3_: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEEC1EOS3_, __ZN14AnimationState10SetEnabledEb: __ZN14AnimationState10SetEnabledEb, __ZN10SpookyHash5FinalEPyS0_: __ZN10SpookyHash5FinalEPyS0_, __ZN14BillboardAsset15ThreadedCleanupEv: __ZN14BillboardAsset15ThreadedCleanupEv, __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVEPhSG_Rhb, __ZN15QualitySettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN15QualitySettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN4FMOD12ChannelGroup9setVolumeEf: __ZN4FMOD12ChannelGroup9setVolumeEf, __ZN14DetailRenderer6RenderEP6Camerafifb: __ZN14DetailRenderer6RenderEP6Camerafifb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation17ComputeRootMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKNS0_12MotionOutputERNS_10ValueArrayESB_SB_RNS_8skeleton13SkeletonPoseTIN4math4trsXEEESH_b: __ZN7mecanim9animation17ComputeRootMotionERKNS0_14AvatarConstantERKNS0_14SkeletonTQSMapERKNS0_12MotionOutputERNS_10ValueArrayESB_SB_RNS_8skeleton13SkeletonPoseTIN4math4trsXEEESH_b, _mkfifoat: _mkfifoat, __Z44Register_UnityEngine_Animator_IsInTransitionv: __Z44Register_UnityEngine_Animator_IsInTransitionv, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_18ConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __Z18BuildScriptClassIdRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_: __Z18BuildScriptClassIdRKNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES8_S8_, __ZN23OverlapCallbackNonAlloc14processTouchesEPKN5physx12PxOverlapHitEj: __ZN23OverlapCallbackNonAlloc14processTouchesEPKN5physx12PxOverlapHitEj, __ZNK12WheelJoint2D19GetJointTranslationEv: __ZNK12WheelJoint2D19GetJointTranslationEv, __ZN17SubstanceEnumItem8TransferI14SafeBinaryReadEEvRT_: __ZN17SubstanceEnumItem8TransferI14SafeBinaryReadEEvRT_, __ZZN14PhysicsManager15InitializeClassEvEN15didDestroyWorld7ForwardEv: __ZZN14PhysicsManager15InitializeClassEvEN15didDestroyWorld7ForwardEv, __ZNK13TranslateGLES14GetShaderStageEj: __ZNK13TranslateGLES14GetShaderStageEj, __Z17InitScreenManagerv: __Z17InitScreenManagerv, __ZN16TimerQueriesGLES12ReleaseQueryEj: __ZN16TimerQueriesGLES12ReleaseQueryEj, __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI11AvatarFrameNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN11UnityEngine15CloudWebService14DataDispatcher24IsArchivedSessionExpiredEjj: __ZN11UnityEngine15CloudWebService14DataDispatcher24IsArchivedSessionExpiredEjj, __Z52Register_UnityEngine_Transform_INTERNAL_get_rotationv: __Z52Register_UnityEngine_Transform_INTERNAL_get_rotationv, _UNITY_FT_Stream_Read: _UNITY_FT_Stream_Read, _pshinter_module_class_pic_init: _pshinter_module_class_pic_init, __ZN7mecanim9animation16MotionOutputCopyEPNS0_12MotionOutputEPKS1_bbRKNS_6bitsetILj66EEE: __ZN7mecanim9animation16MotionOutputCopyEPNS0_12MotionOutputEPKS1_bbRKNS_6bitsetILj66EEE, __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE: __ZN7mecanim9animation23DestroyControllerMemoryEPNS0_16ControllerMemoryERNS_6memory9AllocatorE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE12readPropertyIfEEbRT_, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale1Ev: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16getInvMassScale1Ev, __ZN5Unity9Component7SetNameEPKc: __ZN5Unity9Component7SetNameEPKc, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6lengthEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6lengthEv, __ZNKSt3__210moneypunctIcLb0EE13negative_signEv: __ZNKSt3__210moneypunctIcLb0EE13negative_signEv, __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE: __Z23GetComponentsInChildrenRK10GameObjectbPKN5Unity4TypeER13dynamic_arrayIPNS2_9ComponentELj4EE, __ZN5physx2Sc5Scene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh: __ZN5physx2Sc5Scene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh, __Z47ParticleSystem_LightsModule_CUSTOM_GetIntensityP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_LightsModule_CUSTOM_GetIntensityP12Il2CppObjectR15MonoMinMaxCurve, __ZN21BillboardBatchManager23SetBillboardShaderPropsER16ShaderKeywordSetR24BuiltinShaderParamValuesbRK10Matrix4x4fRK8Vector3f: __ZN21BillboardBatchManager23SetBillboardShaderPropsER16ShaderKeywordSetR24BuiltinShaderParamValuesbRK10Matrix4x4fRK8Vector3f, __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetEnabledv: __Z70Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetEnabledv, __ZN6prcoreL12RemapGenericI15TexFormatRGB88811TexFormatI8EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB88811TexFormatI8EEvPKNS_9InnerInfoE, __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUseRandomRowv: __Z79Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetUseRandomRowv, __ZN27ShapeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN27ShapeModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN6Object5ResetEv: __ZN6Object5ResetEv, __ZN13GfxDeviceGLES14BeforeDrawCallEv: __ZN13GfxDeviceGLES14BeforeDrawCallEv, __ZN27AnimationLayerMixerPlayable13GetParametersEj: __ZN27AnimationLayerMixerPlayable13GetParametersEj, __ZN5physx13PxcRunNpBatchEjjjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE: __ZN5physx13PxcRunNpBatchEjjjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE, __ZN5physx8debugger14PvdMarshallingIsiE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsiE12marshalBlockEPKhPhj, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE11prepareDataEv, __Z12GetGfxDevicev: __Z12GetGfxDevicev, __Z53AudioHighPassFilter_Set_Custom_PropHighpassResonanceQP12Il2CppObjectf: __Z53AudioHighPassFilter_Set_Custom_PropHighpassResonanceQP12Il2CppObjectf, __Z7ToLowerINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEET_RKS8_: __Z7ToLowerINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEET_RKS8_, __Z43TrailRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject: __Z43TrailRenderer_Get_Custom_PropNumCapVerticesP12Il2CppObject, __Z19SetLightScissorRectPK5RectTIfEbRS1_bR9GfxDevice: __Z19SetLightScissorRectPK5RectTIfEbRS1_bR9GfxDevice, __Z21SetCurrentMemoryOwnerRK10MemLabelId: __Z21SetCurrentMemoryOwnerRK10MemLabelId, __ZN16UnityAdsSettings18InitializeDefaultsEv: __ZN16UnityAdsSettings18InitializeDefaultsEv, __ZN5Unity11SpringJoint8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity11SpringJoint8TransferI14SafeBinaryReadEEvRT_, __Z34AnimationState_Get_Custom_PropNameP12Il2CppObject: __Z34AnimationState_Get_Custom_PropNameP12Il2CppObject, __Z48NavMeshAgent_CUSTOM_INTERNAL_get_desiredVelocityP12Il2CppObjectP8Vector3f: __Z48NavMeshAgent_CUSTOM_INTERNAL_get_desiredVelocityP12Il2CppObjectP8Vector3f, __ZN5physx14NpRigidDynamic26setKinematicTargetInternalERKNS_11PxTransformE: __ZN5physx14NpRigidDynamic26setKinematicTargetInternalERKNS_11PxTransformE, __Z26InitializeDeveloperConsolev: __Z26InitializeDeveloperConsolev, __Z33RegisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE: __Z33RegisterSerializationCacheBuilderPFvP11Il2CppClassR23CachedSerializationDataRbE, __ZN5physx2Sc5Scene9setLimitsERKNS_13PxSceneLimitsE: __ZN5physx2Sc5Scene9setLimitsERKNS_13PxSceneLimitsE, __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE: __ZN6Camera25SetNormalizedViewportRectERK5RectTIfE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj651ENS_22PxRepXPropertyAccessorILj651ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj651ENS_22PxRepXPropertyAccessorILj651ES4_KffEEEEvRKT0_, __ZNK14UnityWebStream24GetProgressUntilLoadableEv: __ZNK14UnityWebStream24GetProgressUntilLoadableEv, _UNITY_png_set_strip_alpha: _UNITY_png_set_strip_alpha, __Z41Register_UnityEngine_Event_get_clickCountv: __Z41Register_UnityEngine_Event_get_clickCountv, _BF_crypt: _BF_crypt, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj683ES2_NS_21PxVehicleDriveSimDataES6_EEKNS_34PxVehicleDriveSimDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleDriveTankEE15complexPropertyINS_22PxRepXPropertyAccessorILj683ES2_NS_21PxVehicleDriveSimDataES6_EEKNS_34PxVehicleDriveSimDataGeneratedInfoEEEvPjRKT_RT0_, __ZNK29ParticleSystemPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK29ParticleSystemPropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN8LODGroup11LODRendererELj4EEEEvRT_17TransferMetaFlags, __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv: __ZNK26PlayerSettingsSplashScreen33GetSplashScreenBackgroundPortraitEv, __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE19StreamedBinaryWriteILb0EEEvRPT_PKcRjS9_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE19StreamedBinaryWriteILb0EEEvRPT_PKcRjS9_RT0_, __Z50ParticleSystem_ShapeModule_CUSTOM_GetUseMeshColorsP12Il2CppObject: __Z50ParticleSystem_ShapeModule_CUSTOM_GetUseMeshColorsP12Il2CppObject, __ZN23ForwardShaderRenderLoopC2E10MemLabelId: __ZN23ForwardShaderRenderLoopC2E10MemLabelId, __ZN17RenderLoopContextD0Ev: __ZN17RenderLoopContextD0Ev, __Z61Register_UnityEngine_Rigidbody2D_get_useFullKinematicContactsv: __Z61Register_UnityEngine_Rigidbody2D_get_useFullKinematicContactsv, __ZN5physx2Gu25PersistentContactManifold14getWorldNormalERKNS_6shdfnd3aos12PsTransformVE: __ZN5physx2Gu25PersistentContactManifold14getWorldNormalERKNS_6shdfnd3aos12PsTransformVE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5emptyEv, __Z18MurmurHash1AlignedPKvij: __Z18MurmurHash1AlignedPKvij, __ZN12b2MotorJointC2EPK15b2MotorJointDef: __ZN12b2MotorJointC2EPK15b2MotorJointDef, __Z24LODGroup_CUSTOM_ForceLODP12Il2CppObjecti: __Z24LODGroup_CUSTOM_ForceLODP12Il2CppObjecti, __Z17IsUsingSubEmitterP14ParticleSystem: __Z17IsUsingSubEmitterP14ParticleSystem, __Z42Register_UnityEngine_LODGroup_get_lodCountv: __Z42Register_UnityEngine_LODGroup_get_lodCountv, __Z34AnimationState_Set_Custom_PropTimeP12Il2CppObjectf: __Z34AnimationState_Set_Custom_PropTimeP12Il2CppObjectf, __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_: __ZN13sorted_vectorINSt3__24pairIi14ConstantStringEEN10vector_mapIiS2_NS0_4lessIiEENS0_9allocatorIS3_EEE13value_compareES8_E14find_or_insertIiS2_EEvRPT0_RKT_, __Z48Register_UnityEngine_Camera_SetTargetBuffersImplv: __Z48Register_UnityEngine_Camera_SetTargetBuffersImplv, __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_InternalCreatev: __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_InternalCreatev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi1EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIiLi1EEEEvRT_17TransferMetaFlags, __ZN15AnchoredJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15AnchoredJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z38GameObject_CUSTOM_AddComponentInternalP12Il2CppObjectP12Il2CppString: __Z38GameObject_CUSTOM_AddComponentInternalP12Il2CppObjectP12Il2CppString, __Z24setPxD6Joint_LinearLimitPN5physx9PxD6JointERKNS_18PxJointLinearLimitE: __Z24setPxD6Joint_LinearLimitPN5physx9PxD6JointERKNS_18PxJointLinearLimitE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEPKw, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZNK5physx25PxVehicleConstraintShader19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx25PxVehicleConstraintShader19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN5physx5cloth7SwClothD2Ev: __ZN5physx5cloth7SwClothD2Ev, __Z41CharacterController_Get_Custom_PropHeightP12Il2CppObject: __Z41CharacterController_Get_Custom_PropHeightP12Il2CppObject, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_PKc17TransferMetaFlags, __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray: __ZL27ScriptingKeywordNamesToMaskP11Il2CppArray, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj38ENS_11PxRigidBodyEKffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z53Register_UnityEngine_LineRenderer_set_widthMultiplierv: __Z53Register_UnityEngine_LineRenderer_set_widthMultiplierv, _UNITY_png_set_sRGB_gAMA_and_cHRM: _UNITY_png_set_sRGB_gAMA_and_cHRM, _UNITY_png_handle_pHYs: _UNITY_png_handle_pHYs, __ZN26AnimatorOverrideController23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN26AnimatorOverrideController23VirtualRedirectTransferER17RemapPPtrTransfer, __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimev: __Z65Register_UnityEngine_Experimental_Director_DirectorPlayer_GetTimev, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEE7GetFreeEi, __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI6ShaderE8UnityStrEENS_19__map_value_compareIS4_S6_NS_4lessIS4_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZNK21EnlightenSceneMapping32GetSystemAtlasForInputSystemHashERK7Hash128: __ZNK21EnlightenSceneMapping32GetSystemAtlasForInputSystemHashERK7Hash128, __ZN13MonoBehaviour10SmartResetEv: __ZN13MonoBehaviour10SmartResetEv, __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE: __ZN5physx2Gu21computeVertexSpaceOBBERNS0_3BoxERKS1_RKNS_11PxTransformERKNS_11PxMeshScaleE, __ZNSt3__210__time_putC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__210__time_putC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z40RenderTexture_Get_Custom_PropVolumeDepthP12Il2CppObject: __Z40RenderTexture_Get_Custom_PropVolumeDepthP12Il2CppObject, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj, __ZL25GeomMTDCallback_BoxConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL25GeomMTDCallback_BoxConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z44Register_UnityEngine_LensFlare_get_fadeSpeedv: __Z44Register_UnityEngine_LensFlare_get_fadeSpeedv, __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_: __ZNSt3__26vectorI15ComputeShaderCBNS_9allocatorIS1_EEEC2ERKS4_, __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getWorldBoundsEf: __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE14getWorldBoundsEf, __ZN4FMOD12ChannelGroup19getAudibilityFactorEPf: __ZN4FMOD12ChannelGroup19getAudibilityFactorEPf, __Z53Register_UnityEngine_ParticleSystem_set_startLifetimev: __Z53Register_UnityEngine_ParticleSystem_set_startLifetimev, __ZN21UniformBufferTFMethod15UnmapBoneBufferEv: __ZN21UniformBufferTFMethod15UnmapBoneBufferEv, __Z62Register_UnityEngine_WebCamTexture_get_videoVerticallyMirroredv: __Z62Register_UnityEngine_WebCamTexture_get_videoVerticallyMirroredv, __ZNK5physx2Sq10AABBPruner10getPayloadERKj: __ZNK5physx2Sq10AABBPruner10getPayloadERKj, __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR11NodeYSorterP16HeightMeshBVNodeEEvT0_S5_T_, __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE: __ZN5physx2Sn10parseShapeINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEEEEvRT_RPNS_10PxGeometryERNS_6shdfnd5ArrayIPNS_10PxMaterialENSA_19ReflectionAllocatorISD_EEEE, __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj: __ZN7ApiGLES26BindFramebufferDrawBuffersEN2gl6HandleILNS0_10ObjectTypeE9EEEiPKj, __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterTypev: __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterTypev, __Z59AnimatorControllerPlayable_CUSTOM_GetParameterCountInternalR9HPlayable: __Z59AnimatorControllerPlayable_CUSTOM_GetParameterCountInternalR9HPlayable, __Z47Register_UnityEngine_Transform_SetAsLastSiblingv: __Z47Register_UnityEngine_Transform_SetAsLastSiblingv, _XXH64_createState: _XXH64_createState, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_10NpMaterialEEEEEE15growAndPushBackERKS2_, __Z43ParticleSystem_ShapeModule_CUSTOM_SetLengthP12Il2CppObjectf: __Z43ParticleSystem_ShapeModule_CUSTOM_SetLengthP12Il2CppObjectf, __ZN10GUIElement7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10GUIElement7PRODUCEE10MemLabelId18ObjectCreationMode, __Z13RegisterClassI12InputManagerEvv: __Z13RegisterClassI12InputManagerEvv, __Z35ReflectionProbe_Get_Custom_PropTypeP12Il2CppObject: __Z35ReflectionProbe_Get_Custom_PropTypeP12Il2CppObject, __Z32setPxSceneDescBroadPhaseCallbackPN5physx11PxSceneDescEPNS_20PxBroadPhaseCallbackE: __Z32setPxSceneDescBroadPhaseCallbackPN5physx11PxSceneDescEPNS_20PxBroadPhaseCallbackE, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLocalRefv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewLocalRefv, __Z18setPxSpringDampingPN5physx8PxSpringEf: __Z18setPxSpringDampingPN5physx8PxSpringEf, __ZN19b2PrismaticJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_: __ZN19b2PrismaticJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_, __Z16DeleteRenderLoopP10RenderLoop: __Z16DeleteRenderLoopP10RenderLoop, __ZN5physx2Gu16rayAABBIntersectERKNS_6PxVec3ES3_S3_S3_RS1_: __ZN5physx2Gu16rayAABBIntersectERKNS_6PxVec3ES3_S3_S3_RS1_, __ZN5physx7profile30PxProfileMemoryEventBufferImpl12onAllocationEjPKcS3_iPv: __ZN5physx7profile30PxProfileMemoryEventBufferImpl12onAllocationEjPKcS3_iPv, __ZN11ContextGLES7DestroyEv: __ZN11ContextGLES7DestroyEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN15dtProximityGrid7addItemEiPKf: __ZN15dtProximityGrid7addItemEiPKf, __ZNK14VertexDataInfo16GetStreamsLayoutEv: __ZNK14VertexDataInfo16GetStreamsLayoutEv, __ZNK9Projector25CalculateProjectionMatrixEv: __ZNK9Projector25CalculateProjectionMatrixEv, __ZN5physx27PxHeightFieldRepXSerializer16objectToFileImplEPKNS_13PxHeightFieldEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx27PxHeightFieldRepXSerializer16objectToFileImplEPKNS_13PxHeightFieldEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN7Joint2D8ReCreateEb: __ZN7Joint2D8ReCreateEb, __Z29NeedToDecompressTextureFormat13TextureFormat: __Z29NeedToDecompressTextureFormat13TextureFormat, __ZN13TargetJoint2D10SmartResetEv: __ZN13TargetJoint2D10SmartResetEv, __Z42setPxVehicleDriveDynData_AutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf: __Z42setPxVehicleDriveDynData_AutoBoxSwitchTimePN5physx21PxVehicleDriveDynDataEf, _jpeg_start_decompress: _jpeg_start_decompress, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv, _unity_z_deflateCopy: _unity_z_deflateCopy, __Z29Transfer_Blittable_ArrayFieldI8JSONRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN11Rigidbody2D7CleanupE19DeactivateOperation: __ZN11Rigidbody2D7CleanupE19DeactivateOperation, __ZN4FMOD7SystemI10recordStopEi: __ZN4FMOD7SystemI10recordStopEi, _jpeg_suppress_tables: _jpeg_suppress_tables, __ZNK9Transform17GetHierarchyCountEv: __ZNK9Transform17GetHierarchyCountEv, __Z46RelativeJoint2D_Set_Custom_PropCorrectionScaleP12Il2CppObjectf: __Z46RelativeJoint2D_Set_Custom_PropCorrectionScaleP12Il2CppObjectf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES6_EELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairI4PPtrI14SphereColliderES6_EELj4EEEEvRT_17TransferMetaFlags, __ZN13ComputeShader10FindKernelERKN9ShaderLab16FastPropertyNameE: __ZN13ComputeShader10FindKernelERKN9ShaderLab16FastPropertyNameE, __Z48Register_UnityEngine_WindZone_get_windTurbulencev: __Z48Register_UnityEngine_WindZone_get_windTurbulencev, __ZNK14DataBufferGLES17UpdateCausesStallEv: __ZNK14DataBufferGLES17UpdateCausesStallEv, __ZN20TextRenderingPrivate8FontImpl11GrowTextureEi: __ZN20TextRenderingPrivate8FontImpl11GrowTextureEi, __ZNK25BlendshapePropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK25BlendshapePropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZN9JSONWrite8TransferI13dynamic_arrayI11QuaternionfLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI11QuaternionfLj4EEEEvRT_PKc17TransferMetaFlags, __ZNKSt3__210moneypunctIwLb0EE10neg_formatEv: __ZNKSt3__210moneypunctIwLb0EE10neg_formatEv, __ZN14ParticleSystem12ClearBuffersEv: __ZN14ParticleSystem12ClearBuffersEv, __ZN13MemoryManager25GetAllocatorContainingPtrEPKv: __ZN13MemoryManager25GetAllocatorContainingPtrEPKv, __Z38Canvas_CUSTOM_GetDefaultCanvasMaterialv: __Z38Canvas_CUSTOM_GetDefaultCanvasMaterialv, __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_13PxRigidStaticEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13do_date_orderEv, __Z85Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_: __Z85Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetRelativePointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_, __ZN5physx2Sc8BodyCore14setMaxAngVelSqEf: __ZN5physx2Sc8BodyCore14setMaxAngVelSqEf, __Z45CharacterController_Set_Custom_PropStepOffsetP12Il2CppObjectf: __Z45CharacterController_Set_Custom_PropStepOffsetP12Il2CppObjectf, __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_GetColorv: __Z58Register_UnityEngine_CanvasRenderer_INTERNAL_CALL_GetColorv, __Z65Register_UnityEngine_RuntimeAnimatorController_get_animationClipsv: __Z65Register_UnityEngine_RuntimeAnimatorController_get_animationClipsv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj484ENS_22PxRepXPropertyAccessorILj484ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN8Animator4PlayE9HPlayableP12Il2CppObject: __ZN8Animator4PlayE9HPlayableP12Il2CppObject, _cpowl: _cpowl, _strtol_l: _strtol_l, __Z45Register_UnityEngine_CullingGroup_GetDistancev: __Z45Register_UnityEngine_CullingGroup_GetDistancev, __ZN9b2Fixture7DestroyEP16b2BlockAllocator: __ZN9b2Fixture7DestroyEP16b2BlockAllocator, __ZN4FMOD8ChannelI9setVolumeEf: __ZN4FMOD8ChannelI9setVolumeEf, __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN15QualitySettings14QualitySettingENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE8pushNameEPKc, __ZN5physx3Ext13DistanceJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext13DistanceJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN11AudioSource24SetBypassListenerEffectsEb: __ZN11AudioSource24SetBypassListenerEffectsEb, __ZN5Unity12PhysicsQuery21OverlapSphereInternalERK8Vector3ffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE: __ZN5Unity12PhysicsQuery21OverlapSphereInternalERK8Vector3ffi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE, __ZN19MeshParticleEmitter12CleanupClassEv: __ZN19MeshParticleEmitter12CleanupClassEv, __ZN13GfxDeviceGLES16CreateDepthStateERK13GfxDepthState: __ZN13GfxDeviceGLES16CreateDepthStateERK13GfxDepthState, __Z27GetNumScenesInBuildSettingsv: __Z27GetNumScenesInBuildSettingsv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj566ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj566ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z35setPxVehicleDriveDynDataMTargetGearPN5physx21PxVehicleDriveDynDataEj: __Z35setPxVehicleDriveDynDataMTargetGearPN5physx21PxVehicleDriveDynDataEj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12PPtrKeyframeLj4EEEEvRT_17TransferMetaFlags, __ZN5physx9PxTaskMgrD2Ev: __ZN5physx9PxTaskMgrD2Ev, __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2EPKcj: __ZNSt3__214codecvt_bynameIwc11__mbstate_tEC2EPKcj, __ZNSt3__213shared_futureIvED2Ev: __ZNSt3__213shared_futureIvED2Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj84ENS_22PxRepXPropertyAccessorILj84ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj84ENS_22PxRepXPropertyAccessorILj84ES4_ffEEEEvRKT0_, __Z21getPxJoint_ConstraintPKN5physx7PxJointE: __Z21getPxJoint_ConstraintPKN5physx7PxJointE, _syslog: _syslog, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI15OrderedCallbackS2_EEPS2_EEbT0_S6_T_, __Z50Register_UnityEngine_ComputeBuffer_InternalGetDatav: __Z50Register_UnityEngine_ComputeBuffer_InternalGetDatav, _tt_size_request: _tt_size_request, __ZNSt3__214collate_bynameIwED2Ev: __ZNSt3__214collate_bynameIwED2Ev, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEEEEjT_j, __ZNK20BufferedSocketStream23IsArtificiallyConnectedEv: __ZNK20BufferedSocketStream23IsArtificiallyConnectedEv, __ZN5Flare12FlareElement8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Flare12FlareElement8TransferI24GenerateTypeTreeTransferEEvRT_, __Z16CalculateWeightsILb0EEvPP14AnimationStateiiPfi: __Z16CalculateWeightsILb0EEvPP14AnimationStateiiPfi, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZNK20IntermediateRenderer16GetMaterialCountEv: __ZNK20IntermediateRenderer16GetMaterialCountEv, __ZN12MemoryStreamD2Ev: __ZN12MemoryStreamD2Ev, __ZN11NoiseModuleD2Ev: __ZN11NoiseModuleD2Ev, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11detachShapeERNS_7PxShapeEb: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE11detachShapeERNS_7PxShapeEb, __GLOBAL__sub_I_runtime_containers_lump_cpp: __GLOBAL__sub_I_runtime_containers_lump_cpp, __ZL23FindShadowCastingLightsR12ActiveLightsR13dynamic_arrayI13ShadowedLightLj16EEjj: __ZL23FindShadowCastingLightsR12ActiveLightsR13dynamic_arrayI13ShadowedLightLj16EEjj, __Z37Register_UnityEngine_Gradient_SetKeysv: __Z37Register_UnityEngine_Gradient_SetKeysv, __Z21CalculateMipMapOffsetii13TextureFormati: __Z21CalculateMipMapOffsetii13TextureFormati, __ZN5physx17AggregateAABBTaskC2Ev: __ZN5physx17AggregateAABBTaskC2Ev, __ZN15DirectorManager15InitializeClassEv: __ZN15DirectorManager15InitializeClassEv, __ZNK5physx17SapUpdateWorkTask7getNameEv: __ZNK5physx17SapUpdateWorkTask7getNameEv, __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddExplosionForcev: __Z62Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddExplosionForcev, __ZN25ParticleSystemGeometryJob13ReleaseMemJobEP25DynamicVBOGeometryJobData: __ZN25ParticleSystemGeometryJob13ReleaseMemJobEP25DynamicVBOGeometryJobData, __ZL31GeomOverlapCallback_PlaneConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL31GeomOverlapCallback_PlaneConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z13RegisterClassI17PolygonCollider2DEvv: __Z13RegisterClassI17PolygonCollider2DEvv, __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EEclEv: __ZNSt3__223mersenne_twister_engineIjLj32ELj624ELj397ELj31ELj2567483615ELj11ELj4294967295ELj7ELj2636928640ELj15ELj4022730752ELj18ELj1812433253EEclEv, __ZNK5physx7NpScene10getGravityEv: __ZNK5physx7NpScene10getGravityEv, __Z54Register_UnityEngine_ReflectionProbe_set_nearClipPlanev: __Z54Register_UnityEngine_ReflectionProbe_set_nearClipPlanev, __Z42GUIUtility_Get_Custom_PropSystemCopyBufferv: __Z42GUIUtility_Get_Custom_PropSystemCopyBufferv, __Z20InvalidateNavMeshHitP10NavMeshHit: __Z20InvalidateNavMeshHitP10NavMeshHit, __Z35LensFlare_Set_Custom_PropBrightnessP12Il2CppObjectf: __Z35LensFlare_Set_Custom_PropBrightnessP12Il2CppObjectf, __ZNSt3__215__num_get_floatIeEET_PKcS3_Rj: __ZNSt3__215__num_get_floatIeEET_PKcS3_Rj, _ecvt: _ecvt, __ZN6Camera14StandaloneCullEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEER11CullResults: __ZN6Camera14StandaloneCullEP6ShaderRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEER11CullResults, __ZN2UI13PrepareOutputERNS_7BatchesEjj: __ZN2UI13PrepareOutputERNS_7BatchesEjj, __Z44AudioReverbFilter_Set_Custom_PropRoomRolloffP12Il2CppObjectf: __Z44AudioReverbFilter_Set_Custom_PropRoomRolloffP12Il2CppObjectf, __ZNSt3__214__split_bufferIPPN9ShaderLab21SerializedShaderStateENS_9allocatorIS4_EEE10push_frontERKS4_: __ZNSt3__214__split_bufferIPPN9ShaderLab21SerializedShaderStateENS_9allocatorIS4_EEE10push_frontERKS4_, __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf: __ZL4facejjjRN5physx6PxVec3ERKS0_S3_S3_PfRf, ___crypt_blowfish: ___crypt_blowfish, __ZNK19TextRenderingModule29TMGenGetCursorIndexAtPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfERK8Vector2f: __ZNK19TextRenderingModule29TMGenGetCursorIndexAtPositionEPN13TextRendering17TextMeshGeneratorERK5RectTIfERK8Vector2f, __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi: __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi, __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE8recreateEj, __Z48Register_UnityEngine_Camera_set_stereoSeparationv: __Z48Register_UnityEngine_Camera_set_stereoSeparationv, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z34Register_UnityEngine_Tree_set_datav: __Z34Register_UnityEngine_Tree_set_datav, __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z42PolygonCollider2D_Set_Custom_PropPathCountP12Il2CppObjecti: __Z42PolygonCollider2D_Set_Custom_PropPathCountP12Il2CppObjecti, __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI15ComputeBufferIDP17ComputeBufferGLESEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __Z70Register_UnityEngine_TextGenerator_INTERNAL_CALL_Populate_Internal_cppv: __Z70Register_UnityEngine_TextGenerator_INTERNAL_CALL_Populate_Internal_cppv, __ZN13MonoBehaviour26CalculateSupportedMessagesEv: __ZN13MonoBehaviour26CalculateSupportedMessagesEv, __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __Z44Register_UnityEngine_Animator_ResetTriggerIDv: __Z44Register_UnityEngine_Animator_ResetTriggerIDv, __ZN13WheelCollider32RigidbodyMassDistributionChangedEv: __ZN13WheelCollider32RigidbodyMassDistributionChangedEv, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN10PngDecoder7CleanupEv: __ZN10PngDecoder7CleanupEv, __ZN7mecanim9animation16CreateClipSimpleEjRNS_6memory9AllocatorE: __ZN7mecanim9animation16CreateClipSimpleEjRNS_6memory9AllocatorE, __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14SubstanceInput8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK6Camera24GetScreenViewportRectIntEv: __ZNK6Camera24GetScreenViewportRectIntEv, __ZN5physx3Ext10FixedJoint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext10FixedJoint15importExtraDataERNS_24PxDeserializationContextE, __Z34GameObject_Get_Custom_PropIsStaticP12Il2CppObject: __Z34GameObject_Get_Custom_PropIsStaticP12Il2CppObject, _UNITY_png_get_header_ver: _UNITY_png_get_header_ver, __ZN16MemoryFileSystem4ReadER13FileEntryDatayyPvPy: __ZN16MemoryFileSystem4ReadER13FileEntryDatayyPvPy, __ZNK22BuiltinResourceManager15GetAllResourcesEv: __ZNK22BuiltinResourceManager15GetAllResourcesEv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIdEES4_S4_S4_RNS_8ios_baseERjRT_, __Z26CleanupMemoryProfilerStatsv: __Z26CleanupMemoryProfilerStatsv, __ZNK5Umbra9Matrix4x39isUniformEv: __ZNK5Umbra9Matrix4x39isUniformEv, __Z55Register_UnityEngine_Texture2D_INTERNAL_CALL_ReadPixelsv: __Z55Register_UnityEngine_Texture2D_INTERNAL_CALL_ReadPixelsv, __ZNK5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4sizeEv: __ZNK5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE4sizeEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRt: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRt, __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_11PxAggregateES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __Z39GameObject_CUSTOM_GetComponentsInternalP12Il2CppObjectS0_hhhhS0_: __Z39GameObject_CUSTOM_GetComponentsInternalP12Il2CppObjectS0_hhhhS0_, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_113ClassDescImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS4_, __ZN5physx2Sc7ElementD2Ev: __ZN5physx2Sc7ElementD2Ev, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRx: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRx, __ZN5physx22PxcContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcContactSphereSphereERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZltRK15OrderedCallbackS1_: __ZltRK15OrderedCallbackS1_, __ZN7mecanim8skeleton4Node8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim8skeleton4Node8TransferI14SafeBinaryReadEEvRT_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRe: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRe, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRf: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRf, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_SC_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRl: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRl, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRm: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjRm, __ZN13MonoBehaviour10DeactivateE19DeactivateOperation: __ZN13MonoBehaviour10DeactivateE19DeactivateOperation, __ZN16Physics2DManager18AddEffectorUpdatesEP10Effector2D: __ZN16Physics2DManager18AddEffectorUpdatesEP10Effector2D, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11QuaternionfLj4EEEEvRT_17TransferMetaFlags, __ZN11UnityEngine7Connect20BasePersistentValues12ToJsonStringER8UnityStr: __ZN11UnityEngine7Connect20BasePersistentValues12ToJsonStringER8UnityStr, __ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE: __ZN5physx2Sq16BucketPrunerCore12removeObjectERKNS0_13PrunerPayloadE, __Z29GameObject_Get_Custom_PropTagP12Il2CppObject: __Z29GameObject_Get_Custom_PropTagP12Il2CppObject, _UNITY_png_write_iCCP: _UNITY_png_write_iCCP, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx2Sc16ArticulationCore22setSeparationToleranceEf: __ZN5physx2Sc16ArticulationCore22setSeparationToleranceEf, _cf2_glyphpath_pushMove: _cf2_glyphpath_pushMove, __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z56ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetEnabledP12Il2CppObjecth, __ZN9JSONWrite8TransferI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI10Matrix4x4fLj4EEEEvRT_PKc17TransferMetaFlags, __Z25GL_CUSTOM_InvalidateStatev: __Z25GL_CUSTOM_InvalidateStatev, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__am_pmEv, __ZNK6Camera9GetAspectEv: __ZNK6Camera9GetAspectEv, __ZN12TreeDatabase13ValidateTreesEv: __ZN12TreeDatabase13ValidateTreesEv, __ZNK11dtPathQueue18getRequestPathSizeEj: __ZNK11dtPathQueue18getRequestPathSizeEj, __Z44Register_UnityEngine_AndroidJNI_SetLongFieldv: __Z44Register_UnityEngine_AndroidJNI_SetLongFieldv, __Z27UnloadUnusedAssetsImmediateb: __Z27UnloadUnusedAssetsImmediateb, __ZN5physx2Gu27generatedContactsEEContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE: __ZN5physx2Gu27generatedContactsEEContactsERKNS0_8CapsuleVERNS0_13PolygonalDataERKNS0_15HullPolygonDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNSC_6FloatVERKNSC_5Vec3VE, __Z43Terrain_Set_Custom_PropCollectDetailPatchesP12Il2CppObjecth: __Z43Terrain_Set_Custom_PropCollectDetailPatchesP12Il2CppObjecth, __Z49Register_UnityEngine_AudioChorusFilter_get_dryMixv: __Z49Register_UnityEngine_AudioChorusFilter_get_dryMixv, __ZN19SkinnedMeshRenderer30GetActualRootBoneFromAnyThreadEv: __ZN19SkinnedMeshRenderer30GetActualRootBoneFromAnyThreadEv, __ZN21WorldParticleColliderD2Ev: __ZN21WorldParticleColliderD2Ev, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIcEE, __ZNK10AudioMixer26GetTypeInfoVirtualInternalEv: __ZNK10AudioMixer26GetTypeInfoVirtualInternalEv, __Z46Joint2D_CUSTOM_INTERNAL_CALL_GetReactionTorqueP12Il2CppObjectf: __Z46Joint2D_CUSTOM_INTERNAL_CALL_GetReactionTorqueP12Il2CppObjectf, __Z36Terrain_Get_Custom_PropDrawHeightmapP12Il2CppObject: __Z36Terrain_Get_Custom_PropDrawHeightmapP12Il2CppObject, __ZN5physx16NpParticleSystemD2Ev: __ZN5physx16NpParticleSystemD2Ev, __Z49Register_UnityEngine_Animator_set_feetPivotActivev: __Z49Register_UnityEngine_Animator_set_feetPivotActivev, __Z48Register_UnityEngine_SurfaceEffector2D_set_speedv: __Z48Register_UnityEngine_SurfaceEffector2D_set_speedv, __Z37getPxSceneLimitsMaxNbObjectsPerRegionPKN5physx13PxSceneLimitsE: __Z37getPxSceneLimitsMaxNbObjectsPerRegionPKN5physx13PxSceneLimitsE, __Z40WheelCollider_Get_Custom_PropBrakeTorqueP12Il2CppObject: __Z40WheelCollider_Get_Custom_PropBrakeTorqueP12Il2CppObject, __ZN19CloudServiceHandler12CloseServiceEv: __ZN19CloudServiceHandler12CloseServiceEv, __Z37UnityWebRequest_Get_Custom_PropIsDoneP12Il2CppObject: __Z37UnityWebRequest_Get_Custom_PropIsDoneP12Il2CppObject, __ZN9ShaderLab11ShaderState25FromSerializedShaderStateERKNS_21SerializedShaderStateEP16PropertyNamesSet: __ZN9ShaderLab11ShaderState25FromSerializedShaderStateERKNS_21SerializedShaderStateEP16PropertyNamesSet, __ZN10SampleClip13LoadAudioDataEv: __ZN10SampleClip13LoadAudioDataEv, __ZN4FMOD7SystemI19getRecordNumDriversEPi: __ZN4FMOD7SystemI19getRecordNumDriversEPi, __ZN12LineRendererC2E10MemLabelId18ObjectCreationMode: __ZN12LineRendererC2E10MemLabelId18ObjectCreationMode, __Z48Register_UnityEngine_TerrainData_SetBasemapDirtyv: __Z48Register_UnityEngine_TerrainData_SetBasemapDirtyv, __ZN5physx2Sn5ConvX6read64ERPKv: __ZN5physx2Sn5ConvX6read64ERPKv, __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE14processTouchesEPKS1_j: __ZN16PxOverflowBufferIN5physx12PxOverlapHitEE14processTouchesEPKS1_j, __ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData: __ZN4Mesh15AppendTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEjRKNS1_I7SubMeshS2_IS7_LS3_16ELi16EEEEPK14SharedMeshData, __Z41MonoBehaviour_Get_Custom_PropUseGUILayoutP12Il2CppObject: __Z41MonoBehaviour_Get_Custom_PropUseGUILayoutP12Il2CppObject, __ZNK5physx18PxVehicleDriveTank19getConcreteTypeNameEv: __ZNK5physx18PxVehicleDriveTank19getConcreteTypeNameEv, _UNITY_LZ4_decompress_fast_usingDict: _UNITY_LZ4_decompress_fast_usingDict, __ZN19SkinnedMeshRenderer14UpdateRendererEv: __ZN19SkinnedMeshRenderer14UpdateRendererEv, __Z29StdTemplateConversionFunctionIhjEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhjEbPvR14SafeBinaryRead, __ZNK5physx14PxVehicleGraph19computeGraphChannelEjPfPNS_6PxVec3EPcj: __ZNK5physx14PxVehicleGraph19computeGraphChannelEjPfPNS_6PxVec3EPcj, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD0Ev: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplD0Ev, __ZN5physx23NpArticulationLinkArray17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx23NpArticulationLinkArray17getBinaryMetaDataERNS_14PxOutputStreamE, __Z20CompareApproximatelyRK10Matrix4x4fS1_f: __Z20CompareApproximatelyRK10Matrix4x4fS1_f, __Z44Canvas_Get_Custom_PropReferencePixelsPerUnitP12Il2CppObject: __Z44Canvas_Get_Custom_PropReferencePixelsPerUnitP12Il2CppObject, _ft_bitmap_glyph_copy: _ft_bitmap_glyph_copy, __ZN20TextRenderingPrivate19NativeTextGenerator9GetBoundsEv: __ZN20TextRenderingPrivate19NativeTextGenerator9GetBoundsEv, __ZN23CloudWebServicesManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN23CloudWebServicesManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx11NpAggregate12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx11NpAggregate12createObjectERPhRNS_24PxDeserializationContextE, __ZN5physx2Sc19ShapeInstancePairLL11updateStateEb: __ZN5physx2Sc19ShapeInstancePairLL11updateStateEb, __ZN5physx23AggregateAABBUpdateTask11runInternalEv: __ZN5physx23AggregateAABBUpdateTask11runInternalEv, __ZN14SphereCollider9GetBoundsEv: __ZN14SphereCollider9GetBoundsEv, __ZNK9AudioClip12GetFrequencyEv: __ZNK9AudioClip12GetFrequencyEv, __ZNSt3__215__thread_structD2Ev: __ZNSt3__215__thread_structD2Ev, __Z45RectTransform_Get_Custom_PropDrivenPropertiesP12Il2CppObject: __Z45RectTransform_Get_Custom_PropDrivenPropertiesP12Il2CppObject, __ZNK30SpriteRendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK30SpriteRendererAnimationBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE7reserveEj: __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE7reserveEj, __ZN5physx2Gu13RTreeMidphaseC2Ev: __ZN5physx2Gu13RTreeMidphaseC2Ev, __ZN5physx2Sc8BodyCore16setLinearDampingEf: __ZN5physx2Sc8BodyCore16setLinearDampingEf, __Z13RegisterClassI16ParticleAnimatorEvv: __Z13RegisterClassI16ParticleAnimatorEvv, __ZN7mecanim9animation18DestroyAvatarInputEPNS0_11AvatarInputERNS_6memory9AllocatorE: __ZN7mecanim9animation18DestroyAvatarInputEPNS0_11AvatarInputERNS_6memory9AllocatorE, __ZN15SerializeTraitsI13TreePrototypeE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI13TreePrototypeE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZNK15ReflectionProbe16GetGlobalExtentsEv: __ZNK15ReflectionProbe16GetGlobalExtentsEv, __ZN5physx2Gu15MeshRayCollider7collideILi1ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_: __ZN5physx2Gu15MeshRayCollider7collideILi1ELi0EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_, __ZNK12BaseRenderer19GetLightmapIndexIntE12LightmapType: __ZNK12BaseRenderer19GetLightmapIndexIntE12LightmapType, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13RevoluteJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, _UNITY_FT_Create_Class_ft_raster1_renderer_class: _UNITY_FT_Create_Class_ft_raster1_renderer_class, __Z26ShaderFromSerializedShaderPKN9ShaderLab16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS3_9allocatorIS7_EEEEbPS6_: __Z26ShaderFromSerializedShaderPKN9ShaderLab16SerializedShaderERNSt3__26vectorI4PPtrI6ShaderENS3_9allocatorIS7_EEEEbPS6_, __ZN8Playable11ClearInputsEb: __ZN8Playable11ClearInputsEb, __ZN21ProceduralTextureData15CopyFromTextureEP17ProceduralTexture: __ZN21ProceduralTextureData15CopyFromTextureEP17ProceduralTexture, __ZN5physx2Sc21ArticulationJointCore12setStiffnessEf: __ZN5physx2Sc21ArticulationJointCore12setStiffnessEf, __ZZ23InitPlayerLoopCallbacksvEN46PostLateUpdatePlayerSendFramePostPresentstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN46PostLateUpdatePlayerSendFramePostPresentstruct7ForwardEv, __ZN8Playable11ClearInputsEv: __ZN8Playable11ClearInputsEv, __Z52Register_UnityEngine_Canvas_get_overridePixelPerfectv: __Z52Register_UnityEngine_Canvas_get_overridePixelPerfectv, __ZNK12PhysXRaycast14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEjbi23QueryTriggerInteractionb: __ZNK12PhysXRaycast14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEjbi23QueryTriggerInteractionb, __ZN5physx2Sc14ConstraintCoreC2ERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj: __ZN5physx2Sc14ConstraintCoreC2ERNS_21PxConstraintConnectorERKNS_23PxConstraintShaderTableEj, __ZNK5physx2Sc15ClothFabricCore7getSetsEPjj: __ZNK5physx2Sc15ClothFabricCore7getSetsEPjj, __Z40Register_UnityEngine_AssetBundle_LoadAllv: __Z40Register_UnityEngine_AssetBundle_LoadAllv, __ZN21InheritVelocityModuleD0Ev: __ZN21InheritVelocityModuleD0Ev, __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE: __ZNSt3__26__treeIyNS_4lessIyEENS_9allocatorIyEEE7destroyEPNS_11__tree_nodeIyPvEE, _UNITY_png_set_compression_method: _UNITY_png_set_compression_method, __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI14SubstanceInputNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __Z35PointEffector2D_Get_Custom_PropDragP12Il2CppObject: __Z35PointEffector2D_Get_Custom_PropDragP12Il2CppObject, __Z40setPxArticulationJoint_SwingLimitEnabledPN5physx19PxArticulationJointEb: __Z40setPxArticulationJoint_SwingLimitEnabledPN5physx19PxArticulationJointEb, __ZN5physx10PxsContext18setBounceThresholdEf: __ZN5physx10PxsContext18setBounceThresholdEf, __ZNK12TreeRenderer13GetTreeBoundsERK12TreeInstance: __ZNK12TreeRenderer13GetTreeBoundsERK12TreeInstance, __ZN9WWWCached13StartDownloadEb: __ZN9WWWCached13StartDownloadEb, __ZN5physx3Scb5Scene7releaseEv: __ZN5physx3Scb5Scene7releaseEv, __Z62Register_UnityEngine_AssetBundleManifest_GetDirectDependenciesv: __Z62Register_UnityEngine_AssetBundleManifest_GetDirectDependenciesv, __ZNK14EdgeCollider2D26GetTypeInfoVirtualInternalEv: __ZNK14EdgeCollider2D26GetTypeInfoVirtualInternalEv, __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIhNS_8debugger19ForwardingAllocatorEED2Ev, __Z37AndroidJNI_CUSTOM_GetStaticFloatField13Il2Cpp_IntPtrS_: __Z37AndroidJNI_CUSTOM_GetStaticFloatField13Il2Cpp_IntPtrS_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine26SelectorTransitionConstantEEEEEvRT_17TransferMetaFlags, __ZN9GfxDevice17CreateIndexBufferEv: __ZN9GfxDevice17CreateIndexBufferEv, _srandom: _srandom, __Z26GetUniqueTempPathInProjectv: __Z26GetUniqueTempPathInProjectv, __Z10FilterRowsP13CImageSurfaceRS_iiiiifbfiiR17PrecomputeContext: __Z10FilterRowsP13CImageSurfaceRS_iiiiifbfiiR17PrecomputeContext, __ZNK5physx2Gu15HeightFieldUtil30getFaceIndexAtShapePointNoTestEff: __ZNK5physx2Gu15HeightFieldUtil30getFaceIndexAtShapePointNoTestEff, __ZN17ProfilerFrameData15AllocTimerQueryEv: __ZN17ProfilerFrameData15AllocTimerQueryEv, __ZN11AudioSource16CheckConsistencyEv: __ZN11AudioSource16CheckConsistencyEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17setStaticFrictionEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17setStaticFrictionEf, __ZNK20LocalFileSystemPosix25GetApplicationManagedPathEv: __ZNK20LocalFileSystemPosix25GetApplicationManagedPathEv, __ZN15FileSystemEntry9MakeLocalEb: __ZN15FileSystemEntry9MakeLocalEb, __ZN19ParticleSystemState8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19ParticleSystemState8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN21UnityAnalyticsManager13InitAnalyticsEv: __ZN21UnityAnalyticsManager13InitAnalyticsEv, __Z26ApplyMaterialPassWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms: __Z26ApplyMaterialPassWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms, __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE: __ZN5physx2Sc16InteractionScene11removeActorERNS0_5ActorE, __Z36getPxMaterial_RestitutionCombineModePKN5physx10PxMaterialE: __Z36getPxMaterial_RestitutionCombineModePKN5physx10PxMaterialE, __ZN22UnityProfilerPerThread26BeforeDomainUnloadCallbackEv: __ZN22UnityProfilerPerThread26BeforeDomainUnloadCallbackEv, __ZN2UI6Canvas13AwakeFromLoadE17AwakeFromLoadMode: __ZN2UI6Canvas13AwakeFromLoadE17AwakeFromLoadMode, __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData: __ZN9DepthPass13PrepareSubsetEjRK10RenderNodeifRK17ShaderReplaceData, __ZN5physx6shdfnd9MutexImpl4lockEv: __ZN5physx6shdfnd9MutexImpl4lockEv, __ZN22MotionVectorRenderLoopD0Ev: __ZN22MotionVectorRenderLoopD0Ev, __Z22MonoGUIContentToNativeP12Il2CppObjectR10GUIContent: __Z22MonoGUIContentToNativeP12Il2CppObjectR10GUIContent, __Z36getNbPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataE: __Z36getNbPxVehicleWheelsSimData_TireDataPKN5physx22PxVehicleWheelsSimDataE, __ZN13CameraLODData7ExtractER12LODDataArray: __ZN13CameraLODData7ExtractER12LODDataArray, __Z12SetupSteppedPfRK11KeyframeTplIfES3_: __Z12SetupSteppedPfRK11KeyframeTplIfES3_, __ZN13ComputeShader23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13ComputeShader23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj565ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleTireLoadFilterDataEEEEclILj565ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z9ReadPixelI11ColorRGBA32ET_PKh13TextureFormat: __Z9ReadPixelI11ColorRGBA32ET_PKh13TextureFormat, __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_: __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_21PxProfileEventHandlerELb0EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS8_INS0_9StopEventENS8_INS0_18RelativeStartEventENS8_INS0_17RelativeStopEventENS8_INS0_10EventValueENS8_INS0_17CUDAProfileBufferENS8_IhNS0_5EmptyEEEEEEEEEEEEEEET0_, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED2Ev: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEED2Ev, __ZN9HaloLayer15ThreadedCleanupEv: __ZN9HaloLayer15ThreadedCleanupEv, __Z45setPxRevoluteJoint_ProjectionAngularTolerancePN5physx15PxRevoluteJointEf: __Z45setPxRevoluteJoint_ProjectionAngularTolerancePN5physx15PxRevoluteJointEf, __ZN4FMOD8ChannelI18getInputChannelMixEPfi: __ZN4FMOD8ChannelI18getInputChannelMixEPfi, __ZN17Physics2DSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17Physics2DSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKRotationInternalP12Il2CppObjectiR11Quaternionf: __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKRotationInternalP12Il2CppObjectiR11Quaternionf, __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE: __ZN14CachingManager12ReadInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPlPNS0_6vectorIS6_NS4_IS6_EEEE, __ZN18ProfilerConnection32HandleSetMemoryRecordModeMessageEPKvjj: __ZN18ProfilerConnection32HandleSetMemoryRecordModeMessageEPKvjj, __Z47Rigidbody_Set_Custom_PropCollisionDetectionModeP12Il2CppObjecti: __Z47Rigidbody_Set_Custom_PropCollisionDetectionModeP12Il2CppObjecti, __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEE: __ZN14CachingManager13WriteInfoFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERKNS0_6vectorIS6_NS4_IS6_EEEE, __ZNK5physx25PxVehicleGraphChannelDesc7isValidEv: __ZNK5physx25PxVehicleGraphChannelDesc7isValidEv, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl23findPropertyMessageImplERKN5physx8debugger14NamespacedNameE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl23findPropertyMessageImplERKN5physx8debugger14NamespacedNameE, __ZN16PlayerConnection8IsServerEv: __ZN16PlayerConnection8IsServerEv, __Z36Profiler_CUSTOM_GetRuntimeMemorySizeP12Il2CppObject: __Z36Profiler_CUSTOM_GetRuntimeMemorySizeP12Il2CppObject, __ZNK9WWWCached6GetETAEv: __ZNK9WWWCached6GetETAEv, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4gptrEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4gptrEv, __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L12ucs4_to_utf8EPKjS1_RS1_PhS3_RS3_mNS_12codecvt_modeE, __ZN13ConstantForce12AddToManagerEv: __ZN13ConstantForce12AddToManagerEv, __Z28TerrainData_CUSTOM_GetHeightP12Il2CppObjectii: __Z28TerrainData_CUSTOM_GetHeightP12Il2CppObjectii, __Z31TextMesh_Get_Custom_PropTabSizeP12Il2CppObject: __Z31TextMesh_Get_Custom_PropTabSizeP12Il2CppObject, __ZN14MemoryProfiler15AllocateStructsEv: __ZN14MemoryProfiler15AllocateStructsEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE8pushNameEPKc, __ZN5physx2Sc16ArticulationCore24setSolverIterationCountsEt: __ZN5physx2Sc16ArticulationCore24setSolverIterationCountsEt, __ZNK5physx10PxsContext15getCCDMaxPassesEv: __ZNK5physx10PxsContext15getCCDMaxPassesEv, __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI9TransformEN7VRInput18ReferenceTransformEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier87ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN13OcclusionArea7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13OcclusionArea7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK13RenderTexture22GetSupportedMipMapFlagEb: __ZNK13RenderTexture22GetSupportedMipMapFlagEb, __Z25ApproximateUVDistributionPK10Matrix4x4fR4MeshRK8Vector2ffi: __Z25ApproximateUVDistributionPK10Matrix4x4fR4MeshRK8Vector2ffi, __ZN15LocationService14GetLastHeadingEv: __ZN15LocationService14GetLastHeadingEv, __ZN5Unity10FixedJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity10FixedJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12MeshCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12MeshCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _UNITY_png_set_compression_buffer_size: _UNITY_png_set_compression_buffer_size, __ZN4gles10InvalidateERK14GfxContextGLESR15DeviceStateGLES: __ZN4gles10InvalidateERK14GfxContextGLESR15DeviceStateGLES, __ZN10GUITexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10GUITexture7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN21LightProbeProxyVolume7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN21LightProbeProxyVolume7PRODUCEE10MemLabelId18ObjectCreationMode, _clearerr: _clearerr, __ZN10CBBoxInt32C2Ev: __ZN10CBBoxInt32C2Ev, __ZNSt3__213__vector_baseIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEED2Ev: __ZNSt3__213__vector_baseIN19SpriteMeshGenerator4pathENS_9allocatorIS2_EEED2Ev, __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_14PxArticulationES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb0EE6GetKeyES8_Lb0EE6createERKS4_Rb, __ZNSt3__217iostream_categoryEv: __ZNSt3__217iostream_categoryEv, __ZN5physx27PxcContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx27PxcContactSphereHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZThn4_N12_GLOBAL__N_111StreamOwner7releaseEv: __ZThn4_N12_GLOBAL__N_111StreamOwner7releaseEv, __ZN11BoxCollider8TransferI14SafeBinaryReadEEvRT_: __ZN11BoxCollider8TransferI14SafeBinaryReadEEvRT_, __ZN5Umbra5QueryC2ERKS0_: __ZN5Umbra5QueryC2ERKS0_, __ZN5physx11PxMeshQuery23findOverlapTriangleMeshERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_PjjjRb: __ZN5physx11PxMeshQuery23findOverlapTriangleMeshERKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES6_PjjjRb, __ZN24iPhoneRemoteNotificationD2Ev: __ZN24iPhoneRemoteNotificationD2Ev, __Z33Font_Get_Custom_PropCharacterInfoP12Il2CppObject: __Z33Font_Get_Custom_PropCharacterInfoP12Il2CppObject, __ZN15ReflectionProbe19ScheduleFullRefreshEv: __ZN15ReflectionProbe19ScheduleFullRefreshEv, __ZNSt3__212strstreambufC2EPKhi: __ZNSt3__212strstreambufC2EPKhi, __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15RelativeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11AudioSourceD2Ev: __ZN11AudioSourceD2Ev, __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Vector4f8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z43Register_UnityEngine_RemoteSettings_GetBoolv: __Z43Register_UnityEngine_RemoteSettings_GetBoolv, __ZN5physx11NpReadCheckC2EPKNS_7NpSceneEPKc: __ZN5physx11NpReadCheckC2EPKNS_7NpSceneEPKc, __Z40GUIStyle_CUSTOM_Internal_CalcMinMaxWidth13Il2Cpp_IntPtrP12Il2CppObjectPfS2_: __Z40GUIStyle_CUSTOM_Internal_CalcMinMaxWidth13Il2Cpp_IntPtrP12Il2CppObjectPfS2_, __Z13RegisterClassI4HaloEvv: __Z13RegisterClassI4HaloEvv, __ZN8Material17SetShaderKeywordsERK8UnityStr: __ZN8Material17SetShaderKeywordsERK8UnityStr, __ZN7b2Timer5ResetEv: __ZN7b2Timer5ResetEv, __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj: __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationAngleEj, __ZN21EnlightenSceneMapping8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21EnlightenSceneMapping8TransferI24GenerateTypeTreeTransferEEvRT_, __Z33SpringJoint_Get_Custom_PropSpringP12Il2CppObject: __Z33SpringJoint_Get_Custom_PropSpringP12Il2CppObject, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj: __ZNSt3__27codecvtIwc11__mbstate_tEC2EPKcj, __ZN13RenderTexture28GetCreatedRenderTextureCountEv: __ZN13RenderTexture28GetCreatedRenderTextureCountEv, __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46getPxSimulationStatisticsNbActiveDynamicBodiesPKN5physx22PxSimulationStatisticsE: __Z46getPxSimulationStatisticsNbActiveDynamicBodiesPKN5physx22PxSimulationStatisticsE, __ZN15FileSystemEntryC2ERK13FileEntryData: __ZN15FileSystemEntryC2ERK13FileEntryData, __ZN4PPtrI17ProceduralTextureE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI17ProceduralTextureE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc19ShapeInstancePairLL7destroyEv: __ZN5physx2Sc19ShapeInstancePairLL7destroyEv, __ZN5physx2Sc19ShapeInstancePairLL34setContactReportPostSolverVelocityERNS0_20ContactStreamManagerE: __ZN5physx2Sc19ShapeInstancePairLL34setContactReportPostSolverVelocityERNS0_20ContactStreamManagerE, __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI8UnityStrNS_4lessIS1_EENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpClothFabricEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN15LODGroupManagerC2E10MemLabelId: __ZN15LODGroupManagerC2E10MemLabelId, __ZN10SampleClip15ThreadedCleanupEv: __ZN10SampleClip15ThreadedCleanupEv, __ZN9Scripting30CreateScriptableObjectWithTypeEP12Il2CppObjectb: __ZN9Scripting30CreateScriptableObjectWithTypeEP12Il2CppObjectb, __ZN29AssetBundleLoadAssetOperation18GetAllLoadedAssetsER13dynamic_arrayIP6ObjectLj4EE: __ZN29AssetBundleLoadAssetOperation18GetAllLoadedAssetsER13dynamic_arrayIP6ObjectLj4EE, __ZN15PointEffector2D14SetAngularDragEf: __ZN15PointEffector2D14SetAngularDragEf, __ZN13ModuleManager3GetEv: __ZN13ModuleManager3GetEv, __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEE7SortJobEPS6_: __ZN14qsort_internal18QSortSingleJobDataIP21ForwardRenderPassDataiN23ForwardShaderRenderLoop18RenderObjectSorterILb1EEEE7SortJobEPS6_, __ZThn4_N5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE: __ZThn4_N5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE, __ZN9ShaderLab14SerializedPass8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab14SerializedPass8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR26ColliderIdentityComparitorPP10Collider2DEEjT0_S6_S6_S6_S6_T_, __ZN5Flare15ThreadedCleanupEv: __ZN5Flare15ThreadedCleanupEv, __ZN10__cxxabiv117__array_type_infoD0Ev: __ZN10__cxxabiv117__array_type_infoD0Ev, __Z13SetCopyBufferRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z13SetCopyBufferRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN5physx2Sc5Scene24fireOutOfBoundsCallbacksEv: __ZN5physx2Sc5Scene24fireOutOfBoundsCallbacksEv, __Z24RegisterStrippedTypeInfoI12ScriptMapperEviPKcS2_: __Z24RegisterStrippedTypeInfoI12ScriptMapperEviPKcS2_, __Z17GL_CUSTOM_Vertex3fff: __Z17GL_CUSTOM_Vertex3fff, __Z21CleanupEngineGraphicsv: __Z21CleanupEngineGraphicsv, __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f: __ZN12VertexWelderILi2048EE9AddUniqueERK8Vector3f, __ZNK13EmscriptenWWW7GetTypeEv: __ZNK13EmscriptenWWW7GetTypeEv, __Z33Register_UnityEngine_GL_PopMatrixv: __Z33Register_UnityEngine_GL_PopMatrixv, __ZN15Lz4DecompressorD0Ev: __ZN15Lz4DecompressorD0Ev, __ZN11UnityEngine15PlatformWrapper19GetScreenResolutionEv: __ZN11UnityEngine15PlatformWrapper19GetScreenResolutionEv, __ZN6prcore15ClearImageFloatER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE: __ZN6prcore15ClearImageFloatER14ImageReferenceRK11ColorRGBA32NS0_9ClearModeE, __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc9ActorPairENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN8Animator28SetRuntimeAnimatorControllerEP25RuntimeAnimatorController: __ZN8Animator28SetRuntimeAnimatorControllerEP25RuntimeAnimatorController, __ZN13Simd4fFactoryIRKfEC2ES1_: __ZN13Simd4fFactoryIRKfEC2ES1_, __ZN5physx14NpSpatialIndex11rebuildFullEv: __ZN5physx14NpSpatialIndex11rebuildFullEv, __ZN6Avatar8TransferI14SafeBinaryReadEEvRT_: __ZN6Avatar8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_: __ZNSt3__26vectorIjNS_9allocatorIjEEE21__push_back_slow_pathIKjEEvRT_, __ZN38AssetBundleLoadFromCacheAsyncOperation20ExecuteSynchronouslyEv: __ZN38AssetBundleLoadFromCacheAsyncOperation20ExecuteSynchronouslyEv, __ZNK5physx7NpCloth27getNbVirtualParticleWeightsEv: __ZNK5physx7NpCloth27getNbVirtualParticleWeightsEv, __ZN15SerializeTraitsI16SplashScreenLogoE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI16SplashScreenLogoE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN17TransformInternal23AllocateTransformThreadER18TransformHierarchyjj: __ZN17TransformInternal23AllocateTransformThreadER18TransformHierarchyjj, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4Ejj, __ZN21AssetBundleFileSystem10AddArchiveEP20ArchiveStorageReader: __ZN21AssetBundleFileSystem10AddArchiveEP20ArchiveStorageReader, __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity11SpringJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z23AudioSource_CUSTOM_PlayP12Il2CppObjecty: __Z23AudioSource_CUSTOM_PlayP12Il2CppObjecty, __ZN12_GLOBAL__N_118LegacySerialStream9writeNameEPKc: __ZN12_GLOBAL__N_118LegacySerialStream9writeNameEPKc, __Z53Register_UnityEngine_Rigidbody_set_maxAngularVelocityv: __Z53Register_UnityEngine_Rigidbody_set_maxAngularVelocityv, __Z38Application_Get_Custom_PropIsWebPlayerv: __Z38Application_Get_Custom_PropIsWebPlayerv, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN5physx33PxVehicleChassisDataGeneratedInfoC2Ev: __ZN5physx33PxVehicleChassisDataGeneratedInfoC2Ev, __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI19StreamedBinaryWriteILb0EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDriveNWEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN14AnimationStateD2Ev: __ZN14AnimationStateD2Ev, __ZN8VRDevice11FixedUpdateEv: __ZN8VRDevice11FixedUpdateEv, __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11LightProbes14LightProbeData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK9GfxDevice14GetDeviceLevelEv: __ZNK9GfxDevice14GetDeviceLevelEv, __ZN9GfxDevice19RenderTargetBarrierEv: __ZN9GfxDevice19RenderTargetBarrierEv, __ZN15ConstantForce2D16SetRelativeForceERK8Vector2f: __ZN15ConstantForce2D16SetRelativeForceERK8Vector2f, __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev: __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorED2Ev, __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayout: __ZN4Mesh14ResizeVerticesEjjjRK20VertexChannelsLayout, _regfree: _regfree, __ZN4Mesh15SetSubMeshCountEjb: __ZN4Mesh15SetSubMeshCountEjb, __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb: __ZN5physx2Gu15GJKLocalRayCastERNS0_9TriangleVERNS0_8CapsuleVERKNS_6shdfnd3aos6FloatVERKNS6_5Vec3VESC_RS7_RSA_SE_fb, __ZN18AssetBundleManager14AddPreloadDataEiR13dynamic_arrayINS_11PreloadDataELj8EEb: __ZN18AssetBundleManager14AddPreloadDataEiR13dynamic_arrayINS_11PreloadDataELj8EEb, __Z40Cloth_Get_Custom_PropStretchingStiffnessP12Il2CppObject: __Z40Cloth_Get_Custom_PropStretchingStiffnessP12Il2CppObject, __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRN15ResourceManager10Dependency6SorterEPS2_EEjT0_S6_S6_S6_T_, __ZN13GfxDeviceNullD2Ev: __ZN13GfxDeviceNullD2Ev, __Z72Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayListImplv: __Z72Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayListImplv, __ZN5physx6shdfnd10FoundationC2ERNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE: __ZN5physx6shdfnd10FoundationC2ERNS_15PxErrorCallbackERNS_19PxAllocatorCallbackE, __ZNSt3__210istrstreamD0Ev: __ZNSt3__210istrstreamD0Ev, __ZNK5physx7NpCloth24getSelfCollisionDistanceEv: __ZNK5physx7NpCloth24getSelfCollisionDistanceEv, __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j: __ZN5physx2Gu15getClosestPointEPKNS_6shdfnd3aos5Vec3VES5_S5_RS4_RS3_S7_j, __Z47PlatformEffector2D_Set_Custom_PropUseSideBounceP12Il2CppObjecth: __Z47PlatformEffector2D_Set_Custom_PropUseSideBounceP12Il2CppObjecth, __Z17IntersectAABBAABBRK10MinMaxAABBS1_: __Z17IntersectAABBAABBRK10MinMaxAABBS1_, __Z15PluginsGetCountv: __Z15PluginsGetCountv, __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_RemoveTreesv: __Z54Register_UnityEngine_Terrain_INTERNAL_CALL_RemoveTreesv, __ZN10Matrix4x4f16AdjustDepthRangeEfff: __ZN10Matrix4x4f16AdjustDepthRangeEfff, __ZN23ArchiveStorageConverter21FinalizeTargetArchiveEPj: __ZN23ArchiveStorageConverter21FinalizeTargetArchiveEPj, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, __ZN5physx3Ext14SphericalJoint11prepareDataEv: __ZN5physx3Ext14SphericalJoint11prepareDataEv, _UNITY_png_read_info: _UNITY_png_read_info, __ZN13GfxDeviceNull32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat: __ZN13GfxDeviceNull32CreateColorRenderSurfacePlatformEP17RenderSurfaceBase19RenderTextureFormat, __ZN18ScriptingArguments11GetUInt64AtEi: __ZN18ScriptingArguments11GetUInt64AtEi, __ZNK26AnimatorControllerPlayable8HasStateEii: __ZNK26AnimatorControllerPlayable8HasStateEii, __ZN9LensFlareD2Ev: __ZN9LensFlareD2Ev, __ZN5Umbra4Math5atan2ENS_5FloatES1_: __ZN5Umbra4Math5atan2ENS_5FloatES1_, __ZNSt3__213shared_futureIvEaSERKS1_: __ZNSt3__213shared_futureIvEaSERKS1_, __ZN4FMOD3DSP9getActiveEPb: __ZN4FMOD3DSP9getActiveEPb, __Z45Register_UnityEngine_AndroidJNI_FromCharArrayv: __Z45Register_UnityEngine_AndroidJNI_FromCharArrayv, __Z39Input_Get_Custom_PropImeCompositionModev: __Z39Input_Get_Custom_PropImeCompositionModev, __ZThn8_N5physx2Sc18TriggerInteractionD0Ev: __ZThn8_N5physx2Sc18TriggerInteractionD0Ev, __Z45Register_UnityEngine_RenderTexture_set_formatv: __Z45Register_UnityEngine_RenderTexture_set_formatv, __Z36UnityWebRequest_CUSTOM_InternalBeginP12Il2CppObject: __Z36UnityWebRequest_CUSTOM_InternalBeginP12Il2CppObject, _catopen: _catopen, __ZNK5physx13BigConvexData13ComputeOffsetERKNS_6PxVec3E: __ZNK5physx13BigConvexData13ComputeOffsetERKNS_6PxVec3E, __ZN7dtCrowd13markPathStaleEi: __ZN7dtCrowd13markPathStaleEi, __Z15GetSoundManagerv: __Z15GetSoundManagerv, __ZN5physx26PxAggregateGeneratedValuesC2EPKNS_11PxAggregateE: __ZN5physx26PxAggregateGeneratedValuesC2EPKNS_11PxAggregateE, __ZN14ParticleSystem12SetStartSizeEf: __ZN14ParticleSystem12SetStartSizeEf, __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_: __ZN5Unity5Joint16JointTransferPreI14SafeBinaryReadEEvRT_, __ZN18ProceduralMaterial23VirtualRedirectTransferER14SafeBinaryRead: __ZN18ProceduralMaterial23VirtualRedirectTransferER14SafeBinaryRead, __ZN13MonoBehaviour35RebuildMonoInstanceFromScriptChangeEP11Il2CppClassP12Il2CppObject: __ZN13MonoBehaviour35RebuildMonoInstanceFromScriptChangeEP11Il2CppClassP12Il2CppObject, __ZN13RenderTexture21SetShadowSamplingModeE18ShadowSamplingMode: __ZN13RenderTexture21SetShadowSamplingModeE18ShadowSamplingMode, __Z43Register_UnityEngine_RenderSettings_set_sunv: __Z43Register_UnityEngine_RenderSettings_set_sunv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEy: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEy, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEx: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEx, __ZN13OpenFileCache10OpenCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13OpenFileCache10OpenCachedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN13InitialModule16CheckConsistencyEv: __ZN13InitialModule16CheckConsistencyEv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEs: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEs, _glob: _glob, __ZN2UI30GetETC1SupportedCanvasMaterialEv: __ZN2UI30GetETC1SupportedCanvasMaterialEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj589ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj589ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13find_first_ofEPKwjj, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEt: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEt, __ZN20TextRenderingPrivate8FontImpl32InvokeFontTextureRebuiltCallbackEv: __ZN20TextRenderingPrivate8FontImpl32InvokeFontTextureRebuiltCallbackEv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEj: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEj, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEi: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEi, __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf: __Z18MatrixToQuaternionRK10Matrix3x3fR11Quaternionf, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEm: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEm, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEl: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEl, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEb: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEb, __ZN11MatrixStack9SetMatrixERK10Matrix4x4f: __ZN11MatrixStack9SetMatrixERK10Matrix4x4f, __ZN19SkinnedMeshRenderer19UnloadFromGfxDeviceEv: __ZN19SkinnedMeshRenderer19UnloadFromGfxDeviceEv, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEe: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEe, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEd: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEElsEd, __ZN10Matrix3x3fmLERKS_: __ZN10Matrix3x3fmLERKS_, __ZN19StreamedBinaryWriteILb0EE8TransferI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI9OffsetPtrIN7mecanim9animation19Blend1dDataConstantEEEEvRT_PKc17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110UniqueEdgeENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile26WrapperReflectionAllocatorIjEEE6GetKeyESD_Lb1EE15reserveInternalEj, __Z61Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewBooleanArrayv: __Z61Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewBooleanArrayv, __Z30TransferField_LinearCollectionI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN8Animator27ClearStateMachineBehavioursEv: __ZN8Animator27ClearStateMachineBehavioursEv, __ZNKSt3__215__codecvt_utf16IDsLb0EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IDsLb0EE11do_encodingEv, __ZN8Animator40GetAllowConstantClipSamplingOptimizationEv: __ZN8Animator40GetAllowConstantClipSamplingOptimizationEv, __Z35ParticleSystem_CUSTOM_Internal_StopP12Il2CppObject26ParticleSystemStopBehavior: __Z35ParticleSystem_CUSTOM_Internal_StopP12Il2CppObject26ParticleSystemStopBehavior, __GLOBAL__sub_I_runtime_graphics3_lump_cpp: __GLOBAL__sub_I_runtime_graphics3_lump_cpp, __ZN14MemoryProfiler17PopAllocationRootEv: __ZN14MemoryProfiler17PopAllocationRootEv, __Z50Register_UnityEngine_SparseTexture_Internal_Createv: __Z50Register_UnityEngine_SparseTexture_Internal_Createv, __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeI18VertexChannelsInfo16MeshVertexFormatEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier16ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN11PreloadData8TransferI14SafeBinaryReadEEvRT_: __ZN11PreloadData8TransferI14SafeBinaryReadEEvRT_, __ZN18BackgroundJobQueue8ShutdownEv: __ZN18BackgroundJobQueue8ShutdownEv, __Z39Renderer_Set_Custom_PropLightProbeUsageP12Il2CppObject15LightProbeUsage: __Z39Renderer_Set_Custom_PropLightProbeUsageP12Il2CppObject15LightProbeUsage, __ZN24GenerateTypeTreeTransferC2ER8TypeTree24TransferInstructionFlagsPvi: __ZN24GenerateTypeTreeTransferC2ER8TypeTree24TransferInstructionFlagsPvi, __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z44BuoyancyEffector2D_Set_Custom_PropLinearDragP12Il2CppObjectf: __Z44BuoyancyEffector2D_Set_Custom_PropLinearDragP12Il2CppObjectf, __Z46Register_UnityEngine_AudioSource_get_panStereov: __Z46Register_UnityEngine_AudioSource_get_panStereov, __ZN5physx2Sc19ConstraintGroupNode19clearProjectionDataEv: __ZN5physx2Sc19ConstraintGroupNode19clearProjectionDataEv, __ZNK18ScreenManagerWebGL9GetHeightEv: __ZNK18ScreenManagerWebGL9GetHeightEv, __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferI21ComputeShaderResourceEEvRT_PKc17TransferMetaFlags, __ZN12AdsIdHandlerC2Ev: __ZN12AdsIdHandlerC2Ev, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZNK5Umbra10Visibility19getOutputObjectMaskEv: __ZNK5Umbra10Visibility19getOutputObjectMaskEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZN16MinMaxPolyCurves15DoubleIntegrateEv: __ZN16MinMaxPolyCurves15DoubleIntegrateEv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj9EEERAT__Kc, __Z42Physics2D_Get_Custom_PropShowColliderSleepv: __Z42Physics2D_Get_Custom_PropShowColliderSleepv, __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE5CheckEv: __ZN10ObjectPoolIN4FMOD3DSPENS0_4DSPIEE5CheckEv, __ZNKSt3__210moneypunctIwLb1EE16do_decimal_pointEv: __ZNKSt3__210moneypunctIwLb1EE16do_decimal_pointEv, __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR23CompareReflectionProbesP31RuntimeReflectionProbeBlendInfoEEjT0_S5_S5_T_, __ZN11UnityEngine15PlatformWrapper17GetGraphicsVendorEv: __ZN11UnityEngine15PlatformWrapper17GetGraphicsVendorEv, __ZN5Unity5Joint14SetBreakTorqueEf: __ZN5Unity5Joint14SetBreakTorqueEf, _sinhf: _sinhf, _sinhl: _sinhl, __Z30CustomEventData_CUSTOM_AddByteP12Il2CppObjectP12Il2CppStringh: __Z30CustomEventData_CUSTOM_AddByteP12Il2CppObjectP12Il2CppStringh, __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapEnabledv: __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapEnabledv, __Z7StrICmpPKcS0_: __Z7StrICmpPKcS0_, __ZNK5Unity10HingeJoint28PxJointSupportsInternalStateEv: __ZNK5Unity10HingeJoint28PxJointSupportsInternalStateEv, __Z35ReflectionProbe_CUSTOM_BlendCubemapP12Il2CppObjectS0_fS0_: __Z35ReflectionProbe_CUSTOM_BlendCubemapP12Il2CppObjectS0_fS0_, __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E12resize_deltaEjj, __Z56Register_UnityEngine_Shader_GetGlobalMatrixArrayImplListv: __Z56Register_UnityEngine_Shader_GetGlobalMatrixArrayImplListv, __ZN5physx15concludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx15concludeContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_16NpParticleSystemENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, _lstat: _lstat, __Z43Physics2D_Get_Custom_PropQueriesHitTriggersv: __Z43Physics2D_Get_Custom_PropQueriesHitTriggersv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5ungetEv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5ungetEv, __Z53VRSettings_Set_Custom_PropRenderViewportScaleInternalf: __Z53VRSettings_Set_Custom_PropRenderViewportScaleInternalf, _ps_hints_init: _ps_hints_init, __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E: __ZN5physx2Sq8populateERKNS0_13PrunerPayloadERNS0_13PxActorShape2E, __ZNK9Rigidbody24GetInertiaTensorRotationEv: __ZNK9Rigidbody24GetInertiaTensorRotationEv, __ZN9Rigidbody17AddExplosionForceEfRK8Vector3fffi: __ZN9Rigidbody17AddExplosionForceEfRK8Vector3fffi, __ZNK8Playable7GetTimeEv: __ZNK8Playable7GetTimeEv, __ZN11CullResults26DestroySharedRendererSceneEv: __ZN11CullResults26DestroySharedRendererSceneEv, __ZN2UI30RemoveCanvasRendererFromCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE: __ZN2UI30RemoveCanvasRendererFromCanvasER8JobFencePNS_12CanvasHandleERNS_10CanvasDataE, __Z35Input_CUSTOM_INTERNAL_CALL_GetTouchiR5Touch: __Z35Input_CUSTOM_INTERNAL_CALL_GetTouchiR5Touch, __Z57Register_UnityEngine_GameObject_Internal_CreateGameObjectv: __Z57Register_UnityEngine_GameObject_Internal_CreateGameObjectv, _UNITY_png_write_tRNS: _UNITY_png_write_tRNS, __ZN12NavMeshAgent19CompleteOffMeshLinkEv: __ZN12NavMeshAgent19CompleteOffMeshLinkEv, __ZNK5physx2Sc9ClothCore13getRestOffsetEv: __ZNK5physx2Sc9ClothCore13getRestOffsetEv, __ZN23b2EdgeAndCapsuleContactD0Ev: __ZN23b2EdgeAndCapsuleContactD0Ev, __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastAllv: __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_BoxCastAllv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIlEES4_S4_S4_RNS_8ios_baseERjRT_, __Z27LocationService_CUSTOM_StopP12Il2CppObject: __Z27LocationService_CUSTOM_StopP12Il2CppObject, __ZN12InputManager23GetEnableIMECompositionEv: __ZN12InputManager23GetEnableIMECompositionEv, __Z14tessAddContourP14TESStesselatoriPKvii: __Z14tessAddContourP14TESStesselatoriPKvii, __Z54Register_UnityEngine_AudioReverbFilter_get_hfReferencev: __Z54Register_UnityEngine_AudioReverbFilter_get_hfReferencev, __Z64Register_UnityEngine_CanvasRenderer_SplitIndiciesStreamsInternalv: __Z64Register_UnityEngine_CanvasRenderer_SplitIndiciesStreamsInternalv, __Z25WWW_Get_Custom_PropIsDoneP12Il2CppObject: __Z25WWW_Get_Custom_PropIsDoneP12Il2CppObject, __ZN14AreaEffector2D21ContactUpdateCallbackEf: __ZN14AreaEffector2D21ContactUpdateCallbackEf, __ZL31InitializeModule_CrashReportingv: __ZL31InitializeModule_CrashReportingv, __ZN5physx10PxsContext18createArticulationEv: __ZN5physx10PxsContext18createArticulationEv, __Z31AudioSource_Get_Custom_PropMuteP12Il2CppObject: __Z31AudioSource_Get_Custom_PropMuteP12Il2CppObject, _fseek: _fseek, __ZN17SurfaceEffector2D8SetSpeedEf: __ZN17SurfaceEffector2D8SetSpeedEf, __ZNK16b2PrismaticJoint13GetMotorForceEf: __ZNK16b2PrismaticJoint13GetMotorForceEf, __Z43ParticleSystem_LightsModule_CUSTOM_GetRatioP12Il2CppObject: __Z43ParticleSystem_LightsModule_CUSTOM_GetRatioP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8GUIStyle13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZNK5physx10PxsContext27getCCDContactModifyCallbackEv: __ZNK5physx10PxsContext27getCCDContactModifyCallbackEv, __ZN4gles18AliasRenderSurfaceEP17RenderSurfaceGLES9TextureID: __ZN4gles18AliasRenderSurfaceEP17RenderSurfaceGLES9TextureID, __ZN5physx2Sn5ConvX7releaseEv: __ZN5physx2Sn5ConvX7releaseEv, __Z23Gradient_CUSTOM_CleanupP12Il2CppObject: __Z23Gradient_CUSTOM_CleanupP12Il2CppObject, __Z51Register_UnityEngine_Physics_get_queriesHitTriggersv: __Z51Register_UnityEngine_Physics_get_queriesHitTriggersv, __Z54Register_UnityEngine_Physics2D_set_maxTranslationSpeedv: __Z54Register_UnityEngine_Physics2D_set_maxTranslationSpeedv, __Z17SkipSampleRecursePK14ProfilerSample: __Z17SkipSampleRecursePK14ProfilerSample, _unity_z_inflateBackEnd: _unity_z_inflateBackEnd, __ZN13ScreenManager24SetIsFullScreenImmediateEb: __ZN13ScreenManager24SetIsFullScreenImmediateEb, _j1: _j1, __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimeUpdateModev: __Z75Register_UnityEngine_Experimental_Director_DirectorPlayer_SetTimeUpdateModev, __ZN5Umbra9RasterOps6blitOrERNS_17BlockRasterBufferERKS1_: __ZN5Umbra9RasterOps6blitOrERNS_17BlockRasterBufferERKS1_, __Z40Physics_CUSTOM_INTERNAL_CALL_CheckSphereRK8Vector3ffi23QueryTriggerInteraction: __Z40Physics_CUSTOM_INTERNAL_CALL_CheckSphereRK8Vector3ffi23QueryTriggerInteraction, __ZNK14VertexDataInfo17GetChannelsLayoutEv: __ZNK14VertexDataInfo17GetChannelsLayoutEv, __ZN9UdpSocket4RecvEPvjP8sockaddrPj: __ZN9UdpSocket4RecvEPvjP8sockaddrPj, __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXv: __Z60Register_UnityEngine_ParticleSystem_MainModule_SetStartSizeXv, _decode_mcu_AC_refine: _decode_mcu_AC_refine, __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIxEEvRT_PKc17TransferMetaFlags, __ZN5physx53PxVehicleDriveSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE: __ZN5physx53PxVehicleDriveSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRKNS_15PxVehicleWheelsERNS_21PxVehicleDriveDynDataE, __Z19CleanupClothManagerv: __Z19CleanupClothManagerv, __ZN24dtObstacleAvoidanceQueryC2Ev: __ZN24dtObstacleAvoidanceQueryC2Ev, __Z51Register_UnityEngine_LineRenderer_set_useWorldSpacev: __Z51Register_UnityEngine_LineRenderer_set_useWorldSpacev, __Z29AnimationCurve_CUSTOM_GetKeysP12Il2CppObject: __Z29AnimationCurve_CUSTOM_GetKeysP12Il2CppObject, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE, __ZN13GfxDeviceGLES14EndBufferWriteEP9GfxBufferj: __ZN13GfxDeviceGLES14EndBufferWriteEP9GfxBufferj, __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E: __ZN5physx14PxRigidBodyExt16getVelocityAtPosERKNS_11PxRigidBodyERKNS_6PxVec3E, __Z40ParticleAnimator_Set_Custom_PropSizeGrowP12Il2CppObjectf: __Z40ParticleAnimator_Set_Custom_PropSizeGrowP12Il2CppObjectf, __ZN11UnityEngine15CloudWebService16SessionContainer20ArchiveSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE: __ZN11UnityEngine15CloudWebService16SessionContainer20ArchiveSessionHeaderERK8UnityStrS4_RNS0_13SessionHeaderE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEpLEPKw, __ZN6Camera7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Camera7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx14PxsAABBManager28removeAggregateAggregatePairEPNS_9AggregateES2_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE: __ZN5physx14PxsAABBManager28removeAggregateAggregatePairEPNS_9AggregateES2_PNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEE, __Z41BuoyancyEffector2D_Set_Custom_PropDensityP12Il2CppObjectf: __Z41BuoyancyEffector2D_Set_Custom_PropDensityP12Il2CppObjectf, __Z46Register_UnityEngine_AnimationState_get_lengthv: __Z46Register_UnityEngine_AnimationState_get_lengthv, __ZN14PhysicsManager23GetSleepAngularVelocityEv: __ZN14PhysicsManager23GetSleepAngularVelocityEv, __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIiPK8TypeTreeEENS_19__map_value_compareIiS5_NS_4lessIiEELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN12InputManager11MakeDefaultEv: __ZN12InputManager11MakeDefaultEv, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __ZN12LightsModule5StartER23ParticleSystemParticlesjj: __ZN12LightsModule5StartER23ParticleSystemParticlesjj, __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKPositionInternalP12Il2CppObjectiR8Vector3f: __Z51Animator_CUSTOM_INTERNAL_CALL_GetIKPositionInternalP12Il2CppObjectiR8Vector3f, __Z10GetNbShapePKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumE: __Z10GetNbShapePKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumE, __Z40Graphics_CUSTOM_Internal_SetMRTFullSetupP11Il2CppArrayP21ScriptingRenderBufferiiiS0_S0_ii: __Z40Graphics_CUSTOM_Internal_SetMRTFullSetupP11Il2CppArrayP21ScriptingRenderBufferiiiS0_S0_ii, __ZN15b2ContactFilterD0Ev: __ZN15b2ContactFilterD0Ev, __ZN5physx3Ext20DefaultCpuDispatcherC2EjPj: __ZN5physx3Ext20DefaultCpuDispatcherC2EjPj, __Z72Register_UnityEngine_RenderTexture_INTERNAL_CALL_GetNativeDepthBufferPtrv: __Z72Register_UnityEngine_RenderTexture_INTERNAL_CALL_GetNativeDepthBufferPtrv, __ZN5physx3Ext15computeConeMassEfff: __ZN5physx3Ext15computeConeMassEfff, __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv: __ZN17AnimationPlayable28DeallocateResourcesRecursiveEv, __ZN5physx12storeIndicesEjjPKjRNS_14PxOutputStreamEb: __ZN5physx12storeIndicesEjjPKjRNS_14PxOutputStreamEb, __ZN8Animator8WriteJobEPPS_j: __ZN8Animator8WriteJobEPPS_j, __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_: __ZN7mecanim8skeleton24SkeletonPoseComputeLocalIN4math4trsXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_, __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorINS_4pairI7Hash128iEE13stl_allocatorIS3_L18MemLabelIdentifier79ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z55Register_UnityEngine_WWW_enforceWebSecurityRestrictionsv: __Z55Register_UnityEngine_WWW_enforceWebSecurityRestrictionsv, __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshScalev: __Z60Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshScalev, __ZN4FMOD3DSP6removeEv: __ZN4FMOD3DSP6removeEv, _linkat: _linkat, __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetCycleCountP12Il2CppObjecti: __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetCycleCountP12Il2CppObjecti, __ZNK6Camera15GetStereoEyeEndEv: __ZNK6Camera15GetStereoEyeEndEv, _try_realloc_chunk: _try_realloc_chunk, __ZNSt3__25stoulERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji: __ZNSt3__25stoulERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji, __Z41GUITexture_CUSTOM_INTERNAL_set_pixelInsetP12Il2CppObjectRK5RectTIfE: __Z41GUITexture_CUSTOM_INTERNAL_set_pixelInsetP12Il2CppObjectRK5RectTIfE, __ZN12TreeRenderer25CreateLODRenderersForTreeEi: __ZN12TreeRenderer25CreateLODRenderersForTreeEi, __Z52Register_UnityEngine_QualitySettings_SetQualityLevelv: __Z52Register_UnityEngine_QualitySettings_SetQualityLevelv, __Z63Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_IntersectRayv: __Z63Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_IntersectRayv, __ZNSt3__214__num_put_base14__format_floatEPcPKcj: __ZNSt3__214__num_put_base14__format_floatEPcPKcj, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIwEE, __Z37InterpolateLightProbeCoefficientsSafeRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2: __Z37InterpolateLightProbeCoefficientsSafeRK17LightProbeContextRK29LightProbeSamplingCoordinatesR20SphericalHarmonicsL2, __ZN5physx8debugger4comm12ErrorMessageD0Ev: __ZN5physx8debugger4comm12ErrorMessageD0Ev, __Z29GameObject_Set_Custom_PropTagP12Il2CppObjectP12Il2CppString: __Z29GameObject_Set_Custom_PropTagP12Il2CppObjectP12Il2CppString, __Z47Register_UnityEngine_TerrainData_GetDetailLayerv: __Z47Register_UnityEngine_TerrainData_GetDetailLayerv, __Z13CleanupIl2Cppv: __Z13CleanupIl2Cppv, __ZN31CanvasBatchIntermediateRendererC2Ev: __ZN31CanvasBatchIntermediateRendererC2Ev, __ZN3WWW18FeedUnityWebStreamEb: __ZN3WWW18FeedUnityWebStreamEb, __Z27ConvertTextureEndianessReadiPhi: __Z27ConvertTextureEndianessReadiPhi, __Z45LineRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti: __Z45LineRenderer_Set_Custom_PropNumCornerVerticesP12Il2CppObjecti, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN11Rigidbody2D12SetSimulatedEb: __ZN11Rigidbody2D12SetSimulatedEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj654ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj654ES3_bbEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx8debugger14PvdMarshallingIhjE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhjE12marshalBlockEPKhPhj, __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE: __ZN5physx2Sc9StaticSimC2ERNS0_5SceneERNS0_10StaticCoreE, __ZNK9ShaderLab9IntShader19CreatePropertySheetERK10MemLabelId: __ZNK9ShaderLab9IntShader19CreatePropertySheetERK10MemLabelId, _crypt: _crypt, __Z43Register_UnityEngine_AudioSource_set_spreadv: __Z43Register_UnityEngine_AudioSource_set_spreadv, __ZN11AudioSource14SetPlayOnAwakeEb: __ZN11AudioSource14SetPlayOnAwakeEb, __Z32getPxVehicleAutoBoxData_UpRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE: __Z32getPxVehicleAutoBoxData_UpRatiosPKN5physx20PxVehicleAutoBoxDataENS_18PxVehicleGearsData4EnumE, __ZN12HingeJoint2D11SetUseMotorEb: __ZN12HingeJoint2D11SetUseMotorEb, __ZN14RenderSettings17SetLinearFogStartEf: __ZN14RenderSettings17SetLinearFogStartEf, __ZN18CrashReportHandler23RegisterGlobalCallbacksEv: __ZN18CrashReportHandler23RegisterGlobalCallbacksEv, __ZN5physx9NpFactory8addShapeEPNS_7PxShapeEb: __ZN5physx9NpFactory8addShapeEPNS_7PxShapeEb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj695ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z25EstimateRenderTextureSizeiii19RenderTextureFormat17DepthBufferFormat16TextureDimensionb: __Z25EstimateRenderTextureSizeiii19RenderTextureFormat17DepthBufferFormat16TextureDimensionb, __ZN11b2WeldJoint4DumpEv: __ZN11b2WeldJoint4DumpEv, __Z19GetBuildSettingsPtrv: __Z19GetBuildSettingsPtrv, _printf: _printf, __ZN13AudioProfiler19CaptureChannelGroupEPN4FMOD12ChannelGroupERNS_27AudioProfilerCaptureContextEi: __ZN13AudioProfiler19CaptureChannelGroupEPN4FMOD12ChannelGroupERNS_27AudioProfilerCaptureContextEi, __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSleepAfterCountEj, __Z45Register_UnityEngine_ParticleEmitter_Simulatev: __Z45Register_UnityEngine_ParticleEmitter_Simulatev, _setsockopt: _setsockopt, __Z60Register_UnityEngine_LODGroup_get_crossFadeAnimationDurationv: __Z60Register_UnityEngine_LODGroup_get_crossFadeAnimationDurationv, __ZN11AudioSource14SetRolloffModeE11RolloffMode: __ZN11AudioSource14SetRolloffModeE11RolloffMode, __Z57Register_UnityEngine_CanvasRenderer_get_hasPopInstructionv: __Z57Register_UnityEngine_CanvasRenderer_get_hasPopInstructionv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12LightmapDataLj4EEEEvRT_17TransferMetaFlags, __ZN4Mesh15ThreadedCleanupEv: __ZN4Mesh15ThreadedCleanupEv, __Z20SetHasFrameToPresentb: __Z20SetHasFrameToPresentb, __ZNK5physx7NpCloth21getNbCollisionSpheresEv: __ZNK5physx7NpCloth21getNbCollisionSpheresEv, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, _jsimd_rgb_ycc_convert: _jsimd_rgb_ycc_convert, __Z56Register_UnityEngine_TerrainData_get_wavingGrassStrengthv: __Z56Register_UnityEngine_TerrainData_get_wavingGrassStrengthv, __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EED2Ev: __ZN5physx2Cm11IndexedPoolINS_2Sc10FilterPairELj32EED2Ev, __ZN9InputAxis13MakeAnalogKeyEiiii: __ZN9InputAxis13MakeAnalogKeyEiiii, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6assignEPKcj, __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState: __ZN4gles16CreateDepthStateER15DeviceStateGLES13GfxDepthState, __Z12GenerateHashPKhj: __Z12GenerateHashPKhj, __Z47Register_UnityEngine_Texture2D_get_whiteTexturev: __Z47Register_UnityEngine_Texture2D_get_whiteTexturev, __ZNK6Sprite11GetInnerUVsEb: __ZNK6Sprite11GetInnerUVsEb, __ZN17SharedTextureData32GetCrunchDecompressedTextureDataIS_EEbRKT_: __ZN17SharedTextureData32GetCrunchDecompressedTextureDataIS_EEbRKT_, __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED2Ev: __ZN26IntersectAnyVsMeshCallbackILi1ELb1EED2Ev, __ZN15DistanceJoint2D15ThreadedCleanupEv: __ZN15DistanceJoint2D15ThreadedCleanupEv, __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayyPvPy: __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayyPvPy, __ZN11UmbraModule30GetUmbraVisibilityOutputBufferEPKN5Umbra10VisibilityE: __ZN11UmbraModule30GetUmbraVisibilityOutputBufferEPKN5Umbra10VisibilityE, __Z33Shader_Get_Custom_PropIsSupportedP12Il2CppObject: __Z33Shader_Get_Custom_PropIsSupportedP12Il2CppObject, __Z45Register_UnityEngine_CullingGroup_get_enabledv: __Z45Register_UnityEngine_CullingGroup_get_enabledv, __ZL26GeomMTDCallback_SphereMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL26GeomMTDCallback_SphereMeshRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z39Register_UnityEngine_Cursor_set_visiblev: __Z39Register_UnityEngine_Cursor_set_visiblev, __ZN7ApiGLES27BindTransformFeedbackBufferEjj: __ZN7ApiGLES27BindTransformFeedbackBufferEjj, __Z47Register_UnityEngine_AssetBundle_LoadFromMemoryv: __Z47Register_UnityEngine_AssetBundle_LoadFromMemoryv, __Z51Register_UnityEngine_Cursor_INTERNAL_CALL_SetCursorv: __Z51Register_UnityEngine_Cursor_INTERNAL_CALL_SetCursorv, __ZN11dtPathQueue7requestEyyPKfS1_PK13dtQueryFilterb: __ZN11dtPathQueue7requestEyyPKfS1_PK13dtQueryFilterb, __ZThn4_NK5physx5cloth8SwSolver26getInterCollisionStiffnessEv: __ZThn4_NK5physx5cloth8SwSolver26getInterCollisionStiffnessEv, __Z32getPxArticulationJoint_ChildPosePKN5physx19PxArticulationJointE: __Z32getPxArticulationJoint_ChildPosePKN5physx19PxArticulationJointE, __ZN12AudioManager25RebindAudioSourcesToMixerEP10AudioMixer: __ZN12AudioManager25RebindAudioSourcesToMixerEP10AudioMixer, __Z40GameObject_CUSTOM_GetComponentInChildrenP12Il2CppObjectS0_h: __Z40GameObject_CUSTOM_GetComponentInChildrenP12Il2CppObjectS0_h, __ZN14GfxDeviceStats26AccumulateUsedTextureUsageEv: __ZN14GfxDeviceStats26AccumulateUsedTextureUsageEv, __ZN14GfxDeviceStats15BeginFrameStatsEv: __ZN14GfxDeviceStats15BeginFrameStatsEv, __ZN5Umbra12QueryContext8findCellERKNS_7Vector3E: __ZN5Umbra12QueryContext8findCellERKNS_7Vector3E, __Z51Register_UnityEngine_ReflectionProbe_set_importancev: __Z51Register_UnityEngine_ReflectionProbe_set_importancev, __ZN18GlslGpuProgramGLES6CreateE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER14ChannelAssigns: __ZN18GlslGpuProgramGLES6CreateE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER14ChannelAssigns, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj180ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK13RenderTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK13RenderTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __Z42Register_UnityEngine_Resources_UnloadAssetv: __Z42Register_UnityEngine_Resources_UnloadAssetv, __ZN16AllProfilerStats9SerializeER13dynamic_arrayIiLj4EE: __ZN16AllProfilerStats9SerializeER13dynamic_arrayIiLj4EE, __Z25GetSubstanceTextureFormat21SubstanceOutputFormatb: __Z25GetSubstanceTextureFormat21SubstanceOutputFormatb, __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_: __ZN5physx22computeWheelLocalPosesERKNS_23PxVehicleWheels4SimDataERKNS_23PxVehicleWheels4DynDataEPKNS_18PxWheelQueryResultEjRKNS_11PxTransformEPS9_, __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE: __ZNK5physx11PxsCCDShape17getLastCCDAbsPoseEPKNS_12PxsRigidBodyE, __ZN6Shader17MainThreadCleanupEv: __ZN6Shader17MainThreadCleanupEv, __ZN5physx13NpVolumeCache20getMaxNbStaticShapesEv: __ZN5physx13NpVolumeCache20getMaxNbStaticShapesEv, _UNITY_png_write_chunk_data: _UNITY_png_write_chunk_data, __Z35Camera_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z35Camera_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, __ZN14Texture2DArray14DestroyTextureEv: __ZN14Texture2DArray14DestroyTextureEv, __ZN8Collider9GetBoundsEv: __ZN8Collider9GetBoundsEv, __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__215time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __Z26RemoveCleanLogEntryHandlerPFb7LogTypePKcPiE: __Z26RemoveCleanLogEntryHandlerPFb7LogTypePKcPiE, __Z40Register_UnityEngine_Avatar_SetParameterv: __Z40Register_UnityEngine_Avatar_SetParameterv, __ZN5physx21PxcPCMContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx21PxcPCMContactPlaneBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN4Halo23VirtualRedirectTransferER14SafeBinaryRead: __ZN4Halo23VirtualRedirectTransferER14SafeBinaryRead, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER14SafeBinaryRead: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER14SafeBinaryRead, __ZN8LODGroup6CreateEv: __ZN8LODGroup6CreateEv, __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_10PxMaterialEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, _shutdown: _shutdown, __ZN6Object27AllocateAndAssignInstanceIDEPS_: __ZN6Object27AllocateAndAssignInstanceIDEPS_, __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15AnchoredJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z24getNbPxScene_ConstraintsPKN5physx7PxSceneE: __Z24getNbPxScene_ConstraintsPKN5physx7PxSceneE, __ZN9JSONWrite8TransferI13dynamic_arrayIyLj8EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIyLj8EEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Gu16SupportLocalImplINS0_4BoxVEED0Ev: __ZN5physx2Gu16SupportLocalImplINS0_4BoxVEED0Ev, __Z58Animator_CUSTOM_INTERNAL_CALL_SetBoneLocalRotationInternalP12Il2CppObject14HumanBodyBonesRK11Quaternionf: __Z58Animator_CUSTOM_INTERNAL_CALL_SetBoneLocalRotationInternalP12Il2CppObject14HumanBodyBonesRK11Quaternionf, __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage: __ZN19ShaderPropertySheet35SetTextureWithNoAuxiliaryPropertiesERKN9ShaderLab16FastPropertyNameE9TextureID16TextureDimension14VRTextureUsage, __ZN24UVModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN24UVModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z18Transfer_BlittableI8JSONReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20ArchiveStorageReader21FillStreamCachedBlockEPNS_11CachedBlockE: __ZN20ArchiveStorageReader21FillStreamCachedBlockEPNS_11CachedBlockE, __Z48SystemInfo_Get_Custom_PropGraphicsDeviceVendorIDv: __Z48SystemInfo_Get_Custom_PropGraphicsDeviceVendorIDv, __GLOBAL__sub_I_runtime_particlesystem_lump_cpp: __GLOBAL__sub_I_runtime_particlesystem_lump_cpp, __Z51Register_UnityEngine_Physics2D_set_showColliderAABBv: __Z51Register_UnityEngine_Physics2D_set_showColliderAABBv, __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthZP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_NoiseModule_CUSTOM_GetStrengthZP12Il2CppObjectR15MonoMinMaxCurve, __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_: __ZL15AccumulateNoiseILb1ELi3EEN4math8floatNx2ERKNS0_8floatNx3ERKfiS6_S6_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxParticleFluidEEEEclILj181ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z24sweepCapsule_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z24sweepCapsule_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN14dtPathCorridor5resetEyPKf: __ZN14dtPathCorridor5resetEyPKf, __Z11GetJobQueuev: __Z11GetJobQueuev, __ZN5physx2Sc9ClothCore15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc9ClothCore15exportExtraDataERNS_22PxSerializationContextE, __ZN11TimeManager4SyncEfb: __ZN11TimeManager4SyncEfb, __ZNK5physx7NpScene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE: __ZNK5physx7NpScene25getVisualizationParameterENS_24PxVisualizationParameter4EnumE, __ZN22ParticleSystemRenderer13ResetInternalEv: __ZN22ParticleSystemRenderer13ResetInternalEv, __Z56getPxSimulationStatisticsRequiredContactConstraintMemoryPKN5physx22PxSimulationStatisticsE: __Z56getPxSimulationStatisticsRequiredContactConstraintMemoryPKN5physx22PxSimulationStatisticsE, __ZN11LightProbes12CleanupClassEv: __ZN11LightProbes12CleanupClassEv, __ZN13GfxDeviceNull14SetScissorRectERK5RectTIiE: __ZN13GfxDeviceNull14SetScissorRectERK5RectTIiE, __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_110parse_nameINS0_2DbEEEPKcS4_S4_RT_, __ZN20SoundChannelInstanceD2Ev: __ZN20SoundChannelInstanceD2Ev, __ZN12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE: __ZN12_GLOBAL__N_110Connection11onZoneAddedERN5physx13PxProfileZoneE, __ZN5physx9NpFactory22createArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE: __ZN5physx9NpFactory22createArticulationLinkERNS_14NpArticulationEPNS_18NpArticulationLinkERKNS_11PxTransformE, __ZN20SoundChannelInstance19FMODChannelCallbackEP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS3_: __ZN20SoundChannelInstance19FMODChannelCallbackEP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS3_, __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE: __ZN19ShaderPropertySheet18AddTextureFromInfoERKN9ShaderLab16FastPropertyNameEPKNS0_25SerializedTexturePropertyE, __Z56Renderer_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f: __Z56Renderer_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f, __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIyyEEPyEEjT0_S5_S5_T_, __Z61Register_UnityEngine_Analytics_CustomEventData_InternalCreatev: __Z61Register_UnityEngine_Analytics_CustomEventData_InternalCreatev, __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE: __ZN20ArchiveStorageHeader14ReadBlocksInfoER12FileAccessorRKNS_6HeaderERNS_10BlocksInfoE, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropImplERKN5physx8debugger14NamespacedNameEPKc: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropImplERKN5physx8debugger14NamespacedNameEPKc, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EExEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z67Register_UnityEngine_AndroidJNIHelper_INTERNAL_CALL_CreateJavaProxyv: __Z67Register_UnityEngine_AndroidJNIHelper_INTERNAL_CALL_CreateJavaProxyv, __Z49Register_UnityEngine_Light_set_alreadyLightmappedv: __Z49Register_UnityEngine_Light_set_alreadyLightmappedv, __ZN5physx3Ext13RevoluteJoint18setDriveForceLimitEf: __ZN5physx3Ext13RevoluteJoint18setDriveForceLimitEf, __ZN5physx2Sc8SimStats8simStartEv: __ZN5physx2Sc8SimStats8simStartEv, __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_17RepXVisitorReaderINS_7PxShapeEEENS_17PxCapsuleGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN8Material13AwakeFromLoadE17AwakeFromLoadMode: __ZN8Material13AwakeFromLoadE17AwakeFromLoadMode, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZNK13RenderTexture20GetTextureLayerCountEv: __ZNK13RenderTexture20GetTextureLayerCountEv, __ZN5physx16PxOverlapBufferNILi1EED0Ev: __ZN5physx16PxOverlapBufferNILi1EED0Ev, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE15reserveInternalEj, __ZNK6Camera21ViewportToCameraPointERK8Vector3f: __ZNK6Camera21ViewportToCameraPointERK8Vector3f, __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI8Vector3fEEvRT_PKc17TransferMetaFlagsb, __ZN14DataBufferGLES3MapEiij: __ZN14DataBufferGLES3MapEiij, __ZN9GfxDevice16WakeRenderThreadEv: __ZN9GfxDevice16WakeRenderThreadEv, __Z31AndroidJNI_CUSTOM_FromCharArray13Il2Cpp_IntPtr: __Z31AndroidJNI_CUSTOM_FromCharArray13Il2Cpp_IntPtr, __Z50Register_UnityEngine_ParticleEmitter_set_particlesv: __Z50Register_UnityEngine_ParticleEmitter_set_particlesv, __ZNK16BaseVideoTexture13GetDataHeightEv: __ZNK16BaseVideoTexture13GetDataHeightEv, __ZNK8VRDevice18GetDeviceConnectedEv: __ZNK8VRDevice18GetDeviceConnectedEv, __Z38UnityWebRequest_Get_Custom_PropIsErrorP12Il2CppObject: __Z38UnityWebRequest_Get_Custom_PropIsErrorP12Il2CppObject, __Z58Register_UnityEngine_TrailRenderer_INTERNAL_get_startColorv: __Z58Register_UnityEngine_TrailRenderer_INTERNAL_get_startColorv, __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxPrismaticJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z32setPxVehicleDrive4WMDriveSimDataPN5physx16PxVehicleDrive4WENS_23PxVehicleDriveSimData4WE: __Z32setPxVehicleDrive4WMDriveSimDataPN5physx16PxVehicleDrive4WENS_23PxVehicleDriveSimData4WE, __ZN5physx11RTreeCooker13RemapCallbackD2Ev: __ZN5physx11RTreeCooker13RemapCallbackD2Ev, __ZNK11AudioSource17GetSamplePositionEv: __ZNK11AudioSource17GetSamplePositionEv, __ZN7mecanim9animation9DenseClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation9DenseClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx20InternalTriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx20InternalTriangleMesh17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx2Gu9ContainerC2Ev: __ZN5physx2Gu9ContainerC2Ev, _UNITY_LZ4_compress_limitedOutput: _UNITY_LZ4_compress_limitedOutput, __ZL39WriteQueueForTransferFunctionIntoCache2I8JSONReadEvP11Il2CppClassR23CachedSerializationDataRb: __ZL39WriteQueueForTransferFunctionIntoCache2I8JSONReadEvP11Il2CppClassR23CachedSerializationDataRb, __ZN16LevelGameManager15ThreadedCleanupEv: __ZN16LevelGameManager15ThreadedCleanupEv, __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE: __ZL16ContainsPropertyPKP8MaterialRKN9ShaderLab16FastPropertyNameE, __Z18Debug_CUSTOM_Breakv: __Z18Debug_CUSTOM_Breakv, __Z36AndroidJNI_CUSTOM_SetStaticLongField13Il2Cpp_IntPtrS_x: __Z36AndroidJNI_CUSTOM_SetStaticLongField13Il2Cpp_IntPtrS_x, __ZN5Umbra11ArrayMapperD2Ev: __ZN5Umbra11ArrayMapperD2Ev, __Z33CreateUnloadUnusedAssetsOperationb: __Z33CreateUnloadUnusedAssetsOperationb, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3eofEv: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE3eofEv, __Z20GetPhysicsManagerPtrv: __Z20GetPhysicsManagerPtrv, __ZNK14PhysicMaterial13GetBouncinessEv: __ZNK14PhysicMaterial13GetBouncinessEv, __ZNSt3__221recursive_timed_mutexD2Ev: __ZNSt3__221recursive_timed_mutexD2Ev, __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_12PxFixedJointEEC2ERNS_19PxAllocatorCallbackE, __ZN7StriperC2Ev: __ZN7StriperC2Ev, __ZN24CompressedAnimationCurve19DecompressQuatCurveERN13AnimationClip15QuaternionCurveE: __ZN24CompressedAnimationCurve19DecompressQuatCurveERN13AnimationClip15QuaternionCurveE, __ZN12TextureIdMap13UpdateTextureE9TextureIDi: __ZN12TextureIdMap13UpdateTextureE9TextureIDi, __ZNK16ParticleRenderer26GetTypeInfoVirtualInternalEv: __ZNK16ParticleRenderer26GetTypeInfoVirtualInternalEv, __Z26TransformVerticesInnerLoopILb0ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb0ELb1ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __Z59Register_UnityEngine_Animator_get_runtimeAnimatorControllerv: __Z59Register_UnityEngine_Animator_get_runtimeAnimatorControllerv, __ZN20SpeedTreeWindManager32FillGlobalWindOnlyPropertiesFromER19ShaderPropertySheetRKS0_: __ZN20SpeedTreeWindManager32FillGlobalWindOnlyPropertiesFromER19ShaderPropertySheetRKS0_, __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEvRT_RKS8_SB_j: __Z14replace_stringINSt3__212basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEvRT_RKS8_SB_j, __Z54ParticleSystem_InheritVelocityModule_CUSTOM_GetEnabledP12Il2CppObject: __Z54ParticleSystem_InheritVelocityModule_CUSTOM_GetEnabledP12Il2CppObject, __ZNK17SurfaceEffector2D21DesignedForNonTriggerEv: __ZNK17SurfaceEffector2D21DesignedForNonTriggerEv, __ZN5physx2Sc5SceneD2Ev: __ZN5physx2Sc5SceneD2Ev, __ZN5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE: __ZN5physx5cloth9SwFactory12createSolverEPNS_13PxProfileZoneEPNS_13PxTaskManagerE, __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI8MaterialELj4EEEiP11Il2CppArrayRKT_i: __Z34FillScriptingArrayFromUnityObjectsI13dynamic_arrayI4PPtrI8MaterialELj4EEEiP11Il2CppArrayRKT_i, __Z42ReflectionProbe_Set_Custom_PropCullingMaskP12Il2CppObjecti: __Z42ReflectionProbe_Set_Custom_PropCullingMaskP12Il2CppObjecti, __Z51SceneManager_CUSTOM_LoadSceneAsyncNameIndexInternalP12Il2CppStringihh: __Z51SceneManager_CUSTOM_LoadSceneAsyncNameIndexInternalP12Il2CppStringihh, __ZN4FMOD6System17getNetworkTimeoutEPi: __ZN4FMOD6System17getNetworkTimeoutEPi, __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw: __ZNSt3__29__num_getIwE17__stage2_int_prepERNS_8ios_baseEPwRw, __ZN12SocketStream18CanSendNonblockingEj: __ZN12SocketStream18CanSendNonblockingEj, __ZN13SplatDatabase17MainThreadCleanupEv: __ZN13SplatDatabase17MainThreadCleanupEv, __ZNKSt3__28messagesIcE5closeEi: __ZNKSt3__28messagesIcE5closeEi, __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpaceP12Il2CppObject: __Z51ParticleSystem_MainModule_CUSTOM_GetSimulationSpaceP12Il2CppObject, __Z71Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_MoveWindowv: __Z71Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_Internal_MoveWindowv, __ZN13dynamic_arrayI11KeyframeTplIfELj4EE6insertEPS1_PKS1_S5_: __ZN13dynamic_arrayI11KeyframeTplIfELj4EE6insertEPS1_PKS1_S5_, __ZN26ProbeSetTetrahedralization5ClearEv: __ZN26ProbeSetTetrahedralization5ClearEv, __Z26GetRegisteredWebCamDevicesRNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEEE: __Z26GetRegisteredWebCamDevicesRNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS1_L18MemLabelIdentifier56ELi16EEEE, __ZN4FMOD3DSP11setUserDataEPv: __ZN4FMOD3DSP11setUserDataEPv, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19getInvInertiaScale1Ev, __Z51Register_UnityEngine_AndroidJNI_SetStaticShortFieldv: __Z51Register_UnityEngine_AndroidJNI_SetStaticShortFieldv, __ZN5Umbra12StreamWriter6putStrEPKc: __ZN5Umbra12StreamWriter6putStrEPKc, __ZN9Texture2DD0Ev: __ZN9Texture2DD0Ev, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5beginEv, __ZL26HullProjectionCB_BigConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_: __ZL26HullProjectionCB_BigConvexRKN5physx2Gu13PolygonalDataERKNS_6PxVec3ERKNS_2Cm8Matrix34ERKNS7_23FastVertex2ShapeScalingERfSE_, __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib: __ZNK10__cxxabiv117__class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib, __ZN5physx2Gu16computeBoxPointsERKNS_9PxBounds3EPNS_6PxVec3E: __ZN5physx2Gu16computeBoxPointsERKNS_9PxBounds3EPNS_6PxVec3E, _UNITY_png_zalloc: _UNITY_png_zalloc, __ZN17SizeBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17SizeBySpeedModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx20PxClothMeshQuadifier13getDescriptorEv: __ZNK5physx20PxClothMeshQuadifier13getDescriptorEv, __Z40Register_UnityEngine_Texture2D_LoadImagev: __Z40Register_UnityEngine_Texture2D_LoadImagev, __ZN15dtProximityGridC2Ev: __ZN15dtProximityGridC2Ev, __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f: __ZNK10SizeModule12UpdateSingleERK22ParticleSystemParticlebR8Vector3f, __Z48ConstantForce_CUSTOM_INTERNAL_set_relativeTorqueP12Il2CppObjectRK8Vector3f: __Z48ConstantForce_CUSTOM_INTERNAL_set_relativeTorqueP12Il2CppObjectRK8Vector3f, __Z38BoxCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall: __Z38BoxCollider2D_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP13Vector2fIcall, __ZNK5physx38PxArticulationLinkCollectionPropHelper10createLinkEPNS_14PxArticulationEPNS_18PxArticulationLinkERKNS_11PxTransformE: __ZNK5physx38PxArticulationLinkCollectionPropHelper10createLinkEPNS_14PxArticulationEPNS_18PxArticulationLinkERKNS_11PxTransformE, __ZN4PPtrI14PhysicMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI14PhysicMaterialE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZnajRK10MemLabelIdiPKcS3_S3_i: __ZnajRK10MemLabelIdiPKcS3_S3_i, __ZN13SliderJoint2D8SetMotorERK12JointMotor2D: __ZN13SliderJoint2D8SetMotorERK12JointMotor2D, __Z24TransferMeshDataByteSwapI14SafeBinaryReadEvRT_R13dynamic_arrayIhLj1EE: __Z24TransferMeshDataByteSwapI14SafeBinaryReadEvRT_R13dynamic_arrayIhLj1EE, __Z37setPxParticleReadDataRestOffsetBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKfEE: __Z37setPxParticleReadDataRestOffsetBufferPN5physx18PxParticleReadDataENS_16PxStrideIteratorIKfEE, __Z58Register_UnityEngine_CharacterJoint_INTERNAL_get_swingAxisv: __Z58Register_UnityEngine_CharacterJoint_INTERNAL_get_swingAxisv, __ZN5physx2Sc5ActorD2Ev: __ZN5physx2Sc5ActorD2Ev, __Z41ConstantForce2D_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK13Vector2fIcall: __Z41ConstantForce2D_CUSTOM_INTERNAL_set_forceP12Il2CppObjectRK13Vector2fIcall, __ZN5physx3Cct17CapsuleController14setUpDirectionERKNS_6PxVec3E: __ZN5physx3Cct17CapsuleController14setUpDirectionERKNS_6PxVec3E, __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx14finishContactsERNS_13PxcNpWorkUnitERNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13__get_weekdayERiRS4_S4_RjRKNS_5ctypeIwEE, __ZN11UnityEngine7Connect16PersistentValuesD0Ev: __ZN11UnityEngine7Connect16PersistentValuesD0Ev, __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_15InlineAllocatorILj768ENS0_13TempAllocatorEEEE8recreateEj, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5Umbra20ObjectDistanceParams17getReferencePointERNS_7Vector3E: __ZNK5Umbra20ObjectDistanceParams17getReferencePointERNS_7Vector3E, __Z52Register_UnityEngine_TerrainData_get_splatPrototypesv: __Z52Register_UnityEngine_TerrainData_get_splatPrototypesv, __ZNSt3__26locale2id6__initEv: __ZNSt3__26locale2id6__initEv, _wmemcpy: _wmemcpy, __Z18Transfer_BlittableI14SafeBinaryReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18CrashReportManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18CrashReportManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16ParticleRenderer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN12_GLOBAL__N_111StreamOwner7releaseEv: __ZN12_GLOBAL__N_111StreamOwner7releaseEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN30RuntimeInitializeOnLoadManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN30RuntimeInitializeOnLoadManager8TransferI24GenerateTypeTreeTransferEEvRT_, __Z53LightProbes_CUSTOM_INTERNAL_CALL_GetInterpolatedProbeRK8Vector3fP12Il2CppObjectP20SphericalHarmonicsL2: __Z53LightProbes_CUSTOM_INTERNAL_CALL_GetInterpolatedProbeRK8Vector3fP12Il2CppObjectP20SphericalHarmonicsL2, __ZN12SoundManager12DisposeSoundEPN11SoundHandle8InstanceE: __ZN12SoundManager12DisposeSoundEPN11SoundHandle8InstanceE, __Z42Terrain_CUSTOM_INTERNAL_set_legacySpecularP12Il2CppObjectRK10ColorRGBAf: __Z42Terrain_CUSTOM_INTERNAL_set_legacySpecularP12Il2CppObjectRK10ColorRGBAf, __ZN12EventManagerC2Ev: __ZN12EventManagerC2Ev, __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetEnabledv: __Z68Register_UnityEngine_ParticleSystem_InheritVelocityModule_SetEnabledv, __Z33SpringJoint_Set_Custom_PropSpringP12Il2CppObjectf: __Z33SpringJoint_Set_Custom_PropSpringP12Il2CppObjectf, __ZN8UVModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8UVModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI14AnimationEvent13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEEEvRT_j, __ZN13RenderTexture28GetCreatedRenderTextureBytesEv: __ZN13RenderTexture28GetCreatedRenderTextureBytesEv, __Z15addImpulseAtPosRN5physx11PxsBodyCoreERKNS_6PxVec3ES4_: __Z15addImpulseAtPosRN5physx11PxsBodyCoreERKNS_6PxVec3ES4_, __ZN13GfxDeviceGLES26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID: __ZN13GfxDeviceGLES26AliasRenderSurfacePlatformEP17RenderSurfaceBase9TextureID, _rgb_rgb_convert_25: _rgb_rgb_convert_25, __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeE: __ZNSt3__224__buffered_inplace_mergeIRN10vector_mapIijNS_4lessIiEENS_9allocatorINS_4pairIijEEEEE13value_compareENS_11__wrap_iterIPS6_EEEEvT0_SE_SE_T_NS_15iterator_traitsISE_E15difference_typeESI_PNSH_10value_typeE, __ZN5physx15PxGeometryQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformES3_S6_: __ZN5physx15PxGeometryQuery7overlapERKNS_10PxGeometryERKNS_11PxTransformES3_S6_, __ZN12InputManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12InputManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD0Ev: __ZThn8_N5physx2Sc35ParticleElementRbElementInteractionD0Ev, __ZN5physx25PxProfileBulkEventHandler16parseEventBufferEPKhjRS0_b: __ZN5physx25PxProfileBulkEventHandler16parseEventBufferEPKhjRS0_b, __Z13DrawWaterMarkb: __Z13DrawWaterMarkb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN5Unity5Cloth26ClothConstrainCoefficientsELj4EEEEvRT_17TransferMetaFlags, __ZN20TextRenderingPrivate8FontImpl17AwakeFromLoadImplE17AwakeFromLoadMode: __ZN20TextRenderingPrivate8FontImpl17AwakeFromLoadImplE17AwakeFromLoadMode, __Z39Register_UnityEngine_RectOffset_get_topv: __Z39Register_UnityEngine_RectOffset_get_topv, __ZN7b2Joint4DumpEv: __ZN7b2Joint4DumpEv, __Z15CullSpotShadowsR9IndexListPK9SceneNodePK4AABBR15SpotCullContext: __Z15CullSpotShadowsR9IndexListPK9SceneNodePK4AABBR15SpotCullContext, __ZN15QualitySettings28SetShadowDistanceTemporarilyEf: __ZN15QualitySettings28SetShadowDistanceTemporarilyEf, __Z44Register_UnityEngine_Canvas_get_sortingOrderv: __Z44Register_UnityEngine_Canvas_get_sortingOrderv, __Z17sweepBox_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z17sweepBox_MeshGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN16GraphicsSettings8TransferI14SafeBinaryReadEEvRT_: __ZN16GraphicsSettings8TransferI14SafeBinaryReadEEvRT_, __ZN15LightmapSTCache26ApplyLegacyVertexLitMatrixERK10RenderNodeR9GfxDevice: __ZN15LightmapSTCache26ApplyLegacyVertexLitMatrixERK10RenderNodeR9GfxDevice, __ZN10Effector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN10Effector2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __Z64Register_UnityEngine_ParticleSystem_TriggerModule_SetRadiusScalev: __Z64Register_UnityEngine_ParticleSystem_TriggerModule_SetRadiusScalev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSEw, __ZNSt3__212__rs_defaultD2Ev: __ZNSt3__212__rs_defaultD2Ev, __ZNKSt3__214collate_bynameIcE12do_transformEPKcS3_: __ZNKSt3__214collate_bynameIcE12do_transformEPKcS3_, __ZN9UdpSocket4SendEPKvjP8sockaddrj: __ZN9UdpSocket4SendEPKvjP8sockaddrj, __ZN15OcclusionPortal22CalculatePortalEnabledEv: __ZN15OcclusionPortal22CalculatePortalEnabledEv, __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeIiPN9ShaderLab10GrabPasses5EntryEEENS_19__map_value_compareIiS6_NS_4lessIiEELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN2UI13RectTransform38SetAnchoredPositionWithoutNotificationERK8Vector2f: __ZN2UI13RectTransform38SetAnchoredPositionWithoutNotificationERK8Vector2f, __ZN11OffMeshLink15SetCostOverrideEf: __ZN11OffMeshLink15SetCostOverrideEf, __ZNK9dtNavMesh19getTileAndPolyByRefEyPPK10dtMeshTilePPK6dtPoly: __ZNK9dtNavMesh19getTileAndPolyByRefEyPPK10dtMeshTilePPK6dtPoly, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6rbeginEv, __Z61Register_UnityEngine_GameObject_Internal_AddComponentWithTypev: __Z61Register_UnityEngine_GameObject_Internal_AddComponentWithTypev, __ZN11OffMeshLink15UpdatePositionsEv: __ZN11OffMeshLink15UpdatePositionsEv, __ZN21ComponentRequirements13StaticDestroyEPv: __ZN21ComponentRequirements13StaticDestroyEPv, __ZNK19AssetBundleManifest26GetTypeInfoVirtualInternalEv: __ZNK19AssetBundleManifest26GetTypeInfoVirtualInternalEv, __ZN6Shader8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN6Shader8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z39WheelCollider_Set_Custom_PropSteerAngleP12Il2CppObjectf: __Z39WheelCollider_Set_Custom_PropSteerAngleP12Il2CppObjectf, __ZNK16DeveloperConsole15IsVisibleNoLockEv: __ZNK16DeveloperConsole15IsVisibleNoLockEv, __Z26SkinVerticesGenericMathLibILi1ELb1ELb0EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi1ELb1ELb0EEvPKhiiiiPhiPKvS4_, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE13isSubordinateEv, __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIcEEEEvPT_, __ZN15UniformTFMethod13DoneRenderingEv: __ZN15UniformTFMethod13DoneRenderingEv, __Z35Register_UnityEngine_Camera_get_hdrv: __Z35Register_UnityEngine_Camera_get_hdrv, _UNITY_FT_Get_Kerning: _UNITY_FT_Get_Kerning, __Z14OrthoNormalizeR10Matrix3x3f: __Z14OrthoNormalizeR10Matrix3x3f, __Z29GUI_CUSTOM_SetNextControlNameP12Il2CppString: __Z29GUI_CUSTOM_SetNextControlNameP12Il2CppString, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI15NavMeshTileData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __Z12SetupSteppedP8Vector3fRK11KeyframeTplIS_ES4_: __Z12SetupSteppedP8Vector3fRK11KeyframeTplIS_ES4_, __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc: __ZN5physx2Sn9StrToImplINS_6PxVec3EE5strtoERS2_RPKc, __Z28GUIStyle_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString: __Z28GUIStyle_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString, __Z31GetAnimationScriptingClassesPtrv: __Z31GetAnimationScriptingClassesPtrv, __Z58Register_UnityEngine_AudioSource_set_spatializePostEffectsv: __Z58Register_UnityEngine_AudioSource_set_spatializePostEffectsv, __ZN7Texture8TransferI14SafeBinaryReadEEvRT_: __ZN7Texture8TransferI14SafeBinaryReadEEvRT_, __ZN10GameObject25TransformParentHasChangedEv: __ZN10GameObject25TransformParentHasChangedEv, __ZN19UnityConnectService20OnExitPlayModeStaticEPS_: __ZN19UnityConnectService20OnExitPlayModeStaticEPS_, __Z32GUIUtility_CUSTOM_UpdateUndoNamev: __Z32GUIUtility_CUSTOM_UpdateUndoNamev, __Z72Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustPointv: __Z72Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustPointv, __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXv: __Z57Register_UnityEngine_ParticleSystem_NoiseModule_GetRemapXv, __ZN5physx15PxVehicleUpdate40updateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE: __ZN5physx15PxVehicleUpdate40updateSingleVehicleAndStoreTelemetryDataEfRKNS_6PxVec3ERKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_15PxVehicleWheelsEPNS_25PxVehicleWheelQueryResultERNS_22PxVehicleTelemetryDataE, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN12b2ChainShapeD2Ev: __ZN12b2ChainShapeD2Ev, __ZN9GfxDevice21SetWorldMatrixAndTypeERK10Matrix4x4f13TransformType: __ZN9GfxDevice21SetWorldMatrixAndTypeERK10Matrix4x4f13TransformType, __ZN5physx58PxVehicleDriveTankSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE: __ZN5physx58PxVehicleDriveTankSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_30PxVehicleDriveTankRawInputDataEfRNS_18PxVehicleDriveTankE, __ZN18UnityConnectClientD0Ev: __ZN18UnityConnectClientD0Ev, __Z17GetNbTriggerPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_: __Z17GetNbTriggerPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_, __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j: __ZNK5physx24PxRigidBodyGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEEEEjT_j, __ZN9GfxDevice17SendVRDeviceEventEjf: __ZN9GfxDevice17SendVRDeviceEventEjf, __ZN9Texture3D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Texture3D8TransferI18StreamedBinaryReadILb1EEEEvRT_, _cff_check_points: _cff_check_points, __ZNK10MonoScript13GetScriptTypeEv: __ZNK10MonoScript13GetScriptTypeEv, __ZN9GfxDevice17SendVRDeviceEventEjj: __ZN9GfxDevice17SendVRDeviceEventEjj, __ZN24b2ChainAndCapsuleContactD0Ev: __ZN24b2ChainAndCapsuleContactD0Ev, __Z25Animator_CUSTOM_CrossFadeP12Il2CppObjectifif: __Z25Animator_CUSTOM_CrossFadeP12Il2CppObjectifif, __Z35LightProbeProxyVolume_CUSTOM_UpdateP12Il2CppObject: __Z35LightProbeProxyVolume_CUSTOM_UpdateP12Il2CppObject, __Z49Register_UnityEngine_Rigidbody2D_get_gravityScalev: __Z49Register_UnityEngine_Rigidbody2D_get_gravityScalev, __ZN5physx16PxControllerDescD2Ev: __ZN5physx16PxControllerDescD2Ev, __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetWorldSpacev: __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetWorldSpacev, __ZNSt3__217moneypunct_bynameIcLb1EED0Ev: __ZNSt3__217moneypunct_bynameIcLb1EED0Ev, __Z15AddLoopingFrameI11QuaternionfEvR17AnimationCurveTplIT_Ef: __Z15AddLoopingFrameI11QuaternionfEvR17AnimationCurveTplIT_Ef, __ZN5audio5mixerL19IsAnyChannelPlayingEPN4FMOD12ChannelGroupE: __ZN5audio5mixerL19IsAnyChannelPlayingEPN4FMOD12ChannelGroupE, __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EE11ClassIDTypez: __ZN6Object18FindObjectsOfTypesER13dynamic_arrayIPS_Lj4EE11ClassIDTypez, __ZN5audio5mixer14EffectConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5audio5mixer14EffectConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z13RegisterClassI10Collider2DEvv: __Z13RegisterClassI10Collider2DEvv, __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __Z31Mesh_Get_Custom_PropVertexCountP12Il2CppObject: __Z31Mesh_Get_Custom_PropVertexCountP12Il2CppObject, __ZN5physx3Scb5Scene22updateLowLevelMaterialEPPNS_10NpMaterialE: __ZN5physx3Scb5Scene22updateLowLevelMaterialEPPNS_10NpMaterialE, __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdatePresentAfterDrawstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36PostLateUpdatePresentAfterDrawstruct7ForwardEv, __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKiPKN11AssetBundle9AssetInfoEEEi21InstanceIDHashFunctorN14dense_hash_mapIiS6_S8_NS0_8equal_toIiEE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv, __ZN27AnimatorControllerParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN27AnimatorControllerParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx7NpScene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE: __ZNK5physx7NpScene17getBroadPhaseCapsERNS_16PxBroadPhaseCapsE, __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIiEEvRT_PKc17TransferMetaFlags, __Z30Graphics_CUSTOM_DrawProcedural16GfxPrimitiveTypeii: __Z30Graphics_CUSTOM_DrawProcedural16GfxPrimitiveTypeii, __Z40ReflectionProbe_Set_Custom_PropIntensityP12Il2CppObjectf: __Z40ReflectionProbe_Set_Custom_PropIntensityP12Il2CppObjectf, __ZN5Umbra20RuntimeTomeGenerator15generatePortalsEiRNS_5ArrayIiEEPKNS0_6ResultERi: __ZN5Umbra20RuntimeTomeGenerator15generatePortalsEiRNS_5ArrayIiEEPKNS0_6ResultERi, __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI13TreePrototypeNS0_9allocatorIS2_EEEEEvRT_j, __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestAllv: __Z57Register_UnityEngine_Rigidbody_INTERNAL_CALL_SweepTestAllv, __ZNK8VRDevice22GetRenderViewportScaleEv: __ZNK8VRDevice22GetRenderViewportScaleEv, _UNITY_png_create_info_struct: _UNITY_png_create_info_struct, __Z31MonoBehaviour_CUSTOM_IsInvokingP12Il2CppObjectP12Il2CppString: __Z31MonoBehaviour_CUSTOM_IsInvokingP12Il2CppObjectP12Il2CppString, __Z33GUI_CUSTOM_INTERNAL_CALL_DoWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_hRS0_: __Z33GUI_CUSTOM_INTERNAL_CALL_DoWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_hRS0_, __Z30RectOffset_Get_Custom_PropLeftP12Il2CppObject: __Z30RectOffset_Get_Custom_PropLeftP12Il2CppObject, __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI9InputAxisNS_9allocatorIS1_EEE8__appendEj, __ZN8Material23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN8Material23VirtualRedirectTransferER17RemapPPtrTransfer, __Z52Register_UnityEngine_Material_GetMatrixArrayImplListv: __Z52Register_UnityEngine_Material_GetMatrixArrayImplListv, __Z52Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawSpherev: __Z52Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawSpherev, __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE: __ZN5physx2Gu9RTreePage13computeBoundsERNS0_10RTreeNodeQE, __ZN13TextRendering4Font8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13TextRendering4Font8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZThn4_NK5physx5cloth8SwFabric16getNumRestvaluesEv: __ZThn4_NK5physx5cloth8SwFabric16getNumRestvaluesEv, __ZN21LinearCollectionField8GetArrayEv: __ZN21LinearCollectionField8GetArrayEv, __ZN11BoxCollider15ThreadedCleanupEv: __ZN11BoxCollider15ThreadedCleanupEv, __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev: __ZN5physx31PxVehicleGearsDataGeneratedInfoC2Ev, __Z42PointEffector2D_Set_Custom_PropForceSourceP12Il2CppObject19EffectorSelection2D: __Z42PointEffector2D_Set_Custom_PropForceSourceP12Il2CppObject19EffectorSelection2D, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi16EEEEEE15growAndPushBackERKS2_, __Z57Register_UnityEngine_ParticleSystem_TriggerModule_GetExitv: __Z57Register_UnityEngine_ParticleSystem_TriggerModule_GetExitv, __ZN8Animator15WritePropertiesEff: __ZN8Animator15WritePropertiesEff, __ZN9GfxDevice12ExecuteAsyncEiPFvPN21GfxDeviceAsyncCommand10ArgScratchEPKNS0_3ArgEEPS2_S5_R8JobFence: __ZN9GfxDevice12ExecuteAsyncEiPFvPN21GfxDeviceAsyncCommand10ArgScratchEPKNS0_3ArgEEPS2_S5_R8JobFence, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __ZNK4Mesh12GetTrianglesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __Z32AndroidJNI_CUSTOM_FromFloatArray13Il2Cpp_IntPtr: __Z32AndroidJNI_CUSTOM_FromFloatArray13Il2Cpp_IntPtr, __ZN14UnityAnalytics23RegisterGlobalCallbacksEv: __ZN14UnityAnalytics23RegisterGlobalCallbacksEv, __Z41Terrain_CUSTOM_INTERNAL_CALL_SampleHeightP12Il2CppObjectRK8Vector3f: __Z41Terrain_CUSTOM_INTERNAL_CALL_SampleHeightP12Il2CppObjectRK8Vector3f, __ZNK5physx2Sc10StaticCore6getSimEv: __ZNK5physx2Sc10StaticCore6getSimEv, _XXH32_reset: _XXH32_reset, __Z70Register_UnityEngine_Gyroscope_INTERNAL_CALL_userAcceleration_Internalv: __Z70Register_UnityEngine_Gyroscope_INTERNAL_CALL_userAcceleration_Internalv, __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverLifetimev: __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetColorOverLifetimev, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED2Ev: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEED2Ev, __ZN13AnimationClip16ClearCachedRangeEv: __ZN13AnimationClip16ClearCachedRangeEv, __ZNSt3__210__stdinbufIcE9__getcharEb: __ZNSt3__210__stdinbufIcE9__getcharEb, __ZNSt3__29__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE: __ZNSt3__29__num_putIwE21__widen_and_group_intEPcS2_S2_PwRS3_S4_RKNS_6localeE, __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI18AnimatorControllerE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_set_centerv: __Z56Register_UnityEngine_CapsuleCollider_INTERNAL_set_centerv, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f, __ZN2UI15SortForBatchingEPKNS_23RenderableUIInstructionEjPS0_i: __ZN2UI15SortForBatchingEPKNS_23RenderableUIInstructionEjPS0_i, _TT_Load_Glyph_Header: _TT_Load_Glyph_Header, __ZN5physx2Sc17ParticleSystemSim14resetFilteringEv: __ZN5physx2Sc17ParticleSystemSim14resetFilteringEv, __ZN13TargetJoint2D15SetDampingRatioEf: __ZN13TargetJoint2D15SetDampingRatioEf, __ZZ23InitPlayerLoopCallbacksvEN44UpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN44UpdateScriptRunDelayedDynamicFrameRatestruct7ForwardEv, __Z75Register_UnityEngine_AnimatorOverrideController_Internal_CreateAnimationSetv: __Z75Register_UnityEngine_AnimatorOverrideController_Internal_CreateAnimationSetv, __Z55Register_UnityEngine_LineRenderer_get_numCornerVerticesv: __Z55Register_UnityEngine_LineRenderer_get_numCornerVerticesv, __ZN15DistanceJoint2D5ResetEv: __ZN15DistanceJoint2D5ResetEv, __ZN5physx3Ext14SphericalJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext14SphericalJoint12createObjectERPhRNS_24PxDeserializationContextE, __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb0EEEvRPT_PKcRjS9_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE18StreamedBinaryReadILb0EEEvRPT_PKcRjS9_RT0_, __ZNK5physx18PxVehicleGearsData7isValidEv: __ZNK5physx18PxVehicleGearsData7isValidEv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv, __Z65Register_UnityEngine_Networking_UnityWebRequest_GetResponseHeaderv: __Z65Register_UnityEngine_Networking_UnityWebRequest_GetResponseHeaderv, __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE: __ZN11GPUProfiler17ClearTimerQueriesER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EE, __ZNK13SpeedTreeWind12InTransitionEv: __ZNK13SpeedTreeWind12InTransitionEv, __Z44TerrainData_CUSTOM_RecalculateBasemapIfDirtyP12Il2CppObject: __Z44TerrainData_CUSTOM_RecalculateBasemapIfDirtyP12Il2CppObject, __ZN5Unity17ConfigurableJoint17SetProjectionModeEi: __ZN5Unity17ConfigurableJoint17SetProjectionModeEi, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgENS_4fposI11__mbstate_tEE: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE5seekgENS_4fposI11__mbstate_tEE, __ZN5physx9NpFactory21registerArticulationsEv: __ZN5physx9NpFactory21registerArticulationsEv, __ZN12_GLOBAL__N_110Connection24sendStreamInitializationEv: __ZN12_GLOBAL__N_110Connection24sendStreamInitializationEv, __ZN5physx20GetNbTorqueCurvePairEPKNS_19PxVehicleEngineDataE: __ZN5physx20GetNbTorqueCurvePairEPKNS_19PxVehicleEngineDataE, __Z31TextMesh_Set_Custom_PropTabSizeP12Il2CppObjectf: __Z31TextMesh_Set_Custom_PropTabSizeP12Il2CppObjectf, __ZN10Effector2D12BeginContactEP9b2Contact: __ZN10Effector2D12BeginContactEP9b2Contact, __Z46Register_UnityEngine_HumanTrait_get_MuscleNamev: __Z46Register_UnityEngine_HumanTrait_get_MuscleNamev, __ZNK29LineParametersPropertyBinding17GetLineParametersEP6Object: __ZNK29LineParametersPropertyBinding17GetLineParametersEP6Object, __ZN24RingBufferMemoryFileData15NotifyWriteDoneEv: __ZN24RingBufferMemoryFileData15NotifyWriteDoneEv, __Z55Register_UnityEngine_LineRenderer_set_numCornerVerticesv: __Z55Register_UnityEngine_LineRenderer_set_numCornerVerticesv, __ZN5physx2Gu23triBoxSweepTestBoxSpaceERKNS_10PxTriangleERKNS_6PxVec3ES6_S6_fRfb: __ZN5physx2Gu23triBoxSweepTestBoxSpaceERKNS_10PxTriangleERKNS_6PxVec3ES6_S6_fRfb, __ZN5Umbra20ObjectDistanceParams17setReferencePointEPKNS_7Vector3E: __ZN5Umbra20ObjectDistanceParams17setReferencePointEPKNS_7Vector3E, __ZNK5physx2Sc9ClothCore25getVirtualParticleWeightsEPNS_6PxVec3E: __ZNK5physx2Sc9ClothCore25getVirtualParticleWeightsEPNS_6PxVec3E, __Z19TransferField_ArrayI9JSONWrite27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI9JSONWrite27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertENS_11__wrap_iterIPKS6_EERSA_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6insertENS_11__wrap_iterIPKS6_EERSA_, __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev: __ZN5physx36PxVehicleDriveSimData4WGeneratedInfoC2Ev, __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, __Z13RegisterClassI10FlareLayerEvv: __Z13RegisterClassI10FlareLayerEvv, __Z18IsAbsoluteFilePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z18IsAbsoluteFilePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN12ServerSocket6AcceptEP8sockaddrPj: __ZN12ServerSocket6AcceptEP8sockaddrPj, __ZN5physx20BigConvexDataBuilderC2EPKNS_2Gu14ConvexHullDataEPNS_13BigConvexDataEPKNS_6PxVec3E: __ZN5physx20BigConvexDataBuilderC2EPKNS_2Gu14ConvexHullDataEPNS_13BigConvexDataEPKNS_6PxVec3E, __Z38ParticleEmitter_Set_Custom_PropEnabledP12Il2CppObjecth: __Z38ParticleEmitter_Set_Custom_PropEnabledP12Il2CppObjecth, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15setActorSimFlagEb: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE15setActorSimFlagEb, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11detachShapeERNS_7PxShapeEb: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11detachShapeERNS_7PxShapeEb, __ZN12_GLOBAL__N_121SocketNetworkInStream17getLoadedDataSizeEv: __ZN12_GLOBAL__N_121SocketNetworkInStream17getLoadedDataSizeEv, __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP8ColliderNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE6createERKS4_Rb, __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerIDv: __Z84Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_ResetTriggerIDv, __Z45PhysicMaterial_Set_Custom_PropStaticFriction2P12Il2CppObjectf: __Z45PhysicMaterial_Set_Custom_PropStaticFriction2P12Il2CppObjectf, __ZN2gl20IsFormatDepthStencilENS_9TexFormatE: __ZN2gl20IsFormatDepthStencilENS_9TexFormatE, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19findPropertyMessageERKN5physx8debugger14NamespacedNameE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl19findPropertyMessageERKN5physx8debugger14NamespacedNameE, __Z40Register_UnityEngine_Mesh_get_isReadablev: __Z40Register_UnityEngine_Mesh_get_isReadablev, __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN5physx2Sc9ClothCore19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj: __ZN5physx2Sc9ClothCore19setCollisionSpheresEPKNS_22PxClothCollisionSphereEj, __ZN2UI19DistanceToRectangleEP8Vector3f8Vector2f: __ZN2UI19DistanceToRectangleEP8Vector3f8Vector2f, __Z34setPxJointLimitParametersStiffnessPN5physx22PxJointLimitParametersEf: __Z34setPxJointLimitParametersStiffnessPN5physx22PxJointLimitParametersEf, __Z45CleanupRectTransformAnimationBindingInterfacev: __Z45CleanupRectTransformAnimationBindingInterfacev, __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYv: __Z58Register_UnityEngine_ParticleSystem_SizeBySpeedModule_GetYv, __Z41Register_UnityEngine_Physics2D_IsTouchingv: __Z41Register_UnityEngine_Physics2D_IsTouchingv, __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE4findIS2_EENS_15__tree_iteratorIS3_PNS_11__tree_nodeIS3_PvEEiEERKT_, __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20ArchiveStorageReader18AcquireCachedBlockEjj: __ZN20ArchiveStorageReader18AcquireCachedBlockEjj, __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity10FixedJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN9GfxDevice20CreateComputeProgramEPKhj: __ZN9GfxDevice20CreateComputeProgramEPKhj, __Z36Register_UnityEngine_GUIClip_Reapplyv: __Z36Register_UnityEngine_GUIClip_Reapplyv, __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject: __ZN9Scripting29RuntimeObjectInitLogExceptionEP12Il2CppObject, __ZNK9allocutil14BuddyAllocator5EmptyEv: __ZNK9allocutil14BuddyAllocator5EmptyEv, __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZNK5physx2Sc9ClothCore6getSimEv: __ZNK5physx2Sc9ClothCore6getSimEv, __ZN13RuntimeStaticI12FlareManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI12FlareManagerE13StaticDestroyEPv, __ZN14DataBufferGLES16FlushMappedRangeEii: __ZN14DataBufferGLES16FlushMappedRangeEii, __Z51Register_UnityEngine_AudioClip_get_preloadAudioDatav: __Z51Register_UnityEngine_AudioClip_get_preloadAudioDatav, __Z25MultiplyMatrixArray4x4REFPK10Matrix4x4fS1_PS_j: __Z25MultiplyMatrixArray4x4REFPK10Matrix4x4fS1_PS_j, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEixEj, __ZN14ParticleSystem18SetSimulationSpaceE29ParticleSystemSimulationSpace: __ZN14ParticleSystem18SetSimulationSpaceE29ParticleSystemSimulationSpace, __ZN9AudioClip7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9AudioClip7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN15PointEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE: __ZN15PointEffector2D23PreSolveContactCallbackERN10Effector2D15EffectorContactE, __ZL18ReplacementPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL18ReplacementPassJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZNK13b2DynamicTree5QueryI12b2BroadPhaseEEvPT_RK6b2AABB: __ZNK13b2DynamicTree5QueryI12b2BroadPhaseEEvPT_RK6b2AABB, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE17releaseEmptySlabsEv, __Z15Transfer_StringI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj, __ZN25ConvexVsMeshSweepCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN25ConvexVsMeshSweepCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx7NpActor15exportExtraDataERNS_22PxSerializationContextE, __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv: __ZNK5physx5cloth12LerpIteratorI8Scalar4fNS0_17UnalignedIteratorIS2_Lj3EEEEdeEv, __ZN19ShaderPropertySheet26SetTextureScaleOffsetValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f: __ZN19ShaderPropertySheet26SetTextureScaleOffsetValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f, __ZNK5physx27PxDefaultMemoryOutputStream7getSizeEv: __ZNK5physx27PxDefaultMemoryOutputStream7getSizeEv, __Z50Register_UnityEngine_AudioSource_set_bypassEffectsv: __Z50Register_UnityEngine_AudioSource_set_bypassEffectsv, __ZN4FMOD6System20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE: __ZN4FMOD6System20set3DRolloffCallbackEPFfP12FMOD_CHANNELfE, __ZN8Playable7SetDataEyPv: __ZN8Playable7SetDataEyPv, __ZN12_GLOBAL__N_111StreamOwner5writeEPKhj: __ZN12_GLOBAL__N_111StreamOwner5writeEPKhj, __ZN5physx32PxsSolverConstraintPartitionTask11runInternalEv: __ZN5physx32PxsSolverConstraintPartitionTask11runInternalEv, __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr: __ZN11UnityEngine15CloudWebService18RestFileDownloader10InitializeERK8UnityStr, __Z21GetUncheckedGfxDevicev: __Z21GetUncheckedGfxDevicev, __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmcc: __ZNKSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwPK2tmcc, __Z39Register_UnityEngine_Rigidbody_get_dragv: __Z39Register_UnityEngine_Rigidbody_get_dragv, __ZN5physx2Sq11getHitShapeEPKNS_3Scb5ShapeE: __ZN5physx2Sq11getHitShapeEPKNS_3Scb5ShapeE, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration18generateEEContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration18generateEEContactsERKNS_6shdfnd3aos5Vec3VES6_S6_S6_jS6_S6_RKNS3_6FloatVEPNS0_21MeshPersistentContactERj, __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE6extendEv: __ZN5physx11PxcPoolListINS_16PxsParticleShapeENS_10PxsContextEE6extendEv, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getExternalReferenceERj, __ZN7mecanim9animation14AvatarConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation14AvatarConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __Z42Register_UnityEngine_Camera_get_pixelWidthv: __Z42Register_UnityEngine_Camera_get_pixelWidthv, __ZN9TextAsset7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9TextAsset7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN17SharedTextureData17GetImageReferenceEii: __ZN17SharedTextureData17GetImageReferenceEii, __ZN4MeshD2Ev: __ZN4MeshD2Ev, __ZN22DeviceMVPMatricesStateD2Ev: __ZN22DeviceMVPMatricesStateD2Ev, __ZN5physx5cloth11SwClothDataC2ERNS0_7SwClothERKNS0_8SwFabricE: __ZN5physx5cloth11SwClothDataC2ERNS0_7SwClothERKNS0_8SwFabricE, __ZN5physx2Sc8BodyCore10putToSleepEv: __ZN5physx2Sc8BodyCore10putToSleepEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__move_assign_allocERS5_NS_17integral_constantIbLb0EEE, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseNullILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN4UNET16ScriptingUpdater7CleanupEv: __ZN4UNET16ScriptingUpdater7CleanupEv, __ZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_: __ZNK5physx2Sq8AABBTree5walk2EPFbPKNS0_12AABBTreeNodeEjPvES5_, __ZNSt3__217__assoc_sub_state10__sub_waitERNS_11unique_lockINS_5mutexEEE: __ZNSt3__217__assoc_sub_state10__sub_waitERNS_11unique_lockINS_5mutexEEE, __Z41Register_UnityEngine_Light_get_shadowBiasv: __Z41Register_UnityEngine_Light_get_shadowBiasv, __ZNSt3__215numpunct_bynameIwE6__initEPKc: __ZNSt3__215numpunct_bynameIwE6__initEPKc, __ZN5physx15NpActorTemplateINS_7PxClothEE12setActorFlagENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_7PxClothEE12setActorFlagENS_11PxActorFlag4EnumEb, __ZN4FMOD7Channel9getVolumeEPf: __ZN4FMOD7Channel9getVolumeEPf, __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE: __ZN5Umbra5Query16setDebugRendererEPNS_13DebugRendererE, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17GetProfilerHeaderEPKv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE17GetProfilerHeaderEPKv, __GLOBAL__sub_I_iostream_cpp: __GLOBAL__sub_I_iostream_cpp, __Z49WheelCollider_CUSTOM_INTERNAL_get_forwardFrictionP12Il2CppObjectP18WheelFrictionCurve: __Z49WheelCollider_CUSTOM_INTERNAL_get_forwardFrictionP12Il2CppObjectP18WheelFrictionCurve, __ZN11CustomArray8StoreU32Ej: __ZN11CustomArray8StoreU32Ej, __ZNK14SpriteRenderer28GetSpriteRenderDataInContextEPK6Sprite: __ZNK14SpriteRenderer28GetSpriteRenderDataInContextEPK6Sprite, __ZN13MemoryManagerD2Ev: __ZN13MemoryManagerD2Ev, __Z41SystemInfo_Get_Custom_PropOperatingSystemv: __Z41SystemInfo_Get_Custom_PropOperatingSystemv, __ZN9ShaderLab4Pass7ReleaseEv: __ZN9ShaderLab4Pass7ReleaseEv, __ZN5physx28PxPlaneGeometryGeneratedInfoC2Ev: __ZN5physx28PxPlaneGeometryGeneratedInfoC2Ev, __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN25RuntimeAnimatorController8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZL22Transfer_ManagedObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet: __ZN20GpuProgramParameters23AddMatrixParamWithFlagsEPKcii15ShaderParamTypeiiihP16PropertyNamesSet, _lround: _lround, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBAHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888817TexFormatRGBAHalfEEvPKNS_9InnerInfoE, __ZN5physx3Cct12SweptCapsuleD2Ev: __ZN5physx3Cct12SweptCapsuleD2Ev, __ZN11Rigidbody2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN11Rigidbody2D13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEjT0_S6_S6_S6_S6_T_, __ZN24TreeIntermediateRenderer15UpdateTransformERK10Matrix4x4fRK4AABB: __ZN24TreeIntermediateRenderer15UpdateTransformERK10Matrix4x4fRK4AABB, __ZN5physx3Ext13DistanceJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext13DistanceJoint12createObjectERPhRNS_24PxDeserializationContextE, __Z35Event_CUSTOM_Internal_GetMouseDeltaP12Il2CppObjectP13Vector2fIcall: __Z35Event_CUSTOM_Internal_GetMouseDeltaP12Il2CppObjectP13Vector2fIcall, __ZN21DownloadHandlerBuffer17OnCompleteContentEv: __ZN21DownloadHandlerBuffer17OnCompleteContentEv, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb: __ZN9TextureOpI11TextureDataE15ExtractMipLevelEPS0_S2_iibb, __ZN14DirectorPlayer13AwakeFromLoadE17AwakeFromLoadMode: __ZN14DirectorPlayer13AwakeFromLoadE17AwakeFromLoadMode, __ZN15LODGroupManager20DestroyCameraLODDataEPK6Camera: __ZN15LODGroupManager20DestroyCameraLODDataEPK6Camera, __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti: __ZNK8GUIStyle22GetCursorPixelPositionERK5RectTIfER10GUIContenti, __ZNK5physx19NpArticulationJoint20getTargetOrientationEv: __ZNK5physx19NpArticulationJoint20getTargetOrientationEv, __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE: __ZN11UnityEngine7Connect13ConnectConfig10UnregisterERNS0_13ConfigHandlerE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE8pushNameEPKc, __ZN10Matrix3x4f8TransferI14SafeBinaryReadEEvRT_: __ZN10Matrix3x4f8TransferI14SafeBinaryReadEEvRT_, __ZN18GlslGpuProgramGLES15ApplyGpuProgramERK20GpuProgramParametersPKh: __ZN18GlslGpuProgramGLES15ApplyGpuProgramERK20GpuProgramParametersPKh, __ZNK5physx9NpPhysics19getNbTriangleMeshesEv: __ZNK5physx9NpPhysics19getNbTriangleMeshesEv, __ZNK13BaseAllocator17ValidateIntegrityEPKv: __ZNK13BaseAllocator17ValidateIntegrityEPKv, __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI11TexFormatI817TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN12MeshRenderer15ThreadedCleanupEv: __ZN12MeshRenderer15ThreadedCleanupEv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8pubimbueERKNS_6localeE: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE8pubimbueERKNS_6localeE, __ZN7mecanim8skeleton18CreateSkeletonMaskEjPNS0_19SkeletonMaskElementERNS_6memory9AllocatorE: __ZN7mecanim8skeleton18CreateSkeletonMaskEjPNS0_19SkeletonMaskElementERNS_6memory9AllocatorE, __ZN15MulticastSocket4SendEPKvj: __ZN15MulticastSocket4SendEPKvj, __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCirclev: __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCirclev, __ZN3WWW7ReleaseEv: __ZN3WWW7ReleaseEv, __ZN14PhysicsManager20ReleasePvdConnectionEv: __ZN14PhysicsManager20ReleasePvdConnectionEv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z67Register_UnityEngine_ParticleSystem_LightsModule_GetRangeMultiplierv: __Z67Register_UnityEngine_ParticleSystem_LightsModule_GetRangeMultiplierv, __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf: __ZN5physx2Sc18ParticleSystemCore15setParticleMassEf, __ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E: __ZNK5physx2Gu13GeometryUnion29computeBoundsWithCCDThresholdERNS_6PxVec3ES3_RKNS_11PxTransformEPKNS_9PxBounds3E, __Z41getPxVehicleClutchDataMEstimateIterationsPKN5physx19PxVehicleClutchDataE: __Z41getPxVehicleClutchDataMEstimateIterationsPKN5physx19PxVehicleClutchDataE, __ZN12InputManager13GetButtonDownERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager13GetButtonDownERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z52Screen_Get_Custom_PropAutorotateToPortraitUpsideDownv: __Z52Screen_Get_Custom_PropAutorotateToPortraitUpsideDownv, __Z36Caching_Get_Custom_PropSpaceOccupiedv: __Z36Caching_Get_Custom_PropSpaceOccupiedv, __ZN11MonoManager8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11MonoManager8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx15NpActorTemplateINS_7PxClothEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_7PxClothEE17setDominanceGroupEh, __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf: __ZN14ParticleSystem38UpdateModulesPostSimulationIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf, __ZN5physx2Sn13XmlWriterImplD0Ev: __ZN5physx2Sn13XmlWriterImplD0Ev, __Z19TransferField_ArrayI8JSONRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx9NpPhysics12getMaterialsEPPNS_10PxMaterialEjj: __ZNK5physx9NpPhysics12getMaterialsEPPNS_10PxMaterialEjj, __ZN11DynamicMesh13CreatePolygonERK13dynamic_arrayI8Vector3fLj4EEj: __ZN11DynamicMesh13CreatePolygonERK13dynamic_arrayI8Vector3fLj4EEj, __ZN4FMOD8ChannelI9isPlayingEPb: __ZN4FMOD8ChannelI9isPlayingEPb, __ZN13GfxDeviceNull17BeginTimerQueriesEv: __ZN13GfxDeviceNull17BeginTimerQueriesEv, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __Z50Register_UnityEngine_RenderSettings_get_fogDensityv: __Z50Register_UnityEngine_RenderSettings_get_fogDensityv, __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesXP12Il2CppObjecti: __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesXP12Il2CppObjecti, _cff_driver_class_pic_init: _cff_driver_class_pic_init, __Z24RegisterStrippedTypeInfoI15RelativeJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15RelativeJoint2DEviPKcS2_, __ZNK8Animator7IsHumanEv: __ZNK8Animator7IsHumanEv, __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthYMultiplierP12Il2CppObject: __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthYMultiplierP12Il2CppObject, __Z36Application_Get_Custom_PropIsTestRunv: __Z36Application_Get_Custom_PropIsTestRunv, __ZN5Umbra9Matrix4x35clearEv: __ZN5Umbra9Matrix4x35clearEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9GfxDevice19CopyContextDataFromEPKS_: __ZN9GfxDevice19CopyContextDataFromEPKS_, __Z27CalculateProjectedBoxArea2DPK8Vector3f: __Z27CalculateProjectedBoxArea2DPK8Vector3f, __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapZMultiplierP12Il2CppObject: __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapZMultiplierP12Il2CppObject, __ZN5physx5cloth14SwSolverKernelI8Scalar4fEC2ERKNS0_7SwClothERNS0_11SwClothDataER14StackAllocatorILj16EERNS0_21IterationStateFactoryEPNS_13PxProfileZoneE: __ZN5physx5cloth14SwSolverKernelI8Scalar4fEC2ERKNS0_7SwClothERNS0_11SwClothDataER14StackAllocatorILj16EERNS0_21IterationStateFactoryEPNS_13PxProfileZoneE, __Z32getPxArticulationJoint_StiffnessPKN5physx19PxArticulationJointE: __Z32getPxArticulationJoint_StiffnessPKN5physx19PxArticulationJointE, __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE: __ZN5physx2Gu25PersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos5Vec3VERKNS5_12PsTransformVE, __ZN5physx2Gu13GeometryUnion17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu13GeometryUnion17getBinaryMetaDataERNS_14PxOutputStreamE, __Z50AudioHighPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject: __Z50AudioHighPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject, __Z52Register_UnityEngine_Joint_INTERNAL_get_currentForcev: __Z52Register_UnityEngine_Joint_INTERNAL_get_currentForcev, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj678ES2_NS_23PxVehicleDriveSimData4WES6_EEKNS_36PxVehicleDriveSimData4WGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj678ES2_NS_23PxVehicleDriveSimData4WES6_EEKNS_36PxVehicleDriveSimData4WGeneratedInfoEEEvPjRKT_RT0_, __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z8EvaluateIL12GradientMode1ELS0_0EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D: __ZN10Collider2D31CalculateColliderTransformationEPP6b2BodyR10Matrix4x4fP11Rigidbody2D, __ZN5Image8SetImageERK14ImageReferenceb: __ZN5Image8SetImageERK14ImageReferenceb, __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN5physx30NbDiscreteContactPairsPropertyC2Ev: __ZN5physx30NbDiscreteContactPairsPropertyC2Ev, _Compute_Funcs: _Compute_Funcs, __Z36setPxVehicleDriveDynDataMCurrentGearPN5physx21PxVehicleDriveDynDataEj: __Z36setPxVehicleDriveDynDataMCurrentGearPN5physx21PxVehicleDriveDynDataEj, __ZN7mecanim5human21HumanSubColliderXformEPKNS0_5HumanERKN4math4trsXEi: __ZN7mecanim5human21HumanSubColliderXformEPKNS0_5HumanERKN4math4trsXEi, __ZN20BufferedSocketStream4PollEy: __ZN20BufferedSocketStream4PollEy, __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapXMultiplierP12Il2CppObjectf: __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapXMultiplierP12Il2CppObjectf, _chown: _chown, __ZN5physx18PxsDynamicsContext7destroyEv: __ZN5physx18PxsDynamicsContext7destroyEv, __ZN5physx2Sc5Scene19scheduleParticleGpuERNS_10PxBaseTaskE: __ZN5physx2Sc5Scene19scheduleParticleGpuERNS_10PxBaseTaskE, __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10Matrix4x4f8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11RadixSorterD2Ev: __ZN11RadixSorterD2Ev, __Z40NavMeshAgent_Set_Custom_PropAngularSpeedP12Il2CppObjectf: __Z40NavMeshAgent_Set_Custom_PropAngularSpeedP12Il2CppObjectf, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED0Ev: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEED0Ev, __ZN18GfxFramebufferGLES32InvalidateActiveFramebufferStateEv: __ZN18GfxFramebufferGLES32InvalidateActiveFramebufferStateEv, __Z27InitializeRenderLoopContextP6CameraRK19SharedRendererSceneP10RenderLoop: __Z27InitializeRenderLoopContextP6CameraRK19SharedRendererSceneP10RenderLoop, __ZN5physx9NpFactory17createRigidStaticERKNS_11PxTransformE: __ZN5physx9NpFactory17createRigidStaticERKNS_11PxTransformE, __ZNK13b2CircleShape13GetChildCountEv: __ZNK13b2CircleShape13GetChildCountEv, __ZN5physx23PxsBroadPhaseContextSap15getCreatedPairsEv: __ZN5physx23PxsBroadPhaseContextSap15getCreatedPairsEv, __Z32getPxVehicleGearsDataMSwitchTimePKN5physx18PxVehicleGearsDataE: __Z32getPxVehicleGearsDataMSwitchTimePKN5physx18PxVehicleGearsDataE, __Z19getShapeWorldBoundsRKN5physx7PxShapeE: __Z19getShapeWorldBoundsRKN5physx7PxShapeE, __ZNSt3__215__time_get_tempIcED0Ev: __ZNSt3__215__time_get_tempIcED0Ev, __Z11FitTangentsI11QuaternionfEvR11KeyframeTplIT_ES4_ffRKS2_S6_: __Z11FitTangentsI11QuaternionfEvR11KeyframeTplIT_ES4_ffRKS2_S6_, __ZN26AnimatorControllerPlayable10GetIntegerEiRi: __ZN26AnimatorControllerPlayable10GetIntegerEiRi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj602ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj602ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN23TransformChangeDispatch28GetAndClearChangedTransformsE27TransformChangeSystemHandleR13dynamic_arrayI23TransformAccessReadOnlyLj4EE: __ZN23TransformChangeDispatch28GetAndClearChangedTransformsE27TransformChangeSystemHandleR13dynamic_arrayI23TransformAccessReadOnlyLj4EE, __ZN5Umbra11ShadowUtils17getLightSpaceAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector4ERKS1_: __ZN5Umbra11ShadowUtils17getLightSpaceAABBERNS_4AABBERKNS_9Matrix4x4EPKNS_7Vector4ERKS1_, _UNITY_FT_Stream_New: _UNITY_FT_Stream_New, __ZN25b2PolygonAndCircleContactC2EP9b2FixtureS1_: __ZN25b2PolygonAndCircleContactC2EP9b2FixtureS1_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxVehicleEngineDataEEEE36handlePxFixedSizeLookupTablePropertyILj521ES4_fjNS_18PxUnknownClassInfoEEEvjRKNS_34PxFixedSizeLookupTablePropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17PhysicsMaterial2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN14ShadowSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14ShadowSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __Z47Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK8Vector3fi: __Z47Rigidbody_CUSTOM_INTERNAL_CALL_AddRelativeForceP12Il2CppObjectRK8Vector3fi, __ZN5physx2Sc8RigidSimD0Ev: __ZN5physx2Sc8RigidSimD0Ev, __ZNSt3__26locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7codecvtIcc11__mbstate_tEEEEvPT_, __ZN11ForceModule9ResetSeedERK27ParticleSystemReadOnlyState: __ZN11ForceModule9ResetSeedERK27ParticleSystemReadOnlyState, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu11HeightFieldEE12getClassSizeEv, __ZN14PreloadManager17SetThreadPriorityE14ThreadPriority: __ZN14PreloadManager17SetThreadPriorityE14ThreadPriority, __ZNK9ShaderLab16FastPropertyName7GetNameEv: __ZNK9ShaderLab16FastPropertyName7GetNameEv, __ZN11AssetBundle7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11AssetBundle7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sn5ConvX11closeOutputEv: __ZN5physx2Sn5ConvX11closeOutputEv, __ZN22BaseUnityConnectClient22UpdateConfigFromServerEv: __ZN22BaseUnityConnectClient22UpdateConfigFromServerEv, __ZN4FMOD6System14getSpeakerModeEP16FMOD_SPEAKERMODE: __ZN4FMOD6System14getSpeakerModeEP16FMOD_SPEAKERMODE, _ldexp: _ldexp, __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_: __ZNK5physx2Gu16SupportLocalImplINS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_, __ZN11TerrainData12CleanupClassEv: __ZN11TerrainData12CleanupClassEv, __Z79Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableInteriorCollisionsv: __Z79Register_UnityEngine_ParticleSystem_CollisionModule_GetEnableInteriorCollisionsv, __Z19UpdateProceduralTplILb1EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E: __Z19UpdateProceduralTplILb1EEvRK20DualMinMaxPolyCurvesR23ParticleSystemParticlesPfRKN4math7_float4E, __Z16AppendSceneRangeiiiR13dynamic_arrayI10SceneRangeLj4EE: __Z16AppendSceneRangeiiiR13dynamic_arrayI10SceneRangeLj4EE, __ZN5physx7NpShapeC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKttb: __ZN5physx7NpShapeC2ERKNS_10PxGeometryENS_7PxFlagsINS_11PxShapeFlag4EnumEhEEPKttb, __ZZN14Physics2DState10InitializeEvEN30PreUpdatePhysics2DUpdatestruct7ForwardEv: __ZZN14Physics2DState10InitializeEvEN30PreUpdatePhysics2DUpdatestruct7ForwardEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERf: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERf, __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN23ShaderVariantCollection8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN10AtomicList4LoadERi: __ZN10AtomicList4LoadERi, __Z40Register_UnityEngine_MeshFilter_get_meshv: __Z40Register_UnityEngine_MeshFilter_get_meshv, __Z43Physics2D_Set_Custom_PropQueriesHitTriggersh: __Z43Physics2D_Set_Custom_PropQueriesHitTriggersh, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERj: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERj, __ZN5physx22PxcContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcContactPlaneCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERh: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERh, __ZN5physx14PxRigidBodyExt18addForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb: __ZN5physx14PxRigidBodyExt18addForceAtLocalPosERNS_11PxRigidBodyERKNS_6PxVec3ES5_NS_11PxForceMode4EnumEb, __ZN19SharedBillboardDataD2Ev: __ZN19SharedBillboardDataD2Ev, __ZN5physx2Sc8ClothSim18removeCollisionBoxEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim18removeCollisionBoxEPKNS0_8ShapeSimE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20SoundChannelInstance17set3DDopplerLevelEf: __ZN20SoundChannelInstance17set3DDopplerLevelEf, __ZN4Halo13AwakeFromLoadE17AwakeFromLoadMode: __ZN4Halo13AwakeFromLoadE17AwakeFromLoadMode, __ZN9GfxDevice26SetRandomWriteTargetBufferEi15ComputeBufferID: __ZN9GfxDevice26SetRandomWriteTargetBufferEi15ComputeBufferID, __ZN10AudioMixer20TransitionToSnapshotERK4PPtrI18AudioMixerSnapshotEf: __ZN10AudioMixer20TransitionToSnapshotERK4PPtrI18AudioMixerSnapshotEf, __ZThn4_N12_GLOBAL__N_111StreamOwner9readBytesEPhj: __ZThn4_N12_GLOBAL__N_111StreamOwner9readBytesEPhj, __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitv: __Z63Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitv, __ZNK8VRDevice19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZNK8VRDevice19GetTrackedNodeNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13SweepCallback14processTouchesEPKN5physx10PxSweepHitEj: __ZN13SweepCallback14processTouchesEPKN5physx10PxSweepHitEj, __Z63Register_UnityEngine_WheelCollider_INTERNAL_get_forwardFrictionv: __Z63Register_UnityEngine_WheelCollider_INTERNAL_get_forwardFrictionv, __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_get_relativeForcev: __Z63Register_UnityEngine_ConstantForce2D_INTERNAL_get_relativeForcev, __ZN15b2RevoluteJoint23InitVelocityConstraintsERK12b2SolverData: __ZN15b2RevoluteJoint23InitVelocityConstraintsERK12b2SolverData, __ZNK8Playable14GetInputWeightEi: __ZNK8Playable14GetInputWeightEi, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ConstraintGroupNodeEEEE15growAndPushBackERKS2_, _UNITY_FT_Stroker_LineTo: _UNITY_FT_Stroker_LineTo, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZN9SubModule14SubEmitterData8LessThanEPKS0_S2_: __ZN9SubModule14SubEmitterData8LessThanEPKS0_S2_, __ZN22NavMeshProjectSettingsD0Ev: __ZN22NavMeshProjectSettingsD0Ev, __ZN9Scripting27BackingArrayFieldForListOfTEP11Il2CppClass: __ZN9Scripting27BackingArrayFieldForListOfTEP11Il2CppClass, __ZNK12b2MotorJoint16GetAngularOffsetEv: __ZNK12b2MotorJoint16GetAngularOffsetEv, __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E: __ZNK15PolynomialCurve24EvaluateDoubleIntegratedERKN4math7_float4E, __ZNK20TextRenderingPrivate8TextMesh7GetFontEv: __ZNK20TextRenderingPrivate8TextMesh7GetFontEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Gu30LargePersistentContactManifoldEEEE15growAndPushBackERKS2_, __Z54Register_UnityEngine_Camera_INTERNAL_get_cullingMatrixv: __Z54Register_UnityEngine_Camera_INTERNAL_get_cullingMatrixv, __ZN32PlaneColliderCache_dense_hashmap7ReplaceERK8Vector3fS2_S2_S2_iif: __ZN32PlaneColliderCache_dense_hashmap7ReplaceERK8Vector3fS2_S2_S2_iif, __Z72Register_UnityEngine_Animator_INTERNAL_CALL_SetBoneLocalRotationInternalv: __Z72Register_UnityEngine_Animator_INTERNAL_CALL_SetBoneLocalRotationInternalv, __Z55NavMeshAgent_CUSTOM_INTERNAL_CALL_CalculatePathInternalP12Il2CppObjectRK8Vector3fS0_: __Z55NavMeshAgent_CUSTOM_INTERNAL_CALL_CalculatePathInternalP12Il2CppObjectRK8Vector3fS0_, __ZNK17ArchiveFileSystem6ExistsERK13FileEntryData: __ZNK17ArchiveFileSystem6ExistsERK13FileEntryData, __ZNK5physx13NpClothFabric12getNbTethersEv: __ZNK5physx13NpClothFabric12getNbTethersEv, __Z49Register_UnityEngine_Random_INTERNAL_get_rotationv: __Z49Register_UnityEngine_Random_INTERNAL_get_rotationv, __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj: __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj, __Z39setPxVehicleSuspensionDataMCamberAtRestPN5physx23PxVehicleSuspensionDataEf: __Z39setPxVehicleSuspensionDataMCamberAtRestPN5physx23PxVehicleSuspensionDataEf, __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi: __ZNK19RenderEventsContext21FlattenCommandBuffersEiR17ShaderPassContextR15RenderNodeQueueP19ProfilerInformationi, __ZNK9ShaderLab11ShaderState29GetSupportsFullForwardShadowsEv: __ZNK9ShaderLab11ShaderState29GetSupportsFullForwardShadowsEv, __ZNSt3__217__widen_from_utf8ILj16EED0Ev: __ZNSt3__217__widen_from_utf8ILj16EED0Ev, __ZN5physx13NpClothFabric7releaseEv: __ZN5physx13NpClothFabric7releaseEv, __ZN19BaseConnectSettings10SetEnabledEb: __ZN19BaseConnectSettings10SetEnabledEb, __Z52Register_UnityEngine_Screen_get_autorotateToPortraitv: __Z52Register_UnityEngine_Screen_get_autorotateToPortraitv, __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_113ClassDescImplEED0Ev: __ZN5physx8debugger15ForwardingArrayIPN12_GLOBAL__N_113ClassDescImplEED0Ev, __ZN25RuntimeAnimatorController21BuildCustomControllerERK13AnimationClipPKN7mecanim9animation18ControllerConstantERNS3_6memory9AllocatorE: __ZN25RuntimeAnimatorController21BuildCustomControllerERK13AnimationClipPKN7mecanim9animation18ControllerConstantERNS3_6memory9AllocatorE, __ZN14SerializedFile4Type8ReadTypeILb1EEEbibRPKhS3_Pi: __ZN14SerializedFile4Type8ReadTypeILb1EEEbibRPKhS3_Pi, __ZNK6Avatar13HasRootMotionEv: __ZNK6Avatar13HasRootMotionEv, __ZN14dtPathCorridor8freePathEv: __ZN14dtPathCorridor8freePathEv, __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE8recreateEj: __ZN5physx6shdfnd5ArrayIhNS_7profile26WrapperReflectionAllocatorIhEEE8recreateEj, __Z52Application_Set_Custom_PropBackgroundLoadingPriority14ThreadPriority: __Z52Application_Set_Custom_PropBackgroundLoadingPriority14ThreadPriority, __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEEC2ERNS_19PxAllocatorCallbackEjPS2_: __ZN5physx7profile17MemoryEventBufferINS_19PxProfileEventMutexENS0_8NullLockEEC2ERNS_19PxAllocatorCallbackEjPS2_, __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __ZN7mecanim24CreateValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE: __ZN7mecanim24CreateValueArrayConstantENS_9ValueTypeEjRNS_6memory9AllocatorE, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpArticulationEE13isSubordinateEv, __ZL15AddSliverCornerPjjii: __ZL15AddSliverCornerPjjii, __ZN10HumanTrait4Body13GetMuscleNameEi: __ZN10HumanTrait4Body13GetMuscleNameEi, __Z67Register_UnityEngine_Terrain_Internal_GetSplatMaterialPropertyBlockv: __Z67Register_UnityEngine_Terrain_Internal_GetSplatMaterialPropertyBlockv, __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene: __ZN19RuntimeSceneManager19UnloadSceneInternalEP10UnityScene, __Z17PxcPoolMallocTermv: __Z17PxcPoolMallocTermv, __Z30Playable_CUSTOM_InternalCreateP12Il2CppObject: __Z30Playable_CUSTOM_InternalCreateP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZN9b2Fixture13CreateProxiesEP12b2BroadPhaseRK11b2Transform: __ZN9b2Fixture13CreateProxiesEP12b2BroadPhaseRK11b2Transform, __ZL21GetAllTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __ZL21GetAllTrianglesHelperRK4MeshiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __ZNK5physx7NpCloth19getVirtualParticlesEPj: __ZNK5physx7NpCloth19getVirtualParticlesEPj, __ZN5physx23GetMFrictionVsSlipGraphEPKNS_17PxVehicleTireDataEjj: __ZN5physx23GetMFrictionVsSlipGraphEPKNS_17PxVehicleTireDataEjj, __ZNSt3__26locale5__imp12install_fromINS_8numpunctIcEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8numpunctIcEEEEvRKS1_, __ZN17MonoScriptManager21RegisterRuntimeScriptER10MonoScript: __ZN17MonoScriptManager21RegisterRuntimeScriptER10MonoScript, __ZN33AssetBundleLoadFromAsyncOperation9SetResultENS_21AssetBundleLoadResultEPKc: __ZN33AssetBundleLoadFromAsyncOperation9SetResultENS_21AssetBundleLoadResultEPKc, __ZN5physx6shdfnd18enableFPExceptionsEv: __ZN5physx6shdfnd18enableFPExceptionsEv, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE18getConstraintFlagsEv, __Z50LODGroup_Get_Custom_PropCrossFadeAnimationDurationv: __Z50LODGroup_Get_Custom_PropCrossFadeAnimationDurationv, ___cxx_global_var_init12: ___cxx_global_var_init12, ___cxx_global_var_init13: ___cxx_global_var_init13, ___cxx_global_var_init10: ___cxx_global_var_init10, ___cxx_global_var_init11: ___cxx_global_var_init11, __ZN9Texture3D14DestroyTextureEv: __ZN9Texture3D14DestroyTextureEv, _y0f: _y0f, __ZN5physx16PxcRunNpPCMBatchEjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE: __ZN5physx16PxcRunNpPCMBatchEjjjPNS_16PxsThreadContextERNS_17PxcNpMemBlockPoolEjjPNS_15PxcNpBatchEntryEjS5_jS5_jS5_jPjjRjS7_PNS_14PxLightCpuTaskERNS_2Cm9FlushPoolE, __ZL30InitializeModule_JSONSerializev: __ZL30InitializeModule_JSONSerializev, __Z29StdTemplateConversionFunctionIyiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyiEbPvR14SafeBinaryRead, __ZN12ScriptMapper7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12ScriptMapper7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_11ConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __ZN20TextRenderingPrivate19NativeTextGenerator13FontSizeRatioEf: __ZN20TextRenderingPrivate19NativeTextGenerator13FontSizeRatioEf, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10setDampingEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10setDampingEf, __ZNK9Heightmap21GetMaximumHeightErrorEiii: __ZNK9Heightmap21GetMaximumHeightErrorEiii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE15indexedPropertyILj426ES4_NS_8PxD6Axis4EnumENS_10PxD6Motion4EnumEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __Z18ConvertUTF16toUTF8PKtiPhRi: __Z18ConvertUTF16toUTF8PKtiPhRi, __Z47RenderSettings_Set_Custom_PropReflectionBouncesi: __Z47RenderSettings_Set_Custom_PropReflectionBouncesi, __Z18Transfer_BlittableI9JSONWriteLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK7Texture12GetGPUHeightEv: __ZNK7Texture12GetGPUHeightEv, __Z40Mesh_CUSTOM_GetAllocArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei: __Z40Mesh_CUSTOM_GetAllocArrayFromChannelImplP12Il2CppObject30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypei, __Z54Register_UnityEngine_AnimationState_AddMixingTransformv: __Z54Register_UnityEngine_AnimationState_AddMixingTransformv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj124ENS_22PxRepXPropertyAccessorILj124ES4_PKcSA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEE14handleAccessorILj124ENS_22PxRepXPropertyAccessorILj124ES4_PKcSA_EEEEvRKT0_, __Z55AvatarBuilder_CUSTOM_INTERNAL_CALL_BuildHumanAvatarMonoP12Il2CppObjectRK20MonoHumanDescription: __Z55AvatarBuilder_CUSTOM_INTERNAL_CALL_BuildHumanAvatarMonoP12Il2CppObjectRK20MonoHumanDescription, __ZNSt3__218__insertion_sort_3IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_: __ZNSt3__218__insertion_sort_3IRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_, __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE10deallocateEv: __ZNSt3__26vectorIPNS_6locale5facetENS_15__sso_allocatorIS3_Lj28EEEE10deallocateEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __ZNK14ParticleSystem10GetPrewarmEv: __ZNK14ParticleSystem10GetPrewarmEv, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE17setDominanceGroupEh, __ZN4FMOD13ChannelGroupI14getNumChannelsEPi: __ZN4FMOD13ChannelGroupI14getNumChannelsEPi, __ZN12_GLOBAL__N_117ProfileZoneClient17handleBufferFlushEPKhj: __ZN12_GLOBAL__N_117ProfileZoneClient17handleBufferFlushEPKhj, __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE7reserveEj: __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE7reserveEj, __ZN5physx3Ext13DistanceJoint14setMinDistanceEf: __ZN5physx3Ext13DistanceJoint14setMinDistanceEf, __ZNK24OcclusionCullingSettings19ShouldWriteForBuildEv: __ZNK24OcclusionCullingSettings19ShouldWriteForBuildEv, __Z13RegisterClassI15RelativeJoint2DEvv: __Z13RegisterClassI15RelativeJoint2DEvv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ShapeInstancePairLLEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN5physx3Scb5Actor7OffsetsC2Ev: __ZN5physx3Scb5Actor7OffsetsC2Ev, __Z18Transfer_BlittableI9JSONWriteLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK15MonoScriptCache6RetainEv: __ZNK15MonoScriptCache6RetainEv, __Z38WebCamTexture_Get_Custom_PropIsPlayingP12Il2CppObject: __Z38WebCamTexture_Get_Custom_PropIsPlayingP12Il2CppObject, __ZN24OptimizedPolynomialCurve9IntegrateEv: __ZN24OptimizedPolynomialCurve9IntegrateEv, __Z27Texture2DArray_CUSTOM_ApplyP12Il2CppObjecthh: __Z27Texture2DArray_CUSTOM_ApplyP12Il2CppObjecthh, __ZNK14RenderSettings26GetTypeInfoVirtualInternalEv: __ZNK14RenderSettings26GetTypeInfoVirtualInternalEv, __Z46SkinnedMeshRenderer_CUSTOM_GetBlendShapeWeightP12Il2CppObjecti: __Z46SkinnedMeshRenderer_CUSTOM_GetBlendShapeWeightP12Il2CppObjecti, __Z36HingeJoint_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK10JointMotor: __Z36HingeJoint_CUSTOM_INTERNAL_set_motorP12Il2CppObjectRK10JointMotor, __Z37NavMeshPath_CUSTOM_GetCornersNonAllocP12Il2CppObjectP11Il2CppArray: __Z37NavMeshPath_CUSTOM_GetCornersNonAllocP12Il2CppObjectP11Il2CppArray, __ZN8JSONRead8TransferIN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfigEEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIN11UnityEngine9Analytics15AnalyticsConfig17CustomEventConfigEEEvRT_PKc17TransferMetaFlagsb, __ZNSt15underflow_errorD0Ev: __ZNSt15underflow_errorD0Ev, __ZN8VRDevice19RenderOcclusionMeshEv: __ZN8VRDevice19RenderOcclusionMeshEv, __ZN14SubstanceInputC2ERKS_: __ZN14SubstanceInputC2ERKS_, __ZN7Cubemap34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction: __ZN7Cubemap34UpdateFileTextureUploadInstructionEP28FileTextureUploadInstruction, __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_3Scb12RemovedShapeENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __Z48DownloadHandlerTexture_CUSTOM_InternalGetTextureP12Il2CppObject: __Z48DownloadHandlerTexture_CUSTOM_InternalGetTextureP12Il2CppObject, __ZN5physx7NpScene15SceneCompletion7releaseEv: __ZN5physx7NpScene15SceneCompletion7releaseEv, _copysignf: _copysignf, __ZN14ConstantString6assignERKS_: __ZN14ConstantString6assignERKS_, __ZN14MemoryProfiler18RegisterMemoryToIDEjj: __ZN14MemoryProfiler18RegisterMemoryToIDEjj, __ZN2UI13DoSyncCullingERNS_13UIInstructionEb: __ZN2UI13DoSyncCullingERNS_13UIInstructionEb, __ZN17PolygonCollider2D16CheckConsistencyEv: __ZN17PolygonCollider2D16CheckConsistencyEv, __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorINS_4pairIiiEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, _copysignl: _copysignl, __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_14PxArticulationENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z61Register_UnityEngine_Rigidbody2D_set_useFullKinematicContactsv: __Z61Register_UnityEngine_Rigidbody2D_set_useFullKinematicContactsv, __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE: __ZNSt3__26__treeINS_12__value_typeIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEN11UnityEngine7Connect19RemoteSettingsValueEEENS_19__map_value_compareIS6_SA_NS_4lessIS6_EELb1EEE13stl_allocatorISA_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeISA_PvEE, __ZN7Texture6RetainEv: __ZN7Texture6RetainEv, __Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei: __Z24IntersectAABBPlaneBoundsRK4AABBPK5Planei, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS0_3aos6Mat33VENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN4FMOD6System9getDriverEPi: __ZN4FMOD6System9getDriverEPi, __ZN15ReflectionProbe18SetTimeSlicingModeENS_15TimeSlicingModeE: __ZN15ReflectionProbe18SetTimeSlicingModeENS_15TimeSlicingModeE, __ZNK8Material21GetShaderKeywordNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE: __ZNK8Material21GetShaderKeywordNamesERNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEE, __ZN9rapidjson8internal6Grisu2EdPcPiS2_: __ZN9rapidjson8internal6Grisu2EdPcPiS2_, __ZN11GameManagerD2Ev: __ZN11GameManagerD2Ev, __ZN5physx15NpParticleFluid25lockParticleFluidReadDataEv: __ZN5physx15NpParticleFluid25lockParticleFluidReadDataEv, __Z8CRCBeginv: __Z8CRCBeginv, __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackE: __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackE, __ZNSt3__24stolERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji: __ZNSt3__24stolERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPji, ___syscall_ret: ___syscall_ret, __ZN5physx10ChangeList11computeListEv: __ZN5physx10ChangeList11computeListEv, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE7setNameEPKc, __Z63Register_UnityEngine_HumanPoseHandler_Internal_HumanPoseHandlerv: __Z63Register_UnityEngine_HumanPoseHandler_Internal_HumanPoseHandlerv, __Z13StoreLineDataP15LineBuilderDataRfRKN4math8float4x4EPKNS2_14float3_storageE: __Z13StoreLineDataP15LineBuilderDataRfRKN4math8float4x4EPKNS2_14float3_storageE, __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI21SoftJointLimit_Unity4E8TransferI14SafeBinaryReadEEvRS0_RT_, __Z39Register_UnityEngine_GUIText_set_anchorv: __Z39Register_UnityEngine_GUIText_set_anchorv, __ZN5physx2Gu12SupportLocalD2Ev: __ZN5physx2Gu12SupportLocalD2Ev, __Z23LODGroup_CUSTOM_GetLODsP12Il2CppObject: __Z23LODGroup_CUSTOM_GetLODsP12Il2CppObject, __ZN11LightProbesD0Ev: __ZN11LightProbesD0Ev, __Z16SceneLoadingLoopv: __Z16SceneLoadingLoopv, __ZN9Projector15ThreadedCleanupEv: __ZN9Projector15ThreadedCleanupEv, __Z37Mesh_Get_Custom_PropVertexBufferCountP12Il2CppObject: __Z37Mesh_Get_Custom_PropVertexBufferCountP12Il2CppObject, __Z37AnimationClip_Get_Custom_PropWrapModeP12Il2CppObject: __Z37AnimationClip_Get_Custom_PropWrapModeP12Il2CppObject, __ZL7AddQuadPjjii: __ZL7AddQuadPjjii, __ZN5physx27PxcFsGetImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_: __ZN5physx27PxcFsGetImpulseSelfResponseERKNS_9PxcFsDataEjRKNS_14PxcSIMDSpatialERS3_jS5_S6_, __ZN14AnimationState14AllocateCurvesEi: __ZN14AnimationState14AllocateCurvesEi, __ZN5physx13PxClothFabricD0Ev: __ZN5physx13PxClothFabricD0Ev, __ZN13GfxDeviceGLES17AfterPluginRenderEv: __ZN13GfxDeviceGLES17AfterPluginRenderEv, __ZNK7ApiGLES6VerifyEv: __ZNK7ApiGLES6VerifyEv, __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR17DetailNodeXSorterP16DetailMeshBVNodeEEjT0_S5_S5_T_, __Z14ExtractAddressP8sockaddrjPciPi: __Z14ExtractAddressP8sockaddrjPciPi, __ZN15RelativeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15RelativeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN11UnityEngine15CloudWebService14DataDispatcher33SaveDirtyDispatchSessionContainerERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService14DataDispatcher33SaveDirtyDispatchSessionContainerERNS0_16SessionContainerE, __ZN5physx32PxHeightFieldDescGeneratedValuesC2EPKNS_17PxHeightFieldDescE: __ZN5physx32PxHeightFieldDescGeneratedValuesC2EPKNS_17PxHeightFieldDescE, __ZN5physx14updateParticleERNS_16PxsFluidParticleERKNS_19PxsParticleCollDataEbRKNS_7PxPlaneERNS_9PxBounds3E: __ZN5physx14updateParticleERNS_16PxsFluidParticleERKNS_19PxsParticleCollDataEbRKNS_7PxPlaneERNS_9PxBounds3E, __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags, __ZNK6Avatar14GetPreRotationEi: __ZNK6Avatar14GetPreRotationEi, __ZN9Coroutine14InvokeMoveNextEPP15Il2CppException: __ZN9Coroutine14InvokeMoveNextEPP15Il2CppException, __ZN5physx2Sc15ArticulationSim15setIslandHandleERNS0_7BodySimEj: __ZN5physx2Sc15ArticulationSim15setIslandHandleERNS0_7BodySimEj, __ZN8Renderer29SetMotionVectorGenerationModeE26MotionVectorGenerationMode: __ZN8Renderer29SetMotionVectorGenerationModeE26MotionVectorGenerationMode, __Z44AudioReverbFilter_Get_Custom_PropLfReferenceP12Il2CppObject: __Z44AudioReverbFilter_Get_Custom_PropLfReferenceP12Il2CppObject, __ZL44UnityAudioEffect_InternalSetPositionCallbackP14FMOD_DSP_STATEj: __ZL44UnityAudioEffect_InternalSetPositionCallbackP14FMOD_DSP_STATEj, __ZNSt3__215__thread_struct25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE: __ZNSt3__215__thread_struct25notify_all_at_thread_exitEPNS_18condition_variableEPNS_5mutexE, __Z24RegisterStrippedTypeInfoI13TargetJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI13TargetJoint2DEviPKcS2_, __Z37getNbPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataE: __Z37getNbPxVehicleWheelsSimData_WheelDataPKN5physx22PxVehicleWheelsSimDataE, _sfnt_module_class_pic_free: _sfnt_module_class_pic_free, __Z51Register_UnityEngine_VR_VRSettings_LoadDeviceByNamev: __Z51Register_UnityEngine_VR_VRSettings_LoadDeviceByNamev, __ZN11BoxCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11BoxCollider23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve: __Z44ParticleSystem_SizeBySpeedModule_CUSTOM_GetXP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI9TextureIDP7TextureEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZNK5physx19NpArticulationJoint12getDriveTypeEv: __ZNK5physx19NpArticulationJoint12getDriveTypeEv, __ZN20OcclusionCullingData7CleanupEv: __ZN20OcclusionCullingData7CleanupEv, __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_S8_S8_T_, __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_springv: __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_springv, __ZN7Terrain23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN7Terrain23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z23TransferScriptingObjectI18StreamedBinaryReadILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI18StreamedBinaryReadILb0EEEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SpringJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn17readAllPropertiesINS_14PxArticulationEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_14PxArticulationEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_: __ZNSt3__26__sortIR12GCHandleLessPNS_4pairIyiEEEEvT0_S6_T_, __ZN11AudioSource19ConfigureFMODGroupsEv: __ZN11AudioSource19ConfigureFMODGroupsEv, __ZN5physx2Sq14PrunerCallbackD2Ev: __ZN5physx2Sq14PrunerCallbackD2Ev, __ZN16ScriptingManagerC2E10MemLabelId18ObjectCreationMode: __ZN16ScriptingManagerC2E10MemLabelId18ObjectCreationMode, __ZN10CBBoxInt325EmptyEv: __ZN10CBBoxInt325EmptyEv, __Z40Register_UnityEngine_Animator_get_avatarv: __Z40Register_UnityEngine_Animator_get_avatarv, __ZN5physx15solveConclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx15solveConclude1DERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState: __ZNK8GUIStyle11DrawContentER8GUIStateRK5RectTIfER10GUIContentPK13GUIStyleState, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25getMassSpaceInertiaTensorEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25getMassSpaceInertiaTensorEv, __ZN17AudioReverbFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17AudioReverbFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN14MemoryProfilerC2Ev: __ZN14MemoryProfilerC2Ev, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_13NpClothFabricEEEEEvPT_jRKT0_RKT1_j, __Z41AudioReverbFilter_Set_Custom_PropDryLevelP12Il2CppObjectf: __Z41AudioReverbFilter_Set_Custom_PropDryLevelP12Il2CppObjectf, __ZN4Node6InsertERfS0_ffbb: __ZN4Node6InsertERfS0_ffbb, __ZN5IMGUI22GetEventTypeForControlERK8GUIStateRK10InputEventi: __ZN5IMGUI22GetEventTypeForControlERK8GUIStateRK10InputEventi, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewFloatArrayiRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_NewFloatArrayiRPv, __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE: __ZN5physx3Scb9Aggregate8addActorERNS0_5ActorE, __ZN5physx2Sq10AABBPruner11shiftOriginERKNS_6PxVec3E: __ZN5physx2Sq10AABBPruner11shiftOriginERKNS_6PxVec3E, __ZN5Umbra13MatrixFactory16orthonormalBasisERKNS_7Vector3E: __ZN5Umbra13MatrixFactory16orthonormalBasisERKNS_7Vector3E, __ZNK10MemoryFile8PositionEv: __ZNK10MemoryFile8PositionEv, __ZN5physx8debugger4comm16SetPropertyValue9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm16SetPropertyValue9serializeERNS1_15EventSerializerE, __Z52Register_UnityEngine_Physics2D_GetLayerCollisionMaskv: __Z52Register_UnityEngine_Physics2D_GetLayerCollisionMaskv, __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN8Collider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12AudioManager19SetApplicationPauseEb: __ZN12AudioManager19SetApplicationPauseEb, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE25setRigidBodyFlagsInternalERKNS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEES8_, __Z18CleanupVideoModulev: __Z18CleanupVideoModulev, __Z19scripting_value_boxP11Il2CppClassPv: __Z19scripting_value_boxP11Il2CppClassPv, __Z54Register_UnityEngine_BuoyancyEffector2D_get_linearDragv: __Z54Register_UnityEngine_BuoyancyEffector2D_get_linearDragv, _updatewindow: _updatewindow, __ZNK9AudioClip7GetDataEPfjj: __ZNK9AudioClip7GetDataEPfjj, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12resize_deltaEjj, __ZN11UTF16StringD2Ev: __ZN11UTF16StringD2Ev, __ZN2UI14CanvasRenderer13SetShouldCullEb: __ZN2UI14CanvasRenderer13SetShouldCullEb, _tt_cmap12_init: _tt_cmap12_init, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefINS1_20StreamPropMessageArgEEE, __ZN6Skybox23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Skybox23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN20LocalFileSystemPosix29ConvertErrnoToFileSystemErrorEi: __ZN20LocalFileSystemPosix29ConvertErrnoToFileSystemErrorEi, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j, __ZNSt3__227__insertion_sort_incompleteIR24RayHitsByDepthComparitorP12RaycastHit2DEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR24RayHitsByDepthComparitorP12RaycastHit2DEEbT0_S5_T_, __Z41ParticleSystem_ShapeModule_CUSTOM_GetMeshP12Il2CppObject: __Z41ParticleSystem_ShapeModule_CUSTOM_GetMeshP12Il2CppObject, __ZNK13b2DynamicTree15ValidateMetricsEi: __ZNK13b2DynamicTree15ValidateMetricsEi, __Z58Register_UnityEngine_AudioSource_get_spatializePostEffectsv: __Z58Register_UnityEngine_AudioSource_get_spatializePostEffectsv, __ZN10TagManager39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN10TagManager39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_: __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE10insert_oneERKS2_, __ZN5physx2Sq8AABBTree16progressiveBuildEPNS0_15AABBTreeBuilderEjj: __ZN5physx2Sq8AABBTree16progressiveBuildEPNS0_15AABBTreeBuilderEjj, __ZN17BufferManagerGLES24UpdateLiveSetFromPendingEv: __ZN17BufferManagerGLES24UpdateLiveSetFromPendingEv, __ZN16UnityAdsSettings5ResetEv: __ZN16UnityAdsSettings5ResetEv, __ZN15NavMeshObstacle9SetHeightEf: __ZN15NavMeshObstacle9SetHeightEf, __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv: __ZNK24OptimizedPolynomialCurve20FindMinMaxIntegratedEv, __Z49Register_UnityEngine_AI_OffMeshLink_get_activatedv: __Z49Register_UnityEngine_AI_OffMeshLink_get_activatedv, __Z76Register_UnityEngine_TerrainData_Internal_GetMaximumDetailResolutionPerPatchv: __Z76Register_UnityEngine_TerrainData_Internal_GetMaximumDetailResolutionPerPatchv, __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE4copyIS2_EEvRKNS1_IjT_EE: __ZN5physx6shdfnd5ArrayIjNS0_9AllocatorEE4copyIS2_EEvRKNS1_IjT_EE, __ZN9dtNavMeshC2Ev: __ZN9dtNavMeshC2Ev, __Z41Register_UnityEngine_Mathf_NextPowerOfTwov: __Z41Register_UnityEngine_Mathf_NextPowerOfTwov, __ZN23ManagedAttributeManagerC2Ev: __ZN23ManagedAttributeManagerC2Ev, __ZN5physx7NpScene7collideEfPNS_10PxBaseTaskEPvj: __ZN5physx7NpScene7collideEfPNS_10PxBaseTaskEPvj, __ZN13BatchRenderer20RenderSingleWithPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEiPKNS7_10GrabPassesEjib: __ZN13BatchRenderer20RenderSingleWithPassER17ShaderPassContextPK18SharedMaterialDataP6ShaderPN9ShaderLab4PassEiPKNS7_10GrabPassesEjib, __ZN5Umbra12PortalCuller17nextCellToProcessERNS_16DoublyLinkedListINS0_8CellDataEtEE: __ZN5Umbra12PortalCuller17nextCellToProcessERNS_16DoublyLinkedListINS0_8CellDataEtEE, __Z44Register_UnityEngine_GUIStyle_get_fixedWidthv: __Z44Register_UnityEngine_GUIStyle_get_fixedWidthv, __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_S3_iiiiiiiiNS0_15FramebufferMaskE: __ZN7ApiGLES15BlitFramebufferEN2gl6HandleILNS0_10ObjectTypeE9EEENS0_15FramebufferReadES3_S3_iiiiiiiiNS0_15FramebufferMaskE, __ZN8JSONRead8TransferIsEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIsEEvRT_PKc17TransferMetaFlagsb, __ZN14SplatPrototypeC2Ev: __ZN14SplatPrototypeC2Ev, __ZNK21DownloadHandlerScript11GetProgressEv: __ZNK21DownloadHandlerScript11GetProgressEv, __ZN12NavMeshAgent14SetAutoBrakingEb: __ZN12NavMeshAgent14SetAutoBrakingEb, __ZNK4AABB8IsInsideERK8Vector3f: __ZNK4AABB8IsInsideERK8Vector3f, __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE: __ZNKSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIwS3_NS_9allocatorIwEEEE, __Z31Light_Get_Custom_PropBakedIndexP12Il2CppObject: __Z31Light_Get_Custom_PropBakedIndexP12Il2CppObject, __ZN5physx2Sc18ParticleSystemCore17notifyCpuFallbackEv: __ZN5physx2Sc18ParticleSystemCore17notifyCpuFallbackEv, __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_T_, __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffnessD0Ev: __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN23RenameSpringToStiffnessD0Ev, __ZN19CharacterController12ScaleChangedEv: __ZN19CharacterController12ScaleChangedEv, __Z40ParticleSystem_MainModule_CUSTOM_SetLoopP12Il2CppObjecth: __Z40ParticleSystem_MainModule_CUSTOM_SetLoopP12Il2CppObjecth, __Z43Register_UnityEngine_Input_GetJoystickNamesv: __Z43Register_UnityEngine_Input_GetJoystickNamesv, __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN12AudioManager23InitScriptBufferManagerEv: __ZN12AudioManager23InitScriptBufferManagerEv, _UnityReplayKitShowCameraPreviewAt: _UnityReplayKitShowCameraPreviewAt, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__28ios_base4InitC2Ev: __ZNSt3__28ios_base4InitC2Ev, __ZL12InvokeMethodI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI14SafeBinaryReadEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN21AnimationPosePlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN21AnimationPosePlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __ZN5physx22PxVehicleWheelsSimData11setTireDataEjRKNS_17PxVehicleTireDataE: __ZN5physx22PxVehicleWheelsSimData11setTireDataEjRKNS_17PxVehicleTireDataE, __ZN7dtCrowd30SetObstaclePositionAndVelocityERK13dtCrowdHandlePKfS4_: __ZN7dtCrowd30SetObstaclePositionAndVelocityERK13dtCrowdHandlePKfS4_, __ZL41InitializeUnityWebRequestScriptingClassesv: __ZL41InitializeUnityWebRequestScriptingClassesv, __ZNKSt3__210moneypunctIwLb1EE13thousands_sepEv: __ZNKSt3__210moneypunctIwLb1EE13thousands_sepEv, __ZN19SkinnedMeshRenderer25CalculateSkinningMatricesERK10Matrix4x4fPS0_j: __ZN19SkinnedMeshRenderer25CalculateSkinningMatricesERK10Matrix4x4fPS0_j, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE15reserveInternalEj, __ZNKSt3__214__codecvt_utf8IDiE13do_max_lengthEv: __ZNKSt3__214__codecvt_utf8IDiE13do_max_lengthEv, __Z13GL_CUSTOM_Endv: __Z13GL_CUSTOM_Endv, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEEEEjT_j, _UNITY_png_set_option: _UNITY_png_set_option, _UNITY_png_get_tRNS: _UNITY_png_get_tRNS, __ZN24AudioScriptBufferManager4InitEv: __ZN24AudioScriptBufferManager4InitEv, __ZN7Hash1283SetEPKhj: __ZN7Hash1283SetEPKhj, __Z39GUI_CUSTOM_INTERNAL_set_backgroundColorRK10ColorRGBAf: __Z39GUI_CUSTOM_INTERNAL_set_backgroundColorRK10ColorRGBAf, __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20GpuProgramParameters12UAVParameterENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN12_GLOBAL__N_112UserRenderer7releaseEv: __ZN12_GLOBAL__N_112UserRenderer7releaseEv, __ZN15ParticleEmitterD0Ev: __ZN15ParticleEmitterD0Ev, __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeE: __ZN5physx14PxCreateStaticERNS_9PxPhysicsERKNS_11PxTransformERNS_7PxShapeE, __Z20scripting_gc_disablev: __Z20scripting_gc_disablev, __ZL22InitializeModule_IMGUIv: __ZL22InitializeModule_IMGUIv, __ZN19AssetBundleManifest15AssetBundleInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19AssetBundleManifest15AssetBundleInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj162ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj162ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Sc5Scene9islandGenEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene9islandGenEPNS_10PxBaseTaskE, __Z38getPxSceneDescCcdContactModifyCallbackPKN5physx11PxSceneDescE: __Z38getPxSceneDescCcdContactModifyCallbackPKN5physx11PxSceneDescE, __ZN23ManagedAttributeManager35CallManagedGetDefaultExecutionOrderEP11Il2CppClass: __ZN23ManagedAttributeManager35CallManagedGetDefaultExecutionOrderEP11Il2CppClass, __ZN13PhysicsModule18DeleteMemoryStreamEP19PhysicsModuleStream: __ZN13PhysicsModule18DeleteMemoryStreamEP19PhysicsModuleStream, __ZN11NoiseModule15PreviewNoiseJobILi3EEEvP19PreviewNoiseJobData: __ZN11NoiseModule15PreviewNoiseJobILi3EEEvP19PreviewNoiseJobData, __ZN5physx2Sn17readAllPropertiesINS_9PxD6JointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_9PxD6JointEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN7ApiGLES16BindStencilStateEPK15GfxStencilStatei: __ZN7ApiGLES16BindStencilStateEPK15GfxStencilStatei, __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI17RemapPPtrTransfer27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj23ENS_12PxRigidActorERKNS_11PxTransformES7_EEEEvjRT_, __ZN13SubstanceData4InitEv: __ZN13SubstanceData4InitEv, __ZNKSt3__220__codecvt_utf8_utf16IwE13do_max_lengthEv: __ZNKSt3__220__codecvt_utf8_utf16IwE13do_max_lengthEv, __ZNK11OffMeshLink26GetTypeInfoVirtualInternalEv: __ZNK11OffMeshLink26GetTypeInfoVirtualInternalEv, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS0_9allocatorIS4_EEEEEvRT_j, __ZN13NavMeshParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13NavMeshParams8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD2Ev: __ZN11UnityEngine15CloudWebService17CloudJobSchedulerD2Ev, __Z37UnityWebRequest_CUSTOM_InternalGetUrlP12Il2CppObject: __Z37UnityWebRequest_CUSTOM_InternalGetUrlP12Il2CppObject, _clogl: _clogl, __ZNK13WheelCollider13GetSprungMassEv: __ZNK13WheelCollider13GetSprungMassEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj591ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj591ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx15PxsCCDSweepTask7getNameEv: __ZNK5physx15PxsCCDSweepTask7getNameEv, __Z51Register_UnityEngine_RenderTexture_get_antiAliasingv: __Z51Register_UnityEngine_RenderTexture_get_antiAliasingv, __ZN24dtObstacleAvoidanceQuery5resetEPKfff: __ZN24dtObstacleAvoidanceQuery5resetEPKfff, __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEb: __ZN18BaseUnityAnalytics10QueueEventERN11UnityEngine15CloudWebService17CloudServiceEventEb, __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi: __ZN14dtNavMeshQuery20updateSlicedFindPathEiPi, __ZNKSt3__212ctype_bynameIwE9do_narrowEwc: __ZNKSt3__212ctype_bynameIwE9do_narrowEwc, __ZN5physx27InternalTriangleMeshBuilder14createEdgeListEv: __ZN5physx27InternalTriangleMeshBuilder14createEdgeListEv, __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI7SubMesh13stl_allocatorIS2_L18MemLabelIdentifier16ELi16EEEEEvRT_j, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj533ENS_22PxRepXPropertyAccessorILj533ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj533ENS_22PxRepXPropertyAccessorILj533ES4_ffEEEEvRKT0_, __Z33Texture2DArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayii: __Z33Texture2DArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayii, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES7_EEKNS_31PxVehicleGearsDataGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx16PxsIslandManager13updateIslandsEPNS_10PxBaseTaskEj: __ZN5physx16PxsIslandManager13updateIslandsEPNS_10PxBaseTaskEj, __ZN5Umbra15CameraTransform16setCameraToWorldERKNS_9Matrix4x4E: __ZN5Umbra15CameraTransform16setCameraToWorldERKNS_9Matrix4x4E, __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_: __ZNSt3__26__sortIRNS_6__lessINS_4pairIPKN5Unity4TypeE7Hash128EES8_EEPS8_EEvT0_SC_T_, __Z48ConfigurableJoint_CUSTOM_INTERNAL_get_slerpDriveP12Il2CppObjectP10JointDrive: __Z48ConfigurableJoint_CUSTOM_INTERNAL_get_slerpDriveP12Il2CppObjectP10JointDrive, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_20rigidBodyNarrowPhaseEPNS_10PxBaseTaskEEEED0Ev, __ZN19UnityConnectService18OnAdsIdRequestDoneERK8UnityStrbS2_: __ZN19UnityConnectService18OnAdsIdRequestDoneERK8UnityStrbS2_, __Z23GetContainerElementTypeRK16TypeTreeIterator: __Z23GetContainerElementTypeRK16TypeTreeIterator, __ZZN15DirectorManager15InitializeClassEvEN45PreLateUpdateDirectorUpdateAnimationEndstruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN45PreLateUpdateDirectorUpdateAnimationEndstruct7ForwardEv, __ZN5physx2Gu10ConvexMesh17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Gu10ConvexMesh17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackERNS_15PxErrorCallbackE: __ZN5physx6shdfnd12ErrorHandler23unRegisterErrorCallbackERNS_15PxErrorCallbackE, __ZNK5physx14PxLightCpuTask12getReferenceEv: __ZNK5physx14PxLightCpuTask12getReferenceEv, __ZN9Texture2D34CreateFileTextureUploadInstructionEv: __ZN9Texture2D34CreateFileTextureUploadInstructionEv, __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_get_forcev: __Z55Register_UnityEngine_ConstantForce2D_INTERNAL_get_forcev, __ZNSt3__26locale5__imp12install_fromINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvRKS1_, __Z50CanvasRenderer_CUSTOM_CreateUIVertexStreamInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_S0_: __Z50CanvasRenderer_CUSTOM_CreateUIVertexStreamInternalP12Il2CppObjectS0_S0_S0_S0_S0_S0_S0_, __Z37Camera_Set_Custom_PropStereoTargetEyeP12Il2CppObject13TargetEyeMask: __Z37Camera_Set_Custom_PropStereoTargetEyeP12Il2CppObject13TargetEyeMask, __ZN13TargetJoint2D22SetAutoConfigureTargetEb: __ZN13TargetJoint2D22SetAutoConfigureTargetEb, __ZN8Renderer15UpdateLocalAABBEv: __ZN8Renderer15UpdateLocalAABBEv, _log2f: _log2f, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __Z53Register_UnityEngine_SystemInfo_get_supportsGyroscopev: __Z53Register_UnityEngine_SystemInfo_get_supportsGyroscopev, __Z22GetGraphicsSettingsPtrv: __Z22GetGraphicsSettingsPtrv, __Z45LightmapSettings_Get_Custom_PropLightmapsModev: __Z45LightmapSettings_Get_Custom_PropLightmapsModev, __ZN22ParticleSystemRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN22ParticleSystemRenderer13AwakeFromLoadE17AwakeFromLoadMode, __Z15GetAdsIdHandlerv: __Z15GetAdsIdHandlerv, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE4FindERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEE: __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE4FindERKNS1_12basic_stringIcNS1_11char_traitsIcEENS8_IcEEEE, __ZNSt3__26locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7codecvtIDic11__mbstate_tEEEEvPT_, _UNITY_png_get_y_offset_pixels: _UNITY_png_get_y_offset_pixels, __ZN4FMOD12ChannelGroup11getWaveDataEPfii: __ZN4FMOD12ChannelGroup11getWaveDataEPfii, __ZN13AnimationClip35ClipWasModifiedAndUpdateMuscleRangeEv: __ZN13AnimationClip35ClipWasModifiedAndUpdateMuscleRangeEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E, __ZN15AudioReverbZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15AudioReverbZone23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_ItLj2EES4_: __Z15WeldVertexArrayR13dynamic_arrayI8Vector3fLj4EERS_ItLj2EES4_, _list_add: _list_add, __ZNKSt3__215__codecvt_utf16IDiLb1EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IDiLb1EE9do_lengthER11__mbstate_tPKcS5_j, __ZN5physx18PxVehicleDriveTank5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj: __ZN5physx18PxVehicleDriveTank5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataERKNS_21PxVehicleDriveSimDataEj, __Z33EmitSerializationCommandsForFieldI19StreamedBinaryWriteILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI19StreamedBinaryWriteILb0EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN9Transform25CompleteTransformTransferI14SafeBinaryReadEEvRT_: __ZN9Transform25CompleteTransformTransferI14SafeBinaryReadEEvRT_, __ZN9AudioClip11ReadyToPlayEv: __ZN9AudioClip11ReadyToPlayEv, __ZN11AudioFilterD2Ev: __ZN11AudioFilterD2Ev, __ZNK14SplatMaterials12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE: __ZNK14SplatMaterials12GetMaterialsER13dynamic_arrayIP8MaterialLj4EE, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __Z34register_external_gfx_deallocationPvPKci: __Z34register_external_gfx_deallocationPvPKci, __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR11EventSorterP14AnimationEventEEjT0_S5_S5_S5_T_, __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf: __ZN20SweepCapsuleCallback8finalizeERN5physx10PxSweepHitERKNS0_2Gu7CapsuleERKNS0_22PxTriangleMeshGeometryERKNS0_11PxTransformEbf, __ZN5physx2Cm10Collection6removeERNS_12PxCollectionE: __ZN5physx2Cm10Collection6removeERNS_12PxCollectionE, __Z21getPxScene_AggregatesPKN5physx7PxSceneEPPNS_11PxAggregateEj: __Z21getPxScene_AggregatesPKN5physx7PxSceneEPPNS_11PxAggregateEj, __ZN5physx2Cm12RenderBufferD0Ev: __ZN5physx2Cm12RenderBufferD0Ev, __ZThn32_N14SpriteRendererD1Ev: __ZThn32_N14SpriteRendererD1Ev, __Z33setPxMaterial_FrictionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE: __Z33setPxMaterial_FrictionCombineModePN5physx10PxMaterialENS_13PxCombineMode4EnumE, __ZN12_GLOBAL__N_110DataStreamD0Ev: __ZN12_GLOBAL__N_110DataStreamD0Ev, __ZNK8Animator25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo: __ZNK8Animator25GetAnimatorTransitionInfoEiR22AnimatorTransitionInfo, __ZNK14RenderSettings19GetCustomReflectionEv: __ZNK14RenderSettings19GetCustomReflectionEv, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_15NpParticleFluidENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZNK12MeshRenderer19GetStaticBatchIndexEv: __ZNK12MeshRenderer19GetStaticBatchIndexEv, __ZNK5physx2Sc18ParticleSystemCore12getViscosityEv: __ZNK5physx2Sc18ParticleSystemCore12getViscosityEv, __ZN30RuntimeInitializeOnLoadManager8TransferI14SafeBinaryReadEEvRT_: __ZN30RuntimeInitializeOnLoadManager8TransferI14SafeBinaryReadEEvRT_, __Z26Shader_CUSTOM_GetGlobalInti: __Z26Shader_CUSTOM_GetGlobalInti, __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_: __ZN5physx13CubemapLookupERKNS_6PxVec3ERfS3_, __ZN9Scripting18IsFieldFlagsPublicEi: __ZN9Scripting18IsFieldFlagsPublicEi, __ZN6Object24SetCachedScriptingObjectEP12Il2CppObject: __ZN6Object24SetCachedScriptingObjectEP12Il2CppObject, __Z44Animator_CUSTOM_GetNextAnimatorClipInfoCountP12Il2CppObjecti: __Z44Animator_CUSTOM_GetNextAnimatorClipInfoCountP12Il2CppObjecti, __Z42Register_UnityEngine_CanvasGroup_set_alphav: __Z42Register_UnityEngine_CanvasGroup_set_alphav, __ZN21InheritVelocityModule16CheckConsistencyEv: __ZN21InheritVelocityModule16CheckConsistencyEv, __ZN8Animator11GetVelocityEv: __ZN8Animator11GetVelocityEv, __ZN5physx22XmlMemoryAllocatorImpl8allocateEj: __ZN5physx22XmlMemoryAllocatorImpl8allocateEj, __Z17setPxJoint_ActorsPN5physx7PxJointEPNS_12PxRigidActorES3_: __Z17setPxJoint_ActorsPN5physx7PxJointEPNS_12PxRigidActorES3_, __ZN9Rigidbody27GetMaxDepenetrationVelocityEv: __ZN9Rigidbody27GetMaxDepenetrationVelocityEv, __ZNK14SerializedFile11GetByteSizeEx: __ZNK14SerializedFile11GetByteSizeEx, __ZN5physx9NpFactory19onConstraintReleaseEPNS_12PxConstraintE: __ZN5physx9NpFactory19onConstraintReleaseEPNS_12PxConstraintE, _alloc_barray: _alloc_barray, __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI18ProceduralMaterialE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj76ENS0_26PxPvdRangePropertyAccessorILj76ES4_fEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj76ENS0_26PxPvdRangePropertyAccessorILj76ES4_fEEEEvjRKT0_, _UNITY_png_do_strip_channel: _UNITY_png_do_strip_channel, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888816TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888816TexFormatRGFloatEEvPKNS_9InnerInfoE, __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetEnabledv: __Z60Register_UnityEngine_ParticleSystem_TriggerModule_SetEnabledv, __ZN5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEED0Ev, __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN21WorldParticleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx6shdfnd8SyncImplC2Ev: __ZN5physx6shdfnd8SyncImplC2Ev, __ZN5physx22PxConstraintVisualizerD2Ev: __ZN5physx22PxConstraintVisualizerD2Ev, __Z28Collider2D_CUSTOM_IsTouchingP12Il2CppObjectS0_: __Z28Collider2D_CUSTOM_IsTouchingP12Il2CppObjectS0_, __Z30Mesh_CUSTOM_RecalculateNormalsP12Il2CppObject: __Z30Mesh_CUSTOM_RecalculateNormalsP12Il2CppObject, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED2Ev: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorED2Ev, __ZN16PackedQuatVector11UnpackQuatsEP11Quaternionf: __ZN16PackedQuatVector11UnpackQuatsEP11Quaternionf, __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReport7onEventEjPj: __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReport7onEventEjPj, _UNITY_FT_Stroker_ConicTo: _UNITY_FT_Stroker_ConicTo, __ZN12_GLOBAL__N_117ConnectionManager8setColorEPKvRKN5physx8debugger8PvdColorE: __ZN12_GLOBAL__N_117ConnectionManager8setColorEPKvRKN5physx8debugger8PvdColorE, __ZN12_GLOBAL__N_110Connection15checkConnectionEv: __ZN12_GLOBAL__N_110Connection15checkConnectionEv, __ZN5physx24PxsComputeAABBLocalSpaceERKNS_17PxcAABBDataStaticERNS_9PxBounds3E: __ZN5physx24PxsComputeAABBLocalSpaceERKNS_17PxcAABBDataStaticERNS_9PxBounds3E, __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_SetDestinationv: __Z65Register_UnityEngine_AI_NavMeshAgent_INTERNAL_CALL_SetDestinationv, __ZN15ResourceManager8TransferI17RemapPPtrTransferEEvRT_: __ZN15ResourceManager8TransferI17RemapPPtrTransferEEvRT_, __Z22GetShaderCachePathGLESv: __Z22GetShaderCachePathGLESv, __Z60Register_UnityEngine_WheelCollider_get_forceAppPointDistancev: __Z60Register_UnityEngine_WheelCollider_get_forceAppPointDistancev, __ZN14ParticleSystem24UpdateModulesIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjfPj: __ZN14ParticleSystem24UpdateModulesIncrementalERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjfPj, __ZN12_GLOBAL__N_116CollectionSorterD0Ev: __ZN12_GLOBAL__N_116CollectionSorterD0Ev, __Z16CullPointShadowsR9IndexListPK9SceneNodePK4AABBR16PointCullContext: __Z16CullPointShadowsR9IndexListPK9SceneNodePK4AABBR16PointCullContext, __ZN13BaseAllocatorC2EPKc: __ZN13BaseAllocatorC2EPKc, __Z48Register_UnityEngine_AudioReverbZone_get_densityv: __Z48Register_UnityEngine_AudioReverbZone_get_densityv, __Z62Register_UnityEngine_Screen_get_autorotateToPortraitUpsideDownv: __Z62Register_UnityEngine_Screen_get_autorotateToPortraitUpsideDownv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8overflowEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE8overflowEj, __Z51Register_UnityEngine_ReflectionProbe_set_resolutionv: __Z51Register_UnityEngine_ReflectionProbe_set_resolutionv, __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Object23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx13GuMeshFactory17removeHeightFieldERNS_13PxHeightFieldE: __ZN5physx13GuMeshFactory17removeHeightFieldERNS_13PxHeightFieldE, __ZN15TerrainRenderer24ReclaimPatchVertexBufferEP15SharedGfxBuffer: __ZN15TerrainRenderer24ReclaimPatchVertexBufferEP15SharedGfxBuffer, __Z33getPxCloth_MotionConstraintConfigPKN5physx7PxClothE: __Z33getPxCloth_MotionConstraintConfigPKN5physx7PxClothE, __Z35Rigidbody2D_Set_Custom_PropRotationP12Il2CppObjectf: __Z35Rigidbody2D_Set_Custom_PropRotationP12Il2CppObjectf, __ZN17GeneralConnection14NetworkMessage17InitializeMessageEv: __ZN17GeneralConnection14NetworkMessage17InitializeMessageEv, __ZN12ServerSocket14StartListeningEtb: __ZN12ServerSocket14StartListeningEtb, __ZN14RenderSettings32CleanupGeneratedSkyboxReflectionEPKc: __ZN14RenderSettings32CleanupGeneratedSkyboxReflectionEPKc, __ZN19MeshParticleEmitterC2E10MemLabelId18ObjectCreationMode: __ZN19MeshParticleEmitterC2E10MemLabelId18ObjectCreationMode, __ZN14ParticleSystem22AllocateParticleArraysEv: __ZN14ParticleSystem22AllocateParticleArraysEv, __ZN11UnityEngine9Analytics15AnalyticsConfig12EventsConfig11ResetValuesEv: __ZN11UnityEngine9Analytics15AnalyticsConfig12EventsConfig11ResetValuesEv, __ZNK15EditorExtension26GetTypeInfoVirtualInternalEv: __ZNK15EditorExtension26GetTypeInfoVirtualInternalEv, __ZN5Unity5Cloth6CreateEv: __ZN5Unity5Cloth6CreateEv, __Z7ToLowerI8UnityStrET_RKS1_: __Z7ToLowerI8UnityStrET_RKS1_, __Z37Collider2D_CUSTOM_INTERNAL_get_offsetP12Il2CppObjectP13Vector2fIcall: __Z37Collider2D_CUSTOM_INTERNAL_get_offsetP12Il2CppObjectP13Vector2fIcall, __ZNSt3__227__insertion_sort_incompleteIRPFbRK8Vector2fS3_EPS1_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRK8Vector2fS3_EPS1_EEbT0_S8_T_, _PxCloseVehicleSDK: _PxCloseVehicleSDK, __ZN14DLHAudioHelperD2Ev: __ZN14DLHAudioHelperD2Ev, __ZN24OcclusionCullingSettings15InitializeClassEv: __ZN24OcclusionCullingSettings15InitializeClassEv, __ZN12AudioManager23OnEnterPlayModePreStartEv: __ZN12AudioManager23OnEnterPlayModePreStartEv, __ZNK6Skybox26GetTypeInfoVirtualInternalEv: __ZNK6Skybox26GetTypeInfoVirtualInternalEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj279ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj279ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx8debugger4comm20PvdConnectionManager6createERNS_19PxAllocatorCallbackES4_b: __ZN5physx8debugger4comm20PvdConnectionManager6createERNS_19PxAllocatorCallbackES4_b, __Z49Register_UnityEngine_Input_INTERNAL_CALL_GetTouchv: __Z49Register_UnityEngine_Input_INTERNAL_CALL_GetTouchv, ___getopt_long: ___getopt_long, __Z35ReflectionProbe_Get_Custom_PropModeP12Il2CppObject: __Z35ReflectionProbe_Get_Custom_PropModeP12Il2CppObject, __ZN21AssetReferenceStorage22GarbageCollectCallbackER27GarbageCollectorThreadState: __ZN21AssetReferenceStorage22GarbageCollectCallbackER27GarbageCollectorThreadState, __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZN5Umbra12PortalCullerC2EPNS_12QueryContextEPNS_11TransformerEfPKNS_23ImpObjectDistanceParamsEii: __ZN5Umbra12PortalCullerC2EPNS_12QueryContextEPNS_11TransformerEfPKNS_23ImpObjectDistanceParamsEii, _jpeg_gen_optimal_table: _jpeg_gen_optimal_table, __ZN5physx2Sc15ClothFabricCore16scaleRestlengthsEf: __ZN5physx2Sc15ClothFabricCore16scaleRestlengthsEf, __Z46Register_UnityEngine_Terrain_get_lightmapIndexv: __Z46Register_UnityEngine_Terrain_get_lightmapIndexv, __Z32CustomEventData_CUSTOM_AddUInt64P12Il2CppObjectP12Il2CppStringy: __Z32CustomEventData_CUSTOM_AddUInt64P12Il2CppObjectP12Il2CppStringy, __Z40UnityAdsSettings_Get_Custom_PropTestModev: __Z40UnityAdsSettings_Get_Custom_PropTestModev, __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRS7_: __ZN5physx7profile15EventSerializerINS0_12MemoryBufferINS0_21WrapperNamedAllocatorEEEE9streamifyEPKcRS7_, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveRK23ParticleSystemParticlesPf, __Z47Register_UnityEngine_RenderTexture_GetTemporaryv: __Z47Register_UnityEngine_RenderTexture_GetTemporaryv, __Z71Register_UnityEngine_ParticleSystem_TrailModule_GetInheritParticleColorv: __Z71Register_UnityEngine_ParticleSystem_TrailModule_GetInheritParticleColorv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _cexp: _cexp, __ZN4FMOD6System6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD6System6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev: __ZThn120_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED1Ev, __Z25setPxParticleBase_DampingPN5physx14PxParticleBaseEf: __Z25setPxParticleBase_DampingPN5physx14PxParticleBaseEf, __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI8RendererE8TransferI14SafeBinaryReadEEvRT_, __Z26GetUnityPurchasingSettingsv: __Z26GetUnityPurchasingSettingsv, __ZN5physx5cloth6FabricD2Ev: __ZN5physx5cloth6FabricD2Ev, __ZN23ReflectionProbesContext8CopyFromERKS_: __ZN23ReflectionProbesContext8CopyFromERKS_, __Z18SkinGenericMathLibILi4ELb1ELb1EEvR12SkinMeshInfo: __Z18SkinGenericMathLibILi4ELb1ELb1EEvR12SkinMeshInfo, __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev: __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED2Ev, __Z48Transform_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f: __Z48Transform_CUSTOM_INTERNAL_get_localToWorldMatrixP12Il2CppObjectP10Matrix4x4f, __ZNK5physx7NpScene21getBroadPhaseCallbackEh: __ZNK5physx7NpScene21getBroadPhaseCallbackEh, __ZN11OffMeshLink20UpdateMovedPositionsEv: __ZN11OffMeshLink20UpdateMovedPositionsEv, __Z30setPxVehicleWheelDataMMaxSteerPN5physx18PxVehicleWheelDataEf: __Z30setPxVehicleWheelDataMMaxSteerPN5physx18PxVehicleWheelDataEf, __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_: __ZN10Effector2D8TransferI14SafeBinaryReadEEvRT_, __Z20setPxJoint_LocalPosePN5physx7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformE: __Z20setPxJoint_LocalPosePN5physx7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformE, __Z40SpriteRenderer_CUSTOM_SetSprite_INTERNALP12Il2CppObjectS0_: __Z40SpriteRenderer_CUSTOM_SetSprite_INTERNALP12Il2CppObjectS0_, __ZN5physx7NpCloth20addCollisionTriangleERKNS_24PxClothCollisionTriangleE: __ZN5physx7NpCloth20addCollisionTriangleERKNS_24PxClothCollisionTriangleE, __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetPaddingv: __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetPaddingv, _UNITY_tt_face_get_device_metrics: _UNITY_tt_face_get_device_metrics, __ZN5physx8debugger4comm11SetPickableD0Ev: __ZN5physx8debugger4comm11SetPickableD0Ev, __ZNK8Renderer10HasEnabledEv: __ZNK8Renderer10HasEnabledEv, __Z13RegisterClassI10TagManagerEvv: __Z13RegisterClassI10TagManagerEvv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj278ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxTriangleMeshGeometryEE15complexPropertyINS_22PxRepXPropertyAccessorILj278ES2_NS_11PxMeshScaleES6_EEKNS_24PxMeshScaleGeneratedInfoEEEvPjRKT_RT0_, __ZZN13TrailRenderer15InitializeClassEvEN31FunctorImpl_27kTransformChanged4CallEPviR11MessageData: __ZZN13TrailRenderer15InitializeClassEvEN31FunctorImpl_27kTransformChanged4CallEPviR11MessageData, __ZNK12HandlerChain12GetAssetGUIDERK13FileEntryData: __ZNK12HandlerChain12GetAssetGUIDERK13FileEntryData, __Z20GUIStyle_CUSTOM_InitP12Il2CppObject: __Z20GUIStyle_CUSTOM_InitP12Il2CppObject, __Z36AssetBundle_CUSTOM_LoadFromFileAsyncP12Il2CppStringjy: __Z36AssetBundle_CUSTOM_LoadFromFileAsyncP12Il2CppStringjy, __ZNSt3__26locale5__imp7installINS_8numpunctIcEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8numpunctIcEEEEvPT_, __ZN17SurfaceEffector2D17SetSpeedVariationEf: __ZN17SurfaceEffector2D17SetSpeedVariationEf, __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv, __ZN22BaseUnityConnectClient9InitStateEv: __ZN22BaseUnityConnectClient9InitStateEv, __ZN5physx20InternalTriangleMeshD2Ev: __ZN5physx20InternalTriangleMeshD2Ev, __ZN5physx5cloth8SwSolver17EndSimulationTaskD0Ev: __ZN5physx5cloth8SwSolver17EndSimulationTaskD0Ev, __Z28dtFreeObstacleAvoidanceQueryP24dtObstacleAvoidanceQuery: __Z28dtFreeObstacleAvoidanceQueryP24dtObstacleAvoidanceQuery, __Z46Register_UnityEngine_Rigidbody_get_angularDragv: __Z46Register_UnityEngine_Rigidbody_get_angularDragv, __ZN22LocalFileSystemHandler19InitializeFileEntryER13FileEntryData: __ZN22LocalFileSystemHandler19InitializeFileEntryER13FileEntryData, __Z15RegisterMonoRPCPFvPKcE: __Z15RegisterMonoRPCPFvPKcE, __Z38Time_Get_Custom_PropRenderedFrameCountv: __Z38Time_Get_Custom_PropRenderedFrameCountv, __ZNSt3__221recursive_timed_mutex6unlockEv: __ZNSt3__221recursive_timed_mutex6unlockEv, __ZN15ArchiveReadFileD2Ev: __ZN15ArchiveReadFileD2Ev, __ZN20TextRenderingPrivate8FontImpl21AddCharacterToTextureEjifj: __ZN20TextRenderingPrivate8FontImpl21AddCharacterToTextureEjifj, __ZN5physx19PxsFluidSpatialHashD2Ev: __ZN5physx19PxsFluidSpatialHashD2Ev, __Z44Register_UnityEngine_Mesh_RecalculateNormalsv: __Z44Register_UnityEngine_Mesh_RecalculateNormalsv, __ZN15b2FrictionJoint23InitVelocityConstraintsERK12b2SolverData: __ZN15b2FrictionJoint23InitVelocityConstraintsERK12b2SolverData, __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEEC2EjjS9_: __ZNSt3__214__split_bufferINS_4pairIPNS_18condition_variableEPNS_5mutexEEERNS_18__hidden_allocatorIS6_EEEC2EjjS9_, __Z46Register_UnityEngine_Texture_Internal_GetWidthv: __Z46Register_UnityEngine_Texture_Internal_GetWidthv, __ZN4FMOD6System13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE: __ZN4FMOD6System13getDriverCapsEiPjPiP16FMOD_SPEAKERMODE, __Z17IsNodeVisibleSlowRK9SceneNodeRK4AABBRK22SceneCullingParameters: __Z17IsNodeVisibleSlowRK9SceneNodeRK4AABBRK22SceneCullingParameters, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setSelfCollisionStiffnessEf, __ZN18AudioLowPassFilter5ResetEv: __ZN18AudioLowPassFilter5ResetEv, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE7reserveEj: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE7reserveEj, __ZN16LightmapSettings28SetDynamicGILightmapTexturesEPK22RealtimeLightmapIDDataj: __ZN16LightmapSettings28SetDynamicGILightmapTexturesEPK22RealtimeLightmapIDDataj, __ZZN2UI23InitializeCanvasManagerEvEN42EarlyUpdateUpdateCanvasRectTransformstruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN42EarlyUpdateUpdateCanvasRectTransformstruct7ForwardEv, __Z45Register_UnityEngine_GUIStyle_SetFontInternalv: __Z45Register_UnityEngine_GUIStyle_SetFontInternalv, __Z51Register_UnityEngine_Resources_FindObjectsOfTypeAllv: __Z51Register_UnityEngine_Resources_FindObjectsOfTypeAllv, _UNITY_LZ4_decompress_safe_forceExtDict: _UNITY_LZ4_decompress_safe_forceExtDict, __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_16PxParticleSystemEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx8debugger8renderer16RenderSerializerD2Ev: __ZN5physx8debugger8renderer16RenderSerializerD2Ev, __ZN16GUIKeyboardState16LoadIntoGUIStateER8GUIState: __ZN16GUIKeyboardState16LoadIntoGUIStateER8GUIState, __ZN7ApiGLES14BindReadBufferEj: __ZN7ApiGLES14BindReadBufferEj, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, ___fpending: ___fpending, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN20SpeedTreeWindManager20UnregisterGlobalWindER13SpeedTreeWind: __ZN20SpeedTreeWindManager20UnregisterGlobalWindER13SpeedTreeWind, __ZN5physx15PxSerialization26createCollectionFromBinaryEPvRNS_23PxSerializationRegistryEPKNS_12PxCollectionE: __ZN5physx15PxSerialization26createCollectionFromBinaryEPvRNS_23PxSerializationRegistryEPKNS_12PxCollectionE, _UNITY_png_get_user_height_max: _UNITY_png_get_user_height_max, __Z56Register_UnityEngine_ParticleSystemRenderer_set_sortModev: __Z56Register_UnityEngine_ParticleSystemRenderer_set_sortModev, __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18BuoyancyEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5Umbra13MatrixFactory5orthoEffffff: __ZN5Umbra13MatrixFactory5orthoEffffff, __ZN7mecanim5human10GetAxeInfoEj: __ZN7mecanim5human10GetAxeInfoEj, __Z48Register_UnityEngine_Rigidbody2D_get_constraintsv: __Z48Register_UnityEngine_Rigidbody2D_get_constraintsv, __ZN4FMOD6System17get3DNumListenersEPi: __ZN4FMOD6System17get3DNumListenersEPi, __ZN5audio5mixer12GetLiveValueERNS0_16AudioMixerMemoryEi: __ZN5audio5mixer12GetLiveValueERNS0_16AudioMixerMemoryEi, __ZN15dtPathQueryInfo5purgeEv: __ZN15dtPathQueryInfo5purgeEv, __ZN8Animator17MainThreadCleanupEv: __ZN8Animator17MainThreadCleanupEv, __ZN11b2WeldJoint23InitVelocityConstraintsERK12b2SolverData: __ZN11b2WeldJoint23InitVelocityConstraintsERK12b2SolverData, __ZN20ArchiveStorageReader28TryReadDirectoryInfoFromFileEP5IFile: __ZN20ArchiveStorageReader28TryReadDirectoryInfoFromFileEP5IFile, __ZNK26AnimatorOverrideController30GetAnimationClipOverrideVectorEv: __ZNK26AnimatorOverrideController30GetAnimationClipOverrideVectorEv, __ZN5physx6shdfnd9SListImpl5flushEv: __ZN5physx6shdfnd9SListImpl5flushEv, __Z40TargetJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall: __Z40TargetJoint2D_CUSTOM_INTERNAL_set_anchorP12Il2CppObjectRK13Vector2fIcall, __Z48Register_UnityEngine_Material_GetVectorArrayImplv: __Z48Register_UnityEngine_Material_GetVectorArrayImplv, __ZN5physx3Scb9Aggregate17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb9Aggregate17getBinaryMetaDataERNS_14PxOutputStreamE, __Z44Register_UnityEngine_Cubemap_get_mipmapCountv: __Z44Register_UnityEngine_Cubemap_get_mipmapCountv, __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE11getTypeNameEv, __ZN15b2ContactSolver24SolvePositionConstraintsEv: __ZN15b2ContactSolver24SolvePositionConstraintsEv, __ZN18CrashReportHandler17HandleLogCallbackEPS_RKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_ib: __ZN18CrashReportHandler17HandleLogCallbackEPS_RKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEES9_ib, __ZN10GameObject21WillDestroyGameObjectEv: __ZN10GameObject21WillDestroyGameObjectEv, __ZN5Unity9Component23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity9Component23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z13RegisterClassI21LightProbeProxyVolumeEvv: __Z13RegisterClassI21LightProbeProxyVolumeEvv, __ZN17BufferManagerGLES5ClearEv: __ZN17BufferManagerGLES5ClearEv, __Z9FTReallocP13FT_MemoryRec_llPv: __Z9FTReallocP13FT_MemoryRec_llPv, __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb: __Z30IsUsingLightProbesForRenderingRK18SharedRendererDatabb, __ZThn4_N16RayRTreeCallbackILi0ELb1EE14processResultsEjPj: __ZThn4_N16RayRTreeCallbackILi0ELb1EE14processResultsEjPj, __ZN14EdgeCollider2D9SetPointsEPK8Vector2fj: __ZN14EdgeCollider2D9SetPointsEPK8Vector2fj, ___crypt_sha512: ___crypt_sha512, __ZN12FixedJoint2D15SetDampingRatioEf: __ZN12FixedJoint2D15SetDampingRatioEf, __ZN11BoxCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11BoxCollider8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd13ReadWriteLock10lockReaderEv: __ZN5physx6shdfnd13ReadWriteLock10lockReaderEv, __ZN19AssetBundleManifest23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN19AssetBundleManifest23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE9__get_dayERiRS4_S4_RjRKNS_5ctypeIcEE, __Z27scripting_class_is_inflatedP11Il2CppClass: __Z27scripting_class_is_inflatedP11Il2CppClass, __Z51Register_UnityEngine_Texture_INTERNAL_get_texelSizev: __Z51Register_UnityEngine_Texture_INTERNAL_get_texelSizev, __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z55ParticleSystem_SizeBySpeedModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData: __ZN10GameObject14SendMessageAnyERK17MessageIdentifierR11MessageData, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj142ENS_22PxRepXPropertyAccessorILj142ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj142ENS_22PxRepXPropertyAccessorILj142ES4_ffEEEEvRKT0_, __ZNK6Camera13GetCameraRectEb: __ZNK6Camera13GetCameraRectEb, __ZN6Motion13AddObjectUserER8UserList: __ZN6Motion13AddObjectUserER8UserList, _decode_mcu_DC_first: _decode_mcu_DC_first, __ZNK15b2RevoluteJoint16GetReactionForceEf: __ZNK15b2RevoluteJoint16GetReactionForceEf, _cff_index_get_pointers: _cff_index_get_pointers, __ZThn4_NK5physx5cloth8SwFabric13getNumIndicesEv: __ZThn4_NK5physx5cloth8SwFabric13getNumIndicesEv, __ZN14ParticleSystem18SetStartRotation3DERK8Vector3f: __ZN14ParticleSystem18SetStartRotation3DERK8Vector3f, __ZN28EnlightenRendererInformation8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN28EnlightenRendererInformation8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7mecanim12statemachine21SelectorStateConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine21SelectorStateConstant8TransferI14SafeBinaryReadEEvRT_, __Z35Motion_Get_Custom_PropIsHumanMotionP12Il2CppObject: __Z35Motion_Get_Custom_PropIsHumanMotionP12Il2CppObject, __ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE: __ZNK9Heightmap9BuildDescERN5physx17PxHeightFieldDescE, __Z28getPxMaterial_ReferenceCountPKN5physx10PxMaterialE: __Z28getPxMaterial_ReferenceCountPKN5physx10PxMaterialE, __Z27MonoBehaviour_CUSTOM_InvokeP12Il2CppObjectP12Il2CppStringf: __Z27MonoBehaviour_CUSTOM_InvokeP12Il2CppObjectP12Il2CppStringf, __ZL28DrawBillboardsWith3DRotationILb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL28DrawBillboardsWith3DRotationILb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZNKSt3__214__codecvt_utf8IwE16do_always_noconvEv: __ZNKSt3__214__codecvt_utf8IwE16do_always_noconvEv, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplC2ERN5physx19PxAllocatorCallbackE: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImplC2ERN5physx19PxAllocatorCallbackE, __Z34AlignedCylinderOverlapsOrientedBoxPfPKfS1_fff: __Z34AlignedCylinderOverlapsOrientedBoxPfPKfS1_fff, __Z63Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMouseDeltav: __Z63Register_UnityEngine_Event_INTERNAL_CALL_Internal_SetMouseDeltav, __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI18ComputeShaderParamNS_9allocatorIS1_EEE8__appendEj, __Z46TerrainData_Set_Custom_PropWavingGrassStrengthP12Il2CppObjectf: __Z46TerrainData_Set_Custom_PropWavingGrassStrengthP12Il2CppObjectf, __Z52AnimatorControllerPlayable_CUSTOM_ResetTriggerStringR9HPlayableP12Il2CppString: __Z52AnimatorControllerPlayable_CUSTOM_ResetTriggerStringR9HPlayableP12Il2CppString, __Z56ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve: __Z56ParticleSystem_EmissionModule_CUSTOM_GetRateOverDistanceP12Il2CppObjectR15MonoMinMaxCurve, _UNITY_png_set_background_fixed: _UNITY_png_set_background_fixed, __ZNKSt3__218__time_get_storageIcE15__do_date_orderEv: __ZNKSt3__218__time_get_storageIcE15__do_date_orderEv, __ZN15NavMeshObstacle17RemoveFromManagerEv: __ZN15NavMeshObstacle17RemoveFromManagerEv, __ZN13SparseTexture19UnloadFromGfxDeviceEb: __ZN13SparseTexture19UnloadFromGfxDeviceEb, _UNITY_LZ4_create: _UNITY_LZ4_create, __ZN5physx2Gu24PCMMeshContactGeneration23addManifoldPointToPatchERKNS_6shdfnd3aos5Vec3VERKNS3_6FloatVEj: __ZN5physx2Gu24PCMMeshContactGeneration23addManifoldPointToPatchERKNS_6shdfnd3aos5Vec3VERKNS3_6FloatVEj, __ZN5physx2Sc9StaticSim21postActor2WorldChangeEv: __ZN5physx2Sc9StaticSim21postActor2WorldChangeEv, __ZN14AnimationState20UpdateAnimationStateEdRN5Unity9ComponentE: __ZN14AnimationState20UpdateAnimationStateEdRN5Unity9ComponentE, __ZN5Flare5ResetEv: __ZN5Flare5ResetEv, __Z42Register_UnityEngine_Shader_get_maximumLODv: __Z42Register_UnityEngine_Shader_get_maximumLODv, __Z25getPxTolerancesScaleSpeedPKN5physx17PxTolerancesScaleE: __Z25getPxTolerancesScaleSpeedPKN5physx17PxTolerancesScaleE, __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_: __ZNK5physx16MatrixNNLUSolver5solveERKNS_7VectorNERS1_, __ZN10DebugStats9SerializeER13dynamic_arrayIiLj4EE: __ZN10DebugStats9SerializeER13dynamic_arrayIiLj4EE, __ZN5physx19TriangleMeshBuilder12loadFromDescERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb: __ZN5physx19TriangleMeshBuilder12loadFromDescERKNS_18PxTriangleMeshDescERKNS_15PxCookingParamsEb, __ZN12NavMeshAgent11SetPositionERK8Vector3f: __ZN12NavMeshAgent11SetPositionERK8Vector3f, __Z41Register_UnityEngine_TextMesh_get_offsetZv: __Z41Register_UnityEngine_TextMesh_get_offsetZv, __ZN9dtNavMesh31connectOffMeshConnectionsToTileEP10dtMeshTile: __ZN9dtNavMesh31connectOffMeshConnectionsToTileEP10dtMeshTile, __ZN5Umbra5FloatdVEf: __ZN5Umbra5FloatdVEf, __ZN7Joint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN7Joint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z62Register_UnityEngine_QualitySettings_get_particleRaycastBudgetv: __Z62Register_UnityEngine_QualitySettings_get_particleRaycastBudgetv, __ZNK5Umbra15ShadowCullerExt21getReceiverMaskBufferERNS_18ReceiverMaskBufferE: __ZNK5Umbra15ShadowCullerExt21getReceiverMaskBufferERNS_18ReceiverMaskBufferE, __ZN26AnimatorControllerPlayable12SetPlayStateE9PlayState: __ZN26AnimatorControllerPlayable12SetPlayStateE9PlayState, __ZN21ExecutionOrderManager49SortBehaviourByExecutionOrderAndReverseInstanceIDEii: __ZN21ExecutionOrderManager49SortBehaviourByExecutionOrderAndReverseInstanceIDEii, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayINSt3__24pairIi12ImmediatePtrIN5Unity9ComponentEEEELj4EEEEvRT_17TransferMetaFlags, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getNumVirtualParticleWeightsEv, __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext: __Z16StoreRenderStateR20CameraRenderOldStateRK17ShaderPassContext, __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth17UnalignedIteratorIS1_Lj3EEEEEvPNS3_12TriangleDataERKT0_j: __ZN12_GLOBAL__N_117generateTrianglesI8Scalar4fN5physx5cloth17UnalignedIteratorIS1_Lj3EEEEEvPNS3_12TriangleDataERKT0_j, __ZN5Unity5Joint12WakeupActorsEPN5physx7PxJointE: __ZN5Unity5Joint12WakeupActorsEPN5physx7PxJointE, __ZN13RenderTexture15DiscardContentsEv: __ZN13RenderTexture15DiscardContentsEv, __ZN9JSONWrite8TransferINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZN2UIL41GenerateRenderableUIInstructionCombineJobEPNS_28PreprocessUIInstructionsDataE: __ZN2UIL41GenerateRenderableUIInstructionCombineJobEPNS_28PreprocessUIInstructionsDataE, __ZN11UnityEngine9Animation43DoesBindingSupportConstantCurveOptimizationERKNS0_14GenericBindingE: __ZN11UnityEngine9Animation43DoesBindingSupportConstantCurveOptimizationERKNS0_14GenericBindingE, __ZN5physx26solveVBlockCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj: __ZN5physx26solveVBlockCoulombFrictionEPNS_13PxsSolverCoreEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS9_jRNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSA_19ReflectionAllocatorISC_EEEESG_PNS_2Cm13SpatialVectorEPNS_25PxcThresholdStreamElementEjRj, __ZNK5physx36PxJointAngularLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j: __ZNK5physx36PxJointAngularLimitPairGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEEEEEjT_j, __ZN9BlobWrite8TransferIN7mecanim9animation12AvatarMemoryEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim9animation12AvatarMemoryEEEvRT_PKc17TransferMetaFlags, __ZN15OcclusionPortal23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15OcclusionPortal23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx11NpAggregate11getNbActorsEv: __ZNK5physx11NpAggregate11getNbActorsEv, __Z52Camera_CUSTOM_INTERNAL_CALL_ResetWorldToCameraMatrixP12Il2CppObject: __Z52Camera_CUSTOM_INTERNAL_CALL_ResetWorldToCameraMatrixP12Il2CppObject, __ZN10dtNodePool5clearEv: __ZN10dtNodePool5clearEv, __ZN15FileSystemEntry11MoveToTrashEv: __ZN15FileSystemEntry11MoveToTrashEv, __ZN5Umbra4Math4acosENS_5FloatE: __ZN5Umbra4Math4acosENS_5FloatE, __ZNK9Transform15GetSiblingIndexEv: __ZNK9Transform15GetSiblingIndexEv, __ZN5physx2Sc8RigidSim10getPxActorEv: __ZN5physx2Sc8RigidSim10getPxActorEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapXP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapXP12Il2CppObjectR15MonoMinMaxCurve, __ZN13SparseTexture23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13SparseTexture23VirtualRedirectTransferER17RemapPPtrTransfer, __Z31CreateScriptableObjectUncheckediP10MonoScriptPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z31CreateScriptableObjectUncheckediP10MonoScriptPNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc: __ZN11UnityEngine9Analytics15UserCustomEvent12CustomParams11IsKeyExistsEPKc, __ZN4Mesh23VirtualRedirectTransferER14SafeBinaryRead: __ZN4Mesh23VirtualRedirectTransferER14SafeBinaryRead, __ZNK20ArchiveStorageReader9EnumerateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP13dynamic_arrayI13FileEntryInfoLj8EE19FileEnumerationFlag: __ZNK20ArchiveStorageReader9EnumerateERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEP13dynamic_arrayI13FileEntryInfoLj8EE19FileEnumerationFlag, __ZN2UI14CanvasRenderer17DirtySyncTypeFlagEt: __ZN2UI14CanvasRenderer17DirtySyncTypeFlagEt, __ZThn4_N12_GLOBAL__N_110DataStreamD1Ev: __ZThn4_N12_GLOBAL__N_110DataStreamD1Ev, __Z48Transform_CUSTOM_INTERNAL_CALL_RotateAroundLocalP12Il2CppObjectRK8Vector3ff: __Z48Transform_CUSTOM_INTERNAL_CALL_RotateAroundLocalP12Il2CppObjectRK8Vector3ff, __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb: __ZN5physx10PxsContext13onShapeChangeERKNS_12PxsShapeCoreERKNS_12PxsRigidCoreEb, _UNITY_png_write_oFFs: _UNITY_png_write_oFFs, __ZN5Umbra20RuntimeTomeGeneratorD2Ev: __ZN5Umbra20RuntimeTomeGeneratorD2Ev, __Z36CommandBuffer_CUSTOM_Blit_IdentifierP12Il2CppObjectR26MonoRenderTargetIdentifierS2_S0_i: __Z36CommandBuffer_CUSTOM_Blit_IdentifierP12Il2CppObjectR26MonoRenderTargetIdentifierS2_S0_i, __ZN5physx3Scb11RigidObject19processShapeRemovesEv: __ZN5physx3Scb11RigidObject19processShapeRemovesEv, __ZN7mecanim12statemachine19GetTransitionSourceE28TransitionInterruptionSourcej: __ZN7mecanim12statemachine19GetTransitionSourceE28TransitionInterruptionSourcej, __ZN13SpeedTreeWind9SetParamsERKNS_7SParamsE: __ZN13SpeedTreeWind9SetParamsERKNS_7SParamsE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_jj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceEjjRKS5_jj, __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_24packetShapesFinalizationEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5Umbra10QueryState15importRemoteObjERNS_10StackAllocEPKvj: __ZN5Umbra10QueryState15importRemoteObjERNS_10StackAllocEPKvj, __ZN10GameObject8SetLayerEi: __ZN10GameObject8SetLayerEi, __ZN15dtProximityGrid4initEi: __ZN15dtProximityGrid4initEi, __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_RaycastRK13Vector2fIcallS1_fiffP12RaycastHit2D: __Z47Physics2D_CUSTOM_INTERNAL_CALL_Internal_RaycastRK13Vector2fIcallS1_fiffP12RaycastHit2D, __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE: __ZN6Camera11SetupRenderER17ShaderPassContextRK21CameraRenderingParamsNS_10RenderFlagE, __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E12maybe_shrinkEv, __ZNSt3__225notify_all_at_thread_exitERNS_18condition_variableENS_11unique_lockINS_5mutexEEE: __ZNSt3__225notify_all_at_thread_exitERNS_18condition_variableENS_11unique_lockINS_5mutexEEE, _jinit_memory_mgr: _jinit_memory_mgr, __Z46Playable_CUSTOM_INTERNAL_CALL_GetInputInternalR9HPlayableiS0_: __Z46Playable_CUSTOM_INTERNAL_CALL_GetInputInternalR9HPlayableiS0_, __ZNK6Shader7GetNameEv: __ZNK6Shader7GetNameEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj542ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj542ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_, __Z21scripting_object_initP12Il2CppObject: __Z21scripting_object_initP12Il2CppObject, __ZN10HumanTrait11RightFinger10IsLeftHandEv: __ZN10HumanTrait11RightFinger10IsLeftHandEv, __ZN5physx9NpFactoryD0Ev: __ZN5physx9NpFactoryD0Ev, __ZN5physx5cloth8SwSolver8addClothEPNS0_5ClothE: __ZN5physx5cloth8SwSolver8addClothEPNS0_5ClothE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS4_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sc20ArticulationJointSimC2ERNS0_21ArticulationJointCoreERNS0_8ActorSimES5_: __ZN5physx2Sc20ArticulationJointSimC2ERNS0_21ArticulationJointCoreERNS0_8ActorSimES5_, __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14CompressedMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12LineRenderer11SetPositionEiRK8Vector3f: __ZN12LineRenderer11SetPositionEiRK8Vector3f, __ZN5physx23PxcPCMContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx23PxcPCMContactSphereMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN8GUIState24Internal_SetManagedEventEPv: __ZN8GUIState24Internal_SetManagedEventEPv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEE14handleAccessorILj151ENS_22PxRepXPropertyAccessorILj151ES4_NS_6PxVec3ES9_EEEEvRKT0_, __ZN11JpegDecoder7CleanupEv: __ZN11JpegDecoder7CleanupEv, __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI19StreamedBinaryWriteILb0EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z44Register_UnityEngine_Cloth_get_selfCollisionv: __Z44Register_UnityEngine_Cloth_get_selfCollisionv, __ZNK8Animator20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo: __ZNK8Animator20GetAnimatorStateInfoEi14StateInfoIndexR17AnimatorStateInfo, __ZNSt3__218get_pointer_safetyEv: __ZNSt3__218get_pointer_safetyEv, __ZN18AnimatorController23VirtualRedirectTransferER14SafeBinaryRead: __ZN18AnimatorController23VirtualRedirectTransferER14SafeBinaryRead, __ZN7mecanim9animation16GetWeightsDirectERKNS0_23BlendDirectDataConstantEPf: __ZN7mecanim9animation16GetWeightsDirectERKNS0_23BlendDirectDataConstantEPf, __ZNK20GpuProgramParameters14GetValueParamsEv: __ZNK20GpuProgramParameters14GetValueParamsEv, __ZN20TextRenderingPrivate15ReadOSFontFilesEv: __ZN20TextRenderingPrivate15ReadOSFontFilesEv, __ZN15AnimationBinder23InsertCurveIDIntoLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEERS8_: __ZN15AnimationBinder23InsertCurveIDIntoLookupER14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS1_EE13stl_allocatorINS3_4pairIKS1_jEEL18MemLabelIdentifier1ELi16EEERS8_, __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitSpringP12Il2CppObjectP20SoftJointLimitSpring: __Z55ConfigurableJoint_CUSTOM_INTERNAL_get_linearLimitSpringP12Il2CppObjectP20SoftJointLimitSpring, __Z30setPxRigidBody_AngularVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E: __Z30setPxRigidBody_AngularVelocityPN5physx11PxRigidBodyERKNS_6PxVec3E, __Z40AnimationState_CUSTOM_AddMixingTransformP12Il2CppObjectS0_h: __Z40AnimationState_CUSTOM_AddMixingTransformP12Il2CppObjectS0_h, __ZN18AnimatorController13AwakeFromLoadE17AwakeFromLoadMode: __ZN18AnimatorController13AwakeFromLoadE17AwakeFromLoadMode, _ft_outline_glyph_prepare: _ft_outline_glyph_prepare, _fetestexcept: _fetestexcept, __Z39RelativeJoint2D_Get_Custom_PropMaxForceP12Il2CppObject: __Z39RelativeJoint2D_Get_Custom_PropMaxForceP12Il2CppObject, __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI10RectOffsetEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN9GfxDevice17CommitVertexDeclsEv: __ZN9GfxDevice17CommitVertexDeclsEv, __Z32CountListsWithValidRendererCountPK16RendererCullData: __Z32CountListsWithValidRendererCountPK16RendererCullData, __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformE: __ZN5physx18NpArticulationLink13setGlobalPoseERKNS_11PxTransformE, __ZN11SoundHandleaSERKS_: __ZN11SoundHandleaSERKS_, __ZN5Umbra8fillByteEPvhj: __ZN5Umbra8fillByteEPvhj, __Z18GetUnityInterfacesv: __Z18GetUnityInterfacesv, __Z37SpringJoint2D_Get_Custom_PropDistanceP12Il2CppObject: __Z37SpringJoint2D_Get_Custom_PropDistanceP12Il2CppObject, __Z29Application_CUSTOM_ForceCrashi: __Z29Application_CUSTOM_ForceCrashi, __ZN5physx2Gu9Container6DeleteEj: __ZN5physx2Gu9Container6DeleteEj, __ZN11TimeManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN11TimeManager23VirtualRedirectTransferER14SafeBinaryRead, __Z29Cubemap_Get_Custom_PropFormatP12Il2CppObject: __Z29Cubemap_Get_Custom_PropFormatP12Il2CppObject, __ZN9GfxDevice13SaveDrawStatsEv: __ZN9GfxDevice13SaveDrawStatsEv, __Z43getPxVehicleSuspensionDataMSpringDamperRatePKN5physx23PxVehicleSuspensionDataE: __Z43getPxVehicleSuspensionDataMSpringDamperRatePKN5physx23PxVehicleSuspensionDataE, __ZN11AudioSource27ForceRolloffCurveEvaluationEv: __ZN11AudioSource27ForceRolloffCurveEvaluationEv, __ZN15OverlapCallbackD0Ev: __ZN15OverlapCallbackD0Ev, __ZN12AudioManager8InitFMODEv: __ZN12AudioManager8InitFMODEv, __ZN5physxL17updateStreamForceEPNS_6PxVec3EPNS_16PxsFluidParticleEPKS2_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE: __ZN5physxL17updateStreamForceEPNS_6PxVec3EPNS_16PxsFluidParticleEPKS2_PKjjRKNS_26PxsFluidDynamicsParametersERKNS_30PxsFluidDynamicsParametersSIMDE, __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7Hash1288TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__220__codecvt_utf8_utf16IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_: __ZNKSt3__220__codecvt_utf8_utf16IDiE5do_inER11__mbstate_tPKcS5_RS5_PDiS7_RS7_, __ZN5physx18RepXSerializerImplINS_9PxD6JointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_9PxD6JointEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_: __ZL9SubdivideR13dynamic_arrayI16HeightMeshBVNodeLj4EEiiiS2_RS_IiLj4EERKS3_, __Z26Transfer_UnityEngineObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI9JSONWriteLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN7ApiGLES15ActivateContextEN2gl13ContextHandleE: __ZN7ApiGLES15ActivateContextEN2gl13ContextHandleE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE12readPropertyIfEEbRT_, __ZN17AnimationPlayable13ClearBindingsEv: __ZN17AnimationPlayable13ClearBindingsEv, __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_GetEnabledv: __Z64Register_UnityEngine_ParticleSystem_SubEmittersModule_GetEnabledv, __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_16PxConstraintInfoENS0_15InlineAllocatorILj384ENS0_13TempAllocatorEEEE15growAndPushBackERKS2_, __ZN4Mesh25CreateCustomFormatChannelE13ShaderChannel19VertexChannelFormati: __ZN4Mesh25CreateCustomFormatChannelE13ShaderChannel19VertexChannelFormati, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj392ENS_22PxRepXPropertyAccessorILj392ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj392ENS_22PxRepXPropertyAccessorILj392ES4_ffEEEEvRKT0_, __ZNK5physx2Sc16ArticulationCore16createDriveCacheEfj: __ZNK5physx2Sc16ArticulationCore16createDriveCacheEfj, __ZN11Rigidbody2D15SetGravityScaleEf: __ZN11Rigidbody2D15SetGravityScaleEf, __ZN9Animation9CrossFadeER14AnimationStatefib: __ZN9Animation9CrossFadeER14AnimationStatefib, __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessImmEEPmEEjT0_S5_S5_T_, _ps_hints_t1reset: _ps_hints_t1reset, __Z44TerrainData_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi: __Z44TerrainData_CUSTOM_INTERNAL_CALL_RemoveTreesP12Il2CppObjectRK13Vector2fIcallfi, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEED0Ev, ___fstatfs: ___fstatfs, __Z60Register_UnityEngine_ComputeShader_Internal_DispatchIndirectv: __Z60Register_UnityEngine_ComputeShader_Internal_DispatchIndirectv, __ZN11PreloadData23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11PreloadData23VirtualRedirectTransferER17RemapPPtrTransfer, __Z13FileNameNoExtRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z13FileNameNoExtRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z46Register_UnityEngine_WheelJoint2D_get_useMotorv: __Z46Register_UnityEngine_WheelJoint2D_get_useMotorv, _cff_parser_init: _cff_parser_init, __ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_: __ZNK5Umbra11Transformer22frustumTestBoundsFullyEPKNS_14ActivePlaneSetENS_12SIMDRegisterES4_, __ZN16MecanimAnimation25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding: __ZN16MecanimAnimation25RegisterIAnimationBindingE11ClassIDTypeiP17IAnimationBinding, __ZN5physx2Sc8ClothSim19removeCollisionMeshEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim19removeCollisionMeshEPKNS0_8ShapeSimE, __Z24RegisterStrippedTypeInfoI8WindZoneEviPKcS2_: __Z24RegisterStrippedTypeInfoI8WindZoneEviPKcS2_, __ZN10Matrix3x3f18SetBasisTransposedERK8Vector3fS2_S2_: __ZN10Matrix3x3f18SetBasisTransposedERK8Vector3fS2_S2_, __ZNK25ThreadsafeLinearAllocator19GetRequestedPtrSizeEPKv: __ZNK25ThreadsafeLinearAllocator19GetRequestedPtrSizeEPKv, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getConstraintEv, __Z20SetupForwardAddLightRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_: __Z20SetupForwardAddLightRK15SharedLightDatafR17ShaderPassContextRK10TextureRefS6_S6_, __Z53ParticleSystemRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject: __Z53ParticleSystemRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject, __ZN30VelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN30VelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZNK5physx20PxsSolverCoreGeneral33solveVCoulombParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESI_RNSD_IjNSF_IjEEEESL_PNS_2Cm13SpatialVectorERiSP_j: __ZNK5physx20PxsSolverCoreGeneral33solveVCoulombParallelAndWriteBackEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPiS9_S9_S9_S9_PNS_25PxcThresholdStreamElementEjS9_RNS_6shdfnd5ArrayINS_24PxsConstraintBatchHeaderENSC_19ReflectionAllocatorISE_EEEESI_RNSD_IjNSF_IjEEEESL_PNS_2Cm13SpatialVectorERiSP_j, _pclose: _pclose, __ZNK5physx16PxsParticleShape10getBoundsVEv: __ZNK5physx16PxsParticleShape10getBoundsVEv, __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewGlobalRefv: __Z58Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewGlobalRefv, __Z36Graphics_CUSTOM_GetActiveColorBufferP21ScriptingRenderBuffer: __Z36Graphics_CUSTOM_GetActiveColorBufferP21ScriptingRenderBuffer, __ZN18ProceduralMaterial21AwakeFromLoadThreadedEv: __ZN18ProceduralMaterial21AwakeFromLoadThreadedEv, __ZN11UnityEngine15CloudWebService13SessionHeader15RestoreFromFileER12FileAccessor: __ZN11UnityEngine15CloudWebService13SessionHeader15RestoreFromFileER12FileAccessor, __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f: __ZN6Camera19SetProjectionMatrixERK10Matrix4x4f, __ZN5physx2Sn13XmlNodeReader19setCurrentItemValueEPKc: __ZN5physx2Sn13XmlNodeReader19setCurrentItemValueEPKc, __ZN5physx14PxsAABBManager19purgeAggregatePairsEj: __ZN5physx14PxsAABBManager19purgeAggregatePairsEj, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E14squash_deletedEv, __Z33Texture_Set_Custom_PropMipMapBiasP12Il2CppObjectf: __Z33Texture_Set_Custom_PropMipMapBiasP12Il2CppObjectf, __ZN6prcoreL13inner_stretchILj3ELj3EEEvPKNS_9InnerInfoE: __ZN6prcoreL13inner_stretchILj3ELj3EEEvPKNS_9InnerInfoE, __Z29AndroidJNI_CUSTOM_SetIntField13Il2Cpp_IntPtrS_i: __Z29AndroidJNI_CUSTOM_SetIntField13Il2Cpp_IntPtrS_i, __Z39Rigidbody2D_Get_Custom_PropGravityScaleP12Il2CppObject: __Z39Rigidbody2D_Get_Custom_PropGravityScaleP12Il2CppObject, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_8debugger19ForwardingAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb, __ZN7ApiGLES19CreateSparseTextureEj16TextureDimensionN2gl9TexFormatEiiiiRiS3_S3_: __ZN7ApiGLES19CreateSparseTextureEj16TextureDimensionN2gl9TexFormatEiiiiRiS3_S3_, __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE: __ZN16Physics2DManager13OverlapBoxAllERK8Vector2fS2_fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE, __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev: __ZN11UnityEngine15CloudWebService16SessionContainerD2Ev, __ZN5physx21PxVehicleDriveSimData12setGearsDataERKNS_18PxVehicleGearsDataE: __ZN5physx21PxVehicleDriveSimData12setGearsDataERKNS_18PxVehicleGearsDataE, __ZNK13TranslateGLES15FramebufferReadEN2gl15FramebufferReadE: __ZNK13TranslateGLES15FramebufferReadEN2gl15FramebufferReadE, __Z34TerrainData_CUSTOM_GetAdjustedSizeP12Il2CppObjecti: __Z34TerrainData_CUSTOM_GetAdjustedSizeP12Il2CppObjecti, __ZN15SerializeTraitsINSt3__24pairIttEEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsINSt3__24pairIttEEE8TransferI14SafeBinaryReadEEvRS2_RT_, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE13stl_allocatorIS6_L18MemLabelIdentifier77ELi16EEE21__push_back_slow_pathIKS6_EEvRT_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE13stl_allocatorIS6_L18MemLabelIdentifier77ELi16EEE21__push_back_slow_pathIKS6_EEvRT_, __ZN6Camera17RemoveFromManagerEv: __ZN6Camera17RemoveFromManagerEv, __ZN5physx2Cm29ConstraintImmediateVisualizer18visualizeLimitConeERKNS_11PxTransformEffb: __ZN5physx2Cm29ConstraintImmediateVisualizer18visualizeLimitConeERKNS_11PxTransformEffb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ES2_RKNS_20PxVehicleAutoBoxDataES6_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_21PxVehicleDriveSimDataEE15complexPropertyINS_22PxRepXPropertyAccessorILj666ES2_RKNS_20PxVehicleAutoBoxDataES6_EEKNS_33PxVehicleAutoBoxDataGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx19TriangleMeshBuilder18computeLocalBoundsEv: __ZN5physx19TriangleMeshBuilder18computeLocalBoundsEv, __ZNKSt3__210moneypunctIcLb1EE16do_positive_signEv: __ZNKSt3__210moneypunctIcLb1EE16do_positive_signEv, __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorINS_4pairIijEENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9pbackfailEj, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_zDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_get_zDrivev, __ZN10HumanTrait13GetColliderIdER6Avatari: __ZN10HumanTrait13GetColliderIdER6Avatari, _ignore_err: _ignore_err, _fill_window: _fill_window, __ZN24ControllerFilterCallbackD0Ev: __ZN24ControllerFilterCallbackD0Ev, __ZZ23InitPlayerLoopCallbacksvEN33EarlyUpdateUpdatePreloadingstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN33EarlyUpdateUpdatePreloadingstruct7ForwardEv, __ZN5physx15PxVehicleWheels8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx15PxVehicleWheels8requiresERNS_23PxProcessPxBaseCallbackE, __Z58Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexIndicesv: __Z58Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexIndicesv, __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j: __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E9copy_fromERKSJ_j, __ZNKSt3__220__time_get_c_storageIwE3__rEv: __ZNKSt3__220__time_get_c_storageIwE3__rEv, __ZN14StackAllocator8AllocateEji: __ZN14StackAllocator8AllocateEji, _hasmntopt: _hasmntopt, __ZN11UnityEngine9Animation40FindTransformBindingIndexBySkeletonIndexERK13dynamic_arrayINS0_14BoundTransformELj4EEi: __ZN11UnityEngine9Animation40FindTransformBindingIndexBySkeletonIndexERK13dynamic_arrayINS0_14BoundTransformELj4EEi, __ZN16b2CapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN16b2CapsuleContact7DestroyEP9b2ContactP16b2BlockAllocator, __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_get_motorv: __Z52Register_UnityEngine_HingeJoint2D_INTERNAL_get_motorv, __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi: __ZN7mecanim8skeleton14SkeletonGetDoFEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEi, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE17find_first_not_ofEPKcj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj35ENS_22PxRepXPropertyAccessorILj35ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_, __Z35SpriteRenderer_Get_Custom_PropFlipYP12Il2CppObject: __Z35SpriteRenderer_Get_Custom_PropFlipYP12Il2CppObject, __Z54Register_UnityEngine_AI_NavMeshPath_GetCornersNonAllocv: __Z54Register_UnityEngine_AI_NavMeshPath_GetCornersNonAllocv, __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv: __ZNSt3__25dequeI18ReflectionProbeJobNS_9allocatorIS1_EEE19__add_back_capacityEv, __Z42Register_UnityEngine_Caching_get_spaceUsedv: __Z42Register_UnityEngine_Caching_get_spaceUsedv, __Z45Register_UnityEngine_Canvas_set_targetDisplayv: __Z45Register_UnityEngine_Canvas_set_targetDisplayv, __ZNK9TextAsset18GetScriptClassNameEv: __ZNK9TextAsset18GetScriptClassNameEv, _UNITY_FT_GlyphLoader_New: _UNITY_FT_GlyphLoader_New, __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_10StartEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_10StartEventEEEbRT_, __ZNK12WheelJoint2D26GetTypeInfoVirtualInternalEv: __ZNK12WheelJoint2D26GetTypeInfoVirtualInternalEv, __ZN9BlobWrite8TransferIhEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIhEEvRT_PKc17TransferMetaFlags, __Z47Register_UnityEngine_Texture2DArray_GetPixels32v: __Z47Register_UnityEngine_Texture2DArray_GetPixels32v, __ZN14AnimationState12UpdateFadingEf: __ZN14AnimationState12UpdateFadingEf, __ZN18PlatformEffector2D12SetUseOneWayEb: __ZN18PlatformEffector2D12SetUseOneWayEb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj588ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleSuspensionDataEEEEclILj588ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18PxVehicleDriveTankD2Ev: __ZN5physx18PxVehicleDriveTankD2Ev, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EEPS1_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS4_EEPS1_, __ZN26AnimatorControllerPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE: __ZN26AnimatorControllerPlayable19PreProcessAnimationEPK35AnimationPlayableEvaluationConstantPKN7mecanim9animation18AnimationNodeStateE, __Z29getPxRigidBody_CMassLocalPosePKN5physx11PxRigidBodyE: __Z29getPxRigidBody_CMassLocalPosePKN5physx11PxRigidBodyE, __Z38MonoBehaviour_CUSTOM_StopAllCoroutinesP12Il2CppObject: __Z38MonoBehaviour_CUSTOM_StopAllCoroutinesP12Il2CppObject, __Z39Texture2D_CUSTOM_INTERNAL_CALL_CompressP12Il2CppObjecth: __Z39Texture2D_CUSTOM_INTERNAL_CALL_CompressP12Il2CppObjecth, __Z32GL_CUSTOM_INTERNAL_set_modelviewRK10Matrix4x4f: __Z32GL_CUSTOM_INTERNAL_set_modelviewRK10Matrix4x4f, __ZN14DetailDatabase21RemoveLocalLayerIndexEiR11DetailPatch: __ZN14DetailDatabase21RemoveLocalLayerIndexEiR11DetailPatch, _fstatat: _fstatat, __Z29Transfer_Blittable_ArrayFieldI9JSONWritehEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritehEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx2Sc18ParticleSystemCore11setGridSizeEf: __ZN5physx2Sc18ParticleSystemCore11setGridSizeEf, __ZN5physx7NpCloth6wakeUpEv: __ZN5physx7NpCloth6wakeUpEv, __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesXP12Il2CppObject: __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesXP12Il2CppObject, __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationYP12Il2CppObjectR15MonoMinMaxCurve, __ZN7mecanim4hand12HandPoseCopyEPKNS0_8HandPoseEPS1_: __ZN7mecanim4hand12HandPoseCopyEPKNS0_8HandPoseEPS1_, __Z16GetStringFromEnvPKc: __Z16GetStringFromEnvPKc, __Z22FindAndLoadUnityPluginPKcPPv: __Z22FindAndLoadUnityPluginPKcPPv, __Z35Register_UnityEngine_Animation_Playv: __Z35Register_UnityEngine_Animation_Playv, __ZN9GfxDevice19AsyncResourceUploadEii9TextureID: __ZN9GfxDevice19AsyncResourceUploadEii9TextureID, __Z21GetAssetBundleManagerv: __Z21GetAssetBundleManagerv, __ZN5physx2Sn5ConvX11alignStreamEPKci: __ZN5physx2Sn5ConvX11alignStreamEPKci, __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetDampingv: __Z58Register_UnityEngine_ParticleSystem_NoiseModule_GetDampingv, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN5physx11growPatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjf: __ZN5physx11growPatchesERNS_20PxcCorrelationBufferERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjf, __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig11ResetValuesEv: __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig11ResetValuesEv, __Z43Register_UnityEngine_Canvas_get_worldCamerav: __Z43Register_UnityEngine_Canvas_get_worldCamerav, __ZN5Unity12PhysicsQueryD2Ev: __ZN5Unity12PhysicsQueryD2Ev, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E15insert_noresizeERKSC_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E15insert_noresizeERKSC_, __ZNK8Animator25GetStateMachineBehavioursEv: __ZNK8Animator25GetStateMachineBehavioursEv, __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z36Terrain_Get_Custom_PropLightmapIndexP12Il2CppObject: __Z36Terrain_Get_Custom_PropLightmapIndexP12Il2CppObject, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21setUserCustomProfilerEPNS_20PxUserCustomProfilerE, __Z54Register_UnityEngine_SpriteRenderer_GetSprite_INTERNALv: __Z54Register_UnityEngine_SpriteRenderer_GetSprite_INTERNALv, __ZN15LightProbeUtils32BarycentricCoordinates3DTriangleEPK8Vector3fRS1_: __ZN15LightProbeUtils32BarycentricCoordinates3DTriangleEPK8Vector3fRS1_, __ZN19SkinnedMeshRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN19SkinnedMeshRenderer13AwakeFromLoadE17AwakeFromLoadMode, __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info: __Z33BuildSerializationCommandQueueForI8JSONReadEvRK34BuildSerializationCommandQueueArgsR32SerializationCommandQueueBuilderRP20AllowNameConversionsbPK18TransferField_Info, __ZN10AudioMixer18SetCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE: __ZN10AudioMixer18SetCurrentSnapshotERK4PPtrI18AudioMixerSnapshotE, __ZN7mecanim12statemachine21SelectorStateConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim12statemachine21SelectorStateConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI21ComputeShaderResourceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNSt3__2L10__init_patIwEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_: __ZNSt3__2L10__init_patIwEEvRNS_10money_base7patternERNS_12basic_stringIT_NS_11char_traitsIS5_EENS_9allocatorIS5_EEEEbcccS5_, __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE: __ZN4File4OpenERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS_10PermissionENS_12AutoBehaviorE, __ZN12_GLOBAL__N_123DoubleBufferedOutStream7executeEv: __ZN12_GLOBAL__N_123DoubleBufferedOutStream7executeEv, __Z30RemoteSettings_CUSTOM_GetFloatP12Il2CppStringf: __Z30RemoteSettings_CUSTOM_GetFloatP12Il2CppStringf, __ZN14AnimationState4StopEv: __ZN14AnimationState4StopEv, __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_: __ZNK17AnimationCurveTplI11QuaternionfE20FindIndexForSamplingERKNS1_5CacheEfRiS5_, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __Z55ParticleSystem_TrailModule_CUSTOM_GetLifetimeMultiplierP12Il2CppObject: __Z55ParticleSystem_TrailModule_CUSTOM_GetLifetimeMultiplierP12Il2CppObject, __ZNSt3__26vectorIN20FileSystemEnumerator10MountPointENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN20FileSystemEnumerator10MountPointENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __Z28LayerMask_CUSTOM_NameToLayerP12Il2CppString: __Z28LayerMask_CUSTOM_NameToLayerP12Il2CppString, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10getDampingEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE10getDampingEv, _strtod_l: _strtod_l, __ZN18AudioLowPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN18AudioLowPassFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN12FixedJoint2D5ResetEv: __ZN12FixedJoint2D5ResetEv, _tcgetattr: _tcgetattr, __ZN18SpeedTreeWindAsset7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN18SpeedTreeWindAsset7PRODUCEE10MemLabelId18ObjectCreationMode, __Z48Register_UnityEngine_CanvasRenderer_get_hasMovedv: __Z48Register_UnityEngine_CanvasRenderer_get_hasMovedv, __ZN4FMOD6System14setSpeakerModeE16FMOD_SPEAKERMODE: __ZN4FMOD6System14setSpeakerModeE16FMOD_SPEAKERMODE, __Z40getPxRigidDynamic_ContactReportThresholdPKN5physx14PxRigidDynamicE: __Z40getPxRigidDynamic_ContactReportThresholdPKN5physx14PxRigidDynamicE, __ZN21ProceduralTextureDataC2ERKS_: __ZN21ProceduralTextureDataC2ERKS_, __ZN26AnimatorOverrideController10ClearAssetEv: __ZN26AnimatorOverrideController10ClearAssetEv, __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17ProceduralTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetOuterUVP12Il2CppObjectR8Vector4f: __Z43DataUtility_CUSTOM_INTERNAL_CALL_GetOuterUVP12Il2CppObjectR8Vector4f, __ZN13GfxDeviceGLES14SetScissorRectERK5RectTIiE: __ZN13GfxDeviceGLES14SetScissorRectERK5RectTIiE, __ZN7mecanim9animation16ControllerMemory8TransferI9BlobWriteEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI9BlobWriteEEvRT_, __Z47Input_CUSTOM_INTERNAL_CALL_GetAccelerationEventiR12Acceleration: __Z47Input_CUSTOM_INTERNAL_CALL_GetAccelerationEventiR12Acceleration, __Z53Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxv: __Z53Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxv, __ZN5physx13GuMeshFactory18removeTriangleMeshERNS_14PxTriangleMeshE: __ZN5physx13GuMeshFactory18removeTriangleMeshERNS_14PxTriangleMeshE, _ftrylockfile: _ftrylockfile, __Z46Register_UnityEngine_Joint_INTERNAL_get_anchorv: __Z46Register_UnityEngine_Joint_INTERNAL_get_anchorv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6resizeEj, __ZNK11PreloadData26GetTypeInfoVirtualInternalEv: __ZNK11PreloadData26GetTypeInfoVirtualInternalEv, __ZN10GameObject8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10GameObject8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN14RenderSettings19SetCustomReflectionEP7Cubemap: __ZN14RenderSettings19SetCustomReflectionEP7Cubemap, __ZN5physx6shdfnd6SocketD2Ev: __ZN5physx6shdfnd6SocketD2Ev, __ZN14PhysicsManager10SphereTestERK8Vector3ffi23QueryTriggerInteraction: __ZN14PhysicsManager10SphereTestERK8Vector3ffi23QueryTriggerInteraction, __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE: __ZN5physx21PxcArticulationHelper10setInertiaERNS_12PxcFsInertiaERKNS_11PxsBodyCoreERKNS_11PxTransformE, __ZN19RuntimeSceneManager11UnloadSceneEP10UnityScene: __ZN19RuntimeSceneManager11UnloadSceneEP10UnityScene, __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_788kBecameVisible4CallEPviR11MessageData: __ZZN19SkinnedMeshRenderer15InitializeClassEvEN29FunctorImpl_788kBecameVisible4CallEPviR11MessageData, __ZN14AreaEffector2D17SetForceMagnitudeEf: __ZN14AreaEffector2D17SetForceMagnitudeEf, __ZN13SplatDatabase4InitEii: __ZN13SplatDatabase4InitEii, __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib: __ZNK10__cxxabiv122__base_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib, __ZN9GfxDevice20DeallocRenderSurfaceEP17RenderSurfaceBase: __ZN9GfxDevice20DeallocRenderSurfaceEP17RenderSurfaceBase, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13getNumSpheresEv, __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayINS_9PxBounds3ENS0_15InlineAllocatorILj192ENS0_19ReflectionAllocatorIS2_EEEEE19resizeUninitializedEj, __ZN14ParticleSystem13KillParticlesILb0EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj: __ZN14ParticleSystem13KillParticlesILb0EEEvRjbRK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjPj, __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_: __ZNSt3__216__pad_and_outputIwNS_11char_traitsIwEEEENS_19ostreambuf_iteratorIT_T0_EES6_PKS4_S8_S8_RNS_8ios_baseES4_, __ZN15AudioMixerGroup8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15AudioMixerGroup8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi: __ZN7mecanim5human18Human2SkeletonPoseEPKNS0_5HumanEPKNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEEi, __Z44BillboardAsset_CUSTOM_MakeMaterialPropertiesP12Il2CppObjectS0_S0_: __Z44BillboardAsset_CUSTOM_MakeMaterialPropertiesP12Il2CppObjectS0_S0_, __ZN5physx2Gu26computeSphereTriImpactDataERNS_6PxVec3ES2_RKS1_S4_fRKNS_10PxTriangleE: __ZN5physx2Gu26computeSphereTriImpactDataERNS_6PxVec3ES2_RKS1_S4_fRKNS_10PxTriangleE, _t2_hints_open: _t2_hints_open, __Z56getPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE: __Z56getPxVehicleTireDataMLongitudinalStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE, __ZNSt3__28ios_base4initEPv: __ZNSt3__28ios_base4initEPv, __ZN23iPhoneLocalNotification10PresentNowEv: __ZN23iPhoneLocalNotification10PresentNowEv, __Z62setPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPN5physx19PxVehicleEngineDataEf: __Z62setPxVehicleEngineDataMDampingRateZeroThrottleClutchDisengagedPN5physx19PxVehicleEngineDataEf, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx3Ext31UnregisterExtensionsSerializersERNS_23PxSerializationRegistryE: __ZN5physx3Ext31UnregisterExtensionsSerializersERNS_23PxSerializationRegistryE, __Z10tesvertLeqP10TESSvertexS0_: __Z10tesvertLeqP10TESSvertexS0_, __ZNK5physx13NpVolumeCache5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf: __ZNK5physx13NpVolumeCache5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEf, __ZN14AnimationState15SetWeightTargetEffb: __ZN14AnimationState15SetWeightTargetEffb, __ZThn8_N5physx2Sc19ShapeInstancePairLL7destroyEv: __ZThn8_N5physx2Sc19ShapeInstancePairLL7destroyEv, __ZN13ConstantForce5ResetEv: __ZN13ConstantForce5ResetEv, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN11AudioModule19ResumeVideoTexturesEv: __ZN11AudioModule19ResumeVideoTexturesEv, __ZN30AudioEffectInternalDescriptionC2EP26UnityAudioEffectDefinition: __ZN30AudioEffectInternalDescriptionC2EP26UnityAudioEffectDefinition, __ZNK5physx7NpCloth26getNbSeparationConstraintsEv: __ZNK5physx7NpCloth26getNbSeparationConstraintsEv, __ZN14NavMeshCarvingD2Ev: __ZN14NavMeshCarvingD2Ev, __ZN5physx35PxConvexMeshGeometryGeneratedValuesC2EPKNS_20PxConvexMeshGeometryE: __ZN5physx35PxConvexMeshGeometryGeneratedValuesC2EPKNS_20PxConvexMeshGeometryE, __ZN15ResourceManager23VirtualRedirectTransferER14SafeBinaryRead: __ZN15ResourceManager23VirtualRedirectTransferER14SafeBinaryRead, __Z46Register_UnityEngine_Gizmos_INTERNAL_get_colorv: __Z46Register_UnityEngine_Gizmos_INTERNAL_get_colorv, __ZN18PlatformEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN18PlatformEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionZv: __Z62Register_UnityEngine_LightProbeProxyVolume_get_gridResolutionZv, __ZN14LineParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14LineParameters8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZZN13WheelCollider15InitializeClassEvEN33FunctorImpl_1264kTransformChanged4CallEPviR11MessageData: __ZZN13WheelCollider15InitializeClassEvEN33FunctorImpl_1264kTransformChanged4CallEPviR11MessageData, __Z53Register_UnityEngine_Quaternion_INTERNAL_CALL_Inversev: __Z53Register_UnityEngine_Quaternion_INTERNAL_CALL_Inversev, __ZNKSt3__212ctype_bynameIwE5do_isEtw: __ZNKSt3__212ctype_bynameIwE5do_isEtw, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData9PoolData8ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __Z32GUIText_Set_Custom_PropFontStyleP12Il2CppObjecti: __Z32GUIText_Set_Custom_PropFontStyleP12Il2CppObjecti, __GLOBAL__sub_I_SparseTextureGLES_cpp: __GLOBAL__sub_I_SparseTextureGLES_cpp, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4copyEPcjj, __ZN5Umbra10StackAlloc5resetEPvj: __ZN5Umbra10StackAlloc5resetEPvj, __Z57Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointv: __Z57Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapPointv, __ZN5RandN7SetSeedERKi: __ZN5RandN7SetSeedERKi, __Z29StdTemplateConversionFunctionIifEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIifEbPvR14SafeBinaryRead, __Z20SetAlphaToRedChanneliiPhi13TextureFormat: __Z20SetAlphaToRedChanneliiPhi13TextureFormat, __Z25GUIStyleState_CUSTOM_InitP12Il2CppObject: __Z25GUIStyleState_CUSTOM_InitP12Il2CppObject, __Z20CollectProfilerStatsR16AllProfilerStats: __Z20CollectProfilerStatsR16AllProfilerStats, __ZN14SafeBinaryReadC2Ev: __ZN14SafeBinaryReadC2Ev, __ZN5physx21PxcArticulationHelper22setupSolverConstraintsERNS_9PxcFsDataEjRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPKNS_19PxsArticulationLinkEPKNS_30PxcArticulationJointTransformsEfRjRNS_25PxsConstraintBlockManagerE: __ZN5physx21PxcArticulationHelper22setupSolverConstraintsERNS_9PxcFsDataEjRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPKNS_19PxsArticulationLinkEPKNS_30PxcArticulationJointTransformsEfRjRNS_25PxsConstraintBlockManagerE, __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEi17AwakeFromLoadMode: __ZN18AwakeFromLoadQueue30PersistentManagerAwakeFromLoadEi17AwakeFromLoadMode, __ZN5Umbra15GateStateVectorC2Ev: __ZN5Umbra15GateStateVectorC2Ev, __Z54Register_UnityEngine_AudioSource_SetScheduledStartTimev: __Z54Register_UnityEngine_AudioSource_SetScheduledStartTimev, __Z38RenderTexture_Set_Custom_PropIsCubemapP12Il2CppObjecth: __Z38RenderTexture_Set_Custom_PropIsCubemapP12Il2CppObjecth, __ZN12AdsIdHandlerD2Ev: __ZN12AdsIdHandlerD2Ev, __ZN5physx20BigConvexDataBuilderD2Ev: __ZN5physx20BigConvexDataBuilderD2Ev, __ZNK18ScreenManagerWebGL20GetCurrentResolutionEv: __ZNK18ScreenManagerWebGL20GetCurrentResolutionEv, __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpClothEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNK5physx10NpMaterial8getFlagsEv: __ZNK5physx10NpMaterial8getFlagsEv, __ZN24RingBufferMemoryFileData12SetBlockSizeEj: __ZN24RingBufferMemoryFileData12SetBlockSizeEj, __ZN8Animator15SetBodyPositionERK8Vector3f: __ZN8Animator15SetBodyPositionERK8Vector3f, __ZN4FMOD6SoundI10getNumTagsEPiS1_: __ZN4FMOD6SoundI10getNumTagsEPiS1_, __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE: __ZN5Umbra5Query13setGateStatesEPKNS_15GateStateVectorE, __ZN4mathL11quatToEulerERKNS_7_float4ENS_13RotationOrderE: __ZN4mathL11quatToEulerERKNS_7_float4ENS_13RotationOrderE, __Z32AndroidJNI_CUSTOM_SetObjectField13Il2Cpp_IntPtrS_S_: __Z32AndroidJNI_CUSTOM_SetObjectField13Il2Cpp_IntPtrS_S_, __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject: __ZN9Scripting34SetScriptingArrayObjectElementImplEP11Il2CppArrayiP12Il2CppObject, __ZN5Unity12PhysicsQuery18OverlapBoxInternalERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_12PxOverlapHitEEE: __ZN5Unity12PhysicsQuery18OverlapBoxInternalERK8Vector3fS3_RK11Quaternionfi23QueryTriggerInteractionRN5physx13PxHitCallbackINS8_12PxOverlapHitEEE, __ZN5Umbra4Math3absENS_5FloatE: __ZN5Umbra4Math3absENS_5FloatE, __ZN5physx12enable3WModeEjjbRNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE: __ZN5physx12enable3WModeEjjbRNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE, __Z24RegisterStrippedTypeInfoI19MeshParticleEmitterEviPKcS2_: __Z24RegisterStrippedTypeInfoI19MeshParticleEmitterEviPKcS2_, __Z69Register_UnityEngine_QualitySettings_INTERNAL_set_shadowCascade4Splitv: __Z69Register_UnityEngine_QualitySettings_INTERNAL_set_shadowCascade4Splitv, __ZN4FMOD6SoundI11getUserDataEPPv: __ZN4FMOD6SoundI11getUserDataEPPv, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE7seekposENS_4fposI11__mbstate_tEEj, __ZN14AnimationEventaSERKS_: __ZN14AnimationEventaSERKS_, __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_: __ZNSt3__27__sort5IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_SE_SE_T_, __Z50Register_UnityEngine_ParticleSystem_set_randomSeedv: __Z50Register_UnityEngine_ParticleSystem_set_randomSeedv, __Z52Register_UnityEngine_AndroidJNI_CallStaticLongMethodv: __Z52Register_UnityEngine_AndroidJNI_CallStaticLongMethodv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7putbackEc: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE7putbackEc, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRm, __ZN23MeshVertexFormatManager10ReleaseAllEv: __ZN23MeshVertexFormatManager10ReleaseAllEv, __ZN12b2MouseJoint4DumpEv: __ZN12b2MouseJoint4DumpEv, _UNITY_FT_Glyph_Stroke: _UNITY_FT_Glyph_Stroke, __Z24LoadImageIntoTextureImplI10PngDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE: __Z24LoadImageIntoTextureImplI10PngDecoderEbR9Texture2DPKhjb13TextureFormatR13dynamic_arrayIhLj1EE, __ZNK4Mesh10GetIndicesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj: __ZNK4Mesh10GetIndicesERNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEEj, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx12NpConstraint18getSceneFromActorsEv: __ZNK5physx12NpConstraint18getSceneFromActorsEv, __ZN10TagManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10TagManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx2Sc5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb: __ZN5physx2Sc5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb, __ZNK9Rigidbody21GetMaxAngularVelocityEv: __ZNK9Rigidbody21GetMaxAngularVelocityEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation17BlendTreeConstantEEEEEvRT_17TransferMetaFlags, __ZN2UI14CanvasRenderer15SetAlphaTextureEP7Texture: __ZN2UI14CanvasRenderer15SetAlphaTextureEP7Texture, __ZN13GfxDeviceGLES24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj: __ZN13GfxDeviceGLES24DrawNullGeometryIndirectE16GfxPrimitiveType15ComputeBufferIDj, __ZN6Camera14AddImageFilterERK11ImageFilter: __ZN6Camera14AddImageFilterERK11ImageFilter, _jsimd_can_idct_2x2: _jsimd_can_idct_2x2, __ZN2UI13CanvasManager23RemoveAllDirtyRenderersEPNS_6CanvasE: __ZN2UI13CanvasManager23RemoveAllDirtyRenderersEPNS_6CanvasE, __ZN18AudioLowPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN18AudioLowPassFilter23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN10Effector2D17RemoveFromManagerEv: __ZN10Effector2D17RemoveFromManagerEv, __ZN8Material7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8Material7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN8Material23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8Material23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL17PngWriteFlushFuncP14png_struct_def: __ZL17PngWriteFlushFuncP14png_struct_def, __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12ImmediatePtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZNK8VRDevice20GetCullingParametersEPK6CameraR10Matrix4x4fS4_Rf: __ZNK8VRDevice20GetCullingParametersEPK6CameraR10Matrix4x4fS4_Rf, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE19getConcreteTypeNameEv, __ZN4FMOD6SoundI13setMusicSpeedEf: __ZN4FMOD6SoundI13setMusicSpeedEf, __ZN20TextRenderingPrivate8TextMesh12SetAlignmentEs: __ZN20TextRenderingPrivate8TextMesh12SetAlignmentEs, __Z65Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayImplListv: __Z65Register_UnityEngine_MaterialPropertyBlock_GetVectorArrayImplListv, __ZN9Scripting26DestroyObjectFromScriptingE4PPtrI6ObjectEf: __ZN9Scripting26DestroyObjectFromScriptingE4PPtrI6ObjectEf, __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab16SerializedTagMap8TransferI14SafeBinaryReadEEvRT_, __Z64Register_UnityEngine_SystemInfo_get_supportsCubemapArrayTexturesv: __Z64Register_UnityEngine_SystemInfo_get_supportsCubemapArrayTexturesv, __Z24RegisterAllInternalCallsv: __Z24RegisterAllInternalCallsv, __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBAHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBAHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN13RenderTexture10GrabPixelsEiiii: __ZN13RenderTexture10GrabPixelsEiiii, __ZN17FileSystemHandler6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __ZN17FileSystemHandler6ParentERK13FileEntryDataRNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN20SoundChannelInstance20get3DConeOrientationEP11FMOD_VECTOR: __ZN20SoundChannelInstance20get3DConeOrientationEP11FMOD_VECTOR, __ZN13MemoryManager18GetCustomAllocatorERK10MemLabelId: __ZN13MemoryManager18GetCustomAllocatorERK10MemLabelId, __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI9JSONWrite27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN8Animator23GetLeftFeetBottomHeightEv: __ZN8Animator23GetLeftFeetBottomHeightEv, __ZThn4_N5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E: __ZThn4_N5physx5cloth8SwSolver23setInterCollisionFilterEPFbPvS2_E, __ZNK6Camera26GetStereoSingleCullEnabledEv: __ZNK6Camera26GetStereoSingleCullEnabledEv, __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj: __Z12SetFileFlagsRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEjj, __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode1EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E, __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxBaseTaskENS0_15InlineAllocatorILj40ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN23ShaderVariantCollection7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN23ShaderVariantCollection7PRODUCEE10MemLabelId18ObjectCreationMode, _llabs: _llabs, __ZN11AudioSource8SetPitchEf: __ZN11AudioSource8SetPitchEf, __ZN26AnimatorControllerPlayable13RebuildMemoryEv: __ZN26AnimatorControllerPlayable13RebuildMemoryEv, __ZN13RenderTexture23GetNativeDepthBufferPtrEv: __ZN13RenderTexture23GetNativeDepthBufferPtrEv, __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent: __ZNK8GUIStyle12GetGeneratorERK5RectTIfER10GUIContent, __ZN9HaloLayer12AddToManagerEv: __ZN9HaloLayer12AddToManagerEv, __ZN15ComputeShaderCB8TransferI14SafeBinaryReadEEvRT_: __ZN15ComputeShaderCB8TransferI14SafeBinaryReadEEvRT_, __ZN2UI13CanvasManager12RemoveCanvasEPNS_6CanvasE: __ZN2UI13CanvasManager12RemoveCanvasEPNS_6CanvasE, __Z51Register_UnityEngine_CharacterController_get_radiusv: __Z51Register_UnityEngine_CharacterController_get_radiusv, __ZN19TouchPhaseEmulation15IsExistingTouchEi: __ZN19TouchPhaseEmulation15IsExistingTouchEi, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7setNameEPKc: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7setNameEPKc, __Z28GetAbsoluteAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z28GetAbsoluteAssetBundlePrefixRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN4FMOD8ChannelI9getVolumeEPf: __ZN4FMOD8ChannelI9getVolumeEPf, __ZN5physx6shdfnd10ThreadImpl19getDefaultStackSizeEv: __ZN5physx6shdfnd10ThreadImpl19getDefaultStackSizeEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj14ENS_22PxRepXPropertyAccessorILj14ENS_7PxActorEPKcSB_EEEEvRKT0_, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17CUDAProfileBufferEfPKhjj, __Z45Physics2D_Get_Custom_PropChangeStopsCallbacksv: __Z45Physics2D_Get_Custom_PropChangeStopsCallbacksv, __ZN5physx2Sc19ShapeInstancePairLLD2Ev: __ZN5physx2Sc19ShapeInstancePairLLD2Ev, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_GetBoxv: __Z68Register_UnityEngine_ParticleSystem_ShapeModule_INTERNAL_CALL_GetBoxv, __Z61Register_UnityEngine_GUISettings_Internal_GetCursorFlashSpeedv: __Z61Register_UnityEngine_GUISettings_Internal_GetCursorFlashSpeedv, __Z53Register_UnityEngine_Rendering_CommandBuffer_get_namev: __Z53Register_UnityEngine_Rendering_CommandBuffer_get_namev, __ZN19SkinnedMeshRenderer27SetSkinnedMeshMotionVectorsEb: __ZN19SkinnedMeshRenderer27SetSkinnedMeshMotionVectorsEb, __ZN5IMGUIL14SortTwoWindowsEPKNS_9GUIWindowES2_: __ZN5IMGUIL14SortTwoWindowsEPKNS_9GUIWindowES2_, __ZN5physx16PxVehicleNoDriveC2Ev: __ZN5physx16PxVehicleNoDriveC2Ev, __Z47Register_UnityEngine_RenderSettings_set_fogModev: __Z47Register_UnityEngine_RenderSettings_set_fogModev, __Z34GetUnityConnectScriptingClassesPtrv: __Z34GetUnityConnectScriptingClassesPtrv, __ZN9BoxPruner13resizeObjectsEv: __ZN9BoxPruner13resizeObjectsEv, __ZNK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZNK5physx5cloth9SwFactory20extractRestPositionsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15NavMeshSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11WindManagerD2Ev: __ZN11WindManagerD2Ev, __ZN14PlayerSettings8TransferI17RemapPPtrTransferEEvRT_: __ZN14PlayerSettings8TransferI17RemapPPtrTransferEEvRT_, __ZL22ConvertImageToRGBM_JobP17ImageSliceJobDataj: __ZL22ConvertImageToRGBM_JobP17ImageSliceJobDataj, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext7D6JointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE16dispatchAccessorILj435ENS0_26PxPvdRangePropertyAccessorILj435ES4_NS_6PxVec3EEEEEvjRKT0_bbb: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEE16dispatchAccessorILj435ENS0_26PxPvdRangePropertyAccessorILj435ES4_NS_6PxVec3EEEEEvjRKT0_bbb, __Z41Register_UnityEngine_Input_get_touchCountv: __Z41Register_UnityEngine_Input_get_touchCountv, __ZN12_GLOBAL__N_115constrainMotionI8Scalar4fPKS1_EEvPT_PKS4_RKT0_S4_: __ZN12_GLOBAL__N_115constrainMotionI8Scalar4fPKS1_EEvPT_PKS4_RKT0_S4_, __ZN13Simd4iFactoryIRKiEC2ES1_: __ZN13Simd4iFactoryIRKiEC2ES1_, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetYMultiplierP12Il2CppObjectf, __Z47Register_UnityEngine_GUIStyle_Internal_CalcSizev: __Z47Register_UnityEngine_GUIStyle_Internal_CalcSizev, __ZN5physx19getYTorqueCurvePairEPKNS_19PxVehicleEngineDataEj: __ZN5physx19getYTorqueCurvePairEPKNS_19PxVehicleEngineDataEj, __ZN5physx9NpFactory17createClothFabricERKNS_17PxClothFabricDescE: __ZN5physx9NpFactory17createClothFabricERKNS_17PxClothFabricDescE, __ZN14AreaEffector2D17SetForceVariationEf: __ZN14AreaEffector2D17SetForceVariationEf, __Z56Register_UnityEngine_Terrain_set_treeMaximumFullLODCountv: __Z56Register_UnityEngine_Terrain_set_treeMaximumFullLODCountv, __ZN19CharacterControllerD0Ev: __ZN19CharacterControllerD0Ev, __ZN13MonoBehaviour15GetUseGUILayoutEv: __ZN13MonoBehaviour15GetUseGUILayoutEv, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_getES4_S4_RNS_8ios_baseERjRd, __ZN12InputManager9GetButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager9GetButtonERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z44AudioReverbFilter_Set_Custom_PropReverbDelayP12Il2CppObjectf: __Z44AudioReverbFilter_Set_Custom_PropReverbDelayP12Il2CppObjectf, __Z51Register_UnityEngine_AudioClip_get_loadInBackgroundv: __Z51Register_UnityEngine_AudioClip_get_loadInBackgroundv, __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f: __ZN6Camera19SetStereoViewMatrixE15StereoscopicEyeRK10Matrix4x4f, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc15CoreInteractionES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __Z36getPxParticleSystem_ConcreteTypeNamePKN5physx16PxParticleSystemE: __Z36getPxParticleSystem_ConcreteTypeNamePKN5physx16PxParticleSystemE, __ZN13UnityProfiler20AddPerThreadProfilerEP22UnityProfilerPerThread: __ZN13UnityProfiler20AddPerThreadProfilerEP22UnityProfilerPerThread, __Z52ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveP12Il2CppObjectR15MonoMinMaxCurve: __Z52ParticleSystem_InheritVelocityModule_CUSTOM_SetCurveP12Il2CppObjectR15MonoMinMaxCurve, __ZN9BoxPruner9setBoundsEtRK5IAABB: __ZN9BoxPruner9setBoundsEtRK5IAABB, __ZN7Terrain28CopySplatMaterialCustomPropsEPK19ShaderPropertySheet: __ZN7Terrain28CopySplatMaterialCustomPropsEPK19ShaderPropertySheet, __Z13RegisterClassI24PhysicsUpdateBehaviour2DEvv: __Z13RegisterClassI24PhysicsUpdateBehaviour2DEvv, __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE: __ZN5physx22PxVehicleWheelsSimData12setWheelDataEjRKNS_18PxVehicleWheelDataE, __ZN5physx13NpRigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx13NpRigidStatic17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth9IndexPairENS0_9AllocatorEE8recreateEj, __ZN12MeshCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12MeshCollider8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE5eraseERS6_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKvNS_8debugger18NonNegativeIntegerEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S8_SB_NS7_19ForwardingAllocatorEE6GetKeyESD_Lb1EE5eraseERS6_, __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE16StaticInitializeES5_: __ZN13RuntimeStaticINSt3__23mapINS0_4pairIPcS3_EEPFbPvR14SafeBinaryReadE20smaller_tstring_pairIPKcENS0_9allocatorINS2_IKS4_S9_EEEEEEE16StaticInitializeES5_, __ZN17ProceduralTexture21AwakeFromLoadThreadedEv: __ZN17ProceduralTexture21AwakeFromLoadThreadedEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN17ProceduralTexture13AwakeFromLoadE17AwakeFromLoadMode: __ZN17ProceduralTexture13AwakeFromLoadE17AwakeFromLoadMode, __Z30TransferField_LinearCollectionI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5Umbra4Tome12getGateCountEv: __ZNK5Umbra4Tome12getGateCountEv, __Z42Terrain_CUSTOM_INTERNAL_get_legacySpecularP12Il2CppObjectP10ColorRGBAf: __Z42Terrain_CUSTOM_INTERNAL_get_legacySpecularP12Il2CppObjectP10ColorRGBAf, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_13NpRigidStaticEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z21SpriteRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi: __Z21SpriteRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi, __Z28GUIStyle_Get_Custom_PropNameP12Il2CppObject: __Z28GUIStyle_Get_Custom_PropNameP12Il2CppObject, _shm_open: _shm_open, __ZN17ProfilerFrameDataD2Ev: __ZN17ProfilerFrameDataD2Ev, __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i: __ZN21TreeBinaryTreeBuilder5BuildER12TreeDatabaseRK8Vector3fS4_i, __Z35getPxHeightFieldGeometryHeightFieldPKN5physx21PxHeightFieldGeometryE: __Z35getPxHeightFieldGeometryHeightFieldPKN5physx21PxHeightFieldGeometryE, __ZN17PersistentManager21ProduceObjectInternalER14SerializedFile26SerializedObjectIdentifierii: __ZN17PersistentManager21ProduceObjectInternalER14SerializedFile26SerializedObjectIdentifierii, __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17PackedFloatVector8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z47Rigidbody_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP8Vector3f: __Z47Rigidbody_CUSTOM_INTERNAL_get_worldCenterOfMassP12Il2CppObjectP8Vector3f, __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj: __ZNSt3__28time_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2EPKcj, __Z52Register_UnityEngine_AI_OffMeshLink_get_navMeshLayerv: __Z52Register_UnityEngine_AI_OffMeshLink_get_navMeshLayerv, __Z31Playables_CUSTOM_CastToInternalP12Il2CppObject13Il2Cpp_IntPtri: __Z31Playables_CUSTOM_CastToInternalP12Il2CppObject13Il2Cpp_IntPtri, __ZN16TimerQueriesGLES18PollNextTimerQueryEb: __ZN16TimerQueriesGLES18PollNextTimerQueryEb, __ZN5physx3Ext13DistanceJoint10setDampingEf: __ZN5physx3Ext13DistanceJoint10setDampingEf, __ZNSt3__215__time_get_tempIcEC2EPKc: __ZNSt3__215__time_get_tempIcEC2EPKc, __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationZMultiplierP12Il2CppObject: __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationZMultiplierP12Il2CppObject, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_25GenericInsituStringStreamIS2_EEEEjRT_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseHex4INS_25GenericInsituStringStreamIS2_EEEEjRT_, __Z19UnityObjectToStringP6Object: __Z19UnityObjectToStringP6Object, __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8UnityStr13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEEEEvRT_j, __Z46Register_UnityEngine_Physics2D_set_timeToSleepv: __Z46Register_UnityEngine_Physics2D_set_timeToSleepv, __Z51Register_UnityEngine_Material_GetColorArrayImplListv: __Z51Register_UnityEngine_Material_GetColorArrayImplListv, __ZN13SplatDatabase21AwakeFromLoadThreadedEv: __ZN13SplatDatabase21AwakeFromLoadThreadedEv, __ZN24MaterialDisplayListCache16CachedShaderPass15ResetMRUIndicesEv: __ZN24MaterialDisplayListCache16CachedShaderPass15ResetMRUIndicesEv, __Z30Animator_Set_Custom_PropAvatarP12Il2CppObjectS0_: __Z30Animator_Set_Custom_PropAvatarP12Il2CppObjectS0_, __Z62Register_UnityEngine_Experimental_Director_DirectorPlayer_Stopv: __Z62Register_UnityEngine_Experimental_Director_DirectorPlayer_Stopv, __ZN15CollisionModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState: __ZN15CollisionModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState, __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS5_13ccdBroadPhaseEPNS_10PxBaseTaskEEEEENS0_19ReflectionAllocatorIS8_EEE8recreateEj, __ZN18SharedMaterialDataC2ERKS_: __ZN18SharedMaterialDataC2ERKS_, __Z59Register_UnityEngine_Texture2D_LoadRawTextureData_ImplArrayv: __Z59Register_UnityEngine_Texture2D_LoadRawTextureData_ImplArrayv, __Z46CharacterJoint_Set_Custom_PropEnableProjectionP12Il2CppObjecth: __Z46CharacterJoint_Set_Custom_PropEnableProjectionP12Il2CppObjecth, __ZN4FMOD8ChannelI11getPriorityEPi: __ZN4FMOD8ChannelI11getPriorityEPi, __ZNSt3__210moneypunctIcLb1EEC2Ej: __ZNSt3__210moneypunctIcLb1EEC2Ej, __ZN11AudioSource12CleanupClassEv: __ZN11AudioSource12CleanupClassEv, __ZN5Umbra5Query9deinitSpuEv: __ZN5Umbra5Query9deinitSpuEv, __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __Z43setPxVehicleSuspensionDataMCamberAtMaxDroopPN5physx23PxVehicleSuspensionDataEf: __Z43setPxVehicleSuspensionDataMCamberAtMaxDroopPN5physx23PxVehicleSuspensionDataEf, __Z32TextMesh_Get_Custom_PropFontSizeP12Il2CppObject: __Z32TextMesh_Get_Custom_PropFontSizeP12Il2CppObject, __ZN5physx2Sc8ClothSim24updateRigidBodyPositionsEv: __ZN5physx2Sc8ClothSim24updateRigidBodyPositionsEv, __ZN15DistanceJoint2D24SetAutoConfigureDistanceEb: __ZN15DistanceJoint2D24SetAutoConfigureDistanceEb, __ZN5physx2Sc18TriggerInteraction12onDeactivateEj: __ZN5physx2Sc18TriggerInteraction12onDeactivateEj, __ZN5physx2Gu5Debug9visualizeERKNS_16PxSphereGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_16PxSphereGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __ZNK18AnimatorController41GetStateMachineBehaviourVectorDescriptionEv: __ZNK18AnimatorController41GetStateMachineBehaviourVectorDescriptionEv, __Z47Register_UnityEngine_Projector_get_ignoreLayersv: __Z47Register_UnityEngine_Projector_get_ignoreLayersv, __ZN14AreaEffector2DD0Ev: __ZN14AreaEffector2DD0Ev, __ZN5physx2Gu13RTreeMidphase15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Gu13RTreeMidphase15exportExtraDataERNS_22PxSerializationContextE, __ZN11UnityEngine15CloudWebService16SessionContaineraSERKS1_: __ZN11UnityEngine15CloudWebService16SessionContaineraSERKS1_, __ZZN8Collider15InitializeClassEvEN37FunctorImpl_778kForceRecreateCollider4CallEPviR11MessageData: __ZZN8Collider15InitializeClassEvEN37FunctorImpl_778kForceRecreateCollider4CallEPviR11MessageData, __ZN7mecanim9animation25DestroyBlendTreeWorkspaceEPNS0_18BlendTreeWorkspaceERNS_6memory9AllocatorE: __ZN7mecanim9animation25DestroyBlendTreeWorkspaceEPNS0_18BlendTreeWorkspaceERNS_6memory9AllocatorE, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__XEv, __ZN5Umbra10unmapArrayEPNS_10StackAllocEPKv: __ZN5Umbra10unmapArrayEPNS_10StackAllocEPKv, __ZN13MemoryManager17LowLevelCAllocateEjj: __ZN13MemoryManager17LowLevelCAllocateEjj, __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI13AnimationClipE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx7NpShape14getBoxGeometryERNS_13PxBoxGeometryE: __ZNK5physx7NpShape14getBoxGeometryERNS_13PxBoxGeometryE, __Z31setPxSceneDescMeshContactMarginPN5physx11PxSceneDescEf: __Z31setPxSceneDescMeshContactMarginPN5physx11PxSceneDescEf, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZN12WheelJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12WheelJoint2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z38QualitySettings_Set_Custom_PropLodBiasf: __Z38QualitySettings_Set_Custom_PropLodBiasf, __ZN13ScreenManager20RequestSetFullscreenEb: __ZN13ScreenManager20RequestSetFullscreenEb, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9sputbackcEc: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE9sputbackcEc, __Z48Register_UnityEngine_AnimationClip_set_frameRatev: __Z48Register_UnityEngine_AnimationClip_set_frameRatev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab14SerializedPass8PassTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN9ShaderLab14SerializedPass8PassTypeEEvRT_RT0_PKc17TransferMetaFlags, __ZN5physx3Ext13RevoluteJoint12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx3Ext13RevoluteJoint12createObjectERPhRNS_24PxDeserializationContextE, __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZv: __Z64Register_UnityEngine_ParticleSystem_MainModule_GetStartRotationZv, __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN5physx7NpScene11shiftOriginERKNS_6PxVec3E: __ZN5physx7NpScene11shiftOriginERKNS_6PxVec3E, __ZN5physx2Sc24ElementInteractionMarker10onActivateEj: __ZN5physx2Sc24ElementInteractionMarker10onActivateEj, __ZN4FMOD12ChannelGroup10getChannelEiPPNS_7ChannelE: __ZN4FMOD12ChannelGroup10getChannelEiPPNS_7ChannelE, __ZN7Texture13ApplySettingsEv: __ZN7Texture13ApplySettingsEv, __ZNKSt3__212bad_weak_ptr4whatEv: __ZNKSt3__212bad_weak_ptr4whatEv, __ZNK12NavMeshAgent11GetPositionEv: __ZNK12NavMeshAgent11GetPositionEv, __Z18SetProjectionPlanePN5physx14PxParticleBaseENS_15PxMetaDataPlaneE: __Z18SetProjectionPlanePN5physx14PxParticleBaseENS_15PxMetaDataPlaneE, __ZN12LightsModuleD2Ev: __ZN12LightsModuleD2Ev, __ZN22MemoryCacherReadBlocksC2EPPhij: __ZN22MemoryCacherReadBlocksC2EPPhij, __ZN13MonoBehaviour10LateUpdateEv: __ZN13MonoBehaviour10LateUpdateEv, __ZN15FileSystemEntry8IsLockedEv: __ZN15FileSystemEntry8IsLockedEv, __ZN13RenderTexture9GetActiveEi: __ZN13RenderTexture9GetActiveEi, __ZN9Animation14IsPlayingLayerEi: __ZN9Animation14IsPlayingLayerEi, __ZN5physx7NpScene15addArticulationERNS_14PxArticulationE: __ZN5physx7NpScene15addArticulationERNS_14PxArticulationE, __ZL18triangleConvexTestRKN5physx2Gu13PolygonalDataEhjPKNS_6PxVec3ERKNS_7PxPlaneERS5_RKNS_2Cm8Matrix34ESE_SE_SE_RKNSB_23FastVertex2ShapeScalingEfRS4_RfRbb: __ZL18triangleConvexTestRKN5physx2Gu13PolygonalDataEhjPKNS_6PxVec3ERKNS_7PxPlaneERS5_RKNS_2Cm8Matrix34ESE_SE_SE_RKNSB_23FastVertex2ShapeScalingEfRS4_RfRbb, __Z54Register_UnityEngine_AudioReverbFilter_get_reverbDelayv: __Z54Register_UnityEngine_AudioReverbFilter_get_reverbDelayv, __Z44Physics2D_Set_Custom_PropMaxLinearCorrectionf: __Z44Physics2D_Set_Custom_PropMaxLinearCorrectionf, __ZNK5physx7NpScene21getDominanceGroupPairEhh: __ZNK5physx7NpScene21getDominanceGroupPairEhh, _jsimd_can_h2v1_downsample: _jsimd_can_h2v1_downsample, __ZN13RenderTexture10GrabPixelsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii: __ZN13RenderTexture10GrabPixelsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii, __ZNK13b2PulleyJoint16GetGroundAnchorAEv: __ZNK13b2PulleyJoint16GetGroundAnchorAEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE17setSleepThresholdEf, __Z48Register_UnityEngine_Rigidbody_get_sleepVelocityv: __Z48Register_UnityEngine_Rigidbody_get_sleepVelocityv, __Z29StdTemplateConversionFunctionIyxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyxEbPvR14SafeBinaryRead, __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetPositionv: __Z92Register_UnityEngine_Experimental_Director_AnimationOffsetPlayable_INTERNAL_CALL_GetPositionv, __Z34Texture2D_CUSTOM_GetRawTextureDataP12Il2CppObject: __Z34Texture2D_CUSTOM_GetRawTextureDataP12Il2CppObject, __ZN15CapsuleCollider6CreateEPK9Rigidbody: __ZN15CapsuleCollider6CreateEPK9Rigidbody, _wmemcmp: _wmemcmp, _UnityReplayKitStartRecording: _UnityReplayKitStartRecording, __Z27Graphics_CUSTOM_DrawTextureR32MonoInternalDrawTextureArguments: __Z27Graphics_CUSTOM_DrawTextureR32MonoInternalDrawTextureArguments, __ZNK5physx3Cct17CapsuleController8getStateERNS_17PxControllerStateE: __ZNK5physx3Cct17CapsuleController8getStateERNS_17PxControllerStateE, __ZN15TerrainRenderer24GetPatchMeshVertexFormatEv: __ZN15TerrainRenderer24GetPatchMeshVertexFormatEv, __Z44ParticleSystem_TriggerModule_CUSTOM_GetEnterP12Il2CppObject: __Z44ParticleSystem_TriggerModule_CUSTOM_GetEnterP12Il2CppObject, __ZN14EmissionModule16CheckConsistencyEv: __ZN14EmissionModule16CheckConsistencyEv, __Z30getPxCloth_AngularInertiaScalePKN5physx7PxClothE: __Z30getPxCloth_AngularInertiaScalePKN5physx7PxClothE, __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE13finalizeQueryEv: __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE13finalizeQueryEv, __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j: __ZNK5physx27PxVehicleDriveGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j, __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR31RayHitsByInverseDepthComparitorP12RaycastHit2DEEjT0_S5_S5_S5_T_, __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEEEEjT_j: __ZNK5physx32PxArticulationJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEEEEjT_j, __Z15GetScriptMapperv: __Z15GetScriptMapperv, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetCollidesWithv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetCollidesWithv, __Z46Register_UnityEngine_Tree_get_hasSpeedTreeWindv: __Z46Register_UnityEngine_Tree_get_hasSpeedTreeWindv, __ZN5Umbra13MatrixFactory9frustumLHEffffff: __ZN5Umbra13MatrixFactory9frustumLHEffffff, __Z34AnimationState_Get_Custom_PropTimeP12Il2CppObject: __Z34AnimationState_Get_Custom_PropTimeP12Il2CppObject, __ZN5physx2Gu8EdgeListC2Ev: __ZN5physx2Gu8EdgeListC2Ev, __ZN26AnimatorOverrideController7SetClipE4PPtrI13AnimationClipES2_b: __ZN26AnimatorOverrideController7SetClipE4PPtrI13AnimationClipES2_b, __Z56Register_UnityEngine_Animator_get_linearVelocityBlendingv: __Z56Register_UnityEngine_Animator_get_linearVelocityBlendingv, __Z18getPxD6Joint_DrivePKN5physx9PxD6JointENS_9PxD6Drive4EnumE: __Z18getPxD6Joint_DrivePKN5physx9PxD6JointENS_9PxD6Drive4EnumE, __ZNK5physx7NpCloth13getClothFlagsEv: __ZNK5physx7NpCloth13getClothFlagsEv, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED0Ev: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEED0Ev, _UNITY_tt_face_get_metrics: _UNITY_tt_face_get_metrics, __ZN4File19OpenFileSystemEntryERK15FileSystemEntryNS_10PermissionENS_12AutoBehaviorE: __ZN4File19OpenFileSystemEntryERK15FileSystemEntryNS_10PermissionENS_12AutoBehaviorE, __ZNSt3__211timed_mutex6unlockEv: __ZNSt3__211timed_mutex6unlockEv, __ZN14RenderSettings14SetAmbientModeENS_11AmbientModeE: __ZN14RenderSettings14SetAmbientModeENS_11AmbientModeE, _tt_glyph_load: _tt_glyph_load, __ZThn8_N5physx2Sc24ElementInteractionMarker12onDeactivateEj: __ZThn8_N5physx2Sc24ElementInteractionMarker12onDeactivateEj, __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev: __ZN5physx27PxD6JointDriveGeneratedInfoC2Ev, __ZN9WWWCached14BlockUntilDoneEv: __ZN9WWWCached14BlockUntilDoneEv, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE7reserveEj, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveEOS3_: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEE4moveEOS3_, __ZN5physx28PxParticleFluidGeneratedInfoC2Ev: __ZN5physx28PxParticleFluidGeneratedInfoC2Ev, __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15CapsuleCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4backEv, __Z41Register_UnityEngine_Light_get_cookieSizev: __Z41Register_UnityEngine_Light_get_cookieSizev, __Z49Register_UnityEngine_TerrainData_get_detailHeightv: __Z49Register_UnityEngine_TerrainData_get_detailHeightv, __ZN5physx6shdfnd5ArrayINS_2Cm8Matrix34ENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Cm8Matrix34ENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z53ParticleSystem_CollisionModule_CUSTOM_GetMaxKillSpeedP12Il2CppObject: __Z53ParticleSystem_CollisionModule_CUSTOM_GetMaxKillSpeedP12Il2CppObject, _dprintf: _dprintf, __Z41setPxVehicleDifferential4WDataMCentreBiasPN5physx27PxVehicleDifferential4WDataEf: __Z41setPxVehicleDifferential4WDataMCentreBiasPN5physx27PxVehicleDifferential4WDataEf, __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff: __Z15WriteLineVertexRP10LineVertexRKN4math8float4x4ERKNS2_7_float3ERK11ColorRGBA32RKff, __ZN17PersistentManager14ReloadFromDiskER6Object: __ZN17PersistentManager14ReloadFromDiskER6Object, __ZN13ComputeShaderD0Ev: __ZN13ComputeShaderD0Ev, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN5physx19NpArticulationJointD2Ev: __ZN5physx19NpArticulationJointD2Ev, __ZNK4Mesh32IsSuitableSizeForDynamicBatchingEv: __ZNK4Mesh32IsSuitableSizeForDynamicBatchingEv, __ZN17ArchiveFileSystem5WriteER13FileEntryDatayyPvPy: __ZN17ArchiveFileSystem5WriteER13FileEntryDatayyPvPy, __ZN12TreeRenderer21GenerateBillboardMeshER4MeshRK13dynamic_arrayIjLj4EEb: __ZN12TreeRenderer21GenerateBillboardMeshER4MeshRK13dynamic_arrayIjLj4EEb, __Z44Register_UnityEngine_AnimationState_get_timev: __Z44Register_UnityEngine_AnimationState_get_timev, __ZNKSt3__210moneypunctIcLb1EE10pos_formatEv: __ZNKSt3__210moneypunctIcLb1EE10pos_formatEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15DownloadHandler23OnUnbindScriptingObjectEv: __ZN15DownloadHandler23OnUnbindScriptingObjectEv, __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferI10JointDriveEEvRT_PKc17TransferMetaFlags, __ZN13GfxDeviceGLES29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE: __ZN13GfxDeviceGLES29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE, _UNITY_FT_Face_GetCharVariantIsDefault: _UNITY_FT_Face_GetCharVariantIsDefault, _tre_make_trans: _tre_make_trans, __ZN16b2PrismaticJointD0Ev: __ZN16b2PrismaticJointD0Ev, __ZN10Matrix3x4fC2ERK10Matrix3x3f: __ZN10Matrix3x4fC2ERK10Matrix3x3f, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIN7mecanim5human9HumanGoalELi4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIN7mecanim5human9HumanGoalELi4EEEEvRT_17TransferMetaFlags, __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx15solveExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZN8GUILayerD0Ev: __ZN8GUILayerD0Ev, __ZN12_GLOBAL__N_121SocketNetworkInStreamD2Ev: __ZN12_GLOBAL__N_121SocketNetworkInStreamD2Ev, __ZN20TextRenderingPrivate8FontImpl21AddCharacterInfoEntryERK5RectTIfES4_fibijf: __ZN20TextRenderingPrivate8FontImpl21AddCharacterInfoEntryERK5RectTIfES4_fibijf, __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI10RectOffsetEEvRT_PKc17TransferMetaFlagsb, __ZN5physx2Sc5Scene12createClientEv: __ZN5physx2Sc5Scene12createClientEv, __Z39AudioSource_Get_Custom_PropDopplerLevelP12Il2CppObject: __Z39AudioSource_Get_Custom_PropDopplerLevelP12Il2CppObject, __Z38Register_UnityEngine_Animator_GetStatsv: __Z38Register_UnityEngine_Animator_GetStatsv, __ZN5physx2Sc8BodyCoreC2ENS_11PxActorType4EnumERKNS_11PxTransformE: __ZN5physx2Sc8BodyCoreC2ENS_11PxActorType4EnumERKNS_11PxTransformE, __ZN8LODGroup10DeactivateE19DeactivateOperation: __ZN8LODGroup10DeactivateE19DeactivateOperation, __ZNK5physx3Cct12SweptCapsule18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E: __ZNK5physx3Cct12SweptCapsule18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E, __Z55Register_UnityEngine_ParticleRenderer_get_velocityScalev: __Z55Register_UnityEngine_ParticleRenderer_get_velocityScalev, __ZN5physx28solveExtContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx28solveExtContactConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx23PxsBroadPhaseContextSap11batchUpdateEjRPNS_17PxcBroadPhasePairERjS4_: __ZN5physx23PxsBroadPhaseContextSap11batchUpdateEjRPNS_17PxcBroadPhasePairERjS4_, __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_: __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E15insert_noresizeERKS8_, __Z55Register_UnityEngine_WheelCollider_get_wheelDampingRatev: __Z55Register_UnityEngine_WheelCollider_get_wheelDampingRatev, __Z34Graphics_Set_Custom_PropActiveTier12GraphicsTier: __Z34Graphics_Set_Custom_PropActiveTier12GraphicsTier, __Z36OffMeshLink_Get_Custom_PropActivatedP12Il2CppObject: __Z36OffMeshLink_Get_Custom_PropActivatedP12Il2CppObject, __Z4sqrtRK8Scalar4f: __Z4sqrtRK8Scalar4f, __ZN15DirectorManager20FixedAdvanceTimeFuncEP14AdvanceTimeJobj: __ZN15DirectorManager20FixedAdvanceTimeFuncEP14AdvanceTimeJobj, __ZNK8Animator22GetControllerWorkspaceEv: __ZNK8Animator22GetControllerWorkspaceEv, __ZNK5physx5cloth11SwClothData9reconcileERNS0_7SwClothE: __ZNK5physx5cloth11SwClothData9reconcileERNS0_7SwClothE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __ZZL20PickDetailPolyHeightRK10DetailMeshiRK8Vector3fEN18PickHeightCallback7processES1_RK14DetailMeshPolyPKii: __ZZL20PickDetailPolyHeightRK10DetailMeshiRK8Vector3fEN18PickHeightCallback7processES1_RK14DetailMeshPolyPKii, __ZNK9GfxDevice31CalculateDeviceProjectionMatrixER10Matrix4x4fbb: __ZNK9GfxDevice31CalculateDeviceProjectionMatrixER10Matrix4x4fbb, __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetWorldSpacev: __Z76Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetWorldSpacev, __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorEC2EPKc, __Z70Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformDirectionv: __Z70Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformDirectionv, __ZN4FMOD3DSP9setActiveEb: __ZN4FMOD3DSP9setActiveEb, _UNITY_png_set_add_alpha: _UNITY_png_set_add_alpha, __ZN5physx6shdfnd10ThreadImpl5sleepEj: __ZN5physx6shdfnd10ThreadImpl5sleepEj, __Z51ParticleRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf: __Z51ParticleRenderer_Set_Custom_PropCameraVelocityScaleP12Il2CppObjectf, __ZN11ShapeModule16CheckConsistencyEv: __ZN11ShapeModule16CheckConsistencyEv, __ZL16WalkDirtyRegionsP14TESStesselatorP12ActiveRegion: __ZL16WalkDirtyRegionsP14TESStesselatorP12ActiveRegion, __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionXP12Il2CppObjecti: __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionXP12Il2CppObjecti, _zipCloseFileInZipRaw: _zipCloseFileInZipRaw, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK26AnimatorOverrideController17GetAnimationClipsEv: __ZNK26AnimatorOverrideController17GetAnimationClipsEv, __ZN11HaloManager10UpdateHaloEi8Vector3f11ColorRGBA32fjP6Object: __ZN11HaloManager10UpdateHaloEi8Vector3f11ColorRGBA32fjP6Object, __ZN16PlayerConnection22InitializeListenSocketER12ServerSocketRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi: __ZN16PlayerConnection22InitializeListenSocketER12ServerSocketRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEi, __Z51Register_UnityEngine_AndroidJNI_GetStaticShortFieldv: __Z51Register_UnityEngine_AndroidJNI_GetStaticShortFieldv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS4_Rb, __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv: __ZN13WheelCollider30ComputeWheelCentreOfMassOffsetEv, __ZN14AssetReferenceC2Ev: __ZN14AssetReferenceC2Ev, __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E: __ZN5Umbra12QueryContext11findClusterERKNS_7Vector3E, __ZN5Umbra9Matrix3x311flushToZeroEv: __ZN5Umbra9Matrix3x311flushToZeroEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI26EnlightenSystemInformationLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI26EnlightenSystemInformationLj8EEEEvRT_17TransferMetaFlags, __Z57Register_UnityEngine_QualitySettings_set_shadowResolutionv: __Z57Register_UnityEngine_QualitySettings_set_shadowResolutionv, _strncmp: _strncmp, __ZL35PrepareRenderNodesQueueToMainThreadR35RenderNodeQueuePrepareThreadContext: __ZL35PrepareRenderNodesQueueToMainThreadR35RenderNodeQueuePrepareThreadContext, __ZN9Animation23VirtualRedirectTransferER14SafeBinaryRead: __ZN9Animation23VirtualRedirectTransferER14SafeBinaryRead, __Z47Register_UnityEngine_Renderer_set_lightmapIndexv: __Z47Register_UnityEngine_Renderer_set_lightmapIndexv, __ZN8VRDevice20UpdateVRSplashScreenEv: __ZN8VRDevice20UpdateVRSplashScreenEv, __ZN11UnityEngine15CloudWebService14DataDispatcher37SetupSessionContainerToDispatchStaticEPv: __ZN11UnityEngine15CloudWebService14DataDispatcher37SetupSessionContainerToDispatchStaticEPv, __ZN5physx15PxsParticleDataD2Ev: __ZN5physx15PxsParticleDataD2Ev, __Z43LightmapSettings_Set_Custom_PropLightProbesP12Il2CppObject: __Z43LightmapSettings_Set_Custom_PropLightProbesP12Il2CppObject, __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_S2_: __ZNK8GUIStyle28ComputeImageSizeBoundedWidthERK8Vector2fRS0_S2_, __ZNK8GUIStyle23CalcSizeWithConstraintsER10GUIContentRK8Vector2f: __ZNK8GUIStyle23CalcSizeWithConstraintsER10GUIContentRK8Vector2f, __ZN9Polygon2D12SetPathCountEi: __ZN9Polygon2D12SetPathCountEi, __ZN11AudioSource21Update3DPanParametersE12SoundChannelf: __ZN11AudioSource21Update3DPanParametersE12SoundChannelf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleDrive4WEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx18PxVehicleDriveTank12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx18PxVehicleDriveTank12createObjectERPhRNS_24PxDeserializationContextE, __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_S6_T_, __ZNK12_GLOBAL__N_121SocketNetworkInStream11isConnectedEv: __ZNK12_GLOBAL__N_121SocketNetworkInStream11isConnectedEv, __Z28LODGroup_Set_Custom_PropSizeP12Il2CppObjectf: __Z28LODGroup_Set_Custom_PropSizeP12Il2CppObjectf, __Z38GameObject_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr: __Z38GameObject_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ejc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2Ejc, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxD6JointDriveEE12readPropertyIfEEbRT_, __ZNKSt3__215__codecvt_utf16IwLb1EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_: __ZNKSt3__215__codecvt_utf16IwLb1EE5do_inER11__mbstate_tPKcS5_RS5_PwS7_RS7_, __ZN13GfxDeviceGLES17CreateRasterStateERK14GfxRasterState: __ZN13GfxDeviceGLES17CreateRasterStateERK14GfxRasterState, __ZN5physx2Sn21SerializationRegistry18registerSerializerEtRNS_12PxSerializerE: __ZN5physx2Sn21SerializationRegistry18registerSerializerEtRNS_12PxSerializerE, __ZN5physx14NpSpatialIndex5flushEv: __ZN5physx14NpSpatialIndex5flushEv, __ZN7StriperD2Ev: __ZN7StriperD2Ev, _posix_openpt: _posix_openpt, __ZN30EmissionModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN30EmissionModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN2UI6Canvas23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK8Collider: __ZN14PhysicsManager32AddToTriggerStayStatesIfRequiredEPK8Collider, __ZN4FMOD13ChannelGroupI20override3DAttributesEPK11FMOD_VECTORS3_: __ZN4FMOD13ChannelGroupI20override3DAttributesEPK11FMOD_VECTORS3_, __ZN8GUIState19GetIDOfNamedControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8GUIState19GetIDOfNamedControlERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEEEEjT_j: __ZNK5physx27PxArticulationGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEEEEjT_j, __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13AnimationClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4Mesh13AwakeFromLoadE17AwakeFromLoadMode: __ZN4Mesh13AwakeFromLoadE17AwakeFromLoadMode, __Z38AudioSource_Get_Custom_PropPlayOnAwakeP12Il2CppObject: __Z38AudioSource_Get_Custom_PropPlayOnAwakeP12Il2CppObject, __ZN21AnimationClipPlayableD2Ev: __ZN21AnimationClipPlayableD2Ev, __Z47Register_UnityEngine_Camera_get_stereoTargetEyev: __Z47Register_UnityEngine_Camera_get_stereoTargetEyev, __Z31setPxJointAngularLimitPairUpperPN5physx23PxJointAngularLimitPairEf: __Z31setPxJointAngularLimitPairUpperPN5physx23PxJointAngularLimitPairEf, __Z20sweepBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z20sweepBox_CapsuleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5audio5mixer14EffectConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5audio5mixer14EffectConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN27AnimationLayerMixerPlayableC2E18DirectorPlayerType: __ZN27AnimationLayerMixerPlayableC2E18DirectorPlayerType, __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_16PxParticleSystemEE22getClientBehaviorFlagsEv, __ZN9Animation14CloneAnimationEP14AnimationState: __ZN9Animation14CloneAnimationEP14AnimationState, __ZNK8LODGroup6GetLODEi: __ZNK8LODGroup6GetLODEi, __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EENS4_IS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN5physx2Gu25PersistentContactManifold12drawManifoldERKNS0_17PersistentContactERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVESC_: __ZN5physx2Gu25PersistentContactManifold12drawManifoldERKNS0_17PersistentContactERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVESC_, __Z43Animator_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f: __Z43Animator_CUSTOM_INTERNAL_get_targetPositionP12Il2CppObjectP8Vector3f, __Z13RegisterClassI15ReflectionProbeEvv: __Z13RegisterClassI15ReflectionProbeEvv, __ZNK25BlendshapePropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE: __ZNK25BlendshapePropertyBinding30CurveAttributeToSerializedPathERKN11UnityEngine9Animation10BoundCurveE, __ZN9ShaderLab20SerializedProperties16AddColorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f: __ZN9ShaderLab20SerializedProperties16AddColorPropertyEPKcS2_RKNSt3__26vectorINS3_12basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEENS8_ISA_EEEERK8Vector4f, __Z17TransformVerticesPhRK10Matrix4x4fRK16VertexBufferDatajjj25GfxTransformVerticesFlags: __Z17TransformVerticesPhRK10Matrix4x4fRK16VertexBufferDatajjj25GfxTransformVerticesFlags, _Move_CVT: _Move_CVT, __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI9TransformE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN10Matrix4x4f14SetPerspectiveEffff: __ZN10Matrix4x4f14SetPerspectiveEffff, __ZNK10GameObject22CountDerivedComponentsEi: __ZNK10GameObject22CountDerivedComponentsEi, __Z67AnimatorOverrideController_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject: __Z67AnimatorOverrideController_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject, __Z45Animator_Get_Custom_PropRightFeetBottomHeightP12Il2CppObject: __Z45Animator_Get_Custom_PropRightFeetBottomHeightP12Il2CppObject, _strtoimax: _strtoimax, __Z57Register_UnityEngine_ParticleSystem_MainModule_GetEnabledv: __Z57Register_UnityEngine_ParticleSystem_MainModule_GetEnabledv, __ZN12WWWDelayCallC2EP3WWWPF15CallObjectStateP6ObjectPvES4_S5_PFS2_S5_E: __ZN12WWWDelayCallC2EP3WWWPF15CallObjectStateP6ObjectPvES4_S5_PFS2_S5_E, __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEEC2EjjSB_: __ZNSt3__214__split_bufferINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEERNS5_IS9_Lj4096EEEEC2EjjSB_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE5cloneERNS0_7FactoryE, __ZN18ProceduralMaterial26RebuildTexturesImmediatelyEv: __ZN18ProceduralMaterial26RebuildTexturesImmediatelyEv, __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI18StreamedBinaryReadILb1EELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_: __ZN5physx2Gu30distanceSegmentSegmentSquared2ERKNS0_7SegmentES3_PfS4_, __ZN11CullResults4InitEPKN5Umbra4TomeE: __ZN11CullResults4InitEPKN5Umbra4TomeE, __Z43UnityAnalyticsHandler_CUSTOM_InternalCreateP12Il2CppObject: __Z43UnityAnalyticsHandler_CUSTOM_InternalCreateP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleSuspensionDataEE8pushNameEPKc, __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_13PxClothFabricEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx6shdfnd9SListImplD2Ev: __ZN5physx6shdfnd9SListImplD2Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab18SerializedPropertyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab18SerializedPropertyENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN11b2WeldJointD0Ev: __ZN11b2WeldJointD0Ev, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_yDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_yDrivev, __ZN14SerializedFile4TypeC2Eibs: __ZN14SerializedFile4TypeC2Eibs, __ZN11AudioModule25AudioManagerAwakeFromLoadE17AwakeFromLoadMode: __ZN11AudioModule25AudioManagerAwakeFromLoadE17AwakeFromLoadMode, _readdir: _readdir, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxVehicleAutoBoxDataEE12readPropertyIfEEbRT_, __ZN5audio5mixer16FindChannelGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID: __ZN5audio5mixer16FindChannelGroupERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUID, __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED2Ev: __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEED2Ev, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags, __ZN11Rigidbody2D12SetSleepModeENS_9SleepModeE: __ZN11Rigidbody2D12SetSleepModeENS_9SleepModeE, __Z64Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedFieldv: __Z64Register_UnityEngine_AndroidJNI_INTERNAL_CALL_FromReflectedFieldv, __ZN17Physics2DSettings27SetMinPenetrationForPenaltyEf: __ZN17Physics2DSettings27SetMinPenetrationForPenaltyEf, _jpeg_has_multiple_scans: _jpeg_has_multiple_scans, __ZNK5physx2Gu5RTree23computeBottomLevelCountEj: __ZNK5physx2Gu5RTree23computeBottomLevelCountEj, __ZN5Unity14CharacterJoint19SetEnableProjectionEb: __ZN5Unity14CharacterJoint19SetEnableProjectionEb, __Z7CRCFeedjPKhj: __Z7CRCFeedjPKhj, __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS8_: __ZN15dense_hashtableINSt3__24pairIKPK17RenderSurfaceBaseP13RenderTextureEES4_N16RenderTextureMap11HashFunctorEN14dense_hash_mapIS4_S7_SA_NS0_8equal_toIS4_EE13stl_allocatorIS8_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS8_, __Z29Component_CUSTOM_GetComponentP12Il2CppObjectP12Il2CppString: __Z29Component_CUSTOM_GetComponentP12Il2CppObjectP12Il2CppString, __ZNK7b2World14GetTreeQualityEv: __ZNK7b2World14GetTreeQualityEv, __Z36GameObject_CUSTOM_GetComponentByNameP12Il2CppObjectP12Il2CppString: __Z36GameObject_CUSTOM_GetComponentByNameP12Il2CppObjectP12Il2CppString, __ZNSt3__219__shared_weak_count4lockEv: __ZNSt3__219__shared_weak_count4lockEv, __ZN5Umbra15CameraTransform17setUserClipPlanesEPKNS_7Vector4Ei: __ZN5Umbra15CameraTransform17setUserClipPlanesEPKNS_7Vector4Ei, __ZN23UnityPurchasingSettings8TransferI14SafeBinaryReadEEvRT_: __ZN23UnityPurchasingSettings8TransferI14SafeBinaryReadEEvRT_, __Z65Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundInternalv: __Z65Register_UnityEngine_Transform_INTERNAL_CALL_RotateAroundInternalv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z52Register_UnityEngine_AudioSource_INTERNAL_CALL_Pausev: __Z52Register_UnityEngine_AudioSource_INTERNAL_CALL_Pausev, __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __ZL19InitializeModule_UIv: __ZL19InitializeModule_UIv, __Z44ParticleAnimator_Set_Custom_PropAutodestructP12Il2CppObjecth: __Z44ParticleAnimator_Set_Custom_PropAutodestructP12Il2CppObjecth, __ZN10DynamicVBO9NextFrameEv: __ZN10DynamicVBO9NextFrameEv, __ZN23AnimationOffsetPlayableD0Ev: __ZN23AnimationOffsetPlayableD0Ev, __ZN2UI11CanvasGroup17SetBlocksRaycastsEb: __ZN2UI11CanvasGroup17SetBlocksRaycastsEb, __Z43Gyroscope_CUSTOM_setUpdateInterval_Internalif: __Z43Gyroscope_CUSTOM_setUpdateInterval_Internalif, __ZNK13GfxDeviceGLES14GetScissorRectEv: __ZNK13GfxDeviceGLES14GetScissorRectEv, __Z54ParticleSystem_TrailModule_CUSTOM_SetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient: __Z54ParticleSystem_TrailModule_CUSTOM_SetColorOverLifetimeP12Il2CppObjectR18MonoMinMaxGradient, __ZN5Umbra20RuntimeStructBuilder4initEPNS_9AllocatorEj: __ZN5Umbra20RuntimeStructBuilder4initEPNS_9AllocatorEj, __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_R4Mesh: __ZN17CollisionMeshData8TransferI18StreamedBinaryReadILb1EEEEvRT_R4Mesh, __Z41Register_UnityEngine_ComputeShader_SetIntv: __Z41Register_UnityEngine_ComputeShader_SetIntv, __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv: __ZNK5physx5cloth17UnalignedIteratorI8Scalar4fLj3EEdeEv, __ZN5physx17PxcSweepBoxConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx17PxcSweepBoxConvexERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getDynamicFrictionEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE18getDynamicFrictionEv, __Z37AssetBundle_CUSTOM_LoadAsset_InternalP12Il2CppObjectP12Il2CppStringS0_: __Z37AssetBundle_CUSTOM_LoadAsset_InternalP12Il2CppObjectP12Il2CppStringS0_, __Z46EmitSerializationCommandsForManagedObjectFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI17RemapPPtrTransferEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZNK23ArchiveStorageConverter13GetBlocksInfoEv: __ZNK23ArchiveStorageConverter13GetBlocksInfoEv, __Z34NavMeshAgent_Set_Custom_PropHeightP12Il2CppObjectf: __Z34NavMeshAgent_Set_Custom_PropHeightP12Il2CppObjectf, __ZN10__cxxabiv117__pbase_type_infoD0Ev: __ZN10__cxxabiv117__pbase_type_infoD0Ev, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE19setRigidDynamicFlagENS_15PxRigidBodyFlag4EnumEb, __ZN6Shader8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN6Shader8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx2Sc5Scene7addBodyEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E: __ZN5physx2Sc5Scene7addBodyEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj541ENS_22PxRepXPropertyAccessorILj541ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj541ENS_22PxRepXPropertyAccessorILj541ES4_ffEEEEvRKT0_, __Z29StdTemplateConversionFunctionIbsEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbsEbPvR14SafeBinaryRead, __ZN22LocalFileSystemHandler16LastErrorMessageEv: __ZN22LocalFileSystemHandler16LastErrorMessageEv, __Z40Register_UnityEngine_AndroidJNI_ThrowNewv: __Z40Register_UnityEngine_AndroidJNI_ThrowNewv, __ZN10systeminfo13GetDeviceNameEv: __ZN10systeminfo13GetDeviceNameEv, __ZN11DynamicMesh9AddVertexERK8Vector3f: __ZN11DynamicMesh9AddVertexERK8Vector3f, __Z18LockObjectCreationv: __Z18LockObjectCreationv, __Z59Register_UnityEngine_Rigidbody_get_solverVelocityIterationsv: __Z59Register_UnityEngine_Rigidbody_get_solverVelocityIterationsv, __ZNK12BaseRenderer19GetStaticBatchIndexEv: __ZNK12BaseRenderer19GetStaticBatchIndexEv, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC2Ev, __Z51Register_UnityEngine_AI_OffMeshLink_UpdatePositionsv: __Z51Register_UnityEngine_AI_OffMeshLink_UpdatePositionsv, __Z30Camera_CUSTOM_AddCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_: __Z30Camera_CUSTOM_AddCommandBufferP12Il2CppObject21RenderCameraEventTypeS0_, __ZN5physx17collisionResponseERNS_19PxsParticleCollDataEbbRNS_27PxsFluidCollisionParametersE: __ZN5physx17collisionResponseERNS_19PxsParticleCollDataEbbRNS_27PxsFluidCollisionParametersE, __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE: __ZN11UnityEngine9Animation30DestroyAnimatorGenericBindingsEPNS0_30AnimatorGenericBindingConstantERN7mecanim6memory9AllocatorE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj663ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleEngineDataES7_EEKNS_32PxVehicleEngineDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev: __ZNSt3__213__vector_baseI20ComputeShaderVariantNS_9allocatorIS1_EEED2Ev, __Z45Register_UnityEngine_PointEffector2D_set_dragv: __Z45Register_UnityEngine_PointEffector2D_set_dragv, __ZN21UnityAnalyticsManagerD2Ev: __ZN21UnityAnalyticsManagerD2Ev, __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEEEEjT_j: __ZNK5physx23PxMaterialGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEEEEEjT_j, __ZN18ProceduralMaterial19FixAlphaSourcesUIDsEv: __ZN18ProceduralMaterial19FixAlphaSourcesUIDsEv, __ZL16ClearFramebufferN6Camera9ClearModeE5RectTIfERK10ColorRGBAfbb: __ZL16ClearFramebufferN6Camera9ClearModeE5RectTIfERK10ColorRGBAfbb, __Z73Register_UnityEngine_CullingGroup_INTERNAL_CALL_SetDistanceReferencePointv: __Z73Register_UnityEngine_CullingGroup_INTERNAL_CALL_SetDistanceReferencePointv, __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE: __Z34CopyFloatArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewCharArrayiRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewCharArrayiRPv, __ZL40PrepareRenderNodesOnMainThreadDeprecatedR35RenderNodeQueuePrepareThreadContext: __ZL40PrepareRenderNodesOnMainThreadDeprecatedR35RenderNodeQueuePrepareThreadContext, __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayINS_5cloth13MovingAverage7ElementENS0_9AllocatorEE6resizeEjRKS4_, __ZN21LightProbeProxyVolume27ValidateBoundingBoxSettingsEv: __ZN21LightProbeProxyVolume27ValidateBoundingBoxSettingsEv, __ZN4FMOD8ChannelI13setSpeakerMixEffffffff: __ZN4FMOD8ChannelI13setSpeakerMixEffffffff, __ZN10Matrix4x4fC2ERK10Matrix3x3f: __ZN10Matrix4x4fC2ERK10Matrix3x3f, __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetEnabledv: __Z73Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetEnabledv, __Z31getPxVehicleGearsData_GearRatioPKN5physx18PxVehicleGearsDataENS0_4EnumE: __Z31getPxVehicleGearsData_GearRatioPKN5physx18PxVehicleGearsDataENS0_4EnumE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj122ES3_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj122ES3_NS_7PxFlagsINS_11PxShapeFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z24setPxCloth_ContactOffsetPN5physx7PxClothEf: __Z24setPxCloth_ContactOffsetPN5physx7PxClothEf, __ZN5Umbra8QueryExt21buildMaskShadowCullerERNS_15ShadowCullerExtERKNS_10VisibilityERKNS_7Vector3EPS7_iPfjPPKNS_15CameraTransformEi: __ZN5Umbra8QueryExt21buildMaskShadowCullerERNS_15ShadowCullerExtERKNS_10VisibilityERKNS_7Vector3EPS7_iPfjPPKNS_15CameraTransformEi, __Z52Register_UnityEngine_AudioReverbZone_set_minDistancev: __Z52Register_UnityEngine_AudioReverbZone_set_minDistancev, __ZN15ParticleEmitterC2E10MemLabelId18ObjectCreationMode: __ZN15ParticleEmitterC2E10MemLabelId18ObjectCreationMode, __ZN8Animator13BatchedIKPassERK13dynamic_arrayI11DirectorJobLj8EE: __ZN8Animator13BatchedIKPassERK13dynamic_arrayI11DirectorJobLj8EE, __Z26getPxTolerancesScaleLengthPKN5physx17PxTolerancesScaleE: __Z26getPxTolerancesScaleLengthPKN5physx17PxTolerancesScaleE, _UNITY_png_get_image_width: _UNITY_png_get_image_width, __ZN14PhysicsManager18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction: __ZN14PhysicsManager18SweepRigidbodyTestEPN5physx12PxRigidActorERK8Vector3ffR10RaycastHiti23QueryTriggerInteraction, __ZNK21EnlightenSceneMapping19GetTerrainChunkUVSTER8Vector4fiRK7Hash128: __ZNK21EnlightenSceneMapping19GetTerrainChunkUVSTER8Vector4fiRK7Hash128, __ZN19StreamedBinaryWriteILb0EE5AlignEv: __ZN19StreamedBinaryWriteILb0EE5AlignEv, __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj64ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE: __ZN5physx3Scb5Shape6Access5writeINS0_11ShapeBuffer3FnsILj64ELj0EEEEEvRS1_RNS_2Sc9ShapeCoreENT_3ArgE, __ZN9Animation15ThreadedCleanupEv: __ZN9Animation15ThreadedCleanupEv, __Z26GetApplicationContentsPathv: __Z26GetApplicationContentsPathv, __ZN15ReplacementPass20AcquireRendererSceneERK19SharedRendererScene: __ZN15ReplacementPass20AcquireRendererSceneERK19SharedRendererScene, __ZNK6Camera20WorldToViewportPointERK8Vector3f: __ZNK6Camera20WorldToViewportPointERK8Vector3f, __ZN9Texture2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Texture2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN10Matrix4x4f12SetTRInverseERK8Vector3fRK11Quaternionf: __ZN10Matrix4x4f12SetTRInverseERK8Vector3fRK11Quaternionf, __ZN20PxsAtomIntegrateTask11runInternalEv: __ZN20PxsAtomIntegrateTask11runInternalEv, __Z27Terrain_CUSTOM_SetNeighborsP12Il2CppObjectS0_S0_S0_S0_: __Z27Terrain_CUSTOM_SetNeighborsP12Il2CppObjectS0_S0_S0_S0_, __ZN5Umbra5QueryD2Ev: __ZN5Umbra5QueryD2Ev, __ZN5physx5cloth11SwCollisionI8Scalar4fE23buildSphereAccelerationEPKNS0_10SphereDataE: __ZN5physx5cloth11SwCollisionI8Scalar4fE23buildSphereAccelerationEPKNS0_10SphereDataE, __ZN5physx9transformERKNS_2Cm8Matrix34ERKNS_2Gu3BoxE: __ZN5physx9transformERKNS_2Cm8Matrix34ERKNS_2Gu3BoxE, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19onConstraintReleaseEv, __ZN5physx9NpFactory21createNpParticleFluidEjb: __ZN5physx9NpFactory21createNpParticleFluidEjb, __Z34setPxVehicleDriveSimData_GearsDataPN5physx21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataE: __Z34setPxVehicleDriveSimData_GearsDataPN5physx21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataE, __ZNK20BufferedSocketStream11IsConnectedEv: __ZNK20BufferedSocketStream11IsConnectedEv, __ZN5physx16PxVehicleDrive4W4freeEv: __ZN5physx16PxVehicleDrive4W4freeEv, __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE: __ZN5physx14NpShapeManager18setupAllSceneQueryERKNS_12PxRigidActorE, __ZN5physx11EdgeManagerD2Ev: __ZN5physx11EdgeManagerD2Ev, __Z30getPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveEj: __Z30getPxVehicleNoDrive_SteerAnglePKN5physx16PxVehicleNoDriveEj, __Z36Register_UnityEngine_Light_get_rangev: __Z36Register_UnityEngine_Light_get_rangev, __ZN21AssetBundleFileSystem10ToAbsoluteEPKc: __ZN21AssetBundleFileSystem10ToAbsoluteEPKc, __Z13RegisterClassI15TerrainColliderEvv: __Z13RegisterClassI15TerrainColliderEvv, __ZN18CapsuleCast2DQueryD0Ev: __ZN18CapsuleCast2DQueryD0Ev, __Z57Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsulev: __Z57Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsulev, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E14squash_deletedEv, _ms_seek: _ms_seek, __Z40CalculateBoundingSphereFromFrustumPointsPK8Vector3fRS_Rf: __Z40CalculateBoundingSphereFromFrustumPointsPK8Vector3fRS_Rf, __ZN2UI13CanvasManager20MarkAllCanvasesDirtyEv: __ZN2UI13CanvasManager20MarkAllCanvasesDirtyEv, __ZN21ArchiveStorageCreator10AppendDataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEPKvj: __ZN21ArchiveStorageCreator10AppendDataERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEPKvj, __Z61Register_UnityEngine_LightProbeProxyVolume_get_resolutionModev: __Z61Register_UnityEngine_LightProbeProxyVolume_get_resolutionModev, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDrive4WEEC2ERNS_19PxAllocatorCallbackE, __Z41Register_UnityEngine_TextMesh_get_tabSizev: __Z41Register_UnityEngine_TextMesh_get_tabSizev, _sha512_sum: _sha512_sum, __ZN13ConstantForce15ThreadedCleanupEv: __ZN13ConstantForce15ThreadedCleanupEv, __Z41Register_UnityEngine_Joint_get_breakForcev: __Z41Register_UnityEngine_Joint_get_breakForcev, __ZN13TextRendering4Font7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13TextRendering4Font7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_: __ZN17AnimationCurveTplIfE6AssignEPK11KeyframeTplIfES4_, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __ZNK5physx10NpMaterial25getRestitutionCombineModeEv: __ZNK5physx10NpMaterial25getRestitutionCombineModeEv, __ZL28CleanupIMGUIScriptingClassesv: __ZL28CleanupIMGUIScriptingClassesv, __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32: __ZNK4Mesh17ExtractColorArrayEP11ColorRGBA32, __ZN11MonoManager15ThreadedCleanupEv: __ZN11MonoManager15ThreadedCleanupEv, __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_: __ZNK15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E13find_positionERS2_, __Z26AddEulerCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb: __Z26AddEulerCurveToClipBuilderR17AnimationCurveTplI8Vector3fERK8UnityStrR18MecanimClipBuilderb, __Z29Avatar_CUSTOM_SetMuscleMinMaxP12Il2CppObjectiff: __Z29Avatar_CUSTOM_SetMuscleMinMaxP12Il2CppObjectiff, __Z24RegisterStrippedTypeInfoIN5Unity10HingeJointEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity10HingeJointEEviPKcS3_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi64EEEEEE15growAndPushBackERKS2_, __Z44Register_UnityEngine_Cubemap_Internal_Createv: __Z44Register_UnityEngine_Cubemap_Internal_Createv, __ZN15HeightMeshQuery16RemoveHeightDataEi: __ZN15HeightMeshQuery16RemoveHeightDataEi, __Z19UnixTimeToUnityTimelR8DateTime: __Z19UnixTimeToUnityTimelR8DateTime, __ZN9IVRDeviceD2Ev: __ZN9IVRDeviceD2Ev, __ZN5physxL17AddConvexTriangleEPNS_27ConvexHullTriangleInterfaceEPKfS3_S3_: __ZN5physxL17AddConvexTriangleEPNS_27ConvexHullTriangleInterfaceEPKfS3_S3_, __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEEEvRT_j, _strcmp: _strcmp, __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z23DeletePathNameExtensionRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, ___unlockfile: ___unlockfile, __Z29GL_CUSTOM_SetRevertBackfacingh: __Z29GL_CUSTOM_SetRevertBackfacingh, __Z38AudioSource_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth: __Z38AudioSource_Set_Custom_PropPlayOnAwakeP12Il2CppObjecth, __Z63Register_UnityEngine_ParticleSystemRenderer_get_normalDirectionv: __Z63Register_UnityEngine_ParticleSystemRenderer_get_normalDirectionv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_17TransferMetaFlags, _tt_cmap14_variants: _tt_cmap14_variants, _setgid: _setgid, __ZNK5physx3Cct13BoxController8getStateERNS_17PxControllerStateE: __ZNK5physx3Cct13BoxController8getStateERNS_17PxControllerStateE, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERf: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERf, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERh: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERh, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI17SortingLayerEntryNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z39AudioReverbFilter_Get_Custom_PropRoomLFP12Il2CppObject: __Z39AudioReverbFilter_Get_Custom_PropRoomLFP12Il2CppObject, __ZNSt3__26vectorIN19ConstantBuffersGLES11ConstBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN19ConstantBuffersGLES11ConstBufferENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E: __ZN5Umbra12QueryContext8findSlotERKNS_7Vector3E, __ZNK15HeightMeshQuery16GetTerrainHeightERK8Vector3fPf: __ZNK15HeightMeshQuery16GetTerrainHeightERK8Vector3fPf, __ZN11UnityEngine7Connect15AppInstallEventD2Ev: __ZN11UnityEngine7Connect15AppInstallEventD2Ev, __ZNK4Mesh19ExtractTangentArrayEP8Vector4f: __ZNK4Mesh19ExtractTangentArrayEP8Vector4f, __Z58Register_UnityEngine_SystemInfo_get_supportsSparseTexturesv: __Z58Register_UnityEngine_SystemInfo_get_supportsSparseTexturesv, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERy: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERy, __ZN7mecanim9animation28MotionOutputSetDeltaRotationEPNS0_12MotionOutputERKN4math7_float4E: __ZN7mecanim9animation28MotionOutputSetDeltaRotationEPNS0_12MotionOutputERKN4math7_float4E, __ZNSt3__227__insertion_sort_incompleteIR11EventSorterP14AnimationEventEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR11EventSorterP14AnimationEventEEbT0_S5_T_, __ZN13WebCamTexture4PlayEv: __ZN13WebCamTexture4PlayEv, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEED0Ev: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEED0Ev, __Z28Animator_CUSTOM_GetIntegerIDP12Il2CppObjecti: __Z28Animator_CUSTOM_GetIntegerIDP12Il2CppObjecti, __Z47Register_UnityEngine_RenderTexture_set_isVolumev: __Z47Register_UnityEngine_RenderTexture_set_isVolumev, __ZNK23ArchiveStorageConverter23GetProcessedArchiveSizeEv: __ZNK23ArchiveStorageConverter23GetProcessedArchiveSizeEv, __ZN5physx26NpPhysicsInsertionCallback12insertObjectERNS_6PxBaseE: __ZN5physx26NpPhysicsInsertionCallback12insertObjectERNS_6PxBaseE, __Z42ParticleSystemRenderer_Get_Custom_PropMeshP12Il2CppObject: __Z42ParticleSystemRenderer_Get_Custom_PropMeshP12Il2CppObject, __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EERKSB_PKS8_: __ZNSt3__2plIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEEENS_12basic_stringIT_T0_T1_EERKSB_PKS8_, __ZN17SurfaceEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17SurfaceEffector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl22setNamedPropertyValuesEN5physx8debugger7DataRefINS2_10NamedValueEEENS2_18NonNegativeIntegerE: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl22setNamedPropertyValuesEN5physx8debugger7DataRefINS2_10NamedValueEEENS2_18NonNegativeIntegerE, __ZNK18AssetBundleManager24GetAssetBundleScenePathsERK8UnityStrRS0_S3_: __ZNK18AssetBundleManager24GetAssetBundleScenePathsERK8UnityStrRS0_S3_, __Z13RegisterClassI9Texture3DEvv: __Z13RegisterClassI9Texture3DEvv, __ZN14b2CapsuleShape13SetByExtentsXEff: __ZN14b2CapsuleShape13SetByExtentsXEff, __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8Renderer23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN15NavMeshObstacle5ResetEv: __ZN15NavMeshObstacle5ResetEv, __ZNK5physx2Sn20SerializationContext13getCollectionEv: __ZNK5physx2Sn20SerializationContext13getCollectionEv, __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab18SerializedProperty8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_: __ZNK8GUIStyle29ComputeImageSizeBoundedHeightERK8Vector2fRS0_, __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13AudioListener23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx8debugger17MemPvdInputStream4readEPhRj: __ZN5physx8debugger17MemPvdInputStream4readEPhRj, __ZNSt3__26locale5__imp12install_fromINS_8numpunctIwEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_8numpunctIwEEEEvRKS1_, __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sn9MetaClassENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZNK5Umbra10Visibility16getOutputObjectsEv: __ZNK5Umbra10Visibility16getOutputObjectsEv, __ZN14PhysicsManager18SetBounceThresholdEf: __ZN14PhysicsManager18SetBounceThresholdEf, __Z39ParticleSystemRenderer_RenderBillboardsRK15RenderNodeQueuejRK14ChannelAssignsi: __Z39ParticleSystemRenderer_RenderBillboardsRK15RenderNodeQueuejRK14ChannelAssignsi, __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_highAngularXLimitv: __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_highAngularXLimitv, ___shm_mapname: ___shm_mapname, __ZN11ClothModule16InitClothManagerEv: __ZN11ClothModule16InitClothManagerEv, __ZNK8VRDevice22GetDidPauseApplicationEv: __ZNK8VRDevice22GetDidPauseApplicationEv, __ZN8DrawUtil36DrawLineOrTrailMultipleFromNodeQueueERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __ZN8DrawUtil36DrawLineOrTrailMultipleFromNodeQueueERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN12_GLOBAL__N_117EventBufferClient6unlockEv: __ZN12_GLOBAL__N_117EventBufferClient6unlockEv, __Z56ParticleSystem_MainModule_CUSTOM_SetStartDelayMultiplierP12Il2CppObjectf: __Z56ParticleSystem_MainModule_CUSTOM_SetStartDelayMultiplierP12Il2CppObjectf, __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Flare12FlareElement8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv: __ZNKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__cEv, __ZN5physx2Sc21ConstraintInteractionD0Ev: __ZN5physx2Sc21ConstraintInteractionD0Ev, __Z44Application_Set_Custom_PropStackTraceLogTypei: __Z44Application_Set_Custom_PropStackTraceLogTypei, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN5physx2Sn18RepXCollectionImplD0Ev: __ZN5physx2Sn18RepXCollectionImplD0Ev, __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Sn15ExportReferenceENS0_19ReflectionAllocatorIS3_EEE8recreateEj, _setmntent: _setmntent, __Z42Random_CUSTOM_INTERNAL_get_rotationUniformP11Quaternionf: __Z42Random_CUSTOM_INTERNAL_get_rotationUniformP11Quaternionf, __ZN4Mesh19UnloadFromGfxDeviceEv: __ZN4Mesh19UnloadFromGfxDeviceEv, __Z45Register_UnityEngine_AudioReverbZone_set_roomv: __Z45Register_UnityEngine_AudioReverbZone_set_roomv, __Z56Register_UnityEngine_RenderSettings_set_fogStartDistancev: __Z56Register_UnityEngine_RenderSettings_set_fogStartDistancev, __Z29Avatar_Get_Custom_PropIsValidP12Il2CppObject: __Z29Avatar_Get_Custom_PropIsValidP12Il2CppObject, _UNITY_LZ4_uncompress: _UNITY_LZ4_uncompress, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteStringEPKcj, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossv, _UNITY_FT_Destroy_Class_tt_services: _UNITY_FT_Destroy_Class_tt_services, __Z20FakeGetTimeInSamplesv: __Z20FakeGetTimeInSamplesv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _common_163: _common_163, __ZN21AnimationClipPlayable13ClearBindingsEv: __ZN21AnimationClipPlayable13ClearBindingsEv, __ZN12HingeJoint2DD0Ev: __ZN12HingeJoint2DD0Ev, __ZNK5physx24PxClothMeshQuadifierImpl13getDescriptorEv: __ZNK5physx24PxClothMeshQuadifierImpl13getDescriptorEv, __Z48GUIStyle_CUSTOM_INTERNAL_get_Internal_clipOffsetP12Il2CppObjectP13Vector2fIcall: __Z48GUIStyle_CUSTOM_INTERNAL_get_Internal_clipOffsetP12Il2CppObjectP13Vector2fIcall, __Z57Register_UnityEngine_Physics_set_minPenetrationForPenaltyv: __Z57Register_UnityEngine_Physics_set_minPenetrationForPenaltyv, __ZN11SoundHandleD2Ev: __ZN11SoundHandleD2Ev, _iswprint_l: _iswprint_l, __ZN18GfxFramebufferGLES8BlitQuadEv: __ZN18GfxFramebufferGLES8BlitQuadEv, _UNITY_png_malloc_base: _UNITY_png_malloc_base, __ZN11AudioSource8DoUpdateEv: __ZN11AudioSource8DoUpdateEv, __Z48CharacterJoint_CUSTOM_INTERNAL_get_lowTwistLimitP12Il2CppObjectP14SoftJointLimit: __Z48CharacterJoint_CUSTOM_INTERNAL_get_lowTwistLimitP12Il2CppObjectP14SoftJointLimit, __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16LightmapSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z29Animation_CUSTOM_GetClipCountP12Il2CppObject: __Z29Animation_CUSTOM_GetClipCountP12Il2CppObject, __ZN5physx16PxVehicleNoDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE: __ZN5physx16PxVehicleNoDrive5setupEPNS_9PxPhysicsEPNS_14PxRigidDynamicERKNS_22PxVehicleWheelsSimDataE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN5physx31PxClothGeodesicTetherCookerImpl20findVertTriNeighborsEv: __ZN5physx31PxClothGeodesicTetherCookerImpl20findVertTriNeighborsEv, __ZNK11DynamicMesh12IntersectionER13dynamic_arrayI8Vector3fLj4EERKS0_I5PlaneLj4EES3_Ph: __ZNK11DynamicMesh12IntersectionER13dynamic_arrayI8Vector3fLj4EERKS0_I5PlaneLj4EES3_Ph, __ZNK22ScAfterIntegrationTask7getNameEv: __ZNK22ScAfterIntegrationTask7getNameEv, __ZNSt3__218__insertion_sort_3IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_: __ZNSt3__218__insertion_sort_3IRPFbRKN18AwakeFromLoadQueue4ItemES4_EPS2_EEvT0_S9_T_, __ZNK15ReflectionProbe24CalculateHDRDecodeValuesEv: __ZNK15ReflectionProbe24CalculateHDRDecodeValuesEv, __Z34Sprite_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObjectRK5RectTIfERK13Vector2fIcallfj14SpriteMeshTypeRK8Vector4f: __Z34Sprite_CUSTOM_INTERNAL_CALL_CreateP12Il2CppObjectRK5RectTIfERK13Vector2fIcallfj14SpriteMeshTypeRK8Vector4f, __ZThn8_N5physx2Gu12TriangleMeshD0Ev: __ZThn8_N5physx2Gu12TriangleMeshD0Ev, __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipVv: __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipVv, __ZN12_GLOBAL__N_110Connection22setIsTopLevelUIElementEPKvb: __ZN12_GLOBAL__N_110Connection22setIsTopLevelUIElementEPKvb, __ZN6Skybox16RenderSingleFaceEP8Materiali: __ZN6Skybox16RenderSingleFaceEP8Materiali, __ZN8GUIStateD2Ev: __ZN8GUIStateD2Ev, __ZN5IMGUI13GetWindowRectER8GUIStatei: __ZN5IMGUI13GetWindowRectER8GUIStatei, __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15TextureSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK12UnityVersiongtERKS_: __ZNK12UnityVersiongtERKS_, _deflate_slow: _deflate_slow, __Z20GetChannelFormatSizeh: __Z20GetChannelFormatSizeh, __ZN5physx37solveContactCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx37solveContactCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN5Unity9Component10SetEnabledEb: __ZN5Unity9Component10SetEnabledEb, __ZNKSt3__214__codecvt_utf8IDsE11do_encodingEv: __ZNKSt3__214__codecvt_utf8IDsE11do_encodingEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj444ENS_22PxRepXPropertyAccessorILj444ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj444ENS_22PxRepXPropertyAccessorILj444ES4_ffEEEEvRKT0_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu12TriangleMeshEE12createObjectERPhRNS_24PxDeserializationContextE, __ZL20PrepareSceneNodesJobP24PrepareSceneNodesJobDataj: __ZL20PrepareSceneNodesJobP24PrepareSceneNodesJobDataj, __ZN10GUIManager16GUIObjectWrapperC2EP13MonoBehaviour: __ZN10GUIManager16GUIObjectWrapperC2EP13MonoBehaviour, __Z18ReleaseLogHandlersv: __Z18ReleaseLogHandlersv, __ZN19CharacterController8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19CharacterController8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z47Register_UnityEngine_AudioChorusFilter_set_ratev: __Z47Register_UnityEngine_AudioChorusFilter_set_ratev, __ZN5physx6shdfnd4sortI10SortedDataNS0_4LessIS2_EENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortI10SortedDataNS0_4LessIS2_EENS0_19ReflectionAllocatorIS2_EEEEvPT_jRKT0_RKT1_j, __Z53setPxSimulationStatisticsParticlesGpuMeshCacheHitratePN5physx22PxSimulationStatisticsEf: __Z53setPxSimulationStatisticsParticlesGpuMeshCacheHitratePN5physx22PxSimulationStatisticsEf, __ZN15DirectorManager12ExecuteStageE13DirectorStage: __ZN15DirectorManager12ExecuteStageE13DirectorStage, __Z19IntersectAABBSphereRK4AABBRK6Sphere: __Z19IntersectAABBSphereRK4AABBRK6Sphere, __ZN7b2World4DumpEv: __ZN7b2World4DumpEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_St16initializer_listIwE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceENS_11__wrap_iterIPKwEES9_St16initializer_listIwE, __ZNK15FileSystemEntry9IsSymLinkEv: __ZNK15FileSystemEntry9IsSymLinkEv, __ZN7ApiGLESC2Ev: __ZN7ApiGLESC2Ev, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER14SafeBinaryRead, __ZNK17ArchiveFileSystem18HasMountedArchivesEv: __ZNK17ArchiveFileSystem18HasMountedArchivesEv, __ZN12_GLOBAL__N_116CollectionSorter7processERN5physx6PxBaseE: __ZN12_GLOBAL__N_116CollectionSorter7processERN5physx6PxBaseE, __ZN10systeminfo22GetUsedVirtualMemoryMBEv: __ZN10systeminfo22GetUsedVirtualMemoryMBEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpArticulationEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __Z44Register_UnityEngine_Terrain_get_terrainDatav: __Z44Register_UnityEngine_Terrain_get_terrainDatav, __Z43ParticleSystem_MainModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z43ParticleSystem_MainModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z13RegisterClassI30RuntimeInitializeOnLoadManagerEvv: __Z13RegisterClassI30RuntimeInitializeOnLoadManagerEvv, __Z13SetGLViewportRK5RectTIfE: __Z13SetGLViewportRK5RectTIfE, __ZN10HumanTrait11HasColliderER6Avatari: __ZN10HumanTrait11HasColliderER6Avatari, __ZNK26DownloadHandlerAssetBundle8GetBytesEv: __ZNK26DownloadHandlerAssetBundle8GetBytesEv, __Z26FinishAllCaptureScreenshotv: __Z26FinishAllCaptureScreenshotv, _jpeg_mem_term: _jpeg_mem_term, __Z37SystemInfo_Get_Custom_PropDeviceModelv: __Z37SystemInfo_Get_Custom_PropDeviceModelv, __ZN15RelativeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15RelativeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI9RigidbodyE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z29StdTemplateConversionFunctionIbiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbiEbPvR14SafeBinaryRead, __ZN17BlendShapeChannel8TransferI14SafeBinaryReadEEvRT_: __ZN17BlendShapeChannel8TransferI14SafeBinaryReadEEvRT_, __ZN7mecanim9animation12StreamedClip8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation12StreamedClip8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z44Register_UnityEngine_ComputeBuffer_get_countv: __Z44Register_UnityEngine_ComputeBuffer_get_countv, __ZL17IsSpotLightCulledRK11ActiveLightibRK4AABBS4_RK10Matrix4x4f: __ZL17IsSpotLightCulledRK11ActiveLightibRK4AABBS4_RK10Matrix4x4f, __ZN31CollisionModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN31CollisionModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv: __Z63ThreadAndSerializationSafeCheckGetMonoBehaviourBeingTransferredv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_12_hourERiRS4_S4_RjRKNS_5ctypeIcEE, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_21collisionFinalizationEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNK5Umbra16LineSegmentQuery9getResultEv: __ZNK5Umbra16LineSegmentQuery9getResultEv, __ZNK13EmscriptenWWW11GetProgressEv: __ZNK13EmscriptenWWW11GetProgressEv, __ZNK20LocalFileSystemPosix9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag: __ZNK20LocalFileSystemPosix9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag, __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRPFbRK16NavMeshCarveDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_, __ZN6Camera13CopiableStateC2Ev: __ZN6Camera13CopiableStateC2Ev, __ZN5physx3Scb14ParticleSystem9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEENS_11PxForceMode4EnumE: __ZN5physx3Scb14ParticleSystem9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEENS_11PxForceMode4EnumE, __ZN5physx2Gu12StoreIndicesEtjPKtRNS_14PxOutputStreamEb: __ZN5physx2Gu12StoreIndicesEtjPKtRNS_14PxOutputStreamEb, __ZNK13GfxDeviceGLES16IsScissorEnabledEv: __ZNK13GfxDeviceGLES16IsScissorEnabledEv, __ZN12BaseRenderer23UpdatePreviousFrameDataEv: __ZN12BaseRenderer23UpdatePreviousFrameDataEv, __Z38AudioReverbZone_Get_Custom_PropDensityP12Il2CppObject: __Z38AudioReverbZone_Get_Custom_PropDensityP12Il2CppObject, __ZN5physx16PxsBroadPhaseMBP12removeRegionEj: __ZN5physx16PxsBroadPhaseMBP12removeRegionEj, __Z51Register_UnityEngine_AsyncOperation_InternalDestroyv: __Z51Register_UnityEngine_AsyncOperation_InternalDestroyv, __ZN9AudioClip23VirtualRedirectTransferER14SafeBinaryRead: __ZN9AudioClip23VirtualRedirectTransferER14SafeBinaryRead, __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__215time_put_bynameIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __Z34Debug_CUSTOM_ClearDeveloperConsolev: __Z34Debug_CUSTOM_ClearDeveloperConsolev, __ZN21ArchiveStorageCreator10AppendNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEy: __ZN21ArchiveStorageCreator10AppendNodeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEN20ArchiveStorageHeader9NodeFlagsEy, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_PKc17TransferMetaFlags, __ZThn8_N12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv: __ZThn8_N12_GLOBAL__N_117ConnectionManager12onAllocationEjPKcS2_iPv, __ZNK5Umbra10PortalInfo18getBoundingCirclesERNS_7Vector3ERfS3_RNS_7Vector4E: __ZNK5Umbra10PortalInfo18getBoundingCirclesERNS_7Vector3ERfS3_RNS_7Vector4E, __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv: __ZN5physx2Sc17ParticleSystemSim19processShapesUpdateEv, __ZN14PhysicsManager22ProcessRecordedReportsEv: __ZN14PhysicsManager22ProcessRecordedReportsEv, __ZN4FMOD7ReverbI15set3DAttributesEPK11FMOD_VECTORff: __ZN4FMOD7ReverbI15set3DAttributesEPK11FMOD_VECTORff, __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI17PhysicsMaterial2DE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__210moneypunctIcLb1EE11frac_digitsEv: __ZNKSt3__210moneypunctIcLb1EE11frac_digitsEv, __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13MonoBehaviour23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z40Register_UnityEngine_Event_get_characterv: __Z40Register_UnityEngine_Event_get_characterv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphereGeometryEEEE14handleAccessorILj273ENS_22PxRepXPropertyAccessorILj273ES4_ffEEEEvRKT0_, __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb: __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb, __ZN9Texture2D11InitTextureEii13TextureFormatNS_10EInitFlagsEiii: __ZN9Texture2D11InitTextureEii13TextureFormatNS_10EInitFlagsEiii, __ZN5physx7NpActorC2EPKc: __ZN5physx7NpActorC2EPKc, __ZN9Texture2D15ThreadedCleanupEv: __ZN9Texture2D15ThreadedCleanupEv, __ZNK14ParticleSystem18GetMaxNumParticlesEv: __ZNK14ParticleSystem18GetMaxNumParticlesEv, __ZN5physx2Sc5Scene17finalizationPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene17finalizationPhaseEPNS_10PxBaseTaskE, __ZNK5physx30PxVehicleTireDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEEEEjT_j: __ZNK5physx30PxVehicleTireDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEEEEEjT_j, __ZN17GeneralConnection14NetworkMessage11GetDataSizeEv: __ZN17GeneralConnection14NetworkMessage11GetDataSizeEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS_9allocatorIS3_EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetRotationR9HPlayableR11Quaternionf: __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_GetRotationR9HPlayableR11Quaternionf, __Z51ParticleSystemRenderer_Get_Custom_PropTrailMaterialP12Il2CppObject: __Z51ParticleSystemRenderer_Get_Custom_PropTrailMaterialP12Il2CppObject, __Z13RegisterClassI17PhysicsMaterial2DEvv: __Z13RegisterClassI17PhysicsMaterial2DEvv, _do_flush: _do_flush, __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE: __ZN5physx2Gu8GJKLocalERKNS0_9TriangleVERKNS0_4BoxVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVE, __Z24RegisterStrippedTypeInfoIN5Unity9ComponentEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity9ComponentEEviPKcS3_, __ZN5physx11HullLibrary10expandhullEPNS_6float3EiRS2_Rif: __ZN5physx11HullLibrary10expandhullEPNS_6float3EiRS2_Rif, _UNITY_LZ4_compress: _UNITY_LZ4_compress, __Z19IsMultiTouchEnabledv: __Z19IsMultiTouchEnabledv, __ZN5Unity5Joint9SetAnchorERK8Vector3f: __ZN5Unity5Joint9SetAnchorERK8Vector3f, __ZN8Playable22ScheduleForDestructionEv: __ZN8Playable22ScheduleForDestructionEv, __ZN9allocutil14BuddyAllocator17FreeBlockRegistryC2E10MemLabelIdhj: __ZN9allocutil14BuddyAllocator17FreeBlockRegistryC2E10MemLabelIdhj, __Z62Register_UnityEngine_Renderer_INTERNAL_set_lightmapScaleOffsetv: __Z62Register_UnityEngine_Renderer_INTERNAL_set_lightmapScaleOffsetv, __ZN22CrashReportingSettings5ResetEv: __ZN22CrashReportingSettings5ResetEv, __ZN22ParticleSystemRenderer24PrepareForRenderThreadedERK32ParticleSystemGeometryJobModulesR31ParticleSystemParticlesTempDataP23ParticleSystemParticlesR22ParticleSystemTempDataRK26ParticleSystemRendererData: __ZN22ParticleSystemRenderer24PrepareForRenderThreadedERK32ParticleSystemGeometryJobModulesR31ParticleSystemParticlesTempDataP23ParticleSystemParticlesR22ParticleSystemTempDataRK26ParticleSystemRendererData, __Z66Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimev: __Z66Register_UnityEngine_ParticleSystem_EmissionModule_SetRateOverTimev, __Z20TexelCoordSolidAngleiffi: __Z20TexelCoordSolidAngleiffi, __ZN11AudioSource25UnbindFromChannelInstanceERK7WeakPtrI20SoundChannelInstanceE: __ZN11AudioSource25UnbindFromChannelInstanceERK7WeakPtrI20SoundChannelInstanceE, __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_: __ZNSt3__27__sort3IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_T_, __Z67Register_UnityEngine_ParticleSystem_LightsModule_SetRangeMultiplierv: __Z67Register_UnityEngine_ParticleSystem_LightsModule_SetRangeMultiplierv, __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE6narrowEcc: __ZNKSt3__29basic_iosIcNS_11char_traitsIcEEE6narrowEcc, __ZN17UniqueIDGenerator9DestroyIDE13UniqueSmallID: __ZN17UniqueIDGenerator9DestroyIDE13UniqueSmallID, __Z26Light_Set_Custom_PropFlareP12Il2CppObjectS0_: __Z26Light_Set_Custom_PropFlareP12Il2CppObjectS0_, __ZN12GUIClipState24SetAbsoluteMousePositionERK8Vector2f: __ZN12GUIClipState24SetAbsoluteMousePositionERK8Vector2f, __Z40Register_UnityEngine_Cubemap_SmoothEdgesv: __Z40Register_UnityEngine_Cubemap_SmoothEdgesv, __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_18PxArticulationLinkENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __GLOBAL__sub_I_SamplerManager_cpp: __GLOBAL__sub_I_SamplerManager_cpp, __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv: __ZN25MinMaxOptimizedPolyCurves15DoubleIntegrateEv, __ZN9GfxDevice15CreateTextureIDEv: __ZN9GfxDevice15CreateTextureIDEv, _pread: _pread, __ZNKSt3__210moneypunctIwLb1EE10neg_formatEv: __ZNKSt3__210moneypunctIwLb1EE10neg_formatEv, __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue11ResetValuesEv: __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue11ResetValuesEv, __Z59Register_UnityEngine_Component_GetComponentsForListInternalv: __Z59Register_UnityEngine_Component_GetComponentsForListInternalv, __ZN5physx2Sc5Scene13addConstraintERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_: __ZN5physx2Sc5Scene13addConstraintERNS0_14ConstraintCoreEPNS0_9RigidCoreES5_, __ZN5physx34PxVehicleClutchDataGeneratedValuesC2EPKNS_19PxVehicleClutchDataE: __ZN5physx34PxVehicleClutchDataGeneratedValuesC2EPKNS_19PxVehicleClutchDataE, __Z46SystemInfo_Get_Custom_PropSupportsImageEffectsv: __Z46SystemInfo_Get_Custom_PropSupportsImageEffectsv, __ZNK5physx3Ext13RevoluteJoint8getAngleEv: __ZNK5physx3Ext13RevoluteJoint8getAngleEv, __Z50NavMeshObstacle_Set_Custom_PropCarveOnlyStationaryP12Il2CppObjecth: __Z50NavMeshObstacle_Set_Custom_PropCarveOnlyStationaryP12Il2CppObjecth, __ZN27LightProbeProxyVolumeSample10InvalidateEv: __ZN27LightProbeProxyVolumeSample10InvalidateEv, __Z53ParticleSystem_CollisionModule_CUSTOM_SetCollidesWithP12Il2CppObjecti: __Z53ParticleSystem_CollisionModule_CUSTOM_SetCollidesWithP12Il2CppObjecti, __ZN11AudioSource19UpdateLowpassFilterEf: __ZN11AudioSource19UpdateLowpassFilterEf, __ZL12ShadowMapJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE: __ZL12ShadowMapJobPN21GfxDeviceAsyncCommand10ArgScratchEPKNS_3ArgE, __ZN14CachingManager10SetEnabledEb: __ZN14CachingManager10SetEnabledEb, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu11HeightFieldES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveTypeR9GfxBuffer15ComputeBufferIDj: __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveTypeR9GfxBuffer15ComputeBufferIDj, __Z81Register_UnityEngine_SceneManagement_SceneManager_LoadSceneAsyncNameIndexInternalv: __Z81Register_UnityEngine_SceneManagement_SceneManager_LoadSceneAsyncNameIndexInternalv, __ZNK5physx2Sc15ClothFabricCore12getNbTethersEv: __ZNK5physx2Sc15ClothFabricCore12getNbTethersEv, __ZN10TagManager5ResetEv: __ZN10TagManager5ResetEv, __ZN14PreloadManager22ProcessSingleOperationEv: __ZN14PreloadManager22ProcessSingleOperationEv, __ZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEj: __ZNK5physx2Sq10AABBPruner9visualizeERNS_2Cm12RenderOutputEj, __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputWeightInternalv: __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetInputWeightInternalv, __ZN17ProceduralTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17ProceduralTexture23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN7mecanim12statemachine20StateMachineConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim12statemachine20StateMachineConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z13RegisterClassIN5Unity17ConfigurableJointEEvv: __Z13RegisterClassIN5Unity17ConfigurableJointEEvv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE8pushNameEPKc, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE23__do_get_floating_pointIeEES4_S4_S4_RNS_8ios_baseERjRT_, ___rem_pio2f: ___rem_pio2f, __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireMeshv: __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireMeshv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _self_destruct: _self_destruct, __ZNSt3__211__stdoutbufIwE4syncEv: __ZNSt3__211__stdoutbufIwE4syncEv, __ZN9Projector8TransferI14SafeBinaryReadEEvRT_: __ZN9Projector8TransferI14SafeBinaryReadEEvRT_, __ZZN19CharacterController15InitializeClassEvEN35FunctorImpl_589kAnimatorMoveBuiltin4CallEPviR11MessageData: __ZZN19CharacterController15InitializeClassEvEN35FunctorImpl_589kAnimatorMoveBuiltin4CallEPviR11MessageData, __ZNK5physx2Sq8AABBTree12computeDepthEv: __ZNK5physx2Sq8AABBTree12computeDepthEv, __ZN6Avatar23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN6Avatar23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z41getPxArticulation_MaxProjectionIterationsPKN5physx14PxArticulationE: __Z41getPxArticulation_MaxProjectionIterationsPKN5physx14PxArticulationE, __ZNK15b2RevoluteJoint13GetLowerLimitEv: __ZNK15b2RevoluteJoint13GetLowerLimitEv, __Z24RegisterStrippedTypeInfoI8RendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI8RendererEviPKcS2_, _tlsf_overhead: _tlsf_overhead, __ZN5Umbra4Math3expENS_5FloatE: __ZN5Umbra4Math3expENS_5FloatE, __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_: __ZNSt3__26__sortIR17DetailNodeXSorterP16DetailMeshBVNodeEEvT0_S5_T_, __Z23DestroyMutexLockedStackP16MutexLockedStack: __Z23DestroyMutexLockedStackP16MutexLockedStack, __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8UnityStrNS0_9allocatorIS2_EEEEEvRT_j, __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD1Ev: __ZThn4_N11UnityEngine15CloudWebService14DataDispatcherD1Ev, __Z33Canvas_Get_Custom_PropRenderOrderP12Il2CppObject: __Z33Canvas_Get_Custom_PropRenderOrderP12Il2CppObject, _j0f: _j0f, __ZN5physx18PxcGetMaterialMeshEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx18PxcGetMaterialMeshEPKNS_12PxsShapeCoreEjRNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI10RaycastHitNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, _exp2: _exp2, __ZNK17FileSystemHandler12LastModifiedERK13FileEntryData: __ZNK17FileSystemHandler12LastModifiedERK13FileEntryData, __Z41WWW_CUSTOM_enforceWebSecurityRestrictionsP12Il2CppObject: __Z41WWW_CUSTOM_enforceWebSecurityRestrictionsP12Il2CppObject, __ZNK5physx2Sc5Scene18hasParticleSystemsEv: __ZNK5physx2Sc5Scene18hasParticleSystemsEv, __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_16PxSphericalJointEED0Ev, __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessIN12_GLOBAL__N_19BatchItemES3_EEPS3_EEvT0_S7_T_, __Z39Register_UnityEngine_JsonUtility_ToJsonv: __Z39Register_UnityEngine_JsonUtility_ToJsonv, __ZN15ReflectionProbeD0Ev: __ZN15ReflectionProbeD0Ev, __Z47Register_UnityEngine_Cloth_get_bendingStiffnessv: __Z47Register_UnityEngine_Cloth_get_bendingStiffnessv, __ZN5physx2Gu13RTreeMidphase15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Gu13RTreeMidphase15importExtraDataERNS_24PxDeserializationContextE, __Z56Register_UnityEngine_DistanceJoint2D_get_maxDistanceOnlyv: __Z56Register_UnityEngine_DistanceJoint2D_get_maxDistanceOnlyv, __ZNK5physx17PxVehicleTireData7isValidEv: __ZNK5physx17PxVehicleTireData7isValidEv, __Z13RegisterClassI16LightmapSettingsEvv: __Z13RegisterClassI16LightmapSettingsEvv, __ZN5physx27solveContactPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx27solveContactPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, _UNITY_FT_Init_Class_tt_cmap14_class_rec: _UNITY_FT_Init_Class_tt_cmap14_class_rec, __ZN8Animator8SetSpeedEf: __ZN8Animator8SetSpeedEf, __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorI4PPtrI9Texture2DENS_9allocatorIS3_EEE8__appendEj, __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb: __ZN13WebCamTexture14GetDeviceNamesERNSt3__26vectorI16MonoWebCamDevice13stl_allocatorIS2_L18MemLabelIdentifier56ELi16EEEEb, __ZN6SpriteD0Ev: __ZN6SpriteD0Ev, __Z33WWW_Get_Custom_PropUploadProgressP12Il2CppObject: __Z33WWW_Get_Custom_PropUploadProgressP12Il2CppObject, __ZN10AudioMixer8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10AudioMixer8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z26MonoGUIContentToTempNativeP12Il2CppObject: __Z26MonoGUIContentToTempNativeP12Il2CppObject, __ZNK5physx5cloth8SwSolver10beginFrameEv: __ZNK5physx5cloth8SwSolver10beginFrameEv, __ZN5physx6shdfnd5ArrayIPNS_2Sn7XmlNodeENS_7profile26WrapperReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sn7XmlNodeENS_7profile26WrapperReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZNSt3__28ios_base16__call_callbacksENS0_5eventE: __ZNSt3__28ios_base16__call_callbacksENS0_5eventE, __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI10RectOffsetE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN5Umbra15StartCellFinder14findStartCellsENS_12PortalCuller4TileEPKNS_7ImpTileE: __ZN5Umbra15StartCellFinder14findStartCellsENS_12PortalCuller4TileEPKNS_7ImpTileE, __Z42TerrainData_CUSTOM_Internal_SetDetailLayerP12Il2CppObjectiiiiiP11Il2CppArray: __Z42TerrainData_CUSTOM_Internal_SetDetailLayerP12Il2CppObjectiiiiiP11Il2CppArray, __Z42AudioReverbZone_Get_Custom_PropMaxDistanceP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropMaxDistanceP12Il2CppObject, __ZNK8GUIStyle10RenderTextERK5RectTIfERN13TextRendering17TextMeshGeneratorE10ColorRGBAf: __ZNK8GUIStyle10RenderTextERK5RectTIfERN13TextRendering17TextMeshGeneratorE10ColorRGBAf, __ZNK5Unity10FixedJoint26GetTypeInfoVirtualInternalEv: __ZNK5Unity10FixedJoint26GetTypeInfoVirtualInternalEv, __ZZL32InitializeModule_ParticlesLegacyvEN59PostLateUpdateParticlesLegacyUpdateAllParticleSystemsstruct7ForwardEv: __ZZL32InitializeModule_ParticlesLegacyvEN59PostLateUpdateParticlesLegacyUpdateAllParticleSystemsstruct7ForwardEv, __ZN19CharacterController5ResetEv: __ZN19CharacterController5ResetEv, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E15insert_noresizeERKS7_: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E15insert_noresizeERKS7_, __Z41Register_UnityEngine_Cloth_set_useGravityv: __Z41Register_UnityEngine_Cloth_set_useGravityv, __ZN2UI20GetDefaultUIMaterialEv: __ZN2UI20GetDefaultUIMaterialEv, __ZN11LightProbes21ZeroBakedCoefficientsEv: __ZN11LightProbes21ZeroBakedCoefficientsEv, __Z40getPxArticulationJoint_TangentialDampingPKN5physx19PxArticulationJointE: __Z40getPxArticulationJoint_TangentialDampingPKN5physx19PxArticulationJointE, __ZN15CollisionModuleD2Ev: __ZN15CollisionModuleD2Ev, __ZN11HaloManager4HaloC2Ei: __ZN11HaloManager4HaloC2Ei, __Z20UnloadDynamicLibraryPv: __Z20UnloadDynamicLibraryPv, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetXMultiplierv, __ZN21ComponentRequirements16StaticInitializeEPv: __ZN21ComponentRequirements16StaticInitializeEPv, __Z34getPxScene_VisualizationCullingBoxPKN5physx7PxSceneE: __Z34getPxScene_VisualizationCullingBoxPKN5physx7PxSceneE, __Z52Register_UnityEngine_GUI_InternalRepaintEditorWindowv: __Z52Register_UnityEngine_GUI_InternalRepaintEditorWindowv, __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE6RemoveES4_: __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE6RemoveES4_, __ZN5physx7NpScene18releaseVolumeCacheEPNS_13NpVolumeCacheE: __ZN5physx7NpScene18releaseVolumeCacheEPNS_13NpVolumeCacheE, __ZN5Umbra15KDTraverseStackIiE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbii: __ZN5Umbra15KDTraverseStackIiE12pushChildrenILb1EEEvNS_15KDTraverseEntryEfbii, __ZN9Projector23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Projector23VirtualRedirectTransferER17RemapPPtrTransfer, __Z70Register_UnityEngine_DrivenRectTransformTracker_CanRecordModificationsv: __Z70Register_UnityEngine_DrivenRectTransformTracker_CanRecordModificationsv, __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv: __ZNK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv, __ZN16DeveloperConsole7SetOpenEb: __ZN16DeveloperConsole7SetOpenEb, __Z50Register_UnityEngine_HingeJoint_INTERNAL_get_motorv: __Z50Register_UnityEngine_HingeJoint_INTERNAL_get_motorv, __Z24RegisterModule_Animationv: __Z24RegisterModule_Animationv, __ZN6Object39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN6Object39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN14InputInterface11PerformDragER10InputEvent: __ZN14InputInterface11PerformDragER10InputEvent, __ZNK2UI14CanvasRenderer26GetTypeInfoVirtualInternalEv: __ZNK2UI14CanvasRenderer26GetTypeInfoVirtualInternalEv, __Z39HingeJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP18JointAngleLimits2D: __Z39HingeJoint2D_CUSTOM_INTERNAL_get_limitsP12Il2CppObjectP18JointAngleLimits2D, __ZN12SoundManager6UpdateEv: __ZN12SoundManager6UpdateEv, __ZN11UnityEngine15CloudWebService18CloudServiceConfigaSERKS1_: __ZN11UnityEngine15CloudWebService18CloudServiceConfigaSERKS1_, __ZN5physx2Sc15ArticulationSim14internalWakeUpEf: __ZN5physx2Sc15ArticulationSim14internalWakeUpEf, __ZN5physx9NpPhysics17sendMaterialTableERNS_7NpSceneE: __ZN5physx9NpPhysics17sendMaterialTableERNS_7NpSceneE, __ZN19AssetBundleManifest22CollectAllDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE: __ZN19AssetBundleManifest22CollectAllDependenciesERK8UnityStrRNSt3__26vectorIS0_NS3_9allocatorIS0_EEEE, __ZN6Avatar13AwakeFromLoadE17AwakeFromLoadMode: __ZN6Avatar13AwakeFromLoadE17AwakeFromLoadMode, _setuid: _setuid, __ZN4FMOD7SystemI17getNumCDROMDrivesEPi: __ZN4FMOD7SystemI17getNumCDROMDrivesEPi, __Z29setPxCloth_LinearInertiaScalePN5physx7PxClothENS_6PxVec3E: __Z29setPxCloth_LinearInertiaScalePN5physx7PxClothENS_6PxVec3E, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEtEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z55Register_UnityEngine_Animation_get_animateOnlyIfVisiblev: __Z55Register_UnityEngine_Animation_get_animateOnlyIfVisiblev, __ZN10VertexDataC2ERKS_jRK19VertexStreamsLayoutRK20VertexChannelsLayout: __ZN10VertexDataC2ERKS_jRK19VertexStreamsLayoutRK20VertexChannelsLayout, __ZN11MinMaxCurveC2Ev: __ZN11MinMaxCurveC2Ev, __GLOBAL__sub_I_runtime_plugininterface_lump_cpp: __GLOBAL__sub_I_runtime_plugininterface_lump_cpp, __ZNK11AudioSource24GetBypassListenerEffectsEv: __ZNK11AudioSource24GetBypassListenerEffectsEv, __ZN8Collider22GetPositionAndRotationERK9TransformR10Matrix4x4f: __ZN8Collider22GetPositionAndRotationERK9TransformR10Matrix4x4f, _gray_line_to: _gray_line_to, _strcpy: _strcpy, __ZN5physx14PxRigidBodyExt19linearSweepMultipleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEPNS_10PxSweepHitEPjjRSC_RiRbRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf: __ZN5physx14PxRigidBodyExt19linearSweepMultipleERNS_11PxRigidBodyERNS_7PxSceneERKNS_6PxVec3EfNS_7PxFlagsINS_9PxHitFlag4EnumEtEEPNS_10PxSweepHitEPjjRSC_RiRbRKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf, _setpgid: _setpgid, __ZN5physx8debugger14PvdMarshallingIxdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIxdE12marshalBlockEPKhPhj, __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_: __ZNSt3__26__sortIRNS_6__lessI11KeyframeTplIfES3_EEPS3_EEvT0_S7_T_, __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI5RectTIfELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId, __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj: __ZNK5physx22PxVehicleWheelsSimData22getSuspTravelDirectionEj, __Z21sweepConvex_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z21sweepConvex_PlaneGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN2UI29MarkParentCanvasDirtyAsNeededEPNS_6CanvasE: __ZN2UI29MarkParentCanvasDirtyAsNeededEPNS_6CanvasE, __ZN11UnityEngine7Connect15AppInstallEventD0Ev: __ZN11UnityEngine7Connect15AppInstallEventD0Ev, __ZN14PlayerSettings18SetSubmitAnalyticsEb: __ZN14PlayerSettings18SetSubmitAnalyticsEb, __ZN5physx3Cct26CharacterControllerManager16setPreciseSweepsEb: __ZN5physx3Cct26CharacterControllerManager16setPreciseSweepsEb, __Z25SetNbModifiedContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j: __Z25SetNbModifiedContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j, __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE5eraseENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_PvEEiEE: __ZNSt3__26__treeINS_12__value_typeIiN14NavMeshManager9LayerDataEEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE5eraseENS_21__tree_const_iteratorIS4_PNS_11__tree_nodeIS4_PvEEiEE, __ZN17AnimationPlayable16DestroyRecursiveERN7mecanim6memory16MecanimAllocatorE: __ZN17AnimationPlayable16DestroyRecursiveERN7mecanim6memory16MecanimAllocatorE, __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11UnityEngine9Animation14GenericBinding8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN17AudioChorusFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN17AudioChorusFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj578ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj578ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_SetStartSizeZP12Il2CppObjectR15MonoMinMaxCurve, __Z58Register_UnityEngine_Screen_set_autorotateToLandscapeRightv: __Z58Register_UnityEngine_Screen_set_autorotateToLandscapeRightv, __Z50Register_UnityEngine_GameObject_INTERNAL_get_scenev: __Z50Register_UnityEngine_GameObject_INTERNAL_get_scenev, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE, __ZN5physx2Gu22intersectCapsuleConvexERKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E: __ZN5physx2Gu22intersectCapsuleConvexERKNS_17PxCapsuleGeometryERKNS_11PxTransformERKNS0_10ConvexMeshERKNS_11PxMeshScaleES6_PNS_6PxVec3E, __ZL21PxcGenerateVFContactsRN5physx2Gu13ContactBufferERKNS0_7SegmentEfRKNS0_3BoxERKNS_6PxVec3Ef: __ZL21PxcGenerateVFContactsRN5physx2Gu13ContactBufferERKNS0_7SegmentEfRKNS0_3BoxERKNS_6PxVec3Ef, __ZNK6Camera26GetStereoWorldToClipMatrixE15StereoscopicEye: __ZNK6Camera26GetStereoWorldToClipMatrixE15StereoscopicEye, __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z24GetLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNK5physx2Gu11HeightField25getTriangleNormalInternalEj: __ZNK5physx2Gu11HeightField25getTriangleNormalInternalEj, __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKPositionInternalv: __Z65Register_UnityEngine_Animator_INTERNAL_CALL_GetIKPositionInternalv, __ZN15MulticastSocketD0Ev: __ZN15MulticastSocketD0Ev, __ZN8Gradient16SetConstantColorE11ColorRGBA32: __ZN8Gradient16SetConstantColorE11ColorRGBA32, __Z29StdTemplateConversionFunctionIahEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIahEbPvR14SafeBinaryRead, __ZN17GeneralConnection10Connection14ReceiveMessageEPNS_14NetworkMessageE: __ZN17GeneralConnection10Connection14ReceiveMessageEPNS_14NetworkMessageE, __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb: __ZN5physx2Sc5Scene20removeParticleSystemERNS0_18ParticleSystemCoreEb, __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI4MeshE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15CollisionModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf: __ZN15CollisionModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf, __ZN5physx27partitionContactConstraintsERNS_23ConstraintPartitionArgsE: __ZN5physx27partitionContactConstraintsERNS_23ConstraintPartitionArgsE, __ZN5physx2Sc9ClothCore10putToSleepEv: __ZN5physx2Sc9ClothCore10putToSleepEv, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekposENS_4fposI11__mbstate_tEEj: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE10pubseekposENS_4fposI11__mbstate_tEEj, __ZN5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE: __ZN5physx7profile30PxProfileMemoryEventBufferImpl12removeClientERNS_26PxProfileEventBufferClientE, __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetMinVertexDistancev: __Z68Register_UnityEngine_ParticleSystem_TrailModule_SetMinVertexDistancev, __ZN15QualitySettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15QualitySettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11UnityEngine7Connect15DeviceInfoEventC2ERK8UnityStrb: __ZN11UnityEngine7Connect15DeviceInfoEventC2ERK8UnityStrb, __ZN5simdi5arrayER8Scalar4f: __ZN5simdi5arrayER8Scalar4f, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__is_longEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE9__is_longEv, __Z24RegisterStrippedTypeInfoI4HaloEviPKcS2_: __Z24RegisterStrippedTypeInfoI4HaloEviPKcS2_, __ZN7mecanim8skeleton25Skeleton2BoneAdjustLengthEPKNS0_8SkeletonEiiiRKN4math7_float3ERKfPNS0_13SkeletonPoseTINS4_4trsXEEESD_: __ZN7mecanim8skeleton25Skeleton2BoneAdjustLengthEPKNS0_8SkeletonEiiiRKN4math7_float3ERKfPNS0_13SkeletonPoseTINS4_4trsXEEESD_, _wcpcpy: _wcpcpy, __ZN4FMOD12ChannelGroup9setPausedEb: __ZN4FMOD12ChannelGroup9setPausedEb, __Z37HingeJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject: __Z37HingeJoint2D_Get_Custom_PropUseLimitsP12Il2CppObject, __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13OcclusionArea23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN11TrailModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11TrailModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN12InputManager5ResetEv: __ZN12InputManager5ResetEv, __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc: __ZL31DeleteLastPathNameComponentImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPKc, __Z33Gizmos_CUSTOM_INTERNAL_set_matrixRK10Matrix4x4f: __Z33Gizmos_CUSTOM_INTERNAL_set_matrixRK10Matrix4x4f, __Z45Register_UnityEngine_AndroidJNI_SetFloatFieldv: __Z45Register_UnityEngine_AndroidJNI_SetFloatFieldv, __ZN5physx3Ext19ProfileEventHandler14findCollectionEj: __ZN5physx3Ext19ProfileEventHandler14findCollectionEj, __ZNK32RendererMaterialAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK32RendererMaterialAnimationBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, _setresgid: _setresgid, __ZN8WindZone8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8WindZone8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi16EEENS0_19ReflectionAllocatorIS4_EEE15disposeElementsEv, __Z35Mesh_CUSTOM_GetBlendShapeFrameCountP12Il2CppObjecti: __Z35Mesh_CUSTOM_GetBlendShapeFrameCountP12Il2CppObjecti, __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib: __ZNK10__cxxabiv122__base_class_type_info16search_above_dstEPNS_19__dynamic_cast_infoEPKvS4_ib, __ZThn4_N5physx5cloth8SwFabricD1Ev: __ZThn4_N5physx5cloth8SwFabricD1Ev, __ZN7mecanim25ValueArrayCopyInverseMaskEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE: __ZN7mecanim25ValueArrayCopyInverseMaskEPKNS_10ValueArrayEPS0_PKNS_14ValueArrayMaskE, __ZN7Striper7ComputeER13STRIPERRESULT: __ZN7Striper7ComputeER13STRIPERRESULT, __ZNK9dtNavMesh25getTileAndPolyByRefUnsafeEyPPK10dtMeshTilePPK6dtPoly: __ZNK9dtNavMesh25getTileAndPolyByRefUnsafeEyPPK10dtMeshTilePPK6dtPoly, __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_2Cm8Matrix34E: __ZN5physx2Gu5Debug16convertToPxMat44ERKNS_2Cm8Matrix34E, __ZN19ConstantBuffersGLESC2Ev: __ZN19ConstantBuffersGLESC2Ev, __Z16NotifyPlayerQuitb: __Z16NotifyPlayerQuitb, __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity5Joint22JointTransferPreNoAxisI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sc5Scene14updateDynamicsEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene14updateDynamicsEPNS_10PxBaseTaskE, __Z38scripting_profiler_install_enter_leavePFvPvPK10MethodInfoES4_: __Z38scripting_profiler_install_enter_leavePFvPvPK10MethodInfoES4_, __Z26Material_CUSTOM_GetTextureP12Il2CppObjecti: __Z26Material_CUSTOM_GetTextureP12Il2CppObjecti, __ZN5Umbra15GateStateVectorC2EPvjb: __ZN5Umbra15GateStateVectorC2EPvjb, __ZN2UI6Canvas16SetPlaneDistanceEf: __ZN2UI6Canvas16SetPlaneDistanceEf, __Z15printf_consolev7LogTypePKcPi: __Z15printf_consolev7LogTypePKcPi, _UNITY_png_crc_read: _UNITY_png_crc_read, __ZN10MonoScript7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10MonoScript7PRODUCEE10MemLabelId18ObjectCreationMode, __Z67Register_UnityEngine_Networking_UnityWebRequest_get_chunkedTransferv: __Z67Register_UnityEngine_Networking_UnityWebRequest_get_chunkedTransferv, __ZN19ShaderPropertySheet30SetTextureWithNoScaleAndOffsetERKN9ShaderLab16FastPropertyNameEP7Texture: __ZN19ShaderPropertySheet30SetTextureWithNoScaleAndOffsetERKN9ShaderLab16FastPropertyNameEP7Texture, __Z44Register_UnityEngine_HumanTrait_get_BoneNamev: __Z44Register_UnityEngine_HumanTrait_get_BoneNamev, __Z40ParticleSystem_ShapeModule_CUSTOM_SetArcP12Il2CppObjectf: __Z40ParticleSystem_ShapeModule_CUSTOM_SetArcP12Il2CppObjectf, __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj: __ZNSt3__26vectorI4PPtrI6ShaderE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE8__appendEj, __Z46Register_UnityEngine_Terrain_get_drawHeightmapv: __Z46Register_UnityEngine_Terrain_get_drawHeightmapv, __Z46Register_UnityEngine_Joint2D_set_connectedBodyv: __Z46Register_UnityEngine_Joint2D_set_connectedBodyv, __ZN4crnd17crnd_unpack_beginEPKvj: __ZN4crnd17crnd_unpack_beginEPKvj, __ZN11TypeManager27FatalErrorOnClassIDConflictEiPKc: __ZN11TypeManager27FatalErrorOnClassIDConflictEiPKc, _UNITY_png_malloc: _UNITY_png_malloc, __Z32CanvasGroup_Set_Custom_PropAlphaP12Il2CppObjectf: __Z32CanvasGroup_Set_Custom_PropAlphaP12Il2CppObjectf, __Z50Register_UnityEngine_ConfigurableJoint_set_yMotionv: __Z50Register_UnityEngine_ConfigurableJoint_set_yMotionv, __Z38NavMeshAgent_Get_Custom_PropAutoRepathP12Il2CppObject: __Z38NavMeshAgent_Get_Custom_PropAutoRepathP12Il2CppObject, _sfnt_get_ps_name: _sfnt_get_ps_name, __ZN13GfxDeviceGLES15UpdateSRGBWriteEv: __ZN13GfxDeviceGLES15UpdateSRGBWriteEv, __ZNSt3__26vectorI4PPtrI6ObjectENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorI4PPtrI6ObjectENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayIiLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN11DynamicMesh21RemoveDegenerateEdgesEv: __ZN11DynamicMesh21RemoveDegenerateEdgesEv, __ZN8Animator13ClearPlayableEv: __ZN8Animator13ClearPlayableEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE12__get_minuteERiRS4_S4_RjRKNS_5ctypeIwEE, __ZN4FMOD5Sound13getLoopPointsEPjjS1_j: __ZN4FMOD5Sound13getLoopPointsEPjjS1_j, __Z55QualitySettings_Set_Custom_PropRealtimeReflectionProbesh: __Z55QualitySettings_Set_Custom_PropRealtimeReflectionProbesh, __Z42Register_UnityEngine_Camera_set_cameraTypev: __Z42Register_UnityEngine_Camera_set_cameraTypev, __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType: __ZNK13TranslateGLES8TopologyE16GfxPrimitiveType, __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE: __ZN5physx22PxcArticulationFnsSimdINS_26PxcArticulationFnsSimdBaseEE17propagateVelocityERKNS_8PxcFsRowERKNS_17PxcFsJointVectorsERKNS_6shdfnd3aos5Vec3VERKNS_14PxcSIMDSpatialERKNS_11PxcFsRowAuxE, __Z50Register_UnityEngine_GUIUtility_get_hasModalWindowv: __Z50Register_UnityEngine_GUIUtility_get_hasModalWindowv, __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD0Ev: __ZN12_GLOBAL__N_143SphereMeshContactGenerationCallback_NoScaleD0Ev, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE17getEventIdForNameEPKc, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE26__invalidate_all_iteratorsEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE26__invalidate_all_iteratorsEv, __Z34Register_UnityEngine_Time_get_timev: __Z34Register_UnityEngine_Time_get_timev, __Z12ReadFromFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvyj: __Z12ReadFromFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvyj, __Z46Register_UnityEngine_Time_set_captureFrameratev: __Z46Register_UnityEngine_Time_set_captureFrameratev, __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j: __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j, __ZN9GfxDevice16SetRenderTargetsERK20GfxRenderTargetSetup: __ZN9GfxDevice16SetRenderTargetsERK20GfxRenderTargetSetup, __ZN13GfxDeviceGLES23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer: __ZN13GfxDeviceGLES23DeleteGPUSkinPoseBufferEP17GPUSkinPoseBuffer, __ZN5Umbra20RuntimeStructBuilderC2Ev: __ZN5Umbra20RuntimeStructBuilderC2Ev, __ZN5physx2Sc9ShapeCoreD2Ev: __ZN5physx2Sc9ShapeCoreD2Ev, __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_10MemLabelId17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_10MemLabelId17TransferMetaFlags, __ZN15CacheReaderBase18GetAddressOfMemoryEv: __ZN15CacheReaderBase18GetAddressOfMemoryEv, __ZN5physx7Cooking18createTriangleMeshERKNS_18PxTriangleMeshDescERNS_26PxPhysicsInsertionCallbackE: __ZN5physx7Cooking18createTriangleMeshERKNS_18PxTriangleMeshDescERNS_26PxPhysicsInsertionCallbackE, __ZN10MeshFilter15InitializeClassEv: __ZN10MeshFilter15InitializeClassEv, _vscanf: _vscanf, __Z37ShaderVariantCollection_CUSTOM_WarmUpP12Il2CppObject: __Z37ShaderVariantCollection_CUSTOM_WarmUpP12Il2CppObject, __Z20CreateObjectFromCodeI10GameObjectEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI10GameObjectEPT_17AwakeFromLoadMode10MemLabelId, _popen: _popen, __ZN8b2Island6ReportEPK27b2ContactVelocityConstraint: __ZN8b2Island6ReportEPK27b2ContactVelocityConstraint, __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_12NpConstraintENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __Z48ParticleSystem_CollisionModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z48ParticleSystem_CollisionModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z40Register_UnityEngine_MeshFilter_set_meshv: __Z40Register_UnityEngine_MeshFilter_set_meshv, __ZN13MemoryManager18LowLevelReallocateEPvjj: __ZN13MemoryManager18LowLevelReallocateEPvjj, __ZN10MeshFilter15ThreadedCleanupEv: __ZN10MeshFilter15ThreadedCleanupEv, __Z34MeshCollider_Set_Custom_PropConvexP12Il2CppObjecth: __Z34MeshCollider_Set_Custom_PropConvexP12Il2CppObjecth, __ZN5physx15PxCollectionExt16createCollectionERNS_7PxSceneE: __ZN5physx15PxCollectionExt16createCollectionERNS_7PxSceneE, __ZN13BitSetUtility17GetNumberOfBlocksEj: __ZN13BitSetUtility17GetNumberOfBlocksEj, __ZN18UnityPropertySheet8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18UnityPropertySheet8TransferI24GenerateTypeTreeTransferEEvRT_, __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_: __Z13runNpBatchPPUPN5physx18PxcNpThreadContextEPNS_15PxcNpBatchEntryEjjPjjRjS5_, __ZN5physx8debugger4comm20StreamPropMessageArg9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm20StreamPropMessageArg9serializeERNS1_15EventSerializerE, __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17ProceduralTexture23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity11SpringJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _pause: _pause, __Z55ScriptableObject_CUSTOM_Internal_CreateScriptableObjectP12Il2CppObject: __Z55ScriptableObject_CUSTOM_Internal_CreateScriptableObjectP12Il2CppObject, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestitutionEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestitutionEf, __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4pptrEv: __ZNKSt3__215basic_streambufIcNS_11char_traitsIcEEE4pptrEv, __ZN5physx2Sq11PruningPool9addObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE: __ZN5physx2Sq11PruningPool9addObjectERKNS_9PxBounds3ERKNS0_13PrunerPayloadE, __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEED2Ev, __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE: __ZN13Simd4fFactoryIN6detail9FourTupleEEC2ERKS_IRKfE, __Z49setPxVehicleWheelsSimData_SuspForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E: __Z49setPxVehicleWheelsSimData_SuspForceAppPointOffsetPN5physx22PxVehicleWheelsSimDataEjNS_6PxVec3E, __ZThn8_NK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E: __ZThn8_NK5physx3Cct17CapsuleController11getWorldBoxERNS_17PxExtendedBounds3E, __ZNSt12out_of_rangeD0Ev: __ZNSt12out_of_rangeD0Ev, __ZN15LightProbeGroupC2E10MemLabelId18ObjectCreationMode: __ZN15LightProbeGroupC2E10MemLabelId18ObjectCreationMode, __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_set_slerpDrivev: __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_set_slerpDrivev, _UNITY_TT_Set_CodeRange: _UNITY_TT_Set_CodeRange, __ZN9Rigidbody21UpdateKinematicTargetERKN5physx11PxTransformE: __ZN9Rigidbody21UpdateKinematicTargetERKN5physx11PxTransformE, __ZN5physx22getEdgeTriangleIndicesERKNS_2Gu11HeightFieldERKNS_8EdgeDataEPj: __ZN5physx22getEdgeTriangleIndicesERKNS_2Gu11HeightFieldERKNS_8EdgeDataEPj, __Z59Register_UnityEngine_ShaderVariantCollection_RemoveInternalv: __Z59Register_UnityEngine_ShaderVariantCollection_RemoveInternalv, __Z18getPxActorUserDataPKN5physx7PxActorE: __Z18getPxActorUserDataPKN5physx7PxActorE, __Z34Screen_Set_Custom_PropSleepTimeouti: __Z34Screen_Set_Custom_PropSleepTimeouti, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E9set_valueEPSC_RKSC_, __ZN5physx6shdfnd12ErrorHandlerD2Ev: __ZN5physx6shdfnd12ErrorHandlerD2Ev, __ZN9GfxDeviceD2Ev: __ZN9GfxDeviceD2Ev, _iswpunct: _iswpunct, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsDynDataEEEE27handleExtendedIndexPropertyILj631ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z44Register_UnityEngine_LensFlare_set_fadeSpeedv: __Z44Register_UnityEngine_LensFlare_set_fadeSpeedv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN7mecanim4hand12HandCopyAxesEPKNS0_4HandEPKNS_8skeleton8SkeletonES3_PS5_: __ZN7mecanim4hand12HandCopyAxesEPKNS0_4HandEPKNS_8skeleton8SkeletonES3_PS5_, __Z46Register_UnityEngine_Material_IsKeywordEnabledv: __Z46Register_UnityEngine_Material_IsKeywordEnabledv, __Z43Cloth_Get_Custom_PropWorldAccelerationScaleP12Il2CppObject: __Z43Cloth_Get_Custom_PropWorldAccelerationScaleP12Il2CppObject, _expm1: _expm1, __ZN11AudioSource11AssignPropsEv: __ZN11AudioSource11AssignPropsEv, __Z45Register_UnityEngine_Application_get_isEditorv: __Z45Register_UnityEngine_Application_get_isEditorv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess: __Z23CurvesSupportProceduralRK21MinMaxAnimationCurvess, __ZN20BufferedSocketStream15WouldBlockErrorEv: __ZN20BufferedSocketStream15WouldBlockErrorEv, _log1pl: _log1pl, __ZN15ResourceManager19PreloadDependenciesEi: __ZN15ResourceManager19PreloadDependenciesEi, __ZNK18PlatformEffector2D21CalculateContactStateERN10Effector2D15EffectorContactE: __ZNK18PlatformEffector2D21CalculateContactStateERN10Effector2D15EffectorContactE, __ZNK19SkinnedMeshRenderer19GetBlendShapeWeightEj: __ZNK19SkinnedMeshRenderer19GetBlendShapeWeightEj, __ZN5physx2Sn18RepXCollectionImpl17addCollectionItemENS0_18RepXCollectionItemE: __ZN5physx2Sn18RepXCollectionImpl17addCollectionItemENS0_18RepXCollectionItemE, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_19NpArticulationJointEEEEEvPT_jRKT0_RKT1_j, __ZN13b2PulleyJoint23InitVelocityConstraintsERK12b2SolverData: __ZN13b2PulleyJoint23InitVelocityConstraintsERK12b2SolverData, __Z59Register_UnityEngine_Joint_get_autoConfigureConnectedAnchorv: __Z59Register_UnityEngine_Joint_get_autoConfigureConnectedAnchorv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7b2World11ClearForcesEv: __ZN7b2World11ClearForcesEv, __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD12ChannelGroup6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, _cf2_outline_reset: _cf2_outline_reset, __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectv: __Z55Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectv, __ZN5physx3Ext23DefaultBufferedProfiler30removeBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE: __ZN5physx3Ext23DefaultBufferedProfiler30removeBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE, _jpeg_fdct_ifast: _jpeg_fdct_ifast, __ZN12TreeRenderer6RenderER6CameraRKNSt3__26vectorIP5Light13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEfffii: __ZN12TreeRenderer6RenderER6CameraRKNSt3__26vectorIP5Light13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEfffii, __ZN8Animator20GetAnimatorStateNameEib: __ZN8Animator20GetAnimatorStateNameEib, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE8readsomeEPci: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE8readsomeEPci, __ZN7Terrain12AddToManagerEv: __ZN7Terrain12AddToManagerEv, __ZL31QueryPortalVisibilityCombineJobP28QueryPortalVisibilityJobData: __ZL31QueryPortalVisibilityCombineJobP28QueryPortalVisibilityJobData, __ZN17AnimationCurveTplI8Vector3fE15SetPostInfinityEi: __ZN17AnimationCurveTplI8Vector3fE15SetPostInfinityEi, __ZN22UnityWebRequestManager14BackendReleaseEv: __ZN22UnityWebRequestManager14BackendReleaseEv, __Z44CharacterController_Get_Custom_PropSkinWidthP12Il2CppObject: __Z44CharacterController_Get_Custom_PropSkinWidthP12Il2CppObject, __ZN18PlatformEffector2DD0Ev: __ZN18PlatformEffector2DD0Ev, __ZN6prcoreL10inner_flipILj1EEEvPhS1_j: __ZN6prcoreL10inner_flipILj1EEEvPhS1_j, __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth8SwTetherENS0_9AllocatorEE15growAndPushBackERKS3_, __Z10SetNbShapePN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumEj: __Z10SetNbShapePN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumEj, __ZN6Object23VirtualRedirectTransferER14SafeBinaryRead: __ZN6Object23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx7NpScene15addRigidDynamicERNS_14NpRigidDynamicE: __ZN5physx7NpScene15addRigidDynamicERNS_14NpRigidDynamicE, __ZNK5physx2Sc8ShapeSim8getRbSimEv: __ZNK5physx2Sc8ShapeSim8getRbSimEv, __Z52MonoBehaviour_CUSTOM_StopCoroutineViaEnumerator_AutoP12Il2CppObjectS0_: __Z52MonoBehaviour_CUSTOM_StopCoroutineViaEnumerator_AutoP12Il2CppObjectS0_, __ZNK5physx2Sc21ElementSimInteraction13getNPhaseCoreEv: __ZNK5physx2Sc21ElementSimInteraction13getNPhaseCoreEv, __Z42AudioReverbZone_Set_Custom_PropHFReferenceP12Il2CppObjectf: __Z42AudioReverbZone_Set_Custom_PropHFReferenceP12Il2CppObjectf, __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E: __ZNK8Gradient8EvaluateIL12GradientMode1EEEN4math4pix4ERKNS2_7_float4E, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv, __ZN13GfxDeviceGLES12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj: __ZN13GfxDeviceGLES12UpdateBufferEP9GfxBuffer13GfxBufferMode14GfxBufferLabeljPKvj, __ZN14PhysicsManager11FixedUpdateEv: __ZN14PhysicsManager11FixedUpdateEv, __ZN14PhysicMaterial18SetFrictionCombineEi: __ZN14PhysicMaterial18SetFrictionCombineEi, __ZN8LODGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8LODGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN14CachingManager28GetMaximumDiskSpaceAvailableEv: __ZN14CachingManager28GetMaximumDiskSpaceAvailableEv, __ZN22BuiltinResourceManager14RegisterShaderExPKcS1_b: __ZN22BuiltinResourceManager14RegisterShaderExPKcS1_b, __ZN12_GLOBAL__N_110DataStream23appendPropertyValueDataEN5physx8debugger7DataRefIKhEE: __ZN12_GLOBAL__N_110DataStream23appendPropertyValueDataEN5physx8debugger7DataRefIKhEE, __ZN9Transform40InstantiateTransformSubhierarchyInternalER18TransformHierarchyPPS_Pij: __ZN9Transform40InstantiateTransformSubhierarchyInternalER18TransformHierarchyPPS_Pij, __Z30getPxDistanceJoint_MinDistancePKN5physx15PxDistanceJointE: __Z30getPxDistanceJoint_MinDistancePKN5physx15PxDistanceJointE, __ZNK15ReflectionProbe23ConfiguredToAutoRefreshEv: __ZNK15ReflectionProbe23ConfiguredToAutoRefreshEv, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11postCCDPassEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx2Sc9ClothCore20addCollisionTriangleERKNS_24PxClothCollisionTriangleE: __ZN5physx2Sc9ClothCore20addCollisionTriangleERKNS_24PxClothCollisionTriangleE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE11__recommendEj, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE19onConstraintReleaseEv, __ZN5physx10PxsContext9updateCCDEfPNS_10PxBaseTaskEb: __ZN5physx10PxsContext9updateCCDEfPNS_10PxBaseTaskEb, __ZN5physx2Gu33pcmDistanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_: __ZN5physx2Gu33pcmDistanceSegmentSegmentSquared4ERKNS_6shdfnd3aos5Vec3VES5_S5_S5_S5_S5_S5_S5_S5_S5_RNS2_5Vec4VES7_, __Z24RegisterStrippedTypeInfoI18AudioMixerSnapshotEviPKcS2_: __Z24RegisterStrippedTypeInfoI18AudioMixerSnapshotEviPKcS2_, __ZN22UnityProfilerPerThread22SkipSampleRecurseIndexEj: __ZN22UnityProfilerPerThread22SkipSampleRecurseIndexEj, __ZN9Rigidbody17SetSleepThresholdEf: __ZN9Rigidbody17SetSleepThresholdEf, __ZNK15RelativeJoint2D16GetAngularOffsetEv: __ZNK15RelativeJoint2D16GetAngularOffsetEv, _UNITY_png_colorspace_sync: _UNITY_png_colorspace_sync, __ZNSt3__27codecvtIcc11__mbstate_tED0Ev: __ZNSt3__27codecvtIcc11__mbstate_tED0Ev, __Z79Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountInBuildSettingsv: __Z79Register_UnityEngine_SceneManagement_SceneManager_get_sceneCountInBuildSettingsv, __ZN12FileAccessor5WriteEyPKvPy: __ZN12FileAccessor5WriteEyPKvPy, __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEED2Ev: __ZN10ObjectPoolIN4FMOD12ChannelGroupENS0_13ChannelGroupIEED2Ev, __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_14NpRigidDynamicENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZN5physx10NpMaterial8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx10NpMaterial8requiresERNS_23PxProcessPxBaseCallbackE, __ZNK9ShaderLab4Pass21ComputePassValuesHashERK16ShaderKeywordSetPK19ShaderPropertySheetRK17ShaderPassContextP6Shader: __ZNK9ShaderLab4Pass21ComputePassValuesHashERK16ShaderKeywordSetPK19ShaderPropertySheetRK17ShaderPassContextP6Shader, __Z37Cubemap_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiiRK10ColorRGBAf: __Z37Cubemap_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiiRK10ColorRGBAf, __Z41Register_UnityEngine_JsonUtility_FromJsonv: __Z41Register_UnityEngine_JsonUtility_FromJsonv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj87ENS0_26PxPvdRangePropertyAccessorILj87ES4_jEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj87ENS0_26PxPvdRangePropertyAccessorILj87ES4_jEEEEvjRKT0_, __Z40Register_UnityEngine_WindZone_set_radiusv: __Z40Register_UnityEngine_WindZone_set_radiusv, __ZNK5physx7NpScene18getNbArticulationsEv: __ZNK5physx7NpScene18getNbArticulationsEv, __ZN17SurfaceEffector2D28UpdateFrictionBounceContactsEv: __ZN17SurfaceEffector2D28UpdateFrictionBounceContactsEv, __GLOBAL__sub_I_runtime_camera_lump_cpp: __GLOBAL__sub_I_runtime_camera_lump_cpp, __Z21CubemapGPUConvolutionP13RenderTextureS0_bijjb: __Z21CubemapGPUConvolutionP13RenderTextureS0_bijjb, __ZN5Umbra21UserCallbackAllocator8allocateEjPKc: __ZN5Umbra21UserCallbackAllocator8allocateEjPKc, __ZN5Umbra20ObjectDistanceParams16setDistanceScaleEf: __ZN5Umbra20ObjectDistanceParams16setDistanceScaleEf, __ZN5physx5cloth9SwFactoryD2Ev: __ZN5physx5cloth9SwFactoryD2Ev, __Z45getNbPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataE: __Z45getNbPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataE, __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf: __ZL13ClassifyCurveI8Vector3fE11ClipOptTypeR17AnimationCurveTplIT_Ebf, __Z42Register_UnityEngine_Font_GetCharacterInfov: __Z42Register_UnityEngine_Font_GetCharacterInfov, __ZN14StackAllocatorD2Ev: __ZN14StackAllocatorD2Ev, __Z36Cloth_Get_Custom_PropSolverFrequencyP12Il2CppObject: __Z36Cloth_Get_Custom_PropSolverFrequencyP12Il2CppObject, __Z29getPxRigidDynamic_WakeCounterPKN5physx14PxRigidDynamicE: __Z29getPxRigidDynamic_WakeCounterPKN5physx14PxRigidDynamicE, __ZN4FMOD6SoundI16getNumSyncPointsEPi: __ZN4FMOD6SoundI16getNumSyncPointsEPi, __Z57Register_UnityEngine_Canvas_set_normalizedSortingGridSizev: __Z57Register_UnityEngine_Canvas_set_normalizedSortingGridSizev, _setpgrp: _setpgrp, __Z59AnchoredJoint2D_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject: __Z59AnchoredJoint2D_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject, __Z36Register_UnityEngine_Light_set_rangev: __Z36Register_UnityEngine_Light_set_rangev, __Z20push_allocation_rootPvP13BaseAllocatorb: __Z20push_allocation_rootPvP13BaseAllocatorb, __ZN8Collider29FetchPoseFromTransformUtilityERK8Vector3f: __ZN8Collider29FetchPoseFromTransformUtilityERK8Vector3f, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer7PvdLineEEE: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer7PvdLineEEE, __ZN23iPhoneLocalNotification8ScheduleEv: __ZN23iPhoneLocalNotification8ScheduleEv, __ZN5Unity5Joint22JointTransferPreNoAxisI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity5Joint22JointTransferPreNoAxisI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5Umbra15IntersectFilter11boundsCheckERKNS_4AABBE: __ZNK5Umbra15IntersectFilter11boundsCheckERKNS_4AABBE, __ZN18ScriptingArguments9AddDoubleEd: __ZN18ScriptingArguments9AddDoubleEd, __Z21HandleGUITexturePropsP19ShaderPropertySheetP7Texture: __Z21HandleGUITexturePropsP19ShaderPropertySheetP7Texture, __Z36Application_Get_Custom_PropIsPlayingv: __Z36Application_Get_Custom_PropIsPlayingv, __ZN7mecanim12statemachine26EvaluateSelectorTransitionEPKNS0_26SelectorTransitionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE: __ZN7mecanim12statemachine26EvaluateSelectorTransitionEPKNS0_26SelectorTransitionConstantEPKNS_18ValueArrayConstantEPKNS_10ValueArrayE, _tcdrain: _tcdrain, __ZN4FMOD13ChannelGroupI7getNameEPci: __ZN4FMOD13ChannelGroupI7getNameEPci, __ZN2UI14CanvasRenderer20OnCanvasGroupChangedEv: __ZN2UI14CanvasRenderer20OnCanvasGroupChangedEv, __Z69Register_UnityEngine_Terrain_INTERNAL_set_realtimeLightmapScaleOffsetv: __Z69Register_UnityEngine_Terrain_INTERNAL_set_realtimeLightmapScaleOffsetv, __Z37Register_UnityEngine_GL_get_sRGBWritev: __Z37Register_UnityEngine_GL_get_sRGBWritev, __ZN7dtCrowd18getAgentNeighboursERK13dtCrowdHandlePS0_i: __ZN7dtCrowd18getAgentNeighboursERK13dtCrowdHandlePS0_i, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13get_allocatorEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE13get_allocatorEv, __Z42Register_UnityEngine_GUIStyle_set_clippingv: __Z42Register_UnityEngine_GUIStyle_set_clippingv, __ZN17GlobalGameManager15ThreadedCleanupEv: __ZN17GlobalGameManager15ThreadedCleanupEv, __ZN5Unity5Cloth8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity5Cloth8TransferI14SafeBinaryReadEEvRT_, __Z36GetRuntimeInitializeOnLoadManagerPtrv: __Z36GetRuntimeInitializeOnLoadManagerPtrv, __Z63ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterPropertiesP12Il2CppObjectii: __Z63ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterPropertiesP12Il2CppObjectii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj625ENS_22PxRepXPropertyAccessorILj625ES4_KjjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj625ENS_22PxRepXPropertyAccessorILj625ES4_KjjEEEEvjRKT0_, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER14SafeBinaryRead, __ZN12HandlerChain4ReadER13FileEntryDatayyPvPy: __ZN12HandlerChain4ReadER13FileEntryDatayyPvPy, _block_prepare_used: _block_prepare_used, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj436ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj436ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN26AnimatorOverrideController23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z37RegisterStaticallyLinkedModuleClassesv: __Z37RegisterStaticallyLinkedModuleClassesv, __Z39Cloth_Get_Custom_PropWorldVelocityScaleP12Il2CppObject: __Z39Cloth_Get_Custom_PropWorldVelocityScaleP12Il2CppObject, __ZN12GraphicsCaps24SharedCapsPostInitializeEv: __ZN12GraphicsCaps24SharedCapsPostInitializeEv, __ZNK5physx31PxClothGeodesicTetherCookerImpl15getCookerStatusEv: __ZNK5physx31PxClothGeodesicTetherCookerImpl15getCookerStatusEv, __GLOBAL__sub_I_Player_cpp: __GLOBAL__sub_I_Player_cpp, __ZNK26PlayerSettingsSplashScreen40GetSplashScreenBackgroundLandscapeAspectEv: __ZNK26PlayerSettingsSplashScreen40GetSplashScreenBackgroundLandscapeAspectEv, __Z46Register_UnityEngine_Audio_AudioMixer_GetFloatv: __Z46Register_UnityEngine_Audio_AudioMixer_GetFloatv, __Z40Rigidbody2D_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP13Vector2fIcall: __Z40Rigidbody2D_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP13Vector2fIcall, __ZN13ProbeRenderer10RenderQuadEP15ReflectionProbeP13RenderTextureib: __ZN13ProbeRenderer10RenderQuadEP15ReflectionProbeP13RenderTextureib, __ZN16CrashReportEvent14GetCacheKeyForERK8UnityStrS2_: __ZN16CrashReportEvent14GetCacheKeyForERK8UnityStrS2_, __Z39Register_UnityEngine_Avatar_get_isHumanv: __Z39Register_UnityEngine_Avatar_get_isHumanv, __Z43Register_UnityEngine_Texture2D_PackTexturesv: __Z43Register_UnityEngine_Texture2D_PackTexturesv, __ZN9Animation25RebuildStateForEverythingEv: __ZN9Animation25RebuildStateForEverythingEv, __Z13RegisterClassI18ProceduralMaterialEvv: __Z13RegisterClassI18ProceduralMaterialEvv, __ZL35StaticInitializeRuntimeSceneManagerPv: __ZL35StaticInitializeRuntimeSceneManagerPv, __ZN5Umbra9Matrix4x311flushToZeroEv: __ZN5Umbra9Matrix4x311flushToZeroEv, __ZN5physx28NpArticulationGetRootFromScbERNS_3Scb12ArticulationE: __ZN5physx28NpArticulationGetRootFromScbERNS_3Scb12ArticulationE, __ZN15ArchiveReadFile5FlushEv: __ZN15ArchiveReadFile5FlushEv, __ZN8VRDevice28HasAudioConfigurationChangedEv: __ZN8VRDevice28HasAudioConfigurationChangedEv, __ZN8LODGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8LODGroup8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z23GetGlobalCachingManagerv: __Z23GetGlobalCachingManagerv, __ZN12b2WheelJoint13SetMotorSpeedEf: __ZN12b2WheelJoint13SetMotorSpeedEf, __ZN5physx2Cm8PtrTable7reallocEjjRNS0_22PtrTableStorageManagerE: __ZN5physx2Cm8PtrTable7reallocEjjRNS0_22PtrTableStorageManagerE, __Z39DistanceJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf: __Z39DistanceJoint2D_Set_Custom_PropDistanceP12Il2CppObjectf, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPvEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE7destroyEPNS_11__tree_nodeIS9_S8_EE, __ZN6b2DrawD2Ev: __ZN6b2DrawD2Ev, __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_: __ZN8Vector2f8TransferI14SafeBinaryReadEEvRT_, __Z58Register_UnityEngine_GUIUtility_Internal_GetPixelsPerPointv: __Z58Register_UnityEngine_GUIUtility_Internal_GetPixelsPerPointv, __Z45QualitySettings_Get_Custom_PropShadowCascadesv: __Z45QualitySettings_Get_Custom_PropShadowCascadesv, __Z24RegisterStrippedTypeInfoI13BuildSettingsEviPKcS2_: __Z24RegisterStrippedTypeInfoI13BuildSettingsEviPKcS2_, __Z45AssetBundleManifest_CUSTOM_GetAllAssetBundlesP12Il2CppObject: __Z45AssetBundleManifest_CUSTOM_GetAllAssetBundlesP12Il2CppObject, __ZN21ArchiveStorageCreator10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN21ArchiveStorageCreator10InitializeERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetSeparateAxesv: __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetSeparateAxesv, __ZNK13SpringJoint2D26GetTypeInfoVirtualInternalEv: __ZNK13SpringJoint2D26GetTypeInfoVirtualInternalEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS5_L18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __Z47BuoyancyEffector2D_Set_Custom_PropFlowMagnitudeP12Il2CppObjectf: __Z47BuoyancyEffector2D_Set_Custom_PropFlowMagnitudeP12Il2CppObjectf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN24AudioScriptBufferManager15GetPCMReadArrayEjRP11Il2CppArray: __ZN24AudioScriptBufferManager15GetPCMReadArrayEjRP11Il2CppArray, __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE: __ZN5physx14NpShapeManager9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneERKNS_12PxRigidActorE, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN13OpenFileCacheC2Ev: __ZN13OpenFileCacheC2Ev, __Z33TerrainData_CUSTOM_GetDetailLayerP12Il2CppObjectiiiii: __Z33TerrainData_CUSTOM_GetDetailLayerP12Il2CppObjectiiiii, __ZN8Animator11SetPlayableEP8Playablei: __ZN8Animator11SetPlayableEP8Playablei, __ZN5physx2Sc7BodySim26notifyClearSpatialVelocityEv: __ZN5physx2Sc7BodySim26notifyClearSpatialVelocityEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx2Gu11HeightField9saveCellsEPvj: __ZNK5physx2Gu11HeightField9saveCellsEPvj, __Z54Register_UnityEngine_Transform_INTERNAL_get_localScalev: __Z54Register_UnityEngine_Transform_INTERNAL_get_localScalev, __ZN5physx6shdfnd13ReadWriteLock10lockWriterEv: __ZN5physx6shdfnd13ReadWriteLock10lockWriterEv, __ZN12AudioManager16UnScheduleSourceEP11AudioSource: __ZN12AudioManager16UnScheduleSourceEP11AudioSource, __Z26CleanupTextRenderingModulev: __Z26CleanupTextRenderingModulev, __ZN17TransformInternal21DetachTransformThreadER18TransformHierarchyjj: __ZN17TransformInternal21DetachTransformThreadER18TransformHierarchyjj, __ZTv0_n12_NSt3__210istrstreamD0Ev: __ZTv0_n12_NSt3__210istrstreamD0Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj28ENS_11PxRigidBodyERKNS_11PxTransformES7_EEEEvjRT_, __ZN13RenderTexture10ForceClearEv: __ZN13RenderTexture10ForceClearEv, __Z77Register_UnityEngine_AnimatorOverrideController_set_runtimeAnimatorControllerv: __Z77Register_UnityEngine_AnimatorOverrideController_set_runtimeAnimatorControllerv, __ZN5physx2Gu22SupportMapRelativeImplINS0_4BoxVEED0Ev: __ZN5physx2Gu22SupportMapRelativeImplINS0_4BoxVEED0Ev, __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayINS_8debugger18PropertyMessageArgENS2_19ForwardingAllocatorEED0Ev, __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi: __ZN9TextureOpI17SharedTextureDataE12ExtractImageEPS0_P14ImageReferenceNS3_8BlitModeEbi, __ZN12b2EPCollider21ComputeEdgeSeparationEv: __ZN12b2EPCollider21ComputeEdgeSeparationEv, __ZN14PlayerSettings15ThreadedCleanupEv: __ZN14PlayerSettings15ThreadedCleanupEv, _UNITY_png_inflate_read: _UNITY_png_inflate_read, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI8Vector3fLj4EEEEvRT_17TransferMetaFlags, _cff_builder_close_contour: _cff_builder_close_contour, __ZN8VRDevice8RecenterEv: __ZN8VRDevice8RecenterEv, __Z18Transfer_BlittableI9JSONWriteLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx7NpShape7releaseEv: __ZN5physx7NpShape7releaseEv, __ZN5physx11MeshCleanerC2EjPKNS_6PxVec3EjPKjf: __ZN5physx11MeshCleanerC2EjPKNS_6PxVec3EjPKjf, __ZN18GfxFramebufferGLES25CleanupFBOMapForTextureIDERK9TextureID: __ZN18GfxFramebufferGLES25CleanupFBOMapForTextureIDERK9TextureID, __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK26ProbeSetTetrahedralization7GetHashEv: __ZNK26ProbeSetTetrahedralization7GetHashEv, __Z22sweepConvex_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z22sweepConvex_SphereGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN10TagManagerD0Ev: __ZN10TagManagerD0Ev, __Z27UploadSparseTextureTileGLES9TextureIDiiiPKhii: __Z27UploadSparseTextureTileGLES9TextureIDiiiPKhii, __ZNK20UnityConnectSettings26GetTypeInfoVirtualInternalEv: __ZNK20UnityConnectSettings26GetTypeInfoVirtualInternalEv, __Z69Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserBirthYearv: __Z69Register_UnityEngine_Analytics_UnityAnalyticsHandler_SetUserBirthYearv, __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN8Material23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_29PxClothMotionConstraintConfigEE12readPropertyIfEEbRT_, __ZZN2UI11CanvasGroup15InitializeClassEvEN38FunctorImpl_118kTransformParentChanged4CallEPviR11MessageData: __ZZN2UI11CanvasGroup15InitializeClassEvEN38FunctorImpl_118kTransformParentChanged4CallEPviR11MessageData, __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetSeparateAxesv: __Z63Register_UnityEngine_ParticleSystem_NoiseModule_SetSeparateAxesv, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE6do_putES4_RNS_8ios_baseEcd, __ZNK6Avatar8GetAssetEv: __ZNK6Avatar8GetAssetEv, __ZN26AnimatorControllerPlayable13ClearPlayableEv: __ZN26AnimatorControllerPlayable13ClearPlayableEv, __Z41TargetJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject: __Z41TargetJoint2D_Get_Custom_PropDampingRatioP12Il2CppObject, __Z48Register_UnityEngine_Camera_get_depthTextureModev: __Z48Register_UnityEngine_Camera_get_depthTextureModev, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE6createERS4_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyPKNS_18PxArticulationLinkEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS_7profile26WrapperReflectionAllocatorIS7_EEE6GetKeyESE_Lb1EE6createERS4_Rb, __ZNKSt3__215__codecvt_utf16IwLb1EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IwLb1EE11do_encodingEv, _fgetws: _fgetws, __ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi: __ZNK26AnimatorControllerPlayable22IsInTransitionInternalEi, __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN30RuntimeInitializeOnLoadManager9ClassInfo8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13RenderTexture6CreateEv: __ZN13RenderTexture6CreateEv, __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms: __Z37ApplyMaterialPassAndKeywordsWithCacheRK18SharedMaterialDataR17ShaderPassContextP6ShaderPN9ShaderLab4PassEibPKNS6_10GrabPassesEP11SubPrograms, __ZN5physx13PxsCCDContext6createEPNS_10PxsContextE: __ZN5physx13PxsCCDContext6createEPNS_10PxsContextE, _fgetwc: _fgetwc, __Z51Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointNonAllocRK13Vector2fIcallP11Il2CppArrayiff: __Z51Physics2D_CUSTOM_INTERNAL_CALL_OverlapPointNonAllocRK13Vector2fIcallP11Il2CppArrayiff, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_17ScaleBiasIteratorIS2_PKS2_EEEEvRT_RS6_: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE18integrateParticlesINS0_17ScaleBiasIteratorIS2_PKS2_EEEEvRT_RS6_, __Z23GL_CUSTOM_BeginInternali: __Z23GL_CUSTOM_BeginInternali, _dcngettext: _dcngettext, __ZNK13b2DynamicTree13ComputeHeightEi: __ZNK13b2DynamicTree13ComputeHeightEi, __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j: __ZN17TransformInternalL20CopyTransformMinimalER18TransformHierarchyjS1_j, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE8teleportERKNS_6PxVec3E, __ZNKSt3__220__time_get_c_storageIwE3__cEv: __ZNKSt3__220__time_get_c_storageIwE3__cEv, __ZN23iPhoneLocalNotification11SetUserInfoEP12Il2CppObject: __ZN23iPhoneLocalNotification11SetUserInfoEP12Il2CppObject, __ZN9Texture2D25CreateScaledAndPaddedDataEPP17SharedTextureDataS2_: __ZN9Texture2D25CreateScaledAndPaddedDataEPP17SharedTextureDataS2_, __ZN24RigidbodyMovementState2D18SetLinearMoveStateERK8Vector2f: __ZN24RigidbodyMovementState2D18SetLinearMoveStateERK8Vector2f, __ZN8Renderer10SetEnabledEb: __ZN8Renderer10SetEnabledEb, __ZN16DeveloperConsole17GetObjectGUIStateEv: __ZN16DeveloperConsole17GetObjectGUIStateEv, __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoTogglev: __Z47Register_UnityEngine_GUI_INTERNAL_CALL_DoTogglev, __ZNK13b2DynamicTree13ComputeHeightEv: __ZNK13b2DynamicTree13ComputeHeightEv, __Z31GL_Set_Custom_PropInvertCullingh: __Z31GL_Set_Custom_PropInvertCullingh, __Z41Register_UnityEngine_Animation_RemoveClipv: __Z41Register_UnityEngine_Animation_RemoveClipv, _tt_cmap2_get_info: _tt_cmap2_get_info, _tt_cmap14_char_variants: _tt_cmap14_char_variants, __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN20GpuProgramParameters19AtomicCounterBufferENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __Z41Animator_Get_Custom_PropRecorderStartTimeP12Il2CppObject: __Z41Animator_Get_Custom_PropRecorderStartTimeP12Il2CppObject, __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_RotationBySpeedModule_CUSTOM_SetZP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN13SplatDatabase8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SplatDatabase8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_FT_Init_Class_tt_service_gx_multi_masters: _UNITY_FT_Init_Class_tt_service_gx_multi_masters, __ZN17BillboardRenderer15UpdateLocalAABBEv: __ZN17BillboardRenderer15UpdateLocalAABBEv, __ZNK16TypeTreeIterator7GetNodeEv: __ZNK16TypeTreeIterator7GetNodeEv, _nice: _nice, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj487ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity10FixedJoint23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity10FixedJoint23VirtualRedirectTransferER14SafeBinaryRead, __ZN8VRDevice17CreateEyeTexturesEv: __ZN8VRDevice17CreateEyeTexturesEv, __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN5Flare12FlareElementENS_9allocatorIS2_EEE8__appendEj, __Z20SetMultiTouchEnabledb: __Z20SetMultiTouchEnabledb, __ZN5physx3Scb14ParticleSystem13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE: __ZN5physx3Scb14ParticleSystem13setVelocitiesEjRKNS_16PxStrideIteratorIKjEERKNS2_IKNS_6PxVec3EEE, __Z37Register_UnityEngine_PlayerPrefs_Savev: __Z37Register_UnityEngine_PlayerPrefs_Savev, __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIjNS_8debugger19ForwardingAllocatorEE8recreateEj, __ZN25ThreadsafeLinearAllocator16FrameMaintenanceEb: __ZN25ThreadsafeLinearAllocator16FrameMaintenanceEb, _iswcntrl: _iswcntrl, __ZN13RuntimeStaticI13ModuleManagerE13StaticDestroyEPv: __ZN13RuntimeStaticI13ModuleManagerE13StaticDestroyEPv, __iup_worker_interpolate: __iup_worker_interpolate, __ZNKSt3__215error_condition7messageEv: __ZNKSt3__215error_condition7messageEv, __ZN11Rigidbody2D8TransferI14SafeBinaryReadEEvRT_: __ZN11Rigidbody2D8TransferI14SafeBinaryReadEEvRT_, __ZN29DelayedPointerDeletionManager21DeallocateLocalMemoryEv: __ZN29DelayedPointerDeletionManager21DeallocateLocalMemoryEv, __ZNK5Umbra14TomeCollection21getClusterPortalCountEv: __ZNK5Umbra14TomeCollection21getClusterPortalCountEv, __ZN7Terrain8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7Terrain8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z56Register_UnityEngine_AI_NavMeshPath_ClearCornersInternalv: __Z56Register_UnityEngine_AI_NavMeshPath_ClearCornersInternalv, _UNITY_png_get_sCAL: _UNITY_png_get_sCAL, __ZN8Collider29GetPositionAndRotationUtilityERK9TransformRK8Vector3fR10Matrix4x4f: __ZN8Collider29GetPositionAndRotationUtilityERK9TransformRK8Vector3fR10Matrix4x4f, __ZN9Scripting9GetMethodEP11Il2CppClassPKc: __ZN9Scripting9GetMethodEP11Il2CppClassPKc, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram12UAVParameterENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __ZN4FMOD6System19getRecordDriverCapsEiPjPiS2_: __ZN4FMOD6System19getRecordDriverCapsEiPjPiS2_, __ZN11dtNodeQueueD2Ev: __ZN11dtNodeQueueD2Ev, __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_S7_T_, __Z49AudioLowPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject: __Z49AudioLowPassFilter_Get_Custom_PropCutoffFrequencyP12Il2CppObject, __ZNSt3__26locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_9money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZN5physx11NpAggregateD0Ev: __ZN5physx11NpAggregateD0Ev, __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv: __ZNSt3__25dequeI4NodeNS_9allocatorIS1_EEE19__add_back_capacityEv, __Z31Rigidbody2D_Get_Custom_PropMassP12Il2CppObject: __Z31Rigidbody2D_Get_Custom_PropMassP12Il2CppObject, __ZN5physx2Sc13ClothBulkData15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc13ClothBulkData15importExtraDataERNS_24PxDeserializationContextE, __ZN4Mesh15GetSharedPxMeshEv: __ZN4Mesh15GetSharedPxMeshEv, __ZNK5physx14NpArticulation25getStabilizationThresholdEv: __ZNK5physx14NpArticulation25getStabilizationThresholdEv, __ZN5physx33PxClothFabricPhaseGeneratedValuesC2EPKNS_18PxClothFabricPhaseE: __ZN5physx33PxClothFabricPhaseGeneratedValuesC2EPKNS_18PxClothFabricPhaseE, _UNITY_TT_Goto_CodeRange: _UNITY_TT_Goto_CodeRange, __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_10ShrunkBoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __ZN19SkinnedMeshRenderer10DeactivateE19DeactivateOperation: __ZN19SkinnedMeshRenderer10DeactivateE19DeactivateOperation, __ZNK13b2DynamicTree17ValidateStructureEi: __ZNK13b2DynamicTree17ValidateStructureEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj484ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z47SystemInfo_Get_Custom_PropSupportsMotionVectorsv: __Z47SystemInfo_Get_Custom_PropSupportsMotionVectorsv, __ZNK10FileSystem18IsAbsoluteFilePathEPKc: __ZNK10FileSystem18IsAbsoluteFilePathEPKc, __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb: __ZN5physx2Sn18readShapesPropertyINS0_21RepXVisitorReaderBaseINS_13PxRigidStaticEEES3_EEvRT_PT0_PKNS_27PxRigidActorShapeCollectionEb, _read_restart_marker: _read_restart_marker, __Z13RegisterClassI16GraphicsSettingsEvv: __Z13RegisterClassI16GraphicsSettingsEvv, __Z21SetShaderGlobalVectorN9ShaderLab16FastPropertyNameERK8Vector4f: __Z21SetShaderGlobalVectorN9ShaderLab16FastPropertyNameERK8Vector4f, __ZN5physx17clothSphereWriterERNS_14PxOutputStreamERKNS_22PxClothCollisionSphereE: __ZN5physx17clothSphereWriterERNS_14PxOutputStreamERKNS_22PxClothCollisionSphereE, __ZN15MBP_PairManager10removePairEjj: __ZN15MBP_PairManager10removePairEjj, __ZN11UnityEngine15CloudWebService16SessionContainer14PurgeAllEventsEv: __ZN11UnityEngine15CloudWebService16SessionContainer14PurgeAllEventsEv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN9GfxDevice23CreateGPUSkinPoseBufferEv: __ZN9GfxDevice23CreateGPUSkinPoseBufferEv, __Z46Register_UnityEngine_AudioSource_set_minVolumev: __Z46Register_UnityEngine_AudioSource_set_minVolumev, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIcEEEvRT_17TransferMetaFlags, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekposENS_4fposI11__mbstate_tEEj: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE10pubseekposENS_4fposI11__mbstate_tEEj, __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_S5_: __ZNK5physx5cloth11SwCollisionI8Scalar4fE12getShapeMaskEPKS2_S5_, __ZN5physx2Sc8ClothSim9startStepEv: __ZN5physx2Sc8ClothSim9startStepEv, __ZN19MemoryProfilerStatsC2Ev: __ZN19MemoryProfilerStatsC2Ev, __ZL25InitializeModule_UnityAdsv: __ZL25InitializeModule_UnityAdsv, _UNITY_png_get_y_offset_inches: _UNITY_png_get_y_offset_inches, __Z42PointEffector2D_Get_Custom_PropForceTargetP12Il2CppObject: __Z42PointEffector2D_Get_Custom_PropForceTargetP12Il2CppObject, __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEv: __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEv, __Z35OcclusionPortal_Set_Custom_PropOpenP12Il2CppObjecth: __Z35OcclusionPortal_Set_Custom_PropOpenP12Il2CppObjecth, __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager11RegisterTagEjRKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcRK8UnityStr: __ZN11UnityEngine9Analytics15UserCustomEvent3AddEPKcRK8UnityStr, __ZNK6Sprite11GetOuterUVsEb: __ZNK6Sprite11GetOuterUVsEb, __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13TextRendering4Font23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z17CleanupAllObjectsv: __Z17CleanupAllObjectsv, __ZN4FMOD5Sound7getNameEPci: __ZN4FMOD5Sound7getNameEPci, __Z64Register_UnityEngine_AI_NavMeshAgent_get_autoTraverseOffMeshLinkv: __Z64Register_UnityEngine_AI_NavMeshAgent_get_autoTraverseOffMeshLinkv, __ZN5physx17AggregateAABBTaskD2Ev: __ZN5physx17AggregateAABBTaskD2Ev, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEED0Ev, __ZN15CapsuleCollider5ResetEv: __ZN15CapsuleCollider5ResetEv, __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN5physx2Gu19intersectBoxCapsuleERKNS0_3BoxERKNS0_7CapsuleE: __ZN5physx2Gu19intersectBoxCapsuleERKNS0_3BoxERKNS0_7CapsuleE, __ZN14PhysicMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14PhysicMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE: __ZN9Scripting17FindObjectsOfTypeEP12Il2CppObjectNS_8FindModeE, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Gu10ConvexMeshES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZN5physx2Gu27checkOverlapCapsule_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu27checkOverlapCapsule_boxGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, __ZN7mecanim5human18HumanSetupColliderEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE: __ZN7mecanim5human18HumanSetupColliderEPNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEE, __Z28Cloth_Get_Custom_PropEnabledP12Il2CppObject: __Z28Cloth_Get_Custom_PropEnabledP12Il2CppObject, __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev: __ZN11UnityEngine15CloudWebService13WWWRestClientD2Ev, __GLOBAL__sub_I_runtime_misc_lump_cpp: __GLOBAL__sub_I_runtime_misc_lump_cpp, __ZN5physx2Cm12RefCountableD2Ev: __ZN5physx2Cm12RefCountableD2Ev, __Z53Register_UnityEngine_RectTransform_get_drivenByObjectv: __Z53Register_UnityEngine_RectTransform_get_drivenByObjectv, __ZN12_GLOBAL__N_117createClothFabricERKN5physx17PxClothFabricDescE: __ZN12_GLOBAL__N_117createClothFabricERKN5physx17PxClothFabricDescE, _UNITY_FT_Destroy_Class_ft_raster1_renderer_class: _UNITY_FT_Destroy_Class_ft_raster1_renderer_class, __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_: __ZN9ShaderLab20SerializedSubProgram14ConstantBufferC2ERKS1_, __Z18ToInternalInfinityi: __Z18ToInternalInfinityi, __ZN6Sprite13PivotToOffsetERK5RectTIfERK8Vector2f: __ZN6Sprite13PivotToOffsetERK5RectTIfERK8Vector2f, __ZN13ProbeSetIndex8TransferI14SafeBinaryReadEEvRT_: __ZN13ProbeSetIndex8TransferI14SafeBinaryReadEEvRT_, __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17CapsuleCollider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15DirectorManager14ConnectionPool22NumInFlightConnectionsEv: __ZN15DirectorManager14ConnectionPool22NumInFlightConnectionsEv, __ZNK12NavMeshAgent20CalculatePolygonPathERK8Vector3fP11NavMeshPath: __ZNK12NavMeshAgent20CalculatePolygonPathERK8Vector3fP11NavMeshPath, __ZN8UVModule6UpdateERK23ParticleSystemParticlesPf: __ZN8UVModule6UpdateERK23ParticleSystemParticlesPf, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i: __ZN9dtNavMesh15connectExtLinksEP10dtMeshTileS1_i, __Z53Register_UnityEngine_TerrainData_get_wavingGrassSpeedv: __Z53Register_UnityEngine_TerrainData_get_wavingGrassSpeedv, __ZN16GeometryJobTasks30ScheduleDynamicVBOGeometryJobsER9GfxDevicePFvP25DynamicVBOGeometryJobDatajEPFvS3_ES3_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle: __ZN16GeometryJobTasks30ScheduleDynamicVBOGeometryJobsER9GfxDevicePFvP25DynamicVBOGeometryJobDatajEPFvS3_ES3_j16GfxPrimitiveTypeP21DynamicVBOChunkHandle, __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE13set_empty_keyERSE_: __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE13set_empty_keyERSE_, __ZN5physx16PxsFluidDynamics4initEb: __ZN5physx16PxsFluidDynamics4initEb, __ZNK5physx2Gu11HeightField9getFormatEv: __ZNK5physx2Gu11HeightField9getFormatEv, __ZN5physx14NpArticulation26setInternalDriveIterationsEj: __ZN5physx14NpArticulation26setInternalDriveIterationsEj, __ZNKSt3__211__libcpp_db6unlockEv: __ZNKSt3__211__libcpp_db6unlockEv, __ZN16LightmapSettings15AppendLightmapsEiRK13dynamic_arrayI12LightmapDataLj4EE: __ZN16LightmapSettings15AppendLightmapsEiRK13dynamic_arrayI12LightmapDataLj4EE, __ZNK9LensFlare26GetTypeInfoVirtualInternalEv: __ZNK9LensFlare26GetTypeInfoVirtualInternalEv, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_15PxPlaneGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_15PxPlaneGeometryE, __ZN14TerrainManager21OffsetLightmapIndicesER18AwakeFromLoadQueueii: __ZN14TerrainManager21OffsetLightmapIndicesER18AwakeFromLoadQueueii, __ZN22BaseUnityConnectClient12PauseSessionEv: __ZN22BaseUnityConnectClient12PauseSessionEv, __ZN22b2EdgeAndCircleContactD0Ev: __ZN22b2EdgeAndCircleContactD0Ev, __ZN21DownloadHandlerScriptD2Ev: __ZN21DownloadHandlerScriptD2Ev, __Z45Register_UnityEngine_RenderTexture_get_formatv: __Z45Register_UnityEngine_RenderTexture_get_formatv, __ZN8GUIStyle14GetDefaultFontEv: __ZN8GUIStyle14GetDefaultFontEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxParticleSystemEEEE14handleAccessorILj173ENS_22PxRepXPropertyAccessorILj173ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEbj: __ZN5physx2Sc35ParticleElementRbElementInteraction7destroyEbj, __ZN8VRDevice15InitializePosesEv: __ZN8VRDevice15InitializePosesEv, __ZN5physx12_GLOBAL__N_116LocationCallbackD0Ev: __ZN5physx12_GLOBAL__N_116LocationCallbackD0Ev, __ZN18PlayableControllerC2Ev: __ZN18PlayableControllerC2Ev, __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet: __Z39CreateInstancedMeshIntermediateRendererR4MeshiR8Material17ShadowCastingModebiP6CameraPK10Matrix4x4fjPK19ShaderPropertySheet, __Z35EnsureQuaternionContinuityLoopFrameR17AnimationCurveTplI11QuaternionfE: __Z35EnsureQuaternionContinuityLoopFrameR17AnimationCurveTplI11QuaternionfE, __ZN14CachingManager21SetCompressionEnabledEb: __ZN14CachingManager21SetCompressionEnabledEb, __Z58Register_UnityEngine_TerrainData_INTERNAL_CALL_RemoveTreesv: __Z58Register_UnityEngine_TerrainData_INTERNAL_CALL_RemoveTreesv, __ZN11BoxCollider7CleanupEv: __ZN11BoxCollider7CleanupEv, __ZN15AudioEchoFilterD2Ev: __ZN15AudioEchoFilterD2Ev, __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapYP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_GetRemapYP12Il2CppObjectR15MonoMinMaxCurve, __Z37Register_UnityEngine_GL_set_wireframev: __Z37Register_UnityEngine_GL_set_wireframev, __Z24RegisterStrippedTypeInfoI10AudioMixerEviPKcS2_: __Z24RegisterStrippedTypeInfoI10AudioMixerEviPKcS2_, __ZN5physx6shdfnd8FPUGuardC2Ev: __ZN5physx6shdfnd8FPUGuardC2Ev, __Z57Register_UnityEngine_GUIStyleState_INTERNAL_set_textColorv: __Z57Register_UnityEngine_GUIStyleState_INTERNAL_set_textColorv, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_GetXMultiplierP12Il2CppObject, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE9PrefValueEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE14__count_uniqueIS7_EEjRKT_, __Z50Register_UnityEngine_AudioReverbFilter_get_densityv: __Z50Register_UnityEngine_AudioReverbFilter_get_densityv, __ZN13SpeedTreeWindC2Ev: __ZN13SpeedTreeWindC2Ev, __Z29StdTemplateConversionFunctionIttEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIttEbPvR14SafeBinaryRead, __ZNK5physx2Sc15ArticulationSim13findBodyIndexERNS0_7BodySimE: __ZNK5physx2Sc15ArticulationSim13findBodyIndexERNS0_7BodySimE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj85ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__28__sp_mut6unlockEv: __ZNSt3__28__sp_mut6unlockEv, __Z35Resources_CUSTOM_GetBuiltinResourceP12Il2CppObjectP12Il2CppString: __Z35Resources_CUSTOM_GetBuiltinResourceP12Il2CppObjectP12Il2CppString, __ZN7b2World9DrawJointEP7b2Joint: __ZN7b2World9DrawJointEP7b2Joint, __ZN24b2ChainAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN24b2ChainAndPolygonContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN5Umbra15CameraTransform10setFrustumEffff: __ZN5Umbra15CameraTransform10setFrustumEffff, __Z65Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsuleNonAllocv: __Z65Register_UnityEngine_Physics_INTERNAL_CALL_OverlapCapsuleNonAllocv, __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXMultiplierv: __Z77Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetXMultiplierv, __ZNK11b2GearJoint10GetAnchorBEv: __ZNK11b2GearJoint10GetAnchorBEv, __ZN11Rigidbody2D16AddRelativeForceERK8Vector2fNS_9ForceModeE: __ZN11Rigidbody2D16AddRelativeForceERK8Vector2fNS_9ForceModeE, __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_: __ZN18JobBatchDispatcher26ScheduleJobDependsInternalER8JobFencePFvPvES2_RKS0_, __ZN13ComputeShader18GetConstantBuffersE17GfxDeviceRendereri: __ZN13ComputeShader18GetConstantBuffersE17GfxDeviceRendereri, __ZNK17FileSystemHandler6TargetERK13FileEntryDataR15FileSystemEntry: __ZNK17FileSystemHandler6TargetERK13FileEntryDataR15FileSystemEntry, __ZN15NavMeshObstacle16OnNavMeshCleanupEv: __ZN15NavMeshObstacle16OnNavMeshCleanupEv, __ZL28GeomMTDCallback_ConvexConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL28GeomMTDCallback_ConvexConvexRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z28getPxArticulation_IsSleepingPKN5physx14PxArticulationE: __Z28getPxArticulation_IsSleepingPKN5physx14PxArticulationE, _cff_font_done: _cff_font_done, _UNITY_FT_Get_CMap_Format: _UNITY_FT_Get_CMap_Format, __ZN5physx2Gu27generateFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb: __ZN5physx2Gu27generateFullContactManifoldERKNS0_8CapsuleVERNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos15PsMatTransformVEPNS0_17PersistentContactERjRKNS9_6FloatVERNS9_5Vec3VEb, __Z39NavMeshPath_CUSTOM_ClearCornersInternalP12Il2CppObject: __Z39NavMeshPath_CUSTOM_ClearCornersInternalP12Il2CppObject, __ZNK5physx13NpClothFabric14getNbParticlesEv: __ZNK5physx13NpClothFabric14getNbParticlesEv, __ZN5physx9NpFactory15destroyInstanceEv: __ZN5physx9NpFactory15destroyInstanceEv, __ZN5physx2Sc15ClothFabricCore15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc15ClothFabricCore15exportExtraDataERNS_22PxSerializationContextE, __ZN5Umbra15PortalRayTracerC2EPNS_12QueryContextERKNS_7Vector3EPKNS_23ImpObjectDistanceParamsEPNS_11TransformerE: __ZN5Umbra15PortalRayTracerC2EPNS_12QueryContextERKNS_7Vector3EPKNS_23ImpObjectDistanceParamsEPNS_11TransformerE, __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE15getSerializableEv, __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE: __ZN20ArchiveStorageHeader19GetBlocksInfoOffsetERKNS_6HeaderE, __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI19ComputeShaderKernelNS_9allocatorIS1_EEE8__appendEj, __ZN5physx23PxvRegisterHeightFieldsEv: __ZN5physx23PxvRegisterHeightFieldsEv, __ZN26AnimatorOverrideController8TransferI14SafeBinaryReadEEvRT_: __ZN26AnimatorOverrideController8TransferI14SafeBinaryReadEEvRT_, __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv: __ZN24GenerateTypeTreeTransfer16EndArrayTransferEv, __ZN5physx3Ext7D6Joint15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx3Ext7D6Joint15exportExtraDataERNS_22PxSerializationContextE, __Z39UnityWebRequest_CUSTOM_GetRequestHeaderP12Il2CppObjectP12Il2CppString: __Z39UnityWebRequest_CUSTOM_GetRequestHeaderP12Il2CppObjectP12Il2CppString, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getNumVirtualParticlesEv, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE16setInvMassScale0Ef, __Z29TerrainData_CUSTOM_GetHeightsP12Il2CppObjectiiii: __Z29TerrainData_CUSTOM_GetHeightsP12Il2CppObjectiiii, __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z32Collider_Get_Custom_PropMaterialP12Il2CppObject: __Z32Collider_Get_Custom_PropMaterialP12Il2CppObject, __ZN5physx8debugger4comm19EndSetPropertyValue9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm19EndSetPropertyValue9serializeERNS1_15EventSerializerE, __Z47Register_UnityEngine_Light_set_shadowResolutionv: __Z47Register_UnityEngine_Light_set_shadowResolutionv, __ZN11TimeManager21DidFinishLoadingSceneEv: __ZN11TimeManager21DidFinishLoadingSceneEv, __Z34GUI_CUSTOM_GetNameOfFocusedControlv: __Z34GUI_CUSTOM_GetNameOfFocusedControlv, __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_: __Z33CalculateLightShadowCenterAndTypeRK6CameraR8Vector4fRfS4_, __ZN11NoiseModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11NoiseModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK9Transform16GetLocalRotationEv: __ZNK9Transform16GetLocalRotationEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math4AxesEEEEvRT_17TransferMetaFlags, __Z47SurfaceEffector2D_Get_Custom_PropSpeedVariationP12Il2CppObject: __Z47SurfaceEffector2D_Get_Custom_PropSpeedVariationP12Il2CppObject, __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim12statemachine20StateMachineConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sc18ParticleSystemCore13onOriginShiftERKNS_6PxVec3E: __ZN5physx2Sc18ParticleSystemCore13onOriginShiftERKNS_6PxVec3E, __Z55Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatricesP12Il2CppObjectRK10Matrix4x4fS3_: __Z55Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatricesP12Il2CppObjectRK10Matrix4x4fS3_, __Z34Canvas_Get_Custom_PropPixelPerfectP12Il2CppObject: __Z34Canvas_Get_Custom_PropPixelPerfectP12Il2CppObject, __Z48ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve: __Z48ParticleSystem_NoiseModule_CUSTOM_GetScrollSpeedP12Il2CppObjectR15MonoMinMaxCurve, __Z51Register_UnityEngine_ReflectionProbe_get_importancev: __Z51Register_UnityEngine_ReflectionProbe_get_importancev, __ZN13RenderTexture15SetAsEyeTextureEb: __ZN13RenderTexture15SetAsEyeTextureEb, __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZNSt3__211__libcpp_db4swapEPvS1_: __ZNSt3__211__libcpp_db4swapEPvS1_, __Z47Register_UnityEngine_AI_NavMesh_GetAreaFromNamev: __Z47Register_UnityEngine_AI_NavMesh_GetAreaFromNamev, __Z15FMODMemoryAllocjjPKc: __Z15FMODMemoryAllocjjPKc, __Z34getPxTriangleMeshGeometryMeshFlagsPKN5physx22PxTriangleMeshGeometryE: __Z34getPxTriangleMeshGeometryMeshFlagsPKN5physx22PxTriangleMeshGeometryE, __Z42Register_UnityEngine_GUIUtility_GetChangedv: __Z42Register_UnityEngine_GUIUtility_GetChangedv, __ZNK10Matrix4x4f14GetDeterminantEv: __ZNK10Matrix4x4f14GetDeterminantEv, __ZN17Physics2DSettings21SetQueriesHitTriggersEb: __ZN17Physics2DSettings21SetQueriesHitTriggersEb, __ZN15AudioReverbZone8TransferI14SafeBinaryReadEEvRT_: __ZN15AudioReverbZone8TransferI14SafeBinaryReadEEvRT_, _tre_ast_to_tnfa: _tre_ast_to_tnfa, __Z67AnimatorOverrideController_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_: __Z67AnimatorOverrideController_Set_Custom_PropRuntimeAnimatorControllerP12Il2CppObjectS0_, __ZNK10FileSystem19GetUserConfigFolderEv: __ZNK10FileSystem19GetUserConfigFolderEv, __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERPKc: __ZN5physx8debugger4comm16EventStreamifierINS1_13MeasureStreamEE9streamifyERPKc, _UNITY_FT_Load_Sfnt_Table: _UNITY_FT_Load_Sfnt_Table, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE19constrainSeparationEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE19constrainSeparationEv, __ZN4FMOD4DSPIC2EPNS_7SystemIE: __ZN4FMOD4DSPIC2EPNS_7SystemIE, __ZN25SingleBlockMemoryFileDataD2Ev: __ZN25SingleBlockMemoryFileDataD2Ev, __ZN9Animation14SetCullingTypeENS_11CullingTypeE: __ZN9Animation14SetCullingTypeENS_11CullingTypeE, __ZN9DebugGLES4InitER7ApiGLES: __ZN9DebugGLES4InitER7ApiGLES, __ZNKSt3__214__codecvt_utf8IDiE11do_encodingEv: __ZNKSt3__214__codecvt_utf8IDiE11do_encodingEv, __ZN13RuntimeStaticI17UniqueIDGeneratorE13StaticDestroyEPv: __ZN13RuntimeStaticI17UniqueIDGeneratorE13StaticDestroyEPv, __Z29StdTemplateConversionFunctionIjiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIjiEbPvR14SafeBinaryRead, __ZN12MeshRenderer13DidModifyMeshEv: __ZN12MeshRenderer13DidModifyMeshEv, __Z46Register_UnityEngine_GL_INTERNAL_set_modelviewv: __Z46Register_UnityEngine_GL_INTERNAL_set_modelviewv, __ZN5physx16collideWithPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf: __ZN5physx16collideWithPlaneEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEf, __Z38AnimationState_Get_Custom_PropWrapModeP12Il2CppObject: __Z38AnimationState_Get_Custom_PropWrapModeP12Il2CppObject, __ZN12_GLOBAL__N_119PvdConnectionReaderD0Ev: __ZN12_GLOBAL__N_119PvdConnectionReaderD0Ev, __ZNK5physx2Sc5Scene32getMaxNbConstraintDataBlocksUsedEv: __ZNK5physx2Sc5Scene32getMaxNbConstraintDataBlocksUsedEv, __Z18Transfer_BlittableI8JSONReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10AudioMixer26OnEditingInPlayModeChangedEv: __ZN10AudioMixer26OnEditingInPlayModeChangedEv, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIjEEclERS1_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIjEEclERS1_17TransferMetaFlagsR9BlobWrite, __Z51UnityAdsSettings_Set_Custom_PropInitializeOnStartuph: __Z51UnityAdsSettings_Set_Custom_PropInitializeOnStartuph, __ZNSt3__26vectorIcNS_9allocatorIcEEE6insertINS_11__wrap_iterIPKcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsISA_E9referenceEEE5valueENS5_IPcEEE4typeES8_SA_SA_: __ZNSt3__26vectorIcNS_9allocatorIcEEE6insertINS_11__wrap_iterIPKcEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIcNS_15iterator_traitsISA_E9referenceEEE5valueENS5_IPcEEE4typeES8_SA_SA_, __ZN17MessageIdentifierC2EPKcNS_7OptionsEPKN5Unity4TypeES1_: __ZN17MessageIdentifierC2EPKcNS_7OptionsEPKN5Unity4TypeES1_, __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf: __Z21CalculateClosestPointRK8Vector3fRK4AABBRS_Rf, __Z37Register_UnityEngine_Gradient_Cleanupv: __Z37Register_UnityEngine_Gradient_Cleanupv, __ZN5physx2Sq16BucketPrunerCore10resizeCoreEv: __ZN5physx2Sq16BucketPrunerCore10resizeCoreEv, __ZN13RuntimeStaticI15DirectorManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI15DirectorManagerE16StaticInitializeEPv, __ZN19CollisionListener2D25DestroyColliderCollisionsEP10Collider2D: __ZN19CollisionListener2D25DestroyColliderCollisionsEP10Collider2D, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetcEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE5sgetcEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, __Z16b2GetPointStatesP12b2PointStateS0_PK10b2ManifoldS3_: __Z16b2GetPointStatesP12b2PointStateS0_PK10b2ManifoldS3_, __GLOBAL__sub_I_runtime_allocator_lump_cpp: __GLOBAL__sub_I_runtime_allocator_lump_cpp, __ZN17MemoryCacheReader12GetCacheSizeEv: __ZN17MemoryCacheReader12GetCacheSizeEv, __ZN13SpeedTreeWind8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SpeedTreeWind8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx24PxComputeMeshPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES5_Rj: __ZN5physx24PxComputeMeshPenetrationEjRKNS_10PxGeometryERKNS_11PxTransformERKNS_22PxTriangleMeshGeometryES5_Rj, __ZN5physx3Ext19ProfileEventHandler12onStartEventERKNS_16PxProfileEventIdEjyhhy: __ZN5physx3Ext19ProfileEventHandler12onStartEventERKNS_16PxProfileEventIdEjyhhy, __Z18UploadTextureAtlasP9Texture2Db: __Z18UploadTextureAtlasP9Texture2Db, _UNITY_png_get_user_width_max: _UNITY_png_get_user_width_max, __ZN11DynamicMesh13MergePolygonsEv: __ZN11DynamicMesh13MergePolygonsEv, __ZN20SpeedTreeWindManager25GetCachedGlobalWindVectorEv: __ZN20SpeedTreeWindManager25GetCachedGlobalWindVectorEv, __Z29scripting_profiler_install_gcPFvPviiEPFvS_xE: __Z29scripting_profiler_install_gcPFvPviiEPFvS_xE, __ZN5physx2Sc10ClothShapeD2Ev: __ZN5physx2Sc10ClothShapeD2Ev, __Z30LensFlare_Set_Custom_PropFlareP12Il2CppObjectS0_: __Z30LensFlare_Set_Custom_PropFlareP12Il2CppObjectS0_, __ZN9Coroutine16CleanupCoroutineEPv: __ZN9Coroutine16CleanupCoroutineEPv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj444ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj444ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z37AnimationClip_CUSTOM_AddEventInternalP12Il2CppObjectS0_: __Z37AnimationClip_CUSTOM_AddEventInternalP12Il2CppObjectS0_, __Z45getPxSimulationStatisticsPeakConstraintMemoryPKN5physx22PxSimulationStatisticsE: __Z45getPxSimulationStatisticsPeakConstraintMemoryPKN5physx22PxSimulationStatisticsE, __ZN5physx6shdfnd4Time17getElapsedSecondsEv: __ZN5physx6shdfnd4Time17getElapsedSecondsEv, __ZN10CBBoxInt327AugmentEiii: __ZN10CBBoxInt327AugmentEiii, __ZN11UnityEngine15CloudWebService19SessionEventManager16StartExpiryTimerERNS0_16SessionContainerE: __ZN11UnityEngine15CloudWebService19SessionEventManager16StartExpiryTimerERNS0_16SessionContainerE, __ZN5physx2Gu27intersectRayCapsuleInternalERKNS_6PxVec3ES3_S3_S3_fPf: __ZN5physx2Gu27intersectRayCapsuleInternalERKNS_6PxVec3ES3_S3_S3_fPf, __ZN19SharedBillboardDataC2ERKS_: __ZN19SharedBillboardDataC2ERKS_, __Z17tessMeshSplitEdgeP8TESSmeshP12TESShalfEdge: __Z17tessMeshSplitEdgeP8TESSmeshP12TESShalfEdge, __ZN14PhysicsManager19ProcessTriggerStaysEv: __ZN14PhysicsManager19ProcessTriggerStaysEv, __Z29ConvertCollision2DToScriptingP11Collision2D: __Z29ConvertCollision2DToScriptingP11Collision2D, __Z50Register_UnityEngine_WWW_get_responseHeadersStringv: __Z50Register_UnityEngine_WWW_get_responseHeadersStringv, __ZN5physx11NpAggregate11removeActorERNS_7PxActorE: __ZN5physx11NpAggregate11removeActorERNS_7PxActorE, __Z23WWW_Get_Custom_PropSizeP12Il2CppObject: __Z23WWW_Get_Custom_PropSizeP12Il2CppObject, __ZNK14PlayerSettings17GetStackTraceTypeE7LogType: __ZNK14PlayerSettings17GetStackTraceTypeE7LogType, __ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_: __ZN5physx2Gu17intersectEdgeEdgeERKNS_6PxVec3ES3_S3_S3_S3_RfRS1_, __ZNK8Material15ShaderHasErrorsEv: __ZNK8Material15ShaderHasErrorsEv, __ZN4FMOD7SystemI15getPluginHandleE15FMOD_PLUGINTYPEiPj: __ZN4FMOD7SystemI15getPluginHandleE15FMOD_PLUGINTYPEiPj, __Z49Register_UnityEngine_LightProbeProxyVolume_Updatev: __Z49Register_UnityEngine_LightProbeProxyVolume_Updatev, __Z47GameObject_CUSTOM_Internal_AddComponentWithTypeP12Il2CppObjectS0_: __Z47GameObject_CUSTOM_Internal_AddComponentWithTypeP12Il2CppObjectS0_, __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_18PxArticulationLinkEE15exportExtraDataERNS_22PxSerializationContextE, __Z65Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplListv: __Z65Register_UnityEngine_MaterialPropertyBlock_SetVectorArrayImplListv, __Z16UnloadAllPluginsv: __Z16UnloadAllPluginsv, __Z58ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZLimitSpringP12Il2CppObjectP20SoftJointLimitSpring: __Z58ConfigurableJoint_CUSTOM_INTERNAL_get_angularYZLimitSpringP12Il2CppObjectP20SoftJointLimitSpring, __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags, __Z54Register_UnityEngine_ParticleSystem_MainModule_GetLoopv: __Z54Register_UnityEngine_ParticleSystem_MainModule_GetLoopv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE16setRestPositionsENS0_5RangeIKNS_6PxVec4EEE, __ZN5physx2Sc8BodyCore13getSerialCoreERNS_11PxsBodyCoreE: __ZN5physx2Sc8BodyCore13getSerialCoreERNS_11PxsBodyCoreE, __Z47AudioReverbZone_Set_Custom_PropReflectionsDelayP12Il2CppObjectf: __Z47AudioReverbZone_Set_Custom_PropReflectionsDelayP12Il2CppObjectf, __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12MeshRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN12_GLOBAL__N_110ConnectionD0Ev: __ZN12_GLOBAL__N_110ConnectionD0Ev, __ZThn28_N14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj: __ZThn28_N14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj, __Z39MaterialPropertyBlock_CUSTOM_GetTextureP12Il2CppObjecti: __Z39MaterialPropertyBlock_CUSTOM_GetTextureP12Il2CppObjecti, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_SetYv, __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_14NpRigidDynamicEE19getConcreteTypeNameEv, __ZN5physx11NpAggregate17removeAndReinsertERNS_7PxActorEb: __ZN5physx11NpAggregate17removeAndReinsertERNS_7PxActorEb, __Z46RenderSettings_Get_Custom_PropCustomReflectionv: __Z46RenderSettings_Get_Custom_PropCustomReflectionv, __Z39Rigidbody_Get_Custom_PropFreezeRotationP12Il2CppObject: __Z39Rigidbody_Get_Custom_PropFreezeRotationP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, _write_marker_header: _write_marker_header, __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi: __ZN7ApiGLES5ClearEjRK10ColorRGBAfbfi, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE18__construct_at_endIPS1_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeES8_S8_j, _unlink: _unlink, __GLOBAL__sub_I_runtime_utilities2_lump_cpp: __GLOBAL__sub_I_runtime_utilities2_lump_cpp, __ZN8PlayableC2EP12Il2CppObject18DirectorPlayerType: __ZN8PlayableC2EP12Il2CppObject18DirectorPlayerType, __Z36RegisterModuleClasses_UnityAnalyticsv: __Z36RegisterModuleClasses_UnityAnalyticsv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4swapERS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4swapERS5_, __ZN17Physics2DSettings23SetColliderContactColorERK10ColorRGBAf: __ZN17Physics2DSettings23SetColliderContactColorERK10ColorRGBAf, __ZN10GUITexture15InitializeClassEv: __ZN10GUITexture15InitializeClassEv, __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN22BuiltinResourceManager8ResourceENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZNSt11logic_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNSt11logic_errorC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_: __ZNSt3__27__sort5IR25ValueParameterArraySorterPN20GpuProgramParameters14ValueParameterEEEjT0_S6_S6_S6_S6_T_, __Z21ConvertImageToPNGFileRK14ImageReferenceRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z21ConvertImageToPNGFileRK14ImageReferenceRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __Z47Register_UnityEngine_CullingGroup_EraseSwapBackv: __Z47Register_UnityEngine_CullingGroup_EraseSwapBackv, __Z42Vector3_CUSTOM_INTERNAL_CALL_RotateTowardsRK8Vector3fS1_ffRS_: __Z42Vector3_CUSTOM_INTERNAL_CALL_RotateTowardsRK8Vector3fS1_ffRS_, __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorEj: __ZN5physx14NpShapeManager15setupSceneQueryERNS_2Sq17SceneQueryManagerERKNS_12PxRigidActorEj, __Z39Register_UnityEngine_Mesh_CombineMeshesv: __Z39Register_UnityEngine_Mesh_CombineMeshesv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EOS3_: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEEC2EOS3_, __ZN5physx8debugger4comm15NameHandleValue9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm15NameHandleValue9serializeERNS1_15EventSerializerE, __Z37NavMeshObstacle_Get_Custom_PropRadiusP12Il2CppObject: __Z37NavMeshObstacle_Get_Custom_PropRadiusP12Il2CppObject, __Z56Register_UnityEngine_DynamicGI_INTERNAL_CALL_SetEmissivev: __Z56Register_UnityEngine_DynamicGI_INTERNAL_CALL_SetEmissivev, __ZN5physx15PxVehicleWheels15computeByteSizeEj: __ZN5physx15PxVehicleWheels15computeByteSizeEj, __ZN5physx2Sc8ClothSim17addCollisionShapeEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim17addCollisionShapeEPKNS0_8ShapeSimE, __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_10ClothShapeE: __ZN5physx2Sc5Scene19addBroadPhaseVolumeERNS0_10ClothShapeE, __ZN7mecanim5human29HumanFixEndPointsSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_i: __ZN7mecanim5human29HumanFixEndPointsSkeletonPoseEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPNS0_9HumanPoseEPS8_SD_SD_i, __ZNK5physx14NpRigidDynamic21getMaxAngularVelocityEv: __ZNK5physx14NpRigidDynamic21getMaxAngularVelocityEv, _jpeg_stdio_dest: _jpeg_stdio_dest, __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_11PxDebugTextENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN13UnityProfilerD2Ev: __ZN13UnityProfilerD2Ev, __Z20GetPhysics2DSettingsv: __Z20GetPhysics2DSettingsv, __ZN24MeshIntermediateRenderer13StaticDestroyEPv: __ZN24MeshIntermediateRenderer13StaticDestroyEPv, __ZN5Umbra9Matrix2x25clearEv: __ZN5Umbra9Matrix2x25clearEv, __Z38Register_UnityEngine_Cloth_get_normalsv: __Z38Register_UnityEngine_Cloth_get_normalsv, __ZL22addOrRemoveRigidObjectILb0ELb1ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b: __ZL22addOrRemoveRigidObjectILb0ELb1ELb0ELb1EN5physx3Scb11RigidStaticEEvRNS0_2Sc5SceneERT3_b, __Z56Register_UnityEngine_Physics_set_defaultSolverIterationsv: __Z56Register_UnityEngine_Physics_set_defaultSolverIterationsv, __ZN24GenerateTypeTreeTransfer21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN24GenerateTypeTreeTransfer21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, __ZN11UnityEngine9Animation29InvalidateAvatarBindingObjectEPNS0_21AvatarBindingConstantEP6Object: __ZN11UnityEngine9Animation29InvalidateAvatarBindingObjectEPNS0_21AvatarBindingConstantEP6Object, __Z31getPxClothFabric_ReferenceCountPKN5physx13PxClothFabricE: __Z31getPxClothFabric_ReferenceCountPKN5physx13PxClothFabricE, __ZN5physx2Sc35ParticleElementRbElementInteraction11updateStateEb: __ZN5physx2Sc35ParticleElementRbElementInteraction11updateStateEb, __ZNK33AssetBundleLoadFromAsyncOperation10PrintErrorEv: __ZNK33AssetBundleLoadFromAsyncOperation10PrintErrorEv, __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl7releaseEv: __ZN12_GLOBAL__N_126PvdObjectModelMetaDataImpl7releaseEv, __ZN22BlockMemoryCacheWriter12GetCacheSizeEv: __ZN22BlockMemoryCacheWriter12GetCacheSizeEv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23setIjNS2_4lessIjEENS2_9allocatorIjEEEEEEvRT_17TransferMetaFlags, __ZN18DelayedCallManagerD2Ev: __ZN18DelayedCallManagerD2Ev, __Z27GetBlendShapeNameFromScriptRK4Meshi: __Z27GetBlendShapeNameFromScriptRK4Meshi, __ZN9Transform15InitializeClassEv: __ZN9Transform15InitializeClassEv, __ZN5physx12NpConstraint17getScbRigidObjectEPNS_12PxRigidActorE: __ZN5physx12NpConstraint17getScbRigidObjectEPNS_12PxRigidActorE, __ZN5Umbra13MatrixFactory5orthoEfff: __ZN5Umbra13MatrixFactory5orthoEfff, __ZN12b2MotorJoint23InitVelocityConstraintsERK12b2SolverData: __ZN12b2MotorJoint23InitVelocityConstraintsERK12b2SolverData, __Z58Register_UnityEngine_Audio_AudioMixerSnapshot_TransitionTov: __Z58Register_UnityEngine_Audio_AudioMixerSnapshot_TransitionTov, __ZN5physx3Ext27GetExtensionsBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext27GetExtensionsBinaryMetaDataERNS_14PxOutputStreamE, __ZNSt3__214collate_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214collate_bynameIcEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZNK17ArchiveFileSystem8FilenameERK13FileEntryData: __ZNK17ArchiveFileSystem8FilenameERK13FileEntryData, __Z38RenderTexture_Set_Custom_PropUseMipMapP12Il2CppObjecth: __Z38RenderTexture_Set_Custom_PropUseMipMapP12Il2CppObjecth, __Z70Register_UnityEngine_Renderer_INTERNAL_set_realtimeLightmapScaleOffsetv: __Z70Register_UnityEngine_Renderer_INTERNAL_set_realtimeLightmapScaleOffsetv, __ZN5physx2Sc15ClothFabricCore4loadERKNS_17PxClothFabricDescE: __ZN5physx2Sc15ClothFabricCore4loadERKNS_17PxClothFabricDescE, __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj: __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EE20resize_uninitializedEj, _unity_z_inflateInit_: _unity_z_inflateInit_, __Z34SliderJoint2D_Set_Custom_PropAngleP12Il2CppObjectf: __Z34SliderJoint2D_Set_Custom_PropAngleP12Il2CppObjectf, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_18packetShapesUpdateEPNS_10PxBaseTaskEEEED0Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxShapeEEEEclILj116ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE15getNumParticlesEv, __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension: __ZN14VertexDataInfo18SetAsSingleChannelEPvj13ShaderChannelRK22ChannelFormatDimension, __ZN21AssetBundleFileSystem13RemoveArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN21AssetBundleFileSystem13RemoveArchiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN9Animation14BlendOptimizedEv: __ZN9Animation14BlendOptimizedEv, __Z57Register_UnityEngine_ParticleSystem_TriggerModule_SetExitv: __Z57Register_UnityEngine_ParticleSystem_TriggerModule_SetExitv, __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_: __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE6insertENS_11__wrap_iterIPKS4_EERS9_, __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_: __ZNSt3__27__sort3IRPFbRKNS_4pairIN9ShaderLab16FastPropertyNameEfEES6_EPS4_EEjT0_SB_SB_T_, __ZN5physx2Sq8BitArray4initEj: __ZN5physx2Sq8BitArray4initEj, __ZN43MultiWriterSingleReaderAtomicCircularBuffer19ReserveSpaceForDataEi: __ZN43MultiWriterSingleReaderAtomicCircularBuffer19ReserveSpaceForDataEi, __ZN17ArchiveFileSystem8IsLockedERK13FileEntryData: __ZN17ArchiveFileSystem8IsLockedERK13FileEntryData, __Z38AnimationClip_CUSTOM_SetEventsInternalP12Il2CppObjectP11Il2CppArray: __Z38AnimationClip_CUSTOM_SetEventsInternalP12Il2CppObjectP11Il2CppArray, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEED2Ev, __ZN13GfxDeviceNull20ImmediateTexCoordAllEfff: __ZN13GfxDeviceNull20ImmediateTexCoordAllEfff, __ZN5physx14NpRigidDynamic29wakeUpInternalNoKinematicTestERNS_3Scb4BodyEbb: __ZN5physx14NpRigidDynamic29wakeUpInternalNoKinematicTestERNS_3Scb4BodyEbb, __ZNK6Sprite26GetTypeInfoVirtualInternalEv: __ZNK6Sprite26GetTypeInfoVirtualInternalEv, __ZN14NavMeshManager16CleanupWithErrorEPKc: __ZN14NavMeshManager16CleanupWithErrorEPKc, __ZN14BillboardAssetC2E10MemLabelId18ObjectCreationMode: __ZN14BillboardAssetC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sc7BodySim17updateWakeCounterEffffb: __ZN5physx2Sc7BodySim17updateWakeCounterEffffb, __ZN8JSONRead8TransferIdEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIdEEvRT_PKc17TransferMetaFlagsb, __ZNK5physx15PxRevoluteJoint8isKindOfEPKc: __ZNK5physx15PxRevoluteJoint8isKindOfEPKc, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZN5physx3Ext14SphericalJoint12setLimitConeERKNS_16PxJointLimitConeE: __ZN5physx3Ext14SphericalJoint12setLimitConeERKNS_16PxJointLimitConeE, __Z26Font_Get_Custom_PropAscentP12Il2CppObject: __Z26Font_Get_Custom_PropAscentP12Il2CppObject, __ZN5physx36PxsSolverCoreRegisterArticulationFnsEv: __ZN5physx36PxsSolverCoreRegisterArticulationFnsEv, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE8__appendEj, __ZN11PreloadDataD0Ev: __ZN11PreloadDataD0Ev, __Z46Register_UnityEngine_AudioEchoFilter_get_delayv: __Z46Register_UnityEngine_AudioEchoFilter_get_delayv, __ZN15QualitySettings17SetShadowDistanceEf: __ZN15QualitySettings17SetShadowDistanceEf, __Z34FindAllRequiredComponentsRecursiveiR10vector_setIiNSt3__24lessIiEENS0_9allocatorIiEEE: __Z34FindAllRequiredComponentsRecursiveiR10vector_setIiNSt3__24lessIiEENS0_9allocatorIiEEE, __ZN8Scalar4fC2Effff: __ZN8Scalar4fC2Effff, __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI11Rigidbody2DE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z44Register_UnityEngine_AnimationCurve_Evaluatev: __Z44Register_UnityEngine_AnimationCurve_Evaluatev, __ZZN10Collider2D15InitializeClassEvEN31FunctorImpl_79kTransformChanged4CallEPviR11MessageData: __ZZN10Collider2D15InitializeClassEvEN31FunctorImpl_79kTransformChanged4CallEPviR11MessageData, __ZN5physx2Sn18RepXCollectionImpl11setUpVectorERKNS_6PxVec3E: __ZN5physx2Sn18RepXCollectionImpl11setUpVectorERKNS_6PxVec3E, _iswspace: _iswspace, __ZN5physx2Sn20SerializationContext9writeDataEPKvj: __ZN5physx2Sn20SerializationContext9writeDataEPKvj, __ZN5physx10PxsContext17registerParticlesEv: __ZN5physx10PxsContext17registerParticlesEv, __ZN12EventManager11InvokeEventEP10EventEntryPvi: __ZN12EventManager11InvokeEventEP10EventEntryPvi, _PxUnregisterPhysicsSerializers: _PxUnregisterPhysicsSerializers, __ZN12CubemapArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12CubemapArray23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxPrismaticJointEE12readPropertyIfEEbRT_, __ZN5physx3Scb5Scene10getPxSceneEv: __ZN5physx3Scb5Scene10getPxSceneEv, __ZN11Rigidbody2D15InitializeClassEv: __ZN11Rigidbody2D15InitializeClassEv, __Z24RegisterStrippedTypeInfoI12LineRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI12LineRendererEviPKcS2_, __ZN12NavMeshAgent27UpdateActiveAgentParametersEv: __ZN12NavMeshAgent27UpdateActiveAgentParametersEv, __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet: __ZN20GpuProgramParameters15AddTextureParamEPKcii16TextureDimensionP16PropertyNamesSet, __ZN17PolygonCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17PolygonCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z15NormalizeRobustRK8Vector3f: __Z15NormalizeRobustRK8Vector3f, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE13getBreakForceERfS5_, __ZN13SparseTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13SparseTexture8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z40OcclusionArea_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z40OcclusionArea_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_GetPixelv: __Z51Register_UnityEngine_Cubemap_INTERNAL_CALL_GetPixelv, __ZN5Unity11SpringJoint8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity11SpringJoint8TransferI24GenerateTypeTreeTransferEEvRT_, __Z54Register_UnityEngine_CullingGroup_SetBoundingDistancesv: __Z54Register_UnityEngine_CullingGroup_SetBoundingDistancesv, __Z46Register_UnityEngine_AndroidJNI_FromFloatArrayv: __Z46Register_UnityEngine_AndroidJNI_FromFloatArrayv, __ZN22BuiltinResourceManager16StaticInitializeEPv: __ZN22BuiltinResourceManager16StaticInitializeEPv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj649ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj649ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetPositionR9HPlayableRK8Vector3f: __Z56AnimationOffsetPlayable_CUSTOM_INTERNAL_CALL_SetPositionR9HPlayableRK8Vector3f, __Z39AndroidJNI_CUSTOM_SetObjectArrayElement13Il2Cpp_IntPtriS_: __Z39AndroidJNI_CUSTOM_SetObjectArrayElement13Il2Cpp_IntPtriS_, __ZNK5physx3Cct15ObstacleContext20getControllerManagerEv: __ZNK5physx3Cct15ObstacleContext20getControllerManagerEv, __ZN4Mesh18GetSubMeshBuffer16Ei: __ZN4Mesh18GetSubMeshBuffer16Ei, __ZN11LightProbes8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11LightProbes8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN19CharacterController9SetRadiusEf: __ZN19CharacterController9SetRadiusEf, __Z52ParticleSystem_CollisionModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf: __Z52ParticleSystem_CollisionModule_CUSTOM_SetRadiusScaleP12Il2CppObjectf, __Z50PlatformEffector2D_Set_Custom_PropRotationalOffsetP12Il2CppObjectf: __Z50PlatformEffector2D_Set_Custom_PropRotationalOffsetP12Il2CppObjectf, __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE: __ZNKSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE6do_putES4_bRNS_8ios_baseEwRKNS_12basic_stringIwS3_NS_9allocatorIwEEEE, __ZN20SoundChannelInstance9isVirtualEPb: __ZN20SoundChannelInstance9isVirtualEPb, _dngettext: _dngettext, __ZNK7Texture14GetMipmapCountEv: __ZNK7Texture14GetMipmapCountEv, __ZN4FMOD5Sound12getOpenStateEP14FMOD_OPENSTATEPjPbS4_: __ZN4FMOD5Sound12getOpenStateEP14FMOD_OPENSTATEPjPbS4_, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_, _UNITY_tt_driver_done: _UNITY_tt_driver_done, __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_14PxTriangleMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN17AudioReverbFilter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17AudioReverbFilter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11UnityEngine15CloudWebService18RestFileDownloader17OnCompleteContentEv: __ZN11UnityEngine15CloudWebService18RestFileDownloader17OnCompleteContentEv, __ZN9Animation7AddClipER13AnimationClipRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEiib: __ZN9Animation7AddClipER13AnimationClipRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEiib, __Z37AudioReverbFilter_Get_Custom_PropRoomP12Il2CppObject: __Z37AudioReverbFilter_Get_Custom_PropRoomP12Il2CppObject, __ZN6Avatar8SetAssetEPN7mecanim9animation14AvatarConstantERKNSt3__23mapIj8UnityStrNS4_4lessIjEENS4_9allocatorINS4_4pairIKjS6_EEEEEE: __ZN6Avatar8SetAssetEPN7mecanim9animation14AvatarConstantERKNSt3__23mapIj8UnityStrNS4_4lessIjEENS4_9allocatorINS4_4pairIKjS6_EEEEEE, __ZN14EmissionModule10EmitCommonER27ParticleSystemEmissionStateRjfj: __ZN14EmissionModule10EmitCommonER27ParticleSystemEmissionStateRjfj, __ZN5physx3Ext14SphericalJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext14SphericalJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN19CollisionListener2D12BeginContactEP9b2Contact: __ZN19CollisionListener2D12BeginContactEP9b2Contact, __ZN19TransportJavaScript11PostRequestEv: __ZN19TransportJavaScript11PostRequestEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_N6detail7ci_lessELb1EEENS5_IS8_EEE4findIS7_EENS_15__tree_iteratorIS8_PNS_11__tree_nodeIS8_PvEEiEERKT_, __Z32AndroidJNI_CUSTOM_SetStringField13Il2Cpp_IntPtrS_P12Il2CppString: __Z32AndroidJNI_CUSTOM_SetStringField13Il2Cpp_IntPtrS_P12Il2CppString, __Z32CustomEventData_CUSTOM_AddDoubleP12Il2CppObjectP12Il2CppStringd: __Z32CustomEventData_CUSTOM_AddDoubleP12Il2CppObjectP12Il2CppStringd, __ZNKSt3__210moneypunctIwLb1EE10pos_formatEv: __ZNKSt3__210moneypunctIwLb1EE10pos_formatEv, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj18EEERAT__Kc, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12getNbClassesEv: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12getNbClassesEv, __ZN5Unity5Joint9SetupAxesEi: __ZN5Unity5Joint9SetupAxesEi, __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11ChannelInfo8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN19SpriteMeshGenerator16GetOptimizedPathEi: __ZN19SpriteMeshGenerator16GetOptimizedPathEi, __Z50Register_UnityEngine_Gyroscope_getEnabled_Internalv: __Z50Register_UnityEngine_Gyroscope_getEnabled_Internalv, __Z27GUIText_Get_Custom_PropTextP12Il2CppObject: __Z27GUIText_Get_Custom_PropTextP12Il2CppObject, __ZN8UserList7AddUserERS_: __ZN8UserList7AddUserERS_, __ZNK8Animator17GetAnimationClipsEv: __ZNK8Animator17GetAnimationClipsEv, __Z47Animator_CUSTOM_GetCurrentAnimatorClipInfoCountP12Il2CppObjecti: __Z47Animator_CUSTOM_GetCurrentAnimatorClipInfoCountP12Il2CppObjecti, __Z52Register_UnityEngine_AndroidJNI_GetShortArrayElementv: __Z52Register_UnityEngine_AndroidJNI_GetShortArrayElementv, __Z47ParticleSystem_MainModule_CUSTOM_GetStartSize3DP12Il2CppObject: __Z47ParticleSystem_MainModule_CUSTOM_GetStartSize3DP12Il2CppObject, __Z19mono_profiler_begin21ScriptingMethodIl2CppP11Il2CppClassS_P12Il2CppObject: __Z19mono_profiler_begin21ScriptingMethodIl2CppP11Il2CppClassS_P12Il2CppObject, __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmcc: __ZNKSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcPK2tmcc, _UNITY_png_get_header_version: _UNITY_png_get_header_version, __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_: __ZN15SerializeTraitsINSt3__24pairI8StateKey10StateRangeEEE8TransferI24GenerateTypeTreeTransferEEvRS4_RT_, __ZN19SpriteMeshGenerator12path_segment12max_distanceENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii: __ZN19SpriteMeshGenerator12path_segment12max_distanceENSt3__26vectorINS_6vertexENS1_9allocatorIS3_EEEEii, __Z25scripting_class_get_flagsP11Il2CppClass: __Z25scripting_class_get_flagsP11Il2CppClass, __Z62Register_UnityEngine_AudioDistortionFilter_get_distortionLevelv: __Z62Register_UnityEngine_AudioDistortionFilter_get_distortionLevelv, __ZN5physx20PxsParticleSystemSim18removeInteractionVERKNS_16PxvParticleShapeEjjbbb: __ZN5physx20PxsParticleSystemSim18removeInteractionVERKNS_16PxvParticleShapeEjjbbb, __ZN5physx2Gu26checkOverlapOBB_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu26checkOverlapOBB_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE9push_backERKS2_: __ZNSt3__24listIN10GUIManager12SortedScriptE11memory_poolIS2_EE9push_backERKS2_, __ZNK5physx2Gu10ConvexMesh11getVerticesEv: __ZNK5physx2Gu10ConvexMesh11getVerticesEv, __ZN9ShaderLab20SerializedSubProgram12UAVParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram12UAVParameter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK5physx16PxsBroadPhaseMBP10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj: __ZNK5physx16PxsBroadPhaseMBP10getRegionsEPNS_22PxBroadPhaseRegionInfoEjj, __ZN21AudioDistortionFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN21AudioDistortionFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK21WorldParticleCollider26GetTypeInfoVirtualInternalEv: __ZNK21WorldParticleCollider26GetTypeInfoVirtualInternalEv, __ZNK11RemoveByPtr17ShouldRemoveStateEP14AnimationState: __ZNK11RemoveByPtr17ShouldRemoveStateEP14AnimationState, __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE11getTypeNameEv, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj64ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN17Physics2DSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN17Physics2DSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEED2Ev: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEED2Ev, __Z33BillboardAsset_CUSTOM_GetVerticesP12Il2CppObject: __Z33BillboardAsset_CUSTOM_GetVerticesP12Il2CppObject, __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj: __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE8recreateEj, _PxGetFoundation: _PxGetFoundation, __Z57ParticleSystem_TrailModule_CUSTOM_SetInheritParticleColorP12Il2CppObjecth: __Z57ParticleSystem_TrailModule_CUSTOM_SetInheritParticleColorP12Il2CppObjecth, __Z33PluginsInitializePreloadedPluginsv: __Z33PluginsInitializePreloadedPluginsv, __ZN5physx16PxBroadPhaseBase12removeRegionEj: __ZN5physx16PxBroadPhaseBase12removeRegionEj, __Z54ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsP12Il2CppObjectS0_S0_: __Z54ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsP12Il2CppObjectS0_S0_, __ZN5physx18NpArticulationLink9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb: __ZN5physx18NpArticulationLink9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb, __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYMultiplierv: __Z68Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetYMultiplierv, __ZN16BlendShapeVertex8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16BlendShapeVertex8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI20DeviceBlendStateGLES11memcmp_lessIS1_16DeviceBlendStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZN4FMOD5Sound13getMusicSpeedEPf: __ZN4FMOD5Sound13getMusicSpeedEPf, __ZN5physx7NpActorD2Ev: __ZN5physx7NpActorD2Ev, __ZN4PPtrI8RendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI8RendererE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18ProceduralMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z15GetAccelerationjR12Acceleration: __Z15GetAccelerationjR12Acceleration, __Z47Register_UnityEngine_Light_get_shadowNormalBiasv: __Z47Register_UnityEngine_Light_get_shadowNormalBiasv, __Z15IsDepthRTFormat19RenderTextureFormat: __Z15IsDepthRTFormat19RenderTextureFormat, __ZNKSt3__215__codecvt_utf16IDsLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IDsLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZN5physx6shdfnd18BufferedSocketImpl5writeEPKhj: __ZN5physx6shdfnd18BufferedSocketImpl5writeEPKhj, _jround_up: _jround_up, __ZN12_GLOBAL__N_124PropertyDefinitionHelper14createPropertyERKN5physx8debugger14NamespacedNameEPKcS5_NS2_12PropertyType4EnumE: __ZN12_GLOBAL__N_124PropertyDefinitionHelper14createPropertyERKN5physx8debugger14NamespacedNameEPKcS5_NS2_12PropertyType4EnumE, _cff_make_private_dict: _cff_make_private_dict, __ZN24GenerateTypeTreeTransfer18SetScriptingObjectEP12Il2CppObjecti: __ZN24GenerateTypeTreeTransfer18SetScriptingObjectEP12Il2CppObjecti, __Z26PlayerLoadSettingsAndInputRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z26PlayerLoadSettingsAndInputRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN22RenderingCommandBuffer16AddReleaseTempRTERKN9ShaderLab16FastPropertyNameE: __ZN22RenderingCommandBuffer16AddReleaseTempRTERKN9ShaderLab16FastPropertyNameE, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z56ParticleSystem_ShapeModule_CUSTOM_GetSkinnedMeshRendererP12Il2CppObject: __Z56ParticleSystem_ShapeModule_CUSTOM_GetSkinnedMeshRendererP12Il2CppObject, __ZN12_GLOBAL__N_110DataStream21beginSetPropertyValueEPKvPKcRKN5physx8debugger14NamespacedNameE: __ZN12_GLOBAL__N_110DataStream21beginSetPropertyValueEPKvPKcRKN5physx8debugger14NamespacedNameE, __ZN15RelativeJoint2DD0Ev: __ZN15RelativeJoint2DD0Ev, __Z61Register_UnityEngine_ParticleSystem_MainModule_SetScalingModev: __Z61Register_UnityEngine_ParticleSystem_MainModule_SetScalingModev, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE9setActorsEPNS_12PxRigidActorES6_, __ZN24AudioScriptBufferManager18BeforeDomainReloadEv: __ZN24AudioScriptBufferManager18BeforeDomainReloadEv, __ZN5physx2Sc5Scene31scheduleParticleShapeGenerationERNS_10PxBaseTaskES3_: __ZN5physx2Sc5Scene31scheduleParticleShapeGenerationERNS_10PxBaseTaskES3_, __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_7PxShapeENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS3_EEEEE6resizeEjRKS3_, __ZNKSt3__210moneypunctIcLb0EE8groupingEv: __ZNKSt3__210moneypunctIcLb0EE8groupingEv, __ZN4FMOD12ChannelGroup9getVolumeEPf: __ZN4FMOD12ChannelGroup9getVolumeEPf, __Z55Register_UnityEngine_QualitySettings_set_softVegetationv: __Z55Register_UnityEngine_QualitySettings_set_softVegetationv, __ZNK13WheelCollider15GetGlobalRadiusEv: __ZNK13WheelCollider15GetGlobalRadiusEv, __ZN27GenericSlowGarbageCollectorD0Ev: __ZN27GenericSlowGarbageCollectorD0Ev, __ZN9GfxDevice14SetWorldMatrixERK10Matrix4x4f: __ZN9GfxDevice14SetWorldMatrixERK10Matrix4x4f, __Z60Register_UnityEngine_ConfigurableJoint_get_rotationDriveModev: __Z60Register_UnityEngine_ConfigurableJoint_get_rotationDriveModev, __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_: __ZN5physx11HullLibrary6b2bfixEPNS_3TriES2_, __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterPropertiesv: __Z77Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterPropertiesv, __ZN17GlobalGameManagerD2Ev: __ZN17GlobalGameManagerD2Ev, __ZNK14ParticleSystem13GetStartColorEv: __ZNK14ParticleSystem13GetStartColorEv, __Z40NavMeshAgent_Set_Custom_PropWalkableMaskP12Il2CppObjecti: __Z40NavMeshAgent_Set_Custom_PropWalkableMaskP12Il2CppObjecti, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __ZN15PointEffector2D17SetForceMagnitudeEf: __ZN15PointEffector2D17SetForceMagnitudeEf, __Z18IsBuiltinArrayNamePKc: __Z18IsBuiltinArrayNamePKc, __ZN13ScreenManager23SetIsOrientationEnabledE18EnabledOrientationb: __ZN13ScreenManager23SetIsOrientationEnabledE18EnabledOrientationb, __ZN5Umbra11ArrayMapper4initEjj: __ZN5Umbra11ArrayMapper4initEjj, __Z18Transfer_BlittableI14SafeBinaryReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN17ArchiveFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior: __ZN17ArchiveFileSystem4OpenER13FileEntryData14FilePermission16FileAutoBehavior, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZNKSt3__210moneypunctIcLb1EE13thousands_sepEv: __ZNKSt3__210moneypunctIcLb1EE13thousands_sepEv, __ZN5physx2Sc16ArticulationCoreD2Ev: __ZN5physx2Sc16ArticulationCoreD2Ev, __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE10deallocateEv: __ZNSt3__26vectorI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEE10deallocateEv, __Z30AndroidJNI_CUSTOM_IsSameObject13Il2Cpp_IntPtrS_: __Z30AndroidJNI_CUSTOM_IsSameObject13Il2Cpp_IntPtrS_, __ZN5physx2Sn24readStridedFlagsPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorEPKNS_11PxU32ToNameE: __ZN5physx2Sn24readStridedFlagsPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorEPKNS_11PxU32ToNameE, __ZN5physx13PxHitCallbackINS_12PxRaycastHitEED2Ev: __ZN5physx13PxHitCallbackINS_12PxRaycastHitEED2Ev, __Z13free_internalPv: __Z13free_internalPv, __ZN16PlayerConnectionC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEtb: __ZN16PlayerConnectionC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEtb, __ZNK7dtCrowd35InsertActiveAgentsIntoProximityGridEP15dtProximityGridii: __ZNK7dtCrowd35InsertActiveAgentsIntoProximityGridEP15dtProximityGridii, __Z50Register_UnityEngine_CanvasRenderer_SetPopMaterialv: __Z50Register_UnityEngine_CanvasRenderer_SetPopMaterialv, __Z18Transfer_BlittableI9JSONWriteLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKw, __ZN16MemoryFileSystem9SetLengthER13FileEntryDatay: __ZN16MemoryFileSystem9SetLengthER13FileEntryDatay, __Z37CalculateJobCountWithMinIndicesPerJobiii: __Z37CalculateJobCountWithMinIndicesPerJobiii, __ZN5physx13NpRigidStatic7releaseEv: __ZN5physx13NpRigidStatic7releaseEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj694ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, _UNITY_png_set_alpha_mode: _UNITY_png_set_alpha_mode, __ZN8Animator18AutoMecanimDataSetD2Ev: __ZN8Animator18AutoMecanimDataSetD2Ev, __Z48Register_UnityEngine_TerrainData_Internal_Createv: __Z48Register_UnityEngine_TerrainData_Internal_Createv, __Z42AudioReverbFilter_Set_Custom_PropDecayTimeP12Il2CppObjectf: __Z42AudioReverbFilter_Set_Custom_PropDecayTimeP12Il2CppObjectf, __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB: __Z17PrepareShadowMapsRK11CullResultsRK11ActiveLightRK10MinMaxAABB, __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI19LightProbeOcclusionLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __ZN7mecanim9animation28DestroyBlendTreeNodeConstantEPNS0_21BlendTreeNodeConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation28DestroyBlendTreeNodeConstantEPNS0_21BlendTreeNodeConstantERNS_6memory9AllocatorE, __Z42RenderTexture_CUSTOM_Internal_GetDimensionP12Il2CppObject: __Z42RenderTexture_CUSTOM_Internal_GetDimensionP12Il2CppObject, __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f, __ZN20TextRenderingPrivate8FontImpl8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__get_short_sizeEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16__get_short_sizeEv, __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb: __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb, __ZN12AdsIdHandler17RequestAdsIdAsyncEP12Il2CppObject: __ZN12AdsIdHandler17RequestAdsIdAsyncEP12Il2CppObject, __ZNSt3__23mapIPKc21ScriptingMethodIl2Cpp14CStringCompare13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier1ELi16EEEixERS7_: __ZNSt3__23mapIPKc21ScriptingMethodIl2Cpp14CStringCompare13stl_allocatorINS_4pairIKS2_S3_EEL18MemLabelIdentifier1ELi16EEEixERS7_, __ZNKSt3__27collateIwE12do_transformEPKwS3_: __ZNKSt3__27collateIwE12do_transformEPKwS3_, __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z39Register_UnityEngine_Rigidbody_set_dragv: __Z39Register_UnityEngine_Rigidbody_set_dragv, __Z42FixedJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject: __Z42FixedJoint2D_Get_Custom_PropReferenceAngleP12Il2CppObject, __ZN13SparseTexture10UploadTileEiiiPKhj: __ZN13SparseTexture10UploadTileEiiiPKhj, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8max_sizeEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE8max_sizeEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, __ZNKSt3__25ctypeIwE8do_widenEPKcS3_Pw: __ZNKSt3__25ctypeIwE8do_widenEPKcS3_Pw, __Z48ParticleSystem_CollisionModule_CUSTOM_SetQualityP12Il2CppObjecti: __Z48ParticleSystem_CollisionModule_CUSTOM_SetQualityP12Il2CppObjecti, __Z26setPxJointLinearLimitValuePN5physx18PxJointLinearLimitEf: __Z26setPxJointLinearLimitValuePN5physx18PxJointLinearLimitEf, __ZN5physx18PxcSweepCapsuleBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx18PxcSweepCapsuleBoxERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN9Rigidbody25SetCollisionDetectionModeEi: __ZN9Rigidbody25SetCollisionDetectionModeEi, __ZN5physx3Ext7D6Joint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Ext7D6Joint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj467ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxRevoluteJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj467ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE19getConcreteTypeNameEv, __GLOBAL__sub_I_runtime_input_lump_cpp: __GLOBAL__sub_I_runtime_input_lump_cpp, _start_pass_huff: _start_pass_huff, __ZN5physx2Sn22DeserializationContextD0Ev: __ZN5physx2Sn22DeserializationContextD0Ev, __Z25getPxActor_DominanceGroupPKN5physx7PxActorE: __Z25getPxActor_DominanceGroupPKN5physx7PxActorE, __ZN11LightProbes23ZeroBakedLightOcclusionEv: __ZN11LightProbes23ZeroBakedLightOcclusionEv, __Z49Register_UnityEngine_WheelCollider_get_isGroundedv: __Z49Register_UnityEngine_WheelCollider_get_isGroundedv, __ZN12_GLOBAL__N_117MemoryEventClientD0Ev: __ZN12_GLOBAL__N_117MemoryEventClientD0Ev, __ZN13TargetJoint2D6CreateEv: __ZN13TargetJoint2D6CreateEv, __ZZN14ParticleSystem15InitializeClassEvEN47PreLateUpdateParticleSystemBeginUpdateAllstruct7ForwardEv: __ZZN14ParticleSystem15InitializeClassEvEN47PreLateUpdateParticleSystemBeginUpdateAllstruct7ForwardEv, _strstr: _strstr, __ZN20BufferedSocketStream4RecvEPvj: __ZN20BufferedSocketStream4RecvEPvj, __ZN5physx2Gu12TriangleMeshC2Ev: __ZN5physx2Gu12TriangleMeshC2Ev, __ZN2UI13RectTransform8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN2UI13RectTransform8TransferI24GenerateTypeTreeTransferEEvRT_, __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour: __Z63ThreadAndSerializationSafeCheckSetMonoBehaviourBeingTransferredP13MonoBehaviour, __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader: __ZN9ShaderLab10SubProgram30CreateFromSerializedSubProgramERKNS_20SerializedSubProgramEP16PropertyNamesSetPK6Shader, __ZZN13WheelCollider15InitializeClassEvEN38FunctorImpl_1263kForceRecreateCollider4CallEPviR11MessageData: __ZZN13WheelCollider15InitializeClassEvEN38FunctorImpl_1263kForceRecreateCollider4CallEPviR11MessageData, __Z55Register_UnityEngine_PhysicMaterial_set_frictionCombinev: __Z55Register_UnityEngine_PhysicMaterial_set_frictionCombinev, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEwj, __ZN26PlayerSettingsSplashScreen8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN26PlayerSettingsSplashScreen8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZN13GfxDeviceGLES27GetNativeIndexBufferPointerEP9GfxBuffer: __ZN13GfxDeviceGLES27GetNativeIndexBufferPointerEP9GfxBuffer, __ZN11PreloadData7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11PreloadData7PRODUCEE10MemLabelId18ObjectCreationMode, _UNITY_FT_Destroy_Class_sfnt_services: _UNITY_FT_Destroy_Class_sfnt_services, __ZN11MatrixStack13GetMatrix4x4fEi: __ZN11MatrixStack13GetMatrix4x4fEi, __ZN4FMOD7SystemI9getDriverEPi: __ZN4FMOD7SystemI9getDriverEPi, __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI13MonoBehaviourE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK6Avatar13GetAxisLengthEi: __ZNK6Avatar13GetAxisLengthEi, __ZNK5physx21MBPPostUpdateWorkTask7getNameEv: __ZNK5physx21MBPPostUpdateWorkTask7getNameEv, __ZNKSt3__217moneypunct_bynameIcLb0EE16do_decimal_pointEv: __ZNKSt3__217moneypunct_bynameIcLb0EE16do_decimal_pointEv, __Z70Register_UnityEngine_Profiling_Profiler_set_maxNumberOfSamplesPerFramev: __Z70Register_UnityEngine_Profiling_Profiler_set_maxNumberOfSamplesPerFramev, __Z52Register_UnityEngine_Physics2D_set_baumgarteTOIScalev: __Z52Register_UnityEngine_Physics2D_set_baumgarteTOIScalev, __ZN10SampleClip17MainThreadCleanupEv: __ZN10SampleClip17MainThreadCleanupEv, _fchownat: _fchownat, _UNITY_FT_Bitmap_Done: _UNITY_FT_Bitmap_Done, __Z32setPxRigidDynamic_AngularDampingPN5physx14PxRigidDynamicEf: __Z32setPxRigidDynamic_AngularDampingPN5physx14PxRigidDynamicEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj66ES3_NS_28PxArticulationJointDriveType4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj66ES3_NS_28PxArticulationJointDriveType4EnumES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getStiffnessFrequencyEv, __ZN4FMOD12ChannelGroup19setAudibilityFactorEf: __ZN4FMOD12ChannelGroup19setAudibilityFactorEf, __ZZN13AudioListener15InitializeClassEvEN31FunctorImpl_179kDidAddComponent4CallEPviR11MessageData: __ZZN13AudioListener15InitializeClassEvEN31FunctorImpl_179kDidAddComponent4CallEPviR11MessageData, __ZNK10SampleClip20GetCompressionFormatEv: __ZNK10SampleClip20GetCompressionFormatEv, __Z51Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK13Vector2fIcallS3_N11Rigidbody2D9ForceModeE: __Z51Rigidbody2D_CUSTOM_INTERNAL_CALL_AddForceAtPositionP12Il2CppObjectRK13Vector2fIcallS3_N11Rigidbody2D9ForceModeE, _fscanf: _fscanf, __ZN12LightsModule8TransferI14SafeBinaryReadEEvRT_: __ZN12LightsModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7NpScene17createVolumeCacheEjj: __ZN5physx7NpScene17createVolumeCacheEjj, __ZN5physx2Sc8ShapeSimD2Ev: __ZN5physx2Sc8ShapeSimD2Ev, __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass: __ZN12NativeBufferI27Converter_SimpleNativeClassI10RectOffsetEE19ProcessAfterReadingER9ArrayInfoP11Il2CppClass, _cff_subfont_load: _cff_subfont_load, __Z19tessGetElementCountP14TESStesselator: __Z19tessGetElementCountP14TESStesselator, __ZN15QualitySettings15SetBlendWeightsEi: __ZN15QualitySettings15SetBlendWeightsEi, __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeXSorterP16DetailMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR17DetailNodeXSorterP16DetailMeshBVNodeEEbT0_S5_T_, __ZN11b2RopeJointD0Ev: __ZN11b2RopeJointD0Ev, __Z54Register_UnityEngine_ReflectionProbe_get_nearClipPlanev: __Z54Register_UnityEngine_ReflectionProbe_get_nearClipPlanev, __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_12postCCDSweepEPNS_10PxBaseTaskEEEE7getNameEv, __ZN18DelayedCallManager17MainThreadCleanupEv: __ZN18DelayedCallManager17MainThreadCleanupEv, __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_9StopEventEEEbRT_: __ZN5physx7profile18EventParseOperatorINS_21PxProfileEventHandlerELb0EE18handleProfileEventINS0_9StopEventEEEbRT_, __ZN5physx10NpMaterial12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx10NpMaterial12createObjectERPhRNS_24PxDeserializationContextE, __ZN9LensFlare17RemoveFromManagerEv: __ZN9LensFlare17RemoveFromManagerEv, __ZNSt3__214__split_bufferIN19SpriteMeshGenerator4pathERNS_9allocatorIS2_EEED2Ev: __ZNSt3__214__split_bufferIN19SpriteMeshGenerator4pathERNS_9allocatorIS2_EEED2Ev, __ZN5physx12PxsRigidBody20advancePrevPoseToToiEf: __ZN5physx12PxsRigidBody20advancePrevPoseToToiEf, __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_ClearRenderTargetv: __Z76Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_ClearRenderTargetv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12find_last_ofEPKcjj, __ZN5Umbra15MemOutputStreamD0Ev: __ZN5Umbra15MemOutputStreamD0Ev, __ZN16Physics2DManager21GetRayIntersectionAllERK8Vector3fS2_fiPK10Collider2DP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager21GetRayIntersectionAllERK8Vector3fS2_fiPK10Collider2DP13dynamic_arrayI12RaycastHit2DLj4EE, __ZN9GfxDevice26InsertCustomMarkerCallbackEPFviEi: __ZN9GfxDevice26InsertCustomMarkerCallbackEPFviEi, __ZN16TimerQueriesGLES13AllocateQueryEv: __ZN16TimerQueriesGLES13AllocateQueryEv, __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_ToBooleanArrayP11Il2CppArrayRPv: __Z46AndroidJNI_CUSTOM_INTERNAL_CALL_ToBooleanArrayP11Il2CppArrayRPv, __ZNK6Object8HasEventEPFvPvS0_iEPKv: __ZNK6Object8HasEventEPFvPvS0_iEPKv, _get_current_dir_name: _get_current_dir_name, __Z25Rigidbody2D_CUSTOM_WakeUpP12Il2CppObject: __Z25Rigidbody2D_CUSTOM_WakeUpP12Il2CppObject, __ZN4crnd10dxt1_block16get_block_colorsEPNS_10color_quadIhiEEtt: __ZN4crnd10dxt1_block16get_block_colorsEPNS_10color_quadIhiEEtt, __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_: __ZN5physx7profile17MemoryEventParserILb1EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_16StringTableEventERKNS0_17MemoryEventHeaderERT_, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE20setActorFlagInternalENS_11PxActorFlag4EnumEb: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE20setActorFlagInternalENS_11PxActorFlag4EnumEb, __ZN8Animator10SetTriggerEi: __ZN8Animator10SetTriggerEi, __ZN10AtomicList5TouchEi: __ZN10AtomicList5TouchEi, __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim12statemachine13StateConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc18TriggerInteractionEEEEEE15growAndPushBackERKS2_, __ZNK5physx2Gu11HeightField27getTriangleAdjacencyIndicesEjjjjRjS2_S2_: __ZNK5physx2Gu11HeightField27getTriangleAdjacencyIndicesEjjjjRjS2_S2_, __ZN19SkinnedMeshRenderer30CalculateAnimatedPosesWithRootERK10Matrix4x4fPS0_j: __ZN19SkinnedMeshRenderer30CalculateAnimatedPosesWithRootERK10Matrix4x4fPS0_j, __ZNK5physx2Sn22DeserializationContext15getPhysXVersionEv: __ZNK5physx2Sn22DeserializationContext15getPhysXVersionEv, __ZN13GfxDeviceGLES12SetWireframeEb: __ZN13GfxDeviceGLES12SetWireframeEb, __ZN15ConstantForce2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15ConstantForce2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx13NpVolumeCache10invalidateEv: __ZN5physx13NpVolumeCache10invalidateEv, __Z23TransferScriptingObjectI9JSONWriteEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI9JSONWriteEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN12_GLOBAL__N_111StreamOwner6unlockEv: __ZN12_GLOBAL__N_111StreamOwner6unlockEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj418ENS_22PxRepXPropertyAccessorILj418ENS_7PxJointEffEEEEvRKT0_, __ZN18AudioLowPassFilterD0Ev: __ZN18AudioLowPassFilterD0Ev, _strtoll: _strtoll, __ZN31CanvasBatchIntermediateRendererD0Ev: __ZN31CanvasBatchIntermediateRendererD0Ev, __ZN5physx2Gu12TriangleMesh20checkMeshIndicesSizeEv: __ZN5physx2Gu12TriangleMesh20checkMeshIndicesSizeEv, __Z37Register_UnityEngine_GL_set_sRGBWritev: __Z37Register_UnityEngine_GL_set_sRGBWritev, __ZN15AudioEchoFilter8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15AudioEchoFilter8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE: __ZN7mecanim5human20HumanGetHintPositionEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEENS0_4GoalE, __ZNK5Unity10HingeJoint26GetTypeInfoVirtualInternalEv: __ZNK5Unity10HingeJoint26GetTypeInfoVirtualInternalEv, __Z50Register_UnityEngine_ParticleEmitter_set_minEnergyv: __Z50Register_UnityEngine_ParticleEmitter_set_minEnergyv, __ZN7ApiGLES12DeleteShaderERj: __ZN7ApiGLES12DeleteShaderERj, __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z44NavMeshAgent_CUSTOM_INTERNAL_set_destinationP12Il2CppObjectRK8Vector3f: __Z44NavMeshAgent_CUSTOM_INTERNAL_set_destinationP12Il2CppObjectRK8Vector3f, __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv: __ZN2UI6Canvas29EncapsulateChildrenMeshBoundsEv, __ZN7dtCrowd16UpdateFilterCostEif: __ZN7dtCrowd16UpdateFilterCostEif, __ZN5physx14PxsAABBManager20selfCollideAggregateERKNS_19AggregateSortedDataERKNS_9AggregateEPNS_17SelfCollideBitmapE: __ZN5physx14PxsAABBManager20selfCollideAggregateERKNS_19AggregateSortedDataERKNS_9AggregateEPNS_17SelfCollideBitmapE, __Z39Register_UnityEngine_Rigidbody_get_massv: __Z39Register_UnityEngine_Rigidbody_get_massv, __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf: __ZN5physx2Sc7BodySim26calculateKinematicVelocityEf, __ZL21CarveJobMultithreadedP12CarveJobInfoj: __ZL21CarveJobMultithreadedP12CarveJobInfoj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEEclILj62ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN23b2EdgeAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN23b2EdgeAndCapsuleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN5physx9NpFactory15addArticulationEPNS_14PxArticulationEb: __ZN5physx9NpFactory15addArticulationEPNS_14PxArticulationEb, __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_: __ZNSt3__26__sortIR23CompareReflectionProbesP24ReflectionProbeBlendInfoEEvT0_S5_T_, __ZN12CubemapArrayC2E10MemLabelId18ObjectCreationMode: __ZN12CubemapArrayC2E10MemLabelId18ObjectCreationMode, __Z20GetPathNameExtensionPKcj: __Z20GetPathNameExtensionPKcj, __Z57Register_UnityEngine_Gyroscope_getUpdateInterval_Internalv: __Z57Register_UnityEngine_Gyroscope_getUpdateInterval_Internalv, __Z38Renderer_Get_Custom_PropSharedMaterialP12Il2CppObject: __Z38Renderer_Get_Custom_PropSharedMaterialP12Il2CppObject, __Z40PhysicMaterial_Set_Custom_PropBouncinessP12Il2CppObjectf: __Z40PhysicMaterial_Set_Custom_PropBouncinessP12Il2CppObjectf, __Z57Register_UnityEngine_Random_INTERNAL_get_insideUnitSpherev: __Z57Register_UnityEngine_Random_INTERNAL_get_insideUnitSpherev, __Z50Register_UnityEngine_DynamicGI_set_updateThresholdv: __Z50Register_UnityEngine_DynamicGI_set_updateThresholdv, _start_pass_main: _start_pass_main, __ZN5physx6shdfnd8SyncImpl3setEv: __ZN5physx6shdfnd8SyncImpl3setEv, __ZN5Unity17ConfigurableJoint9SetXDriveERK10JointDrive: __ZN5Unity17ConfigurableJoint9SetXDriveERK10JointDrive, __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE: __ZN5physx2Gu33MultiplePersistentContactManifold34addManifoldContactsToContactBufferERNS0_13ContactBufferERKNS_6shdfnd3aos12PsTransformVES8_RKNS5_6FloatVE, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7setNameEPKc, __Z24RegisterStrippedTypeInfoI15FrictionJoint2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI15FrictionJoint2DEviPKcS2_, __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS3_L18MemLabelIdentifier51ELi16EEEEEvRT_j, __Z12testransEvalP10TESSvertexS0_S0_: __Z12testransEvalP10TESSvertexS0_S0_, __ZN11MonoManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11MonoManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage: __ZN11MonoManager25GetAssemblyIndexFromImageEPK11Il2CppImage, __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRNS_6__lessI11CulledLightS2_EEPS2_EEvT0_S6_T_, __ZL12TouchHandleriPK20EmscriptenTouchEventPv: __ZL12TouchHandleriPK20EmscriptenTouchEventPv, __Z39RelativeJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf: __Z39RelativeJoint2D_Set_Custom_PropMaxForceP12Il2CppObjectf, __ZNK5physx3Ext13DistanceJoint14getMaxDistanceEv: __ZNK5physx3Ext13DistanceJoint14getMaxDistanceEv, __ZZN8VRDevice10InitializeEbEN29FrameEventsVRBeginFramestruct7ForwardEv: __ZZN8VRDevice10InitializeEbEN29FrameEventsVRBeginFramestruct7ForwardEv, __ZNK5physx7PxCloth8isKindOfEPKc: __ZNK5physx7PxCloth8isKindOfEPKc, __ZN5physx2Sc5Scene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE: __ZN5physx2Sc5Scene24setContactModifyCallbackEPNS_23PxContactModifyCallbackE, __ZN16MessageForwarderC2ERKS_: __ZN16MessageForwarderC2ERKS_, __ZN16MemoryFileSystem4CopyER13FileEntryDataS1_: __ZN16MemoryFileSystem4CopyER13FileEntryDataS1_, __ZN12ImageDecoderC2Ev: __ZN12ImageDecoderC2Ev, __ZN20SoundChannelInstance12UpdateVolumeEv: __ZN20SoundChannelInstance12UpdateVolumeEv, __ZN5physx9PxTaskMgr16setCpuDispatcherERNS_15PxCpuDispatcherE: __ZN5physx9PxTaskMgr16setCpuDispatcherERNS_15PxCpuDispatcherE, __Z52ParticleSystem_SubEmittersModule_CUSTOM_GetCollisionP12Il2CppObjecti: __Z52ParticleSystem_SubEmittersModule_CUSTOM_GetCollisionP12Il2CppObjecti, __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j: __ZNK5physx29PxPrismaticJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEEEEjT_j, __Z43getPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataEj: __Z43getPxVehicleWheelsSimData_WheelCentreOffsetPKN5physx22PxVehicleWheelsSimDataEj, __ZN14ParticleSystem4StopE26ParticleSystemStopBehavior: __ZN14ParticleSystem4StopE26ParticleSystemStopBehavior, __Z30GameObject_CUSTOM_GetComponentP12Il2CppObjectS0_: __Z30GameObject_CUSTOM_GetComponentP12Il2CppObjectS0_, __ZNK22NavMeshProjectSettings15GetAreaFromNameERK8UnityStr: __ZNK22NavMeshProjectSettings15GetAreaFromNameERK8UnityStr, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_24NpPtrTableStorageManager8PtrBlockILi4EEEEEEEE15growAndPushBackERKS2_, __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_18PxArticulationLinkEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE: __ZN5physx2Sn12handleShapesINS0_21RepXVisitorWriterBaseINS_18PxArticulationLinkEEEEEvRT_RKNS_27PxRigidActorShapeCollectionE, __Z47Register_UnityEngine_Camera_RemoveCommandBufferv: __Z47Register_UnityEngine_Camera_RemoveCommandBufferv, __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMaxv: __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMaxv, __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_2Gu10RTreeNodeQENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE25getRelativeLinearVelocityEv: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE25getRelativeLinearVelocityEv, __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN9UdpSocket4OpenEPKci: __ZN9UdpSocket4OpenEPKci, __ZN5physx13NpClothFabricD2Ev: __ZN5physx13NpClothFabricD2Ev, __Z38setPxParticleBase_ExternalAccelerationPN5physx14PxParticleBaseERKNS_6PxVec3E: __Z38setPxParticleBase_ExternalAccelerationPN5physx14PxParticleBaseERKNS_6PxVec3E, __ZN11JSONUtility17DeserializeObjectERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP11Il2CppClassS5_24TransferInstructionFlags: __ZN11JSONUtility17DeserializeObjectERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP11Il2CppClassS5_24TransferInstructionFlags, __ZN5physx2Sc5Scene18setSolverBatchSizeEj: __ZN5physx2Sc5Scene18setSolverBatchSizeEj, __ZN13GfxDeviceNull19SetUserBackfaceModeEb: __ZN13GfxDeviceNull19SetUserBackfaceModeEb, __ZN9LensFlareD0Ev: __ZN9LensFlareD0Ev, __Z24setPxJoint_InvMassScale1PN5physx7PxJointEf: __Z24setPxJoint_InvMassScale1PN5physx7PxJointEf, __ZNSt3__211__stdoutbufIcE6xsputnEPKci: __ZNSt3__211__stdoutbufIcE6xsputnEPKci, __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_: __ZNKSt3__26__treeINS_12__value_typeI8UnityStrN7VRInput17TrackedDeviceInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEE13stl_allocatorIS5_L18MemLabelIdentifier87ELi16EEE4findIS2_EENS_21__tree_const_iteratorIS5_PNS_11__tree_nodeIS5_PvEEiEERKT_, __ZN5physx24PxcContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx24PxcContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z51Register_UnityEngine_Collider2D_INTERNAL_set_offsetv: __Z51Register_UnityEngine_Collider2D_INTERNAL_set_offsetv, __ZN13dynamic_arrayI12LightmapDataLj4EE5clearEv: __ZN13dynamic_arrayI12LightmapDataLj4EE5clearEv, __ZN7mecanim5human14RetargetToTDoFEPKNS0_5HumanEPNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESB_: __ZN7mecanim5human14RetargetToTDoFEPKNS0_5HumanEPNS0_9HumanPoseEPNS_8skeleton13SkeletonPoseTIN4math4trsXEEESB_, __Z34MaterialPropertyBlock_CUSTOM_ClearP12Il2CppObject: __Z34MaterialPropertyBlock_CUSTOM_ClearP12Il2CppObject, __Z61Register_UnityEngine_RenderSettings_set_defaultReflectionModev: __Z61Register_UnityEngine_RenderSettings_set_defaultReflectionModev, __ZN5physx16PxsBroadPhaseMBP11freeBuffersEv: __ZN5physx16PxsBroadPhaseMBP11freeBuffersEv, __ZN17AnimationCurveTplIfE14SetPreInfinityEi: __ZN17AnimationCurveTplIfE14SetPreInfinityEi, __Z46Register_UnityEngine_Camera_get_opaqueSortModev: __Z46Register_UnityEngine_Camera_get_opaqueSortModev, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetcEv: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE5sgetcEv, __Z29getPxCloth_CollisionMassScalePKN5physx7PxClothE: __Z29getPxCloth_CollisionMassScalePKN5physx7PxClothE, _UNITY_png_handle_sBIT: _UNITY_png_handle_sBIT, __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EE13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS8_EERSE_: __ZNSt3__26vectorINS_4pairINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EE13stl_allocatorIS8_L18MemLabelIdentifier37ELi16EEE6insertENS_11__wrap_iterIPKS8_EERSE_, __ZN4FMOD7Channel11getWaveDataEPfii: __ZN4FMOD7Channel11getWaveDataEPfii, _sfnt_done_face: _sfnt_done_face, __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE: __ZN9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE10FindMemberIS3_EENS_21GenericMemberIteratorILb0ES2_S3_EERKNS0_IS2_T_EE, __Z41Rigidbody2D_Get_Custom_PropFreezeRotationP12Il2CppObject: __Z41Rigidbody2D_Get_Custom_PropFreezeRotationP12Il2CppObject, __ZNK8Animator13GetLayerCountEv: __ZNK8Animator13GetLayerCountEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jjRKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2ERKS5_jjRKS4_, __ZN31CanvasBatchIntermediateRenderer10InitializeEPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS4_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb: __ZN31CanvasBatchIntermediateRenderer10InitializeEPN2UI6CanvasEP15SharedGfxBufferP17VertexDeclarationjS4_RK10Matrix4x4ftRK4AABB4PPtrI8MaterialEi17ShadowCastingModeb, __ZN21AnimationClipPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE: __ZN21AnimationClipPlayable22SetStateMachineMessageEN7mecanim12statemachine19StateMachineMessageE, __ZN9TextAsset13AwakeFromLoadE17AwakeFromLoadMode: __ZN9TextAsset13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE15getSerializableEv, _UNITY_FT_Create_Class_tt_services: _UNITY_FT_Create_Class_tt_services, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE13isSubordinateEv: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE13isSubordinateEv, __ZN10GCProfiler10ResetStatsEv: __ZN10GCProfiler10ResetStatsEv, __Z60Register_UnityEngine_QualitySettings_set_shadowCascade2Splitv: __Z60Register_UnityEngine_QualitySettings_set_shadowCascade2Splitv, __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthZMultiplierP12Il2CppObjectf: __Z56ParticleSystem_NoiseModule_CUSTOM_SetStrengthZMultiplierP12Il2CppObjectf, __ZN16BaseVideoTexture4StopEv: __ZN16BaseVideoTexture4StopEv, __ZN15b2DistanceJointD0Ev: __ZN15b2DistanceJointD0Ev, __ZNK13SparseTexture26GetTypeInfoVirtualInternalEv: __ZNK13SparseTexture26GetTypeInfoVirtualInternalEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN13AnimationClip12Vector3CurveE13stl_allocatorIS4_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z43Register_UnityEngine_Application_ForceCrashv: __Z43Register_UnityEngine_Application_ForceCrashv, __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10Collider2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __Z24IsTouchPressureSupportedv: __Z24IsTouchPressureSupportedv, __Z47Register_UnityEngine_CapsuleCollider_get_radiusv: __Z47Register_UnityEngine_CapsuleCollider_get_radiusv, __ZN5physx2Gu15sweepCapsuleBoxERKNS0_7CapsuleERKNS_11PxTransformERKNS_6PxVec3ES9_fRS7_RfSA_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu15sweepCapsuleBoxERKNS0_7CapsuleERKNS_11PxTransformERKNS_6PxVec3ES9_fRS7_RfSA_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZN10GCProfiler18PrintDetailedStatsEb: __ZN10GCProfiler18PrintDetailedStatsEb, __ZN5physx2Sc19ConstraintGroupNode18initProjectionDataEPS1_PNS0_13ConstraintSimE: __ZN5physx2Sc19ConstraintGroupNode18initProjectionDataEPS1_PNS0_13ConstraintSimE, __ZN19SkinnedMeshRenderer22CreateSkinMatricesTaskEP10Matrix4x4fjbb: __ZN19SkinnedMeshRenderer22CreateSkinMatricesTaskEP10Matrix4x4fjbb, __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7GetFreeEi: __ZN10ObjectPoolIN4FMOD7ChannelENS0_8ChannelIEE7GetFreeEi, __Z39Register_UnityEngine_PlayerPrefs_GetIntv: __Z39Register_UnityEngine_PlayerPrefs_GetIntv, __ZN11UnityEngine15PlatformWrapper33GetCurrentMillisecondsInLocalTimeEv: __ZN11UnityEngine15PlatformWrapper33GetCurrentMillisecondsInLocalTimeEv, _UNITY_png_colorspace_set_endpoints: _UNITY_png_colorspace_set_endpoints, __ZN5physx16PxsParticleShapeD2Ev: __ZN5physx16PxsParticleShapeD2Ev, __ZN5physx2Sc15ArticulationSim7addBodyERNS0_7BodySimEPS2_PNS0_20ArticulationJointSimE: __ZN5physx2Sc15ArticulationSim7addBodyERNS0_7BodySimEPS2_PNS0_20ArticulationJointSimE, __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_24PxsConstraintBatchHeaderEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvS3_jRNS_16PxcSolverContextES7_jPiE: __ZNK5physx20PxsSolverCoreGeneral10writeBackVEPKNS_23PxcSolverConstraintDescEjPNS_24PxsConstraintBatchHeaderEjPNS_25PxcThresholdStreamElementEjRjPNS_17PxcSolverBodyDataEPPFvS3_jRNS_16PxcSolverContextES7_jPiE, __ZN5physx9NpDestroyERNS_3Scb4BaseE: __ZN5physx9NpDestroyERNS_3Scb4BaseE, __ZN5Unity5Cloth19SetBendingStiffnessEf: __ZN5Unity5Cloth19SetBendingStiffnessEf, __ZN14PhysicsManager7AddBodyEiR8ListNodeI9RigidbodyE: __ZN14PhysicsManager7AddBodyEiR8ListNodeI9RigidbodyE, __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E: __ZN5physxlsERNS_14PxOutputStreamERKNS_6PxVec3E, __ZN5physx7NpScene16addParticleFluidERNS_15NpParticleFluidE: __ZN5physx7NpScene16addParticleFluidERNS_15NpParticleFluidE, __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRatiov: __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRatiov, _UNITY_png_set_sig_bytes: _UNITY_png_set_sig_bytes, __Z38MaterialPropertyBlock_CUSTOM_InitBlockP12Il2CppObject: __Z38MaterialPropertyBlock_CUSTOM_InitBlockP12Il2CppObject, __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE: __Z18ReadStringFromFilePNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEERKNS0_IcS2_NS_9allocatorIcEEEE, __Z33WheelCollider_Set_Custom_PropMassP12Il2CppObjectf: __Z33WheelCollider_Set_Custom_PropMassP12Il2CppObjectf, __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetLookAtPositionInternalv: __Z69Register_UnityEngine_Animator_INTERNAL_CALL_SetLookAtPositionInternalv, __Z32Behaviour_Get_Custom_PropEnabledP12Il2CppObject: __Z32Behaviour_Get_Custom_PropEnabledP12Il2CppObject, __Z21BindGenericFloatCurveRK7CurveIDRP6ObjectP10GameObjectP9TransformRPvRiRN11UnityEngine9Animation10BoundCurveE: __Z21BindGenericFloatCurveRK7CurveIDRP6ObjectP10GameObjectP9TransformRPvRiRN11UnityEngine9Animation10BoundCurveE, __ZN4PPtrI14SphereColliderE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI14SphereColliderE8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERNS_15basic_streambufIcS2_EE, __ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj: __ZL20applyAllPreFiltersSQPKN5physx2Sq13PxActorShape2ERNS_14PxQueryHitType4EnumERKNS_7PxFlagsINS_11PxQueryFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackERKNS_14NpSceneQueriesEPNS_20BatchQueryFilterDataERNS7_INS_9PxHitFlag4EnumEtEEj, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEEEEEvRT_17TransferMetaFlags, __Z17GenerateRandomNx3RKN4math5_int4E: __Z17GenerateRandomNx3RKN4math5_int4E, __Z34setPxVehicleDriveTankMDriveSimDataPN5physx18PxVehicleDriveTankENS_21PxVehicleDriveSimDataE: __Z34setPxVehicleDriveTankMDriveSimDataPN5physx18PxVehicleDriveTankENS_21PxVehicleDriveSimDataE, __ZN5physx3Cct10Controller9onReleaseEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE: __ZN5physx3Cct10Controller9onReleaseEPKNS_6PxBaseEPvNS_19PxDeletionEventFlag4EnumE, __ZN13AnimationClip15InitializeClassEv: __ZN13AnimationClip15InitializeClassEv, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17getStaticFrictionEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE17getStaticFrictionEv, __ZN2UI13RectTransform23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN2UI13RectTransform23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5Unity12PhysicsQuery7BoxCastERK8Vector3fS3_S3_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery7BoxCastERK8Vector3fS3_S3_RK11QuaternionffR10RaycastHiti23QueryTriggerInteraction, __ZN5physx2Gu21computeMTD_CapsuleBoxERNS_6PxVec3ERfRKNS0_7CapsuleERKNS0_3BoxE: __ZN5physx2Gu21computeMTD_CapsuleBoxERNS_6PxVec3ERfRKNS0_7CapsuleERKNS0_3BoxE, __ZN12TreeInstance8TransferI14SafeBinaryReadEEvRT_: __ZN12TreeInstance8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19islandGenSecondPassEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx6shdfnd6TlsGetEj: __ZN5physx6shdfnd6TlsGetEj, __Z43Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestAllP12Il2CppObjectRK8Vector3ff23QueryTriggerInteraction: __Z43Rigidbody_CUSTOM_INTERNAL_CALL_SweepTestAllP12Il2CppObjectRK8Vector3ff23QueryTriggerInteraction, __ZN5physx7NpScene22checkCollisionInternalEb: __ZN5physx7NpScene22checkCollisionInternalEb, __ZN21AnimationPosePlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant: __ZN21AnimationPosePlayable25AnimationPlayableAllocateEP35AnimationPlayableEvaluationConstant, __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE: __ZNSt3__26__treeINS_12__value_typeIPN2UI6CanvasENS_3setIPNS2_14CanvasRendererENS_4lessIS7_EENS_9allocatorIS7_EEEEEENS_19__map_value_compareIS4_SD_NS8_IS4_EELb1EEENSA_ISD_EEE7destroyEPNS_11__tree_nodeISD_PvEE, __Z57Register_UnityEngine_Rigidbody_get_collisionDetectionModev: __Z57Register_UnityEngine_Rigidbody_get_collisionDetectionModev, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_16NpParticleSystemEEEEEvPT_jRKT0_RKT1_j, __ZNK24NavMeshSceneDataRegistry9GetScenesER13dynamic_arrayIiLj4EEPK11NavMeshData: __ZNK24NavMeshSceneDataRegistry9GetScenesER13dynamic_arrayIiLj4EEPK11NavMeshData, __Z50Register_UnityEngine_Joint_set_enablePreprocessingv: __Z50Register_UnityEngine_Joint_set_enablePreprocessingv, __ZN5physx20PxsParticleSystemSim19obtainParticleStateEv: __ZN5physx20PxsParticleSystemSim19obtainParticleStateEv, __ZNK6Camera21ViewportToScreenPointERK8Vector3f: __ZNK6Camera21ViewportToScreenPointERK8Vector3f, __ZN5physx3Ext15CpuWorkerThreadC2Ev: __ZN5physx3Ext15CpuWorkerThreadC2Ev, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN9Rigidbody9AddTorqueERK8Vector3fi: __ZN9Rigidbody9AddTorqueERK8Vector3fi, __Z38MeshCollider_Get_Custom_PropSharedMeshP12Il2CppObject: __Z38MeshCollider_Get_Custom_PropSharedMeshP12Il2CppObject, __ZN12TreeRenderer10InjectTreeERK12TreeInstance: __ZN12TreeRenderer10InjectTreeERK12TreeInstance, __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE14processTouchesEPKS1_j: __ZN16PxOverflowBufferIN5physx12PxRaycastHitEE14processTouchesEPKS1_j, __ZNK5physx13ActorAABBTask7getNameEv: __ZNK5physx13ActorAABBTask7getNameEv, __ZN22ParticleSystemRenderer21RendererBecameVisibleEv: __ZN22ParticleSystemRenderer21RendererBecameVisibleEv, __ZN27AnimatorControllerParameter15SetDefaultFloatEf: __ZN27AnimatorControllerParameter15SetDefaultFloatEf, __ZN7dtCrowd9moveAgentERK13dtCrowdHandlePKf: __ZN7dtCrowd9moveAgentERK13dtCrowdHandlePKf, __ZN6Sprite8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN6Sprite8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx13addConstraintERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_: __ZN5physx13addConstraintERNS_19PxsParticleCollDataERKNS_6PxVec3ES4_, __Z59ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterSystemP12Il2CppObjectiS0_: __Z59ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterSystemP12Il2CppObjectiS0_, __ZN13MonoBehaviour14StartCoroutineEPKcP12Il2CppObject: __ZN13MonoBehaviour14StartCoroutineEPKcP12Il2CppObject, __Z46ParticleSystem_EmissionModule_CUSTOM_GetBurstsP12Il2CppObjectP11Il2CppArray: __Z46ParticleSystem_EmissionModule_CUSTOM_GetBurstsP12Il2CppObjectP11Il2CppArray, __ZN5physx8debugger4comm28SendPropertyMessageFromGroup9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm28SendPropertyMessageFromGroup9serializeERNS1_15EventSerializerE, __ZL24CleanupPrepassRenderLoopPv: __ZL24CleanupPrepassRenderLoopPv, __Z51RenderSettings_Get_Custom_PropDefaultReflectionModev: __Z51RenderSettings_Get_Custom_PropDefaultReflectionModev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_11NpAggregateEEEE15growAndPushBackERKS2_, _UNITY_FT_Create_Class_ft_smooth_lcdv_renderer_class: _UNITY_FT_Create_Class_ft_smooth_lcdv_renderer_class, __ZN4FMOD13ChannelGroupI7getMuteEPb: __ZN4FMOD13ChannelGroupI7getMuteEPb, __ZN5physx2Sn18RecursiveTraversalD2Ev: __ZN5physx2Sn18RecursiveTraversalD2Ev, __ZN5physx2Sc5Actor22deactivateInteractionsEj: __ZN5physx2Sc5Actor22deactivateInteractionsEj, __ZN10dtNodePool7getNodeEy: __ZN10dtNodePool7getNodeEy, __ZN4FMOD8ChannelI12getFrequencyEPf: __ZN4FMOD8ChannelI12getFrequencyEPf, __Z28Font_Get_Custom_PropFontSizeP12Il2CppObject: __Z28Font_Get_Custom_PropFontSizeP12Il2CppObject, __Z33setPxVehicleDriveDynData_GearDownPN5physx21PxVehicleDriveDynDataEb: __Z33setPxVehicleDriveDynData_GearDownPN5physx21PxVehicleDriveDynDataEb, __Z18CalculateWorldAABBR10GameObjectP4AABB: __Z18CalculateWorldAABBR10GameObjectP4AABB, __ZN5physx9NpFactory17addParticleSystemEPNS_16PxParticleSystemEb: __ZN5physx9NpFactory17addParticleSystemEPNS_16PxParticleSystemEb, __ZN11dtPathQueue6updateEiPi: __ZN11dtPathQueue6updateEiPi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj624ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj624ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN15DirectorManager14ConnectionPool8DestructEv: __ZN15DirectorManager14ConnectionPool8DestructEv, __ZN9SubModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9SubModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15AnchoredJoint2D18SetConnectedAnchorERK8Vector2f: __ZN15AnchoredJoint2D18SetConnectedAnchorERK8Vector2f, __ZN7mecanim12statemachine10StartStateERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEb: __ZN7mecanim12statemachine10StartStateERKNS0_20StateMachineConstantERKNS0_17StateMachineInputERNS0_18StateMachineOutputERNS0_18StateMachineMemoryEb, __ZN11UnityEngine9Animation29CreateAnimatorGenericBindingsERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEbRNS6_6memory9AllocatorER8Animator: __ZN11UnityEngine9Animation29CreateAnimatorGenericBindingsERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEbRNS6_6memory9AllocatorER8Animator, __Z28SortingLayer_CUSTOM_NameToIDP12Il2CppString: __Z28SortingLayer_CUSTOM_NameToIDP12Il2CppString, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEEC2EPNS_19PxAllocatorCallbackEPKcjRKS2_, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE18flushProfileEventsEv, __Z45DownloadHandlerTexture_CUSTOM_InternalGetDataP12Il2CppObject: __Z45DownloadHandlerTexture_CUSTOM_InternalGetDataP12Il2CppObject, __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Raycastv: __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Raycastv, __ZN11MonoManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11MonoManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformWWWEv: __ZN11UnityEngine15CloudWebService13WWWRestClient10PerformWWWEv, __ZN8AnimatorD0Ev: __ZN8AnimatorD0Ev, __ZN6b2DrawC2Ev: __ZN6b2DrawC2Ev, __ZNK6Camera20GetClipToWorldMatrixER10Matrix4x4f: __ZNK6Camera20GetClipToWorldMatrixER10Matrix4x4f, _gzflush: _gzflush, __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEj: __ZNSt3__26vectorIfNS_9allocatorIfEEE8__appendEj, __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI24GenerateTypeTreeTransfer27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN4FMOD6System17set3DNumListenersEi: __ZN4FMOD6System17set3DNumListenersEi, __ZN8Animator24GetAnimatorClipInfoCountEib: __ZN8Animator24GetAnimatorClipInfoCountEib, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setAngularDragERKNS_6PxVec3E, __ZNK5physx14NpSpatialIndex7overlapERKNS_9PxBounds3ERNS_24PxSpatialOverlapCallbackE: __ZNK5physx14NpSpatialIndex7overlapERKNS_9PxBounds3ERNS_24PxSpatialOverlapCallbackE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj467ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj467ES3_RKNS_23PxJointAngularLimitPairES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z12pqExtractMinP9PriorityQ: __Z12pqExtractMinP9PriorityQ, __ZN13MonoBehaviour25TransferEngineAndInstanceI17RemapPPtrTransferEEvRT_: __ZN13MonoBehaviour25TransferEngineAndInstanceI17RemapPPtrTransferEEvRT_, __ZN14SerializedFile14AddExternalRefERK14FileIdentifier: __ZN14SerializedFile14AddExternalRefERK14FileIdentifier, __Z55Register_UnityEngine_Connect_UnityAdsSettings_GetGameIdv: __Z55Register_UnityEngine_Connect_UnityAdsSettings_GetGameIdv, __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE: __ZN5physx2Sc10NPhaseCore37removeFromPersistentContactEventPairsEPNS0_19ShapeInstancePairLLE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4syncEv: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4syncEv, __ZN14CachingManager18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN14CachingManager18DidLoadAssetBundleERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp: __ZN19ScriptingInvocationC2EP12Il2CppObject21ScriptingMethodIl2Cpp, __ZNK8Material6GetTagEib: __ZNK8Material6GetTagEib, __Z42ParticleSystem_ShapeModule_CUSTOM_GetAngleP12Il2CppObject: __Z42ParticleSystem_ShapeModule_CUSTOM_GetAngleP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj421ENS_7PxJointEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj657ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z52Register_UnityEngine_MaterialPropertyBlock_InitBlockv: __Z52Register_UnityEngine_MaterialPropertyBlock_InitBlockv, __ZN15SharedLightDataD0Ev: __ZN15SharedLightDataD0Ev, __ZN2UI6Canvas8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN2UI6Canvas8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN20TextRenderingPrivate17TextMeshGeneratorENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN14AvatarPlaybackC2E10MemLabelId: __ZN14AvatarPlaybackC2E10MemLabelId, __Z39Texture2D_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiRK10ColorRGBAf: __Z39Texture2D_CUSTOM_INTERNAL_CALL_SetPixelP12Il2CppObjectiiRK10ColorRGBAf, __Z24getPxCloth_StretchConfigPKN5physx7PxClothENS_22PxClothFabricPhaseType4EnumE: __Z24getPxCloth_StretchConfigPKN5physx7PxClothENS_22PxClothFabricPhaseType4EnumE, __ZN5physx2Gu30checkOverlapCapsule_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE: __ZN5physx2Gu30checkOverlapCapsule_sphereGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_7CapsuleE, __ZN5physx2Gu22computePlane_ConvexMTDERKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformERNS_10PxSweepHitE: __ZN5physx2Gu22computePlane_ConvexMTDERKNS_7PxPlaneERKNS_20PxConvexMeshGeometryERKNS_11PxTransformERNS_10PxSweepHitE, __ZN5physx17PxcNpMemBlockPoolC2ERNS_19PxcScratchAllocatorE: __ZN5physx17PxcNpMemBlockPoolC2ERNS_19PxcScratchAllocatorE, _isupper_l: _isupper_l, __ZN16b2PrismaticJoint13SetMotorSpeedEf: __ZN16b2PrismaticJoint13SetMotorSpeedEf, __ZN5Umbra18ImpCameraTransform6updateEv: __ZN5Umbra18ImpCameraTransform6updateEv, __ZNK8VRDevice10GetEnabledEv: __ZNK8VRDevice10GetEnabledEv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_12NpConstraintEEEEEE15growAndPushBackERKS2_, __Z23dtNavMeshDataSwapEndianPhi: __Z23dtNavMeshDataSwapEndianPhi, __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_MainModule_CUSTOM_SetStartRotationXP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx15PxsParticleData13addParticlesVERKNS_22PxParticleCreationDataE: __ZN5physx15PxsParticleData13addParticlesVERKNS_22PxParticleCreationDataE, __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo: __Z17GetSceneBuildInfoRK8UnityStriR14SceneBuildInfo, __Z50ParticleSystem_EmissionModule_CUSTOM_GetBurstCountP12Il2CppObject: __Z50ParticleSystem_EmissionModule_CUSTOM_GetBurstCountP12Il2CppObject, __ZN9GfxDevice8OnCreateEv: __ZN9GfxDevice8OnCreateEv, __ZN2gl15IsFormatIEEE754ENS_9TexFormatE: __ZN2gl15IsFormatIEEE754ENS_9TexFormatE, __ZN5physx2Sc19ClothFabricBulkData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc19ClothFabricBulkData17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN19AutoOffMeshLinkData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN19AutoOffMeshLinkData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Umbra10StatsAlloc10deallocateEPv: __ZN5Umbra10StatsAlloc10deallocateEPv, __ZN25PostFilteredUserCollector10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE: __ZN25PostFilteredUserCollector10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE, __Z51ShaderVariantCollection_Get_Custom_PropVariantCountP12Il2CppObject: __Z51ShaderVariantCollection_Get_Custom_PropVariantCountP12Il2CppObject, __ZN2UI6Canvas9SetCameraE4PPtrI6CameraE: __ZN2UI6Canvas9SetCameraE4PPtrI6CameraE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEclILj280ES3_PNS_14PxTriangleMeshES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetMaxLightsv: __Z61Register_UnityEngine_ParticleSystem_LightsModule_SetMaxLightsv, __ZN5physx3Cct13BoxController14setUpDirectionERKNS_6PxVec3E: __ZN5physx3Cct13BoxController14setUpDirectionERKNS_6PxVec3E, _UNITY_png_write_find_filter: _UNITY_png_write_find_filter, __Z54Register_UnityEngine_Physics2D_get_alwaysShowCollidersv: __Z54Register_UnityEngine_Physics2D_get_alwaysShowCollidersv, __ZNK4Mesh22CalculateTriangleCountEv: __ZNK4Mesh22CalculateTriangleCountEv, __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer13DeleteArchiveERK8UnityStr, __Z46Physics_Set_Custom_PropPenetrationPenaltyForcef: __Z46Physics_Set_Custom_PropPenetrationPenaltyForcef, __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE: __ZN20SoundChannelInstance14SetFMODChannelEPN4FMOD7ChannelE, __Z46Register_UnityEngine_Joint_get_enableCollisionv: __Z46Register_UnityEngine_Joint_get_enableCollisionv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj479ENS_22PxRepXPropertyAccessorILj479ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE14handleAccessorILj479ENS_22PxRepXPropertyAccessorILj479ES4_ffEEEEvRKT0_, __Z44Register_UnityEngine_Animator_set_fireEventsv: __Z44Register_UnityEngine_Animator_set_fireEventsv, __ZN5physx3Scb5Scene15addArticulationERNS0_12ArticulationE: __ZN5physx3Scb5Scene15addArticulationERNS0_12ArticulationE, __Z5b2LogPKcz: __Z5b2LogPKcz, __ZN20LateBehaviourManagerD0Ev: __ZN20LateBehaviourManagerD0Ev, __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f: __ZN5physx2Gu15computeSweptBoxERNS0_3BoxERKNS_6PxVec3ES5_RKNS_7PxMat33ES5_f, __ZN11BoxCollider22FetchPoseFromTransformEv: __ZN11BoxCollider22FetchPoseFromTransformEv, __ZN5physx32PxClothParticleDataGeneratedInfoC2Ev: __ZN5physx32PxClothParticleDataGeneratedInfoC2Ev, __Z49Register_UnityEngine_Terrain_get_materialTemplatev: __Z49Register_UnityEngine_Terrain_get_materialTemplatev, __ZN6Camera23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Camera23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE: __ZN9ShaderLabL18AddPropertyToArrayERK19ShaderPropertySheetR13dynamic_arrayIiLj4EERKNS_8FloatValE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj28ENS_11PxRigidBodyERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z48Register_UnityEngine_MeshCollider_set_sharedMeshv: __Z48Register_UnityEngine_MeshCollider_set_sharedMeshv, __Z42TerrainData_Set_Custom_PropSplatPrototypesP12Il2CppObjectP11Il2CppArray: __Z42TerrainData_Set_Custom_PropSplatPrototypesP12Il2CppObjectP11Il2CppArray, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKcSC_, __ZNSt3__210__stdinbufIcED0Ev: __ZNSt3__210__stdinbufIcED0Ev, __ZN19GCProfilerCallbacksL10OnGCResizeEPvx: __ZN19GCProfilerCallbacksL10OnGCResizeEPvx, __ZN12LineRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12LineRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EEdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx6shdfnd6Socket6listenEtPNS1_10ConnectionE: __ZN5physx6shdfnd6Socket6listenEtPNS1_10ConnectionE, __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI24GenerateTypeTreeTransferEEvRS5_RT_: __ZN15SerializeTraitsINSt3__24pairI4PPtrI14SphereColliderES4_EEE8TransferI24GenerateTypeTreeTransferEEvRS5_RT_, __ZN7mecanim9animationL25MuscleIndexIdSortFunctionENS0_13MuscleIndexIdES1_: __ZN7mecanim9animationL25MuscleIndexIdSortFunctionENS0_13MuscleIndexIdES1_, __ZN12_GLOBAL__N_115ParamNameLookup15AddBuiltinNamesEPPKcjb: __ZN12_GLOBAL__N_115ParamNameLookup15AddBuiltinNamesEPPKcjb, __ZN14CompletionTask3runEv: __ZN14CompletionTask3runEv, __ZN16MemoryFileSystem10AtomicMoveER13FileEntryDataS1_: __ZN16MemoryFileSystem10AtomicMoveER13FileEntryDataS1_, _jpeg_write_tables: _jpeg_write_tables, __ZN9GfxDevice29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE: __ZN9GfxDevice29DestroyComputeConstantBuffersEjP12ObjectHandleI18ConstantBuffer_TagPvE, __Z49Camera_CUSTOM_INTERNAL_CALL_ScreenToViewportPointP12Il2CppObjectRK8Vector3fRS1_: __Z49Camera_CUSTOM_INTERNAL_CALL_ScreenToViewportPointP12Il2CppObjectRK8Vector3fRS1_, __ZN12_GLOBAL__N_124PropertyDefinitionHelper17pushBracketedNameEPKcS2_S2_: __ZN12_GLOBAL__N_124PropertyDefinitionHelper17pushBracketedNameEPKcS2_S2_, __ZNK9dtNavMesh12getTileByRefEy: __ZNK9dtNavMesh12getTileByRefEy, __Z45Register_UnityEngine_HingeJoint_set_useSpringv: __Z45Register_UnityEngine_HingeJoint_set_useSpringv, __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13TrailRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPNS_19PxProfileZoneClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_19PxProfileZoneClientENS_7profile26WrapperReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z39Register_UnityEngine_Mathf_IsPowerOfTwov: __Z39Register_UnityEngine_Mathf_IsPowerOfTwov, __ZN2UI14CanvasRenderer20SetHasPopInstructionEb: __ZN2UI14CanvasRenderer20SetHasPopInstructionEb, _llvm_bswap_i16: _llvm_bswap_i16, __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN6Avatar23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z37Animator_Set_Custom_PropStabilizeFeetP12Il2CppObjecth: __Z37Animator_Set_Custom_PropStabilizeFeetP12Il2CppObjecth, _printf_core: _printf_core, __ZN5physx17MBPUpdateWorkTaskD2Ev: __ZN5physx17MBPUpdateWorkTaskD2Ev, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj, _printf_console: _printf_console, __ZN5physx2Sn13XmlNodeReader18getCurrentItemNameEv: __ZN5physx2Sn13XmlNodeReader18getCurrentItemNameEv, __ZN5Umbra20ObjectDistanceParamsC2Ev: __ZN5Umbra20ObjectDistanceParamsC2Ev, __Z53Register_UnityEngine_TerrainData_get_detailResolutionv: __Z53Register_UnityEngine_TerrainData_get_detailResolutionv, __ZN8VRDevice21EnableStereoRenderingEv: __ZN8VRDevice21EnableStereoRenderingEv, __ZN10VertexData13SwapEndianessEv: __ZN10VertexData13SwapEndianessEv, __ZNK5physx2Sc18ParticleSystemCore13getRestOffsetEv: __ZNK5physx2Sc18ParticleSystemCore13getRestOffsetEv, __ZN5physx22PxVehicleWheelsSimData22setSuspTravelDirectionEjRKNS_6PxVec3E: __ZN5physx22PxVehicleWheelsSimData22setSuspTravelDirectionEjRKNS_6PxVec3E, __Z36SphereCollider_Get_Custom_PropRadiusP12Il2CppObject: __Z36SphereCollider_Get_Custom_PropRadiusP12Il2CppObject, __Z50Register_UnityEngine_MonoBehaviour_InvokeRepeatingv: __Z50Register_UnityEngine_MonoBehaviour_InvokeRepeatingv, __ZN13AnimationClip16AddPositionCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE: __ZN13AnimationClip16AddPositionCurveERK17AnimationCurveTplI8Vector3fERKNSt3__212basic_stringIcNS5_11char_traitsIcEENS5_9allocatorIcEEEE, __ZN14CachingManager17GenerateTimeStampEv: __ZN14CachingManager17GenerateTimeStampEv, __ZN36ExternalForcesModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN36ExternalForcesModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN10Matrix4x4f10SetFrustumEffffff: __ZN10Matrix4x4f10SetFrustumEffffff, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE5eraseERS4_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPNS_20SVariableMemPoolNodeEEEjNS0_4HashIjEENS1_11HashMapBaseIjS6_S9_NS_7profile26WrapperReflectionAllocatorIS6_EEE6GetKeyESD_Lb1EE5eraseERS4_, __ZN16LightmapSettings14SetLightProbesEP11LightProbes: __ZN16LightmapSettings14SetLightProbesEP11LightProbes, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE13setLinearDragERKNS_6PxVec3E, __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_GetKey_Internalv: __Z65Register_UnityEngine_AnimationCurve_INTERNAL_CALL_GetKey_Internalv, _UNITY_FT_Render_Glyph_Internal: _UNITY_FT_Render_Glyph_Internal, __ZN12PhysXRaycast7RaycastERK3Rayfi23QueryTriggerInteractionR10RaycastHit: __ZN12PhysXRaycast7RaycastERK3Rayfi23QueryTriggerInteractionR10RaycastHit, __Z24GetCrashReportManagerPtrv: __Z24GetCrashReportManagerPtrv, __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE: __ZNSt3__214__num_get_base10__get_baseERNS_8ios_baseE, __ZN16HumanPoseHandlerD2Ev: __ZN16HumanPoseHandlerD2Ev, __Z24ConvertBufferToPNGBufferPKhjjj13TextureFormatPvPFvS2_PhjE: __Z24ConvertBufferToPNGBufferPKhjjj13TextureFormatPvPFvS2_PhjE, __ZN5physx2Gu19_gjkRelativeRayCastINS0_11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_11ConvexHullVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f, __ZNK5physx16PxsSolverEndTask7getNameEv: __ZNK5physx16PxsSolverEndTask7getNameEv, _iswalpha: _iswalpha, __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_: __ZN14qsort_internal6_QSortIPPKN9SubModule14SubEmitterDataEiPFbS4_S4_EEEvT_S8_T0_T1_, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_SetXv, __Z57ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterTypeP12Il2CppObjectii: __Z57ParticleSystem_SubEmittersModule_CUSTOM_SetSubEmitterTypeP12Il2CppObjectii, __ZN5physx2Sc16ArticulationCoreC2Ev: __ZN5physx2Sc16ArticulationCoreC2Ev, __ZN5physx20PxsParticleSystemSim17getParticleStateVEv: __ZN5physx20PxsParticleSystemSim17getParticleStateVEv, __ZN7ApiGLES13DeleteTextureERj: __ZN7ApiGLES13DeleteTextureERj, __ZNK14ParticleSystem14GetPlayOnAwakeEv: __ZNK14ParticleSystem14GetPlayOnAwakeEv, __ZN23ForwardShaderRenderLoop21CleanupAfterRenderingEv: __ZN23ForwardShaderRenderLoop21CleanupAfterRenderingEv, __ZN5audio5mixer18SetExposedPropertyERKNS0_16AudioMixerMemoryEif: __ZN5audio5mixer18SetExposedPropertyERKNS0_16AudioMixerMemoryEif, __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE: __ZNSt3__26vectorI9CollisionNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5clearEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5clearEv, __ZN13RenderTexture12SetDimensionE16TextureDimension: __ZN13RenderTexture12SetDimensionE16TextureDimension, __ZN5physx2Gu5Debug9visualizeERKNS_21PxHeightFieldGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_21PxHeightFieldGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE7reserveEj: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS_9allocatorIS3_EEE7reserveEj, __ZNK21AssetBundleFileSystem6ExistsERK13FileEntryData: __ZNK21AssetBundleFileSystem6ExistsERK13FileEntryData, __ZN9Rigidbody15CleanupInternalEb: __ZN9Rigidbody15CleanupInternalEb, __ZN13SparseTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13SparseTexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData32ENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN11TimeManagerD2Ev: __ZN11TimeManagerD2Ev, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4backEv, ___shgetc: ___shgetc, __Z20profiler_begin_framev: __Z20profiler_begin_framev, __ZN5physx27PxcPCMContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx27PxcPCMContactCapsuleCapsuleERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE4findIS2_EENS3_11__wrap_iterIPS2_EERKT_: __ZN13sorted_vectorIN20TextRenderingPrivate8FontImpl13CharacterInfoENSt3__24lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE4findIS2_EENS3_11__wrap_iterIPS2_EERKT_, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim12statemachine18StateMachineMemoryEEEEvRT_PKc17TransferMetaFlags, __ZNKSt3__215__codecvt_utf16IwLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IwLb1EE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB888EEvPKNS_9InnerInfoE, __Z17Mesh_CUSTOM_ClearP12Il2CppObjecth: __Z17Mesh_CUSTOM_ClearP12Il2CppObjecth, __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj: __ZNSt3__28time_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEEC2EPKcj, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm, __ZN5physx16PxVehicleDrive4WD2Ev: __ZN5physx16PxVehicleDrive4WD2Ev, __ZNK21EnlightenSceneMapping18GetInputSystemHashEi: __ZNK21EnlightenSceneMapping18GetInputSystemHashEi, __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_positionv: __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_get_positionv, __Z52Register_UnityEngine_TerrainCollider_get_terrainDatav: __Z52Register_UnityEngine_TerrainCollider_get_terrainDatav, __ZN12CachedReader16OutOfBoundsErrorEjj: __ZN12CachedReader16OutOfBoundsErrorEjj, __Z44Register_UnityEngine_HingeJoint_get_velocityv: __Z44Register_UnityEngine_HingeJoint_get_velocityv, __Z30setPxTriangleMeshGeometryScalePN5physx22PxTriangleMeshGeometryENS_11PxMeshScaleE: __Z30setPxTriangleMeshGeometryScalePN5physx22PxTriangleMeshGeometryENS_11PxMeshScaleE, __ZN8Animator23ClearContainedRenderersEv: __ZN8Animator23ClearContainedRenderersEv, __Z30setPxDistanceJoint_MaxDistancePN5physx15PxDistanceJointEf: __Z30setPxDistanceJoint_MaxDistancePN5physx15PxDistanceJointEf, __ZN5physx27PxClothFabricRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx27PxClothFabricRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z30Mathf_CUSTOM_ClosestPowerOfTwoi: __Z30Mathf_CUSTOM_ClosestPowerOfTwoi, __ZN9Texture2D11SetPixels32EiPK11ColorRGBA32i: __ZN9Texture2D11SetPixels32EiPK11ColorRGBA32i, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19getInvInertiaScale1Ev, __ZN8Material17MainThreadCleanupEv: __ZN8Material17MainThreadCleanupEv, __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayINS_2Sq10FIFOStack213NodeAndParentENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __Z41Projector_Get_Custom_PropOrthographicSizeP12Il2CppObject: __Z41Projector_Get_Custom_PropOrthographicSizeP12Il2CppObject, __ZL11RecurseCopyR8TypeTreeRK16TypeTreeIteratorS3_: __ZL11RecurseCopyR8TypeTreeRK16TypeTreeIteratorS3_, __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii: __ZL9SubdivideR13dynamic_arrayI16DetailMeshBVNodeLj4EES2_ii, __Z13RegisterClassI9TextAssetEvv: __Z13RegisterClassI9TextAssetEvv, __Z49Physics2D_CUSTOM_INTERNAL_CALL_CircleCastNonAllocRK13Vector2fIcallfS1_P11Il2CppArrayfiff: __Z49Physics2D_CUSTOM_INTERNAL_CALL_CircleCastNonAllocRK13Vector2fIcallfS1_P11Il2CppArrayfiff, __ZN11BoxCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11BoxCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z35ParticleEmitter_Set_Custom_PropEmitP12Il2CppObjecth: __Z35ParticleEmitter_Set_Custom_PropEmitP12Il2CppObjecth, __ZThn4_NK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZThn4_NK5physx5cloth9SwFactory28extractParticleAccelerationsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv: __ZN10UnityScene43RegisterLevelGameManagersWithManagerContextEv, __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_: __ZNSt3__2plIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEENS_12basic_stringIT_T0_T1_EERKSA_PKS7_, __Z67Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleNonAllocv: __Z67Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapCapsuleNonAllocv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE12readPropertyIfEEbRT_, __ZNK7dtCrowd14getSteerTargetERK13dtCrowdHandlePf: __ZNK7dtCrowd14getSteerTargetERK13dtCrowdHandlePf, _UNITY_png_handle_as_unknown: _UNITY_png_handle_as_unknown, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getPreviousParticlesEv, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E12maybe_shrinkEv, __ZN5physx27PxVehicleDifferentialNWData14setDrivenWheelEjb: __ZN5physx27PxVehicleDifferentialNWData14setDrivenWheelEjb, __ZN12ScriptMapper23VirtualRedirectTransferER14SafeBinaryRead: __ZN12ScriptMapper23VirtualRedirectTransferER14SafeBinaryRead, __Z48Register_UnityEngine_Renderer_set_sharedMaterialv: __Z48Register_UnityEngine_Renderer_set_sharedMaterialv, __ZN14AvatarPlayback10CursorTimeEv: __ZN14AvatarPlayback10CursorTimeEv, __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES: __Z27BufferUpdateCausesStallGLESPK14DataBufferGLES, __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE: __ZN5physx23PxVehicleWheels4SimData23setSceneQueryFilterDataEjRKNS_12PxFilterDataE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__move_assign_allocERS5_, __ZN6Avatar8GetAssetEv: __ZN6Avatar8GetAssetEv, __ZN15AnchoredJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN15AnchoredJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN5physx2Sq12BucketPruner13updateObjectsEPKjPKNS_9PxBounds3Ej: __ZN5physx2Sq12BucketPruner13updateObjectsEPKjPKNS_9PxBounds3Ej, __ZNK5Umbra4Path11getCapacityEv: __ZNK5Umbra4Path11getCapacityEv, __Z50Register_UnityEngine_ParticleEmitter_set_maxEnergyv: __Z50Register_UnityEngine_ParticleEmitter_set_maxEnergyv, __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15TerrainCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN11TextureData17GetImageReferenceEii: __ZN11TextureData17GetImageReferenceEii, __ZNK5physx7NpScene16getArticulationsEPPNS_14PxArticulationEjj: __ZNK5physx7NpScene16getArticulationsEPPNS_14PxArticulationEjj, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN20TextRenderingPrivate8TextMesh15ThreadedCleanupEv: __ZN20TextRenderingPrivate8TextMesh15ThreadedCleanupEv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_, __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19ComputeShaderKernel8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager29setArticulationRootLinkHandleEjPvRKNS_20PxsIslandManagerHookIjLj4294967295EEE, __Z41Material_CUSTOM_Internal_CreateWithStringP12Il2CppObjectP12Il2CppString: __Z41Material_CUSTOM_Internal_CreateWithStringP12Il2CppObjectP12Il2CppString, __ZNSt3__212future_errorC2ERKS0_: __ZNSt3__212future_errorC2ERKS0_, __ZN13SliderJoint2D9SetLimitsERK24JointTranslationLimits2D: __ZN13SliderJoint2D9SetLimitsERK24JointTranslationLimits2D, __ZN5Umbra9RasterOps17updateDepthBufferERKNS_17BlockRasterBufferERNS_11DepthBufferEf: __ZN5Umbra9RasterOps17updateDepthBufferERKNS_17BlockRasterBufferERNS_11DepthBufferEf, _poll: _poll, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, _UNITY_png_set_pHYs: _UNITY_png_set_pHYs, __Z37AudioSettings_CUSTOM_GetDSPBufferSizePiS_: __Z37AudioSettings_CUSTOM_GetDSPBufferSizePiS_, __ZN16SpriteRenderData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16SpriteRenderData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13BitSetUtility12CreateBitSetEjRK10MemLabelId: __ZN13BitSetUtility12CreateBitSetEjRK10MemLabelId, __Z53Camera_CUSTOM_INTERNAL_CALL_GetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f: __Z53Camera_CUSTOM_INTERNAL_CALL_GetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeR10Matrix4x4f, __ZNK21ScriptingObjectOfTypeI7CubemapEptEv: __ZNK21ScriptingObjectOfTypeI7CubemapEptEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __Z49Register_UnityEngine_EdgeCollider2D_get_edgeCountv: __Z49Register_UnityEngine_EdgeCollider2D_get_edgeCountv, __ZN14ParticleSystem14SetLengthInSecEf: __ZN14ParticleSystem14SetLengthInSecEf, __ZN9AudioClip17MainThreadCleanupEv: __ZN9AudioClip17MainThreadCleanupEv, __Z50QualitySettings_Set_Custom_PropShadowCascade2Splitf: __Z50QualitySettings_Set_Custom_PropShadowCascade2Splitf, __Z60Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexTrianglesv: __Z60Register_UnityEngine_Mesh_PrintErrorBadSubmeshIndexTrianglesv, __ZN16SpriteRenderData11UnshareDataEv: __ZN16SpriteRenderData11UnshareDataEv, __Z52Register_UnityEngine_TerrainData_INTERNAL_get_boundsv: __Z52Register_UnityEngine_TerrainData_INTERNAL_get_boundsv, __Z52Register_UnityEngine_WindZone_set_windPulseMagnitudev: __Z52Register_UnityEngine_WindZone_set_windPulseMagnitudev, __Z46Register_UnityEngine_Physics_get_sleepVelocityv: __Z46Register_UnityEngine_Physics_get_sleepVelocityv, __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_15PxDistanceJointEED0Ev, __ZNK5physx2Sc5Scene16getNbConstraintsEv: __ZNK5physx2Sc5Scene16getNbConstraintsEv, __ZN5physx35PxJointLimitParametersGeneratedInfoC2Ev: __ZN5physx35PxJointLimitParametersGeneratedInfoC2Ev, __ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i: __ZN21TreeBinaryTreeBuilder11AddLastTreeER14TreeBinaryTreeRK8Vector3fS4_i, __Z53Register_UnityEngine_QualitySettings_get_currentLevelv: __Z53Register_UnityEngine_QualitySettings_get_currentLevelv, __ZN2UI11CanvasGroup12AddToManagerEv: __ZN2UI11CanvasGroup12AddToManagerEv, __ZL8StbAllocjPv: __ZL8StbAllocjPv, __Z18GUIClip_CUSTOM_Popv: __Z18GUIClip_CUSTOM_Popv, __Z22GetBackButtonLeavesAppv: __Z22GetBackButtonLeavesAppv, __Z39Register_UnityEngine_Time_get_fixedTimev: __Z39Register_UnityEngine_Time_get_fixedTimev, __ZNK5physx2Sc17ParticleSystemSim16getInternalFlagsEv: __ZNK5physx2Sc17ParticleSystemSim16getInternalFlagsEv, __Z29StdTemplateConversionFunctionIybEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIybEbPvR14SafeBinaryRead, __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN8LODGroup11LODStruct50ENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN12HandlerChain5WriteER13FileEntryDatayPvPy: __ZN12HandlerChain5WriteER13FileEntryDatayPvPy, __ZNK18AnimatorController17GetAnimationClipsEv: __ZNK18AnimatorController17GetAnimationClipsEv, __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10MeshFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z39GraphicsSettings_CUSTOM_GetCustomShaderN16GraphicsSettings17BuiltinShaderTypeE: __Z39GraphicsSettings_CUSTOM_GetCustomShaderN16GraphicsSettings17BuiltinShaderTypeE, __Z45BillboardAsset_CUSTOM_SetVerticesInternalListP12Il2CppObjectS0_: __Z45BillboardAsset_CUSTOM_SetVerticesInternalListP12Il2CppObjectS0_, __ZN9Animation7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Animation7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN13MemoryManager16LowLevelAllocateEj: __ZN13MemoryManager16LowLevelAllocateEj, _UNITY_png_set_cHRM: _UNITY_png_set_cHRM, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER17RemapPPtrTransfer, _asinhl: _asinhl, __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE8__appendEj, __Z38Terrain_Set_Custom_PropLegacyShininessP12Il2CppObjectf: __Z38Terrain_Set_Custom_PropLegacyShininessP12Il2CppObjectf, __Z40AndroidJNI_CUSTOM_CallStaticStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z40AndroidJNI_CUSTOM_CallStaticStringMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZN13GfxDeviceGLES25SetShaderPropertiesCopiedERK19ShaderPropertySheet: __ZN13GfxDeviceGLES25SetShaderPropertiesCopiedERK19ShaderPropertySheet, __Z14DrawGUITextureRK5RectTIfEP7Textureiiii11ColorRGBA32P8Materiali: __Z14DrawGUITextureRK5RectTIfEP7Textureiiii11ColorRGBA32P8Materiali, _sincosf: _sincosf, __ZN5Unity11SpringJoint12SetToleranceEf: __ZN5Unity11SpringJoint12SetToleranceEf, __ZN19ControllerHitReport15onControllerHitERKN5physx16PxControllersHitE: __ZN19ControllerHitReport15onControllerHitERKN5physx16PxControllersHitE, __ZN15LODGroupManager32CalculateAnimatedCrossFadeCulledEhfPhPf: __ZN15LODGroupManager32CalculateAnimatedCrossFadeCulledEhfPhPf, __ZN16LightmapSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16LightmapSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN9ShaderLab25SerializedTextureProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab25SerializedTextureProperty8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18GetEternalGUIStatev: __Z18GetEternalGUIStatev, _UNITY_FT_Bitmap_New: _UNITY_FT_Bitmap_New, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDriveNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj639ENS_15PxVehicleWheelsENS_22PxVehicleWheelsSimDataES7_EEKNS_35PxVehicleWheelsSimDataGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx7NpScene15SceneCompletionD0Ev: __ZN5physx7NpScene15SceneCompletionD0Ev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj391ENS_22PxRepXPropertyAccessorILj391ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_20PxClothStretchConfigEEEE14handleAccessorILj391ENS_22PxRepXPropertyAccessorILj391ES4_ffEEEEvRKT0_, __ZN16LightmapSettings15RemoveLightmapsEi: __ZN16LightmapSettings15RemoveLightmapsEi, __ZNK15AudioEchoFilter26GetTypeInfoVirtualInternalEv: __ZNK15AudioEchoFilter26GetTypeInfoVirtualInternalEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj625ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE8__appendEj, __Z45SkinnedMeshRenderer_Get_Custom_PropSharedMeshP12Il2CppObject: __Z45SkinnedMeshRenderer_Get_Custom_PropSharedMeshP12Il2CppObject, __Z57Register_UnityEngine_ParticleSystem_MainModule_SetPrewarmv: __Z57Register_UnityEngine_ParticleSystem_MainModule_SetPrewarmv, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefIhEE: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefIhEE, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER14SafeBinaryRead, __Z42Register_UnityEngine_SortingLayer_NameToIDv: __Z42Register_UnityEngine_SortingLayer_NameToIDv, __ZN11KeyframeTplIfEC2EfRKf: __ZN11KeyframeTplIfEC2EfRKf, __ZN11UmbraModule12SetupPortalsEPKN5Umbra4TomeE: __ZN11UmbraModule12SetupPortalsEPKN5Umbra4TomeE, __ZN5physx2Sc10NPhaseCore28fireCustomFilteringCallbacksEv: __ZN5physx2Sc10NPhaseCore28fireCustomFilteringCallbacksEv, __ZNK10GUIElement26GetTypeInfoVirtualInternalEv: __ZNK10GUIElement26GetTypeInfoVirtualInternalEv, _isspace_l: _isspace_l, __ZN13EmscriptenWWWD0Ev: __ZN13EmscriptenWWWD0Ev, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx14PxLightCpuTaskD0Ev: __ZN5physx14PxLightCpuTaskD0Ev, __ZN9GfxDevice17ImmediateTexCoordEifff: __ZN9GfxDevice17ImmediateTexCoordEifff, __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv: __ZNK5physx2Sc9ShapeCore20getNbMaterialIndicesEv, __ZN4FMOD6System11isRecordingEiPb: __ZN4FMOD6System11isRecordingEiPb, __Z43MaterialPropertyBlock_CUSTOM_GetMatrixArrayP12Il2CppObjecti: __Z43MaterialPropertyBlock_CUSTOM_GetMatrixArrayP12Il2CppObjecti, __ZNK18PlatformEffector2D16UseContactUpdateEv: __ZNK18PlatformEffector2D16UseContactUpdateEv, __ZNSt3__213__vector_baseIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEED2Ev: __ZNSt3__213__vector_baseIN12TreeDatabase9PrototypeENS_9allocatorIS2_EEED2Ev, __ZN5physx2Sn5ConvX25convertInternalReferencesEPKvRi: __ZN5physx2Sn5ConvX25convertInternalReferencesEPKvRi, __ZN10Matrix3x3f5ScaleERK8Vector3f: __ZN10Matrix3x3f5ScaleERK8Vector3f, __ZNK5physx19NpArticulationJoint17getTargetVelocityEv: __ZNK5physx19NpArticulationJoint17getTargetVelocityEv, __ZN5physx19NpClothParticleData7tryLockENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE: __ZN5physx19NpClothParticleData7tryLockENS_7PxFlagsINS_16PxDataAccessFlag4EnumEhEE, __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_: __ZN5physx21PxcArticulationHelper13applyImpulsesERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialES5_, __Z41OffMeshLink_Get_Custom_PropStartTransformP12Il2CppObject: __Z41OffMeshLink_Get_Custom_PropStartTransformP12Il2CppObject, __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatRGBAFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji: __ZN5physx23PxVehicleWheels4SimData20setWheelShapeMappingEji, __Z37Time_Get_Custom_PropUnscaledDeltaTimev: __Z37Time_Get_Custom_PropUnscaledDeltaTimev, __ZN5physx12InlineBitmapILj4096EED2Ev: __ZN5physx12InlineBitmapILj4096EED2Ev, __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_: __ZN7mecanim14ValueArrayCopyEPKNS_10ValueArrayEPS0_, __ZN13dynamic_arrayIP8MaterialLj4EE18resize_initializedEjRKS1_12ResizePolicy: __ZN13dynamic_arrayIP8MaterialLj4EE18resize_initializedEjRKS1_12ResizePolicy, __ZN5physx2Gu28computeMTD_ConvexHeightFieldERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES9_: __ZN5physx2Gu28computeMTD_ConvexHeightFieldERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformERKNS_21PxHeightFieldGeometryES9_, __Z29scripting_class_get_namespaceP11Il2CppClass: __Z29scripting_class_get_namespaceP11Il2CppClass, __ZN12HandlerChain10ToAbsoluteEPKc: __ZN12HandlerChain10ToAbsoluteEPKc, __ZN9Scripting38RuntimeCreateAndInitObjectLogExceptionEP11Il2CppClass: __ZN9Scripting38RuntimeCreateAndInitObjectLogExceptionEP11Il2CppClass, _dcgettext: _dcgettext, __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram15VectorParameter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN11UnityEngine9AnimationL56CalculateTransformBindingSizeBasedOnConstantOptimizationERKNS0_20AnimationSetBindingsERK13dynamic_arrayINS0_14BoundTransformELj4EEPKiPKN7mecanim9animation14AvatarConstantEb: __ZN11UnityEngine9AnimationL56CalculateTransformBindingSizeBasedOnConstantOptimizationERKNS0_20AnimationSetBindingsERK13dynamic_arrayINS0_14BoundTransformELj4EEPKiPKN7mecanim9animation14AvatarConstantEb, __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode: __ZN4gles13UploadTextureEP7ApiGLESR11GLESTexture13TextureFormatPKvjiiiij17TextureColorSpace16TextureUsageMode, __ZN5physx2Sn21SerializationRegistry24unregisterRepXSerializerEt: __ZN5physx2Sn21SerializationRegistry24unregisterRepXSerializerEt, __ZN4FMOD8ChannelI15getChannelGroupEPPNS_12ChannelGroupE: __ZN4FMOD8ChannelI15getChannelGroupEPPNS_12ChannelGroupE, __Z58Register_UnityEngine_SurfaceEffector2D_get_useContactForcev: __Z58Register_UnityEngine_SurfaceEffector2D_get_useContactForcev, __ZNK5physx14PxVehicleDrive19getConcreteTypeNameEv: __ZNK5physx14PxVehicleDrive19getConcreteTypeNameEv, __Z24RegisterStrippedTypeInfoI13ComputeShaderEviPKcS2_: __Z24RegisterStrippedTypeInfoI13ComputeShaderEviPKcS2_, __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev: __ZN5physx40PxVehicleTireLoadFilterDataGeneratedInfoC2Ev, __ZN5physx2Cm10FanoutTaskD2Ev: __ZN5physx2Cm10FanoutTaskD2Ev, __ZN11BoxCollider23VirtualRedirectTransferER14SafeBinaryRead: __ZN11BoxCollider23VirtualRedirectTransferER14SafeBinaryRead, __Z16TransferTextPPtrI9JSONWriteEvR4PPtrI6ObjectERT_: __Z16TransferTextPPtrI9JSONWriteEvR4PPtrI6ObjectERT_, __ZN5physx24PxsParticleSystemBatcher17registerParticlesEv: __ZN5physx24PxsParticleSystemBatcher17registerParticlesEv, __ZN22AnimationMixerPlayable7GetTypeEv: __ZN22AnimationMixerPlayable7GetTypeEv, __Z40Register_UnityEngine_Event_get_modifiersv: __Z40Register_UnityEngine_Event_get_modifiersv, _UNITY_png_set_alpha_mode_fixed: _UNITY_png_set_alpha_mode_fixed, __ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_: __ZN19SpriteMeshGenerator4path14self_intersectE8Vector2fS1_, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE21GetReservedMemorySizeEv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE21GetReservedMemorySizeEv, __Z51Register_UnityEngine_LineRenderer_get_useWorldSpacev: __Z51Register_UnityEngine_LineRenderer_get_useWorldSpacev, __ZNK17AnimationCurveTplI11QuaternionfE15GetPostInfinityEv: __ZNK17AnimationCurveTplI11QuaternionfE15GetPostInfinityEv, __Z20getPxSpringStiffnessPKN5physx8PxSpringE: __Z20getPxSpringStiffnessPKN5physx8PxSpringE, __ZNK15NavMeshObstacle26GetTypeInfoVirtualInternalEv: __ZNK15NavMeshObstacle26GetTypeInfoVirtualInternalEv, __Z30RegisterModuleClasses_UnityAdsv: __Z30RegisterModuleClasses_UnityAdsv, __ZN8GUIStyleC2ERKS_: __ZN8GUIStyleC2ERKS_, __Z9heapAllocPvj: __Z9heapAllocPvj, __ZNK8VRDevice9GetActiveEv: __ZNK8VRDevice9GetActiveEv, __ZN4FMOD8ChannelI6getPanEPf: __ZN4FMOD8ChannelI6getPanEPf, __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE: __ZN11UnityEngine9Animation35SetTransformPropertyApplyMainThreadER9TransformRKNS0_30AnimatorGenericBindingConstantERKNS0_21AvatarBindingConstantE, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferjEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN23iPhoneLocalNotification9HasActionEb: __ZN23iPhoneLocalNotification9HasActionEb, __ZN28LightProbeProxyVolumeManager17UpdateBoundingBoxER21LightProbeProxyVolume: __ZN28LightProbeProxyVolumeManager17UpdateBoundingBoxER21LightProbeProxyVolume, __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff: __ZN15LODGroupManager24UpdateLODGroupParametersEiR8LODGroupRK8Vector3ff, _cf2_free_instance: _cf2_free_instance, __Z40ParticleAnimator_Get_Custom_PropSizeGrowP12Il2CppObject: __Z40ParticleAnimator_Get_Custom_PropSizeGrowP12Il2CppObject, __Z39Profiler_CUSTOM_GetTotalAllocatedMemoryv: __Z39Profiler_CUSTOM_GetTotalAllocatedMemoryv, __ZN9WWWCached17UnlockPartialDataEv: __ZN9WWWCached17UnlockPartialDataEv, __Z30TextMesh_Set_Custom_PropAnchorP12Il2CppObjecti: __Z30TextMesh_Set_Custom_PropAnchorP12Il2CppObjecti, __ZN14PhysicsManager15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction: __ZN14PhysicsManager15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction, __ZN12MeshCollider12SetSkinWidthEf: __ZN12MeshCollider12SetSkinWidthEf, __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj: __ZN7ApiGLES12CreateBufferEN2gl12BufferTargetElPKvj, _compress_block: _compress_block, __ZNK23ArchiveStorageConverter22GetOriginalArchiveSizeEv: __ZNK23ArchiveStorageConverter22GetOriginalArchiveSizeEv, __ZNK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv: __ZNK26AnimatorControllerPlayable41GetStateMachineBehaviourVectorDescriptionEv, __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_: __ZN5physx3Scb4Body22addSpatialAccelerationEPKNS_6PxVec3ES4_, __ZN12b2ChainShape10CreateLoopEPK6b2Vec2i: __ZN12b2ChainShape10CreateLoopEPK6b2Vec2i, __Z41BillboardAsset_Get_Custom_PropVertexCountP12Il2CppObject: __Z41BillboardAsset_Get_Custom_PropVertexCountP12Il2CppObject, ___dns_count_addrs: ___dns_count_addrs, __ZN14Texture2DArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN14Texture2DArray23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z51MaterialPropertyBlock_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_: __Z51MaterialPropertyBlock_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_, __ZN37InheritVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN37InheritVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN14RenderSettings10SetFogModeE7FogMode: __ZN14RenderSettings10SetFogModeE7FogMode, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_18MeshEdgeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN4FMOD13ChannelGroupI24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD13ChannelGroupI24overrideReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES, _ps_unicodes_char_index: _ps_unicodes_char_index, __ZN5physx5cloth11SwCollisionI8Scalar4fE24estimatePersistentMemoryERKNS0_7SwClothE: __ZN5physx5cloth11SwCollisionI8Scalar4fE24estimatePersistentMemoryERKNS0_7SwClothE, __Z26GetCloudWebServicesManagerv: __Z26GetCloudWebServicesManagerv, __ZN20FileSystemEnumerator18EnumerateDirectoryEPKcPFbR13FileEntryInfoPvES4_19FileEnumerationFlag: __ZN20FileSystemEnumerator18EnumerateDirectoryEPKcPFbR13FileEntryInfoPvES4_19FileEnumerationFlag, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxArticulationLinkEEEE14handleAccessorILj36ENS_22PxRepXPropertyAccessorILj36ENS_11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEESD_EEEEvRKT0_, __ZN5physx7NpCloth12setParticlesEPKNS_15PxClothParticleES3_: __ZN5physx7NpCloth12setParticlesEPKNS_15PxClothParticleES3_, __ZN5physx8debugger14PvdMarshallingItxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItxE12marshalBlockEPKhPhj, __ZN5physx22PxVehicleTelemetryData5clearEv: __ZN5physx22PxVehicleTelemetryData5clearEv, __Z66Animator_Get_Custom_PropIsRootPositionOrRotationControlledByCurvesP12Il2CppObject: __Z66Animator_Get_Custom_PropIsRootPositionOrRotationControlledByCurvesP12Il2CppObject, __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16LevelGameManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN11OffMeshLink8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11OffMeshLink8TransferI24GenerateTypeTreeTransferEEvRT_, __Z57Register_UnityEngine_Animator_GetIKPositionWeightInternalv: __Z57Register_UnityEngine_Animator_GetIKPositionWeightInternalv, __ZNK16MemoryFileSystem14UnlockFileDataEPKcPPv: __ZNK16MemoryFileSystem14UnlockFileDataEPKcPPv, __ZN13GfxDeviceNull13DeleteTextureE9TextureID: __ZN13GfxDeviceNull13DeleteTextureE9TextureID, __Z19SetupShadowCullDataR6CameraRK17ShaderReplaceDataPK22SceneCullingParametersR14ShadowCullData: __Z19SetupShadowCullDataR6CameraRK17ShaderReplaceDataPK22SceneCullingParametersR14ShadowCullData, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyEN5physx8debugger18NonNegativeIntegerEPKc: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl12findPropertyEN5physx8debugger18NonNegativeIntegerEPKc, __ZN15TextureTFMethodD0Ev: __ZN15TextureTFMethodD0Ev, __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15AudioReverbZone8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9ShaderLab9SubShader20IsSubShaderSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __ZN9ShaderLab9SubShader20IsSubShaderSupportedERKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN9Rigidbody22ApplyRootMotionBuiltinEP14RootMotionData: __ZN9Rigidbody22ApplyRootMotionBuiltinEP14RootMotionData, __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYMultiplierv: __Z70Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeYMultiplierv, _grayscale_convert_21: _grayscale_convert_21, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj89ENS_22PxRepXPropertyAccessorILj89ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj89ENS_22PxRepXPropertyAccessorILj89ES4_ffEEEEvRKT0_, __Z34AudioClip_Get_Custom_PropLoadStateP12Il2CppObject: __Z34AudioClip_Get_Custom_PropLoadStateP12Il2CppObject, __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE: __ZN5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE15addSpatialForceEPKNS_6PxVec3ES5_NS_11PxForceMode4EnumE, __ZN5physx3Ext18ProfileZoneHandler11flushEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE: __ZN5physx3Ext18ProfileZoneHandler11flushEventsERNS_6shdfnd5ArrayIPNS_26PxBufferedProfilerCallbackENS2_19ReflectionAllocatorIS5_EEEE, __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE: __ZN5physx2Sc18ParticleSystemCore8setFlagsENS_7PxFlagsINS_18PxParticleBaseFlag4EnumEtEE, __ZN12CachedWriter16InitActiveWriterERNS_12ActiveWriterER15CacheWriterBase: __ZN12CachedWriter16InitActiveWriterERNS_12ActiveWriterER15CacheWriterBase, __Z33setPxVehicleEngineDataMPeakTorquePN5physx19PxVehicleEngineDataEf: __Z33setPxVehicleEngineDataMPeakTorquePN5physx19PxVehicleEngineDataEf, __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRangev: __Z57Register_UnityEngine_ParticleSystem_LightsModule_SetRangev, __ZN5physx2Gu9ContainerC2ERKS1_: __ZN5physx2Gu9ContainerC2ERKS1_, __Z13RegisterClassI8WindZoneEvv: __Z13RegisterClassI8WindZoneEvv, __ZN13RendererScene17BeginCameraRenderEv: __ZN13RendererScene17BeginCameraRenderEv, __ZN9ShaderLab10SubProgramD2Ev: __ZN9ShaderLab10SubProgramD2Ev, __ZN5physx3Cct17CapsuleController15getPxControllerEv: __ZN5physx3Cct17CapsuleController15getPxControllerEv, __Z54Register_UnityEngine_Effector2D_get_designedForTriggerv: __Z54Register_UnityEngine_Effector2D_get_designedForTriggerv, __ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy: __ZN33AssetBundleLoadFromAsyncOperation28InitializeAssetBundleStorageERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEy, __Z13RegisterClassI17CapsuleCollider2DEvv: __Z13RegisterClassI17CapsuleCollider2DEvv, __ZN12MeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12MeshRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN7mecanim14SetValueWeightEPNS_16ValueArrayWeightEf: __ZN7mecanim14SetValueWeightEPNS_16ValueArrayWeightEf, __ZNK5physx2Sc9ClothCore25getMotionConstraintConfigEv: __ZNK5physx2Sc9ClothCore25getMotionConstraintConfigEv, __ZN5physx16PxsFluidDynamics18processPacketRangeEj: __ZN5physx16PxsFluidDynamics18processPacketRangeEj, __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_: __ZN15QualitySettings14QualitySetting8TransferI14SafeBinaryReadEEvRT_, __Z24RegisterStrippedTypeInfoI10Effector2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI10Effector2DEviPKcS2_, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat18TexFormatARGBFloatEEvPKNS_9InnerInfoE, __ZN11ShapeModule15ReleaseMeshDataEv: __ZN11ShapeModule15ReleaseMeshDataEv, __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev: __ZThn128_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED0Ev, __ZN12_GLOBAL__N_118LegacySerialStream9alignDataEj: __ZN12_GLOBAL__N_118LegacySerialStream9alignDataEj, _read: _read, __Z45Register_UnityEngine_Collider2D_get_isTriggerv: __Z45Register_UnityEngine_Collider2D_get_isTriggerv, __ZN5physx3Ext22computeCylinderDensityEfff: __ZN5physx3Ext22computeCylinderDensityEfff, __ZN15QualitySettings15SetCurrentIndexEib: __ZN15QualitySettings15SetCurrentIndexEib, __Z47ParticleRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf: __Z47ParticleRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf, __ZN13ConstantForce23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13ConstantForce23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN13GfxDeviceGLES22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace: __ZN13GfxDeviceGLES22UploadTextureCubeArrayE9TextureIDPKhjii13TextureFormatij17TextureColorSpace, __ZN9BlobWrite8TransferIN4math5LimitEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN4math5LimitEEEvRT_PKc17TransferMetaFlags, __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv: __ZN13sorted_vectorINSt3__24pairIijEEN10vector_mapIijNS0_4lessIiEENS0_9allocatorIS2_EEE13value_compareES7_E21sort_clear_duplicatesEv, __ZN13WheelCollider12CleanupClassEv: __ZN13WheelCollider12CleanupClassEv, _reap: _reap, __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject: __Z39scripting_class_from_systemtypeinstanceP12Il2CppObject, __ZN19AudioHighPassFilterD2Ev: __ZN19AudioHighPassFilterD2Ev, __ZN11NoiseModule11ResetScrollEv: __ZN11NoiseModule11ResetScrollEv, __ZN23ShaderVariantCollection8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN23ShaderVariantCollection8TransferI24GenerateTypeTreeTransferEEvRT_, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE11ColorRGBA32EvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_: __ZN12b2BroadPhase11UpdatePairsI16b2ContactManagerEEvPT_, __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE: __ZN7mecanim9animation17DestroyClipOutputEPNS0_10ClipOutputERNS_6memory9AllocatorE, __Z24GetExecutionOrderManagerv: __Z24GetExecutionOrderManagerv, __ZN5physx2Sn9StrToImplINS_15PxMetaDataPlaneEE5strtoERS2_RPKc: __ZN5physx2Sn9StrToImplINS_15PxMetaDataPlaneEE5strtoERS2_RPKc, __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z32GUITexture_Get_Custom_PropBorderP12Il2CppObject: __Z32GUITexture_Get_Custom_PropBorderP12Il2CppObject, __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E12maybe_shrinkEv, __ZN10GameObject12SetHideFlagsEi: __ZN10GameObject12SetHideFlagsEi, __Z43Application_CUSTOM_CanStreamedLevelBeLoadedi: __Z43Application_CUSTOM_CanStreamedLevelBeLoadedi, __ZN11AudioSource15SetDopplerLevelEf: __ZN11AudioSource15SetDopplerLevelEf, __ZN5physx2Sc16InteractionScene18releaseConstraintsEb: __ZN5physx2Sc16InteractionScene18releaseConstraintsEb, __ZN5physx9writeWordEtbRNS_14PxOutputStreamE: __ZN5physx9writeWordEtbRNS_14PxOutputStreamE, _dup: _dup, __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_: __ZNK17AnimationCurveTplIfE20FindIndexForSamplingERKNS0_5CacheEfRiS4_, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10StartEventEEEvRNS0_11EventHeaderERT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_10StartEventEEEvRNS0_11EventHeaderERT_, _mincore: _mincore, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_23postIslandGenSecondPassEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_: __ZN5physx7AddPairEjjRNS_14SapPairManagerERPjRjS4_, __Z24Input_CUSTOM_GetKeyUpInti: __Z24Input_CUSTOM_GetKeyUpInti, __Z70Register_UnityEngine_TerrainData_Internal_GetMinimumAlphamapResolutionv: __Z70Register_UnityEngine_TerrainData_Internal_GetMinimumAlphamapResolutionv, __Z57Register_UnityEngine_ConfigurableJoint_get_angularZMotionv: __Z57Register_UnityEngine_ConfigurableJoint_get_angularZMotionv, __Z40Transform_CUSTOM_INTERNAL_set_localScaleP12Il2CppObjectRK8Vector3f: __Z40Transform_CUSTOM_INTERNAL_set_localScaleP12Il2CppObjectRK8Vector3f, __Z44Register_UnityEngine_Screen_set_sleepTimeoutv: __Z44Register_UnityEngine_Screen_set_sleepTimeoutv, __Z53Register_UnityEngine_AudioReverbZone_set_decayHFRatiov: __Z53Register_UnityEngine_AudioReverbZone_set_decayHFRatiov, __ZN12HandlerChain11MoveToTrashER13FileEntryData: __ZN12HandlerChain11MoveToTrashER13FileEntryData, __Z41GUIUtility_Set_Custom_PropKeyboardControli: __Z41GUIUtility_Set_Custom_PropKeyboardControli, __ZNK6Camera18GetRenderRectangleEv: __ZNK6Camera18GetRenderRectangleEv, _format_message: _format_message, __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE20RegisterDeallocationEPKv: __ZN21UnityDefaultAllocatorI17LowLevelAllocatorE20RegisterDeallocationEPKv, __ZN14DirectorPlayer8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14DirectorPlayer8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataEv: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20lockParticleReadDataEv, __ZNK13WebCamTexture20GetStorageMemorySizeEv: __ZNK13WebCamTexture20GetStorageMemorySizeEv, __ZN14PhysicMaterial17ReleasePxMaterialEv: __ZN14PhysicMaterial17ReleasePxMaterialEv, __ZN17Physics2DSettings12CleanupClassEv: __ZN17Physics2DSettings12CleanupClassEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv, __Z13DecompressBC7iiiPKjPj: __Z13DecompressBC7iiiPKjPj, __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD2Ev: __ZZ27sweepCCTBox_HeightFieldGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu3BoxERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEfEN11LocalReportD2Ev, __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16ParticleAnimator8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46AudioSource_Set_Custom_PropIgnoreListenerPauseP12Il2CppObjecth: __Z46AudioSource_Set_Custom_PropIgnoreListenerPauseP12Il2CppObjecth, __ZN25ParticleSystemGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj: __ZN25ParticleSystemGeometryJob9RenderJobEP25DynamicVBOGeometryJobDataj, __ZNK5physx14NpArticulation16createDriveCacheEfj: __ZNK5physx14NpArticulation16createDriveCacheEfj, __ZN18ScriptingArguments10AddBooleanEb: __ZN18ScriptingArguments10AddBooleanEb, __ZN11IMGUIModule21QueryGUIDisplayTargetEP11Il2CppClass: __ZN11IMGUIModule21QueryGUIDisplayTargetEP11Il2CppClass, __Z50Register_UnityEngine_ConfigurableJoint_set_xMotionv: __Z50Register_UnityEngine_ConfigurableJoint_set_xMotionv, _strncasecmp_l: _strncasecmp_l, __ZNK5Umbra4Tome15findObjectIndexEj: __ZNK5Umbra4Tome15findObjectIndexEj, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepThresholdEv, __ZZNK9dtNavMesh15findNearestPolyEPKfS1_PfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi: __ZZNK9dtNavMesh15findNearestPolyEPKfS1_PfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI13TreePrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN10Collider2D10DeactivateE19DeactivateOperation: __ZN10Collider2D10DeactivateE19DeactivateOperation, __ZN21BillboardBatchManager15BatchBillboardsERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __ZN21BillboardBatchManager15BatchBillboardsERK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN2UI6Canvas15InitializeClassEv: __ZN2UI6Canvas15InitializeClassEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE8getSceneEv, __ZN19MeshParticleEmitter16SetupParticleTriER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti: __ZN19MeshParticleEmitter16SetupParticleTriER8ParticleRK8Vector3fRK10Matrix4x4fRK10Matrix3x3fSA_f14StrideIteratorIS2_ESC_PKti, __ZN5physx11PxHitBufferINS_12PxRaycastHitEE14processTouchesEPKS1_j: __ZN5physx11PxHitBufferINS_12PxRaycastHitEE14processTouchesEPKS1_j, __ZNK5physx14NpRigidDynamic14getWakeCounterEv: __ZNK5physx14NpRigidDynamic14getWakeCounterEv, __ZN15AudioReverbZoneC2E10MemLabelId18ObjectCreationMode: __ZN15AudioReverbZoneC2E10MemLabelId18ObjectCreationMode, __Z50Register_UnityEngine_ConfigurableJoint_set_zMotionv: __Z50Register_UnityEngine_ConfigurableJoint_set_zMotionv, _ilogbl: _ilogbl, __Z56Register_UnityEngine_QualitySettings_get_maxQueuedFramesv: __Z56Register_UnityEngine_QualitySettings_get_maxQueuedFramesv, __ZN14TerrainManager26Heightmap_GetPxHeightFieldER9Heightmap: __ZN14TerrainManager26Heightmap_GetPxHeightFieldER9Heightmap, __ZNSt3__215__codecvt_utf16IDsLb1EED0Ev: __ZNSt3__215__codecvt_utf16IDsLb1EED0Ev, _ps_get_macintosh_name: _ps_get_macintosh_name, __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToObjectArrayP11Il2CppArray13Il2Cpp_IntPtrRPv: __Z45AndroidJNI_CUSTOM_INTERNAL_CALL_ToObjectArrayP11Il2CppArray13Il2Cpp_IntPtrRPv, __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_: __Z15tessMeshConnectP8TESSmeshP12TESShalfEdgeS2_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE10__set_sizeEj, __ZN5physx6shdfnd5ArrayIPNS_11PxsBodyCoreENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_11PxsBodyCoreENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z47ConfigurableJoint_Set_Custom_PropProjectionModeP12Il2CppObjecti: __Z47ConfigurableJoint_Set_Custom_PropProjectionModeP12Il2CppObjecti, __ZNSt3__227__insertion_sort_incompleteIRPFbPN2UI6CanvasES3_EPS3_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbPN2UI6CanvasES3_EPS3_EEbT0_S8_T_, __Z69Register_UnityEngine_SceneManagement_Scene_GetRootGameObjectsInternalv: __Z69Register_UnityEngine_SceneManagement_Scene_GetRootGameObjectsInternalv, __Z29getPxCloth_LinearInertiaScalePKN5physx7PxClothE: __Z29getPxCloth_LinearInertiaScalePKN5physx7PxClothE, __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj: __ZN5physx2Gu22closestPtPointTriangleEPNS_6shdfnd3aos5Vec3VES4_S4_PiS5_Rj, __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu19SupportMapLocalImplINS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, __Z34Terrain_Get_Custom_PropTerrainDataP12Il2CppObject: __Z34Terrain_Get_Custom_PropTerrainDataP12Il2CppObject, __ZN5physx7NpCloth21setCollisionMassScaleEf: __ZN5physx7NpCloth21setCollisionMassScaleEf, __ZNK5Unity5Cloth26GetTypeInfoVirtualInternalEv: __ZNK5Unity5Cloth26GetTypeInfoVirtualInternalEv, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS_9allocatorIS3_EEE18__construct_at_endIPS3_EENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_j, __Z60Register_UnityEngine_LODGroup_set_crossFadeAnimationDurationv: __Z60Register_UnityEngine_LODGroup_set_crossFadeAnimationDurationv, __ZN13RenderTexture16SetSRGBReadWriteEb: __ZN13RenderTexture16SetSRGBReadWriteEb, __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_12PxActorShapeENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z55Register_UnityEngine_LightmapSettings_get_lightmapsModev: __Z55Register_UnityEngine_LightmapSettings_get_lightmapsModev, __ZL29InitializeModule_UnityConnectv: __ZL29InitializeModule_UnityConnectv, __ZN5physx2Gu9Container5RefitEv: __ZN5physx2Gu9Container5RefitEv, __ZThn8_N12_GLOBAL__N_111StreamOwnerD0Ev: __ZThn8_N12_GLOBAL__N_111StreamOwnerD0Ev, __ZN21AnimationClipPlayable19DeallocateResourcesEv: __ZN21AnimationClipPlayable19DeallocateResourcesEv, __ZN6IDList7GetNextER8GUIStatei9FocusTypeRK5RectTIfE: __ZN6IDList7GetNextER8GUIStatei9FocusTypeRK5RectTIfE, __GLOBAL__sub_I_runtime_shaders_lump_cpp: __GLOBAL__sub_I_runtime_shaders_lump_cpp, __Z39BillboardAsset_CUSTOM_GetImageTexCoordsP12Il2CppObject: __Z39BillboardAsset_CUSTOM_GetImageTexCoordsP12Il2CppObject, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewFloatArrayv: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewFloatArrayv, __GLOBAL__sub_I_runtime_camera_renderloops2_lump_cpp: __GLOBAL__sub_I_runtime_camera_renderloops2_lump_cpp, __Z36getPxClothMotionConstraintConfigBiasPKN5physx29PxClothMotionConstraintConfigE: __Z36getPxClothMotionConstraintConfigBiasPKN5physx29PxClothMotionConstraintConfigE, __ZN5physx37updateAtomProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj: __ZN5physx37updateAtomProgressesWithArticulationsEPNS_23PxcSolverConstraintDescEjjjPjj, __ZN15DistanceJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15DistanceJoint2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1E8Vector2fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIwwEEPwEEjT0_S5_S5_S5_S5_T_, __ZN5physx6PxBaseD2Ev: __ZN5physx6PxBaseD2Ev, __ZN5physx7NpCloth18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj: __ZN5physx7NpCloth18setCollisionPlanesEPKNS_21PxClothCollisionPlaneEj, __Z50Register_UnityEngine_AudioSource_get_rolloffFactorv: __Z50Register_UnityEngine_AudioSource_get_rolloffFactorv, __ZN7mecanim8skeleton20SkeletonPoseSetDirtyEPKNS0_8SkeletonEPjiij: __ZN7mecanim8skeleton20SkeletonPoseSetDirtyEPKNS0_8SkeletonEPjiij, __ZN5physx2Sc24ConstraintProjectionTree20buildProjectionTreesERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc24ConstraintProjectionTree20buildProjectionTreesERNS0_19ConstraintGroupNodeE, __ZNK8Animator13GetPlayerTypeEv: __ZNK8Animator13GetPlayerTypeEv, __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_: __Z8EvaluateIL12GradientMode0ELS0_1EEN4math4pix4ERK14MinMaxGradientRKNS1_7_float4ES8_, __ZN12_GLOBAL__N_119RendererEventClient17handleBufferFlushEPKhj: __ZN12_GLOBAL__N_119RendererEventClient17handleBufferFlushEPKhj, __ZL24GeomMTDCallback_PlaneBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL24GeomMTDCallback_PlaneBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZN9Behaviour10SetEnabledEb: __ZN9Behaviour10SetEnabledEb, _pad: _pad, __ZN12AudioManager14OnExitPlayModeEv: __ZN12AudioManager14OnExitPlayModeEv, __ZN19LowerResBlitTexture13ApplySettingsEv: __ZN19LowerResBlitTexture13ApplySettingsEv, __ZN5physx16PxsBroadPhaseMBPC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerERKNS_11PxSceneDescEPNS_14PxsAABBManagerE: __ZN5physx16PxsBroadPhaseMBPC2ERNS_19PxcScratchAllocatorERNS_2Cm13EventProfilerERKNS_11PxSceneDescEPNS_14PxsAABBManagerE, __ZN14EdgeCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN14EdgeCollider2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx16NpParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx16NpParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE, __Z29scripting_gchandle_get_targetj: __Z29scripting_gchandle_get_targetj, __Z54Register_UnityEngine_VR_VRSettings_get_eyeTextureWidthv: __Z54Register_UnityEngine_VR_VRSettings_get_eyeTextureWidthv, __ZN5physx30PxDistanceJointGeneratedValuesC2EPKNS_15PxDistanceJointE: __ZN5physx30PxDistanceJointGeneratedValuesC2EPKNS_15PxDistanceJointE, __Z32AndroidJNI_CUSTOM_CallLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z32AndroidJNI_CUSTOM_CallLongMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorI17AnimationCurveTplIfE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __Z25dtNavMeshHeaderSwapEndianPh: __Z25dtNavMeshHeaderSwapEndianPh, __Z35GUI_CUSTOM_InitializeGUIClipTexturev: __Z35GUI_CUSTOM_InitializeGUIClipTexturev, __ZN9Texture2D21AwakeFromLoadThreadedEv: __ZN9Texture2D21AwakeFromLoadThreadedEv, __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20ComputeShaderVariant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectR10ColorRGBAf: __Z44CanvasRenderer_CUSTOM_INTERNAL_CALL_GetColorP12Il2CppObjectR10ColorRGBAf, __ZN14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj: __ZN14PhysicsManager9onContactERKN5physx19PxContactPairHeaderEPKNS0_13PxContactPairEj, __ZN13WheelCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13WheelCollider23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI8UnityStr13stl_allocatorIS1_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z21Event_CUSTOM_PopEventP12Il2CppObject: __Z21Event_CUSTOM_PopEventP12Il2CppObject, __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferItEEvRT_PKc17TransferMetaFlagsb, _putc: _putc, __ZN23MeshVertexFormatManager10GetDefaultEj: __ZN23MeshVertexFormatManager10GetDefaultEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj49ENS0_26PxPvdRangePropertyAccessorILj49ES4_jEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj49ENS0_26PxPvdRangePropertyAccessorILj49ES4_jEEEEvjRKT0_, __Z42Input_CUSTOM_INTERNAL_get_mouseScrollDeltaP13Vector2fIcall: __Z42Input_CUSTOM_INTERNAL_get_mouseScrollDeltaP13Vector2fIcall, __Z27Material_CUSTOM_GetPassNameP12Il2CppObjecti: __Z27Material_CUSTOM_GetPassNameP12Il2CppObjecti, __Z56Register_UnityEngine_TextGenerator_GetCharactersInternalv: __Z56Register_UnityEngine_TextGenerator_GetCharactersInternalv, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetZv, _gray_raster_render: _gray_raster_render, __ZN16MessageForwarder18HasMessageCallbackERK17MessageIdentifier: __ZN16MessageForwarder18HasMessageCallbackERK17MessageIdentifier, _puts: _puts, __ZN5physx2Gu5Debug9visualizeERKNS_20PxConvexMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj: __ZN5physx2Gu5Debug9visualizeERKNS_20PxConvexMeshGeometryERNS_2Cm12RenderOutputERKNS5_8Matrix34ERKNS_9PxBounds3Eyfj, __ZNK9Heightmap12GetSteepnessEff: __ZNK9Heightmap12GetSteepnessEff, _putw: _putw, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setCMassLocalPoseInternalERKNS_11PxTransformE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE25setCMassLocalPoseInternalERKNS_11PxTransformE, __ZN7mecanim19ValueArrayBlendNodeERNS_10ValueArrayERNS_16ValueArrayWeightERNS_14ValueArrayMaskERKS0_RKS4_f: __ZN7mecanim19ValueArrayBlendNodeERNS_10ValueArrayERNS_16ValueArrayWeightERNS_14ValueArrayMaskERKS0_RKS4_f, _jpeg_write_scanlines: _jpeg_write_scanlines, __Z56Register_UnityEngine_TrailRenderer_set_minVertexDistancev: __Z56Register_UnityEngine_TrailRenderer_set_minVertexDistancev, __ZN9Scripting25BroadcastScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti: __ZN9Scripting25BroadcastScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __Z28GameObject_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString: __Z28GameObject_CUSTOM_CompareTagP12Il2CppObjectP12Il2CppString, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4swapERS3_: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE4swapERS3_, __ZN5physx18PxcSweepConvexMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx18PxcSweepConvexMeshERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN12_GLOBAL__N_110Connection6addRefEv: __ZN12_GLOBAL__N_110Connection6addRefEv, __ZN11UmbraModule13LoadUmbraTomeEPKhj: __ZN11UmbraModule13LoadUmbraTomeEPKhj, __ZNK12TreeDatabase9Prototype31GetTreeInstanceMatrixNoRotationER10Matrix4x4fRK8Vector3fRK12TreeInstance: __ZNK12TreeDatabase9Prototype31GetTreeInstanceMatrixNoRotationER10Matrix4x4fRK8Vector3fRK12TreeInstance, __ZN14ParticleSystem13SetStartDelayEf: __ZN14ParticleSystem13SetStartDelayEf, __ZN5physx6shdfnd7FastIPC7canSendEj: __ZN5physx6shdfnd7FastIPC7canSendEj, __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrjEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier85ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10putToSleepEv, __Z54Register_UnityEngine_AndroidJNI_CallStaticStringMethodv: __Z54Register_UnityEngine_AndroidJNI_CallStaticStringMethodv, __Z43Register_UnityEngine_RenderSettings_get_sunv: __Z43Register_UnityEngine_RenderSettings_get_sunv, __ZN4Mesh11SetTangentsEPK8Vector4fj: __ZN4Mesh11SetTangentsEPK8Vector4fj, __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEjT0_S6_S6_S6_T_, __ZN5physx2Gu10ConvexMesh14onRefCountZeroEv: __ZN5physx2Gu10ConvexMesh14onRefCountZeroEv, __ZN30RuntimeInitializeOnLoadManager13AwakeFromLoadE17AwakeFromLoadMode: __ZN30RuntimeInitializeOnLoadManager13AwakeFromLoadE17AwakeFromLoadMode, __Z37Canvas_Get_Custom_PropOverrideSortingP12Il2CppObject: __Z37Canvas_Get_Custom_PropOverrideSortingP12Il2CppObject, __Z30ConvertLegacyShaderChannelMaskj: __Z30ConvertLegacyShaderChannelMaskj, __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE: __ZN5physx13PxcLtbProjectERKNS_9PxcFsDataEPNS_14PxcSIMDSpatialEPNS_6shdfnd3aos5Vec3VE, __ZNK14b2CapsuleShape5CloneEP16b2BlockAllocator: __ZNK14b2CapsuleShape5CloneEP16b2BlockAllocator, __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local13_computeDepthERKS1_PNS0_9MetaClassEiRi: __ZZN5physx2Sn8MetaData4loadERNS_13PxInputStreamENS0_12MetaDataTypeEEN5Local13_computeDepthERKS1_PNS0_9MetaClassEiRi, __ZN5Umbra9Matrix4x44makeERKNS_9Matrix4x3E: __ZN5Umbra9Matrix4x44makeERKNS_9Matrix4x3E, __ZN5physx6shdfnd8TlsAllocEv: __ZN5physx6shdfnd8TlsAllocEv, __ZNK16b2PrismaticJoint14IsLimitEnabledEv: __ZNK16b2PrismaticJoint14IsLimitEnabledEv, __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_25PxcThresholdStreamElementENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZNK16LightmapSettings23GetLightmapDecodeValuesEv: __ZNK16LightmapSettings23GetLightmapDecodeValuesEv, __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii: __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_ii, __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN23ShaderVariantCollection11VariantInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z44AnimatorControllerPlayable_CUSTOM_SetFloatIDR9HPlayableif: __Z44AnimatorControllerPlayable_CUSTOM_SetFloatIDR9HPlayableif, __ZN13ComputeShader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13ComputeShader23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK16TypeTreeIterator4NextEv: __ZNK16TypeTreeIterator4NextEv, __ZN15NavMeshObstacle23VirtualRedirectTransferER14SafeBinaryRead: __ZN15NavMeshObstacle23VirtualRedirectTransferER14SafeBinaryRead, __ZN21EnlightenSceneMapping6AppendEiRKS_: __ZN21EnlightenSceneMapping6AppendEiRKS_, __Z35setPxHeightFieldGeometryHeightScalePN5physx21PxHeightFieldGeometryEf: __Z35setPxHeightFieldGeometryHeightScalePN5physx21PxHeightFieldGeometryEf, __ZN11DynamicMesh12CollapseEdgeEii: __ZN11DynamicMesh12CollapseEdgeEii, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj556ENS_22PxRepXPropertyAccessorILj556ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEE14handleAccessorILj556ENS_22PxRepXPropertyAccessorILj556ES4_ffEEEEvRKT0_, __ZN5physx22PxClothGeneratedValuesC2EPKNS_7PxClothE: __ZN5physx22PxClothGeneratedValuesC2EPKNS_7PxClothE, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj384EEEEEE4copyINS0_15InlineAllocatorILj256ES7_EEEEvRKNS1_IS2_T_EE, __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_: __ZNSt3__24listI4PPtrI6CameraENS_9allocatorIS3_EEE6removeERKS3_, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE12getClassSizeEv, __Z42setPxScene_ClothInterCollisionNbIterationsPN5physx7PxSceneEj: __Z42setPxScene_ClothInterCollisionNbIterationsPN5physx7PxSceneEj, _localeconv: _localeconv, __ZN5physx6shdfnd13ReadWriteLockD2Ev: __ZN5physx6shdfnd13ReadWriteLockD2Ev, __ZNK5physx24PxDefaultMemoryInputData9getLengthEv: __ZNK5physx24PxDefaultMemoryInputData9getLengthEv, __ZNK5physx19NpArticulationJoint13isSubordinateEv: __ZNK5physx19NpArticulationJoint13isSubordinateEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, _PxRegisterUnifiedHeightFields: _PxRegisterUnifiedHeightFields, __ZN5physx2Cm10Collection8removeIdEy: __ZN5physx2Cm10Collection8removeIdEy, __ZN10HumanTrait12RequiredBoneEi: __ZN10HumanTrait12RequiredBoneEi, __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E: __Z15UpdateRandomTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveS3_S3_R5RandNR23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS8_7_float4E, __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN7Joint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelv: __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_GetPixelv, __ZNSt3__26vectorIPN4FMOD3DSPENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN4FMOD3DSPENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZN15ParticleEmitter18InitParticleEnergyER4RandR8Particlef: __ZN15ParticleEmitter18InitParticleEnergyER4RandR8Particlef, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj506ENS_22PxRepXPropertyAccessorILj506ENS_8PxSpringEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxD6JointDriveEEEE14handleAccessorILj506ENS_22PxRepXPropertyAccessorILj506ENS_8PxSpringEffEEEEvRKT0_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEaSERKS5_, __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayIN4math14float3_storageELj4EEE19ResizeSTLStyleArrayERS3_iRK10MemLabelId, __ZN25ConvexVsMeshSweepCallbackD2Ev: __ZN25ConvexVsMeshSweepCallbackD2Ev, __Z24InitializeVehiclesModulev: __Z24InitializeVehiclesModulev, __ZN19SkinnedMeshRenderer13DidModifyMeshEv: __ZN19SkinnedMeshRenderer13DidModifyMeshEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_png_set_read_user_transform_fn: _UNITY_png_set_read_user_transform_fn, __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j: __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E9copy_fromERKSF_j, __ZN5physx2Sc9StaticSimD2Ev: __ZN5physx2Sc9StaticSimD2Ev, __ZN5physx2Sq16BucketPrunerCoreD2Ev: __ZN5physx2Sq16BucketPrunerCoreD2Ev, __ZN13BuildSettingsD0Ev: __ZN13BuildSettingsD0Ev, __ZN5physx2Sc20ArticulationJointSimD0Ev: __ZN5physx2Sc20ArticulationJointSimD0Ev, __ZNK18PlatformEffector2D18DesignedForTriggerEv: __ZNK18PlatformEffector2D18DesignedForTriggerEv, __ZN14PhysicsManager18ReleasePxMaterialsER13dynamic_arrayIP14PhysicMaterialLj4EE: __ZN14PhysicsManager18ReleasePxMaterialsER13dynamic_arrayIP14PhysicMaterialLj4EE, __Z20InvertMatrix4x4_FullPKfPf: __Z20InvertMatrix4x4_FullPKfPf, _munlock: _munlock, __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt: __ZN5physx2Sc9ShapeCore18setMaterialIndicesEPKtt, __Z34Animator_Set_Custom_PropUpdateModeP12Il2CppObjectN8Animator10UpdateModeE: __Z34Animator_Set_Custom_PropUpdateModeP12Il2CppObjectN8Animator10UpdateModeE, __ZN13b2DynamicTree11CreateProxyERK6b2AABBPv: __ZN13b2DynamicTree11CreateProxyERK6b2AABBPv, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17setStaticFrictionEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE17setStaticFrictionEf, __ZN20SoundChannelInstance23ApplyBufferedParametersEv: __ZN20SoundChannelInstance23ApplyBufferedParametersEv, __ZN5physx20PxsSolverCoreGeneral6createEv: __ZN5physx20PxsSolverCoreGeneral6createEv, __ZNK5Umbra14TomeCollection13getGateUserIDEi: __ZNK5Umbra14TomeCollection13getGateUserIDEi, __ZN10AudioMixerD0Ev: __ZN10AudioMixerD0Ev, _Horizontal_Sweep_Span: _Horizontal_Sweep_Span, __ZN5Umbra11TileMatcher10matchTilesEiRKNS_8RectBaseINS_8Vector2iEiEEiS5_: __ZN5Umbra11TileMatcher10matchTilesEiRKNS_8RectBaseINS_8Vector2iEiEEiS5_, __ZNK13AnimationClip18GetAverageDurationEv: __ZNK13AnimationClip18GetAverageDurationEv, __ZN13ProbeRenderer8ConvolveEv: __ZN13ProbeRenderer8ConvolveEv, __ZN12NavMeshAgent11SetAreaCostEjf: __ZN12NavMeshAgent11SetAreaCostEjf, __ZN13GfxDeviceNull16CreateBlendStateERK13GfxBlendState: __ZN13GfxDeviceNull16CreateBlendStateERK13GfxBlendState, __ZN21UniformBufferTFMethod13DoneRenderingEv: __ZN21UniformBufferTFMethod13DoneRenderingEv, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE17AnimationCurveTplIfELb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx21PxcArticulationHelper12updateBodiesERKNS_25PxcArticulationSolverDescEf: __ZN5physx21PxcArticulationHelper12updateBodiesERKNS_25PxcArticulationSolverDescEf, __Z34Camera_CUSTOM_RemoveCommandBuffersP12Il2CppObject21RenderCameraEventType: __Z34Camera_CUSTOM_RemoveCommandBuffersP12Il2CppObject21RenderCameraEventType, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4AABBLj4EEEEvRT_17TransferMetaFlags, __ZN5physx8debugger14PvdMarshallingIfiE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIfiE12marshalBlockEPKhPhj, __ZN5physx8debugger19PvdNetworkOutStream20createDoubleBufferedERNS_19PxAllocatorCallbackERS1_j: __ZN5physx8debugger19PvdNetworkOutStream20createDoubleBufferedERNS_19PxAllocatorCallbackERS1_j, __ZN12_GLOBAL__N_111StreamOwner11getInStreamEv: __ZN12_GLOBAL__N_111StreamOwner11getInStreamEv, __ZN11UnityEngine15PlatformWrapper14GetRendererAPIEv: __ZN11UnityEngine15PlatformWrapper14GetRendererAPIEv, __ZN5physx7NpCloth22setSleepLinearVelocityEf: __ZN5physx7NpCloth22setSleepLinearVelocityEf, __ZN18AssetBundleManagerC2Ev: __ZN18AssetBundleManagerC2Ev, __Z14resize_trimmedINSt3__26vectorINS0_4pairIifEE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorINS0_4pairIifEE13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEEEvRT_j, __ZN5Umbra9IndexListC2EPiii: __ZN5Umbra9IndexListC2EPiii, _tre_parse: _tre_parse, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEEEEvRT_17TransferMetaFlags, __Z61Register_UnityEngine_ParticleRenderer_get_cameraVelocityScalev: __Z61Register_UnityEngine_ParticleRenderer_get_cameraVelocityScalev, _UNITY_FT_Get_First_Char: _UNITY_FT_Get_First_Char, __Z54Register_UnityEngine_TerrainData_get_wavingGrassAmountv: __Z54Register_UnityEngine_TerrainData_get_wavingGrassAmountv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv, _tlsf_free: _tlsf_free, __ZN16MecanimAnimation19PathHashesToIndicesERN5Unity9ComponentEPKjjPt: __ZN16MecanimAnimation19PathHashesToIndicesERN5Unity9ComponentEPKjjPt, __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15UnityAdsManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx27PxVehicleDriveGeneratedInfoC2Ev: __ZN5physx27PxVehicleDriveGeneratedInfoC2Ev, __ZL22stbir__decode_scanlineP11stbir__infoi: __ZL22stbir__decode_scanlineP11stbir__infoi, __Z41LineRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf: __Z41LineRenderer_CUSTOM_INTERNAL_get_endColorP12Il2CppObjectP10ColorRGBAf, _processblock: _processblock, __ZN20BaseBehaviourManager14IntegrateListsEv: __ZN20BaseBehaviourManager14IntegrateListsEv, __ZNSt3__26vectorI9UnityGUIDNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI9UnityGUIDNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapI8UnityStriNS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_iEEEEEEEEvRT_17TransferMetaFlags, __ZN15AnchoredJoint2D15ThreadedCleanupEv: __ZN15AnchoredJoint2D15ThreadedCleanupEv, __ZN11AudioSource19SetScheduledEndTimeEd: __ZN11AudioSource19SetScheduledEndTimeEd, __Z20PlayerUpdateCanvasesv: __Z20PlayerUpdateCanvasesv, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_9StopEventEEEvRNS0_11EventHeaderERT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE9sendEventINS0_9StopEventEEEvRNS0_11EventHeaderERT_, __Z37Register_UnityEngine_GUIText_get_fontv: __Z37Register_UnityEngine_GUIText_get_fontv, __ZNK5physx13GuMeshFactory19getNbTriangleMeshesEv: __ZNK5physx13GuMeshFactory19getNbTriangleMeshesEv, __Z35Cloth_Get_Custom_PropSleepThresholdP12Il2CppObject: __Z35Cloth_Get_Custom_PropSleepThresholdP12Il2CppObject, __ZN8TypeTreeaSERKS_: __ZN8TypeTreeaSERKS_, __Z36HumanTrait_Get_Custom_PropMuscleNamev: __Z36HumanTrait_Get_Custom_PropMuscleNamev, __ZN9CGProgram12SetCGProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9CGProgram12SetCGProgramERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx8debugger22PvdObjectModelMetaData31getCurrentPvdObjectModelVersionEv: __ZN5physx8debugger22PvdObjectModelMetaData31getCurrentPvdObjectModelVersionEv, _cff_get_ros: _cff_get_ros, __Z19getPxPhysics_ScenesPKN5physx9PxPhysicsEPPNS_7PxSceneEj: __Z19getPxPhysics_ScenesPKN5physx9PxPhysicsEPPNS_7PxSceneEj, __Z41AudioEchoFilter_Set_Custom_PropDecayRatioP12Il2CppObjectf: __Z41AudioEchoFilter_Set_Custom_PropDecayRatioP12Il2CppObjectf, __ZN9Scripting11RaiseIfNullEP12Il2CppObject: __ZN9Scripting11RaiseIfNullEP12Il2CppObject, __ZN13UnityProfiler21StartNewFrameInternalE12ProfilerMode: __ZN13UnityProfiler21StartNewFrameInternalE12ProfilerMode, __Z38getPxParticleBase_ExternalAccelerationPKN5physx14PxParticleBaseE: __Z38getPxParticleBase_ExternalAccelerationPKN5physx14PxParticleBaseE, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6rbeginEv, __ZN9UdpSocketC2Eb: __ZN9UdpSocketC2Eb, __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData: __ZL24GenerateParticleGeometryIL24ParticleSystemRenderMode0ELb1ELb1ELb0ELb0EEvPhRK22ParticleSystemTempDataRK26ParticleSystemRendererData32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesRK31ParticleSystemParticlesTempData, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE8readsomeEPwi: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE8readsomeEPwi, __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKNS_6PxVec3ES6_fRj: __ZNK5physx3Cct15ObstacleContext13raycastSingleERNS_12PxRaycastHitERKNS_6PxVec3ES6_fRj, __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GradientEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx6shdfnd7PAUtils10debugEventEtjj: __ZN5physx6shdfnd7PAUtils10debugEventEtjj, __ZN5physx2Sn18RepXCollectionImpl18setTolerancesScaleERKNS_17PxTolerancesScaleE: __ZN5physx2Sn18RepXCollectionImpl18setTolerancesScaleERKNS_17PxTolerancesScaleE, __Z50Collider_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_: __Z50Collider_CUSTOM_INTERNAL_CALL_ClosestPointOnBoundsP12Il2CppObjectRK8Vector3fRS1_, __ZN6Camera19SetDepthTextureModeEj: __ZN6Camera19SetDepthTextureModeEj, ___freadahead: ___freadahead, __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI18TexFormatARGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZN23RaycastCallbackNonAlloc14processTouchesEPKN5physx12PxRaycastHitEj: __ZN23RaycastCallbackNonAlloc14processTouchesEPKN5physx12PxRaycastHitEj, __Z40Cloth_Set_Custom_PropUseVirtualParticlesP12Il2CppObjectf: __Z40Cloth_Set_Custom_PropUseVirtualParticlesP12Il2CppObjectf, __ZN5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEED0Ev: __ZN5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEED0Ev, __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapZMultiplierP12Il2CppObjectf: __Z53ParticleSystem_NoiseModule_CUSTOM_SetRemapZMultiplierP12Il2CppObjectf, __ZN15DownloadHandler6RetainEv: __ZN15DownloadHandler6RetainEv, __ZL30InitializeSpeedTreeWindManagerPv: __ZL30InitializeSpeedTreeWindManagerPv, __ZN5physx3Ext23DefaultBufferedProfiler27addBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE: __ZN5physx3Ext23DefaultBufferedProfiler27addBufferedProfilerCallbackERNS_26PxBufferedProfilerCallbackE, __ZNKSt3__210moneypunctIcLb1EE13decimal_pointEv: __ZNKSt3__210moneypunctIcLb1EE13decimal_pointEv, __ZN9GfxDevice20SetRenderSurfaceNameEP17RenderSurfaceBasePKc: __ZN9GfxDevice20SetRenderSurfaceNameEP17RenderSurfaceBasePKc, __ZN18SpeedTreeWindAssetD0Ev: __ZN18SpeedTreeWindAssetD0Ev, __Z52Register_UnityEngine_Canvas_GetDefaultCanvasMaterialv: __Z52Register_UnityEngine_Canvas_GetDefaultCanvasMaterialv, __ZN10Effector2D15PreSolveContactEP9b2Contact: __ZN10Effector2D15PreSolveContactEP9b2Contact, __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii: __ZN5Umbra11Transformer4initERKNS_18ImpCameraTransformENS_7Vector3Eiii, __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi: __ZN5Umbra13BorderMatcherC2ERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERNS1_IiEERNS2_13GeneratorTreeEi, __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity10HingeJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z57Register_UnityEngine_Material_get_globalIlluminationFlagsv: __Z57Register_UnityEngine_Material_get_globalIlluminationFlagsv, __ZN5physx8debugger14PvdMarshallingItfE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItfE12marshalBlockEPKhPhj, __Z40NavMeshAgent_Set_Custom_PropAccelerationP12Il2CppObjectf: __Z40NavMeshAgent_Set_Custom_PropAccelerationP12Il2CppObjectf, __ZNKSt3__27codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_: __ZNKSt3__27codecvtIDsc11__mbstate_tE10do_unshiftERS1_PcS4_RS4_, __Z19GetGyroRotationRatei: __Z19GetGyroRotationRatei, __Z17dynamic_pptr_castIP10GameObject6ObjectET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP10GameObject6ObjectET_RK4PPtrIT0_E, __ZN5audio5mixer16SnapshotConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5audio5mixer16SnapshotConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN8Renderer19SetSortingLayerNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN8Renderer19SetSortingLayerNameERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z34TextMesh_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z34TextMesh_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh: __ZN5physx2Gu22GJKRelativePenetrationERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERNS8_5Vec3VESG_SG_RSC_PhSI_Rh, __ZNK12GUIClipState9GetOffsetEv: __ZNK12GUIClipState9GetOffsetEv, _UNITY_png_write_cHRM_fixed: _UNITY_png_write_cHRM_fixed, __ZN8Renderer10DeactivateE19DeactivateOperation: __ZN8Renderer10DeactivateE19DeactivateOperation, __ZN7mecanim5human9HumanPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim5human9HumanPose8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN9Transform20SendTransformChangedEi: __ZN9Transform20SendTransformChangedEi, __Z38DynamicGI_Set_Custom_PropIndirectScalef: __Z38DynamicGI_Set_Custom_PropIndirectScalef, __ZNKSt3__214__codecvt_utf8IDsE13do_max_lengthEv: __ZNKSt3__214__codecvt_utf8IDsE13do_max_lengthEv, __ZN12HingeJoint2D9SetLimitsERK18JointAngleLimits2D: __ZN12HingeJoint2D9SetLimitsERK18JointAngleLimits2D, __Z23SetClothingSceneGravityRK8Vector3f: __Z23SetClothingSceneGravityRK8Vector3f, __ZNSt3__219__shared_weak_count12__add_sharedEv: __ZNSt3__219__shared_weak_count12__add_sharedEv, __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj: __Z30AddDefaultStreamsToMeshBuffersR9GfxDeviceR11MeshBuffersjjj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj432ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj432ES3_RKNS_16PxJointLimitConeES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB: __ZN19SkinnedMeshRenderer24CalculateBoneBasedBoundsEPK10Matrix4x4fjR10MinMaxAABB, __ZNK20LocalFileSystemPosix6TargetERK13FileEntryDataR15FileSystemEntry: __ZNK20LocalFileSystemPosix6TargetERK13FileEntryDataR15FileSystemEntry, __Z40getPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataEj: __Z40getPxVehicleWheelsSimData_SuspensionDataPKN5physx22PxVehicleWheelsSimDataEj, __ZN16Physics2DManager16OverlapCircleAllERK8Vector2ffiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE: __ZN16Physics2DManager16OverlapCircleAllERK8Vector2ffiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE, __Z24RegisterStrippedTypeInfoIN5Unity5ClothEEviPKcS3_: __Z24RegisterStrippedTypeInfoIN5Unity5ClothEEviPKcS3_, __ZN3WWWD0Ev: __ZN3WWWD0Ev, __Z45getPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataEj: __Z45getPxVehicleWheelsSimData_SuspTravelDirectionPKN5physx22PxVehicleWheelsSimDataEj, __ZN5physx2Gu25contactCapsuleHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu25contactCapsuleHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, _UNITY_tt_face_load_hmtx: _UNITY_tt_face_load_hmtx, __ZNKSt3__28numpunctIwE12do_falsenameEv: __ZNKSt3__28numpunctIwE12do_falsenameEv, __Z18ConvertUTF8toUTF16PKhiR13dynamic_arrayItLj2EE: __Z18ConvertUTF8toUTF16PKhiR13dynamic_arrayItLj2EE, __ZN5physx5cloth9SwFactoryC2Ev: __ZN5physx5cloth9SwFactoryC2Ev, __Z28GUIStyleState_CUSTOM_CleanupP12Il2CppObject: __Z28GUIStyleState_CUSTOM_CleanupP12Il2CppObject, __Z25Camera_Get_Custom_PropHdrP12Il2CppObject: __Z25Camera_Get_Custom_PropHdrP12Il2CppObject, __ZN12_GLOBAL__N_117ConnectionManager23recordAllocationHandlerEjPKcS2_iPv: __ZN12_GLOBAL__N_117ConnectionManager23recordAllocationHandlerEjPKcS2_iPv, __ZNKSt3__217moneypunct_bynameIwLb0EE13do_pos_formatEv: __ZNKSt3__217moneypunct_bynameIwLb0EE13do_pos_formatEv, __ZN15GUIEventManager11ClearEventsEv: __ZN15GUIEventManager11ClearEventsEv, __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventv: __Z68Register_UnityEngine_Analytics_UnityAnalyticsHandler_SendCustomEventv, _UNITY_FT_Outline_Get_Orientation: _UNITY_FT_Outline_Get_Orientation, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15ScriptsIterator4NextEv: __ZN15ScriptsIterator4NextEv, __ZN31ThreadsafeLinearAllocatorHeader29CalculateNeededAllocationSizeEji: __ZN31ThreadsafeLinearAllocatorHeader29CalculateNeededAllocationSizeEji, __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESI_RKT_: __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE12__find_equalIS6_EERPNS_16__tree_node_baseIPvEESI_RKT_, __ZN11UnityEngine15PlatformWrapper17GameEngineVersionEv: __ZN11UnityEngine15PlatformWrapper17GameEngineVersionEv, __Z13RegisterClassI14SpriteRendererEvv: __Z13RegisterClassI14SpriteRendererEvv, __Z19GL_CUSTOM_LoadOrthov: __Z19GL_CUSTOM_LoadOrthov, __ZN5physx16PxsFluidDynamics29updateParticlesBruteForceHaloENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE: __ZN5physx16PxsFluidDynamics29updateParticlesBruteForceHaloENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE, __Z27setPxClothParticleInvWeightPN5physx15PxClothParticleEf: __Z27setPxClothParticleInvWeightPN5physx15PxClothParticleEf, __ZN8JSONRead8TransferIN11UnityEngine7Connect13ConnectConfig14GroupingConfigEEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIN11UnityEngine7Connect13ConnectConfig14GroupingConfigEEEvRT_PKc17TransferMetaFlagsb, __ZL23CompareMeshTriangleDataRK16MeshTriangleDataS1_: __ZL23CompareMeshTriangleDataRK16MeshTriangleDataS1_, __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_7NpShapeENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __Z53Renderer_Set_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObjectS0_: __Z53Renderer_Set_Custom_PropLightProbeProxyVolumeOverrideP12Il2CppObjectS0_, __Z33Projector_Get_Custom_PropMaterialP12Il2CppObject: __Z33Projector_Get_Custom_PropMaterialP12Il2CppObject, __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Behaviour8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z8rotate2DRKfS0_S0_: __Z8rotate2DRKfS0_S0_, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __Z64Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeVertexBufferPtrv: __Z64Register_UnityEngine_Mesh_INTERNAL_CALL_GetNativeVertexBufferPtrv, __ZN7mecanim9animation30SkeletonPoseFromValueRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapEPKiRS8_ii: __ZN7mecanim9animation30SkeletonPoseFromValueRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapEPKiRS8_ii, __Z44Register_UnityEngine_ReflectionProbe_set_hdrv: __Z44Register_UnityEngine_ReflectionProbe_set_hdrv, _jpeg_read_scanlines: _jpeg_read_scanlines, __Z41Register_UnityEngine_LocationService_Stopv: __Z41Register_UnityEngine_LocationService_Stopv, __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKiPKcEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E12resize_deltaEjj, __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEEC2INS_11__wrap_iterIPS1_EEEET_SA_RKS4_PNS_9enable_ifIXaasr21__is_forward_iteratorISA_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeE: __ZNSt3__26vectorI14HeightMeshData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEEC2INS_11__wrap_iterIPS1_EEEET_SA_RKS4_PNS_9enable_ifIXaasr21__is_forward_iteratorISA_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeE, __ZN5physx2Sc13ClothBulkDataD2Ev: __ZN5physx2Sc13ClothBulkDataD2Ev, __ZN13UnityProfiler7CleanupEv: __ZN13UnityProfiler7CleanupEv, __ZN6prcoreL12RemapGenericI15TexFormatRGB56511TexFormatI8EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB56511TexFormatI8EEvPKNS_9InnerInfoE, __ZN17ArchiveFileSystem4LockER13FileEntryData12FileLockMode: __ZN17ArchiveFileSystem4LockER13FileEntryData12FileLockMode, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj389ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxClothStretchConfigEEEEclILj389ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleNoDriveEEEE27handleExtendedIndexPropertyILj695ES4_fKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z11tesedgeEvalP10TESSvertexS0_S0_: __Z11tesedgeEvalP10TESSvertexS0_S0_, __Z27FindSeparatedPathComponentsPKcjc: __Z27FindSeparatedPathComponentsPKcjc, __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_set_lowAngularXLimitv: __Z68Register_UnityEngine_ConfigurableJoint_INTERNAL_set_lowAngularXLimitv, __ZNSt3__219__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_: __ZNSt3__219__double_or_nothingIcEEvRNS_10unique_ptrIT_PFvPvEEERPS2_S9_, __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc: __ZN10__cxxabiv112_GLOBAL__N_111string_pairC2ILj13EEERAT__Kc, __ZN5physx2Sc21ArticulationJointCore10setDampingEf: __ZN5physx2Sc21ArticulationJointCore10setDampingEf, __Z10DecodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z10DecodePathRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN25b2CapsuleAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN25b2CapsuleAndCircleContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN5physx3Ext13RevoluteJoint16setDriveVelocityEf: __ZN5physx3Ext13RevoluteJoint16setDriveVelocityEf, __ZN5physx2Sc19ParticlePacketShape19reallocInteractionsERPPNS0_35ParticleElementRbElementInteractionERttt: __ZN5physx2Sc19ParticlePacketShape19reallocInteractionsERPPNS0_35ParticleElementRbElementInteractionERttt, __ZNK5physx3Cct13BoxController16getContactOffsetEv: __ZNK5physx3Cct13BoxController16getContactOffsetEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEE15growAndPushBackERKS2_, __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd6MutexTINS_8debugger19ForwardingAllocatorEED2Ev, __ZN5physx21PxsBodyTransformVault12teleportBodyERKNS_11PxsBodyCoreE: __ZN5physx21PxsBodyTransformVault12teleportBodyERKNS_11PxsBodyCoreE, __ZN5Umbra9Matrix3x39transposeERKS0_: __ZN5Umbra9Matrix3x39transposeERKS0_, __ZN5physx24NbBroadPhaseAddsPropertyC2Ev: __ZN5physx24NbBroadPhaseAddsPropertyC2Ev, __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj: __ZNK5physx22PxVehicleWheelsSimData12getWheelDataEj, __ZNK13ScreenManager14HasBlitTextureEv: __ZNK13ScreenManager14HasBlitTextureEv, __ZN4FMOD6System11getUserDataEPPv: __ZN4FMOD6System11getUserDataEPPv, __ZNKSt3__215__codecvt_utf16IDiLb0EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IDiLb0EE16do_always_noconvEv, __Z7OpenURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z7OpenURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, _chmod: _chmod, __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_22PxVehicleWheelsSimDataEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj: __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE6resizeEjRKj, __ZNSt11range_errorD0Ev: __ZNSt11range_errorD0Ev, __ZNSt3__26locale5__imp12install_fromINS_7codecvtIcc11__mbstate_tEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_7codecvtIcc11__mbstate_tEEEEvRKS1_, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6insertENS_11__wrap_iterIPKS1_EERS7_, __ZN22UnityAnalyticsSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN22UnityAnalyticsSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11DynamicMesh22RemovePolygonUnorderedEj: __ZN11DynamicMesh22RemovePolygonUnorderedEj, __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj: __ZN7mecanim14FindValueIndexEPKNS_18ValueArrayConstantEj, __Z36Projector_Set_Custom_PropAspectRatioP12Il2CppObjectf: __Z36Projector_Set_Custom_PropAspectRatioP12Il2CppObjectf, __ZNK5Umbra7ImpTome12computeCRC32Ev: __ZNK5Umbra7ImpTome12computeCRC32Ev, __Z46getPxSimulationStatisticsCompressedContactSizePKN5physx22PxSimulationStatisticsE: __Z46getPxSimulationStatisticsCompressedContactSizePKN5physx22PxSimulationStatisticsE, _nanf: _nanf, __ZN8GUIStyle15SetMouseTooltipER8GUIStateRK11UTF16StringRK5RectTIfE: __ZN8GUIStyle15SetMouseTooltipER8GUIStateRK11UTF16StringRK5RectTIfE, __ZN10Matrix3x3f10IsIdentityEf: __ZN10Matrix3x3f10IsIdentityEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj416ENS_22PxRepXPropertyAccessorILj416ENS_7PxJointEffEEEEvRKT0_, __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev: __ZN5physx32PxVehicleClutchDataGeneratedInfoC2Ev, __ZN5physx20PxsSolverCoreGeneralD0Ev: __ZN5physx20PxsSolverCoreGeneralD0Ev, __Z16CleanupAfterLoadv: __Z16CleanupAfterLoadv, __ZN5physx8debugger4comm14CreateInstance9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm14CreateInstance9serializeERNS1_15EventSerializerE, __ZNKSt3__210moneypunctIwLb1EE11do_groupingEv: __ZNKSt3__210moneypunctIwLb1EE11do_groupingEv, __ZN12CachedReader21LockCacheBlockBoundedEv: __ZN12CachedReader21LockCacheBlockBoundedEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj42ENS_22PxRepXPropertyAccessorILj42ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj42ENS_22PxRepXPropertyAccessorILj42ES4_ffEEEEvRKT0_, __ZN7dtCrowd13getMoveTargetERK13dtCrowdHandlePf: __ZN7dtCrowd13getMoveTargetERK13dtCrowdHandlePf, __ZN10HumanTrait19GetMuscleDefaultMaxEi: __ZN10HumanTrait19GetMuscleDefaultMaxEi, __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_FindClassP12Il2CppStringRPv: __Z41AndroidJNI_CUSTOM_INTERNAL_CALL_FindClassP12Il2CppStringRPv, __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri: __ZN13ComputeShader20GetCompatibleVariantE17GfxDeviceRendereri, __ZN4FMOD6System17createDSPByPluginEjPPNS_3DSPE: __ZN4FMOD6System17createDSPByPluginEjPPNS_3DSPE, __Z21IsValidFileNameSymbolc: __Z21IsValidFileNameSymbolc, __Z45Physics2D_Set_Custom_PropMaxAngularCorrectionf: __Z45Physics2D_Set_Custom_PropMaxAngularCorrectionf, __ZNK5Unity9Component10HasEnabledEv: __ZNK5Unity9Component10HasEnabledEv, __ZN5physx24PxcPCMContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx24PxcPCMContactCapsuleMeshERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z40AreaEffector2D_Set_Custom_PropForceAngleP12Il2CppObjectf: __Z40AreaEffector2D_Set_Custom_PropForceAngleP12Il2CppObjectf, __ZN5physx6shdfnd19disableFPExceptionsEv: __ZN5physx6shdfnd19disableFPExceptionsEv, __ZN12SoundManager20RegisterModifiedClipEP10SampleClip: __ZN12SoundManager20RegisterModifiedClipEP10SampleClip, __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb: __ZN5physx2Sc10NPhaseCore28clearContactReportActorPairsEb, __ZNK13EmscriptenWWW17IsDownloadingDoneEv: __ZNK13EmscriptenWWW17IsDownloadingDoneEv, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __Z26TransformVerticesInnerLoopILb1ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags: __Z26TransformVerticesInnerLoopILb1ELb0ELb0EEvPhRK10Matrix4x4fRK10Matrix3x3fjPKhiiiS8_ii25GfxTransformVerticesFlags, __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext: __Z24EndRenderQueueExtractionP29RenderNodeQueuePrepareContext, __ZL16CreateSplashQuadR9Transform4PPtrI9Texture2DERK8Vector3fS6_: __ZL16CreateSplashQuadR9Transform4PPtrI9Texture2DERK8Vector3fS6_, __ZN8LODGroup25RemoveFromCachedRenderersEP8Renderer: __ZN8LODGroup25RemoveFromCachedRenderersEP8Renderer, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE20getExternalReferenceERj, __ZN12SoundManager20SetLoopPointsForClipEP10SampleClipPN4FMOD5SoundE: __ZN12SoundManager20SetLoopPointsForClipEP10SampleClipPN4FMOD5SoundE, __ZN10__cxxabiv119__pointer_type_infoD0Ev: __ZN10__cxxabiv119__pointer_type_infoD0Ev, __Z64Register_UnityEngine_Texture_SetGlobalAnisotropicFilteringLimitsv: __Z64Register_UnityEngine_Texture_SetGlobalAnisotropicFilteringLimitsv, __ZN21ArchiveStorageCreator10StoreChunkEv: __ZN21ArchiveStorageCreator10StoreChunkEv, _jinit_color_converter: _jinit_color_converter, __ZNK5physx2Sc5Scene34getClothInterCollisionNbIterationsEv: __ZNK5physx2Sc5Scene34getClothInterCollisionNbIterationsEv, __ZNK7Texture20GetTextureLayerCountEv: __ZNK7Texture20GetTextureLayerCountEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI12TreeInstanceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI12TreeInstanceNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd11printStringEPKc: __ZN5physx6shdfnd11printStringEPKc, __ZN18AudioLowPassFilter6UpdateEv: __ZN18AudioLowPassFilter6UpdateEv, __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc: __ZN5physx2Sn9StrToImplINS_11PxTransformEE5strtoERS2_RPKc, __Z64ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsDeprecatedP12Il2CppObjectS0_P11Il2CppArray: __Z64ParticleSystemExtensionsImpl_CUSTOM_GetCollisionEventsDeprecatedP12Il2CppObjectS0_P11Il2CppArray, __ZN9JSONWrite8TransferI8GradientEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8GradientEEvRT_PKc17TransferMetaFlags, __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc: __ZN11UnityEngine15CloudWebService13WWWRestClient21ParseHTTPHeaderStringENSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEERNS0_16WWWRestHeaderMapERjPKc, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getSimulationFilterDataEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE23getSimulationFilterDataEv, __Z43AnimatorControllerPlayable_CUSTOM_GetBoolIDR9HPlayablei: __Z43AnimatorControllerPlayable_CUSTOM_GetBoolIDR9HPlayablei, __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE: __ZN5physx2Sc21ArticulationJointCore13setParentPoseERKNS_11PxTransformE, __ZN15AnimationBinder18CalculateTargetPtrEiP6ObjectPKcPPvPi: __ZN15AnimationBinder18CalculateTargetPtrEiP6ObjectPKcPPvPi, __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXMultiplierv: __Z70Register_UnityEngine_ParticleSystem_NoiseModule_SetStrengthXMultiplierv, __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_get_limitsv: __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_get_limitsv, __ZN14PhysicsManagerD2Ev: __ZN14PhysicsManagerD2Ev, __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb: __ZN19ShaderPropertySheet17UpdateTextureInfoEiRKN9ShaderLab16FastPropertyNameEP7Textureb, __ZN5physx18RepXSerializerImplINS_7PxShapeEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_7PxShapeEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN24ConvexVsHeightfieldSweep7onEventEjPj: __ZN24ConvexVsHeightfieldSweep7onEventEjPj, __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE: __ZN5physx16MatrixNNLUSolver11decomposeLUERKNS_8MatrixNNE, __ZNK7Texture11GetGPUWidthEv: __ZNK7Texture11GetGPUWidthEv, __ZNK7Joint2D16GetReactionForceEf: __ZNK7Joint2D16GetReactionForceEf, __ZZN8VRModuleC1EvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv: __ZZN8VRModuleC1EvEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv, __ZN5physx7NpScene9setLimitsERKNS_13PxSceneLimitsE: __ZN5physx7NpScene9setLimitsERKNS_13PxSceneLimitsE, __ZN24GenerateTypeTreeTransfer8TransferIN9ShaderLab19SerializedSubShaderEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIN9ShaderLab19SerializedSubShaderEEEvRT_PKc17TransferMetaFlags, __Z27getNbPxPhysics_ClothFabricsPKN5physx9PxPhysicsE: __Z27getNbPxPhysics_ClothFabricsPKN5physx9PxPhysicsE, __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI17TexFormatRGBFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z48Register_UnityEngine_Application_get_productNamev: __Z48Register_UnityEngine_Application_get_productNamev, __Z43PhysicsMaterial2D_Set_Custom_PropBouncinessP12Il2CppObjectf: __Z43PhysicsMaterial2D_Set_Custom_PropBouncinessP12Il2CppObjectf, __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatABGR8888EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB444417TexFormatABGR8888EEvPKNS_9InnerInfoE, __Z25ScriptingStringToPropertyR11ICallString: __Z25ScriptingStringToPropertyR11ICallString, __ZN5physx6shdfnd10Foundation19AlignCheckAllocator10deallocateEPv: __ZN5physx6shdfnd10Foundation19AlignCheckAllocator10deallocateEPv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj631ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z29StdTemplateConversionFunctionIthEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIthEbPvR14SafeBinaryRead, __ZN9UdpSocketC2Ei: __ZN9UdpSocketC2Ei, __ZThn32_N12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N12MeshRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z26CaptureScreenshotImmediateNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiiii: __Z26CaptureScreenshotImmediateNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiiii, __Z48Register_UnityEngine_Material_SetMatrixArrayImplv: __Z48Register_UnityEngine_Material_SetMatrixArrayImplv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE22clearMotionConstraintsEv, __ZN24b2PositionSolverManifold10InitializeEP27b2ContactPositionConstraintRK11b2TransformS4_i: __ZN24b2PositionSolverManifold10InitializeEP27b2ContactPositionConstraintRK11b2TransformS4_i, _imaxdiv: _imaxdiv, _ynf: _ynf, __ZN13BoxCollider2DD2Ev: __ZN13BoxCollider2DD2Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE9__grow_byEjjjjjj, __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPhjRKNS0_8RigidSimES5_jjj: __ZN5physx2Sc20ContactStreamManager28fillInContactReportExtraDataEPhjRKNS0_8RigidSimES5_jjj, __Z19SimpleStringToFloatPKcPi: __Z19SimpleStringToFloatPKcPi, __ZN9HumanBoneC2Ev: __ZN9HumanBoneC2Ev, __Z10DecodeRGBMiiPhi13TextureFormat10RGBMRanges: __Z10DecodeRGBMiiPhi13TextureFormat10RGBMRanges, __ZN11UnityEngine15PlatformWrapper17GetPlayerPrefsIntERK8UnityStri: __ZN11UnityEngine15PlatformWrapper17GetPlayerPrefsIntERK8UnityStri, __ZN5Light12SetLightTypeE9LightType: __ZN5Light12SetLightTypeE9LightType, __ZL12InvokeMethodI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI24GenerateTypeTreeTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN20OcclusionCullingData23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z36AnimationCurve_Get_Custom_PropLengthP12Il2CppObject: __Z36AnimationCurve_Get_Custom_PropLengthP12Il2CppObject, __Z42GUIStyle_CUSTOM_INTERNAL_get_contentOffsetP12Il2CppObjectP13Vector2fIcall: __Z42GUIStyle_CUSTOM_INTERNAL_get_contentOffsetP12Il2CppObjectP13Vector2fIcall, __Z65Register_UnityEngine_Networking_UnityWebRequest_set_redirectLimitv: __Z65Register_UnityEngine_Networking_UnityWebRequest_set_redirectLimitv, __ZN12CubemapArrayD0Ev: __ZN12CubemapArrayD0Ev, __ZNK13b2PulleyJoint10GetLengthBEv: __ZNK13b2PulleyJoint10GetLengthBEv, __ZN8Material21CopySettingsFromOtherERKS_: __ZN8Material21CopySettingsFromOtherERKS_, __ZNK6Camera26CalculateCullingParametersER17CullingParameters: __ZNK6Camera26CalculateCullingParametersER17CullingParameters, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __ZN20TextRenderingPrivate8FontImpl5ResetEv: __ZN20TextRenderingPrivate8FontImpl5ResetEv, __ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu17contactConvexMeshERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, _ft_smooth_render_lcd_v: _ft_smooth_render_lcd_v, __ZN5Unity5Cloth21SetRandomAccelerationERK8Vector3f: __ZN5Unity5Cloth21SetRandomAccelerationERK8Vector3f, __ZN5Umbra10TomeLoader4loadERNS_11InputStreamEPNS_9AllocatorE: __ZN5Umbra10TomeLoader4loadERNS_11InputStreamEPNS_9AllocatorE, __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv: __ZN5physx2Sc7Element33ElementInteractionReverseIterator7getNextEv, __ZN13AvatarBuilder11BuildAvatarER6AvatarRK10GameObjectRK16HumanDescriptionNS_7OptionsE: __ZN13AvatarBuilder11BuildAvatarER6AvatarRK10GameObjectRK16HumanDescriptionNS_7OptionsE, __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE: __ZN5physx2Sc5Actor21unregisterInteractionEPNS0_11InteractionE, __ZN10MeshFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10MeshFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN21UnityAnalyticsManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN21UnityAnalyticsManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN6Object8TransferI14SafeBinaryReadEEvRT_: __ZN6Object8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__26localeC2Ev: __ZNSt3__26localeC2Ev, _ispunct_l: _ispunct_l, __ZN13SparseTexture17UploadToGfxDeviceEv: __ZN13SparseTexture17UploadToGfxDeviceEv, __ZN5physx19PxsSimObjectFactory18createArticulationEv: __ZN5physx19PxsSimObjectFactory18createArticulationEv, __ZN18ScreenManagerWebGL6UpdateEv: __ZN18ScreenManagerWebGL6UpdateEv, __Z53Register_UnityEngine_Light_get_shadowCustomResolutionv: __Z53Register_UnityEngine_Light_get_shadowCustomResolutionv, __ZN9dtNavMesh19getNeighbourTilesAtEiiiPP10dtMeshTilei: __ZN9dtNavMesh19getNeighbourTilesAtEiiiPP10dtMeshTilei, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj623ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj623ES3_KffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z55QualitySettings_CUSTOM_INTERNAL_get_shadowCascade4SplitP8Vector3f: __Z55QualitySettings_CUSTOM_INTERNAL_get_shadowCascade4SplitP8Vector3f, __Z50ParticleSystemRenderer_Set_Custom_PropSortingFudgeP12Il2CppObjectf: __Z50ParticleSystemRenderer_Set_Custom_PropSortingFudgeP12Il2CppObjectf, __ZN18ProceduralMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18ProceduralMaterial23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN30ForwardShaderRenderLoopScratch15ThreadedCleanupEv: __ZN30ForwardShaderRenderLoopScratch15ThreadedCleanupEv, __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetRandomizedP12Il2CppObjecth: __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetRandomizedP12Il2CppObjecth, __Z45PhysicMaterial_Get_Custom_PropFrictionCombineP12Il2CppObject: __Z45PhysicMaterial_Get_Custom_PropFrictionCombineP12Il2CppObject, __Z31GUIText_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z31GUIText_Set_Custom_PropMaterialP12Il2CppObjectS0_, _pthread_mutex_unlock: _pthread_mutex_unlock, __ZNK15b2RevoluteJoint14IsMotorEnabledEv: __ZNK15b2RevoluteJoint14IsMotorEnabledEv, __Z43TransformVerticesStridedSeparatePointersREFRPhRK10Matrix4x4fj14StrideIteratorI8Vector3fES6_S4_I11ColorRGBA32ES4_I8Vector2fESA_S4_I8Vector4fE: __Z43TransformVerticesStridedSeparatePointersREFRPhRK10Matrix4x4fj14StrideIteratorI8Vector3fES6_S4_I11ColorRGBA32ES4_I8Vector2fESA_S4_I8Vector4fE, __Z59Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimev: __Z59Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimev, __Z49Register_UnityEngine_AssetBundle_GetAllScenePathsv: __Z49Register_UnityEngine_AssetBundle_GetAllScenePathsv, __Z16FromToQuaternionRK8Vector3fS1_: __Z16FromToQuaternionRK8Vector3fS1_, __ZN4FMOD6System17setOutputByPluginEj: __ZN4FMOD6System17setOutputByPluginEj, __ZN5physx15PxErrorCallbackD2Ev: __ZN5physx15PxErrorCallbackD2Ev, _IsMacResource: _IsMacResource, __ZN15StaticBatchInfo8TransferI14SafeBinaryReadEEvRT_: __ZN15StaticBatchInfo8TransferI14SafeBinaryReadEEvRT_, _cff_driver_class_pic_free: _cff_driver_class_pic_free, __ZN22AnimationMixerPlayable11DerivesFromEP11Il2CppClass: __ZN22AnimationMixerPlayable11DerivesFromEP11Il2CppClass, __ZN24GenerateTypeTreeTransfer8TransferINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__23mapI4PPtrI6ShaderEN23ShaderVariantCollection10ShaderInfoENS1_4lessIS5_EENS1_9allocatorINS1_4pairIKS5_S7_EEEEEEEEvRT_PKc17TransferMetaFlags, __ZL20InternalErrorConsolePKcz: __ZL20InternalErrorConsolePKcz, _tt_cmap14_get_def_chars: _tt_cmap14_get_def_chars, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_SetXv, __ZN20TextRenderingPrivate8FontImpl12HasCharacterEjij: __ZN20TextRenderingPrivate8FontImpl12HasCharacterEjij, __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxSphericalJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7mecanim5human7GetAxesEPKNS0_5HumanEi: __ZN7mecanim5human7GetAxesEPKNS0_5HumanEi, _regexec: _regexec, __ZN13MonoBehaviourD2Ev: __ZN13MonoBehaviourD2Ev, __ZN5physx3Ext13DistanceJoint15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx3Ext13DistanceJoint15importExtraDataERNS_24PxDeserializationContextE, __Z55ParticleSystemExtensionsImpl_CUSTOM_SetTriggerParticlesP12Il2CppObjectiS0_ii: __Z55ParticleSystemExtensionsImpl_CUSTOM_SetTriggerParticlesP12Il2CppObjectiS0_ii, __ZN17BufferManagerGLES16PruneFreeBuffersEv: __ZN17BufferManagerGLES16PruneFreeBuffersEv, __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim9animation18ControllerConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z84Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_RectangleContainsScreenPointv: __Z84Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_RectangleContainsScreenPointv, __ZNK6Camera20GetWorldToClipMatrixEv: __ZNK6Camera20GetWorldToClipMatrixEv, __ZN13TrailRendererD2Ev: __ZN13TrailRendererD2Ev, __ZN5Light12SetIntensityEf: __ZN5Light12SetIntensityEf, __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE: __ZN15TerrainRenderer21RecursiveRenderMeshesER12QuadTreeNodeR9HeightmapRKNS_22QuadTreeNodeParametersE, __Z37Material_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_: __Z37Material_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_, __Z58Register_UnityEngine_ParticleSystem_TriggerModule_SetEnterv: __Z58Register_UnityEngine_ParticleSystem_TriggerModule_SetEnterv, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEce: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEce, __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv: __ZNK21ScriptingObjectOfTypeI9Texture2DEptEv, __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv: __ZNK2UI13RectTransform26CalculateRectInParentSpaceEv, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE13onOriginShiftERKNS_6PxVec3E, __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__210moneypunctIwLb0EE13do_neg_formatEv: __ZNKSt3__210moneypunctIwLb0EE13do_neg_formatEv, __Z31Event_Get_Custom_PropClickCountP12Il2CppObject: __Z31Event_Get_Custom_PropClickCountP12Il2CppObject, __ZN13SplatDatabase13UploadBasemapEv: __ZN13SplatDatabase13UploadBasemapEv, ___signbit: ___signbit, __ZN5physx8debugger14PvdMarshallingIafE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIafE12marshalBlockEPKhPhj, __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE: __ZN5physx14NpShapeManager26markAllSceneQueryForUpdateERNS_2Sq17SceneQueryManagerE, __ZN14PhysicMaterialC2E10MemLabelId18ObjectCreationMode: __ZN14PhysicMaterialC2E10MemLabelId18ObjectCreationMode, __Z52Register_UnityEngine_AnimationCurve_get_postWrapModev: __Z52Register_UnityEngine_AnimationCurve_get_postWrapModev, __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu16SupportLocalImplINS0_9TriangleVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __Z56Register_UnityEngine_AudioListener_GetSpectrumDataHelperv: __Z56Register_UnityEngine_AudioListener_GetSpectrumDataHelperv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc35ParticleElementRbElementInteractionEEEE15growAndPushBackERKS2_, __ZNK9GfxDevice19GetProjectionMatrixEv: __ZNK9GfxDevice19GetProjectionMatrixEv, __ZN5physx2Gu23intersectHeightFieldBoxERKNS0_15HeightFieldUtilERKNS0_3BoxE: __ZN5physx2Gu23intersectHeightFieldBoxERKNS0_15HeightFieldUtilERKNS0_3BoxE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN12ImageFilters20GetTargetAfterOpaqueEbb: __ZN12ImageFilters20GetTargetAfterOpaqueEbb, __Z18GetScriptMapperPtrv: __Z18GetScriptMapperPtrv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI28EnlightenRendererInformationLj8EEEEvRT_17TransferMetaFlags, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EEhEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE21getCentrifugalInertiaEv, __ZNK26AnimatorOverrideController27GetAnimationClipsToRegisterEv: __ZNK26AnimatorOverrideController27GetAnimationClipsToRegisterEv, __ZN5Umbra4Math3powENS_5FloatES1_: __ZN5Umbra4Math3powENS_5FloatES1_, __Z18Transfer_BlittableI8JSONReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN8Playable6CastToEP11Il2CppClass: __ZN8Playable6CastToEP11Il2CppClass, __ZN11UmbraModule15GetObjectUserIDEPKN5Umbra4TomeEi: __ZN11UmbraModule15GetObjectUserIDEPKN5Umbra4TomeEi, __Z61Register_UnityEngine_ParticleSystem_MainModule_GetStartSize3Dv: __Z61Register_UnityEngine_ParticleSystem_MainModule_GetStartSize3Dv, __Z29Transfer_Blittable_ArrayFieldI8JSONReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadyEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _ft_stroker_arcto: _ft_stroker_arcto, __ZN13MonoBehaviour20InvokeOnRenderObjectEv: __ZN13MonoBehaviour20InvokeOnRenderObjectEv, __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationXMultiplierP12Il2CppObject: __Z60ParticleSystem_MainModule_CUSTOM_GetStartRotationXMultiplierP12Il2CppObject, __ZNSt3__227__insertion_sort_incompleteIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRN14Raycast2DQuery31RaycastHitsByFractionComparitorEP12RaycastHit2DEEbT0_S6_T_, __ZN11AudioSource19SetSpatializerFloatEif: __ZN11AudioSource19SetSpatializerFloatEif, __ZNK13TranslateGLES4FuncE15CompareFunction: __ZNK13TranslateGLES4FuncE15CompareFunction, __ZNK5physx16PxSphericalJoint19getConcreteTypeNameEv: __ZNK5physx16PxSphericalJoint19getConcreteTypeNameEv, __Z16GetScreenManagerv: __Z16GetScreenManagerv, __Z48Register_UnityEngine_Renderer_get_sortingLayerIDv: __Z48Register_UnityEngine_Renderer_get_sortingLayerIDv, __ZNK14SerializedFile11IsAvailableEx: __ZNK14SerializedFile11IsAvailableEx, __ZN11CullResults30GetOrCreateSharedRendererSceneEv: __ZN11CullResults30GetOrCreateSharedRendererSceneEv, __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_13PxHeightFieldEE11getTypeNameEv, __ZNK5physx11PxAggregate8isKindOfEPKc: __ZNK5physx11PxAggregate8isKindOfEPKc, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK8GUIStyle10DoCalcSizeER10GUIContentRK8Vector2f: __ZNK8GUIStyle10DoCalcSizeER10GUIContentRK8Vector2f, __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_: __ZN13dynamic_arrayI12RaycastHit2DLj4EE9push_backERKS0_, __ZL31InitializeIMGUIScriptingClassesv: __ZL31InitializeIMGUIScriptingClassesv, __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcx: __ZNKSt3__27num_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEE3putES4_RNS_8ios_baseEcx, __Z49Register_UnityEngine_Rigidbody2D_IsTouchingLayersv: __Z49Register_UnityEngine_Rigidbody2D_IsTouchingLayersv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleDrive4WEE8pushNameEPKc, __ZN9b2Fixture9SetSensorEb: __ZN9b2Fixture9SetSensorEb, __ZN5physx29PxClothSimpleTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE: __ZN5physx29PxClothSimpleTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE, __ZN8VRDevice14SetRenderScaleEf: __ZN8VRDevice14SetRenderScaleEf, __ZN12MeshRendererC2E10MemLabelId18ObjectCreationMode: __ZN12MeshRendererC2E10MemLabelId18ObjectCreationMode, __Z23ShutdownVehiclesManagerv: __Z23ShutdownVehiclesManagerv, __ZN9Texture3D17MainThreadCleanupEv: __ZN9Texture3D17MainThreadCleanupEv, __ZN18ProceduralMaterial13AwakeFromLoadE17AwakeFromLoadMode: __ZN18ProceduralMaterial13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS9_6FloatVERKNS9_5Vec3VESI_RSD_RSG_SK_f, __ZN19BaseConnectSettingsC2Ev: __ZN19BaseConnectSettingsC2Ev, __Z61Register_UnityEngine_Physics2D_INTERNAL_set_colliderAABBColorv: __Z61Register_UnityEngine_Physics2D_INTERNAL_set_colliderAABBColorv, __Z64Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayv: __Z64Register_UnityEngine_Rendering_CommandBuffer_SetGlobalFloatArrayv, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseValueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN11dtNodeQueueC2Ei: __ZN11dtNodeQueueC2Ei, __ZL34RegisterModuleICalls_JSONSerializev: __ZL34RegisterModuleICalls_JSONSerializev, __ZN19BaseConnectSettings5ResetEv: __ZN19BaseConnectSettings5ResetEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z52Register_UnityEngine_Event_Internal_GetMousePositionv: __Z52Register_UnityEngine_Event_Internal_GetMousePositionv, __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z68ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject, __ZN13InitialModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState: __ZN13InitialModule13AwakeFromLoadEP14ParticleSystemRK27ParticleSystemReadOnlyState, __ZN5physx2Gu18sweepSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleERKNS_6PxVec3EfRfRS7_SB_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu18sweepSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleERKNS_6PxVec3EfRfRS7_SB_NS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZN24CompressedAnimationCurveC2ERKS_: __ZN24CompressedAnimationCurveC2ERKS_, __Z44Time_Set_Custom_PropMaximumParticleDeltaTimef: __Z44Time_Set_Custom_PropMaximumParticleDeltaTimef, __ZN8LODGroup12CleanupClassEv: __ZN8LODGroup12CleanupClassEv, __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER14SafeBinaryRead: __ZN20TextRenderingPrivate8TextMesh23VirtualRedirectTransferER14SafeBinaryRead, __ZNK26PlayerSettingsSplashScreen29GetSplashScreenOverlayOpacityEv: __ZNK26PlayerSettingsSplashScreen29GetSplashScreenOverlayOpacityEv, __ZN14UnityWebStreamC2EPKc7Hash128jb: __ZN14UnityWebStreamC2EPKc7Hash128jb, __ZNK5physx2Sc9ClothCore14getWorldBoundsEv: __ZNK5physx2Sc9ClothCore14getWorldBoundsEv, __Z39AvatarBuilder_CUSTOM_BuildGenericAvatarP12Il2CppObjectP12Il2CppString: __Z39AvatarBuilder_CUSTOM_BuildGenericAvatarP12Il2CppObjectP12Il2CppString, __ZN15ConstantForce2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15ConstantForce2D23VirtualRedirectTransferER17RemapPPtrTransfer, __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesXv: __Z76Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetNumTilesXv, __ZNK5physx2Sc8BodyCore17getInverseInertiaEv: __ZNK5physx2Sc8BodyCore17getInverseInertiaEv, __ZNK26PlayerSettingsSplashScreen39GetSplashScreenBackgroundPortraitAspectEv: __ZNK26PlayerSettingsSplashScreen39GetSplashScreenBackgroundPortraitAspectEv, __ZN13AvatarBuilder17GetRootMotionNodeERK8UnityStrRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEE: __ZN13AvatarBuilder17GetRootMotionNodeERK8UnityStrRKNSt3__26vectorINS_14NamedTransformENS3_9allocatorIS5_EEEE, __ZNSt3__210to_wstringEf: __ZNSt3__210to_wstringEf, __ZNK5physx2Sq16BucketPrunerCore7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE: __ZNK5physx2Sq16BucketPrunerCore7raycastERKNS_6PxVec3ES4_RfRNS0_14PrunerCallbackE, _FT_Init_Class_sfnt_service_glyph_dict: _FT_Init_Class_sfnt_service_glyph_dict, __Z29Animator_CUSTOM_GetBehavioursP12Il2CppObjectS0_: __Z29Animator_CUSTOM_GetBehavioursP12Il2CppObjectS0_, __ZN9GfxDevice23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_: __ZN9GfxDevice23ResolveDepthIntoTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_, __ZN5physx10NpMaterialD0Ev: __ZN5physx10NpMaterialD0Ev, __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E5Int64Ex: __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E5Int64Ex, __Z50Register_UnityEngine_AudioReverbZone_get_decayTimev: __Z50Register_UnityEngine_AudioReverbZone_get_decayTimev, __Z58DownloadHandlerScript_CUSTOM_InternalSetPreallocatedBufferP12Il2CppObjectP11Il2CppArray: __Z58DownloadHandlerScript_CUSTOM_InternalSetPreallocatedBufferP12Il2CppObjectP11Il2CppArray, _hstrerror: _hstrerror, __Z52Register_UnityEngine_Terrain_set_drawTreesAndFoliagev: __Z52Register_UnityEngine_Terrain_set_drawTreesAndFoliagev, __ZN16MeshVertexFormatC2ERKS_: __ZN16MeshVertexFormatC2ERKS_, _UNITY_FT_Init_Class_cff_service_ps_info: _UNITY_FT_Init_Class_cff_service_ps_info, __Z17DebugStringToFileRK21DebugStringToFileData: __Z17DebugStringToFileRK21DebugStringToFileData, __ZN8Collider32RigidbodyMassDistributionChangedEv: __ZN8Collider32RigidbodyMassDistributionChangedEv, __Z45CharacterController_Get_Custom_PropStepOffsetP12Il2CppObject: __Z45CharacterController_Get_Custom_PropStepOffsetP12Il2CppObject, __ZN10GUIManager16ResetCursorFlashEi: __ZN10GUIManager16ResetCursorFlashEi, __ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor: __ZN11UnityEngine15CloudWebService16SessionContainer17CreateAndOpenFileERK8UnityStrS4_R12FileAccessor, __ZNK18AnimatorController26GetTypeInfoVirtualInternalEv: __ZNK18AnimatorController26GetTypeInfoVirtualInternalEv, __ZN5Umbra15CameraTransform17getUserClipPlanesEPNS_7Vector4ERi: __ZN5Umbra15CameraTransform17getUserClipPlanesEPNS_7Vector4ERi, __ZZ23InitPlayerLoopCallbacksvEN47PreLateUpdateScriptRunBehaviourLateUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN47PreLateUpdateScriptRunBehaviourLateUpdatestruct7ForwardEv, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEEEEjT_j, __ZN5physx3Ext13RevoluteJointD2Ev: __ZN5physx3Ext13RevoluteJointD2Ev, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS3_RS5_EE, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIbEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIbEEEvRT_PKc17TransferMetaFlags, _jpeg_finish_decompress: _jpeg_finish_decompress, __Z51Register_UnityEngine_AndroidJNI_SetByteArrayElementv: __Z51Register_UnityEngine_AndroidJNI_SetByteArrayElementv, __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth: __Z64ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetSeparateAxesP12Il2CppObjecth, __ZN11NoiseModule6UpdateERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjjfRKN4math7_float4E: __ZN11NoiseModule6UpdateERK27ParticleSystemReadOnlyStateR23ParticleSystemParticlesjjfRKN4math7_float4E, __ZN13AnimationClipD2Ev: __ZN13AnimationClipD2Ev, __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Sprite23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, _tt_get_advances: _tt_get_advances, __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_28PxvParticleShapesUpdateInputENS0_13TempAllocatorEE6resizeEjRKS2_, __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv: __ZN12AdsIdHandler23InvokeAllAdsIdListenersEv, __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN20OcclusionCullingData23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN20OcclusionCullingData23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK6Avatar12GetLimitSignEi: __ZNK6Avatar12GetLimitSignEi, __Z41Animator_CUSTOM_INTERNAL_get_rootRotationP12Il2CppObjectP11Quaternionf: __Z41Animator_CUSTOM_INTERNAL_get_rootRotationP12Il2CppObjectP11Quaternionf, __ZN11NoiseModule16CheckConsistencyEv: __ZN11NoiseModule16CheckConsistencyEv, __ZN9Heightmap14RecreateShapesEv: __ZN9Heightmap14RecreateShapesEv, __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_: __ZN18GfxFramebufferGLES19ReadbackResolveMSAAEP17RenderSurfaceGLESS1_, __Z13RegisterClassI8LODGroupEvv: __Z13RegisterClassI8LODGroupEvv, __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI18StreamedBinaryReadILb1EE27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN5physx3Ext21InertiaTensorComputerC2ERKNS_7PxMat33ERKNS_6PxVec3Ef: __ZN5physx3Ext21InertiaTensorComputerC2ERKNS_7PxMat33ERKNS_6PxVec3Ef, __ZN13BaseAllocator16FrameMaintenanceEb: __ZN13BaseAllocator16FrameMaintenanceEb, __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR11NodeZSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetMethodIDv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetMethodIDv, __ZN7mecanim13crc32_table_tILj79764919EE10init_tableEv: __ZN7mecanim13crc32_table_tILj79764919EE10init_tableEv, __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIffEEPfEEjT0_S5_S5_S5_T_, __Z32RectOffset_Set_Custom_PropBottomP12Il2CppObjecti: __Z32RectOffset_Set_Custom_PropBottomP12Il2CppObjecti, __ZNK11NamedObject7GetNameEv: __ZNK11NamedObject7GetNameEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj409ENS0_26PxPvdRangePropertyAccessorILj409ENS_7PxJointEPNS_12PxRigidActorEEEEEvjRKT0_, __ZNK10GameObject7GetNameEv: __ZNK10GameObject7GetNameEv, __Z49ParticleSystem_LightsModule_CUSTOM_GetLightPrefabP12Il2CppObject: __Z49ParticleSystem_LightsModule_CUSTOM_GetLightPrefabP12Il2CppObject, __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToCharArrayv: __Z57Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToCharArrayv, __ZN5physx7NpSceneD0Ev: __ZN5physx7NpSceneD0Ev, _fwscanf: _fwscanf, __ZN10GUIManager17CleanupGUIManagerEv: __ZN10GUIManager17CleanupGUIManagerEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5emptyEv, __ZN13AnimationClip12CleanupClassEv: __ZN13AnimationClip12CleanupClassEv, __Z40TerrainData_CUSTOM_GetInterpolatedHeightP12Il2CppObjectff: __Z40TerrainData_CUSTOM_GetInterpolatedHeightP12Il2CppObjectff, __ZN5physx22PxVehicleWheelsSimDataaSERKS0_: __ZN5physx22PxVehicleWheelsSimDataaSERKS0_, __ZN5physx13GuMeshFactory15addTriangleMeshEPNS_2Gu12TriangleMeshEb: __ZN5physx13GuMeshFactory15addTriangleMeshEPNS_2Gu12TriangleMeshEb, __Z42Register_UnityEngine_Animator_GetLayerNamev: __Z42Register_UnityEngine_Animator_GetLayerNamev, __ZNK5physx3Ext7D6Joint16getDriveVelocityERNS_6PxVec3ES3_: __ZNK5physx3Ext7D6Joint16getDriveVelocityERNS_6PxVec3ES3_, __ZN5Umbra9Matrix3x35clearEv: __ZN5Umbra9Matrix3x35clearEv, __Z30ExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray: __Z30ExtractMeshComponentFromScriptRK4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArray, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj459ES3_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj459ES3_NS_7PxFlagsINS_20PxPrismaticJointFlag4EnumEtEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z17Projector_CleanupR15RenderNodeQueuej: __Z17Projector_CleanupR15RenderNodeQueuej, __Z25GetLocalNotificationCountv: __Z25GetLocalNotificationCountv, __ZN12SocketStream15WouldBlockErrorEv: __ZN12SocketStream15WouldBlockErrorEv, __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetEnabledv: __Z73Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetEnabledv, __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapYMultiplierP12Il2CppObject: __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapYMultiplierP12Il2CppObject, __Z49Register_UnityEngine_Cloth_get_worldVelocityScalev: __Z49Register_UnityEngine_Cloth_get_worldVelocityScalev, __ZNK18ScreenManagerWebGL13GetShowCursorEv: __ZNK18ScreenManagerWebGL13GetShowCursorEv, __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_9TriangleVENS0_17ShrunkConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN5Umbra5FloatmLEf: __ZN5Umbra5FloatmLEf, _UNITY_png_realloc_array: _UNITY_png_realloc_array, __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye: __ZNK19VREyeTextureManager21GetUnityRenderTextureE15StereoscopicEye, _tre_neg_char_classes_match: _tre_neg_char_classes_match, __ZN9Transform18GetTransformAccessEv: __ZN9Transform18GetTransformAccessEv, __Z53Register_UnityEngine_Physics2D_get_velocityIterationsv: __Z53Register_UnityEngine_Physics2D_get_velocityIterationsv, __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6gcountEv: __ZNKSt3__213basic_istreamIcNS_11char_traitsIcEEE6gcountEv, __ZN23AnimationOffsetPlayableC2E18DirectorPlayerType: __ZN23AnimationOffsetPlayableC2E18DirectorPlayerType, __Z56Register_UnityEngine_RenderSettings_get_customReflectionv: __Z56Register_UnityEngine_RenderSettings_get_customReflectionv, __Z17SetupVertexLightsRKNSt3__26vectorIP5LightNS_9allocatorIS2_EEEER17ShaderPassContext: __Z17SetupVertexLightsRKNSt3__26vectorIP5LightNS_9allocatorIS2_EEEER17ShaderPassContext, __ZN29SerializeTraitsForStringTypesI8UnityStrE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_: __ZN29SerializeTraitsForStringTypesI8UnityStrE8TransferI24GenerateTypeTreeTransferEEvRS0_RT_, __ZN11UnityEngine15CloudWebService17CloudJobScheduler5CloseEv: __ZN11UnityEngine15CloudWebService17CloudJobScheduler5CloseEv, __ZN13TargetJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13TargetJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z53ParticleSystem_LightsModule_CUSTOM_GetRangeMultiplierP12Il2CppObject: __Z53ParticleSystem_LightsModule_CUSTOM_GetRangeMultiplierP12Il2CppObject, __Z60Register_UnityEngine_RelativeJoint2D_set_autoConfigureOffsetv: __Z60Register_UnityEngine_RelativeJoint2D_set_autoConfigureOffsetv, __ZN8GUIStyleaSERKS_: __ZN8GUIStyleaSERKS_, __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12LineRenderer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii: __ZN23ParticleSystemParticles16CopyFromArrayAOSEPK22ParticleSystemParticleii, __ZN12_GLOBAL__N_117FixedJointProjectEPKvRN5physx11PxTransformES4_b: __ZN12_GLOBAL__N_117FixedJointProjectEPKvRN5physx11PxTransformES4_b, __ZNSt3__28numpunctIwED2Ev: __ZNSt3__28numpunctIwED2Ev, __Z46Input_CUSTOM_INTERNAL_get_compositionCursorPosP13Vector2fIcall: __Z46Input_CUSTOM_INTERNAL_get_compositionCursorPosP13Vector2fIcall, __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_: __Z21TransferBlobSerializeIN7mecanim9animation18ClipMuscleConstantE14SafeBinaryReadEvRPT_PKcRjS8_RT0_, __ZN5physx3Cct17CapsuleControllerD2Ev: __ZN5physx3Cct17CapsuleControllerD2Ev, __ZN7mecanim9animation21MotionOutputBlendNodeEPNS0_12MotionOutputES2_fbbRKNS_6bitsetILj66EEE: __ZN7mecanim9animation21MotionOutputBlendNodeEPNS0_12MotionOutputES2_fbbRKNS_6bitsetILj66EEE, __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_: __ZNSt3__27__sort3IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_T_, __ZN9UdpSocketC2Ev: __ZN9UdpSocketC2Ev, __ZN12_GLOBAL__N_119createParticleFluidEjb: __ZN12_GLOBAL__N_119createParticleFluidEjb, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEED2Ev: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi64EEENS0_19ReflectionAllocatorIS4_EEED2Ev, __ZN10Matrix4x4f19SetPerspectiveCotanEfff: __ZN10Matrix4x4f19SetPerspectiveCotanEfff, __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15AnchoredJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z42ContactPoint_CUSTOM_ColliderFromInstanceIdi: __Z42ContactPoint_CUSTOM_ColliderFromInstanceIdi, __ZNK5physx9NpPhysics15getHeightFieldsEPPNS_13PxHeightFieldEjj: __ZNK5physx9NpPhysics15getHeightFieldsEPPNS_13PxHeightFieldEjj, __ZN5physx14PxLightCpuTask7releaseEv: __ZN5physx14PxLightCpuTask7releaseEv, __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_13NpRigidStaticENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZL39WriteQueueForTransferFunctionIntoCache2I9JSONWriteEvP11Il2CppClassR23CachedSerializationDataRb: __ZL39WriteQueueForTransferFunctionIntoCache2I9JSONWriteEvP11Il2CppClassR23CachedSerializationDataRb, _jpeg_read_raw_data: _jpeg_read_raw_data, _tre_add_tag_left: _tre_add_tag_left, __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_18PxVehicleDriveTankEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZN5physx2Sc8BodyCore24setCCDAdvanceCoefficientEf: __ZN5physx2Sc8BodyCore24setCCDAdvanceCoefficientEf, __ZNK15b2RevoluteJoint10GetAnchorAEv: __ZNK15b2RevoluteJoint10GetAnchorAEv, __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet: __ZN23ShaderVariantCollection13RemoveVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet, __ZN5physx23PxsBroadPhaseContextSap11batchRemoveEv: __ZN5physx23PxsBroadPhaseContextSap11batchRemoveEv, __ZN13ComputeShader21DispatchComputeShaderEj15ComputeBufferIDj: __ZN13ComputeShader21DispatchComputeShaderEj15ComputeBufferIDj, __Z60Register_UnityEngine_Profiling_Profiler_GetTempAllocatorSizev: __Z60Register_UnityEngine_Profiling_Profiler_GetTempAllocatorSizev, __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_: __ZNSt3__27__sort3IRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEjT0_SB_SB_T_, __Z37AudioEchoFilter_Set_Custom_PropDryMixP12Il2CppObjectf: __Z37AudioEchoFilter_Set_Custom_PropDryMixP12Il2CppObjectf, __ZN5Umbra10PathFinder10outputPathERNS_7ImpPathEfRKNS_7Vector3ES5_: __ZN5Umbra10PathFinder10outputPathERNS_7ImpPathEfRKNS_7Vector3ES5_, __Z34GUIUtility_CUSTOM_Internal_ExitGUIv: __Z34GUIUtility_CUSTOM_Internal_ExitGUIv, __Z48Register_UnityEngine_AI_NavMeshAgent_GetAreaCostv: __Z48Register_UnityEngine_AI_NavMeshAgent_GetAreaCostv, __ZN5physx14NpRigidDynamic9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb: __ZN5physx14NpRigidDynamic9addTorqueERKNS_6PxVec3ENS_11PxForceMode4EnumEb, __Z46AnimatorControllerPlayable_CUSTOM_GetIntegerIDR9HPlayablei: __Z46AnimatorControllerPlayable_CUSTOM_GetIntegerIDR9HPlayablei, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj156ES2_RKNS_19PxClothTetherConfigES6_EEKNS_32PxClothTetherConfigGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE15complexPropertyINS_22PxRepXPropertyAccessorILj156ES2_RKNS_19PxClothTetherConfigES6_EEKNS_32PxClothTetherConfigGeneratedInfoEEEvPjRKT_RT0_, __Z21setPxJoint_BreakForcePN5physx7PxJointEff: __Z21setPxJoint_BreakForcePN5physx7PxJointEff, __ZN23ParticleSystemParticles13SetUsesTrailsEv: __ZN23ParticleSystemParticles13SetUsesTrailsEv, __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb1EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb1EEEvP12NoiseJobData, __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue8TransferI8JSONReadEEvRT_: __ZN11UnityEngine7Connect13ConnectConfig11ConfigValue8TransferI8JSONReadEEvRT_, __ZN15AudioMixerGroup8TransferI17RemapPPtrTransferEEvRT_: __ZN15AudioMixerGroup8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx8debugger14PvdMarshallingIixE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIixE12marshalBlockEPKhPhj, __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI18AudioMixerSnapshotE8TransferI14SafeBinaryReadEEvRT_, __Z34Material_CUSTOM_GetVectorArrayImplP12Il2CppObjecti: __Z34Material_CUSTOM_GetVectorArrayImplP12Il2CppObjecti, __ZN13b2DynamicTree7BalanceEi: __ZN13b2DynamicTree7BalanceEi, __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEE18__construct_at_endEj: __ZNSt3__214__split_bufferIN12TreeDatabase9PrototypeERNS_9allocatorIS2_EEE18__construct_at_endEj, __ZN6prcoreL31inner_stretch_argb4444_bilinearEPKNS_9InnerInfoE: __ZN6prcoreL31inner_stretch_argb4444_bilinearEPKNS_9InnerInfoE, __ZNK5physx16PxVehicleDriveNW8isKindOfEPKc: __ZNK5physx16PxVehicleDriveNW8isKindOfEPKc, __ZN6Sprite7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Sprite7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sc9ActorCoreD2Ev: __ZN5physx2Sc9ActorCoreD2Ev, __Z46Register_UnityEngine_Joint2D_get_connectedBodyv: __Z46Register_UnityEngine_Joint2D_get_connectedBodyv, __Z46Register_UnityEngine_Renderer_SetPropertyBlockv: __Z46Register_UnityEngine_Renderer_SetPropertyBlockv, __Z37setPxRevoluteJoint_RevoluteJointFlagsPN5physx15PxRevoluteJointENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE: __Z37setPxRevoluteJoint_RevoluteJointFlagsPN5physx15PxRevoluteJointENS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEE, __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14PhysicMaterial23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z24IntersectAABBFrustumFullRK4AABBPK5Plane: __Z24IntersectAABBFrustumFullRK4AABBPK5Plane, __ZN7Hash1285ResetEv: __ZN7Hash1285ResetEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags, __ZN10TagManager28GetSortingLayerValueFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZN10TagManager28GetSortingLayerValueFromNameERKN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __ZN12MeshCollider17MainThreadCleanupEv: __ZN12MeshCollider17MainThreadCleanupEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj72ENS_22PxRepXPropertyAccessorILj72ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj72ENS_22PxRepXPropertyAccessorILj72ES4_ffEEEEvRKT0_, __ZN5physx28PxRigidStaticGeneratedValuesC2EPKNS_13PxRigidStaticE: __ZN5physx28PxRigidStaticGeneratedValuesC2EPKNS_13PxRigidStaticE, __Z22SampleReflectionProbesRK23ReflectionProbesContextRK4AABBji20ReflectionProbeUsageR16ReflectionSample: __Z22SampleReflectionProbesRK23ReflectionProbesContextRK4AABBji20ReflectionProbeUsageR16ReflectionSample, __ZNK5physx12NpBatchQuery7getDescEv: __ZNK5physx12NpBatchQuery7getDescEv, _UNITY_FT_Select_Size: _UNITY_FT_Select_Size, __Z24RegisterBuiltinVRDevicesv: __Z24RegisterBuiltinVRDevicesv, __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv: __ZN24MaterialDisplayListCache16CachedShaderPass10ReleaseAllEv, __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE: __ZL21BlitScaleStbImageImplRK14ImageReferenceRS_NS_10ColorSpaceE, __Z36RenderTexture_Set_Custom_PropEnabledh: __Z36RenderTexture_Set_Custom_PropEnabledh, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj401ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_29PxClothMotionConstraintConfigEEEEclILj401ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN14DirectorPlayerD2Ev: __ZN14DirectorPlayerD2Ev, __ZN13TranslateGLES17InitTextureTargetERK12GraphicsCaps: __ZN13TranslateGLES17InitTextureTargetERK12GraphicsCaps, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj260ENS_22PxRepXPropertyAccessorILj260ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxCapsuleGeometryEEEE14handleAccessorILj260ENS_22PxRepXPropertyAccessorILj260ES4_ffEEEEvRKT0_, __ZN13GfxDeviceGLES14SetTextureNameE9TextureIDPKc: __ZN13GfxDeviceGLES14SetTextureNameE9TextureIDPKc, __ZN18CrashReportHandler18HandleFlushReportsEPS_: __ZN18CrashReportHandler18HandleFlushReportsEPS_, __Z41SphereCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z41SphereCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient: __Z54ParticleSystem_ColorOverLifetimeModule_CUSTOM_SetColorP12Il2CppObjectR18MonoMinMaxGradient, __ZN4Mesh20GetCachedBonesBoundsEv: __ZN4Mesh20GetCachedBonesBoundsEv, __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z58ParticleSystem_RotationBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __ZNKSt3__217moneypunct_bynameIcLb0EE11do_groupingEv: __ZNKSt3__217moneypunct_bynameIcLb0EE11do_groupingEv, __ZN7mecanim9animation22EvaluateAvatarRetargetEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb: __ZN7mecanim9animation22EvaluateAvatarRetargetEPKNS0_14AvatarConstantEPKNS0_11AvatarInputEPNS0_12AvatarOutputEPNS0_12AvatarMemoryEPNS0_15AvatarWorkspaceEb, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE7getNameEv, __Z97Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoInternalv: __Z97Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetAnimatorClipInfoInternalv, __ZN5physx8debugger4comm11SetPickable9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm11SetPickable9serializeERNS1_15EventSerializerE, __Z51Camera_Get_Custom_PropClearStencilAfterLightingPassP12Il2CppObject: __Z51Camera_Get_Custom_PropClearStencilAfterLightingPassP12Il2CppObject, __ZN13AudioListener12AddToManagerEv: __ZN13AudioListener12AddToManagerEv, __ZN14VehiclesModule23ShutdownVehiclesManagerEv: __ZN14VehiclesModule23ShutdownVehiclesManagerEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE13getBreakForceERfS5_, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVERKNS0_18ConvexHullNoScaleVERKNS_6shdfnd3aos6FloatVERNS8_5Vec3VESD_SD_RS9_PhSF_Rhb, __Z35Camera_Get_Custom_PropTargetDisplayP12Il2CppObject: __Z35Camera_Get_Custom_PropTargetDisplayP12Il2CppObject, __Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags: __Z26BeginRenderQueueExtractionR15RenderNodeQueuePK16RendererCullDataRK13CullingOutputPK12LODDataArray15ExtractionFlags, __Z22IsSplashScreenFinishedv: __Z22IsSplashScreenFinishedv, __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue: __ZL12SetPrefValueRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERK9PrefValue, __ZNK5physx30PxTolerancesScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEEEEEjT_j: __ZNK5physx30PxTolerancesScaleGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxTolerancesScaleEEEEEEEjT_j, _unity_z_zcalloc: _unity_z_zcalloc, __ZN20TextRenderingPrivate8TextMesh15InitializeClassEv: __ZN20TextRenderingPrivate8TextMesh15InitializeClassEv, __ZN5physx8debugger4comm10EventGroupD0Ev: __ZN5physx8debugger4comm10EventGroupD0Ev, __Z11UpdateInputv: __Z11UpdateInputv, __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeIiP9ProjectorEENS_19__map_value_compareIiS4_NS_4lessIiEELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS4_IS6_EEE6assignIPS6_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS6_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, _UNITY_ft_synthesize_vertical_metrics: _UNITY_ft_synthesize_vertical_metrics, __ZNSt3__227__insertion_sort_incompleteIR11NodeXSorterP16HeightMeshBVNodeEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIR11NodeXSorterP16HeightMeshBVNodeEEbT0_S5_T_, __ZNSt3__211__sift_downIR25RenderPrePassObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_: __ZNSt3__211__sift_downIR25RenderPrePassObjectSorterP16RenderObjectDataEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_, __Z43Register_UnityEngine_AudioClip_get_channelsv: __Z43Register_UnityEngine_AudioClip_get_channelsv, __ZN9GfxDevice11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns: __ZN9GfxDevice11DrawBuffersEP9GfxBufferPK18VertexStreamSourceiPK16DrawBuffersRangeiP17VertexDeclarationRK14ChannelAssigns, __Z43Register_UnityEngine_SpringJoint_get_springv: __Z43Register_UnityEngine_SpringJoint_get_springv, __ZN15AudioEchoFilter15ThreadedCleanupEv: __ZN15AudioEchoFilter15ThreadedCleanupEv, __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb: __ZN11UnityEngine9Animation36GenerateTransformBindingMapRecursiveER9TransformRKN7mecanim5crc32ER13dynamic_arrayINS0_14BoundTransformELj4EEPKNS3_9animation14AvatarConstantEb, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags, __ZZN2UI14CanvasRenderer15InitializeClassEvEN38FunctorImpl_803kCanvasHierarchyChanged4CallEPviR11MessageData: __ZZN2UI14CanvasRenderer15InitializeClassEvEN38FunctorImpl_803kCanvasHierarchyChanged4CallEPviR11MessageData, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE14handleAccessorILj415ENS_22PxRepXPropertyAccessorILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESD_EEEEvRKT0_, __ZN5physx6shdfnd16MemoryMappedFile14getBaseAddressEv: __ZN5physx6shdfnd16MemoryMappedFile14getBaseAddressEv, __ZN7mecanim6memory16MecanimAllocator8AllocateEjj: __ZN7mecanim6memory16MecanimAllocator8AllocateEjj, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEED2Ev, __ZN4FMOD4DSPI7releaseEv: __ZN4FMOD4DSPI7releaseEv, __ZN13EmscriptenWWW15LockPartialDataEv: __ZN13EmscriptenWWW15LockPartialDataEv, __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetEnabledv: __Z74Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetEnabledv, __ZN4FMOD6System10loadPluginEPKcPjj: __ZN4FMOD6System10loadPluginEPKcPjj, __Z47WheelCollider_Set_Custom_PropSuspensionDistanceP12Il2CppObjectf: __Z47WheelCollider_Set_Custom_PropSuspensionDistanceP12Il2CppObjectf, __ZN5physx6shdfnd7FastXml8Callback14processDoctypeEPKcS4_S4_S4_: __ZN5physx6shdfnd7FastXml8Callback14processDoctypeEPKcS4_S4_S4_, __ZN24UserAuthorizationManagerC2Ev: __ZN24UserAuthorizationManagerC2Ev, __ZNK13RenderTexture12GetDimensionEv: __ZNK13RenderTexture12GetDimensionEv, __ZN5physx2Sc16ArticulationCore18setFreezeThresholdEf: __ZN5physx2Sc16ArticulationCore18setFreezeThresholdEf, __ZN5physx56PxVehicleDrive4WSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE: __ZN5physx56PxVehicleDrive4WSmoothDigitalRawInputsAndSetAnalogInputsERKNS_25PxVehicleKeySmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDrive4WRawInputDataEfbRNS_16PxVehicleDrive4WE, __Z41Register_UnityEngine_HingeJoint_get_anglev: __Z41Register_UnityEngine_HingeJoint_get_anglev, __Z12BuildTextureItPFvP9Texture2DPtiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb: __Z12BuildTextureItPFvP9Texture2DPtiiiiEES1_PKcii13TextureFormatRKT0_17TextureColorSpaceb, __Z32setPxArticulationJoint_StiffnessPN5physx19PxArticulationJointEf: __Z32setPxArticulationJoint_StiffnessPN5physx19PxArticulationJointEf, __ZNK19TouchPhaseEmulation24IsTouchPressureSupportedEv: __ZNK19TouchPhaseEmulation24IsTouchPressureSupportedEv, __Z44Register_UnityEngine_Event_GetTypeForControlv: __Z44Register_UnityEngine_Event_GetTypeForControlv, __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI14SafeBinaryReadEEvRT_, __ZN15ParticleEmitter4EmitERK8Vector3fS2_ffRK11ColorRGBA32ff: __ZN15ParticleEmitter4EmitERK8Vector3fS2_ffRK11ColorRGBA32ff, __ZltRK18ParticleSorterPredS1_: __ZltRK18ParticleSorterPredS1_, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EEiEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_6solverEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN5physx2Sn14RepXCollection16getLatestVersionEv: __ZN5physx2Sn14RepXCollection16getLatestVersionEv, _tre_compare_items: _tre_compare_items, __ZN5physx7NpScene20fireCallBacksPreSyncEv: __ZN5physx7NpScene20fireCallBacksPreSyncEv, __ZN5physx21PxSpringGeneratedInfoC2Ev: __ZN5physx21PxSpringGeneratedInfoC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxJointLimitConeEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z40AudioChorusFilter_Set_Custom_PropWetMix2P12Il2CppObjectf: __Z40AudioChorusFilter_Set_Custom_PropWetMix2P12Il2CppObjectf, __Z44Register_UnityEngine_Animator_get_updateModev: __Z44Register_UnityEngine_Animator_get_updateModev, __ZNK8Animator28WarningStringIfLoggingActiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK8Animator28WarningStringIfLoggingActiveERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorIN9ShaderLab14SerializedPassENS_9allocatorIS2_EEE6assignIPS2_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev: __ZN11UnityEngine15CloudWebService18RestFileDownloaderD2Ev, _ft_outline_glyph_bbox: _ft_outline_glyph_bbox, __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI15CapsuleColliderE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNKSt3__27collateIcE12do_transformEPKcS3_: __ZNKSt3__27collateIcE12do_transformEPKcS3_, __ZN27ShapeModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN27ShapeModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZNK12b2MotorJoint19GetCorrectionFactorEv: __ZNK12b2MotorJoint19GetCorrectionFactorEv, __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi: __Z43LocalSerializedObjectIdentifierToInstanceIDRK31LocalSerializedObjectIdentifierRi, __ZN15TerrainRenderer10FindParentER12QuadTreeNode: __ZN15TerrainRenderer10FindParentER12QuadTreeNode, __Z23IsWorldPlayingThisFramev: __Z23IsWorldPlayingThisFramev, __ZNK5physx5cloth8SwSolver19StartSimulationTask7getNameEv: __ZNK5physx5cloth8SwSolver19StartSimulationTask7getNameEv, __Z40Physics2D_CUSTOM_GetIgnoreLayerCollisionii: __Z40Physics2D_CUSTOM_GetIgnoreLayerCollisionii, _swprintf: _swprintf, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initIPKcEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_, __ZN5physx19NpArticulationJointD0Ev: __ZN5physx19NpArticulationJointD0Ev, __ZN5physx3Scb5Scene11shiftOriginERKNS_6PxVec3E: __ZN5physx3Scb5Scene11shiftOriginERKNS_6PxVec3E, __ZN13BaseAllocator13ThreadCleanupEv: __ZN13BaseAllocator13ThreadCleanupEv, __Z41NavMesh_CUSTOM_GetAvoidancePredictionTimev: __Z41NavMesh_CUSTOM_GetAvoidancePredictionTimev, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab19SerializedSubShaderENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZNSt3__212ctype_bynameIcED2Ev: __ZNSt3__212ctype_bynameIcED2Ev, __ZN14MinMaxGradient19InitializeOptimizedER23OptimizedMinMaxGradient: __ZN14MinMaxGradient19InitializeOptimizedER23OptimizedMinMaxGradient, __Z52Register_UnityEngine_Physics2D_set_velocityThresholdv: __Z52Register_UnityEngine_Physics2D_set_velocityThresholdv, __Z44PhysicMaterial_Get_Custom_PropStaticFrictionP12Il2CppObject: __Z44PhysicMaterial_Get_Custom_PropStaticFrictionP12Il2CppObject, __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZSt17rethrow_exceptionSt13exception_ptr: __ZSt17rethrow_exceptionSt13exception_ptr, __Z34SparseTexture_CUSTOM_UpdateTileRawP12Il2CppObjectiiiP11Il2CppArray: __Z34SparseTexture_CUSTOM_UpdateTileRawP12Il2CppObjectiiiP11Il2CppArray, __ZN13UnityProfiler11EndGPUFrameEv: __ZN13UnityProfiler11EndGPUFrameEv, __ZN5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEED0Ev: __ZN5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEED0Ev, __Z28scripting_class_is_interfaceP11Il2CppClass: __Z28scripting_class_is_interfaceP11Il2CppClass, __ZN18PlatformEffector2D16SetUseSideBounceEb: __ZN18PlatformEffector2D16SetUseSideBounceEb, __ZN5physx7profile15ZoneManagerImpl21addProfileZoneHandlerERNS_20PxProfileZoneHandlerE: __ZN5physx7profile15ZoneManagerImpl21addProfileZoneHandlerERNS_20PxProfileZoneHandlerE, __ZL28CheckCopyTextureMipArgumentsP7TextureiiS0_ii: __ZL28CheckCopyTextureMipArgumentsP7TextureiiS0_ii, __ZN20SoundChannelInstance11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS4_E: __ZN20SoundChannelInstance11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS4_E, __ZN24EllipsoidParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi: __ZN24EllipsoidParticleEmitter14SetupParticlesERNSt3__26vectorI8Particle13stl_allocatorIS2_L18MemLabelIdentifier18ELi16EEEERK8Vector3fRK10Matrix3x3fi, __ZN11UnityEngine15CloudWebService19SessionEventManager20ArchivePendingEventsEv: __ZN11UnityEngine15CloudWebService19SessionEventManager20ArchivePendingEventsEv, __ZThn4_NK5physx5cloth8SwFabric10getNumSetsEv: __ZThn4_NK5physx5cloth8SwFabric10getNumSetsEv, __Z44Time_Get_Custom_PropMaximumParticleDeltaTimev: __Z44Time_Get_Custom_PropMaximumParticleDeltaTimev, __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4AABB8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_: __ZN5physx7profile17MemoryEventParserILb0EE5parseINS_35ProfileBulkMemoryEventHandlerBufferILj4096EEEEEvRKNS0_15AllocationEventERKNS0_17MemoryEventHeaderERT_, __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10SampleClip23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx8CCDSweepINS_2Gu8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f: __ZN5physx8CCDSweepINS_2Gu8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_10postSolverEPNS_10PxBaseTaskEEEE7getNameEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcRKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcRKS4_, __ZN4FMOD7Channel7getMuteEPb: __ZN4FMOD7Channel7getMuteEPb, __ZNK5physx2Sc18ParticleSystemCore18getDynamicFrictionEv: __ZNK5physx2Sc18ParticleSystemCore18getDynamicFrictionEv, __ZNK11Rigidbody2D10GetInertiaEv: __ZNK11Rigidbody2D10GetInertiaEv, __ZN11JpegDecoder16DecodePixelsImplEPhjb13TextureFormat: __ZN11JpegDecoder16DecodePixelsImplEPhjb13TextureFormat, __ZL16contactHullMesh2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESI_bb: __ZL16contactHullMesh2RKN5physx2Gu13PolygonalDataERKNS_9PxBounds3ERKNS_24PxTriangleMeshGeometryLLERKNS_11PxTransformESC_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingESI_bb, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI31EnlightenSystemAtlasInformationLj8EEEEvRT_17TransferMetaFlags, __Z36getPxConstraint_MinResponseThresholdPKN5physx12PxConstraintE: __Z36getPxConstraint_MinResponseThresholdPKN5physx12PxConstraintE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxPrismaticJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj437ENS_22PxRepXPropertyAccessorILj437ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj437ENS_22PxRepXPropertyAccessorILj437ES4_ffEEEEvRKT0_, _nanl: _nanl, __ZNK9allocutil14BuddyAllocator6SizeOfENS_5ChunkE: __ZNK9allocutil14BuddyAllocator6SizeOfENS_5ChunkE, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE11__recommendEj, __ZN5physx7NpScene11unlockWriteEv: __ZN5physx7NpScene11unlockWriteEv, __Z68Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshMaterialIndexv: __Z68Register_UnityEngine_ParticleSystem_ShapeModule_GetMeshMaterialIndexv, __ZN22UnityAnalyticsSettings22SetInitializeOnStartupEb: __ZN22UnityAnalyticsSettings22SetInitializeOnStartupEb, __ZN5Light12CleanupClassEv: __ZN5Light12CleanupClassEv, __Z36GUITexture_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z36GUITexture_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __ZN12_GLOBAL__N_123DebugKHRDefaultCallbackEjjjjiPKcPKv: __ZN12_GLOBAL__N_123DebugKHRDefaultCallbackEjjjjiPKcPKv, _log1pf: _log1pf, __ZN10AudioMixer18BuildMixerConstantEv: __ZN10AudioMixer18BuildMixerConstantEv, __ZN5physx24PxDefaultMemoryInputData4readEPvj: __ZN5physx24PxDefaultMemoryInputData4readEPvj, __ZN5physx3Ext20DefaultCpuDispatcher16getAffinityMasksEPjj: __ZN5physx3Ext20DefaultCpuDispatcher16getAffinityMasksEPjj, __Z39MeshCollider_Set_Custom_PropInflateMeshP12Il2CppObjecth: __Z39MeshCollider_Set_Custom_PropInflateMeshP12Il2CppObjecth, __ZN5physx7NpCloth18setSolverFrequencyEf: __ZN5physx7NpCloth18setSolverFrequencyEf, __ZN5audio5mixer20GetGroupPathFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID: __ZN5audio5mixer20GetGroupPathFromGUIDERKNS0_18AudioMixerConstantERK9UnityGUID, __ZN4crnd6vectorIhE6assignERKS1_: __ZN4crnd6vectorIhE6assignERKS1_, __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData: __ZN9Transform19BroadcastMessageAnyERK17MessageIdentifierR11MessageData, __ZN2UIL18CompareCanvasDepthEPNS_6CanvasES1_: __ZN2UIL18CompareCanvasDepthEPNS_6CanvasES1_, _UNITY_png_set_crc_action: _UNITY_png_set_crc_action, __Z32Canvas_Get_Custom_PropRenderModeP12Il2CppObject: __Z32Canvas_Get_Custom_PropRenderModeP12Il2CppObject, __Z24CullingGroup_CUSTOM_InitP12Il2CppObject: __Z24CullingGroup_CUSTOM_InitP12Il2CppObject, __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12ImmediatePtrI9TransformE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIi17ShadowCachingDataEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier64ELi16EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZNK5physx2Gu5RTree11traverseRayILi1EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f: __ZNK5physx2Gu5RTree11traverseRayILi1EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f, __ZThn8_N5physx2Sc24ElementInteractionMarkerD0Ev: __ZThn8_N5physx2Sc24ElementInteractionMarkerD0Ev, __Z24FullscreenChangeCallbackiPK31EmscriptenFullscreenChangeEventPv: __Z24FullscreenChangeCallbackiPK31EmscriptenFullscreenChangeEventPv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED0Ev: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEED0Ev, _rewinddir: _rewinddir, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE, __ZN23CloudWebServicesManager27UnregisterPlayerLoopHandlerEP19CloudServiceHandler: __ZN23CloudWebServicesManager27UnregisterPlayerLoopHandlerEP19CloudServiceHandler, __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_SetDensityv: __Z55Register_UnityEngine_Rigidbody_INTERNAL_CALL_SetDensityv, __ZNK9Texture3D11GetPixels32EP11ColorRGBA32i: __ZNK9Texture3D11GetPixels32EP11ColorRGBA32i, __Z38RectOffset_CUSTOM_INTERNAL_CALL_RemoveP12Il2CppObjectRK5RectTIfERS2_: __Z38RectOffset_CUSTOM_INTERNAL_CALL_RemoveP12Il2CppObjectRK5RectTIfERS2_, __ZN8Animator12RetargetStepEv: __ZN8Animator12RetargetStepEv, __ZN5physx10NpMaterial7releaseEv: __ZN5physx10NpMaterial7releaseEv, _creat: _creat, __Z36AnimationState_Get_Custom_PropLengthP12Il2CppObject: __Z36AnimationState_Get_Custom_PropLengthP12Il2CppObject, __ZN17AudioChorusFilter6UpdateEv: __ZN17AudioChorusFilter6UpdateEv, _mbsnrtowcs: _mbsnrtowcs, __ZN4FMOD8ChannelI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD8ChannelI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN21ArchiveStorageCreator17StoreCurrentBlockEb: __ZN21ArchiveStorageCreator17StoreCurrentBlockEb, __ZN13LoadOperation7PerformEv: __ZN13LoadOperation7PerformEv, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE7reserveEj, __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE4findIS1_EENS_15__tree_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEERKT_: __ZNSt3__26__treeI19RepeatingLogMessageNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier70ELi16EEE4findIS1_EENS_15__tree_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEERKT_, _stbir_resize_uint8_srgb_edgemode: _stbir_resize_uint8_srgb_edgemode, __ZN19ScriptingInvocation6InvokeIP12Il2CppObjectEET_PP15Il2CppExceptionb: __ZN19ScriptingInvocation6InvokeIP12Il2CppObjectEET_PP15Il2CppExceptionb, __Z52Register_UnityEngine_Terrain_set_treeCrossFadeLengthv: __Z52Register_UnityEngine_Terrain_set_treeCrossFadeLengthv, __ZN19SkinnedMeshRenderer19SetBlendShapeWeightEjf: __ZN19SkinnedMeshRenderer19SetBlendShapeWeightEjf, __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv: __ZN15NameToObjectMapI6ShaderNSt3__23mapI4PPtrIS0_E8UnityStrNS1_4lessIS4_EENS1_9allocatorINS1_4pairIKS4_S5_EEEEEENS1_8multimapIS5_S4_NS6_IS5_EENS8_INS9_IKS5_S4_EEEEEEE7RebuildEv, __ZNSt3__218condition_variable10notify_oneEv: __ZNSt3__218condition_variable10notify_oneEv, __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SpeedTreeWind10SWindGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx11PxHitBufferINS_10PxSweepHitEE14processTouchesEPKS1_j: __ZN5physx11PxHitBufferINS_10PxSweepHitEE14processTouchesEPKS1_j, __ZN8WindZoneD0Ev: __ZN8WindZoneD0Ev, __ZNK16MemoryFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag: __ZNK16MemoryFileSystem9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwi: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7getlineEPwi, __ZN19ParticleSystemState8TransferI14SafeBinaryReadEEvRT_: __ZN19ParticleSystemState8TransferI14SafeBinaryReadEEvRT_, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc19ParticlePacketShapeEEEE15growAndPushBackERKS2_, __Z30Caching_CUSTOM_CleanNamedCacheP12Il2CppString: __Z30Caching_CUSTOM_CleanNamedCacheP12Il2CppString, __ZN15FileSystemEntry11CreateAsDirEv: __ZN15FileSystemEntry11CreateAsDirEv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getNumRestPositionsEv, __Z51Register_UnityEngine_AudioSettings_SetDSPBufferSizev: __Z51Register_UnityEngine_AudioSettings_SetDSPBufferSizev, __ZN5physx18NpArticulationLink7releaseEv: __ZN5physx18NpArticulationLink7releaseEv, __ZN7mecanim9animation18GetXformCurveValueERKN4math4trsXEi: __ZN7mecanim9animation18GetXformCurveValueERKN4math4trsXEi, __Z18Transfer_BlittableI9JSONWriteLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZNK5physx7NpActor13findConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseE: __ZNK5physx7NpActor13findConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseE, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_18updateCCDMultiPassEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN5Flare12FlareElementENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN5Flare12FlareElementENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN17Physics2DSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN17Physics2DSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_: __ZNK5physx2Gu13GeometryUnion13computeBoundsERNS_9PxBounds3ERKNS_11PxTransformEfPKS2_, __Z45LineRenderer_CUSTOM_INTERNAL_CALL_SetPositionP12Il2CppObjectiRK8Vector3f: __Z45LineRenderer_CUSTOM_INTERNAL_CALL_SetPositionP12Il2CppObjectiRK8Vector3f, __ZN5physx2Sn18writeAllPropertiesINS_13PxBoxGeometryEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_13PxBoxGeometryEEEvRNS_7profile12ProfileArrayINS0_14NameStackEntryEEEPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __Z49Rigidbody_Get_Custom_PropSolverVelocityIterationsP12Il2CppObject: __Z49Rigidbody_Get_Custom_PropSolverVelocityIterationsP12Il2CppObject, __Z62Register_UnityEngine_QualitySettings_get_asyncUploadBufferSizev: __Z62Register_UnityEngine_QualitySettings_get_asyncUploadBufferSizev, _sockatmark: _sockatmark, __ZN6HelperI17RemapPPtrTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI17RemapPPtrTransfer23TransferArrayField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcjj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcjj, __ZN19StreamedBinaryWriteILb1EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData: __ZN19StreamedBinaryWriteILb1EE4InitERK12CachedWriter24TransferInstructionFlags20BuildTargetSelectionRK13BuildUsageTagRK15GlobalBuildData, __ZN11AudioModule19SetApplicationPauseEb: __ZN11AudioModule19SetApplicationPauseEb, __ZN18BuoyancyEffector2D12SetFlowAngleEf: __ZN18BuoyancyEffector2D12SetFlowAngleEf, __ZN9AudioClip6ReloadEv: __ZN9AudioClip6ReloadEv, __Z33GUIStyle_Set_Custom_PropAlignmentP12Il2CppObjecti: __Z33GUIStyle_Set_Custom_PropAlignmentP12Il2CppObjecti, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float3EEEclERS4_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIKN4math7_float3EEEclERS4_17TransferMetaFlagsR9BlobWrite, __ZN5Unity10FixedJointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity10FixedJointC2E10MemLabelId18ObjectCreationMode, __Z47GUISettings_CUSTOM_Internal_GetCursorFlashSpeedv: __Z47GUISettings_CUSTOM_Internal_GetCursorFlashSpeedv, __ZN4FMOD6Reverb9getActiveEPb: __ZN4FMOD6Reverb9getActiveEPb, __ZN11MatrixStack18SetCurrentIdentityEv: __ZN11MatrixStack18SetCurrentIdentityEv, __Z43Terrain_Get_Custom_PropCollectDetailPatchesP12Il2CppObject: __Z43Terrain_Get_Custom_PropCollectDetailPatchesP12Il2CppObject, __ZN18CrashReportHandlerD2Ev: __ZN18CrashReportHandlerD2Ev, __ZN12CubemapArray5ResetEv: __ZN12CubemapArray5ResetEv, __ZN14SubstanceValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14SubstanceValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN4crnd16crnd_debug_breakEv: __ZN4crnd16crnd_debug_breakEv, __ZN5physx20createContactPatchesERNS_18PxcNpThreadContextEjf: __ZN5physx20createContactPatchesERNS_18PxcNpThreadContextEjf, __ZN14ParticleSystem27CopyParticlesToUnalignedDstER23ParticleSystemParticlesjjj: __ZN14ParticleSystem27CopyParticlesToUnalignedDstER23ParticleSystemParticlesjjj, __Z18CleanupUmbraModulev: __Z18CleanupUmbraModulev, __Z49Register_UnityEngine_ParticleAnimator_set_dampingv: __Z49Register_UnityEngine_ParticleAnimator_set_dampingv, _tt_cmap2_char_next: _tt_cmap2_char_next, __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyPositionInternalP12Il2CppObjectR8Vector3f: __Z53Animator_CUSTOM_INTERNAL_CALL_GetBodyPositionInternalP12Il2CppObjectR8Vector3f, __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode: __ZN7Joint2DC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv: __ZN5physx2Sc7Element26ElementInteractionIterator7getNextEv, __ZN17CommonStringTableD2Ev: __ZN17CommonStringTableD2Ev, __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStream7executeEv: __ZThn4_N12_GLOBAL__N_123DoubleBufferedOutStream7executeEv, __ZN21LinearCollectionField15GetElementClassEv: __ZN21LinearCollectionField15GetElementClassEv, __ZNSt3__217moneypunct_bynameIwLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__217moneypunct_bynameIwLb1EEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN5physx18RepXSerializerImplINS_14PxArticulationEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx18RepXSerializerImplINS_14PxArticulationEE16fileToObjectImplEPS1_RNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, _psh_globals_funcs_init: _psh_globals_funcs_init, __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f: __ZNK11BoxCollider16GetGlobalExtentsERK8Vector3f, __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetEnabledv: __Z78Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetEnabledv, __ZN5physx7NpCloth16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE: __ZN5physx7NpCloth16setStretchConfigENS_22PxClothFabricPhaseType4EnumERKNS_20PxClothStretchConfigE, __Z45Register_UnityEngine_GUIUtility_get_mouseUsedv: __Z45Register_UnityEngine_GUIUtility_get_mouseUsedv, __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_91kDidDeleteMotion4CallEPviR11MessageData: __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_91kDidDeleteMotion4CallEPviR11MessageData, __ZN4Mesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN4Mesh23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN8WindZone23VirtualRedirectTransferER14SafeBinaryRead: __ZN8WindZone23VirtualRedirectTransferER14SafeBinaryRead, __ZN9ShaderLab9SubShader8PostLoadEP6Shader: __ZN9ShaderLab9SubShader8PostLoadEP6Shader, __ZN9ShaderLab19SerializedSubShader8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab19SerializedSubShader8TransferI14SafeBinaryReadEEvRT_, __ZN12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv: __ZN12_GLOBAL__N_110Connection12onAllocationEjPKcS2_iPv, __Z38CircleCollider2D_Get_Custom_PropRadiusP12Il2CppObject: __Z38CircleCollider2D_Get_Custom_PropRadiusP12Il2CppObject, __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED0Ev: __ZN5physx7profile10DataBufferINS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS6_EEED0Ev, __Z42Register_UnityEngine_GUIText_set_alignmentv: __Z42Register_UnityEngine_GUIText_set_alignmentv, __Z42NavMeshAgent_Set_Custom_PropUpdatePositionP12Il2CppObjecth: __Z42NavMeshAgent_Set_Custom_PropUpdatePositionP12Il2CppObjecth, __Z17RandomUnitVector2R5RandN: __Z17RandomUnitVector2R5RandN, __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE: __ZNSt3__29basic_iosIwNS_11char_traitsIwEEEC2EPNS_15basic_streambufIwS2_EE, __Z17GetSocketErrorMsgi: __Z17GetSocketErrorMsgi, __Z26CreateAllowNameConversionsv: __Z26CreateAllowNameConversionsv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE17__do_get_unsignedIyEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN22MemoryCacherReadBlocks16UnlockCacheBlockEj: __ZN22MemoryCacherReadBlocks16UnlockCacheBlockEj, _UNITY_ft_base_pic_init: _UNITY_ft_base_pic_init, __ZN10Collider2D16CheckConsistencyEv: __ZN10Collider2D16CheckConsistencyEv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEixEj, __ZN19AssetBundleManifest33CollectAllDependenciesRecursivelyEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE: __ZN19AssetBundleManifest33CollectAllDependenciesRecursivelyEiRNSt3__23setIiNS0_4lessIiEENS0_9allocatorIiEEEE, ___uflow: ___uflow, __ZN19SkinnedMeshRenderer15UpdateClothDataEv: __ZN19SkinnedMeshRenderer15UpdateClothDataEv, __ZN23RaycastCallbackNonAllocD0Ev: __ZN23RaycastCallbackNonAllocD0Ev, __ZNK9ShaderLab11ShaderState16ApplyShaderStateEjPK19ShaderPropertySheetRK17ShaderPassContextP6ShaderPNS_4PassEP11SubPrograms: __ZNK9ShaderLab11ShaderState16ApplyShaderStateEjPK19ShaderPropertySheetRK17ShaderPassContextP6ShaderPNS_4PassEP11SubPrograms, __ZN5physx2Sc15ArticulationSim20saveLastCCDTransformEv: __ZN5physx2Sc15ArticulationSim20saveLastCCDTransformEv, __ZN7mecanim9animation14AvatarConstant15InitializeClassEv: __ZN7mecanim9animation14AvatarConstant15InitializeClassEv, __Z41RenderTexture_Set_Custom_PropIsPowerOfTwoP12Il2CppObjecth: __Z41RenderTexture_Set_Custom_PropIsPowerOfTwoP12Il2CppObjecth, __ZN14BillboardAssetD2Ev: __ZN14BillboardAssetD2Ev, __ZN13RenderTexture10ReleaseAllEv: __ZN13RenderTexture10ReleaseAllEv, __ZN14ParticleSystem22SetUsesInitialVelocityEv: __ZN14ParticleSystem22SetUsesInitialVelocityEv, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18PlatformEffector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN18PlatformEffector2D23VirtualRedirectTransferER14SafeBinaryRead, __Z30createPxPhysics_TriangleMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE: __Z30createPxPhysics_TriangleMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE, _cff_slot_done: _cff_slot_done, __Z42Rigidbody_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK8Vector3f: __Z42Rigidbody_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK8Vector3f, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE9addForcesEjRKNS_16PxStrideIteratorIKjEERKNS4_IKNS_6PxVec3EEENS_11PxForceMode4EnumE, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE8requiresERNS_23PxProcessPxBaseCallbackE, __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularXDriveP12Il2CppObjectP10JointDrive: __Z51ConfigurableJoint_CUSTOM_INTERNAL_get_angularXDriveP12Il2CppObjectP10JointDrive, __ZNK5physx2Gu29ConvexVsMeshContactGeneration16generateContactsERKNS_7PxPlaneEPKNS_6PxVec3ERS6_RS5_fj: __ZNK5physx2Gu29ConvexVsMeshContactGeneration16generateContactsERKNS_7PxPlaneEPKNS_6PxVec3ERS6_RS5_fj, __Z40Camera_CUSTOM_Internal_RenderToCubemapRTP12Il2CppObjectS0_i: __Z40Camera_CUSTOM_Internal_RenderToCubemapRTP12Il2CppObjectS0_i, __Z13ConvertPixelsPKh13TextureFormatPhS1_j: __Z13ConvertPixelsPKh13TextureFormatPhS1_j, __ZN23iPhoneLocalNotification17SetRepeatCalendarE18CalendarIdentifier: __ZN23iPhoneLocalNotification17SetRepeatCalendarE18CalendarIdentifier, __ZNK22GenericPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK22GenericPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZN5physx2Sc14ConstraintCore23setMinResponseThresholdEf: __ZN5physx2Sc14ConstraintCore23setMinResponseThresholdEf, __Z50getPxVehicleTireDataMCamberStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE: __Z50getPxVehicleTireDataMCamberStiffnessPerUnitGravityPKN5physx17PxVehicleTireDataE, __Z51Register_UnityEngine_SystemInfo_get_operatingSystemv: __Z51Register_UnityEngine_SystemInfo_get_operatingSystemv, __ZNSt3__211char_traitsIwE4moveEPwPKwj: __ZNSt3__211char_traitsIwE4moveEPwPKwj, __ZN22CrashReportingSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN22CrashReportingSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z40getPxVehicleSuspensionData_RecipMaxDroopPKN5physx23PxVehicleSuspensionDataE: __Z40getPxVehicleSuspensionData_RecipMaxDroopPKN5physx23PxVehicleSuspensionDataE, __Z27ConvertSubMeshesToTrianglesRNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEER13dynamic_arrayItLj2EE: __Z27ConvertSubMeshesToTrianglesRNSt3__26vectorI7SubMesh13stl_allocatorIS1_L18MemLabelIdentifier16ELi16EEEER13dynamic_arrayItLj2EE, __ZN5physx21PxcArticulationHelper20initializeDriveCacheERNS_9PxcFsDataEtPKNS_19PxsArticulationLinkEfjPcj: __ZN5physx21PxcArticulationHelper20initializeDriveCacheERNS_9PxcFsDataEtPKNS_19PxsArticulationLinkEfjPcj, __ZN12HingeJoint2D12SetUseLimitsEb: __ZN12HingeJoint2D12SetUseLimitsEb, __ZNSt3__26locale5facet16__on_zero_sharedEv: __ZNSt3__26locale5facet16__on_zero_sharedEv, __ZN5physx18NpArticulationLink15releaseInternalEv: __ZN5physx18NpArticulationLink15releaseInternalEv, __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi: __ZN5Umbra12QueryContext7mapTileERNS_10MappedTileEi, __Z20InverseTransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_: __Z20InverseTransformAABBRK4AABBRK8Vector3fRK11QuaternionfRS_, __ZN11TerrainData13AwakeFromLoadE17AwakeFromLoadMode: __ZN11TerrainData13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj431ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE15complexPropertyINS_22PxRepXPropertyAccessorILj431ES2_RKNS_23PxJointAngularLimitPairES6_EEKNS_36PxJointAngularLimitPairGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx2Sc9RigidCoreD2Ev: __ZN5physx2Sc9RigidCoreD2Ev, __ZZN2UI11CanvasGroup15InitializeClassEvEN40FunctorImpl_119kTransformChildrenChanged4CallEPviR11MessageData: __ZZN2UI11CanvasGroup15InitializeClassEvEN40FunctorImpl_119kTransformChildrenChanged4CallEPviR11MessageData, __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j: __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDrive4WEEEEEEEjT_j, __ZN8Material8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8Material8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN7Joint2D15InitializeClassEv: __ZN7Joint2D15InitializeClassEv, __Z46Register_UnityEngine_Canvas_set_sortingLayerIDv: __Z46Register_UnityEngine_Canvas_set_sortingLayerIDv, __ZN5physx6shdfnd12PxRingBuffer15MultiPartPacket7processEv: __ZN5physx6shdfnd12PxRingBuffer15MultiPartPacket7processEv, __ZN5physx25PxVehicleConstraintShaderD0Ev: __ZN5physx25PxVehicleConstraintShaderD0Ev, __ZN15OcclusionPortal10DeactivateE19DeactivateOperation: __ZN15OcclusionPortal10DeactivateE19DeactivateOperation, __ZNK5physx13NpRigidStatic23checkConstraintValidityEv: __ZNK5physx13NpRigidStatic23checkConstraintValidityEv, __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii: __ZNK14dtNavMeshQuery7raycastEyPKfS1_PK13dtQueryFilterP15dtRaycastResultPyPii, __Z27GetComponentsInChildrenImplILb0EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE: __Z27GetComponentsInChildrenImplILb0EEvR10GameObjectiR13dynamic_arrayIPN5Unity9ComponentELj4EE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE28getTetherConstraintStiffnessEv, __ZN25SingleBlockMemoryFileData5WriteEyyPKv: __ZN25SingleBlockMemoryFileData5WriteEyyPKv, __Z64Register_UnityEngine_AnimatorOverrideController_GetOverrideClipsv: __Z64Register_UnityEngine_AnimatorOverrideController_GetOverrideClipsv, __ZN5Unity10HingeJointD2Ev: __ZN5Unity10HingeJointD2Ev, __ZN5physx14NpArticulation22setSeparationToleranceEf: __ZN5physx14NpArticulation22setSeparationToleranceEf, __ZN17MemoryCacheWriter16UnlockCacheBlockEj: __ZN17MemoryCacheWriter16UnlockCacheBlockEj, __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11BoxCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z28GUIUtility_CUSTOM_SetChangedh: __Z28GUIUtility_CUSTOM_SetChangedh, _asprintf: _asprintf, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__26locale5__imp12install_fromINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_9money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvRKS1_, __ZN8Renderer10AddToSceneEv: __ZN8Renderer10AddToSceneEv, __ZN25SubstanceRawTextureSharedD0Ev: __ZN25SubstanceRawTextureSharedD0Ev, _UNITY_png_user_version_check: _UNITY_png_user_version_check, __ZN4crnd12crn_unpacker11unpack_dxt1EPPhjjjjjj: __ZN4crnd12crn_unpacker11unpack_dxt1EPPhjjjjjj, __Z42Terrain_Set_Custom_PropHeightmapMaximumLODP12Il2CppObjecti: __Z42Terrain_Set_Custom_PropHeightmapMaximumLODP12Il2CppObjecti, _textdomain: _textdomain, __ZN6Object8AddEventEPFvPvS0_iES0_: __ZN6Object8AddEventEPFvPvS0_iES0_, __ZN5physx22computeVolumeIntegralsERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsE: __ZN5physx22computeVolumeIntegralsERKNS_20PxSimpleTriangleMeshEfRNS_11PxIntegralsE, __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE8__appendEj: __ZNSt3__26vectorINS_4pairIifEE13stl_allocatorIS2_L18MemLabelIdentifier34ELi16EEE8__appendEj, __ZL23OutOfBoundsReadingErroriiiR6Object: __ZL23OutOfBoundsReadingErroriiiR6Object, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxSphericalJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_: __ZN5Umbra15PortalRayTracer13intersectAABBENS_7Vector3ES1_RfS2_RKS1_, __Z43Register_UnityEngine_Camera_get_fieldOfViewv: __Z43Register_UnityEngine_Camera_get_fieldOfViewv, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_125ConstraintGraphColorCountENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx2Sc9ClothCore22setSleepLinearVelocityEf: __ZN5physx2Sc9ClothCore22setSleepLinearVelocityEf, __ZN10systeminfo24GetOperatingSystemFamilyEv: __ZN10systeminfo24GetOperatingSystemFamilyEv, __ZN19TouchPhaseEmulation15FindByPointerIdEPP9TouchImplj: __ZN19TouchPhaseEmulation15FindByPointerIdEPP9TouchImplj, __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEED0Ev: __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEED0Ev, __ZN5physx27PxcContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx27PxcContactConvexHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN16Physics2DManager14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEji: __ZN16Physics2DManager14BatchIntersectERK13dynamic_arrayI15BatchedRaycastsLj4EEjRS0_I20BatchedRaycastResultLj4EEji, __ZN5physx13SingleManager6resizeEj: __ZN5physx13SingleManager6resizeEj, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN11Rigidbody2D18AddForceAtPositionERK8Vector2fS2_NS_9ForceModeE: __ZN11Rigidbody2D18AddForceAtPositionERK8Vector2fS2_NS_9ForceModeE, __Z40setPxSimulationStatisticsNbDynamicBodiesPN5physx22PxSimulationStatisticsEj: __Z40setPxSimulationStatisticsNbDynamicBodiesPN5physx22PxSimulationStatisticsEj, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE16setInvMassScale0Ef, __ZN5physx6shdfnd6SocketC2Eb: __ZN5physx6shdfnd6SocketC2Eb, __ZN5Light9SetupHaloEv: __ZN5Light9SetupHaloEv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEE15growAndPushBackERKS2_, __ZN13TriggerModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf: __ZN13TriggerModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKf, __Z44DownloadHandlerBuffer_CUSTOM_InternalGetDataP12Il2CppObject: __Z44DownloadHandlerBuffer_CUSTOM_InternalGetDataP12Il2CppObject, __ZN5physx2Sn13XmlNodeWriter6endTagEv: __ZN5physx2Sn13XmlNodeWriter6endTagEv, __ZNK21EnlightenSceneMapping14FindSceneIndexEi: __ZNK21EnlightenSceneMapping14FindSceneIndexEi, __ZNK5physx2Sc14ConstraintCore8getForceERNS_6PxVec3ES3_: __ZNK5physx2Sc14ConstraintCore8getForceERNS_6PxVec3ES3_, __Z35CullingGroup_Set_Custom_PropEnabledP12Il2CppObjecth: __Z35CullingGroup_Set_Custom_PropEnabledP12Il2CppObjecth, __ZN5physx9NpFactory27releaseParticleSystemToPoolERNS_16NpParticleSystemE: __ZN5physx9NpFactory27releaseParticleSystemToPoolERNS_16NpParticleSystemE, _cff_get_glyph_data: _cff_get_glyph_data, __ZN4FMOD8ChannelI13get3DPanLevelEPf: __ZN4FMOD8ChannelI13get3DPanLevelEPf, __Z23DeleteSparseTextureGLES9TextureID: __Z23DeleteSparseTextureGLES9TextureID, __ZNK13GfxDeviceNull11GetViewportEv: __ZNK13GfxDeviceNull11GetViewportEv, _UNITY_png_colorspace_sync_info: _UNITY_png_colorspace_sync_info, __Z34getPxRigidDynamic_ConcreteTypeNamePKN5physx14PxRigidDynamicE: __Z34getPxRigidDynamic_ConcreteTypeNamePKN5physx14PxRigidDynamicE, __ZN13ShadowJobDataC2ERKS_: __ZN13ShadowJobDataC2ERKS_, __ZNK5physx5cloth8SwSolver25getInterCollisionDistanceEv: __ZNK5physx5cloth8SwSolver25getInterCollisionDistanceEv, __ZN12_GLOBAL__N_110Connection11isConnectedEv: __ZN12_GLOBAL__N_110Connection11isConnectedEv, __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN14ParticleSystem23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z50Register_UnityEngine_Animation_Internal_StopByNamev: __Z50Register_UnityEngine_Animation_Internal_StopByNamev, __ZL19CleanupModule_IMGUIv: __ZL19CleanupModule_IMGUIv, __ZN6Camera4CullER11CullResults8CullFlag: __ZN6Camera4CullER11CullResults8CullFlag, __ZN10GUITexture8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10GUITexture8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN20TextRenderingPrivate8FontImpl13CharacterInfo8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__215__codecvt_utf16IwLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_: __ZNKSt3__215__codecvt_utf16IwLb0EE10do_unshiftER11__mbstate_tPcS4_RS4_, __ZN8Remapper16IsPreallocatedIDEi: __ZN8Remapper16IsPreallocatedIDEi, __ZN13RuntimeStaticI13RendererSceneE16StaticInitializeEPv: __ZN13RuntimeStaticI13RendererSceneE16StaticInitializeEPv, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx35solveExtContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx35solveExtContactCoulombConcludeBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN9dtNavMesh20addOffMeshConnectionEPK25dtOffMeshConnectionParams: __ZN9dtNavMesh20addOffMeshConnectionEPK25dtOffMeshConnectionParams, __ZN5physx24PxcPCMContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx24PxcPCMContactSpherePlaneERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __Z25BeginsWithCaseInsensitivePKcS0_: __Z25BeginsWithCaseInsensitivePKcS0_, __Z39AudioChorusFilter_Get_Custom_PropDryMixP12Il2CppObject: __Z39AudioChorusFilter_Get_Custom_PropDryMixP12Il2CppObject, __ZN5physx2Sn13XmlNodeReader4readEPKcRy: __ZN5physx2Sn13XmlNodeReader4readEPKcRy, __ZN14MemoryProfiler17ShrinkMemoryUsageEv: __ZN14MemoryProfiler17ShrinkMemoryUsageEv, __Z25_SetupConstraintsParallelffjPN5physx20PxsIndexedConstraintERNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEPiS8_S8_RNS_25PxsConstraintBlockManagerE: __Z25_SetupConstraintsParallelffjPN5physx20PxsIndexedConstraintERNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEPiS8_S8_RNS_25PxsConstraintBlockManagerE, __ZNK15FileSystemEntry4SizeEv: __ZNK15FileSystemEntry4SizeEv, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6resizeEj: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6resizeEj, __ZN14DataBufferGLES7ReleaseEv: __ZN14DataBufferGLES7ReleaseEv, __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy: __ZN20ArchiveStorageReader10InitializeER15FileSystemEntryy, __ZN17ProfilerFrameData11DeserializeEPPib: __ZN17ProfilerFrameData11DeserializeEPPib, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15b2DistanceJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN15b2DistanceJoint24SolveVelocityConstraintsERK12b2SolverData, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN18AnimatorController23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Gu22pcmContactSphereConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu22pcmContactSphereConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZN8BitArray5emptyEv: __ZN8BitArray5emptyEv, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE19getEventIdsForNamesEPPKcj, __ZN21DownloadHandlerScript13OnReceiveDataEPKvj: __ZN21DownloadHandlerScript13OnReceiveDataEPKvj, __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv: __ZNK5physx2Sc9ShapeCore18getMaterialIndicesEv, __ZNSt3__219__shared_weak_count16__release_sharedEv: __ZNSt3__219__shared_weak_count16__release_sharedEv, __ZNK5physx3Ext14PrismaticJoint28getProjectionLinearToleranceEv: __ZNK5physx3Ext14PrismaticJoint28getProjectionLinearToleranceEv, __ZThn8_N12_GLOBAL__N_111StreamOwner5writeEPKhj: __ZThn8_N12_GLOBAL__N_111StreamOwner5writeEPKhj, __Z20CreateObjectFromCodeI9TransformEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI9TransformEPT_17AwakeFromLoadMode10MemLabelId, __ZN5physx2Sn5ConvX9exportIntEi: __ZN5physx2Sn5ConvX9exportIntEi, __ZNK15ReflectionProbe15GetGlobalCenterEv: __ZNK15ReflectionProbe15GetGlobalCenterEv, __ZZ23InitPlayerLoopCallbacksvEN36UpdateScriptRunBehaviourUpdatestruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN36UpdateScriptRunBehaviourUpdatestruct7ForwardEv, __ZN8Material8TransferI17RemapPPtrTransferEEvRT_: __ZN8Material8TransferI17RemapPPtrTransferEEvRT_, __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK17AnimationCurveTplI8Vector3fE20EvaluateWithoutCacheEfRS0_: __ZNK17AnimationCurveTplI8Vector3fE20EvaluateWithoutCacheEfRS0_, __ZN5Umbra10TomeLoader14loadFromBufferEPKhjPNS_9AllocatorE: __ZN5Umbra10TomeLoader14loadFromBufferEPKhjPNS_9AllocatorE, __Z24RegisterStrippedTypeInfoI13AudioListenerEviPKcS2_: __Z24RegisterStrippedTypeInfoI13AudioListenerEviPKcS2_, __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignINS_21__tree_const_iteratorIiPNS_11__tree_nodeIiPvEEiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIiNS_9allocatorIiEEE6assignINS_21__tree_const_iteratorIiPNS_11__tree_nodeIiPvEEiEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIiNS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZNK12IFileAdapter4SizeERK13FileEntryData: __ZNK12IFileAdapter4SizeERK13FileEntryData, __ZNSt3__26locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_7num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __ZN15LightProbeGroupD0Ev: __ZN15LightProbeGroupD0Ev, __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20NavMeshBuildSettings8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN25b2CapsuleAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator: __ZN25b2CapsuleAndCircleContact7DestroyEP9b2ContactP16b2BlockAllocator, __ZNK5physx5cloth8SwFabric15getNumParticlesEv: __ZNK5physx5cloth8SwFabric15getNumParticlesEv, __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_: __ZN5physx3Scb4Body18addSpatialVelocityEPKNS_6PxVec3ES4_, __ZN13MemoryManager30InitializeMainThreadAllocatorsEv: __ZN13MemoryManager30InitializeMainThreadAllocatorsEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4readEPwi: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE4readEPwi, __ZN5Unity4Type26FindTypeByPersistentTypeIDEi: __ZN5Unity4Type26FindTypeByPersistentTypeIDEi, __ZN26AnimatorControllerPlayable12GetBehaviourEP11Il2CppClass: __ZN26AnimatorControllerPlayable12GetBehaviourEP11Il2CppClass, __Z38Register_UnityEngine_Input_GetKeyUpIntv: __Z38Register_UnityEngine_Input_GetKeyUpIntv, __ZN4FMOD7Channel7setMuteEb: __ZN4FMOD7Channel7setMuteEb, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4readEPci: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE4readEPci, __ZN5physx16writeBack1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx16writeBack1DBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZNK5physx18NpArticulationLink13getNbChildrenEv: __ZNK5physx18NpArticulationLink13getNbChildrenEv, __Z54Physics_Set_Custom_PropDefaultSolverVelocityIterationsi: __Z54Physics_Set_Custom_PropDefaultSolverVelocityIterationsi, __ZN3MBP12purgeHandlesEP10MBP_Objectj: __ZN3MBP12purgeHandlesEP10MBP_Objectj, __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetApplyFootIKv: __Z79Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetApplyFootIKv, __ZN13RendererScene19AddRendererInternalEP8RendereriRK4AABB: __ZN13RendererScene19AddRendererInternalEP8RendereriRK4AABB, __ZN5physx2Sn13XmlNodeReader18pushCurrentContextEv: __ZN5physx2Sn13XmlNodeReader18pushCurrentContextEv, __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeForcev: __Z61Register_UnityEngine_Rigidbody_INTERNAL_CALL_AddRelativeForcev, __Z37Collider2D_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB: __Z37Collider2D_CUSTOM_INTERNAL_get_boundsP12Il2CppObjectP4AABB, __Z18ConvertUTF8toUTF16PPKhS0_PPtS2_15ConversionFlags: __Z18ConvertUTF8toUTF16PPKhS0_PPtS2_15ConversionFlags, __ZN8VRModuleD2Ev: __ZN8VRModuleD2Ev, __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags: __ZN8JSONRead21TransferSTLStyleArrayINSt3__26vectorINS1_12basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES6_IS9_LS7_1ELi16EEEEEEvRT_17TransferMetaFlags, __Z21FindGameObjectWithTagj: __Z21FindGameObjectWithTagj, __Z55Register_UnityEngine_Renderer_set_realtimeLightmapIndexv: __Z55Register_UnityEngine_Renderer_set_realtimeLightmapIndexv, _tt_cmap0_get_info: _tt_cmap0_get_info, __Z33ScriptingClassArrayToDynamicArrayI12LightmapData16LightmapDataMono13dynamic_arrayIS0_Lj4EEEvP11Il2CppArrayRT1_PFvRT0_RT_E: __Z33ScriptingClassArrayToDynamicArrayI12LightmapData16LightmapDataMono13dynamic_arrayIS0_Lj4EEEvP11Il2CppArrayRT1_PFvRT0_RT_E, __ZN10builtintex12GetBlackCubeEv: __ZN10builtintex12GetBlackCubeEv, __Z13RegisterClassI11TerrainDataEvv: __Z13RegisterClassI11TerrainDataEvv, __ZN21ExecutionOrderManager15InitializeClassEv: __ZN21ExecutionOrderManager15InitializeClassEv, __Z29Cloth_CUSTOM_SetEnabledFadingP12Il2CppObjecthf: __Z29Cloth_CUSTOM_SetEnabledFadingP12Il2CppObjecthf, __Z33AudioSource_Get_Custom_PropVolumeP12Il2CppObject: __Z33AudioSource_Get_Custom_PropVolumeP12Il2CppObject, __ZN5physx26PxConvexMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE: __ZN5physx26PxConvexMeshRepXSerializer12fileToObjectERNS_9XmlReaderERNS_18XmlMemoryAllocatorERNS_23PxRepXInstantiationArgsEPNS_12PxCollectionE, __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader: __ZN17ArchiveFileSystem13RemoveStorageEP20ArchiveStorageReader, __Z31GameObject_Set_Custom_PropLayerP12Il2CppObjecti: __Z31GameObject_Set_Custom_PropLayerP12Il2CppObjecti, __ZNK5physx15NpParticleFluid7getTypeEv: __ZNK5physx15NpParticleFluid7getTypeEv, __Z47ParticleSystem_TrailModule_CUSTOM_GetWorldSpaceP12Il2CppObject: __Z47ParticleSystem_TrailModule_CUSTOM_GetWorldSpaceP12Il2CppObject, __ZNSt3__26vectorI20ProcessFrameJobGroupNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI20ProcessFrameJobGroupNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEC2ERKSB_: __ZNSt3__24pairIKN4core12basic_stringIcNS1_20StringStorageDefaultIcEEEEN11UnityEngine9Analytics15UserCustomEvent11CustomValueEEC2ERKSB_, _modfl: _modfl, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSolveEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN5physx7NpScene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh: __ZN5physx7NpScene21setBroadPhaseCallbackEPNS_20PxBroadPhaseCallbackEh, __ZN4FMOD8ChannelI7getModeEPj: __ZN4FMOD8ChannelI7getModeEPj, __ZN12HingeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN12HingeJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _UNITY_FT_Stroker_BeginSubPath: _UNITY_FT_Stroker_BeginSubPath, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __ZNK5physx7NpShape11getGeometryEv: __ZNK5physx7NpShape11getGeometryEv, __ZN15CapsuleCollider10SmartResetEv: __ZN15CapsuleCollider10SmartResetEv, _wcsncpy: _wcsncpy, __Z37GeomOverlapCallback_SphereHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z37GeomOverlapCallback_SphereHeightfieldRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z24RegisterStrippedTypeInfoI9BehaviourEviPKcS2_: __Z24RegisterStrippedTypeInfoI9BehaviourEviPKcS2_, __ZN12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv: __ZN12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv, __Z50Register_UnityEngine_SystemInfo_get_processorCountv: __Z50Register_UnityEngine_SystemInfo_get_processorCountv, __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE: __ZNSt3__214__num_put_base18__identify_paddingEPcS1_RKNS_8ios_baseE, __ZN12IFileAdapter4ReadER13FileEntryDatayPvPy: __ZN12IFileAdapter4ReadER13FileEntryDatayPvPy, __Z28LODGroup_Get_Custom_PropSizeP12Il2CppObject: __Z28LODGroup_Get_Custom_PropSizeP12Il2CppObject, __ZN5physx2Sc8ShapeSim12onFlagChangeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx2Sc8ShapeSim12onFlagChangeENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZNK14TerrainManager17CreateMeshPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP4MeshLj4EE: __ZNK14TerrainManager17CreateMeshPatchesEPK6ObjectRK8Vector3fR13dynamic_arrayIP4MeshLj4EE, __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetRowIndexP12Il2CppObjecti: __Z61ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetRowIndexP12Il2CppObjecti, __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_9DataArrayEii: __ZN5Umbra8mapArrayEPNS_10StackAllocERKNS_9DataArrayEii, __Z18BuildTransformListR9TransformR13dynamic_arrayIPS_Lj4EE: __Z18BuildTransformListR9TransformR13dynamic_arrayIPS_Lj4EE, __Z35ReflectionProbe_Set_Custom_PropTypeP12Il2CppObjecti: __Z35ReflectionProbe_Set_Custom_PropTypeP12Il2CppObjecti, __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj0ES2_NS_19GenericStringStreamIS2_EEEERS4_RT1_: __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E11ParseStreamILj0ES2_NS_19GenericStringStreamIS2_EEEERS4_RT1_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj69ENS_22PxRepXPropertyAccessorILj69ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj69ENS_22PxRepXPropertyAccessorILj69ES4_ffEEEEvRKT0_, __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_: __ZN9Transform26SetPositionWithLocalOffsetERK8Vector3fS2_, __Z58Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorIDv: __Z58Register_UnityEngine_SystemInfo_get_graphicsDeviceVendorIDv, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11CulledLightS2_EEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI11CulledLightS2_EEPS2_EEbT0_S6_T_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags, __ZN17ArchiveFileSystem5CloseER13FileEntryData: __ZN17ArchiveFileSystem5CloseER13FileEntryData, __ZN9AudioClipD2Ev: __ZN9AudioClipD2Ev, _UNITY_png_colorspace_set_chromaticities: _UNITY_png_colorspace_set_chromaticities, __ZN5physx8CCDSweepINS_2Gu4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f: __ZN5physx8CCDSweepINS_2Gu4BoxVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_12PsTransformVERKNS8_5Vec3VERKNS8_6FloatVESH_SH_RSI_RSF_SM_f, __Z50Register_UnityEngine_Texture_Internal_GetDimensionv: __Z50Register_UnityEngine_Texture_Internal_GetDimensionv, __Z47Register_UnityEngine_Animator_get_stabilizeFeetv: __Z47Register_UnityEngine_Animator_get_stabilizeFeetv, __ZN5physx16PxVehicleDriveNWC2Ev: __ZN5physx16PxVehicleDriveNWC2Ev, __ZN14SerializedFile12ReadMetadataILb0EEEbijPKhjj: __ZN14SerializedFile12ReadMetadataILb0EEEbijPKhjj, __ZN15EditorExtension7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15EditorExtension7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc21ConstraintInteractionEEEE15growAndPushBackERKS2_, __Z36CullingGroup_CUSTOM_FinalizerFailureP12Il2CppObject: __Z36CullingGroup_CUSTOM_FinalizerFailureP12Il2CppObject, __ZN6HelperI24GenerateTypeTreeTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI24GenerateTypeTreeTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, _getwc: _getwc, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1EPNS_15basic_streambufIwS2_EE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwiw: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE3getEPwiw, __GLOBAL__sub_I_runtime_dynamics2_lump_cpp: __GLOBAL__sub_I_runtime_dynamics2_lump_cpp, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimData4WEE15complexPropertyINS_22PxRepXPropertyAccessorILj665ENS_21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataES7_EEKNS_32PxVehicleClutchDataGeneratedInfoEEEvPjRKT_RT0_, __ZN4File19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN4File19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx9PxTaskMgr16setGpuDispatcherERNS_15PxGpuDispatcherE: __ZN5physx9PxTaskMgr16setGpuDispatcherERNS_15PxGpuDispatcherE, __Z28getPxConvexMeshGeometryScalePKN5physx20PxConvexMeshGeometryE: __Z28getPxConvexMeshGeometryScalePKN5physx20PxConvexMeshGeometryE, __ZN4FMOD7SystemI18getChannelsPlayingEPi: __ZN4FMOD7SystemI18getChannelsPlayingEPi, __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix4x3E: __ZN5UmbramlERKNS_7Vector3ERKNS_9Matrix4x3E, __Z45Register_UnityEngine_AudioListener_get_volumev: __Z45Register_UnityEngine_AudioListener_get_volumev, __ZN7mecanim12statemachine13StateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim12statemachine13StateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13BitSetUtility13DestroyBitSetERPjRK10MemLabelId: __ZN13BitSetUtility13DestroyBitSetERPjRK10MemLabelId, __ZN11LightProbes20SetBakedCoefficientsEPK20SphericalHarmonicsL2i: __ZN11LightProbes20SetBakedCoefficientsEPK20SphericalHarmonicsL2i, __ZN15MulticastSocket10InitializeEPKctb: __ZN15MulticastSocket10InitializeEPKctb, __Z51Register_UnityEngine_Rigidbody2D_get_sharedMaterialv: __Z51Register_UnityEngine_Rigidbody2D_get_sharedMaterialv, __ZN13ComputeShader14BeforeDispatchEj: __ZN13ComputeShader14BeforeDispatchEj, __ZN5physx15PxBroadPhaseExt28createRegionsFromWorldBoundsEPNS_9PxBounds3ERKS1_jj: __ZN5physx15PxBroadPhaseExt28createRegionsFromWorldBoundsEPNS_9PxBounds3ERKS1_jj, __ZN25b2CapsuleAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN25b2CapsuleAndCircleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED2Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKjPcEEjNS0_4HashIjEENS1_11HashMapBaseIjS5_S8_NS_8debugger19ForwardingAllocatorEE6GetKeyESB_Lb1EED2Ev, __ZN9Texture2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Texture2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z35ReflectionProbe_Set_Custom_PropModeP12Il2CppObjecti: __Z35ReflectionProbe_Set_Custom_PropModeP12Il2CppObjecti, __Z49Register_UnityEngine_ParticleRenderer_get_uvTilesv: __Z49Register_UnityEngine_ParticleRenderer_get_uvTilesv, __ZN12AudioManager16SetListenerPauseEb: __ZN12AudioManager16SetListenerPauseEb, __ZN14DirectorPlayerC2E10MemLabelId18ObjectCreationMode: __ZN14DirectorPlayerC2E10MemLabelId18ObjectCreationMode, __ZNK17ProceduralTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi: __ZNK17ProceduralTexture16ExtractImageImplEP14ImageReferenceNS0_8BlitModeEbi, __ZN5physx2Cm20visualizeJointFramesERNS0_12RenderOutputEfRKNS_11PxTransformES5_: __ZN5physx2Cm20visualizeJointFramesERNS0_12RenderOutputEfRKNS_11PxTransformES5_, __ZNK5physx2Gu11HeightField14computeExtremeEjjjj: __ZNK5physx2Gu11HeightField14computeExtremeEjjjj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv, __ZNSt3__210__time_getC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__210__time_getC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZThn12_N5physx10NpMaterial14onRefCountZeroEv: __ZThn12_N5physx10NpMaterial14onRefCountZeroEv, _getsockopt: _getsockopt, __ZNK12HandlerChain12LastModifiedERK13FileEntryData: __ZNK12HandlerChain12LastModifiedERK13FileEntryData, __Z29Transfer_Blittable_ArrayFieldI8JSONRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead4AABBEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5Unity5Cloth15ThreadedCleanupEv: __ZN5Unity5Cloth15ThreadedCleanupEv, __Z20CompareNavMeshParamsRK13NavMeshParamsS1_: __Z20CompareNavMeshParamsRK13NavMeshParamsS1_, _dup2: _dup2, __ZN37AssetBundleLoadFromFileAsyncOperation17ConvertArchiveJobEPv: __ZN37AssetBundleLoadFromFileAsyncOperation17ConvertArchiveJobEPv, __ZNK12AudioManager13GetNumDevicesEv: __ZNK12AudioManager13GetNumDevicesEv, __ZN5physx19PxcPCMContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx19PxcPCMContactBoxBoxERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, _Vertical_Sweep_Init: _Vertical_Sweep_Init, __Z26SkinnedMeshRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi: __Z26SkinnedMeshRenderer_RenderRK15RenderNodeQueuejRK14ChannelAssignsi, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_GetMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_GetMethodID13Il2Cpp_IntPtrP12Il2CppStringS1_RPv, __ZNK5physx7NpCloth14getWakeCounterEv: __ZNK5physx7NpCloth14getWakeCounterEv, __Z29getPxCloth_StiffnessFrequencyPKN5physx7PxClothE: __Z29getPxCloth_StiffnessFrequencyPKN5physx7PxClothE, __ZN18ProfilerConnection7CleanupEv: __ZN18ProfilerConnection7CleanupEv, __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_: __ZN10Effector2D8TransferI17RemapPPtrTransferEEvRT_, __ZN10GISettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10GISettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc14ConstraintCoreENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN25SingleBlockMemoryFileData6UnlockEPv: __ZN25SingleBlockMemoryFileData6UnlockEPv, __Z26ExtractProjectionNearPlaneRK10Matrix4x4fP5Plane: __Z26ExtractProjectionNearPlaneRK10Matrix4x4fP5Plane, __ZZN2UI13RectTransform15InitializeClassEvEN31FunctorImpl_65kTransformChanged4CallEPviR11MessageData: __ZZN2UI13RectTransform15InitializeClassEvEN31FunctorImpl_65kTransformChanged4CallEPviR11MessageData, __ZN18AsyncUploadManager16StaticInitializeEPv: __ZN18AsyncUploadManager16StaticInitializeEPv, __ZN5Unity14CharacterJoint8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5Unity14CharacterJoint8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4TreeD0Ev: __ZN4TreeD0Ev, __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZMultiplierv: __Z67Register_UnityEngine_ParticleSystem_NoiseModule_SetRemapZMultiplierv, __ZN30ForwardShaderRenderLoopScratchD2Ev: __ZN30ForwardShaderRenderLoopScratchD2Ev, __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb: __ZN5physx2Gu15gjkLocalRayCastINS0_9TriangleVENS0_4BoxVES2_NS0_10ShrunkBoxVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb, __ZN13GfxDeviceNull16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput: __ZN13GfxDeviceNull16CreateGpuProgramE20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput, _strerror_r: _strerror_r, __ZN13ConstantForce8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13ConstantForce8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z68Register_UnityEngine_Camera_INTERNAL_get_nonJitteredProjectionMatrixv: __Z68Register_UnityEngine_Camera_INTERNAL_get_nonJitteredProjectionMatrixv, __ZN5physx20PxsParticleSystemSim25spatialHashUpdateSectionsEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim25spatialHashUpdateSectionsEPNS_10PxBaseTaskE, __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID: __Z21profiler_begin_objectP19ProfilerInformation10ProfilerID, __ZN5physx19PxsFluidSpatialHash14getHaloRegionsERNS_25PxsFluidPacketHaloRegionsERKNS_17PxcGridCellVectorEPKNS_15PxsParticleCellEPKNS_22PxsFluidPacketSectionsEj: __ZN5physx19PxsFluidSpatialHash14getHaloRegionsERNS_25PxsFluidPacketHaloRegionsERKNS_17PxcGridCellVectorEPKNS_15PxsParticleCellEPKNS_22PxsFluidPacketSectionsEj, __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE: __Z23CollectSceneGameObjectsR13dynamic_arrayIiLj4EE, __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN20OcclusionCullingDataC2E10MemLabelId18ObjectCreationMode: __ZN20OcclusionCullingDataC2E10MemLabelId18ObjectCreationMode, __Z21AddComponentUncheckedR10GameObjectiP10MonoScriptPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE: __Z21AddComponentUncheckedR10GameObjectiP10MonoScriptPNSt3__212basic_stringIcNS3_11char_traitsIcEENS3_9allocatorIcEEEE, __ZN5physx16NpParticleSystem8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx16NpParticleSystem8requiresERNS_23PxProcessPxBaseCallbackE, __Z41Caching_Set_Custom_PropCompressionEnabledh: __Z41Caching_Set_Custom_PropCompressionEnabledh, __ZN17Physics2DSettings20IgnoreLayerCollisionEiib: __ZN17Physics2DSettings20IgnoreLayerCollisionEiib, __ZNSt3__26locale5__impC2ERKS1_S3_i: __ZNSt3__26locale5__impC2ERKS1_S3_i, __ZN5physx2Sc5Scene24getOutOfBoundsAggregatesEv: __ZN5physx2Sc5Scene24getOutOfBoundsAggregatesEv, __Z17getPxJoint_ActorsPKN5physx7PxJointERPNS_12PxRigidActorES5_: __Z17getPxJoint_ActorsPKN5physx7PxJointERPNS_12PxRigidActorES5_, __ZNK12MeshCollider26GetTypeInfoVirtualInternalEv: __ZNK12MeshCollider26GetTypeInfoVirtualInternalEv, _PxGetPhysicsBinaryMetaData: _PxGetPhysicsBinaryMetaData, __ZN10GameObject22RemoveComponentAtIndexEi: __ZN10GameObject22RemoveComponentAtIndexEi, __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Projector23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z43Register_UnityEngine_TerrainData_RemoveUserv: __Z43Register_UnityEngine_TerrainData_RemoveUserv, __ZNSt3__26vectorI12WebCamDeviceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI12WebCamDeviceNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZN2UI6Canvas30SetSortingBucketNormalizedSizeEf: __ZN2UI6Canvas30SetSortingBucketNormalizedSizeEf, __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab28SerializedShaderRTBlendState8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI9OffsetPtrIN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEEEEEvRT_PKc17TransferMetaFlags, __ZN12InputManager11GetButtonUpERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN12InputManager11GetButtonUpERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE: __ZN7Terrain14SetTerrainDataERK4PPtrI11TerrainDataE, __ZN27UnloadUnusedAssetsOperation19IntegrateMainThreadEv: __ZN27UnloadUnusedAssetsOperation19IntegrateMainThreadEv, __ZN7mecanim5human17ReachGoalRotationEPKNS0_5HumanERKN4math7_float4EiPNS_8skeleton13SkeletonPoseTINS4_4trsXEEESC_SC_: __ZN7mecanim5human17ReachGoalRotationEPKNS0_5HumanERKN4math7_float4EiPNS_8skeleton13SkeletonPoseTINS4_4trsXEEESC_SC_, __ZN5physx9NpFactory13registerClothEv: __ZN5physx9NpFactory13registerClothEv, __Z51Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorRotationP12Il2CppObjectP11Quaternionf: __Z51Rigidbody_CUSTOM_INTERNAL_get_inertiaTensorRotationP12Il2CppObjectP11Quaternionf, __ZNSt3__218__insertion_sort_3IRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_, __ZN4FMOD7Channel15setChannelGroupEPNS_12ChannelGroupE: __ZN4FMOD7Channel15setChannelGroupEPNS_12ChannelGroupE, __Z43Camera_CUSTOM_INTERNAL_set_projectionMatrixP12Il2CppObjectRK10Matrix4x4f: __Z43Camera_CUSTOM_INTERNAL_set_projectionMatrixP12Il2CppObjectRK10Matrix4x4f, __Z41Register_UnityEngine_Motion_get_isLoopingv: __Z41Register_UnityEngine_Motion_get_isLoopingv, __ZN10Matrix3x3f11SetIdentityEv: __ZN10Matrix3x3f11SetIdentityEv, __ZN20OverlapCircleQuery2DD0Ev: __ZN20OverlapCircleQuery2DD0Ev, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19getInvInertiaScale1Ev, __Z44Register_UnityEngine_AudioSource_PlayDelayedv: __Z44Register_UnityEngine_AudioSource_PlayDelayedv, __Z33RenderSettings_Get_Custom_PropSunv: __Z33RenderSettings_Get_Custom_PropSunv, __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier: __Z43InstanceIDToLocalSerializedObjectIdentifieriR31LocalSerializedObjectIdentifier, _tt_cmap6_char_next: _tt_cmap6_char_next, __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_: __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E15insert_noresizeERKS5_, __Z26setPxScene_SolverBatchSizePN5physx7PxSceneEj: __Z26setPxScene_SolverBatchSizePN5physx7PxSceneEj, __Z48Register_UnityEngine_SparseTexture_get_tileWidthv: __Z48Register_UnityEngine_SparseTexture_get_tileWidthv, __Z60Register_UnityEngine_GUIUtility_SetDidGUIWindowsEatLastEventv: __Z60Register_UnityEngine_GUIUtility_SetDidGUIWindowsEatLastEventv, __ZN5physx15NpActorTemplateINS_7PxClothEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_7PxClothEE15exportExtraDataERNS_22PxSerializationContextE, __Z42ParticleEmitter_Get_Custom_PropMaxEmissionP12Il2CppObject: __Z42ParticleEmitter_Get_Custom_PropMaxEmissionP12Il2CppObject, __ZN12HandlerChain5CloseER13FileEntryData: __ZN12HandlerChain5CloseER13FileEntryData, _index: _index, __Z68Register_UnityEngine_RenderTexture_INTERNAL_CALL_MarkRestoreExpectedv: __Z68Register_UnityEngine_RenderTexture_INTERNAL_CALL_MarkRestoreExpectedv, __Z29StdTemplateConversionFunctionItiEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionItiEbPvR14SafeBinaryRead, __ZN5physx21PxcArticulationHelper30computeUnconstrainedVelocitiesERKNS_25PxcArticulationSolverDescEfRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescERjRNS_2Cm13EventProfilerERNS_25PxsConstraintBlockManagerE: __ZN5physx21PxcArticulationHelper30computeUnconstrainedVelocitiesERKNS_25PxcArticulationSolverDescEfRNS_24PxcConstraintBlockStreamEPNS_23PxcSolverConstraintDescERjRNS_2Cm13EventProfilerERNS_25PxsConstraintBlockManagerE, __ZN2UI13RectTransformD0Ev: __ZN2UI13RectTransformD0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEE6__initEPKcj, __Z58Register_UnityEngine_Rendering_CommandBuffer_ReleaseBufferv: __Z58Register_UnityEngine_Rendering_CommandBuffer_ReleaseBufferv, __ZNK6Avatar6GetTOSEv: __ZNK6Avatar6GetTOSEv, __ZN15SkyboxGenerator18GetCubemapSkyboxVBEv: __ZN15SkyboxGenerator18GetCubemapSkyboxVBEv, __Z34Material_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray: __Z34Material_CUSTOM_SetMatrixArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN7Striper11FreeUsedRamEv: __ZN7Striper11FreeUsedRamEv, __Z46OffMeshLink_Set_Custom_PropAutoUpdatePositionsP12Il2CppObjecth: __Z46OffMeshLink_Set_Custom_PropAutoUpdatePositionsP12Il2CppObjecth, __ZN10EventEntry12CanBeInvokedEv: __ZN10EventEntry12CanBeInvokedEv, __ZN6Object11InvokeEventEi: __ZN6Object11InvokeEventEi, __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_: __ZNSt3__27__sort4IR12GreaterLayerPP14AnimationStateEEjT0_S6_S6_S6_T_, __ZN5physx6shdfnd5ArrayIPNS_12NpBatchQueryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_12NpBatchQueryENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z44Register_UnityEngine_Animator_set_updateModev: __Z44Register_UnityEngine_Animator_set_updateModev, __Z53Register_UnityEngine_AI_NavMeshAgent_get_accelerationv: __Z53Register_UnityEngine_AI_NavMeshAgent_get_accelerationv, __Z38setPxSceneDescCcdContactModifyCallbackPN5physx11PxSceneDescEPNS_26PxCCDContactModifyCallbackE: __Z38setPxSceneDescCcdContactModifyCallbackPN5physx11PxSceneDescEPNS_26PxCCDContactModifyCallbackE, __ZN10MeshFilter20AssignMeshToRendererEv: __ZN10MeshFilter20AssignMeshToRendererEv, __ZN9Rigidbody11SetVelocityERK8Vector3f: __ZN9Rigidbody11SetVelocityERK8Vector3f, __ZL17ProgramUniform3fvPK7ApiGLESjiihPKv: __ZL17ProgramUniform3fvPK7ApiGLESjiihPKv, __ZL24CalculateDistanceIndicesR16CullingGroupDataR10BlockRangeR20CullingGroupsJobData: __ZL24CalculateDistanceIndicesR16CullingGroupDataR10BlockRangeR20CullingGroupsJobData, __ZN7mecanim9animation14WeightForIndexEPKfjjf: __ZN7mecanim9animation14WeightForIndexEPKfjjf, __Z61Register_UnityEngine_TerrainData_INTERNAL_get_wavingGrassTintv: __Z61Register_UnityEngine_TerrainData_INTERNAL_get_wavingGrassTintv, __ZN24MeshIntermediateRenderer14OnAssetDeletedEv: __ZN24MeshIntermediateRenderer14OnAssetDeletedEv, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE7getNameEv, __ZNK17ArchiveFileSystem12GetLocalPathEPKc: __ZNK17ArchiveFileSystem12GetLocalPathEPKc, __ZNK5physx19ActorAABBUpdateTask7getNameEv: __ZNK5physx19ActorAABBUpdateTask7getNameEv, __ZN5physx16PxVehicleDrive4W17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx16PxVehicleDrive4W17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN17PackedFloatVector12UnpackFloatsEPfiiii: __ZN17PackedFloatVector12UnpackFloatsEPfiiii, __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_: __ZN7mecanim8skeleton26SkeletonPoseComputeGlobalQEPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIN4math4trsXEEEPS7_, __ZN8RendererD2Ev: __ZN8RendererD2Ev, __ZN13TranslateGLES30InitRenderTextureFormat2FormatERK12GraphicsCaps: __ZN13TranslateGLES30InitRenderTextureFormat2FormatERK12GraphicsCaps, __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead: __ZN24EllipsoidParticleEmitter23VirtualRedirectTransferER14SafeBinaryRead, _tre_ast_new_iter: _tre_ast_new_iter, __Z33ResetWheelQueriesTouchingColliderP8Collider: __Z33ResetWheelQueriesTouchingColliderP8Collider, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __Z28PlayerPrefs_CUSTOM_DeleteKeyP12Il2CppString: __Z28PlayerPrefs_CUSTOM_DeleteKeyP12Il2CppString, __Z14GetDynamicsSDKv: __Z14GetDynamicsSDKv, __ZN5physx2Sc5Scene19getActiveTransformsERjh: __ZN5physx2Sc5Scene19getActiveTransformsERjh, __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_: __ZNK5Umbra11Transformer21computeActivePlaneSetERNS_14ActivePlaneSetEPKS1_NS_12SIMDRegisterES5_, __ZN8VRDevice39UpdateTrackedDevicesAndCameraTransformsEv: __ZN8VRDevice39UpdateTrackedDevicesAndCameraTransformsEv, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE28getMassSpaceInvInertiaTensorEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE28getMassSpaceInvInertiaTensorEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__initEjc, __ZNK14PreloadManager19GetTimeSliceTimeoutEv: __ZNK14PreloadManager19GetTimeSliceTimeoutEv, __Z35AnimationClip_Get_Custom_PropLengthP12Il2CppObject: __Z35AnimationClip_Get_Custom_PropLengthP12Il2CppObject, __Z46Register_UnityEngine_Rigidbody2D_set_simulatedv: __Z46Register_UnityEngine_Rigidbody2D_set_simulatedv, __Z67Register_UnityEngine_AI_NavMeshObstacle_set_carvingTimeToStationaryv: __Z67Register_UnityEngine_AI_NavMeshObstacle_set_carvingTimeToStationaryv, __ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_: __ZN5physx2Sn17readAllPropertiesINS_13PxBoxGeometryENS_26PxBoxGeometryGeneratedInfoEEEbNS_23PxRepXInstantiationArgsERNS_7profile12ProfileArrayINS0_20ReaderNameStackEntryEEERNS6_IjEERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionERT0_, __ZN9AudioClip10InitStreamEP10IWWWStreamPKcP13MoviePlaybackbb15FMOD_SOUND_TYPE: __ZN9AudioClip10InitStreamEP10IWWWStreamPKcP13MoviePlaybackbb15FMOD_SOUND_TYPE, __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf: __ZN5physx14PxVehicleGraph15updateTimeSliceEPKf, __Z61ParticleSystem_MainModule_CUSTOM_GetGravityModifierMultiplierP12Il2CppObject: __Z61ParticleSystem_MainModule_CUSTOM_GetGravityModifierMultiplierP12Il2CppObject, __ZNSt3__24stoiERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji: __ZNSt3__24stoiERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji, __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj: __ZNSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS2_L18MemLabelIdentifier12ELi16EEE8__appendEj, __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_: __ZNSt3__27__sort3IR24RayHitsByDepthComparitorP12RaycastHit2DEEjT0_S5_S5_T_, __Z73Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalColorv: __Z73Register_UnityEngine_Rendering_CommandBuffer_INTERNAL_CALL_SetGlobalColorv, __ZN11UnityEngine7Connect20BasePersistentValues13RestoreValuesER8JSONRead: __ZN11UnityEngine7Connect20BasePersistentValues13RestoreValuesER8JSONRead, __ZN17FileSystemHandler4LockER13FileEntryData12FileLockMode: __ZN17FileSystemHandler4LockER13FileEntryData12FileLockMode, __ZN2UI6Canvas23VirtualRedirectTransferER14SafeBinaryRead: __ZN2UI6Canvas23VirtualRedirectTransferER14SafeBinaryRead, _UNITY_png_destroy_png_struct: _UNITY_png_destroy_png_struct, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj576ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj576ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__23mapIjP25SubstanceRawTextureSharedNS_4lessIjEE13stl_allocatorINS_4pairIKjS2_EEL18MemLabelIdentifier77ELi16EEEixERS7_: __ZNSt3__23mapIjP25SubstanceRawTextureSharedNS_4lessIjEE13stl_allocatorINS_4pairIKjS2_EEL18MemLabelIdentifier77ELi16EEEixERS7_, __ZN5physxL18testPolyEdgeNormalERKNS_2Gu9TriangleVEhRKNS0_15HullPolygonDataERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSH_RNSG_5Vec3VENS0_13FeatureStatusERSN_: __ZN5physxL18testPolyEdgeNormalERKNS_2Gu9TriangleVEhRKNS0_15HullPolygonDataERKNS0_13PolygonalDataEPNS0_16SupportLocalImplIS1_EEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERSH_RNSG_5Vec3VENS0_13FeatureStatusERSN_, __ZN5Unity5Joint7SetAxisERK8Vector3f: __ZN5Unity5Joint7SetAxisERK8Vector3f, __Z15GetPositionMeshIL20MeshDistributionMode0ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo: __Z15GetPositionMeshIL20MeshDistributionMode0ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo, __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playable: __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playable, __ZNK22ParticleSystemRenderer20PrepareForMeshRenderER26ParticleSystemTempMeshDataR14ParticleSystem: __ZNK22ParticleSystemRenderer20PrepareForMeshRenderER26ParticleSystemTempMeshDataR14ParticleSystem, __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st: __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_PvP11CUstream_st, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEEEvRT_17TransferMetaFlags, __ZN4FMOD5Sound13setVariationsEfff: __ZN4FMOD5Sound13setVariationsEfff, __ZNK5physx5cloth8SwFabric12getNumPhasesEv: __ZNK5physx5cloth8SwFabric12getNumPhasesEv, __Z47Register_UnityEngine_LODGroup_RecalculateBoundsv: __Z47Register_UnityEngine_LODGroup_RecalculateBoundsv, __Z26CalculateLightScreenBoundsRK13ShadowJobDataRK15SharedLightDataP5RectTIfER13TargetEyeMask: __Z26CalculateLightScreenBoundsRK13ShadowJobDataRK15SharedLightDataP5RectTIfER13TargetEyeMask, __ZN6b2RopeD2Ev: __ZN6b2RopeD2Ev, __ZN5physx2Sc17ParticleSystemSim25visualizeCollisionNormalsERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim25visualizeCollisionNormalsERNS_2Cm12RenderOutputE, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE9getFabricEv, __Z55Register_UnityEngine_CharacterController_set_stepOffsetv: __Z55Register_UnityEngine_CharacterController_set_stepOffsetv, __Z38Shader_CUSTOM_SetGlobalMatrixArrayImpliP11Il2CppArray: __Z38Shader_CUSTOM_SetGlobalMatrixArrayImpliP11Il2CppArray, __ZN5Unity5ClothD2Ev: __ZN5Unity5ClothD2Ev, __ZN14EmissionModuleD2Ev: __ZN14EmissionModuleD2Ev, __ZN12TreeRenderer23UpdateWindAssetPointersEv: __ZN12TreeRenderer23UpdateWindAssetPointersEv, __ZN22NavMeshProjectSettings16CheckConsistencyEv: __ZN22NavMeshProjectSettings16CheckConsistencyEv, __ZN4FMOD6SoundI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS: __ZN4FMOD6SoundI13getMemoryInfoEjjPjP25FMOD_MEMORY_USAGE_DETAILS, __ZN19ShaderPropertySheet31SetTextureScaleAndOffsetIndexedERKN9ShaderLab16FastPropertyNameEif: __ZN19ShaderPropertySheet31SetTextureScaleAndOffsetIndexedERKN9ShaderLab16FastPropertyNameEif, __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastAllv: __Z59Register_UnityEngine_Physics2D_INTERNAL_CALL_CapsuleCastAllv, __ZN4Mesh9SetColorsEPK10ColorRGBAfj: __ZN4Mesh9SetColorsEPK10ColorRGBAfj, __ZN12b2ChainShape13SetNextVertexERK6b2Vec2: __ZN12b2ChainShape13SetNextVertexERK6b2Vec2, __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEEEEjT_j: __ZNK5physx35PxTriangleMeshGeometryGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxTriangleMeshGeometryEEEEEEEjT_j, __ZN27NoiseModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN27NoiseModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN13GfxDeviceNull20SetRenderTargetsImplERK20GfxRenderTargetSetup: __ZN13GfxDeviceNull20SetRenderTargetsImplERK20GfxRenderTargetSetup, __Z23ConvertImageToDoubleLDRR14ImageReference: __Z23ConvertImageToDoubleLDRR14ImageReference, __ZN15AudioMixerGroup23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15AudioMixerGroup23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4rendEv, __Z54SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByBuildIndexiRi: __Z54SceneManager_CUSTOM_INTERNAL_CALL_GetSceneByBuildIndexiRi, _cf2_getLanguageGroup: _cf2_getLanguageGroup, __Z25SplashScreen_CUSTOM_Beginv: __Z25SplashScreen_CUSTOM_Beginv, __Z17pqDeletePriorityQP9TESSallocP9PriorityQ: __Z17pqDeletePriorityQP9TESSallocP9PriorityQ, __Z11MurmurHash2PKvij: __Z11MurmurHash2PKvij, __ZN9Transform25CompleteTransformTransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Transform25CompleteTransformTransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z36GeneratePolygonOutlineVerticesOfSizeiR13dynamic_arrayI8Vector2fLj4EEii: __Z36GeneratePolygonOutlineVerticesOfSizeiR13dynamic_arrayI8Vector2fLj4EEii, __ZN5Umbra9intersectERKNS_6SphereERKNS_8TriangleE: __ZN5Umbra9intersectERKNS_6SphereERKNS_8TriangleE, __ZN4FMOD5Sound11getSubSoundEiPPS0_: __ZN4FMOD5Sound11getSubSoundEiPPS0_, __Z60Register_UnityEngine_ComputeShader_GetKernelThreadGroupSizesv: __Z60Register_UnityEngine_ComputeShader_GetKernelThreadGroupSizesv, _unity_z_inflateEnd: _unity_z_inflateEnd, ___madvise: ___madvise, __ZN14PhysicMaterial13AwakeFromLoadE17AwakeFromLoadMode: __ZN14PhysicMaterial13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx13GuMeshFactory18createTriangleMeshERNS_13PxInputStreamE: __ZN5physx13GuMeshFactory18createTriangleMeshERNS_13PxInputStreamE, __ZN14StackAllocator18FreeAllAllocationsEv: __ZN14StackAllocator18FreeAllAllocationsEv, __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE: __ZN5physx6shdfnd5ArrayINS_5cloth11PhaseConfigENS0_9AllocatorEE4copyIS4_EEvRKNS1_IS3_T_EE, __ZN7Texture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN7Texture23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14SubstanceValue8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14SubstanceValue8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Unity11SpringJoint16CheckConsistencyEv: __ZN5Unity11SpringJoint16CheckConsistencyEv, __ZN14PhysicsManager15IgnoreCollisionER8ColliderS1_b: __ZN14PhysicsManager15IgnoreCollisionER8ColliderS1_b, __Z40Input_Get_Custom_PropBackButtonLeavesAppv: __Z40Input_Get_Custom_PropBackButtonLeavesAppv, __ZN11TerrainDataC2E10MemLabelId18ObjectCreationMode: __ZN11TerrainDataC2E10MemLabelId18ObjectCreationMode, __ZN5physx3Scb5Scene22removeBroadPhaseRegionEj: __ZN5physx3Scb5Scene22removeBroadPhaseRegionEj, __ZN5physx36PxVehicleDriveSimDataGeneratedValuesC2EPKNS_21PxVehicleDriveSimDataE: __ZN5physx36PxVehicleDriveSimDataGeneratedValuesC2EPKNS_21PxVehicleDriveSimDataE, __ZNK12NavMeshAgent15IsOnOffMeshLinkEv: __ZNK12NavMeshAgent15IsOnOffMeshLinkEv, __Z16SmartResetObjectR6Object: __Z16SmartResetObjectR6Object, __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToWorldPointv: __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToWorldPointv, __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE: __ZN5physx3Ext5joint16ConstraintHelper16quarterAnglePairEffffRKNS_6PxVec3ERKNS_22PxJointLimitParametersE, __ZN11OffMeshLink5ResetEv: __ZN11OffMeshLink5ResetEv, __ZN15b2RevoluteJoint11EnableLimitEb: __ZN15b2RevoluteJoint11EnableLimitEb, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE28isContinuousCollisionEnabledEv, _tt_cmap8_char_next: _tt_cmap8_char_next, __ZN5physx9NpFactory8addClothEPNS_7PxClothEb: __ZN5physx9NpFactory8addClothEPNS_7PxClothEb, __Z50ConfigurableJoint_Get_Custom_PropRotationDriveModeP12Il2CppObject: __Z50ConfigurableJoint_Get_Custom_PropRotationDriveModeP12Il2CppObject, __ZN5Umbra12RegionFinderD2Ev: __ZN5Umbra12RegionFinderD2Ev, __Z26Mesh_CUSTOM_GetIndicesImplP12Il2CppObjecti: __Z26Mesh_CUSTOM_GetIndicesImplP12Il2CppObjecti, __ZN8Animator8SetFloatEif: __ZN8Animator8SetFloatEif, __ZN5physx9NpFactory18releaseShapeToPoolERNS_7NpShapeE: __ZN5physx9NpFactory18releaseShapeToPoolERNS_7NpShapeE, __ZN5physx21PxcUnimplementedSweepERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf: __ZN5physx21PxcUnimplementedSweepERKNS_11PxsCCDShapeES2_PKNS_12PxsRigidBodyES5_RKNS_11PxTransformES8_S8_S8_fRNS_6PxVec3ESA_RNS_10PxcNpCacheERNS_18PxcNpThreadContextEf, __ZN10MeshFilter13AwakeFromLoadE17AwakeFromLoadMode: __ZN10MeshFilter13AwakeFromLoadE17AwakeFromLoadMode, __ZL25CleanupUIScriptingClassesv: __ZL25CleanupUIScriptingClassesv, __Z38AndroidJNI_CUSTOM_SetShortArrayElement13Il2Cpp_IntPtris: __Z38AndroidJNI_CUSTOM_SetShortArrayElement13Il2Cpp_IntPtris, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN21ProceduralTextureData12CopyFromDataERKS_: __ZN21ProceduralTextureData12CopyFromDataERKS_, __ZN10Collider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10Collider2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN2UI14CanvasRenderer18OnTransformChangedEi: __ZN2UI14CanvasRenderer18OnTransformChangedEi, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRPv: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_RNS_8ios_baseERjRPv, __ZN18AudioLowPassFilter18SetCutoffFrequencyEf: __ZN18AudioLowPassFilter18SetCutoffFrequencyEf, __ZN5physx11PxHitBufferINS_10PxSweepHitEED0Ev: __ZN5physx11PxHitBufferINS_10PxSweepHitEED0Ev, __Z44getPxRevoluteJoint_ProjectionLinearTolerancePKN5physx15PxRevoluteJointE: __Z44getPxRevoluteJoint_ProjectionLinearTolerancePKN5physx15PxRevoluteJointE, __ZL16CompareCarveDataRK16NavMeshCarveDataS1_: __ZL16CompareCarveDataRK16NavMeshCarveDataS1_, __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_: __ZN12_GLOBAL__N_134classifyConstraintWithArticulationERKN5physx23PxcSolverConstraintDescEPKNS0_13PxcSolverBodyEjPjjRjS8_RbS9_, __ZNK5Umbra18ReceiverMaskBuffer9getHeightEv: __ZNK5Umbra18ReceiverMaskBuffer9getHeightEv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceIPKcEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE7replaceIPKcEENS_9enable_ifIXsr19__is_input_iteratorIT_EE5valueERS5_E4typeENS_11__wrap_iterIS8_EESF_SA_SA_, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, _cf2_glyphpath_lineTo: _cf2_glyphpath_lineTo, __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericIntegerToFloatI17TexFormatARGB888815TexFormatRFloatEEvPKNS_9InnerInfoE, __ZN19RuntimeSceneManager17DontDestroyOnLoadER6Object: __ZN19RuntimeSceneManager17DontDestroyOnLoadER6Object, __Z44ParticleSystem_MainModule_CUSTOM_SetDurationP12Il2CppObjectf: __Z44ParticleSystem_MainModule_CUSTOM_SetDurationP12Il2CppObjectf, __ZN15NavMeshObstacle9SetCenterERK8Vector3f: __ZN15NavMeshObstacle9SetCenterERK8Vector3f, __Z26Texture2D_CUSTOM_GetPixelsP12Il2CppObjectiiiii: __Z26Texture2D_CUSTOM_GetPixelsP12Il2CppObjectiiiii, __Z34Register_UnityEngine_Sprite_get_uvv: __Z34Register_UnityEngine_Sprite_get_uvv, __ZN11UnityEngine7Connect15AppInstallEventC2Ev: __ZN11UnityEngine7Connect15AppInstallEventC2Ev, __Z45Register_UnityEngine_WWW_GetAudioClipInternalv: __Z45Register_UnityEngine_WWW_GetAudioClipInternalv, __ZN8Animator12SetFloatDampEifff: __ZN8Animator12SetFloatDampEifff, __ZNK9HaloLayer26GetTypeInfoVirtualInternalEv: __ZNK9HaloLayer26GetTypeInfoVirtualInternalEv, __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig8TransferI8JSONReadEEvRT_: __ZN11UnityEngine7Connect13ConnectConfig13SessionConfig8TransferI8JSONReadEEvRT_, __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiPNS_9AllocatorEPKS0_: __ZN5Umbra14TomeCollection5buildEPPKNS_4TomeEiPNS_9AllocatorEPKS0_, __Z41getPxArticulation_InternalDriveIterationsPKN5physx14PxArticulationE: __Z41getPxArticulation_InternalDriveIterationsPKN5physx14PxArticulationE, __Z48Register_UnityEngine_WheelJoint2D_get_jointSpeedv: __Z48Register_UnityEngine_WheelJoint2D_get_jointSpeedv, __ZN9ShaderLab22SerializedBindChannelsC2Ev: __ZN9ShaderLab22SerializedBindChannelsC2Ev, __Z68AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorClipInfoInternalR9HPlayablei: __Z68AnimatorControllerPlayable_CUSTOM_GetCurrentAnimatorClipInfoInternalR9HPlayablei, __Z38Register_UnityEngine_TextMesh_get_textv: __Z38Register_UnityEngine_TextMesh_get_textv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN13MonoBehaviour18GetScriptClassNameEv: __ZN13MonoBehaviour18GetScriptClassNameEv, __Z10WriteArrayIN12ProfilerData17AllocatedGCMemoryEEvR13dynamic_arrayIiLj4EERKS2_IT_Xsr11AlignOfTypeIS5_EE5alignEE: __Z10WriteArrayIN12ProfilerData17AllocatedGCMemoryEEvR13dynamic_arrayIiLj4EERKS2_IT_Xsr11AlignOfTypeIS5_EE5alignEE, __ZN9HaloLayer17RemoveFromManagerEv: __ZN9HaloLayer17RemoveFromManagerEv, _getmntent: _getmntent, _longest_match: _longest_match, __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_FlushEventsv: __Z64Register_UnityEngine_Analytics_UnityAnalyticsHandler_FlushEventsv, __ZL21NavMeshGarbageCollectR27GarbageCollectorThreadState: __ZL21NavMeshGarbageCollectR27GarbageCollectorThreadState, __Z53Register_UnityEngine_SurfaceEffector2D_get_forceScalev: __Z53Register_UnityEngine_SurfaceEffector2D_get_forceScalev, __ZN5physx7PxJoint17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx7PxJoint17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN25RuntimeAnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN25RuntimeAnimatorController7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5Umbra4HashIiiE6rehashEj: __ZN5Umbra4HashIiiE6rehashEj, __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv: __ZNK17AnimationCurveTplI8Vector3fE8GetRangeEv, __ZN13TrailRenderer15ThreadedCleanupEv: __ZN13TrailRenderer15ThreadedCleanupEv, __Z60Register_UnityEngine_GUIStyle_Internal_DrawWithTextSelectionv: __Z60Register_UnityEngine_GUIStyle_Internal_DrawWithTextSelectionv, __ZN5physx18PxsSolverStartTask16articulationTaskEv: __ZN5physx18PxsSolverStartTask16articulationTaskEv, __ZN11UmbraModule11GetTomeSizeEPKN5Umbra4TomeE: __ZN11UmbraModule11GetTomeSizeEPKN5Umbra4TomeE, _UNITY_FT_Outline_Translate: _UNITY_FT_Outline_Translate, __ZN17CapsuleCollider2D7SetSizeERK8Vector2f: __ZN17CapsuleCollider2D7SetSizeERK8Vector2f, __ZN5physx2Sc19ShapeInstancePairLL12onDeactivateEj: __ZN5physx2Sc19ShapeInstancePairLL12onDeactivateEj, __ZN9ShaderLab14SerializedPassaSERKS0_: __ZN9ShaderLab14SerializedPassaSERKS0_, __Z50Register_UnityEngine_AudioSettings_get_speakerModev: __Z50Register_UnityEngine_AudioSettings_get_speakerModev, __Z67Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoProjectionMatrixv: __Z67Register_UnityEngine_Camera_INTERNAL_CALL_GetStereoProjectionMatrixv, __Z70Register_UnityEngine_Renderer_INTERNAL_get_realtimeLightmapScaleOffsetv: __Z70Register_UnityEngine_Renderer_INTERNAL_get_realtimeLightmapScaleOffsetv, __Z46setPxPrismaticJoint_ProjectionAngularTolerancePN5physx16PxPrismaticJointEf: __Z46setPxPrismaticJoint_ProjectionAngularTolerancePN5physx16PxPrismaticJointEf, __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10Matrix3x4f8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4crnd10dxt5_block17get_block_values6EPNS_10color_quadIhiEEjj: __ZN4crnd10dxt5_block17get_block_values6EPNS_10color_quadIhiEEjj, __ZN5physx22PxD6JointGeneratedInfoC2Ev: __ZN5physx22PxD6JointGeneratedInfoC2Ev, __Z40setPxVehicleDriveDynDataMGearDownPressedPN5physx21PxVehicleDriveDynDataEb: __Z40setPxVehicleDriveDynDataMGearDownPressedPN5physx21PxVehicleDriveDynDataEb, __ZNK18DownloadHandlerVFS11GetProgressEv: __ZNK18DownloadHandlerVFS11GetProgressEv, __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi: __ZN18StreamedBinaryReadILb0EE10ReadDirectEPvi, __ZNK9GfxDevice26HasActiveRandomWriteTargetEv: __ZNK9GfxDevice26HasActiveRandomWriteTargetEv, __Z63AnimatorControllerPlayable_CUSTOM_GetAnimatorControllerInternalR9HPlayable: __Z63AnimatorControllerPlayable_CUSTOM_GetAnimatorControllerInternalR9HPlayable, __Z37Animation_CUSTOM_INTERNAL_CALL_SampleP12Il2CppObject: __Z37Animation_CUSTOM_INTERNAL_CALL_SampleP12Il2CppObject, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEvPT_jRKT0_RKT1_j, __Z26Light_Get_Custom_PropFlareP12Il2CppObject: __Z26Light_Get_Custom_PropFlareP12Il2CppObject, __Z20SplatPrototypeToMonoRK14SplatPrototypeR18MonoSplatPrototype: __Z20SplatPrototypeToMonoRK14SplatPrototypeR18MonoSplatPrototype, __Z41Physics_Set_Custom_PropQueriesHitTriggersh: __Z41Physics_Set_Custom_PropQueriesHitTriggersh, __ZN17AnimationPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE: __ZN17AnimationPlayable22PrepareAnimationEventsEfR13dynamic_arrayI22AnimationClipEventInfoLj4EE, _scanf: _scanf, __ZNK9Rigidbody16GetInertiaTensorEv: __ZNK9Rigidbody16GetInertiaTensorEv, __Z15IsGyroAvailablev: __Z15IsGyroAvailablev, __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim13ValueConstantEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_: __Z17TransferOffsetPtrI9OffsetPtrIN7mecanim13ValueConstantEE24GenerateTypeTreeTransferEvRT_PKcRjRT0_, __ZN5physx19processDigitalValueEjRKNS_25PxVehicleKeySmoothingDataEbff: __ZN5physx19processDigitalValueEjRKNS_25PxVehicleKeySmoothingDataEbff, __Z49Register_UnityEngine_Light_set_shadowSoftnessFadev: __Z49Register_UnityEngine_Light_set_shadowSoftnessFadev, __ZN4crnd27crnd_unpack_level_segmentedEPvPKvjPS0_jjj: __ZN4crnd27crnd_unpack_level_segmentedEPvPKvjPS0_jjj, __ZN10ScSceneFnsIN5physx3Scb4BodyEE6insertERNS0_2Sc5SceneERS2_: __ZN10ScSceneFnsIN5physx3Scb4BodyEE6insertERNS0_2Sc5SceneERS2_, __ZN13WheelCollider10DeactivateE19DeactivateOperation: __ZN13WheelCollider10DeactivateE19DeactivateOperation, __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI14SoftJointLimitE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN9Animation12AddToManagerEv: __ZN9Animation12AddToManagerEv, __ZNK13SparseTexture20GetStorageMemorySizeEv: __ZNK13SparseTexture20GetStorageMemorySizeEv, __ZN5physx18RepXSerializerImplINS_9PxD6JointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_9PxD6JointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE7reserveEj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags, __ZN7ApiGLES24CommitSparseTexturePagesEj16TextureDimensioniiiiiiih: __ZN7ApiGLES24CommitSparseTexturePagesEj16TextureDimensioniiiiiiih, _isxdigit_l: _isxdigit_l, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS_7profile21WrapperNamedAllocatorEE6GetKeyESC_Lb1EE6createERS6_Rb, __Z49CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalColorP12Il2CppObjectiRK10ColorRGBAf: __Z49CommandBuffer_CUSTOM_INTERNAL_CALL_SetGlobalColorP12Il2CppObjectiRK10ColorRGBAf, __Z50Register_UnityEngine_Collider2D_get_sharedMaterialv: __Z50Register_UnityEngine_Collider2D_get_sharedMaterialv, __Z24RegisterStrippedTypeInfoI7TerrainEviPKcS2_: __Z24RegisterStrippedTypeInfoI7TerrainEviPKcS2_, __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN17AudioChorusFilter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z39setPxScene_ClothInterCollisionStiffnessPN5physx7PxSceneEf: __Z39setPxScene_ClothInterCollisionStiffnessPN5physx7PxSceneEf, __ZN4FMOD7Channel19set3DMinMaxDistanceEff: __ZN4FMOD7Channel19set3DMinMaxDistanceEff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj587ENS_22PxRepXPropertyAccessorILj587ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj587ENS_22PxRepXPropertyAccessorILj587ES4_ffEEEEvRKT0_, __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI8Gradient13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEEEEvRT_j, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindERKS5_j: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5rfindERKS5_j, __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI18ComputeShaderParamNS0_9allocatorIS2_EEEEEvRT_j, __ZL25GeomMTDCallback_SphereBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL25GeomMTDCallback_SphereBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __Z57ConfigurableJoint_CUSTOM_INTERNAL_set_angularXLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring: __Z57ConfigurableJoint_CUSTOM_INTERNAL_set_angularXLimitSpringP12Il2CppObjectRK20SoftJointLimitSpring, _UNITY_LZ4_decompress_safe_usingDict: _UNITY_LZ4_decompress_safe_usingDict, __ZN13GfxDeviceGLES29GetNativeComputeBufferPointerE15ComputeBufferID: __ZN13GfxDeviceGLES29GetNativeComputeBufferPointerE15ComputeBufferID, _feupdateenv: _feupdateenv, __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode3EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf: __Z19UpdateWholeSheetTplIL27ParticleSystemCurveEvalMode3EEvfRK11MinMaxCurveS3_RK23ParticleSystemParticlesPf, __ZN18AsyncUploadManager15DoDeCruncherJobEP28FileTextureUploadInstruction: __ZN18AsyncUploadManager15DoDeCruncherJobEP28FileTextureUploadInstruction, __ZN5physx2Cm17FreeListAllocator18unlinkFromFreeListEPNS0_5ChunkE: __ZN5physx2Cm17FreeListAllocator18unlinkFromFreeListEPNS0_5ChunkE, __ZN14PhysicMaterialD0Ev: __ZN14PhysicMaterialD0Ev, ___p1evll: ___p1evll, __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_GetTriggerParticlesv: __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_GetTriggerParticlesv, __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN21ArchiveStorageCreator18AppendDataFromFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_N20ArchiveStorageHeader9NodeFlagsE: __ZN21ArchiveStorageCreator18AppendDataFromFileERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_N20ArchiveStorageHeader9NodeFlagsE, __ZNK5physx23PxVehicleDriveSimDataNW7isValidEv: __ZNK5physx23PxVehicleDriveSimDataNW7isValidEv, __Z47Register_UnityEngine_AudioSource_GetCustomCurvev: __Z47Register_UnityEngine_AudioSource_GetCustomCurvev, __ZN5physx20PxsParticleSystemSim4initERNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterE: __ZN5physx20PxsParticleSystemSim4initERNS_15PxsParticleDataERKNS_26PxvParticleSystemParameterE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __Z47Register_UnityEngine_AudioSource_SetCustomCurvev: __Z47Register_UnityEngine_AudioSource_SetCustomCurvev, __Z18ParseGfxDeviceArgsv: __Z18ParseGfxDeviceArgsv, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToObjectArrayv: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToObjectArrayv, __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxVec3E: __ZN9Rigidbody21UpdateKinematicTargetERKN5physx6PxVec3E, _lgammaf: _lgammaf, __ZNK11LightProbes14LightProbeData11GetPositionEjRPK8Vector3f: __ZNK11LightProbes14LightProbeData11GetPositionEjRPK8Vector3f, __Z39Light_Get_Custom_PropAlreadyLightmappedP12Il2CppObject: __Z39Light_Get_Custom_PropAlreadyLightmappedP12Il2CppObject, _lgammal: _lgammal, __Z26getPxJointLinearLimitValuePKN5physx18PxJointLinearLimitE: __Z26getPxJointLinearLimitValuePKN5physx18PxJointLinearLimitE, __Z48Register_UnityEngine_Camera_get_stereoSeparationv: __Z48Register_UnityEngine_Camera_get_stereoSeparationv, __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_: __ZN5physx2Cm10OwnedArrayIPNS_2Sc11InteractionENS2_5ActorEjXadL_ZNS5_19reallocInteractionsERPS4_RjjjEEE8pushBackERS4_RS5_, __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEb: __ZNK5physx20BigConvexDataBuilder4SaveERNS_14PxOutputStreamEb, __ZN6SocketC2Eiii: __ZN6SocketC2Eiii, __ZN16ReflectionProbes28GetMaxBakedCubemapResolutionEv: __ZN16ReflectionProbes28GetMaxBakedCubemapResolutionEv, __ZN5physx2Sc7BodySim12onDeactivateEv: __ZN5physx2Sc7BodySim12onDeactivateEv, __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15AudioMixerGroup8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_18NpArticulationLinkENS0_19ReflectionAllocatorIS2_EEE12allocateSlabEv, __ZN5physx12NpBatchQuery17checkForSPUErrorsEv: __ZN5physx12NpBatchQuery17checkForSPUErrorsEv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z32GUI_CUSTOM_INTERNAL_CALL_DoLabelRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr: __Z32GUI_CUSTOM_INTERNAL_CALL_DoLabelRK5RectTIfEP12Il2CppObject13Il2Cpp_IntPtr, __Z47Register_UnityEngine_Light_get_shadowResolutionv: __Z47Register_UnityEngine_Light_get_shadowResolutionv, __Z49Physics2D_CUSTOM_INTERNAL_get_colliderAsleepColorP10ColorRGBAf: __Z49Physics2D_CUSTOM_INTERNAL_get_colliderAsleepColorP10ColorRGBAf, _access: _access, __Z18Transfer_BlittableI8JSONReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z45UnityAnalyticsHandler_CUSTOM_SetUserBirthYearP12Il2CppObjecti: __Z45UnityAnalyticsHandler_CUSTOM_SetUserBirthYearP12Il2CppObjecti, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ejw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2Ejw, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIaLj1EEEEvRT_17TransferMetaFlags, __Z22RegisterModule_Physicsv: __Z22RegisterModule_Physicsv, __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE9getShapesEPPNS_7PxShapeEjj: __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE9getShapesEPPNS_7PxShapeEjj, __ZN17CapsuleCollider2DD2Ev: __ZN17CapsuleCollider2DD2Ev, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE13TryDeallocateEPv, __ZN9Scripting32SetScriptingArrayTypeElementImplEP11Il2CppArrayiP12Il2CppObject: __ZN9Scripting32SetScriptingArrayTypeElementImplEP11Il2CppArrayiP12Il2CppObject, __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS1_4lessIjEENS1_9allocatorINS1_4pairIKjS3_EEEEEEEEvRT_17TransferMetaFlags, __Z54Register_UnityEngine_Terrain_set_realtimeLightmapIndexv: __Z54Register_UnityEngine_Terrain_set_realtimeLightmapIndexv, __Z45Register_UnityEngine_Animator_set_logWarningsv: __Z45Register_UnityEngine_Animator_set_logWarningsv, __ZN16LightmapSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16LightmapSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRPFbP10GUIElementS2_EPS2_EEjT0_S7_S7_S7_T_, __ZNK4Mesh26GetTypeInfoVirtualInternalEv: __ZNK4Mesh26GetTypeInfoVirtualInternalEv, __Z53Register_UnityEngine_AndroidJNI_SetStaticBooleanFieldv: __Z53Register_UnityEngine_AndroidJNI_SetStaticBooleanFieldv, __Z13RegisterClassI13MonoBehaviourEvv: __Z13RegisterClassI13MonoBehaviourEvv, __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB: __ZN26LightProbeProxyVolumeUtilsL27ComputeLocalAABBOnHierarchyERK10Matrix4x4fR9TransformR10MinMaxAABB, __ZN5physx2Gu25PersistentContactManifold20reduceContactsForPCMERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE: __ZN5physx2Gu25PersistentContactManifold20reduceContactsForPCMERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VE, __ZN5physx2Sc5Scene20finishBatchInsertionERNS0_19BatchInsertionStateE: __ZN5physx2Sc5Scene20finishBatchInsertionERNS0_19BatchInsertionStateE, __Z36LineRenderer_Get_Custom_PropEndWidthP12Il2CppObject: __Z36LineRenderer_Get_Custom_PropEndWidthP12Il2CppObject, __ZNK18ProceduralMaterial45CheckIfInputModificationIsAllowedAndWarnIfNotEv: __ZNK18ProceduralMaterial45CheckIfInputModificationIsAllowedAndWarnIfNotEv, __ZN5physx10PxsContext20removeParticleSystemEPNS_20PxvParticleSystemSimEb: __ZN5physx10PxsContext20removeParticleSystemEPNS_20PxvParticleSystemSimEb, __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode: __ZN9TextAssetC2E10MemLabelId18ObjectCreationMode, _cf2_stack_popFixed: _cf2_stack_popFixed, __Z19GetIClusterRendererv: __Z19GetIClusterRendererv, __ZNK13WheelCollider6GetRpmEv: __ZNK13WheelCollider6GetRpmEv, __ZN5physx3Scb5Scene8addClothERNS0_5ClothE: __ZN5physx3Scb5Scene8addClothERNS0_5ClothE, __Z19GetBytesForOnePixel13TextureFormat: __Z19GetBytesForOnePixel13TextureFormat, __ZN14SplatMaterials11SetSpecularERK11ColorRGBA32f: __ZN14SplatMaterials11SetSpecularERK11ColorRGBA32f, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1Ev: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC1Ev, __Z64Register_UnityEngine_AssetBundle_LoadAssetWithSubAssets_Internalv: __Z64Register_UnityEngine_AssetBundle_LoadAssetWithSubAssets_Internalv, __ZN7dtCrowd17requestMoveTargetEiPKf: __ZN7dtCrowd17requestMoveTargetEiPKf, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, _ft_smooth_render_generic: _ft_smooth_render_generic, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYMultiplierP12Il2CppObject, __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine: __ZN13MonoBehaviour24TryCreateAndRunCoroutineEP12Il2CppObject21ScriptingMethodIl2CppPP9Coroutine, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE: __ZN5Umbra9intersectERKNS_4AABBERKNS_11LineSegmentE, __Z52Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Inversev: __Z52Register_UnityEngine_Matrix4x4_INTERNAL_CALL_Inversev, __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_: __ZNSt3__26vectorIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEE21__push_back_slow_pathIRKS2_EEvOT_, __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapZP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_NoiseModule_CUSTOM_SetRemapZP12Il2CppObjectR15MonoMinMaxCurve, __ZNKSt3__220__codecvt_utf8_utf16IDsE11do_encodingEv: __ZNKSt3__220__codecvt_utf8_utf16IDsE11do_encodingEv, __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_: __ZNK9rapidjson12GenericValueINS_4UTF8IcEE13JSONAllocatorE6AcceptINS_12PrettyWriterI16TempBufferWriterS2_S2_S3_EEEEbRT_, __ZN12_GLOBAL__N_116MetaDataProviderD0Ev: __ZN12_GLOBAL__N_116MetaDataProviderD0Ev, __ZN15ReflectionProbe21SetCustomBakedTextureE4PPtrI7TextureE: __ZN15ReflectionProbe21SetCustomBakedTextureE4PPtrI7TextureE, __ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi0ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE: __ZN9ShaderLab11shaderprops8GetFloatEPK19ShaderPropertySheetS3_NS_16FastPropertyNameERNS0_16PropertyLocationE, __ZN2UI6CanvasC2E10MemLabelId18ObjectCreationMode: __ZN2UI6CanvasC2E10MemLabelId18ObjectCreationMode, __Z31RunNativeTestsIfRequiredAndExitv: __Z31RunNativeTestsIfRequiredAndExitv, __ZN14GfxDeviceStats14AddUsedTextureE9TextureID: __ZN14GfxDeviceStats14AddUsedTextureE9TextureID, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewIntArrayiRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewIntArrayiRPv, __ZN10__cxxabiv117__class_type_infoD0Ev: __ZN10__cxxabiv117__class_type_infoD0Ev, __Z41ParticleSystem_Set_Custom_PropScalingModeP12Il2CppObject25ParticleSystemScalingMode: __Z41ParticleSystem_Set_Custom_PropScalingModeP12Il2CppObject25ParticleSystemScalingMode, __Z70Register_UnityEngine_ParticleSystem_ShapeModule_SetSkinnedMeshRendererv: __Z70Register_UnityEngine_ParticleSystem_ShapeModule_SetSkinnedMeshRendererv, __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj: __ZN5physx2Gu32PCMConvexVsMeshContactGeneration15processTriangleERKNS0_13PolygonalDataEPNS0_12SupportLocalEPKNS_6PxVec3EjhRKNS_6shdfnd3aos6FloatVEbRKNSB_12PsTransformVERKNSB_15PsMatTransformVEPNS0_21MeshPersistentContactERj, __Z14tessDeleteTessP14TESStesselator: __Z14tessDeleteTessP14TESStesselator, __ZN19CloudServiceHandler31SetICloudServiceHandlerListenerEP28ICloudServiceHandlerListener: __ZN19CloudServiceHandler31SetICloudServiceHandlerListenerEP28ICloudServiceHandlerListener, __Z40Collider2D_Set_Custom_PropUsedByEffectorP12Il2CppObjecth: __Z40Collider2D_Set_Custom_PropUsedByEffectorP12Il2CppObjecth, __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP19BaseConnectSettings13stl_allocatorIS2_L18MemLabelIdentifier5ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEclILj415ENS_7PxJointENS_7PxFlagsINS_16PxConstraintFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18PxsDynamicsContext6createEPNS_10PxsContextE: __ZN5physx18PxsDynamicsContext6createEPNS_10PxsContextE, __Z13RegisterClassI14ParticleSystemEvv: __Z13RegisterClassI14ParticleSystemEvv, __ZN14PhysicMaterial15ChangedMaterialEv: __ZN14PhysicMaterial15ChangedMaterialEv, __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryERNS_10PxMaterialENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZNK5physx33PxRigidActorShapeCollectionHelper11createShapeEPNS_12PxRigidActorERKNS_10PxGeometryERNS_10PxMaterialENS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __ZNSt3__211__money_putIwEC2Ev: __ZNSt3__211__money_putIwEC2Ev, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN16ParticleRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN16ParticleRenderer13AwakeFromLoadE17AwakeFromLoadMode, __Z38UploadHandler_CUSTOM_InternalCreateRawP12Il2CppObjectP11Il2CppArray: __Z38UploadHandler_CUSTOM_InternalCreateRawP12Il2CppObjectP11Il2CppArray, __Z48ParticleSystem_TrailModule_CUSTOM_SetTextureModeP12Il2CppObjectf: __Z48ParticleSystem_TrailModule_CUSTOM_SetTextureModeP12Il2CppObjectf, __Z18Transfer_BlittableI14SafeBinaryReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18ProceduralMaterial17SetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK10ColorRGBAf: __ZN18ProceduralMaterial17SetSubstanceColorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEERK10ColorRGBAf, __ZN4crnd12symbol_codec13stop_decodingEv: __ZN4crnd12symbol_codec13stop_decodingEv, __ZN15LODGroupManager21CalculateLODDataArrayERK13LODParametersPK6Cameraf: __ZN15LODGroupManager21CalculateLODDataArrayERK13LODParametersPK6Cameraf, __Z56Register_UnityEngine_Shader_SetGlobalMatrixArrayImplListv: __Z56Register_UnityEngine_Shader_SetGlobalMatrixArrayImplListv, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseStringILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_b, __Z43ReflectionProbe_Get_Custom_PropFarClipPlaneP12Il2CppObject: __Z43ReflectionProbe_Get_Custom_PropFarClipPlaneP12Il2CppObject, __Z40Joint_Get_Custom_PropEnablePreprocessingP12Il2CppObject: __Z40Joint_Get_Custom_PropEnablePreprocessingP12Il2CppObject, __ZN9b2Fixture4DumpEi: __ZN9b2Fixture4DumpEi, __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB4444EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI15TexFormatRGB56517TexFormatARGB4444EEvPKNS_9InnerInfoE, _UNITY_png_gamma_16bit_correct: _UNITY_png_gamma_16bit_correct, __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej: __ZN16GeometryJobTasks19PutGeometryJobFenceER9GfxDevicej, __ZN10SizeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10SizeModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z45Register_UnityEngine_Sprite_INTERNAL_get_rectv: __Z45Register_UnityEngine_Sprite_INTERNAL_get_rectv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj666ENS_21PxVehicleDriveSimDataERKNS_20PxVehicleAutoBoxDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z13CleanupEnginev: __Z13CleanupEnginev, __ZN5Umbra9intersectERKNS_4AABBERKNS_6SphereE: __ZN5Umbra9intersectERKNS_4AABBERKNS_6SphereE, __Z52Register_UnityEngine_Shader_SetGlobalMatrixArrayImplv: __Z52Register_UnityEngine_Shader_SetGlobalMatrixArrayImplv, __ZNK9Texture2D13GetDataHeightEv: __ZNK9Texture2D13GetDataHeightEv, __ZNKSt3__217moneypunct_bynameIcLb1EE14do_curr_symbolEv: __ZNKSt3__217moneypunct_bynameIcLb1EE14do_curr_symbolEv, __ZN25ThreadsafeLinearAllocator13TryDeallocateEPv: __ZN25ThreadsafeLinearAllocator13TryDeallocateEPv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj18ENS_22PxRepXPropertyAccessorILj18ENS_7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEESD_EEEEvRKT0_, __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataP7TextureRK10Matrix4x4fR17ShaderPassContext: __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataP7TextureRK10Matrix4x4fR17ShaderPassContext, __Z50Register_UnityEngine_Rigidbody_INTERNAL_CALL_Sleepv: __Z50Register_UnityEngine_Rigidbody_INTERNAL_CALL_Sleepv, __ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane: __ZL16SplitPolyByPlaneR13dynamic_arrayI8Vector3fLj4EERKS1_RK5Plane, __ZNK9DebugGLES15SamplerBindingsEv: __ZNK9DebugGLES15SamplerBindingsEv, _UNITY_tt_face_load_prep: _UNITY_tt_face_load_prep, __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIxxEEPxEEjT0_S5_S5_S5_S5_T_, __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_: __ZNSt3__26__treeI9TextureIDNS_4lessIS1_EE13stl_allocatorIS1_L18MemLabelIdentifier57ELi16EEE14__assign_multiINS_21__tree_const_iteratorIS1_PNS_11__tree_nodeIS1_PvEEiEEEEvT_SF_, __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_15PxsArticulationENS0_16AlignedAllocatorILj64ENS0_9AllocatorEEEE15disposeElementsEv, __ZN5physx3Ext14PrismaticJoint15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx3Ext14PrismaticJoint15exportExtraDataERNS_22PxSerializationContextE, __ZNK5physx3Ext14PrismaticJoint29getProjectionAngularToleranceEv: __ZNK5physx3Ext14PrismaticJoint29getProjectionAngularToleranceEv, __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_23PxVehicleSuspensionDataENS0_15InlineAllocatorILj240ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZNK17GeneralConnection14HasBytesToSendEv: __ZNK17GeneralConnection14HasBytesToSendEv, __Z47ParticleSystem_CollisionModule_CUSTOM_GetBounceP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_CollisionModule_CUSTOM_GetBounceP12Il2CppObjectR15MonoMinMaxCurve, __ZN15Cast2DQueryBase18ReportFixtureProxyEPK14b2FixtureProxy: __ZN15Cast2DQueryBase18ReportFixtureProxyEPK14b2FixtureProxy, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_NS_17integral_constantIbLb0EEE, __Z28setPxSceneLimitsMaxNbRegionsPN5physx13PxSceneLimitsEj: __Z28setPxSceneLimitsMaxNbRegionsPN5physx13PxSceneLimitsEj, __ZN5physx2Sc17ParticleSystemSim18visualizeStartStepERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim18visualizeStartStepERNS_2Cm12RenderOutputE, __ZN13MonoBehaviour19GetDebugDescriptionEv: __ZN13MonoBehaviour19GetDebugDescriptionEv, __ZN12_GLOBAL__N_117ConnectionManager21nullAllocationHandlerEjPKcS2_iPv: __ZN12_GLOBAL__N_117ConnectionManager21nullAllocationHandlerEjPKcS2_iPv, __ZN5physx2Sc9ClothCore18addCollisionConvexEj: __ZN5physx2Sc9ClothCore18addCollisionConvexEj, __ZN4FMOD8ChannelI18UpdateDopplerPitchEv: __ZN4FMOD8ChannelI18UpdateDopplerPitchEv, _UNITY_FT_Outline_GetInsideBorder: _UNITY_FT_Outline_GetInsideBorder, __ZN9RigidbodyD2Ev: __ZN9RigidbodyD2Ev, __ZL14CleanupShadowsPv: __ZL14CleanupShadowsPv, _cff_charset_cid_to_gindex: _cff_charset_cid_to_gindex, __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb0EEEvP12NoiseJobData: __ZN11NoiseModule17CalculateNoiseJobILi2ELb1ELb0EEEvP12NoiseJobData, __ZN7mecanim9animation18ControllerConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim9animation18ControllerConstant8TransferI14SafeBinaryReadEEvRT_, __ZN5Umbra12QueryContext17addQueryDebugQuadERKNS_7Vector3ES3_S3_S3_RKNS_7Vector4E: __ZN5Umbra12QueryContext17addQueryDebugQuadERKNS_7Vector3ES3_S3_S3_RKNS_7Vector4E, __ZNK13WebCamTexture9IsRunningEv: __ZNK13WebCamTexture9IsRunningEv, __ZN12CubemapArray11InitTextureEiii13TextureFormatb: __ZN12CubemapArray11InitTextureEiii13TextureFormatb, __Z40getPxScene_ContactReportStreamBufferSizePKN5physx7PxSceneE: __Z40getPxScene_ContactReportStreamBufferSizePKN5physx7PxSceneE, __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI8JSONRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z16GetRendererScenev: __Z16GetRendererScenev, __ZN5physx20PxsParticleSystemSim21collisionFinalizationEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim21collisionFinalizationEPNS_10PxBaseTaskE, __ZN5Umbra10Visibility19setOutputObjectMaskEPj: __ZN5Umbra10Visibility19setOutputObjectMaskEPj, __Z43SkinnedMeshRenderer_Set_Custom_PropRootBoneP12Il2CppObjectS0_: __Z43SkinnedMeshRenderer_Set_Custom_PropRootBoneP12Il2CppObjectS0_, __ZN7mecanim9animation20MotionOutputBlendEndEPNS0_12MotionOutputEbbRKNS_6bitsetILj66EEERf: __ZN7mecanim9animation20MotionOutputBlendEndEPNS0_12MotionOutputEbbRKNS_6bitsetILj66EEERf, __ZNK13WheelCollider10IsGroundedEv: __ZNK13WheelCollider10IsGroundedEv, __Z37RenderTexture_CUSTOM_ReleaseTemporaryP12Il2CppObject: __Z37RenderTexture_CUSTOM_ReleaseTemporaryP12Il2CppObject, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadtEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadtEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __Z34GetBlendShapeFrameWeightFromScriptRK4Meshii: __Z34GetBlendShapeFrameWeightFromScriptRK4Meshii, __ZNK9Polygon2D14GetNearestEdgeERK8Vector2fRiS3_S3_Rfb: __ZNK9Polygon2D14GetNearestEdgeERK8Vector2fRiS3_S3_Rfb, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE12getClassSizeEv, _cf2_hint_lock: _cf2_hint_lock, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7setNameEPKc: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE7setNameEPKc, __Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z22IsFileOrDirectoryInUseRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__218__insertion_sort_3IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessI13BuildCurveKeyS2_EEPS2_EEvT0_S6_T_, _UNITY_png_build_grayscale_palette: _UNITY_png_build_grayscale_palette, __ZN5physx23PxsBroadPhaseContextSap6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE: __ZN5physx23PxsBroadPhaseContextSap6updateEjjRKNS_23PxcBroadPhaseUpdateDataEPNS_10PxBaseTaskE, __ZN19CloudServiceHandlerC2Ev: __ZN19CloudServiceHandlerC2Ev, _UNITY_LZ4_slideInputBuffer: _UNITY_LZ4_slideInputBuffer, __Z54Register_UnityEngine_Animator_get_leftFeetBottomHeightv: __Z54Register_UnityEngine_Animator_get_leftFeetBottomHeightv, __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4FMOD6SoundI19getMusicNumChannelsEPi: __ZN4FMOD6SoundI19getMusicNumChannelsEPi, __ZN21AssetBundleFileSystem6DeleteER13FileEntryDatab: __ZN21AssetBundleFileSystem6DeleteER13FileEntryDatab, __Z52Register_UnityEngine_AndroidJNI_CallStaticVoidMethodv: __Z52Register_UnityEngine_AndroidJNI_CallStaticVoidMethodv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24getParticleAccelerationsEv, __Z24RegisterStrippedTypeInfoI14DirectorPlayerEviPKcS2_: __Z24RegisterStrippedTypeInfoI14DirectorPlayerEviPKcS2_, __ZN12_GLOBAL__N_19MyFastXmlD0Ev: __ZN12_GLOBAL__N_19MyFastXmlD0Ev, __ZN11NoiseModule8TransferI17RemapPPtrTransferEEvRT_: __ZN11NoiseModule8TransferI17RemapPPtrTransferEEvRT_, __ZN5physx20PxsParticleSystemSim24updateCollisionParameterEv: __ZN5physx20PxsParticleSystemSim24updateCollisionParameterEv, __ZNK5physx5cloth8SwFabric10getFactoryEv: __ZNK5physx5cloth8SwFabric10getFactoryEv, __Z59Register_UnityEngine_ParticleSystem_TriggerModule_GetInsidev: __Z59Register_UnityEngine_ParticleSystem_TriggerModule_GetInsidev, __Z34VRSettings_CUSTOM_LoadDeviceByNameP11Il2CppArray: __Z34VRSettings_CUSTOM_LoadDeviceByNameP11Il2CppArray, __ZN9InputAxis12MakeJoystickEi: __ZN9InputAxis12MakeJoystickEi, __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN22NavMeshProjectSettings23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve: __ZL15ReadMinMaxCurveR15MonoMinMaxCurveRK11MinMaxCurve, __ZN4FMOD6System11getWaveDataEPfii: __ZN4FMOD6System11getWaveDataEPfii, __Z47Register_UnityEngine_AnimationState_get_enabledv: __Z47Register_UnityEngine_AnimationState_get_enabledv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj602ENS_22PxRepXPropertyAccessorILj602ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_17PxVehicleTireDataEEEE14handleAccessorILj602ENS_22PxRepXPropertyAccessorILj602ES4_ffEEEEvRKT0_, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE14do_get_weekdayES4_S4_RNS_8ios_baseERjP2tm, __ZN15b2RevoluteJoint4DumpEv: __ZN15b2RevoluteJoint4DumpEv, __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMinv: __Z57Register_UnityEngine_RectTransform_INTERNAL_get_anchorMinv, __ZN10MonoScript16RebuildFromAwakeEv: __ZN10MonoScript16RebuildFromAwakeEv, __ZN5physx16PxsFluidDynamics21updatePacketLocalHashENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE: __ZN5physx16PxsFluidDynamics21updatePacketLocalHashENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE, __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE: __ZN5physx17PxcNpMemBlockPool22acquireConstraintBlockERNS_6shdfnd5ArrayIPNS_13PxcNpMemBlockENS1_19ReflectionAllocatorIS4_EEEE, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3getES4_S4_RNS_8ios_baseERjP2tmPKwSC_, __ZN5physx7NpCloth9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE: __ZN5physx7NpCloth9visualizeERNS_2Cm12RenderOutputEPNS_7NpSceneE, __ZN13TriggerModule8TransferI17RemapPPtrTransferEEvRT_: __ZN13TriggerModule8TransferI17RemapPPtrTransferEEvRT_, __ZN15RelativeJoint2D6CreateEv: __ZN15RelativeJoint2D6CreateEv, __ZN5physx16PxsIslandManager19addArticulationLinkERNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager19addArticulationLinkERNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZNK13b2DynamicTree5QueryI24b2WorldQueryProxyWrapperEEvPT_RK6b2AABB: __ZNK13b2DynamicTree5QueryI24b2WorldQueryProxyWrapperEEvPT_RK6b2AABB, __ZN11MonoManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN11MonoManager23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN4math8ColliderEEEEvRT_17TransferMetaFlags, __ZN2UI6Canvas23ClearNestedCanvasDepthsEv: __ZN2UI6Canvas23ClearNestedCanvasDepthsEv, __Z60Register_UnityEngine_Rendering_CommandBuffer_get_sizeInBytesv: __Z60Register_UnityEngine_Rendering_CommandBuffer_get_sizeInBytesv, __ZN15NavMeshObstacle15ThreadedCleanupEv: __ZN15NavMeshObstacle15ThreadedCleanupEv, __ZN13SparseTexture23VirtualRedirectTransferER14SafeBinaryRead: __ZN13SparseTexture23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd5ArrayINS_18PxProfileEventNameENS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_18PxProfileEventNameENS_7profile26WrapperReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN8Animator11ResolveHashEi: __ZN8Animator11ResolveHashEi, __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortINS_5cloth8SwSolver22CpuClothSimulationTaskEPFbRKS4_S6_ENS0_19ReflectionAllocatorIS4_EEEEvPT_jRKT0_RKT1_j, __ZN15NavMeshSettingsD0Ev: __ZN15NavMeshSettingsD0Ev, __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17BlendShapeChannel8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx17AggregateAABBTask11runInternalEv: __ZN5physx17AggregateAABBTask11runInternalEv, __ZN7mecanim9animation26ComputeClipMuscleDeltaPoseERKNS0_18ClipMuscleConstantEffRNS_5human9HumanPoseERN4math4trsXES9_S9_S9_RNS_6memory9AllocatorE: __ZN7mecanim9animation26ComputeClipMuscleDeltaPoseERKNS0_18ClipMuscleConstantEffRNS_5human9HumanPoseERN4math4trsXES9_S9_S9_RNS_6memory9AllocatorE, __Z43Register_UnityEngine_WWW_get_uploadProgressv: __Z43Register_UnityEngine_WWW_get_uploadProgressv, _strtok_r: _strtok_r, __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXv: __Z64Register_UnityEngine_ParticleSystem_MainModule_SetStartRotationXv, __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer11PvdTriangleEEE: __ZN12_GLOBAL__N_112RenderWriterIN5physx8debugger22ForwardingMemoryBufferEE9streamifyERNS2_7DataRefINS2_8renderer11PvdTriangleEEE, __ZN5physx3Scb14ParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb14ParticleSystem17getBinaryMetaDataERNS_14PxOutputStreamE, __Z49Register_UnityEngine_AssetBundleRequest_get_assetv: __Z49Register_UnityEngine_AssetBundleRequest_get_assetv, __Z24RegisterStrippedTypeInfoI13WheelColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI13WheelColliderEviPKcS2_, __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_set_limitsv: __Z53Register_UnityEngine_HingeJoint2D_INTERNAL_set_limitsv, __Z39AudioReverbFilter_Get_Custom_PropRoomHFP12Il2CppObject: __Z39AudioReverbFilter_Get_Custom_PropRoomHFP12Il2CppObject, __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI10AudioMixerE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_41PCMCapsuleVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj: __ZN5physx2Gu32PCMMeshContactGenerationCallbackINS_41PCMCapsuleVsMeshContactGenerationCallbackEE10processHitERKNS_12PxRaycastHitERKNS_6PxVec3ES9_S9_RfPKj, __Z61Register_UnityEngine_ParticleSystem_MainModule_SetStartSize3Dv: __Z61Register_UnityEngine_ParticleSystem_MainModule_SetStartSize3Dv, _PxRegisterArticulations: _PxRegisterArticulations, __ZZN4Halo15InitializeClassEvEN31FunctorImpl_48kTransformChanged4CallEPviR11MessageData: __ZZN4Halo15InitializeClassEvEN31FunctorImpl_48kTransformChanged4CallEPviR11MessageData, __ZN5physx11NpAggregate8getSceneEv: __ZN5physx11NpAggregate8getSceneEv, _UNITY_FT_Outline_Render: _UNITY_FT_Outline_Render, __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE: __ZN9Transform16RemoveFromParentENS_17RemoveParentFlagsE, __ZN26b2PolygonAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_: __ZN26b2PolygonAndCapsuleContact8EvaluateEP10b2ManifoldRK11b2TransformS4_, __ZN14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj: __ZN14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj, __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth: __Z59ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetWorldSpaceP12Il2CppObjecth, _freopen: _freopen, __Z55Animator_CUSTOM_INTERNAL_CALL_SetLookAtPositionInternalP12Il2CppObjectRK8Vector3f: __Z55Animator_CUSTOM_INTERNAL_CALL_SetLookAtPositionInternalP12Il2CppObjectRK8Vector3f, __Z5arrayR8Scalar4f: __Z5arrayR8Scalar4f, __ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior: __ZN12FileAccessor4OpenEPKc14FilePermission16FileAutoBehavior, _UNITY_FT_List_Insert: _UNITY_FT_List_Insert, __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS9_: __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E15insert_noresizeERKS9_, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9sputbackcEw: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEE9sputbackcEw, __ZN5physx24PxAggregateGeneratedInfoC2Ev: __ZN5physx24PxAggregateGeneratedInfoC2Ev, __Z50Register_UnityEngine_FixedJoint2D_set_dampingRatiov: __Z50Register_UnityEngine_FixedJoint2D_set_dampingRatiov, __ZN13MonoBehaviour15SetUseGUILayoutEb: __ZN13MonoBehaviour15SetUseGUILayoutEb, __Z53ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsWidthP12Il2CppObjecth: __Z53ParticleSystem_TrailModule_CUSTOM_SetSizeAffectsWidthP12Il2CppObjecth, __ZN13GfxDeviceGLES23GetNativeTexturePointerE9TextureID: __ZN13GfxDeviceGLES23GetNativeTexturePointerE9TextureID, __ZN9WWWCachedD2Ev: __ZN9WWWCachedD2Ev, __ZN4PPtrI7CubemapE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI7CubemapE8TransferI14SafeBinaryReadEEvRT_, __ZN14ImageReferenceC2Eii13TextureFormat: __ZN14ImageReferenceC2Eii13TextureFormat, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z52DistanceJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth: __Z52DistanceJoint2D_Set_Custom_PropAutoConfigureDistanceP12Il2CppObjecth, __Z38Register_UnityEngine_Font_get_fontSizev: __Z38Register_UnityEngine_Font_get_fontSizev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj416ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN19CloudServiceHandler20StartEventDispatcherERKN11UnityEngine15CloudWebService18CloudServiceConfigERNS1_16WWWRestHeaderMapE: __ZN19CloudServiceHandler20StartEventDispatcherERKN11UnityEngine15CloudWebService18CloudServiceConfigERNS1_16WWWRestHeaderMapE, __Z39Light_Get_Custom_PropCommandBufferCountP12Il2CppObject: __Z39Light_Get_Custom_PropCommandBufferCountP12Il2CppObject, _Direct_Move_Orig: _Direct_Move_Orig, __ZN2gl8GetLabelENS_10ObjectTypeE: __ZN2gl8GetLabelENS_10ObjectTypeE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxJointLimitConeEEEE14handleAccessorILj485ENS_22PxRepXPropertyAccessorILj485ENS_22PxJointLimitParametersEffEEEEvRKT0_, __Z28getPxDistanceJoint_StiffnessPKN5physx15PxDistanceJointE: __Z28getPxDistanceJoint_StiffnessPKN5physx15PxDistanceJointE, __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext: __ZNK23ForwardShaderRenderLoop19SetLightShadowPropsERK15SharedLightDataRK10TextureRefRK10Matrix4x4fR17ShaderPassContext, _versionsort: _versionsort, __Z16ApplyBlendShapesR12SkinMeshInfoPh: __Z16ApplyBlendShapesR12SkinMeshInfoPh, __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_5cloth5Vec4TItEENS0_9AllocatorEE8recreateEj, __ZN11Rigidbody2D6CreateEv: __ZN11Rigidbody2D6CreateEv, __ZN4crnd10dxt5_block16get_block_valuesEPjjj: __ZN4crnd10dxt5_block16get_block_valuesEPjjj, __ZN16Physics2DManager29ConvertCollision2DToScriptingEP11Collision2D: __ZN16Physics2DManager29ConvertCollision2DToScriptingEP11Collision2D, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERt: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERt, __ZN17SizeBySpeedModule8TransferI14SafeBinaryReadEEvRT_: __ZN17SizeBySpeedModule8TransferI14SafeBinaryReadEEvRT_, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERs: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERs, __Z14CreateJobQueuePKcS0_i: __Z14CreateJobQueuePKcS0_i, ___flbf: ___flbf, __ZN37ConvexVsMeshContactGenerationCallbackD0Ev: __ZN37ConvexVsMeshContactGenerationCallbackD0Ev, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERx: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERx, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERy: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERy, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERf: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERf, __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE14allocateObjectERNS_23PxRepXInstantiationArgsE: __ZN5physx21PxJointRepXSerializerINS_9PxD6JointEE14allocateObjectERNS_23PxRepXInstantiationArgsE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERd: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERd, __ZN5physx19clothTriangleWriterERNS_14PxOutputStreamERKNS_24PxClothCollisionTriangleE: __ZN5physx19clothTriangleWriterERNS_14PxOutputStreamERKNS_24PxClothCollisionTriangleE, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERb: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERb, __ZN10MemoryPool5ResetEv: __ZN10MemoryPool5ResetEv, __ZN16ParticleAnimator15InitializeClassEv: __ZN16ParticleAnimator15InitializeClassEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERl: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERl, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERm: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERm, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERj: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERj, __Z39GraphicsSettings_CUSTOM_SetCustomShaderN16GraphicsSettings17BuiltinShaderTypeEP12Il2CppObject: __Z39GraphicsSettings_CUSTOM_SetCustomShaderN16GraphicsSettings17BuiltinShaderTypeEP12Il2CppObject, __ZNK17GlobalGameManager26GetTypeInfoVirtualInternalEv: __ZNK17GlobalGameManager26GetTypeInfoVirtualInternalEv, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERi: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEErsERi, _isgraph: _isgraph, __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectArrayv: __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_NewObjectArrayv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE19setInvInertiaScale1Ef, __ZN18AwakeFromLoadQueue33RegisterObjectInstanceIDsInternalEPNS_4ItemEj: __ZN18AwakeFromLoadQueue33RegisterObjectInstanceIDsInternalEPNS_4ItemEj, __Z13AddComponentsR10GameObjectPKcz: __Z13AddComponentsR10GameObjectPKcz, __ZN5physx2Gu22pcmContactConvexConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu22pcmContactConvexConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __ZNSt12domain_errorD0Ev: __ZNSt12domain_errorD0Ev, __Z58ParticleSystem_ShapeModule_CUSTOM_GetRandomDirectionAmountP12Il2CppObject: __Z58ParticleSystem_ShapeModule_CUSTOM_GetRandomDirectionAmountP12Il2CppObject, __ZNK5physx2Sc20ArticulationJointSim8getChildEv: __ZNK5physx2Sc20ArticulationJointSim8getChildEv, __ZN13b2CircleShapeD0Ev: __ZN13b2CircleShapeD0Ev, __ZN14VehiclesModule20SetupVehiclesManagerEv: __ZN14VehiclesModule20SetupVehiclesManagerEv, __ZN5physx6shdfnd5ArrayIPNS_2Sc8ShapeSimENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc8ShapeSimENS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorIS4_EEEEE15growAndPushBackERKS4_, __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension: __ZNK13TranslateGLES16GetTextureTargetE16TextureDimension, __ZZN12MeshRenderer15InitializeClassEvEN30FunctorImpl_98kDidModifyBounds4CallEPviR11MessageData: __ZZN12MeshRenderer15InitializeClassEvEN30FunctorImpl_98kDidModifyBounds4CallEPviR11MessageData, _alloc_large: _alloc_large, __Z11CloneObjectR6Object: __Z11CloneObjectR6Object, __ZN17Physics2DSettingsD0Ev: __ZN17Physics2DSettingsD0Ev, __Z42Register_UnityEngine_GUIStyle_set_richTextv: __Z42Register_UnityEngine_GUIStyle_set_richTextv, __Z43Vector3_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK8Vector3fS1_fRS_: __Z43Vector3_CUSTOM_INTERNAL_CALL_SlerpUnclampedRK8Vector3fS1_fRS_, __ZN5physx3Cct13BoxController7releaseEv: __ZN5physx3Cct13BoxController7releaseEv, __Z50Register_UnityEngine_Input_set_backButtonLeavesAppv: __Z50Register_UnityEngine_Input_set_backButtonLeavesAppv, __ZN10GameObject23VirtualRedirectTransferER14SafeBinaryRead: __ZN10GameObject23VirtualRedirectTransferER14SafeBinaryRead, __Z37AndroidJNIHelper_Get_Custom_PropDebugv: __Z37AndroidJNIHelper_Get_Custom_PropDebugv, __ZN5Umbra6DoublemIERKd: __ZN5Umbra6DoublemIERKd, __ZN11ICallString18GetScriptingStringEv: __ZN11ICallString18GetScriptingStringEv, __Z37getPxSceneDescSimulationEventCallbackPKN5physx11PxSceneDescE: __Z37getPxSceneDescSimulationEventCallbackPKN5physx11PxSceneDescE, __ZN5physx21PxVehicleDriveSimData13setEngineDataERKNS_19PxVehicleEngineDataE: __ZN5physx21PxVehicleDriveSimData13setEngineDataERKNS_19PxVehicleEngineDataE, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE12createObjectERPhRNS_24PxDeserializationContextE, __ZNK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E: __ZNK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E, __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetSuperclassv: __Z59Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetSuperclassv, __ZN5physx6shdfnd5ArrayINS_8IntervalENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_8IntervalENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE15growAndPushBackERKS2_, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getBreakForceERfS5_: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE13getBreakForceERfS5_, __Z57Register_UnityEngine_Screen_set_autorotateToLandscapeLeftv: __Z57Register_UnityEngine_Screen_set_autorotateToLandscapeLeftv, __ZL29CleanupModule_UnityWebRequestv: __ZL29CleanupModule_UnityWebRequestv, __ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv: __ZN10__cxxabiv112_GLOBAL__N_19destruct_EPv, __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD2Ev: __ZN5physx38PxsSolverCreateFinalizeConstraintsTaskD2Ev, __Z32setPxRigidBody_RigidDynamicFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE: __Z32setPxRigidBody_RigidDynamicFlagsPN5physx11PxRigidBodyENS_7PxFlagsINS_15PxRigidBodyFlag4EnumEhEE, __Z39Register_UnityEngine_Animator_GetBoolIDv: __Z39Register_UnityEngine_Animator_GetBoolIDv, __ZN21DownloadHandlerScript21InvokeCompleteContentEv: __ZN21DownloadHandlerScript21InvokeCompleteContentEv, __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsLevelv: __Z59Register_UnityEngine_AudioReverbFilter_get_reflectionsLevelv, __ZNK7VRInput16GetLocalPositionERK8UnityStr4PPtrI9TransformE: __ZNK7VRInput16GetLocalPositionERK8UnityStr4PPtrI9TransformE, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetRotationv: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_targetRotationv, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_15RayCastCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentINS0_15RayCastCallbackELb0ELb0ELb0EEEvRKNS_6PxVec3ES6_PT_PS5_, __ZN5physx8debugger19PvdNetworkOutStream14createFromFileERNS_19PxAllocatorCallbackEPKc: __ZN5physx8debugger19PvdNetworkOutStream14createFromFileERNS_19PxAllocatorCallbackEPKc, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_4pairIfjEES3_EEPS3_EEbT0_S7_T_, __ZL16sample_gc_resizePvx: __ZL16sample_gc_resizePvx, __ZN12AudioManager15GetSoundManagerEv: __ZN12AudioManager15GetSoundManagerEv, __ZN14PhysicMaterial18SetDynamicFrictionEf: __ZN14PhysicMaterial18SetDynamicFrictionEf, __Z32GUIText_Get_Custom_PropFontStyleP12Il2CppObject: __Z32GUIText_Get_Custom_PropFontStyleP12Il2CppObject, _Split_Conic: _Split_Conic, __Z45CommandBuffer_CUSTOM_SetRenderTarget_ColDepthP12Il2CppObjectR26MonoRenderTargetIdentifierS2_iii: __Z45CommandBuffer_CUSTOM_SetRenderTarget_ColDepthP12Il2CppObjectR26MonoRenderTargetIdentifierS2_iii, __ZN9SubModuleD2Ev: __ZN9SubModuleD2Ev, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, _setkey: _setkey, _memmem: _memmem, __Z55SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_ClearInternalR20SphericalHarmonicsL2: __Z55SphericalHarmonicsL2_CUSTOM_INTERNAL_CALL_ClearInternalR20SphericalHarmonicsL2, __Z41setPxArticulation_InternalDriveIterationsPN5physx14PxArticulationEj: __Z41setPxArticulation_InternalDriveIterationsPN5physx14PxArticulationEj, __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev: __ZN20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationED2Ev, __ZNK20BufferedSocketStream10IsBlockingEv: __ZNK20BufferedSocketStream10IsBlockingEv, __ZN14PhysicsManager34ResetInterpolatedTransformPositionEv: __ZN14PhysicsManager34ResetInterpolatedTransformPositionEv, __ZNSt3__26vectorI23UnityVRDeviceDefinition13stl_allocatorIS1_L18MemLabelIdentifier87ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI23UnityVRDeviceDefinition13stl_allocatorIS1_L18MemLabelIdentifier87ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __Z57Register_UnityEngine_LineRenderer_INTERNAL_get_startColorv: __Z57Register_UnityEngine_LineRenderer_INTERNAL_get_startColorv, _cff_slot_init: _cff_slot_init, __ZN4FMOD7Channel9isPlayingEPb: __ZN4FMOD7Channel9isPlayingEPb, __ZL22Transfer_ManagedObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI9JSONWriteLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10GameObject13SetSelfActiveEb: __ZN10GameObject13SetSelfActiveEb, __ZNK21GLESRenderTargetSetupltERKS_: __ZNK21GLESRenderTargetSetupltERKS_, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewLocalRef13Il2Cpp_IntPtrRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_NewLocalRef13Il2Cpp_IntPtrRPv, __ZL21RegisterInterfaceImpl18UnityInterfaceGUIDP15IUnityInterface: __ZL21RegisterInterfaceImpl18UnityInterfaceGUIDP15IUnityInterface, __ZN4FMOD13ChannelGroupI9getVolumeEPf: __ZN4FMOD13ChannelGroupI9getVolumeEPf, __Z28CollectMemoryAllocationStatsR11MemoryStats: __Z28CollectMemoryAllocationStatsR11MemoryStats, __ZN5physx10PxsContext14updateCCDBeginEv: __ZN5physx10PxsContext14updateCCDBeginEv, __ZNK9Texture2D9GetPixelsEiiiiiP11ColorRGBA32i: __ZNK9Texture2D9GetPixelsEiiiiiP11ColorRGBA32i, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetXv, __ZN13MemoryManager13GetMemcatNameERK10MemLabelId: __ZN13MemoryManager13GetMemcatNameERK10MemLabelId, __Z30AddTransformComponentUncheckedR10GameObjecti: __Z30AddTransformComponentUncheckedR10GameObjecti, __ZN11dtPathQueue13getPathResultEjPyPiPfPjP15dtPathQueryInfoi: __ZN11dtPathQueue13getPathResultEjPyPiPfPjP15dtPathQueryInfoi, __Z48Register_UnityEngine_Collider_get_sharedMaterialv: __Z48Register_UnityEngine_Collider_get_sharedMaterialv, __ZN17PolygonCollider2DD0Ev: __ZN17PolygonCollider2DD0Ev, __Z23GetVirtualJoystickIndexPKc: __Z23GetVirtualJoystickIndexPKc, __Z36AndroidJNI_CUSTOM_SetStaticCharField13Il2Cpp_IntPtrS_t: __Z36AndroidJNI_CUSTOM_SetStaticCharField13Il2Cpp_IntPtrS_t, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEE14handleAccessorILj33ENS_22PxRepXPropertyAccessorILj33ENS_11PxRigidBodyERKNS_6PxVec3ESA_EEEEvRKT0_, __ZN2UI6Canvas15SetSortingOrderEs: __ZN2UI6Canvas15SetSortingOrderEs, __ZN9Texture2D12CleanupClassEv: __ZN9Texture2D12CleanupClassEv, __ZN13GfxDeviceGLES21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii: __ZN13GfxDeviceGLES21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii, _Move_CVT_Stretched: _Move_CVT_Stretched, __Z32setPxArticulationJoint_ChildPosePN5physx19PxArticulationJointERKNS_11PxTransformE: __Z32setPxArticulationJoint_ChildPosePN5physx19PxArticulationJointERKNS_11PxTransformE, __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_: __ZN11AudioFilter8TransferI14SafeBinaryReadEEvRT_, __Z76Register_UnityEngine_ParticleSystem_CollisionModule_GetUsesCollisionMessagesv: __Z76Register_UnityEngine_ParticleSystem_CollisionModule_GetUsesCollisionMessagesv, __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact: __ZN10Effector2D19ProcessBeginContactEbP10Collider2DS1_P9b2Contact, __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStrS7_S7_: __ZN11UnityEngine15CloudWebService17WebFileDownloaderINS0_13WWWRestClientENS0_16WWWRestHeaderMapEE10InitializeERK8UnityStrS7_S7_, __ZN5physx14NpRigidDynamic15switchFromNoSimEv: __ZN5physx14NpRigidDynamic15switchFromNoSimEv, __Z26Animation_CUSTOM_IsPlayingP12Il2CppObjectP12Il2CppString: __Z26Animation_CUSTOM_IsPlayingP12Il2CppObjectP12Il2CppString, __ZN5physx3Cct13BoxController13setStepOffsetEf: __ZN5physx3Cct13BoxController13setStepOffsetEf, __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_: __ZNK5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE7getSizeEiRiS3_, __ZN5physx7NpShape10isWritableEv: __ZN5physx7NpShape10isWritableEv, __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI10MonoScriptE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx9NpPhysics17createHeightFieldERKNS_17PxHeightFieldDescE: __ZN5physx9NpPhysics17createHeightFieldERKNS_17PxHeightFieldDescE, __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv: __ZN11AssetBundle44BuildLookupAndNameContainerFromPathContainerEv, __ZN9Projector7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Projector7PRODUCEE10MemLabelId18ObjectCreationMode, __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv: __ZThn4_NK5physx5cloth9SwFactory10copyToHostEPKvS3_Pv, __ZN5Umbra4Math3tanENS_5FloatE: __ZN5Umbra4Math3tanENS_5FloatE, __ZL18OrientationHandleriPK32EmscriptenDeviceOrientationEventPv: __ZL18OrientationHandleriPK32EmscriptenDeviceOrientationEventPv, __ZN15DistanceJoint2DD0Ev: __ZN15DistanceJoint2DD0Ev, __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN5physx7profile15ZoneManagerImpl17removeProfileZoneERNS_13PxProfileZoneE: __ZN5physx7profile15ZoneManagerImpl17removeProfileZoneERNS_13PxProfileZoneE, __ZN18UnityConnectClient23RegisterGlobalCallbacksEv: __ZN18UnityConnectClient23RegisterGlobalCallbacksEv, __ZNSt3__210__stdinbufIwE5imbueERKNS_6localeE: __ZNSt3__210__stdinbufIwE5imbueERKNS_6localeE, __ZN6Camera18ApplyRenderTextureEv: __ZN6Camera18ApplyRenderTextureEv, __ZN15Cast2DQueryBaseD0Ev: __ZN15Cast2DQueryBaseD0Ev, __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12AudioManager23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx2Gu22intersectSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleE: __ZN5physx2Gu22intersectSphereCapsuleERKNS0_6SphereERKNS0_7CapsuleE, __Z28delete_object_internal_step1P6Object: __Z28delete_object_internal_step1P6Object, __ZN9Rigidbody23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN9Rigidbody23VirtualRedirectTransferER17RemapPPtrTransfer, __Z36Register_UnityEngine_Random_set_seedv: __Z36Register_UnityEngine_Random_set_seedv, __ZNKSt3__223__match_any_but_newlineIwE6__execERNS_7__stateIwEE: __ZNKSt3__223__match_any_but_newlineIwE6__execERNS_7__stateIwEE, __ZN13GfxDeviceNull12SetWireframeEb: __ZN13GfxDeviceNull12SetWireframeEb, __ZN5physx14NpArticulation14setWakeCounterEf: __ZN5physx14NpArticulation14setWakeCounterEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj531ENS_22PxRepXPropertyAccessorILj531ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleGearsDataEEEE14handleAccessorILj531ENS_22PxRepXPropertyAccessorILj531ES4_ffEEEEvRKT0_, __ZN5physx17PxsFluidCollision15updateCollisionEPKhRNS_10PxBaseTaskE: __ZN5physx17PxsFluidCollision15updateCollisionEPKhRNS_10PxBaseTaskE, __ZN5physx3Ext13DistanceJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext13DistanceJoint17resolveReferencesERNS_24PxDeserializationContextE, __Z58Register_UnityEngine_SceneManagement_Scene_SetNameInternalv: __Z58Register_UnityEngine_SceneManagement_Scene_SetNameInternalv, __ZNK5physx14NpArticulation16updateDriveCacheERNS_24PxArticulationDriveCacheEfj: __ZNK5physx14NpArticulation16updateDriveCacheERNS_24PxArticulationDriveCacheEfj, __ZN5physx13NpClothFabric15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx13NpClothFabric15exportExtraDataERNS_22PxSerializationContextE, __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE6extendEv: __ZN5physx11PxcPoolListINS_17PxsContactManagerENS_10PxsContextEE6extendEv, __ZN23iPhoneLocalNotification14SetAlertActionEPKc: __ZN23iPhoneLocalNotification14SetAlertActionEPKc, __Z39Physics_CUSTOM_INTERNAL_CALL_RaycastAllRK8Vector3fS1_fi23QueryTriggerInteraction: __Z39Physics_CUSTOM_INTERNAL_CALL_RaycastAllRK8Vector3fS1_fi23QueryTriggerInteraction, __Z31Rigidbody2D_Set_Custom_PropMassP12Il2CppObjectf: __Z31Rigidbody2D_Set_Custom_PropMassP12Il2CppObjectf, __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram14ConstantBuffer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z52Register_UnityEngine_BillboardRenderer_get_billboardv: __Z52Register_UnityEngine_BillboardRenderer_get_billboardv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj614ES2_KjNS_18PxVehicleWheelDataEEEKNS_31PxVehicleWheelDataGeneratedInfoEEEvPjRKT_RT0_, _cf2_getBlueMetrics: _cf2_getBlueMetrics, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ConstraintGroupNodeENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj627ES4_bKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN4FMOD5Sound11setSubSoundEiPS0_: __ZN4FMOD5Sound11setSubSoundEiPS0_, __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKPKcPK4RTTIEES3_N11TypeManager23ConstCharPtrHashFunctorEN14dense_hash_mapIS3_S7_SA_NS9_19ConstCharPtrEqualToE13stl_allocatorIS8_L18MemLabelIdentifier6ELi16EEE9SelectKeyESC_SF_E12maybe_shrinkEv, __Z52Register_UnityEngine_GUIStyle_Internal_GetLineHeightv: __Z52Register_UnityEngine_GUIStyle_Internal_GetLineHeightv, __ZNSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE25__construct_node_with_keyERS6_: __ZNSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE25__construct_node_with_keyERS6_, __ZN14CachingManager13GetTempFolderEv: __ZN14CachingManager13GetTempFolderEv, __Z30WindZone_Set_Custom_PropRadiusP12Il2CppObjectf: __Z30WindZone_Set_Custom_PropRadiusP12Il2CppObjectf, __Z30Animator_CUSTOM_SetFloatIDDampP12Il2CppObjectifff: __Z30Animator_CUSTOM_SetFloatIDDampP12Il2CppObjectifff, __ZNK5physx2Sc18ParticleSystemCore16getParticleCountEv: __ZNK5physx2Sc18ParticleSystemCore16getParticleCountEv, __ZL21stb__MatchColorsBlockPhS_i: __ZL21stb__MatchColorsBlockPhS_i, __ZN10GameObject24ActivateAwakeRecursivelyE19DeactivateOperation: __ZN10GameObject24ActivateAwakeRecursivelyE19DeactivateOperation, __Z75Register_UnityEngine_AnimationClip_INTERNAL_CALL_EnsureQuaternionContinuityv: __Z75Register_UnityEngine_AnimationClip_INTERNAL_CALL_EnsureQuaternionContinuityv, __ZNK13TranslateGLES23VertexArraySizeBitfieldEi: __ZNK13TranslateGLES23VertexArraySizeBitfieldEi, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __Z33Coroutine_CUSTOM_ReleaseCoroutineP12Il2CppObject: __Z33Coroutine_CUSTOM_ReleaseCoroutineP12Il2CppObject, __Z56Register_UnityEngine_DistanceJoint2D_set_maxDistanceOnlyv: __Z56Register_UnityEngine_DistanceJoint2D_set_maxDistanceOnlyv, __ZN7mecanim9animation18ControllerConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation18ControllerConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12CachedReader22FetchResourceImageDataE19ActiveResourceImagejj: __ZN12CachedReader22FetchResourceImageDataE19ActiveResourceImagejj, __ZN7mecanim5human17NormalizedHandleXEPKNS0_5HumanEi: __ZN7mecanim5human17NormalizedHandleXEPKNS0_5HumanEi, __ZN21RotationBySpeedModule8TransferI14SafeBinaryReadEEvRT_: __ZN21RotationBySpeedModule8TransferI14SafeBinaryReadEEvRT_, __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToCharArrayP11Il2CppArrayRPv: __Z43AndroidJNI_CUSTOM_INTERNAL_CALL_ToCharArrayP11Il2CppArrayRPv, __ZN21UnityAnalyticsManager33OnPlayerSessionStateChangedStaticEPS_jyy: __ZN21UnityAnalyticsManager33OnPlayerSessionStateChangedStaticEPS_jyy, __ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi0ELi2EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __Z49Register_UnityEngine_Animation_get_animatePhysicsv: __Z49Register_UnityEngine_Animation_get_animatePhysicsv, __ZN13TextRendering4Font23VirtualRedirectTransferER14SafeBinaryRead: __ZN13TextRendering4Font23VirtualRedirectTransferER14SafeBinaryRead, __Z69Register_UnityEngine_ScriptableObject_Internal_CreateScriptableObjectv: __Z69Register_UnityEngine_ScriptableObject_Internal_CreateScriptableObjectv, __ZN13ConstantForce7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13ConstantForce7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx9NpFactory12addAggregateEPNS_11PxAggregateEb: __ZN5physx9NpFactory12addAggregateEPNS_11PxAggregateEb, __ZNSt3__227__num_get_unsigned_integralImEET_PKcS3_Rji: __ZNSt3__227__num_get_unsigned_integralImEET_PKcS3_Rji, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE21getProfileZoneManagerEv, __ZN12HingeJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN12HingeJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN11TypeManager7Builder18TraverseDepthFirstERKNS0_4NodeEj: __ZN11TypeManager7Builder18TraverseDepthFirstERKNS0_4NodeEj, __Z45Register_UnityEngine_AnimationClip_get_lengthv: __Z45Register_UnityEngine_AnimationClip_get_lengthv, __ZN5physx2Sq16BucketPrunerCoreC2Eb: __ZN5physx2Sq16BucketPrunerCoreC2Eb, ___randname: ___randname, __Z34ParticleSystem_CUSTOM_SetParticlesP12Il2CppObjectP11Il2CppArrayi: __Z34ParticleSystem_CUSTOM_SetParticlesP12Il2CppObjectP11Il2CppArrayi, __ZNKSt3__25ctypeIcE10do_toupperEPcPKc: __ZNKSt3__25ctypeIcE10do_toupperEPcPKc, __Z48NavMeshAgent_CUSTOM_INTERNAL_CALL_SetDestinationP12Il2CppObjectRK8Vector3f: __Z48NavMeshAgent_CUSTOM_INTERNAL_CALL_SetDestinationP12Il2CppObjectRK8Vector3f, _gzrewind: _gzrewind, __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj: __ZN5physx15PxVehicleUpdate25storeSuspWheelTireResultsERKNS_30ProcessSuspWheelTireOutputDataEPKfPNS_18PxWheelQueryResultEj, __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj: __ZN5physx2Sc19ShapeInstancePairLL23processUserNotificationEjtbj, __ZN14PhysicsManager20SetupDefaultMaterialEv: __ZN14PhysicsManager20SetupDefaultMaterialEv, __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_18RelativeStartEventEEEvhtRKT_: __ZN5physx7profile11EventBufferINS_24PxDefaultContextProviderENS_6shdfnd6MutexTINS0_26WrapperReflectionAllocatorIhEEEENS0_14ScopedLockImplIS7_EENS_24PxProfileNullEventFilterEE10doAddEventINS0_18RelativeStartEventEEEvhtRKT_, __ZNK5physx18PxsDynamicsContext28computeUnconstrainedVelocityEPNS_12PxsRigidBodyE: __ZNK5physx18PxsDynamicsContext28computeUnconstrainedVelocityEPNS_12PxsRigidBodyE, __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv: __ZNK5physx2Sq17SceneQueryManager10getPxSceneEv, __ZZN14Physics2DState10InitializeEvEN37FixedUpdatePhysics2DFixedUpdatestruct7ForwardEv: __ZZN14Physics2DState10InitializeEvEN37FixedUpdatePhysics2DFixedUpdatestruct7ForwardEv, __Z25scripting_array_class_getP11Il2CppClassj: __Z25scripting_array_class_getP11Il2CppClassj, __ZN28LightProbeProxyVolumeManager12CleanupClassEv: __ZN28LightProbeProxyVolumeManager12CleanupClassEv, __ZNK12NavMeshAgent17GetSteeringTargetEv: __ZNK12NavMeshAgent17GetSteeringTargetEv, __ZN21DownloadHandlerScript21SetPreallocatedBufferEP11Il2CppArray: __ZN21DownloadHandlerScript21SetPreallocatedBufferEP11Il2CppArray, __ZNK15GUIEventManager13GetEventCountEv: __ZNK15GUIEventManager13GetEventCountEv, __Z48Register_UnityEngine_Audio_AudioMixer_ClearFloatv: __Z48Register_UnityEngine_Audio_AudioMixer_ClearFloatv, __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12FixedJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN17SurfaceEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN17SurfaceEffector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN19ShaderPropertySheet8CopyFromERKS_: __ZN19ShaderPropertySheet8CopyFromERKS_, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE12createObjectERPhRNS_24PxDeserializationContextE, __ZThn4_N5physx5cloth9SwFactory5cloneERKNS0_5ClothE: __ZThn4_N5physx5cloth9SwFactory5cloneERKNS0_5ClothE, __ZN17AnimationPlayable20GetPlayableClassNameEv: __ZN17AnimationPlayable20GetPlayableClassNameEv, __Z42Register_UnityEngine_Shader_set_maximumLODv: __Z42Register_UnityEngine_Shader_set_maximumLODv, __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED0Ev: __ZN14DrawBufferGLESI11IndexBuffer26IndexBufferUsageMapperGLESED0Ev, __Z50Transform_CUSTOM_INTERNAL_CALL_SetLocalEulerAnglesP12Il2CppObjectRK8Vector3fN4math13RotationOrderE: __Z50Transform_CUSTOM_INTERNAL_CALL_SetLocalEulerAnglesP12Il2CppObjectRK8Vector3fN4math13RotationOrderE, __Z38QualitySettings_Set_Custom_PropShadowsN15QualitySettings13ShadowQualityE: __Z38QualitySettings_Set_Custom_PropShadowsN15QualitySettings13ShadowQualityE, __ZN16BlendShapeVertex8TransferI14SafeBinaryReadEEvRT_: __ZN16BlendShapeVertex8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionE: __ZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionE, __ZN7mecanim9animation9DenseClip8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation9DenseClip8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN10CastFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE: __ZN10CastFilter10postFilterERKN5physx12PxFilterDataERKNS0_10PxQueryHitE, __ZN5physx9NpFactory29releaseArticulationLinkToPoolERNS_18NpArticulationLinkE: __ZN5physx9NpFactory29releaseArticulationLinkToPoolERNS_18NpArticulationLinkE, __ZN5physx24PxcArticulationFnsScalar8multiplyEPNS_2Cm13SpatialVectorEPKS2_RKNS_7PxMat33E: __ZN5physx24PxcArticulationFnsScalar8multiplyEPNS_2Cm13SpatialVectorEPKS2_RKNS_7PxMat33E, __Z25GetShouldShowSplashScreenv: __Z25GetShouldShowSplashScreenv, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVES2_E9doSupportERKNS_6shdfnd3aos5Vec3VERS6_S9_S9_, __ZN9RigidbodyD0Ev: __ZN9RigidbodyD0Ev, _csqrtf: _csqrtf, __ZN11AudioModule17StopVideoTexturesEv: __ZN11AudioModule17StopVideoTexturesEv, __ZN14dtPathCorridor10invalidateEv: __ZN14dtPathCorridor10invalidateEv, __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeLinearLimitERKNS_11PxTransformES4_fb: __ZN5physx2Cm29ConstraintImmediateVisualizer20visualizeLinearLimitERKNS_11PxTransformES4_fb, __Z15MoveReplaceFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z15MoveReplaceFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __ZN14PhysicsManager14CapsuleCastAllERK8Vector3fS2_fS2_fi23QueryTriggerInteraction: __ZN14PhysicsManager14CapsuleCastAllERK8Vector3fS2_fS2_fi23QueryTriggerInteraction, __ZN5physx7profile32PxProfileMemoryEventRecorderImplD0Ev: __ZN5physx7profile32PxProfileMemoryEventRecorderImplD0Ev, __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE: __ZN9Scripting19TypeToScriptingTypeEPKN5Unity4TypeE, _jinit_c_master_control: _jinit_c_master_control, __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_InternalDestroyv: __Z82Register_UnityEngine_Experimental_Director_Playables_INTERNAL_CALL_InternalDestroyv, __Z45Register_UnityEngine_Camera_RenderDontRestorev: __Z45Register_UnityEngine_Camera_RenderDontRestorev, __ZN8GUIState23GetNameOfFocusedControlEv: __ZN8GUIState23GetNameOfFocusedControlEv, __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9UnityGUID8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN17CapsuleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17CapsuleCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer, _jpeg_start_compress: _jpeg_start_compress, _UNITY_png_save_uint_32: _UNITY_png_save_uint_32, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN4FMOD13ChannelGroupI14overrideVolumeEf: __ZN4FMOD13ChannelGroupI14overrideVolumeEf, __ZN21LightProbeProxyVolume23VirtualRedirectTransferER14SafeBinaryRead: __ZN21LightProbeProxyVolume23VirtualRedirectTransferER14SafeBinaryRead, __ZN9ShaderLab11ShaderState15AddDeviceStatesEjPK19ShaderPropertySheetS3_: __ZN9ShaderLab11ShaderState15AddDeviceStatesEjPK19ShaderPropertySheetS3_, __Z48Register_UnityEngine_MaterialPropertyBlock_Clearv: __Z48Register_UnityEngine_MaterialPropertyBlock_Clearv, __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti: __ZN26AnimatorControllerPlayable19ValidateParameterIDE17GetSetValueResulti, __ZN26AnimatorControllerPlayable13GetParametersEv: __ZN26AnimatorControllerPlayable13GetParametersEv, __ZN3WWW8SetErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN3WWW8SetErrorERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale1Ef: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE19setInvInertiaScale1Ef, __Z30Transform_CUSTOM_GetChildCountP12Il2CppObject: __Z30Transform_CUSTOM_GetChildCountP12Il2CppObject, __ZN14MemoryProfiler13ThreadCleanupEv: __ZN14MemoryProfiler13ThreadCleanupEv, __ZN5physx2Sc5Scene9addStaticEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E: __ZN5physx2Sc5Scene9addStaticEPNS_7PxActorERNS0_19BatchInsertionStateEPNS_9PxBounds3E, __ZN5physx6shdfnd5ArrayINS_17PxActiveTransformENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_17PxActiveTransformENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS3_9allocatorIiEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setIiNSt3__24lessIiEENS3_9allocatorIiEEEEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_Audio_AudioMixer_SetFloatv: __Z46Register_UnityEngine_Audio_AudioMixer_SetFloatv, __ZN16PlayerConnection18CreateListenSocketEv: __ZN16PlayerConnection18CreateListenSocketEv, __ZNK25ThreadsafeLinearAllocator17GetProfilerHeaderEPKv: __ZNK25ThreadsafeLinearAllocator17GetProfilerHeaderEPKv, __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12createObjectERPhRNS_24PxDeserializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE12createObjectERPhRNS_24PxDeserializationContextE, __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEER8UnityStr: __ZN8keywords20KeywordNamesToStringERKNSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEENS5_IS7_EEEER8UnityStr, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEaSERKS3_: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEEaSERKS3_, __ZNKSt3__28messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE: __ZNKSt3__28messagesIcE7do_openERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_6localeE, __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE8pushBackEv: __ZN5physx16PxsCCDBlockArrayINS_10PxsCCDBodyELi128EE8pushBackEv, __Z17SetIsWorldPlayingb: __Z17SetIsWorldPlayingb, __Z32Material_CUSTOM_IsKeywordEnabledP12Il2CppObjectP12Il2CppString: __Z32Material_CUSTOM_IsKeywordEnabledP12Il2CppObjectP12Il2CppString, __Z18Transfer_BlittableI8JSONReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx18PxcNpThreadContext10clearStatsEv: __ZN5physx18PxcNpThreadContext10clearStatsEv, __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z59ParticleSystem_SizeOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE11ParseObjectILj1ENS_25GenericInsituStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN4math5Limit8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4math5Limit8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN6Camera7SetNearEf: __ZN6Camera7SetNearEf, __ZN22BaseUnityConnectClient12StartSessionEv: __ZN22BaseUnityConnectClient12StartSessionEv, __Z23GetInvalidFilenameCharsv: __Z23GetInvalidFilenameCharsv, __ZN13BoxCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13BoxCollider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z47Register_UnityEngine_AudioReverbZone_get_reverbv: __Z47Register_UnityEngine_AudioReverbZone_get_reverbv, __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessINS_4pairIjjEES3_EEPS3_EEjT0_S7_S7_S7_T_, __Z45Register_UnityEngine_HingeJoint_get_useLimitsv: __Z45Register_UnityEngine_HingeJoint_get_useLimitsv, __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb: __ZN5physx2Sc5Scene12removeShapesERNS0_8RigidSimERNS_6shdfnd11InlineArrayIPNS0_8ShapeSimELj64ENS4_19ReflectionAllocatorIS7_EEEERNS5_IPKNS0_9ShapeCoreELj64ENS8_ISE_EEEEb, __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_24ShrunkConvexHullNoScaleVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSA_6FloatVERNSA_5Vec3VESI_SI_RSE_PhSK_Rh, __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE: __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_10DebugBasisE, __ZNK9Transform22InverseTransformVectorERK8Vector3f: __ZNK9Transform22InverseTransformVectorERK8Vector3f, __ZN12WheelJoint2D13AwakeFromLoadE17AwakeFromLoadMode: __ZN12WheelJoint2D13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_11ConvexHullVENS0_18ConvexHullNoScaleVEED0Ev, __ZN11ErrorStream11reportErrorEN5physx11PxErrorCode4EnumEPKcS4_i: __ZN11ErrorStream11reportErrorEN5physx11PxErrorCode4EnumEPKcS4_i, __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE: __ZNSt3__26vectorIN22NavMeshProjectSettings15NavMeshAreaDataENS_9allocatorIS2_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS2_RS4_EE, __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE10onComShiftEj, __ZNSt3__26locale5__imp7installINS_15time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEEEEvPT_, __ZN8LODGroup18UpgradeFrom50AssetERKNSt3__26vectorINS_11LODStruct50ENS0_9allocatorIS2_EEEE: __ZN8LODGroup18UpgradeFrom50AssetERKNSt3__26vectorINS_11LODStruct50ENS0_9allocatorIS2_EEEE, __Z55Register_UnityEngine_Animator_INTERNAL_get_rootRotationv: __Z55Register_UnityEngine_Animator_INTERNAL_get_rootRotationv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier66ELi16EEE21__grow_by_and_replaceEjjjjjjPKc, __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimitD0Ev: __ZZN5physx2Sn12RepXUpgrader35upgrade3_2CollectionTo3_3CollectionERNS0_14RepXCollectionEEN28UpdateArticulationSwingLimitD0Ev, __Z20GetGameObjectManagerv: __Z20GetGameObjectManagerv, __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb: __ZN5physx13GuMeshFactory21notifyFactoryListenerEPKNS_6PxBaseEtb, __Z42Application_Set_Custom_PropRunInBackgroundh: __Z42Application_Set_Custom_PropRunInBackgroundh, __ZN4FMOD6System12createReverbEPPNS_6ReverbE: __ZN4FMOD6System12createReverbEPPNS_6ReverbE, __Z65Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplListv: __Z65Register_UnityEngine_MaterialPropertyBlock_SetMatrixArrayImplListv, __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_SetTriggerParticlesv: __Z69Register_UnityEngine_ParticleSystemExtensionsImpl_SetTriggerParticlesv, __ZNK5physx10NpMaterial17getStaticFrictionEv: __ZNK5physx10NpMaterial17getStaticFrictionEv, __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv: __ZThn8_NKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE3__xEv, __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorClipInfoInternalv: __Z104Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetCurrentAnimatorClipInfoInternalv, __ZN16BaseVideoTexture22UploadGfxTextureBufferEPj: __ZN16BaseVideoTexture22UploadGfxTextureBufferEPj, __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode3EEvRK11MinMaxCurveR23ParticleSystemParticlesPfRKN4math7_float4EjjRK8Vector2f, __Z26ScheduleMultiDependencyJobR8JobFenceR18JobBatchDispatcherPS_j: __Z26ScheduleMultiDependencyJobR8JobFenceR18JobBatchDispatcherPS_j, __Z35Terrain_Set_Custom_PropMaterialTypeP12Il2CppObjectN7Terrain12MaterialTypeE: __Z35Terrain_Set_Custom_PropMaterialTypeP12Il2CppObjectN7Terrain12MaterialTypeE, __Z23getPxScene_FilterShaderPKN5physx7PxSceneE: __Z23getPxScene_FilterShaderPKN5physx7PxSceneE, __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip: __ZN12SoundManager22GetHandleFromFMODSoundEPN11SoundHandle8InstanceEjP10SampleClip, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc24ElementInteractionMarkerEEEEEvPT_jRKT0_RKT1_j, __Z46Camera_CUSTOM_INTERNAL_CALL_WorldToScreenPointP12Il2CppObjectRK8Vector3fRS1_: __Z46Camera_CUSTOM_INTERNAL_CALL_WorldToScreenPointP12Il2CppObjectRK8Vector3fRS1_, __ZN39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader: __ZN39AssetBundleLoadFromStreamAsyncOperation38OnArchiveStorageDirectoryInfoProcessedEP23ArchiveStorageConverterP20ArchiveStorageReader, __Z45ParticleSystem_CollisionModule_CUSTOM_GetModeP12Il2CppObject: __Z45ParticleSystem_CollisionModule_CUSTOM_GetModeP12Il2CppObject, __Z15Transfer_StringI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI24GenerateTypeTreeTransferLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z47Register_UnityEngine_Light_set_shadowNormalBiasv: __Z47Register_UnityEngine_Light_set_shadowNormalBiasv, __Z54Register_UnityEngine_ParticleAnimator_set_autodestructv: __Z54Register_UnityEngine_ParticleAnimator_set_autodestructv, __Z47Rigidbody_CUSTOM_INTERNAL_CALL_GetPointVelocityP12Il2CppObjectRK8Vector3fRS1_: __Z47Rigidbody_CUSTOM_INTERNAL_CALL_GetPointVelocityP12Il2CppObjectRK8Vector3fRS1_, __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS9_RSA_EE: __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS9_RSA_EE, __ZN14CachingManager7DisposeEv: __ZN14CachingManager7DisposeEv, __ZNK5physx11HullLibrary10extrudableEf: __ZNK5physx11HullLibrary10extrudableEf, __ZNK9Texture3D20GetStorageMemorySizeEv: __ZNK9Texture3D20GetStorageMemorySizeEv, __ZN13WheelCollider22CreatePhysXObjIfNeededEv: __ZN13WheelCollider22CreatePhysXObjIfNeededEv, __ZN9Scripting20SendScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti: __ZN9Scripting20SendScriptingMessageER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEP12Il2CppObjecti, __ZN4FMOD6System4initEijPv: __ZN4FMOD6System4initEijPv, __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev: __ZNSt3__27num_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEED2Ev, __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE7reserveEj: __ZNSt3__26vectorI11DetailPatchNS_9allocatorIS1_EEE7reserveEj, __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE4findIS2_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStr14CallbackArray2IRKS2_R8JSONReadEEENS_19__map_value_compareIS2_S9_NS_4lessIS2_EELb1EEE13stl_allocatorIS9_L18MemLabelIdentifier5ELi16EEE4findIS2_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_, __Z33GetBlendShapeFrameCountFromScriptRK4Meshi: __Z33GetBlendShapeFrameCountFromScriptRK4Meshi, __ZN5Umbra12OutputStreamD0Ev: __ZN5Umbra12OutputStreamD0Ev, __ZN10systeminfo17SupportsVibrationEv: __ZN10systeminfo17SupportsVibrationEv, __ZN15OcclusionPortal23VirtualRedirectTransferER14SafeBinaryRead: __ZN15OcclusionPortal23VirtualRedirectTransferER14SafeBinaryRead, __Z19dtFreeProximityGridP15dtProximityGrid: __Z19dtFreeProximityGridP15dtProximityGrid, __ZN16CircleCollider2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN16CircleCollider2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefIKhEE: __ZN5physx8debugger4comm16EventStreamifierINS0_19PvdNetworkOutStreamEE9streamifyERNS0_7DataRefIKhEE, __ZN5physx13GuMeshFactoryC2Ev: __ZN5physx13GuMeshFactoryC2Ev, __ZN18ProfilerConnection10InitializeEv: __ZN18ProfilerConnection10InitializeEv, __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayIPNS_6PxBaseENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj, __ZNK9Transform15TransformVectorERK8Vector3f: __ZNK9Transform15TransformVectorERK8Vector3f, __ZN11UnityEngine9Analytics9PerfEventD0Ev: __ZN11UnityEngine9Analytics9PerfEventD0Ev, __ZN5physx3Cct26CharacterControllerManager15setTessellationEbf: __ZN5physx3Cct26CharacterControllerManager15setTessellationEbf, __ZN7mecanim9animation15FindMuscleIndexEj: __ZN7mecanim9animation15FindMuscleIndexEj, __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatARGB4444EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888817TexFormatARGB4444EEvPKNS_9InnerInfoE, __Z49Register_UnityEngine_CanvasGroup_set_interactablev: __Z49Register_UnityEngine_CanvasGroup_set_interactablev, __Z32Renderer_CUSTOM_GetPropertyBlockP12Il2CppObjectS0_: __Z32Renderer_CUSTOM_GetPropertyBlockP12Il2CppObjectS0_, __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D: __ZN10Collider2D16RecreateColliderEbP11Rigidbody2D, __Z66Register_UnityEngine_Connect_UnityConnectSettings_get_testEventUrlv: __Z66Register_UnityEngine_Connect_UnityConnectSettings_get_testEventUrlv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_7NpClothEEEEEvPT_jRKT0_RKT1_j, __ZN5physx38PxVehicleWheels4SimDataGeneratedValuesC2EPKNS_23PxVehicleWheels4SimDataE: __ZN5physx38PxVehicleWheels4SimDataGeneratedValuesC2EPKNS_23PxVehicleWheels4SimDataE, __Z38Register_UnityEngine_Gradient_get_modev: __Z38Register_UnityEngine_Gradient_get_modev, __Z51Register_UnityEngine_Shader_SetGlobalFloatArrayImplv: __Z51Register_UnityEngine_Shader_SetGlobalFloatArrayImplv, __ZN13GfxDeviceNull15ImmediateNormalEfff: __ZN13GfxDeviceNull15ImmediateNormalEfff, __GLOBAL__sub_I_runtime_core_callbacks_lump_cpp: __GLOBAL__sub_I_runtime_core_callbacks_lump_cpp, __ZN5physx6shdfnd10SocketImplD2Ev: __ZN5physx6shdfnd10SocketImplD2Ev, __Z35Canvas_Set_Custom_PropTargetDisplayP12Il2CppObjecti: __Z35Canvas_Set_Custom_PropTargetDisplayP12Il2CppObjecti, __ZN9JSONWrite8TransferI13dynamic_arrayI5RectTIfELj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI5RectTIfELj4EEEEvRT_PKc17TransferMetaFlags, __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7putbackEw: __ZNSt3__213basic_istreamIwNS_11char_traitsIwEEE7putbackEw, __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode0EEvRK11MinMaxCurveR23ParticleSystemParticlesjjPKN4math8floatNx3E, __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z60ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, __Z30AndroidJNI_CUSTOM_FromIntArray13Il2Cpp_IntPtr: __Z30AndroidJNI_CUSTOM_FromIntArray13Il2Cpp_IntPtr, __ZN21DownloadHandlerScript26InvokeReceiveContentLengthEP12Il2CppObjecti: __ZN21DownloadHandlerScript26InvokeReceiveContentLengthEP12Il2CppObjecti, __Z35BillboardAsset_Set_Custom_PropWidthP12Il2CppObjectf: __Z35BillboardAsset_Set_Custom_PropWidthP12Il2CppObjectf, __ZN5physx7NpClothD0Ev: __ZN5physx7NpClothD0Ev, __ZN16GUIKeyboardState5ResetEv: __ZN16GUIKeyboardState5ResetEv, __ZN7dtCrowd20UpdateActiveAgentIDsEv: __ZN7dtCrowd20UpdateActiveAgentIDsEv, _unity_z_deflateSetHeader: _unity_z_deflateSetHeader, __Z43Register_UnityEngine_Animator_GetBoolStringv: __Z43Register_UnityEngine_Animator_GetBoolStringv, __ZN5physx2Sc18TriggerInteractionD2Ev: __ZN5physx2Sc18TriggerInteractionD2Ev, __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE: __ZN7mecanim9animation25DestroyAnimationNodeStateEPNS0_18AnimationNodeStateERNS_6memory9AllocatorE, __ZN11b2GearJoint8SetRatioEf: __ZN11b2GearJoint8SetRatioEf, __Z14GetHaloManagerv: __Z14GetHaloManagerv, __Z21GenerateSpriteOutline4PPtrI9Texture2DEfRK5RectTIfERK8Vector2ffhbjibPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENS9_9allocatorISC_EEEEPSB_I12SpriteVertexLj4EEPSB_ItLj2EEPS3_P8Vector4f: __Z21GenerateSpriteOutline4PPtrI9Texture2DEfRK5RectTIfERK8Vector2ffhbjibPNSt3__26vectorI13dynamic_arrayIS6_Lj4EENS9_9allocatorISC_EEEEPSB_I12SpriteVertexLj4EEPSB_ItLj2EEPS3_P8Vector4f, __Z40Animator_Get_Custom_PropRecorderStopTimeP12Il2CppObject: __Z40Animator_Get_Custom_PropRecorderStopTimeP12Il2CppObject, __ZN16ParticleRenderer16AllocateUVFramesEi: __ZN16ParticleRenderer16AllocateUVFramesEi, __ZN5physx24setVehicleToleranceScaleERKNS_17PxTolerancesScaleE: __ZN5physx24setVehicleToleranceScaleERKNS_17PxTolerancesScaleE, __ZN16MemoryFileSystem11HasFastHashERK13FileEntryDataR7Hash128: __ZN16MemoryFileSystem11HasFastHashERK13FileEntryDataR7Hash128, __ZN12_GLOBAL__N_112UserRenderer6addRefEv: __ZN12_GLOBAL__N_112UserRenderer6addRefEv, __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL22Transfer_ManagedObjectI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_LZ4_decompress_fast_withPrefix64k: _UNITY_LZ4_decompress_fast_withPrefix64k, __ZN15CapsuleCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15CapsuleCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __Z54ParticleSystem_TrailModule_CUSTOM_SetMinVertexDistanceP12Il2CppObjectf: __Z54ParticleSystem_TrailModule_CUSTOM_SetMinVertexDistanceP12Il2CppObjectf, _getifaddrs: _getifaddrs, __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN4Mesh23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z52Register_UnityEngine_Sprite_INTERNAL_get_textureRectv: __Z52Register_UnityEngine_Sprite_INTERNAL_get_textureRectv, __Z30Event_CUSTOM_GetTypeForControlP12Il2CppObjecti: __Z30Event_CUSTOM_GetTypeForControlP12Il2CppObjecti, __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN21UnityAnalyticsManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN6Socket15SetSocketOptionEiib: __ZN6Socket15SetSocketOptionEiib, __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE: __ZN5physx2CmlsERNS0_12RenderOutputERKNS0_11DebugCircleE, __ZN4crnd10dxt5_block14pack_endpointsEjj: __ZN4crnd10dxt5_block14pack_endpointsEjj, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier127ELi16EEE9SelectKeyES7_SA_E9copy_fromERKSD_j, __ZNSt3__213__vector_baseINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEENS5_IS9_Lj4096EEEED2Ev: __ZNSt3__213__vector_baseINS_6vectorINS1_IN10__cxxabiv112_GLOBAL__N_111string_pairENS3_11short_allocIS4_Lj4096EEEEENS5_IS7_Lj4096EEEEENS5_IS9_Lj4096EEEED2Ev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6resizeEj, __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv: __ZN11UnityEngine15CloudWebService17SessionEventQueue10PurgeQueueEv, __ZN20TextRenderingPrivate17TextMeshGenerator8GenerateEv: __ZN20TextRenderingPrivate17TextMeshGenerator8GenerateEv, __ZThn4_NK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE: __ZThn4_NK5physx5cloth9SwFactory24extractMotionConstraintsERKNS0_5ClothENS0_5RangeINS_6PxVec4EEE, __ZN14CompletionTaskD0Ev: __ZN14CompletionTaskD0Ev, __ZN15DirectorManager14ScheduleForAddEP18PlayableController: __ZN15DirectorManager14ScheduleForAddEP18PlayableController, __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_: __ZNSt3__29__num_getIcE19__stage2_float_prepERNS_8ios_baseEPcRcS5_, __ZN12_GLOBAL__N_115StringTableImplD2Ev: __ZN12_GLOBAL__N_115StringTableImplD2Ev, __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE: __ZNSt3__26__treeINS_12__value_typeIPvsEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier83ELi16EEE7destroyEPNS_11__tree_nodeIS3_S2_EE, __ZN5Umbra10PathFinderD2Ev: __ZN5Umbra10PathFinderD2Ev, __Z29GUI_CUSTOM_INTERNAL_get_colorP10ColorRGBAf: __Z29GUI_CUSTOM_INTERNAL_get_colorP10ColorRGBAf, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx3Cct18computeTemporalBoxERNS_17PxExtendedBounds3EffffRKNS_6PxVec3ERKNS_14PxExtendedVec3ES5_: __ZN5physx3Cct18computeTemporalBoxERNS_17PxExtendedBounds3EffffRKNS_6PxVec3ERKNS_14PxExtendedVec3ES5_, __Z49Rigidbody_CUSTOM_INTERNAL_CALL_ResetInertiaTensorP12Il2CppObject: __Z49Rigidbody_CUSTOM_INTERNAL_CALL_ResetInertiaTensorP12Il2CppObject, __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_: __ZN7mecanim8skeleton25SkeletonPoseComputeGlobalIN4math7affineXEEEvPKNS0_8SkeletonEPKNS0_13SkeletonPoseTIT_EEPS9_, __ZN19SkinnedMeshRendererD2Ev: __ZN19SkinnedMeshRendererD2Ev, __Z41setPxArticulationJoint_InternalCompliancePN5physx19PxArticulationJointEf: __Z41setPxArticulationJoint_InternalCompliancePN5physx19PxArticulationJointEf, __ZN5physx22PxcDiscreteNarrowPhaseERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE: __ZN5physx22PxcDiscreteNarrowPhaseERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE, __ZN16Physics2DManager13OverlapCircleERK8Vector2ffiffPK10Collider2D: __ZN16Physics2DManager13OverlapCircleERK8Vector2ffiffPK10Collider2D, __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE: __ZNK13TranslateGLES15GetBufferTargetEN2gl12BufferTargetE, __ZN9Animation13SyncLayerTimeEi: __ZN9Animation13SyncLayerTimeEi, __Z38SparseTexture_Get_Custom_PropIsCreatedP12Il2CppObject: __Z38SparseTexture_Get_Custom_PropIsCreatedP12Il2CppObject, __ZN5physx2Gu25PersistentContactManifold20replaceManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE: __ZN5physx2Gu25PersistentContactManifold20replaceManifoldPointERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE, __ZN12_GLOBAL__N_124PropertyDefinitionHelper16clearNamedValuesEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper16clearNamedValuesEv, __ZN10HumanTrait4Body14GetMuscleCountEv: __ZN10HumanTrait4Body14GetMuscleCountEv, __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectClassv: __Z60Register_UnityEngine_AndroidJNI_INTERNAL_CALL_GetObjectClassv, __ZN10GameObject23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN10GameObject23VirtualRedirectTransferER17RemapPPtrTransfer, __Z13RegisterClassI14EdgeCollider2DEvv: __Z13RegisterClassI14EdgeCollider2DEvv, __ZN9Texture2D14DestroyTextureEv: __ZN9Texture2D14DestroyTextureEv, __ZN9Projector23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN9Projector23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z54ParticleSystem_CollisionModule_CUSTOM_GetMaxPlaneCountP12Il2CppObject: __Z54ParticleSystem_CollisionModule_CUSTOM_GetMaxPlaneCountP12Il2CppObject, __Z54Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleP12Il2CppObjectRK8Vector3fRK11Quaternionf: __Z54Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleP12Il2CppObjectRK8Vector3fRK11Quaternionf, __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameMultiplierP12Il2CppObjectf: __Z73ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameMultiplierP12Il2CppObjectf, __Z43QualitySettings_Set_Custom_PropCurrentLeveli: __Z43QualitySettings_Set_Custom_PropCurrentLeveli, __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6Uint64Ey: __ZN9rapidjson15GenericDocumentINS_4UTF8IcEE13JSONAllocatorS3_E6Uint64Ey, __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager: __Z21CheckMethodParameters21ScriptingMethodIl2CppP11Il2CppClassPS1_jP6ObjectR11MonoManager, __Z38AndroidJNI_CUSTOM_SetStaticDoubleField13Il2Cpp_IntPtrS_d: __Z38AndroidJNI_CUSTOM_SetStaticDoubleField13Il2Cpp_IntPtrS_d, __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE: __ZN5physx7NpScene23addArticulationInternalERNS_14PxArticulationE, __ZN17AudioReverbFilter5ResetEv: __ZN17AudioReverbFilter5ResetEv, __ZN13GfxDeviceGLES18CreateVertexBufferEv: __ZN13GfxDeviceGLES18CreateVertexBufferEv, __Z38Time_Get_Custom_PropTimeSinceLevelLoadv: __Z38Time_Get_Custom_PropTimeSinceLevelLoadv, __ZN26AnimatorControllerPlayable21SetOverrideControllerEP26AnimatorOverrideController: __ZN26AnimatorControllerPlayable21SetOverrideControllerEP26AnimatorOverrideController, __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Unity14CharacterJoint23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv117__class_type_info9can_catchEPKNS_16__shim_type_infoERPv, __ZN2UI14CanvasRenderer20WillDestroyComponentEv: __ZN2UI14CanvasRenderer20WillDestroyComponentEv, __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_: __ZN5UmbraL9newPortalERNS_5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEEERiijjRNS_12SIMDRegisterES7_, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZN12AudioManager14ScheduleSourceEP11AudioSourced: __ZN12AudioManager14ScheduleSourceEP11AudioSourced, __ZN14TimerQueryGLESD0Ev: __ZN14TimerQueryGLESD0Ev, __ZN5Unity5Joint14FinalizeCreateEb: __ZN5Unity5Joint14FinalizeCreateEb, __ZN6prcoreL13inner_stretchILj2ELj2EEEvPKNS_9InnerInfoE: __ZN6prcoreL13inner_stretchILj2ELj2EEEvPKNS_9InnerInfoE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayIN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEEvRT_17TransferMetaFlags, __ZN5Umbra9crc32HashEPKjj: __ZN5Umbra9crc32HashEPKjj, __Z26setPxCloth_DragCoefficientPN5physx7PxClothEf: __Z26setPxCloth_DragCoefficientPN5physx7PxClothEf, __Z62Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_SqrDistancev: __Z62Register_UnityEngine_Bounds_INTERNAL_CALL_Internal_SqrDistancev, __ZN5physx12NpBatchQuery16writeBatchHeaderERKNS_17BatchStreamHeaderE: __ZN5physx12NpBatchQuery16writeBatchHeaderERKNS_17BatchStreamHeaderE, __ZNK5physx10NpMaterial17getReferenceCountEv: __ZNK5physx10NpMaterial17getReferenceCountEv, __ZN5physx2Sq12BucketPrunerD2Ev: __ZN5physx2Sq12BucketPrunerD2Ev, __Z56Register_UnityEngine_RelativeJoint2D_set_correctionScalev: __Z56Register_UnityEngine_RelativeJoint2D_set_correctionScalev, __ZN4FMOD6SoundI7getNameEPci: __ZN4FMOD6SoundI7getNameEPci, __Z29setPxMaterial_DynamicFrictionPN5physx10PxMaterialEf: __Z29setPxMaterial_DynamicFrictionPN5physx10PxMaterialEf, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_10NpMaterialEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZN5Unity5Joint13AwakeFromLoadE17AwakeFromLoadMode: __ZN5Unity5Joint13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_15PxDistanceJointEE12readPropertyIfEEbRT_, __ZN5physx16PxsFluidDynamicsD2Ev: __ZN5physx16PxsFluidDynamicsD2Ev, __Z48Register_UnityEngine_Camera_set_depthTextureModev: __Z48Register_UnityEngine_Camera_set_depthTextureModev, __Z46Register_UnityEngine_Animator_SetTriggerStringv: __Z46Register_UnityEngine_Animator_SetTriggerStringv, _tanh: _tanh, __ZN5physx30PxVehicle4WEnable3WTadpoleModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE: __ZN5physx30PxVehicle4WEnable3WTadpoleModeERNS_22PxVehicleWheelsSimDataERNS_22PxVehicleWheelsDynDataERNS_23PxVehicleDriveSimData4WE, __Z40Joint_Set_Custom_PropEnablePreprocessingP12Il2CppObjecth: __Z40Joint_Set_Custom_PropEnablePreprocessingP12Il2CppObjecth, __Z54Register_UnityEngine_TerrainData_Internal_SetAlphamapsv: __Z54Register_UnityEngine_TerrainData_Internal_SetAlphamapsv, __Z45Camera_CUSTOM_Internal_RenderToCubemapTextureP12Il2CppObjectS0_i: __Z45Camera_CUSTOM_Internal_RenderToCubemapTextureP12Il2CppObjectS0_i, __ZN9b2ContactD2Ev: __ZN9b2ContactD2Ev, __Z51Register_UnityEngine_AndroidJNI_SetStaticFloatFieldv: __Z51Register_UnityEngine_AndroidJNI_SetStaticFloatFieldv, __Z29Mesh_Get_Custom_PropBindposesP12Il2CppObject: __Z29Mesh_Get_Custom_PropBindposesP12Il2CppObject, __ZN11RadixSorterC2Ev: __ZN11RadixSorterC2Ev, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8getSceneEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE8getSceneEv, __ZNK5physx13NpClothFabric7getSetsEPjj: __ZNK5physx13NpClothFabric7getSetsEPjj, __ZN12CubemapArray13AwakeFromLoadE17AwakeFromLoadMode: __ZN12CubemapArray13AwakeFromLoadE17AwakeFromLoadMode, __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN2UI13RectTransform23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIsLj2EEEEvRT_17TransferMetaFlags, __ZN5physx2Sn21SerializationRegistry30registerBinaryMetaDataCallbackEPFvRNS_14PxOutputStreamEE: __ZN5physx2Sn21SerializationRegistry30registerBinaryMetaDataCallbackEPFvRNS_14PxOutputStreamEE, __ZN5physx14PxVehicleGraph10setChannelERNS_25PxVehicleGraphChannelDescEj: __ZN5physx14PxVehicleGraph10setChannelERNS_25PxVehicleGraphChannelDescEj, __ZN19SharedRendererSceneD0Ev: __ZN19SharedRendererSceneD0Ev, __Z17SetupClothManagerv: __Z17SetupClothManagerv, __ZN5physx3Cct13HandleManager10SetupListsEPPvPtS4_S4_: __ZN5physx3Cct13HandleManager10SetupListsEPPvPtS4_S4_, __ZN14RedirectHelper15PerformRedirectEPv: __ZN14RedirectHelper15PerformRedirectEPv, __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_: __Z23GetAllowNameConversionsPK20AllowNameConversionsPKcS3_, __ZN8Animator15ThreadedCleanupEv: __ZN8Animator15ThreadedCleanupEv, __ZNK19LowerResBlitTexture20GetStorageMemorySizeEv: __ZNK19LowerResBlitTexture20GetStorageMemorySizeEv, __Z18ClipAnimationCurveI8Vector3fEbRK17AnimationCurveTplIT_ERS3_ff: __Z18ClipAnimationCurveI8Vector3fEbRK17AnimationCurveTplIT_ERS3_ff, __ZNSt3__28ios_base7failureC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_10error_codeE: __ZNSt3__28ios_base7failureC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNS_10error_codeE, __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_12NpConstraintEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN5physx15PxsParticleData10exportDataERNS_22PxSerializationContextE: __ZN5physx15PxsParticleData10exportDataERNS_22PxSerializationContextE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE16find_last_not_ofEPKwj, ___vsyslog: ___vsyslog, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK9Texture2D25GetImageReferenceInternalEP14ImageReferenceii: __ZNK9Texture2D25GetImageReferenceInternalEP14ImageReferenceii, __Z15GetPositionMeshIL20MeshDistributionMode1ELb1EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo: __Z15GetPositionMeshIL20MeshDistributionMode1ELb1EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo, __Z16DecodeEscapedURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z16DecodeEscapedURLRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv: __ZN11UnityEngine15PlatformWrapper18GetOperatingSystemEv, __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7Joint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZdaPvRKSt9nothrow_t: __ZdaPvRKSt9nothrow_t, __ZN6prcoreL10inner_flipILj3EEEvPhS1_j: __ZN6prcoreL10inner_flipILj3EEEvPhS1_j, __ZN5physx2Sc8ClothSim12updateBoundsEv: __ZN5physx2Sc8ClothSim12updateBoundsEv, __ZNKSt3__217moneypunct_bynameIwLb1EE13do_neg_formatEv: __ZNKSt3__217moneypunct_bynameIwLb1EE13do_neg_formatEv, _jpeg_add_quant_table: _jpeg_add_quant_table, __ZNK5physx19NpArticulationJoint13getSwingLimitERfS1_: __ZNK5physx19NpArticulationJoint13getSwingLimitERfS1_, __ZN5Umbra20getRuntimeInfoStringENS_10InfoStringE: __ZN5Umbra20getRuntimeInfoStringENS_10InfoStringE, __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessINS_4pairIfjEES3_EEPS3_EEjT0_S7_S7_S7_T_, __Z58Register_UnityEngine_AudioSource_set_outputAudioMixerGroupv: __Z58Register_UnityEngine_AudioSource_set_outputAudioMixerGroupv, __Z29Transfer_Blittable_ArrayFieldI8JSONRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead5RectTIfEEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEEclILj83ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN9ShaderLab21SerializedShaderState8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab21SerializedShaderState8TransferI24GenerateTypeTreeTransferEEvRT_, __Z35AndroidJNI_CUSTOM_GetStaticIntField13Il2Cpp_IntPtrS_: __Z35AndroidJNI_CUSTOM_GetStaticIntField13Il2Cpp_IntPtrS_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN11UnityEngine9Animation14GenericBindingELj4EEEEvRT_17TransferMetaFlags, __Z46Register_UnityEngine_Animation_CrossFadeQueuedv: __Z46Register_UnityEngine_Animation_CrossFadeQueuedv, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS7_RS8_EE: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEE26__swap_out_circular_bufferERNS_14__split_bufferIS7_RS8_EE, __ZN16CircleCollider2D9SetRadiusEf: __ZN16CircleCollider2D9SetRadiusEf, __Z57Register_UnityEngine_SystemInfo_get_graphicsMultiThreadedv: __Z57Register_UnityEngine_SystemInfo_get_graphicsMultiThreadedv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj541ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj541ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN21LightProbeProxyVolume17RemoveFromManagerEv: __ZN21LightProbeProxyVolume17RemoveFromManagerEv, __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularXDriveP12Il2CppObjectRK10JointDrive: __Z51ConfigurableJoint_CUSTOM_INTERNAL_set_angularXDriveP12Il2CppObjectRK10JointDrive, __ZN22BaseUnityConnectClient18RequestStateChangeENS_5StateE: __ZN22BaseUnityConnectClient18RequestStateChangeENS_5StateE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxArticulationEEEEclILj87ES4_jEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z35AndroidJNI_CUSTOM_ExceptionDescribev: __Z35AndroidJNI_CUSTOM_ExceptionDescribev, __Z47Register_UnityEngine_Graphics_SetupVertexLightsv: __Z47Register_UnityEngine_Graphics_SetupVertexLightsv, __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f: __ZN5physx36bodyCoreComputeUnconstrainedVelocityERNS_11PxsBodyCoreERKNS_6PxVec3ES4_f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj479ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev: __ZNSt3__215basic_streambufIwNS_11char_traitsIwEEED2Ev, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags, __Z24CalculateKnownPathLengthPKfiPKhS0_PK14dtPathCorridor: __Z24CalculateKnownPathLengthPKfiPKhS0_PK14dtPathCorridor, __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase: __ZN18GfxFramebufferGLES37GetFramebufferNameFromColorAttachmentEP17RenderSurfaceBase, __ZN5physx2Sc8ClothSim18addCollisionSphereEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim18addCollisionSphereEPKNS0_8ShapeSimE, __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI14SubstanceInputNS0_9allocatorIS2_EEEEEvRT_j, __ZN15SerializeTraitsI11ChannelInfoE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI11ChannelInfoE8TransferI14SafeBinaryReadEEvRS0_RT_, __Z36Register_UnityEngine_GUI_FocusWindowv: __Z36Register_UnityEngine_GUI_FocusWindowv, __GLOBAL__sub_I_runtime_physics2d2_lump_cpp: __GLOBAL__sub_I_runtime_physics2d2_lump_cpp, __ZN19BaseConnectSettingsD2Ev: __ZN19BaseConnectSettingsD2Ev, __ZNK10__cxxabiv116__shim_type_info5noop2Ev: __ZNK10__cxxabiv116__shim_type_info5noop2Ev, __ZN10AudioMixer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10AudioMixer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _wctrans_l: _wctrans_l, __Z28Random_CUSTOM_RandomRangeIntii: __Z28Random_CUSTOM_RandomRangeIntii, __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb: __ZN14CachingManager15SetCurrentCacheERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEExb, _UNITY_FT_Atan2: _UNITY_FT_Atan2, __ZN20ArchiveStorageHeader26CanReadHeaderAndBlocksInfoERKNS_6HeaderE: __ZN20ArchiveStorageHeader26CanReadHeaderAndBlocksInfoERKNS_6HeaderE, __ZZN10Collider2D15InitializeClassEvEN30FunctorImpl_81kDidAddComponent4CallEPviR11MessageData: __ZZN10Collider2D15InitializeClassEvEN30FunctorImpl_81kDidAddComponent4CallEPviR11MessageData, __ZN9Animation20BuildAnimationStatesEv: __ZN9Animation20BuildAnimationStatesEv, __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j: __ZN5physx2Sc10NPhaseCore16onOverlapRemovedEPNS0_7ElementES3_j, __Z54TerrainData_Get_Custom_PropInternal_alphamapResolutionP12Il2CppObject: __Z54TerrainData_Get_Custom_PropInternal_alphamapResolutionP12Il2CppObject, __ZN20ArchiveStorageReaderC2Ev: __ZN20ArchiveStorageReaderC2Ev, __ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer: __ZNK9Heightmap28GetHeightRespectingNeighborsEiiPK15TerrainRenderer, __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZDrivev: __Z66Register_UnityEngine_ConfigurableJoint_INTERNAL_get_angularYZDrivev, __ZN12_GLOBAL__N_117ProfileZoneClient19handleClientRemovedEv: __ZN12_GLOBAL__N_117ProfileZoneClient19handleClientRemovedEv, __Z37GraphicsSettings_CUSTOM_SetShaderModeN16GraphicsSettings17BuiltinShaderTypeEN21BuiltinShaderSettings17BuiltinShaderModeE: __Z37GraphicsSettings_CUSTOM_SetShaderModeN16GraphicsSettings17BuiltinShaderTypeEN21BuiltinShaderSettings17BuiltinShaderModeE, __ZN21WorldParticleCollider23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN21WorldParticleCollider23VirtualRedirectTransferER17RemapPPtrTransfer, __Z36Rigidbody_Set_Custom_PropConstraintsP12Il2CppObjecti: __Z36Rigidbody_Set_Custom_PropConstraintsP12Il2CppObjecti, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI14HeightMeshData13stl_allocatorIS4_L18MemLabelIdentifier73ELi16EEEEEEvRT_17TransferMetaFlags, __ZN4FMOD8ChannelI19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD8ChannelI19getReverbPropertiesEP29FMOD_REVERB_CHANNELPROPERTIES, __ZNK7ApiGLES14QueryExtensionEPKc: __ZNK7ApiGLES14QueryExtensionEPKc, __ZN7mecanim9animation18ControllerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim9animation18ControllerConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z27NavMesh_CUSTOM_SetLayerCostif: __Z27NavMesh_CUSTOM_SetLayerCostif, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI14OcclusionSceneLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI14OcclusionSceneLj4EEEEvRT_17TransferMetaFlags, __Z26Light_Get_Custom_PropRangeP12Il2CppObject: __Z26Light_Get_Custom_PropRangeP12Il2CppObject, __ZN4FMOD7SystemI9setDriverEi: __ZN4FMOD7SystemI9setDriverEi, __ZNK17ArchiveFileSystem14FindItemByPathEPKc: __ZNK17ArchiveFileSystem14FindItemByPathEPKc, __ZN5physx2Gu19computePlane_BoxMTDERKNS_7PxPlaneERKNS0_3BoxERNS_10PxSweepHitE: __ZN5physx2Gu19computePlane_BoxMTDERKNS_7PxPlaneERKNS0_3BoxERNS_10PxSweepHitE, __Z23AddComponentsFromVAListR10GameObjectPKcPi: __Z23AddComponentsFromVAListR10GameObjectPKcPi, __ZNK8GUIStyle17DrawTextSelectionER8GUIStateRK5RectTIfER10GUIContentiiRK10ColorRGBAfSA_: __ZNK8GUIStyle17DrawTextSelectionER8GUIStateRK5RectTIfER10GUIContentiiRK10ColorRGBAfSA_, __Z37Register_UnityEngine_GUI_FocusControlv: __Z37Register_UnityEngine_GUI_FocusControlv, __Z46ReflectionProbe_Set_Custom_PropTimeSlicingModeP12Il2CppObjecti: __Z46ReflectionProbe_Set_Custom_PropTimeSlicingModeP12Il2CppObjecti, __ZN8Animator21GetHintWeightPositionEi: __ZN8Animator21GetHintWeightPositionEi, __ZN5physx17PxsFluidCollision25updateFluidShapeCollisionEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_9PxBounds3EPKjPKfPKNS_19PxsW2STransformTempERKNS_22PxsParticleStreamShapeE: __ZN5physx17PxsFluidCollision25updateFluidShapeCollisionEPNS_16PxsFluidParticleEPNS_18PxsFluidTwoWayDataEPNS_6PxVec3ES6_RNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_9PxBounds3EPKjPKfPKNS_19PxsW2STransformTempERKNS_22PxsParticleStreamShapeE, __ZN5physx2Sc20ArticulationJointSim12onDeactivateEj: __ZN5physx2Sc20ArticulationJointSim12onDeactivateEj, __ZN5physx2Sc10NPhaseCoreC2ERNS0_5SceneERKNS_11PxSceneDescE: __ZN5physx2Sc10NPhaseCoreC2ERNS0_5SceneERKNS_11PxSceneDescE, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED0Ev: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEED0Ev, __ZN11b2RopeJointC2EPK14b2RopeJointDef: __ZN11b2RopeJointC2EPK14b2RopeJointDef, __Z36TerrainData_Set_Custom_PropThicknessP12Il2CppObjectf: __Z36TerrainData_Set_Custom_PropThicknessP12Il2CppObjectf, __ZN5physx16PxsFluidDynamics12updatePacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE: __ZN5physx16PxsFluidDynamics12updatePacketENS_16PxsSphUpdateTypeEPNS_6PxVec3EPNS_16PxsFluidParticleERKNS_15PxsParticleCellERKNS_22PxsFluidPacketSectionsERKNS_25PxsFluidPacketHaloRegionsERNS_27PxsFluidDynamicsTempBuffersE, __Z67Register_UnityEngine_RenderSettings_INTERNAL_get_ambientGroundColorv: __Z67Register_UnityEngine_RenderSettings_INTERNAL_get_ambientGroundColorv, __ZN5physx3Ext20computeEllipsoidMassERKNS_6PxVec3Ef: __ZN5physx3Ext20computeEllipsoidMassERKNS_6PxVec3Ef, __ZN14StackAllocatorC2Ej10MemLabelIdPKc: __ZN14StackAllocatorC2Ej10MemLabelIdPKc, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim9animation13LayerConstantEEEEEvRT_17TransferMetaFlags, __ZN4Mesh14SetBoneWeightsEPK13BoneInfluencei: __ZN4Mesh14SetBoneWeightsEPK13BoneInfluencei, __ZNK16ParticleAnimator17GetColorAnimationEP10ColorRGBAf: __ZNK16ParticleAnimator17GetColorAnimationEP10ColorRGBAf, __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11OffMeshLink23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z56Register_UnityEngine_Animator_set_linearVelocityBlendingv: __Z56Register_UnityEngine_Animator_set_linearVelocityBlendingv, _raccess_guess_apple_single: _raccess_guess_apple_single, __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20setMaxMotionDistanceEf: __ZN5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20setMaxMotionDistanceEf, __ZN13GfxDeviceGLES31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj: __ZN13GfxDeviceGLES31DrawIndexedNullGeometryIndirectE16GfxPrimitiveTypeP9GfxBuffer15ComputeBufferIDj, __ZN5physx2Sc5Scene12beforeSolverEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene12beforeSolverEPNS_10PxBaseTaskE, __ZN9Animation23RemoveContainedRendererEP8Renderer: __ZN9Animation23RemoveContainedRendererEP8Renderer, _UNITY_png_read_rows: _UNITY_png_read_rows, __ZN22BaseUnityConnectClient18OnEnterStatePausedEv: __ZN22BaseUnityConnectClient18OnEnterStatePausedEv, __Z24setPxCloth_StretchConfigPN5physx7PxClothENS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigE: __Z24setPxCloth_StretchConfigPN5physx7PxClothENS_22PxClothFabricPhaseType4EnumENS_20PxClothStretchConfigE, __Z54Register_UnityEngine_SurfaceEffector2D_set_useFrictionv: __Z54Register_UnityEngine_SurfaceEffector2D_set_useFrictionv, __ZNK11AudioSource28CalculateDistanceAttenuationEv: __ZNK11AudioSource28CalculateDistanceAttenuationEv, _UNITY_FT_Init_Class_sfnt_service_sfnt_table: _UNITY_FT_Init_Class_sfnt_service_sfnt_table, __ZN9GfxDevice17AfterPluginRenderEv: __ZN9GfxDevice17AfterPluginRenderEv, __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI15NavMeshTileData13stl_allocatorIS1_L18MemLabelIdentifier73ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZNSt3__215messages_bynameIwEC2EPKcj: __ZNSt3__215messages_bynameIwEC2EPKcj, __ZN5physx5cloth14SwSolverKernelI8Scalar4fEclEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fEclEv, __ZN5physx2Gu29computeMTD_CapsuleHeightFieldERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE: __ZN5physx2Gu29computeMTD_CapsuleHeightFieldERNS_6PxVec3ERfRKNS0_7CapsuleERKNS_21PxHeightFieldGeometryERKNS_11PxTransformE, __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff: __ZN5physx5cloth9ClothImplINS0_7SwClothEE28setMotionConstraintScaleBiasEff, __ZN14PlayerSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN14PlayerSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx2Sc9ClothCore14setWakeCounterEf: __ZN5physx2Sc9ClothCore14setWakeCounterEf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEEclILj409ENS_7PxJointEPNS_12PxRigidActorEEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN10Collider2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN10Collider2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5Umbra4Math4asinERKNS_6DoubleE: __ZN5Umbra4Math4asinERKNS_6DoubleE, __ZN4FMOD6SoundI21setMusicChannelVolumeEif: __ZN4FMOD6SoundI21setMusicChannelVolumeEif, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEE6sentryC2ERS3_, __ZN17ArchiveFileSystem22MountArchiveFromMemoryEPKvjb: __ZN17ArchiveFileSystem22MountArchiveFromMemoryEPKvjb, __ZN9ShaderLab20SerializedSubProgram13BufferBinding8TransferI14SafeBinaryReadEEvRT_: __ZN9ShaderLab20SerializedSubProgram13BufferBinding8TransferI14SafeBinaryReadEEvRT_, __ZN5physx3Scb5Scene3addINS0_10ConstraintELb1EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene3addINS0_10ConstraintELb1EEEvRT_RNS0_13ObjectTrackerE, _UNITY_tt_size_done: _UNITY_tt_size_done, __ZN5physx2Sn18RepXCollectionImpl16createCollectionEPKc: __ZN5physx2Sn18RepXCollectionImpl16createCollectionEPKc, _cf2_blues_capture: _cf2_blues_capture, __ZN5physx27PxClothGeodesicTetherCookerC2ERKNS_15PxClothMeshDescE: __ZN5physx27PxClothGeodesicTetherCookerC2ERKNS_15PxClothMeshDescE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj435ES4_NS_6PxVec3EEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_: __ZL23computeSweepConvexPlaneRKN5physx20PxConvexMeshGeometryEPNS_2Gu14ConvexHullDataERKjRKNS_11PxTransformERKNS_6PxVec3ESD_, __ZN8LODGroup20ClearCachedRenderersEv: __ZN8LODGroup20ClearCachedRenderersEv, __Z47TerrainData_Get_Custom_PropAlphamapTextureCountP12Il2CppObject: __Z47TerrainData_Get_Custom_PropAlphamapTextureCountP12Il2CppObject, __Z40CullingGroup_CUSTOM_SetBoundingDistancesP12Il2CppObjectP11Il2CppArray: __Z40CullingGroup_CUSTOM_SetBoundingDistancesP12Il2CppObjectP11Il2CppArray, __ZNKSt3__215__codecvt_utf16IwLb0EE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__215__codecvt_utf16IwLb0EE9do_lengthER11__mbstate_tPKcS5_j, __Z64Register_UnityEngine_Collider_INTERNAL_CALL_ClosestPointOnBoundsv: __Z64Register_UnityEngine_Collider_INTERNAL_CALL_ClosestPointOnBoundsv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj670ES3_RKNS_30PxVehicleAckermannGeometryDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimData4WEEEEclILj670ES3_RKNS_30PxVehicleAckermannGeometryDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9BlobWrite8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim8skeleton8SkeletonEEEvRT_PKc17TransferMetaFlags, __ZN14Texture2DArray19AllocateTextureDataEib: __ZN14Texture2DArray19AllocateTextureDataEib, __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateResetInputAxisstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN34PostLateUpdateResetInputAxisstruct7ForwardEv, __ZN14DetailDatabase17MainThreadCleanupEv: __ZN14DetailDatabase17MainThreadCleanupEv, __ZN17CollisionMeshData13AwakeFromLoadE17AwakeFromLoadMode: __ZN17CollisionMeshData13AwakeFromLoadE17AwakeFromLoadMode, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE23getNumMotionConstraintsEv, __Z38GUI_CUSTOM_INTERNAL_CALL_DoModalWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_RS0_: __Z38GUI_CUSTOM_INTERNAL_CALL_DoModalWindowiRK5RectTIfEP12Il2CppObjectS4_S4_S4_RS0_, __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj: __ZNSt3__26vectorI8Gradient13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE8__appendEj, __ZN5physx2Sn18RepXCollectionImplD2Ev: __ZN5physx2Sn18RepXCollectionImplD2Ev, __ZN11BoxColliderD0Ev: __ZN11BoxColliderD0Ev, __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_: __ZN12ImmediatePtrIN5Unity9ComponentEE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc7Physics13registerClothEv: __ZN5physx2Sc7Physics13registerClothEv, __ZN12QuadTreeNode14PrepareBuffersER15TerrainRenderer: __ZN12QuadTreeNode14PrepareBuffersER15TerrainRenderer, __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_localRotationAxisv: __Z68Register_UnityEngine_ParticleAnimator_INTERNAL_get_localRotationAxisv, _UNITY_ft_pic_container_destroy: _UNITY_ft_pic_container_destroy, __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN8LODGroup23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z37setPxScene_DynamicTreeRebuildRateHintPN5physx7PxSceneEj: __Z37setPxScene_DynamicTreeRebuildRateHintPN5physx7PxSceneEj, __ZN5physx55PxVehicleDriveNWSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE: __ZN5physx55PxVehicleDriveNWSmoothAnalogRawInputsAndSetAnalogInputsERKNS_25PxVehiclePadSmoothingDataERKNS_22PxFixedSizeLookupTableILj8EEERKNS_28PxVehicleDriveNWRawInputDataEfbRNS_16PxVehicleDriveNWE, __ZN18AudioLowPassFilter26SetCutoffFrequencyInternalEf: __ZN18AudioLowPassFilter26SetCutoffFrequencyInternalEf, __ZN5physx27InternalTriangleMeshBuilderD2Ev: __ZN5physx27InternalTriangleMeshBuilderD2Ev, __ZNK9Texture2D12GetGPUHeightEv: __ZNK9Texture2D12GetGPUHeightEv, __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14AreaEffector2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx8debugger14PvdMarshallingIhtE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIhtE12marshalBlockEPKhPhj, __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev: __ZN5physx35PxTriangleMeshGeometryGeneratedInfoC2Ev, _match_in_dir: _match_in_dir, __Z16IsTouchSupportedv: __Z16IsTouchSupportedv, __ZN8VRDevice21StopRenderingToDeviceEv: __ZN8VRDevice21StopRenderingToDeviceEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6lengthEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6lengthEv, __ZN8Material9SetShaderEP6Shader: __ZN8Material9SetShaderEP6Shader, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj658ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj658ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx14PxGetFilterOpsERNS_10PxFilterOp4EnumES2_S2_: __ZN5physx14PxGetFilterOpsERNS_10PxFilterOp4EnumES2_S2_, __Z25GetNbModifiedContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_: __Z25GetNbModifiedContactPairsPKN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES4_, _jpeg_make_c_derived_tbl: _jpeg_make_c_derived_tbl, __ZN9Animation6RewindEv: __ZN9Animation6RewindEv, __ZThn12_N5physx3Ext13RevoluteJointD0Ev: __ZThn12_N5physx3Ext13RevoluteJointD0Ev, _block_trim_used: _block_trim_used, __ZN11AudioSource32CorrectScheduledTimeAfterUnpauseEy: __ZN11AudioSource32CorrectScheduledTimeAfterUnpauseEy, __ZN13GfxDeviceGLES13SetBufferNameEP9GfxBufferPKc: __ZN13GfxDeviceGLES13SetBufferNameEP9GfxBufferPKc, __ZN5physx7NpCloth17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx7NpCloth17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E: __ZN5physx2Cm12RenderOutputlsENS_6PxVec3E, __ZN14ParticleSystem10SetPrewarmEb: __ZN14ParticleSystem10SetPrewarmEb, __Z49Joint_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject: __Z49Joint_Get_Custom_PropAutoConfigureConnectedAnchorP12Il2CppObject, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext10FixedJointEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN19ScriptingInvocationC2EPKcS1_S1_S1_: __ZN19ScriptingInvocationC2EPKcS1_S1_S1_, __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10RectOffset8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20TextRenderingPrivate8TextMesh8SetColorE11ColorRGBA32: __ZN20TextRenderingPrivate8TextMesh8SetColorE11ColorRGBA32, __Z41Rigidbody_Set_Custom_PropDetectCollisionsP12Il2CppObjecth: __Z41Rigidbody_Set_Custom_PropDetectCollisionsP12Il2CppObjecth, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjRKS5_, __Z46Register_UnityEngine_Light_set_bounceIntensityv: __Z46Register_UnityEngine_Light_set_bounceIntensityv, __ZN12b2MotorJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN12b2MotorJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN5physx27InternalTriangleMeshBuilder15releaseEdgeListEv: __ZN5physx27InternalTriangleMeshBuilder15releaseEdgeListEv, __ZN5physx2Sc5Scene13getErrorStateEv: __ZN5physx2Sc5Scene13getErrorStateEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation18MotionNeighborListEEEEvRT_17TransferMetaFlags, __ZL19stbir__support_zerof: __ZL19stbir__support_zerof, __ZN11AudioSource9SetVolumeEf: __ZN11AudioSource9SetVolumeEf, __Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_: __Z26IsStreamedBinaryCompatibleRK16TypeTreeIteratorS1_, __Z29setPxCloth_StiffnessFrequencyPN5physx7PxClothEf: __Z29setPxCloth_StiffnessFrequencyPN5physx7PxClothEf, __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv: __ZN5physx2Sc18ParticleSystemCore14resetFilteringEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12__invariantsEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE12__invariantsEv, __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj: __ZN10__cxxabiv112_GLOBAL__N_15arenaILj4096EE10deallocateEPcj, __Z55Register_UnityEngine_Animation_INTERNAL_get_localBoundsv: __Z55Register_UnityEngine_Animation_INTERNAL_get_localBoundsv, ___cosdf: ___cosdf, __ZNSt3__26vectorIN5physx12PxRaycastHitENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN5physx12PxRaycastHitENS_9allocatorIS2_EEE8__appendEj, __Z35Time_Get_Custom_PropSmoothDeltaTimev: __Z35Time_Get_Custom_PropSmoothDeltaTimev, __ZNK11AudioSource16GetBypassEffectsEv: __ZNK11AudioSource16GetBypassEffectsEv, __Z46Register_UnityEngine_Rigidbody_get_isKinematicv: __Z46Register_UnityEngine_Rigidbody_get_isKinematicv, __ZN5Unity10FixedJointD2Ev: __ZN5Unity10FixedJointD2Ev, __Z22UnregisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE: __Z22UnregisterLogToConsolePFvRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiPKciiiiPFvRK11CppLogEntryEE, __ZN5physx17PxsCCDAdvanceTaskD0Ev: __ZN5physx17PxsCCDAdvanceTaskD0Ev, __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z22TransferField_NonArrayI9JSONWrite27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15NavMeshObstacle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z24GetUIScriptingClassesPtrv: __Z24GetUIScriptingClassesPtrv, __ZN10GISettingsC2Ev: __ZN10GISettingsC2Ev, __ZL38GetApplicationSpecificDataPathAppendixNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_: __ZL38GetApplicationSpecificDataPathAppendixNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERS5_, __ZN2UI18SortForBatchingJobEPNS_14SortingJobDataE: __ZN2UI18SortForBatchingJobEPNS_14SortingJobDataE, __ZN10FlareLayerD0Ev: __ZN10FlareLayerD0Ev, __Z42Register_UnityEngine_LayerMask_NameToLayerv: __Z42Register_UnityEngine_LayerMask_NameToLayerv, __ZNK5physx2Gu10ConvexMesh13getNbVerticesEv: __ZNK5physx2Gu10ConvexMesh13getNbVerticesEv, __ZN7Cubemap23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN7Cubemap23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z26scripting_field_get_offsetP9FieldInfo: __Z26scripting_field_get_offsetP9FieldInfo, _send_tree: _send_tree, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx11HullLibrary9overhullvEPNS_6float3EiiRS2_RiRPiS4_ffif: __ZN5physx11HullLibrary9overhullvEPNS_6float3EiiRS2_RiRPiS4_ffif, __ZN5physx14PxsComputeAABBEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS3_: __ZN5physx14PxsComputeAABBEPKNS_12PxsRigidCoreERKNS_9PxBounds3ERS3_, __Z21getPxAggregate_ActorsPKN5physx11PxAggregateEPPNS_7PxActorEj: __Z21getPxAggregate_ActorsPKN5physx11PxAggregateEPPNS_7PxActorEj, __ZN17AudioCustomFilter12readCallbackEP14FMOD_DSP_STATEPfS2_jii: __ZN17AudioCustomFilter12readCallbackEP14FMOD_DSP_STATEPfS2_jii, __Z46ParticleSystem_MainModule_CUSTOM_GetStartDelayP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_GetStartDelayP12Il2CppObjectR15MonoMinMaxCurve, __Z40NavMeshAgent_Get_Custom_PropAccelerationP12Il2CppObject: __Z40NavMeshAgent_Get_Custom_PropAccelerationP12Il2CppObject, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE16getInvMassScale0Ev, __ZN14DirectorPlayer4PlayE9HPlayableP12Il2CppObject: __ZN14DirectorPlayer4PlayE9HPlayableP12Il2CppObject, __ZN21RotationBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21RotationBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE20getBoundingBoxCenterEv, __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe: __ZN16ReflectionProbes15AcquireRendererEPK15ReflectionProbe, __ZN7mecanim12statemachine21DoBlendTreeEvaluationERKNS0_13StateConstantERNS0_11StateOutputERNS0_14StateWorkspaceERKNS_18ValueArrayConstantERKNS0_17StateMachineInputEb: __ZN7mecanim12statemachine21DoBlendTreeEvaluationERKNS0_13StateConstantERNS0_11StateOutputERNS0_14StateWorkspaceERKNS_18ValueArrayConstantERKNS0_17StateMachineInputEb, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN24RigidbodyMovementState2D23ResetInterpolationStateEb: __ZN24RigidbodyMovementState2D23ResetInterpolationStateEb, __ZN11Rigidbody2D16CorrectBodyStateEv: __ZN11Rigidbody2D16CorrectBodyStateEv, __ZN18AudioMixerSnapshotC2E10MemLabelId18ObjectCreationMode: __ZN18AudioMixerSnapshotC2E10MemLabelId18ObjectCreationMode, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE7releaseEv: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE7releaseEv, __Z52Register_UnityEngine_AndroidJNI_CallStaticByteMethodv: __Z52Register_UnityEngine_AndroidJNI_CallStaticByteMethodv, __ZN28ApplyBuiltinInstanceProperty4InitER9GfxDevice: __ZN28ApplyBuiltinInstanceProperty4InitER9GfxDevice, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer8PvdPointEEE, __ZN4Mesh21AwakeFromLoadThreadedEv: __ZN4Mesh21AwakeFromLoadThreadedEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, __ZNK16ReflectionProbes17GetDefaultTextureEPb: __ZNK16ReflectionProbes17GetDefaultTextureEPb, __ZN10AudioMixer8GetFloatEPKcPf: __ZN10AudioMixer8GetFloatEPKcPf, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_4BoxVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags, __ZN13GfxDeviceGLES19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_: __ZN13GfxDeviceGLES19ResolveColorSurfaceE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_, __ZN13UnityProfiler11SetIsActiveEb: __ZN13UnityProfiler11SetIsActiveEb, __ZN20UnityConnectSettings11SetTestModeEb: __ZN20UnityConnectSettings11SetTestModeEb, __ZNK5physx7NpCloth21getDampingCoefficientEv: __ZNK5physx7NpCloth21getDampingCoefficientEv, __Z40Renderer_Get_Custom_PropStaticBatchIndexP12Il2CppObject: __Z40Renderer_Get_Custom_PropStaticBatchIndexP12Il2CppObject, __ZN5physx2Sc5Scene5flushEb: __ZN5physx2Sc5Scene5flushEb, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZN19ClampVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19ClampVelocityModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEEclILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESB_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z69Register_UnityEngine_AvatarBuilder_INTERNAL_CALL_BuildHumanAvatarMonov: __Z69Register_UnityEngine_AvatarBuilder_INTERNAL_CALL_BuildHumanAvatarMonov, __ZThn4_N12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv: __ZThn4_N12_GLOBAL__N_117ConnectionManager19onInstanceDestroyedEPKv, __ZL19CleanupModule_Umbrav: __ZL19CleanupModule_Umbrav, __ZNK12GUIClipState10GetTopRectEv: __ZNK12GUIClipState10GetTopRectEv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf: __ZN5physx5cloth9ClothImplINS0_7SwClothEE18setSolverFrequencyEf, __ZN12IFileAdapter5CloseER13FileEntryData: __ZN12IFileAdapter5CloseER13FileEntryData, __Z47NavMeshAgent_CUSTOM_INTERNAL_get_steeringTargetP12Il2CppObjectP8Vector3f: __Z47NavMeshAgent_CUSTOM_INTERNAL_get_steeringTargetP12Il2CppObjectP8Vector3f, __Z53Register_UnityEngine_Physics2D_set_velocityIterationsv: __Z53Register_UnityEngine_Physics2D_set_velocityIterationsv, __ZNK15OcclusionPortal26GetTypeInfoVirtualInternalEv: __ZNK15OcclusionPortal26GetTypeInfoVirtualInternalEv, __Z45SystemInfo_CUSTOM_SupportsRenderTextureFormat19RenderTextureFormat: __Z45SystemInfo_CUSTOM_SupportsRenderTextureFormat19RenderTextureFormat, __Z65Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorRotationv: __Z65Register_UnityEngine_Rigidbody_INTERNAL_get_inertiaTensorRotationv, __ZN5physx6shdfnd7FastIPC7releaseEv: __ZN5physx6shdfnd7FastIPC7releaseEv, __ZNSt3__26vectorIPFvPviR11MessageDataENS_9allocatorIS5_EEE8__appendEjRKS5_: __ZNSt3__26vectorIPFvPviR11MessageDataENS_9allocatorIS5_EEE8__appendEjRKS5_, __ZN4FMOD7SystemI19getHardwareChannelsEPi: __ZN4FMOD7SystemI19getHardwareChannelsEPi, __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayyPvPy: __ZN21AssetBundleFileSystem5WriteER13FileEntryDatayyPvPy, __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram13BufferBindingEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE: __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram13BufferBindingEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE, _fesetexceptflag: _fesetexceptflag, __Z32BillboardAsset_CUSTOM_SetIndicesP12Il2CppObjectP11Il2CppArray: __Z32BillboardAsset_CUSTOM_SetIndicesP12Il2CppObjectP11Il2CppArray, __GLOBAL__sub_I_runtime_physics2d_lump_cpp: __GLOBAL__sub_I_runtime_physics2d_lump_cpp, __ZN5physx2Sc35ParticleElementRbElementInteractionD0Ev: __ZN5physx2Sc35ParticleElementRbElementInteractionD0Ev, __ZN5physx12NpBatchQuery11getRunOnSpuEv: __ZN5physx12NpBatchQuery11getRunOnSpuEv, __ZN18ScriptingArguments13IncreaseCountEv: __ZN18ScriptingArguments13IncreaseCountEv, _UNITY_FT_Get_Glyph: _UNITY_FT_Get_Glyph, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE27Converter_SimpleNativeClassI8GUIStyleEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZNK5physx14NpArticulation8getLinksEPPNS_18PxArticulationLinkEj: __ZNK5physx14NpArticulation8getLinksEPPNS_18PxArticulationLinkEj, __ZN12NavMeshAgent23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN12NavMeshAgent23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN13SpringJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SpringJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj: __ZThn124_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE10startEventEtyj, __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType: __ZN12BaseRenderer26SetLightmapIndexIntNoDirtyEi12LightmapType, __ZN5Umbra18CellGraphTraversal9enterNodeERKNS_10PortalNodeE: __ZN5Umbra18CellGraphTraversal9enterNodeERKNS_10PortalNodeE, __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer13BeginTransferEPKcS1_Pc17TransferMetaFlags, __ZN29BillboardTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN29BillboardTreeInstanceRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE11attachShapeERNS_7PxShapeE, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6snextcEv: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6snextcEv, __Z22PointDistanceToFrustumRK8Vector4fPK5Planei: __Z22PointDistanceToFrustumRK8Vector4fPK5Planei, __ZN15MulticastSocket7DisbandEv: __ZN15MulticastSocket7DisbandEv, __Z47Register_UnityEngine_Time_get_unscaledDeltaTimev: __Z47Register_UnityEngine_Time_get_unscaledDeltaTimev, __Z33Material_CUSTOM_GetColorArrayImplP12Il2CppObjecti: __Z33Material_CUSTOM_GetColorArrayImplP12Il2CppObjecti, __Z51Register_UnityEngine_Collider2D_INTERNAL_get_boundsv: __Z51Register_UnityEngine_Collider2D_INTERNAL_get_boundsv, __ZNK5physx2Sc9ClothCore20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE: __ZNK5physx2Sc9ClothCore20getMotionConstraintsEPNS_31PxClothParticleMotionConstraintE, __Z37MaterialPropertyBlock_CUSTOM_GetFloatP12Il2CppObjecti: __Z37MaterialPropertyBlock_CUSTOM_GetFloatP12Il2CppObjecti, __ZN12CachedReader15UpdateReadCacheEPvj: __ZN12CachedReader15UpdateReadCacheEPvj, __ZN5physx5cloth11SwCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EEPNS_13PxProfileZoneE: __ZN5physx5cloth11SwCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EEPNS_13PxProfileZoneE, __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15ReflectionProbe23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN6prcoreL27StretchGenericFloatBilinearI14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI14TexFormatRHalfEEvPKNS_9InnerInfoE, __Z28Mesh_CUSTOM_GetTrianglesImplP12Il2CppObjecti: __Z28Mesh_CUSTOM_GetTrianglesImplP12Il2CppObjecti, __ZNSt3__218__insertion_sort_3IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEvT0_S6_T_, __ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib: __ZNK14b2CapsuleShape11ComputeAABBEP6b2AABBRK11b2Transformib, __ZN15FrictionJoint2D6CreateEv: __ZN15FrictionJoint2D6CreateEv, __ZN9profiling14SamplerManagerC2Ev: __ZN9profiling14SamplerManagerC2Ev, __Z11SkinGenericILi1ELb1ELb1EEvR12SkinMeshInfo: __Z11SkinGenericILi1ELb1ELb1EEvR12SkinMeshInfo, __ZN5physx12InlineBufferIjLj1024EE4freeEv: __ZN5physx12InlineBufferIjLj1024EE4freeEv, __ZNK29ParticleSystemPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK29ParticleSystemPropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_: __ZNSt3__27__sort3IRNS_6__lessIiiEEPiEEjT0_S5_S5_T_, __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_: __ZN7Joint2D8TransferI14SafeBinaryReadEEvRT_, __ZN9Rigidbody12MovePositionERK8Vector3f: __ZN9Rigidbody12MovePositionERK8Vector3f, __Z27InsertAnimationClipCurveIDsR14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEER13AnimationClip: __Z27InsertAnimationClipCurveIDsR14dense_hash_mapI7CurveIDj10hash_curveNSt3__28equal_toIS0_EE13stl_allocatorINS2_4pairIKS0_jEEL18MemLabelIdentifier1ELi16EEER13AnimationClip, __ZN4FMOD6System19getSoftwareChannelsEPi: __ZN4FMOD6System19getSoftwareChannelsEPi, __Z15CleanupVRModulev: __Z15CleanupVRModulev, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadsEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z17PrepareUDPAddressPKctP8sockaddrjih: __Z17PrepareUDPAddressPKctP8sockaddrjih, __ZN2UI11CanvasGroup21SetIgnoreParentGroupsEb: __ZN2UI11CanvasGroup21SetIgnoreParentGroupsEb, __GLOBAL__sub_I_SizeByVelocityModule_cpp: __GLOBAL__sub_I_SizeByVelocityModule_cpp, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE27getNumSeparationConstraintsEv, __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_S5_T_, __ZNSt3__26vectorIPN5physx15PxVehicleWheelsENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN5physx15PxVehicleWheelsENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN8LODGroup3LODENS_9allocatorIS2_EEE8__appendEj, __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode: __ZN18AwakeFromLoadQueue3AddER6ObjectPK8TypeTreeb17AwakeFromLoadMode, __Z38QualitySettings_CUSTOM_SetQualityLevelih: __Z38QualitySettings_CUSTOM_SetQualityLevelih, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN30RuntimeInitializeOnLoadManager15ClassMethodInfoE13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEvRT_j, __Z31SparseTexture_CUSTOM_UnloadTileP12Il2CppObjectiii: __Z31SparseTexture_CUSTOM_UnloadTileP12Il2CppObjectiii, __ZNK14TerrainManager16GetActiveTerrainEv: __ZNK14TerrainManager16GetActiveTerrainEv, __ZN15SerializeTraitsINSt3__24pairI7Hash128S2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI7Hash128S2_EEE8TransferI14SafeBinaryReadEEvRS3_RT_, __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14ParticleSystem8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z13TransferFieldI19StreamedBinaryWriteILb0EELb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_: __Z13TransferFieldI19StreamedBinaryWriteILb0EELb0E27Converter_SimpleNativeClassI17AnimationCurveTplIfEEEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT1_, __ZN15ResourceManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15ResourceManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN14ParticleSystem14SetScalingModeE25ParticleSystemScalingMode: __ZN14ParticleSystem14SetScalingModeE25ParticleSystemScalingMode, __Z48Register_UnityEngine_Animator_get_parameterCountv: __Z48Register_UnityEngine_Animator_get_parameterCountv, __ZN5physx2Sn18RepXCollectionImpl14createRepXNodeEPKc: __ZN5physx2Sn18RepXCollectionImpl14createRepXNodeEPKc, __ZN18BuoyancyEffector2D14SetAngularDragEf: __ZN18BuoyancyEffector2D14SetAngularDragEf, __Z50Register_UnityEngine_Camera_get_layerCullDistancesv: __Z50Register_UnityEngine_Camera_get_layerCullDistancesv, __ZN5physx7NpCloth23setSelfCollisionIndicesEPKjj: __ZN5physx7NpCloth23setSelfCollisionIndicesEPKjj, __ZN17BaseWebCamTextureD2Ev: __ZN17BaseWebCamTextureD2Ev, __ZN4FMOD6System15getOutputHandleEPPv: __ZN4FMOD6System15getOutputHandleEPPv, __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId: __ZN15SerializeTraitsI13dynamic_arrayI10Matrix4x4fLj4EEE19ResizeSTLStyleArrayERS2_iRK10MemLabelId, __Z33Gradient_Set_Custom_PropColorKeysP12Il2CppObjectP11Il2CppArray: __Z33Gradient_Set_Custom_PropColorKeysP12Il2CppObjectP11Il2CppArray, __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN18AudioMixerSnapshot8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv: __ZNK21ScriptingObjectOfTypeI12CubemapArrayEptEv, __ZN17OverlapBoxQuery2DD0Ev: __ZN17OverlapBoxQuery2DD0Ev, __ZN43MultiWriterSingleReaderAtomicCircularBuffer18GetNextPayloadSizeEv: __ZN43MultiWriterSingleReaderAtomicCircularBuffer18GetNextPayloadSizeEv, __ZN5physx23solveConcludeExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx23solveConcludeExtContactERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl17getPropertiesImplEN5physx8debugger18NonNegativeIntegerERPNS2_19PropertyDescriptionERjS7_: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl17getPropertiesImplEN5physx8debugger18NonNegativeIntegerERPNS2_19PropertyDescriptionERjS7_, __Z40TextGenerator_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_: __Z40TextGenerator_CUSTOM_GetVerticesInternalP12Il2CppObjectS0_, __Z33WheelCollider_CUSTOM_GetGroundHitP12Il2CppObjectP12MonoWheelHit: __Z33WheelCollider_CUSTOM_GetGroundHitP12Il2CppObjectP12MonoWheelHit, __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5RectTIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix2v: __Z50Register_UnityEngine_AudioChorusFilter_get_wetMix2v, __Z21CubemapConvolutionJobP22CubemapConvolutionDataj: __Z21CubemapConvolutionJobP22CubemapConvolutionDataj, __ZZ23InitPlayerLoopCallbacksvEN27FixedUpdateClearLinesstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN27FixedUpdateClearLinesstruct7ForwardEv, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK10SampleClip12GetLoadStateEv: __ZNK10SampleClip12GetLoadStateEv, __ZN16MemoryFileSystem4LockER13FileEntryData12FileLockMode: __ZN16MemoryFileSystem4LockER13FileEntryData12FileLockMode, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIiN19AssetBundleManifest15AssetBundleInfoENSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags, __ZNKSt3__28numpunctIcE11do_groupingEv: __ZNKSt3__28numpunctIcE11do_groupingEv, __Z19free_alloc_internalPvRK10MemLabelId: __Z19free_alloc_internalPvRK10MemLabelId, __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXv: __Z67Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetXv, __ZN16BaseVideoTexture17StopVideoTexturesEv: __ZN16BaseVideoTexture17StopVideoTexturesEv, __ZN12_GLOBAL__N_110DataStream17pushBackObjectRefEPKvPKcS2_: __ZN12_GLOBAL__N_110DataStream17pushBackObjectRefEPKvPKcS2_, __ZN5physx18PxVehicleDriveTank8allocateEj: __ZN5physx18PxVehicleDriveTank8allocateEj, __ZN10systeminfo19GetPhysicalMemoryMBEv: __ZN10systeminfo19GetPhysicalMemoryMBEv, __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE: __ZN5physx16copyToSolverBodyERNS_13PxcSolverBodyERNS_17PxcSolverBodyDataERKNS_11PxsBodyCoreERNS_12PxsRigidBodyE, _strlcpy: _strlcpy, __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12CubemapArray23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN13WebCamTexture6UpdateEv: __ZN13WebCamTexture6UpdateEv, __ZNK5physx2Sn5ConvX12getMetaClassEiNS0_12MetaDataTypeE: __ZNK5physx2Sn5ConvX12getMetaClassEiNS0_12MetaDataTypeE, _putchar_unlocked: _putchar_unlocked, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_11ConvexHullVENS0_17ShrunkConvexHullVEE13populateVertsEPKhjPKNS_6PxVec3EPNS_6shdfnd3aos5Vec3VE, __ZN4PPtrI15OcclusionPortalE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI15OcclusionPortalE8TransferI14SafeBinaryReadEEvRT_, __Z30GeomOverlapCallback_SphereMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __Z30GeomOverlapCallback_SphereMeshRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __ZN13TextRendering4Font12CleanupClassEv: __ZN13TextRendering4Font12CleanupClassEv, __Z49Register_UnityEngine_Transform_get_parentInternalv: __Z49Register_UnityEngine_Transform_get_parentInternalv, __ZN13MonoBehaviour6UpdateEv: __ZN13MonoBehaviour6UpdateEv, _log10: _log10, ___tandf: ___tandf, _UNITY_png_do_read_interlace: _UNITY_png_do_read_interlace, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj617ES4_NS_6PxVec3EKjNS_18PxUnknownClassInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN5physx3Scb5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb: __ZN5physx3Scb5Scene19addBroadPhaseRegionERKNS_18PxBroadPhaseRegionEb, __ZN19CloudServiceHandler14SetServiceInfoENS_11ServiceTypeE: __ZN19CloudServiceHandler14SetServiceInfoENS_11ServiceTypeE, __Z49Register_UnityEngine_TrailRenderer_get_startWidthv: __Z49Register_UnityEngine_TrailRenderer_get_startWidthv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj614ES4_NS_18PxVehicleWheelDataEKjNS_31PxVehicleWheelDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZN22BuiltinResourceManager16RegisterResourceExPKcPKN5Unity4TypeEb: __ZN22BuiltinResourceManager16RegisterResourceExPKcPKN5Unity4TypeEb, __ZN19ShaderPropertySheetD2Ev: __ZN19ShaderPropertySheetD2Ev, __ZN13GfxDeviceNull32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat: __ZN13GfxDeviceNull32CreateDepthRenderSurfacePlatformEP17RenderSurfaceBase17DepthBufferFormat, __ZL36RegisterModuleICalls_UnityWebRequestv: __ZL36RegisterModuleICalls_UnityWebRequestv, __ZL28PostprocessWebGLGraphicsCapsv: __ZL28PostprocessWebGLGraphicsCapsv, __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIcNS_8debugger19ForwardingAllocatorEED2Ev, __ZN5UmbraL21buildShadowCullerImplEPNS_8QueryExtEPNS_15ImpShadowCullerEPKNS_10VisibilityEPKNS_15CameraTransformERKNS_7Vector3EPSB_iPfjPS9_i: __ZN5UmbraL21buildShadowCullerImplEPNS_8QueryExtEPNS_15ImpShadowCullerEPKNS_10VisibilityEPKNS_15CameraTransformERKNS_7Vector3EPSB_iPfjPS9_i, __ZN9Projector12AddToManagerEv: __ZN9Projector12AddToManagerEv, __Z25GetUncheckedRealGfxDevicev: __Z25GetUncheckedRealGfxDevicev, __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii: __ZN5Umbra20RuntimeTomeGenerator15getMatchingTreeEii, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags, __ZN16ReflectionSampleC2Ev: __ZN16ReflectionSampleC2Ev, __ZN18GfxFramebufferGLES21GrabIntoRenderTextureEP17RenderSurfaceGLESiiii: __ZN18GfxFramebufferGLES21GrabIntoRenderTextureEP17RenderSurfaceGLESiiii, __Z40getPxParticleReadDataValidParticleBitmapPKN5physx18PxParticleReadDataE: __Z40getPxParticleReadDataValidParticleBitmapPKN5physx18PxParticleReadDataE, __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED0Ev: __ZN26IntersectAnyVsMeshCallbackILi2ELb0EED0Ev, __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_set_forcev: __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_set_forcev, __ZN5physx2Sc35ParticleElementRbElementInteraction10onActivateEj: __ZN5physx2Sc35ParticleElementRbElementInteraction10onActivateEj, __Z37Component_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr: __Z37Component_CUSTOM_GetComponentFastPathP12Il2CppObjectS0_13Il2Cpp_IntPtr, __ZN5Umbra13MatrixFactory7frustumEffff: __ZN5Umbra13MatrixFactory7frustumEffff, __ZN5physx2Cm12RenderBuffer5shiftERKNS_6PxVec3E: __ZN5physx2Cm12RenderBuffer5shiftERKNS_6PxVec3E, __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientLightP10ColorRGBAf: __Z47RenderSettings_CUSTOM_INTERNAL_get_ambientLightP10ColorRGBAf, _log1p: _log1p, __ZN5physx24updateCollDataStaticMeshERNS_19PxsParticleCollDataERKNS_11PxTransformEf: __ZN5physx24updateCollDataStaticMeshERNS_19PxsParticleCollDataERKNS_11PxTransformEf, __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv: __ZNK20DynamicHeapAllocatorI17LowLevelAllocatorE15FindPoolFromPtrEPKv, __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE: __Z29AwakeAndActivateClonedObjectsRK10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINS0_4pairIiiEEL18MemLabelIdentifier1ELi16EEE, __Z50getPxSimulationStatisticsParticlesGpuMeshCacheSizePKN5physx22PxSimulationStatisticsE: __Z50getPxSimulationStatisticsParticlesGpuMeshCacheSizePKN5physx22PxSimulationStatisticsE, __Z78Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSingleWithParentv: __Z78Register_UnityEngine_Object_INTERNAL_CALL_Internal_InstantiateSingleWithParentv, __ZN7b2Joint6CreateEPK10b2JointDefP16b2BlockAllocator: __ZN7b2Joint6CreateEPK10b2JointDefP16b2BlockAllocator, __Z43scripting_object_invoke_default_constructorP12Il2CppObjectPP15Il2CppException: __Z43scripting_object_invoke_default_constructorP12Il2CppObjectPP15Il2CppException, __ZN5Umbra12PortalCuller12finalizeCellEt: __ZN5Umbra12PortalCuller12finalizeCellEt, __ZN15CollisionEvents10SortEventsEv: __ZN15CollisionEvents10SortEventsEv, __ZNKSt3__27collateIwE10do_compareEPKwS3_S3_S3_: __ZNKSt3__27collateIwE10do_compareEPKwS3_S3_S3_, __ZNK9DebugGLES14BufferBindingsEv: __ZNK9DebugGLES14BufferBindingsEv, __ZNK8Animator13IsOptimizableEv: __ZNK8Animator13IsOptimizableEv, __ZN16LightmapSettingsC2E10MemLabelId18ObjectCreationMode: __ZN16LightmapSettingsC2E10MemLabelId18ObjectCreationMode, __ZN17AudioCustomFilter21WaitForScriptCallbackEv: __ZN17AudioCustomFilter21WaitForScriptCallbackEv, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData9PoolData8EEEEEvPT_jRKT0_RKT1_j, __Z27Event_Set_Custom_PropButtonP12Il2CppObjecti: __Z27Event_Set_Custom_PropButtonP12Il2CppObjecti, __Z47Register_UnityEngine_GUIStyle_set_stretchHeightv: __Z47Register_UnityEngine_GUIStyle_set_stretchHeightv, __ZNK5physx7PxShape8isKindOfEPKc: __ZNK5physx7PxShape8isKindOfEPKc, __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE: __ZNKSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3getES4_S4_bRNS_8ios_baseERjRNS_12basic_stringIcS3_NS_9allocatorIcEEEE, __ZNK5Light26GetTypeInfoVirtualInternalEv: __ZNK5Light26GetTypeInfoVirtualInternalEv, __ZZN2UI23InitializeCanvasManagerEvEN45PostLateUpdateUpdateCanvasRectTransformstruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN45PostLateUpdateUpdateCanvasRectTransformstruct7ForwardEv, _duplocale: _duplocale, __Z48AudioSource_Get_Custom_PropBypassListenerEffectsP12Il2CppObject: __Z48AudioSource_Get_Custom_PropBypassListenerEffectsP12Il2CppObject, __ZNK5physx16PxsBroadPhaseMBP24getNumOutOfBoundsObjectsEv: __ZNK5physx16PxsBroadPhaseMBP24getNumOutOfBoundsObjectsEv, __Z15PlayerInitStatev: __Z15PlayerInitStatev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj418ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK29ParticleSystemPropertyBinding22GetClassIDForAttributeEj: __ZNK29ParticleSystemPropertyBinding22GetClassIDForAttributeEj, _cff_size_select: _cff_size_select, __Z41RenderTexture_Get_Custom_PropAntiAliasingP12Il2CppObject: __Z41RenderTexture_Get_Custom_PropAntiAliasingP12Il2CppObject, __ZN5physx2Sq10AABBPruner5purgeEv: __ZN5physx2Sq10AABBPruner5purgeEv, __ZN17SizeBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17SizeBySpeedModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN4File5WriteEPKvj: __ZN4File5WriteEPKvj, __Z53Register_UnityEngine_Physics2D_set_queriesHitTriggersv: __Z53Register_UnityEngine_Physics2D_set_queriesHitTriggersv, __Z20AddKeySmoothTangentsR17AnimationCurveTplIfEff: __Z20AddKeySmoothTangentsR17AnimationCurveTplIfEff, __Z13RegisterClassI18CrashReportManagerEvv: __Z13RegisterClassI18CrashReportManagerEvv, __ZN22BaseUnityConnectClient12ProcessStateENS_5StateE: __ZN22BaseUnityConnectClient12ProcessStateENS_5StateE, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERf: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERf, __ZN5Umbra9BitVectorD2Ev: __ZN5Umbra9BitVectorD2Ev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERe: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERe, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERb: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERb, __ZN5physx23ProjectionPlanePropertyC2Ev: __ZN5physx23ProjectionPlanePropertyC2Ev, __ZNKSt3__210moneypunctIwLb1EE13negative_signEv: __ZNKSt3__210moneypunctIwLb1EE13negative_signEv, __ZN9Animation10RemoveClipER13AnimationClip: __ZN9Animation10RemoveClipER13AnimationClip, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERm: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERm, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERj: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERj, __ZN5physx2Cm29ConstraintImmediateVisualizerD0Ev: __ZN5physx2Cm29ConstraintImmediateVisualizerD0Ev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERt: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERt, ___setxid: ___setxid, __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalSetContentTypev: __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalSetContentTypev, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERs: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERs, __ZN7mecanim9animation28MotionOutputGetDeltaPositionEPKNS0_12MotionOutputE: __ZN7mecanim9animation28MotionOutputGetDeltaPositionEPKNS0_12MotionOutputE, __Z30getPxTriangleMeshGeometryScalePKN5physx22PxTriangleMeshGeometryE: __Z30getPxTriangleMeshGeometryScalePKN5physx22PxTriangleMeshGeometryE, __ZN2UIL31GenerateRenderableUIInstructionEPNS_28PreprocessUIInstructionsDataEj: __ZN2UIL31GenerateRenderableUIInstructionEPNS_28PreprocessUIInstructionsDataEj, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERx: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERx, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERy: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsERy, __ZN8Animator13GetAvatarRootEv: __ZN8Animator13GetAvatarRootEv, __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_14NpArticulationENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXv, __ZN7mecanim12statemachine22ResetTriggerConditionsERK9OffsetPtrIS1_INS0_17ConditionConstantEEEjPKNS_18ValueArrayConstantEPNS0_21StateMachineWorkspaceE: __ZN7mecanim12statemachine22ResetTriggerConditionsERK9OffsetPtrIS1_INS0_17ConditionConstantEEEjPKNS_18ValueArrayConstantEPNS0_21StateMachineWorkspaceE, __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIwc11__mbstate_tEEEEvPT_: __ZNSt3__26locale5__imp7installINS_14codecvt_bynameIwc11__mbstate_tEEEEvPT_, __ZN24EllipsoidParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN24EllipsoidParticleEmitter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN14DirectorPlayer8TransferI17RemapPPtrTransferEEvRT_: __ZN14DirectorPlayer8TransferI17RemapPPtrTransferEEvRT_, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetYMultiplierv, __ZThn28_N14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj: __ZThn28_N14PhysicsManager17onConstraintBreakEPN5physx16PxConstraintInfoEj, __ZN7Texture39ShouldIgnoreInGarbageDependencyTrackingEv: __ZN7Texture39ShouldIgnoreInGarbageDependencyTrackingEv, __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf: __ZN5physx2Sq9ShapeDataC2ERKNS_10PxGeometryERKNS_11PxTransformEf, __ZN13BuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13BuildSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK14DetailDatabase12IsPatchDirtyEii: __ZNK14DetailDatabase12IsPatchDirtyEii, __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN20SoundChannelInstance14GetPositionPCMEPj: __ZN20SoundChannelInstance14GetPositionPCMEPj, __ZN19SpriteMeshGenerator4path8cvx_costEi: __ZN19SpriteMeshGenerator4path8cvx_costEi, __ZN9ShaderLab16SerializedShaderD2Ev: __ZN9ShaderLab16SerializedShaderD2Ev, __Z37UnityWebRequest_CUSTOM_InternalSetUrlP12Il2CppObjectP12Il2CppString: __Z37UnityWebRequest_CUSTOM_InternalSetUrlP12Il2CppObjectP12Il2CppString, __ZN7mecanim9animation25DestroyClipMuscleConstantEPNS0_18ClipMuscleConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation25DestroyClipMuscleConstantEPNS0_18ClipMuscleConstantERNS_6memory9AllocatorE, __ZNK13TranslateGLES9GetFormatE17DepthBufferFormat: __ZNK13TranslateGLES9GetFormatE17DepthBufferFormat, __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib: __ZNK10__cxxabiv120__si_class_type_info16search_below_dstEPNS_19__dynamic_cast_infoEPKvib, __Z24GetAABBVerticesForSpriteRK4AABBP8Vector3f: __Z24GetAABBVerticesForSpriteRK4AABBP8Vector3f, __Z45CommandBuffer_CUSTOM_SetRenderTarget_MultipleP12Il2CppObjectP11Il2CppArrayR26MonoRenderTargetIdentifier: __Z45CommandBuffer_CUSTOM_SetRenderTarget_MultipleP12Il2CppObjectP11Il2CppArrayR26MonoRenderTargetIdentifier, __ZN12_GLOBAL__N_124PropertyDefinitionHelper24clearPropertyMessageArgsEv: __ZN12_GLOBAL__N_124PropertyDefinitionHelper24clearPropertyMessageArgsEv, __ZN8JSONRead8TransferI4AABBEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI4AABBEEvRT_PKc17TransferMetaFlagsb, __ZN5audio5mixer13GroupConstant8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN5audio5mixer13GroupConstant8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15OcclusionPortal23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode: __ZN15TerrainRenderer10RemoveMeshER12QuadTreeNode, __Z44getPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataEj: __Z44getPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataEj, __ZN9Rigidbody6CreateEb: __ZN9Rigidbody6CreateEb, __Z48AudioSource_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_: __Z48AudioSource_Set_Custom_PropOutputAudioMixerGroupP12Il2CppObjectS0_, _gzsetparams: _gzsetparams, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE15getSerializableEv, __ZN4FMOD8ChannelI11setUserDataEPv: __ZN4FMOD8ChannelI11setUserDataEPv, __ZN12b2EPCollider7CollideEP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS7_: __ZN12b2EPCollider7CollideEP10b2ManifoldPK11b2EdgeShapeRK11b2TransformPK14b2PolygonShapeS7_, _truncl: _truncl, __ZN14MessageHandler7CleanupEv: __ZN14MessageHandler7CleanupEv, __Z42AudioReverbZone_Get_Custom_PropLFReferenceP12Il2CppObject: __Z42AudioReverbZone_Get_Custom_PropLFReferenceP12Il2CppObject, __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI18StreamedBinaryReadILb0EE16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN10MonoScript23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimev: __Z80Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_GetFrameOverTimev, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI17BlendShapeChannelNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj: __ZN19ShaderPropertySheet27AddNewPropertyUninitializedERKN9ShaderLab16FastPropertyNameENS_12PropertyTypeEijj, __Z40ParticleSystem_MainModule_CUSTOM_GetLoopP12Il2CppObject: __Z40ParticleSystem_MainModule_CUSTOM_GetLoopP12Il2CppObject, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE10setSpheresENS0_5RangeIKNS_6PxVec4EEEjj, __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE8__appendEj: __ZNSt3__26vectorIN15ResourceManager10DependencyE13stl_allocatorIS2_L18MemLabelIdentifier51ELi16EEE8__appendEj, __ZN22BaseUnityConnectClient16IsConnectEnabledEv: __ZN22BaseUnityConnectClient16IsConnectEnabledEv, __Z54Register_UnityEngine_AndroidJNI_CallStaticDoubleMethodv: __Z54Register_UnityEngine_AndroidJNI_CallStaticDoubleMethodv, __ZNK17BaseWebCamTexture9GetPixelsE13TextureFormatPvj: __ZNK17BaseWebCamTexture9GetPixelsE13TextureFormatPvj, __ZNK16UnityAdsSettings9GetGameIdE15RuntimePlatform: __ZNK16UnityAdsSettings9GetGameIdE15RuntimePlatform, __ZNSt3__212system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNSt3__212system_error6__initERKNS_10error_codeENS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __Z29AnimationClip_CUSTOM_SetCurveP12Il2CppObjectP12Il2CppStringS0_S2_S0_: __Z29AnimationClip_CUSTOM_SetCurveP12Il2CppObjectP12Il2CppStringS0_S2_S0_, __ZN31TransformFeedbackSkinPoseBuffer6UpdateEPK10Matrix4x4fi: __ZN31TransformFeedbackSkinPoseBuffer6UpdateEPK10Matrix4x4fi, __Z48Caching_Get_Custom_PropMaximumAvailableDiskSpacev: __Z48Caching_Get_Custom_PropMaximumAvailableDiskSpacev, __ZN9Transform4FindEPKS_: __ZN9Transform4FindEPKS_, __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f: __ZN5physx2Gu19_gjkRelativeRayCastINS0_8CapsuleVES2_EEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNS8_6FloatVERKNS8_5Vec3VESH_RSC_RSF_SJ_f, __ZN5physx3Ext13DistanceJointD0Ev: __ZN5physx3Ext13DistanceJointD0Ev, __ZN5physx34PxsSolverConstraintPostProcessTaskD2Ev: __ZN5physx34PxsSolverConstraintPostProcessTaskD2Ev, __ZNK5physx3Cct26CharacterControllerManager15onObstacleAddedEjPKNS_17PxObstacleContextE: __ZNK5physx3Cct26CharacterControllerManager15onObstacleAddedEjPKNS_17PxObstacleContextE, __ZN13BoxCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13BoxCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10Effector2D8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14PreloadManager18PeekIntegrateQueueEv: __ZN14PreloadManager18PeekIntegrateQueueEv, __ZN18PlatformEffector2D8TransferI14SafeBinaryReadEEvRT_: __ZN18PlatformEffector2D8TransferI14SafeBinaryReadEEvRT_, __Z19GL_CUSTOM_TexCoord3fff: __Z19GL_CUSTOM_TexCoord3fff, __ZNKSt3__217moneypunct_bynameIcLb0EE13do_neg_formatEv: __ZNKSt3__217moneypunct_bynameIcLb0EE13do_neg_formatEv, __ZN11UnityEngine15PlatformWrapper13GetUnityAdsIdEv: __ZN11UnityEngine15PlatformWrapper13GetUnityAdsIdEv, __ZN5physx24PxsParticleSystemBatcher21scheduleCollisionPrepEPPNS_20PxvParticleSystemSimEPPNS_14PxLightCpuTaskEjRNS_10PxBaseTaskE: __ZN5physx24PxsParticleSystemBatcher21scheduleCollisionPrepEPPNS_20PxvParticleSystemSimEPPNS_14PxLightCpuTaskEjRNS_10PxBaseTaskE, __ZN4Tree12CleanupClassEv: __ZN4Tree12CleanupClassEv, __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedMethodv: __Z63Register_UnityEngine_AndroidJNI_INTERNAL_CALL_ToReflectedMethodv, __Z16RandomUnitVectorR5RandN: __Z16RandomUnitVectorR5RandN, __Z45Profiler_CUSTOM_SetTempAllocatorRequestedSizej: __Z45Profiler_CUSTOM_SetTempAllocatorRequestedSizej, __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE: __ZN5Umbra15CameraTransform3setERKNS_9Matrix4x4ERKNS_7Vector3ENS0_10DepthRangeENS_12MatrixFormatE, __ZN5physx2Sn13XmlNodeWriter8tabCountEv: __ZN5physx2Sn13XmlNodeWriter8tabCountEv, __ZN15SerializeTraitsIN22NavMeshProjectSettings15NavMeshAreaDataEE8TransferI14SafeBinaryReadEEvRS1_RT_: __ZN15SerializeTraitsIN22NavMeshProjectSettings15NavMeshAreaDataEE8TransferI14SafeBinaryReadEEvRS1_RT_, __ZNK5physx3Ext10FixedJoint15exportExtraDataERNS_22PxSerializationContextE: __ZNK5physx3Ext10FixedJoint15exportExtraDataERNS_22PxSerializationContextE, __ZN14SpriteRenderer15InitializeClassEv: __ZN14SpriteRenderer15InitializeClassEv, __Z47ParticleSystem_CollisionModule_CUSTOM_GetDampenP12Il2CppObjectR15MonoMinMaxCurve: __Z47ParticleSystem_CollisionModule_CUSTOM_GetDampenP12Il2CppObjectR15MonoMinMaxCurve, __Z33NavMeshAgent_Set_Custom_PropSpeedP12Il2CppObjectf: __Z33NavMeshAgent_Set_Custom_PropSpeedP12Il2CppObjectf, __ZN15TerrainRenderer16ForceSplitParentER12QuadTreeNode: __ZN15TerrainRenderer16ForceSplitParentER12QuadTreeNode, __Z18Transfer_BlittableI9JSONWriteLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z10md5_finishP11md5_contextPh: __Z10md5_finishP11md5_contextPh, __Z50Register_UnityEngine_RenderSettings_set_fogDensityv: __Z50Register_UnityEngine_RenderSettings_set_fogDensityv, __ZNK9Heightmap13GetPatchIndexEiii: __ZNK9Heightmap13GetPatchIndexEiii, __ZNK14SoundHandleAPI12GetFrequencyEv: __ZNK14SoundHandleAPI12GetFrequencyEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj287ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxHeightFieldGeometryEEEEclILj287ES3_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESA_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5Unity10HingeJoint23VirtualRedirectTransferER14SafeBinaryRead: __ZN5Unity10HingeJoint23VirtualRedirectTransferER14SafeBinaryRead, __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetDieWithParticlesv: __Z67Register_UnityEngine_ParticleSystem_TrailModule_GetDieWithParticlesv, __Z9SetLocalR15TransformAccessRKN4math7_float4E: __Z9SetLocalR15TransformAccessRKN4math7_float4E, __ZN4FMOD7SystemI15setNetworkProxyEPKc: __ZN4FMOD7SystemI15setNetworkProxyEPKc, __ZN4FMOD8ChannelI11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E: __ZN4FMOD8ChannelI11setCallbackEPF11FMOD_RESULTP12FMOD_CHANNEL25FMOD_CHANNEL_CALLBACKTYPEPvS5_E, __Z17CreateBatchDeleteR11BatchDeletej: __Z17CreateBatchDeleteR11BatchDeletej, __Z54Register_UnityEngine_Canvas_get_referencePixelsPerUnitv: __Z54Register_UnityEngine_Canvas_get_referencePixelsPerUnitv, __ZN5physx19calcForce4_onlyPtrsERNS_6shdfnd3aos6Mat44VEPKNS_16PxsFluidParticleES6_S6_S6_RKS2_S8_RKNS_30PxsFluidDynamicsParametersSIMDE: __ZN5physx19calcForce4_onlyPtrsERNS_6shdfnd3aos6Mat44VEPKNS_16PxsFluidParticleES6_S6_S6_RKS2_S8_RKNS_30PxsFluidDynamicsParametersSIMDE, __Z36TerrainData_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f: __Z36TerrainData_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK8Vector3f, __ZN15SharedGfxBufferD0Ev: __ZN15SharedGfxBufferD0Ev, __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __Z52Register_UnityEngine_RenderSettings_set_haloStrengthv: __Z52Register_UnityEngine_RenderSettings_set_haloStrengthv, __ZN5physx27InternalTriangleMeshBuilder9cleanMeshEb: __ZN5physx27InternalTriangleMeshBuilder9cleanMeshEb, _cacosl: _cacosl, __ZN13TextRendering4Font23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN13TextRendering4Font23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN9ShaderLab14SerializedPassD2Ev: __ZN9ShaderLab14SerializedPassD2Ev, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10DeallocateEPv: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE10DeallocateEPv, __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb: __ZNK15TextureSettings5ApplyER9GfxDevice9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb, _cacosf: _cacosf, __ZL25InitializeModule_Vehiclesv: __ZL25InitializeModule_Vehiclesv, __ZNK5physx2Sc9ClothCore21getNbCollisionSpheresEv: __ZNK5physx2Sc9ClothCore21getNbCollisionSpheresEv, __ZN5Unity17ConfigurableJoint8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity17ConfigurableJoint8TransferI14SafeBinaryReadEEvRT_, __ZN5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv: __ZN5physx5cloth9ClothImplINS0_7SwClothEE12clearInertiaEv, __ZN5physx35solveFrictionCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx35solveFrictionCoulombPreBlock_StaticEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxJointLinearLimitEEEE14handleAccessorILj486ENS_22PxRepXPropertyAccessorILj486ENS_22PxJointLimitParametersEffEEEEvRKT0_, __Z45Register_UnityEngine_AnimationClip_set_legacyv: __Z45Register_UnityEngine_AnimationClip_set_legacyv, __ZN5physx2Sc5Scene14getConstraintsEv: __ZN5physx2Sc5Scene14getConstraintsEv, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN8TToArray15CoordinateCountI11QuaternionfEEiv: __ZN8TToArray15CoordinateCountI11QuaternionfEEiv, __ZN9Animation12BlendGenericEv: __ZN9Animation12BlendGenericEv, __ZN29MotionVectorRenderLoopScratchD2Ev: __ZN29MotionVectorRenderLoopScratchD2Ev, __ZN20ArchiveStorageHeader6HeaderC2Ev: __ZN20ArchiveStorageHeader6HeaderC2Ev, __ZN5physx5cloth8SwFabricD2Ev: __ZN5physx5cloth8SwFabricD2Ev, __ZN15LocationService16GetHeadingStatusEv: __ZN15LocationService16GetHeadingStatusEv, __ZN4FMOD6System9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE: __ZN4FMOD6System9playSoundE17FMOD_CHANNELINDEXPNS_5SoundEbPPNS_7ChannelE, __ZN4PPtrI11LightProbesE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI11LightProbesE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15OcclusionPortal13AwakeFromLoadE17AwakeFromLoadMode: __ZN15OcclusionPortal13AwakeFromLoadE17AwakeFromLoadMode, __ZN10Collider2D12LayerChangedEv: __ZN10Collider2D12LayerChangedEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj493ENS_22PxRepXPropertyAccessorILj493ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj493ENS_22PxRepXPropertyAccessorILj493ES4_ffEEEEvRKT0_, __Z53Register_UnityEngine_Profiling_Profiler_get_supportedv: __Z53Register_UnityEngine_Profiling_Profiler_get_supportedv, __ZN4PPtrI5FlareE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI5FlareE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx7NpScene18removeArticulationERNS_14PxArticulationEb: __ZN5physx7NpScene18removeArticulationERNS_14PxArticulationEb, __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK18ProceduralMaterial18FindSubstanceInputERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11AssetBundle23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN10FileSystem21MountMemoryFileSystemEv: __ZN10FileSystem21MountMemoryFileSystemEv, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat14TexFormatRHalfEEvPKNS_9InnerInfoE, __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_10moneypunctIwLb0EEEEEvPT_, __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17SurfaceEffector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E12expand_arrayEjN21dense_hash_map_traits17integral_constantIbLb0EEE, __Z16ClearScissorRectbRK5RectTIiER9GfxDevice: __Z16ClearScissorRectbRK5RectTIiER9GfxDevice, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN5physx18PxsDynamicsContext22createFinalizeContactsENS_14PxFrictionType4EnumEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEjPNS_10PxBaseTaskERNS_16PxsThreadContextE: __ZN5physx18PxsDynamicsContext22createFinalizeContactsENS_14PxFrictionType4EnumEPNS_23PxcSolverConstraintDescEPNS_17PxcSolverBodyDataEjPNS_10PxBaseTaskERNS_16PxsThreadContextE, __Z15GetSceneManagerv: __Z15GetSceneManagerv, __Z38Gradient_CUSTOM_INTERNAL_CALL_EvaluateP12Il2CppObjectfR10ColorRGBAf: __Z38Gradient_CUSTOM_INTERNAL_CALL_EvaluateP12Il2CppObjectfR10ColorRGBAf, __ZN14AnimationState7SetTimeEf: __ZN14AnimationState7SetTimeEf, __ZNSt3__217moneypunct_bynameIwLb0EED0Ev: __ZNSt3__217moneypunct_bynameIwLb0EED0Ev, __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_: __ZN5physx2Gu15MeshRayCollider7collideILi1ELi1EEEvRKNS_6PxVec3ES5_fbRKNS0_17RTreeMidphaseDataERNS0_15MeshHitCallbackINS_12PxRaycastHitEEEPS4_, __Z11PremultiplyPh13TextureFormatj: __Z11PremultiplyPh13TextureFormatj, __ZNK10MemoryFile4SizeEv: __ZNK10MemoryFile4SizeEv, __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_HasStateInternalv: __Z86Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_HasStateInternalv, __ZN5Unity12PhysicsQuery10RaycastAllERK3Rayfi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery10RaycastAllERK3Rayfi23QueryTriggerInteraction, __ZNK25BlendshapePropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK25BlendshapePropertyBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __Z60Register_UnityEngine_ShaderVariantCollection_get_shaderCountv: __Z60Register_UnityEngine_ShaderVariantCollection_get_shaderCountv, __Z29StdTemplateConversionFunctionIijEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIijEbPvR14SafeBinaryRead, __ZN5physx6shdfnd14printFormattedEPKcz: __ZN5physx6shdfnd14printFormattedEPKcz, __ZN10Matrix4x4fC2EPKf: __ZN10Matrix4x4fC2EPKf, __Z49Register_UnityEngine_Event_Internal_GetMouseDeltav: __Z49Register_UnityEngine_Event_Internal_GetMouseDeltav, __Z10AddVehiclePN5physx16PxVehicleNoDriveEjPNS_18PxWheelQueryResultE: __Z10AddVehiclePN5physx16PxVehicleNoDriveEjPNS_18PxWheelQueryResultE, __Z31NativeToScriptingVertexDataType22ChannelFormatDimension: __Z31NativeToScriptingVertexDataType22ChannelFormatDimension, __ZN9Texture2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9Texture2D23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _UNITY_png_icc_profile_error: _UNITY_png_icc_profile_error, __ZNKSt3__210moneypunctIcLb1EE11do_groupingEv: __ZNKSt3__210moneypunctIcLb1EE11do_groupingEv, __ZN12WheelJoint2D13SetSuspensionERK17JointSuspension2D: __ZN12WheelJoint2D13SetSuspensionERK17JointSuspension2D, __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev: __ZN5physx29PxSphereGeometryGeneratedInfoC2Ev, __ZN17AudioChorusFilter5ResetEv: __ZN17AudioChorusFilter5ResetEv, __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14PhysicsManager8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4FMOD13ChannelGroupI11getWaveDataEPfii: __ZN4FMOD13ChannelGroupI11getWaveDataEPfii, __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS3_9allocatorINS3_4pairIiS2_EEEEEEEvRT_17TransferMetaFlags, __ZNK16MemoryFileSystem8PositionERK13FileEntryData: __ZNK16MemoryFileSystem8PositionERK13FileEntryData, __Z27GUIText_Get_Custom_PropFontP12Il2CppObject: __Z27GUIText_Get_Custom_PropFontP12Il2CppObject, __ZN29AssetBundleLoadAssetOperation14GetLoadedAssetEv: __ZN29AssetBundleLoadAssetOperation14GetLoadedAssetEv, __ZNK11Rigidbody2D17GetRelativeVectorERK8Vector2f: __ZNK11Rigidbody2D17GetRelativeVectorERK8Vector2f, __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEjRKS1_: __ZNSt3__26vectorI11ColorRGBA32NS_9allocatorIS1_EEE8__appendEjRKS1_, __ZN12_GLOBAL__N_110Connection13sendStreamEndEv: __ZN12_GLOBAL__N_110Connection13sendStreamEndEv, __ZN9Projector17RemoveFromManagerEv: __ZN9Projector17RemoveFromManagerEv, __Z39Register_UnityEngine_TextGenerator_Initv: __Z39Register_UnityEngine_TextGenerator_Initv, __ZN8Animator30GetEffectiveAnimatorControllerEv: __ZN8Animator30GetEffectiveAnimatorControllerEv, __Z35HingeJoint_Set_Custom_PropUseLimitsP12Il2CppObjecth: __Z35HingeJoint_Set_Custom_PropUseLimitsP12Il2CppObjecth, __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientLightv: __Z61Register_UnityEngine_RenderSettings_INTERNAL_get_ambientLightv, __ZN11LightProbes14LightProbeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11LightProbes14LightProbeData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z43Behaviour_Get_Custom_PropIsActiveAndEnabledP12Il2CppObject: __Z43Behaviour_Get_Custom_PropIsActiveAndEnabledP12Il2CppObject, __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_13PxsCCDContextEXadL_ZNS2_18postCCDDepenetrateEPNS_10PxBaseTaskEEEE11runInternalEv, __Z47ParticleEmitter_CUSTOM_INTERNAL_get_rndVelocityP12Il2CppObjectP8Vector3f: __Z47ParticleEmitter_CUSTOM_INTERNAL_get_rndVelocityP12Il2CppObjectP8Vector3f, __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing2Limitv: __Z60Register_UnityEngine_CharacterJoint_INTERNAL_set_swing2Limitv, __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_Compressv: __Z53Register_UnityEngine_Texture2D_INTERNAL_CALL_Compressv, __Z45Material_CUSTOM_INTERNAL_CALL_SetTextureScaleP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall: __Z45Material_CUSTOM_INTERNAL_CALL_SetTextureScaleP12Il2CppObjectP12Il2CppStringRK13Vector2fIcall, __ZN13RenderTexture19UnloadFromGfxDeviceEb: __ZN13RenderTexture19UnloadFromGfxDeviceEb, __ZN5physx2Sc8ClothSim26removeCollisionHeightfieldEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim26removeCollisionHeightfieldEPKNS0_8ShapeSimE, __ZNK24iPhoneRemoteNotification9HasActionEv: __ZNK24iPhoneRemoteNotification9HasActionEv, __Z28getPxSceneDescFilterCallbackPKN5physx11PxSceneDescE: __Z28getPxSceneDescFilterCallbackPKN5physx11PxSceneDescE, __ZN12_GLOBAL__N_19InitTableEv: __ZN12_GLOBAL__N_19InitTableEv, __ZN12_GLOBAL__N_110DataStream11enableCacheEv: __ZN12_GLOBAL__N_110DataStream11enableCacheEv, __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI18AudioMixerSnapshotE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z40UnityAnalyticsHandler_CUSTOM_TransactionP12Il2CppObjectP12Il2CppStringdS2_: __Z40UnityAnalyticsHandler_CUSTOM_TransactionP12Il2CppObjectP12Il2CppStringdS2_, _unzOpenCurrentFilePassword: _unzOpenCurrentFilePassword, __ZN13SpringJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN13SpringJoint2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN14DataBufferGLESC2ER17BufferManagerGLESiNS_11BufferUsageEb: __ZN14DataBufferGLESC2ER17BufferManagerGLESiNS_11BufferUsageEb, __ZN5physx2Sc21ArticulationJointCoreD2Ev: __ZN5physx2Sc21ArticulationJointCoreD2Ev, __ZN5physx2Sc8ClothSimC2ERNS0_5SceneERNS0_9ClothCoreE: __ZN5physx2Sc8ClothSimC2ERNS0_5SceneERNS0_9ClothCoreE, __ZN5physx2Gu22GJKRelativeTesselationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_: __ZN5physx2Gu22GJKRelativeTesselationERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERKNS5_6FloatVERNS5_5Vec3VESD_SD_RS9_, __Z64Register_UnityEngine_SkinnedMeshRenderer_set_updateWhenOffscreenv: __Z64Register_UnityEngine_SkinnedMeshRenderer_set_updateWhenOffscreenv, __Z38SpringJoint2D_Get_Custom_PropFrequencyP12Il2CppObject: __Z38SpringJoint2D_Get_Custom_PropFrequencyP12Il2CppObject, __ZNK13TargetJoint2D16UseConnectedBodyEv: __ZNK13TargetJoint2D16UseConnectedBodyEv, __ZN5physx11NpAggregate16addActorInternalERNS_7PxActorERNS_7NpSceneE: __ZN5physx11NpAggregate16addActorInternalERNS_7PxActorERNS_7NpSceneE, __ZN14PhysicsManager18ProcessJointBreaksEv: __ZN14PhysicsManager18ProcessJointBreaksEv, __Z39DirectorPlayer_CUSTOM_SetTimeUpdateModeP12Il2CppObject18DirectorUpdateMode: __Z39DirectorPlayer_CUSTOM_SetTimeUpdateModeP12Il2CppObject18DirectorUpdateMode, _jpeg_destroy_compress: _jpeg_destroy_compress, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZNSt3__26locale5__imp7installINS_5ctypeIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_5ctypeIwEEEEvPT_, __Z33Gradient_Get_Custom_PropAlphaKeysP12Il2CppObject: __Z33Gradient_Get_Custom_PropAlphaKeysP12Il2CppObject, __Z55Register_UnityEngine_SystemInfo_get_usesReversedZBufferv: __Z55Register_UnityEngine_SystemInfo_get_usesReversedZBufferv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj144ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEEclILj144ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx29solveContactPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx29solveContactPreBlock_ConcludeEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZN5physx28updateAtomFrictionProgressesEPNS_23PxcSolverConstraintDescEjjj: __ZN5physx28updateAtomFrictionProgressesEPNS_23PxcSolverConstraintDescEjjj, __ZNK10MinMaxAABB17CalculateVerticesEP8Vector3f: __ZNK10MinMaxAABB17CalculateVerticesEP8Vector3f, __Z38Input_Get_Custom_PropMultiTouchEnabledv: __Z38Input_Get_Custom_PropMultiTouchEnabledv, __ZNK16UploadHandlerRaw15GetNumBytesLeftEv: __ZNK16UploadHandlerRaw15GetNumBytesLeftEv, __ZL14SceneWasLoadediR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZL14SceneWasLoadediR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_21PxsBodyTransformVault13PxsBody2WorldEEEEEvPT_jRKT0_RKT1_j, __ZN14NullGpuProgramD0Ev: __ZN14NullGpuProgramD0Ev, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE21getCollisionMassScaleEv, __ZN4FMOD7SystemI17set3DNumListenersEi: __ZN4FMOD7SystemI17set3DNumListenersEi, __ZN5physx12_GLOBAL__N_115OverlapCallbackD0Ev: __ZN5physx12_GLOBAL__N_115OverlapCallbackD0Ev, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E12resize_deltaEjj, __Z44Animator_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f: __Z44Animator_CUSTOM_INTERNAL_get_angularVelocityP12Il2CppObjectP8Vector3f, __ZThn4_N16RayRTreeCallbackILi1ELb1EED1Ev: __ZThn4_N16RayRTreeCallbackILi1ELb1EED1Ev, __ZN15AudioReverbZone17MainThreadCleanupEv: __ZN15AudioReverbZone17MainThreadCleanupEv, __ZN5physx2Sc16InteractionSceneD2Ev: __ZN5physx2Sc16InteractionSceneD2Ev, __ZN13Simd4fFactoryIN6detail14AlignedPointerIfEEEC2ES2_: __ZN13Simd4fFactoryIN6detail14AlignedPointerIfEEEC2ES2_, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED2Ev: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEED2Ev, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_19updateCCDSinglePassEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv: __ZN5physx2Sc10NPhaseCore23updateDirtyInteractionsEv, __ZN19StreamedBinaryWriteILb1EE20TransferTypelessDataEjPvi: __ZN19StreamedBinaryWriteILb1EE20TransferTypelessDataEjPvi, __ZNK14RenderSettings12SetupAmbientEv: __ZNK14RenderSettings12SetupAmbientEv, __Z32getPxRigidDynamic_AngularDampingPKN5physx14PxRigidDynamicE: __Z32getPxRigidDynamic_AngularDampingPKN5physx14PxRigidDynamicE, __ZNK5physx2Sc16ArticulationCore26getExternalDriveIterationsEv: __ZNK5physx2Sc16ArticulationCore26getExternalDriveIterationsEv, __ZN4Mesh8TransferI17RemapPPtrTransferEEvRT_: __ZN4Mesh8TransferI17RemapPPtrTransferEEvRT_, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z30getPxCapsuleGeometryHalfHeightPKN5physx17PxCapsuleGeometryE: __Z30getPxCapsuleGeometryHalfHeightPKN5physx17PxCapsuleGeometryE, _UNITY_png_get_pCAL: _UNITY_png_get_pCAL, __ZN5physx7NpCloth13setClothFlagsENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx7NpCloth13setClothFlagsENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __Z76Register_UnityEngine_TerrainData_Internal_GetMinimumDetailResolutionPerPatchv: __Z76Register_UnityEngine_TerrainData_Internal_GetMinimumDetailResolutionPerPatchv, _setvbuf: _setvbuf, __ZThn8_N12_GLOBAL__N_111StreamOwner5flushEv: __ZThn8_N12_GLOBAL__N_111StreamOwner5flushEv, __Z24Input_CUSTOM_GetButtonUpP12Il2CppString: __Z24Input_CUSTOM_GetButtonUpP12Il2CppString, __Z37AudioEchoFilter_Get_Custom_PropWetMixP12Il2CppObject: __Z37AudioEchoFilter_Get_Custom_PropWetMixP12Il2CppObject, __ZN12NavMeshAgent9SetHeightEf: __ZN12NavMeshAgent9SetHeightEf, _inet_netof: _inet_netof, __Z38Register_UnityEngine_Cubemap_SetPixelsv: __Z38Register_UnityEngine_Cubemap_SetPixelsv, __ZN9JSONWrite8TransferINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI8MonoPPtr13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEEEEEvRT_PKc17TransferMetaFlags, _UNITY_png_format_number: _UNITY_png_format_number, __Z65Register_UnityEngine_ParticleSystem_MainModule_GetStartRotation3Dv: __Z65Register_UnityEngine_ParticleSystem_MainModule_GetStartRotation3Dv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE11prepareDataEv, __Z18Transfer_BlittableI8JSONReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getCMassLocalPoseEv: __ZNK5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE17getCMassLocalPoseEv, __Z6selectRK8Scalar4fS1_S1_: __Z6selectRK8Scalar4fS1_S1_, __Z50Register_UnityEngine_ParticleSystem_get_startDelayv: __Z50Register_UnityEngine_ParticleSystem_get_startDelayv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6appendEPKw, __Z44Register_UnityEngine_HingeJoint_get_useMotorv: __Z44Register_UnityEngine_HingeJoint_get_useMotorv, __Z40Animation_CUSTOM_INTERNAL_CALL_SyncLayerP12Il2CppObjecti: __Z40Animation_CUSTOM_INTERNAL_CALL_SyncLayerP12Il2CppObjecti, _gztell: _gztell, __ZNK12CullingGroup11GetDistanceEj: __ZNK12CullingGroup11GetDistanceEj, __ZN7b2WorldC2ERK6b2Vec2: __ZN7b2WorldC2ERK6b2Vec2, __Z53Terrain_CUSTOM_Internal_GetSplatMaterialPropertyBlockP12Il2CppObjectS0_: __Z53Terrain_CUSTOM_Internal_GetSplatMaterialPropertyBlockP12Il2CppObjectS0_, __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __Z38BoxCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall: __Z38BoxCollider2D_CUSTOM_INTERNAL_set_sizeP12Il2CppObjectRK13Vector2fIcall, __ZN18LoadSceneOperation13UnloadStreamsEb: __ZN18LoadSceneOperation13UnloadStreamsEb, __ZL37RegisterModuleICalls_CloudWebServicesv: __ZL37RegisterModuleICalls_CloudWebServicesv, __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject: __Z60ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetSeparateAxesP12Il2CppObject, __Z34AndroidJNI_CUSTOM_FromBooleanArray13Il2Cpp_IntPtr: __Z34AndroidJNI_CUSTOM_FromBooleanArray13Il2Cpp_IntPtr, __Z29StdTemplateConversionFunctionIixEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIixEbPvR14SafeBinaryRead, __ZN13TriggerModuleD0Ev: __ZN13TriggerModuleD0Ev, __ZN5physx26PxConvexMeshRepXSerializer16objectToFileImplEPKNS_12PxConvexMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx26PxConvexMeshRepXSerializer16objectToFileImplEPKNS_12PxConvexMeshEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN5physx20PxsSolverCoreGeneral8destroyVEv: __ZN5physx20PxsSolverCoreGeneral8destroyVEv, __ZNK5physx12PxConvexMesh8isKindOfEPKc: __ZNK5physx12PxConvexMesh8isKindOfEPKc, __ZN14DirectorPlayer15SetPrepareStageEv: __ZN14DirectorPlayer15SetPrepareStageEv, __ZNK5physx2Sc15ClothFabricCore18getParticleIndicesEPjj: __ZNK5physx2Sc15ClothFabricCore18getParticleIndicesEPjj, __ZN12AudioManagerD2Ev: __ZN12AudioManagerD2Ev, __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext: __ZL25UpdateCameraDepthTexturesR17RenderLoopContextP13RenderTextureS2_RK13dynamic_arrayI16RenderObjectDataLj4EEbbbR17ShaderPassContext, __ZL18MouseButtonHandleriPK20EmscriptenMouseEventPv: __ZL18MouseButtonHandleriPK20EmscriptenMouseEventPv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__23mapIN9ShaderLab16FastPropertyNameE10ColorRGBAfNS2_4lessIS5_EENS2_9allocatorINS2_4pairIKS5_S6_EEEEEEEEvRT_17TransferMetaFlags, __ZN8Material12UpdateHashesEv: __ZN8Material12UpdateHashesEv, __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i: __ZL13AddRightEdgesP14TESStesselatorP12ActiveRegionP12TESShalfEdgeS4_S4_i, __Z45Register_UnityEngine_ComputeBuffer_InitBufferv: __Z45Register_UnityEngine_ComputeBuffer_InitBufferv, __ZN7CubemapD0Ev: __ZN7CubemapD0Ev, __ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_: __ZL14testBoxBoxAxisRN5physx6PxVec3ERfRKS0_RKNS_2Gu3BoxES8_, __ZN13MemoryManager10DeallocateEPvRK10MemLabelId: __ZN13MemoryManager10DeallocateEPvRK10MemLabelId, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE17getDominanceGroupEv, __Z36SparseTexture_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormatih: __Z36SparseTexture_CUSTOM_Internal_CreateP12Il2CppObjectii13TextureFormatih, __ZN8BitArray4initEj: __ZN8BitArray4initEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6assignEPKwj, __Z21GetLODGroupManagerPtrv: __Z21GetLODGroupManagerPtrv, __ZN10GISettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN10GISettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNKSt3__220__codecvt_utf8_utf16IwE9do_lengthER11__mbstate_tPKcS5_j: __ZNKSt3__220__codecvt_utf8_utf16IwE9do_lengthER11__mbstate_tPKcS5_j, __ZN12LightManager12CleanupClassEv: __ZN12LightManager12CleanupClassEv, __ZN14FileCacherRead10DirectReadEPvjj: __ZN14FileCacherRead10DirectReadEPvjj, __ZNK9DebugGLES14ProgramBindingEv: __ZNK9DebugGLES14ProgramBindingEv, __ZNK9dtNavMesh25getFirstOffMeshConnectionEv: __ZNK9dtNavMesh25getFirstOffMeshConnectionEv, __ZN5physx26PxRigidStaticGeneratedInfoC2Ev: __ZN5physx26PxRigidStaticGeneratedInfoC2Ev, __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15AnchoredJoint2D8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN8Collider11GetMaterialEv: __ZN8Collider11GetMaterialEv, __ZNSt3__220__codecvt_utf8_utf16IDsED0Ev: __ZNSt3__220__codecvt_utf8_utf16IDsED0Ev, __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev: __ZN5physx31PxVehicleWheelDataGeneratedInfoC2Ev, __ZN11Rigidbody2D8AddForceERK8Vector2fNS_9ForceModeE: __ZN11Rigidbody2D8AddForceERK8Vector2fNS_9ForceModeE, __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_get_slerpDrivev: __Z62Register_UnityEngine_ConfigurableJoint_INTERNAL_get_slerpDrivev, __Z45GUIStyle_CUSTOM_Internal_GetCursorFlashOffsetv: __Z45GUIStyle_CUSTOM_Internal_GetCursorFlashOffsetv, __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPhNS_8debugger19ForwardingAllocatorEE15growAndPushBackERKS2_, __ZL15skip_input_dataP22jpeg_decompress_structl: __ZL15skip_input_dataP22jpeg_decompress_structl, __ZN7b2JointD2Ev: __ZN7b2JointD2Ev, __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback: __ZNK9dtNavMesh13queryPolygonsEPKfS1_P15dtQueryCallback, __ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_: __ZN5physx2Gu25distanceSegmentBoxSquaredERKNS_6PxVec3ES3_S3_S3_RKNS_7PxMat33EPfPS1_, __ZN29TriggerModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN29TriggerModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb: __Z12DoRenderLoopR10RenderLoop13RenderingPathR11CullResultsR14ShadowMapCacheb, __ZN5physx2Sc9ClothCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc9ClothCore17getBinaryMetaDataERNS_14PxOutputStreamE, __ZNK9dtNavMesh19findConnectingPolysEPKfiPK10dtMeshTileiPyPfi: __ZNK9dtNavMesh19findConnectingPolysEPKfiPK10dtMeshTileiPyPfi, __ZL19stbir__filter_cubicff: __ZL19stbir__filter_cubicff, __ZNK9BlobWrite25AllowDataLayoutValidationEv: __ZNK9BlobWrite25AllowDataLayoutValidationEv, __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation18ClipMuscleConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu18findOverlapOBBMeshERKNS0_3BoxERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb: __ZN5physx2Gu18findOverlapOBBMeshERKNS0_3BoxERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb, __ZN2UI20DoSyncInheritedAlphaERNS_13UIInstructionEf: __ZN2UI20DoSyncInheritedAlphaERNS_13UIInstructionEf, __ZN5Unity12PhysicsQuery15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery15RaycastNonAllocERK3RayP10RaycastHitifi23QueryTriggerInteraction, __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo: __Z23ExecuteJobInfoImmediateRK21SingleThreadedJobInfo, _fclose_file_func: _fclose_file_func, __ZN23ParticleSystemParticles13SetUses3DSizeEv: __ZN23ParticleSystemParticles13SetUses3DSizeEv, __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj: __ZThn12_N5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj, __ZN4FMOD3DSP11getUserDataEPPv: __ZN4FMOD3DSP11getUserDataEPPv, __Z30Object_CUSTOM_DestroyImmediateP12Il2CppObjecth: __Z30Object_CUSTOM_DestroyImmediateP12Il2CppObjecth, __ZN4Halo16TransformChangedEv: __ZN4Halo16TransformChangedEv, __ZN5Umbra11PatchWriterD2Ev: __ZN5Umbra11PatchWriterD2Ev, __Z63Register_UnityEngine_Rendering_GraphicsSettings_SetCustomShaderv: __Z63Register_UnityEngine_Rendering_GraphicsSettings_SetCustomShaderv, __Z43Register_UnityEngine_Gradient_set_alphaKeysv: __Z43Register_UnityEngine_Gradient_set_alphaKeysv, __Z23XORDecryptFromHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_: __Z23XORDecryptFromHexStringRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_RS5_, __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_: __ZN20SoftJointLimitSpring8TransferI14SafeBinaryReadEEvRT_, __ZN14UnityWebStream26WaitForThreadDecompressionEv: __ZN14UnityWebStream26WaitForThreadDecompressionEv, _UNITY_ft_corner_orientation: _UNITY_ft_corner_orientation, __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_: __ZNSt3__23mapI8UnityStrN7VRInput17TrackedDeviceInfoENS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_S3_EEL18MemLabelIdentifier87ELi16EEE25__construct_node_with_keyERS8_, __Z34Animator_Get_Custom_PropHumanScaleP12Il2CppObject: __Z34Animator_Get_Custom_PropHumanScaleP12Il2CppObject, _UNITY_tt_face_free_sbit: _UNITY_tt_face_free_sbit, __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc35ParticleElementRbElementInteractionENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5physx2Sc5Scene6setPCMEb: __ZN5physx2Sc5Scene6setPCMEb, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1Ev: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEC1Ev, __ZN19CharacterController9SetHeightEf: __ZN19CharacterController9SetHeightEf, __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sc20TriggerPairExtraDataENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastNonAllocv: __Z61Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastNonAllocv, __ZN13BitSetUtility8CopyBitsEPKjjjPjj: __ZN13BitSetUtility8CopyBitsEPKjjjPjj, __ZN5physx5cloth11emptyBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEv: __ZN5physx5cloth11emptyBoundsI8Scalar4fEENS0_11BoundingBoxIT_EEv, __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_: __ZNK5physx2Gu16SupportLocalImplINS0_18ConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS5_6FloatVESA_, __ZNK5physx3Cct17CapsuleController13getSlopeLimitEv: __ZNK5physx3Cct17CapsuleController13getSlopeLimitEv, __ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv119__pointer_type_info9can_catchEPKNS_16__shim_type_infoERPv, __ZNK14b2CapsuleShape13GetChildCountEv: __ZNK14b2CapsuleShape13GetChildCountEv, __ZN24MoveReplaceFileOperation7ExecuteEv: __ZN24MoveReplaceFileOperation7ExecuteEv, __ZN12UnityVersionC2EPKc: __ZN12UnityVersionC2EPKc, __ZN19CharacterControllerD2Ev: __ZN19CharacterControllerD2Ev, __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN5Unity9Component8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z56Register_UnityEngine_Physics2D_set_angularSleepTolerancev: __Z56Register_UnityEngine_Physics2D_set_angularSleepTolerancev, __Z12CollectPPtrsRK6ObjectRNSt3__23setIiNS2_4lessIiEENS2_9allocatorIiEEEE: __Z12CollectPPtrsRK6ObjectRNSt3__23setIiNS2_4lessIiEENS2_9allocatorIiEEEE, __Z33Texture_Get_Custom_PropAnisoLevelP12Il2CppObject: __Z33Texture_Get_Custom_PropAnisoLevelP12Il2CppObject, __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN15AnchoredJoint2DC2E10MemLabelId18ObjectCreationMode, __ZN19ClampVelocityModuleD0Ev: __ZN19ClampVelocityModuleD0Ev, __Z37Physics2D_CUSTOM_INTERNAL_get_gravityP13Vector2fIcall: __Z37Physics2D_CUSTOM_INTERNAL_get_gravityP13Vector2fIcall, __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEEEEEjT_j: __ZNK5physx28PxVehicleWheelsGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleNoDriveEEEEEEEjT_j, __Z39Cloth_Set_Custom_PropCollisionMassScaleP12Il2CppObjectf: __Z39Cloth_Set_Custom_PropCollisionMassScaleP12Il2CppObjectf, __ZL29GeomOverlapCallback_BoxConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL29GeomOverlapCallback_BoxConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb1EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z65EmitSerializationCommandsForLinearCollectionOfManagedObjectsFieldI18StreamedBinaryReadILb1EEEvRK23TransferArrayField_InfoR20SerializationCommandR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossMultiplierv: __Z77Register_UnityEngine_ParticleSystem_CollisionModule_GetLifetimeLossMultiplierv, __ZN11LightProbes23VirtualRedirectTransferER14SafeBinaryRead: __ZN11LightProbes23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorIN17PxcPoolMallocData10PoolData32EEEEEvPT_jRKT0_RKT1_j, __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastAllv: __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_RaycastAllv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE12getClassSizeEv, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToViewportPointv: __Z63Register_UnityEngine_Camera_INTERNAL_CALL_ScreenToViewportPointv, __ZN13BuildSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN13BuildSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN13ComputeShader25GetKernelThreadGroupSizesEjPj: __ZN13ComputeShader25GetKernelThreadGroupSizesEjPj, __ZN18UnityConnectClient25UnregisterGlobalCallbacksEv: __ZN18UnityConnectClient25UnregisterGlobalCallbacksEv, __ZN17MemoryCacheReader14LockCacheBlockEjPPhS1_: __ZN17MemoryCacheReader14LockCacheBlockEjPPhS1_, __ZN11TimeManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11TimeManager23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z46Register_UnityEngine_Cloth_set_sphereCollidersv: __Z46Register_UnityEngine_Cloth_set_sphereCollidersv, __Z53Register_UnityEngine_BillboardAsset_GetImageTexCoordsv: __Z53Register_UnityEngine_BillboardAsset_GetImageTexCoordsv, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Sc26ActorPairContactReportDataEEEEEE15growAndPushBackERKS2_, __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI18StreamedBinaryReadILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx27setSerializationRegistryPtrEPKNS_23PxSerializationRegistryE: __ZN5physx27setSerializationRegistryPtrEPKNS_23PxSerializationRegistryE, __ZN12MeshCollider13DidModifyMeshEv: __ZN12MeshCollider13DidModifyMeshEv, __Z52Register_UnityEngine_AndroidJNI_GetStaticDoubleFieldv: __Z52Register_UnityEngine_AndroidJNI_GetStaticDoubleFieldv, __Z18Transfer_BlittableI9JSONWriteLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E5RectTIfEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__210__stdinbufIwE9__getcharEb: __ZNSt3__210__stdinbufIwE9__getcharEb, __ZN5physx14PxsAABBManager13releaseVolumeEj: __ZN5physx14PxsAABBManager13releaseVolumeEj, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12resize_deltaEjj, __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE16setInvMassScale0Ef, __ZN16Physics2DManager10RaycastAllERK8Vector2fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager10RaycastAllERK8Vector2fS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE, __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverTrailv: __Z65Register_UnityEngine_ParticleSystem_TrailModule_GetColorOverTrailv, __ZNK5physx7NpShape8getActorEv: __ZNK5physx7NpShape8getActorEv, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE13simulateClothEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE13simulateClothEv, __ZN5physx23PxProcessPxBaseCallbackD2Ev: __ZN5physx23PxProcessPxBaseCallbackD2Ev, __ZN11GameManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11GameManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5Umbra6DoublemLERKd: __ZN5Umbra6DoublemLERKd, __ZN19RenderBufferManager14GarbageCollectEi: __ZN19RenderBufferManager14GarbageCollectEi, __ZN17ArchiveFileSystemC2EPKc: __ZN17ArchiveFileSystemC2EPKc, __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKc21ScriptingMethodIl2CppEENS_19__map_value_compareIS3_S5_14CStringCompareLb1EEE13stl_allocatorIS5_L18MemLabelIdentifier1ELi16EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VE, _umask: _umask, __ZN5Umbra12RegionFinderC2EPNS_12QueryContextEiRKNS_7Vector3Efb: __ZN5Umbra12RegionFinderC2EPNS_12QueryContextEiRKNS_7Vector3Efb, __ZN5physx5cloth11SwCollisionI8Scalar4fE8allocateERNS3_13CollisionDataE: __ZN5physx5cloth11SwCollisionI8Scalar4fE8allocateERNS3_13CollisionDataE, __ZN5physx3Scb5Scene11removeClothERNS0_5ClothE: __ZN5physx3Scb5Scene11removeClothERNS0_5ClothE, __Z24getPxCloth_ContactOffsetPKN5physx7PxClothE: __Z24getPxCloth_ContactOffsetPKN5physx7PxClothE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE15__get_monthnameERiRS4_S4_RjRKNS_5ctypeIcEE, __Z46Animator_CUSTOM_IsParameterControlledByCurveIDP12Il2CppObjecti: __Z46Animator_CUSTOM_IsParameterControlledByCurveIDP12Il2CppObjecti, __ZN13TrailRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN13TrailRenderer8TransferI14SafeBinaryReadEEvRT_, __ZN17SurfaceEffector2D5ResetEv: __ZN17SurfaceEffector2D5ResetEv, __Z51ParticleEmitter_Set_Custom_PropEmitterVelocityScaleP12Il2CppObjectf: __Z51ParticleEmitter_Set_Custom_PropEmitterVelocityScaleP12Il2CppObjectf, __Z58setPxVehicleSuspensionData_MassAndPreserveNaturalFrequencyPN5physx23PxVehicleSuspensionDataEf: __Z58setPxVehicleSuspensionData_MassAndPreserveNaturalFrequencyPN5physx23PxVehicleSuspensionDataEf, __ZNK13ComputeShader26GetTypeInfoVirtualInternalEv: __ZNK13ComputeShader26GetTypeInfoVirtualInternalEv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwjj, __Z52Playable_CUSTOM_INTERNAL_CALL_GetInputWeightInternalR9HPlayablei: __Z52Playable_CUSTOM_INTERNAL_CALL_GetInputWeightInternalR9HPlayablei, __ZN21GLESGpuProgramApplier10ApplyFloatERKN20GpuProgramParameters14ValueParameterEPKft: __ZN21GLESGpuProgramApplier10ApplyFloatERKN20GpuProgramParameters14ValueParameterEPKft, __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState: __ZN4gles18CreateStencilStateER15DeviceStateGLESRK15GfxStencilState, __ZN5physx2Gu11gjkRelativeINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_4BoxVES2_EEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSA_5Vec3VESF_SF_RNSA_6FloatVE, __Z31TextMesh_Set_Custom_PropOffsetZP12Il2CppObjectf: __Z31TextMesh_Set_Custom_PropOffsetZP12Il2CppObjectf, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE5eraseERS4_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKyNS_7profile19FullAllocationEventEEEyNS0_4HashIyEENS1_11HashMapBaseIyS6_S9_NS5_26WrapperReflectionAllocatorIhEEE6GetKeyESC_Lb1EE5eraseERS4_, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_SetXP12Il2CppObjectR15MonoMinMaxCurve, __ZNK5Umbra9IndexList6getPtrEv: __ZNK5Umbra9IndexList6getPtrEv, __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO: __Z13LoadFMODSoundPPN11SoundHandle8InstanceEPKcjP10SampleClipjjP22FMOD_CREATESOUNDEXINFO, __Z30Mesh_CUSTOM_GetBlendShapeIndexP12Il2CppObjectP12Il2CppString: __Z30Mesh_CUSTOM_GetBlendShapeIndexP12Il2CppObjectP12Il2CppString, __Z29Animator_Set_Custom_PropSpeedP12Il2CppObjectf: __Z29Animator_Set_Custom_PropSpeedP12Il2CppObjectf, __ZN14ParticleSystem21SetUsesAxisOfRotationEv: __ZN14ParticleSystem21SetUsesAxisOfRotationEv, __Z50Register_UnityEngine_AndroidJNI_SetStaticCharFieldv: __Z50Register_UnityEngine_AndroidJNI_SetStaticCharFieldv, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E4AABBEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenv: __Z61Register_UnityEngine_ParticleSystem_CollisionModule_SetDampenv, __ZN4FMOD4DSPI16showConfigDialogEPvb: __ZN4FMOD4DSPI16showConfigDialogEPvb, __Z31CubemapArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayiii: __Z31CubemapArray_CUSTOM_SetPixels32P12Il2CppObjectP11Il2CppArrayiii, __ZNSt3__26__clocEv: __ZNSt3__26__clocEv, __ZN7mecanim12statemachine25DestroyStateMachineOutputEPNS0_18StateMachineOutputERNS_6memory9AllocatorE: __ZN7mecanim12statemachine25DestroyStateMachineOutputEPNS0_18StateMachineOutputERNS_6memory9AllocatorE, __ZNK20UnityConnectSettings16IsHwStatsEnabledEv: __ZNK20UnityConnectSettings16IsHwStatsEnabledEv, __ZN8Collider7RaycastERK3RayfR10RaycastHit: __ZN8Collider7RaycastERK3RayfR10RaycastHit, __ZN8WWWAudio15LockPartialDataEv: __ZN8WWWAudio15LockPartialDataEv, __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf: __Z52ConfigurableJoint_CUSTOM_INTERNAL_get_targetRotationP12Il2CppObjectP11Quaternionf, __ZN11UnityEngine15CloudWebService16SessionContainer16ArchiveGroupDataERK8UnityStrS4_: __ZN11UnityEngine15CloudWebService16SessionContainer16ArchiveGroupDataERK8UnityStrS4_, __ZL37UnityAudioEffect_InternalReadCallbackP14FMOD_DSP_STATEPfS1_jii: __ZL37UnityAudioEffect_InternalReadCallbackP14FMOD_DSP_STATEPfS1_jii, _malloc_usable_size: _malloc_usable_size, __ZNK14Texture2DArray20GetStorageMemorySizeEv: __ZNK14Texture2DArray20GetStorageMemorySizeEv, __Z39Terrain_Get_Custom_PropMaterialTemplateP12Il2CppObject: __Z39Terrain_Get_Custom_PropMaterialTemplateP12Il2CppObject, _getrlimit: _getrlimit, __ZN4FMOD6System11getDSPClockEPjS1_: __ZN4FMOD6System11getDSPClockEPjS1_, __ZN20UnloadSceneOperationD2Ev: __ZN20UnloadSceneOperationD2Ev, __Z18SetITerrainPhysicsP15ITerrainPhysics: __Z18SetITerrainPhysicsP15ITerrainPhysics, __ZL32InitializeModule_ParticlesLegacyv: __ZL32InitializeModule_ParticlesLegacyv, __Z23_SimulationFilterShaderjN5physx12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj: __Z23_SimulationFilterShaderjN5physx12PxFilterDataEjS0_RNS_7PxFlagsINS_10PxPairFlag4EnumEtEEPKvj, __GLOBAL__sub_I_runtime_shaders_gpuprograms_lump_cpp: __GLOBAL__sub_I_runtime_shaders_gpuprograms_lump_cpp, __ZN5physx18PxsDynamicsContext12mergeResultsEv: __ZN5physx18PxsDynamicsContext12mergeResultsEv, __Z33SetCaptureAllKeyboardInputEnabledb: __Z33SetCaptureAllKeyboardInputEnabledb, __Z46Register_UnityEngine_Rigidbody2D_set_sleepModev: __Z46Register_UnityEngine_Rigidbody2D_set_sleepModev, __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_: __ZNSt3__26__sortIRNS_6__lessIN11UnityEngine9Animation13CachedBindingES4_EEPS4_EEvT0_S8_T_, _srand48: _srand48, __Z25BatchDeleteObjectInternalPKii: __Z25BatchDeleteObjectInternalPKii, __ZNK13GfxDeviceNull16IsScissorEnabledEv: __ZNK13GfxDeviceNull16IsScissorEnabledEv, __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_nextPositionv: __Z62Register_UnityEngine_AI_NavMeshAgent_INTERNAL_get_nextPositionv, ___dn_comp: ___dn_comp, __Z27QuaternionCurveToEulerCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE: __Z27QuaternionCurveToEulerCurveR17AnimationCurveTplI11QuaternionfEPPS_IfE, __ZN9AssetUser15OnBoundsChangedEv: __ZN9AssetUser15OnBoundsChangedEv, __ZN11NamedObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN11NamedObject23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z25CopySerializedIfDifferentRK6ObjectRS_: __Z25CopySerializedIfDifferentRK6ObjectRS_, __ZN11UnityEngine15CloudWebService14RestDownloader9ClearDoneEv: __ZN11UnityEngine15CloudWebService14RestDownloader9ClearDoneEv, __Z41Register_UnityEngine_AudioClip_get_lengthv: __Z41Register_UnityEngine_AudioClip_get_lengthv, __ZN5physx2Sn5ConvX15releaseMetaDataEv: __ZN5physx2Sn5ConvX15releaseMetaDataEv, __ZN12MeshCollider5ResetEv: __ZN12MeshCollider5ResetEv, __ZN5physx3Cct9SweepTest17onObstacleUpdatedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f: __ZN5physx3Cct9SweepTest17onObstacleUpdatedEjPKNS_17PxObstacleContextERKNS_6PxVec3ES7_f, _jrand48: _jrand48, __ZL20CopyNodesIntoJobGapsP29RenderNodeQueuePrepareContext: __ZL20CopyNodesIntoJobGapsP29RenderNodeQueuePrepareContext, __ZL26GeomMTDCallback_CapsuleBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL26GeomMTDCallback_CapsuleBoxRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZZN10GUIManager14InitGUIManagerEvEN33UIEventsIMGUIRenderOverlaysstruct7ForwardEi: __ZZN10GUIManager14InitGUIManagerEvEN33UIEventsIMGUIRenderOverlaysstruct7ForwardEi, __ZN5physx9NpPhysics27getPhysicsInsertionCallbackEv: __ZN5physx9NpPhysics27getPhysicsInsertionCallbackEv, __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEEC2EjjS5_: __ZNSt3__214__split_bufferIPNS_17__assoc_sub_stateERNS_18__hidden_allocatorIS2_EEEC2EjjS5_, _tt_property_set: _tt_property_set, __Z27ShaderPassContextInitializev: __Z27ShaderPassContextInitializev, __Z33AudioClip_Get_Custom_PropChannelsP12Il2CppObject: __Z33AudioClip_Get_Custom_PropChannelsP12Il2CppObject, __ZN9JSONWrite8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_PKc17TransferMetaFlags, __ZN13AnimationClip15GetRuntimeAssetEv: __ZN13AnimationClip15GetRuntimeAssetEv, __Z66Register_UnityEngine_ParticleSystem_CollisionModule_GetRadiusScalev: __Z66Register_UnityEngine_ParticleSystem_CollisionModule_GetRadiusScalev, __Z44Register_UnityEngine_ComputeBuffer_CopyCountv: __Z44Register_UnityEngine_ComputeBuffer_CopyCountv, _jinit_d_main_controller: _jinit_d_main_controller, __ZN22LocalFileSystemHandler18SetApplicationPathEPKc: __ZN22LocalFileSystemHandler18SetApplicationPathEPKc, __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackERNS0_14PvdInputStreamE: __ZN5physx8debugger22PvdObjectModelMetaData6createERNS_19PxAllocatorCallbackERNS0_14PvdInputStreamE, __ZN19TouchPhaseEmulation11AllocateNewEv: __ZN19TouchPhaseEmulation11AllocateNewEv, __ZN7mecanim5human19HumanPoseBlendBeginERNS0_9HumanPoseE: __ZN7mecanim5human19HumanPoseBlendBeginERNS0_9HumanPoseE, __ZN23iPhoneLocalNotification12SetSoundNameEPKc: __ZN23iPhoneLocalNotification12SetSoundNameEPKc, __ZN15AABBTreeRaycastILb1EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE: __ZN15AABBTreeRaycastILb1EEclEPN5physx2Sq13PrunerPayloadERKNS2_8AABBTreeERKNS1_6PxVec3ESA_RfSA_RNS2_14PrunerCallbackE, __ZN26AnimatorControllerPlayable10SetIntegerEiRKi: __ZN26AnimatorControllerPlayable10SetIntegerEiRKi, __ZN5Umbra9RasterOps20testRectAnyReferenceERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf: __ZN5Umbra9RasterOps20testRectAnyReferenceERKNS_17BlockRasterBufferERKNS_8Vector4iEPNS_11DepthBufferEf, __ZN12b2ChainShape11CreateChainEPK6b2Vec2i: __ZN12b2ChainShape11CreateChainEPK6b2Vec2i, __ZN5physx2Sc17ParticleSystemSim20visualizeSpatialGridERNS_2Cm12RenderOutputE: __ZN5physx2Sc17ParticleSystemSim20visualizeSpatialGridERNS_2Cm12RenderOutputE, __ZNK13ScreenManager20GetScreenOrientationEv: __ZNK13ScreenManager20GetScreenOrientationEv, __ZN5physx10NpMaterial22setFrictionCombineModeENS_13PxCombineMode4EnumE: __ZN5physx10NpMaterial22setFrictionCombineModeENS_13PxCombineMode4EnumE, __ZN5physx6PxVec3aSERKS0_: __ZN5physx6PxVec3aSERKS0_, __Z65Register_UnityEngine_LightProbeProxyVolume_get_isFeatureSupportedv: __Z65Register_UnityEngine_LightProbeProxyVolume_get_isFeatureSupportedv, __ZN5physx2Sc8ClothSim21removeCollisionConvexEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim21removeCollisionConvexEPKNS0_8ShapeSimE, __ZN8Material19UnshareMaterialDataEv: __ZN8Material19UnshareMaterialDataEv, __ZNSt3__217__libcpp_sscanf_lEPKcP15__locale_structS1_z: __ZNSt3__217__libcpp_sscanf_lEPKcP15__locale_structS1_z, __Z37TrailRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf: __Z37TrailRenderer_Set_Custom_PropEndWidthP12Il2CppObjectf, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE14setTranslationERKNS_6PxVec3E, __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev: __ZNSt3__29money_putIcNS_19ostreambuf_iteratorIcNS_11char_traitsIcEEEEED0Ev, __ZN21AnimationClipPlayableC2E18DirectorPlayerType: __ZN21AnimationClipPlayableC2E18DirectorPlayerType, __Z35setPxVehicleDriveSimData_ClutchDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataE: __Z35setPxVehicleDriveSimData_ClutchDataPN5physx21PxVehicleDriveSimDataERKNS_19PxVehicleClutchDataE, __ZN33AssetBundleLoadFromAsyncOperation12IsCrc32ValidEv: __ZN33AssetBundleLoadFromAsyncOperation12IsCrc32ValidEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj543ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj543ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt16nested_exceptionD0Ev: __ZNSt16nested_exceptionD0Ev, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj621ES2_KjNS_12PxFilterDataEEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZNK13MonoBehaviour15CanAssignScriptERK4PPtrI10MonoScriptE: __ZNK13MonoBehaviour15CanAssignScriptERK4PPtrI10MonoScriptE, __ZN7mecanim12statemachine25DestroyTransitionConstantEPNS0_18TransitionConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine25DestroyTransitionConstantEPNS0_18TransitionConstantERNS_6memory9AllocatorE, __Z38GUIClip_CUSTOM_INTERNAL_CALL_SetMatrixRK10Matrix4x4f: __Z38GUIClip_CUSTOM_INTERNAL_CALL_SetMatrixRK10Matrix4x4f, __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_: __ZNK5physx2Gu22SupportLocalShrunkImplINS0_18ConvexHullNoScaleVENS0_24ShrunkConvexHullNoScaleVEE9doSupportERKNS_6shdfnd3aos5Vec3VERNS6_6FloatVESB_, __Z46AnimatorControllerPlayable_CUSTOM_StringToHashP12Il2CppString: __Z46AnimatorControllerPlayable_CUSTOM_StringToHashP12Il2CppString, __ZNK13SpeedTreeWind15GetBranchAnchorEv: __ZNK13SpeedTreeWind15GetBranchAnchorEv, _emit_message: _emit_message, __ZN5physx14PxsAABBManager16addAggregatePairEjj: __ZN5physx14PxsAABBManager16addAggregatePairEjj, __ZNK5physx2Gu10ConvexMesh13getNbPolygonsEv: __ZNK5physx2Gu10ConvexMesh13getNbPolygonsEv, __ZN5physx2Cm12RenderOutputlsERKNS0_9DebugTextE: __ZN5physx2Cm12RenderOutputlsERKNS0_9DebugTextE, __ZN25b2CapsuleAndCircleContactC2EP9b2FixtureS1_: __ZN25b2CapsuleAndCircleContactC2EP9b2FixtureS1_, ___nl_langinfo_l: ___nl_langinfo_l, __ZNK19SimpleRayTriOverlap7overlapERKN5physx6PxVec3ES3_S3_RNS0_12PxRaycastHitE: __ZNK19SimpleRayTriOverlap7overlapERKN5physx6PxVec3ES3_S3_RNS0_12PxRaycastHitE, __ZN17SurfaceEffector2D23VirtualRedirectTransferER14SafeBinaryRead: __ZN17SurfaceEffector2D23VirtualRedirectTransferER14SafeBinaryRead, __ZN11UnityEngine7Connect14RemoteSettings6GetIntERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEi: __ZN11UnityEngine7Connect14RemoteSettings6GetIntERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEi, __ZN5Unity11SpringJoint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity11SpringJoint7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN18AsyncUploadManager19AsyncResourceUploadER9GfxDeviceii9TextureID: __ZN18AsyncUploadManager19AsyncResourceUploadER9GfxDeviceii9TextureID, __Z42ReflectionProbe_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z42ReflectionProbe_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __Z25Event_Get_Custom_PropTypeP12Il2CppObject: __Z25Event_Get_Custom_PropTypeP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj14ENS_7PxActorEPKcS9_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN22LocalFileSystemHandler19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN22LocalFileSystemHandler19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZNK5Umbra9FloatList11getCapacityEv: __ZNK5Umbra9FloatList11getCapacityEv, _jinit_input_controller: _jinit_input_controller, __Z5splatILj2EE8Scalar4fRKS0_: __Z5splatILj2EE8Scalar4fRKS0_, __ZN26AnimatorControllerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN26AnimatorControllerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj498ENS_22PxRepXPropertyAccessorILj498ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxJointAngularLimitPairEEEE14handleAccessorILj498ENS_22PxRepXPropertyAccessorILj498ES4_ffEEEEvRKT0_, __ZN5Unity14CharacterJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN5Unity14CharacterJoint8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z53Register_UnityEngine_ConfigurableJoint_set_swapBodiesv: __Z53Register_UnityEngine_ConfigurableJoint_set_swapBodiesv, __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_: __ZN14MessageHandler23RegisterMessageCallbackEPKN5Unity4TypeERK17MessageIdentifierPFvPviR11MessageDataES3_, __ZN19RenderEventsContextD2Ev: __ZN19RenderEventsContextD2Ev, __Z51Register_UnityEngine_MaterialPropertyBlock_GetFloatv: __Z51Register_UnityEngine_MaterialPropertyBlock_GetFloatv, __ZN15QualitySettings17SetShadowCascadesEi: __ZN15QualitySettings17SetShadowCascadesEi, __ZNK12NavMeshAgent21CalculateScaledHeightEv: __ZNK12NavMeshAgent21CalculateScaledHeightEv, __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __Z27RegisterModuleClasses_Audiov: __Z27RegisterModuleClasses_Audiov, __ZN5physx2Sc8BodyCore6backupERNS0_12SimStateDataE: __ZN5physx2Sc8BodyCore6backupERNS0_12SimStateDataE, __ZNSt3__225__num_get_signed_integralIxEET_PKcS3_Rji: __ZNSt3__225__num_get_signed_integralIxEET_PKcS3_Rji, __Z7CRCDonej: __Z7CRCDonej, __Z47Register_UnityEngine_Caching_get_spaceAvailablev: __Z47Register_UnityEngine_Caching_get_spaceAvailablev, _cff_parse_real: _cff_parse_real, __ZNK5physx2Sc8BodyCore16getLinearDampingEv: __ZNK5physx2Sc8BodyCore16getLinearDampingEv, __ZN11UTF16String10CopyStringERKS_: __ZN11UTF16String10CopyStringERKS_, __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z49AudioReverbFilter_Set_Custom_PropReflectionsDelayP12Il2CppObjectf: __Z49AudioReverbFilter_Set_Custom_PropReflectionsDelayP12Il2CppObjectf, __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv: __ZN12b2BroadPhase11CreateProxyERK6b2AABBPv, __ZN14ParticleSystem21EmitParticlesExternalER24ParticleSystemEmitParamsj: __ZN14ParticleSystem21EmitParticlesExternalER24ParticleSystemEmitParamsj, _finish_input_pass: _finish_input_pass, __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib: __Z23BlitCopyCompressedImage13TextureFormatPKhiiPhiib, __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf: __ZNK5physx2Gu15HeightFieldUtil18computePointNormalEjRKNS_6PxVec3ERKNS_11PxTransformEffffRf, __ZN8Gradient8TransferI17RemapPPtrTransferEEvRT_: __ZN8Gradient8TransferI17RemapPPtrTransferEEvRT_, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE7__weeksEv, __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11Tetrahedron8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZZN8Animator15InitializeClassEvEN31FunctorImpl_395kDidAddComponent4CallEPviR11MessageData: __ZZN8Animator15InitializeClassEvEN31FunctorImpl_395kDidAddComponent4CallEPviR11MessageData, __ZNK25ThreadsafeLinearAllocator10GetPtrSizeEPKv: __ZNK25ThreadsafeLinearAllocator10GetPtrSizeEPKv, __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei: __ZN7mecanim8skeleton14SkeletonSetDoFEPKNS0_8SkeletonEPNS0_13SkeletonPoseTIN4math4trsXEEERKNS5_7_float3Ei, __ZN5Umbra12QueryContext19addQueryDebugSphereERKNS_7Vector3EfRKNS_7Vector4E: __ZN5Umbra12QueryContext19addQueryDebugSphereERKNS_7Vector3EfRKNS_7Vector4E, __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv: __ZN17PersistentManager40LoadRemainingPreallocatedObjectsInternalEv, __ZN5physx7NpCloth23sendPvdVirtualParticlesEv: __ZN5physx7NpCloth23sendPvdVirtualParticlesEv, _pre_process_context: _pre_process_context, __ZN20FileSystemEnumerator5ClearEv: __ZN20FileSystemEnumerator5ClearEv, __ZL15GetRendererImplv: __ZL15GetRendererImplv, __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE: __ZN18AssetBundleManager30CollectPreloadDataDependenciesEPK11AssetBundleRKNSt3__26vectorI14ConstantStringNS3_9allocatorIS5_EEEEbR13dynamic_arrayIiLj4EE, __ZN16PxOverflowBufferIN5physx12PxRaycastHitEED0Ev: __ZN16PxOverflowBufferIN5physx12PxRaycastHitEED0Ev, __ZN22ParticleSystemRendererC2E10MemLabelId18ObjectCreationMode: __ZN22ParticleSystemRendererC2E10MemLabelId18ObjectCreationMode, __ZN13Simd4fFactoryIN6detail13OffsetPointerIfEEEC2ES2_: __ZN13Simd4fFactoryIN6detail13OffsetPointerIfEEEC2ES2_, __ZN15OcclusionPortal8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15OcclusionPortal8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14DetailRenderer18ReloadDirtyDetailsEv: __ZN14DetailRenderer18ReloadDirtyDetailsEv, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv, __Z52Register_UnityEngine_MaterialPropertyBlock_SetBufferv: __Z52Register_UnityEngine_MaterialPropertyBlock_SetBufferv, __Z33CommandBuffer_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString: __Z33CommandBuffer_Set_Custom_PropNameP12Il2CppObjectP12Il2CppString, __Z19InitShaderCacheGLESv: __Z19InitShaderCacheGLESv, __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E: __ZL15gPrecomputeSortRN5physx2Sq16BucketPrunerNodeEPKNS_6PxVec3E, __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15DistanceJoint2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20UnityConnectSettings17InitializeSettingER19BaseConnectSettings: __ZN20UnityConnectSettings17InitializeSettingER19BaseConnectSettings, __Z18Transfer_BlittableI14SafeBinaryReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb1EdEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z59Register_UnityEngine_AI_OffMeshLink_set_autoUpdatePositionsv: __Z59Register_UnityEngine_AI_OffMeshLink_set_autoUpdatePositionsv, __ZN20TextRenderingPrivate17TextMeshGeneratorC2ERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii: __ZN20TextRenderingPrivate17TextMeshGeneratorC2ERK11UTF16StringPN13TextRendering4FontE10TextAnchor13TextAlignmentfffbb11ColorRGBA32fii, __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j: __ZN5physx5cloth9ClothImplINS0_7SwClothEE12setTrianglesENS0_5RangeIKNS_6PxVec3EEES7_j, __ZL12SweepBoxMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL12SweepBoxMeshPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, _UNITY_FT_Create_Class_ft_smooth_renderer_class: _UNITY_FT_Create_Class_ft_smooth_renderer_class, __ZN5physx8debugger14PvdMarshallingItiE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItiE12marshalBlockEPKhPhj, __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE, __ZN10MonoScript21AwakeFromLoadThreadedEv: __ZN10MonoScript21AwakeFromLoadThreadedEv, __Z17SetUnityWebStreamP14UnityWebStream: __Z17SetUnityWebStreamP14UnityWebStream, _mbsrtowcs: _mbsrtowcs, __Z61Register_UnityEngine_ParticleRenderer_set_cameraVelocityScalev: __Z61Register_UnityEngine_ParticleRenderer_set_cameraVelocityScalev, __Z50Register_UnityEngine_SkinnedMeshRenderer_get_bonesv: __Z50Register_UnityEngine_SkinnedMeshRenderer_get_bonesv, _UNITY_png_set_packing: _UNITY_png_set_packing, __ZN5physx2Sn15SimpleXmlWriterD2Ev: __ZN5physx2Sn15SimpleXmlWriterD2Ev, __ZN17CollisionMeshData15GetSharedNxMeshER4Mesh: __ZN17CollisionMeshData15GetSharedNxMeshER4Mesh, __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapXMultiplierP12Il2CppObject: __Z53ParticleSystem_NoiseModule_CUSTOM_GetRemapXMultiplierP12Il2CppObject, __ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E: __ZN5physx14PxsComputeAABBEbRKNS_18PxcAABBDataDynamicERNS_9PxBounds3E, __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_: __ZN12_GLOBAL__N_124calculateFrictionImpulseI8Scalar4fEEvRKT_S4_S4_S4_S4_S4_PS3_S5_S4_S4_S4_PS2_, __ZN5physx2Gu11HeightField14onRefCountZeroEv: __ZN5physx2Gu11HeightField14onRefCountZeroEv, __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo: __ZN21LinearCollectionFieldC2ERK17GeneralMonoObjectP9FieldInfo, __ZN2UI14CanvasRenderer16CheckConsistencyEv: __ZN2UI14CanvasRenderer16CheckConsistencyEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_20PxClothStretchConfigEE12readPropertyIfEEbRT_, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18DownloadHandlerVFSD2Ev: __ZN18DownloadHandlerVFSD2Ev, __ZNK9Texture2D13IsNPOTAllowedEv: __ZNK9Texture2D13IsNPOTAllowedEv, __ZN5physx2Sn5ConvX9convert64EPKcRKNS0_15PxMetaDataEntryES6_: __ZN5physx2Sn5ConvX9convert64EPKcRKNS0_15PxMetaDataEntryES6_, __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN2UI6Canvas8TransferI18StreamedBinaryReadILb1EEEEvRT_, _start_pass_coef_19: _start_pass_coef_19, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorI9InputAxisNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_9basic_iosIcS2_EES6_E: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEErsEPFRNS_9basic_iosIcS2_EES6_E, __Z19sweepConvex_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z19sweepConvex_BoxGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_20PxConvexMeshGeometryES5_RKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZN20ExternalForcesModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN20ExternalForcesModule8AllocateERK27ParticleSystemReadOnlyStateR19ParticleSystemState, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc13ConstraintSimES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE15reserveInternalEj, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKw: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7compareEjjPKw, __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev: __ZN5physx31PxVehicleDriveTankGeneratedInfoC2Ev, __Z30Font_Get_Custom_PropLineHeightP12Il2CppObject: __Z30Font_Get_Custom_PropLineHeightP12Il2CppObject, __ZN15ReflectionProbe17RemoveFromManagerEv: __ZN15ReflectionProbe17RemoveFromManagerEv, __ZN5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv: __ZN5physx7profile30PxProfileMemoryEventBufferImpl18flushProfileEventsEv, __ZNK13GfxDeviceNull19GetProjectionMatrixEv: __ZNK13GfxDeviceNull19GetProjectionMatrixEv, __ZNKSt3__223__future_error_category4nameEv: __ZNKSt3__223__future_error_category4nameEv, __ZN10HumanTrait9GetBoneIdERK6Avatari: __ZN10HumanTrait9GetBoneIdERK6Avatari, __ZNK13GfxDeviceGLES26GetActiveRenderTargetCountEv: __ZNK13GfxDeviceGLES26GetActiveRenderTargetCountEv, __ZN14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj: __ZN14PhysicsManager9onTriggerEPN5physx13PxTriggerPairEj, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEESt16initializer_listIcE, __ZN19SkinnedMeshRenderer26ClearCachedAnimatorBindingEv: __ZN19SkinnedMeshRenderer26ClearCachedAnimatorBindingEv, __ZN5physx14NpShapeManager20clearShapesOnReleaseERNS_3Scb5SceneERNS_12PxRigidActorE: __ZN5physx14NpShapeManager20clearShapesOnReleaseERNS_3Scb5SceneERNS_12PxRigidActorE, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_2Sc8ShapeSimENS4_10NPhaseCore16ClothListElementEEES7_NS0_4HashIS7_EENS1_11HashMapBaseIS7_SA_SD_NS0_9AllocatorEE6GetKeyESF_Lb1EE6createERS8_Rb, __Z50RectTransform_CUSTOM_INTERNAL_get_anchoredPositionP12Il2CppObjectP13Vector2fIcall: __Z50RectTransform_CUSTOM_INTERNAL_get_anchoredPositionP12Il2CppObjectP13Vector2fIcall, __Z36EdgeCollider2D_Get_Custom_PropPointsP12Il2CppObject: __Z36EdgeCollider2D_Get_Custom_PropPointsP12Il2CppObject, __Z33setPxCloth_MotionConstraintConfigPN5physx7PxClothERKNS_29PxClothMotionConstraintConfigE: __Z33setPxCloth_MotionConstraintConfigPN5physx7PxClothERKNS_29PxClothMotionConstraintConfigE, __Z21CheckImageFormatValidii13TextureFormat: __Z21CheckImageFormatValidii13TextureFormat, __Z37Sprite_Get_Custom_PropPackingRotationP12Il2CppObject: __Z37Sprite_Get_Custom_PropPackingRotationP12Il2CppObject, __ZNK5physx9NpFactory17getNbClothFabricsEv: __ZNK5physx9NpFactory17getNbClothFabricsEv, __Z54Register_UnityEngine_Application_Internal_ExternalCallv: __Z54Register_UnityEngine_Application_Internal_ExternalCallv, _mallinfo: _mallinfo, __ZN16Physics2DManager26SetTransformMessageEnabledEb: __ZN16Physics2DManager26SetTransformMessageEnabledEb, __Z34getPxArticulation_ConcreteTypeNamePKN5physx14PxArticulationE: __Z34getPxArticulation_ConcreteTypeNamePKN5physx14PxArticulationE, __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11NavMeshData23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, _LzmaDec_FreeProbs: _LzmaDec_FreeProbs, __ZN15ReflectionProbe23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15ReflectionProbe23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN19TouchPhaseEmulation17PreprocessTouchesEv: __ZN19TouchPhaseEmulation17PreprocessTouchesEv, __ZN18AnimatorController17MainThreadCleanupEv: __ZN18AnimatorController17MainThreadCleanupEv, __Z31getPxVehicleAutoBoxData_LatencyPKN5physx20PxVehicleAutoBoxDataE: __Z31getPxVehicleAutoBoxData_LatencyPKN5physx20PxVehicleAutoBoxDataE, __ZN13InitialModule9ResetSeedERK27ParticleSystemReadOnlyState: __ZN13InitialModule9ResetSeedERK27ParticleSystemReadOnlyState, __ZN14MessageHandler15MessageIDToNameEi: __ZN14MessageHandler15MessageIDToNameEi, __Z47CopyWorldSpaceTransformDataWithoutNotificationsP6ObjectS0_: __Z47CopyWorldSpaceTransformDataWithoutNotificationsP6ObjectS0_, __ZN9LensFlare15ThreadedCleanupEv: __ZN9LensFlare15ThreadedCleanupEv, __ZN11KeyframeTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11KeyframeTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx8debugger4comm15DestroyInstance9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm15DestroyInstance9serializeERNS1_15EventSerializerE, __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev: __ZZNK5physx26PxSerializerDefaultAdapterINS_3Ext14SphericalJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallbackD0Ev, __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j: __ZN5physx6shdfnd4sortIPvNS0_4LessIS2_EENS0_19ReflectionAllocatorINS_2Sc9ActorPairEEEEEvPT_jRKT0_RKT1_j, __Z30Animator_CUSTOM_ResetTriggerIDP12Il2CppObjecti: __Z30Animator_CUSTOM_ResetTriggerIDP12Il2CppObjecti, __ZNK5physx14NpSpatialIndex12flushUpdatesEv: __ZNK5physx14NpSpatialIndex12flushUpdatesEv, __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE: __ZN4FMOD6System18createChannelGroupEPKcPPNS_12ChannelGroupE, __ZN11UnityEngine15PlatformWrapper19GetEnabledVRDevicesEv: __ZN11UnityEngine15PlatformWrapper19GetEnabledVRDevicesEv, __ZN12EventManager11RemoveEventEP10EventEntry: __ZN12EventManager11RemoveEventEP10EventEntry, __ZN8UVModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN8UVModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEE14handleAccessorILj550ENS_22PxRepXPropertyAccessorILj550ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_27PxVehicleDifferentialNWDataEEEE14handleAccessorILj550ENS_22PxRepXPropertyAccessorILj550ES4_jjEEEEvjRKT0_, __ZN2UI6Canvas12CleanupClassEv: __ZN2UI6Canvas12CleanupClassEv, __Z43Application_Get_Custom_PropBundleIdentifierv: __Z43Application_Get_Custom_PropBundleIdentifierv, __Z54Register_UnityEngine_PhysicsMaterial2D_Internal_Createv: __Z54Register_UnityEngine_PhysicsMaterial2D_Internal_Createv, __ZN5physx7NpScene14prepareCollideEf: __ZN5physx7NpScene14prepareCollideEf, ___cxa_get_globals_fast: ___cxa_get_globals_fast, __ZN5physx25PxFixedJointGeneratedInfoC2Ev: __ZN5physx25PxFixedJointGeneratedInfoC2Ev, __ZN20QuadTreeNodeRendererC2Ev: __ZN20QuadTreeNodeRendererC2Ev, __Z33Joint2D_Get_Custom_PropBreakForceP12Il2CppObject: __Z33Joint2D_Get_Custom_PropBreakForceP12Il2CppObject, _UNITY_FT_CMap_Done: _UNITY_FT_CMap_Done, __ZN5physx3Scb11RigidStatic9syncStateEv: __ZN5physx3Scb11RigidStatic9syncStateEv, __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_12mergeDensityEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN4FMOD8ChannelI33UpdateStartPositionForPitchChangeEff: __ZN4FMOD8ChannelI33UpdateStartPositionForPitchChangeEff, __Z51Register_UnityEngine_ParticleSystem_get_playOnAwakev: __Z51Register_UnityEngine_ParticleSystem_get_playOnAwakev, __ZNK12HandlerChain9CanHandleEPKc: __ZNK12HandlerChain9CanHandleEPKc, __ZN13TranslateGLES28InitDepthBufferFormat2FormatERK12GraphicsCaps: __ZN13TranslateGLES28InitDepthBufferFormat2FormatERK12GraphicsCaps, __Z37getPxTriangleMeshGeometryTriangleMeshPKN5physx22PxTriangleMeshGeometryE: __Z37getPxTriangleMeshGeometryTriangleMeshPKN5physx22PxTriangleMeshGeometryE, __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, _UNITY_TT_Clear_CodeRange: _UNITY_TT_Clear_CodeRange, __Z38LightProbes_Set_Custom_PropBakedProbesP12Il2CppObjectP11Il2CppArray: __Z38LightProbes_Set_Custom_PropBakedProbesP12Il2CppObjectP11Il2CppArray, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS0_9allocatorIS4_EEEEEvRT_j, __ZN7b2JointC2EPK10b2JointDef: __ZN7b2JointC2EPK10b2JointDef, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE19GetRequestedPtrSizeEPKv, __ZN5Umbra10QueryStateC2EPvj: __ZN5Umbra10QueryStateC2EPvj, __ZN9Transform26ValidateHierarchyRecursiveER18TransformHierarchyRiS2_iPh: __ZN9Transform26ValidateHierarchyRecursiveER18TransformHierarchyRiS2_iPh, __ZN9GfxDevice22CopyComputeBufferCountE15ComputeBufferIDS0_j: __ZN9GfxDevice22CopyComputeBufferCountE15ComputeBufferIDS0_j, __ZN8WindZone15ThreadedCleanupEv: __ZN8WindZone15ThreadedCleanupEv, _tt_cmap13_char_map_binary: _tt_cmap13_char_map_binary, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead17AnimationCurveTplIfELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKcPcEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S7_SA_NS_8debugger19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev, _jsimd_can_h2v2_downsample: _jsimd_can_h2v2_downsample, __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEER17ShaderPassContext: __Z28RenderSceneShaderReplacementRK13dynamic_arrayI16RenderObjectDataLj4EERK19SharedRendererSceneP6ShaderRKNSt3__212basic_stringIcNS9_11char_traitsIcEENS9_9allocatorIcEEEER17ShaderPassContext, _ft_ansi_stream_io: _ft_ansi_stream_io, __ZN11PreloadData23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN11PreloadData23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb: __Z16EmitterStoreDataRKN4math8float3x3EPKfR23ParticleSystemParticlesjRNS_8floatNx3ES8_R5RandNffbb, __ZN2UI14CanvasRenderer18OnParentingChangedEv: __ZN2UI14CanvasRenderer18OnParentingChangedEv, __ZNK9Transform11IsSceneRootEv: __ZNK9Transform11IsSceneRootEv, __ZN16ReflectionProbes13IsActiveProbeEP15ReflectionProbe: __ZN16ReflectionProbes13IsActiveProbeEP15ReflectionProbe, __ZN5physx7NpScene15setCCDMaxPassesEj: __ZN5physx7NpScene15setCCDMaxPassesEj, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_18ConvexHullNoScaleVENS0_11ConvexHullVEED0Ev, __Z65Register_UnityEngine_ParticleSystem_MainModule_SetStartRotation3Dv: __Z65Register_UnityEngine_ParticleSystem_MainModule_SetStartRotation3Dv, __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EE: __ZN5physx5cloth15SwSelfCollisionI8Scalar4fEC2ERNS0_11SwClothDataER14StackAllocatorILj16EE, __ZL18UnityDetourReallocPvi: __ZL18UnityDetourReallocPvi, __ZN12LineRenderer16CheckConsistencyEv: __ZN12LineRenderer16CheckConsistencyEv, __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetRectOffsetPtrP12Il2CppObjectiRPv: __Z46GUIStyle_CUSTOM_INTERNAL_CALL_GetRectOffsetPtrP12Il2CppObjectiRPv, __Z18HandleSteppedCurveRK11KeyframeTplIfES2_Rf: __Z18HandleSteppedCurveRK11KeyframeTplIfES2_Rf, __ZN14EdgeCollider2DD2Ev: __ZN14EdgeCollider2DD2Ev, __Z46Register_UnityEngine_GL_INTERNAL_CALL_Viewportv: __Z46Register_UnityEngine_GL_INTERNAL_CALL_Viewportv, __ZN11JpegDecoderD2Ev: __ZN11JpegDecoderD2Ev, _UNITY_FT_MulDiv: _UNITY_FT_MulDiv, __ZN5Unity5Cloth14SetupCollidersEv: __ZN5Unity5Cloth14SetupCollidersEv, __ZN7mecanim9animation17EvaluateBlendTreeERKNS0_17BlendTreeConstantERKNS0_14BlendTreeInputERNS0_15BlendTreeOutputERNS0_18BlendTreeWorkspaceERKNS0_12AnimationSetE: __ZN7mecanim9animation17EvaluateBlendTreeERKNS0_17BlendTreeConstantERKNS0_14BlendTreeInputERNS0_15BlendTreeOutputERNS0_18BlendTreeWorkspaceERKNS0_12AnimationSetE, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE6getDirEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE5eraseERKS4_: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE5eraseERKS4_, __ZN17Physics2DSettings21SetVelocityIterationsEi: __ZN17Physics2DSettings21SetVelocityIterationsEi, __ZN14UnityWebStream14UpdateProgressEv: __ZN14UnityWebStream14UpdateProgressEv, __Z28IntersectAABBSphereInclusiveRK4AABBRK6Sphere: __Z28IntersectAABBSphereInclusiveRK4AABBRK6Sphere, __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject: __Z56ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8Renderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK14ParticleSystem13GetStartSpeedEv: __ZNK14ParticleSystem13GetStartSpeedEv, __ZNK5physx12NpConstraint8getSceneEv: __ZNK5physx12NpConstraint8getSceneEv, __Z61Register_UnityEngine_RenderSettings_get_defaultReflectionModev: __Z61Register_UnityEngine_RenderSettings_get_defaultReflectionModev, __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxAllv: __Z58Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxAllv, __Z34Animator_CUSTOM_SetFloatStringDampP12Il2CppObjectP12Il2CppStringfff: __Z34Animator_CUSTOM_SetFloatStringDampP12Il2CppObjectP12Il2CppStringfff, _tempnam: _tempnam, __Z30GetClassIDWithoutLoadingObjecti: __Z30GetClassIDWithoutLoadingObjecti, __ZN17Physics2DSettings21SetPositionIterationsEi: __ZN17Physics2DSettings21SetPositionIterationsEi, __ZN23CloudWebServicesManagerC2E10MemLabelId18ObjectCreationMode: __ZN23CloudWebServicesManagerC2E10MemLabelId18ObjectCreationMode, __ZN18StreamedBinaryReadILb0EE5AlignEv: __ZN18StreamedBinaryReadILb0EE5AlignEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEED2Ev: __ZN5physx6shdfnd8PoolBaseINS_24NpPtrTableStorageManager8PtrBlockILi4EEENS0_19ReflectionAllocatorIS4_EEED2Ev, __Z36Register_UnityEngine_Object_set_namev: __Z36Register_UnityEngine_Object_set_namev, __Z43Renderer_Get_Custom_PropIsPartOfStaticBatchP12Il2CppObject: __Z43Renderer_Get_Custom_PropIsPartOfStaticBatchP12Il2CppObject, __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdatePollPlayerConnectionstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN37EarlyUpdatePollPlayerConnectionstruct7ForwardEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram14ConstantBufferENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_: __ZN13dynamic_arrayI8Vector4fLj4EE9push_backERKS0_, __ZNK10FileSystem20GetApplicationFolderEv: __ZNK10FileSystem20GetApplicationFolderEv, __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE: __ZN5physx2Gu8gjkLocalINS0_9TriangleVENS0_4BoxVEEEjRKT_RKT0_RNS_6shdfnd3aos5Vec3VESD_SD_RNSB_6FloatVE, __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob: __ZN16MeshVertexFormatC2EjRK18VertexChannelsInfob, __ZNK5physx23PxsBroadPhaseContextSap18getNumCreatedPairsEv: __ZNK5physx23PxsBroadPhaseContextSap18getNumCreatedPairsEv, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z33EmitSerializationCommandsForFieldI17RemapPPtrTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI17RemapPPtrTransferEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN4FMOD6System26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD6System26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE14AllocationPageIL11RequestType1EEEbPKv, __ZNKSt3__27codecvtIDic11__mbstate_tE16do_always_noconvEv: __ZNKSt3__27codecvtIDic11__mbstate_tE16do_always_noconvEv, __Z18Transfer_BlittableI9JSONWriteLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z38Application_Get_Custom_PropProductNamev: __Z38Application_Get_Custom_PropProductNamev, __ZN5physx12NpBatchQuery18resetResultBuffersEv: __ZN5physx12NpBatchQuery18resetResultBuffersEv, __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn9UnionTypeENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __ZN14ParticleSystemD2Ev: __ZN14ParticleSystemD2Ev, __ZNK6Sprite10GetPaddingEb: __ZNK6Sprite10GetPaddingEb, __ZN9Heightmap23RecomputeInvalidPatchesER13dynamic_arrayIiLj4EE: __ZN9Heightmap23RecomputeInvalidPatchesER13dynamic_arrayIiLj4EE, __Z28getPxClothFabric_NbParticlesPKN5physx13PxClothFabricE: __Z28getPxClothFabric_NbParticlesPKN5physx13PxClothFabricE, __Z18Transfer_BlittableI17RemapPPtrTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx8debugger14PvdMarshallingItyE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItyE12marshalBlockEPKhPhj, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE11getRotationEv, __ZN5physx2Sn20SerializationContext9writeNameEPKc: __ZN5physx2Sn20SerializationContext9writeNameEPKc, __ZN13EmscriptenWWWD2Ev: __ZN13EmscriptenWWWD2Ev, _jpeg_read_coefficients: _jpeg_read_coefficients, __ZN5physx7NpScene8lockReadEPKcj: __ZN5physx7NpScene8lockReadEPKcj, __ZN15NavMeshObstacle26CalculateSupportedMessagesEv: __ZN15NavMeshObstacle26CalculateSupportedMessagesEv, __ZThn24_NK5physx2Sc16ActorInteraction13getNPhaseCoreEv: __ZThn24_NK5physx2Sc16ActorInteraction13getNPhaseCoreEv, __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterTypev: __Z71Register_UnityEngine_ParticleSystem_SubEmittersModule_SetSubEmitterTypev, __Z13RegisterClassI13AnimationClipEvv: __Z13RegisterClassI13AnimationClipEvv, __Z38GUIClip_CUSTOM_INTERNAL_CALL_GetMatrixR10Matrix4x4f: __Z38GUIClip_CUSTOM_INTERNAL_CALL_GetMatrixR10Matrix4x4f, __ZN12CubemapArray19UnloadFromGfxDeviceEb: __ZN12CubemapArray19UnloadFromGfxDeviceEb, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED2Ev: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEED2Ev, __ZN17SurfaceEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE: __ZN17SurfaceEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE, __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19LightProbeOcclusion8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc26ActorPairContactReportDataENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE19getConcreteTypeNameEv, __ZN13TriggerEvents5ClearEv: __ZN13TriggerEvents5ClearEv, __Z20ConfigureBlockRangesP10BlockRangeii: __Z20ConfigureBlockRangesP10BlockRangeii, __ZN13RenderTexture19MarkRestoreExpectedEv: __ZN13RenderTexture19MarkRestoreExpectedEv, __ZN5physx2Sc8ClothSim15addCollisionBoxEPKNS0_8ShapeSimE: __ZN5physx2Sc8ClothSim15addCollisionBoxEPKNS0_8ShapeSimE, __ZN15TerrainRenderer20GetPatchVertexStreamEiiiPP15SharedGfxBuffer: __ZN15TerrainRenderer20GetPatchVertexStreamEiiiPP15SharedGfxBuffer, __ZN26PlayerSettingsSplashScreen5ResetEv: __ZN26PlayerSettingsSplashScreen5ResetEv, __Z18EnsureRadiusIsSaneRf: __Z18EnsureRadiusIsSaneRf, __ZN19CharacterController24SetEnableOverlapRecoveryEb: __ZN19CharacterController24SetEnableOverlapRecoveryEb, _unzCloseCurrentFile: _unzCloseCurrentFile, _tt_name_entry_ascii_from_other: _tt_name_entry_ascii_from_other, __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_8debugger10NamedValueENS2_19ForwardingAllocatorEE6resizeEjRKS3_, __ZN5physx13GuMeshFactory7releaseEv: __ZN5physx13GuMeshFactory7releaseEv, __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17PolygonCollider2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z33Sprite_CUSTOM_INTERNAL_get_borderP12Il2CppObjectP8Vector4f: __Z33Sprite_CUSTOM_INTERNAL_get_borderP12Il2CppObjectP8Vector4f, __ZN9ShaderLab27SerializedShaderVectorValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9ShaderLab27SerializedShaderVectorValue8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN20LocalFileSystemPosix11CreateAsDirER13FileEntryData: __ZN20LocalFileSystemPosix11CreateAsDirER13FileEntryData, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwb: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwb, __Z42RenderSettings_Get_Custom_PropHaloStrengthv: __Z42RenderSettings_Get_Custom_PropHaloStrengthv, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE10onComShiftEj, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwe: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwe, __Z55Register_UnityEngine_PhysicMaterial_get_dynamicFrictionv: __Z55Register_UnityEngine_PhysicMaterial_get_dynamicFrictionv, __ZNSt3__26locale5__impD2Ev: __ZNSt3__26locale5__impD2Ev, __ZN8VRModule30BeforeInitializeEngineGraphicsEv: __ZN8VRModule30BeforeInitializeEngineGraphicsEv, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwl: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwl, __ZNK9Heightmap7GetSizeEv: __ZNK9Heightmap7GetSizeEv, __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color: __ZN7b2World9DrawShapeEP9b2FixtureRK11b2TransformRK7b2Color, _UNITY_png_get_chunk_malloc_max: _UNITY_png_get_chunk_malloc_max, __ZN10MemoryPool14AllocNewBubbleEv: __ZN10MemoryPool14AllocNewBubbleEv, __ZNK5physx7NpScene30getClothInterCollisionDistanceEv: __ZNK5physx7NpScene30getClothInterCollisionDistanceEv, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwx: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwx, __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwy: __ZNKSt3__27num_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEE3putES4_RNS_8ios_baseEwy, __ZN5physx3Scb10Constraint9syncStateEv: __ZN5physx3Scb10Constraint9syncStateEv, __ZNK9Animation12GetClipCountEv: __ZNK9Animation12GetClipCountEv, __ZN14MinMaxGradientC2Ev: __ZN14MinMaxGradientC2Ev, __ZN11MonoManager14LoadAssembliesEv: __ZN11MonoManager14LoadAssembliesEv, __Z53Register_UnityEngine_Terrain_get_collectDetailPatchesv: __Z53Register_UnityEngine_Terrain_get_collectDetailPatchesv, __Z27getPxJoint_InvInertiaScale1PKN5physx7PxJointE: __Z27getPxJoint_InvInertiaScale1PKN5physx7PxJointE, __ZN20BufferedSocketStreamC2Eijjb: __ZN20BufferedSocketStreamC2Eijjb, __Z37Rigidbody2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayf: __Z37Rigidbody2D_CUSTOM_INTERNAL_CALL_CastP12Il2CppObjectRK13Vector2fIcallP11Il2CppArrayf, __ZN5physx2Sn8MetaDataC2ERNS0_5ConvXE: __ZN5physx2Sn8MetaDataC2ERNS0_5ConvXE, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_14PxRigidDynamicEEENS_22PxTriangleMeshGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN12TreeRenderer20CollectTreeRenderersER13dynamic_arrayI9SceneNodeLj4EERS0_I4AABBLj4EE: __ZN12TreeRenderer20CollectTreeRenderersER13dynamic_arrayI9SceneNodeLj4EERS0_I4AABBLj4EE, __ZNK9ShaderLab11ShaderState22IsShaderStateSupportedEv: __ZNK9ShaderLab11ShaderState22IsShaderStateSupportedEv, __ZN19CollisionListener2D8PreSolveEP9b2ContactPK10b2Manifold: __ZN19CollisionListener2D8PreSolveEP9b2ContactPK10b2Manifold, __ZN13GfxDeviceGLES16CreateBlendStateERK13GfxBlendState: __ZN13GfxDeviceGLES16CreateBlendStateERK13GfxBlendState, __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetTypev: __Z59Register_UnityEngine_ParticleSystem_CollisionModule_GetTypev, __ZeqRK14ImageReferenceS1_: __ZeqRK14ImageReferenceS1_, __Z14GetAppDataPathv: __Z14GetAppDataPathv, ___ctype_get_mb_cur_max: ___ctype_get_mb_cur_max, __Z26FillCommonScriptingClassesR22CommonScriptingClasses: __Z26FillCommonScriptingClassesR22CommonScriptingClasses, __ZN19TouchPhaseEmulationD2Ev: __ZN19TouchPhaseEmulationD2Ev, __ZZN2UI6Canvas15InitializeClassEvEN33FunctorImpl_1283kTransformChanged4CallEPviR11MessageData: __ZZN2UI6Canvas15InitializeClassEvEN33FunctorImpl_1283kTransformChanged4CallEPviR11MessageData, __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_2Sc19ConstraintGroupNodeES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZN14DetailDatabase21AwakeFromLoadThreadedEv: __ZN14DetailDatabase21AwakeFromLoadThreadedEv, __Z41Physics2D_Get_Custom_PropMaxRotationSpeedv: __Z41Physics2D_Get_Custom_PropMaxRotationSpeedv, __ZNK5physx16PxParticleSystem19getConcreteTypeNameEv: __ZNK5physx16PxParticleSystem19getConcreteTypeNameEv, __Z19getNbPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE: __Z19getNbPxScene_ActorsPKN5physx7PxSceneENS_7PxFlagsINS_15PxActorTypeFlag4EnumEtEE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11__get_year4ERiRS4_S4_RjRKNS_5ctypeIcEE, _ft_outline_glyph_done: _ft_outline_glyph_done, __ZNK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv: __ZNK5physx7profile30PxProfileMemoryEventBufferImpl10hasClientsEv, __ZN5physx2Sn18RepXCollectionImpl12getAllocatorEv: __ZN5physx2Sn18RepXCollectionImpl12getAllocatorEv, __Z49PlatformEffector2D_Get_Custom_PropUseSideFrictionP12Il2CppObject: __Z49PlatformEffector2D_Get_Custom_PropUseSideFrictionP12Il2CppObject, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS2_9allocatorIS6_EEEEEEvRT_17TransferMetaFlags, __ZL18NavMeshUnloadScenei: __ZL18NavMeshUnloadScenei, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE13getActorFlagsEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE13getActorFlagsEv, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE7getNameEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE7getNameEv, __Z53Register_UnityEngine_ParticleSystem_set_playbackSpeedv: __Z53Register_UnityEngine_ParticleSystem_set_playbackSpeedv, __ZN15CollisionModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15CollisionModule8TransferI24GenerateTypeTreeTransferEEvRT_, __Z26setPxSceneDescFrictionTypePN5physx11PxSceneDescENS_14PxFrictionType4EnumE: __Z26setPxSceneDescFrictionTypePN5physx11PxSceneDescENS_14PxFrictionType4EnumE, __Z68Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsv: __Z68Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsv, __ZN22BaseUnityConnectClient20LookForVersionChangeEb: __ZN22BaseUnityConnectClient20LookForVersionChangeEb, _tt_get_kerning: _tt_get_kerning, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE13lockParticlesEv, __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIN9ShaderLab16FastPropertyNameE10ColorRGBAfEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, _tlsf_check_heap: _tlsf_check_heap, __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE11runInternalEv, __ZNSt3__210__time_getD2Ev: __ZNSt3__210__time_getD2Ev, __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN27ParticleSystemReadOnlyState8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sn13XmlNodeReader10leaveChildEv: __ZN5physx2Sn13XmlNodeReader10leaveChildEv, __Z50AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedField13Il2Cpp_IntPtrRPv: __Z50AndroidJNI_CUSTOM_INTERNAL_CALL_FromReflectedField13Il2Cpp_IntPtrRPv, __ZN13UnityProfiler23RemovePerThreadProfilerEP22UnityProfilerPerThread: __ZN13UnityProfiler23RemovePerThreadProfilerEP22UnityProfilerPerThread, __ZN5physx2Gu33MultiplePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_: __ZN5physx2Gu33MultiplePersistentContactManifold12drawManifoldERNS_2Cm12RenderOutputERKNS_6shdfnd3aos12PsTransformVES9_, __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN2UI13RectTransform8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN16DeprecatedColors8TransferI14SafeBinaryReadEEvRT_: __ZN16DeprecatedColors8TransferI14SafeBinaryReadEEvRT_, __ZN6Sprite8TransferI14SafeBinaryReadEEvRT_: __ZN6Sprite8TransferI14SafeBinaryReadEEvRT_, __Z63Register_UnityEngine_Networking_DownloadHandler_InternalDestroyv: __Z63Register_UnityEngine_Networking_DownloadHandler_InternalDestroyv, __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI24GenerateTypeTreeTransferEEvRS3_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStrS2_EEE8TransferI24GenerateTypeTreeTransferEEvRS3_RT_, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15DetailPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI15DetailPrototypeNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __Z45Register_UnityEngine_Font_Internal_CreateFontv: __Z45Register_UnityEngine_Font_Internal_CreateFontv, __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE: __ZN5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE13setActorFlagsENS_7PxFlagsINS_11PxActorFlag4EnumEtEE, __ZN12SocketStreamD0Ev: __ZN12SocketStreamD0Ev, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE8pushNameEPKc, __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer21TransferSTLStyleArrayINSt3__26vectorIN30RuntimeInitializeOnLoadManager9ClassInfoE13stl_allocatorIS4_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertEjPKwj, __Z44AnimationMixerPlayable_CUSTOM_InternalCreateR9HPlayable: __Z44AnimationMixerPlayable_CUSTOM_InternalCreateR9HPlayable, __Z40Application_Get_Custom_PropStreamedBytesv: __Z40Application_Get_Custom_PropStreamedBytesv, _fileno: _fileno, __Z43Gyroscope_CUSTOM_getUpdateInterval_Internali: __Z43Gyroscope_CUSTOM_getUpdateInterval_Internali, __ZN15GUIEventManager22GetLastEventForDisplayEi: __ZN15GUIEventManager22GetLastEventForDisplayEi, __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE13StaticDestroyES8_: __ZN13RuntimeStaticINSt3__23mapINS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEPvNS0_4lessIS7_EENS5_INS0_4pairIKS7_S8_EEEEEEE13StaticDestroyES8_, __ZN15LocationService23IsHeadingUpdatesEnabledEv: __ZN15LocationService23IsHeadingUpdatesEnabledEv, __ZN8JSONRead14BeginMetaGroupEPKc: __ZN8JSONRead14BeginMetaGroupEPKc, __ZN5physx7NpShape15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx7NpShape15importExtraDataERNS_24PxDeserializationContextE, __Z16BytesToHexStringPKvjPc: __Z16BytesToHexStringPKvjPc, __ZNK9Heightmap10GetHeightsEiiiiPf: __ZNK9Heightmap10GetHeightsEiiiiPf, __ZNK5physx7NpCloth18getSolverFrequencyEv: __ZNK5physx7NpCloth18getSolverFrequencyEv, __ZL16CleanupModule_AIv: __ZL16CleanupModule_AIv, __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI24CompressedAnimationCurve13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN9ShaderLab9IntShader27DeleteUnsupportedSubShadersEv: __ZN9ShaderLab9IntShader27DeleteUnsupportedSubShadersEv, _inflate_fast: _inflate_fast, __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getConstraintsEPPNS_12PxConstraintEjj: __ZNK5physx20NpRigidActorTemplateINS_14PxRigidDynamicEE14getConstraintsEPPNS_12PxConstraintEjj, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI8Vector2fEEEvRT_17TransferMetaFlags, __ZN12ImageFilters7PrepareEbbi: __ZN12ImageFilters7PrepareEbbi, __Z51Register_UnityEngine_Physics2D_set_maxRotationSpeedv: __Z51Register_UnityEngine_Physics2D_set_maxRotationSpeedv, __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10onActivateEj: __ZThn8_N5physx2Sc35ParticleElementRbElementInteraction10onActivateEj, __ZNKSt3__215__codecvt_utf16IwLb0EE16do_always_noconvEv: __ZNKSt3__215__codecvt_utf16IwLb0EE16do_always_noconvEv, __Z45setPxSimulationStatisticsPeakConstraintMemoryPN5physx22PxSimulationStatisticsEj: __Z45setPxSimulationStatisticsPeakConstraintMemoryPN5physx22PxSimulationStatisticsEj, __ZNSt3__218__insertion_sort_3IRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_: __ZNSt3__218__insertion_sort_3IRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_, _ft_black_set_mode: _ft_black_set_mode, __ZN11ClothModule19CleanupClothManagerEv: __ZN11ClothModule19CleanupClothManagerEv, __ZNK11b2RopeJoint10GetAnchorAEv: __ZNK11b2RopeJoint10GetAnchorAEv, __ZNK15ArchiveReadFile8PositionEv: __ZNK15ArchiveReadFile8PositionEv, __ZN5physx3Ext14SphericalJoint15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx3Ext14SphericalJoint15exportExtraDataERNS_22PxSerializationContextE, __Z12PlayerRenderb: __Z12PlayerRenderb, __Z39Caching_CUSTOM_INTERNAL_CALL_MarkAsUsedP12Il2CppStringRK7Hash128: __Z39Caching_CUSTOM_INTERNAL_CALL_MarkAsUsedP12Il2CppStringRK7Hash128, __Z48Register_UnityEngine_Effector2D_set_colliderMaskv: __Z48Register_UnityEngine_Effector2D_set_colliderMaskv, __Z24InitializeEngineGraphicsb: __Z24InitializeEngineGraphicsb, __Z24LightAttenuateNormalizedf: __Z24LightAttenuateNormalizedf, __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE16StaticInitializeEPv: __ZN13RuntimeStaticI13dynamic_arrayIP13GfxTimerQueryLj4EEE16StaticInitializeEPv, __ZN15dtProximityGridD2Ev: __ZN15dtProximityGridD2Ev, __ZN14RenderSettings27UpdateIndirectSpecularColorEv: __ZN14RenderSettings27UpdateIndirectSpecularColorEv, __Z28Cloth_Set_Custom_PropEnabledP12Il2CppObjecth: __Z28Cloth_Set_Custom_PropEnabledP12Il2CppObjecth, __ZNK5physx19NpArticulationJoint20getSwingLimitEnabledEv: __ZNK5physx19NpArticulationJoint20getSwingLimitEnabledEv, _tt_cmap14_validate: _tt_cmap14_validate, __ZN11UnityEngine7Connect14RemoteSettings10UnregisterEPNS0_13ConfigHandlerE: __ZN11UnityEngine7Connect14RemoteSettings10UnregisterEPNS0_13ConfigHandlerE, _UNITY_ft_mem_alloc: _UNITY_ft_mem_alloc, __ZNK11AudioSource14GetMaxDistanceEv: __ZNK11AudioSource14GetMaxDistanceEv, __ZN4FMOD6System13getDriverInfoEiPciP9FMOD_GUID: __ZN4FMOD6System13getDriverInfoEiPciP9FMOD_GUID, __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9AudioClip23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _output_message: _output_message, __ZN15AudioMixerGroup7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN15AudioMixerGroup7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ActorENS0_19ReflectionAllocatorIS4_EEE8recreateEj, __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb: __ZNK5physx2Gu15HeightFieldUtil23findClosestPointsOnCellEjjNS_6PxVec3EPS2_Pjbbb, __ZN16LightmapSettings17GetGIWorkflowModeEv: __ZN16LightmapSettings17GetGIWorkflowModeEv, _UNITY_png_set_cHRM_XYZ: _UNITY_png_set_cHRM_XYZ, __Z39InitializeAnimationStateNetworkProviderv: __Z39InitializeAnimationStateNetworkProviderv, __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IRNS_6__lessIiiEEPiEEjT0_S5_S5_S5_T_, __Z29Cloth_Get_Custom_PropVerticesP12Il2CppObject: __Z29Cloth_Get_Custom_PropVerticesP12Il2CppObject, __Z40TargetJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall: __Z40TargetJoint2D_CUSTOM_INTERNAL_get_anchorP12Il2CppObjectP13Vector2fIcall, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale0Ef: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE19setInvInertiaScale0Ef, __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getRestitutionEv: __ZNK5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14getRestitutionEv, __ZN9JSONWrite21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags: __ZN9JSONWrite21TransferSTLStyleArrayI31ArrayOfManagedObjectsTransfererEEvRT_17TransferMetaFlags, __ZN18GfxFramebufferGLES7PrepareEv: __ZN18GfxFramebufferGLES7PrepareEv, __Z29FindRelativeTransformWithPathR9TransformPKcb: __Z29FindRelativeTransformWithPathR9TransformPKcb, __ZNK13TranslateGLES14GetShaderTitleEN2gl11ShaderStageE: __ZNK13TranslateGLES14GetShaderTitleEN2gl11ShaderStageE, __ZN26AnimatorControllerPlayableD0Ev: __ZN26AnimatorControllerPlayableD0Ev, __ZN5physx2Sn17readAllPropertiesINS_15PxParticleFluidEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_15PxParticleFluidEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN15ReflectionProbe15SetBakedTextureE4PPtrI7TextureE: __ZN15ReflectionProbe15SetBakedTextureE4PPtrI7TextureE, __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf: __ZN10Matrix4x4f5SetTRERK8Vector3fRK11Quaternionf, __ZN4FMOD7Channel14getLowPassGainEPf: __ZN4FMOD7Channel14getLowPassGainEPf, __ZN13SplatDatabase21SetAlphamapResolutionEi: __ZN13SplatDatabase21SetAlphamapResolutionEi, _UNITY_LZ4_sizeofState: _UNITY_LZ4_sizeofState, __ZN13SplatDatabase12GetAlphamapsEjjjjPf: __ZN13SplatDatabase12GetAlphamapsEjjjjPf, __Z28ParticleEmitter_CUSTOM_Emit3P12Il2CppObjectR33MonoInternalEmitParticleArguments: __Z28ParticleEmitter_CUSTOM_Emit3P12Il2CppObjectR33MonoInternalEmitParticleArguments, __Z53ParticleSystem_SubEmittersModule_CUSTOM_AddSubEmitterP12Il2CppObjectS0_ii: __Z53ParticleSystem_SubEmittersModule_CUSTOM_AddSubEmitterP12Il2CppObjectS0_ii, __ZNK5physx13PxClothFabric8isKindOfEPKc: __ZNK5physx13PxClothFabric8isKindOfEPKc, __ZN5Light5ResetEv: __ZN5Light5ResetEv, __ZL24stbir__support_trapezoidf: __ZL24stbir__support_trapezoidf, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj615ES2_KjNS_17PxVehicleTireDataEEEKNS_30PxVehicleTireDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_: __ZNSt3__29__num_getIcE17__stage2_int_loopEciPcRS2_RjcRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSD_S2_, __ZN5physx7NpCloth18addCollisionConvexEj: __ZN5physx7NpCloth18addCollisionConvexEj, __ZNSt3__218shared_timed_mutex8try_lockEv: __ZNSt3__218shared_timed_mutex8try_lockEv, __ZN19SkinnedMeshRenderer26EndCurrentSkinningInstanceEv: __ZN19SkinnedMeshRenderer26EndCurrentSkinningInstanceEv, __GLOBAL__sub_I_TimerQueryGLES_cpp: __GLOBAL__sub_I_TimerQueryGLES_cpp, __ZN13GfxDeviceGLES12SetSRGBWriteEb: __ZN13GfxDeviceGLES12SetSRGBWriteEb, ___polevll: ___polevll, __ZN13RuntimeStaticI22VirtualJoystickManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI22VirtualJoystickManagerE16StaticInitializeEPv, __Z40AudioSource_CUSTOM_GetSpectrumDataHelperP12Il2CppObjectP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW: __Z40AudioSource_CUSTOM_GetSpectrumDataHelperP12Il2CppObjectP11Il2CppArrayi19FMOD_DSP_FFT_WINDOW, __ZN5physx6shdfnd4Time22getCurrentCounterValueEv: __ZN5physx6shdfnd4Time22getCurrentCounterValueEv, __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMinKillSpeedv: __Z67Register_UnityEngine_ParticleSystem_CollisionModule_GetMinKillSpeedv, __ZN9JSONWrite8TransferI17AnimationCurveTplIfEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI17AnimationCurveTplIfEEEvRT_PKc17TransferMetaFlags, __Z43ConfigurableJoint_Set_Custom_PropSwapBodiesP12Il2CppObjecth: __Z43ConfigurableJoint_Set_Custom_PropSwapBodiesP12Il2CppObjecth, __ZN5physx2Sn13XmlWriterImpl5writeEPKcRKNS_12PxRepXObjectE: __ZN5physx2Sn13XmlWriterImpl5writeEPKcRKNS_12PxRepXObjectE, __Z45NavMeshAgent_Get_Custom_PropAvoidancePriorityP12Il2CppObject: __Z45NavMeshAgent_Get_Custom_PropAvoidancePriorityP12Il2CppObject, __ZN5physx25PxVehicleConstraintShader13onOriginShiftERKNS_6PxVec3E: __ZN5physx25PxVehicleConstraintShader13onOriginShiftERKNS_6PxVec3E, __ZN7mecanim9animation25DestroyControllerConstantEPNS0_18ControllerConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation25DestroyControllerConstantEPNS0_18ControllerConstantERNS_6memory9AllocatorE, __Z48Register_UnityEngine_AndroidJNI_CallDoubleMethodv: __Z48Register_UnityEngine_AndroidJNI_CallDoubleMethodv, __Z63Register_UnityEngine_ParticleSystemRenderer_get_maxParticleSizev: __Z63Register_UnityEngine_ParticleSystemRenderer_get_maxParticleSizev, __ZZ24InitializeEngineGraphicsbEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv: __ZZ24InitializeEngineGraphicsbEN35exitPlayModeAfterOnEnableInEditMode7ForwardEv, __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv: __ZN24dense_hashtable_iteratorINSt3__24pairIK7CurveIDjEES2_10hash_curveN14dense_hash_mapIS2_jS5_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEE9SelectKeyES8_SB_E30advance_past_empty_and_deletedEv, __Z45Register_UnityEngine_Mesh_INTERNAL_set_boundsv: __Z45Register_UnityEngine_Mesh_INTERNAL_set_boundsv, _Compute_Point_Displacement: _Compute_Point_Displacement, __ZN5physx2Gu25checkOverlapOBB_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu25checkOverlapOBB_planeGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __Z51UnityAdsSettings_Get_Custom_PropInitializeOnStartupv: __Z51UnityAdsSettings_Get_Custom_PropInitializeOnStartupv, __ZN16ScriptingManager15GetAssemblyNameENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_: __ZN16ScriptingManager15GetAssemblyNameENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES6_, __ZN15ApplicationInfo10GetVersionEv: __ZN15ApplicationInfo10GetVersionEv, __ZN17PersistentManager17GetSerializedTypeEi: __ZN17PersistentManager17GetSerializedTypeEi, _gzungetc: _gzungetc, __ZN14PlayerSettings13SetColorSpaceE10ColorSpace: __ZN14PlayerSettings13SetColorSpaceE10ColorSpace, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab26SerializedShaderDependencyENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN6Camera6SetFovEf: __ZN6Camera6SetFovEf, __ZN11UnityEngine9Animation35CleanupGenericAnimationBindingCacheEPv: __ZN11UnityEngine9Animation35CleanupGenericAnimationBindingCacheEPv, __ZN8Renderer7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN8Renderer7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK13GfxDeviceGLES27GetActiveRenderDepthSurfaceEv: __ZNK13GfxDeviceGLES27GetActiveRenderDepthSurfaceEv, __Z15GetPositionMeshIL20MeshDistributionMode1ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo: __Z15GetPositionMeshIL20MeshDistributionMode1ELb0EEvRN4math8floatNx3ES3_RNS1_4pix4ERK14StrideIteratorI8Vector3fESA_RKS6_I11ColorRGBA32EPK16MeshTriangleDataiRKfSJ_SJ_R5RandNP12SkinMeshInfo, __Z12IsUserActiveRKj: __Z12IsUserActiveRKj, __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE: __ZN5physx2Gu11HeightFieldC2EPNS_13GuMeshFactoryE, __ZN5physx2Gu11sweepBoxBoxERKNS0_3BoxES3_RKNS_6PxVec3EfRS4_S7_RfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu11sweepBoxBoxERKNS0_3BoxES3_RKNS_6PxVec3EfRS4_S7_RfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZL28CleanupModule_UnityAnalyticsv: __ZL28CleanupModule_UnityAnalyticsv, __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb: __ZNK15TextureSettings5ApplyE9TextureID16TextureDimensionb17TextureColorSpace18ShadowSamplingModeb, __ZN21SweepCallbackNonAlloc14processTouchesEPKN5physx10PxSweepHitEj: __ZN21SweepCallbackNonAlloc14processTouchesEPKN5physx10PxSweepHitEj, __Z39OffMeshLink_Set_Custom_PropNavMeshLayerP12Il2CppObjecti: __Z39OffMeshLink_Set_Custom_PropNavMeshLayerP12Il2CppObjecti, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBAHalf16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZN5physx14PxsAABBManager11preAllocateEjjj: __ZN5physx14PxsAABBManager11preAllocateEjjj, __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13setBreakForceEff: __ZN5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE13setBreakForceEff, __Z55Register_UnityEngine_Shader_GetGlobalFloatArrayImplListv: __Z55Register_UnityEngine_Shader_GetGlobalFloatArrayImplListv, __ZN5physx19getXTorqueCurvePairEPKNS_19PxVehicleEngineDataEj: __ZN5physx19getXTorqueCurvePairEPKNS_19PxVehicleEngineDataEj, __ZN16RenderTextureMap6UpdateEPK17RenderSurfaceBaseP13RenderTexture: __ZN16RenderTextureMap6UpdateEPK17RenderSurfaceBaseP13RenderTexture, __ZN14AnimationState18AddMixingTransformER9Transformb: __ZN14AnimationState18AddMixingTransformER9Transformb, __Z18Transfer_BlittableI9JSONWriteLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1E10Matrix4x4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL30GeomMTDCallback_BoxHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_: __ZL30GeomMTDCallback_BoxHeightFieldRN5physx6PxVec3ERfRKNS_10PxGeometryERKNS_11PxTransformES5_S8_, __ZNK5physx7NpCloth14getWorldBoundsEf: __ZNK5physx7NpCloth14getWorldBoundsEf, __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6removeERNS0_2Sc5SceneERS2_b: __ZN10ScSceneFnsIN5physx3Scb11RigidStaticEE6removeERNS0_2Sc5SceneERS2_b, __ZN14SpriteRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14SpriteRenderer8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __Z32AndroidJNI_CUSTOM_GetStringField13Il2Cpp_IntPtrS_: __Z32AndroidJNI_CUSTOM_GetStringField13Il2Cpp_IntPtrS_, __Z15return_overrideRK21AnimationClipOverride: __Z15return_overrideRK21AnimationClipOverride, __Z38Avatar_CUSTOM_INTERNAL_CALL_GetZYPostQP12Il2CppObjectiRK11QuaternionfS3_RS1_: __Z38Avatar_CUSTOM_INTERNAL_CALL_GetZYPostQP12Il2CppObjectiRK11QuaternionfS3_RS1_, __ZN14ParticleSystem12KeepUpdatingEv: __ZN14ParticleSystem12KeepUpdatingEv, __ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode: __ZN12BaseRenderer25FlattenSharedMaterialDataILb0EEEbRS_R22PerThreadPageAllocatorR10RenderNode, _BF_encrypt: _BF_encrypt, __Z32Caching_Get_Custom_PropSpaceUsedv: __Z32Caching_Get_Custom_PropSpaceUsedv, __ZN13WebCamTexture16CaptureNextFrameEP28PlatformDependentCaptureData: __ZN13WebCamTexture16CaptureNextFrameEP28PlatformDependentCaptureData, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE16TransferTypelessEPjPKc17TransferMetaFlags, __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi: __ZN14ParticleSystem7Update1ERS_R23ParticleSystemParticlesfNS_11UpdateFlagsEi, __Z33GUIClip_CUSTOM_INTERNAL_CALL_PushRK5RectTIfERK13Vector2fIcallS5_h: __Z33GUIClip_CUSTOM_INTERNAL_CALL_PushRK5RectTIfERK13Vector2fIcallS5_h, __Z50Register_UnityEngine_PhysicMaterial_get_bouncinessv: __Z50Register_UnityEngine_PhysicMaterial_get_bouncinessv, ___expo2f: ___expo2f, _scalbnl: _scalbnl, __ZNK5physx7NpActor14getNpAggregateERj: __ZNK5physx7NpActor14getNpAggregateERj, __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionZP12Il2CppObjecti: __Z52LightProbeProxyVolume_Set_Custom_PropGridResolutionZP12Il2CppObjecti, __ZN5physx3Scb5Cloth17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb5Cloth17getBinaryMetaDataERNS_14PxOutputStreamE, __Z49setPxVehicleWheelsDynData_TireForceShaderFunctionPN5physx22PxVehicleWheelsDynDataEPFvPKvffffffffffffRfS4_S4_S4_E: __Z49setPxVehicleWheelsDynData_TireForceShaderFunctionPN5physx22PxVehicleWheelsDynDataEPFvPKvffffffffffffRfS4_S4_S4_E, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13getRestOffsetEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE13getRestOffsetEv, __ZNSt3__26chrono12system_clock11from_time_tEl: __ZNSt3__26chrono12system_clock11from_time_tEl, __ZN14DetailDatabase8TransferI17RemapPPtrTransferEEvRT_: __ZN14DetailDatabase8TransferI17RemapPPtrTransferEEvRT_, __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv: __ZNK13Simd4fFactoryIN6detail13OffsetPointerIfEEEcv8Scalar4fEv, __ZNK16UploadHandlerRaw12GetBytesSentEv: __ZNK16UploadHandlerRaw12GetBytesSentEv, __ZN6HelperI17RemapPPtrTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb: __ZN6HelperI17RemapPPtrTransfer18TransferField_InfoE24SerializationFunctionForERKS1_R23StaticTransferFieldInfoPb, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim12statemachine16LeafInfoConstantEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim12statemachine16LeafInfoConstantEEEEvRT_17TransferMetaFlags, __ZN10MonoScript18CleanupScriptCacheEv: __ZN10MonoScript18CleanupScriptCacheEv, __ZN5physx19NpArticulationJoint22setTangentialStiffnessEf: __ZN5physx19NpArticulationJoint22setTangentialStiffnessEf, __ZN6prcoreL12RemapGenericI17TexFormatARGB444411TexFormatI8EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB444411TexFormatI8EEvPKNS_9InnerInfoE, __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_: __ZNK15dense_hashtableINSt3__24pairIK9TextureIDiEES2_N12TextureIdMap20TextureIDHashFunctorEN14dense_hash_mapIS2_iS6_NS0_8equal_toIS2_EE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E13find_positionERS3_, __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_11collideStepEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN6Sprite8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN6Sprite8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK12HandlerChain9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag: __ZNK12HandlerChain9EnumerateEPKcP13dynamic_arrayI13FileEntryInfoLj8EEbPPv19FileEnumerationFlag, __ZN14EdgeCollider2D10SmartResetEv: __ZN14EdgeCollider2D10SmartResetEv, __ZN11KeyframeTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN11KeyframeTplIfE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE15__do_get_signedIxEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17SizeBySpeedModule8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13AnimationClip8TransferI14SafeBinaryReadEEvRT_: __ZN13AnimationClip8TransferI14SafeBinaryReadEEvRT_, __ZNK11AudioSource12GetStereoPanEv: __ZNK11AudioSource12GetStereoPanEv, __ZNK15FileSystemEntry12FolderExistsEv: __ZNK15FileSystemEntry12FolderExistsEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8Vector3fNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE: __ZN5physx3Scb5Scene17addParticleSystemERNS0_14ParticleSystemE, __ZN22ForwardLinearAllocator8allocateEjj: __ZN22ForwardLinearAllocator8allocateEjj, __Z20dtAllocPathQueryInfov: __Z20dtAllocPathQueryInfov, __ZNK5physx20PxVehicleAutoBoxData7isValidEv: __ZNK5physx20PxVehicleAutoBoxData7isValidEv, __ZN14PhysicsManager6UpdateEv: __ZN14PhysicsManager6UpdateEv, _ctermid: _ctermid, __ZN7CubemapC2E10MemLabelId18ObjectCreationMode: __ZN7CubemapC2E10MemLabelId18ObjectCreationMode, __Z11PremultiplyR14ImageReference: __Z11PremultiplyR14ImageReference, __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI8Vector2fNS_9allocatorIS1_EEE6assignI14StrideIteratorIS1_EEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI14SafeBinaryReadEEvRS6_RT_: __ZN15SerializeTraitsINSt3__24pairI8UnityStr4PPtrI6ObjectEEEE8TransferI14SafeBinaryReadEEvRS6_RT_, __ZN14OcclusionScene8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14OcclusionScene8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx2Sc9ClothCore18getSolverFrequencyEv: __ZNK5physx2Sc9ClothCore18getSolverFrequencyEv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_8debugger14NamespacedNameEPN12_GLOBAL__N_113ClassDescImplEEES5_NS7_20NamespacedNameHasherENS1_11HashMapBaseIS5_S9_SB_NS4_19ForwardingAllocatorEE6GetKeyESD_Lb1EED0Ev, __ZN19RuntimeSceneManager20RemoveAndDeleteSceneEP10UnityScene: __ZN19RuntimeSceneManager20RemoveAndDeleteSceneEP10UnityScene, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestitutionEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestitutionEf, __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15ParticleEmitter23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z38GUIStyle_CUSTOM_Internal_GetLineHeight13Il2Cpp_IntPtr: __Z38GUIStyle_CUSTOM_Internal_GetLineHeight13Il2Cpp_IntPtr, __ZN13SpeedTreeWind30SetInitialDirectionAndStrengthERK8Vector4f: __ZN13SpeedTreeWind30SetInitialDirectionAndStrengthERK8Vector4f, __ZN7ApiGLES6EnableEN2gl10EnabledCapE: __ZN7ApiGLES6EnableEN2gl10EnabledCapE, __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode: __ZN6Object7ProduceEPKN5Unity4TypeEi10MemLabelId18ObjectCreationMode, __ZN13TextRendering17GetITextRenderingEv: __ZN13TextRendering17GetITextRenderingEv, __ZN12ScriptMapperC2E10MemLabelId18ObjectCreationMode: __ZN12ScriptMapperC2E10MemLabelId18ObjectCreationMode, __Z43PhysicMaterial_Get_Custom_PropBounceCombineP12Il2CppObject: __Z43PhysicMaterial_Get_Custom_PropBounceCombineP12Il2CppObject, __Z48Input_Get_Custom_PropEatKeyPressOnTextFieldFocusv: __Z48Input_Get_Custom_PropEatKeyPressOnTextFieldFocusv, __Z61Register_UnityEngine_CharacterController_set_detectCollisionsv: __Z61Register_UnityEngine_CharacterController_set_detectCollisionsv, __Z44Canvas_Set_Custom_PropReferencePixelsPerUnitP12Il2CppObjectf: __Z44Canvas_Set_Custom_PropReferencePixelsPerUnitP12Il2CppObjectf, __Z39Animator_Set_Custom_PropFeetPivotActiveP12Il2CppObjectf: __Z39Animator_Set_Custom_PropFeetPivotActiveP12Il2CppObjectf, ___fxstatat: ___fxstatat, __ZN7dtCrowd12setAgentPathERK13dtCrowdHandlePKfS4_PKyib: __ZN7dtCrowd12setAgentPathERK13dtCrowdHandlePKfS4_PKyib, __ZZL16ClipDetailMeshesR13dynamic_arrayIP17ClippedDetailMeshLj4EERK11DynamicMeshRK10DetailMeshPK10dtMeshTileRK8Vector3ffEN12ClipCallback7processES9_RK14DetailMeshPolyPKii: __ZZL16ClipDetailMeshesR13dynamic_arrayIP17ClippedDetailMeshLj4EERK11DynamicMeshRK10DetailMeshPK10dtMeshTileRK8Vector3ffEN12ClipCallback7processES9_RK14DetailMeshPolyPKii, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getRelativeTransformEv: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE20getRelativeTransformEv, _decode_mcu_AC_first: _decode_mcu_AC_first, __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseERKNS_6bitsetILj66EEE: __ZN7mecanim5human14HumanPoseClearERNS0_9HumanPoseERKNS_6bitsetILj66EEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE14handleAccessorILj414ENS0_26PxPvdRangePropertyAccessorILj414ENS_7PxJointEfEEEEvjRKT0_, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayItLj2EEEEvRT_17TransferMetaFlags, __Z15SetIsFirstFrameb: __Z15SetIsFirstFrameb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj554ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_30PxVehicleAckermannGeometryDataEEEEclILj554ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Cm12RefCountable17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Cm12RefCountable17getBinaryMetaDataERNS_14PxOutputStreamE, __Z23scripting_thread_attachP12Il2CppDomain: __Z23scripting_thread_attachP12Il2CppDomain, __ZN5Umbra9IndexList11setCapacityEi: __ZN5Umbra9IndexList11setCapacityEi, __ZN13RenderTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13RenderTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9Transform8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9Transform8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z57Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayv: __Z57Register_UnityEngine_MaterialPropertyBlock_GetMatrixArrayv, __ZNK5Umbra12PortalCuller15visualizePortalERKNS_6PortalEbb: __ZNK5Umbra12PortalCuller15visualizePortalERKNS_6PortalEbb, __Z21CalculateNumberOfJobsRK15UpdateCrowdInfo: __Z21CalculateNumberOfJobsRK15UpdateCrowdInfo, __ZN21ProceduralTextureData20GetProceduralTextureEv: __ZN21ProceduralTextureData20GetProceduralTextureEv, __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS4_RS6_EEPS4_: __ZNSt3__26vectorINS_4pairIiN19AssetBundleManifest15AssetBundleInfoEEENS_9allocatorIS4_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS4_RS6_EEPS4_, __ZN17UniqueIDGenerator8CreateIDEv: __ZN17UniqueIDGenerator8CreateIDEv, __ZN12CachedReader3EndEv: __ZN12CachedReader3EndEv, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getLinearVelocityEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE17getLinearVelocityEv, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZN16b2ContactManager20FlushPendingContactsEv: __ZN16b2ContactManager20FlushPendingContactsEv, __ZNK15NavMeshObstacle14GetWorldCenterEv: __ZNK15NavMeshObstacle14GetWorldCenterEv, __ZN9rapidjson8internal8DigitGenERKNS0_5DiyFpES3_yPcPiS5_: __ZN9rapidjson8internal8DigitGenERKNS0_5DiyFpES3_yPcPiS5_, __ZNK12InputManager19GetJoystickPositionEii: __ZNK12InputManager19GetJoystickPositionEii, __Z38TargetJoint2D_Get_Custom_PropFrequencyP12Il2CppObject: __Z38TargetJoint2D_Get_Custom_PropFrequencyP12Il2CppObject, __Z42GUIStyleState_CUSTOM_SetBackgroundInternalP12Il2CppObjectS0_: __Z42GUIStyleState_CUSTOM_SetBackgroundInternalP12Il2CppObjectS0_, __ZNK11Rigidbody2D11GetVelocityEv: __ZNK11Rigidbody2D11GetVelocityEv, __Z45Bounds_CUSTOM_INTERNAL_CALL_Internal_ContainsRK4AABBRK8Vector3f: __Z45Bounds_CUSTOM_INTERNAL_CALL_Internal_ContainsRK4AABBRK8Vector3f, __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim12statemachine18TransitionConstant8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN2UI6CanvasD0Ev: __ZN2UI6CanvasD0Ev, __ZNSt3__211__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t: __ZNSt3__211__stdoutbufIcEC2EP8_IO_FILEP11__mbstate_t, __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxNonAllocv: __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxNonAllocv, __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_: __ZN13dynamic_arrayIN8LODGroup11LODRendererELj4EEC2ERKS2_, __Z36LoadAssetWithSubAssetFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EE: __Z36LoadAssetWithSubAssetFromAssetBundleR11AssetBundleRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEEP12Il2CppObjectR13dynamic_arrayIP6ObjectLj4EE, __Z40SkinnedMeshRenderer_Get_Custom_PropBonesP12Il2CppObject: __Z40SkinnedMeshRenderer_Get_Custom_PropBonesP12Il2CppObject, __Z35GUIUtility_Set_Custom_PropMouseUsedh: __Z35GUIUtility_Set_Custom_PropMouseUsedh, __ZN20BaseBehaviourManagerD0Ev: __ZN20BaseBehaviourManagerD0Ev, __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenMultiplierv: __Z71Register_UnityEngine_ParticleSystem_CollisionModule_GetDampenMultiplierv, __ZNK5physx9NpPhysics18getTolerancesScaleEv: __ZNK5physx9NpPhysics18getTolerancesScaleEv, __ZN20IntermediateRendererC2Ev: __ZN20IntermediateRendererC2Ev, __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6gcountEv: __ZNKSt3__213basic_istreamIwNS_11char_traitsIwEEE6gcountEv, __ZN17MemoryCacheReader11GetPathNameEv: __ZN17MemoryCacheReader11GetPathNameEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier12ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx22PxcContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx22PxcContactSphereConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZN17BillboardRenderer21UpdateCachedBillboardEv: __ZN17BillboardRenderer21UpdateCachedBillboardEv, __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE: __ZN5physx31PxcFsPropagateDrivenInertiaSimdERNS_9PxcFsDataEPKNS_12PxcFsInertiaEPKfPKNS_6shdfnd3aos6Mat33VENS_21PxcFsScratchAllocatorE, __ZN5physx6shdfnd5ArrayINS0_4PairINS_14PxConcreteType4EnumEjEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayINS0_4PairINS_14PxConcreteType4EnumEjEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE: __ZN5physx7NpClothC2ERKNS_11PxTransformERNS_13NpClothFabricEPKNS_15PxClothParticleENS_7PxFlagsINS_11PxClothFlag4EnumEtEE, __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv: __ZN23ParticleSystemParticles21SetUsesAxisOfRotationEv, __Z17GetNavMeshManagerv: __Z17GetNavMeshManagerv, __Z48setPxVehicleAckermannGeometryDataMAxleSeparationPN5physx30PxVehicleAckermannGeometryDataEf: __Z48setPxVehicleAckermannGeometryDataMAxleSeparationPN5physx30PxVehicleAckermannGeometryDataEf, _strchr: _strchr, __ZN16b2PulleyJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_S4_S4_f: __ZN16b2PulleyJointDef10InitializeEP6b2BodyS1_RK6b2Vec2S4_S4_S4_f, __ZNK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE: __ZNK5physx5cloth9SwFactory27extractSelfCollisionIndicesERKNS0_5ClothENS0_5RangeIjEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxVehicleAutoBoxDataEEEE15indexedPropertyILj537ES4_NS_18PxVehicleGearsData4EnumEfEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE13__get_pointerEv, __ZN13RenderTexture15DestroySurfacesEv: __ZN13RenderTexture15DestroySurfacesEv, __ZNK18AnimatorController12StringFromIDEj: __ZNK18AnimatorController12StringFromIDEj, __ZN5Unity10HingeJoint20ApplySetupAxesToDescEi: __ZN5Unity10HingeJoint20ApplySetupAxesToDescEi, __ZN5physx24solveContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx24solveContactCoulombBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_: __ZNSt3__27__sort3IR29ColliderHitsByDepthComparitorPP10Collider2DEEjT0_S6_S6_T_, __ZN16SpriteRenderData11SetVerticesEPK8Vector2fjRK6Sprite: __ZN16SpriteRenderData11SetVerticesEPK8Vector2fjRK6Sprite, __ZNSt3__26locale5__imp7installINS_8messagesIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_8messagesIwEEEEvPT_, __ZN7ApiGLES8DispatchEjjj: __ZN7ApiGLES8DispatchEjjj, __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEEC2INS_11__wrap_iterIPS7_EEEET_SE_RKS8_PNS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeE: __ZNSt3__26vectorINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES4_IS7_LS5_1ELi16EEEC2INS_11__wrap_iterIPS7_EEEET_SE_RKS8_PNS_9enable_ifIXaasr21__is_forward_iteratorISE_EE5valuesr16is_constructibleIS7_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeE, __Z35Component_Get_Custom_PropGameObjectP12Il2CppObject: __Z35Component_Get_Custom_PropGameObjectP12Il2CppObject, __Z38Shader_CUSTOM_GetGlobalVectorArrayImpli: __Z38Shader_CUSTOM_GetGlobalVectorArrayImpli, __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_get_suspensionv: __Z57Register_UnityEngine_WheelJoint2D_INTERNAL_get_suspensionv, __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED0Ev: __ZN5physx6shdfnd7ThreadTINS0_19ReflectionAllocatorINS0_10ThreadImplEEEED0Ev, __Z38CombineInstance_CUSTOM_InternalGetMeshP12Il2CppObjecti: __Z38CombineInstance_CUSTOM_InternalGetMeshP12Il2CppObjecti, __ZN6Socket19PollAsyncConnectionEil: __ZN6Socket19PollAsyncConnectionEil, __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD2Ev: __ZN12_GLOBAL__N_123FStreamNetworkOutStreamD2Ev, __ZN10OnGUIState8EndOnGUIEv: __ZN10OnGUIState8EndOnGUIEv, __ZN5physx7NpScene9visualizeEv: __ZN5physx7NpScene9visualizeEv, __ZL34GetComponentsImplementationRecurseILb0ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue: __ZL34GetComponentsImplementationRecurseILb0ELi1ELi1EEbR10GameObjectbRK17CompareParametersRK39GetComponentsImplementation_ReturnValue, __ZN5physx3Ext13DistanceJoint14setMaxDistanceEf: __ZN5physx3Ext13DistanceJoint14setMaxDistanceEf, __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv: __ZNK13Simd4fFactoryIN6detail7IntTypeILi1EEEEcv8Scalar4fEv, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleDriveNWEE16objectToFileImplEPKS1_PNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __Z54Register_UnityEngine_SystemInfo_get_copyTextureSupportv: __Z54Register_UnityEngine_SystemInfo_get_copyTextureSupportv, _UNITY_png_set_read_status_fn: _UNITY_png_set_read_status_fn, __ZN10__cxxabiv129__pointer_to_member_type_infoD0Ev: __ZN10__cxxabiv129__pointer_to_member_type_infoD0Ev, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7getNameEv, __Z63Register_UnityEngine_ParticleSystem_LightsModule_SetLightPrefabv: __Z63Register_UnityEngine_ParticleSystem_LightsModule_SetLightPrefabv, __Z63Register_UnityEngine_ParticleSystemRenderer_set_minParticleSizev: __Z63Register_UnityEngine_ParticleSystemRenderer_set_minParticleSizev, __ZN15QualitySettings16SetSoftParticlesEb: __ZN15QualitySettings16SetSoftParticlesEb, __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j: __ZNK5physx34PxVehicleDriveDynDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEEEEjT_j, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13do_date_orderEv, __Z48Register_UnityEngine_SurfaceEffector2D_get_speedv: __Z48Register_UnityEngine_SurfaceEffector2D_get_speedv, __ZN16GraphicsSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN16GraphicsSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _sfnt_get_name_index: _sfnt_get_name_index, __Z21getPxCloth_RestOffsetPKN5physx7PxClothE: __Z21getPxCloth_RestOffsetPKN5physx7PxClothE, __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI17ProceduralTextureE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20UnityConnectSettingsC2E10MemLabelId18ObjectCreationMode: __ZN20UnityConnectSettingsC2E10MemLabelId18ObjectCreationMode, __ZN5physx12NpWriteCheckC2EPNS_7NpSceneEPKcb: __ZN5physx12NpWriteCheckC2EPNS_7NpSceneEPKcb, __Z18GetTargetFrameRatev: __Z18GetTargetFrameRatev, __ZN5physx3Scb12Articulation9syncStateEv: __ZN5physx3Scb12Articulation9syncStateEv, __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim12statemachine21SelectorStateConstantEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferIN7mecanim12statemachine21SelectorStateConstantEEEvRT_PKc17TransferMetaFlags, __ZN14UnityAnalytics21OnSceneTimingCallbackERK15SceneLoadTimingRK8UnityStr: __ZN14UnityAnalytics21OnSceneTimingCallbackERK15SceneLoadTimingRK8UnityStr, __ZN14CompletionTask22ProcessAllPhysicsTasksEv: __ZN14CompletionTask22ProcessAllPhysicsTasksEv, __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb: __Z22PackTextureAtlasSimpleP9Texture2DiiPS0_P5RectTIfEibb, __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI11NavMeshDataE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z50LODGroup_Set_Custom_PropCrossFadeAnimationDurationf: __Z50LODGroup_Set_Custom_PropCrossFadeAnimationDurationf, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveRK23ParticleSystemParticlesPfRK8Vector2f, __ZN25MultiBlocksMemoryFileDataD0Ev: __ZN25MultiBlocksMemoryFileDataD0Ev, __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE16__construct_nodeERKNS_4pairIKS4_S6_EE: __ZNSt3__26__treeINS_12__value_typeI4PPtrI13RenderTextureEN19RenderBufferManager23RenderTextureParametersEEENS_19__map_value_compareIS4_S7_NS_4lessIS4_EELb1EEE11memory_poolIS7_EE16__construct_nodeERKNS_4pairIKS4_S6_EE, __ZN10PngDecoder16DecodePixelsImplEPhjb13TextureFormat: __ZN10PngDecoder16DecodePixelsImplEPhjb13TextureFormat, __Z47Register_UnityEngine_AudioSource_set_spatializev: __Z47Register_UnityEngine_AudioSource_set_spatializev, __ZN8MaterialD2Ev: __ZN8MaterialD2Ev, __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_: __ZNSt3__27__sort4IR11NodeYSorterP16HeightMeshBVNodeEEjT0_S5_S5_S5_T_, __ZNK13sorted_vectorIN22BuiltinResourceManager8ResourceENSt3__24lessIS1_EENS2_9allocatorIS1_EEE4findIS1_EENS2_11__wrap_iterIPKS1_EERKT_: __ZNK13sorted_vectorIN22BuiltinResourceManager8ResourceENSt3__24lessIS1_EENS2_9allocatorIS1_EEE4findIS1_EENS2_11__wrap_iterIPKS1_EERKT_, __Z46Register_UnityEngine_HingeJoint2D_set_useMotorv: __Z46Register_UnityEngine_HingeJoint2D_set_useMotorv, __ZN5physx2Sn21SerializationRegistry22registerRepXSerializerEtRNS_16PxRepXSerializerE: __ZN5physx2Sn21SerializationRegistry22registerRepXSerializerEtRNS_16PxRepXSerializerE, __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef: __ZN19ShaderPropertySheet24SetTextureFromTextureRefERKN9ShaderLab16FastPropertyNameEPK10TextureRef, __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20TextRenderingPrivate8TextMesh8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPNS_26PxProfileEventBufferClientENS_8debugger19ForwardingAllocatorEED0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcjRKS4_: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEC2EPKcjRKS4_, __ZN13AudioListener15InitializeClassEv: __ZN13AudioListener15InitializeClassEv, __ZN14ParticleSystem16SetStartRotationEf: __ZN14ParticleSystem16SetStartRotationEf, __ZNK11Rigidbody2D11GetPositionEv: __ZNK11Rigidbody2D11GetPositionEv, __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIN9ShaderLab20SerializedSubProgram16TextureParameterENS0_9allocatorIS4_EEEEEvRT_j, __ZNK5Umbra9BitVector7testNotERKS0_: __ZNK5Umbra9BitVector7testNotERKS0_, __ZN19SkinnedMeshRenderer24ReadSkinningDataForClothERK12SkinMeshInfob: __ZN19SkinnedMeshRenderer24ReadSkinningDataForClothERK12SkinMeshInfob, __ZN5physx3Ext14PrismaticJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext14PrismaticJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __Z42GUIUtility_Set_Custom_PropSystemCopyBufferP12Il2CppString: __Z42GUIUtility_Set_Custom_PropSystemCopyBufferP12Il2CppString, __ZNK5physx14PxRigidDynamic8isKindOfEPKc: __ZNK5physx14PxRigidDynamic8isKindOfEPKc, __Z48TerrainData_CUSTOM_Internal_GetMaximumResolutionv: __Z48TerrainData_CUSTOM_Internal_GetMaximumResolutionv, __ZNK9GfxDevice19GetTotalBufferCountEv: __ZNK9GfxDevice19GetTotalBufferCountEv, __ZN5physx3Ext20DefaultCpuDispatcher7runTaskERNS_10PxBaseTaskE: __ZN5physx3Ext20DefaultCpuDispatcher7runTaskERNS_10PxBaseTaskE, __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z49ParticleSystem_SizeOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx27solveConcludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx27solveConcludeContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, _close_file: _close_file, __ZN8DrawUtil18DrawMeshBuffersRawERK11MeshBuffersR4MeshRK14ChannelAssignsii: __ZN8DrawUtil18DrawMeshBuffersRawERK11MeshBuffersR4MeshRK14ChannelAssignsii, __Z40Rigidbody2D_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK13Vector2fIcall: __Z40Rigidbody2D_CUSTOM_INTERNAL_set_velocityP12Il2CppObjectRK13Vector2fIcall, __Z23RandomPointInsideSphereR5RandNRKfS2_: __Z23RandomPointInsideSphereR5RandNRKfS2_, __ZN5physx9PxTaskMgr12addReferenceERNS_14PxLightCpuTaskE: __ZN5physx9PxTaskMgr12addReferenceERNS_14PxLightCpuTaskE, __ZN10MemoryFile4SeekEx10FileOrigin: __ZN10MemoryFile4SeekEx10FileOrigin, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj46ENS_22PxRepXPropertyAccessorILj46ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEE14handleAccessorILj46ENS_22PxRepXPropertyAccessorILj46ES4_ffEEEEvRKT0_, __ZN17Physics2DSettings20SetShowColliderSleepEb: __ZN17Physics2DSettings20SetShowColliderSleepEb, __Z37Register_UnityEngine_Random_get_valuev: __Z37Register_UnityEngine_Random_get_valuev, __ZNSt3__211__money_getIcEC2Ev: __ZNSt3__211__money_getIcEC2Ev, __ZN7mecanim12statemachine18EvaluateTransitionEPKNS0_18TransitionConstantEPKNS0_15TransitionInputEPNS0_16TransitionOutputEPKNS0_16TransitionMemoryEPNS0_21StateMachineWorkspaceE: __ZN7mecanim12statemachine18EvaluateTransitionEPKNS0_18TransitionConstantEPKNS0_15TransitionInputEPNS0_16TransitionOutputEPKNS0_16TransitionMemoryEPNS0_21StateMachineWorkspaceE, __ZNK14ParticleSystem18GetStartDelayCurveEv: __ZNK14ParticleSystem18GetStartDelayCurveEv, __ZN7Terrain12SetNeighborsEPS_S0_S0_S0_: __ZN7Terrain12SetNeighborsEPS_S0_S0_S0_, __ZNK5physx2Gu12TriangleMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_11PxMeshScaleERKNS_9PxBounds3Eyfj: __ZNK5physx2Gu12TriangleMesh14debugVisualizeERNS_2Cm12RenderOutputERKNS2_8Matrix34ERKNS_11PxMeshScaleERKNS_9PxBounds3Eyfj, __Z6GetTagR11UTF16StringRiRb: __Z6GetTagR11UTF16StringRiRb, __GLOBAL__sub_I_runtime_graphics_commandbuffer_lump_cpp: __GLOBAL__sub_I_runtime_graphics_commandbuffer_lump_cpp, __ZN20TextRenderingPrivate7GUITextD2Ev: __ZN20TextRenderingPrivate7GUITextD2Ev, __ZN6Camera24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture: __ZN6Camera24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture, __ZNK9Transform14TransformPointERK8Vector3f: __ZNK9Transform14TransformPointERK8Vector3f, _cabs: _cabs, __Z10WritePixelPhRK10ColorRGBAf13TextureFormat: __Z10WritePixelPhRK10ColorRGBAf13TextureFormat, _request_virt_sarray: _request_virt_sarray, __ZN22UnityProfilerPerThread10ClearFrameEv: __ZN22UnityProfilerPerThread10ClearFrameEv, __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb: __ZN18GfxFramebufferGLES21InvalidateAttachmentsEPKbb, __ZN5physx2Sc5Actor20activateInteractionsEj: __ZN5physx2Sc5Actor20activateInteractionsEj, __ZN2UI6Canvas23GetRootCanvasMeshBoundsEv: __ZN2UI6Canvas23GetRootCanvasMeshBoundsEv, __ZN18MultiFrameGUIState5ResetEv: __ZN18MultiFrameGUIState5ResetEv, __ZNSt3__217moneypunct_bynameIcLb1EEC2EPKcj: __ZNSt3__217moneypunct_bynameIcLb1EEC2EPKcj, __ZN5Unity14CharacterJoint19SetTwistLimitSpringERK20SoftJointLimitSpring: __ZN5Unity14CharacterJoint19SetTwistLimitSpringERK20SoftJointLimitSpring, __ZN10UnitySceneC2EiRK8UnityStrS2_RK9UnityGUIDi: __ZN10UnitySceneC2EiRK8UnityStrS2_RK9UnityGUIDi, __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipUv: __Z72Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetFlipUv, __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE: __Z35CopyMatrixArrayShaderPropertyToListP12Il2CppObjectPK19ShaderPropertySheetN9ShaderLab16FastPropertyNameE, __ZNKSt3__210moneypunctIwLb0EE13thousands_sepEv: __ZNKSt3__210moneypunctIwLb0EE13thousands_sepEv, __ZN4FMOD5Sound4lockEjjPPvS2_PjS3_: __ZN4FMOD5Sound4lockEjjPPvS2_PjS3_, __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19GetDownloadProgressEv: __ZNK20UnityWebRequestProtoI19TransportJavaScript16AtomicRefCounter14RedirectHelper14ResponseHelper15DownloadHandler13UploadHandler12HeaderHelper14AsyncOperationE19GetDownloadProgressEv, __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214codecvt_bynameIDsc11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZNSt3__220__vector_base_commonILb1EEC2Ev: __ZNSt3__220__vector_base_commonILb1EEC2Ev, __ZN11UnityEngine7Connect14RemoteSettings8GetValueERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE: __ZN11UnityEngine7Connect14RemoteSettings8GetValueERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj467ENS_22PxRepXPropertyAccessorILj467ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE14handleAccessorILj467ENS_22PxRepXPropertyAccessorILj467ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_, __ZN17MemoryCacheReader18GetAddressOfMemoryEv: __ZN17MemoryCacheReader18GetAddressOfMemoryEv, __Z48getPxVehicleDifferentialNWData_DrivenWheelStatusPKN5physx27PxVehicleDifferentialNWDataE: __Z48getPxVehicleDifferentialNWData_DrivenWheelStatusPKN5physx27PxVehicleDifferentialNWDataE, __ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform: __ZN15AnimationBinder9BindCurveERK7CurveIDR20BoundCurveDeprecatedR9Transform, __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIwEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15numpunct_bynameIwEEEEvPT_, __ZNK15FileSystemEntry5IsDirEv: __ZNK15FileSystemEntry5IsDirEv, __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPhNS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale0Ev: __ZNK5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE16getInvMassScale0Ev, _putc_unlocked: _putc_unlocked, __ZNK8VRDevice19GetEyeTextureHeightEv: __ZNK8VRDevice19GetEyeTextureHeightEv, __ZL28RegisterModuleICalls_Terrainv: __ZL28RegisterModuleICalls_Terrainv, __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONRead8Vector2fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN6Camera19UpdateDepthTexturesERK11CullResultsRK19SharedRendererSceneNS_10RenderFlagE: __ZN6Camera19UpdateDepthTexturesERK11CullResultsRK19SharedRendererSceneNS_10RenderFlagE, __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE: __ZN8Collider11SetMaterialE4PPtrI14PhysicMaterialE, __ZN5physx2Sc19ShapeInstancePairLL25postNarrowPhaseSecondPassERNS_16PxsIslandManagerEb: __ZN5physx2Sc19ShapeInstancePairLL25postNarrowPhaseSecondPassERNS_16PxsIslandManagerEb, __ZN9Animation8TransferI14SafeBinaryReadEEvRT_: __ZN9Animation8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx14NpRigidDynamic13getGlobalPoseEv: __ZNK5physx14NpRigidDynamic13getGlobalPoseEv, __ZN5Umbra9AllocatorD2Ev: __ZN5Umbra9AllocatorD2Ev, __ZN4FMOD7SystemI11getUserDataEPPv: __ZN4FMOD7SystemI11getUserDataEPPv, __Z50Register_UnityEngine_TerrainData_ResetDirtyDetailsv: __Z50Register_UnityEngine_TerrainData_ResetDirtyDetailsv, __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14SphereCollider23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z49EmitSerializationCommandsForLinearCollectionFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z49EmitSerializationCommandsForLinearCollectionFieldI8JSONReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_22PxClothFabricPhaseType4EnumENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, _log2l: _log2l, __ZN15SerializeTraitsI22OffsetPtrArrayTransferIKN4math7_float3EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_: __ZN15SerializeTraitsI22OffsetPtrArrayTransferIKN4math7_float3EEE8TransferI19StreamedBinaryWriteILb0EEEEvRS4_RT_, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI17DeviceRasterState11memcmp_lessIS1_S1_ENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __ZN5physx32PxCapsuleGeometryGeneratedValuesC2EPKNS_17PxCapsuleGeometryE: __ZN5physx32PxCapsuleGeometryGeneratedValuesC2EPKNS_17PxCapsuleGeometryE, __Z50Register_UnityEngine_Camera_INTERNAL_set_pixelRectv: __Z50Register_UnityEngine_Camera_INTERNAL_set_pixelRectv, __Z51Register_UnityEngine_AI_NavMeshObstacle_get_carvingv: __Z51Register_UnityEngine_AI_NavMeshObstacle_get_carvingv, __ZN5physx18PxcArticulationRef9ltbFactorERNS_9PxcFsDataE: __ZN5physx18PxcArticulationRef9ltbFactorERNS_9PxcFsDataE, __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE21__push_back_slow_pathIKS9_EEvRT_: __ZNSt3__26vectorI10vector_mapIiiNS_4lessIiEE13stl_allocatorINS_4pairIiiEEL18MemLabelIdentifier37ELi16EEES4_IS9_LS7_37ELi16EEE21__push_back_slow_pathIKS9_EEvRT_, __ZN13GfxDeviceGLES13SetBlendStateEPK16DeviceBlendState: __ZN13GfxDeviceGLES13SetBlendStateEPK16DeviceBlendState, __ZN4FMOD3DSP16getParameterInfoEiPcS1_S1_iPfS2_: __ZN4FMOD3DSP16getParameterInfoEiPcS1_S1_iPfS2_, __ZN15DistanceJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN15DistanceJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN18CrashReportManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx3Ext19computeCylinderMassEfff: __ZN5physx3Ext19computeCylinderMassEfff, __Z51Register_UnityEngine_QualitySettings_set_vSyncCountv: __Z51Register_UnityEngine_QualitySettings_set_vSyncCountv, __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI15TextureSettingsE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZNK5physx15PxRevoluteJoint19getConcreteTypeNameEv: __ZNK5physx15PxRevoluteJoint19getConcreteTypeNameEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj494ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj494ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_set_centerv: __Z56Register_UnityEngine_ReflectionProbe_INTERNAL_set_centerv, __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVES7_: __ZN5physx2Gu22barycentricCoordinatesERKNS_6shdfnd3aos5Vec3VES5_S5_RNS2_6FloatVES7_, __ZNK15ParticleEmitter10HasEnabledEv: __ZNK15ParticleEmitter10HasEnabledEv, __ZN8Animator16GetGravityWeightEv: __ZN8Animator16GetGravityWeightEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE13get_monthnameES4_S4_RNS_8ios_baseERjP2tm, __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalSetMethodv: __Z65Register_UnityEngine_Networking_UnityWebRequest_InternalSetMethodv, __Z44Rigidbody2D_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK13Vector2fIcall: __Z44Rigidbody2D_CUSTOM_INTERNAL_set_centerOfMassP12Il2CppObjectRK13Vector2fIcall, __ZN5physx2Cm24destroyFreeListAllocatorERNS0_17FreeListAllocatorE: __ZN5physx2Cm24destroyFreeListAllocatorERNS0_17FreeListAllocatorE, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_112VertTriangleENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5clearEj: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEE5clearEj, __ZNK16ReflectionProbes18GetPendingJobCountEv: __ZNK16ReflectionProbes18GetPendingJobCountEv, __ZN11AudioSource9SetSpreadEf: __ZN11AudioSource9SetSpreadEf, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, _block_locate_free: _block_locate_free, __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_: __ZL18tessellateTriangleP10TessParamsRKN5physx6PxVec3ES4_S4_, __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthZMultiplierP12Il2CppObject: __Z56ParticleSystem_NoiseModule_CUSTOM_GetStrengthZMultiplierP12Il2CppObject, __ZN6Camera19SetOrthographicSizeEf: __ZN6Camera19SetOrthographicSizeEf, __Z48SliderJoint2D_CUSTOM_INTERNAL_CALL_GetMotorForceP12Il2CppObjectf: __Z48SliderJoint2D_CUSTOM_INTERNAL_CALL_GetMotorForceP12Il2CppObjectf, __Z28scripting_class_is_valuetypeP11Il2CppClass: __Z28scripting_class_is_valuetypeP11Il2CppClass, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getConstraintEv: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE13getConstraintEv, __Z46Physics2D_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayfiff: __Z46Physics2D_CUSTOM_INTERNAL_CALL_RaycastNonAllocRK13Vector2fIcallS1_P11Il2CppArrayfiff, __ZNK14PlayerSettings26GetTypeInfoVirtualInternalEv: __ZNK14PlayerSettings26GetTypeInfoVirtualInternalEv, __ZL35RegisterModuleICalls_TerrainPhysicsv: __ZL35RegisterModuleICalls_TerrainPhysicsv, __ZN5physx2Sc5Scene23removeArticulationJointERNS0_21ArticulationJointCoreE: __ZN5physx2Sc5Scene23removeArticulationJointERNS0_21ArticulationJointCoreE, __ZN13SubstanceData6AddRefEv: __ZN13SubstanceData6AddRefEv, __ZN9TextAsset23VirtualRedirectTransferER14SafeBinaryRead: __ZN9TextAsset23VirtualRedirectTransferER14SafeBinaryRead, __ZN27ConvexVsMeshOverlapCallbackD2Ev: __ZN27ConvexVsMeshOverlapCallbackD2Ev, __ZN19MemoryProfilerStats21ChangePersistancyflagEibb: __ZN19MemoryProfilerStats21ChangePersistancyflagEibb, __ZN7b2TimerC2Ev: __ZN7b2TimerC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj545ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj545ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z41RenderSettings_Set_Custom_PropAmbientModeN14RenderSettings11AmbientModeE: __Z41RenderSettings_Set_Custom_PropAmbientModeN14RenderSettings11AmbientModeE, __ZN5physx2Sc5Scene20setMeshContactMarginEf: __ZN5physx2Sc5Scene20setMeshContactMarginEf, __Z51MaterialPropertyBlock_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_: __Z51MaterialPropertyBlock_CUSTOM_GetVectorArrayImplListP12Il2CppObjectiS0_, __ZN19CharacterController23UpdateControllerManagerEv: __ZN19CharacterController23UpdateControllerManagerEv, __Z47Register_UnityEngine_Texture2D_get_blackTexturev: __Z47Register_UnityEngine_Texture2D_get_blackTexturev, __ZN11UnityEngine15CloudWebService18RestFileDownloaderD0Ev: __ZN11UnityEngine15CloudWebService18RestFileDownloaderD0Ev, __Z36HingeJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth: __Z36HingeJoint2D_Set_Custom_PropUseMotorP12Il2CppObjecth, __ZN5physx3Ext10FixedJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_: __ZN5physx3Ext10FixedJoint6attachERNS_9PxPhysicsEPNS_12PxRigidActorES5_, __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi2ELb1ELb0EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb: __ZN5physx2Gu19gjkLocalPenetrationINS0_8CapsuleVENS0_4BoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos6FloatVERNSB_5Vec3VESG_SG_RSC_PhSI_Rhb, __ZN14DetailDatabase29UpdateDetailPrototypesIfDirtyEv: __ZN14DetailDatabase29UpdateDetailPrototypesIfDirtyEv, __ZZN15DirectorManager15InitializeClassEvEN36EarlyUpdateDirectorAdvanceTimestruct7ForwardEv: __ZZN15DirectorManager15InitializeClassEvEN36EarlyUpdateDirectorAdvanceTimestruct7ForwardEv, __ZN11AudioSource13SetSpatializeEb: __ZN11AudioSource13SetSpatializeEb, __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_velocityv: __Z54Register_UnityEngine_Rigidbody2D_INTERNAL_set_velocityv, __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ViewportPointToRayv: __Z60Register_UnityEngine_Camera_INTERNAL_CALL_ViewportPointToRayv, __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE6assignINS_11__wrap_iterIPS1_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZN9GfxDevice22ReleaseThreadOwnershipEv: __ZN9GfxDevice22ReleaseThreadOwnershipEv, __Z40UnityWebRequest_CUSTOM_InternalSetMethodP12Il2CppObject21UnityWebRequestMethod: __Z40UnityWebRequest_CUSTOM_InternalSetMethodP12Il2CppObject21UnityWebRequestMethod, __ZNK5physx6shdfnd6Socket11isConnectedEv: __ZNK5physx6shdfnd6Socket11isConnectedEv, __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE15set_deleted_keyERSE_: __ZN14dense_hash_mapIN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEP19ProfilerInformation11djb2_hash_tIS4_ENSt3__28equal_toIS4_EE13stl_allocatorINS9_4pairIKS4_S6_EEL18MemLabelIdentifier57ELi16EEE15set_deleted_keyERSE_, __Z43Transform_CUSTOM_INTERNAL_CALL_RotateAroundP12Il2CppObjectRK8Vector3ff: __Z43Transform_CUSTOM_INTERNAL_CALL_RotateAroundP12Il2CppObjectRK8Vector3ff, __Z43ParticleSystem_LightsModule_CUSTOM_SetRangeP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_LightsModule_CUSTOM_SetRangeP12Il2CppObjectR15MonoMinMaxCurve, _opendir: _opendir, __ZN5Umbra4PathaSERKS0_: __ZN5Umbra4PathaSERKS0_, __ZNK11ICallString6LengthEv: __ZNK11ICallString6LengthEv, __ZN11UnityEngine9Animation15IsPPtrAnimationERKNS0_14GenericBindingE: __ZN11UnityEngine9Animation15IsPPtrAnimationERKNS0_14GenericBindingE, __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalCreatev: __Z62Register_UnityEngine_Networking_UnityWebRequest_InternalCreatev, __Z63Register_UnityEngine_Rendering_GraphicsSettings_GetCustomShaderv: __Z63Register_UnityEngine_Rendering_GraphicsSettings_GetCustomShaderv, __ZN19SpriteMeshGenerator4path17find_max_distanceEi: __ZN19SpriteMeshGenerator4path17find_max_distanceEi, __ZN5physx11HullLibrary12calchullpbevEPNS_6float3EiiRNS_12hullLibArray5ArrayINS_5PlaneEEEf: __ZN5physx11HullLibrary12calchullpbevEPNS_6float3EiiRNS_12hullLibArray5ArrayINS_5PlaneEEEf, __ZN5physx14NpArticulation14wakeUpInternalEbb: __ZN5physx14NpArticulation14wakeUpInternalEbb, __Z18Transfer_BlittableI8JSONReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z30GetLightProbeProxyVolumeHandleRK28LightProbeProxyVolumeContextRK12BaseRenderer: __Z30GetLightProbeProxyVolumeHandleRK28LightProbeProxyVolumeContextRK12BaseRenderer, __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN15TextureSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z22setPxSceneDescUserDataPN5physx11PxSceneDescEPv: __Z22setPxSceneDescUserDataPN5physx11PxSceneDescEPv, __ZN11UnityEngine15CloudWebService16SessionContainer18GetIndexFromDataIdEy: __ZN11UnityEngine15CloudWebService16SessionContainer18GetIndexFromDataIdEy, __ZN4FMOD7SystemI15getOutputHandleEPPv: __ZN4FMOD7SystemI15getOutputHandleEPPv, __Z36setPxClothMotionConstraintConfigBiasPN5physx29PxClothMotionConstraintConfigEf: __Z36setPxClothMotionConstraintConfigBiasPN5physx29PxClothMotionConstraintConfigEf, __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_ED0Ev: __ZN5physx2Gu29EPASupportMapPairRelativeImplINS0_4BoxVES2_ED0Ev, __ZNKSt3__26localeeqERKS0_: __ZNKSt3__26localeeqERKS0_, __ZN7Terrain27GetSplatMaterialCustomPropsER19ShaderPropertySheet: __ZN7Terrain27GetSplatMaterialCustomPropsER19ShaderPropertySheet, __ZThn4_N12_GLOBAL__N_117ConnectionManagerD1Ev: __ZThn4_N12_GLOBAL__N_117ConnectionManagerD1Ev, __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z54ParticleSystem_SizeBySpeedModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __ZN19SkinnedMeshRenderer15ThreadedCleanupEv: __ZN19SkinnedMeshRenderer15ThreadedCleanupEv, __ZNKSt3__215__codecvt_utf16IDiLb0EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IDiLb0EE11do_encodingEv, __ZN10GameObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10GameObject8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN14SpriteRenderer17MainThreadCleanupEv: __ZN14SpriteRenderer17MainThreadCleanupEv, __Z29Transfer_Blittable_ArrayFieldI8JSONReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReaddEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, _UNITY_png_set_benign_errors: _UNITY_png_set_benign_errors, __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode1ELS0_0EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_12PxSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_, __Z68Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipInstancesv: __Z68Register_UnityEngineInternal_GIDebugVisualisation_CycleSkipInstancesv, __Z25Transform_CUSTOM_GetChildP12Il2CppObjecti: __Z25Transform_CUSTOM_GetChildP12Il2CppObjecti, __ZN5physx2Sc15CoreInteractionD2Ev: __ZN5physx2Sc15CoreInteractionD2Ev, __ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE: __ZN16Physics2DManager15OverlapPointAllERK8Vector2fiffPK10Collider2DP13dynamic_arrayIPS3_Lj4EE, __Z38AudioSource_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject: __Z38AudioSource_CUSTOM_INTERNAL_CALL_PauseP12Il2CppObject, __ZN5physx5cloth8SwFabric15scaleRestvaluesEf: __ZN5physx5cloth8SwFabric15scaleRestvaluesEf, __ZN4Mesh10SetIndicesEPKtjj16GfxPrimitiveTypeb: __ZN4Mesh10SetIndicesEPKtjj16GfxPrimitiveTypeb, __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipVP12Il2CppObjectf: __Z58ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetFlipVP12Il2CppObjectf, _vwprintf: _vwprintf, __ZN16BaseVideoTexture19UnloadFromGfxDeviceEb: __ZN16BaseVideoTexture19UnloadFromGfxDeviceEb, __Z18Transfer_BlittableI9JSONWriteLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EsEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx15PxVehicleUpdate11shiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE: __ZN5physx15PxVehicleUpdate11shiftOriginERKNS_6PxVec3EjPPNS_15PxVehicleWheelsE, __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_get_limitsv: __Z54Register_UnityEngine_SliderJoint2D_INTERNAL_get_limitsv, __Z44AreaEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf: __Z44AreaEffector2D_Set_Custom_PropForceMagnitudeP12Il2CppObjectf, __ZN10GUIElement15ThreadedCleanupEv: __ZN10GUIElement15ThreadedCleanupEv, __ZN20ArchiveStorageReaderD2Ev: __ZN20ArchiveStorageReaderD2Ev, __Z47ParticleRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject: __Z47ParticleRenderer_Get_Custom_PropMaxParticleSizeP12Il2CppObject, __Z51AnchoredJoint2D_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK13Vector2fIcall: __Z51AnchoredJoint2D_CUSTOM_INTERNAL_set_connectedAnchorP12Il2CppObjectRK13Vector2fIcall, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15MatrixParameterENS_9allocatorIS3_EEE18__construct_at_endINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESC_SC_j, __ZN11UnityEngine9Animation32CreateAnimatorGenericBindingsOptERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEPKNS0_21AvatarBindingConstantEbRNS6_6memory9AllocatorER8Animator: __ZN11UnityEngine9Animation32CreateAnimatorGenericBindingsOptERKNS0_20AnimationSetBindingsER9TransformPKN7mecanim9animation14AvatarConstantEPKNS7_18ControllerConstantEPKNS0_21AvatarBindingConstantEbRNS6_6memory9AllocatorER8Animator, __ZN14BillboardAsset8SetWidthEf: __ZN14BillboardAsset8SetWidthEf, __ZNK12_GLOBAL__N_122SocketNetworkOutStream11isConnectedEv: __ZNK12_GLOBAL__N_122SocketNetworkOutStream11isConnectedEv, __ZN14NavMeshManager20UpdateCarvingResultsEv: __ZN14NavMeshManager20UpdateCarvingResultsEv, __ZNK25BlendshapePropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK25BlendshapePropertyBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZNK14ParticleSystem12GetParticlesEi: __ZNK14ParticleSystem12GetParticlesEi, _cff_parse_font_bbox: _cff_parse_font_bbox, __ZNK26AnimatorControllerPlayable13GetLayerCountEv: __ZNK26AnimatorControllerPlayable13GetLayerCountEv, __ZN9ProjectorC2E10MemLabelId18ObjectCreationMode: __ZN9ProjectorC2E10MemLabelId18ObjectCreationMode, __Z38Register_UnityEngine_AudioClip_SetDatav: __Z38Register_UnityEngine_AudioClip_SetDatav, __ZN8Animator11SetPlayableEP17AnimationPlayable: __ZN8Animator11SetPlayableEP17AnimationPlayable, __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb: __ZN8Animator18SetupAvatarDataSetEPKN7mecanim9animation14AvatarConstantERNS_13AvatarDataSetEb, __Z50TerrainData_CUSTOM_NeedUpgradeScaledTreePrototypesP12Il2CppObject: __Z50TerrainData_CUSTOM_NeedUpgradeScaledTreePrototypesP12Il2CppObject, __Z61ParticleSystem_MainModule_CUSTOM_SetGravityModifierMultiplierP12Il2CppObjectf: __Z61ParticleSystem_MainModule_CUSTOM_SetGravityModifierMultiplierP12Il2CppObjectf, __ZN5physx23PxGeometryGeneratedInfoC2Ev: __ZN5physx23PxGeometryGeneratedInfoC2Ev, __Z53ParticleSystem_ShapeModule_CUSTOM_SetAlignToDirectionP12Il2CppObjecth: __Z53ParticleSystem_ShapeModule_CUSTOM_SetAlignToDirectionP12Il2CppObjecth, _UNITY_FT_Glyph_Get_CBox: _UNITY_FT_Glyph_Get_CBox, __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN20SphericalHarmonicsL28TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4PPtrI13RenderTextureE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI13RenderTextureE8TransferI14SafeBinaryReadEEvRT_, __ZN31ParticleSystemParticlesTempDataD2Ev: __ZN31ParticleSystemParticlesTempDataD2Ev, __ZN6Camera8CopyFromERKS_: __ZN6Camera8CopyFromERKS_, __ZN5physx16PxsBroadPhaseMBP11shiftOriginERKNS_6PxVec3E: __ZN5physx16PxsBroadPhaseMBP11shiftOriginERKNS_6PxVec3E, __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_: __ZN5physx7profile5visitIbNS0_18EventParseOperatorINS_29ProfileBulkEventHandlerBufferILj256EEELb1EEEEET_NS0_10EventTypes4EnumERKNS0_6TUnionINS0_10StartEventENS9_INS0_9StopEventENS9_INS0_18RelativeStartEventENS9_INS0_17RelativeStopEventENS9_INS0_10EventValueENS9_INS0_17CUDAProfileBufferENS9_IhNS0_5EmptyEEEEEEEEEEEEEEET0_, __ZNKSt3__27codecvtIDic11__mbstate_tE11do_encodingEv: __ZNKSt3__27codecvtIDic11__mbstate_tE11do_encodingEv, __ZN13OcclusionArea5ResetEv: __ZN13OcclusionArea5ResetEv, __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE: __ZN5physx3Scb5Scene23removeArticulationJointERNS0_17ArticulationJointE, __ZN20GpuProgramParameters15AddTextureParamERKNS_16TextureParameterE: __ZN20GpuProgramParameters15AddTextureParamERKNS_16TextureParameterE, __ZN19SharedBillboardData8TransferI14SafeBinaryReadEEvRT_: __ZN19SharedBillboardData8TransferI14SafeBinaryReadEEvRT_, __Z26Texture3D_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayi: __Z26Texture3D_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayi, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEEEE15growAndPushBackERKS2_, __ZN14EdgeCollider2D5ResetEv: __ZN14EdgeCollider2D5ResetEv, __Z39getPxClothStretchConfigCompressionLimitPKN5physx20PxClothStretchConfigE: __Z39getPxClothStretchConfigCompressionLimitPKN5physx20PxClothStretchConfigE, __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_: __ZN8GUIStyle8TransferI14SafeBinaryReadEEvRT_, __ZNK9Rigidbody13GetUseGravityEv: __ZNK9Rigidbody13GetUseGravityEv, __ZN4FMOD13ChannelGroupI17overrideFrequencyEf: __ZN4FMOD13ChannelGroupI17overrideFrequencyEf, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE12iterateClothEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE12iterateClothEv, __ZN7mecanim4hand14BoneFromMuscleEi: __ZN7mecanim4hand14BoneFromMuscleEi, __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f: __ZN5physx2Gu16_gjkLocalRayCastINS0_9TriangleVENS0_11ConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNS9_5Vec3VESF_RSA_RSD_SH_f, __ZN7ApiGLES17ActiveTextureUnitEj: __ZN7ApiGLES17ActiveTextureUnitEj, __ZN10MonoScript23VirtualRedirectTransferER14SafeBinaryRead: __ZN10MonoScript23VirtualRedirectTransferER14SafeBinaryRead, __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetInnerUVv: __Z65Register_UnityEngine_Sprites_DataUtility_INTERNAL_CALL_GetInnerUVv, __ZN16MemoryFileSystem18IsAbsoluteFilePathEPKc: __ZN16MemoryFileSystem18IsAbsoluteFilePathEPKc, __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve: __Z50ParticleSystem_ForceOverLifetimeModule_CUSTOM_GetYP12Il2CppObjectR15MonoMinMaxCurve, __ZN5physx6shdfnd10Foundation24setReportAllocationNamesEb: __ZN5physx6shdfnd10Foundation24setReportAllocationNamesEb, __Z10DestripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE: __Z10DestripifyPKjiRNSt3__26vectorIj13stl_allocatorIjL18MemLabelIdentifier1ELi16EEEE, __ZN21AssetBundleFileSystem16DestroyFileEntryER13FileEntryData: __ZN21AssetBundleFileSystem16DestroyFileEntryER13FileEntryData, __Z49Register_UnityEngine_GUI_INTERNAL_CALL_DragWindowv: __Z49Register_UnityEngine_GUI_INTERNAL_CALL_DragWindowv, __ZN9JSONWrite8TransferI13dynamic_arrayIhLj1EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayIhLj1EEEEvRT_PKc17TransferMetaFlags, __ZN17PrePassRenderLoop15RenderFinalPassEP13RenderTextureS1_b: __ZN17PrePassRenderLoop15RenderFinalPassEP13RenderTextureS1_b, _setregid: _setregid, __ZN5physx8debugger15ForwardingArrayIjED0Ev: __ZN5physx8debugger15ForwardingArrayIjED0Ev, __ZN9Polygon2D5ResetEv: __ZN9Polygon2D5ResetEv, __ZN16BaseVideoTexture20SuspendVideoTexturesEv: __ZN16BaseVideoTexture20SuspendVideoTexturesEv, __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2EPKcj: __ZNSt3__214codecvt_bynameIcc11__mbstate_tEC2EPKcj, __ZN14RenderSettings17UpdateGlobalStateEv: __ZN14RenderSettings17UpdateGlobalStateEv, __ZNK13TranslateGLES10VertexTypeE19VertexChannelFormat: __ZNK13TranslateGLES10VertexTypeE19VertexChannelFormat, __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayINS_13PxExtendedBoxENS0_19ReflectionAllocatorIS2_EEE15growAndPushBackERKS2_, __Z13RegisterClassI15ConstantForce2DEvv: __Z13RegisterClassI15ConstantForce2DEvv, __ZN17TransformInternal25DestroyTransformHierarchyEP18TransformHierarchy: __ZN17TransformInternal25DestroyTransformHierarchyEP18TransformHierarchy, __Z39Register_UnityEngine_Mesh_get_bindposesv: __Z39Register_UnityEngine_Mesh_get_bindposesv, __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMinv: __Z51Register_UnityEngine_HumanTrait_GetMuscleDefaultMinv, __Z38QualitySettings_Get_Custom_PropLodBiasv: __Z38QualitySettings_Get_Custom_PropLodBiasv, __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo: __ZN12NativeBufferI27Converter_SimpleNativeClassI8GUIStyleEE15SetupForWritingER9ArrayInfo, __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI19StreamedBinaryWriteILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN15b2RevoluteJoint11EnableMotorEb: __ZN15b2RevoluteJoint11EnableMotorEb, __ZN8JSONRead18TransferStringDataINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_: __ZN8JSONRead18TransferStringDataINSt3__212basic_stringIcNS1_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEEEEvRT_, __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetContentTypev: __Z71Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetContentTypev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj67ENS_22PxRepXPropertyAccessorILj67ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxArticulationJointEEEE14handleAccessorILj67ENS_22PxRepXPropertyAccessorILj67ES4_ffEEEEvRKT0_, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initIPKwEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESA_SA_, __Z12CanSetWeight9HPlayable: __Z12CanSetWeight9HPlayable, __ZN5Unity17ConfigurableJointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity17ConfigurableJointC2E10MemLabelId18ObjectCreationMode, __Z50RenderTexture_CUSTOM_INTERNAL_CALL_DiscardContentsP12Il2CppObject: __Z50RenderTexture_CUSTOM_INTERNAL_CALL_DiscardContentsP12Il2CppObject, __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_13NpClothFabricENS0_19ReflectionAllocatorIS2_EEE17releaseEmptySlabsEv, __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j: __ZNK5physx28PxRevoluteJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEEEEEjT_j, __Z29setPxParticleBase_RestitutionPN5physx14PxParticleBaseEf: __Z29setPxParticleBase_RestitutionPN5physx14PxParticleBaseEf, __ZN20ArchiveStorageReader4ReadEyyPvPy: __ZN20ArchiveStorageReader4ReadEyyPvPy, __ZNK5physx7NpCloth25getNbSelfCollisionIndicesEv: __ZNK5physx7NpCloth25getNbSelfCollisionIndicesEv, __ZThn680_N18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_: __ZThn680_N18UnityConnectClient18OnAdsIdRequestDoneERK8UnityStrbS2_, __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc: __ZN5physx7NpActor12addConnectorENS_15NpConnectorType4EnumEPNS_6PxBaseEPKc, __Z68Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshMaterialIndexv: __Z68Register_UnityEngine_ParticleSystem_ShapeModule_SetMeshMaterialIndexv, __ZN20ArchiveStorageHeader10CanReadAllERKNS_6HeaderE: __ZN20ArchiveStorageHeader10CanReadAllERKNS_6HeaderE, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z17SetNbTriggerPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j: __Z17SetNbTriggerPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j, __ZN14DetailDatabase22RefreshPrototypesStep1EPP9Texture2D: __ZN14DetailDatabase22RefreshPrototypesStep1EPP9Texture2D, __Z17dynamic_pptr_castIP9Behaviour6ObjectET_RK4PPtrIT0_E: __Z17dynamic_pptr_castIP9Behaviour6ObjectET_RK4PPtrIT0_E, __ZN14UnityAnalytics27OnSceneTimingCallbackStaticEPS_RK15SceneLoadTimingRK8UnityStr: __ZN14UnityAnalytics27OnSceneTimingCallbackStaticEPS_RK15SceneLoadTimingRK8UnityStr, __Z40NavMeshObstacle_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f: __Z40NavMeshObstacle_CUSTOM_INTERNAL_get_sizeP12Il2CppObjectP8Vector3f, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED2Ev: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEED2Ev, __ZN11b2GearJointC2EPK14b2GearJointDef: __ZN11b2GearJointC2EPK14b2GearJointDef, _Round_Super: _Round_Super, __Z51Register_UnityEngine_PhysicsMaterial2D_get_frictionv: __Z51Register_UnityEngine_PhysicsMaterial2D_get_frictionv, __ZN18ScriptingArguments8GetIntAtEi: __ZN18ScriptingArguments8GetIntAtEi, __Z43MonoBehaviour_CUSTOM_Internal_IsInvokingAllP12Il2CppObject: __Z43MonoBehaviour_CUSTOM_Internal_IsInvokingAllP12Il2CppObject, __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE: __ZN11UnityEngine9Animation28GenericAnimationBindingCache20BindGenericComponentERKNS0_14GenericBindingER9TransformRNS0_10BoundCurveE, __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress: __ZN17PersistentManager19LoadObjectsThreadedEPiiR12LoadProgress, __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE: __Z17QuaternionToEulerRK11QuaternionfN4math13RotationOrderE, __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9TextAsset23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN4FMOD8ChannelI11UpdatePitchEv: __ZN4FMOD8ChannelI11UpdatePitchEv, __ZN5physx7NpScene14updateMaterialERNS_10NpMaterialE: __ZN5physx7NpScene14updateMaterialERNS_10NpMaterialE, __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastNonAllocv: __Z63Register_UnityEngine_Physics2D_INTERNAL_CALL_CircleCastNonAllocv, __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE: __ZN5physx10writeDwordEjbRNS_14PxOutputStreamE, __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv: __ZThn116_N5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE7releaseEv, __Z25GetAudioEffectDefinitionsPi: __Z25GetAudioEffectDefinitionsPi, __ZN5physx3Scb5Scene20switchRigidFromNoSimERNS0_11RigidObjectEb: __ZN5physx3Scb5Scene20switchRigidFromNoSimERNS0_11RigidObjectEb, __ZN5physx20BigConvexDataBuilder16PrecomputeSampleEjRKNS_6PxVec3E: __ZN5physx20BigConvexDataBuilder16PrecomputeSampleEjRKNS_6PxVec3E, __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE7releaseEv: __ZN5physx20NpRigidActorTemplateINS_13PxRigidStaticEE7releaseEv, __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI10MonoScriptE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z46Camera_CUSTOM_INTERNAL_get_worldToCameraMatrixP12Il2CppObjectP10Matrix4x4f: __Z46Camera_CUSTOM_INTERNAL_get_worldToCameraMatrixP12Il2CppObjectP10Matrix4x4f, __Z39Register_UnityEngine_Animator_set_speedv: __Z39Register_UnityEngine_Animator_set_speedv, __ZNK9Transform20GetHierarchyCapacityEv: __ZNK9Transform20GetHierarchyCapacityEv, __ZN4FMOD12ChannelGroup8getGroupEiPPS0_: __ZN4FMOD12ChannelGroup8getGroupEiPPS0_, __Z56Register_UnityEngine_Rigidbody_INTERNAL_get_centerOfMassv: __Z56Register_UnityEngine_Rigidbody_INTERNAL_get_centerOfMassv, __Z21CheckForAbstractClassR10GameObject11ClassIDTypePNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z21CheckForAbstractClassR10GameObject11ClassIDTypePNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __Z55Register_UnityEngine_SphereCollider_INTERNAL_set_centerv: __Z55Register_UnityEngine_SphereCollider_INTERNAL_set_centerv, __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv: __ZThn12_N5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE15getSerializableEv, __Z50Register_UnityEngine_Cloth_get_useVirtualParticlesv: __Z50Register_UnityEngine_Cloth_get_useVirtualParticlesv, __Z42Register_UnityEngine_Light_set_cullingMaskv: __Z42Register_UnityEngine_Light_set_cullingMaskv, __ZN11UnityEngine7Connect17DeviceInfoUpdaterC2Ev: __ZN11UnityEngine7Connect17DeviceInfoUpdaterC2Ev, __ZN4Mesh32RecalculateSubmeshBoundsInternalEj: __ZN4Mesh32RecalculateSubmeshBoundsInternalEj, __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13NavMeshParams8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN17ProceduralTexture17UploadToGfxDeviceEv: __ZN17ProceduralTexture17UploadToGfxDeviceEv, __GLOBAL__sub_I_runtime_application_lump_cpp: __GLOBAL__sub_I_runtime_application_lump_cpp, __ZN5physx25PxConstraintGeneratedInfoC2Ev: __ZN5physx25PxConstraintGeneratedInfoC2Ev, __Z29GetRowBytesFromWidthAndFormati13TextureFormat: __Z29GetRowBytesFromWidthAndFormati13TextureFormat, __ZN5physx34NpConstraintGetRigidObjectsFromScbERKNS_3Scb10ConstraintERPNS0_11RigidObjectES6_: __ZN5physx34NpConstraintGetRigidObjectsFromScbERKNS_3Scb10ConstraintERPNS0_11RigidObjectES6_, __Z24RegisterStrippedTypeInfoI18CrashReportManagerEviPKcS2_: __Z24RegisterStrippedTypeInfoI18CrashReportManagerEviPKcS2_, __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_7NpShapeEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZNK5physx9NpPhysics9getShapesEPPNS_7PxShapeEjj: __ZNK5physx9NpPhysics9getShapesEPPNS_7PxShapeEjj, __ZN11NavMeshDataD2Ev: __ZN11NavMeshDataD2Ev, __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE11lower_boundIS1_EENS2_11__wrap_iterIPS1_EERKT_: __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE11lower_boundIS1_EENS2_11__wrap_iterIPS1_EERKT_, __ZN5Unity10FixedJoint20ApplySetupAxesToDescEi: __ZN5Unity10FixedJoint20ApplySetupAxesToDescEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_13PxRigidStaticEEEE14handleAccessorILj16ENS_22PxRepXPropertyAccessorILj16ENS_7PxActorEhhEEEEvRKT0_, _asinhf: _asinhf, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6substrEjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6substrEjj, __ZN8TToArray5IndexIfEEfRKT_i: __ZN8TToArray5IndexIfEEfRKT_i, _UNITY_FT_Request_Size: _UNITY_FT_Request_Size, __Z53Register_UnityEngine_RenderTexture_Internal_GetHeightv: __Z53Register_UnityEngine_RenderTexture_Internal_GetHeightv, __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL27StretchGenericFloatBilinearI17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __Z22AnimationEventFromMonoRK18MonoAnimationEventR14AnimationEvent: __Z22AnimationEventFromMonoRK18MonoAnimationEventR14AnimationEvent, __Z13RegisterClassI15PointEffector2DEvv: __Z13RegisterClassI15PointEffector2DEvv, __ZN4Mesh7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN4Mesh7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN4gles14IsDummySurfaceEP17RenderSurfaceBase: __ZN4gles14IsDummySurfaceEP17RenderSurfaceBase, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_20PxConvexMeshGeometryEEEEclILj268ES3_NS_11PxMeshScaleES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __GLOBAL__sub_I_runtime_animation_director_lump_cpp: __GLOBAL__sub_I_runtime_animation_director_lump_cpp, __ZN4crnd21crnd_get_texture_infoEPKvjPNS_16crn_texture_infoE: __ZN4crnd21crnd_get_texture_infoEPKvjPNS_16crn_texture_infoE, __ZN10MeshFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10MeshFilter23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, _cfgetospeed: _cfgetospeed, __ZN17TransformInternal26InsertTransformThreadAfterER18TransformHierarchyjjj: __ZN17TransformInternal26InsertTransformThreadAfterER18TransformHierarchyjjj, __ZN9Animation7SetClipE4PPtrI13AnimationClipE: __ZN9Animation7SetClipE4PPtrI13AnimationClipE, __Z26DestroyStreamedClipBuilderP19StreamedClipBuilder: __Z26DestroyStreamedClipBuilderP19StreamedClipBuilder, __ZN9TextAsset8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN9TextAsset8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector4fLj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI8Vector4fLj4EEEEvRT_PKc17TransferMetaFlags, __ZN9TextAssetD2Ev: __ZN9TextAssetD2Ev, __ZN18BuoyancyEffector2DD2Ev: __ZN18BuoyancyEffector2DD2Ev, __ZNK23ShaderVariantCollection26GetTypeInfoVirtualInternalEv: __ZNK23ShaderVariantCollection26GetTypeInfoVirtualInternalEv, __ZN12ImageFilters19ReleaseTargetForLDREPP13RenderTexture: __ZN12ImageFilters19ReleaseTargetForLDREPP13RenderTexture, _ether_aton: _ether_aton, __ZN9Rigidbody8TransferI14SafeBinaryReadEEvRT_: __ZN9Rigidbody8TransferI14SafeBinaryReadEEvRT_, __Z59Register_UnityEngine_SystemInfo_SupportsRenderTextureFormatv: __Z59Register_UnityEngine_SystemInfo_SupportsRenderTextureFormatv, __Z49Register_UnityEngine_CubemapArray_Internal_Createv: __Z49Register_UnityEngine_CubemapArray_Internal_Createv, __ZN18ProfilerConnection34HandleEndInstrumentFunctionMessageEPKvjj: __ZN18ProfilerConnection34HandleEndInstrumentFunctionMessageEPKvjj, _UNITY_png_set_compression_level: _UNITY_png_set_compression_level, __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeI7Hash12816CrashReportEventEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEE13stl_allocatorIS4_L18MemLabelIdentifier5ELi16EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Camera23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19AutoOffMeshLinkData8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z18MurmurHashNeutral2PKvij: __Z18MurmurHashNeutral2PKvij, __ZN17InternalIndexPoolD0Ev: __ZN17InternalIndexPoolD0Ev, __ZN13SpeedTreeWind7SParams8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN13SpeedTreeWind7SParams8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN17MonoScriptManager14CollectGarbageEv: __ZN17MonoScriptManager14CollectGarbageEv, __ZN16Physics2DManager21SetLayerCollisionMaskEij: __ZN16Physics2DManager21SetLayerCollisionMaskEij, __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseIN17PxcPoolMallocData10PoolData16ENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN11UnityEngine15CloudWebService14DataDispatcher16SetRequestHeaderERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEj: __ZN11UnityEngine15CloudWebService14DataDispatcher16SetRequestHeaderERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEj, __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb: __ZN5physx3Scb5Scene15removeRigidBodyERNS0_4BodyEbb, __ZN5physx14PxRigidDynamicD0Ev: __ZN5physx14PxRigidDynamicD0Ev, __ZN11UnityEngine15PlatformWrapper16GetVideoMemoryMBEv: __ZN11UnityEngine15PlatformWrapper16GetVideoMemoryMBEv, __ZN4FMOD6System19getRecordNumDriversEPi: __ZN4FMOD6System19getRecordNumDriversEPi, __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_: __ZN10MemoryPool24RegisterStaticMemoryPoolEPS_, __ZN22RenderingCommandBuffer15AddDrawRendererEP8RendererP8Materialii: __ZN22RenderingCommandBuffer15AddDrawRendererEP8RendererP8Materialii, __ZNK31SortCollisionEventsByGameObjectclERK22ParticleCollisionEventS2_: __ZNK31SortCollisionEventsByGameObjectclERK22ParticleCollisionEventS2_, __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Animation23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN2UI6Canvas16UpdateBatchOrderEv: __ZN2UI6Canvas16UpdateBatchOrderEv, __Z43GraphicsSettings_CUSTOM_GetGraphicsSettingsv: __Z43GraphicsSettings_CUSTOM_GetGraphicsSettingsv, __ZN7ApiGLES13CreateTextureE16TextureDimensionN2gl9TexFormatEiiiii: __ZN7ApiGLES13CreateTextureE16TextureDimensionN2gl9TexFormatEiiiii, _connect: _connect, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE14CheckIntegrityEv: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE14CheckIntegrityEv, __Z52Register_UnityEngine_AudioReverbZone_get_HFReferencev: __Z52Register_UnityEngine_AudioReverbZone_get_HFReferencev, _mknodat: _mknodat, _UNITY_FT_Vector_Length: _UNITY_FT_Vector_Length, __ZN16ParticleRenderer19SetUVAnimationYTileEi: __ZN16ParticleRenderer19SetUVAnimationYTileEi, __ZN5physx19CVariableMemoryPool8allocateEj: __ZN5physx19CVariableMemoryPool8allocateEj, __Z45Register_UnityEngine_Renderer_set_probeAnchorv: __Z45Register_UnityEngine_Renderer_set_probeAnchorv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI11ChannelInfoLj4EEEEvRT_17TransferMetaFlags, __ZN4Halo15InitializeClassEv: __ZN4Halo15InitializeClassEv, __Z57Register_UnityEngine_PlatformEffector2D_set_useSideBouncev: __Z57Register_UnityEngine_PlatformEffector2D_set_useSideBouncev, __ZN5physx14NpSpatialIndex7releaseEv: __ZN5physx14NpSpatialIndex7releaseEv, __ZN4HaloD0Ev: __ZN4HaloD0Ev, __ZN16MeshSkinningData16GetSkinInfluenceEi: __ZN16MeshSkinningData16GetSkinInfluenceEi, __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN9Transform23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZL12InvokeMethodI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI19StreamedBinaryWriteILb0EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN18ProceduralMaterialD0Ev: __ZN18ProceduralMaterialD0Ev, __ZN20ArchiveStorageReader22ReadBlocksAndDirectoryER12FileAccessor: __ZN20ArchiveStorageReader22ReadBlocksAndDirectoryER12FileAccessor, __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_: __Z14AppendPathNameRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_, __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawCubev: __Z50Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawCubev, __ZNSt3__26vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIKfEEvRT_: __ZNSt3__26vectorIfNS_9allocatorIfEEE21__push_back_slow_pathIKfEEvRT_, __ZNK22ParticleSystemRenderer15GetSortingFudgeEv: __ZNK22ParticleSystemRenderer15GetSortingFudgeEv, __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE11flushEventsEv: __ZN5physx7profile10DataBufferINS_19PxProfileEventMutexENS0_8NullLockEE11flushEventsEv, __ZN12_GLOBAL__N_1L4gXORERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L4gXORERN5physx12PxGroupsMaskERKS1_S4_, __Z41CommandBuffer_CUSTOM_SetGlobalVectorArrayP12Il2CppObjectiP11Il2CppArray: __Z41CommandBuffer_CUSTOM_SetGlobalVectorArrayP12Il2CppObjectiP11Il2CppArray, __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi: __ZN17PersistentManager51LocalSerializedObjectIdentifierToInstanceIDInternalERK31LocalSerializedObjectIdentifierRi, __ZN8Material9GetMatrixEN9ShaderLab16FastPropertyNameE: __ZN8Material9GetMatrixEN9ShaderLab16FastPropertyNameE, __ZN14Texture2DArrayC2E10MemLabelId18ObjectCreationMode: __ZN14Texture2DArrayC2E10MemLabelId18ObjectCreationMode, _cf2_hintmask_setNew: _cf2_hintmask_setNew, __ZN15CapsuleCollider9SetHeightEf: __ZN15CapsuleCollider9SetHeightEf, __Z48Register_UnityEngine_TerrainData_get_detailWidthv: __Z48Register_UnityEngine_TerrainData_get_detailWidthv, __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_velocityv: __Z52Register_UnityEngine_Rigidbody_INTERNAL_set_velocityv, __Z35Register_UnityEngine_Event_PopEventv: __Z35Register_UnityEngine_Event_PopEventv, __ZN8Animator15GetGoalRotationEi: __ZN8Animator15GetGoalRotationEi, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ShaderEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN9JSONWrite8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI31ArrayOfManagedObjectsTransfererEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sc18ParticleSystemCore17getPxParticleBaseEv: __ZN5physx2Sc18ParticleSystemCore17getPxParticleBaseEv, _UNITY_ft_smooth_renderer_class_pic_init: _UNITY_ft_smooth_renderer_class_pic_init, __ZN5physx31PxVehicleDrive4WGeneratedValuesC2EPKNS_16PxVehicleDrive4WE: __ZN5physx31PxVehicleDrive4WGeneratedValuesC2EPKNS_16PxVehicleDrive4WE, __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_13PxRigidStaticEE17setDominanceGroupEh, __Z43Physics_Get_Custom_PropDefaultContactOffsetv: __Z43Physics_Get_Custom_PropDefaultContactOffsetv, __Z48Register_UnityEngine_AudioChorusFilter_get_depthv: __Z48Register_UnityEngine_AudioChorusFilter_get_depthv, __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS0_4PairINS2_IjjEENS_22PxClothFabricPhaseType4EnumEEENS0_19ReflectionAllocatorIS6_EEE8recreateEj, __ZN5physx2Sc7BodySim21postSwitchToKinematicEv: __ZN5physx2Sc7BodySim21postSwitchToKinematicEv, __ZN17ProceduralTexture17MainThreadCleanupEv: __ZN17ProceduralTexture17MainThreadCleanupEv, __ZNK5Umbra14TomeCollection12getGateCountEv: __ZNK5Umbra14TomeCollection12getGateCountEv, __ZNK5physx11AdjTriangle11HasNeighborEjPj: __ZNK5physx11AdjTriangle11HasNeighborEjPj, __ZN5Umbra9Matrix4x36invertERKS0_: __ZN5Umbra9Matrix4x36invertERKS0_, __Z45Playables_CUSTOM_BeginIgnoreAllocationTrackerv: __Z45Playables_CUSTOM_BeginIgnoreAllocationTrackerv, __Z43ParticleSystemRenderer_RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __Z43ParticleSystemRenderer_RenderMultipleMeshesRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, _cf2_getDefaultWidthX: _cf2_getDefaultWidthX, __ZNK5physx14NpArticulation24getSolverIterationCountsERjS1_: __ZNK5physx14NpArticulation24getSolverIterationCountsERjS1_, __ZN5audio5mixer14GetFloatBufferERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDPKcPfi: __ZN5audio5mixer14GetFloatBufferERKNS0_18AudioMixerConstantERKNS0_16AudioMixerMemoryERK9UnityGUIDPKcPfi, __ZN15CapsuleColliderD0Ev: __ZN15CapsuleColliderD0Ev, __Z22SetupForwardBaseLightsRK18ForwardLightsBlockR17ShaderPassContextRK10TextureRefS6_: __Z22SetupForwardBaseLightsRK18ForwardLightsBlockR17ShaderPassContextRK10TextureRefS6_, __ZN25RuntimeAnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN25RuntimeAnimatorController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN10AudioMixer18EnsureValidRuntimeEv: __ZN10AudioMixer18EnsureValidRuntimeEv, __ZN5physx7NpCloth12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx7NpCloth12createObjectERPhRNS_24PxDeserializationContextE, __Z32checkOverlapCapsule_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleE: __Z32checkOverlapCapsule_triangleGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleE, __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyIjEEvRNS_9XmlReaderEPKcRPvRjS8_RNS_18XmlMemoryAllocatorE, __ZN16SpriteRenderData8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16SpriteRenderData8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN15AudioReverbZone13SetFMODValuesEv: __ZN15AudioReverbZone13SetFMODValuesEv, __ZN15NavMeshObstacleC2ER10MemLabelId18ObjectCreationMode: __ZN15NavMeshObstacleC2ER10MemLabelId18ObjectCreationMode, __ZN5physx16GetMaterialIndexEPKNS_2Gu15HeightFieldDataEj: __ZN5physx16GetMaterialIndexEPKNS_2Gu15HeightFieldDataEj, __ZN19UnityConnectServiceD2Ev: __ZN19UnityConnectServiceD2Ev, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE14setOwnerClientEh: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE14setOwnerClientEh, __ZN2UI14CanvasRenderer17MainThreadCleanupEv: __ZN2UI14CanvasRenderer17MainThreadCleanupEv, __Z39Register_UnityEngine_Mesh_get_canAccessv: __Z39Register_UnityEngine_Mesh_get_canAccessv, __ZN4UNET16ScriptingUpdater3GetEv: __ZN4UNET16ScriptingUpdater3GetEv, __ZNK5physx2Sc16ArticulationCore17getSleepThresholdEv: __ZNK5physx2Sc16ArticulationCore17getSleepThresholdEv, __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN16HeightMeshBVNode8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshColorsv: __Z64Register_UnityEngine_ParticleSystem_ShapeModule_SetUseMeshColorsv, __ZN5physx3Scb5Scene15removeAggregateERNS0_9AggregateE: __ZN5physx3Scb5Scene15removeAggregateERNS0_9AggregateE, __Z45ParticleAnimator_CUSTOM_INTERNAL_get_rndForceP12Il2CppObjectP8Vector3f: __Z45ParticleAnimator_CUSTOM_INTERNAL_get_rndForceP12Il2CppObjectP8Vector3f, _unity_z_inflateReset: _unity_z_inflateReset, __ZL19StaticDestroyShaderPv: __ZL19StaticDestroyShaderPv, __Z18set_root_referencePvjRK10MemLabelIdP23AllocationRootReference: __Z18set_root_referencePvjRK10MemLabelIdP23AllocationRootReference, __Z39ParticleSystem_Get_Custom_PropIsStoppedP12Il2CppObject: __Z39ParticleSystem_Get_Custom_PropIsStoppedP12Il2CppObject, __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPN12_GLOBAL__N_112PropDescImplENS_8debugger19ForwardingAllocatorEED2Ev, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE26clearParticleAccelerationsEv, __ZN10TagManagerC2E10MemLabelId18ObjectCreationMode: __ZN10TagManagerC2E10MemLabelId18ObjectCreationMode, __Z47MaterialPropertyBlock_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray: __Z47MaterialPropertyBlock_CUSTOM_SetVectorArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN13TrailRenderer14UpdateRendererEv: __ZN13TrailRenderer14UpdateRendererEv, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8WindZone12WindZoneModeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN8WindZone12WindZoneModeEEvRT_RT0_PKc17TransferMetaFlags, __ZN5physx2Gu29distanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_: __ZN5physx2Gu29distanceSegmentSegmentSquaredERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_, __Z42Register_UnityEngine_PlayerPrefs_TrySetIntv: __Z42Register_UnityEngine_PlayerPrefs_TrySetIntv, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE17getSleepPassCountEv, __ZN15QualitySettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15QualitySettings23VirtualRedirectTransferER17RemapPPtrTransfer, __Z47Register_UnityEngine_BillboardAsset_GetVerticesv: __Z47Register_UnityEngine_BillboardAsset_GetVerticesv, __ZN18GfxFramebufferGLES8ActivateENS_7BuiltinEb: __ZN18GfxFramebufferGLES8ActivateENS_7BuiltinEb, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS7_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPKNS_6PxBaseEjEES6_NS0_4HashIS6_EENS1_11HashMapBaseIS6_jSA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS7_Rb, _fdim: _fdim, __ZN5MutexC2Ev: __ZN5MutexC2Ev, __ZN17CollisionMeshData8TransferI24GenerateTypeTreeTransferEEvRT_R4Mesh: __ZN17CollisionMeshData8TransferI24GenerateTypeTreeTransferEEvRT_R4Mesh, __ZN5physx2Sn21RepXVisitorWriterBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_21PxVehicleDriveDynDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj643ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN9BoxPruner14preparePruningER16MBPOS_TmpBuffers: __ZN9BoxPruner14preparePruningER16MBPOS_TmpBuffers, __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13SliderJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, ___uremdi3: ___uremdi3, __Z52Register_UnityEngine_Material_GetVectorArrayImplListv: __Z52Register_UnityEngine_Material_GetVectorArrayImplListv, __ZN14GfxContextGLESD2Ev: __ZN14GfxContextGLESD2Ev, __Z38TerrainData_CUSTOM_Internal_SetHeightsP12Il2CppObjectiiiiP11Il2CppArray: __Z38TerrainData_CUSTOM_Internal_SetHeightsP12Il2CppObjectiiiiP11Il2CppArray, __ZN20LocalFileSystemPosix5CloseER13FileEntryData: __ZN20LocalFileSystemPosix5CloseER13FileEntryData, __ZNSt3__210__stdinbufIwED0Ev: __ZNSt3__210__stdinbufIwED0Ev, __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager10removeEdgeENS0_9eEdgeTypeERNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN5physx6shdfnd7PAUtils9stopEventEtt: __ZN5physx6shdfnd7PAUtils9stopEventEtt, __Z14replace_stringI8UnityStrEvRT_RKS1_S4_j: __Z14replace_stringI8UnityStrEvRT_RKS1_S4_j, __Z14SetSHConstantsR28ApplyBuiltinInstancePropertyRK20SphericalHarmonicsL2: __Z14SetSHConstantsR28ApplyBuiltinInstancePropertyRK20SphericalHarmonicsL2, __ZN8Renderer15ThreadedCleanupEv: __ZN8Renderer15ThreadedCleanupEv, __ZN20TextRenderingPrivate8FontImpl14GetOSFontNamesERNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE: __ZN20TextRenderingPrivate8FontImpl14GetOSFontNamesERNSt3__26vectorI8UnityStr13stl_allocatorIS3_L18MemLabelIdentifier34ELi16EEEE, __Z46Register_UnityEngine_AudioSource_get_maxVolumev: __Z46Register_UnityEngine_AudioSource_get_maxVolumev, __ZN8Animator25WriteDefaultValuesNoDirtyEv: __ZN8Animator25WriteDefaultValuesNoDirtyEv, __ZN16GeometryJobTasks19EndGeometryJobFrameER9GfxDevice: __ZN16GeometryJobTasks19EndGeometryJobFrameER9GfxDevice, __Z28CalculatePositionAndVelocityR8Vector3fS0_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesj: __Z28CalculatePositionAndVelocityR8Vector3fS0_RK27ParticleSystemReadOnlyStateRK19ParticleSystemStateRK23ParticleSystemParticlesj, __ZNSt3__2L15utf16be_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE: __ZNSt3__2L15utf16be_to_ucs4EPKhS1_RS1_PjS3_RS3_mNS_12codecvt_modeE, __ZNSt3__218__insertion_sort_3IR12GreaterLayerPP14AnimationStateEEvT0_S6_T_: __ZNSt3__218__insertion_sort_3IR12GreaterLayerPP14AnimationStateEEvT0_S6_T_, __Z38SpringJoint_Get_Custom_PropMaxDistanceP12Il2CppObject: __Z38SpringJoint_Get_Custom_PropMaxDistanceP12Il2CppObject, __Z32AudioClip_CUSTOM_UnloadAudioDataP12Il2CppObject: __Z32AudioClip_CUSTOM_UnloadAudioDataP12Il2CppObject, __ZN5physx3Scb11RigidObject17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb11RigidObject17getBinaryMetaDataERNS_14PxOutputStreamE, __Z22AssignCookieToMaterialRK15SharedLightDataP8Material: __Z22AssignCookieToMaterialRK15SharedLightDataP8Material, __ZNK7Texture9HasMipMapEv: __ZNK7Texture9HasMipMapEv, __Z49Register_UnityEngine_MeshCollider_set_inflateMeshv: __Z49Register_UnityEngine_MeshCollider_set_inflateMeshv, __Z67Register_UnityEngine_Rendering_GraphicsSettings_GetGraphicsSettingsv: __Z67Register_UnityEngine_Rendering_GraphicsSettings_GetGraphicsSettingsv, __Z19RecalculateAutoKeyTIfEvR17AnimationCurveTplIT_Eif: __Z19RecalculateAutoKeyTIfEvR17AnimationCurveTplIT_Eif, __ZNSt3__217moneypunct_bynameIwLb1EEC2EPKcj: __ZNSt3__217moneypunct_bynameIwLb1EEC2EPKcj, __ZN5physx8debugger14PvdMarshallingItdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingItdE12marshalBlockEPKhPhj, __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv: __ZN39AssetBundleLoadFromStreamAsyncOperation14FinalizeStreamEv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransferdEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNSt3__26vectorIN12TreeRenderer13PrototypeInfoE13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE8__appendEj: __ZNSt3__26vectorIN12TreeRenderer13PrototypeInfoE13stl_allocatorIS2_L18MemLabelIdentifier62ELi16EEE8__appendEj, __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException: __ZN19ScriptingInvocation13InvokeCheckedEPP15Il2CppException, _statvfs: _statvfs, __ZN26AnimatorControllerPlayable13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN26AnimatorControllerPlayable13GetLayerIndexERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z5ClearR13CImageSurface: __Z5ClearR13CImageSurface, __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadfEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadfEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __Z53VRSettings_Get_Custom_PropRenderViewportScaleInternalv: __Z53VRSettings_Get_Custom_PropRenderViewportScaleInternalv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj3ENS_22PxRepXPropertyAccessorILj3ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_10PxMaterialEEEE14handleAccessorILj3ENS_22PxRepXPropertyAccessorILj3ES4_ffEEEEvRKT0_, __ZN14SubstanceInput8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14SubstanceInput8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx9PxTaskMgr17resetDependenciesEv: __ZN5physx9PxTaskMgr17resetDependenciesEv, __Z50Register_UnityEngine_ComputeBuffer_InternalSetDatav: __Z50Register_UnityEngine_ComputeBuffer_InternalSetDatav, __ZN22BaseUnityConnectClient31InvokeDonePreparingOnMainThreadEv: __ZN22BaseUnityConnectClient31InvokeDonePreparingOnMainThreadEv, __ZN22BlockMemoryCacheWriterC2E10MemLabelId: __ZN22BlockMemoryCacheWriterC2E10MemLabelId, __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferIKN4math7_float3EEEvRT_PKc17TransferMetaFlags, __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_get_motorv: __Z52Register_UnityEngine_WheelJoint2D_INTERNAL_get_motorv, __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKiiEEi21InstanceIDHashFunctorN14dense_hash_mapIiiS4_NS0_8equal_toIiEE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE9SelectKeyES7_SA_E12maybe_shrinkEv, __ZNK9Rigidbody14GetIsKinematicEv: __ZNK9Rigidbody14GetIsKinematicEv, __Z59Register_UnityEngine_AI_OffMeshLink_get_autoUpdatePositionsv: __Z59Register_UnityEngine_AI_OffMeshLink_get_autoUpdatePositionsv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIKN4math7_float3EEEEvRT_17TransferMetaFlags, __ZN5physx19NpArticulationJoint28setTwistLimitContactDistanceEf: __ZN5physx19NpArticulationJoint28setTwistLimitContactDistanceEf, __ZN15QualitySettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN15QualitySettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12_GLOBAL__N_110Connection15unlockOutStreamEv: __ZN12_GLOBAL__N_110Connection15unlockOutStreamEv, __ZN5physx2Gu20sweepCCTBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE: __ZN5physx2Gu20sweepCCTBoxTrianglesEjPKNS_10PxTriangleEbRKNS_13PxBoxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRSA_SD_RfRjPKjfNS_7PxFlagsINS_9PxHitFlag4EnumEtEE, __ZN5physx2Sc14ConstraintCore9setBodiesEPNS0_9RigidCoreES3_: __ZN5physx2Sc14ConstraintCore9setBodiesEPNS0_9RigidCoreES3_, __Z37Terrain_Get_Custom_PropActiveTerrainsv: __Z37Terrain_Get_Custom_PropActiveTerrainsv, __ZN7mecanim9animation12GetHumanPoseINS0_10ValueDeltaEEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE: __ZN7mecanim9animation12GetHumanPoseINS0_10ValueDeltaEEEvRKNS0_18ClipMuscleConstantEPKT_RNS_5human9HumanPoseE, __ZN13ComputeBuffer17ReloadToGfxDeviceEv: __ZN13ComputeBuffer17ReloadToGfxDeviceEv, __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS9_EEiEESC_RKT_: __ZNSt3__26__treeIiNS_4lessIiEE13stl_allocatorIiL18MemLabelIdentifier1ELi16EEE12__find_equalIiEERPNS_16__tree_node_baseIPvEENS_21__tree_const_iteratorIiPNS_11__tree_nodeIiS9_EEiEESC_RKT_, __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN15DistanceJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, _UNITY_FT_Init_Class_tt_cmap6_class_rec: _UNITY_FT_Init_Class_tt_cmap6_class_rec, __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_83kSetPolygon2D4CallEPviR11MessageData: __ZZN10Collider2D15InitializeClassEvEN27FunctorImpl_83kSetPolygon2D4CallEPviR11MessageData, __ZN19ShaderPropertySheet24SetTextureTexelSizeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f: __ZN19ShaderPropertySheet24SetTextureTexelSizeValueEiRKN9ShaderLab16FastPropertyNameERK8Vector4f, _strupr: _strupr, __Z48Register_UnityEngine_HingeJoint2D_get_jointAnglev: __Z48Register_UnityEngine_HingeJoint2D_get_jointAnglev, __ZN14NavMeshManager16UpdatePostScriptEv: __ZN14NavMeshManager16UpdatePostScriptEv, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartDelayv, __Z54CanvasRenderer_CUSTOM_INTERNAL_CALL_EnableRectClippingP12Il2CppObjectRK5RectTIfE: __Z54CanvasRenderer_CUSTOM_INTERNAL_CALL_EnableRectClippingP12Il2CppObjectRK5RectTIfE, __ZN5physx14PxsAABBManager16updateAABBsAndBPEjjjPNS_10PxBaseTaskEPjjbPi: __ZN5physx14PxsAABBManager16updateAABBsAndBPEjjjPNS_10PxBaseTaskEPjjbPi, __ZNK14NavMeshManager24GetNavMeshDataInstanceIDEi: __ZNK14NavMeshManager24GetNavMeshDataInstanceIDEi, __ZN29AssetBundleLoadAssetOperation20PreparePreloadAssetsEb: __ZN29AssetBundleLoadAssetOperation20PreparePreloadAssetsEb, __ZN9Scripting21RaiseManagedExceptionEPKcS1_S1_z: __ZN9Scripting21RaiseManagedExceptionEPKcS1_S1_z, __Z15GetInputManagerv: __Z15GetInputManagerv, ___lgammal_r: ___lgammal_r, __ZN11AudioSource20SetCustomSpreadCurveERK17AnimationCurveTplIfE: __ZN11AudioSource20SetCustomSpreadCurveERK17AnimationCurveTplIfE, __ZN4Mesh10SetIndicesEPKjjj16GfxPrimitiveTypeb: __ZN4Mesh10SetIndicesEPKjjj16GfxPrimitiveTypeb, __ZNK5physx15NpParticleFluid23getRestParticleDistanceEv: __ZNK5physx15NpParticleFluid23getRestParticleDistanceEv, __ZN6Shader19MarkShaderHasErrorsEPKS_: __ZN6Shader19MarkShaderHasErrorsEPKS_, __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIccEEPcEEjT0_S5_S5_S5_S5_T_, __ZNK9dtNavMesh15getPolyGeometryEyPfPyi: __ZNK9dtNavMesh15getPolyGeometryEyPfPyi, __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_: __ZNSt3__26vectorI4PPtrI13AnimationClipE13stl_allocatorIS3_L18MemLabelIdentifier25ELi16EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISB_E9referenceEEE5valueEvE4typeESB_SB_, __ZNK9Heightmap20ExtractRawHeightDataER13dynamic_arrayIsLj2EEiiii: __ZNK9Heightmap20ExtractRawHeightDataER13dynamic_arrayIsLj2EEiiii, __Z30RegisterModule_UnityWebRequestv: __Z30RegisterModule_UnityWebRequestv, __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_8CapsuleVERNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERKNS6_6FloatVERKNS6_5Vec3VESF_RSA_RSD_SH_fb, __ZN5physx22PxVehicleWheelsDynData14setToRestStateEv: __ZN5physx22PxVehicleWheelsDynData14setToRestStateEv, __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej: __ZNSt3__29money_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2Ej, _UNITY_png_handle_gAMA: _UNITY_png_handle_gAMA, __ZN5physx3Scb5Shape9syncStateEv: __ZN5physx3Scb5Shape9syncStateEv, __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN6Skybox23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionYv: __Z62Register_UnityEngine_LightProbeProxyVolume_set_gridResolutionYv, __Z43Register_UnityEngine_Texture_get_filterModev: __Z43Register_UnityEngine_Texture_get_filterModev, __Z48Register_UnityEngine_Input_get_multiTouchEnabledv: __Z48Register_UnityEngine_Input_get_multiTouchEnabledv, __ZN5physx7NpScene31setClothInterCollisionStiffnessEf: __ZN5physx7NpScene31setClothInterCollisionStiffnessEf, __ZN12InputManager15InitializeClassEv: __ZN12InputManager15InitializeClassEv, __Z42Register_UnityEngine_LayerMask_LayerToNamev: __Z42Register_UnityEngine_LayerMask_LayerToNamev, __ZL20dst_init_destinationP20jpeg_compress_struct: __ZL20dst_init_destinationP20jpeg_compress_struct, __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateBufferv: __Z68Register_UnityEngine_Networking_DownloadHandler_InternalCreateBufferv, __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf: __ZNK9Rigidbody20ClosestPointOnBoundsERK8Vector3fRS0_Rf, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_7PxClothEEEEEEEjT_j, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS5_L18MemLabelIdentifier52ELi16EEEEEEvRT_17TransferMetaFlags, __ZNSt3__26locale5__imp12install_fromINS_5ctypeIwEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_5ctypeIwEEEEvRKS1_, __ZN5Umbra9fnv64HashEPKhj: __ZN5Umbra9fnv64HashEPKhj, __Z50Register_UnityEngine_ShaderVariantCollection_Clearv: __Z50Register_UnityEngine_ShaderVariantCollection_Clearv, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEE11runInternalEv: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_20particlePostShapeGenEPNS_10PxBaseTaskEEEE11runInternalEv, __ZN13GfxDeviceGLES16SetAntiAliasFlagEb: __ZN13GfxDeviceGLES16SetAntiAliasFlagEb, __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_IsValidInternalv: __Z81Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_IsValidInternalv, __ZN7ApiGLES5QueryEN2gl6HandleILNS0_10ObjectTypeE4EEENS0_11QueryResultE: __ZN7ApiGLES5QueryEN2gl6HandleILNS0_10ObjectTypeE4EEENS0_11QueryResultE, __ZN8Animator24CollectAnimatedRenderersERKNS_15BindingsDataSetE: __ZN8Animator24CollectAnimatedRenderersERKNS_15BindingsDataSetE, __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_: __ZNSt3__27__sort3IRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEjT0_S7_S7_T_, __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv: __ZN23ParticleSystemParticles22SetUsesRotationalSpeedEv, __ZN11ForceModuleD2Ev: __ZN11ForceModuleD2Ev, __ZNK12NavMeshAgent11PathPendingEv: __ZNK12NavMeshAgent11PathPendingEv, __ZThn24_N5physx2Sc21ConstraintInteractionD0Ev: __ZThn24_N5physx2Sc21ConstraintInteractionD0Ev, __Z18Transfer_BlittableI9JSONWriteLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_TT_New_Context: _UNITY_TT_New_Context, __Z46Transform_CUSTOM_INTERNAL_CALL_TransformVectorP12Il2CppObjectRK8Vector3fRS1_: __Z46Transform_CUSTOM_INTERNAL_CALL_TransformVectorP12Il2CppObjectRK8Vector3fRS1_, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseFalseILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZNK6Shader19CreatePropertySheetERK10MemLabelId: __ZNK6Shader19CreatePropertySheetERK10MemLabelId, __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx3Ext5JointINS_15PxRevoluteJointENS_30PxRevoluteJointGeneratedValuesEE8requiresERNS_23PxProcessPxBaseCallbackE, __Z55Animator_CUSTOM_INTERNAL_CALL_GetIKHintPositionInternalP12Il2CppObjectiR8Vector3f: __Z55Animator_CUSTOM_INTERNAL_CALL_GetIKHintPositionInternalP12Il2CppObjectiR8Vector3f, __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetMaxLightsv: __Z61Register_UnityEngine_ParticleSystem_LightsModule_GetMaxLightsv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_7PxClothEE8pushNameEPKc, __Z57Register_UnityEngine_ParticleSystemRenderer_set_alignmentv: __Z57Register_UnityEngine_ParticleSystemRenderer_set_alignmentv, __Z49Animator_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject: __Z49Animator_Get_Custom_PropRuntimeAnimatorControllerP12Il2CppObject, __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN26AnimatorOverrideController8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIiiEEPiEEbT0_S5_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIiiEEPiEEbT0_S5_T_, __ZN13TextRendering4Font8TransferI14SafeBinaryReadEEvRT_: __ZN13TextRendering4Font8TransferI14SafeBinaryReadEEvRT_, __Z35Camera_Set_Custom_PropTargetTextureP12Il2CppObjectS0_: __Z35Camera_Set_Custom_PropTargetTextureP12Il2CppObjectS0_, __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveCountP12Il2CppObjecti: __Z48ParticleSystem_NoiseModule_CUSTOM_SetOctaveCountP12Il2CppObjecti, __ZN18AudioLowPassFilter15ThreadedCleanupEv: __ZN18AudioLowPassFilter15ThreadedCleanupEv, __Z29Camera_Get_Custom_PropCurrentv: __Z29Camera_Get_Custom_PropCurrentv, __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_: __Z77Rigidbody2D_CUSTOM_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityP12Il2CppObjectRK13Vector2fIcallPS1_, __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv: __ZN5physx2Sc10NPhaseCore15fetchFilterPairEPv, __Z38UnityAnalyticsHandler_CUSTOM_SetUserIdP12Il2CppObjectP12Il2CppString: __Z38UnityAnalyticsHandler_CUSTOM_SetUserIdP12Il2CppObjectP12Il2CppString, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE26getNumSelfCollisionIndicesEv, __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI19SkinnedMeshRendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13UnityProfiler16EndProfilingModeE12ProfilerMode: __ZN13UnityProfiler16EndProfilingModeE12ProfilerMode, __ZN7mecanim9animation20CreateBlendTreeInputERNS_6memory9AllocatorE: __ZN7mecanim9animation20CreateBlendTreeInputERNS_6memory9AllocatorE, __ZN11Rigidbody2D15ThreadedCleanupEv: __ZN11Rigidbody2D15ThreadedCleanupEv, __ZNK13BaseAllocator16IsDelayedReleaseEv: __ZNK13BaseAllocator16IsDelayedReleaseEv, __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_16PxSphereGeometryE: __ZNK5physx29PxShapeGeometryPropertyHelper11getGeometryEPKNS_7PxShapeERNS_16PxSphereGeometryE, __Z46Register_UnityEngine_MeshFilter_set_sharedMeshv: __Z46Register_UnityEngine_MeshFilter_set_sharedMeshv, __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE19TransferSTLStyleMapINSt3__28multimapI8UnityStr4PPtrI6ObjectENS2_4lessIS4_EE13stl_allocatorINS2_4pairIKS4_S7_EEL18MemLabelIdentifier51ELi16EEEEEEvRT_17TransferMetaFlags, __ZN5physx9NpFactory18onAggregateReleaseEPNS_11PxAggregateE: __ZN5physx9NpFactory18onAggregateReleaseEPNS_11PxAggregateE, __ZN17GenericDynamicVBO11SwapBuffersEj: __ZN17GenericDynamicVBO11SwapBuffersEj, _cacosh: _cacosh, __ZN19StreamedBinaryWriteILb1EE5AlignEv: __ZN19StreamedBinaryWriteILb1EE5AlignEv, __ZN5physx23NpParticleFluidReadDataD0Ev: __ZN5physx23NpParticleFluidReadDataD0Ev, __ZNK5physx3Cct13BoxController20getHalfForwardExtentEv: __ZNK5physx3Cct13BoxController20getHalfForwardExtentEv, __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_13PxTriggerPairENS0_19ReflectionAllocatorIS2_EEE8recreateEj, __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_13NpClothFabricENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZNSt3__27collateIcED2Ev: __ZNSt3__27collateIcED2Ev, __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv: __ZN18GfxFramebufferGLES32ProcessInvalidatedRenderSurfacesEv, __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeIN2gl13ContextHandleEPN14GfxContextGLES8InstanceEEENS_19__map_value_compareIS3_S7_NS_4lessIS3_EELb1EEENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZNK5physx16PxsBroadPhaseMBP18getNumCreatedPairsEv: __ZNK5physx16PxsBroadPhaseMBP18getNumCreatedPairsEv, __ZN19AudioHighPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN19AudioHighPassFilter23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __ZN7Cubemap16SetSourceTextureE11CubemapFace4PPtrI9Texture2DE: __ZN7Cubemap16SetSourceTextureE11CubemapFace4PPtrI9Texture2DE, __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE: __ZN5physx3Scb5Scene9getStreamENS_7ScbType4EnumE, __ZN5Umbra11Transformer13classifyPlaneERKNS_12SIMDRegisterE: __ZN5Umbra11Transformer13classifyPlaneERKNS_12SIMDRegisterE, __ZNK5Unity10HingeJoint8GetAngleEv: __ZNK5Unity10HingeJoint8GetAngleEv, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetRequestedPtrSizeEPKv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE19GetRequestedPtrSizeEPKv, __ZN2UI14CanvasRenderer7SetMeshEP4Mesh: __ZN2UI14CanvasRenderer7SetMeshEP4Mesh, __ZN15QualitySettings10SetCurrentENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN15QualitySettings10SetCurrentENSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __ZNK19CollisionListener2D10IsTouchingEPK10Collider2DS2_: __ZNK19CollisionListener2D10IsTouchingEPK10Collider2DS2_, __ZN9HaloLayerD2Ev: __ZN9HaloLayerD2Ev, __ZN5physx25solveContact_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx25solveContact_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __ZNK5physx16PxsParticleShape12getUserDataVEv: __ZNK5physx16PxsParticleShape12getUserDataVEv, __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIyEEvRT_PKc17TransferMetaFlags, __Z31setPxClothParticleDataParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE: __Z31setPxClothParticleDataParticlesPN5physx19PxClothParticleDataEPNS_15PxClothParticleE, __Z11Build3DLineP10LineVertexRK14LineParametersRKN4math8float4x4ES7_PKNS4_14float3_storageEj: __Z11Build3DLineP10LineVertexRK14LineParametersRKN4math8float4x4ES7_PKNS4_14float3_storageEj, __ZNK5physx14NpSceneQueries5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf: __ZNK5physx14NpSceneQueries5sweepERKNS_10PxGeometryERKNS_11PxTransformERKNS_6PxVec3EfRNS_13PxHitCallbackINS_10PxSweepHitEEENS_7PxFlagsINS_9PxHitFlag4EnumEtEERKNS_17PxQueryFilterDataEPNS_21PxQueryFilterCallbackEPKNS_12PxQueryCacheEf, __Z43HumanTrait_Get_Custom_PropRequiredBoneCountv: __Z43HumanTrait_Get_Custom_PropRequiredBoneCountv, __Z67Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformVectorv: __Z67Register_UnityEngine_Transform_INTERNAL_CALL_InverseTransformVectorv, __ZN14DirectorPlayer17MainThreadCleanupEv: __ZN14DirectorPlayer17MainThreadCleanupEv, __Z37GUIStyle_Get_Custom_PropStretchHeightP12Il2CppObject: __Z37GUIStyle_Get_Custom_PropStretchHeightP12Il2CppObject, __Z26Animator_CUSTOM_SetFloatIDP12Il2CppObjectif: __Z26Animator_CUSTOM_SetFloatIDP12Il2CppObjectif, __ZN11DetailPatchC2ERKS_: __ZN11DetailPatchC2ERKS_, __Z15DestroyJobQueuev: __Z15DestroyJobQueuev, __Z42Register_UnityEngine_Canvas_get_rootCanvasv: __Z42Register_UnityEngine_Canvas_get_rootCanvasv, __ZN11b2WeldJoint24SolveVelocityConstraintsERK12b2SolverData: __ZN11b2WeldJoint24SolveVelocityConstraintsERK12b2SolverData, __ZN15CollisionModule8TransferI17RemapPPtrTransferEEvRT_: __ZN15CollisionModule8TransferI17RemapPPtrTransferEEvRT_, _tgamma: _tgamma, __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CircleCastv: __Z64Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_CircleCastv, __Z33AudioSource_Set_Custom_PropVolumeP12Il2CppObjectf: __Z33AudioSource_Set_Custom_PropVolumeP12Il2CppObjectf, __Z47Physics2D_CUSTOM_INTERNAL_set_colliderAABBColorRK10ColorRGBAf: __Z47Physics2D_CUSTOM_INTERNAL_set_colliderAABBColorRK10ColorRGBAf, __ZN5Umbra14TomeCollection4initEPvj: __ZN5Umbra14TomeCollection4initEPvj, __ZN18GfxFramebufferGLES32UpdateDefaultFramebufferViewportEv: __ZN18GfxFramebufferGLES32UpdateDefaultFramebufferViewportEv, __Z43Register_UnityEngine_Animator_GetBehavioursv: __Z43Register_UnityEngine_Animator_GetBehavioursv, __Z30getPxVehicleWheelDataMMaxSteerPKN5physx18PxVehicleWheelDataE: __Z30getPxVehicleWheelDataMMaxSteerPKN5physx18PxVehicleWheelDataE, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI12ImmediatePtrI9TransformELj4EEEEvRT_17TransferMetaFlags, __ZN7mecanim12statemachine23CreateConditionConstantEjjfRNS_6memory9AllocatorE: __ZN7mecanim12statemachine23CreateConditionConstantEjjfRNS_6memory9AllocatorE, _cff_get_glyph_name: _cff_get_glyph_name, __ZN14PlayerSettings19PostInitializeClassEv: __ZN14PlayerSettings19PostInitializeClassEv, __ZN22RenderingCommandBuffer18AddSetGlobalMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4f: __ZN22RenderingCommandBuffer18AddSetGlobalMatrixERKN9ShaderLab16FastPropertyNameERK10Matrix4x4f, __Z39Camera_Set_Custom_PropStereoConvergenceP12Il2CppObjectf: __Z39Camera_Set_Custom_PropStereoConvergenceP12Il2CppObjectf, ___cxx_global_var_init_2: ___cxx_global_var_init_2, __ZN12InputManager30GetEatKeyPressOnTextFieldFocusEv: __ZN12InputManager30GetEatKeyPressOnTextFieldFocusEv, __Z50Register_UnityEngine_AudioReverbZone_get_diffusionv: __Z50Register_UnityEngine_AudioReverbZone_get_diffusionv, __Z31Camera_CUSTOM_GetCommandBuffersP12Il2CppObject21RenderCameraEventType: __Z31Camera_CUSTOM_GetCommandBuffersP12Il2CppObject21RenderCameraEventType, __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f: __Z52MaterialPropertyBlock_CUSTOM_INTERNAL_CALL_SetMatrixP12Il2CppObjectiRK10Matrix4x4f, __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetNormalOffsetv: __Z63Register_UnityEngine_ParticleSystem_ShapeModule_GetNormalOffsetv, __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZv: __Z72Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_GetZv, __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext: __ZN15ReplacementPass16PerformRenderingER17ShaderPassContext, __Z67Register_UnityEngine_Networking_UnityWebRequest_set_chunkedTransferv: __Z67Register_UnityEngine_Networking_UnityWebRequest_set_chunkedTransferv, __ZN19CloudServiceHandler16HandlePlayerLoopEv: __ZN19CloudServiceHandler16HandlePlayerLoopEv, _jpeg_set_quality: _jpeg_set_quality, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN9ShaderLab20SerializedSubProgram13BufferBindingENS1_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN29InitialModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN29InitialModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN17PersistentManager38SerializedObjectIdentifierToInstanceIDERK26SerializedObjectIdentifier: __ZN17PersistentManager38SerializedObjectIdentifierToInstanceIDERK26SerializedObjectIdentifier, __Z39UnityAdsSettings_Set_Custom_PropEnabledh: __Z39UnityAdsSettings_Set_Custom_PropEnabledh, __ZplRK8Scalar4fS1_: __ZplRK8Scalar4fS1_, __Z31setPxVehicleClutchDataMStrengthPN5physx19PxVehicleClutchDataEf: __Z31setPxVehicleClutchDataMStrengthPN5physx19PxVehicleClutchDataEf, __ZN13AvatarBuilder36ReadFromLocalTransformToSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNSt3__26vectorINS_14NamedTransformENS7_9allocatorIS9_EEEE: __ZN13AvatarBuilder36ReadFromLocalTransformToSkeletonPoseEPN7mecanim8skeleton13SkeletonPoseTIN4math4trsXEEERKNSt3__26vectorINS_14NamedTransformENS7_9allocatorIS9_EEEE, __ZNK24RingBufferMemoryFileData4SizeEv: __ZNK24RingBufferMemoryFileData4SizeEv, __Z51AudioLowPassFilter_Set_Custom_PropCustomCutoffCurveP12Il2CppObjectS0_: __Z51AudioLowPassFilter_Set_Custom_PropCustomCutoffCurveP12Il2CppObjectS0_, __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE: __ZN5physx2Gu25PersistentContactManifold17addManifoldPoint2ERKNS_6shdfnd3aos5Vec3VES6_RKNS3_5Vec4VERKNS3_6FloatVE, __ZNK5physx16PxVehicleDrive4W8isKindOfEPKc: __ZNK5physx16PxVehicleDrive4W8isKindOfEPKc, __Z39Register_UnityEngine_GUIText_get_anchorv: __Z39Register_UnityEngine_GUIText_get_anchorv, __ZN5physx10PxsCCDPair12sweepFindToiERNS_16PxsThreadContextEfj: __ZN5physx10PxsCCDPair12sweepFindToiERNS_16PxsThreadContextEfj, __Z59Register_UnityEngine_ParticleRenderer_get_uvAnimationCyclesv: __Z59Register_UnityEngine_ParticleRenderer_get_uvAnimationCyclesv, __ZN17GeneralConnection13MulticastInfo5ParseEPKcPv: __ZN17GeneralConnection13MulticastInfo5ParseEPKcPv, __Z22SetBackButtonLeavesAppb: __Z22SetBackButtonLeavesAppb, _cff_get_standard_encoding: _cff_get_standard_encoding, __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeYMultiplierP12Il2CppObjectf: __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeYMultiplierP12Il2CppObjectf, __ZNK6Object25GetNeedsPerObjectTypeTreeEv: __ZNK6Object25GetNeedsPerObjectTypeTreeEv, __ZN4FMOD13ChannelGroupI14set3DOcclusionEff: __ZN4FMOD13ChannelGroupI14set3DOcclusionEff, __ZNSt3__218__insertion_sort_3IRNS_6__lessImmEEPmEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessImmEEPmEEvT0_S5_T_, __Z37Physics_Set_Custom_PropSleepThresholdf: __Z37Physics_Set_Custom_PropSleepThresholdf, __ZN5physx2Sc5Scene14postBroadPhaseEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene14postBroadPhaseEPNS_10PxBaseTaskE, __ZN12_GLOBAL__N_110DataStream17allocateMemForCmdEj: __ZN12_GLOBAL__N_110DataStream17allocateMemForCmdEj, __Z30Light_Get_Custom_PropIntensityP12Il2CppObject: __Z30Light_Get_Custom_PropIntensityP12Il2CppObject, __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb1EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z33EmitSerializationCommandsForFieldI18StreamedBinaryReadILb1EEEvR18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __Z18Transfer_BlittableI8JSONReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UTF16String_TakeOverPreAllocatedUTF16Bytes: _UTF16String_TakeOverPreAllocatedUTF16Bytes, __ZN4FMOD8ChannelI16getSpeakerLevelsE12FMOD_SPEAKERPfi: __ZN4FMOD8ChannelI16getSpeakerLevelsE12FMOD_SPEAKERPfi, __ZNK12BaseRenderer14GetSubsetIndexEi: __ZNK12BaseRenderer14GetSubsetIndexEi, __ZN5physx21contactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx21contactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEEC2EPNS_15basic_streambufIcS2_EE, __ZN14ParticleSystem5ClearEv: __ZN14ParticleSystem5ClearEv, __ZN10UnityScene7SetNameERK8UnityStr: __ZN10UnityScene7SetNameERK8UnityStr, __ZNSt3__212strstreambuf9pbackfailEi: __ZNSt3__212strstreambuf9pbackfailEi, __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z53ParticleSystem_RotationOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j: __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE18__construct_at_endINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESB_SB_j, __ZN10systeminfo13SupportsAudioEv: __ZN10systeminfo13SupportsAudioEv, __Z17FMODMemoryReallocPvjjPKc: __Z17FMODMemoryReallocPvjjPKc, __ZN9AudioClip12moviepcmreadEP10FMOD_SOUNDPvj: __ZN9AudioClip12moviepcmreadEP10FMOD_SOUNDPvj, __Z58Register_UnityEngine_Rendering_SplashScreen_get_isFinishedv: __Z58Register_UnityEngine_Rendering_SplashScreen_get_isFinishedv, __Z36CombineMeshVerticesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEERKNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEER4Meshb: __Z36CombineMeshVerticesForStaticBatchingRKNSt3__26vectorI15CombineInstanceNS_9allocatorIS1_EEEERKNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEER4Meshb, __ZNSt3__28numpunctIcED2Ev: __ZNSt3__28numpunctIcED2Ev, __ZN6IDList25CalculateNextFromHintListER8GUIStateib: __ZN6IDList25CalculateNextFromHintListER8GUIStateib, __Z15GetAudioManagerv: __Z15GetAudioManagerv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE24setSelfCollisionDistanceEf, __ZN14ParticleSystem12GetParticlesEi: __ZN14ParticleSystem12GetParticlesEi, __ZN10SpookyHash4InitEyy: __ZN10SpookyHash4InitEyy, __ZN5physx23collideWithMeshTriangleERNS_6PxVec3ES1_S1_S1_RfS2_RKS0_S4_S4_S4_S4_bRKfS6_: __ZN5physx23collideWithMeshTriangleERNS_6PxVec3ES1_S1_S1_RfS2_RKS0_S4_S4_S4_S4_bRKfS6_, __ZN14PlayerSettings23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN14PlayerSettings23VirtualRedirectTransferER17RemapPPtrTransfer, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN13OcclusionArea8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13OcclusionArea8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z38Rigidbody_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f: __Z38Rigidbody_CUSTOM_INTERNAL_set_positionP12Il2CppObjectRK8Vector3f, __ZN21LightProbeProxyVolume12AddToManagerEv: __ZN21LightProbeProxyVolume12AddToManagerEv, __ZZ24InitializeNavMeshManagervEN23PreUpdateAIUpdatestruct7ForwardEv: __ZZ24InitializeNavMeshManagervEN23PreUpdateAIUpdatestruct7ForwardEv, __Z15Transfer_StringI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z42setPxFixedJoint_ProjectionAngularTolerancePN5physx12PxFixedJointEf: __Z42setPxFixedJoint_ProjectionAngularTolerancePN5physx12PxFixedJointEf, __Z44Camera_CUSTOM_INTERNAL_CALL_ScreenPointToRayP12Il2CppObjectRK8Vector3fR3Ray: __Z44Camera_CUSTOM_INTERNAL_CALL_ScreenPointToRayP12Il2CppObjectRK8Vector3fR3Ray, __Z26setPxDistanceJoint_DampingPN5physx15PxDistanceJointEf: __Z26setPxDistanceJoint_DampingPN5physx15PxDistanceJointEf, __ZN8Remapper14PreallocateIDsExiRiS0_: __ZN8Remapper14PreallocateIDsExiRiS0_, __ZNK11AudioSource21GetCustomRolloffCurveEv: __ZNK11AudioSource21GetCustomRolloffCurveEv, __ZN11UnityEngine15CloudWebService19SessionEventManagerD2Ev: __ZN11UnityEngine15CloudWebService19SessionEventManagerD2Ev, __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_14PxcSIMDSpatialENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZNKSt3__214__codecvt_utf8IDiE16do_always_noconvEv: __ZNKSt3__214__codecvt_utf8IDiE16do_always_noconvEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseIPNS_7PxShapeES4_NS0_4HashIS4_EENS1_11HashSetBaseIS4_S6_NS0_9AllocatorELb1EE6GetKeyES8_Lb1EE15reserveInternalEj, __ZN14DetailRendererC2E4PPtrI11TerrainDataE8Vector3f: __ZN14DetailRendererC2E4PPtrI11TerrainDataE8Vector3f, __Z64Register_UnityEngine_Camera_INTERNAL_CALL_ResetReplacementShaderv: __Z64Register_UnityEngine_Camera_INTERNAL_CALL_ResetReplacementShaderv, __ZN16LightmapSettings12SetLightmapsERK13dynamic_arrayI12LightmapDataLj4EE: __ZN16LightmapSettings12SetLightmapsERK13dynamic_arrayI12LightmapDataLj4EE, __Z45QualitySettings_Set_Custom_PropSoftVegetationh: __Z45QualitySettings_Set_Custom_PropSoftVegetationh, __ZN30RuntimeInitializeOnLoadManager6UpdateEv: __ZN30RuntimeInitializeOnLoadManager6UpdateEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEE14handleAccessorILj180ENS_22PxRepXPropertyAccessorILj180ENS_14PxParticleBaseEffEEEEvRKT0_, __ZN19SkinnedMeshRenderer34GetVisibleSkinnedMeshRendererCountEv: __ZN19SkinnedMeshRenderer34GetVisibleSkinnedMeshRendererCountEv, __ZN5physx14PxsAABBManager31removeEmptyActorsFromAggregatesEv: __ZN5physx14PxsAABBManager31removeEmptyActorsFromAggregatesEv, __ZN12BaseRenderer12GetLocalAABBER4AABB: __ZN12BaseRenderer12GetLocalAABBER4AABB, __Z30setPxArticulationJoint_DampingPN5physx19PxArticulationJointEf: __Z30setPxArticulationJoint_DampingPN5physx19PxArticulationJointEf, __ZNK11BoxCollider15GetGlobalCenterEv: __ZNK11BoxCollider15GetGlobalCenterEv, __Z40FrictionJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject: __Z40FrictionJoint2D_Get_Custom_PropMaxTorqueP12Il2CppObject, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead22ProceduralPropertyTypeEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead22ProceduralPropertyTypeEvRT_RT0_PKc17TransferMetaFlags, __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_: __ZNSt3__27__sort4IRNS_6__lessIN2UI14DepthSortEntryES3_EEPS3_EEjT0_S7_S7_S7_T_, __ZN5Umbra20RuntimeTomeGenerator14generateHeaderERNS_7ImpTomeERNS0_6ResultEPKS3_: __ZN5Umbra20RuntimeTomeGenerator14generateHeaderERNS_7ImpTomeERNS0_6ResultEPKS3_, __ZN8Material33ReleaseAllMaterialsPropertySheetsEv: __ZN8Material33ReleaseAllMaterialsPropertySheetsEv, __ZN5physx3Cct17CapsuleController11setUserDataEPv: __ZN5physx3Cct17CapsuleController11setUserDataEPv, __ZN6prcoreL26RemapGenericFloatToIntegerI16TexFormatRGFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI16TexFormatRGFloat17TexFormatARGB8888EEvPKNS_9InnerInfoE, __Z45BuoyancyEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf: __Z45BuoyancyEffector2D_Set_Custom_PropAngularDragP12Il2CppObjectf, __ZN17PolygonCollider2D8TransferI14SafeBinaryReadEEvRT_: __ZN17PolygonCollider2D8TransferI14SafeBinaryReadEEvRT_, __ZN2UI13RectTransform10SmartResetEv: __ZN2UI13RectTransform10SmartResetEv, __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEjc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6insertENS_11__wrap_iterIPKcEEjc, __ZN18BlockRangeInternal25GetSizeFromLastBlockRangeEP10BlockRangej: __ZN18BlockRangeInternal25GetSizeFromLastBlockRangeEP10BlockRangej, _UNITY_png_set_gamma: _UNITY_png_set_gamma, __Z27Mesh_CUSTOM_Internal_CreateP12Il2CppObject: __Z27Mesh_CUSTOM_Internal_CreateP12Il2CppObject, __Z26SkinVerticesGenericMathLibILi2ELb1ELb0EEvPKhiiiiPhiPKvS4_: __Z26SkinVerticesGenericMathLibILi2ELb1ELb0EEvPKhiiiiPhiPKvS4_, __ZN8GUIStyle14GetGUIClipRectEv: __ZN8GUIStyle14GetGUIClipRectEv, __ZN9JSONWrite27TransferStringToCurrentNodeEPKc: __ZN9JSONWrite27TransferStringToCurrentNodeEPKc, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRGHalfEEvPKNS_9InnerInfoE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj90ENS_22PxRepXPropertyAccessorILj90ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxArticulationEEEE14handleAccessorILj90ENS_22PxRepXPropertyAccessorILj90ES4_ffEEEEvRKT0_, __ZN9Texture3D8TransferI14SafeBinaryReadEEvRT_: __ZN9Texture3D8TransferI14SafeBinaryReadEEvRT_, __ZN5physxL23PxcSweepSphereTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf: __ZN5physxL23PxcSweepSphereTrianglesERKNS_11PxsCCDShapeES2_RKNS_11PxTransformES5_S5_S5_fRNS_6PxVec3ES7_RNS_10PxcNpCacheERNS_18PxcNpThreadContextERKNS_2Cm23FastVertex2ShapeScalingERNS_2Gu9TriangleVEf, __ZN5physx18NpArticulationLink17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx18NpArticulationLink17resolveReferencesERNS_24PxDeserializationContextE, __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_RKNS_6bitsetILj66EEE: __ZN7mecanim5human13HumanPoseCopyERNS0_9HumanPoseERKS1_RKNS_6bitsetILj66EEE, __ZL45FrustumAndOcculusionCullLocalLightsCombineJobP21LocalLightCullJobData: __ZL45FrustumAndOcculusionCullLocalLightsCombineJobP21LocalLightCullJobData, __ZN5physx3Cct13BoxController11setUserDataEPv: __ZN5physx3Cct13BoxController11setUserDataEPv, __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_: __ZNSt3__26__sortIRN10vector_mapIi22ParticleModulePropertyNS_4lessIiEENS_9allocatorINS_4pairIiS2_EEEEE13value_compareEPS7_EEvT0_SD_T_, __Z42Register_UnityEngine_Joint_get_breakTorquev: __Z42Register_UnityEngine_Joint_get_breakTorquev, __ZNK15TerrainRenderer17CreateMeshPatchesER13dynamic_arrayIP4MeshLj4EE: __ZNK15TerrainRenderer17CreateMeshPatchesER13dynamic_arrayIP4MeshLj4EE, __ZN21OverlapCapsuleQuery2DC2ERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DR13dynamic_arrayIPS5_Lj4EE: __ZN21OverlapCapsuleQuery2DC2ERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfiffPK10Collider2DR13dynamic_arrayIPS5_Lj4EE, __ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc: __ZN12AudioManager18ValidateFMODResultE11FMOD_RESULTPKc, __ZN24dtObstacleAvoidanceQuery10addCapsuleEPKfS1_S1_S1_: __ZN24dtObstacleAvoidanceQuery10addCapsuleEPKfS1_S1_S1_, __ZN8keywords20GetTotalKeywordCountEv: __ZN8keywords20GetTotalKeywordCountEv, __ZN9InputAxis6UpdateEv: __ZN9InputAxis6UpdateEv, __Z33Material_CUSTOM_SetColorArrayImplP12Il2CppObjectiP11Il2CppArray: __Z33Material_CUSTOM_SetColorArrayImplP12Il2CppObjectiP11Il2CppArray, __ZN11DynamicMesh7ReserveEii: __ZN11DynamicMesh7ReserveEii, __ZN20dynamic_block_vectorI14FileIdentifierE6resizeEj: __ZN20dynamic_block_vectorI14FileIdentifierE6resizeEj, __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI9JSONWrite8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN2UI11BreaksBatchERKNS_23RenderableUIInstructionES2_: __ZN2UI11BreaksBatchERKNS_23RenderableUIInstructionES2_, __ZZN23CloudWebServicesManagerC1E10MemLabelId18ObjectCreationModeEN39EarlyUpdateCloudWebServicesUpdatestruct7ForwardEv: __ZZN23CloudWebServicesManagerC1E10MemLabelId18ObjectCreationModeEN39EarlyUpdateCloudWebServicesUpdatestruct7ForwardEv, __ZN20UnityConnectSettingsD2Ev: __ZN20UnityConnectSettingsD2Ev, __ZN5physx3Scb5Scene13isUpdatingPvdEv: __ZN5physx3Scb5Scene13isUpdatingPvdEv, __ZN5physx2Sc8ClothSimD0Ev: __ZN5physx2Sc8ClothSimD0Ev, __Z38getPxVehicleDriveDynDataMGearUpPressedPKN5physx21PxVehicleDriveDynDataE: __Z38getPxVehicleDriveDynDataMGearUpPressedPKN5physx21PxVehicleDriveDynDataE, __ZNK15Lz4Decompressor7GetTypeEv: __ZNK15Lz4Decompressor7GetTypeEv, __ZNK13RenderTexture12GetDataWidthEv: __ZNK13RenderTexture12GetDataWidthEv, __ZN20OcclusionCullingData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN20OcclusionCullingData23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN15CapsuleColliderC2E10MemLabelId18ObjectCreationMode: __ZN15CapsuleColliderC2E10MemLabelId18ObjectCreationMode, __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI17RemapPPtrTransfer10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet: __Z18FillParamsBaseGLESjR20GpuProgramParametersP16PropertyNamesSet, __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv: __ZN15dense_hashtableINSt3__24pairIKN9ShaderLab7Program23ShaderKeywordSetAndHashEPKNS2_10SubProgramEEES4_NS3_24ShaderKeywordHashFunctorEN14dense_hash_mapIS4_S8_SA_NS0_8equal_toIS4_EE13stl_allocatorIS9_L18MemLabelIdentifier65ELi16EEE9SelectKeyESD_SG_E12maybe_shrinkEv, __ZN5physx2Sq16BucketPrunerCore9addObjectERKNS0_13PrunerPayloadERKNS_9PxBounds3E: __ZN5physx2Sq16BucketPrunerCore9addObjectERKNS0_13PrunerPayloadERKNS_9PxBounds3E, __Z56Register_UnityEngine_Terrain_get_treeMaximumFullLODCountv: __Z56Register_UnityEngine_Terrain_get_treeMaximumFullLODCountv, __ZN14RenderSettings15SetAmbientProbeERK20SphericalHarmonicsL2: __ZN14RenderSettings15SetAmbientProbeERK20SphericalHarmonicsL2, _UNITY_FT_Property_Get: _UNITY_FT_Property_Get, __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN14DirectorPlayer23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5Light9SetCookieEP7Texture: __ZN5Light9SetCookieEP7Texture, __ZN15TerrainRenderer23FindNeighborAndRendererER12QuadTreeNodeiRPS_: __ZN15TerrainRenderer23FindNeighborAndRendererER12QuadTreeNodeiRPS_, __Z40Camera_Get_Custom_PropLayerCullDistancesP12Il2CppObject: __Z40Camera_Get_Custom_PropLayerCullDistancesP12Il2CppObject, __ZN5physx7Cooking17createHeightFieldERKNS_17PxHeightFieldDescERNS_26PxPhysicsInsertionCallbackE: __ZN5physx7Cooking17createHeightFieldERKNS_17PxHeightFieldDescERNS_26PxPhysicsInsertionCallbackE, __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx: __ZN17PersistentManager30GetInstanceIDFromPathAndFileIDERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEx, __ZN11ShapeModuleD0Ev: __ZN11ShapeModuleD0Ev, __ZN13TriggerModule8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13TriggerModule8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z50Register_UnityEngine_Renderer_get_sortingLayerNamev: __Z50Register_UnityEngine_Renderer_get_sortingLayerNamev, __ZN5physx2Gu17rayAABBIntersect2ERKNS_6PxVec3ES3_S3_S3_RS1_Rf: __ZN5physx2Gu17rayAABBIntersect2ERKNS_6PxVec3ES3_S3_S3_RS1_Rf, __ZN8Animator16GetDeltaRotationEv: __ZN8Animator16GetDeltaRotationEv, __ZN7mecanim23DestroyValueArrayWeightEPNS_16ValueArrayWeightERNS_6memory9AllocatorE: __ZN7mecanim23DestroyValueArrayWeightEPNS_16ValueArrayWeightERNS_6memory9AllocatorE, __Z44Register_UnityEngine_Terrain_set_castShadowsv: __Z44Register_UnityEngine_Terrain_set_castShadowsv, __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsInTransitionInternalv: __Z92Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_IsInTransitionInternalv, __Z45Register_UnityEngine_GUIStyle_set_fixedHeightv: __Z45Register_UnityEngine_GUIStyle_set_fixedHeightv, __GLOBAL__sub_I_GfxDeviceNull_cpp: __GLOBAL__sub_I_GfxDeviceNull_cpp, __Z35AudioSource_Set_Custom_PropPriorityP12Il2CppObjecti: __Z35AudioSource_Set_Custom_PropPriorityP12Il2CppObjecti, __ZN4FMOD6SoundI17set3DConeSettingsEfff: __ZN4FMOD6SoundI17set3DConeSettingsEfff, __ZN22BlockMemoryCacheWriterD0Ev: __ZN22BlockMemoryCacheWriterD0Ev, __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN5Unity17ConfigurableJoint23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z54Register_UnityEngine_AudioListener_GetOutputDataHelperv: __Z54Register_UnityEngine_AudioListener_GetOutputDataHelperv, __Z43Register_UnityEngine_Sprite_get_packingModev: __Z43Register_UnityEngine_Sprite_get_packingModev, __ZNK5physx9PxD6Joint19getConcreteTypeNameEv: __ZNK5physx9PxD6Joint19getConcreteTypeNameEv, __Z78Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsDeprecatedv: __Z78Register_UnityEngine_ParticleSystemExtensionsImpl_GetCollisionEventsDeprecatedv, __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI8Vector2fEEvRT_PKc17TransferMetaFlags, __Z13RegisterClassI15NavMeshObstacleEvv: __Z13RegisterClassI15NavMeshObstacleEvv, __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayPvPy: __ZN20LocalFileSystemPosix5WriteER13FileEntryDatayPvPy, __ZN11NamedObject7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11NamedObject7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN12AudioManager26SetDefaultMicrophoneDriverEP9FMOD_GUID: __ZN12AudioManager26SetDefaultMicrophoneDriverEP9FMOD_GUID, __Z30Skybox_Get_Custom_PropMaterialP12Il2CppObject: __Z30Skybox_Get_Custom_PropMaterialP12Il2CppObject, __Z40Register_UnityEngine_Skybox_set_materialv: __Z40Register_UnityEngine_Skybox_set_materialv, __ZN22ParticleSystemRenderer15OnDidDeleteMeshEP4Mesh: __ZN22ParticleSystemRenderer15OnDidDeleteMeshEP4Mesh, __ZN5physx8debugger14PvdMarshallingIaiE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIaiE12marshalBlockEPKhPhj, __Z45CanvasGroup_Get_Custom_PropIgnoreParentGroupsP12Il2CppObject: __Z45CanvasGroup_Get_Custom_PropIgnoreParentGroupsP12Il2CppObject, __ZN7mecanim5human9HumanPose8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim5human9HumanPose8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN18SpeedTreeWindTimesC2Ev: __ZN18SpeedTreeWindTimesC2Ev, __ZN36ExternalForcesModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN36ExternalForcesModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z53Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f: __Z53Camera_CUSTOM_INTERNAL_CALL_SetStereoProjectionMatrixP12Il2CppObject15StereoscopicEyeRK10Matrix4x4f, __Z38BillboardAsset_Set_Custom_PropMaterialP12Il2CppObjectS0_: __Z38BillboardAsset_Set_Custom_PropMaterialP12Il2CppObjectS0_, __ZN2UI17PrepareBatchesJobEPNS_21PrepareBatchesJobDataE: __ZN2UI17PrepareBatchesJobEPNS_21PrepareBatchesJobDataE, __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj: __ZN14ParticleSystem17SimulateParticlesERKS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjRKfPj, __ZL34StaticDestroyAudioSourceFilterRootPv: __ZL34StaticDestroyAudioSourceFilterRootPv, __Z33getPxVehicleDriveDynData_GearDownPKN5physx21PxVehicleDriveDynDataE: __Z33getPxVehicleDriveDynData_GearDownPKN5physx21PxVehicleDriveDynDataE, __Z51AssetBundleCreateRequest_Get_Custom_PropAssetBundleP12Il2CppObject: __Z51AssetBundleCreateRequest_Get_Custom_PropAssetBundleP12Il2CppObject, __Z39GUIClip_CUSTOM_INTERNAL_CALL_GetTopRectR5RectTIfE: __Z39GUIClip_CUSTOM_INTERNAL_CALL_GetTopRectR5RectTIfE, __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11Rigidbody2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN8BitArrayD2Ev: __ZN8BitArrayD2Ev, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetXMultiplierv, __ZN29ParticleSystemPropertyBinding46CleanupParticleSystemAnimationBindingInterfaceEv: __ZN29ParticleSystemPropertyBinding46CleanupParticleSystemAnimationBindingInterfaceEv, __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYv: __Z63Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetYv, __ZN13GfxDeviceGLES20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace: __ZN13GfxDeviceGLES20UploadTexture2DArrayE9TextureIDPKhjiii13TextureFormatij17TextureColorSpace, __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN17AudioReverbFilter23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z43Physics2D_Set_Custom_PropPositionIterationsi: __Z43Physics2D_Set_Custom_PropPositionIterationsi, __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN17AudioReverbFilter8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK2UI6Canvas19GetSortingLayerNameEv: __ZNK2UI6Canvas19GetSortingLayerNameEv, __Z31AssetBundle_CUSTOM_LoadFromFileP12Il2CppStringjy: __Z31AssetBundle_CUSTOM_LoadFromFileP12Il2CppStringjy, __ZN15dtProximityGrid13resetCellSizeEff: __ZN15dtProximityGrid13resetCellSizeEff, __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j: __ZNK5physx20PxJointGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEEEEjT_j, __Z45Register_UnityEngine_Component_get_gameObjectv: __Z45Register_UnityEngine_Component_get_gameObjectv, __ZN12NavMeshAgent26SetAutoTraverseOffMeshLinkEb: __ZN12NavMeshAgent26SetAutoTraverseOffMeshLinkEb, __ZThn32_N19SkinnedMeshRenderer19UpdateTransformInfoEv: __ZThn32_N19SkinnedMeshRenderer19UpdateTransformInfoEv, __ZN14RenderSettingsD0Ev: __ZN14RenderSettingsD0Ev, __Z24RegisterStrippedTypeInfoI9AudioClipEviPKcS2_: __Z24RegisterStrippedTypeInfoI9AudioClipEviPKcS2_, __ZN11AudioSource27SetCustomReverbZoneMixCurveERK17AnimationCurveTplIfE: __ZN11AudioSource27SetCustomReverbZoneMixCurveERK17AnimationCurveTplIfE, __Z49Register_UnityEngine_Renderer_set_lightProbeUsagev: __Z49Register_UnityEngine_Renderer_set_lightProbeUsagev, __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEENS_4lessIS6_EE13stl_allocatorIS6_L18MemLabelIdentifier37ELi16EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __Z63Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimev: __Z63Register_UnityEngine_ParticleSystem_MainModule_GetStartLifetimev, __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7releaseEv: __ZN5physx15NpActorTemplateINS_14PxRigidDynamicEE7releaseEv, __ZN5physx9NpPhysics17createRigidStaticERKNS_11PxTransformE: __ZN5physx9NpPhysics17createRigidStaticERKNS_11PxTransformE, __Z61Register_UnityEngine_Terrain_INTERNAL_set_lightmapScaleOffsetv: __Z61Register_UnityEngine_Terrain_INTERNAL_set_lightmapScaleOffsetv, __Z40Register_UnityEngine_Mesh_GetIndicesImplv: __Z40Register_UnityEngine_Mesh_GetIndicesImplv, __Z53Register_UnityEngine_RenderBufferHelper_GetLoadActionv: __Z53Register_UnityEngine_RenderBufferHelper_GetLoadActionv, __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j: __ZNK5physx27PxParticleBaseGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEEEEjT_j, __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_get_rndVelocityv: __Z61Register_UnityEngine_ParticleEmitter_INTERNAL_get_rndVelocityv, __Z23CreateSparseTextureGLES9TextureIDiiN2gl9TexFormatEi: __Z23CreateSparseTextureGLES9TextureIDiiN2gl9TexFormatEi, __ZN5physx9NpFactory7releaseEv: __ZN5physx9NpFactory7releaseEv, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE3__xEv, __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_: __ZN5physx6shdfnd8internal8HashBaseIPNS_3Scb4BaseES5_NS0_4HashIS5_EENS1_11HashSetBaseIS5_S7_NS0_9AllocatorELb1EE6GetKeyES9_Lb1EE5eraseERKS5_, __ZN5physx17ConvexMeshBuilder22computeInternalObjectsEv: __ZN5physx17ConvexMeshBuilder22computeInternalObjectsEv, __Z19RenderBasePassDepthRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERS2_I17PrePassRenderDataLj4EER17ShaderPassContext: __Z19RenderBasePassDepthRK17RenderLoopContextR13dynamic_arrayI16RenderObjectDataLj4EERS2_I17PrePassRenderDataLj4EER17ShaderPassContext, __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE: __ZNSt3__26vectorI20ComputeShaderVariantNS_9allocatorIS1_EEE26__swap_out_circular_bufferERNS_14__split_bufferIS1_RS3_EE, __Z30NavMeshAgent_CUSTOM_CopyPathToP12Il2CppObjectS0_: __Z30NavMeshAgent_CUSTOM_CopyPathToP12Il2CppObjectS0_, __Z53Register_UnityEngine_WebCamTexture_set_requestedWidthv: __Z53Register_UnityEngine_WebCamTexture_set_requestedWidthv, __ZN5physx3Scb5Scene14removeMaterialERNS_2Sc12MaterialCoreE: __ZN5physx3Scb5Scene14removeMaterialERNS_2Sc12MaterialCoreE, __Z47Register_UnityEngine_AudioReverbZone_set_reverbv: __Z47Register_UnityEngine_AudioReverbZone_set_reverbv, __ZNSt3__26vectorIP9FieldInfo13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP9FieldInfo13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN12HingeJoint2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN26EnlightenSystemInformation8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN26EnlightenSystemInformation8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN16ParticleAnimator15ThreadedCleanupEv: __ZN16ParticleAnimator15ThreadedCleanupEv, __ZN6MotionC2E10MemLabelId18ObjectCreationMode: __ZN6MotionC2E10MemLabelId18ObjectCreationMode, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine20StateMachineConstantEEEEEvRT_17TransferMetaFlags, __Z56Register_UnityEngine_Animator_INTERNAL_get_pivotPositionv: __Z56Register_UnityEngine_Animator_INTERNAL_get_pivotPositionv, __ZN6CameraD2Ev: __ZN6CameraD2Ev, __ZNKSt3__28messagesIwE3getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE: __ZNKSt3__28messagesIwE3getEiiiRKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEE, __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsAlignCanvasRectTransformWithCamerastruct7ForwardEv: __ZZN2UI23InitializeCanvasManagerEvEN48UIEventsAlignCanvasRectTransformWithCamerastruct7ForwardEv, __ZNK10FileSystem25GetApplicationManagedPathEv: __ZNK10FileSystem25GetApplicationManagedPathEv, __ZN13MonoBehaviour12AddToManagerEv: __ZN13MonoBehaviour12AddToManagerEv, __ZNSt3__23mapI4PPtrI9TransformEN7VRInput18ReferenceTransformENS_4lessIS3_EE13stl_allocatorINS_4pairIKS3_S5_EEL18MemLabelIdentifier87ELi16EEEixERSA_: __ZNSt3__23mapI4PPtrI9TransformEN7VRInput18ReferenceTransformENS_4lessIS3_EE13stl_allocatorINS_4pairIKS3_S5_EEL18MemLabelIdentifier87ELi16EEEixERSA_, __ZThn8_N12_GLOBAL__N_110ConnectionD1Ev: __ZThn8_N12_GLOBAL__N_110ConnectionD1Ev, __Z11WriteStringR13dynamic_arrayIiLj4EEPKc: __Z11WriteStringR13dynamic_arrayIiLj4EEPKc, __ZN11TimeManager13AwakeFromLoadE17AwakeFromLoadMode: __ZN11TimeManager13AwakeFromLoadE17AwakeFromLoadMode, __ZN39AssetBundleLoadFromMemoryAsyncOperation7ExecuteEPKhj: __ZN39AssetBundleLoadFromMemoryAsyncOperation7ExecuteEPKhj, __ZN12NavMeshAgent8SetSpeedEf: __ZN12NavMeshAgent8SetSpeedEf, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS5_EE13stl_allocatorIS5_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_setI4PPtrI10MonoScriptENSt3__24lessIS5_EE13stl_allocatorIS5_L18MemLabelIdentifier76ELi16EEEEEvRT_17TransferMetaFlags, __ZNK5physx2Sc18ParticleSystemCore16getParticleStateEv: __ZNK5physx2Sc18ParticleSystemCore16getParticleStateEv, __ZN5physx2Sc18ParticleSystemCoreD2Ev: __ZN5physx2Sc18ParticleSystemCoreD2Ev, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEbT0_S7_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessIN12_GLOBAL__N_114ParamNameIndexES3_EEPS3_EEbT0_S7_T_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj421ENS_22PxRepXPropertyAccessorILj421ENS_7PxJointEPKcSB_EEEEvRKT0_, __Z43NavMeshPath_CUSTOM_CalculateCornersInternalP12Il2CppObject: __Z43NavMeshPath_CUSTOM_CalculateCornersInternalP12Il2CppObject, __ZN19SpriteMeshGenerator10FindBoundsER5RectTIfE: __ZN19SpriteMeshGenerator10FindBoundsER5RectTIfE, __ZN4FMOD7SystemI12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE: __ZN4FMOD7SystemI12createStreamEPKcjP22FMOD_CREATESOUNDEXINFOPPNS_5SoundE, __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev: __ZN11UnityEngine7Connect15DeviceInfoEventD2Ev, __ZN14qsort_internal18QSortSingleJobDataIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEE7SortJobEPS5_: __ZN14qsort_internal18QSortSingleJobDataIP18RPDataMotionVectoriN22MotionVectorRenderLoop18RenderObjectSorterEE7SortJobEPS5_, __ZN20SweepCapsuleCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj: __ZN20SweepCapsuleCallback10processHitERKN5physx12PxRaycastHitERKNS0_6PxVec3ES6_S6_RfPKj, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_4BoxVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZNK23iPhoneLocalNotification29GetApplicationIconBadgeNumberEv: __ZNK23iPhoneLocalNotification29GetApplicationIconBadgeNumberEv, __ZN16b2BlockAllocator5ClearEv: __ZN16b2BlockAllocator5ClearEv, __ZN11NavMeshData17MainThreadCleanupEv: __ZN11NavMeshData17MainThreadCleanupEv, __ZNK9profiling14SamplerManager16GetSamplersNamesEv: __ZNK9profiling14SamplerManager16GetSamplersNamesEv, __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE: __ZN5physx19NpRigidBodyTemplateINS_18PxArticulationLinkEE11createShapeERKNS_10PxGeometryEPKPNS_10PxMaterialEtNS_7PxFlagsINS_11PxShapeFlag4EnumEhEE, __Z58Register_UnityEngine_ConfigurableJoint_get_projectionAnglev: __Z58Register_UnityEngine_ConfigurableJoint_get_projectionAnglev, __Z6simd4iRKi: __Z6simd4iRKi, __ZN21AnimationClipPlayable7GetTypeEv: __ZN21AnimationClipPlayable7GetTypeEv, __Z31Rigidbody2D_Set_Custom_PropDragP12Il2CppObjectf: __Z31Rigidbody2D_Set_Custom_PropDragP12Il2CppObjectf, __ZNSt9bad_allocC2Ev: __ZNSt9bad_allocC2Ev, __ZN5Umbra11PatchReaderC2Ev: __ZN5Umbra11PatchReaderC2Ev, __ZThn4_N5physx5cloth8SwSolver25setInterCollisionDistanceEf: __ZThn4_N5physx5cloth8SwSolver25setInterCollisionDistanceEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj580ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleWheelDataEEEEclILj580ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim9animation16ControllerMemory8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim9animation16ControllerMemory8TransferI24GenerateTypeTreeTransferEEvRT_, __Z35setPxSceneDescContactModifyCallbackPN5physx11PxSceneDescEPNS_23PxContactModifyCallbackE: __Z35setPxSceneDescContactModifyCallbackPN5physx11PxSceneDescEPNS_23PxContactModifyCallbackE, __ZN12AudioManager8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN12AudioManager8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Sc24ElementInteractionMarker7destroyEv: __ZN5physx2Sc24ElementInteractionMarker7destroyEv, __ZL50UnityAudioEffect_InternalGetFloatParameterCallbackP14FMOD_DSP_STATEiPfPc: __ZL50UnityAudioEffect_InternalGetFloatParameterCallbackP14FMOD_DSP_STATEiPfPc, __Z48getPxArticulationJoint_SwingLimitContactDistancePKN5physx19PxArticulationJointE: __Z48getPxArticulationJoint_SwingLimitContactDistancePKN5physx19PxArticulationJointE, __Z29GUI_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf: __Z29GUI_CUSTOM_INTERNAL_set_colorRK10ColorRGBAf, __ZNK20TextRenderingPrivate8TextMesh26GetTypeInfoVirtualInternalEv: __ZNK20TextRenderingPrivate8TextMesh26GetTypeInfoVirtualInternalEv, __Z36Register_UnityEngine_Input_GetKeyIntv: __Z36Register_UnityEngine_Input_GetKeyIntv, __ZNK5Umbra10Visibility17getOutputClustersEv: __ZNK5Umbra10Visibility17getOutputClustersEv, __ZNK8LODGroup10HasEnabledEv: __ZNK8LODGroup10HasEnabledEv, __Z57Register_UnityEngine_Camera_INTERNAL_get_projectionMatrixv: __Z57Register_UnityEngine_Camera_INTERNAL_get_projectionMatrixv, __ZN4FMOD6System20set3DSpeakerPositionE12FMOD_SPEAKERffb: __ZN4FMOD6System20set3DSpeakerPositionE12FMOD_SPEAKERffb, __Z53Register_UnityEngine_ParticleSystem_Internal_Simulatev: __Z53Register_UnityEngine_ParticleSystem_Internal_Simulatev, __Z24RegisterStrippedTypeInfoI11PreloadDataEviPKcS2_: __Z24RegisterStrippedTypeInfoI11PreloadDataEviPKcS2_, __ZN8Animator8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8Animator8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z26getPxHeightFieldDescNbRowsPKN5physx17PxHeightFieldDescE: __Z26getPxHeightFieldDescNbRowsPKN5physx17PxHeightFieldDescE, __Z15AddLoopingFrameI8Vector3fEvR17AnimationCurveTplIT_Ef: __Z15AddLoopingFrameI8Vector3fEvR17AnimationCurveTplIT_Ef, __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreav: __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapAreav, _tt_cmap2_char_index: _tt_cmap2_char_index, __Z19SetGlobalPreferencePKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z19SetGlobalPreferencePKcRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN22ParticleSystemRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN22ParticleSystemRenderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN16StreamedResourceeqERKS_: __ZN16StreamedResourceeqERKS_, __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_xDrivev: __Z58Register_UnityEngine_ConfigurableJoint_INTERNAL_set_xDrivev, __ZN13CameraLODData13RemoveAtIndexEj: __ZN13CameraLODData13RemoveAtIndexEj, __ZN11AudioModule13GetNumDevicesEv: __ZN11AudioModule13GetNumDevicesEv, __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI6CameraE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv: __ZN5physx6shdfnd10ThreadImpl15quitIsSignalledEv, __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass: __ZN15DirectorManager29CacheScriptingMethodsForClassEP11Il2CppClass, __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f: __ZNK15CapsuleCollider16GetGlobalExtentsERK8Vector3f, __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16SubstanceArchive23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN5physx18NpArticulationLink8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb: __ZN5physx18NpArticulationLink8addForceERKNS_6PxVec3ENS_11PxForceMode4EnumEb, __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityv: __Z91Register_UnityEngine_Rigidbody2D_INTERNAL_CALL_Rigidbody2D_CUSTOM_INTERNAL_GetPointVelocityv, __ZN13TranslateGLES14InitVertexTypeERK12GraphicsCaps16GfxDeviceLevelGL: __ZN13TranslateGLES14InitVertexTypeERK12GraphicsCaps16GfxDeviceLevelGL, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxDistanceJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZNK5physx18PxArticulationLink19getConcreteTypeNameEv: __ZNK5physx18PxArticulationLink19getConcreteTypeNameEv, __ZN27ForceModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN27ForceModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN13TargetJoint2DC2E10MemLabelId18ObjectCreationMode: __ZN13TargetJoint2DC2E10MemLabelId18ObjectCreationMode, _jpeg_fdct_islow: _jpeg_fdct_islow, __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalMatrixiRK10Matrix4x4f: __Z43Shader_CUSTOM_INTERNAL_CALL_SetGlobalMatrixiRK10Matrix4x4f, __Z27getPxJoint_InvInertiaScale0PKN5physx7PxJointE: __Z27getPxJoint_InvInertiaScale0PKN5physx7PxJointE, __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI19StreamedBinaryWriteILb0EE8Vector4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode: __ZN13MonoBehaviourC2E10MemLabelId18ObjectCreationMode, __Z43ParticleSystem_LightsModule_CUSTOM_SetRatioP12Il2CppObjectf: __Z43ParticleSystem_LightsModule_CUSTOM_SetRatioP12Il2CppObjectf, __ZN5physx35integrateNoDriveWheelRotationAnglesEfPKfS1_S1_PKbRKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE: __ZN5physx35integrateNoDriveWheelRotationAnglesEfPKfS1_S1_PKbRKNS_23PxVehicleWheels4SimDataERNS_23PxVehicleWheels4DynDataE, __Z18CanRemoveComponentRN5Unity9ComponentEPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __Z18CanRemoveComponentRN5Unity9ComponentEPNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN4File13SetFileLengthEy: __ZN4File13SetFileLengthEy, __ZN8b2Island8SolveTOIERK10b2TimeStepii: __ZN8b2Island8SolveTOIERK10b2TimeStepii, __ZNKSt3__27codecvtIwc11__mbstate_tE11do_encodingEv: __ZNKSt3__27codecvtIwc11__mbstate_tE11do_encodingEv, __Z33TextMesh_Set_Custom_PropAlignmentP12Il2CppObjecti: __Z33TextMesh_Set_Custom_PropAlignmentP12Il2CppObjecti, __Z48Register_UnityEngine_Input_set_compensateSensorsv: __Z48Register_UnityEngine_Input_set_compensateSensorsv, _sfnt_table_info: _sfnt_table_info, __ZN30RotationModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN30RotationModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __Z50Register_UnityEngine_AndroidJNI_SetIntArrayElementv: __Z50Register_UnityEngine_AndroidJNI_SetIntArrayElementv, __Z24AudioClip_CUSTOM_GetDataP12Il2CppObjectP11Il2CppArrayi: __Z24AudioClip_CUSTOM_GetDataP12Il2CppObjectP11Il2CppArrayi, __ZL12InvokeMethodI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL12InvokeMethodI18StreamedBinaryReadILb1EEEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z35Register_UnityEngine_Light_get_typev: __Z35Register_UnityEngine_Light_get_typev, __ZThn4_N5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_: __ZThn4_N5physx5cloth9SwFactory12createFabricEjNS0_5RangeIKjEES4_NS2_IKfEES4_S4_S6_, __ZThn4_N12_GLOBAL__N_110DataStreamD0Ev: __ZThn4_N12_GLOBAL__N_110DataStreamD0Ev, __ZN18AwakeFromLoadQueue7ReserveEj: __ZN18AwakeFromLoadQueue7ReserveEj, _strcasecmp: _strcasecmp, __Z27compute_intervals_isectlinePfS_S_ffffffffS_S_S_S_: __Z27compute_intervals_isectlinePfS_S_ffffffffS_S_S_S_, __ZN26AnimatorOverrideController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN26AnimatorOverrideController23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN4Mesh15CopyTransformedERKS_RK10Matrix4x4f: __ZN4Mesh15CopyTransformedERKS_RK10Matrix4x4f, __ZN14AreaEffector2DC2E10MemLabelId18ObjectCreationMode: __ZN14AreaEffector2DC2E10MemLabelId18ObjectCreationMode, __ZNK30SpriteRendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE: __ZNK30SpriteRendererAnimationBinding13GetFloatValueERKN11UnityEngine9Animation10BoundCurveE, __ZN5physx10PxsContext30secondPassUpdateContactManagerEfPNS_25NarrowPhaseContactManagerEjPNS_10PxBaseTaskE: __ZN5physx10PxsContext30secondPassUpdateContactManagerEfPNS_25NarrowPhaseContactManagerEjPNS_10PxBaseTaskE, __ZN12TextureInput32CheckFor16bOrGrayscaleConversionEbbi: __ZN12TextureInput32CheckFor16bOrGrayscaleConversionEbbi, __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_65kDidDeleteMotion4CallEPviR11MessageData: __ZZN26AnimatorOverrideController15InitializeClassEvEN30FunctorImpl_65kDidDeleteMotion4CallEPviR11MessageData, __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6insertINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueESA_E4typeENS8_IPKS2_EESC_SC_: __ZNSt3__26vectorIN11DynamicMesh10DetailHullE13stl_allocatorIS2_L18MemLabelIdentifier1ELi16EEE6insertINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueESA_E4typeENS8_IPKS2_EESC_SC_, __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10Effector2D8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN2UI14CanvasRenderer10SetTextureEP7Texture: __ZN2UI14CanvasRenderer10SetTextureEP7Texture, __Z46Register_UnityEngine_BillboardAsset_get_bottomv: __Z46Register_UnityEngine_BillboardAsset_get_bottomv, __ZNK14ParticleSystem25GetSafeCollisionEventSizeEv: __ZNK14ParticleSystem25GetSafeCollisionEventSizeEv, _XXH32_update: _XXH32_update, __ZNK22LocalFileSystemHandler20GetUserAppDataFolderEv: __ZNK22LocalFileSystemHandler20GetUserAppDataFolderEv, __ZNK20b2SeparationFunction8EvaluateEiif: __ZNK20b2SeparationFunction8EvaluateEiif, __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteDoubleEd: __ZN9rapidjson6WriterI16TempBufferWriterNS_4UTF8IcEES3_13JSONAllocatorE11WriteDoubleEd, __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbRK16MeshTriangleDataS3_EPS1_EEvT0_S8_T_, __ZN10GUITexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN10GUITexture8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _nearbyintf: _nearbyintf, __Z23PlayerCleanupCachedDatav: __Z23PlayerCleanupCachedDatav, __Z61Register_UnityEngine_Renderer_INTERNAL_get_localToWorldMatrixv: __Z61Register_UnityEngine_Renderer_INTERNAL_get_localToWorldMatrixv, _nearbyintl: _nearbyintl, __ZN22UnityAnalyticsSettings10InitializeER6Object: __ZN22UnityAnalyticsSettings10InitializeER6Object, __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_: __ZN14ParticleSystem33UpdateLocalToWorldMatrixAndScalesERK9TransformR10Matrix4x4fR10Matrix3x3fR8Vector3fS8_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxParticleSystemEE12readPropertyIfEEbRT_, __Z34GameObject_Set_Custom_PropIsStaticP12Il2CppObjecth: __Z34GameObject_Set_Custom_PropIsStaticP12Il2CppObjecth, __ZN23TransformChangeDispatch15InitializeClassEv: __ZN23TransformChangeDispatch15InitializeClassEv, __ZN8GUIStyle8TransferI9JSONWriteEEvRT_: __ZN8GUIStyle8TransferI9JSONWriteEEvRT_, __ZN8LODGroupD2Ev: __ZN8LODGroupD2Ev, __ZNK5physx9NpPhysics11getNbScenesEv: __ZNK5physx9NpPhysics11getNbScenesEv, __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv: __ZN5physx22NpRigidStaticGetShapesERNS_3Scb11RigidStaticERPKPv, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS1_9allocatorIS3_EEEEEEvRT_17TransferMetaFlags, __ZN5Unity10HingeJoint8TransferI14SafeBinaryReadEEvRT_: __ZN5Unity10HingeJoint8TransferI14SafeBinaryReadEEvRT_, __ZN13SparseTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN13SparseTexture8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17resolveReferencesERNS_24PxDeserializationContextE, __ZN5Light17RemoveFromManagerEv: __ZN5Light17RemoveFromManagerEv, __ZN19CharacterController10SmartResetEv: __ZN19CharacterController10SmartResetEv, __ZN3MBP14findOverlapsMTEPKj: __ZN3MBP14findOverlapsMTEPKj, __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer19TransferSTLStyleMapINSt3__28multimapI8UnityStrN11AssetBundle9AssetInfoENS1_4lessIS3_EENS1_9allocatorINS1_4pairIKS3_S5_EEEEEEEEvRT_17TransferMetaFlags, __Z31CalculateInverseLerpOffsetScaleRK8Vector2f: __Z31CalculateInverseLerpOffsetScaleRK8Vector2f, __ZNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI21ScriptingMethodIl2Cpp13stl_allocatorIS1_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadsEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadsEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, _jinit_inverse_dct: _jinit_inverse_dct, __ZNK5physx2Sc15ClothFabricCore15getNbRestvaluesEv: __ZNK5physx2Sc15ClothFabricCore15getNbRestvaluesEv, __ZN13MemoryManager23GetTotalAllocatedMemoryEv: __ZN13MemoryManager23GetTotalAllocatedMemoryEv, __ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw: __ZNSt3__29__num_getIwE19__stage2_float_loopEwRbRcPcRS4_wwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPjRSE_RjPw, __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI6ObjectE8TransferI14SafeBinaryReadEEvRT_, __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterSystemv: __Z73Register_UnityEngine_ParticleSystem_SubEmittersModule_GetSubEmitterSystemv, __ZN11LightProbes8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11LightProbes8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu21computeEdgeEdgeNormalERNS_6PxVec3ERKS1_S4_S4_S4_S4_f: __ZN5physx2Gu21computeEdgeEdgeNormalERNS_6PxVec3ERKS1_S4_S4_S4_S4_f, __Z42Register_UnityEngine_TextMesh_set_fontSizev: __Z42Register_UnityEngine_TextMesh_set_fontSizev, __ZN8Animator20GotoStateInFixedTimeEiifff: __ZN8Animator20GotoStateInFixedTimeEiifff, __ZN5physx2Sn13XmlNodeReaderD0Ev: __ZN5physx2Sn13XmlNodeReaderD0Ev, __ZN7mecanim9animation21DestroyBlendTreeInputEPNS0_14BlendTreeInputERNS_6memory9AllocatorE: __ZN7mecanim9animation21DestroyBlendTreeInputEPNS0_14BlendTreeInputERNS_6memory9AllocatorE, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS5_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS3_IjjEENS_2Sn17SerialObjectIndexEEES4_NS0_4HashIS4_EENS1_11HashMapBaseIS4_S7_SA_NS0_9AllocatorEE6GetKeyESC_Lb1EE6createERS5_Rb, __ZN9Scripting42GetScriptingWrapperOfComponentOfGameObjectER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE: __ZN9Scripting42GetScriptingWrapperOfComponentOfGameObjectER10GameObjectRKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEE, __ZN11NoiseModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11NoiseModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE19__get_short_pointerEv, __ZThn8_N5physx13NpClothFabric14onRefCountZeroEv: __ZThn8_N5physx13NpClothFabric14onRefCountZeroEv, __ZN23PreloadManagerOperation19IntegrateTimeSlicedEi: __ZN23PreloadManagerOperation19IntegrateTimeSlicedEi, __ZN5Umbra9Matrix4x49transposeEv: __ZN5Umbra9Matrix4x49transposeEv, __ZNKSt3__210moneypunctIwLb1EE8groupingEv: __ZNKSt3__210moneypunctIwLb1EE8groupingEv, __ZN5physx23PxsBroadPhaseContextSap9updatePPUEPNS_10PxBaseTaskE: __ZN5physx23PxsBroadPhaseContextSap9updatePPUEPNS_10PxBaseTaskE, __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev: __ZNSt3__29money_putIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEED0Ev, __ZN15LODGroupManager16CalculateLODFadeEjhf: __ZN15LODGroupManager16CalculateLODFadeEjhf, __ZNK9TextAsset26GetTypeInfoVirtualInternalEv: __ZNK9TextAsset26GetTypeInfoVirtualInternalEv, __ZN15AudioReverbZone16ChangePropertiesEv: __ZN15AudioReverbZone16ChangePropertiesEv, __Z37GL_CUSTOM_INTERNAL_CALL_MultiTexCoordiRK8Vector3f: __Z37GL_CUSTOM_INTERNAL_CALL_MultiTexCoordiRK8Vector3f, _cf2_freeSeacComponent: _cf2_freeSeacComponent, __Z31Texture_Get_Custom_PropWrapModeP12Il2CppObject: __Z31Texture_Get_Custom_PropWrapModeP12Il2CppObject, __Z44Register_UnityEngine_RemoteSettings_GetFloatv: __Z44Register_UnityEngine_RemoteSettings_GetFloatv, __ZN27TrailModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN27TrailModulePropertyBindings13SetFloatValueER14ParticleSystemif, __Z48Register_UnityEngine_Animator_ResetTriggerStringv: __Z48Register_UnityEngine_Animator_ResetTriggerStringv, __Z50Camera_CUSTOM_INTERNAL_CALL_ResetReplacementShaderP12Il2CppObject: __Z50Camera_CUSTOM_INTERNAL_CALL_ResetReplacementShaderP12Il2CppObject, __Z64Register_UnityEngine_RenderSettings_INTERNAL_set_ambientSkyColorv: __Z64Register_UnityEngine_RenderSettings_INTERNAL_set_ambientSkyColorv, __ZN4FMOD7Channel13getAudibilityEPf: __ZN4FMOD7Channel13getAudibilityEPf, __Z17InstantiateObjectR6ObjectP9TransformRK8Vector3fRK11QuaternionfR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINSA_4pairIiiEEL18MemLabelIdentifier1ELi16EEE: __Z17InstantiateObjectR6ObjectP9TransformRK8Vector3fRK11QuaternionfR10vector_mapIiiNSt3__24lessIiEE13stl_allocatorINSA_4pairIiiEEL18MemLabelIdentifier1ELi16EEE, __Z39UnityAdsSettings_Get_Custom_PropEnabledv: __Z39UnityAdsSettings_Get_Custom_PropEnabledv, __ZN13WheelCollider16TransformChangedEi: __ZN13WheelCollider16TransformChangedEi, __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIPNS_11PxAggregateENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __ZNK13Lz4Compressor20CompressStreamDeinitEPv: __ZNK13Lz4Compressor20CompressStreamDeinitEPv, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEES9_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5eraseENS_11__wrap_iterIPKwEES9_, __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf: __ZNK4Mesh17ExtractColorArrayEP10ColorRGBAf, __ZNK13AnimationClip13IsHumanMotionEv: __ZNK13AnimationClip13IsHumanMotionEv, __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb: __ZN15LODGroupManager16CalculateLODMaskERKNS_12LODGroupDescEfjhfPhPfRb, __ZN9CoroutineC2Ev: __ZN9CoroutineC2Ev, __ZN9b2Simplex6Solve2Ev: __ZN9b2Simplex6Solve2Ev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6__initEjw, __Z38Material_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_: __Z38Material_CUSTOM_GetMatrixArrayImplListP12Il2CppObjectiS0_, __ZN5physx6shdfnd5ArrayIPNS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc13ConstraintSimENS0_19ReflectionAllocatorIS4_EEE15growAndPushBackERKS4_, __ZN17MemoryCacheReaderD0Ev: __ZN17MemoryCacheReaderD0Ev, __ZN12MeshCollider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN12MeshCollider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6cbeginEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6cbeginEv, __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_16PxVehicleDrive4WEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb0EEEEEvPT_: __ZNSt3__26locale5__imp7installINS_17moneypunct_bynameIwLb0EEEEEvPT_, __Z22RandomBarycentricCoordR5RandN: __Z22RandomBarycentricCoordR5RandN, __Z38AudioSource_Get_Custom_PropMinDistanceP12Il2CppObject: __Z38AudioSource_Get_Custom_PropMinDistanceP12Il2CppObject, __ZN5physx18PxVehicleDriveTankC2Ev: __ZN5physx18PxVehicleDriveTankC2Ev, __ZNK5physx13PxClothFabric19getConcreteTypeNameEv: __ZNK5physx13PxClothFabric19getConcreteTypeNameEv, _tre_stack_push: _tre_stack_push, __Z38Rigidbody_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf: __Z38Rigidbody_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf, __Z53Register_UnityEngine_CanvasRenderer_get_relativeDepthv: __Z53Register_UnityEngine_CanvasRenderer_get_relativeDepthv, _calloc: _calloc, __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetMinVertexDistancev: __Z68Register_UnityEngine_ParticleSystem_TrailModule_GetMinVertexDistancev, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE4copyINS0_15InlineAllocatorILj256ES5_EEEEvRKNS1_IS2_T_EE, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE16do_get_monthnameES4_S4_RNS_8ios_baseERjP2tm, __ZNK14ParticleSystem27GetSafeTriggerParticlesSizeEN13TriggerEvents9EventTypeE: __ZNK14ParticleSystem27GetSafeTriggerParticlesSizeEN13TriggerEvents9EventTypeE, __ZN4FMOD7Channel6addDSPEPNS_3DSPEPPNS_13DSPConnectionE: __ZN4FMOD7Channel6addDSPEPNS_3DSPEPPNS_13DSPConnectionE, __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE: __ZN5physx2Sc16InteractionScene26notifyInteractionActivatedEPNS0_11InteractionE, __ZN13PhysicsModule28GetCollisionShapeForColliderEPKN5Unity9ComponentERN8IPhysics13ColliderShapeE: __ZN13PhysicsModule28GetCollisionShapeForColliderEPKN5Unity9ComponentERN8IPhysics13ColliderShapeE, __ZN16GraphicsSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN16GraphicsSettings23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI14SafeBinaryRead10RectOffsetLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle: __ZNK10DynamicVBO13IsHandleValidERK21DynamicVBOChunkHandle, __ZNK22ParticleSystemRenderer26GetTypeInfoVirtualInternalEv: __ZNK22ParticleSystemRenderer26GetTypeInfoVirtualInternalEv, __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE: __ZN5physx17PxsFluidCollision26updateFluidBodyContactPairEPKNS_16PxsFluidParticleEjPNS_19PxsParticleCollDataERNS_25PxsFluidConstraintBuffersEPNS_27PxsFluidParticleOpcodeCacheERNS_21PxsFluidLocalCellHashERKNS_6PxVec3ERKNS_31PxsParticleStreamContactManagerERKNS_19PxsW2STransformTempE, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx13NpRigidStatic13setGlobalPoseERKNS_11PxTransformEb: __ZN5physx13NpRigidStatic13setGlobalPoseERKNS_11PxTransformEb, __ZN5physx2Cm18visualizeLimitConeERNS0_12RenderOutputEfRKNS_11PxTransformEffb: __ZN5physx2Cm18visualizeLimitConeERNS0_12RenderOutputEfRKNS_11PxTransformEffb, __ZNK5physx2Sc18ParticleSystemCore14getParticleMapEv: __ZNK5physx2Sc18ParticleSystemCore14getParticleMapEv, stackAlloc: stackAlloc, __ZN5physx3Cct15userHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef: __ZN5physx3Cct15userHitCallbackEPKNS0_20InternalCBData_OnHitERKNS0_12SweptContactERKNS_6PxVec3Ef, __Z29StdTemplateConversionFunctionIssEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIssEbPvR14SafeBinaryRead, __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE19TransferSTLStyleMapINSt3__23mapI8UnityStriNS2_4lessIS4_EENS2_9allocatorINS2_4pairIKS4_iEEEEEEEEvRT_17TransferMetaFlags, __ZN16PlayerConnection25CreateAndReportConnectionEi: __ZN16PlayerConnection25CreateAndReportConnectionEi, __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEEEEjT_j: __ZNK5physx30PxHeightFieldDescGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEEEEjT_j, __ZN5physx9NpPhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableEbPNS_20PxProfileZoneManagerE: __ZN5physx9NpPhysicsC2ERKNS_17PxTolerancesScaleERKNS_14PxvOffsetTableEbPNS_20PxProfileZoneManagerE, __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_6__lessIddEEPdEEjT0_S5_S5_S5_S5_T_, _tlsf_realloc: _tlsf_realloc, __ZN4Mesh16GetSkinInfluenceEi: __ZN4Mesh16GetSkinInfluenceEi, __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_18PxVehicleDriveTankEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN10GpuProgramC2Ev: __ZN10GpuProgramC2Ev, __Z55Terrain_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f: __Z55Terrain_CUSTOM_INTERNAL_set_realtimeLightmapScaleOffsetP12Il2CppObjectRK8Vector4f, __Z29Register_UnityEngine_GL_Flushv: __Z29Register_UnityEngine_GL_Flushv, __ZNK5physx3Cct17CapsuleController11getUserDataEv: __ZNK5physx3Cct17CapsuleController11getUserDataEv, __ZN19SharedBillboardDataC2ERK10MemLabelId: __ZN19SharedBillboardDataC2ERK10MemLabelId, __Z13RegisterClassI12ScriptMapperEvv: __Z13RegisterClassI12ScriptMapperEvv, __ZN11UnityEngine15CloudWebService14RestDownloader13OnReceiveDataEPKvj: __ZN11UnityEngine15CloudWebService14RestDownloader13OnReceiveDataEPKvj, __Z43WebCamTexture_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf: __Z43WebCamTexture_CUSTOM_INTERNAL_CALL_GetPixelP12Il2CppObjectiiR10ColorRGBAf, __ZN26IntersectAnyVsMeshCallbackILi1ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj: __ZN26IntersectAnyVsMeshCallbackILi1ELb0EE10processHitERKN5physx12PxRaycastHitERKNS1_6PxVec3ES7_S7_RfPKj, __Z41WebCamTexture_Get_Custom_PropRequestedFPSP12Il2CppObject: __Z41WebCamTexture_Get_Custom_PropRequestedFPSP12Il2CppObject, _h2v1_downsample: _h2v1_downsample, __ZN10AudioMixer8SetFloatEPKcf: __ZN10AudioMixer8SetFloatEPKcf, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25setAcceleationFilterWidthEj, __Z21SetShaderGlobalMatrixN9ShaderLab16FastPropertyNameERK10Matrix4x4f: __Z21SetShaderGlobalMatrixN9ShaderLab16FastPropertyNameERK10Matrix4x4f, __ZNSt3__26vectorIP9Texture2DNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_: __ZNSt3__26vectorIP9Texture2DNS_9allocatorIS2_EEE21__push_back_slow_pathIKS2_EEvRT_, __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj: __ZN5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE20getExternalReferenceERj, __ZN7mecanim5human21HumanGetColliderXformEPKNS0_5HumanERKN4math4trsXEi: __ZN7mecanim5human21HumanGetColliderXformEPKNS0_5HumanERKN4math4trsXEi, __Z64Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayImplListv: __Z64Register_UnityEngine_MaterialPropertyBlock_GetFloatArrayImplListv, __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPwEEEET_S4_S4_S4_: __ZNSt3__212__rotate_gcdINS_11__wrap_iterIPwEEEET_S4_S4_S4_, __ZN9LensFlare13SetBrightnessEf: __ZN9LensFlare13SetBrightnessEf, __ZN13RenderTexture24CorrectVerticalTexelSizeEb: __ZN13RenderTexture24CorrectVerticalTexelSizeEb, __ZN6b2Rope10InitializeEPK9b2RopeDef: __ZN6b2Rope10InitializeEPK9b2RopeDef, __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN4PPtrI18ProceduralMaterialE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI18ProceduralMaterialE8TransferI14SafeBinaryReadEEvRT_, __ZN18DownloadHandlerVFS22OnReceiveContentLengthEj: __ZN18DownloadHandlerVFS22OnReceiveContentLengthEj, __ZN5physx2Sn20SerializationContext9alignDataEj: __ZN5physx2Sn20SerializationContext9alignDataEj, __ZNK7b2Mat337Solve33ERK6b2Vec3: __ZNK7b2Mat337Solve33ERK6b2Vec3, __ZN5physx26solveContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx26solveContactBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN18BackgroundJobQueue21ExecuteMainThreadJobsEv: __ZN18BackgroundJobQueue21ExecuteMainThreadJobsEv, __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev: __ZN5physx30PxVehicleTireDataGeneratedInfoC2Ev, __Z34Animator_Set_Custom_PropFireEventsP12Il2CppObjecth: __Z34Animator_Set_Custom_PropFireEventsP12Il2CppObjecth, __ZN5physx13updateJouncesEPKfPf: __ZN5physx13updateJouncesEPKfPf, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEc: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEaSEc, __ZN4Tree20WillDestroyComponentEv: __ZN4Tree20WillDestroyComponentEv, __ZL17Transfer_GUIStyleI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL17Transfer_GUIStyleI8JSONReadLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z49Register_UnityEngine_SystemInfo_get_processorTypev: __Z49Register_UnityEngine_SystemInfo_get_processorTypev, __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN12MeshCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z18HiearchyMatchesOptP9TransformPKN7mecanim8skeleton8SkeletonEPKj: __Z18HiearchyMatchesOptP9TransformPKN7mecanim8skeleton8SkeletonEPKj, __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj: __ZN5physx2Gu33PCMCapsuleVsMeshContactGeneration10generateEEERKNS_6shdfnd3aos5Vec3VES6_RKNS3_6FloatVES6_jS6_S6_PNS0_21MeshPersistentContactERj, __ZN12FlareManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData: __ZN12FlareManager21ReleaseGeometryJobMemEP25DynamicVBOGeometryJobData, _UNITY_ft_mem_strdup: _UNITY_ft_mem_strdup, __Z16DestroyJobSystemv: __Z16DestroyJobSystemv, __Z65Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierv: __Z65Register_UnityEngine_ParticleSystem_MainModule_SetGravityModifierv, __ZN7mecanim6memory16MecanimAllocator10DeallocateEPv: __ZN7mecanim6memory16MecanimAllocator10DeallocateEPv, __ZN26DownloadHandlerAssetBundleD0Ev: __ZN26DownloadHandlerAssetBundleD0Ev, __ZN13RenderTextureD2Ev: __ZN13RenderTextureD2Ev, __ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_: __ZNK5physx16PxsSolverExtBody15projectVelocityERKNS_6PxVec3ES3_, __ZNSt3__214error_categoryD0Ev: __ZNSt3__214error_categoryD0Ev, __Z27GenerateOutlineFromMeshDataRK13dynamic_arrayItLj2EERKS_I12SpriteVertexLj4EERS_I8Vector2fLj4EE: __Z27GenerateOutlineFromMeshDataRK13dynamic_arrayItLj2EERKS_I12SpriteVertexLj4EERS_I8Vector2fLj4EE, __ZN14TerrainManager25ReloadTerrainsToGfxDeviceEv: __ZN14TerrainManager25ReloadTerrainsToGfxDeviceEv, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE10ParseArrayILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZN5Unity17ConfigurableJoint27ApplyKeepConfigurationSpaceEv: __ZN5Unity17ConfigurableJoint27ApplyKeepConfigurationSpaceEv, __Z52Playable_CUSTOM_INTERNAL_CALL_SetInputWeightInternalR9HPlayableRKS_f: __Z52Playable_CUSTOM_INTERNAL_CALL_SetInputWeightInternalR9HPlayableRKS_f, __ZN22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZN22ParticleSystemRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN17PolygonCollider2D5ResetEv: __ZN17PolygonCollider2D5ResetEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_22PxVehicleWheelsSimDataEE12readPropertyIfEEbRT_, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI8UnityStrS2_EEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessI8UnityStrS2_EEPS2_EEbT0_S6_T_, __ZNK14AreaEffector2D21DesignedForNonTriggerEv: __ZNK14AreaEffector2D21DesignedForNonTriggerEv, __ZNK5Unity14CharacterJoint26GetTypeInfoVirtualInternalEv: __ZNK5Unity14CharacterJoint26GetTypeInfoVirtualInternalEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIjLj4EEEEvRT_17TransferMetaFlags, __ZN27AnimationLayerMixerPlayable13ClearBindingsEv: __ZN27AnimationLayerMixerPlayable13ClearBindingsEv, __Z52Register_UnityEngine_ParticleEmitter_set_minEmissionv: __Z52Register_UnityEngine_ParticleEmitter_set_minEmissionv, __Z33AndroidJNI_CUSTOM_FromObjectArray13Il2Cpp_IntPtr: __Z33AndroidJNI_CUSTOM_FromObjectArray13Il2Cpp_IntPtr, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxJointLimitConeEE8pushNameEPKc, __Z13FloatToStringfPKc: __Z13FloatToStringfPKc, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj431ENS_22PxRepXPropertyAccessorILj431ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_9PxD6JointEEEE14handleAccessorILj431ENS_22PxRepXPropertyAccessorILj431ES4_RKNS_23PxJointAngularLimitPairES9_EEEEvRKT0_, __Z29StdTemplateConversionFunctionIaaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIaaEbPvR14SafeBinaryRead, __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_7NpSceneEXadL_ZNS2_12executeSceneEPNS_10PxBaseTaskEEEE7getNameEv, __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb: __ZN5physx2Gu19EPALocalPenetrationERKNS0_8CapsuleVERKNS0_11ConvexHullVERNS_6shdfnd3aos5Vec3VESA_SA_RNS8_6FloatVEPhSD_Rhb, __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameP12Il2CppObjectR15MonoMinMaxCurve: __Z63ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetStartFrameP12Il2CppObjectR15MonoMinMaxCurve, __ZN20SoundChannelInstance13set3DPanLevelEf: __ZN20SoundChannelInstance13set3DPanLevelEf, __ZN24OcclusionCullingSettings13AwakeFromLoadE17AwakeFromLoadMode: __ZN24OcclusionCullingSettings13AwakeFromLoadE17AwakeFromLoadMode, __ZN5Umbra12QueryContextC2EPNS_10QueryStateEj: __ZN5Umbra12QueryContextC2EPNS_10QueryStateEj, __Z64Register_UnityEngine_ParticleSystem_CollisionModule_GetVoxelSizev: __Z64Register_UnityEngine_ParticleSystem_CollisionModule_GetVoxelSizev, __ZNK12PhysXRaycast17BroadPhaseCullingER13dynamic_arrayIN5physx12PxOverlapHitELj4EERS0_I4AABBLj4EERK10MinMaxAABBibi23QueryTriggerInteraction: __ZNK12PhysXRaycast17BroadPhaseCullingER13dynamic_arrayIN5physx12PxOverlapHitELj4EERS0_I4AABBLj4EERK10MinMaxAABBibi23QueryTriggerInteraction, __Z45QualitySettings_Set_Custom_PropShadowDistancef: __Z45QualitySettings_Set_Custom_PropShadowDistancef, __ZN5physx2Sc5Scene19updateCCDSinglePassEPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene19updateCCDSinglePassEPNS_10PxBaseTaskE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj547ENS_22PxRepXPropertyAccessorILj547ES4_NS4_4EnumES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEE14handleAccessorILj547ENS_22PxRepXPropertyAccessorILj547ES4_NS4_4EnumES9_EEEEvRKT0_, __ZN5physx2Sq8AABBTree5buildEPNS0_15AABBTreeBuilderE: __ZN5physx2Sq8AABBTree5buildEPNS0_15AABBTreeBuilderE, __Z43Register_UnityEngine_Material_SetBufferImplv: __Z43Register_UnityEngine_Material_SetBufferImplv, __Z42DynamicGI_CUSTOM_INTERNAL_CALL_SetEmissiveP12Il2CppObjectRK10ColorRGBAf: __Z42DynamicGI_CUSTOM_INTERNAL_CALL_SetEmissiveP12Il2CppObjectRK10ColorRGBAf, __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing1Limitv: __Z60Register_UnityEngine_CharacterJoint_INTERNAL_get_swing1Limitv, __ZN14NavMeshCarving14PrepareCarvingEv: __ZN14NavMeshCarving14PrepareCarvingEv, __Z40TerrainData_Get_Custom_PropTreeInstancesP12Il2CppObject: __Z40TerrainData_Get_Custom_PropTreeInstancesP12Il2CppObject, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxClothTetherConfigEE8pushNameEPKc, __ZNK5physx7NpScene15getCCDMaxPassesEv: __ZNK5physx7NpScene15getCCDMaxPassesEv, __ZN5Unity10HingeJoint7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN5Unity10HingeJoint7PRODUCEE10MemLabelId18ObjectCreationMode, __Z28getPxMaterial_StaticFrictionPKN5physx10PxMaterialE: __Z28getPxMaterial_StaticFrictionPKN5physx10PxMaterialE, __Z48TargetJoint2D_Set_Custom_PropAutoConfigureTargetP12Il2CppObjecth: __Z48TargetJoint2D_Set_Custom_PropAutoConfigureTargetP12Il2CppObjecth, __ZN26AnimatorControllerPlayable10SetTriggerEi: __ZN26AnimatorControllerPlayable10SetTriggerEi, _getopt: _getopt, __Z9IsTestRunv: __Z9IsTestRunv, __Z39SystemInfo_CUSTOM_SupportsTextureFormat13TextureFormat: __Z39SystemInfo_CUSTOM_SupportsTextureFormat13TextureFormat, __Z46ParticleSystem_ShapeModule_CUSTOM_SetMeshScaleP12Il2CppObjectf: __Z46ParticleSystem_ShapeModule_CUSTOM_SetMeshScaleP12Il2CppObjectf, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERiPjPfPNS_5ArrayIiEERKNS_4AABBE: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERiPjPfPNS_5ArrayIiEERKNS_4AABBE, __ZN24dtObstacleAvoidanceQuery18addBoundarySegmentEPKfS1_: __ZN24dtObstacleAvoidanceQuery18addBoundarySegmentEPKfS1_, __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_: __ZN5physx2GuL18getIncidentPolygonEPNS_6shdfnd3aos5Vec3VERS3_RKS3_RKNS2_15PsMatTransformVES7_, __ZZN8Collider15InitializeClassEvEN32FunctorImpl_779kTransformChanged4CallEPviR11MessageData: __ZZN8Collider15InitializeClassEvEN32FunctorImpl_779kTransformChanged4CallEPviR11MessageData, _UNITY_png_destroy_gamma_table: _UNITY_png_destroy_gamma_table, __ZN24UserAuthorizationManager22GetAuthorizationDialogEv: __ZN24UserAuthorizationManager22GetAuthorizationDialogEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj624ENS_22PxRepXPropertyAccessorILj624ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEE14handleAccessorILj624ENS_22PxRepXPropertyAccessorILj624ES4_KffEEEEvRKT0_, __Z50AnimatorControllerPlayable_CUSTOM_GetIntegerStringR9HPlayableP12Il2CppString: __Z50AnimatorControllerPlayable_CUSTOM_GetIntegerStringR9HPlayableP12Il2CppString, __ZN11AudioSource15rolloffCallbackEP12FMOD_CHANNELf: __ZN11AudioSource15rolloffCallbackEP12FMOD_CHANNELf, __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_: __ZL17FinishLeftRegionsP14TESStesselatorP12ActiveRegionS2_, __ZNK5physx3Cct8SweptBox18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E: __ZNK5physx3Cct8SweptBox18computeTemporalBoxERKNS0_9SweepTestERNS_17PxExtendedBounds3ERKNS_14PxExtendedVec3ERKNS_6PxVec3E, __ZN22UnityProfilerPerThread10InitializeEPKcS1_: __ZN22UnityProfilerPerThread10InitializeEPKcS1_, __Z10IsZeroGUIDP9FMOD_GUID: __Z10IsZeroGUIDP9FMOD_GUID, __ZN10Effector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10Effector2D23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN7Cursors17GetSoftwareCursorEv: __ZN7Cursors17GetSoftwareCursorEv, __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesYP12Il2CppObject: __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetNumTilesYP12Il2CppObject, __ZN14SplatMaterials15UpdateMaterialsEv: __ZN14SplatMaterials15UpdateMaterialsEv, __Z56Register_UnityEngine_RelativeJoint2D_INTERNAL_get_targetv: __Z56Register_UnityEngine_RelativeJoint2D_INTERNAL_get_targetv, __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EEjPKi: __ZN7mecanim8skeleton16SkeletonPoseCopyIN4math4trsXENS2_7affineXEEEvPKNS0_13SkeletonPoseTIT_EEPNS5_IT0_EEjPKi, __Z42SurfaceEffector2D_Get_Custom_PropUseBounceP12Il2CppObject: __Z42SurfaceEffector2D_Get_Custom_PropUseBounceP12Il2CppObject, _destroy_size: _destroy_size, __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN15ConstantForce2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z25getPxParticleBase_DampingPKN5physx14PxParticleBaseE: __Z25getPxParticleBase_DampingPKN5physx14PxParticleBaseE, __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb: __ZN17BufferManagerGLES13AcquireBufferEiN14DataBufferGLES11BufferUsageEb, __Z42Register_UnityEngine_LocationService_Startv: __Z42Register_UnityEngine_LocationService_Startv, __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_17PxcBroadPhasePairENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __ZN5physx2Sc5Scene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE: __ZN5physx2Sc5Scene22setClientBehaviorFlagsEhNS_7PxFlagsINS_20PxClientBehaviorFlag4EnumEhEE, __ZN7Cubemap15ThreadedCleanupEv: __ZN7Cubemap15ThreadedCleanupEv, __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE: __ZN5physx7profile8ZoneImplINS_28PxProfileNameProviderForwardEE9addClientERNS_19PxProfileZoneClientE, __ZN9JSONWrite8TransferIN11UnityEngine9Analytics16TransactionEvent11ReceiptDataEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIN11UnityEngine9Analytics16TransactionEvent11ReceiptDataEEEvRT_PKc17TransferMetaFlags, __ZNSt3__25stollERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji: __ZNSt3__25stollERKNS_12basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEEPji, __ZN5physx2Gu23computeMTD_ConvexConvexERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformES6_S9_: __ZN5physx2Gu23computeMTD_ConvexConvexERNS_6PxVec3ERfRKNS_20PxConvexMeshGeometryERKNS_11PxTransformES6_S9_, __ZN5physx24PxcGetMaterialShapeShapeEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE: __ZN5physx24PxcGetMaterialShapeShapeEPKNS_12PxsShapeCoreES2_RNS_18PxcNpThreadContextEPNS_15PxsMaterialInfoE, __Z18Transfer_BlittableI8JSONReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi: __ZZNK14dtNavMeshQuery15findNearestPolyEPKfS1_PK13dtQueryFilterPyPfEN12NearestQuery15processPolygonsEPK10dtMeshTilePKyPPK6dtPolyi, __ZN11UnityEngine7Connect15AppInstallEvent12ToJsonStringER9JSONWrite: __ZN11UnityEngine7Connect15AppInstallEvent12ToJsonStringER9JSONWrite, __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Gu31SpherePersistentContactManifoldENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN5physx2Gu11GJKRelativeERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_11ConvexHullVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVE, __ZN20TextRenderingPrivate14DynamicFontMap16StaticInitializeEv: __ZN20TextRenderingPrivate14DynamicFontMap16StaticInitializeEv, __Z57Register_UnityEngine_AI_NavMeshAgent_set_stoppingDistancev: __Z57Register_UnityEngine_AI_NavMeshAgent_set_stoppingDistancev, __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI8RendererE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN9Behaviour15InitializeClassEv: __ZN9Behaviour15InitializeClassEv, __ZN22AnimationMixerPlayable20GetPlayableClassNameEv: __ZN22AnimationMixerPlayable20GetPlayableClassNameEv, __Z29GetNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE: __Z29GetNbPxClothFabric_RestvaluesPKN5physx13PxClothFabricE, __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_: __ZNKSt3__27num_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE17__do_get_unsignedImEES4_S4_S4_RNS_8ios_baseERjRT_, __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi: __ZN5physx13NpVolumeCache12fillInternalEjPKNS_12PxOverlapHitEi, __ZN5physx2Sc5Scene7collideEfPNS_10PxBaseTaskE: __ZN5physx2Sc5Scene7collideEfPNS_10PxBaseTaskE, __ZN9ShaderLab20SerializedSubProgram6BindCBEPKci: __ZN9ShaderLab20SerializedSubProgram6BindCBEPKci, __ZNK26AnimatorControllerPlayable21GetStateMachineMemoryEi: __ZNK26AnimatorControllerPlayable21GetStateMachineMemoryEi, __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetSeparateAxesv: __Z69Register_UnityEngine_ParticleSystem_SizeBySpeedModule_SetSeparateAxesv, __ZN5physx14PxVehicleDrive17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx14PxVehicleDrive17getBinaryMetaDataERNS_14PxOutputStreamE, __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetWorldSpacev: __Z73Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetWorldSpacev, __ZN5physx2Gu25computeBox_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbjRNS_10PxSweepHitE: __ZN5physx2Gu25computeBox_HeightFieldMTDERKNS_21PxHeightFieldGeometryERKNS_11PxTransformERKNS0_3BoxES6_ffbjRNS_10PxSweepHitE, __Z28Texture2D_CUSTOM_EncodeToPNGP12Il2CppObject: __Z28Texture2D_CUSTOM_EncodeToPNGP12Il2CppObject, __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeIN20TextRenderingPrivate7FontRefENS2_6OSFontEEENS_19__map_value_compareIS3_S5_NS_4lessIS3_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN16LightmapSettings24GetEnlightenSceneMappingEv: __ZN16LightmapSettings24GetEnlightenSceneMappingEv, __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs8allocateEjj: __ZN5physx43PxVehicleDrivableSurfaceToTireFrictionPairs8allocateEjj, __ZN5physx26solveFriction_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE: __ZN5physx26solveFriction_BStaticBlockEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextE, __Z45CleanupMonoBehaviourAnimationBindingInterfacev: __Z45CleanupMonoBehaviourAnimationBindingInterfacev, __ZNK21ImposterRenderTexture18GetBillboardParamsERfS0_: __ZNK21ImposterRenderTexture18GetBillboardParamsERfS0_, __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb: __ZN5Umbra5ArrayINS_20RuntimeTomeGenerator14ExternalPortalEE6updateEibbb, __ZN9Behaviour15ThreadedCleanupEv: __ZN9Behaviour15ThreadedCleanupEv, __ZN30AudioEffectInternalDescriptionC2E13FMOD_DSP_TYPEPb: __ZN30AudioEffectInternalDescriptionC2E13FMOD_DSP_TYPEPb, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryRead10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z37MeshCollider_Set_Custom_PropSkinWidthP12Il2CppObjectf: __Z37MeshCollider_Set_Custom_PropSkinWidthP12Il2CppObjectf, __ZN8VRDevice27OnAudioConfigurationChangedEv: __ZN8VRDevice27OnAudioConfigurationChangedEv, __ZN5physx11NpAggregate29removeArticulationAndReinsertERNS_14PxArticulationEb: __ZN5physx11NpAggregate29removeArticulationAndReinsertERNS_14PxArticulationEb, __ZN15NavMeshSettings15ThreadedCleanupEv: __ZN15NavMeshSettings15ThreadedCleanupEv, __ZNK14SphereCollider26GetTypeInfoVirtualInternalEv: __ZNK14SphereCollider26GetTypeInfoVirtualInternalEv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE17find_first_not_ofEPKwj, __ZN13ConstantForceC2E10MemLabelId18ObjectCreationMode: __ZN13ConstantForceC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxArticulationLinkEE8pushNameEPKc, __Z44Register_UnityEngine_Joint2D_set_breakTorquev: __Z44Register_UnityEngine_Joint2D_set_breakTorquev, __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z26Transfer_UnityEngineObjectI14SafeBinaryReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx15PxsParticleData19addDeltaVelocitiesVERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef: __ZN5physx15PxsParticleData19addDeltaVelocitiesVERKNS_2Cm10BitMapBaseINS_6shdfnd9AllocatorEEEPKNS_6PxVec3Ef, __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve: __Z46ParticleSystem_MainModule_CUSTOM_GetStartSizeYP12Il2CppObjectR15MonoMinMaxCurve, __ZN16DeveloperConsoleD2Ev: __ZN16DeveloperConsoleD2Ev, __ZN12_GLOBAL__N_121SocketNetworkInStream9readBytesEPhj: __ZN12_GLOBAL__N_121SocketNetworkInStream9readBytesEPhj, __ZN12_GLOBAL__N_19MyFastXmlD2Ev: __ZN12_GLOBAL__N_19MyFastXmlD2Ev, __Z25SetNbDiscreteContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j: __Z25SetNbDiscreteContactPairsPN5physx22PxSimulationStatisticsENS_14PxGeometryType4EnumES3_j, __ZN9GfxDevice14OnCreateBufferEP9GfxBuffer: __ZN9GfxDevice14OnCreateBufferEP9GfxBuffer, __ZN5physx18PxcArticulationRef12applyImpulseERKNS_9PxcFsDataEPNS_2Cm13SpatialVectorEjRKS5_: __ZN5physx18PxcArticulationRef12applyImpulseERKNS_9PxcFsDataEPNS_2Cm13SpatialVectorEjRKS5_, __ZNK11GameManager26GetTypeInfoVirtualInternalEv: __ZNK11GameManager26GetTypeInfoVirtualInternalEv, __ZNK5physx7NpScene20getMeshContactMarginEv: __ZNK5physx7NpScene20getMeshContactMarginEv, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainMotionEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainMotionEv, __ZN11b2RopeJoint23InitVelocityConstraintsERK12b2SolverData: __ZN11b2RopeJoint23InitVelocityConstraintsERK12b2SolverData, __ZNK9Transform13GetLocalScaleEv: __ZNK9Transform13GetLocalScaleEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI8UnityStrEEvRT_17TransferMetaFlags, __Z45CharacterController_Get_Custom_PropSlopeLimitP12Il2CppObject: __Z45CharacterController_Get_Custom_PropSlopeLimitP12Il2CppObject, __ZN5physx2Sc21ConstraintInteraction11updateStateEb: __ZN5physx2Sc21ConstraintInteraction11updateStateEb, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE6resizeEjRKS3_, __Z29Cloth_Get_Custom_PropFrictionP12Il2CppObject: __Z29Cloth_Get_Custom_PropFrictionP12Il2CppObject, __ZNK12PhysXRaycast9IntersectERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_jR20BatchedRaycastResultb: __ZNK12PhysXRaycast9IntersectERK8Vector3fS2_RK4AABBffPN5physx12PxOverlapHitEPS3_jR20BatchedRaycastResultb, __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE7destroyEPNS_11__tree_nodeIS5_PvEE, __ZN10GameObject6SetTagEj: __ZN10GameObject6SetTagEj, __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE16getNbConstraintsEv: __ZNK5physx20NpRigidActorTemplateINS_13PxRigidStaticEE16getNbConstraintsEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj417ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_: __ZNK15dense_hashtableINSt3__24pairIKi17ThreadedAwakeDataEEi21InstanceIDHashFunctorN14dense_hash_mapIiS3_S5_NS0_8equal_toIiEENS0_9allocatorIS4_EEE9SelectKeyES8_SA_E13find_positionERS2_, __ZN10GameObject8TransferI14SafeBinaryReadEEvRT_: __ZN10GameObject8TransferI14SafeBinaryReadEEvRT_, __Z59Register_UnityEngine_Rigidbody_set_maxDepenetrationVelocityv: __Z59Register_UnityEngine_Rigidbody_set_maxDepenetrationVelocityv, __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_StringToHashv: __Z82Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_StringToHashv, __ZN14SpriteRenderer8TransferI14SafeBinaryReadEEvRT_: __ZN14SpriteRenderer8TransferI14SafeBinaryReadEEvRT_, __Z22Check2MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_P6ObjectR11MonoManager: __Z22Check2MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_S1_P6ObjectR11MonoManager, __Z41Register_UnityEngine_GUIText_get_materialv: __Z41Register_UnityEngine_GUIText_get_materialv, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext14PrismaticJointEE12getClassSizeEv, __Z37Projector_Get_Custom_PropIgnoreLayersP12Il2CppObject: __Z37Projector_Get_Custom_PropIgnoreLayersP12Il2CppObject, __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_: __ZN13dynamic_arrayIN20GpuProgramParameters14ValueParameterELj4EEC2ERKS2_, __GLOBAL__sub_I_ProfilerImpl_cpp: __GLOBAL__sub_I_ProfilerImpl_cpp, __ZN5physx31PxcContactBoxHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx31PxcContactBoxHeightFieldUnifiedERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZNK14MemoryProfiler32GetRegisteredAllocationsOverviewERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE: __ZNK14MemoryProfiler32GetRegisteredAllocationsOverviewERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEE, __Z51Register_UnityEngine_TextGenerator_GetVerticesArrayv: __Z51Register_UnityEngine_TextGenerator_GetVerticesArrayv, __ZN5physx15PxsParticleDataC2ERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E: __ZN5physx15PxsParticleDataC2ERNS_30PxvParticleSystemStateDataDescERKNS_9PxBounds3E, __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj: __ZNK5physx22PxVehicleWheelsSimData26getTireForceAppPointOffsetEj, __ZNSt3__211__sift_downIR19ROSorterReplacementP17RODataReplacementEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_: __ZNSt3__211__sift_downIR19ROSorterReplacementP17RODataReplacementEEvT0_S5_T_NS_15iterator_traitsIS5_E15difference_typeES5_, __ZN8Material8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8Material8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z29setPxSceneDescSimulationOrderPN5physx11PxSceneDescENS_17PxSimulationOrder4EnumE: __Z29setPxSceneDescSimulationOrderPN5physx11PxSceneDescENS_17PxSimulationOrder4EnumE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim9animation10ValueDeltaEEEEvRT_17TransferMetaFlags, __ZN5Umbra11PatchWriter6finishEv: __ZN5Umbra11PatchWriter6finishEv, __ZN5Unity14CharacterJointC2E10MemLabelId18ObjectCreationMode: __ZN5Unity14CharacterJointC2E10MemLabelId18ObjectCreationMode, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcjj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE16find_last_not_ofEPKcjj, __Z53ParticleSystem_TrailModule_CUSTOM_SetDieWithParticlesP12Il2CppObjecth: __Z53ParticleSystem_TrailModule_CUSTOM_SetDieWithParticlesP12Il2CppObjecth, __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm12DelegateTaskINS_20PxsParticleSystemSimEXadL_ZNS2_14dynamicsUpdateEPNS_10PxBaseTaskEEEED0Ev, __Z31getPxVehicleEngineData_RecipMOIPKN5physx19PxVehicleEngineDataE: __Z31getPxVehicleEngineData_RecipMOIPKN5physx19PxVehicleEngineDataE, __ZNK13AnimationClip10FloatCurve16CopyWithoutCurveERS0_: __ZNK13AnimationClip10FloatCurve16CopyWithoutCurveERS0_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxVehicleNoDriveEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj693ES2_KjfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZN21AssetBundleFileSystem9SetLengthER13FileEntryDatay: __ZN21AssetBundleFileSystem9SetLengthER13FileEntryDatay, __ZL41RuntimeInitializeOnSceneLoadedBeforeAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE: __ZL41RuntimeInitializeOnSceneLoadedBeforeAwakeiR18AwakeFromLoadQueueN19RuntimeSceneManager11LoadingModeE, _Ins_UNKNOWN: _Ins_UNKNOWN, __ZNSt3__212strstreambuf7seekposENS_4fposI11__mbstate_tEEj: __ZNSt3__212strstreambuf7seekposENS_4fposI11__mbstate_tEEj, __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE: __ZN5physx3TriC2EiiiPNS_12hullLibArray5ArrayIPS0_EE, __Z39Register_UnityEngine_Animator_SetBoolIDv: __Z39Register_UnityEngine_Animator_SetBoolIDv, __Z50Register_UnityEngine_Canvas_INTERNAL_get_pixelRectv: __Z50Register_UnityEngine_Canvas_INTERNAL_get_pixelRectv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj619ES2_KjNS_6PxVec3EEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateUpdateAllRenderersstruct7ForwardEv: __ZZ23InitPlayerLoopCallbacksvEN38PostLateUpdateUpdateAllRenderersstruct7ForwardEv, __ZN14ParticleSystem10DeactivateE19DeactivateOperation: __ZN14ParticleSystem10DeactivateE19DeactivateOperation, __ZNSt3__211__stdoutbufIwE8overflowEj: __ZNSt3__211__stdoutbufIwE8overflowEj, _UNITY_LZ4_saveDict: _UNITY_LZ4_saveDict, __ZN5physx2Sc13ShapeIterator7getNextEv: __ZN5physx2Sc13ShapeIterator7getNextEv, __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN12NavMeshAgent8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z46ScriptableObject_CUSTOM_CreateInstanceFromTypeP12Il2CppObject: __Z46ScriptableObject_CUSTOM_CreateInstanceFromTypeP12Il2CppObject, __Z38Joint2D_Set_Custom_PropEnableCollisionP12Il2CppObjecth: __Z38Joint2D_Set_Custom_PropEnableCollisionP12Il2CppObjecth, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI15CapsuleColliderELj4EEEEvRT_17TransferMetaFlags, __ZN14DataBufferGLES23mapBufferUsageToGLUsageENS_11BufferUsageE: __ZN14DataBufferGLES23mapBufferUsageToGLUsageENS_11BufferUsageE, __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev: __ZN11UnityEngine15CloudWebService14DataDispatcherD2Ev, __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev: __ZN9ShaderLab20SerializedSubProgram14ConstantBufferD2Ev, _getdomainname: _getdomainname, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIyLj8EEEEvRT_17TransferMetaFlags, __ZNK21FullParameterPreparer14OnPrepareFloatER12PartialArrayIfERKN20GpuProgramParameters14ValueParameterEj: __ZNK21FullParameterPreparer14OnPrepareFloatER12PartialArrayIfERKN20GpuProgramParameters14ValueParameterEj, __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN8Collider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4math4Axes8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN4math4Axes8TransferI24GenerateTypeTreeTransferEEvRT_, __Z45AudioReverbFilter_Get_Custom_PropReverbPresetP12Il2CppObject: __Z45AudioReverbFilter_Get_Custom_PropReverbPresetP12Il2CppObject, __ZN5physx7NpShape15releaseInternalEv: __ZN5physx7NpShape15releaseInternalEv, __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE: __ZN5physx23PxVehicleDriveSimData4W24setAckermannGeometryDataERKNS_30PxVehicleAckermannGeometryDataE, __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE8TransferINSt3__26vectorIhNS2_9allocatorIhEEEEEEvRT_PKc17TransferMetaFlags, __ZNK16LightmapSettings24GetEnlightenSceneMappingEv: __ZNK16LightmapSettings24GetEnlightenSceneMappingEv, __ZN19AssetBundleManifest8TransferI14SafeBinaryReadEEvRT_: __ZN19AssetBundleManifest8TransferI14SafeBinaryReadEEvRT_, __ZN8LODGroup7CleanupEv: __ZN8LODGroup7CleanupEv, __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_PKS2_S6_: __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EE6insertEPS2_PKS2_S6_, __ZN5physx6PxVec4C2Effff: __ZN5physx6PxVec4C2Effff, __ZN5physx6shdfnd5ArrayIPFvRNS_14PxOutputStreamEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_: __ZN5physx6shdfnd5ArrayIPFvRNS_14PxOutputStreamEENS0_19ReflectionAllocatorIS5_EEE15growAndPushBackERKS5_, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSpeedv, __Z18Transfer_BlittableI9JSONWriteLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z40ConstantForce_CUSTOM_INTERNAL_set_torqueP12Il2CppObjectRK8Vector3f: __Z40ConstantForce_CUSTOM_INTERNAL_set_torqueP12Il2CppObjectRK8Vector3f, __ZN12CubemapArray9SetPixelsEiPK10ColorRGBAf11CubemapFaceii: __ZN12CubemapArray9SetPixelsEiPK10ColorRGBAf11CubemapFaceii, __ZN11BoxCollider9SetCenterERK8Vector3f: __ZN11BoxCollider9SetCenterERK8Vector3f, __ZNSt3__211char_traitsIcE7compareEPKcS3_j: __ZNSt3__211char_traitsIcE7compareEPKcS3_j, __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI12TreeInstanceNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __Z62GUIStyle_CUSTOM_INTERNAL_CALL_Internal_CalcSizeWithConstraints13Il2Cpp_IntPtrP12Il2CppObjectRK13Vector2fIcallPS2_: __Z62GUIStyle_CUSTOM_INTERNAL_CALL_Internal_CalcSizeWithConstraints13Il2Cpp_IntPtrP12Il2CppObjectRK13Vector2fIcallPS2_, __ZNK9dtNavMesh10getTileRefEPK10dtMeshTile: __ZNK9dtNavMesh10getTileRefEPK10dtMeshTile, __ZNSt3__26vectorIN11TypeManager18TypeCallbackStructE13stl_allocatorIS2_L18MemLabelIdentifier6ELi16EEE8__appendEj: __ZNSt3__26vectorIN11TypeManager18TypeCallbackStructE13stl_allocatorIS2_L18MemLabelIdentifier6ELi16EEE8__appendEj, __ZN13AnimationClip13SetSampleRateEf: __ZN13AnimationClip13SetSampleRateEf, __ZNK5Umbra14TomeCollection13findGateIndexEj: __ZNK5Umbra14TomeCollection13findGateIndexEj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer14EffectConstantEEEEvRT_17TransferMetaFlags, __ZN16SpriteRenderDataC2Ev: __ZN16SpriteRenderDataC2Ev, __ZN11UnityEngine15CloudWebService16SessionContainer16GetJsonDataBlockEjRK8UnityStrRS2_Pj: __ZN11UnityEngine15CloudWebService16SessionContainer16GetJsonDataBlockEjRK8UnityStrRS2_Pj, __ZN5physx27PxParticleBaseGeneratedInfoC2Ev: __ZN5physx27PxParticleBaseGeneratedInfoC2Ev, __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv: __ZN30dense_hashtable_const_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E30advance_past_empty_and_deletedEv, __Z42VRDevice_CUSTOM_INTERNAL_CALL_GetNativePtrRPv: __Z42VRDevice_CUSTOM_INTERNAL_CALL_GetNativePtrRPv, __ZN10SampleClip8TransferI17RemapPPtrTransferEEvRT_: __ZN10SampleClip8TransferI17RemapPPtrTransferEEvRT_, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5crendEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE5crendEv, __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeI4PPtrI6ObjectENS_4lessIS3_EENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, __ZN9ShaderLab14PopParserStateEv: __ZN9ShaderLab14PopParserStateEv, __ZNKSt13runtime_error4whatEv: __ZNKSt13runtime_error4whatEv, __ZN23CloudWebServicesManager25RegisterPlayerLoopHandlerEP19CloudServiceHandler: __ZN23CloudWebServicesManager25RegisterPlayerLoopHandlerEP19CloudServiceHandler, __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_: __ZNSt3__26__sortIR31SortCollisionEventsByGameObjectP22ParticleCollisionEventEEvT0_S5_T_, __ZN5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE: __ZN5physx7profile30PxProfileMemoryEventBufferImpl9addClientERNS_26PxProfileEventBufferClientE, __ZNK12StatusHelper10IsRedirectEv: __ZNK12StatusHelper10IsRedirectEv, __ZNKSt3__220__vector_base_commonILb1EE20__throw_out_of_rangeEv: __ZNKSt3__220__vector_base_commonILb1EE20__throw_out_of_rangeEv, __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11getNbShapesEv: __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE11getNbShapesEv, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE19getConcreteTypeNameEv: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE19getConcreteTypeNameEv, __Z31Sprite_CUSTOM_Internal_GetPivotP12Il2CppObjectP13Vector2fIcall: __Z31Sprite_CUSTOM_Internal_GetPivotP12Il2CppObjectP13Vector2fIcall, __ZN14PhysicsManager10BoxCastAllERK8Vector3fS2_S2_RK11Quaternionffi23QueryTriggerInteraction: __ZN14PhysicsManager10BoxCastAllERK8Vector3fS2_S2_RK11Quaternionffi23QueryTriggerInteraction, __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j: __ZN15dense_hashtableINSt3__24pairIKiP4RTTIEEiN11TypeManager27HashFunctorPersistentTypeIDEN14dense_hash_mapIiS4_S7_NS0_8equal_toIiEE13stl_allocatorIS5_L18MemLabelIdentifier6ELi16EEE9SelectKeyESA_SD_E9copy_fromERKSG_j, __ZNK29LineParametersPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK29LineParametersPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZNK12LineRenderer12GetPositionsEP8Vector3fj: __ZNK12LineRenderer12GetPositionsEP8Vector3fj, __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf: __ZN14ParticleSystem14StartParticlesERS_R23ParticleSystemParticlesfffjjf, __ZN12HingeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN12HingeJoint2D7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5IMGUI14GUIWindowStateC2Ev: __ZN5IMGUI14GUIWindowStateC2Ev, __ZN5physx2Sq10AABBPrunerD2Ev: __ZN5physx2Sq10AABBPrunerD2Ev, __Z41Register_UnityEngine_GUIText_set_fontSizev: __Z41Register_UnityEngine_GUIText_set_fontSizev, __ZN19CharacterController8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN19CharacterController8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK13Simd4iFactoryIRKiEcv8Scalar4fEv: __ZNK13Simd4iFactoryIRKiEcv8Scalar4fEv, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE17MessageIdentifierEENS_19__map_value_compareIS7_S9_NS_4lessIS7_EELb1EEENS5_IS9_EEE4findIS7_EENS_15__tree_iteratorIS9_PNS_11__tree_nodeIS9_PvEEiEERKT_, __ZN9ShaderLab26SerializedShaderDependencyaSERKS0_: __ZN9ShaderLab26SerializedShaderDependencyaSERKS0_, __ZN8Animator9GetStagesER13dynamic_arrayI9StageDescLj4EE: __ZN8Animator9GetStagesER13dynamic_arrayI9StageDescLj4EE, __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo: __ZN23MeshVertexFormatManager19GetMeshVertexFormatERK18VertexChannelsInfo, __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_: __ZNSt3__26__treeINS_12__value_typeI8UnityStrbEENS_19__map_value_compareIS2_S3_NS_4lessIS2_EELb1EEE13stl_allocatorIS3_L18MemLabelIdentifier87ELi16EEE12__find_equalIS2_EERPNS_16__tree_node_baseIPvEESH_RKT_, __Z16CullDynamicSceneR8JobFenceS0_RK22SceneCullingParametersR13CullingOutput: __Z16CullDynamicSceneR8JobFenceS0_RK22SceneCullingParametersR13CullingOutput, __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_: __ZN14MinMaxGradient8TransferI17RemapPPtrTransferEEvRT_, __ZN13DrawImmediateD2Ev: __ZN13DrawImmediateD2Ev, __ZN7ApiGLES11CreateQueryEv: __ZN7ApiGLES11CreateQueryEv, __ZN26AnimatorControllerPlayable14GetLayerWeightEi: __ZN26AnimatorControllerPlayable14GetLayerWeightEi, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj434ES3_RKNS_11PxTransformES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z37GUILayer_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3f: __Z37GUILayer_CUSTOM_INTERNAL_CALL_HitTestP12Il2CppObjectRK8Vector3f, __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f: __Z9UpdateTplIL22MinMaxGradientEvalMode1EL12GradientMode0ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradientRK8Vector2f, __ZNK5physx18NpArticulationLink15getInboundJointEv: __ZNK5physx18NpArticulationLink15getInboundJointEv, __ZN4FMOD7SystemI9unlockDSPEv: __ZN4FMOD7SystemI9unlockDSPEv, __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags: __ZN14SafeBinaryRead8TransferIN7mecanim8skeleton12SkeletonMaskEEEvRT_PKc17TransferMetaFlags, __ZN15CapsuleCollider16TransformChangedEi: __ZN15CapsuleCollider16TransformChangedEi, __Z51Register_UnityEngine_GUIUtility_ReleaseMouseControlv: __Z51Register_UnityEngine_GUIUtility_ReleaseMouseControlv, __Z17UploadCubemapData9TextureIDPhjiiii13TextureFormatj17TextureColorSpaceR9GfxDevice: __Z17UploadCubemapData9TextureIDPhjiiii13TextureFormatj17TextureColorSpaceR9GfxDevice, __ZN5physx7NpScene20removeParticleSystemERNS_16NpParticleSystemE: __ZN5physx7NpScene20removeParticleSystemERNS_16NpParticleSystemE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayIN9ShaderLab21SerializedBindChannelELj4EEEEvRT_17TransferMetaFlags, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE16getLinearInertiaEv, __ZNSt3__214__split_bufferIP10InputEventNS_9allocatorIS2_EEE10push_frontERKS2_: __ZNSt3__214__split_bufferIP10InputEventNS_9allocatorIS2_EEE10push_frontERKS2_, __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13SparseTexture23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z28AddBlendShapeFrameFromScriptR4Mesh11ICallStringfP11Il2CppArrayS3_S3_: __Z28AddBlendShapeFrameFromScriptR4Mesh11ICallStringfP11Il2CppArrayS3_S3_, _UNITY_FT_Destroy_Class_cff_services: _UNITY_FT_Destroy_Class_cff_services, __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E: __Z9UpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveS3_S3_R23ParticleSystemParticlesjjbRKN4math8float3x3ERKNS6_7_float4E, __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb1EEEEEvRKS1_: __ZNSt3__26locale5__imp12install_fromINS_10moneypunctIcLb1EEEEEvRKS1_, __Z29Time_Get_Custom_PropTimeScalev: __Z29Time_Get_Custom_PropTimeScalev, _UNITY_FT_Outline_Done: _UNITY_FT_Outline_Done, __ZNKSt3__217moneypunct_bynameIcLb1EE16do_thousands_sepEv: __ZNKSt3__217moneypunct_bynameIcLb1EE16do_thousands_sepEv, __ZN5physx2Gu21contactBoxHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu21contactBoxHeightfieldERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z49Register_UnityEngine_AudioSource_set_dopplerLevelv: __Z49Register_UnityEngine_AudioSource_set_dopplerLevelv, __Z11SkinGenericILi1ELb1ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi1ELb1ELb0EEvR12SkinMeshInfo, __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_118parse_substitutionINS0_2DbEEEPKcS4_S4_RT_, __ZN35ClampVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi: __ZN35ClampVelocityModulePropertyBindings13GetFloatValueERK14ParticleSystemi, __ZN11ColorModule8TransferI14SafeBinaryReadEEvRT_: __ZN11ColorModule8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Sc9ClothCore10getPxClothEv: __ZN5physx2Sc9ClothCore10getPxClothEv, __ZNK5physx14NpArticulation22computeImpulseResponseEPNS_18PxArticulationLinkERNS_6PxVec3ES4_RKNS_24PxArticulationDriveCacheERKS3_S9_: __ZNK5physx14NpArticulation22computeImpulseResponseEPNS_18PxArticulationLinkERNS_6PxVec3ES4_RKNS_24PxArticulationDriveCacheERKS3_S9_, __ZN13GfxDeviceNull17DestroyGpuProgramEPK10GpuProgram: __ZN13GfxDeviceNull17DestroyGpuProgramEPK10GpuProgram, __Z13RegisterClassI13TargetJoint2DEvv: __Z13RegisterClassI13TargetJoint2DEvv, __ZN28LightsModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN28LightsModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZNSt9type_infoD2Ev: __ZNSt9type_infoD2Ev, __Z30setPxVehicleNoDrive_SteerAnglePN5physx16PxVehicleNoDriveEjf: __Z30setPxVehicleNoDrive_SteerAnglePN5physx16PxVehicleNoDriveEjf, __ZN25VirtualJoystickPropertiesC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb: __ZN25VirtualJoystickPropertiesC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEEb, __Z22Material_CUSTOM_GetTagP12Il2CppObjectP12Il2CppStringhS2_: __Z22Material_CUSTOM_GetTagP12Il2CppObjectP12Il2CppStringhS2_, __Z16FlaggedAsSkippedIA256_cEbRK13FileEntryInfoRKT_19FileEnumerationFlag: __Z16FlaggedAsSkippedIA256_cEbRK13FileEntryInfoRKT_19FileEnumerationFlag, __ZN15RaycastCallbackD0Ev: __ZN15RaycastCallbackD0Ev, __ZNK19ShaderPropertySheet7IsDirtyEv: __ZNK19ShaderPropertySheet7IsDirtyEv, __ZN9WWWCached7GetSizeEv: __ZN9WWWCached7GetSizeEv, __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE: __ZN5physx3Scb5Scene17scheduleForUpdateERNS0_4BaseE, __Z53Register_UnityEngine_Collider2D_INTERNAL_CALL_Raycastv: __Z53Register_UnityEngine_Collider2D_INTERNAL_CALL_Raycastv, __ZN5physx2Sc15ContactIterator4Pair14getNextContactEv: __ZN5physx2Sc15ContactIterator4Pair14getNextContactEv, __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve: __Z58ParticleSystem_LimitVelocityOverLifetimeModule_CUSTOM_GetZP12Il2CppObjectR15MonoMinMaxCurve, __Z41DecompressNativeTextureFormatWithMipLevel13TextureFormatS_iiiPKjiiPj: __Z41DecompressNativeTextureFormatWithMipLevel13TextureFormatS_iiiPKjiiPj, __ZNK6Camera27CalculateViewportRayVectorsERK5RectTIfEf21MonoOrStereoscopicEyeP8Vector3f: __ZNK6Camera27CalculateViewportRayVectorsERK5RectTIfEf21MonoOrStereoscopicEyeP8Vector3f, __ZNK13BaseAllocator22GetNumberOfAllocationsEv: __ZNK13BaseAllocator22GetNumberOfAllocationsEv, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI21AnimationClipOverrideLj4EEEEvRT_17TransferMetaFlags, __Z51Register_UnityEngine_RenderTexture_set_antiAliasingv: __Z51Register_UnityEngine_RenderTexture_set_antiAliasingv, __Z67Register_UnityEngine_Connect_UnityConnectSettings_set_testConfigUrlv: __Z67Register_UnityEngine_Connect_UnityConnectSettings_set_testConfigUrlv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Sc13ConstraintSimEEEE4copyINS0_15InlineAllocatorILj256ES6_EEEEvRKNS1_IS2_T_EE, __ZNK26AnimatorOverrideController13GetBehavioursEv: __ZNK26AnimatorOverrideController13GetBehavioursEv, __ZN20ExternalForcesModule8TransferI14SafeBinaryReadEEvRT_: __ZN20ExternalForcesModule8TransferI14SafeBinaryReadEEvRT_, __ZNK13SpeedTreeWind14GetShaderTableEv: __ZNK13SpeedTreeWind14GetShaderTableEv, __ZN5physx7NpCloth20sendPvdRestPositionsEv: __ZN5physx7NpCloth20sendPvdRestPositionsEv, __ZN4FMOD7SystemI17getNetworkTimeoutEPi: __ZN4FMOD7SystemI17getNetworkTimeoutEPi, __ZNKSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_: __ZNKSt3__23mapI8UnityStrjNS_4lessIS1_EE13stl_allocatorINS_4pairIKS1_jEEL18MemLabelIdentifier85ELi16EEE16__find_equal_keyERPNS_16__tree_node_baseIPvEERS6_, __Z39ParticleAnimator_Get_Custom_PropDampingP12Il2CppObject: __Z39ParticleAnimator_Get_Custom_PropDampingP12Il2CppObject, __Z39Register_UnityEngine_Input_GetKeyStringv: __Z39Register_UnityEngine_Input_GetKeyStringv, __ZNKSt3__212ctype_bynameIwE10do_tolowerEw: __ZNKSt3__212ctype_bynameIwE10do_tolowerEw, __ZNK10FlareLayer26GetTypeInfoVirtualInternalEv: __ZNK10FlareLayer26GetTypeInfoVirtualInternalEv, __ZNSt3__219__shared_weak_countD0Ev: __ZNSt3__219__shared_weak_countD0Ev, __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI17SortingLayerEntryNS_9allocatorIS1_EEE21__push_back_slow_pathIKS1_EEvRT_, __ZNK5Umbra10PortalInfo9getCenterERNS_7Vector3E: __ZNK5Umbra10PortalInfo9getCenterERNS_7Vector3E, __ZN6Motion7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN6Motion7PRODUCEE10MemLabelId18ObjectCreationMode, _UNITY_FT_Set_Renderer: _UNITY_FT_Set_Renderer, __ZN6CameraC2E10MemLabelId18ObjectCreationMode: __ZN6CameraC2E10MemLabelId18ObjectCreationMode, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxJointLinearLimitPairEEEE14handleAccessorILj487ENS_22PxRepXPropertyAccessorILj487ENS_22PxJointLimitParametersEffEEEEvRKT0_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj461ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj461ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx18PxGetAssertHandlerEv: __ZN5physx18PxGetAssertHandlerEv, __Z18CalculateLocalAABBRK10GameObjectP4AABB: __Z18CalculateLocalAABBRK10GameObjectP4AABB, __ZN2UI13RectTransform17SetDrivenByObjectEPK6Object: __ZN2UI13RectTransform17SetDrivenByObjectEPK6Object, __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN17AnimationCurveTplIfE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK10__cxxabiv120__function_type_info9can_catchEPKNS_16__shim_type_infoERPv: __ZNK10__cxxabiv120__function_type_info9can_catchEPKNS_16__shim_type_infoERPv, __ZN18ProceduralMaterial17AwakeDependenciesEb: __ZN18ProceduralMaterial17AwakeDependenciesEb, __ZN12_GLOBAL__N_113StaticDestroyEPv: __ZN12_GLOBAL__N_113StaticDestroyEPv, __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc12SimStateDataENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN20ComputeShaderVariant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN20ComputeShaderVariant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__26locale5__impC2Ej: __ZNSt3__26locale5__impC2Ej, __ZN15TerrainRenderer11RenderStep3EP6Cameraib20ReflectionProbeUsageP9TransformRK13dynamic_arrayIP8MaterialLj4EES7_: __ZN15TerrainRenderer11RenderStep3EP6Cameraib20ReflectionProbeUsageP9TransformRK13dynamic_arrayIP8MaterialLj4EES7_, __Z26RecalculateSplineSlopeLoopI8Vector3fEvR17AnimationCurveTplIT_Eif: __Z26RecalculateSplineSlopeLoopI8Vector3fEvR17AnimationCurveTplIT_Eif, __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_116parse_expressionINS0_2DbEEEPKcS4_S4_RT_, __Z62Register_UnityEngine_CharacterJoint_INTERNAL_get_lowTwistLimitv: __Z62Register_UnityEngine_CharacterJoint_INTERNAL_get_lowTwistLimitv, __ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags: __ZN15FileSystemEntry6CopyToERS_23FileSystemCopyMoveFlags, __ZN5physx2Gu11HeightFieldD0Ev: __ZN5physx2Gu11HeightFieldD0Ev, __ZNK2UI6Canvas16GetTargetDisplayEv: __ZNK2UI6Canvas16GetTargetDisplayEv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9UnityGUIDEEEvRT_17TransferMetaFlags, __ZN30VelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN30VelocityModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_17TransferMetaFlags, __ZN15GlobalCallbacks3GetEv: __ZN15GlobalCallbacks3GetEv, __ZN24RingBufferMemoryFileData16GetNewWriteBlockEv: __ZN24RingBufferMemoryFileData16GetNewWriteBlockEv, __Z39setPxHeightFieldDescConvexEdgeThresholdPN5physx17PxHeightFieldDescEf: __Z39setPxHeightFieldDescConvexEdgeThresholdPN5physx17PxHeightFieldDescEf, __Z37setPxVehicleDriveDynDataMUseAutoGearsPN5physx21PxVehicleDriveDynDataEb: __Z37setPxVehicleDriveDynDataMUseAutoGearsPN5physx21PxVehicleDriveDynDataEb, __ZNK5physx7NpCloth21getStiffnessFrequencyEv: __ZNK5physx7NpCloth21getStiffnessFrequencyEv, __ZN25ConvexVsMeshSweepCallbackC2ERKN5physx2Gu14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEbfb: __ZN25ConvexVsMeshSweepCallbackC2ERKN5physx2Gu14ConvexHullDataERKNS0_11PxMeshScaleERKNS0_2Cm23FastVertex2ShapeScalingERKNS0_11PxTransformESE_RKNS0_6PxVec3EfNS0_7PxFlagsINS0_9PxHitFlag4EnumEtEEbfb, __Z46QualitySettings_Get_Custom_PropMaximumLODLevelv: __Z46QualitySettings_Get_Custom_PropMaximumLODLevelv, __ZN7Texture13SetMipMapBiasEf: __ZN7Texture13SetMipMapBiasEf, __ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE: __ZN5physx2Gu10ReadHeaderEhhhhRjRbRNS_13PxInputStreamE, __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN11AudioFilter8TransferI19StreamedBinaryWriteILb0EEEEvRT_, _cf2_hint_isValid: _cf2_hint_isValid, __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE: __ZN14ParticleSystem7Update2ERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemStateNS_11UpdateFlagsE, __ZN27TrailModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE: __ZN27TrailModulePropertyBindings13AddPropertiesER10vector_mapIi22ParticleModulePropertyNSt3__24lessIiEENS2_9allocatorINS2_4pairIiS1_EEEEE, __ZN7mecanim9animation21SkeletonPoseFromValueIN4math7affineXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTINS2_4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib: __ZN7mecanim9animation21SkeletonPoseFromValueIN4math7affineXEEEvRKNS_8skeleton8SkeletonERKNS4_13SkeletonPoseTINS2_4trsXEEERKNS_10ValueArrayEPKNS0_14SkeletonTQSMapERNS8_IT_EEPKib, __ZN5physx12NpBatchQueryD2Ev: __ZN5physx12NpBatchQueryD2Ev, __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc: __ZNSt3__29__num_getIcE17__stage2_int_prepERNS_8ios_baseEPcRc, __ZN5physx6shdfnd5ArrayINS_2Sn5UnionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_: __ZN5physx6shdfnd5ArrayINS_2Sn5UnionENS0_19ReflectionAllocatorIS3_EEE15growAndPushBackERKS3_, __Z29StdTemplateConversionFunctionIytEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIytEbPvR14SafeBinaryRead, __ZNSt3__218__insertion_sort_3IRNS_6__lessIssEEPsEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IRNS_6__lessIssEEPsEEvT0_S5_T_, __ZNK5physx2Sc15ArticulationSim28debugCheckWakeCounterOfLinksEf: __ZNK5physx2Sc15ArticulationSim28debugCheckWakeCounterOfLinksEf, __Z34Caching_CUSTOM_GetVersionFromCacheP12Il2CppString: __Z34Caching_CUSTOM_GetVersionFromCacheP12Il2CppString, __ZN20TextRenderingPrivate7GUIText11GetMaterialEv: __ZN20TextRenderingPrivate7GUIText11GetMaterialEv, __ZN15LightmapSTCache5ApplyERK10RenderNode: __ZN15LightmapSTCache5ApplyERK10RenderNode, __ZNK5physx21SapPostUpdateWorkTask7getNameEv: __ZNK5physx21SapPostUpdateWorkTask7getNameEv, __ZNK12b2ChainShape13GetChildCountEv: __ZNK12b2ChainShape13GetChildCountEv, __ZN5Umbra9Matrix3x36invertERKS0_: __ZN5Umbra9Matrix3x36invertERKS0_, __ZN13RenderTexture19SetAutoGenerateMipsEb: __ZN13RenderTexture19SetAutoGenerateMipsEb, __ZN5physx41solveContactCoulomb_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx41solveContactCoulomb_BStaticBlockWriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_18PxVehicleGearsDataEE12readPropertyIfEEbRT_, __Z34MonoBehaviour_CUSTOM_StopCoroutineP12Il2CppObjectP12Il2CppString: __Z34MonoBehaviour_CUSTOM_StopCoroutineP12Il2CppObjectP12Il2CppString, __ZN11dtPathQueueD2Ev: __ZN11dtPathQueueD2Ev, __Z18Transfer_BlittableI8JSONReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN10AudioMixer15ThreadedCleanupEv: __ZN10AudioMixer15ThreadedCleanupEv, __Z44Register_UnityEngine_GUIStyle_set_fixedWidthv: __Z44Register_UnityEngine_GUIStyle_set_fixedWidthv, __ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv: __ZNK5physx5cloth14IterationStateI8Scalar4fE15getCurrentAlphaEv, __GLOBAL__sub_I_umbra_cpp: __GLOBAL__sub_I_umbra_cpp, __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetEnabledP12Il2CppObject: __Z60ParticleSystem_TextureSheetAnimationModule_CUSTOM_GetEnabledP12Il2CppObject, __ZN19TransportJavaScript10OnResponseEPviS0_jPc: __ZN19TransportJavaScript10OnResponseEPviS0_jPc, __Z53setPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj: __Z53setPxVehicleWheelsSimData_LowForwardSpeedSubStepCountPN5physx22PxVehicleWheelsSimDataEj, __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh: __ZNK5physx2Sc5Scene21getDominanceGroupPairEhh, __ZN7ApiGLES11BindProgramEjb: __ZN7ApiGLES11BindProgramEjb, __Z44RenderSettings_Get_Custom_PropFogEndDistancev: __Z44RenderSettings_Get_Custom_PropFogEndDistancev, __Z71Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustRectv: __Z71Register_UnityEngine_RectTransformUtility_INTERNAL_CALL_PixelAdjustRectv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z36AudioSource_Get_Custom_PropIsVirtualP12Il2CppObject: __Z36AudioSource_Get_Custom_PropIsVirtualP12Il2CppObject, __ZN16b2ContactManager7DestroyEP9b2Contact: __ZN16b2ContactManager7DestroyEP9b2Contact, __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI9Texture2DE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNK5physx16PxVehicleNoDrive8isKindOfEPKc: __ZNK5physx16PxVehicleNoDrive8isKindOfEPKc, __ZN17AnimationPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE: __ZN17AnimationPlayable7DestroyERN7mecanim6memory16MecanimAllocatorE, __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej: __ZNSt3__29money_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEEC2Ej, __ZN15NavMeshObstacleD2Ev: __ZN15NavMeshObstacleD2Ev, __ZN16ReflectionSample10InvalidateEv: __ZN16ReflectionSample10InvalidateEv, __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_11NpAggregateEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z39PolygonCollider2D_Get_Custom_PropPointsP12Il2CppObject: __Z39PolygonCollider2D_Get_Custom_PropPointsP12Il2CppObject, __Z35SetMeshComponentFromArrayFromScriptR4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi: __Z35SetMeshComponentFromArrayFromScriptR4Mesh30InternalScriptingShaderChannel34InternalScriptingVertexChannelTypeiP11Il2CppArrayi, _exp10: _exp10, __ZN4FMOD7SystemI20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb: __ZN4FMOD7SystemI20get3DSpeakerPositionE12FMOD_SPEAKERPfS2_Pb, __Z45Physics2D_Get_Custom_PropMaxAngularCorrectionv: __Z45Physics2D_Get_Custom_PropMaxAngularCorrectionv, __Z19CalcBoxWorldExtentsPfPKfS1_S1_S1_: __Z19CalcBoxWorldExtentsPfPKfS1_S1_S1_, __ZN9WWWCached6CancelEv: __ZN9WWWCached6CancelEv, __ZN15AudioReverbZone7CleanupEv: __ZN15AudioReverbZone7CleanupEv, __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_secondaryAxisv: __Z65Register_UnityEngine_ConfigurableJoint_INTERNAL_set_secondaryAxisv, __ZN4FMOD7SystemI11recordStartEiPNS_5SoundEb: __ZN4FMOD7SystemI11recordStartEiPNS_5SoundEb, __Z26TerrainData_CUSTOM_HasUserP12Il2CppObjectS0_: __Z26TerrainData_CUSTOM_HasUserP12Il2CppObjectS0_, __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE: __ZN5physx2Gu27PCMContactConvexHeightfieldERKNS0_13PolygonalDataEPNS0_12SupportLocalERKNS_6shdfnd3aos6FloatVERKNS_9PxBounds3ERKNS_21PxHeightFieldGeometryERKNS_11PxTransformESJ_fRNS0_13ContactBufferERKNS_2Cm23FastVertex2ShapeScalingEbRNS0_33MultiplePersistentContactManifoldE, _cf2_hintmask_setAll: _cf2_hintmask_setAll, __ZN2UI14DepthSortLayer12AddWithDepthERKNS_23RenderableUIInstructionEi: __ZN2UI14DepthSortLayer12AddWithDepthERKNS_23RenderableUIInstructionEi, __Z47Register_UnityEngine_AudioReverbFilter_get_roomv: __Z47Register_UnityEngine_AudioReverbFilter_get_roomv, __ZN5Umbra16LineSegmentQueryC2ERKNS_7Vector3ES3_PNS_9IndexListE: __ZN5Umbra16LineSegmentQueryC2ERKNS_7Vector3ES3_PNS_9IndexListE, __ZN12NavMeshAgent23VirtualRedirectTransferER14SafeBinaryRead: __ZN12NavMeshAgent23VirtualRedirectTransferER14SafeBinaryRead, __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playableb: __ZN26AnimatorControllerPlayable12PrepareFrameERK9FrameDataP8Playableb, __ZN17BillboardRenderer12SetBillboardERK4PPtrI14BillboardAssetE: __ZN17BillboardRenderer12SetBillboardERK4PPtrI14BillboardAssetE, __ZNK14ImageReference13NeedsReformatEii13TextureFormat: __ZNK14ImageReference13NeedsReformatEii13TextureFormat, __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev: __ZTv0_n12_NSt3__213basic_ostreamIwNS_11char_traitsIwEEED0Ev, __Z7ApplySHR15SHConstantCacheRK17LightProbeContextRK10RenderNodeb: __Z7ApplySHR15SHConstantCacheRK17LightProbeContextRK10RenderNodeb, __Z16CreateGpuProgram20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput: __Z16CreateGpuProgram20ShaderGpuProgramTypeRK13dynamic_arrayIhLj1EER22CreateGpuProgramOutput, __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_set_centerOfMassv: __Z58Register_UnityEngine_Rigidbody2D_INTERNAL_set_centerOfMassv, __ZN9GfxDevice21CopyRenderSurfaceDescEP17RenderSurfaceBasePKS0_: __ZN9GfxDevice21CopyRenderSurfaceDescEP17RenderSurfaceBasePKS0_, __Z46QualitySettings_Get_Custom_PropMaxQueuedFramesv: __Z46QualitySettings_Get_Custom_PropMaxQueuedFramesv, __ZNK13WheelCollider29FindRigidBodyToWheelTransformEPK9Rigidbody: __ZNK13WheelCollider29FindRigidBodyToWheelTransformEPK9Rigidbody, __Z57Register_UnityEngine_RenderSettings_set_reflectionBouncesv: __Z57Register_UnityEngine_RenderSettings_set_reflectionBouncesv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_9PxD6JointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __Z10dictSearchP4DictPv: __Z10dictSearchP4DictPv, __ZN7TextureD0Ev: __ZN7TextureD0Ev, _strncpy: _strncpy, __ZN8Collider16SetContactOffsetEf: __ZN8Collider16SetContactOffsetEf, __ZNK5physx6shdfnd7FastIPC8isServerEv: __ZNK5physx6shdfnd7FastIPC8isServerEv, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZNSt3__218__insertion_sort_3IR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_: __ZNSt3__218__insertion_sort_3IR24RayHitsByDepthComparitorP12RaycastHit2DEEvT0_S5_T_, __Z34AreaEffector2D_Set_Custom_PropDragP12Il2CppObjectf: __Z34AreaEffector2D_Set_Custom_PropDragP12Il2CppObjectf, __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ResetFieldOfViewv: __Z58Register_UnityEngine_Camera_INTERNAL_CALL_ResetFieldOfViewv, __ZN5physx9NpFactory30releaseArticulationJointToPoolERNS_19NpArticulationJointE: __ZN5physx9NpFactory30releaseArticulationJointToPoolERNS_19NpArticulationJointE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj686ES2_RKNS_27PxVehicleDifferentialNWDataES6_EEKNS_40PxVehicleDifferentialNWDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_23PxVehicleDriveSimDataNWEE15complexPropertyINS_22PxRepXPropertyAccessorILj686ES2_RKNS_27PxVehicleDifferentialNWDataES6_EEKNS_40PxVehicleDifferentialNWDataGeneratedInfoEEEvPjRKT_RT0_, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLESt16initializer_listIcE: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEpLESt16initializer_listIcE, __Z11SkinGenericILi4ELb1ELb0EEvR12SkinMeshInfo: __Z11SkinGenericILi4ELb1ELb0EEvR12SkinMeshInfo, __Z40Collider2D_Get_Custom_PropSharedMaterialP12Il2CppObject: __Z40Collider2D_Get_Custom_PropSharedMaterialP12Il2CppObject, __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E: __ZN5physx5cloth9ClothImplINS0_7SwClothEE16setLinearInertiaERKNS_6PxVec3E, __ZN5physx2Sn18RepXCollectionImpl12copyRepXNodeEPKNS0_7XmlNodeE: __ZN5physx2Sn18RepXCollectionImpl12copyRepXNodeEPKNS0_7XmlNodeE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIdLj8EEEEvRT_17TransferMetaFlags, __ZN13GfxDeviceGLES5ClearEjRK10ColorRGBAffj: __ZN13GfxDeviceGLES5ClearEjRK10ColorRGBAffj, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayINSt3__26vectorI17SubstanceEnumItemNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN15PointEffector2DD2Ev: __ZN15PointEffector2DD2Ev, __Z44Register_UnityEngine_Graphics_set_activeTierv: __Z44Register_UnityEngine_Graphics_set_activeTierv, __ZN9Animation10RemoveClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation10RemoveClipERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN25RuntimeAnimatorController23DestroyCustomControllerEPN7mecanim9animation18ControllerConstantERNS0_6memory9AllocatorE: __ZN25RuntimeAnimatorController23DestroyCustomControllerEPN7mecanim9animation18ControllerConstantERNS0_6memory9AllocatorE, __ZN14VehiclesModule17InvalidateVehicleEj: __ZN14VehiclesModule17InvalidateVehicleEj, __Z16BytesToHexStringPKvj: __Z16BytesToHexStringPKvj, __ZN5physx14PxVehicleGraph5setupERKNS_18PxVehicleGraphDescENS_18PxVehicleGraphType4EnumE: __ZN5physx14PxVehicleGraph5setupERKNS_18PxVehicleGraphDescENS_18PxVehicleGraphType4EnumE, __ZN19ConstantBuffersGLES13UpdateBuffersEv: __ZN19ConstantBuffersGLES13UpdateBuffersEv, __ZN5physx28collideWithStaticHeightFieldEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEfRKNS_11PxTransformE: __ZN5physx28collideWithStaticHeightFieldEPNS_19PxsParticleCollDataEjRKNS_2Gu13GeometryUnionEfRKNS_11PxTransformE, __ZNK5physx7NpScene23getSimulationStatisticsERNS_22PxSimulationStatisticsE: __ZNK5physx7NpScene23getSimulationStatisticsERNS_22PxSimulationStatisticsE, __ZN11UnityEngine15CloudWebService16WWWRestHeaderMapaSERKS1_: __ZN11UnityEngine15CloudWebService16WWWRestHeaderMapaSERKS1_, __ZN14NavMeshManager20CalculatePolygonPathEP11NavMeshPathRK8Vector3fS4_RK13dtQueryFilter: __ZN14NavMeshManager20CalculatePolygonPathEP11NavMeshPathRK8Vector3fS4_RK13dtQueryFilter, __ZN6Camera8SetDepthEf: __ZN6Camera8SetDepthEf, __ZN11UnityEngine7Connect20BasePersistentValuesD0Ev: __ZN11UnityEngine7Connect20BasePersistentValuesD0Ev, __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIfEEclERS1_17TransferMetaFlagsR9BlobWrite: __ZN34BlobWriteTransferSTLStyleArrayImplI22OffsetPtrArrayTransferIfEEclERS1_17TransferMetaFlagsR9BlobWrite, __ZN5physx2Sc5Scene17stepSetupSimulateEv: __ZN5physx2Sc5Scene17stepSetupSimulateEv, __Z64Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleWithParentP12Il2CppObjectS0_RK8Vector3fRK11Quaternionf: __Z64Object_CUSTOM_INTERNAL_CALL_Internal_InstantiateSingleWithParentP12Il2CppObjectS0_RK8Vector3fRK11Quaternionf, __ZN11IMGUIModule25IsDeveloperConsoleVisibleEv: __ZN11IMGUIModule25IsDeveloperConsoleVisibleEv, __Z20AddActiveLocalLightsR11CullResultsPPK5LightPK8Vector4fRK9IndexListPfRS8_R12ActiveLightsP5RectTIfEP13TargetEyeMask: __Z20AddActiveLocalLightsR11CullResultsPPK5LightPK8Vector4fRK9IndexListPfRS8_R12ActiveLightsP5RectTIfEP13TargetEyeMask, __Z8GetTouchjR5Touch: __Z8GetTouchjR5Touch, __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxv: __Z55Register_UnityEngine_Physics2D_INTERNAL_CALL_OverlapBoxv, __ZN4PPtrI16SubstanceArchiveE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrI16SubstanceArchiveE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN4FMOD7SystemI26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES: __ZN4FMOD7SystemI26getReverbAmbientPropertiesEP22FMOD_REVERB_PROPERTIES, __Z47Register_UnityEngine_GUIUtility_HasMouseControlv: __Z47Register_UnityEngine_GUIUtility_HasMouseControlv, __ZNK5physx29PxVehicleDriveNWGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j: __ZNK5physx29PxVehicleDriveNWGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_16PxVehicleDriveNWEEEEEEEjT_j, __ZN5physx8debugger16ClassDescriptionD2Ev: __ZN5physx8debugger16ClassDescriptionD2Ev, __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj: __ZN15dense_hashtableINSt3__24pairIKNS1_IPK10Collider2DS4_EEjEES5_NS2_23ColliderPairHashFunctorEN14dense_hash_mapIS5_jS8_NS0_8equal_toIS5_EE13stl_allocatorIS7_L18MemLabelIdentifier65ELi16EEE9SelectKeyESB_SE_E12resize_deltaEjj, __Z51Register_UnityEngine_AndroidJNI_GetStaticFloatFieldv: __Z51Register_UnityEngine_AndroidJNI_GetStaticFloatFieldv, __ZN17Physics2DSettings17SetBaumgarteScaleEf: __ZN17Physics2DSettings17SetBaumgarteScaleEf, __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_16PxsFluidDynamicsEXadL_ZNS2_10mergeForceEPNS_10PxBaseTaskEEEE7getNameEv, __ZN7mecanim12statemachine21SelectorStateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN7mecanim12statemachine21SelectorStateConstant8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_limitsv: __Z51Register_UnityEngine_HingeJoint_INTERNAL_get_limitsv, __ZN11JpegDecoder11InitDecoderEv: __ZN11JpegDecoder11InitDecoderEv, __ZL24stbir__calculate_filtersP11stbir__infoP19stbir__contributorsPf12stbir_filterffii: __ZL24stbir__calculate_filtersP11stbir__infoP19stbir__contributorsPf12stbir_filterffii, __ZN19ConstantBuffersGLES10ResetBindsEv: __ZN19ConstantBuffersGLES10ResetBindsEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_19PxArticulationJointEEEEclILj76ES4_fEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEEclILj283ES3_PNS_13PxHeightFieldES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z32Texture3D_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormath: __Z32Texture3D_CUSTOM_Internal_CreateP12Il2CppObjectiii13TextureFormath, __Z15UpdateLightsTplILb1EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem: __Z15UpdateLightsTplILb1EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem, __ZN23SweepBoxMeshHitCallbackD0Ev: __ZN23SweepBoxMeshHitCallbackD0Ev, __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESF_SF_j: __ZNSt3__26vectorI8UnityStrNS_9allocatorIS1_EEE18__construct_at_endINS_11__wrap_iterIPNS_12basic_stringIcNS_11char_traitsIcEENS2_IcEEEEEEEENS_9enable_ifIXsr21__is_forward_iteratorIT_EE5valueEvE4typeESF_SF_j, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_110TripletSetENS0_9AllocatorEE6resizeEjRKS3_, __ZN5Unity17ConfigurableJoint20SetHighAngularXLimitERK14SoftJointLimit: __ZN5Unity17ConfigurableJoint20SetHighAngularXLimitERK14SoftJointLimit, __Z39NavMeshAgent_Get_Custom_PropPathPendingP12Il2CppObject: __Z39NavMeshAgent_Get_Custom_PropPathPendingP12Il2CppObject, __Z45ParticleSystem_CollisionModule_CUSTOM_SetModeP12Il2CppObjecti: __Z45ParticleSystem_CollisionModule_CUSTOM_SetModeP12Il2CppObjecti, __Z8EvaluateRK14MinMaxGradientff: __Z8EvaluateRK14MinMaxGradientff, __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_: __ZNSt3__26__sortIRNS_6__lessI8UnityStrS2_EEPS2_EEvT0_S6_T_, __Z41ParticleSystem_Get_Custom_PropPlayOnAwakeP12Il2CppObject: __Z41ParticleSystem_Get_Custom_PropPlayOnAwakeP12Il2CppObject, _UNITY_png_set_PLTE: _UNITY_png_set_PLTE, __Z43AnimationClipPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable: __Z43AnimationClipPlayable_CUSTOM_InternalCreateP12Il2CppObjectR9HPlayable, __ZNK5physx2Gu15HeightFieldUtil14isBoundaryEdgeEj: __ZNK5physx2Gu15HeightFieldUtil14isBoundaryEdgeEj, __Z38AndroidJNI_CUSTOM_GetStaticStringField13Il2Cpp_IntPtrS_: __Z38AndroidJNI_CUSTOM_GetStaticStringField13Il2Cpp_IntPtrS_, __ZN5physx2Sc16ArticulationCore12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_: __ZN5physx2Sc16ArticulationCore12applyImpulseERNS0_8BodyCoreERKNS_9PxcFsDataERKNS_6PxVec3ES9_, __ZN6Shader8TransferI14SafeBinaryReadEEvRT_: __ZN6Shader8TransferI14SafeBinaryReadEEvRT_, __Z27Material_CUSTOM_HasPropertyP12Il2CppObjecti: __Z27Material_CUSTOM_HasPropertyP12Il2CppObjecti, __ZNK13GfxDeviceGLES14GetDeviceLevelEv: __ZNK13GfxDeviceGLES14GetDeviceLevelEv, __ZN11UnityEngine7Connect14RemoteSettings13ConfigChangedERK8UnityStrR8JSONRead: __ZN11UnityEngine7Connect14RemoteSettings13ConfigChangedERK8UnityStrR8JSONRead, __Z19TransferField_ArrayI14SafeBinaryRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI14SafeBinaryRead27Converter_UnityEngineObjectEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_get_forcev: __Z56Register_UnityEngine_ParticleAnimator_INTERNAL_get_forcev, __ZN8DrawUtil11DrawMeshRawERK14ChannelAssignsR4MeshiiPS3_: __ZN8DrawUtil11DrawMeshRawERK14ChannelAssignsR4MeshiiPS3_, __ZN20SubstanceArchiveDataD0Ev: __ZN20SubstanceArchiveDataD0Ev, __ZN11MonoManagerD0Ev: __ZN11MonoManagerD0Ev, __ZN15NavMeshObstacle15InitializeClassEv: __ZN15NavMeshObstacle15InitializeClassEv, __ZN13RuntimeStaticI18UnityConnectClientE13StaticDestroyEPv: __ZN13RuntimeStaticI18UnityConnectClientE13StaticDestroyEPv, __ZN11SoundHandle20UnbindFromSampleClipEv: __ZN11SoundHandle20UnbindFromSampleClipEv, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPcic: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getEPcic, __Z29AudioMixerSendProcessCallbackP21UnityAudioEffectStatePfS1_jii: __Z29AudioMixerSendProcessCallbackP21UnityAudioEffectStatePfS1_jii, __ZN7b2ShapeD2Ev: __ZN7b2ShapeD2Ev, __Z18ClearFilterExtentsP10CBBoxInt32: __Z18ClearFilterExtentsP10CBBoxInt32, __Z24RegisterStrippedTypeInfoI18AnimatorControllerEviPKcS2_: __Z24RegisterStrippedTypeInfoI18AnimatorControllerEviPKcS2_, __ZNK5physx6PxBase12isReleasableEv: __ZNK5physx6PxBase12isReleasableEv, __ZN5physx7NpScene10startWriteEb: __ZN5physx7NpScene10startWriteEb, __ZN14AreaEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE: __ZN14AreaEffector2D20BeginContactCallbackERN10Effector2D15EffectorContactE, __Z31RegisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE: __Z31RegisterDeviceEventCallbackImplPFv23UnityGfxDeviceEventTypeE, __ZN5Umbra10Visibility17setOutputClustersEPNS_9IndexListE: __ZN5Umbra10Visibility17setOutputClustersEPNS_9IndexListE, __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EOS3_: __ZNSt3__213basic_ostreamIwNS_11char_traitsIwEEEC2EOS3_, __Z36CalculateLODGroupBoundsCenterAndSizeR8Vector3fRfRK8LODGroup: __Z36CalculateLODGroupBoundsCenterAndSizeR8Vector3fRfRK8LODGroup, __GLOBAL__sub_I_artifacts_generated_webgl_runtime3_lump_cpp: __GLOBAL__sub_I_artifacts_generated_webgl_runtime3_lump_cpp, __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient: __Z9UpdateTplIL22MinMaxGradientEvalMode0EL12GradientMode1ELS1_1EEvRK23ParticleSystemParticlesP11ColorRGBA32RK14MinMaxGradientRK23OptimizedMinMaxGradient, __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL26solveContactCoulomb4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z33TrailRenderer_Set_Custom_PropTimeP12Il2CppObjectf: __Z33TrailRenderer_Set_Custom_PropTimeP12Il2CppObjectf, __ZN6Skybox23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN6Skybox23VirtualRedirectTransferER24GenerateTypeTreeTransfer, _cff_face_init: _cff_face_init, __Z48Register_UnityEngine_PlayerPrefs_TrySetSetStringv: __Z48Register_UnityEngine_PlayerPrefs_TrySetSetStringv, __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E: __Z34CalculateGlobalPositionAndRotation23TransformAccessReadOnlyRKN4math7_float3ERKNS0_7_float4E, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_SetZMultiplierP12Il2CppObjectf, __Z48RelativeJoint2D_CUSTOM_INTERNAL_set_linearOffsetP12Il2CppObjectRK13Vector2fIcall: __Z48RelativeJoint2D_CUSTOM_INTERNAL_set_linearOffsetP12Il2CppObjectRK13Vector2fIcall, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEE14handleAccessorILj287ENS_22PxRepXPropertyAccessorILj287ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxHeightFieldGeometryEEEE14handleAccessorILj287ENS_22PxRepXPropertyAccessorILj287ES4_NS_7PxFlagsINS_18PxMeshGeometryFlag4EnumEhEESC_EEEEvRKT0_, __Z38setPxD6Joint_ProjectionLinearTolerancePN5physx9PxD6JointEf: __Z38setPxD6Joint_ProjectionLinearTolerancePN5physx9PxD6JointEf, __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim5human9HumanGoal8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z62Register_UnityEngine_Physics2D_INTERNAL_set_colliderAwakeColorv: __Z62Register_UnityEngine_Physics2D_INTERNAL_set_colliderAwakeColorv, __ZN17PersistentManager27IntegrateAllThreadedObjectsEv: __ZN17PersistentManager27IntegrateAllThreadedObjectsEv, __ZN5physx5cloth10findBitSetEj: __ZN5physx5cloth10findBitSetEj, __ZN20LocalFileSystemPosix10AtomicMoveER13FileEntryDataS1_: __ZN20LocalFileSystemPosix10AtomicMoveER13FileEntryDataS1_, __ZNK9Rigidbody7GetMassEv: __ZNK9Rigidbody7GetMassEv, __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21WorldParticleCollider8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4File7IsValidEv: __ZN4File7IsValidEv, __ZN4FMOD6System6updateEv: __ZN4FMOD6System6updateEv, __ZN4FMOD7Channel7getModeEPj: __ZN4FMOD7Channel7getModeEPj, __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_16NpParticleSystemEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN9GfxDevice25GenerateRenderSurfaceMipsEP17RenderSurfaceBase: __ZN9GfxDevice25GenerateRenderSurfaceMipsEP17RenderSurfaceBase, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj472ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEEclILj472ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE21__push_back_slow_pathIKS1_EEvRT_: __ZNSt3__26vectorI8Particle13stl_allocatorIS1_L18MemLabelIdentifier18ELi16EEE21__push_back_slow_pathIKS1_EEvRT_, __Z42CapsuleCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f: __Z42CapsuleCollider_CUSTOM_INTERNAL_set_centerP12Il2CppObjectRK8Vector3f, __Z17PxcPoolMallocInitv: __Z17PxcPoolMallocInitv, __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN13BuildSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup11LODStruct50ENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup11LODStruct50ENS1_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_14NpRigidDynamicEEEE15growAndPushBackERKS2_, __ZN4FMOD6System11getCPUUsageEPfS1_S1_S1_S1_: __ZN4FMOD6System11getCPUUsageEPfS1_S1_S1_S1_, __ZN32PlaneColliderCache_dense_hashmapC2Ev: __ZN32PlaneColliderCache_dense_hashmapC2Ev, __Z36QualitySettings_Get_Custom_PropNamesv: __Z36QualitySettings_Get_Custom_PropNamesv, __ZN17AudioCustomFilter14GetOrCreateDSPEv: __ZN17AudioCustomFilter14GetOrCreateDSPEv, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE11do_get_dateES4_S4_RNS_8ios_baseERjP2tm, __ZL20CalculateCapsuleHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff: __ZL20CalculateCapsuleHullR13dynamic_arrayI5PlaneLj4EERK16NavMeshCarveDataRK8Vector3fff, __Z47ConfigurableJoint_Set_Custom_PropAngularXMotionP12Il2CppObjecti: __Z47ConfigurableJoint_Set_Custom_PropAngularXMotionP12Il2CppObjecti, __ZNK25MultiBlocksMemoryFileData4SizeEv: __ZNK25MultiBlocksMemoryFileData4SizeEv, __ZN5physx2Sq10AABBPruner6commitEv: __ZN5physx2Sq10AABBPruner6commitEv, __Z35Register_UnityEngine_WWW_get_isDonev: __Z35Register_UnityEngine_WWW_get_isDonev, __ZThn32_N8RendererD1Ev: __ZThn32_N8RendererD1Ev, __Z29StdTemplateConversionFunctionIhaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIhaEbPvR14SafeBinaryRead, __ZN15b2FrictionJointC2EPK18b2FrictionJointDef: __ZN15b2FrictionJointC2EPK18b2FrictionJointDef, __Z18Transfer_BlittableI8JSONReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0EiEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN5physx2Cm17FreeListAllocator11directAllocEj: __ZN5physx2Cm17FreeListAllocator11directAllocEj, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5clearEv: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE5clearEv, __ZNK5physx2Cm8PtrTable4findEPKv: __ZNK5physx2Cm8PtrTable4findEPKv, __ZNSt3__227__insertion_sort_incompleteIRPFbRK16NavMeshCarveDataS3_EPS1_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRPFbRK16NavMeshCarveDataS3_EPS1_EEbT0_S8_T_, __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17setDominanceGroupEh: __ZN5physx15NpActorTemplateINS_15PxParticleFluidEE17setDominanceGroupEh, __Z44GUIStyle_CUSTOM_INTERNAL_CALL_Internal_Draw213Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih: __Z44GUIStyle_CUSTOM_INTERNAL_CALL_Internal_Draw213Il2Cpp_IntPtrRK5RectTIfEP12Il2CppObjectih, __ZN19SpriteMeshGenerator4pathC2ERKS0_: __ZN19SpriteMeshGenerator4pathC2ERKS0_, __Z41Collider_Get_Custom_PropAttachedRigidbodyP12Il2CppObject: __Z41Collider_Get_Custom_PropAttachedRigidbodyP12Il2CppObject, __ZN5physx2Sc5Scene12onBodyWakeUpEPNS0_7BodySimE: __ZN5physx2Sc5Scene12onBodyWakeUpEPNS0_7BodySimE, __ZN5physx2Cm17FreeListAllocator10directFreeEPv: __ZN5physx2Cm17FreeListAllocator10directFreeEPv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_12PxFixedJointEE14simplePropertyIKNS_3Pvd28PxPvdIndexedPropertyAccessorILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEEEvjRT_, __Z69Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimeMultiplierv: __Z69Register_UnityEngine_ParticleSystem_TrailModule_SetLifetimeMultiplierv, __ZNK14SpriteRenderer26GetTypeInfoVirtualInternalEv: __ZNK14SpriteRenderer26GetTypeInfoVirtualInternalEv, __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_: __ZNSt3__27__sort3IRN10vector_mapI7Hash12813ProbeSetIndexNS_4lessIS2_EENS_9allocatorINS_4pairIS2_S3_EEEEE13value_compareEPS8_EEjT0_SE_SE_T_, __ZN5physx14NpSceneQueriesD0Ev: __ZN5physx14NpSceneQueriesD0Ev, __Z24RegisterStrippedTypeInfoI13TrailRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI13TrailRendererEviPKcS2_, __ZN5UmbramlERKNS_9Matrix4x3ERKNS_9Matrix4x4E: __ZN5UmbramlERKNS_9Matrix4x3ERKNS_9Matrix4x4E, __ZNSt3__213__vector_baseI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEED2Ev: __ZNSt3__213__vector_baseI12TextureInput13stl_allocatorIS1_L18MemLabelIdentifier77ELi16EEED2Ev, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine21SelectorStateConstantEEEEEvRT_17TransferMetaFlags, __ZN11LightProbes13AwakeFromLoadE17AwakeFromLoadMode: __ZN11LightProbes13AwakeFromLoadE17AwakeFromLoadMode, __Z33Material_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray: __Z33Material_CUSTOM_SetFloatArrayImplP12Il2CppObjectiP11Il2CppArray, __Z24WWW_Get_Custom_PropErrorP12Il2CppObject: __Z24WWW_Get_Custom_PropErrorP12Il2CppObject, __ZN2UI11CanvasGroup23VirtualRedirectTransferER14SafeBinaryRead: __ZN2UI11CanvasGroup23VirtualRedirectTransferER14SafeBinaryRead, __Z28createPxPhysics_ConvexMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE: __Z28createPxPhysics_ConvexMeshesPN5physx9PxPhysicsERNS_13PxInputStreamE, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferIN5audio5mixer16SnapshotConstantEEEEvRT_17TransferMetaFlags, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_19NpArticulationJointEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __Z25GetNavMeshProjectSettingsv: __Z25GetNavMeshProjectSettingsv, __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8beginTagEPKc: __ZN5physx2Sn19SimpleXmlWriterImplINS_14PxOutputStreamEE8beginTagEPKc, __Z43Animator_CUSTOM_SetIKPositionWeightInternalP12Il2CppObjectif: __Z43Animator_CUSTOM_SetIKPositionWeightInternalP12Il2CppObjectif, __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI16TexFormatRGFloat15TexFormatRFloatEEvPKNS_9InnerInfoE, __ZN9GfxDevice13SetBufferNameEP9GfxBufferPKc: __ZN9GfxDevice13SetBufferNameEP9GfxBufferPKc, __ZN12MeshCollider13DidDeleteMeshEv: __ZN12MeshCollider13DidDeleteMeshEv, __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI17RemapPPtrTransferLb0E10ColorRGBAfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK15TextureSettings8GetAnisoEv: __ZNK15TextureSettings8GetAnisoEv, __Z41Register_UnityEngine_Sprite_get_trianglesv: __Z41Register_UnityEngine_Sprite_get_trianglesv, __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED2Ev: __ZN5physx20NpRigidActorTemplateINS_18PxArticulationLinkEED2Ev, __Z36Animation_Set_Custom_PropCullingTypeP12Il2CppObjectN9Animation11CullingTypeE: __Z36Animation_Set_Custom_PropCullingTypeP12Il2CppObjectN9Animation11CullingTypeE, __ZN8LODGroup15ThreadedCleanupEv: __ZN8LODGroup15ThreadedCleanupEv, __ZNSt3__210moneypunctIcLb0EED0Ev: __ZNSt3__210moneypunctIcLb0EED0Ev, __ZNSt3__26vectorIPN5IMGUI9GUIWindowENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorIPN5IMGUI9GUIWindowENS_9allocatorIS3_EEE21__push_back_slow_pathIKS3_EEvRT_, __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_: __ZZNK5physx26PxSerializerDefaultAdapterINS_18NpArticulationLinkEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextEEN16RequiresCallback7processES4_, __ZN21BillboardBatchManager3GetEv: __ZN21BillboardBatchManager3GetEv, __ZN9LensFlare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9LensFlare23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale1Ev: __ZNK5physx3Ext5JointINS_15PxDistanceJointENS_30PxDistanceJointGeneratedValuesEE19getInvInertiaScale1Ev, __ZN4FMOD8ChannelI19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES: __ZN4FMOD8ChannelI19setReverbPropertiesEPK29FMOD_REVERB_CHANNELPROPERTIES, __Z21PostprocessStacktracePKcRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z21PostprocessStacktracePKcRNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN17PolygonCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN17PolygonCollider2D23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN13SpeedTreeWind5ScaleEf: __ZN13SpeedTreeWind5ScaleEf, __ZN7Terrain5ResetEv: __ZN7Terrain5ResetEv, __ZNSt3__26locale5__imp7installINS_15time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_: __ZNSt3__26locale5__imp7installINS_15time_put_bynameIwNS_19ostreambuf_iteratorIwNS_11char_traitsIwEEEEEEEEvPT_, __ZNK18SpeedTreeWindAsset26GetTypeInfoVirtualInternalEv: __ZNK18SpeedTreeWindAsset26GetTypeInfoVirtualInternalEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxVehicleDriveTankEEEEclILj640ENS_15PxVehicleWheelsENS_22PxVehicleWheelsDynDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7Cursors20RenderSoftwareCursorEv: __ZN7Cursors20RenderSoftwareCursorEv, __Z16GetRenderManagerv: __Z16GetRenderManagerv, __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIjLi3EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI19StaticArrayTransferIjLi3EEEEvRT_17TransferMetaFlags, __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_get_sizev: __Z52Register_UnityEngine_BoxCollider2D_INTERNAL_get_sizev, __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE: __ZNSt3__26__treeINS_12__value_typeIPKvNS_4pairIjP20ArchiveStorageReaderEEEENS_19__map_value_compareIS3_S8_NS_4lessIS3_EELb1EEENS_9allocatorIS8_EEE7destroyEPNS_11__tree_nodeIS8_PvEE, __Z24RegisterStrippedTypeInfoI17AudioChorusFilterEviPKcS2_: __Z24RegisterStrippedTypeInfoI17AudioChorusFilterEviPKcS2_, __ZN3MBP12removeObjectEj: __ZN3MBP12removeObjectEj, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEE14handleAccessorILj15ENS_22PxRepXPropertyAccessorILj15ENS_7PxActorENS_7PxFlagsINS_11PxActorFlag4EnumEtEESD_EEEEvRKT0_, __ZNK5Umbra11Transformer16getNearPlaneQuadEv: __ZNK5Umbra11Transformer16getNearPlaneQuadEv, __ZN20LocalFileSystemPosix4SeekER13FileEntryDatax10FileOrigin: __ZN20LocalFileSystemPosix4SeekER13FileEntryDatax10FileOrigin, __Z36Rigidbody2D_Set_Custom_PropSimulatedP12Il2CppObjecth: __Z36Rigidbody2D_Set_Custom_PropSimulatedP12Il2CppObjecth, __ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physx13solveFrictionERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __Z24RegisterStrippedTypeInfoI15AudioReverbZoneEviPKcS2_: __Z24RegisterStrippedTypeInfoI15AudioReverbZoneEviPKcS2_, __ZN29DepthOrReplacementPassScratchD0Ev: __ZN29DepthOrReplacementPassScratchD0Ev, __ZNSt3__211__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i: __ZNSt3__211__money_putIwE8__formatEPwRS2_S3_jPKwS5_RKNS_5ctypeIwEEbRKNS_10money_base7patternEwwRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERKNSE_IwNSF_IwEENSH_IwEEEESQ_i, __Z23Mesh_CUSTOM_MarkDynamicP12Il2CppObject: __Z23Mesh_CUSTOM_MarkDynamicP12Il2CppObject, __Z53Register_UnityEngine_Material_INTERNAL_CALL_GetMatrixv: __Z53Register_UnityEngine_Material_INTERNAL_CALL_GetMatrixv, __ZN5physx2Gu21pcmContactPlaneConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu21pcmContactPlaneConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z46Register_UnityEngine_AndroidJNI_CallVoidMethodv: __Z46Register_UnityEngine_AndroidJNI_CallVoidMethodv, __ZN5physx5cloth8SwFabricD0Ev: __ZN5physx5cloth8SwFabricD0Ev, __ZN7ApiGLES14SetPolygonModeEb: __ZN7ApiGLES14SetPolygonModeEb, __Z26getPxSceneDescFilterShaderPKN5physx11PxSceneDescE: __Z26getPxSceneDescFilterShaderPKN5physx11PxSceneDescE, __ZN8VRDevice6UpdateEv: __ZN8VRDevice6UpdateEv, __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawIconRK8Vector3fP12Il2CppStringh: __Z36Gizmos_CUSTOM_INTERNAL_CALL_DrawIconRK8Vector3fP12Il2CppStringh, __ZN5physx3Scb5Scene3addINS0_17ArticulationJointELb0EEEvRT_RNS0_13ObjectTrackerE: __ZN5physx3Scb5Scene3addINS0_17ArticulationJointELb0EEEvRT_RNS0_13ObjectTrackerE, __ZN4FMOD3DSP9getOutputEiPPS0_PPNS_13DSPConnectionE: __ZN4FMOD3DSP9getOutputEiPPS0_PPNS_13DSPConnectionE, __ZN5physx15PxSerialization24serializeCollectionToXmlERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPNS_9PxCookingEPKS3_PNS0_18PxXmlMiscParameterE: __ZN5physx15PxSerialization24serializeCollectionToXmlERNS_14PxOutputStreamERNS_12PxCollectionERNS_23PxSerializationRegistryEPNS_9PxCookingEPKS3_PNS0_18PxXmlMiscParameterE, __ZNK13GfxDeviceNull12GetWireframeEv: __ZNK13GfxDeviceNull12GetWireframeEv, __Z39AudioMixerDuckingGetFloatBufferCallbackP21UnityAudioEffectStatePKcPfi: __Z39AudioMixerDuckingGetFloatBufferCallbackP21UnityAudioEffectStatePKcPfi, __ZN12HingeJoint2D5ResetEv: __ZN12HingeJoint2D5ResetEv, __ZN5physx7NpCloth12setClothFlagENS_11PxClothFlag4EnumEb: __ZN5physx7NpCloth12setClothFlagENS_11PxClothFlag4EnumEb, __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZv: __Z62Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZv, __Z64Register_UnityEngine_SkinnedMeshRenderer_get_updateWhenOffscreenv: __Z64Register_UnityEngine_SkinnedMeshRenderer_get_updateWhenOffscreenv, __ZNK5physx16PxVehicleNoDrive19getConcreteTypeNameEv: __ZNK5physx16PxVehicleNoDrive19getConcreteTypeNameEv, __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj: __ZN8DrawUtil22DrawProceduralIndirectE16GfxPrimitiveType15ComputeBufferIDj, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE7getNameEv, __ZN9Rigidbody19SetDetectCollisionsEb: __ZN9Rigidbody19SetDetectCollisionsEb, __ZN8GUIState12PopAndDeleteEPS_: __ZN8GUIState12PopAndDeleteEPS_, __ZN16ReflectionProbes11RemoveProbeE4PPtrI15ReflectionProbeE: __ZN16ReflectionProbes11RemoveProbeE4PPtrI15ReflectionProbeE, __Z24scripting_cpp_string_forP12Il2CppString: __Z24scripting_cpp_string_forP12Il2CppString, __Z42ReflectionProbe_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z42ReflectionProbe_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE22setClientBehaviorFlagsENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZN22UnityAnalyticsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN22UnityAnalyticsSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z59Register_UnityEngine_CullingGroup_SetDistanceReferencePointv: __Z59Register_UnityEngine_CullingGroup_SetDistanceReferencePointv, __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrIN5Unity9ComponentEE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN3MBP12addBoxPrunerERKN5physx18PxBroadPhaseRegionEb: __ZN3MBP12addBoxPrunerERKN5physx18PxBroadPhaseRegionEb, __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIN9ShaderLab20SerializedSubProgram15VectorParameterENS_9allocatorIS3_EEE6assignIPS3_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEEEEjT_j, __ZN9GfxDevice16RestoreDrawStatsEv: __ZN9GfxDevice16RestoreDrawStatsEv, __Z45Register_UnityEngine_Light_get_shadowStrengthv: __Z45Register_UnityEngine_Light_get_shadowStrengthv, __ZN13GfxDeviceNull21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii: __ZN13GfxDeviceNull21GrabIntoRenderTextureE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseES4_iiii, __Z51ParticleSystemRenderer_CUSTOM_Internal_GetMeshCountP12Il2CppObject: __Z51ParticleSystemRenderer_CUSTOM_Internal_GetMeshCountP12Il2CppObject, __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE: __ZN5physx2Sc5Scene17addParticleSystemERNS0_18ParticleSystemCoreE, __ZN4FMOD3DSP5resetEv: __ZN4FMOD3DSP5resetEv, __Z49Register_UnityEngine_LineRenderer_set_textureModev: __Z49Register_UnityEngine_LineRenderer_set_textureModev, __ZN4FMOD6System19getMasterSoundGroupEPPNS_10SoundGroupE: __ZN4FMOD6System19getMasterSoundGroupEPPNS_10SoundGroupE, __ZN23ForwardShaderRenderLoopD2Ev: __ZN23ForwardShaderRenderLoopD2Ev, __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj: __ZNSt3__26vectorINS_4pairI7Hash128S2_EENS_9allocatorIS3_EEE8__appendEj, __Z39setPxVehicleDriveDynDataMGearSwitchTimePN5physx21PxVehicleDriveDynDataEf: __Z39setPxVehicleDriveDynDataMGearSwitchTimePN5physx21PxVehicleDriveDynDataEf, __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI17TexFormatRGBFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZN6Camera38PrepareCullingParametersRendererArraysERK23CameraCullingParametersR11CullResults: __ZN6Camera38PrepareCullingParametersRendererArraysERK23CameraCullingParametersR11CullResults, __ZN12_GLOBAL__N_1L4gNORERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L4gNORERN5physx12PxGroupsMaskERKS1_S4_, __Z54Register_UnityEngine_Time_get_maximumParticleDeltaTimev: __Z54Register_UnityEngine_Time_get_maximumParticleDeltaTimev, __Z20ResetInputAfterPausev: __Z20ResetInputAfterPausev, __ZN10GUITexture8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN10GUITexture8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z11FitTangentsIfEvR11KeyframeTplIT_ES3_ffRKS1_S5_: __Z11FitTangentsIfEvR11KeyframeTplIT_ES3_ffRKS1_S5_, __ZN16HeightMeshBVNode8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN16HeightMeshBVNode8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z55Register_UnityEngine_Analytics_CustomEventData_AddSBytev: __Z55Register_UnityEngine_Analytics_CustomEventData_AddSBytev, __Z32setPxVehicleWheelsMWheelsSimDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsSimDataE: __Z32setPxVehicleWheelsMWheelsSimDataPN5physx15PxVehicleWheelsENS_22PxVehicleWheelsSimDataE, __ZN16BaseVideoTexture19ResumeVideoTexturesEv: __ZN16BaseVideoTexture19ResumeVideoTexturesEv, __Z32Transform_CUSTOM_GetSiblingIndexP12Il2CppObject: __Z32Transform_CUSTOM_GetSiblingIndexP12Il2CppObject, __ZN9Texture3D9SetPixelsEiPK10ColorRGBAfi: __ZN9Texture3D9SetPixelsEiPK10ColorRGBAfi, __Z46EmitSerializationCommandsForManagedObjectFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI19StreamedBinaryWriteILb0EEEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN7mecanim12statemachine21DestroyStateWorkspaceEPNS0_14StateWorkspaceERNS_6memory9AllocatorE: __ZN7mecanim12statemachine21DestroyStateWorkspaceEPNS0_14StateWorkspaceERNS_6memory9AllocatorE, __Z63ParticleSystemExtensionsImpl_CUSTOM_GetSafeTriggerParticlesSizeP12Il2CppObjecti: __Z63ParticleSystemExtensionsImpl_CUSTOM_GetSafeTriggerParticlesSizeP12Il2CppObjecti, __ZN7mecanim5human5Human8TransferI9BlobWriteEEvRT_: __ZN7mecanim5human5Human8TransferI9BlobWriteEEvRT_, _get_interesting_appn: _get_interesting_appn, __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVES3_RKNS_6shdfnd3aos6FloatVERNS5_5Vec3VESA_SA_RS6_PhSC_Rhb: __ZN5physx2Gu19GJKLocalPenetrationERKNS0_9TriangleVES3_RKNS_6shdfnd3aos6FloatVERNS5_5Vec3VESA_SA_RS6_PhSC_Rhb, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E8BitFieldEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z19AddCurveToDenseClipIfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E: __Z19AddCurveToDenseClipIfEvRN7mecanim9animation9DenseClipEiRK17AnimationCurveTplIT_E, __ZN7Cubemap13UploadTextureEv: __ZN7Cubemap13UploadTextureEv, __Z36Animator_Set_Custom_PropPlaybackTimeP12Il2CppObjectf: __Z36Animator_Set_Custom_PropPlaybackTimeP12Il2CppObjectf, __ZNK22UnityProfilerPerThread15SaveToFrameDataER17ProfilerFrameData: __ZNK22UnityProfilerPerThread15SaveToFrameDataER17ProfilerFrameData, __Z51AudioLowPassFilter_Get_Custom_PropCustomCutoffCurveP12Il2CppObject: __Z51AudioLowPassFilter_Get_Custom_PropCustomCutoffCurveP12Il2CppObject, __ZN2UI6Canvas24SetCachedMeshBoundsDirtyEv: __ZN2UI6Canvas24SetCachedMeshBoundsDirtyEv, __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE: __ZN5physx9NpPhysics14updateMaterialERNS_10NpMaterialE, __ZThn8_N5physx3Cct17CapsuleControllerD0Ev: __ZThn8_N5physx3Cct17CapsuleControllerD0Ev, __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_CallObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv: __Z48AndroidJNI_CUSTOM_INTERNAL_CALL_CallObjectMethod13Il2Cpp_IntPtrS_P11Il2CppArrayRPv, __ZNK13WheelCollider12GetGroundHitER8WheelHit: __ZNK13WheelCollider12GetGroundHitER8WheelHit, __Z43Register_UnityEngine_TextMesh_get_alignmentv: __Z43Register_UnityEngine_TextMesh_get_alignmentv, __ZN5physx14NpRigidDynamic12createObjectERPhRNS_24PxDeserializationContextE: __ZN5physx14NpRigidDynamic12createObjectERPhRNS_24PxDeserializationContextE, __ZN11SoundHandle8Instance15UpdateLoadStateEv: __ZN11SoundHandle8Instance15UpdateLoadStateEv, __ZZN8VRModuleC1EvEN25audioConfigurationChanged7ForwardEv: __ZZN8VRModuleC1EvEN25audioConfigurationChanged7ForwardEv, __ZNK25RuntimeAnimatorController26GetTypeInfoVirtualInternalEv: __ZNK25RuntimeAnimatorController26GetTypeInfoVirtualInternalEv, __ZN9Polygon2DC2Ev: __ZN9Polygon2DC2Ev, __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx15NpActorTemplateINS_16PxParticleSystemEE15exportExtraDataERNS_22PxSerializationContextE, __ZN20TextRenderingPrivate17TextMeshGenerator14GarbageCollectEv: __ZN20TextRenderingPrivate17TextMeshGenerator14GarbageCollectEv, __ZNK25UnityWebRequestJavaScript16GetDownloadBytesEv: __ZNK25UnityWebRequestJavaScript16GetDownloadBytesEv, __ZN15DirectorManager12AddToManagerEP18PlayableController: __ZN15DirectorManager12AddToManagerEP18PlayableController, __Z59Register_UnityEngine_ParticleSystem_TriggerModule_SetInsidev: __Z59Register_UnityEngine_ParticleSystem_TriggerModule_SetInsidev, __ZNK5physx2Sc8RigidSim14getSimForShapeERNS0_9ShapeCoreE: __ZNK5physx2Sc8RigidSim14getSimForShapeERNS0_9ShapeCoreE, __ZN24MaterialDisplayListCache16CachedShaderPassC2Ev: __ZN24MaterialDisplayListCache16CachedShaderPassC2Ev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj295ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj295ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK28MonoBehaviourPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE: __ZNK28MonoBehaviourPropertyBinding9BindValueER6ObjectRKN11UnityEngine9Animation14GenericBindingERNS3_10BoundCurveE, __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode1ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_, __ZNSt3__214__split_bufferIP18ReflectionProbeJobNS_9allocatorIS2_EEE10push_frontERKS2_: __ZNSt3__214__split_bufferIP18ReflectionProbeJobNS_9allocatorIS2_EEE10push_frontERKS2_, __ZNSt3__218__time_get_storageIwE4initERKNS_5ctypeIwEE: __ZNSt3__218__time_get_storageIwE4initERKNS_5ctypeIwEE, __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_15InlineAllocatorILj256ENS0_19ReflectionAllocatorINS_2Cm5BlockIS2_Lj16EEEEEEEE15growAndPushBackERKS2_, __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf: __Z63ParticleSystem_RotationOverLifetimeModule_CUSTOM_SetXMultiplierP12Il2CppObjectf, _cff_get_interface: _cff_get_interface, __ZN12CachedReader25GetSerializedFilePathNameEv: __ZN12CachedReader25GetSerializedFilePathNameEv, __Z12CalculateEtaiid: __Z12CalculateEtaiid, __ZN5physx2Sq10AABBPruner9buildStepEv: __ZN5physx2Sq10AABBPruner9buildStepEv, __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorWriterBaseINS_22PxVehicleWheelsSimDataEE23extendedIndexedPropertyINS_3Pvd36PxPvdExtendedIndexedPropertyAccessorILj613ES2_KjNS_23PxVehicleSuspensionDataEEEKNS_36PxVehicleSuspensionDataGeneratedInfoEEEvPjRKT_RT0_, __Z50Register_UnityEngine_AI_NavMeshObstacle_get_radiusv: __Z50Register_UnityEngine_AI_NavMeshObstacle_get_radiusv, __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_8CapsuleVENS0_10ShrunkBoxVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __Z49Rigidbody2D_Get_Custom_PropCollisionDetectionModeP12Il2CppObject: __Z49Rigidbody2D_Get_Custom_PropCollisionDetectionModeP12Il2CppObject, __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString: __ZN9Scripting34SetScriptingArrayStringElementImplEP11Il2CppArrayiP12Il2CppString, __ZNK8Animator19GetControllerMemoryEv: __ZNK8Animator19GetControllerMemoryEv, __ZN12HingeJoint2D7CleanupEb: __ZN12HingeJoint2D7CleanupEb, __ZL12PhysxJobFuncPN5physx10PxBaseTaskE: __ZL12PhysxJobFuncPN5physx10PxBaseTaskE, __Z33GUI_CUSTOM_INTERNAL_CALL_DoToggleRK5RectTIfEihP12Il2CppObject13Il2Cpp_IntPtr: __Z33GUI_CUSTOM_INTERNAL_CALL_DoToggleRK5RectTIfEihP12Il2CppObject13Il2Cpp_IntPtr, __Z48AnimatorControllerPlayable_CUSTOM_ResetTriggerIDR9HPlayablei: __Z48AnimatorControllerPlayable_CUSTOM_ResetTriggerIDR9HPlayablei, __ZN5physx14PxVehicleGraphD2Ev: __ZN5physx14PxVehicleGraphD2Ev, __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc9ActorPairENS0_19ReflectionAllocatorIS3_EEE15disposeElementsEv, __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_: __ZN11Quaternionf8TransferI14SafeBinaryReadEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj442ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxDistanceJointEEEEclILj442ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_9TriangleVENS0_11ConvexHullVEE18doWarmStartSupportEiiRNS_6shdfnd3aos5Vec3VES8_S8_, __ZN17AudioChorusFilter7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN17AudioChorusFilter7PRODUCEE10MemLabelId18ObjectCreationMode, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getCurrentParticlesEv, __ZN16UploadHandlerRawC2Ev: __ZN16UploadHandlerRawC2Ev, __ZN13GfxDeviceGLES17CreateIndexBufferEv: __ZN13GfxDeviceGLES17CreateIndexBufferEv, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat16TexFormatRGFloatEEvPKNS_9InnerInfoE, __ZNK11DynamicMesh13MergePolygonsER13dynamic_arrayI8Vector3fLj4EERKS2_S5_: __ZNK11DynamicMesh13MergePolygonsER13dynamic_arrayI8Vector3fLj4EERKS2_S5_, __ZNK18PlatformEffector2D26GetTypeInfoVirtualInternalEv: __ZNK18PlatformEffector2D26GetTypeInfoVirtualInternalEv, __ZN13WheelCollider14SetBrakeTorqueEf: __ZN13WheelCollider14SetBrakeTorqueEf, __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb: __ZN9JSONWrite14OutputToStringERN4core12basic_stringIcNS0_20StringStorageDefaultIcEEEEb, __Z28Shader_CUSTOM_GetGlobalFloati: __Z28Shader_CUSTOM_GetGlobalFloati, __ZNK9Behaviour10GetEnabledEv: __ZNK9Behaviour10GetEnabledEv, __ZN11ICallStringC2EP12Il2CppString: __ZN11ICallStringC2EP12Il2CppString, __ZN5physx15computeMaxIndexEPKjj: __ZN5physx15computeMaxIndexEPKjj, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv, __ZN9AudioClip10InitWSoundEPN11SoundHandle8InstanceE: __ZN9AudioClip10InitWSoundEPN11SoundHandle8InstanceE, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKNS_2Sq13PrunerPayloadEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE6createERS6_Rb, __Z12IsHiddenFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z12IsHiddenFileRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN19StreamedBinaryWriteILb0EE8TransferIN11UnityEngine9Animation28AnimationClipBindingConstantEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferIN11UnityEngine9Animation28AnimationClipBindingConstantEEEvRT_PKc17TransferMetaFlags, __ZN14GfxContextGLES14GetFramebufferEv: __ZN14GfxContextGLES14GetFramebufferEv, __ZN5Umbra8QueryExt20queryConnectedRegionEjRNS_9IndexListEiRKNS_7Vector3EfPfPNS_9FloatListES8_PS1_: __ZN5Umbra8QueryExt20queryConnectedRegionEjRNS_9IndexListEiRKNS_7Vector3EfPfPNS_9FloatListES8_PS1_, __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j: __ZNK5physx20PxActorGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_13PxRigidStaticEEEEEEEjT_j, __ZN4FMOD7SystemI12loadGeometryEPKviPPNS_8GeometryE: __ZN4FMOD7SystemI12loadGeometryEPKviPPNS_8GeometryE, _open_face_from_buffer: _open_face_from_buffer, __ZN12_GLOBAL__N_110DataStream7releaseEv: __ZN12_GLOBAL__N_110DataStream7releaseEv, __ZN5physx2Sc9ClothCore20removeCollisionPlaneEj: __ZN5physx2Sc9ClothCore20removeCollisionPlaneEj, __Z57Register_UnityEngine_Physics_get_minPenetrationForPenaltyv: __Z57Register_UnityEngine_Physics_get_minPenetrationForPenaltyv, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE5eraseERS6_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_18PxDeletionListenerEPNS_9NpPhysics18NpDelListenerEntryEEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_S9_SC_NS0_9AllocatorEE6GetKeyESE_Lb1EE5eraseERS6_, __ZNSt3__217__assoc_sub_state9__executeEv: __ZNSt3__217__assoc_sub_state9__executeEv, __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolIDv: __Z79Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetBoolIDv, __Z23Application_CUSTOM_Quitv: __Z23Application_CUSTOM_Quitv, __ZN22BaseUnityConnectClient6RetainEv: __ZN22BaseUnityConnectClient6RetainEv, __ZN18PlatformEffector2D19SetRotationalOffsetEf: __ZN18PlatformEffector2D19SetRotationalOffsetEf, __ZN4FMOD6Reverb15set3DAttributesEPK11FMOD_VECTORff: __ZN4FMOD6Reverb15set3DAttributesEPK11FMOD_VECTORff, __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN13AnimationClip9PPtrCurve8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z45GUIStyle_CUSTOM_INTERNAL_CALL_SetMouseTooltipP12Il2CppObjectP12Il2CppStringRK5RectTIfE: __Z45GUIStyle_CUSTOM_INTERNAL_CALL_SetMouseTooltipP12Il2CppObjectP12Il2CppStringRK5RectTIfE, __ZN13SpringJoint2DD0Ev: __ZN13SpringJoint2DD0Ev, __ZN6Socket5CloseEi: __ZN6Socket5CloseEi, __ZN9WWWCached17SetThreadPriorityE14ThreadPriority: __ZN9WWWCached17SetThreadPriorityE14ThreadPriority, __ZN5physx2Sc5Scene23checkConstraintBreakageEv: __ZN5physx2Sc5Scene23checkConstraintBreakageEv, __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb: __ZN5physx20InternalTriangleMesh17allocateTrianglesEjb, __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv: __ZN6Camera6RenderER11CullResultsR17ShaderPassContextPK21CameraRenderingParamsNS_10RenderFlagEPv, __Z17deleteBucketAllocP11BucketAlloc: __Z17deleteBucketAllocP11BucketAlloc, __ZNSt3__215recursive_mutex6unlockEv: __ZNSt3__215recursive_mutex6unlockEv, __ZNSt3__223__future_error_categoryD0Ev: __ZNSt3__223__future_error_categoryD0Ev, __ZN14GrowableBufferC2ERKS_: __ZN14GrowableBufferC2ERKS_, __ZN5physx22PxActorGeneratedValuesC2EPKNS_7PxActorE: __ZN5physx22PxActorGeneratedValuesC2EPKNS_7PxActorE, __ZN5physx2Sq16BucketPrunerCore17setExternalMemoryEjPNS_9PxBounds3EPNS0_13PrunerPayloadE: __ZN5physx2Sq16BucketPrunerCore17setExternalMemoryEjPNS_9PxBounds3EPNS0_13PrunerPayloadE, __Z30Caching_Set_Custom_PropEnabledh: __Z30Caching_Set_Custom_PropEnabledh, __ZNK6Camera25GetSkyboxProjectionMatrixEfR10Matrix4x4f: __ZNK6Camera25GetSkyboxProjectionMatrixEfR10Matrix4x4f, __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE: __ZN20TextRenderingPrivate15DynamicFontData17GetFaceForFontRefERKNS_7FontRefERKNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS9_L18MemLabelIdentifier34ELi16EEEE, __Z57Register_UnityEngine_ParticleSystem_get_useAutoRandomSeedv: __Z57Register_UnityEngine_ParticleSystem_get_useAutoRandomSeedv, __ZN5physx3Ext21InertiaTensorComputerC2Eb: __ZN5physx3Ext21InertiaTensorComputerC2Eb, __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetEnabledv: __Z69Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_GetEnabledv, __ZN9rapidjson4UTF8IcE6EncodeINS_13GenericReaderIS1_S1_13JSONAllocatorE11StackStreamEEEvRT_j: __ZN9rapidjson4UTF8IcE6EncodeINS_13GenericReaderIS1_S1_13JSONAllocatorE11StackStreamEEEvRT_j, __ZNSt3__26vectorIN5physx10PxSweepHitENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN5physx10PxSweepHitENS_9allocatorIS2_EEE8__appendEj, __Z28Animator_CUSTOM_StopPlaybackP12Il2CppObject: __Z28Animator_CUSTOM_StopPlaybackP12Il2CppObject, __ZL22InitializeModule_Audiov: __ZL22InitializeModule_Audiov, __Z7VFormatPKcPi: __Z7VFormatPKcPi, __Z22EdgeEdgeContactSpecialRKN5physx6PxVec3ERKNS_7PxPlaneES2_S2_S2_S2_S2_RfRS0_jjf: __Z22EdgeEdgeContactSpecialRKN5physx6PxVec3ERKNS_7PxPlaneES2_S2_S2_S2_S2_RfRS0_jjf, __ZNK5physx17AggregateAABBTask25updateNumFastMovingShapesEv: __ZNK5physx17AggregateAABBTask25updateNumFastMovingShapesEv, __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb: __Z19UpdateProceduralTplILb0EEvRK22DualMinMax3DPolyCurvesRK11MinMaxCurveS5_S5_R23ParticleSystemParticlesRKN4math8float3x3Eb, __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayIPNS_2Sc17ParticleSystemSimENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI15AudioMixerGroupE8TransferI14SafeBinaryReadEEvRT_, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7releaseEv: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE7releaseEv, __ZNK12NavMeshAgent7RaycastERK8Vector3fP10NavMeshHit: __ZNK12NavMeshAgent7RaycastERK8Vector3fP10NavMeshHit, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapIi14ConstantStringNSt3__24lessIiEENS4_9allocatorINS4_4pairIiS3_EEEEEEEvRT_17TransferMetaFlags, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj471ENS_22PxRepXPropertyAccessorILj471ES4_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESC_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_15PxRevoluteJointEEEE14handleAccessorILj471ENS_22PxRepXPropertyAccessorILj471ES4_NS_7PxFlagsINS_19PxRevoluteJointFlag4EnumEtEESC_EEEEvRKT0_, __ZN16Physics2DManager14CapsuleCastAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE: __ZN16Physics2DManager14CapsuleCastAllERK8Vector2fS2_N17CapsuleCollider2D16CapsuleDirectionEfS2_fiffPK10Collider2DbP13dynamic_arrayI12RaycastHit2DLj4EE, __Z12GetParameterR11UTF16StringRib: __Z12GetParameterR11UTF16StringRib, __ZN5physx22PxPhysicsGeneratedInfoC2Ev: __ZN5physx22PxPhysicsGeneratedInfoC2Ev, __ZN12CullingGroup10SetEnabledEb: __ZN12CullingGroup10SetEnabledEb, __ZNK14SphereCollider15GetGlobalCenterEv: __ZNK14SphereCollider15GetGlobalCenterEv, __Z57Register_UnityEngine_Application_get_internetReachabilityv: __Z57Register_UnityEngine_Application_get_internetReachabilityv, __ZNK13ScreenManager13GetShowCursorEv: __ZNK13ScreenManager13GetShowCursorEv, __ZN7mecanim22CreateValueArrayWeightEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE: __ZN7mecanim22CreateValueArrayWeightEPKNS_18ValueArrayConstantERNS_6memory9AllocatorE, __Z61Register_UnityEngine_CharacterController_get_detectCollisionsv: __Z61Register_UnityEngine_CharacterController_get_detectCollisionsv, __Z45AssetBundleManifest_CUSTOM_GetAllDependenciesP12Il2CppObjectP12Il2CppString: __Z45AssetBundleManifest_CUSTOM_GetAllDependenciesP12Il2CppObjectP12Il2CppString, __ZN7mecanim9animation26DestroyControllerWorkspaceEPNS0_19ControllerWorkspaceERNS_6memory9AllocatorE: __ZN7mecanim9animation26DestroyControllerWorkspaceEPNS0_19ControllerWorkspaceERNS_6memory9AllocatorE, __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN11Rigidbody2D23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z51Register_UnityEngine_AndroidJNI_GetLongArrayElementv: __Z51Register_UnityEngine_AndroidJNI_GetLongArrayElementv, __Z39Transform_Set_Custom_PropParentInternalP12Il2CppObjectS0_: __Z39Transform_Set_Custom_PropParentInternalP12Il2CppObjectS0_, __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN14AnimationEvent8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE7getNameEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE7getNameEv, __Z51Register_UnityEngine_Camera_set_useOcclusionCullingv: __Z51Register_UnityEngine_Camera_set_useOcclusionCullingv, __ZN8UVModule5ResetEv: __ZN8UVModule5ResetEv, __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallObjectMethodv: __Z62Register_UnityEngine_AndroidJNI_INTERNAL_CALL_CallObjectMethodv, __Z29StdTemplateConversionFunctionIbaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbaEbPvR14SafeBinaryRead, __ZNK5physx14PxsAABBManager11getBPBoundsEj: __ZNK5physx14PxsAABBManager11getBPBoundsEj, __ZNKSt3__220__codecvt_utf8_utf16IwE11do_encodingEv: __ZNKSt3__220__codecvt_utf8_utf16IwE11do_encodingEv, __ZN5audio5mixer15FindEffectIndexERKNS0_18AudioMixerConstantERK9UnityGUID: __ZN5audio5mixer15FindEffectIndexERKNS0_18AudioMixerConstantERK9UnityGUID, __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv: __ZN5physx6shdfnd8PoolBaseINS_19NpArticulationJointENS0_19ReflectionAllocatorIS2_EEE15disposeElementsEv, __ZN14RenderSettings21SetAmbientGroundColorERK10ColorRGBAf: __ZN14RenderSettings21SetAmbientGroundColorERK10ColorRGBAf, __ZN13ConstantForce23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN13ConstantForce23VirtualRedirectTransferER17RemapPPtrTransfer, __ZN5physx2Sc8ActorSimD0Ev: __ZN5physx2Sc8ActorSimD0Ev, __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv: __ZNK5physx2Gu26EPASupportMapPairLocalImplINS0_8CapsuleVENS0_11ConvexHullVEE6getDirEv, __Z44Register_UnityEngine_AndroidJNI_SetByteFieldv: __Z44Register_UnityEngine_AndroidJNI_SetByteFieldv, __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZMultiplierv: __Z72Register_UnityEngine_ParticleSystem_RotationBySpeedModule_SetZMultiplierv, __GLOBAL__sub_I_runtime_camera_renderlayers_lump_cpp: __GLOBAL__sub_I_runtime_camera_renderlayers_lump_cpp, _fclose: _fclose, __ZN17ShaderPassContext8CopyFromERKS_: __ZN17ShaderPassContext8CopyFromERKS_, __ZN16RayRTreeCallbackILi1ELb0EED0Ev: __ZN16RayRTreeCallbackILi1ELb0EED0Ev, __ZN5physx15PxSerialization21createBinaryConverterEv: __ZN5physx15PxSerialization21createBinaryConverterEv, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIfEEEvRT_PKc17TransferMetaFlags, __ZN9Transform11SetPositionERK8Vector3f: __ZN9Transform11SetPositionERK8Vector3f, __ZN8UVModule8TransferI17RemapPPtrTransferEEvRT_: __ZN8UVModule8TransferI17RemapPPtrTransferEEvRT_, __ZN8JSONRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI8MonoPPtrEEvRT_PKc17TransferMetaFlagsb, __Z45Register_UnityEngine_SpriteRenderer_get_flipXv: __Z45Register_UnityEngine_SpriteRenderer_get_flipXv, __Z47Register_UnityEngine_HumanTrait_get_MuscleCountv: __Z47Register_UnityEngine_HumanTrait_get_MuscleCountv, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0E11QuaternionfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN11ForceModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN11ForceModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx16AggregateManager6resizeEj: __ZN5physx16AggregateManager6resizeEj, __ZNK5physx5cloth6GatherI8Scalar4fEclEPKS2_: __ZNK5physx5cloth6GatherI8Scalar4fEclEPKS2_, __Z42TrailRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_: __Z42TrailRenderer_Set_Custom_PropColorGradientP12Il2CppObjectS0_, __Z28Animator_CUSTOM_IsControlledP12Il2CppObjectS0_: __Z28Animator_CUSTOM_IsControlledP12Il2CppObjectS0_, __ZN5physx23PxCapsuleControllerDescD0Ev: __ZN5physx23PxCapsuleControllerDescD0Ev, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16TextureDimensionEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryRead16TextureDimensionEvRT_RT0_PKc17TransferMetaFlags, __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb: __ZNK17MeshRenderingData18ExtractMeshBuffersEjR11MeshBuffersbb, __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE12getAggregateEv: __ZNK5physx15NpActorTemplateINS_13PxRigidStaticEE12getAggregateEv, _gzclearerr: _gzclearerr, __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj: __ZNK11NoiseModule14CalculateNoiseILi1ELb1ELb1EEEvR23ParticleSystemParticlesRK27ParticleSystemReadOnlyStatejj, __ZN16b2ContactManager7AddPairEPvS0_: __ZN16b2ContactManager7AddPairEPvS0_, __ZNK14PhysicsManager26GetTypeInfoVirtualInternalEv: __ZNK14PhysicsManager26GetTypeInfoVirtualInternalEv, __ZN9ShaderLab20SerializedSubProgram8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9ShaderLab20SerializedSubProgram8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5Unity12PhysicsQuery18OverlapBoxNonAllocERK8Vector3fS3_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery18OverlapBoxNonAllocERK8Vector3fS3_RK11QuaternionfPP8Colliderii23QueryTriggerInteraction, __ZN17Physics2DSettings22SetColliderAsleepColorERK10ColorRGBAf: __ZN17Physics2DSettings22SetColliderAsleepColorERK10ColorRGBAf, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE4findEcj, __ZN14PreloadManager17IsLoadingOrQueuedEv: __ZN14PreloadManager17IsLoadingOrQueuedEv, __Z32getPxClothStretchConfigStiffnessPKN5physx20PxClothStretchConfigE: __Z32getPxClothStretchConfigStiffnessPKN5physx20PxClothStretchConfigE, __ZN10RenderLoopC2ER6Camera: __ZN10RenderLoopC2ER6Camera, __ZNSt12length_errorD0Ev: __ZNSt12length_errorD0Ev, __ZNK39AssetBundleLoadFromStreamAsyncOperation25CreateTempOutputDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK39AssetBundleLoadFromStreamAsyncOperation25CreateTempOutputDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z29StdTemplateConversionFunctionIyaEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIyaEbPvR14SafeBinaryRead, __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXMultiplierv: __Z73Register_UnityEngine_ParticleSystem_SizeOverLifetimeModule_SetXMultiplierv, __ZNSt3__212strstreambuf9underflowEv: __ZNSt3__212strstreambuf9underflowEv, __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKRotationInternalP12Il2CppObjectiRK11Quaternionf: __Z51Animator_CUSTOM_INTERNAL_CALL_SetIKRotationInternalP12Il2CppObjectiRK11Quaternionf, __ZNK15CapsuleCollider16GetLocalRotationEv: __ZNK15CapsuleCollider16GetLocalRotationEv, __ZN19SkinnedMeshRenderer29UpdateVisibleSkinnedMeshQueueEb: __ZN19SkinnedMeshRenderer29UpdateVisibleSkinnedMeshQueueEb, __Z7GetArgcv: __Z7GetArgcv, __Z46Register_UnityEngine_Physics2D_get_timeToSleepv: __Z46Register_UnityEngine_Physics2D_get_timeToSleepv, __Z23CalculateGlobalPosition23TransformAccessReadOnly: __Z23CalculateGlobalPosition23TransformAccessReadOnly, __Z54Register_UnityEngine_RenderSettings_get_fogEndDistancev: __Z54Register_UnityEngine_RenderSettings_get_fogEndDistancev, __Z32Event_Get_Custom_PropCommandNameP12Il2CppObject: __Z32Event_Get_Custom_PropCommandNameP12Il2CppObject, __Z10tesvertCCWP10TESSvertexS0_S0_: __Z10tesvertCCWP10TESSvertexS0_S0_, __Z18ClipAnimationCurveI11QuaternionfEbRK17AnimationCurveTplIT_ERS3_ff: __Z18ClipAnimationCurveI11QuaternionfEbRK17AnimationCurveTplIT_ERS3_ff, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxRevoluteJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat: __ZN13RenderTexture14SetDepthFormatE17DepthBufferFormat, __ZN4FMOD12ChannelGroup14set3DOcclusionEff: __ZN4FMOD12ChannelGroup14set3DOcclusionEff, __Z15Transfer_StringI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI17RemapPPtrTransferLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E: __ZNK24OptimizedPolynomialCurve18EvaluateIntegratedERKN4math7_float4E, __Z53Register_UnityEngine_VR_VRSettings_get_showDeviceViewv: __Z53Register_UnityEngine_VR_VRSettings_get_showDeviceViewv, __ZN10VertexData8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10VertexData8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZNK8Collider21ShouldIgnoreCollisionEPS_: __ZNK8Collider21ShouldIgnoreCollisionEPS_, __ZN5physx2Sc7BodySim15setArticulationEPNS0_15ArticulationSimEfb: __ZN5physx2Sc7BodySim15setArticulationEPNS0_15ArticulationSimEfb, __ZNK12UnityVersioneqERKS_: __ZNK12UnityVersioneqERKS_, __ZN13RenderManager16GetCurrentCameraEv: __ZN13RenderManager16GetCurrentCameraEv, __Z29StdTemplateConversionFunctionIsbEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIsbEbPvR14SafeBinaryRead, __ZN5physx23writeBackContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_: __ZN5physx23writeBackContactCoulombERKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextERNS_17PxcSolverBodyDataES6_, __ZNK5Umbra6KDTree4Node13getDebugLinesEPNS_7Vector3E: __ZNK5Umbra6KDTree4Node13getDebugLinesEPNS_7Vector3E, __ZN10Collider2D11GetMaterialEv: __ZN10Collider2D11GetMaterialEv, __ZN9Transform12RotateAroundERK8Vector3ff: __ZN9Transform12RotateAroundERK8Vector3ff, __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewLongArrayiRPv: __Z44AndroidJNI_CUSTOM_INTERNAL_CALL_NewLongArrayiRPv, __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_originCustomv: __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_get_originCustomv, __ZN5Umbra20RuntimeTomeGenerator20outputClusterPortalsEi: __ZN5Umbra20RuntimeTomeGenerator20outputClusterPortalsEi, _jpeg_destroy_decompress: _jpeg_destroy_decompress, __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE: __ZN5physx2Gu11GJKRelativeERKNS0_4BoxVERKNS0_11ConvexHullVERKNS_6shdfnd3aos15PsMatTransformVERNS8_5Vec3VESD_SD_RNS8_6FloatVE, __ZN12FixedJoint2DD2Ev: __ZN12FixedJoint2DD2Ev, __Z15Transfer_StringI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI18StreamedBinaryReadILb0EELb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZL8MainLoopv: __ZL8MainLoopv, __ZN5physx2Sc10NPhaseCore30removeFromDirtyInteractionListEPNS0_15CoreInteractionE: __ZN5physx2Sc10NPhaseCore30removeFromDirtyInteractionListEPNS0_15CoreInteractionE, __ZN5physx2Sn5ConvX17convertCollectionEPKvii: __ZN5physx2Sn5ConvX17convertCollectionEPKvii, __ZN14NavMeshManager21InitializeCrowdSystemEf: __ZN14NavMeshManager21InitializeCrowdSystemEf, __ZN5Umbra11ShadowUtils21getWorldToLightMatrixERNS_9Matrix4x4ERKS1_RKNS_7Vector3E: __ZN5Umbra11ShadowUtils21getWorldToLightMatrixERNS_9Matrix4x4ERKS1_RKNS_7Vector3E, __Z38Shader_Get_Custom_PropGlobalMaximumLODv: __Z38Shader_Get_Custom_PropGlobalMaximumLODv, __ZN5Umbra8QueryExt17queryShortestPathEjRNS_4PathERKNS_7Vector3ES5_: __ZN5Umbra8QueryExt17queryShortestPathEjRNS_4PathERKNS_7Vector3ES5_, __ZN5physx14NpArticulation17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx14NpArticulation17resolveReferencesERNS_24PxDeserializationContextE, __Z50Register_UnityEngine_EdgeCollider2D_get_pointCountv: __Z50Register_UnityEngine_EdgeCollider2D_get_pointCountv, __ZNKSt3__219__iostream_category7messageEi: __ZNKSt3__219__iostream_category7messageEi, __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf: __ZL20projectPointToPoly2DPKfPK6dtPolyPK10dtMeshTilePf, __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19SkinnedMeshRenderer8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN13BuildSettings20GetSceneIndexCheckedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN13BuildSettings20GetSceneIndexCheckedERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN13GfxDeviceNull14ImmediateColorEffff: __ZN13GfxDeviceNull14ImmediateColorEffff, __ZN15ReflectionProbe19IsFinishedRenderingEi: __ZN15ReflectionProbe19IsFinishedRenderingEi, __ZN16ParticleRenderer23VirtualRedirectTransferER14SafeBinaryRead: __ZN16ParticleRenderer23VirtualRedirectTransferER14SafeBinaryRead, __Z48SurfaceEffector2D_Get_Custom_PropUseContactForceP12Il2CppObject: __Z48SurfaceEffector2D_Get_Custom_PropUseContactForceP12Il2CppObject, __ZN5physx7NpCloth24sendPvdCollisionCapsulesEv: __ZN5physx7NpCloth24sendPvdCollisionCapsulesEv, __ZN11Rigidbody2D11SetBodyTypeENS_8BodyTypeEb: __ZN11Rigidbody2D11SetBodyTypeENS_8BodyTypeEb, __ZN5physx14NpShapeManager17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx14NpShapeManager17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN8Animator26AnimatorVisibilityCallbackEPvS0_i: __ZN8Animator26AnimatorVisibilityCallbackEPvS0_i, __ZN4FMOD3DSP16setSpeakerActiveE12FMOD_SPEAKERb: __ZN4FMOD3DSP16setSpeakerActiveE12FMOD_SPEAKERb, __ZN5physx8debugger8renderer19RenderSerializerMapINS1_11PvdTriangleEE9serializeERNS1_16RenderSerializerERS3_: __ZN5physx8debugger8renderer19RenderSerializerMapINS1_11PvdTriangleEE9serializeERNS1_16RenderSerializerERS3_, __Z45CanvasRenderer_Get_Custom_PropHasRectClippingP12Il2CppObject: __Z45CanvasRenderer_Get_Custom_PropHasRectClippingP12Il2CppObject, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI11KeyframeTplI11QuaternionfELj4EEEEvRT_17TransferMetaFlags, __Z65Register_UnityEngine_TerrainData_get_Internal_heightmapResolutionv: __Z65Register_UnityEngine_TerrainData_get_Internal_heightmapResolutionv, __Z27RegisterModuleClasses_IMGUIv: __Z27RegisterModuleClasses_IMGUIv, __ZN9GfxDevice16SetActiveContextEPv: __ZN9GfxDevice16SetActiveContextEPv, __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_originCustomv: __Z68Register_UnityEngine_LightProbeProxyVolume_INTERNAL_set_originCustomv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE9setPlanesENS0_5RangeIKNS_6PxVec4EEEjj, __ZNK16BaseVideoTexture20GetRuntimeMemorySizeEv: __ZNK16BaseVideoTexture20GetRuntimeMemorySizeEv, __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN13WheelCollider23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, ___fpurge: ___fpurge, __ZN23iPhoneLocalNotification12GetScheduledEv: __ZN23iPhoneLocalNotification12GetScheduledEv, __ZN18BuoyancyEffector2D16SetFlowVariationEf: __ZN18BuoyancyEffector2D16SetFlowVariationEf, __Z58Register_UnityEngine_SystemInfo_get_supportsRenderTexturesv: __Z58Register_UnityEngine_SystemInfo_get_supportsRenderTexturesv, __ZN5physx2Sc21ConstraintInteraction10onActivateEj: __ZN5physx2Sc21ConstraintInteraction10onActivateEj, __ZN9Projector8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9Projector8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNSt3__25stoldERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj: __ZNSt3__25stoldERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEPj, __ZN24OcclusionCullingSettings8TransferI14SafeBinaryReadEEvRT_: __ZN24OcclusionCullingSettings8TransferI14SafeBinaryReadEEvRT_, __GLOBAL__sub_I_runtime_graphics_mesh_lump_cpp: __GLOBAL__sub_I_runtime_graphics_mesh_lump_cpp, __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb: __ZN14NavMeshManager26SetOffMeshConnectionActiveEyb, __ZN5Umbra6DoubleC2Ei: __ZN5Umbra6DoubleC2Ei, __Z11GetRotationi: __Z11GetRotationi, __ZNKSt3__211__libcpp_db8__find_cEPv: __ZNKSt3__211__libcpp_db8__find_cEPv, __ZN7b2World8SolveTOIERK10b2TimeStep: __ZN7b2World8SolveTOIERK10b2TimeStep, __ZN5physx6shdfnd9atomicMaxEPVii: __ZN5physx6shdfnd9atomicMaxEPVii, __Z46Register_UnityEngine_RenderSettings_get_skyboxv: __Z46Register_UnityEngine_RenderSettings_get_skyboxv, __ZN16GraphicsSettings18GetBuiltinMaterialENS_19BuiltinMaterialTypeE: __ZN16GraphicsSettings18GetBuiltinMaterialENS_19BuiltinMaterialTypeE, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl15getNbPropertiesEN5physx8debugger18NonNegativeIntegerE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl15getNbPropertiesEN5physx8debugger18NonNegativeIntegerE, _ps_unicodes_char_next: _ps_unicodes_char_next, __ZN12LODFadeCache14ApplyValueOnlyEf: __ZN12LODFadeCache14ApplyValueOnlyEf, __ZN5physx3Ext7D6Joint13setTwistLimitERKNS_23PxJointAngularLimitPairE: __ZN5physx3Ext7D6Joint13setTwistLimitERKNS_23PxJointAngularLimitPairE, __ZN4FMOD8ChannelI18get3DCustomRolloffEPP11FMOD_VECTORPi: __ZN4FMOD8ChannelI18get3DCustomRolloffEPP11FMOD_VECTORPi, __ZN2UI6Canvas14SetScaleFactorEf: __ZN2UI6Canvas14SetScaleFactorEf, __ZN4FMOD7SystemI14getDriverInfoWEiPsiP9FMOD_GUID: __ZN4FMOD7SystemI14getDriverInfoWEiPsiP9FMOD_GUID, __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv: __ZNKSt3__215time_get_bynameIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE7__am_pmEv, __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN4PPtrIN5Unity9ComponentEE8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN13RenderTexture15DiscardContentsEbb: __ZN13RenderTexture15DiscardContentsEbb, __Z39UploadHandlerRaw_CUSTOM_InternalGetDataP12Il2CppObject: __Z39UploadHandlerRaw_CUSTOM_InternalGetDataP12Il2CppObject, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj546ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_27PxVehicleDifferential4WDataEEEEclILj546ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z32Light_CUSTOM_RemoveCommandBufferP12Il2CppObject20RenderLightEventTypeS0_: __Z32Light_CUSTOM_RemoveCommandBufferP12Il2CppObject20RenderLightEventTypeS0_, __ZN15b2RevoluteJoint24SolvePositionConstraintsERK12b2SolverData: __ZN15b2RevoluteJoint24SolvePositionConstraintsERK12b2SolverData, _UNITY_FT_Request_Metrics: _UNITY_FT_Request_Metrics, __ZN14RenderSettings15SetLinearFogEndEf: __ZN14RenderSettings15SetLinearFogEndEf, __Z41GUITexture_CUSTOM_INTERNAL_get_pixelInsetP12Il2CppObjectP5RectTIfE: __Z41GUITexture_CUSTOM_INTERNAL_get_pixelInsetP12Il2CppObjectP5RectTIfE, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED0Ev: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm21PvdInstanceDataStream10PvdCommandENS2_19ForwardingAllocatorEED0Ev, __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE: __ZN5physx10writeFloatEfbRNS_14PxOutputStreamE, __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_: __ZN15AnchoredJoint2D8TransferI17RemapPPtrTransferEEvRT_, __ZN15ConstantForce2DC2E10MemLabelId18ObjectCreationMode: __ZN15ConstantForce2DC2E10MemLabelId18ObjectCreationMode, __ZN5physx23PxVehicleWheels4DynData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx23PxVehicleWheels4DynData17getBinaryMetaDataERNS_14PxOutputStreamE, __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputCountInternalv: __Z88Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_GetOutputCountInternalv, __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferI22OffsetPtrArrayTransferIN7mecanim8skeleton4NodeEEEEvRT_PKc17TransferMetaFlags, __ZNK5physx2Sc5Scene17getBroadPhaseTypeEv: __ZNK5physx2Sc5Scene17getBroadPhaseTypeEv, __ZNSt3__227__insertion_sort_incompleteIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIRN10Effector2D15EffectorContact24PredecateContactGroupingEPS2_EEbT0_S6_T_, __ZN5physx38PxJointAngularLimitPairGeneratedValuesC2EPKNS_23PxJointAngularLimitPairE: __ZN5physx38PxJointAngularLimitPairGeneratedValuesC2EPKNS_23PxJointAngularLimitPairE, __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetLengthv: __Z57Register_UnityEngine_ParticleSystem_ShapeModule_GetLengthv, __Z30setPxActor_ClientBehaviorFlagsPN5physx7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE: __Z30setPxActor_ClientBehaviorFlagsPN5physx7PxActorENS_7PxFlagsINS_25PxActorClientBehaviorFlag4EnumEhEE, __ZNSt3__219__shared_mutex_base8try_lockEv: __ZNSt3__219__shared_mutex_base8try_lockEv, __ZN13SpringJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN13SpringJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv: __ZN5physx2Cm26PreallocatingRegionManager15searchForMemoryEv, __ZN5physx7NpCloth22setAngularInertiaScaleENS_6PxVec3E: __ZN5physx7NpCloth22setAngularInertiaScaleENS_6PxVec3E, __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB565EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB444415TexFormatRGB565EEvPKNS_9InnerInfoE, __ZN13MonoBehaviour18CallMethodInactiveEPKc: __ZN13MonoBehaviour18CallMethodInactiveEPKc, __ZN24iPhoneRemoteNotification8GetErrorEv: __ZN24iPhoneRemoteNotification8GetErrorEv, _vfwscanf: _vfwscanf, __Z50Register_UnityEngine_PointEffector2D_get_forceModev: __Z50Register_UnityEngine_PointEffector2D_get_forceModev, __ZN8Renderer19UpdateTransformInfoEv: __ZN8Renderer19UpdateTransformInfoEv, __ZN9ShaderLab4Pass28CreateFromSerializedGrabPassERKNS_14SerializedPassE: __ZN9ShaderLab4Pass28CreateFromSerializedGrabPassERKNS_14SerializedPassE, __ZN12_GLOBAL__N_123DoubleBufferedOutStream7releaseEv: __ZN12_GLOBAL__N_123DoubleBufferedOutStream7releaseEv, __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __Z57CrashReportHandler_Get_Custom_PropEnableCaptureExceptionsv: __Z57CrashReportHandler_Get_Custom_PropEnableCaptureExceptionsv, __ZNSt3__211__libcpp_db9__erase_cEPv: __ZNSt3__211__libcpp_db9__erase_cEPv, __Z42Shader_CUSTOM_GetGlobalVectorArrayImplListiP12Il2CppObject: __Z42Shader_CUSTOM_GetGlobalVectorArrayImplListiP12Il2CppObject, __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE8TransferIN9ShaderLab26SerializedShaderFloatValueEEEvRT_PKc17TransferMetaFlags, __ZN15SerializeTraitsI17JointSuspension2DE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI17JointSuspension2DE8TransferI14SafeBinaryReadEEvRS0_RT_, __ZN5physx2Sc9ShapeCore15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc9ShapeCore15importExtraDataERNS_24PxDeserializationContextE, __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE: __ZN12_GLOBAL__N_112RenderReaderILb0EE9streamifyERN5physx8debugger7DataRefINS3_8renderer7PvdLineEEE, __Z33Random_CUSTOM_GetRandomUnitCircleP13Vector2fIcall: __Z33Random_CUSTOM_GetRandomUnitCircleP13Vector2fIcall, __ZN19CloudServiceHandler10InitializeERK8UnityStrNS_13InitModeFlagsE: __ZN19CloudServiceHandler10InitializeERK8UnityStrNS_13InitModeFlagsE, __Z54ParticleSystem_LightsModule_CUSTOM_SetUseParticleColorP12Il2CppObjecth: __Z54ParticleSystem_LightsModule_CUSTOM_SetUseParticleColorP12Il2CppObjecth, __Z31WillAddComponentChangeTransformR10GameObjectiP11Il2CppClass: __Z31WillAddComponentChangeTransformR10GameObjectiP11Il2CppClass, __ZThn12_N5physx3Ext14SphericalJointD0Ev: __ZThn12_N5physx3Ext14SphericalJointD0Ev, __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE: __ZNSt3__26__treeINS_12__value_typeIj8UnityStrEENS_19__map_value_compareIjS3_NS_4lessIjEELb1EEENS_9allocatorIS3_EEE16__construct_nodeERKNS_4pairIKjS2_EE, __ZNK5physx9PxTaskMgr16getCpuDispatcherEv: __ZNK5physx9PxTaskMgr16getCpuDispatcherEv, __ZNK8TypeTree13DumpToConsoleEv: __ZNK8TypeTree13DumpToConsoleEv, __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYv: __Z64Register_UnityEngine_ParticleSystem_ForceOverLifetimeModule_GetYv, __ZN8JobQueue17CreateJobsForEachEPFvPvjES0_jPFvS0_E10JobGroupIDP8JobGroup: __ZN8JobQueue17CreateJobsForEachEPFvPvjES0_jPFvS0_E10JobGroupIDP8JobGroup, _UNITY_TT_Get_HMetrics: _UNITY_TT_Get_HMetrics, __Z42ParticleEmitter_Get_Custom_PropMinEmissionP12Il2CppObject: __Z42ParticleEmitter_Get_Custom_PropMinEmissionP12Il2CppObject, __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_: __Z17TransformAABBSlowRK10MinMaxAABBRK10Matrix4x4fRS_, __ZN13GfxDeviceGLES4InitE16GfxDeviceLevelGL: __ZN13GfxDeviceGLES4InitE16GfxDeviceLevelGL, __ZNK9AudioClip16GetBitsPerSampleEv: __ZNK9AudioClip16GetBitsPerSampleEv, ___procfdname: ___procfdname, __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE: __ZN5physx2Sc24ConstraintProjectionTree20purgeProjectionTreesERNS0_19ConstraintGroupNodeE, __ZN6Camera13SetClearFlagsEi: __ZN6Camera13SetClearFlagsEi, __ZN8Animator17RemoveFromManagerEv: __ZN8Animator17RemoveFromManagerEv, __ZN12_GLOBAL__N_112UserRenderer19visualizeDoubleConeERKN5physx11PxTransformEfb: __ZN12_GLOBAL__N_112UserRenderer19visualizeDoubleConeERKN5physx11PxTransformEfb, __ZN10GUIManagerC2Ev: __ZN10GUIManagerC2Ev, __Z26CleanLogToPlayerConnection7LogTypePKcPi: __Z26CleanLogToPlayerConnection7LogTypePKcPi, __Z49Register_UnityEngine_Mesh_GetBlendShapeFrameCountv: __Z49Register_UnityEngine_Mesh_GetBlendShapeFrameCountv, __ZN5physx2Sc21ArticulationJointCore13setTwistLimitEff: __ZN5physx2Sc21ArticulationJointCore13setTwistLimitEff, __ZNK11MatrixStack9GetMatrixEv: __ZNK11MatrixStack9GetMatrixEv, __ZN8Material14CreateMaterialER6Shaderib: __ZN8Material14CreateMaterialER6Shaderib, __Z23setPxCloth_InertiaScalePN5physx7PxClothEf: __Z23setPxCloth_InertiaScalePN5physx7PxClothEf, __ZNKSt3__210moneypunctIcLb1EE13do_neg_formatEv: __ZNKSt3__210moneypunctIcLb1EE13do_neg_formatEv, __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Linecastv: __Z62Register_UnityEngine_Physics2D_INTERNAL_CALL_Internal_Linecastv, __ZN6prcore9BlitImageERK14ImageReferenceRS0_ii: __ZN6prcore9BlitImageERK14ImageReferenceRS0_ii, __ZN4Mesh13RemoveChannelE13ShaderChannel: __ZN4Mesh13RemoveChannelE13ShaderChannel, __ZN13GfxDeviceNull18CreateVertexBufferEv: __ZN13GfxDeviceNull18CreateVertexBufferEv, __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_19PxVehicleEngineDataEE30PxFixedSizeLookupTablePropertyINS_3Pvd41PxPvdFixedSizeLookupTablePropertyAccessorILj521ES2_jfEEKNS_18PxUnknownClassInfoEEEvPjRKT_RT0_, __Z32setPxArticulationJoint_DriveTypePN5physx19PxArticulationJointENS_28PxArticulationJointDriveType4EnumE: __Z32setPxArticulationJoint_DriveTypePN5physx19PxArticulationJointENS_28PxArticulationJointDriveType4EnumE, __Z22CopyRemoteNotificationj: __Z22CopyRemoteNotificationj, __Z19JoystickButtonToKeyii: __Z19JoystickButtonToKeyii, __ZN18WheelFrictionCurve8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18WheelFrictionCurve8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7getNameEv: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE7getNameEv, __ZN5physx31PxClothGeodesicTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE: __ZN5physx31PxClothGeodesicTetherCookerImpl16createTetherDataERKNS_15PxClothMeshDescE, __Z61ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailMultiplierP12Il2CppObject: __Z61ParticleSystem_TrailModule_CUSTOM_GetWidthOverTrailMultiplierP12Il2CppObject, __Z49Register_UnityEngine_Animator_get_feetPivotActivev: __Z49Register_UnityEngine_Animator_get_feetPivotActivev, __ZN6prcoreL26RemapGenericFloatToIntegerI14TexFormatRHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE: __ZN6prcoreL26RemapGenericFloatToIntegerI14TexFormatRHalf17TexFormatARGB8888EEvPKNS_9InnerInfoE, __ZN9Texture2D13RebuildMipMapEv: __ZN9Texture2D13RebuildMipMapEv, __Z38Transform_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf: __Z38Transform_CUSTOM_INTERNAL_set_rotationP12Il2CppObjectRK11Quaternionf, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEE15indexedPropertyILj410ENS_7PxJointENS_17PxJointActorIndex4EnumENS_11PxTransformEEEvjRKNS_21PxIndexedPropertyInfoIXT_ET0_T1_T2_EEPKNS_11PxU32ToNameERKNS_18PxUnknownClassInfoE, __ZN23ShaderVariantCollection23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN23ShaderVariantCollection23VirtualRedirectTransferER17RemapPPtrTransfer, __Z51TerrainData_Get_Custom_PropDetailResolutionPerPatchP12Il2CppObject: __Z51TerrainData_Get_Custom_PropDetailResolutionPerPatchP12Il2CppObject, __ZN20OcclusionCullingData12SetUmbraTomeEPKhi: __ZN20OcclusionCullingData12SetUmbraTomeEPKhi, __ZN5physx2Sn13XmlNodeWriter12addAttributeEPKcS3_: __ZN5physx2Sn13XmlNodeWriter12addAttributeEPKcS3_, __ZN9Texture2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Texture2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z33Register_UnityEngine_GL_TexCoord2v: __Z33Register_UnityEngine_GL_TexCoord2v, __Z18Transfer_BlittableI9JSONWriteLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb0E8Vector3fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK11TimeManager26GetTypeInfoVirtualInternalEv: __ZNK11TimeManager26GetTypeInfoVirtualInternalEv, __ZN4crnd10dxt1_block14pack_endpointsEjj: __ZN4crnd10dxt1_block14pack_endpointsEjj, __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc19ShapeInstancePairLLENS0_19ReflectionAllocatorIS3_EEE12allocateSlabEv, __ZN7mecanim9animation12AvatarMemory8TransferI17RemapPPtrTransferEEvRT_: __ZN7mecanim9animation12AvatarMemory8TransferI17RemapPPtrTransferEEvRT_, __ZNK12b2MotorJoint12GetMaxTorqueEv: __ZNK12b2MotorJoint12GetMaxTorqueEv, __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDrive4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE: __ZN5physx2Sn17readAllPropertiesINS_16PxVehicleDrive4WEEEbNS_23PxRepXInstantiationArgsERNS_9XmlReaderEPT_RNS_18XmlMemoryAllocatorERNS_12PxCollectionE, __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferI11ColorRGBA32EEvRT_PKc17TransferMetaFlagsb, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj44ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj44ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_: __ZN5physx6shdfnd5ArrayINS_2Sc5Scene14SimpleBodyPairENS0_19ReflectionAllocatorIS4_EEE6resizeEjRKS4_, __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetSeparateAxesv: __Z78Register_UnityEngine_ParticleSystem_RotationOverLifetimeModule_GetSeparateAxesv, __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE15growAndPushBackERKS2_: __ZN5physx6shdfnd5ArrayIPvNS0_19ReflectionAllocatorINS_2Cm5BlockIhLj256EEEEEE15growAndPushBackERKS2_, __Z44Register_UnityEngine_GUI_Internal_EndWindowsv: __Z44Register_UnityEngine_GUI_Internal_EndWindowsv, __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue8TransferI8JSONReadEEvRT_: __ZN11UnityEngine9Analytics15AnalyticsConfig11ConfigValue8TransferI8JSONReadEEvRT_, __ZN12CachedReader11SetPositionEj: __ZN12CachedReader11SetPositionEj, __ZN14DirectorPlayer14OnProcessStageERK13dynamic_arrayI11DirectorJobLj8EE: __ZN14DirectorPlayer14OnProcessStageERK13dynamic_arrayI11DirectorJobLj8EE, __Z41Camera_Get_Custom_PropUseOcclusionCullingP12Il2CppObject: __Z41Camera_Get_Custom_PropUseOcclusionCullingP12Il2CppObject, _UNITY_png_set_expand_gray_1_2_4_to_8: _UNITY_png_set_expand_gray_1_2_4_to_8, __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_: __ZNSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEPN16MemoryFileSystem4NodeEEENS_19__map_value_compareIS8_SC_NS_4lessIS8_EELb1EEES5_ISC_LS6_54ELi16EEE4findIS8_EENS_15__tree_iteratorISC_PNS_11__tree_nodeISC_PvEEiEERKT_, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EtEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN12_GLOBAL__N_112UserRenderer12removeClientERN5physx26PxProfileEventBufferClientE: __ZN12_GLOBAL__N_112UserRenderer12removeClientERN5physx26PxProfileEventBufferClientE, __ZN8TypeTree19AppendChildrenRangeERK16TypeTreeIteratorjjb: __ZN8TypeTree19AppendChildrenRangeERK16TypeTreeIteratorjjb, __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii: __ZN7mecanim5human15Human2LimbAlignEPKNS0_5HumanEPKNS_8skeleton13SkeletonPoseTIN4math4trsXEEEPS8_SB_ii, __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI4PPtrI6ShaderE8UnityStrEEEEvRT_PKc17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE8TransferINSt3__24pairI4PPtrI6ShaderE8UnityStrEEEEvRT_PKc17TransferMetaFlags, __ZN9Rigidbody16SetSleepVelocityEf: __ZN9Rigidbody16SetSleepVelocityEf, __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_16PxVehicleNoDriveEE12getClassSizeEv, __Z18SplitRespectQuotesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorIS5_NS3_IS5_EEEE: __Z18SplitRespectQuotesRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEERNS_6vectorIS5_NS3_IS5_EEEE, __ZN19CullingGroupManager15AddCullingGroupEP12CullingGroup: __ZN19CullingGroupManager15AddCullingGroupEP12CullingGroup, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11getGridSizeEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE11getGridSizeEv, __ZZN8VRDevice10InitializeEbEN30FixedUpdateVRFixedUpdatestruct7ForwardEv: __ZZN8VRDevice10InitializeEbEN30FixedUpdateVRFixedUpdatestruct7ForwardEv, __ZNK16ReflectionProbes28RealtimeReflectionProbeCountEv: __ZNK16ReflectionProbes28RealtimeReflectionProbeCountEv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE17setConstraintFlagENS_16PxConstraintFlag4EnumEb, __Z43Register_UnityEngine_Collider_set_isTriggerv: __Z43Register_UnityEngine_Collider_set_isTriggerv, __ZNK11Rigidbody2D18GetAngularVelocityEv: __ZNK11Rigidbody2D18GetAngularVelocityEv, __ZN5Umbra12QueryContext11getGateCostERKNS_6PortalE: __ZN5Umbra12QueryContext11getGateCostERKNS_6PortalE, _UNITY_png_handle_pCAL: _UNITY_png_handle_pCAL, __ZN6b2Body11SetMassDataEPK10b2MassData: __ZN6b2Body11SetMassDataEPK10b2MassData, __ZN20UnloadSceneOperation19IntegrateMainThreadEv: __ZN20UnloadSceneOperation19IntegrateMainThreadEv, __Z29StdTemplateConversionFunctionIbxEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIbxEbPvR14SafeBinaryRead, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getWorldBoundsEf: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE14getWorldBoundsEf, __ZNK21EnlightenSceneMapping16GetRenderersSizeEi: __ZNK21EnlightenSceneMapping16GetRenderersSizeEi, __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture: __ZN13RenderManager24OnRenderSurfaceDestroyedE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEP13RenderTexture, __Z42Effector2D_Get_Custom_PropRequiresColliderP12Il2CppObject: __Z42Effector2D_Get_Custom_PropRequiresColliderP12Il2CppObject, __Z66Register_UnityEngine_Networking_UnityWebRequest_get_uploadProgressv: __Z66Register_UnityEngine_Networking_UnityWebRequest_get_uploadProgressv, __Z62Register_UnityEngine_LODGroup_INTERNAL_set_localReferencePointv: __Z62Register_UnityEngine_LODGroup_INTERNAL_set_localReferencePointv, __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev: __ZNSt3__212basic_stringIcNS_11char_traitsIcEEN10__cxxabiv112_GLOBAL__N_112malloc_allocIcEEED2Ev, __ZNKSt3__25ctypeIwE11do_scan_notEtPKwS3_: __ZNKSt3__25ctypeIwE11do_scan_notEtPKwS3_, __ZN10MonoScript23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN10MonoScript23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __Z15AddLoopingFrameIfEvR17AnimationCurveTplIT_Ef: __Z15AddLoopingFrameIfEvR17AnimationCurveTplIT_Ef, __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN16GraphicsSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN8Material23VirtualRedirectTransferER14SafeBinaryRead: __ZN8Material23VirtualRedirectTransferER14SafeBinaryRead, __ZNK7Texture26CanReuploadDataToGfxDeviceEv: __ZNK7Texture26CanReuploadDataToGfxDeviceEv, __ZN5physx25PxVehicleGraphChannelDescC2Ev: __ZN5physx25PxVehicleGraphChannelDescC2Ev, _getservbyport: _getservbyport, __ZN12HandlerChainD2Ev: __ZN12HandlerChainD2Ev, __ZN5physx13NpVolumeCache21getMaxNbDynamicShapesEv: __ZN5physx13NpVolumeCache21getMaxNbDynamicShapesEv, __Z53Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_Raycastv: __Z53Register_UnityEngine_AI_NavMesh_INTERNAL_CALL_Raycastv, __ZN14VehiclesModule37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf: __ZN14VehiclesModule37UpdateVehicleSpringCMOffsetsAndMassesEPN5physx16PxVehicleNoDriveEf, __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE: __ZN5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE12setLocalPoseENS_17PxJointActorIndex4EnumERKNS_11PxTransformE, __ZN5physx8debugger4comm23AppendPropertyValueData9serializeERNS1_15EventSerializerE: __ZN5physx8debugger4comm23AppendPropertyValueData9serializeERNS1_15EventSerializerE, __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEvT0_S8_T_, __ZNK9Transform16GetTransformTypeEv: __ZNK9Transform16GetTransformTypeEv, __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState: __ZN4gles17CreateRasterStateER15DeviceStateGLESRK14GfxRasterState, __ZN11Rigidbody2D15SetCenterOfMassERK8Vector2f: __ZN11Rigidbody2D15SetCenterOfMassERK8Vector2f, __Z58Register_UnityEngine_ParticleSystem_ShapeModule_SetEnabledv: __Z58Register_UnityEngine_ParticleSystem_ShapeModule_SetEnabledv, __ZNK4Mesh18GetTotalIndexCountEv: __ZNK4Mesh18GetTotalIndexCountEv, __Z49getPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj: __Z49getPxVehicleWheelsSimData_SuspForceAppPointOffsetPKN5physx22PxVehicleWheelsSimDataEj, __ZN12_GLOBAL__N_124PropertyDefinitionHelper13addNamedValueEPKcj: __ZN12_GLOBAL__N_124PropertyDefinitionHelper13addNamedValueEPKcj, __ZN7mecanim9animation21CreateClipMuscleInputEPKNS0_18ClipMuscleConstantERNS_6memory9AllocatorE: __ZN7mecanim9animation21CreateClipMuscleInputEPKNS0_18ClipMuscleConstantERNS_6memory9AllocatorE, __ZN11UnityEngine7Connect14RemoteSettings6HasKeyERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE: __ZN11UnityEngine7Connect14RemoteSettings6HasKeyERKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEE, __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZv: __Z60Register_UnityEngine_ParticleSystem_MainModule_GetStartSizeZv, __ZN5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE: __ZN5physx5cloth9ClothImplINS0_7SwClothEE23setSelfCollisionIndicesENS0_5RangeIKjEE, __ZN12_GLOBAL__N_119RendererEventClientD0Ev: __ZN12_GLOBAL__N_119RendererEventClientD0Ev, __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__zeroEv: __ZNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE6__zeroEv, __ZN20TextRenderingPrivate8TextMeshC2E10MemLabelId18ObjectCreationMode: __ZN20TextRenderingPrivate8TextMeshC2E10MemLabelId18ObjectCreationMode, __Z44Register_UnityEngine_Input_get_imeIsSelectedv: __Z44Register_UnityEngine_Input_get_imeIsSelectedv, __Z29InitializeTextRenderingModulev: __Z29InitializeTextRenderingModulev, __ZNK14TerrainManager21GetInterpolatedHeightEPK6ObjectRK8Vector3fS5_Rf: __ZNK14TerrainManager21GetInterpolatedHeightEPK6ObjectRK8Vector3fS5_Rf, __ZN30RuntimeInitializeOnLoadManagerC2E10MemLabelId18ObjectCreationMode: __ZN30RuntimeInitializeOnLoadManagerC2E10MemLabelId18ObjectCreationMode, __ZSt15get_new_handlerv: __ZSt15get_new_handlerv, __ZN12_GLOBAL__N_15qNullEff: __ZN12_GLOBAL__N_15qNullEff, __Z46Register_UnityEngine_VR_VRSettings_get_enabledv: __Z46Register_UnityEngine_VR_VRSettings_get_enabledv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxPrismaticJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _jsimd_can_convsamp: _jsimd_can_convsamp, __ZN14BoxCast2DQuery19InitializeCastShapeEv: __ZN14BoxCast2DQuery19InitializeCastShapeEv, __Z42Register_UnityEngine_LightProbes_get_countv: __Z42Register_UnityEngine_LightProbes_get_countv, __ZN14RotationModuleD2Ev: __ZN14RotationModuleD2Ev, __Z40AndroidJNI_CUSTOM_SetBooleanArrayElement13Il2Cpp_IntPtrih: __Z40AndroidJNI_CUSTOM_SetBooleanArrayElement13Il2Cpp_IntPtrih, __ZN9Animation22UpdateQueuedAnimationsERb: __ZN9Animation22UpdateQueuedAnimationsERb, __ZN15ResourceManager23VirtualRedirectTransferER17RemapPPtrTransfer: __ZN15ResourceManager23VirtualRedirectTransferER17RemapPPtrTransfer, __Z68Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_GetWindowsBoundsv: __Z68Register_UnityEngine_GUILayoutUtility_INTERNAL_CALL_GetWindowsBoundsv, __ZNK5physx2Sc5Scene26getVisualizationCullingBoxEv: __ZNK5physx2Sc5Scene26getVisualizationCullingBoxEv, __Z44Register_UnityEngine_AnimationState_set_namev: __Z44Register_UnityEngine_AnimationState_set_namev, __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev: __ZTv0_n12_NSt3__213basic_istreamIcNS_11char_traitsIcEEED1Ev, __Z41UnityAdsSettings_CUSTOM_IsPlatformEnabledi: __Z41UnityAdsSettings_CUSTOM_IsPlatformEnabledi, __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx7NpActor15importExtraDataERNS_24PxDeserializationContextE, __Z37getPxScene_ContactCorrelationDistancePKN5physx7PxSceneE: __Z37getPxScene_ContactCorrelationDistancePKN5physx7PxSceneE, __ZN18ProceduralMaterial15RebuildTexturesEv: __ZN18ProceduralMaterial15RebuildTexturesEv, __ZN10AudioMixerC2E10MemLabelId18ObjectCreationMode: __ZN10AudioMixerC2E10MemLabelId18ObjectCreationMode, __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_10NpMaterialEE18registerReferencesERNS_6PxBaseERNS_22PxSerializationContextE, __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE19TransferSTLStyleMapINSt3__23mapIj8UnityStrNS2_4lessIjEENS2_9allocatorINS2_4pairIKjS4_EEEEEEEEvRT_17TransferMetaFlags, __ZNK14ParticleSystem26GetTypeInfoVirtualInternalEv: __ZNK14ParticleSystem26GetTypeInfoVirtualInternalEv, __ZN5physx18PxVehicleDriveTank4freeEv: __ZN5physx18PxVehicleDriveTank4freeEv, __ZN5physx10BPWorkTask11runInternalEv: __ZN5physx10BPWorkTask11runInternalEv, __ZN5physx14NpRigidDynamic13switchToNoSimEv: __ZN5physx14NpRigidDynamic13switchToNoSimEv, __ZN5physx17MBPUpdateWorkTask11runInternalEv: __ZN5physx17MBPUpdateWorkTask11runInternalEv, __ZN12EventManager20InvokeEventNonStaticEP10EventEntryPvi: __ZN12EventManager20InvokeEventNonStaticEP10EventEntryPvi, __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EEPKN5Unity4TypeEz: __ZN6Object22FindInstanceIDsOfTypesER13dynamic_arrayIiLj4EEPKN5Unity4TypeEz, __Z52Register_UnityEngine_LineRenderer_get_numCapVerticesv: __Z52Register_UnityEngine_LineRenderer_get_numCapVerticesv, __Z42Register_UnityEngine_Collider2D_IsTouchingv: __Z42Register_UnityEngine_Collider2D_IsTouchingv, __ZNKSt3__27codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j: __ZNKSt3__27codecvtIDic11__mbstate_tE9do_lengthERS1_PKcS5_j, __ZL19b2FindMaxSeparationPiPK14b2PolygonShapeRK11b2TransformS2_S5_: __ZL19b2FindMaxSeparationPiPK14b2PolygonShapeRK11b2TransformS2_S5_, __ZN5physx6shdfnd10Foundation19AlignCheckAllocator26registerAllocationListenerERNS_20PxAllocationListenerE: __ZN5physx6shdfnd10Foundation19AlignCheckAllocator26registerAllocationListenerERNS_20PxAllocationListenerE, __ZN17InternalIndexPoolD2Ev: __ZN17InternalIndexPoolD2Ev, __ZNKSt3__217moneypunct_bynameIwLb0EE16do_negative_signEv: __ZNKSt3__217moneypunct_bynameIwLb0EE16do_negative_signEv, __ZN9GfxDevice14SetTextureNameE9TextureIDPKc: __ZN9GfxDevice14SetTextureNameE9TextureIDPKc, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_RKS4_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEEC2EOS5_RKS4_, __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE10InitializeEv: __ZN13RuntimeStaticINSt3__23setI19RepeatingLogMessageNS0_4lessIS2_EE13stl_allocatorIS2_L18MemLabelIdentifier70ELi16EEEEE10InitializeEv, __ZNSt3__217moneypunct_bynameIwLb1EED2Ev: __ZNSt3__217moneypunct_bynameIwLb1EED2Ev, __Z44Register_UnityEngine_AndroidJNI_IsInstanceOfv: __Z44Register_UnityEngine_AndroidJNI_IsInstanceOfv, __ZNK10SizeModule6UpdateERK23ParticleSystemParticlesPPf: __ZNK10SizeModule6UpdateERK23ParticleSystemParticlesPPf, __ZN8Material13SetFloatArrayEN9ShaderLab16FastPropertyNameEPKfj: __ZN8Material13SetFloatArrayEN9ShaderLab16FastPropertyNameEPKfj, __Z46EmitSerializationCommandsForManagedObjectFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions: __Z46EmitSerializationCommandsForManagedObjectFieldI14SafeBinaryReadEvRK18TransferField_InfoR32SerializationCommandQueueBuilderRP20AllowNameConversions, __ZN8Renderer17SetSortingLayerIDEi: __ZN8Renderer17SetSortingLayerIDEi, __ZN5physx13PxHitCallbackINS_12PxOverlapHitEED2Ev: __ZN5physx13PxHitCallbackINS_12PxOverlapHitEED2Ev, __Z14GetTemporaryRTbbibb: __Z14GetTemporaryRTbbibb, __ZN12LightsModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN12LightsModule8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z49Register_UnityEngine_Physics_IgnoreLayerCollisionv: __Z49Register_UnityEngine_Physics_IgnoreLayerCollisionv, __ZN7mecanim4hand8HandPose8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim4hand8HandPose8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN12_GLOBAL__N_117ConnectionManager29getAndAddRefCurrentConnectionEv: __ZN12_GLOBAL__N_117ConnectionManager29getAndAddRefCurrentConnectionEv, __ZN9Transform7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Transform7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj: __ZN5physx6shdfnd5ArrayIjNS0_19ReflectionAllocatorIjEEE19resizeUninitializedEj, __ZN2UI15DoSyncWorldRectERNS_13UIInstructionE: __ZN2UI15DoSyncWorldRectERNS_13UIInstructionE, __ZNK5physx2Gu5RTree11traverseRayILi0EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f: __ZNK5physx2Gu5RTree11traverseRayILi0EEEvRKNS_6PxVec3ES5_jPjPNS1_15CallbackRaycastEPS4_f, __ZNK5Umbra11Transformer23transformClipXYToRasterERKNS_7Vector2Eb: __ZNK5Umbra11Transformer23transformClipXYToRasterERKNS_7Vector2Eb, __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D8BodyTypeEEvRT_RT0_PKc17TransferMetaFlags: __Z32TransferEnumWithNameForceIntSizeI14SafeBinaryReadN11Rigidbody2D8BodyTypeEEvRT_RT0_PKc17TransferMetaFlags, __Z40Register_UnityEngine_Texture3D_get_depthv: __Z40Register_UnityEngine_Texture3D_get_depthv, __ZNK8VRModule23GetFirstSupportedDeviceEv: __ZNK8VRModule23GetFirstSupportedDeviceEv, __ZNK13AnimationClip22GetAverageAngularSpeedEv: __ZNK13AnimationClip22GetAverageAngularSpeedEv, __ZN7mecanim12statemachine18StateMachineMemory8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN7mecanim12statemachine18StateMachineMemory8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__28__get_dbEv: __ZNSt3__28__get_dbEv, __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_: __ZNSt3__26vectorIPN2UI6CanvasENS_9allocatorIS3_EEE6insertENS_11__wrap_iterIPKS3_EERS8_, __ZN5physx5cloth11SwCollisionI8Scalar4fE26collideContinuousParticlesEv: __ZN5physx5cloth11SwCollisionI8Scalar4fE26collideContinuousParticlesEv, __Z40setPxParticleReadDataValidParticleBitmapPN5physx18PxParticleReadDataEPKj: __Z40setPxParticleReadDataValidParticleBitmapPN5physx18PxParticleReadDataEPKj, __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE8__appendEj: __ZNSt3__26vectorI16ShadowCasterData13stl_allocatorIS1_L18MemLabelIdentifier2ELi16EEE8__appendEj, __Z52Register_UnityEngine_AudioReverbFilter_set_decayTimev: __Z52Register_UnityEngine_AudioReverbFilter_set_decayTimev, __ZN8Playable19DeallocateResourcesEv: __ZN8Playable19DeallocateResourcesEv, __ZN5physx14NpSceneQueriesC2ERKNS_11PxSceneDescE: __ZN5physx14NpSceneQueriesC2ERKNS_11PxSceneDescE, __ZL18computePlaneBoundsRN5physx9PxBounds3ERKNS_11PxTransformEf: __ZL18computePlaneBoundsRN5physx9PxBounds3ERKNS_11PxTransformEf, __ZN4FMOD8ChannelI11EndCallbackEv: __ZN4FMOD8ChannelI11EndCallbackEv, __ZN20GpuProgramParametersaSERKS_: __ZN20GpuProgramParametersaSERKS_, __Z51Register_UnityEngine_Profiling_Profiler_get_enabledv: __Z51Register_UnityEngine_Profiling_Profiler_get_enabledv, __Z13RegisterClassI16CircleCollider2DEvv: __Z13RegisterClassI16CircleCollider2DEvv, __ZNK5physx2Cm10Collection8getNbIdsEv: __ZNK5physx2Cm10Collection8getNbIdsEv, __ZNK5physx25PxClothSimpleTetherCooker15getCookerStatusEv: __ZNK5physx25PxClothSimpleTetherCooker15getCookerStatusEv, __ZN25b2CapsuleAndCircleContactD0Ev: __ZN25b2CapsuleAndCircleContactD0Ev, __Z34Register_UnityEngine_WWW_get_errorv: __Z34Register_UnityEngine_WWW_get_errorv, __ZN13ComputeShader30DestroyRuntimeDataWorkerThreadEv: __ZN13ComputeShader30DestroyRuntimeDataWorkerThreadEv, __Z47Register_UnityEngine_Animator_get_hasRootMotionv: __Z47Register_UnityEngine_Animator_get_hasRootMotionv, __ZN5physx17PxMeshOverlapUtilD2Ev: __ZN5physx17PxMeshOverlapUtilD2Ev, __Z35RegisterModuleClasses_JSONSerializev: __Z35RegisterModuleClasses_JSONSerializev, __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPj: __ZN16RayRTreeCallbackILi0ELb1EE14processResultsEjPj, __ZNK8Animator13HasRootMotionEv: __ZNK8Animator13HasRootMotionEv, __Z18tessGetVertexCountP14TESStesselator: __Z18tessGetVertexCountP14TESStesselator, __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEED0Ev: __ZN5physx2Cm18DelegateFanoutTaskINS_2Sc5SceneEXadL_ZNS3_17finalizationPhaseEPNS_10PxBaseTaskEEEED0Ev, __Z16ApplyRadialForceR23ParticleSystemParticlesjjRK8Vector3ffRKN4math7_float4E: __Z16ApplyRadialForceR23ParticleSystemParticlesjjRK8Vector3ffRKN4math7_float4E, __ZN18StreamedBinaryReadILb1EE10ReadDirectEPvi: __ZN18StreamedBinaryReadILb1EE10ReadDirectEPvi, __Z27IsShaderInstanceMatrixParamPKcPi: __Z27IsShaderInstanceMatrixParamPKcPi, __ZN12CubemapArray14DestroyTextureEv: __ZN12CubemapArray14DestroyTextureEv, __ZN13GfxDeviceNull14BeforeDrawCallEv: __ZN13GfxDeviceNull14BeforeDrawCallEv, __ZN14PhysicMaterial17SetStaticFrictionEf: __ZN14PhysicMaterial17SetStaticFrictionEf, __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb: __ZN5physx2Gu18GJKRelativeRayCastERNS0_4BoxVES2_RKNS_6shdfnd3aos15PsMatTransformVERKNS4_6FloatVERKNS4_5Vec3VESD_RS8_RSB_SF_fb, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI10vector_mapI7Hash128S3_NSt3__24lessIS3_EENS4_9allocatorINS4_4pairIS3_S3_EEEEEEEvRT_17TransferMetaFlags, __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci: __ZNSt3__215basic_streambufIcNS_11char_traitsIcEEE6xsgetnEPci, __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri: __ZNK5physx2Gu17ShrunkConvexHullV12supportLocalERKNS_6shdfnd3aos5Vec3VERS4_Ri, __ZN5physx30PxcContactTraceSegmentCallback12underFaceHitERKNS_2Gu15HeightFieldUtilERKNS_6PxVec3ES7_fffj: __ZN5physx30PxcContactTraceSegmentCallback12underFaceHitERKNS_2Gu15HeightFieldUtilERKNS_6PxVec3ES7_fffj, __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEEC2ERNS_19PxAllocatorCallbackE: __ZN5physx21PxJointRepXSerializerINS_15PxRevoluteJointEEC2ERNS_19PxAllocatorCallbackE, __ZN5physx15PxsParticleData16removeParticlesVEv: __ZN5physx15PxsParticleData16removeParticlesVEv, __ZN5physx19NpArticulationJoint21setInternalComplianceEf: __ZN5physx19NpArticulationJoint21setInternalComplianceEf, __ZN5physx3Cct9SweepTest13voidTestCacheEv: __ZN5physx3Cct9SweepTest13voidTestCacheEv, __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatA8EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI17TexFormatARGB888811TexFormatA8EEvPKNS_9InnerInfoE, __Z44Register_UnityEngine_ComputeShader_SetBufferv: __Z44Register_UnityEngine_ComputeShader_SetBufferv, __ZN22DownloadHandlerTexture22OnReceiveContentLengthEj: __ZN22DownloadHandlerTexture22OnReceiveContentLengthEj, __Z27CanvasRenderer_CUSTOM_ClearP12Il2CppObject: __Z27CanvasRenderer_CUSTOM_ClearP12Il2CppObject, __ZN14RotationModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14RotationModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN7ApiGLES7DisableEN2gl10EnabledCapE: __ZN7ApiGLES7DisableEN2gl10EnabledCapE, __ZN5physx3Cct17CapsuleController15setClimbingModeENS_21PxCapsuleClimbingMode4EnumE: __ZN5physx3Cct17CapsuleController15setClimbingModeENS_21PxCapsuleClimbingMode4EnumE, __Z54Register_UnityEngine_WheelCollider_INTERNAL_get_centerv: __Z54Register_UnityEngine_WheelCollider_INTERNAL_get_centerv, __Z39Register_UnityEngine_GameObject_set_tagv: __Z39Register_UnityEngine_GameObject_set_tagv, __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjPjPfRNS_6memory9AllocatorE: __ZN7mecanim9animation27CreateBlendTreeNodeConstantEjjPjPfRNS_6memory9AllocatorE, __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_: __ZN5physx2Sc5Scene18addToLostTouchListEPNS0_7BodySimES3_, __ZNSt3__28numpunctIwEC2Ej: __ZNSt3__28numpunctIwEC2Ej, _UnityReplayKitHideCameraPreview: _UnityReplayKitHideCameraPreview, __ZN15LODGroupManager21ReserveInternalArraysEj: __ZN15LODGroupManager21ReserveInternalArraysEj, __Z46TerrainData_Get_Custom_PropWavingGrassStrengthP12Il2CppObject: __Z46TerrainData_Get_Custom_PropWavingGrassStrengthP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayIN9SubModule14SubEmitterDataELj4EEEEvRT_17TransferMetaFlags, __ZN11UnityEngine7Connect20BasePersistentValues7RestoreERK8UnityStr: __ZN11UnityEngine7Connect20BasePersistentValues7RestoreERK8UnityStr, _mblen: _mblen, __ZN14DetailDatabase17ResetDirtyDetailsEv: __ZN14DetailDatabase17ResetDirtyDetailsEv, __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_: __ZNSt3__26vectorI17SubstanceEnumItemNS_9allocatorIS1_EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS8_E9referenceEEE5valueEvE4typeES8_S8_, __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_2Gu10ConvexMeshEE15exportExtraDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZNK5Umbra4Path11getNumNodesEv: __ZNK5Umbra4Path11getNumNodesEv, __ZN12b2MouseJoint24SolvePositionConstraintsERK12b2SolverData: __ZN12b2MouseJoint24SolvePositionConstraintsERK12b2SolverData, __ZN10GISettings5ResetEv: __ZN10GISettings5ResetEv, __ZN5physx7NpCloth24setSelfCollisionDistanceEf: __ZN5physx7NpCloth24setSelfCollisionDistanceEf, __ZN5physx2Sc10NPhaseCore19findTriggerContactsEPNS0_18TriggerInteractionEbb: __ZN5physx2Sc10NPhaseCore19findTriggerContactsEPNS0_18TriggerInteractionEbb, __ZN15DirectorManager24ConstructPlayableOfClassEP11Il2CppClass: __ZN15DirectorManager24ConstructPlayableOfClassEP11Il2CppClass, __ZN5physx8debugger14PvdMarshallingIsdE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIsdE12marshalBlockEPKhPhj, _cff_builder_start_point: _cff_builder_start_point, __Z45Register_UnityEngine_Display_GetSystemExtImplv: __Z45Register_UnityEngine_Display_GetSystemExtImplv, __Z37Register_UnityEngine_Random_InitStatev: __Z37Register_UnityEngine_Random_InitStatev, __ZNSt3__217moneypunct_bynameIwLb1EE4initEPKc: __ZNSt3__217moneypunct_bynameIwLb1EE4initEPKc, _bind_textdomain_codeset: _bind_textdomain_codeset, __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi: __ZN5physx2Sn5ConvX12convertClassEPKcPKNS0_9MetaClassEi, __Z31Register_UnityEngine_Event_Initv: __Z31Register_UnityEngine_Event_Initv, __Z41Application_Get_Custom_PropCloudProjectIdv: __Z41Application_Get_Custom_PropCloudProjectIdv, __ZN31TransformFeedbackSkinPoseBufferD2Ev: __ZN31TransformFeedbackSkinPoseBufferD2Ev, __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE: __ZN5physx2Gu13getConvexDataERKNS0_13GeometryUnionERNS_2Cm23FastVertex2ShapeScalingERNS_9PxBounds3ERNS0_13PolygonalDataE, __Z29Transfer_Blittable_ArrayFieldI8JSONReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadaEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f: __ZNK8WindZone17ComputeWindVectorERK4AABBR8Vector4f, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb0EE8BitFieldEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z29StdTemplateConversionFunctionIdfEbPvR14SafeBinaryRead: __Z29StdTemplateConversionFunctionIdfEbPvR14SafeBinaryRead, __Z24RegisterStrippedTypeInfoI21LightProbeProxyVolumeEviPKcS2_: __Z24RegisterStrippedTypeInfoI21LightProbeProxyVolumeEviPKcS2_, _bind: _bind, __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainTetherEv: __ZN5physx5cloth14SwSolverKernelI8Scalar4fE15constrainTetherEv, __Z7md5hashPKvij: __Z7md5hashPKvij, __Z25Event_Set_Custom_PropTypeP12Il2CppObjecti: __Z25Event_Set_Custom_PropTypeP12Il2CppObjecti, __Z47ParticleSystemRenderer_RenderMultipleBillboardsRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns: __Z47ParticleSystemRenderer_RenderMultipleBillboardsRK15RenderNodeQueueRK18RenderMultipleDataRK14ChannelAssigns, __ZN8Material25GetDefaultDiffuseMaterialEv: __ZN8Material25GetDefaultDiffuseMaterialEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj483ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN10MonoScript8TransferI14SafeBinaryReadEEvRT_: __ZN10MonoScript8TransferI14SafeBinaryReadEEvRT_, __ZN5Umbra12PortalCuller14findRemoteCellERNS0_4TileEiiRNS0_9CellStateE: __ZN5Umbra12PortalCuller14findRemoteCellERNS0_4TileEiiRNS0_9CellStateE, __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_: __ZNK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE9getActorsERPNS_12PxRigidActorES7_, __Z57Register_UnityEngine_WebCamTexture_INTERNAL_CALL_GetPixelv: __Z57Register_UnityEngine_WebCamTexture_INTERNAL_CALL_GetPixelv, __Z31Profiler_CUSTOM_GetMonoUsedSizev: __Z31Profiler_CUSTOM_GetMonoUsedSizev, __Z68Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetProgressv: __Z68Register_UnityEngine_Networking_UploadHandlerRaw_InternalGetProgressv, __Z17CommitBatchDeleteR11BatchDelete: __Z17CommitBatchDeleteR11BatchDelete, __ZN5physx2Sc9RigidCore15addShapeToSceneERNS0_9ShapeCoreE: __ZN5physx2Sc9RigidCore15addShapeToSceneERNS0_9ShapeCoreE, __ZL53SortBehaviourItemByExecutionOrderAndReverseInstanceIDRKN18AwakeFromLoadQueue4ItemES2_: __ZL53SortBehaviourItemByExecutionOrderAndReverseInstanceIDRKN18AwakeFromLoadQueue4ItemES2_, __ZN5physx3Cct13BoxController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE: __ZN5physx3Cct13BoxController18setNonWalkableModeENS_27PxControllerNonWalkableMode4EnumE, __ZNSt3__215future_categoryEv: __ZNSt3__215future_categoryEv, __ZN18GfxFramebufferGLESC2ER7ApiGLESPv: __ZN18GfxFramebufferGLESC2ER7ApiGLESPv, __ZThn12_N5physx3Ext7D6Joint11prepareDataEv: __ZThn12_N5physx3Ext7D6Joint11prepareDataEv, _UNITY_png_check_fp_string: _UNITY_png_check_fp_string, __Z26getNbPxScene_ArticulationsPKN5physx7PxSceneE: __Z26getNbPxScene_ArticulationsPKN5physx7PxSceneE, __ZN13PhysicsModule29BakeNxMeshStreamFromUnityMeshEP4MeshbbbR13dynamic_arrayIhLj1EE: __ZN13PhysicsModule29BakeNxMeshStreamFromUnityMeshEP4MeshbbbR13dynamic_arrayIhLj1EE, __Z61Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxNonAllocv: __Z61Register_UnityEngine_Physics_INTERNAL_CALL_OverlapBoxNonAllocv, __ZN14UnityAnalytics18IsAnalyticsEnabledEv: __ZN14UnityAnalytics18IsAnalyticsEnabledEv, __ZN5physx26PxcFrictionPatchStreamPair5resetEv: __ZN5physx26PxcFrictionPatchStreamPair5resetEv, __ZN26VertexDeclarationCacheGLESD0Ev: __ZN26VertexDeclarationCacheGLESD0Ev, __ZL14OnWorldStartedv: __ZL14OnWorldStartedv, __ZNSt3__211timed_mutexC2Ev: __ZNSt3__211timed_mutexC2Ev, __ZNK9Rigidbody14GetConstraintsEv: __ZNK9Rigidbody14GetConstraintsEv, __ZN10Collider2D8TransferI17RemapPPtrTransferEEvRT_: __ZN10Collider2D8TransferI17RemapPPtrTransferEEvRT_, __ZN11UnityEngine7Connect15AppRunningEventD0Ev: __ZN11UnityEngine7Connect15AppRunningEventD0Ev, __Z55Register_UnityEngine_CanvasGroup_set_ignoreParentGroupsv: __Z55Register_UnityEngine_CanvasGroup_set_ignoreParentGroupsv, __ZN4FMOD6System19setStreamBufferSizeEjj: __ZN4FMOD6System19setStreamBufferSizeEjj, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb1EjEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z20CreateObjectFromCodeI14Texture2DArrayEPT_17AwakeFromLoadMode10MemLabelId: __Z20CreateObjectFromCodeI14Texture2DArrayEPT_17AwakeFromLoadMode10MemLabelId, _closedir: _closedir, __ZN22RenderingCommandBuffer11AddDrawMeshERK10Matrix4x4fP4MeshP8MaterialiiP19ShaderPropertySheet: __ZN22RenderingCommandBuffer11AddDrawMeshERK10Matrix4x4fP4MeshP8MaterialiiP19ShaderPropertySheet, _tre_add_tag_right: _tre_add_tag_right, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_22PxVehicleWheelsSimDataEEEEclILj626ES3_KjjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE: __ZN9SubModule23SetSubEmitterDeprecatedE21ParticleSystemSubTypei4PPtrI14ParticleSystemE, __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN4PPtrI11LightProbesE8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN13BuildSettings7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13BuildSettings7PRODUCEE10MemLabelId18ObjectCreationMode, __ZThn4_N12MemoryStreamD0Ev: __ZThn4_N12MemoryStreamD0Ev, __ZN5physx2Gu3Box6createERKNS0_7CapsuleE: __ZN5physx2Gu3Box6createERKNS0_7CapsuleE, __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorIjNS0_9allocatorIjEEEEEvRT_j, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetStrengthYv, __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI14SafeBinaryReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN17BillboardRenderer14OnAssetDeletedEv: __ZN17BillboardRenderer14OnAssetDeletedEv, __ZN11MatrixStack4PushERK10Matrix4x4f: __ZN11MatrixStack4PushERK10Matrix4x4f, __ZN20ExternalForcesModule9FreeCacheER19ParticleSystemState: __ZN20ExternalForcesModule9FreeCacheER19ParticleSystemState, __ZN5physx24PxDefaultMemoryInputData4seekEj: __ZN5physx24PxDefaultMemoryInputData4seekEj, __Z27CullLocalLightShadowCastersiibR11CullResults: __Z27CullLocalLightShadowCastersiibR11CullResults, __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE: __ZL8AddLightRK12ActiveLightsRK8Vector3fiR13dynamic_arrayI11CulledLightLj4EE, __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE19RenderTextureFormat: __ZN15TextureSettings38ClearUnsupportedSettingsForColorFormatE19RenderTextureFormat, __ZN5physx2Gu25PersistentContactManifold12drawTriangleERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_S9_j: __ZN5physx2Gu25PersistentContactManifold12drawTriangleERNS_2Cm12RenderOutputERKNS_6shdfnd3aos5Vec3VES9_S9_j, __ZN11UnityEngine15CloudWebService16SessionContainer31HandleDeleteArchivedFolderErrorERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer31HandleDeleteArchivedFolderErrorERK8UnityStr, _jsimd_idct_float: _jsimd_idct_float, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_EC2ERKSL_j, __Z30getPxClothFabricPhasePhaseTypePKN5physx18PxClothFabricPhaseE: __Z30getPxClothFabricPhasePhaseTypePKN5physx18PxClothFabricPhaseE, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E15insert_noresizeERKSC_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E15insert_noresizeERKSC_, __Z43Register_UnityEngine_Camera_get_cullingMaskv: __Z43Register_UnityEngine_Camera_get_cullingMaskv, __ZN12WheelJoint2D8SetMotorERK12JointMotor2D: __ZN12WheelJoint2D8SetMotorERK12JointMotor2D, __Z45Register_UnityEngine_Canvas_set_planeDistancev: __Z45Register_UnityEngine_Canvas_set_planeDistancev, __Z47Register_UnityEngine_Physics_get_sleepThresholdv: __Z47Register_UnityEngine_Physics_get_sleepThresholdv, _UnityReplayKitAPIAvailable: _UnityReplayKitAPIAvailable, ___fputwc_unlocked: ___fputwc_unlocked, __ZN2UIL13UIGeometryJobEPNS_17UIGeometryJobDataE: __ZN2UIL13UIGeometryJobEPNS_17UIGeometryJobDataE, __ZN5Umbra8QueryExt20getMemoryRequirementENS0_9QueryTypeEPKNS_4TomeE: __ZN5Umbra8QueryExt20getMemoryRequirementENS0_9QueryTypeEPKNS_4TomeE, __ZL31stbir__filter_mitchell_modifiedff: __ZL31stbir__filter_mitchell_modifiedff, __Z47ShaderVariantCollection_CUSTOM_ContainsInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray: __Z47ShaderVariantCollection_CUSTOM_ContainsInternalP12Il2CppObjectS0_14ShaderPassTypeP11Il2CppArray, __ZNK6Camera6GetFovEv: __ZNK6Camera6GetFovEv, __ZN5physx9NpPhysics17createClothFabricERNS_13PxInputStreamE: __ZN5physx9NpPhysics17createClothFabricERNS_13PxInputStreamE, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15setParticleMassEf: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE15setParticleMassEf, __ZN13BaseAllocator17GetUsedBlockCountEPii: __ZN13BaseAllocator17GetUsedBlockCountEPii, __ZN5physx2Sn13XmlNodeWriter15writeContentTagEPKcS3_: __ZN5physx2Sn13XmlNodeWriter15writeContentTagEPKcS3_, __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI19StreamedBinaryWriteILb0EELb0EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5Umbra14TomeCollection15findObjectIndexEj: __ZNK5Umbra14TomeCollection15findObjectIndexEj, __Z18Transfer_BlittableI14SafeBinaryReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI14SafeBinaryReadLb0EyEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _h2v1_upsample: _h2v1_upsample, _sha512_update: _sha512_update, __Z40Register_UnityEngine_Texture2D_GetPixelsv: __Z40Register_UnityEngine_Texture2D_GetPixelsv, __ZN24PrepareSceneNodesJobDataC2Ev: __ZN24PrepareSceneNodesJobDataC2Ev, __ZNK14ParticleSystem18GetSimulationSpeedEv: __ZNK14ParticleSystem18GetSimulationSpeedEv, __ZN5physx2Gu10ConvexMesh15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Gu10ConvexMesh15exportExtraDataERNS_22PxSerializationContextE, __Z38setPxParticleBase_SimulationFilterDataPN5physx14PxParticleBaseERKNS_12PxFilterDataE: __Z38setPxParticleBase_SimulationFilterDataPN5physx14PxParticleBaseERKNS_12PxFilterDataE, __ZN24DownloadHandlerAudioClipC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15FMOD_SOUND_TYPE: __ZN24DownloadHandlerAudioClipC2ERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE15FMOD_SOUND_TYPE, __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_6PxVec4ENS0_16AlignedAllocatorILj16ENS0_9AllocatorEEEE6resizeEjRKS2_, __ZN31EnlightenSystemAtlasInformation8TransferI14SafeBinaryReadEEvRT_: __ZN31EnlightenSystemAtlasInformation8TransferI14SafeBinaryReadEEvRT_, _scalblnf: _scalblnf, __Z46Register_UnityEngine_Rigidbody_set_angularDragv: __Z46Register_UnityEngine_Rigidbody_set_angularDragv, __ZL32GeomOverlapCallback_SphereConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE: __ZL32GeomOverlapCallback_SphereConvexRKN5physx10PxGeometryERKNS_11PxTransformES2_S5_PNS_2Gu12TriggerCacheE, _scalblnl: _scalblnl, _wcscspn: _wcscspn, __Z16tessMeshMakeEdgeP8TESSmesh: __Z16tessMeshMakeEdgeP8TESSmesh, __ZN5physx2Sn5ConvX13resetNbErrorsEv: __ZN5physx2Sn5ConvX13resetNbErrorsEv, __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI9InputAxisNS0_9allocatorIS2_EEEEEvRT_j, __ZN11CullResultsD2Ev: __ZN11CullResultsD2Ev, _stbir_resize_float_generic: _stbir_resize_float_generic, __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_25PxcArticulationSolverDescENS0_19ReflectionAllocatorIS2_EEE6resizeEjRKS2_, __Z47Register_UnityEngine_Canvas_set_overrideSortingv: __Z47Register_UnityEngine_Canvas_set_overrideSortingv, __ZNK14UnityWebStream13IsReadyToPlayEv: __ZNK14UnityWebStream13IsReadyToPlayEv, __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN17AnimationCurveTplIfE8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN13ComputeShader23VirtualRedirectTransferER14SafeBinaryRead: __ZN13ComputeShader23VirtualRedirectTransferER14SafeBinaryRead, __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesYP12Il2CppObjecti: __Z62ParticleSystem_TextureSheetAnimationModule_CUSTOM_SetNumTilesYP12Il2CppObjecti, __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj: __ZNSt3__214codecvt_bynameIDic11__mbstate_tEC2ERKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEj, __ZN13RenderTexture7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN13RenderTexture7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN5physx18RepXSerializerImplINS_11PxAggregateEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_11PxAggregateEE11getTypeNameEv, __ZN9Coroutine22CompareCoroutineDirectEPvS0_: __ZN9Coroutine22CompareCoroutineDirectEPvS0_, __ZNK5physx3Ext7D6Joint14getSwingYAngleEv: __ZNK5physx3Ext7D6Joint14getSwingYAngleEv, __ZNK13TextRendering4Font26GetTypeInfoVirtualInternalEv: __ZNK13TextRendering4Font26GetTypeInfoVirtualInternalEv, __ZN15TerrainRenderer23SetNeighboringRenderersEPS_S0_S0_S0_: __ZN15TerrainRenderer23SetNeighboringRenderersEPS_S0_S0_S0_, __ZThn12_NK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE: __ZThn12_NK5physx3Ext5JointINS_9PxD6JointENS_24PxD6JointGeneratedValuesEE19updatePvdPropertiesERNS_8debugger4comm13PvdDataStreamEPKNS_12PxConstraintENS_15PxPvdUpdateType4EnumE, __ZSt13get_terminatev: __ZSt13get_terminatev, __Z42Register_UnityEngine_Camera_get_cameraTypev: __Z42Register_UnityEngine_Camera_get_cameraTypev, __ZN11UnityEngine9Animation31UnregisterGenericBindingObjectsEPNS0_30AnimatorGenericBindingConstantE: __ZN11UnityEngine9Animation31UnregisterGenericBindingObjectsEPNS0_30AnimatorGenericBindingConstantE, __Z61ParticleSystem_ShapeModule_CUSTOM_GetSphericalDirectionAmountP12Il2CppObject: __Z61ParticleSystem_ShapeModule_CUSTOM_GetSphericalDirectionAmountP12Il2CppObject, __ZN14UnityWebStream7ReleaseEv: __ZN14UnityWebStream7ReleaseEv, __Z44setPxRevoluteJoint_ProjectionLinearTolerancePN5physx15PxRevoluteJointEf: __Z44setPxRevoluteJoint_ProjectionLinearTolerancePN5physx15PxRevoluteJointEf, __Z58Register_UnityEngine_LightProbeProxyVolume_get_refreshModev: __Z58Register_UnityEngine_LightProbeProxyVolume_get_refreshModev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj452ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_12PxFixedJointEEEEclILj452ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx2Gu27intersectHeightFieldCapsuleERKNS0_15HeightFieldUtilERKNS0_7CapsuleE: __ZN5physx2Gu27intersectHeightFieldCapsuleERKNS0_15HeightFieldUtilERKNS0_7CapsuleE, __ZN5physx9NpFactory14onShapeReleaseEPNS_7PxShapeE: __ZN5physx9NpFactory14onShapeReleaseEPNS_7PxShapeE, __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE7SetDataEPKhj: __ZN11UnityEngine15CloudWebService10RestClientINS0_16WWWRestHeaderMapEE7SetDataEPKhj, __Z14ClipAnimationsI11QuaternionfN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_: __Z14ClipAnimationsI11QuaternionfN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEEvRKNSt3__26vectorIT0_T1_EEfffbRSA_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj678ES3_NS_23PxVehicleDriveSimData4WES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxVehicleDrive4WEEEEclILj678ES3_NS_23PxVehicleDriveSimData4WES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z22Mesh_CUSTOM_ResizeListP12Il2CppObjecti: __Z22Mesh_CUSTOM_ResizeListP12Il2CppObjecti, __ZNK5physx2Sc5Scene26getBounceThresholdVelocityEv: __ZNK5physx2Sc5Scene26getBounceThresholdVelocityEv, __ZN11Rigidbody2D13FindRigidbodyEPK10GameObjectPKS_: __ZN11Rigidbody2D13FindRigidbodyEPK10GameObjectPKS_, __ZN21AudioDistortionFilter5ResetEv: __ZN21AudioDistortionFilter5ResetEv, _cf2_getGlyphOutline: _cf2_getGlyphOutline, __Z20Graphics_CUSTOM_BlitP12Il2CppObjectS0_: __Z20Graphics_CUSTOM_BlitP12Il2CppObjectS0_, __Z28RegisterModule_JSONSerializev: __Z28RegisterModule_JSONSerializev, __ZN14SpriteRenderer15GetSpriteBoundsEv: __ZN14SpriteRenderer15GetSpriteBoundsEv, __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDriveNWEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE: __ZN5physx2Sn18writeAllPropertiesINS_16PxVehicleDriveNWEEEvPKT_RNS_9XmlWriterERNS_12MemoryBufferERNS_12PxCollectionE, __Z49Register_UnityEngine_TrailRenderer_get_widthCurvev: __Z49Register_UnityEngine_TrailRenderer_get_widthCurvev, __ZSt14set_unexpectedPFvvE: __ZSt14set_unexpectedPFvvE, __Z45RenderTexture_Set_Custom_PropAutoGenerateMipsP12Il2CppObjecth: __Z45RenderTexture_Set_Custom_PropAutoGenerateMipsP12Il2CppObjecth, __Z50Register_UnityEngine_Application_CaptureScreenshotv: __Z50Register_UnityEngine_Application_CaptureScreenshotv, __ZZL31InitializeAudioManagerCallbacksvEN39PostLateUpdateUpdateVideoTexturesstruct7ForwardEv: __ZZL31InitializeAudioManagerCallbacksvEN39PostLateUpdateUpdateVideoTexturesstruct7ForwardEv, __ZN4FMOD7SystemI17setOutputByPluginEj: __ZN4FMOD7SystemI17setOutputByPluginEj, __ZN38StateMachineBehaviourVectorDescription8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN38StateMachineBehaviourVectorDescription8TransferI24GenerateTypeTreeTransferEEvRT_, __Z45SystemInfo_Get_Custom_PropUsesReversedZBufferv: __Z45SystemInfo_Get_Custom_PropUsesReversedZBufferv, __Z42AudioReverbZone_Set_Custom_PropMinDistanceP12Il2CppObjectf: __Z42AudioReverbZone_Set_Custom_PropMinDistanceP12Il2CppObjectf, __Z63Register_UnityEngine_Terrain_GetClosestReflectionProbesInternalv: __Z63Register_UnityEngine_Terrain_GetClosestReflectionProbesInternalv, __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN5Flare23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZN5physx3Ext21InertiaTensorComputer11setCylinderEiff: __ZN5physx3Ext21InertiaTensorComputer11setCylinderEiff, __ZN5physx38solveFrictionCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx38solveFrictionCoulombPreBlock_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, _fesetenv: _fesetenv, __ZN20DeviceBlendStateGLESC2ERK13GfxBlendState: __ZN20DeviceBlendStateGLESC2ERK13GfxBlendState, __Z55Register_UnityEngine_PointEffector2D_set_forceVariationv: __Z55Register_UnityEngine_PointEffector2D_set_forceVariationv, __Z37Register_UnityEngine_AndroidJNI_Throwv: __Z37Register_UnityEngine_AndroidJNI_Throwv, __Z50Register_UnityEngine_Cloth_get_stretchingStiffnessv: __Z50Register_UnityEngine_Cloth_get_stretchingStiffnessv, __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN11MonoManager23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __ZNK11b2EdgeShape13GetChildCountEv: __ZNK11b2EdgeShape13GetChildCountEv, __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_GetRangev: __Z76Register_UnityEngine_ParticleSystem_SizeBySpeedModule_INTERNAL_CALL_GetRangev, __Z58Register_UnityEngine_GL_INTERNAL_CALL_LoadProjectionMatrixv: __Z58Register_UnityEngine_GL_INTERNAL_CALL_LoadProjectionMatrixv, __ZN5physx2Gu21findOverlapSphereMeshERKNS0_6SphereERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb: __ZN5physx2Gu21findOverlapSphereMeshERKNS0_6SphereERKNS0_13RTreeMidphaseERKNS_11PxTransformERKNS_11PxMeshScaleEPjjjRb, __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet: __ZNK23ShaderVariantCollection15ContainsVariantEP6Shader14ShaderPassTypeRK16ShaderKeywordSet, __ZN7mecanim12statemachine23SetMessageOnChildStatesENS0_19StateMachineMessageERNS0_18StateMachineMemoryERNS0_18StateMachineOutputEb: __ZN7mecanim12statemachine23SetMessageOnChildStatesENS0_19StateMachineMessageERNS0_18StateMachineMemoryERNS0_18StateMachineOutputEb, __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEaSEOS3_: __ZNSt3__213basic_ostreamIcNS_11char_traitsIcEEEaSEOS3_, __ZN12TreeRenderer24UpdateLegacyMeshPointersEv: __ZN12TreeRenderer24UpdateLegacyMeshPointersEv, __ZN11NavMeshData13AwakeFromLoadE17AwakeFromLoadMode: __ZN11NavMeshData13AwakeFromLoadE17AwakeFromLoadMode, __ZN28LightProbeProxyVolumeContext5ResetEv: __ZN28LightProbeProxyVolumeContext5ResetEv, __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev: __ZN5physx32PxVehicleEngineDataGeneratedInfoC2Ev, __ZN18ScriptingArguments9AddObjectEP12Il2CppObject: __ZN18ScriptingArguments9AddObjectEP12Il2CppObject, __ZN13RenderManager12RemoveCameraEP6Camera: __ZN13RenderManager12RemoveCameraEP6Camera, __ZN9DepthPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceDatab: __ZN9DepthPass7PrepareER6CameraRK13dynamic_arrayI16RenderObjectDataLj4EERK15RenderNodeQueueRK17ShaderReplaceDatab, _write_frame_header: _write_frame_header, __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_: __Z8EvaluateIL27ParticleSystemCurveEvalMode2EEKN4math7_float4ERK11MinMaxCurveRS3_S7_, __ZN14MessageHandler10InitializeEP11TypeManagerPKN5Unity4TypeE: __ZN14MessageHandler10InitializeEP11TypeManagerPKN5Unity4TypeE, __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE: __ZNSt3__26__treeI22DeviceStencilStateGLES11memcmp_lessIS1_18DeviceStencilStateENS_9allocatorIS1_EEE7destroyEPNS_11__tree_nodeIS1_PvEE, __Z23Random_CUSTOM_InitStatei: __Z23Random_CUSTOM_InitStatei, __ZN5physx9NpFactory21releaseMaterialToPoolERNS_10NpMaterialE: __ZN5physx9NpFactory21releaseMaterialToPoolERNS_10NpMaterialE, __ZNK10FileSystem17GetHandlerForPathEPKc: __ZNK10FileSystem17GetHandlerForPathEPKc, __Z41Register_UnityEngine_Light_get_renderModev: __Z41Register_UnityEngine_Light_get_renderModev, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEE27handleExtendedIndexPropertyILj613ES4_NS_23PxVehicleSuspensionDataEKjNS_36PxVehicleSuspensionDataGeneratedInfoEEEvjRKNS_29PxExtendedIndexedPropertyInfoIXT_ET0_T2_T1_EERKT3_, __ZNK5physx11NpAggregate13getOwnerSceneEv: __ZNK5physx11NpAggregate13getOwnerSceneEv, __ZN13GfxDeviceGLES20DestroyComputeBufferE15ComputeBufferID: __ZN13GfxDeviceGLES20DestroyComputeBufferE15ComputeBufferID, __Z48Register_UnityEngine_Input_get_compositionStringv: __Z48Register_UnityEngine_Input_get_compositionStringv, __ZN5Unity17ConfigurableJoint13SetSwapBodiesEb: __ZN5Unity17ConfigurableJoint13SetSwapBodiesEb, __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_: __ZN5physx2Sn13parseGeometryINS0_21RepXVisitorReaderBaseINS_18PxArticulationLinkEEENS_21PxHeightFieldGeometryEEEPNS_10PxGeometryERT_RT0_, __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10BlendShapeLj4EEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI13dynamic_arrayI10BlendShapeLj4EEEEvRT_17TransferMetaFlags, __ZN5Umbra4Math5atan2ERKNS_6DoubleES3_: __ZN5Umbra4Math5atan2ERKNS_6DoubleES3_, __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14PlayerSettings8TransferI18StreamedBinaryReadILb1EEEEvRT_, __Z54Register_UnityEngine_Application_set_stackTraceLogTypev: __Z54Register_UnityEngine_Application_set_stackTraceLogTypev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxSphericalJointEEEEclILj419ENS_7PxJointEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgENS_4fposI11__mbstate_tEE: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE5seekgENS_4fposI11__mbstate_tEE, __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetDampenv: __Z77Register_UnityEngine_ParticleSystem_LimitVelocityOverLifetimeModule_SetDampenv, __ZN12_GLOBAL__N_111StreamOwner5flushEv: __ZN12_GLOBAL__N_111StreamOwner5flushEv, __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED2Ev: __ZN5physx6shdfnd5ArrayIPNS_8debugger4comm20PvdConnectionHandlerENS2_19ForwardingAllocatorEED2Ev, __ZN14AudioBehaviourC2E10MemLabelId18ObjectCreationMode: __ZN14AudioBehaviourC2E10MemLabelId18ObjectCreationMode, __Z38AudioMixerSnapshot_CUSTOM_TransitionToP12Il2CppObjectf: __Z38AudioMixerSnapshot_CUSTOM_TransitionToP12Il2CppObjectf, __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE11getTypeNameEv: __ZN5physx18RepXSerializerImplINS_12PxConvexMeshEE11getTypeNameEv, __ZN13GfxDeviceGLES20GetComputeBufferDataE15ComputeBufferIDPvj: __ZN13GfxDeviceGLES20GetComputeBufferDataE15ComputeBufferIDPvj, ___srandom: ___srandom, __ZN11TypeManager7Builder3AddEP4RTTI: __ZN11TypeManager7Builder3AddEP4RTTI, __ZN5Umbra9allocTomeEjPNS_9AllocatorE: __ZN5Umbra9allocTomeEjPNS_9AllocatorE, __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE10getInvMassEv: __ZNK5physx19NpRigidBodyTemplateINS_14PxRigidDynamicEE10getInvMassEv, __ZN14GfxDeviceStats11ClientStats5ResetEv: __ZN14GfxDeviceStats11ClientStats5ResetEv, __ZN11ForceModule5ResetEv: __ZN11ForceModule5ResetEv, __ZN17SizeBySpeedModule16CheckConsistencyEv: __ZN17SizeBySpeedModule16CheckConsistencyEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj561ENS_22PxRepXPropertyAccessorILj561ES4_jjEEEEvjRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_19PxVehicleClutchDataEEEE14handleAccessorILj561ENS_22PxRepXPropertyAccessorILj561ES4_jjEEEEvjRKT0_, __ZNK12NavMeshAgent24CalculateDimensionScalesEv: __ZNK12NavMeshAgent24CalculateDimensionScalesEv, __ZL25LogCallbackImplementationRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib: __ZL25LogCallbackImplementationRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_ib, _UNITY_FT_Load_Char: _UNITY_FT_Load_Char, __Z22Check1MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_P6ObjectR11MonoManager: __Z22Check1MethodParameters21ScriptingMethodIl2CppP11Il2CppClassS1_P6ObjectR11MonoManager, __Z19TransferField_ArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_: __Z19TransferField_ArrayI8JSONRead16Converter_StringEvRK23StaticTransferFieldInfoR31RuntimeSerializationCommandInfoRT0_, __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERh: __ZN12_GLOBAL__N_112RenderReaderILb1EE9streamifyERh, __ZN15PointEffector2D14SetForceSourceE19EffectorSelection2D: __ZN15PointEffector2D14SetForceSourceE19EffectorSelection2D, _unity_z_deflateInit2_: _unity_z_deflateInit2_, __Z34Application_Get_Custom_PropVersionv: __Z34Application_Get_Custom_PropVersionv, __ZNK5physx16PxVehicleDriveNW19getConcreteTypeNameEv: __ZNK5physx16PxVehicleDriveNW19getConcreteTypeNameEv, __Z13RegisterClassI14PhysicMaterialEvv: __Z13RegisterClassI14PhysicMaterialEvv, __Z49Camera_CUSTOM_INTERNAL_CALL_ResetProjectionMatrixP12Il2CppObject: __Z49Camera_CUSTOM_INTERNAL_CALL_ResetProjectionMatrixP12Il2CppObject, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_11PxMeshScaleEEEE14handleAccessorILj265ENS_22PxRepXPropertyAccessorILj265ES4_NS_6PxQuatES9_EEEEvRKT0_, __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv: __ZN5physx6shdfnd8PoolBaseINS_2Cm5BlockIPvLj8EEENS0_19ReflectionAllocatorIS5_EEE12allocateSlabEv, __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags: __ZN19StreamedBinaryWriteILb0EE21TransferSTLStyleArrayINSt3__26vectorI8UnityStrNS2_9allocatorIS4_EEEEEEvRT_17TransferMetaFlags, __Z55Register_UnityEngine_Application_get_webSecurityEnabledv: __Z55Register_UnityEngine_Application_get_webSecurityEnabledv, __ZN14TerrainManager14GetTerrainDataEP7Terrain: __ZN14TerrainManager14GetTerrainDataEP7Terrain, __Z62Register_UnityEngine_ParticleSystem_TrailModule_SetTextureModev: __Z62Register_UnityEngine_ParticleSystem_TrailModule_SetTextureModev, __Z41Application_Get_Custom_PropSystemLanguagev: __Z41Application_Get_Custom_PropSystemLanguagev, __Z24RemapClassIDToNewClassIDib: __Z24RemapClassIDToNewClassIDib, __ZN14ParticleSystem7SetLoopEb: __ZN14ParticleSystem7SetLoopEb, __ZNK5physx43PxVehicleAckermannGeometryDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEEEEEjT_j: __ZNK5physx43PxVehicleAckermannGeometryDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_30PxVehicleAckermannGeometryDataEEEEEEEjT_j, __ZN4FMOD13ChannelGroupI18overrideSpeakerMixEffffffff: __ZN4FMOD13ChannelGroupI18overrideSpeakerMixEffffffff, _cff_builder_add_point: _cff_builder_add_point, __ZN5physx2Gu9Container7SetSizeEj: __ZN5physx2Gu9Container7SetSizeEj, __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f: __ZN12VertexWelderILi64EE9AddUniqueERK8Vector3f, __ZN16PlayerConnection26InitializeMulticastAddressEt: __ZN16PlayerConnection26InitializeMulticastAddressEt, __Z47ParticleSystem_EmissionModule_CUSTOM_SetEnabledP12Il2CppObjecth: __Z47ParticleSystem_EmissionModule_CUSTOM_SetEnabledP12Il2CppObjecth, __Z43Register_UnityEngine_Shader_get_isSupportedv: __Z43Register_UnityEngine_Shader_get_isSupportedv, __ZN10GUITextureD0Ev: __ZN10GUITextureD0Ev, __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj: __ZN5physx5cloth9ClothImplINS0_7SwClothEE11setConvexesENS0_5RangeIKjEEjj, __ZN5Unity10HingeJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN5Unity10HingeJoint23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK5Unity5Joint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_: __ZNK5Unity5Joint25CalculateGlobalHingeSpaceER8Vector3fS2_S2_, __ZN19LowerResBlitTexture17MainThreadCleanupEv: __ZN19LowerResBlitTexture17MainThreadCleanupEv, __ZN16Physics2DManager25AddJointBreakLimitUpdatesEP7Joint2D: __ZN16Physics2DManager25AddJointBreakLimitUpdatesEP7Joint2D, __Z31Texture2DArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii: __Z31Texture2DArray_CUSTOM_SetPixelsP12Il2CppObjectP11Il2CppArrayii, __ZN17BufferManagerGLES12AdvanceFrameEv: __ZN17BufferManagerGLES12AdvanceFrameEv, __Z43Register_UnityEngine_Animation_GetClipCountv: __Z43Register_UnityEngine_Animation_GetClipCountv, __ZNSt3__26vectorI12SkeletonBoneNS_9allocatorIS1_EEE8__appendEj: __ZNSt3__26vectorI12SkeletonBoneNS_9allocatorIS1_EEE8__appendEj, __ZN5physx14SingleAABBTaskD2Ev: __ZN5physx14SingleAABBTaskD2Ev, __ZN4math5Limit8TransferI14SafeBinaryReadEEvRT_: __ZN4math5Limit8TransferI14SafeBinaryReadEEvRT_, _jsimd_can_rgb_gray: _jsimd_can_rgb_gray, __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI16SubstanceArchiveE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN30RuntimeInitializeOnLoadManager23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN9JSONWrite13StartSequenceEi: __ZN9JSONWrite13StartSequenceEi, __ZNK13RendererScene23GetDynamicBoundingBoxesEv: __ZNK13RendererScene23GetDynamicBoundingBoxesEv, __Z16WriteBytesToFilePKvjRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE: __Z16WriteBytesToFilePKvjRKNSt3__212basic_stringIcNS1_11char_traitsIcEENS1_9allocatorIcEEEE, __ZN5physx2Gu9RadixSort4SortEPKjjNS0_9RadixHintE: __ZN5physx2Gu9RadixSort4SortEPKjjNS0_9RadixHintE, __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j: __ZNK5physx31PxVehicleDriveTankGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxVehicleDriveTankEEEEEEEjT_j, __ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb: __ZNK5physx2Gu11HeightField13isSolidVertexEjjjtRb, __ZN5physx13NpClothFabric4loadERNS_13PxInputStreamE: __ZN5physx13NpClothFabric4loadERNS_13PxInputStreamE, __ZN10AudioMixer24ReassignAllChannelGroupsEv: __ZN10AudioMixer24ReassignAllChannelGroupsEv, __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE: __ZN5physxL19solveContact4_BlockEPKNS_23PxcSolverConstraintDescERNS_16PxcSolverContextE, __ZSt10unexpectedv: __ZSt10unexpectedv, __ZL15TestContainmentRKN5physx6PxVec3EPKfjPKNS_2Gu15HullPolygonDataE: __ZL15TestContainmentRKN5physx6PxVec3EPKfjPKNS_2Gu15HullPolygonDataE, __ZN12CachedReader4SkipEj: __ZN12CachedReader4SkipEj, __ZN14dense_hash_mapIy9PlaneDataN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorENSt3__28equal_toIyEE13stl_allocatorINS3_4pairIKyS0_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERS8_: __ZN14dense_hash_mapIy9PlaneDataN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorENSt3__28equal_toIyEE13stl_allocatorINS3_4pairIKyS0_EEL18MemLabelIdentifier65ELi16EEE15set_deleted_keyERS8_, __Z52Register_UnityEngine_PointEffector2D_set_angularDragv: __Z52Register_UnityEngine_PointEffector2D_set_angularDragv, __ZNK5physx42PxClothMotionConstraintConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEEEEEjT_j: __ZNK5physx42PxClothMotionConstraintConfigGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_29PxClothMotionConstraintConfigEEEEEEEjT_j, __ZN5physx2Sc5Scene34setClothInterCollisionNbIterationsEj: __ZN5physx2Sc5Scene34setClothInterCollisionNbIterationsEj, __ZNK24RendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi: __ZNK24RendererAnimationBinding12SetPPtrValueERKN11UnityEngine9Animation10BoundCurveEi, __ZN4FMOD6System7lockDSPEv: __ZN4FMOD6System7lockDSPEv, __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE: __ZL30ReconstructParamNamesFromTableIN9ShaderLab20SerializedSubProgram15VectorParameterEEvRKNSt3__23mapIi8UnityStrNS3_4lessIiEENS3_9allocatorINS3_4pairIKiS5_EEEEEERNS3_6vectorIT_NS8_ISH_EEEE, _UNITY_FT_Create_Class_tt_driver_class: _UNITY_FT_Create_Class_tt_driver_class, __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE: __ZN5physxmlERKNS_11PxTransformERKNS_11PxMeshScaleE, __Z30TransferField_LinearCollectionI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z30TransferField_LinearCollectionI17RemapPPtrTransferEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZThn4_N16RayRTreeCallbackILi0ELb0EE14processResultsEjPj: __ZThn4_N16RayRTreeCallbackILi0ELb0EE14processResultsEjPj, __Z37AudioMixerDuckingSetParameterCallbackP21UnityAudioEffectStateif: __Z37AudioMixerDuckingSetParameterCallbackP21UnityAudioEffectStateif, __ZNK9SubModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E: __ZNK9SubModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateR23ParticleSystemParticlesjjRKN4math7_float4E, __Z51Register_UnityEngine_TerrainData_get_alphamapLayersv: __Z51Register_UnityEngine_TerrainData_get_alphamapLayersv, __ZN14AnimationState21CleanupUnstoppedStateEv: __ZN14AnimationState21CleanupUnstoppedStateEv, __ZN5physx2Sc9ClothCore15setTetherConfigERKNS_19PxClothTetherConfigE: __ZN5physx2Sc9ClothCore15setTetherConfigERKNS_19PxClothTetherConfigE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj477ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_16PxSphericalJointEE15complexPropertyINS_22PxRepXPropertyAccessorILj477ES2_RKNS_16PxJointLimitConeES6_EEKNS_29PxJointLimitConeGeneratedInfoEEEvPjRKT_RT0_, __ZN5physx3Cct13HandleManager6RemoveEj: __ZN5physx3Cct13HandleManager6RemoveEj, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE19getBoundingBoxScaleEv, __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getParticleBaseFlagsEv: __ZNK5physx22NpParticleBaseTemplateINS_15PxParticleFluidENS_15NpParticleFluidEE20getParticleBaseFlagsEv, __ZN9Transform30SetPositionWithoutNotificationERK8Vector3f: __ZN9Transform30SetPositionWithoutNotificationERK8Vector3f, _UNITY_png_write_sig: _UNITY_png_write_sig, __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_SetHumanPosev: __Z73Register_UnityEngine_HumanPoseHandler_INTERNAL_CALL_Internal_SetHumanPosev, __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_13PxcNpMemBlockENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_12PxRigidActorENS0_19ReflectionAllocatorIS3_EEE8recreateEj, __Z38ReflectionProbe_Get_Custom_PropTextureP12Il2CppObject: __Z38ReflectionProbe_Get_Custom_PropTextureP12Il2CppObject, __ZN17VertexDeclarationD2Ev: __ZN17VertexDeclarationD2Ev, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEE14setRestOffsetsEjRKNS_16PxStrideIteratorIKjEERKNS4_IKfEE, __ZNSt3__27promiseIvE9set_valueEv: __ZNSt3__27promiseIvE9set_valueEv, __ZN8WindZoneC2E10MemLabelId18ObjectCreationMode: __ZN8WindZoneC2E10MemLabelId18ObjectCreationMode, __ZN5physx2Sc8BodyCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc8BodyCore17getBinaryMetaDataERNS_14PxOutputStreamE, ___cxa_bad_cast: ___cxa_bad_cast, __ZNK5physx2Gu11HeightField10getNormal_Efffff: __ZNK5physx2Gu11HeightField10getNormal_Efffff, __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallback7onEventEjPj: __ZN12_GLOBAL__N_142SphereHeightfieldContactGenerationCallback7onEventEjPj, __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVENS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERKNSB_5Vec3VESK_RSF_RSI_SM_fb: __ZN5physx2Gu18gjkRelativeRayCastINS0_4BoxVENS0_11ConvexHullVENS0_10ShrunkBoxVENS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERKNSB_5Vec3VESK_RSF_RSI_SM_fb, __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __ZL26Transfer_SimpleNativeClassI18StreamedBinaryReadILb0EE8GradientLb1EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _getservent: _getservent, __ZN11NoiseModule5ResetEv: __ZN11NoiseModule5ResetEv, __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED0Ev: __ZN5physx22NpParticleBaseTemplateINS_16PxParticleSystemENS_16NpParticleSystemEED0Ev, __ZN14PhysicsManager20CleanupDynamicsSceneEv: __ZN14PhysicsManager20CleanupDynamicsSceneEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE20setSleepTestIntervalEj, __Z45Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiff: __Z45Physics2D_CUSTOM_INTERNAL_CALL_CapsuleCastAllRK13Vector2fIcallS1_N17CapsuleCollider2D16CapsuleDirectionEfS1_fiff, __ZN25MinMaxOptimizedPolyCurves20FindMinMaxIntegratedEv: __ZN25MinMaxOptimizedPolyCurves20FindMinMaxIntegratedEv, __Z50Register_UnityEngine_AudioSource_get_reverbZoneMixv: __Z50Register_UnityEngine_AudioSource_get_reverbZoneMixv, __ZN5physx2Sc19ConstraintGroupNode11projectPoseERS1_: __ZN5physx2Sc19ConstraintGroupNode11projectPoseERS1_, _cff_get_cid_from_glyph_index: _cff_get_cid_from_glyph_index, __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb0EELb0EaEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E: __Z18MagnitudeUpdateTplIL27ParticleSystemCurveEvalMode2EEvRK11MinMaxCurveR23ParticleSystemParticlesjjRKN4math7_float4E, __ZN14NavMeshManager15UnregisterAgentERi: __ZN14NavMeshManager15UnregisterAgentERi, __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIfEEvRT_PKc17TransferMetaFlags, __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12getClassSizeEv: __ZNK5physx26PxSerializerDefaultAdapterINS_3Ext13DistanceJointEE12getClassSizeEv, __ZN14FileCacherRead14LockCacheBlockEjPPhS1_: __ZN14FileCacherRead14LockCacheBlockEjPPhS1_, __Z14pqNewPriorityQP9TESSallociPFiPvS1_E: __Z14pqNewPriorityQP9TESSallociPFiPvS1_E, __ZN13MonoBehaviour15CreateCoroutineEP12Il2CppObject21ScriptingMethodIl2Cpp: __ZN13MonoBehaviour15CreateCoroutineEP12Il2CppObject21ScriptingMethodIl2Cpp, __ZN5physx13PxCloneStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_12PxRigidActorE: __ZN5physx13PxCloneStaticERNS_9PxPhysicsERKNS_11PxTransformERKNS_12PxRigidActorE, __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv: __ZThn8_NKSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE8__monthsEv, __Z28delete_object_internal_step2P6Object: __Z28delete_object_internal_step2P6Object, __ZN5physx21PxProfileEventHandler21durationToNanosecondsEy: __ZN5physx21PxProfileEventHandler21durationToNanosecondsEy, __ZN5physx9NpPhysics18createArticulationEv: __ZN5physx9NpPhysics18createArticulationEv, __ZNK9DebugGLES8CullModeEv: __ZNK9DebugGLES8CullModeEv, __ZN8Animator21GetGoalWeightPositionEi: __ZN8Animator21GetGoalWeightPositionEi, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorReaderINS_7PxClothEEEE14handleAccessorILj149ENS_22PxRepXPropertyAccessorILj149ES4_NS_6PxVec3ES9_EEEEvRKT0_, __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif: __Z23RecalculateSplineSlopeTIfEvR17AnimationCurveTplIT_Eif, __ZN5physx13NpClothFabric15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx13NpClothFabric15importExtraDataERNS_24PxDeserializationContextE, __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorINS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier1ELi16EEEES5_IS8_LS6_1ELi16EEEEEvRT_j, __Z57Register_UnityEngine_AudioSource_get_ignoreListenerVolumev: __Z57Register_UnityEngine_AudioSource_get_ignoreListenerVolumev, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE19__copy_assign_allocERKS5_, __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_: __ZL18AppendPathNameImplRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_cRS5_, __ZN6prcore10FlipImageYER14ImageReference: __ZN6prcore10FlipImageYER14ImageReference, __Z29setPxArticulation_WakeCounterPN5physx14PxArticulationEf: __Z29setPxArticulation_WakeCounterPN5physx14PxArticulationEf, __ZN16b2BlockAllocator4FreeEPvi: __ZN16b2BlockAllocator4FreeEPvi, __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEED0Ev: __ZN5physx23PxVehicleRepXSerializerINS_16PxVehicleNoDriveEED0Ev, _catanhf: _catanhf, __Z59Register_UnityEngine_Rigidbody_get_maxDepenetrationVelocityv: __Z59Register_UnityEngine_Rigidbody_get_maxDepenetrationVelocityv, __ZNK5physx2Sc20ArticulationJointSim9getParentEv: __ZNK5physx2Sc20ArticulationJointSim9getParentEv, __ZNK15AudioReverbZone26GetTypeInfoVirtualInternalEv: __ZNK15AudioReverbZone26GetTypeInfoVirtualInternalEv, _catanhl: _catanhl, __ZN5physx2Sc35ParticleElementRbElementInteractionC2ERNS0_19ParticlePacketShapeERNS0_8ShapeSimERNS0_16ActorElementPairE: __ZN5physx2Sc35ParticleElementRbElementInteractionC2ERNS0_19ParticlePacketShapeERNS0_8ShapeSimERNS0_16ActorElementPairE, __ZN10GUITexture13AwakeFromLoadE17AwakeFromLoadMode: __ZN10GUITexture13AwakeFromLoadE17AwakeFromLoadMode, __ZN5physx27InternalTriangleMeshBuilder13remapTopologyEPKj: __ZN5physx27InternalTriangleMeshBuilder13remapTopologyEPKj, __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler: __ZN10FileSystem14UnmountHandlerEP17FileSystemHandler, __ZN5physx7NpCloth18clearInterpolationEv: __ZN5physx7NpCloth18clearInterpolationEv, __ZNK5physx2Cm10FanoutTask7getNameEv: __ZNK5physx2Cm10FanoutTask7getNameEv, __ZN9Animation4StopERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN9Animation4StopERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, _cf2_getStdHW: _cf2_getStdHW, __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_: __ZN5physx6shdfnd5ArrayINS_5cloth20SwInterCollisionDataENS0_19ReflectionAllocatorIS3_EEE6resizeEjRKS3_, __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_: __Z22EvaluateRandomGradientIL12GradientMode0ELS0_1EEN4math4pix4ERK23OptimizedMinMaxGradientRKNS1_7_float4ES8_, __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj: __ZNSt3__215time_get_bynameIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEEC2ERKNS_12basic_stringIcS3_NS_9allocatorIcEEEEj, __ZN2UI13UIInstructionC2Ev: __ZN2UI13UIInstructionC2Ev, __ZN10RenderLoopD2Ev: __ZN10RenderLoopD2Ev, __Z35Physics_CUSTOM_INTERNAL_set_gravityRK8Vector3f: __Z35Physics_CUSTOM_INTERNAL_set_gravityRK8Vector3f, __ZN13GfxDeviceGLES16DrawNullGeometryE16GfxPrimitiveTypeii: __ZN13GfxDeviceGLES16DrawNullGeometryE16GfxPrimitiveTypeii, __Z46AnimatorControllerPlayable_CUSTOM_PlayInternal9HPlayableRS_iif: __Z46AnimatorControllerPlayable_CUSTOM_PlayInternal9HPlayableRS_iif, __ZNK3MBP12getBoxPrunerEj: __ZNK3MBP12getBoxPrunerEj, __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb: __ZN5physx2Gu15gjkLocalRayCastINS0_8CapsuleVENS0_11ConvexHullVES2_NS0_17ShrunkConvexHullVEEEbRT_RT0_RKNS_6shdfnd3aos6FloatVERKNSA_5Vec3VESG_RSB_RSE_SI_fb, __ZN14TerrainManager21OffsetLightmapIndicesE18RemapLightmapIndexS0_: __ZN14TerrainManager21OffsetLightmapIndicesE18RemapLightmapIndexS0_, __Z56Register_UnityEngine_AssetBundle_LoadAssetAsync_Internalv: __Z56Register_UnityEngine_AssetBundle_LoadAssetAsync_Internalv, __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayINS_11NpConnectorENS0_15InlineAllocatorILj32ENS0_19ReflectionAllocatorIS2_EEEEE8recreateEj, __ZNKSt3__25ctypeIwE9do_narrowEPKwS3_cPc: __ZNKSt3__25ctypeIwE9do_narrowEPKwS3_cPc, __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_: __ZN5Unity5Joint17JointTransferPostI14SafeBinaryReadEEvRT_, __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastAllv: __Z56Register_UnityEngine_Physics2D_INTERNAL_CALL_LinecastAllv, __Z57ParticleSystem_TrailModule_CUSTOM_GetInheritParticleColorP12Il2CppObject: __Z57ParticleSystem_TrailModule_CUSTOM_GetInheritParticleColorP12Il2CppObject, __ZNK5physx2Sn12PointerRemap17checkRefIsNotUsedEj: __ZNK5physx2Sn12PointerRemap17checkRefIsNotUsedEj, __ZN10SampleClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN10SampleClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN20ExternalForcesModule8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN20ExternalForcesModule8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN11OffMeshLinkD2Ev: __ZN11OffMeshLinkD2Ev, __ZN19VREyeTextureManager17BlitToFramebufferE15UnityVRBlitModeRK5RectTIfEf: __ZN19VREyeTextureManager17BlitToFramebufferE15UnityVRBlitModeRK5RectTIfEf, __ZN5physx2Sc15ClothFabricCore15importExtraDataERNS_24PxDeserializationContextE: __ZN5physx2Sc15ClothFabricCore15importExtraDataERNS_24PxDeserializationContextE, __ZN18b2RevoluteJointDef10InitializeEP6b2BodyS1_RK6b2Vec2: __ZN18b2RevoluteJointDef10InitializeEP6b2BodyS1_RK6b2Vec2, __ZN17AudioCustomFilterC2EP13MonoBehaviour: __ZN17AudioCustomFilterC2EP13MonoBehaviour, __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE: __ZNSt3__26__treeINS_12__value_typeI8UnityStr4PPtrI6ObjectEEENS_19__map_value_compareIS2_S6_NS_4lessIS2_EELb1EEENS_9allocatorIS6_EEE7destroyEPNS_11__tree_nodeIS6_PvEE, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERNS_20RuntimeStructBuilderERNS_18SerializedTreeDataEPNS_5ArrayIiEEPPjPPfRKNS_4AABBE: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9serializeERNS_20RuntimeStructBuilderERNS_18SerializedTreeDataEPNS_5ArrayIiEEPPjPPfRKNS_4AABBE, __ZNKSt3__210moneypunctIcLb1EE14do_frac_digitsEv: __ZNKSt3__210moneypunctIcLb1EE14do_frac_digitsEv, __ZNK28RectTransformPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE: __ZNK28RectTransformPropertyBinding15GenerateBindingERK8UnityStrbRN11UnityEngine9Animation14GenericBindingE, __ZN16TimerQueriesGLES16PollTimerQueriesEb: __ZN16TimerQueriesGLES16PollTimerQueriesEb, __ZN7mecanim5human16DeltaPoseQualityERNS0_9HumanPoseEf: __ZN7mecanim5human16DeltaPoseQualityERNS0_9HumanPoseEf, __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject: __ZN9Scripting32GetCachedPtrFromScriptingWrapperEP12Il2CppObject, __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetFrequencyv: __Z60Register_UnityEngine_ParticleSystem_NoiseModule_GetFrequencyv, __Z18GetInputManagerPtrv: __Z18GetInputManagerPtrv, __ZN5physx7NpScene34setClothInterCollisionNbIterationsEj: __ZN5physx7NpScene34setClothInterCollisionNbIterationsEj, __Z64Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstCountv: __Z64Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstCountv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj589ENS_22PxRepXPropertyAccessorILj589ES4_ffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_23PxVehicleSuspensionDataEEEE14handleAccessorILj589ENS_22PxRepXPropertyAccessorILj589ES4_ffEEEEvRKT0_, _seekdir: _seekdir, __Z26CalculateImageMipLevelSizeii13TextureFormatj: __Z26CalculateImageMipLevelSizeii13TextureFormatj, __ZN12_GLOBAL__N_110Connection11setPickableEPKvb: __ZN12_GLOBAL__N_110Connection11setPickableEPKvb, __Z41Animation_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB: __Z41Animation_CUSTOM_INTERNAL_set_localBoundsP12Il2CppObjectRK4AABB, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEEclILj414ENS_7PxJointEfEEvRKNS_19PxRangePropertyInfoIXT_ET0_T1_EEj, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxVehicleDriveSimDataNWEEEEclILj664ENS_21PxVehicleDriveSimDataERKNS_18PxVehicleGearsDataES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx2Sc9RigidCore6getSimEv: __ZNK5physx2Sc9RigidCore6getSimEv, __ZN10Matrix4x4f8TransferI9JSONWriteEEvRT_: __ZN10Matrix4x4f8TransferI9JSONWriteEEvRT_, __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb: __ZN11ShapeModule5StartERK27ParticleSystemReadOnlyStateRK19ParticleSystemStateR23ParticleSystemParticlesRK10Matrix4x4fjb, __ZN9AudioClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN9AudioClip8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZNKSt3__215__codecvt_utf16IDiLb1EE11do_encodingEv: __ZNKSt3__215__codecvt_utf16IDiLb1EE11do_encodingEv, _jpeg_abort_decompress: _jpeg_abort_decompress, __ZNK33AssetBundleLoadFromAsyncOperation20IsDirectoryInfoValidERKN20ArchiveStorageHeader13DirectoryInfoE: __ZNK33AssetBundleLoadFromAsyncOperation20IsDirectoryInfoValidERKN20ArchiveStorageHeader13DirectoryInfoE, __ZN10JointMotor8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN10JointMotor8TransferI18StreamedBinaryReadILb1EEEEvRT_, _y0: _y0, __ZN9WWWCached15LockPartialDataEv: __ZN9WWWCached15LockPartialDataEv, __ZNK5physx19PxClothFabricCooker13getDescriptorEv: __ZNK5physx19PxClothFabricCooker13getDescriptorEv, __ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj: __ZNK5physx21PxVehicleDriveDynData14getAnalogInputEj, __ZN7Texture20SetGlobalAnisoLimitsEii: __ZN7Texture20SetGlobalAnisoLimitsEii, __Z79Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_ClearInternalv: __Z79Register_UnityEngine_Rendering_SphericalHarmonicsL2_INTERNAL_CALL_ClearInternalv, __ZN13GfxDeviceGLES18BeforePluginRenderEv: __ZN13GfxDeviceGLES18BeforePluginRenderEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_16PxParticleSystemEEEEclILj173ENS_14PxParticleBaseEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z13RegisterClassI21WorldParticleColliderEvv: __Z13RegisterClassI21WorldParticleColliderEvv, __Z29Transfer_Blittable_ArrayFieldI9JSONWritefEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWritefEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN5physx20PxsParticleSystemSim14dynamicsUpdateEPNS_10PxBaseTaskE: __ZN5physx20PxsParticleSystemSim14dynamicsUpdateEPNS_10PxBaseTaskE, __ZN5physx2Gu19pcmContactBoxConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE: __ZN5physx2Gu19pcmContactBoxConvexERKNS0_13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS0_5CacheERNS0_13ContactBufferE, __Z6FTFreeP13FT_MemoryRec_Pv: __Z6FTFreeP13FT_MemoryRec_Pv, __Z49Register_UnityEngine_AudioReverbFilter_get_roomHFv: __Z49Register_UnityEngine_AudioReverbFilter_get_roomHFv, __Z20GL_CUSTOM_PushMatrixv: __Z20GL_CUSTOM_PushMatrixv, __ZNK12b2ChainShape11ComputeMassEP10b2MassDataf: __ZNK12b2ChainShape11ComputeMassEP10b2MassDataf, __Z29Transfer_Blittable_ArrayFieldI8JSONReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI8JSONReadfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __Z46Register_UnityEngine_Renderer_get_sortingOrderv: __Z46Register_UnityEngine_Renderer_get_sortingOrderv, __ZN14HeightMeshData8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN14HeightMeshData8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK9Transform18GetWorldScaleLossyEv: __ZNK9Transform18GetWorldScaleLossyEv, __ZNK12AudioManager14GetRealDSPTimeEv: __ZNK12AudioManager14GetRealDSPTimeEv, __ZN11GPUProfiler14CollectGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EEb: __ZN11GPUProfiler14CollectGPUTimeER13dynamic_arrayIN12ProfilerData7GPUTimeELj4EEb, __ZN5physx3Ext13RevoluteJoint20setRevoluteJointFlagENS_19PxRevoluteJointFlag4EnumEb: __ZN5physx3Ext13RevoluteJoint20setRevoluteJointFlagENS_19PxRevoluteJointFlag4EnumEb, __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_springv: __Z51Register_UnityEngine_HingeJoint_INTERNAL_set_springv, __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE: __ZN5physx2Gu31SinglePersistentContactManifold26reduceBatchContactsCapsuleEPKNS0_21MeshPersistentContactEjRNS0_15PCMContactPatchE, __ZN24dtObstacleAvoidanceQueryD2Ev: __ZN24dtObstacleAvoidanceQueryD2Ev, __Z50getPxVehicleDifferential4WDataMFrontLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE: __Z50getPxVehicleDifferential4WDataMFrontLeftRightSplitPKN5physx27PxVehicleDifferential4WDataE, __ZNK22ParticleSystemRenderer12GetMeshCountEv: __ZNK22ParticleSystemRenderer12GetMeshCountEv, __ZNK7Joint2D10FetchBodyBEv: __ZNK7Joint2D10FetchBodyBEv, __Z15Transfer_StringI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z15Transfer_StringI8JSONReadLb0EEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx2Gu12TriangleMesh14getLocalBoundsEv: __ZNK5physx2Gu12TriangleMesh14getLocalBoundsEv, __ZN5Umbra9intersectERKNS_7Vector4ERKNS_4AABBE: __ZN5Umbra9intersectERKNS_7Vector4ERKNS_4AABBE, __Z29Rigidbody2D_CUSTOM_IsSleepingP12Il2CppObject: __Z29Rigidbody2D_CUSTOM_IsSleepingP12Il2CppObject, __Z57Register_UnityEngine_Animator_GetIKRotationWeightInternalv: __Z57Register_UnityEngine_Animator_GetIKRotationWeightInternalv, __ZN5physx3Ext23DefaultBufferedProfiler21getProfileZoneManagerEv: __ZN5physx3Ext23DefaultBufferedProfiler21getProfileZoneManagerEv, __ZN5physx6shdfnd10SocketImpl5writeEPKhj: __ZN5physx6shdfnd10SocketImpl5writeEPKhj, __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv: __ZN20DynamicHeapAllocatorI17LowLevelAllocatorE14CheckIntegrityEv, __ZN5physx13GuMeshFactoryD0Ev: __ZN5physx13GuMeshFactoryD0Ev, __Z25LoadFullScreenOrthoMatrixffR9GfxDevice: __Z25LoadFullScreenOrthoMatrixffR9GfxDevice, __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEC2ERKS3_: __ZN13dynamic_arrayI11KeyframeTplI8Vector3fELj4EEC2ERKS3_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj296ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxHeightFieldDescEEEEclILj296ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z23sweepCapsule_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf: __Z23sweepCapsule_ConvexGeomRKN5physx10PxGeometryERKNS_11PxTransformERKNS_2Gu7CapsuleERKNS_6PxVec3EfRNS_10PxSweepHitENS_7PxFlagsINS_9PxHitFlag4EnumEtEEf, __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE: __ZNSt3__26__treeINS_12__value_typeIi26SerializedObjectIdentifierEENS_19__map_value_compareIiS3_NS_4lessIiEELb1EEENS_9allocatorIS3_EEE7destroyEPNS_11__tree_nodeIS3_PvEE, _jpeg_abort_compress: _jpeg_abort_compress, __ZNK14ParticleSystem28CalculateRequiredCatchupTimeEd: __ZNK14ParticleSystem28CalculateRequiredCatchupTimeEd, __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EED2Ev: __ZN19dynamic_block_arrayI14ProfilerSampleLj16384EED2Ev, __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeZMultiplierP12Il2CppObjectf: __Z56ParticleSystem_MainModule_CUSTOM_SetStartSizeZMultiplierP12Il2CppObjectf, __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup: __ZN18GfxFramebufferGLES8ActivateERK20GfxRenderTargetSetup, __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE: __ZN5physx2Sn25readStridedBufferPropertyINS_15PxClothParticleEEEvRNS_9XmlReaderEPKcRPvRjS9_RNS_18XmlMemoryAllocatorE, __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags: __Z16GenerateTypeTreeRK6ObjectR8TypeTree24TransferInstructionFlags, __ZNK16MemoryFileSystem7IsEmptyEv: __ZNK16MemoryFileSystem7IsEmptyEv, __Z47Register_UnityEngine_Projector_get_orthographicv: __Z47Register_UnityEngine_Projector_get_orthographicv, __Z23getNbPxScene_AggregatesPKN5physx7PxSceneE: __Z23getNbPxScene_AggregatesPKN5physx7PxSceneE, __Z30setPxDistanceJoint_MinDistancePN5physx15PxDistanceJointEf: __Z30setPxDistanceJoint_MinDistancePN5physx15PxDistanceJointEf, __ZN14MessageHandler28InitializeMessageIdentifiersEv: __ZN14MessageHandler28InitializeMessageIdentifiersEv, __ZNK14ParticleSystem8IsPausedEv: __ZNK14ParticleSystem8IsPausedEv, __Z14ProccessStringRNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEERKNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEE: __Z14ProccessStringRNSt3__23mapIj8UnityStrNS_4lessIjEENS_9allocatorINS_4pairIKjS1_EEEEEERKNS_12basic_stringIcNS_11char_traitsIcEENS4_IcEEEE, __ZN7mecanim10ValueArray8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim10ValueArray8TransferI14SafeBinaryReadEEvRT_, __Z34Display_CUSTOM_RelativeMouseAtImpliiPiS_: __Z34Display_CUSTOM_RelativeMouseAtImpliiPiS_, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj649ENS_22PxRepXPropertyAccessorILj649ES4_KffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_21PxVehicleDriveDynDataEEEE14handleAccessorILj649ENS_22PxRepXPropertyAccessorILj649ES4_KffEEEEvRKT0_, __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE24GetBookKeepingMemorySizeEv: __ZNK19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE24GetBookKeepingMemorySizeEv, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEE25enableContinuousCollisionEb, __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID: __ZN28ApplyBuiltinInstanceProperty9SetTexEnvE24BuiltinShaderTexEnvParam16TextureDimension14VRTextureUsage9TextureID, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI13ProbeSetIndexLj8EEEEvRT_17TransferMetaFlags, __Z42Physics2D_Set_Custom_PropShowColliderSleeph: __Z42Physics2D_Set_Custom_PropShowColliderSleeph, __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE: __ZN5physx21processSuspTireWheelsEjRKNS_29ProcessSuspWheelTireConstDataERKNS_29ProcessSuspWheelTireInputDataERNS_30ProcessSuspWheelTireOutputDataE, __Z43Register_UnityEngine_Gradient_set_colorKeysv: __Z43Register_UnityEngine_Gradient_set_colorKeysv, __ZN4Halo17RemoveFromManagerEv: __ZN4Halo17RemoveFromManagerEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags, __ZN13BuildSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN13BuildSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZThn4_N12_GLOBAL__N_111StreamOwnerD1Ev: __ZThn4_N12_GLOBAL__N_111StreamOwnerD1Ev, _tmpfile: _tmpfile, _sfnt_get_interface: _sfnt_get_interface, __ZN9Rigidbody8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Rigidbody8TransferI24GenerateTypeTreeTransferEEvRT_, _UNITY_ft_mem_qalloc: _UNITY_ft_mem_qalloc, __ZN12b2WheelJointD0Ev: __ZN12b2WheelJointD0Ev, __ZNKSt3__217moneypunct_bynameIwLb0EE16do_thousands_sepEv: __ZNKSt3__217moneypunct_bynameIwLb0EE16do_thousands_sepEv, __ZN2UI13RectTransform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN2UI13RectTransform23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN5physx12PxsRigidBody12advanceToToiEffb: __ZN5physx12PxsRigidBody12advanceToToiEffb, __Z53SceneManager_Get_Custom_PropSceneCountInBuildSettingsv: __Z53SceneManager_Get_Custom_PropSceneCountInBuildSettingsv, __ZN12_GLOBAL__N_1L5gNANDERN5physx12PxGroupsMaskERKS1_S4_: __ZN12_GLOBAL__N_1L5gNANDERN5physx12PxGroupsMaskERKS1_S4_, __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE: __ZN7mecanim9animation17MotionOutputClearEPNS0_12MotionOutputE, __Z46getNbPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataE: __Z46getNbPxVehicleWheelsDynData_WheelRotationSpeedPKN5physx22PxVehicleWheelsDynDataE, __ZN18ScriptingArguments11GetIntPtrAtEi: __ZN18ScriptingArguments11GetIntPtrAtEi, __ZN11UnityEngine15CloudWebService19SessionEventManager5StartERK8UnityStrii: __ZN11UnityEngine15CloudWebService19SessionEventManager5StartERK8UnityStrii, __Z29GetPhysicsScriptingClassesPtrv: __Z29GetPhysicsScriptingClassesPtrv, __ZThn12_N12_GLOBAL__N_110ConnectionD1Ev: __ZThn12_N12_GLOBAL__N_110ConnectionD1Ev, __ZN8Animator14SetCullingModeENS_11CullingModeE: __ZN8Animator14SetCullingModeENS_11CullingModeE, __ZN18AssetBundleManager17UnloadAssetBundleEP11AssetBundle: __ZN18AssetBundleManager17UnloadAssetBundleEP11AssetBundle, __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN9ShaderLab19SerializedSubShaderENS_9allocatorIS2_EEE8__appendEj, __Z43ParticleSystem_LightsModule_CUSTOM_GetRangeP12Il2CppObjectR15MonoMinMaxCurve: __Z43ParticleSystem_LightsModule_CUSTOM_GetRangeP12Il2CppObjectR15MonoMinMaxCurve, __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalPositionv: __Z68Register_UnityEngine_VR_InputTracking_INTERNAL_CALL_GetLocalPositionv, __Z44setPxVehicleDriveDynData_EngineRotationSpeedPN5physx21PxVehicleDriveDynDataEf: __Z44setPxVehicleDriveDynData_EngineRotationSpeedPN5physx21PxVehicleDriveDynDataEf, __GLOBAL__sub_I_TransformFeedbackSkinning_cpp: __GLOBAL__sub_I_TransformFeedbackSkinning_cpp, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI4PPtrI13AnimationClipELj4EEEEvRT_17TransferMetaFlags, __ZN14SubstanceInput8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN14SubstanceInput8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_14PxRigidDynamicEE12readPropertyIfEEbRT_, __ZN5physx5cloth11SwCollisionI8Scalar4fED2Ev: __ZN5physx5cloth11SwCollisionI8Scalar4fED2Ev, __ZN5physx16PxsThreadContext5resetEjj: __ZN5physx16PxsThreadContext5resetEjj, __ZN11UnityEngine15CloudWebService14DataDispatcher23EnumerateSessionFoldersER13dynamic_arrayI13FileEntryInfoLj8EERPKS3_: __ZN11UnityEngine15CloudWebService14DataDispatcher23EnumerateSessionFoldersER13dynamic_arrayI13FileEntryInfoLj8EERPKS3_, __Z33GUIStyle_Get_Custom_PropFontStyleP12Il2CppObject: __Z33GUIStyle_Get_Custom_PropFontStyleP12Il2CppObject, __Z19tessComputeInteriorP14TESStesselator: __Z19tessComputeInteriorP14TESStesselator, __ZNK5physx2Sc16ArticulationCore18getFreezeThresholdEv: __ZNK5physx2Sc16ArticulationCore18getFreezeThresholdEv, __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale0Ef: __ZN5physx3Ext5JointINS_16PxPrismaticJointENS_31PxPrismaticJointGeneratedValuesEE16setInvMassScale0Ef, _UNITY_FT_Destroy_Class_ft_smooth_renderer_class: _UNITY_FT_Destroy_Class_ft_smooth_renderer_class, __Z36RemoveErrorWithIdentifierFromConsolei: __Z36RemoveErrorWithIdentifierFromConsolei, __ZN23AllocationRootReferenceC2EP24ProfilerAllocationHeaderjPKcS3_: __ZN23AllocationRootReferenceC2EP24ProfilerAllocationHeaderjPKcS3_, _Unity_FT_Init_FreeType: _Unity_FT_Init_FreeType, __ZN16BehaviourManager6UpdateEv: __ZN16BehaviourManager6UpdateEv, __ZN10DynamicVBO8GetChunkEjjj16GfxPrimitiveTypeP21DynamicVBOChunkHandle: __ZN10DynamicVBO8GetChunkEjjj16GfxPrimitiveTypeP21DynamicVBOChunkHandle, __ZN20BaseBehaviourManager12CommonUpdateI21FixedBehaviourManagerEEvv: __ZN20BaseBehaviourManager12CommonUpdateI21FixedBehaviourManagerEEvv, _UNITY_png_get_pHYs: _UNITY_png_get_pHYs, __ZN5physx17SapUpdateWorkTask11runInternalEv: __ZN5physx17SapUpdateWorkTask11runInternalEv, __ZN15HeightMeshQuery13AddHeightDataEiPKNSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEPK13dynamic_arrayI13HeightmapDataLj4EE: __ZN15HeightMeshQuery13AddHeightDataEiPKNSt3__26vectorI14HeightMeshData13stl_allocatorIS2_L18MemLabelIdentifier73ELi16EEEEPK13dynamic_arrayI13HeightmapDataLj4EE, _getresuid: _getresuid, __ZN5physx40setupFinalizeExtSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhffRNS_16PxsSolverExtBodyESE_jffff: __ZN5physx40setupFinalizeExtSolverConstraintsCoulombERNS_13PxcNpWorkUnitERKNS_2Gu13ContactBufferERKNS_27PxcCorrelationBufferCoulombERKNS_11PxTransformESB_bPhffRNS_16PxsSolverExtBodyESE_jffff, __Z48Register_UnityEngine_SpringJoint_set_minDistancev: __Z48Register_UnityEngine_SpringJoint_set_minDistancev, __ZN9Animation27RecomputeContainedRenderersEv: __ZN9Animation27RecomputeContainedRenderersEv, __ZN13UnityProfiler19SetupProfilerEventsEv: __ZN13UnityProfiler19SetupProfilerEventsEv, __Z24RegisterStrippedTypeInfoI17PhysicsMaterial2DEviPKcS2_: __Z24RegisterStrippedTypeInfoI17PhysicsMaterial2DEviPKcS2_, __ZN8Material8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN8Material8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN2UI17DestroyCanvasDataER8JobFenceRNS_10CanvasDataE: __ZN2UI17DestroyCanvasDataER8JobFenceRNS_10CanvasDataE, _fmaxf: _fmaxf, __ZN12b2MotorJointD0Ev: __ZN12b2MotorJointD0Ev, __ZNK6Camera28ExtractCameraRenderingParamsEv: __ZNK6Camera28ExtractCameraRenderingParamsEv, __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeINS_12__value_typeIjN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEEENS_19__map_value_compareIjS7_NS_4lessIjEELb1EEE13stl_allocatorIS7_L18MemLabelIdentifier6ELi16EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN5physx2Sc7BodySim20postBody2WorldChangeEv: __ZN5physx2Sc7BodySim20postBody2WorldChangeEv, __ZN19ControllerHitReport5onHitERKN5physx15PxControllerHitEP8Collider: __ZN19ControllerHitReport5onHitERKN5physx15PxControllerHitEP8Collider, __ZN5physx2Gu17RadixSortBufferedD2Ev: __ZN5physx2Gu17RadixSortBufferedD2Ev, __Z13RegisterClassI13ComputeShaderEvv: __Z13RegisterClassI13ComputeShaderEvv, __ZN8Material21BuildShaderKeywordSetEv: __ZN8Material21BuildShaderKeywordSetEv, __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN13AnimationClip15QuaternionCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN2UI6Canvas22CanvasHierarchyChangedEv: __ZN2UI6Canvas22CanvasHierarchyChangedEv, __ZN5physx2Sn12PointerRemapD2Ev: __ZN5physx2Sn12PointerRemapD2Ev, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_124PropertyMessageEntryImplENS_8debugger19ForwardingAllocatorEE8recreateEj, __Z18Transfer_BlittableI9JSONWriteLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI9JSONWriteLb1EfEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, _UNITY_png_build_gamma_table: _UNITY_png_build_gamma_table, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE6insertENS_11__wrap_iterIPKwEEw, __ZNK13InitialModule10GetGravityERK27ParticleSystemReadOnlyStateRK19ParticleSystemState: __ZNK13InitialModule10GetGravityERK27ParticleSystemReadOnlyStateRK19ParticleSystemState, __ZN9Transform25CompleteTransformTransferI24GenerateTypeTreeTransferEEvRT_: __ZN9Transform25CompleteTransformTransferI24GenerateTypeTreeTransferEEvRT_, __ZN23ParticleSystemParticlesD2Ev: __ZN23ParticleSystemParticlesD2Ev, __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet: __ZN8keywords18StringToKeywordSetERK8UnityStrR16ShaderKeywordSet, __ZN17Physics2DSettings23VirtualRedirectTransferER14SafeBinaryRead: __ZN17Physics2DSettings23VirtualRedirectTransferER14SafeBinaryRead, __ZThn8_NK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E: __ZThn8_NK5physx3Cct13BoxController11getWorldBoxERNS_17PxExtendedBounds3E, __ZNK14dtNavMeshQuery16findStraightPathEPKfS1_PKyiPfPhPyPii: __ZNK14dtNavMeshQuery16findStraightPathEPKfS1_PKyiPfPhPyPii, __ZN17SizeBySpeedModuleD0Ev: __ZN17SizeBySpeedModuleD0Ev, _fmaxl: _fmaxl, __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_: __ZNK15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES7_EES7_11djb2_hash_tIS7_EN14dense_hash_mapIS7_S7_SB_NS0_8equal_toIS7_EE13stl_allocatorIS9_L18MemLabelIdentifier54ELi16EEE9SelectKeyESE_SH_E13find_positionERS8_, __ZN5physx22PxVehicleWheelsSimData4freeEv: __ZN5physx22PxVehicleWheelsSimData4freeEv, __ZN5physx2Gu18CompleteBoxPruningEPKNS_9PxBounds3EjRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE: __ZN5physx2Gu18CompleteBoxPruningEPKNS_9PxBounds3EjRNS_6shdfnd5ArrayIjNS4_19ReflectionAllocatorIjEEEERKNS0_4AxesE, __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN15DetailPrototype8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN4FMOD7Channel11setPriorityEi: __ZN4FMOD7Channel11setPriorityEi, __Z12DestroyWorldb: __Z12DestroyWorldb, __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE: __ZN5physx2Sq13getGlobalPoseERKNS_7NpShapeERKNS_12PxRigidActorE, __Z60Register_UnityEngine_Rendering_CommandBuffer_SetGlobalBufferv: __Z60Register_UnityEngine_Rendering_CommandBuffer_SetGlobalBufferv, __Z29Sprite_Get_Custom_PropTextureP12Il2CppObject: __Z29Sprite_Get_Custom_PropTextureP12Il2CppObject, __ZNSt3__213__vector_baseIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEED2Ev: __ZNSt3__213__vector_baseIPNS_17__assoc_sub_stateENS_18__hidden_allocatorIS2_EEED2Ev, __Z48UnityConnectSettings_Set_Custom_PropTestEventUrlP12Il2CppString: __Z48UnityConnectSettings_Set_Custom_PropTestEventUrlP12Il2CppString, __Z40Cloth_Get_Custom_PropUseVirtualParticlesP12Il2CppObject: __Z40Cloth_Get_Custom_PropUseVirtualParticlesP12Il2CppObject, _cff_index_init: _cff_index_init, __Z38getPxScene_ClothInterCollisionDistancePKN5physx7PxSceneE: __Z38getPxScene_ClothInterCollisionDistancePKN5physx7PxSceneE, __ZN16Physics2DManager10OverlapBoxERK8Vector2fS2_fiffPK10Collider2D: __ZN16Physics2DManager10OverlapBoxERK8Vector2fS2_fiffPK10Collider2D, __Z58Register_UnityEngine_SystemInfo_get_supportsComputeShadersv: __Z58Register_UnityEngine_SystemInfo_get_supportsComputeShadersv, __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb: __ZN8GUIState12GetControlIDERS_i9FocusTypeRK5RectTIfEb, __ZN5physx2Sn21RepXVisitorReaderBaseINS_11PxMeshScaleEE8pushNameEPKc: __ZN5physx2Sn21RepXVisitorReaderBaseINS_11PxMeshScaleEE8pushNameEPKc, __ZN5physx6shdfnd7FastIPCC2ERNS0_5PxIPC9ErrorCodeENS2_14ConnectionTypeEPKcjjbbj: __ZN5physx6shdfnd7FastIPCC2ERNS0_5PxIPC9ErrorCodeENS2_14ConnectionTypeEPKcjjbbj, __Z24RegisterStrippedTypeInfoI15NavMeshObstacleEviPKcS2_: __Z24RegisterStrippedTypeInfoI15NavMeshObstacleEviPKcS2_, __ZN5physx10PxsContext11shiftOriginERKNS_6PxVec3E: __ZN5physx10PxsContext11shiftOriginERKNS_6PxVec3E, _ispunct: _ispunct, __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS0_9allocatorIS4_EEEEEvRT_j, __Z47ParticleSystem_LightsModule_CUSTOM_GetMaxLightsP12Il2CppObject: __Z47ParticleSystem_LightsModule_CUSTOM_GetMaxLightsP12Il2CppObject, __Z21setPxCloth_GlobalPosePN5physx7PxClothERKNS_11PxTransformE: __Z21setPxCloth_GlobalPosePN5physx7PxClothERKNS_11PxTransformE, __ZNSt3__211__libcpp_db15__iterator_copyEPvPKv: __ZNSt3__211__libcpp_db15__iterator_copyEPvPKv, __Z45NavMeshAgent_Get_Custom_PropRemainingDistanceP12Il2CppObject: __Z45NavMeshAgent_Get_Custom_PropRemainingDistanceP12Il2CppObject, __ZN5physx42PxVehicleDifferential4WDataGeneratedValuesC2EPKNS_27PxVehicleDifferential4WDataE: __ZN5physx42PxVehicleDifferential4WDataGeneratedValuesC2EPKNS_27PxVehicleDifferential4WDataE, _UNITY_FT_GlyphLoader_CreateExtra: _UNITY_FT_GlyphLoader_CreateExtra, __ZN14AsyncOperation11GetPriorityEv: __ZN14AsyncOperation11GetPriorityEv, __Z35GUIStyle_Set_Custom_PropFixedHeightP12Il2CppObjectf: __Z35GUIStyle_Set_Custom_PropFixedHeightP12Il2CppObjectf, _jpeg_new_colormap: _jpeg_new_colormap, __Z30Mesh_Get_Custom_PropIsReadableP12Il2CppObject: __Z30Mesh_Get_Custom_PropIsReadableP12Il2CppObject, __ZN17BillboardRenderer13AwakeFromLoadE17AwakeFromLoadMode: __ZN17BillboardRenderer13AwakeFromLoadE17AwakeFromLoadMode, __ZN12_GLOBAL__N_124PropertyDefinitionHelper8pushNameEPKcS2_: __ZN12_GLOBAL__N_124PropertyDefinitionHelper8pushNameEPKcS2_, __ZN7mecanim9animation30ValueFromSkeletonPoseRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapEPKiRNS_10ValueArrayEii: __ZN7mecanim9animation30ValueFromSkeletonPoseRecursiveERKNS_8skeleton8SkeletonERKNS1_13SkeletonPoseTIN4math4trsXEEEPKNS0_14SkeletonTQSMapEPKiRNS_10ValueArrayEii, __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI4MeshE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z35LensFlare_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf: __Z35LensFlare_CUSTOM_INTERNAL_get_colorP12Il2CppObjectP10ColorRGBAf, __Z31Profiler_Get_Custom_PropEnabledv: __Z31Profiler_Get_Custom_PropEnabledv, __Z53ParticleSystemRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf: __Z53ParticleSystemRenderer_Set_Custom_PropMaxParticleSizeP12Il2CppObjectf, __ZZN8VRDevice10InitializeEbEN27FrameEventsVREndFramestruct7ForwardEv: __ZZN8VRDevice10InitializeEbEN27FrameEventsVREndFramestruct7ForwardEv, __Z31Mesh_Get_Custom_PropBoneWeightsP12Il2CppObject: __Z31Mesh_Get_Custom_PropBoneWeightsP12Il2CppObject, __ZN34ColorBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif: __ZN34ColorBySpeedModulePropertyBindings13SetFloatValueER14ParticleSystemif, __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity5Cloth8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN7mecanim5human9HumanPose8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN15SerializeTraitsI12AspectRatiosE8TransferI14SafeBinaryReadEEvRS0_RT_: __ZN15SerializeTraitsI12AspectRatiosE8TransferI14SafeBinaryReadEEvRS0_RT_, __Z35Camera_Set_Custom_PropRenderingPathP12Il2CppObject13RenderingPath: __Z35Camera_Set_Custom_PropRenderingPathP12Il2CppObject13RenderingPath, __Z19GetRotMatrixNormVecPfPKff: __Z19GetRotMatrixNormVecPfPKff, __Z55Register_UnityEngine_WheelCollider_set_wheelDampingRatev: __Z55Register_UnityEngine_WheelCollider_set_wheelDampingRatev, __ZN15NavMeshObstacle12AddToManagerEv: __ZN15NavMeshObstacle12AddToManagerEv, __ZN15DetailPrototypeC2ERKS_: __ZN15DetailPrototypeC2ERKS_, __Z24RegisterStrippedTypeInfoI12MeshRendererEviPKcS2_: __Z24RegisterStrippedTypeInfoI12MeshRendererEviPKcS2_, __ZN9BlobWrite8TransferIN7mecanim10ValueArrayEEEvRT_PKc17TransferMetaFlags: __ZN9BlobWrite8TransferIN7mecanim10ValueArrayEEEvRT_PKc17TransferMetaFlags, __ZN5physx15PxVehicleUpdate10updateTankEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_18PxVehicleDriveTankEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE: __ZN5physx15PxVehicleUpdate10updateTankEfRKNS_6PxVec3EffRKNS_43PxVehicleDrivableSurfaceToTireFrictionPairsEPNS_18PxVehicleDriveTankEPNS_25PxVehicleWheelQueryResultEPNS_29PxVehicleConcurrentUpdateDataE, __Z28TextMesh_Get_Custom_PropFontP12Il2CppObject: __Z28TextMesh_Get_Custom_PropFontP12Il2CppObject, __ZThn32_N16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N16ParticleRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __ZN11TypeManager19CallInitializeTypesEv: __ZN11TypeManager19CallInitializeTypesEv, __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev: __ZN21BillboardBatchManager24AutoBillboardShaderPropsD2Ev, __ZN5physx16PxsIslandManager43computeChangeToNumEdgeReferencesToKinematicEv: __ZN5physx16PxsIslandManager43computeChangeToNumEdgeReferencesToKinematicEv, __ZN12ImageFilters24GetBlitCopyDepthMaterialEv: __ZN12ImageFilters24GetBlitCopyDepthMaterialEv, __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb: __ZN5physx2Gu22EPARelativePenetrationERKNS0_18ConvexHullNoScaleVES3_RKNS_6shdfnd3aos15PsMatTransformVERNS5_5Vec3VESA_SA_RNS5_6FloatVEPhSD_Rhb, __Z38CalculateExplicitLightProbeCoordinatesiR29LightProbeSamplingCoordinates: __Z38CalculateExplicitLightProbeCoordinatesiR29LightProbeSamplingCoordinates, __ZN2UI14CanvasRenderer13SyncWorldRectENS0_8SyncFlagEb: __ZN2UI14CanvasRenderer13SyncWorldRectENS0_8SyncFlagEb, __ZN5physx2Sc7BodySimD2Ev: __ZN5physx2Sc7BodySimD2Ev, __ZL18InitializeIfNeededv: __ZL18InitializeIfNeededv, __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_90kDidModifyMotion4CallEPviR11MessageData: __ZZN18AnimatorController15InitializeClassEvEN30FunctorImpl_90kDidModifyMotion4CallEPviR11MessageData, _UNITY_FT_Get_Module_Interface: _UNITY_FT_Get_Module_Interface, __ZN21WorldParticleCollider8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN21WorldParticleCollider8TransferI24GenerateTypeTreeTransferEEvRT_, __ZN5physx15NpParticleFluid8requiresERNS_23PxProcessPxBaseCallbackE: __ZN5physx15NpParticleFluid8requiresERNS_23PxProcessPxBaseCallbackE, __ZN14ParticleSystem27UpdateModulesNonIncrementalERK32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesR31ParticleSystemParticlesTempData: __ZN14ParticleSystem27UpdateModulesNonIncrementalERK32ParticleSystemGeometryJobModulesRK23ParticleSystemParticlesR31ParticleSystemParticlesTempData, _towctrans_l: _towctrans_l, __Z36Graphics_CUSTOM_ExecuteCommandBufferP12Il2CppObject: __Z36Graphics_CUSTOM_ExecuteCommandBufferP12Il2CppObject, __ZN14ParticleSystem19UpdateVelocityStateERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemState: __ZN14ParticleSystem19UpdateVelocityStateERS_RK27ParticleSystemReadOnlyStateR19ParticleSystemState, __ZN7Joint2D5ResetEv: __ZN7Joint2D5ResetEv, __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEjRKS3_: __ZNSt3__26vectorI13dynamic_arrayI8Vector2fLj4EENS_9allocatorIS3_EEE8__appendEjRKS3_, __ZN7Texture23VirtualRedirectTransferER14SafeBinaryRead: __ZN7Texture23VirtualRedirectTransferER14SafeBinaryRead, __ZN5physx2Gu11gjkRelativeINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE: __ZN5physx2Gu11gjkRelativeINS0_4BoxVENS0_11ConvexHullVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERNSB_5Vec3VESG_SG_RNSB_6FloatVE, __ZThn32_N13TrailRendererD1Ev: __ZThn32_N13TrailRendererD1Ev, __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18getConstraintFlagsEv: __ZNK5physx3Ext5JointINS_16PxSphericalJointENS_31PxSphericalJointGeneratedValuesEE18getConstraintFlagsEv, __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI24GenerateTypeTreeTransfer10ColorRGBAfEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN9ShaderLab20SerializedSubProgram8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN4Mesh8TransferI14SafeBinaryReadEEvRT_: __ZN4Mesh8TransferI14SafeBinaryReadEEvRT_, __ZN13GfxDeviceNull15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij: __ZN13GfxDeviceNull15UploadTexture3DE9TextureIDPKhiiii13TextureFormatij, __ZN12b2MotorJoint4DumpEv: __ZN12b2MotorJoint4DumpEv, __ZN11UnityEngine15CloudWebService14RestDownloaderD0Ev: __ZN11UnityEngine15CloudWebService14RestDownloaderD0Ev, __Z47TerrainData_CUSTOM_INTERNAL_set_wavingGrassTintP12Il2CppObjectRK10ColorRGBAf: __Z47TerrainData_CUSTOM_INTERNAL_set_wavingGrassTintP12Il2CppObjectRK10ColorRGBAf, __Z11heapReallocPvS_j: __Z11heapReallocPvS_j, __Z32AndroidJNI_CUSTOM_CallCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray: __Z32AndroidJNI_CUSTOM_CallCharMethod13Il2Cpp_IntPtrS_P11Il2CppArray, __Z37TerrainData_CUSTOM_GetSupportedLayersP12Il2CppObjectiiii: __Z37TerrainData_CUSTOM_GetSupportedLayersP12Il2CppObjectiiii, __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb: __ZN6b2Body13CreateFixtureEPK12b2FixtureDefb, __Z32Camera_Get_Custom_PropClearFlagsP12Il2CppObject: __Z32Camera_Get_Custom_PropClearFlagsP12Il2CppObject, __ZN15AudioEchoFilter23VirtualRedirectTransferER14SafeBinaryRead: __ZN15AudioEchoFilter23VirtualRedirectTransferER14SafeBinaryRead, __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED0Ev: __ZThn4_N5physx5cloth9ClothImplINS0_7SwClothEED0Ev, __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv: __ZN13RuntimeStaticI18BackgroundJobQueueE10InitializeEv, _nearbyint: _nearbyint, __ZNK5Umbra18ReceiverMaskCuller21computeLightSpaceAABBERNS_7Vector3ES2_RKS1_S4_: __ZNK5Umbra18ReceiverMaskCuller21computeLightSpaceAABBERNS_7Vector3ES2_RKS1_S4_, __ZN12GraphicsCapsC2Ev: __ZN12GraphicsCapsC2Ev, __ZN22AnimationMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput: __ZN22AnimationMixerPlayable16ProcessAnimationEP35AnimationPlayableEvaluationConstantP32AnimationPlayableEvaluationInputP33AnimationPlayableEvaluationOutput, __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh: __ZN5physx2Gu22gjkRelativePenetrationINS0_17ShrunkConvexHullVENS0_24ShrunkConvexHullNoScaleVEEEjRKT_RKT0_RKNS_6shdfnd3aos15PsMatTransformVERKNSB_6FloatVERNSB_5Vec3VESJ_SJ_RSF_PhSL_Rh, __ZN5physx2Sc21ArticulationJointCore28setTwistLimitContactDistanceEf: __ZN5physx2Sc21ArticulationJointCore28setTwistLimitContactDistanceEf, __Z24Mathf_CUSTOM_PerlinNoiseff: __Z24Mathf_CUSTOM_PerlinNoiseff, __ZN8keywords7CleanupEv: __ZN8keywords7CleanupEv, __Z46BuoyancyEffector2D_Get_Custom_PropSurfaceLevelP12Il2CppObject: __Z46BuoyancyEffector2D_Get_Custom_PropSurfaceLevelP12Il2CppObject, __Z38AsyncOperation_Get_Custom_PropPriorityP12Il2CppObject: __Z38AsyncOperation_Get_Custom_PropPriorityP12Il2CppObject, __ZNK13BaseAllocator15WalkAllocationsEPFvPKvjPKPvjE: __ZNK13BaseAllocator15WalkAllocationsEPFvPKvjPKPvjE, _psnames_get_service: _psnames_get_service, __ZNK5physx7NpCloth22getSleepLinearVelocityEv: __ZNK5physx7NpCloth22getSleepLinearVelocityEv, _jpeg_get_large: _jpeg_get_large, __Z64Register_UnityEngine_Camera_INTERNAL_CALL_CalculateObliqueMatrixv: __Z64Register_UnityEngine_Camera_INTERNAL_CALL_CalculateObliqueMatrixv, __ZN5physx3Ext13RevoluteJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext13RevoluteJoint17resolveReferencesERNS_24PxDeserializationContextE, __Z53RenderSettings_CUSTOM_INTERNAL_get_ambientGroundColorP10ColorRGBAf: __Z53RenderSettings_CUSTOM_INTERNAL_get_ambientGroundColorP10ColorRGBAf, __ZN11DynamicMesh13MergePolygonsERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE: __ZN11DynamicMesh13MergePolygonsERNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS4_L18MemLabelIdentifier1ELi16EEEE, __Z24RegisterStrippedTypeInfoI12MeshColliderEviPKcS2_: __Z24RegisterStrippedTypeInfoI12MeshColliderEviPKcS2_, __ZN13dynamic_arrayIP8MaterialLj4EEC2ERKS2_: __ZN13dynamic_arrayIP8MaterialLj4EEC2ERKS2_, __ZN5physx8debugger14PvdMarshallingIjxE12marshalBlockEPKhPhj: __ZN5physx8debugger14PvdMarshallingIjxE12marshalBlockEPKhPhj, __Z38SceneManager_Get_Custom_PropSceneCountv: __Z38SceneManager_Get_Custom_PropSceneCountv, __ZN13RuntimeStaticI12EventManagerE16StaticInitializeEPv: __ZN13RuntimeStaticI12EventManagerE16StaticInitializeEPv, __Z46Register_UnityEngine_AndroidJNI_ExceptionClearv: __Z46Register_UnityEngine_AndroidJNI_ExceptionClearv, __ZN11TypeManager25InitializeDerivedFromInfoEv: __ZN11TypeManager25InitializeDerivedFromInfoEv, __ZN19StreamedBinaryWriteILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj: __ZN19StreamedBinaryWriteILb0EE21TransferResourceImageE19ActiveResourceImagePKcR13StreamingInfoPvj, __ZN5physx13BigConvexData17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx13BigConvexData17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN13DrawImmediate13ImmediateVertC2Ev: __ZN13DrawImmediate13ImmediateVertC2Ev, __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j: __ZNK5physx35PxVehicleWheelsSimDataGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxVehicleWheelsSimDataEEEEEEEjT_j, __Z39Motion_CUSTOM_INTERNAL_get_averageSpeedP12Il2CppObjectP8Vector3f: __Z39Motion_CUSTOM_INTERNAL_get_averageSpeedP12Il2CppObjectP8Vector3f, __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanSetWeightsInternalv: __Z87Register_UnityEngine_Experimental_Director_Playable_INTERNAL_CALL_CanSetWeightsInternalv, __ZN10HumanTrait10LeftFinger11GetBoneNameEi: __ZN10HumanTrait10LeftFinger11GetBoneNameEi, _UNITY_png_write_sPLT: _UNITY_png_write_sPLT, __ZN8Collider22CreatePhysXObjIfNeededEv: __ZN8Collider22CreatePhysXObjIfNeededEv, __ZNK5physx19NpArticulationJoint22getTangentialStiffnessEv: __ZNK5physx19NpArticulationJoint22getTangentialStiffnessEv, __ZNSt3__227__insertion_sort_incompleteIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEbT0_S8_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_4lessI4PPtrI10MonoScriptEEEPS4_EEbT0_S8_T_, __Z47Register_UnityEngine_TrailRenderer_set_endWidthv: __Z47Register_UnityEngine_TrailRenderer_set_endWidthv, __ZNK5physx15NpActorTemplateINS_7PxClothEE17getDominanceGroupEv: __ZNK5physx15NpActorTemplateINS_7PxClothEE17getDominanceGroupEv, __ZN20SphericalHarmonicsL27SetZeroEv: __ZN20SphericalHarmonicsL27SetZeroEv, __ZN5Unity12PhysicsQuery19CapsuleCastNonAllocERK8Vector3fS3_fS3_P10RaycastHitifi23QueryTriggerInteraction: __ZN5Unity12PhysicsQuery19CapsuleCastNonAllocERK8Vector3fS3_fS3_P10RaycastHitifi23QueryTriggerInteraction, __ZNKSt3__210moneypunctIwLb1EE11frac_digitsEv: __ZNKSt3__210moneypunctIwLb1EE11frac_digitsEv, __Z46Physics_Get_Custom_PropDefaultSolverIterationsv: __Z46Physics_Get_Custom_PropDefaultSolverIterationsv, __Z60Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstsv: __Z60Register_UnityEngine_ParticleSystem_EmissionModule_GetBurstsv, __Z48Renderer_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f: __Z48Renderer_CUSTOM_INTERNAL_get_lightmapScaleOffsetP12Il2CppObjectP8Vector4f, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj665ES3_RKNS_19PxVehicleClutchDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveSimDataEEEEclILj665ES3_RKNS_19PxVehicleClutchDataES7_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN7mecanim12statemachine27DestroyStateMachineConstantEPNS0_20StateMachineConstantERNS_6memory9AllocatorE: __ZN7mecanim12statemachine27DestroyStateMachineConstantEPNS0_20StateMachineConstantERNS_6memory9AllocatorE, __ZN9GfxDevice11CopyTextureE9TextureIDiiiS0_iii: __ZN9GfxDevice11CopyTextureE9TextureIDiiiS0_iii, __ZN13GfxDeviceNull17CaptureScreenshotEiiiiPh: __ZN13GfxDeviceNull17CaptureScreenshotEiiiiPh, __Z27SortingLayer_CUSTOM_IsValidi: __Z27SortingLayer_CUSTOM_IsValidi, __Z63Register_UnityEngine_Renderer_set_lightProbeProxyVolumeOverridev: __Z63Register_UnityEngine_Renderer_set_lightProbeProxyVolumeOverridev, __Z13RegisterClassI6AvatarEvv: __Z13RegisterClassI6AvatarEvv, __ZN12LineRenderer5ResetEv: __ZN12LineRenderer5ResetEv, __ZN8WindZone17RemoveFromManagerEv: __ZN8WindZone17RemoveFromManagerEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_14PxRigidDynamicEEEEclILj23ENS_12PxRigidActorERKNS_11PxTransformES8_EEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN13RuntimeStaticI23MeshVertexFormatManagerE10InitializeEv: __ZN13RuntimeStaticI23MeshVertexFormatManagerE10InitializeEv, __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm: __ZNKSt3__28time_getIwNS_19istreambuf_iteratorIwNS_11char_traitsIwEEEEE11do_get_timeES4_S4_RNS_8ios_baseERjP2tm, __ZN12NavMeshAgent11SetAreaMaskEj: __ZN12NavMeshAgent11SetAreaMaskEj, __Z23GetLODGroupAABBUnawakenR10MinMaxAABBRK8LODGroup: __Z23GetLODGroupAABBUnawakenR10MinMaxAABBRK8LODGroup, __ZN4crnd12symbol_codecC2Ev: __ZN4crnd12symbol_codecC2Ev, __ZN5physx3Cct8SweptBoxC2Ev: __ZN5physx3Cct8SweptBoxC2Ev, __Z54Register_UnityEngine_Application_get_stackTraceLogTypev: __Z54Register_UnityEngine_Application_get_stackTraceLogTypev, __ZN14PhysicsManager26SetDefaultSolverIterationsEi: __ZN14PhysicsManager26SetDefaultSolverIterationsEi, _ps_dimension_set_mask_bits: _ps_dimension_set_mask_bits, __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferIjEEvRT_PKc17TransferMetaFlags, __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E: __ZN5physx2Gu15PCMPolygonalBoxC2ERKNS_6PxVec3E, __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI9JSONWrite10Matrix4x4fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN11UnityEngine9Analytics15UserCustomEventD2Ev: __ZN11UnityEngine9Analytics15UserCustomEventD2Ev, __ZN9Texture2D7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN9Texture2D7PRODUCEE10MemLabelId18ObjectCreationMode, __Z46RelativeJoint2D_Get_Custom_PropCorrectionScaleP12Il2CppObject: __Z46RelativeJoint2D_Get_Custom_PropCorrectionScaleP12Il2CppObject, __Z39Cloth_Set_Custom_PropWorldVelocityScaleP12Il2CppObjectf: __Z39Cloth_Set_Custom_PropWorldVelocityScaleP12Il2CppObjectf, __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_: __ZN10__cxxabiv112_GLOBAL__N_122parse_unqualified_nameINS0_2DbEEEPKcS4_S4_RT_, __Z18Transfer_BlittableI8JSONReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI8JSONReadLb0E8Vector4fEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZNK5physx2Sc15ArticulationSim22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_: __ZNK5physx2Sc15ArticulationSim22computeImpulseResponseERNS0_8BodyCoreERNS_6PxVec3ES5_RKNS_9PxcFsDataERKS4_SA_, __Z32AndroidJNI_CUSTOM_DeleteLocalRef13Il2Cpp_IntPtr: __Z32AndroidJNI_CUSTOM_DeleteLocalRef13Il2Cpp_IntPtr, __ZN5physx7NpScene15SceneCompletion11runInternalEv: __ZN5physx7NpScene15SceneCompletion11runInternalEv, __ZN15TerrainRenderer21BuildPatchMeshStreamsERA4_10StreamInfoRA8_11ChannelInfo: __ZN15TerrainRenderer21BuildPatchMeshStreamsERA4_10StreamInfoRA8_11ChannelInfo, __ZN12AudioManager11FixedUpdateEv: __ZN12AudioManager11FixedUpdateEv, __Z38Terrain_CUSTOM_CreateTerrainGameObjectP12Il2CppObject: __Z38Terrain_CUSTOM_CreateTerrainGameObjectP12Il2CppObject, __ZN11UnityEngine15PlatformWrapper14GetSensorFlagsEv: __ZN11UnityEngine15PlatformWrapper14GetSensorFlagsEv, __Z45NavMeshAgent_CUSTOM_INTERNAL_get_nextPositionP12Il2CppObjectP8Vector3f: __Z45NavMeshAgent_CUSTOM_INTERNAL_get_nextPositionP12Il2CppObjectP8Vector3f, stackRestore: stackRestore, __ZN18BuoyancyEffector2D15ThreadedCleanupEv: __ZN18BuoyancyEffector2D15ThreadedCleanupEv, __Z48Register_UnityEngine_Camera_set_stereoMirrorModev: __Z48Register_UnityEngine_Camera_set_stereoMirrorModev, __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EOS3_: __ZNSt3__214basic_iostreamIcNS_11char_traitsIcEEEC1EOS3_, __Z32AudioSource_CUSTOM_PlayScheduledP12Il2CppObjectd: __Z32AudioSource_CUSTOM_PlayScheduledP12Il2CppObjectd, __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE: __ZN5physx2Sq17SceneQueryManager11removeShapeEPNS0_10ActorShapeE, __Z51Register_UnityEngine_Graphics_Internal_BlitMaterialv: __Z51Register_UnityEngine_Graphics_Internal_BlitMaterialv, __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf: __ZN5physx2Gu19intersectRayCapsuleERKNS_6PxVec3ES3_S3_S3_fPf, __ZN9Transform13AwakeFromLoadE17AwakeFromLoadMode: __ZN9Transform13AwakeFromLoadE17AwakeFromLoadMode, __ZNSt3__219__shared_weak_count10__add_weakEv: __ZNSt3__219__shared_weak_count10__add_weakEv, __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_: __ZNSt3__27__sort5IRPFbRK16MeshTriangleDataS3_EPS1_EEjT0_S8_S8_S8_S8_T_, __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_: __ZL22intersectEdgeEdgePrecaRKN5physx6PxVec3ES2_S2_RKNS_7PxPlaneEjjfS2_S2_S2_RfRS0_, __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN21LightProbeProxyVolume8TransferI18StreamedBinaryReadILb0EEEEvRT_, __Z10pqHeapInitP13PriorityQHeap: __Z10pqHeapInitP13PriorityQHeap, _zipOpen2: _zipOpen2, __ZN5physx25PxDefaultFileOutputStreamC2EPKc: __ZN5physx25PxDefaultFileOutputStreamC2EPKc, __ZN4FMOD6System11recordStartEiPNS_5SoundEb: __ZN4FMOD6System11recordStartEiPNS_5SoundEb, __ZNK5physx7NpScene17getBroadPhaseTypeEv: __ZNK5physx7NpScene17getBroadPhaseTypeEv, __ZN10HumanTrait14MuscleFromBoneEii: __ZN10HumanTrait14MuscleFromBoneEii, __Z19ClearShadowMapCacheP14ShadowMapCache: __Z19ClearShadowMapCacheP14ShadowMapCache, __ZN5physx14NpShapeManagerC2Ev: __ZN5physx14NpShapeManagerC2Ev, __Z51Register_UnityEngine_Camera_ResetStereoViewMatricesv: __Z51Register_UnityEngine_Camera_ResetStereoViewMatricesv, __ZN5physx3Ext14PrismaticJoint17resolveReferencesERNS_24PxDeserializationContextE: __ZN5physx3Ext14PrismaticJoint17resolveReferencesERNS_24PxDeserializationContextE, __ZN11UnityEngine15CloudWebService16SessionContainer32GetLastModifiedSecondsSinceEpochERK8UnityStr: __ZN11UnityEngine15CloudWebService16SessionContainer32GetLastModifiedSecondsSinceEpochERK8UnityStr, __Z57ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterTypeP12Il2CppObjecti: __Z57ParticleSystem_SubEmittersModule_CUSTOM_GetSubEmitterTypeP12Il2CppObjecti, __Z26SetPolynomialCurveToLinearR17AnimationCurveTplIfER24OptimizedPolynomialCurve: __Z26SetPolynomialCurveToLinearR17AnimationCurveTplIfER24OptimizedPolynomialCurve, __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetColorv: __Z63Register_UnityEngine_ParticleSystem_ColorBySpeedModule_GetColorv, __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE: __ZN5physx7profile10EventValue9streamifyINS0_17EventDeserializerILb1EEEEEvRT_RKNS0_11EventHeaderE, __Z24RegisterStrippedTypeInfoI13RenderTextureEviPKcS2_: __Z24RegisterStrippedTypeInfoI13RenderTextureEviPKcS2_, __ZN13MemoryManager28GetTotalUnusedReservedMemoryEv: __ZN13MemoryManager28GetTotalUnusedReservedMemoryEv, __ZNK5physx20PxsSolverCoreGeneral6solveVEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE: __ZNK5physx20PxsSolverCoreGeneral6solveVEfjjPNS_13PxcSolverBodyEPNS_17PxcSolverBodyDataEjjPNS_25PxcArticulationSolverDescEjPNS_23PxcSolverConstraintDescEjS8_jPNS_2Cm13SpatialVectorE, __ZNK13EmscriptenWWW17GetUploadProgressEv: __ZNK13EmscriptenWWW17GetUploadProgressEv, __ZN4FMOD5Sound11getUserDataEPPv: __ZN4FMOD5Sound11getUserDataEPPv, __Z40AudioSettings_CUSTOM_INTERNAL_CALL_ResetRK27AudioConfigurationScripting: __Z40AudioSettings_CUSTOM_INTERNAL_CALL_ResetRK27AudioConfigurationScripting, __ZN5physx2Cm10FanoutTask7releaseEv: __ZN5physx2Cm10FanoutTask7releaseEv, __Z32Canvas_Get_Custom_PropRootCanvasP12Il2CppObject: __Z32Canvas_Get_Custom_PropRootCanvasP12Il2CppObject, __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadxEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo: __Z35Transfer_Blittable_SingleValueFieldI14SafeBinaryReadxEvRT_R17GeneralMonoObjectRK23StaticTransferFieldInfo, __ZNK14StackAllocatorILj16EE9getHeaderEPv: __ZNK14StackAllocatorILj16EE9getHeaderEPv, __ZN24iPhoneRemoteNotification14GetDeviceTokenEv: __ZN24iPhoneRemoteNotification14GetDeviceTokenEv, __Z60Register_UnityEngine_Object_FindObjectsOfTypeIncludingAssetsv: __Z60Register_UnityEngine_Object_FindObjectsOfTypeIncludingAssetsv, _UNITY_FT_Done_Face: _UNITY_FT_Done_Face, __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_: __ZN5physx6shdfnd5ArrayINS_17PxVehicleTireDataENS0_15InlineAllocatorILj320ENS0_19ReflectionAllocatorIS2_EEEEE6resizeEjRKS2_, __Z11CopyTextureP7TextureS0_: __Z11CopyTextureP7TextureS0_, __ZNK13SliderJoint2D26GetTypeInfoVirtualInternalEv: __ZNK13SliderJoint2D26GetTypeInfoVirtualInternalEv, __Z38ParticleSystem_CUSTOM_Internal_EmitOldP12Il2CppObjectR22ParticleSystemParticle: __Z38ParticleSystem_CUSTOM_Internal_EmitOldP12Il2CppObjectR22ParticleSystemParticle, __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij: __ZN11DynamicMesh10AddPolygonERK13dynamic_arrayI8Vector3fLj4EERKij, __Z24getPxShape_ContactOffsetPKN5physx7PxShapeE: __Z24getPxShape_ContactOffsetPKN5physx7PxShapeE, __ZN6Object33AllocateAndAssignInstanceIDNoLockEPS_: __ZN6Object33AllocateAndAssignInstanceIDNoLockEPS_, __Z62Register_UnityEngine_Connect_UnityConnectSettings_get_testModev: __Z62Register_UnityEngine_Connect_UnityConnectSettings_get_testModev, __ZNK26AnimatorControllerPlayable23GetStateMachineConstantEi: __ZNK26AnimatorControllerPlayable23GetStateMachineConstantEi, __ZNK6Camera20ViewportToWorldPointERK8Vector3f: __ZNK6Camera20ViewportToWorldPointERK8Vector3f, __ZN14ConstantString7cleanupEv: __ZN14ConstantString7cleanupEv, __ZN15DetailPrototypeaSERKS_: __ZN15DetailPrototypeaSERKS_, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKtPNS_16PxRepXSerializerEEEtNS0_4HashItEENS1_11HashMapBaseItS6_S9_NS0_9AllocatorEE6GetKeyESB_Lb1EE5eraseERS4_, __ZN9AudioClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN9AudioClip23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZNK8Animator16IsMatchingTargetEv: __ZNK8Animator16IsMatchingTargetEv, __ZN7mecanim12statemachine26SelectorTransitionConstant8TransferI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine26SelectorTransitionConstant8TransferI14SafeBinaryReadEEvRT_, __ZN5physx7profile19MemoryEventRecorderD2Ev: __ZN5physx7profile19MemoryEventRecorderD2Ev, __Z48Register_UnityEngine_Rigidbody2D_get_angularDragv: __Z48Register_UnityEngine_Rigidbody2D_get_angularDragv, __ZNK24iPhoneRemoteNotification29GetApplicationIconBadgeNumberEv: __ZNK24iPhoneRemoteNotification29GetApplicationIconBadgeNumberEv, __ZNKSt3__210moneypunctIwLb0EE13decimal_pointEv: __ZNKSt3__210moneypunctIwLb0EE13decimal_pointEv, __ZN12_GLOBAL__N_110Connection17getConnectionTypeEv: __ZN12_GLOBAL__N_110Connection17getConnectionTypeEv, __ZN13GfxDeviceGLES15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj: __ZN13GfxDeviceGLES15SetSurfaceFlagsE12ObjectHandleI17RenderSurface_TagP17RenderSurfaceBaseEjj, __ZN38AssetBundleLoadFromCacheAsyncOperation7ExecuteEv: __ZN38AssetBundleLoadFromCacheAsyncOperation7ExecuteEv, __ZN16LightmapSettings8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN16LightmapSettings8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_: __ZNSt3__27__sort3IRPFbN7mecanim9animation13MuscleIndexIdES3_EPS3_EEjT0_S8_S8_T_, __Z32WindZone_Get_Custom_PropWindMainP12Il2CppObject: __Z32WindZone_Get_Custom_PropWindMainP12Il2CppObject, __ZN5physx9PxTaskMgr13decrReferenceERNS_14PxLightCpuTaskE: __ZN5physx9PxTaskMgr13decrReferenceERNS_14PxLightCpuTaskE, __ZN15SerializeTraitsIN18UnityPropertySheet11UnityTexEnvEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_: __ZN15SerializeTraitsIN18UnityPropertySheet11UnityTexEnvEE8TransferI24GenerateTypeTreeTransferEEvRS1_RT_, __ZN5physx26calcForce4_twoWay_onlyPtrsERNS_6shdfnd3aos6Mat44VES3_PNS_16PxsFluidParticleES5_S5_S5_RKS2_S7_RKNS1_5Vec4VERKNS_30PxsFluidDynamicsParametersSIMDE: __ZN5physx26calcForce4_twoWay_onlyPtrsERNS_6shdfnd3aos6Mat44VES3_PNS_16PxsFluidParticleES5_S5_S5_RKS2_S7_RKNS1_5Vec4VERKNS_30PxsFluidDynamicsParametersSIMDE, __ZN11TimeManager27SetMaximumParticleDeltaTimeEf: __ZN11TimeManager27SetMaximumParticleDeltaTimeEf, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_17PxVehicleTireDataEEEEclILj604ES3_jjEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, _wcstof: _wcstof, __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_: __ZNSt3__26__sortIRPFbRK6b2PairS3_EPS1_EEvT0_S8_T_, __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7FrustumENS_12MatrixFormatE: __ZN5Umbra15CameraTransformC2ERKNS_9Matrix4x4ERKNS_7FrustumENS_12MatrixFormatE, __ZN8DateTime14GetDaysInMonthEi: __ZN8DateTime14GetDaysInMonthEi, __ZNSt3__211__stdoutbufIcED0Ev: __ZNSt3__211__stdoutbufIcED0Ev, __Z52Register_UnityEngine_SystemInfo_get_systemMemorySizev: __Z52Register_UnityEngine_SystemInfo_get_systemMemorySizev, _cff_size_init: _cff_size_init, __ZN7Texture20SetMipMapBiasNoDirtyEf: __ZN7Texture20SetMipMapBiasNoDirtyEf, __Z36Texture_CUSTOM_Internal_GetDimensionP12Il2CppObject: __Z36Texture_CUSTOM_Internal_GetDimensionP12Il2CppObject, __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags: __ZN14SafeBinaryRead21TransferSTLStyleArrayI22OffsetPtrArrayTransferI9OffsetPtrIN7mecanim12statemachine13StateConstantEEEEEvRT_17TransferMetaFlags, __ZN10TagManager23GetSortingLayerUniqueIDEi: __ZN10TagManager23GetSortingLayerUniqueIDEi, __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE10insert_oneERKS1_: __ZN13sorted_vectorIN23ShaderVariantCollection11VariantInfoENSt3__24lessIS1_EENS2_9allocatorIS1_EEE10insert_oneERKS1_, __Z51Register_UnityEngine_GUIUtility_get_keyboardControlv: __Z51Register_UnityEngine_GUIUtility_get_keyboardControlv, __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi: __ZN8DrawUtil8DrawMeshERK14ChannelAssignsR4MeshRK10Matrix4x4fi, __ZN8Animator11FixedUpdateEv: __ZN8Animator11FixedUpdateEv, __Z67Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalCreatev: __Z67Register_UnityEngine_Analytics_UnityAnalyticsHandler_InternalCreatev, __Z15UpdateLightsTplILb0EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem: __Z15UpdateLightsTplILb0EEvR4ListI17ParticleLightNodeES3_PK15SharedLightDatabbbRK11MinMaxCurveS9_RK10Matrix4x4fRK23ParticleSystemParticlesRK14ParticleSystem, __ZN5Umbra8QueryExt16queryLocalLightsERNS_9IndexListEjPKNS_11SphereLightEiRKS1_PS6_: __ZN5Umbra8QueryExt16queryLocalLightsERNS_9IndexListEjPKNS_11SphereLightEiRKS1_PS6_, __Z18CreateDecompressor15CompressionType10MemLabelId: __Z18CreateDecompressor15CompressionType10MemLabelId, _getservbyname: _getservbyname, __Z49Register_UnityEngine_LensFlare_INTERNAL_get_colorv: __Z49Register_UnityEngine_LensFlare_INTERNAL_get_colorv, __ZN5physx2Sc8SimStatsC2Ev: __ZN5physx2Sc8SimStatsC2Ev, __ZN5physx3Scb5Scene20processPendingRemoveEv: __ZN5physx3Scb5Scene20processPendingRemoveEv, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_18PxJointLinearLimitEEEEclILj485ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN5physx23solve1D4Block_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi: __ZN5physx23solve1D4Block_WriteBackEPKNS_23PxcSolverConstraintDescEjRNS_16PxcSolverContextEPNS_25PxcThresholdStreamElementEjPi, __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev: __ZNSt3__29basic_iosIcNS_11char_traitsIcEEED2Ev, __Z43Transform_CUSTOM_INTERNAL_set_localRotationP12Il2CppObjectRK11Quaternionf: __Z43Transform_CUSTOM_INTERNAL_set_localRotationP12Il2CppObjectRK11Quaternionf, __ZN2UI14CanvasRenderer12SyncClipRectENS0_8SyncFlagEb: __ZN2UI14CanvasRenderer12SyncClipRectENS0_8SyncFlagEb, __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKw: __ZNSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE7replaceEjjPKw, __Z39SliderJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject: __Z39SliderJoint2D_Get_Custom_PropJointSpeedP12Il2CppObject, __Z36AndroidJNI_CUSTOM_GetStaticLongField13Il2Cpp_IntPtrS_: __Z36AndroidJNI_CUSTOM_GetStaticLongField13Il2Cpp_IntPtrS_, __ZNK19TextRenderingModule10TMGenFlushEv: __ZNK19TextRenderingModule10TMGenFlushEv, __ZN4FMOD7SystemI11isRecordingEiPb: __ZN4FMOD7SystemI11isRecordingEiPb, __ZN16ParticleAnimatorD2Ev: __ZN16ParticleAnimatorD2Ev, __ZN15SerializeTraitsIN7mecanim12statemachine16LeafInfoConstantEE8TransferI14SafeBinaryReadEEvRS2_RT_: __ZN15SerializeTraitsIN7mecanim12statemachine16LeafInfoConstantEE8TransferI14SafeBinaryReadEEvRS2_RT_, _rintl: _rintl, __ZNK11b2EdgeShape11ComputeAABBEP6b2AABBRK11b2Transformib: __ZNK11b2EdgeShape11ComputeAABBEP6b2AABBRK11b2Transformib, __ZN8Playable19PrepareFrameVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv: __ZN8Playable19PrepareFrameVisitorERK9FrameDataPS_S3_P14DirectorPlayeriPv, __Z45CharacterJoint_Get_Custom_PropProjectionAngleP12Il2CppObject: __Z45CharacterJoint_Get_Custom_PropProjectionAngleP12Il2CppObject, __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_: __ZNSt3__26vectorI14AnimationEvent13stl_allocatorIS1_L18MemLabelIdentifier25ELi16EEE6assignIPS1_EENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS1_NS_15iterator_traitsIS9_E9referenceEEE5valueEvE4typeES9_S9_, __ZNK19ShaderPropertySheet24GetFloatValueInsRGBSpaceEi: __ZNK19ShaderPropertySheet24GetFloatValueInsRGBSpaceEi, __ZNKSt3__210moneypunctIcLb0EE13positive_signEv: __ZNKSt3__210moneypunctIcLb0EE13positive_signEv, __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_: __ZN15dense_hashtableINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP11AssetBundleEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EENS0_9allocatorISC_EEE9SelectKeyESH_SJ_E4swapERSM_, __Z57Register_UnityEngine_Animator_GetCurrentAnimatorStateInfov: __Z57Register_UnityEngine_Animator_GetCurrentAnimatorStateInfov, __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_10PxMaterialENS0_15InlineAllocatorILj20ENS0_19ReflectionAllocatorIS3_EEEEE8recreateEj, __ZN15HeightMeshQuery4InitEff: __ZN15HeightMeshQuery4InitEff, __ZNK5physx2Sc13ConstraintSim8isBrokenEv: __ZNK5physx2Sc13ConstraintSim8isBrokenEv, __Z12NHxRoughnessIhEvP9Texture2DPT_iiii: __Z12NHxRoughnessIhEvP9Texture2DPT_iiii, __ZNSt3__227__insertion_sort_incompleteIR29ColliderHitsByDepthComparitorPP10Collider2DEEbT0_S6_T_: __ZNSt3__227__insertion_sort_incompleteIR29ColliderHitsByDepthComparitorPP10Collider2DEEbT0_S6_T_, __ZN20TextRenderingPrivate12GetFallbacksEv: __ZN20TextRenderingPrivate12GetFallbacksEv, __Z47CommandBuffer_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectS0_iS0_iP11Il2CppArrayiS0_: __Z47CommandBuffer_CUSTOM_Internal_DrawMeshInstancedP12Il2CppObjectS0_iS0_iP11Il2CppArrayiS0_, __Z38Matrix4x4_CUSTOM_INTERNAL_CALL_InverseRK10Matrix4x4fRS_: __Z38Matrix4x4_CUSTOM_INTERNAL_CALL_InverseRK10Matrix4x4fRS_, __Z37setPxSceneDescBounceThresholdVelocityPN5physx11PxSceneDescEf: __Z37setPxSceneDescBounceThresholdVelocityPN5physx11PxSceneDescEf, __ZN12SoundManager12AwaitLoadingEPN11SoundHandle8InstanceE: __ZN12SoundManager12AwaitLoadingEPN11SoundHandle8InstanceE, __ZN19SkinnedMeshRenderer17SkinMeshImmediateEv: __ZN19SkinnedMeshRenderer17SkinMeshImmediateEv, _UNITY_png_image_size: _UNITY_png_image_size, __Z39Register_UnityEngine_GameObject_get_tagv: __Z39Register_UnityEngine_GameObject_get_tagv, __ZN12TLSAllocatorI14StackAllocatorE10DeallocateEPv: __ZN12TLSAllocatorI14StackAllocatorE10DeallocateEPv, __ZN15NavMeshSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN15NavMeshSettings23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN18BuoyancyEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN18BuoyancyEffector2D8TransferI24GenerateTypeTreeTransferEEvRT_, __Z32Gizmos_CUSTOM_INTERNAL_get_colorP10ColorRGBAf: __Z32Gizmos_CUSTOM_INTERNAL_get_colorP10ColorRGBAf, __ZNK12GraphicsCaps17CheckGPUSupportedEv: __ZNK12GraphicsCaps17CheckGPUSupportedEv, __Z30VRDevice_Get_Custom_PropFamilyv: __Z30VRDevice_Get_Custom_PropFamilyv, __ZN11UnityEngine9Analytics13UserInfoEventD0Ev: __ZN11UnityEngine9Analytics13UserInfoEventD0Ev, __Z34Animator_Get_Custom_PropLayerCountP12Il2CppObject: __Z34Animator_Get_Custom_PropLayerCountP12Il2CppObject, __ZN10GUITexture16CalculateDrawBoxERK5RectTIfE: __ZN10GUITexture16CalculateDrawBoxERK5RectTIfE, __ZN8Animator20SetupBindingsDataSetEPKN7mecanim9animation18ControllerConstantEPN11UnityEngine9Animation20AnimationSetBindingsERNS_15BindingsDataSetERNS_13AvatarDataSetE: __ZN8Animator20SetupBindingsDataSetEPKN7mecanim9animation18ControllerConstantEPN11UnityEngine9Animation20AnimationSetBindingsERNS_15BindingsDataSetERNS_13AvatarDataSetE, __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN4PPtrI9AudioClipE8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE22getClientBehaviorFlagsEv: __ZNK5physx15NpActorTemplateINS_14PxRigidDynamicEE22getClientBehaviorFlagsEv, __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb1EE21TransferSTLStyleArrayI22OffsetPtrArrayTransferIfEEEvRT_17TransferMetaFlags, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwjj: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE4findEPKwjj, __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj: __ZN5physx6shdfnd8internal8HashBaseINS0_4PairIKPNS_6PxBaseEjEES5_NS0_4HashIS5_EENS1_11HashMapBaseIS5_jS9_NS0_9AllocatorEE6GetKeyESB_Lb1EE15reserveInternalEj, __ZN10GpuProgram22ApplyTextureParametersEPKhR9GfxDevice10ShaderType: __ZN10GpuProgram22ApplyTextureParametersEPKhR9GfxDevice10ShaderType, __ZNK5Umbra6KDTree8getPathsEPji: __ZNK5Umbra6KDTree8getPathsEPji, __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE: __ZNK5physx3Ext5JointINS_12PxFixedJointENS_27PxFixedJointGeneratedValuesEE6getComEPNS_12PxRigidActorE, __ZN6Socket7ConnectEPK8sockaddrjlbb: __ZN6Socket7ConnectEPK8sockaddrjlbb, __Z22Object_CUSTOM_ToStringP12Il2CppObject: __Z22Object_CUSTOM_ToStringP12Il2CppObject, __Z35LensFlare_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf: __Z35LensFlare_CUSTOM_INTERNAL_set_colorP12Il2CppObjectRK10ColorRGBAf, __ZN11MonoManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11MonoManager7PRODUCEE10MemLabelId18ObjectCreationMode, __ZN11AudioSource8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11AudioSource8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj48ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_14PxRigidDynamicEEEEclILj48ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZN9ShaderLab20SerializedSubProgram15MatrixParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei: __ZN9ShaderLab20SerializedSubProgram15MatrixParameterC2ERKNSt3__212basic_stringIcNS2_11char_traitsIcEENS2_9allocatorIcEEEEii15ShaderParamTypei, __ZN19AssetBundleManifest8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN19AssetBundleManifest8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK10GameObject27FindConflictingComponentPtrEi: __ZNK10GameObject27FindConflictingComponentPtrEi, __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj: __ZN5physx19CVariableMemoryPool10AddFreeMemEPhj, __ZN5physx2Sc7BodySim30internalWakeUpArticulationLinkEf: __ZN5physx2Sc7BodySim30internalWakeUpArticulationLinkEf, __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE: __ZNK5physx26PxSerializerDefaultAdapterINS_13NpRigidStaticEE8requiresERNS_6PxBaseERNS_23PxProcessPxBaseCallbackE, __Z23setPxCloth_TetherConfigPN5physx7PxClothERKNS_19PxClothTetherConfigE: __Z23setPxCloth_TetherConfigPN5physx7PxClothERKNS_19PxClothTetherConfigE, __ZN5physx13IslandManagerD2Ev: __ZN5physx13IslandManagerD2Ev, __ZNK5physx19NpArticulationJoint12getChildPoseEv: __ZNK5physx19NpArticulationJoint12getChildPoseEv, __Z27setPxJoint_InvInertiaScale0PN5physx7PxJointEf: __Z27setPxJoint_InvInertiaScale0PN5physx7PxJointEf, __Z43Register_UnityEngine_LightmapSettings_Resetv: __Z43Register_UnityEngine_LightmapSettings_Resetv, __ZN4Tree15ThreadedCleanupEv: __ZN4Tree15ThreadedCleanupEv, __Z51Register_UnityEngine_LineRenderer_set_colorGradientv: __Z51Register_UnityEngine_LineRenderer_set_colorGradientv, __ZN5physx2Sc5Scene18removeArticulationERNS0_16ArticulationCoreE: __ZN5physx2Sc5Scene18removeArticulationERNS0_16ArticulationCoreE, __Z23IntersectSphereTriangleRK6SphereRK8Vector3fS4_S4_: __Z23IntersectSphereTriangleRK6SphereRK8Vector3fS4_S4_, __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_: __ZNK5physx2Gu29EPASupportMapPairRelativeImplINS0_8CapsuleVENS0_11ConvexHullVEE9doSupportERKNS_6shdfnd3aos5Vec3VERS7_SA_SA_, __Z19dtAllocNavMeshQueryPK9dtNavMeshi: __Z19dtAllocNavMeshQueryPK9dtNavMeshi, __Z49ParticleEmitter_CUSTOM_INTERNAL_get_localVelocityP12Il2CppObjectP8Vector3f: __Z49ParticleEmitter_CUSTOM_INTERNAL_get_localVelocityP12Il2CppObjectP8Vector3f, __ZN13RendererScene22RecalculateDirtyBoundsEv: __ZN13RendererScene22RecalculateDirtyBoundsEv, __ZN14PhysicMaterial23GetInstantiatedMaterialEPS_R6Object: __ZN14PhysicMaterial23GetInstantiatedMaterialEPS_R6Object, __ZNK7Cubemap26GetTypeInfoVirtualInternalEv: __ZNK7Cubemap26GetTypeInfoVirtualInternalEv, _gzopen: _gzopen, __Z17AsyncReadWaitDoneP16AsyncReadCommand: __Z17AsyncReadWaitDoneP16AsyncReadCommand, __Z8BuildCapjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfRKNS2_7_float4ERK11ColorRGBA32SA_b: __Z8BuildCapjRP10LineVertexRKN4math8float4x4EPK15LineBuilderDataRKfRKNS2_7_float4ERK11ColorRGBA32SA_b, __ZN21LightProbeProxyVolume17MainThreadCleanupEv: __ZN21LightProbeProxyVolume17MainThreadCleanupEv, __Z4GrayP9Texture2DPhiiii: __Z4GrayP9Texture2DPhiiii, __Z22scripting_array_new_3dP11Il2CppClassjjjj: __Z22scripting_array_new_3dP11Il2CppClassjjjj, __Z53PhysicMaterial_CUSTOM_Internal_CreateDynamicsMaterialP12Il2CppObjectP12Il2CppString: __Z53PhysicMaterial_CUSTOM_Internal_CreateDynamicsMaterialP12Il2CppObjectP12Il2CppString, __Z45TerrainData_CUSTOM_UpgradeScaledTreePrototypeP12Il2CppObject: __Z45TerrainData_CUSTOM_UpgradeScaledTreePrototypeP12Il2CppObject, __ZL26DrawParticlesFromNodeQueueRK15RenderNodeQueuejRK14ChannelAssignsi: __ZL26DrawParticlesFromNodeQueueRK15RenderNodeQueuejRK14ChannelAssignsi, __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE: __ZNKSt3__28time_getIcNS_19istreambuf_iteratorIcNS_11char_traitsIcEEEEE13__get_percentERS4_S4_RjRKNS_5ctypeIcEE, __ZN17ArchiveFileSystem14UnmountArchiveEPKc: __ZN17ArchiveFileSystem14UnmountArchiveEPKc, __ZN5physx2Gu12StoreIndicesEjjPKjRNS_14PxOutputStreamEb: __ZN5physx2Gu12StoreIndicesEjjPKjRNS_14PxOutputStreamEb, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb1E11ColorRGBA32EvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z54Register_UnityEngine_Animation_INTERNAL_CALL_SyncLayerv: __Z54Register_UnityEngine_Animation_INTERNAL_CALL_SyncLayerv, __ZN10Effector2DD0Ev: __ZN10Effector2DD0Ev, __ZN2UI14CanvasRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN2UI14CanvasRenderer23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __Z46RenderSettings_Set_Custom_PropAmbientIntensityf: __Z46RenderSettings_Set_Custom_PropAmbientIntensityf, __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI14TexFormatRHalf18TexFormatRGBAFloatEEvPKNS_9InnerInfoE, __ZN19ParticleSystemState8TransferI17RemapPPtrTransferEEvRT_: __ZN19ParticleSystemState8TransferI17RemapPPtrTransferEEvRT_, __ZNK7Terrain12GetWorldAABBEv: __ZNK7Terrain12GetWorldAABBEv, __Z61Register_UnityEngine_ParticleSystemRenderer_get_trailMaterialv: __Z61Register_UnityEngine_ParticleSystemRenderer_get_trailMaterialv, _TT_Forget_Glyph_Frame: _TT_Forget_Glyph_Frame, __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject: __Z63ParticleSystem_VelocityOverLifetimeModule_CUSTOM_GetZMultiplierP12Il2CppObject, __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb: __ZN5physx3Scb5Scene17removeRigidStaticERNS0_11RigidStaticEbb, __Z78Register_UnityEngine_Experimental_Director_GenericMixerPlayable_InternalCreatev: __Z78Register_UnityEngine_Experimental_Director_GenericMixerPlayable_InternalCreatev, __ZN19CloudServiceHandler7ReleaseEv: __ZN19CloudServiceHandler7ReleaseEv, __ZN17ProfilerFrameDataC2Eii: __ZN17ProfilerFrameDataC2Eii, __Z41WebCamTexture_Set_Custom_PropRequestedFPSP12Il2CppObjectf: __Z41WebCamTexture_Set_Custom_PropRequestedFPSP12Il2CppObjectf, __ZNK21AssetBundleFileSystem5IsDirERK13FileEntryData: __ZNK21AssetBundleFileSystem5IsDirERK13FileEntryData, __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev: __ZN5physx43PxVehicleAckermannGeometryDataGeneratedInfoC2Ev, __Z35TextMesh_Get_Custom_PropLineSpacingP12Il2CppObject: __Z35TextMesh_Get_Custom_PropLineSpacingP12Il2CppObject, __ZN9ShaderLab15PushParserStateEPNS_21SerializedShaderStateE: __ZN9ShaderLab15PushParserStateEPNS_21SerializedShaderStateE, __Z27getPxD6JointDriveForceLimitPKN5physx14PxD6JointDriveE: __Z27getPxD6JointDriveForceLimitPKN5physx14PxD6JointDriveE, __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE: __ZN5physx16PxsIslandManager16setEdgeConnectedERKNS_20PxsIslandManagerHookIjLj4294967295EEE, __ZN23ArchiveStorageConverterD2Ev: __ZN23ArchiveStorageConverterD2Ev, __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_: __ZNSt3__27__sort5IRNS_4lessIiEEPiEEjT0_S5_S5_S5_S5_T_, _cf2_glyphpath_pushPrevElem: _cf2_glyphpath_pushPrevElem, __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE: __ZN2UI13CanvasManager19RemoveDirtyRendererEPNS_6CanvasEPNS_14CanvasRendererE, __ZN5physx22PxDefaultFileInputData4readEPvj: __ZN5physx22PxDefaultFileInputData4readEPvj, __Z34CubemapArray_Get_Custom_PropFormatP12Il2CppObject: __Z34CubemapArray_Get_Custom_PropFormatP12Il2CppObject, __ZN7mecanim9animation19Blend2dDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN7mecanim9animation19Blend2dDataConstant8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv: __ZN20TextRenderingPrivate17TextMeshGenerator5FlushEv, __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE: __ZNSt3__26__treeINS_12__value_typeI9TextureID21SparseTextureInfoGLESEENS_19__map_value_compareIS2_S4_NS_4lessIS2_EELb1EEENS_9allocatorIS4_EEE7destroyEPNS_11__tree_nodeIS4_PvEE, __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi: __ZN23TextDOMTransferReadBaseI8JSONReadE12PushMetaFlagEi, __ZNK5physx2Cm12RenderBuffer12getTrianglesEv: __ZNK5physx2Cm12RenderBuffer12getTrianglesEv, _pshinter_get_t2_funcs: _pshinter_get_t2_funcs, __ZN15RelativeJoint2D8TransferI14SafeBinaryReadEEvRT_: __ZN15RelativeJoint2D8TransferI14SafeBinaryReadEEvRT_, __ZN10GameObject23InvokeDestroyedCallbackEPS_: __ZN10GameObject23InvokeDestroyedCallbackEPS_, __ZN5Unity10HingeJoint11SetUseMotorEb: __ZN5Unity10HingeJoint11SetUseMotorEb, __ZN2UI14CanvasRenderer32DirtySyncTypeFlagPreservingBatchEt: __ZN2UI14CanvasRenderer32DirtySyncTypeFlagPreservingBatchEt, __ZN16CircleCollider2D8TransferI14SafeBinaryReadEEvRT_: __ZN16CircleCollider2D8TransferI14SafeBinaryReadEEvRT_, __ZN8Material15ThreadedCleanupEv: __ZN8Material15ThreadedCleanupEv, __ZNK5Umbra14TomeCollection9getBoundsERNS_7Vector3ES2_: __ZNK5Umbra14TomeCollection9getBoundsERNS_7Vector3ES2_, __ZN17ArchiveFileSystem4ReadER13FileEntryDatayPvPy: __ZN17ArchiveFileSystem4ReadER13FileEntryDatayPvPy, __ZN5physx21PxShapeRepXSerializerD0Ev: __ZN5physx21PxShapeRepXSerializerD0Ev, __ZN11UnityEngine15CloudWebService19SessionEventManager5PauseEb: __ZN11UnityEngine15CloudWebService19SessionEventManager5PauseEb, __ZN5physx9PxTaskMgr16setSpuDispatcherERNS_15PxSpuDispatcherE: __ZN5physx9PxTaskMgr16setSpuDispatcherERNS_15PxSpuDispatcherE, __ZNK5physx12NpBatchQuery18getPreFilterShaderEv: __ZNK5physx12NpBatchQuery18getPreFilterShaderEv, __Z51LightProbeProxyVolume_Get_Custom_PropResolutionModeP12Il2CppObject: __Z51LightProbeProxyVolume_Get_Custom_PropResolutionModeP12Il2CppObject, __ZN17PolygonCollider2D14CreateInternalEP11Rigidbody2D: __ZN17PolygonCollider2D14CreateInternalEP11Rigidbody2D, __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder: __Z23ConvertCacheToBuildKeysIfEvRN17AnimationCurveTplIT_E5CacheEiP19StreamedClipBuilder, __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_: __ZNSt3__26vectorI4PPtrI23ShaderVariantCollectionE13stl_allocatorIS3_L18MemLabelIdentifier52ELi16EEE6assignINS_11__wrap_iterIPS3_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS3_NS_15iterator_traitsISD_E9referenceEEE5valueEvE4typeESD_SD_, __ZN6Socket8SetErrorEi: __ZN6Socket8SetErrorEi, __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE: __ZN5Unity12PhysicsQuery22OverlapCapsuleInternalERK8Vector3fS3_fi23QueryTriggerInteractionRN5physx13PxHitCallbackINS5_12PxOverlapHitEEE, __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf: __ZN5physx2Gu19getCapsuleTransformERKNS0_7CapsuleERf, __ZN20TextRenderingPrivate8TextMeshD2Ev: __ZN20TextRenderingPrivate8TextMeshD2Ev, __Z36BillboardAsset_Set_Custom_PropHeightP12Il2CppObjectf: __Z36BillboardAsset_Set_Custom_PropHeightP12Il2CppObjectf, __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv: __ZN11UnityEngine15PlatformWrapper25GetGraphicsRendererStringEv, __ZN20SpeedTreeWindManager8TickWindER18SpeedTreeWindTimesRP18SpeedTreeLocalWindRK4AABBRK18SpeedTreeWindAsset: __ZN20SpeedTreeWindManager8TickWindER18SpeedTreeWindTimesRP18SpeedTreeLocalWindRK4AABBRK18SpeedTreeWindAsset, __ZN6Skybox12RenderSkyboxEP8MaterialRK6Camera: __ZN6Skybox12RenderSkyboxEP8MaterialRK6Camera, __ZN15ReflectionProbe13SetImportanceEs: __ZN15ReflectionProbe13SetImportanceEs, __ZN15TerrainRendererD2Ev: __ZN15TerrainRendererD2Ev, __Z10GetLocalIPv: __Z10GetLocalIPv, __Z37Register_UnityEngine_WWW_get_progressv: __Z37Register_UnityEngine_WWW_get_progressv, __ZN11Rigidbody2D11SetSleepingEb: __ZN11Rigidbody2D11SetSleepingEb, __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b: __ZN12HeaderHelper3SetERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEES8_b, __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE: __ZNSt3__26__treeINS_12__value_typeI8UnityStrN11AssetBundle9AssetInfoEEENS_19__map_value_compareIS2_S5_NS_4lessIS2_EELb1EEENS_9allocatorIS5_EEE16__construct_nodeERKNS_4pairIKS2_S4_EE, __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf: __ZN5physx2Sc16ArticulationCore22setWakeCounterInternalEf, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayI13dynamic_arrayI8BitFieldLj4EEEEvRT_17TransferMetaFlags, __Z41SphereCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f: __Z41SphereCollider_CUSTOM_INTERNAL_get_centerP12Il2CppObjectP8Vector3f, __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb: __ZN8JSONRead8TransferIjEEvRT_PKc17TransferMetaFlagsb, __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIN12_GLOBAL__N_126BrokenConstraintReportDataENS0_15InlineAllocatorILj512ENS0_13TempAllocatorEEEE8recreateEj, __ZN15ReflectionProbe19ClearRenderTexturesEv: __ZN15ReflectionProbe19ClearRenderTexturesEv, __ZNK5physx3Cct13BoxController17getHalfSideExtentEv: __ZNK5physx3Cct13BoxController17getHalfSideExtentEv, __ZN24GenerateTypeTreeTransfer8TransferI11DetailPatchEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferI11DetailPatchEEvRT_PKc17TransferMetaFlags, __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_: __ZNSt3__26vectorI13dynamic_arrayI8Vector3fLj4EE13stl_allocatorIS3_L18MemLabelIdentifier1ELi16EEE21__push_back_slow_pathIKS3_EEvRT_, __ZdaPvRK10MemLabelIdiPKcS4_S4_i: __ZdaPvRK10MemLabelIdiPKcS4_S4_i, __ZNK16BaseVideoTexture25IsVideoVerticallyMirroredEv: __ZNK16BaseVideoTexture25IsVideoVerticallyMirroredEv, __Z23TransferScriptingObjectI8JSONReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache: __Z23TransferScriptingObjectI8JSONReadEvRT_P12Il2CppObjectP11Il2CppClassPK15MonoScriptCache, __ZN22MemoryCacherReadBlocks11GetPathNameEv: __ZN22MemoryCacherReadBlocks11GetPathNameEv, __ZN13ProbeRendererC2Ev: __ZN13ProbeRendererC2Ev, __ZN5physx2Gu25PersistentContactManifold20reduceBatchContacts2EPKNS0_17PersistentContactEj: __ZN5physx2Gu25PersistentContactManifold20reduceBatchContacts2EPKNS0_17PersistentContactEj, _UNITY_FT_Glyph_To_Bitmap: _UNITY_FT_Glyph_To_Bitmap, __ZL19SweepCapsuleUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE: __ZL19SweepCapsuleUserBoxPKN5physx3Cct9SweepTestEPKNS0_11SweptVolumeEPKNS0_11TouchedGeomERKNS_14PxExtendedVec3ERKNS_6PxVec3ERNS0_12SweptContactE, __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN5Unity10HingeJoint8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZNK5physx7NpScene29getMaxNbContactDataBlocksUsedEv: __ZNK5physx7NpScene29getMaxNbContactDataBlocksUsedEv, __ZN10Collider2D12CleanupClassEv: __ZN10Collider2D12CleanupClassEv, __Z36BillboardAsset_Set_Custom_PropBottomP12Il2CppObjectf: __Z36BillboardAsset_Set_Custom_PropBottomP12Il2CppObjectf, __Z55Register_UnityEngine_Animator_INTERNAL_set_rootRotationv: __Z55Register_UnityEngine_Animator_INTERNAL_set_rootRotationv, __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2: __Z14SetSHConstantsR13BatchRendererRK20SphericalHarmonicsL2, __Z50Register_UnityEngine_ParticleSystem_get_randomSeedv: __Z50Register_UnityEngine_ParticleSystem_get_randomSeedv, __Z52Register_UnityEngine_FixedJoint2D_get_referenceAnglev: __Z52Register_UnityEngine_FixedJoint2D_get_referenceAnglev, __ZN9JSONWrite8TransferI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_PKc17TransferMetaFlags: __ZN9JSONWrite8TransferI13dynamic_arrayI11KeyframeTplIfELj4EEEEvRT_PKc17TransferMetaFlags, __ZN5physx2Sc7BodySim22postSetKinematicTargetEv: __ZN5physx2Sc7BodySim22postSetKinematicTargetEv, __Z6b2FreePv: __Z6b2FreePv, __ZN13MonoBehaviour11FixedUpdateEv: __ZN13MonoBehaviour11FixedUpdateEv, __Z29Avatar_Get_Custom_PropIsHumanP12Il2CppObject: __Z29Avatar_Get_Custom_PropIsHumanP12Il2CppObject, __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_: __ZNSt3__26vectorIh13stl_allocatorIhL18MemLabelIdentifier14ELi16EEE6assignINS_11__wrap_iterIPhEEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIhNS_15iterator_traitsISA_E9referenceEEE5valueEvE4typeESA_SA_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE10getDampingEv, __ZN10GUIManager28GetDidGUIWindowsEatLastEventEi: __ZN10GUIManager28GetDidGUIWindowsEatLastEventEi, __ZN20BaseBehaviourManager12CommonUpdateI20LateBehaviourManagerEEvv: __ZN20BaseBehaviourManager12CommonUpdateI20LateBehaviourManagerEEvv, __ZN9Texture3D11SetPixels32EiPK11ColorRGBA32i: __ZN9Texture3D11SetPixels32EiPK11ColorRGBA32i, __ZN5Umbra15MemOutputStreamC2EPNS_9AllocatorE: __ZN5Umbra15MemOutputStreamC2EPNS_9AllocatorE, __ZN8RendererD0Ev: __ZN8RendererD0Ev, __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE: __ZNSt3__215basic_stringbufIcNS_11char_traitsIcEENS_9allocatorIcEEE3strERKNS_12basic_stringIcS2_S4_EE, _UNITY_FT_Outline_Check: _UNITY_FT_Outline_Check, __ZNK8Material8FindPassERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZNK8Material8FindPassERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __ZN14SubstanceValue8TransferI14SafeBinaryReadEEvRT_: __ZN14SubstanceValue8TransferI14SafeBinaryReadEEvRT_, __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv: __ZNK5physx5cloth9ClothImplINS0_7SwClothEE24getSelfCollisionDistanceEv, __ZNK12AudioManager16GetListenerPauseEv: __ZNK12AudioManager16GetListenerPauseEv, __ZN5physx3Ext10FixedJointD0Ev: __ZN5physx3Ext10FixedJointD0Ev, __Z63Register_UnityEngine_Rendering_CommandBuffer_ReleaseTemporaryRTv: __Z63Register_UnityEngine_Rendering_CommandBuffer_ReleaseTemporaryRTv, __ZN7mecanim10ValueArray8TransferI8BlobSizeEEvRT_: __ZN7mecanim10ValueArray8TransferI8BlobSizeEEvRT_, __ZNK16MemoryFileSystem9CanHandleEPKc: __ZNK16MemoryFileSystem9CanHandleEPKc, __ZN5physx2Sc9ClothCore21setDampingCoefficientENS_6PxVec3E: __ZN5physx2Sc9ClothCore21setDampingCoefficientENS_6PxVec3E, __Z45Register_UnityEngine_AudioSource_set_priorityv: __Z45Register_UnityEngine_AudioSource_set_priorityv, __ZN5Umbra6DoubleC2Ej: __ZN5Umbra6DoubleC2Ej, __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_get_rndForcev: __Z59Register_UnityEngine_ParticleAnimator_INTERNAL_get_rndForcev, __ZNK19TouchPhaseEmulation19IsMultiTouchEnabledEv: __ZNK19TouchPhaseEmulation19IsMultiTouchEnabledEv, __ZN10AtomicList5ResetEP10AtomicNodei: __ZN10AtomicList5ResetEP10AtomicNodei, __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E5eraseERS4_: __ZN15dense_hashtableINSt3__24pairIKP29AssetBundleLoadAssetOperationbEES3_N18AssetBundleManager11HashFunctorEN14dense_hash_mapIS3_bS7_NS0_8equal_toIS3_EENS0_9allocatorIS5_EEE9SelectKeyESA_SC_E5eraseERS4_, __Z56RaycastHit_CUSTOM_INTERNAL_CALL_CalculateRaycastTexCoordP13Vector2fIcallP12Il2CppObjectRKS_RK8Vector3fii: __Z56RaycastHit_CUSTOM_INTERNAL_CALL_CalculateRaycastTexCoordP13Vector2fIcallP12Il2CppObjectRKS_RK8Vector3fii, __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS4_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_: __ZNSt3__26vectorI4PPtrIN13TextRendering4FontEE13stl_allocatorIS4_L18MemLabelIdentifier34ELi16EEE6assignINS_11__wrap_iterIPS4_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS4_NS_15iterator_traitsISE_E9referenceEEE5valueEvE4typeESE_SE_, __Z42Application_Set_Custom_PropTargetFrameRatei: __Z42Application_Set_Custom_PropTargetFrameRatei, __ZNK8VRDevice20ResetCompositorLayerEv: __ZNK8VRDevice20ResetCompositorLayerEv, __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv: __ZNK5physx2Cm12DelegateTaskINS_2Sc5SceneEXadL_ZNS3_15postNarrowPhaseEPNS_10PxBaseTaskEEEE7getNameEv, __ZN18AnimatorController52OnInvalidateAnimatorControllerAndRebuildDependenciesEv: __ZN18AnimatorController52OnInvalidateAnimatorControllerAndRebuildDependenciesEv, __ZL25CalculateCurveRangesValueRKN4math7_float2ERK17AnimationCurveTplIfE: __ZL25CalculateCurveRangesValueRKN4math7_float2ERK17AnimationCurveTplIfE, __ZN16BaseVideoTexture13AwakeFromLoadE17AwakeFromLoadMode: __ZN16BaseVideoTexture13AwakeFromLoadE17AwakeFromLoadMode, __ZN21WorldParticleColliderC2E10MemLabelId18ObjectCreationMode: __ZN21WorldParticleColliderC2E10MemLabelId18ObjectCreationMode, __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags: __Z24TransferPPtrToMonoObjectiP11Il2CppClassP23DataToCreateNullWrapper24TransferInstructionFlags, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj498ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_23PxJointAngularLimitPairEEEEclILj498ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI21BoxTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_: __ZNK5physx2Gu15HeightFieldUtil12traceSegmentI21BoxTraceSegmentReportLb0ELb0ELb1EEEvRKNS_6PxVec3ES6_PT_PS5_, __Z58Register_UnityEngine_Networking_DownloadHandler_get_isDonev: __Z58Register_UnityEngine_Networking_DownloadHandler_get_isDonev, __ZN6Socket4SendEPKvjP12SendUserData: __ZN6Socket4SendEPKvjP12SendUserData, ___stdio_read: ___stdio_read, __ZN19RingbufferTemplates23PeekValueFromRingBufferIi17GrowingRingbufferEEbRT0_RPKT_: __ZN19RingbufferTemplates23PeekValueFromRingBufferIi17GrowingRingbufferEEbRT0_RPKT_, __ZN9Animation17SampleDefaultClipEd: __ZN9Animation17SampleDefaultClipEd, _ft_smooth_get_cbox: _ft_smooth_get_cbox, __Z47WebCamTexture_Get_Custom_PropDidUpdateThisFrameP12Il2CppObject: __Z47WebCamTexture_Get_Custom_PropDidUpdateThisFrameP12Il2CppObject, __Z41NavMeshAgent_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f: __Z41NavMeshAgent_CUSTOM_INTERNAL_get_velocityP12Il2CppObjectP8Vector3f, __ZN15EditorExtensionD0Ev: __ZN15EditorExtensionD0Ev, __ZN21LinearCollectionField26GetSizeFieldFromListObjectEv: __ZN21LinearCollectionField26GetSizeFieldFromListObjectEv, __ZN16SpriteRenderData14RecalculateUVsER13dynamic_arrayI12SpriteVertexLj4EER9Texture2DRK8Vector2fRK5RectTIfERK8Vector4fSC_S8_21SpritePackingRotation: __ZN16SpriteRenderData14RecalculateUVsER13dynamic_arrayI12SpriteVertexLj4EER9Texture2DRK8Vector2fRK5RectTIfERK8Vector4fSC_S8_21SpritePackingRotation, __ZN5physx22PxVehicleWheelsSimData4copyERKS0_jj: __ZN5physx22PxVehicleWheelsSimData4copyERKS0_jj, __ZNK10MonoScript26GetTypeInfoVirtualInternalEv: __ZNK10MonoScript26GetTypeInfoVirtualInternalEv, __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext: __Z28SetupVertexLightShaderParamsiPK14GfxVertexLightR17ShaderPassContext, __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj: __ZN5physx2Gu25closestPtPointTetrahedronEPNS_6shdfnd3aos5Vec3VES4_S4_Rj, __ZN5physx2Sc21ArticulationJointCore20setTwistLimitEnabledEb: __ZN5physx2Sc21ArticulationJointCore20setTwistLimitEnabledEb, __ZN8Animator21SetHintWeightPositionEif: __ZN8Animator21SetHintWeightPositionEif, __ZL33InitializePhysicsScriptingClassesv: __ZL33InitializePhysicsScriptingClassesv, __ZN37AssetBundleLoadFromFileAsyncOperation7ExecuteEv: __ZN37AssetBundleLoadFromFileAsyncOperation7ExecuteEv, __ZN5physx2Sc9ShapeCore15exportExtraDataERNS_22PxSerializationContextE: __ZN5physx2Sc9ShapeCore15exportExtraDataERNS_22PxSerializationContextE, __ZN5physx2Gu17RadixSortBufferedC2Ev: __ZN5physx2Gu17RadixSortBufferedC2Ev, __ZN5physx2Gu27checkOverlapOBB_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE: __ZN5physx2Gu27checkOverlapOBB_capsuleGeomERKNS_10PxGeometryERKNS_11PxTransformERKNS0_3BoxE, __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE: __ZNSt3__26__treeIPFvP11Il2CppClassR23CachedSerializationDataRbENS_4lessIS7_EENS_9allocatorIS7_EEE7destroyEPNS_11__tree_nodeIS7_PvEE, __ZN13GfxDeviceGLES14GetFramebufferEv: __ZN13GfxDeviceGLES14GetFramebufferEv, __ZN8Collider10SetEnabledEb: __ZN8Collider10SetEnabledEb, __Z57Register_UnityEngine_AI_NavMeshAgent_get_stoppingDistancev: __Z57Register_UnityEngine_AI_NavMeshAgent_get_stoppingDistancev, __ZNK15PointEffector2D16UseContactUpdateEv: __ZNK15PointEffector2D16UseContactUpdateEv, __ZN8LODGroup16CheckConsistencyEv: __ZN8LODGroup16CheckConsistencyEv, __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf: __Z18SetImagePixelBlockPhii13TextureFormatiiiiiPK10ColorRGBAf, __ZN5Umbra4Math4asinENS_5FloatE: __ZN5Umbra4Math4asinENS_5FloatE, __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb: __Z19UpdateProceduralTplILb1EEvRK22DualMinMax3DPolyCurvesS2_R23ParticleSystemParticlesRKN4math8float3x3Eb, __Z42VRSettings_Get_Custom_PropLoadedDeviceNamev: __Z42VRSettings_Get_Custom_PropLoadedDeviceNamev, __ZN12_GLOBAL__N_116MetaDataProvider6unlockEv: __ZN12_GLOBAL__N_116MetaDataProvider6unlockEv, __ZN17PolygonCollider2D11RefreshPolyEv: __ZN17PolygonCollider2D11RefreshPolyEv, __ZN11UnityEngine7Connect13ConnectConfig14GroupingConfig11ResetValuesEv: __ZN11UnityEngine7Connect13ConnectConfig14GroupingConfig11ResetValuesEv, __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_: __ZN11MinMaxCurve8TransferI18StreamedBinaryReadILb0EEEEvRT_, __ZN5physx2Gu5RTree7releaseEv: __ZN5physx2Gu5RTree7releaseEv, __ZN18PlatformEffector2D15ThreadedCleanupEv: __ZN18PlatformEffector2D15ThreadedCleanupEv, __ZNK5physx28PxParticleFluidGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j: __ZNK5physx28PxParticleFluidGeneratedInfo23visitInstancePropertiesINS_18RepXPropertyFilterINS_2Sn17RepXVisitorWriterINS_15PxParticleFluidEEEEEEEjT_j, __ZN11UnityEngine7Connect13ConnectConfig8RegisterERNS0_13ConfigHandlerE: __ZN11UnityEngine7Connect13ConnectConfig8RegisterERNS0_13ConfigHandlerE, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj660ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_21PxVehicleDriveDynDataEEEEclILj660ES3_ffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __Z26scripting_method_get_class21ScriptingMethodIl2Cpp: __Z26scripting_method_get_class21ScriptingMethodIl2Cpp, _jpeg_destroy: _jpeg_destroy, __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_PKc17TransferMetaFlags: __ZN24GenerateTypeTreeTransfer8TransferINSt3__26vectorIN4core12basic_stringIcNS3_20StringStorageDefaultIcEEEENS1_9allocatorIS7_EEEEEEvRT_PKc17TransferMetaFlags, __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_: __ZN14UnityAnalytics11TransactionERK8UnityStrdS2_, __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf14TexFormatRHalfEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRGHalf14TexFormatRHalfEEvPKNS_9InnerInfoE, __ZN17UniqueIDGenerator17DestroyAllIndicesEv: __ZN17UniqueIDGenerator17DestroyAllIndicesEv, __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv: __ZNK21UnityDefaultAllocatorI17LowLevelAllocatorE10GetPtrSizeEPKv, __ZN12WheelJoint2D11SetUseMotorEb: __ZN12WheelJoint2D11SetUseMotorEb, __Z49AudioReverbFilter_Get_Custom_PropReflectionsLevelP12Il2CppObject: __Z49AudioReverbFilter_Get_Custom_PropReflectionsLevelP12Il2CppObject, _sift: _sift, __ZNK13TranslateGLES23VertexArrayTypeBitfieldE19VertexChannelFormat: __ZNK13TranslateGLES23VertexArrayTypeBitfieldE19VertexChannelFormat, __ZN8Animator12StopPlaybackEv: __ZN8Animator12StopPlaybackEv, __Z13RegisterClassIN20TextRenderingPrivate7GUITextEEvv: __Z13RegisterClassIN20TextRenderingPrivate7GUITextEEvv, __ZN11UnityEngine7Connect14RemoteSettings8RegisterEPNS0_13ConfigHandlerE: __ZN11UnityEngine7Connect14RemoteSettings8RegisterEPNS0_13ConfigHandlerE, __Z49SystemInfo_Get_Custom_PropSupportsRenderToCubemapv: __Z49SystemInfo_Get_Custom_PropSupportsRenderToCubemapv, __Z72Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedMultiplierv: __Z72Register_UnityEngine_ParticleSystem_NoiseModule_SetScrollSpeedMultiplierv, __ZN15UnityWebRequestD2Ev: __ZN15UnityWebRequestD2Ev, _ether_ntohost: _ether_ntohost, __ZN5physx13PxDiagonalizeERKNS_7PxMat33ERNS_6PxQuatE: __ZN5physx13PxDiagonalizeERKNS_7PxMat33ERNS_6PxQuatE, __Z38SurfaceEffector2D_Set_Custom_PropSpeedP12Il2CppObjectf: __Z38SurfaceEffector2D_Set_Custom_PropSpeedP12Il2CppObjectf, __ZN9LensFlare8TransferI24GenerateTypeTreeTransferEEvRT_: __ZN9LensFlare8TransferI24GenerateTypeTreeTransferEEvRT_, __ZNK5physx16PxsBroadPhaseMBP7getTypeEv: __ZNK5physx16PxsBroadPhaseMBP7getTypeEv, _UNITY_FT_Outline_Done_Internal: _UNITY_FT_Outline_Done_Internal, __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission: __ZN10MemoryFileC2E10MemLabelIdP14MemoryFileData14FilePermission, __ZN5physx2Sc9ShapeCore24resolveMaterialReferenceEjt: __ZN5physx2Sc9ShapeCore24resolveMaterialReferenceEjt, __ZN7mecanim5human15HumanPoseWeightERNS0_9HumanPoseERKS1_f: __ZN7mecanim5human15HumanPoseWeightERNS0_9HumanPoseERKS1_f, __ZNSt3__215__time_get_tempIwED0Ev: __ZNSt3__215__time_get_tempIwED0Ev, __Z44Register_UnityEngine_GUI_Internal_GetTooltipv: __Z44Register_UnityEngine_GUI_Internal_GetTooltipv, __ZN18AudioMixerSnapshot23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN18AudioMixerSnapshot23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN4FMOD7Channel8getDelayE14FMOD_DELAYTYPEPjS2_: __ZN4FMOD7Channel8getDelayE14FMOD_DELAYTYPEPjS2_, __ZN10SizeModule8TransferI14SafeBinaryReadEEvRT_: __ZN10SizeModule8TransferI14SafeBinaryReadEEvRT_, __ZN8Renderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer: __ZN8Renderer23VirtualRedirectTransferER24GenerateTypeTreeTransfer, __ZN15NavMeshObstacle8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN15NavMeshObstacle8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN16ReflectionProbes12PresentProbeEP15ReflectionProbe: __ZN16ReflectionProbes12PresentProbeEP15ReflectionProbe, __ZN15TerrainColliderD2Ev: __ZN15TerrainColliderD2Ev, __ZN11Rigidbody2D16CheckConsistencyEv: __ZN11Rigidbody2D16CheckConsistencyEv, __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb1EE: __ZN7Terrain23VirtualRedirectTransferER18StreamedBinaryReadILb1EE, __Z56Register_UnityEngine_Animator_set_layersAffectMassCenterv: __Z56Register_UnityEngine_Animator_set_layersAffectMassCenterv, __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN9Behaviour23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __Z36getPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataEj: __Z36getPxVehicleDriveDynData_AnalogInputPKN5physx21PxVehicleDriveDynDataEj, _UNITY_LZ4_compress_limitedOutput_continue: _UNITY_LZ4_compress_limitedOutput_continue, __ZN5physx2Sq12AABBTreeNode9subdivideERKNS_9PxBounds3EPNS0_15AABBTreeBuilderEPj: __ZN5physx2Sq12AABBTreeNode9subdivideERKNS_9PxBounds3EPNS0_15AABBTreeBuilderEPj, __Z47ConfigurableJoint_Get_Custom_PropAngularZMotionP12Il2CppObject: __Z47ConfigurableJoint_Get_Custom_PropAngularZMotionP12Il2CppObject, _ether_aton_r: _ether_aton_r, __ZN13ScreenManager18RequestOrientationE17ScreenOrientation: __ZN13ScreenManager18RequestOrientationE17ScreenOrientation, __Z51AnimatorControllerPlayable_CUSTOM_CrossFadeInternalR9HPlayableifif: __Z51AnimatorControllerPlayable_CUSTOM_CrossFadeInternalR9HPlayableifif, __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __Z27DeleteLastPathNameComponentRKNSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb1EEEEvRT_: __ZN14SubstanceValue8TransferI18StreamedBinaryReadILb1EEEEvRT_, __ZN5physx2Sq17SceneQueryManagerC2ERNS_3Scb5SceneERKNS_11PxSceneDescE: __ZN5physx2Sq17SceneQueryManagerC2ERNS_3Scb5SceneERKNS_11PxSceneDescE, __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_: __ZN5physx2Sn21RepXVisitorReaderBaseINS_9PxD6JointEE14simplePropertyIKNS_22PxRepXPropertyAccessorILj434ES2_RKNS_11PxTransformES6_EEEEvjRT_, __ZN12TreeRenderer11RenderBatchER14TreeBinaryTreef: __ZN12TreeRenderer11RenderBatchER14TreeBinaryTreef, __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority: __Z31ScheduleDifferentJobsConcurrentR8JobFencePK3Jobi11JobPriority, __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE: __ZNK12_GLOBAL__N_126PvdObjectModelMetaDataImpl13findClassImplERKN5physx8debugger14NamespacedNameE, __ZN13PhysicsModule31GetColliderSharedMeshInstanceIDER12MeshCollider: __ZN13PhysicsModule31GetColliderSharedMeshInstanceIDER12MeshCollider, __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb: __ZN5physx2Sc9ClothCore12setClothFlagENS_11PxClothFlag4EnumEb, __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitSpringv: __Z69Register_UnityEngine_ConfigurableJoint_INTERNAL_set_linearLimitSpringv, __Z58Register_UnityEngine_Caching_get_maximumAvailableDiskSpacev: __Z58Register_UnityEngine_Caching_get_maximumAvailableDiskSpacev, __Z25getPxJointLimitConeYAnglePKN5physx16PxJointLimitConeE: __Z25getPxJointLimitConeYAnglePKN5physx16PxJointLimitConeE, __ZN5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE: __ZN5physx5cloth8SwSolver8simulateEfRNS_10PxBaseTaskE, __ZN24UserAuthorizationManager24RequestUserAuthorizationEi: __ZN24UserAuthorizationManager24RequestUserAuthorizationEi, __ZN9TextAsset9SetScriptERK8UnityStrb: __ZN9TextAsset9SetScriptERK8UnityStrb, __ZN17AudioReverbFilterD2Ev: __ZN17AudioReverbFilterD2Ev, _scalbf: _scalbf, __ZN2UI11CanvasGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE: __ZN2UI11CanvasGroup23VirtualRedirectTransferER19StreamedBinaryWriteILb0EE, __ZN13GfxDeviceGLES14GetPresentModeEv: __ZN13GfxDeviceGLES14GetPresentModeEv, __ZNK16BaseVideoTexture21GetVideoRotationAngleEv: __ZNK16BaseVideoTexture21GetVideoRotationAngleEv, __ZN5Umbra16TileTraverseTree4nextERi: __ZN5Umbra16TileTraverseTree4nextERi, __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv: __ZN5physx6shdfnd8PoolBaseINS_2Sc24ElementInteractionMarkerENS0_19ReflectionAllocatorIS3_EEE17releaseEmptySlabsEv, __ZN22UnityProfilerPerThreadD2Ev: __ZN22UnityProfilerPerThreadD2Ev, __ZNK8Collider26GetTypeInfoVirtualInternalEv: __ZNK8Collider26GetTypeInfoVirtualInternalEv, __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getWorldBoundsEf: __ZNK5physx20NpRigidActorTemplateINS_18PxArticulationLinkEE14getWorldBoundsEf, __ZN10GUIManager14InitGUIManagerEv: __ZN10GUIManager14InitGUIManagerEv, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_12PxFixedJointEEEE14handleAccessorILj417ENS_22PxRepXPropertyAccessorILj417ENS_7PxJointEffEEEEvRKT0_, __ZN5physx24PxcPCMContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx24PxcPCMContactPlaneConvexERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZThn32_N12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData: __ZThn32_N12LineRenderer15AddAsRenderNodeER15RenderNodeQueueRK20DeprecatedSourceData, __Z8XORCryptPKvjS0_jPv: __Z8XORCryptPKvjS0_jPv, _UNITY_FT_Stream_ExtractFrame: _UNITY_FT_Stream_ExtractFrame, __ZN5physx3Ext17computeSphereMassEff: __ZN5physx3Ext17computeSphereMassEff, __ZNK13WheelCollider24FindNewAttachedRigidbodyEPK9Rigidbodyb: __ZNK13WheelCollider24FindNewAttachedRigidbodyEPK9Rigidbodyb, __ZN38StateMachineBehaviourVectorDescription8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN38StateMachineBehaviourVectorDescription8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __ZN7mecanim12statemachine19EvaluateTransitionsERK9OffsetPtrIS1_INS0_18TransitionConstantEEEjRNS0_15TransitionInputERNS0_16TransitionOutputERNS0_16TransitionMemoryEPKNS0_20StateMachineConstantEPKNS0_17StateMachineInputEPNS0_18StateMachineOutputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceEi: __ZN7mecanim12statemachine19EvaluateTransitionsERK9OffsetPtrIS1_INS0_18TransitionConstantEEEjRNS0_15TransitionInputERNS0_16TransitionOutputERNS0_16TransitionMemoryEPKNS0_20StateMachineConstantEPKNS0_17StateMachineInputEPNS0_18StateMachineOutputEPNS0_18StateMachineMemoryEPNS0_21StateMachineWorkspaceEi, __Z59Register_UnityEngine_ParticleSystemRenderer_get_lengthScalev: __Z59Register_UnityEngine_ParticleSystemRenderer_get_lengthScalev, __ZNK11AudioSource24GetSpatializePostEffectsEv: __ZNK11AudioSource24GetSpatializePostEffectsEv, __Z31Mesh_CUSTOM_INTERNAL_set_boundsP12Il2CppObjectRK4AABB: __Z31Mesh_CUSTOM_INTERNAL_set_boundsP12Il2CppObjectRK4AABB, __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j: __Z14resize_trimmedINSt3__26vectorI20ComputeShaderVariantNS0_9allocatorIS2_EEEEEvRT_j, __ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b: __ZN5physx2Gu15intersectOBBOBBERKNS_6PxVec3ES3_RKNS_7PxMat33ES3_S3_S6_b, __ZN11MonoManager13AwakeFromLoadE17AwakeFromLoadMode: __ZN11MonoManager13AwakeFromLoadE17AwakeFromLoadMode, __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZv: __Z67Register_UnityEngine_ParticleSystem_VelocityOverLifetimeModule_GetZv, __ZN7dtCrowd14SetObstacleBoxERK13dtCrowdHandlePKfS4_S4_S4_: __ZN7dtCrowd14SetObstacleBoxERK13dtCrowdHandlePKfS4_S4_S4_, __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj: __ZNK5physx22PxVehicleWheelsDynData21getWheelRotationSpeedEj, __Z81Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetAnimationClipv: __Z81Register_UnityEngine_Experimental_Director_AnimationClipPlayable_GetAnimationClipv, __ZN12_GLOBAL__N_16ParserILb1EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE: __ZN12_GLOBAL__N_16ParserILb1EE9parseDataEN5physx8debugger7DataRefIKhEERNS3_8renderer20PvdUserRenderHandlerE, __Z53Register_UnityEngine_GameObject_FindGameObjectWithTagv: __Z53Register_UnityEngine_GameObject_FindGameObjectWithTagv, __ZN25DeferredRenderLoopScratch15ThreadedCleanupEv: __ZN25DeferredRenderLoopScratch15ThreadedCleanupEv, __ZNKSt3__214collate_bynameIwE12do_transformEPKwS3_: __ZNKSt3__214collate_bynameIwE12do_transformEPKwS3_, __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI24GenerateTypeTreeTransferLb1ExEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __ZN17ArchiveFileSystem4NameEv: __ZN17ArchiveFileSystem4NameEv, __ZN5physx31PxcPCMContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE: __ZN5physx31PxcPCMContactCapsuleHeightFieldERKNS_2Gu13GeometryUnionES3_RKNS_11PxTransformES6_RKfRNS_10PxcNpCacheERNS0_13ContactBufferE, __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEbT0_SB_T_: __ZNSt3__227__insertion_sort_incompleteIRNS_6__lessINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEES7_EEPS7_EEbT0_SB_T_, __ZN12LightsModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK14ParticleSystem: __ZN12LightsModule6UpdateERK27ParticleSystemReadOnlyStateR19ParticleSystemStateRK23ParticleSystemParticlesRK14ParticleSystem, __ZN13BuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN13BuildSettings8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z28QuadTreeNodeRenderer_CleanupR15RenderNodeQueuej: __Z28QuadTreeNodeRenderer_CleanupR15RenderNodeQueuej, __ZN14ImageReference10ClearImageERK11ColorRGBA32NS_9ClearModeE: __ZN14ImageReference10ClearImageERK11ColorRGBA32NS_9ClearModeE, __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE: __ZNK5physx26PxSerializerDefaultAdapterINS_18PxVehicleDriveTankEE10exportDataERNS_6PxBaseERNS_22PxSerializationContextE, __ZN13AudioProfiler12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE: __ZN13AudioProfiler12CaptureFrameER13dynamic_arrayI22AudioProfilerGroupInfoLj4EERS0_I20AudioProfilerDSPInfoLj4EERS0_I21AudioProfilerClipInfoLj4EERS0_IcLj1EE, __ZNK5Umbra16LineSegmentQuery8getStartEv: __ZNK5Umbra16LineSegmentQuery8getStartEv, __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE8__appendEj: __ZNSt3__26vectorIN19SpriteMeshGenerator6vertexENS_9allocatorIS2_EEE8__appendEj, __ZN5physx20AggregateOverlapTask11runInternalEv: __ZN5physx20AggregateOverlapTask11runInternalEv, __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9constructERNS2_11ConstructorEiPS1_: __ZN5Umbra25RuntimeSpatialSubdivisionINS_9AllocatorEE9constructERNS2_11ConstructorEiPS1_, __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_: __ZN13dynamic_arrayI11KeyframeTplIfELj4EEC2ERKS2_, __Z30Shader_CUSTOM_GetGlobalTexturei: __Z30Shader_CUSTOM_GetGlobalTexturei, __Z38Register_UnityEngine_Caching_Authorizev: __Z38Register_UnityEngine_Caching_Authorizev, __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj: __ZN5physx18RepXPropertyFilterINS_2Sn17RepXVisitorReaderINS_22PxJointLinearLimitPairEEEEclILj486ENS_22PxJointLimitParametersEffEEvRKNS_14PxPropertyInfoIXT_ET0_T1_T2_EEj, __ZZL31InitializeAudioManagerCallbacksvEN31PostLateUpdateUpdateAudiostruct7ForwardEv: __ZZL31InitializeAudioManagerCallbacksvEN31PostLateUpdateUpdateAudiostruct7ForwardEv, __Z27setPxSceneDescCpuDispatcherPN5physx11PxSceneDescEPNS_15PxCpuDispatcherE: __Z27setPxSceneDescCpuDispatcherPN5physx11PxSceneDescEPNS_15PxCpuDispatcherE, __ZN12HandlerChain4ReadER13FileEntryDatayPvPy: __ZN12HandlerChain4ReadER13FileEntryDatayPvPy, __Z101Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorClipInfoInternalv: __Z101Register_UnityEngine_Experimental_Director_AnimatorControllerPlayable_GetNextAnimatorClipInfoInternalv, __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__get_long_capEv: __ZNKSt3__212basic_stringIwNS_11char_traitsIwEENS_9allocatorIwEEE14__get_long_capEv, __ZN11UnityEngine7Connect13ConfigHandler6RetainEv: __ZN11UnityEngine7Connect13ConfigHandler6RetainEv, __ZN11Rigidbody2D11SetMaterialE4PPtrI17PhysicsMaterial2DE: __ZN11Rigidbody2D11SetMaterialE4PPtrI17PhysicsMaterial2DE, __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags: __ZN18StreamedBinaryReadILb0EE21TransferSTLStyleArrayINSt3__26vectorIN8LODGroup3LODENS2_9allocatorIS5_EEEEEEvRT_17TransferMetaFlags, __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E15insert_noresizeERKS4_: __ZN15dense_hashtableINSt3__24pairIKy9PlaneDataEEyN32PlaneColliderCache_dense_hashmap17UInt64HashFunctorEN14dense_hash_mapIyS3_S6_NS0_8equal_toIyEE13stl_allocatorIS4_L18MemLabelIdentifier65ELi16EEE9SelectKeyES9_SC_E15insert_noresizeERKS4_, _cff_parse_font_matrix: _cff_parse_font_matrix, __ZN5physx23correlatePatchesCoulombERNS_27PxcCorrelationBufferCoulombERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjjj: __ZN5physx23correlatePatchesCoulombERNS_27PxcCorrelationBufferCoulombERKNS_2Gu13ContactBufferERKNS_11PxTransformES8_fjjj, __ZNSt3__210__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t: __ZNSt3__210__stdinbufIwEC2EP8_IO_FILEP11__mbstate_t, __ZN15ConstantForce2D5ResetEv: __ZN15ConstantForce2D5ResetEv, __ZN5physx7NpShape16setContactOffsetEf: __ZN5physx7NpShape16setContactOffsetEf, __Z64Register_UnityEngine_CanvasRenderer_SplitUIVertexStreamsInternalv: __Z64Register_UnityEngine_CanvasRenderer_SplitUIVertexStreamsInternalv, __Z50MaterialPropertyBlock_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_: __Z50MaterialPropertyBlock_CUSTOM_GetFloatArrayImplListP12Il2CppObjectiS0_, __Z52Register_UnityEngine_PointEffector2D_set_forceTargetv: __Z52Register_UnityEngine_PointEffector2D_set_forceTargetv, __ZN12_GLOBAL__N_117ConnectionManager13sendStreamEndEv: __ZN12_GLOBAL__N_117ConnectionManager13sendStreamEndEv, __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv: __ZThn4_NK5physx5cloth9ClothImplINS0_7SwClothEE22getPreviousIterationDtEv, __ZThn4_NK5physx5cloth8SwSolver25getInterCollisionDistanceEv: __ZThn4_NK5physx5cloth8SwSolver25getInterCollisionDistanceEv, __Z48ParticleSystemRenderer_Get_Custom_PropRenderModeP12Il2CppObject: __Z48ParticleSystemRenderer_Get_Custom_PropRenderModeP12Il2CppObject, _UNITY_tt_size_run_fpgm: _UNITY_tt_size_run_fpgm, __ZNKSt3__28messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE: __ZNKSt3__28messagesIcE6do_getEiiiRKNS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEE, __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERc: __ZNSt3__213basic_istreamIcNS_11char_traitsIcEEE3getERc, __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_: __ZNSt3__26vectorIN13AnimationClip10FloatCurveE13stl_allocatorIS2_L18MemLabelIdentifier25ELi16EEE6assignINS_11__wrap_iterIPS2_EEEENS_9enable_ifIXaasr21__is_forward_iteratorIT_EE5valuesr16is_constructibleIS2_NS_15iterator_traitsISC_E9referenceEEE5valueEvE4typeESC_SC_, __ZN5physx2Sq11PruningPool6resizeEj: __ZN5physx2Sq11PruningPool6resizeEj, __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv: __ZN8Renderer39GetCustomPropertiesRememberToUpdateHashEv, __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__is_longEv: __ZNKSt3__212basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEE9__is_longEv, __ZN6Object8TransferI19StreamedBinaryWriteILb0EEEEvRT_: __ZN6Object8TransferI19StreamedBinaryWriteILb0EEEEvRT_, __Z51LightmapSettings_Get_Custom_PropLightmapsModeLegacyv: __Z51LightmapSettings_Get_Custom_PropLightmapsModeLegacyv, __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_: __ZN5physx2Gu16intersectRayAABBERKNS_6shdfnd3aos5Vec3VES5_S5_S5_RNS2_6FloatVES7_, __Z48Register_UnityEngine_Compass_get_magneticHeadingv: __Z48Register_UnityEngine_Compass_get_magneticHeadingv, __ZNK5physx2Gu10ConvexMesh14getPolygonDataEjRNS_13PxHullPolygonE: __ZNK5physx2Gu10ConvexMesh14getPolygonDataEjRNS_13PxHullPolygonE, __ZN15TextureTFMethod15UnmapBoneBufferEv: __ZN15TextureTFMethod15UnmapBoneBufferEv, __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv: __ZN5IMGUI14GUIWindowState23ReleaseScriptingObjectsEv, __Z61Register_UnityEngine_ShaderVariantCollection_ContainsInternalv: __Z61Register_UnityEngine_ShaderVariantCollection_ContainsInternalv, __Z11PxcPoolFreePvj: __Z11PxcPoolFreePvj, __ZN7mecanim12statemachine13StateConstant39Transfer_Pre_5_2_BackwardsCompatibilityI14SafeBinaryReadEEvRT_: __ZN7mecanim12statemachine13StateConstant39Transfer_Pre_5_2_BackwardsCompatibilityI14SafeBinaryReadEEvRT_, __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE: __ZN24OcclusionCullingSettings23VirtualRedirectTransferER18StreamedBinaryReadILb0EE, __ZN17PersistentManagerD0Ev: __ZN17PersistentManagerD0Ev, __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE14__count_uniqueIS7_EEjRKT_: __ZNKSt3__26__treeINS_12__value_typeINS_12basic_stringIcNS_11char_traitsIcEENS_9allocatorIcEEEEiEENS_19__map_value_compareIS7_S8_NS_4lessIS7_EELb1EEENS5_IS8_EEE14__count_uniqueIS7_EEjRKT_, __ZN10SampleClip15UnloadAudioDataEv: __ZN10SampleClip15UnloadAudioDataEv, __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB565EEvPKNS_9InnerInfoE: __ZN6prcoreL12RemapGenericI11TexFormatI815TexFormatRGB565EEvPKNS_9InnerInfoE, __ZN4PPtrI9AudioClipE8TransferI14SafeBinaryReadEEvRT_: __ZN4PPtrI9AudioClipE8TransferI14SafeBinaryReadEEvRT_, __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER14SafeBinaryRead: __ZN20TextRenderingPrivate7GUIText23VirtualRedirectTransferER14SafeBinaryRead, __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireCubev: __Z54Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawWireCubev, __ZN24GenerateTypeTreeTransfer20AssertContainsNoPPtrERK16TypeTreeIterator: __ZN24GenerateTypeTreeTransfer20AssertContainsNoPPtrERK16TypeTreeIterator, __ZN24iPhoneRemoteNotification14SetDeviceTokenEP11objc_object: __ZN24iPhoneRemoteNotification14SetDeviceTokenEP11objc_object, __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj: __ZNSt3__26vectorINS_4pairI8StateKey10StateRangeEENS_9allocatorIS4_EEE8__appendEj, __ZN5physx31PxParticleSystemGeneratedValuesC2EPKNS_16PxParticleSystemE: __ZN5physx31PxParticleSystemGeneratedValuesC2EPKNS_16PxParticleSystemE, __ZNK13MonoBehaviour25ShouldRunScriptableObjectEv: __ZNK13MonoBehaviour25ShouldRunScriptableObjectEv, __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFrameMultiplierv: __Z87Register_UnityEngine_ParticleSystem_TextureSheetAnimationModule_SetStartFrameMultiplierv, __ZN5physx3Scb5Actor17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx3Scb5Actor17getBinaryMetaDataERNS_14PxOutputStreamE, __ZN14SubstanceInputaSERKS_: __ZN14SubstanceInputaSERKS_, __ZN5physx25PxcDiscreteNarrowPhasePCMERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE: __ZN5physx25PxcDiscreteNarrowPhasePCMERNS_18PxcNpThreadContextERNS_13PxcNpWorkUnitE, __ZN10FileSystem19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE: __ZN10FileSystem19SetCurrentDirectoryERKNSt3__212basic_stringIcNS0_11char_traitsIcEENS0_9allocatorIcEEEE, __Z44Object_CUSTOM_Internal_CloneSingleWithParentP12Il2CppObjectS0_h: __Z44Object_CUSTOM_Internal_CloneSingleWithParentP12Il2CppObjectS0_h, __ZNK29LineParametersPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf: __ZNK29LineParametersPropertyBinding13SetFloatValueERKN11UnityEngine9Animation10BoundCurveEf, __ZN14Physics2DState10InitializeEv: __ZN14Physics2DState10InitializeEv, __Z56Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalColorv: __Z56Register_UnityEngine_Shader_INTERNAL_CALL_GetGlobalColorv, __ZN13GfxDeviceNull16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode: __ZN13GfxDeviceNull16SetTextureParamsE9TextureID16TextureDimension17TextureFilterMode15TextureWrapModeifb17TextureColorSpace18ShadowSamplingMode, __Z16LightAttenuationIA4_tEvP9Texture2DPT_iiii: __Z16LightAttenuationIA4_tEvP9Texture2DPT_iiii, __ZThn8_N5physx17ConvexMeshBuilderD1Ev: __ZThn8_N5physx17ConvexMeshBuilderD1Ev, __ZN5physx3Ext20ProfileZoneInterfaceD0Ev: __ZN5physx3Ext20ProfileZoneInterfaceD0Ev, __ZN5physx2Sc10StaticCore14setActor2WorldERKNS_11PxTransformE: __ZN5physx2Sc10StaticCore14setActor2WorldERKNS_11PxTransformE, __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE8recreateEj: __ZN5physx6shdfnd5ArrayIPNS_3Scb5ShapeENS0_15InlineAllocatorILj16ENS0_19ReflectionAllocatorIS4_EEEEE8recreateEj, __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv: __ZN11UnityEngine15PlatformWrapper16GetProcessorTypeEv, __ZN5physx2Sc10StaticCore17getBinaryMetaDataERNS_14PxOutputStreamE: __ZN5physx2Sc10StaticCore17getBinaryMetaDataERNS_14PxOutputStreamE, __Z53Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawFrustumv: __Z53Register_UnityEngine_Gizmos_INTERNAL_CALL_DrawFrustumv, __ZL30StaticInitializeIUnityGraphicsPv: __ZL30StaticInitializeIUnityGraphicsPv, __ZNK15CapsuleCollider15GetGlobalCenterEv: __ZNK15CapsuleCollider15GetGlobalCenterEv, __ZN5physx17ConvexHullBuilder4InitEjPKNS_6PxVec3EjPKjjPKNS_13PxHullPolygonE: __ZN5physx17ConvexHullBuilder4InitEjPKNS_6PxVec3EjPKjjPKNS_13PxHullPolygonE, __Z34Cloth_Get_Custom_PropSelfCollisionP12Il2CppObject: __Z34Cloth_Get_Custom_PropSelfCollisionP12Il2CppObject, __ZN11UnityEngine7Connect20BasePersistentValues5ResetEv: __ZN11UnityEngine7Connect20BasePersistentValues5ResetEv, __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE: __ZN5physx18RepXSerializerImplINS_15PxDistanceJointEE12objectToFileERKNS_12PxRepXObjectEPNS_12PxCollectionERNS_9XmlWriterERNS_12MemoryBufferERNS_23PxRepXInstantiationArgsE, __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_: __ZN5physx3Pvd17PvdPropertyFilterINS_2Sn17RepXVisitorWriterINS_18PxArticulationLinkEEEE14handleAccessorILj17ENS_22PxRepXPropertyAccessorILj17ENS_7PxActorEhhEEEEvRKT0_, _request_virt_barray: _request_virt_barray, __Z50Register_UnityEngine_ParticleAnimator_set_sizeGrowv: __Z50Register_UnityEngine_ParticleAnimator_set_sizeGrowv, __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo: __Z29Transfer_Blittable_ArrayFieldI18StreamedBinaryReadILb1EE8Vector3fEvRT_R9ArrayInfoRK23StaticTransferFieldInfo, __ZN30RuntimeInitializeOnLoadManager15InitializeClassEv: __ZN30RuntimeInitializeOnLoadManager15InitializeClassEv, __ZN5physx2Gu13MeshInterfaceD2Ev: __ZN5physx2Gu13MeshInterfaceD2Ev, __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo: __Z18Transfer_BlittableI18StreamedBinaryReadILb1EELb0EhEvRK29SerializationCommandArgumentsR31RuntimeSerializationCommandInfo, __Z27GetAudioScriptingClassesPtrv: __Z27GetAudioScriptingClassesPtrv, __Z51ParticleSystem_CUSTOM_GetCustomParticleDataInternalP12Il2CppObjectS0_i: __Z51ParticleSystem_CUSTOM_GetCustomParticleDataInternalP12Il2CppObjectS0_i, __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv: __ZThn4_NK5physx5cloth9SwFactory12copyFromHostEPKvS3_Pv, __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10ReallocateEPvji: __ZN19DualThreadAllocatorI20DynamicHeapAllocatorI17LowLevelAllocatorEE10ReallocateEPvji, __ZN11OffMeshLink16SetBiDirectionalEb: __ZN11OffMeshLink16SetBiDirectionalEb, __ZNKSt10bad_typeid4whatEv: __ZNKSt10bad_typeid4whatEv, __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv: __ZN24dense_hashtable_iteratorINSt3__24pairIKNS0_12basic_stringIcNS0_11char_traitsIcEE13stl_allocatorIcL18MemLabelIdentifier54ELi16EEEEP20ArchiveStorageReaderEES8_11djb2_hash_tIS8_EN14dense_hash_mapIS8_SB_SE_NS0_8equal_toIS8_EES5_ISC_LS6_54ELi16EEE9SelectKeyESH_SI_E30advance_past_empty_and_deletedEv, __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE: __ZN6prcoreL17RemapGenericFloatI15TexFormatRFloat17TexFormatRGBFloatEEvPKNS_9InnerInfoE, __ZN11TimeManager7PRODUCEE10MemLabelId18ObjectCreationMode: __ZN11TimeManager7PRODUCEE10MemLabelId18ObjectCreationMode, __Z14FindMainCamerav: __Z14FindMainCamerav, _pass_startup: _pass_startup, __ZN16b2PolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator: __ZN16b2PolygonContact6CreateEP9b2FixtureiS1_iP16b2BlockAllocator, __ZN4FMOD7SystemI11getWaveDataEPfii: __ZN4FMOD7SystemI11getWaveDataEPfii, __ZN14GfxContextGLES7ReleaseEN2gl13ContextHandleE: __ZN14GfxContextGLES7ReleaseEN2gl13ContextHandleE, __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_: __ZN15dense_hashtableINSt3__24pairIKN4core12basic_stringIcNS2_20StringStorageDefaultIcEEEEP19ProfilerInformationEES6_11djb2_hash_tIS6_EN14dense_hash_mapIS6_S9_SC_NS0_8equal_toIS6_EE13stl_allocatorISA_L18MemLabelIdentifier57ELi16EEE9SelectKeyESF_SI_E4swapERSL_, __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_: __ZN9rapidjson13GenericReaderINS_4UTF8IcEES2_13JSONAllocatorE9ParseTrueILj0ENS_19GenericStringStreamIS2_EENS_15GenericDocumentIS2_S3_S3_EEEEvRT0_RT1_, __ZNK5physx16NpParticleSystem7getTypeEv: __ZNK5physx16NpParticleSystem7getTypeEv };
})
;